Explanation of the files
========================

lumi.dat.ori:    

 Contains the  JADE luminosities integrated in
 consecutive runs with same cms energy (run periods).
 The numbers were manually transfered from Olsson 
 historic printout of the program 'TAKLUMI'

lumi.dat: 

 Like lumi.dat.ori, but with the following modifications:
 1. Tabulators are replaced by blanks.
 2. '0.0'-entries have been brought to the format of
    the other entries.
 3. The missing run periods 540-564 and 581-591 were 
    added in the head of the file. The corresponding 
    luminosity numbers were retrieved from the very 
    first page of the TAKLUMI printout where they are
    given with an accuracy of 4 digits.

jaderun.dat.ori: 

 Contains an overview of the beam energies vs.
 data taking period and run period.

jaderun.dat:

 Like jaderun.dat.ori, but in a format more suitable to
 be processed by a kumac. In addition, the following lines 
 were corrected:

   1985   13.03  13.03  24801 24803    17.536  18
   1985   22.03  22.03  24961 24970    16.500  18

shutdown.dat:

  Contains the shutdown periods.

taklumi.f:

  A FORTRAN program to read the original JADE luminosity files, i.e. the
  luminosity vs. run information. It was modified to read the file
 'lumi.dat' that contains the luminosity vs. run period data.

  N.B.: Checksums from Olssons fax are only reproduced exactly if 
        the given run periods corresponding to these checksums 
        match the run periods in the present luminosity file.

C   19/02/84 807251441  MEMBER NAME  BANKPR   (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BANKPR 
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL     ?     :  PRINT BOS BANK NAMES OR CONTENTS.
C
C        MOD: J. OLSSON   15/11/83 :
C        MOD: C. BOWDERY  14/02/84 :  RESOLVE PROBLEM WITH DELETED BANKS
C        MOD: C. BOWDERY  14/02/84 :  NAMES PRINTED BY S/R EVBKPR
C        MOD: J. HAGEMANN 26/11/84 :  VERTEX CHAMBER BANKS PRINTOUT
C                                  :  ADDED AND IMPROVED PATR-BANK
C                                  :  PRINTOUT
C        MOD: J. HAGEMANN 24/06/85 :  IMPROVED PRINTOUT FOR
C                                  :  BPCH-BANK
C        MOD: J. HAGEMANN 23/09/85 :  PRINTOUT FOR VTHT- * VPAT- BANKS
C        MOD: J. HAGEMANN 10/02/86 :  PRINTOUT FOR VCVW- * TTOP- BANKS
C        MOD: J. HAGEMANN 02/05/86 :  IMPROVED PRINTOUT FOR JHTL-BANK
C                                     COMPLETELY NEW STRUCTURE,
C                                     PRINTOUT FOR SOME BANKS DONE VIA
C                                     SUBROUTINES
C        MOD: J. HAGEMANN 20/05/86 :  PRINTOUT FOR PALL-BANK
C        MOD: J. HAGEMANN 21/07/86 :  IMPROVED PRINTOUT FOR PATR-BANK
C        MOD: J. OLSSON   04/08/86 :  EXTENSION ZTRG FORMAT DESCR.2
C        MOD: J. OLSSON   20/08/86 :  DEDX PRINT OF MOM. ERROR
C        MOD: E  ELSEN    26/08/86 :  J68K PRINT
C        MOD: J. HAGEMANN 09/09/86 :  FOR BANK NAME PASSED BY FIRST
C                                     COMMAND ARGUMENT "ACMD" AND BANK
C                                     NUMBER BY SECOND COMMAND ARGUMENT
C                                     "BCMD"
C        MOD: J. HAGEMANN 06/04/87 :  FOR OUTPUT ON LASER PRINTERS
C        MOD: J. HAGEMANN 30/06/87 :  FOR SELECTION OF VECT-BANK / BCMD
C   LAST MOD: J. HAGEMANN 19/01/88 :  FOR PRINTOUT OF HWDS,HHTL-BANKS
C
C
C  IRETUR :   -1 = BANK PRINTOUT FINISHED
C              0 = RETURN AFTER CONTINUATION OF PRINTOUT OF BANK NOT
C                  CONTAINED IN BANK LIST
C         1 - 28 = RETURN AFTER CONTINUATION OF PRINTOUT OF BANK
C                  CONTAINED IN BANK LIST
C        41 - 44 = RETURN AFTER CONTINUATION OF PRINTOUT OF FAMP BANK
C                  (SEVERAL SECTIONS)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C
      LOGICAL DSPDTM
C
      REAL*8 DATE,TIME
      REAL*8 DESTPL
C
#include "cgraph.for"
#include "cdata.for"
C
      COMMON / CWORK  / HDUM(8000),
     +                  HADC(2,42),HTDC(2,42),HTDC1(2,42),HADCF(2,16),
     +                  HTDCF(2,16),HTSPAR(16)
      COMMON / CWORK1 / HWORK(70),DATE,TIME
      COMMON / CHEADR / HEAD(108)
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
C
      DIMENSION HDSPL(68),HSYM(10),HDATSV(22),HTX(6),HTM1(4),HTM2(4)
      DIMENSION NAMES(30), HELP(2)
      DIMENSION HBYTE(500)
C
      EQUIVALENCE (IZWORD,HELP(1))
      EQUIVALENCE (HWORK(1),NAME)
      EQUIVALENCE (HWORK(3),HDSPL(1))
      EQUIVALENCE (HDATSV(1),IDATSV(1)),(DATE,HTM1(1)),(TIME,HTM2(1))
      EQUIVALENCE (ABN1,NAMEB)
C
      DIMENSION DESTPL(7)
C
      DATA DESTPL  / 'L1      ','L2      ','L3      ','L4      ',
     *               'L5      ','PLOTTER ','EXTPLOTT' /
C
      DATA NAMES  /'JETC','PATR','TAGC','JHTL','ZETC',
     *             'GVTX','DEDX','ZVTX','LGCL','TOFR',
     *             'TPEV','TPTR','ATOF','TPVX','VECT',
     *             'TRIG','N50S','MPRS','BK17','ZTRG',
     *             'FAMP','BPCH','VTXC','VTHT','VPAT',
     *             'VCVW','J68K','PALL','HWDS','HHTL'/
C
      DATA HSYM /'0 ','1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 '/
      DATA HBLANK/'  '/,HMINUS/'- '/, NNAMES /30/
      DATA HTX /'DS','N ','DA','TE','TI','ME'/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*140,cHDSPL*136,cfmt*7
      EQUIVALENCE (cHWORK,HWORK(1)),(cHDSPL,HDSPL(1))
*** PMF(end)
C
C
C------------------  C O D E  ------------------------------------------
C
      IF( ACMD .EQ. 0.0 ) GO TO 10
      IF( ACMD .LT. 0.0 .AND. ACMD .GT. -11.0 ) GO TO 5
         ABN1 = ACMD
         GO TO 15
C
C                            NEGATIVE INDEX --> PRINT BOS BANK NAMES
C
    5    CALL EVBKPR(ICODE)
         IF( ICODE .EQ. 0 ) RETURN
         CALL TRMOUT(80,'Error in BMRT (currentlist),  called in BANKPR^
     *')
         RETURN
C
   10 CALL TRMOUT(80,' * * Please enter NAME of desired BANK.^')
      CALL TRMIN( 4, NAMEB )
   15 IBANK  = IBLN(NAMEB)
      IPBANK = IDATA(IBANK)
      LIM1   = IPBANK - 2
      IF( LIM1 .GE. 1 ) GO TO 30
   20    CALL TRMOUT(80,'The BANK is EMPTY or does NOT EXIST.^')
         RETURN
C** CHECK IF MORE THAN ONE BANK WITH SAME NAME; IF SO, REQUEST NUMBER.
   30 IF( IDATA(LIM1+1) .EQ. 0 .OR. NAMEB .EQ. NAMES(15) ) GO TO 80
         IF( BCMD .LE. 0.0  .OR.  BCMD .GT. 99.0 ) GO TO 35
            NBOS = IFIX(BCMD)
            GO TO 60
   35    CALL TRMOUT(80,'Following BOS BANK NUMBERS are present:^')
         LM1 = LIM1
   40    CALL DIAGIN('                    ',1,IDATA(LM1),N,N,N,N,N)
         IF( IDATA(LM1+1) .EQ. 0 ) GO TO 50
            LM1 = IDATA(LM1+1)-2
            GO TO 40
   50    CALL TRMOUT(80,'Please ENTER desired BOS BANK NUMBER.^')
         NBOS = TERNUM(DUMMY)
   60    IF( NBOS .EQ. IDATA(LIM1) ) GO TO 80
            IF( IDATA(LIM1+1) .NE. 0 ) GO TO 70
               GO TO 20
   70       LIM1 = IDATA(LIM1+1) - 2
            GO TO 60
   80 CALL ERASE
      IRETUR = -1
C********************** WRITE CAPTION
      CALL HOME
      CALL CHRSIZ(4)
      HWORK(1) = HTX(1)
      HWORK(2) = HTX(2)
      HWORK(3) = HBLANK
      DO 90  I = 1,22
         HWORK(I+3) = HDATSV(I)
   90 CONTINUE
      CALL EOUTST( 50, HWORK )
      KCNT   = 0
      IHEAD  = IBLN('HEAD')
      IPHEAD = IDATA(IHEAD)
      IHHEAD = 2*IPHEAD
      DO 110 III = 1,3
         IF( III .EQ. 1 ) NUMCAP = HDATA(IHHEAD+10)
         IF( III .EQ. 2 ) NUMCAP = HDATA(IHHEAD+11)
         IF( III .EQ. 3 ) NUMCAP = ICREC
         IF( NUMCAP .LT. 0 ) KCNT = KCNT + 1
         IF( NUMCAP .LT. 0 ) HWORK(KCNT) = HMINUS
         NUMCAP = IABS(NUMCAP)
         NDIG   = 1
         ACAP   = NUMCAP
         IF( NUMCAP .GT. 0 ) NDIG = 1 + ALOG10(ACAP+0.001)
         IF( NDIG .GT. 8 ) NDIG = 8
         DO 100 JJJ = 1,NDIG
            KKK    = KCNT + NDIG - JJJ + 1
            NTEN   = NUMCAP/10
            IDIG   = NUMCAP - 10*NTEN
            HWORK(KKK) = HSYM(IDIG+1)
            NUMCAP = NTEN
  100    CONTINUE
         KCNT = KCNT + NDIG
         IF( III .LT. 3 ) KCNT = KCNT + 1
         IF( III .LT. 3 ) HWORK(KCNT) = HBLANK
  110 CONTINUE
      KCNT = 2*KCNT
      CALL NEWLIN
      CALL EOUTST( KCNT, HWORK )
C WRITE DATE AND TIME
      CALL DAY( DATE, TIME )
      HWORK(1) = HTX(3)
      HWORK(2) = HTX(4)
      HWORK(3) = HBLANK
      DO 120  I = 1,4
         HWORK(I+3) = HTM1(I)
  120 CONTINUE
      CALL NEWLIN
      CALL EOUTST(14,HWORK)
      HWORK(1) = HTX(5)
      HWORK(2) = HTX(6)
      HWORK(3) = HBLANK
      DO 130  I = 1,4
         HWORK(I+3) = HTM2(I)
  130 CONTINUE
      CALL NEWLIN
      CALL EOUTST(14,HWORK)
      CALL NEWLIN
      CALL CHRSIZ(3)
      CALL NEWLIN
C****************************** WRITE BANK HEADER
      LIM2  = LIM1 + 3
      LIMX  = LIM2 - 1
      LIMHX = 2*LIMX
      NAME  = IDATA(LIM1-1)
      CALL CORE(HDSPL,76)
      WRITE(cHDSPL,140)(IDATA(LHO),LHO=LIM1,LIMX),(HDATA(LIMHX+J),J=1,2)! PMF 17/11/99: UNIT=10 -> UNIT=cHDSPL 
  140 FORMAT(3I10,2I10)
      CALL EOUTST(80,HWORK)
      CALL NEWLIN
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
      IYT0 = IYT
      CALL CHRSIZ(4)
      CALL CSIZE(IX,IXT)
      SIZE   = IXT*.8
      DEL    = 1.7*SIZE
C****************************** WRITE BANK CONTENT
      NWO    = IDATA(LIM2-1) - 1
      LENGB  = 2*NWO
      NCYCLE = 1 + (LENGB-1)/20
      INNAM  = 0
      DO 150  INN = 1,NNAMES
         IF( NAMEB .NE. NAMES(INN) ) GO TO 150
            INNAM = INN
            GO TO 160
  150 CONTINUE
      GO TO 500
  160 GOTO( 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000,10000,
     *     11000,12000,13000,14000,15000,16000,17000,18000,19000,20000,
     *     19000,22000,23000,24000,25000,26000,27000,28000, 2000, 4000),
     * INNAM
C-------------- NORMAL PRINT OF BANKS, INTEGER*2 FORMAT
  500 CONTINUE
      DO 505 LHO = 1,NCYCLE
  501    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 502
            IRETUR = 0
            GO TO 90000
  502    LIML = 2*LIM2 + 20*(LHO-1) + 1
         LIMU = LIML + 19
         IF( LIMU .GT. (2*LIM2+LENGB) ) LIMU = 2*LIM2 + LENGB
         ILIM = LIMU - LIML + 1
         IF( ILIM .LE. 0 ) GO TO 90100
         DO 503  I = 1,ILIM
            LLO = LIML + I - 1
            HWORK(I+100) = HDATA(LLO)
  503    CONTINUE
         IILIM = 6*ILIM + 1
         CALL CORE(HWORK,IILIM)
         WRITE(cHWORK,504) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
  504    FORMAT(' ',20I6)
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
  505 CONTINUE
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR JETC BANK
 1000 LENGB  = LENGB + 2
      NCYCLE = 1 + (LENGB-1)/20
      LENGB  = LENGB - 2
      DO 1006 LHO = 1,NCYCLE
 1001    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 1002
            IRETUR = 1
            GO TO 90000
 1002    LIML = 2*LIM2 + 20*(LHO-1) + 1
         IF( LHO .GT. 5 ) LIML = LIML - 2
         LIMU = LIML + 19
         IF( LHO .EQ. 5 ) LIMU = LIMU - 2
         IF( LIMU .GT. (2*LIM2 + LENGB) ) LIMU = 2*LIM2 + LENGB
         ILIM = LIMU - LIML + 1
         IF( ILIM .LE. 0 ) GO TO 90100
         DO 1003  I = 1,ILIM
            LLO = LIML + I - 1
            HWORK(I+100) = HDATA(LLO)
 1003    CONTINUE
         IF( LHO .LE. 5 ) GO TO 1005
            DO 1004  I = 1,ILIM,4
               IX = HWORK(I+100)
               IX = ISHFTR(IX,3)
               HWORK(I+100) = IX
 1004       CONTINUE
 1005    IILIM = 6*ILIM + 1
         CALL CORE(HWORK,IILIM)
         WRITE(cHWORK,504) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 1006 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR PATR BANKS
 2000 LIM2  = LIM2 - 1
      NPATR = IDATA(LIM2-2)
      LO    = IDATA(LIM2+1)
      NTR   = IDATA(LIM2+2)
      LTR   = IDATA(LIM2+3)
      IPO   = LIM2 + LO
      CALL CORE(HWORK,47)
      WRITE(cHWORK,2001) (IDATA(LIM2+II),II=1,LO) ! PMF 17/11/99: JUSCRN changed to cHWORK
 2001 FORMAT('  ',3I5,2X,Z8,4I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      IF( NTR .GT. 100 ) RETURN
      ICNT = 0
 2002 ICNT = ICNT + 1
      IF( ICNT .GT. NTR ) GO TO 90100
 2003 YS = YS - DEL
      IF( YS .GT. 200.0 ) GO TO 2004
         IRETUR = 2
         GO TO 90000
 2004 IPP = IPO + (ICNT-1)*LTR
      CALL CORE(HWORK,122)
      WRITE(cHWORK,2005) IDATA(IPP+1),IDATA(IPP+2), ! PMF 17/11/99: JUSCRN changed to cHWORK
     * (IDATA(IPP+I),I=3,4),(ADATA(IPP+I),I=5,10),
     *                  IDATA(IPP+11),(ADATA(IPP+I),I=12,17)
 2005 FORMAT(' ',I2,1X,Z8,1X,I5,I3,1X,2F8.3,F10.3,3F7.3,2X,I3,1X,
     * 2F8.3,F10.3,3F7.3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,124)
      IF(IDATA(IPP+18).EQ.1)
     *WRITE(cHWORK,2006) IDATA(IPP+18),(ADATA(IPP+I),I=19,23), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                   IDATA(IPP+24),(ADATA(IPP+I),I=25,28),
     *                   IDATA(IPP+29),(ADATA(IPP+I),I=30,32),
     *                   IDATA(IPP+33)
 2006 FORMAT(' ',I2,1X,E10.4,F8.3,E11.4,1X,F8.3,F7.3,I3,1X,4E11.4,1X,I2,
     * 3F7.2,I3)
      IF(IDATA(IPP+18).EQ.2)
     *WRITE(cHWORK,2007) IDATA(IPP+18),(ADATA(IPP+I),I=19,23), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                   IDATA(IPP+24),(ADATA(IPP+I),I=25,28),
     *                   IDATA(IPP+29),(ADATA(IPP+I),I=30,32),
     *                   IDATA(IPP+33)
 2007 FORMAT(' ',I2,1X,E10.4,2F8.3,1X,E11.4,F7.3,I3,1X,4E11.4,1X,I2,
     * 3F7.2,I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
      YS = YS - DEL
      IF( NPATR .NE. 12 ) GO TO 2009
         CALL CORE(HWORK,118)
         WRITE(cHWORK,2008) (IDATA(IPP+I),I=34,48), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                      (HDATA(IPP*2+I),I=3,4)
 2008    FORMAT(' ',6I4,2X,8I5,2X,Z8,2X,' PART.NO.',I4,1X,'IN VECT 0',
     *          '    PART.TYPE',I3)
         CALL SYSSYM(XS,YS,SIZE,HWORK,118,0.)
         GO TO 2011
 2009 CALL CORE(HWORK,89)
      WRITE(cHWORK,2010) (IDATA(IPP+I),I=34,44),(ADATA(IPP+I),I=45,46), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                   (IDATA(IPP+I),I=47,48)
 2010 FORMAT(' ',6I4,2X,4I6,I4,2F8.1,I8,2X,Z8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,89,0.)
 2011 CONTINUE
      IF(LTR .LT. 62) GO TO 2002
      IF((LTR .LT. 64) .OR.
     *   (LTR.EQ.64 .AND.
     *    (.NOT.TBIT(IDATA(IPP+2),19).OR.ABS(ADATA(IPP+51)).LT.0.01)
     *    .AND. INNAM.NE.29))
     *                        GO TO 2020
         YS = YS - DEL
         CALL CORE(HWORK,114)
         IF(IDATA(IPP+18).EQ.1)WRITE(cHWORK,2012) (ADATA(IPP+I),I=49,58) ! PMF 17/11/99: JUSCRN changed to cHWORK
 2012    FORMAT(' ',2X,F9.3,E11.4,F9.3,1X,6E12.4,F8.3)
         IF(IDATA(IPP+18).EQ.2)WRITE(cHWORK,2013) (ADATA(IPP+I),I=49,58) ! PMF 17/11/99: JUSCRN changed to cHWORK
 2013    FORMAT(' ',2X,F9.3,F9.3,2X,F9.3,1X,6E12.4,F8.3)
         CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
         YS = YS - DEL
         IF( LTR .GT. 64 ) GOTO 2015
            CALL CORE(HWORK,65)
            WRITE(cHWORK,2014) (IDATA(IPP+I),I=59,64) ! PMF 17/11/99: JUSCRN changed to cHWORK
 2014       FORMAT(' ',26X,I3,2X,Z8,1X,Z8,1X,3I5)
            CALL SYSSYM(XS,YS,SIZE,HWORK,65,0.)
            GO TO 2002
 2015    CONTINUE
         CALL CORE(HWORK,115)
         WRITE(cHWORK,2016) (IDATA(IPP+I),I=59,68) ! PMF 17/11/99: JUSCRN changed to cHWORK
 2016    FORMAT(' ',26X,I3,2X,Z8,1X,Z8,1X,3I5,2X,4E12.4)
         CALL SYSSYM(XS,YS,SIZE,HWORK,115,0.)
         GO TO 2002
 2020 CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(cHWORK,2021) (ADATA(IPP+I),I=49,59), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                   (IDATA(IPP+I),I=60,62)
 2021 FORMAT(' ',2X,11E10.3,I7,2I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
      GO TO 2002
C--------------- SPECIAL FORMAT FOR TAGC BANK
 3000 CONTINUE
      DO 3005 LHO = 1,NCYCLE
 3001    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 3002
            IRETUR = 3
            GO TO 90000
 3002    LIML = 2*LIM2 + 20*(LHO-1) + 1
         LIMU = LIML + 19
         IF( LIMU .GT. (2*LIM2+LENGB) ) LIMU = 2*LIM2 + LENGB
         ILIM = LIMU - LIML + 1
         IF( ILIM .LE. 0 ) GO TO 90100
         DO 3003  I = 1,ILIM
            LLO = LIML + I - 1
            HWORK(I+100) = HDATA(LLO)
 3003    CONTINUE
         IILIM = 6*ILIM + 1
         CALL CORE(HWORK,IILIM)
         WRITE(cHWORK,3004) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
 3004    FORMAT(' ',20I6)
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 3005 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR JHTL BANK
 4000 CONTINUE
      LIM2   = LIM2 - 1
      LENGTH = IDATA(LIM2)
      LENGB  = LENGTH - 1
      NCYCLE = 1 + (LENGB-1)/4
      DO 4008 I = 1,NCYCLE
 4001    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 4002
            IRETUR = 4
            GO TO 90000
 4002    LIML = LIM2 + 4*(I-1) + 1
         LIMU = LIML + 4
         IF( LIMU .GT. (LIM2+LENGTH) ) LIMU = LIM2 + LENGTH
         ILIM = LIMU - LIML
         IF( ILIM .LE. 0 ) GO TO 90100
         DO 4003  J = 1,ILIM
            LLO  = LIML + J
            IWD  = IDATA(LLO)
            IJK  = (J-1)*10 + 100
            HWORK(IJK+ 1) = LAND(ISHFTR(IWD,27), 31)
            HWORK(IJK+ 2) = LAND(ISHFTR(IWD,25),  3)
            HWORK(IJK+ 3) = LAND(ISHFTR(IWD,24),  1)
            HWORK(IJK+ 4) = LAND(ISHFTR(IWD,17),127)
            HWORK(IJK+ 5) = LAND(ISHFTR(IWD,16),  1)
            HWORK(IJK+ 6) = LAND(ISHFTR(IWD,11), 31)
            HWORK(IJK+ 7) = LAND(ISHFTR(IWD, 9),  3)
            HWORK(IJK+ 8) = LAND(ISHFTR(IWD, 8),  1)
            HWORK(IJK+ 9) = LAND(ISHFTR(IWD, 1),127)
            HWORK(IJK+10) = LAND(IWD          ,  1)
 4003    CONTINUE
         IILIM = 30*ILIM + 1
         ILIMP = 100 + ILIM*10
         CALL CORE(HWORK,IILIM)
         IF( ILIM .EQ. 1 )
     *   WRITE(cHWORK,4004) (HWORK(JJ),JJ=101,ILIMP) ! PMF 17/11/99: JUSCRN changed to cHWORK
 4004    FORMAT(' ','/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X)
         IF( ILIM .EQ. 2 )
     *   WRITE(cHWORK,4005) (HWORK(JJ),JJ=101,ILIMP) ! PMF 17/11/99: JUSCRN changed to cHWORK
 4005    FORMAT(' ','/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X,
     *              '/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X)
         IF( ILIM .EQ. 3 )
     *   WRITE(cHWORK,4006) (HWORK(JJ),JJ=101,ILIMP) ! PMF 17/11/99: JUSCRN changed to cHWORK
 4006    FORMAT(' ','/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X,
     *              '/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X,
     *              '/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X)
         IF( ILIM .EQ. 4 )
     *   WRITE(cHWORK,4007) (HWORK(JJ),JJ=101,ILIMP) ! PMF 17/11/99: JUSCRN changed to cHWORK
 4007    FORMAT(' ','/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X,
     *              '/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X,
     *              '/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X,
     *              '/',I2,I3,I2,I3,I2,' *',I2,I3,I2,I3,I2,3X)
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 4008 CONTINUE
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR ZETC BANK
 5000 LENGB  = LENGB + 2
      NCYCLE = 1 + (LENGB-1)/20
      LENGB  = LENGB - 2
      DO 5005 LHO = 1,NCYCLE
 5001    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 5002
            IRETUR = 5
            GO TO 90000
 5002 LIML = 2*LIM2 + 20*(LHO-1) + 1
      LIMU = LIML + 19
      IF( LIMU .GT. (2*LIM2 + LENGB) ) LIMU = 2*LIM2 + LENGB
      ILIM = LIMU - LIML + 1
      IF( ILIM .LE. 0 ) GO TO 90100
      DO 5003  I = 1,ILIM
         LLO = LIML + I - 1
         HWORK(I+100) = HDATA(LLO)
 5003 CONTINUE
      DO 5004  I = 1,ILIM,4
         IX = HWORK(I+100)
         IX = ISHFTR(IX,3)
         HWORK(I+100) = IX
 5004 CONTINUE
      IILIM = 6*ILIM + 1
      CALL CORE(HWORK,IILIM)
      WRITE(cHWORK,504) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 5005 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR GVTX BANKS
 6000 NV  = IDATA(LIM2)
      IPO = LIM2
      DO 6002  INV = 1,NV
         IPO = LIM2+(INV-1)*10
         CALL CORE(HWORK,72)
         WRITE(cHWORK,6001) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                      IDATA(IPO+8),ADATA(IPO+9),IDATA(IPO+10)
 6001    FORMAT(' ',I3,3F8.2,3F8.2,I4,F8.2,I8)
         CALL SYSSYM(XS,YS,SIZE,HWORK,72,0.)
         YS = YS - DEL
 6002 CONTINUE
      NT = IDATA(IPO+11)
      CALL CORE(HWORK,4)
      WRITE(cHWORK,6003) NT ! PMF 17/11/99: JUSCRN changed to cHWORK
 6003 FORMAT(' ',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,4,0.)
      YS = YS - DEL
      IPO = IPO + 11 - 15
      DO 6007  INTnn = 1,NT
         IPO = IPO + 15
         CALL CORE(HWORK,64)
         WRITE(cHWORK,6004) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,8) ! PMF 17/11/99: JUSCRN changed to cHWORK
 6004    FORMAT(' ',I3,F8.2,2F7.3,3F8.2,2F7.3)
         CALL SYSSYM(XS,YS,SIZE,HWORK,64,0.)
         YS = YS - DEL
         CALL CORE(HWORK,42)
         WRITE(cHWORK,6005) (ADATA(IPO+1+JJ),JJ=9,11), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       IDATA(IPO+13),IDATA(IPO+14),ADATA(IPO+15)
 6005    FORMAT(' ',3F8.2,I4,I3,F10.2)
         CALL SYSSYM(XS,YS,SIZE,HWORK,42,0.)
         YS = YS - DEL
         IF( YS .GT. 80.0 ) GO TO 6007
            IRETUR = 6
            GO TO 90000
 6006    CONTINUE
 6007 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR DEDX BANKS
 7000 NTR = IDATA(LIM2+1)
      CALL CORE(HWORK,4)
      WRITE(cHWORK,7001) NTR ! PMF 17/11/99: JUSCRN changed to cHWORK
 7001 FORMAT(' ',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,4,0.)
      NTR = MIN0(NTR,60)
      YS  = YS - DEL
      DO 7004  ITR = 1,NTR
         IPO = LIM2 + 1 + (ITR-1)*10
         CALL CORE(HWORK,92)
         WRITE(cHWORK,7002) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                      IDATA(IPO+8),ADATA(IPO+9),ADATA(IPO+10)
 7002    FORMAT(' ',I3,2F8.2,4E12.4,I4,2F10.3)
         CALL SYSSYM(XS,YS,SIZE,HWORK,92,0.)
         YS = YS - DEL
         IF( YS .GT. 80.0 ) GO TO 7004
            IRETUR = 7
            GO TO 90000
 7003    CONTINUE
 7004 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR ZVTX BANKS
 8000 LIM2 = LIM2 - 1
      CALL PRZVTX( LIM2, XS, YS, DEL, SIZE )
      GO TO 90100
C--------------- SPECIAL FORMAT FOR LGCL BANKS
 9000 LIM2 = LIM2 - 1
      CALL CORE(HWORK,29)
      WRITE(cHWORK,9001) (IDATA(LIM2+LL),LL=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
 9001 FORMAT(' ',4I7)
      CALL SYSSYM(XS,YS,SIZE,HWORK,29,0.)
      LIM2 = LIM2 + 4
      YS   = YS - DEL
      CALL CORE(HWORK,118)
      WRITE(cHWORK,9002) (IDATA(LIM2+LL),LL=1,6),(ADATA(LIM2+LL),LL=7,10 ! PMF 17/11/99: JUSCRN changed to cHWORK
     *),IDATA(LIM2+11),(ADATA(LIM2+LL),LL=12,15),(IDATA(LIM2+L),L=16,21)
 9002 FORMAT(' ',I3,I9,4I4,4F8.3,I4,4F8.3,2I3,I6,3I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,118,0.)
      NCLST  = IDATA(LIM2+3)
      NWPCL  = IDATA(LIM2+21)
      ILABEL = IDATA(LIM2+17)
      NCLS2  = NCLST*2+ 2
      LIM2   = LIM2 + 21
      LIM22  = 2*LIM2
      YS     = YS - DEL
      CALL CORE(HWORK,101)
*PMF26/11/99 WRITE(cHWORK,9003) ((HDATA(LIM22+L),HDATA(LIM22+L+1)),L=1,NCLS2,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
*       CALL SYSSYM(XS,YS,SIZE,HWORK,101,0.)
      nnnn=ncls2
      print *,int((ncls2-1)/20)
      do iiii=1,1+int((ncls2-1)/20)
       write(chwork,9003) (hdata(lim22+l+20*(iiii-1)),l=1,min(20,nnnn)) ! PMF 17/11/99: JUSCRN changed to cHWORK
       call syssym(xs,ys,size,hwork,101,0.)
       ys=ys-del
       nnnn=nnnn-20
      enddo
*PMF(end)
 9003 FORMAT(' ',20I5)! PMF 26/11/99: 20I5->20I4 
      IF( NCLST .LE. 0 ) GO TO 90100
      LIM2 = LIM2 + NCLST + 1
      YS   = YS - DEL
      DO 9006  ITR = 1,NCLST
         IPO = LIM2 + (ITR-1)*NWPCL
         CALL CORE(HWORK,119)
         WRITE(cHWORK,9004) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                      IDATA(IPO+8),(ADATA(IPO+JJ),JJ=9,NWPCL)
 9004    FORMAT(' ',I3,2F8.3,2F9.2,2F8.3,I4,4F8.3,F10.3,2F6.3,F7.3)
         CALL SYSSYM(XS,YS,SIZE,HWORK,119,0.)
         YS = YS - DEL
         IF( YS .GT. 80.0 ) GO TO 9006
            IRETUR = 9
            GO TO 90000
 9005    CONTINUE
 9006 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR TOFR BANKS
10000 NTR  = IDATA(LIM2)
      LIM2 = LIM2 - 1
      CALL CORE(HWORK,17)
      WRITE(cHWORK,10001) (IDATA(LIM2+I),I=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
10001 FORMAT(' ',4I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,17,0.)
      YS = YS - DEL
      DO 10004  ITR = 1,NTR
         IPO = LIM2 + 4 + (ITR-1)*14
         CALL CORE(HWORK,118)
         WRITE(cHWORK,10002) (IDATA(IPO+I),I=1,3),(ADATA(IPO+I),I=4,14) ! PMF 17/11/99: JUSCRN changed to cHWORK
10002    FORMAT(' ',3I3,F8.3,F8.1,4F8.4,4F12.3,E12.4)
         CALL SYSSYM(XS,YS,SIZE,HWORK,118,0.)
         YS = YS - DEL
         IF( YS .GT. 80.0 ) GO TO 10004
            IRETUR = 10
            GO TO 90000
10003    CONTINUE
10004 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR TPEV BANK
11000 LIM2 = LIM2 - 1
      CALL PRTPEV( LIM2, XS, YS, DEL, SIZE )
      GO TO 90100
C--------------- SPECIAL FORMAT FOR TPTR BANKS
12000 LIM2 = LIM2 - 1
      CALL PRTPTR( LIM2, XS, YS, DEL, SIZE )
      GO TO 90100
C--------------- SPECIAL FORMAT FOR ATOF BANK
13000 IPTOF = LIM2-1
      CALL AGRPR(IPTOF,*13001)
      GO TO 13003
13001 WRITE(JUSCRN,13002)
13002 FORMAT(' ATFUGR ERROR, WRONG BANK DESCRIPTOR...' )
      RETURN
13003 CALL PRATOF( XS, YS, DEL, SIZE )
      GO TO 90100
C--------------- SPECIAL FORMAT FOR TPVX BANK
14000 LIM2 = LIM2 - 1
      CALL PRTPVX( LIM2, XS, YS, DEL, SIZE )
      GO TO 90100
C--------------- SPECIAL FORMAT FOR VECT BANK
C-  FIRST VECT 0, THEN VECT 1 IF IT EXISTS
C-
15000 IVPS = 0
      LIM2 = LIM2 - 1
      IF( NBOS .EQ. 1 ) GO TO 15010
15001 LO   = IDATA(LIM2+1)
      LTR  = IDATA(LIM2+2)
      NTR  = IDATA(LIM2+4)
      IPO  = LIM2 + LO
      CALL CORE(HWORK,106)
      WRITE(cHWORK,15002) (IDATA(LIM2+II),II=1,LO) ! PMF 17/11/99: JUSCRN changed to cHWORK
15002 FORMAT('  ',6I8,2F8.4,5I8)
      LOO = LO*8 + 2
      CALL SYSSYM(XS,YS,SIZE,HWORK,LOO,0.)
      LO1 = MIN0(12,LO)
      IF( LO1 .LT. 7 ) GO TO 15004
         YS = YS - DEL
         CALL CORE(HWORK,124)
         WRITE(cHWORK,15003) (ADATA(LIM2+II),II=7,LO1) ! PMF 17/11/99: JUSCRN changed to cHWORK
15003    FORMAT(' HEADER WORDS 7-.. ',6E14.6)
         LOO = (LO1-6)*14 + 19
         CALL SYSSYM(XS,YS,SIZE,HWORK,LOO,0.)
15004 ICNT = 0
15005 ICNT = ICNT + 1
      IF( ICNT .GT. NTR .AND. IVPS .EQ. 1 ) GO TO 90100
      IF( ICNT .GT. NTR .AND. IVPS .EQ. 0 ) GO TO 15010
15006 YS = YS - DEL
      IF( YS .GT. 50.0 ) GO TO 15007
         IRETUR = 15
         GO TO 90000
15007 IPP = IPO + (ICNT-1)*LTR
      IF( LTR .EQ. 10 ) CALL CORE(HWORK,102)
      IF( LTR .EQ. 12 ) CALL CORE(HWORK,122)
      IF( LTR .EQ. 10 )
     *  WRITE(cHWORK,15008) ICNT,(ADATA(IPP+I),I=1,5), ! PMF 17/11/99: JUSCRN changed to cHWORK
     * (IDATA(IPP+I),I=6,7),(ADATA(IPP+I),I=8,10)
15008 FORMAT(' ',I4,3X,4F10.4,2X,F10.6,2X,2I4,2X,3F10.3)
      IF( LTR .EQ. 12 )
     *  WRITE(cHWORK,15009) ICNT, ! PMF 17/11/99: JUSCRN changed to cHWORK
     * (ADATA(IPP+I),I=1,5),(IDATA(IPP+I),I=6,7),
     * (ADATA(IPP+I),I=8,10),HDATA(2*IPP+21),HDATA(2*IPP+22),
     *  ADATA(IPP+12)
15009 FORMAT(' ',I4,3X,4F10.4,2X,F10.6,2X,2I4,2X,3F10.3,2I5,F10.2)
      IF( LTR .EQ. 10 ) CALL SYSSYM(XS,YS,SIZE,HWORK,102,0.)
      IF( LTR .EQ. 12 ) CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      GO TO 15005
15010 CONTINUE
      LIM2 = IDATA(LIM2-1)
      IF( LIM2 .LT. 1 ) GO TO 90100
      IVPS = 1
C* WRITE BANK HEADER FOR VECT 1
      call setlin(ys)           !PMF 29/11/99: let newlin know the current line
      CALL NEWLIN
      CALL NEWLIN
      LIM1  = LIM2 - 2
      LIMX  = LIM2
      LIMHX = 2*LIMX
      NAME  = IDATA(LIM2-3)
      CALL CORE(HDSPL,76)
      WRITE(cHDSPL,140)(IDATA(LHO),LHO=LIM1,LIMX),(HDATA(LIMHX+J),J=1,2) ! PMF 17/11/99: UNIT=10 changed to cHDSPL
      CALL EOUTST(80,HWORK)
      CALL NEWLIN
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
      CALL CHRSIZ(4)
      CALL CSIZE(IX,IXT)
      GO TO 15001
C--------------- SPECIAL FORMAT FOR TRIG BANK
16000 CONTINUE
      DO 16005 LHO = 1,NCYCLE
16001    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 16002
            IRETUR = 16
            GO TO 90000
16002    LIML = 2*LIM2 + 20*(LHO-1) + 1
         LIMU = LIML + 19
         IF( LIMU .GT. (2*LIM2+LENGB) ) LIMU = 2*LIM2 + LENGB
         ILIM = LIMU - LIML + 1
         IF( ILIM .LE. 0 ) GO TO 90100
         DO 16003  I = 1,ILIM
            LLO = LIML + I - 1
            HWORK(I+100) = HDATA(LLO)
16003    CONTINUE
         IILIM = 6*ILIM + 1
         CALL CORE(HWORK,IILIM)
         WRITE(cHWORK,16004) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
16004    FORMAT(' ',20I6)
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
16005 CONTINUE
      GO TO 90100
C--------------- SPECIAL FORMAT FOR N50S BANKS
17000 LIM2 = LIM2 - 1
      CALL PRN50S( LIM2, XS, YS, DEL, SIZE )
C
C MPRS BANK PART, INCLUDE SO THAT ALSO INDEPENDENT PRINT POSSIBLE
C
      IPLNAM = IDATA(IBLN('MPRS'))
      IF( IPLNAM .LE. 0 ) GO TO 90100
      LIM2 = IPLNAM + 1
      YS   = YS - DEL
      CALL CORE(HWORK,54)
      WRITE(cHWORK,17001) ! PMF 17/11/99: JUSCRN changed to cHWORK
17001 FORMAT(' ------------->>>   MIPROC RESULTS   <<<--------------')
      CALL SYSSYM(XS,YS,SIZE,HWORK,54,0.)
C--------------- SPECIAL FORMAT FOR MPRS BANKS
18000 LIM2 = LIM2 - 1
      CALL PRMPRS( LIM2, XS, YS, DEL, SIZE )
      GO TO 90100
C
C--------------- SPECIAL FORMAT FOR FAMP BANKS (NOW TEMPORARILY BK17)
19000 LIM2 = LIM2 - 1
      LH2  = LIM2*2
      YS   = YS - DEL
      CALL CORE(HWORK,28)
      WRITE(cHWORK,19001) HDATA(LH2+3) ! PMF 17/11/99: JUSCRN changed to cHWORK
19001 FORMAT(' FAMP PROGRAM VERSION ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
C TRIGGERS
      NTRI = HDATA(LH2+4)
      IF( NTRI .LE. 0 ) GO TO 19003
         YS = YS - DEL
         CALL CORE(HWORK,77)
         WRITE(cHWORK,19002) (HDATA(LH2+NTRI+K),K=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
19002    FORMAT(' #T2 TRACKS ',I3,' R3 TRACKS CELLS 33-48 ',Z4,
     *          '  CELLS 17-32 ',Z4,'  CELLS 1-16 ',Z4)
         CALL SYSSYM(XS,YS,SIZE,HWORK,77,0.)
C COUNTERS
19003 NCOU = HDATA(LH2+5)
      IF( NCOU .LE. 0 ) GO TO 19005
         AA = HDATA(LH2+NCOU+2)*.1
         YS = YS - DEL
         CALL CORE(HWORK,53)
         WRITE(cHWORK,19004) HDATA(LH2+NCOU+1),AA,HDATA(LH2+NCOU+3), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       HDATA(LH2+NCOU+4)
19004    FORMAT(' #TOFS ',I3,' TDIF(NS) ',F8.1,' ZVTOF ',I6,' ZVLG ',I6)
         CALL SYSSYM(XS,YS,SIZE,HWORK,53,0.)
C LEAD GLASS
19005 NL = HDATA(LH2+6)
      IF( NL .LE. 0 ) GO TO 19007
         AA1 = HDATA(LH2+NL+5)*.001
         AA2 = HDATA(LH2+NL+6)*.001
         AA3 = HDATA(LH2+NL+7)*.001
         AA4 = HDATA(LH2+NL+8)*.001
         YS  = YS - DEL
         CALL CORE(HWORK,124)
         WRITE(cHWORK,19006) (HDATA(LH2+NL+K),K=1,4),AA1,AA2,AA3,AA4, ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       (HDATA(LH2+NL+KK),KK=9,10)
19006    FORMAT(' NR CLUSTERS TOTAL,BARREL,-EC,+EC : ',4I5,
     *          ' ENERGIES: ',4F8.3,' NHCLI ',I6,' ERES ',I6)
         CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
C INNER DETECTOR ANALYSIS
19007 ND = HDATA(LH2+7)
      IF( ND .GT. 0 ) GO TO 19009
         YS = YS - DEL
         CALL CORE(HWORK,35)
         WRITE(cHWORK,19008) ! PMF 17/11/99: JUSCRN changed to cHWORK
19008    FORMAT(' ---> NO INNER DETECTOR INFORMATION')
         CALL SYSSYM(XS,YS,SIZE,HWORK,35,0.)
         GO TO 19033
19009 CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(cHWORK,19010) (HDATA(LH2+ND+K),K=1,3) ! PMF 17/11/99: JUSCRN changed to cHWORK
19010 FORMAT(' ID ZVTX FLAG ',I3,'  ZVTX IN MM ',I6,' INRGZV ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
      YS     = YS - DEL
      INRGZV = HDATA(LH2+ND+3)
      NTR    = HDATA(LH2+ND+4)
      NTRT   = HDATA(LH2+ND+5)
      CALL CORE(HWORK,49)
      IF( NTR .LT. 0 ) WRITE(cHWORK,19011) ! PMF 17/11/99: JUSCRN changed to cHWORK
19011 FORMAT(' PATTERN RECOGNITION NOT PERFORMED              ')
      IF( NTR .EQ. 0 ) WRITE(cHWORK,19012) ! PMF 17/11/99: JUSCRN changed to cHWORK
19012 FORMAT(' PATTERN RECOGNITION PERFORMED, NO TRACKS FOUND ')
      IF( NTR .LE. 0 ) CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      IF( NTR .LE. 0 ) GO TO 19033
         WRITE(cHWORK,19013) NTRT,NTR ! PMF 17/11/99: JUSCRN changed to cHWORK
19013    FORMAT(' PATREC PERFORMED,',I3,' TRACKS FOUND',I3,
     *          ' TRACK BANKS')
         CALL SYSSYM(XS,YS,SIZE,HWORK,49,0.)
         LORT = HDATA(LH2+ND+6)
         LTRT = HDATA(LH2+ND+7)
         MWR1 = HDATA(LH2+ND+8)
         MWR2 = HDATA(LH2+ND+9)
         MWR3 = HDATA(LH2+ND+10)
         IEFA = HDATA(LH2+ND+11)
         IPLT = LH2+ND+LORT-LTRT
         YS   = YS - DEL
         CALL CORE(HWORK,102)
         WRITE(cHWORK,19014) NTRT,LORT,LTRT,MWR1,MWR2,MWR3,IEFA ! PMF 17/11/99: JUSCRN changed to cHWORK
19014    FORMAT(' TRACKS LISTED ',I4,'  LO AND LT FOR EACH ',2I4,
     *          ' NR WORDS MAP RING1-3: ',3I5,' ERROR FLAG ',Z4)
         CALL SYSSYM(XS,YS,SIZE,HWORK,102,0.)
C
         DO 19018  ITR = 1,NTR
            IPLT    = IPLT + LTRT
            IFTR    = HDATA(IPLT)
            RR1     = HDATA(IPLT+1)*.1
            FI1     = HDATA(IPLT+2)
            Z1      = HDATA(IPLT+3)*.1
            RR2     = HDATA(IPLT+4)*.1
            FI2     = HDATA(IPLT+5)
            Z2      = HDATA(IPLT+6)*.1
            HELP(1) = HDATA(IPLT+8)
            HELP(2) = HDATA(IPLT+9)
            RR      = FLOAT(IZWORD)*.1
            SIGXY   = HDATA(IPLT+10)*.01
            NXY     = HDATA(IPLT+11)
            TANTH   = HDATA(IPLT+12)*001
            Z0      = HDATA(IPLT+13)*.1
            SIGZ    = HDATA(IPLT+14)*.1
            NZ      = HDATA(IPLT+15)
            YS      = YS - DEL
            IF( YS .GT. 50.0 ) GO TO 19015
               IRETUR = 19
               GO TO 90000
19015       CONTINUE
            CALL CORE(HWORK,120)
            WRITE(cHWORK,19016) ITR,IFTR,RR1,FI1, ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                          Z1,RR2,FI2,Z2,RR,SIGXY,NXY
19016       FORMAT(' ',I2,' SEC. ',I3,' R-FI-Z 1 ',F8.1,F5.0,F8.1,
     *             ' R-FI-Z 2 ',F8.1,F5.0,F8.1,
     *             ' RCURV SIGXY NHITXY ',E14.6,F8.2,I4)
            CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
C
            YS = YS - DEL
            CALL CORE(HWORK,115)
            WRITE(cHWORK,19017) TANTH,Z0,SIGZ,NZ ! PMF 17/11/99: JUSCRN changed to cHWORK
19017       FORMAT(' ',59X,' TANTHETA ',F10.5,' Z0 ',F8.2,
     *             ' SIGZ(MM) ',F7.4,' NZ ',I2)
            CALL SYSSYM(XS,YS,SIZE,HWORK,115,0.)
C
19018 CONTINUE
      IPLT  = IPLT + LTRT
      IPLT1 = IPLT
      IPLT2 = IPLT1+MWR1
      IPLT3 = IPLT2+MWR2
      IPLT4 = IPLT3+MWR3
      YS    = YS - DEL
      IF( YS .GT. 50.0 ) GO TO 19019
         IRETUR = 41
         GO TO 90000
19019 CONTINUE
      CALL CORE(HWORK,44)
      WRITE(cHWORK,19020) IPLT1,IPLT2,IPLT3,IPLT4 ! PMF 17/11/99: JUSCRN changed to cHWORK
19020 FORMAT(' FAMP HIT MAP POINTERS: ',4I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,44,0.)
      IF( IPLT2 .EQ. IPLT1 ) GO TO 19024
19021    IPLT22 = IPLT2-1
         IF( IPLT22 .GT. IPLT1+19 ) IPLT22 = IPLT1+19
         IRESV = 22+5*(IPLT22-IPLT1+1)
         YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 19022
            IRETUR = 42
            GO TO 90000
19022    CONTINUE
         CALL CORE(HWORK,IRESV)
         WRITE(cHWORK,19023) (HDATA(II),II=IPLT1,IPLT22) ! PMF 17/11/99: JUSCRN changed to cHWORK
19023    FORMAT(' ',14X,' RING1 ',20(Z4,1X))
         CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
         IF( IPLT22 .GE. IPLT2-1 ) GO TO 19024
            IPLT1 = IPLT22 + 1
            GO TO 19021
19024 CONTINUE
      IF( IPLT3 .EQ. IPLT2 ) GO TO 19028
19025    IPLT33 = IPLT3-1
         IF( IPLT33 .GT. IPLT2+19 ) IPLT33 = IPLT2 + 19
         IRESV = 22 + 5*(IPLT33-IPLT2+1)
         YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 19026
            IRETUR = 43
            GO TO 90000
19026    CONTINUE
         CALL CORE(HWORK,IRESV)
         WRITE(cHWORK,19027) (HDATA(II),II=IPLT2,IPLT33) ! PMF 17/11/99: JUSCRN changed to cHWORK
19027    FORMAT(' ',14X,' RING2 ',20(Z4,1X))
         CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
         IF( IPLT33 .GE. IPLT3-1 ) GO TO 19028
            IPLT2 = IPLT33 + 1
            GO TO 19025
19028 CONTINUE
      IF( IPLT4 .EQ. IPLT3 ) GO TO 19032
      IF( INRGZV .NE. 3 ) GO TO 19032
19029    IPLT44 = IPLT3-1
         IF( IPLT44 .GT. IPLT3+19 ) IPLT44 = IPLT3 + 19
         IRESV = 22 + 5*(IPLT44-IPLT3+1)
         YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 19030
            IRETUR = 44
            GO TO 90000
19030    CONTINUE
         CALL CORE(HWORK,IRESV)
         WRITE(cHWORK,19031) (HDATA(II),II=IPLT3,IPLT44) ! PMF 17/11/99: JUSCRN changed to cHWORK
19031    FORMAT(' ',14X,' RING3 ',20(Z4,1X))
         CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
         IF( IPLT44 .GE. IPLT4-1 ) GO TO 19032
            IPLT3 = IPLT44+1
            GO TO 19029
19032 CONTINUE
C
19033 NM = HDATA(LH2+8)
      IF( NM .LE. 0 ) GO TO 19036
         YS  = YS - DEL
         NMU = HDATA(LH2+NM)
         IF( NMU .GT. 5 ) NMU =  5
         NCORE = 44 + NMU*4
         NMU   = 2*NMU + 1
         CALL CORE(HWORK,64)
         WRITE(cHWORK,19034) HDATA(LH2+NM),HDATA(LH2+NM+1), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                      (HDATA(LH2+NM+K),K=2,NMU,2)
19034    FORMAT(' NR MUON TRACKS ',I2,'   IN BARREL ',I3,
     *          ' POSITION ',5I4)
         CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
         YS = YS - DEL
         CALL CORE(HWORK,64)
         WRITE(cHWORK,19035) (HDATA(LH2+NM+K+1),K = 2,NMU,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
19035    FORMAT('                ',3X,'             ',3X,
     *          ' QUALITY ',5I4)
         CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
C
19036 CONTINUE
      NTG = HDATA(LH2+9)
      IF( NTG .LE. 0 ) GO TO 19038
         YS = YS - DEL
         CALL CORE(HWORK,50)
         WRITE(cHWORK,19037) (HDATA(LH2+NTG+K),K=1,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
19037    FORMAT(' TAGGING ENERGIES(MEV) IN -Z, +Z: ',2I8)
         CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
19038 CONTINUE
      GO TO 90100
C-------------------------
C----   SPECIAL FORMAT FOR ZTRG BANKS
C-------------------------
20000 LIM2   = LIM2 - 1
      LEZTRG = IDATA(LIM2)
      IZDESC = HDATA(2*LIM2+1)
      IF(IZDESC.GE.2) GO TO 20100
C  OLD FORMAT
      HPOINT = 2*( LIM2 + 1 )
      HZLENG = 2*( LEZTRG - 1 )
      YS     = YS - DEL
C                    WRITE HEADER
      IILIM  = 110
      CALL CORE(HWORK,IILIM)
      WRITE(cHWORK,20001) ! PMF 17/11/99: JUSCRN changed to cHWORK
20001 FORMAT(' DATA  B15 CHANNEL FIFOF HITCN UFLOW OFLOW Z-VALUE',10X,
     *' DATA  B15 CHANNEL FIFOF HITCN UFLOW OFLOW Z-VALUE')
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
C
      DO 20004 IHIT = 1,HZLENG,2
         HELP(2) = HDATA(HPOINT+IHIT)
         IZWRD1  = IZWORD
         KANAL1  = LAND( ISHFTR(IZWORD,11),15)
         HITCN1  = LAND( ISHFTR(IZWORD,8),3)
         IBT151  = 0
         IF( TBIT(IZWORD,16) ) IBT151 = 1
         IZWRT1  = LAND( IZWORD,63 )
         IOVRF1  = 0
         IF( LAND(IZWORD,64) .NE. 0 ) IOVRF1 = 1
         IUNDF1  = 0
         IF( LAND(IZWORD,128) .NE. 0 ) IUNDF1 = 1
         IFIFF1  = 0
         IF( LAND(IZWORD,1024) .NE. 0 ) IFIFF1 = 1
C
         HELP(2) = HDATA(HPOINT+IHIT+1)
         IZWRD2  = IZWORD
         KANAL2  = LAND( ISHFTR(IZWORD,11),15)
         HITCN2  = LAND( ISHFTR(IZWORD,8),3)
         IBT152 = 0
         IF( TBIT(IZWORD,16) ) IBT152 = 1
         IZWRT2 = LAND( IZWORD,63 )
         IOVRF2 = 0
         IF( LAND(IZWORD,64) .NE. 0 ) IOVRF2 = 1
         IUNDF2 = 0
         IF( LAND(IZWORD,128) .NE. 0 ) IUNDF2 = 1
         IFIFF2 = 0
         IF( LAND(IZWORD,1024) .NE.0 ) IFIFF2 = 1
C
         YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 20002
            IRETUR = 20
            GO TO 90000
20002    CONTINUE
         IILIM = 108
         CALL CORE(HWORK,IILIM)
         WRITE(cHWORK,20003) IZWRD1,IBT151,KANAL1,IFIFF1,HITCN1,IUNDF1, ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       IOVRF1,IZWRT1,
     *                       IZWRD2,IBT152,KANAL2,IFIFF2,HITCN2,IUNDF2,
     *                       IOVRF2,IZWRT2
20003    FORMAT(' ',Z4,3X,I1,4X,I2,5X,I1,5X,I1,5X,I1,5X,I1,4X,I5,
     *          13X,Z4,3X,I1,4X,I2,5X,I1,5X,I1,5X,I1,5X,I1,4X,I5)
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
20004 CONTINUE
      GO TO 90100
C
C  NEW FORMAT
C
20100 HPOINT = 2*( LIM2 + 1 ) + 1
      HZLENG = HDATA(HPOINT)
      YS     = YS - DEL
C                    WRITE HEADER
      IILIM  = 112
      CALL CORE(HWORK,IILIM)
      WRITE(cHWORK,20101) HZLENG ! PMF 17/11/99: JUSCRN changed to cHWORK
20101 FORMAT(' DATA  B15 CRATE SLOT SUBADR. OR UL LL OV Z-VALUE',5X,
     *' DATA  B15 CRATE SLOT SUBADR. OR UL LL OV Z-VALUE  L: ',I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
C
      DO 20104 IHIT = 1,HZLENG,2
         HELP(2) = HDATA(HPOINT+IHIT)
         IZWRD1  = IZWORD
         IF(HELP(2).LT.0) GO TO 20105
C  DATA WORD
         IBT151  = 0
         IZWRT1  = LAND( IZWORD,63 )
         IOVRF1  = 0
         IF( LAND(IZWORD,64) .NE. 0 ) IOVRF1 = 1
         ILL1  = 0
         IF( LAND(IZWORD,128) .NE. 0 ) ILL1 = 1
         IUL1  = 0
         IF( LAND(IZWORD,256) .NE. 0 ) IUL1 = 1
         IOR1  = 0
         IF( LAND(IZWORD,512) .NE. 0 ) IOR1 = 1
         GO TO 20106
C
20105    ISUB1 = LAND(IZWORD,3)
         ISLO1 = LAND(IZWORD,MSKSLO)
         ISLO1 = ISHFTR(ISLO1,2)
         ICRA1 = LAND(IZWORD,MSKCRA)
         ICRA1 = ISHFTR(ICRA1,7)
         IBT151 = 1
C
20106    HELP(2) = HDATA(HPOINT+IHIT+1)
         IZWRD2  = IZWORD
         IF(HELP(2).LT.0) GO TO 20107
C  DATA WORD
         IBT152  = 0
         IZWRT2  = LAND( IZWORD,63 )
         IOVRF2  = 0
         IF( LAND(IZWORD,64) .NE. 0 ) IOVRF2 = 1
         ILL2  = 0
         IF( LAND(IZWORD,128) .NE. 0 ) ILL2 = 1
         IUL2  = 0
         IF( LAND(IZWORD,256) .NE. 0 ) IUL2 = 1
         IOR2  = 0
         IF( LAND(IZWORD,512) .NE. 0 ) IOR2 = 1
         GO TO 20108
C
20107    ISUB2 = LAND(IZWORD,3)
         ISLO2 = LAND(IZWORD,MSKSLO)
         ISLO2 = ISHFTR(ISLO2,2)
         ICRA2 = LAND(IZWORD,MSKCRA)
         ICRA2 = ISHFTR(ICRA2,7)
         IBT152 = 1
C
C
20108    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 20102
            IRETUR = 26
            GO TO 90000
20102    CONTINUE
         IILIM = 106
         CALL CORE(HWORK,IILIM)
C ONLY DATA WORDS
         IF(IBT151.EQ.0.AND.IBT152.EQ.0)
     *   WRITE(cHWORK,20103) IZWRD1,IBT151,IOR1,IUL1,ILL1, ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       IOVRF1,IZWRT1,
     *                       IZWRD2,IBT152,IOR2,IUL2,ILL2,
     *                       IOVRF2,IZWRT2
20103 FORMAT(' ',Z4,3X,I1,                 22X,I1,2X,I1,2X,I1,2X,I1,4X,
     * I2, 8X,Z4,3X,I1,                 22X,I1,2X,I1,2X,I1,2X,I1,4X,I2)
C  DATA + ADRESS
         IF(IBT151.EQ.0.AND.IBT152.NE.0)
     *   WRITE(cHWORK,20109) IZWRD1,IBT151,IOR1,IUL1,ILL1, ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       IOVRF1,IZWRT1,
     *                       IZWRD2,IBT152,ICRA2,ISLO2,ISUB2
20109 FORMAT(' ',Z4,3X,I1,                 22X,I1,2X,I1,2X,I1,2X,I1,4X,
     * I2, 8X,Z4,3X,I1,4X,I1,3X,I2,5X,I1)
C   ADRESS + DATA
         IF(IBT151.NE.0.AND.IBT152.EQ.0)
     *   WRITE(cHWORK,20110) IZWRD1,IBT151,ICRA1,ISLO1,ISUB1, ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       IZWRD2,IBT152,IOR2,IUL2,ILL2,
     *                       IOVRF2,IZWRT2
20110 FORMAT(' ',Z4,3X,I1,4X,I1,3X,I2,5X,I1,5X,
     *    25X,Z4,3X,I1,                 22X,I1,2X,I1,2X,I1,2X,I1,4X,I2)
C  ONLY ADRESS WORDS
         IF(IBT151.NE.0.AND.IBT152.NE.0)
     *   WRITE(cHWORK,20111) IZWRD1,IBT151,ICRA1,ISLO1,ISUB1, ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                       IZWRD2,IBT152,ICRA2,ISLO2,ISUB2
20111 FORMAT(' ',Z4,3X,I1,4X,I1,3X,I2,5X,I1,5X,
     *    25X,Z4,3X,I1,4X,I1,3X,I2,5X,I1)
C
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
20104 CONTINUE
C
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR BPCH BANK
22000 LIM2 = LIM2 - 1
      LIMLIM = 2*LIM2
      LENGB  = 2*IDATA(LIM2)
      IAPOIN = LIMLIM + 2
      ILSUM = 0
22001 ILMPST = HDATA( IAPOIN + 1 )/2
C                            CHECK IF MP-STRING IS CORRECT
         IF( HDATA(IAPOIN + ILMPST) .NE. -2 ) GO TO 22002
             GO TO 22003
22002    IF( HDATA(IAPOIN + ILMPST) .NE. -1  .OR.
     *       HDATA(IAPOIN + ILMPST - 1) .NE. -2 ) GO TO 22090
C
C                            PROCESS MICROPROCESSOR-STRING
22003    YS = YS - DEL - DEL
C
         IPMPST = IAPOIN + 6
         ILSUMW = 0
         IMPROC = (HDATA(IPMPST+2)+41)/42
C
         CALL CORE(HWORK,66)
         WRITE(cHWORK,22004) (HDATA(IAPOIN+I),I=1,6), IMPROC ! PMF 17/11/99: JUSCRN changed to cHWORK
22004    FORMAT(' ',I4,I6,'   $',Z4,2I6,'   $',Z4,10X,'***   MP',I3,
     *          '   ***')
         CALL SYSSYM(XS,YS,SIZE,HWORK,66,0.)
C
22005    YS = YS - DEL
         IF( YS .GT. 150.0 ) GO TO 22006
            IRETUR = 22
            GO TO 90000
22006    ILWSDB = HDATA(IPMPST+1)
         ILWSID = ILWSDB/2
C                  CHECK IF WIRESIDE STRING IS CORRECT
         IF( HDATA( IPMPST + ILWSID) .NE. -8 ) GO TO 22049
C
C                            PROCESS WIRESIDE-STRING
            IWIRSD = HDATA(IPMPST+2)
            ILSTR  = ILWSDB - 6
            IEND   = ILWSID - 3
C
22007       DO 22008 I = 1, IEND
               ILB = I*2
               IHB = ILB - 1
***PMF 10/06/99   HBYTE(IHB) = LAND( HDATA( IPMPST+2+I ), 65280 )/256
***               HBYTE(ILB) = LAND( HDATA( IPMPST+2+I ), 255 )
              HBYTE(IHB) = hLAND( HDATA( IPMPST+2+I ), hint(65280) )/256
              HBYTE(ILB) = hLAND( HDATA( IPMPST+2+I ), hint(255) )
***PMF (end)
22008       CONTINUE
C
            IF( ILSTR .GT. 37 ) GO TO 22010
               ICORE = 12 + 3*ILSTR
               CALL CORE(HWORK,ICORE)
               WRITE(cHWORK,22009) ILWSDB, IWIRSD, (HBYTE(I),I=1,ILSTR) ! PMF 17/11/99: JUSCRN changed to cHWORK
22009          FORMAT(' ',I4,I4,'   ',37(Z2,1X))
               CALL SYSSYM(XS,YS,SIZE,HWORK,ICORE,0.)
               GO TO 22020
C
22010          CALL CORE(HWORK,123)
               WRITE(cHWORK,22009) ILWSDB, IWIRSD, (HBYTE(I),I=1,37) ! PMF 17/11/99: JUSCRN changed to cHWORK
               CALL SYSSYM(XS,YS,SIZE,HWORK,123,0.)
C
               YS = YS - DEL
               ILCON = ILSTR - 37
               ICORE = 12 + 3*ILCON
               CALL CORE(HWORK,ICORE)
               WRITE(cHWORK,22011) (HBYTE(37+I),I=1,ILCON) ! PMF 17/11/99: JUSCRN changed to cHWORK
22011          FORMAT(' ',11X,37(Z2,1X))
               CALL SYSSYM(XS,YS,SIZE,HWORK,ICORE,0.)
C
C                            CHECK IF LAST WS-STRING
22020       ILSUMW = ILSUMW + ILWSID
C                            SAFETY CHECK IF END OF MP-STRING
            IF( ILSUMW .GT. (ILMPST-7) ) GO TO 22050
C                            SET FLAG FOR LAST WIRESIDE-STRING
            IF( ILSUMW .EQ. (ILMPST-7) .OR. ILSUMW .EQ. (ILMPST-8) )
     *                                         GO TO 22050
               IPMPST = IPMPST + ILWSID
               GO TO 22005
22049    CALL TRMOUT(80,' BANKPR: error in wireside-string^')
22050 CONTINUE
C
C                            CHECK IF LAST MP-STRING
            ILSUM  = ILSUM + ILMPST
C                            SAFETY CHECK IF END OF BANK
            IF( ILSUM .GT. LENGB-2 ) GO TO 22099
C                            SET FLAG FOR LAST MP-STRING
            IF( ILSUM .EQ. LENGB-2 .OR. ILSUM .EQ. LENGB-3 ) GO TO 22099
               IAPOIN = IAPOIN + ILMPST
               GO TO 22001
22090    CALL TRMOUT(80,' BANKPR: error in microprocessor-string^')
22099 CONTINUE
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR VTXC BANK
23000 LIM2   = LIM2 - 1
      LIMLIM = 2*LIM2
      LOL    = 5
      LOLLOL = 10
      CALL CORE(HWORK,41)
      WRITE(cHWORK,23001) (IDATA(LIM2 + I),I=1,LOL) ! PMF 17/11/99: JUSCRN changed to cHWORK
23001 FORMAT(' ',5I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,41,0.)
      LENGTH = 2*IDATA(LIM2)
      LENGB = LENGTH - LOLLOL
      NCYCLE = 1 + (LENGB - 1)/20
      DO 23005 LHO = 1,NCYCLE
23002    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 23003
            IRETUR = 23
            GO TO 90000
23003    LIML = LIMLIM + 20*(LHO - 1) + LOLLOL
         LIMU = LIML + 20
         IF( LIMU .GT. (LIMLIM+LENGTH) ) LIMU = LIMLIM + LENGTH
         ILIM = LIMU - LIML
         IF( ILIM .LE. 0 ) GO TO 90100
         DO 23004 I = 1, ILIM
            LLO = LIML + I
            HWORK(I+100) = HDATA(LLO)
23004    CONTINUE
         IILIM = 6*ILIM + 1
         CALL CORE(HWORK,IILIM)
         WRITE(cHWORK,504) (HWORK(100+I),I=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
23005 CONTINUE
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR VTHT BANK
24000 LIM2   = LIM2 - 1
      LIMLIM = 2*LIM2
      LOLLOL = 6
      YS     = YS - DEL
      CALL CORE(HWORK,44)
      WRITE(cHWORK,24001) (HDATA(LIMLIM + I),I=1,LOLLOL) ! PMF 17/11/99: JUSCRN changed to cHWORK
24001 FORMAT(' ',I3,5I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,44,0.)
      LENGTH = 2*IDATA(LIM2)
      LENGB  = LENGTH - LOLLOL
      NCYCLE = 1 + (LENGB - 1)/8
      YS     = YS - DEL
      DO 24005 LHO = 1,NCYCLE
24002    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 24003
            IRETUR = 24
            GO TO 90000
24003    LIML = LIMLIM + 8*(LHO - 1) + LOLLOL
         LIMU = LIML + 8
         IF( LIMU .GT. (LIMLIM+LENGTH) ) LIMU = LIMLIM + LENGTH
         ILIM = LIMU - LIML
         IF( ILIM .LE. 0 ) GO TO 90100
         CALL CORE(HWORK,50)
         WRITE(cHWORK,24004) (HDATA(LIML+I),I=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
24004    FORMAT('  ',8I6)
         CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
24005 CONTINUE
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR VPAT BANK
25000 LIM2   = LIM2 - 1
      LIMLIM = 2*LIM2
      LOLLOL = 6
      YS     = YS - DEL
      CALL CORE(HWORK,44)
      WRITE(cHWORK,25001) (HDATA(LIMLIM + I),I=1,LOLLOL) ! PMF 17/11/99: JUSCRN changed to cHWORK
25001 FORMAT(' ',I3,5I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,44,0.)
      LENGTH = 2*IDATA(LIM2)
      LENGB = LENGTH - LOLLOL
      NCYCLE = 1 + (LENGB - 1)/12
      YS = YS - DEL
      DO 25005 LHO = 1,NCYCLE
25002    YS = YS - DEL
         IF( YS .GT. 50.0 ) GO TO 25003
            IRETUR = 25
            GO TO 90000
25003    LIML = LIMLIM + 12*(LHO - 1) + LOLLOL
         LIMU = LIML + 12
         IF( LIMU .GT. (LIMLIM+LENGTH) ) LIMU = LIMLIM + LENGTH
         ILIM = LIMU - LIML
         IF( ILIM .LE. 0 ) GO TO 90100
         CALL CORE(HWORK,74)
         WRITE(cHWORK,25004) (HDATA(LIML+I),I=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
25004    FORMAT('  ',12I6)
         CALL SYSSYM(XS,YS,SIZE,HWORK,74,0.)
25005 CONTINUE
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR VCVW BANK
26000 LIM2   = LIM2 - 1
      LIMLIM = 2*LIM2
      LOLLOL = 6
      YS     = YS - DEL
      CALL CORE(HWORK,44)
      WRITE(cHWORK,26001) (HDATA(LIMLIM + I),I=1,LOLLOL) ! PMF 17/11/99: JUSCRN changed to cHWORK
26001 FORMAT(' ',I3,5I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,44,0.)
      LENGTH = 2*IDATA(LIM2)
      IPARRY = LIMLIM + LOLLOL
26002 YS = YS - DEL
      IF( YS .GT. 150.0 ) GO TO 26003
         IRETUR = 26
         GO TO 90000
26003 ILENWS = HDATA(IPARRY+1)
      IF( ILENWS .GT. 24 ) GO TO 26005
         ICORE = 2 + ILENWS*5
         CALL CORE(HWORK,ICORE)
         WRITE(cHWORK,26004) (HDATA(IPARRY+I),I=1,ILENWS) ! PMF 17/11/99: JUSCRN changed to cHWORK
26004    FORMAT(' ',I4,I5,2X,22I5)
         CALL SYSSYM(XS,YS,SIZE,HWORK,ICORE,0.)
         GO TO 26007
26005 CALL CORE(HWORK,122)
      WRITE(cHWORK,26004) (HDATA(IPARRY+I),I=1,24) ! PMF 17/11/99: JUSCRN changed to cHWORK
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
C
      YS = YS - DEL
      ILCON = ILENWS - 24
      ICORE = 12 + 5*ILCON
      CALL CORE(HWORK,ICORE)
      WRITE(cHWORK,26006) (HDATA(IPARRY+24+I),I=1,ILCON) ! PMF 17/11/99: JUSCRN changed to cHWORK
26006 FORMAT(' ',11X,22I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,ICORE,0.)
26007 IPARRY = IPARRY + ILENWS
      IF( HDATA(IPARRY+1) .LE. 0 ) GO TO 90100
         IF( IPARRY .LT. LIMLIM+LENGTH ) GO TO 26002
      GO TO 90100
C____________________________ SPECIAL FORMAT FOR J68K BANK
27000 IRETUR = 0
      DEL = 0.7 * DEL
      SIZE = 0.7 * SIZE
27001 CALL PRJ68K( XS, YS, DEL, SIZE, IRETUR )
      IF( IRETUR.NE.0 ) GO TO 90000
      GO TO 90100
C--------------- SPECIAL FORMAT FOR PALL BANKS
28000 LIM2  = LIM2 - 1
      LO    = IDATA(LIM2+1)
      LTR   = IDATA(LIM2+2)
      NPA   = IDATA(LIM2+4)
      IPO   = LIM2 + LO
      CALL CORE(HWORK,79)
      WRITE(cHWORK,28001) (IDATA(LIM2+II),II=1,6),(ADATA(LIM2+JJ),JJ=7,8 ! PMF 17/11/99: JUSCRN changed to cHWORK
     *),IDATA(LIM2+9)
28001 FORMAT(' ',6I8,2F11.4,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,79,0.)
      YS   = YS - DEL
      ICNT = 0
28002 ICNT = ICNT + 1
      IF( ICNT .GT. NPA ) GO TO 90100
28003 YS = YS - DEL
      IF( YS .GT. 50.0 ) GO TO 28004
         IRETUR = 28
         GO TO 90000
28004 IPP = IPO + (ICNT-1)*LTR
      CALL CORE(HWORK,95)
      WRITE(cHWORK,28005) ! PMF 17/11/99: JUSCRN changed to cHWORK
     *     ICNT,(ADATA(IPP+II),II=1,5),(IDATA(IPP+JJ),JJ=6,9)
28005 FORMAT(' ',I4,3X,4F11.4,F11.6,4I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,95,0.)
      GO TO 28002
C---------------    CONTINUATION SECTION
90000 CONTINUE
      CALL CORE(HWORK,14)
      WRITE(cHWORK,90001) ! PMF 17/11/99: JUSCRN changed to cHWORK
90001 FORMAT(' CONTINUED ...')
      CALL SYSSYM(XS,YS,SIZE,HWORK,14,0.)
      GO TO 90200
90100 IRETUR = -1
90200 CALL TRMOUT(80,'Hardcopy ?^')
      CALL DECIDE(IANSW)
      IF( IANSW .NE. 1 ) GO TO 90300
90290    CALL TRMOUT(80,'Hardcopy on Laser Printer L1 .. L5 ?  (1 .. 5)^
     *')
         CALL TRMOUT(80,'Hardcopy on INTERNAL PLOTTER ?  (6)^')
         CALL TRMOUT(80,'Hardcopy on EXTERNAL PLOTTER ?  (7)^')
         CALL TRMOUT(80,'Enter your choice (1 .. 7 ) :^')
         CALL FYRINT(NDEST,ID2,ID3,ID4)
         IF( NDEST .LT. 1 .OR. NDEST .GT. 7 ) GO TO 90290
         IF( NDEST .LT. 6 ) CALL PTRANS(335,100)
         CALL HDCDST(DESTPL(NDEST))
90300 IF(IRETUR .EQ. -1 ) GO TO 99999
      IF( IANSW .EQ. 1 ) CALL PROMPT
      CALL ERASE
      YS = IYT0
      CALL TRMOUT(80,'TERMINATE THIS LISTING?^')
      CALL DECIDE(IANSW)
      IF( IANSW .EQ. 1 ) GO TO 99999
      CALL ERASE
      IF( IRETUR .EQ. 0 ) GO TO 501
      GOTO ( 1001, 2003, 3001, 4001, 5001, 6006, 7003,99999, 9005,10003,
     *      99999,99999,99999,99999,15006,16001,99999,99999,19015,20002,
     *      19015,22005,23002,24002,25002,26002,27001,28003, 2003, 4001,
     *      19019,19022,19026,19030,99999,99999,99999,99999,99999,99999)
     *   ,IRETUR
99999 RETURN
      END

C   29/05/80 312221222  MEMBER NAME  GENEE    (S)           FORTRAN
      SUBROUTINE GENMU( * )
C-----------------------------------------------------------
C
C  VERSION OF 03/03/80  LAST MOD 03/03/80    E.ELSEN
C  GENERATE MU-MU EVENTS AND FILL COMMON CPROD
C  RETURN 1 IF MORE THAN 10000 EVENTS
C----------------------------------------------------------
C
      COMMON/CPROD/ NEV,BEAM,PT,APHI,ATHETA,IFLAVR,
     *       NP,NC,NN,PP(4,500),XM(500),JCH(500),JTP(500),JP(500,2),
     *       NF,NCF,NNF,PF(4,300),XMF(300),ICF(300),ITF(300),
     *       PSTRT(3,300)
C
      DATA ICALL / 0 /, ICALIM / 10000 /
      DATA EBEAM /12. /
C
      ICALL = ICALL + 1
      IF( ICALL .GT. ICALIM ) RETURN 1
C                                           HEADER FOR CPROD
      NEV = ICALL
      IFLAVR = 0
      NP = 2
      NC = 2
      NN = 0
      NF = 2
      NCF = 2
      NNF = 0
C
      APHI = 6.28319 * RN(DUMMY)
      X = (1.-2*RN(DUMMY))*0.85
C
      ATHETA = ARCOS( X )
C     CALL UHIST( 1001, X )
      SINTH = SQRT( 1. - X**2 )
      PT = EBEAM * SINTH
C
      PP(1,1) = EBEAM * COS(APHI)*SINTH
      PP(2,1) = EBEAM * SIN(APHI)*SINTH
      PP(3,1) = EBEAM * X
      XM(1) = .000511
      PP(4,1) = SQRT( PP(1,1)**2+PP(2,1)**2+PP(3,1)**2+XM(1)**2)
      JCH(1) = 1
      JTP(1) = 2
      EBEAM = - EBEAM
      PP(1,2) = EBEAM * COS(APHI)*SINTH
      PP(2,2) = EBEAM * SIN(APHI)*SINTH
      PP(3,2) = EBEAM * X
      XM(2) = XM(1)
      PP(4,2) = SQRT( PP(1,2)**2+PP(2,2)**2+PP(3,2)**2+XM(2)**2)
      BEAM = SQRT(EBEAM**2 + XM(1)**2)
      JCH(2) = -1
      JTP(2) = JTP(1)
C
      DO 1000 J=1,2
      PF(1,J) = PP(1,J)
      PF(2,J) = PP(2,J)
      PF(3,J) = PP(3,J)
      PF(4,J) = PP(4,J)
      XMF(J) = XM(J)
      ICF(J) = JCH(J)
      ITF(J) = JTP(J)
      PSTRT(1,J) = 0.
      PSTRT(2,J) = 0.
      PSTRT(3,J) = 0.
 1000 CONTINUE
C
      RETURN
      END

C   01/11/84            MEMBER NAME  PBGRZ    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PBGRZ( INDEX, SH1, SH2, SH3 )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  LG AMPLITUDES   (R-Z-VIEWS)
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgeo1.for"
#include "cgraph.for"
C
      COMMON /CWORK1/ R,FI,XA,COSFI,X1,Y1,YA,SINFI,X2,Y2,ZET,X3,Y3,X4,Y400001900
     +               ,IMW(200)
C
      COMMON /CJTRIG/ PI,TWOPI
C
C-----------------  C O D E  -------------------------------------------
C
C     LEAD GLASS AMPLITUDES IN RZ VIEWS
C
      CALL PBGSUM(INDEX)
      call setcol('ECAL')     ! PMF 23/11/99: set colour
C DISPLAY ENDCAP SUMS
      DO 5020 IKJ=1,2
      X=ZENDMI-DEPEND+10.
      IF(IKJ.EQ.2) X=ZENDPL+10.
      Y0=-6*BLXY+10.
      DO 5020 KJI=1,12
      IRETRV=84+12*(IKJ-1)+KJI
      IESUM=IMW(IRETRV)
      IF(IESUM.LT.1) GO TO 5020
      Y=Y0+(KJI-1)*BLXY
      CALL DNUM(IESUM,X,Y,SH3,0.)
 5020 CONTINUE
C---
C---     NOW DO BARREL.
C---
      DO 34 ICC = 109,172
      IESUM = IMW(ICC)
      IF(IESUM.LT.0) GO TO 34
      ICCC = ICC - 108
      IF(ICCC.GT.32) ICCC = ICCC - 32
      X1 = ZLGMI + (ICCC-1)*BLZ
      Y1 = RLG
      X0 = X1 + 5.*SH2
      Y0 = Y1 + SH1
      FII = PI/2.
      IF(ICC.LT.141) GO TO 22
      Y1 = - RLG
      Y0 = Y1 - SH1
      X0 = X1 + SH2
      FII = 3.*PI/2.
   22 CALL DNUM(IESUM,X0,Y0,SH3,FII)
   34 CONTINUE
      call setcol(' ')     ! PMF 23/11/99: reset colour
      RETURN
      END

C   07/06/96 606071806  MEMBER NAME  BENT     (S4)          FORTG1
      SUBROUTINE BENT(NA,NB,NC,ND)
C     BOS SUBPROGRAM =0.1=
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
#include "ccs.for"
      EXTERNAL UCOPY2
      INTEGER INIT/0/
C
C     LAYOUT OF BANK COMMON/BCS/
C
C     INDEX    IW( )             I   MEANING
C     ------------------------------------------------------
C         1    IW(1)             I+  POINTER TO FIRST BANKS
C         .    ...               I
C     NAMAX    IW(NAMAX)         I
C      NFRS    SPACE FOR BANKS   I+     *
C              ...               I      *
C              ...               I      *
C              ...               I      * BANK SPACE
C              ...               I      *
C              ...               I      *
C      NLST    SPACE FOR BANKS   I      *
C              NALIST(1)         I+  LIST OF NAMES
C              ...               I
C     ISLST    NALIST(NLIST)     I
C              NSLIST(1)         I+  SPECIAL LIST OF NAMES
C              ...               I
C     IMLST    NSLIST(NLIST)     I
C              NMLIST(1)         I+  MARKER FOR SPECIAL LIST
C              ...               I
C              NMLIST(NLIST)     I
C     INAMV    NAME              I+  NAME
C              NAMES(1)          I+  NAMES
C              ...               I
C     IOLST    NAMES(NAMAX)      I
C              IOLIST(1)         I+  IO-MARKER
C              ...               I
C     IPLST    IOLIST(NAMAX)     I
C              IK(1)             I+  POINTER FOR NAMES
C              ...               I
C              IK(NAMAX)         I
C              IK(NAMAX+1)       I
C              ...               I
C     NLAST    IK(NAMAX+NPRIM)   I
C
C
      IF(INIT.NE.0) GOTO 100
      INIT=1
      CALL VZERO(ICOND,80)
      CALL VZERO(IUND ,11)
      NLAST =NA
      NLAST1=NLAST
      CALL VZERO(IW,NLAST)
      NRECL =NA
      NDUMP =500
      NDUMP1=NDUMP
      NSPL  =NLAST/10
      NAMAX =100
      NLIST =100
      NERRL =10
      NEOTP =2
      IF(NB.GT. 0) NSPL=NB
      IF(NC.GE.10) NAMAX=NC
      IF(ND.GE.10) NLIST=ND
      MARKWR=-1
C
   10 NPRIM=(NAMAX/2)*2-1
   12 NPRIM=NPRIM+2
      DO 14 K=3,NPRIM,2
      L    =NPRIM/K
      IF(L.LT.K) GOTO 16
      IF(L*K.EQ.NPRIM) GOTO 12
   14 CONTINUE
C
   16 NAMAX1=NAMAX+1
      IPLST=NLAST-NAMAX-NPRIM
      IOLST=IPLST-NAMAX
      INAMV=IOLST-NAMAX
      IMLST=INAMV-NLIST-1
      ISLST=IMLST-NLIST
      NFRS =NAMAX1
      NEXT =NFRS
      NLST =ISLST-NLIST
      ILOW=NLST
C
  100 RETURN
C
      END
      SUBROUTINE BDMPA(IARG)
      IF(IARG.EQ. 2) STOP 1
      IF(IARG.EQ. 1) STOP 2
      IF(IARG.EQ.30) STOP 3
      STOP 4
      END

C   22/06/84 406222014  MEMBER NAME  AFTP83   (S)           FORTRAN
C
C
C
C THIS   IS THE MAIN LEVEL OF MY ROUTINES TO TP THE TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE  AFTP83(IWRITE,EN, * , * )
C
C
C COMMONS   ETC FOR A.J.FINCH'S TP OF TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       IMPLICIT INTEGER * 2 ( H)
C
#include "cdata.for"
C
#include "comtag.for"
C
#include "cwktag.for"
C
#include "ctaggo.for"
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       INTEGER  START
       REAL  MZED
       INTEGER  PZMX
C
C PLUS   AND MINUS ZED DISTANCES OF TAGGERS
C
       DATA  PZED,MZED / 3160.0 , -3160.0 /
C
C
C----------------------- C O D E ---------------------------------------
C
C
C
C
C---                                         INITIALISATION
C
       CALL  TAGINT(&999)
C
       HWPCL  = 13
C
C ANGCUT   DEFINES COLINEARITY CRITERION
C FOR  COMPARING  CLUSTERS IN + AND - ZED
C
       ANGCUT  = 3.1
C
C  THRESH   IS THE THRESHOLD ENERGY FOR
C  STARTING   A CLUSTER SEARCH (MEV ?)
C
       THRESH  = EN * 25.0
C
       IF  ( IWRITE .EQ. 1 ) WRITE(6,6009) THRESH
 6009  FORMAT('  THRESHOLD FOR CLUSTER SEARCH IN TAGGER = ',F8.3)
C
C
       HIPM  = 4
C
       ISHALL  = IWRITE
C
C FILL   ARRAY CATAG : -
C COMFIL   DOES RETURN 1 FOR MISSING ATAG BANK - NO PROVISION YET
C NONE   REQUIRED TAGG/0 ONLY WILL BE CREATED ALL OTHER BANKS HAVE
C 0 LENGTH    SHOULD REALLY HAVE CHECKED BEFORE CALLING IT .
C
C
       CALL  COMFIL(ISHALL,&97)
C
C
C      SUBTRACT  PEDESTALS APPEARING DUE TO AC PICK UP ON SIGNAL CABLES
C
C
   97  CALL  PEDFIX
C
C RECALIBRATE   USING FACTORS FOUND FROM CALIBR COMMON FILLED PREVIOUSLY
C BY KALIBR   IN CALLING ROUTINE.
C
       CALL  CALAD(ISHALL)
C
C WORK  OUT SMZ AND SPZ  I.E. SUM OF ALL BLOCKS AT - Z/ + Z RESPECTIVELY
C
       CALL SRSUM(-1,SMZ,&98)
   98  CALL SRSUM(1,SPZ,&99)
   99  ETOT  = SMZ + SPZ
C
C SAVE   THIS INFORMATION IN WHAT WILL EVENTUALLY BE TAGG/0
C
       ATAGG0(29)  = 0.001 * ETOT
       ATAGG0(29)  = 0.001 * ETOT
       ATAGG0(32)  = 0.001 * ETOT
       ATAGG0(30)  = 0.001 * SMZ
       ATAGG0(33)  = 0.001 * SMZ
       ATAGG0(31)  = 0.001 * SPZ
       ATAGG0(34)  = 0.001 * SPZ
C
C
C NOW  PREPARE  TO DO THE FOLLOWING SECTION OF CODE FOR
C - Z  ONLY  ,LATER IT IS DONE FOR + ZED
C
       N = 0
C
C ZED  IS  - ZED   (IN MM )
C
       ZED = MZED
C
C JPART   IS - 1 FOR    - Z + 1 FOR + Z
C
       JPART = -1
C
C ISTART/IEND   = FIRST AND LAST PARTS OF CATAG TO USE ( - Z CHANNELS )
C
       ISTART = ISTMZ
       IEND   = IENDMZ
C
C APOINT   IS A POINTER USED IN CONSTRUCTING THE CLUSTER MAP FOR OUTPUT
C
       APOINT = 4
       HPZ    = APOINT
C
C
C SORT   ADC'S BY SIZE ORDER  SORTED LIST IS IN SADC
C
    1  CALL SORT1(ISTART,IEND,ISHALL)
C
C FIND   ADDRESSES OF MEMBERS OF CLUSTERS
C
       ISHALL  = IWRITE
       CALL  CLUSFN(ISTART,IEND,THRESH,ISHALL)
C
       IF ( IWRITE .EQ. 1 ) WRITE(6,6001) NCLST,JPART
 6001  FORMAT(' CLUSFN FOUND ',I4,' CLUSTERS IN TAGGER JPART ',I4)
C
C SAVE   THE INFORMATION WE HAVE NOW FOR CLUSTERS ( NUMBER OF THEM )
C

       IF  ( JPART .EQ. -1 ) HCLZMI = NCLST
       IF  ( JPART .EQ.  1 ) HCLZPL = NCLST
C
       IF  ( NCLST .EQ. 0 ) GOTO 10
C
C NOW  START  A LOOP OVER EACH CLUSTER IN TURN
C
       DO 10 I = 1,NCLST
          N  = N + 1
C
C SORT   EACH CLUSTER BY ENERGY ,PUT RESULT IN CLUS (9,2)
C
          CALL SORT2(I)
C
C CALCULATE   SUM OF ENERGY FOR CLUSTER , ANFD FILL ACLS
C      APOINT  POINTS TO THE START OF CLUSTER N IN ACLS
C
          HMAP(1,N)  = APOINT
C
C      FFADC  IS THE ADDRESS OF THE 'PARENT' OF THIS CLUSTER
C
          FFADC  = CMAP(I,1)
C
C      NNEI  IS THE NUMBER OF BLOCKS WHICH ARE NEIGHBOURS OF THIS BLOCK
C
          NNEI  = NLIST(FFADC,1,MARK)
C
C START   A LOOP OVER EACH MEMBER OF CLUSTER TO PUT THEM IN CLUSTER MAP
C AND  WORK  OUT SUM
C
          SUM  = 0
C
          DO 5 J = 1,NNEI
C
C      END  OF CLUSTER IF ENERGY OF THIS BLOCK IS ZERO
C
             IF  ( CLUS(J,2) .LE. 0 ) GOTO 5
             IHAPIN = APOINT * 2
C
C CONVERT   BACK FROM SOFTWARE ADDRESS TO HARDWARE ADDRESS
C TO REVERSE   ACTION TAKEN IN COMFIL (SOFTWARE ADDRESSES MAKE PROGRAM
C EASIER   TO WRITE AND READ)
C
             IADC  = CLUS(J,1)
             IHADC = FSTOH(IADC)
C
C FSTOH   RETURNS A VALUE OF - 1 IF IT CANT WORK OUT HARDWARE ADDRESS
C
             IF ( IHADC .EQ. -1 ) GOTO 5
C
C FILL   CLUSTER MAP - FIRST HALF WORD IS ADDRESS SECOND IS ENERGY
C
             HACLS(IHAPIN - 1) = IHADC
             HACLS(IHAPIN)     = CLUS(J,2)
C
C INCREMENT   POINTER   ALWAYS POINTS TO NEXT WORD TO BE FILLED
C
             APOINT = APOINT + 1
             SUM = SUM + CLUS(J,2)
 5        CONTINUE
C
          IF ( IWRITE .EQ. 1 ) WRITE(6,6005) N,JPART,SUM
 6005     FORMAT(1X,'THE ENERGY SUM FOR CLUSTER ',I4,
     1              ' IN JPART ',I4,'   IS ',F12.3)
C
C END  OF  LOOP OVER EACH MEMBER OF CLUSTER
C
C      HMAP(2,N)  IS WHERE TO FIND THE LAST MEMBER OF CLUSTER N IN ACLS
C
         HMAP(2,N)  = APOINT - 1
C
C WORK   OUT POSITION OF CENTRE OF EACH CLUSTER
C
         CALL CLSPS(SUM,ISHALL)
C
C WORK   OUT DIRECTION COSINES
C
         CALL TGDCOS(CAND(2 ) ,CAND(3 ) ,ZED,DX,DY,DZ)
C
C NOW  SAVE  INFORMATION FOR THIS CLUSTER
C
          IB = (N - 1) * HWPCL
          HIB = IB * 2
          HTAGG2(HIB + 1) = N
          HTAGG2(HIB + 2) = JPART
          ATAGG2(IB + 5)  = 0.001 * CAND(1 )
          ATAGG2(IB + 6)  = 0.001 * SIGEN
          ATAGG2(IB + 7)  = CAND(2)
          ATAGG2(IB + 8)  = CAND(3)
          ATAGG2(IB + 9)  = SIGX
          ATAGG2(IB + 10) = SIGY
          ATAGG2(IB + 11) = DX
          ATAGG2(IB + 12) = DY
          ATAGG2(IB + 13) = DZ
C
C END  OF  LOOP OVER EACH CLUSTER
C
   10  CONTINUE
C
C SET  UP  FOR AND DO PLUS ZED
C
       JPART  = JPART + 2
       IF ( JPART .GT. 1 ) GOTO 15
       HIPZ   = APOINT
       ZED    = PZED
       ISTART = ISTPZ
       IEND   = IENDPZ
       GOTO 1
C
   15  CONTINUE
C
C NOW  ALL  CLUSTERS IN - Z AND + Z HAVE BEEN FOUND AND THEIR PROPERTIES
C CALCULATED   - CALCULATE SOME MORE PROPERTIES OF THE EVENT AS A WHOLE
C
       HCLST  = HCLZPL + HCLZMI
       HNEUT  = HCLST
       HIPL   = APOINT
       ACOLAN = 6.29316
C
C      NOW  DO ACCOLINEARITY CHECKS
C
C      FIRST  CHECK THERE ARE CLUSTERS EACH SIDE
C
       IF ( ( HCLZMI .EQ. 0 ) .OR. ( HCLZPL .EQ. 0 ) ) GOTO 20
       EMAX  = 0
C
C FIND   THE CLUSTER IN - Z WITH GREATEST ENERGY (PROBABLY FIRST ONE)
C  MZMX   IS THE RECORD OF THIS (AS CLUSTER NUMBER IN TAGG/2)
C
       DO 16 I = 1,HCLZMI
          IB = (I - 1) * HWPCL
          EN = ATAGG2(IB + 5)
          IF ( EN .LT. EMAX ) GOTO 16
          EMAX = EN
          MZMX = I
   16  CONTINUE
C
C SIMILARLY    FOR + Z
C
       EMAX   = 0
       START  = HCLZMI + 1
       DO 17 I = START,HCLST
          IB = (I - 1) * HWPCL
          EN = ATAGG2(IB + 5)
          IF ( EN .LT. EMAX ) GOTO 17
          EMAX = EN
          PZMX = I
  17   CONTINUE
C
C FIND   THE ANGLE BETWEEN THE  LARGEST CLUSTERS IN + / - Z
C
       CALL ACOL(MZMX,PZMX,THETA)
       ACOLAN = THETA
C
C      NOW  FOR EACH CLUSTER IN - Z LOOK FOR A COLINEAR CLUSTER IN + Z
C
       START = HCLZMI + 1
C
       DO 20 I = 1,HCLZMI
C
          DO 22 J = START,HCLST
C
             CALL ACOL(I,J,THETA)
C
             IF ( THETA .LT. ANGCUT ) GOTO 22
C
C        COLINEAR PAIR FOUND   - FIRST COUNT HOW MANY THERE ARE
C
             HCOL = HCOL + 1
C
C TELL   - Z CLUSTER ABOUT ITS + Z PARTNER AND VICE VERSA
C
             HIB = 2 * ((I - 1) * HWPCL)
             HTAGG2(HIB + 5) = J
             HIB = 2 * ((J - 1) * HWPCL)
             HTAGG2(HIB + 5) = I
   22     CONTINUE
   20  CONTINUE
       ATAGG0(28) = ACOLAN
C
C FILL   TP BNKS ICLST/IPOINT ARE LENGTHS OF BANKS TO CREATE
C TAGSTO   CREATES THE BOS BANKS 'ACLS' 'TAGG'/0,1,2
C
       ICLST  = HCLST
       IPOINT = APOINT
       CALL TAGSTO(ICLST,IPOINT,IERTAG)
       IF ( IERTAG .NE. 0 ) RETURN 2

       RETURN
C
  999  RETURN 1
       END

C   29/09/77 606101226  MEMBER NAME  JCHAMB9  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JCHAMB( R, P, PENETR, PENETZ, IRETRN, DRMAX, * )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    05/01/78 :  PROPAGATES PARTICLE IN JET CHAMBER
C                                     THROUGH DIFFERENT LAYERS
C        MOD  E. ELSEN    02/10/81 :
C   LAST MOD  J. HAGEMANN 21/09/84 :  CHANGES DUE TO MODIFICATION OF
C             R. RAMCKE               SUBROUTINES JRING, JTRAPZ
C
C    ENERGY LOSS AND MULTIPLE SCATTERING ARE CONSIDERED ACCORDING
C    TO SWITCHES ELOSS AND MULSC
C    ROUTINE USES ROTATED COORDINATE SYSTEM
C    IRETRN IS RETRUN CODE:
C        IRETRN = 0 : NEXT ELEMENT, INCREASING X
C               = 1 : NEXT ELEMENT, DECREASING X
C               = 2 : NEXT ELEMENT, INCREASING Z
C               = 3 : NEXT ELEMENT, DECREASING Z
C               = 4 : PARTICLE STOPPED IN SYSTEM OR DECAY CONDITION
C                     REACHED.
C    RETURN 1 IF OVERFLOW IN EVENT REGISTER
C-----------------------------------------------------------------------
C
      COMMON / CJCELL / NCELL(3),
     *                  NWIRES(3)
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
      COMMON / CJIONI / POTBEA, ZAROBE,
     *                  POTTRI, ZAROTR,
     *                  POTIVE, ZAROIV,
     *                  POTRH0, ZAROR0,
     *                  POTJET, ZAROJE,
     *                  POTRH1, ZAROR1,
     *                  POTRH2, ZAROR2,
     *                  POTRH3, ZAROR3,
     *                  POTOVE, ZAROOV,
     *                  POTTOF, ZAROTO,
     *                  POTVES, ZARVES,
     *                  POTZJL, ZAROJL,
     *                  POTZJR, ZAROJR
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      COMMON / CJXDAT / XSLOPE, YSLOPE, XL(3), XH(3), R3P, RD3P,
     *                  S, S2,
     *                  XSL3L, X3L, XSL3H, X3H, YSL3L, Y3L, YSL3H,
     *                  YHWIDT, SINHLF, COSHLF, DRITAN
C
      DIMENSION R(5), P(7), DR(3)
      DIMENSION IERR(7)
C
      DATA TWOPI / 6.283185 /
*** PMF  20/06/00 Loop counter provided by subroutines TRCDTV, TRCDET
      INTEGER ILOOP1,ILOOP2
      COMMON/CLOOP/ ILOOP1,ILOOP2
*** PMF (end)
C
C------------------  C O D E  ------------------------------------------
C
C      -----ZERO CONTROL ARRAY IERR(7)
                   DO 881 I6=1,7
  881              IERR(I6) = 0
C      -----       END  OF CONTROL SECTION
         DPSI = TWOPI / FLOAT( NCELL(1) )
         PENETR = 0.
         PENETZ = 0.
C
C
C     ----   CHECK CHAMBER FRAME AND CHANGE TO ROTATED SYSTEM -----
C
   10 IF( R(3) .GE. ZJM ) GO TO 20
                    IRETRN = 3
                    RETURN
   20 IF( R(3) .LE. ZJP ) GO TO 30
                    IRETRN = 2
                    RETURN
   30 R(5) = ATAN2( R(2), R(1) )
                IF( R(5) .LT. PSIIN(1) ) R(5) = R(5) + TWOPI
                ICELL = ( R(5) - PSIIN(1) ) / DPSI + .5
                ICELL = MOD( ICELL, NCELL(1) )
                PHI = FLOAT( ICELL )* DPSI + PSIIN(1)
                COSPHI = COS( PHI )
                SINPHI = SIN( PHI )
                CALL JROTAT( R, COSPHI, SINPHI )
                CALL JROTAT( P, COSPHI, SINPHI )
C
      IF( R(1) .GE. R0ROH ) GO TO 50
*** PMF 20/06/00
*   Check the loop counter provided by TRCDET, TRCDTV
*   in order to detect infinite loops which sometimes happen 
*   for decreasing R (IRETRN = 1). This is due to rounding errors
*   in the calculation of the particle position here and in
*   subroutine JPRTLO.
      IF ( ILOOP1 .GT. 99 ) THEN
       IF ( ABS(R(1)-R0ROH)/R0ROH .LT. 1.E-5 ) THEN
       R(1)=R0ROH
       PRINT *,'*** JCHAMB: Infinite loop detected!!!(PMF 02/01/01)'
       PRINT *,'*** IRETRN = 1 case ignored after ',iloop1,' loops!!!'
       ILOOP1=0
       GOTO 50
       ELSE
       PRINT *,'*** JCHAMB: Bad infinite loop detected!!!(PMF 20/06/00)'
       PRINT *,'*** Will stop now!!!'
       STOP
       ENDIF
      ENDIF
*** PMF(end)
                          IRETRN = 1
                          GO TO 1000
C  50    XXX = XSLOPE*ABS(R(2))+RD3P
   50 IF( R(1) .LE. XSLOPE*ABS( R(2) ) + RD3P ) GO TO 100
                          IRETRN = 0
                          GO TO 1000
C
C
C    -----   START TRACKING THROUGH DIFFERENT LAYERS     -----
C
C    -----     FIRST ROHACELL
  100 CALL JTRAPZ( 1, R, P, R0ROH, R0ROH+DR0ROH, ZJM, ZJP,
     *                   POTRH0, ZAROR0, DR0ROH/XR0ROH, IRETRN,
     *                   COSPHI, SINPHI, DRMAX )
           IF( IRETRN .NE. 0 ) GO TO 1000
C
C    -----     FIRST RING
  200 CALL JRING( 1, ICELL, COSPHI, SINPHI, R, P, IRETRN, DRMAX, &2000 )
           GO TO ( 100, 1000, 1000, 1000, 1000 ), IRETRN
C
C    -----     SECOND ROHACELL
  300 CALL JTRAPZ( 1, R, P, R1ROH, R1ROH+DR1ROH, ZJM, ZJP,
     *                   POTRH1, ZAROR1, DR1ROH/XR1ROH, IRETRN,
     *                   COSPHI, SINPHI, DRMAX )
           GO TO ( 200, 1000, 1000, 1000, 1000 ), IRETRN
C
C    -----     SECOND RING
  400 CALL JRING( 2, ICELL, COSPHI, SINPHI, R, P, IRETRN, DRMAX, &2000 )
           GO TO ( 300, 1000, 1000, 1000, 1000 ), IRETRN
C
C    -----     THIRD ROHACELL
  500 CALL JTRAPZ( 1, R, P, R2ROH, R2ROH+DR2ROH, ZJM, ZJP,
     *                   POTRH2, ZAROR2, DR2ROH/XR2ROH, IRETRN,
     *                   COSPHI, SINPHI, DRMAX )
           GO TO ( 400, 1000, 1000, 1000, 1000 ), IRETRN
C
C    -----     THIRD RING
  600 CALL JRING( 3, ICELL, COSPHI, SINPHI, R, P, IRETRN, DRMAX, &2000 )
           GO TO ( 500, 1000, 1000, 1000, 1000 ), IRETRN
C
C    -----     FOURTH ROHACELL
  700 CALL JTRAPZ( 2, R, P, R3P, RD3P, ZJM, ZJP,
     *                   POTRH3, ZAROR3, DR3ROH/XR3ROH, IRETRN,
     *                   COSPHI, SINPHI , DRMAX )
           IF( IRETRN .EQ. 1 ) GO TO 600
C
C
C    ----   TRANSFORM INTO OLD COORDINATE SYSTEM    -----
 1000                   CALL JROTAT( R, COSPHI, -SINPHI )
                        CALL JROTAT( P, COSPHI, -SINPHI )
C
C      -----UPDATE AND CHECK CONTROL ARRAY IERR(7)
                   IERR(IRETRN+1) = IERR(IRETRN+1) + 1
                   IF( IERR(IRETRN+1) .LT. 30 ) GO TO 884
C 883  WRITE(6,9110) IERR
C9110  FORMAT(//'   *******   FORCED RETURN FROM JCHAMB *****'/
C    *          '             FAKING STOPPING PARTICLE'/
C    *          '             CONTROL ARRAY IERR (0-6)',7(2X,I4)//)
                   IRETRN = 4
                   RETURN
  884              CONTINUE
C      -----       END  OF CONTROL SECTION
C                                     IF IRETRN.EQ. 5 RESTART
C                                     TRACKING IN NEXT CELL
      IF( IRETRN .EQ. 5 ) GO TO 10
C
        R(4) = SQRT( R(1)*R(1) + R(2)*R(2) )
C    *          ' ---------------------------------------------------')
        IF( IRETRN .EQ. 2 ) PENETZ = R(3) - ZJP
        IF( IRETRN .EQ. 3 ) PENETZ = ZJM - R(3)
        RETURN
C
C   ----    ERROR EXIT FOR OVERFLOW IN HIT REGISTER   -----
 2000  RETURN 1
       END
      SUBROUTINE JROTAT( X, COSPHI, SINPHI )
C  *--------------------------------------------------------
C  *
C  *  VERSION OF 26/09/78
C  *  ROTATES THREE VECTOR X IN X Y PLANE.
C  *  COSPHI AND SINPHI DEFINE ROTATING ANGLE
C  *--------------------------------------------------------
C
      DIMENSION X(2)
C
      XX = X(1)
      X(1) = X(1)*COSPHI + X(2)*SINPHI
      X(2) = X(2)*COSPHI - XX*SINPHI
      RETURN
      END

C   18/05/84 405181805  MEMBER NAME  FWCAP    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FWCAP(ADX,ADY,LLL,FC,ITXT)
C-----------------------------------------------------------------------
C
C
C   AUTHOR:    J. OLSSON        ?    :  DRAW FORWARD DETECTOR FRONT VIEW
C
C   LAST MOD:  J. NYE       18/05/84 :  USE TAGMRK - WORKS FOR MC TOO
C
C
C     DRAW THE FORWARD DETECTOR FOR THE FW VIEW (CALLED BY DRAWFD)
C     FC IS A MAGNIFICATION FACTOR, SOMETIMES NEEDED FOR VISIBILITY.
C     ITXT NONZERO MEANS TEXT AND BEAM CROSS WILL BE ADDED TO PICTURE.
C     CALL TAGMRK TO FIND OUT VERSION NUMBER OF APPARATUS.
C
C     THE COMPLETE 1979-80 SETUP, WITH CHAMBERS AND SCINTILLATORS, CAN
C     BE FOUND IN THE MEMBER TAGDS0. IT IS NO LONGER BEING USED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgeo2.for"
#include "cwktag.for"
C
      DIMENSION XYHOL(2)
      EQUIVALENCE (XYHOL(1),XYHOL1)
C
C------------------  C O D E  ------------------------------------------
C
C                            TAGMRK PUTS VERSION NUMBER IN COMMON
C
      CALL TAGMRK(&1)
   1  IF( MARK .EQ. 0 ) GO TO 3
      IF( MARK .EQ. 1 ) GO TO 2
C
C                            1983 SET UP OF FORWARD COUNTERS
C
      CALL FWC83(ADX,ADY,LLL,FC,ITXT)
      RETURN
C
C                            1981-2 SET UP OF FORWARD COUNTERS
C
  2   CALL NEWCAP(ADX,ADY,LLL,ITXT)
      RETURN
C
C                            1979-80 SET UP OF FORWARD COUNTERS
C
  3   Y1   = - FENDC * 0.5
      X1   =   XYHOL1
      DO  17  I = 1,6
        Y1 = Y1 + FENDC
        Y2 = Y1
        IF( I .EQ. 1  .OR.  I .EQ. 3 ) X2 = X1 + 4.0 * FENDC
        IF( I .EQ. 2 ) X1 = FENDC
        IF( I .GT. 4 ) X2 = X2 - FENDC
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   17 CONTINUE
C
      X1 = - FENDC
      Y1 =   XYHOL2
      DO  18  I = 1,6
        X1 = X1 + FENDC
        X2 = X1
        IF( I .EQ. 1  .OR.  I .EQ. 3 ) Y2 = Y1 + 4.0 * FENDC
        IF( I .EQ. 2 ) Y1 = 1.5 * FENDC
        IF( I .GT. 4 ) Y2 = Y2 - FENDC
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   18 CONTINUE
C
      X1 = - FENDC
      X2 =   FENDC
      Y1 =   XYHOL2 - FENDC
      DO  19  I = 1,5
        Y1 = Y1 + FENDC
        Y2 = Y1
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   19 CONTINUE
C
      X1 =   XYHOL1 - FENDC
      Y1 = - 1.5 * FENDC
      Y2 = - Y1
      DO  20  I = 1,5
        X1 = X1 + FENDC
        X2 = X1
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   20 CONTINUE
C
      IF( ITXT .EQ. 0 ) RETURN
C
C                            WRITE TEXT
C                            WRITE +- Z   BELOW
C
      SH3 = 0.6 * FENDC
      Y1  = ADY - 7.0 * FENDC
      I   = 1
      IF( ADX .GT. 0.0 ) I = 2
      LABT = 101 + (I - 1) * 2
      X1   = ADX - 0.5 * FENDC
      CALL RUTEXT(LABT,X1,Y1,SH3)
C
C                            DRAW BEAM CROSS INSIDE CAP
C
      CALL MOVEA(ADX,ADY-20.)
      CALL DRAWA(ADX,ADY+20.)
      CALL MOVEA(ADX+20.,ADY)
      CALL DRAWA(ADX-30.,ADY)
      CALL DRAWA(ADX-30.,ADY+15.)
      CALL DRAWA(ADX-45.,ADY)
      CALL DRAWA(ADX-30.,ADY-15.)
      CALL DRAWA(ADX-30.,ADY)
C
      RETURN
C
C-----------------------------------------------------------------------
      ENTRY FWCAP1(ADX,ADY,INDX,K)
C-----------------------------------------------------------------------
C
C        DRAW FORWARD DETECTOR CAPS IN Z-X VIEW (K=1), Z-Y VIEW (K=2)
C        ADX,ADY IS POSITION OF CENTER OF FRONT FACE(CLOSEST WWP)
C        INDX IS 1 FOR -Z CAP, 2 FOR +Z CAP
C
      Y2  = 4.0 * FENDC + XYHOL(K)
      Y1  = ADY - Y2
      Y2  = ADY + Y2
      CALL DRAMOV(ADX,Y1,ADX,Y2,0)
      FCT = 1.0
      IF( INDX .EQ. 2 ) FCT = -1.0
      X2 = ADX + FCT * BLDPFW
      CALL DRAMOV(X2,Y1,X2,Y2,0)
      Y1 = -0.5 * FENDC
      IF( K .EQ. 1 ) Y1 = - FENDC
      DO  101  I = 1,6
        Y1 = Y1 + FENDC
        CALL DRAMOV(ADX,ADY+Y1,X2,ADY+Y1,0)
        CALL DRAMOV(ADX,ADY-Y1,X2,ADY-Y1,0)
101   CONTINUE
      Y1 = 4.0 * FENDC + XYHOL(K)
      CALL DRAMOV(ADX,ADY+Y1,X2,ADY+Y1,0)
      CALL DRAMOV(ADX,ADY-Y1,X2,ADY-Y1,0)
      RETURN
      END

C   16/07/79 011130328  MEMBER NAME  LGCALB   (SOURCE)      FORTRAN
      SUBROUTINE LGCALB(*)
C
C     S.YAMADA   09-03-79  10:50
C     LAST MODIFICATI0N  14-11-79  01:35 BY Y.WATANABE
C     LAST MODIFICATI0N  27-08-80  08:35 BY Y.WATANABE
C                INTERCHANGE 293 AND 613.
C     LAST MODIFICATI0N  12-11-80  13:35 BY Y.WATANABERUNS=4865-5666
C                INTERCHANGE AMP CABLE FOR THE LAST ADC OF THE BARREL.
C---- LG-ADC CALIBRATION SUB.TO SIMULATE THE LHO'S SYSTEM.
C
C---- TAKEDA'S  LGERSE IS CALLED TO FIX UP BAD CHANNELS
      IMPLICIT INTEGER *2 (H)
C
#include "cdata.for"
C
#include "clgwork1.for"
#include "clgkalb.for"
C
C     BOUNDARY LIST
      INTEGER*2 HCHLST(4)/0,2688,2784,2880/
      DATA INITP/0/
      IF(INITP.GT.0) GO TO 5
      INITP=1
      IP= IBLN('ALGL')
      IPNPHD= IBLN('HEAD')
5     CONTINUE
      LNG = 3
C     CALL CLOC( NP, 'ALGL',0 )
      NP=IDATA(IP)
      IF(NP.LE.0) RETURN
C---- IDATA(NP)=# OF DATA IN HDATA INCLUDING SUB-POINTERS
C               AND THE NORD-STATUS WORD.
      LNG = IDATA(NP)
      NNP = NP+NP
C
C
C---- EXAMINE IF FORMAT CHANGE IS ALREADY DONE. EXAMINE POINTERS
C
      IF(HDATA(NNP+3).NE.1) GO TO 110
      IPO = 1
      DO 10 K=1,3
      IPK = HDATA(NNP+K+3)
      IF(IPK.LT.IPO) GO TO 110
      IF(MOD(IPK,2).NE.1) GO TO 110
      IPO = IPK
10    CONTINUE
      IF((IPO-1)/2+3.NE.LNG) GO TO 110
C
C---- FORMAT IS ALREADY CHANGED.
C     DATA IS SIMPLY COPIED  AFTER THE LENGTH CHECK.
      LNGC = 4*LNG
      IF(LNGC.GT.11532) LNGC=11532
      CALL MVCL(HNORD,0,HDATA,4*NP,LNGC)
      IF(2883-LNG) 120,20,20
C
C---- CALIBRATION CHECK
20    IF(HNORML.EQ.0) GO TO 30
      WRITE(6,600) HNORML
600   FORMAT(' (LGCALB) LG-DATA IS ALREADY CALIBRATED.HNORML=',I6)
      GO TO 50
C
30    NHIT = LNG-3
      IF(NHIT.LE.0) GO TO 95
C
C---- SET THE NORMALIZATION FLAG
C     CF.  HNORM=1, FOR ONE-DIMENSIONAL M.C DATA
C     CF.  HNORM=2, FOR THREE-DIMENSIONAL M.C DATA
      NNORML = 3
C
C---- ERASE ALWAYS FIRED COUNTERS
50    HRUN = 0
C     IPNPHD = IBLN( 'HEAD' )
      NNPHD = IDATA(IPNPHD)
      NNPHD=NNPHD+NNPHD
      IF(NNPHD) 60,60,70
60    WRITE(6,610) NNPHD
610   FORMAT('0 ***** (LGCALB) ''HEAD'' IS MISSING, HNPHD=',I6,'  LGERSE
     $ IS NOT CALLED')
      GO TO 80
C
70    HEXP = HDATA(NNPHD+9)
      HRUN = HDATA(NNPHD+10)
      CALL LGERSE( HEXP,HRUN,&80 )
80    NP=NCAL(2)
      NPH=NP+NP+1
      J=0
C     INITIAL SET OF THE DETECTOR PART COUNTER KPOS
      KPOS=1
      DO 90 N=1,NHIT
      MEV=HLGADC(2,N)
      IF(MEV.LT.1) GO TO 90
      HCHN=HLGADC(1,N)
C..................INTERCHANGED CABLES.
      HCHO=HCHN
      IF(HCHN.EQ.293) HCHO=613
      IF(HCHN.EQ.613) HCHO=293
C...........AN AMP CABLE HAD BEEN INTERCHANGED OCT-NOV '80 RUNS
      IF(HRUN.LT.4992) GO TO 81
      IF(HRUN.GT.5667) GO TO 81
      IF(HCHN.GE.2664.AND.HCHN.LE.2687) HCHO=HCHN-24
      IF(HCHN.GE.2640.AND.HCHN.LE.2663) HCHO=HCHN+24
81    HCHN=HCHO
C..........................
      NP=NPH+HCHN+HCHN
      IPED=HCAL(NP)+8
      IPED=ISHFTR(IPED,4)
      MEV=MEV*HCAL(NP+1)+512
      MEV=ISHFTR(MEV,10)-IPED
      IF(MEV.LT.1) GO TO 90
      J=J+1
      IF(MEV.GT.32000) MEV=32000
C        IN CASE IT OVERFLOWS......
      HLGADC(2,J)=MEV
      HLGADC(1,J)=HCHN
C---  SET NEW POINTERS
82    IF(HCHN-HCHLST(KPOS)) 90,84,84
84    HPOINT(KPOS)=J+J-1
      KPOS=KPOS+1
      GO TO 82
90    CONTINUE
C        SET POINTERS CORRECTLY.
      DO 92 KK=KPOS,4
92    HPOINT(KK)=J+J+1
C
      LNG=J+3
      LNGC=LNG*4
      HNORML = HNORML + 10000
C
C---- CREATE THE NORMALIZED LG-ADC BANK.
95    LNG = LNGC/4
      CALL BDLS('ALGN',1)
      CALL BCRE(NPALGN,'ALGN',1,LNG,&140,IER)
      CALL BSAW( 1, 'ALGN')
      CALL BSTR( NPALGN, HNORD, LNG )
100   RETURN
C
C
C---- WRONG POINTERS
110   WRITE(6,620)
620   FORMAT(' *** WRONG DATA AFTER REFORMATTING ***')
C     CALL HPRS( 'HEAD',0)
C     CALL HPRS( 'ALGL',0)
      RETURN 1
C
C
C---- TOO LONG DATA
120   WRITE(6,630) LNG, LNGC,HEXP,HRUN,HDATA(NNPHD+11)
630   FORMAT(2X,20(1H*),'DATA IS TOO LONG******LNG,LNGC=',2I6,
     1 5X,'EXP#,RUN#,EV#=',3I8)
      DO 130 K=2,4
        IF( HPOINT(K).GT.5761 ) HPOINT(K) = 5761
130     CONTINUE
      RETURN 1
C
C---- ERROR IN CREATING 'ALGN'
140   WRITE(6,640) IER
640   FORMAT(' NOT ENOUGH SPACE IN /BCS/ TO PUT ALGN. IER=',5I5)
      RETURN 1
      END

C   17/01/79 409061133  MEMBER NAME  CMASS2   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE CMASS(NCN,PMOM,T,TM,TP,PAT,BETA,DBETA,BETAM,BETAP,
     -                  PRO,PKA,PPI,PEL)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      DIMENSION XM2(4),PROB(4)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (XM2(1),PMAS2),(XM2(2),XKMAS2),(XM2(3),PIMAS2),
     1 (XM2(4),EMS2)
      DATA PMAS2,XKMAS2,PIMAS2,EMS2/ .8803684, .2437081,
     -                               .01947892, 2.61124E-7/
      DATA CVEL/  2.997925E2 / ,DTOF/.5/
      DATA IFAULT/0/
C
      IF(PAT.LT.920.)  GOTO  999
      IF(TM.LE.1.)  GOTO  12
      BETAM= PAT/TM/CVEL
   12 IF(TP.LE.1.)  GOTO  14
      BETAP= PAT/TP/CVEL
C
   14 IF(T.LE.0.)  GOTO  999
      IF(PAT.LT.920.)  GOTO  999
      BETA= PAT/T/CVEL
      BET2= BETA*BETA
      PMOM2 = PMOM*PMOM
      DELP = .033*PMOM2
      EMAS2= PMOM2*(1./BET2-1.)
      EMASS= SQRT(ABS(EMAS2))
      DMAS2= 2.*PMOM2*CVEL*CVEL*T/PAT/PAT*DTOF
      IF(EMASS.GT..00001)  GOTO  20
      DERT = SQRT(DMAS2)
      GOTO  21
   20 DERT = DMAS2/2./EMASS
   21 DERP = (1./BET2-1.)*DELP*DELP
      DMAS = SQRT(DERT**2+ABS(DERP))
      DO   1   M=1,4
      ENRG2 = PMOM2+XM2(M)
      ENRG = SQRT(ENRG2)
      BETAM = ABS(PMOM)/ENRG
      DBP = XM2(M)/ENRG**3.*DELP
      SIGM2 = DBP*DBP + DBETA*DBETA
      PROB(M) = (BETA-BETAM)**2/SIGM2/2.
    1 CONTINUE
      PRO = PROB(1)
      PKA = PROB(2)
      PPI = PROB(3)
      PEL = PROB(4)
       RETURN
  999 BETA = 20.
      EMAS2 = -4.
      IFAULT = IFAULT + 1
      IF(IFAULT.LE. 0) PRINT 102,NCN,T,PAT,PMOM
  102 FORMAT(/' FAULT IN CMASS ',I5,2F10.3)
      RETURN
       END

C   16/03/88 803161221  MEMBER NAME  TAGPS2   (S)           FORTRAN
C
C
C        THIS IS A VERSION  WITH ALL THE DEBUG REMOVED  TO MAKE
C
C        IT EASIER TO READ !
C
C
C
C
C------  T A G P S 2  ------  T A G P S 2  ------  T A G P S 2  ------
C
C------  T A G P S 2  ------  T A G P S 2  ------  T A G P S 2  ------
C
C------  T A G P S 2  ------  T A G P S 2  ------  T A G P S 2  ------
C
C
         SUBROUTINE TAGPS2(SUM,IWRITE)
C
C TAGPS2 - DOES THE WORK OF TAGPOS FOR 1983 TAGGER
C
C INPUT  :   SUM     -  SUM OF ENERGY IN CLUSTER
C            IWRITE  -  = 1  TURNS ON DEBUG INFO
C
C  MODIFIED : 12/4/85 - A.J.FINCH
C                       MAJOR CHANGES TO R AND FI DETERMINATION CODE.
C                       NOW MUCH SIMPLER - ALSO RESULTS ARE BETTER:
C                       PRODUCES CORRECT DISTRIBUTION IN R AND PHI
C                        FOR BHABHAS
C
C MODIFIED : 16/10/85 - A.J.FINCH
C                       ENERGY CORRECTED FOR POSITION AT SMALL ANGLES
C                       - BASED ON OBSERVED VARIATION IN DATA, AND MC
C
C MODIFIED : 11/9/87  - A.J.FINCH
C                       IMPROVED ENERGY / POSITION CORRECTIONS
C
C MODIFIED : 11/3/88  - A.J.FINCH
C                       IMPROVED ENERGY / POSITION CORRECTIONS
C                        ( DUE TO CHANGES IN JOHN NYE'S CALIBRATION )
C
C
#include "cwktag.for"
C
#include "cdata.for"

C
C
C
       LOGICAL FIRST
       INTEGER ONE
       INTEGER OUTER
       INTEGER ADC
       INTEGER   RTYPE(9)
       INTEGER   FITYPE(9)
       INTEGER  INRIN
C
C
       REAL THMIN(9),THMAX(9),MSLOPE(9),CSLOPE(9)
C
       DIMENSION FUDGE(3)
C
C CONSTANTS USED IN ENERGY/THETA CORRECTIONS
C
       DATA THMIN /0.0,0.031,0.034,0.037,0.0435,0.0485,0.0555,0.066,
     1            0.071/
       DATA THMAX /0.031,0.034,0.037,0.0435,0.0485,0.0555,0.066,0.071,
     1            10.0/
       DATA MSLOPE /0.0,3.854,1.445,16.23,-23.121,9.083,2.753,9.827,0.0/
       DATA CSLOPE /0.82,0.805,0.887,0.340,2.052,0.490,0.841,0.291,0.7/
C-----------------------------------------------------------------------
C
       DATA PIBY2  / 1.570796327 /
       DATA PIBY4  / 0.785398163 /
       DATA PIBY8  / 0.392699081 /
       DATA FUDGE  / 0.68 , 0.80 , 0.95 /
C
C
       DATA R1  /  96.0 / , R2  / 110.0 / , R3  / 140.0 / , R4 / 225.0 /
       DATA R12 / 102.0 / , R23 / 125.0 / , R34 / 210.0 /
C
       DATA RSLOP1 / 0.05 / , RSLP31 / 0.10 / , RCUT1 / 0.10 /
       DATA RSLP32 / 0.06 /
C
       DATA FSLOP1 / 0.11  / , FSLOP2 / 0.04  / , FCUT1 / 0.13 /
       DATA ZTAG / 3160.0 /, RM / 0.024 /
C
       DATA INRIN/27529/
       DATA FIRST/ .TRUE. /
C
C
C ONE IS THE ADC SOFTWARE ADDRESS OF THE HIT BLOCK (TOP OF SORTED
C CLUSTER MAP)
C
C
       ONE    = CLUS(1,1)
       ILOOP  = 1
C
C
C
    1  ONESUM = 0.0
       TWOSUM = 0.0
       THRSUM = 0.0
       TEST2  = SUM * 0.00001
       ILOOP  = ILOOP + 1
       OUTER = 0
C
       IF ( .NOT. FIRST ) GOTO 782
          FIRST = .FALSE.
        RSHIFT = (LOG(RCUT1*2))/(-1.0*RSLP31)
        FSHIFT = (LOG(FCUT1*2))/(-1.0*FSLOP1)
 782   CONTINUE
C
C FIRST FIND THE NUMBER OF BLOCKS,WITH LARGE AMOUNTS
C OF ENERGY IN THEM,AND FOR THESE ,SET UP THE LIST R - TYPE
C AND FI - TYPE
C
C R-TYPE = 1 FOR INNER BLOCKS
C          2     MIDDLE
C          3     OUTER
C
C FI-TYPE = 1 FOR BLOCKS IN THE - FI DIRECTION FROM THE BLOCK
C            WITH THE LARGEST AMOUNT OF ENERGY( = 'ONE')
C         = 2 FOR BLOCKS WITH THE SAME FI AS  ONE
C         = 3 FOR BLOCKS IN THE + FI DIRECTION.
C
C --------------------------------------------------------
C
C <<<<<<<< HERE STARTS THE LOOP>>>>>>>>>>>
C
C
       DO 10 I = 1,9
C
C HAS THIS BLOCK GOT A DECENT AMOUNT OF ENERGY ?
C
          IF ( CLUS(I,2) .LT. TEST2 ) GOTO 11
C
             NBIG      = I
C
C ADC IS ADC'S SOFTWARE ADDRESS
C
             ADC       = CLUS(I,1)
C
C SET UP RTYPE AND FITYPE LISTS
C
             RTYPE(I)  = TAGRTY(ADC)
             FITYPE(I) = TAGFTY(ADC,ONE)
C
C ------------------------------------------------------------
C NOW IT IS NECCESSARY TO CORRECT THE ENERGIES IN THE CLUSTER
C SO THAT THEY REPRESENT THE ACTUAL ENERGY DEPOSITED,RATHER
C THAN THE ENERGY SUCH THAT ALL CLUSTERS (SUMMED OVER MANY
C BLOCKS ) HAVE THE CORRECT ENERGY.THESE ARE DIFFERENT
C FOR INNER AND MIDDLE BLOCKS DUE TO EDGE EFFECTS,I.E.
C ALL SHOWERS IN THESE BLOCKS LOSE SOME PORTION INTO
C INSIDE EDGE OF DETECTOR.
C
C--------------------------------------------------------------
C
             IF ( ILOOP .EQ. 1)CLUS(I,2) = CLUS(I,2) * FUDGE(RTYPE(I))
C
C -------------------------------------------------------------
C WHILE WE ARE AT IT CALCULATE SUM OF ENERGIES IN RESPECTIVELY
C ALL BLOCKS OF FITYPE 1,DITTO 2,AND 3,USED IN RATIO
C CALCULATIONS LATER
C
C  -------------------------------------------------------------
C
             IF ( FITYPE(I) .EQ. 1 ) ONESUM = ONESUM + CLUS(I,2 )
             IF ( FITYPE(I) .EQ. 2 ) TWOSUM = TWOSUM + CLUS(I,2 )
             IF ( FITYPE(I) .EQ. 3 ) THRSUM = THRSUM + CLUS(I,2 )
C
C ---------------------------------------------------------------
C
C ALSO FIND THE POINTER TO THE BLOCK IN CLUS THAT IS
C THE OUTERMOST ONE IN THE HIT CAKE SLICE (SEGMENT).
C USED TO CHOOSE WHICH RATIO TO CALCULATE
C
C ( THE OUTER BLOCK IS BIGGEST SO IS MOST IMPORTANT )
C
C ----------------------------------------------------------------
C
             IF ( (FITYPE(I).EQ.2) .AND. (RTYPE(I).EQ.3) ) OUTER  = I
   10  CONTINUE
C
C >>>>> HERE ENDETH THE LOOP OVER BLOCKS FOR INITIAL SETTING UP <<<<<
C
   11  CONTINUE

C --------------------------------------------------------------------
C
C
C NOW DO THE CALCULATION OF R ( DISTANCE OF SHOWER CENTRE FROM BEAM LINE
C ) - THE CALCULATION WORKS AS FOLLOWS:
C
C FIND THE RATIO BETWEEN THE ENERGY THAT THE SHOWER DEPOSITS IN
C ONE PART OF THE DETECTOR, AND THE TOTAL ENERGY DEP[OSITED.
C
C E.G. IF THE LARGEST AMOUNT OF ENERGY IS IN A MIDDLE BLOCK,
C   AND THE NEXT LARGEST AMOUNT OF ENERGY IS IN THE BLOCK OUTSIDE
C THIS BLOCK , THEN WORK OUT THE RATIO OF THE ENERGY IN THIS OUTER
C BLOCK TO THGE TOTAL ENERGY IN ALL THREE BLOCKS IN A CAKESLICE
C - THIS RATIO THEN GIVES YOU RCORR - THE DISTANCE FROM
C THE BOUNDARY BETWEEN THESE TWO, AND THE CENTRE OF THE SHOWER.
C RCORR IS OBTAINED BY ASSUMING
C
C   RATIO = 0.5 EXP (-RSLOPE.RCORR) ; RSLOPE HAS BEEN ADJUSTED
C                                TO OPTIMISE THE  PROCEDURE
C
C  FOR LARGE BLOCKS ONLY - IF RATIO < RCUT1
C                             SLOPE CHANGES TO RSLP32
C                           OTHERWISE SLOPE = RSLP31
C
C WHICH RATIO TO USE ?:
C
C ------------------------------------------------------------------
C BLOCK WITH MOST                      RATIO:
C       ENERGY:
C
C ------------------------------------------------------------------
C
C INNER RING BLOCKS (RTYPE = 1)      ENERGY IN  OUTER
C                                     RINGS  DIVIDED BY TOTAL
C
C MIDDLE RING BLOCKS (RTYPE = 2)      ENERGY IN OUTER
C                                     RING DIVIDED BY TOTAL
C
C OUTER RING BLOCKS (RTYPE = 3)      ENERGY IN MIDDLE AND INNER
C                                     RINGS COMBINED DIVIDED BY TOTAL
C
C --------------------------------------------------------------------

       IF ( RTYPE(1).EQ.3) RATIO = (TWOSUM - CLUS (1,2))/TWOSUM
       IF(OUTER.EQ.0)GOTO 23
       IF ( RTYPE(1).NE.3) RATIO = CLUS(OUTER,2)/TWOSUM
       IF ( RATIO .GE. 0.0005) GOTO 25
C
C IF RATIO IS VERY SMALL - MUST USE 'CENTRE' OF BLOCK AS R POSITION
C
  23      IF ( RTYPE(1).EQ. 1 ) R = R12
          IF ( RTYPE(1).EQ. 2 ) R = R23
          IF ( RTYPE(1).EQ. 3 ) R = R34
C
C   THEREFORE END OF R CALCULATION
C
          GOTO 41
C
   25  CONTINUE
C
C
C NOW CALCULATE RCORR FROM RATIO
C
C
C
C
      IF ( RATIO .LE. 0.0 ) GOTO 32
C
        IF(RTYPE(1).EQ.3) GOTO 320
C
          RCORR =  (LOG(2.0 * RATIO ))/( -1.0 * RSLOP1 )
          GOTO 32
C
320     IF(RATIO.LE.RCUT1) GOTO 321
C
          RCORR =  (LOG(2.0 * RATIO ))/( -1.0 * RSLP31 )
          GOTO 32
C
321     RCORR =  ((LOG(RATIO/RCUT1))/( -1.0 * RSLP32))  + RSHIFT
C
 32    CONTINUE
C
C  RCORR CALCULATION COMPLETE
C
C ADD RCORR TO THE RELEVANT VALUE OF R ,THAT IS THE BOUNDARY
C WHICH DIVIDED RATIO (  = ENERGY OUTSIDE BOUNDARY/TOTAL ENERGY)
C
C
       IF ( RTYPE(1) .NE. 3 ) R = R3 - RCORR
       IF ( RTYPE(1) .EQ. 3 ) R = R3 + RCORR
C
C
C LIMIT CORRECTION TO NOT TAKING CENTRE OF CLUSTER OUT OF COUNTER
C TO PROTECT AGAINST OVER ZEALOUS CORRECTION DUE TO POOR CALIBRATION
C DEAD CHANELS ETC.
C
C
       IF ( R .LT. R1 ) R = R1
        IF ( R .GT. R34 ) R = R34
C
C END OF R CALCULATION
C
41     CONTINUE
C
C----------------------------------------------------------------------
C
C - DEBUG SECTION
C
       IF ( IWRITE .EQ. 1 ) WRITE(6,664)RATLOS,ECLS1,RTYPE(1)
       IF ( IWRITE .EQ. 1 ) WRITE(6,665)CLUS(INNER,2),CLUS(MIDDLE,2),
     *     CLUS(OUTER,2),TWOSUM,RATIO,RCORR,R
 665   FORMAT(' ++TAGPS2: E1,E2,E3,ET,RAT,R,RC=',4(F8.2,2X),/,
     *        ' ++TAGPS2: RAT,RCORR,R         =',3(F10.4,2X))
 664   FORMAT(' ++TAGPS2: RATLOS,ECLS1,RTYP1  =',3(F8.2,2X))
C
C
C -------------------------------------------------------
C
C  HAVING DETERMINED R WORK OUT FI
C
C -------------------------------------------------------
C
C
C  THE SAME IDEA IS USED HERE AS FOR THE LARGE BLOCKS R CALCULATION
C  EXCEPT THE RATIO IS CALCULATED USING SUMS OF TWO CAKESLICES:
C THE ONE WHICH CONTAINS THE BLOCK WITH THE HICHEST ENERGY ,
C AND IT'S NEIGHBOURING CAKESLICE WITH THE MOST ENERGY
C
C
C
C
       FICORR = 0
C
C
C IF ONLY ONE  HIT BLOCK NO FI CORRECTION CALCULATED
C
C
       IF ( NBIG .EQ. 1 ) GOTO 43
C
C
C     FISIGN = 0 = > NO ENERGY IN NEIGHBOURING BLOCKS
C     FISIGN = -1/+1 = > MOST ENERGY IN NEIGHBOURS IN -FI/+FI DIRECTION
C
C
       FISIGN = 0
C
C
C
       RATIO  = ONESUM / SUM
       FISIGN = - 1
   34  IF ( ONESUM .GT. THRSUM) GOTO 36
          RATIO  = THRSUM / SUM
          FISIGN = + 1
   36  CONTINUE
       IF ( RATIO .EQ. 0 ) FISIGN = 0
C
C
C IF FISIGN IS STILL 0 ONESUM AND THRSUM ARE 0 SO NO RATIO
C CALCULATED (FICOR = 0)
C
C
      IF ( FISIGN .EQ. 0 ) GOTO 43
C
C
C RCORR IS DISTANCE IN  MM FROM SHOWER TO BOUNDARY BETWEEN
C HIT OCTANT AND NEIGHBOURING OCTANT,DETERMINED FROM SHARING
C IF RATIO IS LARGE,MOST OF SHOWER IS IN HIT OCTANT,SO RCORR IS
C LARGE,RCORR IS DISTANCE OF CENTRE OF SHOWER FROM BOUNDARY
C
C
      FICORR = 0.0
      IF ( RATIO .LT. 0.0001 ) GOTO 37
C
        IF(RATIO.LE.FCUT1) GOTO 421
C
          RCORR =  (LOG(2.0 * RATIO ))/( -1.0 * FSLOP1 )
          GOTO 42
C
421     RCORR =  ((LOG(RATIO/FCUT1))/( -1.0 * FSLOP2))  + FSHIFT
C
 42    CONTINUE
C
C  RCORR CALCULATION COMPLETE
         IF((RCORR/R).GT.1.0)RCORR = R
         FICORR = FISIGN*(PIBY8-ASIN(RCORR/R))
         IF(ABS(FICORR).GT.PIBY8)FICORR = FISIGN*PIBY8
C

C
  37  CONTINUE
C
C
C     CORRECT R FOR FI POSITION
C
C
      R = R / ( COS( FICORR ) )
      IF(R.GT.R4) R = R4
C
C
C ACTUAL VALUE OF FI (TFI) IS FI OF 'HIT' BLOCK ('ONE') + FI CORRECTION
C
C
  43   TFI = TAGPHI(ONE) + FICORR
C
C
C CAND(2) = X = R COS(FI)   CAND(3) = Y = R SIN(FI)
C
C
      CAND(2) = R * (COS(TFI) )
      CAND(3) = R * (SIN(TFI) )
C
C
C CAND(1) = ENERGY OF CLUSTER
C
C
       CAND(1) = SUM
C
C
C  ADJUST ENERGY FOR EMPIRICALLY OBSERVED DEPENDENCE ON POSTITION
C        AT CERTAIN ANGLES - VERSION OF 5/5/87
C                            + UPDATES 11/3/88 FOR NEW CALIBRATION
C
C *** NOT DONE FOR MC DATA - AS MC DOES NOT SIMULATE THIS !!***
        IF(IMC.EQ.1) GOTO 200
C
C - FIRST CONVERT R TO RAD
C
        THETA  = ( R / ZTAG  )
C
C CALCULATE RATIO
C
C RATIO .NE. 1.0 => OVERALL SCALING
C TAKES MODAL VALUE OF BHABHA PEAK TO CORRECT E BEAM
C FOR 17.5 GEV EBEAM
C
        RATIO = 1.0286
        ISTART = 1
        IRUN = 0
C
C CHANGE 1 -> 4 AS FIRST INDEX,IF RUN NO.>
C                     WHEN INNER RING INSTALLED
C                     OR < 24600
C                                       CHANGE MADE-9/3/88
C
      IND = IDATA(IBLN('HEAD'))
      IF (IND.GT.0) IRUN = HDATA(2*IND+10)
      IF(IRUN.LT.24600)ISTART = 4
      IF(IRUN.GT.INRIN)ISTART = 4
      DO 145 I = ISTART,9
      IF(THETA.LE.THMIN(I).OR.THETA.GT.THMAX(I))GOTO 145
            RATIO = RATIO*( MSLOPE(I)*THETA + CSLOPE(I))
            GOTO 146
145   CONTINUE
146   CONTINUE
C
C NOW PHI DEPENDANCE ( SEEMS FAIRLY INDEPENDENT OF THETA, AND
C  RUN PERIOD )
C
C
       FIPRIM = AMOD(TFI+PIBY2,PIBY4)
       IF(FIPRIM.GT.PIBY8)FIPRIM = PIBY4 - FIPRIM
C
       IF(FIPRIM.LT.0.01786) GOTO 1786
       IF(FIPRIM.LT.0.03573.AND.FIPRIM.GE.0.01786)GOTO 3573
       IF(FIPRIM.LT.0.05359.AND.FIPRIM.GE.0.03573)GOTO 5359
       IF(FIPRIM.GT.0.37514)GOTO 37514
C
C LARGE FI - GEOMETRIC OPTICS ? OR ABSORBTION IN SCINTILLATOR?
C
         RATIO = RATIO * (-0.135*FIPRIM+ 1.022)
         GOTO 6252
C
C SMALL FI - BBQ EFFECT ?
C
1786    RATIO = RATIO *   0.881
        GOTO 6252
3573    RATIO = RATIO *   0.850
        GOTO 6252
5359    RATIO = RATIO *   0.994
        GOTO 6252
C
C EXACT MIDDLE OF BLOCKS ??? NON-UNDERSTOOD EFFECT!
C
37514   RATIO = RATIO *   0.92
C
6252   CONTINUE
C
C AND ADJUST ENERGY
C
        CAND(1) = CAND(1) / RATIO
C
C AND FINALLY - ERROR ON ENERGY = SIGEN ASSUME 10 PER CENT AT
C                              17 GEV
C
C
 200      SIGEN = 0.40 * SQRT(CAND(1) )
C
       IF ( IWRITE .EQ. 1 ) WRITE(6,666)R,TFI,CAND(1),SIGEN
 666   FORMAT(' ++TAGPS2: R,FI,E,SIGEN = ',4(F10.2,2X) )
C
C
C
C
 1000  RETURN
       END

C   25/11/83 801202118  MEMBER NAME  MCJADE   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCJADE( NREVS, IPRINT )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    11/05/79 :  MC TRACKING PROGRAM
C
C      MOD  E. ELSEN    10/06/82 :
C      MOD  J. OLSSON   30/08/83 :  SUBSET TRACKED & EVENT COUNTING
C      MOD  W. BARTEL   25/10/83 :  PARTICLES BEYOND COIL NOT TRACKED
C      MOD  C. BOWDERY  17/11/83 :  CALL TO MCVSUM FOR ERROR SUMMARY
C      MOD  C. BOWDERY  24/11/83 :  DELETE CALL TO TRCOIL FOR PHOTONS
C      MOD  W. BARTEL   29/11/83 :  IEVMIN/MAX (/CIEVS/) DEFLT. IN BLDAT
C      MOD  W. BARTEL   29/11/83 :  INTRODUCE N AND K0L TRACKING
C      MOD  W. BARTEL   29/11/83 :  EXTERNAL JADEBD  INSTEAD OF BLDAT
C      MOD  J. HAGEMANN 28/08/84 :  VERTEX CHAMBER TRACKING FACILITY
C           R. RAMCKE               IMPLEMENTED
C      MOD  J. HAGEMANN 19/04/86 :  FWDDET REPLACED BY MCTAGM
C      MOD  J.OLSSON    09/06/86 :  LFLAG(2) IS TRUE IF LFLAG(4) IS TRUE
C      MOD  J.OLSSON    11/06/86 :  NSEC T.O. LIMIT DEPENDS ON LFLAG(4)
C LAST MOD  J.O, A.WEG. 20/01/88 :  JBWTOR INSTALLED FOR OPERATOR STOP
C
C LAST MOD
C   P. Movilla Fernandez Aug./98 :  Adapted for use on new platforms
C                                   Get rid of old IBM stuff
C                                   Reorganize I/O handling
C                                   Introduce call to user routine MCUSER in WRTMCB
C
C
C    ALLOWS SECTIONS OF THE INPUT FILE TO BE TRACKED.
C    MINIMUM AND MAXIMUM NR OF EVENT SET IN SUBR. JGETEV
C    EVENT COUNT PASSED VIA /CIEVS/ KIEV,IEVMIN,IEVMAX
C
C    WRITE NREVS MTC EVENTS ON UNIT 2. TAKE INPUT FOUR VECTORS
C    FROM ROUTINE JGETVC.
C    IF NREVS .EQ. 0, EVENTS ARE WRITTEN UNTIL EOF OR TIME OUT.
C    INPUT FOUR VECTORS FOR THE FIRST IPRINT ARE PRINTED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C                                      JADE BLOCK DATA IS NOW JADEBD
      EXTERNAL JADEBD
C
      COMMON / CJTCDC / IBANK, IPART
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
      COMMON / CGEO1  / BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *                  RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *                  R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *                  R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *                  RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *                  ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *                  ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *                  ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *                  XRJETC,
     *                  RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *                  BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *                  XHOL1,XHOL2,YHOL1,YHOL2
C
      DIMENSION PV(10),R0(5),RR(5)
      DIMENSION PVSAVE(10),R0SAVE(3)
C
      DATA NSEC / 4 /
      DATA NUNIT / 2 /
C
      LOGICAL*1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                 BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
C------------------  C O D E  ------------------------------------------
C
C                                           PRINT NEWS
***      CALL MCNEWS
C
C     ***** JBWTOR ENABLE OPERATOR TO CANCEL IN ORDERED FASHION *****
C             INITIALIZE
C
***      CALL JBWTOR(*2727)
***      GO TO 2728
C
***2727  WRITE(6,2729)
***2729  FORMAT(/,'========== JBWTOR INIT ERROR =======')
2728  CONTINUE
C
C
C   LFLAG(2) MUST BE TRUE IF MEIER/MAGNUSSEN LG TRACKING IS USED
C
      IF(LFLAG(4).AND..NOT.LFLAG(2)) WRITE(6,681)
681   FORMAT(' ### WARNING ###  LFLAG(2) SET TRUE, SINCE LFLAG(4) TRUE')
      IF(LFLAG(4).AND..NOT.LFLAG(2)) LFLAG(2) = .TRUE.
C IF 3-D EGS CODE IS USED, LARGER TIME OUT LIMIT IS NEEDED
      IF(LFLAG(4)) NSEC = 6
C
C  LFLAG(5) MUST BE TRUE IF VERTEX CHAMBER GEOMETRY IS USED
C
      IF(LFLAG(5).AND.(HDATE(6).GT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).GE.5))) GO TO 692
      IF(.NOT.LFLAG(5).AND.(HDATE(6).LT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).LT.5))) GO TO 692
      IF(HDATE(6).GT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).GE.5)) LFLAG(5) = .TRUE.
      IF(HDATE(6).LT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).LT.5)) LFLAG(5) = .FALSE.
      WRITE(6,691)
691   FORMAT('  #####  WARNING ####  LFLAG(5) HAS BEEN SWITCHED TO AGREE
     $ WITH COMMON /TODAY/ SETTING OF DETECTOR HARDWARE')
692   CONTINUE
C                                           INPUT OF MUCHAMBER CALIBRATI
***      CALL MUCONM
C
C                                           INITIALIZE PROGRAM
 2200 NEVTS = NREVS
      IF( NEVTS .EQ. 0 ) NEVTS = 999999
C
      IWRT = 0
      CALL BWRO( NUNIT, 1558, 2 )
      CALL JINIT
C
      IF(LFLAG(4)) WRITE(6,111)
  111 FORMAT(///,X,'***********************************************',/,
     *           X,'* LEAD GLASS SIMULATION IS DONE USING         *',/,
     *           X,'*        F11MEI.MCSHOWS(TRLG3)                *',/,
     *           X,'*                                             *',/,
     *           X,'* CONTAINING :                                *',/,
     *           X,'*                                             *',/,
     *           X,'*     - EM. SHOWERS FROM INTEGRATION OVER     *',/,
     *           X,'*       3 DIM SHOWER FUNCTION FOR PARTICLES   *',/,
     *           X,'*       ABOVE 100 MEV                         *',/,
     *           X,'*     - STANDARD EM-SHOWER PROCEDURE FOR      *',/,
     *           X,'*       FOR LOW ENERGY PARTICLES              *',/,
     *           X,'*     - HADRON INTERACTION USING THE KANZAKI  *',/,
     *           X,'*       SCHEME BASED ON THE KEK MEASURMENTS   *',/,
     *           X,'*       LIGHT GUIDES ARE INCLUDED FOR BARREL  *',/,
     *           X,'*                                             *',/,
     *           X,'*                           VERSION 20/09/83  *',/,
     *           X,'***********************************************',//)
C
      IF(LFLAG(5)) WRITE(6,112)
  112 FORMAT(///,4X,'***********************************************',/,
     *           4X,'* -> V E R T E X  C H A M B E R  TRACKING <-  *',/,
     *           4X,'*               SWITCHED  O N                 *',/,
     *           4X,'*                           VERSION 28/08/84  *',/,
     *           4X,'***********************************************',/)
C
      DO 1001 IEV=1,NEVTS
C
C TEST FOR OPERATOR STOP
C
***      CALL JBWTOR(*92)
C
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1011
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1011
      GO TO 90
C                                           INITIALISE EVENT
1011  CALL EVTINI
      IJETCP = 0
      IFWHIT = 0
      IPRI = 1
      IF( IWRT .GT. IPRINT-1 ) IPRI= 0
C                                           GET EVENT
      CALL JGETEV( *91, *1001 ) ! PMF 22/06/00: add branch on RETURN2
C
 1002 CONTINUE
C                                           NEXT PARTICLE
      CALL JGETVC( PV, R0, ICODE, IPRI )
      IF( ICODE .GT. 0 ) GO TO 1003
C
C                                           CHECK TIME FOR PARTICLES
C                                           NECESSARY IF MUONS INCLUDED
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1012
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1012
      KIEV = KIEV - 1
      GO TO 90
C
C     DON'T TRACK PARTICLES WHICH START ONLY BEYOND THE COIL OR
C     THE END CAP LEAD GLASS ARRAY
C                                   OCT. 25. 1983 W.BARTEL
C
1012  R4 = SQRT( R0(1)*R0(1) + R0(2)*R0(2) )
      IF( R4 .GT. RCOIL) GO TO 1000
      IF( ABS(R0(3)) .GT. ZENDPL) GO TO 1000
C
C                                           FWD TRACKING
CCC   CALL FWDDET( PV, R0, IFWHIT )
      CALL MCTAGM( PV, R0)
C                                           BRANCH ACCORDING
C                                           TO CHARGE OF PARTICLE
C                                           PHOTONS
      IF( PV(7) .EQ. 0. .AND. PV(8).LT.2.) GO TO 3
C                                           BRANCH OFF K0L AND N
      IF( PV(7) .EQ. 0. .AND. ABS(PV(8)-5.) . LT. 1.E-5) GO TO 4
      IF( PV(7) .EQ. 0. .AND. ABS(PV(8)-6.) . LT. 1.E-5) GO TO 4
C
C***********************************************************************
C                                           CHECK IF VERTEX CHAMBER
C                                           TRACKING IS WANTED
      IF( .NOT. LFLAG(5) )  CALL TRCDET(PV,R0,RR,*1004)
      IF(  LFLAG(5) )  CALL TRCDTV(PV,R0,RR,*1004)
C***********************************************************************
C
      IF( PV(6) .LT. .001 ) GO TO 1000
C
      CALL TRCOIL(PV,RR,*992 )
  992 R0(1) = RR(1)
      R0(2) = RR(2)
      R0(3) = RR(3)
      GO TO 996
C
C                                           TRACK PHOTONS
    3 CALL JTRKGM(PV,R0,*1000)
      GO TO 996
C                                           TRACK K0L , N
    4 CALL JTRNTR(PV,R0,*1000)
C                                           SAVE VECTORS
  996 R0SAVE(1) = R0(1)
      R0SAVE(2) = R0(2)
      R0SAVE(3) = R0(3)
      DO 995 ISA = 1,10
  995 PVSAVE(ISA) = PV(ISA)
C                                           LEAD GLASS
      CALL TRLGL(PV,R0,*997)
C
  997 CONTINUE
C
  998 IF( PV(6) .LT. .001 ) GO TO 1000
      CALL MURTNE(PVSAVE,R0SAVE)
      GO TO 1000
C
 1004 IF( IJETCP .GT. 0 ) GO TO 1000
      IJETCP = 1
      WRITE(6,151) IEV, IPART
  151 FORMAT(5X,' TOO MANY JET-CHAMBER HITS AT EVENT',I5,' TRACK',I4)
      GO TO 1000
C
C
 1000 CONTINUE
      GO TO 1002
C
 1003 CONTINUE
C
C***********************************************************************
C                                           SORT VERTEX CHAMBER HITS
      IF( LFLAG(5) ) CALL JSTORE
C***********************************************************************
      CALL JSPOIN
      CALL ORDLG
      CALL MUORDR
      CALL TOFMAK
      CALL WRTMCB( NUNIT )
      IWRT = IWRT + 1
C
 1001 CONTINUE
C                                           NO MORE EVENTS REQUESTED
C
      WRITE(6,9105)
 9105 FORMAT(/' --  END OF REQUESTED DATA  --')
      GO TO 91
C
C
C                                          OPERATOR STOP
C
***   92 CONTINUE
***      WRITE(6,9102)
*** 9102 FORMAT(/'======== OPERATOR STOP=========')
***      GO TO 91
C
C
C                                           TIME OUT
C
   90 CONTINUE
      WRITE(6,9101)
 9101 FORMAT(/' ========= TIME OUT =========')
C
C                                           END OF DATA
   91 CONTINUE
      CALL BMLT( 0, DUMMY )
      CALL BWRITE( NUNIT )
C
C                                           PRINT INPUT ERROR SUMMARY
C
      CALL MCVSUM
C
      ILAST = IEVMIN + KIEV - 1
      WRITE(6,109) NEVTS, IEVMIN,ILAST,KIEV, IWRT
  109 FORMAT(//1X,I6,' EVENT(S) REQUESTED TO BE TRACKED.'/
     +  1X,I6,' IS RECORD NO. OF FIRST REQUESTED EVT FROM INPUT FILE.'/
     +  1X,I6,' IS RECORD NO. OF LAST EVENT READ FROM INPUT FILE.'/
     +  1X,I6,' EVENT(S) READ FROM THE INPUT FILE.'/
     +  1X,I6,' EVENT(S) WRITTEN OUT.'//)
      RETURN
      END

C   24/07/79 C9082401   MEMBER NAME  ANOM01   (S)           FORTRAN
      SUBROUTINE ANOM01(IRUN)
C---  ANOMALIES OF RUNS 540 - 564
C---  13.6 GEV    JUNE 1979
C
C     H.WRIEDT    24.07.79     23:40
C     LAST MODIFICATION     24.08.79     11:25
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (540,541,10,543,544,545,10,547,10,549,10,10,552,553,10,10,
     &      10,10,10,559,560,561,10,563,564),IRUN
   10 RETURN
C
  540 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 330
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
  541 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 330
      KCONST(149) = -1
      LIMIT(149) = 285
      KCONST(156) = -1
      LIMIT(156) = 285
      KCONST(166) = -1
      LIMIT(166) = 345
      KCONST(167) = -1
      LIMIT(167) = 270
      KCONST(171) = -1
      LIMIT(171) = 315
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 285
C
      LTHRES(112) = .TRUE.
C
      RETURN
C
  543 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 330
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
  544 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 330
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  545 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 330
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(186) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  547 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
      LCHANN(186) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 200
      KCONST(140) = -1
      LIMIT(140) = 330
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  549 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
      LCHANN(186) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 330
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  552 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
  553 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
      LCHANN(186) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(170) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(186) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  559 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      LTHRES(52) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  560 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 330
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  561 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(149) = -1
      LIMIT(149) = 285
      KCONST(166) = -1
      LIMIT(166) = 345
      KCONST(167) = -1
      LIMIT(167) = 270
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 285
      KCONST(187) = -1
      LIMIT(187) = 285
C
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(112) = .TRUE.
C
      RETURN
C
  563 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  564 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
C
      RETURN
C
      END

C   07/06/96 606071844  MEMBER NAME  GOREC    (S4)          FORTRAN
C   16/03/79 C9031701   MEMBER NAME  GOREC    (SRC)         FORTRAN
      SUBROUTINE GOREC(*,*)
C   06/02/79            MEMBER NAME  GOREC    (S)           FORTRAN
C   23/01/79 C9020601   MEMBER NAME  GOREC    (SRC)         FORTRAN
C   12/12/78 C9011001   MEMBER NAME  GOREC    (SRC)         FORTRAN
C   05/12/78 C8120601   MEMBER NAME  GOREC    (SRC)         FORTRAN
C   24/10/77 C8111201   MEMBER NAME  GOREC    (PLULIBS)     FORTRAN
C
C
C     LIEST EVENTS VON SEQ. BZW. LSB (FT01 WEITERE FTNUMMERN
C     SIND MIT DER DATENKARTE
C     RUNI SECFT THIRDFT
C     WOBEI SECFT ETC DIE FTNUMMERN DER EINHEITEN SIND, DIE NACH
C     FT01 GELESEN WERDEN) UND DIRECTACCESSDATEIEN (FT30-39).
C     MISCHUNG VON DA UND SEQ EINGABE IST NICHT MOEGLICH.
C     ZUR BESCHEIBUNG DER EINGABE GIBT ES
C     SEQEX        VOREINSTELLUNG
C     SEQMC        FUER MONTE-CARLO-DATEN
C     DAEX NUNIT NA NB   NA UND NB SIND DIE GRENZEN ZWISCHEN DENEN
C     DAMC NUNIT NA NB   DER DIRECT-ACCESS-DATENSATZ GELESEN WIRD
C                        NUNIT=FORTRANEINHEIT, MEHRERE TRIPEL MOEGLICH
C     RFTN               ALS EINGABEKARTE SCHALTET AUF LESEN MIT
C                        FORTRAN UM (ANSTELLE VON ASSEMBLER)
C
C     ZUR STEUERUNG DER EINGABE GIBT ES DIE KARTEN
C     RECSKIP NREC  BENUTZE DIE ERSTEN NREC RECORDS NICHT
C     SKIP    NRUN1..NRUN2-NRUN3  BENUTZE DIESE RUNS NICHT
C     USE     NRUN1..NRUN2-NRUN3  BENUTZE NUR DIESE RUNS
C
C     DIE STEUERUNG KANN AUCH UEBER SUBROUTINE-CALLS ERFOLGEN
C     CALL SKRUN   UEBERSPRINGE RUN
C     CALL SKREST  UEBERSPRINGE REST DES DATENSATZES
C     CALL SPECEV(&1)  ERMOEGLICHT DIE AUSWAHL VON BESTIMMTEN
C                  EVENTS,DIE ROUTINE NIMMT DEN NORMALEN
C                  AUSGANG FUER ALLE EVENTS,DIE AUF
C     $RUN NRUN NEV1 NEV2  VERZEICHNET SIND, SONST RETURN 1.
C
C     ES IST MOEGLICH NUR RUNS BESTIMMTER ENERGIE ZUZULASSEN
C     DIE SELEKTION ERFOLGT AUTOMATISCH, WENN FOLGENDE KARTE DA IST
C     SELE EBEAM1-EBEAM2 EBEAM3-EBEAM4 ...(EBEAM IN GEV)
C     DIE SUBROUTINE MONCOU ADDIERT DIE KORRIGIERTEN MONITOR-COUNTS
C     AUF UND SPEICHERT DIE LUMINOSITAETEN IN 1/NB AUF DER BANK
C     (NANO,0). DAZU MUSS VOR DEM AUFRUF VON GOREC (ABER NACH BINT)
C     CALL MONCOU  GERUFEN WERDEN.NOETIG IST EINE STEUERKARTE
C     EBEAM   EBEAM1 EBEAM2 EBEAM3 ....
C     DANN WIRD IN DEN INTERVALLEN 0-EBEAM1 (1.INTERVALL) EBEAM1-
C     EBEAM2 (2.INTERVALL) .. DIE LUMINOSITAET AUFADDIERT.
C     CALL SELMON (I,ALUM)  LIEFERT DANN DIE NUMMER DES INTERVALLS FUER
C     DEN GERADE LAUFENDEN RUN, ALUM DIE LUMINOSITAET. DIE STEUERKARTE
C     PRMO  LIEFERT AUSFUEHRLICHE INFORMATIONEN UEBER DEN MONITOR
C     DER RUNBEREICH, IN DEM ADDIERT WIRD MUSS DURCH EINE ODER
C     MEHRERE STEUERKARTEN
C     RUNS NRUN1 NRUN2
C     SPEZIFIZIERT WERDEN
C
C     DIE STEUERKARTE *LISTE DIENT ZUM FESTLEGUNG DER BANKS, DIE
C     AUSGESCHRIEBEN BZW. ZERSTOERT WERDEN SOLLEN. SIE IST NUR
C     NOETIG, WENN WAEHREND DES JOBS VOM USER NEUE BANKS ERZEUGT
C     WERDEN.
C     FORMAT
C     *LISTE 5 7 '(7(1X,A4))
C      HEAD EV15 EV30 AREV EV31 COPH TEIS
C     BEDEUTUNG  DIE ERSTEN 5 NAMEN DER LISTE WERDEN AUSGESCHRIEBEN
C     ALLE 7 BANKS WERDEN NACH JEDEM EVENT VERNICHTET. BEI VERWENDUNG
C     DER *LISTE-KARTE MUESSEN UNBEDINGT ALLE VORKOMMENDEN BANKNAMEN
C     ALS ZU ZERSTOEREND ERKLAERT WERDEN.
C     ALS ALTERNATIVE GIBT ES DIE AUFRUFE
C     CALL BSAW(N,'NAM1NAM2....NAMN') FUER AUSZUSCHREIBENDE BANKS
C     CALL BSAT(N,'NAM1NAM2....NAMN') FUER NICHT ZU SCHREIBENDE BANKS
C
C     DIE AUSGABE VON EVENTS KANN AUF SEQUENTIELLE (FT08),
C     DIRECT-ACCESS (FT02) SOWIE LSB-DATEIEN (FT09) SOWIE AUF
C     DEN KARTENSTANZER (FT07) ERFOLGEN. STEUERKARTEN
C     SEQWRT
C     DAWRT NA NB
C     LSBWRT
C     ZUSAETZLICH GIBT ES FOLGENDE SUBROUTINE-CALLS
C     CALL SEQWRT   DIE ROUTINEN KOENNEN AUCH MEHRFACH
C     CALL SEQNOW   PRO EVENT GERUFEN WERDEN,AUSSCHLAG-
C     CALL DAWRT    GEBEND IST DER LETZTE AUFRUF.
C     CALL DANOW    VOREINSTELLUNG  SEQWRT DANOW
C     CALL LSBWRT   VOREINSTELLUNG  LSBNOW
C     CALL LSBNOW
C     CALL PUNEVT SCHREIBT RUNNUMMER UND EVENTNUMMER IM
C                 FORMAT, WELCHES VON 'SPECEV' ERWARTET WIRD
C                 BEGRENZUNG AUF LIM EVENTS ERFOLGT MIT
C     CALL PUNLIM(LIM) VOREINSTELLUNG 100
C     WENN KEINE WEITERE AUSGABE AUF FT02 ODER FT09 ERWARTET
C     KANN DER OUTPUT ABGESCHLOSSEN WERDEN MIT DEM AUFRUF
C     CALL LSBCLS(IUNIT)        IUNIT=2,9
C
C     DIE STEUERUNG DES AUSDRUCKS ERFOLGT MIT
C     CALL PRIEVT SCHREIBT EIN EVENT MIT ALLEN BANKS AUF FT06
C     CALL PRILIM(LIM) BEGRENZUNG AUF LIM (10) EVENTS
C     PRHD        BEWIRKT DEN AUSDRUCK JE EINER ZEILE FUER
C                 RUNBEGINN UND RUNENDE
C     PRSH        BEWIRKT VERKUERZTEN AUSDRUCK(10 RUNS / ZEILE)
C     LIMIT NREC NSEC NERR  BEWIRKT DEN ABBRUCH DES JOBS
C                 NACH NREC (ALLE) EVENTS  NSEC (2) SEKUNDEN VOR
C                 TIME OVERFLOW  NACH NERR (5) LESEFEHLERN
C
C     MIT DER DATENKARTE
C     NORB   WIRD VERHINDERT,DASS GOREC DEN
C     RUN AUF DER RUNBIBLIOTHEK SUCHT (TESTBETRIEB)
C
C     DIE EVENT-DATEN AB OKTOBER 1977 HABEN ALS KENNUNG DIE BANK
C     (HEAD,0)     LAENGE 10 PLATZ 1 RUNNUMMER PLATZ 2 EVENTNUMMER
C     NICHT-EVENTDATEN(BANKS TE01 CH03 MO04 ETC.) WERDEN WIE EIN
C     RECORD BEHANDELT, GOREC VERZWEIGT JEDOCH ZUR SUBROUTINE
C     SPECRC(INIR,NTOT) INIR  INDEX DES 1. WORTES, NTOT *4-WORDCOUNT
C     DIE VOM USER GESCHRIEBEN WERDEN MUSS, WENN DIESE BANKS
C     BEHANDELT WERDEN SOLLEN.
C
C     BENOETIGT WERDEN DIE BIBLIOTHEKEN
C     F14LUE.PLULIB  LKED.SYSLIB
C     PLUTOS.PDADAT  GO.FT14F001 FUER EXP. DATEN
C     F33BAC.RNBIBBA GO.FT15F001 FUER MONTE CARLO '76
C     F33MOC.RUNBIB  GO.FT15F001 FUER MONTE CARLO '78 - '80
C     PLUTOS.DABANK  GO.FT17F001 FUER EICHUNG SHOWER/MYON/HADRON ABS
C
      EXTERNAL PUNEVT,PRIEVT,SBYT,JFUL,LDBIT
C     BENUTZTE COMMON-BEREICHE
      COMMON/BCS/IW(1000)
      REAL RW(1000)
      INTEGER*2 IW2(2)
      EQUIVALENCE (IW(1),IW2(1))
      EQUIVALENCE(IW(1),RW(1))
C     ALLGEMEINER DATENSPEICHER
      INTEGER*2 IPAR
      COMMON/IPAR64/IPAR(64)
      INTEGER JPAR(32)
      EQUIVALENCE (IPAR(1),JPAR(1))
C     SPEICHERUNG VON DATEN AUS DER RUNBIBLIOTHEK
      COMMON/FLAGMC/MONTE
C     FLAGGE FUER MONTE CARLO
      COMMON/BLISTE/NLD,NLW
C     N1 UND N2 AUS *LISTE-STEUERKARTEN
      COMMON/STIMES/JSEC
C     COMMON AUS ZEITABBRUCHROUTINE JUHR
      COMMON/RUBIBL/ LMAX,IUNGRN,NR0,LRECL,NRPAR
C     COMMON FUER RUNBIB
C
      REAL CP/0./,HNULL/0./,EBEAM/0./
      LOGICAL DA/.FALSE./,END/.FALSE./,MONTE,HEADLG
      LOGICAL CURR/.FALSE./,SKIP/.FALSE./,PRHD/.FALSE./
      LOGICAL DAW/.FALSE./,SEQW/.FALSE./,SEQWC/.FALSE./
      LOGICAL DAWRTC/.FALSE./,EOF/.FALSE./,ERR/.FALSE./
      LOGICAL LRECSK/.FALSE./,PRSH/.FALSE./,DAWRTL/.FALSE./
      LOGICAL LSBW/.FALSE./,LSBWC/.FALSE./,NORB/.FALSE./
      LOGICAL EVE,NOFOR/.FALSE./,FIXFOR/.FALSE./
      INTEGER IKATA/0/,PROP/'PROP'/,INUNIT/1/
      INTEGER LIM(3)/0,3,5/,NRUN/0/,LRUN/0/,IWR/8/,IOLD/0/
      INTEGER IEV/0/,NEVT/0/,NERR/0/,JR/0/,HEAD/'HEAD'/,HIDD/'HIDD'/
      INTEGER RECSKI/0/,RECSKP/0/,SPEC/0/
      INTEGER TEXT(3,6)/'END ','OF D','S   ','EVEN','T LI','MIT ',
     1'TIME','LIMI','T   ','ERRO','R LI','MIT ',
     2'INSU','FF.S','PACE','USER',' CAL','L   '/
C
C     ENDE VEREINBARUNGSTEIL
C
C     INITIALISIERUNG
      IF (CURR) GOTO 30
C
C     BLOBELS NEW TIME-OVERFLOW ROUTINE
C     NOT USED
C     CALL AAAA
      MONTE=.FALSE.
      CALL BLOC (IND,'SEQM',0,&1)
      MONTE=.TRUE.
      GOTO 3
1     CALL BLOC (IND,'DAMC',0,&2)
      INUNIT=IW(IND+1)
      MONTE=.TRUE.
      DA=.TRUE.
      GOTO 3
2     CALL BLOC (IND,'DAEX',0,&3)
      INUNIT=IW(IND+1)
      DA=.TRUE.
3     IF (MONTE) WRITE (6,1002)
      IF (DA) WRITE (6,1004)
      CALL BLOC (IND,'LIMI',0,&5)
      NW=IW(IND)
      IF (NW.EQ.0) GOTO 5
      IF (NW.GE.4) NW=3
      DO 4 I=1,NW
4     LIM(I)=IW(IND+I)
5     CALL BLOC (IND,'PRHD',0,&6)
      PRHD=.TRUE.
      CALL BDLS ('PRHD',0)
6     CALL BLOC (IND,'SEQW',0,&7)
      SEQW=.TRUE.
7     CALL BLOC (IND,'DAWR',0,&8)
      DAW=.TRUE.
      CALL BWRO(2,1609,2)
8     CALL BPOS ('*LIS')
      CALL BNXT (IND,&9)
      NLD=IW(IND)
      NLW=IW(IND-2)
9     CONTINUE
      CALL BLOC(IND,'VREA',0,&9005)
      NOFOR=.TRUE.
9005  CONTINUE
      CALL BLOC(IND,'RECS',0,&10)
      RECSKI=IW(IND+1)
      RECSKP=RECSKI
      CALL BDLS ('RECS',0)
10    CONTINUE
      CALL BLOC(IND,'PRSH',0,&11)
      PRSH=.TRUE.
      CALL BDLS ('PRSH',0)
      PRHD=.FALSE.
11    CONTINUE
      CALL BLOC(IND,'DAWL',0,&12)
      DAWRTL=.TRUE.
      DAW=.TRUE.
12    CONTINUE
      CALL BLOC(IND,'LSBW',0,&13)
      LSBW=.TRUE.
      CALL BWRO(9,1609,2)
13    CONTINUE
      CALL BLOC(IND,'NORB',0,&14)
      NORB=.TRUE.
14    CONTINUE
      CALL BLOC(IND,'RFTF',0,&15)
      FIXFOR=.TRUE.
15    CONTINUE
      CURR=.TRUE.
C     CALL PRIPS
C
C     ENDE INITIALISIERUNG
C
30    IF (END) GOTO 102
      IF (LRUN.NE.0.AND.LRUN.NE.NRUN) GOTO 62
C
C     AUSSCHREIBEN EINES EVENTS (SEQUENTIELL)
C
      IF (.NOT.SEQW) GOTO 42
      IF (.NOT.SEQWC) GOTO 42
      CALL BSLW
      CALL BWRITE(8)
42    SEQWC=.TRUE.
C
C     AUSSCHREIBEN DIRECT-ACCESS
C
      IF (.NOT.DAW) GOTO 44
      IF (.NOT.DAWRTC) GOTO 44
      IF (DAWRTL) CALL BSLW
      IF (.NOT.DAWRTL) CALL BMLT(10,'HEADPROPGEOMVTYPEV00EV15EV30AREVMYC
     *OEV31')
      CALL CNTPOP(&44)
43    CALL BWRS(2,NTOT,INIR)
      IF (INIR.EQ.0) GOTO 44
      CALL PREPOP(NRECO,&435)
      CALL FWRTDB(2,NRECO,NTOT,IW(INIR))
      GOTO 43
435   DAW=.FALSE.
      GOTO 43
44    DAWRTC=.FALSE.
C
C     AUSSCHREIBEN LSB
C
      IF (.NOT.LSBW) GOTO 48
      IF (.NOT.LSBWC) GOTO 48
      CALL BSLW
      CALL BWRITE(9)
48    LSBWC=.FALSE.
C
C     LETZTES EVENT ENTFERNEN
C
      CALL BSLT
      CALL BDLM
      CALL BGAR(IGA)
C
C     VORGEGEBENE GRENZEN ERREICHT
C     USE OLD IUHR
50    IF(IUHR(LIM(2)).EQ.2) GOTO 93
C 50    IF (JSEC.LE.LIM(2)) GOTO 93
      LRECSK=.FALSE.
      IF (LIM(1).NE.0.AND.NEVT.GE.LIM(1)) GOTO 92
C
C     EINLESEN
C
      IF (RECSKI.EQ.0) GOTO 51
      RECSKI=RECSKI-1
      IF (RECSKI.EQ.0) WRITE (6,1018) RECSKP
      LRECSK=.TRUE.
51    CONTINUE
515   CALL BRDS(INUNIT,NTOT,INIR)
      IF (INIR.EQ.0) GOTO 56
      IF (DA) GOTO 54
      IF (NOFOR) GOTO 517
      CALL BFRD(INUNIT,IW(INIR),IW(INIR+1))
      IF (IW(INIR)) 91,72,515
517   CONTINUE
      CALL VBUFF(MIN0(32000,NTOT*4))
52    CALL VREAD(IW(INIR),IW(INIR+1),&91)
C     NTOT=(NTOT+3)/4
      IF (IW(INIR+1).EQ.HEAD.OR.IW(INIR+1).EQ.HIDD) GOTO 55
      NTOT=(NTOT+1)/2
      IF (NTOT.LT.20) SPEC=SPEC+1
      IF (NTOT.LT.20) GOTO 52
      IF (IW(INIR+9).NE.PROP) GOTO 53
      IW(INIR+5)=IW2(INIR*2+1)
      IW(INIR+1)=HEAD
      IW(INIR+2)=0
      IW(INIR+3)=0
      IW(INIR+4)=4
      IW(INIR+6)=IW2(INIR*2+3)
      IW(INIR+7)=0
      IW(INIR+8)=0
      IOLD=IOLD+1
      GOTO 55
53    IKATA=IKATA+1
      IF (IKATA.GT.20) GOTO 52
      WRITE (6,1024) INIR
      CALL UWP(IW,INIR,INIR+20)
      GOTO 52
54    CONTINUE
      CALL PREPIP(INUNIT,NRECI,&91)
      CALL FRDDA(INUNIT,NRECI,IW(INIR),IW(INIR+1),&91)
55    CONTINUE
      GOTO 515
56    CONTINUE
C
C     CHECK SPECIAL RECORD
C
      EVE=.TRUE.
      CALL LENHEA(&95)
      CALL BLOC(IHEAD,'HEAD',0,&72)
      IF (IW(IHEAD+4).EQ.0) GOTO 58
      EVE=.FALSE.
      SPEC=SPEC+1
C     CALL SPECCO(INIR,NTOT)
      CALL SPECRC(INIR,NTOT)
      IF (LRECSK) RECSKI=RECSKI+1
C     GOTO 30
58    CONTINUE
      IF (LRECSK) GOTO 48
C
C     EVENT INPUT
C
      NRUN=IW(IHEAD+1)
      IF (NRUN.EQ.LRUN.AND.SKIP) GOTO 48
      CALL BLOC(ILW,'*LIS',NLW,&59)
      CALL BSAT (NLD,IW(ILW+1))
      CALL BSAW(NLW,IW(ILW+1))
      CALL BSAW(1,'HEAD')
59    CONTINUE
      IF (NRUN.NE.LRUN) GOTO 60
      IF (EVE) IEV=IEV+1
      IF (EVE) NEVT=NEVT+1
C     CALL LENVTY(&95)
      IF (PRSH) CALL RUNC
      GOTO 101
C
C     RUNBIBLIOTHEK
C
60    IF (LRUN.EQ.0) GOTO 62
      IF (SKIP) GOTO 62
61    IF (PRHD) WRITE (6,1006) LRUN,IEV
      GOTO 102
62    LRUN=NRUN
      IF (NORB) GOTO 67
      CALL BSPC(IA,LB,IDM1,IDM2)
      IF (LB.LT.1610) GOTO 95
C
C     AUTOMATIC MC - RECOGNITION
C
      CALL BLOC(IHD,'HEAD',0,&635)
      HEADLG=.FALSE.
      IF (IW(IHD+14).NE.0) HEADLG=.TRUE.
      IF((MONTE.AND.HEADLG).OR.((.NOT.MONTE).AND.(.NOT.HEADLG)))GOTO 63500037200
      MONTE=HEADLG
C     WRITE (6,1030) MONTE
      CALL CAPITL('FROM NOW',8,6)
      CALL CAPITL('READING ',8,6)
      IF (MONTE) CALL CAPITL('M CARLO',8,6)
      IF (.NOT.MONTE) CALL CAPITL('REAL    ',8,6)
      CALL CAPITL('EVENTS  ',8,6)
      IF (MONTE) GOTO 635
      IUNGRN=14
      NR0=220
  635 CONTINUE
C
      IRETC=2
      IF (MONTE) GOTO 64
      CALL GETRUN(LRUN,IPAR,IW(IA),&70,&71)
      GOTO 66
64    CONTINUE
      CALL MCGRUN(LRUN,IPAR,IW(IA),&70,&71)
66    CONTINUE
C
C     NEUER RUN
C
67    CALL SELRUN(SKIP,NRUN)
      IF (SKIP) GOTO 44
      IEV=0
      IF (NORB) GOTO 69
      HNULL=IPAR(26)
      HNULL=0.001*HNULL
      CP=HNULL*3.0E-5
      EBEAM=FLOAT(JPAR(6))/1000.
      CALL SELEN(EBEAM/1000.,'SELE',NEB)
      IF (NEB.NE.1) GOTO 68
      SKIP=.TRUE.
      GOTO 44
68    CONTINUE
      CALL BDLS('RUN ',0)
      CALL BCRE (IRN,'RUN ',0,50,&95,IER)
      SCHLAN=0.
      IF(LRUN.LT.15000) SCHLAN=0.012
      IW(IRN+1)=LRUN
      RW(IRN+2)=HNULL
      RW(IRN+3)=CP
      RW(IRN+4)=EBEAM
      RW(IRN+16)=0.0
      RW(IRN+17)=2.0*EBEAM*SCHLAN/1000.
      RW(IRN+18)=0.0
      RW(IRN+19)=2.0*EBEAM/1000.
69    CONTINUE
      IF (EVE) IEV=IEV+1
      IF (EVE) NEVT=NEVT+1
      IF (PRHD) WRITE (6,1008) LRUN,HNULL,CP,EBEAM
      IF (PRSH) CALL RUNC
C     CALL LENVTY(&95)
      GOTO 100
C
C     SPECIAL CONDITIONS-  RUNLIB NOT OKAY
C
70    CONTINUE
      IRETC=1
71    CONTINUE
      WRITE (6,1010) LRUN,IRETC
      SKIP=.TRUE.
      GOTO 44
C
C     READ ERROR
C
72    NERR=NERR+1
      IF (NERR.GT.LIM(3)) GOTO 94
      GOTO 44
C
C     ABBRUCHKRITERIEN
C
98    JR=JR+1
97    JR=JR+1
96    JR=JR+1
95    JR=JR+1
94    JR=JR+1
93    JR=JR+1
92    JR=JR+1
91    JR=JR+1
      IF (JR.NE.1) GOTO 89
      CALL BLOC(IR,'RUNI',0,&89)
      JLEN=IW(IR)
      IF (JLEN.LE.0) GOTO 89
      DO 90 KK=1,JLEN
      IF (IW(IR+KK).LT.0) GOTO 90
      WRITE (6,1028) INUNIT,IW(IR+KK)
      CALL BSTA
      CALL BDLS('+BUF',INUN IT)
      CALL BDLS('$BUF',INUN IT)
      INUNIT=IW(IR+KK)
      IW(IR+KK)=-INUNIT
      JR=0
      CALL VPARM(INUNIT,32767,1,1,10)
      GOTO 30
90    CONTINUE
89    CONTINUE
      END=.TRUE.
      GOTO 61
C
C
      ENTRY GOBEG(*)
C
      IF (.NOT.END) GOTO 101
      IF (JR.NE.1) END=.FALSE.
      WRITE(6,1014) NEVT,NERR,(TEXT(I,JR),I=1,3)
      IF (IOLD.GT.0) WRITE (6,1020) IOLD
      IF (IKATA.GT.0) WRITE (6,1026) IKATA
C     CALL BLOC(IJOBC,'JOBC',0,&20005)
C     IF (JR.EQ.1) CALL JOBCFI(-NEVT)
C     IF (JR.NE.1) CALL JOBCFI(NEVT)
C0005 CONTINUE
      CALL PUNFIN
      IF (SPEC.GT.0) WRITE (6,1022) SPEC
      IF (PRSH) CALL RUNE
      IUCLS=0
      GOTO 200
      ENTRY LSBCLS(I29)
      IUCLS=I29
200   CALL BMLT(0,BLA)
      IF (.NOT.LSBW) GOTO 210
      IF (IUCLS.EQ.0.OR.IUCLS.EQ.9) CALL BWRITE(9)
210   CONTINUE
      IF (.NOT.DAW) GOTO 220
      INIW=0
      IF (IUCLS.EQ.0.OR.IUCLS.EQ.2) CALL BWRS(2,NTOT,INIW)
      IF (INIW.EQ.0) GOTO 220
      CALL LSTPOP(NREC,&220)
      CALL FWRTDB(2,NREC,NTOT,IW(INIW))
220   CONTINUE
      GOTO 100
C
C
      ENTRY SKRUN
C
      IF (PRHD) WRITE (6,1012) LRUN
      SKIP=.TRUE.
      GOTO 100
C
C
      ENTRY SKREST
C
      JR=6
      END=.TRUE.
      GOTO 100
C
C
      ENTRY SEQWRT
C
      SEQWC=.TRUE.
      GOTO 100
C
C
      ENTRY DAWRT
C
      DAWRTC=.TRUE.
      GOTO 100
C
C
      ENTRY SEQNOW
C
      SEQWC=.FALSE.
      GOTO 100
C
C
      ENTRY DANOW
C
      DAWRTC=.FALSE.
      GOTO 100
C
C
      ENTRY LSBWRT
C
      LSBWC=.TRUE.
      GOTO 100
C
C
      ENTRY LSBNOW
C
      LSBWC=.FALSE.
      GOTO 100
C
C               GOREC          GOBEG
100   RETURN
C               RUNBEGINN      ENDE
101   RETURN 1
C               EVENT          NAECHSTER RUN
102   RETURN 2
C               RUNENDE
C
C
1002  FORMAT (' -------- READING MONTE CARLO EVENTS')
1004  FORMAT (' -------- READING FROM DIRECT-ACCESS-DATASET')
1006  FORMAT (' -------- RUN',I8,' ENDED',I11,'EVENTS')
1008  FORMAT (' -------- RUN',I8,' STARTED  H0 = ',F7.3,
     1'  CP = ',E12.4,'  EBEAM = ',F10.3)
1010  FORMAT (' -------- RUN',I8,' SKIPPED EXIT',I2,' FROM GETRUN')
1012  FORMAT (' -------- RUN',I8,' SKIPPED(USER)')
1014  FORMAT (' -------- TOTAL',I10,' EVENTS',I4,' READ ERRORS',
     14X,'REASON FOR END IS ',3A4)
1018  FORMAT (' -------- RECORD  1 UNTIL',I8,' HAVE BEEN SKIPPED')
1020  FORMAT (' -------- NUMBER OF EVENTS WITH OLD DATAFORMAT',I7)
1022  FORMAT (' -------- NUMBER OF SPECIAL RECORDS',I7)
1024  FORMAT (' -------- GOREC  FATAL DATA ERROR  INIR',I10)
1026  FORMAT (' -------- NUMBER OF DATA ERRORS WITH UNKNOWN FORMAT',I7)
 1028 FORMAT(' --------   END READING FROM UNIT',I3,/,
     1      ' -------- START READING FROM UNIT',I3)
      END
      SUBROUTINE FWRTDB(IUN,NREC,LREC,IW)
      DEFINE FILE 2 (20000,1610,U,LX)
      INTEGER IW(LREC)
      WRITE (IUN'NREC,END=101,ERR=102)  IW
      RETURN
  101 WRITE (6,110)
      RETURN
  102 WRITE (6,111)
      RETURN
  110 FORMAT(' ATTEMPT TO WRITE PAST EOF ON UNIT 2')
  111 FORMAT(' WRITE ERROR ON UNIT 2')
      END

C   14/08/78 C8081401   MEMBER NAME  PTCPRT   (LGSOURCE)    FORTRAN
      SUBROUTINE PTCPRT(PRTCL,NP)
C
C---- S.YAMADA   14-08-78  16:00
C
C---- PRINT NO.OF PARTICLES AND ENERGY IN THE PRTCL-ARRAY.
C
      DIMENSION PRTCL(9,200)
C
      ETOT = 0.
      EEP = 0.
      EGM = 0.
      NEP = 0
      NGM = 0
C
      IF(NP) 10,10,1
    1   DO 2 N=1,NP
        EN = PRTCL(2,N)*0.511
        ETOT = ETOT+EN
        IF(PRTCL(1,N)) 3,4,3
    3   EEP = EEP+EN
        NEP = NEP+1
        GO TO 2
    4   EGM = EGM+EN
        NGM = NGM+1
    2   CONTINUE
C
   10 WRITE(6,600) NP,NEP,NGM,ETOT,EEP,EGM
  600 FORMAT(' NP,NEL,NGM=',3I4,'  ETOT,EEL,EGM=',3F10.1,'MEV')
      RETURN
      END

C   12/08/87 708121047  MEMBER NAME  TRKBSE   (S)           FORTRAN77
      SUBROUTINE TRKBSE(IPN,IALGN,EBISE)
C
C
C   COPIED FROM F11HEL.ES(TRKBSE)
C
C   UEBERNOMMEN VON  F11MEI.SHOWS(TRKBLK)
C
C             CALCULATING IMPACT POINT ON LG SURFACE
C             SUM UP ENERGIY IN BLOCKS STRUCK BY TRACK
C
C                                                 16/01/1985
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgeo1.for"
C
C     COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
C    *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
C    *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
C    +                NBLO,MEICL(50),NEICL(50)
      COMMON /LISE/   IBLCSE,NBSK,NBSE,XSI,YSI,ZSI,XSF,YSF,ZSF,XSTAST,
     *                YSTAST,ZSTAST,PSTAST,TRSE(3,50),TRISE
      DIMENSION IRSE(3,50)
      EQUIVALENCE(IRSE(1,1),TRSE(1,1))
      DIMENSION ALIST(3,50),BLIST(3,50),TSURF(3,12)
      DIMENSION POS1(25),POS2(25)
      DIMENSION X(3),V(3)
      EQUIVALENCE (XSI,X(1)),(YSI,X(2)),(ZSI,X(3))
      EQUIVALENCE (UI,V(1)),(VI,V(2)),(WI,V(3))
      DATA PI/3.14159/, TWOPI/6.283185/
      DATA SIGX,SIGY,SIGZ,SIGP /160.,160.,160.,.08/
      DATA POS1,POS2 /5*0.,5*1.,5*-1.,5*2.,5*-2.,0.,-2.,-1.,1.,2.,0.,
     *-2.,-1.,1.,2.,0.,-2.,-1.,1.,2.,0.,-2.,-1.,1.,2.,0.,-2.,-1.,1.,2./
C
      DATA ICALL/0/
      IF(ICALL.NE.0) GO TO 9999
      ICALL=1
      ZLGEFM=ZLGMI+BLZ
      ZLGEFP=ZLGPL-BLZ
      RBARSQ=RLG**2
      OUTRSQ=OUTR2**2
      RMAG=RCOIL+0.5*DRCOIL
      RMAGSQ=RMAG**2
      DEPENH=0.5*DEPEND
      TSURF( 1, 1)=0.
      TSURF( 1, 2)=   BLXY
      TSURF( 1, 3)=2.*BLXY
      TSURF( 1, 4)=TSURF( 1, 3)+50.
      TSURF( 1, 5)=3.*BLXY
      TSURF( 1, 6)=TSURF( 1, 5)+50.
      TSURF( 1, 7)=4.*BLXY
      TSURF( 1, 8)=TSURF( 1, 7)+50.
      TSURF( 1, 9)=5.*BLXY
      TSURF( 1,10)=TSURF( 1, 9)+50.
      TSURF( 1,11)=6.*BLXY
      TSURF( 1,12)=TSURF( 1,11)+50.
      TSURF( 2, 1)=2.*BLXY+50.
      TSURF( 2, 2)=2.*BLXY
      TSURF( 2, 3)=   BLXY
      TSURF( 2, 4)=0.
      TSURF( 2, 5)=0.
      TSURF( 2, 6)=0.
      TSURF( 2, 7)=0.
      TSURF( 2, 8)=0.
      TSURF( 2, 9)=0.
      TSURF( 2,10)=0.
      TSURF( 2,11)=0.
      TSURF( 2,12)=0.
      TSURF( 3, 1)=6.*BLXY+50.
      TSURF( 3, 2)=6.*BLXY+50.
      TSURF( 3, 3)=6.*BLXY
      TSURF( 3, 4)=   BLXY
      TSURF( 3, 5)=5.*BLXY
      TSURF( 3, 6)=   BLXY
      TSURF( 3, 7)=5.*BLXY
      TSURF( 3, 8)=   BLXY
      TSURF( 3, 9)=4.*BLXY
      TSURF( 3,10)=   BLXY
      TSURF( 3,11)=2.*BLXY
      TSURF( 3,12)=   BLXY
C
 9999 DO 40 ICLR=1,50
      IRSE(1,ICLR)=-1
      TRSE(2,ICLR)=0.
      TRSE(3,ICLR)=0.
   40 CONTINUE
C
      IPNH0=2*IALGN+5
      NWO=IDATA(IALGN)
      MXH=2*(IALGN+NWO)
C
C     DON'T EXTRAPOLATE PATHOLOGICAL TRACKS
C
      IF(IDATA(IPN+24).LT.6.OR.IDATA(IPN+33).LT.6) GOTO 1
C
C     GET R-Z FIT PARAMETERS.
C
      Z0=ADATA(IPN+31)
      ZSL=ADATA(IPN+30)
      OODEM=1./SQRT(1.+ZSL**2)
      WI=    ZSL*OODEM
C
C     FIND RADIUS AND CENTER OF GYRATION IN X,Y PLANE.
C
      ITYPE=IDATA(IPN+18)
      IF(ITYPE.NE.1) GO TO 2
C
C     CIRCLE FIT.
C     GET INITIAL POINT AND DIRECTION IN CASE WE USE THE STRAIGHT
C     LINE APPROXIMATION.
C

      AC=ADATA(IPN+21)
      X0=ADATA(IPN+20)*COS(AC)
      Y0=ADATA(IPN+20)*SIN(AC)
      R0SQ=X0**2+Y0**2
      R0=SQRT(R0SQ)
      A0=AC-PI/2.
      DOT=ADATA(IPN+8)*COS(A0)+ADATA(IPN+9)*SIN(A0)
      IF(DOT.LT.0.) A0=A0+PI
      CROSS=0.
C
      CURV=ADATA(IPN+19)
      IF(CURV.LT.1.E-6) GO TO 3
      R=1./CURV
      D0=R+ADATA(IPN+20)
      ALPHA=ADATA(IPN+21)
      XC=D0*COS(ALPHA)
      YC=D0*SIN(ALPHA)
      AL0=ATAN2((Y0-YC),(X0-XC))
      GO TO 4
    2 CONTINUE
      IF(ITYPE.NE.2) GO TO 1
C
C     PARABOLA FIT.
C
      A0=ADATA(IPN+19)
      X0=ADATA(IPN+20)
      Y0=ADATA(IPN+21)
      CURV=2.*ADATA(IPN+22)
      IF(ABS(CURV).GT.1.E-6) GO TO 76
      ANG=A0+PI/2.
      PERP=X0*COS(ANG)+Y0*SIN(ANG)
      X0=PERP*COS(ANG)
      Y0=PERP*SIN(ANG)
      R0SQ=X0**2+Y0**2
      R0=SQRT(R0SQ)
      GO TO 3
   76 CONTINUE
      R=1./CURV
      ANG=A0+PI/2.
      XC=X0+R*COS(ANG)
      YC=Y0+R*SIN(ANG)
      R=ABS(R)
      AL0=ATAN2(-YC,-XC)
      X0=XC+R*COS(AL0)
      Y0=YC+R*SIN(AL0)
      A0=AL0-PI/2.
      DOT=ADATA(IPN+8)*COS(A0)+ADATA(IPN+9)*SIN(A0)
      IF(DOT.LT.0.) A0=A0+PI
      GO TO 4
    3 CONTINUE
C
C     STRAIGHT LINE CASE.
C
      UI=COS(A0)*OODEM
      VI=SIN(A0)*OODEM
      AR0=0.
      IF(R0.GT.0.1) AR0=ATAN2(Y0,X0)
      CSD=COS(A0-AR0)
      SDSQ=1.-CSD**2
      RADIA=RBARSQ-SDSQ*R0SQ
      IF(RADIA.LT.0.0) GOTO 351
      XYPATH=SQRT(RADIA)-R0*CSD
      PATH=XYPATH/OODEM
      ZBIMPC=Z0+WI*PATH
      IF(ZBIMPC.LT.ZLGEFM) GO TO 5
      IF(ZBIMPC.GT.ZLGEFP) GO TO 7
C
C     HITS BARREL.
C
      IREG=0
      XSI=X0+UI*PATH
      YSI=Y0+VI*PATH
      ZSI=ZBIMPC
      GO TO 6
    5 CONTINUE
      IREG=-1
      ZPATH=ZENDMI-Z0
      ZSI=ZENDMI
      GO TO 75
    7 CONTINUE
      IREG=1
      ZPATH=ZENDPL-Z0
      ZSI=ZENDPL
   75 CONTINUE
      PATH=ZPATH/WI
      XSI=X0+UI*PATH
      YSI=Y0+VI*PATH
      GO TO 6
    4 CONTINUE
C
C     CIRCULAR ORBITS.
C
      CROSS=(X0-XC)*ADATA(IPN+9)-(Y0-YC)*ADATA(IPN+8)
      RCSQ=XC**2+YC**2
      RC=SQRT(RCSQ)
      RMAX=RC+R
      IF(RMAX.LT.(RMAG+100.)) GO TO 8
      DEL=R-RC
      IF(ABS(DEL).LT.1.E-1) DEL=0.
      COSL=(2.*RC*DEL+DEL**2-RMAGSQ)/(2.*RC*RMAG)
      AL=ARCOS(COSL)
      IF(CROSS.LT.0.) AL=-AL
      AIN=AL0+AL
      XSI=RMAG*COS(AIN)
      YSI=RMAG*SIN(AIN)
      XYPATH=SQRT((XSI-X0)**2+(YSI-Y0)**2)
      APATH=2.*ARSIN(0.5*XYPATH/R)
      IF(CROSS.LT.0.) APATH=-APATH
      ZPATH=ZSL*R*ABS(APATH)
      ZSI=Z0+ZPATH
      IF((ZSI.LT.ZLGEFM).OR.(ZSI.GT.ZLGEFP)) GO TO 8
C
C     INTERSECTS COIL.
C
      IREG=0
      AI=A0+APATH
      UI=COS(AI)*OODEM
      VI=SIN(AI)*OODEM
C
C     TRANSPORT FROM COIL TO BARREL.
C
      BTERM=(UI*XSI+VI*YSI)/OODEM
      XYPATH=SQRT(RBARSQ-RMAGSQ+BTERM**2)-BTERM
      PATH=XYPATH/OODEM
      XSI=XSI+UI*PATH
      YSI=YSI+VI*PATH
      ZSI=ZSI+WI*PATH
      GO TO 6
    8 CONTINUE
      IF(ABS(WI).LT.0.1) GO TO 29
      IF(WI.GT.0.) GO TO 9
      IREG=-1
      ZSI=ZENDMI
      GO TO 10
    9 CONTINUE
      IREG=1
      ZSI=ZENDPL
   10 CONTINUE
      ZPATH=ZSI-Z0
      APATH=ZPATH/(ZSL*R)
      IF(CROSS.LT.0.) APATH=-APATH
      AIN=AL0+APATH
      XSI=XC+R*COS(AIN)
      YSI=YC+R*SIN(AIN)
      AI=A0+APATH
      UI=COS(AI)*OODEM
      VI=SIN(AI)*OODEM
C
    6 CONTINUE
      PTRANS=ABS(0.0299792458*BKGAUS/CURV)
      PLONGI=PTRANS*ZSL
      ECHPRT=SQRT(PTRANS**2+PLONGI**2+139.57**2)
      IF(ECHPRT.GT.15000.) ECHPRT=6000.
      PMAG=SQRT(ECHPRT**2-139.57**2)
      PTRANS=PMAG/SQRT(1.+ZSL**2)
      PLONGI=PTRANS*ZSL
C
C
C     TRANSPORT PARTICLES THROUGH LEAD GLASS.
C
C
      XSHIFT = 40.
      YSHIFT = 40.
      ZSHIFT = 40.
      PSHIFT = .02
      XSTAST = XSI
      YSTAST = YSI
      ZSTAST = ZSI
      PSTAST = ATAN2(XSI,YSI)
      IF(PSTAST.LT.0) PSTAST = PSTAST + TWOPI
      IFINE = 0
C
CCC37 QUAMAX = 0.
      ITMAX = 1
      ITER = 1
      ITSEL = 0
      X1=XSI
      Y1=YSI
      Z1=ZSI
      PH1 = ATAN2(XSI,YSI)
      IF(PH1.LT.0) PH1=PH1+TWOPI
CCC34 CONTINUE
      NSURF=0
      IF(IREG.NE.0) GO TO 11
C
C     HITS BARREL.
C
      XSI=RLG*SIN(PH1 + POS2(ITER)*PSHIFT)
      YSI=RLG*COS(PH1 + POS2(ITER)*PSHIFT)
      ZSI=Z1 + POS1(ITER)*ZSHIFT
      PHI=ATAN2(XSI,YSI)
      IF(PHI.LT.0.) PHI=PHI+TWOPI
      WEIGHT = DGAUS2(ZSI,PHI,ZSTAST,PSTAST,SIGZ,SIGP)
      BTERM=(UI*XSI+VI*YSI)/OODEM
      XYPATH=SQRT(OUTRSQ-RBARSQ+BTERM**2)-BTERM
      PATH=XYPATH/OODEM
      XSF=XSI+UI*PATH
      YSF=YSI+VI*PATH
      ZSF=ZSI+WI*PATH
      DPHI=ARSIN((XSI*YSF-XSF*YSI)/(RLG*OUTR2))
      IF(ABS(DPHI).LT.1.E-3) GO TO 20
      PHII=TWOPI+ATAN2(YSI,XSI)
      PHIF=PHII+DPHI
      IBI=84.*PHII/TWOPI
      IBF=84.*PHIF/TWOPI
      NSURF=0
      NBCR=IABS(IBF-IBI)
      IF(NBCR.LT.1) GO TO 20
      PHIMI=TWOPI*(IBI+0.5)/84.
      PHIMF=TWOPI*(IBF+0.5)/84.
      STEP=(PHIMF-PHIMI)/NBCR
      PHIN=PHIMI+0.5*STEP-PI/2.
   21 CONTINUE
      UN=COS(PHIN)
      VN=SIN(PHIN)
      DRIFTN=-(UN*XSI+VN*YSI)
      DOT=UN*UI+VN*VI
      DRIFT=DRIFTN/DOT
      IF(NSURF.GE.48) GOTO 20
      NSURF=NSURF+1
      ALIST(1,NSURF)=XSI+UI*DRIFT
      ALIST(2,NSURF)=YSI+VI*DRIFT
      ALIST(3,NSURF)=ZSI+WI*DRIFT
      IF(NSURF.GE.NBCR) GO TO 20
      PHIN=PHIN+STEP
      GO TO 21
   20 CONTINUE
      IF(ABS(WI).LT.1.E-3) GO TO 22
      IBI=(ZSI+50.*BLZ)/BLZ
      IBF=(ZSF+50.*BLZ)/BLZ
      NBCR=IABS(IBF-IBI)
      IF(NBCR.LT.1) GO TO 22
      ZMI=(IBI+0.5)*BLZ-50.*BLZ
      ZMF=(IBF+0.5)*BLZ-50.*BLZ
      STEP=(ZMF-ZMI)/NBCR
      ZS=ZMI+0.5*STEP
      ISTEP=0
   23 CONTINUE
      DRIFTN=ZS-ZSI
      DRIFT=DRIFTN/WI
      ISTEP=ISTEP+1
      IF(NSURF.GE.48) GOTO 22
      NSURF=NSURF+1
      ALIST(1,NSURF)=XSI+UI*DRIFT
      ALIST(2,NSURF)=YSI+VI*DRIFT
      ALIST(3,NSURF)=ZS
      IF(ISTEP.GE.NBCR) GO TO 22
      ZS=ZS+STEP
      GO TO 23
   22 CONTINUE
      IF(NSURF.GE.48) GOTO 18
      NSURF=NSURF+1
      ALIST(1,NSURF)=XSI
      ALIST(2,NSURF)=YSI
      ALIST(3,NSURF)=ZSI
      IF(NSURF.GE.48) GOTO 18
      NSURF=NSURF+1
      ALIST(1,NSURF)=XSF
      ALIST(2,NSURF)=YSF
      ALIST(3,NSURF)=ZSF
      GO TO 18
   11 CONTINUE
C
C     HITS ENDCAP.
C
      XSI=X1+POS1(ITER)*XSHIFT
      YSI=Y1+POS2(ITER)*YSHIFT
      ZSI=Z1
      WEIGHT = DGAUS2(XSI,YSI,XSTAST,YSTAST,SIGX,SIGY)
      ZSF=ZSI+IREG*DEPEND
      ZM=0.5*(ZSI+ZSF)
      IDIM=0
      NSURF=0
   12 CONTINUE
      IDIM=IDIM+1
      JDIM=3-IDIM
      TRANS=V(IDIM)
      IF(ABS(TRANS).LT.1.0E-3) GO TO 13
      KTR=0
   14 CONTINUE
      KTR=KTR+1
      IF(KTR.GT.23) GO TO 13
      JTR=13-KTR
      IF(KTR.GE.12) JTR=KTR-11
      SIGN=-1.
      IF(KTR.GE.12) SIGN=1.
      TDRIFT=SIGN*TSURF(1,JTR)-X(IDIM)
      DRIFT=TDRIFT/TRANS
      ZS=ZSI+WI*DRIFT
      IF(ABS(ZS-ZM).GT.DEPENH) GO TO 14
      YS=X(JDIM)+V(JDIM)*DRIFT
      AYS=ABS(YS)
      IF((AYS.LT.TSURF(2,JTR)).OR.(AYS.GT.TSURF(3,JTR))) GOTO 14
      NSURF=NSURF+1
      ALIST(IDIM,NSURF)=SIGN*TSURF(1,JTR)
      ALIST(JDIM,NSURF)=YS
      ALIST(   3,NSURF)=ZS
      GO TO 14
   13 CONTINUE
      IF(IDIM.LT.2) GO TO 12
      NSURF=NSURF+1
      ALIST(1,NSURF)=XSI
      ALIST(2,NSURF)=YSI
      ALIST(3,NSURF)=ZSI
      DRIFT=(ZSF-ZSI)/WI
      XSF=XSI+UI*DRIFT
      YSF=YSI+VI*DRIFT
      NSURF=NSURF+1
      ALIST(1,NSURF)=XSF
      ALIST(2,NSURF)=YSF
      ALIST(3,NSURF)=ZSF
C
C     BARREL AND END CAP TRACKS MERGE HERE.
C
   18 CONTINUE
C
C     ORDER.
C
      DO 15 I=1,NSURF
      AMINW=1.0E8
      DO 16 J=1,NSURF
      IF(IREG.EQ.0) CW=ALIST(1,J)**2+ALIST(2,J)**2
      IF(IREG.NE.0) CW=ABS(ALIST(3,J))
      IF(CW.GT.AMINW) GO TO 16
      AMINW=CW
      K=J
   16 CONTINUE
      DO 17 J=1,3
      BLIST(J,I)=ALIST(J,K)
      ALIST(J,K)=2.0E8
   17 CONTINUE
   15 CONTINUE
C
C     COUNT REAL BLOCKS HIT AND COMPUTE PATH LENGTHS.
C
      NBSK=0
      DO 19 I=2,NSURF
      XB=0.5*(BLIST(1,(I-1))+BLIST(1,I))
      YB=0.5*(BLIST(2,(I-1))+BLIST(2,I))
      ZB=0.5*(BLIST(3,(I-1))+BLIST(3,I))
      IBLK=NUMBLC(XB,YB,ZB,IREG)
      IF(IBLK.LT.0) GO TO 19
      NBSK=NBSK+1
      DX=BLIST(1,I)-BLIST(1,(I-1))
      DY=BLIST(2,I)-BLIST(2,(I-1))
      DZ=BLIST(3,I)-BLIST(3,(I-1))
      IF(ABS(DX).LT.1.0E-3) DX=1.0E-3
      IF(ABS(DY).LT.1.0E-3) DY=1.0E-3
      IF(ABS(DZ).LT.1.0E-3) DZ=1.0E-3
      DL=SQRT(DX**2+DY**2+DZ**2)
      IRSE(1,NBSK)=IBLK
      TRSE(2,NBSK)=DL
   19 CONTINUE
   29 CONTINUE
C
      QUANT = 0.
      TRISE = 0.
      EBISE = -1.
      NBSE = 0
      IF(NBSK.LT.1) GOTO 35
C
C     TOTAL TRACKLENGTH FOR THIS ITERATION
C
      DO 88 ILOP=1,NBSK
      TRISE = TRISE + TRSE(2,ILOP)
   88 CONTINUE
      IF(TRISE.LT..00001) GOTO 1
C
C     CALCULATE QUANT
C
      KBLK=0
   25 CONTINUE
      KBLK=KBLK+1
      IF(KBLK.GT.NBSK) GO TO 26
      IBLK=IRSE(1,KBLK)
      EBL=0.
      IPNH=IPNH0
   27 CONTINUE
      IPNH=IPNH+2
      IF(IPNH.GT.MXH) GO TO 28
      JBLK=HDATA(IPNH)
      IF(JBLK.NE.IBLK) GO TO 27
      NBSE = NBSE + 1
      EBL=HDATA(IPNH+1)
      EBISE = EBISE + EBL
      IRSE(3,KBLK)=HDATA(IPNH+1)
   28 QUANT = QUANT + (EBL/ECHPRT)*(TRSE(2,KBLK)/TRISE)
      GOTO 25
   26 QUANT = WEIGHT*QUANT*FLOAT(NBSE)/FLOAT(NBSK)
C
   35 IBLCSE = 0
      IF(NBSK.LT.1) IBLCSE = 1
      IF(NBSK.GE.1.AND.EBISE.LT.1.) IBLCSE = 2
      NBL1=IRSE(1,1)
      NBL2=IRSE(1,2)
      RETURN
  351 IBLCSE=4
      RETURN
    1 IBLCSE = 3
      RETURN
      END

C   19/02/80 808021752  MEMBER NAME  ENGLOS   (SOURCE)      FORTRAN
C
C
C    PARAMETERS FOR 100-700 MEV ELECTRONS FROM EGS4 ADDED
C                                                      D.PITZL 30.06.87
C**********************************************************************
      SUBROUTINE ENGLOS ( E, D, DE, * )
C**********************************************************************
C
C     ENERGY LOSS OF ELECTRONS IN ALUMINIUM.
C
C     INPUT  : E  = INPUT ENERGY IN GEV
C              D  = THICKNESS OF ALUMINUM ABSORBER IN CENTIMETER
C     OUTPUT : DE = ENERGY LOSS IN GEV
C
C                        WRITTEN BY H.TAKEDA  15/02/80
C                        TYPED BY Y.WATANABE  19/02/80
C
      DIMENSION  BENG(20) , BTHK(7)
      INTEGER*2 HCOR(20,7)
C                           INCIDENT ENERGIES IN GEV
      DATA  BENG / 0.0, 0.1, 0.2,  0.3,  0.5,  0.7,  1.0,  2.0,   3.0,
     1   4.0, 5.0, 6.0, 7.0, 9.0, 11.0, 13.0, 15.0, 17.0, 19.0, 100.0/
C                            THICKNESS ALU IN CM
      DATA  BTHK / 0.0, 7.0, 9.0, 11.0, 13.0, 15.0, 100.0/
C                             ENERGY LOSS IN MEV
      DATA  HCOR / 20 * 0,
     2  0,  38,  42,  44,  48,  49,  55,  65,  70,  78,
     +                          84,  90,  95,             7*  96,
     3  0,  49,  57,  62,  69,  72,  76,  90, 102, 112,
     +                         118, 126, 130, 134,        6* 136,
     4  0,  59,  72,  80,  92,  97, 108, 130, 146, 157,
     +                         168, 180, 190, 196, 200,   5* 202,
     5  0,  64,  87,  99, 118, 126, 134, 170, 194, 212,
     +                         228, 238, 245, 256, 264,   5* 268,
     6  0,  71,  99, 117, 144, 156, 172, 218, 258, 278,
     +                         300, 320, 336, 350, 360,   5* 362,
     7   20 * 0/
      DATA IERR1,IERR2,IENTRY,IERCNT,IBTHK,IBENG/3*0,5,7,20/
C     EXTRAPOLATE THE THICKNESS OF ALUMINUM
      DE=0.
C---- INITIALIZE
      IF(IENTRY.GE.1) GO TO 2
      DO 1 I=1,IBENG
      F=(BTHK(IBTHK)-BTHK(IBTHK-2))/(BTHK(IBTHK-1)-BTHK(IBTHK-2))
      HCOR(I,IBTHK)=HCOR(I,IBTHK-2)+F*(HCOR(I,IBTHK-1)-HCOR(I,IBTHK-2))
1     CONTINUE
C     WRITE(6,900) HCOR
C900  FORMAT(16I6)
      PRINT 9123
 9123 FORMAT ( T2, 'JADELG.LOAD (ENGLOS) CALLED FROM LGECOR' )
      IENTRY=1
C
C       CHECK BAD INPUTS
2     IF(E.GE.0. .AND. E.LE.100.) GO TO 3
      IERR1=IERR1+1
      IF(IERR1.GT.IERCNT) RETURN1
      WRITE(6,600) E
600   FORMAT('0 **BAD  ENERGY INTO LGECOR(ENGLOS) E=',F10.3)
      RETURN1
C
3     IF(D.GE.0. .AND. D.LE.100.) GO TO 4
      IERR2=IERR2+1
      IF(IERR2.GT.IERCNT) RETURN1
      WRITE(6,610) D
610   FORMAT('0 **BAD THICKNESS INTO LGECOR(ENGLOS) D=',F10.3)
      RETURN1
C
4     DO 5 I=2,IBENG
      IF(E.LT.BENG(I)) GO TO 6
5     CONTINUE
6     DO 7 J=2,IBTHK
      IF(D.LT.BTHK(J)) GO TO 8
7     CONTINUE
C
8     EPORT=(E-BENG(I-1))/(BENG(I)-BENG(I-1))
      TPORT=(D-BTHK(J-1))/(BTHK(J)-BTHK(J-1))
C
      FACT1=HCOR(I-1,J-1)+EPORT*(HCOR(I,J-1)-HCOR(I-1,J-1))
      FACT2=HCOR(I-1,J  )+EPORT*(HCOR(I,J  )-HCOR(I-1,J  ))
C
      DE=FACT1+TPORT*(FACT2-FACT1)
      DE=DE/1000.
      IF(DE.GT.E) DE=E
      RETURN
      END

C   20/03/84 711172327  MEMBER NAME  FWCHEV   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FWCHEV
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON PREHISTORY :  DISPLAY FORWARD (TAGGING) SYSTEM
C
C        MOD: J. OLSSON   10/06/79 :  CHAMBER DISPLAY ADDED
C        MOD: J. OLSSON    4/10/83 :  CHAMBER DISPLAY REMOVED. (FWCHE0)
C        MOD: J. OLSSON    8/02/84 :
C        MOD: A. FINCH    12/03/84 :  UPDATED. SEE TAGG.S(TAGNOTE)
C        MOD: J. NYE      30/05/84 :  USES TAGMRK RATHER THAN TAGINT
C        MOD: C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS.
C   LAST MOD: C. BOWDERY   7/08/85 :  NEW TAGGING NAMES + TAGINT BACK
C   LAST MOD: J. OLSSON   23/10/85 :  PROPER HANDLING OF MC PEDESTALS
C
C
C        DISPLAY JADE FORWARD DETECTOR EVENT.
C        USED IN VIEWS NR 12(FW) 13(RU) AND COMMAND 58(FC)
C
C        1979-80 TAGGING APPARATUS
C        -------------------------
C
C        SUBTRACT A STANDARD PEDESTAL FROM LEAD GLASS, CONVERT TO MEV
C        WITH A STANDARD FACTOR 5.0      STANDARD PEDESTAL = 500 COUNTS
C        WITH A STANDARD FACTOR 7.5, PEDESTAL = 50 COUNTS AFTER RUN 278200002600
C
C        1981-82,83.. TAGGING APPARATUS
C        ------------------------------
C
C        CHANGED TO USE THE CALIBRATION OF A.FINCH, FOR 1981-82 AND 198300003100
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C---------  MACRO CHSYM    SYMBOLS USED IN GRAPHICS WRITING -----
      COMMON /CHSYM/ HSYM(36)
C------ END MACRO CHSYM
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO2 .... JADE TAGGING GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO2 / FENDC,XYHOL1,XYHOL2,BLDPFW,ZMINBL,ZPLUBL,
     +                 XSC(2),YSC(2),RSC(2),ZMISC(2),ZPLSC(2),DZSC,
     +                 CHX(3,4),CHY(3,4),CHZ(3,4),WLEN,PITCH,WZDIS
C
C--------------------------- END OF MACRO CGEO2 ------------------------
C
C----------------------------------------------------------------------
C      MACRO CGEO3 .... JADE FORWARD DETECTOR GEOMETRY, 1981-3 VERSION
C----------------------------------------------------------------------
C
      COMMON / CGEO3 / ZPLUM2,ZMINM2,NRPBSC,PBSCR(4),PBSCZ(4)
C
C------------------------ END OF MACRO CGEO3 --------------------------
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CHEADR / HEAD(108)
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  HMW(132)
C
      DIMENSION  NPBPED(3),PBGCAL(3)
C
      DATA NPBPED / 500, 50 ,0/, PBGCAL / 5.0, 7.5 ,5.5/
C
C------------------  C O D E  ------------------------------------------
C
C
      IPNTR = IDATA(IBLN('ATAG'))
      IF( IPNTR .LT. 1 ) GO TO 300
C
CCC                        USE TAGMRK SO THAT WE CAN ALSO HANDLE MC DATA
CCC
CCC   CALL TAGMRK(*300)
C
C                          USE TAGINT ONCE TO INITIALISE CWKTAG
C
      CALL TAGINT(*300)
C
      ADDEND = 84.0 * BLFI
      FDX    = 0.0
      ADY    = 0.0
      FACTFW = 1.0
      SH3    = 0.75 * FENDC
      IF( LASTVW .NE. 12 ) GO TO 2
C
C                           FW VIEW (12)
C
      FDX    = -(XMAX - XMIN) * 0.25
      FACTFW = 1.5
      SH3    = 0.70 * FENDC
   2  CONTINUE
      IF( LASTVW .NE. 13 ) GO TO 3
C
C                            RU VIEW (13)
C
      IF ( MARK .EQ. 2 ) SH3 = FENDC
      FACTFW = 2.0
      ADY    = 900.0
      FDX    = 0.5 * ADDEND
C
   3  IF( MARK .EQ. 1 ) GO TO 1111
      IF( MARK .NE. 0 ) GO TO 2222
C
C                            ENTER HERE FOR 1979-80 APPARATUS
C
      NBLIM = 190
      IRUN  = 1
C
C                            NO PROVISION FOR THIS IN TAGMRK SCHEME
C
      IF ( HEAD(18) .GT. 2781 ) IRUN = 2
      IF ( IMC .EQ. 1 ) IRUN = 3
C--
C  LOOP OVER BLOCK HITS, GET BLOCK NUMBER NB AND PULSEHEIGHT HPH
C     SUBTRACT PEDESTAL AND MULTIPLY WITH GAIN, STORE IN CATAG ARRAY
C--
      IADD   = 2 * IPNTR + 6
      IFLUMI = IADD + HDATA( IADD - 1 )
  200 CONTINUE
      IADD   = IADD + 1
      IF( IADD .GE. IFLUMI ) GO TO 210
C
      NB   = HDATA(IADD)
      IADD = IADD + 1
      IF( NB .EQ. 0 ) GO TO 200
      IF( NB .GT. 190 ) GO TO 200
      CATAG(NB) = 0.0
      IF( NB .GT.  46 .AND. NB .LT.  49 ) GO TO 200
      IF( NB .GT.  94 .AND. NB .LT.  97 ) GO TO 200
      IF( NB .GT. 142 .AND. NB .LT. 145 ) GO TO 200
      HPH = HDATA(IADD)
      HPH = HPH - NPBPED(IRUN)
      IF ( HPH .LT. 0 ) HPH = 0
      CATAG(NB) = HPH * PBGCAL(IRUN)
      GO TO 200
C
C
C
C
C----------------------------------------1981/82 APPARATUS ONLY---------
C
C
C                            ENTER HERE FOR 1981-82 APPARATUS
C
 1111 CONTINUE
C     IF( MARK .NE. 1 ) GO TO 2222
C
      NBLIM = 64
      CALL TAGADC(0,*300)
      CALL TAGPED
      CALL TAGKAL(0)
      GO TO 210
C
C
C
C----------------------------------------1983    APPARATUS ONLY---------
C
C
C                            ENTER HERE FOR 1983-.. APPARATUS
C
2222  CONTINUE
      IF( MARK .NE. 2 ) GO TO 999
C
      CALL TAGADC(0,*300)
      CALL TAGPED
      CALL TAGKAL(0)
      NBLIM = IENDPZ
C
C   DISPLAY LOOP FOR 1983-..  LEAD SCINTILLATOR ELEMENTS
C
      NTAGK=IENDMZ
C
C CHECK THE MAGNIFICATION, TO CHOOSE BETWEEN CRICRO AND PHNUMB
C
      IMAGOK = 0
      DELTX = ABS(XMAX-XMIN)
      IF ( DELTX .LT. 5000.0 .AND. LSTCMD .NE. 58 ) IMAGOK = 1
      IF ( DELTX .LT. 3000.0 .AND. LSTCMD .EQ. 58 ) IMAGOK = 1
C
      DO 400  NB = 1,NBLIM
      IF( CATAG(NB) .LT. 1.0 ) GO TO 400
C GET CORNER COORDINATES OF UNIT
      CALL XYTAG(NB,XTAG,YTAG,SLOTAG)
      ADX = FDX
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 12 ) ADX = -FDX
      IF ( LASTVW .EQ. 13 ) ADX = FDX - 750.0
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 13 ) ADX = FDX + 750.0
      IF( IMAGOK .EQ. 0 ) GO TO 399
      X1 = -XTAG * FACTFW + ADX
      Y1 =  YTAG * FACTFW + ADY
      IPH = CATAG(NB)
      CALL PHNUMB(IPH,SH3,SLOTAG)
      GO TO 400
399   X1 = -X1 * FACTFW
      X2 = -X2 * FACTFW
      X3 = -X3 * FACTFW
      X4 = -X4 * FACTFW
      Y1 =  Y1 * FACTFW
      Y2 =  Y2 * FACTFW
      Y3 =  Y3 * FACTFW
      Y4 =  Y4 * FACTFW
      CALL CRICRO(ADX,ADY)
400   CONTINUE
      GO TO 300
C
C
C
C----------------------------------------1979-82 DETECTORS ONLY---------
C
C
210   CONTINUE
C
C   DISPLAY LOOP FOR 1979-82  LEAD GLASS CAPS
C
      NTAGK=96
      IF ( MARK .EQ. 1 ) NTAGK = 32
C
      DO 333  NB = 1,NBLIM
      IF( CATAG(NB) .LT. 1.0 ) GO TO 333
      INB = NB
      IF ( MARK .EQ. 1 ) INB = NB - 1
C GET CENTER COORDINATES OF BLOCK
      CALL XYTAG(INB,XTAG,YTAG,SLOTAG)
      ADX = FDX
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 12 ) ADX = -FDX
      IF ( LASTVW .EQ. 13 ) ADX = FDX - 1100.0
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 13 ) ADX = FDX + 1100.0
C  OBS THAT COORDINATES FOR X IN 1979-82 ALREADY HAVE REVERSED SIGN, FOR
C   DISPLAY IN POSITIVE SYSTEM
      X1 = -XTAG + ADX - 0.40 * FENDC
      Y1 =  YTAG + ADY - 0.40 * FENDC
      IPH = CATAG(NB)
      CALL PHNUMB(IPH,SH3,SLOTAG)
333   CONTINUE
C
  300 CONTINUE
      RETURN
 999  CONTINUE
      WRITE(6,6712)
6712  FORMAT('   ERROR RETURN FROM FWCHEV ')
      RETURN
      END

C   18/02/81 207171751  MEMBER NAME  TFUPKO   (S)           FORTRAN
      SUBROUTINE TFUNPK(IPTOFR)
C
C   LHIST=1 PRODUCES ALL HISTOGRAMS
C
      COMMON/RJECT/IREJ,KREJ
      COMMON/POINT/IPHEAD,IPLTCH,IPT1,IPTOF,IPCLST,IPR,IPPATR,IPNT(12),
     1             IPBP
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/ENRGMG/BENGEV,BKGAUS,EGCOR
      COMMON/TOFHIT/XTOF(50),YTOF(50),ZTOF(50)
      COMMON/TRKINF/LTRK,DX1(10),DY1(10),DZ1(10),DXL(10),DYL(10),
     1            DZL(10),NXY(10),NRZ(10),CHIXY(10),ZPTOF(10),CHIRZ(10),
     2              X1(10),Y1(10),Z1(10),XL(10),YL(10),ZL(10),ZVER(10),
     3              NGOOD,IGOOD(10),PMOM(10),FI1(10),FIL(10),
     4              NFIN,ITRK1(10),ITRK2(10),RMIN(10)
      COMMON/TOFRES/TOFLGT(10),TDT(10),TDR(10),BETA(10),IQUAL(10)
     1          ,ITOFHT(10),PATH(10),MUCAND,IMUCND(10),NMU,IMUFIN(10)
     2          ,TAUMR(42),TAUPR(42)
      COMMON/TRACC/NACC,ALF(10),NMALF
      COMMON/DT4/NTGOOD(10),DDT1(10),DDT2(10),DDT3(10),DDT4(10)
***PMF#include "ddatas.for"
#include "ddata.for"
      COMMON/INOUT/WRITFL,EVWRIT
      COMMON/FLAGS/HISTFL,PRFL,NPRLIM
      LOGICAL WRITFL,EVWRIT,HISTFL,PRFL
      DIMENSION KKREJ(10),JTRK(2),NC1(10)
      DIMENSION RTOF(14,50),ITOF(14,50)
      EQUIVALENCE (RTOF(1,1),ITOF(1,1))
C
      DATA IBUG/ 0/,KBUG/ 0/,IENTRY/0/,JBUG/30/,KERR/0/
      DATA LBUG/0/,NPRREJ/0/
      DATA CVEL/  2.997925E2 /,RADTOF/920./
C
      IF(IENTRY.NE.0)  GOTO  19
      IENTRY = 1
      CFIC = 3.142/12.
      CTOF = 6.284/42.
      CTOF2= CTOF/2.
C     CALL HDELET(0)
      ZA = NRUN
      ZB = ZA+700.
      CALL HBOOK1(3507,20HREJECT CODES       $,100,0.,100.)
      CALL HTABLE(3506,' TOF CNTR FLAG $',42,0.,42.,4,-2.,2.,511.)
      CALL HBOOK1(1703,20HQUAL1              $,4,-2.,2.)
      CALL HBOOK1(1701,20H BETA              $,100,-1.,4.)
      CALL HBOOK2(1711,15HT      ITOF   $,100,-5.,15.,42,0.,42.)
      CALL HBOOK2(1702,15HNRUN TOF      $,100,ZA,ZB,40,-5.,15.)
C
   19 CONTINUE
      EVWRIT = .FALSE.
      CALL SETSL(KKREJ,0,40,0)
      MUCAND = 0
      NTR = IDATA(IPTOFR+1)
      CALL HF1(3507,20.,1.)
      KREJ = 70
      IF(NTR.NE.2) GOTO  60
      KREJ = 72
      CALL HF1(3507,22.,1.)
C
C
      DO   1   N=1,50
      DO   1   I=1,14
      RTOF(I,N) = DATA(IPTOFR+4+(N-1)*14+I)
    1 CONTINUE
C
      KREJ = 74
      CALL HF1(3507,23.,1.)
C
      JBUG = JBUG + 1
      IMU = 0
C
      IBUG = IBUG + 1
      IF(IBUG.LE.10) PRINT 106,NRUN,NEV,IEV,NTR,NOHIT
  106 FORMAT(' TFPROD NTR',8I5)
      IF(IBUG.LE.10) CALL TOFRPR
C
      CALL SETSL(NC1,0,40,0)
      DO   4   M=1,NTR
      NC1(1) = NC1(1)+1
      CALL HF1(3507,48.,1.)
C     P1 = ABS(PMOM(M))
      NC1(2) = NC1(2)+1
C
C  CHECK QUALITY OF TOF DETERMINATION
C
      CALL HF1 (1703,FLOAT(ITOF(2,M)),1.)
      IF(ITOF(2,M).GE.10)  GOTO  4
      ITOF1 = ITOF(3,M)
      CALL HFILL(3506,FLOAT(ITOF1),FLOAT(ITOF(2,M)))
      IF(ITOF(2,M).NE.1)  GOTO  4
      NC1(6) = NC1(6)+1
      CALL HF1(3507,60.,1.)
C
C
      PCOR1 = (RTOF(5,M)-RADTOF)/CVEL
      T1 = RTOF(4,M)-PCOR1
C     TAUMR(ITOF1) = TAUM(ITOF1)-PCOR1
C     TAUPR(ITOF1) = TAUP(ITOF1)-PCOR1
      NC1(8) = NC1(8)+1
C
C     IF(HSTAT(ITOF1).NE.2)CALL HFILL(1711,TAUMR(ITOF1),FLOAT(ITOF1))
C     IF(HSTAT(ITOF2).NE.2)CALL HFILL(1711,TAUMR(ITOF2),FLOAT(ITOF2))
C     IF(HSTAT(ITOF1).NE.1)CALL HFILL(1712,TAUPR(ITOF1),FLOAT(ITOF1))
C     IF(HSTAT(ITOF2).NE.1)CALL HFILL(1712,TAUPR(ITOF2),FLOAT(ITOF2))
      CALL HFILL(1711,T1,FLOAT(ITOF1))
      CALL HFILL(1702,FLOAT(NRUN),T1)
      CALL HF1(1701,RTOF(6,M),1.)
C
    7 IMU = IMU + 1
      IF(IMU.GT.10)  GOTO  4
      NC1(10) = NC1(10)+1
    4 CONTINUE
C
      DO   59   I=1,10
      IF(NC1(I).LE.0)  GOTO  59
      CALL HF1(3507,90.+FLOAT(I),1.)
   59 CONTINUE
C
   60 CONTINUE
      IF(MUCAND.LE.0) NPRREJ = NPRREJ + 1
      IF(MUCAND.LE.0.AND.NPRREJ.LE. 0)
     1  PRINT 701,NRUN,IEV,NEV,KREJ,KKREJ
  701 FORMAT(' REJECTED TFUNPK ',3I6,5X,I2,5X,10I3)
C
      RETURN
  997 CONTINUE
      KERR = KERR + 1
      IF(KERR.GT.20) RETURN
      PRINT 118
  118 FORMAT(' ERROR IN TOFR BANK')
      RETURN
      END

C   20/10/81 110201215  MEMBER NAME  MUHDSP   (JADEMUS)     FORTRAN
C   29/03/80 110180058  MEMBER NAME  MUHDSP   (S)           FORTRAN
C   12/02/80            MEMBER NAME  MUHDSP   (JADEMUS)     FORTRAN
C
C NEW VERSION 17.24 18/09/81 CHRIS BOWDERY- TO ONLY DRAW BASIC HITS
C
C-----------------------------------------------------------------------
      SUBROUTINE MUHDSP
C-----------------------------------------------------------------------
C
C        THIS ROUTINE DISPLAYS MUON CHAMBER HITS ON SCREEN AS FOLLOWS:
C
C          LARGE CROSS (X) ==> VALID   DRIFT DIGITISING
C          SMALL CROSS (X) ==> INVALID DRIFT DIGITISING
C
C    CDTL     STATE                  ACTION
C    ----     -----                  ------
C
C      8       ON       BAD CHAMBER Z COORDINATES MARKED WITH A CIRCLE
C  **  9  **       ==>  HITS ARE ALWAYS DRAWN IN PROJECT MODE
C     22       ON       HIT NUMBERS ARE DRAWN AND SCALE AS SQRT(MAGNIF)
C     24       OFF      ONLY 'IN PLANE' HITS ARE DRAWN
C     36       ON       UNPHYSICAL MIRROR HITS NOT DRAWN (WHERE KNOWN)
C     37       ON       DELETE HITS NOT ASSOCIATED WITH QUALITY MUONS
C     38       ON       EXTRAPOLATED TRACK NUMBERS DRAWN
C     39       ON       CHAMBER NUMBER AND RAW HIT NUMBERS DRAWN
C
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      LOGICAL FL18,FL22,FL24,DSPDTM,VALID,VALIL,LOST1,END,MUDONE,MUOK
      LOGICAL XYVIEW,ZXVIEW,ZYVIEW
C-----------------------------------------------------------------------
C                  COMMONS
C                  -------
C ( XMIN,YMIN ) * ( XMAX,YMAX ) IN COMMON CGRAPH,ARE THE COORDINATES OF
C                               THE CURRENT VIEW WINDOW IN VIRTUAL SPACE
C
C FL22 = .TRUE.                 IF THE CURRENT WINDOW IS DIFFERENT FROM
C                               THE STANDARD WINDOW
C FL18 = .TRUE.                 IF WE ARE DRAWING SIDE PROJECTIONS
C DSPDTL                        LOGICAL ARRAY CONTAINING CDTL'S  1 - 30
C DSPDTM                        LOGICAL ARRAY CONTAINING CDTL'S 31 - 60
C
C-----------------------------------------------------------------------
#include "cgraph.for"
#include "cmubcs.for"
      COMMON /CPROJ / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON /CGRAP2/ BCMD,DSPDTM(30)
      COMMON /CMUGRA/ IMR112,IMR122,IMUR20,IMUR21,NIDS,NWHIT,NTPH,
     +                NWTR,IMR222,IMR232,NHITS,MUOK
      DIMENSION HC(9),HAMB(2),OFFSET(8)
      DATA OFFSET/60.,-60.,30.,-30.,50.,-50.,40.,-40./
C-----------------------------------------------------------------------
C                    INITIALISATION
C                    --------------
C
C        CHARSZ = HIT NUMBER CHARACTER SIZE , K ='OFFSET' POINTER
C        LCHAM  = LAST CHAMBER NUMBER , MUDONE = TRUE IF ANALYSIS DONE
C        MUOK   = TRUE IF MUR1(0/1/2) AND MUR2(0/1/2/3) BANKS PRESENT
C-----------------------------------------------------------------------
      MUDONE = .FALSE.
      MUOK   = .FALSE.
      K = 0
      LCHAM  = 0
      CHARSZ = 80.
      IF(.NOT. FL22 .OR. FL18) GO TO 4
C
C                  FIND PRESENT MAGNIFICATION AND SCALE HIT NUMBER SIZE
C
         CURMAG = 10000./(XMAX - XMIN)
         CHARSZ = CHARSZ/(CURMAG**0.25)
         IF(CHARSZ.LT.30.) CHARSZ = 30.

C-----------------------------------------------------------------------
C
C FIND NO. OF HITS AND NO. OF WORDS PER HIT IN COORDINATE BANK.
C                  FIND POINTER TO MUR1 BANKS AFTER INITIALISATION.
C
  4   IHIT = 0
      ITRK = 0
      CALL CLOC(IMUR10,'MUR1',0)
      IF(IMUR10.GT.0) GO TO 11
C
C                  MUR1/0 NOT FOUND - CALL MUANAC TO CREATE IT.
C
      CALL MUANAC
      CALL CLOC(IMUR10,'MUR1',0)
        IF(IMUR10.GT.0) GO TO 11
        IF(FL18) RETURN
        CALL TRMOUT(80,'MUON ANALYSIS ERROR. MUR1 NOT CREATED^')
        RETURN
C
C                  MUR1/0 FOUND. PICK UP NUMBER OF HITS IN BANK
C
 11   NHITS=IDATA(IMUR10+1)
      IF(NHITS.LE.0) RETURN
C
C                  FIND NUMBER OF WORDS PER HIT.
C
      NWHIT=IDATA(IMUR10+3)
C
C                  FIND POINTER TO MU COORDINATE BANK MUR1/1
C                  AND MU HIT STATUS BANK MUR1/2.
C
      IMUR11  = IDATA(IMUR10-1)
      IF(IMUR11.LE.0) GO TO 200
      IMR112  = 2*IMUR11
      IMUR12  = IDATA(IMUR11-1)
      IF(IMUR12.LE.0) GO TO 200
      IMR122  = 2*IMUR12
C
C                  FIND POINTER TO AMBIGUITY BANK MUR2/3
C                  FIRST FIND MUR2 BANKS POINTER
C
      CALL CLOC(IMUR20,'MUR2',0)
C                  IF NO MUR2 BANKS JUMP
      IF(IMUR20.LE.0) GO TO 2
C                  FIND NUMBER OF INNER DETECTOR TRACKS.
      NIDS  = IDATA(IMUR20+1)
C                  FIND NUMBER OF I*4 WORDS PER TRACK IN MUR2/1
      NWTR  = IDATA(IMUR20+2)
C                  FIND NUMBER OF I*4 WORDS PER HIT IN MUR2/2 AND MUR2/300012100
      NTPH  = IDATA(IMUR20+3)
C                  FIND MUR2/1 , MUR2/2  AND  MUR2/3 POINTERS
      IMUR21  = IDATA(IMUR20-1)
      IF(IMUR21.LE.0) GO TO 2
      IMUR22  = IDATA(IMUR21-1)
      IF(IMUR22.LE.0) GO TO 2
      IMUR23  = IDATA(IMUR22-1)
      IF(IMUR23.LE.0) GO TO 2
      MUOK    = .TRUE.
C                  FIND THE OTHER BANKS TO SEE IF PHIL 2 ANALYSIS DONE
      IMUR24  = IDATA(IMUR23-1)
      IF(IMUR24.LE.0) GO TO 25
      IMUR25  = IDATA(IMUR24-1)
      IF(IMUR25.LE.0) GO TO 25
      MUDONE  = .TRUE.
C                  CALCULATE POINTERS TO HALF WORDS IN MUR2/2 AND MUR2/300013700
 25   IMR222 = 2*IMUR22
      IMR232 = 2*IMUR23
C-----------------------------------------------------------------------
C
C             ACCESS THE HIT INFORMATION USING S/R MUHIT
C
C INPUT VARIABLES
C
C IHIT        HIT NUMBER (AS DEFINED BY MUR1/1, THE COORDINATE BANK).
C ITRK        SET TO ZERO HERE.
C
C OUTPUT VARIABLES...
C
C HC          THE OUTPUT - 9 WORDS   (AS IN MUR1/1)
C               WORD  1     -  4*CHAMBER NUMBER + (RAW HIT NUMBER -1)
C               WORD  2     -  10*LAYER NUMBER + ORIENTATION
C               WORDS 3 - 8 -  X,Y,Z(LEFT),X,Y,Z(RIGHT) (MM).
C               WORD  9     -  POINTER TO HIT IN MUEV.
C LOST1       = .TRUE. IF THIS HIT HAS BEEN RECOVERED (HIT 4 PROBLEM)
C VALID       = .TRUE. IF HIT HAS VALID DRIFT COORDINATE
C VALIL       = .TRUE. IF HIT HAS VALID LONG. COORDINATE
C HAMB        AMBIGUITY INFORMATION FLAGS :HAMB(1) ==> LEFT  AMBIGUITY
C                                          HAMB(2) ==> RIGHT AMBIGUITY
C
C             = 4 "AMBIGUITY" ASSOCIATED WITH A MUON OF QUALITY > 0
C                  AND < 100 AND USED IN THE CHI-SQUARED FIT.
C             = 3 "AMBIGUITY" ASSOCIATED WITH A MUON OF QUALITY > 99
C                  AND USED IN THE CHI-SQUARED FIT.
C             = 2 AS 3 BUT THE MUON QUALITY WAS NOT > 0  (PHIL 2.1)
C             = 1 "AMBIGUITY" ASSOCIATED TO A TRACK BUT NOT IN CHI**2
C             = 0 "AMBIGUITY" NOT ASSOCIATED TO ANY TRACK
C
C END         = .TRUE. IF THIS IS LAST HIT , .FALSE. OTHERWISE
C
C-----------------------------------------------------------------------
C
  2   IHIT = IHIT + 1
      CALL MUHIT(HC,IHIT,ITRK,LOST1,VALID,VALIL,HAMB,END)
C
C-----------------------------------------------------------------------
C  FIND ORIENTATION OF THIS CHAMBER , IT'S NUMBER AND THE RAW HIT NUMBER
C      IOR          ORIENTATION
C      ---     ----------------------------
C       1      NORMAL TO DRIFT PLANE IS PARALLEL TO THE X-AXIS
C       2        "    "   "     "    "     "     "   "  Y-AXIS
C       3        "    "   "     "    "     "     "   "  Z-AXIS
C-----------------------------------------------------------------------
      IC    = HC(1)
      ICHAM = IC/4
      JHIT  = MOD(IC,4)  + 1
      IC    = HC(2)
      IOR   = MOD(IC,10)
C-----------------------------------------------------------------------
C                  IS CDTL 24 SET ? (TO SHOW OUT OF PLANE HITS)
C-----------------------------------------------------------------------
      XYVIEW = LASTVW.EQ.3
      ZXVIEW = LASTVW.EQ.6  .OR. LASTVW.EQ.7
      ZYVIEW = LASTVW.EQ.10 .OR. LASTVW.EQ.11
C
      IF(DSPDTL(24)) GO TO 10
C-----------------------------------------------------------------------
C
C  CDTL 24 IS NOT SET. THEREFORE , ONLY DRAW HITS AS FOLLOWS :
C    LASTVW=3    (XY) DRAW ONLY HITS ON CHAMBERS WHOSE IOR=1 OR 2
C      "    6,7  (XZ)   "   "    "    "    "       "    "  1 OR 3
C      "    10,11(YZ)   "   "    "    "    "       "    "  2 OR 3
C
C-----------------------------------------------------------------------
      IF( XYVIEW .AND. IOR.NE.3) GO TO 10
      IF( ZXVIEW .AND. IOR.NE.2) GO TO 10
      IF( ZYVIEW .AND. IOR.NE.1) GO TO 10
C                  IF WE ARE HERE , DRAW NOTHING FOR THIS HIT
      GO TO 3
C                  DEFINE SIZE OF THE CROSS   (SMALL IF BAD HIT)
 10   SIZE=20.
      IF(.NOT.VALID)SIZE=10.
C                  SKIP THIS HIT IF CDTL 37 IS ON AND BOTH AMBIGUITIES
C                  ARE BELOW CODE 3 BUT ONLY IF PHIL 2 HAS BEEN DONE
      IF( DSPDTM(7) .AND. HAMB(1).LT.3 .AND. HAMB(2).LT.3
     + .AND. MUDONE ) GO TO 3
C                  JUMP IF CDTL 39 OFF OR IF DRAWING SIDE PROJECTIONS
      IF(.NOT. DSPDTM(9) .OR. FL18 ) GO TO 5
C
C                  FIND THE NUMBER OF CHARACTERS I TO DRAW CHAMBER NO.
C
         ICH = ICHAM
         DO 6 I=1,5
           ICH = ICH/10
           IF(ICH.EQ.0) GO TO 7
   6     CONTINUE
C
C                  CALCULATE CENTRE OF CHAMBER BY AVERAGING HIT COORDS.
C
   7     XCOR  = ( HC(3) + HC(6) )/2
         YCOR  = ( HC(4) + HC(7) )/2
         ZCOR  = ( HC(5) + HC(8) )/2
C
C                  CONVERT TO 2 D VIRTUAL COORDINATE SPACE
C
         CALL XYMUD(XCOR,YCOR,ZCOR,X,Y)
C
C                  SET X TO LEFT OF CHAMBER CENTRE ALLOWING FOR WIDTH
C                  OF CHAMBER NUMBER. SELECT 1 OF 8 Y POSITIONS
C                  IF THIS HIT IS NOT IN A NEW CHAMBER , SELECT SAME
C                  Y POSITION. N.B. IN Z VIEWS THE HITS MAY BE FAR APART
C
         X = X - FLOAT(I)*CHARSZ/3.5 - 40.
         IF(ICHAM.NE.LCHAM) K = K + 1
         IF(K.GT.8) K = 1
         LCHAM = ICHAM
         Y = Y + OFFSET(K)
         CALL DNUM(ICHAM,X,Y,CHARSZ/2.0,0.)
C
C                  FIND THE NUMBER OF CHARACTERS I TO DRAW RAW HIT NO.
C
      KNUM = IHIT
      DO 8 I=1,5
        KNUM = KNUM/10
        IF(KNUM.EQ.0) GO TO 9
  8   CONTINUE
  9   XOFF = FLOAT(I)*CHARSZ*0.80 + 20.
C                  IF HIT WAS CORRUPTED AND RECOVERED , INDICATE THIS
  5   IF(LOST1) JHIT = 0
C
C                  DRAW BOTH AMBIGUITIES
C
      DO 1 J=1,2
C
C                  IF CDTL 36 IS ON , DO NOT DRAW THE UNPHYSICAL
C                  AMBIGUITY WHERE THIS HAS BEEN RESOLVED.
C
        IF( DSPDTM(6) .AND. HAMB(3-J).GE.2 .AND. HAMB(J).LT.HAMB(3-J)
     +                .AND. HAMB(J).LT.3 ) GO TO 1
C
C                  IF CDTL 37 ON DO NOT DRAW ANY AMBIGUITY WITH CODE
C                  LESS THAN 3 IF PHIL 2 HAS BEEN DONE.
C
        IF( DSPDTM(7) .AND. MUDONE .AND. HAMB(J).LT.3) GO TO 1
        IX=3*(J-1)+3
        IY=IX+1
        IZ=IX+2
        XCOR=HC(IX)
        YCOR=HC(IY)
        ZCOR=HC(IZ)
C
C                  CONVERT 3 D SPACE POINT TO 2 D DISPLAY COORDINATES IN
C                  THE X,Y VIRTUAL SPACE.
C
        CALL XYMUD(XCOR,YCOR,ZCOR,X,Y)
C
C                  DRAW MUR2/1 HIT NOS. IF 'CDTL 22' IS SET
C
        IF(DSPDTL(22) .AND..NOT. FL18)
     +    CALL DNUM(IHIT,X+20.,Y+20.,CHARSZ,0.)
C
C                  DRAW RAW HIT NOS. IF 'CDTL 39 * 22' ARE BOTH SET
C
        IF(DSPDTM(9) .AND. DSPDTL(22) .AND..NOT.FL18)
     +    CALL DNUM(JHIT,X+XOFF,Y+10.,CHARSZ/2.,0.)
C
C                  DRAW CROSS ( X ) TO REPRESENT HIT.
C
        CALL MOVEA(X-SIZE,Y-SIZE)
        CALL DRAWA(X+SIZE,Y+SIZE)
        CALL MOVEA(X-SIZE,Y+SIZE)
        CALL DRAWA(X+SIZE,Y-SIZE)
C
C                  JUMP TO END OF DO LOOP:
C                     IF LONGITUDINAL COORDINATE WAS GOOD
C                     IF CDTL 8 IS OFF
C                     IF CURRENT VIEW IS NOT ( ZY  FOR ALL HITS    OR
C                                              ZX  FOR BARREL HITS OR
C                                              XY  FOR ENDWALL HITS   )
C
        IF( VALIL .OR. .NOT.DSPDTL(8) ) GO TO 1
        IF( .NOT.(    ZXVIEW .AND. IOR.EQ.1
     +           .OR. ZYVIEW
     +           .OR. XYVIEW .AND. IOR.EQ.3) ) GO TO 1
C
C                  DRAW A CIRCLE AROUND THIS BAD CHAMBER Z
C
            SIZ2=35.0
            DPHI=0.314159
            PHI=0.
            CALL MOVEA(X+SIZ2,Y)
C
            DO 18 I=1,20
              PHI=PHI+DPHI
              X2=X+SIZ2*COS(PHI)
              Y2=Y+SIZ2*SIN(PHI)
              CALL DRAWA(X2,Y2)
   18       CONTINUE
C                  IF CDTL 24 IS OFF , FORGET THE OTHER AMBIGUITY
            IF( .NOT. DSPDTL(24) ) GO TO 3
 1    CONTINUE
 3    IF(.NOT.END) GO TO 2
      RETURN
200   IF(.NOT. FL18) CALL TRMOUT(80,'MUON HIT BANK(S) MISSING^')
      RETURN
      END

C   07/06/96 606071857  MEMBER NAME  NBK      (S4)          FORTRAN
      FUNCTION NBK(NA,NB,NC)
C     BOS SUBPROGRAM
#include "acs.for"
      COMMON/BCS/IW(1)
#include "star.for"
      CALL NOARG(M)
      IND=0
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAMEV),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      IF(M.GT.1) GOTO 3
      IND=LFDI
      GOTO 100
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)        GOTO    10
      IF(IW(LFDI-2).LT.NR) GOTO 2
      IF(IW(LFDI-2).GT.NR) GOTO    10
      IND=LFDI
C     FOUND
      IF(M.EQ.2) GOTO 100
      NN=0
      IF(NC.LT.0) GOTO 20
      NN=NC-IW(IND)
      IF(NN) 11,100,12
   11 IF(IND+IW(IND)+1.EQ.NEXT) GOTO 20
      IF(NN.GT.(-4)) GOTO 20
C     INSERT DUMMY
      GOTO 100
C     NOT FOUND
   10 IF(M.EQ.2) GOTO 100
      IF(NC.LT.0) GOTO 100
      NN=NC+4
      IF(NEXT+NN.GE.NLST) GOTO 200
      INAME=NAME
      IF(NOTLOW(XNAME)) GOTO 40
      IF(NCPL+NN.GE.NSPL) GOTO 200
   30 NCPL=NCPL+NN
   40 IER=0
      IND=NEXT+3
      IW(IND-3)=NAME
      IW(IND-2)=NR
      IW(IND)=NW
      ISV=IW(LFDK-1)
      IW(LFDK-1)=IND
      IW(IND -1)=ISV
      IF(NW.GT.0) CALL VZERO(IW(IND+1),NW)
      NEXT=NEXT+NN
   50 LIND=IND
C
C     MOVE
   22 CALL UCOPY(IW(IND-3),IW(NEXT),NW)
      IW(IND)=-NN
      ILOW=MIN0(ILOW,IND)
      IND=NEXT+3
      NEXT=NEXT+NW
      IW(LFDK-1)=IND
      NFRE=NFRE+NW
  100 RETURN
  101 RETURN 1
      END

C   09/12/87 807261205  MEMBER NAME  TPSPHE   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPSPHE( NP, P )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       9/12/87:  Do sphericity calculation.
C
C          mod: C. Bowdery      12/01/88:  Add ARGUMENTS comment.
C          mod: C. Bowdery      31/01/88:  Add CALL TPEVI1, etc
C     Last mod: C. Bowdery      26/07/88:  NP added to TPSPUT call
C
C     Routine to coordinate sphericity calculation & storing of results
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     NP        In       I*4      No. of particles in P array
C     P         In       R*4      Momentum array
C                                   P(1,i) = px   of particle i
C                                   P(2,i) = py   of particle i
C                                   P(3,i) = pz   of particle i
C                                   P(4,i) = ptot of particle i
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      INTEGER  NP
      REAL     P(4,200)
      REAL     SPHITY(3), AXES(9)

      LOGICAL  WANTED

C------------------  C O D E  ------------------------------------------

C                            Is the sphericity calculation wanted?

      CALL TPEVI1( WANTED )

      IF( WANTED  .AND.  NP .GT. 0 ) THEN

C                            Compute sphericty eigenvalues, SPHITY(1..3)
C                            and eigenvectors, AXES(1..9), where 1..3
C                            are direction cosines of minor axis, etc.

        CALL SPHRCY( P, NP, SPHITY, AXES )

C                            Store eigenvalues and eigenvectors

        CALL TPSPUT( NP, SPHITY, AXES )

      ENDIF

      RETURN
      END

C   13/02/79 005110616  MEMBER NAME  TPCNST   (SOURCE)      FORTRAN
      SUBROUTINE TPCNST( NPHD )
C
C     S.YAMADA   13-02-79  22:10
C---- LAST MODIFICATION   22-08-79  10:05  E.ELSEN
C
C---- FETCH EVENT CONSTANTS FOR ANALYSIS FROM THE 'HEAD'-BANK
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
      COMMON /CTPCNS/ EBMGEV, BKGAUS, NORDFG(15)
      DATA CONVF/0.001/
C
C
      NPHD2 = NPHD + NPHD
C
      EBMGEV = 0.001*HDATA( NPHD2+29 )
      IF(EBMGEV.LT.1.) EBMGEV=1.
      BKGAUS = CONVF*HDATA( NPHD2+30)
C
C---- UNPACK THE NORD READOUT PATTERN.
      NRP = HDATA(NPHD2+13)
        DO 1 I=1,15
        NRPW = NRP/2
        NORDFG(16-I) = NRP-2*NRPW
    1   NRP = NRPW
C//////////////////////////////
C       WRITE(6,6000) EBMGEV,BKGAUS, NORDFG
C6000   FORMAT(' EBMGEV,BKGAUS=',2E12.4,'  NORDFG=',8I2,2X,8I2)
C//////////////////////////////
      RETURN
      END

C   21/11/78 C9012401   MEMBER NAME  ZBOS05   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------500000200
C     5.  PRINTOUT OF BANKS
C
C     5.1  SINGLE BANKS
C
C               -- --
C     CALL BPRS(NA,NR)
C
C
C        WHERE NA = NAME
C              NR = NUMBER OF BANK TO BE PRINTED
C
C
C     5.2  SETS OF BANKS
C
C                                      ---
C     CALL BPRM              CALL BPRL(LIM)
C
C     ALL BANKS OF THE CURRENT LIST OF NAMES ARE PRINTED. THE
C     CALL OF BPRL IS IGNORED AFTER LIM EXECUTIONS.
C
C     THE PRINTING FORMAT OF EACH WORD IS CHOSEN AUTOMATICALLY
C     (TEXT, INTEGER, REAL), NOT ALWAYS CORRECT.
      RETURN
      END

C   03/02/81 206081403  MEMBER NAME  ATOFPR   (S)           FORTRAN
      SUBROUTINE ATOFPR(IPTOF)
      IMPLICIT INTEGER*2 (H)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HSTAT(42),HON(42)
      COMMON/FWPED/ HADCF(2,16),HTDCF(2,16),HFSTAT(16),HFON(16)
      COMMON/TFPED1/HTDC1(2,42),HON1(42),HTSPAR(16)
#include "chead.for"
      DATA IBUG /0/
C
      NRUN = HEADR(18)
      IF(NRUN.GT.10000)  CALL ATFPR2(IPTOF)
      IF(NRUN.GT.10000)  RETURN
C
      IBUG = IBUG + 1
      PRINT 300,IBUG
  300 FORMAT(//' NEW EVENT',I5/)
      CALL ATOFRW(IPTOF)
      PRINT 305,HON
      PRINT 305,HON1
      PRINT 305,HFON
  305 FORMAT(' HON',42I3)
      DO   1   I=1,42
      IF(I.LE.16.AND.
     *   HON(I).LE.0.AND.HFON(I).LE.0.AND.HON1(I).LE.0)  GOTO  1
      IF(I.GT.16.AND.
     *   HON(I).LE.0.AND.HON1(I).LE.0)  GOTO  1
      PRINT301,I,HADC(1,I),HADC(2,I),HTDC(1,I),HTDC(2,I)
  301 FORMAT(I5,4I6)
      IF(I.GT.16)  GOTO  2
      IF(HFON(I).LE.0)  GOTO 2
      PRINT302,I,HADCF(1,I),HADCF(2,I),HTDCF(1,I),HTDCF(2,I)
  302 FORMAT('+',40X,I5,4I6)
    2 IF(HON1(I).LE.0)  GOTO  1
      PRINT304,I,HTDC1(1,I),HTDC1(2,I)
  304 FORMAT('+',80X,I5,2I6)
  303 FORMAT(/)
    1 CONTINUE
C
      RETURN
      END

C   12/02/82 403240433  MEMBER NAME  LGKOSM   (JADESR)      FORTRAN
C     *************************************************
C     *    COSMIC RAY REDUCTION IN BARREL LEAD GLASS  *
C     *          ORIGINAL VERSION 09-11-79 S.K.       *
C     *          FINAL VERSION    05-12-79 S.K.       *
C     *          CODED AGAIN BY J.KANZAKI 12-02-82    *
C     *          MODIFIED BY S.YAMADA  13-02-82       *
C     *                IT USES ONLY /CWORK/ NOW       ******************
C     *  ERROR: UNINITIALIZED VARIABLE IPATR HAS BEEN FIXED, 24.3.1984 *
C     *                           J.OLSSON            ******************
C     *************************************************
C-----------------------------------------------------------------------
C
      SUBROUTINE LGKOSM(KFLAG,EAB,NHITA,NHITB,COSA,COSB,COSD,DNORM)
C
C----------------------------------------------------------------------+
C             KFLAG=0 : NORMAL BARREL-NEUTRAL EVENT                    |
C                                                                      |
C             KFLAG=16: THE EVENT HAS AT LEAST 1 RECONSTRUCTED TRACK   |
C                                                 IN THE JET CHMBER    |
C             KFLAG=8 : NO ENERGY DEPOSITION IN LEAD GLASS COUNTERS    |
C                                                                      |
C             KFLAG=4 : NO ENERGY DEPOSITION IN THE BARREL PART        |
C                       BUT ETOT IS NOT ZERO                           |
C             KFLAG=2 : ENERGY DEPOSITION IS DOMINATED IN THE END CAP  |
C                                                                      |
C             KFLAG=1 : THE MAX ENERGY CLUSTER IS IN THE END CAP PART  |
C             ---------------------------------------------------------+
C                                                                      |
C          EAB(1,1) : LARGER EIGEN-VALUE OF THE CLUSTER                |
C                          WITH MAX ENERGY IN THE BARREL PART          |
C          EAB(1,2) : SMALLER EIGEN-VALUE OF THE CLUSTER               |
C                          WITH MAX ENERGY IN THE BARREL PART          |
C          EAB(1,3) : MAXIMUM CLUSTER ENERGY                           |
C                                     IN THE BARREL LEAD GLASS         |
C          EAB(2,1) : LARGER EIGEN-VALUE OF THE CLUSTER                |
C                          WITH 2ND ENERGY IN THE BARREL PART          |
C          EAB(2,2) : SMALLER EIGEN-VALUE OF THE CLUSTER               |
C                          WITH 2ND ENERGY IN THE BARREL PART          |
C          EAB(2,3) : 2ND MAXIMUM CLUSTER ENERGY                       |
C                                     IN THE BARREL LEAD GLASS         |
C             TA    : ANGLE BETWEEN PHI & EIGEN-VECTOR OF CLUSTER A    |
C                                                                      |
C             TB    : ANGLE BETWEEN PHI & EIGEN-VECTOR OF CLUSTER B    |
C                                                                      |
C             TD    : ANGLE BETWEEN TWO CLUSTERS                       |
C                                                                      |
C            NHITA  : ADC HIT OF CLUSTER A                             |
C                                                                      |
C            NHITB  : ADC HIT OF CLUSTER B                             |
C                                                                      |
C----------------------------------------------------------------------+
      IMPLICIT INTEGER *2 (H)
      COMMON /BCS/ IW(24000)
      DIMENSION RW(24000)
      INTEGER*2 HW(48000)
      EQUIVALENCE (IW(1),RW(1)),(IW(1),HW(1))
      COMMON /MAXCLS/EIG1,EIG2,EIGSUM,EIGDIV,MAXHIT,ECMAX,MAXCL
      COMMON /EIGAB/CSD(2),CSA(2),CSB(2),
     &        EIGA1,EIGA2,EIGB1,EIGB2,ENEA,ENEB,NA,NB,DNOR
      DIMENSION EAB(2,3),COSD(2),COSA(2),COSB(2)
#include "clgwork1.for"
C-----------------------------------------------------------------------
      KFLAG=0
      DO 5 L=1,3
      EAB(1,L)=0.
      EAB(2,L)=0.
    5 CONTINUE
      COSD(1)=0.
      COSD(2)=0.
      COSA(1)=0.
      COSB(1)=0.
      COSA(2)=0.
      COSB(2)=0.
      NHITA=0
      NHITB=0
      DNORM=0.
C-----------------------------------------------------------------------
      CALL LGANAK
      EAB(1,1)=EIGA1
      EAB(1,2)=EIGA2
      EAB(2,1)=EIGB1
      EAB(2,2)=EIGB2
      EAB(1,3)=ENEA
      EAB(2,3)=ENEB
      COSD(1)=CSD(1)
      COSD(2)=CSD(2)
      COSA(1)=CSA(1)
      COSB(1)=CSB(1)
      COSA(2)=CSA(2)
      COSB(2)=CSB(2)
      NHITA=NA
      NHITB=NB
      DNORM=DNOR
C-----------------------------------------------------------------------
C  CHECK NUMBER OF RECONSTRUCTED TRACKS
C
      INPATR=IW(IBLN('PATR'))
      IF(INPATR.NE.0) GO TO 16
C     WRITE(6,2000)
C2000 FORMAT(' ******* IBLN(PPATR) ***** ERROR **** IN LGKOSM')
      GO TO 17
C  16 INPATR=IW(IPATR)
   16 CONTINUE
      NTRACK=IW(INPATR+2)
      IF(NTRACK.NE.0) KFLAG=KFLAG+16
   17 CONTINUE
C-----------------------------------------------------------------------
C  CHECK 'END CAP BHABHA' EVENTS
C
CC         WRITE(6,6001) ETOT
C6001      FORMAT(' ETOT=',4F10.3)
      IF(ETOT(1).EQ.0.) GO TO 2
C-----------------------------------------------------------------------
C---  THE MAX CLUSTER IN THE BARREL PART IS COMPARED WITH
C---  THE MAX CLUSTER IN THE END CAP
C
      IFL=0
      IB=0
      EM=0.
      DO 10 N=1,NCLST
      ENECL=CLSPRP(2,N)
      IF(EM.GT.ENECL) GO TO 10
      EM=ENECL
      NM=N
   10 CONTINUE
      IF(ICLSPR(1,NM).EQ.0) GO TO 11
      IFL=1
      EAB(1,3)=EM
      NHITA=HMAPCL(2,NM)-HMAPCL(1,NM)+1
C-----------------------------------------------------------------------
   11 CONTINUE
      KFLAG=KFLAG+IFL
      IF(ETOT(2).LE.0.) KFLAG=KFLAG+4
      FRCBRL=ETOT(2)/ETOT(1)
      IF(FRCBRL.LT.0.5) KFLAG=KFLAG+2
      GO TO 7
C-----------------------------------------------------------------------
    2 KFLAG=KFLAG+8
    7 CONTINUE
      RETURN
      END

C   02/11/78 C9101501   MEMBER NAME  LGAVRZ   (SOURCE)      FORTRAN
C
      SUBROUTINE LGAVRZ(JEG,Z0,ZAV,ZSIG,DEPAV)
C
C     S.YAMADA   03-09-78  21:15        VERSION 2
C     RECOPIED FROM LVAVRZ IN(LGTESTP.S) AND MODIFIED FOR REAL DATA
C     LAST MODIFICATION  28-02-79  16:50
C
C---- CALUCULATE THE AVERAGE POSITION OF THE SHOWER MAX.
C
C---- INPUTS
C     JEG = 1 FOR EL/POS,  =0 FOR GAMMA
C     Z0     THE VERTEX POSITION OF THE EVENT.IT IS USED ONLY IF SINTO=000001200
C---- OUTPUTS
C     ZAV    THE AVERAGE Z OF THE SHOWER
C     ZSIG   VARIANCE OF Z WIDTH.
C     DEPAV  THE AVRG DEPTH OF THE SHOWER IN R(MEASURED FROM SURFACE)
C
C---- PULSE HEIGHT OF EACH RING SHOULD BE STORED IN Y
      COMMON /CLGZPT/ ETOT,Y(32),WEIGHT(32),YFIT(32),DERIV(32)
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGMSB/ MSGVAL,AMSG1,AMSG2
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/278112410/
      NVRSN(4) = NVCODE
C
C---- CALCULATE THE AVERAGE Z (WEIGHT=PULSE HEIGHT)
      Z = ZEND(1)+0.5*ZWID(1)
      ZSTEP = ZWID(1)+ZGAP(1)
      YSUM = 0.
      YZSUM = 0.
C---- IST    INDEX FOR THE FIRST HIT IN Y
C---- LST    INDEX FOR THE LAST HIT IN Y
        DO 1 I=1,32
        IF(YSUM.LE.0.0 .AND. Y(I).GT.0.) IST = I
        IF(YSUM.GT.0. .AND. Y(I).LE.0.) GO TO 4
        IF(Y(I).GT.0.) LST = I
        YSUM = YSUM+Y(I)
        YZSUM = YZSUM+Z*Y(I)
        Z = Z+ZSTEP
    1   CONTINUE
C
    4 IF(YSUM.LE.0.) YSUM = 1.0
      ZAV = YZSUM/YSUM
      IF(ABS(ZAV-Z0).GT.360.) GO TO 8
C---- ONLY FOR HIGH ENERGY SHOWER
      IF(ETOT.LT.2000. .OR. LST.EQ.IST) GO TO 8
C
C     FOR NEARLY PARAREL INCIDENT ZAV IS CORRECTEDFOR QUANTIZATION EFF.
C---- FROM THE P.H.RATIO IN Z,POSITION OF THE HIT POINT IS RECALCULATED.
C---- THIS PART IS COPIED FROM AVTOZH(AN ENTRY POINT OF ORIGINAL LGAVRZ)
C
C---- NZ --- RING# WHICH CONTAINS THE AVERAGE Z,NZ1 AND NZ2 ARE NEIGHBR.
      NZ1 = (ZAV-ZEND(1))/ZSTEP
      NZ = NZ1+1
      NZ2 = NZ+1
C
C---- ENERGY FRCTION OF LEFT<MIDDLE AND RIGHT PARTARE CALCULATED.
      Y1 = 0.
      IF(NZ1.LT.IST) GO TO 11
        DO 20 N=IST,NZ1
   20   Y1 = Y1+Y(N)
   11 Y2 = Y(NZ)
      Y3 = 0.
      IF(NZ2.GT.LST) GO TO 13
        DO 12 N=NZ2,LST
   12   Y3 = Y3+Y(N)
C
C---- NORMALIZATION
   13 Y1 = Y1/YSUM
      Y2 = Y2/YSUM
      Y3 = Y3/YSUM
C
C---- FOR ALMOST SYMMETRIC CASE NO CORRECTION.
      IF(Y1.LT.0.016 .AND. Y3.LT.0.016) GO TO 8
      IF(Y1-Y3) 14,8,15
C
C---- Y1<Y3
   14 YMIN= Y3
      XBND = ZEND(1)+NZ*ZSTEP
      IF(YMIN.LE.0.5) GO TO 140
C---- Y1+Y2<Y3
C---- AVZ DOES NOT CORRESPOND TO THE HIGHEST P.H. BUT GO ON!
      YMIN = Y1+Y2
      S = 1.0
      GO TO 16
  140 S = -1.
      GO TO 16
C
C---- Y1>Y3
   15 YMIN = Y1
      XBND = ZEND(1)+NZ1*ZSTEP
      IF(YMIN.LE.0.5) GO TO 150
C---- Y2+Y3<Y1
      YMIN = Y2+Y3
      S = -1.0
      GO TO 16
  150 S = 1.0
C
C---- EMPIRICAL FORMULA FOR Z --------------------
C     YMIN = 0.5*A**2/(DX+A)**2                  I
C     A=0.3598            <<<TEMP 0.50 FOR Z>>>  I
C-------------------------------------------------
      DATA A/0.5000/
   16 HB = 0.5*ZWID(1)
      DX = A*(1.0/SQRT(2.0*YMIN)-1.0)*X0
      IF(DX.GT.HB) DX = HB
      ZAV = XBND+S*DX
C
C       ***********************************
C----   *   AVERAGE DEPTH OF THE SHOWER   *
C       ***********************************
C---- SHOWER ANGLE IS NOT KNOWN.
C---- ITERATION IS USED.
    8 DEPO = 0.
      SM = SHMAX(ETOT,JEG)
      NTRY = 0
C---- SM=AVERAGE SHOWER POSITION ALONG THE SHOWER AXIS.
    2 NTRY = NTRY+1
      IF(NTRY.GT.20) GO TO 21
      DEP = SM/SQRT(1.0+ZAV**2/(RADIUS(3)+DEPO)**2)
      IF(ABS(DEP-DEPO)/DEP.LE.0.01) GO TO 3
      DEPO = DEP
      GO TO 2
   21 MSGVAL = NTRY
      AMSG1 = DEPO
      AMSG2 = DEP
      CALL MESSAG( 5, 1 )
C
    3 DEPAV = DEP
  100 RETURN
      END

C   07/06/96 606071825  MEMBER NAME  BOOKCH   (S4)          FORTRAN
      SUBROUTINE BOOKCH(PGNAME,IVRCUR,IVROLD)
C
C     SUBROUTINE BOOKCH WITH ADDITIONAL ENTRY BOOKIN CAN BE USED
C     TO CHECK, WETHER A CERTAIN PROGRAM IS ALREADY APPLIED TO THE
C     DATA AND TO GET THE VERSION-NR, WITH WHICH THE PROCESSING WAS
C     DONE, AND TO RECORD THE PROCESSING OF A MODUL, TOGETHER WITH
C     THE USED VERSION-NR AND THE DATE OF PROCESSING.
C
C                    -------  ------
C        CALL BOOKCH('PGNAME',IVRCUR,IVROLD)
C                                    ------
C
C            'PGNAME' = NAME OF PROGRAM (2A4, LEFT ADJUSTED)
C             IVRCUR  = CURRENT VERSION-NR = DATE OF INTRODUCTION
C                       AS INTEGER OF THE FORM YYMMDD
C
C             IVROLD  = 0              IF EVENT NOT
C                                      YET PROCESSED WITH THE PROGRAM
C                     = VERSION-NR     IF ALREADY PROCCESSED
C
C
C        CALL BOOKIN
C
C             THE INFORMATION FROM THE PREVIOUS CALL TO BOOKCH IS
C             RECORDED IN A BANK ('BOOK',0) FOR THE CURRENT EVENT
C
      COMMON/BCS/IW(1)
C
C     ENTRY TO GET OLD VERSION-NR IVROLD FROM BANK (BOOK,0) FOR
C     THE PROGRAM PGNAME
C
      INTEGER PGNAME(2),IVRCUR,IVROLD
      INTEGER IDEF/0/,IENT(4),NN/0/
      LOGICAL CURR/.FALSE./
      REAL*8 DATE(2)
      LOGICAL*1 LD(8),LN(4)
      EQUIVALENCE (DATE(1),LD(1)),(NN,LN(1))
      IF(CURR) GOTO 10
      CURR=.TRUE.
C
C     DETERMINE PROCESSING DATE
C
      CALL DAY(DATE(1),DATE(2))
      IDAT=0
      DO 2 I=1,3
      II=9-3*I
      DO 2 J=1,2
      LN(4)=LD(II+J)
    2 IDAT=IDAT*10+NN-240
      IBOK=IBLN('BOOK')
C
C     STORE NEW ENTRY IN LOCAL ARRAY
C
   10 IDEF=1
      IENT(1)=PGNAME(1)
      IENT(2)=PGNAME(2)
      IENT(3)=IVRCUR
      IENT(4)=IDAT
C
C     RESET OLD VERSION-NR
C
   20 IVROLD=0
C
C     FIND BANK (BOOK,0)
C
   30 IND=IBOK+1
   32 IND=IW(IND-1)
      IF(IND.EQ.0) GOTO 100
      IF(IW(IND-2)) 32,40,100
C
C     FIND ENTRY IN BANK (BOOK,0) FOR PGNAME
C
   40 N=IW(IND)/4
      IF(N.EQ.0) GOTO 100
      JND=IND
      DO 42 I=1,N
      IF(IW(JND+1).NE.IENT(1)) GOTO 42
      IF(IW(JND+2).EQ.IENT(2)) GOTO 44
   42 JND=JND+4
      GOTO 100
   44 IVROLD=IW(JND+3)
      GOTO 100
C
C
C
      ENTRY BOOKIN
C
C     ENTRY TO ADD NEW ENTRY INTO BANK (BOOK,0) FROM LOCAL ARRAY
C
   50 IF(IDEF.EQ.0) GOTO 100
      IDEF=0
      NW=0
C
C     FIND BANK (BOOK,0)
C
   60 IND=IBOK+1
   62 IND=IW(IND-1)
      IF(IND.EQ.0) GOTO   82
      IF(IW(IND-2)) 62,70,82
C
C     FIND ENTRY IN BANK (BOOK,0) FOR PGNAME
C
   70 N=IW(IND)/4
      JND=IND
      KND=0
      IF(N.EQ.0) GOTO 82
      DO 74 I=1,N
      IF(IW(JND+1).NE.IENT(1)) GOTO 72
      IF(IW(JND+2).EQ.IENT(2)) GOTO 92
   72 IF(KND.NE.0) GOTO 74
      IF(IW(JND+1).EQ.0.AND.IW(JND+2).EQ.0) KND=JND
   74 JND=JND+4
      IF(KND.NE.0) GOTO 90
C
C     CREATE NEW BANK (BOOK,0) OR INCREASE LENGTH
C
   80 NW=IW(IND)
   82 NW=NW+12
      CALL BCRE(IND,'BOOK',0,NW,&100,IER)
      CALL BSAW(1,'BOOK')
      GOTO 70
C
C     STORE ENTRY IN BANK (BOOK,0)
C
   90 JND=KND
   92 DO 94 I=1,4
   94 IW(JND+I)=IENT(I)
C
C
C
  100 RETURN
      END

C   15/02/81 610020943  MEMBER NAME  XYFIT    (PATRECSR)    FORTRAN
          SUBROUTINE XYFIT
          IMPLICIT INTEGER*2(H)
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C--------------------------------------
C  MACRO CXYFIT .... XYFIT EQUIVALENCES
C--------------------------------------
          LOGICAL TBIT
          EQUIVALENCE(ADWRK(1),TYPE1)
          EQUIVALENCE(ADWRK(2),XSTR)
          EQUIVALENCE(ADWRK(3),YSTR)
          EQUIVALENCE(ADWRK(4),RSTR)
          EQUIVALENCE(ADWRK(5),DXSTR)
          EQUIVALENCE(ADWRK(6),DYSTR)
          EQUIVALENCE(ADWRK(7),DRSTR)
          EQUIVALENCE(ADWRK(8),TYPE2)
          EQUIVALENCE(ADWRK(9),XEND)
          EQUIVALENCE(ADWRK(10),YEND)
          EQUIVALENCE(ADWRK(11),REND)
          EQUIVALENCE(ADWRK(12),DXEND)
          EQUIVALENCE(ADWRK(13),DYEND)
          EQUIVALENCE(ADWRK(14),DREND)
          EQUIVALENCE(ADWRK(15),NPTYPE)
          EQUIVALENCE(ADWRK(16),COEFF1)
          EQUIVALENCE(ADWRK(17),COEFF2)
          EQUIVALENCE(ADWRK(18),COEFF3)
          EQUIVALENCE(ADWRK(19),COEFF4)
          EQUIVALENCE(ADWRK(20),RMSFIT)
          EQUIVALENCE(ADWRK(21),NPUSED)
          EQUIVALENCE(ADWRK(22),CURVT)
          EQUIVALENCE(ADWRK(23),DCURV)
          EQUIVALENCE(ADWRK(24),CURV1)
          EQUIVALENCE(ADWRK(25),CURV2)
CC
          INTEGER*2JTR(10),NHITIN(10)
          REAL*4CHITR(10)
          EQUIVALENCE(ADWRK(26),JTR(1))
          EQUIVALENCE(ADWRK(31),NHITIN(1))
          EQUIVALENCE(ADWRK(36),CHITR(1))
C         - - - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(45),CHITR(10))
          EQUIVALENCE(ADWRK(46),NTRTOT)
CC
          EQUIVALENCE(ADWRK(47),NHIT)
          EQUIVALENCE(ADWRK(48),NTRAK)
          EQUIVALENCE(ADWRK(49),KNTROL)
          EQUIVALENCE(ADWRK(50),ISTORY)
          LOGICAL*1LARR(4),PRINT,FATAL,BADFIT,SETFLG
          EQUIVALENCE(ADWRK(51),LARR(1),PRINT)
          EQUIVALENCE(          LARR(2),FATAL)
          EQUIVALENCE(          LARR(3),BADFIT)
          EQUIVALENCE(          LARR(4),SETFLG)
CC
          EQUIVALENCE(ADWRK(61),SP1,ISP1)
          EQUIVALENCE(ADWRK(62),SP2,ISP2)
          EQUIVALENCE(ADWRK(63),SP3,ISP3)
          EQUIVALENCE(ADWRK(64),SP4,ISP4)
          EQUIVALENCE(ADWRK(65),SP5,ISP5)
          EQUIVALENCE(ADWRK(66),SUMX)
          EQUIVALENCE(ADWRK(67),SUMY)
          EQUIVALENCE(ADWRK(68),SUMXY)
          EQUIVALENCE(ADWRK(69),SUMX2)
          EQUIVALENCE(ADWRK(70),SUMX3)
          EQUIVALENCE(ADWRK(71),SUMX4)
          EQUIVALENCE(ADWRK(72),SUMX2Y)
          EQUIVALENCE(ADWRK(73),X1)
          EQUIVALENCE(ADWRK(74),Y1)
          EQUIVALENCE(ADWRK(75),X2)
          EQUIVALENCE(ADWRK(76),Y2)
CCC
          EQUIVALENCE(ADWRK(93),NMPROG)
          EQUIVALENCE(ADWRK(94),NPTS)
C         EQUIVALENCE(ADWRK(95),NDF)
          EQUIVALENCE(ADWRK(96),XMID)
          EQUIVALENCE(ADWRK(97),YMID)
          EQUIVALENCE(ADWRK(98),SINTH)
          EQUIVALENCE(ADWRK(99),COSTH)
          EQUIVALENCE(ADWRK(100),C2)
          EQUIVALENCE(ADWRK(101),C3)
          EQUIVALENCE(ADWRK(102),C4)
          EQUIVALENCE(ADWRK(103),CURV)
          EQUIVALENCE(ADWRK(104),CHIFIT)
          EQUIVALENCE(ADWRK(105),CHICIR)
          EQUIVALENCE(ADWRK(106),XFIRST)
          EQUIVALENCE(ADWRK(107),XLAST)
          EQUIVALENCE(ADWRK(108),NGOOD)
          EQUIVALENCE(ADWRK(109),NBAD)
          EQUIVALENCE(ADWRK(110),NEXTRA)
          LOGICAL*1USED(80)
          EQUIVALENCE(ADWRK(111),USED(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(130),USED(80))
          REAL*4AX(80),AY(80)
          EQUIVALENCE(ADWRK(131),AX(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(210),AX(80))
          EQUIVALENCE(ADWRK(211),AY(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(290),AY(80))
C---------- END OF MACRO CXYFIT --------------
C
C
C-------------------------------------------------------------------
C
C       ERROR IN PARFIT: DIVISION BY ZERO IN CASE OF CURV. = 0.0
C       CURV. SET TO 1.E-8 IN THIS CASE (P. STEFFEN, 02/10/86)
C-------------------------------------------------------------------
C
C       ------------------ SUBROUTINE XYFIT   ----------------
C       ---- G.F.PEARCE .. LAST UPDATE : 1200 ON  4/02/81 ----
C
C    ROUTINE TO PERFORM A FAST PARABOLA OR CIRCLE FIT TO A GIVEN TRACK
C    IN REAL COORDINATE SPACE. THE TRACK INPUT IS PROVIDED VIA THE
C    WORKING COMMON CWORK. THIS IS BEST DONE BY THE ROUTINE FXYZ.
C
C    THE FIT RESULT IS RETURNED AS A SINGLE TRACK TRACK BANK AGAIN IN
C    THE WORKING COMMON CWORK. (REFER TO POINTERS HPTR0,HPTR9,HLDTR)
C
C    FIT HISTORY IS RETURNED AS THE FOLLOWING BIT STRUCTURE IN THE TRACK
C    HISTORY WORD :
C    BIT 31   ...  FINAL FIT WAS GOOD/BAD (BIT OFF/ON)
C    BIT 30   ...  L/R AMBIGUITIES STILL UNCERTAIN AFTER FIT (BIT ON)
C    BIT 29   ...  FIT WAS TRIED WITHOUT WORST TRACK ELEMENT (BIT ON)
C    BIT 28   ...  FIT WAS TRIED USING ONLY THE BEST TRACK ELEMENT
C    BIT 27   ...  PATROL FOUND GREATER THAN 3 NEW HITS THAT WERE ALSO
C             ...  ON ANOTHER TRACK.
C    BIT 26   ...  PATROL CALLED A RE-FIT WHICH FAILED
C
C    CONTROLLING XYFIT.
C    =================
C                     CONTROL OF THE PARAMETERS AND LIMITS USED BY
C    THIS PROGRAM IS ACHIEVED THROUGH THE ARRAY XYF IN COMMON CPATLM.
C    FOR DETAILS SEE THE INITIALISING ROUTINE INPATR.
C
C-------------------------------------------------------------------
C
C
          NTRAK = HPWRK(30)
C#######################################################################
      PRINT = .FALSE.
      IF (NTRAK.EQ.IXYF(20)) PRINT=.TRUE.
      IF (IXYF(20).LT.0.AND.NTRAK.GE.IABS(IXYF(20))) PRINT=.TRUE.
      IF (TBIT(IXYF(1),28)) PRINT=.FALSE.
      IF (PRINT) PRINT9,NTRAK,IXYF(1)
 9    FORMAT(1X,39('=')/' XYFIT - TRACK',I4,' XYF(1) = ',Z8/1X,39('='))
C#######################################################################
C
C         ===================================
C         ===================================
C         INITIALISATION AND TESTS FOR ERRORS
C         ===================================
C         ===================================
C
          ISTORY=0
          KNTROL=IXYF(1)
          SETFLG=.TRUE.
          NHIT=(HPHT9-HPHT0+1)/HLDHT
          IF(NHIT.GE.4.AND.NHIT.LE.80)GOTO20
C ERRORM 1 ---------- NOT ENOUGH HITS TO FIT --------------------------
          CALLERRORM('   XYFIT',1,NTRAK)
C         ----------------------
C         ABANDON FIT .. GIVE UP
C         ----------------------
 10       RMSFIT=1000000.
          ISTORY=LOR(ISTORY,1)
          GOTO990
C
C         =======================================
C         =======================================
C         FIT PARABOLA AND DETERMINE L/R SOLUTION
C         =======================================
C         =======================================
C
 20       CALLLRFIT
          IF(FATAL)GOTO10
          IF(.NOT.BADFIT.OR.NBAD.EQ.0)GOTO700
          IF(TBIT(KNTROL,31))GOTO700
C
C         =========================================
C         =========================================
C         TRY A FIT WITHOUT THE WORST TRACK ELEMENT
C         =========================================
C         =========================================
C
          CALLTRLCHI
C         ------------------------
C         FIND WORST TRACK ELEMENT
C         (DEMAND > 5 POINTS LEFT)
C         ------------------------
          IF(NTRTOT.LE.1)GOTO900
          CHI=0
          NTRMSK=0
          DO 420 N=1,NTRTOT
          CHITR(N)=CHITR(N)/NHITIN(N)
          IF(NHIT-NHITIN(N).LE.4)GOTO420
          IF(CHITR(N).LE.CHI)GOTO420
          CHI=CHITR(N)
          NTRMSK=JTR(N)
 420      CONTINUE
          IF(TBIT(KNTROL,27))GOTO500
C#######################################################################
      IF (PRINT) PRINT421,NTRMSK
 421  FORMAT(' ****** MASK OUT TRACK ELEMENT',I3)
C#######################################################################
C         ----------------------------
C         MASK OUT WORST TRACK ELEMENT
C         (NTRBAD) AND REPEAT THE FIT.
C         ----------------------------
          IF(NTRMSK.EQ.0)GOTO900
          IPHIT=HPHT0+10
430       ISP1=IABS(IWRK(IPHIT-2))
          IF(ISP1.EQ.NTRMSK.OR.ISP1.EQ.1000)GOTO440
          IWRK(IPHIT)=0
          GOTO450
 440      IWRK(IPHIT)=9
 450      IPHIT=IPHIT+HLDHT
          IF(IPHIT.LT.HPHT9)GOTO430
C         -----------------
C         CALL PARABOLA FIT
C         -----------------
          ISTORY=LOR(ISTORY,4)
          CALLPARFIT
          IF(FATAL)GOTO10
          IF(.NOT.BADFIT)GOTO600
C
C         ===============================
C         ===============================
C         TRY A FIT WITH ONLY THE LONGEST
C         ===============================
C         ===============================
C
 500      IF(NTRTOT.LE.2)GOTO900
          ISP1=0
          DO 530 N=1,NTRTOT
          IF(NHITIN(N)-ISP1)530,510,520
 510      IF(CHITR(N).GT.CHI)GOTO530
 520      CHI=CHITR(N)
          ISP1=NHITIN(N)
          NTRMSK=JTR(N)
 530      CONTINUE
C#######################################################################
      IF (PRINT) PRINT531,NTRMSK
 531  FORMAT(' ****** FIT ONLY TRACK ELEMENT ',I4)
C#######################################################################
          IF (ISP1.LE.4) GOTO900
C         ----------------------------------
C         MASK OUT ALL TRACK ELEMENTS EXCEPT
C         THE LONGEST (NTRGUT) AND REFIT.
C         ----------------------------------
          IPHIT=HPHT0+10
 540      ISP1=IABS(IWRK(IPHIT-2))
          IF(ISP1.EQ.NTRMSK)GOTO550
          IWRK(IPHIT)=9
          GOTO560
 550      IWRK(IPHIT)=0
 560      CONTINUE
          IPHIT=IPHIT+HLDHT
          IF(IPHIT.LT.HPHT9)GOTO540
          ISTORY=LOR(ISTORY,8)
          CALLPARFIT
          IF(FATAL)GOTO10
          IF(BADFIT)GOTO900
C
C         =======================================
C         =======================================
C         REFIT IF SOME BAD HITS WERE RECOLLECTED
C         =======================================
C         =======================================
C
 600      IF(NEXTRA.LE.IGFP(10))GOTO700
C#######################################################################
      IF (PRINT) PRINT601,NEXTRA
 601  FORMAT(' ****** REFIT WITH EXTRA POINTS .. ',I5)
C#######################################################################
          CALLPARFIT
          IF(FATAL)GOTO900
          IF(.NOT.BADFIT)GOTO600
C
C         ================================
C         ================================
C         CONVERT PARABOLA FIT INTO CIRCLE
C         ================================
C         ================================
C
 700      IF(TBIT(KNTROL,30))GOTO800
C#######################################################################
      IF (PRINT.AND.ABS(CURV).LT.XYF(6))PRINT701,CURV,XYF(6)
 701  FORMAT(' ****** NO CIRCLE FIT .. LOW CURVATURE ',2E11.4)
C#######################################################################
          IF(ABS(CURV).LT.XYF(6))GOTO800
C#######################################################################
      IF (PRINT.AND.CHIFIT.GT.XYF(10))PRINT702,CHIFIT,XYF(10)
 702  FORMAT(' ****** NO CIRCLE FIT .. BAD PARAB CHI ',2E11.4)
C#######################################################################
          IF(CHIFIT.GT.XYF(10))GOTO800
C         ----------
C         FIT CIRCLE
C         ----------
          CALLCIRFIT
          IF(.NOT.FATAL)CALLRESIDS
C
C         ===================================
C         ===================================
C         RECALCULATE ABERRATIONS IF REQUIRED
C         ===================================
C         ===================================
C
 800      IF(.NOT.TBIT(KNTROL,29))GOTO900
          IF(NGOOD.LE.3)GOTO900
          CALLNEWINC
C
C         ==================================
C         ==================================
C         LOAD RESULTS INTO CWORK TRACK BANK
C         ==================================
C         ==================================
C
 900      NPTYPE=NMPROG
          RMSFIT=SQRT(CHIFIT)
          NPUSED=NPTS
          COEFF2=XMID+C2*COSTH-C3*SINTH
          COEFF3=YMID+C2*SINTH+C3*COSTH
          X1=XFIRST-C2
          X2=XLAST-C2
          GOTO(910,950),NMPROG
C         -------------------------
C         COMPUTE CIRCLE PARAMETERS
C         CURVATURE, R0-R, EPSILON
C         -------------------------
 910      CURVT=1.0 / C4
          COEFF4=ATAN2(COEFF3,COEFF2)
          COEFF2=SQRT(COEFF2**2+COEFF3**2)-ABS(C4)
          COEFF3=COEFF4
          COEFF1=ABS(CURVT)
C         CIRCLE END POINTS AND GRADIENTS
          Y1=C4**2-X1**2
          IF(Y1.LT.0.) PRINT9991,Y1,NREC,HRUN,HEV,HPWRK(30)
 9991   FORMAT(' XYFIT .. -VE SQRT ON Y1',E11.4,4I10)
          IF(Y1.LT.0.)RMSFIT=1000000.
          IF(Y1.LT.0.)Y1=1.
          Y1=SIGN(SQRT(Y1),CURVT)
          SP1=-X1/Y1
          Y1=Y1+C3
          Y2=C4**2-X2**2
         IF(Y2.LT.0.)PRINT9992,Y2,NREC,HRUN,HEV,HPWRK(30)
 9992   FORMAT(' XYFIT .. -VE SQRT ON Y2',E11.4,4I10)
          IF(Y2.LT.0.)RMSFIT=1000000.
          IF(Y2.LT.0.)Y2=1.
          Y2=SIGN(SQRT(Y2),CURVT)
          SP2=-X2/Y2
          Y2=Y2+C3
          GOTO980
C         --------------------------------------
C         COMPUTE PARABOLA PARAMETERS
C         Y1 = C4 * X1**2
C         WHERE X1 = (X-C2)*COSTH + (Y-C3)*SINTH
C         AND   Y1 = (Y-C3)*COSTH - (X-C2)*SINTH
C         --------------------------------------
 950      COEFF1=ATAN2(SINTH,COSTH)
C         COEFF2=COEFF2
C         COEFF3=COEFF3
          COEFF4=C4
          CURVT=-2*C4
C         PARABOLA END POINTS
          Y1=C4*X1**2+C3
          Y2=C4*X2**2+C3
C         PARABOLA END DIRECTIONS
          SP1=-CURVT*X1
          SP2=-CURVT*X2
 980      CONTINUE
C         -----------------
C         FITTED END POINTS
C         -----------------
          XSTR=XFIRST*COSTH-Y1*SINTH+XMID
          YSTR=XFIRST*SINTH+Y1*COSTH+YMID
          RSTR=SQRT(XSTR**2+YSTR**2)
          XEND=XLAST*COSTH-Y2*SINTH+XMID
          YEND=XLAST*SINTH+Y2*COSTH+YMID
          REND=SQRT(XEND**2+YEND**2)
C         -----------------
C         DIRECTION COSINES
C         -----------------
          CS1 = 1. / SQRT(SP1**2 + 1.)
          SN1 = CS1 * SP1
          DXSTR=CS1*COSTH-SN1*SINTH
          DYSTR=CS1*SINTH+SN1*COSTH
          DRSTR=0
          CS2 = 1. / SQRT(SP2**2 + 1.)
          SN2 = CS2 * SP2
          DXEND=CS2*COSTH-SN2*SINTH
          DYEND=CS2*SINTH+SN2*COSTH
          DREND=0.
C         ------------------------
C         START AND END CURVATURES
C         ------------------------
          CURV1=CURVT
          CURV2=CURVT
          DCURV=0.
C         ------------------
C         TYPE OF END POINTS
C         ------------------
          TYPE1=0
          TYPE2=0
C         -------------------------
C         LOAD OUTPUT BANK IN CWORK
C         -------------------------
 990      IPHIT=HPTR0+3
          CALLMVCL(WRK(IPHIT),0,ADWRK(1),0,100)
          IPHIT=HPTR0+47
          IF(BADFIT)ISTORY=LOR(ISTORY,1)
          IWRK(IPHIT)=LOR(IWRK(IPHIT),ISTORY)
C#######################################################################
      IF (PRINT) CALL PCWORK(0,0,0,0,1)
C#######################################################################
C
C         ==========================================
C         ==========================================
C         COMPUTE TRACK ELEMENT CHI**2 FOR BACKTRACE
C         ==========================================
C         ==========================================
C
          IF(TBIT(KNTROL,28))CALLTRLCHI
          IF(TBIT(KNTROL,28))CALL MVCL(ADWRK(81),0,JTR(1),0,80)
          RETURN
          END
          SUBROUTINE LRFIT
          IMPLICIT INTEGER*2(H)
C
C
C
C
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C               DETERMINE LEFT/RIGHT AMBIGUITY BY FITTING
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C
C
C
C
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C--------------------------------------
C  MACRO CXYFIT .... XYFIT EQUIVALENCES
C--------------------------------------
          LOGICAL TBIT
          EQUIVALENCE(ADWRK(1),TYPE1)
          EQUIVALENCE(ADWRK(2),XSTR)
          EQUIVALENCE(ADWRK(3),YSTR)
          EQUIVALENCE(ADWRK(4),RSTR)
          EQUIVALENCE(ADWRK(5),DXSTR)
          EQUIVALENCE(ADWRK(6),DYSTR)
          EQUIVALENCE(ADWRK(7),DRSTR)
          EQUIVALENCE(ADWRK(8),TYPE2)
          EQUIVALENCE(ADWRK(9),XEND)
          EQUIVALENCE(ADWRK(10),YEND)
          EQUIVALENCE(ADWRK(11),REND)
          EQUIVALENCE(ADWRK(12),DXEND)
          EQUIVALENCE(ADWRK(13),DYEND)
          EQUIVALENCE(ADWRK(14),DREND)
          EQUIVALENCE(ADWRK(15),NPTYPE)
          EQUIVALENCE(ADWRK(16),COEFF1)
          EQUIVALENCE(ADWRK(17),COEFF2)
          EQUIVALENCE(ADWRK(18),COEFF3)
          EQUIVALENCE(ADWRK(19),COEFF4)
          EQUIVALENCE(ADWRK(20),RMSFIT)
          EQUIVALENCE(ADWRK(21),NPUSED)
          EQUIVALENCE(ADWRK(22),CURVT)
          EQUIVALENCE(ADWRK(23),DCURV)
          EQUIVALENCE(ADWRK(24),CURV1)
          EQUIVALENCE(ADWRK(25),CURV2)
CC
          INTEGER*2JTR(10),NHITIN(10)
          REAL*4CHITR(10)
          EQUIVALENCE(ADWRK(26),JTR(1))
          EQUIVALENCE(ADWRK(31),NHITIN(1))
          EQUIVALENCE(ADWRK(36),CHITR(1))
C         - - - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(45),CHITR(10))
          EQUIVALENCE(ADWRK(46),NTRTOT)
CC
          EQUIVALENCE(ADWRK(47),NHIT)
          EQUIVALENCE(ADWRK(48),NTRAK)
          EQUIVALENCE(ADWRK(49),KNTROL)
          EQUIVALENCE(ADWRK(50),ISTORY)
          LOGICAL*1LARR(4),PRINT,FATAL,BADFIT,SETFLG
          EQUIVALENCE(ADWRK(51),LARR(1),PRINT)
          EQUIVALENCE(          LARR(2),FATAL)
          EQUIVALENCE(          LARR(3),BADFIT)
          EQUIVALENCE(          LARR(4),SETFLG)
CC
          EQUIVALENCE(ADWRK(61),SP1,ISP1)
          EQUIVALENCE(ADWRK(62),SP2,ISP2)
          EQUIVALENCE(ADWRK(63),SP3,ISP3)
          EQUIVALENCE(ADWRK(64),SP4,ISP4)
          EQUIVALENCE(ADWRK(65),SP5,ISP5)
          EQUIVALENCE(ADWRK(66),SUMX)
          EQUIVALENCE(ADWRK(67),SUMY)
          EQUIVALENCE(ADWRK(68),SUMXY)
          EQUIVALENCE(ADWRK(69),SUMX2)
          EQUIVALENCE(ADWRK(70),SUMX3)
          EQUIVALENCE(ADWRK(71),SUMX4)
          EQUIVALENCE(ADWRK(72),SUMX2Y)
          EQUIVALENCE(ADWRK(73),X1)
          EQUIVALENCE(ADWRK(74),Y1)
          EQUIVALENCE(ADWRK(75),X2)
          EQUIVALENCE(ADWRK(76),Y2)
CCC
          EQUIVALENCE(ADWRK(93),NMPROG)
          EQUIVALENCE(ADWRK(94),NPTS)
C         EQUIVALENCE(ADWRK(95),NDF)
          EQUIVALENCE(ADWRK(96),XMID)
          EQUIVALENCE(ADWRK(97),YMID)
          EQUIVALENCE(ADWRK(98),SINTH)
          EQUIVALENCE(ADWRK(99),COSTH)
          EQUIVALENCE(ADWRK(100),C2)
          EQUIVALENCE(ADWRK(101),C3)
          EQUIVALENCE(ADWRK(102),C4)
          EQUIVALENCE(ADWRK(103),CURV)
          EQUIVALENCE(ADWRK(104),CHIFIT)
          EQUIVALENCE(ADWRK(105),CHICIR)
          EQUIVALENCE(ADWRK(106),XFIRST)
          EQUIVALENCE(ADWRK(107),XLAST)
          EQUIVALENCE(ADWRK(108),NGOOD)
          EQUIVALENCE(ADWRK(109),NBAD)
          EQUIVALENCE(ADWRK(110),NEXTRA)
          LOGICAL*1USED(80)
          EQUIVALENCE(ADWRK(111),USED(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(130),USED(80))
          REAL*4AX(80),AY(80)
          EQUIVALENCE(ADWRK(131),AX(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(210),AX(80))
          EQUIVALENCE(ADWRK(211),AY(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(290),AY(80))
C---------- END OF MACRO CXYFIT --------------
          LOGICAL*1 LRDONE
C         --------------
C         FIT SOLUTION 1
C         --------------
          SETFLG=.FALSE.
          CALLPARFIT
          SETFLG=.TRUE.
          IF(FATAL)RETURN
 6010     IF(HPHT0A.LE.0)RETURN
CONTROL BIT 26 IS TESTED IN FXYZ
          LRDONE=.FALSE.
          CHILST=CHIFIT
C         --------------
C         FIT SOLUTION 2
C         --------------
          LPHT0=HPHT0
          LPHT9=HPHT9
          HPHT0=HPHT0A
          HPHT9=HPHT9A
          CALLPARFIT
          HPHT0=LPHT0
          HPHT9=LPHT9
          IF(FATAL)GOTO6070
          IF(CHILST.LT.CHIFIT)GOTO6040
C         ---------------
C         KEEP SOLUTION 2
C         ---------------
          IPHIT=HPHT0A
          ISP1=NHIT*HLDHT*4
          CALLMVCL(WRK(LPHT0),0,WRK(IPHIT),0,ISP1)
          IF((CHILST-CHIFIT).GT.XYF(7)*CHIFIT)LRDONE=.TRUE.
          GOTO6060
C         ---------------
C         KEEP SOLUTION 1
C         ---------------
 6040     IF((CHIFIT-CHILST).GT.XYF(7)*CHILST)LRDONE=.TRUE.
          CHILST=CHIFIT
          CALLPARFIT
          IF(FATAL)GOTO6080
C         ---------------------
C         IS L/R NOW RESOLVED ?
C         ---------------------
 6060     IF(.NOT.LRDONE)ISTORY=LOR(ISTORY,2)
C#######################################################################
      IF(LRDONE.AND.PRINT) PRINT6061,CHILST,CHIFIT
 6061 FORMAT(' ****** L/R SOLNS FITTED SUCCESSFULLY ..',2F10.2)
      IF(.NOT.LRDONE.AND.PRINT)PRINT6062,CHILST,CHIFIT
 6062 FORMAT(' ****** L/R SOLNS FITTED UNSUCCESSFULLY ..',2F10.2)
C#######################################################################
          HPHT0A=-HPHT0A
          RETURN
C         --------------------
C         SOLN 2 FIT WAS FATAL
C         --------------------
 6070     FATAL=.FALSE.
C ERRORM 5 ------------ FITTING SOLN 1 IN LRFIT WAS FATAL -------------
          CALLERRORM('   XYFIT',5,NTRAK)
          CALLRESIDS
          GOTO6060
C         -------------------------
C         RECALLING FIT 1 WAS FATAL
C         -------------------------
 6080     CONTINUE
C ERRORM 6 ---------- RECALLING SOLN 1 IN LRFIT WAS FATAL -------------
          CALLERRORM('   XYFIT',6,NTRAK)
          RETURN
          END
          SUBROUTINE PARFIT
          IMPLICIT INTEGER*2(H)
C
C
C
C
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C               FORM PARABOLIC LEAST SQUARES FIT TO TRACK
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C
C
C
C
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C--------------------------------------
C  MACRO CXYFIT .... XYFIT EQUIVALENCES
C--------------------------------------
          LOGICAL TBIT
          EQUIVALENCE(ADWRK(1),TYPE1)
          EQUIVALENCE(ADWRK(2),XSTR)
          EQUIVALENCE(ADWRK(3),YSTR)
          EQUIVALENCE(ADWRK(4),RSTR)
          EQUIVALENCE(ADWRK(5),DXSTR)
          EQUIVALENCE(ADWRK(6),DYSTR)
          EQUIVALENCE(ADWRK(7),DRSTR)
          EQUIVALENCE(ADWRK(8),TYPE2)
          EQUIVALENCE(ADWRK(9),XEND)
          EQUIVALENCE(ADWRK(10),YEND)
          EQUIVALENCE(ADWRK(11),REND)
          EQUIVALENCE(ADWRK(12),DXEND)
          EQUIVALENCE(ADWRK(13),DYEND)
          EQUIVALENCE(ADWRK(14),DREND)
          EQUIVALENCE(ADWRK(15),NPTYPE)
          EQUIVALENCE(ADWRK(16),COEFF1)
          EQUIVALENCE(ADWRK(17),COEFF2)
          EQUIVALENCE(ADWRK(18),COEFF3)
          EQUIVALENCE(ADWRK(19),COEFF4)
          EQUIVALENCE(ADWRK(20),RMSFIT)
          EQUIVALENCE(ADWRK(21),NPUSED)
          EQUIVALENCE(ADWRK(22),CURVT)
          EQUIVALENCE(ADWRK(23),DCURV)
          EQUIVALENCE(ADWRK(24),CURV1)
          EQUIVALENCE(ADWRK(25),CURV2)
CC
          INTEGER*2JTR(10),NHITIN(10)
          REAL*4CHITR(10)
          EQUIVALENCE(ADWRK(26),JTR(1))
          EQUIVALENCE(ADWRK(31),NHITIN(1))
          EQUIVALENCE(ADWRK(36),CHITR(1))
C         - - - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(45),CHITR(10))
          EQUIVALENCE(ADWRK(46),NTRTOT)
CC
          EQUIVALENCE(ADWRK(47),NHIT)
          EQUIVALENCE(ADWRK(48),NTRAK)
          EQUIVALENCE(ADWRK(49),KNTROL)
          EQUIVALENCE(ADWRK(50),ISTORY)
          LOGICAL*1LARR(4),PRINT,FATAL,BADFIT,SETFLG
          EQUIVALENCE(ADWRK(51),LARR(1),PRINT)
          EQUIVALENCE(          LARR(2),FATAL)
          EQUIVALENCE(          LARR(3),BADFIT)
          EQUIVALENCE(          LARR(4),SETFLG)
CC
          EQUIVALENCE(ADWRK(61),SP1,ISP1)
          EQUIVALENCE(ADWRK(62),SP2,ISP2)
          EQUIVALENCE(ADWRK(63),SP3,ISP3)
          EQUIVALENCE(ADWRK(64),SP4,ISP4)
          EQUIVALENCE(ADWRK(65),SP5,ISP5)
          EQUIVALENCE(ADWRK(66),SUMX)
          EQUIVALENCE(ADWRK(67),SUMY)
          EQUIVALENCE(ADWRK(68),SUMXY)
          EQUIVALENCE(ADWRK(69),SUMX2)
          EQUIVALENCE(ADWRK(70),SUMX3)
          EQUIVALENCE(ADWRK(71),SUMX4)
          EQUIVALENCE(ADWRK(72),SUMX2Y)
          EQUIVALENCE(ADWRK(73),X1)
          EQUIVALENCE(ADWRK(74),Y1)
          EQUIVALENCE(ADWRK(75),X2)
          EQUIVALENCE(ADWRK(76),Y2)
CCC
          EQUIVALENCE(ADWRK(93),NMPROG)
          EQUIVALENCE(ADWRK(94),NPTS)
C         EQUIVALENCE(ADWRK(95),NDF)
          EQUIVALENCE(ADWRK(96),XMID)
          EQUIVALENCE(ADWRK(97),YMID)
          EQUIVALENCE(ADWRK(98),SINTH)
          EQUIVALENCE(ADWRK(99),COSTH)
          EQUIVALENCE(ADWRK(100),C2)
          EQUIVALENCE(ADWRK(101),C3)
          EQUIVALENCE(ADWRK(102),C4)
          EQUIVALENCE(ADWRK(103),CURV)
          EQUIVALENCE(ADWRK(104),CHIFIT)
          EQUIVALENCE(ADWRK(105),CHICIR)
          EQUIVALENCE(ADWRK(106),XFIRST)
          EQUIVALENCE(ADWRK(107),XLAST)
          EQUIVALENCE(ADWRK(108),NGOOD)
          EQUIVALENCE(ADWRK(109),NBAD)
          EQUIVALENCE(ADWRK(110),NEXTRA)
          LOGICAL*1USED(80)
          EQUIVALENCE(ADWRK(111),USED(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(130),USED(80))
          REAL*4AX(80),AY(80)
          EQUIVALENCE(ADWRK(131),AX(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(210),AX(80))
          EQUIVALENCE(ADWRK(211),AY(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(290),AY(80))
C---------- END OF MACRO CXYFIT --------------
          FATAL=.FALSE.
C         ---------------------------
C         FIND INNER AND OUTER POINTS
C         ON TRACK TO DETERMINE SLOPE
C         ---------------------------
C         OUTER POINT (BEGINNING OF ARRAY)
          IS3=0
          IS1=0
          IPHIT=HPHT0+10
 5010     IF(IWRK(IPHIT).NE.0)GOTO5020
          IS3=IS3+1
          IS2=IPHIT
          IF(IS1.EQ.0)IS1=IPHIT
 5020     IPHIT=IPHIT+HLDHT
          IF(IPHIT.LT.HPHT9)GOTO5010
          IF(IS3.GE.4)GOTO5030
C ERRORM 2 ---------- NO GOOD POINTS TO FIT ---------------------------
          IF(IS3.LE.0)CALLERRORM('   XYFIT',2,NTRAK)
C ERRORM 3 ---------- NOT ENOUGH GOOD POINTS TO FIT -------------------
          IF(IS3.GT.0)CALLERRORM('   XYFIT',3,NTRAK)
          FATAL=.TRUE.
          RETURN
 5030     CONTINUE
          XEND=WRK(IS1-7)
          YEND=WRK(IS1-6)
          XSTR=WRK(IS2-7)
          YSTR=WRK(IS2-6)
          NMPROG=2
C         --------------------------
C         EVALUATE SLOPE OF SYMMETRY
C         AXES AND ROUGH ORIGIN.
C         --------------------------
          COSTH=XEND-XSTR
          SINTH=YEND-YSTR
          XMID=(XSTR+XEND)/2
          YMID=(YSTR+YEND)/2
          SP1=1.0/SQRT(COSTH**2+SINTH**2)
          COSTH=COSTH*SP1
          SINTH=SINTH*SP1
C         -------------------------
C         TRANSFORM COORDINATES AND
C         PERFORM PARABOLIC FIT.
C         -------------------------
          ISP5=0
          SUMX=0
          SUMY=0
          SUMXY=0
          SUMX2=0
          SUMX3=0
          SUMX4=0
          SUMX2Y=0
          NPTS=0
          IPHIT=HPHT0+3
          DO 5050 N=1,NHIT
          SP2=WRK(IPHIT)-XMID
          Y1=WRK(IPHIT+1)-YMID
          X1=SP2*COSTH+Y1*SINTH
          Y1=Y1*COSTH-SP2*SINTH
          AX(N)=X1
          AY(N)=Y1
          USED(N)=.FALSE.
          IF(IWRK(IPHIT+7).NE.0)GOTO5050
          USED(N)=.TRUE.
          NPTS=NPTS+1
          SUMX=SUMX+X1
          SUMY=SUMY+Y1
          SUMXY=SUMXY+X1*Y1
          SP2=X1**2
          SUMX2=SUMX2+SP2
          SUMX3=SUMX3+X1*SP2
          SUMX4=SUMX4+SP2**2
          SUMX2Y=SUMX2Y+SP2*Y1
 5050     IPHIT=IPHIT+HLDHT
C         ---------------------------
C         COMPUTE PARABOLA PARAMETERS
C         ---------------------------
 5060     CONTINUE
          SP1=SUMX*SUMY/NPTS-SUMXY
          SP2=SUMX*SUMX2/NPTS-SUMX3
          SP3=SUMX**2/NPTS-SUMX2
          SP4=SUMX2*SUMY/NPTS-SUMX2Y
          SP5=SUMX2**2/NPTS-SUMX4
          C2=SP3*SP5-SP2**2
          C4=(SP3*SP4-SP1*SP2)/C2
C
C !!!!!   THE FOLLOWING STATEMENT INSERTED IN ORDER TO AVOID
C !!!!!   DIVISION BY ZERO 5 STATEMENTS FURTHER ON (P.STEFFEN)
          IF(ABS(C4) .LT. 1.E-8) C4 = 1.E-8
C
          C2=(SP1*SP5-SP2*SP4)/C2
          C3=(SUMY-C4*SUMX2-C2*SUMX)/NPTS
          CURV=-2*C4
          C2=C2/CURV
          C3=C3-C4*C2*C2
          NDF=NPTS-4
          ENTRYRESIDS
C
C
C
C
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C          COMPUTE CHI**2 AND HIT RESIDUALS FOR CURRENT FIT
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C
C
C
C
C    FLAG = 0 => HIT WITHIN  ACCEPTANCE CUT (CODE0)
C    FLAG = 1 => HIT OUTSIDE ACCEPTANCE CUT BUT USED IN FIT
C    FLAG = 2 => HIT OUTSIDE ACCEPTANCE CUT BUT WITHIN DOUBLE HIT RESLN
C    FLAG = 3 => HIT OUTSIDE DOUBLE HIT RESOLUTION
          NBAD=0
          NEXTRA=0
          ISP5=0
          CHIFIT=0
C         COMPUTE RESIDUAL CUT
          RADBIT=10*NPTS*ABS(CURV)
          IF(RADBIT.GT.1.0)RADBIT=1.0
          CODE0=XYF(4)+RADBIT*XYF(5)
          CODE2=GFP(3)
          CHSLIM=XYF(2)+RADBIT*XYF(3)
          IF(NMPROG.EQ.2)GOTO4001
          SP1=C4**2
          SP2=0.5/ABS(C4)
 4001     CONTINUE
          IPHIT=HPHT0+10
          DO 4050 N=1,NHIT
          X1=AX(N)
          SP3=(X1-C2)**2
          Y1=AY(N)-C3
          IF(NMPROG.EQ.2)GOTO4010
          CHI=(SP3+Y1**2-SP1)*SP2
          GOTO4020
 4010     CHI=C4*SP3-Y1
 4020     WRK(IPHIT+3)=CHI
          IF(USED(N))CHIFIT=CHIFIT+CHI**2
          IF(.NOT.SETFLG)GOTO4050
          CHI=ABS(CHI)
          IF(CHI.GT.CODE0)GOTO4030
C         GOOD RESIDUAL TO NEW FIT
          IWRK(IPHIT)=0
          IF(USED(N))GOTO4025
          NEXTRA=NEXTRA+1
          GOTO4050
 4025     XFIRST=X1
          IF(ISP5.EQ.0)ISP5=N
          GOTO4050
C         BAD RESIDUAL TO NEW FIT
 4030     IWRK(IPHIT)=2
          IF(CHI.GT.CODE2)IWRK(IPHIT)=3
          IF(.NOT.USED(N))GOTO4050
          IWRK(IPHIT)=1
          NBAD=NBAD+1
 4050     IPHIT=IPHIT+HLDHT
          IF (NDF.GT.0)CHIFIT=CHIFIT/NDF
          NGOOD=NPTS-NBAD+NEXTRA
C####################################################################
      RAD = 1.0/CURV
      IF(PRINT)PRINT4051,NMPROG,NPTS,NGOOD,NBAD,NEXTRA,RAD,
     + CODE0,CHSLIM,CHIFIT
 4051 FORMAT(' FIT ',I1,' #POINTS USED/GOOD/BAD/EXTRA =',4I3,
     +' RADIUS =',E11.4,' CODE0 =',F4.1,' CHSLIM =',F4.1,
     +'  CHI**2 =',F7.3,' ######')
      IF (PRINT) CALL PCWORK(0,0,0,1,0)
C####################################################################
          IF(ISP5.NE.0)GOTO4080
          XLAST=AX(1)
          XFIRST=AX(NHIT)
          GOTO4090
 4080     XLAST=AX(ISP5)
C         ------------------------
C         LABEL AS GOOD OR BAD FIT
C         ------------------------
 4090     BADFIT=.FALSE.
          IF(CHIFIT.GT.CHSLIM)BADFIT=.TRUE.
          RETURN
          END
          SUBROUTINE CIRFIT
          IMPLICIT INTEGER*2(H)
C
C
C
C
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C                    CIRCLE FIT USING PARABOLA
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C
C
C
C
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C--------------------------------------
C  MACRO CXYFIT .... XYFIT EQUIVALENCES
C--------------------------------------
          LOGICAL TBIT
          EQUIVALENCE(ADWRK(1),TYPE1)
          EQUIVALENCE(ADWRK(2),XSTR)
          EQUIVALENCE(ADWRK(3),YSTR)
          EQUIVALENCE(ADWRK(4),RSTR)
          EQUIVALENCE(ADWRK(5),DXSTR)
          EQUIVALENCE(ADWRK(6),DYSTR)
          EQUIVALENCE(ADWRK(7),DRSTR)
          EQUIVALENCE(ADWRK(8),TYPE2)
          EQUIVALENCE(ADWRK(9),XEND)
          EQUIVALENCE(ADWRK(10),YEND)
          EQUIVALENCE(ADWRK(11),REND)
          EQUIVALENCE(ADWRK(12),DXEND)
          EQUIVALENCE(ADWRK(13),DYEND)
          EQUIVALENCE(ADWRK(14),DREND)
          EQUIVALENCE(ADWRK(15),NPTYPE)
          EQUIVALENCE(ADWRK(16),COEFF1)
          EQUIVALENCE(ADWRK(17),COEFF2)
          EQUIVALENCE(ADWRK(18),COEFF3)
          EQUIVALENCE(ADWRK(19),COEFF4)
          EQUIVALENCE(ADWRK(20),RMSFIT)
          EQUIVALENCE(ADWRK(21),NPUSED)
          EQUIVALENCE(ADWRK(22),CURVT)
          EQUIVALENCE(ADWRK(23),DCURV)
          EQUIVALENCE(ADWRK(24),CURV1)
          EQUIVALENCE(ADWRK(25),CURV2)
CC
          INTEGER*2JTR(10),NHITIN(10)
          REAL*4CHITR(10)
          EQUIVALENCE(ADWRK(26),JTR(1))
          EQUIVALENCE(ADWRK(31),NHITIN(1))
          EQUIVALENCE(ADWRK(36),CHITR(1))
C         - - - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(45),CHITR(10))
          EQUIVALENCE(ADWRK(46),NTRTOT)
CC
          EQUIVALENCE(ADWRK(47),NHIT)
          EQUIVALENCE(ADWRK(48),NTRAK)
          EQUIVALENCE(ADWRK(49),KNTROL)
          EQUIVALENCE(ADWRK(50),ISTORY)
          LOGICAL*1LARR(4),PRINT,FATAL,BADFIT,SETFLG
          EQUIVALENCE(ADWRK(51),LARR(1),PRINT)
          EQUIVALENCE(          LARR(2),FATAL)
          EQUIVALENCE(          LARR(3),BADFIT)
          EQUIVALENCE(          LARR(4),SETFLG)
CC
          EQUIVALENCE(ADWRK(61),SP1,ISP1)
          EQUIVALENCE(ADWRK(62),SP2,ISP2)
          EQUIVALENCE(ADWRK(63),SP3,ISP3)
          EQUIVALENCE(ADWRK(64),SP4,ISP4)
          EQUIVALENCE(ADWRK(65),SP5,ISP5)
          EQUIVALENCE(ADWRK(66),SUMX)
          EQUIVALENCE(ADWRK(67),SUMY)
          EQUIVALENCE(ADWRK(68),SUMXY)
          EQUIVALENCE(ADWRK(69),SUMX2)
          EQUIVALENCE(ADWRK(70),SUMX3)
          EQUIVALENCE(ADWRK(71),SUMX4)
          EQUIVALENCE(ADWRK(72),SUMX2Y)
          EQUIVALENCE(ADWRK(73),X1)
          EQUIVALENCE(ADWRK(74),Y1)
          EQUIVALENCE(ADWRK(75),X2)
          EQUIVALENCE(ADWRK(76),Y2)
CCC
          EQUIVALENCE(ADWRK(93),NMPROG)
          EQUIVALENCE(ADWRK(94),NPTS)
C         EQUIVALENCE(ADWRK(95),NDF)
          EQUIVALENCE(ADWRK(96),XMID)
          EQUIVALENCE(ADWRK(97),YMID)
          EQUIVALENCE(ADWRK(98),SINTH)
          EQUIVALENCE(ADWRK(99),COSTH)
          EQUIVALENCE(ADWRK(100),C2)
          EQUIVALENCE(ADWRK(101),C3)
          EQUIVALENCE(ADWRK(102),C4)
          EQUIVALENCE(ADWRK(103),CURV)
          EQUIVALENCE(ADWRK(104),CHIFIT)
          EQUIVALENCE(ADWRK(105),CHICIR)
          EQUIVALENCE(ADWRK(106),XFIRST)
          EQUIVALENCE(ADWRK(107),XLAST)
          EQUIVALENCE(ADWRK(108),NGOOD)
          EQUIVALENCE(ADWRK(109),NBAD)
          EQUIVALENCE(ADWRK(110),NEXTRA)
          LOGICAL*1USED(80)
          EQUIVALENCE(ADWRK(111),USED(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(130),USED(80))
          REAL*4AX(80),AY(80)
          EQUIVALENCE(ADWRK(131),AX(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(210),AX(80))
          EQUIVALENCE(ADWRK(211),AY(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(290),AY(80))
C---------- END OF MACRO CXYFIT --------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
          FATAL=.TRUE.
C ERRORM 4 ------------ NOT ENOUGH HITS FOR CIRCLE -------------------
          IF(NPTS.LE.3)CALLERRORM('   XYFIT',4,NTRAK)
C         ---------------------------
C         START WITH INSCRIBED CIRCLE
C         ---------------------------
          NSERR=0
          IF(CURV.NE.0.0)GOTO900
C ERRORM 10 ----------- CURVATURE ZERO FROM PARFIT -------------------
          CALLERRORM('   XYFIT',10,NTRAK)
          RETURN
 900      C4C=1.0/ABS(CURV)
          C3C=C3-SIGN(C4C,CURV)
          NCLOOP=0
C         NO FIT FOR NPTS <= 4
          IF(NPTS.LE.4)GOTO1051
C         ----------------------------------
C         DETERMINE AVERAGE RADIAL DEVIATION
C         -----------------------------------
 1000     SP2=C4C**2
          DR1=0.
          CHICIR=0.
          DO 1010 N=1,NHIT
          IF(.NOT.USED(N))GOTO1010
          X1=AX(N)-C2
          Y1=AY(N)-C3C
          SP1=X1**2+Y1**2-SP2
          DR1=DR1+SP1
          CHICIR=CHICIR+SP1**2
 1010     CONTINUE
C         --------------------
C         STOP ITERATING NOW ?
C         --------------------
          IF(C4C.NE.0.0)GOTO1011
C ERRORM 11 ------------- CIRCLE FIT ERROR ZERO RADIUS --------------
          CALL ERRORM('   XYFIT',11,NTRAK)
          RETURN
 1011     CHICIR=CHICIR/(4.0*SP2*(NPTS-3))
C#######################################################################
          IF(PRINT)PRINT1012,NCLOOP,CHICIR,CHIL1,CHIFIT
 1012     FORMAT(' CIRCLE FIT LOOP',I3,1X,' CHI**2 =',F7.3,' OLD=',F7.3,
     +    ' PARAB=',F7.3)
C#######################################################################
          IF(CHICIR.LE.0.)GOTO1050
          IF(NCLOOP.EQ.0)GOTO1020
          IF(NCLOOP.GE.8)GOTO1080
          IF(CHICIR.GT.CHIL1)GOTO1070
          IF(ABS(CHICIR-CHIL1).LE.XYF(8)*CHIL1)GOTO1050
C         ------------------------------------
C         CORRECT FOR AVERAGE RADIAL DEVIATION
C         ------------------------------------
 1020     CHIL1=CHICIR
          C3CL1=C3C
          C4CL1=C4C
          NCLOOP=NCLOOP+1
          IF(C4C.NE.0.0)GOTO1021
C ERRORM 12 ------------- CIRCLE FIT ERROR,ZERO RADIUS -----------------
          CALL ERRORM('   XYFIT',12,NTRAK)
          RETURN
 1021     DR1=DR1/(2.0*C4C*NPTS)
          C4C=C4C+DR1
          C3C=C3C-SIGN(DR1,CURV)
C         -------------------------
C         FIT PARABOLA TO RESIDUALS
C         -------------------------
          SP2=C4C**2
          SP1=0.5/C4C
          SUMX=0
          SUMY=0
          SUMXY=0
          SUMX2=0
          N=NHIT
 1030     IF(.NOT.USED(N))GOTO1040
          X2=AX(N)-C2
          SP3=X2**2
          Y2=AY(N)-C3C
          Y2=-(SP3+Y2**2-SP2)*SP1
          SUMX=SUMX+X2
          SUMX2=SUMX2+SP3
          SUMXY=SUMXY+X2*Y2
          SUMY=SUMY+Y2
 1040     N=N-1
          IF(N.GT.0)GOTO1030
C         ------------------------------
C         SOLUTION FOR CIRCLE PARAMETERS
C         ------------------------------
          SPA=SUMX2*NPTS-SUMX**2
          IF( (SPA.NE.0.0).AND.(SP2.NE.0.0).AND.(X1.NE.X2) )GOTO1041
C ERRORM 14 ----------- CIRCLE FIT PARAMETER ERROR ---------------
          CALL ERRORM('   XYFIT',14,NTRAK)
          RETURN
 1041     SP1=(SUMXY*NPTS-SUMX*SUMY)/SPA
          DR2=2*C4C*(SUMY-SP1*SUMX)/NPTS
          SP3=(X2-X1)**2/(4*SP2)
          IF(SP3.GT.1.0)GOTO1060
          SP3=(1.0-SQRT(1.0-SP3))*C4C
          IF(SP3.NE.0.)GOTO1045
C ERRORM 7 ---------- TRACK START AND END ERROR -----------------------
          CALLERRORM('   XYFIT',7,NTRAK)
          RETURN
 1045     DR2=-DR2/SP3
          C4C=C4C+DR2
          C3C=C3C-SIGN(DR2,CURV)
C#######################################################################
          IF(PRINT)PRINT1046,DR1,DR2,C4C,X1,X2
 1046 FORMAT(' ..  DR1=',E11.4,' DR2=',E11.4,
     + '  RAD=',E11.4,'  FIRST/LAST PTS=',2E11.4)
C#######################################################################
          GOTO1000
C         ----------------
C         CIRCLE FIT ENDED
C         ----------------
 1050     IF(CHICIR.GT.10*CHIFIT)GOTO1090
 1051     NMPROG=1
          C3=C3C
          C4=-SIGN(C4C,C4)
          CURV=1.0/C4
          NDF=NPTS-3
          FATAL=.FALSE.
C#######################################################################
          IF(PRINT)PRINT1052,NCLOOP,NPTS,C4
 1052     FORMAT(' EXIT CIRCLE FIT AFTER',I2,' ITERATIONS. NPTS=',I3,
     +    ' RADIUS =',E11.4)
C#######################################################################
          RETURN
C         ------------------------
C         FAILURE .. SAGITTA ERROR
C         ------------------------
 1060     CONTINUE
C#######################################################################
          IF(PRINT)PRINT1061,NSERR,SP3
 1061     FORMAT(' ****** CIRCLE SAGITTA ERROR ',I4,2X,E11.4)
C#######################################################################
          IF(NSERR.GE.2)RETURN
          NSERR=NSERR+1
          C4C=ABS(X2-X1)*0.6
          C3C=C3-SIGN(C4C,CURV)
          GOTO1000
C         --------------------------
C         FAILURE .. NON-CONVERGENCE
C         --------------------------
 1070     CONTINUE
C#######################################################################
      IF (PRINT) PRINT1071,CHICIR,CHIL1,CHIFIT
 1071 FORMAT(' CIRCLE FIT NOT CONVERGING ',3E11.4)
C#######################################################################
          IF(CHIL1.GT.CHIFIT)RETURN
          C4C=C4CL1
          C3C=C3CL1
          CHICIR=CHIL1
C#######################################################################
      IF (PRINT) PRINT1076
 1076 FORMAT(' CONVERGENCE SAVED BY USING LAST ITERATION')
C#######################################################################
          GOTO1050
C         -------------------------
C         FAILURE .. TOO MANY LOOPS
C         -------------------------
 1080     IF(CHICIR.GT.CHIFIT)GOTO1050
C#######################################################################
          IF(PRINT)PRINT1081
 1081     FORMAT(' CIRCLE FIT USING TOO MANY ITERATIONS')
C#######################################################################
          RETURN
C         ----------------------------
C         FAILURE .. CHI**2 > 10*PARAB
C         ----------------------------
 1090     CONTINUE
          RETURN
          END
          SUBROUTINE NEWINC
          IMPLICIT INTEGER*2(H)
C
C
C
C
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C          ADJUST ALL HIT COORDINATES FOR NEW TRACK INCLINATION
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C
C
C
C
C%MACRO 'F11GOD.PATRECSR(CJDRCH)'
C%MACRO 'F11GOD.PATRECSR(CDSMAX)'
C%MACRO 'F11GOD.PATRECSR(CWORKPR)'
C%MACRO 'F11GOD.PATRECSR(CWORKEQ)'
C%MACRO 'F11GOD.PATRECSR(CXYFIT)'
C-- ERROR 1 ==> NEWINC COMMENTED OUT
          CALL ERRORM('NEWINC  ',1,0)
C         INTEGER*4 BIT29N/ZFFFB/
C         IF(.NOT.TBIT(KNTROL,29))RETURN
C         SP2=XMID+C2*COSTH-C3*SINTH
C         SP3=YMID+C2*SINTH+C3*COSTH
C         IPHIT=HPHT0+3
C         GOTO(2010,2020),NMPROG
C2010     R1=ABS(C4)
C         GOTO2030
C2020     R1=1.0/(2*C4)
C         SP2=SP2-R1*SINTH
C         SP3=SP3+R1*COSTH
C         R1=ABS(R1)
C2030     INCELL=IWRK(IPHIT+6)
C         INRING=IWRK(IPHIT+9)
C         IF(IWRK(IPHIT+5).GT.0)GOTO2040
C         LRFLAG=-1
C         LRAMB=1
C         GOTO2050
C2040     LRFLAG=+1
C         LRAMB=2
C2050     TRLORX=TRMATS(INCELL,LRAMB)
C         TRLORY=TRMATC(INCELL,LRAMB)
C         SINLOR=SINDRI(INCELL,LRAMB)
C         COSLOR=COSDRI(INCELL,LRAMB)
C         ISP5=INCELL-24*(INRING-1)
C         IF(INRING.EQ.3)GOTO2060
C         DXWR=DIRWR1(ISP5,1)
C         DYWR=DIRWR1(ISP5,2)
C         GOTO2070
C2060     DXWR=DIRWR3(ISP5,1)
C         DYWR=DIRWR3(ISP5,2)
C2070     TRABX=SINLOR*DXWR-COSLOR*DYWR
C         TRABY=COSLOR*DXWR+SINLOR*DYWR
C         X1=WRK(IPHIT)
C         Y1=WRK(IPHIT+1)
C         BETA=R1/ABS(TRABX*(X1-SP2)+TRABY*(Y1-SP3))
C         IF(BETA.LT.1.0)BETA=1.0
C         IF(BETA.GT.1.2)BETA=1.1
C         SP5=LRFLAG*(BETA-WRK(IPHIT+8))*2.9
C         WRK(IPHIT)=X1+TRLORX*SP5
C         WRK(IPHIT+1)=Y1+TRLORY*SP5
C         WRK(IPHIT+8)=BETA
C         IPHIT=IPHIT+HLDHT
C         IF(IPHIT.LT.HPHT9)GOTO2030
C         KNTROL=LAND(KNTROL,BIT29N)
C2090     CONTINUE
C#######################################################################
C     IF (PRINT) PRINT2091
C2091 FORMAT(' ****** ABERRATIONS CORRECTED ')
C#######################################################################
          RETURN
          END
          SUBROUTINE TRLCHI
          IMPLICIT INTEGER*2(H)
C
C
C
C
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C          COMPUTE CHI**2 CONTRIBUTION FROM EACH TRACK ELEMENT
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C
C
C
C
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C--------------------------------------
C  MACRO CXYFIT .... XYFIT EQUIVALENCES
C--------------------------------------
          LOGICAL TBIT
          EQUIVALENCE(ADWRK(1),TYPE1)
          EQUIVALENCE(ADWRK(2),XSTR)
          EQUIVALENCE(ADWRK(3),YSTR)
          EQUIVALENCE(ADWRK(4),RSTR)
          EQUIVALENCE(ADWRK(5),DXSTR)
          EQUIVALENCE(ADWRK(6),DYSTR)
          EQUIVALENCE(ADWRK(7),DRSTR)
          EQUIVALENCE(ADWRK(8),TYPE2)
          EQUIVALENCE(ADWRK(9),XEND)
          EQUIVALENCE(ADWRK(10),YEND)
          EQUIVALENCE(ADWRK(11),REND)
          EQUIVALENCE(ADWRK(12),DXEND)
          EQUIVALENCE(ADWRK(13),DYEND)
          EQUIVALENCE(ADWRK(14),DREND)
          EQUIVALENCE(ADWRK(15),NPTYPE)
          EQUIVALENCE(ADWRK(16),COEFF1)
          EQUIVALENCE(ADWRK(17),COEFF2)
          EQUIVALENCE(ADWRK(18),COEFF3)
          EQUIVALENCE(ADWRK(19),COEFF4)
          EQUIVALENCE(ADWRK(20),RMSFIT)
          EQUIVALENCE(ADWRK(21),NPUSED)
          EQUIVALENCE(ADWRK(22),CURVT)
          EQUIVALENCE(ADWRK(23),DCURV)
          EQUIVALENCE(ADWRK(24),CURV1)
          EQUIVALENCE(ADWRK(25),CURV2)
CC
          INTEGER*2JTR(10),NHITIN(10)
          REAL*4CHITR(10)
          EQUIVALENCE(ADWRK(26),JTR(1))
          EQUIVALENCE(ADWRK(31),NHITIN(1))
          EQUIVALENCE(ADWRK(36),CHITR(1))
C         - - - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(45),CHITR(10))
          EQUIVALENCE(ADWRK(46),NTRTOT)
CC
          EQUIVALENCE(ADWRK(47),NHIT)
          EQUIVALENCE(ADWRK(48),NTRAK)
          EQUIVALENCE(ADWRK(49),KNTROL)
          EQUIVALENCE(ADWRK(50),ISTORY)
          LOGICAL*1LARR(4),PRINT,FATAL,BADFIT,SETFLG
          EQUIVALENCE(ADWRK(51),LARR(1),PRINT)
          EQUIVALENCE(          LARR(2),FATAL)
          EQUIVALENCE(          LARR(3),BADFIT)
          EQUIVALENCE(          LARR(4),SETFLG)
CC
          EQUIVALENCE(ADWRK(61),SP1,ISP1)
          EQUIVALENCE(ADWRK(62),SP2,ISP2)
          EQUIVALENCE(ADWRK(63),SP3,ISP3)
          EQUIVALENCE(ADWRK(64),SP4,ISP4)
          EQUIVALENCE(ADWRK(65),SP5,ISP5)
          EQUIVALENCE(ADWRK(66),SUMX)
          EQUIVALENCE(ADWRK(67),SUMY)
          EQUIVALENCE(ADWRK(68),SUMXY)
          EQUIVALENCE(ADWRK(69),SUMX2)
          EQUIVALENCE(ADWRK(70),SUMX3)
          EQUIVALENCE(ADWRK(71),SUMX4)
          EQUIVALENCE(ADWRK(72),SUMX2Y)
          EQUIVALENCE(ADWRK(73),X1)
          EQUIVALENCE(ADWRK(74),Y1)
          EQUIVALENCE(ADWRK(75),X2)
          EQUIVALENCE(ADWRK(76),Y2)
CCC
          EQUIVALENCE(ADWRK(93),NMPROG)
          EQUIVALENCE(ADWRK(94),NPTS)
C         EQUIVALENCE(ADWRK(95),NDF)
          EQUIVALENCE(ADWRK(96),XMID)
          EQUIVALENCE(ADWRK(97),YMID)
          EQUIVALENCE(ADWRK(98),SINTH)
          EQUIVALENCE(ADWRK(99),COSTH)
          EQUIVALENCE(ADWRK(100),C2)
          EQUIVALENCE(ADWRK(101),C3)
          EQUIVALENCE(ADWRK(102),C4)
          EQUIVALENCE(ADWRK(103),CURV)
          EQUIVALENCE(ADWRK(104),CHIFIT)
          EQUIVALENCE(ADWRK(105),CHICIR)
          EQUIVALENCE(ADWRK(106),XFIRST)
          EQUIVALENCE(ADWRK(107),XLAST)
          EQUIVALENCE(ADWRK(108),NGOOD)
          EQUIVALENCE(ADWRK(109),NBAD)
          EQUIVALENCE(ADWRK(110),NEXTRA)
          LOGICAL*1USED(80)
          EQUIVALENCE(ADWRK(111),USED(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(130),USED(80))
          REAL*4AX(80),AY(80)
          EQUIVALENCE(ADWRK(131),AX(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(210),AX(80))
          EQUIVALENCE(ADWRK(211),AY(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(290),AY(80))
C---------- END OF MACRO CXYFIT --------------
          ISP2=0
          J=0
          IPHIT=HPHT0+8
 3010     ISP1=IABS(IWRK(IPHIT))
C         -----------------------
C         IGNORE 'PATROLLED' HITS
C         -----------------------
          IF(ISP1.GE.1000)GOTO3030
          IF(ISP1.EQ.ISP2)GOTO3020
C         -----------------
C         NEW TRACK ELEMENT
C         -----------------
          J=J+1
          NHITIN(J)=0
          CHITR(J)=0
          ISP2=ISP1
          JTR(J)=ISP1
C         --------------------------------
C         INCREMENT TRACK ELEMENT COUNTERS
C         --------------------------------
 3020     CHITR(J)=CHITR(J)+WRK(IPHIT+5)**2
          NHITIN(J)=NHITIN(J)+1
 3030     IPHIT=IPHIT+HLDHT
          IF(IPHIT.LT.HPHT9)GOTO3010
          NTRTOT=J
C######################################################################
      IF (PRINT) PRINT3031,(JTR(N),NHITIN(N),CHITR(N),N=1,NTRTOT)
 3031 FORMAT(' TREL CHI**2 COMPUTED ',10(I3,I3,F10.4))
C######################################################################
          RETURN
          END

C   01/11/84 411022059  MEMBER NAME  RDIEFV0  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDIEFV( EPV, NHITV, HITV, IERASV )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 07/12/82 :  SIMULATION OF INEFFICENCY
C             R. RAMCKE               IN VERTEX CHAMBER
C
C        MOD  J. HAGEMANN 12/01/84 :  INEFFICENCY NOW Z-DEPENDENT
C   LAST MOD  J. HAGEMANN 02/11/84 :  IMPROVED CODE
C
C      SET SOME HITS IN ARRAY HITV WITH NHITV HITS TO
C      ZERO TO ACOUNT FOR EFFICIENCY.
C      NUMBER OF EREASED HITS IS IERASV.
C      INEFFICENCY IS DESCRIBED BY TWO PARAMETERS:
C
C         EFF(Z) = EPV(1) - EPV(2)*(Z/Z05MX)**2
C                  ======   ======
C                                     (Z05MX = MAXIMUM HALF WIRE LENGTH)
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cjvtxc.for"
#include "cgeov.for"
C
      DIMENSION HITV(2), EPV(2)
C
C------------------  C O D E  ------------------------------------------
C
C                            INEFFIENCY-FUNCTION
C
      EFF(Z) = EPV(1) - EPV(2)*(Z/Z05MX)**2
C
      Z05MX  = ZVXCP
C
      IERASV = 0
C
      IF( EPV(1) .GT. 0.995 ) RETURN
         IF( NHITV .LE. 0 )   RETURN
C
      N4 = NHITV*4 - 3
C
      DO 1000 I = 1, N4, 4
          IF( HITV(I) .EQ. 0 ) GO TO 1000
C                            ERASE HITS ON NOT EXISTING WIRES
             IF( HITV(I) .EQ. 1 .OR. HITV(I) .EQ. 85 ) GO TO 500
C
                IAL = HITV(I+1)
                IAR = HITV(I+2)
                IF( (IAL + IAR) .GT. 0 ) GO TO 300
                   Z = 0.
                   GO TO 400
  300           Z = 0.5*ZALV*FLOAT(IAR - IAL)/FLOAT(IAR + IAL)
  400           IF( RN(DUM) .LE. EFF(Z) ) GO TO 1000
  500              HITV(I) = 0
                   IERASV = IERASV + 1
 1000 CONTINUE
      RETURN
      END

C   21/02/84 402211403  MEMBER NAME  MUCONW   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUCONW( IFLAG, LUNBOS, LUNJAD, HERR )
C-----------------------------------------------------------------------
C
C LAST CHANGE 15.50 20/02/84 C. BOWDERY   - NO ERROR IF BANKS EXIST
C      CHANGE 11.40 29/06/82 HUGH MCCANN  - ADD /CMUED/ .
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C NEW VERSION 08.34 12/06/81 HUGH MCCANN  - TO ACCOM NEW JADE SYSTEM.
C NEW VERSION 19.09 26/03/81 CHRIS BOWDERY- CHANGES ARGUMENTS
C
C
C-----------------------------------------------------------------------
C
C OUTPUTS MUON CALIBRATION DATA.
C
C               FULL SET                    IF IFLAG=1
C           CHANGES ONLY (HALF WORDS)       IF IFLAG=0
C      BOS FORMAT OUTPUT                    ON LUNBOS UNLESS SET TO 0 .
C     JADE FORMAT (SINGLE LOGICAL RECORD)   ON LUNJAD UNLESS SET TO 0 .
C
C HERR =  N    IF BOS COULD NOT CREATE BANK N ===> NO OUTPUT ATTEMPTED
C HERR = 20    IF LUNBOS = LUNJAD BUT .NE.0   ===> NO OUTPUT ATTEMPTED
C HERR = -1    WARNING:NO POSITIVE LOGICAL UNIT NO. GIVEN ===> NO OUTPUT
C HERR =  0    NORMAL RETURN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            COMMONS.
C
#include "cmubcs.for"
#include "cmucalib.for"
#include "cmuedwrk.for"
#include "cmued.for"
C
      DIMENSION IHED(9)
      DIMENSION NAME(12) , NUMBER(12) , LENGTH(12)
C
C                            DATA INITIALISATION STATEMENTS.
C
      DATA NBANKS /   12   /
      DATA MUNAME / 'MUCA' /
      DATA NAME/'MUCO','MUCD','MUOV','MFFI','MCFI','MFSU',
     +          'MCSU','MCEL','MCST','MUFI','MUYO','MUEN'/
      DATA NUMBER/  1, 0,0,  2,  3,  4,  5,   6,  7, 8, 9,10 /
      DATA LENGTH/100,16,3,370,318,246,634,2220,317,36,10,15 /
      DATA IHED(2)/0/,IHED(3)/0/,IHED(4)/0/,IHED(5)/0/,IHED(8)/0/,
     *     IHED(9)/0/
C
C------------------  C O D E  ------------------------------------------
C
      IHED(1)=MUNAME
      IHED(6)=KTIME
      IHED(7)=IFLAG
C
C                            OUTPUT ENTRY MESSAGE THEN CHECK IF
C                            LUNBOS = LUNJAD. IF SO OUTPUT ERROR
C                            MESSAGE AND RETURN UNLESS BOTH 0 .
C
      CALL MUMESS('MUCONW',0,'CALLED TO OUTPUT MUON CALIBRATION.^')
      IF(LUNBOS.NE.LUNJAD) GO TO 3
      IF(LUNBOS.EQ.0) GO TO 99
C
        CALL MUERRY('MUCONW',LUNBOS,'=LOGICAL UNIT NO.  OF BOTH JADE AND
     + BOS DATASETS. NEITHER WRITTEN.^')
      HERR=20
      RETURN
C
C                            CREATE BANKS IF NOT ALREADY EXISTING,
C                            THAT IS, ALLOW IER = 1.
C
 3    HERR=0
      DO  1  I = 1,NBANKS
        CALL CCRE(IP,NAME(I),NUMBER(I),LENGTH(I),IER)
        IF( IER .GE. 2 ) GO TO 98
        IF(I.EQ.2)  CALL UCOPY(NVERSN,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.3)  CALL UCOPY(HOVALL,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.4)  CALL UCOPY(HMFFIX,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.5)  CALL UCOPY(HMCFIX,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.6)  CALL UCOPY(HMFSUR,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.7)  CALL UCOPY(HMCSUR,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.8)  CALL UCOPY(HMCELE,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.9)  CALL UCOPY(HMCSTA,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.10) CALL UCOPY(HFILDA,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.11) CALL UCOPY(HYKNMI,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.12) CALL UCOPY(IZEII ,IDATA(IP+1),LENGTH(I))
  1   CONTINUE
C
C-----------------------------------------------------------------------
C
C                  OUTPUT BANKS.
C
C             IF LOGICAL UNIT NUMBER LUNBOS > 0 , OUTPUT BOS DATASET
C
      IF(LUNBOS.LE.0)GO TO 2
        CALL BMLT(NBANKS,NAME)
        CALL BWRITE(LUNBOS)
        CALL BDLG
        CALL MUMESS('MUCONW',LUNBOS,'=LOGICAL UNIT NO. OF BOS OUTPUT^')
C
C                            IF LOGICAL  UNIT  NUMBER  LUNJAD  >  0  ,
C                            OUTPUT A SINGLE  RECORD  OF  LENGTH  4194
C                            WORDS FOR THE JADE SYSTEM (STEFFEN)
C
 2    IF( LUNJAD .LE. 0 ) GO TO 99
      IF( IFLAG  .EQ. 0 ) GO TO 22
      NLONG = 4194
      WRITE(LUNJAD) NLONG, (IHED(I),I=1,9), (MUCAL(I),I=1,4185)
      CALL MUMESS('MUCONW',LUNJAD,'=LOGICAL UNIT NO. OF JADE OUTPUT^')
      GO TO 99
C
 22   NLONG = NCHAN + 9
      WRITE(LUNJAD) NLONG, (IHED(I),I=1,9),
     +              (HLOC(I),HUPDAT(I),I=1,NCHAN)
C
C++++++++ DEBUGGING :
C
      DO 26 I=1,NCHAN
        WRITE(6,66)HLOC(I),HUPDAT(I)
   66   FORMAT('0  LOCATION / NEW VALUE : ',2I5)
   26 CONTINUE
C
C++++++++
C
      CALL MUMESS('MUCONW',LUNJAD,'=LOGICAL UNIT NO. OF JADE OUTPUT^')
      GO TO 99
C
C                            ERROR CONDITIONS. HERR = NUMBER  OF  BANK
C                            CAUSING THE ERROR.
C
  98  CALL MUERRY('MUCONW',I,'INSUFFICIENT SPACE FOR BANK CREATION.^')
      HERR=I
C
 99   IF( LUNBOS .GT. 0 .OR. LUNJAD .GT. 0 ) RETURN
C
      CALL MUMESS('MUCONW',0,'NO OUTPUT PRODUCED AS NO POSITIVE LOGICAL
     +UNIT NUMBERS GIVEN^')
      HERR=-1
      RETURN
      END

C   10/01/82 206251143  MEMBER NAME  WFIT     (S)           FORTRAN
      SUBROUTINE FCN(NPAR,G,CHI2,X,IFLAG)
      DIMENSION G(1),X(1)
      DIMENSION S(20),CTH(20),Y(20),ERR(20)
      DIMENSION ST(20),R(20),ERRT(20)
C
      GO TO (10,20,30,40),IFLAG
C
   10 CONTINUE
      BCHI = 4.49E-5
      ZMZ0 = 90.
      DO 11 I=1,100
      READ(5,501) S(I),CTH(I),Y(I),ERR(I)
  501 FORMAT(2F10.0,2F10.3)
      IF(Y(I).LT.0.) GO TO 12
      ERR(I) = ERR(I)/Y(I)
      Y(I) = Y(I)/5.18
      ERR(I) = ERR(I)*Y(I)
      PRINT 502, S(I),CTH(I),Y(I),ERR(I)
  502 FORMAT('  DATA READ', 2F10.0,2F10.3)
   11 CONTINUE
   12 NMAX=I-1
C
C   READ TOTAL CROSS SECTION
      PRINT 504
  504 FORMAT(//'  NOW TOTAL CROSS SECTION '/)
      DO   13   I=1,3
      READ(5,501) ST(I),CZER,R(I),ERRT(I)
      ERRT(I) = ERRT(I)/R(I)
      R(I) = R(I)/86.86
      ERRT(I) = ERRT(I)*R(I)
      PRINT 502, ST(I),CZER,R(I),ERRT(I)
   13 CONTINUE
      PRINT 506
  506 FORMAT(//)
C
      X(1) = 0.006
      X(2) = 1.
      DO 15 I=1,NMAX
      PROP = 1./(S(I)/ZMZ0**2-1.)
      ACHI = S(I)*BCHI*PROP
      CTH1 = 1+CTH(I)**2
      F1 = 1.+2.*X(1)*ACHI+(X(1)+X(2))**2*ACHI*ACHI
      F2 =    4.*X(2)*ACHI+8.*X(1)*X(2)*ACHI*ACHI
      FUNK = F1*CTH1+F2*CTH(I)
      CHI=FUNK-Y(I)
      PRINT 503,I,CTH(I),Y(I),PROP,ACHI,F1,F2,FUNK,CHI
  503 FORMAT(' FUNK',I5,4F10.3,2E12.5,4F10.5)
      CHI2=CHI2+CHI**2/ERR(I)**2
   15 CONTINUE
C
      DO   16   I=1,3
      PROP = 1./(ST(I)/ZMZ0**2-1.)
      ACHI = ST(I)*BCHI*PROP
      FUNK = 1.+2.*X(1)*ACHI+(X(1)+X(2))**2*ACHI*ACHI
      CHI=FUNK-R(I)
      PRINT 505,I,ST(I),R(I),ACHI,PROP,FUNK,CHI
  505 FORMAT(' TOT CROS',I5,2F10.3,2E12.5,2F10.3)
   16 CONTINUE
      RETURN
C
   20 RETURN
C
   40 CONTINUE
      CHI2=0.
      DO 41 I=1,NMAX
      PROP = 1./(S(I)/ZMZ0**2-1.)
      ACHI = S(I)*BCHI*PROP
      CTH1 = 1+CTH(I)**2
      F1 = 1.+2.*X(1)*ACHI+(X(1)+X(2))**2*ACHI*ACHI
      F2 =    4.*X(2)*ACHI+8.*X(1)*X(2)*ACHI*ACHI
      FUNK = F1*CTH1+F2*CTH(I)
      CHI=FUNK-Y(I)
      CHI2=CHI2+CHI**2/ERR(I)**2
   41 CONTINUE
C
      DO   45   I=1,3
      PROP = 1./(ST(I)/ZMZ0**2-1.)
      ACHI = ST(I)*BCHI*PROP
      RT = 1.+2.*X(1)*ACHI+(X(1)+X(2))**2*ACHI*ACHI
      CHI=RT-R(I)
      CHI2=CHI2+CHI**2/ERRT(I)**2
   45 CONTINUE

      RETURN
C
   30 CONTINUE
C
      DO 31 I=1,NMAX
      PROP = 1./(S(I)/ZMZ0**2-1.)
      ACHI = S(I)*BCHI*PROP
      CTH1 = 1+CTH(I)**2
      F1 = 1.+2.*X(1)*ACHI+(X(1)+X(2))**2*ACHI*ACHI
      F2 =    4.*X(2)*ACHI+8.*X(1)*X(2)*ACHI*ACHI
      CALC = F1*CTH1+F2*CTH(I)
      WRITE(6,300) CTH(I),CALC,Y(I),ERR(I)
  300 FORMAT(10E11.3)
   31 CONTINUE
      RETURN
      END

C ============= MACRO CMUTNY =================================
C   /CMUTNY/
C
C CONDENSED MU-FILTER PAARAMETERS FOR USE BY APPROXIMATE SIGNAL TO
C   COORDINATE CONVERSION SUBROUTINE MUTINY.
C
C HPLANS      NO. OF CHAMBER PLANES.
C HVDRAV      AVERAGE DRIFT VELOCITY.
C HDTPAV      AVERAGE DRIFT TIME PEDESTAL.
C HLTPAV      AVERAGE LONGITUDINAL TIME DIFFERENCE PEDESTAL.
C HLSFAV      AVERAGE LONGITUDINAL SCALING FACTOR.
C
C FOR EACH CHAMBER PLANE...
C
C HLY         LAYER NUMBER.
C HOR         ORIENTATION PARAMETER:
C             =1, WIRES PARALLEL TO BEAM, AND NORMAL PARALLEL TO
C                   X-AXIS - FACES 1(-X) AND 2(+X).
C             =2, WIRES PARALLEL TO BEAM, AND NORMAL PARALLEL TO
C                   Y-AXIS - FACES 3(-Y) AND 4(+Y).
C             =3, WIRES VERTICAL, AND NORMAL PARALLEL TO Z-AXIS -
C                   FACES 5(-Z) AND 6(+Z).
C HC1         FIRST CHAMBER NUMBER.
C HCN0        NORMAL       )
C HCL0        LONGITUDINAL )  COORDINATE OF 'ORIGIN' OF CHAMBER PLANE.
C HCT0        TRANSVERSE   )
C HSP         AVERAGE SPACING OF CHAMBERS.
C
C   (THE 'ORIGIN' IS AT ONE END OF THE WIRE OF THE FIRST CHAMBER IN THE
C PLANE.  THE END IS THAT WITH THE LOWEST LONGITUDINAL COORDINATE.)
C
      COMMON /CMUTNY/HPLANS,HVDRAV,HDTPAV,HLTPAV,HLSFAV,
     * HLY(48),HOR(48),HC1(48),HCN0(48),HCL0(48),HCT0(48),HSP(48)
C  ========= ENDMACRO CMUTNY =======================================

C   24/05/79 002210653  MEMBER NAME  PRALGN   (SOURCE)      FORTRAN
      SUBROUTINE PRALGN(LORN,J,MM)
C
C     S.YAMADA      24-05-79   11:30
C                   09-09-79   03:30 Y.WATANABE
C---- DUMP THE LEAD GLASS ADC BANK('ALGN') TO LP
C
C---- LORN=0  FOR 'ALGL'/0,  LORN=1 FOR 'ALGN'/1
C
C---- THE ADDRESS PART IS DECODED ACCORDING TO THE INPUT J
C     J=0, NO DECODING
C     J=1,FOR INPUT CODE I.E. CRATE-SLOT-SUBADDRESS
C     J=2,FOR POSITION CODE I.E. IPHI-IZ FOR THE BARREL PART
C                           I.E. TOP/BOTTOM-NUM FOR THE ENDCAP
C
C---- MM IS NO. OF DATA TO BE PRINTED IN A LINE.
C     THIS ARGUMENT IS PREPARED TO USE THE SUBROUTINE BOTH FOR
C     LP AND OTHER DISPLAY DEVICES.
C
      IMPLICIT INTEGER *2 (H)
#include "cdata.for"
C
      DIMENSION ICL(8),ISLL(8),NSUBL(8),LGL(8),AL(2),NL(2)
      DIMENSION IPHIL(10),IZL(10)
      DATA AL/4HALGL,4HALGN/
C
C---- GET THE POINTER
      DATA INITP/0/
      IF(INITP.GT.0) GO TO 5
      INITP=1
      NL(1)= IBLN(AL(1))
      NL(2)= IBLN(AL(2))
5     CONTINUE
      LO=LORN+1
      IF(LO.LT.1) LO=1
      IF(LO.GT.2) LO=2
C     CALL CLOC(NPLG,AL(LO),NL(LO))
      NPLG=IDATA(NL(LO))
C
      IF(NPLG.LE.0) GO TO 90
      NNPLG = 2*NPLG
      LNG = IDATA(NPLG)
      N1 = NNPLG+1
      N6 = NNPLG+6
C
      NLNG = LNG-3
      WRITE(6,600) AL(LO),NL(LO),NLNG,(HDATA(NH),NH=N1,N6)
  600 FORMAT('0 DUMP OF ',A4,1H/,I1,2X,'NO.OF DATA=',I4,
     $ 5X,'HNORD,HNORML=',2I6,5X,'POINTER=',4I5)
C
      IF(J-1) 1,2,3
    1 WRITE(6,601)
  601 FORMAT(' NONDECODED ADDRESS PART /PULSE HEIGHT')
      GO TO 4
    2 WRITE(6,602)
  602 FORMAT(' DECODED ADDRES, CRATE-SLOT-SUBADDRESS /PULSE HEIGHT')
      GO TO 4
    3 WRITE(6,603)
  603 FORMAT(' DECODED ADDRESS,IPHI-IZ OR TOP/BOT-NUM /PULSE HEIGHT')
C
C---- GET THE NO.OF REPETITION
    4 M = MM
      IF(M.LT.1) M = 1
      IF(M.GT.10) M = 10
      IF(J.GT.0.AND.M.GT.8) M = 8
      N = NLNG/M
      NR = NLNG-M*N
      N1 = N
      IF(NR.GT.0) N1 = N1+1
      NS = 1-M
        DO 10 NN=1,N1
        NS = NS+M
        NE = NS+M-1
        IS = NNPLG+5+2*NS
        IE = IS+2*M-1
        IF(NN.EQ.N1.AND.NR.GT.0) IE = IS+2*NR-1
        IF(NN.EQ.N1.AND.NR.GT.0) NE = NS+NR-1
C
        IF(J-1) 11,12,13
C
   11   WRITE(6,611) NS,(HDATA(NH),NH=IS,IE)
  611   FORMAT(' ',I3,10(I6,1H/,I5))
        GO TO 10
C
C-----  CRATE-SLOT-SUBADDRESS
   12     DO 120 NW=NS,NE
          ID = HDATA(NNPLG+5+2*NW)
          IW = ID/48
          NSUB = ID-48*IW
          IC = IW/20
          ISL = IW-20*IC
          INDX = NW-NS+1
          ICL(INDX) = IC
          ISLL(INDX) = ISL
          NSUBL(INDX) = NSUB
          LGL(INDX) = HDATA(NNPLG+6+2*NW)
  120     CONTINUE
        WRITE(6,612) NS,(ICL(NW),ISLL(NW),NSUBL(NW),LGL(NW),NW=1,INDX)
  612   FORMAT(' ',I3,8(I3,1H-,I2,1H-,I2,1H/,I5))
        GO TO 10
C----   POSITION   IPHI-IZ OR TOP/BOT-NUM
   13     DO 13  0 NW=NS,NE
          ID = HDATA(NNPLG+5+2*NW)
          IF(ID.GE.2688) GO TO 131
          IPHI = ID/32
          IZ = ID-32*IPHI
          GO TO 133
  131     IZ = ID-2687
          IF(IZ.GE.96) GO TO 132
          IPHI = 90
          GO TO 133
  132     IZ = IZ-96
          IPHI = 91
  133     INDX = NW-NS+1
          IPHIL(INDX) = IPHI
          IZL(INDX) = IZ
          LGL(INDX) = HDATA(NNPLG+6+2*NW)
  130     CONTINUE
        WRITE(6,613) NS,(IPHIL(NW),IZL(NW),LGL(NW),NW=1,INDX)
  613   FORMAT(' ',I3, 8(I4,1H-,I2,1H/,I5))
   10   CONTINUE
      RETURN
   90 WRITE(6,690) AL(LO),NL(LO)
  690 FORMAT('0  (PRALGN)',A4,1H/,I1,'  DOES NOT EXIST.')
      RETURN
      END

      SUBROUTINE CBTREL(IPR1,IPR2)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cworkpr.for"
#include "cworkeq.for"
      DIMENSION IPC(12), IAUX(8),RAUX(8),HAUX(2,8)
      EQUIVALENCE (IAUX(1),HAUX(1,1))
      INTEGER*2 HZW(2)
      EQUIVALENCE (HZW(1),IZW,HZW1) , (HZW(2),HZW2)
      COMMON /CPTSLM/ BKTRLM(20)
                      INTEGER LMBKTR(20)
                      REAL CBTRLM(10)
                      EQUIVALENCE (BKTRLM(11),LMBKTR(11),CBTRLM(1))
      IPTR0 = HPTE0
      IPTR9 = HPTE9
      LDTRK = HLDTE
      NPR  = 0
      NPR9 = MIN0(IPR2,100)
      IF(IPR1.EQ.0) NPR9 = 0
      DO 13000 IPTR = IPTR0,IPTR9,LDTRK
        ICELL = IWRK(IPTR   )
        LBTREL= IWRK(IPTR+19)
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
        RMSMIN = 1000.
        ALGHT1 = 0.
        ALGHT2 = 200.
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - RMSMIN.GT.CBTRLM(4)
     -)THEN
          IPC( 5) = 0
          IPC( 6) = 0
          IPC( 7) = 0
          IPC( 8) = 0
          IPC( 9) = IPC( 1)
          IPC(10) = IPC( 2)
          IPC(11) = IPC( 3)
          IPC(12) = IPC( 4)
          ALGHT2 = 400.
      ASSIGN 17004 TO IZZZ02
      GOTO 17002
17004 CONTINUE
      ENDIF
13000 CONTINUE
13001 CONTINUE
      ASSIGN 17006 TO IZZZ03
      GOTO 17005
17006 CONTINUE
      RETURN
17000 CONTINUE
      IF(
     - ICELL.LE.24
     -)THEN
      IF(
     - ICELL.EQ.1
     -)THEN
            IPC( 5) = IPTR0
            IPC( 6) = IPTR0 + (HNTCEL( 3)-2)*LDTRK
            IPC( 7) = IPTR0 + (HNTCEL(24)-1)*LDTRK
            IPC( 8) = IPTR0 + (HNTCEL(25)-2)*LDTRK
            IPC( 9) = IPTR0 + (HNTCEL(25)-1)*LDTRK
            IPC(10) = IPTR0 + (HNTCEL(27)-2)*LDTRK
            IPC(11) = IPTR0 + (HNTCEL(48)-1)*LDTRK
            IPC(12) = IPTR0 + (HNTCEL(49)-2)*LDTRK
            IPC( 1) = IPTR0 + (HNTCEL(49)-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(53)-2)*LDTRK
            IPC( 3) = IPTR0 + (HNTCEL(95)-1)*LDTRK
            IPC( 4) = IPTR0 + (HNTCEL(97)-2)*LDTRK
      ELSE
      IF(
     - ICELL.LT.24
     -)THEN
            IPC( 5) = IPTR0 + (HNTCEL(ICELL- 1)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(ICELL+ 2)-2)*LDTRK
            IPC( 7) = 0
            IPC( 8) = 0
            IPC( 9) = IPTR0 + (HNTCEL(ICELL+23)-1)*LDTRK
            IPC(10) = IPTR0 + (HNTCEL(ICELL+26)-2)*LDTRK
            IPC(11) = 0
            IPC(12) = 0
            ICLL3 = ICELL*2 + 46
            IPC( 1) = IPTR0 + (HNTCEL(ICLL3-1)-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(ICLL3+5)-2)*LDTRK
            IPC( 3) = 0
            IPC( 4) = 0
      ELSE
            IPC( 5) = IPTR0 + (HNTCEL(23)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(25)-2)*LDTRK
            IPC( 7) = IPTR0
            IPC( 8) = IPTR0 + (HNTCEL( 2)-2)*LDTRK
            IPC( 9) = IPTR0 + (HNTCEL(47)-1)*LDTRK
            IPC(10) = IPTR0 + (HNTCEL(49)-2)*LDTRK
            IPC(11) = IPTR0 + (HNTCEL(25)-1)*LDTRK
            IPC(12) = IPTR0 + (HNTCEL(26)-2)*LDTRK
            IPC( 1) = IPTR0 + (HNTCEL(93)-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(97)-2)*LDTRK
            IPC( 3) = IPTR0 + (HNTCEL(49)-1)*LDTRK
            IPC( 4) = IPTR0 + (HNTCEL(51)-2)*LDTRK
      ENDIF
      ENDIF
      ELSE
      IF(
     - ICELL.LE.48
     -)THEN
      IF(
     - ICELL.EQ.25
     -)THEN
            IPC( 1) = IPTR0
            IPC( 2) = IPTR0 + (HNTCEL( 3)-2)*LDTRK
            IPC( 3) = IPTR0 + (HNTCEL(24)-1)*LDTRK
            IPC( 4) = IPTR0 + (HNTCEL(25)-2)*LDTRK
            IPC( 5) = IPTR0 + (HNTCEL(25)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(27)-2)*LDTRK
            IPC( 7) = IPTR0 + (HNTCEL(48)-1)*LDTRK
            IPC( 8) = IPTR0 + (HNTCEL(49)-2)*LDTRK
            IPC( 9) = IPTR0 + (HNTCEL(49)-1)*LDTRK
            IPC(10) = IPTR0 + (HNTCEL(53)-2)*LDTRK
            IPC(11) = IPTR0 + (HNTCEL(95)-1)*LDTRK
            IPC(12) = IPTR0 + (HNTCEL(97)-2)*LDTRK
      ELSE
      IF(
     - ICELL.LT.48
     -)THEN
            IPC( 1) = IPTR0 + (HNTCEL(ICELL-25)-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(ICELL-22)-2)*LDTRK
            IPC( 3) = 0
            IPC( 4) = 0
            IPC( 5) = IPTR0 + (HNTCEL(ICELL- 1)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(ICELL+ 2)-2)*LDTRK
            IPC( 7) = 0
            IPC( 8) = 0
            ICLL3 = (ICELL-24)*2 + 46
            IPC( 9) = IPTR0 + (HNTCEL(ICLL3-1)-1)*LDTRK
            IPC(10) = IPTR0 + (HNTCEL(ICLL3+5)-2)*LDTRK
            IPC(11) = 0
            IPC(12) = 0
      ELSE
            IPC( 1) = IPTR0 + (HNTCEL(23)-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(25)-2)*LDTRK
            IPC( 3) = IPTR0
            IPC( 4) = IPTR0 + (HNTCEL( 2)-2)*LDTRK
            IPC( 5) = IPTR0 + (HNTCEL(47)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(49)-2)*LDTRK
            IPC( 7) = IPTR0 + (HNTCEL(25)-1)*LDTRK
            IPC( 8) = IPTR0 + (HNTCEL(26)-2)*LDTRK
            IPC( 9) = IPTR0 + (HNTCEL(93)-1)*LDTRK
            IPC(10) = IPTR0 + (HNTCEL(97)-2)*LDTRK
            IPC(11) = IPTR0 + (HNTCEL(49)-1)*LDTRK
            IPC(12) = IPTR0 + (HNTCEL(51)-2)*LDTRK
      ENDIF
      ENDIF
      ELSE
          IPC( 9) = 0
          IPC(10) = 0
          IPC(11) = 0
          IPC(12) = 0
      IF(
     - ICELL.EQ.49
     -)THEN
            IPC( 1) = IPTR0 + (HNTCEL(48)-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(49)-2)*LDTRK
            IPC( 3) = IPTR0 + (HNTCEL(25)-1)*LDTRK
            IPC( 4) = IPTR0 + (HNTCEL(26)-2)*LDTRK
            IPC( 5) = IPTR0 + (HNTCEL(49)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(51)-2)*LDTRK
            IPC( 7) = IPTR0 + (HNTCEL(96)-1)*LDTRK
            IPC( 8) = IPTR0 + (HNTCEL(97)-2)*LDTRK
      ELSE
      IF(
     - ICELL.LT.96
     -)THEN
            ICLL2 = (ICELL-50)/2 + 25
            IPC( 1) = IPTR0 + (HNTCEL(ICLL2   )-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(ICLL2+ 2)-2)*LDTRK
            IPC( 3) = 0
            IPC( 4) = 0
            IPC( 5) = IPTR0 + (HNTCEL(ICELL- 1)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(ICELL+ 2)-2)*LDTRK
            IPC( 7) = 0
            IPC( 8) = 0
      ELSE
            IPC( 1) = IPTR0 + (HNTCEL(48)-1)*LDTRK
            IPC( 2) = IPTR0 + (HNTCEL(49)-2)*LDTRK
            IPC( 3) = IPTR0 + (HNTCEL(25)-1)*LDTRK
            IPC( 4) = IPTR0 + (HNTCEL(26)-2)*LDTRK
            IPC( 5) = IPTR0 + (HNTCEL(95)-1)*LDTRK
            IPC( 6) = IPTR0 + (HNTCEL(97)-2)*LDTRK
            IPC( 7) = IPTR0 + (HNTCEL(49)-1)*LDTRK
            IPC( 8) = IPTR0 + (HNTCEL(50)-2)*LDTRK
      ENDIF
      ENDIF
      ENDIF
      ENDIF
        IF(IPC( 1).GT.IPC( 2)) IPC( 1) = 0
        IF(IPC( 3).GT.IPC( 4)) IPC( 3) = 0
        IF(IPC( 5).EQ.IPC( 6)) IPC( 5) = 0
        IF(IPC( 7).GT.IPC( 8)) IPC( 7) = 0
        IF(IPC( 9).GT.IPC(10)) IPC( 9) = 0
        IF(IPC(11).GT.IPC(12)) IPC(11) = 0
      GOTO IZZZ01
17002 CONTINUE
        JPTRI = IPTR
        LRFLGI = ISHFTR(LBTREL,10)
        LRFLGI = LAND(LRFLGI,3)
        XXIM = AMIN1(ABS(WRK(JPTRI+11)),ABS(WRK(JPTRI+15)))
        YYIM = AMIN1(ABS(WRK(JPTRI+12)),ABS(WRK(JPTRI+16)))
        ICLOOP = 5
16000 CONTINUE
      IF(
     - IPC(ICLOOP).GT.0
     -)THEN
            JPTRO = IPC(ICLOOP  )
            JPTR9 = IPC(ICLOOP+1)
15000 CONTINUE
      IF(
     - JPTRO.LE.JPTR9
     -)THEN
      IF(
     - JPTRO.NE.JPTRI
     -)THEN
                NCAND = 255
      IF(
     - ABS(XXIM).GT.ABS(YYIM)
     -)THEN
                  XXOM = AMAX1(ABS(WRK(JPTRO+ 3)),ABS(WRK(JPTRO+ 7)))
                  IF(XXOM-XXIM .GT. CBTRLM(1)) NCAND=0
      ELSE
                  YYOM = AMAX1(ABS(WRK(JPTRO+ 4)),ABS(WRK(JPTRO+ 8)))
                  IF(YYOM-YYIM .GT. CBTRLM(1)) NCAND=0
      ENDIF
      IF(
     - NCAND.EQ.0
     -)THEN
                  NCOMB = 0
                  JCLLI = IWRK(JPTRI)
                  IF(JCLLI.GT.48) JCLLI = ISHFTR(JCLLI-46,1)
                  IF(JCLLI.GT.24) JCLLI = JCLLI - 24
                  JCLLO = IWRK(JPTRO)
                  IF(JCLLO.GT.48) JCLLO = ISHFTR(JCLLO-46,1)
                  IF(JCLLO.GT.24) JCLLO = JCLLO - 24
      IF(
     - IABS(JCLLO-JCLLI).EQ.0
     -)THEN
                    DRLIM = CBTRLM(2)
                    DANGL = CBTRLM(3)
      ELSE
                    DRLIM = CBTRLM(6)
                    DANGL = CBTRLM(7)
      ENDIF
                  ALGHT0 = ALGHT1
                  IF(ICLOOP.GE.9) ALGHT0 = ALGHT2
                  LRFLGO = ISHFTR(IWRK(JPTRO+19),10)
                  LRFLGO = LAND(LRFLGO,3)
                  LRFLIO = LRFLGI + LRFLGO*4
                  LBLR = 0
                  RMSMZW = 1000.
      IZZZSE            =LRFLIO
      GOTO 14002
14003 CONTINUE
                    LRFLAG = 1
      ASSIGN 17008 TO IZZZ04
      GOTO 17007
17008 CONTINUE
                    LBLR = 1
      GOTO 14001
14004 CONTINUE
                    LRFLAG = 2
      ASSIGN 17009 TO IZZZ04
      GOTO 17007
17009 CONTINUE
                    LBLR = 2
      GOTO 14001
14005 CONTINUE
                    LRFLAG = 1
      ASSIGN 17010 TO IZZZ04
      GOTO 17007
17010 CONTINUE
                    LRFLAG = 2
      ASSIGN 17011 TO IZZZ04
      GOTO 17007
17011 CONTINUE
                    LBLR = 3
      GOTO 14001
14006 CONTINUE
                    LRFLAG = 3
      ASSIGN 17012 TO IZZZ04
      GOTO 17007
17012 CONTINUE
                    LBLR = 4
      GOTO 14001
14007 CONTINUE
                    LRFLAG = 4
      ASSIGN 17013 TO IZZZ04
      GOTO 17007
17013 CONTINUE
                    LBLR = 8
      GOTO 14001
14008 CONTINUE
                    LRFLAG = 3
      ASSIGN 17014 TO IZZZ04
      GOTO 17007
17014 CONTINUE
                    LRFLAG = 4
      ASSIGN 17015 TO IZZZ04
      GOTO 17007
17015 CONTINUE
                    LBLR = 12
      GOTO 14001
14009 CONTINUE
                    LRFLAG = 1
      ASSIGN 17016 TO IZZZ04
      GOTO 17007
17016 CONTINUE
                    LRFLAG = 3
      ASSIGN 17017 TO IZZZ04
      GOTO 17007
17017 CONTINUE
                    LBLR = 5
      GOTO 14001
14010 CONTINUE
                    LRFLAG = 2
      ASSIGN 17018 TO IZZZ04
      GOTO 17007
17018 CONTINUE
                    LRFLAG = 4
      ASSIGN 17019 TO IZZZ04
      GOTO 17007
17019 CONTINUE
                    LBLR = 10
      GOTO 14001
14002 CONTINUE
      GOTO(
     -14000,14000,14000,14000,14003,14004,14005,14000,14006,14007,14008,
     -14000,14009,14010
     -), IZZZSE
14000 CONTINUE
14001 CONTINUE
      IF(
     - RMSMZW.GT.CBTRLM(4)
     -)THEN
                    IF(RMSMZW.LE.CBTRLM(5)) NCOMB = 0
      IF(
     - LAND(LBLR,1).EQ.0
     -)THEN
                      LRFLAG = 1
      ASSIGN 17020 TO IZZZ04
      GOTO 17007
17020 CONTINUE
      ENDIF
      IF(
     - LAND(LBLR,2).EQ.0
     -)THEN
                      LRFLAG = 2
      ASSIGN 17021 TO IZZZ04
      GOTO 17007
17021 CONTINUE
      ENDIF
      IF(
     - LAND(LBLR,4).EQ.0
     -)THEN
                      LRFLAG = 3
      ASSIGN 17022 TO IZZZ04
      GOTO 17007
17022 CONTINUE
      ENDIF
      IF(
     - LAND(LBLR,8).EQ.0
     -)THEN
                      LRFLAG = 4
      ASSIGN 17023 TO IZZZ04
      GOTO 17007
17023 CONTINUE
      ENDIF
      ENDIF
              IF(RMSMZW.LT.RMSMIN) RMSMIN = RMSMZW
      ENDIF
      ENDIF
              JPTRO = JPTRO + LDTRK
      GOTO 15000
      ENDIF
15001 CONTINUE
      ENDIF
          ICLOOP = ICLOOP + 2
      IF(.NOT.(
     - ICLOOP.GE.12
     -))GOTO 16000
16001 CONTINUE
      GOTO IZZZ02
17007 CONTINUE
      IZZZSE  =LRFLAG
      GOTO 14013
14014 CONTINUE
          JPTII = JPTRI+3
          JPTIO = JPTRI+11
          JPTOI = JPTRO+3
          JPTOO = JPTRO+11
      GOTO 14012
14015 CONTINUE
          JPTII = JPTRI+7
          JPTIO = JPTRI+15
          JPTOI = JPTRO+3
          JPTOO = JPTRO+11
      GOTO 14012
14016 CONTINUE
          JPTII = JPTRI+3
          JPTIO = JPTRI+11
          JPTOI = JPTRO+7
          JPTOO = JPTRO+15
      GOTO 14012
14017 CONTINUE
          JPTII = JPTRI+7
          JPTIO = JPTRI+15
          JPTOI = JPTRO+7
          JPTOO = JPTRO+15
      GOTO 14012
14013 CONTINUE
      GOTO(
     -14014,14015,14016,14017
     -), IZZZSE
14011 CONTINUE
14012 CONTINUE
        XXII = WRK(JPTII   )
        YYII = WRK(JPTII+ 1)
        DXII = WRK(JPTII+ 2)
        DYII = WRK(JPTII+ 3)
        XXOI = WRK(JPTOI   )
        YYOI = WRK(JPTOI+ 1)
        DXOI = WRK(JPTOI+ 2)
        DYOI = WRK(JPTOI+ 3)
        XXIO = WRK(JPTIO   )
        YYIO = WRK(JPTIO+ 1)
        DXIO = WRK(JPTIO+ 2)
        DYIO = WRK(JPTIO+ 3)
        XXOO = WRK(JPTOO   )
        YYOO = WRK(JPTOO+ 1)
        DXOO = WRK(JPTOO+ 2)
        DYOO = WRK(JPTOO+ 3)
16002 CONTINUE
          ZW1 = (XXII-XXOI)**2 + (YYII-YYOI)**2
          ZW2 = (XXOO-XXIO)**2 + (YYOO-YYIO)**2
          ZW0 = (XXII-XXOO)**2 + (YYII-YYOO)**2
      IF(
     - ZW1.GT.ZW0 .OR. ZW2.GT.ZW0
     -)THEN
      GOTO 16003
      ENDIF
          XOA = ( XXII + XXOO ) *.5
          YOA = ( YYII + YYOO ) *.5
          COSTH = XXOO - XXII
          SINTH = YYOO - YYII
          ZWZ = SQRT(COSTH**2+SINTH**2)
          COSTH = COSTH / ZWZ
          SINTH = SINTH / ZWZ
          XX = XXII - XOA
          YY = YYII - YOA
          YT1 = 0.
          XT1 =-.5*ZWZ
          XX = XXIO - XOA
          YY = YYIO - YOA
          YT2 = YY * COSTH - XX * SINTH
          XT2 = XX * COSTH + YY * SINTH
          XX = XXOI - XOA
          YY = YYOI - YOA
          YT3 = YY * COSTH - XX * SINTH
          XT3 = XX * COSTH + YY * SINTH
          XX = XXOO - XOA
          YY = YYOO - YOA
          YT4 = 0.
          XT4 =-XT1
      IF(
     - ABS(XT2).LT.ABS(XT3)
     -)THEN
            X1 = XT1
            Y1 = YT1
            X2 = XT2
            XC = XT2
            Y2 = YT2
            YC = YT2
            XL = XT3
            YL = YT3
      ELSE
            X1 = XT3
            XC = XT3
            Y1 = YT3
            YC = YT3
            X2 = XT4
            Y2 = YT4
            XL = XT2
            YL = YT2
      ENDIF
          X0 = 0.
          Y0 = 1000000.
          DY = Y2 - Y1
          IF(ABS(DY).GT..01)
     *       Y0 = ((X2-X1)*(X2+X1)/DY + Y2+Y1)*.5
          T  = Y0 - YC
          R0 = ABS(T)
          CHARGE = SIGN(1.,T)
          R0 = .5*(R0 + ((Y0-YC)**2+XC**2) / R0)
          DR0 = (XL**2-XC**2 + (Y0-YL)**2-(Y0-YC)**2)*.5/R0
          DSQ = .75*DR0**2
          XCIRC = X0*COSTH - Y0*SINTH + XOA
          YCIRC = Y0*COSTH + X0*SINTH + YOA
          ALGHT = ABS(XT1)*2.
          ALRAT = AMAX1(ALGHT,ALGHT0) / R0
          DRLIM1 = AMAX1(ALRAT,1.)*CBTRLM(4) + DRLIM
      IF(JPTRI.GE.IPR1) NPR = NPR + 1
      IF(
     - ABS(DR0).GT.DRLIM1
     -)THEN
      GOTO 16003
      ENDIF
          NCAND = 2
      IF(
     - ABS(XXIO-XCIRC).LT.ABS(YYIO-YCIRC)
     -)THEN
            TG1  = DYII / DXII
            TGC1 =-(XXII-XCIRC) / (YYII-YCIRC)
            TG2  = DYIO / DXIO
            TGC2 =-(XXIO-XCIRC) / (YYIO-YCIRC)
            TG3  = DYOI / DXOI
            TGC3 =-(XXOI-XCIRC) / (YYOI-YCIRC)
            TG4  = DYOO / DXOO
            TGC4 =-(XXOO-XCIRC) / (YYOO-YCIRC)
      ELSE
            TG1  = DXII / DYII
            TGC1 =-(YYII-YCIRC) / (XXII-XCIRC)
            TG2  = DXIO / DYIO
            TGC2 =-(YYIO-YCIRC) / (XXIO-XCIRC)
            TG3  = DXOI / DYOI
            TGC3 =-(YYOI-YCIRC) / (XXOI-XCIRC)
            TG4  = DXOO / DYOO
            TGC4 =-(YYOO-YCIRC) / (XXOO-XCIRC)
      ENDIF
          DLTS1 = (TG1-TGC1) / (1.+TG1*TGC1)
          DLTS2 = (TG2-TGC2) / (1.+TG2*TGC2)
          DLTS3 = (TG3-TGC3) / (1.+TG3*TGC3)
          DLTS4 = (TG4-TGC4) / (1.+TG4*TGC4)
          DLTSQ1 = DLTS1**2
          DLTSQ2 = DLTS2**2
          DLTSQ3 = DLTS3**2
          DLTSQ4 = DLTS4**2
          DELTSQ = DLTSQ1 + DLTSQ2 + DLTSQ3 + DLTSQ4
      IF(
     - AMAX1(DLTSQ1,DLTSQ2,DLTSQ3,DLTSQ4).GT.DANGL
     -)THEN
      GOTO 16003
      ENDIF
          RMS = (DSQ/.06 + DELTSQ/.0020) * .2
          IF(RMS.LT.RMSMZW) RMSMZW = RMS
          NCAND = RMS
          IF(NCAND.GE.256) NCAND = 255
      IF(
     - IWRK(JPTRO+20).LT.8 .AND.
     ?       IWRK(JPTRI+21).LT.8 .AND. NCOMB.LT.2
     -)THEN
            NCOMB = NCOMB + 1
            HZW(1) = JPTRO
            HZW(2) = LRFLAG - 1 + NCAND*16
            NCNTRI = IWRK(JPTRI+21) + 1
            IWRK(JPTRI+NCNTRI+29) = IZW
            IWRK(JPTRI+21) = NCNTRI
            HZW(1) = JPTRI
            NCNTRO = IWRK(JPTRO+20) + 1
            IWRK(JPTRO+NCNTRO+21) = IZW
            IWRK(JPTRO+20) = NCNTRO
      ENDIF
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16002
16003 CONTINUE
      GOTO IZZZ04
17005 CONTINUE
        IPTR = HPTE0
16004 CONTINUE
          NCNT= IWRK(IPTR+20)
          IP0 = IPTR+22
      IF(
     - NCNT.GT.1
     -)THEN
            ORFACT =-1.
      ASSIGN 17025 TO IZZZ05
      GOTO 17024
17025 CONTINUE
      ENDIF
          NCNT= IWRK(IPTR+21)
          IP0 = IPTR+30
      IF(
     - NCNT.GT.1
     -)THEN
            ORFACT =+1.
      ASSIGN 17026 TO IZZZ05
      GOTO 17024
17026 CONTINUE
      ENDIF
        IPTR = IPTR + HLDTE
      IF(.NOT.(
     - IPTR.GT.HPTE9
     -))GOTO 16004
16005 CONTINUE
      GOTO IZZZ03
17024 CONTINUE
      CALL MVC(IAUX(1),0,IWRK(IP0),0,32)
      LBORD = 0
      DO 13002 I=1,NCNT
        IZW = IAUX(I)
        IPCN = HZW1
      IF(
     - LAND(IZW,2).EQ.0
     -)THEN
          RSQ = WRK(IPCN+11)**2 + WRK(IPCN+12)**2
      ELSE
          RSQ = WRK(IPCN+15)**2 + WRK(IPCN+16)**2
      ENDIF
        RAUX(I) = RSQ
        IF(I.GT.1 .AND. (RSQ-RAUX(I-1))*ORFACT.LT.0) LBORD = 1
13002 CONTINUE
13003 CONTINUE
      IF(
     - LBORD.NE.0
     -)THEN
      IF(
     - NCNT.EQ.2
     -)THEN
            IWRK(IP0  ) = IAUX(2)
            IWRK(IP0+1) = IAUX(1)
      ELSE
          LBORD = 0
          NCNT9 = NCNT - 1
      DO 13004 I1=1,NCNT9
            NCNT1 = I1 + 1
      DO 13006 I2=NCNT1,NCNT
      IF(
     - (RAUX(I2)-RAUX(I1))*ORFACT .LT. 0.
     -)THEN
                IZW = IAUX(I2)
                IAUX(I2) = IAUX(I1)
                IAUX(I1) = IZW
                ZW  = RAUX(I2)
                RAUX(I2) = RAUX(I1)
                RAUX(I1) = ZW
      ENDIF
13006 CONTINUE
13007 CONTINUE
13004 CONTINUE
13005 CONTINUE
          CALL MVC(IWRK(IP0),0,IAUX(1),0,32)
      ENDIF
      ENDIF
      GOTO IZZZ05
      END

C   16/06/80 404301635  MEMBER NAME  FWMUCN   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FWMUCN
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL       ?     :  DRAW FORWARD MUON COUNTERS
C
C        MOD: J. OLSSON     28/05/81 :
C   LAST MOD: C. BOWDERY    30/04/84 :  COMMENTING IMPROVED
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
#include "cdata.for"
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CWORK2 / AGEO(6,16)
      COMMON / CFWMU  / HAXES(4,3),AFWMU(18)
C
C------------------  C O D E  ------------------------------------------
C
      IF( HEAD(18) .LT. 3730 ) RETURN
      MPROJ = 2
      IF( LASTVW .GT.  7 ) MPROJ = 1
      IF( LASTVW .EQ. 15 ) MPROJ = 3
      IXS = HAXES(1,MPROJ)
      IXA = HAXES(2,MPROJ)
      IYS = HAXES(3,MPROJ)
      IYA = HAXES(4,MPROJ)
C
      DO  1  I = 1,4
        AGEO(1,I) = AFWMU(I)
        AGEO(4,I) = AFWMU(I+4)
        AGEO(5,I) = AFWMU(I+8)
   1  CONTINUE
C
      DO  2  I = 1,4
        AGEO(1,9-I) = -AGEO(1,I) - 5.0
        AGEO(4,9-I) =  AGEO(4,I)
        AGEO(5,9-I) =  AGEO(5,I)
   2  CONTINUE
C
      DO  3  I = 1,8
        AGEO(1,(I+8)) = AGEO(1,I)
        AGEO(4,(I+8)) = AGEO(4,I)
        AGEO(5,(I+8)) = AGEO(5,I)
   3  CONTINUE
C
      DO  4  J = 1,16
        AGEO(6,J) = AFWMU(15)
   4  CONTINUE
C
      DO  5  J = 1,8
        AGEO(2,J+8) = AFWMU(17)
        AGEO(2,J)   = AFWMU(13)
   5  CONTINUE
C
      DO  6  J = 1,4
        AGEO(3,J+4)  =  AFWMU(16)
        AGEO(3,J+8)  = -AFWMU(16)
        AGEO(3,J+12) =  AFWMU(18)
        AGEO(3,J)    =  AFWMU(14)
   6  CONTINUE
C
      IF( LASTVW .NE. 15 ) GO TO 9
      X1   = 5250.0
      Y1   = 4000.0
C
      DO  7  I = 1,8
        AGEO(1,I) = AGEO(1,I) - X1
        AGEO(2,I) = AGEO(2,I) + Y1
   7  CONTINUE
C
      X1 = 1250.0
C
      DO  8  I = 9,16
        AGEO(1,I) = AGEO(1,I) - X1
        AGEO(2,I) = AGEO(2,I) + Y1
   8  CONTINUE
C
   9  DO  10  I = 1,16
        IF( MPROJ .EQ. 1  .AND.  I .GT.  4  .AND.  I .LT. 9 ) GO TO 10
        IF( MPROJ .EQ. 1  .AND.  I .GT. 12 ) GO TO 10
        X0 = IXS * AGEO(IXA,I)
        Y0 = IYS * AGEO(IYA,I)
        DX =       AGEO((IXA+3),I)
        DY =       AGEO((IYA+3),I)
        CALL RECTAN(X0-DX,Y0-DY,X0+DX,Y0+DY,0)
  10  CONTINUE
C
      RETURN
      END

C   06/02/87 809301211  MEMBER NAME  TPTGTP   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTGTP
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery        6/02/87:  Add tagg info into TPTR banks
C              A. Finch
C
C          mod: C. Bowdery      25/07/88:  Add extra argument to TPTGT1
C     Last mod: C. Bowdery      30/09/88:  CALL TPSEFL now
C
C
C     Routine to copy information from TAGG banks into TPTR
C     banks. See JCN 16 for 'TAGG' bank contents.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      INTEGER  LENAR, TAGG, NTAG, NTAG1, NTAG2, NHTAG, NTRACK
      INTEGER  NWPCL, NWPTR, NBNKS, LAST, ITPVX, MODVTX, ITRACK
      INTEGER  NVLM2, NPV2, IER, IB

      PARAMETER  ( LENAR = 100, TAGG = 7 )

      INTEGER  IPNTA( LENAR )

C------------------  C O D E  ------------------------------------------

C                            Get pointer to  TAGG banks (0,1,2)

      CALL CLOC( NTAG,  'TAGG', 0 )
      CALL CLOC( NTAG1, 'TAGG', 1 )
      CALL CLOC( NTAG2, 'TAGG', 2 )

C                            Set error flag = 1000 if TAGG banks missing

      IF( NTAG .LE. 0  .OR.  NTAG1 .LE. 0  .OR.  NTAG2. LE. 0 ) THEN
        CALL TPSEFL( TAGG, 1000 )
      ELSE

C                            Find number of tagging clusters

        NHTAG  = 2*NTAG
        NTRACK = HDATA( NHTAG + 6 )

        IF( NTRACK .GT. 0 ) THEN

          NWPCL  = HDATA(NHTAG+53)
          NWPTR  = HDATA(NHTAG+54)

          CALL BDAR( 'TPTR', NBNKS, IPNTA, LENAR )
          LAST = NBNKS

C                            Warn if no. of TPTR banks exceeds space

          IF( NBNKS .EQ. LENAR ) THEN
            CALL TPWARN
          ENDIF

C                            Locate TPVX/1 bank

          CALL CLOC( ITPVX, 'TPVX',1 )

          IF( ITPVX .LE. 0 ) THEN

            CALL TPWARN
            MODVTX = 2

          ELSE

            NVLM2  = 2*( IDATA(ITPVX) + ITPVX )
            NPV2   = 2*ITPVX + HDATA( 2*ITPVX + 22 ) + 30

            MODVTX = HDATA( 2*ITPVX + 2 )
            IF( MODVTX .NE. 0 ) MODVTX = 20

          ENDIF

          IB = NTAG2

          DO  50  ITRACK = 1,NTRACK

C                            Copy TAGG/2 cluster to new TPTR bank

            CALL TPTGT1( IB, ITRACK, LAST, MODVTX, IER )

            IF( IER .NE. 0 ) THEN
              CALL TPSEFL( TAGG, 2000 )
              CALL TPERRH
              RETURN
            ENDIF

C                            Include tagging tracks in TPVX/1 counts

            IF( ITPVX .GT. 0 ) THEN

              HDATA( 2*ITPVX + 22 ) = HDATA( 2*ITPVX + 22 ) + 1
              HDATA( 2*ITPVX + 26 ) = HDATA( 2*ITPVX + 26 ) + 1
              NPV2 = NPV2 + 1
              IF( NPV2 .LE. NVLM2 ) HDATA(NPV2) = LAST

            ENDIF

C                            Update pointer to TAGG/2 bank

            IB = IB + NWPCL

 50       CONTINUE

        ENDIF
      ENDIF

      RETURN
      END

C   30/03/79 008181705  MEMBER NAME  TOFAR2                 FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE TOFAR2(INLA,INTF,IFLG,*)
C
C          CONVERTS THE TOF DATA FROM CAMAC FORMAT
C       TO ANALYSIS FORMAT :
C                   IRAW(1,NCN)= NCN  ; COUNTER#
C      RAW(2,NCN)= TDC(-)-CM(NCN)-WM(NCN)*(1./SQRT(A0M)-1./SQRT(ADC(-)))
C      RAW(3,NCN)= TDC(+)-CP(NCN)-WP(NCN)*(1./SQRT(A0M)-1./SQRT(ADC(+)))
C       OR
C      RAW(2,NCN)= TDC(-) , IF IFLG= 1.
C      RAW(3,NCN)= TDC(+) , IF IFLG= 1.
C                   RAW(4,NCN) = ADC(-)
C                   RAW(5,NCN) = ADC(+)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
C   12/03/79 007281422  MEMBER NAME  DDATA    (S)           FORTRAN
C
      COMMON /BCS/ IDATA(10000)
      DIMENSION DATA(10000)
      INTEGER *2 HDATA(20000)
      EQUIVALENCE (IDATA(1),DATA(1)), (HDATA(1),IDATA(1))
C
      INTEGER *2  HADC,HTDC,HB,HEADR(108)
      REAL *8 DYC1,DYC2
      COMMON/TFPRM/ NRNC1,NRNC2,DYC1,DYC2,IFLC(42),CM(42),CP(42),
     -DTAU(42),WM(42),WP(42),SV(42),DM(42),DP(42),PEDLM(42),PEDLP(42)
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HB(42)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      DIMENSION MASK(16)
      DIMENSION CORADC(20)
      DIMENSION IRAW(5,42)
      EQUIVALENCE (IRAW(1,1),RAW(1,1))
C
      DATA MASK/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     1          16384,32768/
      DATA CORADC/1.9,2.45,2.8,3.0,3.15,3.3,3.35,3.45,3.5,3.55,3.55,
     1            3.6,8*3.6/
      DATA IENTRY/0/,LERR/0/,IBUG/ 0/,JBUG/10/
      IF(IENTRY.NE.0)  GOTO 320
      IENTRY = IENTRY + 1
C
 320  CONTINUE
C
C========= ADDRESSING
C
      IBUG = IBUG + 1
      JBUG = JBUG + 1
      NRUN = HEADR(18)
       IER= 0
       INLA2= INLA*2
       INTF2= INTF*2
       IL0= INLA2+6
       IA0= INTF2+3
       IT0= INTF2+94
C//////////
C
        NUM= 0
        DO 3000 NCN= 1,42
      IRAW(1,NCN) = 0
C
C========= ADDRESS OF ADC AND TDC FOR COUNTER# NCN
C
        NCN2= NCN*2
        IAA= (NCN-1)/6+NCN2+IA0-2
        IAT= (NCN-1)/4+NCN2+IT0-2
        IAA1= IAA+1
        IAT1= IAT+1
        HADC(1,NCN)= HDATA(IAA)
        HADC(2,NCN)= HDATA(IAA1)
      ADCM = HDATA(IAA) - PEDLM(NCN)
      ADCP = HDATA(IAA1) - PEDLP(NCN)
      IF(NRUN.LE.2306.OR.NCN.LE.38)  GOTO  75
      ADCM = ADCM*2
      ADCP = ADCP*2
   75 HTDC(1,NCN)= HDATA(IAT)
      HTDC(2,NCN)= HDATA(IAT1)
      TDCM = HTDC(1,NCN)
      TDCP = HTDC(2,NCN)
C
C========= CHECK OF LATCHED BIT
C
        NW= (NCN-1)/7+IL0
        MDATA= HDATA(NW)
        IF(MDATA) 100,3000, 100
 100    NORD= MOD(NCN,7)
      IF(NORD.EQ.0) NORD = 7
      IF(LAND(MDATA,MASK(NORD)).GT.0)  GOTO  1500
      GOTO  3000
C
C========= BIT WAS SET
C
 1500 CONTINUE
C
C  COMPUTE PULSEHEIGHT CORRECTION FOR TOF
C
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
      ADCMIV = 1000./ADCM
      ADCPIV = 1000./ADCP
      INDM = IFIX(ADCMIV/.5) + 1
      IF(INDM.LT.2) INDM = 2
      IF(INDM.GT.13) INDM= 13
      CORADM = (CORADC(INDM)-CORADC(INDM-1))/.5*(ADCMIV-(INDM-1)*.5)
     1         + CORADC(INDM-1)
      INDP = IFIX(ADCPIV/.5) +1
      IF(INDP.LT.2) INDP = 2
      IF(INDP.GT.13) INDP= 13
      CORADP = (CORADC(INDP)-CORADC(INDP-1))/.5*(ADCPIV-(INDP-1)*.5)
     1         + CORADC(INDP-1)
      CORADM = CORADM-3.
      CORADP = CORADP-3.
C     IF(IBUG.LE.10) PRINT 501,NCN,HTDC(1,NCN),HTDC(2,NCN),HADC(1,NCN)
C    1 ,HADC(2,NCN)
C 501 FORMAT(' TOFARD',10I10)
      IF(TDCM.LT.10..OR.TDCM.GT.2048.)  GOTO  2000
      TDCM0= TDCM
      IF(IFLG.EQ.1) GO TO 1600
 1510 TDCM0= TDCM0*DM(NCN)
      TDCM0= TDCM0-CM(NCN)-CORADM
C     IF(IBUG.LE.10) PRINT 502,TDCM0,DM(NCN),CM(NCN),CORADM
C 502 FORMAT(7X, 8F12.5)
 1600 IRAW(1,NCN)= NCN
      RAW(2,NCN)= TDCM0
      RAW(4,NCN)= ADCM
C
 2000 IAA1= IAA+1
      IAT1= IAT+1
      IF(TDCP.LT.10.OR.TDCP.GT.2048.)  GOTO  2100
      TDCP0= TDCP
      IF(IFLG.EQ.1) GO TO 2050
2010  TDCP0= TDCP0*DP(NCN)
      TDCP0= TDCP0-CP(NCN)-CORADP
C     IF(IBUG.LE.10) PRINT 502,TDCP0,DP(NCN),CP(NCN),CORADP
2050  IRAW(1,NCN)= NCN
      RAW(3,NCN)= TDCP0
      RAW(5,NCN)= ADCP
2100  CONTINUE
C
 3000 CONTINUE
C/////////
      RETURN
      END

C   11/11/77 C9030201   MEMBER NAME  SETTOF   (S)           FORTRAN
      SUBROUTINE SETTOF(R)
C
C      THIS ROUTINE SETS THE TIME OF FLIGHT COUNTERS
C      IF A TOF COUNTER IS SET, THE CORRESPONDING POSITION IN THE
C      ARRAY HTOFAR IS SET TO 1, OTHERWISE IT IS 0
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      COMMON/CTOFF/HTOFAR(42)
*** PMF 15/10/99      DIMENSION R(1)
      DIMENSION R(*)
*** PMF (end)
      INTEGER*2 HTOFAR
      REAL PI/3.14159/,DFITOF/0.0748/
C
C      CHECK WHETHER TOF COUNTERS ARE HIT AT ALL
C
      IF(R(3).GT.ZTOFPL) RETURN
      IF(R(3).LT.ZTOFMI) RETURN
C
C      SET TOF COUNTER
C
      PHI=ATAN2(R(2),R(1))
      IF(PHI.LT.0.) PHI=2.*PI+PHI
      NTOF=(PHI+DFITOF)/(2*DFITOF)+1
      IF(NTOF.GT.42) NTOF=1
      HTOFAR(NTOF)=1
      RETURN
      END

      SUBROUTINE ZVERTF
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cgraph.for"
#include "czvpar.for"
#include "cjdrch.for"
#include "cdsmax.for"
#include "clbpgm.for"
#include "cworkzv.for"
      LBPGM(2) = LBPGM(2) + 1
      DATA MKLAYR /15/
      DATA LBINIT /0/
      IF(
     - LBINIT.EQ.0
     -)THEN
        LBINIT = 1
        IQJETC = IBLN('JETC')
        IZCON = ZAL*.5
        IZMAX = ZMAX + 40.
      ENDIF
      IPJCA  = IDATA(IQJETC)
      IPJCA2 = IPJCA*2 + 2
      IP0 = IPJCA2 + 98
      ISEGO = IPJCA2
      DO 13000 ISEG=1,96
        ISEGO = ISEGO + 1
        HPTSEC(ISEG) = HDATA(ISEGO) + IP0
13000 CONTINUE
13001 CONTINUE
      HPTSEC(97) = HDATA(ISEGO+1) + IP0
      HPTSEC(98) = 0
      FZRSLT(1) = 0.
      FZRSLT(2) = 1000000.
      FZRSLT(3) = 1000000.
      FZRSLT(4) = 0.
      FZRSLT(5) = 0.
      IZRSLT(6) =-2
      INDLB = 3
      DFIMX0 = DFIMAX
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      IF(
     - IZRSLT(6).LT.3
     -)THEN
        IZRSLT( 7) = IZRSLT( 1)
        IZRSLT( 8) = IZRSLT( 2)
        IZRSLT( 9) = IZRSLT( 3)
        IZRSLT(10) = IZRSLT( 4)
        IZRSLT(11) = IZRSLT( 5)
        IZRSLT(12) = IZRSLT( 6)
        DFIMX0 = 1000.
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - IZRSLT(6).LE.IZRSLT(12)
     -)THEN
          IZRSLT( 1) = IZRSLT( 7)
          IZRSLT( 2) = IZRSLT( 8)
          IZRSLT( 3) = IZRSLT( 9)
          IZRSLT( 4) = IZRSLT(10)
          IZRSLT( 5) = IZRSLT(11)
          IZRSLT( 6) = IZRSLT(12)
      ENDIF
      ENDIF
      NWRES = 6
      CALL CCRE(IPHT,'ZVTX',0,NWRES,IERR)
      IF(IERR.NE.0) RETURN
      CALL BSAW(1,'ZVTX')
         ADATA(IPHT+1) = FZRSLT(1)
         ADATA(IPHT+2) = FZRSLT(2)
         ADATA(IPHT+3) = FZRSLT(3)
         ADATA(IPHT+4) = FZRSLT(4)
         ADATA(IPHT+5) = FZRSLT(5)
         ADATA(IPHT+6) = FZRSLT(6)
      RETURN
17000 CONTINUE
      BINZIV = 1. / BINZ
      PAR1 = FSENSW(1) / (FSENSW(2) - FSENSW(1))
      PAR2 =  RINCR(1) / (FSENSW(2) - FSENSW(1))
      HUFLO = 0
      HOFLO = 0
      MAXZ = 0
      NBACK = 0
      CALL SETS(HIST(1),0,200,0)
      IF(
     - HPTSEC(25)-HPTSEC(1) .LT. NWRDR1
     -)THEN
        IZRSLT(6) = -2
        INDLB = 1
      ELSE
      JSEC=1
16000 CONTINUE
        NWRD1 = HPTSEC(JSEC+1) - HPTSEC(JSEC)
        NWRD2 = HPTSEC(JSEC+25) - HPTSEC(JSEC+24)
      IF(
     - NWRD1.GE.LWRDC0
     -)THEN
      IF(
     - JSEC.EQ.1
     -)THEN
            NWRD1L= HPTSEC(25) - HPTSEC(24)
            NWRD2L= HPTSEC(49) - HPTSEC(48)
      ELSE
            NWRD1L= HPTSEC(JSEC   ) - HPTSEC(JSEC- 1)
            NWRD2L= HPTSEC(JSEC+24) - HPTSEC(JSEC+23)
      ENDIF
      IF(
     - JSEC.EQ.24
     -)THEN
            NWRD1R= HPTSEC( 2) - HPTSEC( 1)
            NWRD2R= HPTSEC(26) - HPTSEC(25)
      ELSE
            NWRD1R= HPTSEC(JSEC+ 2) - HPTSEC(JSEC+ 1)
            NWRD2R= HPTSEC(JSEC+26) - HPTSEC(JSEC+25)
      ENDIF
      IF(
     - NWRD1+NWRD1L.GE.LWRDC1 .OR. NWRD1+NWRD1R.GE.LWRDC1
     -)THEN
      IF(
     - NWRD2L+NWRD2.GE.LWRDC2 .OR. NWRD2R+NWRD2.GE.LWRDC2
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      ENDIF
      ENDIF
      ENDIF
      JSEC = JSEC + 1
      IF(.NOT.(
     - JSEC.GT.24
     -))GOTO 16000
16001 CONTINUE
      CALL MVC(HTMP(1),0,HIST(1),0,200)
      ASSIGN 17009 TO IZZZ05
      GOTO 17008
17009 CONTINUE
      ENDIF
      GOTO IZZZ01
17004 CONTINUE
      DO 13002 ILAYR=1,16
          NZ1(ILAYR) = 0
          NZ2(ILAYR) = 0
13002 CONTINUE
13003 CONTINUE
        DSBIN1 = TIMDEL(1,1)
        DSBIN2 = TIMDEL(2,1)
        IPT0 = HPTSEC(JSEC)
        IPT9 = HPTSEC(JSEC+1) - 1
      DO 13004 IPT = IPT0,IPT9,4
          IWIRE = HDATA(IPT)
          IWIRE = ISHFTR(IWIRE,3)
          ILAYR = LAND(IWIRE,MKLAYR) + 1
          IAMPL = HDATA(IPT+1)
          IAMPR = HDATA(IPT+2)
      IF(
     - IAMPL.GT.0 .AND. IAMPR.GT.0
     -)THEN
            IZ1 = (IZCON * (IAMPR-IAMPL)) / (IAMPR+IAMPL)
      IF(
     - IABS(IZ1).LT.IZMAX
     -)THEN
              NZ1(ILAYR) = NZ1(ILAYR) + 1
              IHIT = NZ1(ILAYR)
              HZ1(IHIT,ILAYR) = IZ1
              IF(ILAYR.GT.8) DSBIN1 = DSBIN2
              DRLAY = (ILAYR-1) * RINCR(1)
              FI1(IHIT,ILAYR) = HDATA(IPT+3)*DSBIN1 / (FSENSW(1)+DRLAY)
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
        JSECA=1
16002 CONTINUE
          JSEC2 = JSEC + JSECA + 22
          IF(JSEC2.LT.25) JSEC2 = 48
          IF(JSEC2.GT.48) JSEC2 = 25
          IPT0 = HPTSEC(JSEC2)
          IPT9 = HPTSEC(JSEC2+1) - 1
      IF(
     - IPT9.GT.IPT0
     -)THEN
            DSBIN1 = TIMDEL(1,2)
            DSBIN2 = TIMDEL(2,2)
      DO 13006 IPT = IPT0,IPT9,4
              IWIRE = HDATA(IPT)
              IWIRE = ISHFTR(IWIRE,3)
              ILAYR = LAND(IWIRE,MKLAYR) + 1
              IAMPL = HDATA(IPT+1)
              IAMPR = HDATA(IPT+2)
      IF(
     - IAMPL.GT.0 .AND. IAMPR.GT.0
     -)THEN
                IZ2 = (IZCON * (IAMPR-IAMPL)) / (IAMPR+IAMPL)
      IF(
     - IABS(IZ2).LT.IZMAX
     -)THEN
                  NZ2(ILAYR) = NZ2(ILAYR) + 1
                  IHIT = NZ2(ILAYR)
                  HZ2(IHIT,ILAYR) = IZ2
                  IF(ILAYR.GT.8) DSBIN1 = DSBIN2
                  DS = HDATA(IPT+3)*DSBIN1
                  IF(JSECA.NE.2)
     ?                     DS = DSMAX(ILAYR,2,1)+DSMAX(ILAYR,2,2) - DS
                  DRLAY = (ILAYR-1) * RINCR(2)
                  FI2(IHIT,ILAYR) = DS / (FSENSW(2)+DRLAY)
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
      ENDIF
        JSECA = JSECA + 1
      IF(.NOT.(
     - JSECA.GT.3
     -))GOTO 16002
16003 CONTINUE
      GOTO IZZZ03
17002 CONTINUE
      BINZIV = .5 / BINZ
      PAR1 = FSENSW(2) / (FSENSW(3) - FSENSW(2))
      PAR2 =  RINCR(2) / (FSENSW(3) - FSENSW(2))
      HUFLO = 0
      HOFLO = 0
      MAXZ = 0
      NBACK = 0
      CALL SETS (HIST(1),0,200,0)
      CALL SETSL(FI1(1,1),0,1024,0)
      IF(
     - HPTSEC(97)-HPTSEC(49) .LT. NWRDR1
     -)THEN
        IZRSLT(6) = -2
        INDLB = 1
      ELSE
      ICLL=49
16004 CONTINUE
        NWRD1 = HPTSEC(ICLL+1) - HPTSEC(ICLL)
      IF(
     - NWRD1.GE.LWRDC0
     -)THEN
      IF(
     - ICLL.EQ.49
     -)THEN
            NWRD1L= HPTSEC(97) - HPTSEC(96)
      ELSE
            NWRD1L= HPTSEC(ICLL   ) - HPTSEC(ICLL- 1)
      ENDIF
      IF(
     - ICLL.EQ.96
     -)THEN
            NWRD1R= HPTSEC(50) - HPTSEC(49)
      ELSE
            NWRD1R= HPTSEC(ICLL+ 2) - HPTSEC(ICLL+ 1)
      ENDIF
      IF(
     - NWRD1+NWRD1L.GE.LWRDC1 .OR. NWRD1+NWRD1R.GE.LWRDC1
     -)THEN
      IF(
     - ICLL.EQ.49 .OR. ICLL.EQ.96
     -)THEN
              NWRD2 = HPTSEC(25)-HPTSEC(24) + HPTSEC(49)-HPTSEC(48)
      ELSE
              ICLL2L = ICLL/2
              NWRD2 = HPTSEC(ICLL2L+2) - HPTSEC(ICLL2L)
      ENDIF
      IF(
     - NWRD2.GE.LWRDC2
     -)THEN
      ASSIGN 17011 TO IZZZ06
      GOTO 17010
17011 CONTINUE
      ASSIGN 17012 TO IZZZ04
      GOTO 17006
17012 CONTINUE
      ENDIF
      ENDIF
      ENDIF
      ICLL = ICLL + 1
      IF(.NOT.(
     - ICLL.GT.96
     -))GOTO 16004
16005 CONTINUE
      CALL MVC(HTMP(1),0,HIST(1),0,200)
      ASSIGN 17013 TO IZZZ05
      GOTO 17008
17013 CONTINUE
      ENDIF
      GOTO IZZZ02
17010 CONTINUE
      DO 13008 ILAYR=1,16
          NZ1(ILAYR) = 0
          NZ2(ILAYR) = 0
13008 CONTINUE
13009 CONTINUE
        IPT0 = HPTSEC(ICLL)
        IPT9 = HPTSEC(ICLL+1) - 1
      DO 13010 IPT = IPT0,IPT9,4
          IWIRE = HDATA(IPT)
          IWIRE = ISHFTR(IWIRE,3)
          ILAYR = LAND(IWIRE,MKLAYR) + 1
          IAMPL = HDATA(IPT+1)
          IAMPR = HDATA(IPT+2)
      IF(
     - IAMPL.GT.0 .AND. IAMPR.GT.0
     -)THEN
            IZ1 = (IZCON * (IAMPR-IAMPL)) / (IAMPR+IAMPL)
      IF(
     - IABS(IZ1).LT.IZMAX
     -)THEN
              NZ2(ILAYR) = NZ2(ILAYR) + 1
              IHIT = NZ2(ILAYR)
              HZ2(IHIT,ILAYR) = IZ1
      ENDIF
      ENDIF
13010 CONTINUE
13011 CONTINUE
        ICLLA=0
16006 CONTINUE
          ICLL2 = ICLL/2 + ICLLA
          IF(ICLL2.LT.25) ICLL2 = 48
          IF(ICLL2.GT.48) ICLL2 = 25
          IPT0 = HPTSEC(ICLL2)
          IPT9 = HPTSEC(ICLL2+1) - 1
      IF(
     - IPT9.GT.IPT0
     -)THEN
      DO 13012 IPT = IPT0,IPT9,4
              IWIRE = HDATA(IPT)
              IWIRE = ISHFTR(IWIRE,3)
              ILAYR = LAND(IWIRE,MKLAYR) + 1
              IAMPL = HDATA(IPT+1)
              IAMPR = HDATA(IPT+2)
      IF(
     - IAMPL.GT.0 .AND. IAMPR.GT.0
     -)THEN
                IZ1 = (IZCON * (IAMPR-IAMPL)) / (IAMPR+IAMPL)
      IF(
     - IABS(IZ1).LT.IZMAX
     -)THEN
                  NZ1(ILAYR) = NZ1(ILAYR) + 1
                  IHIT = NZ1(ILAYR)
                  HZ1(IHIT,ILAYR) = IZ1
      ENDIF
      ENDIF
13012 CONTINUE
13013 CONTINUE
      ENDIF
        ICLLA = ICLLA + 1
      IF(.NOT.(
     - ICLLA.GT.1
     -))GOTO 16006
16007 CONTINUE
      GOTO IZZZ06
17006 CONTINUE
      DO 13014 ILAYR=1,16
          MZ1 = NZ1(ILAYR)
          MZ2 = NZ2(ILAYR)
      IF(
     - MZ1.GT.0 .AND. MZ2.GT.0
     -)THEN
            FACT = (ILAYR-1)*PAR2 + PAR1
      DO 13016 IHIT1=1,MZ1
              Z1 = HZ1(IHIT1,ILAYR)
              FI01 = FI1(IHIT1,ILAYR)
      DO 13018 IHIT2=1,MZ2
                DFI = ABS(FI01 - FI2(IHIT2,ILAYR))
      IF(
     - DFI.LT.DFIMX0
     -)THEN
                  Z2 = HZ2(IHIT2,ILAYR)
                  ZV = Z1 - (Z2-Z1)*FACT
                  IZV = (ZV-ZLOW) * BINZIV + 1
      IF(
     - IZV.GT.0 .AND. IZV.LE.100
     -)THEN
                    HIST(IZV) = HIST(IZV) + 1
      ELSE
                    IF(IZV.LE.  0) HUFLO = HUFLO + 1
                    IF(IZV.GT.NBINZ) HOFLO = HOFLO + 1
      ENDIF
      ENDIF
13018 CONTINUE
13019 CONTINUE
13016 CONTINUE
13017 CONTINUE
      ENDIF
13014 CONTINUE
13015 CONTINUE
      GOTO IZZZ04
17008 CONTINUE
      IZCNT=0
      ICODE=0
      ZPREV=-1000000.
15000 CONTINUE
      IF(
     - IZCNT.LT.5
     -)THEN
        MAXHST = 0
        NHIST1 = 0
      DO 13020 IHIST = 1,NBINZ
          NHIST1 = NHIST1 + HTMP(IHIST)
          IF(HTMP(IHIST).GT.MAXHST) MAXHST =HTMP(IHIST)
13020 CONTINUE
13021 CONTINUE
        MAXZ = MAXHST
        NPEAK = 0
        IH9 = NBINZ-11
      DO 13022 IH=7,IH9
       IHSUM = HTMP(IH)+HTMP(IH+1)+HTMP(IH+2)+HTMP(IH+3)+HTMP(IH+4)
      IF(
     - IHSUM.GT.NPEAK
     -)THEN
            NPEAK = IHSUM
            HPEAK = IH
      ENDIF
13022 CONTINUE
13023 CONTINUE
      IF(
     - NPEAK.EQ.0
     -)THEN
      GOTO 15001
      ENDIF
        PEAK = NPEAK
          H1 = HPEAK - 7
          H2 = HPEAK + 7
       NBACK = HTMP(H1  )+HTMP(H1+1)+HTMP(H1+2)+HTMP(H1+3)+HTMP(H1+4)
     +       + HTMP(H2  )+HTMP(H2+1)+HTMP(H2+2)+HTMP(H2+3)+HTMP(H2+4)
          BACK = .5 * NBACK
          ZV = HTMP(HPEAK+1)   +HTMP(HPEAK+2)*2
     +        +HTMP(HPEAK+3)*3 +HTMP(HPEAK+4)*4
          ZV = ZV / PEAK
          ZVTX      = (HPEAK+ZV-.5)/BINZIV + ZLOW
          DZ =HTMP(HPEAK  )*(ZV   )**2 +HTMP(HPEAK+1)*(ZV-1.)**2
     +       +HTMP(HPEAK+2)*(ZV-2.)**2 +HTMP(HPEAK+3)*(ZV-3.)**2
     +       +HTMP(HPEAK+4)*(ZV-4.)**2
          IF(NPEAK.GT.NPKMIN) ICODE=ICODE+1
          SGN  = (PEAK - BACK)**2
          DSGN = BACK*.5 + PEAK
          IF(SGN/DSGN.GE.SBRAT .AND. NPEAK.GT.2) ICODE=ICODE+2
      IF(
     - ICODE.GE.IZRSLT(6)
     -)THEN
      IF(
     - ICODE.EQ.IZRSLT(6).AND.ABS(ZVTX).GT.ABS(ZPREV)
     -)THEN
      GOTO 15001
      ENDIF
          IZCNT=IZCNT+1
          SCPEAK = BACK * .2
          HTMP(HPEAK-2)=SCPEAK
          HTMP(HPEAK-1)=SCPEAK
          HTMP(HPEAK  )=SCPEAK
          HTMP(HPEAK+1)=SCPEAK
          HTMP(HPEAK+2)=SCPEAK
          HTMP(HPEAK+3)=SCPEAK
          HTMP(HPEAK+4)=SCPEAK
          HTMP(HPEAK+5)=SCPEAK
          HTMP(HPEAK+6)=SCPEAK
          FZRSLT(2) = DZ / (BINZIV**2 * PEAK)
          FZRSLT(3) = FZRSLT(2) / PEAK
          FZRSLT(2) = SQRT(FZRSLT(2))
          FZRSLT(3) = SQRT(FZRSLT(3))
          FZRSLT(4) = PEAK
          FZRSLT(5) = BACK
          FZRSLT(1) = ZVTX
          IND = ABS(ZVTX)*.01 + 1.
          IF(IND.GT.4) IND = 4
          IF(IZRSLT(6).EQ.1) IND = IND + 4
          INDLB = IND + 2
      ZPREV=ZVTX
      IZRSLT(6)=ICODE
      ICODE=0
      ELSE
      GOTO 15001
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      GOTO IZZZ05
      END
      SUBROUTINE INITZV
#include "czvpar.for"
        LBZVDF = 1
        ZLOW = -3500.
        BINZ = 70.
        NBINZ = 100
        NWRDR1 = 24
        LWRDC0 = 8
        LWRDC1 = 16
        LWRDC2 = 16
        IDZ1LM = 80
        IDZ2LM = 140
        NPKMIN = 8
        SBRAT  = 6.25
        DFIMAX = .1
      RETURN
      END

C   17/09/84 712141931  MEMBER NAME  PRSTAT0  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRSTAT(IFLAG1,IFLAG2,IFLAG3)
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    10/05/82 :  PRINT TRIGGER CONDITIONS
C
C   MOD  C. BOWDERY  17/09/84 :  S/R MOVED TO THIS MEMBER
C        MOD  J.OLSSON    24/07/86 :  EXTENSION AND COMPRESSION OF PRINT
C   LAST MOD  E ELSEN     11/12/87 :  PRINT JITTER CONSTANTS FOR ID
C             J.HAGEMANN              AND VTXC
C
C
C     PRINT SMEARING CONDITIONS, I.E. COMMONS /CBIN/ AND /CBINV/
C          AS WELL AS /CBINMC/, /CJDRCH/ AND /CJVTXC/
C      FOR THIS PRINT, THE FLAGS IFLAG1,IFLAG2 AND IFLAG3 ARE USED, THEY
C      ARE SET AND DETERMINED IN RDMTCO.
C
C     PRINT STATUS OF COMMON /CTRIGG/ AND COMMON/CRDSTA/
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cadmin.for"
C
      LOGICAL  LVTXC
      COMMON / CVCEX  / LVTXC
C
      COMMON / CJDRCH / DRCH(34),
     +                  PEDES, TZERO(3),
     +                  DRIROT(96,2), SINDRI(96,2), COSDRI(96,2),
     +                  DRIVEL(96,2)
C
      COMMON / CJVTXC / VXCC(15),
     +                  DRILOR(24), SNLORA(24), CSLORA(24),
     +                  DRVELO(24)
C
      COMMON / CBINV /  DTRSVV, ZRSVV, EFFVV(2), DOUBVV(3), IRNHVV,
     +                  SMPRMV(3)
C
      COMMON / CBIN  / TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3),
     +                BINDL8(6),RJITT, DLRSLN(3)
C
      COMMON / CBINMC / BINMC(6)
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10), IPHALG
C
C------------------  C O D E  ------------------------------------------
C
C     IF( NFLAGS(4) .NE. 1 ) GO TO 8000
      WRITE(6,5810) IFLAG1,IFLAG2,IFLAG3,NFLAGS(4)
5810  FORMAT('  IFLAG1-3, NFLAGS(4) ',3I3,I4)
C
C
C PRINT SMEARING CONDITIONS
C
      IF( IFLAG1 .EQ. 0) WRITE(6,200)
200   FORMAT(' =======  UNSMEARED DATA ====, THE FOLLOWING SMEARING WILL
     $ BE USED =====')
      IF( IFLAG1 .NE. 0) WRITE(6,201)
201   FORMAT(' =======  SMEARED DATA ====, THE FOLLOWING SMEARING WAS ST
     $ORED IN MTCO =====')
C
      WRITE(6,100) (BINDL8(I),I=1,6),(DRCH(I),I=26,32),RJITT, DLRSLN,
     *  DOUB,IRN,EPSI
  100 FORMAT(20X,'  CONSTANTS FOR CENTRAL DETECTOR',/,
     * 3X,'TIMING BINS IN MM ',6(1X,F7.3),/,
     * 3X,'ZMAX ',F9.3,/,
     * 3X,'ZOF  ',F9.3,/,
     * 3X,'ZRS  ',F9.3,/,
     * 3X,'ZNORM',F9.3,/,
     * 3X,'ZL   ',F9.3,/,
     * 3X,'ZSC  ',F9.3,/,
     * 3X,'TILT ANGLE',F9.3,/,
     * 3X,'SMEAR JITTER CONSTANT ',F7.3,
     *    ' Fraction of this Gaussian:',F7.4/
     * 3X,' 2nd Gaussian Shift (JITTER units)',F7.3,
     *    ' sigma (JITTER units)',F7.3/
     * 3X,'DOUB HIT RES IN MM',3(1X,F5.2),/,
     * 3X,'NR OF RDM HITS ',3(1X,I4),/,
     * 3X,'EFFICIENCY ',3(1X,F6.3))
      WRITE(6,101) (BINMC(I),I=1,6)
  101 FORMAT(3X,'  ORIGINAL TIMING BINS IN MM FROM SIMULATION ',/,
     * 3X,6(1X,F7.3),//)
C
C
      IF( LVTXC )
     *    WRITE(6,1038) DTRSVV,(SMPRMV(I),I=1,3),ZRSVV,(EFFVV(I),I=1,2),
     *              (DOUBVV(I),I=1,3),IRNHVV
 1038 FORMAT(5X,' CONSTANTS FOR VERTEX CHAMBER FROM COMMON CBINV'/
     * 5X,'SMEAR JITTER CONSTANT ',F7.3,
     *    ' Fraction of this Gaussian:',F7.4/
     * 5X,' 2nd Gaussian Shift (JITTER units)',F7.3,
     *    ' sigma (JITTER units)',F7.3/
     * 5X,'ZRSVV                ',F9.3,/,
     * 5X,'EFFVV(1),EFFVV(2)    ',2F9.3,/,
     * 5X,'DOUBVV(1)            ',F9.3,/,
     * 5X,'DOUBVV(2)            ',F9.3,/,
     * 5X,'DOUBVV(3)            ',F9.3,/,
     * 5X,'IRNHVV               ',I9  ,/)
C
C
      IF( IFLAG1 .NE. 0 .AND. IFLAG2 .EQ. 0) WRITE(6,202)
202   FORMAT(' =======  SMEARED DATA ====, DOUBLE HIT RESO., RNDM HITS A
     $ND EFFI. NOT AVAILABLE IN MTCO')
      IF( IFLAG1 .NE. 0 .AND. IFLAG3 .EQ. 0) WRITE(6,203)
203   FORMAT(' =======  SMEARED DATA ====, OLD SCHEME HAS BEEN USED, RJI
     $TT VALUE NOT APPLICABLE')
      IF( IFLAG1 .EQ. 0) GO TO 3000
      WRITE(6,204)
204   FORMAT(' ',60('-'))
      IF( IFLAG2 .EQ. 0) WRITE(6,205)
205   FORMAT(' =======  SMEARED DATA ====, THE DETECTOR STATUS AND TRIGG
     $ER CONDITIONS WERE NOT STORED IN MTCO')
      IF( IFLAG2 .EQ. 0) GO TO 8000
      WRITE(6,206)
206   FORMAT(' =======  SMEARED DATA ====, THE DETECTOR STATUS AND TRIGG
     $ER CONDITIONS AS STORED IN MTCO FOLLOW:')
C
3000  CONTINUE
C
      JJSUM = 0
      DO 93  I = 1,16
      DO 93  J = 1,3
93    JJSUM = JJSUM + HMASK(I,J)
      KKSUM = 0
      DO 94  I = 1,10
94    KKSUM = KKSUM + HDEADC(I)
C
      WRITE(6,9104) IHIST
 9104 FORMAT(' *** DETECTOR STATUS & TRIGGER CONDITIONS ***',
     *           '  FOR ',I2,'-',I2,'-',I4,/,
     *' ==============================================================')
      IF( NDEAD .GT. 0 ) WRITE(6,9101) (HITD(I),I=1,NDEAD)
 9101 FORMAT(' LIST OF DEAD WIRES',15I5,(25X,15I5))
      IF( NCDEAD .GT. 0 ) WRITE(6,9102) (HCELLD(I),I=1,NCDEAD)
 9102 FORMAT(' LIST OF DEAD CELLS',15I5,(25X,15I5))
      IF(IPHALG.NE.0) WRITE(6,611)
  611 FORMAT('   STANDARD READOUT THRESHOLD IN LG-BLOCKS:  ENABLED')
      IF(IPHALG.EQ.0) WRITE(6,641)
  641 FORMAT('   STANDARD READOUT THRESHOLD IN LG-BLOCKS:  NOT ENABLED')
C
      IF(IHIST(3).GT.1981) GO TO 1561
C
C   1979 - 1981  TRIGGER CONDITIONS
C
      WRITE(6,601) (HLGTOT(I,1),I=1,4),HLGTL,HLGTH
 601  FORMAT(/,' ***** LATCH THRESHOLDS  *****'/
     *           ' ============================='/
     *  ' TOTAL ENERGY THRESHOLDS ',4I6/
     *  ' TAGGING AND LUMINOSITY ENERGY THRESHOLDS ',2I7)
C
      WRITE(6,602)
 602  FORMAT(/,' ***** T1 ACCEPT TRIGGER CONDITIONS  *****'/
     *           ' ========================================='/
     *  ' T1 BIT  9:  LUMINOSITY CONDITION IN COINCIDENCE ',/
     *  ' T1 BIT 10:  TOTAL LG ENERGY > THRESHOLD 1   ',/
     *  ' T1 BIT 11:  TOTAL LG ENERGY > THRESHOLD 2 AND TAG  ')
C
      WRITE(6,603) NTOFC,IWCOLL,NTFCOL
 603  FORMAT(/,' ***** T1 POSTPONE TRIGGER CONDITIONS  *****'/
     *           ' ==========================================='/
     *  ' T1 BIT  1:  TOTAL ENERGY > THRESHOLD 3, TOF GE ',I3/
     *  ' T1 BIT  2:  TAGGING CONDITION '/
     *  ' T1 BIT  5:  WIDE COPL. TOF WIDTH .LE.',I2,'  AND TOF < ',I2)
C
      IF( HWCOLN .EQ. 1) WRITE(6,606) IWCOLN, NTFCLN
  606 FORMAT(
     *  ' T1 BIT  6:  NARROW COPL. TOF WIDTH .LE.',I2,'  AND TOF < ',I2)
C
      IF( HMPRON .EQ. 1) WRITE(6,604) IWMPRG,HFMPRL,HFMPRH
  604 FORMAT(
     *  ' T1 BIT  7:  MULTIPR. COPL. TOF WIDTH .LE.',I2,' .AND.TOF.GE.',
     * I2,' .AND.TOF.LE.',I2)
C
C
C
      WRITE(6,612) HITCLL,HITWLL,HITSUM
  612 FORMAT(/   ' ***** PARAMETERS FOR TRIGGER T2 *****'/
     *           ' ==================================================='/
     *  ' HIT CELL= NO.OF HITS/CELL GT          ',3I5/
     *  ' HIT WALL= NO.OF HITS/CELL GT          ',3I5/
     *  '           AND SUM IN ADJACENT CELLS GT',3I5)
C
      IF(JJSUM.NE.48.OR.KKSUM.NE.0) WRITE(6,613) HMASK,HDEADC
  613 FORMAT(
     *  ' JETC WIRE DISABLE (=0) MASK     ',3(16I1,4X)/
     *  ' DEAD CELLS (16 WIRES SET)       ',10I4)
C
      WRITE(6,614) HACC1,HACC2,HACC3
  614 FORMAT(
     *  ' T2 ACCEPT1 (T1 POSTPONE BIT  1):   NO. ALL  TRACKS GE ',I4/
     *  ' T2 ACCEPT2 (T1 POSTPONE BIT  5):   NO. FAST TRACKS GE ',I4/
     *  ' T2 ACCEPT3 (T1 POSTPONE BIT  2):   NO. ALL  TRACKS GE ',I4)
      IF( HWCOLN .EQ. 1) WRITE(6,615) HACC4
  615 FORMAT(
     *  ' T2 ACCEPT4 (T1 POSTPONE BIT  6):   NO. FAST TRACKS GE ',I4)
      IF( HMPRON .EQ. 1) WRITE(6,616) HACCM
  616 FORMAT(
     *  ' T2 ACCEPT  (T1 POSTPONE BIT  7):   NO. ALL  TRACKS GE ',I4)
C
      IF( HWCOLN .EQ. 1) WRITE(6,617) IWIDT2
  617 FORMAT(' T2 ACCEPT2 AND 4:   TRACK COPLANARITY WIDTH ',I2)
      IF( HWCOLN .NE. 1) WRITE(6,619)
  619 FORMAT(' T2 ACCEPT2 :     NO TRACK COPLANARITY REQUIRED')
C
      WRITE(6,610)
  610 FORMAT(' ==================================================')
C
      GO TO 8000
C
C   1982 - 1986 TRIGGER CONDITIONS
C
1561  CONTINUE
C
      WRITE(6,701) HLGBRT,HLGBST,HLGQT,HLGTOT,HECAPT,HLGTL,HLGTH
 701  FORMAT(/,' ***** LATCH THRESHOLDS  *****'/
     *           ' ============================='/
     *  ' THRESHOLDS FOR BARREL GROUPS',I4,',  BARREL SEPTANTS',I4,
     *  ',  ENDCAP QUADRANTS',I4/
     *  ' THRESHOLDS FOR TOTAL ENERGY  ',4I5,/,
     *  '                BARREL ENERGY ',4I5,/,
     *  '                ENDCAP ENERGY ',4I5,/,
     *  ' THRESHOLDS FOR TAGGING AND LUMINOSITY ENERGY ',2I6)
C
      IF(IHIST(3).EQ.1982) GO TO 1562
      IF(HTGTRG.EQ.0) WRITE(6,699)
699   FORMAT('    INNER RING INCLUDED IN TAGGING CONDITION')
      IF(HTGTRG.EQ.1) WRITE(6,698)
698   FORMAT('    INNER RING NOT INCLUDED IN TAGGING CONDITION')
C
1562  CONTINUE
      WRITE(6,702)
 702  FORMAT(/,' ***** T1 ACCEPT TRIGGER CONDITIONS  *****'/
     *           ' ========================================='/
     *  ' T1ACC BIT  1:  LUMINOSITY CONDITION IN COINCIDENCE ',/
     *  ' T1ACC BIT  2:  TOTAL ENERGY > THRESHOLD 1   ',/
     *  ' T1ACC BIT  3:  TOTAL ENERGY > THRESHOLD 3 AND TAG  ')
      IF (IHIST(3).GT.1985) WRITE(6,703)
 703  FORMAT(
     *  ' T1ACC BIT  5:  SEPTANT - ECAP QUADRANT COPLANARITY, TOF < 1')
      WRITE(6,704)
 704  FORMAT(
     *  ' T1ACC BIT  9:  BOTH ENDCAP ENERGIES > THRESHOLD 2  ',/
     *  ' T1ACC BIT 10:  SUM OF ECAP ENERGIES > THRESH. 3 AND',
     *  ' BARREL ENERGY > THRESH. 4',/
     *  ' T1ACC BIT 11:  TAG AND BARREL > THRESHOLD 4',/
     *  ' T1ACC BIT 12:  BARREL > THRESHOLD 2',/
     *  ' T1ACC BIT 13:  BOTH ECAP ENERGIES > THRESH. 4  AND ',
     *  ' TOTAL ENERGY > THRESH. 2')
      WRITE(6,705) NRNBSL,NRNBSH,IWIDBS,NTOFBS
 705  FORMAT(
     *  ' T1ACC BIT 14:  NR OF BARREL SEPTANTS GE',I3,', LE',I3,
     *  ',  WIDTH = ',I3,', TOF <',I3)
      IF (IHIST(3).GT.1982) WRITE(6,706) NTOFBS
 706  FORMAT(
     *  ' T1ACC BIT 15:  TAGGING CONDITION AND >= 1 SEPTANT, TOF <',I3)
C
C
C
      WRITE(6,709) NTOFC,NTOFC1,NTOFC2,NTBGC2,NTBGC1,NTBGC
 709  FORMAT(/,' ***** T1 POSTPONE TRIGGER CONDITIONS  *****'/
     *           ' ==========================================='/
     *  ' T1PSP BIT  1:  TOTAL ENERGY > THRESHOLD 4, TOF GE ',I3/
     *  ' T1PSP BIT  3:  SUM OF ECAP ENERGIES > THRESHOLD 2, TOF GE',I2/
     *  ' T1PSP BIT  4:  TOF < ',I2,' TBG NEIGHBOR SUPRESSED GE ',I3/
     *  ' T1PSP BIT  9:  TBG > ',I3,',  BARREL ENERGY > THRESHOLD 4',/
     *  ' T1PSP BIT 10:  TAGGING CONDITION AND TBG > ',I2)
      IF (IHIST(3).GT.1984) WRITE(6,710) NTFBS2
 710  FORMAT(
     *  ' T1PSP BIT 11:  SEPTANT COPLANARITY LIKE T1ACC BIT 14,',
     *  ' TOF > 0 AND TOF < ',I2)
      IF (IHIST(3).GT.1985) WRITE(6,711)
 711  FORMAT(
     *  ' T1PSP BIT 12:  TAGGING CONDITION, TOF > 0, >= 1 SEPTANT')
      WRITE(6,712) IWCOLL,NTFCOL,IWCOLN,NTFCLN,IWCTBG
 712  FORMAT(
     *  ' T1PSP BIT 13:  WIDE COPL. TOF WIDTH .LE.',I2,
     *  '  AND TOF <',I2,/
     *  ' T1PSP BIT 14:  NARROW COPL. TOF WIDTH .LE.',I2,
     *  '  AND TOF <',I2,/
     *  ' T1PSP BIT 15:  COPL. TBG WIDTH .LE.',I2)
      IF (IHIST(3).GT.1984) WRITE(6,717) HT1ACC,HT1PSP
 717  FORMAT(
     *  ' T1 ACCEPT AND ENABLE WORDS (HEAD 37-38), ',Z4,2X,Z4,' (HEX.)')
C
C  T2 ACCEPT
C
      WRITE(6,612) HITCLL,HITWLL,HITSUM
C
      IF(JJSUM.NE.48.OR.KKSUM.NE.0) WRITE(6,613) HMASK,HDEADC
C
      WRITE(6,713) HACC1,HACC2,HACC3,HACC4
 713  FORMAT(
     *  ' T2 ACCEPT1 (T1 POSTPONE BIT  1):   NO. ALL  TRACKS GE ',I4/
     *  ' T2 ACCEPT1 (T1 POSTPONE BIT  4):   NO. ALL  TRACKS GE ',I4/
     *  ' T2 ACCEPT3 (T1 POSTPONE BIT  9):   NO. FAST TRACKS GE ',I4/
     *  ' T2 ACCEPT3 (T1 POSTPONE BIT 10):   NO. FAST TRACKS GE ',I4)
C
      IF (IHIST(3).GT.1984) WRITE(6,714) HACCB1
 714  FORMAT(
     *  ' T2 ACCEPT3 (T1 POSTPONE BIT 11):   NO. ALL  TRACKS GE ',I4)
C
      IF (IHIST(3).GT.1985) WRITE(6,715) HACCB2
 715  FORMAT(
     *  ' T2 ACCEPT3 (T1 POSTPONE BIT 12):   NO. ALL  TRACKS GE ',I4)
C
      WRITE(6,716) IWIDT2
 716  FORMAT(
     *  ' T2 ACCEPT4 (T1 POSTPONE BIT 13-15):   NO. FAST TRACKS GE 2 ',
     *  ', COLLINEAR TRACKS, WIDTH <= ',I4)
      WRITE(6,630)
  630 FORMAT(' =================================================='/)
C
 8000 CONTINUE
      RETURN
      END

C   12/08/87 805171157  MEMBER NAME  CHIEN5   (S)           FORTRAN77
CC    SUBROUTINE CHIEN5(ITR,PTR,XST,YST,ZST,ZVER,CHA,CHI2N,PCHI2,ICLUR)
      SUBROUTINE CHIEN5(ITR,PTR,ESHM,ZVER,CHA,CHI2N,PCHI2,ICLUR)
C
C   COPIED FROM F11HEL.ES(CHIEN5)
C   LAST MOD 4/1/88 ADDED IFIND INIT   E ELSEN
C
C   BIT 31 ICLUR = 0 BEI EINGABE --> PHI IMPACT FROM TRKBLK OPTIMIZATION
C   BIT 31 ICLUR = 1 BEI EINGABE --> PHI IMPACT FROM ID
C
C   BIT 30 ICLUR = 1 WRITE BLOCK + ENERGIE LIST
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
      REAL*8 XVA8(5),ZCO8(5),GUESS,CHI8,ZMIN
C
#include "cdata.for"
#include "cgeo1.for"
C
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
C
C                            CLDAT IS FILLED IN CLUSIN
      COMMON /CLDAT/ NUMBLO,NBLIST(40),ENLIST(40),IPACL,ECLCO,ECLUN,
     *               PIMP1,PIMP2
      DIMENSION ZCO(5), VERT(3), XVA(5)
      DATA ZINTV / 40./
      DATA PHCNST /1.499E-5/, TWOPI /6.283185/
C
      IPHI=0
      IF(TBIT(ICLUR,31)) IPHI=1
      IPRI=0
      IF(TBIT(ICLUR,30)) IPRI=1
      ICLUR=0
      IFIND = 0
C     ECLCO=0.
C     ECLUN=0.
C     ICLUST=1
C     CALL CLUSIN(ITR,ICLUST,IFIND)
      ECLCO=ESHM*1000.
      ECLUN=EBITER
      NUMBLO=0
CCC             IPACL GIVES LG DETECTOR PART -1,0,1 FOR -Z,BARREL,+Z
      IPACL=0
C                    FILL MEICL AND NEICL INTO NBLIST AND ENLIST
      DO 990 IM=1,NBLO
      IF(NEICL(IM).LE.0) GOTO 990
      NUMBLO=NUMBLO+1
      NBLIST(NUMBLO)=MEICL(IM)
      ENLIST(NUMBLO)=NEICL(IM)
  990 CONTINUE
C
      IF(NUMBLO.GE.1) IFIND=1
      IF(IFIND.EQ.0) GOTO 1170
C
      NBMX = MIN0 (NUMBLO, 9)
       IF(IPRI.EQ.1) WRITE (6,1013) ITR,NUMBLO,
     +                (NBLIST(LL),ENLIST(LL),LL=1,NBMX  )
 1013 FORMAT (  1X,'       NCLU,..',4X,2I4,3X, 9(I5,F6.0))
C
C                            CALCULATE CHI2 OF SHOWER PROFILE
C                            FILL LG IMPACT POINT VARIABLES
C                            FOR PHI SEE ABOVE
C                            FOR Z USE TRKBLK OPTIMIZED VALUE ZI
C
      ATID=ATAN2 (YSTART,XSTART)
C                                           MOD 13/08/87 E E
C     IF (ATFI.LE.0.) ATID=ATID+TWOPI
      IF (ATID.LE.0.) ATID=ATID+TWOPI
C                                           END MOD
      ATFI=ATAN2 (YI,XI)
      IF (ATFI.LE.0.) ATFI=ATFI+TWOPI
C
      IF(IPHI.EQ.0) PIMP1=ATFI
      IF(IPHI.GT.0) PIMP1=ATID
C
      PIMP2=ZI
C
C     IF (IPRINT.LT.50)
C    + WRITE (6,1017) ITR,PIMP1,PIMP2,ATFI,ZST
C
C                            CALC EFFECTIVE VERTEX IN X, Y
C
      PHARG= PHCNST * RLG * ABS(BKGAUS) / PTR
      IF(PHARG.GT.1.) GOTO 1180
      PHI0H=ASIN (PHARG)
      DIST= RLG  * TAN(PHI0H)
      XDIST=DIST*SIN( ATFI )
      YDIST=DIST*COS( ATFI )
      VERT(1)= + CHA*XDIST
      VERT(2)= - CHA*YDIST
C                            GET Z - VERTEX OF EVENT
CC    IPZV=IDATA(IBLN('ZVTX'))
CC    IF (IPZV.EQ.0) CALL ZVERTF
      VERT(3)=ZVER
CC    IF (IPRINT.LT.50)
CC   + WRITE (6,1017) ITR,PTR,PHI0H,DIST,X0,Y0,XDIST,YDIST,VERT,RLG
C1017 FORMAT (1X,' VTX 'I4,11F10.3)
C
C                            CALC CHI2 FOR THREE POINTS AROND ZSTART
      CHIMI=100000.
      Z1=ZI-2.*ZINTV
      DO 520 KF=1,5
      ZCO(KF)=Z1+(KF-1)*ZINTV
      PIMP2=ZCO(KF)
C
        CALL SHWCPR (VERT,CHI2)
C
      XVA(KF)=CHI2
      IF (KF.LT.2.OR.KF.GT.4) GOTO 520
      IF (CHI2.LT.CHIMI) CHIMI=CHI2
  520 CONTINUE
C                            MINIMUM OUTSIDE PRESENT RANGE OF Z
      IF (XVA(1).GT.CHIMI) GO TO 521
C                            OUT LEFT
      XVA(5)=XVA(4)
      XVA(4)=XVA(3)
      XVA(3)=XVA(2)
      XVA(2)=XVA(1)
      ZCO(5)=ZCO(4)
      ZCO(4)=ZCO(3)
      ZCO(3)=ZCO(2)
      ZCO(2)=ZCO(1)
      ZCO(1)=ZCO(1)-ZINTV
      PIMP2=ZCO(1)
        CALL SHWCPR (VERT,CHI2)
      XVA(1)=CHI2
      GO TO 530
C                            OUT RIGHT
  521 CONTINUE
      IF (XVA(5).GT.CHIMI) GO TO 530
      XVA(1)=XVA(2)
      XVA(2)=XVA(3)
      XVA(3)=XVA(4)
      XVA(4)=XVA(5)
      ZCO(1)=ZCO(2)
      ZCO(2)=ZCO(3)
      ZCO(3)=ZCO(4)
      ZCO(4)=ZCO(5)
      ZCO(5)=ZCO(5)+ZINTV
      PIMP2=ZCO(5)
        CALL SHWCPR (VERT,CHI2)
      XVA(5)=CHI2
  530 CONTINUE
C                            SOLVE FOR MINIMUM CHI2
      DO 540 I8=1,5
      ZCO8(I8)=ZCO(I8)/100.
  540 XVA8(I8)=XVA(I8)/100.
      GUESS=ZI/100.
      CALL REGN(ZCO8,XVA8,GUESS,ZMIN,CHI8)
C
      PIMP2=ZMIN*100.
C                            FINAL CALL TO 'SHWCPR'
        CALL SHWCPR (VERT,CHI22)
C
      CHI2N = CHI22 / NUMBLO
      PCHI2=PROB(CHI22,NUMBLO)
C
      RETURN
 1170 WRITE(6,1175)
 1175 FORMAT(1X,'     >>>>> IFIND = 0 <<<<<')
      ICLUR=2
      RETURN
 1180 WRITE(6,1185) PHARG,PHCNST,RLG,BKGAUS,PTR
 1185 FORMAT(1X,' ARGUMENT ARSIN.GT.1 <<<<<',F10.5,/,1X,4F20.10)
      CHI2N=-1.
      PCHI2=-1.
      ICLUR=2
      RETURN
      END
      SUBROUTINE REGN(X,Y,GUESS,ZMIN,CHI8)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA N /5/, ND /2/, IMAX/100/, XN/1.D-3/, IN/1/
C
C   NTH-ORDER REGRESSION
C   ND IST DER GRAD DER GLEICHUNG
C   MINIMALE DIMENSIONEN A(2ND+1), R(ND+1,ND+2), T(ND+2)
C                        C(ND), CB(ND)
C   DIMENSION (M) DER MATRIX = ND+1
C
C   + SUCHE DES MAXIMUMS DES GEFUNDENEN POLYNOMS, WENN IN=1
C         GUESS = SCHAETZUNG DES MAXIMUMS
C         IMAX = MAXIMALE ITERATIONSZAHL
C         XN = GENAUIGKEIT
C
      DIMENSION A(21), R(11,12), T(12), PKOF(11)
      DIMENSION AA(11,11), B(11,11), C(11), CB(11)
C   ANZAHL DER PUNKTE N --> DIMENSION X(N), Y(N)
      DIMENSION X(5),Y(5)
C
      DO 10 I=1,21
   10 A(I)=0.D0
      DO 20 I1=1,11
      T(I1)=0.D0
      PKOF(I1)=0.D0
*** PMF10/12/99      C(I)=0.D0
*     CB(I)=0.D0
* see chien52.F
      C(I1)=0.D0
      CB(I1)=0.D0
*** PMF(end)
      R(I1,12)=0.D0
      DO 20 I2=1,11
      AA(I1,I2)=0.D0
      B(I1,I2)=0.D0
   20 R(I1,I2)=0.D0
      T(12)=0.D0
      NDE=2*ND+1
      ND1=ND+1
      ND2=ND+2
C
      A(1)=N
      DO 50 I=1,N
      DO 30 J=2,NDE
   30 A(J)=A(J)+X(I)**(J-1)
      DO 40 K=1,ND1
      R(K,ND2)=T(K)+Y(I)*X(I)**(K-1)
   40 T(K)=T(K)+Y(I)*X(I)**(K-1)
      T(ND2)=T(ND2)+Y(I)**2
   50 CONTINUE
C
      DO 60 J=1,ND1
      DO 60 K=1,ND1
   60 R(J,K)=A(J+K-1)
C
C
C                          MATRIXINVERSION
      M=ND+1
      DO 90 J=1,M
      DO 80 I=1,M
   80 AA(J,I)=R(J,I)
   90 B(J,J)=1.D0
C
      DO 160 J=1,M
      DO 100 I=J,M
      IF(AA(I,J).LT.0.D0) GOTO 110
  100 IF(AA(I,J).GT.0.D0) GOTO 110
      WRITE(6,1001)
 1001 FORMAT(//,1X,' MATRIX SINGULAER')
      GOTO 400
  110 DO 120 K=1,M
      S=AA(J,K)
      AA(J,K)=AA(I,K)
      AA(I,K)=S
      S=B(J,K)
      B(J,K)=B(I,K)
      B(I,K)=S
  120 CONTINUE
      D=1.D0/AA(J,J)
      DO 130 K=1,M
      AA(J,K)=D*AA(J,K)
  130 B(J,K)=D*B(J,K)
      DO 150 L=1,M
      IF(L.EQ.J) GOTO 150
      D=-AA(L,J)
      DO 140 K=1,M
      AA(L,K)=AA(L,K)+D*AA(J,K)
  140 B(L,K)=B(L,K)+D*B(J,K)
  150 CONTINUE
  160 CONTINUE
C
C  BERECHNUNG DER KOEFFIZIENTEN DES POLYNOMS
C
      DO 200 J=1,M
      PKOF(J)=0.D0
      DO 200 I=1,M
  200 PKOF(J)=PKOF(J)+B(I,J)*R(I,ND2)
      DO 210 J=1,M
  210 JK=J-1
C
C
C                         MAXIMUMSUCHE, WENN IN=1
      IF(IN.NE.1) GOTO 400
C
C   1. UND 2. ABLEITUNG DER FUNKTION
C
      DO 300 I=1,ND
  300 C(I)=PKOF(I+1)*I
      NDM1=ND-1
      DO 310 I=1,NDM1
  310 CB(I)=C(I+1)*I
C
C   SUCHE NULLSTELLE DER 1. ABLEITUNG
C   NACH DEM NEWTONSCHEN NAEHERUNGSVERFAHREN
C
      XG=GUESS
      II=0
  320 S=1.D0
      F1=0.D0
      F0=0.D0
      II=II+1
      DO 330 I=1,ND
C CALCULATE VALUE OF FUNCTION
      F0=F0+C(I)*S
C CALCULATE VALUE OF DERIVATIVE
      F1=F1+CB(I)*S
      S=S*XG
  330 CONTINUE
C TEST FOR A ZERO DERIVATIVE, IF YES, STOP SEARCH, PRINT
      IF(F1.EQ.0.D0) GOTO 360
C GET NEW GUESS USING PREVIOUS GUESS
      S=XG-F0/F1
C IF NEW GUESS = LAST GUESS WITHIN XN STOP SEARCH, PRINT
      XS=DABS(XG-S)
      IF(XS.LT.XN) GOTO 370
C SAVE LAST GUESS
      XG=S
      IF(II.GE.IMAX) GOTO 370
      GOTO 320
C
C
  360 WRITE(6,3601) XG
 3601 FORMAT(//,1X,' DERIVATIVE = 0  AT  X =',F8.4)
      GOTO 400
C
  370 YG=PKOF(1)
      DO 380 J=2,ND1
  380 YG=YG+PKOF(J)*XG**(J-1)
      ZMIN=XG
      CHI8=YG
C
  400 RETURN
      END

C   08/01/79 C9010801   MEMBER NAME  LGNMBR   (JADELGS)     FORTRAN
      SUBROUTINE LGNMBR(XYZ,NGLASS)
C
C     S.YAMADA   09-10-78  10:20  COPIED FROM LGSOURCE ON 08-01-79
C     LAST MODIFICATION  09-01-79  20:15
C
C---- CALCULATE THE GLASS NUMBER OF COORDINATE XYZFOR THE BARREL PART.
C
      DIMENSION XYZ(3)
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     1                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     2                ZECAP(4),ZECAPX(4),THECPX(2),
     3                ECXLST(24), ECYLST(24)
      DATA PHIDEV/7.47998E-2/
C
      NGLASS = -1
      PHI = ATAN2(XYZ(2),XYZ(1))
      IF(PHI.LT.0.) PHI = PHI+6.283184
      IPHI = PHI/PHIDEV
      IF(IPHI.GE.84) IPHI = IPHI-84
C
      IZ =(XYZ(3)-ZENDX0(1))/(ZWID(2)+ZGAP(2))
      IF(IZ.LT.0.OR.IZ.GT.31) RETURN
      NGLASS = IZ+32*IPHI
      RETURN
      END

C   14/05/79 C9091801   MEMBER NAME  MUWIRE   (JADEMUS2)    FORTRAN
C   13/12/78 C9032201   MEMBER NAME  MUTINW   (JADEMUS)     FORTRAN
      SUBROUTINE MUWIRE(ICHAM,X,Y,Z)
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C
C PROVIDES X,Y,Z COORDINATES OF ONE END OF THE WIRE OF CHAMBER ICHAM.
C
C INPUT VARIABLES...
C
C ICHAM       CHAMBER NUMBER.
C
C OUTPUT VARIABLES...
C
C X,Y,Z       THE COORDINATES OF ONE END OF THE WIRE.
C
C-----------------------------------------------------------------------
C
C COMMONS
C
#include "cmucalib.for"
C
C-----------------------------------------------------------------------
C
C FRAME NUMBER.
      IFRAME=HFR(ICHAM)
C
C ORIENTATION PARAMETER.
      IOR=HNORM(IFRAME)
C
C CALCULATE THE NORMAL COORDINATE.
      ICNORM=HDIST(IFRAME)+HD1(ICHAM)
C
C CALCULATE THE LOGITUDINAL COORDINATE.
      ICLONG=HCLLO(IFRAME)
C
C CALCULATE THE WIRE COORDINATE.
      ICWIRE=HCTW(ICHAM)
C
C X,Y,Z COORDINATES
      GO TO (11,12,13),IOR
 11   CONTINUE
      X=ICNORM
      Y=ICWIRE
      Z=ICLONG
      GO TO 20
 12   CONTINUE
      X=ICWIRE
      Y=ICNORM
      Z=ICLONG
      GO TO 20
 13   CONTINUE
      X=ICWIRE
      Y=ICLONG
      Z=ICNORM
 20   CONTINUE
C
C MAKE OVERALL TRANSLATION.
      X=X+HOVALL(HUNIT(IFRAME))
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
      RETURN
      END

C   05/05/85 807251153  MEMBER NAME  ZCASS    (JADEGS)      FORTRAN77
************************************************************************
      SUBROUTINE ZCASS(IPATT,NTPAT,NWPAT,NASS1,NASS2)
************************************************************************
*                                                                      *
*     ASSOCIATES Z-CHAMBER HITS WITH PATR TRACKS AND FILLS RESULTS     *
*     INTO RZTRK, IZTRK AND IZASS ARRAYS                               *
*                                                                      *
*     INPUT ARGUMENTS : IPATT     = POINTER TO 1ST TRACK IN PATR       *
*                       NTPAT     = NUMBER OF PATR TRACKS              *
*                       NWPAT     = NUMBER OF WORDS/TRACK IN PATR      *
*                                                                      *
*     OUTPUT          : FILLED COMMON/CZTRK/ AND COMMON/CZASS/         *
*                       NASS1     = NO. OF TRACKS WITH .GE.1 Z-C HIT   *
*                       NASS2     = NO. OF TRACKS WITH 2 Z-CH HITS     *
*                                                                      *
*  20/5/88     ADD RRTRK TO RECORD RADII OF INTERSECTIONS, EE          *
*  25/7/88     CORRECT RRTRK TYPO IN IER.NE.0 BRANCH       EE          *
*                                                                      *
************************************************************************
*
******COMMONBLOCKS
      COMMON/CZDATA/JZDATA(64),IZDATA(3,8,64),RZDATA(3,8,64)
******              JZDATA(NW)        NUMBER OF HITS ON WIRE NW
*                   IZDATA(*,         ADC1,ADC2,TDC
*                            NH,      HIT NUMBER (1--8)
*                               NW)   WIRE NUMBER (1--64)
*                   RZDATA(*,         Z-DZ,Z+DZ,PHI
******                       NH,NW)   HIT NO, WIRE NO.
      COMMON/CZTRK /RZTRK(5,100),IZTRK(3,2,100), RRTRK(2,100)
******              RZTRK(*,NTR)      ZI1,PHI1,ZI2,PHI2,TANTH
*                                         FOR TRACK NUMBER NTR
*                   IZTRK(*,          IM(=1,-DZ,=2,+DZ),NH,NW
*                           IL,       LAYER(=1,INNER,=2,OUTER)
*                              NTR)   TRACKNO
******              RRTRK(*,   NTR)   RI1, RI2 FOR TRACK NTR
      COMMON/CZASS /IZASS(8,64)
******
*                   IZASS(I,NW)       NTR ASS. WITH I'TH HIT ON WIRE NW
******
      COMMON/CZCALI/IBAD(64),IZPED(2,64),IZT0(64)
******              IBAD(NW)          =1 IF ONLY ONE PRE-AMP WORKS
*                   IZPED(I,NW)       PEDESTAL FOR ADCI OF WIRE NW
*                   IZT0(NW)          TIME ZERO FOR WIRE NW
******                                ALL SET IN ZCHCAL
      COMMON/CZEXT /XT, YT, ZT,XI1,YI1,ZI1,XI2,YI2,ZI2
******              XT, YT, ZT        LAST POINT ON TRACK
*                   XI1,YI1,ZI1       INTERSECTION WITH INNER LAYER
*                   XI2,YI2,ZI2            ''       ''  OUTER LAYER
******              COMMON FILLED FOR EACH PATR TRACK BY SUBR *ZEXTRA*
*%MACRO CBCS
C ----------------------------------------------- BOS COMMON
      COMMON/BCS/IW(1)
      REAL RW(1)
      INTEGER*2 HW(1)
      EQUIVALENCE(IW(1),RW(1),HW(1))
C ----------------------------------------------- END BOS DECLARATIONS
******ARRAYS AND DECLARATIONS
      REAL ZWIR(64)      /-1126.,-1124.,  -976., -974.,  -826., -824.,
     *                     -676., -674.,  -526., -524.,  -376., -374.,
     *                     -226., -224.,   -76.,  -74.,
     *                                      76.,   74.,   226.,  224.,
     *                      376.,  374.,   526.,  524.,   676.,  674.,
     *                      826.,  824.,   976.,  974.,  1126., 1124.,
     *                    -1126.,-1124.,  -976., -974.,  -826., -824.,
     *                     -676., -674.,  -526., -524.,  -376., -374.,
     *                     -226., -224.,   -76.,  -74.,
     *                                      76.,   74.,   226.,  224.,
     *                      376.,  374.,   526.,  524.,   676.,  674.,
     *                      826.,  824.,   976.,  974.,  1126., 1124./
      REAL DZMIN(2),DZ(2),DFIMIN(2)
      LOGICAL LPHI/.TRUE./
      PARAMETER(PI=3.1415927,TWOPI=6.2831853,
     *          PHICUT=0.349,ZCUT=75.,DWIR=10.)
***** END ARRAYS AND DECLARATIONS
********************************** C O D E *****************************
      DO 100 I=1,NTPAT
         IPAT = IPATT + (I-1)*NWPAT
         CALL ZEXTRA(IPAT,IER)
*             ZEXTRA EXTRAPOLATES TRACK TO Z-CH.
*                    IER NON-ZERO IF NO INTERCEPT, OR INTERCEPT
*                    WITHIN DEAD SPACES OF Z-CHAMBER.
         IF(IER.NE.0)              THEN
            RZTRK(1,I) = 9999.
            RZTRK(2,I) = IER
            PHI        = ATAN2(YT,XT)
            IF(PHI.LT.0.)          PHI  = PHI  + TWOPI
            RZTRK(4,I) = PHI
            RRTRK(1,I) = SQRT( XT**2+YT**2)
            RRTRK(2,I) = RRTRK(1,I)
            GOTO 100
         ELSE
            RZTRK(1,I) = ZI1
            PHI1       = ATAN2(YI1,XI1)
            IF(PHI1.LT.0.)         PHI1 = PHI1 + TWOPI
            RZTRK(2,I) = PHI1
            RZTRK(3,I) = ZI2
            PHI2       = ATAN2(YI2,XI2)
            IF(PHI2.LT.0.)         PHI2 = PHI2 + TWOPI
            RZTRK(4,I) = PHI2
            RZTRK(5,I) = RW(IPAT+30)
            RRTRK(1,I) = SQRT( XI1**2+YI1**2)
            RRTRK(2,I) = SQRT( XI2**2+YI2**2)
         ENDIF
         NCELL = (ZI1+1200.)/150.
         NWIRE = 2*NCELL + 1
         IF(XI1.LT.0.)             NWIRE = NWIRE + 32
         NWLOW = NWIRE - 2
         NWHIGH= NWIRE + 3
*********
*        TAKE CARE OF WIRES NEAR THE CHAMBER ENDS
*********
         IF(NWLOW .LT. 1)                         NWLOW =  1
         IF(NWLOW .LE.32 .AND. NWIRE.GE.33)       NWLOW = 33
         IF(NWHIGH.GT.64)                         NWHIGH= 64
         IF(NWHIGH.GE.33 .AND. NWIRE.LE.32)       NWHIGH= 32
*********
*        LOOP OVER HITS IN CELLS N-1 TO N+1 (WHERE N IS THE
*        CELL HIT BY THE TRACK) LOOKING FOR MATCHING Z-HITS.
*********
         DZMIN(1)  = 9999.
         DZMIN(2)  = 9999.
         DFIMIN(1) = 9999.
         DFIMIN(2) = 9999.
         DO 110 NW=NWLOW,NWHIGH
            NH = JZDATA(NW)
            IF(NH.LE.0)            GOTO 110
            IL = MOD(NW-1,2) + 1
            ZI = RZTRK(2*IL-1,I)
            FI = RZTRK(2*IL,  I)
            DO 120 N=NH,1,-1
               IF(N.NE.NH)         THEN
                  DTDC = IZDATA(3,N,NW)-IZDATA(3,N+1,NW)
                  FIN  = RZDATA(3,N,NW)
                  FIN1 = RZDATA(3,N+1,NW)
C  I DON'T UNDERSTAND WHAT THE FOLLOWING STATEMENTS
C  ARE INTENDED FOR BUT PROBABLY DO NOT DO IT    J.SPITZER  24/7/87
                  IF(FIN .LT.PI/2.)     FIN = FIN +TWOPI
                  IF(FIN1.LT.PI/2.)     FIN1= FIN1+TWOPI
                  DFIZ = ABS(FIN-FIN1)
                  IF(DTDC.LT.30 .AND. DFIZ.LT.PHICUT)        THEN
                     IZASS(N,NW) = -1
                     GOTO 120
                  ENDIF
               ENDIF
************
*              IF DPHI > PHICUT (20 DEG) NO MATCH UNLESS WIRE IS BAD
************
C              DPHI  = FI - RZDATA(3,N,NW)
C  REPLCED   J.SPITZER  24/7/87
               DPHI  = ACOS(COS(FI - RZDATA(3,N,NW)))
               IF(IBAD(NW).EQ.0 .AND. ABS(DPHI).GT.PHICUT)   GOTO 120
               DZ(1) = ZI - RZDATA(1,N,NW)
               DZ(2) = ZI - RZDATA(2,N,NW)
               IM    = 1
               IF(ABS(DZ(2)) .LT.ABS(DZ(1)))                 IM = 2
               IF(LPHI .AND. IBAD(NW).EQ.0)                  THEN
                  IF(ABS(DPHI).GE.ABS(DFIMIN(IL)))           THEN
                     GOTO 120
                  ELSEIF(ABS(DZ(IM)).LT.ZCUT)                THEN
                     DFIMIN(IL) = DPHI
                  ENDIF
               ELSEIF(ABS(DZ(IM)).GE.ABS(DZMIN(IL)))         THEN
                  GOTO 120
               ENDIF
**************
*              ACCEPT ONLY IF DZ<ZCUT (75 MM)
**************
               IF(ABS(DZ(IM)).LT.ZCUT)                       THEN
                  DZMIN(IL)     = DZ(IM)
                  IZTRK(1,IL,I) = IM
                  IZTRK(2,IL,I) = N
                  IZTRK(3,IL,I) = NW
               ENDIF
 120        CONTINUE
 110     CONTINUE
*********
*        NOW DO ANGULAR CORRECTIONS USING TANTH (TRACK)
*********
         TTR = RZTRK(5,I)
         CTR = ABS(COS(ATAN(TTR)))
C        CALL HIST(902,CTR)
C        CALL CORR(903,TTR,CTR)
         IMI = IZTRK(1,1,I)
         IHI = IZTRK(2,1,I)
         IWI = IZTRK(3,1,I)
         IMO = IZTRK(1,2,I)
         IHO = IZTRK(2,2,I)
         IWO = IZTRK(3,2,I)
C        TZC = (RZDATA(IMO,IHO,IWO)-RZDATA(IMI,IHI,IWI))/DWIR
C INDEX IS JUST GOING TO BE CHECKED
C MOVE ABOVE STATEMENT DOWN TO WHERE IT BELONGS     J.SPITZER  24/7/87
         IF(IMI.NE.0)              THEN
            IZASS(IHI,IWI) = I
            ZTDCO          = ZWIR(IWI)-RZDATA(1,IHI,IWI)
C           CALL HIST(900,ZTDCO)
            IF(ZTDCO.LE.DWIR/2.)   THEN
               ZTDC = ZTDCO/CTR
            ELSE
               ZTDC = ZTDCO + 0.5*DWIR*(1./CTR - 1.)
            ENDIF
C           CALL HIST(901,ZTDC)
C           CALL CORR(904,ZTDCO,ZTDC)
            RZDATA(1,IHI,IWI) = ZWIR(IWI)-ZTDC
            RZDATA(2,IHI,IWI) = ZWIR(IWI)+ZTDC
         ENDIF
         IF(IMO.NE.0)              THEN
            IZASS(IHO,IWO) = I
            ZTDCO          = ZWIR(IWO)-RZDATA(1,IHO,IWO)
C           CALL HIST(900,ZTDCO)
            IF(ZTDCO.LE.DWIR/2.)   THEN
               ZTDC = ZTDCO/CTR
            ELSE
               ZTDC = ZTDCO + 0.5*DWIR*(1./CTR - 1.)
            ENDIF
C           CALL HIST(901,ZTDC)
C           CALL CORR(904,ZTDCO,ZTDC)
            RZDATA(1,IHO,IWO) = ZWIR(IWO)-ZTDC
            RZDATA(2,IHO,IWO) = ZWIR(IWO)+ZTDC
         ENDIF
         IF(IMI.NE.0  .OR. IMO.NE.0)              NASS1 = NASS1+1
         IF(IMI.NE.0 .AND. IMO.NE.0)              THEN
            TZC = (RZDATA(IMO,IHO,IWO)-RZDATA(IMI,IHI,IWI))/DWIR
            NASS2 = NASS2+1
************
*           CHECK CHOICE OF MIRROR USING TAN THETA
************
            IF(ABS(TTR-TZC).GT.0.2)               THEN
               TZ1 = RZDATA(3-IMO,IHO,IWO)-RZDATA(3-IMI,IHI,IWI)
               TZ2 = RZDATA(  IMO,IHO,IWO)-RZDATA(3-IMI,IHI,IWI)
               TZ3 = RZDATA(3-IMO,IHO,IWO)-RZDATA(  IMI,IHI,IWI)
               IF(ABS(TTR-TZ1/DWIR).LT.0.3)       THEN
                  IZTRK(1,1,I) = 3-IMI
                  IZTRK(1,2,I) = 3-IMO
               ELSEIF(ABS(TTR-TZ2/DWIR).LT.0.3)   THEN
                  IZTRK(1,1,I) = 3-IMI
               ELSEIF(ABS(TTR-TZ3/DWIR).LT.0.3)   THEN
                  IZTRK(1,2,I) = 3-IMO
               ENDIF
            ENDIF
         ENDIF
 100  CONTINUE
      RETURN
      END

C   23/08/85 511061950  MEMBER NAME  MCTAGI   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      SUBROUTINE MCTAGI
C
C INITIALISATION ROUTINE FOR TAGGING MONTE CARLO ROUTINES
C  - MUST BE CALLED ONCE PER EVENT
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       IMPLICIT INTEGER*2 (H)
C
      COMMON/TODAY/HDATE(6)
#include "cmctag.for"
C   CALIB - CALIBRATION THAT CONVERTS ADC CHANNEL NUMBER INTO ENERGY
      REAL*4 CALIB(10)/ 5.5,10.0,10.0,7*6.667/
      REAL*4 SIGMA(10)/0.26,0.35,0.35,7*0.10/
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C     DIMENSION IWF(3)
C     DATA IWF/3*0/
      DATA ICALL/0/
C
C
C
C
C ===== CODE ========
C
      ICALL = ICALL + 1
      IHIT = 0
C
      CALL VZERO(HGG,96)
C
C
C CHOOSE VALUE OF MARKMC BASED ON DATE
C
      MARKMC = 0
       IF(HDATE(6).GE.1979.AND.HDATE(6).LE.2000)GOTO 5
999    IF(ICALL.EQ.1)WRITE(6,6000)
6000   FORMAT(/,/,/,'  WARNING FROM MCTAGI HDATE(6) NOT SET ',
     1 /,' DEFAULT TAGGER MC IS MARKMC = 3 (1981/2) ')
      MARKMC = 3
                         GOTO 6
C
5      IF(HDATE(6).LE.1980)MARKMC = 1
       IF(HDATE(6).GE.1983)MARKMC = 4
       IF(HDATE(6).EQ.1982)MARKMC = 3
C THIS ONLY LEAVES 1982 TO DEAL WITH
C - NEED TO USE MONTH TO DECIDE WHETHER OR NOT THERE ARE SNOUTS
       IF(MARKMC.EQ.0.AND.HDATE(5).LT.8)MARKMC = 2
       IF(MARKMC.EQ.0)MARKMC = 3
C
      IF(ICALL.EQ.1)WRITE(6,6001)HDATE(4),HDATE(5),HDATE(6),MARKMC
6001  FORMAT(/,/,/,'  DATE TAKEN FROM COMMON 1TODAY IS ',
     1I2,'/',I2,'/',I4,' SO MARKMC FOR TAGGER SET TO ',I2)
C
 6    CONTINUE
C
C MARKMC IS NOW SET
C
C JUST CHECK
      IF(MARKMC.LT.1.OR.MARKMC.GT.4)GOTO 999
C
C
      IF(MARKMC.EQ.1)INMARK = 0
      IF(MARKMC.EQ.2)INMARK = 1
      IF(MARKMC.EQ.3)INMARK = 1
      IF(MARKMC.EQ.4)INMARK = 2
C
C WRITE OUT A FURTHER  INITIAL MESSAGE
C
      ITMRK = INMARK + 1
       IF(ICALL.EQ.1)WRITE(6,678)ITMRK
678    FORMAT(/,
     1' ++++++++++++++++++++++++++++++++++++++++++++++++++++',/,
     1' +                                                  +',/,
     1' +               FIRST CALL TO MCTAGI               +',/,
     1' +                                                  +',/,
     1' +                 MARK ',I1,8X,'                   +',/,
     1' +             TAGGER IS BEING SIMULATED            +',/,
     1' +                                                  +',/,
     1' +                                                  +',/,
     1' +              CHECK THAT TAGAN AGREES             +',/,
     1' +                   WITH THIS IN                   +',/,
     1' +                ANALYSIS (TP) STEP                +',/,
     1' +                                                  +',/,
     1' +    SEE JADE COMPUTER NOTES 74 AND 86 FOR MORE    +',/,
     1' +               DETAILS                            +',/,
     1' +                                                  +',/,
     1' ++++++++++++++++++++++++++++++++++++++++++++++++++++')
C
C
C SET SOME VARIABLES FOR LATER
C
        IF(MARKMC.EQ.1)NCHANS = 192
        IF(MARKMC.EQ.2)NCHANS = 64
        IF(MARKMC.EQ.3)NCHANS = 64
        IF(MARKMC.GE.4)NCHANS = 48
C
C    SET UP VALUES FOR MCTAGS,MCTAGR WHICH
C    ARE CALLED FROM LHATAG (ENTRY IN STATAG)
C
      SIGMAS = SIGMA(MARKMC)
      CALIBS = CALIB(MARKMC)
C
C
          RETURN
C
         END

C   23/03/80 705202031  MEMBER NAME  QPLOTS   (S)           FORTRAN
      SUBROUTINE QPLOTS
      IMPLICIT INTEGER*2 (H)
C---
C---     DISPLAY EVENT IN QPLANE PROJECTIONS, DRAW QPLOT ONTO PICTURE
C---      23.03.80              LAST CHANGE 16.07.81     J.OLSSON
C---      2.4.1985    CHANGE OF MOTAPR          KOMAMIYA/OLSSON
C---
#include "cgraph.for"
#include "cdata.for"
C
C
      NN = ACMD
      IF(NN.NE.0) GO TO 100
      CALL TRMOUT(80,'CODE 1: PROJ. ON THE Q2-Q3,Q1-Q2 PLANES WITH ENERG
     $Y HISTOGRAMS^')
      CALL TRMOUT(80,'CODE 2:  PROJ. ON THE Q1-Q2,Q2-Q3 AND Q3-Q1 PLANES
     $^')
      CALL TRMOUT(80,'CODE 3:  TRIANGEL PLOT OF Q1, (Q3-Q2)/SQRT(3)^')
      CALL TRMOUT(80,'ENTER OPTION:^')
      NN = TERNUM(DUM)
100   IF(NN.GE.1.AND.NN.LE.3) GO TO 130
      RETURN
130   GO TO (200,300,400),NN
200   CALL EVIPR4
      CALL TRIANQ(500,1100,600,1200)
201   CALL SETSCL(LASTVW)
      RETURN
300   CALL EVIPR2
      CALL TRIANQ(2800,3400,170,770)
      GO TO 201
400   CONTINUE
      CALL TRIANQ(800,1400,0,600)
      GO TO 201
      END
      SUBROUTINE TRIANQ(LXMN,LXMX,LYMN,LYMX)
      IMPLICIT INTEGER*2 (H)
C
C  DISPLAY Q-PLOT   ON SCREEN WINDOW  LXMN,LXMX,LYMN,LYMX
C                 J.OLSSON   24.03.80       LAST CHANGE  24.03.80
C
#include "cdata.for"
#include "cgraph.for"
C
      DATA NHITMN/24/
C
      IPP= IBLN('PATR')
      INPA= IDATA(IPP)
      IF(INPA.LE.0) GO TO 5100
      CALL SUMPAT(INPA,&3000,&3000)
C
C ----- CALCULATE SPHERICITY AND Q-AXIS
C
      IPRMOM = 0
      CALL CHCLSP(SPH,CSTH1,PHI1,Q1,Q23,NHITMN,IPRMOM,&1500)
      CALL TWINDO(LXMN,LXMX,LYMN,LYMX)
      XMN = -.2
      YMN = -.2
      XMX = .8
      YMX = .8
      CALL DWINDO(XMN,XMX,YMN,YMX)
      CALL MOVEA(0.,0.)
      Y = 1./3.
      CALL DRAWA(0.,Y)
      X = 1./SQRT(3.)
      CALL DRAWA(X,0.)
      CALL DRAWA(0.,0.)
      CALL PLYGON(12,0.008,Q23,Q1,0)
      DO 4062 I = 1,3
      Y = I*.1
      CALL MOVEA(-.012,Y)
      CALL DRAWA(.012,Y)
4062  CONTINUE
      DO 4063 I = 1,5
      X = I*.1
      CALL MOVEA(X,-.012)
      CALL DRAWA(X,.012)
4063  CONTINUE
      CALL TWINDO (0,4095,0,4095)
      GO TO 1500
5100  WRITE(6,9510)
9510  FORMAT(' RAW DATA ERROR ')
1500  RETURN
3000  WRITE(6,3500)
3500  FORMAT(' NO CHARGED TRACKS')
      GO TO 1500
      END
      SUBROUTINE EVIPR4
C     T. KOBAYASHI     11.09.1979    16:10
C         MODIFIED     12.09.1979    17:30
C   MODIFIED FOR JADE GRAPHICS  20.03.80    J.OLSSON
C                                  LAST CHANGE 16.07.81
C --- EVENT DISPLAY ON IPS
C --- PROJECTION ON THE Q2-Q3,Q1-Q2 PLANE
C --- ENERGY HISTOGRAM
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / / P(10,100),BANK(12)
#include "cdata.for"
      COMMON/CWORK/RTRACK(600),NTRK,NTRKL,NTRKLH,
     &  RMIN1,RMIN2,RMINL,  ZMIN,ZMINL,
     &  SUMPT,SUMPTL,       SUMP,SUMPL,    SUMLX,SUMLY,SUMLZ,
     &  PTMAX,PMAX,         ACOP
     & ,EH(36),DPRT(10)
      DIMENSION ITRACK(600)
      EQUIVALENCE (ITRACK(1),RTRACK(1))
#include "cgraph.for"
C
      COMMON /MOM/NCLST,NPHTN,NCHTR,PCL(4,50),PPH(4,50),PCH(4,50)
      DIMENSION PR(2)
      DATA NHITMN/24/,RTD/57.295779/
C
       CALL ERASE
C
      INHD=IDATA(IBLN('HEAD'))
         IF(INHD.LE.0)GO TO 5100
         INP =INHD*2+10
         NRUN=HDATA(INP)
         NEVT=HDATA(INP+1)
      INPA= IDATA(IBLN('PATR'))
      IF(INPA.LE.0) GO TO 5100
      CALL SUMPAT(INPA,&3000,&3000)
C
C ----- CALCULATE SPHERICITY AND Q-AXIS
C
      IPRMOM = 0
      CALL CHCLSP(SPH,CSTH1,PHI1,Q1,Q23,NHITMN,IPRMOM,&1500)
      NT=NCHTR+NCLST
         DPRT(1)=SPH
         DPRT(2)=Q1
         DPRT(3)=Q23
C
C ----- DECIDE SCALE AND GET PROJECTED MOM.
C
      IGR=0
      EFC=5.0
         DO 35 I=1,36
35       EH(I)=0.0
         SCALE=0.0
      DO 38 I=1,NT
      P(8,I)=P(1,I)*BANK(5)+P(2,I)*BANK(6)+P(3,I)*BANK(7)
      P(9,I)=P(1,I)*BANK(8)+P(2,I)*BANK(9)+P(3,I)*BANK(10)
         AP2=P(8,I)**2+P(9,I)**2
      P(10,I)=SQRT(AP2)
      IF(P(10,I).GT.SCALE)SCALE=P(10,I)
         IF(AP2.EQ.0.0)GO TO 38
         PHI=ATAN2(P(9,I),P(8,I))*RTD
         IF(PHI.LT.0.0)PHI=PHI+360.0
         IPHI=IFIX(0.1*PHI)+1
      EH(IPHI)=EH(IPHI)+P(10,I)/EFC
38    CONTINUE
         SCALE=1.1*SCALE
         A0=0.0
         A1=7.0*SCALE
         X0=2.0*SCALE
         X1=3.2*SCALE
      CALL DWINDO(A0,A1,A0,A1)
      GO TO 9
C
42    IF(IGR.NE.0) RETURN
      IGR=1
         DO 45 I=1,36
45       EH(I)=0.0
      DO 48 I=1,NT
      P(9,I)=P(1,I)*BANK(2)+P(2,I)*BANK(3)+P(3,I)*BANK(4)
         AP2=P(8,I)**2+P(9,I)**2
      P(10,I)=SQRT(AP2)
         IF(AP2.EQ.0.0)GO TO 48
         PHI=ATAN2(P(9,I),P(8,I))*RTD
         IF(PHI.LT.0.0)PHI=PHI+360.0
         IPHI=IFIX(0.1*PHI)+1
      EH(IPHI)=EH(IPHI)+P(10,I)/EFC
48    CONTINUE
         X0=5.0*SCALE
C
C ----- EVENT DISPLAY
C
9     CALL BOX(IDATSV,SCALE,ICREC,NRUN,NEVT,NCHTR,NCLST,DPRT,X0,X1,IGR)
C
      DO 20 I=1,NT
      PR(1)=-P(9,I)
      PR(2)=P(8,I)
C
      CALL MOVEA(X0,X1)
      IF(I.GT.NCHTR)GO TO 15
      CALL DRAWR(PR(1),PR(2))
      GO TO 20
15    CALL DASHR(PR(1),PR(2),34)
20    CONTINUE
C
C ----- ENERGY HISTOGRAM
C
      DO 40 I=1,36
         PHI=FLOAT(10*(I+8))/RTD
         I1=I+1
         IF(I1.GT.36)I1=I1-36
      CALL EHIST(PHI,EH(I),EH(I1),SCALE,X0,X1)
40    CONTINUE
      GO TO 42
C
3000  WRITE(6,3500)
3500  FORMAT(' NO CHARGED TRACKS')
       GO TO 1500
C
5100  WRITE(6,9510)
9510  FORMAT(' RAW DATA ERROR ')
1500  RETURN
      END
      SUBROUTINE BOX(IDATAL,SCALE,ICNT,NRUN,NEVT,NC,NN,DPRT,SX2,SY2,
     &               IGR)
C --- SUBROUTINE TO DRAW BOX AND WRITE DETAILS
C
      COMMON /CJTRIG/ PI,TWOPI
      DIMENSION IDATAL(11),FB(10),DPRT(10)
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cFB*40
      EQUIVALENCE (cFB,FB(1))
*** PMF(end)
C
      SX1=SX2-SCALE
      SX3=SX2+SCALE
      SY1=SY2-SCALE
      SY3=SY2+SCALE
      DL=0.05*SCALE
      DPHI = TWOPI/100
      PHI = 0.
      CALL MOVEA(SCALE+SX2,SY2)
C
      DO 10 I=1,100
      PHI = PHI + DPHI
10    CALL DRAWA(SCALE*COS(PHI)+SX2,SCALE*SIN(PHI)+SY2)
C
      CALL MOVEA(SX1,SY2)
      CALL DRAWR(DL,0.)
      CALL MOVEA(SX2,SY3)
      CALL DRAWR(0.,-DL)
      CALL MOVEA(SX3,SY2)
      CALL DRAWR(-DL,0.)
      CALL MOVEA(SX2,SY1)
      CALL DRAWR(0.,DL)
C
        IF(IGR.NE.0) RETURN
C
      CALL CHRSIZ(4)
         XSTXT=3.1*SCALE
         YSTXT=1.9*SCALE
         DL1=2.5*DL
      CALL MOVEA(XSTXT,YSTXT)
      CALL EOUTST(20,IDATAL)
C
      YSTXT=YSTXT-DL1
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,14)
      WRITE(cFB,100)ICNT ! PMF 17/11/99: UNIT=10 changed to cFB
100   FORMAT('EVENT NO.',I5)
      CALL EOUTST(14,FB)
C
      YSTXT=YSTXT-DL1
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,21)
      WRITE(cFB,110)NRUN,NEVT ! PMF 17/11/99: UNIT=10 changed to cFB
110   FORMAT('RUN NO.',I6,' -',I6)
      CALL EOUTST(21,FB)
C
      YSTXT=YSTXT-DL1
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,18)
      WRITE(cFB,115)NC,NN ! PMF 17/11/99: UNIT=10 changed to cFB
115   FORMAT('N(C,N) =',2I5)
      CALL EOUTST(18,FB)
C
      YSTXT=YSTXT-DL1
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,11)
      WRITE(cFB,120)DPRT(1) ! PMF 17/11/99: UNIT=10 changed to cFB
120   FORMAT('S =',F8.4)
      CALL EOUTST(11,FB)
C
      YSTXT=YSTXT-DL1
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,19)
      WRITE(cFB,130)(DPRT(J),J=2,3) ! PMF 17/11/99: UNIT=10 changed to cFB
130   FORMAT('Q =',2F8.3)
      CALL EOUTST(19,FB)
C
      YSTXT=YSTXT-DL1
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,20)
      WRITE(cFB,200)SCALE ! PMF 17/11/99: UNIT=10 changed to cFB
200   FORMAT('SCALE =',F7.2,' GEV/C')
      CALL EOUTST(20,FB)
C
      RETURN
      END
      SUBROUTINE EHIST(PHI,E1,E2,SCALE,X0,Y0)
C
C --- SUBROUTINE TO DRAW ENERGY HISTOGRAM
C
      DATA DPH/0.0174533/
C
      R1=E1+SCALE
      R2=E2+SCALE
      PHI1=PHI
      CALL MOVEA(R1*COS(PHI1)+X0,R1*SIN(PHI1)+Y0)
C
      DO 10 I=1,10
      PHI1=PHI1+DPH
10    CALL DRAWA(R1*COS(PHI1)+X0,R1*SIN(PHI1)+Y0)
C
      CALL DRAWA(R2*COS(PHI1)+X0,R2*SIN(PHI1)+Y0)
C
      RETURN
      END
       SUBROUTINE SUMPAT(INPA,*,*)
      IMPLICIT INTEGER*2 (H)
C        LAST MODIFY AT 12.07.79
C
C        MODIFIED FOR REDUCTION 2
C            04/08/1979  19:20   H.TAKEDA
C            17/08/1979  15:15   T.KOBAYASHI
C ------ P>10 ---> P=5
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cdata.for"
C
       COMMON/CWORK/RTRACK(600),NTRK,NTRKL,NTRKLH,
     &  RMIN1,RMIN2,RMINL,  ZMIN,ZMINL,
     &  SUMPT,SUMPTL,       SUMP,SUMPL,    SUMLX,SUMLY,SUMLZ,
     &  PTMAX,PMAX,         ACOP
C
       DIMENSION ITRACK(600),PS(3,2),PSA(3),PSB(3)
       EQUIVALENCE (PSA(1),PS(1,1)),(PSB(1),PS(1,2))
       EQUIVALENCE (ITRACK(1),RTRACK(1))
       DIMENSION R(3),P(3),VECT1(3),VECT2(3),AXIS(3)
       DATA AXIS/0.0, 0.0, 1.0/
       DATA BENER/10.0/
C
            DO 50 I=1,3
  50        R(I)= 0.
            DO 100 I= 1,600
            ITRACK(I)= 0
 100        CONTINUE
       ACOP=1.5
C
       ISTP= INPA+1
       LPAT= IDATA(ISTP)-1
       ISTP= ISTP+1
       LPAT= LPAT+ISTP
       NTRK= IDATA(ISTP)
C/////////
       LTR= IDATA(ISTP+1)
       IF(NTRK.LE.0) RETURN1
       IF(NTRK.GT.50) RETURN2
       RMIN1=10000.
       RMIN2=10000.
       ZMN= 10000.
C
C   NTRKL    # OF TRACKS , IN WHICH # OF HITS IS GREATER THAN 24
C   NTRKLH   # OF TRACKS , IN WHICH TRANS. MOM. GREATER THAN O.2 GEV
C            ( # OF HITS IS GREATER THAN 24 )
C   RMINL    MINIMUM R AMONG "NTRKLH"
C   ZMINL    MINIMUM Z AMONG "NTRKLH"
C   ACOP     ACOPLANARITY ANGLE  COS(THETA)  WITH TWO GOOD TRACKS
C            INCLUDING Z-AXIS
C
       NTRKL=0
       NTRKLH=0
       RMINL=10000.0
       ZMNL= 10000.0
C
       PTMAX= 0.
       PMAX= 0.
       SUMPT= 0.
       SUMPL=0.
       SUMPTL=0.
       SUMP= 0.
       SUMPG= 0.
C
       SUMLX=0.
       SUMLY=0.
       SUMLZ=0.
C
       DO 1000 I= 1,NTRK
C
            IP= LTR*(I-1)+LPAT
            ITNUM= IDATA(IP)
            IPX=10*(I-1)+1
            ITRACK(IPX)= ITNUM
            IF(ITNUM.NE.I) GO TO 1000
C
            IPNX= IP-1
            ZV = ADATA(IPNX+31)
            CALL KIPRCR(IPNX,1,CAP,RMINP,PHIMP,SIGP)
             CALL MOTAPR(IPNX,1,R,P)
C
C     P      MOMENTUM VECTOR
C     PP     MAGNITUDE OF MOMENTUM VECTOR
C     PTP    TRANSVERSE COMPONENT OF MOMENTUM
C
C
            PTP2= P(1)**2+P(2)**2
            PTP= SQRT(PTP2)
            PP= SQRT(P(3)**2+PTP2)
C********************
C  IF MOMENTUM EXCEEDS BEAM ENERGY, IT IS SET TO BEAM ENERGY
C
            A=1.0
            IF(PP.GE.BENER) A=BENER/(2.0*PP)
      P(1)=P(1)*A
      P(2)=P(2)*A
      P(3)=P(3)*A
      PTP=PTP*A
      PP=PP*A
C*******************************
            RTRACK(IPX+1)= RMINP
            RTRACK(IPX+2)= PHIMP
            RTRACK(IPX+3)= ZV
            RTRACK(IPX+4)= PTP
            RTRACK(IPX+5)= PP
            RTRACK(IPX+6)= P(1)
            RTRACK(IPX+7)= P(2)
            RTRACK(IPX+8)= P(3)
            ITRACK(IPX+9)=IDATA(IPNX+24)
C
C  GET 1-ST AND 2-ND 'RMIN'
C
            ARMIN= ABS(RMINP)
C
      IF(ARMIN.GT.RMIN1) GO TO 1
      RMIN2=RMIN1
      RMIN1=ARMIN
      GO TO 2
C
    1 IF(ARMIN.GT.RMIN2) GO TO 2
      RMIN2=ARMIN
    2 CONTINUE
C
            AZV= ABS(ZV)
            IF(AZV.GT.ZMN)   GO TO 800
            ZMN= AZV
            ZMIN= ZV
  800       IF(PTP.GE.PTMAX) PTMAX= PTP
            IF(PP.GE.PMAX) PMAX= PP
            SUMPT= SUMPT+PTP
            SUMP = SUMP +PP
            IF(IDATA(IPNX+24).GE.32) SUMPG= SUMPG+PP
C
C
C  PICK UP LONG TRACK
C
      IF(IDATA(IPNX+24).LT.24 .OR. ARMIN.GT.100.0) GO TO 1000
      NTRKL=NTRKL+1
C--- TRANSEVERSE MOMENTUM
      IF(PTP.LT.0.2) GO TO 1002
C
      NTRKLH=NTRKLH+1
 1002 IF(ARMIN.LE.RMINL) RMINL=ARMIN
      IF(AZV.GT.ZMNL) GO TO 1001
      ZMNL=AZV
      ZMINL=ZV
C
 1001 SUMPL=SUMPL+PP
      SUMPTL=SUMPTL+PTP
C
      SUMLX=SUMLX+P(1)
      SUMLY=SUMLY+P(2)
      SUMLZ=SUMLZ+P(3)
C
      IF(NTRKL.GE.3) GO TO 1000
      PS(1,NTRKL)=P(1)
      PS(2,NTRKL)=P(2)
      PS(3,NTRKL)=P(3)
C
 1000   CONTINUE
C
      IF(NTRKL.NE.2) RETURN
C
      CALL OUTPRD(PSA,AXIS,VECT1)
      CALL OUTPRD(PSB,AXIS,VECT2)
      CALL INNPRD(VECT1,VECT2,ACOP)
C
        RETURN
        END
      SUBROUTINE OUTPRD(A,B,C)
C --- SUBROUTINE TO MAKE VECTOR PRODUCT  C = A * B
C
      DIMENSION A(3),B(3),C(3)
C
      C(1)=A(2)*B(3)-A(3)*B(2)
      C(2)=A(3)*B(1)-A(1)*B(3)
      C(3)=A(1)*B(2)-A(2)*B(1)
C
      RETURN
C  *****************************
C
C    INNER PRODUCT   D = A . B /'A' 'B'
C
      ENTRY INNPRD(A,B,D)
C
      D=0.0
      E=A(1)*B(1)+A(2)*B(2)+A(3)*B(3)
      A1=A(1)*A(1)+A(2)*A(2)+A(3)*A(3)
      B1=B(1)*B(1)+B(2)*B(2)+B(3)*B(3)
C
      IF(A1.LE.0.0 .OR. B1.LE.0.0) RETURN
      D=E/SQRT(A1)/SQRT(B1)
C
      RETURN
      END
      SUBROUTINE CHCLSP(SPH,CSTH,PHI,Q1,Q23,NHITMN,IPR,*)
      IMPLICIT INTEGER*2 (H)
C
C
C     T. KOBAYASHI    09.08.1979    23:20
C         MODIFIED    10.08.1979    23:35
C
C     SUBROUTINE TO CALCULATE SPHERICITY FOR CHARGED TRACKS
C                   AND CLUSTERS
C
#include "cdata.for"
C
      COMMON/CWORK/RTRACK(600),NTRK,NTRKL,NTRKLH,
     &  RMIN1,RMIN2,RMINL,  ZMIN,ZMINL,
     &  SUMPT,SUMPTL,       SUMP,SUMPL,    SUMLX,SUMLY,SUMLZ,
     &  PTMAX,PMAX,         ACOP
      DIMENSION ITRACK(600),NHIT(50)
      EQUIVALENCE (RTRACK(1),ITRACK(1))
C
      COMMON /MOM/NCLST,NPHTN,NCHTR,PCL(4,50),PPH(4,50),PCH(4,50)
      COMMON P(10,100),BANK(12)
      DATA RAD/0.0174533/
C
C -------- STORE CHARGED TRACK MOM. INTO PCH(4,50)
C
      NCHTR=0
      IF(NTRK.LE.0)GO TO 1
      DO 10 I=1,NTRK
      IT=10*(I-1)
         NHITG=ITRACK(IT+10)
         IF(NHITG.LT.NHITMN)GO TO 10
         NCHTR=NCHTR+1
         NHIT(NCHTR)=NHITG
      DO 15 J=1,3
15    P(J,NCHTR)=RTRACK(IT+J+6)
      P(4,NCHTR)=ABS(RTRACK(IT+6))
      DO 16 J=1,4
16    PCH(J,NCHTR)=P(J,NCHTR)
      IF(NCHTR.EQ.50) GO TO 1
10    CONTINUE
C
C ----- STORE CL AND PH MOM. INTO PCL(4,50)AND PPH(4,50)
C
1     NCLST=0
      NPHTN=0
      IND=IDATA(IBLN('LGCL'))
         IF(IND.NE.0)GO TO 2
         WRITE(6,100)
100      FORMAT(' ********** ERROR IN CHCLSP -----> NO "LGCL"')
         GO TO 3
2     IP1=IDATA(IND+1)
      IP3=IDATA(IND+3)
      NCLST=IDATA(IND+IP1+2)
      NWPCL=IDATA(IND+25)
      IF(NCLST.LE.0)GO TO 3
      IF(NCLST.GT.50) NCLST = 50
C
      DO 20 I=1,NCLST
      IB=IND+IP3+(I-1)*NWPCL-1
      DO 25 J=1,3
25    PCL(J,I)=ADATA(IB+2)*ADATA(IB+J+8)
      PCL(4,I)=ADATA(IB+2)
         NCH=IDATA(IB+8)
         IF(NCH.NE.0)GO TO 20
         NPHTN=NPHTN+1
         DO 30 J=1,4
30       PPH(J,NPHTN)=PCL(J,I)
20    CONTINUE
      DO 40 I=1,NCLST
      DO 40 J=1,4
      P(J,NCHTR+I)=PCL(J,I)
40    CONTINUE
C
C -------- CALCULATE SPHERICITY
C
3     NT=NCHTR+NCLST
         IF(NT.GT.1)GO TO 4
         WRITE(6,300)NT,NCHTR,NCLST
300      FORMAT(' ********** ERROR IN CHCLSP -----> N(T,CH,CL) =',3I6)
         RETURN1
C
4     CALL SPHRIX(NT)
      SPH=BANK(1)
      CSTH=BANK(10)
      PHI=ATAN2(BANK(9),BANK(8))/RAD
         IF(PHI.LT.0.0)PHI=PHI+360.0
      Q1=BANK(11)
      Q23=BANK(12)
C
      RETURN
      END
       SUBROUTINE SPHRIX(JNC)
C
C      T. KOBAYASHI    AUG.10.1979   23:10
C
C
C ---- CALCULATE SPHERICITY
C
C      EINGABE: EIN BEREICH VON P-VEKTOREN ZWISCHEN 1 UND JNC
C      AUSGABE: BANK
C               INHALT  + 1  LAMDA(3) --- SPHERICITY
C               INHALT  + 2  COSX OF AXIS(1)
C               INHALT  + 3  COSY OF AXIS(1)
C               INHALT  + 4  COSZ OF AXIS(1)
C               INHALT  + 5  COSX OF AXIS(2)
C               INHALT  + 6  COSY OF AXIS(2)
C               INHALT  + 7  COSZ OF AXIS(2)
C               INHALT  + 8  COSX OF AXIS(3) --- S
C               INHALT  + 9  COSY OF AXIS(3) --- S
C               INHALT  +10  COSZ OF AXIS(3) --- S
C               INHALT  +11  Q1
C               INHALT  +12  (Q3-Q2)/SQRT(3.)
C
C
       DIMENSION PHA(100)
       DIMENSION TT(3,3),DD(3,3),XX(3,3),VV(9),RR(9)
       COMMON P(10,100),BANK(12)
       EXTERNAL VECSUB
C
C
C
C     1:PX  2:PY  3:PZ  4:E
C
C
      DO 10 I=1,10
10    BANK(I)=-1001.0
        IF (JNC.LE.0)RETURN
        DO 301 IT=1,JNC
        CALL LENGTH(IT,PJ)
301     PHA(IT)=PJ
C
C ----- BILDE LAENGEN DER VEKTOREN
C
       DO 69 IT=1,3
       DO 69 JT=1,3
   69  TT(IT,JT)=.0
C
       DO 61 J=1,JNC
       PJ=PHA(J)
       DO 61 IT=1,3
       DO 61 JT=1,3
       IF (JT-IT) 63,62,63
 62    TT(IT,JT)=PJ*PJ+TT(IT,JT)
 63    TT(IT,JT)=TT(IT,JT)-P(IT,J)*P(JT,J)
 61    CONTINUE
C
       DO 64 IT=1,3
       DO 64 JT=1,3
       IF (JT.GT.IT) GO TO 64
       CALL LOC(IT,JT,KV,3,3,1)
       VV(KV)=TT(IT,JT)
64    CONTINUE
C
      CALL EIGEN(VV,RR,3,0)
C
C ----- EIGENVALUES IN DIAGONAL DD
      CALL VTM(VV,DD,3,1)
C
C ----- EIGENVECTORS IN XX IN ROWS
      CALL VTM(RR,XX,3,0)
      TRI=TT(1,1)+TT(2,2)+TT(3,3)
C
C ----- FORM SPHERICITY
C
      SJE=3.0*DD(3,3)/TRI
C
C ----- PUT THE RESULTS INTO BANK
C
         BANK(1)=SJE
      I1=2
      DO 110 I=1,3
      DO 110 J=1,3
         BANK(I1)=XX(I,J)
      I1=I1+1
110   CONTINUE
C
C ----- CALCULATE Q1,Q2,Q3
C
      Q1=1.0-2.0*DD(1,1)/TRI
      Q2=1.0-2.0*DD(2,2)/TRI
      Q3=1.0-2.0*DD(3,3)/TRI
         BANK(11)=Q1
         BANK(12)=(Q3-Q2)/SQRT(3.0)
C
      RETURN
      END
      SUBROUTINE MOTAPR( IND, ITYPE, R, P )
C *---------------------------------------------------------
C *
C *  VERSION OF 11/06/79     LAST MOD  18/06/79    E.ELSEN
C *  FIND MOMENTUM P OF TRACK IND IN PATR BANK AT POSITION R.
C *  ITYPE DETERMINES CURVATURE USED ( AVERAGE, AT FIRST POINT
C *  OR LAST POINT. SEE KIPRCR )
C *---------------------------------------------------------
C
      DIMENSION R(3), P(3), PRM(5)

      COMMON / BCS / RW(1)
      COMMON / CGEO1 / BKGAUS
C                                                FETCH TRACK PARAMETERS
      CALL KIPRCR( IND, ITYPE, CAP, RM, PHIM, SIG )
      DZDR = RW( IND + 30 )
      GO TO 100
C                                                FETCH TRACK PARAMETERS
      ENTRY PRMTOM( PRM, R, P )
C *---------------------------------------------------------
C *  FIND MOMENTUM P FROM PARAMETERS PRM AT R.
C *---------------------------------------------------------
      CAP = ABS( PRM(1) )
      SIG = SIGN( 1., PRM(1) )
      RM = PRM(2)
      PHIM = PRM(3)
      DZDR = PRM(4)
C
C                                                TANGENT DIRECTION
  100 RMIT = RM + 1. / CAP
      RX = R(1) - RMIT*COS( PHIM )
      RY = R(2) - RMIT*SIN( PHIM )
      RTOT = SQRT( RX*RX + RY*RY ) * SIG
      EX = RY / RTOT
      EY = -RX / RTOT
C                                                RADIAL MOMENTUM
C
C  CHANGE TO ABS(BKGAUS)  2.4.1985  KOMAMIYA/OLSSON
C
      PRAD = .3E-4*ABS(BKGAUS)/CAP
C                                                TOTAL MOMENTUM
      P(1) = PRAD * EX
      P(2) = PRAD * EY
      P(3) = PRAD * DZDR
C
      RETURN
      END
      SUBROUTINE MTOPRM( P, R, SIG, PRM )
C *---------------------------------------------------------
C *
C *  VERSION OF 18/06/79     LAST MOD  18/06/79    E.ELSEN
C *  CONVERT MOMENTUM P A TRACK POINT R INTO STANDARD TRACK
C *  PARAMETERS PRM.
C *---------------------------------------------------------
C
      DIMENSION R(3), P(3), PRM(5)

      COMMON / CGEO1 / BKGAUS
      BK = BKGAUS*.3E-4
C                                          RADIUS , CENTER OF CIRCLE
      PRAD = SQRT(P(1)**2+P(2)**2)
      RAD = ABS( PRAD / BK )
      R0X = R(1) + P(2)/BK*SIG
      R0Y = R(2) - P(1)/BK*SIG
C                                          TRACK PARAMETERS
      PRM(1) = 1./RAD*SIG
      PRM(2) = SQRT( R0X*R0X + R0Y*R0Y ) - RAD
      PRM(3) = ATAN2( R0Y, R0X )
      PRM(4) = P(3) / PRAD
      PRM(5) = R(3) - PRM(4)*SQRT( R(1)**2 + R(2)**2 )
C
      RETURN
      END
      SUBROUTINE KIPRCR( IPOINT, ITYPE, CAP, RMIN, PHIMIT, SIG )
C-----------------------------------------------------------
C   VERSION OF 14/06/79    LAST MOD 15/06/79     E.ELSEN
C   CONVERT FIT PARAMETERS OF TRACK ( BANK PATR ) INTO  CURVATURE,
C   PHIMIT AND RMIN AS PARAMETERS OF A CIRCLE. SIGN IS SIG.
C   IF ITYPE = 0  AVERAGE CURVATURE
C            = 1  CURVATURE AT FIRST POINT
C            = 2  CURVATURE AT LAST POINT
C-----------------------------------------------------------
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1)
      EQUIVALENCE ( IW(1),RW(1))
C
      CAP = ABS( RW( IPOINT + 25 ) )
      IF( ITYPE .EQ. 1 ) CAP = ABS( RW( IPOINT + 27 ) )
      IF( ITYPE .EQ. 2 ) CAP = ABS( RW( IPOINT + 28 ) )
      IF( IW(IPOINT+18) .EQ. 2 ) GO TO 1000
C
CCCCIRCLE PARAMETERS
      RMIN = RW( IPOINT + 20 )
      PHIMIT = RW( IPOINT + 21 )
      SIG = SIGN( 1., RW( IPOINT + 27 ) )
      GO TO 2000
C
CCCCPARABOLIC PARAMETERS
C1000 SIG = SIGN( 1., - RW( IPOINT + 22 ) )
 1000 SIG = SIGN( 1., - RW( IPOINT + 25 ) )
      RHO = SIG / AMAX1( CAP, 1.E-8 )
      XCEN = RW(IPOINT+20) + RHO*SIN(RW(IPOINT+19))
      YCEN = RW(IPOINT+21) - RHO*COS(RW(IPOINT+19))
      PHIMIT = ATAN2( YCEN, XCEN )
      RMIN = SQRT( YCEN*YCEN + XCEN*XCEN ) - ABS( RHO )
C
 2000 RETURN
      END
      SUBROUTINE EVIPR2
C
C     T. KOBAYASHI     10.09.1979    10:00
C         MODIFIED     11.09.1979    20:00
C         MODIFIED     22.03.80  FOR USE IN JADE GRAPHICS
C         LAST CHANGE 16.07.81             J.OLSSON
C
C --- EVENT DISPLAY ON IPS
C --- PROJECTION ON THE Q1-Q2, Q2-Q3, Q3-Q1 PLANE
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
      COMMON/CWORK/RTRACK(600),NTRK,NTRKL,NTRKLH,
     &  RMIN1,RMIN2,RMINL,  ZMIN,ZMINL,
     &  SUMPT,SUMPTL,       SUMP,SUMPL,    SUMLX,SUMLY,SUMLZ,
     &  PTMAX,PMAX,         ACOP,
     &  DPRT(10)
#include "cgraph.for"
      DIMENSION ITRACK(600)
      EQUIVALENCE (ITRACK(1),RTRACK(1))
C
      COMMON P(10,100),BANK(12)
      COMMON /MOM/NCLST,NPHTN,NCHTR,PCL(4,50),PPH(4,50),PCH(4,50)
      COMMON /CHEADR/ HEAD(108)
C
      DIMENSION PR(3)
C
      DATA NHITMN/24/,SCALE/5.0/
C
      CALL ERASE
C
         NRUN=HEAD(18)
         NEVT=HEAD(19)
      INPA= IDATA(IBLN('PATR'))
      IF(INPA.LE.0) GO TO 5100
      CALL SUMPAT(INPA,&3000,&3000)
C
C ----- CALCULATE SPHERICITY AND Q-AXIS
C
      IPRMOM = 0
      CALL CHCLSP(SPH,CSTH1,PHI1,Q1,Q23,NHITMN,IPRMOM,&1500)
      NT=NCHTR+NCLST
         DPRT(1)=SPH
         DPRT(2)=Q1
         DPRT(3)=Q23
C
C ----- EVENT DISPLAY
C
      AX0=0.0
      AX1=6.0*SCALE
      AY0=0.6*SCALE
      AY1=6.6*SCALE
      X0=2.0*SCALE
      X1=4.0*SCALE
      CALL DWINDO(AX0,AX1,AY0,AY1)
C
      CALL BOX3(IDATSV,SCALE,ICREC,NRUN,NEVT,NCHTR,NCLST,DPRT)
C
      DO 20 I=1,NT
         DO 22 J=1,3
         J1=3*J-1
22       PR(J)=P(1,I)*BANK(J1)+P(2,I)*BANK(J1+1)+P(3,I)*BANK(J1+2)
      CALL PLIMIT(PR,SCALE)
C
C -------- Q3-Q2
      CALL MOVEA(X0,X1)
      IF(I.GT.NCHTR)GO TO 11
      CALL DRAWR(PR(3),PR(2))
      GO TO 12
11    CALL DASHR(PR(3),PR(2),34)
C
C -------- Q1-Q2
12    CALL MOVEA(X1,X1)
      IF(I.GT.NCHTR)GO TO 13
      CALL DRAWR(PR(1),PR(2))
      GO TO 14
13    CALL DASHR(PR(1),PR(2),34)
C
C -------- Q3-Q1
14    CALL MOVEA(X0,X0)
      IF(I.GT.NCHTR)GO TO 15
      CALL DRAWR(PR(3),PR(1))
      GO TO 20
15    CALL DASHR(PR(3),PR(1),34)
20    CONTINUE
C
C
1500  RETURN
3000  WRITE(6,3500)
3500  FORMAT(' NO CHARGED TRACKS')
      GO TO 1500
C
5100  WRITE(6,9510)
9510  FORMAT(' RAW DATA ERROR ')
      GO TO 1500
      END
      SUBROUTINE BOX3(IDATAL,SCALE,ICNT,NRUN,NEVT,NC,NN,DPRT)
C
C --- SUBROUTINE TO DRAW BOX AND WRITE DETAILS
C
      LOGICAL DSPDTM
      COMMON /CGRAP2/ BCMD,DSPDTM(30)
      DIMENSION IDATAL(11),FB(10),DPRT(10)
C
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cFB*40
      EQUIVALENCE (cFB,FB(1))
*** PMF(end)
C     IF(DSPDTM(30)) WRITE(6,9151) SCALE,ICNT,NRUN,NEVT,NC,NN
C9151  FORMAT(' BOX3 SCLE ICNT NRU NVT NC NN ',E12.4,5I5)
C     IF(DSPDTM(30)) CALL PROMPT
      S1=SCALE
      S3=3.0*SCALE
      S5=5.0*SCALE
C     IF(DSPDTM(30)) WRITE(6,9152) S1,S3,S5
C9152  FORMAT(' BOX3 S1 S3 S5 ',3E12.4)
C     IF(DSPDTM(30)) CALL PROMPT
      CALL MOVEA(S3,S5)
      CALL DRAWA(S3,S1)
      CALL DRAWA(S1,S1)
      CALL DRAWA(S1,S5)
      CALL DRAWA(S5,S5)
      CALL DRAWA(S5,S3)
      CALL DRAWA(S1,S3)
C
      CALL CHRSIZ(3)
C     IF(DSPDTM(30)) WRITE(6,9153) S1,S3,S5
C9153  FORMAT(' BOX3 TO CALL PSCALE: S1,3,5 ',3E12.4)
C     IF(DSPDTM(30)) CALL PROMPT
      CALL PSCALE(S1,S1,S1)
      CALL MOVEA(2.6*S1,1.04*S1)
      CALL EOUTST(7,'(Q3,Q1)')
      CALL PSCALE(S1,S3,S1)
      CALL MOVEA(2.6*S1,3.04*S1)
      CALL EOUTST(7,'(Q3,Q2)')
      CALL PSCALE(S3,S3,S1)
      CALL MOVEA(4.6*S1,3.04*S1)
      CALL EOUTST(7,'(Q1,Q2)')
C
C
      XSTXT=3.6*SCALE
      YSTXT=2.3*S1
      DL=0.12*SCALE
      CALL MOVEA(XSTXT,YSTXT)
      CALL EOUTST(20,IDATAL)
C
      YSTXT=YSTXT-DL
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,14)
      WRITE(cFB,100)ICNT ! PMF 17/11/99: UNIT=10 changed to cFB
100   FORMAT('EVENT NO.',I5)
      CALL EOUTST(14,FB)
C
      YSTXT=YSTXT-DL
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,21)
      WRITE(cFB,110)NRUN,NEVT ! PMF 17/11/99: UNIT=10 changed to cFB
110   FORMAT('RUN NO.',I6,' -',I6)
      CALL EOUTST(21,FB)
C
      YSTXT=YSTXT-DL
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,18)
      WRITE(cFB,115)NC,NN ! PMF 17/11/99: UNIT=10 changed to cFB
115   FORMAT('N(C,N) =',2I5)
      CALL EOUTST(18,FB)
C
      YSTXT=YSTXT-DL
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,11)
      WRITE(cFB,120)DPRT(1) ! PMF 17/11/99: UNIT=10 changed to cFB
120   FORMAT('S =',F8.4)
      CALL EOUTST(11,FB)
C
      YSTXT=YSTXT-DL
      CALL MOVEA(XSTXT,YSTXT)
      CALL CORE(FB,19)
      WRITE(cFB,130)(DPRT(J),J=2,3) ! PMF 17/11/99: UNIT=10 changed to cFB
130   FORMAT('Q =',2F8.3)
      CALL EOUTST(19,FB)
C
      CALL MOVEA(3.2*S1,2.8*S1)
      CALL CORE(FB,20)
      WRITE(cFB,200)SCALE ! PMF 17/11/99: UNIT=10 changed to cFB
200   FORMAT('SCALE =',F7.1,' GEV/C')
      CALL EOUTST(20,FB)
C
      RETURN
      END
      SUBROUTINE PSCALE(X,Y,S)
      LOGICAL DSPDTM
      COMMON /CGRAP2/ BCMD,DSPDTM(30)
C
C --- SUBROUTINE TO DRAW SCALES IN THE BOX
C
C     IF(DSPDTM(30)) WRITE(6,9144) X,Y,S
C9144  FORMAT(' PSCALE XYS ',3E12.4)
C     IF(DSPDTM(30)) CALL PROMPT
      DL=0.05*S
      S2=2.0*S
C     IF(DSPDTM(30)) WRITE(6,9154) X,Y,S,DL,S2
C9154  FORMAT(' PSCALE XYS DL S2 ',5E12.4)
C     IF(DSPDTM(30)) CALL PROMPT
      CALL MOVEA(X,Y+S)
      CALL DRAWR(DL,0.)
C     IF(DSPDTM(30)) CALL PROMPT
      CALL MOVEA(X+S,Y+S2)
      CALL DRAWR(0.,-DL)
C     IF(DSPDTM(30)) CALL PROMPT
      CALL MOVEA(X+S2,Y+S)
      CALL DRAWR(-DL,0.)
C     IF(DSPDTM(30)) CALL PROMPT
      CALL MOVEA(X+S,Y)
      CALL DRAWR(0.,DL)
      RETURN
      END
      SUBROUTINE PLIMIT(PR,SCALE)
C
C --- SUBROUTINE TO REDUCE MOM. WHICH IS OUT OF THE BOUNDARY
C
      DIMENSION PR(3),APR(3)
C
      DO 10 I=1,3
      APR(I)=ABS(PR(I))
      IF(APR(I).GT.SCALE)GO TO 1
10    CONTINUE
      RETURN
C
1     AP=APR(1)
      IF(APR(2).GT.AP)AP=APR(2)
      IF(APR(3).GT.AP)AP=APR(3)
      FC=SCALE/AP
      DO 20 I=1,3
20    PR(I)=FC*PR(I)
      RETURN
      END

C   20/02/80 007100850  MEMBER NAME  KALREV   (JADESR)      FORTRAN
      SUBROUTINE KALREV
      IMPLICIT INTEGER*2 (H)
C---
C---     COPIES BACK FROM WORKING FILE TO AUPDAT...
C---     ELIMINATES DUPLICATE LGST BANKS.
C---                                   L.H. O'NEILL 20.02.80
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
      DATA NLGST/'LGST'/
C---
      ISECLF=10
      ITOK=1
      IF(IUHR(ISECLF).NE.1) ITOK=0
      IF(ITOK.EQ.1) WRITE(6,401)
      IF(ITOK.NE.1) WRITE(6,402)
  401 FORMAT(1X,' TIME OK GOING INTO KALREV.')
  402 FORMAT(1X,' TIME ALMOST OUT GOING INTO KALREV.')
    3 CONTINUE
      IF(ITOK.GT.-20) WRITE(6,403)
  403 FORMAT(1X,' THREE LOOP.')
      ITOK=ITOK-1
      IF(ITOK.LT.0) GO TO 3
      REWIND 2
      REWIND 3
      NREC=0
      LGTIME=-1
    1 CONTINUE
      CALL EVREA1(3,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
C     IOUT=NWORD
C     IF(IOUT.GT.10) IOUT=10
C     WRITE(6,100) NREC,NWORD,(JBUF(I),I=1,IOUT)
  100 FORMAT(1X,I4,I12,10I10)
      IF(JBUF(1).NE.NLGST) GO TO 2
      IF(JBUF(6).EQ.LGTIME) GO TO 1
      LGTIME=JBUF(6)
    2 CONTINUE
      CALL KALBNK(2,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
      RETURN
      END

C   09/05/83 305092216  MEMBER NAME  MUHIT    (JADEMUS)     FORTRAN
C
C LAST CHANGE 22.15 09/05/83 CHRIS BOWDERY- COMMENT CHANGE FOR NW=22
C      CHANGE 19.52 20/10/81 CHRIS BOWDERY- CORRECTED HIT CODE SETTING
C      CHANGE 10.00 19/10/81 CHRIS BOWDERY- FLAG LOST1 AS BAD HIT
C NEW VERSION 18.08 22/09/81 CHRIS BOWDERY- USES NEW MUR2/3
C
C-----------------------------------------------------------------------
      SUBROUTINE MUHIT(HC,IHIT,ITRK,LOST1,VALID,VALIL,HAMB,END)
C-----------------------------------------------------------------------
C
C PROVIDES MUON HIT COORDINATES AND HIT INFORMATION FOR A GIVEN HIT
C NUMBER AND OPTIONALLY AN ASSOCIATED TRACK NUMBER. INITIALISATION
C IS DONE BY THE CALLING ROUTINE VIA COMMON /CMUGRA/
C
C INPUT VARIABLES
C
C IHIT        HIT NUMBER (AS DEFINED BY MUR1/1, THE COORDINATE BANK).
C ITRK        IF NOT 0 , THE TRACK NUMBER ASSOCIATED WITH IHIT
C
C OUTPUT VARIABLES
C
C HC          THE OUTPUT - 9 WORDS...
C               WORD  1     -  4*CHAMBER NUMBER + (HIT NUMBER -1)
C               WORD  2     -  10*LAYER NUMBER + ORIENTATION
C               WORDS 3 - 8 -  X,Y,Z(LEFT),X,Y,Z(RIGHT) (MM).
C               WORD  9     -  POINTER TO HIT IN MUEV.
C LOST1       = .TRUE. IF THIS HIT HAS BEEN RECOVERED (HIT 4 PROBLEM)
C VALID       = .TRUE. IF HIT HAS VALID DRIFT COORDINATE
C VALIL       = .TRUE. IF HIT HAS VALID LONG. COORDINATE
C HAMB        AMBIGUITY INFORMATION FLAGS :HAMB(1) ==> LEFT  AMBIGUITY
C                                          HAMB(2) ==> RIGHT AMBIGUITY
C
C             = 4 "AMBIGUITY" ASSOCIATED WITH A MUON OF QUALITY > 0
C                  AND < 100 AND USED IN THE CHI-SQUARED FIT.
C             = 3 "AMBIGUITY" ASSOCIATED WITH A MUON OF QUALITY > 99
C                  AND USED IN THE CHI-SQUARED FIT.
C             = 2 AS 3 BUT THE MUON QUALITY WAS NOT > 0  (PHIL 2.1)
C             = 1 "AMBIGUITY" ASSOCIATED TO A TRACK BUT NOT IN CHI**2
C             = 0 "AMBIGUITY" NOT ASSOCIATED TO ANY TRACK
C
C END         = .TRUE. IF THIS IS THE LAST HIT , .FALSE. OTHERWISE
C
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL VALID,VALIL,LOST1,END,MUOK
      DIMENSION HC(9),HAMB(2)
C
C-----------------------------------------------------------------------
C
C                  COMMONS
C  CMUGRA IS USED TO STORE POINTERS BETWEEN CALLS OF THIS ROUTINE.
C
#include "cmubcs.for"
      COMMON /CMUGRA/ IMR112,IMR122,IMUR20,IMUR21,NIDS,NWHIT,NTPH,
     +                NWTR,IMR222,IMR232,NHITS,MUOK
C
C                  SET MUR1/1 HIT NUMBER AND VALIDITY FLAGS FOR X & Z
C
      END   = .FALSE.
      VALID = TBIT(HDATA(IMR122+IHIT),14)
      VALIL = TBIT(HDATA(IMR122+IHIT),15)
C
C                  COPY THE HIT INFORMATION FROM MUR1/1
C
      DO 2 I=1,NWHIT
        HC(I) = HDATA(IMR112+I+(IHIT-1)*NWHIT)
 2    CONTINUE
C
C                  IF (HIT NUMBER - 1) IS ZERO AND THIS HIT RECOVERED
C                  THEN SET LOST1 TO BE TRUE, FALSE OTHERWISE.
C
      IVAL  = HC(1)
      LOST1 = MOD(IVAL,4).EQ.0 .AND. .NOT.(TBIT(HDATA(IMR122+IHIT),7) )
C***********************************************************************
C
C                  MAKE OVERWRITTEN HIT 1'S THE SAME AS BAD HITS
C
      IF(LOST1) VALID = .FALSE.
C***********************************************************************
      HAMB(1) = 0
      HAMB(2) = 0
C
C                  IS THIS HIT ASSOCIATED WITH ANY TRACK ?
C
      IF(.NOT. MUOK .OR. NIDS.LE.0) GO TO 4
      IQ222I = IMR222 + (IHIT-1)*NTPH
      IF( HDATA(IQ222I + 1).EQ.0 ) GO TO 4
C
C                  YES , THIS HIT WAS ASSOCIATED WITH SOME TRACK.
C                  CALCULATE THE POINTER TO THE AMBIGUITY FLAGS
C                  FOR THIS HIT. LOOP OVER ALL THE FLAGS AND ALSO
C                  PICK UP THE ASSOCIATED TRACK QUALITY FROM MUR2/1.
C  |--------------|----------------------------------------------------|
C  | MUR2/3 ====> | -   0   -1   +1   -2   +2   -12   +12   +12*  +22* |
C  |--------------|----------------------------------------------------|
C  | LEFT =HAMB(1)| 0   1    1    0    2    0     2     1     2     2  |
C  | RIGHT=HAMB(2)| 0   1    0    1    0    2     1     2     2     2  |
C  |______________|____________________________________________________|
C                                                         * = BAD DRIFT
C     PLUS         IF 100 < MU QUALITY > 0    "2" --> "4" IN ABOVE TABLE
C                  IF       MU QUALITY > 99   "2" --> "3" IN ABOVE TABLE
C
      IQ232I = IMR232 + (IHIT-1)*NTPH
      DO 7 I=1,NTPH
        ITRNUM = HDATA(IQ222I+I)
        ITRNUM = IABS(ITRNUM)
        IF( (ITRK.NE.0 .AND. ITRK.NE.ITRNUM ) .OR.ITRNUM.EQ.0 ) GO TO 7
        MUQUAL = IDATA(IMUR21 + (ITRNUM - 1)*NWTR + 6)
C
C                  GET THE AMBIGUITY FLAG FOR TRACK ITRNUM
C
        NW=HDATA(IQ232I+I)
        J = 1
        IF(NW.GT.0) J = 2
C
C                  FOR PHILOSOPHY 2.0 COMPATABILITY, NW=3 IS EQUIVALENT
C                  TO NW=12 (IF BAD HIT) AND THE CURRENT NW=22.
C
        IF( (NW.EQ.3 .OR. NW.EQ.12) .AND. .NOT.VALID) NW = 22
        IF(NW.EQ.0) NW = 11
        NW   = IABS(NW)
        NWRM = MOD(NW,10)
        NW10 = NW/10
        NADD = 0
        IF(MUQUAL.LE.0) GO TO 6
          NADD = 1
          IF(MUQUAL.LT.100) NADD = 2
 6      IF(NW10.EQ.2) NW10 = NW10 + NADD
        IF(NWRM.EQ.2) NWRM = NWRM + NADD
        IF(NW10.GT.HAMB(3-J) ) HAMB(3-J) = NW10
        IF(NWRM.GT.HAMB(J)   ) HAMB(J)   = NWRM
 7    CONTINUE
C
C                  IF THIS HIT IS THE LAST , SET FLAG
C
 4    IF(IHIT.LT.NHITS) RETURN
      END  = .TRUE.
      RETURN
      END

C   12/03/84 406201108  MEMBER NAME  FSTOH    (S)           FORTRAN
C
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      FUNCTION FSTOH(I)
C
C CONVERT SOFTWARE ADDRESS TO HARDWARE ADDRESS
C SEE ALSO FHTOS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
C
      IF ( MARK .LT. 2 ) GOTO 100
C
C---                               HERE FOR 1983... TAGGER
C
      IF ( (I .LT.  1) .OR.  (I .GT. 48) ) FSTOH =  -1
      IF ( (I .GE.  1) .AND. (I .LE.  8) ) FSTOH = I +  3
      IF ( (I .GE.  9) .AND. (I .LE. 16) ) FSTOH = I + 11
      IF ( (I .GE. 17) .AND. (I .LE. 24) ) FSTOH = I + 19
      IF ( (I .GE. 25) .AND. (I .LE. 32) ) FSTOH = I + 27
      IF ( (I .GE. 33) .AND. (I .LE. 40) ) FSTOH = I + 35
      IF ( (I .GE. 41) .AND. (I .LE. 48) ) FSTOH = I + 43
      RETURN
C
C---                                HERE FOR 1981/2 TAGGER
C
 100  FSTOH = I - 1
      RETURN
      END

C   17/12/83 807251630  MEMBER NAME  VRXCIR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE VRXCIR
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON   17/12/83 :  CONCENTRIC CIRCLES AROUND VERTEX
C
C       MOD:   J. OLSSON    8/02/84 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 11/06/87 :  SET CHARACTER SIZE
C  LAST MOD:   J. HAGEMANN 26/10/87 :  FOR CIRCLES AROUND RUN VERTEX
C
C DRAW CONCENTRIC CIRCLES AROUND VERTEX POINT, FOR VERTEX REGION DISPLAY
C DRAW CONCENTRIC RECTANGLES FOR ZX AND ZY VIEWS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FLVCDO
      LOGICAL TBIT
C
#include "cgraph.for"
C
      COMMON / CGVCDO / FLVCDO(20)
C
      DIMENSION HTX(6)
C
      DATA HTX /'1 ','2 ','3 ','4 ','5 ','MM'/
C
C------------------  C O D E  ------------------------------------------
C
      CALL CHRSIZ(4)
C
      DDD=6.*10.24*25.4/(XMAX-XMIN)
C                            SET CODE FOR DASH DRAWING
      LLX = 18
      R   = 0.0
      DR  = 0.5
      XRV = 0.0
      YRV = 0.0
      IF( .NOT.FLVCDO(11) .OR. LASTVW .NE. 17 ) GO TO 1
          CALL VTXCRV( XRV, YRV, DXR, DYR )
    1 CONTINUE
C
C                  DRAW CIRCLES/RECTANGLES  AROUND INTERACTION POINT
C
      DO 10  I = 1,10
         R = R + DR
         IF( LASTVW .NE. 17 ) GO TO 2
            NN = DDD*FLOAT(I)
            CALL PLYGON(NN,R,-XRV,YRV,LLX)
            GO TO 3
C
C                  DRAW RECTANGLES IN ZX AND ZY VIEWS
C
    2       CALL MOVEA(-R,-R)
            CALL DASHA(R,-R,LLX)
            CALL DASHA(R,R,LLX)
            CALL DASHA(-R,R,LLX)
            CALL DASHA(-R,-R,LLX)
    3    IF(TBIT(I,31)) GO TO 10
C                  FOR EVEN I, WRITE THE RADIUS
         CALL MOVEA(-XRV,R+YRV)
         J = I/2
         IF(J.LT.5) CALL EOUTST(2,HTX(J))
         IF(J.EQ.5) CALL EOUTST(4,HTX(J))
   10 CONTINUE
C
      RETURN
      END

C   20/10/81 110201218  MEMBER NAME  XYMUD    (JADEMUS)     FORTRAN
C   25/09/81 109292308  MEMBER NAME  XYMUD    (S)           FORTRAN
C   22/01/79 C9030601   MEMBER NAME  XYMUD    (JADEGS)      FORTRAN
C
C LAST CHANGE 15.08  25/09/81 CHRIS BOWDERY - REMOVE ROTATE MODE CODE
C
      SUBROUTINE XYMUD(XCOR,YCOR,ZCOR,X,Y)
C
C        THIS ROUTINE CONVERTS THE DETECTOR FRAME COORDINATES OF
C        MUON HITS (XCOR,YCOR,ZCOR) TO THE DISPLAY COORDINATES
C        FOR THE CURRENT VIEW
C
C                                      L.H. O'NEILL
C                                      MONDAY, DECEMBER 11, 1978.
C
#include "cgraph.for"
C
      IPROJ=1
      IF(LASTVW.GT.3) IPROJ=2
      IF(LASTVW.GT.7) IPROJ=3
      IF(IPROJ.EQ.1) X=-XCOR
      IF(IPROJ.EQ.1) Y= YCOR
      IF(IPROJ.EQ.2) X= ZCOR
      IF(IPROJ.EQ.2) Y= XCOR
      IF(IPROJ.EQ.3) X= ZCOR
      IF(IPROJ.EQ.3) Y= YCOR
      RETURN
      END

C   05/12/84 705211147  MEMBER NAME  TAGH2S   (S)           FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TAGH2S(ISAD,IHAD,*)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  THIS ROUTINE CONVERTS HARDWARE ADDRESSES TO SOFTWARE ADDRESSES
C
C  ISAD - OUTPUT - SOFTWARE ADDRESS
C  IHAD - INPUT  - HARDWARE ADDRESS
C
C  RETURN 1 IF IT CANT DO IT ( ILLEGAL ADDRESS SUPPLIED )
C
C
C  NEW VERSION 29/07/84     A.J.FINCH
C  LAST MOD :  18/067/84    J NYE  TIDIED UP
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      INTEGER*2 HDATA
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   CONVERT HARWARE ADDRESSES TO SOFTWARE ADDRESSES
C
C    THE PATTERN FOR 1983 ONWARDS IS -
C
C    HARDWARE ADDRESS                              SOFTWARE ADDRESS
C
C         0 - 3             NOT USED
C         4 - 7           INNER RING - Z               1 - 4
C         8 - 11            "      "                   5 - 8
C        12 - 15            NOT USED
C        16 - 19             "   "
C        20 - 23           MIDDLE RING - Z             9- 12
C        24 - 27              "  "                     13-16
C        28 - 31            NOT USED
C        32 - 35             "   "
C        36 - 39            OUTER RING - Z         17-20
C        40 - 43              "   "                21-24
C        44 - 47            NOT USED
C
C        48 - 51            NOT USED
C        52 - 55          INNER RING + Z              25 - 28
C        56 - 59            "      "                  29 - 32
C        60 - 63            NOT USED
C        64 - 67             "   "
C        68 - 71           MIDDLE RING + Z            33- 36
C        72 - 75              "  "                    37 -40
C        76 - 79            NOT USED
C        80 - 83             "   "
C        84 - 87            OUTER RING + Z         41-44
C        88 - 91              "   "                45-48
C        92 - 95            NOT USED
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C---------------------------- C O D E ----------------------------------
C
C
C
       IF ( MARK .LT. 2 ) GOTO 100
C
C---                                     HERE FOR 1983 ONWARDS TAGGER
C
       K    =   0
       J    = -12
       ISAD =   0
       DO 10 K = 3,43,8
          J = J + 16
          IF ( (IHAD .GE. J) .AND. (IHAD .LE. (J+7)) ) ISAD = IHAD - K
          IF ( ISAD .NE. 0 ) GOTO 30
  10   CONTINUE
       RETURN 1
C
C---                                     CORRECT FOR BAD CABLING
C
C   FOR REAL DATA BETWEEN RUNS 14589
C   AND 15689 CABLES FROM COUNTERS
C   38 AND 40 TO ADCS WERE INTERCHANGED
C
  30    CONTINUE
        IF ( (ISAD .NE. 38) .AND. (ISAD .NE. 40) ) RETURN
        IF ( IMC .EQ. 1 ) RETURN
        IND   = IDATA(IBLN('HEAD'))
        IF ( IND .LE. 0 ) RETURN
        NRUN  = HDATA(IND+10)
        IF ( (NRUN .LT. 14589) .OR. (NRUN .GT. 15689) ) RETURN
        ISAVE = ISAD
        IF ( ISAVE .EQ. 38 ) ISAD = 40
        IF ( ISAVE .EQ. 40 ) ISAD = 38
        RETURN
C
C---                                     HERE FOR 1981/2 TAGGER
C
C  THE PATTERN IS MUCH SIMPLER !
C
  100  ISAD = IHAD + 1
       RETURN
       END

C   11/05/81 509272142  MEMBER NAME  AVABS6   (JADEMC2)     FORTRAN

      FUNCTION  AVABS(ALAMDA)
C---- S.YAMADA     11-05-81
C     LAST MODIFICATION  18-10-78  21:15
C
C---- CALCULATE MEAN ABSORPTION LENGTH IN SF6 FOR WAVE LENGTH ALAMDA.
C     UNIT OF ALAMDA  IS NANO-METER.
C     UNIT   OF AVABS IS CM.
C
      IF(ALAMDA.GE.428.) GO TO  3
      IF(ALAMDA-390.) 1,2,2
    1 AVABS = 10.**(0.03448*ALAMDA-12.654)
      RETURN
    2 AVABS = 10.**(0.02326*ALAMDA-8.2807)
      RETURN
    3 AVABS = 10.**(0.01429*ALAMDA-4.4305)
      RETURN
      END

C   12/03/84 503141427  MEMBER NAME  TAGKAL   (S)           FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C   THIS SUBROUTINE RECALIBRATES ADC'S USING FACTORS IN
C  COMMON CALIBR
C
C INPUT - IWRITE - IF THIS IS EQUAL TO ONE THE ROUTINE
C                  WRITES OUT SOME DEBUGGING INFORMATION
C
C  A.J.FINCH 6/10/83
C  LAST MOD :   J. NYE  24/05/83  TIDIED UP
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TAGKAL(IWRITE)
C
C
       IMPLICIT INTEGER * 2 (H)
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C----------------------------------------------------------------------
C            MACRO CALIBR .... JADE CALIBRATION DATA COMMON
C----------------------------------------------------------------------
      COMMON/CALIBR/ ACALIB(1000)
                     DIMENSION HCALIB(100),ICALIB(100)
                     EQUIVALENCE(ACALIB(1),HCALIB(1),ICALIB(1))
C------------------------ END OF MACRO CALIBR -------------------------
C
       DIMENSION FACTOR(64)
C
       DATA ICOUNT / 0 /
       DATA IDONT  / 0 /
C
C
C------------------------- C O D E -------------------------------------
C
C
C---                                     TEST FOR MONTE CARLO DATA
C---                                     - DONT CALIBRATE IF MC
C
       IF ( IMC .EQ. 1 ) GOTO 15
C
C
C===DEBUG  START=========================DEBUG  START===================
C
       IF ( IWRITE .NE. 1 ) GOTO 9
          WRITE(6,610)
          WRITE(6,605 ) ( CATAG(I),I=1,IENDPZ )
  610     FORMAT(1X,'CATAG ARRAY BEFORE RECALIBRATION ')
C
C===DEBUG  END===========================DEBUG  END=====================
C
C
C
C
C---                                     GET POINTER TO CALIBRATION
C---                                     CONSTANTS IN COMMON/CALIBR/
C
    9  IPOINT = 2 * ICALIB(12)
C
C---                                    ON FIRST CALL ONLY - CHECK
C---                                     CALIB CONSTANTS ARE SENSIBLE
C
       IF ( ICOUNT .EQ. 0 ) GOTO 8
       ICOUNT = 1
C
C                                        THIS LOOP ON FIRST EVENT ONLY
C
       DO 108 I = ISTMZ,IENDPZ
          J = IPOINT + I
          FACT = 0.01 * HCALIB(J)
          IF (  (FACT .LT. 0) .OR. (FACT .GT. 10.0) ) IDONT = 1
  108  CONTINUE
C
       IF ( IDONT .EQ. 1 ) WRITE(6,608)
  608  FORMAT(/,/,' WARNING FROM TAGGING ANALYSIS ROUTINE -TAGKAL-',
     *          /,' ****   ILLEGAL CALIBRATION CONSTANT',
     *               ' FOUND ON FIRST CALL   ****')
C
C
C--------------------------------------- READ FACTORS FROM CALIBR
C
    8  CONTINUE
       IF ( IDONT .EQ. 1 ) GOTO 11
C
C
       DO 10 I = ISTMZ,IENDPZ
          J = IPOINT + I
          CATAG (I) = 0.01 * HCALIB(J) * CATAG(I)
          FACTOR(I) = 0.01 * HCALIB(J)
   10  CONTINUE
C
   11  CONTINUE
       IF ( IWRITE .NE. 1 ) RETURN
C
C
C
C
C--------------------------------------- D E B U G   O N L Y -----------
C
C
C
       IF ( IDONT .EQ. 0 ) WRITE(6,600)
       IF ( IDONT .EQ. 0 ) WRITE(6,605 ) ( FACTOR(I),I=1,IENDPZ )
       IF ( IDONT .EQ. 1 ) WRITE(6,607)
       IF ( IDONT .EQ. 1 ) WRITE(6,611)
       WRITE(6,606)
       WRITE(6,605 ) ( CATAG(I),I=1,IENDPZ )
  600  FORMAT(' CALIBRATION CONSTANTS IN TAGKAL ')
  606  FORMAT(' CATAG ARRAY AFTER RECALIBRATION ')
  605  FORMAT(6(/,8(2X,F8.2) ) )
  607  FORMAT(/,' MESSAGE FROM TAGKAL --- NO RECALIBRATION OF TAGGING',
     *             ' DATA IS BEING PERFORMED ')
  611  FORMAT('  BECAUSE ILLEGAL CALIBRATION CONSTANTS WERE FOUND',
     *           ' IN FIRST EVENT')
C
       RETURN
C
C
C
C--------------------------------------- MONTE CARLO DEBUG -------------
C
C
15    CONTINUE
      IF ( IWRITE .EQ. 1 ) WRITE(6,607)
      IF ( IWRITE .EQ. 1 ) WRITE(6,612)
 612  FORMAT('  BECAUSE THIS IS MONTE CARLO DATA ')
      RETURN
      END

C   12/03/84 412041858  MEMBER NAME  PEDFIX   (S)           FORTRAN
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TAGPED
C
C
C ROUTINE TO DO PEDESTAL SUBTRACTION
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
C
       IF ( MARK .EQ. 1 ) CALL TAGPD1
       IF ( MARK .EQ. 2 ) CALL TAGPD2
       RETURN
       END

C   11/03/79 202131145  MEMBER NAME  LGCLSD   (SOURCE)      FORTRAN
      SUBROUTINE LGCLSD(MAP)
C
C     S.YAMADA    19-01-79   10:15
C     LAST MODIFICATION  11-09-79  02:00 Y.WATANABE
C
C---- PRINT THE LG-CLUSTER ANALYSIS RESULT
C     IF(MAP.EQ.0), CLUSTER MAP IS PRINTED.
C
      IMPLICIT INTEGER *2 (H)
C
#include "clgwork1.for"
C
      DIMENSION  HMAPC1(162)
      EQUIVALENCE  (HMAPC1(1),HMAPCL(1,1))
C
C---- CONTENTS OF THE BUFFER FOR EACH CLUSTER
C     ICLSPR(1,I)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     CLSPRP(2,I)=ENERGY IN GEV
C     CLSPRP(3,I)=SIGMA(ENERGY)
C     CLSPRP(4,I)=WEIGHTED AVERAGE PHI
C     CLSPRP(5,I)=WEIGHTED AVERAGE Z
C     CLSPRP(6,I)=SIGMA PHI (WEIGHTED)
C     CLSPRP(7,I)=SIGMA Z (WEIGHTED)
C     ICLSPR(8,I)=CHARGE,IF THERE IS A CHARGED NEIGHBOUR
C                  TRACK,ITS CHARGE IS COPIED.
C     CLSPRP(9-11,I)=DIRECTION COSIGNS CORRECTED FOR SHOWER DEV.
C     CLSPRP(12-14,I)=CLUSTER SHAPE: ELLIPS EIGENVALUES AND DIRECTION
C     ICLSPR(15,I)=MARK FOR CORNER HIT:# OF EDGE COUNTERS IN THE CLUSTER
C     CLSPRP(16,I)=ENERGY IN GEV (ORIGINAL ENERGY STORAGE)
C
C
C---- WRITE THE GENERAL INF.
C
      WRITE(6,600) IDENT,NCLST,NCLBEC,ETOT,NNEUT,EGAM,IFLAG,NWPCL
  600 FORMAT('0===== LG-CLUSTERS =====    PROG.VERSION=',I2,
     1   '  DATE&TIME=',I9,'  ====================',
     2        /' NCLST=',4I5,'  ENERGY=',4F8.3,'    NG=',I3,'  E-GAM=',
     3        4F8.3,/'   FLAGS=',5I8,'  WORDS/CLUST=',I4)
C
C
C---- ADC-MAP FOR EACH CLUSTER
      IF(MAP.EQ.0) GO TO 2
      KE = (NCLST+1)*2-1
      WRITE(6,601) (HMAPC1(K),K=1,KE)
  601 FORMAT(' LG-ADC MAP AFTER CLUSTER ANALYSIS',
     $           /' ',(10(I5,'-',I4,', ')))
C
C
C---- CLUSTER INFORMATION
    2 IF(NCLST.LE.0) RETURN
      THE = 0.
      PHI = 0.
C
C---- TITLE
      WRITE(6,603)
  603 FORMAT('  I N J',/'  N B B ENERGY  +/-    PHI/X',7X,'Z/Y',5X,
     1  '+-PHI/X', 3X,' +-Z/Y    TRK   THE   PHI COSX   COSY   COSZ',
     2  '     ELLIPS EIGENVALUES       EDGE',   /'  D L C')
C
        DO 10 N=1,NCLST
C----   NO.OF HITS IN THE CLUSTER
        NCNT = HMAPCL(2,N)-HMAPCL(1,N)+1
C
        IF(IFLAG(2).LT.2) GO TO 1
        THE = ARCOS(CLSPRP(11,N))*57.2958
        PHI = ATAN2( CLSPRP(10,N),CLSPRP(9,N))*57.2958
C
    1   WRITE(6,602) N,NCNT,ICLSPR(1,N),(CLSPRP(K,N),K=2,7),ICLSPR(8,N),
     &               THE,PHI, (CLSPRP(K,N),K=9,14),CLSPRP(15,N)
  602   FORMAT(' ',I2,2I2,F7.3,F6.3,2E11.3,2E10.3,I4,
     1                          2F6.1, 3F7.4,1P3E10.2,0PI2)
   10   CONTINUE
      RETURN
      END

C   11/12/79 006251730  MEMBER NAME  VTXPNT   (JADEGS)      FORTRAN
      SUBROUTINE VTXPNT(J,XP,YP,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,ST)
C*800623*DITTMANN************************************************
C*                                                              *
C*     S U P P O R T   F O R   X Y Z   V E R T E X   F I T      *
C*                                                              *
C*       COMMON CWORK1 MUST BE FILLED PROPERLY                  *
C*                                                              *
C*       ENTRY: VTXS                                            *
C****************************************************************
      COMMON /CWORK1/ NT,T(1500)
C
C        ENTRY VTXPNT
C****    CALCULATE POINT XT,YT,ZT ON HELIX J WHICH IS NEAREST
C****    TO POINT XP,YP IN X-Y PROJECTION
      XM = T(J+5) - T(J+2)*T(J+21)
      YM = T(J+6) + T(J+2)*T(J+22)
      SR = SIGN(1.,T(J+2))
      PHIT = ATAN2(-SR*(XM-XP),SR*(YM-YP))
      THETA = PHIT - T(J+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      ST = T(J+2)*THETA
      SPHI = SIN(PHIT)
      CPHI = COS(PHIT)
      XT = XM + T(J+2)*SPHI
      YT = YM - T(J+2)*CPHI
      ZT = T(J+7) + ST*T(J+23)
      SSPACE = ST
      SSCOUL = ST-T(J+27)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      DXY = T(J+10)**2 + (T(J+8)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DZ = (T(J+9)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(DXY))
      DXT2 = SPHI**2 / DXY
      DYT2 = CPHI**2 / DXY
      IF(DXT2.LT.DXYLIM) DXT2=DXYLIM
      IF(DYT2.LT.DXYLIM) DYT2=DXYLIM
      DXT2 = 1. / DXT2
      DYT2 = 1. / DYT2
      DZT2 = T(J+12)**2 + DZ/(T(J+24)**2)**2
      RETURN
C
         ENTRY VTXS(J,S,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT)
C****    CALCULATE POINT XT,YT,ZT ON HELIX J FOR A GIVEN
C****    PROJECTED ARC LENGTH
      THETA = S / T(J+2)
      PHIT = T(J+3) + THETA
      SPHI = SIN(PHIT)
      CPHI = COS(PHIT)
      XT = T(J+5) + T(J+2)*(SPHI-T(J+21))
      YT = T(J+6) - T(J+2)*(CPHI-T(J+22))
      ZT = T(J+7) + S*T(J+23)
      SSPACE = S
      SSCOUL = S-T(J+27)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      DXY = T(J+10)**2 + (T(J+8)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DZ = (T(J+9)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(DXY))
      DXT2 = SPHI**2 / DXY
      DYT2 = CPHI**2 / DXY
      IF(DXT2.LT.DXYLIM) DXT2=DXYLIM
      IF(DYT2.LT.DXYLIM) DYT2=DXYLIM
      DXT2 = 1. / DXT2
      DYT2 = 1. / DYT2
      DZT2 = T(J+12)**2 + DZ/(T(J+24)**2)**2
      RETURN
C
      END

C   21/11/78 C9071601   MEMBER NAME  ZBOS10   (S)           FORTRAN
      SUBROUTINE BSCOM
C     ----------------------------------------------------------------1000000200
C
C     10.  PRINTING STATISTIC AND A DUMP
C
C     THE STATUS OF THE BOS-SYSTEM, EXPECIALLY STATISTICS ON INPUT/
C     OUTPUT IS PRINTED BY
C
C     CALL BSTA
C
C
C
C     A DUMP CONTAINING RELEVANT STATUS INFORMATION AND NDMP
C     WORDS OF THE COMMON/BCS/IW(NSPACE) IS PRINTED BY
C
C     CALL BDMP
C
C     THE PROGRAM STOPS CALLING ABEND.
C     BDMP IS CALLED AUTOMATICALLY IN BOS-ROUTINES UNDER SEVERAL
C     ERROR CONDITIONS, DESCRIBED BELOW. IT IS ALSO CALLED IN
C     CASE OF A SYSTEM COMPLETION CODE 0CX, IF THE STATEMENT
C
C     CALL DUMP0C
C
C     IS USED AFTER BINT.
C
C
C
C     ICOND  SUBPGM   CONDITION                               REMARK
C     -----  ------   --------------------------------------  -------
C         1    IBLN   TOO MANY NAMES USED                     1,2
C        11  BREADC   NOT ENOUGH SPACE IN COMMON/BCS/         3
C        12    BRDS   NOT ENOUGH SPACE IN COMMON/BCS/         3
C        13    BWRS   NOT ENOUGH SPACE IN COMMON/BCS/         3
C        14  BLOADA   NOT ENOUGH SPACE IN COMMON/BCS/, OR     3,4
C                     ILLEGAL DADS
C        15    PODA   NOT ENOUGH SPACE IN COMMON/BCS/, OR     3,4
C                     ILLEGAL DADS
C        21    BRDS   TOO MANY READ ERRORS                    5,1
C        22    BRDS   RECORD READ TOO LONG                    5,3
C        23    BRDS   WRITE-UNIT USED FOR READING
C        24    BWRS   READ-UNIT USED FOR WRITING
C        31    ----   FORTRAN ERROR 240 (0CX)                 6,7
C        32    BGAR   WRONG INDEX FOUND                       6
C        41   BREADC  INCORRECT CARD FOR FORMATED INPUT
C
C
C     REMARKS
C     1   CHANGE PARAMETERS IN BINT1
C     2   PROBABLY USER ERROR, WRONG VARIABLE USED AS A NAME
C     3   INCREASE TOTAL SPACE IN COMMON/BCS/
C     4   PROBABLY USER ERROR, WRONG DATA SET USED
C     5   READ ERRORS
C     6   PROBABLY USER ERROR, BANK STRUCTURE OVERWRITTEN
C     7   PROBABLY USER ERROR, IN MOST CASES A WRONG INDEX IS USED
C
C
C
C
C     DESCRIPTION OF THE VARIABLES OF THE COMMON/ACS/, PRINTED
C     IN A DUMP.

C     INDEX    VARIABLE     MEANING
C
C       1      ICOND        ERROR CONDITION
C       2      NLAST        LENGTH OF COMMON/BCS/
C       3      NDUMP        NR OF WORDS PRINTED IN A DUMP
C       4      NSPL         NR OF WORDS FOR LOW PRIORITY BANKS
C       5      NAMAX        NR OF DIFFERENT NAMES ALLOWED
C       6      NAMAX1       NAMAX+1
C       7      NLIST        NR OF ENTRIES IN LISTS ALLOWED
C       8      NPRIME       PRIME NR USED IN IBLN
C       9      NFRS         FIRST LOCATION FOR BANKS
C      10      NLST         LAST LOCATION FOR BANKS
C
C      11      NEXT         NEXT LOCATION FOR BANKS
C      12      NCI          ACTUAL NR OF DIFFERENT NAMES
C      13      NFRE         NR OF FREE LOCATIONS
C      14      IN           ACTUAL NR OF NAMES IN LIST
C      15      KPOS         INDEX FROM BPOS/CPOS
C      16      LIND         INDEX OF LAST CREATED BANK
C      17      ILOW         LOWEST INDEX OF DELETED BANK
C      18      LFDI         LAST I-INDEX
C      19      LFDK         LAST K-INDEX
C      20      NCPL         ACTUAL NR OF WORDS OF LOW PRIORITY SPACE
C
C      21-30   NHISTH(10)   HISTOGRAM FOR TOTAL SPACE
C
C      31      NHISTH(11)   OVERFLOWS TOTAL SPACE
C      32      NCOL         NR OF GARBAGE COLLECTIONS
C      33      NZT          TIME OF BOS-START
C      34      IBFI         INDEX FOR BUFF-BANK
C      35      NLAST1       COPY OF NLAST
C      36      ISLST        INDEX FOR SPECIAL LIST OF NAMES
C      37      IMLST        INDEX FOR MARKERS OF SP. LIST O.N.
C      38      INAMV        INDEX FOR NAMES
C      39      IOLST        INDEX FOR IO-LIST
C      40      IPLST        INDEX FOR POINTERS TO NAMES
C
C      41-50   NER(10)      INPUT ERROR CODES FROM BINP/BRDS
C
C      51      NRECL        DEFAULT RECORD LENGTH FOR OUTPUT
C      52      NERRL        NR OF ERRORS ALLOWED
C      53      NRIN         NR OF INPUT EVENTS
C      54      NROUT        NR OF OUTPUT EVENTS
C      55      NS           ACTUAL NR OF NAMES IN SPECIAL LIST
C      56      NEXTI        NEXT INDEX FOR BANKS IN BRDS
C      57      NEXTA        INDEX OF BEGIN OF NEW EVENT
C      58      NEXTB        INDEX BEHIND NEW EVENT
C      59      ISAVB        INDEX OF SAVED LOCATION IN BWRS
C      60      NSAVB        CONTENT OF SAVED LOCATION IN BWRS
C
C      61-70   NHISTL(10)   HISTOGRAM FOR LOW PRIORITY SPACE
C
C      71      NHISTL(11)   OVERFLOWS OF LOW PRIORITY SPACE
C      72      MARKWR       MARKER FOR BSEQ
C      73-75   NOUT(3)      OUTPUT UNITS FOR BSEQ
C      76      IASW         SWITCH FOR FORTRAN/ASSEMBLER READ (BSEQ)
C      77      NPRE         NR OF BPRE PRINTOUTS
C      78      IDUMMY(1)    ONE DUMMY WORD (ZERO)
C      79      NEOTP        NR OF LISTINGS FOR INPUT-BANK ERRORS WITH
C                           ERROR CODE LESS THAN 6
C      80      NDUMP1       SAME AS NDUMP
C
C
C
C
C     DESCRIPTION OF BANKS ('+BUF',IUN) FOR INPUT AND OUTPUT
C
C
C
C     BUFFER FOR INPUT = BANK ('+BUF',IUN), LENGTH = 11,
C              LENGTH = 10 + NRECL FOR M-RECORDS
C
C     IBF+ 1   =1 (INPUT)
C          2   BUFFER SIZE USED
C          3   NR OF IO-ERRORS
C          4   NR OF RECORDS
C          5   NR OF EVENTS ACCEPTED
C          6   NR OF EVENTS, WHICH ARE TOO LARGE
C          7   SUM OF NR OF WORDS IN ALL EVENTS
C          8   MAX NR OF WORDS IN AN EVENT
C          9   LIMIT FOR NR OF ERRORS
C         10   POINTER WITHIN RECORD TO NEXT EVENT
C         ----------------
C         11   NTOT (= NR OF WORDS IN THE RECORD FOLLOWING)
C         12   RECORD
C          .   . . .
C          .   . . .
C
C     BUFFER FOR OUTPUT = BANK ('$BUF',IUN), LENGTH = 11
C              LENGTH = 10 + NRECL FOR M RECORDS
C
C     IBF+ 1   =2 (OUTPUT)
C          2   BUFFER SIZE
C          3   OUTPUT MODE
C          4   NR OF RECORDS
C          5   NR OF EVENTS ACCEPTED
C          6   NR OF EVENTS, WHICH ARE TOO LARGE
C          7   SUM OF NR OF WORDS IN ALL EVENTS
C          8   MAX NR OF WORDS IN AN EVENT
C          9   HIDD-NR
C         10   POINTER WITHIN RECORD TO NEXT EVENT
C         ----------------
C         11   NTOT (= NR OF WORDS IN THE RECORD FOLLOWING)
C         12   RECORD
C          .   . . .
C          .   . . .
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
      RETURN
      END

C   07/06/96 606071855  MEMBER NAME  MBOS     (S4)          FORTG1
      SUBROUTINE MBOS(IU,IY,IZ)
      INTEGER IU(1),IY(1),IZ(1)
      INTEGER BLANK/'    '/,TENT(5)/'MBOS','MDRP','MCRE','MCRE','MBWR'/
C
C
      L=JDSTL(IY(1),IU(1))/4+1
      IF(L.NE.1) GOTO 12
      IGOTO=1
      N=IU(1)
      L=IU(N)
      GOTO 80
   10 IZ(1)=IU(N-3)-IU(N-1)-1
      GOTO100
   12 CALL VZERO(IU(2),L-1)
      IF(IZ(1).NE.0) IU(1)=IZ(1)
      N=IU(1)
      IF(IZ(1).EQ.0) GOTO 14
      IU(N-8)=0
      IU(N-7)=0
      IU(N-6)=10
      IU(N-5)=BLANK
      IU(N-4)=0
   14 IU(N-3)=N-8
      IU(N-2)=0
      IU(N-1)=L+4
      IU(N  )=L
      GOTO 100
C
C
      ENTRY MDRP(IU,IY,IZ)
      IGT=2
      GOTO 70
C
C
      ENTRY MCRE(IU,IY,IZ)
      IGT=3
      N=IU(1)
      LL=IU(N)
      L=JDSTL(IY(1),IU(1))/4+1
      IF(L.NE.1) GOTO 20
      IZ(1)=IU(N-3)-IU(N-1)-1
      GOTO 100
   20 IF(L.LT.2.OR.L.GT.LL) GOTO 200
      NWD=IZ(1)+4
      M=IU(N-1)
      IF(IU(L).EQ.0) GOTO 22
      NWD=IZ(1)-IU(IU(L))
      GOTO 30
   22 IF(NWD+IU(N-1).LT.IU(N-3)) GOTO 90
      IF(IU(N-2).EQ.1) GOTO 80
      GOTO 100
   24 J=J-1
      IU(M-3)=IU(N-5)
      IU(M-2)=IU(N-4)
      IU(M-1)=L
      IU(M  )=IZ(1)
      NZER=IZ(1)
      IF(NZER.EQ.0) GOTO 29
      IF(NZER.GT.20) GOTO 28
      DO 26 I=1,NZER
   26 IU(M+I)=0
      GOTO 29
   28 CALL VZERO(IU(M+1),NZER)
   29 IU(N-5)=BLANK
      IU(N-4)=0
      IU(N-3)=IU(N-3)-1
      IU(L)=M
      IU(J)=L
      GOTO 100
C     MODIFY LENGTH, IF BANK ALREADY EXISTING
   30 IGT=4
      IF(NWD+IU(N-1).LT.IU(N-3)) GOTO 90
      IF(IU(N-2).EQ.1) GOTO 80
      GOTO 100
   32 M=IU(L)
      IU(M)=IU(M)+NWD
      GOTO 100
C
C
      ENTRY MNNR(IU,IY,IZ)
      N=IU(1)
      IU(N-5)=IY(1)
      IU(N-4)=IZ(1)
      GOTO 100
C
C
      ENTRY MMLT(IU,IY,IZ)
      N=IU(1)
      IU(N-5)=JDSTL(IY(1),IU(1))/4+1
      IU(N-4)=JDSTL(IZ(1),IU(1))/4+1
      GOTO 100
C
C
      ENTRY MBWR(IU,IY,IZ)
      IGT=5
      N=IU(1)
      LL=IU(N)
      IGT=5
      LA=2
      LB=LL
      LD=0
      IF(IU(N-4).EQ.0) GOTO 72
      LA=IU(N-5)
      LB=IU(N-4)
      IU(N-5)=BLANK
      IU(N-4)=0
      GOTO 72
   50 IY(1)=0
      IF(LC.EQ.0) GOTO 100
      IY(1)=IU(LD)-IU(LC)+4+IU(IU(LD))
      IZ(1)=IU(LC)-3
      GOTO 100
C
C
      ENTRY MBRD(IU,IY,IZ)
      N=IU(1)
      LL=IU(N)
      NW=IY(1)
      CALL VZERO(IU(2),LL-1)
      J=N-8
      IND=LL+4
   60 IF(NW.LE.0) GOTO 64
      K=IU(IND-1)
      IF(K.LT.2.OR.K.GT.LL) GOTO 62
      IU(K)=IND
      J=J-1
      IU(J)=K
      NW=NW-4-IU(IND)
      IND=IND+4+IU(IND)
      GOTO 60
   62 IZ(1)=1
   64 IU(N-3)=J
      IU(N-1)=IND
      GOTO 100
C
C     MARK BANKS FROM INDEX LA TO LB AS DELETED
   70 N=IU(1)
      LL=IU(N)
      LA=JDSTL(IY(1),IU(1))/4+1
      LB=JDSTL(IZ(1),IU(1))/4+1
   72 IF(LA.LT.2.OR.LB.GT.LL.OR.LA.GT.LB) GOTO 200
      J=IU(N-3)
   74 IF(J.GE.N-8) GOTO 79
      LJ=IABS(IU(J))
      IF(LJ.LT.LA) GOTO 79
      IF(LJ.GT.LB) GOTO 78
      IF(IGT.NE.5) GOTO 76
      LC=LJ
      IF(LD.EQ.0) LD=LJ
      GOTO 78
   76 IU(J)=-LJ
      IU(N-2)=1
   78 J=J+1
      GOTO 74
   79 GOTO (100,100,100,100,50),IGT
C
C     GARBAGE COLLECTION
   80 J=N-8
      NSH=0
      NBK=0
      NAC=0
   82 IF(J.LE.IU(N-3)) GOTO 88
      J=J-1
      LJ=IU(J)
      IF(LJ.LT.0) GOTO 84
C     ACTIVE BANK
      IU(J+NBK)=IU(J)
      IF(NAC.EQ.0) M=IU(LJ)
      NAC=1
      IU(LJ)=IU(LJ)-NSH
      GOTO 82
C     DELETED BANK
   84 LJ=-LJ
      IF(NAC.EQ.0) GOTO 86
      IF(NSH.NE.0) CALL UCOPY2(IU(M-3),IU(M-3-NSH),IU(LJ)-M)
      NAC=0
   86 NSH=NSH+4+IU(IU(LJ))
      NBK=NBK+1
      IU(LJ)=0
      GOTO 82
   88 IF(NAC.EQ.1.AND.NSH.NE.0) CALL UCOPY2(IU(M-3),IU(M-3-NSH),
     1   IU(N-1)-M)
      IU(N-3)=IU(N-3)+NBK
      IU(N-2)=0
      IU(N-1)=IU(N-1)-NSH
      GOTO (10,100,22,30,100),IGT
C
C     OBTAIN SPACE OF NWD WORDS FOR BANK OF INDEX L
   90 J=IU(N-3)
      IF(J.GE.N-8) GOTO 94
   92 LJ=IABS(IU(J))
      IF(LJ.LE.L) GOTO 94
      M=IU(LJ)
      IU(LJ)=IU(LJ)+NWD
      IF(IGT.EQ.3) IU(J-1)=IU(J)
      J=J+1
      IF(J.LT.N-8) GOTO 92
   94 IF(M.LT.IU(N-1)) CALL UCOPY2(IU(M-3),IU(M-3+NWD),IU(N-1)-M)
      IU(N-1)=IU(N-1)+NWD
      GOTO (100,100,24,32,100),IGT
C
C
  100 RETURN
  101 FORMAT('0ILLEGAL SECOND OR THIRD ARGUMENT IN ENTRY ',A4,' - STOP')
  200 WRITE(6,101) TENT(IGT)
      STOP
      END

C   20/03/80 201261221  MEMBER NAME  CUTP81   (S)           FORTRAN
      SUBROUTINE CUTP81
C---  CUT OFF ADC-PEDESTALS (MICROPROCESSOR SUBTRACTED) BELOW 50 CH.
C---  (OR EVEN HIGHER, MAXIMUM:99, IF PEDESTAL HAS SHIFTED)
C---  & CREATE NEW VALUES FOR LNG, HPOINT, AND HGGADC
C---  (DEALS WITH 64 ADC-CHANNELS)
C
C     H.WRIEDT     12.06.79       14:00
C     LAST MODIFICATION     26.01.82      12:15
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK(42),LNG,HPOINT(4),HGGADC(2,64)
C
      DIMENSION NMBIN(9),NPBIN(9)
C
        DO 1 I = 2,9
        NMBIN(I) = 0
    1   NPBIN(I) = 0
C
      NDAT = LNG - 2
C---  COUNT NUMBER OF ENTRIES BETWEEN 20 & 100 ADC-CHANNELS ON EACH
C---  SIDE PER EVENT (10 CHANNEL-WISE)
        DO 3 I = 1,NDAT
        IBIN = HGGADC(2,I)/10
        IF (HGGADC(1,I).GT.31) GOTO 2
C       -Z - SIDE
        IF (IBIN.GE.2 .AND. IBIN.LE.9) NMBIN(IBIN) = NMBIN(IBIN) + 1
        GOTO 3
C       +Z - SIDE
    2   IF (IBIN.GE.2 .AND. IBIN.LE.9) NPBIN(IBIN) = NPBIN(IBIN) + 1
    3   CONTINUE
C---  CALCULATE NUMBER OF ADC-CHANNELS WITH CONTENT BETWEEN 20 & 99
      NMSUM = 0
      NPSUM = 0
        DO 5 I = 2,9
        NMSUM = NMSUM + NMBIN(I)
    5   NPSUM = NPSUM + NPBIN(I)
C---  FLAG ACCORDING TO NUMBER OF ADC-CHANNELS BETWEEN 20 & 99
C     IFLAG = 0  : 0 CHANNELS
C           = 1  : 1 - 4 CHANNELS
C           = 2  : > 4 CHANNELS
      IMFLAG = 0
      IF (NMSUM.GE.0) IMFLAG = 1
      IF (NMSUM.GE.5) IMFLAG = 2
      IPFLAG = 0
      IF (NPSUM.GE.0) IPFLAG = 1
      IF (NPSUM.GE.5) IPFLAG = 2
      IMCUT = 49
      IPCUT = 49
      IF (IMFLAG.LT.2 .AND. IPFLAG.LT.2) GOTO 90
C---  > 4 CHANNELS ON ONE SIDE BETWEEN 20 & 99 COUNTS
      MAXMCN = NMBIN(2)
      MAXMBN = 2
      MAXPCN = NPBIN(2)
      MAXPBN = 2
        DO  20 I = 3,9
        IF (IMFLAG.LT.2) GOTO 15
        IF (MAXMCN.GT.NMBIN(I)) GOTO 15
        MAXMCN = NMBIN(I)
        MAXMBN = I
   15   IF (IPFLAG.LT.2) GOTO 20
        IF (MAXPCN.GT.NPBIN(I)) GOTO 20
        MAXPCN = NPBIN(I)
        MAXPBN = I
   20   CONTINUE
C---  IF BIN WITH MAXIMUM NO OF COUNTS < 5 COUNTS: CUT AT 50
      IF (IMFLAG.EQ.2 .AND. MAXMCN.LT.5) IMFLAG = 1
      IF (IPFLAG.EQ.2 .AND. MAXPCN.LT.5) IPFLAG = 1
      IF (IMFLAG.LT.2 .AND. IPFLAG.LT.2) GOTO 90
C---  DETERMINE CUT-VALUE
      IF (IMFLAG.LT.2) GOTO 25
C     -Z - SIDE
      IBIN = MAXMBN
  21  IF (IBIN.LT.8) GOTO 22
      IMCUT = 99
      GOTO 25
  22  IF (NMBIN(IBIN+1).LT.5) GOTO 23
      IBIN = IBIN + 1
      GOTO 21
C     CUT ABOVE FIRST BIN WITH < 5 COUNTSABOVE MAXIMUM
C     (BUT NOT BELOW 49)
   23 IMCUT = IBIN*10 + 19
      IF (IMCUT.LT.49) IMCUT = 49
   25 IF (IPFLAG.LT.2) GOTO 90
C     +Z - SIDE
      IBIN = MAXPBN
  26  IF (IBIN.LT.8) GOTO 27
      IPCUT = 99
      GOTO 90
  27  IF (NPBIN(IBIN+1).LT.5) GOTO 28
      IBIN = IBIN + 1
      GOTO 26
C     CUT ABOVE FIRST BIN WITH < 5 COUNTSABOVE MAXIMUM
C     (BUT NOT BELOW 49)
   28 IPCUT = IBIN*10 + 19
      IF (IPCUT.LT.49) IPCUT = 49
C---  CUT AT 50 IF < 5 CHANNELS BETWEEN 20 & 99 COUNTS
   90 CONTINUE
        DO 100 I = 1,NDAT
        HADR = HGGADC(1,I)
        IF (HADR.LE.31 .AND. HGGADC(2,I).GT.IMCUT) GOTO 100
        IF (HADR.GE.32 .AND. HGGADC(2,I).GT.IPCUT) GOTO 101
C---    CUTOFF OF ADCS WITH LOW CONTENT
C       (THRESHOLD: 49 CHANNELS)
        HGGADC(2,I) = 0
        GOTO 100
C---    SCRATCH UNPHYSICAL ADC-ADDRESSES (I.E. ADDRESSES > 63
C---    AND CONTENTS
  101   IF (HADR.GT.63)
     &   HGGADC(2,I) = 0
  100   CONTINUE

  190 CALL GGSRTH(0,NDAT)
      LNG = 2
        DO 200 I = 1,NDAT
        IF (HGGADC(2,I).LE.0) GOTO 201
  200   LNG = I+2
  201 NDAT = LNG-2
      CALL GGSORT
C
C---  SET UP NEW POINTERS
      HPOINT(1) = 1
      HPOINT(2) = 1
      HPOINT(3) = 1
      IF (NDAT.LE.0) GOTO 211
        DO 210 I = 1,NDAT
        HADDR = HGGADC(1,I)
        IF (HADDR.LE.31) HPOINT(2) = 2*I+1
        IF (HADDR.LE.63) HPOINT(3) = 2*I+1
  210   CONTINUE
  211 HPOINT(4) = 2*NDAT+1
      RETURN
      END

C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C

***HEADER*** MEMBER  MVTRCE    SAVED BY F22RAM  ON 86/12/15  AT 14:04      
C
      COMMON / CVTRCE / IVCELL,IVSIDE,VDRFT,
     *                  VSIGMA,HVMSK(7),VRES(7),ITDST
C                                                              

C   20/12/78 008221828  MEMBER NAME  GGBLNO                 FORTRAN
      SUBROUTINE GGBLNO(XPBGL,YPBGL,NOBL)
C---  OBTAIN PB-GLASS BLOCK NUMBER CORRESPONDING TO X-Y-POSITION
C---  INPUT:  X- AND Y-COORDINATES (IN MM)
C
C     H.WRIEDT      12.12.78      15:30
C     LAST MODIFICATION     18.01.79       15:00
C
      COMMON /CPARTC/ PRTCIN,PRTCL,EMEV,AMASS2,ISIGNZ
      DIMENSION PRTCIN(9), PRTCL(9)
      DIMENSION NBLIST(11,6)
      DATA NBLIST /4*0,1,2,3,4*0,
     1             2*0,4,5,6,7,8,9,10,2*0,
     2             0,11,12,13,14,15,16,17,18,19,0,
     3             20,21,22,23,24,25,26,27,28,29,30,
     4             31,32,33,34,3*0,35,36,37,38,
     5             39,40,41,42,3*0,43,44,45,46/
      N= 0
C---  +Z-DIRECTION (TOWARDS MARK J)
      X0 = XPBGL
      Y0 = YPBGL
      IF (ISIGNZ.GT.0) GOTO 5
C---  -Z-DIRECTION (TOWARDS PLUTO & CELLO)
      X0 = -XPBGL
      Y0 = -YPBGL
C
  5   X = X0
      Y = Y0
      IF (X0) 10,11,11
 10   X = -X0
 11   IF (ABS(Y0).LT.121.5) X = X+20.
      IF (Y0) 20,21,21
 20   Y = -Y0
 21   IF (X.LT.81.) Y = Y-30.
C
      NX = X/81.
      IF (NX.GE.6) GOTO 100
      NX = 6-NX
      NY = (Y+40.5)/81.
      IF (NY.GE.6) GOTO 100
      IF (X0) 40,30,30
C---  BLOCK ADDRESSES 1 TO 46
 30   IF (Y0) 31,32,32
 31   NY = 6-NY
      GOTO 35
 32   NY = 6+NY
 35   N = NBLIST(NY,NX)
      IF (N.EQ.0) GOTO 100
C---  BLOCK ADDRESSES 97 TO 142
      IF (ISIGNZ.GT.0) N = N+96
      GOTO 100
C---  BLOCK ADDRESSES 49 TO 94
 40   IF (Y0) 41,42,42
 41   NY = 6+NY
      GOTO 45
 42   NY = 6-NY
 45   N = NBLIST(NY,NX)
      IF (N.EQ.0) GOTO 100
      N = 95-N
C---  BLOCK ADDRESSES 145 TO 190
      IF (ISIGNZ.GT.0) N = N+96
C
 100  NOBL = N
      RETURN
      END

C   09/09/79 C9090901   MEMBER NAME  LGREIN   (SOURCE)      FORTRAN
      SUBROUTINE LGREIN(NPCL,NPR)
C
C     REINITIALIZE ADATA(NPCLS+2) I.E THE ENERGY OF EACH CLUSTER
C     WHEN LGCDIR IS CALLED WITHOUT LGANAL.
C     Y.WATANABE    09-09-79  05:20
C         NPR   =THE BOS POINTER TO THE RAW LG-ADC DATA ('ALGN')
C         NPCL  =THE BOS POINTER TO THE LG-RESULT BANK ('LGCL')
C
      IMPLICIT INTEGER *2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C     ADATA(NPCLS+2)=CLUSTER ENERGY IN GEV
C---- FIX POINTERS FOR CLUSTER DATA
      NPCGI = NPCL+IDATA(NPCL+1)-1
C---- GET NO.OF CLUSTERS
      NCLST = IDATA(NPCGI+3)
      IF(NCLST.LT.1) RETURN
      NPCLS = NPCL+IDATA(NPCL+3)-1
      LSTEP=IDATA(NPCGI+21)
      NPALGN=2*NPR+6
      NPMAP = (NPCL+IDATA(NPCL+2))*2 -1
C     SUM UP ADC'S TO GET THE ENERGY OF EACH CLUSTER.
      DO 30 N=1,NCLST
      I1=HDATA(NPMAP)
      I2=HDATA(NPMAP+1)
      ESUM=0.
      IF(I1.GT.I2) GO TO 20
      DO 10 I=I1,I2
      II=2*I+NPALGN
      ESUM=ESUM+HDATA(II)
10    CONTINUE
20    ADATA(NPCLS+2)=ESUM/1000.
      NPCLS=NPCLS+LSTEP
      NPMAP=NPMAP+2
30    CONTINUE
C
C     REINITIALIZE THE TOTAL ENERGYS IN GEN INFO., TOO.
      CALL SETSL(ADATA(NPCGI+7),0,36,0.)
      RETURN
      END

*** PMF 19/10/99
*     Since the original subroutine SYMIN4 was not found
*     in the JADE library, try SYMINV which has probably
*     the same functionality as SYMIN4 (Jan Olsson's suggestion!)
      SUBROUTINE SYMIN4(A,L,M,N,IFAIL)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(L,M)
C
      CALL SYMINV(A,L,M,N,IFAIL)
C
      RETURN
      END
*** PMF (end)

C            C7011402   MEMBER NAME  SYMINV   (MINSOR)      FORTRAN
      SUBROUTINE SYMINV(A,L,M,N,IFAIL)
C
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION P(100),Q(100),KR(100),A(L,M)
C
      IFAIL=0
C
      EPSILN=1.0 D-12
      IF(L.LT.N) GO TO 95
      IF(M.LT.N) GO TO 96
C
C                   CONSTRUCT TRUTH TABLE
C
      DO 10 I=1,N
   10 KR(I)=1
C
C                   BEGIN PROGRAMME
C
      DO 65 I=1,N
      K=0
C
C                   SEARCH FOR PIVOT
C
      BIG=0.D0
      DO 37 J=1,N
      TEST=DABS(A(J,J))
      IF(TEST-BIG)37,37,31
   31 IF(KR(J))100,37,32
   32 BIG=TEST
      K=J
   37 CONTINUE
C
C                   TEST FOR ZERO MATRIX
C
      IF(K)100,100,38
C
C                   TEST FOR LINEARITY
C
   38 IF(I.EQ.1) PIVOT1=A(K,K)
      IF(DABS(A(K,K)/PIVOT1)-EPSILN) 100,39,39
C
C                   PREPARATION FOR ELIMINATION STEP1
C
   39 KR(K)=0
      Q(K)=1.D0/A(K,K)
      P(K)=1.D0
      A(K,K)=0.0D0
      KP1=K+1
      KM1=K-1
      IF(KM1)100,50,40
   40 DO 49 J=1,KM1
      P(J)=A(J,K)
      Q(J)= A(J,K)*Q(K)
      IF(KR(J))100,49,42
   42 Q(J)=-Q(J)
   49 A(J,K)=0.D0
   50 IF(K-N)51,60,100
   51 DO 59 J=KP1,N
      P(J)=A(K,J)
      Q(J)=-A(K,J)*Q(K)
      IF(KR(J))100,52,59
   52 P(J)=-P(J)
   59 A(K,J)=0.0D0
C
C                   ELIMINATION PROPER
C
   60 DO 65 J=1,N
      DO 65 K=J,N
   65 A(J,K)= A(J,K)+P(J)*Q(K)
C
C                   ELEMENTS OF LEFT DIAGONAL
C
      DO 70 J=2,N
      JM1=J-1
      DO 70 K=1,JM1
   70 A(J,K)=A(K,J)
      RETURN
C
C                   FAILURE RETURN
C
   95 WRITE(6,150) L,N
      GO TO 100
   96 WRITE(6,151) M,N
  100 IFAIL=1
      RETURN
  150 FORMAT(4H1L =,I5,4H N =,I5,33H L SHOULD BE LARGER OR EQUAL TO N)
  151 FORMAT(4H1M =,I5,4H N =,I5,33H M SHOULD BE LARGER OR EQUAL TO N)
       END
C            C7011402   MEMBER NAME  SYMIN2   (MINSOR)      FORTRAN
      SUBROUTINE SYMIN2(A,L,M,N,IFAIL)
C
C          DIES IST DIE 2. VERSION VON SYMINV
C     (scheint aber identisch zu sein mit der 1. Version, PMF 19/10/99)
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION P(100),Q(100),KR(100),A(L,M)
C
      IFAIL=0
C
      EPSILN=1.0 D-12
      IF(L.LT.N) GO TO 95
      IF(M.LT.N) GO TO 96
C
C                   CONSTRUCT TRUTH TABLE
C
      DO 10 I=1,N
   10 KR(I)=1
C
C                   BEGIN PROGRAMME
C
      DO 65 I=1,N
      K=0
C
C                   SEARCH FOR PIVOT
C
      BIG=0.D0
      DO 37 J=1,N
      TEST=DABS(A(J,J))
      IF(TEST-BIG)37,37,31
   31 IF(KR(J))100,37,32
   32 BIG=TEST
      K=J
   37 CONTINUE
C
C                   TEST FOR ZERO MATRIX
C
      IF(K)100,100,38
C
C                   TEST FOR LINEARITY
C
   38 IF(I.EQ.1) PIVOT1=A(K,K)
      IF(DABS(A(K,K)/PIVOT1)-EPSILN) 100,39,39
C
C                   PREPARATION FOR ELIMINATION STEP1
C
   39 KR(K)=0
      Q(K)=1.D0/A(K,K)
      P(K)=1.D0
      A(K,K)=0.0D0
      KP1=K+1
      KM1=K-1
      IF(KM1)100,50,40
   40 DO 49 J=1,KM1
      P(J)=A(J,K)
      Q(J)= A(J,K)*Q(K)
      IF(KR(J))100,49,42
   42 Q(J)=-Q(J)
   49 A(J,K)=0.D0
   50 IF(K-N)51,60,100
   51 DO 59 J=KP1,N
      P(J)=A(K,J)
      Q(J)=-A(K,J)*Q(K)
      IF(KR(J))100,52,59
   52 P(J)=-P(J)
   59 A(K,J)=0.0D0
C
C                   ELIMINATION PROPER
C
   60 DO 65 J=1,N
      DO 65 K=J,N
   65 A(J,K)= A(J,K)+P(J)*Q(K)
C
C                   ELEMENTS OF LEFT DIAGONAL
C
      DO 70 J=2,N
      JM1=J-1
      DO 70 K=1,JM1
   70 A(J,K)=A(K,J)
      RETURN
C
C                   FAILURE RETURN
C
   95 WRITE(6,150) L,N
      GO TO 100
   96 WRITE(6,151) M,N
  100 IFAIL=1
      RETURN
  150 FORMAT(4H1L =,I5,4H N =,I5,33H L SHOULD BE LARGER OR EQUAL TO N)
  151 FORMAT(4H1M =,I5,4H N =,I5,33H M SHOULD BE LARGER OR EQUAL TO N)
       END

C   23/03/97 703231948  MEMBER NAME  MVERTEX0 (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVERTEX0       SAVED BY F22HAG  ON 88/05/24  AT 17:56
C     PARAMETER MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV,
     *               ITDLEN,IVDLEN,SP0,SP1,DFMASS,SFMUSC, SIGFCZ

C   23/01/87 807251815  MEMBER NAME  SPTHAK   (S)           FORTRAN
      SUBROUTINE SPTHAK( NL,NH,ITH,THR,ISPH,SPHR,IAKO,AKO,IER )
C-----------------------------------------------------------
C   VERSION OF 03/08/79 E.ELSEN      LAST MOD 14/11/86    M.ZIMMER
C   EXTENDED VERSION OF 14/11/86   M.ZIMMER
C   ALSO AKOPLANARITY CALCULATION IS INCLUDED
C   COMPUTE THRUST THR AND SPHERICITY SPHR OF MOMENTA STORED
C   IN LOCATIONS NL TO NH IN BLANK COMMON P(10,400)
C   THE AXIS ARE RETURNED IN ITH AND ISPH, ISPH+1, ISPH+2, IAKO
C   THE THREE NORMALIZED EIGENVALUES OF SPHERICITY ARE STORED IN
C   LOCATIONS 4 OF THE CORRESPONDING AXIS
C   ITHR=0 OR ISPH=0 OR IAKO=0 SUPRESSES CORRESPONDING CALCULATION
C-----------------------------------------------------------
C
C   23/03/97 703231949  MEMBER NAME  MTRINF   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MTRINF         SAVED BY F22HAG  ON 87/04/03  AT 18:35
C
C     -------------- GENERALL TRACK-INFO COMMON -------------------
      DIMENSION IP(10,400)
      COMMON // P(10,400)
      EQUIVALENCE(IP(1,1),P(1,1))
C
      DIMENSION IPE(10,400)
      COMMON /CTRCK0 / NTCH,NTALL,PE(10,400),INDTRK(400),ITRFLG(400)
      EQUIVALENCE(IPE(1,1),PE(1,1))
C
      DIMENSION PC(4,100)
      DIMENSION AXISSP(9), AXISTH(3), SPH(3),AXISAK(3)
C
      IER = 2
      NMOM = NH - NL + 1
      IF( NMOM .LT. 1 ) RETURN
      IER = 0
C                                           COPY VECTORS
      K = 0
      DO 200 J = NL, NH
      K = K + 1
      DO 100 I = 1,3
  100 PC(I,K) = P(I,J)
  200 PC(4,K) = P(6,J)
C
C                                           SPHERICITY
      IF( ISPH.NE.0 ) CALL SPHRCY( PC, NMOM, SPH, AXISSP )
C                                           THRUST
      IF( ITH.NE.0 ) CALL THRUNB( PC, NMOM, 15, THR, AXISTH, IER )
C                                      AKOPLANARITY
      IF( IAKO.NE.0 ) CALL AKOP( PC, NMOM, 15, AKO, AXISAK, IER )
C
C                                           COPY TO LOCATIONS IN P
      IF( ISPH .EQ. 0 ) GO TO 310
      DO 300 J=1,3
      P(J,ISPH) = AXISSP(J)
      P(J,ISPH+1) = AXISSP(J+3)
  300 P(J,ISPH+2) = AXISSP(J+6)
C                                           STORE NORM. EIGENVALUES
      SPHR = SPH(1)
      P(4,ISPH) = SPH(1)
      P(4,ISPH+1) = SPH(2)
      P(4,ISPH+2) = SPH(3)
C                                           STORE NORM. EIGENVALUES
  310 IF( ITH .EQ. 0 ) GOTO 320
      DO 400 I=1,3
  400 P(I,ITH) = AXISTH(I)
      P(4,ITH) = THR
C                                           STORE NORM. EIGENVALUES
  320 IF( IAKO .EQ. 0 ) RETURN
      DO 410 I=1,3
  410 P(I,IAKO) = AXISAK(I)
      P(4,IAKO) = AKO
      RETURN
      END

C   20/01/83 705071225  MEMBER NAME  TRLGS6   (S)           FORTRAN
      SUBROUTINE TRLGS6(PV,R,*)
C
C      THIS ROUTINE TRACKS PARTICLES THROUGH THE LEAD GLASS
C      ARRAYS AND ACCUMULATES PULSEHEIGHTS
C      PV = INCOMING 4 VECTOR IS CHANGED DUE TO ENERGY LOSS
C      R  = 3 VECTOR POINTING TO THE FACE OF THE LEAD GLASS
C      RETURN 1 IS USED IF THE INCIDENT MOMENTUM IS LESS THAN
C               10 MEV
C
C      CHANGE       04/02/83    K.MEIER
C      CHANGE OF EXPECM TO INCORPORATE THE SF6 BLOCKS
C                   25/10/85    N.MAGNUSSEN
C      THIS IS ALMOST IDENTICAL TO TRLG1 BUT THE 3-DIMENSIONAL
C      SHOWER INTEGRATION IS DONE ONLY FOR ELECTRONS AND GAMMAS
C      WITH E > 100 MEV (STANDARD PROCEDURE IS USED FOR LOW ENERGIES)
C      CHANGE       20/09/83    K.MEIER
C      ERROR IN CHARGE CALCULATION CORRECTED
C    PRINT STATEMENTS COMMENTED OUT  11.6.1986    J.OLSSON
C    ERROR IN RATION ESEEN/ENERGY CORRECTED 3.7.86  19.30  J.OLSSON
C    ERROR IN NOT UPDATING R-VECTOR FOR ENDCAP PHOTONS, LEADING TO
C    DOUBLE TRACKING OF ENDCAP PHOTONS AND ELECTRONS, CORRECTED
C    LIKEWISE THE SCALING OF BLOCK ENERGIES DEPENDENT ON READOUT
C    THRESHOLD REMOVED, SINCE THIS IS HANDLED CORRECTLY IN RDALGN
C                                  20.08.1986     J.OLSSON
C    UPDATE ENDCAP POS.VECTOR WITH 20 % EXTRA, FOR PRECISION IN TRLGL
C                                   4.9.86   J.OLSSON
C
C    CALL TO VEGAS REPLACED BY CALL TO WEGAS (COMMON TO TRLGS6,TRLGSH)
C    FNORM FACTORS UPDATED ACC. TO F11MAG.CLUS VALUES
C    RENAME EXPECM TO EXPEC6, TO ENABLE RUNNING AS TRLGS6 TOGETHER WITH
C    TRLGSH, WHICH CALLS ANOTHER EXPECM...    17.11.1986  J.O.
C      CHANGES      19/01/87    J.OLSSON/N.MAGNUSSEN
C      2. FNORM IN EXPECM CHANGED TO 59000 AND 21220 (INTEGRATION VALUE)
C
C   CHANGE OF CODE IN SF65, TO PREVENT NEG. ARGUMENT IN ALOG
C                                       30.1.87    N.M / J.O
C   CHANGE OF CODE IN SF56, FOR SIMILAR REASONS..
C                                        2.2.87    N.M / J.O
C   CHANGE OF DIMENSION IN LISTBL,BLCFRC
C                                        1.4.87    D.P / J.O
C   AVGSUM NORM IN ENERGY SUM
C                                       13.4.87    D.P / J.O
C   PREVENT DIVIDE CHECK FOR AVGSUM=0.
C                                        2.5.87          J.O
C
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      COMMON/CLGHIT/AMPLG(3000)
      DIMENSION RR(3),LISTBL(100),BLCFRC(100),VAR(2),DC(3)
      LOGICAL * 1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGS CODE SLOW!!!!!
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                   BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C
C                     ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.
C
      DATA TWOPI/6.28319/
      REAL RADL/23.9/
*** PMF 15/10/99      DIMENSION R(1),PV(1)
      DIMENSION R(*),PV(*)
*** PMF (end)
      DIMENSION R0(3)
      DATA ICALL /0/
C
      IF(ICALL.EQ.1) GOTO 1111
      WRITE(6,1113)
1113  FORMAT(' ===>> TRLGS6: DOUBLE TRACKING CORRECTED VERSION 4.9.86 '/
     $ '                    REVISED VERSION FROM 19.01.1987...')
      ICALL = 1
C
C      FIND INDEX FOR ENERGY LOSS
C       LOSS = 0  PHOTON
C       LOSS = 1  ELECTRON
C       LOSS = 2  MINIMUM IONIZING PARTICLE
C
 1111 IF(PV(6).LT.0.01) RETURN 1
C
      OUTR=OUTR2*OUTR2
      ELOSS=0.
      ELS  =0.
      EDEPOT = 0.
      LOSS=2
      IF(PV(5).LT.1.E-03) LOSS=1
      IF(PV(5).EQ.0.)     LOSS=0
C
C                                           ENERGIES IN MEV
      ENERGY=PV(4)*1000.
      EINC = ENERGY / 1000.
C
C                                           THE DIRECTION OF THE TRACKIN
C                                           VECTOR IS NOT CHANGED
C                                           WHEN TRACKED THROUGH THE
C                                           BLOCKS
      PV(6)=SQRT(PV(1)**2+PV(2)**2+PV(3)**2)
      PVX=PV(1)/PV(6)
      PVY=PV(2)/PV(6)
      PVZ=PV(3)/PV(6)
      PVXY=PVX**2+PVY**2
      IF(PVXY.LT.1.E-5) RETURN
      DC(1) = PVX
      DC(2) = PVY
      DC(3) = PVZ
      X1=0.
      R1=R(1)**2+R(2)**2
      RADIUS = SQRT( R1 )
      IF( .NOT.
     *  ( ZLGMI+5..LE.R(3).AND.R(3).LE.ZLGPL-5..AND.RADIUS.GT.RLG-5. ))
     *                             GO TO 1000
C
C                                           CENTRAL PART
C
C
C                                           ANTI ENERGY CORRECTION
C                                           ABSORPTION IN COIL
      IBE = 0
      IF( LOSS .LT.2 .AND. LFLAG(3) ) ENERGY=ELGOBS(IBE,DC,EINC)*1000.
C                                           ENERGY SMEARING
      ENERGY = AMAX1( ENERGY, 1. )
      EINC = ENERGY/1000.
      IF( LOSS .LT.2 .AND. LFLAG(1) ) ENERGY=ELSMR(IBE,DC,EINC)*1000.
C
C                                           CALCULATE THICKNESS OF SLAB
C                                           OF LEAD GLASS CORRESPONDING
C                                           TO 1CM TRACK LENGTH
C
      PVR=R(1)*PVX+R(2)*PVY
      DELR=PVR/RADIUS
      TRKL=BLDEP/DELR
C
C                                           DETERMINE STEP SIZE
      NSTEP=BLDEP/(10.*DELR)+1
      XL=10.
      DX=XL/RADL
C
C                                           ENERGY LOSS FOR HADRONS
      IF( LOSS.LT.2.AND.ENERGY.GT.100.) GOTO 500
      IF( LOSS.LT.2 ) GO TO 26
C
C     CALCULATE EXIT POINT AT THE BACK SURFACE OF THE LEAD GLASS
C
      R0(1)=R(1)+PVX*TRKL
      R0(2)=R(2)+PVY*TRKL
      R0(3)=R(3)+PVZ*TRKL
C
C     CALCULATE PATH LENGTH THROUGH LIGHT GUIDE (IFLG = 2)
C
      IFLG = 2
      CALL PLLIGD(PLLI,R(1),R(2),R(3),R0(1),R0(2),R0(3),IFLG)
      ICHG=IFIX(PV(7))
      ITYP=IFIX(PV(8))
      CALL HDECLS(EDEPOT,ICHG,ITYP,PV,IBE,TRKL,PLLI)
      ED=EDEPOT
      EDEPOT=10.*EDEPOT/TRKL*1000.
C     WRITE(6,600) ICHG,ITYP,PV(4),IBE,TRKL,PLLI,ED,EDEPOT
  600 FORMAT(1H ,2I3,F8.3,I5,2F8.2,2X,2F8.3)
   26 CONTINUE
      N0 = 1
C
C                                           DEPTH OF CONVERSION
C                                           FOR PHOTONS IN THE LEAD GLAS
C                                           ASSUME UNIFORM CONVERSION
C                                           PROBABILITY WITHIN
C                                           THE FIRST 2 X0
      IF(LOSS.NE.0) GO TO 23
      X0=51.*RN(DUM)
      N0=X0/(10.*DELR)+1
   23 CONTINUE
C
      ISTEP=0
   21 ISTEP=ISTEP+1
C
C                                           CALCULATE INDEX FOR BLOCKS
C                                           WHICH ARE HIT
      PHI=ATAN2(R(2),R(1))
      IF(PHI.LT.0.) PHI=TWOPI+PHI
      NFI=PHI/DELFI
      IF(ABS(R(3)).GT.ZLGPL) GO TO 22
      DZ=R(3)-ZLGMI
      NZ=DZ/BLZ+1
      NBL=NZ+32*NFI
C
C                                           ACCUMULATE PULSEHEIGHTS
C                                           IN BLOCKS
      IF(LOSS.GE.2) GO TO 25
C                                           PHOTONS AND E
      EDEPOT=0.
      IF(ISTEP.LT.N0) GO TO 24
      X1=X1+DX
      EDEPOT=SHOWR(ENERGY,X1,DX)
      IF(X1.GT.9.) EDEPOT=ENERGY-ELOSS
      ELOSS=ELOSS+EDEPOT
      IF(ELOSS.GT.ENERGY) GO TO 24
      AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      IF(X1.GT.9.) RETURN
      GO TO 24
C
C                                           HADRONS
   25 AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      ELS=ELS+EDEPOT
      IF(ELS.GE.ENERGY) GO TO 22
C
C                                           PROPAGATE TRACK
   24 R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
C                                           CHECK WHETHER PARTICLE IS
C                                           STILL IN THE LEAD GLASS
      R1=R(1)**2+R(2)**2
      IF(R1.GT.OUTR) GO TO 22
      IF(ZLGPL.LT.R(3).OR.R(3).LT.ZLGMI) GO TO 22
      GO TO 21
   22 CONTINUE
      IF(ELOSS.EQ.0.) RETURN
      RX=(PV(4)-ELOSS/2000.)/PV(4)
      IF(ELOSS.GE.ENERGY) RX=0.001
      IF(ELS  .GE.ENERGY) RX=0.001
      RX=ABS(RX)
      DO 1004 I4=1,4
 1004 PV(I4)=PV(I4)*RX
      PV(6)=PV(6)*RX
      RETURN
C
C                                           END CAP LEAD GLASS
C                                           FOLLOW PHOTON TO THE FACE
C                                           OF THE END CAP COUNTERS
 1000 CONTINUE
      RABS=0.
      DO 1001 I3=1,3
 1001 RABS=RABS+R(I3)**2
      RABS=SQRT(RABS)
      DO 1002 I3=1,3
 1002 R(I3)=R(I3)/RABS
      DISTZ=ZENDPL
      IF(R(3).LT.0) DISTZ=ABS(ZENDMI)
      ZLAM=ABS(DISTZ/R(3))
      DO 1003 I3=1,3
 1003 R(I3)=ZLAM*R(I3)
      CALL ENDCLG(R,NBL,*9000)
C
C                                           ANTI ENERGY CORRECTION
C                                           ABSORPTION IN TANK ENDPLATE
      IBE = 1
      IF( R(3) .LT. 0. ) IBE = -1
      IF( LOSS .LT.2 .AND. LFLAG(3) ) ENERGY=ELGOBS(IBE,DC,EINC)*1000.
C                                           ENERGY SMEARING
      ENERGY = AMAX1( ENERGY, 1. )
      EINC = ENERGY/1000.
      IF( LOSS .LT.2 .AND. LFLAG(1) ) ENERGY=ELSMR(IBE,DC,EINC)*1000.
C
C                                           CALCULATE DELZ OF SLAB
C                                           OF LEAD GLASS CORRESPONDING
C                                           1CM TRACK LENGTH IN LEAD GLA
      DELZ=ABS(PVZ*10.)
      TRKL=DEPEND/ABS(PVZ)
C
C                                           DETERMINE STEP SIZE
      NSTEP=DEPEND/DELZ +1
      XL=10.
      DX=XL/RADL
C
C                                           ENERGY LOSS FOR HADRONS
      IF( LOSS.LT.2.AND.ENERGY.GT.100.) GOTO 700
      IF( LOSS.LT.2 ) GO TO 260
      PLLI=0.
      ICHG=IFIX(PV(7))
      ITYP=IFIX(PV(8))
      CALL HDECLS(EDEPOT,ICHG,ITYP,PV,IBE,TRKL,PLLI)
      ED=EDEPOT
      EDEPOT=10.*EDEPOT/TRKL*1000.
C     WRITE(6,600) ICHG,ITYP,PV(4),IBE,TRKL,PLLI,ED,EDEPOT
  260 CONTINUE
      N0 = 1
C
      IF(LOSS.NE.0) GO TO 230
C
C                                           DEPTH OF CONVERSION
C                                           FOR PHOTONS IN THE LEAD GLAS
C                                           ASSUME UNIFORM CONVERSION
C                                           PROBABILITY WITHIN
C                                           THE FIRST 2 X0
      IF(LOSS.NE.0) GO TO 230
      X0=51.*RN(DUM)
      N0=X0/DELZ +1
  230 CONTINUE
C
      ISTEP=0
  210 ISTEP=ISTEP+1
C
C                                           CALCULATE INDEX FOR
C                                           BLOCKS WHICH ARE HIT AND
C                                           CHECK WHETHER PARTICLE IS
C                                           STILL IN THE LEAD GLASS
      CALL ENDCLG(R,NBL,*9000)
C
C                                           ACCUMULATE PULSEHEIGHTS
      IF(LOSS.GE.2) GO TO 250
C                                           PHOTONS AND E
      EDEPOT=0.
      IF(ISTEP.LT.N0) GO TO 240
      X1=X1+DX
      EDEPOT=SHOWR(ENERGY,X1,DX)
      IF(X1.GT.8.) EDEPOT=ENERGY-ELOSS
      ELOSS=ELOSS+EDEPOT
      IF(ELOSS.GT.ENERGY) GO TO 240
      AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      IF(X1.GT.8.) RETURN
      GO TO 240
C                                           HADRONS
  250 AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      ELS=ELS+EDEPOT
      IF(ELS.GE.ENERGY) GO TO 9000
C                                           PROPAGATE TRACK
  240 R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
      GO TO 210
C
C                                           DE/DX ENERGY LOSS
 9000 IF(ELOSS.EQ.0.) RETURN
      RX=(PV(4)-ELOSS/2000.)/PV(4)
      IF(ELOSS.GE.ENERGY) RX=0.001
      IF(ELS  .GE.ENERGY) RX=0.001
      RX=ABS(RX)
      DO 9001 I4=1,4
 9001 PV(I4)=PV(I4)*RX
      PV(6)=PV(6)*RX
C
      RETURN
C
C  500   CENTRAL PART ELECTRONS AND PHOTONS
C  700   ENDCAP       ELECTRONS AND PHOTONS
C
C      CENTRAL PART
C      CALCULATE BLOCKS WHICH MAY SEE PART OF THE EL. MG. SHOWER
C
  500 XL = 40.
      NO = 1
      RR(1) = R(1)
      RR(2) = R(2)
      RR(3) = R(3) + 100.
C
C      CHECK WHETHER PARTICLE IS STILL IN THE LEAD GLASS
C
      R1=RR(1)**2+RR(2)**2
      IF(R1.GT.OUTR) GO TO 510
      IF(ZLGPL.LT.RR(3).OR.RR(3).LT.ZLGMI) GO TO 510
  501 PHI=ATAN2(RR(2),RR(1))
      IF(PHI.LT.0.) PHI=TWOPI+PHI
      NFI=PHI/DELFI
      IF(ABS(RR(3)).GT.ZLGPL) GO TO 510
      DZ=RR(3)-ZLGMI
      NZ=DZ/BLZ+1
      NBL=NZ+32*NFI
C
C     CHECK WHETHER NBL IS ALREADY IN THE BLOCK LIST IF NOT
C     ADD THE BLOCK NUMBER TO THE LIST
C
      IF(NO.EQ.1) GO TO 505
      DO 504 N=1,NO
      IF(LISTBL(N).EQ.NBL) GO TO 503
  504 CONTINUE
      NO = NO + 1
  505 LISTBL(NO)=NBL
      NPL = NFI+1
      NMI = NFI-1
      IF(NFI.EQ. 0) NMI = 83
      IF(NFI.EQ.83) NPL =  0
      LISTBL(NO+1) =NZ+32*NPL
      LISTBL(NO+2) =NZ+32*NMI
      NO = NO + 2
  503 RR(1)=RR(1)+XL*PVX
      RR(2)=RR(2)+XL*PVY
      RR(3)=RR(3)+XL*PVZ
C
C      CHECK WHETHER PARTICLE IS STILL IN THE LEAD GLASS
C
      R1=RR(1)**2+RR(2)**2
      IF(R1.GT.OUTR) GO TO 510
      IF(ZLGPL.LT.RR(3).OR.RR(3).LT.ZLGMI) GO TO 510
      GO TO 501
C
  510 RR(1) = R(1)
      RR(2) = R(2)
      RR(3) = R(3) - 100.
C
C      CHECK WHETHER PARTICLE IS STILL IN THE LEAD GLASS
C
      R1=RR(1)**2+RR(2)**2
      IF(R1.GT.OUTR) GO TO 520
      IF(ZLGPL.LT.RR(3).OR.RR(3).LT.ZLGMI) GO TO 520
C
  511 PHI=ATAN2(RR(2),RR(1))
      IF(PHI.LT.0.) PHI=TWOPI+PHI
      NFI=PHI/DELFI
      IF(ABS(RR(3)).GT.ZLGPL) GO TO 520
      DZ=RR(3)-ZLGMI
      NZ=DZ/BLZ+1
      NBL=NZ+32*NFI
C
C     CHECK WHETHER NBL IS ALREADY IN THE BLOCK LIST IF NOT
C     ADD THE BLOCK NUMBER TO THE LIST
C
      IF(NO.EQ.1) GO TO 515
      DO 514 N=1,NO
      IF(LISTBL(N).EQ.NBL) GO TO 513
  514 CONTINUE
      NO = NO + 1
  515 LISTBL(NO)=NBL
      NPL = NFI+1
      NMI = NFI-1
      IF(NFI.EQ. 0) NMI = 83
      IF(NFI.EQ.83) NPL =  0
      LISTBL(NO+1) =NZ+32*NPL
      LISTBL(NO+2) =NZ+32*NMI
      NO = NO + 2
  513 RR(1)=RR(1)+XL*PVX
      RR(2)=RR(2)+XL*PVY
      RR(3)=RR(3)+XL*PVZ
C
C      CHECK WHETHER PARTICLE IS STILL IN THE LEAD GLASS
C
      R1=RR(1)**2+RR(2)**2
      IF(R1.GT.OUTR) GO TO 520
      IF(ZLGPL.LT.RR(3).OR.RR(3).LT.ZLGMI) GO TO 520
C
      GO TO 511
C
  520 RR(1) = R(1)
      RR(2) = R(2)
      RR(3) = R(3)
C
C      CHECK WHETHER PARTICLE IS STILL IN THE LEAD GLASS
C
      R1=RR(1)**2+RR(2)**2
      IF(R1.GT.OUTR) GO TO 530
      IF(ZLGPL.LT.RR(3).OR.RR(3).LT.ZLGMI) GO TO 530
C
  521 PHI=ATAN2(RR(2),RR(1))
      IF(PHI.LT.0.) PHI=TWOPI+PHI
      NFI=PHI/DELFI
      IF(ABS(RR(3)).GT.ZLGPL) GO TO 530
      DZ=RR(3)-ZLGMI
      NZ=DZ/BLZ+1
      NBL=NZ+32*NFI
C
C     CHECK WHETHER NBL IS ALREADY IN THE BLOCK LIST IF NOT
C     ADD THE BLOCK NUMBER TO THE LIST
C
      IF(NO.EQ.1) GO TO 525
      DO 524 N=1,NO
      IF(LISTBL(N).EQ.NBL) GO TO 523
  524 CONTINUE
      NO = NO + 1
  525 LISTBL(NO)=NBL
      NPL = NFI+1
      NMI = NFI-1
      IF(NFI.EQ. 0) NMI = 83
      IF(NFI.EQ.83) NPL =  0
      LISTBL(NO+1) =NZ+32*NPL
      LISTBL(NO+2) =NZ+32*NMI
      NO = NO + 2
  523 RR(1)=RR(1)+XL*PVX
      RR(2)=RR(2)+XL*PVY
      RR(3)=RR(3)+XL*PVZ
C
C      CHECK WHETHER PARTICLE IS STILL IN THE LEAD GLASS
C
      R1=RR(1)**2+RR(2)**2
      IF(R1.GT.OUTR) GO TO 530
      IF(ZLGPL.LT.RR(3).OR.RR(3).LT.ZLGMI) GO TO 530
C
      GO TO 521
C
C     CALCULATE BLOCK ENERGIES
C
  530 IPART = 0
      VAR(1)= ATAN2(R(2),R(1))
      VAR(2)= R(3)
      IF(LISTBL(1).LT.0) RETURN 1
C ****    EXPEC6 USES BLOCK COUNTING STARTING AT 0
      DO 532 N=1,NO
  532 LISTBL(N) = LISTBL(N) - 1
      CALL EXPEC6(IPART,ENERGY,VAR,DC,NO,LISTBL,BLCFRC,AVGSUM)
C     IF(ESEEN.GT.0.) READCR = ENERGY/ESEEN
C *** CORRECT FOR READOUT THRESHOLD
C
C  AVGSUM NORMS  THE BLCFRC SUM, NEEDED TO KEEP THE RESOLUTION
C  CHANGE 13.4.87, D.PITZL, J.O.
C     ESEEN = 0.
C     DO 533 NB=1,NO
C     EBLOCK = ENERGY*BLCFRC(NB)
C     IF(EBLOCK.GT.28.) ESEEN = ESEEN + EBLOCK
C     ESEEN = ESEEN + EBLOCK
C 533 CONTINUE
      READCR = 1.
C     IF(ESEEN.GT.0.) READCR = ENERGY/ESEEN
C  CHANGED 3.7.86  19.30    J.OLSSON
C     IF(ENERGY.GT.0.) READCR = ESEEN/ENERGY
C ***  UPDATE BLOCK ENERGIES
      DO 531 NB=1,NO
      NBL = LISTBL(NB) + 1
C     AMPLG(NBL) = AMPLG(NBL) + READCR*ENERGY*BLCFRC(NB)
      IF(ABS(AVGSUM).GT..00001)
     $ AMPLG(NBL) = AMPLG(NBL) + READCR*ENERGY*BLCFRC(NB)/AVGSUM
  531 CONTINUE
      R(1) = RR(1)
      R(2) = RR(2)
      R(3) = RR(3)
      RETURN
C
C     END CAP LEAD GLASS
C     FOLLOW PHOTON TO THE FACE OF THE END CAP COUNTERS
C
  700 CONTINUE
      RABS=0.
      DO 701 I3=1,3
  701 RABS=RABS+R(I3)**2
      RABS=SQRT(RABS)
      DO 702 I3=1,3
  702 R(I3)=R(I3)/RABS
      DISTZ=ZENDPL
      IF(R(3).LT.0) DISTZ=ABS(ZENDMI)
      ZLAM=ABS(DISTZ/R(3))
      DO 703 I3=1,3
  703 R(I3)=ZLAM*R(I3)
C
C      SET UP BLOCK ARRAY OF BLOCKS WHICH MIGHT RECIEVE ENERGY
C      FROM THE EL.MG. SHOWER
C
      NO = 0
      RR(3) = R(3)
      DO 710 IC=1,3
      RR(1) = R(1) + (IC-2)*100.
      DO 711 JC=1,3
      RR(2) = R(2) + (JC-2)*100.
      CALL ENDCLG(RR,NBL,*711)
      IF(NO.EQ.0) GO TO 714
      DO 712 N=1,NO
      IF(LISTBL(N).EQ.NBL) GO TO 711
  712 CONTINUE
  714 NO = NO+1
      LISTBL(NO)=NBL
  711 CONTINUE
  710 CONTINUE
C
C     CALCULATE BLOCK ENERGIES
C
  730 IPART = 1
      IF(R(3).LT.0.) IPART = -1
      VAR(1)= R(1)
      VAR(2)= R(2)
      IF(LISTBL(1).LT.0) RETURN 1
C *****     EXPEC6 USES USUAL BLOCK COUNTING STARTING FROM 0
      DO 732 N=1,NO
  732 LISTBL(N) = LISTBL(N) - 1
      CALL EXPEC6(IPART,ENERGY,VAR,DC,NO,LISTBL,BLCFRC,AVGSUM)
C *** CORRECT FOR READOUT THRESHOLD
C     ESEEN = 0.
C     DO 733 NB=1,NO
C     EBLOCK = ENERGY*BLCFRC(NB)
C     IF(EBLOCK.GT.28.) ESEEN = ESEEN + EBLOCK
C 733 CONTINUE
      READCR = 1.
C     IF(ESEEN.GT.0.) READCR = ENERGY/ESEEN
C  CHANGED 3.7.86  19.30    J.OLSSON
C ***  UPDATE BLOCK ENERGIES
      DO 731 NB=1,NO
      NBL = LISTBL(NB) + 1
      IF(ABS(AVGSUM).GT..00001)
     $ AMPLG(NBL) = AMPLG(NBL) + READCR*ENERGY*BLCFRC(NB)/AVGSUM
  731 CONTINUE
C
C UPDATE POSITION VECTOR TO BACK END OF LG, 20 % EXTRA FOR SECURITY
C
      TRKL=DEPEND*1.2/ABS(PVZ)
C
      R(1)=R(1)+PVX*TRKL
      R(2)=R(2)+PVY*TRKL
      R(3)=R(3)+PVZ*TRKL
C
      RETURN
      END
      SUBROUTINE EXPEC6(IPART,E,VAR,DIRC,NBLOCK,IBLIST,BLCFRC,AVGSUM)
C
C     CALCULATE EXPECTED FRACTIONS OF ELECTROMAGNETIC SHOWER
C     IN NBLOCK BLOCKS GIVEN IN A BLOCKLIST IBLIST
C     DISTINGUISH SF5 AND SF6 BLOCKS
C                                   VARIABLES: ...5, ...6
C
C         >>>>>>>>>  MONTE CARLO VERSION  <<<<<<<<<
C
C
C     I/P : IPART        DETECTOR PART -1,0,+1
C           E            SHOWER ENERGY (DEFAULT 500 MEV)
C           VAR          IMPACT POINTS ON LEAD-GLASS SURFACE
C                        VAR(1),VAR(2) = PHI,Z IN BARREL CASE
C                        VAR(1),VAR(2) =   X,Y IN ENDCAP CASE
C           DIRC         DIRECTION COSINE OF SHOWER AXIS (DX,DY,DZ)
C           NBLOCK       LENGTH OF BLOCKLIST
C           IBLIST       LIST OF BLOCKS FOR WHICH THE FRACTIONS
C                        SHOULD BE CALCULATED
C
C     O/P : BLCFRC       FRACTION IN EACH REQUESTED BLOCK *
C                        CORRECTION FOR OUTSIDE FRACTION
C           AVGSUM       ENERGY FRACTION IN BLOCKS CONTAINED IN IBLIST
C
C                                       06/08/82
C               EXTENDED  N.MAGNUSSEN   20/08/85
      EXTERNAL SF5
      EXTERNAL SF6
      EXTERNAL SF65
      EXTERNAL SF56
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      COMMON /TRAFO/ STR,CTR,SPR,CPR,CTRCPR,CTRSPR,STRCPR,STRSPR,
     *               JPART,XMOV5,YMOV5,ZMOV5,XMOV6,YMOV6,ZMOV6
      COMMON /PARAME/ P(6,2),MEDNOW
      COMMON / CJTRIG / PI,TWOPI
      DIMENSION VAR(2),DIRC(3),X0(2)
      DIMENSION EL(6),AL5(6),ALL5(6),BL5(6),ED(5),AD5(5),ALD5(5),BD5(5)
      DIMENSION AL6(6),ALL6(6),BL6(6),AD6(5),ALD6(5),BD6(5)
      DIMENSION XL(3),XU(3)
      DIMENSION IBLIST(1),BLCFRC(1)
C
C     SHOWER FUNCTION PARAMETERS ACCORDING TO EGS3 - MONTE CARLO
C
      DATA EL     /100.   ,300.   ,500.   ,700.   ,1000.  ,5000.  /
      DATA AL5    /  3.25 ,  4.59 ,  5.80 ,  6.06 ,  6.72 ,  8.63 /
      DATA ALL5   /   .73 ,  1.45 ,  1.65 ,  1.84 ,  2.03 ,  2.74 /
      DATA BL5    /   .395,   .443,   .447,   .449,   .460,   .455/
      DATA AL6    /  3.25 ,  4.48 ,  5.54 ,  5.87 ,  6.48 ,  8.06 /
      DATA ALL6   /   .73 ,  1.45 ,  1.65 ,  1.84 ,  2.03 ,  2.74 /
      DATA BL6    /   .381,   .429,   .432,   .437,   .447,   .441/
C
      DATA ED     /100.   ,200.   ,200.   ,300.   ,4000.   /
      DATA AD5    /  1.34 ,  1.21 ,  0.26 ,   .66 ,   1.91 /
      DATA ALD5   /   .72 ,   .2  ,   .19 ,   .19 ,    .71 /
      DATA BD5    /   .048,   .004,   .002,   .011,   -.005/
      DATA AD6    /  1.23 ,  1.06 ,   .33 ,   .61 ,   1.58 /
      DATA ALD6   /   .72 ,   .2  ,   .19 ,   .19 ,    .71 /
      DATA BD6    /   .048,   .003,   .005,   .010,   -.006/
C
      DATA FACMC /.9013/
      DATA X0/23.90,16.60/
C     DATA ICO/0/
      DATA ZSF6/318./
C
      JPART = IPART
      DO 116 IBL = 1,NBLOCK
      BLCFRC(IBL) = 0.
  116 CONTINUE
      AVGSUM = 0.
C
C     IMPACT POINT ON LG SURFACE ??
C
      IF(ICHECK(VAR(1),VAR(2),IPART).NE.1) RETURN
C
C     TRANSFORMATION PARAMETERS
C
      DX = DIRC(1)
      DY = DIRC(2)
      DZ = DIRC(3)
      IF(IPART.EQ.0) GOTO 1
      ZENDCP = IPART*ZENDPL
      XMOV = VAR(1)
      YMOV = VAR(2)
      ZMOV = ZENDCP
      GOTO 2
    1 XMOV = RLG*COS(VAR(1))
      YMOV = RLG*SIN(VAR(1))
      ZMOV = VAR(2)
    2 CTR = DZ/SQRT(DX*DX+DY*DY+DZ*DZ)
      STR = SQRT(1.-CTR*CTR)
      PR=ATAN2(DY,DX)
      IF(PR.LT.0.) PR=PR+TWOPI
      SPR = SIN(PR)
      CPR = COS(PR)
      CTRCPR = CTR*CPR
      CTRSPR = CTR*SPR
      STRCPR = STR*CPR
      STRSPR = STR*SPR
C
C     CHOOSE SHOWER START POINT (THIS IS THE MC-VERSION !)
C
      SSPOI5 = -X0(1)*ALOG(RN(DUMMY))/.773278
      SSPOI6 = X0(2)*SSPOI5/X0(1)
      XMOV5 = XMOV + SSPOI5*DX
      YMOV5 = YMOV + SSPOI5*DY
      ZMOV5 = ZMOV + SSPOI5*DZ
      XMOV6 = XMOV + SSPOI6*DX
      YMOV6 = YMOV + SSPOI6*DY
      ZMOV6 = ZMOV + SSPOI6*DZ
C
C     SHOWER PARAMETERS (PLO'I'5,6  INTERPOLATED FROM PARAM.)
C
      IF(E.LE.0.) E=500.
      IF(E.LT.5000.) GOTO 3
      PLO15 = AL5(6)
      PLO25 = ALL5(6)
      PLO35 = BL5(6)
      PLO16 = AL6(6)
      PLO26 = ALL6(6)
      PLO36 = BL6(6)
      GOTO 9
    3 IF(E.LT.1000.) GOTO 4
      EFAC = (E-EL(5))/ED(5)
      PLO15 = AL5(5)+AD5(5)*EFAC
      PLO25 = ALL5(5)+ALD5(5)*EFAC
      PLO35 = BL5(5)+BD5(5)*EFAC
      PLO16 = AL6(5)+AD6(5)*EFAC
      PLO26 = ALL6(5)+ALD6(5)*EFAC
      PLO36 = BL6(5)+BD6(5)*EFAC
      GOTO 9
    4 IF(E.LT.700.)  GOTO 5
      EFAC = (E-EL(4))/ED(4)
      PLO15 = AL5(4)+AD5(4)*EFAC
      PLO25 = ALL5(4)+ALD5(4)*EFAC
      PLO35 = BL5(4)+BD5(4)*EFAC
      PLO16 = AL6(4)+AD6(4)*EFAC
      PLO26 = ALL6(4)+ALD6(4)*EFAC
      PLO36 = BL6(4)+BD6(4)*EFAC
      GOTO 9
    5 IF(E.LT.500.)  GOTO 6
      EFAC = (E-EL(3))/ED(3)
      PLO15 = AL5(3)+AD5(3)*EFAC
      PLO25 = ALL5(3)+ALD5(3)*EFAC
      PLO35 = BL5(3)+BD5(3)*EFAC
      PLO16 = AL6(3)+AD6(3)*EFAC
      PLO26 = ALL6(3)+ALD6(3)*EFAC
      PLO36 = BL6(3)+BD6(3)*EFAC
      GOTO 9
    6 IF(E.LT.300.)  GOTO 7
      EFAC = (E-EL(2))/ED(2)
      PLO15 = AL5(2)+AD5(2)*EFAC
      PLO25 = ALL5(2)+ALD5(2)*EFAC
      PLO35 = BL5(2)+BD5(2)*EFAC
      PLO16 = AL6(2)+AD6(2)*EFAC
      PLO26 = ALL6(2)+ALD6(2)*EFAC
      PLO36 = BL6(2)+BD6(2)*EFAC
      GOTO 9
    7 IF(E.LT.100.)  GOTO 8
      EFAC = (E-EL(1))/ED(1)
      PLO15 = AL5(1)+AD5(1)*EFAC
      PLO25 = ALL5(1)+ALD5(1)*EFAC
      PLO35 = BL5(1)+BD5(1)*EFAC
      PLO16 = AL6(1)+AD6(1)*EFAC
      PLO26 = ALL6(1)+ALD6(1)*EFAC
      PLO36 = BL6(1)+BD6(1)*EFAC
      GOTO 9
    8 PLO15 = AL5(1)
      PLO25 = ALL5(1)
      PLO35 = BL5(1)
      PLO16 = AL6(1)
      PLO26 = ALL6(1)
      PLO36 = BL6(1)
C
    9 P(1,1) = PLO25
      P(2,1) = PLO15*3.293
      P(3,1) = PLO35
      P(4,1) = 3.134
      P(5,1) = PLO15*.267
      P(6,1) = .6354
      P(1,2) = PLO26
      P(2,2) = PLO16*2.832
      P(3,2) = PLO36
      P(4,2) = 3.017
      P(5,2) = PLO16*.266
      P(6,2) = .60333
C
C     NORMALIZE INTEGRALS
C
      P2A15=PLO25+1.
      P2A16=PLO26+1.
C     FNORM5 = FACMC*60500.0*PLO15*GAMMA(P2A15)/PLO35**P2A15
C     FNORM6 = FACMC*22000.0*PLO16*GAMMA(P2A16)/PLO36**P2A16
C     FNORM5 = FACMC*59800.0*PLO15*GAMMA(P2A15)/PLO35**P2A15
C     FNORM6 = FACMC*21800.0*PLO16*GAMMA(P2A16)/PLO36**P2A16
C     FNORM5 = FACMC*62618.0*PLO15*GAMMA(P2A15)/PLO35**P2A15
C     FNORM6 = FACMC*21936.0*PLO16*GAMMA(P2A16)/PLO36**P2A16
      FNORM5 = FACMC*59000.0*PLO15*GAMMA(P2A15)/PLO35**P2A15
      FNORM6 = FACMC*21220.0*PLO16*GAMMA(P2A16)/PLO36**P2A16
C
C     INTEGRATION
C
C
C     CHECK TOTAL VALUE ON REQUEST
C
      IF(NBLOCK.GT.0) GOTO 113
      XL(1) = RLG
      IF(IPART.NE.0) XL(1) = VAR(1)-500.
      XL(2) = VAR(1)-2.
      IF(IPART.NE.0) XL(2) = VAR(2)-500.
      XL(3) = VAR(2)-500.
      IF(IPART.EQ. 1) XL(3) = ZENDPL
      IF(IPART.EQ.-1) XL(3) = ZENDMI-1000.
      XU(1) = RLG+1000.
      IF(IPART.NE.0) XU(1) = VAR(1)+500.
      XU(2) = VAR(1)+2.
      IF(IPART.NE.0) XU(2) = VAR(2)+500.
      XU(3) = VAR(2)+500.
      IF(IPART.EQ. 1) XU(3) = ZENDPL+1000.
      IF(IPART.EQ.-1) XU(3) = ZENDMI
      CALL WEGAS(SF5,.001,1000,9,XL,XU,AVG,SD,C2)
      AVG = AVG/FNORM5
      SD = SD/FNORM5
C     WRITE(6,1133) AVG,SD,C2
C1133 FORMAT(10X,'---> WEGAS INTEGRAL RESULT : ',F12.5,/,
C    *       10X,'---> ERROR + CHI**2 VALUE  : ',2F12.5)
      RETURN
C
C     PERFORM INTEGRATION OVER REQUESTED BLOCKS
C
  113 MED5=0
      MED6=0
      BEHIN5=E*X0(1)/100.
      BEHIN6=E*X0(2)/100.
      BFRONT=10.
      DO 1131 IB=1,NBLOCK
       IBLOCK = IBLIST(IB)
       IWHICH = 5
       J=MOD(IBLOCK,32)
       IF(J.GE.13.AND.J.LE.18.AND.IPART.EQ.0) IWHICH = 6
       MED = IWHICH
       IF(MED.EQ.5) MED5=1
       IF(MED.EQ.6) MED6=1
 1131 CONTINUE
      IF(MED5.EQ.1.AND.MED6.EQ.0) GOTO 1145
      IF(MED5.EQ.0.AND.MED6.EQ.1) GOTO 1146
      IF(MED5.EQ.1.AND.MED6.EQ.1) GOTO 1147
C
C  ONLY SF5-BLOCKS IN CLUSTER
C
1145  DO 1141 IBL = 1,NBLOCK
       IBLOCK = IBLIST(IBL)
       CALL LIMINT(IBLOCK,IPART,IER,XL(1),XL(2),XL(3),XU(1),XU(2),XU(3))
       IF(IER.GT.0) GOTO 1141
       IF(IPART.EQ. 0) XU(1) = XU(1) + BEHIN5
       IF(IPART.EQ. 1) XU(3) = XU(3) + BEHIN5
       IF(IPART.EQ.-1) XL(3) = XL(3) - BEHIN5
       IF(IPART.EQ. 0) XL(1) = XL(1) - BFRONT
       IF(IPART.EQ. 1) XL(3) = XL(3) - BFRONT
       IF(IPART.EQ.-1) XU(3) = XU(3) + BFRONT
C
C     INTEGRATION OVER A SF5-BLOCK
C
       CALL WEGAS(SF5,.01,200,3,XL,XU,AVG,SD,C2)
       AVG = AVG/FNORM5
       SD = SD/FNORM5
       BLCFRC(IBL) = AVG
       AVGSUM = AVGSUM+AVG
1141  CONTINUE
      GOTO 115
C
C   ONLY SF6-BLOCKS IN CLUSTER
C
1146  CONTINUE
      DO 1142 IBL=1,NBLOCK
       IBLOCK = IBLIST(IBL)
       CALL LIMINT(IBLOCK,IPART,IER,XL(1),XL(2),XL(3),XU(1),XU(2),XU(3))
       IF(IER.GT.0) GOTO 1142
       XU(1) = XU(1) + BEHIN6
       XL(1) = XL(1) - BFRONT
       CALL WEGAS(SF6,.01,200,3,XL,XU,AVG,SD,C2)
       AVG = AVG/FNORM6
       SD = SD/FNORM6
C     IF (ICO.GT.1000) GOTO 2135
C     ICO=ICO+1
C     ESEE=E*AVG
C     WRITE(6,2134) IBLOCK,AVG,SD,C2,ESEE,XMOV6,YMOV6,ZMOV6
C2134 FORMAT(10X,'*--> WEGAS INTEGRAL RESULT SF6#: ',I8,F12.5,/,
C    *       10X,'*--> ERROR + CHI**2 VALUE+ESEEN : ',3F12.5,/,
C    *       10X,'*--> X,Y,ZMOV6: ',3F12.5)
C2135 CONTINUE
       BLCFRC(IBL) = AVG
       AVGSUM = AVGSUM+AVG
1142  CONTINUE
      GOTO 115
C
C     BORDER CROSSING; SF5*SF6 IN CLUSTER
C
1147  CONTINUE
      MEDSRT=5
      IF(ABS(ZMOV6).LT.ZSF6) MEDSRT=6
      DO 1143 IBL=1,NBLOCK
       IBLOCK = IBLIST(IBL)
       CALL LIMINT(IBLOCK,IPART,IER,XL(1),XL(2),XL(3),XU(1),XU(2),XU(3))
       IF(IER.GT.0) GOTO 1143
       IWHICH = 5
       JJ=MOD(IBLOCK,32)
       IF(JJ.GE.13.AND.JJ.LE.18.AND.IPART.EQ.0) IWHICH = 6
       MEDNOW=IWHICH
       IF(MEDSRT.EQ.6.AND.MEDNOW.EQ.5) GOTO 1159
       IF(MEDSRT.EQ.5.AND.MEDNOW.EQ.6) GOTO 1169
       IF(MEDSRT.EQ.5.AND.MEDNOW.EQ.5) GOTO 1149
C START IN SF6 AND NOW IN SF6
       XU(1) = XU(1) + BEHIN6
       XL(1) = XL(1) - BFRONT
        CALL WEGAS(SF6,.01,200,3,XL,XU,AVG,SD,C2)
       AVG = AVG/FNORM6
       SD = SD/FNORM6
C     IF (ICO.GT.1000) GOTO 1135
C     ICO=ICO+1
C     ESEE=E*AVG
C     WRITE(6,1134) IBLOCK,AVG,SD,C2,ESEE
C1134 FORMAT(10X,'---> WEGAS INTEGRAL RESULT SF6#: ',I8,F12.5,/,
C    *       10X,'---> ERROR + CHI**2 VALUE+ESEEN : ',3F12.5)
C1135 CONTINUE
       BLCFRC(IBL) = AVG
       AVGSUM = AVGSUM+AVG
       GOTO 1143
C START IN SF5 AND NOW IN SF5
1149   XU(1) = XU(1) + BEHIN5
       XL(1) = XL(1) - BFRONT
        CALL WEGAS(SF5,.01,200,3,XL,XU,AVG,SD,C2)
       AVG = AVG/FNORM5
       SD = SD/FNORM5
C     IF (ICO.GT.1000) GOTO 1335
C     ICO=ICO+1
C     ESEE=E*AVG
C     WRITE(6,1334) IBLOCK,AVG,SD,C2,ESEE
C1334 FORMAT(10X,'---> WEGAS INTEGRAL RESULT SF5#: ',I8,F12.5,/,
C    *       10X,'---> ERROR + CHI**2 VALUE+ESEEN : ',3F12.5)
C1335 CONTINUE
       BLCFRC(IBL) = AVG
       AVGSUM = AVGSUM+AVG
       GOTO 1143
C START IN SF6 AND NOW IN SF5
1159  XU(1) = XU(1) + BEHIN5
      XL(1) = XL(1) - BFRONT
      CALL WEGAS(SF65,.01,200,3,XL,XU,AVG,SD,C2)
      AVG = AVG/FNORM5
      SD = SD/FNORM5
C     IF (ICO.GT.1000) GOTO 1137
C     ICO=ICO+1
C     ESEE=E*AVG
C     WRITE(6,1136) IBLOCK,AVG,SD,C2,ESEE
C1136 FORMAT(10X,'---> WEGAS INTEGRAL RESULT SF65#: ',I8,F12.5,/,
C    *       10X,'---> ERROR + CHI**2 VALUE+ESEE  : ',3F12.5)
C1137 CONTINUE
      BLCFRC(IBL) = AVG
      AVGSUM = AVGSUM+AVG
      GOTO 1143
C START IN SF5 AND NOW IN SF6
1169  XU(1) = XU(1) + BEHIN6
      XL(1) = XL(1) - BFRONT
      CALL WEGAS(SF56,.01,200,3,XL,XU,AVG,SD,C2)
      AVG = AVG/FNORM6
      SD = SD/FNORM6
C     IF (ICO.GT.1000) GOTO 1137
C     ICO=ICO+1
C     ESEE=E*AVG
C     WRITE(6,1336) IBLOCK,AVG,SD,C2,ESEE
C1336 FORMAT(10X,'---> WEGAS INTEGRAL RESULT SF56#: ',I8,F12.5,/,
C    *       10X,'---> ERROR + CHI**2 VALUE+ESEE  : ',3F12.5)
C1137 CONTINUE
      BLCFRC(IBL) = AVG
      AVGSUM = AVGSUM+AVG
1143  CONTINUE
 115  CONTINUE
C
      AVGDIF = 1.-AVGSUM
C
      RETURN
      END
C
C
      REAL FUNCTION SF5(X)
C
C     FUNCTION TO BE INTEGRATED BY WEGAS
C                                       16/06/82
C                     CHANGED   N.M.    26/08/85
C        CHANGED TO MC VERSION  N.M.    11/10/85
C
      COMMON /TRAFO/ STR,CTR,SPR,CPR,CTRCPR,CTRSPR,STRCPR,STRSPR,
     *               JPART,XMOV5,YMOV5,ZMOV5,XMOV6,YMOV6,ZMOV6
      COMMON /PARAME/ P(6,2),MEDNOW
      REAL X(3)
      DATA X0 /23.90/
C
      SF5 = 0.
C
C     TRANSFORM INTO CARTESIAN DETECTOR SYSTEM
C
      IF(JPART.NE.0) GOTO 1
      XDET = X(1)*COS(X(2))
      YDET = X(1)*SIN(X(2))
      ZDET = X(3)
      FJACOB = X(1)
      GOTO 2
    1 XDET = X(1)
      YDET = X(2)
      ZDET = X(3)
      FJACOB = 1.
C
C     LINEAR TRANSFORMATION TO SHOWER START POINT
C
    2 XLTR = XDET-XMOV5
      YLTR = YDET-YMOV5
      ZLTR = ZDET-ZMOV5
C
C     ROTATE INTO SHOWER SYSTEM (FIRST CHECK SIGN OF ZSHW)
C
      ZSHW  =  XLTR * STRCPR   +   YLTR * STRSPR   +   ZLTR * CTR
C
      IF(ZSHW.LE.0.) RETURN
C
      XSHW  =  XLTR * CTRCPR   +   YLTR * CTRSPR   -   ZLTR * STR
      YSHW  = -XLTR * SPR      +   YLTR * CPR
C
C     SCALE IN RADIATION LENGTHS
C
      RSHS = SQRT(XSHW*XSHW+YSHW*YSHW)/X0
      ZSHS = ZSHW/X0
C
C     COMPRESS SHOWER FUNCTION
C
      P3Z = P(3,1)*ZSHS
      REX = -1.*P(1,1)*ALOG(ZSHS)
      EX1 = -1.*(REX+P3Z+P(4,1)*RSHS)
      EX2 = -1.*(REX+P3Z+P(6,1)*RSHS)
      IF(EX1.LT.-10..OR.EX2.LT.-10.) RETURN
C
      SF5 =  P(2,1)*EXP(EX1) + P(5,1)*EXP(EX2)
C
C     JACOBIAN
C
      SF5 = SF5*FJACOB
C
      RETURN
      END
C
C
      REAL FUNCTION SF6(X)
C
C     FUNCTION TO BE INTEGRATED BY WEGAS
C                                       16/06/82
C                     CHANGED   N.M.    26/08/85
C        CHANGED TO MC VERSION  N.M.    11/10/85
C
      COMMON /TRAFO/ STR,CTR,SPR,CPR,CTRCPR,CTRSPR,STRCPR,STRSPR,
     *               JPART,XMOV5,YMOV5,ZMOV5,XMOV6,YMOV6,ZMOV6
      COMMON /PARAME/ P(6,2),MEDNOW
      REAL X(3)
      DATA X0 /16.60/
C
      SF6 = 0.
C
C     TRANSFORM INTO CARTESIAN DETECTOR SYSTEM
C
      IF(JPART.NE.0) GOTO 1
      XDET = X(1)*COS(X(2))
      YDET = X(1)*SIN(X(2))
      ZDET = X(3)
      FJACOB = X(1)
      GOTO 2
    1 XDET = X(1)
      YDET = X(2)
      ZDET = X(3)
      FJACOB = 1.
C
C     LINEAR TRANSFORMATION TO SHOWER START POINT
C
    2 XLTR = XDET-XMOV6
      YLTR = YDET-YMOV6
      ZLTR = ZDET-ZMOV6
C
C     ROTATE INTO SHOWER SYSTEM (FIRST CHECK SIGN OF ZSHW)
C
      ZSHW  =  XLTR * STRCPR   +   YLTR * STRSPR   +   ZLTR * CTR
C
      IF(ZSHW.LE.0.) RETURN
C
      XSHW  =  XLTR * CTRCPR   +   YLTR * CTRSPR   -   ZLTR * STR
      YSHW  = -XLTR * SPR      +   YLTR * CPR
C
C     SCALE IN RADIATION LENGTHS
C
      RSHS = SQRT(XSHW*XSHW+YSHW*YSHW)/X0
      ZSHS = ZSHW/X0
C
C     COMPRESS SHOWER FUNCTION
C
      P3Z = P(3,2)*ZSHS
      REX = -1.*P(1,2)*ALOG(ZSHS)
      EX1 = -1.*(REX+P3Z+P(4,2)*RSHS)
      EX2 = -1.*(REX+P3Z+P(6,2)*RSHS)
      IF(EX1.LT.-10..OR.EX2.LT.-10.) RETURN
C
      SF6 =  P(2,2)*EXP(EX1) + P(5,2)*EXP(EX2)
C
C     JACOBIAN
C
      SF6 = SF6*FJACOB
C
      RETURN
      END
C
      REAL FUNCTION SF65(X)
C
C     FUNCTION TO BE INTEGRATED BY WEGAS
C     SF6/SF5 BORDER CROSSED FROM SF6 INTO SF5
C                                       16/06/82
C                     CHANGED   N.M.    26/08/85
C        CHANGED TO MC VERSION  N.M.    11/10/85
C
      COMMON /TRAFO/ STR,CTR,SPR,CPR,CTRCPR,CTRSPR,STRCPR,STRSPR,
     *               JPART,XMOV5,YMOV5,ZMOV5,XMOV6,YMOV6,ZMOV6
      COMMON /PARAME/ P(6,2),MEDNOW
      REAL X(3),X0(2)
      DATA X0 /23.90,16.60/,ZSF6/318./
      DATA IC /0/, ICAL65/0/
C
      SF65 = 0.
C
C     TRANSFORM INTO CARTESIAN DETECTOR SYSTEM
C
      IF(JPART.NE.0) GOTO 1
      XDET = X(1)*COS(X(2))
      YDET = X(1)*SIN(X(2))
      ZDET = X(3)
      FJACOB = X(1)
      GOTO 2
    1 XDET = X(1)
      YDET = X(2)
      ZDET = X(3)
      FJACOB = 1.
C
C     LINEAR TRANSFORMATION TO SHOWER START POINT
C     IMPLICTLY ABS(.DET) GT ABS(.MOV)
C
    2 XLTR = XDET-XMOV6
      YLTR = YDET-YMOV6
C     IF(ZMOV6.LT.0.)
C    *WRITE (6,9001) JPART,XDET,YDET,ZDET,XMOV6,YMOV6,ZMOV6
C
C     DETECTOR-COORDINATES OF PUNCHTHROUGH
C     INTEGRATION NOW IN SF5-BLOCK: POSITIVE Z-SIDE
C
      ZLTR = ZDET-ZMOV6
      IF(ZDET.LT.0.) GOTO 200
      DZ1 = ZSF6-ZMOV6
      DZ2 = ZDET-ZSF6
C     ZSHWP = DZ1/CTR
      GOTO 300
C     INTEGRATION NOW IN SF5-BLOCK: NEGATIVE Z-SIDE
 200  DZ1 = ZSF6+ZMOV6
      DZ2 = -ZSF6-ZDET
 300  CONTINUE
      ZSHWP = ABS(DZ1/CTR)
C     IF(ZMOV6.LT.0.)
C    *WRITE (6,9002) XLTR,YLTR,ZLTR,ZSHWP,DZ1,DZ2
C     IF(ZMOV6.LT.0.)
C    *WRITE (6,9004) STR,CTR,SPR,CPR
C
C     ROTATE INTO SHOWER SYSTEM (FIRST CHECK SIGN OF ZSHW)
C
      ZSHW  = XLTR * STRCPR   +  YLTR * STRSPR   +  ZLTR * CTR
C     IF(ZMOV6.LT.0.)
C    *WRITE(6,9005) ZSHW
C
      IF(ZSHW.LE.0.) RETURN
C
      XSHW  =  XLTR * CTRCPR   +   YLTR * CTRSPR   -   ZLTR * STR
      YSHW  = -XLTR * SPR      +   YLTR * CPR
C
C     SCALE IN RADIATION LENGTHS
C
      IF(ZSHWP.LT.0.) ICAL65 = ICAL65 + 1
      IF(ZSHWP.LT.0..AND.ICAL65.LT.100)
     *WRITE (6,9002) XLTR,YLTR,ZLTR,ZSHWP,DZ1,DZ2
      IF(ZSHWP.LT.0..AND.ICAL65.LT.100)
     *WRITE (6,9004) STR,CTR,SPR,CPR
      ZSHWP = ABS(ZSHWP)/X0(2)
      ZSHS = ZSHW/X0(2)
      DELZ = ZSHW - ZSHWP
      IF(DELZ.LE.0.) GOTO 20
      ZSHS = ZSHWP/X0(2) + DELZ/X0(1)
C  DEVIDE RSHW ACCORDING TO DZ1,DZ2
 20   RSHW = SQRT(XSHW*XSHW+YSHW*YSHW)
      RSHW1 = 0.
      IF(ZSHW.GT.ZSHWP) GOTO 25
      RSHW0 = DZ1/STR
      RSHW1 = -ZSHW*CTR/STR
      IF(CTR.LT.0.) RSHW1 = ZSHW*CTR/STR
      RSHW1 = RSHW1 + RSHW0
25    RSHW2 = RSHW - RSHW1
      RSHS = RSHW1/X0(2)+RSHW2/X0(1)
C
C     IF(DELZ.GT.0.) RSHS = RSHS*X0(2)/X0(1)
C     IF(ZMOV6.LT.0.)
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.)
     *WRITE (6,9004) STR,CTR,SPR,CPR
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.)
     *WRITE (6,9002) XLTR,YLTR,ZLTR,ZSHWP,DZ1,DZ2
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.)
     *WRITE(6,9006) XSHW,YSHW,RSHS,ZSHS,RSHW1,RSHW2,RSHW
      IF(MEDNOW.EQ.5) GOTO 999
      IF(IC.GE.100) GOTO 999
C      IF(MEDNOW.NE.5) WRITE (6,6000) MEDNOW
      IC=IC+1
  999 CONTINUE
C
C     COMPRESS SHOWER FUNCTION
C
      P3Z = P(3,1)*ZSHS
      REX = -1.*P(1,1)*ALOG(ZSHS)
      EX1 = -1.*(REX+P3Z+P(4,1)*RSHS)
      EX2 = -1.*(REX+P3Z+P(6,1)*RSHS)
C     IF(ZMOV6.LT.0.)
C    *WRITE(6,9007) EX1,EX2,P3Z,REX,P(3,1),P(1,1)
      IF(EX1.LT.-10..OR.EX2.LT.-10.) RETURN
C
      SF65 =  P(2,1)*EXP(EX1) + P(5,1)*EXP(EX2)
C     IF(ZMOV6.LT.0.)
C    *WRITE(6,9008) SF65

C
C     JACOBIAN
C
 4    SF65 = SF65*FJACOB
 6000 FORMAT(' ***SF65**** MEDNOW UNUSUAL=',I8)
 9001 FORMAT(' JPART,XDET,YDET,ZDET,XMOV6,YMOV6,ZMOV6  ',I6,6F10.4)
 9002 FORMAT(' XLTR,YLTR,ZLTR,ZSHWP,DZ1,DZ2           ',6F12.4)
 9004 FORMAT(' STR,CTR,SPR,CPR      ',4F10.5)
 9005 FORMAT(' ZSHW   ',1F12.5)
 9006 FORMAT(' XSHW,YSHW,RSHS,ZSHS,RSW1,RSHW2,RSHW '/7F10.5)
 9007 FORMAT(' EX1,EX2,P3Z,REX,P(3,2),P(1,2) ',6F12.7)
 9008 FORMAT(' S F 6 5 ',1E12.6)
C
      RETURN
      END
C
      REAL FUNCTION SF56(X)
C
C     FUNCTION TO BE INTEGRATED BY WEGAS
C     SF6/SF5 BORDER CROSSED FROM SF5 INTO SF6
C                                       16/06/82
C                     CHANGED   N.M.    26/08/85
C        CHANGED TO MC VERSION  N.M.    11/10/85
C        CHANGED AGAIN 2.2.87          N.M. / J.O.
C
      COMMON /TRAFO/ STR,CTR,SPR,CPR,CTRCPR,CTRSPR,STRCPR,STRSPR,
     *               JPART,XMOV5,YMOV5,ZMOV5,XMOV6,YMOV6,ZMOV6
      COMMON /PARAME/ P(6,2),MEDNOW
      REAL X(3),X0(2)
      DATA X0 /23.90,16.60/,ZSF6/318./
      DATA IC /0/, ICAL56/0/
C
      SF56 = 0.
C
C     TRANSFORM INTO CARTESIAN DETECTOR SYSTEM
C
      IF(JPART.NE.0) GOTO 1
      XDET = X(1)*COS(X(2))
      YDET = X(1)*SIN(X(2))
      ZDET = X(3)
      FJACOB = X(1)
      GOTO 2
    1 XDET = X(1)
      YDET = X(2)
      ZDET = X(3)
      FJACOB = 1.
C
C     LINEAR TRANSFORMATION TO SHOWER START POINT
C     IMPLICTLY ABS(.DET) GT ABS(.MOV)
C
    2 XLTR = XDET-XMOV5
      YLTR = YDET-YMOV5
C     WRITE (6,9001) JPART,XDET,YDET,ZDET,XMOV5,YMOV5,ZMOV5
C
C     DETECTOR-COORDINATES OF PUNCHTHROUGH
C     INTEGRATION NOW IN SF5-BLOCK: POSITIVE Z-SIDE
C
      ZLTR = ZDET-ZMOV5
      IF(ZDET.LT.0.) GOTO 200
      DZ1 = ZMOV5-ZSF6
      DZ2 = ZSF6 - ZDET
      GOTO 300
 200  DZ1 = -ZSF6-ZMOV5
      DZ2 = ZDET + ZSF6
 300  CONTINUE
C     WRITE (6,9002) XLTR,YLTR,ZLTR
C     WRITE (6,9004) STR,CTR,SPR,CPR
C
C     ROTATE INTO SHOWER SYSTEM (FIRST CHECK SIGN OF ZSHW)
C
      ZSHW  = XLTR * STRCPR   +  YLTR * STRSPR   +  ZLTR * CTR
C     WRITE(6,9005) ZSHW
C
      IF(ZSHW.LE.0.) RETURN
C
      XSHW  =  XLTR * CTRCPR   +   YLTR * CTRSPR   -   ZLTR * STR
      YSHW  = -XLTR * SPR      +   YLTR * CPR
C
C     SCALE IN RADIATION LENGTHS
C
      ZSHS = ZSHW/X0(1)
C  DEVIDE RSHW ACCORDING TO DZ1,DZ2
      RSHW = SQRT(XSHW*XSHW+YSHW*YSHW)
      RSHW1 = RSHW*ABS(DZ1)/(ABS(DZ1)+ABS(DZ2))
      RSHW2 = RSHW - RSHW1
      RSHS = RSHW1/X0(1)+RSHW2/X0(2)
C
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.) ICAL56 = ICAL56 + 1
      IF(ICAL56.GT.100) GO TO 1304
C
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.)
     *WRITE (6,9001) JPART,XDET,YDET,ZDET,XMOV5,YMOV5,ZMOV5
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.)
     *WRITE (6,9004) STR,CTR,SPR,CPR
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.)
     *WRITE (6,9002) XLTR,YLTR,ZLTR,ZSHWP,DZ1,DZ2
      IF(RSHW1.LT.0..OR.RSHW2.LT.0.)
     *WRITE(6,9006) XSHW,YSHW,RSHS,ZSHS,RSHW1,RSHW2,RSHW
C
1304  CONTINUE
      IF(MEDNOW.EQ.6) GOTO 999
      IF(IC.GE.100) GOTO 999
       IF(MEDNOW.NE.6) WRITE (6,6000) MEDNOW
      IC=IC+1
  999 CONTINUE
C
C     COMPRESS SHOWER FUNCTION
C
      P3Z = P(3,2)*ZSHS
      REX = -1.*P(1,2)*ALOG(ZSHS)
      EX1 = -1.*(REX+P3Z+P(4,2)*RSHS)
      EX2 = -1.*(REX+P3Z+P(6,2)*RSHS)
C     WRITE(6,9007) EX1,EX2,P3Z,REX,P(3,2),P(1,2)
      IF(EX1.LT.-10..OR.EX2.LT.-10.) RETURN
C
      SF56 =  P(2,2)*EXP(EX1) + P(5,2)*EXP(EX2)
C     WRITE(6,9008) SF56

C
C     JACOBIAN
C
 4    SF56 = SF56*FJACOB
 9001 FORMAT(' JPART,XDET,YDET,ZDET,XMOV6,YMOV6,ZMOV6  ',I6,6F10.4)
 9002 FORMAT(' XLTR,YLTR,ZLTR            ',3F12.4)
 9004 FORMAT(' STR,CTR,SPR,CPR      ',4F10.5)
 9005 FORMAT(' ZSHW   ',1F12.5)
 9006 FORMAT(' XSHW,YSHW,RSHS,ZSHS,RSHW1,RSHW2,RSHW '/7F10.5)
 9007 FORMAT(' EX1,EX2,P3Z,REX,P(3,2),P(1,2) ',6F12.7)
 9008 FORMAT(' S F 5 6 ',1E12.6)
 6000 FORMAT(' ***SF56**** MEDNOW UNUSUAL=',I8)
C
      RETURN
      END

C   03/02/79 C9020501   MEMBER NAME  ZREAD    (S)           FORTRAN
      SUBROUTINE ZREAD(IUN,NTOT,BIN,NDIM,*,*)
      INTEGER BIN(1),IER/-1/
      COMMON/CFLAG/IFLAG
      IF(IER.LT.0) WRITE(6,201) IUN
      IER=0
      IFLAG=0
      CALL IBCOMR(IUN,&21,&11)
      CALL IBWORD(NTOT,&22,&12)
      IF(NTOT.LE.0) GOTO 31
      IF(NTOT.GT.NDIM) GOTO 32
      CALL IBARR(BIN,NTOT,&23,&13)
      CALL IBCOMF
      GOTO 100
C     READ ERRORS
   13 IER=IER+1
   12 IER=IER+1
   11 IER=IER+1
      IFLAG=IER
      WRITE(6,202) IER
      GOTO 101
C     END EXITS
   23 IER=IER+1
   22 IER=IER+1
   21 IER=IER+1
      IFLAG=IER+10
      WRITE(6,203) IER
      GOTO 102
C     ERROR IN FIRST WORD
   32 IER=IER+1
   31 IER=IER+1
      IFLAG=IER+100
      CALL IBCOMF
      WRITE(6,204) IER
      GOTO 101
C
  100 RETURN
  101 RETURN 1
  102 RETURN 2
C
  201 FORMAT('0ZREAD FIRST ENTRY',I3)
  202 FORMAT('0ZREAD IO-ERROR',I3)
  203 FORMAT('0ZREAD END',I3)
  204 FORMAT('0ZREAD L-ERROR',I3)
      END
      SUBROUTINE PRFLAG
      COMMON/CFLAG/IFLAG
      WRITE(6,101) IFLAG
      CALL ABEND
      RETURN
  101 FORMAT('0** PRFLAG **  IFLAG=',I10)
      END

C   07/06/96 606071911  MEMBER NAME  SORTXY   (S4)          FORTG1
      SUBROUTINE SORTXY(X,Y,N)
      REAL X(N),Y(N),W
      M=N
   10 M=M/2
      IF(M.EQ.0) RETURN
      K=N-M
      DO 40 J=1,K
      I=J
      GOTO 30
   20 I=I-M
      IF(I.LT.1) GOTO 40
   30 L=I+M
      IF(X(L).LT.X(I)) GOTO 50
   40 CONTINUE
      GOTO 10
C     EXCHANGE I AND L
C     ----------------
   50 W=X(I)
      X(I)=X(L)
      X(L)=W
      W=Y(I)
      Y(I)=Y(L)
      Y(L)=W
C     ----------------
      GOTO 20
      END

C   09/03/79 008180717  MEMBER NAME  @LGTEST                FORTRAN
C
C    S.YAMADA   09-03-79  10:25
C     LAST MODIFICATION   09-03-79  23:25
C
C---- SIMPLE TEST PROGRAM FOR LGANAL FOR REAL DATA.
C
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(24000)
      DIMENSION  ADATA(24000),HDATA(48000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
C
#include "clgwork1.for"
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX,DZ
C
      COMMON /CLGMSB/ MSGVAL(5)
      COMMON /CTPCNS/ EBMGEV, BKGAUS
      DATA HRAN/0/
C
C---- INITIALIZATION
      DATA NUNITO,RPATR,RHEAD,RALGN,RLGCL/2,4HPATR,4HHEAD,4HALGN,4HLGCL/
      DATA RTRIG/4HTRIG/
      CALL BINT(24000,4000,500,0)
      CALL BINT1(200,100,10,0)
C     CALL BWRO( NUNITO, 1558, 2)
C        SET UP POINTERS BEFOREHAND
          IPHEAD = IBLN(RHEAD)
          IPTRIG = IBLN(RTRIG)
          IPPATR = IBLN(RPATR)
          IPALGN= IBLN(RALGN)
          IPLGCL= IBLN(RLGCL)
C
      CALL LGINIT
C     ITH = 45
C
C
        DO 1000 N=1,50
C       NTIM=JUHR(2)
C       IF(NTIM.EQ.2) GO TO 300
C
        DATA NUNITI/1/
        CALL BREAD(NUNITI,&200,&200)
C----   TEMPORARY SUBROUTINE TO MODIFY THE M.C. 'PATR' FORMAT.
C
C        CALL HPRS(RHEAD,0)
          NPHEAD = IDATA(IPHEAD)
          IF(NPHEAD.LE.0) GO TO 20
          NHHEAD = NPHEAD+NPHEAD
          HEXP=HDATA(NHHEAD+ 9)
          HRUN=HDATA(NHHEAD+10)
          CALL KALIB2
          HRAN=HRUN
        NPTRIG=IDATA(IPTRIG)
        IF(NPTRIG.LT.1) GO TO 20
        HBIT  =HDATA(NPTRIG+NPTRIG+10)
      WRITE(6,6000) N,HEXP,HRUN,HDATA(NHHEAD+11),HBIT
 6000 FORMAT(1H0,20(1H*),'REC#,EXP,RUN,EV#,TRG',4I6,Z8,50(1H*),/)
C
C
C----     TEST DUMP
         CALL PRALGN(0,0,10)
C        CALL PRALGN(1,0,10)
         CALL LGCALB(&20)
         CALL PRALGN(1,0,10)
C     IF(II.EQ.II) GO TO 20
C     PRALGN(I,J,K); I;0='ALGL'/0, 1='ALGN'/1
C                    J;0=NODECODING, 1=CRATE-SLOT, 2=IPHI-Z
C                    K=NO. DATA TO BE PRINTED PER LINE
          NPPATR = IDATA(IPPATR)
C       CALL PRLGCL
        CALL LGANAL
C
C----   DUMP THE RESULTS
CCCC    CALL LGSHOW
C       CALL LGADCD(2,5)
C       CALL PRALGN(1,0,10)
C       CALL PRALGN(1,2,10)
C
C----   CLUSTER DUMP
C       CALL PRLGCL
C
C----   SECOND STEP ANALYSIS
C       POINTERS OF THE NECESSARY BANKS
        NPALGN =IDATA(IPALGN)
        NPLGCL=IDATA(IPLGCL)
        IF(NPLGCL) 90,90,10
C
C----   SOME BANK IS MISSING
   90   MSGVAL(1) =  NPPATR
        MSGVAL(2) =  NPALGN
        MSGVAL(3) =  NPLGCL
        CALL LGMESG( 1, 2 )
        GO TO 20
C
   10   CALL LGCDIR( NPPATR, NPALGN, NPLGCL )
C
C       CALL BPRS(RPATR,NNN)
C       PRINT INNER DET.CHARGE TRACK TRACING RESULT
        CALL PRCLGC
C----   PRINT CHARGE AND LG-CLUSTER MATCHING TABLE
C       CALL PRITOL(3)
CCC     CALL PRCLGC
C       CALL PRLGCL
C       CALL LGESHW
        CALL PRLGCL
C----               PRINT 'PATR'
C                   NNN = IDATA(NPPR-2)
C                   CALL BPRS(RPATR,NNN)
C
20      CONTINUE
C       CALL BSLW
C       CALL BFIXP
C       CALL BWRITE(NUNITO)
        CALL BSLT
        CALL BDLG
C
 1000   CONTINUE
C//////////////
CCCC  CALL TMLOG(0)
C//////////////
      GO TO 100
  200 MSGVAL(1) = N
      CALL LGMESG( 1,1 )
      GO TO 100
300   WRITE(6,6200) N,(HDATA(HNPHD+J),J=9,11)
6200  FORMAT(' TIME OUT AT REC#,EXP#,RUN#,EV#',10I6)
100   CONTINUE
C     CALL BMLT(0,DUMMY)
C     CALL BFIXP
C     CALL BWRITE(NUNITO)
      CALL BSLT
      CALL BDLG
      STOP
      END

C   09/10/79 910180035  MEMBER NAME  ANOM61   (S)           FORTRAN
      SUBROUTINE ANOM61(IRUN)
C---  ANOMALIES OF RUNS 1497 - 1559
C---  15.25 GEV      SEPTEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     18.10.79     00:25
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1497,1498,1499,13,1501,1502,1503,1504,1505,1506,1507,1508,
     &      1509,13,1511,1512,1513,13,1515,1516,1517,1518,1519,1520,
     &      1521,1522,1523,1524,1525,13,1527,1528,1529,1530,1531,1532,
     &      1533,1534,1535,13,1537,1538,13,1540,1541,13,1543,13,1545,
     &      13,1547,13,13,13,13,13,13,13,13,13,13,1558,1559),IRUN
   13 RETURN
C
 1497 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1498 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1499 LCHANN(79) = .TRUE.
C
      RETURN
C
 1501 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 75
      KCONST(150) = -1
      LIMIT(150) = 60
      KCONST(154) = -1
      LIMIT(154) = 75
      KCONST(155) = -1
      LIMIT(155) = 60
      KCONST(171) = -1
      LIMIT(171) = 45
C
      RETURN
C
 1502 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1503 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1504 LCHANN(79) = .TRUE.
C
      RETURN
C
 1505 LCHANN(79) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 105
      KCONST(150) = -1
      LIMIT(150) = 60
      KCONST(155) = -1
      LIMIT(155) = 60
      KCONST(171) = -1
      LIMIT(171) = 30
C
      RETURN
C
 1506 LCHANN(79) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 45
C
      RETURN
C
 1507 LCHANN(79) = .TRUE.
C
      KCONST(154) = -1
      LIMIT(154) = 105
C
      RETURN
C
 1508 LCHANN(79) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 60
C
      RETURN
C
 1509 LCHANN(79) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 120
      KCONST(150) = -1
      LIMIT(150) = 150
      KCONST(155) = -1
      LIMIT(155) = 135
      KCONST(171) = -1
      LIMIT(171) = 120
C
      RETURN
C
 1511 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 75
C
      RETURN
C
 1512 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 90
C
      RETURN
C
 1513 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 45
      KCONST(169) = -1
      LIMIT(169) = 45
C
      RETURN
C
 1515 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 45
      KCONST(101) = -1
      LIMIT(101) = 75
      KCONST(150) = -1
      LIMIT(150) = 15
      KCONST(155) = -1
      LIMIT(155) = 15
C
      RETURN
C
 1516 LCHANN(79) = .TRUE.
C
      RETURN
C
 1517 LCHANN(79) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 150
      KCONST(101) = -1
      LIMIT(101) = 75
      KCONST(148) = -1
      LIMIT(148) = 45
      KCONST(150) = -1
      LIMIT(150) = 135
      KCONST(155) = -1
      LIMIT(155) = 135
      KCONST(171) = -1
      LIMIT(171) = 120
C
      RETURN
C
 1518 CONTINUE
C
      RETURN
C
 1519 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
 1520 CONTINUE
C
      RETURN
C
 1521 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1522 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
 1523 LCHANN(79) = .TRUE.
C
      RETURN
C
 1524 LCHANN(79) = .TRUE.
C
      RETURN
C
 1525 LCHANN(79) = .TRUE.
C
      RETURN
C
 1527 LCHANN(79) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 60
C
      RETURN
C
 1528 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
 1529 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1530 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 45
C
      RETURN
C
 1531 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1532 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
 1533 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 45
C
      RETURN
C
 1534 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
 1535 LCHANN(79) = .TRUE.
C
      RETURN
C
 1537 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 60
C
      RETURN
C
 1538 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
 1540 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1541 LCHANN(79) = .TRUE.
C
      RETURN
C
 1543 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 30
C
      RETURN
C
 1545 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 45
C
      RETURN
C
 1547 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 60
      KCONST(101) = -1
      LIMIT(101) = 75
C
      RETURN
C
 1558 LCHANN(79) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 60
      KCONST(166) = -1
      LIMIT(166) = 60
C
      RETURN
C
 1559 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 30
      KCONST(101) = -1
      LIMIT(101) = 60
C
      RETURN
C
      END

C   24/08/85 903051543  MEMBER NAME  MCTAGRPL (S)           FORTRAN
C
      SUBROUTINE MCTAGR
C
C    PRINT VERSION
C
C ONCE PER EVENT SIMULATE FLUCTATING PEDESTALS
C + ANYTHING ELSE THAT MAY OCCUR ONCE PER EVENT
C    E.G. RANDOM NOISE
C
C SKIP THIS FOR 79/80 - PEDESTAL TREATMENT DIFFERENT IN
C ANALYSIS - I.E. CANT DO IT ON EVENT BY EVENT BASIS
C
C SEVERAL LOGICAL ERRORS CORRECTED, 18.11.1987    J.O.
C
C
      IMPLICIT INTEGER*2 (H)
#include "cmctag.for"
C
      DATA AVRGE/5.0/
C
      IF(MARKMC.EQ.1)GOTO 1000
C
C  INTODUCE RANDOM NOISE
C      ON AVERAGE 5 BLOCKS HAVE RANDOM NOISE, WITH A SIGMA OF 2 BLOCKS
C
      CALL NVERT(2.0,AVRGE,ANUM)
      NUM = NINT(ANUM)
      ANCHAN = NCHANS-1
C     WRITE(6,601)NUM,NCHANS,ANCHAN
 601  FORMAT(' NUM,NCHANS,ANCHAN ',I5,I5,F8.2)
      IF(NUM.EQ.0)GOTO 351
C
C PICK THE NOSIY BLOCKS AT RANDOM AMONG ALL
C    THE NOISE IS +- 10 CHANNEL COUNTS
C
       DO 35 I = 1,NUM
        IBLOCK = NINT(RN(DUMMY)*ANCHAN) + 1
        CALL NVERT(10.0,0.0,RANCH)
C35     HGG(IBLOCK)=HGG(IBLOCK)+RANCH     CORRECTED 18.11.87
      WRITE(6,2345) I,NUM,IBLOCK,HGG(IBLOCK),RANCH
2345  FORMAT(' MCTAGR: I NUM IB HGG RANCH ',4I6,E12.4)
 35     HGG(IBLOCK)=HGG(IBLOCK)+RANCH*CALIBS
351   CONTINUE
C
C NOW IMITATE FLUCTUATING PEDESTALS
C CHOOSE THE MEAN SIZE OF THE NOISE *CALIB-SO ITS RIGHT WHEN MCTAGS
C    DIVIDES BY CALIB
C
       AVPED=10.0*CALIBS
       CALL NVERT(AVPED,0.0,RMEAN)
C
C          GENERATE RANDOM PEDESTAL:  MEAN OF AVPED +/- 3 CHANNELS
C
       AFLUC = 3. * CALIBS
C
       DO 36 I = 1,NCHANS
C             CALL NVERT(3.0,RMEAN,APED)  CORRECTED 18.11.87
              CALL NVERT(AFLUC,RMEAN,APED)
      WRITE(6,2346) I,NCHANS,HGG(I),APED
2346  FORMAT(' MCTAGR: I NCHANS HGG APED ',3I6,E12.4)
36            HGG(I)=HGG(I)+NINT(APED)
C
1000    RETURN
        END

C   07/06/96 606071817  MEMBER NAME  BGAC     (S4)          FORTG1
      SUBROUTINE BGAC(IGA,NWD)
C     BOS SUBPROGRAM =1.21=
      IGA=0
      CALL BSPC(NA,NB,NC,ND)
      IF(NB.GT.NWD+4) GOTO 100
      CALL BGAR(IGA)
  100 RETURN
      END

C   25/07/79 C9082701   MEMBER NAME  ANOM13   (S)           FORTRAN
      SUBROUTINE ANOM13(IRUN)
C---  ANOMALIES OF RUNS 914 - 960
C---  15.8 GEV      JULY 1979
C
C     H.WRIEDT    24.07.79     23:55
C     LAST MODIFICATION     27.08.79     12:20
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (914,915,916,13,918,919,13,13,13,13,13,13,926,13,13,13,
     &      930,931,13,13,934,13,936,937,13,13,13,13,13,13,944,13,946,
     &      13,13,13,950,951,13,13,13,13,956,957,958,13,960),IRUN
   13 RETURN
C
  914 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  915 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(147) = -1
      LIMIT(147) = 270
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*916 CONTINUE
  916 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(147) = -1
      LIMIT(147) = 270
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*918 CONTINUE
  918 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(147) = -1
      LIMIT(147) = 270
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  919 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(23) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C*926 CONTINUE
  926 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  930 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*931 PRELIMINARY ***
  931 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*934 PRELIMINARY ***
  934 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*936 PRELIMINARY ***
  936 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*937 PRELIMINARY ***
  937 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*944 PRELIMINARY ***
  944 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  946 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*950 PRELIMINARY
  950 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*951 PRELIMINARY
  951 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*956 PRELIMINARY
  956 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*957 PRELIMINARY
  957 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*958 PRELIMINARY
  958 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C*960 PRELIMINARY
  960 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
      END

C   21/11/78 C9071601   MEMBER NAME  ZBOS07   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------700000200
C     7.  INPUT FROM CARDS
C
C     DATA CAN BE READ FROM CARDS IN FREE FORMAT OR IN A FORMAT GIVEN
C     ON THE CARDS ITSELF, AND STORED IN BANKS. THE LAST 8 COLS OF THE
C     CARDS ARE NOT USED IN FREE FORMAT MODE.
C
C     CALL BREADC
C
C     DATA ARE READ FROM CARDS (UNIT 5) UNTIL DATA END OR A CARD WITH
C     ENDQ IS READ.
C
C
C
C     7.1 FREE FORMAT
C
C     READING A CARD OF THE TYPE
C     NAME A B C . . .
C     CREATES A BANK (NAME,0) WITH DATA A, B ,C . . .
C     A SECOND CARD WITH THE SAME NAME CREATES A BANK (NAME,1) ETC.
C     IF THE FIRST CHARACTER OF NAME IS THE DOLLARSIGN $, THAN
C     THE INPUT IS ACCORDING TO THE MODE DESCRIBED BELOW.
C
C     NAME N / A B C . . .
C     CREATES A BANK (NAME,N) WITH DATA A, B, C . . .
C     A SECOND CARD WITH THE SAME (NAME,N) IS NOT STORED.
C
C     THE BANK NAME  CONSISTS OF THE FIRST FOUR CHARACTERS OF
C     NAME.
C     N, A, B, C, . . . ARE CONSTANTS.
C     INTEGER CONSTANTS ARE TO BE WRITTEN WITHOUT A DOT (.),
C     REAL CONSTANTS WITH DOT (.) AND OPTIONALLY WITH EXPONENT.
C     CONTINUATION CARDS STARTING IMMEDIATELY WITH CONSTANTS ARE
C     ALLOWED. NON-NUMERIC CHARACTERS BETWEEN CONSTANTS ARE
C     IGNORED.
C
C     7.2  FORMATED
C
C     AFTER READING A CARD
C
C     NAME N NW '(FORMAT)
C
C     NW WORDS ARE READ ACCORDING TO THE GIVEN FORMAT FROM CONSECUTIVE
C     CARDS AND STORED IN A BANK (NAME,N). THE FORMAT
C     SHOULD START WITH 1X (SEE EXAMPLE), TO ALLOW ECHO-PRINTOUT
C     WITHOUT LINE SKIPPING.
C
C
C     7.3  SPECIAL CARDS
C
C                                 ACTION
C
C     ENDQ                        BREADC RETURNS
C
C     POFF                        PRINTING OF CARDS IS SWITCHED OFF
C
C     PON                         PRINTING OF CARDS IS SWITCHED ON AGAIN
C
C     UNIT N     (N = INTEGER)    THE NEXT CARDS ARE READ FROM
C                                 UNIT N UNTIL DATA END, THEN AGAIN
C                                 FROM UNIT 5.
C
C
C
C     7.4  EXAMPLE
C
C
C     CONSTANTS 1.7 2.3 7 1.23E-4
C     RUN 2769 / 1.520 16.0
C     0.7 2.0
C     TITL 2000 5 '(1X,5A4)
C      PI+ PI+ PI- PI- PI0
C     ENDQ
C
C
C
C
C     BANKS STORED
C
C     NAME             CONS   RUN    TITL
C     NUMBER              0   2769   2000
C     NR.OF WORDS         4      4      5
C
C     1.DATA WORD       1.7  1.520   PI+
C     2.DATA WORD       2.3   16.0   PI+
C     3.DATA WORD         7    0.7   PI-
C     4.DATA WORD   1.23E-4    2.0   PI-
C     5.DATA WORD                    PI0
C
C     INDICES ARE OBTAINED BY
C     CALL BLOC(IND,'CONS',0,&S1)
C     CALL BLOC(IND,'RUN ',2769,&S1)
C     CALL BLOC(IND,'TITL',2000,&S1)   RESP.
C
      RETURN
      END

C   08/09/79 002222002  MEMBER NAME  KORDER   (JADESR)      FORTRAN
      SUBROUTINE KORDER
      IMPLICIT INTEGER*2 (H)
C---
C---     PUTS CALIBRATION UPDATE RECORDS INTO INCREASING TIME ORDER.
C---                                   L.H. O'NEILL 08.09.79
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6)
      DIMENSION LIST(2,10000)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
C---
      IWFLAG=1
      ITIME(1)=0
      ITIME(2)=0
      ITIME(3)=0
      ITIME(4)=1
      ITIME(5)=1
      ITIME(6)=1979
      LASTIM=0
      NDUMMY=KTMCON(ITIME,KTWRIT,LASTIM)
      REWIND 3
      REWIND 4
      READ(3) IDMMY,KSTIME
      WRITE(4) IDMMY,KSTIME
      WRITE(6,500) KSTIME
  500 FORMAT(' *** START TIME = ',I10,/)
      NREC=0
    1 CONTINUE
      CALL EVREA1(3,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
      IF(NREC.GT.10000) WRITE(6,201)
  201 FORMAT(' **** ERROR. MORE THEN 10000 RECORDS. PROGRAMMED STOP.')
      IF(NREC.GT.10000) STOP
      JBUF(5)=KTWRIT
      LIST(1,NREC)=NREC
      LIST(2,NREC)=JBUF(6)
      CALL KALBNK(4,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
C---
C---     FIND TIME ORDER OF RECORDS.
C---
C        WRITE(6,1991) ((LIST(KLM,LHO),KLM=1,2),LHO=1,NREC)
 1991    FORMAT(1X,2I10)
      DO 2 I=1,NREC
      LOWEST=2000000001
      DO 3 J=I,NREC
      IF(LIST(2,J).GE.LOWEST) GO TO 3
      K=J
      LOWEST=LIST(2,J)
    3 CONTINUE
      IADDR=LIST(1,I)
      IVALU=LIST(2,I)
      LIST(1,I)=LIST(1,K)
      LIST(2,I)=LOWEST
      LIST(1,K)=IADDR
      LIST(2,K)=IVALU
C        WRITE(6,1998)
 1998    FORMAT(' ')
C        WRITE(6,1991) ((LIST(KLM,LHO),KLM=1,2),LHO=1,NREC)
    2 CONTINUE
C---
C---     NOW OVERWRITE FILE ON UNIT 3 WITH TIME ORDERED RECORDS.
C---
      REWIND 3
      REWIND 4
      READ(4) IDMMY,KSTIME
      IF(IWFLAG.EQ.1) WRITE(3) IDMMY,KSTIME
C---
      NCURNT=0
      LASTIW=0
      DO 10 I=1,NREC
C         WRITE(6,1995) I,NCURNT,LIST(1,I),LIST(2,I)
 1995     FORMAT(' I,NCURNT,LIST(1,I),LIST(2,I)= ',4I10)
      NWISH=LIST(1,I)
      IF(NWISH.GT.NCURNT) GO TO 4
      REWIND 4
      READ(4) IDMMY,KSTIME
      DO 5 J=1,NWISH
      CALL EVREA1(4,NWORD,JBUF,IRET)
      IF(IRET.EQ.0) GO TO 5
      WRITE(6,202) IRET
  202 FORMAT(' *** ILLEGAL IRET = ',I2,' IN 5 LOOP. STOP.')
      STOP
    5 CONTINUE
      GO TO 6
    4 CONTINUE
      LOOP=NWISH-NCURNT
      DO 7 J=1,LOOP
      CALL EVREA1(4,NWORD,JBUF,IRET)
      IF(IRET.EQ.0) GO TO 7
      WRITE(6,203) IRET
  203 FORMAT(' *** ILLEGAL IRET = ',I2,' IN 7 LOOP. STOP.')
      STOP
    7 CONTINUE
    6 CONTINUE
      NCURNT=NWISH
      IF(JBUF(6).EQ.LIST(2,I)) GO TO 8
      WRITE(6,204) I,JBUF(6),LIST(1,I),LIST(2,I)
  204 FORMAT(' JBUF(6) AND LIST(2,I) DISAGREE. DUMP = ',4I10)
      WRITE(6,303)
  303 FORMAT(' *** PROGRAMMED STOP *** ')
      STOP
    8 CONTINUE
      IF(JBUF(6).GE.LASTIW) GO TO 9
      WRITE(6,205) I,JBUF(6),LASTIW,LIST(1,I),LIST(2,I)
  205 FORMAT(' DECREASING TIME. DUMP = ',5I10)
      WRITE(6,304)
  304 FORMAT(' *** PROGRAMMED STOP *** ')
      STOP
    9 CONTINUE
      LISTIW=JBUF(6)
      IF(IWFLAG.EQ.1) CALL KALBNK(3,NWORD,JBUF)
   10 CONTINUE
      RETURN
      END

C   29/01/79 C9073001   MEMBER NAME  LGCCTL   (SOURCE)      FORTRAN
      SUBROUTINE LGCCTL(IERT)
C
C     S.YAMADA      28-09-78  22:35
C     LAST MODIFICATION   29-01-79  10:35
C
C     CONTROL SUBROUTINE FOR LGCLUS
C     THIS IS CREATED TO FIND CLUSTERS IN THE THREE PARTS SEPARATELY.
C
      IMPLICIT INTEGER *2 (H)
C
C     USED IN LGANAL PART OF PROGRAMS
C        NO CUTS ON MAX FIRIED #CHANNELS (I.E. DIMENSION=2880)
C        CHANGE SIZE OF THE CLUSTER BANK TO 16.. 13/6/80
C        CHANGED BY Y.WATANABE ON 23/09/79. 00:30
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,
     3               MAPCL(81),  CLPRP(1280)
      INTEGER *2 HMAPCL(2,81)
      DIMENSION ICLSPR(16,80),CLSPRP(16,80), CLMPRP(1361)
      EQUIVALENCE (HMAPCL(1,1),MAPCL(1)), (CLMPRP(1),MAPCL(1))
      EQUIVALENCE (ICLSPR(1,1),CLPRP(1)),  (CLSPRP(1,1),CLPRP(1))
C
C
C---- NCLST = NO.OF THE LOCATED CLUSTERS.
C---- MAPCL(J)=THE INDEX OF THE FIRST MEMBER OF THE J-TH CLUSTER
C               IN THE HLGADC.
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/279012910/
      NVRSN(6) = NVCODE
C
      IF(LNG.LE.2) GO TO 101
C
C---- CLUSTER FINDING IS REPEATED FOR EACH PART
   10   DO 20 JP=1,3
        NHIT = (HPOINT(JP+1)-HPOINT(JP))/2
        INIT = (HPOINT(JP)+1)/2
        CALL LGCLUS(JP,INIT,NHIT,IER)
        IERT = IERT+IER
   20   CONTINUE
C---- SET NO. OF CLUSTERS IN EACH PART.
      NCLBEC(3) = NCLBEC(3)-NCLBEC(2)
      NCLBEC(2) = NCLBEC(2)-NCLBEC(1)
  100 RETURN
C
  101 MAPCL(1) = 1
      RETURN
      END

C   08/02/87            MEMBER NAME  TPTOFD   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTOFD
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery        6/02/87:  Delete unwanted TOFR bank
C
C
C
C     Routine to delete unwanted TOFR bank.
C
C------------------  D E F I N I T I O N S  ----------------------------
C
      IMPLICIT  INTEGER*2 (H)
C
      LOGICAL  DELET1
C
C------------------  C O D E  ------------------------------------------

C                            Get instruction relating to bank deletion
C                            DELET1 : delete TOFR bank

      CALL TPTFI3( DELET1 )

      IF( DELET1 ) THEN

        CALL BMLT( 1,'TOFR' )
        CALL BDLM

        CALL TPDIAG()

      ENDIF

      RETURN
      END

C   07/06/96 606071917  MEMBER NAME  USTOS    (S4)          FORTG1
      SUBROUTINE USTOS(N,A,B,C,D)
      COMMON/BCS/IW(1000)
      REAL RW(1000)
      EQUIVALENCE (IW(1),RW(1))
C
C     STORE VECTORS IN BANK COMMON
C     (NAME,NUMBER)   =   ('STO*',N)
C        +1     NO OF VECTORS
C        +2     LENGTH OF VECTOR
C        +3     INTERNAL
C        +4 . . VECTORS
C
      INTEGER NHUN/100/
      REAL V(1)
      CALL BLOC(IND,'STO*',N,&20)
   10 I=IW(IND+3)
      M=IW(IND+2)
      IF(I.GE.IW(IND)) GOTO 100
      INDI=IND+I
      GOTO (1,2,3,4),M
    4 RW(INDI+4)=D
    3 RW(INDI+3)=C
    2 RW(INDI+2)=B
    1 RW(INDI+1)=A
      IW(IND+3)=IW(IND+3)+M
      IW(IND+1)=IW(IND+1)+1
      GOTO 100
   20 CALL NOARG(M)
      M=M-1
      IF(M.GT .4) M=4
      CALL BCRE(IND,'STO*',N,M*NHUN+3,&100,IER)
      IW(IND+1)=0
      IW(IND+2)=M
      IW(IND+3)=3
      GOTO 10
C
      ENTRY USTOR(N,V,NDIM)
      CALL BLOC(IND,'STO*',N,&50)
   30 I=IW(IND+3)
      IF(I.GE.IW(IND)) GOTO 100
      INDI=IND+I
      M=IW(IND+2)
      DO 40 J=1,M
   40 RW(INDI+J)=V(J)
      IW(IND+1)=IW(IND+1)+1
      IW(IND+3)=IW(IND+3)+M
      GOTO 100
   50 M=NDIM
      CALL BCRE(IND,'STO*',N,M*NHUN+3,&100,IER)
      IW(IND+1)=0
      IW(IND+2)=M
      IW(IND+3)=3
      GOTO 30
  100 RETURN
C
      ENTRY DSTOR(IARG)
      NHUN=IARG
      RETURN
       END

C   28/07/87 801191014  MEMBER NAME  TPZSFT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPZSFT
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      28/07/87:  Do central det. Z-S refit
C
C
C     Routine to do Z-S refit of inner detector tracks  using Z chamber
C     information where available  (optional)
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  REFITZ

C                            MODE is refitting mode (See JCN 95)
C                            IOPT is refitting options code

      INTEGER  MODE, IOPT

C------------------  C O D E  ------------------------------------------

C                            Get instruction about refitting

      CALL TPRFI2( REFITZ, MODE, IOPT )

C                            If Z-S refit wanted, do it.

      IF( REFITZ ) THEN

        CALL ZSRFTV( MODE, IOPT )

        CALL TPDIAG()

      ENDIF

      RETURN

      END

C   11/12/78 008201337  MEMBER NAME  COORD                  FORTRAN
      SUBROUTINE COORD(X,DX)
C---  COMPUTE X- AND Y-COORDINATES WHEN Z, STARTING POINT,
C     AND DIRECTIONS ARE GIVEN (ALL DISTANCES IN MM)
C
C     H.WRIEDT    11.12.78      19:15
C     LAST MODIFICATION    29.05.80      19:45
C
      DIMENSION X(3), DX(3)
      COMMON /CPARTC/ PRTCIN,PRTCL,EMEV,AMASS2,ISIGNZ,EBEAM,THETA,PHIDEG
      DIMENSION PRTCIN(9), PRTCL(3,3)
      DATA PIHALF /1.57079632/, PI/3.14159264/
      DATA RADIAN/1.745329E-2/
C
        DO 10 J = 1,3
 10     DX(J) = PRTCL(J,3)
C
      PHI = PHIDEG*RADIAN
      PHI0 = 0.
      IF (PHI.GE.PIHALF) PHI0 = PI
      IF (PHI.LT.-PIHALF) PHI0 = -PI
      PHI1 = -PIHALF
      IF (DX(1).NE.0.) PHI1 = ATAN(DX(2)/DX(1))
      PHI1 = PHI1+PHI0
C
      X(3) = ISIGNZ*X(3)
      THESIN = X(3)*SIN(ARCOS(DX(3)))
      X(1) = PRTCL(1,2)+THESIN*COS(PHI1)
      X(2) = PRTCL(2,2)+THESIN*SIN(PHI1)
      RETURN
      END

C   10/03/79 208201333  MEMBER NAME  LGHIST   (SOURCE)      FORTRAN
      SUBROUTINE LGHIST(NPCL)
C
C     S.YAMADA   10-03-79  22:40
C
C---- TEST HISTOGRAMS FOR LG-ANALYSIS
C
C
#include "cdata.for"
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      DATA IST/0/
C
      IF( IST.NE.0 ) GO TO 1000
      CALL HBOOK1(1,'CLUST ENERGY(DY<0)$',100,0.,20.,0)
      CALL HBOOK1(2,'CLUST ENERGY(DY>0)$',100,0.,20.,0)
      CALL HBOOK1(3,'CLUST ENERGY(DY<0,CH)$',100,0.,20.,0)
      CALL HBOOK1(4,'CLUST ENERGY(DY>0,CH)$',100,0.,20.,0)
      IST = 1
C
C---- SET UP THE POINTER FOR THE LG-CLUSTER PROPERTIES.
 1000 NPCGI = NPCL+IDATA(NPCL+1)-1
C
C---- GET NO.OF CLUSTERS
      NCLST = IDATA(NPCGI+3)
C
      IF(NCLST) 100,100,1
C
C---- GET NO.OF WORDS FOR EACH CLUSTER.
    1 LSTEP = IDATA(NPCGI+21)
C---- SHOWER ENERGY CORRECTION IS CHECKED.
CCC   IF(IDATA(NPCGI+18).EQ.0) GO TO 100
C
      NPCLS = NPCL+IDATA(NPCL+3)-1
C
      NN = NCLST
      IF(NCLST.GT.MAXCLS) NN = MAXCLS
        DO 10 N=1,NN
C       XX = ADATA(NPCLS+9)
        YY = ADATA(NPCLS+10)
        IF(YY) 11,11,12
   11   NPLOT = 1
        GO TO 20
   12   NPLOT = 2
C
   20   CALL HFILL( NPLOT, ADATA(NPCLS+2), DUM,1.)
        IF( IDATA(NPCLS+8).EQ.0 ) GO TO 21
        NPLOT = NPLOT+2
        CALL HFILL( NPLOT, ADATA(NPCLS+2), DUM, 1.0)
C
   21   NPCLS = NPCLS+LSTEP
   10   CONTINUE
C
  100 RETURN
      END

      SUBROUTINE JFTNEW(IPTR,IPJHTL,WRK,LHIT,IPRES,INDEX,XO,YO,
     +CALCST,DSTORW)
      IMPLICIT INTEGER*2 (H)
      DIMENSION WRK(200)
      EQUIVALENCE (ZWZ,IZW)
#include "cdata.for"
#include "cjdrch.for"
      COMMON/CCMZCT/ DIMPCT, ZCUTV, ZCUTVV, IZVCST(5), ZCHWW
      DIMENSION IZCHMB(3,2),AZCHMB(3,2)
      COMMON/JSCALD/ JESCAL,JESKEY,JESDRW
      COMMON/XYFVT1/MODXYV,NOVL
      COMMON /CFLMAS/ AFLMAS
      DIMENSION CALCST(96,27),DSTORW(5,64,24)
      REAL GG(4,8) / 1.16872E-1,-2.58070E-1, 1.32006E-1, 286.,
     +              -1.04290E-1, 8.84550E-2,-1.96380E-2, 286.,
     +               3.24418E-2,-7.46600E-2, 2.36765E-2, 496.,
     +              -5.75000E-2, 4.36000E-2,-1.10000E-2, 496.,
     +               3.12761E-2,-1.12856E-1, 6.26170E-2, 707.,
     +               5.44166E-1,-8.74361E-1, 3.05246E-1, 707.,
     +               3.54954E-1,-6.67922E-1, 2.74681E-1, 707.,
     +              -2.26062E-1, 3.02971E-1,-1.15400E-1, 707./
      REAL GGF(4,8)/         0.,         0.,         0., 286.,
     +                       0.,         0.,         0., 286.,
     +                       0.,         0.,         0., 496.,
     +                       0.,         0.,         0., 496.,
     +                       0.,         0.,         0., 707.,
     +               7.52764E-1,-1.10923E00, 3.47826E-1, 707.,
     +               2.52785E-1,-4.63690E-1, 1.75837E-1, 707.,
     +                       0.,         0.,         0., 707./
      REAL THL(4)/-52.,-52.,-4.,960./,
     +     THU(4)/-4.,-4.,960.,1570./,
     +     A2(4)/-52.,-1.97924E-5,-20.5739,0./,
     +     A3(4)/-9.224,700.,6.E-5,2.E-10/,
     +     A4(4)/1.497,1320.,-8.31E-6,-2.73E-10/
      REAL B1(4,4)/
     + 0.62000E+03,   0.87300E+03,  -0.41000E+03,   0.15800E+04,
     + 0.62000E+03,   0.87300E+03,  -0.41000E+03,   0.15800E+04,
     + 0.57030E+03,   0.89000E+03,  -0.38000E+03,   0.15800E+04,
     + 0.64300E+03,   0.90200E+03,  -0.41200E+03,   0.15800E+04/
      DIMENSION Q(5,4)
      DATA Q/14.5142,3.2743E-2,-6.E-6,0.,0.,
     +       4.46445E1,-8.87962E-2,1.29605E-4,9.02461E-9,-5.85976E-11,
     +       4.52471E1,-8.94577E-2,1.39668E-4,1.05065E-8,-7.46739E-11,
     +       18.256,3.46596E-2,-1.26438E-5,0.,0./
      DIMENSION P(5,4)
      DATA P/-.955408,1.62185E-3,-8.22074E-7,0.,0.,
     +       -.1736,1.41338E-3,-1.14314E-5,1.96957E-8,-7.93752E-12,
     +       -.173,2.2942E-4,-2.4298E-6,0.,0.,
     +       -1.0475,1.92375E-3,-1.2E-6,0.,0./
      REAL OMERIN(3)/2*.130900,.0654498/,ALORIN(3)/3*.34/,
     +     RR1(3)/211.,421.,632./,WIRDIS/10./,SMAXW(2,64),SM01(2,64),
     +     ANG375/.0654498/,
     +     FLTIM1/.028/,FLTIM2/.0363/,FLTIM3/1222.9/,ELFRCZ/.231/,
     +     AVFRMX/.78742/,EPS/1.E-4/,TANLOR/.365028/,SINLOR/.342898/,
     +     COSLOR/.939373/,PIVALU/3.141593/,
     +     PARVD(3)/.59562E-2,.59482E-2,.59421E-2/
      DATA JESOLD/-1/,LIMPRT/0/,KIMPRT/0/,LIMPR1/3/,KIMPR1/0/
***PMF      DIMENSION IRESAR(13),RESAR(13),HRESAR(13)
      DIMENSION IRESAR(14),RESAR(14),HRESAR(14)
      EQUIVALENCE (IRESAR(1),RESAR(1),HRESAR(1))
      INTEGER MKLRT1 /Z1000000/, MKLRT2 /Z100/
      INDX=INDEX
      IF(INDX.EQ.4) INDX=1
      IF(
     - JESCAL.NE.JESOLD
     -)THEN
         JESOLD=JESCAL
      IF(
     - KIMPR1.LT.LIMPR1
     -)THEN
            KIMPR1=KIMPR1+1
            PRINT 720, JESCAL
720      FORMAT(' **** NEW ID CALIBRATION IN EFFECT IN JFETCH AFTER ',
     +   'RUN', I7,/,6X,'BIT 256 IS SET IN THE PROGRAM IDENTIFIER ',
     +   'WORD OF THE PATR BANK',////)
      ENDIF
      ENDIF
      DATA LBINIT /0/,IQJETC/0/,IQHEAD/0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
         LBINIT = 1
         IQJETC = IBLN('JETC')
         IQHEAD = IBLN('HEAD')
         A5=1./.6726
      DO 13000 J=1,8
            GG(1,J)=GG(1,J)*A5
            GG(2,J)=GG(2,J)*A5*.5/GG(4,J)
            GG(3,J)=GG(3,J)*A5*.333333/GG(4,J)**2
      IF(
     - J.EQ.6.OR.J.EQ.7
     -)THEN
               GGF(1,J)=GGF(1,J)*A5
               GGF(2,J)=GGF(2,J)*A5*.5/GGF(4,J)
               GGF(3,J)=GGF(3,J)*A5*.333333/GGF(4,J)**2
      ENDIF
13000 CONTINUE
13001 CONTINUE
      DO 13002 I=1,64
      IF(
     - I.LE.16
     -)THEN
               IRIN=1
               IW=I
      ELSE
      IF(
     - I.LE.32
     -)THEN
                  IRIN=2
                  IW=I-16
      ELSE
                  IRIN=3
                  IW=I-32
                  IF(IW.GT.16) IW=IW-16
      ENDIF
      ENDIF
            R=RR1(IRIN)+(IW-1)*WIRDIS
            SMAXW(1,I)=1.05*R*SIN(OMERIN(IRIN))/COS(ALORIN(IRIN)
     +      -OMERIN(IRIN))
            SMAXW(2,I)=1.05*R*SIN(OMERIN(IRIN))/COS(ALORIN(IRIN)
     +      +OMERIN(IRIN))
            SM01(1,I)=.7*SMAXW(1,I)
            SM01(2,I)=.7*SMAXW(2,I)
      IF(
     - IW.LT.3.OR.IW.GT.14
     -)THEN
               SM01(1,I)=.45*SMAXW(1,I)
               SM01(2,I)=.45*SMAXW(2,I)
      ENDIF
13002 CONTINUE
13003 CONTINUE
        PRINT 7777
 7777   FORMAT(' JFTNEW : VERSION FROM 13/01/88 CALLED!',/,
     &         ' +++++++++++++++++++++++++++++++++++++++++++++++++++++')
      ENDIF
      LHBIT  = LHIT*4
      IPCO = 1
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      IF(
     - NRUN.LT.24200
     -)THEN
         FREQR=1.0127
         FLTIM2=.0363
      ELSE
         FREQR=1.
         FLTIM2=0.
      ENDIF
      NEVT = HDATA(IPHEAD+11)
      ITRK = IDATA(IPTR+1)
      IDATA(IPTR+2) = LOR(IDATA(IPTR+2),256)
      IPJETC = IDATA(IQJETC)
      IP0    = 2*IPJETC + 100
         IPRAW=IPJETC
15000 CONTINUE
      IF(
     - IDATA(IPRAW -1).GT.0
     -)THEN
            IPRAW =IDATA(IPRAW -1)
      GOTO 15000
      ENDIF
15001 CONTINUE
         IPRAW2=2*IPRAW -2*IPJETC
      ZVERT = ADATA(IPTR+31)
      TGTH = ADATA(IPTR+30)
      CSTH = 1./SQRT(TGTH**2 + 1.)
      SNTH  = CSTH * TGTH
         XHCS = (ADATA(IPTR+12) + ADATA(IPTR+5)) * .5
         YHCS = (ADATA(IPTR+13) + ADATA(IPTR+6)) * .5
         XX    =  ADATA(IPTR+12) - ADATA(IPTR+5)
         YY    =  ADATA(IPTR+13) - ADATA(IPTR+6)
         RR    = SQRT(XX**2+YY**2)
      IF(
     - RR.LT.10.
     -)THEN
            IPRES=IPCO
            RETURN
      ENDIF
         CSROT = XX / RR
         SNROT = YY / RR
         ALCS=.5*RR
         SINFIC=SNROT
         COSFIC=CSROT
         IF(COSFIC.GT.1.) COSFIC=1.
         IF(COSFIC.LT.-1.) COSFIC=-1.
         FIC=ACOS(COSFIC)
         IF(SINFIC.LT.0.) FIC=2.*PIVALU-FIC
         BCS1X=-XHCS*COSFIC-YHCS*SINFIC
         BCS1Y= XHCS*SINFIC-YHCS*COSFIC
         CURVXY=ADATA(IPTR+25)
         IF(ABS(CURVXY).LT.1.E-8) CURVXY = SIGN(1.E-8,CURVXY)
         IF(ABS(CURVXY*ALCS).GT..966) CURVXY=SIGN(.966/ALCS,CURVXY)
         CTGTH=TGTH
         IF(ABS(CTGTH).GT.2.) CTGTH=SIGN(2.,CTGTH)
         CPR0=CURVXY/SQRT(1.-(CURVXY*ALCS)**2)
         VCRS=1./CPR0
         CURN1=CURVXY*PARVD(2)
      IZZZSE=INDX
      GOTO 14002
14003 CONTINUE
        XT = 0.
        YT = 0.
        CSROT = 1.
        SNROT = 0.
        XOT   = 0.
      GOTO 14001
14004 CONTINUE
        XT    = XHCS
        YT    = YHCS
        XOT   = 0.
      GOTO 14001
14005 CONTINUE
        XT    = (ADATA(IPTR+12) + XO) * .5
        YT    = (ADATA(IPTR+13) + YO) * .5
        XX    =  ADATA(IPTR+12) - XO
        YY    =  ADATA(IPTR+13) - YO
        RR    = SQRT(XX**2+YY**2)
        CSROT = XX / RR
        SNROT = YY / RR
        XOT   = -.5*RR
      GOTO 14001
14002 CONTINUE
      GOTO(
     -14003,14004,14005
     -), IZZZSE
14000 CONTINUE
        RETURN
14001 CONTINUE
      NOVL = 0
      IPC0 = IPTR + 34
      IPC9 = IPC0 +  5
      DO 13004 IPC = IPC0,IPC9
         JCELL = IDATA(IPC)
      IF(
     - JCELL.GT. 0 .AND. JCELL.LE.96
     -)THEN
            JRING = 1
            IF(JCELL.GT.24) JRING = 2
            IF(JCELL.GT.48) JRING = 3
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - INDEX.EQ.4 .AND. ZCHWW.GT..1 .AND. ZCHWW.LT.2000.
     -)THEN
         CALL ZCFTNW(NRUN,NEVT,ITRK,TGTH,ZVERT,NZHIT,IZCHMB,AZCHMB)
      IF(
     - NZHIT.GT.0
     -)THEN
      DO 13006 J=1,NZHIT
               HRESAR( 1) = 100+IZCHMB(1,J)
               HRESAR( 2) = IZCHMB(2,J)
               HRESAR( 3) = 0
               HRESAR( 4) = 0
               HRESAR( 5) = 1
               HRESAR( 6) = 101
               XX=AZCHMB(1,J)
               YY=AZCHMB(2,J)
               ZZ=AZCHMB(3,J)
               RESAR ( 4) = XX
               RESAR ( 5) = YY
               RESAR ( 6) = ZZ
               UX=XX-ADATA(IPTR+5)
               UY=YY-ADATA(IPTR+6)
               UU=SQRT(UX**2+UY**2)
            IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*SIN(.5*CURVXY*UU)/CURVXY
               IF(UX*ADATA(IPTR+8)+UY*ADATA(IPTR+9).LT.0.) UU=-UU
               RESAR ( 7) = UU
               RESAR ( 8) = ZCHWW
               IF(NRUN.LT.24200) RESAR(8)=RESAR(8)*.6
               CALL MVC(WRK(IPCO),0,RESAR(1),0,LHBIT)
               IPCO = IPCO + LHIT
13006 CONTINUE
13007 CONTINUE
      ENDIF
      ENDIF
      IPRES = IPCO
      IF(
     - INDEX.LT.4
     -)THEN
         WRK (IPRES   ) = XT
         WRK (IPRES+ 1) = YT
         WRK (IPRES+ 2) = CSROT
         WRK (IPRES+ 3) = SNROT
         WRK (IPRES+ 9) = XOT
         WRK (IPRES+10) = 0.
         WRK (IPRES+11) = CSTH
         WRK (IPRES+12) = SNTH
      ENDIF
      RETURN
17000 CONTINUE
         KRING=JRING
         IF(JRING.EQ.3 .AND. JCELL-(JCELL/2)*2.NE.1) KRING=4
      IF(
     - JCELL.LE.24
     -)THEN
            ISEG=JCELL
      ELSE
      IF(
     - JCELL.LE.48
     -)THEN
               ISEG=JCELL-24
      ELSE
               ISEG=(JCELL-47)/2
      ENDIF
      ENDIF
         FISEGM=((ISEG-1)*4+2)*ANG375
         ACEL1=CALCST(JCELL,18)
         ZETCEL=2.*SIN(.5*ACEL1*CURVXY)/CURVXY*TGTH+ZVERT
         IF(ABS(ZETCEL).GT.1000.) ZETCEL=SIGN(1000.,ZETCEL)
         ACEL1=   ACEL1        +ZETCEL*CALCST(JCELL,19)
         BCEL1=CALCST(JCELL,20)+ZETCEL*CALCST(JCELL,21)
         OCEL1=CALCST(JCELL,22)+ZETCEL*CALCST(JCELL,23)
         FIIC=FISEGM+OCEL1-FIC
         ACEL2=CALCST(JCELL,19)*CTGTH*WIRDIS
         BCEL2=CALCST(JCELL,21)*CTGTH*WIRDIS
         OCEL2=CALCST(JCELL,23)*CTGTH*WIRDIS
         ROT1X=COS(FIIC)
         ROT1Y=SIN(FIIC)
         ROT2X=SIN(FIC-FISEGM)
         ROT2Y=COS(FIC-FISEGM)
         BCS1XC=BCS1X+ACEL1*ROT2Y+BCEL1*ROT2X
         BCS1YC=BCS1Y-ACEL1*ROT2X+BCEL1*ROT2Y
        JHIT = 0
        NHIT   = 0
        NHGOOD = 0
        ILAYL =-99
        IPCO = IPCO - LHIT
        IPCLL  = 2*IPJETC + 2 + JCELL
        IP     = HDATA(IPCLL  ) + IP0
        IP9    = HDATA(IPCLL+1) + IP0
        IPHL   = IPJHTL + 2 + HDATA(IPCLL)/4
15002 CONTINUE
      IF(
     - IP.LT.IP9
     -)THEN
          LB   = IDATA(IPHL)
          ITR1 = LAND(ISHFTR(LB,17),127)
          ITR2 = LAND(ISHFTR(LB, 1),127)
      IF(
     - ITR1.EQ.ITRK .OR. ITR2.EQ.ITRK
     -)THEN
            L0GOOD = 0
      IF(
     - ITR1.NE.0 .AND. ITR2.NE.0
     -)THEN
               NOVL   = NOVL + 1
               L0GOOD = 11
               ID1    = LAND(ISHFTR(LB,27), 31)
               ID2    = LAND(ISHFTR(LB,11), 31)
      IF(
     - ITR1 .EQ. ITRK
     -)THEN
                  IF( ID1 .LT. ID2 ) L0GOOD = 2
                  IF( ID1 .GT. ID2 ) L0GOOD = 12
      ELSE
                  IF( ID2 .LT. ID1 ) L0GOOD = 2
                  IF( ID2 .GT. ID1 ) L0GOOD = 12
      ENDIF
      ENDIF
            LBLR = 0
            IF(ITR1.EQ.ITRK) LBLR = LAND(LB,MKLRT1)
            IF(ITR2.EQ.ITRK) LBLR = LAND(LB,MKLRT2)
            LBSIDE =-1
            IF(LBLR.NE.0) LBSIDE = 1
            LBLR = LBSIDE
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            ILAY = LAND(IWIR,15)
            IAMPL = HDATA(IP+1)
            IAMPR = HDATA(IP+2)
            CALL AMPS2Z( IP,IPJETC,ZZ,WW,LZGOOD)
            IW=ILAY+1
            IODD=1
            IF(IW-(IW/2)*2.EQ.0) IODD=-1
            RHIT=ACEL1+(IW-8.5)*WIRDIS
            FLPATH=2.*SIN(.5*RHIT*CURVXY)/CURVXY
            ZHIT=FLPATH*TGTH+ZVERT
            IF(ABS(ZHIT).GT.1200.) ZHIT=SIGN(1200.,ZHIT)
            FLPATH=SQRT(FLPATH**2+ZHIT**2)
            TDRIFT=HDATA(IP+3+IPRAW2)
      IF(
     - NRUN.LT.24200
     -)THEN
               TDRIFT=TDRIFT*64.+32.
               IF(NRUN.GE.19050.AND.NRUN.LE.20274) TDRIFT=TDRIFT+20.
               IF(NRUN.GE. 3300.AND.NRUN.LE. 3550) TDRIFT=TDRIFT-90.
      ELSE
      IF(
     - NRUN.LE.24698
     -)THEN
                  TDRIFT=TDRIFT-5.
                  IF(NRUN.LT.24405) TDRIFT=TDRIFT+153.
                  IF(NRUN.GE.24227.AND.NRUN.LE.24232) TDRIFT=TDRIFT+147.
                  IF(NRUN.GE.24233.AND.NRUN.LE.24245) TDRIFT=TDRIFT+297.
      ENDIF
      ENDIF
            AMRAWL=HDATA(IP+1+IPRAW2)*8.
            AMRAWR=HDATA(IP+2+IPRAW2)*8.
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
            IF(JRING.EQ.3) TDRIFT=TDRIFT*FREQR
            BKGS=ABS(HDATA(IPHEAD+30)*.001)
            IF(BKGS.LT.3.) BKGS=4.8
            AMOMGV=.02998E-3*BKGS*SQRT(1.+CTGTH**2)/CURVXY
            CPERV=SQRT(1.+(AFLMAS/AMOMGV)**2)
            TDRIFT=TDRIFT-FLTIM1*FLPATH*CPERV-FLTIM2*(FLTIM3-ABS(ZHIT))
            TDRIFT=TDRIFT-CALCST(JCELL,IW)
            TSTG=CALCST(JCELL,17)*(1.-ELFRCZ*(ZHIT/1200.)**2)
     +      *AVFRMX*SINLOR*PARVD(JRING)/WIRDIS
            XK=IW-IODD*TSTG-8.5
            ROT3X=XK*WIRDIS*(ROT1X-ROT1Y*XK*OCEL2)
            ROT3Y=XK*WIRDIS*(ROT1Y+ROT1X*XK*OCEL2)
            XWPR=ROT3X+BCS1XC+XK*( ACEL2*ROT2Y+BCEL2*ROT2X)
            YWPR=ROT3Y+BCS1YC+XK*(-ACEL2*ROT2X+BCEL2*ROT2Y)
            NLRSOL = 1
            IF(TDRIFT.LT.300.) NLRSOL = 2
            ILRSOL = 0
16000 CONTINUE
            ILRSOL = ILRSOL + 1
            LBGOOD = L0GOOD
      IF(
     - NLRSOL.EQ.1 .AND. LBSIDE.LT.0  .OR.
     ?           NLRSOL.EQ.2 .AND. ILRSOL.EQ.1
     -)THEN
                LBSIDE =-1
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ELSE
                LBSIDE = 1
      ASSIGN 17006 TO IZZZ03
      GOTO 17004
17006 CONTINUE
      ENDIF
              IF(LBSIDE.NE.LBLR) LBGOOD = LBGOOD + 1
      IF(
     - ILAY.NE.ILAYL .OR. LBGDL.LE.1.AND.LBGOOD.LE.2
     -)THEN
                LBREG = 1
                JHIT = JHIT + 1
                IPCO = IPCO + LHIT
      ELSE
                LBREG = 0
                ZWZ = WRK(IPCO+10)
                IF(LBGOOD.LT.IZW) LBREG = 1
      ENDIF
      IF(
     - LBREG.NE.0
     -)THEN
                NHIT   = NHIT   + 1
                IF(LBGOOD.LE.2) NHGOOD = NHGOOD + 1
      IF(
     - INDEX.NE.4
     -)THEN
                   IRESAR( 1) = ILAY
                   IRESAR( 2) = IP
                   IRESAR( 3) = LBSIDE
                   RESAR ( 4) = XX
                   RESAR ( 5) = YY
                   RESAR ( 6) = ZZ
                   RESAR ( 7) = XX - XOT
                   IF(INDX.EQ.1) RESAR ( 7) = SQRT(XX**2 + YY**2)
                   IRESAR( 8) = LZGOOD
                   RESAR ( 9) = DSC
                   IRESAR(10) = JCELL
                   IRESAR(11) = LBGOOD
                   RESAR (12) = TANBET
                   IRESAR(13) = JRING
                   RESAR (14) = 0.
      ELSE
                   HRESAR( 1) = JCELL
                   HRESAR( 2) = ILAY
                   HRESAR( 3) = LZGOOD
                   HRESAR( 4) = LBGOOD
                   HRESAR( 5) = 1
                   HRESAR( 6) = IP-2*IPJETC
                   RESAR ( 4) = XX
                   RESAR ( 5) = YY
                   RESAR ( 6) = ZZ
                   UX=XX-ADATA(IPTR+5)
                   UY=YY-ADATA(IPTR+6)
                   UU=SQRT(UX**2+UY**2)
            IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*SIN(.5*CURVXY*UU)/CURVXY
                   IF(UX*ADATA(IPTR+8)+UY*ADATA(IPTR+9).LT.0.) UU=-UU
                   RESAR ( 7) = UU
                   RESAR ( 8) = WW
      ENDIF
                CALL MVC(WRK(IPCO),0,RESAR(1),0,LHBIT)
                ILAYL = ILAY
                LBGDL = LBGOOD
      ENDIF
      IF(.NOT.(
     - ILRSOL.GE.NLRSOL
     -))GOTO 16000
16001 CONTINUE
      ENDIF
        IPHL = IPHL + 1
        IP   = IP   + 4
      GOTO 15002
      ENDIF
15003 CONTINUE
        IPCO = IPCO + LHIT
      GOTO IZZZ01
17004 CONTINUE
      IF(
     - LBSIDE.LT.0
     -)THEN
            AG2= CALCST(JCELL,26)
            VDP=-CALCST(JCELL,24)
      ELSE
            AG2= CALCST(JCELL,27)
            VDP= CALCST(JCELL,25)
      ENDIF
         AG2=AG2-FIIC-XK*OCEL2
         SINAG2=SIN(AG2)
         COSAG2=COS(AG2)
         F=XWPR*SINAG2+(YWPR+VCRS)*COSAG2
         G=(ALCS-XWPR)*(ALCS+XWPR)-YWPR*(YWPR+2.*VCRS)
      IF(
     - G.GT.-.98*F**2
     -)THEN
      ASSIGN 17008 TO IZZZ04
      GOTO 17007
17008 CONTINUE
            DISTWC=SQTVAL
            XPR=XWPR+DISTWC*SINAG2
            DYPDXP=1.-(CURVXY*XPR)**2
      IF(
     - DYPDXP.LT..02
     -)THEN
      IF(
     - KIMPRT.LT.LIMPRT
     -)THEN
                  KIMPRT=KIMPRT+1
                  PRINT 675,CURVXY,ALCS,XPR,NRUN,NEVT,ITRK
675      FORMAT(' *** ERROR IN JFTNEW *** CURVATURE, HALF TRACK LENGTH',
     +   ' X IN TR C.S.',/,8X,3E15.5,'   TRACK',I9,I6,I4)
                  PRINT 676, CPR0,VCRS,XHCS,YHCS,FIC,TGTH,
     +            XWPR,YWPR,AG2,F,G,DISTWC,DYPDXP,
     +            KRING,JCELL,ISEG,FISEGM,IW,IODD,ILRSOL,LBSIDE
676               FORMAT(/,' CPR0,VCRS,XHCS,YHCS,FIC,TGTH,',/,
     +            ' XWPR,YWPR,AG2,F,G,DISTWC,DYPDXP,'/,
     +            ' KRING,JCELL,ISEG,FISEGM,IW,IODD,ILRSOL,LBSIDE',/,
     +            1X,6E15.5,/,1X,7E15.5,/,1X,3I4,E15.5,4I6,////)
      ENDIF
               DYPDXP=.02
      ENDIF
            DYPDXP=-XPR*CURVXY/SQRT(DYPDXP)
            C=1.-DYPDXP*SINAG2/COSAG2
            IF(ABS(C).LT..001) C=SIGN(.001,C)
            TANBET=(DYPDXP+SINAG2/COSAG2)/C
            AMU=WIRDIS/PARVD(JRING)*COSLOR
            DELTA=AMU*(TANBET-TANLOR)
            IF(ABS(DELTA).GT.1800.) DELTA=SIGN(1800.,DELTA)
      ELSE
      IF(
     - KIMPRT.LT.LIMPRT
     -)THEN
               KIMPRT=KIMPRT+1
               PRINT 674,CURVXY,ALCS,NRUN,NEVT,ITRK
674      FORMAT(' *** ERROR IN JFTNEW *** CURVATURE, HALF TRACK LENGTH',
     +   /,8X,2E15.5,'   TRACK',I9,I6,I4)
               PRINT 677, CPR0,VCRS,XHCS,YHCS,FIC,TGTH,
     +         XWPR,YWPR,AG2,F,G,
     +         KRING,JCELL,ISEG,FISEGM,IW,IODD,ILRSOL,LBSIDE
677            FORMAT(/,' CPR0,VCRS,XHCS,YHCS,FIC,TGTH,',/,
     +         ' XWPR,YWPR,AG2,F,G,'/,
     +         ' KRING,JCELL,ISEG,FISEGM,IW,IODD,ILRSOL,LBSIDE',/,
     +         1X,6E15.5,/,1X,5E15.5,/,1X,3I4,E15.5,4I6,////)
      ENDIF
            TANBET=TANLOR
            DELTA=0.
      ENDIF
      ASSIGN 17010 TO IZZZ05
      GOTO 17009
17010 CONTINUE
      ASSIGN 17012 TO IZZZ06
      GOTO 17011
17012 CONTINUE
      ASSIGN 17014 TO IZZZ07
      GOTO 17013
17014 CONTINUE
         Y1=VDP*TCORR
      IF(
     - JESDRW.GT.0
     -)THEN
      ASSIGN 17016 TO IZZZ08
      GOTO 17015
17016 CONTINUE
      ENDIF
         DSC=ABS(Y1)
         XX=XWPR+Y1*SINAG2
         YY=YWPR+Y1*COSAG2
      IF(
     - INDX.NE.2
     -)THEN
            A= XX*COSFIC-YY*SINFIC+XHCS
            YY=XX*SINFIC+YY*COSFIC+YHCS
            XX=A
      IF(
     - INDX.EQ.3
     -)THEN
               A = (XX-XT)*CSROT+(YY-YT)*SNROT
               YY=-(XX-XT)*SNROT+(YY-YT)*CSROT
               XX=A
      ENDIF
      ENDIF
      GOTO IZZZ03
17002 CONTINUE
      A=AMRAWL
      IF(AMRAWR.GT.A) A=AMRAWR
      IF(A.LT.10.) A=10.
      IF(
     - NRUN.GE. 24200
     -)THEN
      IF(
     - A.GT.1800.
     -)THEN
            TSLEW=-1.449+1.19097E-3*(A-2000.)
      ELSE
            TSLEW=-2.100+2.11521E-3*(A-1600.)-8.50349E-12*(1600.-A)**4
      ENDIF
      ELSE
      IF(
     - A.GT.5000.
     -)THEN
            TSLEW=-50.+5.80000E-3*(A-5000.)
      ELSE
      IF(
     - A.LT.300.
     -)THEN
               TSLEW=-200.
      ELSE
         TSLEW=-4472.05*A**(-5.23557E-1-6.42692E-3*(ALOG(A)-7.77529)**2)
               IF(NRUN.GE.20275.AND.A.LT.1500.)
     +         TSLEW=TSLEW-(A-1500.)**2*2.26664E-5
      ENDIF
            IF(A.LT.650. .AND.(NRUN.GE.20275 .OR.
     +      NRUN.GE.13000 .AND. NRUN.LE. 14599) )
     +      TSLEW=TSLEW+116.6-1.79687E-1*A
            IF(A.LT.800. .AND. NRUN.GE.11473 .AND. NRUN.LE.12554)
     +      TSLEW=TSLEW+139.4-1.74800E-1*A
      ENDIF
      ENDIF
      TDRIFT=TDRIFT+TSLEW
      GOTO IZZZ02
17009 CONTINUE
      ACTG=ABS(CTGTH)
      IF(
     - NRUN.GE. 24200
     -)THEN
         ZTSLW=0.
      IF(
     - KRING.EQ.4
     -)THEN
      IF(
     - LBSIDE.LT.0
     -)THEN
               ZTSLW=-19.43-14.5942*ACTG+19.8951*ACTG**2
      IF(
     - ACTG.LT..42
     -)THEN
                  ZTSLW=ZTSLW+5.1921+3.216*ACTG-82.49*ACTG**2
      ELSE
                  ZTSLW=ZTSLW-24.66+48.9578*ACTG-22.7265*ACTG**2
      ENDIF
      ELSE
               ZTSLW=5.918-5.45559*ACTG-2.12*ACTG**2
      ENDIF
      ENDIF
      IF(
     - KRING.EQ.3
     -)THEN
      IF(
     - LBSIDE.LT.0
     -)THEN
               ZTSLW=-.937-8.66313*ACTG+9.8988*ACTG**2
      ELSE
               ZTSLW= 2.46- 3.8375*ACTG-14.5671*ACTG**2
      ENDIF
      ENDIF
         J=2*KRING
         IF(LBSIDE.LT.0) J=J-1
      IF(
     - J.EQ.6.OR.J.EQ.7
     -)THEN
            AZ=ABS(ZHIT)
            BZ=ACTG*GGF(4,J)
            ZTSLW=ZTSLW+(AZ-BZ)*(GGF(1,J)+GGF(2,J)*(AZ+BZ)+GGF(3,J)
     +      *(AZ*(AZ+BZ)+BZ**2))
      ENDIF
      ELSE
      IF(
     - KRING.EQ.1
     -)THEN
            ZTSLW=13.46-14.03*ACTG
      ELSE
      IF(
     - KRING.EQ.2
     -)THEN
               ZTSLW=15.23-31.278*ACTG+7.54731*ACTG**2
      ELSE
               ZTSLW=20.86-48.672*ACTG+13.663*ACTG**2
      ENDIF
      ENDIF
      IF(
     - KRING.EQ.1
     -)THEN
      IF(
     - LBSIDE.LT.0
     -)THEN
      IF(
     - ACTG.LT..37
     -)THEN
                  T1=10.30-26.1*ACTG
      ELSE
                  T1=3.88-18.5345*ABS(ACTG-.5427)
      ENDIF
               T1=T1-0.30+ 0.77*ACTG-0.7648*ACTG**2
      ELSE
      IF(
     - ACTG.LT..37
     -)THEN
                  T1=7.50-26.3*ACTG
      ELSE
                  T1=-1.95+6.84118*ABS(ACTG-.4)
      ENDIF
               T1=T1+3.21-14.10*ACTG+10.73*ACTG**2
      ENDIF
            ZTSLW=ZTSLW+T1
      ENDIF
      IF(
     - KRING.EQ.2
     -)THEN
      IF(
     - LBSIDE.LT.0
     -)THEN
      IF(
     - ACTG.LT..40
     -)THEN
                  T1=8.787-19.675*ACTG
      ELSE
                  T1=4.091-18.133*ABS(ACTG-.56)
      ENDIF
      ELSE
      IF(
     - ACTG.LT..48
     -)THEN
                  T1=1.983-12.667*ACTG
      ELSE
                  T1=-4.1125+13.574*ABS(ACTG-.5)
      ENDIF
      ENDIF
            ZTSLW=ZTSLW+T1
      ENDIF
      IF(
     - KRING.EQ.3
     -)THEN
            T1=8.336-12.3519*ACTG
      IF(
     - LBSIDE.LT.0
     -)THEN
               T1=T1-2.68+18.09*ACTG-15.95*ACTG**2
      ELSE
               T1=T1+1.20-14.489*ACTG+14.623*ACTG**2
               IF(NRUN.GE.8712.AND.NRUN.LE.9999)
     +         T1=T1+14.20-8.5415*ACTG-10.6000*ACTG**2
               IF(NRUN.GE.7592.AND.NRUN.LE.8711)
     +         T1=T1+4.16+17.97*ACTG-24.33*ACTG**2
      ENDIF
            ZTSLW=ZTSLW+T1
      ENDIF
      IF(
     - KRING.EQ.4
     -)THEN
      IF(
     - ACTG.LT..56
     -)THEN
               T1=5.58-15.183*ACTG
      ELSE
               T1=-3.30+8.1613*(ACTG-.5)
      ENDIF
      IF(
     - LBSIDE.LT.0
     -)THEN
               T1=T1+3.12-21.16*ACTG+18.90*ACTG**2
               IF(NRUN.GE.11038.AND.NRUN.LE.12554)
     +         T1=T1+.39+29.1785*ACTG-30.4402*ACTG**2
               IF(NRUN.GE.8712.AND.NRUN.LE.9999)
     +         T1=T1+7.30+13.8*ACTG-23.20*ACTG**2
               IF(NRUN.GE.7592.AND.NRUN.LE.8711)
     +         T1=T1+0.16+ 9.08*ACTG- 9.60*ACTG**2
               IF(NRUN.GE.6185.AND.NRUN.LE.7591)
     +         T1=T1-16.6+41.18*ACTG-20.60*ACTG**2
      ELSE
               T1=T1-0.62+12.25*ACTG-10.52*ACTG**2
      ENDIF
            ZTSLW=ZTSLW+T1
      ENDIF
         J=2*KRING
         IF(LBSIDE.LT.0) J=J-1
         AZ=ABS(ZHIT)
         BZ=ACTG*GG(4,J)
         ZTSLW=ZTSLW+(AZ-BZ)*(GG(1,J)+GG(2,J)*(AZ+BZ)+GG(3,J)
     +   *(AZ*(AZ+BZ)+BZ**2))
      IF(
     - KRING.GE.3
     -)THEN
            ZTSLW=ZTSLW+1.70E-2/.6727*(ZHIT-CTGTH*GG(4,J))
      ENDIF
         IF(KRING.GE.3) ZTSLW=ZTSLW*FREQR
      ENDIF
      TCORR=TDRIFT+ZTSLW
      GOTO IZZZ05
17011 CONTINUE
      IF(
     - TCORR.LT.THU(4)
     -)THEN
         TCOR=TCORR
      IF(
     - TCOR.GT.THL(4)
     -)THEN
            TCOR=TCOR+A4(1)+A4(3)*(TCOR-A4(2))**2+A4(4)*(TCOR-A4(2))**4
      ELSE
      IF(
     - TCOR.GT.THL(3)
     -)THEN
               TCOR=TCOR+A3(1)+A3(3)*(TCOR-A3(2))**2
     +         +A3(4)*(TCOR-A3(2))**4
      ELSE
      IF(
     - TCOR.GT.THL(2)
     -)THEN
                  TCOR=TCOR-A2(1)+A2(2)*((TCOR-A2(3))**4-
     +            (A2(1)-A2(3))**4)
      ELSE
                  TCOR=TCOR-A2(1)
      ENDIF
      ENDIF
      ENDIF
         IF(TCOR.GT.0..AND.TCOR.LT.120.) TCOR=TCOR-8.E-2*(TCOR-120.)
         TCORR=TCOR
      ENDIF
      GOTO IZZZ06
17013 CONTINUE
      ASSIGN 17018 TO IZZZ09
      GOTO 17017
17018 CONTINUE
         STGTC=CALCST(JCELL,17)*IODD*LBSIDE*STGCOR
      IF(
     - DELTA.GT.B1(3,KRING)
     -)THEN
            A12=B1(2,KRING)
      ELSE
            A12=B1(1,KRING)
      ENDIF
         CSGINV=SQRT(1.+((DELTA-B1(3,KRING))/B1(4,KRING))**2)
      IF(
     - TCORR.GT.A12
     -)THEN
               TANGCC=A12*(CSGINV-1.)
      ELSE
               TANGCC=TCORR*(CSGINV-1.)
      ENDIF
         TCORR=TCORR+TANGCC+STGTC
      GOTO IZZZ07
17017 CONTINUE
      D=DELTA
      Z=ZHIT
      ASSIGN 17020 TO IZZZ10
      GOTO 17019
17020 CONTINUE
      ASSIGN 17022 TO IZZZ11
      GOTO 17021
17022 CONTINUE
      U=(Z/1200.)**2
      STGCOR=STGDZ0*(1.+U*FRACZD)
      IF(STGCOR.LT..2) STGCOR=.2
      GOTO IZZZ09
17019 CONTINUE
      IF(
     - D.LT.-600.
     -)THEN
            I=1
      ELSE
      IF(
     - D.LT.0.
     -)THEN
               I=2
      ELSE
      IF(
     - D.LT.600.
     -)THEN
                  I=3
      ELSE
                  I=4
      ENDIF
      ENDIF
      ENDIF
         STGDZ0=Q(1,I)+ABS(D)*(Q(2,I)+Q(4,I)*D**2)+Q(3,I)*D**2
     +   +Q(5,I)*D**4
         STGDZ0=STGDZ0/44.9444
      GOTO IZZZ10
17021 CONTINUE
      IF(
     - D.LT.-500.
     -)THEN
            I=1
      ELSE
      IF(
     - D.LT.0.
     -)THEN
               I=2
      ELSE
      IF(
     - D.LT.400.
     -)THEN
                  I=3
      ELSE
                  I=4
      ENDIF
      ENDIF
      ENDIF
         FRACZD=P(1,I)+ABS(D)*(P(2,I)+P(4,I)*D**2)+P(3,I)*D**2
     +   +P(5,I)*D**4
      GOTO IZZZ11
17015 CONTINUE
      IWR=(KRING-1)*16+IW
      IF(
     - Y1.GT.0.
     -)THEN
         IND=2
      ELSE
         IND=1
      ENDIF
      SMAX=SMAXW(IND,IWR)
      SM0=SM01(IND,IWR)
      Y1COR=DSTORW(2*IND,IWR,ISEG)*Y1**2    +   DSTORW(5,IWR,ISEG)
      S0=ABS(Y1)-SM0
      IF(S0.GT.0.) Y1COR=Y1COR+DSTORW(2*IND-1,IWR,ISEG)*S0**2
      IF(
     - IW.EQ.1 .OR. IW.EQ.16
     -)THEN
         X=ABS(Y1/SMAX)
      IF(
     - IWR.EQ.1
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..52
     -)THEN
                  T=-.07*(1.-((2.*X-.52)/.52)**2)
      ELSE
      IF(
     - X.LT.1.
     -)THEN
                     T=.05*(1.-((2.*X-1.37)/.33)**2)
      ELSE
                     T=-.13
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..52
     -)THEN
                  T=-.05*(1.-((2.*X-.52)/.52)**2)
      ELSE
      IF(
     - X.LT.1.
     -)THEN
                     T=.035*(1.-((2.*X-1.34)/.30)**2)
      ELSE
                     T=-.13
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - IWR.EQ.16
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..42
     -)THEN
                  T=.075*(1.-((2.*X-.42)/.42)**2)
      ELSE
      IF(
     - X.LT..67
     -)THEN
                     T=-.06*(1.-((2.*X-1.09)/.25)**2)
      ELSE
      IF(
     - X.LT..9
     -)THEN
                        T= .06*(1.-((2.*X-1.53)/.19)**2)
      ELSE
                        T=-.080
      ENDIF
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..50
     -)THEN
                  T= .05*(1.-((2.*X-.50)/.50)**2)
      ELSE
      IF(
     - X.LT..75
     -)THEN
                     T=-.02*(1.-((2.*X-1.25)/.25)**2)
      ELSE
      IF(
     - X.LT.1.
     -)THEN
                        T=.025*(1.-((2.*X-1.70)/.20)**2)
      ELSE
                        T=-.03
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - IWR.EQ.17
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..40
     -)THEN
                  T=-.085*(1.-((2.*X-.40)/.40)**2)
      ELSE
      IF(
     - X.LT..62
     -)THEN
                     T= .05*(1.-((2.*X-1.02)/.22)**2)
      ELSE
      IF(
     - X.LT.1.
     -)THEN
                        T=-.04*(1.-((2.*X-1.47)/.23)**2)
      ELSE
                        T= .170
      ENDIF
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..37
     -)THEN
                  T=-.10*(1.-((2.*X-.37)/.37)**2)
      ELSE
      IF(
     - X.LT..60
     -)THEN
                     T= .06*(1.-((2.*X- .97)/.23)**2)
      ELSE
      IF(
     - X.LT..72
     -)THEN
                        T=-.03*(1.-((2.*X-1.32)/.12)**2)
      ELSE
      IF(
     - X.LT..9
     -)THEN
                           T= .03*(1.-((2.*X-1.58)/.14)**2)
      ELSE
                           T=-.07
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - IWR.EQ.32
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..27
     -)THEN
                  T=.120*(1.-((2.*X-.27)/.27)**2)
      ELSE
      IF(
     - X.LT..46
     -)THEN
                     T=-.08*(1.-((2.*X- .73)/.19)**2)
      ELSE
      IF(
     - X.LT..64
     -)THEN
                        T= .055*(1.-((2.*X-1.10)/.18)**2)
      ELSE
                        T=0.
      ENDIF
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..43
     -)THEN
                  T= .05*(1.-((2.*X-.43)/.43)**2)
      ELSE
      IF(
     - X.LT..67
     -)THEN
                     T=-.025*(1.-((2.*X-1.10)/.24)**2)
      ELSE
      IF(
     - X.LT.1.
     -)THEN
                        T=.020*(1.-((2.*X-1.55)/.21)**2)
      ELSE
                        T=-.070
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - IWR.EQ.33
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..42
     -)THEN
                  T=-.09*(1.-((2.*X-.42)/.42)**2)
      ELSE
      IF(
     - X.LT..68
     -)THEN
                     T= .06*(1.-((2.*X-1.10)/.26)**2)
      ELSE
      IF(
     - X.LT..95
     -)THEN
                        T=-.055*(1.-((2.*X-1.54)/.18)**2)
      ELSE
                        T=.170
      ENDIF
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..44
     -)THEN
                  T=-.11*(1.-((2.*X-.44)/.44)**2)
      ELSE
      IF(
     - X.LT..68
     -)THEN
                     T= .075*(1.-((2.*X-1.12)/.24)**2)
      ELSE
      IF(
     - X.LT..9
     -)THEN
                        T=-.05*(1.-((2.*X-1.53)/.17)**2)
      ELSE
                        T= .080
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - IWR.EQ.48
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..34
     -)THEN
                  T= .08*(1.-((2.*X-.34)/.34)**2)
      ELSE
      IF(
     - X.LT..85
     -)THEN
                     T=-.035*(1.-((2.*X- .99)/.31)**2)
      ELSE
                     T=.150
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..30
     -)THEN
                  T=.035*(1.-((2.*X-.30)/.30)**2)
      ELSE
                  T=-.035*(1.-((2.*X-1.10)/.50)**2)
      ENDIF
      ENDIF
      ENDIF
      IF(
     - IWR.EQ.49
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..42
     -)THEN
                  T=-.08*(1.-((2.*X-.42)/.42)**2)
      ELSE
      IF(
     - X.LT..70
     -)THEN
                     T=.018*(1.-((2.*X-1.07)/.23)**2)
      ELSE
                     T=.035
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..50
     -)THEN
                  T=-.09*(1.-((2.*X-.50)/.50)**2)
      ELSE
      IF(
     - X.LT..85
     -)THEN
                     T= .080*(1.-((2.*X-1.30)/.30)**2)
      ELSE
                     T=-.060
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - IWR.EQ.64
     -)THEN
      IF(
     - IND.EQ.2
     -)THEN
      IF(
     - X.LT..35
     -)THEN
                  T= .09*(1.-((2.*X-.35)/.35)**2)
      ELSE
      IF(
     - X.LT..64
     -)THEN
                     T=-.07*(1.-((2.*X- .99)/.29)**2)
      ELSE
      IF(
     - X.LT..85
     -)THEN
                        T= .05*(1.-((2.*X-1.44)/.16)**2)
      ELSE
                        T=-.09
      ENDIF
      ENDIF
      ENDIF
      ELSE
      IF(
     - X.LT..40
     -)THEN
                  T= .09*(1.-((2.*X-.40)/.40)**2)
      ELSE
                  T=0.
      ENDIF
      ENDIF
      ENDIF
         Y1COR=Y1COR+T
      ENDIF
      Y1=Y1+Y1COR
      GOTO IZZZ08
17007 CONTINUE
      S=G/F
      U=-S/F
      S=-.5*S
      IF(
     - ABS(U).GT..3
     -)THEN
      IF(
     - U.LT..98
     -)THEN
            SQTVAL=F*(SQRT(1.-U)-1.)
      ELSE
            SQTVAL=0.
      ENDIF
      ELSE
         VAL=-S*(1.+.25*U+.125*U**2)
         QQ=S*U**3/12.8
         N=5
15004 CONTINUE
      IF(
     - ABS(QQ).GT.EPS .AND.N.LT.15
     -)THEN
           VAL=VAL-QQ
           QQ=QQ*U*(1.-1.5/N)
           N=N+1
      GOTO 15004
      ENDIF
15005 CONTINUE
         SQTVAL=VAL
      ENDIF
      GOTO IZZZ04
      END

C   07/06/96 606071824  MEMBER NAME  BNXT     (S4)          FORTG1
      SUBROUTINE BNXT(IND,*)
C     BOS SUBPROGRAM =1.10=
#include "acs.for"
      COMMON/BCS/IW(1)
      IF(KPOS.EQ.0) GOTO 10
      IND=IW(KPOS)
      KPOS=0
      GOTO 20
   10 IND=IW(IND-1)
   20 IF(IND.EQ.0) GOTO 101
  100 RETURN
  101 RETURN 1
      END

C   10/01/82 206241813  MEMBER NAME  MNSMP    (S)           FORTRAN
      SUBROUTINE TSTLAR
      INTEGER *2 HDATA
      COMMON/BCS/IDATA(30000)
      COMMON/TOFRES/TOFLGT(10),TDT(10),TDR(10),BETA(10),IQUAL(10)
     1          ,ITOFHT(10),PATH(10),MUCAND,IMUCND(10),NMU,IMUFIN(10)
     2          ,TAUR(42,2)
      COMMON/TRKINF/NTRK,DX1(10),DY1(10),DZ1(10),DXL(10),DYL(10),
     1              DZL(10),NXY(10),NRZ(10),CHIXY(10),DRZ(10),CHIRZ(10),
     2              X1(10),Y1(10),Z1(10),XL(10),YL(10),ZL(10),ZVER(10),
     3              NGOOD,IGOOD(10),PMOM(10),FI1(10),FIL(10),
     4              NFIN,ITRK1(10),ITRK2(10) ,RMIN(10),R1(10),RL(10)
      COMMON/POINT/IPHEAD,IPLTCH,IPT1,IPTOF,IPCLST,IPR,IPPATR,IPNT(12),
     1             IPBP
      COMMON/PEDOLD/PEDLST(84)
      COMMON/ENRGMG/BENGEV,BKGAUS,EGCOR
      COMMON/CIOUNI/IUNIT,JUNIT,NCALI,KUNITA(10),LUNITA(10)
      COMMON/CGRAPH/ JUSCRN
      DIMENSION RDATA(6000),HDATA(12000),PH(10),SIG(3)
      EQUIVALENCE(IDATA(1),RDATA(1)),(HDATA(1),IDATA(1))
      COMMON/PU/ NTOF,NBEAM,IHIT(200),DPHI
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/FLAGS/HISTFL,PRFL,NPRLIM
      COMMON/INOUT/WRITFL,EVWRIT
      LOGICAL WRITFL,EVWRIT,HISTFL,PRFL
      DIMENSION IBERR(10)
      DIMENSION LRUN(20),JELIM(100,3)
C
      DATA NUN/2/
C
      READ 501,HISTFL,PRFL,NPRLIM
  501 FORMAT(3I5)
      PRINT 502,HISTFL,PRFL,NPRLIM
  502 FORMAT(' FLAGS',2L10,I10)
      NCALI = 2
      KUNITA(1) = 10
      KUNITA(2) = 11
      LUNITA(1) = 21
      LUNITA(2) = 22
      JUSCRN = 6
C
      CALL SETSL(IBERR,0,40,0)
      CALL SETSL(JELIM,0,1200,0)
      IWRITE =0
      IFILE = 0
      NUMRUN = 0
      NBHABH = 0
      NELIM = 0
      WRITFL = .FALSE.
      WRITFL = .TRUE.
      CALL BINT(30000,4000,500,0)
      IF(WRITFL) CALL BWRO(3,1558,2)
      CALL STBUK(40000)
C     CALL PEDINT
      CALL LGINIT
      NAC = 0
      NEV = 0
      LL = 0
      IRUN = 0
      NHERE = 0
      IFIRST = 0
C     CALL MUINI
C
C  LOCATE BOS BANKS
C
      IQPATR = IBLN('PATR')
      IQTOF = IBLN('ATOF')
      IQHEAD = IBLN('HEAD')
      IQTOFR = IBLN('TOFR')
      IQLTCH = IBLN('LATC')
      IQCLST = IBLN('LGCL')
C
      DO   1   N=1,50000
  77  CONTINUE
      EVWRIT = .FALSE.
      IF(IUHR(5).NE.1)  GOTO  7002
      CALL BSLT
      CALL BDLG
      CALL BREAD(NUN,&1000,&7000)
      IPHEAD = IDATA(IQHEAD)
      IF(IPHEAD.LE.0)  GOTO  2000
      NRUN = HDATA(IPHEAD*2+10)
      NEV = NEV + 1
      IEV=HDATA(2*IPHEAD+11)
C WATERLEAK
      IF(NRUN.GE.3560.AND.NRUN.LT.3728)  GOTO  2
C FLAT CABLES INTER CHANGED 25-21  29-35
      IF(NRUN.GE.5064.AND.NRUN.LT.5141)  GOTO  2
      NAC = NAC + 1
C     CALL ELIM(NRUN,IEV,1,LOUT)
C     IF(LOUT.NE.0) GOTO  17
      IGAUS = HDATA(IPHEAD*2+30)
      BKGAUS = FLOAT(IGAUS)/1000.
      BENGEV = 0.001*HDATA(IPHEAD*2+29 )
      EGCOR = EBEAM(HDATA(IPHEAD*2+10))/1000.
C     IF(EGCOR.LT.10.)  GOTO 17
      CALL HF1(111,BKGAUS,1.)
      CALL HF1(112,BENGEV,1.)
      IF(NRUN.EQ.IRUN)  GOTO  74
      LL = LL + 1
      LRUN(LL) = NRUN
      IF(LL.LT.20)  GOTO  73
      LL = 0
      NUMRUN = NUMRUN + 1
      PRINT 704,LRUN
  704 FORMAT('  RUNS  ',20I5)
      CALL SETSL(LRUN,0,80,0)
   73 CALL KLREAD(KALRET)
      IF(KALRET.NE.0) GOTO 300
C     CALL MUREG(0)
   74 IRUN = NRUN
      ITYP=HDATA(2*IPHEAD+12)
      IF(ITYP.GE. 64) GOTO  2
      IPLTCH = IDATA(IQLTCH)
      IF(IPLTCH.LE.0)  GOTO  2002
C     IPPATR = IDATA(IBLN('PATR'))
C     IF(IPPATR.LE.0) GOTO  2003
C     CALL STOTRK(IPPATR,0,1,0,1)
C     IF(NFIN.LE.0)  GOTO  2
      CALL BLOC(IPTOF,'ATOF',0,&400)
      CALL TOFSMP(NRUN)
      CALL COMPR(NRUN)
      CALL PLSMP
      IF(NEV.LE.2) CALL ATOFPR(IPTOF)
C     IF(NEV.LE.2) CALL PRSMP
   22 IWRITE = IWRITE+ 1
      IF(IWRITE.GT.100) GOTO  2
      IF(.NOT.WRITFL) GOTO  2
C     CALL BSAW(1,'TOFR')
      CALL BSLW
      CALL BWRITE(3)
      GOTO  1
   17 CONTINUE
      NELIM = NELIM + 1
      IF(NELIM.GT.100)  GOTO  1
      JELIM(NELIM,1) = NRUN
      JELIM(NELIM,2) = IEV
      JELIM(NELIM,3) = LOUT
    2 GOTO  1
 3000 PRINT 3010
 3010 FORMAT(' ERROR RETURN FROM TOFINT')
      GOTO  2
 3001 PRINT 3011
 3011 FORMAT(' ERROR RETURN FROM TOFMAS')
      GOTO  2
2000  IBERR(1) = IBERR(1) + 1
      GOTO 77
2002  IBERR(2) = IBERR(2) + 1
      GOTO 77
2003  IBERR(3) = IBERR(3) + 1
      GOTO 77
2004  IBERR(4) = IBERR(4) + 1
      GOTO 77
2005  IBERR(5) = IBERR(5) + 1
      GOTO  77
 400  IBERR(6) = IBERR(6) + 1
      GOTO  77
 401  IBERR(7) = IBERR(7) + 1
      GOTO  77
 402  IBERR(8) = IBERR(8) + 1
      GOTO  77
      IMISS = 0
 1000 PRINT 1001,I
 1001 FORMAT(' ERROR IN BREAD  I=',I3)
    1 CONTINUE
      GOTO  7000
C
 7002 PRINT 777
      PRINT 777
      PRINT 777
  777 FORMAT('  ********   TIMELIMIT   ********')
 7000 PRINT 704,(LRUN(L),L=1,LL)
      WRITE(6,7001)NEV,NAC
C
  701 PRINT 705, NELIM
  705 FORMAT(//' EVENTS ELIMINATED'/,I5)
      IF(NELIM.GT.100) NELLIM = 100
      PRINT 706,((JELIM(N,L),L=1,3),N=1,NELIM)
  706 FORMAT(1X,I8,I5,I3)
 7001 FORMAT(' NEV=',I8,' NAC =',I8)
      PRINT 7003,IBERR
 7003 FORMAT(//' BOS ERRORS ',10I10/)
C
C  WRITE LAST EVENT
C
      CALL BMLT(0,DUMMY)
      CALL BWRITE(3)
      CALL BSTA
      PRINT600,IWRITE
  600 FORMAT(//' EVENTS WRITTEN ',I10)
      CALL HISTDO
      RETURN
  300 PRINT 301,NRUN,KALRET
  301 FORMAT(' CALIBRATION TROUBLES FOR RUN ',I6,' KALRET = 'I5)
      RETURN
      END

C   06/02/79 002210700  MEMBER NAME  TPMESG   (SOURCE)      FORTRAN
      SUBROUTINE TPMESG(INDEX)
C
C     S.YAMADA      22-02-79  23:00
C     LAST MODIFICATION   22-08-79  10:55  E.ELSEN
C
C---- TP MESSAGES
C
      IMPLICIT INTEGER *2 (H)
#include "cdata.for"
C
      COMMON /CTPFLG/ ITPFLG(15),ISTEP
      COMMON /CTPMCT/ ICREC,MAXREC, NRUN,NRUN1,NRUN2,KRUN1,KRUN2,
     $                NTLEFT,NTOUT
      INTEGER *2 LIMIT(20)/20*10/
      INTEGER *2 KOUNT(20)/20*0/
C
      IF(INDEX.LT.1) RETURN
      IF(INDEX.GT.20) GO TO 200
C
      KOUNT(INDEX)=KOUNT(INDEX)+1
      IF(KOUNT(INDEX).GT.LIMIT(INDEX)) RETURN
C
C
      IF( INDEX.GT.10 ) GO TO 100
      GO TO (1,2,3,4,5,6,7,8,9,10),INDEX
C
    1 WRITE(6,601)
  601 FORMAT(' (TPMAIN) INPUT READ ERROR. PROGRAMMED STOP.')
      STOP
C
    2 WRITE(6,602)
  602 FORMAT(' (TPMAIN) EVENT HEADER IS MISSING.')
      RETURN
C
    3 WRITE(6,603) ISTEP
  603 FORMAT(' (TPSPRV) /BCS/ SPACE IS NOT ENOUGH TO PUT A NEW BANK.',
     $       '  ISTEP=',I3)
      RETURN
C
    4 WRITE(6,604)
  604 FORMAT(' (TPVTX1)  VERTEX CALCULATION DOES NOT CONVERGE.')
      RETURN
C
    5 WRITE(6,605)
  605 FORMAT(' (TPTOF) WRONG INNER TRACK INDEX')
      RETURN
C
    6 WRITE(6,606)
  606 FORMAT(' (TPTOF) ''TOFR''-BANK IS MISSING')
      RETURN
C
    7 RETURN
C
    8 WRITE(6,608)
  608 FORMAT(' (TPLGCL) ''TPVX''-1 IS MISSING')
      RETURN
C
    9 RETURN
C
   10 RETURN
C
C
  100 INDEX1 = INDEX-10
      GO TO (11,12,13,14,15,16,17,18,19,20),INDEX1
   11 RETURN
C
   12 RETURN
C
   13 RETURN
C
   14 RETURN
C
   15 RETURN
C
   16 WRITE(6,616)
  616 FORMAT(' (TPTCNT), TPVX-I IS MISSING.')
      RETURN
C
   17 WRITE(6,617)
  617 FORMAT(' (TPGNRL) ''TPVX'' IS MISSING OR ''TPTR''/NIS MISSING.')
      RETURN
C
   18 WRITE(6,618)
  618 FORMAT(' (TPGNRL)  ''TPTR''-N IS MISSING ALTHOUGH IT IS SPECIFIED
     & BY THE ''TPVX'' TRACK LIST')
      RETURN
C
   19 WRITE(6,619)
  619 FORMAT(' (TPGNRL)   MOMENTUM BUFFER OVERFLOW')
      RETURN
C
   20 WRITE(6,620)
  620 FORMAT(' (TPBNKS)   ERROR IN BCHM')
      RETURN
C
C
C---- TP-JOB FINISHING MESAGES
C
  200 INDEX1 = INDEX-20
      GO TO (21,22,23,24),INDEX1
   21 WRITE(6,621)
  621 FORMAT('0<< DATA END >>')
      GO TO 25
   22 WRITE(6,622)
  622 FORMAT('0<< NRUN EXCEEDED NRUN2 >>')
      GO TO 25
   23 WRITE(6,623)
  623 FORMAT('0<< ICREC EXCEEDED MAXREC >>')
      GO TO 25
   24 WRITE(6,624)
  624 FORMAT('0<< TIME OUT >>')
   25 WRITE(6,625)  ICREC, NTLEFT,KRUN1,KRUN2
  625 FORMAT(' IREC=',I5,5X,'LEFT TIME=',I7,5X,'1-ST RUN=',I10,
     $         5X,'LAST RUN=',I10)
C
C---- DUMP THE EVENT NO. WHICH IS LEFT IN THE BFFER
C     CALL CLOC( NPHD,'HEAD',0)
      IF(INITP.GT.0) GO TO 30
      INITP=1
      IPHD= IBLN('HEAD')
30    CONTINUE
      NPHD=IDATA(IPHD)
      IF(NPHD.LE.0) RETURN
      N1 = NPHD+NPHD+9
      N2 = N1+2
      WRITE(6,626) (HDATA(NN),NN=N1,N2)
  626 FORMAT(' THE EVENT LEFT IN THE BUFFER, IEXP,IRUN,IREC=',3I6)
      RETURN
      END

C   07/06/96 606071843  MEMBER NAME  DPEAK    (S4)          FORTG1
      SUBROUTINE DPEAK(NA,KA,XA,XZ,SIG)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      CALL BLOC(IND,'PEA*',NA,&1)
      GOTO 100
    1 CALL BCRE(IND,'PEA*',NA,10,&100,IER)
      FWHM=2.35482*SIG
      X1=AMIN1(XA,XZ)-FWHM*2.0
      X2=AMAX1(XA,XZ)+FWHM*2.0
      ST=AMAX1(0.1*FWHM,0.01*(X2-X1))
      NB=0.5+(X2-X1)/ST
      AW=0.5*(X1+X2-FLOAT(NB)*ST)
      NB=((NB+9)/10)*10
      IF(NB.GT.100) NB=100
      IF(NB.LT.20) NB=20
      CALL XBINS(X1,X2,NB,AW,ST)
C
   20 RW(IND+1)=AW
      RW(IND+2)=AW+FLOAT(NB)*ST
      RW(IND+3)=FWHM
      RW(IND+4)=SIG
      RW(IND+5)=AW
      RW(IND+6)=ST
      IW(IND+7)=NB
      IW(IND+8)=-1
C
      NW=(NB+2)*(KA+1)
      CALL BCHL(NW,&100)
      IW(IND+8)=KA
      CALL VZERO(IW(IND+11),NW)
      GOTO 100
C
      ENTRY UPEAK(NA,KA,X)
      IF(KA.LT.0) GOTO 100
      CALL BLOC(IND,'PEA*',NA,&100)
      IF(IW(IND+8).LT.KA) GOTO 100
      K=(X-RW(IND+5))/RW(IND+6)+1.0
      IF(K.GT.IW(IND+7)) K=IW(IND+7)+2
      IF(K.LE.0) K=IW(IND+7)+1
      INDK=IND+10+K+KA*(IW(IND+7)+2)
      RW(INDK)=RW(INDK)+1.0
  100 RETURN
      END

C   23/08/85 511061955  MEMBER NAME  MCTAGE   (S)           FORTRAN
C--------------------------------------------------------------------
C   09/03/84 403110312  MEMBER NAME  MCTAGE   (S)           FORTRAN
C
C
C ROUTINE TO PERFORM MONTE CARLO INTEGRATION OF ENERGY DEPOSITED
C IN LEAD GLASS / LEAD SCINTILLATOR OF TAGGING SYSTEM (JADE)
C
      SUBROUTINE MCTAGE(MARKMC,X,Y,Z,ARRAY,EHIT)
C
C INPUT
C======
C
C    MARKMC  - WHICH MARKMC OF TAGGER
C    X,Y   - POSITION OF HIT (ALL POSITIONS ARE CONSIDERED IN PLANE
C            OF TAGGER
C    ARRAY - ARRAY TO BE DIMENSIONED TO AT LEAST THE MAXIMUM ADDRESS
C            OF BLOCKS  RETURNED BY MCTAGB
C
C OUTPUT
C=======
C
C  THE ENERGIES DEPOSITED ARE STORED IN ARRAY
C
C  DONT FORGET TO CLEAR ARRAY ONCE PER EVENT
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C A.J.FINCH 8/3/84
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C DUE TO FORTRAN NAMING CONVENTION MUST MAKE MCTAGF REAL
C
      REAL MCTAGF
C
C IEND IS THE MAXIMUM DISTANCE FROM THE HIT AT WHICH ENERGY IS CALCULATE
C SO INTEGRAL MUST BE TENDING TO ZERO AT THIS POINT
C
      DATA RMAX/200./
C
C A FEW WELL KNOWN CONSTANTS
C
      DATA TWOPI/6.2832/
C
C ILIMIT CONTROLS THE NUMBER OF TRIES AT THE INTEGRATIONPER STEP
C
      DATA ILIMIT/500/
C
C
      DIMENSION ARRAY(1)
      DIMENSION NUMBER(200)
C
C
C SOME INITIALISATION
C
      NCOUNT = 0
      SUM = 0
      IBMAX=0
      NTRIES = 0

      CALL VZERO(NUMBER,200)

C
C FIRST CHECK ORIGINAL HIT IS IN A BLOCK
C
      CALL MCTAGB(MARKMC,X,Y,Z,IBLOCK,&999)
C
        AMAX = MCTAGF(0.0,MARKMC)
        AMIN = MCTAGF(RMAX,MARKMC)
C
        IF(AMAX.GE.AMIN)GOTO 101
         TEMP = AMIN
         AMIN = AMAX
         AMAX = TEMP
101     CONTINUE
C ----------------------------------------------------------------------
C
C START INTEGRATION LOOP >>>>>>
C
C ----------------------------------------------------------------------
C
  1     CONTINUE
C
C CHOOSE AN 'R' - DISTANCE FROM HIT OF INTEGRATION
C
        R =   RN(DUMMY) * RMAX
C
C
C DECIDE WHETHER TO USE THIS R ?
C
C CHOOSE AN MCTAGF(R)
C
       AN = RN(DUMMY)*(AMAX-AMIN)+AMIN
       W = MCTAGF(R,MARKMC)
       IF(AN.GT.W) GOTO 1
C
C WE ARE USING THIS R SO CALCULATE ANSWER
C
CCCCC CALL HFILL(2,R,0.0,1.0)
C
C
C CHOOSE A FI
C
         FI = TWOPI * RN(DUMMY)
         XX = X+R*COS(FI)
         YY = Y+R*SIN(FI)
         NCOUNT = NCOUNT + 1
C
C IN A BLOCK ?
C
      CALL MCTAGB(MARKMC,XX,YY,Z,IBLOCK,&10)
      IF(IBLOCK.LE.0)GOTO10
C
C YES - ADD RESULT TO ARRAY
C
C
      NUMBER(IBLOCK) = NUMBER(IBLOCK) + 1
      NTRIES = NTRIES + 1
10    IF (NTRIES.LT.ILIMIT)GOTO 1
C ----------------------------------------------------------------------
C
C  END OF INTEGRATION LOOP
C
C ----------------------------------------------------------------------
100   CONTINUE
C ----------------------------------------------------------------------
C
C  END OF MAIN LOOP
C
C ----------------------------------------------------------------------
C
C
C
 900  CONTINUE
C
      IF(NTRIES.LE.0)GOTO 1000
C
       DO 950 I = 1,200
        IF(NUMBER(I).LE.0)GOTO 950
        ARRAY(I)=EHIT*NUMBER(I)*1000/NCOUNT
 950   CONTINUE
C
C THATS IT ALL DONE
 1000 CONTINUE
      RETURN
 999  CONTINUE
      RETURN
      END

C   17/01/79 311281105  MEMBER NAME  TOFINT   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFINT(NRUN,INTF,INPA,*)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   12/03/79 007281422  MEMBER NAME  DDATA    (S)           FORTRAN
C
      COMMON /BCS/ IDATA(10000)
      DIMENSION DATA(10000)
      INTEGER *2 HDATA(20000)
      EQUIVALENCE (IDATA(1),DATA(1)), (HDATA(1),IDATA(1))
C
      COMMON/CTPCNS/BENGEV,BKGAUS
C   18/02/82 202180024  MEMBER NAME  CHEAD    (S)           FORTRAN
      INTEGER *2  HEADR(108)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      COMMON/POINT/IPHEAD,IPLTCH,IPT1,IPTOF,IPCLST,IPR,IPPATR,IPNT(13)
       DATA IFLG/0/,IENTRY/0/
       DATA IRUN/0/
      DATA IERL,IERP,IERH,IER2,IERA/5*0/
C
C========= LOAD CALIBRATION DATA
C
C     IF(IENTRY.EQ.0) PRINT 701
      IPTOF = INTF
      HEADR(18) = NRUN
  701 FORMAT(' NOW YOU CALLED THE ONLY LEGAL VERSION OF TOFINT')
      IF(INTF.LE.0) RETURN1
      IF(INPA.LE.0) RETURN1
      IF(NRUN.LE.1659)  CALL TOFIN2(NRUN,INTF,INPA,*3011)
      IF(NRUN.LE.1659)  RETURN
      IF(NRUN.EQ.0.AND.IENTRY.EQ.0) GOTO  101
      IF(NRUN.EQ.IRUN) GOTO  100
  101 IENTRY = IENTRY+1
      IRUN = NRUN
      CALL RD0880(NRUN)
C
C========= CONVERSION OF PATT. REC. DATA
C
  100 CALL BLOC(INLA,'LATC',0,*3000)
      IPHEAD = IDATA(IBLN('HEAD'))
      IF(IPHEAD.LE.0)  GOTO  3001
      CALL UCOPY(IDATA(IPHEAD-3),IHEADR,54)
      IGAUS = HDATA(IPHEAD*2+30)
      BKGAUS = FLOAT(IGAUS)/1000.
      CALL TFCTD1(INPA)
      IF(NTRK.LT.1) GO TO 4500
C
C========= CONVERSION OF TOF DATA
C
       IF(NRUN.NE.0.AND.NRUN.LT.8712)CALL TOFARD(INLA,INTF,IFLG,*4000)
       IF(NRUN.GE.8712) CALL TFARNW(INLA,INTF,IFLG,*4000)
C
C========= MAKE CORRESPONDENCE BETW. TRACKS AND COUNTERS
C
       CALL TOFCOR
       CALL TOFMAS
C
       RETURN
C
 3011 IER2 = IER2 + 1
      IF(IER2.LE.10) PRINT 3010
 3010 FORMAT(' ERROR RETURN FROM TOFIN2')
      RETURN 1
 3000 CONTINUE
      IERL = IERL + 1
      IF(IERL.LE.10) PRINT 9300,IERL
 9300 FORMAT(1X,'RAW DATA ERROR FROM TOF PROG: NO LATCHED DATA',I5)
      RETURN1
 4000 IERA = IERA + 1
      IF(IERA.LE.10) PRINT 9400
 9400 FORMAT(' ERROR RETURN FROM TOFARD')
      RETURN1
 4500 IERP = IERP + 1
      IF(IERP.LE.10) PRINT 9450,IERP
 9450 FORMAT(1X,'**** MESSAGE FROM TOF PROG NO TRACK IN PATR BANK',I5)
      RETURN1
 3001 IERH = IERH + 1
      IF(IERH.LE.10) PRINT 3002,IERH
 3002 FORMAT(' MESSAGE FROM TOF PROG NO HEADER ',I5)
      RETURN1
  500 PRINT 501,NRUN
  501 FORMAT(' FOR RUN NUMBERS LESS THAN 1660 PLEASE USE INCLUDE OF
     1 TOF1660 ***********' )
      RETURN 1
      END

C   07/06/96 606071916  MEMBER NAME  UPATT    (S4)          FORTRAN
      SUBROUTINE UPATT(NA,LIST)
C
C     ADD PATTERN IN LIST(1)...LIST(ND) TO PATTERN TABLE NA
C     CORRECTED JULY 82
C
      COMMON/BCS/IW(1)
      INTEGER LIST(10)
      IND=ILINK('PAT*',NA)
      IF(IND.EQ.0) GOTO 100
      ND=IW(IND+1)
      K=0
      DO 10 I=1,ND
   10 K=K+IABS(LIST(I))*I*I
      K=4+MOD(K,97)
   15 J=IW(IND+K)
      IF(J.EQ.0) GOTO 40
      DO 20 I=1,ND
      IF(LIST(I).NE.IW(IND+J+I)) GOTO 30
   20 CONTINUE
      IW(IND+J)=IW(IND+J)+1
      GOTO 100
   30 K=J+ND+1
      GOTO 15
C     NEW ENTRY
   40 N=IW(IND+2)+ND+2
      IF(N.LT.IW(IND)) GOTO 50
      IW(IND+3)=IW(IND+3)+1
      GOTO 100
   50 IW(IND+2)=N
      IW(IND+K)=N
      IW(IND+N)=1
      DO 60 I=1,ND
      N=N+1
   60 IW(IND+N)=LIST(I)
      GOTO 100
***PMF      ENTRY DPATT(NA,ND,NL)
***PMF 07/05/99
      ENTRY DPATT(NA,ND2,NL)
      ND=ND2
***PMF(End)
C
C     DEFINE PARAMETERS FOR PATTERN TABLE NA
C
C     CALL DPATT(NA,ND,NL)
C
C        ND = DIMENSION OF LIST (IN UPATT)
C        NL = MAX NUMBER OF DIFFERENT ENTRIES
C
      IF(ND.LT.1.OR.ND.GT.10) GOTO 100
      NW=100+(ND+2)*NL
      IND=IBANK('PAT*',NA,NW)
      IF(IND.EQ.0) GOTO 100
      IW(IND+1)=ND
      IW(IND+2)=99-ND
      GOTO 100
C
      ENTRY PPATT(NA)
C
C     PRINT OUT OF PATTERN TABLES FOR NA OR ALL (IF NA=0)
C
      IF(NA.EQ.0) GOTO 70
      IND=ILINK('PAT*',NA)
      GOTO 80
   70 IND=IBLN('PAT*')+1
      IND=IW(IND-1)
   80 IF(IND.EQ.0) GOTO 100
      NTOT=IW(IND+3)
      ND=IW(IND+1)
      NAA=IW(IND-2)
      NLIM=IW(IND+2)
      IW(IND+2)=0
      N=99-ND
   82 N=N+ND+2
      IF(N.GT.NLIM) GOTO 84
      NTOT=NTOT+IW(IND+N)
      IW(IND+N+ND+1)=0
      GOTO 82
   84 N=99-ND
      WRITE(6,101) IW(IND-2),IW(IND+3),NTOT
   86 N=N+ND+2
      IF(N.GT.NLIM) GOTO 94
      MFR=2
   88 M=IW(IND+MFR)
      IF(M.EQ.0) GOTO 92
      DO 90 I=1,ND
      IF(IW(IND+N+I)-IW(IND+M+I)) 92,90,91
   90 CONTINUE
   91 MFR=M+ND+1
      GOTO 88
   92 IW(IND+N+ND+1)=IW(IND+MFR)
      IW(IND+MFR)=N
      GOTO 86
   94 MFR=2
   96 M=IW(IND+MFR)
      IF(M.EQ.0) GOTO 98
      WRITE(6,102) IW(IND+M),(IW(IND+M+I),I=1,ND)
      MFR=M+ND+1
      GOTO 96
   98 IND=IW(IND-1)
      IDL=ILOC('PAT*',NAA,-1)
      IF(NA.EQ.0) GOTO 80
  100 RETURN
  101 FORMAT('0-------------'/' UPATT',I8,I20,' OVERFLOWS',1X,
     1   'OF TOTAL',I8,' ENTRIES'/
     1   '       ENTRIES   PATTERN . . .'/)
  102 FORMAT(4X,11I10)
      END

C   18/10/82 606101312  MEMBER NAME  MCMAIN9  (S)           FORTRAN
      PROGRAM MCMAIN
      IMPLICIT NONE
************************************************************************
*
*     Main program for the standard JADE tracking simulation
*     without muons.
*
*     This version: ??/10/99 Pedro Movilla Fernandez
*                   28/05/00 PMF: introduce FFREAD for I/O steering
*                   21/12/00 PMF: use CERNLIB package CFIO to read CPROD file
*                                 with other endian format
*
************************************************************************
C
C MCJADE parameters
*------------------------------------------------------------------------
C /TODAY/ HOLDS A DATE TO SPECIFY VERSION OF JADE DETECTOR IN MC
C                         TRACKING JOBS.
C
C       HDATE(1) GIVES SECONDS, HDATE(2) GIVES MINUTES
C       HDATE(3) GIVES HOURS,   HDATE(4) GIVES DAYS
C       HDATE(5) GIVES MONTHS,  HDATE(6) GIVES YEARS
C               (17.5 IS THE NORWEGIAN NATIONAL DAY...)
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
*------------------------------------------------------------------------
C                            FLAGS USED (MAINLY) FOR INPUT
C                            ERROR CHECKING IN THE MONTE CARLO
      LOGICAL*4 VTEST
      COMMON /CVFLAG/ VTEST(20)
*------------------------------------------------------------------------
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                 BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
      LOGICAL*1 LFLAG
      COMMON/CFLAG/LFLAG(10)
*------------------------------------------------------------------------
C    ALLOWS SECTIONS OF THE INPUT FILE TO BE TRACKED.
C    MINIMUM AND MAXIMUM NR OF EVENT SET IN SUBR. JGETEV
C    EVENT COUNT PASSED VIA /CIEVS/ KIEV,IEVMIN,IEVMAX
      INTEGER KIEV,IEVMIN,IEVMAX
      COMMON /CIEVS/ KIEV,IEVMIN,IEVMAX
*------------------------------------------------------------------------
C
C BOS
      INTEGER IW
      COMMON / BCS / IW(33000)
C
C PAW
      INTEGER NWPAW,ICYCLE,HMEMOR
      PARAMETER (NWPAW=2000000)
      COMMON / PAWC / HMEMOR(NWPAW)
C
C FFREAD
      REAL SPACE
      INTEGER FFSPAC
      PARAMETER (FFSPAC=20000)
      COMMON / CFREAD / SPACE(FFSPAC)
C
C User I/O
C     JADE convention: LUN=2: Event input  (cprod files)
C                         =3: Event output (bos files)
      INTEGER IOVECT,IOBOS,IOBANK
      LOGICAL LBANK,LHIST,LSTART,ENDIAN
      COMMON /MYIO/ IOVECT,IOBOS,IOBANK,LBANK,LHIST,LSTART
      EXTERNAL CMYIO
C
C Endian format of CPROD file
      INTEGER IFORM
      COMMON /CPFORM/ IFORM
C
C Misc
      INTEGER NAMLEN,NBYTEW,NWNAM,IOS
      PARAMETER( NAMLEN=120, NBYTEW=4, NWNAM=NAMLEN/NBYTEW )
      INTEGER  HISTF(NWNAM),VECTF(NWNAM),BANKF(NWNAM),BOSF(NWNAM)
      CHARACTER*(NAMLEN) CHISTF,CVECTF,CBANKF,CBOSF
      LOGICAL JFLAG(10),LEXIST
      INTEGER IYEAR,IMONTH,IDAY,NPRI,NEVT
      CHARACTER CSEEDF*11
      DATA CSEEDF / 'mcjade.stat' /
      INTEGER I,LENOCC,IERR
      COMMON /MYIO/ NEVT
C
*------------------------------------------------------------------------
C
C... Initialise BOS/HBOOK/FFREAD
      CALL BINT( 33000, 10000, 500, 0 )
      CALL HLIMIT(NWPAW)
      CALL FFINIT(0)
      CALL FFSET('SIZE',8)
C
C... Read FFREAD cards  
      WRITE(*,'(A)') 'MCMAIN: read FFREAD cards'
C Random number generator
      LSTART=.TRUE.
      CALL FFKEY('MCSTART',LSTART,1,'INTE')
C JADE configuration
      IYEAR=85
      CALL FFKEY('YEAR',IYEAR,1,'INTE')
      IMONTH=6
      CALL FFKEY('MONTH',IMONTH,1,'INTE')
      IDAY=15
      CALL FFKEY('DAY',IDAY,1,'INTE')
C MC tracking mode 
C     Changes from defaults in block data JADEBD:
C     - Perform gamma conversion in outer tank and coil
C     - Perform 3 dim shower profile fit to Eggs code
      JFLAG(2)=.TRUE.
      JFLAG(4)=.TRUE.
      CALL FFKEY('SMEAR',JFLAG(1),1,'LOGI')
      CALL FFKEY('CONVERT',JFLAG(2),1,'LOGI')
      CALL FFKEY('ABSORB',JFLAG(3),1,'LOGI')
      CALL FFKEY('SHOW3D',JFLAG(4),1,'LOGI')
      CALL FFKEY('VERTEX',JFLAG(5),1,'LOGI')
C Number of events
      NPRI=20
      CALL FFKEY('MCNPRI',NPRI,1,'INTE')
      IEVMIN=1
      CALL FFKEY('FIRST',IEVMIN,1,'INTE')
      IEVMAX=0
      CALL FFKEY('LAST',IEVMAX,1,'INTE')
C I/O options
      LBANK=.FALSE.
      CALL FFKEY('BANKS',LBANK,1,'LOGI')
      LHIST=.FALSE.
      CALL FFKEY('HISTO',LHIST,1,'LOGI')
C File names
      CALL VBLANK(HISTF,NWNAM)
      CALL FFKEY('MCHIST',HISTF,NWNAM,'MIXED')
      CALL VBLANK(VECTF,NWNAM)
      CALL FFKEY('MCVECT',VECTF,NWNAM,'MIXED')
      CALL VBLANK(BANKF,NWNAM)
      CALL FFKEY('MCBANK',BANKF,NWNAM,'MIXED')
      CALL VBLANK(BOSF,NWNAM)
      CALL FFKEY('MCBOS',BOSF,NWNAM,'MIXED')
      CALl FFGO
C... Convert hollerith to character
      CALL UHTOC(VECTF,NBYTEW,CVECTF,NAMLEN)
      CALL UHTOC(BOSF,NBYTEW,CBOSF,NAMLEN)
      CALL UHTOC(BANKF,NBYTEW,CBANKF,NAMLEN)
      CALL UHTOC(HISTF,NBYTEW,CHISTF,NAMLEN)
C
C... Output file with tracked events in binary BOS format
      OPEN(UNIT=IOBOS,FILE=CBOSF,STATUS='UNKNOWN',FORM='UNFORMATTED')
C
C... Output file with BOS bank contents in readable ASCII format
      IF(LBANK)
     +     OPEN(IOBANK,FILE=CBANKF,STATUS='UNKNOWN',FORM='FORMATTED')
C
C... Input file with 4-vector data in binary CPROD format
C    Check endian format of CPROD data 
      IF( .NOT.ENDIAN(CVECTF) ) THEN 
         IFORM=-1
      ELSE
         IFORM=1
      ENDIF
C    Open CPROD file
      IF( IFORM.GE.0 ) THEN
       OPEN(UNIT=IOVECT,FILE=CVECTF,STATUS='UNKNOWN',FORM='UNFORMATTED')
      ELSE
       CALL CFOPEN(IOVECT,0,1,'r   ',0,CVECTF,IOS )
      ENDIF
C
C...  MC tracking settings
C --- Check validity of input 4-vectors
C Disable MCVALI checks # 6 & 7 (production vertex checks)
      VTEST(6) = .FALSE.
      VTEST(7) = .FALSE.
C --- Specify version of the JADE detector in common /TODAY/
      HDATE(1)=1
      HDATE(2)=1
      HDATE(3)=1
      HDATE(4)=IDAY
      HDATE(5)=IMONTH
      HDATE(6)=MOD(IYEAR,100)+1900
C --- Tracking mode: shuffle FFREAD input into INTEGER*1 array
      DO I=1,5
         LFLAG(I)=JFLAG(I)
      ENDDO
C --- Maximal number of events to be tracked
      IEVMAX=MAX(0,IEVMAX)
      NEVT=IEVMAX
      IF( IEVMAX.EQ.0 ) IEVMAX=999999
      IEVMIN=MAX(0,IEVMIN)
      IEVMAX=MAX(IEVMIN,IEVMAX)
      IF( NEVT.NE.0 ) NEVT=IEVMAX-IEVMIN+1
C
C... Initialize random number generator
      WRITE(*,FMT='(/,120(''=''))')
      IF( .NOT. LSTART ) CALL MCRAND('R',CSEEDF,0,0,IERR)
      IF( IERR.LT.0 ) GOTO 999
C
C... Book control histograms
      IF(LHIST) CALL MCBOOK    
C
C... Print out some tracking parameters:
      WRITE(*,'(/,A,/,28(''-''))') 'MCMAIN: tracking parameters:'
      WRITE(*,'(A28,A)') 'Input 4-vector file is: '
     >     ,CVECTF(1:LENOCC(CVECTF))
      INQUIRE(FILE=CVECTF,EXIST=LEXIST)
      IF( .NOT. LEXIST ) THEN
         WRITE(*,'(A)') 'MCMAIN: Error: Input file does not exist!'
         WRITE(*,'(A)') '...will stop now!'
         GOTO 999
      ENDIF
      WRITE(*,'(A28,I8)') 'First event to be tracked: ',IEVMIN
      WRITE(*,'(A28,I8)') 'Last event to be tracked: ',IEVMAX
      WRITE(*,'(A28,A,5I3,I5)') 'JADE configuration date: '
     >     ,'HDATE(1..6) =',(HDATE(I),I=1,6)
      WRITE(*,'(A28,A,20L2)') 'MCVALI validation flags: '
     >     ,'VTEST(1..20) =',(VTEST(I),I=1,20)
      WRITE(*,'(A28,A,6L2)') 'MCJADE tracking options: '
     >     ,'LFLAG(1..6) =',(LFLAG(I),I=1,6)
C
C... MC tracking 
      WRITE(*,'(/,A,/,22(''-''))') 'MCMAIN: calling MCJADE:'
      CALL MCJADE( NEVT, NPRI )
C
C... Print out BOS statistics
      CALL BSTA
      CALL PALL
C     
C... Close files
      CLOSE(UNIT=IOBOS)
      IF( IFORM.GE.0 ) THEN
         CLOSE(UNIT=IOVECT)
      ELSE
         CALL CFCLOS(IOVECT,0)
      ENDIF
      IF(LBANK) CLOSE(UNIT=IOBANK) 
C
C... Write out current randon number status
      WRITE(*,FMT='(/,120(''=''))')
      CALL MCRAND('W',CSEEDF,IEVMIN,IEVMIN+KIEV-1,IERR)
C
C... Write out histograms
      IF(LHIST) THEN
         WRITE(*,'(/,A,/,27(''-''))') 'MCMAIN: Control histograms:'
         CALL MCEND
         CALL HCDIR('//PAWC',' ')
         CALL HRPUT(0,CHISTF(1:LENOCC(CHISTF)),'N')
      ENDIF
C
C... Some info
      WRITE(*,'(/,A,/,24(''-''))') 'MCMAIN: I/O information:'
      WRITE(*,'(A30,A)') 'Input 4-vector file was: '
     >     ,CVECTF(1:LENOCC(CVECTF))
      WRITE(*,'(A30,I8)') 'First tracked event was: ',IEVMIN
      WRITE(*,'(A30,I8)') 'Last tracked event was: ',IEVMIN+KIEV-1
      WRITE(*,'(A30,A)') 'Output BOS banks to: '
     >     ,CBOSF(1:LENOCC(CBOSF))
      IF( LHIST ) WRITE(*,'(A30,A)') 'Output histos to: '
     >     ,CHISTF(1:LENOCC(CHISTF))
      IF( LBANK ) WRITE(*,'(A30,A)') 
     >     'Output readable bank contents to: '
     >     ,CBANKF(1:LENOCC(CBANKF))
C
C... The End
 999  STOP
      END
C
      BLOCKDATA CMYIO
      IMPLICIT NONE
      INTEGER IOVECT,IOBOS,IOBANK
      LOGICAL LBANK,LHIST,LSTART
      COMMON /MYIO/ IOVECT,IOBOS,IOBANK,LBANK,LHIST,LSTART,NEVT
      INTEGER NEVT
C
      DATA IOVECT/3/,IOBOS/2/,IOBANK/42/
      DATA LBANK/.FALSE./,LHIST/.TRUE./,LSTART/.TRUE./
C
      END
C
      LOGICAL FUNCTION ENDIAN(CNAM)
      IMPLICIT NONE
*.***************************************************************
*.
*.  21/12/00   P.A. Movilla Fernandez
*.
*.  This routine checks if the endian format of current platform
*.  matches the endian format of the binary CPROD input data.
*.
*.  Input:
*.        CNAM             ... name of the data file
*.  On return:
*.        ENDIAN = .TRUE.  ... format of current platform does match data format
*.        ENDIAN = .FALSE. ... format of current platform does NOT match data format
*.
*.  This is only an 'educated guess'. The routine checks the first
*.  integer words of the event record:
*.      1 = size of the fortran record length in bytes
*.      7 = event flavour
*.      8 = number of 'all' particles
*.  The values should generally not exceed 65535 if the endian format
*.  of the data matches the endian format of the current platform.
*.
*.***************************************************************
      CHARACTER CNAM*(*)
C Check endian format of current platform
      INTEGER IBIG
      INTEGER*2 HBIG(2)
      EQUIVALENCE (IBIG,HBIG)
      DATA IBIG /1/
C
      INTEGER IUIN,IOS,N(8),LIM,NREAD
      DATA LIM/65535/
C Test input file
      CALL CFOPEN(IUIN,0,1,'r   ',0,CNAM,IOS )
      IF( IOS.NE.0 ) THEN
         WRITE(*,'(2A)') ' ENDIAN: Error while opening file ',CNAM
         WRITE(*,'(A)') ' ...will stop now!'
         STOP
      ENDIF
C Read first words of the record
      NREAD=8
      CALL CFGET(IUIN,0,NREAD,NREAD,N,IOS)
C Check words 1,7,8
      IF(  N(1).LE.LIM.AND.N(7).LE.LIM.AND.N(8).LE.LIM ) THEN
         ENDIAN=.TRUE.
      ELSEIF( .NOT.( N(1).LE.LIM.AND.N(7).LE.LIM.AND.N(8).LE.LIM) ) THEN
         ENDIAN=.FALSE.
         CALL VXINVB(N,8)
      ELSE
         WRITE(*,'(3A)') ' ENDIAN: Cannot decide endian format'
     >        ,' of input data file ',CNAM
         WRITE(*,'(A,2I8,A5,I8)') ' Record starts with:',N
         WRITE(*,'(A)') ' ...will stop now!'
         STOP
      ENDIF
C I/O format info
      WRITE(*,'(/,A,/,A,2I8,4F7.3,2I8)') 'ENDIAN:'
     >     ,' Data record starts with:',N
      WRITE(*,'(A,$)') ' JADE data I/O format: '
      IF( ENDIAN ) THEN
         WRITE(*,'(A,$)') 'CPROD data and current platform with'
     >  //' EQUAL endian format.'
      ELSE
         WRITE(*,'(A,$)') 'CPROD data and current platform with'
     >  //' DIFFERENT endian format.'
      ENDIF
      IF( HBIG(1).EQ.1 ) THEN
         WRITE(*,'(A)') ' Current platform is LITTLE ENDIAN.'
      ELSE
         WRITE(*,'(A)') ' Current platform is BIG ENDIAN.'
      ENDIF
C Close input file
      CALL CFCLOS(IUIN,0)
      RETURN
      END

C   20/08/87 806091144  MEMBER NAME  ZE4VTP   (S)        M  FORTRAN77
      SUBROUTINE ZE4VTP
C-----------------------------------------------------------
C  Version of 08/06/88     E ELSEN
C  Last mod   08/06/88     E ELSEN
C  Fill information originating from TP into ZE4V bank.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      INTEGER LADD(-1:2)
      LOGICAL FIRST /.TRUE./
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IPZE4V = IBLN('ZE4V')
      ENDIF
C
      NPZE4V = IW(IPZE4V)
      IF( NPZE4V.GT.0 ) THEN
        NT = HW(NPZE4V*2 + 6)
        LT = HW(NPZE4V*2 + 5)
        LADD(-1) = LT
        LADD(0) = HW(NPZE4V*2 + 9) + LT
        LADD(1) = HW(NPZE4V*2 + 7) + LT
        LADD(2) = HW(NPZE4V*2 +11) + LT
        NP = HW(NPZE4V*2+1) + NPZE4V
C
        DO 10 J=1,NT
          ITPF = HW(NP*2+18)
          IF( ITPF.EQ.1 ) THEN
            NTPTR = HW(NP*2+17)
            CALL CLOC( NPTPTR, 'TPTR', NTPTR )
            IF( NPTPTR.GT.0 ) THEN
C                                       n dE/dx
              HW((NP+LT)*2+25) = IW(NPTPTR+72)
C                                       dE/dx
              RW(NP+LT+ 9) = RW(NPTPTR+73)
C                                       s(dE/dx)
              RW(NP+LT+10) = RW(NPTPTR+74)
C                                       Muon Quality or unused (= 0 )
              MUONQU = HW( NPTPTR*2 + 96 )
              IW(NP+LT+12) = MUONQU
              IF ( MUONQU .EQ. 9 )
     *          HW( NP*2 + 8 ) = HW( NP*2 + 8 )/100*100 + 3
C                                      TOF RESULTS (BETA)
              IF ( ABS( IW( NPTPTR + 58 )) .EQ. 1 ) THEN
                HW( (NP+LT)*2 + 28 ) =
     *             INT( RW( NPTPTR+61 )*1000.) * IW( NPTPTR + 58 )
              ENDIF
            ELSE
              HW((NP+LT)*2+25) = 0
              RW(NP+LT+ 9) = 0.
              RW(NP+LT+10) = 0.
              IW(NP+LT+12) = 0
              HW( (NP+LT)*2 + 28 ) = 0
C                                           erase muon flag
              IF( MOD( HW(NP*2+8), 100 ).EQ.3 ) THEN
                  HW(NP*2+8) = HW( NP*2 + 8 )/100*100
              ENDIF
            ENDIF
          ENDIF
          NP = NP + LADD(ITPF)
   10   CONTINUE
      ENDIF
      END

CDECK  ID>, CKERN.
      SUBROUTINE CKERN(ITKDM,NT,PT,NJREQ,IERR)
*.-----------------------------------------------------------------------
*.
*.    CKERN: Resolves the clustering, and stores information
*.           in common block CKCOM. 
*.           INPUT: ITKDM      (integer) First dimension of PT array 
*.                                 (>=4 required)
*.                  NT         (integer) Number of tracks
*.                  PT(ITKDM,*)(real)    Four-momenta of tracks
*.                  NJREQ      (integer) Clustering limit. Note that the CPU
*.                                       consumption is roughly proportional to
*.                                       calling JADE/Durham algorithm NJREQ 
*.                                       times!! 
*.                                       1) If interested in ALL possible N-jet
*.                                          configurations, set NJREQ equal to
*.                                          NT. Note the remark on CPU time!
*.                                       2) If interested in first N-jet 
*.                                          configuration (with largest 
*.                                          ycut values), set NJREQ equal 
*.                                          to number of jets N-jet.
*.           OUTPUT: IERR      (integer) Error flag, 0=OK.
*.           CALLS:  CKSORD
*.
*.
*.    Once CKERN is called, all information on the event clustering, 
*.    final state jets and particle association can be accessed 
*.    without additional CPU time using the utility routines.
*.
*.---CAMBRIDGE JET CLUSTERING ALGORITHM
*.   BASED ON YCLUS BY S BETHKE
*.   REF: YU L DOKSHITZER, G D LEDER, S MORETTI, B R WEBBER
*.   CAVENDISH-HEP-97/06 (JUNE 1997)
*.   07/07/97 FIRST RELEASED BY BRW
*.   23/08/97 COMMENTS REVISED BY BRW
*.   23/09/97 IMPLEMENT FOR PX LIBRARY BY STK AND SB
*.
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:  11-02-1998, Z. Troscyani, Add factor epsilon
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER ITKDM,NT,NJ,NJREQ,IERR
      REAL PT(ITKDM,*)
      INTEGER NTRK,NV
      PARAMETER( NTRK=300, NV=NTRK*(NTRK-2)+NTRK-(NTRK-2)*(NTRK-1)/2 )
      LOGICAL IP(NTRK),LCALL
      INTEGER I,II,J,K,L,IMINI,JMINI,IAD,IJ(NTRK),JJ(NTRK)
      DOUBLE PRECISION PP(5),PL(5,NTRK),V(NV),PM,VMINI,YSCA,EVIS
C
      DOUBLE PRECISION EPSILON
      DOUBLE PRECISION YCUR(NTRK)
      INTEGER          ICUR, KIX(NTRK)
C      

      SAVE LCALL
      DATA LCALL / .FALSE. /
      DATA EPSILON / 1D-12 /
      SAVE EPSILON

C  Welcome message:
      IF( .NOT.LCALL ) THEN
c        PRINT *, ' '
c        PRINT *, 'Cambridge jet finding algorithm, please refer to:'
c        PRINT *, 'Yu.L. Dokshitzer, G.D. Leder, S. Moretti, B.R. Webber'
c        PRINT *, 'CAVENDISH-HEP-97/06 (June 1997)'
        PRINT *, ' '
        PRINT *, ' #################################################'
        PRINT *, ' ###     C K E R N    V E R S I O N    104     ###'
c        PRINT *, ' ###  S. Bentvelsen and I. Meyer, EPXXX, 1998  ###'
        PRINT *, ' #################################################'
        WRITE(*,'(A,I2,A)') 
     +      '  ##### CAMBRIDGE JET CLUSTERING 1 - ',NJREQ,' JETS  #####'
        PRINT *, ' #################################################'
        LCALL= .TRUE.
      ENDIF
C---WARNINGS
      IERR = 0
      EVIS = 0D0
      ICUR = 0
      NTRACK = NT
      NJREQ = MIN(NJREQ,NT)
      IF( NT.GT.NTRK ) THEN
        WRITE(*,'(''CAMJET: More than '',I3,'' input particles: '',I5)')
     &        NTRK,NT
        IERR= 1
        RETURN
      ELSEIF( NT.LT.2 ) THEN
        WRITE(*,'(''CAMJET: Less than 2 input particles: '',I5)') NT
        IERR= 2
        RETURN
      ENDIF
C
C..   RESET ALL VALUES
C
      NJITER = 0
      DO I=1,NMXY
         YTRANS(I) = 0D0
         NTRANS(I) = 0
         DO J=1,NMXP
            ICMJ(J,I)   = 0
         ENDDO
      ENDDO

      DO I=1,NT
         EVIS = EVIS + DBLE(PT(4,I))
      ENDDO
      YSCA   = EVIS*EVIS
C---COPY MOMENTA INTO PL-ARRAY
 2    DO I=1,NT
         YCUR(I) = 0D0
         IP(I)=.TRUE.
         IJ(I)=I
         DO II=1,4
            PL(II,I)= DBLE(PT(II,I))
         ENDDO
         PM=PL(1,I)**2+PL(2,I)**2+PL(3,I)**2
         IF (PM.GT.0D0) THEN
            PL(5,I)=1D0/SQRT(PM)
         ELSE
            PL(5,I)=1D0
         ENDIF
      ENDDO
C---  FILL V-ARRAY: V(I,J) IS V(NT*(I-1)+J-I(I+1)/2)
      IAD = 0
      DO I=1,NT-1
         DO II=1,5
            PP(II)=PL(II,I)
         ENDDO
         DO J=I+1,NT
            IAD = IAD + 1
            V(IAD) = 2D0*(1D0-(PP(1)*PL(1,J) +PP(2)*PL(2,J)
     &               +PP(3)*PL(3,J))*PP(5)*PL(5,J))
         ENDDO
      ENDDO
      NJ=NT
C---START MAIN LOOP.  FIRST LOOK FOR MINIMUM V
    1 VMINI = 1D10
      IMINI = 0
      IAD = 0
      DO I=1,NT-1
         IF (IP(I)) THEN
            DO J=I+1,NT
               IAD = IAD + 1
               IF (IP(J).AND.V(IAD).LT.VMINI) THEN
                  VMINI = V(IAD)
                  IMINI = I
                  JMINI = J
               ENDIF
            ENDDO
         ELSE
            IAD=IAD+NT-I
         ENDIF
      ENDDO
C---  END OF CLUSTER SEARCH FOR VMINI
      IF (IMINI.NE.0) THEN
C---  NOT FINISHED YET
         ICUR       = ICUR + 1
         YCUR(ICUR) = VMINI*MIN(PL(4,IMINI),PL(4,JMINI))**2
         IF (YCUR(ICUR)+EPSILON.GE.YSCA) THEN
C---  SOFT FREEZING HERE
            IF (PL(4,IMINI).LT.PL(4,JMINI)) THEN
               IP(IMINI)=.FALSE.
            ELSE
               IP(JMINI)=.FALSE.
            ENDIF
         ELSE
C---  COMBINE PARTICLES IMINI AND JMINI
            DO II=1,4
               PL(II,IMINI)=PL(II,IMINI)+PL(II,JMINI)
            ENDDO
            PM=PL(1,IMINI)**2+PL(2,IMINI)**2+PL(3,IMINI)**2
            IF (PM.GT.0D0) THEN
               PL(5,IMINI)=1D0/SQRT(PM)
            ELSE
               PL(5,IMINI)=1D0
            ENDIF
C---  FLAG PARTICLE JMINI AS COMBINED
            IP(JMINI)=.FALSE.
            IJ(JMINI)=IMINI
            NJ=NJ-1
C---  CALCULATE RELEVANT NEW V VALUES
            DO I=1,NT
               IF (I.NE.IMINI) THEN
                  IF (IJ(I).EQ.JMINI) IJ(I)=IMINI
                  IF (IP(I)) THEN
                     K = MIN(I,IMINI)
                     L = MAX(I,IMINI)
                     IAD = NT*(K-1) + L - (K*(K+1))/2
                     V(IAD) = 2D0*(1D0-(PL(1,K)*PL(1,L) +PL(2,K)*PL(2,L)
     &                    +PL(3,K)*PL(3,L))*PL(5,K)*PL(5,L))
                  ENDIF
               ENDIF
            ENDDO
         ENDIF
C---  BACK TO START OF LOOP
         GO TO 1
      ELSE
C
C..   ITERATION IN JET-FINDING FINISHED
C
         NJITER = NJITER + 1
         IF(NJITER.LE.NMXY) THEN
C
C..   STORE THE VALUE OF YFLIP AND THE CORRESPONDING NUMBER OF JETS
C
            YTRANS(NJITER) = YSCA
            NTRANS(NJITER) = NJ

            IF(NJITER.LE.NMXP) THEN
C
C..   STORE THE JET-DIRECTIONS AND PARTICLE ASSOCIATION
C
               J=0
               DO I=1,NT
                  IF (IJ(I).EQ.I) THEN
                     J=J+1
                     JJ(I)=J
                     DO II=1,4
                        PCMJ(NJITER,II,J)= PL(II,I)
                     ENDDO
                  ENDIF
               ENDDO
               DO I=1,NT
                  ICMJ(NJITER,I)=JJ(IJ(I))
               ENDDO
            ENDIF
            IF(NJ.LE.NJREQ) THEN
C
C..   ANOTHER ITERATION?
C
               CALL CKSORD(NT,YCUR,KIX,'I')
               DO I=1,NT
C
C..   DETERMINE THE NEXT VALUE FOR YSCA, RESET VARIABLES
C
                  IF(YCUR(KIX(I)).LT.YSCA) THEN
                     YSCA = YCUR(KIX(I))
                     ICUR = 0
                     DO J=1,NT
                        YCUR(J) = 0D0
                     ENDDO
C
C..   YUP, GO FOR THE NEXT ROUND
C
                     IF(YSCA.NE.0) GOTO 2
                  ENDIF
               ENDDO
            ENDIF
         ENDIF
      ENDIF
C
C..   DEVIDE BY ECM**2
C
      NJMAX = -1
      DO I=1,NJITER
         YTRANS(I) = YTRANS(I)/EVIS**2
         IF(NTRANS(I).GT.NJMAX) NJMAX = NTRANS(I)
      ENDDO

      END

CDECK  ID>, CKSORD.
      SUBROUTINE CKSORD (ISZ,ARY,KIX,COPT)
*.*********************************************************
*. ------
*. CKSORV: TAKEN FROM OPAL PX-LIBRARY
*. ------
*. SOURCE: HERWIG (B.Webber,G.Marchesini)
*. Sort a real array into assending order based on
*. the magnitude of its elements; provide an
*. integer "index array" which specifies the ordering
*. of the array.
*. Usage     :
*.
*.      PARAMETER  (NDIM=1.or.more)
*.      REAL  ARY (NDIM)
*.      INTEGER  KIX (NDIM)
*.      INTEGER  ISIZ
*.      CHARACTER*1  COPT
*.
*.      ISIZ = 1.to.NDIM
*.      COPT = 'I'
*.      CALL PXSORV (ISIZ,ARY,KIX,COPT)
*.
*. INPUT     : ISIZ  The dimension of the input array
*. INPUT     : ARY   The input array
*. OUTPUT    : KIX   The index array
*. CONTROL   : COPT  Control of output vector ARY
*.              = ' ' : return sorted ARY and index array KIX
*.              = 'I' : return index array KIX only, don't
*.                      modify ARY
*.
*.mod: S. BENTVELSEN OCT-97
*.     CHANGE CODE TO BE ABLE TO SORT DOUBLE PRECISION
*.     ARRAYS, AND ARRAY IS ORDERED IN DESENDING VALUES.
*.*********************************************************
      IMPLICIT NONE
      INTEGER  MXSZ
      PARAMETER  (MXSZ=500)
      INTEGER  ISZ,IX,JX
      INTEGER  KIX (*),IL (MXSZ),IR (MXSZ)
      double precision  ARY (*),BRY (MXSZ)
      CHARACTER*1  COPT

      do ix=1,isz
         ary(ix)=-ary(ix)
      enddo


      IF (ISZ.GT.MXSZ) THEN
          WRITE (6,FMT='('' PXSORT: Error,'',
     +           '' Max array size ='',I6)') MXSZ
          KIX (1) = -1
          GO TO 990
      END IF
      IL (1) = 0
      IR (1) = 0
      DO 10 IX = 2,ISZ
          IL (IX) = 0
          IR (IX) = 0
          JX = 1
   2      IF (ARY (IX).GT.ARY (JX)) GO TO 5
   3      IF (IL (JX).EQ.0) GO TO 4
          JX = IL (JX)
          GO TO 2
   4      IR (IX) = -JX
          IL (JX) =  IX
          GO TO 10
   5      IF (IR (JX).LE.0) GO TO 6
          JX = IR (JX)
          GO TO 2
   6      IR (IX) = IR (JX)
          IR (JX) = IX
  10  CONTINUE
      IX = 1
      JX = 1
      GO TO 8
  20  JX = IL (JX)
   8  IF (IL (JX).GT.0) GO TO 20
   9  KIX (IX) = JX
      BRY (IX) = ARY (JX)
      IX = IX + 1
      IF (IR (JX)) 12,30,13
  13  JX = IR (JX)
      GO TO 8
  12  JX = -IR (JX)
      GO TO 9
  30  continue
      do ix=1,isz
         ary(ix)=-ary(ix)
      enddo
      IF (COPT.EQ.'I') RETURN
      DO 31 IX = 1,ISZ
  31  ARY (IX) = BRY (IX)
 990  continue
      RETURN
      END


CDECK  ID>, CYJET.
      SUBROUTINE CYJET(NJET,YL,YH,IERR)
*.-----------------------------------------------------------------------
*.
*.    CYJET: Return the largest pair of y-flip values for a required n-jet 
*.           configuration. 
*.           INPUT:   NJET (integer) Number of jets required
*.           OUTPUT:  YL   (real   ) Lower boundary of y interval
*.                    YH   (real   ) Upper boundary of y interval
*.                    IERR (integer) Error flag, 0=OK.
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      REAL    YL,YH
      INTEGER NJET,I,IERR
      INTEGER NPRINT
      DATA    NPRINT / 0 /
      SAVE    NPRINT

      IERR = 0
      YL = -1.
      YH = -1.
      IF(NJET.GT.NJMAX) THEN
         WRITE(*,*) '#################################################'
         WRITE(*,*) '## CYJET: CAMBRIDGE JET FINDER RESOLVED FOR    ##'
         WRITE(*,'(A,I2,A)') ' ##    NUMBER OF JETS BETWEEN 1 AND '
     +        ,NJMAX,' ONLY     ##'
         WRITE(*,*) '#################################################'
         IERR = 2
         RETURN
      ENDIF
      IF(NJET.LT.1) THEN
         WRITE(*,*) 'ERROR IN NJET: ',NJET
         IERR = 3
         RETURN
      ENDIF

      DO I=1,NJITER
         IF(NTRANS(I).EQ.NJET) THEN
            YH = 1.*YTRANS(I)
            IF(I.LT.NJITER) YL = 1.*YTRANS(I+1)
            GOTO 889
         ENDIF
      ENDDO

      IF(NPRINT.LT.10) THEN
         NPRINT = NPRINT + 1
         WRITE(*,*) '#################################################'
         WRITE(*,*) '## CYJET: CAMBRIDGE JET FINDER CANNOT RESOLVE  ##'
         WRITE(*,'(A,I2,A)') ' ##         THIS CONFIGURATION TO A '
     +        ,NJET,' JET      ##'
         WRITE(*,*) '#################################################'
      ENDIF

 889  CONTINUE
      RETURN
      END
CDECK  ID>, CASSO.
      SUBROUTINE CASSO(NJET,PNJ,BL,IERR)
*.-----------------------------------------------------------------------
*.
*.    CASSO: Return the jet four-momenta and jet-particle association for a
*.           required number of jets.
*.           (corresponding to largest ycut values)
*.           INPUT:   NJET (integer) Number of jets required
*.           OUTPUT:  PNJ(4,*)(real) Array of jets 4-vectors
*.                    BL(*)(integer) Particle i belongs to jet BL(i) 
*.                    IERR (integer) Error flag, 0=OK.
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER NJET, IERR
      REAL PNJ(4,*)
      INTEGER I,J,II
      INTEGER BL(*)
      INTEGER NPRINT
      DATA    NPRINT / 0 /
      SAVE    NPRINT

      IERR = 0
      IF(NJET.GT.NJMAX.OR.NJET.LE.0) THEN
         WRITE(*,*) '#################################################'
         WRITE(*,*) '## CASSO: CAMBRIDGE JET FINDER RESOLVED FOR    ##'
         WRITE(*,'(A,I2,A)') ' ##    NUMBER OF JETS BETWEEN 1 AND '
     +        ,NJMAX,' ONLY     ##'
         WRITE(*,*) '#################################################'
         DO I=1,NJMAX
            DO II=1,4
               PNJ(II,I) = 0
            ENDDO
         ENDDO
         IERR = 2
         RETURN
      ENDIF
      DO I=1,NJITER
         IF(NTRANS(I).EQ.NJET) THEN
            DO J=1,NJET
               DO II=1,4
                  PNJ(II,J) = SNGL(PCMJ(I,II,J))
               ENDDO
            ENDDO
            DO J=1,NTRACK
               BL(J) = ICMJ(I,J)
            ENDDO
            GOTO 889
         ENDIF
      ENDDO

      IF(NPRINT.LT.10) THEN
         NPRINT = NPRINT + 1
         WRITE(*,*) '#################################################'
         WRITE(*,*) '## CASSO: CAMBRIDGE JET FINDER CANNOT RESOLVE  ##'
         WRITE(*,'(A,I2,A)') ' ##         THIS CONFIGURATION TO A '
     +        ,NJET,' JET      ##'
         WRITE(*,*) '#################################################'
      ENDIF

 889  CONTINUE
      RETURN
      END

CDECK  ID>, CAXES.
      SUBROUTINE CAXES(NJET,PNJ,IERR)
*.-----------------------------------------------------------------------
*.
*.    CAXES: Returns the jet four-momenta for a required n-jet configuration
*.           (corresponding to largest ycut values)
*.           INPUT:   NJET (integer) Number of jets required
*.           OUTPUT:  PNJ(4,*)(real) Array of jets 4-vectors 
*.                    IERR (integer) Error flag, 0=OK.
*.           CALLS:   CASSO
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      REAL PNJ(4,*)
      INTEGER ITMP(300)
      INTEGER IERR, NJET

      CALL CASSO(NJET,PNJ,ITMP,IERR)

      RETURN
      END

CDECK  ID>, CNJET.
      SUBROUTINE CNJET(YCUT,NJET,IERR)
*.-----------------------------------------------------------------------
*.
*.    CNJET: Returns number of jets for given value of ycut
*.           INPUT:   YCUT    (real) Normalised ycut value
*.           OUTPUT:  NJET (integer) Number of jets
*.                    IERR (integer) Error flag, 0=OK.
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:  27-02-1998, IMeyer&SBentvelsen Fixed bug
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER I,NJET,IERR
      REAL    YCUT
      REAL    EPSILON
      INTEGER NPRINT
      DATA    NPRINT / 0 /
      DATA    EPSILON / 1E-7 /
      SAVE    NPRINT
      SAVE    EPSILON
      
      IERR = 0
      IF(YCUT.GE.1.) THEN
         IERR = 1
         NJET = 0
         RETURN
      ENDIF

      DO I=1,NJITER
         IF(YCUT.GT.(1.*YTRANS(I)+EPSILON)) THEN
            NJET = NTRANS(I-1)
            GOTO 889
         ENDIF
      ENDDO

      IF(NPRINT.LT.10) THEN
         NPRINT = NPRINT + 1
         WRITE(*,*) '#################################################'
         WRITE(*,*) '## CNJET: CAMBRIDGE JET FINDER CANNOT RESOLVE  ##'
         WRITE(*,'(A,I2,A)') ' ##         THIS CONFIGURATION TO A '
     +        ,NJET,' JET      ##'
         WRITE(*,*) '#################################################'
      ENDIF

 889  CONTINUE
      RETURN
      END

CDECK  ID>, CDBLE.
      SUBROUTINE CDBLE(IDUB,NJDUB,NJC)
*.-----------------------------------------------------------------------
*.
*.    CDBLE: Returns information about Njet configurations found at least
*.           two times.
*.           OUTPUT:  IDUB (integer) Number of Njet configurations for 
*.                                   which at least two Njet configurations 
*.                                   have been found
*.                    NJDUB(*)(integer) Array of length IDUB containing the 
*.                                   values for Njet
*.                    NJC(*)(integer) Array of length IDUB containing the
*.                                   number of different Njet regions
*.                                   NB: Entry NJDUB(i) correspond to NJC(i) 
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER IDUB,NJDUB(*),NJC(*)
      INTEGER NJOC(NMXY)
      INTEGER I

      DO I=1,NMXY
         NJOC(I) = 0
      ENDDO

      DO I=1,NJITER
         IF(NTRANS(I).GT.0.AND.NTRANS(I).LT.NMXY) THEN
            NJOC(NTRANS(I)) = NJOC(NTRANS(I)) + 1
         ENDIF
      ENDDO
      IDUB = 0
      DO I=1,NJITER
         IF(NJOC(I).GE.2) THEN
            IDUB = IDUB + 1
            NJDUB(IDUB) = I
            NJC(IDUB)   = NJOC(I)
         ENDIF
      ENDDO

      RETURN
      END
CDECK  ID>, CNONE.
      SUBROUTINE CNONE(INON,NJNON)
*.-----------------------------------------------------------------------
*.
*.    CNONE: Returns information about Njet configurations that could not
*.           be resolved.
*.           OUTPUT: INONE(integer) Number of Njet configurations that
*.                                  could not be resolved
*.                   NJNON(*)(integer) Array of length INON containing the
*.                                  Njet for which the configuration 
*.                                  could not be resolved.
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER INON,NJNON(*)
      INTEGER NJOC(NMXY)
      INTEGER I

      DO I=1,NMXY
         NJOC(I) = 0
      ENDDO

      DO I=1,NJITER
         IF(NTRANS(I).GT.0.AND.NTRANS(I).LT.NMXY) THEN
            NJOC(NTRANS(I)) = NJOC(NTRANS(I)) + 1
         ENDIF
      ENDDO
      INON = 0
      DO I=1,NJMAX
         IF(NJOC(I).EQ.0) THEN
            INON = INON + 1
            NJNON(INON) = I
         ENDIF
      ENDDO

      RETURN
      END
CDECK  ID>, CNCNT.
      INTEGER FUNCTION CNCNT(NJET)
*.-----------------------------------------------------------------------
*.
*.    CNCNT: (INTEGER FUNCTION) Returns the number of different Njet
*.           configurations found for given Njet.
*.           INPUT:  NJET(integer) Number of required jets
*.
*.
*.  CREATED :  08-01-1998, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER NJET, I

      CNCNT = 0
      DO I=1,NJITER
         IF(NTRANS(I).EQ.NJET) THEN
            CNCNT = CNCNT + 1
         ENDIF
      ENDDO
      
      RETURN
      END

CDECK  ID>, CNASS.
      SUBROUTINE CNASS(NJET,ICON,PNJ,BL,YL,YH,IERR)
*.-----------------------------------------------------------------------
*.
*.    CNASS: Like CASSO, but used to retrieve information about each
*.           Njet configuration.
*.           INPUT:   NJET (integer) Number of jets required
*.                    ICON (integer) Equals i for ith Njet configuration
*.                                   (max valid value = CNCNT(NJET))
*.           OUTPUT:  PNJ(4,*)(real) Array of jets 4-vectors
*.                    BL(*)(integer) Particle i belongs to jet BL(i) 
*.                    YL   (real   ) Lower boundary of y interval for ICONth
*.                                   Njet configuration
*.                    YH   (real   ) Upper boundary of y interval for ICONth
*.                                   Njet configuration
*.                    IERR (integer) Error flag, 0=OK.
*.
*.
*.  CREATED :  08-01-1998, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER NJET, ICON, IERR
      REAL PNJ(4,*),YL,YH
      INTEGER BL(*)
      INTEGER CNCNT, IN, I, II, J
      INTEGER NCH, ITMP
      DATA    NCH / 0 /
      SAVE NCH

      IN = CNCNT(NJET)
      IF(IN.EQ.0) THEN
         NCH = NCH + 1
         IF(NCH.LE.10) THEN
            WRITE(*,*) 'NOT RESOLVED FOR NUMBER OF JETS ',NJET
         ENDIF
         IERR = 1
         RETURN
      ELSEIF(ICON.GT.IN) THEN
         NCH = NCH + 1
         IF(NCH.LE.10) THEN
            WRITE(*,*) 'NJET HAS ONLY ',IN,' DISTINCT YCUT RANGES'
         ENDIF
         IERR = 2
         RETURN
      ENDIF
      
      ITMP = 0
      DO I=1,NJITER
         IF(NTRANS(I).EQ.NJET) THEN
            ITMP = ITMP + 1
            IF(ITMP.EQ.ICON) THEN
               YH = 1.*YTRANS(I)
               IF(I.LT.NJITER) YL = 1.*YTRANS(I+1)
               DO J=1,NJET
                  DO II=1,4
                     PNJ(II,J) = SNGL(PCMJ(I,II,J))
                  ENDDO
               ENDDO
               DO J=1,NTRACK
                  BL(J) = ICMJ(I,J)
               ENDDO
               GOTO 889
            ENDIF
         ENDIF
      ENDDO
      
 889  CONTINUE
      RETURN
      END

CDECK  ID>, CINFO.
      SUBROUTINE CINFO
*.----------------------------------------------------------------------
*.
*.    CINFO: Print all found yflip values to standard output
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER I, IDUB,NJDUB(20),NJOC(20),INON,NJNON(20)

      WRITE(*,'(/A)'    ) '*******************************************'
      WRITE(*,'( A)'    ) '* CINFO: Information Cambridge clustering *'
      WRITE(*,'(A,I3,A)') '*   Clustering resolved to ',NJMAX
     +     ,' Jets       *'
      WRITE(*,'(A,2(I3,A))') '* Iterations: ',NJITER
     +                    ,',  Number of tracks: ',NTRACK,' *'
      WRITE(*,'( A)'    ) '*******************************************'
      WRITE(*,'( A)'    ) '* Iteration   Ycut              Njet      *'
      DO I=1,NJITER
         WRITE(*,'(A,I4,G20.8,I8,A)') '* ',I,YTRANS(I),NTRANS(I)
     +        ,'        *'
      ENDDO
      WRITE(*,'( A)'    ) '*******************************************'
      CALL CDBLE(IDUB,NJDUB,NJOC)
      WRITE(*,'(A,I2,A)') '* Number of double regions for NJET: '
     +      ,IDUB,'   *'
      DO I=1,IDUB
         WRITE(*,'(A,3I9,A)') '* ',I,NJDUB(I),NJOC(I),'             *'
      ENDDO
      WRITE(*,'( A)'    ) '*******************************************'
      CALL CNONE(INON,NJNON)
      WRITE(*,'(A,I2,A)') '* Number of impossible NJET states : '
     +      ,INON,'   *'
      DO I=1,INON
         WRITE(*,'(A,2I9,A)') '* ',I,NJNON(I),'                      *'
      ENDDO
      WRITE(*,'(A/)'    ) '*******************************************'
      

      RETURN
      END

CDECK  ID>, CYGET.
      SUBROUTINE CYGET(NJI,YAR,NAR)
*.----------------------------------------------------------------------
*.    CYGET: Get information on all yflip values and corresponding Njet
*.           values
*.           OUTPUT:  NJI (integer) Number of found yflip values (upto
*.                                  first appearance of NJREQ jets)
*.                    YAR(*)(real)  Array containing all yflip values
*.                    NAR(*)(integer) Array containing all Njet values
*.
*.  CREATED :  11-12-1997, STAN BENTVELSEN
*.  LAST MOD:
*.-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER NJI,NAR(*),I
      REAL    YAR(*)

      NJI = NJITER
      DO I=1,NJITER
         YAR(I) = 1.*YTRANS(I)
         NAR(I) = NTRANS(I)
      ENDDO

      RETURN
      END
CDECK  ID>, CWRIT.
      SUBROUTINE CWRIT(ITKDIM,NT,PT,NDBLE,IERR)
C-----------------------------------------------------------------------
C
C     ROUTINE TO WRITE 4-VECTORS OF THE EVENT IN ASCII FILE 'scam.evdata'
C     AND YFLIP VALUES OF THE EVENT IN ASCII FILE 'scam.yflip'
C     WRITE ONLY WHEN NUMBER OF MULTIPLE REGIONS FOR NJET >= NDBLE
C
C  CREATED :  11-12-1997, STAN BENTVELSEN
C  LAST MOD:
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER ITKDIM, NT, NDBLE, IERR
      INTEGER I,J
      INTEGER IDUB,NJDUB(20),NJOC(20)
      REAL    PT(ITKDIM,*)
      LOGICAL FIRST
      DATA    FIRST / .TRUE. /
      SAVE    FIRST

      IF(FIRST) THEN
         FIRST = .FALSE.
         OPEN(20,FILE='scam.evdata',STATUS='UNKNOWN')
         OPEN(21,FILE='scam.ycut',STATUS='UNKNOWN')
      ENDIF

      CALL CDBLE(IDUB,NJDUB,NJOC)
      IF(IDUB.GE.NDBLE) THEN
         WRITE(20,'(I8)') NT
         DO I=1,NT
            WRITE(20,'(I8,4F12.5)') I,(PT(J,I),J=1,4)
         ENDDO
         WRITE(21,'(I8)') NJITER
         DO I=1,NJITER
            WRITE(21,'(I8,F13.10,I8)') I,YTRANS(I),NTRANS(I)
         ENDDO
      ENDIF

      RETURN
      END
CDECK  ID>, CREAD.
      SUBROUTINE CREAD(ITKDIM,NT,PT,IERR)
C-----------------------------------------------------------------------
C
C  CREATED :  11-12-1997, STAN BENTVELSEN
C  LAST MOD:
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER  I,J,K
      INTEGER ITKDIM, NT, IERR
      REAL    PT(ITKDIM,*)

      LOGICAL FIRST
      DATA    FIRST / .TRUE. /
      SAVE    FIRST

      IF(FIRST) THEN
         FIRST = .FALSE.
         OPEN(20,FILE='scam.evdata',STATUS='UNKNOWN')
      ENDIF

      READ(20,'(I8)') NT
      DO I=1,NT
         READ(20,'(I8,4F12.5)') K,(PT(J,I),J=1,4)
      ENDDO

      RETURN
      END
CDECK  ID>, CMIGR.
      SUBROUTINE CMIGR(NJ,ORD,IERR)
C-----------------------------------------------------------------------
C
C     RETURN THE MIGRATION MATRIX OF TRACKS BETWEEN AN NJ JET
C     CONFIGURATION AND A NJ-1 CONFIGURATION.
C
C     INPUT : NJ         : NUMBER OF JETS
C     OUTPUT: MAT(10,10) : MIGRATION MATRIX, NJ X (NJ-1)
C             IERR       : ERROR FLAG
C
C  CREATED :  17-12-1997, STAN BENTVELSEN
C  LAST MOD:
C-----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER NMXY , NMXP
      PARAMETER (NMXY = 300)
      PARAMETER (NMXP = 30)
      DOUBLE PRECISION YTRANS(NMXY)
      DOUBLE PRECISION PCMJ(NMXP,4,NMXP)
      INTEGER          NTRANS(NMXY), NJITER, NJMAX, NTRACK
      INTEGER          ICMJ(NMXP,NMXY)
      COMMON / CKCOM / YTRANS, PCMJ, NTRANS, ICMJ, NJITER, NJMAX, NTRACK
      INTEGER NJ,IERR
      INTEGER IN(300),IM(300)
      INTEGER I,J,N,M
      REAL    PNJ(4,300), PMJ(4,300)
      INTEGER MAT(10,10), ORD(10,10), SUM(10)
      REAL    PUR(10,10)
      INTEGER KROW(10),KCOL(10)
      REAL*16 MROW(10),MCOL(10)


      IERR = 0
      DO I=1,10
         DO J=1,10
            MAT(I,J) = 0
         ENDDO
      ENDDO
      
      CALL CASSO(NJ  ,PNJ,IN,IERR)
      CALL CASSO(NJ-1,PMJ,IM,IERR)

      DO I=1,NTRACK
         N = IN(I)
         M = IM(I)
         IF(N.NE.0.AND.M.NE.0.AND.N.LE.10.AND.M.LE.10)
     +        MAT(N,M) = MAT(N,M) + 1
      ENDDO

      DO I=1,NJ-1
         SUM(I) = 0
      ENDDO

      DO I=1,NJ-1
         DO J=1,NJ
            SUM(I) = SUM(I) + MAT(J,I)
         ENDDO
      ENDDO

         
      DO I=1,NJ-1
         MCOL(I) = -9999.
         DO J=1,NJ
            PUR(J,I) = 1.*MAT(J,I) / SUM(I)
            IF(PUR(J,I).GT.MCOL(I)) MCOL(I) = PUR(J,I)
         ENDDO
      ENDDO

      DO J=1,NJ
         MROW(J) = -9999.
         DO I=1,NJ-1
            IF(PUR(J,I).GT.MROW(J)) MROW(J) = PUR(J,I)
         ENDDO
      ENDDO
      CALL PXSORV(NJ-1,MCOL,KCOL,' ')
      CALL PXSORV(NJ  ,MROW,KROW,' ')

      DO I=1,NJ-1
         DO J=1,NJ
            ORD(J,I) = MAT(KROW(NJ-J+1),KCOL(NJ-I))
         ENDDO
      ENDDO

      RETURN
      END

C =========== MACRO CMUFIL ==============================
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      COMMON/CMUFIL/HFILDA(72)
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C   ==========ENDMACRO CMUFIL================================

C./ I 0 MACRO
C./ INSERT 1 1
C---------------------------------------
C  MACRO CBOSIBLN .... BOS BANK POINTERS
C---------------------------------------
      COMMON/CBOSIB/
     +             IBHEAD,IBPATR,IBJHTL,IBTPEV,IBTPTR,IBFADC
     +            ,IBGVTX,IBLGCL,IBDEDX,IBATOF,IBTOFR,IBACLS
     +            ,IBLATC,IBTRIG,IBATST,IBATBP,IBALGL,IBTAGG
     +            ,IBATAG,IBJETC,IBJETV,IBTAGC,IBMUEV,IBMPRS
     +            ,IBN50S,IBALGN,IBZVTX,IBMUR1,IBMUR2,IBTPVX
     +            ,IBMTCO,IBMUCO,IBMJET,IBVECT,IBDUM1,IBDUM2
C------- END OF MACRO CBOSIBLN ---------

C   22/03/84           MEMBER NAME  ANATA2   (S)           FORTRAN
C   14/03/84 403221749  MEMBER NAME  ANATAG   (S)           FORTRAN
C
C SPECIAL DUMMY VERSION OF ANATAG WRITTEN BY A.J.FINCH
C
      SUBROUTINE ANATAG(IER)
C
      DATA ICOUNT/0/

#include "cwktag.for"
C
       IF(ICOUNT.GT.5)RETURN
       ICOUNT = ICOUNT + 1
       WRITE(6,600)
 600   FORMAT(/,/,' ***********************WARNING********************'
     1,/,'  YOU HAVE CALLED A DUMMY VERSION OF ANATAG WHICH WILL DO '
     1,/,'  NO ANALYSIS OF TAGGING INFORMATION FOR 1979 80 JADE DATA '
     1,/,'  '
     1,/,' IF YOU REALLY WANT TO DO THIS ANALYSIS HOWEVER YOU SHOULD '
     1,/,' INCLUDE THE FOLLOWING IN YOUR SOURCE '
     1,/,' SUBROUTINE ANATAG(IER) '
     1,/,' CALL ANAL79(IER) '
     1,/,'   RETURN   '
     1,/,'  END       '
     1,/,'  IF YOU TRY IT -- GOOD LUCK ! YOU ARE BETTER OF USING'
     1,/,'  1981 AND LATER DATA  '
     1,/,'  1979 / 80 STUFF WAS PLAGUED BY PEDESTAL PROBLEMS '
     1,/,'   '
     1,/,' PLEASE SEE JADE COMPUTER NOTE 74 FOR MORE DETAILS '
     1,/,'   '
     1,/,'  THIS MESSAGE WILL BE REPEATED 5 TIMES '
     1,/,'  A.J.FINCH 22/3/84 ',/,/,/)
C      CALL ANAL79(IER)
C
       RETURN
       END

C   02/03/79 C9051501   MEMBER NAME  INTTOF   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE INTTOF
C    BANK DESCRIPTOR SET TO ZERO BY E.ELSEN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       INTEGER *2 IBSK
       COMMON/CTOF/IDATA(94)
       COMMON/CTWRK/IADC(84),ITDC(84)
C
       DO 100 I=1,84
       IADC(I)= 0
 100   ITDC(I)= 2048
       DO 200 I=1,94
 200   IDATA(I)= 0
C
       RETURN
       END

C   15/11/81 708291857  MEMBER NAME  INTSHW9  (S)           FORTRAN
      SUBROUTINE INTSHW(FRAC,N,A,Z,ROH,XX0)
C
C     A.SATO     XX-01-78
C
C     LATEST MODIFICATION  BY A.SATO      03-03-78  17:10
C     AFTER YAMADA'S MODIFICATION AT 17-02-78 19:10
C---- LAST MODIFICATION AT LICEPP 20-05-81  12:00
C     COPIED FROM LICEPP TO NOV-1981
C     LAST MOD    29-11-81  11:30
C
C  COPIED FROM F22YAM.LG.S(INTSHWM) ON 16.1.1986
C          INTENDED FOR MULTIPLE MATERIALS IN JADE: AL-ABS,SF5,SF6
C      CHANGE  16.1.1986
C  LAST CHANGE  29.8.1987    (ENELEL,ENELPO)
C                                   J.OLSSON
      COMMON / COLSON/ IPRO
      COMMON /TOTPAT/ PATH
      COMMON /CMATTR/ IMATTR,IMTLIS(10),XCM(10)
      COMMON /CAMPAR/CIC02,BP0
C  /RADLB/ HAS NO DIRECT USE IN SHOWER PROGRAM
      COMMON /RADLB/ XX0CM
C
      COMMON/FB1PAR/BGAM,PROSWD
      COMMON/BRPAR/BRA,BRB,BDEL
      COMMON/M0PAR/CUTM
      COMMON/PAPAR/CP
      COMMON /ENECUT/ ECUT,ECUTEL,ECUTPH,ECUTPS
      COMMON /SFCPA/SFC,SFE
      COMMON /ILPAR/AII,BII,CUTII/DFPAR/CID,AID,RMID,X0D,X1D
      EXTERNAL FPH
      DIMENSION SPTCL(9,MNP),PRTCL(9,MNP)
      DIMENSION PA0(3,3),PA1(3,3), PAQ0(9),PAQ1(9)
      DIMENSION POS(3),DIR(3)
      DIMENSION TETBL(20),ATETBL(20),TETBL0(21),ATETB0(21)
      DIMENSION DTETBL(20)
      EQUIVALENCE (TETBL(1),TETBL0(2)),(ATETBL(1),ATETB0(2))
C     DIMENSION ELTBL(200)
      DIMENSION ELOSEL(200),ELOSPO(200)
      DIMENSION ALTBL(200),ALTBL2(200)
      DIMENSION ECUTLS(3)
C     DIMENSION BUFF(40,10),BELTBL(200,10),BTETB0(21,10)
      DIMENSION BUFF(40,10),BELTEL(200,10),BELTPO(200,10),BTETB0(21,10)
      DIMENSION BDTETB(20,10),BATBT0(21,10)
C     NAMELIST /DMP/ ELTBL,TETBL0,ATETB0
      NAMELIST /DMP/ ELOSEL,ELOSPO,TETBL0,ATETB0
      DATA KPMAX/40/
      DATA NRCOM1/200/,NRCOM2/200/, ES/42./
      DATA EDCOM1/0.1/, CORP/0.284/, ANHAPF/1.60/
      DATA BPHE1/0.0489/,BPHE2/0.2559/,BPHE3/0.0583/
      DIMENSION FRAC(N),Z(N), A(N), X0(10)
      DIMENSION PR(10), POS0(3)
      EQUIVALENCE(ENE0,PA0(2,1)),(ENE1,PA1(2,1))
      EQUIVALENCE (CHG0,PA0(1,1)), (CHG1,PA1(1,1))
     @,(FLEN0,PA0(3,1)), (FLEN1,PA1(3,1))
      EQUIVALENCE(TMP,ITMP)
      EQUIVALENCE(PA0(1,1),PAQ0(1)), (PA1(1,1),PAQ1(1))
      EQUIVALENCE (PA0(1,2),POS(1)), (PA0(1,3),DIR(1))
      EQUIVALENCE (ECUTLS(1),ECUTEL)
      DATA NDV/100/, PAIRTH/2./, ECC/3./, NRR/20/, NRR2/200/
      DATA NTRR/20/, ETHANH/2.0/, PETH/1.82/, CHTHRE/1.272/
      DATA ISW/0/
C
C**** IF(N.GT.10)CALL MSG('COMPONENTS .GT. 10;;')
C         ZERO SET ARRAY BUFF
      IF(ISW.NE.0) GOTO 5000
      ISW=1
      CALL SETSL(BUFF,0,KPMAX*40,0)
C
5000  CONTINUE
      IF(IMATTR.LE. 0) IMATTR=1
      IF(IMATTR.GE.10) PRINT 81600
81600 FORMAT(' MATERIAL EXCEEDS 10')
      IF(IMATTR.GE.10) STOP
      IF( IMTLIS(IMATTR).NE.0 ) WRITE(6,81601) IMATTR
81601 FORMAT('++++ IMATTR=',I4,' IS INITIALIZED AGAIN.++++')
C---- REMEMBER THE SET PARAMETER NUMBER.
      IMTLIS(IMATTR) = 1
C
      CALL PARSET(FRAC,N,A,Z,CUTM,CUTB2,ROH,XX0,X0,ABR1,ABR2,
     +    ALPPA1,ALPPA2,ALPM,ALPBH,ACM,BGAM,AMEAN,ZMEAN)
C
        DO 80000 NPR=1,N
        WRITE(6,80600) A(NPR),Z(NPR),FRAC(NPR),X0(NPR)
80600   FORMAT(' A,Z,FRACTION=',2F10.2,F10.4,'   X0=',F12.4)
80000   CONTINUE
C
      XX0CM = XX0/ROH
      WRITE(6,80601) XX0,XX0CM,ROH ,IMATTR
80601 FORMAT(' XX0,XX0CM=',F10.3,'G/CM**2',F12.4,'CM   ROH=',F10.3,
     & ' INDEX OF MATERIAL',I4)
      XCM(IMATTR) = XX0CM
C
C
      ALPAN1=ACM/2.
      ALPAN0=ANHAPF*ALPAN1
C
C-----CALCULATE EFFECTIVE FRACTION OF LEAD TO DETERMINE THE CROSS
C      SECTION OF PAIR CORRECTION AND P-E EFFECT.
C
      PPB=0.
        DO 90 I=1,N
        IF(81.99 .GT. Z(I) .OR. Z(I) .GT. 82.01) GOTO 90
        PPB=PPB+FRAC(I)*XX0/X0(I)
   90   CONTINUE
C
      DAM=AMINT(FRAC,N,A,Z,XX0)
C
      CORPA0=CORP*PPB
      PROSWD=CUTB2
C       DO 80 I=1,N
        AL = ALOG(183./ZMEAN**0.333333)
        ALF=AL-FF(ZMEAN)
        BRA=1./(4.*ALF+1./3.)
        BRB=1./(4.*ALF)
        BDEL=136./(ZMEAN**0.3333333)
        CP=1./(4.*ALF-1./6.)
   80   A123=3.*SQRT(ZMEAN/137.0)
      PRL=SQRT(PROSWD)*511.*10**3
C
C     SFC---SCALING FACTOR TO REDUCE THE PHOTON 'FREE PATH'.
C     SFE---SCALING FACTOR TO REDUCE THE ELECTRON/POSITRON FREE PATH
C
      IF(SFC.LT.1.)SFC=1.
      ALPPA1=ALPPA1*SFC
      ALPPA2=ALPPA2*SFC
      ACM=ACM*SFC
C
      IF(SFE.LT.1.)SFE=1.
      ABR1=ABR1*SFE
      ABR2=ABR2*SFE
      ALPM=ALPM*SFE
      ALPBH=ALPBH*SFE
C
      CALL PARST2(ZMEAN,AMEAN,XX0,CUTM,PRL)
C
      IF(ECUT.GT.ECC) GOTO 45
C
      CALL STEST0(FPH,ECUT,ECC,TETBL,ACRTO,NRR,NDV)
      TETBL0(1)=0.
      DO 51 I=1,NRR
51    DTETBL(I)=TETBL(I)
      DO 50 I=2,NRR
50    TETBL(I)=TETBL(I-1)+TETBL(I)
      EDD=(ECC-ECUT)/NRR
C
C******GET INVERSE OF TETBL
C
      ATETB0(1)=ECUT
      TDD=TETBL(NRR)/NTRR
      T=0.
      NTRR1 = NTRR-1
      DO 40 J=1,NTRR1
      I=1
      T=T+TDD
41    IF(T.LT.TETBL0(I))GOTO 42
      I=I+1
      GO TO 41
42    I=I-1
      ATETBL(J)=ECUT+(I-1)*EDD+(T-TETBL0(I))*EDD/DTETBL(I)
40    CONTINUE
      ATETBL(NTRR)=ECC
C
   45 ECC2=ECUT+FLOAT(NRR2)
      ENE=ECUT
        DO 55 I=1,NRR2
C       ELTBL(I)=ENELS(ENE)
        ELOSEL(I)=ENELEL(ENE)
        ELOSPO(I)=ENELPO(ENE)
   55   ENE=ENE+1.
C
C     WRITE(6,8221) (ELTBL(I),I=1,200)
C221  FORMAT(' ',20(' ELTBL ',10(F10.4,1X),/))
      WRITE(6,8221) (ELOSEL(I),I=1,200)
8221  FORMAT(' ',20(' ELOSEL ',10(F10.4,1X),/))
      WRITE(6,8222) (ELOSPO(I),I=1,200)
8222  FORMAT(' ',20(' ELOSPO ',10(F10.4,1X),/))
C
      ENE=ECUTPH
        DO 60 I=1,NRCOM1
        ALTBL(I)=ALOG(1.+2.*ENE)
60      ENE=ENE+EDCOM1
      ECCOM1=ENE
        DO 61 I=1,NRCOM2
        ALTBL2(I)=ALOG(1.+2.*ENE)
61      ENE=ENE+1
      NRCM1=NRCOM1-1
      NRCM2=NRCOM2-1
C
C OF THE FOLLOWING PARAMETERS, SOME ARE NOT USED LATER ON
C    CUTB2 == PROSWD
C    XX0,AMEAN,ZMEAN,AL,ALF,PRL ARE ONLY USED FOR CALCULATIONS IN INIT.
C
C
      BUFF(1,IMATTR) = CUTB2
      BUFF(2,IMATTR) = XX0
      BUFF(3,IMATTR) = ABR1
      BUFF(4,IMATTR) = ABR2
      BUFF(5,IMATTR) = ALPPA1
      BUFF(6,IMATTR) = ALPPA2
      BUFF(7,IMATTR) = ALPM
      BUFF(8,IMATTR) = ALPBH
      BUFF(9,IMATTR) = ACM
      BUFF(10,IMATTR)= BGAM
      BUFF(11,IMATTR)= AMEAN
      BUFF(12,IMATTR)= ZMEAN
      BUFF(13,IMATTR)= XX0CM
      BUFF(14,IMATTR)= ALPAN1
      BUFF(15,IMATTR)= ALPAN0
      BUFF(16,IMATTR)= PPB
      BUFF(17,IMATTR)= CORPA0
      BUFF(18,IMATTR)= PROSWD
      BUFF(19,IMATTR)= AL
      BUFF(20,IMATTR)= ALF
      BUFF(21,IMATTR)= BRA
      BUFF(22,IMATTR)= BRB
      BUFF(23,IMATTR)= BDEL
      BUFF(24,IMATTR)= CP
      BUFF(25,IMATTR)= A123
      BUFF(26,IMATTR)= PRL
      BUFF(27,IMATTR)= ECUT
      BUFF(28,IMATTR)= ECUTEL
      BUFF(29,IMATTR)= ECUTPH
      BUFF(30,IMATTR)= ECUTPS
      BUFF(31,IMATTR)= EDD
      BUFF(32,IMATTR)= ECC
      BUFF(33,IMATTR)= CIC02
      BUFF(34,IMATTR)= BP0
      BUFF(35,IMATTR)= TDD
      CALL MVCL( BTETB0(1,IMATTR), 0, TETBL0, 0, 21*4)
      CALL MVCL( BDTETB(1,IMATTR), 0, DTETBL, 0, 20*4)
C     CALL MVCL( BELTBL(1,IMATTR), 0, ELTBL , 0, 200*4)
      CALL MVCL( BELTEL(1,IMATTR), 0, ELOSEL , 0, 200*4)
      CALL MVCL( BELTPO(1,IMATTR), 0, ELOSPO , 0, 200*4)
      CALL MVCL( BATBT0(1,IMATTR), 0, ATETB0, 0, 21*4)
CCC   WRITE(6,DMP)
       NMTTRO=IMATTR
      RETURN
C
C******************************
C
      ENTRY CASSHW(PRTCL,SPTCL,MNP,NP,IER,JBACK)
C
C JBACK IS STEERING CUTS ON SIDE ESCAPE IN LIGHTGUIDES ETC.
C    DOES NOT APPLY TO THE JADE SETUP, TO BE CALLED WITH JBACK=0
C
C
      IF(IPRO.NE.0) WRITE(6,2251) IMATTR,NMTTRO,PRTCL(4,1)
2251  FORMAT(' CASSHW: CALL WITH IMATTR NMTTRO:',2I4,' PRTCL41 ',E12.4)
C
      IF( IMTLIS(IMATTR).NE.0 ) GO TO 5001
         WRITE(6,6905) IMATTR,IMTLIS
 6905    FORMAT('  +++++ WRONG MATERIAL INDEX +++++,IMATTR=',I6,
     *          /' IMTLIS=',10I5,/)
C
 5001 IF(NMTTRO.EQ.IMATTR) GOTO 5100
       NMTTRO=IMATTR
C
       CUTB2     = BUFF( 1,IMATTR)
       XX0       = BUFF( 2,IMATTR)
       ABR1      = BUFF( 3,IMATTR)
       ABR2      = BUFF( 4,IMATTR)
       ALPPA1    = BUFF( 5,IMATTR)
       ALPPA2    = BUFF( 6,IMATTR)
       ALPM      = BUFF( 7,IMATTR)
       ALPBH     = BUFF( 8,IMATTR)
       ACM       = BUFF( 9,IMATTR)
       BGAM      = BUFF(10,IMATTR)
       AMEAN     = BUFF(11,IMATTR)
       ZMEAN     = BUFF(12,IMATTR)
       XX0CM     = BUFF(13,IMATTR)
       ALPAN1    = BUFF(14,IMATTR)
       ALPAN0    = BUFF(15,IMATTR)
       PPB       = BUFF(16,IMATTR)
       CORPA0    = BUFF(17,IMATTR)
       PROSWD    = BUFF(18,IMATTR)
       AL        = BUFF(19,IMATTR)
       ALF       = BUFF(20,IMATTR)
       BRA       = BUFF(21,IMATTR)
       BRB       = BUFF(22,IMATTR)
       BDEL      = BUFF(23,IMATTR)
       CP        = BUFF(24,IMATTR)
       A123      = BUFF(25,IMATTR)
       PRL       = BUFF(26,IMATTR)
       ECUT      = BUFF(27,IMATTR)
       ECUTEL    = BUFF(28,IMATTR)
       ECUTPH    = BUFF(29,IMATTR)
       ECUTPS    = BUFF(30,IMATTR)
       EDD       = BUFF(31,IMATTR)
       ECC       = BUFF(32,IMATTR)
       CIC02     = BUFF(33,IMATTR)
       BP0       = BUFF(34,IMATTR)
       TDD       = BUFF(35,IMATTR)
C
      IF(IPRO.GT.0) WRITE(6,2111) CUTB2,XX0,ABR1,ABR2,ALPPA1,ALPPA2
2111  FORMAT(' CUTB2,XX0,ABR1,ABR2,ALPPA1,ALPPA2 ',6E12.4)
      IF(IPRO.GT.0) WRITE(6,2112) ALPM,ALPBH,ACM,BGAM,AMEAN,ZMEAN
2112  FORMAT(' ALPM ALPBH ACM BGAM AMEAN ZMEAN   ',6E12.4)
      IF(IPRO.GT.0) WRITE(6,2113) XX0CM,ALPAN1,ALPAN0,PPB,CORPA0,PROSWD
2113  FORMAT(' XX0CM ALPAN1 ALPAN0 PPB CORPA0 PROSWD ',6E12.4)
      IF(IPRO.GT.0) WRITE(6,2114) AL,ALF,BRA,BRB,BDEL,CP
2114  FORMAT(' AL ALF BRA BRB BDEL CP                ',6E12.4)
      IF(IPRO.GT.0) WRITE(6,2115) A123,PRL,ECUT,ECUTEL,ECUTPH,ECUTPS
2115  FORMAT(' A123 PRL ECUT ECUTEL ECUTPH ECUTPS    ',6E12.4)
      IF(IPRO.GT.0) WRITE(6,2116) EDD,ECC,CIC02,BP0,TDD
2116  FORMAT(' EDD ECC CIC02 BP0 TDD                 ',5E12.4)
C
      CALL MVCL( TETBL0, 0, BTETB0(1,IMATTR), 0, 21*4)
      CALL MVCL( DTETBL, 0, BDTETB(1,IMATTR), 0, 20*4)
C     CALL MVCL( ELTBL , 0, BELTBL(1,IMATTR), 0, 200*4)
      CALL MVCL( ELOSEL, 0, BELTEL(1,IMATTR), 0, 200*4)
      CALL MVCL( ELOSPO, 0, BELTPO(1,IMATTR), 0, 200*4)
      CALL MVCL( ATETB0, 0, BATBT0(1,IMATTR), 0, 21*4)
CCC   WRITE(6,DMP)
C
5100   CONTINUE
      PATH=0.
      IER=0
      NSP=NP
        DO 20 K=1,NP
          DO 20 I=1,9
20      SPTCL(I,K)=PRTCL(I,K)
      NP=0
C
C*****     MAIN LOOP TO GENERATE SHOWER      *****
C
200   CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2252) NSP,SPTCL(1,NSP),SPTCL(2,NSP)
2252  FORMAT(' CASSHW MAIN LOOP : NSP AT 200 ',I4,' CHG0 ENE0 ',2F8.3)
C
      IF(NSP) 400,400,201
201   DO 210 I=1,9
210   PAQ0(I)=SPTCL(I,NSP)
      NSP=NSP-1
C
100   CONTINUE
      STH0=0.
      STH1 = 0.
      ECUT0=ECUTLS(CHG0+2.1)
C
C-----ECUT0 IS ECUT FOR THE PARTICLE IN PA0
C
      IF(IPRO.GT.0) WRITE(6,2253) NSP,ENE0,ECUT0,CHG0
2253  FORMAT(' CASSHW: NSP ENE0 ECUT0 CHG0 ',I4,3E12.4)
C
C  IF TOO LOW ENERGY, SKIP AND GET NEXT PARTICLE
C
      IF(ENE0.LE.ECUT0) GOTO 200
C
C  BRANCH ACCORDING TO CHARGE
C
      IF(CHG0) 2000,3000,2000
C
C********* ELECTRON AND POSITRON
C
 2000 CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2254) NSP
2254  FORMAT(' CASSHW: ENTERING EL. PART 2000 NSP: ',I5)
C
      CON=1.+A123/ENE0
      ALPBR1=ABR1*CON
      ALPBR2=ABR2*CON
      ALPMBH = ALPM
      ALPANH = 0.
C
      IF(CHG0.LT.0.) GO TO 1000
C
C                                     ****** POSITRONS  ******
C
C---- POSITRON ANNIHILATION
C
      ALPMBH = ALPBH
      ALPANH=ALPAN0*ENE0**(-0.77777)
C
       IF(ENE0.LT.ETHANH) ALPANH=
     &    ALPAN1/((ENE0+1.)*(ENE0**2-1.))
     &    *(    (ENE0**2+4.*ENE0+1.)
     &         *ALOG(ENE0+SQRT(ENE0**2-1.))
     &          -(ENE0+3.)*SQRT(ENE0**2-1.)  )
C
 1000 FAII=1./(ALPBR1+ALPBR2+ALPMBH+ALPANH)
 2001 T=-ALOG(RN(DAM))*FAII
C---- STARTING POSITION OF THE TRACK SEGMENT=POS0(1--3)
        DO 2203 I=1,3
 2203   POS0(I) =POS(I)
      ETMP=ENE0
C
      IF(IPRO.GT.0) WRITE(6,2291) ENE0,ECC
2291  FORMAT(' CASSHW: AFTER 2203 ENE0 ECC ',2E12.4)
C
      IF(ENE0.GT.ECC) GOTO 2201
C
      I=IFIX((ENE0-ECUT)/EDD)+1
      IF(I.GT.NRR)I=NRR
      TM=TETBL0(I)+( TETBL0(I+1)-TETBL0(I) )*
     &             ( (ENE0-ECUT)/EDD+FLOAT(1-I) )
C
C
      IF(IPRO.GT.0) WRITE(6,2292) T,TM
2292  FORMAT(' CASSHW: AT GO TO 2221, T TM ',2E12.4)
C
      IF(T.LE.TM) GOTO 2221
      T=TM
      TS=T*(1.-T/4.*(ENE0*ES/(ENE0**2-1.))**2)
C
      IF(IPRO.GT.0) WRITE(6,2293) TS
2293  FORMAT(' CASSHW: AT GO TO 22101 , TS',E12.4)
C
      IF(TS.LE.0.) GO TO 22101
        DO 2210 I=1,3
 2210   POS(I)=POS(I)+DIR(I)*TS
C
22101 CALL NEWDIR(DIR,AMSCAT(ENE0,T))
      ENE0=ECUT
      GOTO 2202
C
 2221 TS=T*(1.-T/4.*(ENE0*ES/(ENE0**2-1.))**2)
C
      IF(IPRO.GT.0) WRITE(6,2294) TS
2294  FORMAT(' CASSHW: AT GO TO 22131 , TS',E12.4)
C
      IF(TS.LE.0.) GO TO 22131
        DO 2213 I=1,3
 2213   POS(I)=POS(I)+DIR(I)*TS
22131 TRES=TM-T
      I=IFIX(TRES/TDD)+1
      CALL NEWDIR(DIR,AMSCAT(ENE0,T))
      ENE0=ATETB0(I)+(ATETB0(I+1)-ATETB0(I))*(TRES/TDD+FLOAT(1-I))
      GOTO 2202
C
2201  CONTINUE
      TS=T*(1.-T/4.*(ENE0*ES/(ENE0**2-1.))**2)
      IF(TS .LT. 0) TS = 0.
        DO 2211 I=1,3
 2211   POS(I)=POS(I)+DIR(I)*TS
      CALL NEWDIR(DIR,AMSCAT(ENE0,T))
      I=IFIX(ENE0-ECUT)+1
      IF(I.GT.NRR2)I=NRR2
C     ENE0=ENE0-T*ELTBL(I)
      IF(CHG0.LT.0.) ENE0=ENE0-T*ELOSEL(I)
      IF(CHG0.GT.0.) ENE0=ENE0-T*ELOSPO(I)
 2202 FLEN0=FLEN0+T
      IF(ENE0.GT.CHTHRE) PATH=PATH+T
C
      IF(IPRO.GT.0) WRITE(6,2295) PATH,T
2295  FORMAT(' CASSHW: AT 2202  PATH,T',2E12.4)
C
C     CALL CHKEL1(ETMP-ENE0)
C
C---- CERENKOV DATA FOR REAL DETECTOR
C
C    ENERGY STORAGE IN THE LEAD GLASS ARRAY IS DONE HERE. IF IN AL-ABS
C       THE ENERGY LOSS IS APPLIED ONLY
C       UNIT IS RADIATION LENGTH ON CALL
C
      IF(IPRO.GT.0) WRITE(6,2255) T,(POS0(IK),IK=1,3)
2255  FORMAT(' CASSHW:LSCCTC WITH T  POS0 ',4E12.4)
      IF(IPRO.GT.0) WRITE(6,2257) ((PA0(IK,IL),IK=1,3),IL=1,3)
2257  FORMAT(' PA0 ',9E12.4)
C
      CALL LSCCTC(POS0,PA0,T)
C
      IF(IPRO.GT.0) WRITE(6,2238) T,(POS0(IK),IK=1,3)
2238  FORMAT(' AFTER LSCCTC WITH T  POS0 ',4E12.4)
      IF(IPRO.GT.0) WRITE(6,2239) ((PA0(IK,IL),IK=1,3),IL=1,3)
2239  FORMAT('  PA0 ',9E12.4)
C
C
      BOUNDX = BOUND(PA0)
      IF(IPRO.GT.0) WRITE(6,2296) ENE0,ECUT0,BOUNDX
2296  FORMAT(' CASSHW: AT LSCCTC,ENE0 ECUT0 BOUND(PA0) ',3E12.4)
C
      IF(ENE0-ECUT0) 200,200,2002
C---- CHECK BOUNDARIES
2002  IF(BOUND(PA0).LE.0.) GO TO 300
      IF(JBACK.GT.0) CALL BOUND2(JBACK,PA0,&300)
C
      IF(IPRO.GT.0) WRITE(6,2297) CHG0,ENE0
2297  FORMAT(' CASSHW: AT BOUND2  CHG0 ENE0 ',2E12.4)
C
      IF(CHG0.GT.0. .AND. ENE0. LE. 1.001) GO TO 2040
C
      CON=1.+A123/ENE0
      ALPBR1=ABR1*CON
      ALPBR2=ABR2*CON
      ALPANH = 0.
      IF(CHG0.LT.0.) GOTO 2003
C---- POSITRON ANNIHILATION
      ALPANH=ALPAN0*ENE0**(-0.77777)
C
C*********************
C
       IF(ENE0.LT.ETHANH) ALPANH=
     &    ALPAN1/((ENE0+1.)*(ENE0**2-1.))
     &    *(    (ENE0**2+4.*ENE0+1.)
     &         *ALOG(ENE0+SQRT(ENE0**2-1.))
     &          -(ENE0+3.)*SQRT(ENE0**2-1.)  )
C
2003  FAII=1./(ALPBR1+ALPBR2+ALPMBH+ALPANH)
      PR(1)=ALPBR1*FAII
      PR(2)=ALPBR2*FAII
      PR(3)=ALPMBH*FAII
      PR(4)=ALPANH*FAII
      I=IPRDIV(PR,4)
C
      IF(IPRO.GT.0) WRITE(6,2298) I
2298  FORMAT(' CASSHW: AT 2003   I ',I4)
C
      GOTO (2010,2020,2030,2040),I
 2010 CALL BREMS1(ENE0,EPSI)
C
      IF(IPRO.GT.0) WRITE(6,2299) EPSI
2299  FORMAT(' CASSHW: EPSI AFTER BREMS1 ',E12.4)
C
      IF(EPSI)2001,2001,11
 2020 CALL BREMS2(ENE0,EPSI)
C
      IF(IPRO.GT.0) WRITE(6,2301) EPSI
2301  FORMAT(' CASSHW: EPSI AFTER BREMS2 ',E12.4)
C
      IF(EPSI)2001,2001,11
C---- MOLLER OR BHABHA
 2030 IF(CHG0) 1030,1030,2130
C
C---- ELECTRON MOLLER
 1030 CALL M0LLER(ENE0,EPSI)
C
      IF(IPRO.GT.0) WRITE(6,2302) EPSI
2302  FORMAT(' CASSHW: EPSI AFTER M0LLER ',E12.4)
C
      IF(EPSI)2001,2001,2032
C
C---- POSITRON,BHABHA
 2130 CALL BHABHA(ENE0,EPSI)
C
      IF(IPRO.GT.0) WRITE(6,2303) EPSI
2303  FORMAT(' CASSHW: EPSI AFTER BHABHA ',E12.4)
C
      IF(EPSI)2001,2001,2032
C
 2032 CHG1=-1.
      ECUT1=ECUTEL
      EKIN0=ENE0-1.
      EKIN1=EPSI*EKIN0
      ENE1=EKIN1+1.
      C2TH1=EKIN1*(EKIN0+2.)/(EKIN0*(EKIN1+2.))
      CTH1=SQRT(C2TH1)
      STH1=0.
      IF(CTH1.LT.1.) STH1=SQRT(1.-C2TH1)
      EKINX=ENE0-ENE1
      C2TH0=EKINX*(EKIN0+2.)/(EKIN0*(EKINX+2.))
      CTH0=SQRT(C2TH0)
      STH0=0.
      IF(CTH0.LT.1.) STH0=SQRT(1.-C2TH0)
      ENE0 = ENE0-EKIN1
C
      IF(IPRO.GT.0) WRITE(6,2304) ENE0
2304  FORMAT(' CASSHW: ENE0 AT GO TO 13 ',E12.4)
C
      GO TO 13
C
C---- ANNIHILATION
 2040 CHG0=0.
      CHG1=0.
      ECUT0=ECUTPH
      ECUT1=ECUTPH
      ENE0=ENE0+1.
      ENE1=ENE0*0.5*(RN(DAM)+RN(CON))
      FLEN0=0.
C
      IF(IPRO.GT.0) WRITE(6,2256) T,ENE0
2256  FORMAT(' CASSHW: EL AT ANNIHIL. , LEAVING TO 12, T ENE0  ',2E12.4)
C
      GO TO 12
C
C*******PHOTON
C
3000  CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2258) NSP,ENE0,ECCOM1
2258  FORMAT(' CASSHW: ENTERING PHOTON, NSP  ENE0 ECCOM1  ',I5,2E12.4)
C
      IF(ENE0.GE.ECCOM1)GOTO 3301
      CON=(ENE0-ECUTPH)/EDCOM1
      I=IFIX(CON)+1
      IF(I.GT.NRCM1)I=NRCM1
      ALOGEN=ALTBL(I)+(ALTBL(I+1)-ALTBL(I))*(CON+FLOAT(1-I))
      GOTO 3302
 3301 CONTINUE
C     CON=ENE0-ECUTP
C     I=IFIX(CON)+1
C     IF(I.GT.NRCM2)I=NRCM2
C     ALOGEN=ALTBL2(I)+(ALTBL2(I+1)-ALTBL2(I))*(CON+FLOAT(1-I))
       ALOGEN=ALOG(1.+2.*ENE0)
3302  ALPCOM=ACM*ALOGEN/ENE0
      CORPA=CORPA0*ALOG(ENE0)/ENE0
       ALPPHE=PPB*(BPHE1+BPHE2/ENE0+BPHE3/ENE0**2)/ENE0
C
C
      IF(IPRO.GT.0) WRITE(6,2278) ENE0,PAIRTH,ALPPHE
2278  FORMAT(' CASSHW: AT 3500: ENE0 PAIRTH ALPPHE ',3E12.4)
C
      IF(ENE0-PAIRTH) 3500,3500,3501
 3500 EALPA1 = 0.
      EALPA2 = 0.
      ECORPA = 0.
      GO TO 3600
 3501 EALPA1 = ALPPA1
      EALPA2 = ALPPA2
      ECORPA = CORPA
C
      ELPPHE=0.
      IF(ENE0.GT.PETH) ELPPHE=ALPPHE
C
 3600 FAII=1./(EALPA1+EALPA2+ALPCOM+ECORPA+ELPPHE)
3001  ALGARG = RN(DAM)
      T=-ALOG(ALGARG)*FAII
C
      IF(IPRO.GT.0) WRITE(6,2279) T
2279  FORMAT(' CASSHW: AT 3001: T  ',E12.4)
C
      POSREM = POS(1)
3201    DO 3211 I=1,3
3211    POS(I)=POS(I)+DIR(I)*T
C
      IF(IPRO.GT.0) WRITE(6,2305) (POS(IK),IK=1,3)
2305  FORMAT(' CASSHW: LOOP 3211  POS ',3E12.4)
C
      FLEN0=FLEN0+T
C*************************
C
C
      BOUNDP = BOUND(PA0)
      IF(IPRO.GT.0) WRITE(6,2280) ENE0,ECUTPH,BOUNDP
2280  FORMAT(' CASSHW: AT 3002: ENE0 ECUTPH BOUND(PA0) ',3E12.4)
C
      IF(ENE0-ECUTPH) 200,200,3002
3002  CONTINUE
C
      IF(BOUND(PA0).LE.0..AND.IPRO.NE.0) WRITE(6,3345)
     $ NSP,PA0(1,2),BOUNDP,T,FAII,PA0(1,3),ALGARG,POSREM
3345  FORMAT(' CASSHW: NSP P12 BND T FAII DIR RN POSR',I4,7E12.4)
C
      IF(BOUND(PA0).LE.0.) GOTO 300
      IF(JBACK.GT.0) CALL BOUND2(JBACK,PA0,&300)
      PR(1)=EALPA1*FAII
      PR(2)=EALPA2*FAII
      PR(3)=ALPCOM*FAII
      PR(4)=ECORPA*FAII
      PR(5)=ELPPHE*FAII
      I=IPRDIV(PR,5)
C
      IF(IPRO.GT.0) WRITE(6,2281) I
2281  FORMAT(' CASSHW: AT 3002: I=IPRDIV ',I5)
C
      GOTO(3010,3020,3030,3400,3050),I
3010  CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2307) ENE0,PAIRTH
2307  FORMAT(' CASSHW: AT 3010  ENE0 PAIRTH ',2E12.4)
C
      IF(ENE0-PAIRTH)3001,3001,3011
3011  CALL PAIRC1(ENE0,EPSI)
C
      IF(IPRO.GT.0) WRITE(6,2308) ENE0,EPSI
2308  FORMAT(' CASSHW: AFTER PAIRC1  ENE0 EPSI ',2E12.4)
C
      IF(EPSI)3001,3001,3004
3020  CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2310) ENE0,PAIRTH
2310  FORMAT(' CASSHW: AT 3020   ENE0 PAIRTH ',2E12.4)
      IF(ENE0-PAIRTH)3001,3001,3021
3021  CALL PAIRC2(ENE0,EPSI)
C
      IF(IPRO.GT.0) WRITE(6,2309) ENE0,EPSI
2309  FORMAT(' CASSHW: AFTER PAIRC2  ENE0 EPSI ',2E12.4)
C
      IF(EPSI)3001,3001,3004
C
C****** A(Z)*ALOG(K0)/K0 CORRECTION ******
C
3400  CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2311) ENE0,PAIRTH
2311  FORMAT(' CASSHW: AT 3400   ENE0 PAIRTH ',2E12.4)
C
      IF(ENE0-PAIRTH)3001,3001,3401
C   DIFFERENTIAL CROSS SECTION IS UNIFORM DISTRIBUTION
3401  EPSI=(1.-2./ENE0)*RN(DAM)+1./ENE0
C
3004  CHG1=1.
      CHG0=-1.
      ECUT0=ECUTEL
      ECUT1=ECUTPS
C
C----- TEMP.  CONVERSION POINT DISTRIBUTION
C      CALL CONPHS(PAQ0)
C
      FLEN0=0.
C
      IF(IPRO.GT.0) WRITE(6,2282)
2282  FORMAT(' CASSHW: AT 3030: GO TO 19 ')
C
      GO TO 19
C
3030  CALL COMPT(ENE0,ALOGEN,EPSI)
C
      IF(IPRO.GT.0) WRITE(6,2312) ENE0,EPSI
2312  FORMAT(' CASSHW: AFTER COMPT ENE0 EPSI ',2E12.4)
C
      IF(EPSI) 3001,3001,38
C
   38 CHG1=-1.
      ECUT1=ECUTEL
      ENEX=ENE0*EPSI
      CTH0=1.-1./ENEX+1./ENE0
      STH0=SQRT(1.-CTH0*CTH0)
      ENE1=ENE0-ENEX+1.
      PE=SQRT(ENE1*ENE1-1.)
C
      IF(IPRO.GT.0) WRITE(6,2313) PE
2313  FORMAT(' CASSHW: AT 38  PE             ',2E12.4)
C
      IF(PE.LE.0.)GOTO 3037
      CTH1=(ENE0-ENEX*CTH0)/PE
      IF(CTH1.GT.1.)CTH1=1.
      STH1=SQRT(1.-CTH1*CTH1)
3037  ENE0=ENE0+1.
C---- TEMP. PHOTON PATH LENGTH HIST.
C     CALL CONPHS(PAQ0)
C
C
      IF(IPRO.GT.0) WRITE(6,2283)
2283  FORMAT(' CASSHW: AT 3037: GO TO 12 ')
C
      GO TO 12
C
C---- PHOTO-ELECTRIC EFFECT
3050  CONTINUE
C     CALL CONPHS(PAQ0)
C
      CHG0 = -1.
      ECUT0=ECUTEL
      ENE0 = ENE0+0.82
      FLEN0 = 0.0
      CTH0 = 2.*(RN(DUM)-0.5)
      STH0 = SQRT(1.-CTH0**2)
      CALL RANAZI(CF,SF)
      PAQ0(7) = CF*STH0
      PAQ0(8) = SF*STH0
      PAQ0(9) = CTH0
C
      IF(IPRO.GT.0) WRITE(6,2284)
2284  FORMAT(' CASSHW: AFTER PHOTOEL EFF.  : GO TO 100')
C
      GO TO 100
C
C*******NOW SECONDARY PARTICLE IS IN PA1
C
11    CONTINUE
C
      CHG1=0.
      ECUT1=ECUTPH
19    ENE1=ENE0*EPSI
12    CONTINUE
      ENE0=ENE0-ENE1
13    DO 4010 I=4,9
4010  PAQ1(I)=PAQ0(I)
C
C---- GET NEWDIRECTIONS BY M0LLER/BHABHA/COMPTON SCATTERINGS**
C
      IF(IPRO.GT.0) WRITE(6,2314) ENE0,STH0,STH1
2314  FORMAT(' CASSHW: AT 4010 ENE0 STH0-1   ',3E12.4)
C
      IF(STH0.EQ.0. .AND. STH1.EQ.0.) GO TO 4110
      CALL RANAZI(CF,SF)
      IF(STH0.NE.0.) CALL NEWDR2(PA0(1,3),CTH0,STH0,CF,SF)
C
4100  CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2315) STH1,ENE1,ECUT1
2315  FORMAT(' CASSHW: AT 4100 STH1 ENE1 ECUT1  ',3E12.4)
C
      IF(STH1)4111,4110,4111
C---- SKIP LOW ENERGY SECONDARIES TO SAVE BUFFER SPACE AND TIME.
 4111 IF(ENE1 .LE. ECUT1) GOTO 100
      CF=-CF
      SF=-SF
      CALL NEWDR2(PA1(1,3),CTH1,STH1,CF,SF)
4110   CONTINUE
      FLEN1=0.
C**************
C     ***PA1 IS ALWAYS STACKED
      IF(NSP.LT.0)NSP=0
      NSP=NSP+1
C
      IF(IPRO.NE.0) WRITE(6,2316) NSP,MNP
2316  FORMAT(' CASSHW: AT 4210 NSP MNP ',2I5)
C
      IF(NSP.GT.MNP)GO TO 4202
      DO 4210 I=1,9
4210  SPTCL(I,NSP)=PAQ1(I)
C---- CHECK THE MAXIMUM NSP
C     DATA MAXNSP/10/
C     IF(NSP.LE.MAXNSP) GO TO 100
C     MAXNSP = NSP
C     IF(NSP.GT.200.OR.MOD(NSP,10).EQ.0) WRITE(6,6000) MAXNSP
C6000 FORMAT(' MAXNSP NEW MAXIMUM=',I4)
C
      IF(IPRO.GT.0) WRITE(6,2286)
2286  FORMAT(' CASSHW: AT MAXNSP, GO TO 100')
C
      GO TO 100
4202  IER=2
CCCCC CALL MSG('PRTLC OVERFLOW- IER=1;;')
      GO TO 301
C**************
C
C THIS PARTICLE OUT OF THE MATTER
300   NP=NP+1
C
      IF(IPRO.NE.0) WRITE(6,2287) NP,MNP
2287  FORMAT(' CASSHW: AT OUT OF MATTER 300  NP MNP ',2I5)
C
      IF(NP.GT.MNP)GOTO 301
      DO 310 I=1,9
310   PRTCL(I,NP)=PAQ0(I)
C
C           CALL CHKEL(PA0)
      GOTO 200
C
301   IER=1
      RETURN
400   NSP=0
C
      IF(IPRO.NE.0) WRITE(6,2259)
2259  FORMAT(' CASSHW: LEAVING WITH NSP=0 ')
C
      RETURN
      END

C   07/06/96 606071858  MEMBER NAME  NEWOLD1  (S4)          FORTRAN
      SUBROUTINE BCFILE(LUN,NRECA,NBLOCK,IPASS,IOPT)
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
C
C     IUND   =   UNIT
C     INDT   =   INDEX OF DIRECTOTY ENTRY
C     INDC   =   INDEX OF BANK TO BE COPIED
C     NPTR   =   RECORD NR WITH DATA
C     INDA   =   INDEX OF MASTER DIRECTORY BANK
C     LISTE  =   NAME, NR, DATA RECORD NR, NR OF WORDS
C     IPAS   =   PASSWORD
C     NDAREC =   NR OF WORDS/RECORD
C
      REAL*8 DATE(2)
      INTEGER IOPNEW/3HNEW/,IOPOLD/3HOLD/,IOP0LD/3H0LD/,DIRA/4H+DIR/
C
C     FORMAT AND CONTENT OF MASTER DIRECTORY RECORD (RECORD NR 1)
C
C     INDEX      CONTENT
C     ---------- ----------------
C         1      = 49
C         2      = 'DIRA'
C         3      = 0
C         4      = 0
C         5      = 45
C         6      TOTAL NR OF RECORDS
C         7      NR OF USED RECORD
C         8      NPRIME FOR HASH FUNCTION
C         9      = 0 OR NAME OF ADDED/CHANGED BANK
C        10      = 0 OR NR OF ADDED/CHANGED BANK
C        11      NR OF WORDS/RECORD
C        12      = 0 OR (DAY) TIME OF UPDATE IN 1/100 SEC
C        13
C        14
C        15
C        16
C        17
C        18
C        19      (PASSWORD)
C        20      = 0 CHANGES ALLOWED, = 1 CHANGES NOT ALLOWED
C     21-24      DATE/TIME OF LAST LOAD
C     25-28      DATE/TIME OF LAST UPDATE
C     29-32      DATE/TIME OF LAST UNLOAD
C        33      NR OF BANKS AT LAST LOAD
C        34      NR OF BANKS AT LAST UPDATE
C        35      NR OF BANKS AT LAST UNLOAD
C         .
C        50
C     ---------- ----------------
C        51      PRINTOUT COUNTER
C        52
C
C
C
C     FORMAT AND CONTENT OF DIRECTORY RECORDS (RECORD NRS 2, 3 ...)
C
C     INDEX      CONTENT
C     ---------- ----------------
C         1      = 4 + 3*NE        FOR NE ENTRIES
C         2      = 'DIRA'
C         3      = 0
C         4      = 0
C     ---------- ----------------
C         5      NAME
C         6      NR
C         7      NR OF DATA RECORD
C         8      NR OF WORDS
C         9      NAME ETC
C        10
C        11
C        12
C        13
C        14
C        15
C
      NREC=NRECA
      IOP=0
      IF(IOPT.EQ.IOPNEW) IOP=1
      IF(IOPT.EQ.IOPOLD) IOP=2
      IF(IOPT.EQ.IOP0LD) IOP=2
      CALL DAY(DATE(1),DATE(2))
      IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,NREC,NBLOCK,IPASS,IOPT
      IF(IOP.EQ.0) GOTO 201
      IUND=LUN
      IPAS=IPASS
      IF(IOP.EQ.1) GOTO  10
C
C     OLD DATA SET / CHECK NR OF RECORDS AND NR OF WORDS/RECORD
C
      CALL DIDA(0,LISTE,1)
C
C     'OLD BOS' DATA SET IS INDICATED BY NREC=-1610
C
      IF(NREC+1610.EQ.0) NREC=IW(INDA+6)
      IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,NREC,NBLOCK,IPASS,IOPT
      IF(IW(INDA+6).NE.NREC)    GOTO 203
      IF(IW(INDA+11).NE.NBLOCK) GOTO 203
      IF(IW(INDA+20).NE.0)      GOTO 203
      IW(INDA+34)=0
      GOTO 12
C
C     DETERMINE PRIME NUMBER FOR HASH SEARCH ALGORITHM
C
   10 IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,NREC,NBLOCK,IPASS,IOPT
      INDA=IBANK(4H+DIR,IUND,2HDL)
      INDA=IBANK(4H+DIR,IUND,52)
      IF(INDA.EQ.0) GOTO 204
   12 NPRIME=NREC/20
      IF(NPRIME.LE.5) NPRIME=5
      NPRIME=(NPRIME/2)*2+1
      NPRIME=NPRIME-2
   14 NPRIME=NPRIME+2
      A=NPRIME
      J=SQRT(A)
      DO 16 K=3,J,2
      NDIV=NPRIME/K
      IF(NDIV*K.EQ.NPRIME) GOTO 14
   16 CONTINUE
C
C     INITIAL DEFINITION OF THE FIRST RECORD
C
      IW(INDA+1)=4
      IW(INDA+2)=DIRA
      IW(INDA+3)=0
      IW(INDA+4)=0
      IW(INDA+5)=0
      IW(INDA+6)=NREC
      IW(INDA+7)=NPRIME+2
      IW(INDA+8)=NPRIME
      IW(INDA+9)=0
      IW(INDA+10)=0
      IW(INDA+11)=NBLOCK
      IW(INDA+19)=IPASS
      CALL DAY(DATE(1),DATE(2))
      CALL UCOPY(DATE,IW(INDA+21),4)
      IF(IOP.EQ.1) CALL UCOPY(DATE,IW(INDA+25),4)
      IF(IOP.EQ.1) CALL UCOPY(DATE,IW(INDA+29),4)
C
C     WRITE EMPTY DIRECTORY RECORDS
C
      DO 18 K=1,NPRIME
      IW(INDA+3)=K+1
   18 CALL WRDA(K+1,IW(INDA+1),IW(INDA+2))
C
C     WRITE EMPTY NEXT RECORD
C
      IW(INDA+1)=0
      CALL WRDA(NPRIME+2,IW(INDA+1),IW(INDA+2))
C
C     DEFINE AND WRITE MASTER DIRECTORY RECORD
C
      IW(INDA+1)=49
      IW(INDA+3)=0
      IW(INDA+5)=45
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
C
C     MAKE PRINTOUT AND DELETE MASTER DIRECTORY BANK
C
      INDA=IBANK(4H+DIR,IUND,2HDL)
      IPAS=IPASS
      CALL DIDA(0,LISTE,1)
      CALL BGAR(IGA)
C
C
C
  100 RETURN
  101 FORMAT('0---- DIR-UNIT',I3,9X,'INITIALIZE/CLEAR',I8,' RECORDS *',
     1   I5,' WORDS, PASSWORD = ',A4,'   OPTION = ',A4,4X,'(BCFILE)')
C
C     ILLEGAL ARGUMENT IN BCFILE
C
  201 CALL BDMPA(201)
C
C     DIFFERENCE IN DATA SET
C
  203 CALL BDMPA(203)
C
C     INSUFFICIENT SPACE FOR DIRECTORY BANK
C
  204 CALL BDMPA(204)
      GOTO 100
      END
      SUBROUTINE BPWDIR(LUN,IPASS)
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      IND=IBANK(4H+DIR,LUN,2HDL)
      IUND=LUN
      IPAS=IPASS
      CALL DIDA(0,LISTE,1)
  100 RETURN
      END
      FUNCTION INDDIR(NAME,NR,IUNIT,IOPT)
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      REAL*8 DATE(2)
      INTEGER IPR/0/,IOPTL(4)/2HFE,2HDL,2HST,2HFU/,NAMUN/4H+U00/
C
C     DIRECT ACCESS FUNCTION
C
      INDDIR=0
      IUND=IUNIT
      DO 10 IOP=1,4
      IF(IOPT.EQ.IOPTL(IOP)) GOTO 12
   10 CONTINUE
      GOTO 100
   12 LISTE(1)=NAME
      LISTE(2)=NR
      IF(IOP.EQ.4) GOTO 20
      IF(IOP-2) 20,30,40
C
C     FETCH FROM DIRECT ACCESS DATA SET
C
   20 INDC=ILINK(LISTE(1),LISTE(2))
      IF(INDC.NE.0) GOTO 90
      CALL DIDA(1,LISTE,1)
      IF(INDT.EQ.0) GOTO 100
      IF(IOP.NE.4) GOTO 26
   22 IND=IBLN(LISTE(1))
      IND=IW(IND)
      IF(IND.EQ.0) GOTO 26
      IF(IW(IND-1).EQ.0) GOTO 24
      IND=IBANK(LISTE(1),IW(IND-2),'DL')
      GOTO 22
   24 IND=ILINK(LISTE(1),IW(IND-2))
      IF(IW(IND).NE.LISTE(4)) GOTO 25
      INDC=IBANK(LISTE(1),LISTE(2),'RN')
      GOTO 28
   25 IND=IBANK(LISTE(1),IW(IND-2),'DL')
   26 INDC=IBANK(LISTE(1),LISTE(2),LISTE(4))
   28 IF(INDC.EQ.0) GOTO 100
      CALL DAFR(1)
      GOTO 90
C
C     DELETE BANK ON DIRECT ACCESS DATA SET
C
   30 JD=-1
C
C     MAKE SURE DIRECTORY BANK IS THERE AND CHECK PASSWORD
C
      CALL DIDA(0,LISTE,1)
      IF(IW(INDA+20).NE.0) GOTO 100
C
C     RESERVE DATA SET EXCLUSIVELY
C
      CALL DIDA(-1,LISTE,1)
C
C     CHECK, THAT BANK TO BE DELETED IS THERE
C
      CALL DIDA(1,LISTE,1)
      IF(INDT.NE.0) GOTO 35
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      GOTO 100
   35 NPTR=IW(INDT+3)
C
C     DELETE BANK ON DATA SET AND IN DIRECTORY
C
      CALL DAFR(2)
      CALL DIDA(2,LISTE,1)
C
C     UPDATE BANK COUNTER AND PRINT
C
      IW(INDA+51)=IW(INDA+51)+1
      IF(NUNTB.EQ.0) GOTO 70
      IF(IW(INDA+51).LE.100) WRITE(NUNTB,104) IUND,LISTE(1),LISTE(2)
      IF(IW(INDA+51).EQ.100) WRITE(NUNTB,109) IUND
      GOTO 70
C
C     STORE BANK ON DIRECT ACCESS DATA SET
C
   40 JD=1
      INDC=ILINK(LISTE(1),LISTE(2))
      IF(INDC.EQ.0) GOTO 85
      IF(IW(INDC).LE.0) GOTO 85
      IF(IW(INDC).GT.3200) GOTO 85
C
C     MAKE SURE DIRECTORY BANK IS THERE AND CHECK PASSWORD
C
      CALL DIDA(0,LISTE,1)
      IF(IW(INDA+20).NE.0) GOTO 100
C
C     RESERVE DATA SET EXCLUSIVELY
C
      CALL DIDA(-1,LISTE,1)
C
C     SEARCH DIRECTORY FOR BANK
C
      CALL DIDA(1,LISTE,1)
C
C     CHECK TOTAL SPACE ON DATA SET
C
      IF(IW(INDA+7)+2+IW(INDC)/NDAREC.GT.IW(INDA+6)) GOTO 201
      ICO=1
      IF(INDT.EQ.0) GOTO 50
C
C     BANK IS ALREADY ON DATA SET
C
      IW(INDA+34)=IW(INDA+34)-1
      ICO=2
      IF(IW(INDC).EQ.LISTE(4)) GOTO 52
C
C     DELETE BANK ON DATA SET AND IN DIRECTORY
C
      CALL DAFR(2)
      CALL DIDA(2,LISTE,1)
C
C     ADD BANK TO DATA SET AND DIRECTORY
C
   50 CALL DAFR(3)
      CALL DIDA(3,LISTE,1)
      GOTO 54
C
C     INSERT BANK IN SAME PLACE ON DATA SET
C
   52 CALL DAFR(4)
C
C     UPDATE COUNTER AND PRINT
C
   54 IW(INDA+51)=IW(INDA+51)+1
      IF(IW(INDA+51).GT.100) GOTO 70
      GOTO (60,62),ICO
   60 IF(NUNTB.NE.0) WRITE(NUNTB,102) IUND,LISTE(1),LISTE(2)
      GOTO 64
   62 IF(NUNTB.NE.0) WRITE(NUNTB,103) IUND,LISTE(1),LISTE(2)
   64 IF(IW(INDA+51).EQ.100.AND.NUNTB.NE.0) WRITE(NUNTB,109) IUND
C
C     UPDATE FIRST DIRECTORY RECORD AND FREE DATA SET
C
   70 CALL DAY(DATE(1),DATE(2))
      CALL UCOPY(DATE,IW(INDA+25),4)
      IW(INDA+34)=IW(INDA+34)+JD
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
C
C     TWO ADDITIONAL WRITES TO FORCE BUFFER TO BE WRITTEN
C
      CALL WRDA(IW(INDA+6)-1,IW(INDA+1),IW(INDA+2))
      CALL WRDA(IW(INDA+6)  ,IW(INDA+1),IW(INDA+2))
C
C     UPDATE NRDIR BANK
C
      NAMUNT=NAMUN+(IUND/10)*256+MOD(IUND,10)
      IND=ILINK(NAMUNT,LISTE(1))
      IF(IND.EQ.0) GOTO 100
      NW=IW(IND+3)
      IF(NW.GT.3) GOTO 72
      IF(IOP.EQ.2) GOTO 100
      IW(IND+3)=4
      IW(IND+4)=LISTE(2)
      GOTO 100
   72 IF(LISTE(2).LT.IW(IND+4)) GOTO 74
      IF(IOP.EQ.2) GOTO 100
      IW(IND+1)=4
      GOTO 100
   74 DO 76 I=1,NW
      IF(IW(IND+I)-LISTE(2)) 76,78,79
   76 CONTINUE
      IF(IOP.EQ.2) GOTO 100
      IW(IND+2)=NW
      GOTO 100
   78 IF(IOP.EQ.3) GOTO 100
      IF(NW-I.GT.0) CALL UCOPY2(IW(IND+I+1),IW(IND+I),NW-I)
      IW(IND+3)=NW-1
      GOTO 100
   79 IF(IOP.EQ.2) GOTO 100
      IF(NW-I.GT.0) CALL UCOPY2(IW(IND+I),IW(IND+I+1),NW-I)
      IW(IND+I)=LISTE(2)
      IW(IND+2)=NW
      GOTO 100
C
C     PRINT OUT
C
   85 IPR=IPR+1
      IF(IPR.GT.100) GOTO 100
      IF(NUNTB.EQ.0) GOTO 100
      IF(JD.EQ.1) WRITE(NUNTB,107) IW(INDC-3),IW(INDC-2),IW(INDC)
      IF(JD.NE.1) WRITE(NUNTB,108) NAME,NR
      GOTO 100
C
C
   90 INDDIR=INDC
  100 RETURN
C
C     DATA SET SPACE LIMIT REACHED
C
  201 CALL BDMPA(201)
      GOTO 100
  102 FORMAT(' ---- UNIT',I3,' / INDDIR',5X,'BANK (',A4,',',I10,')',1X,
     1   'STORED')
  103 FORMAT(' ---- UNIT',I3,' / INDDIR',5X,'BANK (',A4,',',I10,')',1X,
     1   'REPLACED')
  104 FORMAT(' ---- UNIT',I3,' / INDDIR',5X,'BANK (',A4,',',I10,')',1X,
     1   'DELETED')
  107 FORMAT('0---- INDDIR     UNABLE TO STORE BANK (',A4,',',I10,
     1   ')',I10,' WORDS')
  108 FORMAT('0---- INDDIR     UNABLE TO DELETE BANK (',A4,',',I10,')')
  109 FORMAT(' ---- UNIT',I3,' / INDDIR PRINTOUT SUPPRESSED')
      END
      FUNCTION NRDIR(NAME,NR,IUNIT,IOPT)
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      INTEGER NAMUN/4H+U00/,IOPTL(5)/2HEQ,2HLE,2HLT,2HGE,2HGT/
      NRDIR=0
      IUND=IUNIT
      DO 10 IOP=1,5
      IF(IOPT.EQ.IOPTL(IOP)) GOTO 12
   10 CONTINUE
      GOTO 100
C
C
C
   12 NAMUNT=NAMUN+(IUNIT/10)*256+MOD(IUNIT,10)
      NAMELK=NAME
      NRLK  =NR
      IND=ILINK(NAMUNT,NAMELK)
      IF(IND.EQ.0) GOTO 16
      IF(IW(IND+1).NE.0.AND.NRLK.LT.IW(IND+ 4)) GOTO 16
   13 NW=IW(IND+3)
      IF(IW(IND+2).NE.0.AND.NRLK.GT.IW(IND+NW)) GOTO 16
      IF(NW.LT.4) GOTO 16
      DO 14 I=4,NW
      IF(IW(IND+I)-NRLK) 14,90,92
   14 CONTINUE
      I=NW+1
      GOTO 92
C
C     TRY TO FIND BANK OR NEIGHBOUR DIRECTLY
C
   16 LISTE(1)=NAMELK
      LISTE(2)=NRLK
      CALL DIDA(1,LISTE,1)
      IF(INDT.EQ.0) GOTO 19
      IF(IOP.EQ.3.OR.IOP.EQ.5) GOTO 18
      NRDIR=NRLK
      GOTO 100
   18 IF(IOP.EQ.3) LISTE(2)=LISTE(2)-1
      IF(IOP.EQ.5) LISTE(2)=LISTE(2)+1
      CALL DIDA(1,LISTE,1)
      IF(INDT.EQ.0) GOTO 19
      NRDIR=LISTE(2)
      GOTO 100
C
C
C
   19 NPRIME=IW(INDA+8)
      NFIND=NPRIME/3+5
      NWD=3+8*NFIND
      IND=IBANK(NAMUNT,NAMELK,NWD)
      IF(IND.EQ.0) GOTO 201
C
C     READ ALL DIRECTORY RECORDS AND STORE NUMBERS
C
      LB=3
      ICHA=0
      ICHB=0
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 201
      JREC=1
   20 JREC=JREC+1
      IF(JREC.GT.NPRIME+1) GOTO 24
      NREC=JREC
   22 CALL RDDA(NREC,NDAREC,IW(IA))
      NREC=IW(IA+3)
      K=IA+4
      N=IW(K)/4
      IF(N.EQ.0) GOTO 32
      DO 30 I=1,N
      IF(IW(K+1).NE.NAMELK) GOTO 30
      IF(ICHA.NE.0.AND.IW(K+2).LT.IW(IND+ICHA)) GOTO 30
      IF(ICHB.NE.0.AND.IW(K+2).GT.IW(IND+ICHB)) GOTO 30
      LB=LB+1
      IW(IND+LB)=IW(K+2)
      IF(LB.NE.NWD) GOTO 30
   24 IF(LB.EQ.3) GOTO 100
C
C     SORT NUMBERS
C
      CALL SORTAE(IW(IND+4),1,LB-3,1,0)
      DO 26 L=4,LB
      IF(IW(IND+L).GE.NRLK) GOTO 28
   26 CONTINUE
      L=LB
   28 IF(L-NFIND.GE.4)    ICHA=4
      LA=MAX0(4,L-NFIND)
      LB=MIN0(LB,L+3*NFIND)
      CALL UCOPY2(IW(IND+LA),IW(IND+4),LB-LA+1)
      IF(L+3*NFIND.LE.LB) ICHB=4+LB-LA
      LB=4+LB-LA
      IF(JREC.GT.NPRIME+1) GOTO 40
C
C
C
   30 K=K+4
   32 IF(NREC.EQ.0) GOTO 20
      GOTO 22
C
C
C
   40 IW(IND+1)=ICHA
      IW(IND+2)=ICHB
      IW(IND+3)=LB
      IF(LB.LE.3) LB=4
      IND=IBANK(NAMUNT,NAMELK,LB)
      IF(IND.EQ.0) GOTO 201
      GOTO 13
C
C
C
   90 IF(IOP.EQ.3) I=I-1
      IF(IOP.EQ.5) I=I+1
      GOTO 94
   92 IF(IOP.EQ.1) GOTO 100
      IF(IOP.LE.3) I=I-1
   94 IF(I.GE.4) GOTO 96
      IF(IW(IND+1)) 16,100,16
   96 IF(I.LE.IW(IND+3)) GOTO 98
      IF(IW(IND+2)) 16,100,16
   98 NRDIR=IW(IND+I)
C
C
C
  100 RETURN
C
C     ERROR - NOT ENOUGH SPACE FOR FIND BANK
C
  201 CALL BDMPA(47)
      GOTO 100
      END
      SUBROUTINE BFTDIR(LUN,LUN1,IOPT)
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      REAL*8 DATE(2)
      INTEGER IOPFR/2HFR/,IOPTO/2HTO/,IOPT0/2HT0/,BLANK/4H    /
      INTEGER DIRA/'+DIR'/,DIRO/'DIRA'/
      CALL DAY(DATE(1),DATE(2))
      IOP=0
      IF(IOPT.EQ.IOPFR) IOP=1
      IF(IOPT.EQ.IOPTO) IOP=2
      IF(IOPT.EQ.IOPT0) IOP=2
      IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,LUN1,IOPT
      IF(IOP.EQ.0) GOTO 201
      IUND=LUN
      CALL DIDA(0,LISTE,1)
      IF(INDA.EQ.0) GOTO 202
      IF(IOP.NE.1)  GOTO 20
C
C     OPTION FR=FROM
C
      IF(IW(INDA+34).NE.0) GOTO 201
      IF(IW(INDA+20).EQ.1) GOTO 201
C
C
C
      INDL=IBANK(4H+DIR,-1,2000)
      IF(INDL.EQ.0)     GOTO 201
      INDB=IBANK(4H+DIR,-2,3204)
      IF(INDB.EQ.0)     GOTO 201
      NREC=IW(INDA+6)
      NBK=0
      N=0
      NCT=0
      NERR=0
C
C     READ SEQUENTIAL DATA SET
C
      IF(LUN1.EQ.0) GOTO 18
   10 CALL RDSQ(LUN1,NTOT,IW(INDB+1),&16)
      NCT=NCT+1
      IF(NTOT.LE.0.OR.NTOT.GT.3204) GOTO 12
      IF(NTOT-4.NE.IW(INDB+4)) GOTO 12
      GOTO 14
   12 NERR=NERR+1
      GOTO 10
   14 IF(NCT.EQ.0) GOTO 16
      LISTE(1)=IW(INDB+1)
      LISTE(2)=IW(INDB+2)
      LISTE(3)=0
      LISTE(4)=IW(INDB+4)
      LISTE(5)=2+MOD(IABS(LISTE(1)+LISTE(2)),IW(INDA+8))
      INDC=INDB+4
      CALL DAFR(3)
      CALL UCOPY2(LISTE,IW(INDL+5*N+1),5)
      NBK=NBK+1
      N=N+1
      IF(N.LT.400) GOTO 10
   16 IF(N.EQ.0) GOTO 18
      CALL SORTAE(IW(INDL+1),5,N,5,0)
      CALL DIDA(3,IW(INDL+1),N)
      IF(N.NE.400) GOTO 18
      N=0
      GOTO 10
   18 IW(INDA+33)=NBK
      IW(INDA+34)=NBK
      IW(INDA+35)=NBK
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      NCT=NCT-NERR
      IND =IBANK(4H+DIR,-2,2HDL)
      IND =IBANK(4H+DIR,-1,2HDL)
      IPAS=IW(INDA+19)
      INDA=IBANK(4H+DIR,IUNDA,2HDL)
      CALL DIDA(0,LISTE,1)
      CALL BGAR(IGA)
      IF(NUNTB.NE.0) WRITE(NUNTB,102) LUN,NCT,NERR
      IF(LUN1.NE.0) REWIND LUN1
      GOTO 100
C
C     OPTION TO
C
   20 NPAGL=200
      IPAS=0
      INDA=ILINK(4H+DIR,IUND)
      IF(INDA.NE.0) IPAS=IW(INDA+19)
      INDA=IBANK(4H+DIR,IUND,2HDL)
      CALL BGAR(IGA)
C
C     DETERMINE NUMBER OF RECORDS
C
      CALL DIDA(0,LISTE,1)
      IF(INDA.EQ.0) GOTO 203
      NRECL=IW(INDA+7)
      CALL UCOPY(DATE,IW(INDA+29),4)
C
C     PREPARE BANK FOR TABLE OF CONTENT
C
      INDL=IBANK(4H+DIR,-1,450)
      IF(INDL.EQ.0) GOTO 201
      NPG=0
      NE =0
      NERR=0
      NSE=0
      IA=IBANK(0,0,0)
      IF(IW(IA).LE.3204+NDAREC) GOTO 201
      NRC=0
   24 NTOT=0
      IB=IA
   30 NRC=NRC+1
      ISW=0
      IF(NRC.LE.NRECL) GOTO 32
      ISW=2
      GOTO 50
C
C     READ NEXT RECORD FROM DIRECT ACCESS
C
   32 JSAV=IW(IB-1)
      CALL RDDA(NRC,NDAREC,IW(IB-1))
      NTOTN=IW(IB-1)
      IW(IB-1)=JSAV
      IF(NTOTN.EQ.0) GOTO 36
      IF(NTOTN.GT.4.AND.NTOTN.LE.NDAREC-1) GOTO 34
      NERR=NERR+1
      GOTO 24
   34 IF(IW(IB).NE.DIRA.AND.IW(IB).NE.DIRO) GOTO 40
   36 ISW=1
      GOTO 50
   40 NTOT=NTOT+NTOTN
      IF(IA.EQ.IB) GOTO 50
C
C     COMPARE NAME AND NR
C
      IF(IW(IA  ).NE.IW(IB)  ) GOTO 50
      IF(IW(IA+1).NE.IW(IB+1)) GOTO 50
C
C     EQUAL
C
      NW=IW(IB+3)
      CALL UCOPY2(IW(IB+4),IW(IB),NTOTN-4)
      NTOT=NTOT-4
      IW(IA+3)=IW(IA+3)+NW
C
   50 IND=IA+3
      IF(NTOT.EQ.0.AND.ISW.EQ.2) GOTO 66
      IF(NTOT.EQ.0) GOTO 24
   52 NW=IW(IND)
      IF(NW.LE.0) GOTO 54
      IF(IA+NTOT-1-IND-NW) 54,56,60
C     ERROR
   54 CONTINUE
      GOTO 24
C     LAST BANK
   56 IF(ISW.NE.0) GOTO 60
      CALL UCOPY2(IW(IND-3),IW(IA),NW+4)
      NTOT=NW+4
      IB=IA+NTOT
      ISW=0
      GOTO 30
   60 NWR=NW+4
      IF(LUN1.NE.0) CALL WRSQ(LUN1,NWR,IW(IND-3))
      NSE=NSE+1
      IF(NE.NE.0) GOTO 64
      DO 62 I=1,450
   62 IW(INDL+I)=BLANK
   64 JCOL=NE/50
      INDX=INDL+JCOL*3+(NE-JCOL*50)*3*3
      IW(INDX+1)=IW(IND-3)
      IW(INDX+2)=IW(IND-2)
      IW(INDX+3)=IW(IND)
      NE=NE+1
      IF(ISW.EQ.2) GOTO 66
      IF(NE.LT.150) GOTO 70
   66 IF(NPG.GE.NPAGL) GOTO 68
C
C     PRINT TABLE OF CONTENT
C
      NPG=NPG+1
      IF(NUNTB.NE.0) WRITE(NUNTB,103) LUN,NPG
      CALL PRINTA(IW(INDL+1),-3,450)
   68 IF(NE.EQ.150) NE=0
      IF(ISW.EQ.2) GOTO 90
   70 IND=IND+4+NW
      GOTO 52
   90 IF(INDA.EQ.0) GOTO 92
      IF(IUNTP.EQ.0) GOTO 92
      IF(IW(INDA+20).NE.0) GOTO 92
C
C     UPDATE DATE IN MASTER DIRECTORY
C
      LISTE(1)=DIRA
      LISTE(2)=DIRO
      CALL DIDA(-1,LISTE,1)
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
   92 IZER=IBANK(4H+DIR,-1,2HDL)
      CALL BGAR(IGA)
      IF(NUNTB.NE.0) WRITE(NUNTB,102) LUN,NSE,NERR
      IF(LUN1.NE.0) REWIND LUN1
C
  100 RETURN
  101 FORMAT('0---- DIR-UNIT',I3,0X,'SEQ-UNIT',I3,'   OPTION = ',A4,
     1   '  (BFTDIR START)')
  102 FORMAT('0---- DIR-UNIT',I3,I14,' RECORDS(=BANKS) COPIED,',I4,
     1   ' ILLEGAL RECORDS   (BFTDIR END)')
  103 FORMAT('1---- DIR-UNIT',I3,10X,'PAGE',I3/
     1   11X,3(8X,'NAME',6X,'NUMBER',1X,'NR OF WORDS')/)
  201 CALL BDMPA(47)
  202 CALL BDMPA(48)
  203 CALL BDMPA(49)
      GOTO 100
      END
      SUBROUTINE DIDA(IGOTO,LIST,IL)
      COMMON/ACS/DUMMI(90),NUNTB
C
C     IGOTO =-1   RESERVE DATA SET FOR EXCLUSIVE USE
C     IGOTO = 0   CREATE MASTER DIRECTORY BANK
C     IGOTO = 1   SEARCH FOR NAME,NR IN DIRECTORY RECORDS
C     IGOTO = 2   DELETE NAME,NR IN DIRECTORY RECORD
C     IGOTO = 3   ADD NAME,NR TO DIRECTORY RECORD
C
C     LIST(1) = NAME
C     LIST(2) = NR
C     LIST(3) = NR OF DATA RECORD
C     LIST(4) = NR OF WORDS IN BANK

      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      INTEGER LIST(5,1),IBOS/'BOSS'/,DIRA/'DIRA'/,BINTIM
      JPAS=IPAS
      IPAS=0
      IF(IGOTO.LT.0) GOTO 80
    1 INDA=ILINK(4H+DIR,IUND)
      IF(INDA.EQ.0)  GOTO 10
      IF(IGOTO.GE.0) GOTO 14
      IPRFLG=0
      IF(IW(INDA+20).EQ.0) JPAS=IW(INDA+19)
      GOTO 11
C
C     CREATE MASTER DIRECTORY BANK (FROM DATA SET), IF NOT YET EXISTING
C
   10 INDA=IBANK(4H+DIR,IUND,52)
      IPRFLG=1
      IF(INDA.EQ.0) GOTO 202
   11 CALL RDDA(1,50,IW(INDA+1))
      IW(INDA+ 9)=0
      IW(INDA+10)=0
      IF(IPRFLG.EQ.0) GOTO 15
      IF(NUNTB.NE.0)
     1  WRITE(NUNTB,101) IUND,IW(INDA+6),IW(INDA+7),(IW(INDA+J),J=21,35)
C     READ LAST RECORD, TO CHECK DEFINE FILE STATEMENT
      CALL ERRSET(232,1,1,0,0,232)
      CALL RDDA(IW(INDA+6),1,DUMMY)
C
C     CHECK PASSWORD (IW(INDA+20)=1 MEANS NO CHANGE POSSIBLE)
C
   15 IF(IW(INDA+19).EQ.0)    GOTO 12
      IF(IW(INDA+19).EQ.JPAS) GOTO 12
      IF(JPAS.EQ.IBOS)        GOTO 12
      IW(INDA+19)=0
      IW(INDA+20)=1
      IF(NUNTB.NE.0.AND.IPRFLG.EQ.1) WRITE(NUNTB,102) IUND
      GOTO 14
   12 IW(INDA+20)=0
C
C     CONSISTENCY CHECKS AND BRANCH
C
   14 IF(IW(INDA+2).EQ.DIRA)       GOTO 16
      IF(IW(INDA+2).NE.IW(INDA-3)) GOTO 203
   16 IF(IW(INDA+11).EQ.0) IW(INDA+11)=1610
      NDAREC=IW(INDA+11)
      IF(IGOTO.LE.0) GOTO 100
      IF(IGOTO.EQ.3) GOTO 40
C
C     SEARCH FOR ENTRY IN DIRECTORY RECORDS
C
   20 INDT=0
      NHASH=2+MOD(IABS(LIST(1,1)+LIST(2,1)),IW(INDA+8))
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 201
   22 CALL RDDA(NHASH,NDAREC,IW(IA))
      NHASHX=IW(IA+3)
      INDP=IA+4
      K=INDP
      N=IW(K)/4
      IF(N.EQ.0)              GOTO 26
      IF(N.LT.0.OR.N.GT.(NDAREC-10)/4)  GOTO 201
      DO 24 I=1,N
      IF(LIST(1,1).NE.IW(K+1)) GOTO 24
      IF(LIST(2,1).NE.IW(K+2)) GOTO 24
C
C     ENTRY IN DIRECTORY RECORDS FOUND
C
      LIST(3,1)=IW(K+3)
      LIST(4,1)=IW(K+4)
      INDT=K
      IF(IGOTO-1) 100,100,30
   24 K=K+4
   26 NHASH=NHASHX
      IF(NHASH.NE.0) GOTO 22
      GOTO 100
C
C     DELETE NAME,NR FROM DIRECTORY RECORD
C
   30 NWCP=INDP+IW(INDP)-K-4
      IF(NWCP.NE.0) CALL UCOPY2(IW(K+5),IW(K+1),NWCP)
      IW(INDP)=IW(INDP)-4
      IW(IA)  =IW(IA)  -4
      CALL WRDA(NHASH,IW(IA),IW(IA+1))
      GOTO 100
C
C     ADD NAME,NR TO DIRECTORY RECORD
C
   40 NHASHF=0
      NHASHL=0
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 202
      I=0
C
C     LOOP FOR IL DIRECTORY ENTRIES
C
   50 I=I+1
      IF(I.GT.IL)         GOTO 70
      NHASH=2+MOD(IABS(LIST(1,I)+LIST(2,I)),IW(INDA+8))
      IF(NHASH.EQ.NHASHF) GOTO 56
      NHASHF=NHASH
   52 IF(NHASHL.EQ.0)     GOTO 54
      CALL WRDA(NHASHL,IW(IA),IW(IA+1))
      NHASHL=0
   54 CALL RDDA(NHASH,NDAREC,IW(IA))
   56 INDP=IA+4
      N=IW(INDP)/4
      IF(N.GE.(NDAREC-10)/4)        GOTO 60
C
C     COPY 4 WORDS INTO DIRECTORY
C
      CALL UCOPY(LIST(1,I),IW(INDP+IW(INDP)+1),4)
      IW(INDP)=IW(INDP)+4
      IW(IA)  =IW(IA)  +4
      NHASHL=NHASH
      GOTO 50
C
C     TRY NEXT DIRECTORY RECORD
C
   60 IF(IW(IA+3).EQ.0) GOTO 62
      NHASH=IW(IA+3)
      GOTO 52
C
C     NEW DIRECTORY RECORD REQUIRED
C     WHAT HAPPENS, IF SPACE ON DATA SET NO SUFFICIENT FOR LOAD
   62 NHASHL=NHASH
      IW(INDA+7)=IW(INDA+7)+1
      NHASH=IW(INDA+7)
C
C     SAVE TWO WORDS FROM DIRECTORY RECORD
C
      NTOT=IW(IA)
      NWDR=IW(IA+4)
C
C     WRITE NEW DIRECTORY RECORD
C
      IW(IA)=4
      IW(IA+4)=0
      CALL WRDA(NHASH,IW(IA),IW(IA+1))
C
C     WRITE EMPTY DATA RECORD
C
      IW(INDA+7)=IW(INDA+7)+1
      IW(IA)=0
      CALL WRDA(NHASH+1,IW(IA),IW(IA+1))
C
C     RESTORE TWO WORDS AND ADD POINTER TO NEXT DIRECTORY RECORD
C
      IW(IA)  =NTOT
      IW(IA+3)=NHASH
      IW(IA+4)=NWDR
      GOTO 52
C
C     FINAL WRITE FOR LAST DIRECTORY RECORD
C
   70 IF(NHASHL.EQ.0) GOTO 100
      CALL WRDA(NHASHL,IW(IA),IW(IA+1))
      GOTO 100
C
C     RESERVE DATA SET FOR EXCLUSIVE USE
C
   80 IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 201
C
C     TRY TO RESERVE DATA SET FOR EXCLUSIVE USE
C
      DO 84 I=1,11
      CALL RDDA(2,50,IW(IA))
      CALL RDDA(1,50,IW(IA))
      ITIME=BINTIM(I)
      IF(IW(IA+ 8).NE.0)        GOTO 82
      IF(IW(IA+ 9).NE.0)        GOTO 82
   81 IW(IA+ 8)=LISTE(1)
      IW(IA+ 9)=LISTE(2)
      IW(IA+11)=ITIME
      CALL WRDA(1,IW(IA),IW(IA+1))
      CALL RDDA(2,50,IW(IA))
      CALL RDDA(1,50,IW(IA))
      IF(IW(IA+ 8).NE.LISTE(1)) GOTO 82
      IF(IW(IA+ 9).NE.LISTE(2)) GOTO 82
      GOTO 1
C
C     DATA SET IN USE, TRY AGAIN
C
   82 JTIME=IW(IA+11)
      IDTIME=ITIME
      IF(IDTIME.LT.JTIME) IDTIME=8640000+IDTIME
      IDTIME=IDTIME-JTIME
      IF(NUNTB.NE.0) WRITE(NUNTB,104) IDTIME
  104 FORMAT(1X,'DATA SET RESERVED, TIME DIFFERENCE IS',I10,'/100 SEC')
C     ASSUME FREE, IF MORE THAN 1 MIN TIME DIFFERENCE
      IF(IABS(IDTIME).GT.6000) GOTO 81
C     WAIT  13 SEC (=500000*26 MIKROSEC)
      CALL DELAY(500000)
   84 CONTINUE
   90 IF(NUNTB.NE.0) WRITE(NUNTB,103) IUND
      GOTO 201
C
C
  100 RETURN
  101 FORMAT('0---- DIR-UNIT',I3,9X,'TOTAL',I6,' RECORDS, USED',
     1   I6,' RECORDS'/'0',38X,'LAST LOAD',17X,'LAST UPDATE',17X,
     2   'LAST UNLOAD'/15X,' DATE',10X,3(2A4,2X,2A4,10X)/
     3   15X,' STORED BANKS',12X,3(I8,20X)/)
  102 FORMAT('0---- DIR-UNIT',I3,9X,'PROTECTED DATA SET, NO BCREDA',
     1   ' OR BDLSDA POSSIBLE'/)
  103 FORMAT('0---- DIR-UNIT',I3,' IN USE, NO CHANGE POSSIBLE - STOP'/)
C
C     ERROR - DATA SET IN USE
C
  201 CALL BDMPA(15)
C
C     INSUFFICIENT SPACE FOR DIRAC OPERATION
C
  202 CALL BDMPA(16)
C
C     ILLEGAL DIRECTORY
C
  203 CALL BDMPA(17)
      GOTO 100
      END
      SUBROUTINE DAFR(IGOTO)
      COMMON/ACS/DUMMI(90),NUNTB
C
C     ACCESS TO DATA RECORD OF DIRECT ACCESS DATA SET
C
C     IGOTO = 1   GET BANK FROM DIRECT ACC. DS
C             2   DELETE BANK FROM DIRECT ACC. DS
C             3   ADD BANK TO DIRECT ACC. DS
C             4   ADD BANK IN PREVIOUS PLACE (SAME LENGTH AS BEFORE)
C
C
C     INTERMEDIATE VARIABLES INDB = INDEX TO DATA IN BANK
C                            NWLB = NR OF DATA WORDS LEFT
C                            NPTR = NR OF DATA RECORD
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      INDB=INDC
      IF(IGOTO.EQ.3) GOTO 50
C
C     ADD, DELETE OR REPLACE
C
      NPTR=LISTE(3)
      NWLB=LISTE(4)
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 101
C
C     READ DATA RECORD AND SEARCH FOR NAME,NR
C
   10 CALL RDDA(NPTR,NDAREC,IW(IA))
      INDH=IA+4
      INDL=IA+IW(IA)
      GOTO 14
   12 IF(NPTR.NE.LISTE(3).AND.IGOTO.EQ.2)       GOTO 100
      IF(NPTR.NE.LISTE(3))       GOTO 102
      INDH=INDH+IW(INDH)+4
   14 IF(INDH.GT.INDL.AND.IGOTO.EQ.2)           GOTO 100
      IF(INDH.GT.INDL)           GOTO 102
      IF(IW(INDH-3).NE.LISTE(1)) GOTO 12
      IF(IW(INDH-2).NE.LISTE(2)) GOTO 12
      IF(IGOTO-2) 20,30,40
C
C     COPY BANK FROM DATA RECORD OF DIRECT ACCESS DATA SET
C
   20 CALL UCOPY(IW(INDH+1),IW(INDB+1),IW(INDH))
      INDB=INDB+IW(INDH)
      NWLB=NWLB-IW(INDH)
      IF(NWLB.LE.0) GOTO 100
      NPTR=NPTR+1
      GOTO 10
C
C     DELETE BANK FROM DATA RECORD OF DIRECT ACCESS DATA SET
C
   30 INDS=INDH+IW(INDH)
      NWDS=INDL-INDS
      NWLB=NWLB-IW(INDH)
      IW(IA)=IW(IA)-4-IW(INDH)
      IF(NWDS.GT.0) CALL UCOPY2(IW(INDS+1),IW(INDH-3),NWDS)
C
C     WRITE CHANGED DATA RECORD BACK TO DS
C
   35 CALL WRDA(NPTR,IW(IA),IW(IA+1))
      IF(NWLB.LE.0) GOTO 100
      NPTR=NPTR+1
      GOTO 10
C
C     ADD BANK IN DATA RECORD (SAME PLACE AS BEFORE)
C
   40 CALL UCOPY(IW(INDB+1),IW(INDH+1),IW(INDH))
      INDB=INDB+IW(INDH)
      NWLB=NWLB-IW(INDH)
      GOTO 35
C
C     ADD BANK TO DATA RECORD IN DIRECT ACCESS DATA SET
C
   50 NWLB=IW(INDB)
      NPTR=IW(INDA+7)
      LISTE(3)=0
      LISTE(4)=NWLB
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 101
      CALL RDDA(NPTR,NDAREC,IW(IA))
C
C
C
   55 NTOT=IW(IA)
      IF(NTOT.GT.NDAREC-5) GOTO 60
      CALL UCOPY(IW(INDC-3),IW(IA+NTOT+1),4)
      NTOT=NTOT+4
      IW(IA)=NTOT
      NWCP=MIN0(NDAREC-1-NTOT,NWLB)
      IW(IA+NTOT)=NWCP
      CALL UCOPY(IW(INDB+1),IW(IA+NTOT+1),NWCP)
      IF(LISTE(3).EQ.0) LISTE(3)=NPTR
      NTOT=NTOT+NWCP
      IW(IA)=NTOT
      INDB=INDB+NWCP
      NWLB=NWLB-NWCP
      CALL WRDA(NPTR,IW(IA),IW(IA+1))
      IF(NWLB.EQ.0) GOTO 100
C
C     INCREASE RECORD NUMBER AND PREPARE NEW RECORD
C
   60 IW(INDA+7)=IW(INDA+7)+1
      IW(IA)=0
      NPTR=IW(INDA+7)
      GOTO 55
C
C
C
  100 RETURN
C
C     INSUFFICIENT SPACE FOR DIRAC OPERATION
C
  101 CALL BDMPA(101)
C
C     DIRECTORY/DATA RECORD ERROR
C
  102 IF(IGOTO.EQ.2) GOTO 100
      IF(IGOTO.NE.1) GOTO 1002
C
C     DELETE BANK
C
      INDC=IBANK(LISTE(1),LISTE(2),'DL')
      GOTO 100
 1002 CALL BDMPA(102)
      GOTO 100
      END
      SUBROUTINE RDDA(NRC,NTOT,BUFA)
      COMMON/ACS/DUMMI(90),NUNTB
C     BOS SUBPROGRAM  =4.6=
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      INTEGER BUFA(NTOT)
   10 READ(IUND'NRC) BUFA
      GOTO 100
C
      ENTRY WRDA(NRC,NTOT,BUFA)
      IF(NTOT.NE.0) WRITE(IUND'NRC) NTOT,BUFA
      IF(NTOT.EQ.0) WRITE(IUND'NRC) NTOT,NTOT
      GOTO 100
C
      ENTRY RDSQ(IUNTP,NTOT,BUFA,*)
      READ(IUNTP,END=101) NTOT,BUFA
      GOTO 100
C
      ENTRY WRSQ(IUNTP,NTOT,BUFA)
      WRITE(IUNTP) NTOT,BUFA
C
  100 RETURN
  101 RETURN 1
      END
      SUBROUTINE BTCDIR(NAME,NRA,NRB,LUN)
      COMMON/ACS/DUMMI(90),NUNTB
      INTEGER ITAB(10)
      IF(NUNTB.NE.0) WRITE(NUNTB,101) NAME,NRA,NRB,LUN
      IZ=0
      IF(ILINK(NAME,0).NE.0) GOTO 10
      IND=INDDIR(NAME,0,LUN,2HFE)
      IF(IND.EQ.0) GOTO 10
      IND=IBANK(NAME,NR,2HDL)
      IZ=1
   10 NL=-1
      NR=NRA-1
   20 N=0
   30 NB=NRDIR(NAME,NR,LUN,2HGT)
      IF(NB.GT.NRB) GOTO 50
      IF(NB.EQ.0) GOTO 40
   35 NL=NB
      N=N+1
      NR=NB
      ITAB(N)=NB
      IF(N.LT.10) GOTO 30
      IF(NUNTB.NE.0) WRITE(NUNTB,102) ITAB
      GOTO 20
   40 IF(NL.GE.0) GOTO 50
      IF(IZ.EQ.1) GOTO 35
   50 IF(N.EQ.0) GOTO 100
      IF(NUNTB.NE.0) WRITE(NUNTB,102) (ITAB(I),I=1,N)
  100 RETURN
  101 FORMAT('0---- BTCDIR TABLE OF CONTENT OF BANKS WITH NAME ',A4,
     1 ' NR BETWEEN',I10,' AND',I10/
     2 '      ON DIR DATA SET',I3/)
  102 FORMAT(1X,10I10)
      END
      FUNCTION NPDIR(NAME,NR,IUNIT)
      COMMON/ACS/DUMMI(90),NUNTB
C
C
C     FIND ON DIRECT ACCESS DATA SET THE LARGEST NUMBER NN, WHICH IS
C     LESS OR EQUAL TO NR, FOR ALL BANKS WITH NAME.
C
C                 ---- -- -----
C        NN=NPDIR(NAME,NR,IUNIT)
C
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      NPDIR=0
      IUND=IUNIT
    1 INDD=ILINK('+NPD',IUNIT)
      IF(INDD.EQ.0) GOTO 20
C
C     SEARCH IN TABLE
C
   10 IF(NR.LT.IW(INDD+1)) GOTO 20
      IF(NR.GE.IW(INDD+2)) GOTO 20
      NA=IW(INDD+3)
      IF(NA.EQ.0) GOTO 100
      J=INDD+4
      DO 12 I=1,NA
      IF(NAME.EQ.IW(J)) GOTO 14
   12 J=J+3
      GOTO 100
   14 JA=IW(J+1)
      JB=IW(J+2)
      NPDIR=IW(INDD+JA)
      DO 16 J=JA,JB
      IF(NR.LT.IW(INDD+J)) GOTO 100
   16 NPDIR=IW(INDD+J)
      GOTO 100
C
C     CREATE A NEW LOCAL DIRECTORY BANK
C
C
C     BANK    ('+NPD',IUNIT) CONTENT
C
C       +1     LIMIT OF VALIDITY (LOW)
C        2     LIMIT OF VALIDITY (UP)
C        3     NUMBER OF NAMES
C        4     NAME
C        5     INDEX LOW  (JA)
C        6     INDEX UP   (JB)
C        7     NAME
C        8     INDEX LOW
C        9     INDEX UP
C        ...   ...
C     (JA)     NR     )
C              ...    ) FOR ONE NAME
C     (JB)     NR     )
C
   20 CONTINUE
      CALL RTA
C
C     PREPARE DIRECTORY AND INTERMEDIATE BANKS AND READ DIR RECORDS
C
      CALL DIDA(0,LIST,1)
      INDD=IBANK('+NPD',IUNIT,'DL')
C     RECORD BUFFER
      INDB=IBANK('+NP2',0,NDAREC)
C     SORT BANK
      NAR=1000
      INDR=IBANK('+NP2',1,NAR)
C     NAME/NR DIRECTORY BANK
      NW=3
      INDD=IBANK('+NPD',IUNIT,NW)
      IF(INDB.EQ.0.OR.INDR.EQ.0.OR.INDD.EQ.0) GOTO 200
      NAS=0
      NRUP=0
      NPRIME=IW(INDA+8)
      NRT=IW(INDA+33)
      NRD=0
      JREC=1
   22 JREC=JREC+1
      IF(JREC.GT.NPRIME+1) GOTO 40
      NREC=JREC
   24 IF(NREC.GE.2.AND.NREC.LE.IW(INDA+7)) GOTO 25
      IF(NUNTB.NE.0) WRITE(NUNTB,103) NREC
  103 FORMAT('0ERROR IN NPDIR, RECORD NUMBER IS',I10/)
      GOTO 22
   25 CALL RDDA(NREC,NDAREC,IW(INDB+1))
      NREC=IW(INDB+4)
      K=INDB+2
      N=IW(K+3)/4+1
   26 N=N-1
      K=K+4
      IF(N.GT.0) GOTO 30
      IF(NREC) 24,22,24
C
C     CHECK (NAME,NR) AND STORE
C
   30 NRD=NRD+1
      IF(IW(K+1).LE.0) GOTO 26
      IF(NRUP.EQ.0) GOTO 32
      IF(IW(K+1).GT.NRUP) GOTO 26
C     COMPARE NAME WITH TABLE
   32 NL=(IW(INDD)-1)/3
      IF(NL.EQ.0) GOTO 36
      J=INDD+4
      DO 34 L=1,NL
      IF(IW(J).EQ.IW(K)) GOTO 38
   34 J=J+3
C     NEW NAME
   36 INDD=IBANK('+NPD',IUNIT,NW+3)
      NW=NW+3
      J=INDD+4+3*NL
      IW(J)=IW(K)
      L=NL+1
C     STORE IF INSIDE LIMITS
   38 IF(IW(K+1).GT.NR) GOTO 39
C     POSSIBLE LOWER LIMIT
      IF(IW(K+1).GT.IW(J+1)) IW(J+1)=IW(K+1)
      IF(IW(K+1).LT.IW(J+1)) GOTO 26
   39 IW(INDR+NAS+1)=L
      IW(INDR+NAS+2)=IW(K+1)
      NAS=NAS+2
      IF(NAS.LT.NAR) GOTO 26
C
C     CLEAN TABLE AND SORT
C
   40 INF=2147483647
C     DELETE ENTRIES BELOW LIMITS
      KA=INDR
      IF(NAS.EQ.0) GOTO 50
      DO 42 I=1,NAS,2
      J=INDD+2+3*IW(KA+1)
      IF(IW(KA+2).GE.IW(J)) GOTO 42
      IW(KA+2)=INF
   42 KA=KA+2
C     SORT ARRAY TO INCREASING NR
      CALL SORTAE(IW(INDR+1),2,NAS/2,2,0)
   44 IF(NAS.EQ.0) GOTO 46
      IF(IW(INDR+NAS).NE.INF) GOTO 46
      NAS=NAS-2
      GOTO 44
   46 IF(JREC.GT.NPRIME+1) GOTO 48
      XF=FLOAT(NRD)/FLOAT(NRT+1)
      FAC=0.5*(0.2+0.7*(4.0-XF)*XF/3.0)
      NAF=NAR*FAC
      NAS=MIN0(2*NAF,NAS)
C     IF(NUNTB.NE.0) WRITE(NUNTB,102) NAS,NAR,NRUP,NAF,NRD,NRT,XF,FAC
   48 NRUPC=NRUP
      IF(NRUPC.EQ.0) NRUPC=IW(INDR+NAS)
      NRUPC=MIN0(IW(INDR+NAS),NRUPC)
      IF(NRUPC.GE.NR) NRUP=NRUPC
      IF(NRUP.EQ.0) GOTO 50
   49 IF(NAS.LE.0) GOTO 50
      IF(IW(INDR+NAS).LT.NRUP) GOTO 50
      NAS=NAS-2
      GOTO 49
C
C     FINAL PREPARATION OF LOCAL DIRECTORY BANK
C
   50 IF(JREC.LE.NPRIME+1) GOTO 26
      CALL SORTAA(IW(INDR+1),2,NAS/2,0)
      IF(NAS.LE.0) NAS=0
      NAS2=NAS/2
      IF(NAS.EQ.0) GOTO 58
      J=NAS
      JNR=NAS
   52 L=IW(INDR+J-1)
      IW(INDD+3*L+3)=JNR-NAS2+NW
   54 IW(INDR+JNR)=IW(INDR+J)
      J=J-2
      JNR=JNR-1
      IF(J.LE.0) GOTO 56
      IF(IW(INDR+J-1).EQ.L) GOTO 54
   56 IW(INDD+3*L+2)=JNR+1-NAS2+NW
      IF(J.GT.0) GOTO 52
      CALL UCOPY(IW(INDR+1+NAS2),IW(INDR+1),NAS2)
   58 INDR=IBANK('+NP2',1,NAS2)
      INDB=IBANK('+NP2',0,'DLGC')
      INDD=IBANK('+NPD',IUNIT,NW+NAS2)
      INDR=ILINK('+NP2',1)
      CALL UCOPY(IW(INDR+1),IW(INDD+NW+1),NAS2)
      IW(INDD+1)=NR
      IW(INDD+2)=NRUP
      IF(NRUP.LE.0) IW(INDD+2)=INF
      IW(INDD+3)=NW/3-1
C     IF(NUNTB.NE.0)
C    1  WRITE(NUNTB,101) IUNIT,IW(INDD+1),IW(INDD+2),IW(INDD+3)
      INDR=IBANK('+NP2',1,'DLGC')
      CALL RTE
      GOTO 1
C
C
C
  100 RETURN
C 101 FORMAT('0---- UNIT',I3,' TABLE LIMITS',2I8,I12,' DIFFERENT NAMES')
C 102 FORMAT('0NAS/NAR=',2I10,'   NEW LIMIT IS ',4I10,2G12.4)
  200 INDD=IBANK('+NPD',IUNIT,'DL')
      INDR=IBANK('+NP2',    1,'DL')
      INDB=IBANK('+NP2',    0,'DLGC')
      CALL ABEND
      GOTO 100
      END
      SUBROUTINE SORTAE(A,M,N,KEY,ITYPE)
C
C     SRT04         SORTAE(A,M,N,KEY,ITYPE)
C     -------------------------------------
C
C     SORTAE SORTS AN ARRAY A(M,N) OF N VECTORS, EACH OF LENGTH M,
C     ACCORDING TO THE ELEMENT A(KEY,I) INTO NONDECREASING ORDER,
C     USING THE SHELL ALGORITHM.THE KEY ELEMENT IS ASSUMED TO BE
C     OF TYPE INTEGER (FOR ITYPE=0) OR OF TYPE FLOATING POINT (FOR
C     ITYPE=1).
C
C     USAGE               - - - --- -----
C             CALL SORTAE(A,M,N,KEY,ITYPE)
C                         -
C
C     EXECUTION TIME ON IBM 370/168
C
C     N =  10              T = 220  MIKROSECONDS (ABOUT 30 * COMPARE)
C     N = 100 ... 1000     T = N/15 MILLISECONDS (ROUGHLY LINEAR)
C
C
C
      INTEGER A(M,N),AL1,AL2
      REAL           BL1,BL2
      EQUIVALENCE (AL1,BL1),(AL2,BL2)
      MM=N
   30 MM=MM/2
      IF(MM.EQ.0) GOTO 100
      K=N-MM
      J=0
   40 IF(J.GE.K) GOTO 30
      J=J+1
      L2=J
   50 L1=L2+MM
C
C     COMPARE ELEMENTS L1 AND L2
C     --------------------------
      IF(ITYPE.EQ.1) GOTO 55
C     INTEGER
      IF(A(KEY,L1).GE.A(KEY,L2)) GOTO 40
      GOTO 60
C     FLOATING POINT
   55 AL1=A(KEY,L1)
      AL2=A(KEY,L2)
      IF(BL1.GE.BL2) GOTO 40
C     --------------------------
C
C     EXCHANGE ELEMENTS L1 AND L2
C     ---------------------------
   60 DO 65    I=1,M
      AL1    =A(I,L1)
      A(I,L1)=A(I,L2)
   65 A(I,L2)=AL1
C     ---------------------------
C
      L2=L2-MM
      IF(L2) 40,40,50
C
  100 RETURN
      END
      SUBROUTINE SORTAA(A,M,N,ITYPE)
C
C     SRT05         SORTAA(A,M,N,ITYPE)
C     ---------------------------------
C
C     SORTAA SORTS AN ARRAY A(M,N) OF N VECTORS, EACH OF LENGTH M,
C     ACCORDING TO ALL ELEMENTS IN THE ORDER 1...M, ASSUMED TO BE
C     OF TYPE INTEGER (FOR ITYPE=0) OR OF TYPE FLOATING POINT (FOR
C     ITYPE=1). THE SHELL ALGORITHM IS USED.
C
C     USAGE               - - - -----
C             CALL SORTAE(A,M,N,ITYPE)
C                         -
C
C     EXECUTION TIME ON IBM 370/168
C
C     N =  10              T = 220  MIKROSECONDS (ABOUT 30 * COMPARE)
C     N = 100 ... 1000     T = N/15 MILLISECONDS (ROUGHLY LINEAR)
C
C
C
      INTEGER A(M,N),AL1,AL2
      REAL           BL1,BL2
      EQUIVALENCE (AL1,BL1),(AL2,BL2)
      MM=N
   30 MM=MM/2
      IF(MM.EQ.0) GOTO 100
      K=N-MM
      J=0
   40 IF(J.GE.K) GOTO 30
      J=J+1
      L2=J
   50 L1=L2+MM
C
C     COMPARE ELEMENTS L1 AND L2
C     --------------------------
      IF(ITYPE.EQ.1) GOTO 55
C     INTEGER
      DO 52 KEY=1,M
      IF(A(KEY,L1)-A(KEY,L2)) 60,52,40
   52 CONTINUE
      GOTO 40
C     FLOATING POINT
   55 DO 58 KEY=1,M
      AL1=A(KEY,L1)
      AL2=A(KEY,L2)
      IF(BL1-BL2) 60,58,40
   58 CONTINUE
      GOTO 40
C     --------------------------
C
C     EXCHANGE ELEMENTS L1 AND L2
C     ---------------------------
   60 DO 65    I=1,M
      AL1    =A(I,L1)
      A(I,L1)=A(I,L2)
   65 A(I,L2)=AL1
C     ---------------------------
C
      L2=L2-MM
      IF(L2) 40,40,50
C
  100 RETURN
      END

C   18/06/79 403191608  MEMBER NAME  SUBNEW   (S)           FORTRAN
      SUBROUTINE SUBNEW
C---  SUBTRACT ADC-PEDESTALS (CONSTANT & PHASE OR CONSTANT ONLY)
C---  & CREATE NEW VALUES FOR LNG, HPOINT, AND HGGADC
C---  (DEALS WITH 240 ADC-CHANNELS)
C
C     H.WRIEDT     12.06.79       14:00
C     LAST MODIFICATION     08.11.79      11:00
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
      COMMON /CADCPL/ HADCPL(102,240),HPBHIS(192),IPBPHD(192),
     &                IERR(3)
C
      COMMON /CWORK/ IWORK(42),LNG,HPOINT(4),HGGADC(2,240)
C
      COMMON /CSUBCP/ HSUBPD(240)

      DATA ICOUNT/0/
C
C---  BE CAREFUL! IF REFERENCE CHANNELS ARE HIT IN FIRST EVENT
C---  (THIS SHOULD NEVER OCCUR), THE PROGRAM WILL PROBABLY PRODUCE
C---  NONSENSE. UP TO NOW IT SEEMS UNNECESSARY TO CARE IN THE PROGRAM
C---  BUT YOU NEVER CAN TELL ...
C
C---  DETERMINE RELATIVE PHASE FOR EACH ADC-UNIT (48 CHANNELS EACH)
      WRITE(6,6709)
6709  FORMAT(/,/,/,'   SUBNEW CALLED ',/,/,/)
      ICOUNT = ICOUNT + 1
      IF (HGGADC(1,4).EQ.3) GOTO 1
      IF (IERR(1).LE.100) WRITE(6,600) HGGADC(2,4)
  600 FORMAT(' WRONG CHANNEL FOR SUBTRACTION AT -Z: ',I4)
      IERR(1) = IERR(1) + 1
      RETURN
    1 HSUBMI = HGGADC(2,4)
      IF (HSUBMI.GT.5 .AND. HSUBMI.LT.435) GOTO 21
      IF (HGGADC(1,40).EQ.39) GOTO 31
      IF (IERR(1).LE.100) WRITE(6,600) HGGADC(2,40)
      IERR(1) = IERR(1) + 1
      RETURN
   31 IF (HGGADC(2,40).GE.465) WRITE(6,611) HGGADC(2,4),HGGADC(2,40)
  611 FORMAT(' BOTH REFERENCE CHANNELS FOR -Z, 1.HALF, ARE HIT',
     &       2(2X,I6))
      HSUBMI = HGGADC(2,40) - HSUBPD(40)
   21 CONTINUE
C
      IF (HGGADC(1,93).EQ.92) GOTO 4
      IF (IERR(1).LE.100) WRITE(6,606) HGGADC(2,93)
  606 FORMAT(' WRONG CHANNEL FOR SUBTRACTION AT -Z, 2.HALF: ',I4)
      IERR(1) = IERR(1) + 1
      RETURN
    4 HSUBM2 = HGGADC(2,93)
      IF (HSUBM2.GT.5 .AND. HSUBM2.LT.450) GOTO 24
      IF (HGGADC(1,57).EQ.56) GOTO 34
      IF (IERR(1).LE.100) WRITE(6,606) HGGADC(2,57)
      IERR(1) = IERR(1) + 1
      RETURN
   34 IF (HGGADC(2,57).GE.495) WRITE(6,612) HGGADC(2,93),HGGADC(2,57)
  612 FORMAT(' BOTH REFERENCE CHANNELS FOR -Z, 2.HALF, ARE HIT',
     &       2(2X,I6))
      HSUBM2 = HGGADC(2,57) - HSUBPD(57)
   24 CONTINUE
C
      IF (HGGADC(1,100).EQ.99) GOTO 2
      IF (IERR(1).LE.100) WRITE(6,604) HGGADC(2,100)
  604 FORMAT(' WRONG CHANNEL FOR SUBTRACTION AT +Z: ',I4)
      IERR(1) = IERR(1) + 1
      RETURN
    2 HSUBPL = HGGADC(2,100)
      IF (HSUBPL.GT.5 .AND. HSUBPL.LT.345) GOTO 22
      IF (HGGADC(1,136).EQ.135) GOTO 32
      IF (IERR(1).LE.100) WRITE(6,604) HGGADC(2,136)
      IERR(1) = IERR(1) + 1
      RETURN
   32 IF (HGGADC(2,136).GE.345) WRITE(6,613) HGGADC(2,100),HGGADC(2,136)
  613 FORMAT(' BOTH REFERENCE CHANNELS FOR +Z, 1.HALF, ARE HIT',
     &       2(2X,I6))
      HSUBPL = HGGADC(2,136) - HSUBPD(136)
   22 CONTINUE
C
      IF (HGGADC(1,189).EQ.188) GOTO 8
      IF (IERR(1).LE.100) WRITE(6,607) HGGADC(2,189)
  607 FORMAT(' WRONG CHANNEL FOR SUBTRACTION AT +Z, 2.HALF: ',I4)
      IERR(1) = IERR(1) + 1
      RETURN
    8 HSUBP2 = HGGADC(2,189)
      IF (HSUBP2.GT.5 .AND. HSUBP2.LT.270) GOTO 28
      IF (HGGADC(1,153).EQ.152) GOTO 38
      IF (IERR(1).LE.100) WRITE(6,607) HGGADC(2,153)
      IERR(1) = IERR(1) + 1
      RETURN
   38 IF (HGGADC(2,153).GE.375) WRITE(6,614) HGGADC(2,189),HGGADC(2,153)
  614 FORMAT(' BOTH REFERENCE CHANNELS FOR +Z, 2.HALF, ARE HIT',
     &       2(2X,I6))
      HSUBP2 = HGGADC(2,153) - HSUBPD(153)
   28 CONTINUE
C
C*    IF (HGGADC(1,222).EQ.221) GOTO 3
C*    IF (IERR(1).LE.100) WRITE(6,605) HGGADC(2,222)
C*605 FORMAT(' WRONG CHANNEL FOR SUBTRACTION IN THE 5TH. ADC: ',I4)
C*    IERR(1) = IERR(1) + 1
C*    RETURN
C*  3 HSUBSM = HGGADC(2,222)
      NDAT = LNG - 2
        DO 100 I = 1,NDAT
        HADR = HGGADC(1,I)
        HRED = HGGADC(2,I)
        IF (HRED.EQ.0) GOTO 100
        IF (HADR.GT.191) GOTO 101
        IF (HADR.EQ.0.OR.HADR.EQ.47.OR.HADR.EQ.48.OR.HADR.EQ.95.OR.HADR
     &      .EQ.96.OR.HADR.EQ.143.OR.HADR.EQ.144.OR.HADR.EQ.191) GOTO 9900002700
C
C***    IF (HADR.GT.191) GOTO 9
C---    CHANNELS WITHOUT VARIING PEDESTAL
        IF (LCHANN(HADR)) GOTO 10
C
C---    SUBTRACT PEDESTAL PHASE
        IF (HADR.GT.48) GOTO 5
C---    RELATIVE TO CHANNEL #3
        HRED = HRED - HSUBMI
        GOTO 10
    5   IF (HADR.GT.96) GOTO 6
C---    RELATIVE TO CHANNEL #92
        HRED = HRED - HSUBM2
        GOTO 10
    6   IF (HADR.GT.144) GOTO 7
C---    RELATIVE TO CHANNEL #99
        HRED = HRED - HSUBPL
        GOTO 10
C---    RELATIVE TO CHANNEL #188
    7   HRED = HRED - HSUBP2
        GOTO 10
C---    RELATIVE TO CHANNEL #221
C***9   HRED = HRED - HSUBSM
C***    GOTO 20
C
C---    SUBTRACT PEDESTAL-CONSTANT (DIFFERENT FOR EACH CHANNEL)
   10   IF (LSUB(I)) GOTO 15
        IF (LCHANN(HADR).OR.KCONST(HADR).NE.0) GOTO 11
C***    IN NEXT STM. ON 10.8.79, 15:40, OLD VALUE OF 150 CHANGED TO 225
        IF (HRED.LT.225) GOTO 11
        WRITE(6,602) HGGADC(1,I), HRED
  602   FORMAT(' BLOCK NO. ',I4,' HIT IN SUBTRACTION-CONSTANT ',
     &         'DETERMINING EVENT, PULSE HEIGHT: ',I5,' CHANNELS')
        GOTO 20
C---    DETERMINE PEDESTAL-CONSTANT FOR EACH CHANNEL
   11   HSUBPD(I) = HRED
C---    IF PEDESTAL-CONSTANT IS DETERMINED IN THE ON-LINE PEDESTAL
C       DETERMINING (THE 12.TH) EVENT, INVERT SIGN
        IF (HGGADC(2,I).LT.0) HRED = -HRED
C---    CHANNELS WITH TOO LOW OR TOO HIGH SUBTRACTION CONSTANTS
        IF (KCONST(HADR)) 13,12,14
C
   12   LSUB(I) = .TRUE.
C       IF (ICOUNT.LT.3) WRITE(6,603) HGGADC(1,I),HSUBPD(I),ICOUNT
  603   FORMAT(' SUBTRACTION-CONSTANT FOR BLOCK NO. ',I3,' DETERMINED',
     &         ' TO ',I5,' IN EVENT NO. ',I3)
        GOTO 15
C---    SUBTRACTION CONSTANT TOO LOW
   13   IF (KCONST(HADR).EQ.-10) GOTO 12
        IF (HGGADC(2,I).GT.LIMIT(HADR).AND.HGGADC(2,I).LT.
     &      (LIMIT(HADR)+150)) GOTO 12
        WRITE(6,608) HGGADC(1,I),HGGADC(2,I),ICOUNT,LIMIT(HADR)
  608   FORMAT(' SUBTRACTION-CONSTANT FOR BLOCK NO. ',I3,' NOT YET',
     &         ' DETERMINED, CONTENT :',I5,' IN EVENT NO. ',I3,
     &         ' LOWER LIMIT :',I3)
        GOTO 15
C---    SUBTRACTION CONSTANT TOO HIGH
   14   IF (HGGADC(2,I).GT.(LIMIT(HADR)-150).AND.HGGADC(2,I).LT.
     &      LIMIT(HADR)) GOTO 12
        WRITE(6,609) HGGADC(1,I),HGGADC(2,I),ICOUNT,LIMIT(HADR)
  609   FORMAT(' SUBTRACTION-CONSTANT FOR BLOCK NO. ',I3,' NOT YET',
     &         ' DETERMINED, CONTENT :',I5,' IN EVENT NO. ',I3,
     &         ' UPPER LIMIT :',I3)
C---    CHANNELS WHICH HAVE TO BE SET TO 0
   15   IF (LDEAD(HADR)) GOTO 16
        HRED = HRED - HSUBPD(I)
        GOTO 20
C---    SET CHANNELS TO 0
   16   HRED = 0
C
C---  CHECK ADC-JITTER
   20   HGGADC(2,I) = HRED
        IN = HGGADC(2,I) + 50
        IF (LTHRES(HADR).AND.IN.LT.150) GOTO 99
        IF (KCONST(HADR).EQ.-10 .AND. IN.LT.250) GOTO 99
        IF (IN.GT.100) GOTO 100
        IF (IN.GT.0) GOTO 99
   90   IERR(2) = IERR(2) + 1
        IF (IERR(2).LE.100) WRITE(6,601) HGGADC(1,I), HGGADC(2,I)
  601   FORMAT(' ******* ADC-JITTER > 49     ADC-ADDRESS: ',I4,2X,
     &         'REDUCED CONTENT: ',I4)
C
C---    CUTOFF OF ADCS WITH LOW CONTENT
C       (THRESHOLD: 50 CHANNELS, SPECIAL ONES: 100 CHANNELS)
   99   HGGADC(2,I) = 0
        GOTO 100
C---    SCRATCH UNPHYSICAL ADC-ADDRESSES (I.E. ADDRESSES 208 - 215,
C---    >229) AND CONTENTS
  101   IF ((HADR.GE.208.AND.HADR.LE.215).OR.(HADR.GE.230))
     &   HGGADC(2,I) = 0
  100   CONTINUE
C
      CALL GGSRTH(0,NDAT)
      LNG = 2
        DO 200 I = 1,NDAT
        IF (HGGADC(2,I).LE.0) GOTO 201
  200   LNG = I+2
  201 NDAT = LNG-2
      CALL GGSORT
C
C---  SET UP NEW POINTERS
      HPOINT(1) = 1
      HPOINT(2) = 1
      HPOINT(3) = 1
      IF (NDAT.LE.0) GOTO 211
        DO 210 I = 1,NDAT
        HADDR = HGGADC(1,I)
        IF (HADDR.LE.95) HPOINT(2) = 2*I+1
        IF (HADDR.LE.191) HPOINT(3) = 2*I+1
  210   CONTINUE
  211 HPOINT(4) = 2*NDAT+1
      RETURN
      END

C   14/08/79 105121535  MEMBER NAME  BREADKW  (JADESR)      FORTRAN
C
        SUBROUTINE BREAD(IUN,LENG,ID,*,*)
C---
C---     COPIED OVER FROM 'F22KAW.MTLINKS(STWAD1)' 17.20 16.08.79
C---
C
C             CODED BY S.KAWABATA AT 30.07.79
C             LAST MODIFIED       AT 14.08.79
C
        IMPLICIT INTEGER*2 (H)
        DIMENSION ID(LENG)
        COMMON/CUNPK/ND,NW1,NEV,M5001,INIT,NDR,N
        COMMON/CUPK/NTOT,IX(1557)
        DIMENSION HX(3114)
        EQUIVALENCE (IX(1),HX(1))
        DATA IHD/ 'HIDD'/
        DATA N5001,N1538,N1548,N1558/ 20001, 1557, 1548, 1558/
C
C
        NAME =   0
        NR   = 100
        IF( INIT .NE. 20) GO TO 1
        IF( NLOC .EQ.  1) GO TO 10
        GO TO 20
    1   IF( INIT .EQ. 10) GO TO 3
C
C========================> INITIALIZE <===========================
C
        N    =  0
        NRNS =  0
        NEVT =  0
        NEV  =  0
        IC   =  3
        NWS  =  0
        INIT = 10
        NLOC =  1
C
C=======================> FIRST READ OR S-FORMAT READ <=================
C
    3   READ(IUN,END=1000,ERR=2000) LENG,ID
        N   =  N + 1
C
        IF(  N .EQ.  1) GO TO 7
    4   NEV= NEV+1
        RETURN
    7   IF(ID(1) .NE. IHD) GO TO 4
        INIT  =  20
        NTOT  =  LENG
        CALL UCOPY2(ID(1),IX(1),NTOT)
        GO TO 11
C
C========================> M-FORMAT <==================================
C
C--------->     READ ONE RECORD
   10   READ(IUN,END=1000,ERR=2000) NTOT,IX
        N   =  N + 1
   11   CONTINUE
C
C=======================> CHECK HIDD
C
        IF( IX(1) .EQ. IHD) GO TO 40
                    CALL EWRIT(1,N,13,NRUN,NEVNT,6,'NO BLK HIDD')
        GO TO 500
C
C##20###IF( NLOC .GT. N1538) GO TO 500
   20   IF( NLOC .GT. NTOT) GO TO 500
   30   IF( IX(NLOC) .EQ. IHD) GO TO 40
C-----------> LOOK FOR HIDD
        NLOC =  NLOC + 1
C#######IF( NLOC .GT. NTOT .OR. NLOC .GT. N1538) GO TO 500
        IF( NLOC .GT. NTOT) GO TO 500
        GO TO 30
C
C=======================>
C
   40   NEVNT = IX(NLOC+1)
        NW    = IX(NLOC+3)
        ICF   = IX(NLOC+4)
C
C=======================> CHECK NO. OF WORDS
C
        IF( NW .GT.  1) GO TO 45
                    CALL EWRIT(2,N,40,NRUN,NEVNT,9,'ILLEGAL # OF WORDS')
        GO TO 30
   45   NWX  =  NLOC + NW + 3
C###### IF( NWX .LT. N1558) GO TO 50
        IF( NWX .LE. NTOT) GO TO 50
                          CALL EWRIT(1,N,45,NRUN,NEVNT,6,'TOO LARGE NW')
        GO TO 500
C
C=======================> CHECK FLAG ICF
C
   50   ICFX= ICF + 1
        IF( ICFX .GT. 0 .AND. ICFX .LT. 5) GO TO 55
                           CALL EWRIT(2,N,50,NRUN,NEVNT,5,'ILLEGAL IC')
        GO TO 400
   55   GO TO ( 60, 60, 100, 100),ICFX
C
C=======================> ICF = 0 OR 1 <================================
C
   60   IF( IC .EQ. 3) GO TO 65
                       CALL EWRIT(2,N,60,NRUN,NEVT,8,'INCOMPLETE EVENT')
   65   NLOC2 = 2*NLOC + 26
        NRUN  = HX(NLOC2)
        IF( NRUN .EQ. NRNS) GO TO 75
C###### IF( NRUN .GT. NRNS) GO TO 70
C######                CALL EWRIT(3,N,65,NRUN,NEVNT,6,'ILLEGAL RUN#')
C###### IF( NLOC .EQ. 1) GO TO 70
C#######IF( NRUN .EQ. 2 .OR. NRUN .EQ. 3) GO TO 70
C###################   CALL EWRIT(1,N,65,NRUN,NEVNT,6,'ILLEGAL RUN#')
C###### GO TO 500
C
   70   NRNS = NRUN
        NEVT = NEVNT
C        WRITE(6,9000) NRNS,NEVT,N
C9000    FORMAT(1X,'>>>>>>>>>>> NEW RUN#(',I10,') SEV#(',I10,') IN BLK',
C    -   I6,' <<<<<<<<<<<<<<<<<<<')
        GO TO 81
   75   IF( NEVNT .GT. NEVT) GO TO 80
C#######IF( NEVNT .EQ.    1) GO TO 70
C#######              CALL EWRIT(1,N,75,NRUN,NEVNT,7,'ILLEGAL EVENT#')
C#######GO TO 500
   80   NEVT = NEVNT
   81   NWS  = NW - 1
        CALL UCOPY2(IX(NLOC+5),ID(1),NWS)
        IF( ICF .EQ. 1) GO TO 130
        IC  = 3
        LENG= NWS
        NLOC= NLOC + NW + 4
C#######IF( NLOC .GT. N1538) NLOC = 1
        IF( NLOC .GT. NTOT) NLOC = 1
        NEV= NEV+1
        RETURN
C
C======================> ICF = 2 OR 3  <================================
C
  100   IF( IC .EQ. 2) GO TO 105
       CALL EWRIT(2,N,100,NRUN,NEVNT,15,'MIDDLE PART OF EVENT APPEARED')
        GO TO 400
  105   IF( NEVNT.EQ. NEVT) GO TO 110
C#######         CALL EWRIT(2,N,105,NRUN,NEVNT,10,'EVENT IS INCOMPLETE')
C#######GO TO 400
  110   NW1 = NW + NWS + 4
        IF( NW1 .LT. N5001) GO TO 115
                  CALL EWRIT(2,N,110,NRUN,NEVNT,7,'TOO LARGE EVENT')
        GO TO 400
  115   NST = 4
        NSU = 1
        IF( IX(NLOC+5) .NE. NAME) GO TO 120
        IF( IX(NLOC+6) .NE.   NR) GO TO 120
        NST = 8
        NSU = 5
        ID(IAN) = ID(IAN) + IX(NLOC+8)
  120   IS= NLOC + NST
        NW1 = NW - NSU
        CALL UCOPY2(IX(IS+1),ID(NWS+1),NW1)
        NWS = NWS + NW1
        IF( ICF .EQ. 2) GO TO 130
            LENG= NWS
            IC= 3
            NLOC= NLOC+NW+4
C###########IF(NLOC.GT.N1538) NLOC= 1
            IF(NLOC.GT.NTOT) NLOC= 1
            NWS= 0
        NEV= NEV+1
            RETURN
C
C=================> SET ADDRESS FOR NEXT RECORD <=====================
C
  130  IJ= NLOC+5
       IJ1= IJ
            DO 134 I=1,50
            IJ1= IX(IJ1+3)+IJ1+4
            IF(IJ1.LE.IJ) GO TO 135
            IF(IJ1.GT.NTOT) GO TO 136
            IJ= IJ1
  134       CONTINUE
            GO TO 500
  135       CONTINUE
                 CALL EWRIT(2,N,135,NRUN,NEVNT, 7,'# OF WS ERROR ')
            GO TO 500
  136   IC = 2
        NLOC = 1
        IF(IJ.NE.6) GO TO 137
        IF(IX(IJ).NE.NAME) GO TO 137
        IF(IX(IJ+1).EQ.NR) GO TO 10
137     NAME= IX(IJ)
        NR  = IX(IJ+1)
        IAN = NWS+IJ+3-NTOT
       GO TO 10
C
C====================> REJECT CURRENT EVENT<===========================
C
  400  NLOC= NLOC+NW+4
C########## IF(NLOC.GT.N1538) GO TO 500
            IF(NLOC.GT.NTOT) GO TO 500
            IC= 3
             NWS= 0
       GO TO 20
  500       IC= 3
            NWS= 0
            NLOC= 1
       GO TO 10
C
C=======================> REACH EOF <===================================
C
 1000  RETURN1
C
C======================> READ ERROR <==================================
C
 2000  RETURN2
      END
C
C>>>>>>>>>>>>>>>>>  ERROR MESAGE ROUTINE  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C
       SUBROUTINE EWRIT(IFG,NB,IFL,NRUN,NEVNT,N,ICH)
       INTEGER *2 ICH(20)
       IF(IFG.NE.1) GO TO 100
       WRITE(6,9000) NB,NRUN,NEVNT,IFL,(ICH(J),J=1,N)
 9000  FORMAT(1X,'*** SKIP TO THE NEXT BLOCK BY ERROR IN BLK',I6,
     - ' RUN(',I6,') EVENT(',I7,') FLAG =',I4,' : ',20A2)
       RETURN
  100  IF(IFG.NE.2) GO TO 200
       WRITE(6,9100) NB,NRUN,NEVNT,IFL,(ICH(J),J=1,N)
 9100  FORMAT(1X,'*** SKIP TO THE NEXT HIDD  BY ERROR IN BLK',I6,
     - ' RUN(',I6,') EVENT(',I7,') FLAG =',I4,' : ',20A2)
       RETURN
  200  WRITE(6,9200) NB,NRUN,NEVNT,IFL,(ICH(J),J=1,N)
 9200  FORMAT(1X,'*** WARNING ; EVENT STRUCTURE ERROR IN BLK',I6,
     - ' RUN(',I6,') EVENT(',I7,') FLAG =',I4,' : ',20A2)
       RETURN
       END

C   29/09/78 606101309  MEMBER NAME  JSTEP9   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JSTEP( R, P, DRTOT, DRMAX )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     27/10/78 :  DOES THE STEPPING THROUGH DET.
C
C        MOD  E. ELSEN     13/11/81 :  MADE SAVE AGAINST MAG FIELD < 0
C
C   LAST MOD  J. HAGEMANN  28/08/84 :  DRMAX NOW GIVEN AS ACT. PARAMETER
C
C        THIS SUBROUTINE CALCULATES NEXT POINT R OF
C        TRACK OF PARTICLE WITH MOMENTUM P.
C        STARTING POINT R IS OVERWRITTEN BY COORDINATES OF NEXT
C        POINT. ALL NECCESSARY INFORMATION ABOUT
C        PARTICLE IS STORED UNDER VECTOR P :
C
C           P(1) = X - COMPONENT OF MOMENTUM
C           P(2) = Y - COMPONENT OF MOMENTUM
C           P(3) = Z - COMPONENT OF MOMENTUM
C           P(4) = TOTAL ENERGY OF PARTICLE
C           P(5) = REST MASS OF PARTICE
C           P(6) = LENGTH OF THREE VECTOR P
C                  ALL UNITS IN GEV.
C           P(7) = CHARGE OF PARTICLE IN UNITS OF
C                  ELECTRON CHARGE.
C
C        THE FIRST THREE COMPONENTS OF P WILL BE
C        CHANGED TO NEW MOMENTUM VECTOR IN R+DR.
C        DRTOT IS STEPLENGTH.
C-----------------------------------------------------------------------
C
      COMMON/CGEO1/BKGAUS
C
      DIMENSION R(3),P(7)
C
      DATA ANGLIN  / 0.03 /
C
C------------------------  C O D E  ------------------------------------
C
      EB = 0.3E-4 * ABS(BKGAUS)
      DT = DRMAX / P(6)
      ODT = EB * DT
                  IF( ODT .LT. ANGLIN ) GO TO 10
                  ODT = ANGLIN
                  DT = ODT / EB
   10 ODT = ODT*P(7)
      IF( BKGAUS .LT. 0. ) ODT = - ODT
C
C
      DP1 =  P(2)*ODT
      DP2 = -P(1)*ODT
      ODT2 = ODT*ODT
      CORREC = 1. - .5*ODT2 + .375*ODT2*ODT2
C
C
      R(1) = ( P(1) + .5*DP1 ) * DT  + R(1)
      R(2) = ( P(2) + .5*DP2 ) * DT  + R(2)
      R(3) = P(3)*DT + R(3)
C
C
      P(1) = ( P(1) + DP1 ) * CORREC
      P(2) = ( P(2) + DP2 ) * CORREC
C
C
      DRTOT = ( ( DP1*DP1 + DP2*DP2 ) * .125 + P(6) ) * DT
      RETURN
      END

C   18/09/80 503012017  MEMBER NAME  TOFBK    (JADEGS)      FORTRAN
      SUBROUTINE TOFBK
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IRELT(14,50)
       DIMENSION IW(704)
       EQUIVALENCE (IW(1),INFM(1))
C
C  BSAT CHANGED TO BSAW,  1.3.1985   J.O.
C
C=========   STORE RESULT INTO CURRENT BUFFER
C
       LTFR= 14*NTRK+4
       CALL BCRE(INTR,'TOFR',0,LTFR,*3000,IER)
       IF(INTR.EQ.0.AND.IER.EQ.2) GO TO 3000
       CALL BSTR(INTR,IW,LTFR)
       CALL BSAW(1,'TOFR')
       RETURN
3000   CONTINUE
C/////////
             WRITE(6,9300)
9300         FORMAT(1X,'BOS ERROR IN TOFBK')
      RETURN
      END

C   22/06/84 412061343  MEMBER NAME  TAGGTP   (S)           FORTRAN
C
C
C
C------  T A G G T P  ------  T A G G T P  ------  T A G G T P  ------
C
C------  T A G G T P  ------  T A G G T P  ------  T A G G T P  ------
C
C------  T A G G T P  ------  T A G G T P  ------  T A G G T P  ------
C
C
C
C
C     ----   STEERING ROUTINE FOR TP-ING TAGGING DATA  ----
C
C
C
C
C THIS   IS THE MAIN LEVEL OF MY ROUTINES TO TP THE TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE  TAGGTP(IWRITE,EN, * , * )
C
C
C COMMONS   ETC FOR A.J.FINCH'S TP OF TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       IMPLICIT INTEGER * 2 ( H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C   12/03/84 412041226  MEMBER NAME  CTAGGO   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C HERE ARE THE COMMONS THAT EVENTUALLY BECOME THE TP BANKS ACCLS -
C TAGG/O ,1,2,3
C CONVENTION IN NAMING -
C
C FIRST LETTER -
C         C - NAME OF COMMON
C         H - NAME OF VARIABLES *2 TYPE      INTEGER
C         I -   "       "       *4 TYPE         "
C         A -   "       "                    REAL
C
C REST OF NAME AS FOR TAGG BANKS SEE JADE COMPUTER NOTE 16 FOR MORE DETA
C
C ACTUALLY ALL THIS COULD ALSO GO IN WORKSPACE BUT I CANT BE BOTHERED!
C
C**** IMPORTANT :  IF YOU CHANGE THE SIZE OF THESE COMMONS PLEASE
C                  REMEMBER TO CHANGE 'TAGINT' WHICH CLEARS THEM.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      COMMON / CACLS  / HID1,HID2,HIPM,HIPZ,HDUM,HIPL,HDUMM1(134)
      DIMENSION HACLS(140)
      EQUIVALENCE ( HACLS(1) , HID1 )
C
      COMMON / CTAGG0 / HID3,HID4,HTRACK,HTRZMI,HTRZPL,HCLST,
     *                  HCLZMI,HCLZPL,HNEUT,HCOL,HTYPE,HER,HCORR,
     *                  HPBLAT,HDUM1,HDUM2,HSCAL(36),HWPCL,HWPTR,
     *                  HDUMM2(14)
      DIMENSION     ATAGG0(34)
      EQUIVALENCE ( HID3 , ATAGG0(1) )
C
      COMMON / CTAGG1 / HMAP(2,20)
C
      COMMON / CTAGG2 / ATAGG2(260)
      DIMENSION         ITAGG2(260)
      INTEGER*2         HTAGG2(520)
      EQUIVALENCE ( HTAGG2(1) , ITAGG2(1) , ATAGG2(1) )
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       INTEGER  START
       REAL  MZED
       INTEGER  PZMX
C
C PLUS   AND MINUS ZED DISTANCES OF TAGGERS
C
       DATA  PZED,MZED / 3160.0 , -3160.0 /
C
C
C----------------------- C O D E ---------------------------------------
C
C
C
C
C---                                         INITIALISATION
C
       CALL  TAGINT(*999)
C
       HWPCL  = 13
C
C ANGCUT   DEFINES COLINEARITY CRITERION
C FOR  COMPARING  CLUSTERS IN + AND - ZED
C
       ANGCUT  = 3.1
C
C  THRESH   IS THE THRESHOLD ENERGY FOR
C  STARTING   A CLUSTER SEARCH (MEV ?)
C
       THRESH  = EN * 25.0
C
       IF  ( IWRITE .EQ. 1 ) WRITE(6,6009) THRESH
 6009  FORMAT('  THRESHOLD FOR CLUSTER SEARCH IN TAGGER = ',F8.3)
C
C
       HIPM  = 4
C
       ISHALL  = IWRITE
C
C FILL   ARRAY CATAG : -
C TAGADC   DOES RETURN 1 FOR MISSING ATAG BANK - NO PROVISION YET
C NONE   REQUIRED TAGG/0 ONLY WILL BE CREATED ALL OTHER BANKS HAVE
C 0 LENGTH    SHOULD REALLY HAVE CHECKED BEFORE CALLING IT .
C
C
       CALL  TAGADC(ISHALL,*97)
C
C
C      SUBTRACT  PEDESTALS APPEARING DUE TO AC PICK UP ON SIGNAL CABLES
C
C
   97  CALL  TAGPED
C
C RECALIBRATE   USING FACTORS FOUND FROM CALIBR COMMON FILLED PREVIOUSLY
C BY KALIBR   IN CALLING ROUTINE.
C
       CALL  TAGKAL(ISHALL)
C
C WORK  OUT SMZ AND SPZ  I.E. SUM OF ALL BLOCKS AT - Z/ + Z RESPECTIVELY
C
       CALL TAGSUM(-1,SMZ,*98)
   98  CALL TAGSUM(+1,SPZ,*99)
   99  ETOT  = SMZ + SPZ
C
C SAVE   THIS INFORMATION IN WHAT WILL EVENTUALLY BE TAGG/0
C
       ATAGG0(29)  = 0.001 * ETOT
       ATAGG0(29)  = 0.001 * ETOT
       ATAGG0(32)  = 0.001 * ETOT
       ATAGG0(30)  = 0.001 * SMZ
       ATAGG0(33)  = 0.001 * SMZ
       ATAGG0(31)  = 0.001 * SPZ
       ATAGG0(34)  = 0.001 * SPZ
C
C
C NOW  PREPARE  TO DO THE FOLLOWING SECTION OF CODE FOR
C - Z  ONLY  ,LATER IT IS DONE FOR + ZED
C
       N = 0
C
C ZED  IS  - ZED   (IN MM )
C
       ZED = MZED
C
C JPART   IS - 1 FOR    - Z + 1 FOR + Z
C
       JPART = -1
C
C ISTART/IEND   = FIRST AND LAST PARTS OF CATAG TO USE ( - Z CHANNELS )
C
       ISTART = ISTMZ
       IEND   = IENDMZ
C
C IPOINT   IS A POINTER USED IN CONSTRUCTING THE CLUSTER MAP FOR OUTPUT
C
       IPOINT = 4
       HPZ    = IPOINT
C
C
C SORT   ADC'S BY SIZE ORDER  SORTED LIST IS IN SADC
C
    1  CALL TAGSR1(ISTART,IEND,ISHALL)
C
C FIND   ADDRESSES OF MEMBERS OF CLUSTERS
C
       ISHALL  = IWRITE
       CALL  TAGCLS(ISTART,IEND,THRESH,ISHALL)
C
       IF ( IWRITE .EQ. 1 ) WRITE(6,6001) NCLST,JPART
 6001  FORMAT(' TAGCLS FOUND ',I4,' CLUSTERS IN TAGGER JPART ',I4)
C
C SAVE   THE INFORMATION WE HAVE NOW FOR CLUSTERS ( NUMBER OF THEM )
C

       IF  ( JPART .EQ. -1 ) HCLZMI = NCLST
       IF  ( JPART .EQ.  1 ) HCLZPL = NCLST
C
*** PMF 15/10/99: new GOTO label introduced behind the 'END DO'-CONTINUE statement at label 10
*       IF  ( NCLST .EQ. 0 ) GOTO 10
       IF  ( NCLST .EQ. 0 ) GOTO 11
*** PMF (end)
C
C NOW  START  A LOOP OVER EACH CLUSTER IN TURN
C
       DO 10 I = 1,NCLST
          N  = N + 1
C
C SORT   EACH CLUSTER BY ENERGY ,PUT RESULT IN CLUS (9,2)
C
          CALL TAGSR2(I)
C
C CALCULATE   SUM OF ENERGY FOR CLUSTER , ANFD FILL ACLS
C      IPOINT  POINTS TO THE START OF CLUSTER N IN ACLS
C
          HMAP(1,N)  = IPOINT
C
C      FFADC  IS THE ADDRESS OF THE 'PARENT' OF THIS CLUSTER
C
          FFADC  = CMAP(I,1)
C
C      NNEI  IS THE NUMBER OF BLOCKS WHICH ARE NEIGHBOURS OF THIS BLOCK
C
          NNEI  = NLIST(FFADC,1,MARK)
C
C START   A LOOP OVER EACH MEMBER OF CLUSTER TO PUT THEM IN CLUSTER MAP
C AND  WORK  OUT SUM
C
          SUM  = 0
C
          DO 5 J = 1,NNEI
C
C      END  OF CLUSTER IF ENERGY OF THIS BLOCK IS ZERO
C
             IF  ( CLUS(J,2) .LE. 0 ) GOTO 5
             IHAPIN = IPOINT + IPOINT
C
C CONVERT   BACK FROM SOFTWARE ADDRESS TO HARDWARE ADDRESS
C TO REVERSE   ACTION TAKEN IN TAGADC (SOFTWARE ADDRESSES MAKE PROGRAM
C EASIER   TO WRITE AND READ)
C
             IADC  = CLUS(J,1)
             IHADC = TAGS2H(IADC)
C
C TAGS2H   RETURNS A VALUE OF - 1 IF IT CANT WORK OUT HARDWARE ADDRESS
C
             IF ( IHADC .EQ. -1 ) GOTO 5
C
C FILL   CLUSTER MAP - FIRST HALF WORD IS ADDRESS SECOND IS ENERGY
C
             HACLS(IHAPIN - 1) = IHADC
             HACLS(IHAPIN)     = CLUS(J,2)
C
C INCREMENT   POINTER   ALWAYS POINTS TO NEXT WORD TO BE FILLED
C
             IPOINT = IPOINT + 1
             SUM = SUM + CLUS(J,2)
 5        CONTINUE
C
          IF ( IWRITE .EQ. 1 ) WRITE(6,6005) N,JPART,SUM
 6005     FORMAT(1X,'THE ENERGY SUM FOR CLUSTER ',I4,
     1              ' IN JPART ',I4,'   IS ',F12.3)
C
C END  OF  LOOP OVER EACH MEMBER OF CLUSTER
C
C      HMAP(2,N)  IS WHERE TO FIND THE LAST MEMBER OF CLUSTER N IN ACLS
C
         HMAP(2,N)  = IPOINT - 1
C
C WORK   OUT POSITION OF CENTRE OF EACH CLUSTER
C
         CALL TAGPOS(SUM,ISHALL)
C
C WORK   OUT DIRECTION COSINES
C
         CALL TAGDIR(CAND(2 ) ,CAND(3 ) ,ZED,DX,DY,DZ)
C
C NOW  SAVE  INFORMATION FOR THIS CLUSTER
C
          IB = (N - 1) * HWPCL
          HIB = IB * 2
          HTAGG2(HIB + 1) = N
          HTAGG2(HIB + 2) = JPART
          ATAGG2(IB + 5)  = 0.001 * CAND(1 )
          ATAGG2(IB + 6)  = 0.001 * SIGEN
          ATAGG2(IB + 7)  = CAND(2)
          ATAGG2(IB + 8)  = CAND(3)
          ATAGG2(IB + 9)  = SIGX
          ATAGG2(IB + 10) = SIGY
          ATAGG2(IB + 11) = DX
          ATAGG2(IB + 12) = DY
          ATAGG2(IB + 13) = DZ
C
C END  OF  LOOP OVER EACH CLUSTER
C
   10  CONTINUE
*** PMF 15/10/99: new label added for a former GOTO statement
   11  CONTINUE
*** PMF (end) 
C
C SET  UP  FOR AND DO PLUS ZED
C
       JPART  = JPART + 2
       IF ( JPART .GT. 1 ) GOTO 15
       HIPZ   = IPOINT
       ZED    = PZED
       ISTART = ISTPZ
       IEND   = IENDPZ
       GOTO 1
C
   15  CONTINUE
C
C NOW  ALL  CLUSTERS IN - Z AND + Z HAVE BEEN FOUND AND THEIR PROPERTIES
C CALCULATED   - CALCULATE SOME MORE PROPERTIES OF THE EVENT AS A WHOLE
C
       HCLST  = HCLZPL + HCLZMI
       HNEUT  = HCLST
       HIPL   = IPOINT
       ACOLAN = 6.29316
C
C      NOW  DO ACCOLINEARITY CHECKS
C
C      FIRST  CHECK THERE ARE CLUSTERS EACH SIDE
C
*** PMF 15/10/99: new GOTO label introduced behind the 'END DO'-CONTINUE statement at label 20
*       IF ( ( HCLZMI .EQ. 0 ) .OR. ( HCLZPL .EQ. 0 ) ) GOTO 20
       IF ( ( HCLZMI .EQ. 0 ) .OR. ( HCLZPL .EQ. 0 ) ) GOTO 21
* PMF (end)
       EMAX  = 0
C
C FIND   THE CLUSTER IN - Z WITH GREATEST ENERGY (PROBABLY FIRST ONE)
C  MZMX   IS THE RECORD OF THIS (AS CLUSTER NUMBER IN TAGG/2)
C
       DO 16 I = 1,HCLZMI
          IB = (I - 1) * HWPCL
          EN = ATAGG2(IB + 5)
          IF ( EN .LT. EMAX ) GOTO 16
          EMAX = EN
          MZMX = I
   16  CONTINUE
C
C SIMILARLY    FOR + Z
C
       EMAX   = 0
       START  = HCLZMI + 1
       DO 17 I = START,HCLST
          IB = (I - 1) * HWPCL
          EN = ATAGG2(IB + 5)
          IF ( EN .LT. EMAX ) GOTO 17
          EMAX = EN
          PZMX = I
  17   CONTINUE
C
C FIND   THE ANGLE BETWEEN THE  LARGEST CLUSTERS IN + / - Z
C
       CALL TAGCOL(MZMX,PZMX,THETA)
       ACOLAN = THETA
C
C      NOW  FOR EACH CLUSTER IN - Z LOOK FOR A COLINEAR CLUSTER IN + Z
C
       START = HCLZMI + 1
C
       DO 20 I = 1,HCLZMI
C
          DO 22 J = START,HCLST
C
             CALL TAGCOL(I,J,THETA)
C
             IF ( THETA .LT. ANGCUT ) GOTO 22
C
C        COLINEAR PAIR FOUND   - FIRST COUNT HOW MANY THERE ARE
C
             HCOL = HCOL + 1
C
C TELL   - Z CLUSTER ABOUT ITS + Z PARTNER AND VICE VERSA
C
             HIB = 2 * ((I - 1) * HWPCL)
             HTAGG2(HIB + 5) = J
             HIB = 2 * ((J - 1) * HWPCL)
             HTAGG2(HIB + 5) = I
   22     CONTINUE
   20  CONTINUE
*** PMF 15/10/99: new label added for a former GOTO statement
   21  CONTINUE
*** PMF (end) 
       ATAGG0(28) = ACOLAN
C
C FILL   TP BNKS ICLST/IPOINT ARE LENGTHS OF BANKS TO CREATE
C TAGSTO   CREATES THE BOS BANKS 'ACLS' 'TAGG'/0,1,2
C
       ICLST  = HCLST
       CALL TAGSTO(ICLST,IPOINT,IERTAG)
       IF ( IERTAG .NE. 0 ) RETURN 2

       RETURN
C
  999  RETURN 1
       END

C   05/07/84 407111925  MEMBER NAME  MORE     (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MORE( IRETN )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   7/07/84 :  CHANGE INPUT DATASET ALLOCATION
C
C
C     COMMAND MORE  - CALLS GETDS TO LINK TO NEW INPUT DATASET.
C        IRETN = 0    IF NEW DATASET LINKED
C        IRETN = 1    OTHERWISE
C
C-----------------------------------------------------------------------
C
      IMPLICIT  INTEGER*2 (H)
C
#include "cgraph.for"
C
C------------------  C O D E  ------------------------------------------
C
      LUNREM = NDDINN
      NDDINN = 0
      IRETN  = 1
      CALL TRMOUT(80,'Do you really want to change to another input data
     +set?^')
      CALL DECIDE( IANSW )
      IF( IANSW .EQ. 2 ) GO TO 1
      CALL GETDS(NDDINN,'Please enter FULL NAME of the Dataset with the
     +Events  (without apostrophes)^',IDATSV,HERR)
C
      IF( HERR .NE. 0 ) GO TO 1
        ICREC = 0
        IRETN = 0
        RETURN
C
  1   NDDINN = LUNREM
      CALL TRMOUT(80,'This session will continue with the old input data
     +set. Command?^')
      RETURN
C
      END

C   01/11/84            MEMBER NAME  FICOOR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FICOOR( IFLG, NI, NWE )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  CALCULATE COORDINATES OF
C                                        INNER DETECTOR HITS
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL TBIT, FL18, FL22, FL24
C
#include "cgraph.for"
#include "cdata.for"
#include "cgeo1.for"
#include "cjdrch.for"
C
      COMMON / CJCELL / NCELL(3),NWIRES(3)
      COMMON/CWORK1/R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,EX,EY,COSPH,SINPH
     +             ,KZAMP
C
      COMMON /CJTRIG/ PI,TWOPI
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
      DATA HCALL /0/
C
C-----------------  C O D E  -------------------------------------------
C
      HCALL = HCALL + 1
      IPRJC = 0
      IF(HCALL.GT.1) GO TO 3551
      ZDEEP = 5800.
      ZETMX = ZLGPL + ZDEEP
C COMPUTE FI OF WIRE, RADIUS ETC.
3551  NIW = HDATA(NI)
      NIW = ISHFTR(NIW,3) + 1
      IF(NIW.LE.1536.AND.NIW.GT.0) GO TO 3559
      CALL DIAGIN('ILLEGAL WIRE NO.    ',2,NIW,NI)
      CALL TRMOUT(80,'THIS CAN HAVE SEVERAL REASONS, E.G. WRONG POINTERS
     $, WRONG BANK LENGTH OR^')
      CALL TRMOUT(80,'(LESS LIKELY), CORRUPT DATA. THE DISPLAY OF INNER
     $DETECTOR HITS STOPS HERE.^')
      NWE = -1000
      RETURN
3559  NRING = (NIW-1)/384 + 1
      IF(NRING.GT.3) NRING = 3
      RADD = RINCR(NRING)
      NCL = NCELL(NRING)
      R = FSENSW(NRING) - RADD
      NEW = NIW - (NRING-1)*384
      SHIFI = PSIIN(NRING)
      NCE = ISHFTR(NEW-1,4)
      NWE = NEW - NCE*16
      IF(DSPDTL(26).AND.TBIT(NWE,31)) GO TO 4000
      R = R + NWE*RADD
      NUMCLO = 2
      IF(NWE.LT.9) NUMCLO = 1
      FACT = -SWDEPL
      IF(TBIT(NWE,31)) FACT = -FACT
      FI = SHIFI + NCE*TWOPI/FLOAT(NCL)
      IF(FI.LT.0.)FI = FI + TWOPI
      IF(FI.GT.TWOPI) FI = FI - TWOPI
      IF(IFLG.NE.1) GO TO 1003
C  DECIDE POS/NEG X OR Y
      IF(DSPDTL(9)) R=R*WRAP(FI)
C  COORDINATE CALCULATIONS
 1003 CONTINUE
      NI = NI + 1
C  GET Z-COORDINATE
      IA1 = HDATA(NI)
      NI = NI + 1
      IA2 = HDATA(NI)
      IF(IA1+IA2.GT.0) GO TO 1013
      KZAMP = KZAMP + 1
      ZET = 0.
      GO TO 1014
C1013  ZET = ZAL*.5*(IA2 - IA1)/(IA1+IA2) + ZOFFS
1013  ZET = ZAL*.5*(IA2 - IA1)/(IA1+IA2)
1014  NI = NI + 1
      IF(FL18.AND.FL22) GO TO 3338
      IF((IFLG.EQ.1).AND.DSPDTL(9).AND.(.NOT.DSPDTL(10))) GO TO 3339
3338  NDT = HDATA(NI)
C  DRIFT TIME
      FIDR = (FLOAT(NDT) + 0.5)*TIMDEL(NUMCLO,NRING)
      COSPH = COS(FI)
      SINPH = SIN(FI)
      EX = - (SINPH*DRICOS + COSPH*DRISIN)
      EY =    COSPH*DRICOS - SINPH*DRISIN
      XXX = ABS(R)*COSPH - FACT*SINPH
      YYY = ABS(R)*SINPH + FACT*COSPH
      AAA = FIDR*EX
      BBB = FIDR*EY
      X1 = XXX+AAA
      Y1 = YYY+BBB
      R1 = SQRT(X1*X1 + Y1*Y1)
      FI1 = ATAN2(Y1,X1)
      X2 = XXX-AAA
      Y2 = YYY-BBB
      R2 = SQRT(X2*X2 + Y2*Y2)
      FI2 = ATAN2(Y2,X2)
      IF(FI1.LT.0.) FI1 = FI1 + TWOPI
      IF(FI2.LT.0.) FI2 = FI2 + TWOPI
      IF(DSPDTL(9)) R1=R1*WRAP(FI1)
      IF(DSPDTL(9)) R2=R2*WRAP(FI2)
      IF(.NOT.FL22.OR..NOT.FL18) GO TO 3337
      IF(-X1.LT.XMINR.OR.-X1.GT.XMAXR) IPRJC = 1
      IF(-X2.LT.XMINR.OR.-X2.GT.XMAXR) IPRJC = 1
      IF(Y1.LT.YMINR.OR.Y1.GT.YMAXR) IPRJC = 1
      IF(Y2.LT.YMINR.OR.Y2.GT.YMAXR) IPRJC = 1
3337  CONTINUE
      IF(IFLG.NE.2) GO TO 3339
C     PERSPECTIVE FACTOR
      R1 = R1*(ZDEEP - ZET)/ZETMX
      X1 = R1*COS(FI1)
      Y1 = R1*SIN(FI1)
      R2 = R2*(ZDEEP - ZET)/ZETMX
      X2 = R2*COS(FI2)
      Y2 = R2*SIN(FI2)
3339  NI = NI + 1
      RETURN
4000  NWE = 0
C ENTER HERE FOR MISSING EVEN WIRE HITS
      NI = NI + 4
      RETURN
      END
      FUNCTION WRAP(FI)
C---
#include "cgraph.for"
C---     RETURNS WITH VALUE +1 OR -1 DEPENDING ON WHETHER HITS IN
C---     THE "WRAP AROUND" VIEW SHOULD BE DISPLAYED WITH POSITIVE
C---     OR NEGATIVE Y COORDINATE ON THE SCREEN.
C---
      COMMON /CJTRIG/ PI,TWOPI,PIHALF,PI3HAF
      WRAP=1.
      IF(LASTVW.LT.4) RETURN
      IF(LASTVW.GT.11.AND.LASTVW.NE.76.AND.LASTVW.NE.77) RETURN
      IF(LASTVW.GT.7.AND.LASTVW.NE.76) GO TO 1
      IF(FI.GT.PIHALF.AND.FI.LT.PI3HAF) WRAP=-1.
      RETURN
    1 CONTINUE
      IF(FI.GT.PI) WRAP=-1.
      RETURN
      END

C   04/11/82 606091755  MEMBER NAME  JVTXCH   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JVTXCH ( R, P, PENETR, PENETZ, JRETRN, RDOWN, RUP,
     *                    ZDOWN, ZUP, DRMAX, * )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN  12/11/82 :  PROPAGATES CHARGED PARTICLE
C             R. RAMCKE                THROUGH THE VERTEX CHAMBER
C
C   LAST MOD  J. HAGEMANN  21/09/84 :  USES NEW VERSION OF DRSTEP
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2(H)
      LOGICAL FOUND, ENRLOS, ELOSS, MULSC
C
      COMMON / CSTORE / MHITS, IPV, HSTORE(2000)
C
      COMMON / CJTRLE / TOTLEN, STPLEN
      COMMON / CJSWLD / ITIMOD, MULSC, ELOSS
C
      COMMON / CJVCEL / MCELL, MWIRE
C
      COMMON / CJVTXC / RVEC, ANG1, ANG2, DISTPW, FIRSTP, DISTW1,
     +                  ANGL, COSLOR, SINLOR,
     +                  ZRESV, ZMAXV, ZOFFV, ZNAMP, ZALV, TIMEV
      COMMON / CIJONV / POTVXC, ZAROVC,
     +                  POTVGA, ZAROVG
      COMMON / CGEOV  / RPIPV, DRPIPV, XRLPIV, RVXC, DRVXC, XRLVXC,
     +                  ZVXCM, DZVCM, XRZVCM, ZVXCP, DZVCP, XRZVCP,
     +                  XRVTXC
C
      DIMENSION R(5), P(7), RX(5), RXOLD(3), RXREL1(3), RXREL2(3)
      DIMENSION HDV(4)
      EQUIVALENCE (HDV(1), HMWTOT), (HDV(2), HITAML),
     *            (HDV(3), HITAMR), (HDV(4), HITIM)
C
      DATA  ITERMX / 300 /
      DATA  PMIN / 0.01 /
      DATA  BINWID / 0.003 /
      DATA  TWOPI  / 6.2831853 /
C
C------------------------  C O D E  ------------------------------------
C
      PENETR = 0.
      PENETZ = 0.
      R(4) = SQRT( R(1) * R(1) + R(2) * R(2) )
C
 10   IF ( R(3) .GE. ZDOWN ) GOTO 20
           JRETRN = 3
           RETURN
 20   IF ( R(3) .LE. ZUP )   GOTO 30
           JRETRN = 2
           RETURN
 30   IF ( R(4) .GE. RDOWN ) GOTO 40
           JRETRN = 1
           RETURN
 40   IF ( R(4) .LE. RUP )   GOTO 50
           JRETRN = 0
           RETURN
C
  50  R(5) = ATAN2(R(2), R(1))
           IF ( R(5) .LT. ANG1 ) R(5) = R(5) + TWOPI
           ICELL = IFIX(( R(5) - ANG1 )/ANG2 + .4999)
           ICELL = MOD( ICELL, MCELL )
           PHI = FLOAT( ICELL )*ANG2 + ANG1
           COSPHI = COS(PHI)
           SINPHI = SIN(PHI)
C                                                 ROTATE COORD.
      CALL JROTAT ( R, COSPHI, SINPHI )
      CALL JROTAT ( P, COSPHI, SINPHI )
      RX(1) = R(1)
      RX(2) = R(2)
      RX(3) = R(3)
C                                                 CHECK FRAME OF CELL
      HMWOLD = 0
C
C
      XTRACK = 0.
      XLIMIT = (( P(6)*P(6)/P(4)/21.E-3*BINWID)**2*XRVTXC)**.333333
      XLIMIT = AMIN1( AMAX1(10.,XLIMIT), 100. )
      ETRACK = 0.
      ENRLOS = .FALSE.
      IF(ELOSS.AND.(P(4)/P(5).LT.3..OR.P(5).LT..001)) ENRLOS=.TRUE.
      ELIMIT = AMIN1( 100., 500.*P(6)*P(6))
C
C
      CALL JFTEST ( RX, P, JRETRN, &2000 )
      JRETRN = 4
      MWBASE = ICELL * MWIRE
C
      RXPRO = RX(1) + RX(2) * TANLOR
      MW = ( RXPRO - DISTW1 ) / DISTPW + 1.5
C                                                 PREPARE CHANGE
C                                                 TO NEW COORD.
C                                                 TRX=TRANSLATION
      TRX = DISTW1 + ( MW - 1) * DISTPW
C                                                 START TRACKING
      ITERAT = 0
200   ITERAT = ITERAT + 1
C                                                 SAVE OLD COORD.
           RXOLD(1) = RX(1)
           RXOLD(2) = RX(2)
           RXOLD(3) = RX(3)
      CALL JSTEP( RX, P, DRTOT, DRMAX )
           TOTLEN = TOTLEN + DRTOT
           XTRACK = XTRACK + DRTOT
           ETRACK = ETRACK + DRTOT
C                                                 CHECK
      CALL JFTEST ( RX, P, JRETRN, &2000 )
C                                                 TEST FOR DEATH SPACE
      IF ( MW .LT. 1 .OR. MW .GT. MWIRE ) GOTO 600
C
      RXTRA = RXOLD(1) - TRX
      RYTRA = RXOLD(2)
C
C      WRITE ( 6, 390 ) RXTRA,  RYTRA
C390   FORMAT (' RXTRA =',  F8.3, '   RYTRA= ' , F8.3 )
C
      RXREL1(1) = RXTRA * COSLOR + RYTRA * SINLOR
      RXREL1(2) = RYTRA * COSLOR - RXTRA * SINLOR
C
      RXTRA = RX(1) - TRX
      RYTRA = RX(2)
C
C      WRITE ( 6, 396 ) RXTRA,  RYTRA
C396   FORMAT (' RXTRA =',  F8.3, '   RYTRA= ' , F8.3 )
C
      RXREL2(1) = RXTRA * COSLOR + RYTRA * SINLOR
      RXREL2(2) = RYTRA * COSLOR - RXTRA * SINLOR
C                                                COORD.REL FOR FIRST
C                                                STEP POINT
        ASSIGN 600 TO LABEL
C
 400  CALL JVDTIM ( RXREL1, RXREL2, FOUND, DIST, SLOPE )
      IF ( .NOT. FOUND ) GOTO 500
C                                                ABSOLUTE WIRE NUMBER
      HMWTOT = MWBASE + MW
C--------------------------------------------------------------------
C                                                DRIFT TIME IN MICROM.
      AITIM = AMIN1 (DIST/TIMEV, 32767.)
      HITIM = HFIX(AITIM)
C                                                Z - COORD. (MM)
      HITAML = RX(3) + SIGN(.5, RX(3))
      HITAMR = 0
C---------------------------------------------------------------------
      IF ( HMWOLD .NE. HMWTOT ) GOTO 460
C                                                CHANGE IN WIRE NUMBER ?
      IF ( HSTORE(IPV - 1) .LE. HITIM ) GOTO 500
      GOTO 470
C                                                SMALLER DRIFT TIME FOR
C                                                THE SAME WIRE ?
 460  MHITS = MHITS + 1
      IPV = IPV + 4
      IF (IPV .GT. 2000) RETURN 1
C
C
 470  CALL MVC ( HSTORE, 2*IPV - 10 , HDV , 0 , 8 )
C
C
           HMWOLD = HSTORE(IPV - 4)
C
 500  CONTINUE
      GOTO LABEL, (600, 900)
C                                               WIRE NUMBER FOR 2.POINT
 600  MW1 = MW
      RXPRO = RX(1) + RX(2) * TANLOR
      MW = ( RXPRO - DISTW1 ) / DISTPW + 1.5
C                                                 PREPARE CHANGE
C                                                 TO NEW COORD.
C                                                 TRX=TRANSLATION
      TRX = DISTW1 + ( MW - 1) * DISTPW
C
      IF ( MW1 .EQ. MW .OR. MW .LT. 1
     *     .OR. MW .GT. MWIRE )       GOTO 900
C
      RXTRA = RXOLD(1) - TRX
      RYTRA = RXOLD(2)
      RXREL1(1) = RXTRA * COSLOR + RYTRA * SINLOR
      RXREL1(2) = RYTRA * COSLOR - RXTRA * SINLOR
C
      RXTRA = RX(1) - TRX
      RYTRA = RX(2)
      RXREL2(1) = RXTRA * COSLOR + RYTRA * SINLOR
      RXREL2(2) = RYTRA * COSLOR - RXTRA * SINLOR
      ASSIGN 900 TO LABEL
      GOTO 400
C
 900  CONTINUE
          IF ( TOTLEN .GT. STPLEN )  GOTO 2000
C
                 IF( .NOT. ENRLOS .OR. ETRACK .LT. ELIMIT ) GO TO 930
       CALL JELOSS ( P, ETRACK, POTVGA, ZAROVG, XRVTXC,
     *               RX, COSPHI, SINPHI )
                       ETRACK = 0.
                 IF( P(6) .LE. PMIN ) GO TO 2000
  930            IF( .NOT. MULSC .OR. XTRACK .LT. XLIMIT ) GO TO 1000
       CALL JMULSC( P, XTRACK/XRVTXC )
                       XTRACK = 0.
C
 1000  IF ( ITERAT .LT. ITERMX ) GOTO 200
C                                                 ROTATE BACK
 2000 CALL JROTAT ( RX, COSPHI, -SINPHI )
      CALL JROTAT ( P, COSPHI, -SINPHI)
      R(1) = RX(1)
      R(2) = RX(2)
      R(3) = RX(3)
C
      IF ( JRETRN .EQ. 5 ) GOTO 50
      R(4) = SQRT( R(1) * R(1) + R(2) * R(2) )
      IF ( JRETRN .EQ. 0 ) PENETR = R(4) - RUP
      IF ( JRETRN .EQ. 1 ) PENETR = RDOWN - R(4)
      IF ( JRETRN .EQ. 2 ) PENETZ = R(3) - ZUP
      IF ( JRETRN .EQ. 3 ) PENETZ = ZDOWN - R(3)
C
      RETURN
      END

C   27/06/80 010081657  MEMBER NAME  GGFAC3   (S)           FORTRAN
      SUBROUTINE GGFAC3
C---  COPY CALIBRATION CONSTANTS OF LEAD-GLASS INTO COMMON /CALICO/
C---  RUN 2751 TO RUN 4864
C
C     H.WRIEDT    13.09.79     19:00
C     LAST MODIFICATION    27.07.80   16:35
C
      COMMON /CFACT3/ FACT3(191)
      COMMON /CALICO/ FAKTOR(191)
C
        DO 1 I = 1,191
    1   FAKTOR(I) = FACT3(I)
      WRITE(6,600)
  600 FORMAT(/' *** THIRD SET OF LEAD-GLASS CALIBRATION CONSTANTS',
     &        ' INCLUDED ***')
      RETURN
      END
      BLOCK DATA
C
      COMMON /CFACT3/ FACT3
C     THIS DATA APPLICABLE FROM RUN 2751 TO RUN 4864
C     THE GAIN ASSUMES ENERGY(MEV)=CHANNEL*5.0
      REAL*4 FACT3(191)/191*1.65/
      END

C   11/09/78 110071140  MEMBER NAME  JTRAPZ0  (S)           FORTRAN
      SUBROUTINE JTRAPZ( IFORM, X, P, XLOW, XHIGH, ZLOW, ZHIGH,
     *                   POT, ZARO, XRAD, IRETRN, CA, SA )
C--------------------------------------------------------
C
C  VERSION OF 02/10/78   LAST MOD 07/10/81   E.ELSEN
C  PROPAGATES PARTICLE IN NON ABSORBING MEDIUM
C  DEFINED BY XLOW, XHIGH, ZLOW, ZHIGH.
C  CA AND SA ARE THE OVERALL COS AND SIN FOR ROTATION
C  BACK TO MAIN COORDINATE SYTEM
C  THE EXACT GEOMETRY IS DEFINED BY SWITCH IFORM
C  IRETRN GIVES RETURN CODE.
C  IRETRN=0 : NEXT ELEMENT, INCREASING X
C        =1 : NEXT ELEMENT, DECREASING X
C        =2 : NEXT ELEMENT, INCREASING Z
C        =3 : NEXT ELEMENT, DECREASING Z
C        =4 : PARTICLE STOPPED IN SYSTEM OR DECAY CONDITION
C             REACHED.
C        =5 : NEXT ELEMENT, CHANGING PHI
C--------------------------------------------------------
C
      DIMENSION X(5), P(7)
      COMMON / CJTRLE / TOTLEN, STPLEN
      COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
      LOGICAL  ELOSS, MULSC
      COMMON / CJXDAT / XSLOPE, YSLOPE, XL(3), XH(3), R3P, RD3P,
     *                  S, S2,
     *                  XSL3L, X3L, XSL3H, X3H, YSL3L, Y3L, YSL3H,
     *                  YHWIDT, SINHLF, COSHLF, DRITAN
C
      DATA PMIN / 0.01 /
C
      IRETRN = 4
C
      DO 100 ITERAT = 1,300
C
      GO TO ( 10, 11, 12 ), IFORM

   10 IF( X(1) .LE. XHIGH ) GO TO 20
          IRETRN = 0
          RETURN
   20 IF( X(1) .GE. XLOW ) GO TO 30
          IRETRN = 1
          RETURN
C
   11 IF( X(1) .LE. XSLOPE*ABS(X(2))+XHIGH ) GO TO 21
          IRETRN = 0
          RETURN
   21 IF( X(1) .GE. XSLOPE*ABS(X(2))+XLOW ) GO TO 30
          IRETRN = 1
          RETURN
C
   30 IF( ABS( X(2) ) .LE.  YSLOPE*X(1) ) GO TO 40
          IRETRN = 5
          RETURN
C
   12 IF( X(1) .LE. XSLOPE*ABS(X(2))+XHIGH ) GO TO 22
          IRETRN = 0
          RETURN
   22 IF( X(1) .GE. XLOW ) GO TO 32
          IRETRN = 1
          RETURN
   32 IF( ABS( X(2) ) .LE.  YHWIDT ) GO TO 40
          IRETRN = 5
          RETURN
C
   40 IF( X(3) .LE. ZHIGH  ) GO TO 50
          IRETRN = 2
          RETURN
   50 IF( X(3) .GE. ZLOW  ) GO TO 60
          IRETRN = 3
          RETURN
C
   60 CALL JSTEP( X, P, DRTOT )
C      TOTAL TRACK LENGTH BIGGER THAN MAXIMUM VALUE?
              TOTLEN = TOTLEN  + DRTOT
              IF( TOTLEN .GT. STPLEN ) RETURN
C
          IF( MULSC ) CALL JMULSC( P, DRTOT / XRAD )
          IF( ELOSS ) CALL JELOSS( P, DRTOT, POT, ZARO, XRAD,
     *                             X, CA, SA )
          IF( P(6) .LT. PMIN ) RETURN
C
C
  100 CONTINUE
C
      RETURN
      END

C   09/02/79 311181555  MEMBER NAME  TOFMAK   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFMAK
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       INTEGER *2 HDATA
       COMMON/CTWRK/ IADC(2,42),ITDC(2,42)
       COMMON/CTOF/  HDATA(188)
C
       DO 100 I=1,42
       IM= I-1
       I2= 2*I
       IAA= IM/6+I2+1
       IAT= IM/4+I2+92
       HDATA(IAA)=   IADC(1,I)
       HDATA(IAA+1)= IADC(2,I)
       HDATA(IAT)=   ITDC(1,I)
       HDATA(IAT+1)= ITDC(2,I)
 100   CONTINUE
C
C BANK DESCRIPTOR WORD SET TO 1, J.OLSSON,B.NAROSKA  18.11.1983
C
       HDATA(1)= 1
C
C      DO 200 I=1,42
C200   WRITE(6,9000) I,(IADC(J,I),J=1,2),(ITDC(K,I),K=1,2)
C9000  FORMAT(11I10)
C      WRITE(6,9000) HDATA
       RETURN
       END

      SUBROUTINE ZCFTNW(NRUN,NEVT,ITRK,TGTH,ZVERT,NZHIT,IZCHMB,AZCHMB)
      DIMENSION IZCHMB(3,2),AZCHMB(3,2)
      DATA NRUNLS/-99/,NEVTLS/-99/,JZERR/0/
      COMMON/CZDATA/JZDATA(64),IZDATA(3,8,64),RZDATA(3,8,64)
      COMMON/CZTRK /RZTRK(5,100),IZTRK(3,2,100), RRTRK(2,100)
      LOGICAL FIRST / .TRUE. /
      IF(
     - NEVT.NE.NEVTLS .OR. NRUN.NE.NRUNLS
     -)THEN
      IF(
     - FIRST
     -)THEN
        FIRST = .FALSE.
        WRITE(6,1111)
1111    FORMAT(' Z-CHAMBER HITS ARE USED IN FITTING WITH ZSRFTV ')
      ENDIF
       NEVTLS=NEVT
       NRUNLS=NRUN
       CALL ZCDATA(NTPAT,NZHT,NASS1,NASS2,JZERR)
      ENDIF
      NZHIT=0
      IF(JZERR.NE.0) RETURN
      IMIR=IZTRK(1,1,ITRK)
      IF(
     - IMIR.GT.0
     -)THEN
         IHT=IZTRK(2,1,ITRK)
         IWR=IZTRK(3,1,ITRK)
         PHI=RZTRK(2,ITRK)
         RR = RRTRK(1,ITRK)
         XX=RR*COS(PHI)
         YY=RR*SIN(PHI)
         ZZ=RZDATA(IMIR,IHT,IWR)-13.77
      IF(
     - XX.LT.0.
     -)THEN
      IF(
     - ZZ.LT.-270.
     -)THEN
               ZZ=ZZ-10.9-1.0414E-2*(ZZ+270.)+7.93616E-6*(ZZ+270.)**2
      ELSE
               ZZ=ZZ-10.9+1.98198E-2*(ZZ+270.)-5.13690E-6*(ZZ+270.)**2
      ENDIF
      IF(
     - NRUN.LT.24200
     -)THEN
      IF(
     - ZZ.LT.-270.
     -)THEN
                  ZZ=ZZ+9.2+5.25E-3*(ZZ+270.)
      ELSE
                  ZZ=ZZ+9.2-1.49E-2*(ZZ+270.)+5.1E-6*(ZZ+270.)**2
      ENDIF
               ZZ=ZZ-4.7E-2+9.87E-5*ZZ
      ENDIF
      ELSE
      IF(
     - ZZ.LT.-270.
     -)THEN
               ZZ=ZZ-2.995-3.42774E-3*(ZZ+270.)+1.3112E-5*(ZZ+270.)**2
      ELSE
               ZZ=ZZ-2.995+7.2565E-3*(ZZ+270.)
      ENDIF
      IF(
     - NRUN.GE.24200
     -)THEN
               ZZ=ZZ+1.-2.8E-3*ZZ
               ZZ=ZZ-.076+2.67E-4*ZZ
      ELSE
      IF(
     - NRUN.GE.20275
     -)THEN
      IF(
     - ZZ.LT.0.
     -)THEN
                     ZZ=ZZ-8.09E-3*ZZ-4.5E-6*ZZ**2
      ELSE
                     ZZ=ZZ-8.09E-3*ZZ+5.85E-6*ZZ**2
      ENDIF
      ELSE
      IF(
     - ZZ.LT.480.
     -)THEN
                     ZZ=ZZ+7.75-1.367E-2*ZZ-1.309E-5*ZZ**2
      ELSE
                     ZZ=ZZ-1.34+2.556E-2*(ZZ-500.)-4.25E-5*(ZZ-500.)**2
      ENDIF
      ENDIF
               ZZ=ZZ-.085+1.59E-4*ZZ
      ENDIF
      ENDIF
         NZHIT=NZHIT+1
         IZCHMB(1,NZHIT)=IWR
         IZCHMB(2,NZHIT)=1
         IZCHMB(3,NZHIT)=IMIR
         AZCHMB(1,NZHIT)=XX
         AZCHMB(2,NZHIT)=YY
         AZCHMB(3,NZHIT)=ZZ
      ENDIF
      IMIR=IZTRK(1,2,ITRK)
      IF(
     - IMIR.GT.0
     -)THEN
         IHT=IZTRK(2,2,ITRK)
         IWR=IZTRK(3,2,ITRK)
         PHI=RZTRK(4,ITRK)
         RR = RRTRK(2,ITRK)
         XX=RR*COS(PHI)
         YY=RR*SIN(PHI)
         ZZ=RZDATA(IMIR,IHT,IWR)-14.06
      IF(
     - XX.LT.0.
     -)THEN
      IF(
     - ZZ.LT.-270.
     -)THEN
               ZZ=ZZ-10.9-1.0414E-2*(ZZ+270.)+7.93616E-6*(ZZ+270.)**2
      ELSE
               ZZ=ZZ-10.9+1.98198E-2*(ZZ+270.)-5.13690E-6*(ZZ+270.)**2
      ENDIF
      IF(
     - NRUN.LT.24200
     -)THEN
      IF(
     - ZZ.LT.-270.
     -)THEN
                  ZZ=ZZ+9.2+5.25E-3*(ZZ+270.)
      ELSE
                  ZZ=ZZ+9.2-1.49E-2*(ZZ+270.)+5.1E-6*(ZZ+270.)**2
      ENDIF
               ZZ=ZZ+4.7E-2-9.87E-5*ZZ
      ENDIF
      ELSE
      IF(
     - ZZ.LT.-270.
     -)THEN
               ZZ=ZZ-2.995-3.42774E-3*(ZZ+270.)+1.3112E-5*(ZZ+270.)**2
      ELSE
               ZZ=ZZ-2.995+7.2565E-3*(ZZ+270.)
      ENDIF
      IF(
     - NRUN.GE.24200
     -)THEN
               ZZ=ZZ+1.-2.8E-3*ZZ
               ZZ=ZZ+.076-2.67E-4*ZZ
      ELSE
      IF(
     - NRUN.GE.20275
     -)THEN
      IF(
     - ZZ.LT.0.
     -)THEN
                     ZZ=ZZ-8.09E-3*ZZ-4.5E-6*ZZ**2
      ELSE
                     ZZ=ZZ-8.09E-3*ZZ+5.85E-6*ZZ**2
      ENDIF
      ELSE
      IF(
     - ZZ.LT.480.
     -)THEN
                     ZZ=ZZ+7.75-1.367E-2*ZZ-1.309E-5*ZZ**2
      ELSE
                     ZZ=ZZ-1.34+2.556E-2*(ZZ-500.)-4.25E-5*(ZZ-500.)**2
      ENDIF
      ENDIF
               ZZ=ZZ+.085-1.59E-4*ZZ
      ENDIF
      ENDIF
         NZHIT=NZHIT+1
         IZCHMB(1,NZHIT)=IWR
         IZCHMB(2,NZHIT)=2
         IZCHMB(3,NZHIT)=IMIR
         AZCHMB(1,NZHIT)=XX
         AZCHMB(2,NZHIT)=YY
         AZCHMB(3,NZHIT)=ZZ
      ENDIF
      RETURN
      END

C   04/02/88 807222047  MEMBER NAME  TPVOPT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPVOPT( ERROR )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       4/02/88:  Verify TP options
C
C          mod: C. Bowdery      16/03/88:  Add TRACK options
C          mod: C. Bowdery       7/06/88:  Add VPROCESS option to TRACK
C     Last mod: C. Bowdery      22/07/88:  Set VTXC options.
C
C     Routine to verify TP options in the options table.
C     Errors are printed when found.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     ERROR     Out      L*4      TRUE if errors found
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      PARAMETER  ( NP  = 15, NG = 10 )
      PARAMETER  ( N1  = NP-1, N2  = NP-2,  N3  = NP-3,  N4  = NP-4 )
      PARAMETER  ( N5  = NP-5, N6  = NP-6,  N7  = NP-7,  N8  = NP-8 )
      PARAMETER  ( N9  = NP-9, N10 = NP-10, N11 = NP-11, N12 = NP-12)

      CHARACTER   CTPOPT*20, CVALID(NP,NG)*20
      CHARACTER   CREFIT*8,  CSTRNG*20, CWEAK*20

#include "tables.for"

      LOGICAL  ERROR, WEAK, STRONG, TCOPY(NOPTS)

      DATA  CVALID /
     +  'MUON',  'ANALYSE', 'TP', 'DELETE', 'FULL', 'IFNOTDONE', N6*' ',
     +  'TOF',   'ANALYSE','IFNOTDONE','TP','DELETE', N5*' ',
     +  'TAGG',  'ANALYSE','IFNOTDONE','TP','DELETE', N5*' ',
     +  'VTXC',  'ANALYSE','COMFIT', N3*' ',
     +  'LG',    'ANALYSE','IFNOTDONE','TP','DELETE',
     +           'LGCAL','IFNOLGCAL','TRACKMATCH', N8*' ',
     +  'CALCS', 'THRUST','SPHERICITY','REDUCTION', N4*' ',
     +  'REFIT', 'RFI','IFNORFI','WEAKVTX','STRONGVTX','ZS','IFNOZS',
     +           'COMMONZVTX','OLDPATR', N9*' ',
     +  'DEDX',  'ANALYSE','TP', N3*' ',
     +  'TRACK', 'TP', 'DELETE', 'VPROCESS', N4*' ',
     +  'JETC',  'ANALYSE','OLDDEL','RFICAL','IFNORFICAL',
     +           'ZCAL','ZVTX','IFNOTDONE', N8*' '/

      DATA CREFIT, CSTRNG, CWEAK / 'REFIT', 'STRONGVTX', 'WEAKVTX' /

C------------------  C O D E  ------------------------------------------

      ERROR = .FALSE.

C                            Check each option group in turn

      DO  70  K = 1,NOG

C                            Copy row of true/false options

        DO  10  I = 1,NOK

          TCOPY(I) = ATABLE( K, I )

  10    CONTINUE

C                            Check that the specified options
C                            are valid for this option group by checking
C                            off the valid options in TCOPY using CVALID

        DO  30  I = 1,NG

          IF( CVALID(1,I) .EQ. NTABLE(K) ) THEN

            DO  20  J = 2,NP

              CTPOPT = CVALID( J, I )
              IF( CTPOPT .EQ. ' ' ) GO TO 25

C                            Find the table location of this option

              DO  15  MPOS = 1,NOK

                IF( CTPOPT .EQ. OTABLE( MPOS ) ) GO TO 18

  15          CONTINUE

C                            Programmer error! Option not in OTABLE

              CALL TPERRH
              ERROR = .TRUE.
              RETURN

C                            Clear the flag in the temporary table

  18          TCOPY( MPOS ) = .FALSE.

  20        CONTINUE

C                            Any entries not checked off in TCOPY?

  25        DO  28  N = 1,NOK

              IF( TCOPY(N) ) THEN
                ERROR = .TRUE.

C                            Print the illegal option

                WRITE(6,26)  OTABLE(N), NTABLE(K)
  26            FORMAT(/'  ****   TP option error!  Keyword ',A20,
     +                  ' is not valid for option group  ',A8)
              ENDIF

  28        CONTINUE

C                            Terminate loop over CVALID
            GO TO 70

          ENDIF

  30    CONTINUE

C                            If here then option group not in CVALID

        CALL TPERRH
        PRINT *,CVALID(1,I),I,NTABLE(K),K

        ERROR = .TRUE.

  70  CONTINUE

C                            Check for incompatible options

      CALL TPUOPT( CREFIT, CSTRNG, STRONG )
      CALL TPUOPT( CREFIT, CWEAK,  WEAK   )

      IF( STRONG  .AND.  WEAK ) THEN

        ERROR = .TRUE.
        WRITE(6,85)
  85    FORMAT(/'  ****   TP Option error!  STRONGVTX and WEAKVTX are ',
     +          'incompatible options')

      ENDIF

      RETURN
      END

      SUBROUTINE LOC(I,J,IR,N,M,MS)
C
C     PURPOSE
C        COMPUTE A VECTOR SUBSCRIPT FOR AN ELEMENT IN A MATRIX OF
C        SPECIFIED STORAGE MODE
C
C     DESCRIPTION OF PARAMETERS
C        I   - ROW NUMBER OF ELEMENT
C        J   - COLUMN NUMBER OF ELEMENT
C        IR  - RESULTANT VECTOR SUBSCRIPT
C        N   - NUMBER OF ROWS IN MATRIX
C        M   - NUMBER OF COLUMNS IN MATRIX
C        MS  - ONE DIGIT NUMBER FOR STORAGE MODE OF MATRIX
C               0 - GENERAL
C               1 - SYMMETRIC
C               2 - DIAGONAL
C     REMARKS
C        NONE
C
C     SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C        NONE
C
C     METHOD
C        MS=0   SUBSCRIPT IS COMPUTED FOR A MATRIX WITH N*M ELEMENTS
C               IN STORAGE (GENERAL MATRIX)
C        MS=1   SUBSCRIPT IS COMPUTED FOR A MATRIX WITH N*(N-1)/2 IN 
C               STORAGE (UPPER TRIANGLE OF SYMMETRIC MATRIX). IF
C               ELEMENT IS IN LOWER TRIANGULAR PORTION, SUBSCRIPT IS
C               CORRESPONDING ELEMENT IN UPPER TRIANGLE
C        MS=2   SUBSCRIPT IS COMPUTED FOR A MATRIX WITH N ELEMENTS 
C               IN STORAGE (DIAGONAL ELEMENTS OF DIAGONAL MATRIX).
C               IF ELEMENT IS NOT ON DIAGONAL (AND THEREFORE NOT IN 
C               STORAGE), IR IS SET TO ZERO
C
C     ..............................................................
C
      IX=I
      JX=J
      IF(MS-1) 10,20,30
   10 IRX=N*(JX-1)+IX
      GO TO 36
   20 IF(IX-JX) 22,24,24
   22 IRX=IX+(JX*JX-JX)/2
      GO TO 36
   24 IRX=JX+(IX*IX-IX)/2
      GO TO 36
   30 IRX=0
      IF(IX-JX) 36,32,36
   32 IRX=IX
   36 IR=IRX
      RETURN
      END 

C   18/10/82 210181136  MEMBER NAME  MCMAIN0  (S)           FORTRAN
      COMMON / BCS / IW(24000)
      CALL BINT( 24000, 5000, 500, 0 )
      CALL MCJADE( 0, 50 )
      CALL BSTA
      CALL PALL
      STOP
      END

C   21/11/78 C9071601   MEMBER NAME  ZBOS09   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------900000200
C     9.  BANKS ON DIRECT ACCESS DATA SETS
C
C     THE DIRECT ACCESS BOS ROUTINES ALLOW TO STORE BANKS ON A DIRECT
C     ACCESS DATA SET, CALLED DADS, AND, IN THE SAME JOB OR IN A LATER
C     JOB, TO GET THE BANKS BACK TO THE COMMON/BCS/ OR TO DELETE BANKS
C     ON THE DADS (SEE CH. 9.2). THE ROUTINES USE THE IBM-FORTRAN
C     DIRECT ACCESS FEATURES (E.G. DEFINE FILE), THEY WORK WITH
C     RECORDS OF FIXED LENGTH 1610 WORDS, HOWEVER THE BANKS MAY HAVE
C     ANY LENGTH BETWEEN 1 WORD AND 3200 WORDS.
C     THE DADS HAS TO BE INITIALIZED (SEE CH 9.1) BEFORE THE FIRST
C     BANK IS ADDED TO THE DADS.
C
C
C     9.1  INITIALIZATION OF A DADS
C
C     A DADS IS INITIALIZED BY THE FOLLOWING STATEMENTS, USING THE
C     DD-CARD SHOWN.
C
C          DEFINE FILE IU(NREC,1610,U,IVAR)
C          CALL BINLDA(IU,NREC,IPASS)
C
C     //FTIUF001 DD DSN=DSNAME,DISP=(NEW,CATLG),UNIT=FAST,
C     //   SPACE=(6440,(NREC))
C
C          WHERE    IU = (CONSTANT) FORTRAN=NR. OF THE DADS, EQUAL
C                        TO 17, 18 OR 19
C                 NREC = (CONSTANT) NR OF RECORDS, OF LENGTH 1610 WORDS.
C                        AT LEAST NREC = 10.
C                IPASS = PASSWORD (SEE CH.9.4) FOR PROTECTION
C                        OF THE DADS (NO PROTECTION FOR IPASS = 0)
C                 IVAR = DUMMY VARIABLE
C               DSNAME = DSNAME OF THE DADS
C
C     IN LATER JOBS, THE DD-CARD SHOULD CONTAIN DISP=SHR. THE
C     DEFINE FILE STATEMENT IS NOT NECCESSARY IN LATER JOBS,
C     UNLESS NREC IS GREATER THAN 200.
C
C     WITH NREC = 70, THERE IS SPACE ON THE DADS FOR ABOUT
C     100 000 WORDS.
C
C
C     9.2   STORING AND RETRIEVING BANKS
C
C     IF ANY OF THE CALLS DESCRIBED HERE IS USED, A STATEMENT
C     EXTERNAL BLOCDA
C     SHOULD BE INCLUDED IN THE USER-PROGRAM, TO MAKE SHURE
C     THAT THE SUBROUTINE BLOCDA, WHICH HAS THE ADDITIONAL
C     ENTRIES BCREDA, BDLSDA AND BCHKDA, IS INCLUDED BY THE
C     LINK EDITOR.
C     SEE CH. 9.4 FOR THE USE OF PROTECTED DADS.
C
C
C                 ----- ---
C     CALL BCREDA(IUNDA,IND)
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IND   = INDEX OF THE BANK TO BE STORED ON THE DADS
C
C     THE BANK AT THE INDEX IND IS STORED ON THE DADS, IF THE LENGTH
C     OF THE BANK IS BETWEEN 1 AND 3200 WORDS, AND IF THERE IS ENOUGH
C     SPACE ON THE DADS. IF THERE IS ALREADY A BANK WITH THE SAME
C     NAME AND NR ON THE DADS, THEN THE OLD ONE IS REPLACED BY THE
C     NEW ONE. IF THE LENGTH OF THE OLD BANK IS EQUAL TO THE LENGTH
C     OF THE NEW BANK, NO ADDITIONAL SPACE IS USED ON THE DADS.
C
C
C
C                 -----     ---- --
C     CALL BLOCDA(IUNDA,IND,NAME,NR,&1)
C                       ---         --
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IND   = INDEX OF THE BANK TO BE STORED ON THE DADS
C              NAME  = NAME OF THE BANK
C              NR    = NUMBER OF THE BANK
C              &1    = RETURN 1, IF BANK NOT FOUND (IND=0)
C
C     IF THE BANK IS ALREADY IN STORAGE, THE INDEX IND IS GIVEN
C     WITHOUT SEARCHING THE DADS. OTHERWISE THE DADS IS SEARCHED FOR
C     THE BANK (NAME,NR). IF FOUND, THE BANK IS STORED IN THE
C     COMMON/BCS/.
C
C
C
C
C                 ----- ---- --
C     CALL BDLSDA(IUNDA,NAME,NR)
C
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              NAME  = NAME OF THE BANK
C              NR    = NUMBER OF THE BANK
C
C     THE BANK IS DELETED FROM THE DADS. THE SPACE USED ON THE DADS
C     CANNOT BE USED FOR NEW BANKS.
C
C
C
C
C                 ----- ---- --
C     CALL BCHKDA(IUNDA,NAME,NR,NW)
C                               --
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              NAME  = NAME OF THE BANK
C              NR    = NUMBER OF THE BANK
C              NW    = NR OF WORDS OF THE BANK (NW = 0, IF NOT FOUND
C                      ON THE DADS)
C
C     THE DADS IS SEARCHED FOR THE BANK (NAME,NR). IF FOUND, THE
C     LENGTH OF THE BANK IS GIVEN IN NW (OTHERWISE NW = O).
C
C
C     9.3   UNLOADING AND LOADING THE DADS
C
C     THE SUBROUTINE DESCRIBED BOTH NEED ABOUT 6000 WORDS OF
C     BANK STORAGE, BOTH MAKE A GARBAGE COLLECTION BEFORE THEY
C     RETURN.
C
C                 ----- ----- ---- ----- -----
C     CALL BUNLDA(IUNDA,IUNTP,NREC,NPAGE,IPASS)
C
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IUNTP = FORTRAN UNIT OF THE SEQUENTIAL DA
C              NREC  = NR OF USED RECORDS OF THE DADS, TO BE UNLOADED,
C                      USUALLY THIS ARGUMENT CAN BE ZERO(SEE BELOW)
C              NPAGE = NR OF PAGES FOR PRINTOUT
C              IPASS = PASSWORD
C
C     ALL BANKS FROM THE DADS ARE WRITTEN (S-TYPE RECORDS) ONTO
C     THE SEQUENTIAL DATASET. THIS IS ALSO DONE, IF THE PASSWORD
C     IS NOT CORRECT. IF NREC = 0, THEN THE NR OF RECORDS
C     IS TAKEN FROM THE DADS (USUAL CASE). NREC SHOULD ONLY BE
C     GIVEN IN SPECIAL CASES.
C     DURING UNLOADING A TABLE (NAMES, NUMBERS, LENGTHS) IS
C     PRINTED (MAXIMUM NPAGE PAGES). IF IUNTP = 0, THEN ONLY
C     THE TABLE OF CONTENT IS PRINTED.
C
C
C
C
C                 ----- ----- -----
C     CALL BLOADA(IUNDA,IUNTP,IPASS)
C
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IUNTP = FORTRAN UNIT OF SEQUENTIAL DATA SET,
C                      OBTAINED BY THE USE OF BUNLDA.
C              IPASS = PASSWORD
C
C     THE PROGRAM STOPS, IF THE DADS IS PROTECTED AND AN
C     INCORRECT PASSWORD IS USED.
C     ALL BANKS OF THE SEQUENTIAL DATA SET ARE STORED ON THE
C     DADS, THE PREVIOUS CONTENT OF THE DADS IS OVERWRITTEN.
C
C
C
C     BUNLDA CAN BE USED TO WRITE BACKUP-COPIES OF THE DADS.
C     THE DADS CAN BE COMPRESSED BY THE USE OF BUNLDA, FOLLOWED
C     THE USE OF BLOADA.
C
C
C
C
C     9.4   PROTECTED DADS
C
C
C     IT IS POSSIBLE TO DEFINE A PASSWORD AT THE TIME OF INITIALIZATION
C     OF THE DADS. THEN, FOR ALL CALLS, WHICH MODIFY THE DADS, THE
C     CORRECT PASSWORD HAS TO BE GIVEN. IN ADDITION THERE IS A
C     SPECIAL PASSWORD, WHICH ALLOWS TO MODIFY PROTECTED DADS
C     WITHOUT KNOWING THE CORRECT PASSWORD.
C
C     THE PASSWORD IS GIVEN BY THE CALL
C
C                 ----- ----
C     CALL BPASDA(IUNDA,PASS)
C
C        WHERE  IUNDA = FORTRAN UNIT OF DADS
C               IPASS = PASSWORD
C
C
C
C     BPASDA HAS TO BE CALLED ONCE BEFORE ANY CALL OF
C     BCREDA OR BDLSDA, IF THE DATA SET IS PROTECTED AND
C     SHALL BE MODIFIED BY BCREDA OR BDLSDA. OTHERWISE THE
C     CALLS OF BCREDA AND BDLSDA ARE IGNORED.
C
C
      RETURN
      END

C   19/02/80 002200259  MEMBER NAME  @CHK     (SOURCE)      FORTRAN
C        CHECK NEW ROUTINES
      DIMENSION IF(29)
      E=15.
      R=350.*SQRT(2.)
      YY=425
      DO 40 JY=1,29
      YY=YY-5.
      XX=275.
      DO 30 JX=1,29
      XX=XX+5.
      RR=XX*XX+YY*YY
      DR=SQRT((XX-350.)**2+(YY-350.)**2)
      DDR=0.
      IF(ABS(DR).GT.0.) DDR=(SQRT(RR)-R)/DR
      CALL POSEND(E,0.1*DR,DDR,FACT,&30)
      IF(JX)=FACT*1000.+0.5
30    CONTINUE
      WRITE(6,900) IF
900   FORMAT(29I4)
40    CONTINUE
      STOP
      END

C   18/12/87 802031945  MEMBER NAME  TPROPT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPROPT( CTPOPT, COPT, END, IERROR )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery       18/12/87:  Read one record with TP opts
C
C
C
C     Routine to read in one record of user options from unit 5
C     and decode them. COPT = 'SPECIAL ' means that a special record
C     such as Event Numbers and Smearing Date has been already processed
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     CTPOPT    Out  CHAR*20      Array of options
C     COPT      Out   CHAR*8      Option group name
C                                 = 'SPECIAL ' if special option record
C     END       Out      L*4      Flag = .TRUE. if no more records
C                                 This is signalled if an EOF is found
C                                 or if a record with TPEND is found.
C     IERROR    Out      I*4      Error code variable from TPDECO
C                                   1 : illegal option group name
C                                   2 : unrecognised record
C                                   3 : extra options found
C                                   4 : no room for new option
C                                   5 : unknown option
C                                   6 : illegal syntax
C                                   7 : bad value
C                                  10 : READ error in this routine
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      PARAMETER  ( NOPT = 20 )

      LOGICAL  END, READER

      INTEGER  IERROR

      CHARACTER   COPT*8, STRING*80, CTPOPT( NOPT )*80

      COMMON / CTPRER / READER

C------------------  C O D E  ------------------------------------------

C                            Read a record from unit 5

      READER = .FALSE.
      END    = .FALSE.
   1  READ(5,5,END=80,ERR=90) STRING
   5  FORMAT( A80 )
      IF( STRING .EQ. ' ' ) GO TO 1

C                            Decode the string

      CALL TPDECO( STRING, CTPOPT, COPT, END, IERROR )

      RETURN

C                            EOF encountered on unit 5

  80  END = .TRUE.
      RETURN

C                            Unexpected read error on unit 5

  90  IERROR =  10

      READER= .TRUE.

      RETURN
      END

C   19/12/83 312192005  MEMBER NAME  MOFRCI   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MOFRCI( IND, R, P, CHARGE )
C-----------------------------------------------------------------------
C
C    VERSION OF 27/07/79     LAST MOD  10/08/79    E.ELSEN
C    FIND MOMENTUM P OF TRACK IND IN PATR BANK AT POSITION R.
C    MAG FIELD IS TAKEM FROM HEAD BANK.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))

      DIMENSION R(3), P(3)
      DATA BKGAUS / -4.5 /
C                                                FETCH MAG FIELD
      NPHEAD = IW( IBLN('HEAD') )
      IF( NPHEAD .EQ. 0 ) GO TO 10
      BKGAUS = HW( NPHEAD*2 + 30 ) / 1000.
C                                                FETCH TRACK PARAMETERS
   10 CALL PRTOCI( IND, CAP, RM, PHIM, SIG )
      DZDR = RW( IND + 30 )
C                                                TANGENT DIRECTION
      RMIT = RM + 1. / CAP
      RX = R(1) - RMIT*COS( PHIM )
      RY = R(2) - RMIT*SIN( PHIM )
      RTOT = SQRT( RX*RX + RY*RY ) * SIG
      EX = RY / RTOT
      EY = -RX / RTOT
C                                                RADIAL MOMENTUM
      PRAD = .3E-4*ABS(BKGAUS)/CAP
C                                                TOTAL MOMENTUM
      P(1) = PRAD * EX
      P(2) = PRAD * EY
      P(3) = PRAD * DZDR
C
      CHARGE = SIG
      IF( BKGAUS .LT. 0. ) CHARGE = -CHARGE
C
      RETURN
      END

      SUBROUTINE BAKPAK(ICHNG)
      IMPLICIT INTEGER*2 (H)
      LOGICAL DEADCL
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
      COMMON/CHEADR/HEAD(17),HRUN,HEV
      COMMON/CADMIN/IEVTP,NREC,NRWRIT,NRERR
       DIMENSION HTEMP(9),MAXC(3),HREP(10)
       EQUIVALENCE (RMSLI1,XBKK(33)),(IDLIM,IYBKK(10))
       EQUIVALENCE (JJPR,IXBKK(38))
       DATA MSKLRL /ZFFFFEFFF/,MAXC/24,24,48/
      CALL SETSL(HREP(1),0,20,0)
      RMSLI2=XBKK(34)
      IENTER=ICHNG
      IF(ICHNG.EQ.99) RMSLI2=0.
      IREM=IXYF(1)
      IXYF(1)=9 + 32
      ICHNG=0
      ILT=0
      IRPKNT=0
      RMSLIM=RMSLI1
      DO 13000 JKREP=1,2
      IKXKTR=0
16000 CONTINUE
      IKXKTR=IKXKTR+1
      KTR=IKXKTR
      IF(
     - JKREP.EQ.2
     -)THEN
      ILT=ILT+1
      IF(
     - ILT.LE.ITREP
     -)THEN
      KTR=HREP(ILT)
      ELSE
      GOTO 16001
      ENDIF
      ENDIF
      IF(
     - HNREL(KTR).NE.0
     -)THEN
       INUM=HNREL(KTR)
      IXX=KTR
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      IF(
     - IR1.GT.1.OR.IR2.LT.3
     -)THEN
      IRNG1=IR1
      IRNG2=IR2
      ICL1=KMP2
      LR1=0
      IF(KMP1.NE.KMP2) LR1=1
      RMSOLD=9999.
      DO 13002 JTR=1,100
      IF(
     - HNREL(JTR).NE.0.AND.JTR.NE.KTR
     -)THEN
      IXX=JTR
      ASSIGN 17002 TO IZZZ01
      GOTO 17000
17002 CONTINUE
      IF(
     - IR2.LT.IRNG1.OR.KMP1.NE.KMP2.AND.IR2.LE.IRNG1
     -)THEN
      IPTRK=HISTR(1,JTR)
      IPTRK=IABS(IPTRK)
      ISPEC=0
      IF(HNREL(JTR).EQ.1.AND.NRHT(IPTRK).LT.5.AND.IR2.EQ.1) ISPEC=1
      IF(
     - HNREL(JTR).GT.1.OR.NRHT(IPTRK).GT.0.OR.IR2.GT.1
     -)THEN
      ICL2=KMP1
      IF(IRNG1.EQ.3) ICL=(ICL1+1)/2
      IF(IRNG1.EQ.2) ICL=ICL1-24
      IF(IRNG1.EQ.3.AND.IR2.EQ.1) ICL=ICL-24
      IF(IR2.EQ.IRNG1) ICL=ICL1
      IDIF=IABS(ICL-ICL2)
      IF(
     - IDIF.GT.MAXC(IR2)/2
     -)THEN
      IF(
     - ICL.GT.ICL2
     -)THEN
       ICL=ICL-MAXC(IR2)
      IDIF=IABS(ICL-ICL2)
      ELSE
       ICL2=ICL2-MAXC(IR2)
      IDIF=IABS(ICL-ICL2)
      ENDIF
      ENDIF
      IF(IENTER.EQ.99.AND.IABS(IR2-IRNG1).GT.1.AND.IXBKK(35).EQ.0
     % .AND.HNREL(JTR).EQ.1.AND.NRHT(IPTRK).LT.8) IDIF=99
      LR2=0
      IF(KMP1.NE.KMP2) LR2=1
      IF(
     - IDIF.LE.IDLIM
     -)THEN
      IAB=HNREL(JTR)
      CALL MVC2(HTEMP(1),0,HISTR(1,KTR),0,18) !PMF 28/06/99 MVC -> MVC2
      LRP=1
      LRD=1
      DO 13004 IKOUNT=1,4
      IF(
     - IKOUNT.GE.2
     -)THEN
      IF(
     - LR1.NE.0.AND.LR2.NE.0
     -)THEN
      GOTO 13005
      ENDIF
      IF(
     - LR1.NE.0.AND.LR2.EQ.0
     -)THEN
      IF(
     - IKOUNT.EQ.2
     -)THEN
      LRD=-LRD
      ELSE
      GOTO 13005
      ENDIF
      ENDIF
      IF(
     - LR1.EQ.0.AND.LR2.NE.0
     -)THEN
      IF(
     - IKOUNT.EQ.2
     -)THEN
      LRP=-1
      ELSE
      GOTO 13005
      ENDIF
      ENDIF
      IF(
     - LR1.EQ.0.AND.LR2.EQ.0
     -)THEN
      IF(IKOUNT.EQ.2) LRD=-LRD
      IF(IKOUNT.EQ.3) LRP=-LRP
      IF(IKOUNT.EQ.4) LRD=-LRD
      ENDIF
      ENDIF
      DO 13006 JJ=1,INUM
      HISTR(JJ,KTR)=HISTR(JJ,KTR)*LRP
13006 CONTINUE
13007 CONTINUE
      ASSIGN 17004 TO IZZZ02
      GOTO 17003
17004 CONTINUE
      IF(
     - IEXIT.EQ.99.OR.IEXIT.EQ.98
     -)THEN
      CALL MVC2(HISTR(1,KTR),0,HTEMP(1),0,18)  !PMF 28/06/99 MVC -> MVC2
      GOTO 13005
      ENDIF
      IF(
     - JCOUNT.EQ.INUM+IAB.AND.IR2.EQ.IRNG1
     -)THEN
      ML1=INUM
      ML1=HISTR(ML1,KTR)
      ML1=IABS(ML1)
      ML1=NWR1(ML1)
      ML2=HISTR(1,JTR)
      ML2=IABS(ML2)
      ML2=NWR2(ML2)
      IF(
     - ML2-ML1.GE.IBKK(7)
     -)THEN
      CALL MVC2(HISTR(1,KTR),0,HTEMP(1),0,18) !PMF 28/06/99 MVC -> MVC2
      IF(LAND(JJPR,64).NE.0) PRINT 295,ML1,ML2
 295  FORMAT('   LAYER DIFFERENCE IS TOO LARGE',2I5)
      GOTO 13005
      ENDIF
      ENDIF
       HPOLD=HPFREE
       CALL FXYZ(KTR)
       HPTR0=HPFREE
       HPTR9=HPTR0+49
       HLDTR=50
      HPFREE=HPTR9+1
      IF(
     - HPFREE.LE.HPLAST
     -)THEN
      CALL XYFIT
      RMS=WRK(HPTR0+22)
      IF(
     - RMS.LT.RMSLI2.AND.RMS.GT.RMSLIM.AND.JKREP.EQ.1.AND.ISPEC.EQ.0
     * .AND.(HREP(IRPKNT).NE.KTR.AND.IRPKNT.GT.0.OR.IRPKNT.EQ.0)
     * .AND.IENTER.NE.99
     -)THEN
      IF(
     - IRPKNT.LT.10
     -)THEN
      IRPKNT=IRPKNT+1
      HREP(IRPKNT)=KTR
      ENDIF
      ENDIF
      IF(
     - IRNG1.EQ.3.AND.IR2.EQ.1.AND.IXBKK(35).NE.0
     % .AND.RMS.LT.RMSLIM.AND.RMS.LT.RMSOLD
     -)THEN
      IPREM1=IGFP(1)
      IPREM2=IGFP(6)
      IPREM3=IGFP(9)
       PREM4=GFP(2)
       PREM5=GFP(14)
      IGFP(6)=17
      IGFP(9)=0
      GFP(2)=999999.
      GFP(14)=999999.
      IGFP(1)=LOR(IGFP(1),1)
      RMIN=150.
      RMAX=850.
      CALL PATROL(RMIN,RMAX)
      IFOUND=0
      DO 13008 ICNT=HPHT0,HPHT9,HLDHT
      IF(IWRK(ICNT+10).LT.2.AND.IWRK(ICNT+12).EQ.2) IFOUND=IFOUND+1
13008 CONTINUE
13009 CONTINUE
      IC1=ICL2+24
      IC2=(ICL1+1)/2
      NRUN=HRUN
      NCL1=HNTCEL(IC1+1)-HNTCEL(IC1)
      NCL2=HNTCEL(IC2+1)-HNTCEL(IC2)
      IF(IDIF.EQ.0.AND.IFOUND.LT.IYBKK(9).AND..NOT.(DEADCL(IC1,NRUN)
     $.AND.NCL1.EQ.0.OR.DEADCL(IC2,NRUN).AND.NCL2.EQ.0)) RMS=99.
      IF(IDIF.EQ.1.AND.IFOUND.LT.IYBKK(16).AND..NOT.(DEADCL(IC1,NRUN)
     $.AND.NCL1.EQ.0.OR.DEADCL(IC2,NRUN).AND.NCL2.EQ.0)) RMS=99.
      IGFP(1)=IPREM1
      IGFP(6)=IPREM2
      IGFP(9)=IPREM3
       GFP(2)=PREM4
       GFP(14)=PREM5
      ENDIF
      IF(
     - RMS.LT.RMSLIM.AND.RMS.LT.RMSOLD
     -)THEN
      IF(
     - ISPEC.EQ.0.OR.ISPEC.EQ.1.AND.RMS.LT.RMSLI1
     -)THEN
      RMSOLD=RMS
      ITRACK=JTR
      LRDFIN=LRD
      LRPFIN=LRP
      ENDIF
      ENDIF
      ELSE
      PRINT 33,HRUN,HEV,NREC,KTR,JTR
 33   FORMAT(' +++++++++  NOT ENOUGH SPACE IN CWORK  +++++++(BAKPAK)',
     * 5I10)
      ENDIF
      HPFREE=HPOLD
      CALL MVC2(HISTR(1,KTR),0,HTEMP(1),0,18) !PMF 28/06/99 MVC -> MVC2
13004 CONTINUE
13005 CONTINUE
      HNREL(KTR)=INUM
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
      IF(
     - RMSOLD.NE.9999.
     -)THEN
      DO 13010 JJ=1,INUM
      HISTR(JJ,KTR)=HISTR(JJ,KTR)*LRPFIN
13010 CONTINUE
13011 CONTINUE
      IF(
     - HREP(IRPKNT).EQ.KTR.AND.JKREP.EQ.1
     -)THEN
      IKXKTR=IKXKTR-1
      HREP(IRPKNT)=0
      IRPKNT=IRPKNT-1
      ENDIF
      IAB=HNREL(ITRACK)
      JTR=ITRACK
      LRD=LRDFIN
      ASSIGN 17005 TO IZZZ02
      GOTO 17003
17005 CONTINUE
      DO 13012 IY=1,JCOUNT
      ITC=HISTR(IY,KTR)
      ITC=IABS(ITC)
      LBL(ITC)=LAND(LBL(ITC),MSKLRL)
13012 CONTINUE
13013 CONTINUE
      IF(IEXIT.EQ.99.OR.IEXIT.EQ.98) WRITE(6,769)
 769  FORMAT('  ********* ERROR IN BAKPAK  EXIT ****** ')
      HNREL(ITRACK)=0
      ICHNG=1
      ENDIF
      ENDIF
      ENDIF
      IF(.NOT.(
     - IKXKTR.GE.100
     -))GOTO 16000
16001 CONTINUE
      IF(
     - HREP(1).EQ.0
     -)THEN
      GOTO 13001
      ELSE
      ITREP=IRPKNT
      RMSLIM=RMSLI2
      ENDIF
13000 CONTINUE
13001 CONTINUE
      IXYF(1)=IREM
      IBTRK=NTR
      NTR=100
      NTR=IBTRK
      RETURN
17000 CONTINUE
      IR1=1
      IR2=1
      KMP1=HISTR(1,IXX)
      KMP1=IABS(KMP1)
      KMP1=IPCL(KMP1)
      KMP2=HISTR(HNREL(IXX),IXX)
      KMP2=IABS(KMP2)
      KMP2=IPCL(KMP2)
      IF(KMP2.GT.24) IR1=2
      IF(KMP2.GT.48) IR1=3
      IF(KMP1.GT.24) IR2=2
      IF(KMP1.GT.48) IR2=3
      GOTO IZZZ01
17003 CONTINUE
      IEXIT=0
      JCOUNT=INUM
      DO 13014 KK=1,IAB
      ISIG=0
      ITP2=HISTR(KK,JTR)
      ITP2=IABS(ITP2)
      DO 13016 IJT=1,INUM
      ITP1=HISTR(IJT,KTR)
      IF(
     - IABS(ITP1).EQ.ITP2
     -)THEN
      ISIG=1
      GOTO 13017
      ENDIF
13016 CONTINUE
13017 CONTINUE
      IF(
     - ISIG.EQ.0
     -)THEN
      JCOUNT=JCOUNT+1
      IF(
     - JCOUNT.LE.9
     -)THEN
      HISTR(JCOUNT,KTR)=HISTR(KK,JTR)*LRD
      ELSE
      IEXIT=99
      GOTO 13015
      ENDIF
      ENDIF
13014 CONTINUE
13015 CONTINUE
      HNREL(KTR)=JCOUNT
      IF(
     - JCOUNT.EQ.INUM.OR.JCOUNT.EQ.IAB
     -)THEN
      IEXIT=98
      ENDIF
      GOTO IZZZ02
      END

C   07/06/96 606071827  MEMBER NAME  BPASDA   (S4)          FORTG1
      SUBROUTINE BPASDA(IUNDA,IPASS)
C     BOS SUBPROGRAM   =4.7=
C   07/06/96 606071821  MEMBER NAME  CCS      (S4)          FORTG1
      COMMON/CCS/IUND,INDT,INDC,NPT,INDA,LISTE(5),IPAS
      IUND=IUNDA
      CALL BDLS('+DIR',IUND)
      LISTE(1)=0
      LISTE(2)=0
      IPAS=IPASS
      CALL PODA(1,LISTE,1)
      RETURN
      END

C   12/03/84 411131802  MEMBER NAME  TAGSR1   (S)           FORTRAN
C
C
C
C
C
C
C
       SUBROUTINE TAGSR1(ISTART,IEND,IWRITE)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE SORTS THE CONTENTS OF CATAG INTO ORDER OF ENERGY AND
C PUTS THE ESULTING LIST IN SADC(32,2) WHERE SADC(I,1) = ADDRESS OF BLOC
C AND SADC(I,2) = CONTENTS
C
C ISTART - INPUT - FIRST ADDRESS IN CATAG FROM WHICH DATA SHOULD BE TAKE
C IEND  - INPUT - LAST ADDRESS IN CATAG FROM WHICH DATA SHOULD BE TAKEN
C
C IWRITE - INPUT - FLAG TO TURN ON DEBUGGING INFO IF SET TO 1
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
       DIMENSION STEMP(2)
C
C                                   COPY THE CONTENTS OF PART OF
C                                   CATAG TO BE SORTED INTO SADC
C                                   PLUS ADC ADDRESSES
C
       L = 1
C
       DO 5 I = ISTART,IEND
          SADC(L,1) = I
          SADC(L,2) = CATAG(I)
          L = L + 1
    5  CONTINUE
C
C---DEBUG--------------------------------DEBUG  START-------------------
C
       IF ( IWRITE .EQ. 0) GOTO 101
       WRITE(6,601)
  601  FORMAT('  CONTENTS OF SADC BEFORE SORT ')
       DO 91 I = 1,IENDMZ,8
          WRITE(6,901) SADC(I,2),SADC(I+1,2),SADC(I+2,2),SADC(I+3,2),
     *                 SADC(I+4,2 ),SADC(I+5,2),SADC(I+6,2),SADC(I+7,2)
   91  CONTINUE
C
C---DEBUG--------------------------------DEBUG  END---------------------
C
  101  CONTINUE
C
C
C                                   NOW DO SORT ON SADC
C
       IELOO = IEND - ISTART
       DO 10 J = 1 ,IELOO
          DO 11 K = 1,IELOO
             IF ( SADC(K,2) .GT. SADC(K+1,2) )  GOTO 11
             STEMP(1)    = SADC(K,1)
             STEMP(2)    = SADC(K,2)
             SADC(K,1)   = SADC(K+1,1)
             SADC(K,2)   = SADC(K+1,2)
             SADC(K+1,1) = STEMP(1)
             SADC(K+1,2) = STEMP(2)
   11     CONTINUE
   10  CONTINUE
C
C
       IF ( IWRITE .EQ. 0) GOTO 100
C
C
C---DEBUG ONLY---------------------------DEBUG  ONLY--------------------
C
C
       WRITE(6,600)
  600  FORMAT('  CONTENTS OF SADC AFTER SORT ')
       DO 80 I = 1,IENDMZ,8
          WRITE(6,901) SADC(I,2),SADC(I+1,2),SADC(I+2,2),SADC(I+3,2),
     *                 SADC(I+4,2),SADC(I+5,2),SADC(I+6,2),SADC(I+7,2)
   80  CONTINUE
  901  FORMAT(8(3X,F10.2) )
C
C
  100  RETURN
       END

C   07/06/96 606071919  MEMBER NAME  VLBN     (S4)          FORTG1
      SUBROUTINE VLBN(NX,LB,XL,XH,NB)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (IW(1),RW(1))
      NB=0
      XL=0.0
      XH=0.0
      CALL BLOC(J,'$BIN',NX,&100)
      NJ=MIN0(IW(J),4)+1
      GOTO (100,100,10,15,40),NJ
   10 NB=100
      GOTO 20
   15 NB=IW(J+3)
      IF(NB.GT.1000.OR.NB.LE.0) GOTO 10
   20 IF(LB.LE.0.OR.LB.GT.NB) GOTO 100
      DX=(RW(J+2)-RW(J+1))/FLOAT(NB)
      XH=RW(J+1)+FLOAT(LB)*DX
      XL=XH-DX
      GOTO 100
   40 NB=IW(J)-1
      IF(LB.LE.0) GOTO 100
      IF(LB.GT.NB) GOTO 100
      XL=RW(J+LB)
      XH=RW(J+LB+1)
  100 RETURN
      END

C   07/06/96 606071919  MEMBER NAME  XBINS    (S4)          FORTG1
      SUBROUTINE XBINS(XXA,XXZ,NB,A,B)
      REAL BINS(10) /0.1,0.15,0.2,0.25,0.4,0.5,0.6,0.8,1.0,1.5/
      REAL*8 BN,BIN,FEX,ST,AW,TEN
      TEN=10
      BN=NB
      XA=AMIN1(XXA,XXZ)
      XZ=AMAX1(XXA,XXZ)
      DX=XZ-XA
      IF(DX.LE.0.0) DX=1.E-6
      XM=0.5*(XA+XZ)
      XA=XM-0.4999*DX
      XZ=XM+0.4999*DX
      BIN=DX/BN
      DN=DLOG10(BIN)
      ND=DN
      FEX=TEN**ND
      IF(BIN/FEX.LE.1.0) GOTO 10
      FEX=FEX*TEN
   10 BIN=BIN/FEX
      DO 20 I=1,9
      KI=I
      IF(BINS(I).GE.BIN) GOTO 30
   20 CONTINUE
      KI=9
   30 BIN=BINS(KI)
      ST=BIN*FEX
      AW=IDINT(XA/(TEN*ST))*ST*TEN
      IF(XA-AW.LT.0.0) AW=AW-ST*TEN
      IF(AW+BN*ST.GE.XZ) GOTO 40
      KI=KI+1
      IF(KI.LE.10) GOTO 30
   40 A=AW
      B=ST
      RETURN
      END

C   14/08/84 408271209  MEMBER NAME  MUPR21   (PWMUS)       FORTRAN
C   26/03/80 004291628  MEMBER NAME  MUPR21   (JADEMUS)     FORTRAN
C
C   LAST CHANGE 10.40  14/08/84  P.WARMING   -- OUTPUT COMMENTED
C        CHANGE 17.17  23/04/80  HUGH MCCANN -- TO MAKE SELF-CONTAINED.
C-----------------------------------------------------------------------
C
      SUBROUTINE MUPR21
C
C
C  THIS ROUTINE WRITES OUT SELECTED WORDS FROM BANK MUR2/1.
C
      IMPLICIT INTEGER*2 (H)
#include "cmubcs.for"
C
C  FIND MUR2/0 ---- FOR INFO RE NO. OF TRACKS IN MUR2/1 AND
C                   NO. OF (4-BYTE) WORDS/TRACK IN MUR2/1.
C
      CALL CLOC(INDEX0,'MUR2',0)
      IF(INDEX0.LE.0)GO TO 2
      NUMTRK=IDATA(INDEX0+1)
      NMUW  =IDATA(INDEX0+2)
C
C  FIND MUR2/1
C
      CALL CLOC(INDEX,'MUR2',1)
      IF(INDEX.LE.0)GO TO 1
C
C  PICK UP MAGNETIC FIELD FROM HEADER .
C
      IP=IDATA(IBLN('HEAD'))
      BGAUSS=HDATA(2*IP+30)
C
C  PICK UP PATREC BANK POINTER & NO. OF WORDS/TRACK IN PATREC BANK.
C
      IPPATR=IDATA(IBLN('PATR'))
      ISTART=IDATA(IPPATR+1)+1
      NWTRK=IDATA(IPPATR+3)
      IPT=IPPATR+ISTART-1
C
C  LOOP ROUND TRACKS.
C
      J=INDEX
      J2=2*J
      DO 10 I=1,NUMTRK
C
C PICK UP PATREC INFO.
C
      DCZ=ADATA(IPT+17)
      CURV=-ADATA(IPT+28)
      PT=3.E-8*BGAUSS/CURV
      P=ABS(PT/SQRT(1.0-DCZ*DCZ))
      CHARGE=SIGN(1.,-CURV*BGAUSS)
      ICH=INT(CHARGE)
      IF (I.EQ.1) WRITE (6,610)
  610 FORMAT('0 MUR2/1    MUON INFO FOR I.D. TRACKS'/
     *    '                     MUHIT      CHI2   ENERGY #ABS-  PI-MU',
     *    '   PI     K-MU   MUON    PION     FAKE-PROB-(GOOD-MU)',
     *    ' FAKE-PROB-(ANY-MU) '/
     *    '    TR# CHG MOMENTM MSNLAH QUAL PROBAB   LOSS LENGTH  PROB',
     *    '  SNEAK   PROB   PROB    PROB      PI    K    P   -P ',
     *    '  PI    K    P   -P ')
      WRITE(6,620)IDATA(J+1),ICH,P,IDATA(J+4),IDATA(J+6),ADATA(J+11),
     *        ADATA(J+14),ADATA(J+15),ADATA(J+21),ADATA(J+22),
     *        (ADATA(J+II),II=24,26),(ADATA(J+JJ),JJ=30,37)
  620 FORMAT(' ',I5,I4,F9.2,I7,I5,F7.4,F7.3,F6.3,F7.3,F7.4,
     *        F7.3,F8.3,F8.4,3X,8F5.2)
      J=J+NMUW
      J2=2*J
      IPT=IPT+NWTRK
   10 CONTINUE
      RETURN
C
    1 CONTINUE
C
C  BANK MUR2/1 DOES NOT EXIST
C
      WRITE(6,100)
  100 FORMAT('0',21X,'*****  BANK MUR2/1 DOES NOT EXIST  *****')
      RETURN
    2 CONTINUE
C
C  BANK MUR2/0 DOES NOT EXIST
C
      WRITE(6,110)
  110 FORMAT('0',21X,'*****  BANK MUR2/0 DOES NOT EXIST  *****')
      RETURN
      END

C   29/09/77 004081356  MEMBER NAME  JDTIME   (S)           FORTRAN
      SUBROUTINE JDTIME( X1, X2, FOUND, DIST, SLOPE )
C *------------------------------------------------------------
C *
C * VERSION OF 03/10/78       LAST MOD 08/04/80    E.ELSEN
C * CALCULATES MINIMUM DRIFT DISTANCE DIST OF A POINT BETWEEN X1
C * AND X2 FROM ORIGIN. IF FOUND IS TRUE POINT BELONGS TO THIS
C * DRIFT SPACE. SLOPE IS SLOPE OF TRACK IN THIS SPACE ( NECCESSARY
C * FOR AMPLITUDE NORMALIZATION ).
C *------------------------------------------------------------
C
      DIMENSION X1(2),X2(2)
      LOGICAL FOUND
      COMMON / CJXDAT / XSLOPE, YSLOPE, XL(3), XH(3), R3P, RD3P,
     *                  S, S2,
     *                  XSL3L, X3L, XSL3H, X3H, YSL3L, Y3L, YSL3H,
     *                  YHWIDT, SINHLF, COSHLF, DRITAN
C
      SLOPE = 1.E5
      FOUND = .FALSE.
C
C        ----- RETURN IF BOTH POINTS ARE NOT IN THIS CELL  -----
      IF(  ( -S .GT. X1(1) .OR. X1(1) .GT. S ) .AND.
     *     ( -S .GT. X2(1) .OR. X2(1) .GT. S )  ) RETURN
C
      FOUND = .TRUE.
      XLOW = AMAX1( AMIN1( X1(1), X2(1) ), -S )
      XHIGH = AMIN1( AMAX1( X1(1), X2(1) ), S )
      DELTAX = X2(1) - X1(1)
      DELTAY = X2(2) - X1(2)
      D12 = X1(1)*X1(1) + X1(2)*X1(2)
      D22 = X2(1)*X2(1) + X2(2)*X2(2)
C
      IF( D12 .LE. S2 .OR. D22 .LE. S2 ) GO TO 200
C             POINTS ARE NOT IN INNER CIRCLE WITH RADIUS S.
C
          IF( ABS( DELTAX ) .LE. 1.0E-5 ) GO TO 100
C                 POINTS ARE NOT TOO CLOSE TOGETHER.
C
C               ----- PART FOR EXPLICIT MINIMIZATION
                  SLOPE = DELTAY / DELTAX
                  YITCPT = X1(2) - SLOPE*X1(1)
                  XMIN = -S * SLOPE / SQRT( 1. + SLOPE*SLOPE )
                  DIST = ABS( SLOPE*XMIN+YITCPT )
C
C                   CHOOSE CORECT SIGN FOR XMIN
                            DIST1 = ABS( -SLOPE*XMIN+YITCPT )
                            IF( DIST1 .GT. DIST ) GO TO  20
                            XMIN = - XMIN
                            DIST = DIST1
   20            XMIN = AMAX1( AMIN1( XMIN, XHIGH ), XLOW )
CCCCCC CHANGED   DIST = DIST - SQRT( S2 - XMIN*XMIN ) + S
                 DIST = ABS( SLOPE*XMIN+YITCPT )
     *                       - SQRT( S2 - XMIN*XMIN ) + S
                 RETURN
C
C
C              ----- TAKE ONE OF THE POINTS AS MINIMAL DISTANCE
  100   DIST = AMIN1( ABS(X1(2)) + S - SQRT( AMAX1(S2-X1(1)*X1(1),0.) ),
     *                ABS(X2(2)) + S - SQRT( AMAX1(S2-X2(1)*X2(1),0.) ))
           RETURN
C
C              ----- MINIMIZE EUCLIDEAN DISTANCE
  200 DIST = SQRT( AMIN1( D12, D22 ) )
      IF( ABS( DELTAX ) .LE. 1.0E-5 ) RETURN
C
C              ----- EXPLICIT MINIMIZATION
                SLOPE = DELTAY / DELTAX
                YITCPT = X1(2) - SLOPE*X1(1)
                XMIN = -SLOPE * YITCPT / (1.0 + SLOPE*SLOPE)
                IF( XLOW .GT. XMIN .OR. XMIN .GT. XHIGH ) RETURN
                DIST = AMIN1( DIST, ABS(YITCPT)/SQRT(1.+SLOPE*SLOPE) )
C
      RETURN
      END

C   20/08/80 202051433  MEMBER NAME  FWMUHT   (JADEGS)      FORTRAN
      SUBROUTINE FWMUHT
      IMPLICIT INTEGER*2 (H)
CODE L.O'NEILL,MODIFIED J.OLSSON   28.5.81
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      COMMON /CHEADR/ HEAD(108)
      COMMON /CWORK2/AGEO(6,16)
      COMMON /CFWMU/ HAXES(4,3),AFWMU(18)
      DIMENSION HMIN(2), HPLU(2)
      DATA HMIN/'-','Z'/,HPLU/'+','Z'/,MASK2/Z20000/
C---
      IPNTR=IDATA(IBLN('LATC'))
      IF(IPNTR.LT.1) GO TO 200
      IPNTH=2*IDATA(IBLN('ATOF'))
      IF(IPNTH.LT.1) GO TO 200
      IF(HEAD(18).LT.3730.OR..NOT.DSPDTL(30)) IPNTH=0
      IBDC = IDATA(IPNTR+1)
      IWB1 = 21
      IWB2 = 22
      IF(LAND(MASK2,IBDC).NE.0) IWB1 = 12
      IF(LAND(MASK2,IBDC).NE.0) IWB2 = 13
      MPROJ=2
      IF(LASTVW.GT.7) MPROJ = 1
      IF(LASTVW.EQ.15) MPROJ=3
      IXS=HAXES(1,MPROJ)
      IXA=HAXES(2,MPROJ)
      IYS=HAXES(3,MPROJ)
      IYA=HAXES(4,MPROJ)
      DO 5010  I = 1,4
      AGEO(1,I) = AFWMU(I)
      AGEO(4,I) = AFWMU(I+4)
5010  AGEO(5,I) = AFWMU(I+8)
      DO 1 I=1,4
      AGEO(1,(9-I))=-AGEO(1,I)-5.
      AGEO(4,(9-I))= AGEO(4,I)
1     AGEO(5,(9-I))= AGEO(5,I)
      DO 2 I=1,8
      AGEO(1,(I+8))=AGEO(1,I)
      AGEO(4,(I+8))=AGEO(4,I)
2     AGEO(5,(I+8))=AGEO(5,I)
      DO 7110  J = 1,16
7110  AGEO(6,J) = AFWMU(15)
      DO 7111  J = 1,8
      AGEO(2,J+8) = AFWMU(17)
7111  AGEO(2,J) = AFWMU(13)
      DO 7112  J = 1,4
      AGEO(3,J+4) = AFWMU(16)
      AGEO(3,J+8) = -AFWMU(16)
      AGEO(3,J+12) = AFWMU(18)
7112  AGEO(3,J) = AFWMU(14)
      IF(LASTVW.NE.15) GO TO 300
      SH3=100.
      Y1=4000.
      ICNT=2
      X1=5250.-SH3
      CALL HEMSYM(X1,Y1,SH3,HPLU,ICNT,0.)
      X1=X1+SH3
      DO 301 I=1,8
      AGEO(1,I)=AGEO(1,I)-X1
301   AGEO(2,I)=AGEO(2,I)+Y1
      X1=1250.-SH3
      CALL HEMSYM(X1,Y1,SH3,HMIN,ICNT,0.)
      X1=X1+SH3
      DO 302 I=9,16
      AGEO(1,I)=AGEO(1,I)-X1
302   AGEO(2,I)=AGEO(2,I)+Y1
  300 CONTINUE
C---
      IW1=HDATA(2*IPNTR+IWB1)
      IW2=HDATA(2*IPNTR+IWB2)
      IW0=IW1+256*IW2
      MASK=1
      DO 12 I=1,16
      X0=IXS*AGEO(IXA,I)
      Y0=IYS*AGEO(IYA,I)
      DX=    AGEO((IXA+3),I)
      DY=    AGEO((IYA+3),I)
      IF(IPNTH.GT.0) CALL FTDLHO(IPNTH,I,MPROJ,X0,Y0,DX,DY)
      ITEST=LAND(IW0,MASK)
      MASK=2*MASK
      IF(ITEST.EQ.0) GO TO 12
      NSTEP=2.*DY/50.+1
      STEP=2.*DY/NSTEP
      CALL RECTAN(X0-DX,Y0-DY,X0+DX,Y0+DY,0)
      IFLIP=1
      X=X0-IFLIP*DX
      Y=Y0-DY
      CALL MOVEA(X,Y)
      DO 13 J=1,NSTEP
      IFLIP=-IFLIP
      X=X0-IFLIP*DX
      Y=Y+STEP
      CALL DRAWA(X,Y)
   13 CONTINUE
      IFLIP=-1
      X=X0-IFLIP*DX
      Y=Y0-DY
      CALL MOVEA(X,Y)
      DO 14 J=1,NSTEP
      IFLIP=-IFLIP
      X=X0-IFLIP*DX
      Y=Y+STEP
      CALL DRAWA(X,Y)
   14 CONTINUE
   12 CONTINUE
  200 CONTINUE
      RETURN
      END
      BLOCK DATA BLCKG3 !PMF 03/12/99: add name
      IMPLICIT INTEGER*2 (H)
      COMMON /CFWMU/ HAXES(4,3),AFWMU(18)
      DATA HAXES /1,3,1,2,1,3,1,1,-1,1,1,2/
      DATA AFWMU /-1378.,-1027.,-738.5,-512.5,2*175.,2*112.5,965.,1270.,
     $ 2*1300.,-22.,2569.,15.,2564.,-23.,-2582./
      END

C   29/03/80 004242330  MEMBER NAME  MUFFLZ   (JADEMUS1)    FORTRAN
C LAST CHANGE 19.46 31/03/80 JOHN ALLISON.
      SUBROUTINE MUFFLZ
     *(HC,NHITS,NWHIT,
     * HLUN,
     * IMUR,AMUR,NWMUR,
     * HTC,HAMB,NTPH)
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION
     * HC(1),
     * HLUN(1),
     * IMUR(1),AMUR(1),
     * HTC(1),HAMB(1)
C
C CALLED AFTER EACH 'GOOD' MUON.
C
C HC CONTAINS MUON HIT COORDINATES.
C NHITS IS THE NUMBER OF MUON HITS.
C NWHIT IS NUMBER OF WORDS PER HIT IN HIT COORDINATE ARRAY.
C HLUN IS HIT STATUS ARRAY.
C IMUR,AMUR IS MU-RESULTS 'MUR2' BANK 1 - FILLED BY MUFFLE.
C NWMUR IS NUMBER OF WORDS PER INNER DTECTOR TRACK IN 'MUR2' BANK 1.
C HTC IS HIT-TRACK CORELLATION ARRAY - FILLED BY MUFFLE.
C HAMB IS AMBIGUITY FLAG FOR EACH ENTRY IN HTC.
C NTPH IS NUMBER OF TRACKS PER HIT ALLOCATED IN HTC.
C
C-----------------------------------------------------------------------
C
C COMMONS.
C
#include "cmucalib.for"
#include "cmuffl.for"
#include "cmufwork.for"
#include "cmureg.for"
C
C-----------------------------------------------------------------------
C
C DON'T FORGET TO ACTIVATE THESE STATEMENTS.  THERE MAY BE MORE THAN 10
C   ASSOCIATED HITS, BUT MANY ARRAYS ARE LIMITED TO 10.
C
C     NTHISS=NTHIS
C     IF(NTHIS.GT.10)NTHISS=10
C
C-----------------------------------------------------------------------
C
C++++
C     N3=3*NTHISS
C     WRITE(6,2857)(DALONG(I),I=1,NTHISS)
C2857 FORMAT('0DALONG',T20,10F10.1)
C     WRITE(6,2858)(DEV(I),I=1,N3)
C2858 FORMAT(' DEVIATIONS',T20,10F10.1/(T20,10F10.1))
C     WRITE(6,2859)(VXYDA(I),I=1,NTHISS)
C2859 FORMAT(' VXYDA',T20,10F10.0)
C     WRITE(6,2860)(VZDA(I),I=1,NTHISS)
C2860 FORMAT(' VZDA',T20,10F10.0)
C     WRITE(6,2861)(CXYA(I),I=1,NTHISS)
C2861 FORMAT(' CXYA',T20,10F10.5)
C     WRITE(6,2862)(CZA(I),I=1,NTHISS)
C2862 FORMAT(' CZA',T20,10F10.5)
C     WRITE(6,2863)(INCUT(I),I=1,N3)
C2863 FORMAT(' INCUT',T20,30L2)
C     WRITE(6,2864)(BADA(I),I=1,N3)
C2864 FORMAT(' BADA',T20,30L2)
C     WRITE(6,2865)(ITHISA(I),I=1,NTHISS)
C2865 FORMAT(' ITHISA',T20,10I5)
C     WRITE(6,2866)(IJA(I),I=1,NTHISS)
C2866 FORMAT(' IJA',T20,10I5)
C     WRITE(6,2867)INEFF
C2867 FORMAT(I5,' INEFFICIENCIES.')
C     IF(INEFF.EQ.0)GO TO 2870
C     WRITE(6,2868)(INCHAM(I),I=1,INEFF)
C2868 FORMAT(' INEFFICIENT CHAMBERS',10I5)
C     WRITE(6,2869)(INREG(I),I=1,INEFF)
C2869 FORMAT(' INEFFICIENT REGIONS (PLANES)',10I5)
C2870 CONTINUE
C++++
C     N=NTPH*NHITS
C     WRITE(6,2871)(HAMB(I),I=1,N)
C2871 FORMAT(' AMBIGUITY FLAGS',T20,20I5/(T20,20I5))
C++++
C     WRITE(6,2856)((EM(I,J),I=1,12),J=1,12)
C2856 FORMAT('0FIRST 12 ENTRIES IN ERROR MATRIX'/(12F10.0))
C++++
C++++
C     WRITE(6,1735)CHISQT,NDFT,CHIPRT
C1735 FORMAT(' CHISQT,NDFT,CHIPRT',F10.4,I5,G15.5)
C++++
C++++
C     WRITE(6,3735)CHISTL,NDFTL,CHIPTL
C3735 FORMAT(' CHISTL,NDFTL,CHIPTL',F10.4,I5,G15.5)
C++++
C
C-----------------------------------------------------------------------
C
      RETURN
      END

C   18/07/79 106101752  MEMBER NAME  ERGTOT   (JADEGS)      FORTRAN
      SUBROUTINE ERGTOT(ECYL,ECAMI,ECAPL)
C
C                                  J.OLSSON 03.07.79
C                                     LAST CHANGE 13.07.79
C            CODE TAKEN FROM SUBROUTINE CAPMRK IN EVDISP
C      ECYL,ECAMI,ECAPL ARE ENERGIES OF MAIN CYLINDER AND ENDCAPS.
C                       THEY ARE RETURNED IN MEV.
C         SUPPOSES THAT ALL SPINNERS ARE REMOVED BY LGCALB
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
      COMMON /CLERGY/ ECYLM,ECYLP
C
      ECYL = 0.
      ECAMI = 0.
      ECAPL = 0.
      ECYLM = 0.
      ECYLP = 0.
      IALGN=IBLN('ALGN')
      IPJ=IDATA(IALGN)
      IF(IPJ.LE.0) GO TO 5018
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 5018
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
C
      DO 5004 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      ECYL=ECYL+HDATA(IJK)
      IF(IAD.GT.2687) GO TO 5015
      JADE = IAD - (IAD/32)*32
      IF(JADE.LE.15) ECYLM = ECYLM + HDATA(IJK)
      IF(JADE.GT.15) ECYLP = ECYLP + HDATA(IJK)
      GO TO 5004
5015  IF((IAD-2687).LE.96) ECAMI = ECAMI + HDATA(IJK)
      IF((IAD-2687).GT.96) ECAPL = ECAPL + HDATA(IJK)
5004  CONTINUE
C
      ECYL = ECYL - ECAMI - ECAPL
5018  RETURN
      END

C   30/05/80 803301135  MEMBER NAME  RDATA    (JADEGS)      FORTRAN
      SUBROUTINE RDATA(IER,HRUN)
C---
C---     TABLE FOR REAL DATA TAKING RUNS, RETURNS FLAG IER
C---     IER = 0 IF REAL DATA,  OTHERWISE IER = 1
C---     IER = 0 IF MONTE CARLO, I.E. HRUN < 100
C---          LAST CHANGE  30.03.88           J.OLSSON  30.05.80
C---
      IMPLICIT INTEGER*2 (H)
C
      IER = 1
      IF(HRUN.LT.100) GO TO 100
      IF(HRUN.GT. 539.AND.HRUN.LT. 673) GO TO 100
      IF(HRUN.GT. 698.AND.HRUN.LT. 710) GO TO 100
      IF(HRUN.GT. 763.AND.HRUN.LT. 799) GO TO 100
      IF(HRUN.GT. 803.AND.HRUN.LT.1055) GO TO 100
      IF(HRUN.GT.1055.AND.HRUN.LT.1180) GO TO 100
      IF(HRUN.GT.1209.AND.HRUN.LT.1374) GO TO 100
      IF(HRUN.GT.1375.AND.HRUN.LT.1398) GO TO 100
      IF(HRUN.GT.1496.AND.HRUN.LT.1548) GO TO 100
      IF(HRUN.GT.1557.AND.HRUN.LT.1687) GO TO 100
      IF(HRUN.GT.1710.AND.HRUN.LT.1814) GO TO 100
      IF(HRUN.GT.1845.AND.HRUN.LT.2227) GO TO 100
      IF(HRUN.GT.2294.AND.HRUN.LT.2309) GO TO 100
      IF(HRUN.GT.2310.AND.HRUN.LT.2521) GO TO 100
      IF(HRUN.GT.2744.AND.HRUN.LT.3019) GO TO 100
      IF(HRUN.GT.3036.AND.HRUN.LT.3183) GO TO 100
      IF(HRUN.GT.3184.AND.HRUN.LT.3297) GO TO 100
      IF(HRUN.GT.3324.AND.HRUN.LT.3541) GO TO 100
      IF(HRUN.GT.3560.AND.HRUN.LT.4708) GO TO 100
      IF(HRUN.GT.4709.AND.HRUN.LT.4842) GO TO 100
      IF(HRUN.GT.4852.AND.HRUN.LT.4865) GO TO 100
      IF(HRUN.GT.4993.AND.HRUN.LT.5057) GO TO 100
      IF(HRUN.GT.5057.AND.HRUN.LT.5404) GO TO 100
      IF(HRUN.GT.6310.AND.HRUN.LT.6329) GO TO 100
C KNOWN COSMIC RUNS, TEST RUNS
      IF(HRUN.EQ. 6185) GO TO 200
      IF(HRUN.EQ.15870) GO TO 200
      IF(HRUN.GE.17691.AND.HRUN.LE.17695) GO TO 200
      IF(HRUN.GE.11796.AND.HRUN.LE.11798) GO TO 200
      IF(HRUN.GE. 8630.AND.HRUN.LE. 8631) GO TO 200
      IF(HRUN.EQ.18283) GO TO 200
      IF(HRUN.EQ.18284) GO TO 200
      IF(HRUN.EQ.18287) GO TO 200
      IF(HRUN.EQ.25688) GO TO 200
C
      IF(HRUN.GT.5404                 ) GO TO 100
      GO TO 200
100   IER = 0
200   RETURN
      END

C   04/09/78 C8110201   MEMBER NAME  SHMAX    (JADELGS)     FORTRAN
      FUNCTION SHMAX(ETOT,JEG)
C
C     S.YAMADA   04-09-78  11:50
C     LAST MODIFICATION  05-10-78  20:55
C
C---- CALCULATE THE AVERAGE SHOWER DEPTH FOR THE SHOWER WITH ETOT(MEV)
C     INITIATED BY EL/POS(JEG=1) AND/OR GAMMA(JEG=0).
C
      COMMON /CLGDMS/ X0
      DATA ECUT/4.979/, GCUT/1.725/
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/178100520/
      NVRSN(18) = NVCODE
C
      SHMAX = 0.
      IF(JEG) 1,2,1
C---- ELECTRON/POSITRON
    1 REN = ETOT/ECUT
      IF(REN.LE.1.0) RETURN
      GO TO 3
C---- GAMMA
    2 REN = ETOT/GCUT
      IF(REN.LE.1.0) RETURN
    3 SHMAX = ALOG(REN)*X0
      RETURN
      END

      SUBROUTINE CIRCCK(MTREL0,IATREL,RSLT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
***PMF      DIMENSION IATREL(1),RSLT(6),HATREL(24)
      DIMENSION IATREL(1),RSLT(8),HATREL(24)
#include "cpatlm.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
      DIMENSION XO(20),YO(20), XT(20),YT(20)
      FPAR (X) = (PAR1 *X + PAR2 )*X + PAR3
        DATA NPR /0/
        NPR = NPR + 1
      MTREL = IABS(MTREL0)
      SIGDV0 = RSLT(4)
      IP = 0
      ITREL = MTREL
16000 CONTINUE
        JPTREL = IATREL(ITREL)
        IPTREL = ISHFTR(JPTREL,16)
      IF(
     - LAND(JPTREL,1).EQ.0
     -)THEN
          XO(IP+1) = WRK(IPTREL+ 3)
          XO(IP+2) = WRK(IPTREL+11)
          YO(IP+1) = WRK(IPTREL+ 4)
          YO(IP+2) = WRK(IPTREL+12)
      ELSE
          XO(IP+1) = WRK(IPTREL+ 7)
          XO(IP+2) = WRK(IPTREL+15)
          YO(IP+1) = WRK(IPTREL+ 8)
          YO(IP+2) = WRK(IPTREL+16)
      ENDIF
      IF(
     - LAND(JPTREL,12).EQ.0
     -)THEN
      IF(
     - MTREL0.LT.0
     -)THEN
            ZWZ = XO(IP+1)
            XO(IP+1) = XO(IP+2)
            XO(IP+2) = ZWZ
            ZWZ = YO(IP+1)
            YO(IP+1) = YO(IP+2)
            YO(IP+2) = ZWZ
      ENDIF
          IP = IP + 2
      ELSE
      IF(
     - LAND(JPTREL, 4).NE.0
     -)THEN
            XO(IP+1) = XO(IP+2)
            YO(IP+1) = YO(IP+2)
      ENDIF
          IP = IP + 1
      ENDIF
      ITREL = ITREL - 1
      IF(.NOT.(
     - ITREL.EQ.0
     -))GOTO 16000
16001 CONTINUE
      IP9 = IP
      IP8 = IP - 1
        X1 = XO(  1)
        X2 = XO(IP9)
        Y1 = YO(  1)
        Y2 = YO(IP9)
        XOA = ( X1 + X2 ) / 2
        YOA = ( Y1 + Y2 ) / 2
        COSTH = X2 - X1
        SINTH = Y2 - Y1
        SUMX = 1.0 / SQRT(COSTH**2+SINTH**2)
        COSTH = COSTH * SUMX
        SINTH = SINTH * SUMX
        DMIN = 1000000.
      DO 13000 IP=1,IP9
          XX = XO(IP) - XOA
          YY = YO(IP) - YOA
          YT(IP) = YY * COSTH - XX * SINTH
          XT(IP) = XX * COSTH + YY * SINTH
          DX = ABS(XT(IP))
      IF(
     - DX.LT.DMIN
     -)THEN
            DMIN = DX
            IPA = IP
      ENDIF
13000 CONTINUE
13001 CONTINUE
        XC = XT(IPA)
        YC = YT(IPA)
      S1 = 0.
      S2 = 0.
      S3 = 0.
      S4 = 0.
      S5 = 0.
      S6 = 0.
      S7 = 0.
      DO 13002 IP = 1,IP9
        X = XT(IP)
        Y = YT(IP)
        X2 = X**2
        S1 = S1 + X
        S2 = S2 + X2
        S3 = S3 + X*X2
        S4 = S4 + X2**2
        S5 = S5 + Y*X2
        S6 = S6 + Y*X
        S7 = S7 + Y
13002 CONTINUE
13003 CONTINUE
      S0 = IP9
      F1 = 1. / S4
      XX12 = S3*F1
      XX13 = S2*F1
      YY1  = S5*F1
      XX22 = S2 - S3*XX12
      XX23 = S1 - S3*XX13
      YY2  = S6 - S3*YY1
      XX32 = S1 - S2*XX12
      XX33 = S0 - S2*XX13
      YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
        XX23 = XX23 / XX22
        YY2  = YY2  / XX22
        PAR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
        PAR2 = YY2 - XX23*PAR3
      ELSE
        XX33 = XX33 / XX32
        YY3  = YY3  / XX32
        PAR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
        PAR2 = YY3 - XX33*PAR3
      ENDIF
      PAR1 = YY1 - XX12*PAR2 - XX13*PAR3
      XCIRC =-.5 * PAR2 / PAR1
      YZW   = FPAR(XCIRC)
      R0 = SIGN(1.E6,PAR1)
      IF(ABS(PAR1).GT..5E-6) R0 = .5 / PAR1
      YCIRC = R0 + YZW
      R0 = ABS(R0)
      IF(
     - R0.GT.2000.
     -)THEN
        SUM2 = 0.
        ZW1 = R0**2
        ZW2 = .5/R0
      DO 13004 IP=1,IP9
          F = FPAR(XT(IP))
          DR = YT(IP) - F
          SUM2 = SUM2 + DR**2
13004 CONTINUE
13005 CONTINUE
        SIG = SQRT(SUM2/(IP9-3))
        DX = 0.
      ELSE
      IF(
     - XC.LT.0.
     -)THEN
          X2 = XC
          Y2 = YC
          X1 = XT(  1)
          Y1 = YT(  1)
      ELSE
          X1 = XC
          Y1 = YC
          X2 = XT(IP9)
          Y2 = YT(IP9)
      ENDIF
        XCIRC = 0.
        YCIRC = 100000.
        DY = Y2 - Y1
        IF(ABS(DY).GT..01)
     *     YCIRC = ((X2-X1)*(X2+X1)/DY + Y2+Y1)*.5
        IF(ABS(YCIRC).GT.100000.) YCIRC = SIGN(100000.,YCIRC)
        T  = YCIRC - YC
        R0 = ABS(T)
        CHARGE = SIGN(1.,T)
        R0 = .5*(R0 + ((YCIRC-YC)**2+XC**2) / R0)
      NTRIAL = 0
16002 CONTINUE
      NTRIAL = NTRIAL + 1
        SUM1 = 0.
        SUM2 = 0.
        SUM3 = 0.
        SUM4 = 0.
        ZW1 = R0**2
        ZW2 = .5/R0
      DO 13006 IP=1,IP9
          XZW = XT(IP)
          YZW = (XZW**2+(YT(IP)-YCIRC)**2 - ZW1) * ZW2
          SUM1 = SUM1 + XZW
          SUM2 = SUM2 + XZW**2
          SUM3 = SUM3 + XZW*YZW
          SUM4 = SUM4 + YZW
13006 CONTINUE
13007 CONTINUE
        TILT = (SUM3*IP9-SUM1*SUM4) / (SUM2*IP9-SUM1**2)
        DR0  = (SUM4 - TILT*SUM1)/IP9
        R0 = R0 + DR0
        DX =-TILT*R0
        SUM1 = 0.
        SUM2 = 0.
        SUM3 = 0.
        SUM4 = 0.
        ZW1 = R0**2
        ZW2 = .5/R0
      DO 13008 IP=1,IP9
          XT(IP) = XT(IP) + DX
          XZW = XT(IP)**2
          YZW = (XZW+(YT(IP)-YCIRC)**2 - ZW1) * ZW2
          SUM1 = SUM1 + XZW
          SUM2 = SUM2 + XZW**2
          SUM3 = SUM3 + XZW*YZW
          SUM4 = SUM4 + YZW
13008 CONTINUE
13009 CONTINUE
        B = (SUM3*IP9-SUM1*SUM4) / (SUM2*IP9-SUM1**2)
        DSAG = (SUM4 - B*SUM1)*2. / IP9
        SAG = (XT(IP9)-XT(1))**2 * .125/R0
        DR0 =-R0*DSAG/SAG
        IF(ABS(DSAG/SAG) .GT. 0.2) DR0 = 0.
        R0ZW  = DR0 + R0
        YCZW  = CHARGE*DR0 + YCIRC
      IF(
     - ABS(YCZW).LT.100000. .AND. ABS(DR0).LT.100000.
     -)THEN
          YCIRC = YCZW
          R0    = R0ZW
          LBCHCH= 0
      ELSE
          LBCHCH= 1
      ENDIF
        SUM1 = 0.
        SUM2 = 0.
        ZW1 = R0**2
        ZW2 = .5/R0
      DO 13010 IP=1,IP9
          DR = ((XT(IP)-XCIRC)**2+(YT(IP)-YCIRC)**2 - ZW1) * ZW2
          SUM1 = SUM1 + DR
          SUM2 = SUM2 + DR**2
13010 CONTINUE
13011 CONTINUE
        DR0 = SUM1 / IP9
        R0 = R0 + DR0
        YCIRC = YCIRC + DR0*CHARGE
        SIG = 0.
        IF(IP9.GT.3) SIG = SQRT(ABS(SUM2/IP9 - DR0**2)*IP9/(IP9-3))
        SIG0= SQRT(SUM2/IP9)
      IF(
     - LBCHCH.EQ.0
     -)THEN
      GOTO 16003
      ENDIF
      IF(
     - NTRIAL.GT.1
     -)THEN
      GOTO 16003
      ENDIF
        YCSAV = YCIRC
        DXSAV = DX
        SGSAV = SIG0
        R0SAV = R0
        CHSAV = CHARGE
        YCIRC  = -YCIRC
        R0     = ABS(YCIRC)
        CHARGE =-CHARGE
      DO 13012 IP=1,IP9
          XT(IP) = XT(IP) - DX
13012 CONTINUE
13013 CONTINUE
      IF(.NOT.(
     - .FALSE.
     -))GOTO 16002
16003 CONTINUE
      IF(
     - NTRIAL.GT.1 .AND. SIG0.GT.SGSAV
     -)THEN
        YCIRC  = YCSAV
        DX     = DXSAV
        SIG0   = SGSAV
        R0     = R0SAV
        CHARGE = CHSAVE
      ENDIF
      ENDIF
      XX = XCIRC - DX
      YY = YCIRC
      X0 = XX * COSTH - YY * SINTH + XOA
      Y0 = YY * COSTH + XX * SINTH + YOA
      RATLR = ABS(XT(1)*2. / R0)
      SGANG  = 0.
      RATCR  = 0.
      IF(
     - SIG.LE.SIGDV0
     -)THEN
        NCLL  = 0
        ICLL0 = 0
        IP = 0
        ITREL = MTREL
16004 CONTINUE
          JPTREL = IATREL(ITREL)
          IPTREL = ISHFTR(JPTREL,16)
          ICLL = IWRK(IPTREL)
          IF(ICLL.NE.ICLL0) NCLL = NCLL + 1
          ICLL0 = ICLL
      IF(
     - LAND(JPTREL,1).EQ.0
     -)THEN
            XO(IP+1) = WRK(IPTREL+ 3)
            XO(IP+2) = WRK(IPTREL+11)
            YO(IP+1) = WRK(IPTREL+ 4)
            YO(IP+2) = WRK(IPTREL+12)
            XT(IP+1) = WRK(IPTREL+ 5)
            XT(IP+2) = WRK(IPTREL+13)
            YT(IP+1) = WRK(IPTREL+ 6)
            YT(IP+2) = WRK(IPTREL+14)
      ELSE
            XO(IP+1) = WRK(IPTREL+ 7)
            XO(IP+2) = WRK(IPTREL+15)
            YO(IP+1) = WRK(IPTREL+ 8)
            YO(IP+2) = WRK(IPTREL+16)
            XT(IP+1) = WRK(IPTREL+ 9)
            XT(IP+2) = WRK(IPTREL+17)
            YT(IP+1) = WRK(IPTREL+10)
            YT(IP+2) = WRK(IPTREL+18)
      ENDIF
      IF(
     - LAND(JPTREL,12).EQ.0
     -)THEN
      IF(
     - IABS(IWRK(IPTREL+2)).GT.5
     -)THEN
              IP = IP + 2
      ELSE
              XT(IP+1) = (XT(IP+1)+XT(IP+2)) * .5
              YT(IP+1) = (YT(IP+1)+YT(IP+2)) * .5
              XO(IP+1) = (XO(IP+1)+XO(IP+2)) * .5
              YO(IP+1) = (YO(IP+1)+YO(IP+2)) * .5
              IP = IP + 1
      ENDIF
      ELSE
      IF(
     - LAND(JPTREL, 4).NE.0
     -)THEN
              XT(IP+1) = XT(IP+2)
              YT(IP+1) = YT(IP+2)
      ENDIF
            IP = IP + 1
      ENDIF
        ITREL = ITREL - 1
      IF(.NOT.(
     - ITREL.EQ.0
     -))GOTO 16004
16005 CONTINUE
        IP9 = IP
        IP8 = IP - 1
      DO 13014 IP=1,IP9
          DX = XT(IP)
          DY = YT(IP)
          XX = XO(IP)
          YY = YO(IP)
      IF(
     - ABS(XX-X0).LT.ABS(YY-Y0)
     -)THEN
            TG1  = DY / DX
            TGC1 =-(XX-X0) / (YY-Y0)
      ELSE
            TG1  = DX / DY
            TGC1 =-(YY-Y0) / (XX-X0)
      ENDIF
          DLTS1 = ABS((TG1-TGC1) / (1.+TG1*TGC1))
          SGANG  = DLTS1**2 + SGANG
13014 CONTINUE
13015 CONTINUE
        SGANG  = SQRT(SGANG/FLOAT(IP9))
        RATCR  = NCLL*200. / R0
      ENDIF
      RSLT(1) = R0
      RSLT(2) = X0
      RSLT(3) = Y0
      RSLT(4) = SIG
      RSLT(5) = IP9 - 3
      RSLT(6) = RATLR
      RSLT(7) = SGANG
      RSLT(8) = RATCR
      RETURN
      END

C   07/06/96 606071850  MEMBER NAME  IBLN     (S4)          FORTG1
      FUNCTION IBLN(NAME)
C     BOS SUBPROGRAM =0.3=
#include "acs.for"
      COMMON/BCS/IW(1)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAME),NPRIM)+NAMAX1
   10 K=LFDI
      LFDI=IW(K+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 10
      IF(LFDI.NE.0) GOTO 90
      IF(NCI.GE.NAMAX) CALL BDMPA(1)
      NCI=NCI+1
      LFDI=NCI
      IW(INAMV+LFDI)=NAME
      IW(K+IPLST)=LFDI
   90 IBLN=LFDI
  100 RETURN
      END

C   22/01/79 307041836  MEMBER NAME  STPLST   (JADEGS)      FORTRAN
      SUBROUTINE STPLST
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
      COMMON/CGRAP2/BCMD,DSPDTM(30)
      DATA ICALL/0/
C---
C---     LETS SCANNER SPECIFY A LIST OF USER INDICES AT WHICH THE
C---     PROGRAM WILL STOP AND REQUEST USER GUIDANCE.
C---
C---    ARRAY PSTPS      PROGRAMMED STOP LEVELS; SET FALSE IN USER
C---    ARRAY SSTPS      STANDARDLY SET IN GRAPHICS
C---    ARRAY LSTPS      LABELLED STOP FLAGS
C---          COMMENTED OUT, SINCE NEVER USED      30.8.82  J.OLSSON
C---
      IF(ICALL.EQ.1) GO TO 1
      ICALL=1
      DO 2 I=1,10
      SSTPS(I)=.FALSE.
    2 LSTPS(I)=0
1     CONTINUE
CHECK TRAILING NUMBER
      N1 = ACMD
      N = N1
      IF(N.GT.0.AND.N.LT.11) GO TO 2400
      CALL TRMOUT(80,'PLEASE ENTER USER INDICES AT WHICH YOU WISH TO STO
     $P, SEPARATED BY ENTERS.^')
      CALL TRMOUT(80,'ENTER 0 TO GET OUT OF CHANGE LOOP, 100 TO SEE WHIC
     $H INDICES ARE CURRENTLY SET.^')
3     N=TERNUM(DUMMY)
      IF(N.EQ.100) GO TO 4
      IF(N.EQ.0) GO TO 7
      IF(N.LT.0.OR.N.GT.10) GO TO 5
2400  SSTPS(N)=.NOT.SSTPS(N)
      IF(N1.GT.0) GO TO 7
      GO TO 3
C ILLEGAL ENTRY
5     CALL DIAGIN('ILLEGAL NR ENTERED: ',1,N)
      CALL TRMOUT(80,'PLEASE TRY AGAIN.^')
      GO TO 3
C DISPLAY CURRENT SETTINGS
4     KNTR=0
      DO 6 I=1,10
      IF(.NOT.SSTPS(I)) GO TO 6
      KNTR=KNTR+1
      WRITE(JUSCRN,104) I
  104 FORMAT('FLAG',I4,' IS ON.')
    6 CONTINUE
      IF(KNTR.EQ.0) CALL TRMOUT(80,'NO INDICES ARE SET.^')
      CALL TRMOUT(80,'NOW RETURN TO CHANGE LOOP.^')
      GO TO 3
C LEVEL SETTING READY
    7 CONTINUE
C     CALL TRMOUT(80,'PLEASE NOW ENTER EVENT LABEL VALUES FOR WHICH THE
C    $SCANNER SHOULD BE CALLED.^')
C     CALL TRMOUT(80,'YOU CAN ENTER AS MANY AS TEN. ZERO OR RETURN TERMI
C    $NATES ENTRIES.^')
C     KNTR=0
C   8 CONTINUE
C     KNTR=KNTR+1
C     IF(KNTR.LE.10) GO TO 9
C     CALL TRMOUT(80,'TEN ENTRIES MADE. NO MORE ARE POSSIBLE.^')
C     GO TO 10
C   9 CONTINUE
C     NSET=TERNUM(DUMMY)
C     IF(NSET.EQ.0) GO TO 10
C     LSTPS(KNTR)=NSET
C     GO TO 8
C  10 CONTINUE
C     KNTR=0
C     DO 11 I=1,10
C     NSET=LSTPS(I)
C     IF(NSET.EQ.0) GO TO 11
C     DO 16 J=1,I
C     IF(J.EQ.I) GO TO 16
C     IF(NSET.EQ.LSTPS(J)) GO TO 11
C  16 CONTINUE
C     KNTR=KNTR+1
C     LSTPS(KNTR)=NSET
C  11 CONTINUE
C     CALL TRMOUT(80,'SCANNER WILL BE CALLED WHEN THE FOLLOWING EVENT LA
C    $BEL VALUES OCCUR:^')
C     IF(KNTR.GE.1) GO TO 12
C     CALL TRMOUT(80,'NONE^')
C     GO TO 14
C  12 CONTINUE
C     WRITE(JUSCRN,105) (LSTPS(I),I=1,KNTR)
C 105 FORMAT(' ',10I5)
   14 CONTINUE
      DO 17 ISAFE=1,10
      IF(SSTPS(ISAFE)) GO TO 18
C     IF(LSTPS(ISAFE).NE.0) GO TO 18
   17 CONTINUE
      CALL TRMOUT(80,'THERE ARE NO USER LEVELS SET!^')
      CALL TRMOUT(80,'DO YOU REALLY WISH TO PROCEED THROUGH THE ENTIRE I
     $NPUT FILE WITHOUT STOPPING?^')
      CALL TRMOUT(80,'IF NOT, YOU WILL GET ANOTHER CHANCE TO SET INDICES
     $ AND FLAGS^')
      CALL DECIDE(IANSWR)
      IF(IANSWR.EQ.2) GO TO 1
   18 CONTINUE
      RETURN
      END

C   07/06/96 606071839  MEMBER NAME  CLOC     (S4)          FORTG1
      SUBROUTINE CLOC(IND,NAME,NR)
C     BOS SUBPROGRAM =1.6=
#include "acs.for"
      COMMON/BCS/IW(1)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAME),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 3
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)        GOTO    10
      IF(IW(LFDI-2)-NR) 2,4,10
    4 IND=LFDI
  100 RETURN
   10 IND=0
      GOTO 100
      END

C   30/04/96 604301841  MEMBER NAME  STAR     (BOSLIB.S)    FORTRAN
      REAL STAR/Z0000005C/,FF/Z000000FF/
      EQUIVALENCE (XNAME,INAME)
      LOGICAL NOTLOW
      REAL AND
      EXTERNAL AND
      NOTLOW(XNAME)=AND(XNAME,FF).NE.STAR

C   01/11/84            MEMBER NAME  ECAPS    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE ECAPS(NECC)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  LG END CAPS ENERGIES
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgeo1.for"
#include "cgraph.for"
C
      COMMON /CWORK1/ R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                HMW(132)
C
      DATA ICALL/0/
C
C-----------------  C O D E  -------------------------------------------
C
      IF(ICALL.EQ.1) GO TO 1000
      ICALL=1
      OFST1=0.
      OFST2=1.-OFST1
      BLSEX = OFST1*BLXY
      SH3 = 0.6667*BLXY
 1000 CONTINUE
      IPJ = IDATA(IBLN('ALGN'))
      IF(IPJ.LE.0) GO TO 4
      NWO = IDATA(IPJ)
      IF(NWO.LE.3) GO TO 4
      IPJ = 2*IPJ + 8
      NWO = IPJ + 2*NWO - 8
C
      DO 12  NI = IPJ,NWO,2
      NO = HDATA(NI-1)
      IF(NO.LT.2687) GO TO 12
      IF(NO.GE.0.AND.NO.LE.2879) GO TO 13
      WRITE(JUSCRN,101) NO
  101 FORMAT('ECAPS FOUND ILLEGAL BLOCK NO:',I10)
      GO TO 12
C
C  GET COORDINATE OF BLOCK
C
13    CONTINUE
C     REDUCE TO NUMBERS 1 - 192
      NO = NO - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (NO - 1)/96
      IF(NECC.EQ.1.AND.NE.NE.0) GO TO 12
      IF(NECC.EQ.2.AND.NE.NE.1) GO TO 12
C     REDUCE TO 1 - 96
      NO = NO - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (NO - 1)/24
C     REDUCE TO 1 - 24
      NO = NO - NQ*24
C     COMPUTE CORNER OF BLOCK IN FIRST QUADRANT
      IF(.NOT.((NO.EQ.1).OR.(NO.EQ.5).OR.(NO.EQ.10).OR.(NO.EQ.16)))
     1GO TO 43
      Y0 = BLSEX
      X0 = 3.4*BLXY - BLSEX + (NO/5)*BLXY
   43 CONTINUE
      IF(.NOT.((NO.EQ.2).OR.(NO.EQ.6).OR.(NO.EQ.11).OR.(NO.EQ.17)))
     1GO TO 44
      Y0 = BLSEX + BLXY
      X0 = 3.*BLXY - BLSEX + (NO/5)*BLXY
   44 CONTINUE
      IF(.NOT.((NO.EQ.3).OR.(NO.EQ.7).OR.(NO.EQ.12).OR.(NO.EQ.18)))
     1GO TO 45
      Y0 = BLSEX + 2.*BLXY
      X0 = 2.*BLXY - BLSEX + (NO/5)*BLXY
   45 CONTINUE
      IF(.NOT.((NO.EQ.8).OR.(NO.EQ.13).OR.(NO.EQ.19).OR.(NO.EQ.20)))
     1GO TO 46
      Y0 = BLSEX + BLXY*3.
      K = NO/5
      IF(K.GT.2) K = 7 - K
      X0 = (K+1)*BLXY-BLSEX
   46 CONTINUE
      IF(.NOT.((NO.EQ.4).OR.(NO.EQ.9).OR.(NO.EQ.15).OR.(NO.EQ.24)))
     1GO TO 47
      X0 = BLXY - BLSEX
      K = (NO-1)/5
      IF(K.EQ.4) K = 3
      Y0 = 2.4*BLXY + BLSEX + K*BLXY
   47 CONTINUE
      IF(.NOT.((NO.EQ.14).OR.(NO.EQ.23)))
     1GO TO 48
      X0 = 2.*BLXY - BLSEX
      Y0 = 4.*BLXY + BLSEX + (NO/15)*BLXY
   48 CONTINUE
      IF(.NOT.((NO.EQ.21).OR.(NO.EQ.22)))
     1GO TO 49
      Y0 = 4.*BLXY + BLSEX
      X0 = - BLSEX + 4.*BLXY - ((NO-2)/20)*BLXY
   49 CONTINUE
C     ROTATE TO CORRECT QUADRANT
      IF(NQ.NE.1) GO TO 50
      REM = X0
      X0 = - Y0
      Y0 = REM - OFST2*BLXY
      GO TO 52
   50 CONTINUE
      IF(NQ.NE.2) GO TO 51
      X0 = - X0 + OFST2*BLXY
      Y0 = - Y0 - OFST2*BLXY
      GO TO 52
   51 CONTINUE
      IF(NQ.NE.3) GO TO 52
      REM = Y0
      Y0 = - X0
      X0 = REM + OFST2*BLXY
   52 CONTINUE
      X0 = - X0
 2000 CONTINUE
      X1=X0+10.
      Y1=Y0+10.
      IE = HDATA(NI)
      CALL PHNUMB(IE,SH3,0.)
   12 CONTINUE
C
    4 CONTINUE
      RETURN
      END

C   11/09/79 C9091101   MEMBER NAME  MUERR    (S)           FORTRAN
C LAST CHANGE 10.37 11/09/79 JOHN ALLISON.
      SUBROUTINE MUERR(NAME,INF,MESS,N)
C
      REAL*8 NAME
      LOGICAL*1 MESS(1)
C
C PRINTS MU ERROR MESSAGES.
C
C PROVIDE SUBROUTINE NAME IN NAME.
C PROVIDE INFORMATION IN INTEGER*4 WORD INF.
C PROVIDE MESSAGE IN MESS, LENGTH N CHARACTERS
C
      COMMON /CMUPRN/MUPRIN
C
      IF(MUPRIN.EQ.0)GO TO 99
C
      N=IABS(N)
      IF(N.GT.200)N=200
C
      WRITE(6,100)NAME,INF,(MESS(I),I=1,N)
 100  FORMAT('0***** MU ERROR IN ',A8,4X,', INFORMATION WORD',I10,
     *4X,70A1/(1X,132A1))
C
 99   CONTINUE
      RETURN
      END

C
C-----------------------------  MACRO CGRCOM  --------------------------
C
C                            THIS MACRO DEFINES THE NAMES OF THE
C                            VARIABLES WHICH POINT TO COMMAND WORDS.
C
C
      COMMON / CGRCO1 /   HADC,   HADD,   HALTER, HAMPL,  HAXES,
     +                    HBANK,  HCAPS,  HCHAM,  HCHANG, HCLUST,
     +                    HCOMMD, HCOMEN, HCONT,  HCOPY,  HCOUNT,
     +                    HCWORK, HCYL,   HDATA,  HDEDX,  HDEL,
     +                    HDETLS, HDET,   HDISP,  HDRAW,  HEDIT,
     +                    HENDC,  HEVENT, HEXT
C
      COMMON / CGRCO2 /   HFAMP,  HFILTR, HFIND,  HFIT,   HFLAG,
     +                    HFLASH, HFORWD, HFRONT, HFW,    HGLASS,
     +                    HGOOD,  HHARD,  HHELP,  HID,    HINNER,
     +                    HJET,   HJETC,  HJUMP,  HLEAD,  HLEVEL,
     +                    HLG,    HLIMIT, HLIST,  HMAP,   HMASS,
     +                    HMENU,  HMUON,  HMUPT
C
      COMMON / CGRCO3 /   HNEWS,  HNEXT,  HNO,    HNORD,  HNR,
     +                    HNUMB,  HOPT,   HPARAM, HPARMS, HPATR,
     +                    HPATRN, HPHI,   HPICK,  HPLOTS, HPROJ,
     +                    HQ,     HRECAL, HRECOG, HREGN,  HRESET,
     +                    HRESLT, HRETRN, HR,     HRZ,    HSAVE,
     +                    HSCALE, HSET,   HSHOW
C
      COMMON / CGRCO4 /   HSIDE,  HSTAND, HSTAT,  HTAGG,  HTOF,
     +                    HTOP,   HTRACK, HTRUE,  HTRIG,  HT1,
     +                    HT2,    HT3,    HVERTX, HVIEW,  HVTXC,
     +                    HWRK,   HWRITE, HXY,    HXZ,    HZ
C
C----------------------------  END OF MACRO CGRCOM  --------------------
C

C   14/10/82            MEMBER NAME  TESTWR   (S)           FORTRAN77
      SUBROUTINE TESTWR(NBUF,MODE)
      COMMON/BCS/IW(1)
      CALL BWRO(1,NBUF,MODE)
      NREC=0
      DO 50 K=1,500
C     CREATE HEAD
      DO 10 J=1,3
      CALL BCRE(IND,'HEAD',J,20,&100,IER)
      DO 5 I=1,20
    5 IW(IND+I)=I
   10 CONTINUE
C     CREATE DATA
      NJ=MOD(K,7)+3
      DO 20 J=1,NJ
      NW=10+J
      IF(J.EQ.9) NW=2000
      CALL BCRE(IND,'DATA',J,NW,&100,IER)
      DO 15 I=1,NW
   15 IW(IND+I)=I*100
   20 CONTINUE
C     WRITE
      CALL BMLT(2,'HEADDATA')
   30 CALL BWRS(1,NBUFL,INIW)
      IF(INIW.EQ.0) GOTO 40
      NREC=NREC+1
      IF(NREC.GE.7777) CALL BPRS('BUFF',1)
      CALL BFWR(1,NBUFL,IW(INIW))
      GOTO 30
C     DELETE
   40 CALL BMLT(2,'HEADDATA')
      CALL BDLG
C
   50 CONTINUE
      CALL BMLT(0,DUMMY)
      CALL BWRS(1,NBUFL,INIW)
      IF(INIW.EQ.0) GOTO 60
      CALL BFWR(1,NBUFL,IW(INIW))
   60 CONTINUE
      CALL BSTA
      REWIND 1
      CALL BDLS('+BUF',1)
      CALL BGAR(IGA)
      RETURN
  100 STOP
      END

C   08/12/80 308171157  MEMBER NAME  FXYZNC   (JADESR)      FORTRAN
      SUBROUTINE FXYZ(NT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C
C
C-----------------------------------------------------------------------
C
C         -------------- SUBROUTINE FXYZ(NT) -----------------
C         ---- G.F.PEARCE .. LAST UPDATE : 1030 ON 31/10/80 ----
C
C     THIS SUBROUTINE CALCULATES THE COORDINATES IN REAL SPACE OF ALL
C     HITS ASSOCIATED BY THE TRACK RECOGNITION PROGRAM WITH A SINGLE
C     TRACK. THE SINGLE TRACK FOR WHICH THIS IS DONE IS DEFINED BY THE
C     USER ON INPUT BY THE NUMBER NT, THIS BEING THE NUMBER OF THE
C     TRACK IN THE OUTPUT COMMON FROM SUBROUTINE BACKTR.
C
C     THE RESULTS ARE PLACED IN THE ARRAY WRK IN COMMON/CWORK/.
C     HPHT0    = POINTER TO FIRST WORD OF FIRST HIT IN WRK.
C     HPHT9    = POINTER TO LAST WORD OF LAST HIT IN WRK.
C     HLDHT    = NUMBER OF 4-BYTE WORDS STORED PER HIT IN WRK.
C     HPHT0A   = POINTER TO FIRST WORD OF FIRST HIT FOR COORDINATES
C                CALCULATED USING THE OPPOSITE L/R SOLUTION.
C                IF BACKTRACE HAS UNAMBIGUOUSLY RESOLVED THE L/R SOLN
C                THEN NO REVERSED L/R SOLN IS COMPUTED AND THIS POINTER
C                IS SET NEGATIVE.
C     HPHT9A   = POINTER TO LAST WORD OF LAST HIT IN WRK FOR OPPOSITE
C                L/R SOLUTION. ONLY SET WHEN IDWRK(1) IS NOT NEGATIVE.
C     HPHTLM   = LOWEST ALLOWABLE HPHT0 (CORRESPONDING TO NHITMAX)
C
C-----------------------------------------------------------------------
C
C
      COMMON/CADMIN/IEVTP,NREC,NRWRIT,NRERR
      COMMON/CHEADR/HEAD(20)
C
#include "calibr.for"
C
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     * RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,ZRESOL,ZNORM,ZAL,
     * ZSCAL,DRIDEV,DRICOS,DRISIN,PEDES,TZERO(3),
     * DRIROT(96,2),SINDRI(96,2),COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     * CAB(8)
C  TEMPORARY INSTALLMENT OF ARRAY T0FIX, WILL BE PERMANENT LATER
#include "cdsmax.for"
#include "cpatlm.for"
C
C-----------------------------------------------------------------------
C    EQUIVALENCE OUTPUT BANK TO ADWRK FOR EASE OF TRANSFER TO HIT BANK
C-----------------------------------------------------------------------
C
         EQUIVALENCE (ADWRK( 1),LAYER)
         EQUIVALENCE (ADWRK( 2),NH1)
         EQUIVALENCE (ADWRK( 3),NH)
         EQUIVALENCE (ADWRK( 4),XHIT1)
         EQUIVALENCE (ADWRK( 5),YHIT1)
         EQUIVALENCE (ADWRK( 6),ZHIT1)
         EQUIVALENCE (ADWRK( 7),RHIT1)
         EQUIVALENCE (ADWRK( 8),IERZRF)
         EQUIVALENCE (ADWRK( 9),NLMIDO)
         EQUIVALENCE (ADWRK(10),INCELL)
         EQUIVALENCE (ADWRK(11),IERXYF)
         EQUIVALENCE (ADWRK(12),BETA)
         EQUIVALENCE (ADWRK(13),INRING)
         EQUIVALENCE (ADWRK(14),CHIXYF)
C -- MASKS MK1 TO EXTRACT TRACK ELEMENT NUMBER FROM HIT LABEL
C --       MK2 TO EXTRACT WIRE CROSSING FLAG
C --       MK3 TO EXTRACT FLAG ON UNRESOLVED L/R SOLUTION IN BACKTRACE
C --       MK4 TO EXTRACT FLAG ON TEST TRACK ELEMENT.
         INTEGER*4 MK1/Z00FE/ , MK2/Z100/ , MK3/Z1000/ , MK4/Z20000/
         HPWRK(30) = NT
C
C        ----------------------
C        POINTER INITIALISATION
C        ----------------------
C
         HLDHT = 14
         LONG = HLDHT * 4
         MAXHT = 80
         INHIT = HPFREE + MAXHT * HLDHT
         IF (INHIT.LE.HPLAST) GOTO10
C ----- ERROR 1 --------- NOT ENOUGH SPACE IN CWORK
         CALL ERRORM('FXYZ    ',1,NT)
         INHIT = HPLAST
         MAXHT = (HPLAST-HPFREE)/HLDHT
         IF (MAXHT.GE.8) GOTO10
C ----- ERROR 2 --------- HAD TO ABANDON TRACK NT
         CALL ERRORM('FXYZ    ',2,NT)
         HPHT0 = 1
         HPHT9 = 1
         GOTO1600
 10      HPHT9 = INHIT - 1
         HPHTLM = HPFREE
         HPFREE = INHIT
C
C        -------------------------------
C        OPPOSITE L/R AMBIGUITY POINTERS
C        AMBIGUITY 1 AT TOP, 2 AT BOTTOM
C        ------------------------------
C
         INHIT2 = -1
         IW1 = HISTR(1,NT)
         IW1 = LBL(IABS(IW1))
         LRNOWN = LAND(IW1,MK3)
         IF (TBIT(IXYF(1),26)) LRNOWN = 0
         IF (LRNOWN.EQ.0) GOTO50
C
         HLDHTA = HLDHT
         MAXHT = MAXHT / 2
         INHIT2 = INHIT - MAXHT * HLDHT
         HPHT9A = INHIT2 - 1
C
 50      NHIT = 0
         CHIXYF = 0
         NL = HNREL(NT)
         IF (NL.GT.0) GOTO60
C ----- ERROR 3 --------- NO TRACK ELEMENTS FROM BACKTRACE
         CALL ERRORM('FXYZ    ',3,NT)
         GOTO1590
 60      NLLAST = - 1
         NRLAST = - 1
C
C
C---------------------------------------------------------------------
C   LOOP OVER EACH TRACK ELEMENT BELONGING TO THIS TRACK. FOR
C   EACH TRACK ELEMENT STORE ALL REQUIRED INFORMATION BEFORE LOOPING
C   OVER HITS.
C---------------------------------------------------------------------
C
C
 1140    CONTINUE
C
C        -------------------------------
C        POINTER TO TRACK ELEMENT IN
C        COMMON/MIDOUT/. THIS CARRIES A
C        +VE/-VE SIGN INDICATING A RIGHT/
C        LEFT SOLUTION FROM BACKTRACING
C        -------------------------------
C
         NLMIDO = HISTR(NL,NT)
         IF (NLMIDO.NE.0)GOTO1150
C ----- ERROR 4 --------- TRACK ELEMENT ZERO FROM BACKTRACE
         CALL ERRORM('FXYZ    ',4,NT)
         GOTO1580
 1150    ILMIDO = IABS(NLMIDO)
         LABEL = LBL(ILMIDO)
C
C        -------------------------------
C        IS THIS A TEST TRACK ELEMENT ?
C        -------------------------------
C
         IERXYF=LAND(LABEL,MK4)
         IF(IERXYF.NE.0)IERXYF=2
C
C        -------------------------------
C        CELL NUMBER AND RING NUMBER
C        -------------------------------
C
         INCELL = IPCL(ILMIDO)
         INRING = 1
         IF(INCELL.GT.24)INRING = 2
         IF(INCELL.GT.48)INRING = 3
C
C        -------------------------------
C        LEFT/RIGHT AMBIGUITY FLAG FOR
C        FIRST HIT ON TRACK ELEMENT
C        -------------------------------
C
         IF (NLMIDO.GT.0) GOTO1160
         LRFLAG = - 1
         LR12 = 1
         GOTO1170
 1160    LRFLAG = + 1
         LR12   = 2
C
C        -------------------------------
C        LBZRCR = LABEL FOR WIRE CROSSING
C        IWCRS  = FIRST WIRE # AFTER ELEMENT
C                 CROSSES WIRE BOUNDARY.
C        -------------------------------
C
 1170    LBZRCR = LAND(LABEL,MK2)
         IWCRS = ICRO(ILMIDO)
C
C        ------------------------------
C        LORENTZ ANGLE TRANSFORMATION
C        AND DRIFT VELOCITY
C        ------------------------------
C
         TRLORX = TRMATS(INCELL,1)
         TRLORY = TRMATC(INCELL,1)
         SINLOR = SINDRI(INCELL,1)
         COSLOR = COSDRI(INCELL,1)
         DRFVEL = DRIVEL(INCELL,1)
C
C        ----------------
C        ABERATION ARRAYS
C        ----------------
C
C
C        CORRECTION CONSTANTS FOR INCELL
         IPJCOR = ICALIB(5) + INCELL
         IPJCOS = IPJCOR + (LR12-1)*96
         CCST0  = ACALIB(IPJCOS     )
         CCST1  = ACALIB(IPJCOS+ 192)
         CCST2  = ACALIB(IPJCOS+ 384)
         CCST51 = ACALIB(IPJCOR+ 576) * 10.
         CCST61 = ACALIB(IPJCOR+ 768) * 10.
         CCST81 = ACALIB(IPJCOR+1152)
C
C        -------------------------------
C        RING RADIUS AND WIRE SEPARATION
C        -------------------------------
C
         R0  = FSENSW(INRING)
         DR0 = RINCR(INRING)
C
C        --------------------------------------
C        COMPUTE AVERAGE ANGLE OF TRACK TO WIRE
C        PLANE OVER THIS TRACK ELEMENT. USE THIS
C        ANGLE TO COMPUTE THE CORRECTION TO DRIFT
C        SPACE REQUIRED TO CENTRE DRIFT TIME ON
C        DRIFT CHARGE CENTRE.
C        ---------------------------------------
C
         DXWR = DR0 * COSLOR
         DYWR = DR0 * SINLOR
C        FIRST HALF OF HITS
         BETA  = ( LRFLAG * SL1(ILMIDO) - DYWR )
         BETA = SQRT( DXWR**2 + BETA**2 ) / DXWR
C        SECOND HALF OF HITS
         LAYERM = LRFLAG
         IF (IWCRS.NE.0) LAYERM = - LAYERM
         BETA2 = ( LAYERM * SL2(ILMIDO) - DYWR )
         BETA2 = SQRT( DXWR**2 + BETA2**2 ) / DXWR
         BETA = (BETA + BETA2) / 2
         IF (BETA.LT.1.0) BETA = 1.0
         IF (BETA.GT.1.1) BETA = 1.1
         TANBET=SQRT(BETA**2-1.)
         BETAM1 = BETA-1
C
C        -----------------------------------
C        WMID FOR FIELD DISTORTION ABERATION
C        -----------------------------------
C
         WMID=7.5+(DS1(ILMIDO)+DS2(ILMIDO))*SINLOR/40
C
C        -------------------------------
C        TRACK ELEMENT NUMBER AS STORED
C        IN HIT LABEL DATA BANK.
C        -------------------------------
C
         NLWANT = NTREL(ILMIDO)
C
C        ----------------------------
C        DIRECTION OF WIRE PLANE
C        AND DRIFT SPACE DIRECTION
C        ----------------------------
C
         IW1 = INCELL - 24*(INRING-1)
         IF (INRING.EQ.3) GOTO1180
         DXWR   = DIRWR1(IW1,1)
         DYWR   = DIRWR1(IW1,2)
         GOTO1190
 1180    DXWR   = DIRWR3(IW1,1)
         DYWR   = DIRWR3(IW1,2)
C
C        ------------------------------
C        WIRE STAGGERING ( +/- SWDEPL )
C        ------------------------------
C
 1190    DDXWR = + SWDEPL * DYWR
         DDYWR = - SWDEPL * DXWR
C
C
C----------------------------------------------------------------------
C   LOOP OVER ALL HITS FOR THIS CELL AND SEARCH FOR HITS BELONGING
C   TO THIS TRACK ELEMENT.
C----------------------------------------------------------------------
C
C         ----------------------------
C         DETERMINE POINTERS TO
C         HIT ARRAY AND HIT LABEL
C         ----------------------------
          NH0 = HPTSEC(INCELL)
          NH9 = HPTSEC(INCELL+1)-1
          IF (NH0.GT.0.AND.NH9.GT.0) GOTO1230
C ----- ERROR 6 --------- HPTSEC POINTER IS -VE
         CALL ERRORM('FXYZ    ',6,NT)
          GOTO1580
 1230     NH  = ISHFTR((NH0-HPTSEC(1)),1) + HPHL0
          NH1 = NH0
C
C         ----------------------------
C         LOOP OVER HITS IN CELL
C         ACCEPT HITS ON NLWANT BUT
C         PROTECT AGAINST HIT APPEARING
C         ON SUCCESSIVE TRACK ELEMENTS.
C         ----------------------------
C
 1240     CONTINUE
          IW1 = HWRK(NH)
          IW2 = HWRK(NH+1)
          NL1 = ISHFTR(LAND(IW1,MK1),1)
          NL2 = ISHFTR(LAND(IW2,MK1),1)
          IF(NL1.NE.NLWANT.AND.NL2.NE.NLWANT)GOTO1570
C
C         ------------------------------
C         THIS HIT IS ON REQUIRED TREL
C         REVERSE L/R AMBIGUITY IF THIS
C         HIT CROSSES WIRE BOUNDARY
C         -----------------------------
C
          IWIRE = HDATA(NH1  )
          IWIRE = ISHFTR(IWIRE,3)
          LAYER = LAND(IWIRE,15)
          IF(LBZRCR.EQ.0 .OR. LAYER.NE.IWCRS)GOTO1250
C
C         ---------------------
C         REVERSE L/R AMBIGUITY
C         ---------------------
C
          LRFLAG = - LRFLAG
          NLMIDO = - NLMIDO
          IPJCOS = IPJCOR + (2-LR12)*96
          CCST0  = ACALIB(IPJCOS     )
          CCST1  = ACALIB(IPJCOS+ 192)
          CCST2  = ACALIB(IPJCOS+ 384)
C
C         ------------------------------
C         REJECT THIS HIT IF IT WAS ALSO
C         ON THE PRECEDING TRACK ELEMENT
C         ------------------------------
C
 1250     IF(INRING.NE.NRLAST)GOTO1260
          IF(NL1.EQ.NLLAST.OR.NL2.EQ.NLLAST)GOTO1570
C
C         ------------------------------
C         LOAD DRIFT TIME AND Z AMPLIT.
C         ------------------------------
C
 1260     IAMPL=HDATA(NH1+1)
          IAMPR=HDATA(NH1+2)
          IDRIFT=HDATA(NH1+3)
C
C         -----------------------------
C         FLAG BAD Z-COORDINATE IF DRIFT
C         TIME FOR THIS HIT IS WITHIN
C         DOUBLE HIT RESLN. OF ANOTHER
C         HIT ON THIS LAYER.
C         -----------------------------
C
          IERZRF=0
CC--CC    CLOSEST HIT WITH LOWER DRIFT TIME
CC--CC    NH2=NH1-4
CC--CC    IF(NH2.LT.NH0)GOTO1270
CC--CC    IWIRE2=HDATA(NH2)
CC--CC    IWIRE2=ISHFTR(IWIRE2,3)
CC--CC    IF(IWIRE2.NE.IWIRE)GOTO1270
CC--CC    NEARH2=IDRIFT-HDATA(NH2+3)
CC--CC    IF(IABS(NEARH2).LE.IXYF(18))IERZRF=16
CC--CC    CLOSEST HIT WITH HIGHER DRIFT TIME
C1270     NH3=NH1+4
CC--CC    IF(NH3.GT.NH9)GOTO1280
CC--CC    IWIRE3=HDATA(NH3)
CC--CC    IWIRE3=ISHFTR(IWIRE3,3)
CC--CC    IF(IWIRE3.NE.IWIRE)GOTO1280
CC--CC    NEARH3=IDRIFT-HDATA(NH3+3)
CC--CC    IF(IABS(NEARH3).LE.IXYF(18))IERZRF=16
C
C         ------------------------
C         CREATE SPACE FOR NEW HIT
C         ------------------------
C
 1280     IF(NHIT.LT.MAXHT)GOTO1290
C ----- ERROR 5 --------- RAN OUT OF SPACE IN CWORK FOR TRACK NT
          CALLERRORM('FXYZ    ',5,NT)
          GOTO1590
 1290     NHIT=NHIT+1
          INHIT=INHIT-HLDHT
C
C-----------------------------------------------------------------------
C   COMPUTE (X,Y,Z,R) FOR THIS HIT AND STORE IN THE COORDINATE ARRAY WRK
C-----------------------------------------------------------------------
C
C         ------------
C         Z-COORDINATE
C         ------------
C
          IF(IAMPR.LE.0.OR.IAMPL.LE.0)GOTO1310
          ZHIT1=IAMPR+IAMPL
          ZHIT1=.5*ZAL*FLOAT(IAMPR-IAMPL)/ZHIT1
          GOTO1320
 1310     IERZRF=16
          ZHIT1=0.0
 1320     CONTINUE
C
C         -----------
C         WIRE RADIUS
C         -----------
C
          RWIRE=R0+LAYER*DR0
C
C         ----------------------------
C         CORRECTION FOR WIRE POSITION
C         AT Z=0 PERP. TO WIRE PLANE
C         ----------------------------
C
          DWIRE = CCST51*(LAYER-7.5) + CCST61
          DWIREX = + DWIRE * DYWR
          DWIREY = + DWIRE * DXWR
C
C         ----------------
C         WIRE COORDINATES
C         ----------------
C
          ISTAG=-1
          IF(TBIT(LAYER,31))ISTAG=+1
          DX1=RWIRE*DXWR+ISTAG*DDXWR+DWIREX
          DY1=RWIRE*DYWR+ISTAG*DDYWR-DWIREY
C
C         --------------------------------
C         CONVERT DRIFT TIME INTO DISTANCE
C         --------------------------------
C
          DRIFT=IDRIFT*DRFVEL
          IF(HEAD(18).LE.0)DRIFT=DRIFT+0.5*DRFVEL
C
C         --------------------------------
C         DRIFT PATH DISPERSION CORRECTION
C         --------------------------------
C
          IF(DRIFT.GT.4.0)GOTO1360
          DRIFT=DRIFT+BETAM1*DRIFT
          GOTO1370
 1360     DRIFT=DRIFT+BETAM1*4.0
 1370     CONTINUE
C
C         --------------------------
C         EDGE WIRE FIELD DISTORTION
C         --------------------------
C
          IF(LAYER.GE.3)GOTO1380
          DRIFT=DRIFT*(1.-CCST1*(LAYER-3)**2)
          GOTO1390
 1380     IF(LAYER.LE.12)GOTO1390
          DRIFT=DRIFT*(1.-CCST2*(LAYER-12)**2)
 1390     CONTINUE
C
C         --------------------------------------
C         FIELD DISTORTIONS AT LARGE DRIFT TIMES
C         --------------------------------------
C
          IF(DRIFT.GT.CAB(7))
     #    DRIFT=DRIFT+LRFLAG*CCST0*(LAYER-WMID)*TANBET*(DRIFT-CAB(7))
C
C         ----------------------------------
C         DRIFT VELOCITY VARIATION NEAR WIRE
C         ----------------------------------
C
          IF(DRIFT.LT.CAB(4))DRIFT=DRIFT+CAB(5)*(DRIFT-CAB(4))**2
C
C         -------------------------
C         RESET -VE DRIFT TIMES TO
C         HELP L/R AMBIGUITY SOLN.
C         AS REQUESTED BY P.STEFFEN
C         -------------------------
C
          IF(DRIFT.LT.0.)DRIFT=0.05
C
C         ---------------------
C         X,Y AND R COORDINATES
C         ---------------------
C
          IF(LRFLAG.GT.0) GOTO 20
            XHIT1=DX1 - TRLORX*DRIFT * (1. - CCST81)
            YHIT1=DY1 - TRLORY*DRIFT * (1. - CCST81)
            GOTO 25
   20     CONTINUE
            XHIT1=DX1 + TRLORX*DRIFT * (1. + CCST81)
            YHIT1=DY1 + TRLORY*DRIFT * (1. + CCST81)
   25     CONTINUE
          DR2=DRIFT/RWIRE
          DR1=0.5*DR2**2
          DR2=-LRFLAG*DR2*SINLOR
          RHIT1=DR1+DR2
          RHIT1=RWIRE*(1+RHIT1-.5*RHIT1**2)
C
C         -----------------------------
C         LOAD COORDINATES AND INCREASE
C         POINTER INHIT FOR NEXT HIT
C         ------------------------------
C
          CALLMVCL(WRK(INHIT),0,ADWRK(1),0,LONG)
C
C         --------------------------------
C         IF BACKTR UNCERTAIN ABOUT L/R
C         SOLUTION, COMPUTE BOTH.
C         --------------------------------
C
          IF(LRNOWN.EQ.0)GOTO1570
          XHIT1=DX1-LRFLAG*TRLORX*DRIFT
          YHIT1=DY1-LRFLAG*TRLORY*DRIFT
          DR2=DRIFT/RWIRE
          DR1=0.5*DR2**2
          DR2=-LRFLAG*DR2*SINLOR
          RHIT1=DR1-DR2
          RHIT1=RWIRE*(1+RHIT1-.5*RHIT1**2)
          INHIT2=INHIT2-HLDHT
          CALLMVCL(WRK(INHIT2),0,ADWRK(1),0,LONG)
          IWRK(INHIT2+8)=-IWRK(INHIT2+8)
C
C         ----------------
C         FETCH NEXT LAYER
C         ----------------
C
 1570     NH=NH+2
          NH1=NH1+4
          IF(NH1.LE.NH9)GOTO1240
C
C         ------------------------
C         FETCH NEXT TRACK ELEMENT
C         ------------------------
C
          NLLAST=NLWANT
          NRLAST=INRING
 1580     NL=NL-1
          IF(NL.NE.0)GOTO1140
C
C         ---------------------------
C         END OF FXYZ - SET POINTERS
C         ---------------------------
C
 1590     HPHT0=INHIT
          HPHT0A=INHIT2
 1600     CONTINUE
C2005 FORMAT('0TRACK:',I6,/,(1X,3I6,4F9.3,4I4,F9.3,I6,F9.3))
C     PRINT 2005, HLDHT,(WRK(I),I=HPHT0,HPHT9)
          RETURN
          END

C   18/10/82            MEMBER NAME  APLU     (S)           FORTRAN
      SUBROUTINE APLU(IRB,IEV)
C     SPECIAL PLUTO PROGRAM
C
C     FOR NEW RUN   IRB = RUN NR       = 0 OTHERWISE
C                   IEV = IW(IHD+4)
C
      COMMON/BCS/IW(1)
      INTEGER LRN/0/
      IRB=0
      IEV=0
      CALL BLOC(IHD,'HEAD',0,&100)
      IRN=IW(IHD+1)
      IEV=IW(IHD+4)
      IF(IRN.EQ.LRN) GOTO 100
      LRN=IRN
      IRB=IRN
  100 RETURN
      END

C   07/06/96 606071902  MEMBER NAME  PFUN     (S4)          FORTG1
      SUBROUTINE PFUN(M)
      COMMON/BCS/IW(1000)
      REAL RW(1000)
      EQUIVALENCE (RW(1),IW(1))
      REAL X(31),Y(31)
      YY=BFUN(M,0.0)
      CALL BLOC(IND,'+FUN',M,&100)
      XL=RW(IND+1)
      NW=IW(IND)
      XH=RW(IND+NW-4)
      CALL GPL(1)
      CALL GRX(XL,XH)
      DO 10 I=1,31
      X(I)=XL+FLOAT(I-1)*(XH-XL)/30.0
   10 Y(I)=BFUN(M,X(I))
      CALL GMY(Y,31)
      CALL GPT(Y,X,31,38)
      ND=NW/5
      INDH=IND
      DO 20 I=1,ND
      XX=RW(INDH+1)
      YY=RW(INDH+2)
      INDH=INDH+5
   20 CALL GPT(YY,XX,1,33)
      CALL GNE(M)
      CALL GTE('PLOT OF FUNCTION BY PFUN$')
      CALL GPR(1)
  100 RETURN
      END

C   18/05/84 405181805  MEMBER NAME  FWCAP    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FWCAP(ADX,ADY,LLL,FC,ITXT)
C-----------------------------------------------------------------------
C
C
C   AUTHOR:    J. OLSSON        ?    :  DRAW FORWARD DETECTOR FRONT VIEW
C
C   LAST MOD:  J. NYE       18/05/84 :  USE TAGMRK - WORKS FOR MC TOO
C
C
C     DRAW THE FORWARD DETECTOR FOR THE FW VIEW (CALLED BY DRAWFD)
C     FC IS A MAGNIFICATION FACTOR, SOMETIMES NEEDED FOR VISIBILITY.
C     ITXT NONZERO MEANS TEXT AND BEAM CROSS WILL BE ADDED TO PICTURE.
C     CALL TAGMRK TO FIND OUT VERSION NUMBER OF APPARATUS.
C
C     THE COMPLETE 1979-80 SETUP, WITH CHAMBERS AND SCINTILLATORS, CAN
C     BE FOUND IN THE MEMBER TAGDS0. IT IS NO LONGER BEING USED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C                            MACRO CGEO2 .... JADE TAGGING GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO2 / FENDC,XYHOL1,XYHOL2,BLDPFW,ZMINBL,ZPLUBL,
     +                 XSC(2),YSC(2),RSC(2),ZMISC(2),ZPLSC(2),DZSC,
     +                 CHX(3,4),CHY(3,4),CHZ(3,4),WLEN,PITCH,WZDIS
C
C--------------------------- END OF MACRO CGEO2 ------------------------
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
      DIMENSION XYHOL(2)
      EQUIVALENCE (XYHOL(1),XYHOL1)
C
C------------------  C O D E  ------------------------------------------
C
C                            TAGMRK PUTS VERSION NUMBER IN COMMON
C
      CALL TAGMRK(*1)
   1  IF( MARK .EQ. 0 ) GO TO 3
      IF( MARK .EQ. 1 ) GO TO 2
C
C                            1983 SET UP OF FORWARD COUNTERS
C
      CALL FWC83(ADX,ADY,LLL,FC,ITXT)
      RETURN
C
C                            1981-2 SET UP OF FORWARD COUNTERS
C
  2   CALL NEWCAP(ADX,ADY,LLL,ITXT)
      RETURN
C
C                            1979-80 SET UP OF FORWARD COUNTERS
C
  3   Y1   = - FENDC * 0.5
      X1   =   XYHOL1
      DO  17  I = 1,6
        Y1 = Y1 + FENDC
        Y2 = Y1
        IF( I .EQ. 1  .OR.  I .EQ. 3 ) X2 = X1 + 4.0 * FENDC
        IF( I .EQ. 2 ) X1 = FENDC
        IF( I .GT. 4 ) X2 = X2 - FENDC
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   17 CONTINUE
C
      X1 = - FENDC
      Y1 =   XYHOL2
      DO  18  I = 1,6
        X1 = X1 + FENDC
        X2 = X1
        IF( I .EQ. 1  .OR.  I .EQ. 3 ) Y2 = Y1 + 4.0 * FENDC
        IF( I .EQ. 2 ) Y1 = 1.5 * FENDC
        IF( I .GT. 4 ) Y2 = Y2 - FENDC
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   18 CONTINUE
C
      X1 = - FENDC
      X2 =   FENDC
      Y1 =   XYHOL2 - FENDC
      DO  19  I = 1,5
        Y1 = Y1 + FENDC
        Y2 = Y1
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   19 CONTINUE
C
      X1 =   XYHOL1 - FENDC
      Y1 = - 1.5 * FENDC
      Y2 = - Y1
      DO  20  I = 1,5
        X1 = X1 + FENDC
        X2 = X1
        CALL DRACAP(ADX+X1,ADY+Y1,ADX+X2,ADY+Y2,ADX-X1,ADY-Y1,ADX-X2,
     +              ADY-Y2,LLL)
   20 CONTINUE
C
      IF( ITXT .EQ. 0 ) RETURN
C
C                            WRITE TEXT
C                            WRITE +- Z   BELOW
C
      SH3 = 0.6 * FENDC
      Y1  = ADY - 7.0 * FENDC
      I   = 1
      IF( ADX .GT. 0.0 ) I = 2
      LABT = 101 + (I - 1) * 2
      X1   = ADX - 0.5 * FENDC
      CALL RUTEXT(LABT,X1,Y1,SH3)
C
C                            DRAW BEAM CROSS INSIDE CAP
C
      CALL MOVEA(ADX,ADY-20.)
      CALL DRAWA(ADX,ADY+20.)
      CALL MOVEA(ADX+20.,ADY)
      CALL DRAWA(ADX-30.,ADY)
      CALL DRAWA(ADX-30.,ADY+15.)
      CALL DRAWA(ADX-45.,ADY)
      CALL DRAWA(ADX-30.,ADY-15.)
      CALL DRAWA(ADX-30.,ADY)
C
      RETURN
C
C-----------------------------------------------------------------------
      ENTRY FWCAP1(ADX,ADY,INDX,K)
C-----------------------------------------------------------------------
C
C        DRAW FORWARD DETECTOR CAPS IN Z-X VIEW (K=1), Z-Y VIEW (K=2)
C        ADX,ADY IS POSITION OF CENTER OF FRONT FACE(CLOSEST WWP)
C        INDX IS 1 FOR -Z CAP, 2 FOR +Z CAP
C
      Y2  = 4.0 * FENDC + XYHOL(K)
      Y1  = ADY - Y2
      Y2  = ADY + Y2
      CALL DRAMOV(ADX,Y1,ADX,Y2,0)
      FCT = 1.0
      IF( INDX .EQ. 2 ) FCT = -1.0
      X2 = ADX + FCT * BLDPFW
      CALL DRAMOV(X2,Y1,X2,Y2,0)
      Y1 = -0.5 * FENDC
      IF( K .EQ. 1 ) Y1 = - FENDC
      DO  101  I = 1,6
        Y1 = Y1 + FENDC
        CALL DRAMOV(ADX,ADY+Y1,X2,ADY+Y1,0)
        CALL DRAMOV(ADX,ADY-Y1,X2,ADY-Y1,0)
101   CONTINUE
      Y1 = 4.0 * FENDC + XYHOL(K)
      CALL DRAMOV(ADX,ADY+Y1,X2,ADY+Y1,0)
      CALL DRAMOV(ADX,ADY-Y1,X2,ADY-Y1,0)
      RETURN
      END

C   29/04/87 803181325  MEMBER NAME  ZSFIT    (JADEGS)      FORTRAN
C   14/03/88 803141331  MEMBER NAME  ZSFIT    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE ZSFIT(MDE,DUM1Y,DUM2Y,DUM3Y,MDEH,nargs) ! PMF 03/12/99: 6th argument added
C-----------------------------------------------------------------------
C
C------- METHOD: P.DITTMANN ------ LAST CHANGE: 09.11.87  E.ELSEN  -C
C                                 CHANGE 19.1.84 KILL PRINT IN JADEZC
C                    Z - S   F I T                        J.O.      C
C        MAIN STEERING ROUTINE FOR Z-S PACKAGE.                     C
C        COLLECTION OF ALL HITS OF A CERTAIN TRACK,                 C
C        CALIBRATION OF AMPLITUDES AND CHANGE OF JETC BANK (ZRECAL),C
C        REMOVAL OF HITS IN TRACK OVERLAP REGIONS IN R/PHI AND      C
C        CALCULATION OF X-Y COORDINATES (ZSPUR,ZSXY), CALCULATION   C
C        OF Z-S COORDINATES AND WEIGHT, STRAIT LINE FIT (ZSLINE),   C
C        UPDATE PATR BANK AND JHTL BANK.                            C
C                                                                   C
C        MODE = 0   DOES EVERYTHING                                 C
C             = 1   CALIBRATION ONLY                                C
C             = 2   CALIBRATION AND FIT ONLY                        C
C             = 3   = MODE 0 WITHOUT UPDATING THE 'PATR' BANK       C
C             = 4   = MODE 2 WITHOUT UPDATING THE 'PATR' BANK       C
C             + 8   AS ABOVE + CREATION OF JHTQ BANK                C
C    MODIFIED 09/11/87   E ELSEN
C      ROUTINE NOW ALSO CALLABLE FOR MC
C    MODIFIED 11/06/87   E ELSEN
C      OVERFLOW HITS REJECTED IN AMPS2Z WITH CODE 32
C      ADDED CREATION OF BANK JHTQ, WHICH TRANSFERS THE HIT
C      QUALITY FLAG TO THE DEDX PROGRAMS.
C      ADDED ZSPDBK CALL IF FLAG IS SET
C    MODIFIED 29/04/87   E ELSEN
C      ALL CONSTANTS PUT INTO BLOCKDATA ATTACHED TO AMPS2Z
C      NEW CONSTANTS PROVIDED FOR FADC DATA
C      AMPS2Z CALLED
C    MODIFIED 09/11/87   E ELSEN
C      FIT NOW ALSO PERFORMED FOR MC
C    MODIFIED 14/03/88   E ELSEN
C      SINCE JETC HIT COUNTING NOT IN EFFECT FOR MC
C      RECODE LH EXPRESSION
C-------------------------------------------------------------------C
#include "cdata.for"
#include "cgraph.for"
      INTEGER*2 HDATA
C-----------
      COMMON/CALIBR/JPOINT(1)
      DIMENSION ACALIB(1)
      EQUIVALENCE (JPOINT(1),ACALIB(1))
C-----------
      COMMON /CZSCAL/ IPVERS,ZAL,RESFAC,SECH(5)
C----*----------------TCORR(4,96),XTALK(2,96),PAR(7,1536)-------------
      COMMON /CWORK/ NHIT,IZB(60),IJC(60),IJH(60),NW(60),LH(60),
     *                LRFL(60),ALU(60),ARU(60),X(60),Y(60),Z(60),S(60),
     *                G(60),DT(60),DL(60),DW(60),FCORR(60)
C                                           DEDX-FLAGS
      LOGICAL LWDEDX, MC
      INTEGER DEDXFL(60)
      INTEGER JHTQBT / 2 /, ONE / 1 /
      INTEGER IPRJQ / 0 /, IPRJQM / 10 /
C
#include "czsprm.for"
      DIMENSION IC(6)
      LOGICAL TBIT
      DATA MTRNO1/Z FE0000/, MTRNO2/Z FE/
      DATA ICALL/0/
C------------------- 11.9.85
      MODE=MDE
      MODEH=MDEH
C---------------------------
      MODEHH=MODE
      ICALL =ICALL+1
      IJETC = IDATA( IBLN('JETC') )
      IJETU = 0
      IF( IJETC.GT.0 ) IJETU = IDATA( IJETC - 1 )
      IJHTL = IDATA( IBLN('JHTL') )
      IPATR = IDATA( IBLN('PATR') )
      IX    = 2*IDATA( IBLN('HEAD') )
      IRUN = 0
      IF( IX.GT.0 ) IRUN=HDATA(IX+10)
C                                           MONTE CARLO
      MC = IRUN.LT.100
C
      IF(IJETC.EQ.0
     +   .OR. (IJETU.EQ.0 .AND. .NOT. MC )
     +   .OR. IJHTL.EQ.0 .OR. IPATR.EQ.0) GOTO 80
C
***PMF03/12/99      CALL NOARG( NARGS )
* NOARG does not work properly on the present platform.
* Introduce 6th argument NARGS for subroutine ZSFIT instead.
      IF (MODE.GT.10.AND.NARGS.GT.4 ) MODE=MODEH
      LWDEDX = LAND( MODE, 8 )
***PMF03/12/99      IF( LWDEDX ) MODE = MODE - 8
* On some plattforms, the logical .TRUE. is represented
* by the FIRST bit set to 1, and the status of the
* other bits is ignored!!! In this case, e.g. the byte
* 00000110 represents the logical value .FALSE. , in contrast
* to what here is expected. Thus handle LWDEDX as INTEGER
* and test if any of the bits is set.
      IF( LWDEDX.NE.0 ) MODE = MODE - 8
      IF (MODE.LT.0 .OR. MODE.GT.4) GOTO 86
      GOTO 60
C
   70 IFLAG=0
      IF (MODE.EQ.3) GOTO 83
      IF (MODE.EQ.4) GOTO 84
C
   85 CONTINUE
      IF( MC ) GO TO 91
        IPN = JPOINT(11)
        IPVERS=JPOINT(IPN+1)
        IF(ICALL.EQ.1 .AND. NDDINN .EQ. 0 ) PRINT 901, IPVERS,MODE
  901 FORMAT(/'  ***********     Z - RECALIBRATION  VERSION',I8,'     ',
     +'     MODE',I5/)
        ZAL = 1400.
        NRUN=HDATA(IX+10)
        GO TO 92
   91 CONTINUE
C                                           SET TO ZERO TO SIGNAL AMPS2Z
        ZAL = 0.
C                                           FIND EQUIV RUN NUMBER
        NRUN = IZT2RN(DUMMY)
   92 CONTINUE
C                                           PERIOD
      NZSPRD = 1
      IF( NRUN .GT.  6000 ) NZSPRD = 2
      IF( NRUN .GT. 24200 ) NZSPRD = 3
      RESFAC = AZSRSA(NZSPRD)
      DO 34 I=1,5
   34 SECH(I) = AZSSHT(I,NZSPRD)
C
      IJETC2 = IJETC*2
      IJETU2 = IJETU*2
      NT = IDATA(IPATR+2)
      IF( NT.LE.0 .OR. NT.GT.60 ) GOTO 88
      IF( .NOT. LWDEDX ) GO TO 43
C                                           HITS/WORD
        NHPW = 32/JHTQBT
        LJHTQ = (IDATA(IJHTL)-1+NHPW-1)/NHPW + 1
        CALL BCRE( NPJHTQ, 'JHTQ', IDATA(IJHTL-2),
     *                             LJHTQ, &41, IERJHT )
        CALL BSAW( 1, 'JHTQ' )
        IDATA(NPJHTQ+1) = JHTQBT
C                                           CREATION OF BANK MAY HAVE
C                                           MOVED POINTERS
        IJETC = IDATA( IBLN('JETC') )
        IJETU = 0
        IF( IJETC.GT.0 ) IJETU = IDATA( IJETC - 1 )
        IJHTL = IDATA( IBLN('JHTL') )
        IPATR = IDATA( IBLN('PATR') )
        GO TO 43
   41 CONTINUE
        LWDEDX = .FALSE.
        IF( IPRJQ .GT. IPRJQM ) GO TO 43
          IPRJQ = IPRJQ + 1
          WRITE(6,9101) IERJHT
 9101     FORMAT ('  ***** ERROR IN ZSFIT: NOT ENOUGH SPACE FOR JHTQ',
     *            ' IER=',I5)
   43 CONTINUE
C                                           LOOP OVER ALL TRACKS
      L0 = IDATA(IPATR+1)
      LT = IDATA(IPATR+3)
      KT = IPATR + L0
      DO 59 I=1,NT
        NHIT = 0
        NHF = 0
        IF(ADATA(KT+25).EQ.0.) GOTO 59
        R = -1. / ADATA(KT+25)
        SR = SIGN(1.,R)
        PT = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
        CPHI = ADATA(KT+8) / PT
        SPHI = ADATA(KT+9) / PT
        X0 = ADATA(KT+5)
        Y0 = ADATA(KT+6)
        R0 = SQRT(X0**2+Y0**2)
        XE = ADATA(KT+12)
        YE = ADATA(KT+13)
        SE = R * ATAN2(SR*(CPHI*(XE-X0)+SPHI*(YE-Y0)),
     *                 SR*(SPHI*(XE-X0)-CPHI*(YE-Y0)+R))
        IF(ABS(R).GT.1.E5) SE=SQRT((XE-X0)**2+(YE-Y0)**2)
C                                           COLLECT ALL HITS OF TRACK I
C
C                                           ORDER CELLS
        NC = 0
        DO 12 J=1,6
          KC = IDATA(KT+40-J)
          IF(KC.LE.0 .OR. KC.GT.96) GOTO 12
          IF(NC.EQ.0) GOTO 11
          IF(KC.GT.IC(NC)) GOTO 11
          DO 10 K=1,NC
          IF(KC.GT.IC(K)) GOTO 10
          IF(KC.EQ.IC(K)) GOTO 12
          JC = IC(K)
          IC(K) = KC
          KC = JC
   10     CONTINUE
   11     NC = NC + 1
          IC(NC) = KC
   12   CONTINUE
C                                           LOOP OVER CELLS
        IM2 = I*2
        IM1 = IM2*65536
        DO 19 J=1,NC
          NCP = IJETC2 + IC(J) + 2
          NHCELL = (HDATA(NCP+1)-HDATA(NCP))/4
          KHCELL = (HDATA(NCP)-1)/4
C                                           LOOP OVER HITS
          DO 18 K=1,NHCELL
            KA = IJHTL + KHCELL + K + 1
            IF(IDATA(KA).EQ.0) GOTO 18
              LRFLAG = -1
              IMH=LAND(IDATA(KA),MTRNO1)
              IF(IMH.NE.IM1) GOTO 13
                IF(TBIT(IDATA(KA), 5)) GOTO 18
                IF(TBIT(IDATA(KA), 7)) LRFLAG=1
                KABIT = 15
                GOTO 15
   13       IMH=LAND(IDATA(KA),MTRNO2)
            IF(IMH.NE.IM2) GOTO 18
            IF(TBIT(IDATA(KA),21)) GOTO 18
            IF(TBIT(IDATA(KA),23)) LRFLAG=1
            KABIT = 31
C              HIT FOUND IN CELL IC(J), TRACK I
   15       IF(NHIT.EQ.60) GOTO 19
            NHIT = NHIT + 1
            NH1 = IJETC2 + (KHCELL+K-1)*4 + 101
            IJC(NHIT) = NH1
            IJH(NHIT) = KA
            IF(KABIT.EQ.15) IJH(NHIT)=-IJH(NHIT)
            LRFL(NHIT) = LRFLAG
            MHIT = HDATA(NH1)
            NW(NHIT) = MHIT / 8
C                                           FOLLOWING MOD TO HAVE
C                                           HIT COUNTING WORK FOR
C                                           MC AS WELL.
CCCCCC      LH(NHIT) = LAND(MHIT,7) + 1
            LH(NHIT) = 1
            II = NH1 + 4
   16       IF( II.GE.IJETC2+100+HDATA(IJETC2+99) .OR.
     *          NW(NHIT).NE.HDATA(II)/8 ) GO TO 17
              LH(NHIT) = LH(NHIT) + 1
              II = II + 4
              GO TO 16
   17       CONTINUE
C                                           END MOD
            IZB(NHIT) = LH(NHIT)
            NHF=NHF+1
   18     CONTINUE
   19   CONTINUE
C                                             CALIBRATE AMPLITUDES
C                                             AND UPDATE JETC BANK
        IF( .NOT. MC ) CALL ZRECAL(IJETU,IJETC)
        IF( MODE.EQ.1 .AND. .NOT. LWDEDX ) GOTO 59
C                                             X-Y COORDINATES AND
C                                             HIT CLEANING
        CALL ZSPUR(I,IPATR,MODE)
C
C                                            LOOP OVER ALL HITS OF TRACK
        NHF = 0
        DO 29 J=1,NHIT
          DEDXFL(J) = 0
          IF(IZB(J).EQ.0) GOTO 29
          NH1 = IJC(J)
C                                             CHECK AMPLITUDES
C                                             CALCULATE Z
          CALL AMPS2Z( NH1, IJETC, Z(J), G(J), IZGOOD )
C                                             PREVIOUS AMPLITUDE
          IF(LH(J).LT.2) GOTO 24
            IF(HDATA(NH1+5).LT.8 .OR. HDATA(NH1+6).LT.8) IZGOOD = 16
C                                             POINT IN Z-S
   24     CONTINUE
          IF( IZGOOD .NE.0 ) GO TO 26
            THETA = ATAN2(SR*(CPHI*(X(J)-X0)+SPHI*(Y(J)-Y0)),
     *                    SR*(SPHI*(X(J)-X0)-CPHI*(Y(J)-Y0)+R))
            S(J) = R * THETA
            IF(ABS(R).GT.1.E5) S(J)=SQRT((X(J)-X0)**2+(Y(J)-Y0)**2)
            NHF = NHF + 1
            GOTO 27
   26   IZB(J) = 0
        IF( IZGOOD .EQ. 32 ) DEDXFL(J) = 32
   27   CONTINUE
   29   CONTINUE
C                                             STRAIGHT LINE FIT
        CALL ZSLINE(NHZ,Z0,TANL,SIGZ,ZMIN,ZMAX)
C
        IF (NHZ.LT.3) GOTO 59
        IF (MODE.EQ.1) GOTO 55
C
          IF (IFLAG.EQ.1) GOTO 51
C                                             UPDATE PATR BANK
            IDATA(KT+44) = 3
            ADATA(KT+ 7) = Z0
            COSL = 1./SQRT(1.+TANL**2)
            ADATA(KT+ 8) = CPHI*COSL
            ADATA(KT+ 9) = SPHI*COSL
            ADATA(KT+10) = TANL*COSL
            ADATA(KT+14) = Z0 + SE*TANL
            PTL = SQRT(1.-ADATA(KT+17)**2)
            ADATA(KT+15) = ADATA(KT+15)*COSL/PTL
            ADATA(KT+16) = ADATA(KT+16)*COSL/PTL
            ADATA(KT+17) = ADATA(KT+10)
            ADATA(KT+30) = TANL
            ADATA(KT+31) = Z0 - R0*TANL
            ADATA(KT+32) = SIGZ
            IDATA(KT+33) = NHZ
            ADATA(KT+45) = ZMIN
            ADATA(KT+46) = ZMAX
   51     CONTINUE
C                                             UPDATE JHTL BANK
          DO 52 J=1,NHIT
            KA = IABS(IJH(J))
            KABIT = 31
            IF(IJH(J).LT.0) KABIT=15
            IZBIT = 0
            IF(IZB(J).NE.0) IZBIT=1
            CALL MVB(IDATA(KA),KABIT,IZBIT,31,1)
   52     CONTINUE
C
   55     CONTINUE
          IF( .NOT. LWDEDX ) GO TO 58
            DO 57 J=1,NHIT
              KA = IJH(J)
              NSHIFT = 0
              IF( KA.GT.0 ) GO TO 56
                KA = -KA
                NSHIFT = 1
   56         KA = KA - IJHTL - 1
              IF( DEDXFL(J) .NE. 32 ) DEDXFL(J) = IZB(J)
              IF(DEDXFL(J).EQ.0) GO TO 57
                NRW = (KA-1)/NHPW + 1
                NQW = NPJHTQ + 1 + NRW
                NSHIFT = MOD(KA-1,NHPW)*JHTQBT + NSHIFT
                IDATA(NQW) = LOR(IDATA(NQW),ISHFTL(ONE,NSHIFT))
   57       CONTINUE
C
   58     CONTINUE
C
C                                            FILL ZSPD BANK FOR GRAPHICS
          IF( LZSPDF ) CALL ZSPDBK( I )
C
   59 KT = KT + LT
C
      HDATA(IJETC2+2)=IPVERS
      RETURN
C
   60 CONTINUE
      DO 61 II=1,60
        IZB(II)=0
        IJC(II)=0
        IJH(II)=0
        NW(II)=0
        LH(II)=0
        LRFL(II)=0
        ALU(II)=0.
        ARU(II)=0.
        X(II)=0.
        Y(II)=0.
        Z(II)=0.
        S(II)=0.
        G(II)=0.
        DT(II)=0.
        DL(II)=0.
        DW(II)=0.
        FCORR(II)=0.
   61 CONTINUE
      GOTO 70
C
   83 MODE=0
      IFLAG=1
      GOTO 85
C
   84 MODE=2
      IFLAG=1
      GOTO 85
C
   80 PRINT 81
   81 FORMAT ('  ***** ERROR IN ZSFIT: BANK POINTER = 0')
      RETURN
C
   86 PRINT 87
   87 FORMAT ('  ***** ERROR IN ZSFIT: MODE NOT ALLOWED')
      RETURN
C
   88 PRINT 89
   89 FORMAT ('  ***** ERROR IN ZSFIT: # OF TRACKS < 0 OR > 60')
      RETURN
      END

C   11/03/79 006140243  MEMBER NAME  PRLGCL   (JADELGS)     FORTRAN
      SUBROUTINE PRLGCL
C
C     S.YAMADA    19-01-79   10:15
C     LAST MODIFICATION  11-09-79  22:00  Y.WATANABE
C
C---- PRINT THE BANK LGCL.
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(2)
      DIMENSION  ADATA(2), HDATA(2)
      EQUIVALENCE  (ADATA(1),IDATA(1)), (HDATA(1),IDATA(1))
C
C---- CONTENTS OF THE BUFFER FOR EACH CLUSTER
C
C     IDATA(NPCLS+1)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     ADATA(NPCLS+2)=CLUSTER ENERGY IN GEV
C     ADATA(NCLST+3)=SIGMA(ENERGY)
C     ADATA(NPCLS+4)=WEIGHTED AVERAGE PHI
C     ADATA(NPCLS+5)=WEIGHTED AVERAGE Z
C     ADATA(NPCLS+6)=SIGMA PHI (WEIGHTED)
C     ADATA(NPCLS+7)=SIGMA Z (WEIGHTED)
C     IDATA(NPCLS+8)=NUMBER OF CORRESPONDING INNER TRACKS
C     ADATA(NPCLS+9-11)=DIRECTION COSIGNS CORRECTED FOR SHOWER DEPTH.
C     ADATA(NPCLS+12-14)=CLUSTER STRUCTURE,ELLIPS EIGENVALUES.
C
C---- FIX POINTERS FOR CLUSTER DATA
      DATA INITP/0/
      IF(INITP.GT.0) GO TO 5
      INITP=1
      IPCL= IBLN('LGCL')
5     CONTINUE
C     CALL BLOC( NPCL,'LGCL',1, &90)
      NPCL=IDATA(IPCL)
      IF(NPCL.LE.0) GO TO 90
      NPCGI = NPCL+IDATA(NPCL+1)-1
      NPCMP = NPCL+IDATA(NPCL+2)-1
      NNPCMP = 2*NPCMP
      NPCLS = NPCL+IDATA(NPCL+3)-1
C---- GET NO.OF WORDS FOR EACH CLUSTER.
      LSTEP = IDATA(NPCGI+21)
C
C---- GET NO.OF CLUSTERS
      NCLST = IDATA(NPCGI+3)
C
C---- WRITE THE GENERAL INF.
      K1 = NPCGI+1
      K6 = NPCGI+6
      K7 = NPCGI+7
      K10 = NPCGI+10
      K11 = NPCGI+11
      K12 = NPCGI+12
      K15 = NPCGI+15
      K16 = NPCGI+16
      K20 = NPCGI+20
      K21 = NPCGI+21
      WRITE(6,600) NPCL, (IDATA(K),K=K1,K6),(ADATA(K),K=K7,K10),
     $           IDATA(K11),  (ADATA(K),K=K12,K15),(IDATA(K),K=K16,K21)
  600 FORMAT('0===== LG-CLUSTERS =====  (NPCL=',I5,')    PROG.VERSION=',
     1        I2,'  DATE&TIME=',I9,'  ====================',
     2        /' NCLST=',4I5,'  ENERGY=',4F8.3,'    NG=',I3,'  E-GAM=',
     3        4F8.3,/'   FLAGS=',5I8,'  WORDS/CLUST=',I4)
C
C
C---- ADC-MAP FOR EACH CLUSTER
      K1 = NNPCMP+1
      KE = K1+2*NCLST
      WRITE(6,601) (HDATA(K),K=K1,KE)
  601 FORMAT(' LG-ADC MAP AFTER CLUSTER ANALYSIS',
     $               /' ',(10(I4,'-',I4,',  ')))
C
C
C---- CLUSTER INFORMATION
      KB = NPCLS
      IF(NCLST.LE.0) RETURN
      THE = 0.
      PHI = 0.
C
C---- TITLE
      WRITE(6,603)
  603 FORMAT('  I N J',/'  N B B ENERGY   +/-   PHI/X',5X,'Z/Y',
     1 ' +-PHI/X',3X,'+-Z/Y TRK   THE   PHI   COSX   COSY   COSZ',
     2 5X,'ELLIPS EIGENVALUES',3X,'EDGE',3X,'EUNC',/,'  D L C')
        DO 10 N=1,NCLST
C       NO.OF COUNTERS
        NCNT = HDATA(NNPCMP+2*N)-HDATA(NNPCMP+2*N-1)+1
        K1 = KB+1
        K2 = KB+2
        K7 = KB+7
        K8 = KB+8
        K9 = KB+9
        K14 = KB+14
        K16 = KB+16
C
        IF(IDATA(NPCGI+17).LT.2) GO TO 1
        THE = ARCOS(ADATA(KB+11))*57.2958
        PHI = ATAN2( ADATA(KB+10),ADATA(KB+9))*57.2958
C
    1   WRITE(6,602) N,NCNT,IDATA(K1),(ADATA(K),K=K2,K7),IDATA(K8),
     &               THE,PHI, (ADATA(K),K=K9,K16)
  602   FORMAT(' ',3I2,F7.3,F6.3,4F8.2,I4,2F6.1,3F7.4,3(1PE8.1),
     1    2(0PF7.3))
        KB = KB+LSTEP
   10   CONTINUE
      RETURN
C
   90 WRITE(6,690)
  690 FORMAT('0 ***** ''LGCL'' IS NOT FOUND ****',/)
      RETURN
      END

C   07/06/96 606071849  MEMBER NAME  IBCOMR   (S4)          FORTRAN77
IBCR     TITLE 'SUBROUTINE TO READ OR WRITE A RECORD, PART AT A TIME, U+
               NDER FORTRAN CONTROL'
IBCOMR   CSECT
*
*    MAIN  ENTRY  POINT  FOR  STARTING  TO  READ  A  RECORD .
*    CALLING SEQUENCE  IS :
*
*              CALL  IBCOMR (STREAM NO.,&END,&ERR)
*
*    AUTHOR:- J.C.HART, RUTHERFORD LABORATORY
*
         ENTRY IBCOMW,IBWORD,IB2WD,IBARR,IBARR1,IBCOMF
         B     12(,15)             BRANCH ROUND NAME
         DC    X'7'
         DC    CL7'IBCOMR'
         STM   14,5,12(13)         SAVE REGISTERS
         USING IBCOMR,15
         LA    2,READ
         B     PROLOGUE
*
*    IBCOMW  IS  ENTRY  POINT  FOR  STARTING  TO  WRITE  A  RECORD .
*    CALLING  SEQUENCE  IS :
*
*              CALL  IBCOMW (STREAM NO.,&END,&ERROR)
*
IBCOMW   B     12(,15)             BRANCH ROUND NAME
         DC    X'7'
         DC    CL7'IBCOMW'
         STM   14,5,12(13)         SAVE REGISTERS
         USING IBCOMW,15
         LA    2,WRITE
         B     PROLOGUE
*
*    IBWORD  IS  ENTRY  POINT  FOR  READING  ONE  4-BYTE  WORD .
*    CALLING  SEQUENCE  IS :
*
*              CALL  IBWORD (WORD)
*
IBWORD   B     12(,15)             BRANCH ROUND NAME
         DC    X'7'
         DC    CL7'IBWORD'
         STM   14,5,12(13)         SAVE REGISTERS
         USING IBWORD,15
         LA    2,WORD
         B     PROLOGUE
*
*    IB2WD  IS  ENTRY  POINT  FOR  READING  TWO  4-BYTE  WORDS .
*    CALLING  SEQUENCE  IS :
*
*              CALL  IB2WD (WORD1,WORD2)
*
IB2WD    B     10(,15)             BRANCH ROUND NAME
         DC    X'5'
         DC    CL5'IB2WD'
         STM   14,5,12(13)         SAVE REGISTERS
         USING IB2WD,15
         LA    2,TWOWD
         B     PROLOGUE
*
*    IBARR  IS  ENTRY  POINT  FOR  READING  AN  ARRAY  OF  4-BYTE
*    WORDS .  CALLING  SEQUENCE  IS :
*
*              CALL  IBARR (ARRAY, NO. OF WORDS)
*
IBARR    B     10(,15)             BRANCH ROUND NAME
         DC    X'5'
         DC    CL5'IBARR'
         STM   14,5,12(13)         SAVE REGISTERS
         USING IBARR,15
         LA    2,ARRAY
         B     PROLOGUE
*
*     IBARR1 IS ENTRY POINT FOR READING AN ARRAY OF 1-BYTE WORDS.
*     CALLING SEQUENCE IS :
*
*               CALL IBARR1 (ARRAY,NO.OF BYTES)
*
IBARR1   B     12(,15)             BRANCH ROUND NAME
         DC    X'7',CL7'IBARR1'
         STM   14,5,12(13)         SAVE REGISTERS
         USING IBARR1,15
         LA    2,ARRAY1
         B     PROLOGUE
*
*    IBCOMF  IS  ENTRY  POINT  FOR  FINAL  CALL  TO  IBCOM .
*    CALLING SEQUENCE  IS :
*
*              CALL  IBCOMF
*
IBCOMF   B     12(,15)             BRANCH ROUND NAME
         DC    X'7'
         DC    CL7'IBCOMF'
         STM   14,5,12(13)         SAVE REGISTERS
         USING IBCOMF,15
         LA    2,FINAL
         B     PROLOGUE
*
*    PROLOGUE .
*
PROLOGUE BALR  5,0                 ESTABLISH BASE REGISTER
         USING *,5
         DROP  15
         LR    3,13                KEEP OLD SAVE AREA ADDRESS
         LA    13,SAVEAREA         LOAD NEW SAVE AREA ADDRESS
         ST    13,8(,3)            & STORE IT IN OLD SAVE AREA
         ST    3,4(,13)            STORE OLD SAVE AREA ADDRESS
         BR    2                   BRANCH TO APPROPRIATE SECTION
SAVEAREA DS    18F                 RESERVE SPACE FOR SAVE AREA
*
*   INITIALISE  IBCOM  FOR  UNFORMATTED  READ .
*
READ     L     3,0(,1)             FETCH ARGUMENT ADDRESS
         L     4,0(,3)             FETCH UNIT NO.
         ST    4,UNIT
         CNOP  0,4
         L     15,=V(IBCOM#)
         BAL   14,20(15)           BRANCH TO IBCOM
         DC    XL1'31',AL3(UNIT)
         DC    AL4(ADEND)
         DC    AL4(ADERR)
         B     RETURN
*
*   INITIALISE  IBCOM  FOR  UNFORMATTED  WRITE .
*
WRITE    L     3,0(,1)             FETCH ARGUMENT ADDRESS
         L     4,0(,3)             FETCH UNIT NO.
         ST    4,UNIT
         CNOP  0,4
         L     15,=V(IBCOM#)
         BAL   14,24(15)           BRANCH TO IBCOM
         DC    XL1'31',AL3(UNIT)
         DC    AL4(ADEND)
         DC    AL4(ADERR)
         B     RETURN
*
*    END  &  ERROR  EXITS .
*
END      LA    15,4                FOR RETURN 1
         B     RETURNI
ERR      LA    15,8                FOR RETURN 2
         B     RETURNI
*
*    READ  ONE  4-BYTE  WORD .
*
WORD     L     3,0(,1)             FETCH ARGUMENT ADDRESS
         CNOP  0,4
         L     15,=V(IBCOM#)
         BAL   14,28(15)           BRANCH TO IBCOM
         DC    XL4'04503000'
         B     RETURN
*
*    READ  TWO  4-BYTE  WORDS .
*
TWOWD    LM    3,4,0(1)            FETCH ARGUMENT ADDRESSES
         CNOP  0,4
         L     15,=V(IBCOM#)
         BAL   14,28(15)           BRANCH TO READ FIRST WORD
         DC    XL4'04503000'
         L     15,=V(IBCOM#)
         BAL   14,28(15)           BRANCH TO READ SECOND WORD
         DC    XL4'04504000'
         B     RETURN
*
*    READ  ARRAY  OF  4-BYTE  WORDS .
*
ARRAY    LM    3,4,0(1)            FETCH ARGUMENT ADDRESSES
         ST    3,ADDR              STORE ARRAY ADDRESS
         L     2,0(,4)             LOAD ARRAY LENGTH
         ST    2,LENGTH            & STORE IT
         MVI   LENGTH,X'04'        INSERT WORD LENGTH
         OI    LENGTH+1,X'70'      COPY H-COMPILER
         CNOP  0,4
         L     15,=V(IBCOM#)
         BAL   14,32(15)           BRANCH TO IBCOM
ADDR     DS    1F                  ADDRESS OF ARRAY
LENGTH   DS    1F                  LENGTH OF ARRAY
         B     RETURN
*
*     READ ARRAY OF 1-BYTE WORDS.
*
ARRAY1   LM    3,4,0(1)            FETCH ARGUMENT ADDRESSES
         ST    3,ADDR1             STORE ARRAY ADDRESS
         L     2,0(,4)             LOAD ARRAY LENGTH
         ST    2,LENGTH1           & STORE IT
         MVI   LENGTH1,X'01'       INSERT WORD LENGTH
         CNOP  0,4
         L     15,=V(IBCOM#)
         BAL   14,32(15)           BRANCH TO IBCOM
ADDR1    DS    1F                  ADDRESS OF ARRAY
LENGTH1  DS    1F                  LENGTH OF ARRAY
         B     RETURN
*
*    FINAL  CALL  TO  IBCOM  ( AT  END  OF  READ  OR  WRITE ) .
*
         CNOP  0,4
FINAL    L     15,=V(IBCOM#)
         BAL   14,36(15)           BRANCH TO IBCOM
*
*    RETURN  TO  CALLING  PROGRAM .
*
RETURN   SR    15,15               CLEAR REGISTER 15 FOR NORMAL RETURN
RETURNI  L     13,SAVEAREA+4       LOAD OLD SAVE ADDRESS AGAIN
         LM    2,5,28(13)          RESTORE REGISTERS
         L     14,12(,13)          LOAD RETURN ADDRESS
         MVI   12(13),X'FF'        FLAG RETURN
         BR    14                  & JUMP BACK
*
*    CONSTANTS .
*
ADEND    DC    AL4(END)
ADERR    DC    AL4(ERR)
UNIT     DS    1F
         END

C   23/02/84 403091202  MEMBER NAME  MUCOOR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUCOOR(HMU,NHITS,HC,NHITMX,LMU,HLUN,NWHIT)
C-----------------------------------------------------------------------
C
C
C     MUCOOR CONVERTS THE RAW DATA INTO CARTESIAN COORDINATES
C
C=======================================================================
C DON'T FORGET TO CHANGE MUANAC TO STORE DATE OF THIS VERSION IN BANK 0.
C ALSO CHANGE THE DATE IN THE BANNER PRINTOUT IN THIS ROUTINE.
C=======================================================================
C
C LAST CHANGE 11.40   9/03/84   C. BOWDERY  - TIDYING UP
C      CHANGE 16.00  23/02/84   C. BOWDERY  - NEW DOUBLE PULSE CUT FUNC.
C      CHANGE 15.00   1/02/84   T. GREENSHAW- NMU DESCRIPTION-->@MUSTAT
C      CHANGE 12.00   5/01/84   C. BOWDERY  - MARK MULTI-PULSED HITS
C      CHANGE 12.00  25/10/83   H. MCCANN   - BUGS REMOVED.
C      CHANGE 15.45  30/03/83   H. MCCANN   - FOR MONTE-CARLO.
C      CHANGE 10.30  16/03/83   H. MCCANN   - NEW CALIBRATION/METHOD.
C                               'OLD' CODE IS MARKED 'COBSOLETE' AND NEW
C                               CODE IS EXTENSIVELY COMMENTED.
C      CHANGE 12.30  31/03/82   H. MCCANN  - MODIFY BAD CHAMBER BODGE.
C      CHANGE 13.30  22/02/82   H. MCCANN  - FOR IMPROVED ERROR OUTPUT
C      CHANGE 14.30  04/02/82   H. MCCANN  - BODGE FOR BAD CHAMBERS
C      CHANGE 12.30  19/10/81   H. MCCANN  - CORRECT CRATE6 BAD GAS BUG
C      CHANGE 14.58  04/09/81   C. BOWDERY - CORRECT HANG BUG
C      CHANGE 07.30  10/04/81   H. MCCANN  - JADEMUS UPDATE.
C      CHANGE 10.19  26/03/81   J. ALLISON - TO ADD ABOVE COMMENT
C                                           ABOUT MUANAC, DATE * BANK 0.
C      CHANGE 14.45  24/03/81   H. MCCANN  - ALLOW FOR CRATE 6 DURING
C                                              THE BAD GAS PERIOD.
C      CHANGE 15.00  19/02/81   H. MCCANN  - MORE TIDYING * DEBUGGING
C MAJOR TIDYING UP   10/09/80   I. DUERDOTH
C
C
C-----------------------------------------------------------------------
C          ----------------
C          WHAT MUCOOR DOES
C          ----------------
C
C     CONVERTS MU-CHAMBER SIGNALS TO COORDINATES  USING  FULL  SET  OF
C     CALIBRATION DATA. IF THE COORDINATE IS BAD THEN IT IS SET TO THE
C     CENTRE OF THE CHAMBER,AND HLUN IS UPDATED APPROPRIATELY
C
C     IEV IS THE EVENT NO.
C     NEV IS NO. OF EVENTS PROCESSED SO FAR
C     KRUN IS THE RUN NO.
C     HSECT GIVES THE CRATE FOR EACH CHAMBER
C
C
C     30/03/83 : MONTE-CARLO DATA IS NOW CONSIDERED
C     TO BE DIFFERENT FROM REAL DATA IN THAT THE M-C HITS
C     ARE CREATED WITHOUT NON-LINEAR , ANGULAR * SHIFT EFFECTS.
C
C     OTHERWISE THIS VERSION OF MUCOOR TREATS ALL
C     INPUT MUEV BANKS IDENTICALLY, REGARDLESS OF WHETHER
C     THE INPUT IS MONTE-CARLO , UNDER THE ASSUMPTION THAT
C     M.C. MUEV BANKS ARE IDENTICAL TO REAL DATA.
C
C-----------------------------------------------------------------------
C
C                       INPUT VARIABLES
C
C HMU         THE RAW MU DATA.
C NHITMX      THE MAXIMUM NO OF HITS THAT CAN BE STORED IN OUTPUT
C               ARRAY HC.  THE DIMENSION OF HC IN THE CALLING ROUTINE
C               MUST BE AT LEAST NWHIT*NHITMX.
C LMU         THE LENGTH OF THE RAW DATA BANK.
C NWHIT       THE NUMBER OF WORDS PER HIT IN THE OUTPUT ARRAY HC
C
C-----------------------------------------------------------------------
C                       OUTPUT VARIABLES
C
C NHITS       THE NUMBER OF HITS,  OUTPUT TO THE ARRAY HC.
C HC          THE OUTPUT ARRAY, EACH HIT IS NWHIT WORDS.
C               WORD  1     -  4*CHAMBER NUMBER + (HIT NUMBER -1).
C               WORD  2     -  10*LAYER NUMBER + ORIENTATION PARAMATER.
C               WORDS 3-8   -  X,Y,Z(LEFT),X,Y,Z(RIGHT) (MM).
C
C                              AS OF 16/03/83, THE FOLLOWING APPLIES TO
C                              THE DRIFT COORDINATE ( X OR Y, DEPENDING
C                              ON CHAMBER ORIENTATION) :
C                              (A) 'SOFTWARE SHIFTS' OF WIRE POSITION
C                                  ARE IMPLEMENTED ;
C                              (B) CHAMBER TWIST CORRECTIONS ARE NOT
C                                  IMPLEMENTED, BUT ARE NOW DONE USING
C                                  TRACK "Z" 'S IN MUFFLY.
C
C               WORD  9     -  POINTER TO RAW DATA
C
C HLUN          STATUS BITS FOR EACH HIT IN HC
C
C     .------------.-------------------------------------------------.
C     | BIT NUMBER | 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0 |
C     |------------+------------------------+------------------------|
C     | MNEMONIC   |  0  0  0  0  0  0  M  A  B  C  D  X  Y  Z  T  L |
C     '------------'-------------------------------------------------'
C
C ---->   THIS BIT NUMBERING RUNS OPPOSITE TO IBM CONVENTION
C         I.E. MACHINE SEES 'T' FLAG IN BIT NO. 14.
C         THE USAGE OF THE BITS IS AS FOLLOWS:
C
C      BIT) (TRUTH VALUE)
C HLUN  0  = 0(1)   IF LONGITUDINAL COORDINATE IS INVALID(VALID)
C
C HLUN  1  = 0(1)   IF TRANSVERSE   COORDINATE IS INVALID(VALID)
C                   I.E. MOD(HLUN,4)= 0 ---> BOTH  COORDS. BAD
C                        = 1 ---> LONG. COORD OK ( TRANS. COORD. BAD)
C                        = 2 ---> TRANS COORD OK ( LONG.  COORD. BAD)
C                        = 3 ---> ALL OK
C
C HLUN  2  = 0(1)   IF Z  COORDINATE IS INVALID(VALID)
C
C HLUN  3  = 0(1)   IF Y  COORDINATE IS INVALID(VALID)
C
C HLUN  4  = 0(1)   IF X  COORDINATE IS INVALID(VALID)
C
C HLUN  5  = 0(1)   IF Z  COORDINATE IS NORMAL(DRIFT OR LONG)
C
C HLUN  6  = 0(1)   IF Y  COORDINATE IS NORMAL(DRIFT OR LONG)
C
C HLUN  7  = 0(1)   IF X  COORDINATE IS NORMAL(DRIFT OR LONG)
C
C HLUN  8  = 0(1)   IF HIT1 LOST BY HIT4 * RECOVERED FROM HIT2(ALL OK)
C
C HLUN  9  = 0(1)   IF HIT DID NOT MULTI-PULSE (IF HIT DID MULTI-PULSE)
C
C NOTE:  THE 1'ST SET BIT(OF 5,6,7) IS ALWAYS THAT FOR  LONG. COORD.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FIRST / .TRUE. /, ENOUGH
      LOGICAL PFG   / .TRUE. /
      LOGICAL TIMREF,  GOOD
      LOGICAL ADJCHM, SAMCHM, HIT12
C
C                            COMMONS
C
#include "cmucalib.for"
#include "cmustat.for"
#include "cmubcs.for"
C
      COMMON / CMUIEV / IEV,NEV,IRD,KRUN,KREC,
     +                  ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON / CMUPRN / IPRIN,MUHPR
C     COMMON / CMUDAT / HMUX(634),HMUY(634),HMUZ(634),
C    +                  HLEN(634),HLST(634)
C
      DIMENSION HMU(1),HC(1),HLUN(1)
      DIMENSION IDRIFT(4)
C
C                            LOOK-UP TABLE FOR NON-LINEAR PARTS OF
C                            DRIFT-TIME SPECTRUM
C
      REAL XDT(150)/
     +
     +     0.6,0.6,0.6,0.6,1.5,3.2,5.0,6.35,7.6,8.85,54*0.,
     +     63.75,64.5,65.25,66.0,66.75,67.5,
     +     68.25,69.0,69.5,69.75,70.0,70.5,70.75,71.0,71.0,71.25,
     +     71.25,71.5,71.75,71.75,71.75,72.0,72.25,72.25,72.5,72.5,
     +     72.5,72.75,72.75,73.0,73.0,73.0,73.25,73.25,73.25,73.25,
     +     7*73.5,10*73.75,33*74.0     /
C
      DATA KMESS / 0 /
      DATA HB2 /4/, HB3 /8/, HB4 /16/, HB5 /32/, HB6 /64/, HB7 /128/
C
C                            IMTDLO AND IMTDHI  ARE  RESPECTIVELY  THE
C                            SMALLEST AND LARGEST ACCEPTABLE VALUES OF
C                            THE DRIFT COORDINATE IN MM.
C                  ------>   NEW UNDERSTANDING OF DRIFT  TIME-DISTANCE
C                            RELATIONSHIP MEANS THAT THESE ARE
C                            EFFECTIVELY OBSOLETE. 16/03/83.
C
      DATA IMTDLO / -5 /, IMTDHI / 160 /
C
C                            MAXMES IS THE  MAXIMUM  NUMBER  OF  ERROR
C                            MESSAGES TO BE  PRINTED/JOB  THE  NO.  OF
C                            ERROR MESSAGES IN THE JOB IS  COUNTED  BY
C                            NMESS.
C
      DATA MAXMES / 100 /
C
C                            MAXMUM IS THE MAXIMUM NUMBER  OF  SINGLES
C                            MESSAGES TO BE PRINTED/JOB
C
      DATA MAXMUM / 100 /
C
C                            ICONST IS THE  CONSTANT  SUBTRACTED  FROM
C                            THE DRIFT TIME OF HIT2  TO  ESTIMATE  THE
C                            DRIFT TIME OF HIT1 IN THE EVENT THAT  THE
C                            DRIFT INFORMATION OF HIT1 HAS BEEN LOST
C
      DATA ICONST / 7 /
C
C                            MAXREC IS THE MAXIMUM NUMBER OF  ATTEMPTS
C                            AT DATA RECOVERY
C
      DATA MAXREC / 10 /
C
C                            IZEXTN IS ALLOWED EXTENTION PAST THE ENDS
C                            OF THE CHAMBER IN WHICH WE PULL THE HIT
C                            BACK TO THE PHYSICAL END OF THE CHAMBER
C
      DATA IZEXTN / 500 /
C
C------------------  C O D E  ------------------------------------------
C
C                            IF THIS IS A MUEV BANK  OUTPUT  FROM  THE
C                            OLD M.C. , NO PROCESSING IS ATTEMPTED.
C
      IF( HMU(1) .EQ. 0 ) RETURN
C
C                            COUNT NUMBER OF CALLS TO MUCOOR
C
      NMU(1) = NMU(1) + 1
C
C                            OPTIONAL OUTPUT
C
      PFG = IPRIN .NE. 0
      IF(FIRST) GO TO 861
      GO TO 862
C
C                            ENTER HERE ON FIRST CALL.
C
  861 FIRST = .FALSE.
      NMESS = 0
      IF( .NOT. PFG ) GO TO 862
C
C                            PRINT MUCOOR BANNER
C
      WRITE(6,865)
  865 FORMAT(//' --->  MUON SIGNAL-TO-COORDINATE CONVERSION BY MUCOOR:',
     +         '   VERSION  9/03/84')
C
C                            PRINT MEANING OF MUCOOR ERROR MESSAGES.
C
      WRITE(6,888)
  888 FORMAT(//6X,'THE MEANING OF THE MUON MESSAGE CODES FROM MUCOOR'/
     *         6X,'================================================='//
     *'     1.....CRATE NUMBER OUTSIDE RANGE 1 TO 14'/
     *'     2.....CRATE NUMBER OUT OF SEQUENCE'/
     *'     3.....TIME REFERENCE WORD MISSING'/
     *'     4.....CHAMBER NUMBER OUTSIDE RANGE 1 TO 634'/
     *'     5.....NEW CHAMBER FOUND BUT PREVIOUS CHAMBER NOT FINISHED'/
     *'     6.....CHAMBER NUMBER OUT OF SEQUENCE'/
     *'     7.....HIT NUMBER NOT DECREASED BY ONE'/
     *'     8.....END-OF-CRATE FOUND INSTEAD OF A NEW CRATE MARKER'/
     *'     9.....SINGLES COUNT < 0  OR  COUNT TIME < 0'/
     *'    10.....OUTPUT ARRAY FULL. EXCESS HITS IN THE EVENT ARE LOST'/
     *'    11.....LENGTH ERROR IN HMU ARRAY'/
     *'    12.....LAST WORD IN HMU ARRAY IS NOT 0 OR 3840'/
     *'    13.....SINGLES DATA AFTER CHAMBER WORD WITH HIT NOT 1'/
     *'    14.....UNUSED'/
     *'    15.....UNUSED'/
     *'    16.....CHAMBER IN WRONG CRATE'/
     *'  70+N.....CRATE N MISSING'//)
      WRITE(6,863)
  863 FORMAT(' ****      SOME OF THESE MESSAGES ARE TO BE',
     +       ' EXPECTED FOR REAL DATA, ESPECIALLY "CRATE MISSING".'/
     +       ' ****      MOST OF THE OTHERS ARE NOT SO SERIOUS UNLESS',
     +       ' THEY OCCUR MORE THAN A FEW TIMES TOGETHER.'/
     +       ' ****      THE USUAL RECOVERY ACTION IS FOR MUCOOR TO',
     +       ' IGNORE THE REMAINDER OF THE MU CRATE BEING PROCESSED.'//)
  862 CONTINUE
C
C-----------------------------------------------------------------------
C
C                            INITIALISE COUNTERS ETC
C
C                            SET THE DRIFT TIME OUT-OF-SEQUENCE FLAG = 000027500
C
      ITDOS  = 0
C                            CLEAR HIT COUNTER
      NHITS  = 0
      NDIG   = 0
C
C                            CLEAR COUNTER FOR THE NUMBER OF  ATTEMPTS
C                            AT DATA RECOVERY
C
      NRECOV = 0
C
C                            HAS THE MAXIMUM  NO.  OF  ERROR  MESSAGES
C                            BEEN PRINTED IN THIS JOB?
C
      IF( NMESS .GE. MAXMES ) PFG = .FALSE.
C
C                            SET UP LOOP TO FIND MU HIT DATA
C                            SET IP=2 TO POINT TO FIRST DATA
C                            WORD-1.(IE SKIP BANK DESCRIPTOR)
C
      IP     =   2
      IPLAST =   2 * LMU
      J2     = - NWHIT
      JHIT   =   1
      JCHAM  =   0
      JCRATE =   0
      IER    =   0
      JER    =   0
      ITDH4  =   0
C                            GET TYPE OF DATA
      GO TO 1001
C
C=======================================================================
C=======================================================================
C
C                            START OF MAIN LOOP
C
C        ALL JUMPS IN THIS PROGRAM ARE FORWARDS, EXCEPT TWO:
C          GO TO 2000     *     GO TO 2200
C-----------------------------------------------------------------------
C
C                            RETURN HERE AFTER CONVERTING LAST HIT  TO
C                            COORDS. AND AFTER A RECOVERABLE ERROR
C
 2000  IF( IER .NE. 0 ) GO TO 2201
C
C                            DECIDE WHERE TO RE-ENTER THE MAIN  SEARCH
C                            PROGRAM. THE NEXT WORD COULD BE:
C                                         - END OF DATA
C                                         - NEXT CRATE
C                                         - NEXT CHAM/HIT
C                            IF LAST HIT NUMBER WAS NOT 1 --> MUST  BE
C                            ANOTHER HIT
C
          IF( IHIT .NE. 1 ) GO TO 1012
C
C                            GET NEXT WORD
C
          IP = IP + 1
          IF( IP .GE. IPLAST ) GO TO 200
          NW = HMU(IP)
C
C                            TEST FOR END OF DATA(0F00)
C
          IF( NW .EQ. 3840 ) GO TO 1001
C
C                            TEST FOR NEXT CHAMBER/HIT WORD
C                            ALLOW FOR CORRUPTED CHAMBER NUMBER UP TO
C                            VALUE FOR EOC MARKER.
C
          IF( NW .GE. 4 .AND. NW .LT. 3840 ) GO TO 1013
C
C                            PROBABLY THE NEXT CRATE THEN,  BUT THIS IS
C                            NOT THE CORRECT WAY TO MEET THE NEXT CRATE
C
          IP = IP - 1
          GO TO 1001
C
C-----------------------------------------------------------------------
C
 2201 CONTINUE
      JER   = IER
      JHIT  = 1
      JCHAM = 0
C
C                            ALLOW AN ARBITRARY NO. OF E.O.C. MARKERS
C
      IF( IER    .GT. 1 ) GO TO 1990
      IF( ICRATE .NE. 0 ) GO TO 1990
        IER = 0
        GO TO 1001
 1990 CONTINUE
      IER = 0
      IF( NRECOV .GT. MAXREC ) GO TO 201
      NRECOV = NRECOV + 1
 2200 CONTINUE
C
C                            ERROR RECOVERY: SEARCH FOR NEXT
C                            END-OF-CRATE OR CRATE-MARKER.
C
      NW = HMU(IP)
      IF( NW .EQ. 3840 ) GO TO 2203
      IF( NW .GE. 3841 .AND. NW. LE. 3854 .AND. JER .NE. 2 ) GO TO 2204
C
C                            IF  JER=2  AND  PRESENT  CRATE   HAS   NO
C                            E.O.C.,NEED THE  FOLLOWING  STATEMENT  TO
C                            START NEXT CRATE :
C
      IF( NW .GE. 3841 .AND. NW .LE. 3854 .AND. JER .EQ. 2
     +                 .AND .NW .GT. ICRATE + 3840  ) GO TO 2204
      IP = IP + 1
      IF( IP .GE. IPLAST ) GO TO 201
      GO TO 2200
C
 2203 NMU(63) = NMU(63) + 1
      GO TO 1001
 2204 NMU(64) = NMU(64) + 1
      IP = IP - 1
      GO TO 1001
C
C-----------------------------------------------------------------------
C
C                            --------------
C                            GET NEXT CRATE
C                            --------------
C
 1001 CONTINUE
C
C                            THIS IS THE  INITIAL  ENTRY  POINT.  NEXT
C                            WORD  SHOULD  BE  A   CRATE   WORD.   THE
C                            PROCESSING OF EVERY CRATE MUST START HERE
C                            AND , IN NORMAL CIRCUMSTANCES,  MUST  END
C                            HERE---EXCEPT CRATE 14, WHICH CAN  GO  TO
C                            201 AT THE END WITHOUT  COMING  HERE.  AT
C                            THIS POINT, NOTE THOSE CRATES WHICH HAD A
C                            MISSING E.O.C. MARKER.
C
      IF( JCRATE .GT. 0 .AND. HMU(IP) .NE. 3840 )
     +             NMU(84 + JCRATE) = NMU(84 + JCRATE) + 1
      IP = IP + 1
      IF( IP .GE. IPLAST ) GO TO 200
      NW = HMU(IP)
C
C                            TEST FOR VALID CRATE NUMBER (0 = EOC MARK)
C
      ICRATE = NW - 3840
      IF( ICRATE .EQ. 0 ) GO TO 908
      IF( ICRATE .LT. 1  .OR.  ICRATE .GT. 14 ) GO TO 901
C
C                            CHECK THAT CRATE NUMBER HAS INCREASED
C
      IF( ICRATE .LE. JCRATE     ) GO TO 902
      IF( ICRATE .EQ. JCRATE + 1 ) GO TO 1003
        JCR1 = JCRATE + 1
        ICR1 = ICRATE - 1
C
C                            INCREMENT 'CRATE MISSING' COUNTERS.
C
        DO  1502  JJ = JCR1,ICR1
          IER = 70 + JJ
          MER = 100 * IP + IER
          CALL MUERRY('MUCOOR',MER,' = ERROR CODE. SEE LIST ABOVE.^')
          NMU(70 + JJ) = NMU(70 + JJ) + 1
 1502   CONTINUE
C
C                            MUST PUT IER BACK TO ZERO.
C
        IER   = 0
        NMESS = NMESS + 1
C
 1003 JCRATE = ICRATE
      JCHAM  = 0
      KF910  = 0
C
C-----------------------------------------------------------------------
C
C                            THE NEXT WORD CAN BE EITHER:
C
C                            1) END-OF-CRATE WORD, 3840 (HEX 0F00)
C                            2) TIME REF FOR CRATE, IF THERE ARE HITS
C                            3) CHAMBER/HIT WORD,IF NO HITS,ONLY SINGLES
C
      IP = IP + 1
      NW = HMU(IP)
      IF( NW .EQ. 3840 ) GO TO 1001
C
C                            TEST FOR VALID TIME REF (USUALLY ZERO BUT
C                            AT LEAST ONE EVENT HAS BEEN FOUND WITH
C                            TIME REF WORD = 3584 + NON-ZERO DIGIT)
C                            SO ALLOW TIMREF = 3584 --> 3594
C
      TIMREF = NW .GE. 3584  .AND.  NW .LE. 3594
      IF( .NOT. TIMREF ) IP = IP - 1
C
C                            NEXT WORD MUST BE A CHAMBER/HIT WORD
C
 1012 IP    = IP + 1
      IF( IP .GE. IPLAST ) GO TO 200
      NW    = HMU(IP)
 1013 ICHAM = NW / 4
C
C                            CHECK FOR A VALID CHAMBER NUMBER
C
      IF( ICHAM .LT. 1 .OR. ICHAM .GT. 634 ) GO TO 904
C
C                            CHECK IF CHAMBER IS IN THE CRATE
C
      IF( ICRATE .NE. HSECT(HFR(ICHAM) ) ) GO TO 916
      IHIT = NW - 4*ICHAM + 1
C
C                            IHIT IS BY DEFINITION IN RANGE 1 TO 4
C
C-----------------------------------------------------------------------
C
C                            TEST IF CHAMBER NUMBER AND HIT NUMBER ARE
C                            CONSISTENT WITH THE LAST PROCESSED HIT
C
      IF( JHIT .EQ. 1 ) GO TO 1010
        IF( IHIT  .NE. JHIT - 1 ) GO TO 907
        IF( ICHAM .NE. JCHAM    ) GO TO 905
        GO TO 3906
C
 1010 IF( ICHAM .LE. JCHAM ) GO TO 1906
      GO TO 3906
C
C                            NOTE: CHAMBERS IN CRATES 9 * 10  ARE  NOT
C                            IN SEQUENCE. BEARING THIS IN MIND, DO  WE
C                            HAVE A SEQUENCE ERROR?
C
 1906 IF( .NOT. ( ICRATE .EQ. 9 .OR. ICRATE .EQ. 10 ) ) GO TO 906
      IF( KF910 .EQ. 1 ) GO TO 906
C
      IF(   .NOT. (
     +
     +    ( ICRATE .EQ.  9 .AND. ICHAM .LE. 286 .AND. JCHAM .GE. 323 )
     +                           .OR.
     +    ( ICRATE .EQ. 10 .AND .ICHAM .LE. 298 .AND .JCHAM .GE. 335 )
     +              )
     +                 ) GO TO 906
C
C                            NOT AN ERROR BUT IT CAN ONLY HAPPEN  ONCE
C                            PER CRATE
C
      KF910 = 1
C
 3906 ADJCHM = ICHAM .EQ. JCHAM + 1
      SAMCHM = ICHAM .EQ. JCHAM
      HIT12  = SAMCHM .AND. JHIT .EQ. 2
      IF( .NOT. SAMCHM ) ITDH4 = 0
C
C                            SET ITDH4 = 1 IF 4  HITS IN THIS CHAMBER
C
      IF( .NOT. SAMCHM .AND. IHIT .EQ. 4 ) ITDH4 = 1
C
C                            NEXT WORD IS A DRIFT TIME
C
      IP   = IP + 1
      IITD = HMU(IP)
      KKTD = IITD
C
C                            NEXT WORD IS A LONGITUDINAL TIME DIFFERENCE
C
      IP   = IP + 1
      IITL = HMU(IP)
      KKTL = IITL
C
C                            IF NO TIME REF IN THIS CRATE -->  SINGLES
C                                                              DATA?
C
      IF( IITD .LT. 0 .OR. IITD .GT. 255 .OR.
     +    IITL .LT. 0 .OR. IITL .GT. 255      ) GO TO 1200
C
C                            ERROR IF STILL HERE AND  NO TIME REF.
C
      IF( .NOT. TIMREF ) GO TO 903
      GO TO 1202
C
C-----------------------------------------------------------------------
C
C                            THIS SECTION HANDLES SINGLES RATES DATA
C
 1200 NCNT =  IITD - 2048
      NTIM =  IITL - 2048
      IF( IHIT .NE. 1 ) GO TO 913
      IF( NCNT .LT. 0 .OR. NTIM .LE. 0 ) GO TO 909
      RATE = NCNT
      RATE = 2.0 * RATE / NTIM
C
      IF( ENOUGH ) GO TO 2004
        KMESS = KMESS + 1
CP      WRITE(6,80) ICHAM, NCNT, NTIM, RATE
CP 80   FORMAT(' MUCOOR SINGLES RATES. CHAM=',I3,'   COUNTS=',I3,
CP   +         '   TIME=',I3,'   CNTS/SEC=',F6.1 )
        ENOUGH = KMESS .GE. MAXMUM
C
 2004 CONTINUE
      GO TO 2002
C
C                            TEST IF DRIFT TIMES ARE IN SEQUENCE
C
 1202 IF( .NOT. SAMCHM ) GO TO 1014
C
C                            IF DRIFT TIMES ARE OUT OF  SEQUENCE,  SET
C                            ITDOS AND FLAG ALL HITS IN  THIS  CHAMBER
C                            ASBAD. DO THIS AFTER  PROCESSING HIT1.
C
        IF( IITD .LT. JITD ) GO TO 1014
        ITDOS   = 1
        NMU(26) = NMU(26) + 1
C
C                            NORMALLY, NO PRINTING FOR THIS ERROR
C
 1014 CONTINUE
C
C                            INITIALISE BIT 8 OF HIT STATUS  OK  (I.E.
C                            HIT ONE NOT KILLED ). THIS FLAG  IS  ONLY
C                            MEANINGFUL FOR HIT1.
C
      HLUN3 = 2**8
C
C                            INITIALISE BIT 9 OF HIT STATUS  OK  (I.E.
C                            HIT DID NOT MULTI-PULSE)
C
      HLUN4 = 0
      IF( .NOT. SAMCHM ) GO TO 1015
C
C                            SINCE THE 4'TH  HIT  DESTROYS  THE  DRIFT
C                            INFORMATION OF THE 1'ST, TRY  TO  RECOVER
C                            THIS INFORMATION BY SUBTRACTING  A  FIXED
C                            QUANTITY FROM THE DRIFT TIME OF HIT 2. IF
C                            THERE WERE 4 HITS NOTE THE DRIFT TIME FOR
C                            THE 2'ND HIT. RECORD TEMPORARILY THE DRIFT
C                            TIME FOR EACH HIT.
C
      IDRIFT(IHIT) = IITD
C-----------------------------------------------------------------------
C
C                            DO SOMETHING ABOUT HIT 4 KILLING HIT 1
C
      IF(IHIT.GT.1) GOTO 1015
        IF(ITDH4.EQ.1.AND.IITD.EQ.0.AND.IHIT.EQ.1) GOTO 915
          GOTO 1015
  915     NMU(25)=NMU(25)+1
C
C                            N.B. NORMALLY, NO PRINTING FOR THIS ERROR
C                            WE HAVE LOST HIT ONE, RECOVER IT
C
          KKTD = IDRIFT(2) - ICONST
C
C                            SET STATUS BANK THAT THIS HIT IS
C                            BODGED..( BIT 8=0 )
C
          HLUN3 = 0
 1015 CONTINUE
C
C-----------------------------------------------------------------------
C                            NOTE: KKTD,MAY AT THIS STAGE,BE DIFFERENT
C                            TO IITD IF HIT1 HAS BEEN KILLED BY HIT4
C
          ITD = 0
          IF(KKTD.GE.0.AND.KKTD.LT.256) ITD = KKTD
C
          ITL = 0
          IF(KKTL.GE.4.AND.KKTL.LE.255 ) ITL = KKTL
C
C                            COUNT NUMBER OF DIGITISINGS FOUND
C
          NDIG = NDIG + 1
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                            FIX-UP CHAMBER STATUS FOR CERTAIN PERIODS
C
          CALL MUFSTA( IMONTH, IYEAR )
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C                            GET THE STATUS OF THE CHAMBER
C
          GOOD = HMCSTA(ICHAM).EQ.0
C
C                            IGNORE HITS FROM BAD CHAMBERS
C
          IF( GOOD ) GO TO 1017
C
C                            SIGNAL FROM CHAMBER WITH STATUS 'NOT OK'.
C
            NMU(40) = NMU(40) + 1
            GO TO 2001
C
C                            SIGNAL FROM CHAMBER WITH STATUS 'OK'.
C
 1017 CONTINUE
C
C----------------------------------------------------------------------
C
C                            REMOVE HITS FROM SECOND BEAM CROSSING.
C
C                            AS OF 16/03/83, THE PROCEDURE  RE  ITMCUT
C                            IS EFFECTIVELY OBSOLETE , EXCEPT THAT  IT
C                            WILL CUT  OUT  ANY  WILD  DRIFT  TIMES.
C                            WE NOW  PUT  ITMCUT  =  130 CLOCK PULSES.
C
C                            NORMALLY , THIS MEANS A FIXED CUT  OF  80
C                            CLOCK PULSES (4.0  MICROSECS)  BUT  ,  IF
C                            DRIFT VELOCITY DECREASES  ,  NEED  LARGER
C                            CUTOFF. ---- THIS HAPPENED  BETWEEN  RUNS
C                            4220 * 4482. THE NORMAL DRIFT VELOCITY IS
C                            2150 MICRONS  PER  CLOCK  PULSE.  ---  TO
C                            ABOUT   5   %,   THAT   IS.    SO     PUT
C                            ITMCUT=80*2260/NEW VDRIFT .
C
      ITMCUT = 130
      IF( KRUN .GE. 4220 .AND. KRUN .LE. 4482 )
     +                                  ITMCUT = 180800 / HVDRFT(ICHAM)
      IF ( ITD .GE. ITMCUT ) GO TO 2001
C
C-----------------------------------------------------------------------
C
C                            DOUBLE PULSE CUT (YEAR DEPENDENT)
C
C                            IF THE  PREVIOUS  HIT  WAS  IN  THE  SAME
C                            CHAMBER AND IF IT  WAS  CLOSER  THAN  THE
C                            CUT, MU2PUL, THEN DELETE  THE  PREVIOUSLY
C                            ENTERED HIT BY REDUCING NHITS BY ONE  AND
C                            RESETTING THE POINTER J2, THEN PROCEED TO
C                            PROCESS THE PRESENT HIT.
C
C
         IF( .NOT. SAMCHM ) GO TO 1016
         IF( JITD - KKTD .GT. MU2PUL( IMONTH, IYEAR )    .OR.
     +       JITD - KKTD .LE. 0                            ) GO TO 1016
C
           HLUN4 = 2 ** 9
C
C                            CHECK IF PREVIOUS HIT WAS KEPT. IF NOT DO
C                            NOT DELETE A HIT, JUST PROCESS THIS ONE.
C
           IF( JITD .GE. ITMCUT ) GO TO 1016
C
C                            ITS A  CLOSE  PULSE  ==> DELETE ONE
C
           NHITS   = NHITS - 1
           J2      = J2 - NWHIT
           NMU(24) = NMU(24) + 1
 1016    CONTINUE
C
C-----------------------------------------------------------------------
C
C      WE NOW HAVE A SET OF VALID NUMBERS (ICRATE,ICHAM,IHIT,ITD,ITL)
C      WHICH HAVE SATISFIED ALL THE DATA CONSISTENCY REQUIREMENTS.
C      THESE WILL NOW BE CONVERTED INTO COORDINATES.
C      THEY CAN NO LONGER BE REJECTED, BUT ONLY FLAGGED.
C      ITD, ITL  MAY BE ZERO, INDICATING A HIT BUT NO POSITIONAL
C      INFORMATION.
C
C-----------------------------------------------------------------------
C
C                            GET THE GLOBAL PARAMETERS
C
C                            FRAME NUMBER.
C
          IFRAME = HFR(ICHAM)
C
C                            ORIENTATION PARAMETER.
C
          IOR    = HNORM(IFRAME)
C
C                            CALCULATE THE NORMAL COORDINATE.
C
          ICNORM = HDIST(IFRAME) + HD1(ICHAM)
C
C                            PROCESS THE LONGITUDINAL DATA
C
          IMMTL  = 0
C
C                            WE HAVE TO ENSURE THAT THE  HLSF(4,ICHAM)
C                            IS NOT USED FOR  LONGITUDINAL  COORDINATE
C                            CALCULATION.
C
          LSFACT = HLSF(IHIT,ICHAM)
          IF( IHIT .EQ. 4 ) LSFACT = HLSF(3,ICHAM)
          IF( ITL  .NE. 0 ) IMMTL  = (LSFACT*( ITL - HLTP(ICHAM) ))/100
C
C                            SET HLUN1 TO 1 (=0001)
C
          HLUN1 = 1
          LONG  = 1
C
C                            FIND THE LONGITUDINAL CENTRE OF THE CHAMBER
C                            FIND THE LONGITUDINAL COORD.. FLAG IF BAD
C
          ICLCEN = (HCLLO(IFRAME) + HCLHI(IFRAME)) / 2
          ICLONG = ICLCEN + IMMTL
C
C                            DATA IS GOOD IF POSITION IS WITHIN IZEXTN
C                            OF END OF CHAMBER
C
          IF( ITL    .NE. 0                         .AND.
     *        ICLONG .GE. (HCLLO(IFRAME) - IZEXTN)  .AND.
     *        ICLONG .LE. (HCLHI(IFRAME) + IZEXTN)       ) GO TO 7
C
C                            THE DATA IS BAD. SET HLUN1 TO 0 (=0000)
C
             HLUN1 = 0
             LONG  = 0
C
C                            SET ICLONG TO COORDINATE OF CHAMBER CENTRE
C
             ICLONG = ICLCEN
C
C                            INCREMENT BAD LONGITUDINAL COUNT.
C
             NMU(21) = NMU(21) + 1
    7     CONTINUE
C
          IF( ICLONG .LT. HCLLO(IFRAME) .OR. ICLONG .GT. HCLHI(IFRAME) )
     *               NMU(23) = NMU(23) + 1
C
C                            IF POSITION IS OUTSIDE CHAMBER, PULL IT IN
C
          IF( ICLONG .LT. HCLLO(IFRAME)) ICLONG = HCLLO(IFRAME)
          IF( ICLONG .GT. HCLHI(IFRAME)) ICLONG = HCLHI(IFRAME)
C
C                            FOR  THE  HANG  CORRECTION  WE  NEED  THE
C                            CORRECTED IMMTL
C
C                            ICLONG, HLUN1, LONG ARE NOW SET.
C
C                            PROCESS THE DRIFT TIME DATA (NEW METHOD)
C
          IMMTD = 0
          IF( ITD .LT. 0 ) ITD = 0
          DTX   = ITD
C
C                            CORRECT SHORT AND LONG DRIFT TIMES
C                            (BUT NOT FOR MONTE-CARLO DATA).
C
          IF( ITD  .GT. 9  .AND.  ITD .LT. 64 ) GO TO 864
          IF( KRUN .LT. 100 ) GO TO 864
            DTX = XDT(ITD + 1)
  864     CONTINUE
C
          VDRIFT = HVDRFT(ICHAM)
          DTP    = HDTP(ICHAM) / 10.0
          ALFA   = ABS( ATAN( TANTHM(ICHAM)  )  )
          ALFAP  = ALFA - 0.436
          IF( ALFAP .LT. 0.0001 ) ANGEFF =  0.0
          IF( ALFAP .GT. 0.0001 ) ANGEFF = 15.0 * TAN(ALFAP)
C
C                            FOR MONTE-CARLO DATA, NO ANG. CORRECTION
C
          IF( KRUN .LT. 100 ) ANGEFF = 0.0
          XMMTD = VDRIFT * (DTX - DTP) / 1000.0  +  ANGEFF
C
C                            CORRECT FOR CRATE 6 CLOCK PULSE EXCEPT M.C.
C
C                            ( NOTE THAT THE CALIBRATION FILES  ALWAYS
C                            HAVE CRATE 6 VDR * DTP  EQUAL  TO  GLOBAL
C                            VALUES....THIS  IS  THE  EFFECT  OF   THE
C                            VARIOUS UPDATES AS OF 16/03/83. )
C
          IF( ICRATE .EQ. 6 .AND. KRUN .LT. 8256 .AND. KRUN .GT. 99 )
     +                                            XMMTD = 1.26 * XMMTD
C
          IMMTD = XMMTD
C
C                            CALCULATE THE WIRE COORDINATE.
C                            APPLY SOFTWARE SHIFT TO WIRE POSITION FOR
C                            ALL DATA AFTER BEGINNING OF 1980
C
          ISHIFT = 0
          IF( IYEAR .GE. 1980 ) ISHIFT = HLSF(4,ICHAM)
          IF( IABS(ISHIFT) .GT. 300 ) ISHIFT = 0
C
C                            NO SOFTWARE SHIFTS FOR MONTE-CARLO  DATA.
C
          IF( KRUN .LT. 100 ) ISHIFT = 0
          ICWIRE = HCTW(ICHAM) - ISHIFT
C
C                            SET HLUN2 TO 2 (=0010)
C
          HLUN2 = 2
          NDRIF = 1
C
C                            CALCULATE THE TWO (L/R AMBIGUOUS)
C                            TRANSVERSE COORDINATES.
C
          IF( IMMTD .LT. IMTDLO  .OR.  IMMTD .GT. IMTDHI ) GO TO 85
C
C                            DATA IS GOOD, BUT PULL IN IF JUST OUTSIDE
C                            PHYSICAL RANGE
C
          IF( IMMTD .LT. 0  .OR.  IMMTD .GT. 155 ) NMU(22) = NMU(22) + 100086900
          IF( IMMTD .LT. 0   ) IMMTD = 0
          IF( IMMTD .GT. 155 ) IMMTD = 155
C
C                            CALCULATE THE COORDINATES WITHOUT THE
C                            ANGULAR CORRECTION
C
          ICT1 = ICWIRE - IMMTD
          ICT2 = ICWIRE + IMMTD
          GO TO 8
C
C                            THE DATA IS BAD, SO SET HLUN2 TO 0(=00000)
C
   85     HLUN2 = 0
          NDRIF = 0
C
C                            SET IC1 * IC2 TO COORD. OF CHAMBER CENTRE
C
          ICT1  = ICWIRE
          ICT2  = ICWIRE
C
C                            INCREMENT BAD DRIFT TIME COUNT.
C
          NMU(20) = NMU(20) + 1
    8     CONTINUE
C
C                            ICT1, ICT2, HLUN2, NDRIF ARE NOW SET.
C
C-----------------------------------------------------------------------
C
C                            STORE THE RESULTING  COORDINATES  IN  THE
C                            OUTPUT ARRAY HC.
C
      IF( NHITS .GE. NHITMX ) GO TO 910
        NHITS = NHITS + 1
C                            J2 WAS SET TO -NWHIT AT BEGINNING OF EVENT
        J2 = J2 + NWHIT
C
C                            FILL OUTPUT ARRAY HC.
C                            4*(CHAMBER NUMBER) + (HIT NUMBER -1)
C
        HC(J2 + 1) = HMU(IP - 2)
C
C                            10*LAYER NO. + ORIENTATION PARAMETER (HOR).
C
        HC(J2 + 2) = 10 * HLAYER(IFRAME) + IOR
C
C                            OVERALL X DISPLACEMENT.
C
        IX = HOVALL( HUNIT( IFRAME ) )
C
C                            X,Y,Z COORDINATES
C
        GO TO (11,12,13),IOR
C
   11     HC(J2 + 3) = ICNORM + IX
          HC(J2 + 4) = ICT1
          HC(J2 + 5) = ICLONG
          HC(J2 + 6) = ICNORM + IX
          HC(J2 + 7) = ICT2
          HC(J2 + 8) = ICLONG
          HLUNY      = HB6 + HB5 + HB4 + NDRIF*HB3 + LONG*HB2
          GO TO 20
C
   12     HC(J2 + 3) = ICT1 + IX
          HC(J2 + 4) = ICNORM
          HC(J2 + 5) = ICLONG
          HC(J2 + 6) = ICT2 + IX
          HC(J2 + 7) = ICNORM
          HC(J2 + 8) = ICLONG
          HLUNY      = HB7 + HB5 + NDRIF*HB4 + HB3 + LONG*HB2
          GO TO 20
C
   13     HC(J2 + 3) = ICT1 + IX
          HC(J2 + 4) = ICLONG
          HC(J2 + 5) = ICNORM
          HC(J2 + 6) = ICT2 + IX
          HC(J2 + 7) = ICLONG
          HC(J2 + 8) = ICNORM
          HLUNY      = HB7 + HB6 + NDRIF*HB4 + LONG*HB3 + HB2
C
C                            POINTER TO CHAM/HIT DATA WORD IN RAW DATA
C
   20     HC(J2 + 9) = IP - 2
C
C                            PACK THE STATUS INFORMATION FOR THIS HIT
C                            IN THE FIRST 10 BITS OF HLUN
C
          HLUN(NHITS) = HLUN1 + HLUN2 + HLUN3 + HLUN4 + HLUNY
C
C-----------------------------------------------------------------------
C
C                            RECORD CURRENT PARAMETERS
C                            (TO CHECK NEXT DIGITISING)
C
 2001 JITD  = IITD
      JITL  = IITL
      JTD   = ITD
      JTL   = ITL
      JHIT  = IHIT
      JCHAM = ICHAM
C
      IF( IHIT  .GT. 1 ) GO TO 2002
      IF( ITDOS .EQ. 0 ) GO TO 2002
C
C                            DRIFT TIMES ARE OUT OF SEQUENCE FOR  THIS
C                            CHAMBER. LOOK BACK THRO' THE ARRAY HC AND
C                            COUNT THE NO. OF  HITS  WHICH  WERE  KEPT
C                            FROM  THIS  CHAMBER.  THEN  CORRECT  HLUN
C                            ENTRY FOR THESE HITS BY MAKING BOTH DRIFT
C                            AND LONGITUDINAL COORDINATES 'BAD'.
C
      IKEPT = 0
      J1    = J2 - 3 * NWHIT
C
      DO  3010  JJ = J1,J2,NWHIT
        JHCHAM = HC(JJ + 1) / 4
        IF( JHCHAM .EQ. ICHAM ) IKEPT = IKEPT + 1
 3010 CONTINUE
C
      HLUN1 = 0
      HLUN2 = 0
      LONG  = 0
      NDRIF = 0
C
      DO  3025  I = 1,IKEPT
        GO TO (3011,3012,3013),IOR
 3011     HLUNY = HB6 + HB5 + HB4 + NDRIF*HB3 + LONG*HB2
          GO TO 3020
 3012     HLUNY = HB7 + HB5 + NDRIF*HB4 + HB3 + LONG*HB2
          GO TO 3020
 3013     HLUNY = HB7 + HB6 + NDRIF*HB4 + LONG*HB3 + HB2
 3020     HLUN(NHITS-IKEPT+I) = HLUN1 + HLUN2 + HLUN3 + HLUN4 + HLUNY
C
 3025 CONTINUE
C
C                            BEFORE GOING ON TO  NEXT  CHAMBER  ,  SET
C                            ITDOS TO ZERO AND INCREMENT NMU(27).
C
          ITDOS   = 0
          NMU(27) = NMU(27) + 1
          GO TO 2002
C
C-----------------------------------------------------------------------
C
C                            ERROR COUNTING (RECOVERABLE ERRORS)
C
C                            901 IS INVALID CRATE NUMBER
C
  901 NMU(60) = NMU(60) + 1
      IER = 1
      GO TO 930
C
C                            902 IS CRATE NUMBER OUT OF ORDER
C
  902 NMU(61) = NMU(61) + 1
      IER = 2
      GO TO 930
C
C                            903 IS MISSING TIME REF WORD
C
  903 NMU(62) = NMU(62) + 1
      IER = 3
      GO TO 930
C
C                            904 IS INVALID CHAMBER NUMBER
C
  904 NMU(41) = NMU(41) + 1
      IER = 4
      GO TO 930
C
C                            905 IS NEW CHAMBER WITH JHIT = 1
C
  905 NMU(29) = NMU(29) + 1
      IER = 5
      GO TO 930
C
C                            906 IS CHAMBER NO OUT OF SEQUENCEE
C
  906 NMU(42) = NMU(42) + 1
      IER = 6
      GO TO 930
C
C                            907 IS HIT NUMBER NOT DECREASED BY ONE
C
  907 NMU(28) = NMU(28) + 1
      IER = 7
      GO TO 930
C
C                            908 IS END-OF-CRATE FOUND WHEN CRATE MARKER
C                                                      WAS EXPECTED.
C
  908 NMU(65) = NMU(65) + 1
      IER = 8
      GO TO 930
C
C                            909 IS NEGATIVE COUNTS OR TIME IN SINGLES
C                                                              DATA
  909 NMU(44) = NMU(44) + 1
      IER = 9
      GO TO 930
C
C                            913 IS SINGLES DATA WITH HIT NOT 1
C
  913 NMU(30) = NMU(30) + 1
      IER = 13
      GO TO 930
C
C                            916 IS CHAMBER IN WRONG CRATE
C
  916 NMU(43) = NMU(43) + 1
      IER = 16
C
  930 NMESS = NMESS + 1
      MER   = 100 * IP + IER
      CALL MUERRY('MUCOOR',MER,' = ERROR CODE. SEE LIST ABOVE.^')
C
C                            AFTER ERROR, TRY TO START AGAIN
C                            JUMP BACK TO BEGINNING OF THE MAIN LOOP
C
 2002 CONTINUE
      GO TO  2000
C
C                  END OF MAIN LOOP
C=======================================================================
C=======================================================================
C
C                            END OF INPUT DATA REACHED
C                            CHECK THE POSITION OF THE POINTER
C
  200  IF( IP .EQ. IPLAST + 1 ) GO TO 201
       IF( IP .NE. IPLAST     ) GO TO 911
       IF( HMU(IP) .EQ. 0  .OR.  HMU(IP) .EQ. 3840 ) GO TO 201
       GO TO 912
C
C                            DID CRATE  14  HAVE AN  E.O.C. MARKER?
C
  201  IF( .NOT. (    ICRATE  .EQ. 14  .AND.
     +              ( HMU(IP) .EQ. 3840  .OR.  HMU(IP-1) .EQ.3840 )
     +           )
     +   )                NMU(98)=NMU(98)+1
C
C                            INCREMENT NO. OF HITS AND 'NO DATA' COUNT
C
       NMU(2) = NMU(2) + NHITS
       IF( NHITS .LE. 0 ) NMU(3) = NMU(3) + 1
C
CP     WRITE(6,444)IEV,NHITS
CP444  FORMAT(1X,/,'++++ EVENT ',I3,' ++++ NUMBER OF HITS ',I3/)
C
      RETURN
C
C=======================================================================
C=======================================================================
C
C                            PROCESS THE VARIOUS ERROR CONDITIONS
C
C                            910 IS OVERFLOW OF OUTPUT ARRAY
C
  910 NMU(7) = NMU(7) + 1
      IER = 10
      GO TO 998
C
C                            911 IS LENGTH ERROR IN ARRAY HMU
C
  911 NMU(8) = NMU(8) + 1
      IER = 11
      GO TO 998
C
C                            912 IS LAST WORD NOT 0 OR 3840 IN HMU
C
  912 NMU(9) = NMU(9) + 1
      IER = 12
C
  998 NMESS = NMESS + 1
      MER   = 100 * IP + IER
      CALL MUERRY('MUCOOR',MER,' = ERROR CODE. SEE LIST ABOVE.^')
C
  999 CONTINUE
C                            999 IS THE EXIT FOR ERRORS 10, 11, 12.
C
C                            INCREMENT NO. OF HITS AND 'NO DATA' COUNT
C
       NMU(2) = NMU(2) + NHITS
       IF( NHITS .LE. 0 ) NMU(3) = NMU(3) + 1
C
      RETURN
C                            NMU DESCRIPTION NOW ON MEMBER @MUSTAT
      END

C   10/09/79 002222000  MEMBER NAME  KALCOP   (JADESR)      FORTRAN
      SUBROUTINE KALCOP
      IMPLICIT INTEGER*2 (H)
C---
C---     SIMPLE COPY.
C---                                   L.H. O'NEILL 10.09.79
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
C---
      NREC=0
    1 CONTINUE
      CALL EVREA1(2,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
C     IOUT=NWORD
C     IF(IOUT.GT.10) IOUT=10
C     WRITE(6,100) NREC,NWORD,(JBUF(I),I=1,IOUT)
  100 FORMAT(1X,I4,I12,10I10)
      CALL KALBNK(3,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
      RETURN
      END

C   17/10/77 C8041301   MEMBER NAME  SHOWR    (TESTS)       FORTRAN
      FUNCTION SHOWR(E,XX,DX)
C
C      CALCULATE ENERGY LOSS IN AN ELECTROMAGNETIC SHOWER AS A FUNCTION
C      OF INCIDENT ENERGY E, DEPTH X AND SLAB THICKNESS DX USING
C      LHO SHOWER PROFILE FIT
C      ENERGIES IN MEV, XX AND DX IN RADLENGTH
C
      REAL SL/0.9034/,BE/5.419/,RK/0.3418/,THIRD/0.33333/,CU16/2.5198/
C
      X=XX+1.5
      IF(E.LT.10.) GO TO 1
      XMAX=SL*ALOG(E/BE)
      ROOT=SQRT(1.-((RK*XMAX)**3)/54.)
      C1=(1.+ROOT)**THIRD
      C2=(1.-ROOT)**THIRD
      RA=RK*XMAX*(C1+C2)/CU16
      A=XMAX*(RA**THIRD)
      ARG=RK*(A-(A**3+X**3)**THIRD)
      SHOWR=E*RK*EXP(ARG)*X**2/(A**3+X**3)**0.666667
      SHOWR=SHOWR*DX
      RETURN
    1 SHOWR=E*RK*DX/EXP(RK*X)
      RETURN
      END

C   07/06/96 606071850  MEMBER NAME  IBN      (S4)          FORTG1
      FUNCTION IBN(X,XA,DX,NB)
C     PURPOSE
C        OBTAIN INDEX FROM X IN A EQUIDISTANT SCALE WITH
C        XA = LOWEST CHANNEL LEFT EDGE
C        DX = BIN WIDTH
C        NB = MAX NR OF BINS
C
C     USAGE
C        INDEX=IBN(X,XA,DX,NB)
C
C     REMARK
C        INDEX = 0     FOR X LT XA
C              = NB+1  FOR X GE XA+NB*DX
C
      N=(X-XA)/DX+1.0
      N=MAX0(0,N)
      IBN=MIN0(N,NB+1)
      RETURN
      END

C   19/02/80 808021752  MEMBER NAME  ENLOSG   (SOURCE)      FORTRAN
C
C      PARAMETERS CALCULATED BY EGS3          D.PITZL 21.5.87
C
C***************************************************************
      SUBROUTINE  ENLOSG ( E, D, DE, * )
C***************************************************************
C
C      ENERGY LOSS OF PHOTONS IN ALUMINIUM
C
C     INPUT  : E  = INPUT ENERGY IN GEV
C              D  = THICKNESS OF ALUMINUM ABSORBER IN CENTIMETER
C     OUTPUT : DE = ENERGY LOSS IN GEV
C
C                        WRITTEN BY H.TAKEDA  15/02/80
C                        TYPED BY Y.WATANABE  19/02/80
C
C    VARIABLES: BENG = LIST OF INCIDENT ENERGIES IN GEV
C               BTHK = LIST OF ALU THICKNESSES IN CM
C               HCOR = MATRIX OF ENERGY LOSS IN MEV FOR EACH
C                      THICKNESS AND ENERGY
C                      20 ENERGIES FOR EACH THICKNESS
C
C
C
      DIMENSION BENG(20),BTHK(7)
      INTEGER*2 HCOR(20,7)
      DATA BENG/ 0.0,  0.1,  0.2,  0.3,  0.5,  0.7,  1.0,  2.0,  3.0,
     1           4.0,  5.0,  6.0,  7.0,  9.0, 11.0, 13.0, 15.0, 17.0,
     2          19.0, 99.0/
      DATA BTHK/ 0.0,  7.0,  9.0, 11.0, 13.0, 15.0, 99.0/
C
      DATA HCOR/ 20 * 0 ,
     2    0, 12, 14, 16, 17, 19, 19, 21, 22, 23,
     2   23, 23, 23, 23, 26, 26, 26, 27, 30,  0,
     3    0, 18, 22, 26, 28, 32, 32, 36, 39, 40,
     3   42, 42, 42, 44, 47, 47, 47, 52, 55,  0,
     4    0, 25, 32, 39, 39, 48, 49, 57, 62, 65,
     4   68, 69, 70, 72, 77, 78, 78, 89, 90,  0,
     6    0, 31, 41, 52, 54, 67, 70, 84, 93, 97,
     6  103,105,108,112,124,124,124,141,141,  0,
     6    0, 37, 52, 65, 71, 89, 94,116,130,139,
     6  148,152,158,164,183,184,185,209,212,  0,
     7   20 * 0 /
C
      DATA IERR1,IERR2,IENTRY,IERCNT,IBTHK,IBENG/3*0,5,7,20/
C     EXTRAPOLATE THE THICKNESS OF ALUMINUM
      DE=0.
C
C---- INITIALIZE
C     ENERGY LOSS FOR THICKNESS #7 = 99CM CALCULATED BY LINEAR
C     EXTRAPOLATION. NOT USED AT JADE, JUST FOR SAFETY.
C
      IF(IENTRY.GE.1) GO TO 2
      DO 1 I=1,IBENG
      F=(BTHK(IBTHK)-BTHK(IBTHK-2))/(BTHK(IBTHK-1)-BTHK(IBTHK-2))
      HCOR(I,IBTHK)=HCOR(I,IBTHK-2)+F*(HCOR(I,IBTHK-1)-HCOR(I,IBTHK-2))
1     CONTINUE
C     WRITE(6,900) HCOR
C900  FORMAT(20 I6)
      PRINT 9123
 9123 FORMAT ( T2,'JADELG.LOAD (ENLOSG) CALLED FROM LGECOR' )
      IENTRY=1
C
C       CHECK BAD INPUTS
2     IF (E .GE. 0.0 .AND. E .LE. 99.) GO TO 3
      IERR1=IERR1+1
      IF (IERR1 .GT. IERCNT) RETURN1
      WRITE(6,600) E
600   FORMAT('0 **BAD  ENERGY INTO LGECOR(ENGLOS) E=',F10.3)
      RETURN1
C
3     IF (D .GE. 0.0 .AND. D .LE. 99.) GO TO 4
      IERR2=IERR2+1
      IF(IERR2.GT.IERCNT) RETURN1
      WRITE(6,610) D
610   FORMAT('0 **BAD THICKNESS INTO LGECOR(ENGLOS) D=',F10.3)
      RETURN1
C
4     DO 5 I=2,IBENG
      IF(E.LT.BENG(I)) GO TO 6
5     CONTINUE
6     DO 7 J=2,IBTHK
      IF(D.LT.BTHK(J)) GO TO 8
7     CONTINUE
C
8     EPORT=(E-BENG(I-1))/(BENG(I)-BENG(I-1))
      TPORT=(D-BTHK(J-1))/(BTHK(J)-BTHK(J-1))
C
      FACT1=HCOR(I-1,J-1)+EPORT*(HCOR(I,J-1)-HCOR(I-1,J-1))
      FACT2=HCOR(I-1,J  )+EPORT*(HCOR(I,J  )-HCOR(I-1,J  ))
C
      DE=FACT1+TPORT*(FACT2-FACT1)
      DE=DE/1000.
      IF(DE.GT.E) DE=E
      RETURN
      END

C   11/12/78 C9092001   MEMBER NAME  LGAVDP   (SOURCE)      FORTRAN
      SUBROUTINE LGAVDP(ZAV,EMEV,JEG,DEP)
C
C     S.YAMADA  11-12-78  14:55
C     LAST MODIFICATION    13-09-79   22:35 Y.WATANABE
C
C----   AVERAGE DEPTH OF THE SHOWER IS CALCULATED BY ITERATION.
C
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX
      COMMON /CLGMSB/ MSGVAL,AMSGV1,AMSG2
      DATA SM0/150.0/
C     HALF OF THE COUNTER LENGTH FOR THE DEPTH OF NONSHWERING PARTICLES
C
      ZAV2 = (ZAV-ZVRTX)**2
      DEPO = 0.
C
C---- AVERAGE SHOWER DEPTH ALONG THE AXIS = SM
      IF(JEG.LT.2) SM = SHMAX(EMEV,JEG)
      IF(JEG.EQ.2) SM = SM0
C
      NTRY = 0
    4 NTRY = NTRY+1
      IF(NTRY.GT.20) GO TO 21
      DEP = SM/SQRT(1.0+ZAV2/(RADIUS(3)+DEPO)**2)
      IF(ABS(DEP-DEPO)/DEP.LE.0.01) GO TO 3
      DEPO = DEP
      GO TO 4
C
   21 MSGVAL = NTRY
      AMSGV1 = DEPO
      AMSGV2 = DEP
      CALL LGMESG( 10,1)
C
    3 RETURN
      END

C   16/07/85 507170002  MEMBER NAME  SEPCOM   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SEPCMD( CHARS, NFIELD, ISTAFL, IENDFL , NEXFLD, NEWNEX)
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  16/07/85 :  SEPARATE OFF THE NEXT COMMAND
C
C
C     THIS ROUTINE FINDS THE NEXT COMMAND IN THE BUFFER 'CHARS' WHICH
C     BEGINS AT POSITION ISTAFL(NEXFLD) AND ENDS AT THE NEXT ';'.
C     ON RETURN  NEWNEX CONTAINS THE NEXT STARTING POSITION.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS(80), CSEMIC
C
      DIMENSION  ISTAFL(80), IENDFL(80)
C
      DATA  CSEMIC/';'/
C
C-------------------  C O D E  -----------------------------------------
C
      DO  10  I = NEXFLD,NFIELD
        ISTA = ISTAFL(I)
        IEND = IENDFL(I)
        DO  6  J = ISTA,IEND
          IF( CHARS(J) .NE. CSEMIC ) GO TO 6
            NEWNEX = I
            RETURN
   6    CONTINUE
  10  CONTINUE
C
C                            NO SEMI-COLON FOUND ==> END OF BUFFER
C
      NEWNEX = NFIELD + 1
      RETURN
      END

C   03/04/79 406081642  MEMBER NAME  LINDIS   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE LINDIS(IPO,INDEX,XC,YC,ZC)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON   25/02/79 :  DRAW A STRAIGHT LINE FOR TRACK
C
C       MOD:   J. OLSSON   17/02/84 :
C  LAST MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C
C     STRAIGHT LINE FIT DISPLAY FOR THE JADE DETECTOR
C     IPO IS CURRENT TRACK POINTER
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
C
#include "cgraph.for"
#include "cgeo1.for"
#include "cdata.for"
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CJTRIG / PI,TWOPI
C
      DATA DUM1 /0./
C
C-----------------------------------------------------------------------
C
C  R-Z FIT          Z = A + B*R
C
C  SET VARIABLES
C
      ITR = IDATA(IPO+1)
C  LINE PARAMETERS
      A = ADATA(IPO+31)
      B = ADATA(IPO+30)
C  START POINT
      XB = ADATA(IPO+ 5)
      YB = ADATA(IPO+ 6)
      ZB = ADATA(IPO+ 7)
C  END POINT
      XE = ADATA(IPO+12)
      YE = ADATA(IPO+13)
      ZE = ADATA(IPO+14)
C  SIZE OF VIEW/TRACKLENGTH
      ZZPL = ZLGPL
      ZZPL1 = ZENDPL
      RTS = RLG
      IF(LASTVW.EQ.4.OR.LASTVW.EQ.8) RTS = RTOF
      IF(LASTVW.EQ.18.OR.LASTVW.EQ.19) RTS = .33*(XMAX-XMIN)
      IF(LASTVW.EQ.18.OR.LASTVW.EQ.19) ZZPL = RTS
      IF(LASTVW.EQ.18.OR.LASTVW.EQ.19) ZZPL1 = RTS
      IF(.NOT.DSPDTL(19).OR.LSTCMD.EQ.52) GO TO 1557
C ENTER HERE ONLY IF TRACKS ARE PROLONGED TO BEAM AXIS OR CLOSEST POINT
      APA = ADATA(IPO+19)
      BPA = ADATA(IPO+20)
      CPA = ADATA(IPO+21)
      DPA = ADATA(IPO+22)
      ITYPPA = IDATA(IPO+18)
C---
C---    FIND MINIMUM DISTANCE RP OF PARABOLA (A B C D) FROM ORIGIN
C---    THE PARAMETERS ARE: A = ANGLE BETWEEN LOCAL X-AXIS AND DETECTOR
C---                        B = X COORDINATE OF LOCAL MINIMUM POINT.
C---                        C = Y COORDINATE OF LOCAL MINIMUM POINT.
C---                        D = PARABOLA PARAMETER IN  Y = D * X*X
C---
C---
      IF(ITYPPA.NE.2) GO TO 1009
C--PARABOLA FIT
      COSA = COS(APA)
      SINA = SIN(APA)
C--
C-- FIND POINT OF CLOSEST APPROACH TO ORIGIN, BY SOLVING 3D DEGREE EQUA-
C-- TION ARISING FROM THE CONDITION D/DX (DIST)  =  0
C-- USE CARDAN'S FORMULA
C--
      RMIN = 10000.
      Q = -BPA*COSA - CPA*SINA
      P =  BPA*SINA - CPA*COSA
      P = (1. - 2.*DPA*P)/(6.*DPA*DPA)
      Q = - Q/(4.*DPA*DPA)
      DET = Q*Q + P*P*P
      IF(DET.GT.0) GO TO 5700
C DET < 0,  3 REAL SOLUTIONS
      BIGR = SQRT(ABS(P))
      IF(Q.LT.0.) BIGR = - BIGR
      COSFI = Q/(BIGR**3)
      FIHELP = ARCOS(COSFI)
      IF(FIHELP.LT.0.) FIHELP = FIHELP + TWOPI
      FIHELP = FIHELP/3.
      BIGR = -2.*BIGR
      Y1 = BIGR*COS(FIHELP)
      Y2 = BIGR*COS(FIHELP+TWOPI/3.)
      Y3 = BIGR*COS(FIHELP+2.*TWOPI/3.)
      XPB = AMIN1(Y1,Y2,Y3)
      GO TO 5701
5700  DET = SQRT(DET)
      SUGN = 1.
      IF(-Q+DET.LT.0.) SUGN = -1.
      U = (((-Q+DET)*SUGN)**.3333333)*SUGN
      SUGN = 1.
      IF(-Q-DET.LT.0.) SUGN = -1.
      V = (((-Q-DET)*SUGN)**.3333333)*SUGN
      XPB = U+V
5701  YPB = DPA*XPB*XPB
      X0 = (XPB)*COSA - (YPB)*SINA + BPA
      Y0 = (XPB)*SINA + (YPB)*COSA + CPA
      RMIN = SQRT(X0*X0 + Y0*Y0)
      GO TO 1011
1009  CONTINUE
C  CIRCLE FIT
      RMIN = ABS(BPA)
      X0 = RMIN*COS(CPA)
      Y0 = RMIN*SIN(CPA)
1011  RMINN = RMIN
      IF((INDEX.LT.8.OR.INDEX.EQ.80).AND.X0*XB.LT.0.) RMINN = -RMINN
      IF(INDEX.GT.7.AND.INDEX.NE.80.AND.Y0*YB.LT.0.) RMINN = - RMINN
      Z0 = A + B*RMINN
      GO TO 1558
1557  CONTINUE
      X0 = XC
      Y0 = YC
      Z0 = ZC
1558  CONTINUE
C                    START POINT
      ZETS = ZB
      IF(DSPDTL(19)) ZETS = Z0
      IF(LSTCMD.EQ.52) ZETS = ZC
      IF(DSPDTL(19).AND.LSTCMD.NE.52) GO TO 22
      XXX = XB
      YYY = YB
      IF(LSTCMD.NE.52) GO TO 1774
      XXX = XC
      YYY = YC
1774  IF(DSPDTL(9)) GO TO 1
C  PROJECT MODE
      XYS = XXX
      IF(INDEX.GT.7.AND.INDEX.NE.80) XYS = YYY
      GO TO 2
C  ROTATE MODE
1     XYS = SQRT(XXX*XXX+YYY*YYY)
      IF(INDEX.GT.7.AND.INDEX.NE.80) XYS = SIGN(XYS,YYY)
      IF(INDEX.LT.8.OR.INDEX.EQ.80) XYS = SIGN(XYS,XXX)
C     IF(YYY.LT.0..AND.INDEX.GT.7) XYS = - XYS
C     IF(XXX.LT.0..AND.INDEX.LT.8) XYS = - XYS
      GO TO 2
C ENTER HERE FOR DSPDTL(19) ON, TRACK PROLONGATION
22    IF(DSPDTL(9)) GO TO 9701
C  PROJECT MODE
      XYS = X0
      IF(INDEX.GT.7.AND.INDEX.NE.80) XYS = Y0
      GO TO 2
C  ROTATE MODE
9701  XYS = RMIN
      IF((INDEX.LT.8..OR.INDEX.EQ.80).AND.X0.LT.0.) XYS = - XYS
      IF(INDEX.GT.7.AND.INDEX.NE.80.AND.Y0.LT.0.) XYS = - XYS
C     IF(INDEX.LT.8.AND.X0*XB.LT.0.) XYS = - XYS
C     IF(INDEX.GT.7.AND.Y0*YB.LT.0.) XYS = - XYS
C
 2    CONTINUE
C      IF(DSPDTM(30)) WRITE(6,1202) INDEX,DSPDTL(9),X0,Y0,Z0
C1202  FORMAT(' INDX DSP9 XYZ0 ',2I3,3E12.4)
C      IF(DSPDTM(30)) WRITE(6,1203) RMIN,XYS,XB,YB
C1203  FORMAT(' RMN XYS X-YB ',4E12.4)
C
C                    END POINT
C
      ZETE = ZE
      IF(DSPDTL(9)) GO TO 3
C PROJECT MODE
      XYE = XE
      IF(INDEX.GT.7.AND.INDEX.NE.80) XYE = YE
      IF(.NOT.DSPDTL(23).AND.LASTVW.NE.18.AND.LASTVW.NE.19) GO TO 4
      XYRR = SQRT(XYE**2+ZETE**2)
      IF(XYRR.LE.RTS) GO TO 4
      GO TO 44
C  ROTATE MODE
3     XYE = SQRT(XE*XE+YE*YE)
      IF(YE.LT.0..AND.INDEX.GT.7.AND.INDEX.NE.80) XYE = - XYE
      IF(XE.LT.0..AND.(INDEX.LT.8.OR.INDEX.EQ.80)) XYE = - XYE
      IF(.NOT.DSPDTL(23).AND.LASTVW.NE.18.AND.LASTVW.NE.19) GO TO 4
      XYRR = SQRT(XYE**2+ZETE**2)
      IF(XYRR.LE.RTS) GO TO 4
44    ZETE = A + B*RTS
      IF(LSTCMD.NE.52) GO TO 670
      RCC = SQRT(XC*XC+YC*YC+0.00001)
      REE = SQRT(XE*XE+YE*YE+0.00001)
      ACC = (ZE*RCC - ZC*REE)/(RCC - REE)
      BCC = (ZC - ZE)/(RCC-REE)
      ZETE=ACC + BCC*RTS
670   XYE = RTS
      IF(ABS(ZETE).LT.ZZPL) GO TO 33
      ZETE = SIGN(ZZPL1,ZETE)
      IF(ABS(B).LT..00000001) GO TO 33
      XYE = ABS((ZETE-A)/B)
      IF(LSTCMD.EQ.52) XYE = ABS((ZETE-ACC)/BCC)
33    IF(YE.LT.0..AND.INDEX.GT.7.AND.INDEX.NE.80) XYE = - XYE
      IF(XE.LT.0..AND.(INDEX.LT.8.OR.INDEX.EQ.80)) XYE = - XYE
4     CALL MOVEA(ZETS,XYS)
      CALL DRAWA(ZETE,XYE)
C  -ZETE IN TRNUMB CALL, COMPENSATES INTRINSIC -SIGN, HISTORICAL REASONS
      CALL TRNUMB(ITR,0,-ZETE,XYE,DUM1)
      RETURN
      END

C   18/05/79 807031524  MEMBER NAME  WERTEX   (JADEGS)      FORTRAN
      SUBROUTINE VERTEX
C*800623*DITTMANN****************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VERTEX)   18.9.86
C*                                                                  *
C*    THIS VERSION WAS INSTALLED AS A FORERUNNER OF THE NEW VERTEX- *
C*    PACKAGE. THE LATTER WAS RELEASES IN WINTER 87/88 AND DEVIATES *
C*    CONSIDERABLY FROM THE PRESENT MEMBER WERTEX. SINCE WERTEX IS  *
C*    STILL USED FOR BACKWARD COMPATIBILITY, IT IS KEPT ON JADEGS/GL*
C*    THERE IS HOWEVER NOW A CONFLICT WITH THE OLD MACRO MEMBERS ON *
C*    F11GOD.PATRECSR: THESE ARE THE ONES USED IN THIS MEMBER WERTEX*
C*    AND ARE DIFFERENT FROM THE MACROS WITH THE SAME NAMES WHICH   *
C*    ARE SITUATED ON F22KLE.VERTEX.S AND USED IN THE NEW VERSIONS  *
C*    OF THE ROUTINES. FOR THIS REASONS, ALL MACROS IN THIS MEMBER  *
C*    WERE EXPANDED ON 3.7.88. A ROUTINE USED INTERNALLY ONLY HAS   *
C*    BEEN RENAMED:   VTXCRV IS NOW WTXCRV                          *
C*                                                 J.O.  3.7.88     *
C*                                                                  *
C*  UPDATES :  860217 C.K. : PROPER ERRORS DDX,DDY (SPHI,CPHI)      *
C*                           (SPHI,CPHI -DEPENDENCE) INTRODUCED     *
C*                                                                  *
C*  UPDATES :  860316 C.K. : PROPER ERRORS DXY,DPHI INTRODUCED      *
C*                           ( ACCOUNTING OF CURVATURE-ERROR )      *
C*                                                                  *
C*  MODIFICATION OF 20.5.86                  KLE/RAM                *
C*  MAX NO OF TRACKS FOR VERTEX-FIT NOW 20 ( OLD 7)                 *
C*  COMMON CWORK1 NOW IN MACRO MVERTEX                              *
C*  MODIFICATION OF 27.5.86                  KLE/RAM                *
C*  MODES 2, 3, 4 AND STATISTICS                                    *
C*                                                                  *
C*  MODIFICATION OF 03.06.86                 KLE                    *
C*     END OF ITERAION IF MAX(|DS|) NOT SUM(|DS|) < DSCONV          *
C*                                                                  *
C*    +++ BIG MODIFICATION +++                    860611 C.K.       *
C*                                                                  *
C*    * FOR EACH TRACK NOW 40 INSTEAD OF 30 WORDS IN T()            *
C*                                                                  *
C*    * FITS IN RPHI AND ZS ARE TREATED INDEPENDENT                 *
C*      ( DIFFERENT FIRST POINT, MULT. SCATTERING POSSIBLE,         *
C*        THIS IS NECCESSARY FOR 'COMFIT'TED TRACKS         )       *
C*                                                                  *
C*    +++ END MODIFICATION +++                                      *
C*                                                                  *
C*    - HELIX- AND ERROR-CALCULATIONS WITH VTXS (SEE VTXPNT)        *
C*                                                                  *
C%MACRO VTXDEF
C********************************************************************
C*                                                                  *
C*             X - Y - Z   V E R T E X   F I T                      *
C*                                                                  *
C*       INPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)            *
C*       ================                                           *
C*       NT    = TOTAL NR OF TRACKS OF EVENT                        *
C*       IT(1) =         FLAG (0 = TRACK INCOMPLETE OR BAD, NOT USED*
C*                             1 = GOOD, BUT DO NOT USE IN VERTEXFIT*
C*                             2 = GOOD)                            *
C*       T( 2) = +-R     RADIUS(+ MEANS ANTICLOCKWISE LOOKING TO -Z)*
C*          3  = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          4  = THETA   POLAR ANGLE TO XY-PLANE(0=VERTICAL TO BEAM)*
C*          5  = XT      .                                          *
C*          6  = YT      . FIRST MEASURED POINT ON TRACK            *
C*          7  = ZT      .                                          *
C*          8  = DPHI    ERROR OF PHI                               *
C*          9  = DTHETA  ERROR OF THETA                             *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         13  = NPT     NUMBER OF POINTS ON TRACK (INTEGER)        *
C*         14  = 0       NOT USED ON INPUT                          *
C*         15  = S0      INITIAL ARCLENGTH ( = 0. OR CLOSEST        *
C*                          APPROACH TO RUNVERTEX )                 *
C*         16-40         FOR INTERNAL USE (SEE BELOW)               *
C*        (41-80)        2. TRACK                                   *
C*         .....         ........                                   *
C*                                                                  *
C*       OUTPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)           *
C*       =================                                          *
C*       FOR TRACKS WITH IT(1) GT 0                                 *
C*       IT(1) =         FLAG (3 = TRACK WAS USED IN VERTEXFIT)     *
C*       T( 3) = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          5  = XT      .                                          *
C*          6  = YT      . POINT ON TRACK NEAREST TO VERTEX         *
C*          7  = ZT      .                                          *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         14  = NV      NUMBER OF VERTEX TO WHICH TRACK BELONGS (I)*
C*         15  = S       EXTRAPOLATED ARC LENGTH (USUALLY NEGATIVE) *
C*       ALL OTHER T'S ARE UNCHANGED                                *
C*                                                                  *
C*       NV    = TOTAL NUMBER OF VERTICES                           *
C*       IV(1) =         FLAG (0 = NO VERTEX FIT                    *
C*                             1 = BAD VERTEX FIT                   *
C*                             2 = VERTEX OF 1- OR COLLINEAR 2-PRONG*
C*                             3 = GOOD VERTEX FIT                  *
C*                             4 = E+E- PAIR VERTEX                 *
C*                             5 = ISOLATED SINGLE TRACK VERTEX)    *
C*       V( 2) = X       .                                          *
C*          3  = Y       . VERTEX COORDINATES                       *
C*          4  = Z       .                                          *
C*          5  = DX      .                                          *
C*          6  = DY      . ERROR OF X,Y,Z                           *
C*          7  = DZ      .                                          *
C*       IV(8) = NTR     NUMBER OF TRACKS USED IN VERTEX FIT        *
C*       V( 9) = CHI2    CHISQARE OF FIT (N.D.F. = 2*NTR-3)         *
C*       IV(10)= NTRALL  NUMBER OF TRACKS BELONGING TO THIS VERTEX  *
C*        (11-20)        2. VERTEX                                  *
C*         .....         .........                                  *
C*                                                                  *
C*       INTERNAL PARAMETERS                                        *
C*       ===================                                        *
C*       IT(1) IS SET NEGATIV TEMPORARILY IF TRACK BELONGS TO VERTEX*
C*       T(16) = COULOMB SCATTERING ERROR ( TANKWALL )              *
C*       T(17) = COULOMB SCATTERING ERROR ( NEW BEAMPIPE ONLY )     *
C*       T(18) = S TO TANKWALL NEAR                                 *
C*       T(19) = S TO BEAMPIPE NEAR                                 *
C*       T(20) = PROJ. TRACKLENGTH IN RPHI                          *
C*       T(21) = SIN(PHI0)                                          *
C*       T(22) = COS(PHI0)                                          *
C*       T(23) = TAN(THETA)                                         *
C*       T(24) = COS(THETA)                                         *
C*       T(25)   UNUSED                                             *
C*       T(26) = S TO TANKWALL FAR                                  *
C*       T(27) = S TO TANKWALL NEAR                                 *
C*       T(28) = S.D. X                                             *
C*       T(29) = S.D. Y                                             *
C*       T(30) = S.D. Z                                             *
C*                                                                  *
C*       NEW INTERNAL PARAMETERS ( 31 - 40 )               BY KLE   *
C*       -----------------------                                    *
C*       IT(31)= 1 FOR 'COMFIT'TED TRACKS, 0 ELSE                   *
C*                                      ( COVAR. DEFAULTS :   )     *
C*       T(32) = RPHI COVARIANCE : X**4 ( 180 SIG**2/N / L**4 )     *
C*       T(33) = RPHI COVARIANCE : X**3 ( 0.0 )                     *
C*       T(34) = RPHI COVARIANCE : X**2 ( -18 SIG**2/N / L**2 )     *
C*       T(35) = RPHI COVARIANCE : X**1 ( 0.0 )                     *
C*       T(36) = RPHI COVARIANCE : X**0 ( 9/4 SIG**2/N )            *
C*       T(37) = SIG**2/NPT IN ZS                                   *
C*       T(38) = PROJ. TRACKLENGTH IN ZS                            *
C*       T(39) = S0(ZS) - S0(RPHI)                                  *
C*       T(40) = COVARIANCE TERM FOR ANGULAR ERROR                  *
C*                                                                  *
C********************************************************************
C*                                                                  *
C*   MODES :                                                        *
C*  =========                                                       *
C*   BIT 31 ON --> STARTPOINT IS RUNVERTEX ( NOT FIRST MEASURED )   *
C*   BIT 30 ON --> RUNVERTEX CONSTRAIN                              *
C*   BIT 29 ON --> AXIS CONSTRAIN                                   *
C*   BIT 28 ON --> FITS IN RPHI AND Z ARE INDEPENDENT               *
C*   BIT 27 ON --> LOCAL STATISTICS FROM VERTEX                     *
C*   BIT 26 ON --> OVERWRITE PATR-BANK FOR TYP 2 WITH HELIX-        *
C*                 PARAMETERS                                       *
C*   BIT 25 ON --> MESSAGE FROM VTXEE IF FAILED                     *
C*                                                                  *
C********************************************************************
C*                                                                  *
C*       THIS ROUTINE CALLS SUBROUTINE SMINVD FOR SOLVING THE       *
C*       MATRIX EQUATION                                            *
C*                                                                  *
C*       MAINING OF TAXIS:                                          *
C*              1,2,3: X,Y,Z OF RUN-VERTEX                          *
C*              4,5,6: DX**2,DY**2,DZ**2 ERROR**2 OF RUN-VERTEX     *
C*              7,8,9: EX,EY,EZ UNIT-VECTOR OF CONSTRAIN-AXIS       *
C*              10,11,12: ERROR**2 OF CONSTRAIN-AXIS                *
C*                                                                  *
C*                                                                  *
C*   FOR DETAILS OF STATISTICS SEE VTXSTA                           *
C*                                                                  *
C********************************************************************
      IMPLICIT INTEGER*2 (H)
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR
C
      REAL*8 A,B,DET
C
      LOGICAL LWARN
      LOGICAL LOR, LAXIS, LRVCON, LRVST, LNOZ, LOCSTA
C**
      DATA NCALL / 0 /,LWARN / .TRUE. /
C
      LRVST  = TBIT(MODE,31)
      LRVCON = TBIT(MODE,30)
      LAXIS  = TBIT(MODE,29)
      LNOZ   = TBIT(MODE,28)
      LOCSTA = TBIT(MODE,27)
      LOR    = LRVCON .OR. LAXIS
C
      IERR = 1
      IF(NV.LE.0 .OR. NV.GT.20) GOTO 100
C
      NCALL = NCALL + 1
      IF (NCALL.EQ.1) WRITE(6,9000)
 9000 FORMAT(/
     &' *** NEW VERSION OF VERTEX-PACKAGE IS RUNNING. 24.7.86 C.K. ***'/
     &' ( 40 WORDS PER TRACK IN T(), XY-ERRORS FROM COVARIANCE MATRIX )'
     &/)
      IF (NCALL.EQ.1 .AND. LAXIS) WRITE(6,9001)
 9001 FORMAT(
     & ' *******  SPECIAL VERSION OF VTXPRE/VERTEX  ********',/
     & ' *******     AXIS-CONSTRAINT IS RUNNING     ********'/)
      IF (NCALL.EQ.1 .AND. LRVCON) WRITE(6,9002)
 9002 FORMAT(
     & ' *******  SPECIAL VERSION OF VTXPRE/VERTEX  ********',/
     & ' *******   RUNVERTEX-CONSTRAINT IS RUNNING  ********'/)
C
      LV = (NV-1)*10
      IV(LV+1) = 0
      IERR = 2
      IF(NT.LE.0) GOTO 100
C**
      IF(.NOT.LOR) GOTO 55
         TERR = TAXIS(4)*TAXIS(5)*TAXIS(6)
         IF(TERR .GT. 0.0) GOTO 55
         IF(LWARN) WRITE(6,881)
 881     FORMAT(/' ==== WARNING FROM VERTEX: TAXIS NOT SET',
     &          ' , BUT REQUIRED --> FLAG IGNORED ==== '/)
         LWARN  = .FALSE.
         LAXIS  = .FALSE.
         LRVCON = .FALSE.
 55   CONTINUE
C**
      NREJ  = 0
      NREJV = 0
C                                           ITERATION-LOOP
    1 CONTINUE
      NTRV = 0
      ITER = 0
      CHI2 = 0.
      ITFIN = 0
C                                           CHECK TRACKS
C                                           IF MORE THAN 20,REJECT
C                                           WITH FEWEST MEASURED POINTS
      N = 0
      J = 0
      DO 5 I=1,NT
         IF(IT(J+1).LE.1) GOTO 5
         N = N + 1
         IF(N.GT.20) GOTO 2
            K = N
            GOTO 4
    2    MINPT = 48
         DO 3 K=1,20
            L = NTIND(K)
            IF(IT(L+13).GE.MINPT) GOTO 3
            IMIN = K
            MINPT = IT(L+13)
    3    CONTINUE
         IF(IT(J+13).LE.MINPT) GOTO 5
         K = IMIN
    4    NTIND(K) = J
C        S(K) = 0.
         S(K) = T(J+15)
    5    J = J + 40
C**
      SVR  = 0.0
      DSMAX = 0.0
      IMAX = 0
C**
      IF(N.GT.20) N=20
      NTR = N
      B(1) = 0.0D0
      B(2) = 0.0D0
      IF (LAXIS) N = N + 1
      IERR = 3
      IF(N.LE.0) GOTO 100
      IF (LRVCON) GOTO 10
      IERR = 8
      IF(N.EQ.1) GOTO 50
      IF(N.NE.2) GOTO 10
C                                           CHECK IF COLLINEAR 2-PRONG
      J1 = NTIND(1)
      J2 = NTIND(2)
      COSW = T(J1+24)*T(J2+24) * (T(J1+21)*T(J2+21)+T(J1+22)*T(J2+22))
     *       + SIN(T(J1+4))*SIN(T(J2+4))
      COSW = ABS(COSW)
      IERR = 9
      IF(COSW.GT.COLL2) GOTO 50
C
C                                           VERTEX FIT
   10 CONTINUE
         N = NTR + 3
C**
         IF (LOR) N = N + 1
C**
         L = (N*(N+1))/2
         DO 11 I=1,L
   11       A(I) = 0.D0
         IF(ITFIN.EQ.1) GOTO 13
            DO 12 I=1,N
   12          B(I) = 0.D0
   13    CONTINUE
C**
         IF(.NOT.LOR) GOTO 130
            DDAX = 1./(TAXIS(4) + SVR**2*TAXIS(10))
            DDAY = 1./(TAXIS(5) + SVR**2*TAXIS(11))
            DDAZ = 1./(TAXIS(6) + SVR**2*TAXIS(12))
            XAXIS = TAXIS(1) + SVR*TAXIS(7)
            YAXIS = TAXIS(2) + SVR*TAXIS(8)
            ZAXIS = TAXIS(3) + SVR*TAXIS(9)
            DDAZZ = DDAZ
            IF (LNOZ) DDAZ = 0.
 130     CONTINUE
C**
         DO 19 I=1,NTR
            J = NTIND(I)
            N = I + 3
            L = (N*(N-1))/2
C
C   VTXS IS AN ENTRY POINT IN VTXPNT      J.O. COMMENT
C
            CALL VTXS(J,S(I),XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,DPHIT)
C
            SPHI = SIN(PHIT)
            CPHI = COS(PHIT)
C
            DDX = 1. / DXT2
            DDY = 1. / DYT2
            DDZ = 1. / DZT2
C
            DDZZ = DDZ
            IF (LNOZ) DDZ = 0.
            IF(ITFIN.EQ.0) GOTO 15
               IT(J+1) = 3
               CHITR(I) = DDX*(XT-B(1))**2 + DDY*(YT-B(2))**2
     &                                     + DDZ*(ZT-B(3))**2
               CHI2 = CHI2 + CHITR(I)
               IF ((T(J+5)**2+T(J+6)**2).LT.RTANK**2) NTRV = NTRV + 1
               GOTO 16
   15       CONTINUE
            B(1) = B(1) + DBLE(XT)*DBLE(DDX)
            B(2) = B(2) + DBLE(YT)*DBLE(DDY)
            B(3) = B(3) + DBLE(ZT)*DBLE(DDZZ)
            B(N) = - XT*CPHI*DDX - YT*SPHI*DDY - ZT*T(J+23)*DDZ
   16       A(1) = A(1) + DDX
            A(3) = A(3) + DDY
            A(6) = A(6) + DDZZ
            A(L+1) = -CPHI*DDX
            A(L+2) = -SPHI*DDY
            A(L+3) = -T(J+23)*DDZ
            A(L+N) = CPHI**2*DDX + SPHI**2*DDY + T(J+23)**2*DDZ
   19    CONTINUE
C**
         IF (.NOT.LOR) GOTO 200
            N = NTR + 4
            L = N*(N-1)/2
            IF(ITFIN .EQ. 1) GOTO 190
               B(1) = B(1) + DBLE(XAXIS)*DBLE(DDAX)
               B(2) = B(2) + DBLE(YAXIS)*DBLE(DDAY)
               B(3) = B(3) + DBLE(ZAXIS)*DBLE(DDAZZ)
               B(N) = - XAXIS*TAXIS(7)*DDAX
     &                - YAXIS*TAXIS(8)*DDAY
     &                - ZAXIS*TAXIS(9)*DDAZ
  190       CONTINUE
            A(1) = A(1) + DDAX
            A(3) = A(3) + DDAY
            A(6) = A(6) + DDAZZ
            A(L+1) = -TAXIS(7)*DDAX
            A(L+2) = -TAXIS(8)*DDAY
            A(L+3) = -TAXIS(9)*DDAZ
            A(L+N) = TAXIS(7)**2*DDAX +
     &               TAXIS(8)**2*DDAY +
     &               TAXIS(9)**2*DDAZ
  200    CONTINUE
C**
         IF(ITFIN.EQ.1) GOTO 30
C                                          SOLVE MATRIX EQUATION
C======
C        WRITE(6,8990)ITFIN,N
C8990    FORMAT(' ---> FOR SMINVD ITFIN,N: ',2I5)
C        WRITE(6,8997)(A(JJ),JJ= 1,L)
C8997    FORMAT(' A: ',9G13.4)
C        WRITE(6,8998)(B(JJ),JJ= 1,N)
C8998    FORMAT(' B: ',9G13.4)
C========
         CALL SMINVD(A,B,N,1,DET)
         IERR = 4
         IF(DET.EQ.0.0) GOTO 100
C======
C        WRITE(6,8928)(B(JJ),JJ= 1,N)
C8928    FORMAT(' B  ',9G13.4)
C========
         DSUM  = 0.
         DSMAX = 0.
         IMAX  = 0
         DO 23 I=1,NTR
            J = NTIND(I)
            DS  = B(I+3)
            ADS = ABS(DS)
            IF(ABS(DS/T(J+2)).GT.1.5) GOTO 25
            DSUM = DSUM + ADS
            S(I) = S(I) + DS
            T(J+15) = S(I)
            IF (ADS.LE.DSMAX) GOTO 23
               IMAX = I
               DSMAX = ADS
   23    CONTINUE
C**
         IF (.NOT.LAXIS) GOTO 230
            DS = B(NTR + 4)
            ADS = ABS(DS)
            DSUM = DSUM + ADS
            SVR = SVR + DS
            IF (ADS.LE.DSMAX) GOTO 230
               IMAX = -IMAX
               DSMAX = ADS
  230    CONTINUE
C**
         ITER = ITER + 1
CHANGED  IF(ITER.LT.MITER .AND. DSUM.GT.DSCONV) GOTO 10
         IF(ITER.LT.MITER .AND. DSMAX.GT.DSCONV) GOTO 10
C                                          FIT FINISHED, REPEAT ONCE
C                                          MORE WITH PROPER ERRORS
         ITFIN = 1
C
      GOTO 10
C                         EXTRAPOLATION OF TRACK I EXCEEDS 90 DEG
C                         REMOVE TRACK AND RESTART IF MORE THAN ONE LEFT
   25 IERR = 5
      IF(NTR.LE.2) GOTO 100
      IT(J+1) = 1
      NREJ = NREJ + 1
      IF ((T(J+5)**2+T(J+6)**2).LT.RTANK**2) NREJV = NREJV + 1
C
      GOTO 1
C
   30 CALL SMINVD(A,DUMMY,N,0,DET)
      IERR = 6
      IF(A(1).LT.0.0 .OR. A(3).LT.0.0 .OR. A(6).LT.0.0) GOTO 100
      NDF = 2*NTR - 3
      IF (LNOZ) NDF = NTR - 2
C**
      IF (.NOT.LOR) GOTO 300
         NDF = NDF + 2
         CHI2 = CHI2 + DDAX*(XAXIS-B(1))**2
     &               + DDAY*(YAXIS-B(2))**2
     &               + DDAZ*(ZAXIS-B(3))**2
 300  CONTINUE
C**
      PR = 1.
      IF (NDF.GT.0) PR = PROB(CHI2,NDF)
      IV(LV+1) = 1
      IF(PR.GT.PRCUT) IV(LV+1)=3
      V(LV+2) = B(1)
      V(LV+3) = B(2)
      V(LV+4) = B(3)
      V(LV+5) = DSQRT(A(1))
      V(LV+6) = DSQRT(A(3))
      V(LV+7) = DSQRT(A(6))
      IV(LV+8) = NTR
      V(LV+9) = CHI2
      IERR = -1
      IF(IREJTR.EQ.0) GOTO 100
      IF(IV(LV+1).EQ.3) GOTO 100
      IERR = 7
      IF(NTR.LE.2) GOTO 100
C                                         BAD CHISQUARE
C                                         CHECK IF THERE IS ONE TRACK
C                                         WHICH CONTRIBUTES MOST TO CHI200047300
      CHIMAX = 0.
      DO 32 I=1,NTR
         IF(CHITR(I).LT.CHIMAX) GOTO 32
         CHIMAX = CHITR(I)
         NTMAX = I
   32 CONTINUE
      CHICUT = 3. / NTR
      IF(CHICUT.GT..9) CHICUT=.9
      CHICUT = CHICUT * CHI2
      IERR = 0
      IF(CHIMAX.LT.CHICUT) GOTO 100
      J = NTIND(NTMAX)
      IT(J+1) = 1
      NREJ = NREJ + 1
      IF ((T(J+5)**2+T(J+6)**2).LT.RTANK**2) NREJV = NREJV + 1
C
      GOTO 1
C
C                                           1-PRONG OR COLLINEAR 2-PRONG
C
   50 CONTINUE
      IV(LV+1) = 2
      J = NTIND(1)
      CALL VTXPNT(J,XB,YB,XT1,YT1,ZT1,DXT21,DYT21,DZT21,PHIT,DPHIT,ST)
      IT(J+1) = 3
      IF(NTR.EQ.2) GOTO 52
      V(LV+2) = XT1
      V(LV+3) = YT1
      V(LV+4) = ZT1
      V(LV+5) = SQRT(DXT21)
      V(LV+6) = SQRT(DYT21)
      V(LV+7) = SQRT(DZT21)
      IV(LV+8) = 1
      V(LV+9) = 0.
      IV(LV+10) = 1
      GOTO 100
   52 J = NTIND(2)
      CALL VTXPNT(J,XB,YB,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT,DPHIT,ST)
      IT(J+1) = 3
      V(LV+2) = (XT1+XT2)/2.
      V(LV+3) = (YT1+YT2)/2.
      V(LV+4) = (ZT1+ZT2)/2.
      V(LV+5) = SQRT((DXT21+DXT22)/2.)
      V(LV+6) = SQRT((DYT21+DYT22)/2.)
      V(LV+7) = SQRT((DZT21+DZT22)/2.)
      IV(LV+8) = 2
      V(LV+9) = 0.
      IV(LV+10) = 2
      SDXY1 = SQRT(((XT1-V(LV+2))**2/DXT21 + (YT1-V(LV+3))**2/DYT21)/2.)
      IF(SDXY1.GT.3.) IV(LV+1)=1
      SDXY2 = SQRT(((XT2-V(LV+2))**2/DXT22 + (YT2-V(LV+3))**2/DYT22)/2.)
      IF(SDXY2.GT.3.) IV(LV+1)=1
      SDZ1 = ABS(ZT1-V(LV+4))/SQRT(DZT21)
      IF(SDZ1.GT.3.) IV(LV+1)=1
      SDZ2 = ABS(ZT2-V(LV+4))/SQRT(DZT22)
      IF(SDZ2.GT.3.) IV(LV+1)=1
C
  100 CONTINUE
      IF (.NOT.LOCSTA) GOTO 120
      IF (IERR.LE.0) GOTO 110
      CALL VTXERR(IERR)
      GOTO 120
  110 CONTINUE
      WRITE(6,9345) LRVST,LRVCON,LAXIS,LNOZ,NTR,NTRV,NREJ,NREJV,
     &              ITER,DSMAX,NDF,CHI2
 9345 FORMAT(' START AT RV, RV-CON., AXIS-CON., NO Z : ',4L2/
     &       ' NTR,NREJ           : ',4I6/
     &       ' ITER,DSMAX,NDF,CHI2 : ',I6,G13.4,I6,G13.4)
C
  120 CONTINUE
      HVTXST( 1) = IERR
      HVTXST(19) = ITER
      IDSMAX = 30000
      IF (DSMAX.LT.30.) IDSMAX = IFIX( DSMAX * 1000. )
      HVTXST(20) = IDSMAX
      HVTXST( 2) = HVTXST(2) + 1
      HVTXST(4+IERR) = HVTXST(4+IERR) + 1
      IF (LRVST)  HVTXST(14) = HVTXST(14) + 1
      IF (LRVCON) HVTXST(15) = HVTXST(15) + 1
      IF (LAXIS)  HVTXST(16) = HVTXST(16) + 1
      IF (LNOZ)   HVTXST(17) = HVTXST(17) + 1
      IF (IERR.GT.0) RETURN
C
      HVTXST(18) = IFIX(PR*10000.)
      IF (NTR .GT.19) NTR  = 19
      IF (NTRV.GT.19) NTRV = 19
      HVTXST(21+NTR)  = HVTXST(21+NTR)  + 1
      HVTXST(41+NTRV) = HVTXST(41+NTRV) + 1
      IF (NREJ .GT.19) NREJ  = 19
      IF (NREJV.GT.19) NREJV = 19
      HVTXST(61+NREJ)  = HVTXST(61+NREJ)  + 1
      HVTXST(81+NREJV) = HVTXST(81+NREJV) + 1
      IF (ITER.GT.20) ITER = 20
      HVTXST(100+ITER)  = HVTXST(100+ITER)  + 1
C
      RETURN
      END
      SUBROUTINE VTXAFT
C*800124*DITTMANN***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXAFT)   18.9.86
C*                                                                 *
C*          F I N I S H   X Y Z   V E R T E X   F I T              *
C*                                                                 *
C*       CALCULATE TRACK PARAMETERS AT VERTEX-NEAREST POINT        *
C*       FOR DETAILS OF THE T,V-ARRAYS SEE COMMENT IN SUBR. VERTEX.*
C*                                                                 *
C*******************************************************************
C
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C
      IF(NV.EQ.0) RETURN
C****
C****    EXTRAPOLATE ALL TRACKS TO VERTEX
      J = 0
      DO 9 I=1,NT
      IF(IT(J+1).EQ.0) GOTO 9
      IF(IT(J+14).EQ.0) GOTO 9
      LV = (IT(J+14)-1)*10
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      T(J+3) = PHI
      T(J+5) = XT
      T(J+6) = YT
      T(J+7) = ZT
C *** CORRECT ERROR OF PHI,THETA FOR MULT. SCATTERING
      SSCOUL = SS - T(J+18)
      SSCVXC = SS - T(J+19)
      DPHMS2 = 0.
      IF ((SSCOUL.LT.0.).AND.(T(J+18).LT.0.)) DPHMS2 = T(J+16)**2
      IF (SSCVXC.LT.0.) DPHMS2 = DPHMS2 + T(J+17)**2
      T(J+8) = SQRT( DPHI**2 + DPHMS2 )
C
      SSCOUL = SS + T(J+39) - T(J+18)
      SSCOUL = SS + T(J+39) - T(J+19)
      DTHMS2 = 0.
      IF(SSCOUL.LT.0.) DTHMS2 = T(J+16)**2
      IF (SSCVXC.LT.0.) DTHMS2 = DTHMS2 + T(J+17)**2
      T(J+9) = SQRT( T(J+9)**2 + DTHMS2 )
C ***
      T(J+10) = SQRT(DXT2)
      T(J+11) = SQRT(DYT2)
      T(J+12) = SQRT(DZT2)
      T(J+15) = SS
    9 J = J + 40
C
  100 RETURN
      END
      SUBROUTINE VTXBNK(IPPATR)
C*800205*OLSSON*****************************************************
C*                                                                 *
C* C R E A T E  B A N K  GVTX  F R O M  V E R T E X  R E S U L T S *
C*                                                                 *
C*******************************************************************
C             IPPATR IS POINTER TO 'PATR' ;  SAME BOSBANK NR IS USED
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C
      IF(NV.EQ.0) GO TO 100
C****
C
      NBNK = IDATA(IPPATR-2)
      NWRES = 2 + NV*10 + NT*15
      CALL CCRE(IPHT,'GVTX',NBNK,NWRES,IERR)
      IF(IERR.NE.0) GO TO 100
      CALL BSAW(1,'GVTX')
      IDATA(IPHT+1) = NV
      DO 1  INV = 1,NV
      INVX = IPHT+1+(INV-1)*10
      ISS = (INV-1)*10
      DO 1  I = 1,10
1     IDATA(INVX+I) = IV(ISS+I)
      IDATA(IPHT+2+NV*10) = NT
C
      DO 2  INT = 1,NT
      INTX = IPHT+2+NV*10 + (INT-1)*15
      ISS = (INT-1)*40
      DO 2  I = 1,15
2     IDATA(INTX+I) = IT(ISS+I)
  100 RETURN
      END
      SUBROUTINE VTXEE
C*800604*DITTMANN********************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXEE)   18.9.86
C*                                                          *
C*              X - Y - Z    E E   P A I R S                *
C*                                                          *
C*       A DESCRIPTION OF THE T AND V ARRAYS CAN BE FOUND   *
C*       IN SUBR. VERTEX                                    *
C*860612*KLEINWORT*******************************************
C*                                                          *
C*       MODIFIED TO BE USED WITH VTXC                      *
C*                                                          *
C************************************************************
      IMPLICIT INTEGER*2(H)
C
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX
C
      IF(NT.LE.1) GOTO 100
C****
C****    LOOP OVER ALL TRACK PAIRS
      J1 = 0
      ITEST = 0
      NT1 = NT - 1
      DO 9 I=1,NT1
      IF(IT(J1+1).EQ.0) GOTO 9
      M = I + 1
      J2 = I*40
      DO 28 K=M,NT
      IPOINT = 1
      IF(IT(J2+1).EQ.0) GOTO 8
C
      ITEST  = 1
      IT1  = I
      IT2  = K
C        OPPOSITE CHARGE
      IF(T(J1+2)*T(J2+2).GT.0.) GOTO 8
C        MEASURED R-PHI OPENING
      ITEST  = 2
      DPHI = T(J1+3) - T(J2+3)
      IF(T(J1+2).LT.0.) DPHI=-DPHI
      IF(ABS(DPHI).GT.3.141593) DPHI=DPHI-SIGN(1.,DPHI)*6.283185
      IF(DPHI.LT.EEDPMN .OR. DPHI.GT.EEDPMX) GOTO 8
      ITANK = 0
      IPOINT = 2
      ITEST  = 6
      XM1 = T(J1+5) - T(J1+2)*T(J1+21)
      YM1 = T(J1+6) + T(J1+2)*T(J1+22)
      XM2 = T(J2+5) - T(J2+2)*T(J2+21)
      YM2 = T(J2+6) + T(J2+2)*T(J2+22)
      ICFT1 = IT(J1+31)
      ICFT2 = IT(J2+31)
C        EXTRAPOLATION LENGTH
      IF(T(J1+18).EQ.0. .OR. T(J2+18).EQ.0.) GOTO 6
      ITEST  = 7
      IF(T(J1+18).LT.SEMAX .OR. T(J2+18).LT.SEMAX) GOTO 6
C        PAIR ORIGIN IN TANK (ADD SQRT(2/3)*COULOMB ERROR)
      ST1 = T(J1+18)
      ST2 = T(J2+18)
C
C   VTXS IS AN ENTRY POINT IN VTXPNT       J.O.  COMMENT
C
      CALL VTXS(J1,ST1,XT1,YT1,ZT1,DXT12,DYT12,DZT12,PHIT1,DPHIT1)
      CALL VTXS(J2,ST2,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT2,DPHIT2)
C        DISTANCE IN TANK
      DPHI = PHIT1 - PHIT2
      IF(T(J1+2).LT.0.) DPHI=-DPHI
      IF(ABS(DPHI).GT.3.141593) DPHI=DPHI-SIGN(1.,DPHI)*6.283185
      PTCFT2 =
     &   (FLOAT(1-ICFT1)*(T(J1+16)**2+T(J1+17)**2)
     &   +FLOAT(1-ICFT2)*(T(J2+16)**2+T(J2+17)**2)) / 1.5
      STCFT2 = 49. * PTCFT2
      PTANK2 = (T(J1+16)**2+T(J2+16)**2+T(J1+17)**2+T(J2+17)**2) / 1.5
      STANK2 = 49. * PTANK2
      DX2 = (XT1-XT2)**2
      DY2 = (YT1-YT2)**2
      DXY = SQRT(DX2+DY2)
      DIST = SQRT((XT2-XM1)**2+(YT2-YM1)**2)
      IF(DIST.LT.ABS(T(J1+2))) DXY=-DXY
      DZ = ABS(ZT1-ZT2)
      DTH = ABS(T(J1+4)-T(J2+4))
      SDTH = DTH / SQRT(T(J1+9)**2+T(J2+9)**2+PTANK2)
      ITEST  = 3
      IF(SDTH.GT.EEDTMX) GOTO 6
      CTH = COS((T(J1+4)+T(J2+4))/2.)**2
      SDZ = DZ / SQRT(DZT12+DZT22+STANK2/CTH**2)
      ITEST  = 5
      IF(SDZ.GT.EEDTMX) GOTO 5
      SDPHI = ABS(DPHI)/SQRT(DPHIT1**2+DPHIT2**2+PTCFT2)
      ITEST  = 2
      IF(SDPHI.GT.EEDRMX) GOTO 5
      SDXY = ABS(DXY) / SQRT(1./(1./DXT12+1./DYT12)+
     *                       1./(1./DXT22+1./DYT22)+STCFT2)
      ITEST  = 4
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 5
      ITANK = 1
      GOTO 6
C
    5 CONTINUE
      IPOINT = 3
      ITEST  = 6
C        EXTRAPOLATION LENGTH
      IF(T(J1+18).EQ.0. .OR. T(J2+18).EQ.0.) GOTO 6
      ITEST  = 7
      IF(T(J1+18).LT.SEMAX .OR. T(J2+18).LT.SEMAX) GOTO 6
C        PAIR ORIGIN IN BEAMPIPE (ADD SQRT(2/3)*COULOMB ERROR)
      ST1 = T(J1+19)
      ST2 = T(J2+19)
      CALL VTXS(J1,ST1,XT1,YT1,ZT1,DXT12,DYT12,DZT12,PHIT1,DPHIT1)
      CALL VTXS(J2,ST2,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT2,DPHIT2)
C        DISTANCE IN BEAMPIPE
      DPHI = PHIT1 - PHIT2
      IF(T(J1+2).LT.0.) DPHI=-DPHI
      IF(ABS(DPHI).GT.3.141593) DPHI=DPHI-SIGN(1.,DPHI)*6.283185
      PTCFT2 = PTCFT2 +
     &   (FLOAT(ICFT1)*T(J1+17)**2+FLOAT(ICFT2)*T(J2+17)**2) / 1.5
      STCFT2 = DRPIPE(DUM)**2 * PTCFT2
      STANK2 = DRPIPE(DUM)**2 * PTANK2
      DX2 = (XT1-XT2)**2
      DY2 = (YT1-YT2)**2
      DXY = SQRT(DX2+DY2)
      DIST = SQRT((XT2-XM1)**2+(YT2-YM1)**2)
      IF(DIST.LT.ABS(T(J1+2))) DXY=-DXY
      DZ = ABS(ZT1-ZT2)
      CTH = COS((T(J1+4)+T(J2+4))/2.)**2
      SDZ = DZ / SQRT(DZT12+DZT22+STANK2/CTH**2)
      ITEST  = 5
      IF(SDZ.GT.EEDTMX) GOTO 6
      SDPHI = ABS(DPHI)/SQRT(DPHIT1**2+DPHIT2**2+PTCFT2)
      ITEST  = 2
      IF(SDPHI.GT.EEDRMX) GOTO 6
      SDXY = ABS(DXY) / SQRT(1./(1./DXT12+1./DYT12)+
     *                       1./(1./DXT22+1./DYT22)+STCFT2)
      ITEST  = 4
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 6
      ITANK = 1
C
    6 CONTINUE
      IPOINT = 4
      ITEST  = 4
C        VERTEX WHERE TRACKS ARE PARALLEL
      CALL VTXPNT
     &   (J1,XM2,YM2,XT1,YT1,ZT1,DXT12,DYT12,DZT12,PHIT1,DPHIT1,ST1)
      CALL VTXPNT
     &   (J2,XM1,YM1,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT2,DPHIT2,ST2)
      DX2 = (XT1-XT2)**2
      DY2 = (YT1-YT2)**2
      DXY = SQRT(DX2+DY2)
      DIST = SQRT((XT2-XM1)**2+(YT2-YM1)**2)
      IF(DIST.LT.ABS(T(J1+2))) DXY=-DXY
      IF(ABS(DXY).GT.EEXYMX) GOTO 8
      DZ = ABS(ZT1-ZT2)
      IF(ITANK.EQ.1) GOTO 7
C        PAIR ORIGIN IN CHAMBER
      IPOINT = 5
      ITEST  = 7
      IF(ST1.LT.SEMAX .OR. ST2.LT.SEMAX) GOTO 8
      ITEST  = 8
      IF(ST1.GT.SIMAX .OR. ST2.GT.SIMAX) GOTO 8
      ITEST  = 9
      IF(T(J1+18).NE.0. .AND. ST1-T(J1+18).LT.0.) GOTO 8
      IF(T(J2+18).NE.0. .AND. ST2-T(J2+18).LT.0.) GOTO 8
C        DISTANCE IN CHAMBER
      DTH = ABS(T(J1+4)-T(J2+4))
      SDTH = DTH / SQRT(T(J1+9)**2+T(J2+9)**2)
      ITEST  = 3
      IF(SDTH.GT.EEDTMX) GOTO 8
      SDZ = DZ / SQRT(DZT12+DZT22)
      ITEST  = 5
      IF(SDZ.GT.EEDTMX) GOTO 8
      SDXY = ABS(DXY)/SQRT(1./(1./DXT12+1./DYT12)+1./(1./DXT22+
     *       1./DYT22))
      ITEST  = 4
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 8
C
    7 ITEST = 0
      IF(NV.EQ.20) GOTO 14
      NV = NV + 1
      LV = (NV-1)*10
      IV(LV+1) = 4
      DT1 = SQRT(DXT12)
      DT2 = SQRT(DXT22)
      DXX2 = 1./(1./DT1+1./DT2)
      V(LV+2) = (XT1/DT1+XT2/DT2) * DXX2
      DT1 = SQRT(DYT12)
      DT2 = SQRT(DYT22)
      DYY2 = 1./(1./DT1+1./DT2)
      V(LV+3) = (YT1/DT1+YT2/DT2) * DYY2
      DT1 = SQRT(DZT12)
      DT2 = SQRT(DZT22)
      DZZ2 = 1./(1./DT1+1./DT2)
      V(LV+4) = (ZT1/DT1+ZT2/DT2) * DZZ2
      V(LV+5) = SQRT(DXX2)
      V(LV+6) = SQRT(DYY2)
      V(LV+7) = SQRT(DZZ2)
      V(LV+8) = SQRT(DX2+DY2)
      IV(LV+9) = I
      IV(LV+10) = K
    8 CONTINUE
C****
      IF (TBIT(MODE,25)) CALL VTXEER(IT1,IT2,IPOINT,ITEST)
C****L
   28 J2 = J2 + 40
    9 J1 = J1 + 40
      IF(NV.EQ.0) GOTO 100
   14 I = 1
   15 LV1 = (I-1)*10
      IF(I.EQ.NV) GOTO 19
      M = I + 1
      LV2 = I*10
      DO 16 K=M,NV
      IF ( IV(LV1+ 9).EQ.IV(LV2+ 9) .OR. IV(LV1+10).EQ.IV(LV2+ 9) .OR.
     *     IV(LV1+10).EQ.IV(LV2+10) ) GOTO 17
   16 LV2 = LV2 + 10
      GOTO 19
C        TWO PAIRS WITH SAME TRACK, TAKE PAIR WITH SMALLER DISTANCE
   17 M = I
      IF(V(LV1+8).LT.V(LV2+8)) M=K
      NV = NV - 1
      IF(M.GT.NV) GOTO 15
      DO 18 K=M,NV
      LV2 = K*10
      LV1 = LV2 - 10
      DO 18 J=1,10
   18 V(LV1+J) = V(LV2+J)
      GOTO 15
   19 J1 = (IV(LV1+9)-1)*40
      J2 = (IV(LV1+10)-1)*40
      V(LV1+9) = 0.
      IV(LV1+8) = 2
      IV(LV1+10) = 2
      IT(J1+1) = 3
      IT(J2+1) = 3
      IT(J1+14) = I
      IT(J2+14) = I
      I = I + 1
      IF(I.LE.NV) GOTO 15
C
  100 RETURN
      END
      SUBROUTINE VTXEER(IT1,IT2,IPOINT,ITEST)
C*860529*KLEINWORT***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXEER)   18.9.86
C*                                                                  *
C*   PRINT ERROR-TEXT FOR   V T X E E                               *
C*                                                                  *
C********************************************************************
C
      IMPLICIT INTEGER*2(H)
C
#include "cdata.for"
C
      REAL*8 DTEXT(14)
C
      DATA DTEXT / 'PRETEST ', 'TANKWALL', 'BEAMPIPE', 'PAR.TEST',

     & 'CHAMBER ', 'CHARGE  ', 'D(PHI)  ', 'D(THETA)', 'D(XY)   ',
     & 'D(Z)    ', 'INTRSECT', 'EXTRAP.S', 'INTERP.S', 'RADIUS  ' /
C
      IF (ITEST.EQ.0) GOTO 600
C
      IF ((IPOINT.LT.1).OR.(IPOINT.GT.5)) GOTO 500
      IF ((ITEST.LT.0).OR.(ITEST.GT.9)) GOTO 500
C
      WRITE(6,9000) DTEXT(IPOINT),DTEXT(ITEST+5),IT1,IT2
 9000 FORMAT(' VTXEE FAILED IN ',A8,' DUE TO INVALID ',A8,
     &' WITH TRACKS :',2I3)
C
      IH = IDATA(IBLN('HEAD'))
      IF (IH.LE.0) GOTO 600
C
      NRUN  = HDATA( 2*IH+ 10 )
      NREC  = HDATA( 2*IH+ 11 )
      WRITE(6,9010) NRUN,NREC
 9010 FORMAT(' RUN,REC : ',2I6)
C
      GOTO 600
C
  500 CONTINUE
      WRITE(6,9020) IPOINT,ITEST
 9020 FORMAT(' ??? STRANGE ENTRY TO VTXEER : ',2I5)
C
  600 CONTINUE
      RETURN
      END
      SUBROUTINE VTXERR(IERR)
C*860529*KLEINWORT***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXERR)   18.9.86
C*                                                                  *
C*   PRINT ERROR-TEXT FOR   V E R T E X -FIT                        *
C*                                                                  *
C********************************************************************
      IMPLICIT INTEGER*2 (H)
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C
      REAL*8 DTEXT(27)
      DIMENSION NSTART(10)
C
      DATA NSTART / 1, 4, 5, 6, 8, 14, 19, 24, 25, 28 /
      DATA DTEXT /
     &'NV < 1 O','R NV > 2','0       ',
     &'NT  <= 0',
     &'NTR <= 0',
     &'DET = 0.','0       ',
     &'NTR < 2 ','AFTER RE','JECTING ','TRACK WI','TH DS/R ','> 90 DEG',
     &'ERROR OF',' VERTEXC','OORDINAT','E(S) = 0','.0      ',
     &'NTR < 2 ','AFTER RE','JECTING ','BAD TRAC','K       ',
     &'NTR = 1 ',
     &'COLLINEA','R 2-PRON','G       ' /
C
      IF ((IERR.LT.1).OR.(IERR.GT.9)) GOTO 100
C        IF (HVTXST(4+IERR).GT.0)
      N1 = NSTART(IERR)
      N2 = NSTART(IERR+1)-1
      WRITE(6,9000) IERR,(DTEXT(K),K=N1,N2)
 9000 FORMAT(' ERROR ',I2,' : ',10A8)
      GOTO 200
C
  100 CONTINUE
C
      WRITE(6,9010) IERR
 9010 FORMAT(' ERROR ',I6,' IS UNKNOWN ')
C
  200 CONTINUE
C
      RETURN
      END
      SUBROUTINE VTXINI
C*800623*DITTMANN***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXINI)   18.9.86
C*                                                                 *
C* I N I T I A L I S A T I O N   O F   X Y Z   V E R T E X   F I T *
C*                                                                 *
C*       TO BE CALLED ONCE AND BEFORE FIRST CALL TO VTXPRE, VERTEX *
C*                                                                 *
C*    MODIFIED FOR VERTEX CHAMBER HARDWARE     860211 C.K.         *
C*       ADDITIONAL CONSTANTS ARE TAKEN FROM COMMON /CGEOV/        *
C*       JADEBD MUST BE DECLARED AS EXTERNAL                       *
C*                                                                 *
C*    MODES AND STATISTICS                        860527 C.K.      *
C*                                                                 *
C*******************************************************************
      IMPLICIT INTEGER*2 (H)
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV
C
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C
C        RESET MODE AND CLEAR STATISTICS
      MODE = 0
      DO 10 I = 1, 120
         HVTXST(I) = 0
   10 CONTINUE
C
C        MEAN VERTEX COORDINATES
      XB = 0.
      YB = 0.
      ZB = 0.
C        OUTER RADIUS OF INNER TANK WALL
      RTANK = 174.
C        OUTER DISTANCE BEAM PIPE TO TANK WALL
      DTANK = 81.
C
C THE VARIABLES DTANK AND X0INN ARE UPDATED IN VTXPRE ACC. TO JADE
C STATUS, I.E. OLD OR NEW BEAMPIPE AND BP-COUNTERS OR VTX CHAMBER
C
C        RADIATION LENGTH BETWEEN BEAM AND FIRST WIRE
      X0INN = 0.1312
C        MEAN TRACK RESIDUAL IN XY AND ZR PLANE
      SIGX0 = 0.55
      SIGZ0 = 30.
C        ARTIFICIAL FACTOR TO ACCOUNT FOR SYSTEMATIC ERRORS
      SIGFAC = 1.0
      SIGX0 = SIGX0 * SIGFAC
      SIGZ0 = SIGZ0 * SIGFAC
C        MINIMUM NUMBER OF POINTS IN XY AND Z TRACK
      PNTMIN = 5.
C        MAXIMUM TRACK RESIDUAL IN XY AND Z (SIG<SIG1*SIGX0)
      SIG1 = 4.
C        MAXIMUM DISTANCE OF TRACKS TO AVERAGE BEAM
C        USED IN PRIMARY VERTEX SEARCH
      DISTB = 20.
C        MAXIMUM OPENING ANGLE OF COLLINEAR 2-PRONGS
      COLL2 = 0.99
C        MAXIMUM NUMBER OF ITERATIONS IN VERTEX FIT
      MITER = 12
C        CONVERGENCE PARAMETER
      DSCONV = 0.05
C        MINIMUM PROBABILITY FOR GOOD VERTEX
      PRCUT = 0.001
C        REJECT BAD TRACKS DURING VERTEX FIT (0=NO, 1=YES)
      IREJTR = 1
C        EE PAIRS: MINIMUM AND MAXIMUM MEASURED PHI DIFFERENCE (RADIAN)
      EEDPMN = -0.07
      EEDPMX =  0.8
C        EE PAIRS: MAXIMUM THETA DIFFERENCE (STD.DEV.)
      EEDTMX = 3.0
C        EE PAIRS: MAXIMUM DISTANCE WHERE TRACKS ARE PARALLEL (STD.DEV.)
      EEDRMX = 3.0
C        EE PAIRS: MAXIMUM POSITIVE XY DISTANCE, NO ST.DEV. CUT (MM)
      EEXYMN = 4.0
C        EE PAIRS: MAXIMUM XY DISTANCE WHERE TRACKS ARE PARALLEL (MM)
      EEXYMX = 20.
C        MAXIMUM TRACK EXTRAPOLATION AND INTRAPOLATION(ARC LENGTH)
      SEMAX = -300.
      SIMAX = 25.
C        MAXIMUM TRACK EXTRAPOLATION (PHI)
      PHEMAX = 1.0
C        MAXIMUM TRACK DISTANCE TO VERTEX DURING FIT (STD.DEV.)
      SIG2 = 2.
C        MAXIMUM TRACK DISTANCE TO VERTEX AFTER FIT (STD.DEV.)
      SIG3 = 4.
C        SEC. VERTICES: MINIMUM COS OF TRACK TO MAIN VERTEX (OR XB,YB)
      CSECV = -0.15
C
      RETURN
      END
      SUBROUTINE VTXPNT(J,XP,YP,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,DPHIT,ST)
C*800623*DITTMANN************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXPNT)   18.9.86
C*                                                              *
C*     S U P P O R T   F O R   X Y Z   V E R T E X   F I T      *
C*                                                              *
C*860611*KLEINWORT***********************************************
C*                                                              *
C*  REWRITTEN FOR PROPER ERRORS AND USE WITH 'COMFIT'ED TRACKS  *
C*                                                              *
C*  - AS NEW PARAMETER DPHIT THE ERROR OF PHI IS CALCULATED     *
C*    ( WITHOUT MULTIPLE SCATTERING ! )                         *
C*                                                              *
C*       COMMON CWORK1 MUST BE FILLED PROPERLY                  *
C*                                                              *
C*       ENTRY: VTXS                                            *
C****************************************************************
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C
      REAL*8 XM,YM,RR,PHI,SPHI,CPHI,SR
C        ENTRY VTXPNT
C****    CALCULATE POINT XT,YT,ZT ON HELIX J WHICH IS NEAREST
C****    TO POINT XP,YP IN X-Y PROJECTION
      RR = DBLE(T(J+2))
      XM = DBLE(T(J+5)) - RR*DBLE(T(J+21))
      YM = DBLE(T(J+6)) + RR*DBLE(T(J+22))
      SR = DBLE(SIGN(1.,T(J+2)))
      PHI = DATAN2(-SR*(XM-DBLE(XP)),SR*(YM-DBLE(YP)))
      SPHI = DSIN(PHI)
      CPHI = DCOS(PHI)
      PHIT = SNGL(PHI)
      PHI = PHI - DBLE(T(J+3))
      IF (DABS(PHI).GT.3.141593D0) PHI=PHI-DSIGN(1.D0,PHI)*6.283185D0
      ST = SNGL(RR*PHI)
      XT = SNGL(XM + RR*SPHI)
      YT = SNGL(YM - RR*CPHI)
      ZT = T(J+7) + ST*T(J+23)
      SSPACE = ST
      GOTO 100
C
C
         ENTRY VTXS(J,SJ,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,DPHIT)
C****    CALCULATE POINT XT,YT,ZT ON HELIX J FOR A GIVEN
C****    PROJECTED ARC LENGTH SJ
      RR = DBLE(T(J+2))
      PHI = DBLE(SJ) / RR + DBLE(T(J+3))
      PHIT = SNGL(PHI)
      SPHI = DSIN(PHI)
      CPHI = DCOS(PHI)
      XT = SNGL(DBLE(T(J+5)) + RR*(SPHI-DBLE(T(J+21))))
      YT = SNGL(DBLE(T(J+6)) - RR*(CPHI-DBLE(T(J+22))))
      ZT = T(J+7) + SJ*T(J+23)
      SSPACE = SJ
C
C *** CALCULATION OF RPHI-ERRORS
C
  100 CONTINUE
C
      SSCOUL = SSPACE - T(J+18)
      IF ((SSCOUL.GT.0.).OR.(T(J+18).GT.0.)) SSCOUL=0.
      SSCVXC = SSPACE - T(J+19)
      IF(SSCVXC.GT.0.) SSCVXC=0.
C
      X = SSPACE - 0.5*T(J+20)
C                                      ERROR IN XY (SQUARED)
C
C                                      MULTIPLE SCATTERRING ( TANKWALL )
      DXY = ( T(J+16) * SSCOUL )**2 +
C                                      MULTIPLE SCATTERRING ( BEAMPIPE )
     &      ( T(J+17) * SSCVXC )**2 +
C                                      PARABOLA FIT
     &      ((( T(J+32)   *X + T(J+33) ) *X +
     &          T(J+34) ) *X + T(J+35) ) *X + T(J+36)
C
C                                      ERROR IN PHI (NOT SQUARED)
C
C                                      NO MULTIPLE SCATTERRING
C                                      PARABOLA FIT
      XX = 2.0 * X
      DPHIT = ( T(J+32) *XX + T(J+33) ) *XX + T(J+40)
      IF (DPHIT.GE.0.) DPHIT = SQRT( DPHIT )
C
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(ABS(DXY)))
      DXT2 = SNGL(SPHI**2) / DXY
      DYT2 = SNGL(CPHI**2) / DXY
      IF(ABS(DXT2).LT.DXYLIM) DXT2=DXYLIM
      IF(ABS(DYT2).LT.DXYLIM) DYT2=DXYLIM
      DXT2 = 1. / DXT2
      DYT2 = 1. / DYT2
C
C *** CALCULATION OF ZS-ERRORS
C
      SSPACE = SSPACE + T(J+39)
C
      SSCOUL = SSPACE - T(J+18)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      SSCVXC = SSPACE - T(J+19)
      IF(SSCVXC.GT.0.) SSCVXC=0.
C
      X = SSPACE/T(J+38) - 0.5
C                                      MULTIPLE SCATTERRING
      DZT2 = ( T(J+16) * SSCOUL )**2 + ( T(J+17) * SSCVXC )**2 +
C                                      LINE FIT (WITH TRIPLETS)
     &         T(J+37) * ( 1.5 + 18.*X**2 )
C
      RETURN
C
      END
      SUBROUTINE VTXPRE(IH,IP)
C*800623*DITTMANN***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXPRE)   18.9.86
C*                                                                 *
C*   P R E P A R A T I O N   F O R   X Y Z   V E R T E X   F I T   *
C*                                                                 *
C*       IH = POINTER TO 'HEAD' BANK                               *
C*       IP = POINTER TO 'PATR' BANK (AS IN JADE COMP NOTE 12).    *
C*                                                                 *
C*       VTXPRE COPIES ALL TRACKS INTO /CWORK1/, FLAGS TRACKS WHICH*
C*       SHOULD NOT BE USED IN VERTEX FIT, AND ADDS COULOMB        *
C*       SCATTERING ERRORS IN MATERIAL BEFORE FIRST WIRE.          *
C*       FOR DETAILS OF THE T-ARRAY SEE COMMENT IN SUBR. VERTEX.   *
C*                                                                 *
C*       SUBR. VTXINI MUST BE CALLED BEFORE FIRST CALL TO VTXPRE   *
C*                                                                 *
C*    MODIFIED FOR VERTEX CHAMBER HARDWARE     860211 C.K.         *
C*                                                                 *
C*    MODIFIED COMFIT-ERROR OF SCATTERING-ANGLE   860217 C.K.      *
C*                                                                 *
C*    +++ BIG MODIFICATION +++                    860611 C.K.      *
C*                                                                 *
C*    * FOR EACH TRACK NOW 40 INSTEAD OF 30 WORDS IN T()           *
C*                                                                 *
C*    * FITS IN RPHI AND ZS ARE TREATED INDEPENDENT                *
C*      ( DIFFERENT FIRST POINT, MULT. SCATTERING POSSIBLE,        *
C*        THIS IS NECCESSARY FOR 'COMFIT'TED TRACKS         )      *
C*                                                                 *
C*    +++ END MODIFICATION +++                                     *
C*                                                                 *
C*    - CURVATURE-CORRECTION                                       *
C*    - RECALCULATION OF FIRST MEASURED POINT FOR TYP 2 TRACKS     *
C*                                                                 *
C*    ... COVARIANCES FOR ERROR CALCULATION ...   860714 C.K.      *
C*                                                                 *
C*******************************************************************
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1
      REAL*8 AA,BB,CC,DD,EE,RR,DR,DR1M
      REAL*8 PHI,SPHI,CPHI,XD,YD,PARKOR,DSR,DPHI
      REAL H03
C                  DEFAULT VALUES
      DATA LFIELD,LRUN/-4848,-1/
C
C
      NT = 0
C-------------------------------------------------------
C  UPDATE OF DTANK AND X0INN
C
      DTANK = RITNK - RBPIPE(DUM)
      X0INN = XBPIPE(DUM)
C-------------------------------------------------------
      IF(IH.EQ.0) RETURN
      IH2 = 2*IH
      NRUN = HDATA(IH2+10)
      NVAV = HDATA(IH2+18)
C
C---- LOCATE RUN-VERTEX IF NEEDED
C
      IF (TBIT(MODE,31)) CALL WTXCRV(NRUN,RVX,RVY,RVDX,RVDY)
C     NOTE THIS CODING FIXES UP ONLY VERY LOW FIELDS
         IFIELD = HDATA(IH2+30)
         IF(IABS(IFIELD).GE.100) GO TO 5408
      IF (NRUN .NE. LRUN)  WRITE(6,5407) NRUN,IFIELD,LFIELD
5407  FORMAT(' * WTXPRE #### *   WARNING: RUN ',I6,' HAS MAGNETIC FIELD
     $ = ',I6,' GAUSS - USING ',I6)
      HDATA(IH2+30)=LFIELD
      IFIELD = HDATA(IH2+30)
      LRUN=NRUN
5408  H03 = .00003 * ABS(FLOAT(IFIELD))
      IF(IP.EQ.0) RETURN
      NT = IDATA(IP+2)
      IF(NT.LE.0) RETURN
      IF(NT.GT.50) NT=50
      L0 = IDATA(IP+1)
      LT = IDATA(IP+3)
C
      KT = IP + L0
      JT = 0
      DO 19 I=1,NT
      DO 11 J=1,40
   11 IT(JT+J) = 0
      IPFLAG = IDATA(KT+44)
C        MOST OF THE FOLLOWING TRACK REJECT CRITERIA ARE DUE
C        TO FAULTS IN THE PATR BANK
      IF(ADATA(KT+25).EQ.0.) GOTO 18
      PT = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      IF(PT.EQ.0.) GOTO 18
      IF(ADATA(KT+10).EQ.0.) GOTO 18
CCC   T(JT+2) = -1. / ADATA(KT+25)
      RR = -1.D0 / PARKOR(KT)
      T(JT+2) = SNGL(RR)
      T(JT+3) = ATAN2(ADATA(KT+9),ADATA(KT+8))
      TTH = ADATA(KT+10) / PT
      CTH = 1. / SQRT(1.+TTH**2)
      T(JT+4) = ATAN(TTH)
      T(JT+5) = ADATA(KT+5)
      T(JT+6) = ADATA(KT+6)
      T(JT+7) = ADATA(KT+7)
      SR = SIGN(1.,T(JT+2))
      DSR = DBLE(SR)
      ITYP = IDATA(KT+18)
      XP0  = ADATA(KT+20)
      YP0  = ADATA(KT+21)
C
C *** RECALCULATION OF FIRST MEASURED POINT WITH CORRECTED CURVATURE
C
      IF (ITYP.NE.2) GOTO 111
      XD = DBLE(XP0)
      YD = DBLE(YP0)
      SPHI = DSIN(DBLE(ADATA(KT+19)))
      CPHI = DCOS(DBLE(ADATA(KT+19)))
      AA = XD - RR*SPHI
      BB = YD + RR*CPHI
      DPHI = DATAN2( DSR*(DBLE(T(JT+5))-AA), DSR*(BB-DBLE(T(JT+6))) )
      XD = XD + RR*(DSIN(DPHI)-SPHI)
      YD = YD - RR*(DCOS(DPHI)-CPHI)
      T(JT+3) = SNGL(DPHI)
      T(JT+5) = SNGL(XD)
      T(JT+6) = SNGL(YD)
C
C     CHANGE TO TYP 1 ?
C
      IF (ABS(T(JT+2)).GT.20000.) GOTO 111
      IF (.NOT.TBIT(MODE,26)) GOTO 111
C
C     LIST OF CHANGED ITEMS IN PATR BANK
C
      ADATA(KT+5) = T(JT+5)
      ADATA(KT+6) = T(JT+6)
      ADATA(KT+8) = COS(T(JT+3)) * PT
      ADATA(KT+9) = SIN(T(JT+3)) * PT
      IDATA(KT+18) = 1
      ADATA(KT+19) = 1./ABS(T(JT+2))
      ADATA(KT+20) = SNGL( DSQRT(AA*AA+BB*BB) - DABS(RR) )
      ADATA(KT+21) = SNGL( DATAN2( BB, AA ) )
      ADATA(KT+22) = 0.
      ADATA(KT+25) = -1./T(JT+2)
C
  111 CONTINUE
C
      SIGX = ADATA(KT+23)
      SIGZ = ADATA(KT+32)
C----     THIS CLUDGE SHOULD SOMEHOW ACCOUNT FOR SYSTEMATIC ERRORS
      SIGX = SIGX * SIGFAC
      SIGZ = SIGZ * SIGFAC
C----
      XNPT = IDATA(KT+24)
      ZNPT = IDATA(KT+33)
C        CHECK RESIDUAL
      IF(SIGX.EQ.0..OR.SIGZ.EQ.0.) GOTO 18
      IF(SIGX.GT.SIG1*SIGX0) GOTO 18
      IF(SIGZ.GT.SIG1*SIGZ0) GOTO 18
C        CHECK NUMBER OF POINTS ON TRACK
      IF(XNPT.LT.PNTMIN .OR. ZNPT.LT.PNTMIN) GOTO 18
      PROJL = ABS((ADATA(KT+14)-ADATA(KT+7))/TTH)
      IF(PROJL.LT.1.) GOTO 18
      SXNPT = SQRT(XNPT)
      SZNPT = SQRT(ZNPT)
      T(JT+8) = SIGX * 14./(PROJL*SXNPT)
      T(JT+9) = SIGZ * 4.24*CTH**2/(PROJL*SZNPT)
      T(JT+10) = SIGX * 3. / SXNPT
      T(JT+11) = T(JT+10)
      T(JT+12) = SIGZ * 2.45 / SZNPT
C *** FOR NEW ERROR-CALCULATION
C     RPHI DEFAULT COVARIANCES ( FROM ID WITH 48 WIRES )
      SIG2N    = SIGX*SIGX/XNPT
      T(JT+20) = PROJL
      T(JT+32) = 154.0*SIG2N/PROJL**4
      T(JT+33) =   0.0
      T(JT+34) = -19.6*SIG2N/PROJL**2
      T(JT+35) =   0.0
      T(JT+36) =  2.45*SIG2N
      T(JT+40) =  10.7*SIG2N/PROJL**2
C     ZS PARAMETERS
      T(JT+37) = SIGZ*SIGZ/ZNPT
      T(JT+38) = PROJL
C     TRUE COVARIANCES FROM COMFIT
      IF ((LT.NE.64).OR.(IDATA(KT+2).NE.301).OR.(IDATA(KT+44).NE.3))
     &   GOTO 139
C     RAMCKE TEST
      IF (ADATA(KT+52).EQ.0.0) GOTO 139
      T(JT+32) = ADATA(KT+52)
      T(JT+33) = ADATA(KT+53)
      T(JT+34) = ADATA(KT+54)
      T(JT+35) = ADATA(KT+55)
      T(JT+36) = ADATA(KT+56)
      T(JT+40) = ADATA(KT+57)
  139 CONTINUE
C ***
      IT(JT+13) = IDATA(KT+24)
      T(JT+15) = 0.
      T(JT+21) = SIN(T(JT+3))
      T(JT+22) = COS(T(JT+3))
      T(JT+23) = TTH
      T(JT+24) = CTH
      IT(JT+1) = 2
      IF(IPFLAG.EQ.2) GOTO 14
C----   THIS CLUDGE CORRECTS AN ERROR IN THE PATR BANK
      AA = -DBLE(T(JT+5)) + RR*DBLE(T(JT+21))
      BB = -DBLE(T(JT+6)) - RR*DBLE(T(JT+22))
      IF(ITYP.EQ.2) AA=AA+DBLE(XP0)
      IF(ITYP.EQ.2) BB=BB+DBLE(YP0)
      DR1M = DSQRT(AA**2+BB**2)
      DR = DR1M - DABS(RR)
      IF(ITYP.NE.2) DR=DR-DBLE(ADATA(KT+20))
      T(JT+5) = T(JT+5) + DR*AA/DR1M
      T(JT+6) = T(JT+6) + DR*BB/DR1M
      T(JT+7) = ADATA(KT+31) + ADATA(KT+30)*SQRT(T(JT+5)**2+T(JT+6)**2)
C----
C
   14 XM = T(JT+5) - T(JT+2)*T(JT+21)
      YM = T(JT+6) + T(JT+2)*T(JT+22)
C
C---- START ITERATION AT RUNVERTEX ?
C
      IF (TBIT(MODE,31)) T(JT+15) =
     &      ( ATAN2( SR*(RVX - XM), SR*(YM - RVY) )
     &      - T(JT+3) ) * T(JT+2)
C
C---- MC WITHOUT MULTIPLE SCATTERING ?
C
      X0VX = XFWVXC(IH)
      X0ID = XFWID(IH) - X0VX
      IF (NRUN.GE.100) GOTO 149
      IF (NVAV.NE.-1)  GOTO 149
         X0ID = 0.
         X0VX = 0.
  149 CONTINUE
C
      PT = H03*T(JT+2)
C
C     INTERSECT WITH INNER TANKWALL
C
      AA = XM
      BB = YM
      AA = AA**2 + BB**2
      BB = T(JT+2)
      BB = BB**2
      CC = RTANK**2
      DD = (AA-BB+CC)/2.D0
      EE = AA*CC - DD**2
C        ANY INTERSECT ?
      IF(EE.LE.0.D0) GOTO 17
      EE = DSQRT(EE)
      XT1 = (XM*DD + YM*EE) / AA
      YT1 = (YM*DD - XM*EE) / AA
      XT2 = (XM*DD - YM*EE) / AA
      YT2 = (YM*DD + XM*EE) / AA
      D1 = SQRT((XT1-T(JT+5))**2+(YT1-T(JT+6))**2)
      D2 = SQRT((XT2-T(JT+5))**2+(YT2-T(JT+6))**2)
      IF(D1.LT.D2) GOTO 16
      XT = XT2
      YT = YT2
      XT2 = XT1
      YT2 = YT1
      XT1 = XT
      YT1 = YT
   16 PHI = ATAN2(-SR*(XM-XT1),SR*(YM-YT1))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+27) = T(JT+2)*THETA
      T(JT+18) = T(JT+27)
      PHI = ATAN2(-SR*(XM-XT2),SR*(YM-YT2))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+26) = T(JT+2)*THETA
C        MULT. SCATTERING IN INNER TANK WALL (AND VTXC)
      BETA = 1.
      TH2 = (14.1/(PT*BETA))**2 * X0ID * T(JT+24)
     &      * ( 1. + 1./9. * ALOG10( X0ID / T(JT+24) ) )**2
      T(JT+16) = SQRT(TH2)
   17 CONTINUE
C
C     INTERSECT WITH BEAMPIPE
C
      CC = (RBPIPE(DUM)+DRPIPE(DUM))**2
      DD = (AA-BB+CC)/2.D0
      EE = AA*CC - DD**2
C        ANY INTERSECT ?
      IF(EE.LE.0.D0) GOTO 172
      EE = DSQRT(EE)
      XT1 = (XM*DD + YM*EE) / AA
      YT1 = (YM*DD - XM*EE) / AA
      XT2 = (XM*DD - YM*EE) / AA
      YT2 = (YM*DD + XM*EE) / AA
      D1 = SQRT((XT1-T(JT+5))**2+(YT1-T(JT+6))**2)
      D2 = SQRT((XT2-T(JT+5))**2+(YT2-T(JT+6))**2)
      IF(D1.LT.D2) GOTO 171
      XT = XT2
      YT = YT2
      XT2 = XT1
      YT2 = YT1
      XT1 = XT
      YT1 = YT
  171 PHI = ATAN2(-SR*(XM-XT1),SR*(YM-YT1))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+19) = T(JT+2)*THETA
C        MULT. SCATTERING IN BEAMPIPE
      BETA = 1.
      TH2VX = 0.
      IF (X0VX.GT.0.) TH2VX = (14.1/(PT*BETA))**2 * X0VX * T(JT+24)
     &      * ( 1. + 1./9. * ALOG10( X0VX / T(JT+24) ) )**2
      T(JT+17) = SQRT(TH2VX)
  172 CONTINUE
C
C---- TRACK WITH VTXC ?
C
      R1 = SQRT(T(JT+5)**2+T(JT+6)**2)
      IT(JT+31) = 0
      T(JT+39) = 0.
      IF (R1.GE.RTANK) GOTO 18
      IT(JT+31) = 1
C     DISTANCE 1. WIRE VTXC TO 1. WIRE ID
      DS = 120.
      IF ((IDATA(KT+44).NE.1).AND.(IDATA(KT+44).NE.3)) GOTO 175
C     GET PROJ. TRACKLENGTH FROM ZS-FIT
      PROJLZ = ABS((ADATA(KT+45)-ADATA(KT+46))/TTH)
      DS = T(JT+38) - PROJLZ
C
  175 CONTINUE
      T(JT+38) = T(JT+38) - DS
      T(JT+39) = -DS
C
   18 JT = JT + 40
   19 KT = KT + LT
C
C
      RETURN
      END
      SUBROUTINE VTXSRC
C*800623*DITTMANN********************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXSRC)   18.9.86
C*                                                          *
C*        X - Y - Z    V E R T E X    S E A R C H           *
C*                                                          *
C*       1. SEARCH FOR E+E- PAIRS                           *
C*       2. SEARCH FOR MAIN VERTEX AROUND AVERAGE BEAM      *
C*       3. SEARCH FOR SECONDARY VERTICES                   *
C*                                                          *
C*       A DESCRIPTION OF THE T AND V ARRAYS CAN BE FOUND   *
C*       IN SUBR. VERTEX                                    *
C************************************************************
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV
C
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C
      DIMENSION IV2(20,20)
      EQUIVALENCE (V2(1,1),IV2(1,1))
C
      LOGICAL VREP,RESTOR
C
      NV = 0
      IF(NT.LE.0) RETURN
      IPRVTX = 0
C****
C****    SEARCH FOR GAMMA CONVERSIONS
      CALL VTXEE
      IF(NV.EQ.0) GOTO 5
      LV = 0
      DO 4 I=1,NV
      J = 0
      DO 3 K=1,NT
      IF(IT(J+14).EQ.I) IT(J+1)=-IT(J+1)
    3 J = J + 40
    4 LV = LV + 10
C****
C****    SEARCH FOR PRIMARY VERTEX AROUND AVERAGE BEAM
    5 NTGOD = 0
      NTBAD = 0
      J = 0
      DO 7 I=1,NT
      IF(IT(J+1).LE.0) GOTO 7
      CALL VTXPNT(J,XB,YB,XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      DXY = SQRT((XT-XB)**2+(YT-YB)**2)
      IF(DXY.GT.DISTB) GOTO 6
      IF(SS.LT.SEMAX-RTANK) GOTO 6
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      GOTO 7
    6 IT(J+1) = 1
      NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
    7 J = J + 40
      IF(NTGOD.EQ.0) GOTO 39
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
      VREP = .FALSE.
      RESTOR = .FALSE.
C****
C****    VERTEX FIT
   10 CALL VERTEX
      IF(IV(LV+1).GE.1) GOTO 20
      IF(VREP) GOTO 60
      GOTO 40
C****
C****    CHECK VERTEX AND ITS TRACKS
   20 NTBAD = 0
      NTBAD3 = 0
      NTGOD = 0
      NTGOD3 = 0
      J = 0
      DO 25 I=1,NT
      IF(IT(J+1).LE.0) GOTO 25
C        SMALLEST DISTANCE TO VERTEX
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      DXT2 = DXT2 + V(LV+5)**2
      DYT2 = DYT2 + V(LV+6)**2
      DZT2 = DZT2 + V(LV+7)**2
      SDX = ABS(XT-V(LV+2)) / SQRT(DXT2)
      SDY = ABS(YT-V(LV+3)) / SQRT(DYT2)
      SDZ = ABS(ZT-V(LV+4)) / SQRT(DZT2)
      T(J+15) = SS
      T(J+28) = SDX
      T(J+29) = SDY
      T(J+30) = SDZ
      IF(IT(J+1).EQ.1) GOTO 23
      IF(SDX.GT.SIG2 .OR. SDY.GT.SIG2 .OR. SDZ.GT.SIG2) GOTO 23
C        EXTRAPOLATION LENGTH
      IF(SS.GT.SIMAX) GOTO 23
      SSJC = SS
      IF(T(J+27).EQ.0.) GOTO 22
      IF(SS.LT.T(J+26)-SIMAX) GOTO 23
      IF(SS.LT.T(J+27)) SSJC=T(J+27)
   22 IF(SSJC.LT.SEMAX) GOTO 23
      IF(ABS(SS/T(J+2)).GT.PHEMAX) GOTO 23
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      IF(IT(J+1).EQ.3) NTGOD3=NTGOD3+1
      GOTO 25
   23 NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
      IF(IT(J+1).EQ.3) NTBAD3=NTBAD3+1
   25 J = J + 40
      IF(RESTOR) GOTO 30
      IF(NTGOD3.EQ.20) GOTO 30
      IF(NTBAD3.EQ.0 .AND. NTGOD.EQ.NTGOD3) GOTO 30
      IF(.NOT.VREP .AND. NTGOD.LT.3) GOTO 40
      IF(NTGOD.LE.2) GOTO 60
C        REPEAT VERTEX FIT
      DO 27 I=1,NTGOD
      J = JTGOD(I)
   27 IT(J+1) = 2
      IF(NTBAD.EQ.0) GOTO 10
      DO 28 I=1,NTBAD
      J = JTBAD(I)
   28 IT(J+1) = 1
      GOTO 10
C****
C****    GOOD VERTEX FOUND
   30 IF(NTBAD.EQ.0) GOTO 37
      IF(IV(LV+8).EQ.1) GOTO 37
C        COLLECT ALL TRACKS FITTING TO VERTEX
      NTB = 0
      DO 33 I=1,NTBAD
      J = JTBAD(I)
      IF(T(J+28).GT.SIG3.OR.T(J+29).GT.SIG3.OR.T(J+30).GT.SIG3) GOTO 32
      IF(T(J+15).GT.SIMAX) GOTO 32
      SSJC = T(J+15)
      IF(T(J+27).EQ.0.) GOTO 31
      IF(T(J+15).LT.T(J+26)-SIMAX) GOTO 32
      IF(T(J+15).LT.T(J+27)) SSJC=T(J+27)
   31 IF(SSJC.LT.SEMAX) GOTO 32
      IF(ABS(T(J+15)/T(J+2)).GT.PHEMAX) GOTO 32
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      IT(J+1) = 1
      GOTO 33
   32 NTB = NTB + 1
      JTBAD(NTB) = J
   33 CONTINUE
      NTBAD = NTB
   37 IV(LV+10) = NTGOD
      DO 38 I=1,NTGOD
      J = JTGOD(I)
      IT(J+1) = -IT(J+1)
      IT(J+14) = NV
   38 CONTINUE
      IF(IPRVTX.NE.0) GOTO 39
      IF(ABS(V(LV+2)-XB).LT.3.*DISTB .AND. ABS(V(LV+3)-YB).LT.3.*DISTB)
     *   IPRVTX=NV
   39 IF(NTBAD.EQ.0) GOTO 90
      NTGOD = 0
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
C****
C****    VERTEX SEARCH
   40 IF(NTBAD.EQ.0) GOTO 241
      DO 41 I=1,NTBAD
      J = JTBAD(I)
   41 IT(J+1) = 1
  241 IF(NTGOD.EQ.0) GOTO 43
      DO 141 I=1,NTGOD
      J = JTGOD(I)
      NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
  141 IT(J+1) = 1
   43 NVL = NV
      NV2 = 0
      N1 = 1
      IF(NTBAD.LT.2) GOTO 50
C        TWO TRACK VERTEX
   42 J1 = JTBAD(N1)
      IT(J1+1) = 2
      N21 = N1 + 1
      IF(N21.GT.NTBAD) GOTO 45
      DO 44 N2=N21,NTBAD
      J2 = JTBAD(N2)
      IT(J2+1) = 2
      CALL VERTEX
      IF(IV(LV+1).LE.1) GOTO 44
C        CHECK THIS VERTEX
C        EXTRAPOLATION LENGTH TRACK 1
      CALL VTXPNT(J1,V(LV+2),V(LV+3),XT1,YT1,ZT1,DXT12,DYT12,DZT12,
     *            PHIT1,DPHIT1,ST1)
      IF(ST1.GT.SIMAX) GOTO 44
      SSJC = ST1
      IF(T(J1+27).EQ.0.) GOTO 143
      IF(ST1.LT.T(J1+26)-SIMAX) GOTO 44
      IF(ST1.LT.T(J1+27)) SSJC=T(J1+27)
  143 IF(SSJC.LT.SEMAX) GOTO 44
      IF(ABS(ST1/T(J1+2)).GT.PHEMAX) GOTO 44
C        EXTRAPOLATION LENGTH TRACK 2
      CALL VTXPNT(J2,V(LV+2),V(LV+3),XT2,YT2,ZT2,DXT22,DYT22,DZT22,
     *            PHIT2,DPHIT2,ST2)
      IF(ST2.GT.SIMAX) GOTO 44
      SSJC = ST2
      IF(T(J2+27).EQ.0.) GOTO 243
      IF(ST2.LT.T(J2+26)-SIMAX) GOTO 44
      IF(ST2.LT.T(J2+27)) SSJC=T(J2+27)
  243 IF(SSJC.LT.SEMAX) GOTO 44
      IF(ABS(ST2/T(J2+2)).GT.PHEMAX) GOTO 44
C        COMPARE TRACK DIRECTIONS WITH BEAM
      DZ = ABS(ZT1-ZT2)
      COSW12 = 0.
      IF(IPRVTX.EQ.0) GOTO 147
      LPV = (IPRVTX-1)*10
      DVX = V(LV+2) - V(LPV+2)
      DVY = V(LV+3) - V(LPV+3)
      DVZ = V(LV+4) - V(LPV+4)
      DV12 = SQRT(DVX**2+DVY**2+DVZ**2)
C#######################################################
C 03.6.86    PROTECTION AGAINST DIVIDE WITH ZERO    J.OLSSON
      IF(DV12.LE.10.E-8) GO TO 44
C#######################################################
      COSW1 = (COS(PHIT1)*T(J1+24)*DVX + SIN(PHIT1)*T(J1+24)*DVY +
     *         SIN(T(J1+4))*DVZ) / DV12
      IF(COSW1.LT.CSECV) GOTO 44
      COSW2 = (COS(PHIT2)*T(J2+24)*DVX + SIN(PHIT2)*T(J2+24)*DVY +
     *        SIN(T(J2+4))*DVZ) / DV12
      IF(COSW2.LT.CSECV) GOTO 44
      COSW12 = COSW1 * COSW2
      GOTO 47
  147 DVX = V(LV+2) - XB
      DVY = V(LV+3) - YB
      DV12 = SQRT(DVX**2+DVY**2)
      IF(DV12.LT.DISTB) GOTO 47
      COSW1 = (COS(PHIT1)*DVX + SIN(PHIT1)*DVY) / DV12
      IF(COSW1.LT.CSECV) GOTO 44
      COSW2 = (COS(PHIT2)*DVX + SIN(PHIT2)*DVY) / DV12
      IF(COSW2.LT.CSECV) GOTO 44
      COSW12 = COSW1 * COSW2
C        CHECK IF MORE TRACKS FIT
   47 NT2 = 2
      DO 149 K=1,NTBAD
      J = JTBAD(K)
      IF(IT(J+1).EQ.3) GOTO 149
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      SDX = ABS(XT-V(LV+2)) / SQRT(DXT2)
      SDY = ABS(YT-V(LV+3)) / SQRT(DYT2)
      SDZ = ABS(ZT-V(LV+4)) / SQRT(DZT2)
      IF(SDX.GT.SIG2 .OR. SDY.GT.SIG2 .OR. SDZ.GT.SIG2) GOTO 149
      IF(SS.GT.SIMAX) GOTO 149
      SSJC = SS
      IF(T(J+27).EQ.0.) GOTO 148
      IF(SS.LT.T(J+26)-SIMAX) GOTO 149
      IF(SS.LT.T(J+27)) SSJC=T(J+27)
  148 IF(SSJC.LT.SEMAX) GOTO 149
      IF(ABS(SS/T(J+2)).GT.PHEMAX) GOTO 149
      NT2 = NT2 + 1
  149 CONTINUE
C        TEMPORARY STORE OF ALL TWO TRACK VERTICES
      NV2 = NV2 + 1
      IV2(NV2,1) = NV
      IV2(NV2,2) = NT2
      IV2(NV2,3) = J1
      IV2(NV2,4) = J2
      V2(NV2,5) = COSW12
      V2(NV2,6) = DZ
      IV2(NV2,7) = IV(LV+1)
      IF(NV.EQ.20) GOTO 45
      NV = NV + 1
      LV = (NV-1)*10
C
   44 IT(J2+1) = 1
      IT(J1+1) = 1
      N1 = N1 + 1
      IF(N1.LE.NTBAD) GOTO 42
C        CHOOSE BEST TWO TRACK VERTEX
   45 IT(J1+1) = 1
      IT(J2+1) = 1
      IF(NV2.EQ.0) GOTO 50
      NT2MAX = 0
      DO 46 I=1,NV2
      IF(IV2(I,2).LT.NT2MAX) GOTO 46
      IF(IV2(I,2).EQ.NT2MAX) GOTO 144
      NT2MAX = IV2(I,2)
      LV2 = I
      GOTO 46
  144 IF(IV2(I,7).EQ.IV2(LV2,7)) GOTO 145
      IF(IV2(I,7).GT.IV2(LV2,7)) LV2=I
      GOTO 46
  145 IF(IPRVTX.EQ.0) GOTO 146
      IF(V2(I,5).GT.V2(LV2,5)) LV2=I
      GOTO 46
  146 IF(V2(I,6).LT.V2(LV2,6)) LV2=I
   46 CONTINUE
C        REPEAT VERTEX FIT
      J1 = IV2(LV2,3)
      J2 = IV2(LV2,4)
      NV = NVL
      LV = (NVL-1)*10
      LV2 = (IV2(LV2,1)-1)*10
      J1SAVE = J1
      J2SAVE = J2
      DO 48 K=1,10
      VSAVE(K) = V(LV2+K)
   48 V(LV+K) = V(LV2+K)
      DO 49 K=1,NTBAD
      J = JTBAD(K)
      IT(J+1)=2
   49 CONTINUE
      IT(J1+1) = 3
      IT(J2+1) = 3
      VREP = .TRUE.
      RESTOR = .FALSE.
      GOTO 20
C        SINGLE TRACK VERTEX
   50 DO 52 N1=1,NTBAD
      J1 = JTBAD(N1)
      IF(N1.EQ.1) GOTO 51
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
   51 IV(LV+1) = 5
      V(LV+2) = T(J1+5)
      V(LV+3) = T(J1+6)
      V(LV+4) = T(J1+7)
      V(LV+5) = T(J1+10)
      V(LV+6) = T(J1+11)
      V(LV+7) = T(J1+12)
      IV(LV+8) = 1
      V(LV+9) = 0.
      IV(LV+10) = 1
      IT(J1+1) = -3
      IT(J1+14) = NV
   52 CONTINUE
      GOTO 90
C        SEARCH NOT CONVERGING
C        EMERGENCY ACTION: RESTORE 2-TRACK VERTEX (OTHERWISE DEAD LOOP)
   60 J1 = J1SAVE
      J2 = J2SAVE
      DO 62 I=1,10
   62 V(LV+I) = VSAVE(I)
      IF(NTBAD.EQ.0) GOTO 66
      DO 63 I=1,NTBAD
      J = JTBAD(I)
      IT(J+1)=2
   63 CONTINUE
   66 IF(NTGOD.EQ.0) GOTO 69
      DO 67 I=1,NTGOD
      J = JTGOD(I)
      IT(J+1)=2
   67 CONTINUE
   69 IT(J1+1) = 3
      IT(J2+1) = 3
      RESTOR = .TRUE.
      GOTO 20
C****
C****    CLEAN UP
   90 IF(NV.EQ.0) GOTO 100
      J = 0
      DO 91 I=1,NT
      IF(IT(J+1).LT.0) IT(J+1)=-IT(J+1)
   91 J = J + 40
      IF(NV.EQ.1) GOTO 100
      IF(IPRVTX.NE.0) GOTO 93
      IPRVTX = 1
      DXYP = 1.E20
      LV = 0
      DO 92 I=1,NV
      DXY = V(LV+2)**2+V(LV+3)**2
      IF(DXY.GT.DXYP) GOTO 92
      IPRVTX = I
      DXYP = DXY
   92 LV = LV + 10
   93 IF(IPRVTX.EQ.1) GOTO 100
C        MOVE PRIMARY VERTEX TO FIRST POSITION
      M = IPRVTX - 1
      LV = M*10
      DO 94 I=1,10
   94 VSAVE(I) = V(LV+I)
      DO 96 I=1,M
      DO 95 J=1,10
   95 V(LV+J) = V(LV+J-10)
   96 LV = LV - 10
      DO 97 I=1,10
   97 V(I) = VSAVE(I)
      J = 0
      DO 99 I=1,NT
      IF(IT(J+1).EQ.0) GOTO 99
      IF(IT(J+14).EQ.IPRVTX) GOTO 98
      IF(IT(J+14).LT.IPRVTX) IT(J+14)=IT(J+14)+1
      GOTO 99
   98 IT(J+14) = 1
   99 J = J + 40
C
  100 RETURN
      END
      FUNCTION XFWID(IPHEAD)
C-----------------------------------------------------------------------
C
C
C     RETURNS THE NUMBER OF RADIATION LENGTHS FROM THE INSIDE OF THE
C     BEAM PIPE TO THE FIRST GAS MOLECULE IN THE JET CHAMBER TANK.
C     BASED ON DATE IN HEAD BANK.
C     MC-DATA: NEW GEOMETRY IS FORCED IF FLAG LVTXC IS TRUE
C     ARGUMENT DUMMY IS IGNORED.
C
C   RADIATION LENGTH UPDATE, 9.6.1986    J.O.
C   RADIATION LENGTH UPDATE, 11.6.1986    J.O.
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL NEWDET,LVTXC,LNHARD
C
#include "cdata.for"
#include "cadmin.for"
C
      COMMON / CVCEX  / LVTXC
C
C------------------  C O D E  ------------------------------------------
C
      IH2    = 2*IPHEAD
C
      IMONTH = HDATA(IH2+7)
      IYEAR  = HDATA(IH2+8)
C
C                            OLD GEOMETRY (PRIOR TO MAY 1984)
C
C
C   FOR VALUE OF RADIATION LENGTH, SEE JCN 87
C
      XFWID = 0.1604
C                            NEW DETECTOR HARDWARE IN MONTE-CARLO DATA?
C                            THEN LVTXC IS TRUE (FLAG IS CHECKED AND
C                                                SET IN RDMTCO)
C
      LNHARD = (IMONTH .GE. 5  .AND.  IYEAR .EQ. 1984)
     +                          .OR.  IYEAR .GE. 1985
      NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
C
      IF( .NOT. NEWDET ) RETURN
C
C                            NEW GEOMETRY
C
      XFWID = 0.1443
C
      IF ((IEVTP.NE.0).AND.(IYEAR.LE.1985)) XFWID = 0.1334
C
      RETURN
      END
      FUNCTION XFWVXC(IPHEAD)
C-----------------------------------------------------------------------
C
C
C     RETURNS THE NUMBER OF RADIATION LENGTHS FROM THE INSIDE OF THE
C     BEAM PIPE TO THE FIRST GAS MOLECULE IN THE VERTEX CHAMBER.
C     BASED ON DATE IN HEAD BANK.
C     MC-DATA: NEW GEOMETRY IS FORCED IF FLAG LVTXC IS TRUE
C     ARGUMENT DUMMY IS IGNORED.
C
C   RADIATION LENGTH UPDATE, 9.6.1986    J.O.
C   RADIATION LENGTH UPDATE, 11.6.1986    J.O.
C
C       X0(BEAMPIPE)                0.03371
C       X0(1.KAPTON)                0.00011
C       X0(2.KAPTON+CU)             0.00148
C       X0(3.KAPTON+CU)             0.00262
C       X0(COOLING PIPES)           0.00107
C                                  =========
C                                   0.03899
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL NEWDET,LVTXC,LNHARD
C
#include "cdata.for"
#include "cadmin.for"
C
      COMMON / CVCEX  / LVTXC
C
C------------------  C O D E  ------------------------------------------
C
      IH2    = 2*IPHEAD
C
      IMONTH = HDATA(IH2+7)
      IYEAR  = HDATA(IH2+8)
C
C                            OLD GEOMETRY (PRIOR TO MAY 1984)
C
C
C   FOR VALUE OF RADIATION LENGTH, SEE JCN 87
C
      XFWVXC = 0.00000
C                            NEW DETECTOR HARDWARE IN MONTE-CARLO DATA?
C                            THEN LVTXC IS TRUE (FLAG IS CHECKED AND
C                                                SET IN RDMTCO)
C
      LNHARD = (IMONTH .GE. 5  .AND.  IYEAR .EQ. 1984)
     +                          .OR.  IYEAR .GE. 1985
      NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
C
      IF( .NOT. NEWDET ) RETURN
C
C                            NEW GEOMETRY
C
      XFWVXC = 0.03899
C
      IF ((IEVTP.NE.0).AND.(IYEAR.LE.1985)) XFWVXC = 0.03371
C
      RETURN
      END
      REAL FUNCTION PARKOR*8(IP)
C COPIED AND RENAMED FROM F22KLE.JVTXC.S(PARCOR)   18.9.1986
C
C     IP : POINTER TO TRACK IN PATR-BANK
C
C     CURVATURE-CORRECTION FOR CIRCLES FITTED WITH A PARABOLA
C
      REAL*8 P,Q,R,CM,D,U,V,C
C
      INTEGER*2 HDATA
#include "cdata.for"
C
C *** MEASURED CURVATURE
      CM = -ADATA(IP+22)
      C  =  ADATA(IP+25) * 0.5
      IF (IDATA(IP+18).NE.2) GOTO 100
C *** MEASURED PROJ. TRACKLENGTH
      R  = ABS( ( ADATA(IP+7) - ADATA(IP+14) ) / ADATA(IP+30) ) * 0.5
C
C     CARDANS RULE
C
      P =  7.D0/(18.D0*R*R)
      Q = -7.D0*CM/(12.D0*R*R)
C
      D = DSQRT(Q*Q+P*P*P)
      U = (-Q+D)**(1./3.)
      V = ( Q+D)**(1./3.)
      C = U-V
C
  100 CONTINUE
      PARKOR = C * 2.0D0
C
      RETURN
      END
      SUBROUTINE WTXCRV( NRUN, RVX, RVY ,RVDX, RVDY)
C
C   THIS SUBROUTINE RETURNS FOR A GIVEN RUNNUMBER 'NRUN'
C   THE WITH THE VERTEXCHAMBER CALCULATED RUNVERTEX '(RVX,RVY)'
C   AND ERRORS (RVDX,RVDY)
C   ( IN DETECTOR-COORDINATES )
C
C
      DIMENSION VSTORE(5,37), VS1(5,19), VS2(5,18)
C
      EQUIVALENCE (VSTORE(1,1),VS1(1,1)), (VSTORE(1,20),VS2(1,1))
C
      DATA RLAST  / 24187. /, IPER / 1 /, NCALL / 0 /
C
      DATA VS1 /
     &    20275.,  1.177    ,  .9093E-01,  1.722    ,  .5080E-01,
     &    20366., -1.971    ,  .2840    ,  1.267    ,  .1860    ,
     &    20370.,  1.847    ,  .4167    ,  1.455    ,  .1442    ,
     &    20385., -.4718    ,  .1308    ,  1.868    ,  .6758E-01,
     &    20980.,  .7311    ,  .1489    ,  1.984    ,  .5378E-01,
     &    21008., -.4295    ,  .1269    ,  1.949    ,  .7287E-01,
     &    21211.,  .2094    ,  .8336E-01,  2.052    ,  .4016E-01,
     &    21310., -1.267    ,  .7253E-01,  1.975    ,  .3805E-01,
     &    21329., -.2575    ,  .3390E-01,  1.976    ,  .1680E-01,
     &    21808., -.6072E-01,  .5099E-01,  1.592    ,  .3412E-01,
     &    22026., -.5669    ,  .4785E-01,  1.665    ,  .2744E-01,
     &    22162.,  .4993    ,  .6722E-01,  1.862    ,  .3471E-01,
     &    22214., -.1608E-01,  .6566E-01,  1.937    ,  .3577E-01,
     &    22367.,  .6297    ,  .6978E-01,  1.855    ,  .4481E-01,
     &    22416., -.3393    ,  .6317E-01,  1.910    ,  .2997E-01,
     &    22559., -1.412    ,  .4251E-01,  1.925    ,  .2345E-01,
     &    22854., -.4245    ,  .1020    ,  1.908    ,  .5556E-01,
     &    22897.,  .9606    ,  .1222    ,  1.858    ,  .8161E-01,
     &    22901.,  .2585    ,  .1539    ,  2.215    ,  .8853E-01/
      DATA VS2 /
     &    22915., -.4097    ,  .1003    ,  1.963    ,  .4599E-01,
     &    22976.,  .1262    ,  .1114    ,  1.735    ,  .6050E-01,
     &    23044., -.7860    ,  .2345    ,  2.029    ,  .1177    ,
     &    23054.,  .2327    ,  .8883E-01,  1.830    ,  .5139E-01,
     &    23096.,  .8635    ,  .5580E-01,  1.764    ,  .2453E-01,
     &    23211.,  .3967E-01,  .6786E-01,  1.631    ,  .3873E-01,
     &    23326.,  .6146    ,  .5488E-01,  1.684    ,  .3087E-01,
     &    23418.,  1.595    ,  .2312E-01,  1.730    ,  .1193E-01,
     &    23838., -.3356    ,  .3926E-01,  1.736    ,  .2447E-01,
     &    23993.,  .9898    ,  .1815    ,  1.437    ,  .9115E-01,
     &    24008.,  .3999    ,  .9235E-01,  1.608    ,  .7332E-01,
     &    24016.,  1.018    ,  .9523E-01,  1.683    ,  .4518E-01,
     &    24034.,  1.135    ,  .1226    ,  1.432    ,  .7125E-01,
     &    24050.,  1.041    ,  .1383    ,  1.775    ,  .7137E-01,
     &    24057.,  .3728    ,  .7962E-01,  1.614    ,  .3897E-01,
     &    24094., -.8727    ,  .5520E-01,  1.648    ,  .2776E-01,
     &    24143.,  .6927    ,  .7144E-01,  1.630    ,  .3140E-01,
     &    99999.,  0.000    ,  0.000    ,  0.000    ,  0.000        /
C
      IF (NCALL.EQ.0) WRITE(6,9000)
 9000 FORMAT(/
     &' *** WARNING : RUNVERTICES ARE PRELEMINARY (18.4.86 C.K.) ***'/)
      NCALL = NCALL + 1
C
      RVX  = 0.
      RVDX = 0.
      RVY  = 0.
      RVDY = 0.
C
      RUN = FLOAT(NRUN)
C
      IF ((RUN.LT.VSTORE(1,1)).OR.(RUN.GT.RLAST)) GOTO 999
C
      IF (RUN.LT.VSTORE(1,IPER)) GOTO 300
C
  200 CONTINUE
      IF (RUN.LT.VSTORE(1,IPER+1)) GOTO 400
      IPER = IPER + 1
      GOTO 200
C
  300 CONTINUE
      IPER = IPER - 1
      IF (RUN.LT.VSTORE(1,IPER)) GOTO 300
C
  400 CONTINUE
C
      RVX  = VSTORE(2,IPER)
      RVDX = VSTORE(3,IPER)
      RVY  = VSTORE(4,IPER)
      RVDY = VSTORE(5,IPER)
C
  999 CONTINUE
C
      RETURN
      END

C   01/11/84 512201616  MEMBER NAME  CROAX    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE CROAX(INDEX)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON       ?    :  DRAWS AN AXIS CROSS
C
C       MOD:   J. OLSSON   17/12/83 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 19/10/84 :  NEW INDEX=20
C  LAST MOD:   C. BOWDERY  20/12/85 :  DO NOTHING IF OPTION 48 IS ON
C
C
C     DRAWS AN AXIS CROSS WITH SYMBOLS WRITTEN, AT POSITION X1,Y1.
C     INDEX REFERS TO VIEW INDEX IN JADE GRAPHICS DISPLAY SYSTEM.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
      LOGICAL FL18,FL22,FL24
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CPROJ /XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24,KPROJ
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      DIMENSION  ISGN(4,3),IPER(4,3),HTX(4)
C
      DATA HTX /'X ','Y ','Z ','  '/
      DATA ISGN / 1,1,1,1,1,-1,1,-1,-1,1,1,1 /
      DATA IPER / 2,1,2,2,3,2,1,3,1,3,3,1 /
      DATA FSCA1 /25./, F1,F2,F3 /3.5,1.,2.5/,FX,FY /.08,.05/,FFX /.05/
      DATA FSCA2 /15./, FX1,FY1,FY2 /.735,.08,.66/
C
C------------------  C O D E  ------------------------------------------
C
C                            IF OPTION 48 IS ON, DRAW NO AXES
C
      IF( DSPDTM(18) ) RETURN
C
      IF( INDEX .LT. 0  .OR.  INDEX .EQ. 13  .OR.  INDEX .EQ. 15) RETURN
      IF( INDEX .EQ. 16 ) RETURN
      IF( INDEX .NE. 12 ) GO TO 143
C
C                            FORWARD DETECTOR DISPLAY
C
      XADD = XMIN + FFX*(XMAX-XMIN)
      GO TO 163
143   CONTINUE
      IF( .NOT. FL18) GO TO 160
      XADD = XMIN + FX1*(XMAX-XMIN)
      IF( KPROJ .NE. 1 ) GO TO 161
      YADD = YMIN + FY1*(YMAX-YMIN)
      GO TO 162
161   YADD = YMIN + FY2*(YMAX-YMIN)
162   FSCA = (XMAX-XMIN)*FSCA2/4096.
      GO TO 170
160   XADD = XMIN + FX*(XMAX-XMIN)
163   YADD = YMIN + FY*(YMAX-YMIN)
      FSCA = (XMAX-XMIN)*FSCA1/4096.
170   CALL CHRSIZ(4)
      IF( INDEX .EQ. 20 ) GO TO 50
      IF( INDEX .GT. 3  .AND.  INDEX .NE. 14 .AND.INDEX.NE.17) GO TO 10000005900
C
C                            RFI-VIEWS
C
 50   IX = 1
      GO TO 300
100   IF( INDEX .GT. 7  .AND.  INDEX .NE. 18 ) GO TO 200
C
C                            X-Z VIEWS
C
      IX = 2
      GO TO 300
C
C                            Y-Z VIEWS
C
200   IX = 3
      IF( INDEX .EQ. 12 ) IX = 1
300   ALFA = 135.
      DO 1  I = 1,3
      CALL MOVEA(XADD,YADD)
      ALFA = ALFA - 45.
      CALL RROTAT(ALFA)
      IS = ISGN(IX,I)
      CALL DRAWR(IS*FSCA*F1,0.)
      CALL MOVER(0,-FSCA*F2)
      CALL DRAWR(0,2.*FSCA*F2)
      CALL DRAWR(IS*FSCA*F3,-FSCA*F2)
      CALL DRAWR(-IS*FSCA*F3,-FSCA*F2)
      CALL MOVER(IS*(F3+1.4)*FSCA,FSCA*F2*.5)
      IS = IPER(IX,I)
1     CALL EOUTST(2,HTX(IS))
      RETURN
C
      END

      SUBROUTINE SRTREL
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C----------------------------------------------------------------------
C           MACRO CCYCP .... JET CHAMBER HIT POINTERS (PATREC)
C----------------------------------------------------------------------
      INTEGER*4 HPTSEC
      COMMON/CCYCP/HPTSEC(98)
C     HPTSEC(I) = CDATA POINTER TO 1ST I*2 WORD FOR 1ST HIT OF CELL I
C------------------------ END OF MACRO CCYCP --------------------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
     ,         , (ITR   ,IDWRK(7)),(ITRNG ,IDWRK(8))
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      DATA MKTREL / Z3000/
      DATA MKLBTC / ZFFF/
      DATA MKLFTR / Z 30000/, MKRGHT / Z20000/
      INTEGER  MKLRHT(3) / Z800, Z0, Z900/
      DATA LBZRCR / Z100/
      DATA NANF /0/
      IF(NANF.EQ.0) IQPATR= IBLN('PATR')
      NANF = 1
      IPPATR = IDATA(IQPATR)
          HPFRE0 = HPFREE
          CALL PRHTAR
      IF(
     - NHIT.GE.5
     -)THEN
            CALL FLINEL
            CALL FTRKEL
      IF(
     - NTRKEL.GT.0
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
            NLINUC = 0
      DO 13000 IP=HPHT0,HPHT9,HLDHT
              IF(IWRK(IP+9).EQ.0 .AND. LAND(IWRK(IP+4),7).NE.0)
     .        NLINUC = NLINUC + 1
13000 CONTINUE
13001 CONTINUE
            IDATA(IPPATR+7) = IDATA(IPPATR+7) + NLINUC
      ENDIF
          HPFREE = HPFRE0
      RETURN
17000 CONTINUE
        ICLL16 = (ICELL-1) * 16
        NTRCLL = 0
      DO 13002 IPTR = HPTR0,HPTR9,HLDTR
      IF(
     - ITR.LE.200 .AND. ITRNG.LT.128
     -)THEN
      IF(
     - LAND(IWRK(IPTR+15),MKTREL).NE.0
     -)THEN
            NTRCLL = NTRCLL + 1
            LB = LAND(IWRK(IPTR+15),MKLBTC)
            DRSP1 = WRK(IPTR+ 8)
            DRSP2 = WRK(IPTR+11)
            IF(DRSP1*DRSP2.LT.0) LB = LOR(LB,LBZRCR)
            LBLR = LAND(IWRK(IPTR+15),MKLFTR)
            IF(DRSP1.LT.0..AND.LBLR.NE.0.AND.LBLR.NE.MKLFTR)
     .         LBLR = LXOR(LBLR,MKLFTR)
            LB = LOR(LB,ISHFTR(LBLR,6))
            ITRKAR(ITR, 1) = ICELL
            ITRKAR(ITR, 2) = IWRK(IPTR+ 2)
            ITRKAR(ITR, 3) = IWRK(IPTR+ 7)
            TRKAR (ITR, 4) = ABS(DRSP1)
            DRSL1          = WRK(IPTR+ 9)
            IF(DRSP1.LT.0.)  DRSL1 =-DRSL1
            TRKAR (ITR, 5) = DRSL1
            ITRKAR(ITR, 6) = IWRK(IPTR+10)
            TRKAR (ITR, 7) = ABS(DRSP2)
            DRSL2          = WRK(IPTR+12)
            IF(DRSP2.LT.0.)  DRSL2 =-DRSL2
            TRKAR (ITR, 8) = DRSL2
            ITRKAR(ITR, 9) = LB
            ITRKAR(ITR,10) = ITRNG
            IDXLR =-1
            IF(LBLR.EQ.MKRGHT) IDXLR = 1
            IF(DRSP1.LT.0.) IDXLR =-IDXLR
            IDXLR1 = IDXLR
            ILAYZ =-1
      DO 13004 IP=HPHT0,HPHT9,HLDHT
      IF(
     - IWRK(IP+9).EQ.IPTR .OR.IWRK(IP+10).EQ.IPTR
     -)THEN
                DRSP = WRK(IP+2)
            IF(IWRK(IP+10).EQ.IPTR .AND. TBIT(IWRK(IP+4),20)) DRSP=-DRSP
                IF(DRSP.NE.0.) IDXLR1 = IDXLR
      IF(
     - DRSP*DRSP1.LT.0.
     -)THEN
                  IDXLR1 =-IDXLR
                  IF(ILAYZ.LT. 0) ILAYZ = IWRK(IP)
      ENDIF
                IPLBHT = (IWRK(IP+1) - HPTSEC(1))/2 + HPHL0
                LBHIT = ITRNG*2
                LBHIT = LOR(LBHIT,MKLRHT(IDXLR1+2))
      IF(
     - HWRK(IPLBHT).EQ.0
     -)THEN
                  HWRK(IPLBHT) = LBHIT
      ELSE
                  IF(HWRK(IPLBHT+1).EQ.0) HWRK(IPLBHT+1) = LBHIT
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
            IF(LAND(LB,LBZRCR).NE.0 .AND. ILAYZ.LT.0)
     .                                    ILAYZ = IWRK(IPTR+10) + 1
            IF(ILAYZ.LT.0) ILAYZ = 0
            ITRKAR(ITR,11) = ILAYZ
            ITR   = ITR   + 1
            ITRNG = ITRNG + 1
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
      GOTO IZZZ01
      END

C   24/11/78 402191820  MEMBER NAME  SAEGE    (JADEGS)      FORTRAN
      SUBROUTINE SAEGE(X0,Y0,X1,Y1)
C---
C---    DRAWS SAWTOOTH FUNCTION. THIS IS SUPPOSED TO LOOK LIKE A PHOTON.
C---    LAST UPDATE  10.2.1984  J.O.
C---
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C---
      RLEN=SQRT((X0-X1)**2+(Y0-Y1)**2)
      IF(RLEN.LT..1) GO TO 2
      DIV = (XMAX-XMIN)/30./6.! PMF 29/11/99: add factor 1/6.
C     NSTEPS=RLEN/100.
      NSTEPS=RLEN/DIV
      IF(NSTEPS.LT.2) NSTEPS=2
      STEPX=(X1-X0)/NSTEPS
      STEPY=(Y1-Y0)/NSTEPS
      CALL MOVEA(X0,Y0)
      ISIGN=1
      DX=-0.5*STEPY
      DY= 0.5*STEPX
      XB=X0+0.5*STEPX
      YB=Y0+0.5*STEPY
      XP=XB+ISIGN*DX/2.
      YP=YB+ISIGN*DY/2.
      CALL DRAWA(XP,YP)
      DO 1 ISTEP=2,NSTEPS
      ISIGN=-ISIGN
      XB=X0+STEPX*(ISTEP-0.5)
      YB=Y0+STEPY*(ISTEP-0.5)
      XP=XB+ISIGN*DX/2.
      YP=YB+ISIGN*DY/2.
      CALL DRAWA(XP,YP)
    1 CONTINUE
      CALL DRAWA(X1,Y1)
    2 CONTINUE
      RETURN
      END

C   07/02/87 809291231  MEMBER NAME  TPTFTP   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE TPTFTP
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       7/02/87:  Add TOF data to TPTR banks
C
C     Last mod: C. Bowdery      29/09/88:  CALL TPSEFL now
C
C     Based on routine written by S. Yamada.
C
C     Routine to copy information from the TOFR bank into the TPTR
C     banks.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      INTEGER  LENAR, NSTEP, TOF

      PARAMETER  ( LENAR = 100, TOF = 3 )
      PARAMETER  ( NSTEP =  14 )

      INTEGER  IPNTA( LENAR ), ITOFR, NTRK, NBNKS, ITPTRI, I, K, NT

C------------------  C O D E  ------------------------------------------

      ITOFR = IDATA( IBLN('TOFR') )

      IF( ITOFR .GT. 0 ) THEN

        NTRK = IDATA( ITOFR + 1 )

C                            Get the pointers to the TPTR banks

        CALL BDAR( 'TPTR', NBNKS, IPNTA, LENAR )

C                            Warn if no. of TPTR banks exceeds space

        IF( NBNKS .EQ. LENAR ) THEN
          CALL TPWARN
        ENDIF

C                            Process each TPTR bank in turn

        DO  100  I = 1,NBNKS

          ITPTRI  = IPNTA(I)

C                            Is the track seen in the Jet Chamber?

          IF( HDATA( 2*ITPTRI + 3 ) .LT. 1000 ) GO TO 100

          INDEX = HDATA( 2*ITPTRI + 4 )

          IF( INDEX .LE. 0  .OR.  INDEX .GT. NTRK ) THEN
            CALL TPERRH
            CALL TPSEFL( TOF, 1000 )
          ELSE
            NT = ITOFR + 4 + ( INDEX - 1 ) * NSTEP

            IF( IDATA( NT + 1 ) .NE. INDEX ) THEN
              CALL TPERRH
              CALL TPSEFL( TOF, 1000 )
            ELSE

C                            TOF quality

              IDATA( ITPTRI + 58 ) = IDATA( NT + 2 )

C                            TOF identification probabilities

              DO  20  K = 4,14
                ADATA( ITPTRI + 55 + K ) = ADATA( NT + K )
   20         CONTINUE

            ENDIF

          ENDIF

  100   CONTINUE

      ELSE

        CALL TPSEFL( TOF, 1000 )
        CALL TPWARN

      ENDIF

      RETURN
      END

C   07/06/96 606071912  MEMBER NAME  SPLSMW   (S4)          FORTG1
      SUBROUTINE SPLSMW(Y,X,W,N,A,NSP,CHDF)
      REAL Y(N),X(N),W(N),A(5,NSP),S(4)
      CHDF=0.0
      IF(N.LT.3.OR.NSP.LT.4) GOTO 100
      DX=(X(N)-X(1))/FLOAT(NSP-3)
      DO 10 I=1,NSP
      DO 10 J=1,5
   10 A(J,I)=0.0
C
      DO 40 L=1,N
      XL=(X(L)-X(1))/DX
      IF(XL.LT.0.0) XL=0.0
      LX=XL
      LX=MIN0(LX,NSP-4)
      XL=FLOAT(LX+1)-XL
      DO 20 J=1,4
      IF(J/2.EQ.1) GOTO 15
      S(J)=XL*XL*XL
      GOTO 20
   15 S(J)=1.0+3.0*(1.0+XL*(1.0-XL))*XL
      IF(J.EQ.2) XL=1.0-XL
   20 CONTINUE
      DO 30 I=1,4
      A(5,LX+I)=A(5,LX+I)+Y(L)*S(I)*W(L)
      DO 30 J=1,I
      IJ=I+1-J
   30 A(IJ,LX+J)=A(IJ,LX+J)+S(I)*S(J)*W(L)
   40 CONTINUE
C
      CALL BANDSL(A,NSP,5,IER)
      IF(IER.NE.0) GOTO 100
C
      DO 60 L=1,N
      XL=(X(L)-X(1))/DX
      IF(XL.LT.0.0) XL=0.0
      LX=XL
      LX=MIN0(LX,NSP-4)
      XL=FLOAT(LX+1)-XL
      SUM=0.0
      DO 50 J=1,4
      IF(J/2.EQ.1) GOTO 45
      SX=XL*XL*XL
      GOTO 50
   45 SX=1.0+3.0*(1.0+XL*(1.0-XL))*XL
      IF(J.EQ.2) XL=1.0-XL
   50 SUM=SUM+SX*A(5,LX+J)
      CHDF=CHDF+(SUM-Y(L))*W(L)
      Y(L)=SUM
   60 CONTINUE
      CHDF=CHDF/FLOAT(N+2-NSP)
  100 RETURN
      END

C   07/06/96 606071836  MEMBER NAME  BUNLDA   (S4)          FORTG1
      SUBROUTINE BUNLDA(IUNDA,IUNTP,NREC,NPAG,IPASS)
      COMMON/BCS/IW(1)
#include "ccs.for"
      INTEGER DIRA/'+DIR'/,DIRO/'DIRA'/
      REAL*8 DATE(2)
      CALL DAY(DATE(1),DATE(2))
      WRITE(6,101) IUNDA,IUNTP
      IUND=IUNDA
      INDA=0
      CALL BDLS('+DIR',IUND)
      CALL BDLS('+DIR',-1)
      CALL BGAR(IGA)
      NPAGL=NPAG
      IF(NREC.NE.0) GOTO 5
      IPAS=IPASS
      LISTE(1)=0
      LISTE(2)=0
      CALL PODA(1,LISTE,1)
      NRECL=IW(INDA+7)
      CALL UCOPY(DATE,IW(INDA+29),4)
      GOTO 10
    5 NRECL=NREC
   10 CALL BCRE(INDL,'+DIR',-1,900,&15,IER)
      NPG=0
      NE =0
      NERR=0
      NSE=0
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.GT.5040) GOTO 20
   15 WRITE(6,102)
      GOTO 90
   20 NRC=0
   25 NTOT=0
      IB=IA
   30 NRC=NRC+1
      ISW=0
      IF(NRC.LE.NRECL) GOTO 32
      ISW=2
      GOTO 50
   32 CALL RDDA(NRC,NTOTN,IW(IB))
      IF(NTOTN.EQ.0) GOTO 36
      IF(NTOTN.GT.4.AND.NTOTN.LE.1609) GOTO 35
      NERR=NERR+1
      GOTO 25
   35 IF(IW(IB).NE.DIRA.AND.IW(IB).NE.DIRO) GOTO 40
   36 ISW=1
      GOTO 50
   40 NTOT=NTOT+NTOTN
      IF(IA.EQ.IB) GOTO 50
C     COMPARE NAME AND NR
      IF(IW(IA  ).NE.IW(IB)  ) GOTO 50
      IF(IW(IA+1).NE.IW(IB+1)) GOTO 50
C     EQUAL
      NW=IW(IB+3)
      CALL UCOPY2(IW(IB+4),IW(IB),NTOTN-4)
      NTOT=NTOT-4
      IW(IA+3)=IW(IA+3)+NW
C
   50 IND=IA+3
      IF(NTOT.EQ.0.AND.ISW.EQ.2) GOTO 66
      IF(NTOT.EQ.0) GOTO 25
   52 NW=IW(IND)
      IF(NW.LE.0) GOTO 54
      IF(IA+NTOT-1-IND-NW) 54,56,60
C     ERROR
   54 CONTINUE
      GOTO 25
C     LAST BANK
   56 IF(ISW.NE.0) GOTO 60
      CALL UCOPY2(IW(IND-3),IW(IA),NW+4)
      NTOT=NW+4
      IB=IA+NTOT
      ISW=0
      GOTO 30
   60 NWR=NW+4
      IF(IUNTP.NE.0) CALL WRSQ(IUNTP,NWR,IW(IND-3))
      NSE=NSE+1
      IF(NE.NE.0) GOTO 64
      INDX=INDL
      DO 62 I=1,300
      IW(INDX+1)=BLANK
      IW(INDX+2)=0
      IW(INDX+3)=0
   62 INDX=INDX+3
   64 JCOL=NE/60
      INDX=INDL+JCOL*3+(NE-JCOL*60)*15
      IW(INDX+1)=IW(IND-3)
      IW(INDX+2)=IW(IND-2)
      IW(INDX+3)=IW(IND)
      NE=NE+1
      IF(ISW.EQ.2) GOTO 66
      IF(NE.LT.300) GOTO 70
   66 IF(NPG.GE.NPAGL) GOTO 68
      WRITE(6,103) (IW(INDL+I),I=1,900)
      NPG=NPG+1
   68 IF(NE.EQ.300) NE=0
      IF(ISW.EQ.2) GOTO 90
   70 IND=IND+4+NW
      GOTO 52
   90 IF(INDA.EQ.0) GOTO 92
      IF(IUNTP.EQ.0) GOTO 92
      IF(IW(INDA+20).NE.0) GOTO 92
      LISTE(1)=DIRA
      LISTE(2)=DIRO
      CALL CHDIR
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
   92 CALL BDLS('+DIR',-1)
      CALL BDLS('+DIR',IUND)
      CALL BGAR(IGA)
      WRITE(6,106) NSE,NERR
C
  100 RETURN
  101 FORMAT('0---- BUNLDA     START FOR DA-DATASET',I3,', UNLOAD TO',
     1   ' SQ-DATASET',I3)
  102 FORMAT('0---- BUNLDA     NOT ENOUGH SPACE'/)
  103 FORMAT('1---- BUNLDA     TABLE OF CONTENT'//
     1 (1X,5(A4,I10,I6,6X)))
  106 FORMAT('0---- BUNLDA     END',10X,I10,' RECORDS(BANKS)',
     1   ' COPIED,',I6,' ILLEGAL RECORDS'/)
      END

C   27/08/83 310271210  MEMBER NAME  STPALL   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE STPALL( LENGTH, IPALL )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   29/06/83 :  FILL FOUR VECTOR BANK 'PALL'/0
C
C        MOD  C. BOWDERY   20/10/83 :  NEW CPROD MACRO
C   LAST MOD  C. BOWDERY   27/10/83 :  IFLAVR ==> IABS( IFLAVR )
C
C  FILL FOUR VECT BANK PALL  WHICH CONTAINS ALL THE PARTICLES.
C
C  LENGTH = TOTAL LENGTH OF IPALL ARRAY
C
C  IPALL( 1) = LGTH OF HEADER=L0   IPALL( 2) = LENGTH OF 1PARTICLE DATA
C  IPALL( 3) = EVT #               IPALL( 4) = TOTAL # OF PARTICLES
C  IPALL( 5) = # OF CHARGED PART.  IPALL( 6) =  # OF NEUTRAL PARTICLES
C   VECT( 7) = PHI OF JET AXIS      VECT( 8) = COS(THETA) OF JET AXIS
C  IVECT( 9) = FLAVOUR OF EVENT
C
C  IPALL( L0 + 1 - 4 ) = MOMENTUM FOUR VECTOR
C  IPALL(L0+5) = MASS OF PARTICLE  IPALL(L0+6) = CHARGE OF PARTICLE
C  IPALL(L0+7) = PARTICLE TYPE
C  IPALL(L0 + 8 ) = PARENT PARTICLE NUMBER IN LIST
C  IPALL(L0 + 9 ) = NO. OF PARTON WHICH GAVE RISE TO THIS PARTICLE
C                                           AT THE START.
C  EXTRA ENTRY LHPALL RETURNS LENGTH ONLY
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cprod.for"
C
*** PMF 15/10/99      DIMENSION IPALL(1) , IPP(4,500) , IXM(500)
      DIMENSION IPALL(*) , IPP(4,500) , IXM(500)
*** PMF (end)
C
      EQUIVALENCE (IPP(1,1),PP(1,1)) , (IXM(1),XM(1))
      EQUIVALENCE (IPHI,PHI) , (ITHETA,THETA)
C
      DATA L0 / 9 /, L1 / 9 /
C
C--------------------  C O D E  ----------------------------------------
C
C                   BANK HEADER
C
      IPALL( 1) = L0
      IPALL( 2) = L1
      IPALL( 3) = NEV
      IPALL( 4) = NP
      IPALL( 5) = NC
      IPALL( 6) = NN
      IPALL( 7) = IPHI
      IPALL( 8) = ITHETA
      IPALL( 9) = IABS( IFLAVR )
      J = L0
C
C                  STORE DATA FOR EACH PARTICLE
C
      NJET = 0
      DO 10 K =1,NP
      IPALL(J+ 1) = IPP(1,K)
      IPALL(J+ 2) = IPP(2,K)
      IPALL(J+ 3) = IPP(3,K)
      IPALL(J+ 4) = IPP(4,K)
      IPALL(J+ 5) = IXM(K)
      IPALL(J+ 6) = JCH(K)
      IPALL(J+ 7) = JTP(K)
      IPALL(J+ 8) = JP(K,1)
      IPALL(J+ 9) = JP(K,2)
   10 J = J + L1
C
C----------------------------------------------------------
      ENTRY LHPALL( LENGTH )
C----------------------------------------------------------
C
C                                      LENGTH OF BANK
      LENGTH = NP*L1 + L0
      RETURN
      END

C   07/06/96 606071903  MEMBER NAME  PTABL    (S4)          FORTG1
      SUBROUTINE PTABL(KNA)
      COMMON/BCS/IW(1)
      INTEGER NF(8),NY(16),N/0/
      INTEGER*2 NH(16),NCH(2)
      EQUIVALENCE (NF(1),NH(1)),(N,NCH(1))
      REAL*8 TEXT(16),TEXTS
      KAL=-1
      CALL BPOS('TAB*')
   10 CALL BNXT(IND,&90)
      NC=IW(IND-2)
      KA=NC/16
      IF(KNA.NE.0.AND.KNA.NE.KA) GOTO 10
      II=NC-KA*16
      II=II*16
      IF(KAL.EQ.KA) GOTO 20
      IF(KAL+1.EQ.0) GOTO 14
      NT=0
      DO 12 I=1,16
      CALL ITODA(NY(I),TEXT(I),6)
   12 NT=NT+NY(I)
      CALL ITODA(NT,TEXTS,8)
      WRITE(6,103) TEXT,TEXTS
   14 DO 18 I=1,16
      NY(I)=0
   18 CALL ITODA(I-1,TEXT(I),-6)
      WRITE(6,101) KA,TEXT
      KAL=KA
   20 DO 50 I=1,16
      DO 30 J=1,8
   30 NF(J)=IW(IND+8*(I-1)+J)
      NS=0
      DO 40 J=1,16
      NCH(2)=NH(J)
      NS=NS+N
      NY(J)=NY(J)+N
   40 CALL ITODA(N,TEXT(J),6)
      CALL ITODA(NS,TEXTS,8)
      IF(NS.EQ.0) GOTO 50
      IJ=II+I-1
      WRITE(6,102) IJ,TEXT,IJ,TEXTS
   50 CONTINUE
      GOTO 10
   90 IF(KAL+1.EQ.0) GOTO 100
      IF(KNA.NE.0.AND.KNA.NE.KA) GOTO 100
      NT=0
      DO 92 I=1,16
      CALL ITODA(NY(I),TEXT(I),6)
   92 NT=NT+NY(I)
      CALL ITODA(NT,TEXTS,8)
      WRITE(6,103) TEXT,TEXTS
  100 RETURN
  101 FORMAT('0',4('----')/' UTABL',I11//
     1                    8X,'J=',4(4A6,1X),13X,'SUM'/
     2   7X,'I',/7X,'= +',25('----'),'-+')
  102 FORMAT(1X,I7,' I',4(4A6,1X),' I',I4,2X,A8)
  103 FORMAT(9X,'+-',25('----'),'+'/5X,'SUM',2X,4(4A6,1X),8X,A8/)
      END

C   20/10/81 303161051  MEMBER NAME  MUFFLS   (JADEMUS)     FORTRAN
C   28/03/81 106171601  MEMBER NAME  MUFFLS   (WORKS)       FORTRAN
C   24/03/80 004021728  MEMBER NAME  MUFFLS   (JADEMUS1)    FORTRAN
C   21/05/79 C9070301   MEMBER NAME  MUFFLS   (S)           FORTRAN
C LAST CHANGE 11.00 16/03/83 HUGH MCCANN  - BACK TO STANDARD M.SC. CONST
C      CHANGE 16.04 17/06/81 JOHN ALLISON - DPINA/DKNA CALCN. COMMENTED.
C      CHANGE 16.03 17/06/81 JOHN ALLISON - TO COPE WITH BACK-TRACKING.
C                              (ACTUALLY REQUIRED NO CHANGE. JA.)
C      CHANGE 08.00 10/04/80 HUGH MCCANN - CHANGE MULT. SCATT. CONSTANT
C      CHANGE 17.28 02/04/80 JOHN ALLISON.
C TAKEN FROM JADEMUS 20.15 24/03/80 TO ADD PIDK AND MULTSC.  JA.
C      CHANGE 01.28 03/07/79 JOHN ALLISON.
      SUBROUTINE MUFFLS(*)
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C
C STEPS THROUGH DETECTOR, CALCULATING ENERGY LOSS, MULTIPLE SCATTERING,
C    ETC.
C
C RETURN 1 IF PARTICLE STOPS.
C
C-----------------------------------------------------------------------
C
C COMMONS.
C
C   20/10/81 408081453  MEMBER NAME  CMUFFL   (S)           FORTRAN
C
C LAST CHANGE 15.00 08/08/84 - CKB PWA     - ADD NALLWM,PMXFLG
C      CHANGE 15.00 03/12/83 - HUGH MCCANN - NEW LEAD GLASS PARAMETERS.
C      CHANGE 08.00 12/10/81 - HUGH MCCANN - TO ADD OVLCUT(FOR OVERLAPS)
C      CHANGE 09.33 17/06/81 - JOHN ALLISON - TO ADD RESOLUTIONS.
C
C-------------START OF MACRO CMUFFL-------------------------------------
C
      COMMON / CMUFFL / XYSTEP,RCOILI,RCOILO,PGMID,WMU,WMUSQ,DUMF1(4),
     +                  NSPECI,XPBAR,XPROT,XPION,XKAON,DUMF2(5),
     +                  TBP,GMBP,ABBP,RDBP,DEBP,
     +                  TJETI,GMJETI,ABJETI,RDJETI,DEJETI,
     +                  TJET1,GMJET1,ABJET1,RDJET1,DEJET1,
     +                  TJET2,GMJET2,ABJET2,RDJET2,DEJET2,
     +                  TJET4,GMJET4,ABJET4,RDJET4,DEJET4,
     +                  TJETO,GMJETO,ABJETO,RDJETO,DEJETO,
     +                  TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL,
     +                  ZJETE,TJETE,GMJETE,ABJETE,RDJETE,DEJETE,
     +                  ZEPLG,TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG,
     +                  RLG,ZLG,TLG,GMLG,ABLG,RDLG,DELG,
     +                  ZEP,TEP,GMEP,ABEP,RDEP,DEEP,
     +                  GMG(3),ABG(3),RDG(3),DEG(3),
     +                  VDRES,VLRES,
     +                  REST1,REST2,RESTMX,RESL,RESLMX,FACTOR,OVLCUT,
     +                  ZLGHAF,TLGHAF,ZLGC,GMLGC,ABLGC,RDLGC,DELGC,
     +                  NALLWM,PMXFLG
C
C FOR EXPLANATION SEE BLOCK DATA AFTER SUBROUTINE MUFFLE.
C
C--------------END OF MACRO CMUFFL--------------------------------------
C   20/10/81 202041521  MEMBER NAME  CMUFWORK (JADEMUS)     FORTRAN
C   12/10/81 110152138  MEMBER NAME  CMUFWORK (JADEMUS1)    FORTRAN
C-------------START OF MACRO CMUFWORK-----------------------------------
C LAST CHANGED 21.30 15/10/81 HUGH MCCANN  - EXTEND IOVLAP TO ALLOW
C                                            > 10 ASSOC HITS IN MUFFLY.
C LAST CHANGED 10.00 04/10/81 HUGH MCCANN  - FOR USE OF OVERLAP HITS.
C LAST CHANGED 14.46 17/06/81 JOHN ALLISON - TO ADD 'OVER' VARIABLES.
C LAST CHANGED 23.00 09/04/81 HUGH MCCANN - JADEMUS UPDATE.
C
      COMMON /CWORK/X,Y,Z,DCX,DCY,DCZ,P,PSQ,E,ESQ,D,GM,AB,RD,DE,PPIDK,
     *PKDK,PPBPEN,PPPEN,PPIPEN,PKPEN,DUMW1(29),X8,Y8,Z8,DCX8,DCY8,
     *DCZ8,P8,PSQ8,E8,ESQ8,D8,GM8,AB8,RD8,DE8,PPIDK8,PKDK8,PPBPE8,
     *PPPEN8,PPIPE8,PKPEN8,DUMW28(29),X0,Y0,Z0,DCX0,DCY0,DCZ0,P0,PSQ0,
     *E0,ESQ0,D0,GM0,AB0,RD0,DE0,PPIDK0,PKDK0,PPBPE0,PPPEN0,PPIPE0,
     *PKPEN0,DUMW2(29),X9,Y9,Z9,DCX9,DCY9,DCZ9,P9,PSQ9,E9,ESQ9,D9,GM9,
     *AB9,RD9,DE9,PPIDK9,PKDK9,PPBPE9,PPPEN9,PPIPE9,PKPEN9,DUMW29(29),
C-----200 WORDS UP TO HERE----------------------------------------------
     *X1,Y1,Z1,X2,Y2,Z2,XMID,YMID,ZMID,X3,Y3,Z3,D1,D2,D3,DTC,DUMW3(4),
     *DSTEP,GMSTEP,ABSTEP,RDSTEP,DESTEP,DUMW4(15),ADCZ,COSEC,STPINI,CURV
     *,DANG,DX,DY,DZ,R,RSQ,PT,DPINA,DKNA,DUMW5(7),VX,VY,VZ,RMSXY,RMSZ,
     *VTXYD,VTZD,VTXYAN,VTZANG,VMSANG,VMSD,CMS,DUMW6(8),SDS(10),DUMW7(1000002000
C
C    *SDX,SDY,SDZ,SDTXYD,SDTZD,SDTXYA,SDTZAN,SDMSAN,SDMSD,SDCMS,DM7(10),
C
C NOTE ABOVE CARD SHORTENED TO SDS(10),DUMW7(10), SO THAT STATEMENT DOES
C   NOT EXCEED 19 CONTINUATION CARDS.  I THINK SD--'S ARE NOT USED.
     *),CHISQT,NDFT,CHIPRT,CHISTL,NDFTL,CHIPTL,NBADCH,DUMW8(13),IDTRK,
     *NCEPTS,NTHIS,INEFF,NHLAYR,INFLAG,NELIPS,NGLAYR,DUMW9(72),IREG(200)
C-----600 WORDS UP TO HERE----------------------------------------------
     *,RDOTD(200),CINT(3,200),NFLAG(200),ITEM(200),EM(30,30),DALONG(10),
C-----2710 WORDS UP TO HERE---------------------------------------------
     *DEV(30),VXYDA(10),VZDA(10),CXYA(10),CZA(10),INCUT(30),BADA(30),G(200003100
     *0,20),DEVA(20),IPERM(10),MWORK(20),ITHISA(10),IJA(10),EM1(20,20),E
     *MG(20,20),ELIPSE(700),INCHAM(10),INREG(10),IAPPRO(30),HBADCH(1000)
     *,CTDASH(10),CLDASH(10),VTDASH(10),VLDASH(10),IHTREG(20),LAYRAB,IEF
C-----5421 WORDS UP TO HERE---------------------------------------------
     *FRG(10),DUMW10(69),AAA(10),BBB(10),CCC(10),DDD(10),DOVER,GMOVER,AB
     *OVER,RDOVER,DEOVER,DUMW11(55),X7(50),IHTP(30),IOVLAP(20,20)
C-----6080 WORDS UP TO HERE---------------------------------------------
      DIMENSION ILIPSE(700)
      INTEGER*2 HLIPSE(1400)
      DIMENSION IHTPER(10),IHTEMP(10),IPTEMP(10)
      EQUIVALENCE (ILIPSE(1),HLIPSE(1),ELIPSE(1))
      EQUIVALENCE (IHTP(1) ,IHTPER(1)),
     *            (IHTP(11),IHTEMP(1)),
     *            (IHTP(21),IPTEMP(1))
      LOGICAL INCUT,BADA
C
C-----------------------------------------------------------------------
C
C THE FIRST 50 LOCATIONS ARE RESERVED FOR SPECIAL WORKING VARIABLES.
C THE NEXT 150 LOCATIONS ARE RESERVED FOR COPIES OF THESE SPECIAL
C    VARIABLES, IF, E.G., ONE WISHES TO PRESERVE THEIR VALUES AT
C    THE BEGINNING OF A STEP.
C THE COPIES HAVE A SUFFIX 0 FOR VALUES AT LAST ASSOCIATED HIT.
C THE COPIES HAVE A SUFFIX 7 FOR VALUES AFTER LEAD-GLASS BARREL OR
C    YOKE END-PLUG (X7 IS LATER IN COMMON - SEE BELOW).
C THE COPIES HAVE A SUFFIX 8 FOR VALUES AT LAST BUT ONE GOOD
C    CHAMBER LAYER.
C THE COPIES HAVE A SUFFIX 9 FOR VALUES AT LAST GOOD CHAMBER LAYER.
C NSPECI (SET IN BLOCK DATA BEHIND MUFFLE) IS THE NUMBER OF SUCH
C    VARIABLES ACTUALLY USED.
C
C SPECIAL VARIABLES....
C
C X,Y,Z       = CURRENT COORDINATES.
C DCX,DCY,DCZ = CURRENT DIRECTION COSINES OF TRACK.
C P,PSQ       = CURRENT MOMENTUM (AND ITS SQUARE).
C E,ESQ       = CURRENT ENERGY (AND ITS SQUARE).
C D           = CURRENT DISTANCE FROM VERTEX (MM).
C GM          = MATERIAL TRAVERSED TO CURRENT POSITION (GM CM**-2).
C AB          = ABSORPTION LENGTHS SO FAR.
C RD          = RADIATION LENGTHS SO FAR.
C DE          = ENERGY LOSS (GEV).
C PPIDK       = PROBABILITY OF PION DECAYING TO MUON BEFORE INTERACTING.
C PKDK        = PROBABILITY OF KAON DECAYING TO MUON BEFORE INTERACTING.
C PPBPEN      = ANTI-PROTON ) ( PENETRATION PROBABILITY, I.E. PROBAB-
C PPPEN       = PROTON      ) ( ILITY OF NOT BEING ABSORBED BY A NUCLEUS
C PPIPEN      = PI          ) ( AND NOT DECAYING.  SEE SUBROUTINE
C PKPEN       = K           ) ( MUFFLS FOR FURTHER DETAILS.
C
C-----------------------------------------------------------------------
C
C THE NEXT 200 LOCATIONS ARE RESERVED FOR VARIABLES THAT DO NOT NEED
C    SPECIAL PRESERVATION.
C
C OTHER VARIABLES...
C
C X1,Y1,Z1    = COORDS OF 1ST POINT ON TRACK.
C X2,Y2,Z2    = COORDS OF LAST POINT ON TRACK.
C XMID,YMID,ZMID = COORDS OF MID POINT ON TRACK.
C X3,Y3,Z3    = COORDS OF POINT WHERE TRACK LEAVES MAGNETIC FIELD.
C D1          = DISTANCE TRAVELLED TO (X1,Y1,Z1).
C D2          = DISTANCE TRAVELLED TO (X2,Y2,Z2).
C D3          = DISTANCE TRAVELLED TO (X3,Y3,Z3).
C DTC         = DISTANCE TRAVELLED TO MID-POINT OF TRACK.
C
C DSTEP       = STEP LENGTH THIS STEP (FOR MUFFLU) (MM).
C GMSTEP      = MATERIAL THIS STEP (GM CM**-2).
C ABSTEP      = ABSORPTION LENGTHS THIS STEP.
C RDSTEP      = RADIATION LENGTHS THIS STEP.
C DESTEP      = ENERGY LOSS OF MINIMUM IONISING PARTICLE THIS STEP,
C
C ADCZ        = ABS(DCZ)
C COSEC       = ABS(COSEC(THETA)), WHERE THETA IS ANGLE TO BEAM.
C STPINI      = STEP LENGTH IN INITIAL TRACKING TO COIL OR END PLUG.
C CURV        = CURVATURE FROM 'PATR' BANK.
C DANG        = ANGLE OF TURN FOR EACH STEP.
C DX,DY,DZ    = CHANGES OF X,Y,Z.
C R,RSQ       = DISTANCE FROM BEAM (RADIUS) AND ITS SQUARE.
C PT          = MOMENTUM COMPONENT PERPENDICULAR TO BEAM.
C DPINA       = INTEGRAL OF (DECAY LENGTH)*(PROBABILTY OF NOT INTER-
C                 ACTING) FOR PION. (NO LONGER USED. CAN BE RESURECTED
C DKNA        = SIMILARLY FOR KAON. (BY UN-COMMENTING IN MUFFLS.
C
C VX,VY,VZ    = CURRENT VARIANCES ON X,Y,Z.
C RMSXY       = RMS DEV. NORMAL TO CHORD IN XY FIT.     )
C RMSZ        = RMS Z DEV. IN RZ FIT.                   ) FROM
C VTXYD       = VARIANCE ON DEVIATION NORMAL TO         ) TRACK
C                 TRACK IN XY PLANE AT TRACK CENTRE.    ) RECON-
C VTZD        = VARIANCE ON DEVIATION NORMAL TO         ) STRUCTION
C                 TRACK IN RZ PLANE AT TRACK CENTRE.    ) ERRORS.
C VTXYAN      = VARIANCE ON ANGLE IN XY PLANE (PHI)     )
C VTZANG      = VARIANCE ON ANGLE IN RZ PLANE (THETA)   )
C VMSANG      = VARIANCE OF MULTIPLE SCATTERING ANGLE.
C VMSD        = VARIANCE OF MULTIPLE SCATTERING DEVIATION NORMAL TO
C                 TRACK.
C CMS         = COVARIANCE OF ABOVE TWO QUANTITIES.
C SD--        = CORRESPONDING STANDARD DEVIATIONS (SQUARE ROOTS).
C
C CHISQT      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFT        = NUMBER OF DEGREES OF FREEDOM.           ) (DRIFT)
C CHIPRT      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C CHISTL      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFTL       = NUMBER OF DEGREES OF FREEDOM.           ) & LONG'L
C CHIPTL      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C NBADCH      = NO. OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C
C IDTRK       = INNER DETECTOR TRACK NUMBER.
C NCEPTS      = NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS       = NUMBER OF MUON HITS ASSOCIATED WITH PROJECTED INNER
C                DETECTOR TRACK.
C INEFF       = NUMBER OF INEFFICIENCIES IN MUON SYSTEM FOUND THIS TRACK
C NHLAYR      = NUMBER WHICH REPRESENTS NUMBER OF MUON LAYERS WITH
C                ASSOCIATED MUON HITS. ADD 1 FOR THE INNER LAYER AND
C                2 FOR EACH SUBSEQUENT LAYER.
C INFLAG      = 1 IF LAST LAYER INTERCEPTED WAS INEFFICIENT.
C NELIPS      = NUMBER OF MULTIPLE SCATTERING ELIPSES ENTERED IN ELIPSE.
C NGLAYR      = AS NHLAYR, BUT FOR 'GOOD' LAYERS WHETHER THERE WAS AN
C                ASSOCIATED HIT OR NOT.
C
C-----------------------------------------------------------------------
C
C THE NEXT 1400 LOCATIONS USED BY MUREGY (CALCULATES REGION INTERCEPTS).
C
C IREG        = REGION NUMBER.                           )(IN PAIRS,I.E.
C RDOTD       = R.DOT.(DIR. COSINES) FOR EACH INTERCEPT. )( 2 INTERCEPTS
C CINT        = X,Y,Z COORDINATES OF EACH INTERCEPT.     )( PER REGION.
C NFLAG       = USED INTERNALLY BY MUREGY.
C ITEM        = USED INTERNALLY BY MUREGY.
C
C-----------------------------------------------------------------------
C
C THE NEXT 3600 LOCATIONS USED BY MUFFLE, ETC., TO ACCUMULATE
C   QUANTITIES NEEDED FOR CALCULATING CHI-SQUARED. IN THE DESCRIPTION
C   BELOW I,J GO AS FOLLOWS..
C     1   LEFT DRIFT COORDINATE    )  OF 1ST
C     2   RIGHT DRIFT COORDINATE   )  ASSOCIATED
C     3   LONGITUDINAL COORDINATE  )  HIT
C     4    ETC. FOR NEXT ASSOCIATED HIT.
C   K REFERS TO K'TH ASSOCIATED HIT.
C
C EM(I,J)     = 'ERROR MATRIX', I.E. VARIANCE (I=J) OR COVARIANCE (I.NE.
C                J) FOR COORDINATE I,J.
C DALONG(K)   = DISTANCE OF ASSOCIATED HIT K ALONG TRACK.
C DEV(I)      = DEVIATION OF COORDINATE I FROM EXTRAPOLATED INNER
C                DETECTOR TRACK.
C VXYDA(K)    = VARIANCE ON DEVIATION IN XY PLANE FOR HIT K.
C VZDA(K)     = VARIANCE ON DEVIATION IN RZ PLANE FOR HIT K.
C CXYA(K)     = COVARIANCE BETWEEN DEVIATION AND ANGLE IN XY PLANE.
C CZA(K)      = COVARIANCE BETWEEN DEVIATION AND ANGLE IN RZ PLANE.
C INCUT(I)    = .TRUE. IF COORDINATE I IS IN CUT (SEE MUFFLY).
C BADA(I)     = .TRUE. IF COORDINATE I IS BAD.
C G           = INVERSE ERROR MATRIX.
C DEVA        = CORRESPONDING DEVIATIONS.
C IPERM(K)    = USED TO PERMUTE LEFT/RIGHT AMBIGUITIES.
C MWORK       = USED BY MATRIX INVERTING ROUTINE AS WORKING SPACE.
C ITHISA(K)   = HIT NUMBER OF K'TH ASSOCIATED HIT.
C IJA(K)      = INDEX FOR K'TH ASSOCIATED HIT FOR ENTRY IN BANKS 2 & 3.
C EM1         = COPY OF RELEVANT PART OF ERROR MATRIX FOR TEST PURPOSES.
C EMG         = PRODUCT OF ERROR MATRIX AND ITS INVERSE. SHOULD BE UNIT
C                MATRIX. USED FOR TEST PURPOSES.
C ELIPSE      = TEMPORARY STORAGE FOR MULTIPLE SCATTERING ELIPSES.
C INCHAM      = LIST OF INEFFICIENT CHAMBERS ON THIS TRACK.
C INREG       = LIST OF INEFFICIENT REGIONS (PLANES) ON THIS TRACK.
C IAPPRO      = USED AS WORKING SPACE IN MUFFLX.
C HBADCH      = LIST OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C CTDASH(K)   = TRANSVERSE COORD. ESTIMATED FROM I.D. PROJECTION.
C CLDASH(K)   = LONGITUD'L COORD. ESTIMATED FROM I.D. PROJECTION.
C VTDASH(K)   = VARIANCE ON CTDASH.
C VLDASH(K)   = VARIANCE ON CLDASH (FOR K'TH ASSOCIATED HIT).
C
C-----------------------------------------------------------------------
C
C THE NEXT  380 LOCATIONS USED FOR VARIOUS IMPROVEMENTS TO MUFFLE, ETC.
C
C IHTREG      = FOR EACH ASSOCIATED HIT, THE REGION NO. IN WHICH
C               THE HIT OCCURS.
C LAYRAB      = ABSOLUTE NO. OF LAYERS WHICH HAVE ASSOCIATED HITS.
C IEFFRG      = LIST OF REGION NOS. OF THOSE REGIONS WHICH HAVE AN
C               ASSOCIATED HIT.
C   IHTPER = FLAG FOR EACH ASSOCIATED HIT TO TELL IF IT'S TO
C            GO FORWARD INTO THE CHI**2 CALCULATION . ONLY ONE
C            HIT PER LAYER IS TO BE USED ,APART FROM OVERLAP HITS.
C   IHTEMP = LIST OF HITS WHICH ARE TEMPORARILY IN THE HIT PERMUTATION
C            DUE TO OVERLAPS WITH THE CURRENT AMBIGUITYOF ONE OF THE
C            HITS IN IHTPER.
C   IPTEMP =  AS IHTEMP, BUT FOR L/R AMBIGUITIES.
C IOVLAP   =  MATRIX OF OVERLAP HITS. IOVLAP(I,J)=1 MEANS THAT THERE
C             IS AN OVERLAP BETWEEN ASSOCIATED HITS I & J ( I & J BOTH
C             IN THE RANGE 1 TO NTHIS ).
C AAA(K)      = TRANSFORMATION COEFF. A FOR K'TH ASSOCD. HIT.
C BBB(K)      = TRANSFORMATION COEFF. B FOR K'TH ASSOCD. HIT.
C CCC(K)      = TRANSFORMATION COEFF. C FOR K'TH ASSOCD. HIT.
C DDD(K)      = TRANSFORMATION COEFF. D FOR K'TH ASSOCD. HIT.
C
C DOVER, ETC. = STORES QUANTITIES LEFT OVER AFTER LEAVING LAST ABSORBER.
C
C X7          = VALUES OF SPECIAL VARIABLES AFTER LEAD-GLASS BARREL OR
C               YOKE END-PLUG - USED FOR RE-FITTING, ETC.
C
C-------------END OF MACRO CMUFWORK-------------------------------------
C
C-----------------------------------------------------------------------
C
C DATA INITILISATION, ETC,
C
C FOR CALCULATING PI AND K DECAY WE NEED A CONSTANT WHICH DEPENDS ON
C   MEANLIFE, ETC.  THE PROBABLITY OF DECAYING IN DISTANCE D IS
C   (BRANCHING RATIO)*D/(GAMMA*(MEANLIFE IN REST FRAME)*(VELOCITY))
C   = (BR)*(MASS)*D/((MOMENTUM)*(C-TAU)) WHERE C-TAU IS VELOCITY OF
C   LIGHT * (MEANLIFE IN REST FRAME) AND IS GIVEN, E.G., IN THE
C   PARTICLE DATA BOOKLET. GAMMA IS THE TIME-DILATION FACTOR.
C FOR THE PION, BR(PI->MU) = 1.,
C    C-TAU = 7804 MM, HENCE BR*M/(C-TAU) = 1.788E-05 GEV MM**-1.
C FOR THE KAON, BR(K->MU) = .64,
C    C-TAU = 3709 MM, HENCE BR*M/(C-TAU) = 8.518E-05 GEV MM**-1.
      DATA CPIDK,CKDK/1.788E-5,8.518E-5/
C
C FOR CALCULATING ABSORPTION PROBABILTY WE NED THE ABSORPTION CROSS-
C   SECTION.  THIS IS GIVEN FOR PROTONS ON VARIOUS NUCLEI IN THE
C   PARTICLE DATA BOOKLET.  WE HAVE USED THIS TO CALCULATE THE
C   ABSORPTION LENGTHS GIVEN IN THE BLOCK DATA STATEMENTS AFTER
C   SUBROUTINE MUFFLE (AND KEPT IN THE SAME MEMBER AS MUFFLE).
C   THEY FIGURES ARE A HIGH ENERGY (20GEV I BELIEVE) LIMIT. WE SHOULD
C   TAKE ACCOUNT OF THE ENERGY DEPENDENCE BUT FOR MOMENTA BELOW
C   ABOUT 1 GEV WE GET TOO MUCH BACKGROUND TO DISTIGUISH MUONS ANYWAY
C   AND SINCE 1 GEV IS 'HIGH ENERGY' IN THIS CONTEXT WE IGNORE THIS
C   EFFECT FOR THE TIME BEING.  HOWEVER WE DO INTRODUCE FACTORS
C   TO ACCOUNT FOR THE (SLIGHTLY) DIFFERENT CROSS-SECTIONS FOR PI,K,AND
C   P-BAR, AS FOLLOWS:
      DATA FACPB,FACPI,FACK/1.2,0.9,0.9/
C
C-----------------------------------------------------------------------
C
C LOOK AT ENERGIES AND DIVIDE STEP IF NECESSARY.
      NSTEP=1
      JSTEP=1
 1    CONTINUE
      IF(DESTEP.LT..05*E.OR.DESTEP.LT..010)GO TO 2
      NSTEP=2*NSTEP
      DSTEP=DSTEP/2.
      GMSTEP=GMSTEP/2.
      ABSTEP=ABSTEP/2.
      RDSTEP=RDSTEP/2.
      DESTEP=DESTEP/2.
      GO TO 1
C
C-----------------------------------------------------------------------
C
C START OF STEPPING LOOP.
 2    CONTINUE
C
C-----------------------------------------------------------------------
C
C CALCULATE ACTUAL ENERGY LOSS.
      DEACT=DESTEP*ESQ/PSQ
C
C-----------------------------------------------------------------------
C
C CHECK IF STOPPED - RETURN 1 IF SO.
      IF(E-DEACT.LT.WMU+.010)RETURN1
C
C-----------------------------------------------------------------------
C
C PROPAGATE HADRON ABSORPTION AND DECAY PARAMETERS.
C   PDK1=PROBABILITY OF DECAYING THIS STEP.
C   PSN1=PROBABILITY OF SNEAKING, I.E. NOT BEING ABSORBEB THIS STEP.
C   (FOR DESCRIPTION OF OTHER VARIABLES SEE CMUFWORK.)
C
C FOR P-BAR.
      PSN1=EXP(-FACPB*ABSTEP)
      PPBPEN=PPBPEN*PSN1
C
C FOR PROTON.
      PSN1=EXP(-ABSTEP)
      PPPEN=PPPEN*PSN1
C
C FOR PION.
      PDK1=CPIDK*DSTEP/P
      PSN1=EXP(-FACPI*ABSTEP)
      PPIDK=PPIDK+PPIPEN*PDK1
      PPIPEN=PPIPEN*PSN1*(1.-PDK1)
C     DPINA=DPINA+DSTEP*PPIPEN
C
C FOR KAON.
      PDK1=CKDK*DSTEP/P
      PSN1=EXP(-FACK*ABSTEP)
      PKDK=PKDK+PKPEN*PDK1
      PKPEN=PKPEN*PSN1*(1.-PDK1)
C     DKNA=DKNA+DSTEP*PKPEN
C
C-----------------------------------------------------------------------
C
C PROPAGATE MULTIPLE SCATTERING.
C   THE FORMULAE FOR PROPAGATION OF MULTIPLE SCATTERING ANGLES, ETC.,
C   ARE JUSTIFIED IN JADE NOTE 47. WE ASSUME THAT, E.G.,
C   RMS SCATTERING ANGLE PROJECTED ONTO A PLANE =
C     ((15 MEV/C)/(P*BETA))*SQRT(NUMBER OF RADIATION LENGTHS).
C   (SEE PARTICLE DATA BOOKLET FOR REFINEMENTS AND REFERENCES.)
C   (SEE CMUFWORK FOR DEFINITION OF VARIABLES.)
      CON=RDSTEP*(0.015*E/P**2)**2
      VMSD=VMSD+(VMSANG+CON/3.)*DSTEP**2+2.*CMS*DSTEP
      CMS=CMS+(VMSANG+CON/2.)*DSTEP
      VMSANG=VMSANG+CON
C
C-----------------------------------------------------------------------
C
C PROPAGATE OTHER QUANTITIES.
C
      X=X+DSTEP*DCX
      Y=Y+DSTEP*DCY
      Z=Z+DSTEP*DCZ
      E=E-DEACT
      ESQ=E**2
      PSQ=ESQ-WMUSQ
      P=SQRT(PSQ)
      D=D+DSTEP
      GM=GM+GMSTEP
      AB=AB+ABSTEP
      RD=RD+RDSTEP
      DE=DE+DESTEP
C
C-----------------------------------------------------------------------
C
C END OF STEPPING LOOP.
      JSTEP=JSTEP+1
      IF(JSTEP.LE.NSTEP)GO TO 2
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
C     IF(DSTEP.GE.0.)GO TO 999
C     WRITE(6,100)X,Y,Z,DCX,DCY,DCZ,E,P,D,GM,AB,RD,DE
C100  FORMAT(' X,Y,Z,DCX,DCY,DCZ,E,P,D,GM,AB,RD,DE',3F7.0,3F7.4,2F7.2,
C    * 2F7.0,3F7.2)
C     WRITE(6,101)PPIPEN,PPIDK,DPINA,PKPEN,PKDK,DKNA,PPPEN,PPBPEN
C101  FORMAT(' PPIPEN,PPIDK,DPINA,PKPEN,PKDK,DKNA,PPPEN,PPBPEN',8F10.4)
C     WRITE(6,102)CON,VMSANG,VMSD,CMS
C102  FORMAT(' CON,VMSANG,VMSD,CMS',4E15.4)
C999  CONTINUE
      RETURN
C     DEBUG INIT        (INSIST ON FORTRANG IF USE THIS.)
      END

C   17/05/79 606091757  MEMBER NAME  TRCDTV   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRCDTV( P, R0, RR, * )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN  03/11/82 :  MODIFICATION OF SUBROUTINE
C             R. RAMCKE                TRCDET : BEAM PIPE COUNTERS
C                                      HAVE BEEN REMOVED FOR
C                                      INSTALLATION OF VERTEX CHAMBER
C
C        MOD  J. HAGEMANN  21/09/84 :  CHANGES DUE TO NEW VERSION OF
C                                      SUBROUTINE JSTEP
C   LAST MOD  J. HAGEMANN  17/04/86 :  CHANGES DUE TO NEW VERSION OF
C                                      TRCDET(ELS) FROM K-H.H. (K DECAY)
C
C        PROPAGATES PARTICLE FROM STARTING POINT THROUGH  DETECTOR  UP
C        TO COIL IN R OR LEAD GLASS IN Z.
C
C        R AND P WILL BE CHANGED AND INDICATE LAST  VALUES  IN  PLACE.
C        MULTIPLE SCATTERING IS INCLUDED IF MULSC  .EQ.  TRUE.  ENERGY
C        LOSS IS INCLUDED IF ELOSS .EQ. TRUE.
C
C        IF  ELOSS.EQ..FALSE.  PARTICLE  IS  PROPAGATED  TRMAX  MM  AT
C        MAXIMUM ( SEE DATA STATEMENT ).
C        MOMENTUM CUT IS AT 10. MEV/C.
C        IF PARTICLE STOPS IN SYSTEM, P = 0.
C        IF PARTICLE LEAVES UNDER A SMALL ANGLE IT IS NOT  PROPAGATED.
C
C        RETURN1, IF OVERFLOW IN EVENT REGISTER HITAR.
C
C        P(1)..P(4)     4-VECTOR OF PARTICLE TO BE TRACKED
C        P(5)           MASS IN GEV
C        P(6)           ABS VALUE OF 3 MOMENTUM
C        P(7)           CHARGE
C        P(8)           TYPE OF PARTICLE
C        P(9)..P(10)    FREE ( WILL CONTAIN TRACKING INFORMATION )
C
C        R0(1)..R0(3)   3_VECTOR FOR STARTING POINT OF PARTICLE
C
C        TRACK INFORMATION IS STORED IN CJPATR, KPATR  INDICATING  THE
C        TOTAL LENGTH OF ARRAY APATR. ( JADE COMP.NOTE #12 )
C        OVERFLOW CAUSES OVERWRITING OF LAST TRACK RECORD.
C        TYPE OF STARTING POINT ( APATR(KPATR+4) )  MUST  BE  SUPPLIED
C        FROM CALLING ROUTINE.
C        TRCOFS INTRODUCED IN COMMON /CJTRLE/
C
C        MAXIMUM STEP LENGTH IN EACH DETECTOR PART NOW SET IN DATA
C        STATEMENTS (DRMX1, DRMX2, DRMX3).
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  ELOSS, MULSC
C
      COMMON / CWORK  / NHITS, INEXT, HLIST(1600)
      COMMON / CWSET  / NHALL, ISTART, HPCELL(98), HITAR(16000)
C
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
C
      COMMON / CJIONI / POTBEA, ZAROBE,
     *                  POTTRI, ZAROTR,
     *                  POTIVE, ZAROIV,
     *                  POTRH0, ZAROR0,
     *                  POTJET, ZAROJE,
     *                  POTRH1, ZAROR1,
     *                  POTRH2, ZAROR2,
     *                  POTRH3, ZAROR3,
     *                  POTOVE, ZAROOV,
     *                  POTTOF, ZAROTO,
     *                  POTVES, ZARVES,
     *                  POTZJL, ZAROJL,
     *                  POTZJR, ZAROJR
C
      COMMON / CGEO1  / BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *                  RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *                  R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *                  R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *                  RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *                  ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *                  ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *                  ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *                  XRJETC,
     *                  RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *                  BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *                  XHOL1,XHOL2,YHOL1,YHOL2

      COMMON / CJTRLE / TOTLEN, STPLEN, TRCOFS
      COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
C
      COMMON / CJVTXC / RVEC, ANG1, ANG2, DISTPW, FIRSTP, DISTW1,
     *                  ANGL, COSLOR, SINLOR,
     *                  ZRESV, ZMAXV, ZOFFV, ZNAMP, ZALV, TIMEV
      COMMON / CIJONV / POTVXC, ZAROVC,
     *                  POTVGA, ZAROVG
      COMMON / CGEOV  / RPIPV, DRPIPV, XRLPIV, RVXC, DRVXC, XRLVXC,
     *                  ZVXCM, DZVCM, XRZVCM, ZVXCP, DZVCP, XRZVCP,
     *                  XRVTXC
      COMMON / CSTORE / MHITS, IPV, HSTORE(2000)
C
      DIMENSION  PV2(10), P(10), R0(3),R(5),RR(3)
C
      DATA TRMAX / 5000. /
      DATA PCUT / .01 /
C
      DATA DRMX1  /  5.0  /
      DATA DRMX2  /  3.0  /
      DATA DRMX3  /  1.5  /
*** PMF  06/02/00 Loop counter to detect infinite loops.
*   Infinite loops sometimes happen (very rarely) if the particle
*   is located nearly exactly at the border of the drift chamber frame
*   given by subroutine JCHAMB.
*   Common /CLOOP/ is used in subroutines JPRTHI, JCHAMB.
      INTEGER ILOOP1,ILOOP2
      COMMON/CLOOP/ ILOOP1,ILOOP2
*** PMF (end)
C
C--------------------  C O D E  ----------------------------------------
C
*** PMF 06/02/00 initialize loop counter
      ILOOP1=0
      ILOOP2=0
*** PMF (end)
      R(1) = R0(1)
      R(2) = R0(2)
      R(3) = R0(3)
      R(4) = SQRT( R(1)*R(1) + R(2)*R(2) )
C
CCC  SET DUMMY VALUE FOR TRACK POINT, INITIALIZE HLIST ARRAY POINTERS
C
      IPOTYP = 0
   10 NHITS  = 0
      INEXT  = 1
C
      PENETR = 0.
      PENETZ = 0.
      TOTLEN = 0.
      STPLEN = 1.E19   !1.E40
C
C   DON'T TRACK PARTICLES WITH P<PCUT
C   DON'T TRACK PARTICLES WHICH START BEHIND COIL OR ENDCAP LG.
C                                       OCT.25. 1983 W.BARTEL
C
      IF( P(6) .LT. PCUT ) GO TO 9100
      IF( R(4) .GT. RCOIL) GO TO 9000
      IF( ABS(R(3)) .GT. ZENDPL) GO TO 9000
C
C                           DEFINE PI MU DECAY PARAMETERS
      CALL PIKMUF( P, PV2, STPLEN )
      IF( .NOT. ELOSS ) STPLEN = AMIN1( TRMAX, STPLEN )
C
C
C                            INSIDE BEAM PIPE
  100 CALL JPRFRE( R, P, PENETR, PENETZ,  0.  , RPIPV - 2*DRPIPV,
     *                     ZENDMI, ZENDPL, DRMX1,
     *                     &9100, &9200, &9200, &9100 )
C
C                            INSIDE BEAM PIPE (REDUCED STEP LENGTH)
  150 CALL JPRFRE( R, P, PENETR, PENETZ, RPIPV - 2*DRPIPV, RPIPV,
     *                     ZENDMI, ZENDPL, DRMX3,
     *                      &100, &9200, &9200, &9100 )
C
C                            BEAM PIPE WALL
  200 CALL JPRABS( R, P, PENETR, PENETZ, RPIPV, RPIPV + DRPIPV,
     *             ZENDMI, ZENDPL, POTBEA, ZAROBE, DRPIPV/XRLPIV,
     *             DRMX3,  &150, &9200, &9200, &9100 )
C
C                            INSIDE VERTEX CHAMBER
  250 CALL JVTXCH( R, P, PENETR, PENETZ, JRETRN, RPIPV + DRPIPV, RVXC,
     *             ZVXCM, ZVXCP, DRMX2, &9350 )
                 GOTO( 200, 450, 350, 9100 ), JRETRN
C
C                            OUTER VERTEX CHAMB. WALL
  500 CALL JPRABS( R, P, PENETR, PENETZ, RVXC, RVXC + DRVXC,
     *       ZVXCM + DZVCM, ZVXCP + DZVCP, POTVXC, ZAROVC, DRVXC/XRLVXC,
     *             DRMX3,  &250, &470, &370, &9100 )
C
C                            BETWEEN VERTEX CHAMB. AND INNER VESSEL WALL
  550 CALL JPRFRE( R, P, PENETR, PENETZ, RVXC + DRVXC, RITNK,
     *                     ZVXCM + DZVCM, ZVXCP + DZVCP, DRMX2,
     *                      &500, &470, &370, &9100 )
C
C                            INNER VESSEL WALL
  600 CALL JPRABS( R, P, PENETR, PENETZ, RITNK , RITNK + DRITNK,
     *            ZTKM+DZTKM, ZTKP+DZTKP, POTIVE, ZAROIV, DRITNK/XRLTKI,
     *            DRMX1,  &550, &8300, &7300, &9100 )
C
*** PMF 20/06/2000
*     Loop counter to detect infinite loops when returning 
*     from subroutine JCHAMB for decreasing R.
      GOTO 700
  701 ILOOP1=ILOOP1+1
*** PMF (end)
C
C                           BETWEEN INNER VESSEL WALL AND FIRST ROHACELL
  700 CALL JPRTLO( R, P, PENETR, PENETZ, RITNK  + DRITNK , R0ROH,
     *                     ZJM, ZJP, DRMX1,
     *                      &600, &8700, &7700, &9100 )
C
*** PMF 06/02/00:
*     Loop counter to detect infinite loops when returning
*     from subroutine JPRTHI for decreasing R.
      GOTO 2000
 2001 ILOOP2=ILOOP2+1
*** PMF (end)
CCC  TENTATIVE FILLING OF CJPATR COMMON
 2000 CALL JIPATR( P, R )
C
CCC  TRACK PARTICLES THRU JETCHAMBER
      CALL JCHAMB( R, P, PENETR, PENETZ, IRETRN, DRMX1, &9400 )
C
CCC  UPDATE CJPATR COMMON
      CALL JUPATR( P, R )
C
CCC  BRANCH ACCORDIING TO RETURN CODE FROM JCHAMB
      GO TO ( 701, 8000, 7000, 9100 ) , IRETRN !PMF 20/06/00: Label 700 changed to label 701
C
C
C                            BETWEEN LAST ROHACELL AND OUTER VESSEL WALL
 3100 CALL JPRTHI( R, P, PENETR, PENETZ, R3ROH  + DR3ROH , ROTNK,
     *                     ZJM, ZJP, DRMX1,
     *                     &2001, &8600, &7600, &9100 ) ! PMF 06/02/00: &2000 changed to &2001
C
C                            IN OUTER VESSEL WALL
 3200 CALL JPRABS( R, P, PENETR, PENETZ, ROTNK , ROTNK + DROTNK,
     *             ZTKM+DZTKM,ZTKP+DZTKP, POTOVE, ZAROOV, DROTNK/XRLTKO,
     *             DRMX1,  &3100, &8300, &7300, &9100 )
C
C                            BETWEEN OUTER VESSEL WALL AND TOF COUNTER
 3300 CALL JPRFRE( R, P, PENETR, PENETZ, ROTNK  + DROTNK , RTOF ,
     *                     ZENDMI, ZENDPL, DRMX1,
     *                     &3200, &9000, &9000, &9100 )
C                            IN TOF COUNTER
 3400 CALL JPRTOF( R, P, PENETR, PENETZ, RTOF  , RTOF  + DRTOF ,
     *             ZTOFMI, ZTOFPL, POTTOF, ZAROTO, DRTOF/XRTOF ,
     *             DRMX1,  &3300, &8400, &7400, &9100 )
C                            BETWEEN TOF COUNTER AND COIL
 3500 CALL JPRFRE( R, P, PENETR, PENETZ, RTOF   + DRTOF  , RCOIL,
     *                     ZENDMI, ZENDPL, DRMX1,
     *                     &3400, &9000, &9000, &9100 )
      GO TO 9000
C
C
C                      - Z - PART
C
C                           IN END PLATE OF VERTEX CHAMBER
  350 CALL JPRABS( R, P, PENETR, PENETZ, RPIPV + DRPIPV, RVXC + DRVXC,
     *             ZVXCM + DZVCM, ZVXCM, POTVXC, ZAROVC, -DZVCM/XRZVCM,
     *             DRMX1,  &200, &250, &370, &9100 )
            GO TO 550
C                 BETWEEN END PLATE OF VERTEX CHAMB. AND OUTSIDE
  370 CALL JPRFRE( R, P, PENETR, PENETZ, RPIPV + DRPIPV, RITNK,
     *             ZENDMI, ZVXCM + DZVCM, DRMX1,
     *                     &200, &350, &9200, &9100 )
            GO TO 600
C                           IN END PLATE OF INNER DETECTOR
 7000 CALL JPRABS( R, P, PENETR, PENETZ, R0ROH , R3ROH + DR3ROH,
     *             ZJM+DZJM, ZJM, POTZJL, ZAROJL, -DZJM/XRZJM,
     *             DRMX1,  &7700, &2000, &7100, &9100 )
            GO TO 7600
C                  BETWEEN INNER DETECTOR END PLATE AND VESSEL END PLATE
 7100 CALL JPRFRE( R, P, PENETR, PENETZ, RITNK + DRITNK, ROTNK,
     *               ZTKM, ZJM + DZJM, DRMX1,
     *                      &600, &7000, &7200, &9100 )
            GO TO 3200
C                           IN VESSEL END PLATE
 7200 CALL JPRABS( R, P, PENETR, PENETZ, RITNK + DRITNK , ROTNK,
     *             ZTKM +DZTKM, ZTKM, POTVES, ZARVES, -DZTKM/XRZTKM,
     *             DRMX1,  &600, &7100, &7300, &9100 )
            GO TO 3200
C                           BETWEEN VESSEL END PLATE AND LEAD GLASS
 7300 CALL JPRFRE( R, P, PENETR, PENETZ, RITNK  , ROTNK + DROTNK,
     *               ZENDMI, ZTKM + DZTKM, DRMX1,
     *                      &370, &7200, &9000, &9100 )
            GO TO 3300
C                           BETWEEN TOF COUNTER  AND LEAD GLASS
 7400 CALL JPRFRE( R, P, PENETR, PENETZ, RTOF   , RTOF + DRTOF,
     *                      ZENDMI, ZTOFMI, DRMX1,
     *                     &3300, &3400, &9000, &9100 )
            GO TO 3500
C                           BETWEEN END PLAT OF I DETC. AND OUTER TNK W
 7600 CALL JPRFRE( R, P, PENETR, PENETZ, R3ROH + DR3ROH, ROTNK,
     *                        ZJM + DZJM, ZJM, DRMX1,
     *                      &7000, &3100,  &7100, &9100 )
            GO TO  3200
C                           BETWEEN INNER TNK W AND END PLATE OF I DETC.
 7700 CALL JPRFRE( R, P, PENETR, PENETZ, RITNK + DRITNK, R0ROH,
     *                        ZJM + DZJM, ZJM, DRMX1,
     *                      &600, &700,  &7100, &9100 )
            GO TO  7000
C
C
C                      + Z - PART
C
C                           IN END PLATE OF VERTEX CHAMBER
  450 CALL JPRABS( R, P, PENETR, PENETZ, RPIPV + DRPIPV, RVXC + DRVXC,
     *             ZVXCP, ZVXCP + DZVCP, POTVXC, ZAROVC, DZVCP/XRZVCP,
     *             DRMX1,  &200, &470, &250, &9100 )
            GO TO 550
C                 BETWEEN END PLATE OF VERTEX CHAMB. AND OUTSIDE
  470 CALL JPRFRE( R, P, PENETR, PENETZ, RPIPV + DRPIPV, RITNK,
     *            ZVXCP + DZVCP, ZENDPL, DRMX1,
     *                     &200, &9200, &450, &9100 )
            GO TO 600
C                           IN END PLATE OF INNER DETECTOR ( + Z )
 8000 CALL JPRABS( R, P, PENETR, PENETZ, R0ROH , R3ROH + DR3ROH,
     *             ZJP, ZJP+DZJP, POTZJR, ZAROJR, DZJP/XRZJP,
     *             DRMX1,  &8700, &8100, &2000, &9100 )
            GO TO 8600
C                  BETWEEN INNER DETECTOR END PLATE AND VESSEL END PLATE
 8100 CALL JPRFRE( R, P, PENETR, PENETZ, RITNK + DRITNK, ROTNK,
     *               ZJP + DZJP, ZTKP, DRMX1,
     *                      &600, &8200, &8000, &9100 )
            GO TO 3200
C                           IN VESSEL END PLATE
 8200 CALL JPRABS( R, P, PENETR, PENETZ, RITNK + DRITNK , ROTNK,
     *             ZTKP, ZTKP +DZTKP, POTVES, ZARVES, DZTKP/XRZTKP,
     *             DRMX1,  &600, &8300, &8100, &9100 )
            GO TO 3200
C                           BETWEEN VESSEL END PLATE AND LEAD GLASS
 8300 CALL JPRFRE( R, P, PENETR, PENETZ, RITNK  , ROTNK + DROTNK,
     *               ZTKP + DZTKP, ZENDPL, DRMX1,
     *                      &470, &9000, &8200, &9100 )
            GO TO 3300
C                           BETWEEN TOF COUNTER  AND LEAD GLASS
 8400 CALL JPRFRE( R, P, PENETR, PENETZ, RTOF   , RTOF + DRTOF,
     *                      ZTOFPL, ZENDPL, DRMX1,
     *                     &3300, &9000, &3400, &9100 )
            GO TO 3500
C                           BETWEEN END PLAT OF I DETC. AND OUTER TNK W
 8600 CALL JPRFRE( R, P, PENETR, PENETZ, R3ROH + DR3ROH, ROTNK,
     *                        ZJP, ZJP + DZJP, DRMX1,
     *                      &8000, &8100,  &3100, &9100 )
            GO TO  3200
C                           BETWEEN INNER TNK W AND END PLATE OF I DETC.
 8700 CALL JPRFRE( R, P, PENETR, PENETZ, RITNK + DRITNK, R0ROH,
     *                        ZJP, ZJP + DZJP, DRMX1,
     *                      &600, &8100,  &700, &9100 )
            GO TO  8000
C
C
C
C
 9100 CONTINUE
C                          DECAY OR STOPPING PARTICLE
             IF( STPLEN .GT. TOTLEN ) GO TO 9130
                 IF( .NOT. ELOSS .AND. STPLEN.EQ.TRMAX ) GO TO 9130
                 IF( P(6) .LE. PCUT ) GO TO 9130
             STOPL=STPLEN
             IF(ABS(P(8)-5.).LT.1.E-3) CALL TRKADC(P,R,R0,STOPL,&9120)
                    CALL PIKDEC( P, PV2, STPLEN )
                    TRCOFS = STPLEN + SQRT(R0(1)**2 + R0(2)**2
     *                              + R0(3)**2)
                    CALL SVECT1( PV2, R )
C                                           FINISH THIS PARTICLE
 9120               P(1) = 0.
                    P(2) = 0.
                    P(3) = 0.
                    P(6) = 0.
                    P(4) = P(5)
                    CALL JAPATR( IPOTYP )
                    GO TO 9030
C
C                          PARTICLE STOPPED IN  SYSTEM
 9130               P(1) = 0.
                    P(2) = 0.
                    P(3) = 0.
                    P(6) = 0.
                    P(4) = P(5)
C
C
C                                           FILL CELL INFORMATION
C                                           INTO TRACK ARRAY
 9000 CALL JAPATR( IPOTYP )
C                                           ORDER DRIFT TIMES
C                                           AND INSERT INTO HITAR
 9030 CALL JHITIN( &9400)
C
 9200 CONTINUE
      RR(1) = R(1)
      RR(2) = R(2)
      RR(3) = R(3)
      RETURN
C
C                                           OVERFLOW IN HIT REGISTER
C
 9350 WRITE( 6, 9351 )
 9351 FORMAT(' 0TRCDET: OVERFLOW IN VERTEX CHAMBER HIT REGISTER')
 9400 RETURN 1
      END

      SUBROUTINE STTRKO(ILAYMX)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
      COMMON/CHEADR/HEAD(17),HRUN,HEV
      COMMON/CADMIN/IEVTP,NREC,NRWRIT,NRERR
#include "cdata.for"
#include "ccycp.for"
#include "cjdrch.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
      INTEGER DATE(5), IDAY /0/
      DATA MAXTRK/ 50/
      DATA MKBDHT /Z600/
      DATA LBINIT /0/
      IF(
     - LBINIT.EQ.0
     -)THEN
        LBINIT=1
        IQJHTL = IBLN('JHTL')
        IQPATR = IBLN('PATR')
      ENDIF
      IF(
     - IDAY.EQ.0
     -)THEN
        CALL DAY2(DATE)
        IDAY = DATE(1)*1000 + DATE(2)
      ENDIF
      IPJHTL = IDATA(IQJHTL)*2 + 2
      IPPATR = IDATA(IQPATR)
      ITRBK = IDATA(IPPATR+2)
      LTRBK = IDATA(IPPATR+3)
      IPTRBK = IPPATR + IDATA(IPPATR+1) + ITRBK*LTRBK
      IF(IPTRBK+LTRBK-IPPATR.GT.IDATA(IPPATR)) RETURN
      DO 13000 IP=HPHT0,HPHT9,HLDHT
        IWRK(IP+10) = IWRK(IP+ 7)
        IWRK(IP+ 7) = 0
        IF(IWRK(IP+10).GT.1) IWRK(IP+7) = 16
        WRK (IP+ 6) = ((WRK(IP+4)/WRK(IP+3))**2 *.5 + 1.) * WRK(IP+3)
        IP0 = IWRK(IP+1)
        IAMPL = HDATA(IP0+1)
        IAMPR = HDATA(IP0+2)
      IF(
     - IAMPR.LE.0.OR.IAMPL.LE.0
     -)THEN
          WRK (IP+5) = 0.
          IWRK(IP+7) = 16
      ELSE
          Z1 = IAMPR + IAMPL
          WRK(IP+5) = FLOAT(IAMPR-IAMPL) * ZAL*.5 / Z1
      ENDIF
13000 CONTINUE
13001 CONTINUE
      CALL ZRFIT
      ZLYMX = 1400.
      IF(
     - ILAYMX.LT.40
     -)THEN
        IZW = ILAYMX - 1 + 3
        JRING = IZW / 16
        ILAY  =-JRING*16 + IZW
        RMAX  = ILAY*RINCR(JRING+1) + FSENSW(JRING+1)
        ZLYMX = RMAX*WRK(HPTR0+29) + WRK(HPTR0+30)
      ENDIF
      IF(
     - ABS(ZLYMX)+ 50. .LT. ZMAX
     -)THEN
        RETURN
      ENDIF
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      IDATA(IPPATR+2) = ITRBK
      RETURN
17000 CONTINUE
      JP = HPTR0
      IWRK(HPTR0+47)=LOR(IWRK(HPTR0+47),512)
      WRK(JP+ 6) = WRK(JP+ 6)*WRK(JP+29) + WRK(JP+30)
      WRK(JP+13) = WRK(JP+13)*WRK(JP+29) + WRK(JP+30)
      WRK(JP+ 9)= WRK(JP+ 9)*WRK(JP+29)
      WRK(JP+16)= WRK(JP+16)*WRK(JP+29)
      ALGINV = 1./SQRT(WRK(JP+ 7)**2+WRK(JP+ 8)**2+WRK(JP+ 9)**2)
      WRK(JP+ 7) = WRK(JP+ 7) * ALGINV
      WRK(JP+ 8) = WRK(JP+ 8) * ALGINV
      WRK(JP+ 9) = WRK(JP+ 9) * ALGINV
      ALGINV = 1./SQRT(WRK(JP+14)**2+WRK(JP+15)**2+WRK(JP+16)**2)
      WRK(JP+14) = WRK(JP+14) * ALGINV
      WRK(JP+15) = WRK(JP+15) * ALGINV
      WRK(JP+16) = WRK(JP+16) * ALGINV
      ITRBK = ITRBK + 1
      IP0 = IPTRBK + 1
      IP9 = IPTRBK + LTRBK
      DO 13002 IP = IP0,IP9
        IDATA(IP) = 0
13002 CONTINUE
13003 CONTINUE
      IDATA(IPTRBK+ 1) = ITRBK
      IDATA(IPTRBK+ 2) = 16
      IDATA(IPTRBK+ 3) = IDAY
      IP1 = HPTR0+3
      IP9 = IP1+29
      JP  = IPTRBK + 3
      DO 13004 IP=IP1,IP9
        JP = JP + 1
        IDATA(JP) = IWRK(IP)
13004 CONTINUE
13005 CONTINUE
      IDATA(IPTRBK+47)=IWRK(HPTR0+46)
      IDATA(IPTRBK+48)=IWRK(HPTR0+47)
      IPCLL = IPTRBK + 33
      IPCLLM = IPCLL + 6
      JCELL0 = -1
      IF(
     - ITRBK.LE.MAXTRK
     -)THEN
      IPJET0 = HPTSEC(1)
      DO 13006 IP=HPHT0,HPHT9,HLDHT
        LBBDHT = IWRK(IP+10)
      IF(
     - LBBDHT.LE.1
     -)THEN
          LBBDHT = ISHFTL(LBBDHT,9)
          IPHTLB = ISHFTR((IWRK(IP+1)-IPJET0),1) + IPJHTL
          LBHIT = ITRBK*2
          IF(IWRK(IP+2).GT.0) LBHIT = LOR(LBHIT,256)
          LBHIT1 = HDATA(IPHTLB+1)
          LBHIT2 = HDATA(IPHTLB+2)
          IRES = ABS(WRK(IP+13)) * 5.
          IF(IRES.GT.31) IRES=31
          IRES=ISHFTL(IRES,11)
          LBHIT=LBHIT+IRES
      IF(
     - LAND(LBHIT1,MKBDHT).NE.0
     -)THEN
      IF(
     - LBBDHT.EQ.0
     -)THEN
              LBHIT1 = LBHIT
              LBHIT1 = LOR(LBHIT1,1)
              LBHIT2 = 0
      ELSE
              LBHIT1 = LOR(LBHIT1,1)
              LBHIT  = LOR(LBHIT ,1)
              IF(LBHIT2.EQ.0) LBHIT2 = LOR(LBHIT,LBBDHT)
      ENDIF
      ELSE
      IF(
     - LBHIT1.EQ.0
     -)THEN
              LBHIT1 = LOR(LBHIT,LBBDHT)
              IF(IWRK(IP+7).EQ.0) LBHIT1 = LOR(LBHIT1,1)
      ELSE
      IF(
     - LBBDHT.EQ.0
     -)THEN
                LBHIT2 = LOR(LBHIT,LBBDHT)
                LBHIT1 = LOR(LBHIT1,1)
                LBHIT2 = LOR(LBHIT2,1)
      ENDIF
      ENDIF
      ENDIF
          HDATA(IPHTLB+1) = LBHIT1
          HDATA(IPHTLB+2) = LBHIT2
          JCELL = IWRK(IP+9)
      IF(
     - JCELL.NE.JCELL0
     -)THEN
            JCELL0 = JCELL
            IPCLL  = IPCLL + 1
            IF(IPCLL.GT.IPCLLM) IPCLL = IPCLLM
            IDATA(IPCLL) = JCELL0
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
      DATA NPR /0/
      NPR = NPR + 1
      I0 = IPTRBK + 1
      I9 = IPTRBK + LTRBK
      ENDIF
      IPTRBK = IPTRBK + LTRBK
      GOTO IZZZ01
      END

C   11/07/79 808021741  MEMBER NAME  LGANAL9  (SOURCE)      FORTRAN

C---- MAIN SUBROUTINE FOR THE 1-ST STEP L-GLASS ANALYSIS.

C=======================================================================
      SUBROUTINE LGANAL
C=======================================================================
C
C     S.YAMADA  31-10-78  14:35
C          MODIFICATION    01-08-79  24:00  IZ=0&31 KILLED
C          MODIFICATION    07-01-79  24:00  NEG ENERGY TO 20000
C                                                 Y.WATANABE
C.....THE #WORDS/CLUSTER IS NOW 16..  13/6/80     Y.WATANABE
C          MOD.     04-12-84   18:25    WORK SPACE CLEAR (5200->5520)
C                                                 S.YAMADA

C       MOD. 16/01/86 : POSSIBILITY TO ERASE ONLY THE UNPHYSICAL
C                       HALFRINGS FORESEEN. FOR FURTHER COMMENTS SEE
C                       SUBROUTINE LGERSE.
C                                                         M. KUHLEN

C---   CHANGED TO CALL CALCOR FOR REAL DATA  02.08.88  D.PITZL


      IMPLICIT INTEGER *2 (H)
C PMF 26/11/98 'f11god.patrecsr.for' replaced by 'cdata.for'
C              'jadelg.source.for' replaced by 'clgwork1.for'
C               (see lganal.F)
C include "'f11god.patrecsr.for"
C include "'jadelg.source.for"
#include "cdata.for"
#include "clgwork1.for"

C---  NCLST = NO.OF THE LOCATED CLUSTERS.
C     MAPCL(J)=THE INDEX OF THE FIRST MEMBER OF THE J-TH CLUSTER
C               IN THE HLGADC. (THE FIRST 51 WORDS OF CLMPRP)

      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX,DZ

      COMMON /CLGMSB/ MSGVAL

      DATA NMLGCL/'LGCL'/,  LGANVR/1/,  MESS/0/

      DATA NCALL / 0 /

      NCALL = NCALL + 1
      DATA IINIT / 0 /

      IF ( IINIT .GT. 0 ) GO TO 14
      IINIT = 1
      IPLGCL = IBLN ( NMLGCL )
14    CONTINUE

C---- FOR THE FIRST CALL PRINT THE LG-CLUSTER FINDING PARAMETERS.
      IF ( MESS ) 1001,1000,1001
 1000 CALL LGMESG( 2, 0)
      MESS = 1


C---- FILL HEADER AND CONSTANTS IN THE GENERAL LG-INF. OF THE EVENT.
 1001 IDENT(1) = LGANVR
      IDENT(2) = IDATTM(DUM)

C---- CLEAR CLUSTER RESULTS ARRAY
      CALL SETSL(NCLST,0,5520,0)

C---- SET NO.OF WORDS/CLUSTER
      NWPCL = 16

C---- SET THE FLAG OF LG-ANALYSIS STEP-1.
      IFLAG(2) = 1
C
C*******************************************************************

C       LEAD GLASS CLUSTER FINDING

C     LG-ADC DATA IS MOVED FROM 'ALGN' TO /CWORK/.
      CALL LGDCPY( NP, IFLAG(1))

C---- CHECK IF THERE IS ANY LG-DATA.
      IF(NP.LE.0) GO TO 5

C---- IF DATA FORMAT ERROR IS FOUND,SKIP ANALYSIS AND MAKE AN EMPTY RES.
C     IFLAG(1)=1,IF NOT CALIBRATED.
C     IFLAG(1)=2,IF NOT ALL DATA ARE COPIED DUE TO THE BUFFER SIZE.
C     IFLAG(1)=1024,IF FORMAT CONVRSION IS NOT DONE.

      IF(IFLAG(1).GE.1024) GO TO 5

C#####KILL IZ=0&31 RINGS BECAUSE THEY ARE NOT REAL.
      NHIT=LNG-3
      IF ( NHIT .LE. 0 ) GO TO 85
      IF ( HLGADC (1,1) .GE. 2688 ) HPOINT(2)=1
 150  CONTINUE
      DO 80 I=1, NHIT
C        PROTECTION HERE TO CORRECT NEGATIVE ENRGY DUE TO OVERFLOW.
         HPH = HLGADC (2,I)
         IF ( HPH .LT. 0 ) HLGADC(2,I)=20000
         IADC = HLGADC (1,I)
         IF ( IADC .GT. 2687 ) GO TO 80
         IRING = MOD ( IADC, 32 )

C  TO ERASE ONLY THE UNPHYSICAL TWO HALFRINGS REMOVE THE FOOLOWING
C  THREE STATEMENTS. THIS HAS ALSO TO BE DONE IN LGERSE!!!!!!!
C        IROW = 1 + IADC/32
C        IF( IRING.EQ. 0 .AND. (IROW.GE.22.AND.IROW.LE.63) ) GOTO 80
C        IF( IRING.EQ.31 .AND. (IROW.LE.21 .OR.IROW.GE.64) ) GOTO 80

      IF ( IRING .EQ. 0  .OR.  IRING .EQ. 31 ) HLGADC(2,I)=0
80    CONTINUE
85    CONTINUE

C---     CHANGED 02.08.88 :   CORRECTION OF CALIBRATION SYSTEMATICS
C                             FOR REAL DATA ONLY
C              HNORML = 10000 FOR CALIBRATED DATA WITHOUT CORRECTIONS
C              HNORML = 22000 FOR CALIBRATED DATA WITH CORRECTIONS


      IHEAD = IDATA ( IBLN ( 'HEAD' ) )
      NRUN  = HDATA ( 2*IHEAD + 10 )

      IF( NCALL .EQ. 1 ) PRINT 990, NRUN, HNORML
 990  FORMAT ( T2,'JADELG.LOAD (LGANAL9) CALLED:',
     +   ' NRUN = ',I6,' ,HNORML = ',I6 )

      IF ( NRUN .GT. 100 .AND. HNORML .LT. 11000 ) CALL CALCOR

C---      END CHANGE


C---- CLUSTER FINDING    (NCLST,NCLBEC(1-3) ARE FILLED. MAP IS MADE.)
      CALL LGCCTL ( IFLAG(1) )

C---- CLUSTER POSITIONS AND ENERGIES ARE CALCULATED FOR THE BARREL AND
C     END CAPS.
      IF ( NCLBEC(1) ) 2,2,1
    1 CALL LGCLPB
    2 IF ( NCLBEC(2) + NCLBEC(3) ) 4,4,3
    3 CALL LGCLPC

C---- TOTAL ENERGY IS CALCULATED.
    4 ETOT(1) = ETOT(2)+ETOT(3)+ETOT(4)


C****************************************************************
C---- COPY LG-RESULT INTO A NEW BANK/LGCL/.

C---- FIX POINTERS OF THREE PARTS.
    5 NPNT(1) = 5
      NPNT(2) = 26
      NPNT(3) = NCLST+27
      NPNT(4) = NPNT(3)+NWPCL*NCLST

      IF ( NCLST .EQ. 0 .OR. NCLST .EQ. MAXCLS ) GO TO 10
C---- SHIFT DATA TO FILL THE GAP BETWEEN MAPCL AND CLSPRP
      CALL MVCL(CLMPRP(NCLST+2),0,CLMPRP(MAXCLS+2),0, 4*NCLST*NWPCL)

   10 LNGCL = NPNT(4)-1

C---- CREATE THE LGCL BANK.
      NPLGCL=IDATA(IPLGCL)
      IF ( NPLGCL .LT. 1 ) GO TO 12
      MSGVAL = 1
      CALL LGMESG( 2, 3)
      CALL BDLS(NMLGCL,1)

12    CALL BCRE(NPLGCL,NMLGCL,1,LNGCL,&91,IER)
      CALL BSAW( 1, NMLGCL)
      IF ( IER .EQ. 0 ) GO TO 20

C---- BCRE ENDS WITH AN ERROR.
C     THE 'LGCL' EXISTS ALREADY.
      MSGVAL = IER
      CALL LGMESG( 2, 3)

C---- COPY
   20 CALL BSTR( NPLGCL, NPNT, LNGCL)
      GO TO 30

C---- NOT ENOUGH SPACE IN /BCS/.
   91 IFLAG(1) = IFLAG(1)+100
      MSGVAL = IER
      CALL LGMESG( 2, 2)

C---- OVERWRITE 'ALGN'-BANK WITH THE SORTED LG-ADC'S.
   30 IF(NP.GT.0) CALL MVCL(IDATA,4*NP,HNORD,0,4*LNG)

  100 RETURN
      END

C   08/01/79 C9010801   MEMBER NAME  LGNMEC   (JADELGS)     FORTRAN
      SUBROUTINE LGNMEC(X0,Y0,NO)
C
C     S.YAMADA  24-03-78          (COPIED FROM LGSOURCE 08-01-79)
C     LAST MODIFICATION   15-05-78  12:15
C
C---- OBTAIN THE END CAP COUNTER NUMBER CORRESPONDING TO
C     THE POSITION (X0,Y0)
C
C---- INPUT   X0,Y0 IN RAD.LNG.
C---- OUTPUT   NO=COUNTER NUMBER
C
      DIMENSION NUMLST(36)
      DATA NUMLST/0,0,1,5,10,16,0,0,2,6,11,17, 4,3,7,12,18,0,
     1     9,8,13,20,19,0, 15,14,22,21,0,0, 24,23,4*0/
C
      N = 0
C
      IF(X0) 20,10,10
   10 IF(Y0) 12,11,11
   11 X = X0
      Y = Y0
      GO TO 30
   12 X = -Y0
      Y = X0
      GO TO 30
   20 IF(Y0) 22,21,21
   21 X = Y0
      Y = -X0
      GO TO 30
   22 X = -X0
      Y = -Y0
C
   30 IF(X.LT.6.2533) Y = Y-2.2333
      IF(Y.LT.6.2533) X = X-2.2333
      IX = X/6.2533+1.
      IF(IX.LT.1.OR.IX.GT.6) GO TO 100
      IY = Y/6.2533
      IF(IY.LT.0.OR.IY.GT.5) GO TO 100
      INDX = IX+6*IY
      N = NUMLST(INDX)
      IF(N.EQ.0) GO TO 100
C
C---- MODIFY N FOR THE QUADRUNTS 2,3 AND 4.
      IF(X0) 2,1,1
    1 IF(Y0.LT.0.) N = N+72
      GO TO 100
    2 N = N+24
      IF(Y0.LT.0.) N = N+24
C
  100 NO = N
      RETURN
      END

C   14/12/81 808021744  MEMBER NAME  LGECOR9  (SOURCE)      FORTRAN
C
C
C****************************************************************
      SUBROUTINE LGECOR( RDATA, DEP, NRBLOC, IFLAG)
C****************************************************************
C
C  THIS PROGRAM CALCULATES THE INCIDENT ENERGY
C  FROM THE MEASURED ENERGY.
C
C      05/3/1979     HIROSHI TAKEDA
C           MODIFICATION   22/09/79
C           MODIFICATION   04/10/79 Y.WATANABE
C           MODIFICATION   09/02/80 H.TAKEDA(TYPED BY Y.WATANABE)
C         IMPLEMENTED ON 21/2/80 18:00
C           MODIFICATION   08/09/80 Y.W. LGPOSC FOR BARREL.
C           MODIFICATION   14/12/81 H.T. ENGLOS FOR END-CAP.
C           MODIFICATION   14/12/81 H.T. THICKNESS FOR BARREL MATERIALS
C           MODIFICATION   06/04/82 S.ODAKA
C                          BRLGN FOR BARREL INSTEAD OF LGPOSC
C
C    CHANGED 02.08.88 D.PITZL: CALL ENCORR FOR PHOTONS
C                     T.OEST : READOUT THRESHOLD CORRECTION AS
C                              FUNCTION OF # OF BLOCKS IN CLUSTER
C                              NRBLOC IS ARGUMENT NOW
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C  RDATA : DATA BUFFER OF THE FOLLOWING PARAMETERS.
C
C    IDATA(1)   0   BARREL
C                    -1   BOTTOM END CAP
C                    +1   TOP    END CAP
C    RDATA(2)   CLUSTER ENERGY IN GEV
C    RDATA(3)   SIGMA(ENERGY)
C    RDATA(4)   WEIGHTED AVERAGE PHI        BARREL
C                                       X        END CAP
C    RDATA(5)   WEIGHTED AVERAGE  Z         BARREL
C                                       Y        END CAP
C    RDATA(6)   SIGMA PHI (WEIGHTED)        BARREL
C                            X                   END CAP
C    RDATA(7)   SIGMA  Z (WEIGHTED)         BARREL
C                            Y                   END CAP
C    IDATA(8)   NUMBER OF CORRESPONDING INNER TRACKS
C    RDATA(9--11) DIRECTION COSIGNS CORRECTED FOR SHOWER DEPTH
C
C  DEP  :  SHOWER DEPTH IN MM
C  IFLAG   0    NORMAL RETURN
C          1    ITERATION OVERFLOW
C          2    HIT OUTSIDE END-CAP
C          3    TOO MUCH ENERGY LOSS
C          4    OTHER ILLEGAL RETURNS
C
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
      DIMENSION RDATA(2)
      COMMON /CLGDMS/  X0,RADIUS(6),RADSX0(6),
     1  THX0(4),ZEND(2),ZENDX0(2),
     2  ZWID(2),ZGAP(2),PHWID(2),
     3  ZECAP(4),ZECAPX(4),THECPX(2),
     4  ECXLST(24),ECYLST(24)
C
C  THECPX(1)   THICKNESS OF END CAP COUNTER IN MM
C        (2)                                   X0
C  RADIUS(1,2) DISTANCE TO THE COIL SURFACE (INNER AND OUTER)
C        (3,4) DISTANCE TO THE LEAD GLASS SURFACE (TYPE A)
C  ZEND(1)     END POINT OF BARREL PART COUNTERS  (-)
C      (2)                                        (+)
C  ZGAP(1)     COUNTER GAP OF BARREL PART IN MM
C  THX0(1)     MAGNET COIL THICKNESS IN X0
C              X0 = 8.9 CM FOR ALUMINUM
C
      EQUIVALENCE (PHI,XCO),(ZCO,YCO),(IBE,BE)
      EQUIVALENCE ( RIDTRK, NIDTRK )
      DATA ETHRE/0.01/,PAI2/6.283185/
C
C
      DATA ICALLS / 0 /
C
      IHEAD = IDATA ( IBLN ( 'HEAD' ) )
      NRUN  = HDATA ( 2 * IHEAD + 10 )
      NEVE  = HDATA ( 2 * IHEAD + 11 )
      MCTYP = HDATA ( 2 * IHEAD + 17 )
C
      ICALLS = ICALLS+1

      IF ( ICALLS .EQ. 1  .AND.  NRUN .GT. 100 ) PRINT 3075
 3075 FORMAT( T2,'JADELG.LOAD (LGECOR9) VERSION 02.08.88 CALLED',
     +   ' FOR DATA' )

      IF ( ICALLS .EQ. 1  .AND.  NRUN .LT. 100 .AND. MCTYP .LE. 1 )
     +   PRINT 3076
 3076 FORMAT( T2,'JADELG.LOAD (LGECOR9) VERSION 02.08.88 CALLED',
     +   ' FOR MEIER-MAGNUSSEN MC-DATA' )

      IF ( ICALLS .EQ. 1  .AND.  NRUN .LT. 100 .AND. MCTYP .GT. 1 )
     +   PRINT 3077
 3077 FORMAT( T2,'JADELG.LOAD (LGECOR9) VERSION 02.08.88 CALLED',
     +   ' FOR SHOWER-MC' )
C
C  INITIAL SET UP
C
      BE     = RDATA(1)
      ENERGY = RDATA(2)
C
      COSX   = RDATA(9)
      COSY   = RDATA(10)
      COSZ   = RDATA(11)
      PHI    = RDATA(4)
      ZCO    = RDATA(5)
      RIDTRK = RDATA(8)
C     WRITE(6,900) BE,ENERGY,COSX,COSY,COSZ,PHI,ZCO,DEP
C900  FORMAT(10F10.3)
      IFLAG=0
C
      IF(IBE.EQ.0) GO TO 1
CCCCCCCCCCCCCCCCCCCCC
C
C  END CAP COUNTERS
C
CCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF THE LIGHT GUIDE
C
      R=(THECPX(1)-DEP)/COSZ
      R=ABS(R)
      XX=XCO+R*COSX
      YY=YCO+R*COSY
C
      THETA=ACOS(COSZ)
      THETA=ABS(THETA)*57.2958
      IF(IBE.EQ.-1) THETA=180.0-THETA
C     WRITE(6,900) R,XX,YY,THETA
C
C   ITERATION FOR INCIDENT ENERGY
C
      ETEMP1=ENERGY
      ITERA=1
      JTERA=1
C
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
      X=XX/X0
      Y=YY/X0
      CALL LGNMEC(X,Y,ID)
C
C   CHECK IF HIT IS INSIDE THE COUNTER
C
C
      IF(ID.GT.0) GO TO 60
      X=XCO/X0
      Y=YCO/X0
      CALL LGNMEC(X,Y,ID)
C
      IF(ID.GT.0) GO TO 60
      IFLAG=2
      RETURN
C
   60 MB=(ID-1)/24 +1
      ID=MOD(ID-1,24)+1
      U=ECXLST(ID)
      V=ECYLST(ID)
      GO TO (4,5,6,7),MB
    4 X=U
      Y=V
      GO TO 8
    5 X=-V
      Y=U
      GO TO 8
    6 X=-U
      Y=-V
      GO TO 8
    7 X=V
      Y=-U
    8 R=0.1*SQRT((X-XX)*(X-XX)+(Y-YY)*(Y-YY))
      DDR=SQRT(XX*XX+YY*YY)-SQRT(X*X+Y*Y)
      IF(ABS(R).GT.1.E-10) DDR=0.1*DDR/R
C
C     ENERGY LOSS
C
      THICK=1.17*8.9/ABS(COSZ)
   10 CALL ENGLOS (ETEMP1,THICK,DELTAE,&80)
      ETEMP3=ETEMP1-DELTAE
      IF(ETEMP3.GT.0.) GO TO 32
      ETEMP1=ETEMP1+ETHRE
      GO TO 10
C
C     POS DEP
C
   32 CALL POSEND(ETEMP3,R,DDR,FAC,&80)
C
      ETEMP2=ENERGY/FAC+DELTAE
      EDIF=ABS(ETEMP2-ETEMP1)
      IF(EDIF.LE.ETHRE) GO TO 9
      ITERA=ITERA+1
      IF(ITERA.GE.10) GO TO 40
      ETEMP1=ETEMP2
      GO TO 10
C
   40 ITERA=1
      ETEMP1=0.5*(ETEMP1+ETEMP2)
      JTERA=JTERA+1
      IF(JTERA.LT.5) GO TO 10
      IFLAG=1
      RETURN
C
    9 RDATA(2)=ETEMP2
C      WRITE(6,940) ITERA,JTERA,ETEMP1,FAC,X,Y,R,DDR
C940   FORMAT(2I4,10F10.3)
      RETURN
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  BARREL PART COUNTERS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF LIGHT GUIDE
C
    1 R=RADIUS(3)+DEP
      COSPHI=COS(PHI)
      SINPHI=SIN(PHI)
C       X Y POSITION AT THE SHOWER MEDIAN.
      X=R*COSPHI
      Y=R*SINPHI
C
C     DISTANCE FROM THE SHOWER MAX POINT TO THE EXTRAPOLATED POINT
C           AT THE END FACE OF LEAD GLASS
      A=COSX*COSX+COSY*COSY
      B=X*COSX+Y*COSY
      C=X*X+Y*Y-RADIUS(4)*RADIUS(4)
      RDIF=(SQRT(B*B-A*C)-B)/A
C      X Y Z POSITION AT THE END FACE OF LG
      X=X+RDIF*COSX
      Y=Y+RDIF*COSY
CCC   Z=ZCO+RDIF*COSZ
C     WRITE(6,900) COSPHI,SINPHI,X,Y,Z,A,B,C,RDIF
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
CCC   Z=Z-ZEND(1)+0.5*ZGAP(1)
CCC   PERIOD=ZWID(1)+ZGAP(1)
CCC   IZ=Z/PERIOD+1
CCC   IF(IZ.LE.1) IZ=2
CCC   IF(IZ.GE.32) IZ=31
CCC   Z=Z-PERIOD*(IZ-0.5)
C
      THETA=ATAN2(Y,X)
      IF(THETA.LT.0.) THETA=THETA+PAI2
      STEP=PAI2/84.
      ITH=THETA/STEP
CCC   THETA=(THETA-(ITH+0.5)*STEP)*RADIUS(4)
C
CCC   R=0.1*SQRT(Z*Z+THETA*THETA)
CCCCCCC    CCC ARE NEEDED ONLY FOR POSITION CORRECTION.....
C
C       INCIDENT ANGLE
      ANGNOR=(ITH+0.5)*STEP
      COSNOR=COS(ANGNOR)
      SINNOR=SIN(ANGNOR)
C---     COSX = COSPHI*SINTET, COSNOR = COSPHI
C---     COSY = SINPHI*SINTET, COSNOR = SINPHI
      THETA=COSNOR*COSX+SINNOR*COSY
C        THETA = SIN(THETA) HERE

C     ABSORBER THICKNESS TRAVERSED BY THE PARTICLE.
C     D=7.88/ABS(THETA)    <--- OLD VERSION
      D=0.97*8.9/ABS(THETA)
      THETA=ACOS(THETA)*57.2958
C---       THETA = PI/2 - THETA = ANGLE WITH NORMAL OF CATHODE PLANE
C     WRITE(6,910) ITH,ANGNOR,COSNOR,SINNOR,THETA,D
C910  FORMAT(I4,10F12.4)
      IF(D.LT.50.) GO TO 70
      IFLAG=3
      RETURN
 70   CONTINUE
C
C---     CALCULATE RING # USING CORRECTED COS THETA
C
      ZHELP = COSZ / SQRT(1. - COSZ**2) * 1100.
      ZDIST = ZHELP - ZEND(1)
      NRING = INT ( ZDIST / ( ZGAP(1) + ZWID(1) ) )
C
C  - - - - - - - - - - - ITERATION - - - - - - - - - - - - - - -
C
      ITERA = 1
      EINC  = ENERGY

C---     ITERATION LOOP:

 21   CONTINUE

C===                                 SEPERATE PHOTONS: NO TRACK LINKED
      IF ( NIDTRK .EQ. 0 ) GO TO 23
C---                                        CHARGED CLUSTERS HERE
C
C---                              ENERGY LOSS OF ELECTRONS IN THE COIL :
C
      CALL ENGLOS ( EINC, D, DELTAE, &80 )
C
      EEXP=EINC-DELTAE
      IF ( EEXP .GT. 0. ) GO TO 22
      EINC = EINC + ETHRE
      GO TO 21
C
 22   CONTINUE
C              ANGLE DEPENDENCE
C
      AFAC = 1.
      CALL ANGBAR ( EEXP, THETA, AFAC, &80 )
      EEXP = EEXP * AFAC
C
C              FINE POSITION DEPENDENCE FOR BHABHAS
C
      PFAC = 1.
      PFAC = BRLGN ( EINC, RDATA(11), RDATA(4) )
      EEXP = EEXP * PFAC
      GO TO 26

C---                                       PHOTONS HERE
 23   CONTINUE
C---                                  BRANCH FOR MC: SHOWER VS. MEI-MAG
      IF ( NRUN .LT. 100 .AND. MCTYP .LE. 1 ) GOTO 24
C---                                            DATA AND SHOWER-MC HERE
      EEXP = EINC

      EFAC   = 1.0
      FACTOR = 1.0
C---                ENCORR FOR COIL, LEAKAGE, ANGULAR DEPENDENCE,
C                              READOUT THRESAHOLD FOR PHOTONS
      CALL ENCORR ( EINC, COSZ, EFAC  )
C--                        DISTINGUISH 1-BLOCK FROM MANY-BLOCK PHOTONS:
      CALL THCOFA ( 1000. * EINC, NRING, NRBLOC, FACTOR )

      EEXP = EEXP * EFAC * FACTOR

      GOTO 26
C
 24   CONTINUE
C---                    MEI MAG MC HERE
C
C---                              ENERGY LOSS IN THE COIL :
C
      CALL ENGLOS ( EINC, D, DELTAE, &80 )
C
      EEXP=EINC-DELTAE
      IF ( EEXP .GT. 0. ) GO TO 25
      EINC = EINC + ETHRE
      GO TO 24
C
 25   CONTINUE
C
C
C              CORRECTION FOR READOUT THRESHOLD
C              RTH = ENERGY LOST / ENERGY SEEN
C
      CALL THCORR ( EINCLG, NRING, RTH )
      EEXP = EEXP * ( 1. - RTH )
C---                           1-BLOCK-PHOTONS EXTRA:
      FACTOR = 1.
      CALL THCOFA ( EINCLG, NRING, NRBLOC, FACTOR )
      EEXP = EEXP * FACTOR
C
C              ANGLE DEPENDENCE
C
      AFAC = 1.
      CALL ANGBAR(EEXP,THETA,AFAC,&80)
      EEXP= EEXP*AFAC
C

 26   CONTINUE
C------------------------
C              ITERATION CONVERGENT ?
C
      EDIF = ENERGY - EEXP
      IF ( EINC .GT. 0.350  .AND.  ABS(EDIF).LE.ETHRE) GO TO 20
      IF ( EINC .LE. 0.350  .AND.  ABS(EDIF) / EINC .LE. 0.03 ) GOTO 20

C
C              MAX 10 ITERATIONS
C
      ITERA=ITERA+1
      IF(ITERA.GT.10) GO TO 50
C
C              NEXT ITERATION STEP
C
      EINC = EINC + EDIF
      GO TO 21
C
C  - - - - - - - - - - - END OF ITERATION - - - - - - - -
C
   50 CONTINUE
      PRINT 7122, ENERGY, EINC, COSZ, NRUN, NEVE
 7122 FORMAT (T2,'ITERATION OVERFLOW IN LGECOR: ESEEN, ECALC = ',
     +   2F10.4, ' ,COS THETA = ',F7.3,
     +    ' ,RUN ',0P,I5, ' ,EVENT ',I5)
      IFLAG=1
      RETURN
C
C              ITERATION SUCCESSFULL:
C
 20   CONTINUE
C
      RDATA(2)=EINC
C
CC      WRITE(6,10100) ENERGY,RDATA(4),RDATA(11),D,
CC     &  EINC,DELTAE,AFAC,PFAC,ITERA
CC10100 FORMAT(' <LGECOR> E',F8.3,', PHI',F6.3,', COSZ',F6.3,', D',F8.3,
CC     &  ', EINC',F8.3,', ELOSS',F6.3,', AFAC',F6.3,', PFAC',F6.3,
CC     &  ', ITERA',I3)
      RETURN
C
C     ILLEGAL RETURN
C
   80 RDATA(2)=ENERGY
      RETURN
C************************************
      ENTRY LGECR0(NVR)
C
C  VERSION NUMBER (DATE)   87  5 22
C
      DATA IVR/870522/
      NVR=IVR
      RETURN
      END

C   14/05/79 C9091801   MEMBER NAME  MUWIRE   (JADEMUS2)    FORTRAN
C   13/12/78 C9032201   MEMBER NAME  MUTINW   (JADEMUS)     FORTRAN
      SUBROUTINE MUWIRE(ICHAM,X,Y,Z)
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C
C PROVIDES X,Y,Z COORDINATES OF ONE END OF THE WIRE OF CHAMBER ICHAM.
C
C INPUT VARIABLES...
C
C ICHAM       CHAMBER NUMBER.
C
C OUTPUT VARIABLES...
C
C X,Y,Z       THE COORDINATES OF ONE END OF THE WIRE.
C
C-----------------------------------------------------------------------
C
C COMMONS
C
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C
C-----------------------------------------------------------------------
C
C FRAME NUMBER.
      IFRAME=HFR(ICHAM)
C
C ORIENTATION PARAMETER.
      IOR=HNORM(IFRAME)
C
C CALCULATE THE NORMAL COORDINATE.
      ICNORM=HDIST(IFRAME)+HD1(ICHAM)
C
C CALCULATE THE LOGITUDINAL COORDINATE.
      ICLONG=HCLLO(IFRAME)
C
C CALCULATE THE WIRE COORDINATE.
      ICWIRE=HCTW(ICHAM)
C
C X,Y,Z COORDINATES
      GO TO (11,12,13),IOR
 11   CONTINUE
      X=ICNORM
      Y=ICWIRE
      Z=ICLONG
      GO TO 20
 12   CONTINUE
      X=ICWIRE
      Y=ICNORM
      Z=ICLONG
      GO TO 20
 13   CONTINUE
      X=ICWIRE
      Y=ICLONG
      Z=ICNORM
 20   CONTINUE
C
C MAKE OVERALL TRANSLATION.
      X=X+HOVALL(HUNIT(IFRAME))
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
      RETURN
      END

C   06/06/84 406062125  MEMBER NAME  FINWRD   (S)           FORTRAN
***PMF      SUBROUTINE FINWRD(H,L,N1,N1two,N2,HW,IS)
      SUBROUTINE FINWRD(H,L,N1,N1two,N2,HW,IS)
      IMPLICIT INTEGER*2 (H)
      RETURN
      END

C   07/06/96 606071847  MEMBER NAME  GSTEER   (S4)          FORTRAN
      SUBROUTINE GSTEER(PGNAME,IVRCUR,MODE)
      COMMON/BCS/IW(1)
      COMMON/STEERC/JGOTO,NRUN,LRUN,JRETCD,JSW
      INTEGER PGNAME(2),IVRCUR,MODE,IEND/0/,IBS(2),INB(2),LND/-1/
      LOGICAL CURR/.FALSE./
      EXTERNAL BOOKEE
      IF(CURR) GOTO 10
C
C     INITIALIZE INDICES
C
      CURR=.TRUE.
      IBS(1)=IBLN('BKST')
      IBS(2)=IBLN('HEAD')
      LND=-1
C
C     FIND BANK INDICES
C
   10 DO 16 I=1,2
      INB(I)=0
      IND=IBS(I)+1
   12 IND=IW(IND-1)
      IF(IND.EQ.0) GOTO 16
      IF(IW(IND-2)+I-2) 12,14,16
   14 INB(I)=IND
   16 CONTINUE
C
C     UPDATE LAST ENTRY FROM RETURN CODE
C
   20 JGOTO=6
      IF(LND.LT.0) GOTO 30
      IND=INB(1)
      IF(IND.EQ.0) GOTO 30
      INCR=JRETCD
      IF(INCR.LT.0.OR.INCR.GT.10) INCR=11
      IW(IND+LND+5+INCR)=IW(IND+LND+5+INCR)+1
      LND=-1
C
C     CHECK PROCESSING OF THIS RECORD
C
   30 IF(IEND.EQ.1) GOTO 40
      IF(INB(2).EQ.0) GOTO 100
      IEVT=IW(INB(2)+4)
      IF(IEVT.NE.0) GOTO 100
      NRUN=IW(INB(2)+1)
   36 CALL BOOKCH(PGNAME,IVRCUR,IVROLD)
      IF(MODE.EQ.0) GOTO 38
      IF(MODE.EQ.1.AND.IVROLD.EQ.0) GOTO 38
      IF(MODE.EQ.2.AND.IVROLD.NE.IVRCUR) GOTO 38
      GOTO 100
   38 JGOTO=3
      CALL BOOKIN
C
C     FIND ENTRY IN (BKST,1)
C
   40 IND=INB(1)
      LND=0
      NW=0
      IF(IND.EQ.0) GOTO 52
      N=IW(IND)/20
      DO 42 I=1,N
      IF(IW(IND+LND+1).NE.PGNAME(1)) GOTO 42
      IF(IW(IND+LND+2).EQ.PGNAME(2)) GOTO 60
   42 LND=LND+20
C
C     ADD ENTRY TO (BKST,1)
C
   50 NW=IW(IND)
   52 IF(IEND.EQ.1) GOTO 72
      CALL BCRE(IND,'BKST',1,NW+20,&200,IER)
      IW(IND+LND+1)=PGNAME(1)
      IW(IND+LND+2)=PGNAME(2)
C
C     CHECK RUN SEQUENCE
C
   60 IF(IEND.EQ.1) GOTO 70
      IW(IND+LND+3)=MODE
      IW(IND+LND+4)=IW(IND+LND+4)+1
      JRETCD=0
      LRUN=IW(IND+LND+17)
      IF(NRUN.EQ.LRUN) GOTO 100
      IW(IND+LND+17)=NRUN
      JGOTO=4
      IF(LRUN.EQ.0) JGOTO=1
      GOTO 100
C
C     JOB END CASE
C
   70 LRUN=IW(IND+LND+17)
      IF(LRUN.EQ.0) GOTO 72
      IW(IND+LND+17)=0
      JGOTO=5
      LND=-1
      GOTO 100
   72 LND=-1
      JGOTO=6
      GOTO 100
C
C
C
      ENTRY GSTEND
C
C     ENTRY AT JOB END
C
   80 CALL BOOKEJ
      IEND=1
      CALL BLOC(IND,'BKST',1,&100)
      IF(LND.LT.0) GOTO 82
      INCR=JRETCD
      IF(INCR.LT.0.OR.INCR.GT.10) INCR=11
      IW(IND+LND+5+INCR)=IW(IND+LND+5+INCR)+1
   82 LND=-1
      WRITE(6,101)
      N=IW(IND)/20
      DO 84 I=1,N
      WRITE(6,102) (IW(IND+J),J=1,16)
      IF(IW(IND+4).NE.IW(IND+5)) GOTO 84
      WRITE(6,103) (IW(IND+J),J=1,2)
   84 IND=IND+20
      GOTO 100
C
C
C
      ENTRY GSTAGA
C
C     ENTRY TO START AGAIN
C
      IEND=0
      CALL BDLS('BKST',1)
C
C
C
  100 RETURN
  101 FORMAT('0PGNAME  MODE      SUM',9X,
     1   'STATISTIC ON PROCESSING RETURN CODES'/' -',5('----'),9X,
     2   '0',6X,'1',6X,'2',6X,'3',6X,'4',6X,'5',6X,'6',6X,'7',6X,
     3   '8',6X,'9',5X,'10  UNDEFINED')
  102 FORMAT(1X,2A4,I4,I9,3X,11I7,I11)
  103 FORMAT(1X,2A4,'<---',' RETURN CODE ALWAYS 0, NO PROCESSING DONE')

  104 FORMAT('0STOP IN GSTEER DUE TO INSUFFICIENT SPACE')
C
C     ERROR - INSUFFICIENT SPACE
C
  200 WRITE(6,104)
      CALL ABEND
      GOTO 100
      END

C   08/07/80 707221940  MEMBER NAME  ADJCIR   (TPSOURCE)    FORTRAN
      SUBROUTINE ADJCIR (IPATR,IND1,IND2)
C
C     M.NOZAKI  12-06-80  18:30
C
C      FIND NEAREST LOW ENERGY ELECTRON TRACK
C
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C                            MAX. DISTANCE OF TWO CIRCLES (MM)
      DATA  DCMAX / 50. /
C                            MIN. CURVATURE
      DATA  CURV0 /2.5E-3/
C                            MIN. OF MIN.DISTANCE
      DATA  RMINC / 100. /
C
       IND2 = 0
C
       NTRK = IDATA(IPATR+2)
        IF(NTRK.LE.0) RETURN
       LTR = IDATA(IPATR+3)
       L0 = IDATA(IPATR+1) + IPATR
       L9 = L0 + LTR*(NTRK-1)
C
       IF(ABS(ADATA(IND1+25)).LT.CURV0) RETURN
       CALL PRTOCI (IND1,CURV1,RMIN1,EPS1,SIG1)
       IF(RMIN1.LT.RMINC) RETURN
       RAD1 = 1./CURV1*SIG1
       EPS1 = ADATA(IND1+21)
       XC1 = (RAD1+RMIN1)*COS(EPS1)
       YC1 = (RAD1+RMIN1)*SIN(EPS1)
       DCM = DCMAX
C
      DO 1010 IP = L0,L9,LTR
       IF(IP.EQ.IND1) GOTO 1010
       IF(ABS(ADATA(IP+25)).LT.CURV0) GOTO 1010
       CALL PRTOCI (IP,CURV2,RMIN2,EPS2,SIG2)
       IF(CURV2.GT.CURV1) GOTO 1010
       RAD2 = 1./CURV2*SIG2
       XC2 = (RAD2+RMIN2)*COS(EPS2)
       YC2 = (RAD2+RMIN2)*SIN(EPS2)
       DC = SQRT((XC1-XC2)**2+(YC1-YC2)**2)
       IF(DC.GT.DCM) GOTO 1010
       DCM = DC
       IND2 = IP
 1010 CONTINUE
C
      RETURN
      END

C   09/10/79 002161537  MEMBER NAME  ANOM68   (S)           FORTRAN
      SUBROUTINE ANOM68(IRUN)
C---  ANOMALIES OF RUNS 1662 - 1686
C---  15.32 GEV      SEPTEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     16.02.80    15:35
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1662,13,1664,1665,1666,1667,13,1669,13,1671,13,1673,1674,13,
     &      1676,1677,1678,1679,1680,1681,1682,1683,1684,1685,1686),IRUN
   13 RETURN
C
 1662 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
C1664 PRELIMINARY
 1664 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(162) = -1
      LIMIT(162) = 75
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
C1665 PRELIMINARY
 1665 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
C1666 PRELIMINARY
 1666 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
C1667 PRELIMINARY
 1667 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(162) = -1
      LIMIT(162) = 75
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
 1669 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(162) = -1
      LIMIT(162) = 75
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 120
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(50) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(56) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(62) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(65) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(74) = .TRUE.
      LTHRES(76) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(81) = .TRUE.
      LTHRES(82) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(86) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(90) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
C
      RETURN
C
 1671 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(50) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(62) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(65) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(68) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(73) = .TRUE.
      LTHRES(76) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(81) = .TRUE.
      LTHRES(82) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(86) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(90) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
C
      RETURN
C
 1673 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(73) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
C
      RETURN
C
C1674 PRELIMINARY
 1674 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(59) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(73) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
C
      RETURN
C
C1676 PRELIMINARY
 1676 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(73) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
 1677 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 120
C
      LTHRES(67) = .TRUE.
      LTHRES(165) = .TRUE.
      LTHRES(166) = .TRUE.
      LTHRES(167) = .TRUE.
C
      RETURN
C
 1678 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(73) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
      LTHRES(112) = .TRUE.
C
      RETURN
C
C1679 PRELIMINARY
 1679 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(59) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(73) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
C
      RETURN
C
 1680 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(82) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
C1681 PRELIMINARY
 1681 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(162) = -1
      LIMIT(162) = 45
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 120
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(82) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1682 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      RETURN
C
 1683 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(1) = .TRUE.
      LTHRES(7) = .TRUE.
      LTHRES(18) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(32) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(46) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
C1684 PRELIMINARY
 1684 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 75
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
C1685 PRELIMINARY
 1685 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(162) = -1
      LIMIT(162) = 75
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 1686 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
      END

C   19/11/79 306101856  MEMBER NAME  PEDC     (S)           FORTRAN
      SUBROUTINE PEDC
#include "tfprm.for"
#include "tfadc.for"
      DIMENSION A(84,5),B(84,5),DIF(84,5)
      CALL SETSL(DIF,0,420*4,0)
      DO   5   I=1,42
      A(2*I-1,1) = PEDLM(I)
      A(2*I  ,1) = PEDLP(I)
    5 CONTINUE
      KEND = 4
      IUN = 10
   10 CONTINUE
      K = IUN-8
      IF(K.LT.1) K = 1
      READ(IUN) (A(L,K),L=1,84)
      IUN = IUN + 1
      IF(IUN.LE.8+KEND)  GOTO  10
      IF(KEND.LT.2)  GOTO  25
      DO   20   L=1,84
      DO   15   K=2,KEND
      DIF(L,K) = A(L,K) - A(L,1)
   15 CONTINUE
   20 CONTINUE
C
   25 DO   30   L=1,84
      PRINT 101,L,(A (L,K),K=1,KEND),(DIF(L,K),K=1,KEND)
 101  FORMAT(I5,10F10.3)
   30 CONTINUE
      PRINT 103
  103 FORMAT(///)
C
      RETURN
      END

C   22/10/79 001232336  MEMBER NAME  ANOM95   (S)           FORTRAN
      SUBROUTINE ANOM95(IRUN)
C---  ANOMALIES OF RUNS 1920 - 1928
C---  15.56 GEV      OCTOBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     23.01.80     23:35
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1920,1921,1922,1923,1924,1925,1926,1927,1928),IRUN
   13 RETURN
C
 1920 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(107) = +1
      LIMIT(107) = 345
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(173) = +1
      LIMIT(173) = 450
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C1921 PRELIMINARY
 1921 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(107) = +1
      LIMIT(107) = 345
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(173) = +1
      LIMIT(173) = 450
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 1922 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(35) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C1923 PRELIMINARY
 1923 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 75
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(7) = .TRUE.
      LTHRES(35) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C1924 PRELIMINARY
 1924 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(35) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C1925 PRELIMINARY
 1925 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(35) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C1926 PRELIMINARY
 1926 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 135
      KCONST(184) = -1
      LIMIT(184) = 120
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(7) = .TRUE.
      LTHRES(35) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C1927 PRELIMINARY
 1927 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(35) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C1928 PRELIMINARY
 1928 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(35) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
      END

C   02/11/81 903061114  MEMBER NAME  MCJADE   (S)           FORTRAN
      SUBROUTINE MCJADE( NREVS, IPRINT )
C--------------------------------------------------------
C   SPECIAL VERSION OF JADE MONTE CARLO TRACKING PROGRAM
C                      USING
C   TOKYO SHOWER MONTE CARLO (A.SATO, S.YAMADA)
C                       IMPLEMENTED BY J.OLSSON
C
C   PHOTONS ARE TREATED IN SPECIAL VERSION OF TRKGAM, WHICH RETURNS2
C   AFTER COMPLETION OF SHOWER. THIS GIVES RETURN1 IN JTRKGM AND NEXT..
C   ELECTRONS ARE FED INTO LGMC56 DIRECTLY IN THIS MAIN ROUTINE..
C--------------------------------------------------------
C
C             11/05/79                          E.ELSEN
C      MOD  E. ELSEN    10/06/82 :
C      MOD  J. OLSSON   30/08/83 :  SUBSET TRACKED & EVENT COUNTING
C      MOD  W. BARTEL   25/10/83 :  PARTICLES BEYOND COIL NOT TRACKED
C      MOD  C. BOWDERY  17/11/83 :  CALL TO MCVSUM FOR ERROR SUMMARY
C      MOD  C. BOWDERY  24/11/83 :  DELETE CALL TO TRCOIL FOR PHOTONS
C      MOD  W. BARTEL   29/11/83 :  IEVMIN/MAX (/CIEVS/) DEFLT. IN BLDAT
C      MOD  W. BARTEL   29/11/83 :  INTRODUCE N AND K0L TRACKING
C      MOD  W. BARTEL   29/11/83 :  EXTERNAL JADEBD  INSTEAD OF BLDAT
C      MOD  J. HAGEMANN 28/08/84 :  VERTEX CHAMBER TRACKING FACILITY
C           R. RAMCKE               IMPLEMENTED
C      MOD  J. HAGEMANN 19/04/86 :  FWDDET REPLACED BY MCTAGM
C      MOD  J.OLSSON    09/06/86 :  LFLAG(2) IS TRUE IF LFLAG(4) IS TRUE
C      MOD  J.OLSSON    11/06/86 :  NSEC T.O. LIMIT DEPENDS ON LFLAG(4)
C      MOD  J.OLSSON    25/04/87 :  LFLAG(6) FOR TOKYO SHOWER PROGRAM
C
C
C    ALLOWS SECTIONS OF THE INPUT FILE TO BE TRACKED.
C    MINIMUM AND MAXIMUM NR OF EVENT SET IN SUBR. JGETEV
C    EVENT COUNT PASSED VIA /CIEVS/ KIEV,IEVMIN,IEVMAX
C
C    WRITE NREVS MTC EVENTS ON UNIT 2. TAKE INPUT FOUR VECTORS
C    FROM ROUTINE JGETVC.
C    IF NREVS .EQ. 0, EVENTS ARE WRITTEN UNTIL EOF OR TIME OUT.
C    INPUT FOUR VECTORS FOR THE FIRST IPRINT ARE PRINTED.
C
C-----------------------------------------------------------------------
C
C      UPDATED TO JMC.S STANDARD     11.5.1984   J.OLSSON
C      UPDATED TO ALEX FINCH NEW FW   4.11.1985   J.OLSSON
C      UPDATED TO CALL LGMC56, SF5-SF6 SHOWER MC  J.OLSSON   23.1.86
C
C--------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C                                              BLOCK DATA IS NOW JADEBD
      EXTERNAL JADEBD
C
      COMMON / CJTCDC / IBANK, IPART
      COMMON / CIEVS / KIEV,IEVMIN,IEVMAX
C
      COMMON /CCSF56/ NFINAL,NTR56
C
      COMMON /BCS/ IW(30000)
      DIMENSION HW(1),AW(1)
      EQUIVALENCE(IW(1),HW(1)),(IW(1),AW(1))
C
      COMMON / COLSON/ IPRO
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      DIMENSION PV(10),R0(5),RR(5),RYAM(3)
      DIMENSION PVSAVE(10),R0SAVE(3)
C-----------------------
C  SHOWER MC COMMON, BLOCK DATA SET IN LGCR56
C
      COMMON /CLGD56/ RADIUS(6),ZEND(2),ZWID,ZGAP,PHWID,
     2                ECXLST(24), ECYLST(24),ZECAP(4),ZPV(4),TPV,
     3                TH(4),THECP
C
C     RADIUS(1,2) = DISTANCE TO THE COIL SURFACES(INNER AND OUTER)
C       THESE VALUES ARE AVERAGES, SINCE THE TOTAL RADIATION LENGTH IS
C       IS ASSUMED TO COME FROM PURE AL. IN REALITY PLASTIC AND H20 IS
C       ALSO CONSIDERED:
C
C  1979-1983: 97.85 % X0 = 0.9785*88.947 MM = 87.03 MM
C        DATA RADIUS/ 900.0, 987.0, 1100.0, 1400.0, 1150.0, 1400.0/
C
C  1984-1986: 104.10 % X0 = 1.0410*88.947 MM = 92.59 MM
C        DATA RADIUS/ 900.0, 992.6, 1100.0, 1400.0, 1150.0, 1400.0/
C
C     RADIUS(3,4) = DISTANCE TO THE LEAD GLASS SURFACES(TYPE A)
C     RADIUS(5,6) = DISTANCE TO THE LEAD GLASS SURFACES(TYPE A-PR)
C---------------------------
C
      DATA NSEC / 4 /, IERR2/0/, IERR3/0/, IERR4/0/
      DATA NUNIT / 2 /
C
      LOGICAL*1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGS CODE
C                              (MEIER / MAGNUSSEN PROGRAM)
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                 BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C        LFLAG(6) = 3 DIM TOKYO SHOWER PROGRAM, JADE NOTE 20A
C
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
C
C------------------  C O D E  ------------------------------------------
C
C                                           PRINT NEWS
      CALL MCNEWS
C
C     ***** JBWTOR ENABLE OPERATOR TO CANCEL IN ORDERED FASHION *****
C             INITIALIZE
C
      CALL JBWTOR(&2727)
      GO TO 2728
C
2727  WRITE(6,2729)
2729  FORMAT(/,'========== JBWTOR INIT ERROR =======')
2728  CONTINUE
C
C
      IF(LFLAG(6)) WRITE(6,913)
913   FORMAT('  ****************************************************'/
     $       '  *                                                  *'/
     $       '  *   TOKYO SHOWER MONTE CARLO,   SF5 + SF6  VERSION *'/
     $       '  *                                                  *'/
     $       '  ****************************************************')
C
C
C   LFLAG(1-3) MUST BE TRUE IF TOKYO SHOWER SIMULATION IS USED
C
      IF(LFLAG(4).AND..NOT.LFLAG(2)) WRITE(6,681)
681   FORMAT(' ### WARNING ###  LFLAG(2) SET TRUE, SINCE LFLAG(4) TRUE')
      IF(LFLAG(6).AND..NOT.LFLAG(2)) WRITE(6,693)
693   FORMAT(' ### WARNING ###  LFLAG(2) SET TRUE, SINCE LFLAG(6) TRUE')
      IF(LFLAG(4).AND..NOT.LFLAG(2)) LFLAG(2) = .TRUE.
      IF(LFLAG(6).AND..NOT.LFLAG(2)) LFLAG(2) = .TRUE.
C
      IF(LFLAG(6).AND..NOT.LFLAG(1)) WRITE(6,678)
678   FORMAT(' ### WARNING ###  LFLAG(1) SET TRUE, SINCE LFLAG(4) TRUE')
      IF(LFLAG(6).AND..NOT.LFLAG(1)) LFLAG(1) = .TRUE.
      IF(LFLAG(6).AND..NOT.LFLAG(3)) WRITE(6,679)
679   FORMAT(' ### WARNING ###  LFLAG(3) SET TRUE, SINCE LFLAG(4) TRUE')
      IF(LFLAG(6).AND..NOT.LFLAG(3)) LFLAG(3) = .TRUE.
C IF TOKYO OR MEIER CODE IS USED, LARGER TIME OUT LIMIT IS NEEDED
      IF(LFLAG(6).OR.LFLAG(4)) NSEC = 6
C
C  LFLAG(5) MUST BE TRUE IF VERTEX CHAMBER GEOMETRY IS USED
C
      IF(LFLAG(5).AND.(HDATE(6).GT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).GE.5))) GO TO 692
      IF(.NOT.LFLAG(5).AND.(HDATE(6).LT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).LT.5))) GO TO 692
      IF(HDATE(6).GT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).GE.5)) LFLAG(5) = .TRUE.
      IF(HDATE(6).LT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).LT.5)) LFLAG(5) = .FALSE.
      WRITE(6,691)
691   FORMAT('  #####  WARNING ####  LFLAG(5) HAS BEEN SWITCHED TO AGREE
     $ WITH COMMON /TODAY/ SETTING OF DETECTOR HARDWARE')
692   CONTINUE
C
C THE SHOWER MC COMMON, /CLGD56/, NEEDS ADJUSTMENT OF SOME PARAMETERS
C                                 FOR 1984-1986 (Z-CHAMBER)
C
      IF(HDATE(6).LT.1984) GO TO 1450
C
      RADIUS(2) = 992.6
      TH(1) = RADIUS(2) - RADIUS(1)
      TH(2) = RADIUS(3) - RADIUS(2)
C
1450  CONTINUE
C                                           INPUT OF MUCHAMBER CALIBRATI
      CALL MUCONM
C
C                                           INITIALIZE PROGRAM
 2200 NEVTS = NREVS
      IF( NEVTS .EQ. 0 ) NEVTS = 999999
C
      IWRT = 0
      CALL BWRO( NUNIT, 1558, 2 )
      CALL JINIT
C
C     IF(LFLAG(4)) WRITE(6,111)
C 111 FORMAT(///,X,'***********************************************',/,
C    *           X,'* LEAD GLASS SIMULATION IS DONE USING         *',/,
C    *           X,'*        F11MEI.MCSHOWS(TRLG3)                *',/,
C    *           X,'*                                             *',/,
C    *           X,'* CONTAINING :                                *',/,
C    *           X,'*                                             *',/,
C    *           X,'*     - EM. SHOWERS FROM INTEGRATION OVER     *',/,
C    *           X,'*       3 DIM SHOWER FUNCTION FOR PARTICLES   *',/,
C    *           X,'*       ABOVE 100 MEV                         *',/,
C    *           X,'*     - STANDARD EM-SHOWER PROCEDURE FOR      *',/,
C    *           X,'*       FOR LOW ENERGY PARTICLES              *',/,
C    *           X,'*     - HADRON INTERACTION USING THE KANZAKI  *',/,
C    *           X,'*       SCHEME BASED ON THE KEK MEASURMENTS   *',/,
C    *           X,'*       LIGHT GUIDES ARE INCLUDED FOR BARREL  *',/,
C    *           X,'*                                             *',/,
C    *           X,'*                           VERSION 20/09/83  *',/,
C    *           X,'***********************************************',//)
C
C                                      ************************
C                                       **                  **
C                                         **  EVENT LOOP  **
C                                       **                  **
C                                      ************************
      DO 1001 IEV=1,NEVTS
C
C TEST FOR OPERATOR STOP
C
      CALL JBWTOR(&92)
C
C
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1011
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1011
      GO TO 90
C                                           INITIALISE EVENT
1011  CALL EVTINI
      IJETCP = 0
      IPRI = 1
      IF( IWRT .GT. IPRINT -1) IPRI= 0
C                                           GET EVENT
      CALL JGETEV( &91 )
C
C                                      ************************
C                                       **                  **
C                                         **  TRACK LOOP  **
C                                       **                  **
C                                      ************************
      NTR56 = 0
 1002 CONTINUE
C                                           NEXT PARTICLE
      CALL JGETVC( PV, R0, ICODE, IPRI )
      NTR56 = NTR56 + 1
      IF(NTR56.GT.NFINAL) GO TO 2120
      IPSF56 = IW(IBLN('SF56'))
      IF(IPSF56.GT.0) HW(2*IPSF56+2+2*NTR56) = -1
C
2120  IF( ICODE .GT. 0 ) GO TO 1003
C
C                                           CHECK TIME FOR PARTICLES
C                                           NECCESSARY IF MUONS INCLUDED
C                                           NECCESSARY IF SHOWER IS USED
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1012
      IF( JUHR(NSEC) .NE. 2 ) GO TO 1012
      KIEV = KIEV - 1
      GO TO 90
C
C     DON'T TRACK PARTICLES WHICH START ONLY BEYOND THE COIL OR
C     THE END CAP LEAD GLASS ARRAY
C                                   OCT. 25. 1983 W.BARTEL
C
1012  R4 =  R0(1)*R0(1) + R0(2)*R0(2)
      R4 = SQRT( R4 )
      IF( R4 .GT. RCOIL) GO TO 1000
      IF( ABS(R0(3)) .GT. ZENDPL) GO TO 1000
C
C                                           FWD TRACKING
      CALL MCTAGM( PV, R0)
C                                           BRANCH ACCORDING
C                                           TO CHARGE OF PARTICLE, PV(7)
C                                           AND TYPE OF PARTICLE, PV(8)
C
C
      IF(IPRO.NE.0) WRITE(6,2431) (PV(IK),IK=1,10)
2431  FORMAT(' MCJADE: PV ',10(F10.4,1X))
C
C                                           NEUTRINOS
      IF( PV(7) .EQ. 0. .AND. PV(8).LT.0.5) GO TO 1002
C                                           PHOTONS
      IF( PV(7) .EQ. 0. .AND. PV(8).LT.2.) GO TO 3
C
C                                           BRANCH OFF K0L AND N
      IF( PV(7) .EQ. 0. .AND. ABS(PV(8)-5.) . LT. 1.E-5) GO TO 4
      IF( PV(7) .EQ. 0. .AND. ABS(PV(8)-6.) . LT. 1.E-5) GO TO 4
C
C                                     *** CHARGED PARTICLES HERE ***
C
C***********************************************************************
C                                           CHECK IF VERTEX CHAMBER
C                                           TRACKING IS WANTED
      IF( .NOT. LFLAG(5) )  CALL TRCDET(PV,R0,RR,&1004)
      IF(  LFLAG(5) )  CALL TRCDTV(PV,R0,RR,&1004)
C***********************************************************************
C                                          MOMENTUM CHECK, PV(6)
      IF( PV(6) .LT. .001 ) GO TO 1000
C#######################################################################
C    SPECIAL SECTION FOR PASSING ELECTRONS INTO THE TOKYO SHOWER PROGRAM
C
C  LOSS IS A MASS LABEL
C
      LOSS=2
      IF(PV(5).LT.1.E-03) LOSS=1
      IF(PV(5).EQ.0.)     LOSS=0
      IF(LOSS.NE.1) GO TO 5300
C
C                               ELECTRONS HERE
      PVX=PV(1)/PV(6)
      PVY=PV(2)/PV(6)
      PVZ=PV(3)/PV(6)
      PVXY=PVX**2+PVY**2
C
      R1=RR(1)**2+RR(2)**2
C TEST HERE IF THE ELECTRON ALREADY TRACKED FARTHER THAN RADIUS(1)
      REL1 = SQRT(R1)
      IF(REL1.LE.RADIUS(1)) GO TO 1400
C  SCALE ELECTRON RR VECTOR
      SCEL = RADIUS(1)/REL1
      RR(1) = SCEL*RR(1)
      RR(2) = SCEL*RR(2)
      RR(3) = SCEL*RR(3)
      R1=RR(1)**2+RR(2)**2
C
1400  DR2=(ROTNK**2-R1)/PVXY
      IF(IPRO.NE.0) WRITE(6,931) DR2,R1,ROTNK,PVXY
931   FORMAT(' MCJADE ELECTRON:  DR2 R1 ROTNK PVXY ',4E15.7)
      IF( DR2 .GT. 0. ) GO TO 1515
      RY=RR(1)**2+RR(2)**2
      DRY=(RADIUS(1)**2-RY)/PVXY
      PVR=RR(1)*PVX+RR(2)*PVY
      PVR=PVR/PVXY
      PVR2 = PVR**2 + DRY
      IF(PVR2.GE.0.) GO TO 1074
      IERR2 = IERR2 + 1
      IF(IERR2.LT.50) WRITE(6,1073) IEV,IWRT,R0(1),R0(2),R0(3),PVR,DRY
1073  FORMAT(' ---> ERROR2  MCJADE: IEV+W R01-3 PVR DRY ',2I6,5E14.6)
      IF(IERR2.LT.50) WRITE(6,1081) (PV(IO),IO=1,10)
1081  FORMAT(' ---> ERROR2  MCJADE: PV1-10 ',5E14.6)
      IF(IERR2.LT.50) WRITE(6,1082) RADIUS(1),(RR(IO),IO=1,3),PVXY
1082  FORMAT(' ---> ERROR2  MCJADE: RADIUS1 RR1-3 PVXY ',5E14.6)
      GO TO 1002
1074  XL=-PVR+SQRT(PVR2)
C
      RYAM(1)=RR(1)+XL*PVX
      RYAM(2)=RR(2)+XL*PVY
      RYAM(3)=RR(3)+XL*PVZ
      GO TO 15
1515  PVR=RR(1)*PVX+RR(2)*PVY
      PVR=PVR/PVXY
      PVR2 = PVR**2 + DR2
      IF(PVR2.GE.0.) GO TO 1075
      IERR3 = IERR3 + 1
      IF(IERR3.LT.50) WRITE(6,1076) IEV,R0(1),R0(2),R0(3),PVR,DR2
1076  FORMAT(' ---> ERROR3  MCJADE: IEV R01-3 PVR DR2 ',I6,5E14.6)
      GO TO 1001
1075  XL=-PVR+SQRT(PVR2)
C
      RYAM(1)=RR(1)+XL*PVX
      RYAM(2)=RR(2)+XL*PVY
      RYAM(3)=RR(3)+XL*PVZ
15    IREGFL = 0
      IF(IPRO.EQ.0) GO TO 1516
      RYRAD = SQRT(RYAM(1)**2+RYAM(2)**2)
      WRITE(6,9333) ZTKP,ZTKM,RYRAD,RYAM(3)
9333  FORMAT(' ZTKP,ZTKM RYRAD RYAM3 ',4E14.6)
C
1516  IF(RYAM(3).LT.ZTKP.AND.RYAM(3).GT.ZTKM) GO TO 1517
C
C END CAPS
C
      RABS=0.
      DO 801 I3=1,3
 801  RABS=RABS+RYAM(I3)**2
      IF(RABS.GE.0.) GO TO 1077
      IERR4 = IERR4 + 1
      IF(IERR4.LT.50) WRITE(6,1078) IEV,R0(1),R0(2),R0(3),PVR,DR2
1078  FORMAT(' ---> ERROR4  MCJADE: IEV R01-3 PVR DR2 ',I6,5E14.6)
      GO TO 1001
1077  RABS=SQRT(RABS)
      DO 802 I3=1,3
 802  RYAM(I3)=RYAM(I3)/RABS
      ZLAM=ZPV(1)/RYAM(3)
      IREGFL = -1
      IF( RYAM(3) .GT. 0. ) ZLAM=ZPV(3)/RYAM(3)
      IF( RYAM(3) .GT. 0. ) IREGFL = 1
      DO 803 I3=1,3
 803  RYAM(I3)=ZLAM*RYAM(I3)
      IF(IPRO.EQ.0) GO TO 1517
      RYRAD = SQRT(RYAM(1)**2+RYAM(2)**2)
      WRITE(6,9332) ZPV(1),ZPV(3),RYRAD,RYAM(3)
9332  FORMAT(' ZPV1,3 RYRAD RYAM3 ',4E14.6)
C
1517  IF(IPRO.GT.0) WRITE(6,6411) IREGFL
6411  FORMAT(' MCJADE ELECTRON*: IREGFL IN LGMC56 CALL= ',I4)
      CALL LGMC56(0,PV(1),RYAM(1),IREGFL,1)
      GO TO 1000
C                             END SPECIAL SECTION HERE
C#######################################################################
C
C
5300  CALL TRCOIL(PV,RR,&992 )
C                                           SAVE VECTORS
  992 R0(1) = RR(1)
      R0(2) = RR(2)
      R0(3) = RR(3)
      GO TO 996
C
C                                           TRACK PHOTONS
    3 IF(IPRO.NE.0) WRITE(6,3751)
3751  FORMAT(' MCJADE PHOTON AND CALL TO JTRKGM ')
      CALL JTRKGM(PV,R0,&1000)
      GO TO 996
C                                           TRACK K0L , N
    4 CALL JTRNTR(PV,R0,&1000)
C                                           SAVE VECTORS
  996 R0SAVE(1) = R0(1)
      R0SAVE(2) = R0(2)
      R0SAVE(3) = R0(3)
      DO 995 ISA = 1,10
  995 PVSAVE(ISA) = PV(ISA)
C                                           LEAD GLASS
C           WITH SHOWER PROGRAM, THIS IS ONLY FOR MUONS AND HADRONS
      CALL TRLGL(PV,R0,&997)
C
  997 CONTINUE
C
  998 IF( PV(6) .LT. .001 ) GO TO 1000
C                                  MURTNE IS A DUMMY
      CALL MURTNE(PVSAVE,R0SAVE)
      GO TO 1000
C
 1004 IF( IJETCP .GT. 0 ) GO TO 1000
      IJETCP = 1
      WRITE(6,151) IEV, IPART
  151 FORMAT(5X,' TOO MANY JET-CHAMBER HITS AT EVENT',I5,' TRACK',I4)
      GO TO 1000
C
C
 1000 CONTINUE
C                               >>>>>>>  END OF TRACK LOOP  <<<<<<<<
      GO TO 1002
C
 1003 CONTINUE
C
C***********************************************************************
C                                           SORT VERTEX CHAMBER HITS
      IF( LFLAG(5) ) CALL JSTORE
C***********************************************************************
C
      CALL JSPOIN
      CALL ORDLG
      CALL MUORDR
      CALL TOFMAK
      CALL WRTMCB( NUNIT )
      IWRT = IWRT + 1
C
 1001 CONTINUE
C                               >>>>>>>  END OF EVENT LOOP  <<<<<<<<
C
C                                           NO MORE EVENTS REQUESTED
C
      WRITE(6,9105)
 9105 FORMAT(/' --  END OF REQUESTED DATA  --')
      GO TO 91
C
C                                           TIME OUT
   90 CONTINUE
      WRITE(6,9101)
 9101 FORMAT(/' ========= TIME OUT =========')
      GO TO 91
C
C
C                                          OPERATOR STOP
C
   92 CONTINUE
      WRITE(6,9102)
 9102 FORMAT(/'======== OPERATOR STOP=========')
      GO TO 91
C
C                                           END OF DATA
   91 CONTINUE
      CALL BMLT( 0, DUMMY )
      CALL BWRITE( NUNIT )
C
C                                           PRINT INPUT ERROR SUMMARY
C
      CALL MCVSUM
C
      ILAST = IEVMIN + KIEV - 1
      WRITE(6,109) NEVTS, IEVMIN,ILAST,KIEV, IWRT
  109 FORMAT(//1X,I6,' EVENT(S) REQUESTED TO BE TRACKED.'/
     +  1X,I6,' IS RECORD NO. OF FIRST REQUESTED EVT FROM INPUT FILE.'/
     +  1X,I6,' IS RECORD NO. OF LAST EVENT READ FROM INPUT FILE.'/
     +  1X,I6,' EVENT(S) READ FROM THE INPUT FILE.'/
     +  1X,I6,' EVENT(S) WRITTEN OUT.'//)
      RETURN
      END

C   08/06/86 807251549  MEMBER NAME  GPHMAIN  (S)           FORTRAN
C
C----------------------------------------------------------------------
C     MAIN PROGRAM FOR JADE GRAPHICS           JUNE       1986
      PROGRAM GPHMAIN
C----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL  17/05/78 :  MAIN PROGRAM FOR GRAPHICS
C
C        MOD  C. BOWDERY  13/03/84 :  MAJOR OVERHAUL
C        MOD  C. BOWDERY  25/04/84 :  CDTL DEFAULTS CHANGED
C        MOD  C. BOWDERY  14/06/84 :  NEW COMMONS BLOCK DATA SET
C        MOD  C. BOWDERY  12/10/84 :  BLOCK DATA CHANGE
C        MOD  J. HAGEMANN 24/10/84 :  UPDATE PRINTOUT
C        MOD  C. BOWDERY  24/04/85 :  BLOCK DATA COMES FROM MACRO NOW
C        MOD  C. BOWDERY   9/07/85 :  LINK HELP DATASET (DIRECT ACCESS)
C        MOD  C. BOWDERY   3/08/85 :  TIDY UP SCREEN CLEARING
C        MOD  C. BOWDERY   8/06/86 :  CODE PUT INTO SUBROUTINES
C   LAST MOD  J. HAGEMANN 05/03/88 :  FOR OWN BLOCKDATA
C
C         THIS PROGRAM STARTS A GRAPHICS SESSION AND CALLS SUPERV
C   ==>   It contains lower case letters. Check ASIS mode!
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8   DDN,VOLSR
      LOGICAL  OK
C
C                            MACRO CBCSMX.... BOS COMMON + SIZE DEFINED
C
C-----------------------------------------------------------------------
C             MACRO CBCSMX.... BOS COMMON + SIZE DEFINITION
C
C             THIS MACRO DEFINES THE IDATA/HDATA/ADATA NAMES AND
C             FIXES THE ACTUAL SIZE OF /BCS/. IT IS THUS IDEAL FOR
C             MAIN PROGRAMS OR THE SUPERVISOR. LDATA CAN BE USED BY BINT
C
C-----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(60000)
      DIMENSION HDATA(120000),ADATA(60000)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1))
      DATA  LDATA / 60000 /
C
C------------------------ END OF MACRO CBCSMX --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CGAMOD / MODEGA, GAHEX
C
      DIMENSION IHLP(11)
C
      DATA  VOLSR/'        '/
C
      DATA  IHLP /'F22B','OW.H','ELP.','DATA','SET ','    ',5*'    '/
C
C------------------  C O D E  -----------------------------------------
C
C                            INITIALISE PLOT10
C
      CALL INITT(DUMMY)
      CALL TWINDO(0,4095,0,4095)
C
C                            ARE WE RUNNING IN GA MODE? MODEGA = 1 ?
C                            IF YES, CLEAR THE TSO SCREEN
C
      CALL TESTGA( MODEGA, GAHEX )
C
      IF( MODEGA .EQ. 1 ) CALL CLEAR
C
C                            WELCOME THE USER
C
      CALL WELCME
C
C                            ALLOCATE FORTRAN LUN TO INPUT DATA SET.
C
      CALL RALLOC( OK )
      IF( .NOT. OK ) GO TO 10
C
C                            ALLOCATE THE DIRECT ACCESS HELP DATASET
C
      CALL GETPDD(IHLP,VOLSR,DDN,50,HERR)
      IF( HERR .NE. 0  .AND.  HERR .NE. 1040 )
     +                  CALL TRMOUT(80,'Warning: The HELP dataset could
     +not be allocated.^')
C
C                            ALLOCATE THE CALIBRATION DATASETS
C
      CALL CALLOC ( OK )
      IF( .NOT. OK ) GO TO 10
C
C                            CLEAR SCREEN AND INITIALISE BOS
C
      CALL CLRCON
      CALL BINT(LDATA,LDATA,200,1)
C
C                            SET UP DEFAULT GRAPHICS VALUES
C
      CALL SETUPG
C
C                            CALL MAIN ANALYSIS SUPERVISOR ROUTINE.
C
      CALL SUPERV
C
C                            END SCAN SESSION AND TERMINATE PLOT10.
C                            OK IS INPUT ARGUMENT.
C
  10  CALL ENDMES( OK )
C
C                            CLEAR GRAPHICS SCREEN IF IN GA MODE
C                            THEN TERMINATE PLOT10.
C
      IF( MODEGA .EQ. 1 ) CALL ERASE
      CALL FINITT(0,0)
C
      STOP
      END
C
C                            BLOCK DATA FOR GRAPHICS PROGRAM
C
C #include "grblock.for" PMF 5.11.98
C   24/04/85 807251550  MEMBER NAME  GRBLOCK  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      BLOCK DATA BLCKG2 !PMF 03/12/99: add name
C-----------------------------------------------------------------------
C
C                  THIS MACRO IS EXPANDED IN GPHMAIN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  FL18,FL22,FL24,DSPDTM
      LOGICAL  LERROR
      LOGICAL*1  CCMD,CDICTY
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,
     +                  IPRJC,FL18,FL22,FL24,KPROJ
      COMMON / CZKON  / ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
      COMMON / CVX    / NNPATR,ICRSTR,NNJETC,NNVTXC
C
      COMMON / CZGEO  / RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,
     +                  ZCHSS,ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CGRAP3 / IDEFWP, CDICTY(700)
C
      COMMON / CGRAP4 / IPOS4,CCMD(8,200),HCMD(5,200)
      COMMON / CGRAP5 / KOMCAL,LERROR
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
      COMMON / CSTANV / HDISPN, HCSTV2, HCSTV3
C
C---------  MACRO CHSYM    SYMBOLS USED IN GRAPHICS WRITING -----
      COMMON /CHSYM/ HSYM(36)
C------ END MACRO CHSYM
C
C-----------------------------------------------------------------------
C                            MACRO CGRSCL .... GRAPHICS VIEW SCALES
C-----------------------------------------------------------------------
C
      COMMON  / CGRSCL / XMINST(30), XMAXST(30), YMINST(30)
C
C------- END OF MACRO CGRSCL -------------------------------------------
C
C
C------------------  D A T A  ------------------------------------------
C
      DATA HSYM /'0 ','1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 ','A ',
     + 'B ','C ','D ','E ','F ','G ','H ','I ','J ','K ','L ','M ','N ',
     + 'O ','P ','Q ','R ','S ','T ','U ','V ','W ','X ','Y ','Z '/
C
      DATA  FL18,FL22,FL24  / 3*.FALSE. /, KPROJ / 0 /
      DATA  DSPDTM / .TRUE. ,.TRUE. ,.FALSE.,.FALSE.,.FALSE.,
     +               .FALSE.,.FALSE.,.TRUE. ,.FALSE.,.FALSE.,
     +               .TRUE. ,.FALSE.,.TRUE. ,.FALSE.,.TRUE. ,
     +               .FALSE.,.FALSE.,.FALSE.,.TRUE. ,.TRUE. ,
     +               .TRUE. ,.FALSE.,.FALSE.,.FALSE.,.TRUE. ,
     +               .TRUE. ,.FALSE.,.FALSE.,.FALSE.,.FALSE. /
      DATA  ISTVW  / 0 /, JTVW   / 0 /
      DATA  NNPATR / 0 /, NNJETC / 0 /, NNVTXC / 9 /
C
      DATA  MACNR, MACSTA, MACDEP / 0, 169, 1 /
C
      DATA  RZCHI,RZCHA /864.5, 884.5/
      DATA  NZRPSI,NZZ /24,16/
      DATA  Z1ZCH,Z2ZCH /-1200.,1200./
      DATA  ZCHA,ZCHB,ZCHSS /5.,15.,1./
      DATA  ZCHDL,ZCHDLL /100.,20./, DLZZ,DLZPHI /150.,227.63/
      DATA  DLZW1,DLZW2 /228.94,231.58/
C
      DATA  ZCVDR/0.34/, ZCXCH/1.0/, ZCTZER/0.0/, ZCAPED/0.0/
      DATA  XL1,XL2 /2547.28, 2578.96/
      DATA  IDEFWP, IPOS4 / 0, 0 /
      DATA  KOMCAL / 0 /
C
      DATA  HDISPN/ 1 /, HCSTV2/ 1 /, HCSTV3/ -1 /
C
C                            VIEW RA
C
      DATA  XMAXST(1)  /  1400.0 /
      DATA  XMINST(1)  / -1400.0 /
      DATA  YMINST(1)  / -1100.0 /
C
C                            VIEW RB
C
      DATA  XMAXST(2)  /  1950.0 /
      DATA  XMINST(2)  / -2050.0 /
      DATA  YMINST(2)  / -1550.0 /
C
C                            VIEW RC
C
      DATA  XMAXST(3)  /  4900.0 /
      DATA  XMINST(3)  / -4900.0 /
      DATA  YMINST(3)  / -3350.0 /
C
C                            VIEW ZXA
C
      DATA  XMAXST(4)  /  1500.0 /
      DATA  XMINST(4)  / -1800.0 /
      DATA  YMINST(4)  / -1300.0 /
C
C                            VIEW ZXB
C
      DATA  XMAXST(5)  /  2000.0 /
      DATA  XMINST(5)  / -2400.0 /
      DATA  YMINST(5)  / -1700.0 /
C
C                            VIEW ZXC
C
      DATA  XMAXST(6)  /  4400.0 /
      DATA  XMINST(6)  / -5600.0 /
      DATA  YMINST(6)  / -3900.0 /
C
C                            VIEW ZXD
C
      DATA  XMAXST(7)  /  5500.0 /
      DATA  XMINST(7)  / -5500.0 /
      DATA  YMINST(7)  / -3900.0 /
C
C                            VIEW ZYA
C
      DATA  XMAXST(8)  /  1500.0 /
      DATA  XMINST(8)  / -1800.0 /
      DATA  YMINST(8)  / -1300.0 /
C
C                            VIEW ZYB
C
      DATA  XMAXST(9)  /  2000.0 /
      DATA  XMINST(9)  / -2400.0 /
      DATA  YMINST(9)  / -1700.0 /
C
C                            VIEW ZYC
C
      DATA  XMAXST(10) /  4400.0 /
      DATA  XMINST(10) / -5600.0 /
      DATA  YMINST(10) / -3900.0 /
C
C                            VIEW ZYD
C
      DATA  XMAXST(11) /  5500.0 /
      DATA  XMINST(11) / -5500.0 /
      DATA  YMINST(11) / -3900.0 /
C
C                            VIEW FW
C
      DATA  XMAXST(12) /  1200.0 /
      DATA  XMINST(12) / -1200.0 /
      DATA  YMINST(12) / - 800.0 /
C
C                            VIEW RU
C
      DATA  XMAXST(13) /  7890.0 /
      DATA  XMINST(13) / -1610.0 /
      DATA  YMINST(13) / -  25.0 /
C
C                            VIEW CYL
C
      DATA  XMAXST(14) /  1800.0 /
      DATA  XMINST(14) / -1800.0 /
      DATA  YMINST(14) / -1300.0 /
C
C                            VIEW FWMU
C
      DATA  XMAXST(15) /  7890.0 /
      DATA  XMINST(15) / -1610.0 /
      DATA  YMINST(15) / -  25.0 /
C
C                            VIEW Z-CHAMBER (ALIAS  RZ )
C
      DATA  XMAXST(16) /  5530.0 /
      DATA  XMINST(16) / -1250.0 /
      DATA  YMINST(16) /     0.0 /
C
C                            VIEW VRX  (RFI VERTEX REGION)
C
      DATA  XMAXST(17) /     7.0 /
      DATA  XMINST(17) /   - 8.5 /
      DATA  YMINST(17) /   - 6.0 /
C
C                            VIEW VRZX (ZX  VERTEX REGION)
C
      DATA  XMAXST(18) /     7.0 /
      DATA  XMINST(18) /   - 8.5 /
      DATA  YMINST(18) /   - 6.0 /
C
C                            VIEW VRZY (ZY  VERTEX REGION)
C
      DATA  XMAXST(19) /     7.0 /
      DATA  XMINST(19) /   - 8.5 /
      DATA  YMINST(19) /   - 6.0 /
C
C                            VIEW VC   (VERTEX CHAMBER)
C
      DATA  XMAXST(20) /   345.0 /
      DATA  XMINST(20) / - 345.0 /
      DATA  YMINST(20) / - 260.0 /
C
C                            SPARE VIEWS
C
      DATA  XMAXST(21) /   11.0 /
      DATA  XMINST(21) /    7.0 /
      DATA  YMINST(21) /    7.0 /
C
      DATA  XMAXST(22) /   11.0 /
      DATA  XMINST(22) /    7.0 /
      DATA  YMINST(22) /    7.0 /
C
      DATA  XMAXST(23) /   11.0 /
      DATA  XMINST(23) /    7.0 /
      DATA  YMINST(23) /    7.0 /
C
      DATA  XMAXST(24) /   11.0 /
      DATA  XMINST(24) /    7.0 /
      DATA  YMINST(24) /    7.0 /
C
      DATA  XMAXST(25) /   11.0 /
      DATA  XMINST(25) /    7.0 /
      DATA  YMINST(25) /    7.0 /
C
      DATA  XMAXST(26) /   11.0 /
      DATA  XMINST(26) /    7.0 /
      DATA  YMINST(26) /    7.0 /
C
      DATA  XMAXST(27) /   11.0 /
      DATA  XMINST(27) /    7.0 /
      DATA  YMINST(27) /    7.0 /
C
      DATA  XMAXST(28) /   11.0 /
      DATA  XMINST(28) /    7.0 /
      DATA  YMINST(28) /    7.0 /
C
      DATA  XMAXST(29) /   11.0 /
      DATA  XMINST(29) /    7.0 /
      DATA  YMINST(29) /    7.0 /
C
      DATA  XMAXST(30) /   11.0 /
      DATA  XMINST(30) /    7.0 /
      DATA  YMINST(30) /    7.0 /
C
      END

C   14/10/82            MEMBER NAME  UWP      (S)           FORTRAN77
      SUBROUTINE UWP(BIN,NA,NB)
C
      REAL*4 BIN(2)
      REAL*8 FMT(13),FMTF/'  F12.4,'/,FMTG/'  G12.4,'/,
     1     FMTI/'    I12,'/,FMTA/'  8X,A4,'/,FMT1/'        '/,
     2     FMT2/'(11X,   '/
      INTEGER NEQ/0/,LIM(2,8)
      LOGICAL*1 LFMT(96),LL(8),LAST/')'/
      DATA FMT(1)/'(1X,I5, '/,FMT(2)/''' -'',I3,'/
      DATA LIM/75,80,91,97,107,111,123,136,
     1     193,201,209,217,226,233,240,249/
      EQUIVALENCE(FMT(1),LFMT(1)),(LL(1),REQ),(LL(5),NEQ)
      REAL*8 FMZ(11)
      EQUIVALENCE (FMT(3),FMZ(1))
*** s.u
      INTEGER VS(2),TEXT(10)
C
C     PURPOSE
C        PRINT ARRAY WITH AUTOMATIC SELECTION OF INTEGER,
C        FLOATING POINT OR TEXT FORMAT FOR EACH WORD ACCORDING
C        TO CONTENT
C
C     USAGE       --- -- --
C        CALL UWP(BIN,NA,NB)
C
C        PRINTS ARRAY BIN(NA) . . . BIN(NB)
C
C                 -- -- ----
C        CALL UTP(VS,IT,TEXT)
C
C        PRINTS ARRAY VS(2) IN A-FORMAT AND FOR IT.GT.0 THE
C        ARRAY TEXT(1) . . . TEXT(IT) IN A-FORMAT   (IT.LE.10)
C
C        CALL UPP
C
C        NEW PAGE
C
      IUWU=0
    1 IF(NA.GT.NB) GOTO 100
      IZERO=0
      NF=((NA-1)/10)*10+1
      N=NB+1-NF
      DO 60 I=NF,NB,10
      IA=I
      IB=MIN0(I+9,NB)
      IF(IUWU.EQ.0) GOTO 8
      IF(IB.EQ.NB) GOTO 4
      DO 2 J=IA,IB
      IF(BIN(J).NE.0) GOTO 4
    2 CONTINUE
      IF(IZERO.EQ.0) IZERO=IA
      GOTO 60
    4 IF(IZERO.EQ.0) GOTO 8
      WRITE(6,103) IZERO
      IZERO=0
    8 M=3
      DO 50 J=IA,IB
      REQ=BIN(J)
      M=M+1
      LA=0
      DO 20 K=1,4
      LL(8)=LL(K)
      IF(NEQ.EQ.64) GOTO 20
      DO 10 L=1,8
      IF(NEQ.LT.LIM(1,L)) GOTO 40
      IF(NEQ.GT.LIM(2,L)) GOTO 10
      IF(L.LE.4) LA=LA+1
      GOTO 20
   10 CONTINUE
      GOTO 40
   20 CONTINUE
      IF(LA.GT.2) GOTO 40
      FMT(M)=FMTA
      GOTO 50
   40 IF(ABS(REQ).GT.1.E20.OR.ABS(REQ).LT.1.E-20) GOTO 30
      IF(ABS(REQ).LT.10000.0.AND.ABS(REQ).GE.0.1) GOTO 45
      FMT(M)=FMTG
      GOTO 50
   45 FMT(M)=FMTF
      GOTO 50
   30 FMT(M)=FMTI
   50 CONTINUE
      LFMT(8*M)=LAST
      IF(N.LE.10) GOTO 55
      FMT(3)=FMT1
      JB=MOD(IB,1000)
      WRITE(6,FMT) IA,JB,(BIN(II),II=IA,IB)
      GOTO 60
   55 FMT(3)=FMT2
      WRITE(6,FMZ) (BIN(II),II=IA,IB)
   60 CONTINUE
      GOTO 100
C     ENTRY WITH SPPRESSSION OF ZEROS IN SEVERAL LINES
      ENTRY UWU(BIN,NA,NB)
      IUWU=1
      GOTO 1
C
      ENTRY UTP(VS,IT,TEXT)
C
***   s.o. :
***      INTEGER VS(2),TEXT(10) 
      IF(IT.LE.0) GOTO 70
      WRITE(6,101) VS,(TEXT(I),I=1,IT)
      GOTO 100
   70 WRITE(6,101) VS
      GOTO 100
C
      ENTRY UPP
C
      WRITE(6,102)
  100 RETURN
  101 FORMAT('0  ',2A4,10(8X,A4))
  102 FORMAT('1')
  103 FORMAT(1X,I5,2X,'AND FOLLOWING ALL ZERO')
      END

C   09/10/79 912201715  MEMBER NAME  ANOM75   (S)           FORTRAN
      SUBROUTINE ANOM75(IRUN)
C---  ANOMALIES OF RUNS 1756 - 1762
C---  15.39 GEV      OCTOBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     19.12.79     14:30
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1756,1757,1758,1759,1760,1761,1762),IRUN
   13 RETURN
C
 1756 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(2) = -1
      LIMIT(2) = 255
      KCONST(4) = -1
      LIMIT(4) = 270
      KCONST(7) = -1
      LIMIT(7) = 120
      KCONST(8) = -1
      LIMIT(8) = 225
      KCONST(11) = -1
      LIMIT(11) = 195
      KCONST(23) = -1
      LIMIT(23) = 150
      KCONST(25) = -1
      LIMIT(25) = 255
      KCONST(26) = -1
      LIMIT(26) = 240
      KCONST(27) = -1
      LIMIT(27) = 210
      KCONST(29) = -1
      LIMIT(29) = 210
      KCONST(33) = -1
      LIMIT(33) = 195
      KCONST(35) = -1
      LIMIT(35) = 255
      KCONST(42) = -1
      LIMIT(42) = 225
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(15) = .TRUE.
      LTHRES(16) = .TRUE.
      LTHRES(17) = .TRUE.
      LTHRES(21) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(27) = .TRUE.
      LTHRES(38) = .TRUE.
      LTHRES(41) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(44) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(122) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(158) = .TRUE.
      LTHRES(160) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(178) = .TRUE.
C
      RETURN
C
 1757 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      RETURN
C
 1758 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(107) = +1
      LIMIT(107) = 360
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(173) = +1
      LIMIT(173) = 450
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 120
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(183) = .TRUE.
C
      RETURN
C
 1759 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(173) = +1
      LIMIT(173) = 450
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      RETURN
C
 1760 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
 1761 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 120
      KCONST(184) = -1
      LIMIT(184) = 120
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 150
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(51) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(154) = .TRUE.
C
      RETURN
C
C1762 PRELIMINARY
 1762 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(51) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(112) = .TRUE.
C
      RETURN
C
      END

C   11/03/79 C9073001   MEMBER NAME  LGCLUS   (SOURCE)      FORTRAN
      SUBROUTINE LGCLUS(JP,INIT,LNGJP,IER)
C
C     S.YAMADA      06-10-78  08:50    VERSION 2 OF LGCLUS
C     LAST MODIFICATION   16-07-79  17:30
C
C     LOCATE HIT CLUSTERS IN THE LEAD-GLASS COUNTERS
C     ADC-S BELONGING TO A CLUSTER ARE GROUPED TOGETHER AND THE MAP OF
C     THE STARTING MEMBER FOR EACH CLUSTER IS MADE.
C     (SOME MODIFICATIONS ARE MADE FOR SPEED UP)
C
      IMPLICIT INTEGER *2 (H)
C
C---- THERESHOLDS FOR THE CLUSTER FINDING ARE DEFINED IN THE BLOCK DATA.
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
C
#include "clgwork1.for"
C
      DIMENSION LGADC(2000)
      EQUIVALENCE (LGADC(1),HLGADC(1,1))
C
C---- NCLST = NO.OF THE LOCATED CLUSTERS.
C---- HMAPCL(1,J)=THE INDEX OF THE FIRST MEMBER OF THE J-TH CLUSTER
C               IN THE HLGADC.
C---- HMAPCL(2,J)=THE INDEX OF THE LAST MEMBER OF THE J-TH CLUSTER.
C
      COMMON /CLGMSB/ MESVAL
C
      DIMENSION LIST(5)
C     (LIST) STORES NEIGHBOUR POSITIONS.
C
C---- INPUT
C     JP      PART OF THE LG-COUNTER TO BE ANALYSED, 1 FOR BARREL
C                                                 2 FOR Z<0 END CAP
C                                                 3 FOR Z>0 END CAP
C     INIT    INITIAL DATA IN THE HLGADC FOR THE JP-TH PART
C     LNGJP     NO. OF ADC DATA FOR THE JP-TH PART
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/379071113/
      NVRSN(8) = NVCODE
C
      IER = 0
      IF(LNGJP) 80,80,2000
C
C---- ADC DATA SORTING ACCORDING TO THE PULSE HEIGHT
 2000 CALL LGSRTH(INIT-1,LNGJP)
      KEND = INIT+LNGJP-1
C
C---- INITIALIZATION
      NCLST = NCLST+1
      IF(NCLST.GT.MAXCLS) GO TO 90
      HMAPCL(1,NCLST) = INIT
      IPRNT = INIT
C
C---- SET THRESHOLDS
   30 IF(HLGADC(2,IPRNT).LT.ITH) GO TO 70
      IABTHD = HLGADC(2,IPRNT)/IRLTHD
      IABTH2 = HLGADC(2,IPRNT)/IRLTH2
C
C---- NEXT IS THE INDEX OF THE 1-ST NONREPLACED MEMBER.
      NEXT = IPRNT+1
   20 IF(NEXT.GT.KEND) GO TO 4
C---- OBTAIN THE NEIGHBOUR LIST FOR THE IPRNT-TH ADC.
      HJPPRN = HLGADC(1,IPRNT)
      CALL LGNBLS(HJPPRN,NNBR,LIST)
C
      LGAPRN = HLGADC(2,IPRNT)
      IABTH3 = LGAPRN*IRLTH3
C---- LOOK FOR DAUGHTERS
      NCAND = NEXT
   10   JPCND = HLGADC(1,NCAND)
C----   GLOBAL POSITION CHECK
        JDF = JPCND-HJPPRN
        IF(JDF.LT.0) JDF = -JDF
        IF(JDF.GT.80.AND.JDF.LT.2656) GO TO 1
C
C----   CAND IS CLOSE TO PRNT.SURVEY THE NEIGHBOUR TABLE.
          DO 2 NN=1,NNBR
          IF(JPCND.EQ.LIST(NN)) GO TO 40
    2     CONTINUE
        GO TO 1
C
C----   A NEIGHBOUR IS FOUND. CHECK PULSE HEIGHT.
   40   IF(LGAPRN.GE.IABTHD) GO TO 3
C----   TAIL OF THE CLUSTER
        IF(HLGADC(2,NCAND).GT.IABTH2) GO TO 1
        IF(HLGADC(2,NCAND).GT.IABTH3) GO TO 1
C
C----   THE FOUND NEIGHBOUR IS MOVED TO FOLLOW THE PARENT.
    3   IF(NEXT-NCAND) 6,5,5
    6   LWORK = LGADC(NCAND)
C       SHIFT THE DATA BETWEEN NEXT AND NCAND.
        NSHIFT = NCAND-NEXT
          DO 60 NN=1,NSHIFT
          LL = NCAND-NN
          LGADC(LL+1) = LGADC(LL)
   60     CONTINUE
        LGADC(NEXT) = LWORK
C       PROCEED TO THE NEXT PLACE.
    5   NEXT = NEXT+1
    1   NCAND = NCAND+1
      IF(NCAND.LE.KEND) GO TO 10
C
C---- A SURVEY IS OVER FOR A PARENT.
C---- IF A NEW NEIGHBOUR WAS FOUND,TREAT IT AS A PARENT.
      IPRNT = IPRNT+1
      IF(IPRNT.LT.NEXT) GO TO 20
C
C---- ALL NEIGHBOURS ARE ALREADY FOUND.
C     STORE THE LAST * STARTING INDEX OF THE BLOCK INTO HMAPCL
    4 HMAPCL(2,NCLST) = NEXT-1
      NCLST = NCLST+1
      HMAPCL(1,NCLST) = NEXT
      IF(NCLST.GT.MAXCLS) GO TO 90
C---- CHECK IF ANY MORE DATA IS LEFT
      IF(NEXT.LE.KEND) GO TO 30
C
C---- CLUSTER SEARCH IS FINISHED.
C
C---- SET THE LAST CLUSTER NO. FOR EACH PART INTO NCLBEC
   70 NCLST = NCLST-1
   80 NCLBEC(JP) = NCLST
      GO TO 100
C
C---- TOO MANY CLUSTER
   90 NCLST = NCLST-1
      NCLBEC(JP) = NCLST
      CALL LGMESG( 4, 1)
      IER = 10
  100 RETURN
      END

C   19/02/84 402192318  MEMBER NAME  RDMODN   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDMODN( IRN, EPS, IDOUBL )
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    26/04/79 :  SMEAR DRIFT DATA
C
C        MOD  E. ELSEN    29/05/79 :
C        MOD  C. BOWDERY  30/08/83 :  POINTERS FROM OLD TO NEW HITS
C   LAST MOD  C. BOWDERY   6/10/83 :  REMOVE CREATION OF 'JETC'/9 BANK
C   LAST MOD  J. OLSSON   18/01/84 :  CORRECT LOGICAL ERROR IN LOOP 2
C
C                  MODIFY  DRIFT  DATA  TO  ACCOUNT  FOR  RANDOM   HITS,
C                  INEFFICIENCIES AND DOUBLE PULSE RESOLUTION.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cmubcs.for"
C
      COMMON / CWORK  / HWORK(20000)
      COMMON / CWORK1 / JHITS, H4VJH(4000), H4VMRG(5000)
C
      DIMENSION IRN(3), IRAN(3), IDOUBL(3), EPS(3)
C
C
C------------------  C O D E  ------------------------------------------
C
      IPJ = IDATA( IBLN( 'JETC' ) )
      IPH = IDATA( IBLN( 'HITL' ) )
C
C                       IF NO 'JETC' BANK THEN RETURN.
C
      IF( IPJ .EQ. 0 ) RETURN
C                                     CHECK MAXIMUM LENGTH
           LENGTH = HDATA(IPJ*2)*2
           IF(LENGTH.LT.20000) GO TO 4
      WRITE(6,1001) LENGTH
1001  FORMAT(' TOO MANY HITS, LENGTH = ',I10,'  RDMODN PROGRAMMED STOP')
      STOP
C
 4    NHITS = ( HDATA(IPJ*2+99) - 1 ) / 4
C
      DO  1  I = 1,3
        IRAN(I) = IRN(I)
    1 CONTINUE
C
      SCL = -1.
    2 IRNTOT = IRAN(1) + IRAN(2) + IRAN(3)
C
C        SCALE DOWN NUMBER OF RANDOM HITS, IF TOO MANY. MAX IS 800.
C
      IF( IRNTOT .LT. 800 ) GO TO 3
           SC =  800./ FLOAT(IRNTOT)
           GO TO 5
    3 IF( LENGTH + IRNTOT*4 .LT.20000 ) GO TO 6
      SC = (20000. - FLOAT(LENGTH) ) / FLOAT(IRNTOT*4)
    5 DO 7 I=1,3
    7 IRAN(I) = IFIX(FLOAT(IRAN(I)) * SC)
C
      IF(SCL.EQ.SC) GO TO 6
      SCL = SC
      GO TO 2
C
C                       GENERATE RANDOM HITS IN END SECTION OF HWORK
C
    6 CALL RDRDMH( IRAN, HWORK(NHITS*4+1) )
C
C                       MERGE ALL HITS IN HWORK
C                       'JETC' HAS  100 HEADER WORDS.
C
      CALL RDMERG( NHITS, HDATA(IPJ*2+101), IRNTOT, HWORK )
      NHNEW = NHITS + IRNTOT
C
C                       INEFFICIENCIES
C
      CALL RDINEF( EPS, NHNEW, HWORK, INEFLO )
      NHD = NHNEW - INEFLO
C
C                       DOUBLE PULSE RESOLUTION
C
      IDOULO = 0
      IF( NHD .GT. 1 ) CALL RDDOUB( IDOUBL, NHNEW, HWORK, IDOULO )
      NHD = NHD - IDOULO
C
CCC  DEAD CELLS
      IDEAD = 0
      IF( NHD .GT. 0 ) CALL RDDDCL( NHNEW, HWORK, IDEAD )
      NHD = NHD - IDEAD

C
C                  ADJUST LENGTH OF BANK, CONSTRUCT  CELL  POINTERS  AND
C                  ERASE ZERO WIRE NUMBERS
C
      IF( NHD .LE. 0 ) GO TO 1000
      LD = ( NHD - NHITS ) * 2
      IF( LD .NE. 0 ) CALL  BCHM( IPJ, LD, IER )
      CALL RDPOIN( HDATA(IPJ*2+3), NHNEW, HWORK )
C
C                  IF THERE WAS A 'HITL' BANK, CREATE A 'HTSL' BANK
C                  TO STORE THE ASSOCIATION BETWEEN THE ORIGINAL HITS
C                  AND THE SMEARED ONES.
C
      IF(IPH .LE. 0 ) RETURN
      LENGTH = ( JHITS + 2 ) / 2
      CALL BCRE( IND, 'HTSL', 8, LENGTH, &1500, IER )
      CALL BSAW( 1, 'HTSL' )
      HDATA(IND*2 + 1) = JHITS
      CALL MVCL( HDATA, 4*IND + 2, H4VJH, 0, JHITS * 2 )
      RETURN
C
C                  DELETE BANK AND HEAD POINTER BECAUSE ALL POINTS  WERE
C                  ERASED
C
 1000 CALL BDLS( 'JETC', IDATA(IPJ-2) )
      CALL BDLS( 'PATR', 12 )
      RETURN
C
 1500 WRITE(6,1501) IER
 1501 FORMAT(' BCRE ENDED WITH ERROR ',I3,' IN RDMODN. ')
      RETURN
      END

C-------------------------------
C  MACRO CHEADR .... HEADER BANK
C-------------------------------
      COMMON /CHEADR/ IHEADR(54)
      INTEGER*2 HHEADR(108)
      EQUIVALENCE (IHEADR(1),HHEADR(1))
C --
C --  HHEADR(17) = EXPERIMENT NUMBER
C --  HHEADR(18) = RUN NUMBER
C --  HHEADR(19) = EVENT NUMBER
C --  HHEADR(38) = MAGNETIC FIELD (GAUSS)
C --
C--------- END OF MACRO CHEADR ------------

C   07/06/96 606071852  MEMBER NAME  INDDIR   (S4)          FORTRAN
      FUNCTION INDDIR(NAME,NR,IUNIT,IOPT)
C
C     VERSION JULY 82
C
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      REAL*8 DATE(2)
      INTEGER IPR/0/,IOPTL(4)/2HFE,2HDL,2HST,2HFU/,NAMUN/4H+U00/
C
C     DIRECT ACCESS FUNCTION
C
      INDDIR=0
      IUND=IUNIT
      DO 10 IOP=1,4
      IF(IOPT.EQ.IOPTL(IOP)) GOTO 12
   10 CONTINUE
      GOTO 100
   12 LISTE(1)=NAME
      LISTE(2)=NR
      IF(IOP.EQ.4) GOTO 20
      IF(IOP-2) 20,30,40
C
C     FETCH FROM DIRECT ACCESS DATA SET
C
   20 INDC=ILINK(LISTE(1),LISTE(2))
      IF(INDC.NE.0) GOTO 90
      CALL DIDA(1,LISTE,1)
      IF(INDT.EQ.0) GOTO 100
      IF(IOP.NE.4) GOTO 26
   22 IND=IBLN(LISTE(1))
      IND=IW(IND)
      IF(IND.EQ.0) GOTO 26
      IF(IW(IND-1).EQ.0) GOTO 24
      IND=IBANK(LISTE(1),IW(IND-2),'DL')
      GOTO 22
   24 IND=ILINK(LISTE(1),IW(IND-2))
      IF(IW(IND).NE.LISTE(4)) GOTO 25
      INDC=IBANK(LISTE(1),LISTE(2),'RN')
      GOTO 28
   25 IND=IBANK(LISTE(1),IW(IND-2),'DL')
   26 INDC=IBANK(LISTE(1),LISTE(2),LISTE(4))
   28 IF(INDC.EQ.0) GOTO 100
      CALL DAFR(1)
C     IF BANK NOT FOUND DELETE DIRECTORY ENTRY
      IF(INDC.EQ.0) GOTO 30
      GOTO 90
C
C     DELETE BANK ON DIRECT ACCESS DATA SET
C
   30 JD=-1
C
C     MAKE SURE DIRECTORY BANK IS THERE AND CHECK PASSWORD
C
      CALL DIDA(0,LISTE,1)
      IF(IW(INDA+20).NE.0) GOTO 100
C
C     RESERVE DATA SET EXCLUSIVELY
C
      CALL DIDA(-1,LISTE,1)
C
C     CHECK, THAT BANK TO BE DELETED IS THERE
C
      CALL DIDA(1,LISTE,1)
      IF(INDT.NE.0) GOTO 35
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      GOTO 100
   35 NPTR=IW(INDT+3)
C
C     DELETE BANK ON DATA SET AND IN DIRECTORY
C
      CALL DAFR(2)
      CALL DIDA(2,LISTE,1)
C
C     UPDATE BANK COUNTER AND PRINT
C
      IW(INDA+51)=IW(INDA+51)+1
      IF(NUNTB.EQ.0) GOTO 70
      IF(IW(INDA+51).LE.100) WRITE(NUNTB,104) IUND,LISTE(1),LISTE(2)
      IF(IW(INDA+51).EQ.100) WRITE(NUNTB,109) IUND
      GOTO 70
C
C     STORE BANK ON DIRECT ACCESS DATA SET
C
   40 JD=1
      INDC=ILINK(LISTE(1),LISTE(2))
      IF(INDC.EQ.0) GOTO 85
      IF(IW(INDC).LE.0) GOTO 85
      IF(IW(INDC).GT.3200) GOTO 85
C
C     MAKE SURE DIRECTORY BANK IS THERE AND CHECK PASSWORD
C
      CALL DIDA(0,LISTE,1)
      IF(IW(INDA+20).NE.0) GOTO 100
C
C     RESERVE DATA SET EXCLUSIVELY
C
      CALL DIDA(-1,LISTE,1)
C
C     SEARCH DIRECTORY FOR BANK
C
      CALL DIDA(1,LISTE,1)
C
C     CHECK TOTAL SPACE ON DATA SET
C
      IF(IW(INDA+7)+2+IW(INDC)/NDAREC.GT.IW(INDA+6)) GOTO 201
      ICO=1
      IF(INDT.EQ.0) GOTO 50
C
C     BANK IS ALREADY ON DATA SET
C
      IW(INDA+34)=IW(INDA+34)-1
      ICO=2
      IF(IW(INDC).EQ.LISTE(4)) GOTO 52
C
C     DELETE BANK ON DATA SET AND IN DIRECTORY
C
      CALL DAFR(2)
      CALL DIDA(2,LISTE,1)
C
C     ADD BANK TO DATA SET AND DIRECTORY
C
   50 CALL DAFR(3)
      CALL DIDA(3,LISTE,1)
      GOTO 54
C
C     INSERT BANK IN SAME PLACE ON DATA SET
C
   52 CALL DAFR(4)
C
C     UPDATE COUNTER AND PRINT
C
   54 IW(INDA+51)=IW(INDA+51)+1
      IF(IW(INDA+51).GT.100) GOTO 70
      GOTO (60,62),ICO
   60 IF(NUNTB.NE.0) WRITE(NUNTB,102) IUND,LISTE(1),LISTE(2)
      GOTO 64
   62 IF(NUNTB.NE.0) WRITE(NUNTB,103) IUND,LISTE(1),LISTE(2)
   64 IF(IW(INDA+51).EQ.100.AND.NUNTB.NE.0) WRITE(NUNTB,109) IUND
C
C     UPDATE FIRST DIRECTORY RECORD AND FREE DATA SET
C
   70 CALL DAY(DATE(1),DATE(2))
      CALL UCOPY(DATE,IW(INDA+25),4)
      IW(INDA+34)=IW(INDA+34)+JD
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
C
C     TWO ADDITIONAL WRITES TO FORCE BUFFER TO BE WRITTEN
C
      CALL WRDA(IW(INDA+6)-1,IW(INDA+1),IW(INDA+2))
      CALL WRDA(IW(INDA+6)  ,IW(INDA+1),IW(INDA+2))
C
C     UPDATE NRDIR BANK
C
      NAMUNT=NAMUN+(IUND/10)*256+MOD(IUND,10)
      IND=ILINK(NAMUNT,LISTE(1))
      IF(IND.EQ.0) GOTO 100
      NW=IW(IND+3)
      IF(NW.GT.3) GOTO 72
      IF(IOP.EQ.2) GOTO 100
      IW(IND+3)=4
      IW(IND+4)=LISTE(2)
      GOTO 100
   72 IF(LISTE(2).LT.IW(IND+4)) GOTO 74
      IF(IOP.EQ.2) GOTO 100
      IW(IND+1)=4
      GOTO 100
   74 DO 76 I=1,NW
      IF(IW(IND+I)-LISTE(2)) 76,78,79
   76 CONTINUE
      IF(IOP.EQ.2) GOTO 100
      IW(IND+2)=NW
      GOTO 100
   78 IF(IOP.EQ.3) GOTO 100
      IF(NW-I.GT.0) CALL UCOPY2(IW(IND+I+1),IW(IND+I),NW-I)
      IW(IND+3)=NW-1
      GOTO 100
   79 IF(IOP.EQ.2) GOTO 100
      IF(NW-I.GT.0) CALL UCOPY2(IW(IND+I),IW(IND+I+1),NW-I)
      IW(IND+I)=LISTE(2)
      IW(IND+2)=NW
      GOTO 100
C
C     PRINT OUT
C
   85 IPR=IPR+1
      IF(IPR.GT.100) GOTO 100
      IF(NUNTB.EQ.0) GOTO 100
      IF(JD.EQ.1) WRITE(NUNTB,107) IW(INDC-3),IW(INDC-2),IW(INDC)
      IF(JD.NE.1) WRITE(NUNTB,108) NAME,NR
      GOTO 100
C
C
   90 INDDIR=INDC
  100 RETURN
C
C     DATA SET SPACE LIMIT REACHED
C
  201 CALL BDMPA(201)
      GOTO 100
  102 FORMAT(' ---- UNIT',I3,' / INDDIR',5X,'BANK (',A4,',',I10,')',1X,
     1   'STORED')
  103 FORMAT(' ---- UNIT',I3,' / INDDIR',5X,'BANK (',A4,',',I10,')',1X,
     1   'REPLACED')
  104 FORMAT(' ---- UNIT',I3,' / INDDIR',5X,'BANK (',A4,',',I10,')',1X,
     1   'DELETED')
  107 FORMAT('0---- INDDIR     UNABLE TO STORE BANK (',A4,',',I10,
     1   ')',I10,' WORDS')
  108 FORMAT('0---- INDDIR     UNABLE TO DELETE BANK (',A4,',',I10,')')
  109 FORMAT(' ---- UNIT',I3,' / INDDIR PRINTOUT SUPPRESSED')
      END

C   01/11/84 807241307  MEMBER NAME  CAPMRK   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE CAPMRK(INDEX,IESUM)
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON        ?     :  DRAW BEAM CROSS AND EVENT INFO
C
C        MOD: J. OLSSON    20/12/83  :
C        MOD: C. BOWDERY   26/04/83  :  SMALLER ARROW INSIDE BEAM PIPE
C        MOD: J. HAGEMANN  19/10/84  :  FOR SPECIAL VERTEX CHAMBER VIEW
C        MOD: J. OLSSON    15/04/85  :  FOR TRIG1 WITH BANKDESCR.4
C        MOD: C. BOWDERY   17/04/85  :  VERTEX CHAMBER CAPTION ADDED
C        MOD: J. OLSSON    26/04/85  :  T2 COINC. PRINT FOR 1985 DATA..
C        MOD: C. BOWDERY   20/12/85  :  OPTION TO SUPPRESS CAPTION, ETC
C   LAST MOD: J. HAGEMANN  18/02/86  :  FOR VERTEX CHAMBER RUN VERTEX
C
C     INDEX GIVES THE VIEW NUMBER, FOR POSITIVE INDEX
C     NEGATIVE INDEX ARE FOR SPECIAL VIEWS
C       INDEX = -1, LSTCMD = 119   DEDX
C       INDEX = -2, LSTCMD = 121   TOF
C       INDEX = -3, LSTCMD = 124   FADC
C       INDEX = -4, LSTCMD = 125   ZTRG
C
C     IESUM IS A DUMMY, HISTORICAL ARGUMENT
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8      DATE,TIME
      LOGICAL     FL18,FL22,FL24
      LOGICAL     DSPDTM
      LOGICAL*1   TRGW1(2)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C---------  MACRO CHSYM    SYMBOLS USED IN GRAPHICS WRITING -----
      COMMON /CHSYM/ HSYM(36)
C------ END MACRO CHSYM
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  IMW(200)
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
      DIMENSION HTEXT(6,6),HBUF(6),JSUM(6),HDATSV(22),HTX(136)
      DIMENSION HTM1(4),HTM2(4),HMW(400),HTX1(32),HTX2(42),HTX3(62)
C
      EQUIVALENCE (HBUF(1),HMW(69)),(HRGW,TRGW1(1)),(HMW(1),IMW(1))
      EQUIVALENCE (HDATSV(1),IDATSV(1)),(DATE,HTM1(1)),(TIME,HTM2(1))
      EQUIVALENCE (HTX(1),HTX1(1)),(HTX(33),HTX2(1)),(HTX(75),HTX3(1))
C
      DATA HBLANK/'  '/,HMINUS/'- '/, MASK2/Z20000/, MASK4/Z40000/
      DATA HTX1/'DS','N ','DA','TE','TI','ME','JA','DE','  ','DE','TE',
     $'CT','OR','R-','FI',' S','EC','TI','ON','Z-','X ',' S','EC','TI',
     $'ON','Z-','Y ',' S','EC','TI','ON','FO'/
      DATA HTX2/'RW','AR','D ','DE','TE',
     $'CT','OR','SH','OW','ER',' C','OU','NT','ER','S ','R-','FI',' P',
     $'ER','SP','EC','TI','VE','MO','NT','E ','CA','RL','O ',
     $'PR','OJ','EC','T ','MO','DE','RO','TA','TE',' M','OD','E ','  '/
      DATA HTX3/'FW','-M','UO','N ','CO','UN','TE','RS','DE','DX','TO',
     $ 'F ','FL','AS','H ',' A','DC',' Z','-C','HA','MB','ER','  ','RZ',
     $ '-T','RI','GG','ER','VE','RT','EX',' R','EG','IO','N ','RF','I ',
     $ 'VE','RT','EX',' R','EG','IO','N ','ZX','VE','RT','EX',' R','EG',
     $ 'IO','N ','ZY','VE','RT','EX',' C','HA','MB','ER',' R','FI'/
      DATA HTEXT /'I ','D ','H ','I ','T ','S ','E ','L ','G ','T ','O '
     $,'T ','M ','U ','H ','I ','T ','S ','L ','G ','C ','Y ','L ','  ',
     $ 'L ','G ','C ','A ','P ','S ','F ','W ','C ','A ','P ','S '/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHMW*800
      EQUIVALENCE (cHMW,HMW(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
C                            FOR THE STANDARD VIEWS, DRAW BEAM
C                            CROSS IN INTERACTION POINT
C
      call setcol('TEXT') ! PMF 24/11/99: set colour
      IF( INDEX .LE. 0 ) GO TO 30
C
C                            VIEWS RU,FW, RZ, FWMU HAVE NO BEAM CROSS
C
      IF( INDEX .EQ. 12  .OR.  INDEX .EQ. 13 ) GO TO 20
      IF( INDEX .EQ. 15  .OR.  INDEX .EQ. 16 ) GO TO 20
C
C                            SET DIMENSION OF BEAM CROSS
C
      AW = 10.
      BW = 43.
      CW = 20.
C
      IF( INDEX .LT. 17  .OR.  INDEX .GT. 19 ) GO TO 10
C
        AW = 0.1
        BW = 0.2
        CW = 0.12
C
  10  DW = BW + CW
C
C                            DRAW ARROW TO MARK BEAM AND AXIS DIRECTION
C                            UNLESS OPTION 47 IS ON
C
      IF( DSPDTM(17) ) GO TO 15
      SIGN = 1.0
      IF( INDEX .LE. 3  .OR.  INDEX .EQ. 14  .OR.  INDEX .EQ. 17  .OR.
     +    INDEX .EQ. 20 )  SIGN = -1.0
C
      CALL MOVEA(-SIGN*CW, 0.0)
      CALL DRAWA( SIGN*BW, 0.0)
      CALL DRAWA( SIGN*BW, AW )
      CALL DRAWA( SIGN*DW, 0.0)
      CALL DRAWA( SIGN*BW, -AW)
      CALL DRAWA( SIGN*BW, 0.0)
C
      CALL MOVEA(0.0, -CW)
      CALL DRAWA(0.0,  CW)
  15  IF( INDEX .GE. 17  .AND.  INDEX .LE. 19 ) CALL VRXCIR
C
C                                 BEAM SPOT FOR REAL DATA
      IF( HEAD(18) .LE. 100 )  GO TO 20
      IF( INDEX .NE. 17  .AND.  INDEX .NE. 20 ) GO TO 20
         CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) ! PMF 08/11/99: add run argument HEAD(18)
         CALL ELLIPS( 1, INDEX, 0, XRV, YRV, SQRT(DXR), SQRT(DYR), 0.0 )
C
C                            LSTCMD=52: VRES,  FL18  PROJECTIONS
C                            THESE NEED NO FURTHER PROCESSING HERE
C
  20  IF( LSTCMD .EQ. 52  .OR.  FL18 ) goto 999! RETURN
C
C                            DRAW COORDINATE AXES
C
      call setcol('JADE')
      CALL CROAX(INDEX)
      call setcol('TEXT')
C
C                            IF PUBLICATIONS OPTION SET, RETURN
C
  30  IF( DSPDTM(16) ) goto 999!RETURN
C
C                            WRITE OUT EVENT CAPTION.
C
      XXX = XMIN + 0.01*(XMAX - XMIN)
      YYY = YMIN + 0.76*(YMAX - YMIN)
      CALL CHRSIZ(4)
      CALL CSIZE(IHOR,IVER)
      SSS = IVER*(YMAX - YMIN)*1.0/6240.0*.75 ! PMF20/11/99: add factor .75
C
C                            WRITE DSN ON PICTURE
C
      HMW(1) = HTX(1)
      HMW(2) = HTX(2)
C
      DO  40  I = 1,22
        HMW(I+2) = HDATSV(I)
  40  CONTINUE
C
      CALL MOVEA(XXX,YYY)
      CALL EOUTST(48,HMW)
C
C                            WRITE RUN,EVENT,RECORD ON PICTURE
C
      KCNT = 0
      DO  60  III = 1,3
        IF( III    .EQ. 1 ) NUMCAP    = HEAD(18)
        IF( III    .EQ. 2 ) NUMCAP    = HEAD(19)
        IF( III    .EQ. 3 ) NUMCAP    = ICREC
        IF( NUMCAP .LT. 0 ) KCNT      = KCNT + 1
        IF( NUMCAP .LT. 0 ) HMW(KCNT) = HMINUS
        NUMCAP = IABS(NUMCAP)
        NDIG   = 1
        ACAP   = NUMCAP
        IF( NUMCAP .GT. 0 ) NDIG = 1 + ALOG10( ACAP + 0.001 )
        IF( NDIG   .GT. 8 ) NDIG = 8
C
        DO  50  JJJ = 1,NDIG
          KKK      = KCNT + NDIG - JJJ + 1
          NTEN     = NUMCAP/10
          IDIG     = NUMCAP - 10*NTEN
          HMW(KKK) = HSYM(IDIG + 1)
          NUMCAP   = NTEN
  50    CONTINUE
C
        KCNT = KCNT + NDIG
        IF( III .LT. 3 ) KCNT      = KCNT + 1
        IF( III .LT. 3 ) HMW(KCNT) = HBLANK
  60  CONTINUE
C
      YYY = YYY - 3.5*SSS
      CALL HEMSYM(XXX,YYY,SSS,HMW,KCNT,0.)
      XX1 = XMIN + 0.12*(XMAX - XMIN)
      IF( HEAD(18) .GT. 100 ) GO TO 80
C
C                            WRITE   JADE   ON PICTURE
C                            IF RUN < 100, WRITE MONTE CARLO ON PICTURE
C
      DO  70  I = 1,6
        HMW(I) = HTX(55+I)
  70  CONTINUE
C
      CALL MOVEA(XX1,YYY)
      CALL EOUTST(12,HMW)
C
  80  YYY = YYY - 4.0*SSS
      CALL MOVEA(XX1,YYY)
C
      DO  90  I = 1,2
        HMW(I) = HTX(6+I)
  90  CONTINUE
C
      CALL CHRSIZ(3)
      CALL EOUTST(4,HMW)
      CALL CHRSIZ(4)
      YYY = YYY + 4.0*SSS
C
C                            COMPUTE LEADGLASS ENERGY SUMS,NUMBER OF
C                            HITS IN ID AND MUON FILTER
C
      DO  100 IJK = 1,6
        JSUM(IJK) = 0
 100  CONTINUE
C
      CALL ERGTOT(ECYL,ECAMI,ECAPL)
      JSUM(4) = ECYL
      JSUM(5) = ECAMI
      JSUM(6) = ECAPL
C
      IPJ = IDATA(IBLN('JETC'))
      IF( IPJ .GT. 0 ) IPJ     = (IPJ + 1)*2
      IF( IPJ .NE. 2 ) JSUM(1) = (HDATA(IPJ+97)-HDATA(IPJ+1))/4
      JSUM(2) = ECYL + ECAMI + ECAPL
      CALL MUHITS(NMU)
      JSUM(3) = NMU
C
C                            WRITE EVENT INFORMATION INTO CAPTION
C
      DO  130  IJK = 1,5
        YYY = YYY - 1.5*SSS
C
        DO  110  JJK = 1,6
          HMW(JJK) = HTEXT(JJK,IJK)
 110    CONTINUE
C
        HMW(7) = HBLANK
        JOLLA  = JSUM(IJK)
        CALL NUMCOD(JOLLA,HBUF,KKK)
C
        DO  120  JJK = 1,6
          HMW(JJK+7) = HBUF(JJK)
 120    CONTINUE
C
        IF( IJK .NE. 5 ) CALL HEMSYM(XXX,YYY,SSS,HMW,13,0.)
 130  CONTINUE
C
      HMW(14) = HBLANK
      JOLLA   = JSUM(6)
      CALL NUMCOD(JOLLA,HBUF,KKK)
C
      DO  140  JJK = 1,6
        HMW(JJK+14) = HBUF(JJK)
 140  CONTINUE
C
      CALL HEMSYM(XXX,YYY,SSS,HMW,20,0.)
      CALL TAGCHK(IPHTGM,IPHTGP)
      YYY = YYY - 1.5*SSS
      DO  150  JJK = 1,6
        HMW(JJK) = HTEXT(JJK,6)
 150  CONTINUE
C
      HMW(7) = HBLANK
      JOLLA  = IPHTGM
      CALL NUMCOD(JOLLA,HBUF,KKK)
C
      DO  160  JJK = 1,6
        HMW(JJK + 7) = HBUF(JJK)
 160  CONTINUE
C
      HMW(14) = HBLANK
      JOLLA   = IPHTGP
      CALL NUMCOD(JOLLA,HBUF,KKK)
C
      DO  170  JJK = 1,6
        HMW(JJK + 14) = HBUF(JJK)
 170  CONTINUE
C
      CALL HEMSYM(XXX,YYY,SSS,HMW,20,0.)
C
C                            WRITE CAPTION "VIEW INFORMATION"
C
      IF( INDEX .GT.  0 ) GO TO 190
C
C                            SPECIAL VIEWS HERE
C
      IF( INDEX .LT. -2 ) GO TO 180
      LODO = 2
      IADR = 82
      IF( INDEX .EQ. -2 ) IADR = 84
      GO TO 220
 180  IF( INDEX .LT. -4 ) GO TO 190
      LODO = 5
      IADR = 86
      IF( INDEX .EQ. -4 ) IADR = 97
      GO TO 220
C
C                            STANDARD VIEWS HERE
C
 190  YYY=YMIN + 0.75*(YMAX-YMIN) - 2.*SSS
C
      LODO = 9
      IADR = 127
      IF( INDEX .EQ. 20 ) GO TO 220
C
      LODO = 6
      JNDX = 1
      IF(INDEX.GT. 3) JNDX = 2
      IF(INDEX.GT. 7) JNDX = 3
      IADR = 7+JNDX*6
      IF( INDEX .LT. 12 ) GO TO 220
      LODO = 8
      JNDX = INDEX - 11
      IADR = 23 + JNDX*8
      IF( INDEX .LT. 15 ) GO TO 220
      IF(INDEX.GT.15) GO TO 200
      LODO = 8
      IADR = 74
      GO TO 220
 200  IF(INDEX.GT.16) GO TO 210
      LODO = 6
      IADR = 91
      GO TO 220
 210  IF( INDEX .LT. 17  .OR.  INDEX .GT. 19 ) GO TO 220
      LODO = 9
      IF(INDEX.NE.17) LODO = 8
      IADR = 102
      IF(INDEX.EQ.18) IADR = 111
      IF(INDEX.EQ.19) IADR = 119
C
 220  XXX = XMAX - .77*(XMAX-XMIN)
      CALL MOVEA(XXX,YYY)
C
      DO  250  I = 1,LODO
        HMW(I) = HTX(IADR + I)
 250  CONTINUE
C
      LODO = 2*LODO
      CALL EOUTST(LODO,HMW)
      IF( INDEX .LE. 0 ) GO TO 295
C
C                            WRITE INFORMATION FOR ZX OR ZY VIEW,
C                            ROTATED OR PROJECTED MODE
C
      IF( INDEX .GT.  3  .AND.  INDEX .LT. 12 ) GO TO 280
      IF( INDEX .EQ. 18  .OR.   INDEX .EQ. 19 ) GO TO 280
      GO TO 295
 280  YYY  = YMIN + 0.735*(YMAX - YMIN) - 2.0*SSS
      JNDX = 1
      IF( DSPDTL(9) ) JNDX = 2
      LODO = 6
      IADR = 55 + JNDX*LODO
      CALL MOVEA(XXX,YYY)
C
      DO  290  I = 1,LODO
        HMW(I) = HTX(IADR + I)
 290  CONTINUE
C
      LODO = 2*LODO
      CALL EOUTST(LODO,HMW)
C
C                            WRITE BEAM ENERGY AND MAGNETIC FIELD
C
 295  XXX  = XMAX - 0.57*(XMAX - XMIN)
      YYY  = YMIN + 0.75*(YMAX - YMIN)
      CALL MOVEA(XXX,YYY)
      EBEAM = HEAD(37)*0.001
      BFLD  = HEAD(38)*0.001
      CALL CORE(HMW,44)
      WRITE(cHMW,300) EBEAM,BFLD,HEAD(30)  ! PMF 17/11/99: JUSCRN changed to cHMW
 300  FORMAT(' BEAM',F7.3,' GEV  FIELD ',F6.3,' KG  TALC ',Z4)
      CALL EOUTST(44,HMW)
C
C                            WRITE TRIGGER INFORMATION, FROM BANK TRIG 1
C
      ITRG = IDATA(IBLN('TRIG'))
      IF( ITRG .GT. 0 ) GO TO 350
      CALL TRMOUT(80,'TRIGGER BANK NOT PRESENT^')
      GO TO 400
 350  IF( IDATA(ITRG - 2) .EQ. 1 ) GO TO 370
      CALL TRMOUT(80,'FIRST TRIGGER BANK NUMBER NE.1^')
      GO TO 400
 370  IBWSC  = LAND(IDATA(ITRG+1),MASK2)
      IBWSC4 = LAND(IDATA(ITRG+1),MASK4)
      ITRG2  = 2*ITRG
      ITRGL  = IDATA(ITRG)*2
      HRGW   = HDATA(ITRG2+ITRGL)
      HRGWA  = HDATA(ITRG2+ITRGL-2)
      HRGWP  = HDATA(ITRG2+ITRGL-1)
      HRGWA1 = HDATA(ITRG2+ITRGL-4)
      HRGWP1 = HDATA(ITRG2+ITRGL-3)
      HRGWT2 = HDATA(ITRG2+ITRGL)
      XXX = XMAX - 0.53*(XMAX - XMIN)
      YYY = YYY  - 2.0*SSS
      CALL MOVEA(XXX,YYY)
      CALL CORE(HMW,39)
      IF( IBWSC  .EQ. 0  .AND.  IBWSC4 .EQ. 0 )
     +     WRITE(cHMW,372) HRGW ! PMF 17/11/99: JUSCRN changed to cHMW
      IF( IBWSC  .NE. 0  .AND.  IBWSC4 .EQ. 0 )
     +     WRITE(cHMW,374) HRGWA,HRGWP ! PMF 17/11/99: JUSCRN changed to cHMW
      IF( IBWSC4 .NE. 0 )  WRITE(cHMW,376) HRGWA1,HRGWP1,HRGWT2 ! PMF 17/11/99: JUSCRN changed to cHMW
 372  FORMAT(16X,'TRIG ',Z4,14X)
 374  FORMAT(16X,' T1A ',Z4,'  T1P ',Z4,4X)
 376  FORMAT(12X,' T1A ',Z4,' T1P ',Z4,' T2C ',Z4)
      CALL EOUTST(39,HMW)
      YYY = YYY + 2.0*SSS
C
C                            WRITE DATE AND TIME
C
 400  XXX = XMAX - 0.23*(XMAX - XMIN)
      CALL DAY(DATE,TIME)
      HMW(1) = HTX(3)
      HMW(2) = HTX(4)
      HMW(3) = HBLANK
C
      DO  450  I = 1,4
        HMW(I+3) = HTM1(I)
 450  CONTINUE
C
      CALL MOVEA(XXX,YYY)
      CALL EOUTST(14,HMW)
      HMW(1) = HTX(5)
      HMW(2) = HTX(6)
      HMW(3) = HBLANK
C
      DO  480  I = 1,4
        HMW(I+3) = HTM2(I)
 480  CONTINUE
C
      XXX = XMAX - 0.115*(XMAX-XMIN)
      CALL MOVEA(XXX,YYY)
      CALL EOUTST(14,HMW)
C
C                            WRITE CAMAC TIME
C
      XXX = XMAX - 0.23*(XMAX-XMIN)
      YYY = YYY  - 2.0*SSS
      CALL MOVEA(XXX,YYY)
      CALL CORE(HMW,32)
      WRITE(cHMW,500) (HEAD(I),I=11,16) ! PMF 17/11/99: JUSCRN changed to cHMW
 500  FORMAT('CAMAC TIME ',I2,'.',I2,'.',I2,2X,I2,'/',I2,'/',I4)
      CALL EOUTST(32,HMW)
 999  continue
      call setcol(' ') ! PMF 24/11/99: reset colour
      RETURN
      END

C   19/02/84 705251746  MEMBER NAME  RDALGN   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDALGN
C-----------------------------------------------------------------------
C
C  AUTHOR:   J. OLSSON    1/11/81 : REMAKE ALGN BANK FOR MC AFTER CUTS
C
C       MOD: J. OLSSON    4/02/84 : IMPROVED VERSION
C       MOD: C. BOWDERY  13/02/84 : PREVENT GRAPHICS MESSAGE PRINTING
C       MOD: C. BOWDERY  19/02/84 : S/R MOVED TO SEPARATE MEMBER
C       MOD: J. OLSSON   28/07/86 : UPDATE FOR 1983-1986
C       MOD: J. OLSSON   18/08/86 : REMOVE THE RECALCULATION OF ENERGY
C                                   BASED ON REAL CALIBRATION
C  LAST MOD: J. OLSSON   25/05/87 : UPDATE READOUT THRESHOLD FOR 1986
C
C       REMAKE THE BANK ALGN FOR MC EVENTS, KILLING ALL  BLOCKS  BELOW
C       THE READOUT THRESHOLD. THIS IS TO IMITATE REAL DATA READ  OUT.
C       BLOCKS WITH >= 5 COUNTS ARE READ OUT, THE REST ARE  KILLED  TO
C       ALLOW FOR PEDESTAL VARIATION. 5 COUNTS IS ABOUT  25 MEV.  THIS
C       WAS NOT FORESEEN IN MC TRACKING.
C
C       NOTE  THAT  MC  TRACKING  DELIVERS   THE   BANK   ALGN,   WITH
C       PULSEHEIGHTS IN MEV. THEY ARE HERE  CONVERTED  TO  ADC  COUNTS
C       BEFORE THE READ OUT  THRESHOLD  CHECK.  SURVIVING  BLOCKS  ARE
C       TRANSFORMED BACK TO MEV WITH HELP OF THE  AVERAGE  CALIBRATION
C       CONSTANT (C:A 5 MEV/COUNT). THIS GIVES AN EXTRA  "GRANULARITY"
C       EFFECT, WHICH IS OF  SOME  IMPORTANCE  AT  THE  LOWEST  PHOTON
C       ENERGIES.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CRDSTA / NDUM(12), IPHALG
      COMMON / CTRIGG / IHIST(3)
      COMMON / CHEADR / HEAD(108)
      COMMON / CWORK  / HELP(2,2000)
C
      DIMENSION IHELP(2000)
      EQUIVALENCE (HELP(1,1),IHELP(1))
C
      DATA JELL1/0/,JELL2/0/,JELL3/0/,JELL4/0/,JELL5/0/
C  OLD CONSTANTS, USED UNTIL JULY 1986
C     DATA CALC80/5.32/, CALC81/4.94/,ICAL80/5320/, ICAL81/4940/
C     DATA CALC83/6.50/, ICAL83/6500/
C     DATA IUN80/5/, IUN81/6/
C     DATA IUN83/6/
C
C  NEW CONSTANTS DETERMINED FROM /CALIBR/, 29.7.1986
C   THE AVERAGE IS TAKEN OVER BARREL AND ENDCAP BLOCKS, INCLUDING ALL
C   NONZERO CONSTANTS, WITH VALUES BELOW 10000
C
      DATA CALC79 /5.74/, IUN79 /5/, ICAL79 /5740/
      DATA CALC80 /5.54/, IUN80 /5/, ICAL80 /5540/
      DATA CALC81 /4.69/, IUN81 /6/, ICAL81 /4690/
      DATA CALC82 /4.61/, IUN82 /6/, ICAL82 /4610/
      DATA CALC83 /6.29/, IUN83 /6/, ICAL83 /6290/
      DATA CALC84 /6.13/, IUN84 /6/, ICAL84 /6130/
      DATA CALC85 /6.09/, IUN85 /6/, ICAL85 /6090/
      DATA CALC86 /5.94/, IUN86 /6/, ICAL86 /5944/
C
C     DATA CALC86 /6.09/, IUN86 /6/, ICAL86 /6090/  UPDATE 25.5.87
C
      DATA ICALL/0/
C
C------------------  C O D E  ------------------------------------------
C
      IF(HEAD(18).GT.100) GO TO 1000
      IF(IPHALG.EQ.0) GO TO 1000
C
      IPALGN = IDATA(IBLN('ALGN'))
      IF(IPALGN.GT.0) GO TO 1
      JELL1 = JELL1 + 1
      IF(JELL1.LT.2 .AND. NDDINN .EQ. 0 ) WRITE(6,9901)
9901  FORMAT(' * * *  RDALGN MET EVENT  WITHOUT ALGN BANK ')
      GO TO 1000
1     NWO = IDATA(IPALGN)
      IF(NWO.GT.3) GO TO 2
      JELL2 = JELL2 + 1
      IF(JELL2.LT.5) WRITE(6,9902)
9902  FORMAT(' * * *  RDALGN MET EVENT  WITH EMPTY ALGN BANK ')
      GO TO 1000
2     CONTINUE
C
C    LOOP OVER ALGN BANK
C
      IYEAR = IHIST(3)
      IYEAR = MOD(IYEAR,100)
C
      IY = IYEAR - 78
      GO TO (21,31,41,51,61,71,81,85), IY
C
85    CALC = CALC86
      ICALC = ICAL86
      IHMC = IUN86
        GO TO 150
81    CALC = CALC85
      ICALC = ICAL85
      IHMC = IUN85
        GO TO 150
71    CALC = CALC84
      ICALC = ICAL84
      IHMC = IUN84
        GO TO 150
61    CALC = CALC83
      ICALC = ICAL83
      IHMC = IUN83
        GO TO 150
51    CALC = CALC82
      ICALC = ICAL82
      IHMC = IUN82
        GO TO 150
41    CALC = CALC81
      ICALC = ICAL81
      IHMC = IUN81
        GO TO 150
31    CALC = CALC80
      ICALC = ICAL80
      IHMC = IUN80
        GO TO 150
21    CALC = CALC79
      ICALC = ICAL79
      IHMC = IUN79
C
150   CONTINUE
C
      ICALL = ICALL + 1
      IF( ICALL .GT. 1 .OR. NDDINN .NE. 0 ) GO TO 5710
      WRITE(6,5410) IHIST(3),CALC,IHMC
5410  FORMAT(' ** RDALGN **  YEAR: ',I5,'    CAL. CONST: ',F5.2,'  ',I2,
     +       ' COUNTS THRESHOLD')
5710  IPH = IPALGN*2 + 7
      IPHL = 2*(NWO + IPALGN)
      N1 = 0
      N2 = 0
      N3 = 0
      NWRD = 3
      DO 100 IH = IPH,IPHL,2
      IPU = HDATA(IH+1)
      NBL = HDATA(IH)
      PU = FLOAT(IPU)/CALC
      IPUX = IFIX(PU)
      IF(IPUX.LT.IHMC) GO TO 100
C -------------------------------------------------------
C
C THE FOLLOWING 2 STATEMENTS ARE BASED ON THE REAL DATA CALIBRATION
C THEY LEAD TO SYSTEMATICALLY TOO LOW LG ENERGIES...
C
C     IPU = IPUX * ICALC + 512
C     IPU=ISHFTR(IPU,10)
C -------------------------------------------------------
      IF(NBL.GT.0.AND.NBL.LT.2881) GO TO 5
      JELL3 = JELL3 + 1
      IF(JELL3.LT.5) WRITE(6,9903) NBL
9903  FORMAT(' * * *  RDALGN MET EVENT  WITH ILLEGAL BLOCK NR ',I6)
      GO TO 100
5     IF(NBL.LT.2689) N1 = N1 + 1
      IF(NBL.GT.2688.AND.NBL.LT.2785) N2 = N2 + 1
      IF(NBL.GT.2784) N3 = N3 + 1
      NWRD = NWRD + 1
      HELP(1,NWRD) = NBL
      HELP(2,NWRD) = IPU
100   CONTINUE
C
C   SET POINTERS
C
      IHELP(1) = IDATA(IPALGN+1)
      HELP(1,2) = 1
      HELP(2,2) = 1
      IF(N1.GT.0) HELP(2,2) = 2*N1 + 1
      HELP(1,3) = HELP(2,2) + 2*N2
      HELP(2,3) = HELP(1,3) + 2*N3
C
C  RECREATE ALGN
C
      CALL BDLS('ALGN',1)
      CALL BDLS('LGCL',1)
      CALL BGAR(IGA)
      CALL BCRE(KPALGN,'ALGN',1,NWRD,*91,IER)
      CALL BSAW( 1, 'ALGN')
      IF(IER.EQ.0) GO TO 20
C
C---- BCRE ENDS WITH AN ERROR.
C     THE 'ALGN' EXISTS ALREADY.
C
      JELL4 = JELL4 + 1
      IF(JELL4.LT.5) WRITE(6,9904)
9904  FORMAT(' * * *  RDALGN GOT ERROR IN CREATING ALGN BANK ')
      GO TO 1000
C
C---- NOT ENOUGH SPACE IN /BCS/.
   91 JELL5 = JELL5 + 1
      IF(JELL5.LT.5) WRITE(6,9905)
9905  FORMAT(' * * *  RDALGN FOUND NOT ENOUGH SPACE IN BCS ')
      GO TO 1000
C
C---- OVERWRITE 'ALGN'-BANK WITH THE HELP ARRAY
C
  20  CALL MVCL(IDATA,4*KPALGN,IHELP,0,4*NWRD)
C               TO             FROM      BYTES
C
1000  CONTINUE
      RETURN
      END

C   18/08/79 209010957  MEMBER NAME  RETTEN   (JADEGS)      FORTRAN
      SUBROUTINE RETTEN(NOPT)
      IMPLICIT INTEGER*2 (H)
C---
C---     SAVES CWORK CONTENTS ONTO DISK FILE OR RETRIEVES THEM AGAIN.
C---     LAST CHANGE              30.8.82    J.OLSSON
C---
#include "cdata.for"
#include "cgraph.for"
      REAL*8 DDN
      COMMON/CWORK/IWORK(8467)
      COMMON/CSVCW1/NDDSVE
      DIMENSION IHEAD(108)
      DIMENSION HHEAD(216)
      EQUIVALENCE(IHEAD(1),HHEAD(1))
      DIMENSION IDATAL(11),HVOLSR(4)
      DATA ICONT /'CONT'/
      DATA HBLANK/'  '/
      DATA IBNM/'CWRK'/
      DATA LENG/8575/
C---
      IF(NDDSVE.NE.0) GO TO 99
C---
C---   ALLOCATE DATA SET
C---
1     CALL TRMOUT(80,'PLEASE ENTER FULL NAME OF CATALOGUED DATA SET FOR
     $OUTPUT EVENTS:^')
      CALL TRMIN(44,IDATAL)
C---
C---     TEST FOR THE STRING CONTINUE.
C---
      IF(IDATAL(1).NE.ICONT) GO TO 9
      NDDSVE = 0
      GO TO 100
C---
C---     ALLOCATE FORTRAN REFERENCE NUMBER TO OUTPUT DATA SET.
C---
9     CONTINUE
      DO 8 I=1,11
    8 IDATSV(I)=IDATAL(I)
      DO 33 I=1,4
   33 HVOLSR(I)=HBLANK
      NDDSVE=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,NDDSVE,HERR)
      IF(HERR.EQ.0) GO TO 99
C---
C---     ERROR HAS OCCURRED ON ALLOCATION.
C---
      CALL TRMOUT(80,'THE NAME IS INCORRECT OR HMS/MSS IS JAMMED.^')
44    CALL TRMOUT(80,'PLEASE TRY AGAIN OR CONTINUE SESSION BY "CONTINUE"
     $.^')
      GO TO 1
C---
C---     SUCCESSFULLY ALLOCATED DATA SET.
C---
99    IPHEAD=IDATA(IBLN('HEAD'))
      IHHEAD=IPHEAD*2
      REWIND NDDSVE
      IF(NOPT.EQ.1) GO TO 111
      IF(NOPT.EQ.2) GO TO 222
      RETURN
111   CALL MVCL(IHEAD(1),0,IDATA(IPHEAD-3),0,412)
      IHEAD(104)=8575
      IHEAD(105)=IBNM
      IHEAD(106)=0
      IHEAD(107)=0
      IHEAD(108)=8467
      WRITE(NDDSVE) LENG,IHEAD,IWORK
      CALL TRMOUT(80,'HEADER BANK AND CWORK WRITTEN.^')
      END FILE NDDSVE
      CALL TRMOUT(80,'END OF FILE PUT ONTO SAFETY UNIT.^')
      RETURN
222   ISF=0
 4    READ(NDDSVE,ERR=1000,END=2000) LN,IHEAD
      ISF=ISF+1
      IF(IHEAD(105).EQ.IBNM) GO TO 3
      WRITE(JUSCRN,101) IHEAD(105)
  101 FORMAT(' ILLEGAL RECORD TYPE ON RECOVERY FILE. 2ND BANK NAME ',A4)
 3    WRITE(JUSCRN,102) ISF,HHEAD(18),HHEAD(19)
  102 FORMAT(' SAFETY RECORD',I4,' HOLDS CWORK FOR RUN,'I6,' EVENT',I6)
      I1=IHHEAD+10
      I2=IHHEAD+11
      IF((HHEAD(18).NE.HDATA(I1)).OR.(HHEAD(19).NE.HDATA(I2))) GO TO 4
 5    REWIND NDDSVE
 6    READ(NDDSVE,ERR=1000,END=2000) LN,IHEAD,IWORK
      ISF=ISF-1
      IF(ISF.GT.0) GO TO 6
      CALL TRMOUT(80,'CWORK RESTORED.^')
      RETURN
1000  CALL TRMOUT(80,'READ ERROR ON BACKUP FILE. RECOVERY FAILED.^')
      RETURN
2000  CALL TRMOUT(80,
     1'MATCHING EVENT NUMBER NOT FOUND RECOVERY FAILED.^')
100   CONTINUE
      RETURN
      END

C   05/02/80 002080923  MEMBER NAME  VTXBNK   (JADEGS)      FORTRAN
      SUBROUTINE VTXBNK(IPPATR)
C*800205*OLSSON*****************************************************
C*                                                                 *
C* C R E A T E  B A N K  GVTX  F R O M  V E R T E X  R E S U L T S *
C*                                                                 *
C*******************************************************************
C             IPPATR IS POINTER TO 'PATR' ;  SAME BOSBANK NR IS USED
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      COMMON /CWORK1/ NT,T(1500),NV,V(200)
      DIMENSION IV(2),IT(2)
      EQUIVALENCE (V(1),IV(1)),(T(1),IT(1))
C
      IF(NV.EQ.0) GO TO 100
C****
C
      NBNK = IDATA(IPPATR-2)
      NWRES = 2 + NV*10 + NT*15
      CALL CCRE(IPHT,'GVTX',NBNK,NWRES,IERR)
      IF(IERR.NE.0) GO TO 100
      CALL BSAW(1,'GVTX')
      IDATA(IPHT+1) = NV
      DO 1  INV = 1,NV
      INVX = IPHT+1+(INV-1)*10
      ISS = (INV-1)*10
      DO 1  I = 1,10
1     IDATA(INVX+I) = IV(ISS+I)
      IDATA(IPHT+2+NV*10) = NT
C
      DO 2  INT = 1,NT
      INTX = IPHT+2+NV*10 + (INT-1)*15
      ISS = (INT-1)*30
      DO 2  I = 1,15
2     IDATA(INTX+I) = IT(ISS+I)
  100 RETURN
      END

C   07/06/96 606071918  MEMBER NAME  UWP2     (S4)          FORTG1
      SUBROUTINE UWP2
C
      REAL*4 BIN(2)
      REAL*8 FMT(13),FMTF/'  F12.4,'/,FMTG/'  G12.4,'/,
     1     FMTI/'    I12,'/,FMTA/'  8X,A4,'/,FMT1/'        '/,
     2     FMT2/'(11X,   '/
      INTEGER NEQ/0/,LIM(2,8)
      LOGICAL*1 LFMT(96),LL(8),LAST/')'/
      DATA FMT(1)/'(1X,I4, '/,FMT(2)/''' -'',I4,'/
      DATA LIM/75,80,91,97,107,111,123,136,
     1     193,201,209,217,226,233,240,249/
      EQUIVALENCE(FMT(1),LFMT(1)),(LL(1),REQ),(LL(5),NEQ)
      REAL*8 FMZ(11)
      EQUIVALENCE (FMT(3),FMZ(1))
      REAL*4 BINT(10)
      INTEGER*2 BIN2(20)
      EQUIVALENCE(BINT(1),BIN2(1))
***PMF 07/05/99
      INTEGER VS(2),TEXT(10)
***PMF(End)
      RETURN
      ENTRY UWP(BIN,NA,NB)
      IF(NA.GT.NB) GOTO 100
      NF=((NA-1)/10)*10+1
      N=NB+1-NF
      DO 60 I=NF,NB,10
      IA=I
      IB=MIN0(I+9,NB)
      M=3
      DO 50 J=IA,IB
      REQ=BIN(J)
      M=M+1
      LA=0
      DO 20 K=1,4
      LL(8)=LL(K)
      IF(NEQ.EQ.64) GOTO 20
      DO 10 L=1,8
      IF(NEQ.LT.LIM(1,L)) GOTO 40
      IF(NEQ.GT.LIM(2,L)) GOTO 10
      IF(L.LE.4) LA=LA+1
      GOTO 20
   10 CONTINUE
      GOTO 40
   20 CONTINUE
      IF(LA.GT.2) GOTO 40
      FMT(M)=FMTA
      GOTO 50
   40 IF(ABS(REQ).GT.1.E20.OR.ABS(REQ).LT.1.E-20) GOTO 30
      IF(ABS(REQ).LT.10000.0.AND.ABS(REQ).GE.0.1) GOTO 45
      FMT(M)=FMTG
      GOTO 50
   45 FMT(M)=FMTF
      GOTO 50
   30 FMT(M)=FMTI
   50 CONTINUE
      LFMT(8*M)=LAST
      IF(N.LE.10) GOTO 55
      FMT(3)=FMT1
      WRITE(6,FMT) IA,IB,(BIN(II),II=IA,IB)
      GOTO 56
   55 FMT(3)=FMT2
      WRITE(6,FMZ) (BIN(II),II=IA,IB)
   56 K=0
      DO 58 II=IA,IB
      K=K+1
   58 BINT(K)=BIN(II)
      K=K+K
      WRITE(6,103) (BIN2(II),II=1,K)
   60 CONTINUE
      GOTO 100
C
      ENTRY UTP(VS,IT,TEXT)
C
*** PMF      INTEGER VS(2),TEXT(10)
      IF(IT.LE.0) GOTO 70
      WRITE(6,101) VS,(TEXT(I),I=1,IT)
      GOTO 100
   70 WRITE(6,101) VS
      GOTO 100
C
      ENTRY UPP
C
      WRITE(6,102)
  100 RETURN
  101 FORMAT('0  ',2A4,10(8X,A4))
  102 FORMAT('1')
  103 FORMAT(11X,20I6)
      END

C   07/06/96 606071817  MEMBER NAME  BFUN     (S4)          FORTRAN
      FUNCTION BFUN(M,X)
      COMMON/BCS/IW(1000)
      REAL RW(1000)
      EQUIVALENCE (RW(1),IW(1))
      REAL H(2)
      EXTERNAL CUBSPL
C
C     PURPOSE
C        FOR A TABULATED FUNCTION Y = Y(X), CALCULATE THE INTERPOLATED
C        VALUES OF THE FUNCTION AND THE DERIVATIVE AT A GIVEN X
C
C     METHOD
C        THE TABLE OF X AND Y VALUES ARE READ FROM DATACARDS BY
C        SUBR. BREADC (CALLED BY THE USER). THE SPLINE INTERPOLATION
C        METHOD IS USED (SUBR. SPLCOF).
C
C     USAGE
C        EACH FUNCTION IS CHARACTERIZED BY A NUMBER M.
C
C     $FUN M X1 Y1 X2 Y2 . . . XN YN
C
C        F= BFUN(M,X)
C         = INTERPOLATED VALUE OF FUNCTION M FOR GIVEN X
C
C        D= BDER(M,X)
C         = INTERPOLATED VALUE OF DERIVATIVE OF FUNCTION M FOR X
C
C        F OR D = 0.0, IF NO DATA CARDS OR LESS THAN 3 POINTS
C
      IJ=1
   10 CALL BLOC(INDP,'+FUN',M,&20)
      CALL CUBFUN(X,H(1),H(2),RW(INDP+1))
      BFUN=H(IJ)
      GOTO 100
C
      ENTRY BDER(M,X)
      IJ=2
      GOTO 10
C
   20 CALL BLOC(INDF,'$FUN',M,&99)
   30 ND=IW(INDF)/2
      IF(ND.LT.3) GOTO 99
      CALL BCRE(INDP,'+FUN',M,5*ND,&99,IER)
      INDH=INDP
      DO 40 I=1,ND
      RW(INDH+1)=RW(INDF+I+I)
      RW(INDH+2)=RW(INDF+I+I-1)
   40 INDH=INDH+5
      CALL CUBCOP(ND,RW(INDP+1))
      GOTO 10
C
   99 BFUN=0.0
  100 RETURN
      END

C   03/12/83 403011611  MEMBER NAME  MCVSUM   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCVSUM
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   17/11/83 :  PRINTS VALIDATION ERROR SUMMARY
C
C        MOD: C. BOWDERY   22/11/83 :  FOR FURTHER SUMMARY OUTPUT.
C        MOD: C. BOWDERY   24/11/83 :  FORMAT CHANGE I5 --> I6
C        MOD: C. BOWDERY    2/12/83 :  ADD NEW ERROR PRINTOUT
C   LAST MOD: C. BOWDERY    1/03/84 :  CORRECT PRINTOUT
C
C   THIS ROUTINE PRINTS A SUMMARY OF THE VALIDATION ERRORS DETECTED BY
C   BY MCVERR CALLED FROM BRVECT.
C
C   ADDITIONALLY, ERRORS 18 - 20 RECORD THE NUMBER OF READ ERRORS AND
C   BOS ERRORS IN BRVECT AND THE TOTAL NUMBER OF EVENTS REJECTED
C   DUE TO THE ABOVE ERRORS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CVERR / MESSAG(20)
C
C-------------------  C O D E  -----------------------------------------
C
      WRITE(6,100)
 100  FORMAT(/)
C
      IF( MESSAG(1)  .NE. 0 ) WRITE(6,1)  MESSAG(1)
      IF( MESSAG(2)  .NE. 0 ) WRITE(6,2)  MESSAG(2)
      IF( MESSAG(3)  .NE. 0 ) WRITE(6,3)  MESSAG(3)
      IF( MESSAG(4)  .NE. 0 ) WRITE(6,4)  MESSAG(4)
      IF( MESSAG(5)  .NE. 0 ) WRITE(6,5)  MESSAG(5)
      IF( MESSAG(6)  .NE. 0 ) WRITE(6,6)  MESSAG(6)
      IF( MESSAG(7)  .NE. 0 ) WRITE(6,7)  MESSAG(7)
      IF( MESSAG(8)  .NE. 0 ) WRITE(6,8)  MESSAG(8)
      IF( MESSAG(9)  .NE. 0 ) WRITE(6,9)  MESSAG(9)
      IF( MESSAG(10) .NE. 0 ) WRITE(6,10) MESSAG(10)
      IF( MESSAG(11) .NE. 0 ) WRITE(6,11) MESSAG(11)
      IF( MESSAG(12) .NE. 0 ) WRITE(6,12) MESSAG(12)
      IF( MESSAG(13) .NE. 0 ) WRITE(6,13) MESSAG(13)
      IF( MESSAG(14) .NE. 0 ) WRITE(6,14) MESSAG(14)
      IF( MESSAG(15) .NE. 0 ) WRITE(6,15) MESSAG(15)
      IF( MESSAG(16) .NE. 0 ) WRITE(6,16) MESSAG(16)
      IF( MESSAG(17) .NE. 0 ) WRITE(6,17) MESSAG(17)
C
      IF( MESSAG(18) .NE. 0 ) WRITE(6,18) MESSAG(18)
      IF( MESSAG(19) .NE. 0 ) WRITE(6,19) MESSAG(19)
      IF( MESSAG(20) .NE. 0 ) WRITE(6,20) MESSAG(20)
C
      RETURN
C
C                            THE MESSAGES
C
  1   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  1.  BEAM ENERGY WAS '
     +   ,'NEGATIVE, ZERO OR .GE. 1000 GEV')
C
  2   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  2.  MOMENTUM COMPONE'
     +            ,'NTS WERE NON-ZERO BUT .LE. E-20 GEV ',
     +             'OR GREATER THAN BEAM ENERGY')
C
  3   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  3.  ENERGY COMPONE'
     +   ,'NT WAS .LE. E-20 GEV OR GREATER THAN 2 * BEAM ENERGY')
C
  4   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  4.  PARTICLE MASS '
     +   ,'DID NOT AGREE WITH STANDARD MASS FOR TYPE WITHIN 10 MEV')
C
  5   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  5.  ENERGY, MOMENT'
     +   ,'UM AND MASS WERE NOT CONSISTENT TO 5% OF THE ENERGY')
C
  6   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  6.  COMPONENTS OF '
     +   ,'THE PRODUCTION VERTEX WERE .LE. E-20 OR .GE. 5000 MM')
C
  7   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  7.  THE PRODUCTION'
     +   ,' VERTEX WAS .GE. 8000 MM FROM THE INTERACTION POINT')
C
  8   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  8.  TOTAL MOMENTUM'
     +   ,' OF A SINGLE PARTICLE WAS GREATER THAN THE BEAM ENERGY')
C
  9   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR  9.  PARTICLE MASS '
     +   ,'WAS SMALLER THAN E-20 GEV OR GREATER THAN 2 * BEAM ENERGY')
C
 10   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 10.  NO INFORMATION'
     +   ,' AVAILABLE FOR THIS ERROR !!')
C
 11   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 11.  ILLEGAL PARTICLE'
     +   ,' TYPE FOUND. NOT IN THE RANGE 1 TO 6 OR A PARTON')
C
 12   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 12.  ILLEGAL ELECTRIC'
     +   ,' CHARGE FOUND. NOT -1, 0 , +1')
C
 13   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 13.  ILLEGAL EVENT '
     +   ,'NUMBER. ALLOWED RANGE IS  0  TO  9999999')
C
 14   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 14.  COUNT OF TOTAL '
     +   ,'NUMBER OF FINAL PARTICLES (NF) NOT IN RANGE 1 TO 300')
C
 15   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 15.  COUNT OF NUMBER '
     +   ,'OF FINAL CHARGED PARTICLES (NCF) NOT IN RANGE 0 TO 300')
C
 16   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 16.  COUNT OF NUMBER '
     +   ,'OF FINAL NEUTRAL PARTICLES (NNF) NOT IN RANGE 0 TO 300')
C
 17   FORMAT(1X,I6,' OCCURRENCE(S) OF INPUT ERROR 17.  TOTAL COUNT OF '
     +   ,'FINAL PARTICLES .NE. SUM OF COUNTS FOR CHARGED AND NEUTRALS')
C
 18   FORMAT(1X,I6,' OCCURRENCE(S) OF M.C.  ERROR 18.  EVENT COULD NOT'
     +   ,' BE READ BY BRVECT DUE TO FORTRAN READ ERROR')
C
 19   FORMAT(1X,I6,' OCCURRENCE(S) OF M.C.  ERROR 19.  BOS ERROR CODE'
     +   ,' DETECTED IN S/R BRVECT WHEN CREATING VECT OR PALL BANK')
C
 20   FORMAT(/1X,I6,' EVENT(S) REJECTED IN TOTAL BECAUSE OF THE ABOVE'
     +   ,' READ ERRORS, INVALID INPUT AND BOS ERRORS IN BRVECT')
C
      END

C   01/11/84 807251601  MEMBER NAME  HITSCL   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE HITSCL( X0, Y0, SCRUNI )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   30/01/86 :  DRAW SCALING ON HIT CROSS
C
C       ARGUMENTS :
C           X0     =  X - COORDINATE OF HIT
C           Y0     =  Y - COORDINATE OF HIT
C           SCRUNI =  SIZE OF HIT CROSSES
C
C-----------------------------------------------------------------------
C
      LOGICAL FL18,FL22,FL24
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
      DATA WIDTH  / 0.15 /
      DATA SCALW  / 0.25 /
C
C-----------------  C O D E  -------------------------------------------
C
      IF( IPRJC .NE. 0 )  RETURN
C
       XL = X0 - WIDTH
       XR = X0 + WIDTH
       YY = Y0 - SCRUNI
       YD = Y0 - WIDTH
       YU = Y0 + WIDTH
       XX = X0 - SCRUNI
C
       DO 10 I = 1, 13
          CALL MOVEA(XL,YY)
          CALL DRAWA(XR,YY)
          YY = YY + SCALW
          CALL MOVEA(XX,YD)
          CALL DRAWA(XX,YU)
          XX = XX + SCALW
   10 CONTINUE
C
      RETURN
      END

C   11/09/78 606101230  MEMBER NAME  JPRTLO9  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JPRTLO( R, P, PENETR, PENETZ, RLOW, BARHIG,
     *                   ZLOW, ZHIGH, DRMAX, *, *, *, * )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     02/10/78 :  PROPAGATES PARTICLE IN NON
C                                      ABSORBING MEDIUM DEFINED BY
C                                      PARAMETERS  ( RLOW, BARHIG,
C                                                    ZLOW, ZHIGH )
C
C  LAST MOD J. HAGEMANN    28/08/84 :  NEW VERSION OF SUBROUTINE JSTEP
C                                      INCLUDED
C
C        UPON RETURN PENET((R) OR (Z)) IS PENETRATION
C        LENGTH IN NEXT ELEMENT IN R OR Z DIRECTION.
C
C           RETURN  : NEXT ELEMENT, INCREASING R
C           RETURN1 : NEXT ELEMENT, DECREASING R
C           RETURN2 : NEXT ELEMENT, INCREASING Z
C           RETURN3 : NEXT ELEMENT, DECREASING Z
C           RETURN4 : PARTICLE STOPPED IN SYSTEM OR DECAY CONDITION
C                     REACHED.
C-----------------------------------------------------------------------
C
      COMMON / CJTRLE / TOTLEN, STPLEN
C
      COMMON / CJCELL / NCELL(3),
     *                  NWIRES(3)
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
C
      DIMENSION R(5), P(7)
C
      DATA TWOPI / 6.283185 /
C
C------------------------  C O D E  ------------------------------------
C
      IF( R(4) .LT. RLOW ) RETURN 1
      IF( R(3) .GT. ZHIGH ) RETURN 2
      IF( R(3) .LT. ZLOW  ) RETURN 3
C
      PENETZ = 0.
      PENETR = 0.
      DPSI =  TWOPI / FLOAT( NCELL(1) )
C
      DO 100 ITERAT = 1,300
C
         R(5) = ATAN2( R(2), R(1) )
                IF( R(5) .LT. PSIIN(1) ) R(5) = R(5) + TWOPI
                NPHI = ( R(5) - PSIIN(1) ) / DPSI + .5
                DPHI = R(5) - FLOAT( NPHI )*DPSI - PSIIN(1)
      IF( R(4)*COS( DPHI ) .GT. BARHIG ) RETURN
C
      CALL JSTEP( R, P, DRTOT, DRMAX )
        R(4) =  SQRT( R(1)*R(1) + R(2)* R(2) )
C      TOTAL TRACK LENGTH BIGGER THAN MAXIMUM VALUE?
              TOTLEN = TOTLEN  + DRTOT
              IF( TOTLEN .GT. STPLEN ) RETURN4
C
      IF( R(4) .GE. RLOW ) GO TO 110
          PENETR = RLOW - R(4)
          RETURN 1
  110 IF( R(3) .LE. ZLOW .AND. R(3) .LE. ZHIGH )  GO TO 100
          PENETZ = ZLOW - R(3)
          IF( PENETZ .GT. 0. ) RETURN 3
          PENETZ = R(3) - ZHIGH
          IF( PENETZ .GT. 0. ) RETURN 2
C
C
  100 CONTINUE
C
      RETURN 4
      END

C   12/08/87 708120949  MEMBER NAME  EAZERO   (S)           FORTRAN77
      SUBROUTINE EAZERO
C-----------------------------------------------------------
C  VERSION OF 12/08/87     LAST MOD 12/08/87    E ELSEN
C  INIT VARIABLES USED IN E ANALYSIS
C  ADAPTED FORM F11HEL.NEUFS(ELSE34, ENTRY ZUNULL IN EVENTO)
C-----------------------------------------------------------
C
C
      IMPLICIT INTEGER*2 (H)
C---------------------------------------- COMMONS FOR LEAD GLASS ENERGY
C
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
      COMMON /CLDAT/ NUMBLO,NBLIST(40),ENLIST(40),IPACL,ECLCO,ECLUN,
     *               PIMP1,PIMP2
C-------------------------------------------- GENERAL COMMONS
C
      COMMON / CRELC / SIGP,SIG1EP,CH1EP,CHI1W,CHI2N,PCHI2,ESHM,RFIR,
     +                 CHIRP,CHIRZ,ZINT,RDIS,JKAND
C
      XI=-2000.
      YI=-2000.
      ZI=-2000.
      ZF=-2000.
      PSTART=-20.
      PIMP2=-2000.
      EBITER=-1.
      ENEW=-1.
      RFIR=0.0
      CHIRP=-1.
      CHIRZ=-1.
      ZINT=-1200.
      SIGP=-1.
      SIG1EP=-1.
      CH1EP=-1.
      CHI1W=-1.
      CHI2N=-1.
      PCHI2=-1.
      NUMBLO=-1
      JKAND=0
      END

C   25/06/78            MEMBER NAME  PAIRC1   (LGSOURCE)    FORTRAN
      SUBROUTINE PAIRC1(ENE,EPSI)
      COMMON /BRPAR/BRA,BRB,BDEL
      COMMON /PAPAR/CP
      COMMON /SFCPA/SF,SFE
      BH(X)=4.184*ALOG(X+0.952)-0.280
      XR=RN(DAM)
      EPSI=XR
      XR=RN(DAM)
      DEL=BDEL/(ENE*EPSI*(1.-EPSI))
      IF(DEL-1.)20,20,21
 20    G1=1.-CP*DEL*(2.914-0.447*DEL)
      GOTO2
 21    G1=1.-CP*BH(DEL)
 2    IF(SF*XR-G1)30,30,31
 30    RETURN
 31    EPSI=0.
      RETURN
      END

C   01/11/84            MEMBER NAME  PHNUMB   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PHNUMB( IE, SH3, SLOPE )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  DISPLAY LG PULSE HEIGTHS
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "chsym.for"
#include "cgraph.for"
C
      COMMON /CWORK1/ R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4
     +               ,HMW(132)
C
C-----------------  C O D E  -------------------------------------------
C
      IF(IE.LT.1) RETURN
      DELTX = ABS(XMAX-XMIN)
      HUMP = 1
      IF(LASTVW.NE.13.AND.DELTX.LT.4000.) HUMP = 2
      IF(LASTVW.EQ.13.AND.DELTX.LT.5000.) HUMP = 2
      IF(HUMP.EQ.2) GO TO 200
C                "LOGARITMIC" DISPLAY MODE
      IDIV = 1
      DO 35 ICC = 1,5
      IDIV = IDIV*10
      JNDEX = IE/IDIV
      IF(JNDEX.GE.10) GO TO 35
      JNDEX = JNDEX + (ICC-1)*9 + 1
      GO TO 36
   35 CONTINUE
   36 IF(JNDEX.GT.36) JNDEX = 36
      HMW(1) = HSYM(JNDEX)
      CALL HEMSYM(X1,Y1,SH3,HMW,1,SLOPE)
      RETURN
C               WRITE FULL NUMBERS INTO BLOCK
200   CALL DNUM(IE,X1,Y1,SH3*.33,SLOPE)
      RETURN
      END

C   30/03/79 009141224  MEMBER NAME  TOFARD   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE TOFARD(INLA,INTF,IFLG,*)
C
C          CONVERTS THE TOF DATA FROM CAMAC FORMAT
C       TO ANALYSIS FORMAT :
C                   IRAW(1,NCN)= NCN  ; COUNTER#
C      RAW(2,NCN)= TDC(-)-CM(NCN)
C      RAW(3,NCN)= TDC(+)-CP(NCN)
C       OR
C      RAW(2,NCN)= TDC(-) , IF IFLG= 1.
C      RAW(3,NCN)= TDC(+) , IF IFLG= 1.
C                   RAW(4,NCN) = ADC(-)
C                   RAW(5,NCN) = ADC(+)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
#include "ddata.for"
#include "tfprm.for"
#include "tfadc.for"
      INTEGER *2  HADC,HTDC,HEADR(108)
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      DIMENSION MASK(16)
      DIMENSION IRAW(5,42)
      EQUIVALENCE (IRAW(1,1),RAW(1,1))
C
      DATA MASK/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     1          16384,32768/
      DATA IENTRY/0/,LERR/0/,IBUG/0/
      DATA ADCLIM/1./
      IF(IENTRY.NE.0)  GOTO 320
      IENTRY = IENTRY + 1
C
 320  CONTINUE
C
C========= ADDRESSING
C
      NRUN = HEADR(18)
       INLA2= INLA*2
       INTF2= INTF*2
       IL0= INLA2+6
       IA0= INTF2+3
       IT0= INTF2+94
C//////////
      IBUG = IBUG + 1
      BADC = TPARM(1)
      AADC = TPARM(2)
C
      DO 3000 NCN= 1,42
      IRAW(1,NCN) = 0
C
C========= ADDRESS OF ADC AND TDC FOR COUNTER# NCN
C
      NCN2= NCN*2
      IAA= (NCN-1)/6+NCN2+IA0-2
      IAT= (NCN-1)/4+NCN2+IT0-2
      IAA1= IAA+1
      IAT1= IAT+1
      HADC(1,NCN)= HDATA(IAA)
      HADC(2,NCN)= HDATA(IAA1)
      ADCM = HDATA(IAA) - PEDLM(NCN)
      ADCP = HDATA(IAA1) - PEDLP(NCN)
      IF(NRUN.LE.2306.OR.NCN.LE.38)  GOTO  75
      IF(NRUN.GE.3182)  GOTO  75
      ADCM = ADCM*2
      ADCP = ADCP*2
   75 HTDC(1,NCN)= HDATA(IAT)
      HTDC(2,NCN)= HDATA(IAT1)
      IF(NCN.NE.25.AND.NCN.NE.26)  GOTO  76
      IF(NRUN.LT.3728.OR.NRUN.GT.4426)  GOTO  76
      IF(NCN.EQ.25) IAT = IT0-2+58
      IF(NCN.EQ.26) IAT = IT0-2+56
      HTDC(1,NCN)= HDATA(IAT)
   76 CONTINUE
      TDCM = HTDC(1,NCN)
      TDCP = HTDC(2,NCN)
C
C========= CHECK OF LATCHED BIT
C
        NW= (NCN-1)/7+IL0
        MDATA= HDATA(NW)
      IF(MDATA) 100,110, 100
 100  NORD= MOD(NCN,7)
      IF(NORD.EQ.0) NORD = 7
 110  IF(NRUN.LT.3728.OR.NRUN.GT.4426)  GOTO  78
      IF(NCN.NE.25.AND.NCN.NE.26)  GOTO  78
      IF(HTDC(1,NCN).LT. 5.OR.HTDC(1,NCN).GE.2048)  GOTO  3000
      IF(HTDC(2,NCN).LT. 5.OR.HTDC(2,NCN).GE.2048)  GOTO  3000
      GOTO  1500
   78 IF(LAND(MDATA,MASK(NORD)).GT.0)  GOTO  1500
      GOTO  3000
C
C========= BIT WAS SET
C
 1500 CONTINUE
C
C  COMPUTE PULSEHEIGHT CORRECTION FOR TOF
C
      CORADM = 0.
      CORADP = 0.
      IF(HADC(1,NCN).GE.1024) ADCM = 1024.
      IF(HADC(2,NCN).GE.1024) ADCP = 1024.
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
      ADCMIV = 1000./ADCM
      ADCPIV = 1000./ADCP
      CORADM =  AADC + BADC*ADCMIV
      CORADP =  AADC + BADC*ADCPIV
      IF(NRUN.LT.3728)  GOTO  20
      CORADM =   CADCB(2*NCN-1)*SQRT(ADCMIV)
      CORADP =   CADCB(2*NCN  )*SQRT(ADCPIV)
   20 IF(ADCM.LT.1024.) CMS = CORNOR(2*NCN-1)
      IF(ADCP.LT.1024.) CPS = CORNOR(2*NCN)
      IF(ADCM.GE.1024.) CMS = COROVF(2*NCN-1)
      IF(ADCP.GE.1024.) CPS = COROVF(2*NCN)
C
C     IF(IBUG.LE.10) PRINT 106,NCN,CADCA(2*NCN-1),CADCB(2*NCN-1),
C    1 CADCA(2*NCN),CADCB(2*NCN)
C     IF(IBUG.LE.10) PRINT 106,NCN,ADCM,ADCP,CORADM,CORADP,CMS,CPS
C 106 FORMAT(' TOFARD',I5,10F10.3)
      IF(TDCM.LT.10..OR.TDCM.GT.2048.)  GOTO  2000
      IF(ADCM.LT.ADCLIM)  GOTO  2000
      TDCM0= TDCM
      IF(IFLG.EQ.1) GO TO 1600
      TDCM0= TDCM0*TCALM(NCN)
      TDCM0= TDCM0-CMS-CORADM
C     IF(IBUG.LE.10) PRINT 106,NCN,TDCM0
 1600 IRAW(1,NCN)= NCN
      RAW(2,NCN)= TDCM0
      RAW(4,NCN)= ADCM
C
 2000 CONTINUE
      IF(TDCP.LT.10..OR.TDCP.GT.2048.)  GOTO  2100
      IF(ADCP.LT.ADCLIM)  GOTO  2100
      TDCP0= TDCP
      IF(IFLG.EQ.1) GO TO 2050
2010  TDCP0= TDCP0*TCALP(NCN)
      TDCP0= TDCP0-CPS-CORADP
C     IF(IBUG.LE.10) PRINT 106,NCN,TDCP0
2050  IRAW(1,NCN)= NCN
      RAW(3,NCN)= TDCP0
      RAW(5,NCN)= ADCP
2100  CONTINUE
C
 3000 CONTINUE
C/////////
      RETURN
      END

C   17/01/79 203120911  MEMBER NAME  TFSTOR4  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TFSTOR(NTK,NTR,IFL,NCNT,TOF,PL,TDCL,TDCR,ADCL,ADCR,
     -                   TAUM1,TAUP1,ITFW,P2,ZTOF1)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
       DIMENSION RE(14,50)
       EQUIVALENCE (IR(1,1),RE(1,1))
            IR( 1,NTK)= NTK
            IR( 2,NTK)= IFL
            IR( 3,NTK)= NCNT
            RE( 4,NTK)= TOF
            RE( 5,NTK)= PL
            RE( 6,NTK)= TDCL
            RE( 7,NTK)= TDCR
            RE( 8,NTK)= ADCL
            RE( 9,NTK)= ADCR
            RE(10,NTK)= TAUM1
            RE(11,NTK)= TAUP1
            IR(12,NTK)= ITFW
            RE(13,NTK)= 0.
            RE(14,NTK)= ZTOF1
C     PRINT 408,NTK,(RE(J,NTK),J=1,14)
C 408 FORMAT(1X,I2,14F8.0)
            RETURN
            END

C   24/10/80 110141330  MEMBER NAME  HITXYZ   (PATRECSR)    FORTRAN
          SUBROUTINE HITXYZ(IPHIT,LRSOLN,PHITRK,GRADZR,ZRINT,RESULT)
          IMPLICIT INTEGER*2(H)
          REAL*4 RESULT(14)
          LOGICAL TBIT
C
C
C-----------------------------------------------------------------------
C
C    ----------------------  SUBROUTINE HITXYZ -------------------------
C    ---------- G.F.PEARCE .. LAST UPDATE : 1600 ON 24/10/80 -----------
C    ------------ LATEST ABERATIONS BY T.NOZAKI ON 19/9/80 -------------
C
C     SUBROUTINE TO CALCULATE COORDINATES IN REAL SPACE OF ONE HIT
C     IN THE JADE JET CHAMBERS.
C
C     ALL INPUT/OUTPUT IS TRANSMITTED IN THE CALL PARAMETER LIST.
C     THIS CALL LIST IS DESCRIBED BELOW :
C
C     REQUIRED AS INPUT
C     -----------------
C
C 1.  IPHIT  = POINTER TO HIT IN 'JETC'
C
C 2.  LRSOLN = LEFT/RIGHT SOLUTION (-VE FOR LEFT, +VE FOR RIGHT)
C
C 3.  PHITRK = AZIMUTHAL ANGLE OF THE TRACK (IN R-PHI SPACE) AT THIS HIT
C
C 4.  GRADZR = GRADIENT  FROM THE TRACK FIT IN THE Z-R PLANE.
C
C 5.  ZRINT  = INTERCEPT FROM THE TRACK FIT IN THE Z-R PLANE.
C
C     RESULT ARRAY (OUTPUT FROM HITXYZ)
C     ---------------------------------
C
C (1).  LAYER STRUCK BY HIT (0-15)
C
C (2).  POINTER TO HIT IN 'JETC'
C
C (3).  POINTER TO HIT LABEL ARRAY   (DUMMY .. NOT SET BY HITXYZ)
C
C (4).  COMPUTED X COORDINATE
C
C (5).  COMPUTED Y COORDINATE
C
C (6).  COMPUTED Z COORDINATE
C
C (7).  COMPUTED R COORDINATE
C
C (8).  Z-R ERROR FLAG    (0 => GOOD HIT, 10 => BAD HIT)
C
C (9).  LEFT/RIGHT SOLUTION (-VE FOR LEFT, +VE FOR RIGHT)
C
C (10). CELL NUMBER
C
C (11). X-Y ERROR FLAG    (0 => GOOD HIT, 2 => BAD HIT)
C
C (12). SEC(GAMMA)        WHERE GAMMA IS THE ANGLE OF THE TRACK
C                         TO THE NORMAL TO THE DRIFT SPACE DIRN
C
C (13). RING NUMBER
C
C (14). CHI OF POINT TO FIT IN X-Y    (DUMMY .. NOT SET BY HITXYZ)
C
C-----------------------------------------------------------------------
C
C
          REAL*4 XYZHIT(14)
          LOGICAL*1 CALLED/.FALSE./
#include "cdata.for"
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     * RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,ZRESOL,ZNORM,ZAL,
     * ZSCAL,DRIDEV,DRICOS,DRISIN,PEDES,TZERO(3),
     * DRIROT(96,2),SINDRI(96,2),COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     * CABER1,CABER2,CABER3,CABER4,CABER5,CABER6,CABER7,CABER8
#include "cdsmax.for"
#include "cpatlm.for"
      COMMON/CALIBR/JPOINT(100),
     1HMUCAL(8370),HLGMAI(5760),HTAGSY(384),HJPULS(9216),
     1DELTA0(96,2),DELTA1(96,2),DELTA2(96,2),DELTA5(96,2),DELTA6(96,2)
C
C         ------------------------
C         EQUIVALENCE RESULT ARRAY
C         ------------------------
C
          EQUIVALENCE (XYZHIT( 1),LAYER)
          EQUIVALENCE (XYZHIT( 2),NH1)
          EQUIVALENCE (XYZHIT( 3),NH)
          EQUIVALENCE (XYZHIT( 4),XHIT1)
          EQUIVALENCE (XYZHIT( 5),YHIT1)
          EQUIVALENCE (XYZHIT( 6),ZHIT1)
          EQUIVALENCE (XYZHIT( 7),RHIT1)
          EQUIVALENCE (XYZHIT( 8),IERZRF)
          EQUIVALENCE (XYZHIT( 9),LRSIDE)
          EQUIVALENCE (XYZHIT(10),INCELL)
          EQUIVALENCE (XYZHIT(11),IERXYF)
          EQUIVALENCE (XYZHIT(12),SECGAM)
          EQUIVALENCE (XYZHIT(13),INRING)
          EQUIVALENCE (XYZHIT(14),CHIXYF)
          NH1=IPHIT
          LRSIDE=LRSOLN
C
C         ----------------
C         FETCH RUN NUMBER
C         ----------------
C
          IF(CALLED)GOTO100
          IPHEAD=IBLN('HEAD')
          CALLED=.TRUE.
  100     NRUN=2*IDATA(IPHEAD)
          IF(NRUN.GT.0)NRUN=HDATA(NRUN+10)
C
C         ------------------
C         DATA AND CONSTANTS
C         ------------------
C
          INWIRE=HDATA(NH1)
          INWIRE=SHFTR(INWIRE,3)
          IAMPL=HDATA(NH1+1)
          IAMPR=HDATA(NH1+2)
          IDRIFT=HDATA(NH1+3)
          LAYER=LAND(INWIRE,15)
          INCELL=LAND(SHFTR(INWIRE,4),127)+ 1
          INRING=1
          IF(INCELL.GT.24)INRING=2
          IF(INCELL.GT.48)INRING=3
          DR0=RINCR(INRING)
          JCELL=INCELL-24*(INRING-1)
          IF(INRING.EQ.3)GOTO160
          COSPHW=DIRWR1(JCELL,1)
          SINPHW=DIRWR1(JCELL,2)
          GOTO170
  160     COSPHW=DIRWR3(JCELL,1)
          SINPHW=DIRWR3(JCELL,2)
C
C         ---------------------------
C         CALCULATE Z AND FLAG ERRORS
C         ---------------------------
C
  170     IF(IAMPR.LE.0.OR.IAMPL.LE.0)GOTO180
          ZHIT1=IAMPR+IAMPL
          ZHIT1=.5*ZAL*FLOAT(IAMPR-IAMPL)/ZHIT1
          IERZRF=0
          GOTO190
  180     IERZRF=10
          ZHIT1=0.0
  190     CONTINUE
C
C         -------------------
C         COMPUTE WIRE RADIUS
C         -------------------
C
          RWIRE=FSENSW(INRING)+LAYER*DR0
C
C         ---------------
C         WIRE STAGGERING
C         ---------------
C
          STAG=-SWDEPL
          IF(TBIT(LAYER,31))STAG=+SWDEPL
C
C         -------------------
C         COMPUTE X,Y OF WIRE
C         -------------------
C
          XWIRE=RWIRE*COSPHW+STAG*SINPHW
          YWIRE=RWIRE*SINPHW-STAG*COSPHW
C
C         -----------------------
C         SET LEFT/RIGHT SOLUTION
C         -----------------------
C
          LRFLAG=ISIGN(1,LRSIDE)
  200     LR12=1
          IF(LRFLAG.GT.0)LR12=2
C
C         ---------------
C         A FEW CONSTANTS
C         ---------------
C
          SINA=SINDRI(INCELL,1)
          COSA=COSDRI(INCELL,1)
          TANA=SINA/COSA
          TRLORX=TRMATS(INCELL,1)
          TRLORY=TRMATC(INCELL,1)
          DRFVEL=DRIVEL(INCELL,1)
          TANPHW=SINPHW/COSPHW
C
C         -----------------------------
C         COMPUTE BETA AND GAMMA ANGLES
C         -----------------------------
C
          SINPHI=SIN(PHITRK)
          COSPHI=COS(PHITRK)
          COSGAM=TRLORY*COSPHI-TRLORX*SINPHI
          SINGAM=TRLORX*COSPHI+TRLORY*SINPHI
          TANGAM=SINGAM/COSGAM
          SECGAM=1./COSGAM
          SINBET=SINPHI*COSPHW-COSPHI*SINPHW
          COSBET=COSPHI*COSPHW+SINPHI*SINPHW
          TANBET=SINBET/COSBET
          TLTCOR=1./(COSA+SINA*TANBET)
C
C         --------------------------------
C         CONVERT DRIFT TIME INTO DISTANCE
C         --------------------------------
C
          DRIFT=IDRIFT*DRFVEL
C
C         -------------
C         T0 CORRECTION
C         -------------
C
          IF(NRUN.GT.0)DRIFT=DRIFT + 64*T0FIX(INRING)*DRFVEL
          IF(NRUN.LE.0)DRIFT=DRIFT+0.5*DRFVEL
C
C         --------------------------------------------
C         CALCULATE ROUGH COORDINATES (XHIT,YHIT,RHIT)
C         --------------------------------------------
C
          XHIT=XWIRE+LRFLAG*TRLORX*DRIFT
          YHIT=YWIRE+LRFLAG*TRLORY*DRIFT
          RHIT=SQRT(XHIT**2+YHIT**2)
C
C         -----------------------------
C         CALCULATE FITTED Z-COORDINATE
C         -----------------------------
C
          ZFIT=GRADZR*RHIT+ZRINT
C
C         -----------------------------
C         CORRECTION FOR TIME OF FLIGHT
C         -----------------------------
C
          DDRIFT=CABER6*SQRT(RHIT**2+ZFIT**2)
          DRIFT=DRIFT-DDRIFT
C
C         ---------------------------
C         PROPOGATION TIME ALONG WIRE
C         ---------------------------
C
          DDRIFT=CABER1*(1222.9-ABS(ZFIT))
          DRIFT=DRIFT-DDRIFT
C
C         -----------------------------
C         CORRECTION FOR WIRE POSITIONS
C         -----------------------------
C
          DDRIFT=CABER8*((DELTA5(INCELL,1)+DELTA5(INCELL,2)*ZFIT/1211.5)
     #    *(LAYER-7)+(DELTA6(INCELL,1)+DELTA6(INCELL,2)*ZFIT/1211.5))
     #        *TLTCOR
          DRIFT=ABS(DRIFT*LRFLAG-DDRIFT*10.)
C
C         --------------------------------
C         DRIFT PATH DISPERSION CORRECTION
C         --------------------------------
C
          DDRIFT=0.
          IF(DRIFT.GT.CABER2.AND.TANGAM.GE.0.)GOTO250
          IF(DRIFT.GT.CABER3.AND.TANGAM.LT.0.)GOTO255
          DDRIFT=(SECGAM-1.)*DRIFT
          GO TO 260
  250     DDRIFT=(SECGAM-1.)*CABER2
          GO TO 260
  255     DDRIFT=(SECGAM-1.)*CABER3
  260     CONTINUE
          DRIFT=DRIFT+DDRIFT
C
C         ----------------------------------
C         DRIFT VELOCITY VARIATION NEAR WIRE
C         ----------------------------------
C
          DDRIFT=0.
          IF(DRIFT.LT.CABER4 ) DDRIFT=CABER5*(DRIFT-CABER4)**2
          DRIFT=DRIFT+DDRIFT
C
C         ---------------------
C         EDGE WIRE DISTORTIONS
C         ---------------------
C
          IF(LAYER.GE.3) GO TO 271
          DDRIFT=DELTA1(INCELL,LR12)*(LAYER-3)**2*DRIFT
          GO TO 272
 271      IF(LAYER.LE.12)  GO TO 273
          DDRIFT=DELTA2(INCELL,LR12)*(LAYER-12)**2*DRIFT
 272      DRIFT=DRIFT-DDRIFT*CABER8
 273      CONTINUE
C
C         -------------------------------------
C         FIELD DISTORTION AT LARGE DRIFT TIMES
C         -------------------------------------
C
          DDRIFT=0.
          IF(DRIFT.LT.CABER7) GO TO 280
          WMID=7.5+(DRIFT*0.1+(7.5-LAYER)*TANBET*TLTCOR)*SINA*0.5
          DDRIFT=LAYER-WMID
          DDRIFT=-LRFLAG*DELTA0(INCELL,LR12)
     -                                     *TANGAM*DDRIFT*(DRIFT-CABER7)
          DRIFT=DRIFT-DDRIFT*CABER8
 280      CONTINUE
C
C         -------------------------
C         FINALLY CALCULATE (X,Y,R)
C         -------------------------
C
 300      XHIT1=XWIRE+LRFLAG*TRLORX*DRIFT
          YHIT1=YWIRE+LRFLAG*TRLORY*DRIFT
          RHIT1=SQRT(XHIT1**2+YHIT1**2)
          IERXYF=0
          NH=RESULT(3)
          CALLMVCL(RESULT(1),0,XYZHIT(1),0,56)
          RETURN
          END

C   26/04/84 404261457  MEMBER NAME  DRAWZC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWZC( IVIEW )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY    26/04/84 :  DRAW Z CHAMBER
C
C
C     DRAW THE Z CHAMBER FOR THE VIEW IVIEW.
C       IVIEW = 1   : R PHI VIEW
C       IVIEW = 2   : RZ VIEWS
C       IVIEW = 3   : ROLLED OUT VIEW
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CJTRIG / PI,TWOPI
C-----------------------------------------------------------------------
C                            MACRO CZGEO      Z CHAMBER GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CZGEO  / RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,
     +                  ZCHSS,ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
C
C----------------------------END OF CZGEO-------------------------------
C
C
C------------------  C O D E  ------------------------------------------
C
      GO TO ( 1 , 2 , 3 ),IVIEW
C
C                            R PHI VIEW OF THE Z CHAMBER
C
  1     DEFI  = TWOPI / 24.0
        RINRZ = RZCHI / COS(0.5 * DEFI)
        RUTRZ = RZCHA / COS(0.5 * DEFI)
        BIGOF = ATAN2(100.0, RINRZ)
        WEEOF = ATAN2( 20.0, RINRZ)
C
C                            DRAW AS 4 SEPARATE QUADRANTS
C
        CALL BARSEC(    0.,    WEEOF,BIGOF,RINRZ,RUTRZ,0.,0.,6,DEFI,0.)
        CALL BARSEC(0.25*TWOPI,BIGOF,WEEOF,RINRZ,RUTRZ,0.,0.,6,DEFI,0.)
        CALL BARSEC(0.50*TWOPI,WEEOF,BIGOF,RINRZ,RUTRZ,0.,0.,6,DEFI,0.)
        CALL BARSEC(0.75*TWOPI,BIGOF,WEEOF,RINRZ,RUTRZ,0.,0.,6,DEFI,0.)
        RETURN
C
C                            RZ VIEW OF THE Z CHAMBER
C
  2   R1I    = RZCHI + ZCHA
      R2I    = RZCHI + ZCHB
      CALL RECTAN(Z1ZCH,-RZCHA,Z2ZCH,-RZCHI,0)
      CALL RECTAN(Z1ZCH, RZCHI,Z2ZCH, RZCHA,0)
C
C                            DRAW Z CHAMBER WIRES
C
      ZZZ = Z1ZCH - 0.5 * DLZZ
      DO  21  I = 1,16
        ZZZ = ZZZ + DLZZ
        CALL POINTA(ZZZ, R1I)
        CALL POINTA(ZZZ, R2I)
        CALL POINTA(ZZZ,-R1I)
        CALL POINTA(ZZZ,-R2I)
  21  CONTINUE
C
C                            DRAW Z CHAMBER WALLS
C
      ZZZ = Z1ZCH
      DO  22  I = 1,15
        ZZZ = ZZZ + DLZZ
        CALL DRAMOV(ZZZ, RZCHI,ZZZ, RZCHA,0)
        CALL DRAMOV(ZZZ,-RZCHI,ZZZ,-RZCHA,0)
  22  CONTINUE
C
      RETURN
C
C                            ROLLED OUT VIEW OF THE Z CHAMBER
C
C
C                            DRAW CHAMBER BOUNDARIES
C
   3  ADY = 1500.
      X1  =  0.
      X2  =  6. * DLZPHI
      X3  = 12. * DLZPHI
      X4  = 18. * DLZPHI
      X5  = 24. * DLZPHI
      Y1  = ADY
      Y2  = ADY + 16.*DLZZ
      CALL RECTAN(X1+ZCHDLL, Y1, X2-ZCHDL,  Y2, 0)
      CALL RECTAN(X2+ZCHDL,  Y1, X3-ZCHDLL, Y2, 0)
      CALL RECTAN(X3+ZCHDLL, Y1, X4-ZCHDL,  Y2, 0)
      CALL RECTAN(X4+ZCHDL,  Y1, X5-ZCHDLL, Y2, 0)
C
C                            DRAW CELL WALLS
C
      Y0 = Y1 - DLZZ
      DO  31  I  = 1,17
        Y0 = Y0 + DLZZ
        CALL DRAMOV(X1+ZCHDLL, Y0, X2-ZCHDL,  Y0, 0)
        CALL DRAMOV(X2+ZCHDL,  Y0, X3-ZCHDLL, Y0, 0)
        CALL DRAMOV(X3+ZCHDLL, Y0, X4-ZCHDL,  Y0, 0)
        CALL DRAMOV(X4+ZCHDL,  Y0, X5-ZCHDLL, Y0, 0)
 31   CONTINUE
C
C                            DRAW PHI-SECTOR BOUNDARIES
C
      X0 = - DLZPHI
      DO  32  I  = 1,25
        X0 = X0 + DLZPHI
        IF(MOD(I,6) .EQ. 1) GO TO 32
        CALL DRAMOV(X0,Y1,X0,Y2,14)
 32   CONTINUE
C
C                            ADD AXIS LABELLING
C
      SH3 = 0.4*DLZZ
      Y0  = ADY - 0.6*DLZPHI
      DO  33  I = 1,3
        LABT = 103+I
        X0   = (I-1) * (0.5*X5 - 0.4*DLZPHI)
        CALL RUTEXT(LABT,X0,Y0,SH3)
 33   CONTINUE
C
      X0  = -0.8*DLZPHI
      DO  34  I = 1,3
        LABT = 100+I
        Y0   = ADY + (I-1)*7.8*DLZZ
        CALL RUTEXT(LABT,X0,Y0,SH3)
 34   CONTINUE
C
      RETURN
      END

C   11/01/88 801271714  MEMBER NAME  UNITS    (S)        M  MACROFOR
C
C                            JUNITA is the event output unit number
C                                   for accepted events.
C
      PARAMETER  ( JUNITA = 2 )
C
C                            JUNITR is the event output unit number
C                                   for rejected events.
C
      PARAMETER  ( JUNITR = 3 )
C

C   29/11/78 C9021401   MEMBER NAME  LGEERR   (JADELGS)     FORTRAN
      SUBROUTINE LGEERR(IP,ENERGY,SIGENG)
C
C     S.YAMADA   29-11-78  15:50
C     LAST MODIFICATION   14-02-79   18:05
C
C----CALCULATES SIGMA OF THE LG-CLUSTER ENERGY.
C
C---- INPUTS
C     IP=0,FOR THE BARREL,  IP=+-1,FOR THE END CAP.
C     ENERGY=CLUSTER ENERGY IN GEV
C---- OUTPUT
C     SIGENG=EXPECTED SIGMA FOR THE INPUT IN GEV
C
      SIGENG = 0.
      IF(ENERGY.LT.0.) RETURN
C
      IF(ENERGY.GT.2.8) GO TO 1
      SIG = 0.058*SQRT(ENERGY)
      GO TO 2
    1 SIG = 0.035*ENERGY
    2 IF(IP.NE.0) SIG = 2.0*SIG
      SIGENG = SIG
      RETURN
      END

C   01/11/84 807241309  MEMBER NAME  CIRDIS   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE CIRDIS(NN,CURV,RMIN,PHM,XB,YB,XE,YE,A,B,ITYP,XCE,YCE)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON    1/03/79 :  DRAW A CIRCLE SEGMENT
C
C       MOD:   J. OLSSON   10/02/84 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 22/10/84 :  FOR COMMAND VC
C       MOD:   C. BOWDERY   9/08/85 :  FIX CDTL 23 (LG EXTRAPOLATION)
C       MOD:   J. HAGEMANN 10/12/85 :  CORRECT TRACK NUMBER DISPLAY
C       MOD:   J. HAGEMANN 14/04/86 :  CORRECT DISPLAY OF TRACKS IN
C                                      MAGNIFIED VRX VIEW
C       MOD:   J. HAGEMANN 24/11/86 :  DASHED DISPLAY OF COMFIT-TRACKS
C       MOD:   J. HAGEMANN 05/06/87 :  DUE TO UPDATE OF STANDARD CIRDIS
C  LAST MOD:   J. HAGEMANN 27/10/87 :  FOR VRX VIEW
C
C        DRAWS A CIRCLE SEGMENT FROM XB,YB TO XE,YE OF THE CIRCLE WITH
C        PARAMETERS CURV,RMIN,PHM.    NN IS THE SEGMENTATION OF THE
C        POLYGON APPROXIMATION.
C        XCE,YCE IS THE POINT TO WHICH CLOSEST APPROACH IS FOUND
C        THE CIRCLE IS "PROJECTED" ACCORDING TO THE Z-COORDINATE, TO
C        AGREE WITH THE PERSPECTIVE "CYLINDER" VIEW.
C        THE Z-COORDINATE IS GOTTEN FROM THE R-Z FIT:  Z = A + B*R
C                        OR FROM THE Z-FI(HELIX) FIT:  Z = A + B*FI
C
C        IF DSPDTL(19) = TRUE, TRACKS ARE PROLONGED TO CLOSEST APPROACH
C                              TO ORIGIN.
C        IF DSPDTL(23) = TRUE, TRACKS ARE PROLONGED TO TOF OR LEAD GLASS
C                              RADIUS LIMIT.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FLVCDO
      LOGICAL TBIT
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C-----------------------------------------------------------------------
C                            MACRO CGRSCL .... GRAPHICS VIEW SCALES
C-----------------------------------------------------------------------
C
      COMMON  / CGRSCL / XMINST(30), XMAXST(30), YMINST(30)
C
C------- END OF MACRO CGRSCL -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CGVCDO / FLVCDO(20)
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
      COMMON / CVCPV  / ICD, DFX, DFY, IRC
      COMMON / CHEADR / HEAD(108)
C
      DATA  ZDEEP / 5800.0 /
C     DATA  MUMAX,MUMAYP,MUMAYN / 3320.,3320.,-3020./
C
C------------------  C O D E  ------------------------------------------
C
C                            IS THE CURVATURE TOO SMALL?
C
      IF( ABS(CURV) .GT. 1.0E-08 ) GO TO 10
        CALL TRMOUT(44,'Curvature zero encountered in circle display')
        RETURN
C
  10  RAD  = ABS( 1.0/CURV )
      YC   = RAD + RMIN
      XC   = YC*COS(PHM)
      YC   = YC*SIN(PHM)
      RTS  = RLG
      ZZPL = ZLGPL
      ZZMI = ZLGMI
      IF( LASTVW .EQ.  1 ) RTS  = RTOF
      IF( LASTVW .EQ. 17 ) RTS  = 0.33*(XMAX-XMIN)
      IF( LASTVW .EQ. 17 ) ZZPL = RTS
      IF( LASTVW .EQ. 17 ) ZZMI = RTS
      RDT = ABS(XMAX-XMIN)/ABS(XMAXST(20)-XMINST(20))
      IF( RDT .LT. 0.5 ) RDT = 1.0
      IF( LASTVW .EQ. 20 ) RTS = R1ROH*RDT*1.1
      XRV = 0.0
      YRV = 0.0
      IF( .NOT.FLVCDO(11) .OR. LASTVW.NE.17 ) GO TO 5
         CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) !PMF 08/11/99: add run argument HEAD(18)
    5 CONTINUE
C--
      PHMIT = ATAN2(YC-YCE,XC-XCE)
      FI1   = PHMIT - PI
      IF( .NOT.DSPDTL(19) .AND. LSTCMD.NE.52 ) FI1 = ATAN2(YB-YC,XB-XC)
      FI2   = ATAN2(YE-YC,XE-XC)
      IF( FI1 .LT. -PI) FI1 = FI1 + TWOPI
      FIB = FI1
      ARC = ARCMIN(FI2-FI1)
      IF( ARC*CURV .GT. 0.0 ) ARC = SIGN(TWOPI-ABS(ARC),-ARC)
      DEFI = ARC/NN
      IF( LASTVW.GE.17 .AND. LASTVW.LE.19 ) DEFI = DEFI * .01
      XP = - XC - RAD*COS(FI1)
      YP = YC + RAD*SIN(FI1)
      RP = SQRT(XP*XP + YP*YP)
      IF( ITYP .EQ. 1 ) GO TO 233
C        FIHEL = FI1
C        IF( FIHEL .LT. 0.0 ) FIHEL = FIHEL + TWOPI
C        FIHEL = ABS(FIHEL - FIHEL1) - FISTRT
C        ZP    = B*FIHEL + A
C        ZDEL  = B*ABS(DEFI)
C        GO TO 235
233   ZP = A + B*RP
235   IF( LASTVW .NE. 14 ) GO TO 499
         FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
         XP = FP*XP
         YP = FP*YP
499   CALL MOVEA(XP,YP)
      DO 501  I = 1,NN
         FI1 = FI1 + DEFI
         XP  = - XC - RAD*COS(FI1)
         YP  =   YC + RAD*SIN(FI1)
         RP  = SQRT(XP*XP + YP*YP)
C                          /  (-XP-XRV)**2 = (XP+XRV)**2
         RP1 = SQRT((XP+XRV)**2 + (YP-YRV)**2)
         ZP = A + B*RP
237      IF( LASTVW .NE. 14 ) GO TO 507
            FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
            XP = FP*XP
            YP = FP*YP
507      CONTINUE
         IF( LASTVW .NE. 20 ) GO TO 502
             IF( RP1 .LT. 35.0 .OR. RP1 .GT. 75.0 ) GO TO 502
                XTN = XP
                YTN = YP
502      CONTINUE
         IF( RP1 .GT. RTS ) GO TO 508
         IF(.NOT.TBIT(ICD,15) .OR. (TBIT(ICD,15).AND..NOT.FLVCDO(10)) )
     *                                        CALL DRAWA(XP,YP)
         IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .LT. 0 )
     *                                        CALL DRAWA(XP,YP)
         IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .GE. 0 )
     *                                        CALL DASHA(XP,YP,34)
501   CONTINUE
508   CONTINUE
      IF( LASTVW.NE.20 ) CALL TRNUMB(ITR,0,-XP,YP,ZP)
      IF(LASTVW.EQ.20.AND.TBIT(ICD,14)) CALL TRNUMB(ITR,0,-XTN,YTN,ZP)
      IF(LASTVW.EQ.20.AND..NOT.TBIT(ICD,14)) CALL TRNUMB(ITR,0,XB,YB,ZP)
C
      CALL MOVEA(XP,YP)

      IF(.NOT.DSPDTL(23) .OR. LASTVW.GT.16)  RETURN
C
C                            EXTENSION TO TOF OR PBG LIMIT
C
      IFLGX = 0
      NNN   = 0
      R2    = RP
      Z2    = ZP
551   FI1   = FI1 + DEFI
      NNN   = NNN + 1
      IF( NNN.GT.200 .OR. ABS(ARCMIN(FI1-PHM)).LT.ABS(DEFI) ) RETURN
555   XP = - XC - RAD*COS(FI1)
      YP =   YC + RAD*SIN(FI1)
      RP = SQRT(XP*XP + YP*YP)
      IF( RP .LT. RITNK ) RETURN
C     IF( ITYP .EQ. 1 ) GO TO 238
C        ZP = ZP + ZDEL
C        GO TO 239
238   ZP = A + B*RP
239   IF( IFLGX .NE. 0 ) GO TO 553
CHECK LIMITS
         IF( ABS(ZP) .LT. ZZPL ) GO TO 554
            IFLGX = 1
            FAT   = ABS((ABS(ZP) - ZLGPL)/(ZP - Z2))
552         FI1   = FI1 - FAT*DEFI
C           IF( ITYP .EQ. 2 ) ZDEL = -FAT*ZDEL
            GO TO 555
554      IF( RP .LT. RTS ) GO TO 553
            IFLGX = 2
            FAT   = (RP-RTS)/(RP-R2)
            GO TO 552
553   IF( LASTVW .NE. 14 ) GO TO 557
            FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
            XP = FP*XP
            YP = FP*YP
557   R2 = RP
      Z2 = ZP
      IF(.NOT.TBIT(ICD,15) .OR. (TBIT(ICD,15).AND..NOT.FLVCDO(10)) )
     *                                        CALL DRAWA(XP,YP)
      IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .LT. 0 )
     *                                        CALL DRAWA(XP,YP)
      IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .GE. 0 )
     *                                        CALL DASHA(XP,YP,34)
      IF(IFLGX.EQ.0) GO TO 551
      IF(IFLGX.EQ.1) CALL PLYGON(6,10.,XP,YP,0)
      RETURN
      END
C*****************************
      FUNCTION ARCMIN(A)
C
C THIS IS A ROUTINE USED IN PLUTO PATREC. IT FINDS THE SHORTEST ARC
C     BETWEEN TWO ANGLES.
C
      COMMON/CJTRIG/ PI,TWOPI
C
      ARCMIN=A
      IF (ABS(A).LE.PI) GOTO 2
      ARCMIN=AMOD (A+5.*PI,TWOPI)-PI
    2 RETURN
      END
      DOUBLE PRECISION FUNCTION DRCMIN(AA)
      COMMON/CJTRIG/ PI,ZWEIPI
      REAL*8 AA
      DRCMIN=AA
      IF (DABS(AA).LE.PI) GOTO 3
      ARGUM = AA + 2.*ZWEIPI + PI
      DRCMIN=AMOD (ARGUM,ZWEIPI)-PI
    3 RETURN
      END

C   24/10/83 402220043  MEMBER NAME  MCHTRB   (JADEGS)      FORTRAN
C   24/10/83 402220031  MEMBER NAME  MCHTRB   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCHTRB( I4VECT, NFOUND, P9VECT, IPALL, IFLAVR,IQG, IPN)
C-----------------------------------------------------------------------
C
C   AUTHOR    C. BOWDERY  19/10/83 :  TRACEBACK FROM 'VECT' TO 'PALL'
C
C        MOD  C. BOWDERY  26/10/83 :  P9VECT(30,9) --> P9VECT(9,30)
C   LAST MOD  C. BOWDERY  22/02/84 :  BUG IN DO 22 FIXED
C
C
C   GIVEN A 'VECT'/0 PARTICLE NUMBER, I4VECT, LOCATE IDENTICAL ENTRY
C   IN 'PALL' BANK AND TRACE BACKWARDS TO FIND ITS ANCESTOR PARTICLES.
C
C   INPUT:  I4VECT      =  'VECT'/0 PARTICLE NUMBER
C   OUTPUT: NFOUND      =  NUMBER OF 9-VECTORS TRACED IN 'PALL'
C           P9VECT      =  ARRAY OF 9 VECTORS FOR TRACED PARTICLES
C           IPALL       =  ARRAY OF POSITIONS IN 'PALL' FOR EACH 9-VECT
C           IFLAVR      =  QUARK FLAVOUR OF THE EVENT (IF APPROPRIATE)
C           IQG         =  POSITION OF PARTON IN P9VECT
C           IPN         =  PARTON ORDER NUMBER ( 1 = 1ST PARTON ETC.)
C
C-----------------------------------------------------------------------
C
C        THE 9-VECTORS ARE THE FOLLOWING:
C
C  PX, PY, PZ, E, M, CHARGE, TYPE, PARENT_IN_PALL, PARTON_NUMBER
C
C  ALL THESE QUANTITIES ARE REAL*4
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cmubcs.for"
C
      DIMENSION  P9VECT(9,30), PP(5), PV(5), IPALL(30)
C
      DATA IEFL, IEFL2, IEFL3 / 0 , 0 , 0 /
C
C-------------------  C O D E  -----------------------------------------
C
C                  INITIALISE OUTPUT VALUES TO ZERO
C
      IPN    = 0
      IQG    = 0
      IFLAVR = 0
      CALL VZERO( P9VECT, 270 )
      CALL VZERO( IPALL ,  30 )
C
C                  FIND 'VECT'/0 AND 'PALL' BANKS. RETURN IF NOT THERE.
C
      CALL CLOC( INDV, 'VECT', 0 )
      NFOUND = -1
      IF( INDV .LE. 0 ) RETURN
C
      CALL CLOC( INDP, 'PALL', 0 )
      NFOUND = -2
      IF( INDP .LE. 0 ) RETURN
C
C                  CHECK RANGE OF INPUT 'VECT'/0 PARTICLE NUMBER
C
      NFOUND = -3
      MAXPRT = IDATA( INDV + 4 )
C
      IF( I4VECT .LE. MAXPRT .AND. I4VECT .GE. 1 ) GO TO 1
        IEFL3 = IEFL3 + 1
        IF(IEFL3 .GT. 50 ) RETURN
C
          WRITE(6,5) I4VECT, MAXPRT
  5       FORMAT(/' ***  ERROR  ***  I4VECT ( = ',I3,') IS EITHER ',
     +    'GREATER THAN MAX_PARTICLE_NO. ',
     +    '( = ',I3,') OR LESS THAN 1  IN MCHTRB'/)
          RETURN
C
C                  COMPUTE POINTERS TO 'VECT' AND 'PALL'
C
  1   NFOUND = 0
      LV0    = IDATA( INDV + 1 )
      LV1    = IDATA( INDV + 2 )
      INDEXV = INDV + LV0 + (I4VECT-1) * LV1
C
      LP0    = IDATA( INDP + 1 )
      LP1    = IDATA( INDP + 2 )
C
C                  EXTRACT INFORMATION FOR THE TRACK FROM 'VECT'/0
C
      DO  10  I = 1,5
        PV(I) = ADATA( INDEXV + I )
  10  CONTINUE
      IQV   = IDATA( INDEXV + 6 )
      ITV   = IABS( IDATA( INDEXV + 7 ) )
C
      NPALL = IDATA( INDP + 4 )
C
C                  SEARCH FOR AN EXACT MATCH BETWEEN THE GIVEN PARTICLE
C                  IN 'VECT'/0 AND 'PALL'.
C
      DO  22  J = 1,NPALL
        DO  20  I = 1,5
          INDEXP = INDP + LP0 + (NPALL-J) * LP1
          PP(I) = ADATA( INDEXP + I )
          IF( PP(I) .NE. PV(I) ) GO TO 22
  20    CONTINUE
        IQP = IDATA( INDEXP + 6 )
        ITP = IDATA( INDEXP + 7 )
        IF( IQP .NE. IQV .OR. IABS( ITP ) .NE. ITV ) GO TO 22
C
C                  WE HAVE A MATCH - EXIT THE OUTER LOOP
C
        GO TO 30
  22  CONTINUE
C
C                  NO MATCH FOUND - PROBABLY A 'PALL' BANK OF AN OLD
C                  4-VECTOR EVENT NOT CONFORMING TO THE CONVENTION.
C
      IEFL   = IEFL + 1
      IF( IEFL .GT. 100 ) RETURN
        WRITE(6,35) I4VECT
  35    FORMAT(/' *** WARNING ***  MCHTRB FOUND NO MATCH FOR ''VECT''/',
     +    '0 TRACK ',I4,' IN THE ''PALL'' BANK.'/)
        RETURN
C
C                  RECORD DETAILS OF ORIGINAL PARTICLE
C
  30  IPALL(1) = NPALL - J + 1
      DO  40  I = 1,5
        P9VECT(I,1) = PP(I)
  40  CONTINUE
      P9VECT(6,1) = FLOAT( IQP )
      P9VECT(7,1) = FLOAT( ITP )
      P9VECT(8,1) = FLOAT( IDATA( INDEXP + 8 ) )
      P9VECT(9,1) = FLOAT( IDATA( INDEXP + 9 ) )
C
C                  STORE PARTON ORDER NUMBER AND EVENT FLAVOUR
C                  THEN FIND THE PARENT POINTER
C
      IPN       = IDATA( INDEXP + 9 )
      IPARNT    = IDATA( INDEXP + 8 )
      NFOUND    = 1
      IFLAVR    = IDATA( INDP + 9 )
C
C                  LOCATE IN 'PALL' THE PARENT AND ANCESTORS
C
  60  IF( IPARNT .EQ. 0 ) GO TO 70
      INDEXP = INDP + LP0 + (IPARNT-1) * LP1
      NFOUND = NFOUND + 1
      IF( NFOUND .GT. 30 ) GO TO 80
      IPALL(NFOUND) = IPARNT
      DO  50  I = 1,5
        P9VECT(I,NFOUND) = ADATA( INDEXP + I )
 50   CONTINUE
C
      DO  55  I = 6,9
        P9VECT(I,NFOUND)   = FLOAT( IDATA( INDEXP + I ) )
 55   CONTINUE
      IPARNT = IDATA( INDEXP + 8 )
      GO TO 60
C
C                  ALL PARTICLES TRACED. FIND THE PARTON. IQG = 0  IF
C                  NOT FOUND, OTHERWISE IQG = POSITION NUMBER.
C
  70  DO  71  I = 1,NFOUND
        IF( P9VECT(9,I) .NE. -100 ) GO TO 71
          IQG = I
          RETURN
  71  CONTINUE
C
      RETURN
  80  IEFL2 = IEFL2 + 1
      IF( IEFL2 .GT. 100 ) RETURN
        WRITE(6,81)
  81    FORMAT(/' ***  ERROR  ***  MCHTRB: > 30 PARTICLES IN TRACEBACK',
     +          ' OR PARENT POINTER NOT SET TO ZERO AT END OF CHAIN'/)
        RETURN
      END

C   12/01/88 801121139  MEMBER NAME  TPTFI1   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTFI1( ANALYS )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      12/01/88:  Get instructions about TOFINT
C
C
C
C
C     Routine to provide yes/no answer about need for TOF analysis.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     ANALYS    Out      L*4      TRUE if analysis step is to be done
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  TOF*8, CIFND*20, CANALY*20

      LOGICAL  ANALYS, ANAL, IFND, FIRST

#include "bosdata.for"

      INTEGER  ITOFR

      SAVE  FIRST, ANAL, IFND

      DATA  FIRST / .TRUE. /
      DATA  TOF   / 'TOF'  /, CIFND  / 'IFNOTDONE' /
      DATA                    CANALY / 'ANALYSE'   /

C------------------  C O D E  ------------------------------------------

C                            If not first call, ANAL/IFND already SAVEd.

      IF( FIRST ) THEN

C                            Get user option relating to TOF analysis
C                            that is, ANALYSE & IFNOTDONE

        CALL TPUOPT( TOF, CANALY, ANAL )
        CALL TPUOPT( TOF, CIFND,  IFND )

        FIRST = .FALSE.

      ENDIF

      IF( ANAL ) THEN

        ANALYS = .TRUE.

        IF( IFND ) THEN

C                            Find the TOFR bank if present. No analysis
C                            is needed if it is as IFNOTDONE was option.

          ITOFR = IDATA( IBLN('TOFR') )

          IF( ITOFR .GT. 0 ) THEN

            ANALYS = .FALSE.

          ENDIF

        ENDIF

      ELSE

        ANALYS = .FALSE.

      ENDIF

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   09/07/85 508031514 MEMBER NAME  HLPMAC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE HLPMAC( ICMD , CHARS, LEN )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   3/08/85 :  GIVE HELP FOR MACROS
C
C
C     FROM  ICMD, THE COMMAND NUMBER, THE MACRO NUMBER IS DETERMINED
C     AND THE CORRESPONDING MACRO DEFINITION IS FOUND AND DISPLAYED
C     ON THE SCREEN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CDEF
      LOGICAL*1  CHARS(LEN)
C
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
C-------------------  C O D E  -----------------------------------------
C
      CALL CLRCON
C
      IMAC = ICMD - MACSTA
      WRITE(6,10) (CHARS(K),K=1,LEN)
  10  FORMAT(/' Macro:        ',8A1)
      WRITE(6,20) (CDEF(K,IMAC),K=1,80)
  20  FORMAT(/' The current definition of this macro is:'//
     +       1X,80A1/)
      RETURN
      END

C   20/12/85 807251626  MEMBER NAME  TRTEXT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRTEXT(IPPATR,IPP,XXX,YYY,SSS) 
C-----------------------------------------------------------------------
C
C     WRITE INFORMATION FROM BANK 'PATR' FOR ONE TRACK, GIVEN BY IPO,IPP
C     POSITION AND SIZE OF TEXT GIVEN BY XXX,YYY,SSS
C          J.OLSSON,  19.10.79           LAST CHANGE 28.01.80
C            LAST CHANGE 15.01.88  J. HAGEMANN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      COMMON /CHEADR/ HEAD(108)
      COMMON /CJTRIG/ PI,TWOPI
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
     $,PMOM,PZ,PTRANS,RMS,NHTF,RAD,RAD1,THE,PHI,DUM(6),HSIGN,HDUM,NTRRES
     $,IW52
C
      DATA HBLANK/'  '/, HPLUS/'+ '/,HMINUS/'- '/
      DATA HPLCFT/'+¢'/, HMICFT/'-¢'/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      ITR   = IDATA(IPP + 1)
      IF(DSPDTL(14).AND.NTRRES.NE.ITR.AND.NTRRES.NE.0) GO TO 7722
      HSIGN = HBLANK
      RMS   = ADATA(IPP + 23)
      RMSZ  = ADATA(IPP + 32)
      NHTF  = IDATA(IPP + 24)
      NHTZ  = IDATA(IPP + 33)
      NBK   = IDATA(IPPATR-2)
      IF(NBK.EQ.12) RMS = RMS/NHTF
      LTR   = IDATA(IPPATR + 3)
      CALL MOMENT(IPP,PX,PY,PZ,PTRANS,PMOM,FI,THE)
      RAD = ADATA(IPP+25)
      IF( LTR .LT. 64 ) GOTO 641
         ICD = IDATA(IPP + 2)
         IRC  = -100
         IF( ICD .EQ. 301 ) ICD = 65536
         VERVAL = -100.0
         IF( LTR .GT. 62 ) VERVAL = ABS(ADATA(IPP+51))
         IF(TBIT(ICD,19) .AND. LTR.EQ.64 .AND. VERVAL.GT.0.01)
     *                     ICD = IBITON(ICD,15)
         IF( TBIT(ICD,15) .AND. LTR .GE. 64 ) IRC = IDATA(IPP + 62)
         IF(.NOT.TBIT(ICD,15) .OR. IRC.NE.0) GOTO 641
            HSIGN = HPLCFT
            IF(RAD*BKGAUS.LT.0.) HSIGN = HMICFT
            GOTO 642
 641  CONTINUE
         HSIGN = HPLUS
         IF(RAD*BKGAUS.LT.0.) HSIGN = HMINUS
 642  CONTINUE
C** WRITE OUT VALUES
      IF( .NOT. DSPDTL(13) ) GO TO 7544
      FI = FI*180./PI
      CALL CORE(HWORK,80)
      WRITE(cHWORK,221) ITR,HSIGN,RMS,NHTF,RMSZ,NHTZ,FI! PMF 17/11/99: UNIT=10 changed to cHWORK
221   FORMAT(I2,1X,A2,1X,F4.2,'/',I2,1X,F5.1,'/',I2,1X,F5.1)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
7722  YYY = YYY - 1.5*SSS*.75 !PMF 20/11/99: add factor .75
      IF(DSPDTL(14).AND.NTRRES.NE.ITR.AND.NTRRES.NE.0) GO TO 7723
      COSTH = COS(THE)
      CALL CORE(HWORK,80)
      WRITE(cHWORK,222) PMOM,PZ,PTRANS,COSTH ! PMF 17/11/99: UNIT=10 changed to cHWORK
222   FORMAT(F6.3,1X,F7.3,1X,F6.3,1X,F6.3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
7723  YYY = YYY - 2.*SSS*.75 !PMF 20/11/99: add factor .75
7544  RETURN
      END

C   26/07/83 308051411  MEMBER NAME  MUFHIT   (S)           FORTRAN77
C-----------------------------------------------------------------------
      SUBROUTINE MUFHIT(PHI,ALLOW,NUMHF)
C-----------------------------------------------------------------------
C
C        NAME:      MUFHIT
C        VERSION:   1.0
C        LANGUAGE:  FORTRAN 77
C        WRITTEN:   27/07/83              C. BOWDERY
C
C        THIS ROUTINE SEARCHES FOR MUON HITS IN LAYER 1 OF THE FILTER
C        WITHIN + /- 'ALLOW' DEGREES AROUND A  DIRECTION SPECIFIED BY
C        THE ANGLE 'PHI'. THE NUMBER FOUND IS RETURN IN 'NUMHF'.
C        NOTE: IF NO MUON BANKS EXIST, 'NUMHF' = -1 ON EXIT.
C
C        INPUT:     PHI         THE PHI ANGLE OF JADE(IN DEGREES)
C                   ALLOW       THE PLUS AND MINUS ANGULAR RANGE
C        OUTPUT:    NUMHF       THE NUMBER OF LAYER 1 MUON HITS FOUND
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      LOGICAL FIRST
C
C                  BCS -- BOS COMMON.
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION    HDATA(80000),ADATA(40000)
      EQUIVALENCE (HDATA(1),IDATA(1))
      EQUIVALENCE (ADATA(1),IDATA(1))
C
C-----------------------------------------------------------------------
C
C             FIRST CHECK TO SEE IF 'MUR1' BANKS EXIST. IF NOT, CREATE
C             THEM.
C
      NUMHF = 0
      FIRST = .TRUE.
 1    CALL CLOC(MUR10,'MUR1',0)
      CALL CLOC(MUR11,'MUR1',1)
C
      IF(MUR10.EQ.0 ) THEN
        IF(FIRST) THEN
          CALL MUANAC
          FIRST = .FALSE.
        ELSE
C                                      SET ERROR & RETURN
          NUMHF = -1
          RETURN
        ENDIF
      ELSE IF (MUR11.EQ.0) THEN
C                                      NO MUR1/1 BANK SO RETURN
        RETURN
      ENDIF
C
      IF( .NOT. FIRST) GO TO 1
C
C            LOOP OVER ALL MUON HITS:    NHITS = NUMBER OF HITS
C                                        NWHIT = NO. OF HALF WORDS/HIT
      NHITS = IDATA(MUR10 + 1)
      NWHIT = IDATA(MUR10 + 3)
C
      DO  2  I = 1,NHITS
        IP    = MUR11*2 + (I-1)*NWHIT
C                                        2 HALF WORD IS 10*LAYER + ORI.
        LAYER = HDATA(IP + 2) / 10
        IF(LAYER .NE. 1) GO TO 2
C                                        FIND X & Y OF LEFT AMBIGUITY
          XL = HDATA(IP + 3)
          YL = HDATA(IP + 4)
C                                        FIND PHI OF THIS COORDINATE
C
          PHIL = ATAN2(YL,XL) * 180.0 / 3.14159
          IF(PHIL .LT.0 ) PHIL = PHIL + 360.0
C
C                                        REPEAT FOR RIGHT AMBIGUITY
          XR = HDATA(IP + 6)
          YR = HDATA(IP + 7)
C
          PHIR = ATAN2(YR,XR) * 180.0 / 3.14159
          IF(PHIR .LT.0 ) PHIR = PHIR + 360.0
C
C                  IS EITHER AMBIGUITY WITHIN ALLOWED ANGULAR REGION?
C                  IF YES, THEN INCREMENT HIT FOUND COUNTER.
C
          ALLW = ABS(ALLOW)
          IF( ABS(PHIL-PHI) .LT. ALLW  .OR. ABS(PHIR-PHI) .LT. ALLW)
     &           THEN
             NUMHF = NUMHF + 1
          ENDIF
C
  2   CONTINUE
C
      RETURN
      END

C   28/05/82 206291134  MEMBER NAME  MUCONE   (JADEMUS)     FORTRAN
C   27/05/82 205271450  MEMBER NAME  MUCONE   (S)           FORTRAN
C   27/10/81 110271005  MEMBER NAME  MUCONE   (JADEMUS1)    FORTRAN
C   23/10/81 110231703  MEMBER NAME  MUCONE   (S)           FORTRAN
C   17/06/81 106170952  MEMBER NAME  MUCONE   (JADEMUS1)    FORTRAN
C   12/06/81 106151023  MEMBER NAME  MUCONE   (S)           FORTRAN
C   23/09/80 104100731  MEMBER NAME  MUCONE   (JADEMUS)     FORTRAN
C   26/09/79 C9092601   MEMBER NAME  MUCONE   (S)           FORTRAN
C LAST CHANGE 11.40 29/06/82 HUGH MCCANN  - ADD /CMUED/ .
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C      CHANGE 10.00 27/10/81 HUGH MCCANN  - CORRECT BUG.
C      CHANGE 08.55 12/06/81 HUGH MCCANN  - TO ACCOM NEW JADE SYSTEM.
C      CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C      CHANGE 19.39 23/09/80 J.ALLISON - TO ADD ACTW.
C      CHANGE 21.07 20/09/79 HARRISON PROSPER
      SUBROUTINE MUCONE(LUNMUE,IPRINT,IFLAG)
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C
C EDITS MUON CALIBRATION DATA.
C UNLESS LUNMUE=0, READS EDITS FROM LOGICAL UNIT LUNMUE IN /CUNIT/.
C PRINTING SUPRESSED IF IPRINT.LT.2.
C FULL PRINTING IF IPRINT.GE.10.
C THE MODIFIED HMUCAL VALUES & THEIR ADDRESSES ARE SAVED IN /MUED/
C IF IFLAG=0 .IF A COMPLETE NEW SET OF CALIBRATION IS WANTED,
C PUT IFLAG=1 .
C
C-----------------------------------------------------------------------
C
C COMMONS.
#include "cmucalib.for"
#include "cmuedwrk.for"
#include "cmued.for"
C
C-----------------------------------------------------------------------
C
C DATA INITIALISATIION STATEMENTS,ETC.
C
      DIMENSION CMNT(10)
C
      DIMENSION AQ(20)
      DATA AQ/'OVAL','DIST','ANG ','CLLO','CLHI','CTLO','CTHI',
     * 'D1  ','CTW ','VDR ','DTP ','LTP ','LSF ','MCST',
     * 'BLLO','BLHI','BTLO','BTHI','BNLM','ACTW'/
      DATA NQ/20/
C
C-----------------------------------------------------------------------
C
      IF(IPRINT.LT.10)CALL MUMESS('MUCONE',0,'CALLED.^')
      IF(IPRINT.LT.10)CALL MUMESS('MUCONE',NVERSN,DESCRP)
C
C-----------------------------------------------------------------------
C
      IF(IPRINT.LT.10)GO TO 1
      WRITE(6,100)NQ,(AQ(I),I=1,NQ)
 100  FORMAT('1MUCONE CALLED TO EDIT MU CALIBRATION DATA.'/
     * '0THE FOLLOWING DATA CAN BE CHANGED BY SPECIFYING IN COLUMNS 1-4.
     *'/
     *'0',20A5/(20A5))
      WRITE(6,101)
 101  FORMAT('0FIRST GIVE NEW VERSION NUMBER AND DESCRIPTION (TERMINATED
     * WITH ''^'') IN FORMAT(I5,5X,15A4).'/
     *'0THE CHANGES ARE SPECIFIED BY...'/
     *' WHICH,I1,I2,I3,INEW IN FORMAT(A4,1X,3I5,I10).  E.G.'/
     *' DIST     5    7          -2378 SPECIFIES THAT THE NORMAL DISTANC
     *E TO FRAMES 5-7 IS TO BE CHANGED TO -2378.'/
     *'0DEFAULTS ARE AS FOLLOWS...'/
     *'   I1   I2   I3   IFRCH1 IFRCH2 IHIT1 IHIT2'/
     *'    L    M    0       L      M     1     4'/
     *'    L    M    N       L      M     N     N'/
     *'    L    0            L      L'/
     *'    0                 1    ALL'/
     *' WHERE IFRCH1,IFRCH2 ARE THE FIRST AND LAST FRAME (OR CHAMBER, OR
     * FACE) NUMBERS,'/
     *' AND IHIT1,IHIT2 ARE THE FIRST AND LAST HIT (OR BLOCK BOUNDARY) N
     *UMBERS WHENEVER AND/OR WHICHEVER IS RELEVENT.')
 1    CONTINUE
C
C-----------------------------------------------------------------------
C
C READ NEW VERSION DESCRIPTION.(TERMINATE WITH ^.)
      IF(IPRINT.GE.2)WRITE(6,106)NVERSN,DESCRP
 106  FORMAT('0OLD VERSION',I6,5X,15A4)
      IF(LUNMUE.EQ.0)GO TO 98
      READ(LUNMUE,200,END=98)I1,DESCRP
 200  FORMAT(I5,5X,15A4)
      IF(I1.LE.0)GO TO 15
      NVERSN=I1
      GO TO 16
 15   CONTINUE
      NVERSN=NVERSN+1
 16   CONTINUE
      IF(IPRINT.GE.2)WRITE(6,102)NVERSN,DESCRP
 102  FORMAT('0NEW VERSION',I6,5X,15A4)
C
C-----------------------------------------------------------------------
C
C PRINT HEADING.
      IF(IPRINT.GE.2)WRITE(6,103)
 103  FORMAT('0NAME      I1     I2     I3 IFRCH1 IFRCH2  IHIT1  IHIT2
     *   INEW')
C
C-----------------------------------------------------------------------
C
C READ EDIT CARDS.
 4    CONTINUE
      READ(LUNMUE,201,END=99)WHICH,I1,I2,I3,INEW,CMNT
 201  FORMAT(A4,1X,3I5,I10,10A4)
      IFRCH1=1
      IHIT1=1
      IHIT2=4
C
C FIND WHICH ONE.
      DO 5 I=1,NQ
      IF(WHICH.EQ.AQ(I))GO TO 6
 5    CONTINUE
      IF(IPRINT.GE.1)WRITE(6,105)WHICH,I1,I2,I3,INEW,CMNT
 105  FORMAT(1X,A4,1X,3I7,28X,I10,10A4)
      CALL MUERRY('MUCONE',0,'UNRECOGNISED EDIT CARD.^')
      GO TO 4
C
C-----------------------------------------------------------------------
C
C EDIT RECOGNISED.
 6    CONTINUE
      IALPH=I
      IF(I1.NE.0)GO TO 11
C
C I1.EQ.0 - SET IFRCH2 ACCORDINGLY.
      GO TO (7,8,8,8,8,8,8,9,9,9,9,9,9,9,10,10,10,10,10,9),I
 7    CONTINUE
      IFRCH2=5
      GO TO 12
 8    CONTINUE
      IFRCH2=NFRAMS
      GO TO 12
 9    CONTINUE
      IFRCH2=NCHAMS
      GO TO 12
 10   CONTINUE
      IFRCH2=6
      IHIT2=6
      GO TO 12
C
C I1.NE.0 - SET IFRCH2 ACCORDINGLY.
 11   CONTINUE
      IFRCH1=I1
      IFRCH2=I2
      IF(I2.LE.0)IFRCH2=I1
C
C SET NUMBER OF HITS IN CASE REQUIRED.
 12   CONTINUE
      IF(I3.EQ.0)GO TO 13
      IHIT1=I3
      IHIT2=I3
C
 13   CONTINUE
      IF(IPRINT.GE.2)WRITE(6,104)WHICH,I1,I2,I3,IFRCH1,IFRCH2,
     * IHIT1,IHIT2,INEW,CMNT
 104  FORMAT(1X,A4,1X,7I7,I10,10A4)
C
C-----------------------------------------------------------------------
C
C EXECUTE EDITS.
 14   CONTINUE
      GO TO (1001,1002,1003,1004,1005,1006,1007,1008,1009,1010,
     * 1011,1012,1013,1014,1015,1016,1017,1018,1019,1020),I
 1000 CONTINUE
      CALL MUMESS('MUCONE',I,'EDIT NOT IMPLEMENTED.^')
      GO TO 4
C
C-----------------------------------------------------------------------
C
C OVERALL JADE UNIT DISPLACEMENTS.
 1001 CONTINUE
      DO 2001 I=IFRCH1,IFRCH2
      HOVALL(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2001 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C ORIGIN TO MEAN CHABER PLANE DISTANCE.
 1002 CONTINUE
      DO 2002 I=IFRCH1,IFRCH2
      HDIST(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2002 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C ANGULAR TWIST OF CHAMBERS.
 1003 CONTINUE
      DO 2003 I=IFRCH1,IFRCH2
      HANG(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2003 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C LOWER LONGITUDINAL SENSITIVE REGION LIMITS.
 1004 CONTINUE
      DO 2004 I=IFRCH1,IFRCH2
      HCLLO(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2004 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C UPPER LONGITUDINAL SENSITIVE REGION LIMITS.
 1005 CONTINUE
      DO 2005 I=IFRCH1,IFRCH2
      HCLHI(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2005 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C LOWER TRANSVERSE SENSITIVE REGION LIMITS.
 1006 CONTINUE
      WRITE(6,2006)
 2006 FORMAT(' **** CTLO AND CTHI FIXED UP AUTOMATICALLY ****')
      GO TO 4
C
C-----------------------------------------------------------------------
C
C UPPER TRANSVERSE SENSITIVE REGION LIMITS.
 1007 CONTINUE
      WRITE(6,2006)
      GO TO 4
C
C-----------------------------------------------------------------------
C
C OFFSET FROM FRAME MEDIAN PLANE.
 1008 CONTINUE
      DO 2008 I=IFRCH1,IFRCH2
      HD1(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2008 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C WIRE COORDINATE.
 1009 CONTINUE
      DO 2009 I=IFRCH1,IFRCH2
      HCTW(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2009 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C DRIFT VELOCITY.
 1010 CONTINUE
      DO 2010 I=IFRCH1,IFRCH2
      HVDRFT(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2010 CONTINUE
C
C MAKE OLD HVDR EQUAL TO AVERAGE.
C IF A COMPLETE NEW SET OF CALIBRATION DATA IS NOT BEING PRODUCED,
C DON'T UPDATE THE AVERAGE DRIFT VELOCITY.
      IF(IFLAG.EQ.0)GO TO 4
      IVDR=0
      DO 3010 I=1,NCHAMS
      IVDR=IVDR+HVDRFT(I)
 3010 CONTINUE
      HVDR=IVDR/NCHAMS+.5
C
      GO TO 4
C
C-----------------------------------------------------------------------
C
C DRIFT TIME PEDESTAL.
 1011 CONTINUE
      DO 2011 I=IFRCH1,IFRCH2
      HDTP(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2011 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C LONGITUDINAL TIME PEDESTAL.
 1012 CONTINUE
      DO 2012 I=IFRCH1,IFRCH2
      HLTP(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2012 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C LONGITUDINAL SCALE FACTORS.
 1013 CONTINUE
      DO 2013 I=IFRCH1,IFRCH2
      DO 2013 J=IHIT1,IHIT2
      HLSF(J,I)=INEW
      K=4*(I-1)+J
      IF(IFLAG.EQ.0)CALL MUCHAN(K)
 2013 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C CHAMBER STATUS.
 1014 CONTINUE
      DO 2014 I=IFRCH1,IFRCH2
      HMCSTA(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2014 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C LOWER LONGITUDINAL BLOCK LIMIT.
 1015 CONTINUE
      DO 2015 I=IFRCH1,IFRCH2
      HBLLO(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2015 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C UPPER LONGITUDINAL BLOCK LIMIT.
 1016 CONTINUE
      DO 2016 I=IFRCH1,IFRCH2
      HBLHI(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2016 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C LOWER TRANSVERSE BLOCK LIMIT.
 1017 CONTINUE
      DO 2017 I=IFRCH1,IFRCH2
      HBTLO(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2017 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C UPPER TRANSVERSE BLOCK LIMIT.
 1018 CONTINUE
      DO 2018 I=IFRCH1,IFRCH2
      HBTHI(I)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2018 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C NORMAL BLOCK LIMITS.
 1019 CONTINUE
      DO 2019 I=IFRCH1,IFRCH2
      DO 2019 J=IHIT1,IHIT2
      K=6*(I-1)+J
      HBNLIM(K)=INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(K)
 2019 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C ADD CONSTANT TO WIRE COORDINATE.
 1020 CONTINUE
      DO 2020 I=IFRCH1,IFRCH2
      HCTW(I)=HCTW(I)+INEW
      IF(IFLAG.EQ.0)CALL MUCHAN(I)
 2020 CONTINUE
      GO TO 4
C
C-----------------------------------------------------------------------
C
C ERROR CONDITIONS,ETC.
C
 98   CONTINUE
      CALL MUMESS('MUCONE',NVERSN,'NO CHANGES.^')
      GO TO 99
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
C     FIX UP CTLO AND CTHI.
      CALL MUMESS('MUCONE',0,'CTLO AND CTHI FORCED TO BE 150 MM FROM WIR
     *E OF EDGE CHAMBERS.^')
      DO 199 J=1,NFRAMS
        I1=HAC(J)
        I2=HAL(J)
        HCTLO(J)=HCTW(I1)-150
        IALPH=6
        IF(IFLAG.EQ.0)CALL MUCHAN(J)
        HCTHI(J)=HCTW(I2)+150
        IALPH=7
        IF(IFLAG.EQ.0)CALL MUCHAN(J)
  199 CONTINUE
      REWIND LUNMUE
      RETURN
      END

C   12/12/78 C9073001   MEMBER NAME  LGSRTH   (SOURCE)      FORTRAN
      SUBROUTINE LGSRTH( IB, ND )
C
C     S.YAMADA    12-12-78     16:40    COPIED FROM (LGSOURCE)
C     LAST MODIFICATION  09-03-79  15:45
C
C---- PULSE HEIGHT SORT OF LEAD GLASS DATA
C---- SORT ACCORDING TO THE ALGORITHM 201 OF CACM,SEE P.66 DESY R-INFO
C
C---- THIS IS A SUBPROGRAM TO SORT LG-DATA OF DIFFERENT DETECTOR PART
C     SEPARATELY.
C---- IB=BASE INDEX,  ND=NO. OF DATA TO BE SORTED.
C
      IMPLICIT INTEGER *2 (H)
#include "clgwork1.for"
      DIMENSION LGADC(2000)
      EQUIVALENCE (LGADC(1),HLGADC(1,1))
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/178102015/
      NVRSN(17) = NVCODE
C
      IF( ND.LE.1) RETURN
      M = ND
   10 M = M/2
      IF(M.EQ.0) RETURN
      K = ND-M
        DO 50 J=1,K
        I = J+IB
   20   IF(I.LE.IB) GO TO 50
        IF( HLGADC(2,I+M).LE.HLGADC(2,I) ) GO TO 50
C----   REPLACING
    3   IW = LGADC(I)
        LGADC(I) = LGADC(I+M)
        LGADC(I+M) = IW
        I = I-M
        GO TO 20
   50   CONTINUE
      GO TO 10
      END

C   28/11/79 112032028  MEMBER NAME  MOMGAM   (JADEGS)      FORTRAN
      SUBROUTINE MOMGAM(IP,PX,PY,PZ,PTRANS,PTOT,PHI,THE)
      IMPLICIT INTEGER*2 (H)
C---
C---     GIVEN:  POINTER TO CLUSTER BANK IP
C---     RETURN: THREE COMPONENTS OF THE MOMENTUM
C---          J.OLSSON  16.09.79        LAST CHANGE  06.11.81
C---
#include "cdata.for"
#include "cgraph.for"
#include "cgeo1.for"
      COMMON /CJTRIG/ PI,TWOPI
C----------------------------------------
C
      PHI = ATAN2(ADATA(IP+10),ADATA(IP+9))
      IF(PHI.LT.0.) PHI = PHI + TWOPI
      THE = ARCOS(ADATA(IP+11))
C     JPART = IDATA(IP+1)
C     IF(JPART.NE.0) GO TO 2
C****************************** BARREL PHOTONS *****
C     PHI = ADATA(IP+4)
C     THE = ATAN2(ADATA(IP+5),RLG)
C     THE = PI*.5 - THE
C     GO TO 3
C****************************** ENDCAP PHOTONS *****
C2     XP = ADATA(IP+4)
C      YP = ADATA(IP+5)
C      RR = SQRT(XP*XP + YP*YP)
C      THE = ATAN2(RR,ZENDPL)
C      IF(JPART.LT.0) THE = PI - THE
C      PHI = ATAN2(YP,XP)
C      IF(PHI.LT.0.) PHI = PHI + TWOPI
3     CONTINUE
      EGAM = ADATA(IP+2)
      COSTH = COS(THE)
      PZ = EGAM*COSTH
      COSTH = SIN(THE)*EGAM
      PX = COSTH*COS(PHI)
      PY = COSTH*SIN(PHI)
      PTRANS = SQRT(PX*PX + PY*PY)
      PTOT = SQRT(PTRANS*PTRANS + PZ*PZ)
      RETURN
      END

C   18/04/79 C9052901   MEMBER NAME  STLATC   (S)           FORTRAN
      SUBROUTINE STLATC( LENGTH, ILTC )
C-----------------------------------------------------------
C
C  VERSION OF 18/04/79  LAST MOD 29/05/79    E.ELSEN
C  PROVIDE DATA FOR BANK 'LATC' AS DESCRIBED IN
C  JADE NOTE 32.
C  ARRAY ILATCH CONTAINS DATA INCLUDING BANK DESCRIPTOR
C  EXTRA ENTRY LHLATC RETURNS LENGTH ONLY
C----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
       COMMON/CTWRK/IADC(2,42),ITDC(2,42)
      COMMON / CBPC   / HBPCAR(24)
      COMMON / CLGAMP / LGLONG, HAMPL(2000)
C
      COMMON / CDLATC / LGBRT, LGQT, LGET(4)
C
      DIMENSION NLGBR(42), NLGQ(8)
      DIMENSION ILTC(11), HLATCH(22), ILATCH(11)
      EQUIVALENCE (HLATCH(1),ILATCH(1))
C
      INTEGER MASK(16)/Z1,Z2,Z4,Z8,Z10,Z20,Z40,Z80,Z100,Z200,Z400,Z800,
     *                 Z1000,Z2000,Z4000,Z8000/
C
      CALL VZERO( ILATCH , 11 )
C
CCC  LATCHES FOR BP COUNTERS
      DO 100 J =1,24
      IF( HBPCAR(J) .EQ. 0 ) GO TO 100
      NW = (J-1) / 8
      IBT = J - NW*8
      HLATCH(NW+3) = LOR( HLATCH(NW+3), MASK(IBT) )
  100 CONTINUE
C
CCC  LATCHES FOR TOF COUNTERS
      DO 200 J =1,42
      IF( ITDC(1,J) + ITDC(2,J) .GE. 4096 ) GO TO 200
      NW = (J-1) / 7
      IBT = J - NW*7
      HLATCH(NW+6) = LOR( HLATCH(NW+6), MASK(IBT) )
  200 CONTINUE
C
CCC  COMPUTE LATCHES FOR LG ROWS
      IF( LGLONG .EQ. 0 ) GO TO 2000
C
      CALL VZERO( NLGBR, 42 )
      CALL VZERO( NLGQ, 8 )
      NLGE = 0
C
      DO 1000 IBL = 1, LGLONG, 2
      NBLO = HAMPL(IBL)
      NAMP = HAMPL(IBL+1)
      NLGE = NLGE + NAMP
      IF( NBLO .GT. 2688 ) GO TO 600
      NBLO = NBLO - 33
      IF( NBLO .LT. 0 ) NBLO = NBLO + 2688
      KL1 = NBLO / 64 + 1
      KL2 = KL1 + 1
      KL3 = KL2 + 1
      IF( KL2 .GT. 42 ) KL2 = KL2 - 42
      IF( KL3 .GT. 42 ) KL3 = KL3 - 42
      NLGBR(KL1) = NLGBR(KL1) + NAMP
      NLGBR(KL2) = NLGBR(KL2) + NAMP
      NLGBR(KL3) = NLGBR(KL3) + NAMP
      GO TO 1000
C
CCC  END CAP PART
  600 KL = ( NBLO - 2689 ) / 24 + 1
      NLGQ(KL) = NLGQ(KL) + NAMP
 1000 CONTINUE
C
CCC  STORE LG ROW LATCHES
      DO 1100 J =1,42
      IF( NLGBR(J) .LE. LGBRT ) GO TO 1100
      NW = (J-1) / 7
      IBT = J - NW*7
      HLATCH(NW+12) = LOR( HLATCH(NW+12), MASK(IBT) )
 1100 CONTINUE
C
CCC  STORE END CAP LATCHES
      DO 1200 J =1,8
 1200 IF( NLGQ(J) .GT. LGQT ) HLATCH(18) = LOR( HLATCH(18), MASK(J) )
C
CCC  STORE TOTAL LG ENERGY SUM
      DO 1300 J =1,4
 1300 IF( NLGE .GT. LGET(J) ) HLATCH(22) = LOR( HLATCH(22), MASK(J) )
C
C
CCC  MOVE DATA TO OUTPUT ARRAY ILTC
 2000 CALL MVCL( ILTC, 0, HLATCH, 0, 44 )
C
C
C-----------------------------------------------------------
      ENTRY LHLATC( LENGTH )
C-----------------------------------------------------------
      LENGTH = 11
      RETURN
      END

C   15/03/79 202262144  MEMBER NAME  LGCLBK   (S)           FORTRAN
C   13/03/79 C9031501   MEMBER NAME  LGCLPBN  (S)           FORTRAN
      SUBROUTINE LGCLBK
C     MODIFIED TO CALCULATE THE CLUSTER SHAPE
C     BY R.EICHLER       15-03-78  12:00
C     LAST MODIFICATION   16-08-79  19:30   Y.WATANABE
C     LAST MODIFICATION   26-02-82  21:45   S.YAMADA
C                                           POSITION OF COSD()=0.
C     ORIGINAL S.YAMADA 09-10-78  15:55 VERSION 4(L.M. 08-02-79,23:10)
C
C---- LEAD GLASS CLUSTERS IN THE BARREL PART ARE PROCESSED.
C---- TOTAL PULSE HEIGHT,AVERAGE POSITION AND SPATIAL SPREAD ARE
C     CALCULATED FOR EACH CLUSTER.
C
C---- MODIFICATION FOR VERSION 4;
C     ONLY THESE VARIABLES WHICH DO NOT NEED INNER TRACK INF.ARE FILLED.
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
      COMMON /CLGPRM/ ITHADC,MAXCLS
      COMMON/LGSHP/WW(50),ZZ(50),XX(50),EW(2),AVPH,AVZ,SIGPH,SIGZ,EV,KK
C------------------------------ ADDED BY S.K. --- 17-11-79 -------------
      COMMON /EIGVEC/EIGV11,EIGV12,EIGV21,EIGV22
      COMMON /EIGAB/COSD(2),COSA(2),COSB(2),
     &          EIGA1,EIGA2,EIGB1,EIGB2,ENECLA,ENECLB,NHITA,NHITB,DNORM
C     COMMON /CLVEC/V11,V12,V21,V22
C-----------------------------------------------------------------------
C
#include "clgwork1.for"
      EQUIVALENCE (NCLBRL,NCLBEC(1))
C
      COMMON /CLGMSB/ AMSGVL(5)
C-- MODIFIED BY S.KOMAMIYA -------------
      COMMON /MAXCLS/EIG1,EIG2,EIGSUM,EIGDIV,MAXHIT,ECMAX,MAXCL
      DIMENSION NHIT(20)
      DIMENSION EIGN(2,20)
      DIMENSION COS(2,20),PHAI(20),ZET(20)
C     DIMENSION EVC11(20)
C     DIMENSION EVC12(20)
C     DIMENSION EVC21(20)
C     DIMENSION EVC22(20)
C-------------------------------
C
C     ICLSPR(1,I)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     CLSPRP(2,I)=ENERGY IN GEV
C     CLSPRP(3,I)=SIGMA(ENERGY)
C     CLSPRP(4,I)=WEIGHTED AVERAGE PHI
C     CLSPRP(5,I)=WEIGHTED AVERAGE Z
C     CLSPRP(6,I)=SIGMA PHI (WEIGHTED)
C     CLSPRP(7,I)=SIGMA Z (WEIGHTED)
C     ICLSPR(8,I)=CHARGE,IF THERE IS A CHARGED NEIGHBOUR
C                  TRACK,ITS CHARGE IS COPIED.
C     CLSPRP(9-11,I)=DIRECTION COSIGNS CORRECTED FOR SHOWER DEV.
C     CLSPRP(12-14,I)=CLUSTER SHAPE: ELLIPS EIGENVALUES AND DIRECTION
C     CLSPRP(15,I)=FRACTION OF ENERGY IN EDGE COUNTERS IN THE CLUSTER
C
C
      COMMON /CLGZPT/ YETOT,Y(32),WEIGHT(32),YFIT(32),DERIV(32),PHI(84)
C---- THIS COMMON IS USED TO GET THE (Z,PHI)-POSITION OF THE CLUSTER.
C     SEE LGAVRZ AND LGAVRP.
C
      DATA PHUNIT/0.07479983/
      COMMON /CLGVRN/ NVRSN(20)
      DATA NVCODE/478110108/
      NVRSN(9) = NVCODE
C
      ZSTEP=ZWID(1)+ZGAP(1)
      Z0=ZEND(1)+0.5*ZWID(1)
C
      IF(NCLBRL.LE.0) RETURN
      N2=NCLBRL
CC    IF(N2 .GT. MAXCLS) N2=MAXCLS
      IF(N2 .GT. 20 ) N2=20
        DO 1 N=1,N2
        ICLSPR(1,N) = 0
C
        NS = HMAPCL(1,N)
        NL = HMAPCL(2,N)
        WSUM = 0.
        IDO = HLGADC(1,NS)
        IPHO = IDO/32
C--------------------------------------------- ADDED BY S.K. -----------
        PHIO=FLOAT(IPHO)*PHUNIT*RADIUS(3)
C-----------------------------------------------------------------------
        NPMIN = 42
C----   CLEAR Y
        CALL SETSL(Y,0,848,0)
        KK=NL-NS+1
C---    CHECK NO. OF HITS IN THE CLUSTER
        IF(KK.LE.50) GO TO 3
        KK = 50
C
    3     DO 2 NN=NS,NL
          ID = HLGADC(1,NN)
          IPH = ID/32
          IZ = ID-32*IPH
C
C----     ANGLE PHI IS CONSIDERED WITH RESPECT TO THE FIRST BLOCK
C         TO AVOID ANGLE UNCERTAINTY.
          IPHD = IPH-IPHO
          IF(IPHD.GT.42) IPHD = IPHD-84
          IF(IPHD.LE.-42) IPHD = IPHD+84
          NPHD = IPHD+42
C----     CHECK THE MIN.PHI COUNTER #.
          IF(NPHD.LT.NPMIN) NPMIN = NPHD
C
C----     PULSE HEIGHT OF THE NN-TH HIT IS CALIBRATED IN MEV.
C
          W = HLGADC(2,NN)
C
C----     ADD W
          WSUM = WSUM+W
C
          IF(W) 90,9,9
C----     NEGATIVE ENERGY,   CLEARED TO PROTECT 'LGEIGN'.
   90     AMSGVL(1) = W
          CALL LGMESG( 6, 2)
          W = 0.
C
C
C----   FILL ARRAYS FOR CLUSTER SHAPE ANALYSIS
    9     NM=NN-NS+1
          IF(NM.GT.50) GO TO 4
          WW(NM)=W
          ZZ(NM)=IZ*ZSTEP+Z0
          XX(NM)=IPHD*PHUNIT*RADIUS(3)
C
C----     CHECK CORNER HIT
    4     CALL LGCRNR( 0, IZ, IPHI, ICLS)
          IF(ICLS.EQ.1) CLSPRP(15,N)=CLSPRP(15,N)+W
C
    2     CONTINUE
C
C
C----   CHANGE ENERGY UNIT TO GEV.
        WSUM = WSUM*0.001
C----   CALCULATE EIGENVALUES AND 3.MOMENTS OF CLUSTER
C-- MODIVIED BY S.KOMAMIYA -----
        CALL LGEIGK(1.)
C-- DELETED BY S.KOMAMIYA ------
C       CHANGE SIGZ AND SIGPH IN LINEAR DIMENSION.(Y.WATANABE 8/9/79)
C       IF(SIGZ.GT.0.) SIGZ=SQRT(SIGZ)
C       IF(ABS(AVZ-ZZ(1)).LT.0.1) SIGZ=ZWID(1)/3.4641
C       (IF ONLY ONE ROW OF THAT DIMENSION FIRE,
C       SIGMA=COUNTER WIDTH/2/SQRT(3).
C       IF(SIGPH.GT.0.) SIGPH=SQRT(SIGPH)/RADIUS(3)
C       IF(ABS(AVPH-XX(1)).LT.0.1) SIGPH=PHWID(1)/3.4641/RADIUS(3)
C
C----   CALCULATE SIG(ENERGY)
        CALL LGEERR(0,WSUM,SIGENG)
        CLSPRP(2,N) = WSUM
        CLSPRP(3,N) = SIGENG
        CLSPRP(4,N) = AVPH/RADIUS(3)+IPHO*PHUNIT+0.5*PHUNIT
        CLSPRP(5,N) = AVZ
        CLSPRP(6,N) = SIGPH
        CLSPRP(7,N) = SIGZ
C-------------------------------------------- MODIFIED BY S.K. ---------
        IF(EW(1).EQ.0.) GO TO 111
        CLSPRP(12,N)=EW(2)/EW(1)
        GO TO 112
111     CLSPRP(12,N)=0.
112     CLSPRP(13,N)=EW(1)+EW(2)
C-----------------------------------------------------------------------
        CLSPRP(14,N)=EV
        CLSPRP(15,N)=0.001*CLSPRP(15,N)/WSUM
C
        ETOT(2) = ETOT(2)+WSUM
C
C---------------------------------------------- MODIFIED BY S.K. -------
      NHIT(N) = NL-NS+1
      EIGN(1,N)=EW(1)
      EIGN(2,N)=EW(2)
C-- CALCULATE DIRECTION OF THE EIGEN VECTOR ( BELONGS TO EW(1) )
      EIGV1=SQRT(EIGV11**2+EIGV12**2)
      IF(EIGV1.LE.0.) GO TO 500
      COS(1,N)=EIGV11/EIGV1
      COS(2,N)=EIGV12/EIGV1
      GO TO 501
  500 COS(1,N)=0.
      COS(2,N)=0.
  501 CONTINUE
C
C-- CALCULATE PHI- AND Z-COORD. OF THE CLUSTER
C--------------------------- UNWEIGHTED SUM ----------------------------
      PHAI(N)=AVPH+PHIO
      ZET(N)=AVZ
C-----------------------------------------------------------------------
C     EVC11(N)=EIGV11
C     EVC12(N)=EIGV12
C     EVC21(N)=EIGV21
C     EVC22(N)=EIGV22
C-----------------------------------------------------------------------
    1 CONTINUE
C
      ECMAX=0.
      DO 10 L=1,N2
      IF(CLSPRP(2,L).LT.ECMAX) GO TO 10
      MAXCL=L
      ECMAX=CLSPRP(2,L)
   10 CONTINUE
      EIG1=EIGN(1,MAXCL)
      EIG2=EIGN(2,MAXCL)
      MAXHIT=NHIT(MAXCL)
      EIGDIV=CLSPRP(12,MAXCL)
      EIGSUM=CLSPRP(13,MAXCL)
C     V11=EVC11(MAXCL)
C     V12=EVC12(MAXCL)
C     V21=EVC21(MAXCL)
C     V22=EVC22(MAXCL)
C-----------------------------------------------------------------------
      NCLSA=0
      NCLSB=0
      ENECLA=0.
      ENECLB=0.
      DO 700 NN=1,N2
      IF(CLSPRP(2,NN).LE.ENECLA) GO TO 710
      ENECLB=ENECLA
      NCLSB=NCLSA
      ENECLA=CLSPRP(2,NN)
      NCLSA=NN
      GO TO 700
  710 IF(CLSPRP(2,NN).LE.ENECLB) GO TO 700
      ENECLB=CLSPRP(2,NN)
      NCLSB=NN
  700 CONTINUE
C-----------------------------------------------------------------------
      EIGA1=0.
      EIGA2=0.
      EIGB1=0.
      EIGB2=0.
      NHITA=0
      NHITB=0
      COSA(1)=0.
      COSA(2)=0.
      COSB(1)=0.
      COSB(2)=0.
      COSD(1)=0.
      COSD(2)=0.
      DNORM=0.
      IF(NCLSA.EQ.0) GO TO 800
      EIGA1=EIGN(1,NCLSA)
      EIGA2=EIGN(2,NCLSA)
      NHITA=NHIT(NCLSA)
      COSA(1)=COS(1,NCLSA)
      COSA(2)=COS(2,NCLSA)
      IF(NCLSB.EQ.0) GO TO 800
      EIGB1=EIGN(1,NCLSB)
      EIGB2=EIGN(2,NCLSB)
      NHITB=NHIT(NCLSB)
      COSB(1)=COS(1,NCLSB)
      COSB(2)=COS(2,NCLSB)
C---- CALCULATE DIRECTION COSINE OF THE ANGLE BTW TWO CLUSTERS ---------
      DPHI=PHAI(NCLSA)-PHAI(NCLSB)
      PHUNI1=PHUNIT*RADIUS(3)
      IF(DPHI/PHUNI1.GT.42.) DPHI=DPHI-84.*PHUNI1
      IF(DPHI/PHUNI1.LT.-42.) DPHI=DPHI+84.*PHUNI1
      DZET=ZET(NCLSA)-ZET(NCLSB)
      DNORM=SQRT(DPHI**2+DZET**2)
      IF(DNORM.LE.0.) GO TO 600
      COSD(1)=DPHI/DNORM
      COSD(2)=DZET/DNORM
  600 CONTINUE
C------------- TEST FOR REJECTING TWO RELATED COSMIC CLUSTERS----------
  800 CONTINUE
  300 CONTINUE
      RETURN
      END

C   21/12/87 807261954  MEMBER NAME  STRNUM   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE STRNUM( STRING, NCHAR, VALUE, IER )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  21/12/87 :  CONVERT STRING INTO NUMBER 'VALUE'
C
C LAST MOD:   C. BOWDERY  26/07/88 :  CHECK FOR / CODE FROM NUMFUN
C
C     STRING CONTAINS NUMBERS AND OPTIONALLY '+-.' AND HAS A LENGTH
C     NCHAR. VALUE IS THE DERIVED VALUE. IER IS .TRUE. IF ERROR OCCURRED
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  HADONE, IER
C
      LOGICAL*1  STRING(NCHAR)
C
C------------------  C O D E  ------------------------------------------
C
C
   2  NDIG   =  0
      NBP    = -1
      N      =  0
      SIGN   =  1.0
      HADONE = .FALSE.
C                                                CONVERT CHAR TO NUMBER
      DO  6  I = 1,NCHAR
C
C                                                ONLY ALLOW DIGITS,+-.
C
        MVAL = NUMFUN( STRING(I) )
        IF( MVAL .LT. 0  .OR.  MVAL .GT. 12 ) GO TO 99
C                                                PLUS SIGN?
        IF( MVAL .NE. 10 ) GO TO 3
          IF( I .NE. 1 ) GO TO 99
          GO TO 6
C                                                MINUS SIGN?
   3    IF( MVAL .NE. 11 ) GO TO 4
          IF( I .NE. 1 ) GO TO 99
          SIGN = -1.0
          GO TO 6
C                                                POINT? ALREADY HAD ONE?
   4    IF( MVAL .NE. 12 ) GO TO 5
          IF( HADONE ) GO TO 99
          HADONE = .TRUE.
          NBP    = 0
          GO TO 6
C
   5    N    = 10 * N + MVAL
        NDIG = NDIG + 1
        IF( NBP .GE. 0 ) NBP = NBP + 1
C
C                            DANGER OF OVERFLOW ?
C
        IF( N .LT. 2**26 ) GO TO 6
C
C                            YES. IF WE ARE PROCESSING FRACTION THEN
C                            JUST DROP LAST DIGITS. OTHERWISE ERROR.
C
          IF( HADONE ) GO TO 7
          GO TO 99
C
   6  CONTINUE
C
   7  IF( NDIG .EQ. 0 ) GO TO 99
      IF( NBP .EQ. -1 ) NBP = 0
      VALUE = FLOAT(N) * SIGN / (10.0 ** NBP)
C
      IER = .FALSE.
      RETURN
C
C                            HANDLE ANY ERRORS.
C
 99   IER = .TRUE.
      RETURN
C
      END

      SUBROUTINE TRACEO(ITRK,PAR1,PAR2,PAR3)
      IMPLICIT INTEGER*2 (H)
      LOGICAL DEADCL
#include "cheadr.for"
      EQUIVALENCE (HHEADR(18),HRUN)
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      COMMON/CALIBR/JPOINT(100),
     1HMUCAL(8370),HLGMAI(5760),HTAGSY(384),HJPULS(9216),
     1DELTA0(96,2),DELTA1(96,2),DELTA2(96,2),DELTA5(96,2),DELTA6(96,2)
      DIMENSION ITRCLL(6),CSRCLL(6),SNRCLL(6), NCNCK(24)
      DIMENSION CSRNG1(3),SNRNG1(3),CSRNG3(4),SNRNG3(4)
      INTEGER MKBDCL(3) /Z10,Z20,Z40/
      INTEGER MKDDCL(3) /Z01,Z02,Z04/
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 1
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      HPCO0  = HPFREE
      HLDCO  = 14
      HPFREE = HLDCO*100 + HPCO0
      HPCO9 = HPFREE - 1
      IPCOMX= HPFREE - HLDCO
      R0 = FSENSW(IRING)
      DR = RINCR (IRING)
      X0    = DR*15. + R0
      Y0    = (PAR1*X0 + PAR2) * X0
      TGROT = Y0 / X0
      CSROT = 1. / SQRT(TGROT**2 + 1.)
      SNROT = CSROT*TGROT
      CSROT0= CSROT
      SNROT0= SNROT
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      WGHT0 = .01
      Y0    = 0.
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      IF(S0.LT.3.5 .OR. SIG.GT.100.) RETURN
      DORIG = PAR3
      IF(PAR1.LT.0) DORIG =-PAR3
      IF(
     - DORIG.GT.11. .OR. DORIG.LT.-3.
     -)THEN
        WGHT0 = 1.0
        Y0 = SIGN(10.,PAR1)
        IF(DORIG.LT.0) Y0 =-SIGN(2.,PAR1)
      ASSIGN 17006 TO IZZZ03
      GOTO 17004
17006 CONTINUE
      ENDIF
      IF(SIG.GT.0.15) RETURN
      IF(S0 .LT. 4.5) RETURN
      IF(SIG.GT.0.06 .AND. S0 .LT. 6.5) RETURN
      JCELL = ICELL
      JRING = IRING
      ASSIGN 17008 TO IZZZ04
      GOTO 17007
17008 CONTINUE
      KCLL = 0
      NHIT = 0
      IPCO = HPCO0
      JRING = 0
      LBCELL = 0
      LBHTMX = 0
16000 CONTINUE
      JRING = JRING + 1
        NHRNG = 0
        NCLL = 0
16002 CONTINUE
        NCLL = NCLL + 1
        KCLL = KCLL + 1
          JCELL = ITRCLL(KCLL)
      IF(
     - JCELL.NE.0
     -)THEN
            CSROT = CSRCLL(KCLL)
            SNROT = SNRCLL(KCLL)
      ASSIGN 17010 TO IZZZ05
      GOTO 17009
17010 CONTINUE
            NHRNG = NHRNG + JHIT
            IF(LBHTMX.NE.0) RETURN
      ENDIF
      IF(.NOT.(
     - NCLL.EQ.2
     -))GOTO 16002
16003 CONTINUE
        IF(NHRNG.LT.2 .AND. JRING.LT.IRING) RETURN
        IF(JCELL.NE.0) LBCELL = LOR(MKBDCL(JRING),LBCELL)
      IF(.NOT.(
     - KCLL.EQ.6
     -))GOTO 16000
16001 CONTINUE
      HPCO9 = IPCO - 1
      CALL LBHTRO(ITRK,PAR1,PAR2,PAR3,INDPAR)
      IF(
     - INDPAR.EQ.0
     -)THEN
        WGHT0 = 0.10
        Y0 = 0.
      ELSE
        WGHT0 = 0.03
        Y0 = PAR3
      ENDIF
      ASSIGN 17011 TO IZZZ03
      GOTO 17004
17011 CONTINUE
      IF(S0.LT.3.5 .OR. SIG.GT.100.) RETURN
      ALBLM1 = 0.6
      ALBLM2 = 3.0
      ASSIGN 17013 TO IZZZ06
      GOTO 17012
17013 CONTINUE
      WGHT0 = PATRLM(2)
      SIG0  = SIG
      ASSIGN 17014 TO IZZZ03
      GOTO 17004
17014 CONTINUE
      IF(S0.LT.7.5 .OR. SIG.GT.100.) RETURN
      ALBLM1 = 0.6
      ALBLM2 = 3.0
      ASSIGN 17015 TO IZZZ06
      GOTO 17012
17015 CONTINUE
15000 CONTINUE
      IF(
     -  NHITLB-S0 .GT. 4.5 .OR. SIG0-SIG.GT..25
     -)THEN
        SIG0  = SIG
      ASSIGN 17016 TO IZZZ03
      GOTO 17004
17016 CONTINUE
      ASSIGN 17017 TO IZZZ06
      GOTO 17012
17017 CONTINUE
      GOTO 15000
      ENDIF
15001 CONTINUE
      IF(
     - SIG.LE.0.1225
     -)THEN
        CALL CKTRKO(LBCKTR,LBCELL)
        IF(LBCKTR.LE.16) RETURN
      ASSIGN 17019 TO IZZZ07
      GOTO 17018
17019 CONTINUE
        HPHT0S = HPHT0
        HPHT9S = HPHT9
        HLDHTS = HLDHT
        HPHT0  = HPCO0
        HPHT9  = HPCO9
        HLDHT  = HLDCO
        CALL STTRKO(LBCKTR)
        HPHT0  = HPHT0S
        HPHT9  = HPHT9S
        HLDHT  = HLDHTS
      ENDIF
      RETURN
17002 CONTINUE
      XR1  = DR*7.5 + R0
      TGB  = PAR1*XR1 * 2. + PAR2
      CSB  = 1. / SQRT(TGB**2+1.)
      SNB  = CSB * TGB
      DRISN  = SINDRI(ICELL,1)
      DRICS  = COSDRI(ICELL,1)
      IHIT = 0
      IPCO = HPCO0
      IP = HPHT9 - HLDHT + 1
16004 CONTINUE
        LBSIDE  = 0
        LBGOOD = 0
      IF(
     - IABS(IWRK(IP+ 9)).EQ.ITRK
     -)THEN
          LBSIDE = -1
          IF(LAND(IWRK(IP+4),2).NE.0) LBSIDE = 1
          IF(IWRK(IP+ 9).LT.0) LBGOOD = 1
      ELSE
      IF(
     - IABS(IWRK(IP+10)).EQ.ITRK
     -)THEN
          LBSIDE = -1
          IF(LAND(IWRK(IP+4),8).NE.0) LBSIDE = 1
          IF(IWRK(IP+10).LT.0) LBGOOD = 1
      ENDIF
      ENDIF
      IF(
     - LBSIDE.NE.0
     -)THEN
          ILAY = IWRK(IP  )
          Y    = SWDEPL
          IF(LAND(ILAY,1).NE.0) Y =-Y
          DS   =  WRK(IP+2)
          X    = ILAY * DR + R0
      IF(
     - DS.LE.DRC
     -)THEN
            DX   =-DS * SNB
            DY   = DS * CSB
      ELSE
            DX   =-(DS-DRC)*DRISN - DRC*SNB
            DY   = (DS-DRC)*DRICS + DRC*CSB
      ENDIF
          X    = DX*LBSIDE + X
          Y    = DY*LBSIDE + Y
          XX   = X*CSROT + Y*SNROT
          YY   =-X*SNROT + Y*CSROT
          IF(LBGOOD.LE.2) IHIT = IHIT + 1
          IWRK(IPCO   ) = ILAY
          IWRK(IPCO+ 1) = IWRK(IP+1)
          IWRK(IPCO+ 2) = LBSIDE
          WRK (IPCO+ 3) = XX
          WRK (IPCO+ 4) = YY
          WRK (IPCO+ 5) = 0.
          WRK (IPCO+ 6) = 0.
          IWRK(IPCO+ 7) = LBGOOD
          WRK (IPCO+ 8) = DS
          IWRK(IPCO+ 9) = ICELL
          IWRK(IPCO+10) = LBGOOD
          WRK (IPCO+11) = TGB
          IWRK(IPCO+12) = IRING
          WRK (IPCO+13) = 0.
          IPCO = IPCO + HLDCO
      ENDIF
      IP = IP - HLDHT
      IF(.NOT.(
     - IP.LT.HPHT0
     -))GOTO 16004
16005 CONTINUE
      NHIT = IHIT
      HPCO9 = IPCO - 1
      GOTO IZZZ02
17004 CONTINUE
      S0 = WGHT0
      S1 = 0.
      S2 = 0.
      S3 = 0.
      S4 = 0.
      S5 = 0.
      S6 = 0.
      S7 = Y0 * WGHT0
      IPCO = HPCO0
16006 CONTINUE
      IF(
     - IWRK(IPCO+ 7).EQ.0
     -)THEN
          X = WRK(IPCO+3)
          Y = WRK(IPCO+4)
          X2 = X**2
          S1 = S1 + X
          S2 = S2 + X2
          S3 = S3 + X*X2
          S4 = S4 + X2**2
          S5 = S5 + Y*X2
          S6 = S6 + Y*X
          S7 = S7 + Y
          S0 = S0 + 1.
      ENDIF
      IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16006
16007 CONTINUE
      IF(
     - S0.LT.3.5
     -)THEN
        SIG = 1000.
      ELSE
        F1 = 1. / S4
        XX12 = S3*F1
        XX13 = S2*F1
        YY1  = S5*F1
        XX22 = S2 - S3*XX12
        XX23 = S1 - S3*XX13
        YY2  = S6 - S3*YY1
        XX32 = S1 - S2*XX12
        XX33 = S0 - S2*XX13
        YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
          XX23 = XX23 / XX22
          YY2  = YY2  / XX22
          DET  = XX33 - XX32*XX23
      IF(
     - ABS(DET).GT.1.E-30
     -)THEN
            PAR3 = (YY3 - XX32*YY2) / DET
            PAR2 = YY2 - XX23*PAR3
      ENDIF
      ELSE
          XX33 = XX33 / XX32
          YY3  = YY3  / XX32
          DET  = XX23 - XX22*XX33
      IF(
     - ABS(DET).GT.1.E-30
     -)THEN
            PAR3 = (YY2 - XX22*YY3) / DET
            PAR2 = YY3 - XX33*PAR3
      ENDIF
      ENDIF
      IF(
     - ABS(DET).LE.1.E-30
     -)THEN
        SIG = 1000.
      ELSE
        PAR1 = YY1 - XX12*PAR2 - XX13*PAR3
        DEG = S0 - WGHT0 - 2.
        IF(WGHT0.LT..001) DEG = DEG - 1.
        CHISQ = 0.
        DCHIM1 = 0.
        IHITM1 = 0
        IPCO = HPCO0
16008 CONTINUE
      IF(
     - IWRK(IPCO+ 7).EQ.0
     -)THEN
            X = WRK(IPCO+3)
            Y = WRK(IPCO+4)
            F = (PAR1 *X + PAR2 )*X + PAR3
            DCHI = Y - F
            WRK(IPCO+13) = DCHI
            CHISQ = CHISQ + DCHI**2
      ENDIF
        IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16008
16009 CONTINUE
        SIG    =      CHISQ  / DEG
        SIGLM = TRELLM(16)**2
      ENDIF
      ENDIF
      GOTO IZZZ03
17007 CONTINUE
        ICELL0 = ICELL - 1
        IF(ICELL.GT.24) ICELL0 = ICELL - 25
        IF(ICELL.GT.48) ICELL0 = (ICELL-49)/2
      IF(
     - IRING.NE.3
     -)THEN
          TGR1 = TGROT
          SNR1 = SNROT
          CSR1 = CSROT
      ELSE
      IF(
     - LAND(ICELL,1).EQ.0
     -)THEN
            CSR1 = CSROT*CSFI3 - SNROT*SNFI3
            SNR1 = CSROT*SNFI3 + SNROT*CSFI3
      ELSE
            CSR1 = CSROT*CSFI3 + SNROT*SNFI3
            SNR1 =-CSROT*SNFI3 + SNROT*CSFI3
      ENDIF
          TGR1 = SNR1 / CSR1
      ENDIF
        JRING = 0
15002 CONTINUE
      IF(
     - JRING.LT.3
     -)THEN
        JRING = JRING + 1
          R0 = FSENSW(JRING)
          DR = RINCR (JRING)
          X1 = R0 - DR*2.
          X2 = R0 + DR*17.
          Y1 = (PAR1*X1 + PAR2)*X1 + PAR3
          Y2 = (PAR1*X2 + PAR2)*X2 + PAR3
          XX1 = X1*CSR1 - Y1*SNR1
          YY1 = X1*SNR1 + Y1*CSR1
          XX2 = X2*CSR1 - Y2*SNR1
          YY2 = X2*SNR1 + Y2*CSR1
          ICELL1 = 0
          LBINV  = 0
16010 CONTINUE
      IF(
     - JRING.EQ.3
     -)THEN
      IF(
     - ABS(YY1).LT.3.0 .OR. ABS(YY2).LT.3.0 .OR. YY1*YY2.LE.0.
     -)THEN
              ICELL1 =  2
              LBINV = 1
              IF(YY1.GT.YY2) LBINV =-1
      GOTO 16011
      ENDIF
            DY1 = ABS(YY1) - TGFI1*XX1
            DY2 = ABS(YY2) - TGFI1*XX2
      IF(
     - ABS(DY1).LT.3.0 .OR. ABS(DY2).LT.3.0 .OR. DY1*DY2.LE.0.
     -)THEN
              ICELL1 =  1
              IF(YY1.GT.0) ICELL1 = 3
              LBINV  = 1
              IF((DY2-DY1)*YY1 .LT. 0.) LBINV =-1
      GOTO 16011
      ENDIF
            ICELL1 =  2
            IF(YY1.GT.0.) ICELL1 = 3
      IF(
     - DY1.GT.0
     -)THEN
              ICELL1 =  1
              IF(YY1.GT.0.) ICELL1 = 4
      ENDIF
      GOTO 16011
      ENDIF
          DY1 = ABS(YY1) - TGFI1*XX1
          DY2 = ABS(YY2) - TGFI1*XX2
      IF(
     - ABS(DY1).LT.3.0 .OR. ABS(DY2).LT.3.0 .OR. DY1*DY2.LE.0.
     -)THEN
            ICELL1 =  1
            IF(YY1.GT.0) ICELL1 = 2
            LBINV  =  1
            IF((DY2-DY1)*YY1.LT.0.) LBINV =-1
      GOTO 16011
      ENDIF
          ICELL1 =  2
      IF(
     - DY1.GT.0.
     -)THEN
            ICELL1 =  1
            IF(YY1.GT.0.) ICELL1 = 3
      ENDIF
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16010
16011 CONTINUE
          IC2 = 0
          CSROT2 = 0.
          SNROT2 = 0.
      IF(
     - JRING.NE.3
     -)THEN
            IC1 = ICELL1 + ICELL0 - 1
            IF(IC1.LT. 1)  IC1 = IC1 + 24
            IF(IC1.GT.24)  IC1 = IC1 - 24
            IF(JRING.EQ.2) IC1 = IC1 + 24
            CSROT1 = CSRNG1(ICELL1)
            SNROT1 = SNRNG1(ICELL1)
      IF(
     - LBINV.NE.0
     -)THEN
              IC2 = ICELL1 + ICELL0
              IF(IC2.LT. 1)  IC2 = IC2 + 24
              IF(IC2.GT.24)  IC2 = IC2 - 24
              IF(JRING.EQ.2) IC2 = IC2 + 24
              CSROT2 = CSRNG1(ICELL1+1)
              SNROT2 = SNRNG1(ICELL1+1)
      ENDIF
      ELSE
            IC1 = ICELL1 + ICELL0*2 + 47
            IF(IC1.LT.49)  IC1 = IC1 + 48
            IF(IC1.GT.96)  IC1 = IC1 - 48
            CSROT1 = CSRNG3(ICELL1)
            SNROT1 = SNRNG3(ICELL1)
      IF(
     - LBINV.NE.0
     -)THEN
              IC2 = ICELL1 + ICELL0*2 + 48
              IF(IC2.LT.49)  IC2 = IC2 + 48
              IF(IC2.GT.96)  IC2 = IC2 - 48
              CSROT2 = CSRNG3(ICELL1+1)
              SNROT2 = SNRNG3(ICELL1+1)
      ENDIF
      ENDIF
      IF(
     - LBINV.LT.0
     -)THEN
            IZW    = IC2
            IC2    = IC1
            IC1    = IZW
            ZWZ    = CSROT2
            CSROT2 = CSROT1
            CSROT1 = ZWZ
            ZWZ    = SNROT2
            SNROT2 = SNROT1
            SNROT1 = ZWZ
      ENDIF
          ITRCLL(JRING*2-1) = IC1
          ITRCLL(JRING*2  ) = IC2
          CSRCLL(JRING*2-1) = CSROT1*CSR1 + SNROT1*SNR1
          SNRCLL(JRING*2-1) =-SNROT1*CSR1 + CSROT1*SNR1
          CSRCLL(JRING*2  ) = CSROT2*CSR1 + SNROT2*SNR1
          SNRCLL(JRING*2  ) =-SNROT2*CSR1 + CSROT2*SNR1
      GOTO 15002
      ENDIF
15003 CONTINUE
      GOTO IZZZ04
17009 CONTINUE
        R0 = FSENSW(JRING)
        DR = RINCR (JRING)
        XR1  = DR*7.5 + R0
        TGB  = PAR1*XR1 * 2. + PAR2
        XX   = 1. / SQRT(TGB**2+1.)
        YY   = XX * TGB
        CSB  = XX*CSROT - YY*SNROT
        SNB  = XX*SNROT + YY*CSROT
        TGB  = SNB/CSB
        DSBIN1 = DRIVEL(JCELL,1)
        DS0 = 0.
        IF(HRUN.LE.100) DS0 = DSBIN1*.5
        DRISN  = SINDRI(JCELL,1)
        DRICS  = COSDRI(JCELL,1)
        DRISNF = DRISN * .05
        DRITG  = DRISN/DRICS
        TANBET = ABS((TGB-DRITG)/(TGB*DRITG+1.))
        CCST01 = DELTA0(JCELL,1)*TANBET
        CCST02 = DELTA0(JCELL,2)*TANBET
        CCST11 = DELTA1(JCELL,1)
        CCST12 = DELTA1(JCELL,2)
        CCST21 = DELTA2(JCELL,1)
        CCST22 = DELTA2(JCELL,2)
        CCST51 = DELTA5(JCELL,1) * 10.
        CCST61 = DELTA6(JCELL,1) * 10.
        JHIT = 0
        NHIT   = 0
        NHGOOD = 0
        ILAYL =-99
        IPCO = IPCO - HLDCO
        IP9 = HPTSEC(JCELL+1)
        IP  = HPTSEC(JCELL  )
15004 CONTINUE
      IF(
     - IP.LT.IP9
     -)THEN
          IWIR = HDATA(IP)
          IWIR = ISHFTR(IWIR,3)
          ILAY = LAND(IWIR,15)
          DS =(HDATA(IP+3)) * DSBIN1 + DS0
          DSC = DS
          Y    = SWDEPL
          IF(LAND(ILAY,1).NE.0) Y =-Y
          Y    = (7-ILAY)*CCST51 - CCST61 + Y
          X    = ILAY * DR + R0
      IF(
     - DS.LE.DRC
     -)THEN
      IF(
     - DS.LT.4.0
     -)THEN
      IF(
     - DS.GT.DSD1
     -)THEN
                DSC = (DSD1-DSD0)*DRV0 + (DS-DSD1)*DRV1
      ELSE
                DSC = (DS-DSD0)*DRV0
      ENDIF
              IF(DSC.LT.0.1) DSC = 0.1
      ENDIF
            DXR  =-DSC * SNB
            DYR  = DSC * CSB
            DXL  =-DXR
            DYL  =-DYR
      ELSE
      IF(
     - ILAY.LT. 3
     -)THEN
              DILAY =-(ILAY- 3)**2
              DSCL  = (DILAY*CCST11 + 1.) * DSC
              DSCR  = (DILAY*CCST12 + 1.) * DSC
      ELSE
      IF(
     - ILAY.GT.12
     -)THEN
              DILAY =-(ILAY-12)**2
              DSCL  = (DILAY*CCST21 + 1.) * DSC
              DSCR  = (DILAY*CCST22 + 1.) * DSC
      ELSE
              DSCL = DSC
              DSCR = DSC
      ENDIF
      ENDIF
      IF(
     - DSC.GT.ABERR(7)
     -)THEN
              DWIR  = ILAY - 7.5
              DWIRC = DSC*DRISNF
              DWIRL = DWIR + DWIRC
              DWIRR = DWIR - DWIRC
              DSCL  = (DSCL-ABERR(7))*DWIRL*CCST01 + DSCL
              DSCR  =-(DSCR-ABERR(7))*DWIRR*CCST02 + DSCR
      ENDIF
            DXR  =-(DSCR-DRC)*DRISN - DRC*SNB
            DYR  = (DSCR-DRC)*DRICS + DRC*CSB
            DXL  = (DSCL-DRC)*DRISN + DRC*SNB
            DYL  =-(DSCL-DRC)*DRICS - DRC*CSB
      ENDIF
          XL   = DXL + X
          YL   = DYL + Y
          XXL  = XL*CSROT + YL*SNROT
          YYL  =-XL*SNROT + YL*CSROT
          FL   = (PAR1*XXL + PAR2)*XXL + PAR3
          DFL  = FL - YYL
          XR   = DXR + X
          YR   = DYR + Y
          XXR  = XR*CSROT + YR*SNROT
          YYR  =-XR*SNROT + YR*CSROT
          FR   = (PAR1*XXR + PAR2)*XXR + PAR3
          DFR  = YYR - FR
          NLRSOL = 1
          IF(DS.LT.2.0 .AND. DS.NE.0 .AND. JCELL.NE.ICELL) NLRSOL = 2
          ILRSOL = 0
16012 CONTINUE
          ILRSOL = ILRSOL + 1
      IF(
     - NLRSOL.EQ.1 .AND. ABS(DFL).LT.ABS(DFR) .OR.
     ?         NLRSOL.EQ.2 .AND. ILRSOL.EQ.1
     -)THEN
              LBSIDE =-1
              XX  = XXL
              YY  = YYL
              DF  = DFL
      ELSE
              LBSIDE = 1
              XX  = XXR
              YY  = YYR
              DF  = DFR
      ENDIF
            LBGOOD = 0
            IF(ABS(DF).GT.2.0) LBGOOD = 1
            IF(ABS(DF).GT.5.0) LBGOOD = 8
            IF(DF.LE.-10.0) LBGOOD = 4
            IF(DF.GT.-10.0 .AND. DF.LT.-5.0) LBGOOD = 2
      IF(
     - ILAY.NE.ILAYL .OR. LBGDL.LE.1.AND.LBGOOD.LE.1
     -)THEN
              LBREG = 1
              JHIT = JHIT + 1
              IPCO = IPCO + HLDCO
      ELSE
              LBREG = 0
              IF(LBGOOD.LT.IWRK(IPCO+7)) LBREG = 1
            IF(LBGOOD.GE.4 .AND. ABS(DF).LT.ABS(WRK(IPCO+13))) LBREG = 100079400
      ENDIF
      IF(
     - LBREG.NE.0
     -)THEN
      IF(
     - IPCO.GT.IPCOMX
     -)THEN
                LBHTMX = 1
      GOTO 15005
      ENDIF
              NHIT   = NHIT   + 1
              IF(LBGOOD.LE.1) NHGOOD = NHGOOD + 1
              IWRK(IPCO   ) = ILAY
              IWRK(IPCO+ 1) = IP
              IWRK(IPCO+ 2) = LBSIDE
              WRK (IPCO+ 3) = XX
              WRK (IPCO+ 4) = YY
              WRK (IPCO+ 5) = 0.
              WRK (IPCO+ 6) = 0.
              IWRK(IPCO+ 7) = LBGOOD
              WRK (IPCO+ 8) = DSC
              IWRK(IPCO+ 9) = JCELL
              IWRK(IPCO+10) = LBGOOD
              WRK (IPCO+11) = TANBET
              IWRK(IPCO+12) = JRING
              WRK (IPCO+13) = DF
              ILAYL = ILAY
              LBGDL = LBGOOD
      ENDIF
      IF(.NOT.(
     - ILRSOL.GE.NLRSOL
     -))GOTO 16012
16013 CONTINUE
        IP = IP + 4
      GOTO 15004
      ENDIF
15005 CONTINUE
      IF(
     - LBHTMX.EQ.0
     -)THEN
          IPCO = IPCO + HLDCO
      IF(
     - NHIT.LE.2
     -)THEN
            NRUN = HRUN
      IF(
     - DEADCL(JCELL,NRUN)
     -)THEN
              LBCELL = LOR(LBCELL,MKDDCL(JRING))
              JHIT = 16
              NHIT = 16
      ENDIF
      ENDIF
      ENDIF
      GOTO IZZZ05
17018 CONTINUE
      XST = 10000.
      XEN =     0.
      DO 13000 IPCO = HPCO0,HPCO9,HLDCO
      IF(
     - IWRK(IPCO+7).EQ.0
     -)THEN
          X = WRK(IPCO+3)
          IF(X.GT.XEN) XEN = X
          IF(X.LT.XST) XST = X
      ENDIF
13000 CONTINUE
13001 CONTINUE
      YST = (PAR1*XST + PAR2)*XST + PAR3
      YEN = (PAR1*XEN + PAR2)*XEN + PAR3
      TGST = PAR1*XST*2 + PAR2
      DXST = 1./SQRT(TGST**2+1.)
      DYST = DXST * TGST
      TGEN = PAR1*XEN*2 + PAR2
      DXEN = 1./SQRT(TGEN**2+1.)
      DYEN = DXEN * TGEN
      XMIN = -PAR2*.5 / PAR1
      YMIN = (PAR1*XMIN + PAR2)*XMIN + PAR3
      CURV =-PAR1 * 2.
      JCELLD = ICELL
      IF(ICELL.GT.24) JCELLD = ICELL - 24
      IF(ICELL.GT.48) JCELLD = ICELL - 48
      IF(
     - IRING.NE.3
     -)THEN
        DXWR  = DIRWR1(JCELLD,1)
        DYWR  = DIRWR1(JCELLD,2)
      ELSE
        DXWR  = DIRWR3(JCELLD,1)
        DYWR  = DIRWR3(JCELLD,2)
      ENDIF
      XX = DXWR*CSROT0 - DYWR*SNROT0
      YY = DXWR*SNROT0 + DYWR*CSROT0
      UN = SQRT(XX**2 + YY**2)
      CSROT = XX
      SNROT = YY
      HPTR0 = HPFREE
      IP    = HPTR0 - 1
      IWRK(IP+ 1) = 0
      IWRK(IP+ 2) = 16
      IWRK(IP+ 3) = 0
      IWRK(IP+ 4) = INDPAR + 1
      WRK (IP+ 5) = XST *CSROT - YST *SNROT
      WRK (IP+ 6) = XST *SNROT + YST *CSROT
      WRK (IP+ 7) = SQRT(WRK(IP+ 5)**2 + WRK(IP+ 6)**2)
      WRK (IP+ 8) = DXST*CSROT - DYST*SNROT
      WRK (IP+ 9) = DXST*SNROT + DYST*CSROT
      WRK (IP+10) = 1.
      IWRK(IP+11) = 0
      WRK (IP+12) = XEN *CSROT - YEN *SNROT
      WRK (IP+13) = XEN *SNROT + YEN *CSROT
      WRK (IP+14) = SQRT(WRK(IP+12)**2 + WRK(IP+13)**2)
      WRK (IP+15) = DXEN*CSROT - DYEN*SNROT
      WRK (IP+16) = DXEN*SNROT + DYEN*CSROT
      WRK (IP+17) = 1.
      IWRK(IP+18) = 2
      WRK (IP+19) = ATAN2(SNROT,CSROT)
      WRK (IP+20) = XMIN*CSROT - YMIN*SNROT
      WRK (IP+21) = XMIN*SNROT + YMIN*CSROT
      WRK (IP+22) = PAR1
      WRK (IP+23) = SQRT(SIG)
      IWRK(IP+24) = S0 + .001
      WRK (IP+25) = CURV
      WRK (IP+26) = 0.
      WRK (IP+27) = CURV
      WRK (IP+28) = CURV
      I0 = IP+ 1
      I9 = IP+28
      GOTO IZZZ07
17012 CONTINUE
        IWL = -999
        NHITLB = 0
      DO 13002 IP = HPCO0,HPCO9,HLDCO
          IW0 = IWRK(IP)
          X   = WRK(IP+3)
          Y   = WRK(IP+4)
          F   = (PAR1*X + PAR2)*X + PAR3
          DF  = F - Y
      IF(
     - ABS(DF).LT.ALBLM1
     -)THEN
            LBGOOD = 0
            NHITLB = NHITLB + 1
      ELSE
            LBGOOD = 4
            IF(ABS(DF).LT.ALBLM2) LBGOOD = 1
      ENDIF
          IWRK(IP+ 7) = LBGOOD
          WRK (IP+13) = DF
      IF(
     - IWL.EQ.IW0
     -)THEN
      IF(
     - ABS(DFL).LT.ABS(DF)
     -)THEN
              IF(LBGOOD.EQ.0) NHITLB = NHITLB - 1
              IWRK(IP +7) = 16
      ELSE
              IF(IWRK(IPL+7).EQ.0) NHITLB = NHITLB - 1
              IWRK(IPL+7) = 16
      ENDIF
      ENDIF
          IWL = IW0
          IPL = IP
          DFL = DF
13002 CONTINUE
13003 CONTINUE
      GOTO IZZZ06
17000 CONTINUE
        DFI0 = 3.1415927 / 12.
        DFI1 = DFI0 * .5
        DFI3 = DFI1 * .5
        DFI4 = DFI3 + DFI1
        SNFI0 = SIN(DFI0)
        CSFI0 = COS(DFI0)
        TGFI0 = SNFI0/CSFI0
        SNFI1 = SIN(DFI1)
        CSFI1 = COS(DFI1)
        TGFI1 = SNFI1/CSFI1
        SNFI3 = SIN(DFI3)
        CSFI3 = COS(DFI3)
        TGFI3 = SNFI3/CSFI3
        SNFI4 = SIN(DFI4)
        CSFI4 = COS(DFI4)
        CSRNG1(1) = CSFI0
        CSRNG1(2) = 1.
        CSRNG1(3) = CSFI0
        SNRNG1(1) =-SNFI0
        SNRNG1(2) = 0.
        SNRNG1(3) = SNFI0
        CSRNG3(1) = CSFI4
        CSRNG3(2) = CSFI3
        CSRNG3(3) = CSFI3
        CSRNG3(4) = CSFI4
        SNRNG3(1) =-SNFI4
        SNRNG3(2) =-SNFI3
        SNRNG3(3) = SNFI3
        SNRNG3(4) = SNFI4
        DRC = RINCR(1)*.5 * DRICOS
      IF(
     - HRUN.LE.100
     -)THEN
          DSD0   = .0
          DSD1   = 5.0
          DSD2   = 5.0
          DRV0   = 1.0
          DRV1   = 1.0
      ELSE
          DSD0   =-.63
          DSD1   = 1.8
          DSD2   = 4.0
          DRV0   = 0.8
          DRV1   = (DSD2 - (DSD1-DSD0)*DRV0) / (DSD2-DSD1)
      ENDIF
      GOTO IZZZ01
      END

C   25/06/78 708272304  MEMBER NAME  ENELMX   (S)           FORTRAN
      FUNCTION ENELS(E)
C
C THIS FUNCTION GIVES THE AVERAGE IONIZATION LOSS, I.E. ENERGY LOSS
C UP TO THE MAXIMUM TRANSFER POSSIBLE. WMAX IS GIVEN BY FORMULA (53)
C WHICH FOR ELECTRONS IS E-ME. THE FORMULA IS NR (55) IN STERNHEIMER,
C P.R.B (1971) 3681.
C  NOTE THAT THE INPUT ENERGY COMES IN UNITS OF ME, I.E. == GAMMA,
C  THEREFORE     BETA**2 = 1 - 1/E**2
C  LN2 = .69315
C  CON = LN(P/MC) = LN(M BETA GAMMA/M) = LNE + .5 * LN(BETA**2)
C
C  COMMON/ILPAR/ IS SET IN PARST2, CALLED BY INTSHW
C
      COMMON/ILPAR/AI,BI,ALCUTM
C
      DATA RME/0.511/
C
      BE2=1.-1./E**2
      IF(BE2.LE.0.)GOTO10
      CON=ALOG(E)+ALOG(BE2)/2.
C
      ALMAX = (E-1.)*RME
      IF(ALMAX.LE.0) RALMAX = 0.
      IF(ALMAX.GT.0) RALMAX = ALOG(ALMAX)
C
      ENELS=AI*(BI+0.69315+2.*CON+RALMAX-2.*BE2
     @         -DENDEL(0.434294*CON))/BE2
C FUNCTION DENDEL CALCULATES DENSITY EFFECT CORRECTION.
      RETURN
 10   ENELS=0.
      RETURN
      END

C   01/11/84 807241258  MEMBER NAME  DRAWVC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWVC( IVIEW , JNDEX )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN   26/04/84 :  DRAW VERTEX CHAMBER
C
C      MOD:   J. HAGEMANN   19/10/84 :  DRAW CELL NUMBERS  (JNDEX=16)
C      MOD:   J. HAGEMANN   22/05/85 :  SKIP CELL NUMBERS IN A
C                                       DEMAGNIFICATION OF VC-VIEW
C      MOD:   J. HAGEMANN   14/02/86 :  DRAW CHAMBER IN TRUE POSITION
C                                       RELATIVE TO THE ORIGIN
C LAST MOD:   J. HAGEMANN   24/04/86 :  DRAW POTENTIAL WIRE PLANE
C                                       BETWEEN BAD CELLS FOR REAL DATA
C
C     DRAW THE VERTEX CHAMBER FOR THE VIEW IVIEW.
C       IVIEW = 1   : R PHI VIEW
C       IVIEW = 2   : RZ VIEWS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FL18, FL22, FL24
      LOGICAL FLVCDO, DSPDTM
C
C-----------------------------------------------------------------------
C                            MACRO CGEOV      VERTEX CHAMBER GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEOV  / RPIPV,DRPIPV,XRLPIV,RVXC,DRVXC,XRLVXC,
     +                  ZVXCM,DZVCM,XRZVCM, ZVXCP,DZVCP,XRZVCP,
     +                  XRVTXC
C
C--------------------------- END OF MACRO CGEOV ------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CJVCEL     VERTEX CHAMBER CELLS/WIRES
C-----------------------------------------------------------------------
C
      COMMON / CJVCEL / MCELL,MWIRE
C
C--------------------------- END OF MACRO CJVCEL -----------------------
C
C-----------------------------------------------------------------------
C                            MACRO CJVTXC     VERTEX CHAMBER
C-----------------------------------------------------------------------
C
      COMMON / CJVTXC / RVEC, ANG1, ANG2, DISTPW, FIRSTP, DISTW1,
     +                  ANGL, COSLOR, SINLOR,
     +                  ZRESV, ZMAXV, ZOFFV, ZNAMP, ZALV, TIMEV,
     +                  DRILOR(24), SNLORA(24), CSLORA(24),
     +                  DRVELO(24)
C
C--------------------------- END OF MACRO CJVTXC -----------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C-----------------------------------------------------------------------
C                            MACRO CGRSCL .... GRAPHICS VIEW SCALES
C-----------------------------------------------------------------------
C
      COMMON  / CGRSCL / XMINST(30), XMAXST(30), YMINST(30)
C
C------- END OF MACRO CGRSCL -------------------------------------------
C
C   23/03/97 703231941  MEMBER NAME  MVCCAL   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVCCAL         SAVED BY F22KLE  ON 87/02/09  AT 17:52
C   27/06/85 702091751  MEMBER NAME  MVCCAL   (S)           FORTRAN
C
C         THIS MACRO CONTAINS THE DECLARATION FOR THE
C         VTXC-CALIBRATION-COMMON / CVCCAL / :
C
C------------------------------------------------- 03.03.86 J.H. -------
C
      REAL*8 VCDATE
      COMMON / CVCCAL / NVFREE, VFREE(50), VCDATE,
     &      T0, VD, CSLOR, SNLOR, VROT, VDX, VZX, VDY, VZY,
     &      S0R(2,168), CVD(2,168),
     &      VIHCRR(7,2,25)
C
C     NVFREE  : NUMBER OF FREE REAL WORDS IN VFREE
C     VFREE   : REAL ARRAY FOR CONSTANTS
C     T0      : GLOBAL T0                              (. 0.1 NS .)
C     VD      : GLOBAL DRIFTVELOCITY                   (. MM/(0.1 NS) .)
C     CSLOR   : COS( LORENTZ-ANGLE )
C     SNLOR   : SIN( LORENTZ-ANGLE )
C     VROT    : ROTATION VTXC - ID                     (. RADIAN .)
C     VDX     : DISPLACEMENT VTXC - ID IN X            (. MM .)
C     VZX     : SLOPE OF " IN Z
C     VDY     : DISPLACEMENT VTXC - ID IN Y            (. MM .)
C     VZY     : SLOPE OF " IN Z
C     S0R     : DISPLACEMENT FOR EACH WIRE (#)         (. MM .)
C     CVD     : DRIFTVEL.-CORRECTURE FOR EACH WIRE (#)
C
C     VIHCRR  : LAYER-DEPENDENT CORRECTIONS FOR INHOMOGENITIES
C                                                      (. MM . )
C
C     VFREE(50) : D(VROT)/D(Z)                         (. RADIAN/MM .)
C
C     VFREE(48,49) JOBNAME OF JOB GENERATING THIS CALIBRATION
C
C     (#)     : FOR EACH DRIFTSPACESIDE
C
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CGVCDO / FLVCDO(20)
      COMMON / CJTRIG / PI,TWOPI
C
      DIMENSION HTX(24)
C
      DATA HTX / ' 1', ' 2', ' 3', ' 4', ' 5', ' 6', ' 7', ' 8', ' 9',
     +           '10', '11', '12', '13', '14', '15', '16', '17', '18',
     +           '19', '20', '21', '22', '23', '24' /
C
C------------------  C O D E  ------------------------------------------
C
C                            CDTL 4   DRAW VERTEX CHAMBER FIELD WIRES
C                            CDTL 5   DRAW VERTEX CHAMBER SENSE WIRES
C                            CDTL 6   DRAW CROSSES FOR HITS
C
      GO TO ( 100, 2000 ) , IVIEW
C
C                            R PHI VIEW
C
  100 IF( (.NOT. DSPDTL(4))  .AND.  (.NOT. DSPDTL(5)) ) GO TO 1800
C
C                            LOAD CONSTANTS FOR RELATIVE POSITION
      XDEV = 0.0
      YDEV = 0.0
      ADEV = 0.0
      IF( HEAD(18) .LE. 100 ) GO TO 200
         XDEV = VDX
         YDEV = VDY
         ADEV = VROT
C
C                            DRAW CELL NUMBERS ON SCREEN
C                            UNLESS DEMAGNIFIED VIEW
C
  200 IF( JNDEX .NE. 16 .OR. ( FL22 .AND.
     *     ABS(XMAX-XMIN) .GT. ABS(XMAXST(20) - XMINST(20))) .OR.
     *     DSPDTM(16) ) GO TO 600
         CALL CHRSIZ( 4 )
         XSCAL = (XMAX - XMIN)/690.
         IF( FL22 ) XSCAL = (XMAXR - XMINR)/690.
C
         DO 500 I = 1, 24
            PHI = ANG1 + ANG2*FLOAT(I-1) + ADEV
            XN  = (RPIPV - 10.*XSCAL)*COS(PHI) + 4.0*XSCAL + XDEV
            YN  = (RPIPV - 10.*XSCAL)*SIN(PHI) - 3.0*XSCAL + YDEV
C
            IF( .NOT. FL22 ) GO TO 400
C
            IF( -XN .LT. XMINR .OR. -XN .GT. XMAXR .OR.
     *           YN .LT. YMINR .OR.  YN .GT. YMAXR ) GO TO 500
C
  400       CALL MOVEA( -XN, YN )
            CALL EOUTST( 2, HTX(I) )
  500    CONTINUE
C
  600 DDD  = 10.24 * 25.4 / ( XMAX - XMIN )
      RDT = 0.5/ABS(XMAX-XMIN)*ABS(XMAXST(20)-XMINST(20))
      NCOL = IFIX(10.0 * DDD)
      IF( NCOL .LT. 10 ) NCOL = 10
      RR11V = DISTW1
      RR22V = DISTW1 + DISTPW*(MWIRE-1)
      DO  1700  KV = 1, MCELL
        DO  1600  L = 4, 5
          IF (.NOT. DSPDTL(L)) GO TO 1600
C
             PHIV = ANG2*(KV-1) + ANG1*(L*2 - 9) + ADEV
             CSNV = COS(PHIV)
             SSNV = SIN(PHIV)
             XL1V = RR11V*CSNV + XDEV
             YL1V = RR11V*SSNV + YDEV
             IF (L .EQ. 5) GO TO 1100
               STEPXV = DISTPW * CSNV *.5
               STEPYV = DISTPW * SSNV *.5
C
C                            DRAW POTENTIAL WIRE PLANE BETWEEN CELLS
C
               DO 1000 IJ = 1, 13
                  XP1V   = XL1V + STEPXV*FLOAT(IJ-1) - 1.0*CSNV
                  YP1V   = YL1V + STEPYV*FLOAT(IJ-1) - 1.0*SSNV
                  XP2V   = XL1V + STEPXV*FLOAT(IJ-1) + 1.0*CSNV
                  YP2V   = YL1V + STEPYV*FLOAT(IJ-1) + 1.0*SSNV
                  CALL DRAMOV( -XP1V, YP1V, -XP2V, YP2V, 1 )
 1000          CONTINUE
               GO TO 1600
C
 1100        STEPXV = DISTPW * CSNV
             STEPYV = DISTPW * SSNV
C
C                            DRAW SIGNAL WIRES
C
             DO  1500  MV = 1, MWIRE
               IF(MV .NE. 1) GO TO 1300
               IF(KV .NE. 1) GO TO 1200
C
C                            DRAW COOLING PIPE IN CELL 1
C
                 XCOL = 96.5*COS(ANG1+ADEV) + XDEV
                 YCOL = 96.5*SIN(ANG1+ADEV) + YDEV
                 CALL PLYGON( NCOL, 3.0, -XCOL, YCOL, 0 )
                 CALL PLYGON( NCOL, 2.5, -XCOL, YCOL, 0 )
                 GO TO 1400
 1200          IF(KV .NE. 13) GO TO 1300
C
C                            DRAW COOLING PIPE IN CELL 13
C
                 XCOL = -96.5*COS(ANG1+ADEV) + XDEV
                 YCOL = -96.5*SIN(ANG1+ADEV) + YDEV
                 CALL PLYGON( NCOL, 3.0, -XCOL, YCOL, 0 )
                 CALL PLYGON( NCOL, 2.5, -XCOL, YCOL, 0 )
                 GO TO 1400
C
 1300          CALL POINTA( -XL1V, YL1V )
               IF( JNDEX .NE. 16 .OR. .NOT. FLVCDO(19) )  GO TO 1400
                  CALL PLYGON( 11, RDT, -XL1V, YL1V, 0 )
 1400          XL1V = XL1V + STEPXV
               YL1V = YL1V + STEPYV
 1500        CONTINUE
 1600     CONTINUE
 1700 CONTINUE
C
C                            MARK BAD CELL BORDER
      IF( (JNDEX .NE. 16) .OR. (.NOT. DSPDTL(4)) .OR.
     *    (HEAD(18) .LE. 100) ) GO TO 1800
         CS1213 = COS(13.0*ANG2 - ANG1 + ADEV)
         SN1213 = SIN(13.0*ANG2 - ANG1 + ADEV)
         XF1213 = (RR11V-1.0)*CS1213 + XDEV
         YF1213 = (RR11V-1.0)*SN1213 + YDEV
         XL1213 = (RR22V+1.0)*CS1213 + XDEV
         YL1213 = (RR22V+1.0)*SN1213 + YDEV
         CALL DRAMOV( -XF1213, YF1213, -XL1213, YL1213, 1 )
 1800 NN = IFIX(500.*DDD)
      IF( NN .LT. 40 )    NN = 40
      CALL PLYGON( NN, RVXC, -XDEV, YDEV, 0 )
      CALL PLYGON( NN, RVXC+DRVXC, -XDEV, YDEV, 0 )
      RETURN
C
C                            Z VIEWS
C
 2000 CALL DRAMOV( ZVXCM, RPIPV+DRPIPV, ZVXCM, RVXC, 0 )
      CALL DRAWA( ZVXCP, RVXC )
      CALL DRAWA( ZVXCP, RPIPV+DRPIPV )
      CALL DRAWA( ZVXCM, RPIPV+DRPIPV )
C
      CALL DRAMOV( ZVXCM, -RPIPV-DRPIPV, ZVXCM, -RVXC, 0 )
      CALL DRAWA( ZVXCP, -RVXC )
      CALL DRAWA( ZVXCP, -RPIPV-DRPIPV )
      CALL DRAWA( ZVXCM, -RPIPV-DRPIPV )
      X1V = ZVXCM
      X2V = ZVXCP
C
C                           DRAW WIRES OF VERTEX CHAMBER
C
      IF( .NOT. DSPDTL(5) ) RETURN
      DO  2020 KV = 1,2
        RV = DISTW1 + (KV - 1) * (MWIRE - 1) * DISTPW
        CALL DRAMOV( X1V,  RV, X2V,  RV, 1 )
        CALL DRAMOV( X1V, -RV, X2V, -RV, 1 )
 2020 CONTINUE
      RETURN
C
      END

C   29/03/82         4  MEMBER NAME  R1MODE   (JADESR)      FORTRAN
      SUBROUTINE R1MODE
C---------------------------------
C ROUTINE TO DETERMINE REDUC1 MODE
C GFP -- SEPTEMBER 1981
C---------------------------------
      LOGICAL*1 DSN(52),TAPEON
#include "cutsr1.for"
      REAL*8 WORD8,ORDERS(2)/'STARTRUN','NOTRUNS '/
C-------------------
C PRINT PROGRAM NAME
C-------------------
      PRINT5,NVRSN
   5  FORMAT(1H1//
     +1X,10('-')/
     +1X,10('-')/
     +1X,10('-'),5X,'==============================================='/
     +1X,10('-'),5X,'JADE DATA REDUCTION STEP 1 PROGRAM VERSION ',I4/
     +1X,10('-'),5X,'==============================================='/
     +1X,10('-')/
     +1X,10('-'))
C------------------------------
C DETERMINE CALIBRATION SOURCE
C------------------------------
      CALL DSNFDD(8HFT02F002,DSN,IER)
      IF(IER.NE.0)GOTO15
      TAPEON=.TRUE.
      PRINT10
 10   FORMAT(1X,10('-'),1X,
     +        'CALIBRATION FILE ON FT22F001 OVERWRITTEN FROM FT02F001')
      GOTO18
C
C
 15   CALL DSNFDD(8HFT02F001,DSN,IER)
      TAPEON=.FALSE.
      PRINT16
 16   FORMAT(1X,10('-'),1X,
     + 'CALIBRATION FILE READ DIRECTLY FROM FT22F001')
C----------------------
C PRINT INPUT FILE NAME
C----------------------
 18   PRINT99
      PRINT19,(DSN(I),I=1,44)
      PRINT99
 19   FORMAT(1X,10('-'),' INPUT FILE OF EVENTS  = ',44A1)
C-----------------------
C PRINT OUTPUT FILE NAME
C-----------------------
      CALL DSNFDD(8HFT03F001,DSN,IER)
      PRINT20,(DSN(I),I=1,44)
      PRINT99
 20   FORMAT(1X,10('-'),' OUTPUT FILE OF EVENTS = ',44A1)
C------------------------------------
C DETERMINE FIRST EVENT TO BE TREATED
C------------------------------------
      READ(5,30,END=35)WORD8,I1,I2
  30  FORMAT(A8,1X,I8,1X,I8)
      IF(WORD8.NE.ORDERS(1))GOTO35
      NRUNST = I1
      NEVTST = I2
  35  PRINT36,NRUNST,NEVTST
      PRINT99
  36  FORMAT(1X,10('-'),' PROGRAM TO START AT RUN',I6,' EVENT',I6)
C-----------------------------
C DETERMINE RUNS TO BE SKIPPED
C-----------------------------
      NOTTOT=0
      READ(5,40,END=42)WORD8,(NOTRUN(I),I=1,10)
  40  FORMAT(A8,10I6)
      IF(WORD8.NE.ORDERS(2))GOTO42
      DO 41 I=1,10
      IF(NOTRUN(I).EQ.0)GOTO42
  41  NOTTOT=NOTTOT+1
  42  IF(NOTTOT.GT.0)PRINT48,NOTTOT,(NOTRUN(I),I=1,10)
      IF(NOTTOT.EQ.0)PRINT49,NOTTOT
  48  FORMAT(
     +1X,10('-'),I3,' RUNS TO BE AXED',10I6/
     +1X,10('-')/
     +1X,10('-'))
  49  FORMAT(
     +1X,10('-'),I3,' RUNS TO BE AXED'/
     +1X,10('-')/
     +1X,10('-'))
C-----------------------------
C PRINT LEAD GLASS ENERGY CUTS
C-----------------------------
      IF(NVRSN.EQ.1981)PRINT80,ELGLM(1),ELGLM(2),ELGLM(3)
      IF(NVRSN.EQ.1982)PRINT81,(ELGLM(I),I=1,8)
      PRINT99
 80   FORMAT(1X,10('-'),' LEAD GLASS ENERGY THRESHOLDS ',
     +' ETOTLM = ',F6.0,', EMIN =',F6.0,', EMNCYL =',F6.0)
 81   FORMAT(1X,10('-'),    ' LEAD GLASS ENERGY THRESHOLDS ',
     +                      ' ETOT / EBAR :',4F6.0/
     +       1X,10('-'),38X,        'ECAP :',4F6.0)
C---------------------------------
C READ CALIBRATION FILES FROM TAPE
C---------------------------------
      IF(TAPEON)CALL KALPRE
      IF(TAPEON)PRINT99
 99   FORMAT(1X,10('-')/1X,10('-'))
      RETURN
      END
      SUBROUTINE VTXINI
C
C
C DUMMY ROUTINE TO REPLACE VTXINI FOR REDUC1 JOB
C
C
      RETURN
      END
      SUBROUTINE DUMP0C
C
C
C DUMMY ROUTINE TO REPLACE DUMP0C FOR REDUC1 JOB
C
C
      RETURN
      END
      SUBROUTINE RDMTCO(I)
      ENTRY      RDJETC
C
C
C DUMMY ROUTINE TO REPLACE RDMTCO/RDJETC FOR REDUC1 JOB
C
C
      PRINT100
 100  FORMAT(' *** RDMTCO IS A DUMMY ROUTINE --> THIS REDUC1 PACKAGE',
     +       ' IS NOT FOR MCARLO ***')
      RETURN
      END

C   04/03/80 704231727  MEMBER NAME  TFCTD1   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TFCTD1(INPA)
C
C              COMPUTES THE HIT-POSITION AND PATH-LENGTH,AND
C          MAKES TABLES
C            TRK(5,N)    : Z, PHAI, P(MEV), PATH, ZS
C            ITRK(5,CNT#): CNT#, MULTIPLICITY, TRK#1, TRK#2, ...
C            ITRC(TRK#)  : CNT# <=> TRK#
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
C
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/TOFHIT/XTOF(50),YTOF(50),ZTOF(50)
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
C   12/03/79 007281422  MEMBER NAME  DDATA    (S)           FORTRAN
C
      COMMON /BCS/ IDATA(10000)
      DIMENSION DATA(10000)
      INTEGER *2 HDATA(20000)
      EQUIVALENCE (IDATA(1),DATA(1)), (HDATA(1),IDATA(1))
C
       COMMON/CTPCNS/BENGEV,BKGAUS
C
       DATA PAI/ 3.1415927/ ,IBUG/100/,JSQRT/10/
       DATA RTOF,ZLN,DLMAX/ 920.0, 1610.0, 1.0E4/
       DATA DPAI/.14960/
      DATA IENTRY/0/
      IF(IENTRY.NE.0)  GOTO  49
      RTOF2= RTOF*RTOF
      IENTRY = 1
C
   49 IBUG = IBUG + 1
      IF(IBUG.LE.10) PRINT 105,NEV
  105 FORMAT(//' NEW EVENT TFCTD1 ',I5/)
      CALL SETSL(ITRC,0,50*4,0)
      CALL SETSL(TRK,0,250*4,0)
      CALL SETSL(ITRK,0,210*4,0)
C
      NTRK = IDATA(INPA+2)
      LTR = IDATA(INPA+3)
      ISTART = INPA+IDATA(INPA+1)
      IF(IBUG.LE.0) PRINT 676,NTRK,INPA,ISTART
  676 FORMAT(' TRACKS TFCTD1 ',3I10)
      IF(NTRK.GT.50) NTRK = 50
      IF(NTRK.LE.0) RETURN
C/////////
C
       DO 1000 I= 1,NTRK
C
C=========   LOAD TRACK INFORMATION
C
      IP=ISTART+(I-1)*LTR
            ITNUM= IDATA(IP+1)
C/////////
            IF(ITNUM.NE.I) GO TO 1000
C CHECK THAT TRACK HITS TOF COUNTER IN Z
      DZDR = DATA(IP+30)
      ZT   = DATA(IP+31) + DZDR * RTOF
      ZTOF(I) = ZT
      IF(ABS(ZT).GT.ZLN+100.)  GOTO  1000
            X1= DATA(IP+5)
            Y1= DATA(IP+6)
            Z1= DATA(IP+7)
            IF(ABS(Z1).GT.ZLN) GO TO 1000
            X2= DATA(IP+12)
            Y2= DATA(IP+13)
            Z2= DATA(IP+14)
            IF(ABS(Z2).GT.ZLN) GO TO 1000
C
C  COMPUTE CENTER OF CURVATURE FROM TRACK PARAMETERS
C
      IF(ABS(DATA(IP+25)).LT.1.E-28) GOTO  1000
      R = 1./DATA(IP+25)
      ITYPE = IDATA(IP+18)
      IF(IBUG.LE.10) PRINT 111,ITYPE,R
  101 FORMAT(1X,2I5,10F12.5)
  111 FORMAT(1X,I5,10F12.5)
      IF(IDATA(IP+18).EQ.2)  GOTO  30
      IF(IDATA(IP+18).NE.1)  GOTO  1000
C
C  CIRCLE
C
      IF(ABS(DATA(IP+19)).LT.1.E-28) GOTO  1000
      RC= 1./DATA(IP+19)
      D0 = DATA(IP+20)+RC
      ALPHC = DATA(IP+21)
      XM = D0*COS(ALPHC)
      YM = D0*SIN(ALPHC)
      XCL = DATA(IP+20)*COS(ALPHC)
      YCL = DATA(IP+20)*SIN(ALPHC)
      IF(IBUG.LE.0) PRINT 101,IDATA(IP+18),RC,D0,ALPHC,XM,YM,XCL,YCL
      GOTO  31
C
C PARABOLA
   30 CONTINUE
      RP = R
      ALPHP = DATA(IP+19)
      X0 = DATA(IP+20)
      Y0 = DATA(IP+21)
      XM = X0 + RP*SIN(ALPHP)
      YM = Y0 - RP*COS(ALPHP)
      D0 = SQRT(XM**2+YM**2)
      DS = D0-ABS(RP)
      IF(ABS(XM).LT..0000001)  GOTO  32
      ALPH = ATAN2(YM,XM)
      GOTO  33
   32 ALPH = PAI/2.
   33 XCL = DS*COS(ALPH)
      YCL = DS*SIN(ALPH)
      IF(IBUG.LE.0) PRINT 101,IDATA(IP+18),RP,ALPHP,X0,Y0,XM,YM,XCL,
     1 YCL
   31 CONTINUE
      ZCL = SQRT(XCL**2+YCL**2)*DZDR+DATA(IP+31)
C
C  COMPUTE HIT POINT AT TOF COUNTER =
C  POINT ON THE CIRCLE WITH RADIUS R, MIDDLE XM,YM WHICH HAS A DISTANC
C  FROM THE ORIGIN OF RTOF
C
C   STRAIGHT LINE EXTRAPOLATION
C
      RL = SQRT(X2*X2+Y2*Y2)
      RD = RTOF - RL
      IF(ABS(DATA(IP+15)).LT..00001) GOTO  650
      TANXY = DATA(IP+16)/DATA(IP+15)
      PHIXY = ABS(ATAN(TANXY))
      XTE = X2+RD*COS(PHIXY)*SIGN(1.,DATA(IP+15))
      YTE = Y2+RD*SIN(PHIXY)*SIGN(1.,DATA(IP+16))
      GOTO  651
  650 XTE = 0.
      YTE = RTOF
  651 IF(IBUG.LE.0) PRINT 102 ,XTE,YTE
C  FOR HIGH MOMENTA TAKE STRAIGHT EXTRAPOLATION
      IF(ABS(R).GT.7000.)  GOTO  50
C  FOR LOW MOMENTA CALCULATE INTERCEPT OF 2 CIRCLES
      A = RTOF2-R*R+XM*XM+YM*YM
      P = -YM*A/(XM**2+YM**2)
      Q = -(XM**2*RTOF2-A*A/4.)/(XM**2+YM**2)
      IF(IBUG.LE.0) PRINT 102,A,P,Q
  102 FORMAT(1X,10E12.5)
      IF(P*P-4.*Q.LE.0.)  GOTO  987
      YT1 = .5*(-P+SQRT(P*P-4.*Q))
      YT2 = .5*(-P-SQRT(P*P-4.*Q))
      DY1 = ABS(YTE-YT1)
      DY2 = ABS(YTE-YT2)
C TAKE SOLUTION WHICH IS CLOSER TO STRAIGHT EXTRAPOLATION
      DC11 = 5000.
      DC12 = 5000.
      IF(RTOF2-YT1*YT1.LT.0.) GOTO  7
      XT11= SQRT(RTOF2-YT1*YT1)
      XT12= -XT11
      DC11= (XT11-XM)**2+(YT1-YM)**2-R*R
      DC12= (XT12-XM)**2+(YT1-YM)**2-R*R
    7 IF(RTOF2-YT2*YT2.GT.0.) GOTO  8
      DC21 = 5000.
      DC22 = 5000.
      IF(DC11.GE.5000.)  GOTO  988
      GOTO  9
    8 XT21= SQRT(RTOF2-YT2*YT2)
      XT22= -XT21
      DC21= (XT21-XM)**2+(YT2-YM)**2-R*R
      DC22= (XT22-XM)**2+(YT2-YM)**2-R*R
    9 IF(IBUG.LE.0) PRINT 102,YT1,XT11,XT12,DC11,DC12,YT2,XT21,XT22,
     1 DC21,DC22
C DECIDE WHICH 2 SOLUTIONS FIT CIRCLES
      XT1 = XT11
      IF(ABS(DC12).LT.ABS(DC11)) XT1 = XT12
      XT2 = XT21
      IF(ABS(DC22).LT.ABS(DC21)) XT2 = XT22
C
C  TAKE SOLUTION CLOSEST TO STRAIGHT TRACK EXTRAPOLATION
C
      DE1 = SQRT((XTE-XT1)**2+(YTE-YT1)**2)
      DE2 = SQRT((XTE-XT2)**2+(YTE-YT2)**2)
      IF(IBUG.LE.0) PRINT 102,DE1,DE2
      YT = YT1
      IF(ABS(DE2).LT.ABS(DE1)) YT = YT2
      XT = XT1
      IF(ABS(DE2).LT.ABS(DE1)) XT = XT2
      XTOF(I) = XT
      YTOF(I) = YT
      IF(IBUG.LE.10) PRINT 102,XT,XTE,YT,YTE
      EXTR = SQRT((XT-XTE)**2+(YT-YTE)**2)
      GOTO 52
  987 CONTINUE
      ISQRT = ISQRT + 1
      IF(ISQRT.LE.0) PRINT 103,I,ISQRT
  103 FORMAT(' NEG SQRT ',5I10)
      IF(ISQRT.LE.0) PRINT 102,A,P,Q,R,X1,Y1,X2,Y2,XM,YM
      GOTO  1000
  988 JSQRT = JSQRT + 1
      IF(JSQRT.LE.0) PRINT 507,RTOF,YT
  507 FORMAT(' RTOF YT  --  NEG SQRT ',2E12.3)
      IF(JSQRT.LE.0) PRINT 102,A,P,Q
      IF(JSQRT.LE.0) PRINT 102,YT1,YT2,DY1,DY2,YT
      GOTO  1000
C
C=========   PATH LENGTH
C
   50 CONTINUE
      XT = XTE
      YT = YTE
      XTOF(I) = XT
      YTOF(I) = YT
   52 SEHNE = SQRT((XT-XCL)**2+(YT-YCL)**2)
      SINM = ABS(SEHNE/2./R)
      IF(SINM.GT.1.)  GOTO  1000
      ANGM = ASIN(SINM)
      PATHR = ABS(2.*ANGM*R)
      COSA = 1./SQRT(1.+DZDR*DZDR)
      IF(COSA.EQ.0.) COSA = 1.
      PATH= PATHR/COSA
      PHAI = ATAN2(YT,XT)
      IF(PHAI.LT.0.) PHAI = 2.*PAI+PHAI
      IF(IBUG.LE.0) PRINT 102,SEHNE,PATHR,PATH,PHAI
C/////////
C
C=========   STORE THE RESULTS INTO COMMON
C---   ITRC(50) : TRACK # I <=> COUNTER # NCNT
            PHD= PHAI-DPAI/2.
            IF(PHD.GT.0.) GO TO 300
            NCNT= 1
            GO TO 310
 300        NCNT= IFIX(PHD/DPAI)+2
            IF(NCNT.GE.43) NCNT=NCNT-42
 310        ITRC(I)= NCNT
      IF(IBUG.LE.10) PRINT 101,I,NCNT,ZCL
      IF(IBUG.LE.10) PRINT 111,I,XTOF(I),YTOF(I),ZTOF(I)
C---   ITRK(5,42) : COUNTER # NCNT <=> TRACK MULTIPLICITY
            ITRK(1,NCNT)= NCNT
            MTPY= ITRK(2,NCNT)
            MTPY= MTPY+1
            ITRK(2,NCNT)= MTPY
       IF(MTPY.GE.4) GO TO 320
            MTPY= MTPY+2
            ITRK(MTPY,NCNT)= I
C---   TRK(5,50) : TRACK # <=> Z,PHAI,PATH,MOMENTUM,Z-SCATT
C THE MINUS SIGN IS TO COMPENSATE FOR THE DEFINITION OF R ABOVE
 320        PGEVR= -0.03*R*ABS(BKGAUS)/1000.
      PGEV = PGEVR/COSA
      IF(IBUG.LE.10) PRINT 751,R,PGEVR,COSA,PGEV
  751 FORMAT( ' PGEV ',4E12.5/ )
            TRK(1,I)= ZTOF(I)
            TRK(2,I)= PHAI
            TRK(3,I)= PATH
            TRK(4,I)= PGEV
            TRK(5,I)= ZCLOS
C
C/////////
 1000   CONTINUE
C/////////
        RETURN
        END

C   01/11/84 807251536  MEMBER NAME  EVDISP0  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EVDISP(INDEX)
C-----------------------------------------------------------------------
C
C   AUTHOR: J. OLSSON      ?    : EVENT DISPLAY
C
C      MOD: C. BOWDERY   13/03/84 : CDTL 20/21 REVERSED TRUE/FALSE
C      MOD: C. BOWDERY   21/03/84 : FWCHEV ALWAYS CALLED FOR RU VIEW NOW
C      MOD: C. BOWDERY   23/03/84 : FWCHEV NOT CALLED IN CYL ANYMORE
C      MOD: C. BOWDERY   28/04/84 : VERTEX CHAMBER CODE FROM HAGEMANN
C      MOD: C. BOWDERY   10/06/84 : NEW COMMAND NUMBERS.
C      MOD: C. BOWDERY   20/06/84 : CLEAR DETDRW FLAG WHEN CALLED
C      MOD: C. BOWDERY   27/06/84 : CDTL 1 OFF ONLY NOT DRAWS ID NOW
C      MOD: J. HAGEMANN  10/10/84 : INCLUDE DRAWING OF VERTEX CHAMBER
C                                   REAL DATA / OTHER SUBROUTINES
C                                   REMOVED (NOW OWN MEMBER)
C      MOD: J. HAGEMANN  19/10/84 : SPECIAL VERTEX CHAMBER VIEW ADDED
C      MOD: J. HAGEMANN  29/11/84 : UPDATED VERTEX CHAMBER CODE
C      MOD: J. HAGEMANN  30/09/85 : CHANGES FOR VTHT- VPAT -BANKS
C      MOD: J. HAGEMANN  13/03/86 : EXTENDED COMMON CVX
C      MOD: J. HAGEMANN  20/05/86 : DRAW BP-COUNTER FOR INDEX=20 IF SET
C      MOD: J. HAGEMANN  16/12/86 : FOR VTXC Z-COORDINATE DISPLAY
C LAST MOD: J. HAGEMANN  27/02/87 : FOR 1986 ID-DATA SMALLER CROSSES IN
C                                   R-FI-VIEWS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
      LOGICAL INNERC,LEADGL,MUONFL,PHNUMS,PHHIST
      LOGICAL FL18,FL22,FL24
      LOGICAL DETDRW,REDRDT
      LOGICAL LVTXC
      LOGICAL FLVCDO
C
#include "cgraph.for"
#include "cjdrch.for"
#include "cgeov.for"
#include "cjvcel.for"
#include "cjvtxc.for"
C
#include "cgeo1.for"
#include "cgeo2.for"
#include "cdata.for"
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  KZAMP,IMW(132)
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CVCEX  / LVTXC
      COMMON / CVX    / NNPATR,NDUMM,NNJETC,NNVTXC
      COMMON / CADC   / CATAG(190)
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CGRAP6 / DETDRW
      COMMON / CGVCDO / FLVCDO(20)
C
      DIMENSION HMW(264)
C
      EQUIVALENCE (IMW(1),HMW(1))
C
      DATA ICCO  / 0 /
C
C------------------  C O D E  ------------------------------------------
C
      CRLEN = 4.0
      IF( HEAD(16) .EQ. 1986 ) CRLEN = 2.75
C
      IF( ICCO .EQ. 1 ) GO TO 1
      ICCO   = 1
      DEFIX  = TWOPI / 84.0
      SH1    = BLDEP *  0.10
      SH2    = BLFI  *  0.16667
C
      ADX    =    0.0
      ADY    = 2800.0
      YADD   =  900.0
      ADDEND =   84.0     * BLFI
      BLSEX  =    0.16667 * BLXY
C
   1  JNDEX  = INDEX
      IF( INDEX .GT. 7 ) JNDEX = INDEX - 4
      IF( INDEX .LT. 1  .OR.  INDEX .GT. 20 ) RETURN
C
      LASTVW = INDEX
      DETDRW = .FALSE.
C
C                            SET DISPLAY FLAGS
C
      INNERC = JNDEX.LE.7  .AND.  DSPDTL(1)  .AND.  DSPDTL(21)
      LEADGL = (JNDEX.EQ.2.OR.JNDEX.EQ.3.OR.JNDEX.EQ.5.OR.JNDEX.EQ.6.OR.
     +          JNDEX.EQ.7)  .AND.  DSPDTL(2)
      MUONFL = (JNDEX.EQ.3.OR.JNDEX.EQ.6.OR.JNDEX.EQ.7).AND.DSPDTL(3)
      PHNUMS = LEADGL  .AND.  ( .NOT. DSPDTL(7))
      PHHIST = LEADGL  .AND.  DSPDTL(7)
C
C                            GET COMMAND ARGUMENT. MAY BE ZERO.
C
      NECC   = ACMD
C
C                            MARK INTERACTION POINT AND
C                            DRAW ARROW TOWARD CENTER OF PETRA.
C
      CALL CAPMRK(INDEX,IESUM)
C
C                            NOTHING MORE TO DO FOR VERTEX REGION VIEWS
C
      IF( INDEX .GE. 17  .AND.  INDEX .LE. 19 ) RETURN
C
C                            SPECIAL VERTEX CHAMBER VIEW
C
      IF( INDEX .EQ. 20 ) GO TO 7050
C
C                            SPECIAL STEFFEN LG HISTOGRAM REQUIRED?
C
      IF( .NOT. PHHIST ) GO TO 5003
C     CALL TRMOUT(80,'ENERGY HISTOGRAMS NOT AVAILABLE.^')
      IPJ=IDATA(IBLN('ALGN'))
      IF(IPJ.LE.0) GO TO 5003
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 5003
      IPJ=2*IPJ
      LIM1=IPJ+8
      LIM2=IPJ+2*NWO
      DO 5005 IJK=1,84
      IMW(IJK)=0
 5005 CONTINUE
      DO 5006 IJK=LIM1,LIM2,2
      IENER=HDATA(IJK)
      IF(IENER.LE.0) GO TO 5006
      IADDR=HDATA(IJK-1)
      IF(IADDR.GT.2687) GO TO 5006
      NROW=IADDR/32+1
      IHINDX=NROW
      IF(JNDEX.LT.4) GO TO 5007
      IHINDX=IADDR-32*(NROW-1)
      IF((INDEX.LE.7).AND.(NROW.GT.21).AND.(NROW.LT.64))
     1IHINDX=IHINDX+32
      IF((INDEX.GT.7).AND.(NROW.GT.42)) IHINDX=IHINDX+32
 5007 CONTINUE
      IMW(IHINDX)=IMW(IHINDX)+IENER
 5006 CONTINUE
      IF(JNDEX.GT.3) GO TO 5008
      LDRAW=0
      DO 5014 IJK=1,84
      LAST=IJK-1
      IF(LAST.EQ.0) LAST=84
      NEXT=IJK+1
      IF(NEXT.EQ.85) NEXT=1
      IF(IMW(IJK).GT.1) GO TO 5015
      IF(IMW(LAST).GT.1) GO TO 5015
      IF(IMW(NEXT).GT.1) GO TO 5015
      GO TO 5014
 5015 CONTINUE
      PHI=DEFIX*IJK
      X1=-RLG*COS(PHI)
      Y1=RLG*SIN(PHI)
      IF(LDRAW.EQ.LAST) GO TO 5016
      X0=-RLG*COS(PHI-DEFIX)
      Y0=RLG*SIN(PHI-DEFIX)
      CALL MOVEA(X0,Y0)
 5016 CONTINUE
      CALL DRAWA(X1,Y1)
      LDRAW=IJK
 5014 CONTINUE
      AMP=IMW(84)
      IF(IMW(84).LE.1) AMP=0.
      IF(IMW(84).GT.1) AMP=60.*ALOG10(AMP)
      X0=-RLG-AMP
      Y0=0.
      CSSP=1.
      SSSP=0.
      IF(AMP.GT.0.) CALL MOVEA(X0,Y0)
      DO 5009 IJK=1,84
      AMP=IMW(IJK)
      IF(AMP.LE.1.) GO TO 5009
      AMP=60.*ALOG10(AMP)
      RAD=RLG+AMP
      LAST=IJK-1
      IF(LAST.EQ.0) LAST=84
      IF(IMW(LAST).GT.1) GO TO 5010
      PHI=DEFIX*LAST
      CSSP=COS(PHI)
      SSSP=SIN(PHI)
      X0=-RLG*CSSP
      Y0=RLG*SSSP
      CALL MOVEA(X0,Y0)
 5010 CONTINUE
      X0=-RAD*CSSP
      Y0=RAD*SSSP
      CALL DRAWA(X0,Y0)
      PHI=PHI+DEFIX
      CSSP=COS(PHI)
      SSSP=SIN(PHI)
      X0=-RAD*CSSP
      Y0=RAD*SSSP
      CALL DRAWA(X0,Y0)
      NEXT=IJK+1
      IF(NEXT.EQ.85) NEXT=1
      IF(IMW(NEXT).GT.1) GO TO 5009
      X0=-RLG*CSSP
      Y0=RLG*SSSP
      CALL DRAWA(X0,Y0)
 5009 CONTINUE
      GO TO 5003
 5008 CONTINUE
      CALL MOVEA((ZLGMI    -BLZ), RLG)
      CALL DRAWA((ZLGMI+33.*BLZ), RLG)
      CALL MOVEA((ZLGMI    -BLZ),-RLG)
      CALL DRAWA((ZLGMI+33.*BLZ),-RLG)
      DO 5011 IKJ=1,2
      IOFF=32*(IKJ-1)
      ISIGN=3-2*IKJ
      X0=ZLGMI
      Y0=ISIGN*RLG
      CALL MOVEA(X0,Y0)
      DO 5012 IJK=1,32
      AMP=IMW(IJK+IOFF)
      IF(AMP.LE.1.) GO TO 5012
      AMP=60.*ALOG10(AMP)
      IF(IJK.EQ.1) GO TO 5013
      LAST=IJK-1
      IF(IMW(LAST+IOFF).GT.1) GO TO 5013
      X0=ZLGMI+BLZ*LAST
      CALL MOVEA(X0,Y0)
 5013 CONTINUE
      Y0=ISIGN*(RLG+AMP)
      CALL DRAWA(X0,Y0)
      X0=X0+BLZ
      CALL DRAWA(X0,Y0)
      NEXT=IJK+1
      IF(NEXT.EQ.33) NEXT=84-IOFF
      IF(IMW(NEXT+IOFF).GT.1) GO TO 5012
      Y0=ISIGN*RLG
      CALL DRAWA(X0,Y0)
 5012 CONTINUE
 5011 CONTINUE
C
C        DRAW IN END CAPS. ENERGIES COMPUTED IN THE CAPTION ROUTINE
C        AND TUCKED AWAY INTO THE LAST 24 LOCATIONS IN THE SCRATCH
C        ARRAY "HMW" IN COMMON "CWORK1".
C
      DO 5017 IKJ=1,2
      X0=ZENDMI
      IF(IKJ.EQ.2) X0=ZENDPL
      Y0=-6*BLXY
      CALL MOVEA(X0,Y0)
      DO 5018 KJI=1,12
      IRETRV=84+12*(IKJ-1)+KJI
      AMP=IMW(IRETRV)
      IF(AMP.GT.1.) AMP=60.*ALOG10(AMP)
      IF(AMP.LE.1.) AMP=0.
      X=X0+(2*IKJ-3)*AMP
      Y=Y0+(KJI-1)*BLXY
      CALL DRAWA(X,Y)
      Y=Y+BLXY
      CALL DRAWA(X,Y)
 5018 CONTINUE
      X=X0
      CALL DRAWA(X,Y)
 5017 CONTINUE
 5003 CONTINUE
C
      IF( JNDEX .GT. 7 ) GO TO 3
      IF( JNDEX .GT. 3 ) GO TO 5019
C
C
C                            ***************
C                            *  RFI-VIEWS  *
C                            ***************
C
 7050 IF( .NOT. DSPDTM(13) ) GO TO 4
C
C                                      VERTEX CHAMBER
C
      IF( HEAD(18) .LE. 100 ) GO TO 7070
C                            BRANCH FOR REAL DATA
C                                      TEST IF RAW DATA BANK  B P C H
C                                      IS EXISTING
         IPBPCH = IDATA(IBLN('BPCH'))
         IF( IPBPCH .LE. 0 )  GO TO 4
C
            IF( .NOT. FLVCDO(4) ) GO TO 7070
C
C                                      FORCED DISPLAY OF  B P C H
               ILBPCH = IDATA(IPBPCH)
C
               IF( ILBPCH .LE. 1 ) GO TO 4
                  CALL DRVCRD( JNDEX, IPBPCH, ILBPCH )
                  GO TO 4
C
C                            BRANCH FOR REAL DATA AND MC-DATA
C
 7070 CALL DISPVC(INDEX,1)
C
C                                      INNER DETECTOR
C
  4   IF( INDEX .EQ. 20 ) INNERC = .TRUE.
C
      IF( .NOT. INNERC ) GO TO 5
      KZAMP = 0
      IF(NNJETC.LE.0) GO TO 2701
      CALL CLOC(IPJ,'JETC',NNJETC)
      IF(IPJ.GT.0) GO TO 2702
      WRITE(6,2703) NNJETC
2703  FORMAT(' JETC BANK NR',I3,' (GIVEN BY COMMAND JETC) NOT EXISTING')
2701  IPJ = IDATA(IBLN('JETC'))
2702  IF(IPJ.LE.0) GO TO 5
      NWO = (HDATA(2*IPJ+99)-HDATA(2*IPJ+3)+100)/2
C--  LOOP OVER NR OF WORDS IN EVENT
      IF(NWO.LE.2) GO TO 5
      IPJ = 2*IPJ
      NI = IPJ + 101
   91 CONTINUE
      CALL FICOOR(0,NI,NWE)
      IF(NWE.LT.-500) GO TO 5
      IF(NWE.EQ.0) GO TO 9111
C     IF(DSPDTL(26).AND.TBIT(NWE,31)) GO TO 9111
      CALL HITMRK( JNDEX, -X1, Y1, CRLEN, 0 )
      CALL HITMRK( JNDEX, -X2, Y2, CRLEN, 0 )
C--
9111  IF(NI.LE.(IPJ+2*NWO)) GO TO 91
C
      IF( INDEX .EQ. 20 .AND. LVTXC ) RETURN
      IF( INDEX .EQ. 20 .AND. .NOT. LVTXC ) GO TO 51
C
C     IF(KZAMP.GT.0.AND..NOT.FL18)
C    $ CALL DIAGIN('Z-AMP SUM=0, TIMES: ',1,KZAMP,NI,NI,NI,NI,NI)
C
C                                      Z CHAMBER
C
  5   IF( .NOT. DSPDTM(11) ) GO TO 51
      IPZETC = IDATA(IBLN('ZETC'))
      IF( IPZETC .LE. 0 )    GO TO 51
      LENZC  = IDATA(IPZETC)
      IF( LENZC  .LT. 3 )    GO TO 51
      IZHITS = (LENZC-1)/2
      NWO    = IPZETC + LENZC -2
      IPZETC = IPZETC + 1
52    IF( IPZETC .GT. NWO )  GO TO 51
C
      NWIR   = HDATA(2*IPZETC + 1)/8
      CALL RZHITS(IPZETC,XZ,YZ,XZ1,YZ1,XZ2,YZ2,ZZ1,ZZ2,IERR)
      CALL RZDRAW(NWIR,XZ,YZ,XZ1,YZ1,XZ2,YZ2,ZZ1,ZZ2,1)
C
      IPZETC = IPZETC + 2
      GO TO 52
C
C                                      TOF AND BP HODOSCOPE DISPLAY
C
  51  CALL HODRFI
C
C                                      LEAD GLASS DISPLAY (NUMBERS)
C
      IF( PHNUMS ) CALL PBGRFI( SH1, SH2, 4.0 * SH2, DEFIX )
C
C                                      MUON FILTER
C
      IF( MUONFL ) CALL MUHDSP
      IF( MUONFL  .AND.  DSPDTL(18) ) CALL TR3DSP
      RETURN
C
C
C                            ************************
C                            *  ZX-VIEWS, ZY-VIEWS  *
C                            ************************
C
C                                      VERTEX CHAMBER
C
 5019 IF( .NOT. DSPDTM(13) ) GO TO 715
         CALL DISPVC(INDEX,2)
C
C                                      INNER DETECTOR
C
 715  KZAMP = 0
      IF( .NOT. INNERC ) GO TO 11
      IF( FL18  .AND.  .NOT. DSPDTL(20) ) GO TO 11
      IF(NNJETC.LE.0) GO TO 2801
      CALL CLOC(IPJ,'JETC',NNJETC)
      IF(IPJ.GT.0) GO TO 2802
      WRITE(6,2703) NNJETC
2801  IPJ = IDATA(IBLN('JETC'))
2802  IF(IPJ.LE.0) GO TO 11
      NWO = (HDATA(2*IPJ+99)-HDATA(2*IPJ+3)+100)/2
      IF(NWO.LE.2) GO TO 11
      IPJH = 2*IPJ
      NI = IPJH + 101
   93 CONTINUE
C     LOOP OVER WIRES
      CALL FICOOR(1,NI,NWE)
      IF(NWE.LT.-500) GO TO 11
      IF(NWE.EQ.0) GO TO 9333
      X0 = ZET
      IF((.NOT.DSPDTL(9)).OR.DSPDTL(10)) GO TO 4001
      Y0 = R
      CALL HITMRK( JNDEX, ZET, Y0, 4.0, 0 )
      GO TO 4002
 4001 CONTINUE
      DO 4003 LRHIT=1,2
      IF(LRHIT.EQ.2) GO TO 4004
      RLRHI=R1
      FILRH=FI1
      GO TO 4005
 4004 CONTINUE
      RLRHI=R2
      FILRH=FI2
 4005 CONTINUE
      Y0 = RLRHI
C      GET PROJECTED Y-COORDINATE
       IF(INDEX.LE.7) YPRO =  RLRHI*COS(FILRH)
       IF(INDEX.GT.7) YPRO =  RLRHI*SIN(FILRH)
      IF(.NOT.DSPDTL(9)) Y0 = YPRO
      CALL HITMRK( JNDEX, ZET, Y0, 4.0, 0 )
 4003 CONTINUE
 4002 CONTINUE
 9333 IF(NI.LE.(IPJH + 2*NWO)) GO TO 93
C     IF(KZAMP.GT.0.AND..NOT.FL18)
C    $ CALL DIAGIN('Z-AMP SUM=0, TIMES: ',1,KZAMP,NI,NI,NI,NI,NI)
C
C                                      Z CHAMBER
C
  11  IF( .NOT. DSPDTM(11) ) GO TO 81
      IPZETC = IDATA(IBLN('ZETC'))
      IF(IPZETC.LE.0) GO TO 81
      LENZC = IDATA(IPZETC)
      IF(LENZC.LT.3) GO TO 81
      IZHITS = (LENZC-1)/2
      NWO = IPZETC + LENZC -2
      IPZETC = IPZETC + 1
82    IF(IPZETC.GT.NWO) GO TO 81
C
      NWIR   = HDATA(2*IPZETC + 1)/8
      CALL RZHITS(IPZETC,XZ,YZ,XZ1,YZ1,XZ2,YZ2,ZZ1,ZZ2,IERR)
      CALL RZDRAW(NWIR,XZ,YZ,XZ1,YZ1,XZ2,YZ2,ZZ1,ZZ2,2)
C
      IPZETC = IPZETC + 2
      GO TO 82
C
C                                      LEAD GLASS
C
  81  IF( PHNUMS ) CALL PBGRZ( INDEX, SH1, SH2, 4.0 * SH2 )
C
C                                      FORWARD MUON COUNTERS
C
      IF( JNDEX .GT. 5 ) CALL FWMUHT
C
C                                      MUON FILTER
C
      IF( MUONFL ) CALL MUHDSP
      IF( MUONFL  .AND.  DSPDTL(18) ) CALL TR3DSP
C
      IF( JNDEX .NE. 7 ) GO TO 303
C
C                                      DISPLAY FORWARD DETECTOR HITS
C                                      IN ZXD AND ZYD VIEWS
C
C ------- NOT YET CODED ------
C
303   RETURN
C
C                            ***************************
C                            *  FORWARD DETECTOR VIEW *
C                            ***************************
C
  3   IF( JNDEX .EQ. 8 ) CALL FWCHEV
C
      IF(JNDEX.LT.9) RETURN
C
      IF(JNDEX.GT.9) GO TO 310
C
C                            *******************************
C                            *  ROLLED OUT LEADGLASS VIEW  *
C                            *******************************
C
      IPJ = IDATA(IBLN('ALGN'))
      IF(IPJ.LE.0) GO TO 300
      SH3 = 0.6667*BLZ
      NWO = IDATA(IPJ)
      IF(NWO.LE.3) GO TO 300
      IPJ = 2*IPJ + 8
      NWO = IPJ + 2*NWO - 8
C
      DO 12  NI = IPJ,NWO,2
      NO = HDATA(NI-1)
      IF(NO.GT.2687) SH3 = .6667*BLXY
      CALL XYBLK(NO,X1,Y1,DXEB,DYEB)
      X1=X1+10.
      Y1=Y1+10.
      IE = HDATA(NI)
      CALL PHNUMB(IE,SH3,0.)
   12 CONTINUE
C
C                                      FORWARD TAGGING APPARATUS
C
  300 CALL FWCHEV
C
  310 IF(JNDEX.EQ.9) RETURN
C
      IF(JNDEX.NE.10) GO TO 4100
C
C                           **************************************
C                           *  PERSPECTIVE VIEW OF PBG CYL + ID  *
C                           **************************************
C
      IF(NNJETC.LE.0) GO TO 2901
      CALL CLOC(IPJ,'JETC',NNJETC)
      IF(IPJ.GT.0) GO TO 2902
      WRITE(6,2703) NNJETC
2901  IPJ = IDATA(IBLN('JETC'))
2902  IF(IPJ.LE.0) GO TO 8999
      KZAMP = 0
      IF( .NOT. DSPDTL(21) ) GO TO 8999
      NWO = (HDATA(2*IPJ+99)-HDATA(2*IPJ+3)+100)/2
C     REGISTER WIRE HITS
C--  LOOP OVER NR OF WORDS IN EVENT
      IF(NWO.LE.2) RETURN
      IPJH = 2*IPJ
      NI = IPJH + 101
   96 CONTINUE
      CALL FICOOR(2,NI,NWE)
      IF(NWE.LT.-500) GO TO 8999
      IF(NWE.EQ.0) GO TO 9666
C     IF(DSPDTL(26).AND.TBIT(NWE,31)) GO TO 9666
      CALL HITMRK( JNDEX, -X1, Y1, 4.0, 0 )
      CALL HITMRK( JNDEX, -X2, Y2, 4.0, 0 )
9666  IF(NI.LE.(IPJH + 2*NWO)) GO TO 96
C     IF(KZAMP.GT.0.AND..NOT.FL18)
C    $ CALL DIAGIN('Z-AMP SUM=0, TIMES: ',1,KZAMP,NI,NI,NI,NI,NI)
8999  CALL PBGCYL(DEFIX)
      RETURN
C
4100  CONTINUE
      IF(JNDEX.NE.11) GO TO 4201
C
C                            *******************************
C                            *  FORWARD MUON COUNTER VIEW  *
C                            *******************************
C
      IF(HEAD(18).GT.3730) CALL FWMUHT
      IF(HEAD(18).LT.3730.AND.HEAD(18).GT.100) WRITE(6,4101)
4101  FORMAT(' FORWARD MUON COUNTERS NOT YET INSTALLED FOR THIS RUN.')
C
4201  IF(JNDEX.NE.12) RETURN
C
C                            *******************************
C                            *  ROLLED OUT Z CHAMBER VIEW  *
C                            *******************************
C
      IPZETC = IDATA(IBLN('ZETC'))
      IF( IPZETC .LE. 0 )   GO TO 939
      LENZC  = IDATA(IPZETC)
      IF( LENZC  .LT. 3 )   GO TO 939
      IZHITS = (LENZC-1)/2
      NWO    = IPZETC + LENZC -2
      IPZETC = IPZETC + 1
92    IF( IPZETC .GT. NWO ) GO TO 939
C
      CALL RZHITS(IPZETC,XZ,YZ,XZ1,YZ1,XZ2,YZ2,ZZ1,ZZ2,IERR)
      IF( IERR .EQ. 0 ) CALL RZDRAW(XZ,YZ,XZ1,YZ1,XZ2,YZ2,ZZ1,ZZ2,3)
C
      IPZETC = IPZETC + 2
      GO TO 92
C
939   CONTINUE
C
      RETURN
      END

C   26/10/78 002200501  MEMBER NAME  LGADCN   (SOURCE)      FORTRAN
      SUBROUTINE LGADCN(IER)
C
C     S.YAMADA     17-10-78  19:30      COPY OF LGADCN IN LGSOURCE
C     LAST MODIFICATION  16-02-79  14:10
C
C---- ADC ADDDRESS OF THE LEAD GLASS DATA IS CHANGED TO
C     LEAD GLASS POSITION.
C---- CALLED FROM (LGANAL).
C
C---- INPUT FORMAT
C     ADDRESS
C     DATA
C     DATA
C      .
C      .
C     ADDRESS
C     DATA
C      .
C     HERE NO.OF DATA AFTER EACH ADDRESS IS NOT FIXED.
C---- ADDRESS= 2BITS ADDRESS FLAG(10)+4BITS CRATE#+10BITS SUBADDRESS
C
C---- POSITION = PHI NO.(0-83)*32 + Z NO.(0-31)
C---- FOR THE TOP ENDCAP POSITION IS (2688-2783)
C---- FOR THE BOTTOM ENDCAP POSITION IS (2784-2879)
C---- THE ENDCAP LEAD GLASS COUNTERS ARE NUMBERED ACCORDING TO
C     THE JADE NUMBERING SEQUENCE.
C
      IMPLICIT INTEGER *2 (H)
#include "cdata.for"
C
#include "clgwork1.for"
      DATA JMAX/4000/
C
      DIMENSION HH(2), JBT(4) ,HLGA(5760)
      EQUIVALENCE (HH(1),IFULL),(HH(2),HA)
      EQUIVALENCE (HLGA(1),HLGADC(1,1))
      DATA JBT/ 0,2688,2784,2880/
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/178112317/
      NVRSN(1) = NVCODE
C
      IER = 0
C
C---- LOOK FOR THE POINTER OF THE LG-DATA
      CALL CLOC( NP, 'ALGL', 0 )
      IF(NP.LE.0) RETURN
C
C---- FOR THE INPUT DATA LNG= # OF DATA IN HDATA INCLUDING SUB-POINTERS.
      LNG = IDATA(NP)
      NNP = NP+NP
C
C---- EXAMINE IF FORMAT CHANGE IS ALREADY DONE.
      IF(HDATA(NNP+1)-100) 1,200,200
C
C
C---- FORMAT IS CHANGED HERE.   / NOW 'ALGN' IS USED FOR THE INPUT.
C                                 I.E. CONVERSION MUST BE FINISHED.
C
    1 J = 0
C---- J IS THE COUNTER FOR THE CONVERTED DATA
      JP = 1
C---- JP IS THE INDEX FOR THE BOUNDARY TABLE.
      HA = 0
C---- HA IS THE CURRENT ADDRESS OF THE ADC DATAGROUP.
C
      LNGRAW = 2*LNG
C---- CHECK LENGTH (RAW DATA HAS NOT THE POINTER,IF NOT CONVERTED.)
      IF(LNGRAW-2) 20,20,2
    2   DO 10 I=3,LNGRAW
        IF(HDATA(I+NNP).LT.-16384) GO TO 3
        IF(HDATA(I+NNP)) 1,4,4
C----   JUNK DATA IS SKIPPED.
C
C----   NEW ADDRESS IS ENCOUNTERED. REMOVE THE FLAG PART.
    3   HA = HDATA(I+NNP)
        IFULL = IFULL+32768
C----   CONTINUE TO THE NEXT CRATE WITHOUT A GAP.
        IC = HA/1024
C       FOR THE CRATE NO. 0,1 AND 2 ARE EXPECTED.
        IW = HA-1024*IC
        IC = MOD(IC,4)
        IF(IC.GT.2) GO TO 92
        HA = IC*960+IW
        GO TO 10
C
C----   DATA
    4   J = J+1
C       J COUNTS NUMBER OF HITS.
        IF(J.GT.JMAX) GO TO 90
        HLGA(J) = HA
        J = J+1
        HLGA(J) = HDATA(I+NNP)
C----   CHECK THE BOUNDARY OF THE DETECTOR PARTS.
    5   IF(HA.LT.JBT(JP)) GO TO 6
C----   INCREASE POINTER AND REPEAT THE BOUNDARY CHECK.
C----   HPOINT POINTS INTEGER *2 WORD ARRAY NOT THE # OF ADD-DATA PAIR.
        HPOINT(JP) = J-1
        JP = JP+1
        IF(JP-4) 92,5,5
    6   HA = HA+1
   10   CONTINUE
      GO TO 20
C
C---- BUFFER OVERFLOW
   90 IER = 1
      CALL MESSAG( 1)
C
C---- STORE RESULTS
   20   DO 21 KJP=JP,4
   21   HPOINT(KJP) = J+1
      NLNG = J/2+3
C
C---- REPLACE THE 'ALGL'/0 BANK.
C
      NL = NLNG-LNG
      CALL BCHM( NP, NL, IERB)
      IF(IERB) 30,30,94
   30 CALL BSTR( NP, HNORD, NLNG )
      RETURN
C
C---- ADDRESS OVER THE UPPER BOUNDARY.
   92 IER = 2
      CALL MESSAG(2)
      RETURN
C
C---- NOT ENOUGH SPACE IN THE DATA BUFFER
   94 IER = 3
      RETURN
C
C
C
C---- FORMAT IS ALREADY CHANGED IN NORD.
C     CHECK THE POINTERS
  200 IF(HDATA(NNP+3).NE.1) GO TO 290
      IPO = 1
        DO 201 K=1,3
        IPK = HDATA(NNP+K+3)
        IF(IPK.LT.IPO) GO TO 290
        IF(MOD(IPK,2).NE.1) GO TO 290
        IPO = IPK
  201   CONTINUE
      IF((IPO-1)/2+3.NE.LNG) GO TO 290
      GO TO 100
C
C---- POINTER FORMAT ERROR
  290 KS = NNP+1
      KL = NNP+6
      WRITE(6,692) (HDATA(KK),KK=KS,KL)
  692 FORMAT('0***** ERROR IN LG-DATA ***** 1-ST 6 WORDS=',6I7)
      IER = 4
  100 RETURN
      END

C   17/05/88 805171200  MEMBER NAME  CRDOCA   (S)           FORTRAN77
      SUBROUTINE CRDOCA( IND, R, P, RDOCA, CHARGE )
C-----------------------------------------------------------
C
C    VERSION OF 27/07/79     LAST MOD  17/01/85    E.ELSEN
C    FIND MOMENTUM P OF TRACK IND IN PATR BANK AT POSITION R.
C    RDOCA IS THE POINT OF CLOSEST APPROACH ON THE TRACK
C    MAG FIELD IS TAKEN FROM HEAD BANK.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
      REAL*8 RMIT,RX,RY,RTOT,RHO
C
      DIMENSION R(3), P(3), RDOCA(3)
      DATA BKGAUS / -4.5 /
C                                                FETCH MAG FIELD
      NPHEAD = IW( IBLN('HEAD') )
      IF( NPHEAD .EQ. 0 ) GO TO 10
      BKGAUS = HW( NPHEAD*2 + 30 ) / 1000.
C                                                FETCH TRACK PARAMETERS
   10 CALL PRTOCI( IND, CAP, RM, PHIM, SIG )
      DZDR = RW( IND + 30 )
C                                                TANGENT DIRECTION
      RHO  = 1. / CAP
      RMIT = RM + RHO
      RX = R(1) - RMIT*COS( PHIM )
      RY = R(2) - RMIT*SIN( PHIM )
      RTOT = DSQRT( RX*RX + RY*RY )
      EX = RY / RTOT * SIG
      EY = -RX / RTOT * SIG
C                                                RADIAL MOMENTUM
      PRAD = .3E-4*ABS(BKGAUS)/CAP
C                                                TOTAL MOMENTUM
      P(1) = PRAD * EX
      P(2) = PRAD * EY
      P(3) = PRAD * DZDR
C                                           DOCA POINT
      RDOCA(1) = R(1) - RX*(1.D0-RHO/RTOT)
      RDOCA(2) = R(2) - RY*(1.D0-RHO/RTOT)
      RDOCA(3) = DZDR*SQRT(RDOCA(1)**2+RDOCA(2)**2)
C
      CHARGE = SIG
      IF( BKGAUS .LT. 0. ) CHARGE = -CHARGE
C
      RETURN
      END

C   02/11/78 C9021901   MEMBER NAME  LGAVRP   (JADELGS)     FORTRAN
C
      SUBROUTINE LGAVRP(COTTH,IPHO,NPMIN,PHAV,PHSIG)
C
C     S.YAMADA   09-10-78  14:45        VERSION 1
C     RECOPIED FROM LVAVRZ AND MODIFIED FOR PHI
C     LAST MODIFICATION  20-10-78  10:40
C
C---- CALUCULATE THE AVERAGE POSITION OF THE SHOWER MAX.
C
C---- INPUTS
C     COTTH  COT(THETA) OF THE CLUSTER MEASURED FROM THE BEAM.
C     IPHO   REFERENCE COUNTER NO.THE FIRST DATA ACTS AS THE REFERENCE.
C            IT CORRESPONDS TO #42 IN THE PHI-ARRAY.
C     NPMIN  THE MINIMUM OF THE INDECES OF THE PHI COUNTERS.
C---- OUTPUTS
C     PHAV   THE AVERAGE PHI OF THE SHOWER
C     PHSIG  VARIANCE OF PHI WIDTH.
C
C---- PULSE HEIGHT OF EACH BAR SHOULD BE STORED IN PHI
      COMMON /CLGZPT/ ETOT,Y(32),WEIGHT(32),YFIT(32),DERIV(32),PHI(84)
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
      DATA PHUNIT/0.07479983/, PHUNI2/0.559501E-2/
      DATA UNIT/0.2721/
C     UNIT=1 RAD.LENG MEASURED BY RADIUS(3)*PHUNIT.
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/178102010/
      NVRSN(3) = NVCODE
C
C---- CALCULATE THE AVERAGE PHI(WEIGHT=PULSE HEIGHT)
      PHISUM = 0.
      PPSUM = 0.
C---- NPMIN   INDEX FOR THE FIRST HIT IN PHI
        DO 1 I=NPMIN,84
        IF(PHISUM.GT.0. .AND. PHI(I).LE.0.) GO TO 4
        IF(PHI(I).GT.0.) LST = I
        PHISUM = PHISUM+PHI(I)
        PPSUM = PPSUM+PHI(I)*I
    1   CONTINUE
C
    4 IF(PHISUM.LE.0.) PHISUM = 1.0
      PHAV = PPSUM/PHISUM
      IF(LST-NPMIN) 10,10,5
C
C---- FROM P.H. RATIO IN PHI,POSITION OF THE HIT POINT IS RECALCULATED.
C
C---- NP --- BAR# WHICH CONTAINS THE AVERAGE PH,NZ1 AND NZ2 ARE NEIGHBR.
    5 NP = PHAV+0.5
      NP1 = NP-1
      NP2 = NP+1
C
C---- ENERGY FRCTION OF LEFT<MIDDLE AND RIGHT PARTARE CALCULATED.
      Y1 = 0.
      IF(NP1.LT.NPMIN) GO TO 11
        DO 20 N=NPMIN,NP1
   20   Y1 = Y1+PHI(N)
   11 Y2 = PHI(NP)
      Y3 = 0.
      IF(NP2.GT.LST) GO TO 13
        DO 12 N=NP2,LST
   12   Y3 = Y3+PHI(N)
C
C---- NORMALIZATION
   13 Y1 = Y1/PHISUM
      Y2 = Y2/PHISUM
      Y3 = Y3/PHISUM
C
C---- FOR ALMOST SYMMETRIC CASE NO CORRECTION.
      IF(Y1.LT.0.01 .AND. Y3.LT.0.01) GO TO 10
      IF(Y1-Y3) 14,10,15
C
C---- Y1<Y3
   14 YMIN= Y3
      PHBND = NP+0.5
      IF(YMIN.LE.0.5) GO TO 140
C---- Y1+Y2<Y3
C---- AVZ DOES NOT CORRESPOND TO THE HIGHEST P.H. BUT GO ON!
      YMIN = Y1+Y2
      S = 1.0
      GO TO 16
  140 S = -1.
      GO TO 16
C
C---- Y1>Y3
   15 YMIN = Y1
      PHBND = NP-0.5
      IF(YMIN.LE.0.5) GO TO 150
C---- Y2+Y3<Y1
      YMIN = Y2+Y3
      S = -1.0
      GO TO 16
  150 S = 1.0
C
C        ---- EMPIRICAL FORMULA FOR Y --------------------
C        I    YMIN = 0.5*A**2/(DX+A)**2                  I
C        I    MONTE CARLO GIVES  A=0.3598                I
C        I    TEST DATA GIVES COTTH DEPENDENT A          I
C        I    A = 0.80-0.09*(ABS(COTTH)-2.0)**2          I
C        -------------------------------------------------
   16 A = 0.80-0.09*(ABS(COTTH)-2.0)**2
      DX = A*(1.0/SQRT(2.0*YMIN)-1.0)*UNIT
      IF(DX.GT.0.5) DX = 0.5
      PHAV = PHBND+S*DX
C
C---- CHANGE UNIT
   10 PHAV = (PHAV-41.5+IPHO)*PHUNIT
CCCC  PHSIG = PHSIG*PHUNI2  **** NOT CALCULATED YET*****
C
  100 RETURN
      END

C   07/02/79 206141438  MEMBER NAME  LGADCD   (SOURCE)      FORTRAN
      SUBROUTINE LGADCD(J,MM)
C
C     S.YAMADA      07-01-78
C     LAST MODIFICATION  14-06-82  14:35
C---- DUMP THE LEAD GLASS ADC DATA TO LP OR TYPEWRITER/DISPLAY
C
C---- THE ADDRESS PART IS DECODED ACCORDING TO THE INPUT J
C     J=0, NO DECODING
C     J=1,FOR INPUT CODE I.E. CRATE-SLOT-SUBADDRESS
C     J=2,FOR POSITION CODE I.E. IPHI-IZ FOR THE BARREL PART
C                           I.E. TOP/BOTTOM-NUM FOR THE ENDCAP
C
C---- MM IS NO. OF DATA TO BE PRINTED IN A LINE.
C     THIS ARGUMENT IS PREPARED TO USE THE SUBROUTINE BOTH FOR
C     LP AND OTHER DISPLAY DEVICES.
C
      IMPLICIT INTEGER *2 (H)
#include "clgwork1.for"
C
      DIMENSION ICL(8),ISLL(8),NSUBL(8),LGL(8)
      DIMENSION IPHIL(10),IZL(10)
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/178102023/
      NVRSN(2) = NVCODE
C
      NLNG = LNG-3
      WRITE(6,600) NLNG,HNORD,HNORML,HPOINT
  600 FORMAT('0 /CLGADC/ DUMP,  NO.OF DATA=',I4,'    HNORD,HNORML=',2I6,
     $                    '          POINTER=',4I5)
C
      IF( NLNG.LE.0 ) RETURN
C
      IF(J-1) 1,2,3
    1 WRITE(6,601)
  601 FORMAT(' NONDECODED ADDRESS PART /PULSE HEIGHT')
      GO TO 4
    2 WRITE(6,602)
  602 FORMAT(' DECODED ADDRES, CRATE-SLOT-SUBADDRESS /PULSE HEIGHT')
      GO TO 4
    3 WRITE(6,603)
  603 FORMAT(' DECODED ADDRESS,IPHI-IZ OR TOP/BOT-NUM /PULSE HEIGHT')
C
C---- GET THE NO.OF REPETITION
    4 M = MM
      IF(M.LT.1) M = 1
      IF(M.GT.10) M = 10
      IF(J.GT.0.AND.M.GT.8) M = 8
      N = NLNG/M
      NR = NLNG-M*N
      N1 = N
      IF(NR.GT.0) N1 = N1+1
      NS = 1-M
        DO 10 NN=1,N1
        NS = NS+M
        NE = NS+M-1
        IF(NN.EQ.N1.AND.NR.GT.0) NE = NS+NR-1
C
        IF(J-1) 11,12,13
C
   11   WRITE(6,611) NS,(HLGADC(1,NW),HLGADC(2,NW),NW=NS,NE)
  611   FORMAT(' ',I3,10(I6,1H/,I5))
        GO TO 10
C
C-----  CRATE-SLOT-SUBADDRESS
   12     DO 120 NW=NS,NE
          ID = HLGADC(1,NW)
          IW = ID/48
          NSUB = ID-48*IW
          IC = IW/20
          ISL = IW-20*IC
          INDX = NW-NS+1
          ICL(INDX) = IC
          ISLL(INDX) = ISL
          NSUBL(INDX) = NSUB
          LGL(INDX) = HLGADC(2,NW)
  120     CONTINUE
        WRITE(6,612) NS,(ICL(NW),ISLL(NW),NSUBL(NW),LGL(NW),NW=1,INDX)
  612   FORMAT(' ',I3,8(I3,1H-,I2,1H-,I2,1H/,I5))
        GO TO 10
C----   POSITION   IPHI-IZ OR TOP/BOT-NUM
   13     DO 13  0 NW=NS,NE
          ID = HLGADC(1,NW)
          IF(ID.GE.2688) GO TO 131
          IPHI = ID/32
          IZ = ID-32*IPHI
          GO TO 133
  131     IZ = ID-2687
          IF(IZ.GE.96) GO TO 132
          IPHI = 90
          GO TO 133
  132     IZ = IZ-96
          IPHI = 91
  133     INDX = NW-NS+1
          IPHIL(INDX) = IPHI
          IZL(INDX) = IZ
          LGL(INDX) = HLGADC(2,NW)
  130     CONTINUE
        WRITE(6,613) NS,(IPHIL(NW),IZL(NW),LGL(NW),NW=1,INDX)
  613   FORMAT(' ',I3, 8(I4,1H-,I2,1H/,I5))
   10   CONTINUE
      RETURN
      END

      SUBROUTINE PATRCO(IND)
      IMPLICIT INTEGER*2 (H)
#include "cheadr.for"
#include "cdata.for"
#include "ccycp.for"
#include "cjdrch.for"
#include "cdsmax.for"
#include "cpatlm.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
     ,         , (ITR   ,IDWRK(7)),(ITRNG ,IDWRK(8))
      COMMON /CLBPGM/ LBPGM(30)
      INTEGER MSKHIT(16) /1,2,4,8,16,32,64,128,Z100,Z200,Z400,Z800,
     ,                    Z1000,Z2000,Z4000,Z8000/
      DATA HPS /2HPS/
      DATA PATR /'PATR'/, LHEAD,LTRBK /8,48/
      DATA JHTL /'JHTL'/
 2991 FORMAT('0/BCS/ TOO SHORT FOR TRACK BANK; EVENT:',3I6,
     ,       ', IRET=',I2,',NTR,LENGTH=',I3,1X,I4)
 2992 FORMAT('0/CWORK/ TOO SHORT FOR PATREC; EVENT:',3I6)
 2993 FORMAT('0/BCS/ TOO SHORT FOR PATREC; EVENT:',3I6,' ,IERR=',I2)
 2994 FORMAT('0WRONG POINTER IN JETC-BANK; EVENT:',3I6,' ,POINTER:',
     ,        /,(1X,24I5))
      IF(
     - IND.EQ.2
     -)THEN
        CALL PATREC(0)
        RETURN
      ENDIF
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 0
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
        IQJETC = IBLN('JETC')
        DSD0   =-.63
        DSD1   = 1.8
        DSD2   = 4.0
        DRV0   = 0.8
        DRV1   = (DSD2 - (DSD1-DSD0)*DRV0) / (DSD2-DSD1)
      ENDIF
      NTR = 0
      IPJETC = IDATA(IQJETC)
      IF(
     - IPJETC.LE.0
     -)THEN
        IPPATR = IDATA(IQPATR)
      IF(
     - IPPATR.LE.0
     -)THEN
          NBNK = 10
          IZW = LHEAD
          CALL CCRE(IPPATR,PATR,NBNK,IZW,IERR)
          IF(IERR.NE.0) RETURN
          CALL BSAW(1,PATR)
          IDATA(IPPATR+1) = LHEAD
          IDATA(IPPATR+3) = LTRBK
      ENDIF
        RETURN
      ENDIF
      NHITJC = HDATA(IPJETC*2+99) / 4
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      HPFREE = 1
      HPLAST = LMPATR(5)
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - IERRFL.NE.0
     -)THEN
        I1 = IPJCA2 + 1
        I9 = I1 + 97
        WRITE(6,2994) HHEADR(17),HHEADR(18),HHEADR(19),
     ,                (HDATA(I),I=I1,I9)
        CALL BDLS(PATR,NBNK)
        CALL BDLS(JHTL,NBNK)
        RETURN
      ENDIF
      IF(
     - (HPFREE+NHITJC+96*12+10*17 - 1).LT.LMPATR(5)
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ELSE
        WRITE(6,2992) HHEADR(17),HHEADR(18),HHEADR(19)
        CALL BDLS(PATR,NBNK)
        CALL BDLS(JHTL,NBNK)
        RETURN
      ENDIF
      HPFRE0 = HPFREE
      HPRO = HPS
      ITR = 1
      IRINGO = 0
      JCELL=97
16000 CONTINUE
        JCELL = JCELL - 1
        MHIT = (HPTSEC(JCELL+1)-HPTSEC(JCELL)) / 4
      IF(
     - MHIT.GE.5
     -)THEN
          IRING = 3
          IF(JCELL.LE.48) IRING = 2
          IF(JCELL.LE.24) IRING = 1
          ICELL = JCELL
          IERRCD = 0
          HPFREE = HPFRE0
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      ENDIF
      IF(.NOT.(
     - JCELL.EQ.25
     -))GOTO 16000
16001 CONTINUE
      HPFREE = HPFRE0
      LENG  = IDATA(IPPATR+2)*IDATA(IPPATR+3) + IDATA(IPPATR+1)
      NDIFF = LENG - IDATA(IPPATR)
      CALL BCHM(IPPATR,NDIFF,IRET)
      IF(IND.NE.0) CALL PATREC(1)
      RETURN
17006 CONTINUE
        DSBIN1 = TIMDEL(1,IRING)
        DSBIN2 = TIMDEL(2,IRING)
        IP0 = HPTSEC(ICELL)
        IP9 = HPTSEC(ICELL+1) - 1
        IPHL = (HPTSEC(ICELL)-HPTSEC(1))/4 + IDATA(IQJHTL) + 1
        HPHT0 = HPFREE
        HLDHT = 12
        IPHT  = HPHT0
        LBHITW = 0
        NWRD2 = NWORD*2
        ILAY0 = -10
        MLAY  = 0
        JHIT  = 0
      DO 13000 IP=IP0,IP9,4
          IPHL = IPHL + 1
      IF(
     - IDATA(IPHL).EQ.0
     -)THEN
      IF(
     - HDATA(IP+1).GT.0 .AND. HDATA(IP+2).GT.0
     -)THEN
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            ILAYR = LAND(IWIR,15)
            LBHITW = LOR(LBHITW,MSKHIT(ILAYR+1))
            IF(ILAYR.GE.8) DSBIN1 = DSBIN2
            DS =(HDATA(IP+3)) * DSBIN1
            DS = DS
      IF(
     - DS.LT.4.0
     -)THEN
      IF(
     - DS.GT.DSD1
     -)THEN
                DS = (DSD1-DSD0)*DRV0 + (DS-DSD1)*DRV1
      ELSE
                DS = (DS-DSD0)*DRV0
      ENDIF
              IF(DS.LT.0.1) DS = 0.1
      ENDIF
            WRK(IPHT+ 2)  = DS
            IWRK(IPHT  ) = ILAYR
            IWRK(IPHT+ 1) = IP
            IWRK(IPHT+ 3) = 0
            IWRK(IPHT+ 4) = 0
            IWRK(IPHT+ 5) = 0
            IWRK(IPHT+ 6) = 0
            IWRK(IPHT+ 7) = 0
            IWRK(IPHT+ 8) = 0
            IWRK(IPHT+ 9) = 0
            IWRK(IPHT+10) = 0
            IWRK(IPHT+11) = 0
            IPHT = IPHT + HLDHT
            JHIT = JHIT + 1
            IF(ILAYR.NE.ILAY0) MLAY = MLAY + 1
            ILAY0 = ILAYR
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
        NHIT = JHIT
        HPHT9 = IPHT - 1
        HPFREE= IPHT
      IF(
     - MLAY.GE.5
     -)THEN
          LBHT = LBHITW
          LBAD = 0
      DO 13002 I=1,14
      IF(
     - LAND(LBHT,7).EQ.7
     -)THEN
              LBAD = 1
      GOTO 13003
      ENDIF
            LBHT = ISHFTR(LBHT,1)
13002 CONTINUE
13003 CONTINUE
      IF(
     - LBAD.NE.0
     -)THEN
            NTRKEL = 0
            CALL FTRELO
      ENDIF
      ENDIF
        HPFREE = HPFRE0
      GOTO IZZZ04
17000 CONTINUE
        IPJHTL = IDATA(IQJHTL)
        IPPATR = IDATA(IQPATR)
        NBKPAT = 10
        IF(IPPATR.GT.0) NBKPAT = IDATA(IPPATR-2) - 1
        NBKHTL = 10
        IF(IPJHTL.GT.0) NBKHTL = IDATA(IPJHTL-2) - 1
        NBNK = MIN0(10,NBKPAT,NBKHTL)
          IZW = NHITJC + 1
          CALL CCRE(IPJHTL,JHTL,NBNK,IZW,IERR)
          LBRHTL = 0
          IF(IERR.NE.0) LBRHTL = 1
          IZW = LTRBK*30 + LHEAD
          CALL CCRE(IPPATR,PATR,NBNK,IZW,IERR)
      IF(
     - IERR.NE.0 .OR. LBRHTL.NE.0
     -)THEN
            WRITE(6,2993) HHEADR(17),HHEADR(18),HHEADR(19),IERR
            CALL BDLS(PATR,NBNK)
            CALL BDLS(JHTL,NBNK)
            RETURN
      ENDIF
          CALL BSAW(1,PATR)
          CALL BSAW(1,JHTL)
          IDATA(IPPATR+1) = LHEAD
          IDATA(IPPATR+2) = 0
          IDATA(IPPATR+3) = LTRBK
          IDATA(IPPATR+4) = IDATA(IPJHTL-2)
          IDATA(IPPATR+5) = NHITJC
          IDATA(IPPATR+6) = NHITJC
          IDATA(IPPATR+7) = NHITJC
          IDATA(IPPATR+8) = 0
      GOTO IZZZ01
17002 CONTINUE
      IPJCA2 = IPJETC*2 + 2
      IP0 = IPJCA2 + 98
      IERRFL = 0
      IPCLL = IPJCA2
      DO 13004 ICLL=1,96
        IPCLL = IPCLL + 1
        HPTSEC(ICLL) = HDATA(IPCLL) + IP0
        IF(HDATA(IPCLL+1).LT.HDATA(IPCLL)) IERRFL = 1
13004 CONTINUE
13005 CONTINUE
      HPTSEC(97) = HDATA(IPCLL+1) + IP0
      HPTSEC(98) = 0
      GOTO IZZZ02
17004 CONTINUE
      HPHL0 = HPFREE*2 - 1
      HLDHL = NHITJC*2
      HPHL9 = HPHL0 + HLDHL - 1
      NBYTHT = HLDHL*2
      ZERO = 0
      CALL SETSL(HWRK(HPHL0),0,NBYTHT,ZERO)
      HPFREE = HPFREE + NHITJC
      GOTO IZZZ03
      END

C   18/10/82 606071921  MEMBER NAME  ARBANK   (S)           FORTRAN
      SUBROUTINE ARBANK(NAME,NRUN,AR,NAR,IUNIT,IOPT)
C
C     ARBANK FETCHES AN ARRAY FROM DIRECT ACCESS DATA SET IUNIT
C     (IOPT='FE') OR STORES AN ARRAY ON DIRECT ACCESS DATA SET IUNIT
C     (IOPT='ST').
C
C                     ---- -- -- --- -----  --
C         CALL ARBANK(NAME,NR,AR,NAR,IUNIT,'ST')
C
C
C     THE ARRAY AR(1)...AR(NAR), VALID FOR THE RUNS NRUN..., IS STORED
C     ON DIRECT ACCESS DATA SET IUNIT UNDER THE IDENTIFIER NAME.
C     NAR MAY BE BETWEEN 1 AND 45000. NR IS A 6 DIGIT POSITIVE INTEGER.
C
C                     ---- --        -----  --
C         CALL ARBANK(NAME,NR,AR,NAR,IUNIT,'FE')
C                             -- ---
C
C     THE ARRAY AR(1)...AR(NAR), IDENTIFIED BY NAME, AND VALID FOR THE
C     RUN NRUN, IS FETCHED FROM THE DIRECT ACCESS DATA SET IUNIT
C     THE SIZE OF AR HAS TO BE BIG ENOUGH FOR THE DATA.
C
C     THE ARGUMENT NAME SHOULD NOT BE USED AS NAME OF A BANK (ACTUALLY
C     THE DATA ARE STORED ON THE DATA SET IN BANKS (NAME,NRUN),
C     (NAME,100000000+NRUN*100+1), (NAME,100000000+NRUN*100+2)....)
C
      COMMON/BCS/IW(1)
      REAL AR(NAR)
      INTEGER IOPT,FU/'FU  '/,FE/'FE  '/,ST/'ST  '/
      IF(IOPT.EQ.FE.OR.IOPT.EQ.FU) GOTO 20
      IF(IOPT.NE.ST) GOTO 200
      IF(NAR.GT.0.AND.NAR.LE.45000) GOTO 1
      WRITE(6,101) NAR
  101 FORMAT('0ERROR IN ARBANK CALL, NAR =',I12/)
C
C     STORE DATA OF ARRAY ON DIRECT ACCESS DATA SET IUNIT
C
    1 NRN=NRUN
      JA=1
   10 JB=MIN0(JA+3000-1,NAR)
      IND=IBANK(NAME,NRN,JB-JA+1)
      IF(IND.EQ.0) GOTO 200
      CALL UCOPY(AR(JA),IW(IND+1),JB-JA+1)
      IND=INDDIR(NAME,NRN,IUNIT,'ST')
      IND=IBANK(NAME,NRN,'DL')
      IF(JA.EQ.1) NRN=100000000+100*NRN
      NRN=NRN+1
      JA=JB+1
      IF(JB.NE.NAR) GOTO 10
      IND=INDDIR(NAME,NRN,IUNIT,'DL')
      GOTO 100
C
C     FETCH DATA FOR ARRAY FROM DIRECT ACCESS DATA SET
C
   20 IND=ILINK(NAME,NRUN)
      IF(IND.NE.0) GOTO 100
      NRX=NRUN
      IND=INDDIR(NAME,NRX,IUNIT,'FE')
      IF(IND.NE.0) GOTO 25
      NRX=NPDIR(NAME,NRX,IUNIT)
      IND=ILINK(NAME,NRX)
      IF(IND.NE.0) GOTO 100
   25 CALL BMLT(1,NAME)
      CALL BDLM
      NRN=NRX
      JA=1
   30 IND=INDDIR(NAME,NRN,IUNIT,'FE')
      IF(IND.EQ.0) GOTO 40
      JB=JA+IW(IND)-1
      CALL UCOPY(IW(IND+1),AR(JA),JB-JA+1)
      IND=IBANK(NAME,NRN,'DLGC')
      IF(JA.EQ.1) NRN=100000000+100*NRN
      NRN=NRN+1
      JA=JB+1
      GOTO 30
   40 IF(JA.EQ.1) GOTO 200
      IND=IBANK(NAME,NRX,0)
      NAR=JB
C
C
C
  100 RETURN
  200 CALL ABEND
      GOTO 100
      END

C   10/10/84 807241316  MEMBER NAME  DISPVC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DISPVC(INDEX,MODVW)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   28/10/85 :  DISPLAY VERTEX CHAMBER HITS
C                                        IN R-FI VIEWS
C
C         MOD: J. HAGEMANN  13/03/86 : EXTENDED COMMON CVX AND SWITCHING
C                                      OF VTXC BANKS POSSIBLE
C         MOD: J. HAGEMANN  09/04/86 : FOR PRE-FILTER BANK VPAT 19/20
C         MOD: J. HAGEMANN  26/05/86 : SUPPRESS PRINTOUT FOR DATA
C                                      WITHOUT VTXC-BANK
C         MOD: J. HAGEMANN  14/11/86 : PRINT ONCE CALIBRATION CONSTANTS
C                                      FOR REAL DATA
C         MOD: J. HAGEMANN  16/12/86 : STRUCTURE CHANGE FOR Z-COORDINATE
C                                      DISPLAY
C    LAST MOD: J. HAGEMANN  26/01/88 : GENERAL UPDATE
C
C       JNDEX: VIEW INDEX
C       MODVW: 1= R-FI-VIEWS  , 2= Z-VIEWS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FLVCDO
      LOGICAL FL18,FL22,FL24
      LOGICAL LVTXC,LNHARD,NEWDET
      LOGICAL LZDSP,LCOMFT
C
#include "cgraph.for"
#include "cadmin.for"
#include "cgrscl.for"
#include "cdata.for"
#include "mvccal.for"
#include "mvtrce.for"
C
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  KZAMP,IMW(132)
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
      COMMON / CGVCDO / FLVCDO(20)
      COMMON / CVX    / NNPATR,NDUMM,NNJETC,NNVTXC
      COMMON / CVCEX  / LVTXC
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION HVTHT(500), IVPAT(2,500), HTUSED(500), IVPRE(2,500)
C
C
C-----------------  C O D E  -------------------------------------------
C
      JNDEX  = INDEX
C------------------------    TEMPORARY
      CSLOR =  0.961248
      SNLOR = -0.275684
C------------------------    TEMPORARY
      IF( INDEX .GT. 7 ) JNDEX = INDEX - 4
C
      IF( NNVTXC .LT. 0 .OR. NNVTXC .GT. 99 ) GO TO 50
         CALL CLOC( IPVTXC, 'VTXC', NNVTXC )
         NBANK = NNVTXC
         IF( IPVTXC .GT. 0 ) GO TO 80
            LNHARD = (HEAD(15) .GE. 5  .AND.  HEAD(16) .EQ. 1984)
     *                                .OR.   HEAD(16) .GE. 1985
            IPBPCH = IDATA(IBLN('BPCH'))
            NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
            IF( NEWDET .AND. IPBPCH .LE. 0 ) WRITE(6,40) NNVTXC
   40       FORMAT(' VTXC BANK NR',I3,' (GIVEN BY COMMAND VTXC) NOT EXIS
     *TING')
   50 NBANK = 10
      CALL CLOC( IPVTXC, 'VTXC', NBANK )
      IF( IPVTXC .LE. 0 )  GO TO 2000
   80    CONTINUE
         IPVTX2 = IPVTXC*2
         NNVTXC = NBANK
         NHDLV = IDATA(IPVTXC+1)
         NWOV  = IDATA(IPVTXC) - NHDLV
         IF( NWOV .LE. 0 ) GO TO 2000
C
         DO 100 I = 1, 500
            HVTHT(I) = 0
  100    CONTINUE
C
         IF( MODVW .NE. 1 ) GO TO 800
C
         CALL CLOC( IPVTHT, 'VTHT', NBANK )
         IF( IPVTHT .LE. 0 ) GO TO 800
C
  200       ILVTHT = IDATA(IPVTHT)*2
            IPVTH2 = IPVTHT*2
            ILHDVT = HDATA(IPVTH2+1)
            ILTLVT = HDATA(IPVTH2+4)
            ISMTRA = HDATA(IPVTH2+5)
            ISMTR1 = HDATA(IPVTH2+6)
C
            DO 700 I = 1, ISMTRA
               IPAC = IPVTH2 + ILHDVT + (I-1)*ILTLVT + 1
               IF( IPAC .LE. IPVTH2+ILVTHT ) GO TO 300
      CALL TRMOUT(80,'DISPVC : VTHT-BANK --> NUMBER OF TRACKS IN HEADER
     *IS WRONG !^')
               GO TO 800
  300          NHTS = HDATA(IPAC)
C
               IPFL = 2
               IF( I .GT. ISMTR1 ) IPFL = 0
               IF( NHTS .LT. 0 ) IPFL = -10
               NHTS = IABS(NHTS)
C
               DO 600 J = 1, NHTS
                  IPHT = HDATA(IPAC+J)
                  IF( IPFL .EQ. -10 ) GO TO 500
                     IF( IPFL .GT. 0 ) GO TO 400
                        IF( IPHT .LT. 0 ) HVTHT(-IPHT) = HVTHT(-IPHT) -3
                        IF( IPHT .GT. 0 ) HVTHT( IPHT) = HVTHT(IPHT) + 5
                        GO TO 600
  400                HVTHT(IPHT) = IPFL
                     GO TO 600
  500             HVTHT(IPHT) = 0
  600          CONTINUE
C
  700       CONTINUE
C
C
  800    DO 900 I = 1, 500
            IVPAT(1,I) = 0
            IVPAT(2,I) = 0
            HTUSED(I)  = 0
  900    CONTINUE
C
         CALL CLOC( IPVPAT, 'VPAT', NBANK )
         IF( IPVPAT .LE. 0 ) GO TO 1350
C
            ILVPAT = IDATA(IPVPAT)*2
            IPVPA2 = IPVPAT*2
            ILHDVP = HDATA(IPVPA2+1)
            ILTLVP = HDATA(IPVPA2+4)
            ISMTRL = HDATA(IPVPA2+5)
C
            DO 1300 I = 1, ISMTRL
               IPAC = IPVPA2 + ILHDVP + (I-1)*ILTLVP + 5
               IF( IPAC .LE. IPVPA2+ILVPAT ) GO TO 1100
      CALL TRMOUT(80,'DISPVC : VPAT-BANK --> NUMBER OF TRACKS IN HEADER
     *IS WRONG !^')
               GO TO 1350
 1100          NHTL   = HDATA(IPAC)
               NIDT   = HDATA(IPAC-4)
               IPPATR = IDATA(IBLN('PATR'))
               IPHWDS = IDATA(IBLN('HWDS'))
               IF( FLVCDO(15) .AND. IPHWDS .GT. 0 ) IPPATR = IPHWDS
               IPTRK  = IPPATR + IDATA(IPPATR+1)
     *                                 + (NIDT-1)*IDATA(IPPATR+3)
C
               LCOMFT = .FALSE.
               IF( IDATA(IPPATR+3).LT.64 ) GOTO 1190
                  MASK1 = IDATA(IPTRK+60)
                  MASK2 = IDATA(IPTRK+61)
                  CALL VHITLD(MASK1,MASK2)
                  LCOMFT = .TRUE.
 1190          CONTINUE
               DO 1200 J = 1, NHTL
                  IPHL = HDATA(IPAC+J)
                  IF( IPHL .GT. 0 ) IVPAT(1, IPHL) = IVPAT(1,IPHL) + 5
                  IF( IPHL .LT. 0 ) IVPAT(1,-IPHL) = IVPAT(1,-IPHL) - 3
                  IVPAT(2, IABS(IPHL)) = IPTRK
                  IF( .NOT.LCOMFT ) GOTO 1200
                     IPHTVC = IPVTX2 + 6 + IABS(IPHL)*4
                     IWT = HDATA(IPHTVC+1)
                     ILY = MOD(IWT-1,7) + 1
                     IF( HVMSK(ILY) .EQ. 2 ) HTUSED(IABS(IPHL)) = 1
 1200          CONTINUE
C
 1300       CONTINUE
C
 1350    DO 1360 I = 1, 500
            IVPRE(1,I) = 0
            IVPRE(2,I) = 0
 1360    CONTINUE
C
         CALL CLOC( IPVPRE, 'VPAT', NBANK+10 )
         IF( IPVPRE .LE. 0 ) GO TO 1400
C
            ILVPRE = IDATA(IPVPRE)*2
            IPVPR2 = IPVPRE*2
            ILHDVR = HDATA(IPVPR2+1)
            ILTLVR = HDATA(IPVPR2+4)
            ISMTRR = HDATA(IPVPR2+5)
C
            DO 1390 I = 1, ISMTRR
               IPACR = IPVPR2 + ILHDVR + (I-1)*ILTLVR + 5
               IF( IPACR .LE. IPVPR2+ILVPRE ) GO TO 1370
      CALL TRMOUT(80,'DISPVC : VPAT-BANK --> NUMBER OF TRACKS IN HEADER
     *IS WRONG !^')
               GO TO 1400
 1370          NHTLR  = HDATA(IPACR)
               NIDTR  = HDATA(IPACR-4)
               IPPATR = IDATA(IBLN('PATR'))
               IPHWDS = IDATA(IBLN('HWDS'))
               IF( FLVCDO(15) .AND. IPHWDS .GT. 0 ) IPPATR = IPHWDS
               IPTRK  = IPPATR + IDATA(IPPATR+1)
     *                                 + (NIDTR-1)*IDATA(IPPATR+3)
C
               DO 1380 J = 1, NHTLR
                  IPHLR = HDATA(IPACR+J)
                  IF(IPHLR .GT. 0) IVPRE(1, IPHLR) = IVPRE(1, IPHLR) + 5
                  IF(IPHLR .LT. 0) IVPRE(1,-IPHLR) = IVPRE(1,-IPHLR) - 3
                  IVPRE(2, IABS(IPHLR)) = IPTRK
 1380          CONTINUE
C
 1390       CONTINUE
C
 1400    CONTINUE
         IPACTU = IPVTX2 + NHDLV*2 + 1
         NEV = IPACTU
         IIA = 0
 1500       CONTINUE
              IIA = IIA + 1
              IF( IIA .GT. 500 ) GO TO 1530
                 IFLH  = HVTHT(IIA)
                 IFLP  = IVPAT(1,IIA)
                 IPTRK = IVPAT(2,IIA)
                 IFLPR = IVPRE(1,IIA)
                 IPTRR = IVPRE(2,IIA)
                 GO TO 1570
 1530         IFLH  = 0
              IFLP  = 0
              IPTRK = 0
              IFLPR = 0
              IPTRR = 0
 1570         IM = 1
              IF( IFLP .EQ. 0 ) IM = -1
              IF( IFLP .NE. 0 .OR. IFLPR .EQ. 0 ) GO TO 1580
                 IM    = 1
                 IPTRK = IPTRR
 1580         CALL FICOOV( MODVW-1, IPACTU, NWEV, IM, IPTRK )
              IF( NWEV .LT. -500 ) GO TO 2000
              IF( NWEV .EQ. 0 .OR. IPRJC .NE. 0 ) GO TO 1900
              IF( MODVW .EQ. 2 ) GO TO 1810
              IF( .NOT. FLVCDO(1) ) GO TO 1600
                    CALL HITMRK( JNDEX, -X1, Y1, 1.5, 0 )
                    CALL HITMRK( JNDEX, -X2, Y2, 1.5, 0 )
 1600         IF( .NOT. FLVCDO(2) ) GO TO 1700
                    IF( IFLH .LT. 0 .OR. IFLH .EQ. 2 )
     *                         CALL PLYGON( 8, 1.75, -X1, Y1, 0 )
                    IF( IFLH .GT. 0 )
     *                         CALL PLYGON( 8, 1.75, -X2, Y2, 0 )
 1700         IF( .NOT. FLVCDO(3) ) GO TO 1750
                    IDSC = -1
                    IF( HTUSED(IIA) .EQ. 1 ) IDSC = 0
                    IF( IFLP .LT. 0 .OR. IFLP .EQ. 2 )
     *                         CALL PLYGON( 4, 2.75, -X1, Y1, IDSC )
                    IF( IFLP .GT. 0 )
     *                         CALL PLYGON( 4, 2.75, -X2, Y2, IDSC )
 1750         IF( .NOT. FLVCDO(7) ) GO TO 1800
                    IF( IFLPR .LT. 0 .OR. IFLPR .EQ. 2 )
     *                         CALL PLYGON( 3, 2.75, -X1, Y1, 0 )
                    IF( IFLPR .GT. 0 )
     *                         CALL PLYGON( 3, 2.75, -X2, Y2, 0 )
 1800         IF( INDEX .NE. 20 .OR.
     *            ABS(XMAX-XMIN) .GT. 0.5*ABS(XMAXST(20) - XMINST(20))
     *            .OR. .NOT. FLVCDO(1) )
     *                                                GO TO 1900
                    CALL HITSCL( -X1, Y1, 1.5 )
                    CALL HITSCL( -X2, Y2, 1.5 )
C
                    IF( .NOT. FLVCDO(5) ) GO TO 1900
                       IF( ABS(XMAX-XMIN) .GT.
     *                                0.2*ABS(XMAXST(20) - XMINST(20)) )
     *                                                GO TO 1900
                          CALL HITPNT( -X1, Y1, -X2, Y2, IIA )
                          GO TO 1900
C
 1810          IF( NBANK .EQ. 9 ) GO TO 1900
               LZDSP = .FALSE.
               IF( FLVCDO(1) ) LZDSP = .TRUE.
               IF( FLVCDO(1) .OR. FLVCDO(2) .OR. .NOT.FLVCDO(3) )
     *                                             GO TO 1815
                  IF( IFLP .NE. 0 ) LZDSP = .TRUE.
 1815          IF( (.NOT.DSPDTL(9)) .OR. DSPDTL(10) ) GO TO 1820
                  IF( LZDSP ) CALL HITMRK( JNDEX, ZET, R, 1.5, 0 )
                  GO TO 1860
 1820          CONTINUE
               DO 1850  LRHIT = 1, 2
                  IF( LRHIT .EQ. 2 ) GO TO 1830
                     RLRHI = R1
                     FILRH = FI1
                     GO TO 1840
 1830             CONTINUE
                     RLRHI = R2
                     FILRH = FI2
 1840             CONTINUE
                  Y0 = RLRHI
C                                             GET PROJECTED Y-COORDINATE
                  IF( INDEX .LE. 7 ) YPRO =  RLRHI*COS(FILRH)
                  IF( INDEX .GT. 7 ) YPRO =  RLRHI*SIN(FILRH)
                  IF(.NOT.DSPDTL(9)) Y0 = YPRO
                  IF( LZDSP ) CALL HITMRK( JNDEX, ZET, Y0, 1.5, 0 )
C
 1850          CONTINUE
 1860          CONTINUE
C
 1900       IF( IPACTU .LE. (NWOV*2 - 4 + NEV) ) GO TO 1500
C
 2000 CONTINUE
C
      RETURN
      END

C   07/06/96 606071910  MEMBER NAME  SMTWO    (S4)          FORTG1
      SUBROUTINE SMTWO(Y,Z,N,IP)
      REAL Y(N),Z(N),H(320)
C                -   - --
C     CALL SMTWO(Y,Z,N,IP)
C                - -
C
C     SMOOTH N DATA Y( ) BY TWOFOLD APPLICATION
C     OF SIMPLE SM353 METHOD, QUADRATIC INTERPOLATION
C     OF FLAT AREAS AND AVERAGING. RESULT IN Z( ).
C     Y( ) AND Z( ) MAY NOT BE THE SAME ARRAYS, CONTENT
C     OF Y( ) IS DESTROYED.
C     IP = 0  FOR POISSON DISTRIBUTED (COUNTER) DATA
C        = NOT EQUAL 0 OTHERWISE
C
      IF(IP.EQ.0) CALL PTOEQ(Y,N)
      DO 10 I=1,N
   10 Z(I)=Y(I)
      DO 60 K=1,2
      CALL SMONE(Z,Z,N)
      CALL QANN(Z,N)
      CALL HANN(Z,N)
      IF(IP.EQ.0) CALL CANN(Z,N)
C     CALL CUBN(Z,N)
      GOTO (20,40),K
C  20 CALL HANN(Z,N)
C     CALL CUBN(Z,N)
   20 NSP=3+0.2*FLOAT(N)
      NSP=MIN0(64,NSP)
      CALL SPLSME(Z,N,H,NSP,CHDF)
      DO 30 I=1,N
      ZZ=Z(I)
      Z(I)=Y(I)-ZZ
   30 Y(I)=ZZ
      GOTO 60
   40 DO 50 I=1,N
      Z(I)=Y(I)+Z(I)
   50 Y(I)=Z(I)
   60 CONTINUE
      NSP=3+0.2*FLOAT(N)
      NSP=MIN0(64,NSP)
      CALL SPLSME(Y,N,H,NSP,CHDF)
      NSP=4+(N-3)/2
      IF(NSP.GT.64) GOTO 70
      CALL SPLSME(Z,N,H,NSP,CHDF)
      GOTO 90
   70 KL=(N+101)/112
      LK=(N+12*KL-11)/KL
      JA=1
      DO 80 LL=1,KL
      JB=MIN0(N,JA+LK-1)
      NSP=4+(JB-JA+1)/2
      NSP=MIN0(64,NSP)
      CALL SPLSME(Y(JA),JB-JA+1,H,NSP,CHDF)
   80 JA=JB-10
C     CALL CUBN(Y,N)
   90 IF(IP.EQ.0) CALL EQTOP(Y,N)
      IF(IP.EQ.0) CALL EQTOP(Z,N)
  100 RETURN
      END
      SUBROUTINE SMONE(Y,Z,N)
      REAL Y(N),Z(N)
C                -   -
C     CALL SMONE(Y,Z,N)
C                  -
C
C     SMOOTH N DATA Y( ) BY SIMPLE SM353 METHOD
C     WITHOUT QUADRATIC INTERPOLATION AND AVERAGING.
C     RESULT IN Z( ). Y( ) AND Z( ) MAY BE THE SAME ARRAY.
C
      DO 10 I=1,N
   10 Z(I)=Y(I)
      IF(N.LE.3) RETURN
      CALL SM3 (Z,N)
      IF(N.LE.5) RETURN
      CALL SM5 (Z,N)
      CALL SM3C(Z,N)
  100 RETURN
      END
      FUNCTION DIAN5(Z)
      REAL Z(5),ZI(3)
      DIAN3(A,B,C)=AMAX1(AMIN1(A,B),AMIN1(B,C),AMIN1(C,A))
C
C     MEDIAN OF 5 VALUES
C
      IF(Z(1).GT.Z(5)) GOTO 10
      MIN=1
      MAX=5
      GOTO 20
   10 MIN=5
      MAX=1
   20 DO 50 N=1,3
      ZZ=Z(N+1)
      IF(ZZ.GT.Z(MIN)) GOTO 30
      ZI(N)=Z(MIN)
      MIN=N+1
      GOTO 50
   30 IF(ZZ.LT.Z(MAX)) GOTO 40
      ZI(N)=Z(MAX)
      MAX=N+1
      GOTO 50
   40 ZI(N)=ZZ
   50 CONTINUE
      DIAN5=DIAN3(ZI(1),ZI(2),ZI(3))
      RETURN
      END
      SUBROUTINE SM3(Y,N)
      REAL Y(N),EP(3,2)
      DIAN3(A,B,C)=AMAX1(AMIN1(A,B),AMIN1(B,C),AMIN1(C,A))
C
C     REPLACE EACH VALUE BY MEDIAN OF 3 VALUES
C
      NM=N-2
      IF(NM.LT.1) GOTO 100
      EP(1,1)=Y(1)
      EP(1,2)=Y(N)
      ZL=Y(1)
      DO 10 I=1,NM
      ZN=DIAN3(Y(I),Y(I+1),Y(I+2))
      Y(I)=ZL
   10 ZL=ZN
      Y(N-1)=ZL
      EP(2,1)=Y(2)
      EP(2,2)=Y(N-1)
      EP(3,1)=3.0*Y(2)-2.0*Y(3)
      EP(3,2)=3.0*Y(N-1)-2.0*Y(N-2)
      Y(1)=DIAN3(EP(1,1),EP(2,1),EP(3,1))
      Y(N)=DIAN3(EP(1,2),EP(2,2),EP(3,2))
  100 RETURN
      END
      SUBROUTINE SM3C(Y,N)
      REAL Y(N)
      DIAN3(A,B,C)=AMAX1(AMIN1(A,B),AMIN1(B,C),AMIN1(C,A))
C
C     REPLACE EACH VALUE BY MEDIAN OF 3 VALUES, COPYING FIRST AND LAST
C
      NM=N-2
      IF(NM.LT.1) GOTO 100
      ZL=Y(1)
      DO 10 I=1,NM
      ZN=DIAN3(Y(I),Y(I+1),Y(I+2))
      Y(I)=ZL
   10 ZL=ZN
      Y(N-1)=ZL
  100 RETURN
      END
      SUBROUTINE SM5(Y,N)
      REAL Y(N)
      DIAN3(A,B,C)=AMAX1(AMIN1(A,B),AMIN1(B,C),AMIN1(C,A))
C
C     REPLACE EACH VALUE BY MEDIAN OF 5 VALUES
C
      NM=N-4
      IF(NM.LT.1) GOTO 100
      ZL=Y(1)
      ZN=DIAN3(Y(1),Y(2),Y(3))
      ZE=DIAN3(Y(N-2),Y(N-1),Y(N))
      DO 10 I=1,NM
      ZM=DIAN5(Y(I))
      Y(I)=ZL
      ZL=ZN
   10 ZN=ZM
      Y(N-3)=ZN
      Y(N-2)=ZM
      Y(N-1)=ZE
  100 RETURN
      END
      SUBROUTINE HANN(Y,N)
      REAL Y(N)
C
C     REPLACE EACH VALUE BY THE AVERAGE OVER 3 VALUES
C
      IF(N.LT.3) GOTO 100
      ZL=Y(1)
      NM=N-2
      DO 10 I=1,NM
      ZN=0.25*Y(I)+0.5*Y(I+1)+0.25*Y(I+2)
      Y(I)=ZL
   10 ZL=ZN
      Y(N-1)=ZL
  100 RETURN
      END
      SUBROUTINE QANN(Y,N)
      REAL Y(N)
C
C     CORRECT FLAT AREAS OF THREE EQUAL VALUES BY QUADRATIC INTERPOL.
C
      IA=3
      IB=N-2
      IF(IB.LT.IA) GOTO 100
      DO 10 I=IA,IB
      IF(Y(I).NE.Y(I-1).OR.Y(I).NE.Y(I+1)) GOTO 10
      A=Y(I)-Y(I-2)
      B=Y(I)-Y(I+2)
      IF(A*B.LE.0) GOTO 10
      J=1
      IF(ABS(A).GT.ABS(B)) J=-1
      Y(I-J)=Y(I+J)-0.5*(Y(I+J+J)-Y(I-J-J))
      Y(I)=(8.0*Y(I+J)-3.0*Y(I+J+J)+Y(I-J-J))/6.0
   10 CONTINUE
  100 RETURN
      END
      SUBROUTINE CANN(Y,N)
      REAL Y(N)
C
C     REPLACE EACH VALUE BY THE AVERAGE OVER 5 VALUES,
C     IF QUADRATIC TERM NOT SIGNIFICANT
C
      NM=N-4
      IF(NM.LT.1) GOTO 100
      CUT=1.0
      ZL=Y(1)
      ZN=0.25*(Y(1)+2.0*Y(3)+Y(3))
      ZE=0.25*(Y(N)+2.0*Y(N-1)+Y(N-2))
      DO 20 I=1,NM
      ZM=Y(I+2)
      SUM=-2.0*Y(I)+Y(I+1)+2.0*Y(I+2)+Y(I+3)-2.0*Y(I+4)
      SUM=SUM*SUM/14.0
      IF(SUM.GT.CUT) GOTO 10
      SUM=Y(I)+2.0*Y(I+1)+3.0*Y(I+2)+2.0*Y(I+3)+Y(I+4)
      ZM=SUM/9.0
   10 Y(I)=ZL
      ZL=ZN
   20 ZN=ZM
      Y(N-3)=ZN
      Y(N-2)=ZM
      Y(N-1)=ZE
  100 RETURN
      END
      SUBROUTINE CUBN(Y,N)
      REAL Y(N)
C
C     CORRECT EACH MIDDLE VALUE OF 5 VALUES,
C     TO OBTAIN SMOOTH CURVE
C
      NM=N-4
      IF(NM.LT.1) GOTO 100
      ZL=0.0
      ZU=0.0
      DO 10 I=1,NM
      ZM=Y(I+2)
      SUM=-Y(I)+4.0*Y(I+1)-6.0*Y(I+2)+4.0*Y(I+3)-Y(I+4)
      ZM=0.06*SUM
      IF(I.EQ.1) ZN=-0.08*SUM
      IF(I.EQ.NM) ZE=-0.08*SUM
      Y(I)=Y(I)+ZU
      ZU=(ZN-ZL-ZM)/3.0
      ZL=ZN
   10 ZN=ZM
C     Y(N-3)=Y(N-3)+ZL
C     Y(N-2)=Y(N-2)+ZN
C     Y(N-1)=Y(N-1)+ZE
      Y(N-3)=Y(N-3)+ZU
      Y(N-2)=Y(N-2)+(ZN-ZL-ZE)/3.0
      Y(N-1)=Y(N-1)+(ZE-ZN)/3.0
  100 RETURN
      END
      SUBROUTINE PTOEQ(Y,N)
      REAL Y(N)
C
C     TRANSFORM POISSON DISTRIBUTED DATA TO DATA OF VARIANCE 1.0
C
      IA=0
      IB=0
      DO 10 I=1,N
      IF(Y(I).EQ.0.0) GOTO 10
      IF(IA.EQ.0) IA=I
      IB=I
   10 CONTINUE
      IF(IB.EQ.0) GOTO 100
      DO 30 I=IA,IB
      IF(Y(I).GT.0.0) GOTO 20
      Y(I)=1.0
      GOTO 30
   20 Y(I)=SQRT(Y(I))+SQRT(Y(I)+1.0)
   30 CONTINUE
  100 RETURN
      END
      SUBROUTINE EQTOP(Y,N)
      REAL Y(N)
C
C     TRANSFORM BACK TO POISSON DISTRIBUTED DATA
C
      DO 10 I=1,N
      IF(Y(I).GT.1.0) GOTO 5
      Y(I)=0.0
      GOTO 10
    5 SY=(0.5*(Y(I)-1.0/Y(I)))**2
      NY=10.0*SY+0.5
      Y(I)=0.1*FLOAT(NY)
   10 CONTINUE
  100 RETURN
      END

************************************************************************
*
* PLOT10
* ======
*
*     Emulation of some PLOT-10 Terminal Control System
*     Routines used by the JADE library.
*
*     13/08/1999  P.A. Movilla Fernandez
*     12/11/1999  PMF  last mod.
*
*
* Terminal initialization:
*
*     INITT
*     FINITT
*
* Graphics window definition:
*
*     TWINDO  SWINDO
*     DWINDO  VWINDO
*
* Drawing routines:
*
*       screen window       virtual window
*     absolute  relative   absolute relative
*
*     MOVABS    MOVREL     MOVEA    MOVER
*     DRWABS    DRWREL     DRAWA    DRAWR
*     PNTABS    PNTREL     POINTA   POINTR
*     DSHABS    DSHREL     DASHA    DASHR
*
*     RROTAT
*     RSCALE
*     ERASE
*
* Terminal I/O: 
*
*     SCURSR
*     VCURSR
*     ANCHO
*     ANSTR
*     EOUTST
*     CHRSIZ
*     CSIZE
*     HOME
*     NEWLIN
*     LINEF
*     SYSSYM
*     USRSYM
*
*     TRMOUT
*     TRMIN
*
* Utilities:
*
*     SEELOC
*     SEETW
*     SEEDW
*     HDCOPY
*     HDCEXT
*     HDCDST
*
************************************************************************

************************************************************************
*
*      I N I T I A L I Z A T I O N   A N D   T E R M I N A T I O N
* 
************************************************************************

************************************************************************
      SUBROUTINE INITT(IDUMMY)
      IMPLICIT NONE
*
*     Initialization of PLOT-10.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*******************************************************************
*
*     HIGZ colour parameters for graphics action in JADEZ
*
*     This file is included when compiling SETCOL
*
      LOGICAL LCOL,LINIT
      INTEGER NCOL,IFORE,IBACK,IFORE2,IBACK2
      REAL WID
      PARAMETER (NCOL=10)
      REAL RED,GREEN,BLUE
      CHARACTER TCOL*4
      COMMON /PLTCOL/ LCOL,LINIT,IFORE,IBACK,IFORE2,IBACK2
     _     ,RED(NCOL),GREEN(NCOL),BLUE(NCOL),TCOL(NCOL),WID(NCOL)

      INTEGER PLTFLG
      COMMON /CPLTC2/ PLTFLG
*******************************************************************      

*
      INTEGER IDUMMY
Code:
      INIT=.TRUE.
C
C - HIGZ normalization transformation indices
      NTS=8                     ! 'screen window'
      NTV=9                     ! 'virtual window'

C - Maximal screen dimensions of the terminal
      XTMIN=0.
      XTMAX=4095.
      YTMIN=0.
      YTMAX=4095.

C - Standard initialization of HIGZ
      CALL IGSTRT

C - Default settings of HIGZ graphics
      CALL IGDEF

C - Define a 'maximal screen window' by setting the
C   boundaries of the HIGZ normalization transformation (NT)
C   using the maximal screen dimensions ( NT index = NTS )
      CALL ISWN(NTS,XTMIN,XTMAX,YTMIN,YTMAX)
      CALL ISVP(NTS,0.,1.,0.,1.)

C - Default settings for the 'screen window'
      CALL TWINDO(INT(XTMIN),INT(XTMAX),INT(YTMIN),INT(YTMAX))
      CALL CHRSIZ(1)
      TLINE=0

C - Default settings for the 'virtual window'
      CALL DWINDO(XTMIN,XTMAX,YTMIN,YTMAX)

C - Colour settings in JADEZ
      CALL SETCOL('*INI')

C - Set trace mode
      TRACE=.FALSE.
C
      RETURN
      END

C /PLOT10/
      BLOCKDATA CPLOT10
      IMPLICIT NONE
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
      DATA TTEST/.FALSE./,DTEST/.FALSE./,TLINE/0/,ISYNC/0/,LTSO/.FALSE./
      END

************************************************************************
      SUBROUTINE FINITT(IX,IY)
      IMPLICIT NONE
*
*     Termination of PLOT-10.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER IX,IY
Code:
      INIT=.FALSE.

C - Close current PostScript file
      CALL PSCLOS

C - Standard termination of HIGZ
      CALL IGFIN
C
      RETURN
      END

************************************************************************
*
*           D E F I N I T I O N    O F    S C R E E N
*
************************************************************************

************************************************************************
      SUBROUTINE TWINDO(MINX,MAXX,MINY,MAXY)
      IMPLICIT NONE
*     
*     Defines 'screen window'.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER MINX,MAXX,MINY,MAXY
      REAL XTERM,YTERM,XU,XO,YU,YO,AMIN1
Code:
      IF( .NOT.INIT ) CALL PABORT(1)
      IF( .NOT.TTEST ) TTEST=.TRUE.

C - Update 'screen window' in /PLOT10/
      XMIN0=REAL(MINX)
      XMAX0=REAL(MAXX)
      YMIN0=REAL(MINY)
      YMAX0=REAL(MAXY)

C - Define the 'screen window' by setting the boundaries of the
C   viewport of the HIGZ normalization transformation (NT) 
C   of the 'virtual window' (NT index =  NTV).
C   Normalization is done using the 'maximal screen' dimensions.
      XTERM=XTMAX-XTMIN
      YTERM=YTMAX-YTMIN
      XU=AMAX1(XMIN0/XTERM,0.)
      XO=AMIN1(XMAX0/XTERM,1.)
      YU=AMAX1(YMIN0/YTERM,0.)
      YO=AMIN1(YMAX0/YTERM,1.)
      IF( XO.LE.XU .OR. YO.LE.YU ) CALL PABORT(2)
      CALL ISVP(NTV,XU,XO,YU,YO)
      CALL ISELNT(NTV)

C - Initial beam position in 'screen window' coordinates
      XPOS0=0.
      YPOS0=0.

C - Suppress rotation/scaling of subsequent drawings using relative arguments
      LROTAT=.FALSE.
      LSCALE=.FALSE.
C
      IF( TRACE ) CALL SEE
C
      RETURN
      END

*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      SUBROUTINE SWINDO(MINX,MAXX,MINY,MAXY)
      IMPLICIT NONE
      INTEGER MINX,MAXX,MINY,MAXY
Code:
      CALL TWINDO(MINX,MINX+MAXX,MINY,MINY+MAXY)
C
      RETURN
      END

************************************************************************
      SUBROUTINE DWINDO(XMI,XMA,YMI,YMA)
      IMPLICIT NONE
*
*     Defines user 'virtual window'.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL XMI,XMA,YMI,YMA
Code:
      DTEST=.TRUE.
      IF( .NOT.INIT ) CALL PABORT(1)
      IF( XMA.LE.XMI .OR. YMA.LE.YMI ) CALL PABORT(2)
      IF( .NOT.TTEST )
     +     CALL TWINDO(INT(XTMIN),INT(XTMAX),INT(YTMIN),INT(YTMAX))

C - Update dimensions of the 'virtual window' in /PLOT10/
      XMIN=XMI
      XMAX=XMA
      YMIN=YMI
      YMAX=YMA

C - Define 'virtual window' by setting the boundaries
C   of the HIGZ normalization transformation (NT)
C   using the 'virtual window' dimensions (NT index = NTV)
      CALL ISWN(NTV,XMIN,XMAX,YMIN,YMAX)
      CALL ISELNT(NTV)

C - Set initial beam position in 'virtual window' coordinates
      XPOS=XMIN
      YPOS=YMIN

C     ... and also in 'screen window' coordinates
      CALL VTOS

C - Suppress rotation/scaling of subsequent drawings using relative arguments
      LROTAT=.FALSE.
      LSCALE=.FALSE.
C
      IF( TRACE ) CALL SEE
C
      RETURN
      END

*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      SUBROUTINE VWINDO(XMI,XMA,YMI,YMA)
      IMPLICIT NONE
      REAL XMI,XMA,YMI,YMA
Code:
      CALL DWINDO(XMI,XMI+XMA,YMI,YMI+YMA)
C
      RETURN
      END

************************************************************************
*
*                       D R A W I N G
*
************************************************************************

************************************************************************
*
*   Moving/Drawing 
*   > in absolute and relative coordinates
*   > in 'screen' and 'virtual' coordinates
*
*   For details see subroutine DRAW
*
C Screen window coordinates
      SUBROUTINE MOVABS(GOX,GOY)
      IMPLICIT NONE
      INTEGER GOX,GOY
      CALL DRAW(REAL(GOX),REAL(GOY),0,1,'A','S')
      RETURN
      END
C
      SUBROUTINE MOVREL(GOX,GOY)
      IMPLICIT NONE
      INTEGER GOX,GOY
      CALL DRAW(REAL(GOX),REAL(GOY),0,1,'R','S')
      RETURN
      END
C
      SUBROUTINE DRWABS(GOX,GOY)
      IMPLICIT NONE
      INTEGER GOX,GOY
      CALL DRAW(REAL(GOX),REAL(GOY),0,2,'A','S')
      RETURN
      END
C
      SUBROUTINE DRWREL(GOX,GOY)
      IMPLICIT NONE
      INTEGER GOX,GOY
      CALL DRAW(REAL(GOX),REAL(GOY),0,2,'R','S')
      RETURN
      END
C
      SUBROUTINE PNTABS(GOX,GOY)
      IMPLICIT NONE
      INTEGER GOX,GOY
      CALL DRAW(REAL(GOX),REAL(GOY),0,3,'A','S')
      RETURN
      END
C
      SUBROUTINE PNTREL(GOX,GOY)
      IMPLICIT NONE
      INTEGER GOX,GOY
      CALL DRAW(REAL(GOX),REAL(GOY),0,3,'R','S')
      RETURN
      END
C
      SUBROUTINE DSHABS(GOX,GOY,L)
      IMPLICIT NONE
      INTEGER GOX,GOY,L
      CALL DRAW(REAL(GOX),REAL(GOY),L,4,'A','S')
      RETURN
      END
C
      SUBROUTINE DSHREL(GOX,GOY,L)
      IMPLICIT NONE
      INTEGER GOX,GOY,L
      CALL DRAW(REAL(GOX),REAL(GOY),L,4,'R','S')
      RETURN
      END

C Virtual window coordinates
      SUBROUTINE MOVEA(XGO,YGO)
      IMPLICIT NONE
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,0,1,'A','V')
      RETURN
      END
C
      SUBROUTINE MOVER(XGO,YGO)
      IMPLICIT NONE
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,0,1,'R','V')
      RETURN
      END
C
      SUBROUTINE DRAWA(XGO,YGO)
      IMPLICIT NONE
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,0,2,'A','V')
      RETURN
      END
C
      SUBROUTINE DRAWR(XGO,YGO)
      IMPLICIT NONE
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,0,2,'R','V')
      RETURN
      END
C
      SUBROUTINE POINTA(XGO,YGO)
      IMPLICIT NONE
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,0,3,'A','V')
      RETURN
      END
C
      SUBROUTINE POINTR(XGO,YGO)
      IMPLICIT NONE
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,0,3,'R','V')
      RETURN
      END
C
      SUBROUTINE DASHA(XGO,YGO,L)
      IMPLICIT NONE
      INTEGER L
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,L,4,'A','V')
      RETURN
      END
C
      SUBROUTINE DASHR(XGO,YGO,L)
      IMPLICIT NONE
      INTEGER L
      REAL XGO,YGO
      CALL DRAW(XGO,YGO,L,4,'R','V')
      RETURN
      END

************************************************************************
      SUBROUTINE DRAW(XGO,YGO,L0,IC0,SYS,WIN)
      IMPLICIT NONE
*
*     Performs graphics action.
*
*     XGO,YGO : Target coordinates for the beam 
*     L0      : Dash type code for dashed lines
*     IC0     : Type of graphics action 
*              = 1 move without action
*              = 2 draw solid line
*              = 3 draw point
*              = 4 draw dashed line 
*     SYS='A' : Target coordinates are absolute
*     SYS='R' :        "           are relative
*     WIN='S' :        "           are screen window  coordinates
*     WIN='V' :        "           are virtual window coordinates
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL XGO,YGO,X(2),Y(2),AMIN1,AMAX1
      INTEGER L,IC,LTYP,DSHTYP,L0,IC0
      CHARACTER*1 WIN,SYS
Code:
C - Check if initialization was done
      IF( .NOT.INIT ) CALL PABORT(1)
      IF( WIN.EQ.'V' .AND. .NOT.DTEST ) CALL PABORT(3)
      IF( WIN.EQ.'S' .AND. .NOT.TTEST ) CALL PABORT(4)
      IC=IC0
      L=L0

C - Select HIGZ viewport for 'screen window' or 'virtual window' and
C get current beam position in the respective window coordinates 
      IF( WIN.EQ.'S' ) THEN
         CALL ISELNT(NTS)
         X(1)=XPOS0
         Y(1)=YPOS0
      ELSE
         CALL ISELNT(NTV)
         X(1)=XPOS
         Y(1)=YPOS
      ENDIF

C - Calculate target position
C ... from relative coordinates
      IF( SYS.EQ.'R' ) THEN
C   - Perform transformation of the relative moving vector
C      if forced by subroutines RROTAT,RSCALE
         IF( LROTAT ) THEN
            X(2)=COS(ANGLE)*XGO-SIN(ANGLE)*YGO
            Y(2)=SIN(ANGLE)*XGO+COS(ANGLE)*YGO
         ELSE
            X(2)=XGO
            Y(2)=YGO
         ENDIF
         IF( LSCALE ) THEN
            X(2)=SCALE*X(2)
            Y(2)=SCALE*Y(2)
         ENDIF
         X(2)=X(2)+X(1)
         Y(2)=Y(2)+Y(1)
      ELSE
C ... from absolute coordinates
         X(2)=XGO
         Y(2)=YGO
      ENDIF

C - Perform clipping of the beam position in the 'screen window' if needed
C     ( preliminary version )
      IF( WIN.EQ.'S' ) THEN
         X(2)=AMIN1(X(2),XMAX0)
         X(2)=AMAX1(X(2),XMIN0)
         Y(2)=AMIN1(Y(2),YMAX0)
         Y(2)=AMAX1(Y(2),YMIN0)
      ENDIF

C - Store new beam position in 'screen' and 'virtual window' coordinates
      IF( WIN.EQ.'S' ) THEN
         XPOS0=X(2)
         YPOS0=Y(2)
         IF( DTEST ) CALL STOV
      ELSE
         XPOS=X(2)
         YPOS=Y(2)
         CALL VTOS
      ENDIF

C - Perform graphics action
      IF( IC.EQ.4.AND.L.EQ.-1 ) IC=1  
      IF( IC.EQ.4.AND.L.EQ.0 )  IC=2  
      IF( IC.EQ.2.OR.IC.EQ.4 ) THEN
         IF( IC.EQ.4 ) THEN
            LTYP=DSHTYP(L)
         ELSE
            LTYP=1
         ENDIF
C ---> Draw a line
         CALL ISLN(LTYP)
         CALL IPL(2,X,Y)
      ELSEIF( IC.EQ.3 ) THEN
C ---> Draw a point
         CALL IPM(1,X(2),Y(2))
      ENDIF
C
      IF( TRACE ) CALL SEEB
C
      RETURN
      END

************************************************************************
      SUBROUTINE RROTAT(DEG)
      IMPLICIT NONE
*
*     Forces rotation of drawings with relative arguments.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL DEG,ACOS
Code:
      IF( DEG.NE.0.0 ) THEN
         LROTAT=.TRUE.
         ANGLE=ACOS(0.)*DEG/90.
      ELSE
         LROTAT=.FALSE.
         ANGLE=0.
      ENDIF
C
      RETURN
      END

************************************************************************
      SUBROUTINE RSCALE(SCA)
      IMPLICIT NONE
*
*     Forces scaling of drawing with relative arguments.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL SCA
Code:
      IF( SCA.NE.0.0 ) THEN
         LSCALE=.TRUE.
         SCALE=SCA
      ELSE
         LSCALE=.FALSE.
         SCALE=0.
      ENDIF
C
      RETURN
      END

************************************************************************
      SUBROUTINE ERASE
      IMPLICIT NONE
*
*     Clears graphics screen.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*******************************************************************
*
*     HIGZ colour parameters for graphics action in JADEZ
*
*     This file is included when compiling SETCOL
*
      LOGICAL LCOL,LINIT
      INTEGER NCOL,IFORE,IBACK,IFORE2,IBACK2
      REAL WID
      PARAMETER (NCOL=10)
      REAL RED,GREEN,BLUE
      CHARACTER TCOL*4
      COMMON /PLTCOL/ LCOL,LINIT,IFORE,IBACK,IFORE2,IBACK2
     _     ,RED(NCOL),GREEN(NCOL),BLUE(NCOL),TCOL(NCOL),WID(NCOL)

      INTEGER PLTFLG
      COMMON /CPLTC2/ PLTFLG
*******************************************************************      

*
      INTEGER I,IT(2)/1,5/
*
Code:
C - Clear window
      CALL ICLRWK(0,1)

C - Close current PostScript file
      CALL PSCLOS

C - Open new PostScript file with previous name
      CALL PSOPEN(' ',0.,0.)
C
      CALL HOME
      IF( LCOL ) THEN
         CALL ISELNT(NTS)
         IF( IBACK.EQ.1 ) 
     +        CALL IGBOX(XTMIN,XTMAX,YTMIN,YTMAX)
         IF( IBACK2.EQ.1 )
     +        CALL IXBOX(XTMIN,XTMAX,YTMIN,YTMAX,1)
      ENDIF
      CALL IUWK(0,1)
C
      RETURN
      END

************************************************************************
      SUBROUTINE CLEAR
      IMPLICIT NONE
*
*     Clears 'TSO' screen.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
Code:
      TLINE=0
      CALL ERASE
C
      RETURN
      END

************************************************************************
      SUBROUTINE TESTGA(MODEGA,GAHEX)
      IMPLICIT NONE
*
*     Tests if GA Mode (set MODEGA=0: No)
*
      INTEGER MODEGA,GAHEX
Code:
      MODEGA=0
C
      RETURN
      END


************************************************************************
*
*               T E R M I N A L     D I A L O G
*
************************************************************************

************************************************************************      
      SUBROUTINE SCURSR(ICHAR,IX,IY)
      IMPLICIT NONE
*
*  Flashes cursor on screen window and await result.
*  Does not change beam position.
*
      INTEGER ICHAR,IX,IY
      REAL X,Y
Code:
      CALL CURSR(ICHAR,X,Y,'S')
      IX=INT(X+.5)
      IY=INT(Y+.5)
C
      RETURN
      END

************************************************************************
      SUBROUTINE VCURSR(ICHAR,X,Y)
      IMPLICIT NONE
*
*  Flashes cursor on virtual window and await result.
*  Does not change beam position.
*
      INTEGER ICHAR
      REAL X,Y
Code:
      CALL CURSR(ICHAR,X,Y,'V')
C
      RETURN
      END

************************************************************************
      SUBROUTINE CURSR(ICHAR,XWC,YWC,WIN)
      IMPLICIT NONE
*
*     Gets the HIGZ cursor position in normalized
*     device coordinates and world coordinates.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER ICHAR
      CHARACTER*1 WIN,TEXT*80(6),CHAR
      INTEGER NT,IBN
      REAL XNDC,YNDC,XWC,YWC
Code:
      IF( WIN.EQ.'S' ) THEN
         CALL ISELNT(NTS)
         WRITE(TEXT(1),'(2X,16(''-''),A,16(''-''))') ' SCREEN  WINDOW '
         WRITE(TEXT(2),'(2(A6,F6.0))') 'Xmin=',XMIN0,'Xmax=',XMAX0
         WRITE(TEXT(3),'(2(A6,F6.0))') 'Ymin=',YMIN0,'Xmax=',YMAX0
      ELSE
         CALL ISELNT(NTV)
         WRITE(TEXT(1),'(2X,16(''-''),A,16(''-''))') ' VIRTUAL WINDOW '
         WRITE(TEXT(2),'(2(A6,E13.7))') 'Xmin=',XMIN,'Xmax=',XMAX
         WRITE(TEXT(3),'(2(A6,E13.7))') 'Ymin=',YMIN,'Xmax=',YMAX
      ENDIF

C - Get graphic cursor position
      CALL IGLOC(20,NT,IBN,XNDC,YNDC,XWC,YWC)
      IF( WIN.EQ.'S' ) THEN
         WRITE(TEXT(4),'(A,F6.0)') ' Cursor position: X = ',XWC
         WRITE(TEXT(5),'(A,F6.0)') '                  Y = ',YWC
      ELSE
         WRITE(TEXT(4),'(A,E13.7)')    ' Cursor position: X = ',XWC
         WRITE(TEXT(5),'(A,E13.7)')    '                  Y = ',YWC
      ENDIF

C - Get character from terminal if right or middle button
C     of the mouse was pressed
      IF( IBN .NE. 1) THEN
         WRITE(*,'(A)') '*** CURSR: Please enter a keyboard character'
         READ(*,'(A1)') CHAR
         CALL CHTOI(CHAR,ICHAR)
         WRITE(TEXT(6)
     +    ,'( ''Keyboard character '',A1,''('',I3, '') is struck'')') 
     +    CHAR,ICHAR 
      ELSE
         TEXT(6)=' '
      ENDIF

C - Display window data and cursor postion on an extra window 
      IF ( TRACE ) THEN
         WRITE(*,'(A80)') TEXT
         CALL IGMESS(6,TEXT,'PLOT-10','P')
      ENDIF
C
      RETURN
      END

************************************************************************
      SUBROUTINE ANCHO(ICHAR)
      IMPLICIT NONE
*
*     Output of a single 7-bit ASCII character.
*     Updates beam position according to the character size set.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER ICHAR
      CHARACTER*1 CHAR
Code:
C NB.: alignment of character in HIGZ = middle/middle
C      beam position before writing = bottom/left
C      beam position after writing = bottom/right

C- Convert to ASCII
      CALL ITOCH(ICHAR,CHAR)

C - Force correct alignment at the top of the screen
      IF( YPOS0.GT.YTMAX-YCHAR ) YPOS0=YTMAX-YCHAR 

C - Perform line feed and carriage return if needed
      IF( XPOS0+XCHAR .GT. XTMAX*(1.+(XTMAX-XTMIN)*1.E-06) ) THEN
         XPOS0=0.
         YPOS0=YPOS0-YCHAR
      ENDIF

C - Goto home position if needed
      IF( YPOS0 .LT. -1.E-06*(YTMAX-YTMIN) ) THEN
         XPOS0=0.
         YPOS0=YTMAX-YCHAR
      ENDIF

C - Print out character using 'screen window' coordinates
      CALL ISELNT(NTS)
      CALL ITX(XPOS0+XCHAR/2.,YPOS0+YCHAR/2.,CHAR)

C - Update beam position
      XPOS0=XPOS0+XCHAR

C - Update also respective 'virtual window' coordinates
      CALL STOV
C
      IF( TRACE ) CALL SEEB
C
      RETURN
      END

************************************************************************
      SUBROUTINE ANSTR(NWORDS,ICHAR)
      IMPLICIT NONE
*
*     Output of an array of characters, one character per word.
*     Updates beam position according to the character size set.
*
      INTEGER NWORDS,ICHAR,I,NWRD
      DIMENSION ICHAR(136)
Code:
      NWRD=MIN(NWORDS,136)
      DO I=1,NWRD
         CALL ANCHO(ICHAR(I))
      ENDDO
C
      RETURN
      END

************************************************************************
      SUBROUTINE EOUTST(NBYTES,SOURCE)
      IMPLICIT NONE
*
*     Output of an array of four characters packed per word.
*     Updates beam position according to the character size set.
*
      INTEGER*1 SOURCE
      INTEGER NBYTES,TARGET,IBYTE,I
      DIMENSION SOURCE(*),TARGET(136)
      INTEGER*2 HTYP(2)
      INTEGER ITYP/1/
      EQUIVALENCE (HTYP(1),ITYP)
Code:
C - use CERNLIB routine BLOW (M426) to unpack full words into bytes
      NBYTES=MIN(NBYTES,136)
      CALL BLOW(SOURCE,TARGET,NBYTES,8)

C - test the byteorder of the present machine and
C     print out each ASCII character coded in the INTEGER*4
C     array TARGET
      DO IBYTE=1,NBYTES
         IF( HTYP(2).EQ.0 ) THEN
C     ... DEC-like
            CALL ANCHO(TARGET(4*(INT((IBYTE-1)/4)+1)-MOD(IBYTE-1,4)))
         ELSE
C     ... IBM-like
            CALL ANCHO(TARGET(IBYTE))
         ENDIF
      ENDDO
C
      RETURN
      END

************************************************************************
      SUBROUTINE CHRSIZ(ICHAR)
      IMPLICIT NONE
*
*     Selects number of characters per line and size of character 
*     including inter character space.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER ICHAR,NC(4),NL(4)
      REAL YY(4)
C ... from PLOT10 manual
      DATA NC/74,81,121,133/
      DATA NL/35,38,58,64/
C ... from IPS users guide
C      DATA YY/63.,56.,42.,35./
Code:
      IF( ICHAR.GT.4 .OR. ICHAR.LT.1 ) ICHAR=1
C - Update text output attributes in /PLOT10/
      KLIN=NL(ICHAR)
      KCHR=NC(ICHAR)
      ICHRSZ=ICHAR
C PLOT10 manual version
      XCHAR=(XTMAX-XTMIN)/(NC(ICHAR)+1)
      YCHAR=(YTMAX-YTMIN)/NL(ICHAR)
C IPS users guide version
C      YCHAR=YY(ICHAR)
C      XCHAR=YCHAR*55./117.

C - Set height of text generated by HIGZ
      CALL ISCHH(YCHAR*.5)
C     
      RETURN
      END

************************************************************************
      SUBROUTINE CSIZE(IHORZ,IVERT)
      IMPLICIT NONE
*
*     Returns horizontal and vertical character dimensions
*     including inter character space in 'raster units'.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER IHORZ,IVERT
Code:
      IHORZ=INT(XCHAR+.5)
      IVERT=INT(YCHAR+.5)
C
      RETURN
      END

************************************************************************
      SUBROUTINE HOME
      IMPLICIT NONE
*
*     Moves alphanumeric cursor to the upper left corner of the screen.
*     Updates beam position.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
Code:
      TLINE=1

C- Update beam position
      XPOS0=0.
C     YPOS0=YTMAX-YCHAR
      YPOS0=YTMAX
      CALL STOV
C
      RETURN
      END

************************************************************************
      SUBROUTINE NEWLIN
      IMPLICIT NONE
*
*     Generates a line feed and carriage return. Updates beam position.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
Code:

C- Update beam position
      XPOS0=0.
      YPOS0=YPOS0-YCHAR
      IF( YPOS0 .LT. 0.) YPOS0=YTMAX-YCHAR
      CALL STOV
C
      RETURN
      END

************************************************************************
      SUBROUTINE LINEF
      IMPLICIT NONE
*
*     Generates a line feed. Updates beam position. 
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
Code:
C- Update beam position
      YPOS0=YPOS0-YCHAR
      IF( YPOS .LT. 0.) YPOS0=YTMAX-YCHAR
      CALL STOV
C
      RETURN
      END

************************************************************************
      SUBROUTINE TRMOUT(NCHAR,TXT)
      IMPLICIT NONE
*
*  Writes a new line of characters to the screen.
*  Does not change beam position.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER NCHAR,ISV
      CHARACTER TXT*(*),TEXT*1(136)
*
      CHARACTER CFMT*9,C*1
      INTEGER LEN,NCH,I,L
      LOGICAL FIRST /.TRUE./
      SAVE ISV,FIRST
Code:
      DO I=1,NCHAR
         TEXT(I)=' '
      ENDDO
      L=LEN(TXT)
      IF( TXT(L:L).EQ.'$') L=L-1
      DO I=1,MIN(NCHAR,L)
         IF( TXT(I:I).EQ.'^' ) THEN
            TEXT(I)=' '
         ELSE
            TEXT(I)=TXT(I:I)
         ENDIF
      ENDDO

C Normal ouput:
      NCH=MIN(NCHAR,KCHR)
      WRITE(CFMT,'(A1,I3,A3)') '(',NCH,'A1)'
      IF( L.NE.LEN(TXT) ) CFMT(7:9)=',$)'
      WRITE(*,FMT=CFMT)  (TEXT(I),I=1,NCH)

      RETURN
      END
C Output to additional window:
C      CALL IUWK(1,1)
C      CALL IDAWK(1)
C      IF( FIRST ) THEN
C         CALL IOPWK(5,1,3)
C         FIRST=.FALSE.
C      ENDIF
C Activate new workstation
C      LTSO=.TRUE.
C      CALL IACWK(5)
C      CALL ISELNT(NTS)
C      ISV=ICHRSZ
C      CALL CHRSIZ(2)
C Print out the text
C      IF( TLINE.GE.KLIN ) THEN
C         WRITE(*,'(T20,A)') '*** PRESS A KEY ***'
C         READ(*,'(A1)') C
C         TLINE=0
C      ENDIF
C      IF( TLINE.EQ.0 ) CALL CLEAR
C      CALL ISTXCI(3)
C      CALL NEWLIN
C      CALL EOUTST(NCH,TEXT)
C      TLINE=TLINE+1
C Reset test attributes
C      CALL CHRSIZ(ISV)
C      CALL SETCOL(' ')
C Deaktivate extra workstation, reactivate the first one
C      LTSO=.FALSE.
C      CALL IUWK(5,1)
C      CALL IDAWK(5)
C      CALL IACWK(1)
C
C      RETURN
C      END

************************************************************************
      SUBROUTINE TRMIN(NCHAR,TXT)
      IMPLICIT NONE
*
*     Gets a line of text from the terminal.
*     Does not change beam position.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER NCHAR,LEN,I,NCH
      CHARACTER TXT*(*),CFMT*6,TEXT*132
Code:
      NCH=MIN(NCHAR,132)
      DO I=1,NCH
         TEXT(I:I)=' '
      ENDDO
      WRITE(CFMT,'(A2,I3,A1)') '(A',NCH,')'
      CALL IUWK(0)
      READ(*,FMT=CFMT) TEXT
      CALL CLTOU(TEXT)
      DO I=1,NCH
         TXT(I:I)=TEXT(I:I)
      ENDDO
      CALL TRMOUT(NCH,TXT)
C
      RETURN
      END

************************************************************************
      SUBROUTINE SYSSYM(X,Y,HEIGHT,HSTR,NSTR,THETA)
      IMPLICIT NONE
*
*  Adds text strings of arbitrary size and  orientation to the graphic. 
*  It works in screen coordinates. Does not change beam position.
*
      REAL X,Y,HEIGHT,THETA
      INTEGER HSTR,NSTR
      DIMENSION HSTR(INT(NSTR/4)+1)
Code:
      CALL GRTEXT(X,Y,HEIGHT,HSTR,NSTR,THETA,'S')
C
      RETURN
      END

************************************************************************
      SUBROUTINE USRSYM(X,Y,HEIGHT,HSTR,NSTR,THETA)
      IMPLICIT NONE
*     
*  Adds text strings of arbitrary size and orientation to the graphic.
*  It works in virtual coordinates. Does not change beam position.
*
      REAL X,Y,HEIGHT,THETA
      INTEGER HSTR,NSTR
      DIMENSION HSTR(INT(NSTR/4)+1)
Code:
      CALL GRTEXT(X,Y,HEIGHT,HSTR,NSTR,THETA,'V')
C
      RETURN
      END

************************************************************************
      SUBROUTINE GRTEXT(X,Y,HGHT,HSTR,NSTR,THETA,WIN)
      IMPLICIT NONE
*
*  Adds text strings of arbitrary size and orientation to the graphic. 
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL X,Y,HEIGHT,THETA,WIDTH,HGHT,W,H
      REAL XS,YS,COS,SIN,CS,SN,DX,DY
      INTEGER HSTR,ISTR,NSTR,I
      CHARACTER WIN*1
      CHARACTER CSTR*1,CSTR4*4,SPCSYM*4
      DIMENSION ISTR(ABS(NSTR)),CSTR(ABS(NSTR)),CSTR4(ABS(NSTR))
     +     ,HSTR(INT(ABS(NSTR)/4)+1)
*
      INTEGER*2 HTYP(2)
      INTEGER ITYP/1/
      EQUIVALENCE (HTYP(1),ITYP)
Code:
C - Check if initialization was done
      IF( .NOT.INIT ) CALL PABORT(1)
      IF( WIN.EQ.'V' .AND. .NOT.DTEST ) CALL PABORT(3)
      IF( WIN.EQ.'S' .AND. .NOT.TTEST ) CALL PABORT(4)
C --- Conversion from ASCII integer to character string
      CALL BLOW(HSTR,ISTR,ABS(NSTR),8)
      IF( NSTR.GT.0 ) THEN
         DO I=1,NSTR
            IF( HTYP(2).EQ.0 ) THEN
C     ... DEC like byte order
               CALL ITOCH(ISTR(4*(INT((I-1)/4)+1)-MOD(I-1,4)),CSTR(I))
            ELSE
C     ... IBM like byte order
               CALL ITOCH(ISTR(I),CSTR(I))
            ENDIF
         ENDDO
      ELSE
C ---- Conversion from ASCII integer to special symbols
         DO I=1,ABS(NSTR)
            CSTR4(I)=SPCSYM(HSTR(I))
         ENDDO
      ENDIF

C - Select HIGZ viewport for 'screen window' or 'virtual window'
      IF( WIN.EQ.'S' ) THEN
         CALL ISELNT(NTS)
      ELSE
         CALL ISELNT(NTV)
      ENDIF

C - Fetch beam position
      XS=X
      YS=Y

C - Define text attributes ( preliminary )
C      IF( HGHT.GE. 60.) THEN
C         HEIGHT=117./63.*HGHT
C         WIDTH=55./117.*HEIGHT
C      ELSEIF( HGHT.GE.49. .AND. HGHT.LT.60.) THEN
C         HEIGHT=108./56.*HGHT
C         WIDTH=50./108.*HEIGHT
C      ELSEIF( HGHT.GE.39. .AND. HGHT.LT.50.) THEN
C         HEIGHT=71./42.*HGHT
C         WIDTH=33.6/71.*HEIGHT
C      ELSE
C         HEIGHT=64./35.*HGHT
C         WIDTH=30.5/64.*HEIGHT
C      ENDIF
      HEIGHT=HGHT*1.3
      WIDTH=HEIGHT*55./117.
      CALL ISCHH(HEIGHT*.5)
      CALL IGSET('TANG',THETA)

C - Print out the text
C NB.: Character-wise print out is needed in order
C      to ensure equidistant character output !!!
      DO I=1,ABS(NSTR)
         CS=COS(THETA*3.1415927/180.)
         SN=SIN(THETA*3.1415927/180.)
         DX=WIDTH*CS
         DY=WIDTH*SN
         W=.5*WIDTH*CS
         H=.45*HEIGHT*(1+SN)
         IF( NSTR.GT.0 ) THEN
            CALL ITX(XS+W,YS+H,CSTR(I)) ! normal text
         ELSE
            CALL ISTXFP(0,2)
            CALL ITX(XS+W,YS+H
     +           ,CSTR4(I)(1:INDEX(CSTR4(I)//' ',' ')-1)) ! special symbols
            CALL ISTXFP(IFNT,IPRC) ! restore font
         ENDIF
         XS=XS+DX
         YS=YS+DY
      ENDDO

C - Restore inclination angle and text height
      CALL IGSET('TANG',0.)
      CALL ISCHH(YCHAR*.5)

C
      RETURN
      END


************************************************************************
*
*                       U T I L I T I E S
*
************************************************************************


************************************************************************
      SUBROUTINE SEELOC(IX,IY)
      IMPLICIT NONE
*
*     Gets current beam position.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER IX,IY
Code:
      IX=XPOS0
      IY=YPOS0
C
      RETURN
      END

************************************************************************
      SUBROUTINE SEETW(MINX,MAXX,MINY,MAXY)
      IMPLICIT NONE
*
*     Gets screen window data.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER MINX,MAXX,MINY,MAXY
Code:
      IF (.NOT. TTEST) RETURN
      MINX=INT(XMIN0+.5)
      MAXX=INT(XMAX0+.5)
      MINY=INT(YMIN0+.5)
      MAXY=INT(YMAX0+.5)
C
      RETURN
      END

************************************************************************
      SUBROUTINE SEEDW(XMIND,XMAXD,YMIND,YMAXD)
      IMPLICIT NONE
*
*     Gets virtual window data.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL XMIND,XMAXD,YMIND,YMAXD
Code:
      IF (.NOT. DTEST) RETURN
      XMIND=XMIN
      XMAXD=XMAX
      YMIND=YMIN
      YMAXD=YMAX
C
      RETURN
      END

************************************************************************
      SUBROUTINE HDCOPY
      IMPLICIT NONE
*
*     Copy to printer.
*     Save current picture as PostScript file.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      INTEGER IC/1/,LRECL/1024/,ISTAT,ICYCLE
      CHARACTER CIC*3/'001'/
      SAVE IC,CIC
Code:
C - Close current PostScript file
      WRITE(*,FMT=100) FNAME(1:INDEX(FNAME,' ')-1)//'.'//CIC//'.ps'
 100  FORMAT('*** HDCOPY: Saving current picture as ',A)
      CALL PSCLOS

C - Increment copy counter for next copy
      IC=MOD(IC+1,1000)
      IF(IC.LT.10) THEN
         WRITE(CIC,'(A2,I1)') '00',MOD(IC,1000)
      ELSEIF(IC.GE.10.AND.IC.LT.100) THEN
         WRITE(CIC,'(A1,I2)') '0',IC
      ELSEIF(IC.GE.100.AND.IC.LT.1000) THEN
         WRITE(CIC,'(I3)') IC
      ENDIF

C - Prepare for next copy:
      CALL PSOPEN(FNAME(1:INDEX(FNAME,' ')-1)//'.'//CIC//'.ps'
     +     ,XSIZE,YSIZE)
C
      RETURN
      END

************************************************************************
      SUBROUTINE HDCEXT

*     Copy to printer.
*     Save current picture as PostScript file
*
Code:
      CALL HDCOPY
C
      RETURN
      END

************************************************************************
      SUBROUTINE HDCDST(DUMMY)
      IMPLICIT NONE
*
*     Copy to printer.
*     Save current picture as PostScript file
*
      REAL*8 DUMMY
Code:
      WRITE (*,'(''HDCDST: PRINTER ='',A8)') DUMMY
      CALL HDCOPY
C
      RETURN
      END

***THE***END***THE***END***THE***END***THE***END***THE***END***THE***END

************************************************************************
*
*     Further support routines for the PLOT-10 emulation
*
************************************************************************

************************************************************************
      SUBROUTINE IGSTRT
      IMPLICIT NONE
*
*     Standard initialization of HIGZ
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
* PAW
      INTEGER NWPAW
      REAL RPAW
      PARAMETER(NWPAW=50000)
      COMMON/PAWC/ RPAW(NWPAW)
Code:
C - Initialization of ZEBRA
      CALL MZEBRA(-3)

C - Initialization of storage in /PAWC/
      CALL MZPAW(NWPAW,'M')

C - Initialization of HIGZ
      CALL IGINIT(0)

C - Get Workstation type from standard input
C      CALL IGWKTY(KWTYPE)
      KWTYPE=2

C - Initialization of underlaying graphics package
      CALL IGSSE(6,KWTYPE)

C - Clear HIGZ window and force X11 synchronization
      CALL ICLRWK(0,1)
      CALL IXSYNC(ISYNC)

C - Physical dimensions of later graphics output (in cm)
C   and name of graphics output file
C   ...for A4 format
CC      XSIZE=21.
CC      YSIZE=29.7!XSIZE*YTMAX/XTMAX
C   ...for eps format
      XSIZE=25.
      YSIZE=XSIZE*YTMAX/XTMAX
C
      FNAME='JADE'

C - Prepare PostScript output of HIGZ graphics
C  via subroutine HDCOPY 
      CALL PSOPEN(FNAME(1:INDEX(FNAME,' ')-1)//'.001.ps'
     +     ,XSIZE,YSIZE)
C
      RETURN
      END

************************************************************************
      SUBROUTINE IGFIN
*
*     Standard termination of HIGZ
*
C - Update the open workstation and return to alphanumeric mode
      CALL IGTERM

C - Terminate HIGZ
      CALL IGEND
C
      RETURN
      END

************************************************************************
      SUBROUTINE IGDEF
      IMPLICIT NONE
*
*     Default settings of HIGZ graphics
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
C
C Line attributes

C     - line type
      CALL ISLN(1)

C     - line width
      CALL ISLWSC(1.)

C     - colour
      CALL ISPLCI(1)

C
C Marker attributes
C     - type
      CALL ISMK(1)

C     - scale
      CALL ISMKSC(.2)

C     - colour
      CALL ISPMCI(1)

C
C Text attributes
C     - alignment
      CALL ISTXAL(2,3)

C     - height
      CALL ISCHH(.2)

C     - font
      IFNT=0
      IPRC=2
      CALL ISTXFP(IFNT,IPRC)
C     - colour
      CALL ISTXCI(1)
C
      RETURN
      END

************************************************************************
      INTEGER FUNCTION DSHTYP(L)
      IMPLICIT NONE
*
*     Approximates PLOT-10 dash types with HIGZ dash types.
*
      INTEGER L
Code:
      IF(L.EQ.1) THEN
         DSHTYP=3
      ELSEIF(L.EQ.2) THEN
         DSHTYP=4
      ELSEIF(L.EQ.3.OR.L.EQ.12.OR.L.EQ.34) THEN
         DSHTYP=2
      ELSEIF(L.EQ.4.OR.L.EQ.38.OR.L.EQ.47) THEN
         DSHTYP=12
      ELSE
         DSHTYP=3
      ENDIF
C
      RETURN
      END

************************************************************************
      CHARACTER*4 FUNCTION SPCSYM(I)
      IMPLICIT NONE
*
*     Approximates special symbols generated by the 
*     software generator subroutines SYSSYM and USRSYM.
*
      INTEGER I,J
      CHARACTER C*4(0:15)
      DATA C /                  ! translate to IGTEXT 'specials' code
     +     '<"1#',              !  0 empty square
     +     '<"0#',              !  1 circle
     +     '<"2#',              !  2 empty triangle
     +     '>"+#',              !  3 plus
     +     '>"X#',              !  4 cross
     +     '<"U#',              !  5 rhomb
     +     '>"6#',              !  6 arrow up (approx.)
     +     '>"W#',              !  7 ampersand (approx.)
     +     'Z   ',              !  8 Z (approx.)
     +     'Y   ',              !  9 Y (approx.)
     +     '>"F#',              ! 10 double cross ( approx.)
     +     '>"*#',              ! 11 star *
     +     '<"C#',              ! 12 empty cross (approx.)
     +     '>"B#',              ! 13 vertical line
     +     '<"4#',              ! 14 empty star
     +     '    ' /             ! 15 
Code:
      IF( I.LT.0 .OR. I.GT.14 ) THEN
         J=15
      ELSE
         J=I
      ENDIF
      SPCSYM=C(J)
C
      RETURN
      END

************************************************************************
      SUBROUTINE STOV
      IMPLICIT NONE
*
*     Transformation of beam position from 'screen window' 
*     coordinates into 'virtual window' coordinates .
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
Code:
      XPOS=(XMAX-XMIN)/(XMAX0-XMIN0)*(XPOS0-XMIN0)+XMIN
      YPOS=(YMAX-YMIN)/(YMAX0-YMIN0)*(YPOS0-YMIN0)+YMIN
C
      RETURN
      END

************************************************************************
      SUBROUTINE VTOS
      IMPLICIT NONE
*
*     Transformation of beam position from 'virtual window' 
*     coordinates into 'screen window' coordinates.
*     Clipping is also performed ( preliminary version ).
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL AMAX1,AMIN1
Code:
      XPOS0=(XMAX0-XMIN0)/(XMAX-XMIN)*(XPOS-XMIN)+XMIN0
      YPOS0=(YMAX0-YMIN0)/(YMAX-YMIN)*(YPOS-YMIN)+YMIN0
      XPOS0=AMIN1(XPOS0,XMAX0)
      XPOS0=AMAX1(XPOS0,XMIN0)
      YPOS0=AMIN1(YPOS0,YMAX0)
      YPOS0=AMAX1(YPOS0,YMIN0)
C
      RETURN
      END

************************************************************************
      SUBROUTINE PABORT(INDX)
      IMPLICIT NONE
*
*     Program stop in case of error.
*
      INTEGER INDX
Code:
      IF( INDX.EQ.1 ) THEN
         WRITE(*,'(A)') 'PABORT: Call of subroutine INITT missed!'
      ELSEIF (INDX.EQ.2) THEN
         WRITE(*,'(A)') 'PABORT: Window parameters are wrong!'
      ELSEIF (INDX.EQ.3) THEN
         WRITE(*,'(A)') 'PABORT: Virtual window not defined!'
      ELSEIF (INDX.EQ.4) THEN
         WRITE(*,'(A)') 'PABORT: Screen window not defined!'
      ENDIF
      WRITE(*,'(A)')  'Will stop now !'
      STOP
C
      END

************************************************************************
      SUBROUTINE SEE
      IMPLICIT NONE
*
*     Shows beam position plus windows settings.
*
      INTEGER MINX,MAXX,MINY,MAXY,BEAMX,BEAMY
      REAL XMIN,XMAX,YMIN,YMAX,XBEAM,YBEAM
      CHARACTER TEXT*80(9)
Code:
      CALL SEELOC(BEAMX,BEAMY)
      CALL SEELC2(XBEAM,YBEAM)
      CALL SEETW(MINX,MAXX,MINY,MAXY)
      CALL SEEDW(XMIN,XMAX,YMIN,YMAX)
C
      WRITE(TEXT(1),'(2X,12(''-''),A,12(''-''))') 
     +     ' CURRENT WINDOW PARAMETERS '
      TEXT(2)=' Screen  window:'
      WRITE(TEXT(3),'(2(A6,I6))') 'Xmin=',MINX,'Xmax=',MAXX
      WRITE(TEXT(4),'(2(A6,I6))') 'Ymin=',MINY,'Xmax=',MAXY
      WRITE(TEXT(5),'(A,2I6)') ' Beam: (X,Y) = ',BEAMX,BEAMY
C
      TEXT(6)=' Virtual window:'
      WRITE(TEXT(7),'(2(A6,E13.7))') 'Xmin=',XMIN,'Xmax=',XMAX
      WRITE(TEXT(8),'(2(A6,E13.7))') 'Ymin=',YMIN,'Xmax=',YMAX
      WRITE(TEXT(9),'(A,2E13.7)')   ' Beam: X = ',XBEAM,YBEAM
      CALL IGMESS(9,TEXT,'PLOT-10','P') 
      WRITE(*,'(A80)') TEXT
C
      RETURN
      END

************************************************************************
      SUBROUTINE SEEB
      IMPLICIT NONE
*
*     Shows beam position.
*
      INTEGER BEAMX,BEAMY
      REAL XBEAM,YBEAM
      CHARACTER TEXT*80(3)
Code:
      CALL SEELOC(BEAMX,BEAMY)
      CALL SEELC2(XBEAM,YBEAM)
      WRITE(TEXT(1),'(2X,15(''-''),A,15(''-''))') 
     +     ' CURRENT BEAM POSITON '
      WRITE(TEXT(2),'(A,2I6)') ' Screen window : (X,Y) = ',BEAMX,BEAMY
      WRITE(TEXT(3),'(A,2E13.7)') ' Virtual window: (X,Y) = '
     +     ,XBEAM,YBEAM
      CALL IGMESS(3,TEXT,'PLOT-10','P') 
      WRITE(*,'(A80)') TEXT
C
      RETURN
      END

************************************************************************
      SUBROUTINE SEELC2(X,Y)
      IMPLICIT NONE
*
*     Gets current beam position.
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL X,Y
Code:
      X=XPOS
      Y=YPOS
C
      RETURN
      END

************************************************************************
      SUBROUTINE PSCLOS
*
*     Closes current Postscript file and deactivates metafile control.
*
C  - deactivate metafile 
      CALL IGMETA(0,0)

C  - clear workstation 2 (used by IGMETA)  
      CALL ICLWK(2)

C  - close PostScript file
      CLOSE(77)
C
      RETURN
      END

************************************************************************
      SUBROUTINE PSOPEN(FNAM,XSIZ,YSIZ)
      IMPLICIT NONE
*
*     Opens Postscript file and activates metafile control.
*
      CHARACTER FNAM*(*)
      REAL XSIZ,YSIZ
      LOGICAL FIRST/.TRUE./
      CHARACTER*200 FNAM0,F
      REAL XSIZ0,YSIZ0,X,Y
      SAVE FNAM0,XSIZ0,YSIZ0
Code:
      IF( FNAM.EQ.' ' ) THEN
         IF( FIRST ) RETURN
         X=XSIZ0
         Y=YSIZ0
         F=FNAM0
      ELSE
         CALL VBLANK(F,50)
         CALL VBLANK(FNAM0,50)
         X=XSIZ
         Y=YSIZ
         F=FNAM
         XSIZ0=X
         YSIZ0=Y
         FNAM0=F
      ENDIF

C - Open PostScript file
      OPEN(UNIT=77,FILE=F(1:INDEX(F,' ')-1)
     +     ,FORM='FORMATTED',STATUS='UNKNOWN')

C - activate metafile control -[format] nx ny type
C     format  = 4     : A4
C     (nx,ny) = (1,1) : one zone in x/y direction
C     type    = 1,4   : portrait mode
C               2,5   : landscape mode
C
      CALL IGMETA(77,-113)

C - define physical dimensions of the picture 
      CALL IGRNG(X,Y)
C
      FIRST=.FALSE.
C
      RETURN
      END

************************************************************************
      SUBROUTINE SETLIN(Y)
      IMPLICIT NONE
*
*     Updates current line position in COMMON /PLOT10/.
*     A call of SETLIN is sometimes needed when the former terminal output
*     is not performed with the PLOT-10 subroutines EOUTST, ANCHO ...
*
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
*
      REAL Y
Code:
      YPOS0=INT(Y+.5)
C
      RETURN
      END
************************************************************************
      SUBROUTINE ITOADE(I,A,N)
      IMPLICIT NONE
*
*     Converts ASCII character set into the integer representation 
*     'ADE format' (1...127).
*
      INTEGER A(N),F,I,N,J,K
Code:
      F=10**(N-1)
      K=I
      DO J=1,N
         A(J)=K/F+48
         K=K-K/F*F
         F=F/10
      ENDDO
C
      RETURN
      END
 
************************************************************************
      SUBROUTINE EBCASC(IA,IB,IOPT)
      IMPLICIT NONE
*
*    Converts ASCII <-> EBCDIC.
*     Input : IA INTEGER
*     Output: IB INTEGER
*     IOPT=1: Conversion ASCII  -> EBCDIC
*          0: Conversion EBCDIC -> ASCII
*
      INTEGER IA,IB
      INTEGER I,IOPT,EBCDIC(95)
      DATA EBCDIC/64,90,127,123,91,108,80,125,77,93,92
     _     ,78,107,96,75,97
     _     ,240,241,242,243,244,245,246,247,248,249
     _     ,122,94,76,126,110,111,124
     _     ,193,194,195,196,197,198,199,200,201
     _     ,209,210,211,212,213,214,215,216,217
     _     ,226,227,228,229,230,231,232,233
     _     ,-1,224,-1,-1,109,121
     _     ,129,130,131,132,133,134,135,136,137
     _     ,145,146,147,148,149,150,151,152,153
     _     ,162,163,164,165,166,167,168,169,192
     _     ,106,208,161/
Code:
      IB=-1
      IF( IOPT.EQ.0 ) THEN
         DO I=1,95
            IF( EBCDIC(I).EQ.IA .AND. EBCDIC(I).NE.-1 ) IB=I+31
         ENDDO
      ELSEIF( IOPT.EQ.1 ) THEN
         IF( IA.GT.31 .AND. IA.LT.127 ) IB=EBCDIC(IA-31)
      ENDIF
C
      IF( IB.EQ.-1 ) THEN
        WRITE(*,10) IA,IOPT
 10     FORMAT('EBCASC: WRONG ARGUMENT, IA=',I6,' IOPT=',I6)
        IB=0
      ENDIF
C
      RETURN
      END


* The End

C   12/03/84 412051642  MEMBER NAME  TAGRAW   (S)           FORTRAN
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE TAGRAW(IWRITE,*)
C
C THIS IS A VERSION OF TAGADC THAT HANDLES RAW DATA
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
       DIMENSION CALIB(2)
       DATA CALIB  / 10.0 , 6.6667 /
       DATA ICOUNT / 0 /
       LOGICAL NOMSG  / .FALSE. /
       LOGICAL LERROR / .FALSE. /
C
C
       IF ( NDDINN .NE. 0 ) NOMSG = .TRUE.
C
C FIND THE POINTERS ETC
C
C
       CALL BLOC(IND,'ATAG',0,*9001)
       I2S = ( IND * 2 ) + 3
       I2F = 2 * ( IND + IDATA(IND) )
       IF ( HDATA(I2F) .EQ. 0 ) I2F = I2F - 1
C
C
C  UNPACK ADC DATA
C
       IADD = 0
       DO  30 IS = I2S,I2F,1
          IDD = HDATA(IS)
C
C IDD GE 0 => DATA,OTHERWISE -(ADDRESS)
C
          IF ( IDD .GE. 0 ) GOTO 103
C
C HERE IF IDD IS AN ADDRESS - CONVERT IT TO A (POSITIVE) ADDRESS
C
          IADD = IDD + 32768
C
C NOW GOTO END OF LOOP - NEXT BIT OF DATA IS CONTENTS BELONGING
C TO THIS ADDRESS
C
          GOTO  30
C
  103     CONTINUE
C
C HERE FOR DATA
C
 5903     CONTINUE
          ITD = IS
          IF ( (IADD .GE. 96) .OR. (IADD .LT. 0) ) GOTO 20
C
C CONVERT HARDWARE ADDRESS TO SOFTWARE ADDRESS
C
          CALL TAGH2S(ISAD,IADD,*19)
C
          IF ( (ISAD .GT. IENDPZ) .OR. (ISAD .LT. 0) ) GOTO 19
C
C
C ISAD - SOFTWARE ADDRESS,IADD HARDWARE - ADDRESS,IDD - DATA
C NOW FILL CATAG LOCATION (ISAD) WITH CORRECT ENERGY FOR
C THIS BLOCK ( APPROXIMATELY IN MEV THANKS TO CALIB)
C
          CATAG(ISAD) = IDD * CALIB(MARK)
C
C
C CHECK FOR CRAZY DATA
C
          IF ( (IDD .GE. 0) .AND. (IDD .LE. 4090) ) GOTO 20
C
C
C
C---------------------------------- ERROR CONDITIONS-----------------
C
   18     CONTINUE
C
           IF ( .NOT. NOMSG ) WRITE(6, 11)ISAD,CATAG(ISAD)
   11      FORMAT(//,' +++  WARNING FROM TAGGING ROUTINE - TAGRAW -',
     *                '   CATAG(',I4,') HAS CRAZY VALUE -',F12.3,
     *                ' ---  IT HAS BEEN SET TO ZERO ')
C
C---                                     SET THE ARRAY TO ZERO
C
           CATAG(ISAD) = 0.0
           IF ( .NOT. NOMSG ) LERROR = .TRUE.
           GOTO 20
C
C--------------------------------------- HERE FOR ILLEGAL ADDRESS
C
   19      IF ( NOMSG ) GOTO 20
           LERROR = .TRUE.
           WRITE(6, 21)IHAD,ISAD
   21      FORMAT(' +++ ILEGAL ADDRESS FOUND IN TAGRAW IHAD,ISAD ',2I10)
C
C    END OF ERROR HANDLING
C
   20     CONTINUE
C
C INCREMENT ADDRESS
C
          IADD=IADD+1
   30  CONTINUE
C
C---                                     NOW TEST FOR ANY ERRORS
C
       IF ( NOMSG .OR. ( .NOT. LERROR ) )  RETURN
       LERROR = .FALSE.
C
C---                                     IF THERE WAS AN ERROR THEN
C---                                     DUMP OUT THE OFFENDING BANK
C
       CALL HPRS('ATAG',0)
C
C---                                     COUNT THE NUMBER OF ERRORS
C
       ICOUNT = ICOUNT + 1
       IF ( ICOUNT .NE. 10 ) RETURN
       NOMSG = .TRUE.
       WRITE(6, 31)
   31  FORMAT(///,'+++  MORE THAN TEN ERRORS DETECTED BY TAGRAW',
     *            '  -- NO MORE MESSAGES  +++',///)
   41  FORMAT(6(/,8(2X,F9.2)))
C
       RETURN
C
 9001  RETURN 1
C
       END

C   13/08/87 806031220  MEMBER NAME  EKAND    (S)           FORTRAN77
      SUBROUTINE EKAND(JTRK,IKAND)
C-----------------------------------------------------------
C  VERSION OF 13/08/87                          E ELSEN
C  REWRITE OF F11HEL.NEUFS(EKAND)
C
C  INPUT:
C     JTRK  TRACK NUMBER
C  OUTPUT:
C     IKAND = 0 IF ELECTRON CANDIDATE
C           = FAILURE REASON ELSE
C
C  RECORD OF CHANGES:
C  22/04/88  LOG ESHM<0 OCCURENCES
C-----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C
      COMMON / CERECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT,
C  RETURN VALUES FOR CUT VARIABLES
     + ISCAN,ICHECK,CTH,PMOM6,JREM,NDEX,RELDE,DEDX,
     + SULPI,SULH2,PCHI2,ESHLO,VEREL,IPAR,IPAMI,AMINV,
C  RETURN VALUES FOR NON CUT VARIABLES
     + SIGDE,ESHM,ESHSUB,EBITER,ENEW,CHI2N,ICON,SUMPI,ICOP,DPHIM
C
      INTEGER ONE / 1 /
C
      CALL CINIT
      IKAND=0
C
      CALL BLOC(NPLGZU,'LGZU',JTRK,&1200)
C                                 NUMBER OF TRACK IN 'ZE4V' BANK
      JREM=HW(NPLGZU*2+3)
C
C------------------------------------------------- SCAN FLAG
      ISCAN=HW(NPLGZU*2+1)
      IF(ISCAN.GE.ISCUT )   IKAND = LOR(LAND(ICUT,SHFTL(ONE, 0)),IKAND)
C
C------------------------------------------------- ICHECK
      ICHECK=HW(NPLGZU*2+2)
      IF(ICHECK.LT.ICHCUT)  IKAND = LOR(LAND(ICUT,SHFTL(ONE, 1)),IKAND)
C
C------------------------------------------------- COS(THETA)
      PMOM6=RW(NPLGZU+25)
      IF(PMOM6.LT.0.001) PMOM6=0.001
      CTH=RW(NPLGZU+34)/PMOM6
      CTH=ABS(CTH)
      IF(CTH.GT.COSCUT )    IKAND = LOR(LAND(ICUT,SHFTL(ONE, 2)),IKAND)
C
C------------------------------------------------- MOMENTUM CUT
      IF(PMOM6.LT.PCUT)     IKAND = LOR(LAND(ICUT,SHFTL(ONE, 3)),IKAND)
C
C------------------------------------------------- JTRK IN 'ZE4V' ?
      IF(JREM.LE.0 )        IKAND = LOR(LAND(ICUT,SHFTL(ONE, 4)),IKAND)
C
C----------DE/DX--------DE/DX--------DE/DX-------- DE/DX CUTS
C
      NDEX=HW(NPLGZU*2+4)
      DEDX=RW(NPLGZU+3)
      IF(DEDX.LT.0.001) DEDX=0.001
      SIGDE=RW(NPLGZU+4)
      IF( SIGDE.GT.0. .AND. NDEX.EQ.0 ) NDEX = 1000
      IF(SIGDE.LE.0.0) SIGDE=10.0
      RELDE=SIGDE/DEDX
C
C---------------------------------------------------------- DE/DX HITS
      IF(NDEX.LT.NDCUT)     IKAND = LOR(LAND(ICUT,SHFTL(ONE, 5)),IKAND)
C
C------------------------------------------------------ RELATIVE SIGMA
      IF(RELDE.GT.RSCUT)    IKAND = LOR(LAND(ICUT,SHFTL(ONE, 6)),IKAND)
C
C---------------------------------------------------------- DE/DX
      IDCUT=0
      GOTO (100,110), IDVERS
C                               SIGMA CUT
  100 DELO=10.0-DLOCUT*SIGDE
      DEHI=10.0+DHICUT*SIGDE
      GOTO 120
C                               FIXED DE/DX CUT
  110 DELO=DFLCUT
      DEHI=DFHCUT
  120 IF(DEDX.LT.DELO.OR.DEDX.GT.DEHI) IDCUT=1
      IF(IDCUT.EQ.1)        IKAND = LOR(LAND(ICUT,SHFTL(ONE, 7)),IKAND)
C
C--------LEAD GLASS--------LEAD GLASS--------LEAD GLASS------ LG CUTS
C
      ESHM=RW(NPLGZU+16)
      ESHSUB=ESHM
        ESSU=RW(NPLGZU+16)
        IF(ESSU.LT.0.001) ESSU=0.001
      EBITER=RW(NPLGZU+17)
        IF(EBITER.LT.0.001) EBITER=0.001
      ENEW=RW(NPLGZU+18)
      CHI2N=RW(NPLGZU+29)
      PCHI2=RW(NPLGZU+30)
      ICON=HW(NPLGZU*2+92)
      SUMPI=RW(NPLGZU+47)
      ICOP=HW(NPLGZU*2+95)
      DPHIM=RW(NPLGZU+49)
      SUPH2=RW(NPLGZU+51)
C
C-------------------------------------------- UNIQUENESS
      SULPI=SUMPI/ESSU
      IF(SULPI.GT.SUMCUT) GOTO 200
      IF(SUMPI.GT.0.3) GOTO 210
      CFAC=1.0-0.08*SULPI
      ESHSUB=ESHSUB*CFAC
      GOTO 210
  200 IKAND =                       LOR(LAND(ICUT,SHFTL(ONE, 8)),IKAND)
C
C-------------------------------------------- NEAR BY LG ENERGY
  210 SULH2=SUPH2/ESSU
      IF(SULH2.GT.ENECUT)   IKAND = LOR(LAND(ICUT,SHFTL(ONE, 9)),IKAND)
C
C------------------------------------------------------------ P(CHI**2)
      IF(PCHI2.LT.PCHCUT)   IKAND = LOR(LAND(ICUT,SHFTL(ONE,10)),IKAND)
C
C----------------------------------------------------SHADOW ENERGY
      ESHAD=ENEW/EBITER
      ESHAD=AMAX1(0.011,ESHAD)
      ESHLO=LOG10(ESHAD)
      IF(ESHLO.GT.ESHCUT)   IKAND = LOR(LAND(ICUT,SHFTL(ONE,11)),IKAND)
C
C-------- GAMMA CONVERSIONS -------- GAMMA CONVERSIONS --------
C
      IPAR=HW(NPLGZU*2+111)
      IF(IPAR.GE.0 )        IKAND = LOR(LAND(ICUT,SHFTL(ONE,12)),IKAND)
C
      IPAMI=HW(NPLGZU*2+73)
      AMINV=RW(NPLGZU+38)
      IF(AMINV.LT.AMICUT )  IKAND = LOR(LAND(ICUT,SHFTL(ONE,13)),IKAND)
C
C
C
C
C---------------------------------------------------- E/P
      IF(ESHM.LT.0.      )  IKAND = LOR(LAND(ICUT,SHFTL(ONE,14)),IKAND)
      GOTO (220,230), JEVERS
  220 VEREL=AMAX1(0.01,ESHSUB/PMOM6)
      GOTO 240
  230 VEREL=AMAX1(0.01,ESHM/PMOM6)
  240 IF(VEREL.LT.EPCUT)    IKAND = LOR(LAND(ICUT,SHFTL(ONE,19)),IKAND)
      IF(VEREL.GT.EPHCUT)   IKAND = LOR(LAND(ICUT,SHFTL(ONE,20)),IKAND)
C
      GO TO 1210
C
C---------------------- NO 'LGZU' BANK
 1200 IKAND = SHFTL(ONE,26)
 1210 CALL EALZST( IKAND )
      RETURN
      END
C=======================================================================
C
      BLOCK DATA
C
C     STANDARD SELECTION CUTS FOR ELECTRON CANDIDATES
C
      COMMON  / CERECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT,
C  RETURN VALUES FOR CUT VARIABLES
     + ISCAN,ICHECK,CTH,PMOM6,JREM,NDEX,RELDE,DEDX,
     + SULPI,SULH2,PCHI2,ESHLO,VEREL,IPAR,IPAMI,AMINV,
C  RETURN VALUES FOR NON CUT VARIABLES
     + SIGDE,ESHM,ESHSUB,EBITER,ENEW,CHI2N,ICON,SUMPI,ICOP,DPHIM
C
C
C          STANDARD CUT CRITERIA
      DATA ICUT/ 548350 /
C
C          SCAN FLAG,                 COS(THETA),      MOMENTUM
      DATA ISCUT/ 1 /,  ICHCUT/ 3 /,  COSCUT/ 0.76 /,  PCUT/ 1.0 /
C
C          DE/DX HITS,  RELATIVE SIGMA, DE/DX CUT VERSION
      DATA NDCUT/ 15 /, RSCUT/ 0.175 /, IDVERS/ 1 /
C
C          LOWER          UPPER SIGMA CUT
      DATA DLOCUT/ 1.0 /, DHICUT/ 2.0 /
C
C          LOWER          UPPER FIXED DE/DX CUT
      DATA DFLCUT/ 9.0 /, DFHCUT/ 12.5 /
C
C          UNIQUENESS,     NEAR BY LG ENERGY
      DATA SUMCUT/ 0.60 /, ENECUT/ 0.30 /
C
C          P(CHI**2),       SHADOW ENERGY
      DATA PCHCUT / 0.02 /, ESHCUT/ -0.3 /
C
C          E/P VERSION,  LOWER         UPPER E/P CUT
      DATA JEVERS/ 1 /,  EPCUT/ 0.8 /, EPHCUT/ 3.0 /
C
C          MINIMUM INVARIANT MASS
      DATA AMICUT/ 0.050 /
C
      END
C=======================================================================
C
      SUBROUTINE CINIT
C
C     INITIATE RETURN VALUES
C
      COMMON  / CERECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT,
C  RETURN VALUES FOR CUT VARIABLES
     + ISCAN,ICHECK,CTH,PMOM6,JREM,NDEX,RELDE,DEDX,
     + SULPI,SULH2,PCHI2,ESHLO,VEREL,IPAR,IPAMI,AMINV,
C  RETURN VALUES FOR NON CUT VARIABLES
     + SIGDE,ESHM,ESHSUB,EBITER,ENEW,CHI2N,ICON,SUMPI,ICOP,DPHIM
C
      DATA ICALL/0/
C
      ICALL=ICALL+1
      IF(ICALL.GE.2) GOTO 100
C
      ICUW=ICUT
      WRITE(6,99)
   99 FORMAT(/,1X,' ELECTRON SELECTION CRITERIA',/)
      CALL FJHBIT(ICUW)
C
  100 ISCAN=1000
      ICHECK=-1
      CTH=2.0
      PMOM6=-1.0
      JREM=-1
      NDEX=-1
      RELDE=1000.0
      DEDX=-1.0
      SULPI=1000.0
      SULH2=1000.0
      PCHI2=-1.0
      VEREL=-1.0
      SIGDE=1000.0
      ESHM=-1.0
      ESHSUB=-1.0
      EBITER=-1.0
      ENEW=-1.0
      ICON=-1
      SUMPI=-1.0
      ICOP=-1
      DPHIM=-1.0
      IPAR=-1
      IPAMI=-1
      AMINV=1000.0
C
      RETURN
      END
C======================================================================
C
      SUBROUTINE FJHBIT(KA)
C
C     WRITE BIT PATTERN OF KA
C
      COMMON  / CERECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT,
C  RETURN VALUES FOR CUT VARIABLES
     + ISCAN,ICHECK,CTH,PMOM6,JREM,NDEX,RELDE,DEDX,
     + SULPI,SULH2,PCHI2,ESHLO,VEREL,IPAR,IPAMI,AMINV,
C  RETURN VALUES FOR NON CUT VARIABLES
     + SIGDE,ESHM,ESHSUB,EBITER,ENEW,CHI2N,ICON,SUMPI,ICOP,DPHIM
      DIMENSION JHBIT(32)
      LOGICAL FIRST / .TRUE. /
      CHARACTER*50 CCOND(32) / 32*'0  NOT USED' /
      CHARACTER*3 CLEL(0:31)
      INTEGER ITRCNT / 0  /, ACCPTD / 0 /, NOFAIL / 0 /, ITRNOF / 0 /
      INTEGER REASON(0:31) / 32*0 /
      INTEGER FAILS(0:31) / 32*0 /, FAILSP(0:31) / 32*0 /,CHECKS(0:31) /
     *  0,  1,  3,  2,  4,  7,  5,  6, 12,  8,  9, 10, 11, 13, 14, 15,
     * 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31/
      REAL*4 REAMAT(0:31,0:31) / 1024*0./
      INTEGER ONE / 1 /
C
      DO 103 IB1=1,32
        IF( LAND(KA,SHFTL(ONE,32-IB1)) ) THEN
          JHBIT(IB1) = 1
        ELSE
          JHBIT(IB1) = 0
        ENDIF
  103 CONTINUE
C
C
      WRITE(6,1014) JHBIT,KA
 1014 FORMAT(1X,32I2,I12)
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
C
        WRITE(CCOND(32),9232) JHBIT(32),ISCUT
        WRITE(CCOND(31),9231) JHBIT(31),ICHCUT
        WRITE(CCOND(30),9230) JHBIT(30),COSCUT
        WRITE(CCOND(29),9229) JHBIT(29),PCUT
        WRITE(CCOND(28),9228) JHBIT(28)
        WRITE(CCOND(27),9227) JHBIT(27),NDCUT
        WRITE(CCOND(26),9226) JHBIT(26),RSCUT
        WRITE(CCOND(25),9225) JHBIT(25),DLOCUT,DHICUT,IDVERS
        WRITE(CCOND(24),9224) JHBIT(24),SUMCUT
        WRITE(CCOND(23),9223) JHBIT(23),ENECUT
        WRITE(CCOND(22),9222) JHBIT(22),PCHCUT
        WRITE(CCOND(21),9221) JHBIT(21),ESHCUT
        WRITE(CCOND(20),9220) JHBIT(20)
        WRITE(CCOND(19),9219) JHBIT(19),AMICUT
        WRITE(CCOND(18),9218) JHBIT(18)
        WRITE(CCOND(17),9217) JHBIT(17)
        WRITE(CCOND(16),9216) JHBIT(16)
        WRITE(CCOND(15),9215) JHBIT(15)
        WRITE(CCOND(14),9214) JHBIT(14)
        WRITE(CCOND(13),9213) JHBIT(13),EPCUT,JEVERS
        WRITE(CCOND(12),9212) JHBIT(12),EPHCUT
 9232   FORMAT(I1,2X,'ISCAN      <',I3)
 9231   FORMAT(I1,2X,'ICHECK     >=',I3)
 9230   FORMAT(I1,2X,'COSTH      <=',F6.3)
 9229   FORMAT(I1,2X,'P          > ',F6.3)
 9228   FORMAT(I1,2X,'TRACK IN ZE4V?')
 9227   FORMAT(I1,2X,'NDEDX      > ',I3)
 9226   FORMAT(I1,2X,'RELDE      < ',F6.3)
 9225   FORMAT(I1,2X,F6.3,' < DELDEDX/SIGMA < ',F6.3,' IDVERS=',I3)
 9224   FORMAT(I1,2X,'UNIQUENESS < ',F6.3)
 9223   FORMAT(I1,2X,'NEAR BY E  < ',F6.3)
 9222   FORMAT(I1,2X,'P(CHI**2)  > ',F6.3)
 9221   FORMAT(I1,2X,'LG10(ESHAD)> ',F6.3)
 9220   FORMAT(I1,2X,'PHOT PARTNER?')
 9219   FORMAT(I1,2X,'MIN(MIJ)   < ',F6.3)
 9218   FORMAT(I1,2X,'No Meier LG Energy')
 9217   FORMAT(I1,2X,'OBSOLETE')
 9216   FORMAT(I1,2X,'OBSOLETE')
 9215   FORMAT(I1,2X,'OBSOLETE')
 9214   FORMAT(I1,2X,'OBSOLETE')
 9213   FORMAT(I1,2X,'E/P        > ',F6.3,' JEVERS=',I3)
 9212   FORMAT(I1,2X,'E/P        < ',F6.3)
        WRITE(6,9401) (CCOND(I),CCOND(I-16),I=32,17,-1)
 9401   FORMAT(' CUTS USED IN EKAND (0=CUT IS DISABLED)'/1X,100('-')/
     *        (1X,2A50))
      ENDIF
      RETURN
      ENTRY EALZFA( KA )
C-----------------------------------------------------------
C  DETAIL REASON FOR FAILURE
C-----------------------------------------------------------
      IF( KA .NE. 0 ) THEN
        IFL = 0
        I = LAND(ICUT,KA)
        DO 1000 J=32,1,-1
          IF( LAND(I,SHFTL(ONE,32-J)) .NE. 0 ) THEN
            IF( IFL .EQ. 0 ) THEN
              IFL = 1
              WRITE(6,9301) CCOND(J)(4:50)
 9301         FORMAT(10X,' CANDIDATE FAILED AT CUTS: ',A46)
            ELSE
              WRITE(6,9302) CCOND(J)(4:50)
 9302         FORMAT(10X,'                           ',A46)
            ENDIF
          ENDIF
 1000   CONTINUE
      ENDIF
      RETURN
      ENTRY EAFLST( KA, / COSTH / )
C-----------------------------------------------------------
C  ACCUMULATE STATISTICS FOR FAILURES (SIMPLE VERSION)
C-----------------------------------------------------------
      CALL NOARG( NARGS )
      ITRNOF = ITRNOF + 1
      IF( KA .NE. 0 ) THEN
        DO 6010 J=0,31
          I = CHECKS(J)
          IF( LAND(KA,SHFTL(ONE,I)) .EQ. 0 ) GO TO 6010
            FAILS(I) = FAILS(I) + 1
            IF( NARGS.GT.1 .AND. COSTH.GT.0. ) FAILSP(I) = FAILSP(I) + 1
            GO TO 6020
 6010   CONTINUE
 6020   CONTINUE
      ELSE
        NOFAIL = NOFAIL + 1
      ENDIF
      RETURN
      ENTRY EAFLDP
C-----------------------------------------------------------
C  PRINT SIMPLE STATISTICS FOR FAILURES AND CANDIDATES
C-----------------------------------------------------------
      WRITE(6,9601) ITRNOF
 9601 FORMAT(//' Summary of Electron Selection after ',I7,' tracks.',
     *   36X,' Asymmetry of'/
     *   ' cut     rejected     surviving  n/(n-1)       Name',
     *   37X,' rejected tracks'/
     *   1X,103('-'))
      IF( ITRNOF .GT.0 ) THEN
        IPREV = ITRNOF
        DO 6030 J=0,31
          I = CHECKS(J)
          IF( FAILS(I) .GT. 0 ) THEN
            IPREV = IPREV - FAILS(I)
            ASYM = FLOAT(2*FAILSP(I)-FAILS(I))/FAILS(I)
            DASYM = .5*SQRT((1.+ASYM)*(1.-ASYM)/FAILS(I))
            WRITE(6,9602) I, FAILS(I), FLOAT(FAILS(I))/ITRNOF*100,
     *                    IPREV, FLOAT(IPREV)/ITRNOF*100,
     *                    FLOAT(IPREV)/MAX(IPREV+FAILS(I),1)*100,
     *                    CCOND(32-I)(4:50), ASYM, DASYM
 9602       FORMAT(I3,I8,'=',F5.1,'%',I7,'=',F5.1,'%  ',F5.1,'% ',A46,
     *             3X,F6.3,'+-',F5.3)
          ENDIF
 6030   CONTINUE
        WRITE(6,9607) NOFAIL, FLOAT(NOFAIL)/ITRNOF*100
 9607   FORMAT(/3X,I8,'=',F6.2,'% Accepted')
      ENDIF
      RETURN
      ENTRY EALZST( KA )
C-----------------------------------------------------------
C  ACCUMULATE STATISTICS FOR FAILURES
C-----------------------------------------------------------
      ITRCNT = ITRCNT + 1
      IF( KA .NE. 0 ) THEN
        IREAS = 0
        DO 7010 I=0,31
          IF( LAND(KA,SHFTL(ONE,I)) .NE. 0 ) THEN
            REASON(I) = REASON(I) + 1
            IREAS = IREAS + 1
          ENDIF
 7010   CONTINUE
C       WEIGHT = 1./FLOAT(IREAS)
        WEIGHT = 1.
        DO 7030 I=0,31
          IF( LAND(KA,SHFTL(ONE,I)) .NE. 0 ) THEN
            IF( IREAS .EQ. 1 ) THEN
              REAMAT(I,I) = REAMAT(I,I) + WEIGHT
            ELSE
              DO 7020 J=I+1,31
                IF( LAND(KA,SHFTL(ONE,J)) .NE. 0 ) THEN
                  REAMAT(I,J) = REAMAT(I,J) + WEIGHT
                ENDIF
 7020         CONTINUE
            ENDIF
          ENDIF
 7030   CONTINUE
      ELSE
        ACCPTD = ACCPTD + 1
      ENDIF
      RETURN
      ENTRY EALZFL
C-----------------------------------------------------------
C  PRINT STATISTICS FOR FAILURES AND CANDIDATES
C-----------------------------------------------------------
      WRITE(6,9501) ITRCNT
 9501 FORMAT(//40X,'SUMMARY OF '/
     *   20X,' FAILURE REASONS FOR E CANDIDATES AFTER',I7,' TRACKS'/
     *   1X,72('-'))
      IF( ITRCNT .GT.0 ) THEN
        DO 8010 I=0,31
          IF( REASON(I) .GT. 0 ) THEN
            WRITE(6,9502) I, REASON(I), FLOAT(REASON(I))/ITRCNT*100,
     *                    CCOND(32-I)(4:50)
 9502       FORMAT(1X,I3,I7,' = ',F5.1,'% AT CUT ',A46)
          ENDIF
 8010   CONTINUE
        WRITE(6,9507) ACCPTD, FLOAT(ACCPTD)/ITRCNT*100
 9507   FORMAT(/4X,I7,' = ',F5.1,'% ACCEPTED')
        WRITE(6,9503) (I,I=0,31)
 9503   FORMAT(/' REASON MATRIX '/3X,32I3)
C       WRITE(6,9504) (J,(INT(REAMAT(I,J)/ITRCNT*100.),I=0,31),J=0,31)
C9504   FORMAT(1X,I2,32I3)
C                                           SYMMETRIZE
C       DO 8012 J=1,31
C         DO 8011 I=0,J-1
C           REAMAT(J,I) = REAMAT(I,J)
C8011     CONTINUE
C8012   CONTINUE
        DO 8030 J=0,31
          DO 8020 I=0,31
            L = INT(REAMAT(I,J)/ITRCNT*100.+.5)
            IF( L .EQ. 0 ) THEN
              IF( I.NE. J ) THEN
                CLEL(I) = '  .'
              ELSE
                CLEL(I) = '   '
              ENDIF
            ELSE
              WRITE(CLEL(I),9505) L
 9505         FORMAT(I3)
            ENDIF
 8020     CONTINUE
          WRITE(6,9506) J, CLEL, CCOND(32-J)(4:33)
 9506     FORMAT(1X,I2,32A3,1X,A30)
 8030   CONTINUE
      ENDIF
      END

C   12/03/84 504221644  MEMBER NAME  TAGMRK   (S)           FORTRAN
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE TAGMRK(*)
C
C
C  AUTHOR   :  A. J. FINCH
C
C       MOD :  J. M. NYE  - DOESNT RETURN 1 IF ATAG BANK NOT THERE
C                           - ALSO USES SMEARING DATE FOR MC DATA IF
C                             NO ATAG BANK.                 24/05/84
C
C  LAST MOD :  18/06/84  J. NYE  - SETS IFLMRK = -1 WHEN CALLED
C
C
C
C THIS ROUTINE SETS THE VALUE OF 'MARK' IN CWORK TO INDICATE WHICH
C TAGGER THIS IS - VALUE OF MARK          TAGGER
C                  =============          ======
C                       1                 1981/2
C                       2                 1983...
C
C IT DOES A RETURN 1 IF 'HEAD'  BANK DOESNT EXIST
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       IMPLICIT INTEGER*2 (H)
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
       LOGICAL FIRST / .TRUE. /
C
C
C-------------------------- C O D E ------------------------------------
C
C
C
C---                                     GET HEAD AND ATAG POINTERS
C
C
       INHEAD = IDATA( IBLN('HEAD') )
       INATAG = IDATA( IBLN('ATAG') )
       IF ( INHEAD .LE. 0 ) GOTO   1
C
C---                                     GET HEAD BANK DATA
C
       IHHEAD = INHEAD + INHEAD
       NRUNTG = HDATA(IHHEAD + 10)
       NDATE  = HDATA(IHHEAD +  8)
C
       IMC = 0
       IF ( NRUNTG .GT. 0 ) GOTO 200
C
C
C--------------------------------------- MONTE CARLO DATA ONLY ---------
C
C---                                     NRUNTG = 0 => MONTE CARLO DATA
C---                                     SET FLAG FOR TAGKAL ETC.
C
       IF ( NRUNTG .EQ. 0 ) IMC = 1
C
C---                                     IF ATAG BANK EXISTS THEN USE
C---                                     WORD SET BY MC SIMULATION
C
C
       IF ( INATAG .LE. 0 ) GOTO   2
       MCMARK = HDATA( 2 * INATAG + 2 )
       IF ( MCMARK .EQ. 0 ) NRUNTG =  5000
       IF ( MCMARK .EQ. 1 ) NRUNTG = 10000
       IF ( MCMARK .EQ. 2 ) NRUNTG = 15000
       GOTO 200
C
C---                                     ELSE USE SMEARING DATE
C
    2  CONTINUE
       NRUNTG = 10000
       IF ( NDATE .LE. 1980 ) NRUNTG =  5000
       IF ( NDATE .GE. 1983 ) NRUNTG = 15000
C
C
C--------------------------------------- FOR BOTH REAL AND MC DATA -----
C
C
  200  CONTINUE
C
C
C---                                     SET VALUE OF 'MARK'
C
       IF   (NRUNTG.LT. 6000)                           MARK = 0
       IF ( (NRUNTG.GE. 6000) .AND. (NRUNTG.LT.12948) ) MARK = 1
       IF   (NRUNTG.GE.12948)                           MARK = 2
C
C
C---                                     SET IFLMRK = -1 TO FLAG THAT
C---                                     TAGMRK HAS BEEN CALLED
C
       IFLMRK = -1
       FIRST  = .FALSE.
       RETURN
C
C---------------------------------------- R E T U R N   1 --------------
C
C                                        RETURN 1 IF NO HEAD BANK
C
    1  RETURN 1
       END

C   27/03/97 703271243  MEMBER NAME  JEOSUM2  (JMC.S)       FVS
C   27/03/97 703271242  MEMBER NAME  CCOMP    (JMC.S)       FVS
      COMMON/CCOMP/NCOMP(80)
C   23/08/85 511061940  MEMBER NAME  CMCTAG   (S)           FORTRAN
C
C   COMMON FOR NEW FORWARD TAGGER MC
C
      COMMON/CMCTAG/MARKMC,HGG(192),IHIT,INMARK,NCHANS,SIGMAS,CALIBS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   27/03/97 703271242  MEMBER NAME  CMUBCS   (JMC.S)       FVS
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C   27/08/83 310201406  MEMBER NAME  CPROD    (S)           FORTRAN
C ------------------ MACRO CPROD -----------------
C                                       4-VECTOR FORMAT FOR JADE
C
      COMMON/CPROD/ NEV,BEAM,PT,PHI,THETA,IFLAVR,
     *        NP,NC,NN,PP(4,500),XM(500),JCH(500),JTP(500),JP(500,2),
     *        NF,NCF,NNF,PF(4,300),XMF(300),ICF(300),ITF(300),
     *        PSTRT(3,300)
C
C ---------------END MACRO CPROD -----------------
C   18/05/79            MEMBER NAME  CUNIT    (S)           FORTRAN
C---------------START OF MACRO CUNIT (LOGICAL UNIT NUMBERS)-------------
C
      COMMON /CUNIT/LUNMUC,LUNMUE
C
C LUNMUC  LOGICAL UNIT FOR MU CALIBRATION DATA.
C LUNMUE  LOGICAL UNIT FOR MU CALIBRATION DATA EDIT FILE.
C
C---------------END OF MACRO CUNIT--------------------------------------
C   27/03/97 703271242  MEMBER NAME  CMUBCS   (JMC.S)       FVS

C   07/06/96 606071908  MEMBER NAME  SMHIST   (S4)          FORTG1
      SUBROUTINE SMHIST(YI,Y,DY,N,IDY)
      REAL YI(1),Y(1),DY(1)
      REAL A(64,5),YL(128),YS(128),X(128),C(129),W(128)
C
C     ------------------------------------------------------------------
C
C
C     PURPOSE - SMOOTH HISTOGRAM DATA
C
C     USAGE                 --   -- - ---
C               CALL SMHIST(YI,Y,DY,N,IDY)
C                              -
C               YI( ) = INPUT HISTOGRAM OF N BINS
C               Y ( ) = SMOOTHED HISTOGRAM
C               DY( ) = ERRORS OF INPUT HISTOGRAM DATA (FOR IDY=1 ONLY)
C               IDY   = 0   HISTOGRAM WITH ERROR OF BIN CONTENT EQUAL
C                           TO SQRT(CONTENT), POISSON DISTR., OR
C                     = 1   WEIGTHED HISTOGRAM WITH ERRORS GIVEN.
C
C               YI( ) AND Y( ) MAY BE THE SAME ARRAY. THERE IS NO
C               LIMITATION ON THE NUMBER OF BINS.
C
C     METHOD  - IT IS ASSUMED, THAT THE HISTOGRAM DATA CORRESPOND TO
C               BINS OF EQUAL SIZE. THE METHOD CONSISTS OF SEVERAL
C     PARTS. PEAKS AND VALLEYS OF ONLY ONE BIN WILL COMPLETELY VANISH,
C     THUS THE BIN SIZE SHOULD BE CHOOSEN SMALL ENOUGH, THAT EXPECTED
C     PEAKS WILL BE AT LEAST 3 BINS WIDE.
C
C     1. PART      IF THREE ADJACENT BINS CONTAIN LESS THAN 8 (EQUIV.)
C                  ENTRIES, THEY WILL BE AVERAGED.
C     2. PART *    TRANSFORMATION OF THE POISSON DISTRIBUTED DATA TO
C                  DATA OF VARIANCE 1.0
C     3. PART      353C ALGORITHM TO REDUCE LOCAL CHI SQUARE
C                  (SEE SUBROUTINE SMOPER)
C     4. PART      SPLINE FIT (SEE BELOW)
C     5. PART *    BACK TRANSFORMATION
C
C     *  FOR IDY = 0 ONLY.
C
C     SPLINE FIT - THE SUBROUTINE SPLESQ IS USED TO PERFORM A SPLINE
C     FIT, WHICH CONSISTS IN A LEAST SQUARE OF A CERTAIN NUMBER OF
C     REFERENCE POINTS, CONNECTED BY A SPLINE FUNCTION. THE BAND MATRIX
C     OCCURING IN THE FIT IS SOLVED BY A FAST RTR DECOMPOSITION METHOD
C     IN SUBROUTINE BANDSL. THE SPLINE FIT IS PERFORMED ITERATIVELY,
C     REFINING THE SETTING OF REFERENCE POINTS ACCORDING TO THE LOCAL
C     CHI SQUARE. IN THE FIRST ITERATION, THE REFERENCE POINTS ARE
C     CHOOSEN EQUIDISTANT WITH ABOUT 8 BINS BETWEEN 2 REFERENCE POINTS.
C     IN THE FOLLOWING ITERATIONS, USING THE LOCAL CHI SQUARE, THE
C     DISTANCE BETWEEN 2 REFERENCE POINTS IS REDUCED.
C
C     THE RESULTING SMOOTHED HISTOGRAM CONTENT WILL BE SMOOTH WITH
C     LITTLE SHORT LENGTH OSCILLATIONS, WHILE SIGNIFICANT STRUCTURES
C     WILL BE PRESENT.
C
C     SUBROUTINES CALLED - SMOPER
C                          SPLESQ (CALLS BANDSL)
C
C
C     ------------------------------------------------------------------
C
C
C     TRANSFER TO Y( ) AND GET FIRST AND LAST BIN WITH NONZERO CONTENT
C
      IA=0
      IB=0
      WL=0.0
      IL=0
      DO 2 I=1,N
      Y(I)=YI(I)
      IF(IDY.EQ.0.AND.Y(I).EQ.0.0) GOTO 2
      IF(IDY.NE.0.AND.DY(I).EQ.0.0) GOTO 2
      IF(IDY.NE.0.AND.IA.EQ.0) WL=DY(I)
      IF(IA.EQ.0) IA=I
      IB=I
      IF(IDY.EQ.0.OR.I.EQ.1.OR.I.EQ.N) GOTO 2
      IF(DY(I-1).NE.0.0.OR.DY(I+1).NE.0.0) GOTO 2
      WL=WL+DY(I)**2
      IL=IL+1
    2 CONTINUE
      IF(IDY.NE.0.AND.IL.NE.0.AND.WL.EQ.0.0) GOTO 100
      IF(IDY.NE.0) WL=FLOAT(IL)/WL


      NC=IB-IA+1
      IF(NC.LE.3) GOTO 100
C
C     FOLD BINS OF VERY LOW STATISTIC
C
      NM=IB-2
      ZL=Y(IA)
      DO 6 I=IA,NM
      ZN=Y(I+1)
      SUM=Y(I)+Y(I+1)+Y(I+2)
      IF(IDY.EQ.0) GOTO 3
      SUM2=DY(I)**2+DY(I+1)**2+DY(I+2)**2
      IF(SUM2.EQ.0.0) GOTO 4
      IF(SUM**2/SUM2.GT.8.0) GOTO 4
      ZN=0.25*(ZN+Y(I+1))
      GOTO 4
    3 IF(SUM.GT.8.0) GOTO 4
      ZN=ZN+(SUM-3.0*ZN)/(SUM+3.0)
    4 Y(I)=ZL
    6 ZL=ZN
      Y(IB-1)=ZL
C
C     TRANSFORM POISSON DISTRIBUTED DATA TO DATA OF VARIANCES 1.0
C
      IF(IDY.NE.0) GOTO 12
      DO 10 I=IA,IB
      IF(Y(I).GT.0.0) GOTO 8
      Y(I)=1.0
      GOTO 10
    8 Y(I)=SQRT(Y(I))+SQRT(Y(I)+1.0)
   10 CONTINUE
C
C     APPLY SIMPLE 353 ALGORITHM TO REDUCE CHI SQUARES
C
   12 CALL SMOPER(Y(IA),NC,321)
C
C     SMOOTH BY REPEATED SPLINE FITS
C
      IF(IDY.EQ.0) IEQ=-1
      IF(IDY.NE.0) IEQ=+1
      KL=(NC+101)/112
      IF(KL.LE.0) KL=1
      LK=(NC+12*KL-11)/KL
      JA=IA
      DO 80 LL=1,KL
      JB=MIN0(IB,JA+LK-1)
      I=0
      DO 20 J=JA,JB
      I=I+1
      IF(LL.EQ.1) YL(I)=Y(J)
      YS(I)=YL(I)
      IF(IDY.EQ.0) GOTO 20
      W(I)=WL
      IF(DY(J).NE.0.0) W(I)=1.0/DY(J)**2
   20 X(I)=0.25
      X(1)=0.0
      M=I
      NSP=3+MAX0(M/8,1)
      CALL SPLESQ(YS,X,W,M,A,NSP,IEQ,CHDF)
      CLIM=1.0
C     DO 70 K=1,2
      DO 70 K=1,4
      NBEL=0
      NVLG=0
      C(1)=0.0
      DO 30 I=1,M
      IF(IDY.EQ.0) C(I+1)=C(I)+(YS(I)-YL(I))**2
      IF(IDY.NE.0) C(I+1)=C(I)+W(I)*(YS(I)-YL(I))**2
      IF(C(I+1)-C(I).LT.CLIM) NBEL=NBEL+1
   30 YS(I)=YL(I)
      DC=C(M+1)/FLOAT(M-NSP)
      WRITE(6,101) K,DC,DVMAX,M,NSP,IDY,NBEL
  101 FORMAT(1X,I2,2G15.5,4I15)
      DV=C(4)/3.0
      CFAC=1.0
      IF(NBEL+NBEL.GT.M) CFAC=1.1665
      FAC=CFAC
C     IF(DV+DV.GT.CLIM) FAC=1.4142
C     IF(DV+DV.GT.CLIM) FAC=1.2599
C     IF(   DV.GT.CLIM) FAC=2.0000
C     IF(   DV.GT.CLIM) FAC=1.5874
      IF(DV.LT.0.2*DC) FAC=FAC/1.1665
      IF(DV.GT.2.0*DC) FAC=FAC*1.1665
      IF(DV.GT.3.0*DC) FAC=FAC*1.1665
      IF(DV.GT.3.0*DC) NVLG=NVLG+1
      X(2)=FAC*X(2)
      X(3)=FAC*X(3)
      DV=(C(M+1)-C(M-1))/3.0
      FAC=CFAC
      IF(DV.LT.0.2*DC) FAC=FAC/1.1665
C     IF(DV+DV.GT.CLIM) FAC=1.4142
C     IF(DV+DV.GT.CLIM) FAC=1.2599
C     IF(   DV.GT.CLIM) FAC=2.0000
C     IF(   DV.GT.CLIM) FAC=1.5874
      IF(DV.GT.2.0*DC) FAC=FAC*1.1665
      IF(DV.GT.3.0*DC) FAC=FAC*1.1665
      IF(DV.GT.3.0*DC) NVLG=NVLG+1
      X(M)=FAC*X(M)
      X(M-1)=FAC*X(M-1)
      N3=M-3
      IF(N3.LT.4) GOTO 45
      DVMAX=0.0
      DO 40 I=4,N3
      DV=0.125*(C(I+3)+C(I+1)-C(I-1)-C(I-3))
      DVMAX=AMAX1(DV,DVMAX)
      X(I)=X(I)*CFAC
C     IF(DV+DV.GT.CLIM) X(I)=X(I)*1.4142
C     IF(DV+DV.GT.CLIM) X(I)=X(I)*1.2599
C     IF(   DV.GT.CLIM) X(I)=X(I)*1.4142
C     IF(   DV.GT.CLIM) X(I)=X(I)*1.2599
      IF(DV.LT.0.2*DC) X(I)=X(I)/1.1665
      IF(DV.GT.2.0*DC) X(I)=X(I)*1.1665
      IF(DV.GT.3.0*DC) X(I)=X(I)*1.1665
      IF(DV.GT.3.0*DC) NVLG=NVLG+1
   40 CONTINUE
   45 CALL SMOPER(X(2),M-1,5321)
      DO 50 I=2,M
   50 X(I)=X(I-1)+X(I)
      NSP=3+X(M)*0.5
      NSP=MIN0(NSP,64)
      CALL SPLESQ(YS,X,W,M,A,NSP,2*IEQ,CHDF)
      IF(CFAC.EQ.1.0.AND.NVLG.EQ.0) GOTO 71
      XL=X(1)
      DO 60 I=2,M
      XN=X(I)
      X(I)=XN-XL
   60 XL=XN
C     CLIM=0.25*CLIM
C     CLIM=0.50*CLIM
   70 CONTINUE
   71 IF(LL.EQ.KL) GOTO 74
      KA=JB-10
      KB=MIN0(IB,KA+LK-1)
      I=0
      DO 72 K=KA,KB
      I=I+1
   72 YL(I)=Y(K)
   74 I=0
      DO 78 J=JA,JB
      I=I+1
      IF(I.GT.11.OR.JA.EQ.IA) GOTO 76
      Y(J)=0.1*(FLOAT(I-1)*YS(I)+FLOAT(11-I)*Y(J))
      GOTO 78
   76 Y(J)=YS(I)
   78 CONTINUE
   80 JA=JB-10
C
C     TRANSFORM BACK TO POISSON DISTRIBUTED DATA
C
      IF(IDY.NE.0) GOTO 100
      DO 90 I=1,N
      IF(Y(I).GT.1.0) GOTO 85
      Y(I)=0.0
      GOTO 90
   85 SY=(0.5*(Y(I)-1.0/Y(I)))**2
      NY=100.0*SY+0.5
      Y(I)=0.01*FLOAT(NY)
   90 CONTINUE
C
C
  100 RETURN
      END

C   28/11/85 610021350  MEMBER NAME  DRPIPE   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      FUNCTION DRPIPE(DUMMY)
C-----------------------------------------------------------------------
C
C
C     RETURNS THE BEAMPIPE THICKNESS(MM), BASED ON DATE IN HEAD BANK
C     MC-DATA: NEW GEOMETRY IS FORCED IF FLAG LVTXC IS TRUE
C     ARGUMENT DUMMY IS IGNORED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL NEWDET,LVTXC,LNHARD
C
C
C                        --- MACRO CADMIN ---
C
      LOGICAL*1 LBREAD
C
      COMMON / CADMIN / IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG,IERCAL,
     +                  ISMEAR,IJETCI,NFLAGS(10)
C
C                                 NFLAGS IS AN ARRAY OF GENERAL FLAGS
C                                   (1) : USED BY RDDATE
C                                   (2) : USED BY RDTRIG
C                                   (3) : USED BY RDTRIG
C                                   (4) : USED BY RDTRIG / PRSTAT
C                                   (5) : USED BY EVREAD -COUNTS RECORDS
C                                   (6) : USED BY SUPERV -COUNTS ERRORS
C                                   (7) : USED BY EVWRIT -'HEAD'LESS EVS
C                                   (8) : USED BY EVREAD/RDMTCO (EVWRIT)
C                                   (9) : USED BY RDMTCO/EVWRIT
C                                  (10) : FREE
C
C                                  BLOCK DATA SET IN MEMBER JADEBD
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEOV      VERTEX CHAMBER GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEOV  / RPIPV,DRPIPV,XRLPIV,RVXC,DRVXC,XRLVXC,
     +                  ZVXCM,DZVCM,XRZVCM, ZVXCP,DZVCP,XRZVCP,
     +                  XRVTXC
C
C--------------------------- END OF MACRO CGEOV ------------------------
C
C
      COMMON / CVCEX  / LVTXC
C
C------------------  C O D E  ------------------------------------------
C
      IH2    = 2*IDATA( IBLN( 'HEAD' ) )
C
      IMONTH = HDATA(IH2+7)
      IYEAR  = HDATA(IH2+8)
C
C                            OLD GEOMETRY (PRIOR TO MAY 1984)
C
      DRPIPE = DRPIP
C                            NEW DETECTOR HARDWARE IN MONTE-CARLO DATA?
C                            THEN LVTXC IS TRUE (FLAG IS CHECKED AND
C                                                SET IN RDMTCO)
C
      LNHARD = (IMONTH .GE. 5  .AND.  IYEAR .EQ. 1984)
     +                          .OR.  IYEAR .GE. 1985
      NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
C
      IF( .NOT. NEWDET ) RETURN
C
C                            NEW GEOMETRY
C
      DRPIPE = DRPIPV
C
      RETURN
      END

C   07/06/96 606071841  MEMBER NAME  DAFR     (S4)          FORTRAN
      SUBROUTINE DAFR(IGOTO)
C
C     VERSION JULY 82
C
      COMMON/ACS/DUMMI(90),NUNTB
C
C     ACCESS TO DATA RECORD OF DIRECT ACCESS DATA SET
C
C     IGOTO = 1   GET BANK FROM DIRECT ACC. DS
C             2   DELETE BANK FROM DIRECT ACC. DS
C             3   ADD BANK TO DIRECT ACC. DS
C             4   ADD BANK IN PREVIOUS PLACE (SAME LENGTH AS BEFORE)
C
C
C     INTERMEDIATE VARIABLES INDB = INDEX TO DATA IN BANK
C                            NWLB = NR OF DATA WORDS LEFT
C                            NPTR = NR OF DATA RECORD
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      INDB=INDC
      IF(IGOTO.EQ.3) GOTO 50
C
C     ADD, DELETE OR REPLACE
C
      NPTR=LISTE(3)
      NWLB=LISTE(4)
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 101
C
C     READ DATA RECORD AND SEARCH FOR NAME,NR
C
   10 CALL RDDA(NPTR,NDAREC,IW(IA))
      INDH=IA+4
      INDL=IA+IW(IA)
      GOTO 14
   12 IF(NPTR.NE.LISTE(3).AND.IGOTO.EQ.2)       GOTO 100
      IF(NPTR.NE.LISTE(3))       GOTO 102
      INDH=INDH+IW(INDH)+4
   14 IF(INDH.GT.INDL.AND.IGOTO.EQ.2)           GOTO 100
      IF(INDH.GT.INDL)           GOTO 102
      IF(IW(INDH-3).NE.LISTE(1)) GOTO 12
      IF(IW(INDH-2).NE.LISTE(2)) GOTO 12
      IF(IGOTO-2) 20,30,40
C
C     COPY BANK FROM DATA RECORD OF DIRECT ACCESS DATA SET
C
   20 CALL UCOPY(IW(INDH+1),IW(INDB+1),IW(INDH))
      INDB=INDB+IW(INDH)
      NWLB=NWLB-IW(INDH)
      IF(NWLB.LE.0) GOTO 100
      NPTR=NPTR+1
      GOTO 10
C
C     DELETE BANK FROM DATA RECORD OF DIRECT ACCESS DATA SET
C
   30 INDS=INDH+IW(INDH)
      NWDS=INDL-INDS
      NWLB=NWLB-IW(INDH)
      IW(IA)=IW(IA)-4-IW(INDH)
      IF(NWDS.GT.0) CALL UCOPY2(IW(INDS+1),IW(INDH-3),NWDS)
C
C     WRITE CHANGED DATA RECORD BACK TO DS
C
   35 CALL WRDA(NPTR,IW(IA),IW(IA+1))
      IF(NWLB.LE.0) GOTO 100
      NPTR=NPTR+1
      GOTO 10
C
C     ADD BANK IN DATA RECORD (SAME PLACE AS BEFORE)
C
   40 CALL UCOPY(IW(INDB+1),IW(INDH+1),IW(INDH))
      INDB=INDB+IW(INDH)
      NWLB=NWLB-IW(INDH)
      GOTO 35
C
C     ADD BANK TO DATA RECORD IN DIRECT ACCESS DATA SET
C
   50 NWLB=IW(INDB)
      NPTR=IW(INDA+7)
      LISTE(3)=0
      LISTE(4)=NWLB
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 101
      CALL RDDA(NPTR,NDAREC,IW(IA))
C
C
C
   55 NTOT=IW(IA)
      IF(NTOT.GT.NDAREC-5) GOTO 60
      CALL UCOPY(IW(INDC-3),IW(IA+NTOT+1),4)
      NTOT=NTOT+4
      IW(IA)=NTOT
      NWCP=MIN0(NDAREC-1-NTOT,NWLB)
      IW(IA+NTOT)=NWCP
      CALL UCOPY(IW(INDB+1),IW(IA+NTOT+1),NWCP)
      IF(LISTE(3).EQ.0) LISTE(3)=NPTR
      NTOT=NTOT+NWCP
      IW(IA)=NTOT
      INDB=INDB+NWCP
      NWLB=NWLB-NWCP
      CALL WRDA(NPTR,IW(IA),IW(IA+1))
      IF(NWLB.EQ.0) GOTO 100
C
C     INCREASE RECORD NUMBER AND PREPARE NEW RECORD
C
   60 IW(INDA+7)=IW(INDA+7)+1
      IW(IA)=0
      NPTR=IW(INDA+7)
      GOTO 55
C
C
C
  100 RETURN
C
C     INSUFFICIENT SPACE FOR DIRAC OPERATION
C
  101 CALL BDMPA(101)
C
C     DIRECTORY/DATA RECORD ERROR
C
  102 IF(IGOTO.EQ.2) GOTO 100
      IF(IGOTO.NE.1) GOTO 1002
C
C     DELETE BANK
C
      INDC=IBANK(LISTE(1),LISTE(2),'DL')
      GOTO 100
 1002 CALL BDMPA(102)
      GOTO 100
      END

C   23/08/85 903061127  MEMBER NAME  MCTAGM   (S)           FORTRAN
C   23/08/85 508231713  MEMBER NAME  ALLFOR   (S)           FORTRAN
C   23/08/85 508231710  MEMBER NAME  MCTAG    (S)           FORTRAN

C   13/03/84 403232324  MEMBER NAME  MCTAGM   (S)           FORTRAN
C
C THIS ROUTINE IS AN ATTEMPT TO PRODUCE A STANDARD TRACKING
C ROUTINE FOR JADE TAGGERS
C
C EXPLANATION OF SOME TERMS USED:
C
C  MARKMC      DATE      INMARK                         MARK AS USED IN
C
C   1      1979/1980       0                                     1
C   2      EARLY 1981      1     ( NO LEAD SNOUTS )              2
C   3      1981/1982       1     ( WITH LEAD SNOUTS )            2
C   4      1983-1986       2                                     3
C
C INMARK IS WRITTEN IN TO THE ATAG BANKS PRODUCED TO ENABLE TAGAN TO
C             KNOW WHICH SIMULATION HAS BEEN PERFORMED.

C
C
C INPUT - PARTICLE INFO IN PV AND R0 ARRAYS
C
C   PV( 1 ) =   X COMPONENT OF PARTICLES MOMENTUM
C   PV( 2 ) =   Y COMPONENT OF PARTICLES MOMENTUM
C   PV( 3 ) =   Z COMPONENT OF PARTICLES MOMENTUM
C   PV( 4 ) =   ENERGY
C   PV( 5 ) =   MASS
C   PV( 6 ) =   MAGNITUDE OF MOMENTUM
C   PV( 7 ) =   CHARGE
C   PV( 8 ) =   TYPE CODE
C   PV( 9 ) =
C   PV( 10) =
C
C A.J.FINCH 13/3/84
C PROPER RADIATION LENGTH FOR LEAD-SCINT. SANDWICH,  2/3-89   J.O.
C UPDATE PV-VECTOR FOR THOSE PARTICLES THAT HIT TAGGER  6/3-89   J.O.
C
      SUBROUTINE MCTAGM(PV,R0)
C
C
      IMPLICIT INTEGER*2 (H)
C
C   23/08/85 511061940  MEMBER NAME  CMCTAG   (S)           FORTRAN
C
C   COMMON FOR NEW FORWARD TAGGER MC
C
      COMMON/CMCTAG/MARKMC,HGG(192),IHIT,INMARK,NCHANS,SIGMAS,CALIBS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
      DIMENSION PV(10),R0(3)
      REAL*4 THMINM(10),THMINP(10),THMAX(10),LENGTH(10)
      REAL*4 ZMIN(10)
      REAL*4 RADLEN(10),AGG(200),SCALE(10)
C
C HERE ARE SET ALL THE IMPORTANT PARAMETERS
C
C 1) THMIN,THMAX - ACCEPTANCE LIMITS DETERMINED BY BEAM PIPE
C                  AND LEAD ETC.
C
C    THMINM - -Z
C    THMINP - +Z
C
      DATA THMINM/0.0335,0.0361,0.0410,7*0.0320/
      DATA THMINP/0.0335,0.0361,0.041,7*0.0320/
      DATA THMAX/0.1052,0.082,0.082,0.075,6*0.082/
C     DATA THSM/0.002/
C
C 2) RADLEN - RADIATION LENGTH OF MATERIAL OF DETECTOR
C    3 FIRST VALUES ARE FOR SF5 LEADGLASS
C    LATTER VALUES CALCULATED FROM SANDWICH 2MM PB, 10 MM SCINTILLATOR
C
      DATA RADLEN/3*22.39,7*25.3/
C
C 3) ZMIN - DISTANCE FROM INTERACTION POINT TO FACE OF BLOCKS
C
      DATA ZMIN/4850.0,9*2950.0/
C
C 4) LENGTH - LENGTH OF BLOCKS IN MM
C
      DATA LENGTH/3*450.0,7*500.0/
C
C 5) ECRIT - CRITICAL ENERGY OF LEAD
C
      DATA ECRIT/6.90/
C
C 6) SCALE - CORRECT FOR    CALIBRATION
C
      DATA SCALE /10*1.05/
C
      REAL LOGTWO/0.69314718/
      DATA TLIM/5.0/
      DATA IWRITE/0/
      DATA IWLIM/10/
C
C
C ======== CODE ======
C     EXTRACT RELEVANT INFO FROM INPUT ARRAYS
C
      IT = PV(8)+0.5
C
C---  THROW OUT PARTICLES WITHOUT TYPE-CODE
C
      IF (IT.LE.0) RETURN
C
C FIND X,Y,Z DIRECTION COSINES
C
      DX = (PV(1))/PV(6)
      DY = (PV(2))/PV(6)
      DZ = (PV(3))/PV(6)
C
C FIND Z SIGN ( +/- 1 )
      ISIGNZ=1
      IF(PV(3).LT.0)ISIGNZ=-1
C
C AND ENERGY OF PARTICLE
C
      ENHIT = PV(4)
C
C---  CHECK WHETHER PARTICLE TRACK LIES INSIDE THETA-ACCEPTANCE
C       28 MR < THETA < 105.2 MR  OR  3.0364 MR < THETA < 3.1136 MR
C
      THETA = ARCOS(ABS(DZ))
      THMIN=THMINM(MARKMC)
      IF(ISIGNZ.EQ.1)THMIN=THMINP(MARKMC)
C
C
      IF (THETA.LT.THMIN.OR. THETA.GT.THMAX(MARKMC)) GOTO 1000
C
C BRANCH HERE ON WHETHER SHOWERING OR NON SHOWERING PARTICLE
C
      IF (IT.GT.2) GOTO 1000
C
C THESE ARE SHOWERING PARTICLES
C
      IHIT = IHIT + 1
C
C---  PHOTONS AND ELECTRONS
C
C QUESTION ? - WHERE IS THE SHOWER MAXIMUM (LONGITUDINAL)
C            - AND IS IT CONTAINED IN THE DETECTOR ?
C
C FOR AN ANSWER USE THE SIMPLE MODEL DESRIBED IN PERKINS
C FOR LONGITUDINAL DEVELOPMENT OF SHOWERS
C
C
C DMAX IS THE DISTANCE IN MM TO SHOWER MAXIMUM
C    RADLEN CONVERTS FROM RADIATION LENGTHS TO  MM
C    ECRIT = 6.9 MEV FOR LEAD
C
      ARG = (ENHIT*1000.0)/ECRIT
      IF(ARG.GT.0)GOTO 123
           ARG = 1
           IWRITE = IWRITE + 1
           IF(IWRITE.LT.IWLIM)WRITE(6,6001)ARG,ENHIT,ECRIT
6001       FORMAT(' ERROR IN MCTAGM ARG=ENHIT/ECRIT ',3(2X,F8.3))
C
123   A=LOG(ARG)
C
      DMAX = (A/LOGTWO)*RADLEN(MARKMC)
C
C ZT - Z AT WHICH SHOWER IS MAXIMUM
C AZT - ABSOLUTE VALUE OF ZT
C
      AZT = ZMIN(MARKMC) + (DMAX*ABS(DZ))
      ZT=ISIGNZ*AZT
C
C     CHECK FOR SHOWER CONTAINMENT LONGITUDINAL- HOW CLOSE IS MAX
C     TO BACK OF DETECTOR IN RADIATION LENGTHS ?
C
      ESHOW = ENHIT*SCALE(MARKMC)
      TBACK = (ZMIN(MARKMC)+LENGTH(MARKMC)-AZT)/RADLEN(MARKMC)
      IF(TBACK.GE.TLIM)GOTO 300
C
C SIMPLE MINDED TREATMENT OF SHOWERS LEAVING BACK OFDETECTOR
C
       ESHOW=(ENHIT/TLIM)*TBACK
C
C NOW SIMULATE TRANSVERSE SPREAD OF SHOWER
C
C  FIRST FIND X,Y AT WHICH SHOWER IS MAXIMUM
C
 300      CALL MCTAGC(DX,DY,DZ,XSH,YSH,ZT)
C      WRITE(6,679)XSH,YSH,ESHOW
 679   FORMAT(' HIT AT ',F8.2,F8.2,' ENERGY ',F8.2)
C
C
       CALL VZERO(AGG,200)
C
       CALL MCTAGE(MARKMC,XSH,YSH,ZT,AGG,ESHOW)
C
       DO 200 K = 1,192
 200   IF(AGG(K).GT.0)HGG(K) = HGG(K) + AGG(K)
C
C
C
C
C----- END OF TREATMENT OF SHOWERING PARTICLES
2000   PV(1) = 0.
       PV(2) = 0.
       PV(3) = 0.
       PV(4) = 0.
C
C HERE FOR NON SHOWERING PARTICLES
C
1000  RETURN
      END

C   24/06/82 302201628  MEMBER NAME  PLSMP    (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE PLSMP
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IMPLICIT INTEGER*2 (H)
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
C
      DATA IBUG/ 0/,IENTRY/0/
C
      IF(IENTRY.NE.0)  GOTO  19
      IENTRY = 1
      CALL HBOOK2(170,15H TSMP  ITOF   $,100,-5.,15.,42,0.,42.)
      CALL HBPRO(170)
C
   19 CONTINUE
C
      IBUG = IBUG + 1
      IF(IBUG.LE.10) PRINT 100 ,NRUN,IEV,NEV
  100 FORMAT(' TOFSMP RESULTS',3I10)
      DO   1   I=1,42
      IF(HTOF(I).LE.0)  GOTO  1
      CALL HFILL(170,TTOF(I),FLOAT(I))
      IF(IBUG.LE.10) PRINT 101,I,TTOF(I)
  101 FORMAT(' TOF',I5,F12.2)
    1 CONTINUE
      RETURN
       END

C   11/01/88 801112212  MEMBER NAME  TPTGI2   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTGI2( SUMMRY )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery       11/01/88:  Get instructions for tagg TP
C
C
C
C     Routine to provide yes/no answer about need for tagging summary.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     SUMMRY    Out      L*4      TRUE if TP step wanted
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  TAGG*8, TP*20

      LOGICAL  SUMMRY, SUM, FIRST

      SAVE  SUM, FIRST

      DATA  FIRST / .TRUE. /
      DATA  TAGG  / 'TAGG' /,  TP / 'TP' /

C------------------  C O D E  ------------------------------------------

C                            If not first call, SUM already SAVEd.

      IF( FIRST ) THEN

C                            Get user request relating to tagg summary

        CALL TPUOPT( TAGG, TP, SUM )

        FIRST = .FALSE.

      ENDIF

C                            Set SUMMRY equal to SUM

      SUMMRY = SUM

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   12/02/88 808021742  MEMBER NAME  BBCORR   (SOURCE)      FORTRAN


C    LG CALIBRATION CORRECTION: PRODUCT OF BBLEAK, BBCLCE, BBTHLD
C        TAKING INTO ACCOUNT JAPANESE CORRECTION 'BRLGN'

C           CALLED BY CALCOR

C           D.PITZL  15.2.88

C=======================================================================
      SUBROUTINE BBCORR ( NRING, FCORR )
C=======================================================================

C    INPUT  : NRING = NUMBER OF LG-RING IN BARREL ( 0-31 )
C    OUTPUT : FCORR = CORRECTION FACTOR

      IMPLICIT INTEGER*2 (H)
C PMF 26/11/98 'f11god.patrecsr.for' replaced by 'cdata.for'
C               (see lganal.F)
C include "'f11god.patrecsr.for"
#include "cdata.for"

      DATA ICALLS / 0 /

      DIMENSION IRN (16)

      DIMENSION F35SF6 (16)
      DIMENSION F44SF6 (16)
      DIMENSION F35SF5 (16)


      DATA IRN /         0  ,   1  ,   2  ,   3  ,   4  ,   5  ,    6 ,
     +      7  ,   8 ,   9 ,   10 ,   11  ,  12  ,  13  ,  14  ,   15 /

C---        ECM = 35 GEV, LG WITH SF6 + SF6 ( 1986    ) :

      DATA F35SF6 /    0.860, 0.860, 0.860, 0.885, 0.895, 0.890, 0.890,
     +   0.890, 0.890, 0.885, 0.880, 0.895, 0.925, 0.960, 0.975, 0.980/

C---        ECM = 44 GEV, LG WITH SF6 + SF6 ( 1983-85 ) :

      DATA F44SF6 /    0.855, 0.855, 0.855, 0.880, 0.895, 0.890, 0.890,
     +   0.890, 0.885, 0.883, 0.875, 0.885, 0.915, 0.940, 0.965, 0.970/

C---        ECM = 35 GEV, LG ONLY SF5 ( 1979-82 ) :

      DATA F35SF5 /    0.865, 0.865, 0.865, 0.885, 0.905, 0.900, 0.900,
     +   0.900, 0.900, 0.905, 0.915, 0.925, 0.925, 0.925, 0.925, 0.930/
C
      IHEAD  = IDATA ( IBLN('HEAD') )
      NRUN   = HDATA ( 2 * IHEAD + 10 )
      NYEAR  = HDATA ( 2 * IHEAD +  8 )
      EBM    = EBEAM ( HDATA ( 2*IHEAD + 10 ) ) / 1000.0
C
      NRINGW = NRING
C---                                              SYMMETRY AROUND Z=0
      IF ( NRINGW .GT. 15 ) NRINGW = 31 - NRINGW
      NRINGW = NRINGW + 1
C
C---              BRANCH ACCORDING TO YEAR AND ENERGY
C
      IF ( NYEAR .GT. 1982 ) GOTO 20
         FCORR = F35SF5 ( NRINGW )
         IF ( ICALLS .EQ. 0 ) PRINT 1000, NYEAR, EBM
         ICALLS = 1
         GOTO 99
 20   CONTINUE
      IF ( EBM .LT. 19.75 ) GOTO 30
         FCORR = F44SF6 ( NRINGW )
         IF ( ICALLS .EQ. 0 ) PRINT 1000, NYEAR, EBM
         ICALLS = 1
         GOTO 99
 30   CONTINUE
         FCORR = F35SF6 ( NRINGW )
         IF ( ICALLS .EQ. 0 ) PRINT 1000, NYEAR, EBM
         ICALLS = 1
 99   CONTINUE

 1000 FORMAT ( T2,'JADELG.LOAD (BBCORR) CALLED FROM CALCOR',
     +       ' FOR DATA FROM ',I4,', EBEAM = ',F7.3, ' GEV' )

      RETURN
      END

C   13/06/81         2  MEMBER NAME  SPINNR0  (JADEGS)      FORTRAN
      SUBROUTINE SPINNR(NBL,IER,HRUN)
C---
C---     CHECK WHETHER BLOCK NBL IS A SPINNER, AS FAR AS IS KNOWN
C---     IER = 0 IF NO SPINNER, OTHERWISE IER = 1
C---          LAST CHANGE  06.01.81           J.OLSSON  15.04.81
C---
      IMPLICIT INTEGER*2 (H)
C
      IER = 0
      IF(HRUN.LT.100) GO TO 200
C PERMANENT SPINNERS IN 1979, 1980
      IF(HRUN.GT.6000) GO TO 255
      IF(NBL.EQ.2384) GO TO 100
      IF(NBL.EQ. 566) GO TO 100
      IF(HRUN.LT.100) GO TO 200
      IF(HRUN.GT.1496) GO TO 101
C   SUMMER DATA 1979
      IF(NBL.EQ.  45) GO TO 100
      IF(NBL.EQ. 112) GO TO 100
      IF(NBL.EQ. 144) GO TO 100
      IF(NBL.EQ. 146) GO TO 100
      IF(NBL.EQ. 150) GO TO 100
      IF(NBL.EQ. 168) GO TO 100
      IF(NBL.EQ. 225) GO TO 100
      IF(NBL.EQ. 327) GO TO 100
      IF(NBL.EQ. 333) GO TO 100
      IF(NBL.EQ. 377) GO TO 100
      IF(NBL.EQ. 507) GO TO 100
      IF(NBL.EQ. 527) GO TO 100
      IF(NBL.EQ. 641) GO TO 100
      IF(NBL.EQ. 669) GO TO 100
      IF(NBL.EQ. 754) GO TO 100
      IF(NBL.EQ. 803) GO TO 100
      IF(NBL.EQ. 810) GO TO 100
      IF(NBL.EQ. 966) GO TO 100
      IF(NBL.EQ. 982) GO TO 100
      IF(NBL.EQ.1075) GO TO 100
      IF(NBL.EQ.1078) GO TO 100
      IF(NBL.EQ.1137) GO TO 100
      IF(NBL.EQ.1224) GO TO 100
      IF(NBL.EQ.1257) GO TO 100
      IF(NBL.EQ.1353) GO TO 100
      IF(NBL.EQ.1419) GO TO 100
      IF(NBL.EQ.1468) GO TO 100
      IF(NBL.EQ.1474) GO TO 100
      IF(NBL.EQ.1481) GO TO 100
      IF(NBL.EQ.1487) GO TO 100
      IF(NBL.EQ.1491) GO TO 100
      IF(NBL.EQ.1497) GO TO 100
      IF(NBL.EQ.1626) GO TO 100
      IF(NBL.EQ.1749) GO TO 100
      IF(NBL.EQ.1796) GO TO 100
      IF(NBL.EQ.1807) GO TO 100
      IF(NBL.EQ.1859) GO TO 100
      IF(NBL.EQ.1884) GO TO 100
      IF(NBL.EQ.1890) GO TO 100
      IF(NBL.EQ.1893) GO TO 100
      IF(NBL.EQ.1958) GO TO 100
      IF(NBL.EQ.1959) GO TO 100
      IF(NBL.EQ.1969) GO TO 100
      IF(NBL.EQ.2020) GO TO 100
      IF(NBL.EQ.2095) GO TO 100
      IF(NBL.EQ.2131) GO TO 100
      IF(NBL.EQ.2215) GO TO 100
      IF(NBL.EQ.2238) GO TO 100
      IF(NBL.EQ.2472) GO TO 100
      IF(NBL.EQ.2473) GO TO 100
      IF(NBL.EQ.2474) GO TO 100
      IF(NBL.EQ.2534) GO TO 100
      IF(NBL.EQ.2827) GO TO 100
      GO TO 200
101   IF(HRUN.GT.2294) GO TO 102
C   ENERGY SCAN PERIOD
      IF(NBL.EQ.  45) GO TO 100
      IF(NBL.EQ.  74) GO TO 100
      IF(NBL.EQ. 112) GO TO 100
      IF(NBL.EQ. 137) GO TO 100
      IF(NBL.EQ. 141) GO TO 100
      IF(NBL.EQ. 169) GO TO 100
      IF(NBL.EQ. 233) GO TO 100
      IF(NBL.EQ. 234) GO TO 100
      IF(NBL.EQ. 281) GO TO 100
      IF(NBL.EQ. 311) GO TO 100
      IF(NBL.EQ. 377) GO TO 100
      IF(NBL.EQ. 392) GO TO 100
      IF(NBL.EQ. 410) GO TO 100
      IF(NBL.EQ. 413) GO TO 100
      IF(NBL.EQ. 428) GO TO 100
      IF(NBL.EQ. 453) GO TO 100
      IF(NBL.EQ. 457) GO TO 100
      IF(NBL.EQ. 463) GO TO 100
      IF(NBL.EQ. 489) GO TO 100
      IF(NBL.EQ. 528) GO TO 100
      IF(NBL.EQ. 540) GO TO 100
      IF(NBL.EQ. 541) GO TO 100
      IF(NBL.EQ. 555) GO TO 100
      IF(NBL.EQ. 566) GO TO 100
      IF(NBL.EQ. 586) GO TO 100
      IF(NBL.EQ. 619) GO TO 100
      IF(NBL.EQ. 621) GO TO 100
      IF(NBL.EQ. 624) GO TO 100
      IF(NBL.EQ. 646) GO TO 100
      IF(NBL.EQ. 652) GO TO 100
      IF(NBL.EQ. 656) GO TO 100
      IF(NBL.EQ. 688) GO TO 100
      IF(NBL.EQ. 695) GO TO 100
      IF(NBL.EQ. 712) GO TO 100
      IF(NBL.EQ. 721) GO TO 100
      IF(NBL.EQ. 737) GO TO 100
      IF(NBL.EQ. 743) GO TO 100
      IF(NBL.EQ. 753) GO TO 100
      IF(NBL.EQ. 754) GO TO 100
      IF(NBL.EQ. 793) GO TO 100
      IF(NBL.EQ. 810) GO TO 100
      IF(NBL.EQ. 814) GO TO 100
      IF(NBL.EQ. 845) GO TO 100
      IF(NBL.EQ. 848) GO TO 100
      IF(NBL.EQ. 877) GO TO 100
      IF(NBL.EQ. 884) GO TO 100
      IF(NBL.EQ. 887) GO TO 100
      IF(NBL.EQ. 940) GO TO 100
      IF(NBL.EQ. 966) GO TO 100
      IF(NBL.EQ.1039) GO TO 100
      IF(NBL.EQ.1078) GO TO 100
      IF(NBL.EQ.1093) GO TO 100
      IF(NBL.EQ.1127) GO TO 100
      IF(NBL.EQ.1137) GO TO 100
      IF(NBL.EQ.1138) GO TO 100
      IF(NBL.EQ.1141) GO TO 100
      IF(NBL.EQ.1142) GO TO 100
      IF(NBL.EQ.1167) GO TO 100
      IF(NBL.EQ.1192) GO TO 100
      IF(NBL.EQ.1224) GO TO 100
      IF(NBL.EQ.1257) GO TO 100
      IF(NBL.EQ.1272) GO TO 100
      IF(NBL.EQ.1304) GO TO 100
      IF(NBL.EQ.1333) GO TO 100
      IF(NBL.EQ.1334) GO TO 100
      IF(NBL.EQ.1346) GO TO 100
      IF(NBL.EQ.1347) GO TO 100
      IF(NBL.EQ.1351) GO TO 100
      IF(NBL.EQ.1354) GO TO 100
      IF(NBL.EQ.1363) GO TO 100
      IF(NBL.EQ.1365) GO TO 100
      IF(NBL.EQ.1391) GO TO 100
      IF(NBL.EQ.1397) GO TO 100
      IF(NBL.EQ.1419) GO TO 100
      IF(NBL.EQ.1449) GO TO 100
      IF(NBL.EQ.1468) GO TO 100
      IF(NBL.EQ.1474) GO TO 100
      IF(NBL.EQ.1481) GO TO 100
      IF(NBL.EQ.1487) GO TO 100
      IF(NBL.EQ.1508) GO TO 100
      IF(NBL.EQ.1520) GO TO 100
      IF(NBL.EQ.1537) GO TO 100
      IF(NBL.EQ.1538) GO TO 100
      IF(NBL.EQ.1545) GO TO 100
      IF(NBL.EQ.1563) GO TO 100
      IF(NBL.EQ.1565) GO TO 100
      IF(NBL.EQ.1580) GO TO 100
      IF(NBL.EQ.1592) GO TO 100
      IF(NBL.EQ.1593) GO TO 100
      IF(NBL.EQ.1615) GO TO 100
      IF(NBL.EQ.1626) GO TO 100
      IF(NBL.EQ.1640) GO TO 100
      IF(NBL.EQ.1648) GO TO 100
      IF(NBL.EQ.1649) GO TO 100
      IF(NBL.EQ.1679) GO TO 100
      IF(NBL.EQ.1682) GO TO 100
      IF(NBL.EQ.1729) GO TO 100
      IF(NBL.EQ.1739) GO TO 100
      IF(NBL.EQ.1741) GO TO 100
      IF(NBL.EQ.1743) GO TO 100
      IF(NBL.EQ.1747) GO TO 100
      IF(NBL.EQ.1749) GO TO 100
      IF(NBL.EQ.1769) GO TO 100
      IF(NBL.EQ.1779) GO TO 100
      IF(NBL.EQ.1781) GO TO 100
      IF(NBL.EQ.1796) GO TO 100
      IF(NBL.EQ.1807) GO TO 100
      IF(NBL.EQ.1859) GO TO 100
      IF(NBL.EQ.1872) GO TO 100
      IF(NBL.EQ.1884) GO TO 100
      IF(NBL.EQ.1890) GO TO 100
      IF(NBL.EQ.1964) GO TO 100
      IF(NBL.EQ.1993) GO TO 100
      IF(NBL.EQ.2033) GO TO 100
      IF(NBL.EQ.2095) GO TO 100
      IF(NBL.EQ.2199) GO TO 100
      IF(NBL.EQ.2151) GO TO 100
      IF(NBL.EQ.2203) GO TO 100
      IF(NBL.EQ.2220) GO TO 100
      IF(NBL.EQ.2215) GO TO 100
      IF(NBL.EQ.2238) GO TO 100
      IF(NBL.EQ.2254) GO TO 100
      IF(NBL.EQ.2256) GO TO 100
      IF(NBL.EQ.2259) GO TO 100
      IF(NBL.EQ.2342) GO TO 100
      IF(NBL.EQ.2351) GO TO 100
      IF(NBL.EQ.2354) GO TO 100
      IF(NBL.EQ.2407) GO TO 100
      IF(NBL.EQ.2411) GO TO 100
      IF(NBL.EQ.2418) GO TO 100
      IF(NBL.EQ.2424) GO TO 100
      IF(NBL.EQ.2440) GO TO 100
      IF(NBL.EQ.2448) GO TO 100
      IF(NBL.EQ.2451) GO TO 100
      IF(NBL.EQ.2474) GO TO 100
      IF(NBL.EQ.2530) GO TO 100
      IF(NBL.EQ.2552) GO TO 100
      IF(NBL.EQ.2554) GO TO 100
      IF(NBL.EQ.2597) GO TO 100
      IF(NBL.EQ.2689) GO TO 100
      IF(NBL.EQ.2760) GO TO 100
      IF(NBL.EQ.2810) GO TO 100
      IF(NBL.EQ.2811) GO TO 100
      GO TO 200
C**    12 GEV DATA
102   IF(HRUN.GT.2520) GO TO 103
      IF(NBL.EQ.   9) GO TO 100
      IF(NBL.EQ.  35) GO TO 100
      IF(NBL.EQ.  45) GO TO 100
      IF(NBL.EQ. 112) GO TO 100
      IF(NBL.EQ. 119) GO TO 100
      IF(NBL.EQ. 141) GO TO 100
      IF(NBL.EQ. 169) GO TO 100
      IF(NBL.EQ. 281) GO TO 100
      IF(NBL.EQ. 305) GO TO 100
      IF(NBL.EQ. 377) GO TO 100
      IF(NBL.EQ. 399) GO TO 100
      IF(NBL.EQ. 423) GO TO 100
      IF(NBL.EQ. 425) GO TO 100
      IF(NBL.EQ. 489) GO TO 100
      IF(NBL.EQ. 646) GO TO 100
      IF(NBL.EQ. 649) GO TO 100
      IF(NBL.EQ. 667) GO TO 100
      IF(NBL.EQ. 754) GO TO 100
      IF(NBL.EQ. 810) GO TO 100
      IF(NBL.EQ. 816) GO TO 100
      IF(NBL.EQ. 904) GO TO 100
      IF(NBL.EQ. 966) GO TO 100
      IF(NBL.EQ.1077) GO TO 100
      IF(NBL.EQ.1095) GO TO 100
      IF(NBL.EQ.1096) GO TO 100
      IF(NBL.EQ.1125) GO TO 100
      IF(NBL.EQ.1142) GO TO 100
      IF(NBL.EQ.1191) GO TO 100
      IF(NBL.EQ.1192) GO TO 100
      IF(NBL.EQ.1255) GO TO 100
      IF(NBL.EQ.1256) GO TO 100
      IF(NBL.EQ.1257) GO TO 100
      IF(NBL.EQ.1285) GO TO 100
      IF(NBL.EQ.1288) GO TO 100
      IF(NBL.EQ.1353) GO TO 100
      IF(NBL.EQ.1354) GO TO 100
      IF(NBL.EQ.1386) GO TO 100
      IF(NBL.EQ.1391) GO TO 100
      IF(NBL.EQ.1419) GO TO 100
      IF(NBL.EQ.1425) GO TO 100
      IF(NBL.EQ.1437) GO TO 100
      IF(NBL.EQ.1644) GO TO 100
      IF(NBL.EQ.1749) GO TO 100
      IF(NBL.EQ.1796) GO TO 100
      IF(NBL.EQ.1807) GO TO 100
      IF(NBL.EQ.1884) GO TO 100
      IF(NBL.EQ.1890) GO TO 100
      IF(NBL.EQ.1964) GO TO 100
      IF(NBL.EQ.2001) GO TO 100
      IF(NBL.EQ.2130) GO TO 100
      IF(NBL.EQ.2151) GO TO 100
      IF(NBL.EQ.2203) GO TO 100
      IF(NBL.EQ.2238) GO TO 100
      IF(NBL.EQ.2256) GO TO 100
      IF(NBL.EQ.2376) GO TO 100
      IF(NBL.EQ.2440) GO TO 100
      IF(NBL.EQ.2472) GO TO 100
      IF(NBL.EQ.2474) GO TO 100
      IF(NBL.EQ.2504) GO TO 100
      IF(NBL.EQ.2587) GO TO 100
      IF(NBL.EQ.2713) GO TO 100
      IF(NBL.EQ.2726) GO TO 100
      IF(NBL.EQ.2760) GO TO 100
      IF(NBL.EQ.2810) GO TO 100
      IF(NBL.EQ.2834) GO TO 100
      IF(NBL.EQ.2835) GO TO 100
      IF(NBL.EQ.2859) GO TO 100
      GO TO 200
C**    33 GEV DATA AND HIGHER, SPRING 1980
103   IF(HRUN.GT.3318.AND.HRUN.LT.3358) GO TO 100
      IF(HRUN.GT.3728) GO TO 105
      IF(NBL.EQ.  14) GO TO 100
      IF(NBL.EQ.  41) GO TO 100
      IF(NBL.EQ.  45) GO TO 100
      IF(NBL.EQ.  49) GO TO 100
      IF(NBL.EQ.  50) GO TO 100
      IF(NBL.EQ.  57) GO TO 100
      IF(NBL.EQ.  72) GO TO 100
      IF(NBL.EQ.  81) GO TO 100
      IF(NBL.EQ.  87) GO TO 100
      IF(NBL.EQ.  91) GO TO 100
      IF(NBL.EQ. 116) GO TO 100
      IF(NBL.EQ. 119) GO TO 100
      IF(NBL.EQ. 120) GO TO 100
      IF(NBL.EQ. 137) GO TO 100
      IF(NBL.EQ. 141) GO TO 100
      IF(NBL.EQ. 144) GO TO 100
      IF(NBL.EQ. 168) GO TO 100
      IF(NBL.EQ. 169) GO TO 100
      IF(NBL.EQ. 172) GO TO 100
      IF(NBL.EQ. 179) GO TO 100
      IF(NBL.EQ. 204) GO TO 100
      IF(NBL.EQ. 211) GO TO 100
      IF(NBL.EQ. 253) GO TO 100
      IF(NBL.EQ. 265) GO TO 100
      IF(NBL.EQ. 281) GO TO 100
      IF(NBL.EQ. 293) GO TO 100
      IF(NBL.EQ. 294) GO TO 100
      IF(NBL.EQ. 297) GO TO 100
      IF(NBL.EQ. 299) GO TO 100
      IF(NBL.EQ. 359) GO TO 100
      IF(NBL.EQ. 373) GO TO 100
      IF(NBL.EQ. 412) GO TO 100
      IF(NBL.EQ. 423) GO TO 100
      IF(NBL.EQ. 424) GO TO 100
      IF(NBL.EQ. 432) GO TO 100
      IF(NBL.EQ. 459) GO TO 100
      IF(NBL.EQ. 490) GO TO 100
      IF(NBL.EQ. 491) GO TO 100
      IF(NBL.EQ. 521) GO TO 100
      IF(NBL.EQ. 523) GO TO 100
      IF(NBL.EQ. 533) GO TO 100
      IF(NBL.EQ. 551) GO TO 100
      IF(NBL.EQ. 571) GO TO 100
      IF(NBL.EQ. 585) GO TO 100
      IF(NBL.EQ. 619) GO TO 100
      IF(NBL.EQ. 641) GO TO 100
      IF(NBL.EQ. 646) GO TO 100
      IF(NBL.EQ. 661) GO TO 100
      IF(NBL.EQ. 664) GO TO 100
      IF(NBL.EQ. 667) GO TO 100
      IF(NBL.EQ. 685) GO TO 100
      IF(NBL.EQ. 688) GO TO 100
      IF(NBL.EQ. 697) GO TO 100
      IF(NBL.EQ. 711) GO TO 100
      IF(NBL.EQ. 722) GO TO 100
      IF(NBL.EQ. 753) GO TO 100
      IF(NBL.EQ. 754) GO TO 100
      IF(NBL.EQ. 783) GO TO 100
      IF(NBL.EQ. 785) GO TO 100
      IF(NBL.EQ. 816) GO TO 100
      IF(NBL.EQ. 844) GO TO 100
      IF(NBL.EQ. 856) GO TO 100
      IF(NBL.EQ. 887) GO TO 100
      IF(NBL.EQ. 909) GO TO 100
      IF(NBL.EQ. 919) GO TO 100
      IF(NBL.EQ. 950) GO TO 100
      IF(NBL.EQ. 951) GO TO 100
      IF(NBL.EQ. 966) GO TO 100
      IF(NBL.EQ. 982) GO TO 100
      IF(NBL.EQ. 990) GO TO 100
      IF(NBL.EQ.1015) GO TO 100
      IF(NBL.EQ.1022) GO TO 100
      IF(NBL.EQ.1027) GO TO 100
      IF(NBL.EQ.1033) GO TO 100
      IF(NBL.EQ.1041) GO TO 100
      IF(NBL.EQ.1043) GO TO 100
      IF(NBL.EQ.1065) GO TO 100
      IF(NBL.EQ.1074) GO TO 100
      IF(NBL.EQ.1076) GO TO 100
      IF(NBL.EQ.1077) GO TO 100
      IF(NBL.EQ.1104) GO TO 100
      IF(NBL.EQ.1111) GO TO 100
      IF(NBL.EQ.1128) GO TO 100
      IF(NBL.EQ.1162) GO TO 100
      IF(NBL.EQ.1171) GO TO 100
      IF(NBL.EQ.1224) GO TO 100
      IF(NBL.EQ.1239) GO TO 100
      IF(NBL.EQ.1246) GO TO 100
      IF(NBL.EQ.1272) GO TO 100
      IF(NBL.EQ.1285) GO TO 100
      IF(NBL.EQ.1305) GO TO 100
      IF(NBL.EQ.1308) GO TO 100
      IF(NBL.EQ.1317) GO TO 100
      IF(NBL.EQ.1354) GO TO 100
      IF(NBL.EQ.1359) GO TO 100
      IF(NBL.EQ.1367) GO TO 100
      IF(NBL.EQ.1391) GO TO 100
      IF(NBL.EQ.1429) GO TO 100
      IF(NBL.EQ.1438) GO TO 100
      IF(NBL.EQ.1445) GO TO 100
      IF(NBL.EQ.1457) GO TO 100
      IF(NBL.EQ.1467) GO TO 100
      IF(NBL.EQ.1584) GO TO 100
      IF(NBL.EQ.1608) GO TO 100
      IF(NBL.EQ.1611) GO TO 100
      IF(NBL.EQ.1636) GO TO 100
      IF(NBL.EQ.1643) GO TO 100
      IF(NBL.EQ.1644) GO TO 100
      IF(NBL.EQ.1684) GO TO 100
      IF(NBL.EQ.1708) GO TO 100
      IF(NBL.EQ.1712) GO TO 100
      IF(NBL.EQ.1743) GO TO 100
      IF(NBL.EQ.1748) GO TO 100
      IF(NBL.EQ.1752) GO TO 100
      IF(NBL.EQ.1776) GO TO 100
      IF(NBL.EQ.1859) GO TO 100
      IF(NBL.EQ.1893) GO TO 100
      IF(NBL.EQ.1921) GO TO 100
      IF(NBL.EQ.1934) GO TO 100
      IF(NBL.EQ.1944) GO TO 100
      IF(NBL.EQ.1964) GO TO 100
      IF(NBL.EQ.1968) GO TO 100
      IF(NBL.EQ.1969) GO TO 100
      IF(NBL.EQ.2029) GO TO 100
      IF(NBL.EQ.2062) GO TO 100
      IF(NBL.EQ.2063) GO TO 100
      IF(NBL.EQ.2126) GO TO 100
      IF(NBL.EQ.2129) GO TO 100
      IF(NBL.EQ.2130) GO TO 100
      IF(NBL.EQ.2131) GO TO 100
      IF(NBL.EQ.2154) GO TO 100
      IF(NBL.EQ.2160) GO TO 100
      IF(NBL.EQ.2163) GO TO 100
      IF(NBL.EQ.2171) GO TO 100
      IF(NBL.EQ.2209) GO TO 100
      IF(NBL.EQ.2212) GO TO 100
      IF(NBL.EQ.2219) GO TO 100
      IF(NBL.EQ.2221) GO TO 100
      IF(NBL.EQ.2224) GO TO 100
      IF(NBL.EQ.2227) GO TO 100
      IF(NBL.EQ.2247) GO TO 100
      IF(NBL.EQ.2256) GO TO 100
      IF(NBL.EQ.2260) GO TO 100
      IF(NBL.EQ.2376) GO TO 100
      IF(NBL.EQ.2377) GO TO 100
      IF(NBL.EQ.2384) GO TO 100
      IF(NBL.EQ.2398) GO TO 100
      IF(NBL.EQ.2407) GO TO 100
      IF(NBL.EQ.2416) GO TO 100
      IF(NBL.EQ.2428) GO TO 100
      IF(NBL.EQ.2439) GO TO 100
      IF(NBL.EQ.2448) GO TO 100
      IF(NBL.EQ.2489) GO TO 100
      IF(NBL.EQ.2520) GO TO 100
      IF(NBL.EQ.2534) GO TO 100
      IF(NBL.EQ.2543) GO TO 100
      IF(NBL.EQ.2568) GO TO 100
      IF(NBL.EQ.2739) GO TO 100
      IF(NBL.EQ.2760) GO TO 100
      IF(NBL.EQ.2810) GO TO 100
      IF(NBL.EQ.2834) GO TO 100
      GO TO 200
C**    33-35 GEV DATA , SUMMER 1980
105   IF(HRUN.GT.4860) GO TO 106
      IF(NBL.EQ.   5) GO TO 100
      IF(NBL.EQ.  22) GO TO 100
      IF(NBL.EQ.  23) GO TO 100
      IF(NBL.EQ.  24) GO TO 100
      IF(NBL.EQ.  35) GO TO 100
      IF(NBL.EQ.  43) GO TO 100
      IF(NBL.EQ.  45) GO TO 100
      IF(NBL.EQ.  62) GO TO 100
      IF(NBL.EQ.  92) GO TO 100
      IF(NBL.EQ. 118) GO TO 100
      IF(NBL.EQ. 141) GO TO 100
      IF(NBL.EQ. 158) GO TO 100
      IF(NBL.EQ. 169) GO TO 100
      IF(NBL.EQ. 237) GO TO 100
      IF(NBL.EQ. 253) GO TO 100
      IF(NBL.EQ. 281) GO TO 100
      IF(NBL.EQ. 294) GO TO 100
      IF(NBL.EQ. 303) GO TO 100
      IF(NBL.EQ. 377) GO TO 100
      IF(NBL.EQ. 403) GO TO 100
      IF(NBL.EQ. 418) GO TO 100
      IF(NBL.EQ. 427) GO TO 100
      IF(NBL.EQ. 437) GO TO 100
      IF(NBL.EQ. 463) GO TO 100
      IF(NBL.EQ. 513) GO TO 100
      IF(NBL.EQ. 533) GO TO 100
      IF(NBL.EQ. 541) GO TO 100
      IF(NBL.EQ. 566) GO TO 100
      IF(NBL.EQ. 653) GO TO 100
      IF(NBL.EQ. 661) GO TO 100
      IF(NBL.EQ. 664) GO TO 100
      IF(NBL.EQ. 667) GO TO 100
      IF(NBL.EQ. 688) GO TO 100
      IF(NBL.EQ. 694) GO TO 100
      IF(NBL.EQ. 697) GO TO 100
      IF(NBL.EQ. 725) GO TO 100
      IF(NBL.EQ. 726) GO TO 100
      IF(NBL.EQ. 727) GO TO 100
      IF(NBL.EQ. 729) GO TO 100
      IF(NBL.EQ. 730) GO TO 100
      IF(NBL.EQ. 731) GO TO 100
      IF(NBL.EQ. 732) GO TO 100
      IF(NBL.EQ. 738) GO TO 100
      IF(NBL.EQ. 741) GO TO 100
      IF(NBL.EQ. 746) GO TO 100
      IF(NBL.EQ. 747) GO TO 100
      IF(NBL.EQ. 748) GO TO 100
      IF(NBL.EQ. 749) GO TO 100
      IF(NBL.EQ. 754) GO TO 100
      IF(NBL.EQ. 755) GO TO 100
      IF(NBL.EQ. 756) GO TO 100
      IF(NBL.EQ. 758) GO TO 100
      IF(NBL.EQ. 759) GO TO 100
      IF(NBL.EQ. 761) GO TO 100
      IF(NBL.EQ. 762) GO TO 100
      IF(NBL.EQ. 765) GO TO 100
      IF(NBL.EQ. 830) GO TO 100
      IF(NBL.EQ. 844) GO TO 100
      IF(NBL.EQ. 856) GO TO 100
      IF(NBL.EQ. 859) GO TO 100
      IF(NBL.EQ. 881) GO TO 100
      IF(NBL.EQ. 922) GO TO 100
      IF(NBL.EQ. 945) GO TO 100
      IF(NBL.EQ. 951) GO TO 100
      IF(NBL.EQ. 982) GO TO 100
      IF(NBL.EQ. 987) GO TO 100
      IF(NBL.EQ. 993) GO TO 100
      IF(NBL.EQ.1027) GO TO 100
      IF(NBL.EQ.1036) GO TO 100
      IF(NBL.EQ.1086) GO TO 100
      IF(NBL.EQ.1118) GO TO 100
      IF(NBL.EQ.1146) GO TO 100
      IF(NBL.EQ.1150) GO TO 100
      IF(NBL.EQ.1164) GO TO 100
      IF(NBL.EQ.1223) GO TO 100
      IF(NBL.EQ.1224) GO TO 100
      IF(NBL.EQ.1246) GO TO 100
      IF(NBL.EQ.1272) GO TO 100
      IF(NBL.EQ.1275) GO TO 100
      IF(NBL.EQ.1283) GO TO 100
      IF(NBL.EQ.1328) GO TO 100
      IF(NBL.EQ.1334) GO TO 100
      IF(NBL.EQ.1354) GO TO 100
      IF(NBL.EQ.1390) GO TO 100
      IF(NBL.EQ.1415) GO TO 100
      IF(NBL.EQ.1473) GO TO 100
      IF(NBL.EQ.1489) GO TO 100
      IF(NBL.EQ.1501) GO TO 100
      IF(NBL.EQ.1518) GO TO 100
      IF(NBL.EQ.1542) GO TO 100
      IF(NBL.EQ.1545) GO TO 100
      IF(NBL.EQ.1549) GO TO 100
      IF(NBL.EQ.1572) GO TO 100
      IF(NBL.EQ.1667) GO TO 100
      IF(NBL.EQ.1680) GO TO 100
      IF(NBL.EQ.1691) GO TO 100
      IF(NBL.EQ.1720) GO TO 100
      IF(NBL.EQ.1740) GO TO 100
      IF(NBL.EQ.1757) GO TO 100
      IF(NBL.EQ.1807) GO TO 100
      IF(NBL.EQ.1899) GO TO 100
      IF(NBL.EQ.1960) GO TO 100
      IF(NBL.EQ.1961) GO TO 100
      IF(NBL.EQ.1965) GO TO 100
      IF(NBL.EQ.2044) GO TO 100
      IF(NBL.EQ.2063) GO TO 100
      IF(NBL.EQ.2071) GO TO 100
      IF(NBL.EQ.2073) GO TO 100
      IF(NBL.EQ.2077) GO TO 100
      IF(NBL.EQ.2078) GO TO 100
      IF(NBL.EQ.2083) GO TO 100
      IF(NBL.EQ.2090) GO TO 100
      IF(NBL.EQ.2093) GO TO 100
      IF(NBL.EQ.2104) GO TO 100
      IF(NBL.EQ.2116) GO TO 100
      IF(NBL.EQ.2117) GO TO 100
      IF(NBL.EQ.2124) GO TO 100
      IF(NBL.EQ.2125) GO TO 100
      IF(NBL.EQ.2126) GO TO 100
      IF(NBL.EQ.2128) GO TO 100
      IF(NBL.EQ.2129) GO TO 100
      IF(NBL.EQ.2130) GO TO 100
      IF(NBL.EQ.2135) GO TO 100
      IF(NBL.EQ.2154) GO TO 100
      IF(NBL.EQ.2158) GO TO 100
      IF(NBL.EQ.2160) GO TO 100
      IF(NBL.EQ.2164) GO TO 100
      IF(NBL.EQ.2165) GO TO 100
      IF(NBL.EQ.2191) GO TO 100
      IF(NBL.EQ.2192) GO TO 100
      IF(NBL.EQ.2212) GO TO 100
      IF(NBL.EQ.2215) GO TO 100
      IF(NBL.EQ.2243) GO TO 100
      IF(NBL.EQ.2244) GO TO 100
      IF(NBL.EQ.2262) GO TO 100
      IF(NBL.EQ.2264) GO TO 100
      IF(NBL.EQ.2268) GO TO 100
      IF(NBL.EQ.2289) GO TO 100
      IF(NBL.EQ.2299) GO TO 100
      IF(NBL.EQ.2305) GO TO 100
      IF(NBL.EQ.2307) GO TO 100
      IF(NBL.EQ.2316) GO TO 100
      IF(NBL.EQ.2325) GO TO 100
      IF(NBL.EQ.2380) GO TO 100
      IF(NBL.EQ.2384) GO TO 100
      IF(NBL.EQ.2388) GO TO 100
      IF(NBL.EQ.2393) GO TO 100
      IF(NBL.EQ.2395) GO TO 100
      IF(NBL.EQ.2401) GO TO 100
      IF(NBL.EQ.2442) GO TO 100
      IF(NBL.EQ.2447) GO TO 100
      IF(NBL.EQ.2449) GO TO 100
      IF(NBL.EQ.2456) GO TO 100
      IF(NBL.EQ.2459) GO TO 100
      IF(NBL.EQ.2460) GO TO 100
      IF(NBL.EQ.2471) GO TO 100
      IF(NBL.EQ.2472) GO TO 100
      IF(NBL.EQ.2474) GO TO 100
      IF(NBL.EQ.2476) GO TO 100
      IF(NBL.EQ.2478) GO TO 100
      IF(NBL.EQ.2479) GO TO 100
      IF(NBL.EQ.2481) GO TO 100
      IF(NBL.EQ.2482) GO TO 100
      IF(NBL.EQ.2483) GO TO 100
      IF(NBL.EQ.2493) GO TO 100
      IF(NBL.EQ.2494) GO TO 100
      IF(NBL.EQ.2517) GO TO 100
      IF(NBL.EQ.2529) GO TO 100
      IF(NBL.EQ.2531) GO TO 100
      IF(NBL.EQ.2533) GO TO 100
      IF(NBL.EQ.2537) GO TO 100
      IF(NBL.EQ.2538) GO TO 100
      IF(NBL.EQ.2542) GO TO 100
      IF(NBL.EQ.2543) GO TO 100
      IF(NBL.EQ.2593) GO TO 100
      IF(NBL.EQ.2601) GO TO 100
      IF(NBL.EQ.2611) GO TO 100
      IF(NBL.EQ.2618) GO TO 100
      IF(NBL.EQ.2634) GO TO 100
      IF(NBL.EQ.2646) GO TO 100
      IF(NBL.EQ.2653) GO TO 100
      IF(NBL.EQ.2657) GO TO 100
      IF(NBL.EQ.2658) GO TO 100
      IF(NBL.EQ.2662) GO TO 100
      IF(NBL.EQ.2663) GO TO 100
      IF(NBL.EQ.2664) GO TO 100
      IF(NBL.EQ.2665) GO TO 100
      IF(NBL.EQ.2682) GO TO 100
      IF(NBL.EQ.2684) GO TO 100
      IF(NBL.EQ.2713) GO TO 100
      IF(NBL.EQ.2716) GO TO 100
      IF(NBL.EQ.2721) GO TO 100
      IF(NBL.EQ.2810) GO TO 100
      GO TO 200
C**   DATA AUTUMN 1980
106   IF(NBL.EQ.  35) GO TO 100
      IF(NBL.EQ.  43) GO TO 100
      IF(NBL.EQ. 220) GO TO 100
      IF(NBL.EQ. 253) GO TO 100
      IF(NBL.EQ. 281) GO TO 100
      IF(NBL.EQ. 301) GO TO 100
      IF(NBL.EQ. 312) GO TO 100
      IF(NBL.EQ. 313) GO TO 100
      IF(NBL.EQ. 314) GO TO 100
      IF(NBL.EQ. 315) GO TO 100
      IF(NBL.EQ. 343) GO TO 100
      IF(NBL.EQ. 427) GO TO 100
      IF(NBL.EQ. 548) GO TO 100
      IF(NBL.EQ. 661) GO TO 100
      IF(NBL.EQ. 667) GO TO 100
      IF(NBL.EQ. 694) GO TO 100
      IF(NBL.EQ. 756) GO TO 100
      IF(NBL.EQ. 757) GO TO 100
      IF(NBL.EQ. 758) GO TO 100
      IF(NBL.EQ. 816) GO TO 100
      IF(NBL.EQ. 830) GO TO 100
      IF(NBL.EQ. 842) GO TO 100
      IF(NBL.EQ. 856) GO TO 100
      IF(NBL.EQ. 908) GO TO 100
      IF(NBL.EQ. 915) GO TO 100
      IF(NBL.EQ. 922) GO TO 100
      IF(NBL.EQ. 951) GO TO 100
      IF(NBL.EQ.1016) GO TO 100
      IF(NBL.EQ.1077) GO TO 100
      IF(NBL.EQ.1117) GO TO 100
      IF(NBL.EQ.1146) GO TO 100
      IF(NBL.EQ.1227) GO TO 100
      IF(NBL.EQ.1457) GO TO 100
      IF(NBL.EQ.1525) GO TO 100
      IF(NBL.EQ.1549) GO TO 100
      IF(NBL.EQ.1691) GO TO 100
      IF(NBL.EQ.1777) GO TO 100
      IF(NBL.EQ.1899) GO TO 100
      IF(NBL.EQ.1938) GO TO 100
      IF(NBL.EQ.1962) GO TO 100
      IF(NBL.EQ.2033) GO TO 100
      IF(NBL.EQ.2082) GO TO 100
      IF(NBL.EQ.2107) GO TO 100
      IF(NBL.EQ.2152) GO TO 100
      IF(NBL.EQ.2158) GO TO 100
      IF(NBL.EQ.2214) GO TO 100
      IF(NBL.EQ.2215) GO TO 100
      IF(NBL.EQ.2269) GO TO 100
      IF(NBL.EQ.2287) GO TO 100
      IF(NBL.EQ.2293) GO TO 100
      IF(NBL.EQ.2340) GO TO 100
      IF(NBL.EQ.2384) GO TO 100
      IF(NBL.EQ.2410) GO TO 100
      IF(NBL.EQ.2446) GO TO 100
      IF(NBL.EQ.2447) GO TO 100
      IF(NBL.EQ.2523) GO TO 100
      IF(NBL.EQ.2595) GO TO 100
      IF(NBL.EQ.2627) GO TO 100
      IF(NBL.EQ.2737) GO TO 100
      GO TO 200
255   CONTINUE
C  SPRING 1981
      IF(NBL.EQ. 147) GO TO 100
      IF(NBL.EQ. 161) GO TO 100
      IF(NBL.EQ. 253) GO TO 100
      IF(NBL.EQ. 281) GO TO 100
      IF(NBL.EQ. 661) GO TO 100
      IF(NBL.EQ. 665) GO TO 100
      IF(NBL.EQ. 667) GO TO 100
      IF(NBL.EQ. 688) GO TO 100
      IF(NBL.EQ. 790) GO TO 100
      IF(NBL.EQ. 814) GO TO 100
      IF(NBL.EQ.1647) GO TO 100
      IF(NBL.EQ.1691) GO TO 100
      IF(NBL.EQ.2205) GO TO 100
      IF(NBL.EQ.2627) GO TO 100
      GO TO 200
100   IER = 1
200   RETURN
      END

C   12/03/84 406221950  MEMBER NAME  FRTYPE   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C FRTYPE FINDS THE 'R TYPE' OF ADC SOFWARE ADDRESS I
C SEE CSLPS ROUTINE FOR EXPLANATION OF RTYPE (THIS IS FOR 1983 ONWARDS
C  ONLY)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      FUNCTION FRTYPE(I)
C
      IF ( (I .GE.  1) .AND. (I .LE.  8) ) FRTYPE = 1
      IF ( (I .GE.  9) .AND. (I .LE. 16) ) FRTYPE = 2
      IF ( (I .GE. 17) .AND. (I .LE. 24) ) FRTYPE = 3
      IF ( (I .GE. 25) .AND. (I .LE. 32) ) FRTYPE = 1
      IF ( (I .GE. 33) .AND. (I .LE. 40) ) FRTYPE = 2
      IF ( (I .GE. 41) .AND. (I .LE. 48) ) FRTYPE = 3
C
      RETURN
      END

C   03/09/79 508141518  MEMBER NAME  UMCPAK   (S)           FORTRAN
      SUBROUTINE UMCPAK(IER,*)
C---  IT IS ASSUMED THAT THE EVENT IS ALREADY READ
C---  UNPACK DATA OF ONE MONTE-CARLO EVENT
C
C     H.WRIEDT       12.03.79       11:15
C          MODIFICATION       22.03.80      15:30
C          MODIFICATION       27.11.84   JMN STOPPED ATAG PRINTOUT
C                                            AND TESTED FOR NO ADC
C                                            DATA ( IE JUST HEADER
C                                            WORDS IN ATAG BANK )
C     LAST MODIFICATION       14.8.85    AJF CORRECTION TO ABOVE
C
C
      IMPLICIT INTEGER*2 (H)
C
      EXTERNAL BDLM
C
      COMMON /BCS/ IDATA(30000)
      DIMENSION HDATA(60000), RDATA(30000)
      EQUIVALENCE (IDATA(1),RDATA(1),HDATA(1))
C
      COMMON /CWORK/ HCOINC(16),HLUMON(16),HGGLAT(16),HSCALE(36),
     &               LNG,HPOINT(4),HGGADC(2,192),IWORK1(269),HCORR,
     &               HPBLAT,IWORK2,HSCAL(36),IWORK3(762),HACC,HWORK1,
     &               HLULAT,HWORK2,IWORK4(618),HRUNEX,HEVENT,XV,YV,ZV
      DIMENSION LAT(2),HLAT(4)
C
      INTEGER GGADC(242)
      EQUIVALENCE (GGADC(3),HGGADC(1,1)), (HLAT(1),LAT(1))
C
      COMMON /CRUNCO/ HRUN,HOLDRN
C
      COMMON /CMSGCT/ MSGDUM(21),NGGMSG(16)
C
      COMMON /CGGVRN/ NVRSN(20)
      DATA NVCODE/580032215/
      DATA IEV/0/
C
      NVRSN(5) = NVCODE
      IER = 0
C
C---  FETCH DATA FROM 'HEAD'
C---  FETCH HEAD-POINTER
    4 IHEAD = IDATA(IBLN('HEAD'))
      IF (IHEAD.GT.0) GOTO 5
C---  HEAD IS MISSING
      RETURN 1
C---  FETCH RUN- AND EVENT-NO.
    5 INDEX = 2*IHEAD + 10
      HRUNEX = HDATA(INDEX)
      HEVENT = HDATA(INDEX+1)
      HOLDRN = HRUNEX
      HRUN = HRUNEX
      IEV = IEV + 1
C
C---  TRANSFER DATA FROM 'TPVX'
C---  FETCH TPVX-POINTER
    6 IND = IDATA(IBLN('TPVX'))
      IF (IND.GT.0) GOTO 7
C---  TPVX IS MISSING
      XV = 0.
      YV = 0.
      ZV = 0.
      GOTO 50
C---  FETCH EVENT VERTEX
    7 XV = RDATA(IND+2)
      YV = RDATA(IND+3)
      ZV = RDATA(IND+4)
C
C---  CORRECT INITIALIZATION OF LNG
   50 LNG = 2
C---  TRANSFER DATA FROM 'ATAG'
C---  FETCH ATAG-POINTER
      IND = IDATA(IBLN('ATAG'))
      IF (IND.GT.0) GOTO 51
C---  ATAG IS MISSING
      NGGMSG(3) = NGGMSG(3) + 1
      IER = IER + 2
      RETURN
C---  FETCH ATAG-DATA
C---  LNG:  NUMBER OF ADC-DATA + 2
   51 NDATA = IDATA(IND)
      LNG = NDATA - 1
C
C--- JMN                                 NO ATAG BANK DUMP
C
CCC   IF (IEV.LT.30) CALL BPRS('ATAG',0)
CCC   IF (IEV.LT.30) CALL HPRS('ATAG',0)
C--- JMN                                 TEST FOR NO ADC DATA
C     IF ((LNG.GE.5  ).AND.(LNG.LE.242)) GOTO 53
C AJF VERSION 14/8/85
      IF((NDATA.GT.3).AND.(NDATA.LT.200)) GOTO 53
C END OF AJF VERSION
CCC   IF (LNG.LE.242) GOTO 53
C--- JMN                                 END OF JMN CHANGES
C
      RETURN 1
   53 CALL UCOPY(IDATA(IND+2),GGADC(1),LNG)
C
      RETURN
      END

      SUBROUTINE USER(INDEX)
      IMPLICIT INTEGER*2 (H)
      REAL LBACC
      LOGICAL TBIT
      EXTERNAL OR,AND
      REAL OR,AND
#include "cdata.for"
#include "cpatlm.for"
#include "czvpar.for"
#include "cworkzv.for"
#include "cjdrch.for"
#include "cheadr.for"
#include "ciouni.for"
#include "cutsr1.for"
      COMMON/CGBOOK/PLOT(116,13)
      COMMON /CREDRS/ LBAB2,LBAB4,LBAB8,LBAT2M,ARES(40)
                      INTEGER IRES(40)
                      EQUIVALENCE (ARES(1),IRES(1))
      COMMON /CTLIM/ ISECLF
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT
      COMMON/CALIBR/JPOINT(100),
     +HMUCAL(8370),HLGMAI(5760),HTAGSY(384),HJPULS(9216),
     +DELTA0(96,2),DELTA1(96,2),DELTA2(96,2),DELTA5(96,2),DELTA6(96,2)
      COMMON /CIGG/ IPRN,IGG(80),JIGG(80)
      LOGICAL*1 CHOP
      DATA LBSTRT/0/, LIMHIT/12/,MKMUT1/8/,LIMHFW/8/
 2000 FORMAT('1')
 2004 FORMAT('  RUN AND EVENT HAS NO ZVTX BANK ',2I5)
 2006 FORMAT(' RUN AND EVENT ',2I6,' HAS RETURN1 IN LGCALB')
 2010 FORMAT(' ***** ERROR IN USRED82 (INFORM PST), EVENT ',3I6)
      IF(
     - INDEX.EQ.0
     -)THEN
        CALL DBASE(0,IDBCHP)
        NRUN = 63
        NCALI = 1
        LUNITA(1) = 22
        LUNITA(2) = 0
        CALL R1MODE
        ISECLF= 25
        IPRN = 1
        IPFAST = 0
        IQHEAD = IBLN('HEAD')
        IQTRIG = IBLN('TRIG')
        IQALGN = IBLN('ALGN')
        IQZVTX = IBLN('ZVTX')
        IQJETC = IBLN('JETC')
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
        IQMPRS = IBLN('MPRS')
      DO 13000 I = 1,80
         IGG(I) = 0
        JIGG(I) = 0
13000 CONTINUE
13001 CONTINUE
        CALL HLIMIT(6000)
        CALL HBOOK1(111,'TRIGGER BITS (INPUT)      $', 50,0.,   50.)
        CALL HBOOK1(112,'TRIGGER BITS (TRCK-ACC)   $',100,0.,  100.)
        CALL HBOOK1(113,'TRIGGER BITS ACCEPTED     $',100,0.,  100.)
        CALL HBOOK1(1,'ZVERTEX (ALL)$',100,-2000.,2000.)
        CALL HBOOK1(2,'NHITS IN RING1 (ZVERTEX < 300 MMS)$', 50,0.,200.)
        CALL HBOOK1(3,'NUMBER OF TRACKS$',100,0.,50.)
        CALL HBOOK1(4,'LG ENERGY SUM (ALL)  $',100,0.02,40000.)
        CALL HBOOK1(5,'LG ENDCAP ENERGY (BAD BLOCKS) $',100,0.,40000.)
        CALL HBOOK1(  6,'TRACK CURVATURE           $', 50,  0., .010)
        CALL HBOOK1(7,'ZMIN (TRACKS)                 $', 50,  0.,1000.)
        CALL HBOOK1(8,'RMIN                          $', 50,  0., 300.)
        CALL HBOOK1(9,'     ACCEPTED TRACKS          $', 50,  0.,  25.)
        CALL HBOOK1(10,'REJECT INDEX                 $', 50,  0.,  50.)
        CALL HBLACK(0)
        PRINT2000
        INDEX=INDEX+1
        IF(.TRUE.) RETURN
      ENDIF
      IF(
     - INDEX.EQ.100
     -)THEN
      DO 13002 I = 2,80
        JIGG(I) = JIGG(I) + IGG(I)
13002 CONTINUE
13003 CONTINUE
        CALL STAT82
        CALL DBASE(3,IDBCHP)
      DO 13004 I = 1,80
        IGG(I) = JIGG(I)
13004 CONTINUE
13005 CONTINUE
        CALL STAT82
        CALL H1EVLI(    0)
        CALL HISTDO
        IF(.TRUE.) RETURN
      ENDIF
      IF(INDEX.GT.2 .AND. INDEX.LE.5) IGG(INDEX+2) = IGG(INDEX+2) + 1
16000 CONTINUE
      INDREJ = 0
      IZZZSE=INDEX
      GOTO 14002
14003 CONTINUE
      IF(
     - HHEADR(18).GT.NRUN
     -)THEN
              NRUN=HHEADR(18)
      IF(
     - NRUN.NE.IGG(1)
     -)THEN
                   CALL DBASE(2,IDBCHP)
                   IGG(3) = IGG(3) + 1
                   IF(IGG(4).NE.0) CALL STAT82
                   IGG(1) = NRUN
      DO 13006 I = 2,80
                        JIGG(I) = JIGG(I) + IGG(I)
                        IGG(I) = 0
13006 CONTINUE
13007 CONTINUE
                   PRINT 2007,IGG(1)
 2007              FORMAT(1H0/
     +             1X,10('='),20X,10('=')/
     +             1X,10('='),' START OF RUN ',I5,1X,10('=')/
     +             1X,10('='),20X,10('='))
      IF(
     - LBSTRT.EQ.0
     -)THEN
                        LBSTRT = 1
                        ZFITLM(1) = 70.
                        ZFITLM(2) = 35.
      ENDIF
                   CHOP=.FALSE.
                   IF(IGG(1).LT.NRUNST) CHOP=.TRUE.
      IF(
     - NOTTOT.NE.0
     -)THEN
      DO 13008 I=1,NOTTOT
                             IF(IGG(1).EQ.NOTRUN(I)) CHOP=.TRUE.
13008 CONTINUE
13009 CONTINUE
      ENDIF
                   CHOP = CHOP.OR.IDBCHP.NE.0
                   IF(CHOP) PRINT 2018,IGG(1)
 2018              FORMAT(
     +             1X,10('=')/
     +             1X,10('='),' RUN',I6, ' AXED'/
     +             1X,10('='))
      ENDIF
              INDEX=INDEX+1
              IF(.TRUE.) RETURN
      ELSE
      IF(
     - HHEADR(18).LT.NRUN .OR. HHEADR(18).EQ.63
     -)THEN
                   CHOP = .TRUE.
                   PRINT 2011, HHEADR(18)
 2011              FORMAT(' USRED82 .. RUN',I15,' RECORD ENCOUNTERED')
                   CALL DBASE(10,IDBCHP)
                   IF(.TRUE.) RETURN
      ELSE
                   CHOP = .FALSE.
                   PRINT 2020, NRUN
 2020              FORMAT(' USRED82 - CONTINUING WITH RUN',I15)
                   INDEX = 2
                   IF(.TRUE.) RETURN
      ENDIF
      ENDIF
      GOTO 14001
14004 CONTINUE
        INDEX = 1
        IF(HHEADR(18).EQ.NRUNST .AND. HHEADR(19).LT.NEVTST) RETURN
        IF(HHEADR(18).EQ.27987 .AND. HHEADR(19).EQ.5301) RETURN
        IF(HHEADR(18).EQ.27989 .AND. HHEADR(19).EQ.4893) RETURN
        IF(HHEADR(18).EQ.27989 .AND. HHEADR(19).EQ.5555) RETURN
        IF(HHEADR(18).EQ.27989 .AND. HHEADR(19).EQ.5965) RETURN
        IF(HHEADR(18).EQ.27990 .AND. HHEADR(19).EQ.  91) RETURN
        IF(CHOP) RETURN
        CALL DBASE(1,IDBCHP)
        IGG(4) = IGG(4) + 1
        INDREJ =  1
      IF(
     - HHEADR(20).GE.64
     -)THEN
      GOTO 16001
      ENDIF
        IERRLG = 0
        CALL LGCALB(&ERRLGC)
        CALL TRCK82(LBACC,LBTRB1,LBTRB2,IERRLG)
        LBTRBT = LBTRB1
        TRBIT = 0.
      DO 13010 I=1,32
          TRBIT = TRBIT + 1.
      IF(
     - TBIT(LBTRBT,31)
     -)THEN
            CALL HF1(111,TRBIT,1.)
      ENDIF
          LBTRBT = ISHFTR(LBTRBT,1)
          IF(I.EQ.16) LBTRBT = LBAT2M
13010 CONTINUE
13011 CONTINUE
        LBTRBT = LBAB2
        TRBIT = 0.
      DO 13012 I=1,48
          TRBIT = TRBIT + 1.
      IF(
     - TBIT(LBTRBT,31)
     -)THEN
            CALL HF1(112,TRBIT,1.)
      ENDIF
          LBTRBT = ISHFTR(LBTRBT,1)
          IF(I.EQ.32) LBTRBT = LBAB4
          IF(I.EQ.16) LBTRBT = LBAB8
13012 CONTINUE
13013 CONTINUE
        INDEX  =  4
        IF(AND(LBACC,2).NE.0) RETURN
        INDEX  =  4
        IF(AND(LBACC,4).NE.0) RETURN
        INDEX  =  4
        IF(AND(LBACC,8).NE.0) RETURN
        INDREJ =  4
        INDEX  = 11
      IF(
     - AND(LBACC,1).NE.0
     -)THEN
      GOTO 16001
      ENDIF
        INDREJ =  5
        INDEX  =  1
      GOTO 16001
14005 CONTINUE
        INDEX  = 11
        INDREJ = 11
      IF(
     - AND(LBACC,2).NE.0
     -)THEN
      GOTO 16001
      ENDIF
        INDEX  = 5
        IF(AND(LBACC,4).NE.0) RETURN
        INDEX = 1
        IPJCA  = IDATA(IQJETC)
        IPJCA2 = IPJCA*2
        NHITR1 = (HDATA(IPJCA2+27) - HDATA(IPJCA2+3)) / 4
        IPZV   = IDATA(IQZVTX)
        IF(IPZV.LE.0) WRITE(6,2004) HHEADR(18),HHEADR(19)
      IF(
     - IPZV.GT.0
     -)THEN
          IFLAG  = IDATA(IPZV+6)
          ZVTX   = ADATA(IPZV+1)
          PEAK   = ADATA(IPZV+4)
          IGG(IFLAG+27) = IGG(IFLAG+27) + 1
      IF(
     - IFLAG.LT.3
     -)THEN
            INDREJ = 12
      GOTO 16001
      ELSE
            CALL HF1(1,ZVTX,1.)
      IF(
     - ABS(ZVTX).LE.300.
     -)THEN
              ANHTR1 = NHITR1
              CALL HF1(2,ANHTR1,1.)
      ELSE
              INDREJ = 13
      GOTO 16001
      ENDIF
      ENDIF
      ELSE
          INDREJ = 14
      GOTO 16001
      ENDIF
        INDEX = 5
        RETURN
14006 CONTINUE
        INDEX = 1
        IPPATR = IDATA(IQPATR)
        IF(IPPATR.LE.0) PRINT2005,HHEADR(18),HHEADR(19)
 2005   FORMAT('  RUN AND EVENT HAS NO PATR BANK ',2I5)
        INDREJ = 21
        IPPATR = IDATA(IQPATR)
        IF(IPPATR.LE.0) LBACC = OR(LBACC,32)
      IF(
     - IPPATR.LE.0
     -)THEN
      GOTO 16001
      ENDIF
        INDEX = 1
        NTR    = IDATA(IPPATR+2)
        LDTR   = IDATA(IPPATR+3)
        IPTR0  = IPPATR + IDATA(IPPATR+1)
        IPTR9  = IPTR0 + (NTR-1)*LDTR
        ANTR = NTR
        CALL HF1(3,ANTR,1.)
      IF(
     - NTR.LE.0
     -)THEN
          INDREJ = 22
      GOTO 16001
      ENDIF
      IF(
     - AND(LBAB4,MKMUT1).NE.0
     -)THEN
          FACC = 0
          TRAC = 0
          LBSHRT = 0
          IF(AND(LBACC,4).NE.0) LBSHRT = 1
          XO = 0.
          YO = 0.
          ZMIN  = 100000.
          RMIN0 = 100000.
      DO 13014 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+24).GT.LIMHFW
     -)THEN
              FACC = OR(FACC,1)
              CRV = ABS(ADATA(IPTR+25))
              CALL HF1(6,CRV,1.)
      IF(
     - CRV .LE..00150
     -)THEN
                FACC = OR(FACC,2)
                AZV = ABS(ADATA(IPTR+31))
                ZMIN = AMIN1(AZV,ZMIN)
      IF(
     - AZV .LT. 300.  .OR.  LBSHRT .NE. 0
     -)THEN
                  FACC = OR(FACC,4)
                  CALL DRTRCK(IPTR,XO,YO,RMIN)
                  RMIN = ABS(RMIN)
                  RMIN0 = AMIN1(RMIN0,RMIN)
      IF(
     - ABS(RMIN).LT.   50.
     -)THEN
                    TRAC = TRAC + 1.
                    FACC = OR(FACC,8)
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13014 CONTINUE
13015 CONTINUE
      ELSE
          FACC = 0
          TRAC = 0
          LBSHRT = 0
          IF(AND(LBACC,4).NE.0) LBSHRT = 1
          XO = 0.
          YO = 0.
          ZMIN  = 100000.
          RMIN0 = 100000.
      DO 13016 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+24).GT.LIMHIT
     -)THEN
              FACC = OR(FACC,1)
              CRV = ABS(ADATA(IPTR+25))
              CALL HF1(6,CRV,1.)
      IF(
     - CRV .LE..00150
     -)THEN
                FACC = OR(FACC,2)
                AZV = ABS(ADATA(IPTR+31))
                ZMIN = AMIN1(AZV,ZMIN)
      IF(
     - AZV .LT. 300.  .OR.  LBSHRT .NE. 0
     -)THEN
                  FACC = OR(FACC,4)
                  CALL DRTRCK(IPTR,XO,YO,RMIN)
                  RMIN = ABS(RMIN)
                  RMIN0 = AMIN1(RMIN0,RMIN)
      IF(
     - ABS(RMIN).LT.   50.
     -)THEN
                    IF(TRAC.GT.0.) FACC = OR(FACC,8)
                    TRAC = TRAC + 1.
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13016 CONTINUE
13017 CONTINUE
      ENDIF
        CALL HF1(7,ZMIN ,1.)
        CALL HF1(8,RMIN0,1.)
        IF(TRAC.GT. 8.) TRAC =  8.
        IF(AND(LBACC,4).NE.0) TRAC = TRAC + 10.
        CALL HF1(9,TRAC,1.)
      IF(
     - AND(FACC,8).EQ.0
     -)THEN
          INDREJ = 23
          IF(AND(FACC,1).NE.0) INDREJ = 24
          IF(AND(FACC,2).NE.0) INDREJ = 25
          IF(AND(FACC,4).NE.0) INDREJ = 26
          INDEX = 1
      GOTO 16001
      ENDIF
        INDREJ = 30
        INDEX  = 11
      GOTO 16001
14002 CONTINUE
      GOTO(
     -14003,14004,14000,14005,14006
     -), IZZZSE
14000 CONTINUE
        PRINT 2010, HHEADR(18),HHEADR(19),INDEX
        INDEX = 1
        RETURN
14001 CONTINUE
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16000
16001 CONTINUE
      IF(
     - INDEX.EQ.11 .AND. AND(LBACC,14).NE.0
     -)THEN
      IF(
     - IDATA(IQJETC).GT.0
     -)THEN
          IPFAST = 2
          CALL INPATR
          CALL PATREC(0)
          IPPATR = IDATA(IQPATR)
          IPJHTL = IDATA(IQJHTL)
      IF(
     - IPPATR.NE.0 .AND. IDATA(IPPATR-2).EQ.10
     -)THEN
            IDATA(IPPATR-2) = 9
            IF(IPJHTL.NE.0 .AND. IDATA(IPJHTL-2).EQ.10)IDATA(IPJHTL-2)=900058800
      ENDIF
          CALL BDLS('PATR',10)
          CALL BDLS('JHTL',10)
          IPFAST = 0
          CALL INPATR
          ZFITLM(1) = 70.
          ZFITLM(2) = 35.
      ENDIF
      ENDIF
      IWRT = 0
      IF(
     - INDEX.EQ.11
     -)THEN
        IPHEAD = IDATA(IQHEAD)*2
        IF(AND(LBACC, 2).NE.0) IWRT = 1
        IF(AND(LBACC, 4).NE.0) IWRT = IWRT + 8
        IF(AND(LBACC, 8).NE.0) IWRT = IWRT +16
        IF(IPHEAD.GT.0) HDATA(IPHEAD+27) = IWRT
        LBTRBT = LBAB2
        TRBIT = 0.
      DO 13018 I=1,48
          TRBIT = TRBIT + 1.
          IF(TBIT(LBTRBT,31)) CALL HF1(113,TRBIT,1.)
          LBTRBT = ISHFTR(LBTRBT,1)
          IF(I.EQ.32) LBTRBT = LBAB4
          IF(I.EQ.16) LBTRBT = LBAB8
13018 CONTINUE
13019 CONTINUE
      ENDIF
      IF(INDEX.EQ.11) IGG( 10) = IGG( 10) + 1
      ANDREJ = INDREJ
      CALL HF1(10,ANDREJ,1.)
      IF(INDREJ.GT.0) IGG(INDREJ+10) = IGG(INDREJ+10) + 1
      IF(IWRT  .GT.0) IGG(IWRT+50) = IGG(IWRT+50) + 1
      IMPRT=IDATA(IQMPRS)
      IF(
     - IMPRT.GT.0.AND.INDEX.EQ.11
     -)THEN
        IRFLAG=HDATA(2*IMPRT+3)
        IF(AND(IRFLAG,4).NE.0) IGG(49)=IGG(49)+1
        IF(AND(IRFLAG,8).NE.0) IGG(50)=IGG(50)+1
      ENDIF
      RETURN
17000 CONTINUE
        IGG( 9) = IGG( 9) + 1
        IF(IGG( 9).LT.20.AND.IPRN.GT.0) PRINT2006,HHEADR(18),HHEADR(19)
        IERRLG = 1
      END

C   18/07/80 301061237  MEMBER NAME  REDTVA   (JADEGS)      FORTRAN
      SUBROUTINE REDTVA(LWRIT,LRJCT,IWRT,IFTG,IAC,IFLW,IPRN)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C---     SPECIAL VERSION FOR SECOND DATA REDUCTION STEP
C---     *****  THIS IS THE GRAPHICS VERSION **********
C--  IPRN IS THE PRINT INDEX
C--   J.OLSSON    09.07.79        LAST CHANGE 07.08.81
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CREDTV/ CRVLIM,LMHITS,RPLIM,RPLIM1,RATLIM,COSCUT,ZVTXLM,
     $ ZVXLM1,ZVXLM2,ETOTLM,ETOTKP,ETCYKP,ETE1KP,ETE2KP,ZMLIM,FIDEL,
     $ XLM,YLM,ZLM,ERGL,ETAGLM,ETOTCT,TSUMC1,TSUMC2
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
      COMMON /CHEADR/ HEAD(108)
      EQUIVALENCE (HRUN,HEAD(18)),(HEVENT,HEAD(19))
#include "cdata.for"
#include "cgeo1.for"
      COMMON /CJTRIG/ PI,TWOPI
      DIMENSION HELP(2),HELP2(2),THHELP(3)
      EQUIVALENCE (ICAMWD,HELP(1)),(HELP2(1),ICMWD2)
      DATA MSKLUM /Z102/,HRUNTP/-4/,EBMSTR/0./,MKFWMU /Z800/,MKFWM1/Z80/
      DATA MSKLM1 /Z100/,HRUNTP/-4/,EBMSTR/0./,MKFWMU /Z800/,MKFWM1/Z80/
      DATA  HELP/0,0/,HELP2/0,0/,NRUNOL/-1/,IENT /0/
C--------------------------------------------
C---
C  IHIST FOR HISTOGRAMS;   IPRN FOR DEBUG PRINT;
C  ICALIB FOR RECALIBRATION OF LEAD GLASS, ICALJC FOR INNER DETECTOR
C  IREPAT FOR PATTERN RECOGNITION, WITH FOLLOWING OPTIONS:
C  1: SLOW FOR ALL, 2 EXISTING ONE FOR SELECT, REDO SLOW
C  3: FAST FOR ALL, REDO SLOW FOR SELECTED EVENTS;  0 FOR NO PATREC
C                                    BEGIN OF EACH RUN
      IENT = IENT + 1
      IF(IENT.NE.1) GO TO 7575
      PI=ARCOS(-1.)
      TWOPI = 2.*PI
      IQHEAD = IBLN('HEAD')
7575  IPHEAD=IDATA(IQHEAD)
      CALL MVCL(HEAD(1),0,IDATA(IPHEAD-3),0,216)
      NRUN = HEAD(18)
      IF(NRUN.EQ.NRUNOL) GO TO 1021
      NRUNOL = NRUN
      IF(IPRN.GT.0) WRITE(6,102) HRUN,HEVENT,HEAD(20)
102   FORMAT(' ****** RUN ',I5,' EVENT ',I8,' REC.TYPE ',I8)
      EBM = EBEAM(HRUN)
      IF(EBM.GT.2.*EBMSTR) GO TO 1612
      IF(EBM.LT..5*EBMSTR) GO TO 1612
      GO TO 1021
1612  EBMSTR = EBM
C DECIDE BEAM ENERGY AND LIMITS
      IF(EBM.GT.7000.) GO TO 1029
C ENTER HERE FOR    NEW LIMITS   FOR 12 GEV DATA
      WRITE(6,1671) HRUN,HEVENT,EBM
1671  FORMAT(' LOW ENERGY DATA, RUN EVENT ',2I8,' EBEAM ',E12.4)
      ETOTKP = 2500.
      ETCYKP = 1250.
      ETE1KP = 1500.
      ETE2KP = 500.
      RPLIM = 40.
      RPLIM1 = 15.
      GO TO 1024
C ENTER HERE FOR    NEW LIMITS   FOR HIGH ENERGY DATA
1029  WRITE(6,1672) HRUN,HEVENT,EBM
1672  FORMAT(' HIGH ENERGY DATA ,RUN EVENT ',2I8,' EBEAM ',E12.4)
      ETOTKP = 7000.
      ETCYKP = 3500.
      ETE1KP = 4000.
      ETE2KP = 500.
      RPLIM = 30.
      RPLIM1 = 10.
1024  CONTINUE
C1024  WRITE(6,1022)
C1022  FORMAT(' ZVTXLM  LMHITS  ETOTKP  ETOTCT  ETAGLM  COSCUT   ZMLIM
C     $RPLIM  RPLIM1  RATLIM  CRVLIM  ZVXLM1  ZVXLM2')
C     WRITE(6,1023) ZVTXLM,LMHITS,ETOTKP,ETOTCT,ETAGLM,COSCUT,ZMLIM,
C    $ RPLIM,RPLIM1,RATLIM,CRVLIM,ZVXLM1,ZVXLM2
C1023  FORMAT(' ',F6.1,I8,F8.1,F8.1,F8.1,F8.1,F8.1,F8.3,F8.3,F8.3,F8.5,
C    $ F8.1,F8.1)
C      WRITE(6,1027) ETCYKP,ETE1KP,ETE2KP,TSUMC1,TSUMC2
C1027  FORMAT(' ETCYKP  ETE1KP  ETE2KP  ',3F8.1,' TSUMC1-2 ',2F8.1)
C                                                         SELECT EVENT
1021  ZVTX = -600.
      IFLAG=-1
      LRJCT = 0
      LWRIT = 0
      CALL RDATA(IER,HEAD(18))
      IF(IER.NE.0) GO TO 1752
      IF(HEAD(20).EQ.1.OR.HEAD(20).EQ.13) GO TO 1751
      IF(HEAD(20).GE.64) GO TO 1752
      IF(HRUNTP.NE.HRUN) WRITE(6,1753) HRUN,HEAD(20)
1753  FORMAT(' * * * * RUN NR ',I8,'   HAS RECORD TYPE ',I8)
      HRUNTP = HRUN
      GO TO 1751
1752  LRJCT = 16
      IF(IPRN.GT.0) WRITE(6,2490) HRUN,HEVENT,HEAD(20)
2490  FORMAT(' REJECTED AS NOT BEING DATA, RUN&EVENT ',2I8,' TYPE ',I8)
      GO TO 1
C--- EVENT NOT REAL DATA  ------------------------>>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 16      ***
C                                              ************************
1751  ISTAR = 0
      NTR= 0
C   OVERFLOW MARKER
      IFLW= 0
      IF(HEAD(23).NE.0) IFLW = 1
C
C     RECALIBRATION HERE IF REQUESTED, PARAMETER ICALIB
C
C                                           LEAD GLASS CALIBRATION DONE
CALL TRIGGER CHECK, USED IN REDUC1
C     LBTRBT = 0
C     IPTRIG = IDATA(IBLN('TRIG'))
C     IF(IPTRIG.EQ.0) GO TO 3011
C     IF(IDATA(IPTRIG-2).NE.1) GO TO 3011
C     LBTRBT = HDATA(2*IPTRIG  + 10)
C     CALL TRGCHK(LBTRCK,LBTRBT,IPRN)
C     IF(IPRN.GT.0) WRITE(6,3012) LBTRCK,LBTRBT
C3012  FORMAT(' TRGCHK RETURN : LBTRCK AND LBTRBT ',I8,1X,Z4)
C      IF(LBTRCK.NE.0) GO TO 3011
C      LRJCT = 18
C      IF(IPRN.GT.0) WRITE(6,3211) HRUN,HEVENT
C3211  FORMAT(' REJECTED BY THE TRIGGER CHECK, RUN EVENT ',2I8)
C      GO TO 1
C--- TRIGGER CHECK NOT OK ------------------------>>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 18      ***
C                                              ************************
3011  CALL ERGTOT(ECYL,ECAMI,ECAPL)
      ETOT = ECYL + ECAMI + ECAPL
      IF(ETOT.GT.ETOTCT) GO TO 305
C THIS CHECK IS TO SEPARATE EVENTS OUT FOR LUMI CHECK
      ITRG = IDATA(IBLN('TRIG'))
      IF(ITRG.GT.0) GO TO 327
      WRITE(6,326) HEAD(18),HEAD(19)
326   FORMAT(' RUN & EVENT ',2I8,'  NO TRIGGER BANK ')
      GO TO 305
327   IF(IDATA(ITRG-2).EQ.1) GO TO 328
      WRITE(6,325) HEAD(18),HEAD(19)
325   FORMAT(' RUN & EVENT ',2I8,'  FIRST TRIGGER BANK NOT NR 1 ')
      GO TO 305
328   HELP(2) = HDATA(2*ITRG + IDATA(ITRG)*2)
      IF(ICAMWD.NE.MSKLUM.AND.ICAMWD.NE.MSKLM1) GO TO 305
C--- ENERGY < 100 MEV   LUMI TRIGGER ------------->>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 1       ***
C                                              ************************
      LRJCT = 1
      IF(IPRN.GT.0) WRITE(6,3501) HRUN,HEVENT
3501  FORMAT(' REJECTED AS LUMI TRIGGER   RUN EVENT ',2I8)
      GO TO 1
C  SET FLAG FOR ENERGY IN FORWARD TAGGING BLOCKS
C            IFTG < 11     NO ENERGY
C            IFTG = 11     ENERGY ABOVE LIMIT IN NEG. FW ARM
C            IFTG = 12     ENERGY ABOVE LIMIT IN POS. FW ARM
C            IFTG = 113,13 ENERGY ABOVE LIMIT IN BOTH FW ARMS(LUMI)
305   CALL TAGFLG(IFTG)
      IAC = 0
      IF(ETOT.GT.ETOTKP) IAC = 1
      IF(ECYL.GT.ETCYKP) IAC = 1
      IF(ECAMI.GT.ETE1KP.AND.ECYL.GT.ETE2KP) IAC = 1
      IF(ECAPL.GT.ETE1KP.AND.ECYL.GT.ETE2KP) IAC = 1
C
C TEST HERE WHETHER ALL THE ENERGY (95 %) SITS IN ONE ENDCAP BLOCK.
C IF SO, MARK IT WITH IAC = -1
C PERFORM THIS TEST ONLY IF TOTAL ENERGY HIGHER THAN ETOTLM.
C
      IF(ETOT.LT.ETOTLM) GO TO 301
      IF(ECAMI/ETOT.GT..95.OR.ECAPL/ETOT.GT..95) GO TO 302
      GO TO 301
C CHECK WHETHER MORE THAN 95 % OF ENERGY IN ONE ENDCAP BLOCK
302   IPJ=IDATA(IBLN('ALGN'))
      IF(IPJ.LE.0) GO TO 301
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 301
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
      DO 303 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      IF(IAD.LE.2687) GO TO 303
C TEST HERE TO EXCLUDE EDGE BLOCKS FROM THE CHECK
C     REDUCE TO NUMBERS 1 - 192
      NO = IAD - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (NO - 1)/96
C     REDUCE TO 1 - 96
      NO = NO - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (NO - 1)/24
C     REDUCE TO 1 - 24
      NO = NO - NQ*24
      IF(NO.LT.5) GO TO 303
      IF(NO.GT.15.AND.NO.NE.20) GO TO 303
C BLOCK NOT AT EDGE, CHECK FURTHER:
      ETEST = HDATA(IJK)
      IF(ETEST/ETOT.LT..95) GO TO 303
      WRITE(6,3002) HEAD(18),HEAD(19),IAD,ETEST,ETOT
3002  FORMAT(' RU&EV '2I8,' BLOCK',I5,' WITH ENERGY&ETOT ',2E12.4)
      IAC = -1
      GO TO 301
303   CONTINUE
301   CONTINUE
CHECK HERE IF IFLW SET, IF SO CHECK IF DUE TO MASSIVE BAD LEAD GLASS
C           OR TO PICKUP EVENT WITH MORE THAN 1200 ID HITS
      IF(IFLW.EQ.0) GO TO 3087
      IDHITS = 0
      IPJETC = IDATA(IBLN('JETC'))
      IF(IPJETC.EQ.0) GO TO 3087
      IPJETC = 2*(IPJETC+1)
      IDHITS = (HDATA(IPJETC+97) - HDATA(IPJETC+1))/4
      IF(IDHITS.GT.800.AND.IDHITS.LT.1200) GO TO 3087
CHECK FIRST IF OVERFLOW EVENT HAS > 1200 HITS AND NO E,THEN REJECT EVENT
      IF(IDHITS.LE.800) GO TO 3057
      IF(ETOT.GT.500.) GO TO 3087
      WRITE(6,3058) HEAD(18),HEAD(19),IDHITS,ETOT
3058  FORMAT(' ** OVERFLOW RUN EVENT ',2I8,' I.D. HITS & ETOT ',I6,
     $ E12.4)
C                                 ---------------->>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 15      ***
C                                              ************************
      LRJCT = 15
      GO TO 1
3057  IPALGL = IDATA(IBLN('ALGL'))
      IPALGN = IDATA(IBLN('ALGN'))
      IF(IPALGL.GT.0.AND.IPALGN.GT.0) GO TO 3085
      WRITE(6,3084) HEAD(18),HEAD(19)
3084  FORMAT(' RUN&EV,  ALGL AND ALGN DO NOT EXIST ',2I8)
      GO TO 3087
3085  LALGL = IDATA(IPALGL)
      LALGN = IDATA(IPALGN)
      IF(LALGL.GT.10*LALGN) IFLW = 0
      IF(LALGL.GT.10*LALGN.AND.IPRN.GT.0) WRITE(6,4430) HRUN,HEVENT
4430  FORMAT(' RUN EVENT RESET FOR OVERFLOW IN PBG ',2I8)
C  SET FLAG FOR LOW OR BAD ENERGY, OVERFLOW, TAGGING
3087  IWRT = 1
      IF(IAC.LE.0.AND.IFLW.EQ.0.AND.(IFTG.LT.11.OR.ETOT.LT.ETAGLM))
     $ IWRT = 0
C                                                     ZVERTEX CALCULATED
      IPZV = IDATA(IBLN('ZVTX'))
      IF(IPZV.LE.0) GO TO 401
      IFLAG  = IDATA(IPZV+6)
      IF(IFLAG.LT.0) GOTO 401
      ZVTX   = ADATA(IPZV+1)
C                                 ---------------->>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 2       ***
C                                              ************************
      IF(ABS(ZVTX).GT.ZVTXLM.AND.IWRT.NE.1.AND.IFLAG.GT.1) LRJCT = 2
      IF(IPRN.GT.0.AND.LRJCT.EQ.2) WRITE(6,1484) HRUN,HEVENT
1484  FORMAT(' REJECTED FOR BAD ZVERTEX, NO WRITE FLAG  ',2I8)
      IF(LRJCT.EQ.2) GO TO 1
      IF(ABS(ZVTX).GT.ZVXLM1.AND.IFLAG.EQ.3.AND.ECAMI.LT..05*ETOT.AND.
     $ ECAPL.LT..05*ETOT) IAC = 0
      IWRT = 1
      IF(IAC.LE.0.AND.IFLW.EQ.0.AND.(IFTG.LT.11.OR.ETOT.LT.ETAGLM))
     $ IWRT = 0
C                                                       PATREC PERFORMED
C401   CALL REDONE(INDRJ1,KBWRT1,KWRT)
C                                 ---------------->>>>  * REJECT *  <<<<
C                                                    ******************
C                                                    *   LRJCT = 17   *
C                                                    ******************
C      IF(IPRN.GT.0) WRITE(6,1881) INDRJ1,KBWRT1,KWRT
C1881  FORMAT(' REDUC1   INDREJ,KBWRT,KWRT ',3I4)
C      IF(KBWRT1.EQ.0) LRJCT = 17
C      IF(LRJCT.EQ.17.AND.IPRN.GT.0) WRITE(6,5090) HRUN,HEVENT
C5090  FORMAT(' REJECTED BY REDUC1  RUN EVENT ',2I8)
C      IF(LRJCT.EQ.17) GO TO 1
C
401   IPPATR = IDATA(IBLN('PATR'))
C IF NO PATR BANK, PROCEED TO CLUSTER CHECK   (NTR = 0 AT READ EVENT)
      IF(IPPATR.EQ.0) GO TO 503
      LO = IDATA(IPPATR+1)
      NTR = IDATA(IPPATR+2)
      LTR = IDATA(IPPATR+3)
C                                        ************* WRITTEN *********
      IF(NTR.EQ.0.AND.IFTG.GT.10.AND.ETOT.GT.50.) LWRIT = 7
      IF(IPRN.GT.0.AND.LWRIT.EQ.7) WRITE(6,5230) HRUN,HEVENT
5230  FORMAT('  NEUTRAL TAGGED EVENT, ENERGY > 50 MEV ',2I8)
C                                         --------------------------
C                                       --        LWRIT = 7         --
C                                         --------------------------
      IF(LWRIT.EQ.7) GO TO 11
C
      IF(NTR.EQ.0) GO TO 503
      IF(IFTG.GT.10) GO TO 562
      IF(IFLAG.NE.3) GO TO 562
C HERE CHECK EVENTS WITH HIGH ENERGY IN CYLINDER AND ZVTX GT 200.
C  THEY ARE PASSED ON TO NORMAL TRACK CHECK
      IF(ABS(ZVTX).GT.ZVXLM2.AND.ECAMI.LT..05*ETOT.AND.ECAPL.LT..05*ETOT
     $ ) GO TO 578
C  WRITE  1-PRONG  TAGGED EVENTS
C                                        ************* WRITTEN *********
C                                              ------------------------
C                                             ---    LWRIT = 9       ---
C                                              ------------------------
562   IF(NTR.EQ.1.AND.IFTG.GT.10) LWRIT = 9
      IF(LWRIT.EQ.9.AND.IPRN.GT.0) WRITE(6,5460) HRUN,HEVENT
5460  FORMAT(' ONE PRONG TAGGED EVENT   RUN EVENT ',2I8)
      IF(LWRIT.EQ.9) GO TO 11
C NOW WRITE ALL EVENTS WITH THE WRITE FLAG IWRT SET
C                                        ************* WRITTEN *********
      IF(IWRT.EQ.1) LWRIT = 1
      IF(LWRIT.EQ.1.AND.IPRN.GT.0) WRITE(6,5461) HRUN,HEVENT
5461  FORMAT(' EVENT WITH WRITE FLAG    RUN EVENT ',2I8)
C                                         --------------------------
C                                       --        LWRIT = 1         --
C                                         --------------------------
      IF(IWRT.EQ.1) GO TO 11
C-
C-
578   IO = IPPATR
      IO = IO + LO - LTR
C  EVENTS ARE HERE DIVIDED INTO THREE CLASSES : ISTAR = 0,1,2
C    ISTAR = 0 HAS ONLY SHORT TRACKS   (NR OF ZHITS < LMHITS)
C    ISTAR = 2 HAS LONG AND WEAK TRACKS
C    ISTAR = 1 HAS AT LEAST ONE LONG FAST TRACK
C    ONLY ISTAR = 1 EVENTS UNDERGO SERIOUS TRACK CHECKS
C
      ICNTR = 0
      IGDNTR = 0
      ICNT = 0
      ISTAR = 0
      ICNTS = 0
      THESUM = 0.
501   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 502
      IO = IO + LTR
      IF(IDATA(IO+33).LE.LMHITS.AND.IDATA(IO+24).LE.LMHITS) GO TO 5027
      IF(ISTAR.EQ.0) ISTAR = 2
      CRV = ADATA(IO+25)
      AZV = ABS(ADATA(IO+31))
      IF(ABS(CRV).GT.CRVLIM) GOTO 5027
C         COMPUTE MINIMUM DISTANCE OF PARABOLA TO ORIGIN, RFI-PLANE
      ISTAR=1
      IGDNTR = IGDNTR + 1
      CALL
     $    PARMIN(ADATA(IO+19),ADATA(IO+20),ADATA(IO+21),ADATA(IO+22),RP,
     $ IDATA(IO+18))
      IF(RP.LT.RPLIM.AND.AZV.LT.ZMLIM) ICNTR = ICNTR + 1
      THE = ATAN(ADATA(IO+30))
      THE = PI*.5 - THE
      IF(NTR.EQ.3) THHELP(ICNT) = THE
      THESUM = THESUM + THE
      IF(RP.LT.RPLIM1.AND.AZV.LT.ZMLIM) ICNTS = ICNTS + 1
      GO TO 501
5027  IF(NTR.NE.3) GO TO 501
      THE = ATAN(ADATA(IO+30))
      THE = PI*.5 - THE
      THHELP(ICNT) = THE
      GO TO 501
502   IF(IPRN.GT.0) WRITE(6,5990) ISTAR
5990  FORMAT(' ISTAR = ',I7)
      IF(ISTAR.EQ.1) GO TO 5035
C-----------------------------------------------------------------------
C    PROCEED TO CLUSTER CHECK      THESE EVENTS HAVE NO FAST TRACKS
      GO TO 503
C-----------------------------------------------------------------------
C
C  ONLY ISTAR = 1 EVENTS PASS THE FOLLOWING TESTS
C
C NOW COMPUTE RATIO BETWEEN TOTAL GOOD TRACKS (STAR = 1 TRACKS) AND
C TRACKS CLOSE TO THE WWP (GIVEN BY RPLIM AND ZMLIM)
C
5035  RATIO = FLOAT(ICNTR)/FLOAT(IGDNTR)
C
C  SEPARATE EVENTS WITH RATIO > RATLIM AND   EVENTS WITH RATIO < RATLIM
C
      IF(RATIO.GT.RATLIM) GO TO 517
      IF(RATIO.GT..5*RATLIM.AND.IGDNTR.GT.6) GO TO 517
C
C HERE FOR EVENTS WHICH DO NOT PASS RATIO CHECK - - - - - - - - - - -
C   NOW REJECT EVENTS IF
C                     OR GOOD ZVERTEX OUTSIDE LIMITS AND >3 GOOD TRACKS
C                     OR RATIO = 0.   AND >10 GOOD TRACKS
      IF(IFLAG.GT.0.AND.ABS(ZVTX).GT.ZVTXLM.AND.IGDNTR.GT.3) LRJCT = 3
      IF(LRJCT.EQ.3.AND.IPRN.GT.0) WRITE(6,6330) HRUN,HEVENT
6330  FORMAT(' REJECTED: BAD RATIO,ZV>LIM, IGDNTR>3  RUN EV. ',2I8)
      IF(LRJCT.EQ.3) GO TO 5038
      IF(RATIO.EQ.0..AND.IGDNTR.GT.10) LRJCT = 4
      IF(LRJCT.EQ.4.AND.IPRN.GT.0) WRITE(6,6331) HRUN,HEVENT
6331  FORMAT(' REJECTED: RATIO=0.,IGDNTR>10,  RUN EV. ',2I8)
      IF(LRJCT.EQ.4) GO TO 5038
      IF(NTR.EQ.2) GO TO 4923
      IF(NTR.EQ.3) GO TO 517
C   OTHERWISE PROCEED TO CLUSTER CHECK
      GO TO 503
C-----------------------------------------------------------------------
C                                        >>>>>>>>>>> REJECT <<<<<<<<<
C                                              ************************
C                                             ***    LRJCT = 3 AND 4 ***
C                                              ************************
5038  GO TO 1
C-----------------------------------------------------------------------
C
C FOR TWOPRONG COSMIC CANDIDATES, PERFORM TOF CHECK AND
C                   PERFORM SPECIAL INTERACTION POINT TEST  (.5*RPLIM )
517   IF(NTR.NE.3) GO TO 5217
      ICOSM = 0
      ABS12 = ABS(THHELP(1)+THHELP(2)-PI)
      ABS13 = ABS(THHELP(1)+THHELP(3)-PI)
      ABS23 = ABS(THHELP(2)+THHELP(3)-PI)
      ABSM12 = ABS(THHELP(1)-THHELP(2))
      ABSM13 = ABS(THHELP(1)-THHELP(3))
      ABSM23 = ABS(THHELP(2)-THHELP(3))
      IF(IPRN.GE.2) WRITE(6,7574) ABS12,ABS13,ABS23,ABSM12,ABSM13,ABSM2300040500
7574  FORMAT(' ABS12 13 23 ABSM ',6F8.4)
      IF(ABS12.LT..25.AND.(ABSM13.LT..31.OR.ABSM23.LT..31)) GO TO 4924
      IF(ABS13.LT..25.AND.(ABSM23.LT..31.OR.ABSM12.LT..31)) GO TO 4924
      IF(ABS23.LT..25.AND.(ABSM13.LT..31.OR.ABSM12.LT..31)) GO TO 4924
      IF(RATIO.LT.RATLIM) GO TO 503
C---------------------------------------------******* WRITTEN **********
5217  IF(NTR.NE.2) LWRIT = 2
C                                         --------------------------
C                                       --        LWRIT = 2         --
C                                         --------------------------
      IF(LWRIT.EQ.2.AND.IPRN.GT.0) WRITE(6,6710) HRUN,HEVENT
6710  FORMAT(' WRITTEN AS GOOD RATIO NOT FEWPRONG  RUN EVENT ',2I8)
      IF(LWRIT.EQ.2) GO TO 11
C
4923  ICOSM = 0
C TEST ON COLLINEARITY IN THETA
      ABSTHE = ABS(THESUM-PI)
C---------------------------------------------******* WRITTEN **********
      IF(ABSTHE.GT..25.AND.RATIO.GT.RATLIM) LWRIT = 3
C                                         --------------------------
C                                       --        LWRIT = 3         --
C                                         --------------------------
      IF(LWRIT.EQ.3.AND.IPRN.GT.0) WRITE(6,6711) HRUN,HEVENT
6711  FORMAT(' WRITTEN AS GOOD RATIO  NONCOLL.   RUN EVENT ',2I8)
      IF(LWRIT.EQ.3) GO TO 11
      IF(ABSTHE.GT..25) GO TO 503
C
C PERFORM TOF TEST ONLY IF ETOT < 800 MEV, TO AVOID BREMS STRAHLUNG
4924  IF(ETOT.GT.800.) GO TO 5123
      ICOSM = 1
C
C SPECIALLY HARD CHECK FOR COSMIC CANDIDATES ( TWOPRONG )
CHECK TOF FOR COSMIC.  CODE TAKEN FROM NORD 50; P.DITTMANNS PROGRAM
4925  CALL TOFCHK(TDIF,TSUM,NRUN)
      NCOSM = 0
C TIME IN NANOSECONDS
C-----------------------------------------------------------------------
C                                        >>>>>>>>>>>> REJECT <<<<<<<<<<<
      IF(TDIF.GT.COSCUT.AND.TSUM.GT.TSUMC1) NCOSM = 1
      IF(TDIF.GT.COSCUT.AND.TSUM.LT.TSUMC2) NCOSM = 1
      IF(NCOSM.EQ.1) LRJCT = 5
C                                              ************************
C                                             ***    LRJCT = 5       ***
C                                              ************************
      IF(NCOSM.EQ.1.AND.IPRN.GT.0) WRITE(6,7131) HRUN,HEVENT
7131  FORMAT(' REJECTED AS COSMIC COLLINEAR ',2I8)
      IF(NCOSM.EQ.1) GO TO 1
C-----------------------------------------------------------------------
C    NEW RATIO FOR COSMIC CANDIDATES      EXTRA STRONG DEMAND ON RPLIM
5123  IF(IFLAG.LT.0) GO TO 5031
C-----------------------------------------------------------------------
C---------------------------------------------******* WRITTEN **********
5031  IF(ICNTS.GT.0) LWRIT = 4
C                                         --------------------------
C                                       --        LWRIT = 4         --
C                                         --------------------------
      IF(ICNTS.GT.0.AND.IPRN.GT.0) WRITE(6,7132) HRUN,HEVENT
7132  FORMAT(' WRITTEN AS NO COSMIC, GOOD RATIO ',2I8)
      IF(ICNTS.GT.0) GO TO 11
C-----------------------------------------------------------------------
C    NOW REJECT FAILING RATIO EVENTS
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      LRJCT = 6
      IF(IPRN.GT.0) WRITE(6,7133) HRUN,HEVENT
7133  FORMAT(' REJECTED AS NO COSMIC BAD RATIO ',2I8)
C                                              ************************
C                                             ***    LRJCT = 6       ***
C                                              ************************
      GO TO 1
C-----------------------------------------------------------------------
C                                    CLUSTER ANALYSIS PERFORMED
503   IPCL = IDATA(IBLN('LGCL'))
C-----------------------------------------------------------------------
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF (IPCL.EQ.0) LRJCT = 7
C                                              ************************
C                                             ***    LRJCT = 7       ***
C                                              ************************
      IF(IPCL.EQ.0.AND.IPRN.GT.0) WRITE(6,7134) HRUN,HEVENT
7134  FORMAT(' REJECTED NO CLUSTER BANK    ',2I8)
      IF (IPCL.EQ.0) GO TO 1
      IER = IDATA(IPCL+20)
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(IER.NE.0) LRJCT = 8
C                                              ************************
C                                             ***    LRJCT = 8       ***
C                                              ************************
      IF(IER.NE.0.AND.IPRN.GT.0) WRITE(6,7135) HRUN,HEVENT
7135  FORMAT(' REJECTED ERROR FLAG IN CLUSTER BANK  ',2I8)
      IF(IER.NE.0) GO TO 1
      NCLST = IDATA(IPCL+7)
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(NCLST.LE.1) LRJCT = 9
      IF(LRJCT.EQ.9.AND.IPRN.GT.0) WRITE(6,7136) HRUN,HEVENT
7136  FORMAT(' REJECTED NCLST LE 1 ',2I8)
C                                              ************************
C                                             ***    LRJCT = 9       ***
C                                              ************************
      IF(LRJCT.EQ.9) GO TO 1
C-----------------------------------------------------------------------
C     IF(NCLST.LE.1) LWRIT = 8
C     IF(LWRIT.EQ.8.AND.IPRN.GT.0) WRITE(6,7137) HRUN,HEVENT
C7137  FORMAT(' WRITTEN  NCLST LE 1, ECAPS>50        ',2I8)
C                                         --------------------------
C                                       --        LWRIT = 8         --
C                                         --------------------------
C     IF(LWRIT.EQ.8) GO TO 1
C-----------------------------------------------------------------------
      EBM = EBEAM(HRUN)
      IF(NTR.NE.0) GO TO 519
C                ENTER HERE FOR EVENTS WITH NO TRACKS
      IALGN = IDATA(IBLN('ALGN'))
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(IALGN.EQ.0) LRJCT = 10
      IF(IALGN.EQ.0.AND.IPRN.GT.0) WRITE(6,7138) HRUN,HEVENT
7138  FORMAT(' REJECTED NO ALGN BANK     ',2I8)
C                                              ************************
C                                             ***    LRJCT = 10      ***
C                                              ************************
      IF(IALGN.EQ.0) GO TO 1
C- NEUTRAL EVENTS ARE NOW CHECKED FOR MOMENTUM BALANCE -----------------
      CALL HWORLD(IALGN,JEMPTY,UNBAL)
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(JEMPTY.GT.1.OR.UNBAL.LT..05) LRJCT = 11
      IF(LRJCT.EQ.11.AND.IPRN.GT.0) WRITE(6,7139) HRUN,HEVENT
7139  FORMAT(' REJECTED HWORLD IMBALANCE ',2I8)
C                                              ************************
C                                             ***    LRJCT = 11      ***
C                                              ************************
      IF(LRJCT.EQ.11) GO TO 1
C-----------------------------------------------------------------------
C
      IDHITS = 0
      IPJETC = IDATA(IBLN('JETC'))
      IF(IPJETC.EQ.0) GO TO 519
      IPJETC = 2*(IPJETC+1)
      IDHITS = (HDATA(IPJETC+97) - HDATA(IPJETC+1))/4
C-----------------------------------------------------------------------
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
C  NO TRACKS BUT MORE THAN 1000 HITS IN I.D.
5191  IF(IDHITS.GT.1000) LRJCT = 12
      IF(LRJCT.EQ.12.AND.IPRN.GT.0) WRITE(6,7140) HRUN,HEVENT
7140  FORMAT(' REJECTED NEUTRAL WITH IDHITS>1000 ',2I8)
C                                              ************************
C                                             ***    LRJCT = 12      ***
C                                              ************************
      IF(IDHITS.GT.1000) GO TO 1
C-----------------------------------------------------------------------
C  WRITE HERE NEUTRAL EVENTS WITH ETOT < 3.*EBM AND < 10 CLUSTERS
C---------------------------------------------******** WRITTEN *********
      IF(ETOT.LT.3.*EBM.AND.NCLST.LT.10) LWRIT = 6
      IF(LWRIT.EQ.6.AND.(ICAMWD.EQ.MKFWMU.OR.ICAMWD.EQ.MKFWM1))
     * LWRIT = 0
      IF(LWRIT.EQ.6.AND.IPRN.GT.0) WRITE(6,7141) HRUN,HEVENT
7141  FORMAT(' WRITTEN NTR=0, ETOT<3*EBM NCLST<10 ',2I8)
C                                         --------------------------
C                                       --        LWRIT = 6         --
C                                         --------------------------
      IF(LWRIT.EQ.6) GO TO 11
C--
519   IP3 = IDATA(IPCL+3)
      NPWCL = IDATA(IPCL+25)
      MARK = 0
      NNCL = NCLST - 1
C                          SEARCH HERE FOR COLLINEAR CLUSTERS
      DO 610  I = 1,NNCL
      IB1 = IPCL + IP3 + (I-1)*NPWCL - 1
      IF(ADATA(IB1+2).LT.ERGL) GO TO 610
      JPRT1 = IDATA(IB1+1)
      NN = I + 1
      DO 611  J = NN,NCLST
      IB2 = IPCL + IP3 + (J-1)*NPWCL - 1
      JPRT2 = IDATA(IB2+1)
      IF(JPRT1+JPRT2.NE.0) GO TO 611
      IF(ADATA(IB2+2).LT.ERGL) GO TO 611
      IF(JPRT1.NE.0) GO TO 612
C
C  CHECK OF TWO CLUSTERS IN BARREL
C
      FI1 = ADATA(IB1+4)
      FI2 = ADATA(IB2+4)
      ZE1 = ADATA(IB1+5)
      ZE2 = ADATA(IB2+5)
      ABF = ABS(FI2-FI1)
      ABZ = ABS(ZE1+ZE2)
      IF(ABZ.GT.ZLM) GO TO 611
      IF(ABF.LT.PI-FIDEL.OR.ABF.GT.PI+FIDEL) GO TO 611
C TOTALLY NEUTRAL COLLINEARS MUST HAVE MORE THAN 7 % OF ETOT
      IF(NTR.EQ.0.AND.ADATA(IB1+2)+ADATA(IB2+2).LT..00007*ETOT)GO TO 61100059400
      MARK = 1
      THE1 = ATAN2(ZE1,RLG)
      THE2 = ATAN2(ZE2,RLG)
      THE1 = PI*.5 - THE1
      THE2 = PI*.5 - THE2
      GO TO 619
C
C  CHECK OF TWO CLUSTERS IN ENDCAPS
C
612   X1 = ADATA(IB1+4)
      X2 = ADATA(IB2+4)
      Y1 = ADATA(IB1+5)
      Y2 = ADATA(IB2+5)
      ABX = ABS(X1+X2)
      ABY = ABS(Y1+Y2)
      IF(ABX.GT.XLM) GO TO 611
      IF(ABY.GT.YLM) GO TO 611
C TOTALLY NEUTRAL COLLINEARS MUST HAVE MORE THAN 7 % OF ETOT
      IF(NTR.EQ.0.AND.ADATA(IB1+2)+ADATA(IB2+2).LT..00007*ETOT)GO TO 61100061300
      MARK = 1
      FI1 = ATAN2(Y1,X1)
      IF(FI1.LT.0.) FI1 = FI1 + TWOPI
      FI2 = ATAN2(Y2,X2)
      IF(FI2.LT.0.) FI2 = FI2 + TWOPI
      RR = SQRT(X1*X1 + Y1*Y1)
      THE1 = ATAN2(RR,ZENDPL)
      IF(JPRT1.LT.0) THE1 = PI - THE1
      RR = SQRT(X2*X2 + Y2*Y2)
      THE2 = ATAN2(RR,ZENDPL)
      IF(JPRT2.LT.0) THE2 = PI - THE2
      GO TO 619
C
611   CONTINUE
C
610   CONTINUE
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      LRJCT = 13
      IF(LRJCT.EQ.13.AND.IPRN.GT.0) WRITE(6,7142) HRUN,HEVENT
7142  FORMAT(' REJECTED, NO COLLINEARS FOUND      ',2I8)
C                                              ************************
C                                             ***    LRJCT = 13      ***
C                                              ************************
      GO TO 1
C
C
619   ICOSM = 0
C IF COLLINEARS FOUND IN FEWPRONG EVENT AND LOW ENERGY, CHECK TOF.
      IF(NTR.GT.2.AND.NTR.LT.8.AND.ETOT.LT.700..AND.ISTAR.EQ.1)
     $ GO TO 4925
      COSS = SIN(THE1)*SIN(THE2)*(COS(FI1)*COS(FI2)+SIN(FI1)*SIN(FI2))
     $  + COS(THE1)*COS(THE2)
C---------------------------------------------******** WRITTEN *********
      LWRIT = 5
      IF(LWRIT.EQ.5.AND.IPRN.GT.0) WRITE(6,7143) HRUN,HEVENT
7143  FORMAT(' WRITTEN, COLLINEARS FOUND      ',2I8)
C                                         --------------------------
C                                       --        LWRIT = 5         --
C                                         --------------------------
      GO TO 11
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---     'GO TO 11' MEANS ACCEPT EVENT, WRITE IT AND GO TO NEXT EVENT
C---
1     IF(IPRN.GT.0)
     $ WRITE(6,7739) HEAD(18),HEAD(19),LRJCT
7739  FORMAT('  RUN&EV ',2I8,'         CODE ',I5,' >>> RJCT <<< ')
      RETURN
11    IF(IPRN.GT.0) WRITE(6,7738) HEAD(18),HEAD(19),LWRIT
7738  FORMAT('  RUN&EV  ',2I8,' CODE ',I5,'*** WRIT *** ')
      RETURN
      END
      BLOCK DATA
      COMMON /CREDTV/ CRVLIM,LMHITS,RPLIM,RPLIM1,RATLIM,COSCUT,ZVTXLM,
     $ ZVXLM1,ZVXLM2,ETOTLM,ETOTKP,ETCYKP,ETE1KP,ETE2KP,ZMLIM,FIDEL,
     $ XLM,YLM,ZLM,ERGL,ETAGLM,ETOTCT,TSUMC1,TSUMC2
      DATA ERGL /.200/
      DATA ETAGLM /100./
      DATA ETOTCT /100./
      DATA CRVLIM/.00135/, LMHITS/16/
      DATA RPLIM /30./
      DATA RPLIM1/10./
      DATA RATLIM /.20/
      DATA ZMLIM /350./
      DATA FIDEL /.200/
      DATA ZLM /500./
      DATA XLM /350./
      DATA YLM /350./
      DATA COSCUT /5.5/
      DATA ZVTXLM /350./
      DATA ZVXLM1 /500./
      DATA ZVXLM2 /200./
      DATA  ETOTLM /5000./
      DATA  ETOTKP /7000./
      DATA  ETCYKP /3500./
      DATA  ETE1KP /4000./
      DATA  ETE2KP /500./
      DATA  TSUMC1 /30./
      DATA  TSUMC2 /-20./
      END

C   03/08/78 C8082201   MEMBER NAME  BOUND2   (LGSOURCE)    FORTRAN
      SUBROUTINE BOUND2(JBACK,PA0,*)
C
C     S.YAMADA    03-08-78  21:00
C
C---- CHECK BOUNDARIES OF MATERIAL FOR SHOWER
C     JBACK=1 FOR FLANGE, JBACK=2 FOR LIGHT GUIDE
C---- BOUNDARY CHECK OF THE FRONT AND BACK SURFACES ARE DONE BY BOUND.
C
      DATA  RF2/4.540/, RG2/0.1406/
      DIMENSION PA0(9)
C
      IF(JBACK-1) 100,1,2
C
C---- FLANGE
    1 IF(PA0(5)**2+PA0(6)**2.LE.RF2) GO TO 101
      RETURN
C
C---- LIGHT GUIDE
    2 IF(PA0(5)**2+PA0(6)**2.GE.RG2) GO TO 101
C
  100 RETURN
  101 RETURN1
      END

C   12/01/83 403122039  MEMBER NAME  MUERRY   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUERRY(NAME,INF,MESS)
C-----------------------------------------------------------------------
C
C LAST CHANGE 20.15 12/03/84 CHRIS BOWDERY-TIDYING UP
C      CHANGE 12.00 12/01/83 HUGH MCCANN - TRIVIAL BUG.
C      CHANGE 10.30 23/02/82 HUGH MCCANN - TO ADD MUCUTS TREATMENT.
C      CHANGE 13.30 22/02/82 HUGH MCCANN - FOR IMPROVED ERROR OUTPUT.
C      CHANGE 10.3 11/09/79 JOHN ALLISON.
C
C      PRINTS MU ERROR MESSAGES.
C      .  PROVIDE SUBROUTINE NAME IN NAME.
C      .  PROVIDE INFORMATION IN INTEGER*4 WORD INF.
C      .  PROVIDE MESSAGE IN MESS TERMINATED BY '^'.
C
C
C-----------------------------------------------------------------------
C
      LOGICAL*1 MESS(1)
      LOGICAL*1 BAR/'^'/
C
      INTEGER*2 NAME(3)
      INTEGER*2 NANAC(3)/'MU','AN','AC'/,
     *          NCOOR(3)/'MU','CO','OR'/,
     *          NANAF(3)/'MU','AN','AF'/,
     *          NCUTS(3)/'MU','CU','TS'/
C
      COMMON /CMUPRN/ MUPRIN,MUHPR,IANAC,ICOOR,IANAF,LANAC,LCOOR,LANAF,
     +                ITOTAL,LTOTAL,ICUTS,LCUTS
      COMMON /CMUIEV/ IEV,NEV,IRD,KRUN,KREC,
     +                ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
C
C------------------ C O D E  -------------------------------------------
C
      IF( MUPRIN .EQ. 0 ) GO TO 99
C
C                           INITIALISE MUDUMP FLAG.
C
      IDUMP = 0
C
C                            LOOK OUT FOR CALLS  FROM  MUANAC,  MUCOOR,
C                            MUANAF AND MUCUTS.
C
C                            GO TO 20 IF NAME OF CALLING  ROUTINE  DOES
C                            NOT START WITH 'MU'.
C
      IF( NAME(1) .NE. NANAC(1) ) GO TO 20
      IF( NAME(2) .EQ. NANAC(2)  .AND.  NAME(3) .EQ. NANAC(3) ) GO TO 5
      IF( NAME(2) .EQ. NCOOR(2)  .AND.  NAME(3) .EQ. NCOOR(3) ) GO TO 1000020000
      IF( NAME(2) .EQ. NANAF(2)  .AND.  NAME(3) .EQ. NANAF(3) ) GO TO 1500020400
      IF( NAME(2) .EQ. NCUTS(2)  .AND.  NAME(3) .EQ. NCUTS(3) ) GO TO 1800020800
      GO TO 20
C
C                            CALL FROM MUANAC :
C
    5 IANAC = IANAC + 1
      IF( IANAC .EQ. LANAC ) WRITE(6,56) NANAC,LANAC
   56 FORMAT(/' **** WARNING : LIMIT ON NO. OF ERROR MESSAGES FROM ',
     +    3A2,' (',I3,' ) IS NOW REACHED WITH THE FOLLOWING MESSAGE :')
      IF( IANAC .GT. LANAC ) GO TO 99
      GO TO 20
C
C                            CALL FROM MUCOOR :
C
C                            DECODE IER. IP IS NEEDED BY MUDUMP.
C
   10 IP  = INF/100
      MER = INF-100*IP
      INF = MER
C
C                            SET FLAG FOR MUDUMP.
C
      IF( MUPRIN .GE. 3 ) IDUMP = 1
      ICOOR = ICOOR + 1
      IF( ICOOR .EQ. LCOOR ) WRITE(6,56) NCOOR,LCOOR
      IF( ICOOR .GT. LCOOR ) GO TO 99
      GO TO 20
C
C                            CALL FROM MUANAF :
C
   15 IANAF = IANAF + 1
      IF( IANAF .EQ. LANAF ) WRITE(6,56) NANAF,LANAF
      IF( IANAF .GT. LANAF ) GO TO 99
      GO TO 20
C
C                            CALL FROM MUCUTS :
C
   18 ICUTS = ICUTS + 1
      IF( ICUTS .EQ. LCUTS ) WRITE(6,56) NCUTS,LCUTS
      IF( ICUTS .GT. LCUTS ) GO TO 99
C
   20 CONTINUE
C
C                            COUNT  TOTAL  NO.  OF  MESSAGES  OUTPUT  *
C                            COMPARE WITH JOB LIMIT .
C
      ITOTAL = ITOTAL + 1
      IF( ITOTAL .EQ. LTOTAL ) WRITE(6,26) LTOTAL
   26 FORMAT(/'XXXX WARNING : LIMIT ON THE TOTAL NO. OF MESSAGES (',
     +I4,' ) FOR THIS JOB IS NOW REACHED WITH THE FOLLOWING MESSAGE :')
      IF( ITOTAL .GT. LTOTAL ) GO TO 99
C
C                            COUNT NUMBER OF CHARACTERS.
C
      N = 1
 1    IF( MESS(N) .EQ. BAR ) GO TO 2
      N = N + 1
      IF( N .LE. 200 ) GO TO 1
C
   2  N=N-1
C
C                            WRITE EVENT HEADER IF THIS  IS  THE  FIRST
C                            MESSAGE FOR THIS EVENT.
C
      IF( MUHPR .EQ. 0 ) WRITE(6,1006) KRUN,KREC,IEV,IHOURS,IMINS,
     +                                 ISECS,IDAY,IMONTH,IYEAR
 1006 FORMAT(/'   RUN',I6,2X,'EVENT',I6,
     +     2X,'RECORD (FILE)',I6,2X,'TIME =',I3,':',I2,':',I2,
     +     2X,'DATE =',I3,':',I2,':',I4,'   MESSAGES :')
C
      MUHPR = 1
C
      WRITE(6,100) NAME,INF,(MESS(I),I=1,N)
 100  FORMAT('   *** MU ERROR IN ',3A2,4X,', INFORMATION --->',I10,',',
     +       4X,70A1/(1X,132A1))
C
C                            FOR MUCOOR ERRORS AND MUPRIN .GE. 3 , DUMP
C                            THE MUEV BANK.
C
      IF( IDUMP .NE. 0 ) CALL MUDUMP(INF,IP)
C
 99   CONTINUE
      RETURN
      END

C   07/06/96 606071906  MEMBER NAME  QTABL    (S4)          FORTG1
      SUBROUTINE QTABL(KA,I,A)
      REAL A(16)
      COMMON/BCS/IW(1)
      INTEGER NF(8),N/0/
      INTEGER*2 NH(16),NCH(2)
      EQUIVALENCE (NF(1),NH(1)),(N,NCH(1))
      DO 10 J=1,16
   10 A(J)=0.0
      IF(I.LT.0.OR.I.GT.255) GOTO 100
      II=I/16
      IJ=I-II*16
      NC=KA*16+II
      CALL BLOC(IND,'TAB*',NC,&100)
      IND=IND+IJ*8
      DO 20 J=1,8
   20 NF(J)=IW(IND+J)
      DO 30 J=1,16
      NCH(2)=NH(J)
   30 A(J)=N
  100 RETURN
      END

C   07/06/96 606071814  MEMBER NAME  BFTDIR   (S4)          FORTRAN
      SUBROUTINE BFTDIR(LUN,LUN1,IOPT)
C
C     VERSION JULY 82
C
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      REAL*8 DATE(2)
      INTEGER IOPFR/2HFR/,IOPTO/2HTO/,IOPT0/2HT0/,BLANK/4H    /
      INTEGER DIRA/'+DIR'/,DIRO/'DIRA'/
      CALL DAY(DATE(1),DATE(2))
      IOP=0
      IF(IOPT.EQ.IOPFR) IOP=1
      IF(IOPT.EQ.IOPTO) IOP=2
      IF(IOPT.EQ.IOPT0) IOP=2
      IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,LUN1,IOPT
      IF(IOP.EQ.0) GOTO 201
      IUND=LUN
      CALL DIDA(0,LISTE,1)
      IF(INDA.EQ.0) GOTO 202
      IF(IOP.NE.1)  GOTO 20
C
C     OPTION FR=FROM
C
      IF(IW(INDA+34).NE.0) GOTO 201
      IF(IW(INDA+20).EQ.1) GOTO 201
C
C
C
      INDL=IBANK(4H+DIR,-1,2000)
      IF(INDL.EQ.0)     GOTO 201
      INDB=IBANK(4H+DIR,-2,3204)
      IF(INDB.EQ.0)     GOTO 201
      NREC=IW(INDA+6)
      NBK=0
      N=0
      NCT=0
      NERR=0
C
C     READ SEQUENTIAL DATA SET
C
      IF(LUN1.EQ.0) GOTO 18
   10 CALL RDSQ(LUN1,NTOT,IW(INDB+1),&16)
      NCT=NCT+1
      IF(NTOT.LE.0.OR.NTOT.GT.3204) GOTO 12
      IF(NTOT-4.NE.IW(INDB+4)) GOTO 12
      GOTO 14
   12 NERR=NERR+1
      GOTO 10
   14 IF(NCT.EQ.0) GOTO 16
      LISTE(1)=IW(INDB+1)
      LISTE(2)=IW(INDB+2)
      LISTE(3)=0
      LISTE(4)=IW(INDB+4)
      LISTE(5)=2+MOD(IABS(LISTE(1)+LISTE(2)),IW(INDA+8))
      INDC=INDB+4
      CALL DAFR(3)
      CALL UCOPY2(LISTE,IW(INDL+5*N+1),5)
      NBK=NBK+1
      N=N+1
      IF(N.LT.400) GOTO 10
   16 IF(N.EQ.0) GOTO 18
      CALL SORTAE(IW(INDL+1),5,N,5,0)
      CALL DIDA(3,IW(INDL+1),N)
      IF(N.NE.400) GOTO 18
      N=0
      GOTO 10
   18 IW(INDA+33)=NBK
      IW(INDA+34)=NBK
      IW(INDA+35)=NBK
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      NCT=NCT-NERR
      IND =IBANK(4H+DIR,-2,2HDL)
      IND =IBANK(4H+DIR,-1,2HDL)
      IPAS=IW(INDA+19)
      INDA=IBANK(4H+DIR,IUNDA,2HDL)
      CALL DIDA(0,LISTE,1)
      CALL BGAR(IGA)
      IF(NUNTB.NE.0) WRITE(NUNTB,102) LUN,NCT,NERR
      IF(LUN1.NE.0) REWIND LUN1
      GOTO 100
C
C     OPTION TO
C
   20 NPAGL=200
      IPAS=0
      INDA=ILINK(4H+DIR,IUND)
      IF(INDA.NE.0) IPAS=IW(INDA+19)
      INDA=IBANK(4H+DIR,IUND,2HDL)
      CALL BGAR(IGA)
C
C     DETERMINE NUMBER OF RECORDS
C
      CALL DIDA(0,LISTE,1)
      IF(INDA.EQ.0) GOTO 203
      NRECL=IW(INDA+7)
      CALL UCOPY(DATE,IW(INDA+29),4)
C
C     PREPARE BANK FOR TABLE OF CONTENT
C
      INDL=IBANK(4H+DIR,-1,450)
      IF(INDL.EQ.0) GOTO 201
      NPG=0
      NE =0
      NERR=0
      NSE=0
      IA=IBANK(0,0,0)
      IF(IW(IA).LE.3204+NDAREC) GOTO 201
      NRC=0
   24 NTOT=0
      IB=IA
   30 NRC=NRC+1
      ISW=0
      IF(NRC.LE.NRECL) GOTO 32
      ISW=2
      GOTO 50
C
C     READ NEXT RECORD FROM DIRECT ACCESS
C
   32 JSAV=IW(IB-1)
      CALL RDDA(NRC,NDAREC,IW(IB-1))
      NTOTN=IW(IB-1)
      IW(IB-1)=JSAV
      IF(NTOTN.EQ.0) GOTO 36
      IF(NTOTN.GT.4.AND.NTOTN.LE.NDAREC-1) GOTO 34
      NERR=NERR+1
      GOTO 24
   34 IF(IW(IB).NE.DIRA.AND.IW(IB).NE.DIRO) GOTO 40
   36 ISW=1
      GOTO 50
   40 NTOT=NTOT+NTOTN
      IF(IA.EQ.IB) GOTO 50
C
C     COMPARE NAME AND NR
C
      IF(IW(IA  ).NE.IW(IB)  ) GOTO 50
      IF(IW(IA+1).NE.IW(IB+1)) GOTO 50
C
C     EQUAL
C
      NW=IW(IB+3)
      CALL UCOPY2(IW(IB+4),IW(IB),NTOTN-4)
      NTOT=NTOT-4
      IW(IA+3)=IW(IA+3)+NW
C
   50 IND=IA+3
      IF(NTOT.EQ.0.AND.ISW.EQ.2) GOTO 66
      IF(NTOT.EQ.0) GOTO 24
   52 NW=IW(IND)
      IF(NW.LE.0) GOTO 54
      IF(IA+NTOT-1-IND-NW) 54,56,60
C     ERROR
   54 CONTINUE
      GOTO 24
C     LAST BANK
   56 IF(ISW.NE.0) GOTO 60
      CALL UCOPY2(IW(IND-3),IW(IA),NW+4)
      NTOT=NW+4
      IB=IA+NTOT
      ISW=0
      GOTO 30
   60 NWR=NW+4
      IF(LUN1.NE.0) CALL WRSQ(LUN1,NWR,IW(IND-3))
      NSE=NSE+1
      IF(NE.NE.0) GOTO 64
      DO 62 I=1,450
   62 IW(INDL+I)=BLANK
   64 JCOL=NE/50
      INDX=INDL+JCOL*3+(NE-JCOL*50)*3*3
      IW(INDX+1)=IW(IND-3)
      IW(INDX+2)=IW(IND-2)
      IW(INDX+3)=IW(IND)
      NE=NE+1
      IF(ISW.EQ.2) GOTO 66
      IF(NE.LT.150) GOTO 70
   66 IF(NPG.GE.NPAGL) GOTO 68
C
C     PRINT TABLE OF CONTENT
C
      NPG=NPG+1
      IF(NUNTB.NE.0) WRITE(NUNTB,103) LUN,NPG
      CALL PRINTA(IW(INDL+1),-3,450)
   68 IF(NE.EQ.150) NE=0
      IF(ISW.EQ.2) GOTO 90
   70 IND=IND+4+NW
      GOTO 52
   90 IF(INDA.EQ.0) GOTO 92
      IF(IUNTP.EQ.0) GOTO 92
      IF(IW(INDA+20).NE.0) GOTO 92
C
C     UPDATE DATE IN MASTER DIRECTORY
C
      LISTE(1)=DIRA
      LISTE(2)=DIRO
      CALL DIDA(-1,LISTE,1)
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
   92 IZER=IBANK(4H+DIR,-1,2HDL)
      CALL BGAR(IGA)
      IF(NUNTB.NE.0) WRITE(NUNTB,102) LUN,NSE,NERR
      IF(LUN1.NE.0) REWIND LUN1
C
  100 RETURN
  101 FORMAT('0---- DIR-UNIT',I3,0X,'SEQ-UNIT',I3,'   OPTION = ',A4,
     1   '  (BFTDIR START)')
  102 FORMAT('0---- DIR-UNIT',I3,I14,' RECORDS(=BANKS) COPIED,',I4,
     1   ' ILLEGAL RECORDS   (BFTDIR END)')
  103 FORMAT('1---- DIR-UNIT',I3,10X,'PAGE',I3/
     1   11X,3(8X,'NAME',6X,'NUMBER',1X,'NR OF WORDS')/)
  201 CALL BDMPA(47)
  202 CALL BDMPA(48)
  203 CALL BDMPA(49)
      GOTO 100
      END

C   03/12/83 312030146  MEMBER NAME  MCVERR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCVERR( IERROR,TEXT,VALUE,IVALUE,
     +                   ITEXT2,IEVENT,ITRACK,VALID )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   16/11/83 :  PRINTS VALIDATION ERROR MESSAGES
C
C        MOD: C. BOWDERY   22/11/83 :  FOR TEST DISABLING
C   LAST MOD: C. BOWDERY    2/12/83 :  IMPROVEMENTS
C
C   THIS ROUTINE PRINTS THE MESSAGE STORED IN 'TEXT' FOR ERROR CODE
C   'IERROR' UNLESS 20 MESSAGES HAVE BEEN PRINTED OR THE TEST HAS BEEN
C   DISABLED IN COMMON /CVFLAG/. IF THE TEST IS ENABLED, THE ERROR IS
C   RECORDED IN COMMON /CVERR/.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1 TEXT(1), ENDT, TEXT1(35) , BLANK
C
      LOGICAL VALID , VTEST
C
      COMMON / CVERR  / MESSAG(20)
      COMMON / CVFLAG / VTEST(20)
C
      DATA ENDT / '^' / , BLANK / ' ' /
C
C-------------------  C O D E  -----------------------------------------
C
C                       IS THE VALIDATION FLAG ENABLED FOR THIS ERROR?
C                       IF DISABLED, THEN RETURN WITH VALID = .TRUE.
C
      VALID = .TRUE.
      IF( .NOT. VTEST(IERROR) ) RETURN
      VALID = .FALSE.
C
C                       PRINT NOTHING IF 20 OF THESE ERRORS HAVE ALREADY
C                       BEEN PRINTED.
C
      MESSAG(IERROR) = MESSAG(IERROR) + 1
      IF( MESSAG(IERROR) .GT. 20 )  RETURN
C
C                       TRANSFER 'TEXT' TO 'TEXT1' AFTER CLEARING LATTER
C
      DO  5   N = 1,35
        TEXT1( N ) = BLANK
   5  CONTINUE
C
      DO  10  N = 1,35
        IF( TEXT( N ) .EQ. ENDT ) GO TO 20
          TEXT1( N ) = TEXT( N )
  10  CONTINUE
C
C
C                       SEPARATE THE INTEGER AND REAL ERRORS
C
  20  IF( IERROR .GT. 10 ) GO TO 3
        WRITE(6,2) IERROR,TEXT1,VALUE,ITEXT2,IEVENT,ITRACK
   2    FORMAT(/' *** INPUT DATA ERROR ',I2,' *** ',5X,35A1,' (',G9.3,
     +          A4,')   FOR EVENT ',I6,'  TRACK ',I3,
     +          '    ***')
        RETURN
C
   3  WRITE(6,4) IERROR,TEXT1,IVALUE,ITEXT2,IEVENT,ITRACK
   4  FORMAT(/' *** INPUT DATA ERROR ',I2,' *** ',5X,35A1,' (',I9,
     +          A4,')   FOR EVENT ',I6,'  TRACK ',I3,
     +          '    ***')
      RETURN
      END

C   11/01/88 807212001  MEMBER NAME  TPTRI2   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTRI2( VPROC )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       7/06/88:  Get instr. about vertex proc.
C
C
C
C     Routine to provide yes/no answer about need for track
C     post-processing (primary vertex, new direction cosines, decay
C     searches and V0 searches).
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     VPROC     Out      L*4      TRUE if vertex processing step wanted
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  TRACK*8, VPROCS*20

      LOGICAL  VPROC, VP, FIRST

      SAVE  VP, FIRST

      DATA  FIRST / .TRUE. /
      DATA  TRACK / 'TRACK' /,  VPROCS / 'VPROCESS' /

C------------------  C O D E  ------------------------------------------

C                            If not first call, VP already SAVEd.

      IF( FIRST ) THEN

C                            Get user request relating to vertex proc.

        CALL TPUOPT( TRACK, VPROCS, VP )

        FIRST = .FALSE.

      ENDIF

C                            Set VPROC equal to VP

      VPROC = VP

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   06/11/87 711061909  MEMBER NAME  TPTRFM   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTRFM
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       6/11/87:  Add vertex related info.
C
C
C
C     Routine to add vertex related information to the TPTR banks
C     and create TPVX banks. Includes fine momentum determination.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

C------------------  C O D E  ------------------------------------------


C                            Delete existing vertex banks

      CALL BMLT( 1, 'GVTX' )
      CALL BDLM

      IPATR = IDATA( IBLN( 'PATR'))
      IF( IPATR .LE. 0 ) THEN
        CALL TPWARN
      ELSE

C                            Main vertex finding routine

        CALL TPVTXD( IPATR, IERR )
        IF( IERR .NE. 0 ) THEN

C                            Handle the difficult cases, e.g. collinear
C                            2 prongs and coplanar events.

          CALL TPVTX1( IPATR )
          CALL CLOC( ITPVX,'TPVX',1)
          IF( ITPVX .GT. 0 ) THEN

C                            Update the TPVX banks for the above cases

            CALL CLOC( ITPEV, 'TPEV', 1 )
            IF( ITPEV .GT. 0 ) THEN
              CALL TPVTX2( IPATR, ITPEV, ITPVX )
            ELSE
              CALL TPERRH
            ENDIF

          ENDIF
        ENDIF

      ENDIF

      RETURN
      END

C   19/08/80 009221742  MEMBER NAME  FWDDET   (S)           FORTRAN
      SUBROUTINE FWDDET(PV,R0,IHIT)
C---  PREPARE AND SUPERVISE SIMULATION OF FORWARD DETECTORS' LEAD-GLASS
C---  (WITHOUT SHOWER SIMULATION)
C
C     H.WRIEDT     18.03.80    15:30
C     LAST MODIFICATION     21.08.80    13:55
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION PV(10),R0(3),X(3),DX(3)
C
      COMMON /CGGRAW/ HGG(192)
C
      COMMON /CPARTC/ PRTCIN(3,3),PRTCL(3,3),EMEV,AMASSQ,ISIGNZ,EBEAM,
     &                THETA,PHI
C
      DATA TWOPI/6.2831853/,PI/3.1415927/,PIHALF/1.5707963/
      DATA ELEMAS/0.511E-3/,RADIAN/1.745329E-2/
      DATA EMINC / .005 /
C
C***  FOR TESTS ONLY
      DATA I1/0/
      I1 = I1 + 1
C***  END OF TEST INSERT
      IT = PV(8)+0.5
C---  THROW OUT PARTICLES WITHOUT TYPE-CODE
      IF (IT.LE.0) RETURN
      IF( PV(4) .LE. EMINC )  RETURN
C---  PREPARE INFORMATION NEEDED FOR FORWARD DETECTORS' LEAD-GLASS
      PRTCL(1,1) = PV(7)
      PRTCL(2,1) = PV(4)/ELEMAS
      PRTCL(3,1) = 0.
        DO 1 J = 1,3
        PRTCL(J,2) = R0(J)
        PRTCL(J,3) = PV(J)/PV(4)
          DO 2 K = 1,3
    2     PRTCIN(J,K) = PRTCL(J,K)
    1   CONTINUE
      EOLD = PV(4)
      EMEV = EOLD*1000.
      ISIGNZ = SIGN(1.,PV(3))
      THETA = ARCOS(PRTCL(3,3))
C---  DETERMINE PHI
      IF (PV(1).NE.0.) GOTO 3
      PHI = SIGN(PIHALF,PV(2))*ISIGNZ
      GOTO 4
    3 PHI = ATAN(PV(2)/PV(1))
      IF (PV(1).LT.0.) PHI = PI+PHI
    4 IF (PHI.GT.PI) PHI = PHI-TWOPI
    5 PHI = PHI/RADIAN
C
C---  COMPUTE X- AND Y-COORDINATES IN PB-GLASS SURFACE PLANE
C     (EACH IN MM)
      ZPBGL = 4850.
      X(3) = ZPBGL
      CALL COORD(X,DX)
C---  DETERMINE ADDRESS OF HIT BLOCK
      X1 = X(1)
      Y1 = X(2)
      CALL GGBLNO(X1,Y1,NOBL)
C***
C***  IF(I1.LE.20) WRITE(6,600) NOBL,X1,Y1,DX,P,PHI,THETA
C*600 FORMAT(' FWDDET-TEST: BLOCK-NR.,X,Y,DX,DY,DZ:',I6,5(2X,E12.4)/
C*** &       '   P(1)-P(4),PHI,THETA:',6(2X,E12.4))
C***
      IF (NOBL.LE.0) RETURN
      IHIT = IHIT + 1
C---  DEPOSIT ENERGY ACCORDING TO PARTICLE TYPE
      IF (IT.GT.2) GOTO 10
C---  PHOTONS AND ELECTRONS
C---  SMEAR ENERGY (FWHM: 20% AT 15 GEV BEAM-ENERGY)
      SIGMA = 0.33*SQRT(EOLD)
      CALL NVERT(SIGMA,EOLD,ENEW)
      PHEIGH = ENEW*1000./5.5
      HGG(NOBL) = HGG(NOBL) + PHEIGH
      RETURN
C---  NON-SHOWERING PARTICLES
C***  HAS TO BE WRITTEN
   10 RETURN
      END

C   04/03/82 203041030  MEMBER NAME  USR1ANA  (JADESR)      FORTRAN
      SUBROUTINE USER(INDEX)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C---
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CTLIM/ ISECLF
C
#include "cdata.for"
#include "cheadr.for"
      EQUIVALENCE (HHEADR(18),HRUN) , (HHEADR(19),HEV)
      EQUIVALENCE (HHEADR(35),HWRT)
C
      COMMON // DUMHST(6000)
C
      DIMENSION NCOUNT(20)
C---
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   MUON CHAMBER TRACKING HAS BEEN DONE.
C              9   MUON AND INNER DETECTOR TRACKS HAVE BEEN ASSOCIATED.
C             10   UNUSED
C---
C---     CHECK IF CALL AT END OF JOB
      IF(INDEX.EQ.2) GOTO 1002
C
      IF(INDEX.NE.0) GOTO 1000
        CALL SETSL(NCOUNT(1),0,80,0)
        IQPATR = IBLN('PATR')
        IQPATR = IBLN('PATR')
        ISECLF= 0
        CALL HLIMIT(6000)
        CALL HBOOK1( 11,'ZV                    $',100,-500., 500.)
C
 1000 CONTINUE
      INDEX=INDEX+1
      IF(INDEX.LT.100) RETURN
        PRINT 2002, NREC,NRUN,NEV
 2002   FORMAT(' LAST EVENT WAS:',3I6)
        PRINT 2003, NCOUNT
 2003   FORMAT('0NCOUNT =',10I8)
        CALL H1EVLI(    0)
        CALL HISTDO
      RETURN
C
 1002 CONTINUE
      DATA NREC/ 0/
      NREC = NREC + 1
      NRUN = HRUN
      NEV  = HEV
      IF(NREC.LT. 1) GOTO 1
      IF(HWRT.NE.16 .AND. HWRT.NE.24) GOTO 1
C
      IQPATR = IBLN('PATR')
      IPPATR = IDATA(IQPATR)
      IF(IPPATR.LE.0) GOTO 1
      CALL ZVTRCK(ZV,IND,IPPATR)
C
      IF(NREC.LE.10) PRINT 2901, NREC, HRUN,HEV,HWRT,IND,ZV
 2901 FORMAT(1H ,'EVENT =',5I6,F8.1)
C
      IF(IND.LE.0) GOTO 1
      CALL HF1(11,ZV,1.)
C
      INDEX=11
      RETURN
    1 INDEX=1
      RETURN
C
      END

C   29/04/87 705071934  MEMBER NAME  ZSPUR9   (JADEGS)      FORTRAN
      SUBROUTINE ZSPUR(I,IPATR,MODE)
C*811215*DITTMANN****************************************************
C*                                                                  *
C*                C L E A N   Z   H I T S                           *
C*                        A N D                                     *
C*       C A L C U L A T E   X - Y   C O O R D I N A T E S          *
C*                                                                  *
C*       COLLECT TRACKS NEAR IN R/PHI,                              *
C*       REMOVE HITS FOR WHICH ANOTHER TRACK PASSES BY WITHIN       *
C*       A FRACTION OF THE ADC GATE (3 MM) FOR BOTH AMBIGUITIES.    *
C*       MODE = 1 OR 2 SWITCHES OFF THIS FEATURE.                   *
C*       CALCULATE X-Y COOERDINATES (ZSXY).                         *
C*       HEMISPHERE TEST MODIFIED E ELSEN 11/11/86                  *
C*       MODIFIED 29/04/87    E ELSEN                               *
C*       INTRODUCED COMMON CZSPRM                                   *
C********************************************************************
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      INTEGER*2 HDATA
      COMMON /CWORK/ NHIT,IZB(60),IJC(60),IJH(60),NW(60),LH(60),
     *                LRFL(60),ALU(60),ARU(60),X(60),Y(60),Z(60),S(60),
     *                G(60),DT(60),DL(60),DW(60),FCORR(60)
     *               ,IL(25),ARL(25),XML(25),YML(25)
C
C  COMMON FOR Z-RESOLUTION PARAMETERS,   USED IN SUBR. AMPS2Z
C
      COMMON / CZSPRM / NZSPRD,
C                                           PARMS FOR RESOLUTIONS
     * AZSRS0(3), AZSRSA(3),
C                                           PARMS FOR CUTS
     * AZSCT1(3), AZSCT2(3), AZSCT3(3), AZSCT4(3),
C                                           SECOND HIT
     * AZSSHT(5,3),
C                                           SECOND HIT DISTANCE
     * AZSSHD(3),
C                                           AVE RESOLUTIONS
     * AZSSAV(3),
C                                           ZSPD BANK FILL FLAG
     * LZSPDF
      LOGICAL LZSPDF
C
      NTNA = 0
      IF(MODE.EQ.1 .OR. MODE.EQ.2) GOTO 10
C
      NT = IDATA(IPATR+2)
      L0 = IDATA(IPATR+1)
      LT = IDATA(IPATR+3)
      KT = IPATR + L0 + (I-1)*LT
      PT = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      CPHI = ADATA(KT+8) / PT
      SPHI = ADATA(KT+9) / PT
C        FIND TRACKS NEAR IN R/PHI
      KKT = IPATR + L0
      DO 9 L=1,NT
      IF(L.EQ.I) GOTO 9
      IF(ADATA(KKT+25).EQ.0.) GOTO 9
      PTL = SQRT(ADATA(KKT+8)**2+ADATA(KKT+9)**2)
      CP2 = ADATA(KKT+8)/PTL
      SP2 = ADATA(KKT+9)/PTL
C     IF(ABS(CPHI-CP2).GT.1. .OR. ABS(SPHI-SP2).GT.1.) GOTO 9
C                                           START MOD
      IF(    CPHI*CP2+SPHI*SP2 .LT.0.) GOTO 9
C                                           END MOD
      IF(NTNA.EQ.25) GOTO 9
      NTNA = NTNA + 1
      IL(NTNA) = L
      RL = -1. / ADATA(KKT+25)
      ARL(NTNA) = ABS(RL)
      XML(NTNA) = ADATA(KKT+5) - RL*SP2
      YML(NTNA) = ADATA(KKT+6) + RL*CP2
    9 KKT = KKT + LT
C        LOOP OVER ALL HITS OF TRACK I
   10 CONTINUE
      DO 29 J=1,NHIT
      IF(IZB(J).EQ.0) GOTO 29
C        R/PHI COORDINATES
      NH1 = IJC(J)
      LRFLAG = LRFL(J)
      CALL ZSXY(NH1,LRFLAG,XJET1,YJET1,XJET2,YJET2)
      X(J) = XJET1
      Y(J) = YJET1
C        CHECK IF OTHER TRACKS WITHIN DOUBLE TRACK RESOLUTION
      IF(NTNA.EQ.0) GOTO 27
      DO 25 L=1,NTNA
      DIST = SQRT((XJET1-XML(L))**2+(YJET1-YML(L))**2) - ARL(L)
      IF(ABS(DIST).LT.AZSSHD(NZSPRD)) GOTO 26
      DIST = SQRT((XJET2-XML(L))**2+(YJET2-YML(L))**2) - ARL(L)
      IF(ABS(DIST).LT.AZSSHD(NZSPRD)) GOTO 26
   25 CONTINUE
      GOTO 27
   26 IZB(J) = 0
   27 CONTINUE
   29 CONTINUE
C
      RETURN
      END

C   07/06/96 606071827  MEMBER NAME  BOUTP    (S4)          FORTG1
      SUBROUTINE BOUTP(NTOT,INIW)
C     BOS SUBPROGRAM =3.8=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      INTEGER ITWO/2/
      EQUIVALENCE (TWO,ITWO)
      REAL OR
      EXTERNAL OR
C     ASSEMBLE BANKS IN CONTIGUOUS LOCATIONS
      MODE=-1
      GOTO 10
C
      ENTRY BORDP(NTOT,INIW)
      MODE=NTOT
      NREL=INIW
   10 INIW=0
      NROUT=NROUT+1
      IORD=0
      NTOT=0
      INDA=0
      J=0
   20 J=J+1
      IF(J.GT.IN) GOTO 30
      IND=IW(NLST+J)
      NIND=IW(IND)
      IF(NIND.NE.0) RW(IOLST+IND)=OR(RW(IOLST+IND),TWO)
      IND=NIND
      IF(IND.EQ.0) GOTO 20
      IF(INDA.EQ.0) INDA=IND
   25 IF(IND.NE.INDA+NTOT) IORD=1
      NTOT=NTOT+4+IW(IND)
      IND=IW(IND-1)
      IF(IND) 20,20,25
   30 IF(NTOT.NE.0) INIW=INDA-3
      IF(NTOT.EQ.0) GOTO 100
      IF(MODE) 60,40,50
   40 IF(NTOT+1.LE.NREL) GOTO 60
   45 INIW=0
      GOTO 100
   50 IF(NTOT+1.GT.NREL) GOTO 45
      IF(IORD.EQ.0) GOTO 100
      IF(NEXT+NTOT.GT.NLST) GOTO 45
C     ORDER LOOP
   60 IF(IORD.EQ.0) GOTO 100
      NEXTX=NEXT
      ISW=0
      IF(NEXT+NTOT.GT.NLST) ISW=-1
   70 J=0
   72 J=J+1
      IF(J.GT.IN) GOTO 82
      IND=IW(NLST+J)
      IND=IW(IND)
      IF(IND.LE.0) GOTO 72
C     BANK
   74 IF(ISW.NE.0) GOTO 76
      NW=IW(IND)+4
      CALL UCOPY2(IW(IND-3),IW(NEXTX),NW)
      NEXTX=NEXTX+NW
      GOTO 80
C     MOVE
   76 IF(ISW.GT.0) GOTO 78
      ISW=1
      NA1=IW(IND-3)
      NR1=IW(IND-2)
   78 CALL BCHM(IND,0,IER)
      IF(IER.EQ.0) GOTO 80
      NA2=IW(IND-3)
      NR2=IW(IND-2)
      CALL BGAR(IGA)
      CALL BLOC(IND,NA2,NR2,*90)
      CALL BCHM(IND,0,IER)
      IF(IER.NE.0) GOTO 90
C
   80 IND=IW(IND-1)
      IF(IND) 72,72,74
   82 INIW=NEXT
      IF(ISW) 90,100,84
   84 CALL BLOC(IND,NA1,NR1,*90)
      INIW=IND-3
      GOTO 100
C     ERROR OR TOO LARGE
   90 INIW=0
      IF(MODE+1.EQ.0) NTOT=0
  100 RETURN
      END

C   22/03/80 403202335  MEMBER NAME  AMCTAG   (S)           FORTRAN
      SUBROUTINE AMCTAG(IER1)
C---  PROGRAM FOR FORWARD DETECTORS' DATA ANALYSIS
C---  MONTE CARLO VERSION
C
C     H.WRIEDT      10.04.79     14:25
C     LAST MODIFICATION      22.03.80       15:25
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK(1908),HRUNEX,HEVENT
C
      DATA MASK/1/
C
      COMMON /CMSGCT/ MSGDUM(20),NGGMAX,NGGMSG(16)
C
      COMMON /CGGVRN/ NVRSN(20)
      DATA NVCODE/580032215/
      DATA ICOUNT/0/
C
      NVRSN(1) = NVCODE
C
      IF (ICOUNT.EQ.0) CALL GGFAC2
      IF (ICOUNT.EQ.0) WRITE(6,610)
  610 FORMAT(/' *** AMCTAG WIRD BENUTZT ***')
      ICOUNT = 1
C---  CLEAR COMMON BLOCKS FOR NEW EVENT
C RENAMED TO GSCRUB FROM GCLEAR - A.J.FINCH 20/3/84 TO PREVENT
C CONFLICT WITH IPS COMMAND OF SAME NAME
      CALL GSCRUB
C
C---  UNPACK DATA OF NEW EVENT
      CALL UMCPAK(IER,&1)
      CALL CONVER
C***  IF (IER.EQ.0) GOTO 10
C***  IF (IER.EQ.7) GOTO 102
      IMASK = IAND(IER,MASK)
C***  IF (IMASK.EQ.1) GOTO 100
C
C---  DRIFT CHAMBERS
C***  HAS TO BE WRITTEN
   10 CONTINUE
C
C---  LEAD GLASS
  100 CALL GGSORT
      IER = IER/2
      IMASK = IAND(IER,MASK)
C***  IF (IMASK.EQ.1) GOTO 102
C
C---  CLUSTER SEARCH
      CALL GGCCTL(&200)
C
C---  LEAD-GLASS RESULT DUMP
      CALL GGCLPC
C
C---  COMBINE TRACK INFORMATION OF LUMONITORS AND LEAD GLASS
C---  (IN THE FUTURE DRIFT CHAMBERS, TOO)
      CALL TRACKS
C
C---  FILL RESULT INTO NEW BANKS
  102 CALL REPACK(IER1)
      GOTO 1
C
C---  HANDLING OF EVENTS WITH TOO MANY CLUSTERS
  200 IF (NGGMSG(5).LE.NGGMAX) WRITE(6,605) HEVENT,HRUNEX
  605 FORMAT(' EVENT',I6,' OF RUN',I6,' SKIPPED FOR MORE THAN 51',
     &       ' CLUSTERS IN THE FORWARD DETECTORS LEAD-GLASS BLOCKS')
C
   1  RETURN
      END

      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C   10/09/79 C9091001   MEMBER NAME  EVREAH   (JADEGS)      FORTRAN
      SUBROUTINE EVREAH(NUNIT,NWORD,HDATA,IRET)
      IMPLICIT INTEGER*2 (H)
      DIMENSION HDATA(NWORD)
      READ(NUNIT,ERR=1,END=2) NWORD,HDATA
      IRET=0
      RETURN
    1 CONTINUE
      IRET=1
      RETURN
    2 IRET=2
      RETURN
      END

      SUBROUTINE PRHTAR
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,            (ICELL,IDWRK(1)),(NHIT,IDWRK(2)),(IRING,IDWRK(3))
#include "cjdrch.for"
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 0
        IQJHTL = IBLN('JHTL')
        DSD0   =-.63
        DSD1   = 1.8
        DSD2   = 4.0
        DRV0   = 0.8
        DRV1   = (DSD2 - (DSD1-DSD0)*DRV0) / (DSD2-DSD1)
      ENDIF
      DSBIN1 = TIMDEL(1,IRING)
      DSBIN2 = TIMDEL(2,IRING)
      IP0 = HPTSEC(ICELL)
      IP9 = HPTSEC(ICELL+1) - 1
      IPHL = (HPTSEC(ICELL)-HPTSEC(1))/4 + IDATA(IQJHTL) + 1
      HPHT0 = HPFREE
      HLDHT = 12
      IPHT  = HPHT0
      JHIT = 0
      NWRD2 = NWORD*2
      DO 13000 IP=IP0,IP9,4
        IPHL = IPHL + 1
      IF(
     - IDATA(IPHL).EQ.0
     -)THEN
      IF(
     - HDATA(IP+1).GT.0 .AND. HDATA(IP+2).GT.0
     -)THEN
          IWIR = HDATA(IP)
          IWIR = ISHFTR(IWIR,3)
          ILAYR = LAND(IWIR,15)
          IF(ILAYR.GE.8) DSBIN1 = DSBIN2
          DS =(HDATA(IP+3)) * DSBIN1
      IF(
     - DS.LT.4.0
     -)THEN
      IF(
     - DS.GT.DSD1
     -)THEN
              DS = (DSD1-DSD0)*DRV0 + (DS-DSD1)*DRV1
      ELSE
              DS = (DS-DSD0)*DRV0
      ENDIF
            IF(DS.LT.0.1) DS = 0.1
      ENDIF
          WRK(IPHT+2)  = AMAX1(DS,0.)
          IWRK(IPHT  ) = ILAYR
          IWRK(IPHT+1) = IP
          IWRK(IPHT+4) = 0
          IWRK(IPHT+5) = 0
          IWRK(IPHT+6) = 0
          IWRK(IPHT+7) = 0
          IPHT = IPHT + HLDHT
          JHIT = JHIT + 1
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      NHIT = JHIT
      HPHT9 = IPHT - 1
      HPFREE= IPHT
      RETURN
      END

C   17/11/84 711091458  MEMBER NAME  DATEMC0  (S)           FORTRAN
               SUBROUTINE DATEMC(H)
               IMPLICIT INTEGER*2 (H)
               DIMENSION H(6)
C   COMMON TODAY MAY BE FILLED BY USER
               COMMON/TODAY/HSS,HMM,HHH,HDY,HMO,HYY
               H(1)=HSS
               H(2)=HMM
               H(3)=HHH
               H(4)=HDY
               H(5)=HMO
               H(6)=HYY
               RETURN
               END

C   12/03/84 406222001  MEMBER NAME  PEDFIX   (S)           FORTRAN
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE PEDFIX
C
C
C ROUTINE TO DO PEDESTAL SUBTRACTION
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
C
       IF ( MARK .EQ. 1 ) CALL PEDFX2
       IF ( MARK .EQ. 2 ) CALL PEDFX3
       RETURN
       END
C
C
C
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C    SECOND ROUTINE TO ATTEMPT OFFLINE SUBTRACTION OF PEDESTALS
C     FOR EACH 'SUPERBLOCK' OF 3 LEAD SCINTILLATOR ELEMENTS IT
C   CHECKS THAT
C     NOONE CHANNEL IS GREATER THAT 500 MEV,IF THIS IS THE CASE ALL
C  THREE BLOCKS ARE IGNORED , OTHERWISE THE VALUES IN THE BLOCKS ARE
C   USED TO ESTIMATE A MEAN ADC PEDESTAL , WHICH IS THEN SUBTACTED
C   FROMALL BLOCKS.
C
C A.J.FINCH 11/12/82
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE PEDFX3
C
C
#include "cwktag.for"
C
C
       VALUE  = 500
       APICKM = 0
       APICKP = 0
       NUMM   = 0
       NUMP   = 0
C
C
C---                                MINUS Z FIRST
C
C---                                LOOP OVER ALL 8 'CAKESLICES'
C
       DO 10 I = 1,8
C
C---                                LOOP OVER 3 PARTS OF 'CAKESLICE'
C---                                AND TEST FOR ENERGY > 'VALUE'
C
          DO 20 J = 1,17,8
             ITEST = J+I-1
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 10
   20     CONTINUE
C
C   NONE OF THE BLOCKS IN THE 'CAKESLICE' UNDER TEST HAVE FAILED
C   TO BE LESS THAN 'VALUE'
C
C
C---                                SUM ALL NON ZERO BLOCKS IN NON-HIT
C---                                'CAKESLICE' AND COUNT HOW MANY
C---                                THERE ARE
C
          DO 30 L = 1,17,8
             ITEST = I+L-1
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 30
             APICKM = APICKM + CATAG(ITEST)
             NUMM = NUMM + 1
   30     CONTINUE
   10  CONTINUE
C
C
C
C
C
C---                                NOW PLUS Z
C
C
C
C
C
C---                                LOOP OVER ALL 8 'CAKESLICES'
C
       DO 11 I = 25,32
C
C---                                LOOP OVER 3 PARTS OF 'CAKESLICE'
C---                                AND TEST FOR ENERGY > 'VALUE'
C
C
          DO 21 J = 1,17,8
             ITEST = J + I - 1
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 11
   21     CONTINUE
C
C   NONE OF THE BLOCKS IN THE SUPERBLOCK UNDER TEST HAVE FAILED
C   TO BE LESS THAN VALUE
C
C---                                SUM ALL NON ZERO BLOCKS IN NON-HIT
C---                                'CAKESLICE' AND COUNT HOW MANY
C---                                THERE ARE
          DO 31 L = 1,17,8
             ITEST = I + L - 1
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 31
             APICKP = APICKP + CATAG(ITEST)
             NUMP = NUMP + 1
   31     CONTINUE
   11  CONTINUE
C
C
C
C---------------------------------- SUBTRACT PEDESTAL FROM CATAG ARRAY
C
C
C NOW WE HAVE THE VALUE APICKP AND APICKM TO BE SUBTRACTED
C  DO THE SUBTRACTION FROM CATAG ARRAY
C
C
C
C---                                CALC THE MEAN NON ZERO PEDESTAL - Z
C
       IF ( NUMM .LE. 6 ) GOTO 50
       APICKM = APICKM / NUMM
C
C
       DO 40 I = 1,24
          IF ( CATAG(I) .EQ. 0 ) GOTO 40
          CATAG(I) = CATAG(I) - APICKM
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   40  CONTINUE
C
C
C---                                SAME FOR +Z
C
C

   50  IF ( NUMP .LE. 6 ) GOTO 41
C      IF ( NUMP .LE. 4 ) GOTO 41
C
       APICKP = APICKP / NUMP
C
       DO 41 I = 25,48
          IF ( CATAG(I) .EQ. 0 ) GOTO 41
          CATAG(I) = CATAG(I) - APICKP
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   41  CONTINUE
C
C
   51  RETURN
       END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE PEDFX2
C
C ROUTINE TO SUBTRACT PEDESTALS - 1981/1982
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
       INTEGER*4 TEST(64)/  3,4,6,7 ,5,8,9,12 ,10,11,13,14 ,15,16,17,1
     *             ,19,20,22,23 ,21,24,25,28 ,26,27,29,30 ,31,32,1,2
     *             ,33,34,63,64 ,35,36,38,39 ,37,40,41,44 ,42,43,45,46
     *             ,47,48,49,50 ,51,52,54,55 ,53,56,57,59 ,58,59,61,62/
       VALUE  = 800
       APICKM = 0
       APICKP = 0
       NUMM   = 0
       NUMP   = 0
C
C
C
C
C 1/4 OF A TAGGING SYSTEM =
C
C                               ___________
C                               I    I    I
C                     __________I    I    I
C                     I    I    L____L____I
C                     I    I    I    I    I
C                     L____L____I    I    I
C                     I    I    L____L____I
C                     I    I    I
C                  ___L____L____I
C                  I    I    I
C                  I    I    I
C                  L____L____I
C                  I    I    I
C                  I    I    I
C                  L____L____I__
C                     I    I    L
C                     I    I    I__________
C                     L____L____I    I    I
C                     I    I    L    I    I
C                     I    I    I____L____I
C                     L____L____I    I    I
C                               I    I    I
C                               L____L____I
C
C   'SUPERBLOCK' =
C
C                  ___________
C                  I    I    I
C                  I    I    I
C                  L____L____I
C                  I    I    I
C                  I    I    I
C                  L____L____I
C
C

C
C LOOP OVER ALL 'SUPERBLOCKS' (SET OF FOUR BLOCKS) IN -Z TAGGER
C
       DO 10 I = 1,32,4
C
          K = I + 3
C
C LOOP OVER ALL MEMBERS OF SUPERBLOCK
C
          DO 20 J = I,K
             ITEST = TEST(J)
C
C      TEST FOR GREATER THAN 'VALUE'
C
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 10
   20     CONTINUE
C
C   NONE OF THE BLOCKS IN THE SUPERBLOCK UNDER TEST HAVE FAILED
C   TO BE LESS THAN 800,SO ANY HITS MUST BE PEDESTALS
C
          DO 30 L = I,K
             ITEST = TEST(L)
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 30
             APICKM = APICKM+CATAG(ITEST)
             NUMM = NUMM + 1
   30     CONTINUE
   10  CONTINUE
C
C NOW PLUS ZED
C
       DO 11 I = 33,64,4
C
          K = I+3
          DO 21 J = I,K
             ITEST = TEST(J)
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 11
   21     CONTINUE
C
C   NONE OF THE BLOCKS IN THE SUPERBLOCK UNDER TEST HAVE FAILED
C   TO BE LESS THAN 800
C
          DO 31 L = I,K
             ITEST = TEST(L)
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 31
             APICKP = APICKP+CATAG(ITEST)
             NUMP = NUMP + 1
   31     CONTINUE
   11  CONTINUE
C
C    CALCULATE THE MEAN NON ZERO PEDESTAL
C
       IF ( NUMM .EQ. 0 ) GOTO 50
       APICKM = APICKM/NUMM
C
C NOW WE HAVE THE VALUES APICKP AND APICKM TO BE SUBTRACTED
C  DO THE SUBTRACTION
C
       IF ( NUMM .LE. 4 ) GOTO 50
       DO 40 I = 1,32
          IF ( CATAG(I) .EQ. 0 ) GOTO 40
          CATAG(I) = CATAG(I) - APICKM
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   40  CONTINUE
C
C
   50  IF ( NUMP .EQ. 0 ) GOTO 41
       IF ( NUMP .LE. 4 ) GOTO 41
C
       APICKP = APICKP/NUMP
C
       DO 41 I = 33,64
          IF ( CATAG(I) .EQ. 0 ) GOTO 41
          CATAG(I) = CATAG(I) - APICKP
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   41  CONTINUE
C
C
        RETURN
        END

C   07/06/96 606071820  MEMBER NAME  BINP2    (S4)          FORTG1
      SUBROUTINE BINP(NRW,AR)
C     BOS SUBPROGRAM =3.7=
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
#include "star.for"
      INTEGER IONE/1/
      EQUIVALENCE (IONE,ONE)
      INTEGER AR(1)
C     CREATE POINTER FOR NEW BANKS
      IF(NRW.LT.4) GOTO 100
      IF(NEXT+NRW.GT.NLST) GOTO 100
      CALL UCOPY2(AR,IW(NEXT),NRW)
      GOTO 2
      ENTRY BFRR(NRW,AR)
    2 ICD=0
      NRIN=NRIN+1
      IEB=0
      NEXTS=NEXT
      IF(NRW.LT.4) GOTO 81
      NS=0
      NTOT=NRW
C     CHECK BANK LENGTH AND GET INDEX FOR NAME
   10 LENG=IW(NEXT+3)
      IF(LENG.LT.0) GOTO 83
      LENG=LENG+4
      IF(LENG.GT.NTOT) GOTO 83
      LNAM=IW(NEXT)
      IW(INAMV)=LNAM
      LFDI=MOD(IABS(LNAM),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      KL  =LFDI
      IF(NS.GE.NLIST) CALL BDMPA(35)
      NS=NS+1
      RW(IOLST+KL)=OR(RW(IOLST+KL),ONE)
      IW(ISLST+NS)=KL
      IW(IMLST+NS)=1
      IF(IW(KL).EQ.0) GOTO 50
C     BANK ALREADY THERE, DELETE THESE
      IEB=1
      IF(NEOTP.LE.1) GOTO 15
      NEOTP=NEOTP-1
      WRITE(6,102) LNAM
   15 INAME=IW(INAMV+KL)
      LENGS=0
      I=IW(KL)
      IW(KL)=0
   20 LENG=4+IW(I)
      LENGS=LENGS+LENG
      IW(I)=-LENG
      NFRE=NFRE+LENG
      I=IW(I-1)
      IF(I.NE.0) GOTO 20
      LENG=IW(NEXT+3)+4
      IF(NOTLOW(XNAME)) GOTO 50
      NCPL=NCPL-LENGS
      GOTO 50
C     CHECK LENGTH OF BANK
   30 LENG=IW(NEXT+3)
      IF(LENG.LT.0) GOTO 82
      LENG=LENG+4
      IF(LENG.GT.NTOT) GOTO 83
C     CHECK BANK NR
      IF(IW(NEXT+1)-IW(K-2)) 84,40,60
C     SAME, APPEND
   40 IW(K)=IW(K)+LENG-4
      CALL UCOPY2(IW(NEXT+4),IW(NEXT),NTOT-4)
      NEXT=NEXT+LENG-4
      IF(NOTLOW(XNAME)) GOTO 70
      NCPL=NCPL+LENG-4
      GOTO 70
C     NEW NAME
   50 K=KL+1
      INAME=IW(INAMV+KL)
C     LARGER NR
   60 IW(K-1)=NEXT+3
      K=NEXT+3
      IW(K-1)=0
      NEXT=NEXT+LENG
      IF(NOTLOW(XNAME)) GOTO 70
      NCPL=NCPL+LENG
C     CHECK COMPLETE RECORD
   70 NTOT=NTOT-LENG
      IF(NTOT.EQ.0) GOTO 90
      IF(NTOT.LT.4) GOTO 85
      IF(IW(NEXT).EQ.LNAM) GOTO 30
      GOTO 10
C     ERRORS
C     RECORD END WRONG
   85 ICD=ICD+1
C     WRONG ORDER IN BANK NR
   84 ICD=ICD+1
C     BANK LENGTH TO LARGE
   83 ICD=ICD+1
C     BANK LENGTH NEGATIVE
   82 ICD=ICD+1
C     RECORD LENGTH LESS THAN 4
   81 ICD=ICD+1
      NER(ICD)=NER(ICD)+1
      IF(NEOTP.LE.0) GOTO 89
      WRITE(6,101) ICD
      CALL UWP(IW(NEXTS),1,NRW)
      NEOTP=NEOTP-1
   89 CALL BSLT
      CALL BDLM
      NEXT=NEXTS
      NS=0
      GOTO 100
   90 IF(IEB.EQ.0) GOTO 100
      NER(10)=NER(10)+1
C
  100 RETURN
  101 FORMAT('0LISTING OF RECORD WITH INPUT-BANK ERROR OF CODE',I2/)
  102 FORMAT('0READ BANK NAME',1X,A4,' ALREADY PRESENT'/)
      END

C   07/06/96 606071830  MEMBER NAME  BREADCA  (S4)          FORTRAN
      SUBROUTINE BREADC
C     BOS SUBPROGRAM =2.1=
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (IW(1),RW(1))
#include "acs.for"
      LOGICAL*1 LL(8)
      EQUIVALENCE (LABEL,LL(1)),(NH,LL(5))
      INTEGER NH/0/
      INTEGER ENDQ/'ENDQ'/
   10 NW=NLST-NEXT-100
      IF(NW.LE.0) GOTO 90
      CALL READFC(LABEL,NF,IW(NEXT+4),MODE,NW,&100)
      IF(LABEL.EQ.ENDQ) GOTO 100
      IF(MODE) 90,15,30
   15 INC=-1
   20 INC=INC+1
      CALL BLOC(IND,LABEL,INC,&25)
      GOTO 20
   25 CALL BCRE(IND,LABEL,INC,0,&90,IER)
      CALL BCHM(IND,NF,IER)
      GOTO 10
   30 INC=IW(NEXT+4)
      NF=NF-1
      DO 40 I=1,NF
   40 IW(NEXT+3+I)=IW(NEXT+4+I)
      CALL BLOC(IND,LABEL,INC,&25)
      WRITE(6,101)
      GOTO 10
   90 ICOND=9
      CALL BDMP
  100 RETURN
  101 FORMAT(' -------- LAST BANK DOUBLY DEFINED')
      END

C   25/11/79 002161912  MEMBER NAME  FAKALB   (SOURCE)      FORTRAN
      SUBROUTINE FAKALB(HEXP,HRUN,*)
C     PUT IN BAD CHANNEL INFO. INTO COMMON/CALIBR/
C     HEXP  :  INPUT EXPERIMENTAL #
C     HRUN  :  INPUT RUN#
C     HBUF  :  BUFFER FOR BAD CHANNELS. FOR THE OUTPUT OF THE PROG,
C              (J,I),J;1=ADC#,2=#CHANNELS TO BE SUBTRACTED.
C     CODED BY Y.WATANABE 19/9/79  09:05
      IMPLICIT INTEGER *2 (H)
#include "clgkalb.for"
      EQUIVALENCE (NEVNT,HBAD(1)),(HHEXP,HBAD(3)),(HHRUN,HBAD(4))
      EQUIVALENCE (HBUF(1),NCAL(3002))
      DIMENSION  HBBB(11526),HIN(4,2880),HBUF(1000),HBAD(1000)
      EQUIVALENCE (HIN(1,1),HBBB(7))
      EQUIVALENCE (HCAL(100),HBBB(1))
      DATA INIT/0/,HARUN/0/
C
C     PUT IN CALIBRATION DATA
      IF(INIT.GT.0) GO TO 30
C
C     PUT IN CALIBRATION CONSTS.
      CALL SETSL(HCAL,0,20000,0)
      READ(20) LENG,(HBBB(I),I=1,LENG)
C     WRITE(6,890) LENG,(HBBB(I),I=1,20)
C890  FORMAT(21I6)
      HP=10
      NCAL(2)=HP
      HP=HP+HP+1
      DO 10 I=1,2880
      HCAL(HP)=HIN(2,I)
      HCAL(HP+1)=HIN(4,I)
      HP=HP+2
10    CONTINUE
C     WRITE(6,900) (HCAL(I),I=22,5782,2)
C900  FORMAT(20I6)
      INIT=1
C
30    IF(HRUN.LE.0) RETURN1
      IFG=0
      NCAL(7)=3000
C
40    READ(21,END=60) NLENG,(HBAD(I),I=1,NLENG)
      IF(NLENG.LT.11) GO TO 40
      IF(NEVNT.LT.500) GO TO 55
      NCAL(3001)=NLENG
      DO 50 I=1,NLENG
50    HBUF(I)=HBAD(I)
55    IF(HHRUN.LT.HRUN) GO TO 40
      IF(HHRUN.GT.HRUN) GO TO 60
      WRITE(6,610) HRUN
  610 FORMAT(1X,'$$$ RUN # ',I4,' FOUND$$$ GOOD GOOD ')
      HARUN=HHRUN
      REWIND 21
C
      RETURN
C     WRITE(6,920) (HBUF(J),J=1,NLENG)
C920   FORMAT(10(2I6,1X))
C
60    REWIND 21
      WRITE(6,600) HRUN,HARUN
  600 FORMAT(1X,'*** RUN # ',I4,' NOT FOUND***  *USE',I4)
      RETURN
      END

C   03/08/85 508062008 MEMBER NAME  DEFMAC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DEFMAC
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  17/07/85 :  DEFINE A NEW MACRO OF COMMANDS
C
C LAST MOD:   C. BOWDERY   3/08/85 :  CHECK THAT NAME IS UNIQUE
C
C     THIS ROUTINE DEFINES A NEW MACRO COMMAND. FIRST THE NAME IS
C     PROMPTED FOR, THEN THE INPUT OF THE COMMANDS IS REQUESTED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS
      LOGICAL*1  CDEF
C
      COMMON / CWORK  / NFIELD, CHARS(80), ISTAFL(80), IENDFL(80)
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
C------------------  C O D E  ------------------------------------------
C
      IF( MACNR .LT. 30 ) GO TO 5
        WRITE(6,2)
   2    FORMAT(' 30 macros already defined. No room for more.')
        RETURN
C
   5  WRITE(6,10)
  10  FORMAT(' Please enter the NAME of the new macro (8 letters max.)')
      READ(5,40) CHARS
  40  FORMAT(80A1)
C
C                            FIND THE NAME
C
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .EQ. 0 ) RETURN
C
C                            CORRECT LENGTH AND ONLY ONE?
C
      LEN = IENDFL(1) - ISTAFL(1) + 1
      IF( NFIELD .EQ. 1  .AND.  LEN .LE. 8 ) GO TO 60
        WRITE(6,50)
  50    FORMAT(' Sorry. Only one name of 8 letters or less and no ";"',
     +         '. Please try again')
        GO TO 5
C
C                            IS THE NAME UNIQUE?
C
  60  CALL FINABR( CHARS(ISTAFL(1)), LEN, IREC, MAXARG, IS )
      IF( IREC .LE. 0 ) GO TO 70
        WRITE(6,65)
  65    FORMAT(' A command or macro with that name already exists.'/
     +         ' Use EDITMAC if you wish to redefine a macro   or')
        GO TO 5
C
C                            READ DEFINITION
C
  70  MACNR = MACNR + 1
C
  75  WRITE(6,80)
  80  FORMAT(' Please enter the definition of the macro (1 line)')
C
      READ(5,90) (CDEF(K,MACNR),K=1,80)
  90  FORMAT(80A1)
C
C                            NULL LINE?
C
      CALL LOCFLD( CDEF(1,MACNR), NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .GT. 0 ) GO TO 100
        MACNR = MACNR - 1
        WRITE(6,95)
  95    FORMAT(' Macro definition aborted. No macro defined.')
        RETURN
C
C
C                            ADD NAME TO COMMAND LIST
C                            COMMAND NUMBER IS MACRO NUMBER + BASE NO.
C
 100  NUMCMD = MACNR + MACSTA
      CALL SETCMD( NUMCMD, CHARS(ISTAFL(1)), 0, 0,0,0 )
C
      RETURN
      END

C   05/05/81 706201701  MEMBER NAME  ZRECAL   (JADEGS)      FORTRAN
      SUBROUTINE ZRECAL(IJETU,IJETC)
C*820817*DITTMANN*******************  LAST CHANGE: 03.6.87 K.AMBRUS *
C*                                                                  *
C*               Z   C A L I B R A T I O N                          *
C*                                                                  *
C*       DETERMINE HIT STRING PARAMETERS DT, DL, DW (THIS REQUIRES  *
C*       AN EXISTING PATR BANK),                                    *
C*       CORRECT RAW AMPLITUDES FOR PEDESTALS AND GAINS,            *
C*       CORRECT UNDERSHOOT FOR HITS AFTER FIRST HIT,               *
C*       REMOVE Z-T CORRELATION (DISTORTION OF AMPLITUDES IF TRACK  *
C*       NEAR WIRE PLANE),                                          *
C*       CORRECT FOR STRING Z-DISTORTION AND EFFECTIVE WIRE LENGTH. *
CHANGED 03/06/87 K.AMBRUS
C*       NO Z-CALIBRATION FOR OVERFLOW - HITS
C*       PROTECTION AGAINST HDATA - OVERFLOW CAUSING NEGATIVE AMPLITUDES
C********************************************************************
#include "cdata.for"
      INTEGER*2 HDATA
      COMMON /CZSCAL/ IPVERS,ZAL,RESFAC,SECH(5)
C----*----------------TCORR(4,96),XTALK(2,96),PAR(7,1536)-------------
C-----------
      COMMON/CALIBR/JPOINT(1)
      DIMENSION ACALIB(1)
      EQUIVALENCE (JPOINT(1),ACALIB(1))
C-----------
      COMMON /CWORK/ NHIT,IZB(60),IJC(60),IJH(60),NW(60),LH(60),
     *                LRFL(60),ALU(60),ARU(60),X(60),Y(60),Z(60),S(60),
     *                G(60),DT(60),DL(60),DW(60),FCORR(60)
      DIMENSION IHIT(16),ALT(6),ART(6),TT(6)
C-----------
      IPN = JPOINT(11)
C-----------
      IJETU2 = IJETU*2 + 2
      IJETC2 = IJETC*2 + 2
C                                   SWITCH BETWEEN FORMATS DL8/DL300
      IBNKDS = HDATA(IJETU2-1)
      TSCALE = 1.
      IF( MOD(IBNKDS,10) .GT. 1 ) TSCALE = 64.
C
C        LOOP OVER ALL HITS OF ONE TRACK
C        AND DETERMINE HIT STRING PARAMETERS
      NDT = 0
      DO 9 I=1,NHIT
      JC = IJC(I)
      JU = JC - IJETC2 + IJETU2
      NC = NW(I) / 16
C        FIND HIT STRINGS
      IF(NDT.EQ.0) GOTO 4
      IF(NC.NE.NCL) GOTO 6
      IF(LRFL(I).NE.LRFLL) GOTO 6
      IF(NDT.EQ.16) GOTO 5
    4 NDT = NDT + 1
      IWL = LAND(NW(I),15) + 1
      TL = HDATA(JU+3)/TSCALE
      IHIT(NDT) = I
      IF(NDT.NE.1) GOTO 5
      IWF = IWL
      TF = TL
      NCL = NC
      LRFLL = LRFL(I)
    5 IF(I.NE.NHIT) GOTO 9
C        HIT STRING COMPLETED
    6 DTI = 0.
      DWI = IWL - IWF
      IF(DWI.GT.0.) DTI=(TL-TF)/DWI
      DLI = (IWF+IWL) / 2.
      DO 7 J=1,NDT
      K = IHIT(J)
      IF (K.LE.0 .OR. K.GT.60) GOTO 7
      DT(K) = DTI
      DW(K) = DWI
    7 DL(K) = DLI
      NDT = 0
      IF(I.NE.NHIT) GOTO 4
    9 CONTINUE
C        LOOP OVER ALL HITS OF ONE TRACK
C        AND CALIBRATE AMPLITUDES
      DO 39 I=1,NHIT
      JC = IJC(I)
      JU = JC - IJETC2 + IJETU2
      IW = NW(I) + 1
      NC = NW(I)/16 + 1
      NL = LAND(NW(I),15) + 1
      NH = LH(I)
      IF (NH.LE.0 .OR. NH.GT.60) GOTO 39
      T = HDATA(JU+3)/TSCALE
      IF(T.GT.255.) GOTO 37
C        PEDESTAL AND  GAIN
      J = 2
      IF(NH.GT.1) J=5
C-----AR = HDATA(JU+1)*PAR(J,IW) - PAR(J+2,IW)
      AR = HDATA(JU+1)*ACALIB(IPN+577+J+(IW-1)*7)   -
     +                 ACALIB(IPN+579+J+(IW-1)*7)
C-----AL = HDATA(JU+2)           - PAR(J+1,IW)
      AL = HDATA(JU+2)           - ACALIB(IPN+578+J+(IW-1)*7)
C-----EFFL = PAR(1,IW)
      EFFL = ACALIB(IPN+578+(IW-1)*7)
C
      ALU(I) = AL
      ARU(I) = AR
CHANGED 1: 10/05/87
           IF(HDATA(JU+1).GE.4095 .OR. HDATA(JU+2).GE.4095) GO TO 36
      IF(AL.LE.0. .OR. AR.LE.0.) GOTO 36
C        MULTIPLE HIT UNDERSHOOT
      IF(NH.EQ.1) GOTO 30
      MH = NH - 1
      JUPH = JU + MH*4
      DO 29 J=1,MH
      K = 2
      IF(J.NE.1) K=5
      TP = HDATA(JUPH+3)/TSCALE
      IF(TP.GT.255.) GOTO 37
C-----ARP = HDATA(JUPH+1)*PAR(K,IW) - PAR(K+2,IW)
      ARP = HDATA(JUPH+1)*ACALIB(IPN+577+K+(IW-1)*7)  -
     +                    ACALIB(IPN+579+K+(IW-1)*7)
C-----ALP = HDATA(JUPH+2)           - PAR(K+1,IW)
      ALP = HDATA(JUPH+2)           - ACALIB(IPN+578+K+(IW-1)*7)
      IF(J.EQ.1) GOTO 25
      KH = J - 1
      DO 24 K=1,KH
      TDIF = TP - TT(K) - SECH(1)
      SECHC = SECH(2)*EXP(-SECH(3)*TDIF) - SECH(4)*EXP(-SECH(5)*TDIF)
      ARP = ARP + ART(K)*SECHC
   24 ALP = ALP + ALT(K)*SECHC
   25 IF(J.EQ.MH) GOTO 26
      ART(J) = ARP
      ALT(J) = ALP
      TT(J) = TP
   26 TDIF = T - TP - SECH(1)
      SECHC = SECH(2)*EXP(-SECH(3)*TDIF) - SECH(4)*EXP(-SECH(5)*TDIF)
      AR = AR + ARP*SECHC
      AL = AL + ALP*SECHC
   29 JUPH = JUPH - 4
C        Z DISTORTION
   30 ZD = 0.
      IF(DW(I).LT.6.) GOTO 32
      IF(ABS(DT(I)).GT.4.) GOTO 32
C-----ZD = XTALK(1,NC) * (NL-DL(I))*DT(I) * EXP(-XTALK(2,NC)*DT(I)**2)
      ZD = ACALIB(IPN+386+(NC-1)*2)  * (NL-DL(I))*DT(I) *
     +                        EXP(-ACALIB(IPN+387+(NC-1)*2)*DT(I)**2)
C        Z-T CORRELATION
C--32 TDIF = TCORR(3,NC) - T
   32 TDIF = ACALIB(IPN+4+(NC-1)*4)  -  T
      IF(TDIF.LT.0.) GOTO 33
C-----ZTCOR = 0.5*TDIF**2*(AL*TCORR(1,NC) - AR*TCORR(2,NC))
      ZTCOR = 0.5*TDIF**2*(AL*ACALIB(IPN+2+(NC-1)*4) -
     +                                      AR*ACALIB(IPN+3+(NC-1)*4))
      AL = AL + ZTCOR
      AR = AR - ZTCOR
C        EFFECTIVE WIRE LENGTH
   33 FCORR(I) = EFFL/(1.+ZD)
      CORR = (FCORR(I)-1.) * (AL-AR)/2.
      AL = AL + CORR
      AR = AR - CORR
C
   36 IF(AR.LT.0.) AR=0.
      IF(AL.LT.0.) AL=0.
CHANGED 2: 03/06/87
           IF(AR.GT.4095.) AR=4095.
           IF(AL.GT.4095.) AL=4095.
      GOTO 38
   37 AR = 0.
      AL = 0.
   38 HDATA(JC+1) = AR*8. + .49
      HDATA(JC+2) = AL*8. + .49
   39 CONTINUE
C
      RETURN
      END

C   19/04/85 504191421  MEMBER NAME  MUHITS   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUHITS( NHITS )
C-----------------------------------------------------------------------
C
C
C     PROVIDES NUMBER OF MUON HITS.  MUANAC IS CALLED IF NO MUR1
C     BANK ALREADY EXISTS FOR THIS EVENT.
C
C
C LAST CHANGE 14.00 19/04/85 C. BOWDERY  --- CALL MUANAB BEFORE MUANAC
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            COMMONS
C
#include "cmubcs.for"
C
C------------------  C O D E  ------------------------------------------
C
C                            LOCATE MUR1/0 IF EXISTING
C
      CALL CLOC(IP0,'MUR1',0)
      IF( IP0 .GT. 0 ) GO TO 1
C
C                            MUR1/0 NOT FOUND - CALL MUANAC TO CREATE IT
C                            BUT FIRST CALL MUANAB TO EXTRACT HEAD INFO
C
        CALL MUANAB
        CALL MUANAC
C
        CALL CLOC(IP0,'MUR1',0)
        IF( IP0 .LE. 0 ) GO TO 98
C
C                            MUR1/0 FOUND. EXTRACT NUMBER OF MU HITS
C
  1   NHITS = IDATA(IP0+1)
C
      RETURN
C
C
C                            ERROR CONDITIONS
C
 98   CALL MUERRY('MUHITS',0,'''MUR1'' CANNOT BE CREATED.^')
      NHITS = 0
      RETURN
C
      END

C   02/03/79 311301635  MEMBER NAME  ACTOF    (S)           FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE ACTOF(P,R,TRL)
C      CHANGED IN NCNT PART ON 29/05/79   BY E.ELSEN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       DIMENSION P(10),R(3)
C
C      P(5)= MASS, P(6)= ABS(MOMENTUM), R= 3-VECOTR, TRL= PATH-LENGTH
C
C     GEOMETRICAL CONST
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2,BLPHI
C
C    RTOF= 920.  ZTOFPL= 1500.  ZTOFMI= -1500.
C
       COMMON/CTWRK/IADC(2,42),ITDC(2,42)
C
        DATA PAI,CVEL,DUMP/ 3.1415927, 2.9979246E2, -1.4E-4/
        DATA TUNIT,  WM,   WP,  A0M,  A0P,  CM,  CP, TRAN/
     *       0.05, -50., -51., 200., 200., 40., 40., 162./
C
C---------  CHECK Z-POSITION ON THE TOF COUNTER
C
       Z= R(3)
       IF(ABS(Z).GT.ZTOFPL) RETURN
C
C----------  DEFINE THE HIT COUNTER NUMBER
C
       PHAI= ATAN2(R(2),R(1))
       IF(PHAI.LE.0.) PHAI= PHAI+2.*PAI
       DPAI= PAI/21.
       NCNT= ( PHAI + DPAI/2. ) / DPAI + 1
       IF(NCNT.GT.42) NCNT= 1
C------- TIME OF FLIGHT
       PMAS2= P(5)*P(5)
       DPMAS= P(5)/P(6)
       EGEV= SQRT(P(6)*P(6)+PMAS2)
       BETA= P(6)/EGEV
       VELO= BETA*CVEL
       TOF= TRL/VELO
C------- ADC COUNT
       ZDP= ZTOFPL-Z
       TPLUS= ZDP/TRAN
       ZDM= Z-ZTOFMI
       TMINS= ZDM/TRAN
       ADCA= 100.*(DPMAS+2.)
       ADCM= ADCA*(DUMP*ZDM+1.)
       ADCP= ADCA*(DUMP*ZDP+1.)
       IF(ADCM.GE.1024.) ADCM= 1024.1
       IF(ADCP.GE.1024.) ADCP= 1024.1
C-------- PULSE HEIGHT CORRECTION
        TCM= WM*(1./SQRT(A0M)-1./SQRT(ADCM))+CM
        TCP= WP*(1./SQRT(A0P)-1./SQRT(ADCP))+CP
C-------- TDC COUNT
        NPLUS= (TOF+TPLUS+TCP)/TUNIT + 0.5
        NMINS= (TOF+TMINS+TCM)/TUNIT + 0.5
        IF(NPLUS.GT.ITDC(2,NCNT)) GO TO 500
             ITDC(2,NCNT)= NPLUS
             IADC(2,NCNT)= ADCP
 500    IF(NMINS.GT.ITDC(1,NCNT)) GO TO 600
             ITDC(1,NCNT)= NMINS
             IADC(1,NCNT)= ADCM
 600    RETURN
       END

C   29/06/82 206291130  MEMBER NAME  CMUED    (JADEMUS)     FORTRAN
C             11.20 29/06/82 HUGH MCCANN
      COMMON /CMUED/NCHAN
C  NCHAN IS THE NO. OF I*2 WORDS WHICH ARE CHANGED BY THE CURRENT EDITS.
C    THIS APPROACH IS ADOPTED IN ORDER TO AVOID INITIALISING LOCATIONS
C  IN /CWORK/ .

C   13/01/84 401130954  MEMBER NAME  MUFINI   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUFINI
C-----------------------------------------------------------------------
C
C LAST CHANGE 16.30 11/01/84 CHRIS BOWDERY : PRINT NOTHING IF ALL ZEROS
C      CHANGE 09.49 12/09/79 JOHN ALLISON.
C
C     TO BE CALLED WHEN PROCESSING IS FINISHED.
C     PRINTS MUON STATISTICS IF MUPRIN.GE.2. (DEFAULT = 2)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                           COMMONS
C
#include "cmustat.for"
C
      COMMON /CMUPRN/ MUPRIN
C
C-----------------  C O D E  -------------------------------------------
C
C                           IS STATISTICS PRINTOUT WANTED?
C
      IF( MUPRIN .LT. 2 ) RETURN
C
C                           ARE THERE ANY NON-ZERO STATISTICS TO PRINT?
C                           IF NOT PRINT NOTHING.
C
      J = 0
      DO  1  I = 1,100
        J = J + IABS( NMU(I) )
  1   CONTINUE
      IF( J .EQ. 0 ) RETURN
C
C                           PRINT MUON STATISTICS
C
      WRITE(6,2) ( ( MUTIT(I),NMU(I) ),I=1,100 )
   2  FORMAT(////'      *****  MUON ANALYSIS STATISTICS  *****'/
     +                    20( /1X,5(A8,1X,I5,9X) )//
     +           '      *****  END OF MUON STATISTICS  *****'/////  )
C
      RETURN
      END

C   18/07/79 212011859  MEMBER NAME  RZROLL   (JADEGS)      FORTRAN
      SUBROUTINE RZROLL
C---
C---   DISPLAY IMPACT POINTS OF CHARGED TRACKS ON THE ROLLED OUT RZVIEW
C---       J.OLSSON  03.11.82    LAST CHANGE 03.11.82
C---
      IMPLICIT INTEGER*2 (H)
      COMMON /CJTRIG/ PI,TWOPI
#include "cgeo1.for"
      COMMON /CZGEO/ RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,ZCHSS,
     $               ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      COMMON /CZKON/ ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
#include "cgraph.for"
#include "cdata.for"
C
      ADDERZ = 24.*DLZPHI
      ADDRAD = ADDERZ/TWOPI
      FI48 = TWOPI/48.
      COS48 = COS(FI48)
      RINRZ = RZCHI/COS48
      RUTRZ = RZCHA/COS48
      R1I = RZCHI + ZCHA
      R2I = RZCHI + ZCHB
      ADY = 1500. + Z2ZCH
      IPO = IDATA(IBLN('PATR'))
      IF(IPO.GT.0) GO TO 1900
      CALL TRMOUT(80,' NO PATR BANK..^')
      RETURN
1900  ICNT = 0
      LO = IDATA(IPO+1)
      NTR = IDATA(IPO+2)
      LTR = IDATA(IPO+3)
      IPO = IPO + LO - LTR
200   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 21
      IPO = IPO + LTR
      ITR = IDATA(IPO + 1)
C** DISPLAY TRACKS
      IFLGX = IDATA(IPO+29)
      CALL RZTRCK(50,IDATA(IPO+18),ADATA(IPO+19),ADATA(IPO+20),
     $ ADATA(IPO+21),ADATA(IPO+22),ADATA(IPO+5),ADATA(IPO+6),
     $ ADATA(IPO+12),ADATA(IPO+13),ADATA(IPO+31),ADATA(IPO+30),
     $ XP,YP,ZP,XP2,YP2,ZP2,IFLGX)
      IF(IFLGX.NE.2) GO TO 200
      FIP = ATAN2(YP,XP)
      IF(FIP.LT.0.) FIP = FIP + TWOPI
      X1 = 0.
      X2 = X1 + FIP*ADDRAD
      Y1 = ADY
      Y2 = Y1 + ZP
201   CALL PLYGON(9,.35*DLZZ,X2,Y2,0)
      SIZE = 60.
      CALL NUMBWR(30,ITR,X2+.45*DLZZ,Y2,SIZE)
      CALL MOVEA(X2,Y2)
      IF(IFLGX.NE.2) GO TO 200
      FIP = ATAN2(YP2,XP2)
      IF(FIP.LT.0.) FIP = FIP + TWOPI
      X1 = 0.
      X2 = X1 + FIP*ADDRAD
      Y1 = ADY
      Y2 = Y1 + ZP2
      CALL DRAWA(X2,Y2)
      GO TO 200
21    CONTINUE
      RETURN
      END

C--------------------------------------
C  MACRO CXYFIT .... XYFIT EQUIVALENCES
C--------------------------------------
          LOGICAL TBIT
          EQUIVALENCE(ADWRK(1),TYPE1)
          EQUIVALENCE(ADWRK(2),XSTR)
          EQUIVALENCE(ADWRK(3),YSTR)
          EQUIVALENCE(ADWRK(4),RSTR)
          EQUIVALENCE(ADWRK(5),DXSTR)
          EQUIVALENCE(ADWRK(6),DYSTR)
          EQUIVALENCE(ADWRK(7),DRSTR)
          EQUIVALENCE(ADWRK(8),TYPE2)
          EQUIVALENCE(ADWRK(9),XEND)
          EQUIVALENCE(ADWRK(10),YEND)
          EQUIVALENCE(ADWRK(11),REND)
          EQUIVALENCE(ADWRK(12),DXEND)
          EQUIVALENCE(ADWRK(13),DYEND)
          EQUIVALENCE(ADWRK(14),DREND)
          EQUIVALENCE(ADWRK(15),NPTYPE)
          EQUIVALENCE(ADWRK(16),COEFF1)
          EQUIVALENCE(ADWRK(17),COEFF2)
          EQUIVALENCE(ADWRK(18),COEFF3)
          EQUIVALENCE(ADWRK(19),COEFF4)
          EQUIVALENCE(ADWRK(20),RMSFIT)
          EQUIVALENCE(ADWRK(21),NPUSED)
          EQUIVALENCE(ADWRK(22),CURVT)
          EQUIVALENCE(ADWRK(23),DCURV)
          EQUIVALENCE(ADWRK(24),CURV1)
          EQUIVALENCE(ADWRK(25),CURV2)
CC
          INTEGER*2JTR(10),NHITIN(10)
          REAL*4CHITR(10)
          EQUIVALENCE(ADWRK(26),JTR(1))
          EQUIVALENCE(ADWRK(31),NHITIN(1))
          EQUIVALENCE(ADWRK(36),CHITR(1))
C         - - - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(45),CHITR(10))
          EQUIVALENCE(ADWRK(46),NTRTOT)
CC
          EQUIVALENCE(ADWRK(47),NHIT)
          EQUIVALENCE(ADWRK(48),NTRAK)
          EQUIVALENCE(ADWRK(49),KNTROL)
          EQUIVALENCE(ADWRK(50),ISTORY)
          LOGICAL*1LARR(4),PRINT,FATAL,BADFIT,SETFLG
          EQUIVALENCE(ADWRK(51),LARR(1),PRINT)
          EQUIVALENCE(          LARR(2),FATAL)
          EQUIVALENCE(          LARR(3),BADFIT)
          EQUIVALENCE(          LARR(4),SETFLG)
CC
          EQUIVALENCE(ADWRK(61),SP1,ISP1)
          EQUIVALENCE(ADWRK(62),SP2,ISP2)
          EQUIVALENCE(ADWRK(63),SP3,ISP3)
          EQUIVALENCE(ADWRK(64),SP4,ISP4)
          EQUIVALENCE(ADWRK(65),SP5,ISP5)
          EQUIVALENCE(ADWRK(66),SUMX)
          EQUIVALENCE(ADWRK(67),SUMY)
          EQUIVALENCE(ADWRK(68),SUMXY)
          EQUIVALENCE(ADWRK(69),SUMX2)
          EQUIVALENCE(ADWRK(70),SUMX3)
          EQUIVALENCE(ADWRK(71),SUMX4)
          EQUIVALENCE(ADWRK(72),SUMX2Y)
          EQUIVALENCE(ADWRK(73),X1)
          EQUIVALENCE(ADWRK(74),Y1)
          EQUIVALENCE(ADWRK(75),X2)
          EQUIVALENCE(ADWRK(76),Y2)
CCC
          EQUIVALENCE(ADWRK(93),NMPROG)
          EQUIVALENCE(ADWRK(94),NPTS)
C         EQUIVALENCE(ADWRK(95),NDF)
          EQUIVALENCE(ADWRK(96),XMID)
          EQUIVALENCE(ADWRK(97),YMID)
          EQUIVALENCE(ADWRK(98),SINTH)
          EQUIVALENCE(ADWRK(99),COSTH)
          EQUIVALENCE(ADWRK(100),C2)
          EQUIVALENCE(ADWRK(101),C3)
          EQUIVALENCE(ADWRK(102),C4)
          EQUIVALENCE(ADWRK(103),CURV)
          EQUIVALENCE(ADWRK(104),CHIFIT)
          EQUIVALENCE(ADWRK(105),CHICIR)
          EQUIVALENCE(ADWRK(106),XFIRST)
          EQUIVALENCE(ADWRK(107),XLAST)
          EQUIVALENCE(ADWRK(108),NGOOD)
          EQUIVALENCE(ADWRK(109),NBAD)
          EQUIVALENCE(ADWRK(110),NEXTRA)
          LOGICAL*1USED(80)
          EQUIVALENCE(ADWRK(111),USED(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(130),USED(80))
          REAL*4AX(80),AY(80)
          EQUIVALENCE(ADWRK(131),AX(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(210),AX(80))
          EQUIVALENCE(ADWRK(211),AY(1))
C          - - - - - - - - - - - - - -
C         EQUIVALENCE(ADWRK(290),AY(80))
C---------- END OF MACRO CXYFIT --------------

C   12/03/84 406181741  MEMBER NAME  SRSUM    (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C    THIS SUBROUTINES SUMS ALLL ADC DATA IN ARRAY CATAG ONE END OR THE
C    OTHER TO GIVE THE VALUE OF SUM.
C
C JPART - INPUT - SIGN DETERMINES WHICH END TAGGER IS ANALYSED
C                  JPART > 0 = > +Z
C                  JPART < 0 = > -Z
C
C  SUM - OUTPUT - SUM OF ENERGY
C
C RETURN 1 IF SUM IS A CRAZY VALUE
C
C   A.J.FINCH  10/12/92
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE SRSUM(JPART,SUM,*)
C
#include "cgraph.for"
C
#include "cwktag.for"
C
       DATA ICOUNT / 0 /
C
C = == CODE ===
C
C GET THE RELEVANT POINTERS
C
       ISTART = ISTMZ
       IEND   = IENDMZ
       IF ( JPART .GT. 0 ) ISTART = ISTPZ
       IF ( JPART .GT. 0 ) IEND   = IENDPZ
C
C CALCULATE SUM
C
       SUM = 0.0
       DO 10 I = ISTART,IEND
          SUM = SUM + CATAG(I)
 10    CONTINUE
       IF ( (SUM .LT. 50000.0) .AND. (SUM .GE. 0.0) ) RETURN
C
C
C----------------------------------- ERROR MESSAGES -------------------
C
C
       IF ( NDDINN .NE.  0 ) RETURN 1
       IF ( ICOUNT .GE. 10 ) RETURN 1
       WRITE(6,600) SUM
 600   FORMAT(/,' **** WARNING MESSAGE FROM TAGGING ROUTINE  - SRSUM -',
     *        /,'  SUM HAS A CRAZY VALUE  ',E10.2)
       WRITE(6,603)
 603   FORMAT(1X,' LARGE VALUES MAY BE CAUSED BY DIRTY',
     *           ' BEAM CONDITIONS OR EXTREME PEDESTAL FLUCTUATION')
       WRITE(6,602)
 602   FORMAT(1X,' RAW TAGGING ADC BANK -ATAG- WILL BE PRINTED ',/,/)
       CALL HPRS('ATAG',0)
       ICOUNT = ICOUNT + 1
       IF ( ICOUNT .EQ. 10 ) WRITE(6,601)
 601   FORMAT(1X,' * NO MORE ERROR MESSAGES FROM SRSUM WILL BE PRINTED')
       RETURN 1
       END

C   23/03/97 703231949  MEMBER NAME  MTRINF   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MTRINF         SAVED BY F22HAG  ON 87/04/03  AT 18:35
C
C     -------------- GENERALL TRACK-INFO COMMON -------------------
      DIMENSION IP(10,400)
      COMMON // P(10,400)
      EQUIVALENCE(IP(1,1),P(1,1))
C
      DIMENSION IPE(10,400)
      COMMON /CTRCK0 / NTCH,NTALL,PE(10,400),INDTRK(400),ITRFLG(400)
      EQUIVALENCE(IPE(1,1),PE(1,1))
C

C   10/01/80 001111204  MEMBER NAME  GGRESQ   (S)           FORTRAN
      SUBROUTINE GGRESQ(NADC,NCLUS,*)
C---  CLEARS CONTENTS OF UNPHYSICAL BLOCKS
C---  (IF CONTENT BELOW CERTAIN THRESHOLD, AT THE MOMENT: 11)
C---  AND REORDERS POINTERS
C
C     H.WRIEDT     10.01.80    16:20
C     LAST MODIFICATION      11.01.80     12:00
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),HGGADC(2,192),IWORK2(263),
     &               ID,HTRACK(3),HCLST,HCLBEC(2),HNCLST,HCOL,HTYPE,HER,
     &               HCORR,HPBLAT,HDUMIN(2),HSCAL(36),HWORD(2),ACOLAN,
     &               ETOT(3),ENTOT(3),IWORK3(16),HCLMAP(2,51),
     &               CLSPRP(13,51)
C
      NADR = HGGADC(1,NADC)
      HGGADC(2,NADC) = 0
      LNG = LNG - 1
C---  CONTRACT HGGADC
C---  LAST FILLED ADC
      NFIN = HCLMAP(2,HCLST)
      IF (NADC.EQ.NFIN) GOTO 3
      NFIN = NFIN - 1
        DO 1 I = NADC,NFIN
        HGGADC(1,I) = HGGADC(1,I+1)
    1   HGGADC(2,I) = HGGADC(2,I+1)
      IF (HCLMAP(1,NCLUS).EQ.HCLMAP(2,NCLUS)) GOTO 3
      II = NADC - 2
      WRITE(6,600) ((HGGADC(K,J+II),K=1,2),J=1,3)
  600 FORMAT(/' ***** ERROR DETECTED IN GGRESQ, UNPHYSICAL CLUSTER',
     &        ' CONSISTS OF MORE THAN 1 BLOCK, LG ANALYSIS OF WHOLE',
     &        ' EVENT SKIPPED'/6(2X,I6))
      RETURN 1
C
C---  CORRECT HCLMAP
    3 IF (NCLUS.EQ.HCLST) GOTO 5
      NFIN = HCLST - 1
        DO 4 I = NCLUS,NFIN
        HCLMAP(1,I) = HCLMAP(1,I+1)
    4   HCLMAP(2,I) = HCLMAP(2,I+1)
C---  CORRECT HCLST AND HPOINT
    5 HCLST = HCLST - 1
      IF (HCLST.LE.0) RETURN 1
      HNCLST = HCLST
      IF (NADR.GT.96) GOTO 6
      HCLBEC(1) = HCLBEC(1) - 1
      HPOINT(2) = HPOINT(2) - 2
      GOTO 7
    6 HCLBEC(2) = HCLBEC(2) - 1
    7 HPOINT(3) = HPOINT(3) - 2
C
      NCLUS = NCLUS - 1
      RETURN
      END

C   08/02/79 C9092001   MEMBER NAME  LGCRNR   (SOURCE)      FORTRAN
      SUBROUTINE LGCRNR( IPART, IDZ, IPN, ICLS)
C
C      S.YAMADA   08-02-79  23:40
C      LAST MODIFICATION  10-09-79  19:50  Y.WATANABE
C
C---- FLAG IF THE COUNTER IS A CORNER BLOCK IN THE CLUSTER.
C
C---- INPUTS:
C        IPART=BARREL(0), OR END CAPS(+/-1)
C        IZD= IZ(BARREL) OR ID(NO.IN THE QUODRANT FOR END CAPS, 1-24)
C        IPN= IPHI(BARREL) OR IN( NO. IN THE END CAPS,  1--96)
C---- OUTPUT:
C        ICLS=1 IF THE BLOCK IS ON AN EDGE. =0 IF NOT.
C
C
      ICLS=0
      IF(IPART) 20,10,20
C
C---- BARREL (RING 1 AND 32 ARE MISSING NOW)
   10 IF(IDZ.LE.1 .OR. IDZ.GE.30) GO TO 50
      RETURN
C
C---- END CAP
   20 IF(IDZ.LE.4) GO TO 50
      IF(IDZ.LT.16) GO TO 100
      IF(IDZ.EQ.20) GO TO 100
C
C---- EDGE BLOCK
   50 ICLS=1
C
  100 RETURN
      END

C   01/11/84 807271804  MEMBER NAME  DEFCMD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DEFCMD
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY  11/05/84 :  DEFINE COMMANDS
C
C       MOD:   C. BOWDERY  20/06/84 :  CSLT CHANGED TO CSTL
C       MOD:   C. BOWDERY   5/07/84 :  COMMAND 'MORE' ADDED
C       MOD:   J. HAGEMANN 19/10/84 :  COMMANDS 'VC' AND 'VAC' ADDED
C       MOD:   C. BOWDERY  15/07/85 :  ALPHABETIC ORDERING NOW
C       MOD:   C. BOWDERY  17/07/85 :  SETF AND CPAR OUT.Q AND QX IN
C       MOD:   C. BOWDERY  18/07/85 :  COMMAND MACRO ADDED
C       MOD:   C. BOWDERY   3/08/85 :  COMMAND EDITMAC ADDED
C       MOD:   C. BOWDERY   5/08/85 :  COMMANDS RENAMAC,DELMAC ADDED
C       MOD:   C. BOWDERY  12/08/85 :  COMMAND LIM REMOVED
C       MOD:   C. BOWDERY  17/08/85 :  SYNONYMS ADDED
C       MOD:   C. BOWDERY  20/12/85 :  HLP / LASER ADDED
C       MOD:   J. HAGEMANN 04/02/86 :  VTXC AND PICK ADDED
C       MOD:   C. BOWDERY  20/12/85 :  HLP / LASER ADDED
C       MOD:   J. HAGEMANN 04/02/86 :  VTXC AND PICK ADDED
C       MOD:   G. ECKERLIN 31/07/86 :  J68K (135) ADDED
C       MOD:   J.OLSSON    16/04/87 :  HLP WITH ARGUMENT
C       MOD:   G. ECKERLIN 15/05/87 :  ZFIT (136) ADDED
C       MOD:   C. BOWDERY  23/07/87 :  LASER HAS ARGUMENT TOO
C       MOD:   J. HAGEMANN 25/07/88 :  NEW COMMANDS ADDED
C                                      (EDVP,DAX,VCDO,DIST,MUTYP)
C  LAST MOD:   C. BOWDERY  27/07/88 :  PRINT AND BW HAVE 2 ARGUMENTS
C
C     THIS ROUTINE SETS UP A LIST OF COMMANDS THAT IS USED BY
C     KOMMAN, THE COMMAND INTERPRETER OF THE JADE GRAPHICS PROGRAM.
C     EACH COMMAND HAS A SHORT FORM (UP TO 8 LETTERS), AN IDENTITY
C     NUMBER WHICH DOES NOT HAVE TO BE UNIQUE TO A GIVEN STRING, NUMBER
C     OF ARGUMENTS ALLOWED AND UP TO 3 ASSOCIATED COMMAND WORD POINTERS.
C
C     THUS A COMMAND CAN RECOGNISED FROM ITS ABBREVIATION, E.G. RA
C     OR FROM ITS FULL FORM, E.G. FRONT ID VIEW.
C     ALTERNATIVE WORDS MAY BE RECOGNISED LIKE 'INNER DETECTOR' OR
C     SHORT FORMS LIKE 'FR' WHERE THIS IS UNAMBIGUOUS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C
C-----------------------------  MACRO CGRCOM  --------------------------
C
C                            THIS MACRO DEFINES THE NAMES OF THE
C                            VARIABLES WHICH POINT TO COMMAND WORDS.
C
C
      COMMON / CGRCO1 /   HADC,   HADD,   HALTER, HAMPL,  HAXES,
     +                    HBANK,  HCAPS,  HCHAM,  HCHANG, HCLUST,
     +                    HCOMMD, HCOMEN, HCONT,  HCOPY,  HCOUNT,
     +                    HCWORK, HCYL,   HDATA,  HDEDX,  HDEL,
     +                    HDETLS, HDET,   HDISP,  HDRAW,  HEDIT,
     +                    HENDC,  HEVENT, HEXT
C
      COMMON / CGRCO2 /   HFAMP,  HFILTR, HFIND,  HFIT,   HFLAG,
     +                    HFLASH, HFORWD, HFRONT, HFW,    HGLASS,
     +                    HGOOD,  HHARD,  HHELP,  HID,    HINNER,
     +                    HJET,   HJETC,  HJUMP,  HLEAD,  HLEVEL,
     +                    HLG,    HLIMIT, HLIST,  HMAP,   HMASS,
     +                    HMENU,  HMUON,  HMUPT
C
      COMMON / CGRCO3 /   HNEWS,  HNEXT,  HNO,    HNORD,  HNR,
     +                    HNUMB,  HOPT,   HPARAM, HPARMS, HPATR,
     +                    HPATRN, HPHI,   HPICK,  HPLOTS, HPROJ,
     +                    HQ,     HRECAL, HRECOG, HREGN,  HRESET,
     +                    HRESLT, HRETRN, HR,     HRZ,    HSAVE,
     +                    HSCALE, HSET,   HSHOW
C
      COMMON / CGRCO4 /   HSIDE,  HSTAND, HSTAT,  HTAGG,  HTOF,
     +                    HTOP,   HTRACK, HTRUE,  HTRIG,  HT1,
     +                    HT2,    HT3,    HVERTX, HVIEW,  HVTXC,
     +                    HWRK,   HWRITE, HXY,    HXZ,    HZ
C
C----------------------------  END OF MACRO CGRCOM  --------------------
C
C
C------------------  C O D E  ------------------------------------------
C
C                            FIRST DEFINE THE COMMAND WORDS.
C                            THIS INVOLVES CREATING A DICTIONARY OF
C                            ENGLISH WORDS LIKE 'FRONT', 'VIEW', ETC.
C                            COMMONS CGRCO1/2/3/4 ARE FILLED WITH
C                            POINTERS TO THE COMMAND WORDS.
C
      CALL COMWRD
C
C                            NOW DEFINE THE COMMANDS.
C                            THESE CONSIST OF A NUMBER, SHORT FORM, MAX.
C                            NUMBER OF ARGUMENTS AND
C                            UP TO THREE COMMAND WORD POINTERS.
C
C                            COMMANDS 1 TO 100 ARE DISPLY COMMANDS,
C                            OF WHICH COMMANDS 1 TO 30 ARE VIEWS.
C                            SOME COMMANDS ARE SYNONYMS FOR OTHERS.
C
C                            FOR THE HELP SYSTEM, COMMANDS ARE NOW
C                            IN ALPHABETIC ORDER.
C
C                            CURRENTLY DEFINED  COMMANDS:
C                            - VIEW DISPLY COMMANDS:         1...20 + 30
C                            - NON-VIEW DISPLY COMMANDS:    31...68
C                            - SCANNR COMMANDS:            101..136
C
C                            - DELETED COMMANDS:  110,116,117
C
      CALL SETCMD(123,'AX      ',2,HDISP,HJET,HAXES)
      CALL SETCMD(107,'BDLS    ',2,HDEL,HBANK,0)
      CALL SETCMD( 54,'BL      ',1,HCHANG,HLG,HOPT)
      CALL SETCMD( 32,'BW      ',2,HBANK,HWRITE,0)
C
      CALL SETCMD(108,'C       ',0,HCONT,HNEXT,HLEVEL)
      CALL SETCMD( 42,'CDST    ',1,HLIST,HDISP,HOPT)
      CALL SETCMD( 41,'CDTL    ',1,HCHANG,HDISP,HOPT)
      CALL SETCMD(102,'CLUS    ',1,HDISP,HCLUST,0)
C
      CALL SETCMD( 39,'COM     ',0,HADD,HCOMEN,0)
      CALL SETCMD(115,'CS      ',1,0,0,0)
      CALL SETCMD(114,'CSTL    ',1,HCHANG,HSTAND,HLEVEL)
      CALL SETCMD(115,'CSTV    ',1,HCHANG,HSTAND,HVIEW)
C
      CALL SETCMD( 14,'CYL     ',1,HLG,HCYL,0)
      CALL SETCMD( 65,'DAX     ',1,HDISP,HAXES,0)
      CALL SETCMD(119,'DEDX    ',1,HDISP,HDEDX,0)
      CALL SETCMD(107,'DELETE  ',2,0,0,0)
      CALL SETCMD(133,'DELMAC  ',0,0,0,0)
C
      CALL SETCMD( 38,'DET     ',1,HDET,HDISP,0)
      CALL SETCMD( 67,'DIST    ',1,0,0,0)
      CALL SETCMD( 56,'DRAW    ',1,HDRAW,0,0)
      CALL SETCMD( 57,'EC      ',1,HADD,HENDC,HLG)
C
      CALL SETCMD(118,'EDIT    ',0,HEDIT,HTRACK,HPATR)
      CALL SETCMD(132,'EDITMAC ',0,0,0,0)
      CALL SETCMD( 64,'EDVP    ',0,0,0,0)
      CALL SETCMD(113,'END     ',0,0,0,0)
      CALL SETCMD(113,'EXIT    ',0,0,0,0)
      CALL SETCMD(124,'FADC    ',0,HDISP,HFLASH,HADC)
      CALL SETCMD(127,'FAMP    ',0,HDISP,HFAMP,HRESLT)
C
      CALL SETCMD( 58,'FC      ',1,HADD,HFW,HTAGG)
      CALL SETCMD(122,'FIND    ',2,HFIND,HEVENT,0)
      CALL SETCMD( 12,'FW      ',1,HTAGG,HFW,HMAP)
      CALL SETCMD( 15,'FWMU    ',1,HFORWD,HMUON,HCOUNT)
      CALL SETCMD(104,'GVTX    ',1,HFIT,HVERTX,0)
C
      CALL SETCMD( 33,'H       ',1,HHARD,HCOPY,0)
      CALL SETCMD( 46,'HELP    ',0,HHELP,HCOMMD,HMENU)
      CALL SETCMD( 61,'HLP     ',1,0,0,0)
      CALL SETCMD( 34,'HX      ',0,HHARD,HCOPY,HEXT)
C
      CALL SETCMD(135,'J68K    ',1,0,0,0)
      CALL SETCMD( 60,'JETC    ',1,HCHANG,HJETC,HBANK)
      CALL SETCMD( 37,'JOYS    ',1,HCHANG,HSCALE,0)
C
      CALL SETCMD(109,'JUMP    ',1,HJUMP,HLEVEL,0)
      CALL SETCMD( 61,'LASER   ',1,0,0,0)
      CALL SETCMD(114,'LEVELS  ',1,0,0,0)
      CALL SETCMD(131,'MACRO   ',0,0,0,0)
      CALL SETCMD( 49,'MASS    ',0,HMASS,HDISP,0)
      CALL SETCMD( 35,'MENU    ',0,HCOMMD,HLIST,0)
      CALL SETCMD(129,'MORE    ',0,0,0,0)
C
      CALL SETCMD(106,'MUONS   ',1,HDISP,HGOOD,HMUON)
      CALL SETCMD(105,'MUPT    ',2,HDISP,HMUON,HRESLT)
      CALL SETCMD( 55,'MUR2    ',0,HLIST,HMUON,HRESLT)
      CALL SETCMD( 68,'MUTYP   ',0,HDISP,HGOOD,HMUON)
      CALL SETCMD(111,'N       ',1,HDISP,HNEXT,HEVENT)
      CALL SETCMD(128,'ND50    ',0,HDISP,HNORD,HRESLT)
C
      CALL SETCMD(129,'NEW     ',0,0,0,0)
      CALL SETCMD( 44,'NEWS    ',0,HLIST,HNEWS,0)
      CALL SETCMD(111,'NN      ',1,0,0,0)
      CALL SETCMD(126,'NWCL    ',0,HRECAL,HEVENT,0)
      CALL SETCMD( 41,'OPT     ',1,0,0,0)
C
      CALL SETCMD( 59,'PATR    ',1,HCHANG,HPATR,HBANK)
      CALL SETCMD( 63,'PICK    ',0,HPICK,0,0)
      CALL SETCMD( 32,'PRINT   ',2,0,0,0)
      CALL SETCMD( 40,'PRO     ',1,HPROJ,HDISP,HADD)
C
      CALL SETCMD( 33,'Q       ',1,0,0,0)
      CALL SETCMD(120,'QP      ',1,HDISP,HQ,HPLOTS)
      CALL SETCMD( 34,'QX      ',0,0,0,0)
C
      CALL SETCMD(113,'QUIT    ',0,0,0,0)
      CALL SETCMD(  1,'RA      ',1,HFRONT,HID,0)
      CALL SETCMD(  2,'RB      ',1,HFRONT,HLG,0)
      CALL SETCMD(  3,'RC      ',1,HFRONT,HMUON,0)
C
      CALL SETCMD(126,'RECAL   ',0,0,0,0)
      CALL SETCMD(134,'RENAMAC ',0,0,0,0)
      CALL SETCMD( 45,'RES     ',1,HDISP,HRESLT,0)
C
      CALL SETCMD( 36,'RESET   ',0,0,0,0)
      CALL SETCMD( 48,'RET     ',0,HRETRN,HEDIT,0)
      CALL SETCMD( 36,'RS      ',0,HRESET,HSCALE,0)
C
      CALL SETCMD( 13,'RU      ',1,HLG,HMAP,0)
      CALL SETCMD( 16,'RZ      ',1,HZ,HCHAM,HMAP)
      CALL SETCMD( 30,'S       ',1,0,0,0)
      CALL SETCMD( 51,'SAVE    ',1,HSAVE,HEDIT,HWRK)
C
      CALL SETCMD(101,'SPVA    ',2,0,0,0)
      CALL SETCMD( 42,'STAT    ',1,0,0,0)
      CALL SETCMD(113,'STOP    ',0,0,0,0)
      CALL SETCMD( 30,'STVW    ',1,HSTAND,0,0)
      CALL SETCMD(121,'TOF     ',1,HDISP,HTOF,0)
C
      CALL SETCMD( 47,'TR      ',1,HDISP,HTRACK,HID)
      CALL SETCMD( 50,'TRG2    ',0,HDISP,HT2,HTRIG)
      CALL SETCMD( 43,'TRLG    ',0,HDISP,HT1,HTRIG)
      CALL SETCMD( 31,'TRUE    ',1,HTRUE,HTRACK,HDISP)
C
      CALL SETCMD(130,'VAC     ',1,HVERTX,HCHAM,HAMPL)
      CALL SETCMD( 20,'VC      ',1,HVERTX,HCHAM,0)
      CALL SETCMD( 66,'VCDO    ',1,0,0,0)
      CALL SETCMD(104,'VFIT    ',1,0,0,0)
      CALL SETCMD( 52,'VRES    ',1,HVERTX,HTRACK,HRESLT)
      CALL SETCMD( 17,'VRX     ',0,HFRONT,HVERTX,HREGN)
C
      CALL SETCMD( 18,'VRZX    ',0,HTOP,HVERTX,HREGN)
      CALL SETCMD( 19,'VRZY    ',0,HSIDE,HVERTX,HREGN)
      CALL SETCMD( 62,'VTXC    ',1,HCHANG,HVTXC,HBANK)
      CALL SETCMD( 53,'VX      ',1,HDISP,HVERTX,0)
      CALL SETCMD(112,'WRIT    ',1,HWRITE,HEVENT,0)
C
      CALL SETCMD( 16,'ZC      ',1,0,0,0)
      CALL SETCMD(136,'ZFIT    ',2,0,0,0)
      CALL SETCMD( 37,'ZOOM    ',1,0,0,0)
      CALL SETCMD(125,'ZTRG    ',0,HDISP,HZ,HTRIG)
      CALL SETCMD(103,'ZV      ',1,HDISP,HZ,HVERTX)
C
      CALL SETCMD(  4,'ZXA     ',1,HTOP,HID,0)
      CALL SETCMD(  5,'ZXB     ',1,HTOP,HLG,0)
      CALL SETCMD(  6,'ZXC     ',1,HTOP,HMUON,0)
C
      CALL SETCMD(  7,'ZXD     ',1,HTOP,HFW,0)
      CALL SETCMD(  8,'ZYA     ',1,HSIDE,HID,0)
      CALL SETCMD(  9,'ZYB     ',1,HSIDE,HLG,0)
      CALL SETCMD( 10,'ZYC     ',1,HSIDE,HMUON,0)
      CALL SETCMD( 11,'ZYD     ',1,HSIDE,HFW,0)
C
C
      RETURN
      END

C   09/03/84 807241310  MEMBER NAME  CTDIST   (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE CTDIST
C-----------------------------------------------------------------------
C
C   AUTHOR:  J. HAGEMANN   19/09/86 : CALCULATES DISTANCE BETWEEN TWO
C                                     POINTS GIVEN BY JOYSSTICK INPUT
C                                     (MODE 0)
C  LAST MOD: J. HAGEMANN   24/11/86 : CALCULATE DISTANCE BETWEEN SELEC-
C                                     TED TRACK AND ONE POINT GIVEN BY
C                                     JOYSSTICK (MODE 1)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FLVCDO
C
#include "cdata.for"
#include "cgraph.for"
C
      COMMON / CWORK1 / HWORK(40),SIZEWN,RANGE,XCENT,YCENT
      COMMON / CVX    / NNPATR,ICRSTR,NNJETC,NNVTXC
      COMMON / CGVCDO / FLVCDO(20)
C
C------------------  C O D E  ------------------------------------------
C
C                            CHECK IF DIST IS POSSIBLE FOR THIS VIEW
      IF( LASTVW .GT. 11 .AND. LASTVW .LT. 17 ) GO TO 4000
C                            GET MODE GIVEN BY FIRST ARGUMENT
      MODE = IFIX(ACMD)
      IF( MODE .EQ. 0 .OR. MODE .EQ. 2 ) GO TO 400
C
C                            SELECT TRACK NUMBER AND POINT ON SCREEN
C
C                            CHECK IF DIST IS POSSIBLE FOR THIS VIEW
      IF( LASTVW .GT. 3 .AND. LASTVW .NE. 17 .AND. LASTVW .NE. 20 )
     &         GO TO 4000
      CALL CLOC(IPPATR,'PATR',NNPATR)
      IF( IPPATR .GT. 0 ) GO TO 310
         WRITE(6,9301) NNPATR
 9301    FORMAT(' PATR BANK NR',I3,' (GIVEN BY COMMAND PATR) NOT EXISTIN
     &G')
         GO TO 5000
  310 CONTINUE
      IPHWDS = IDATA(IBLN('HWDS'))
      IF( FLVCDO(15) .AND. IPHWDS .GT. 0 ) IPPATR = IPHWDS
      IHD = IDATA(IPPATR+1)
      ITL = IDATA(IPPATR+3)
      NTR = IDATA(IPPATR+2)
      CALL TRMOUT(80,' Select track number:^')
  320 CALL TRMIN( 4, ICD )
      CALL GETINT( ICD, ITRK )
      IF( ITRK .GT. 0 .AND. ITRK .LE. NTR ) GO TO 330
C
         WRITE(6,9321) ITRK,NTR
 9321    FORMAT(' Track number ',I3,' is outside valid range (1 - ',I3,'
     &)')
         GO TO 320
C
  330 CALL TRMOUT(80,' Now select point with hair cross!^')
C
      CALL VCURSR(HWORK(1),XGET,YGET)
C
      IPTR = IPPATR + IHD + (ITRK-1)*ITL
      CALL DRTRCK(IPTR,-XGET,YGET,DR)
      DR = ABS(DR)
      WRITE(6,9331) DR
 9331 FORMAT(' DISTANCE: ',F12.3)
C
      GO TO 5000
C
C                            FLASH CURSOR ON SCREEN AND AWAIT RESULT
C
  400 CALL TRMOUT(80,' Now select FIRST point with hair cross!^')
C
      CALL VCURSR(HWORK(1),XGET1,YGET1)
C
      CALL TRMOUT(80,' Now select SECOND point with hair cross!^')
C
      CALL VCURSR(HWORK(1),XGET2,YGET2)
C
      DD12 = SQRT((XGET2-XGET1)**2 + (YGET2-YGET1)**2)
      WRITE(6,9401) DD12
 9401 FORMAT(' DISTANCE: ',F12.3)
C
      GO TO 5000
C
 4000 CALL TRMOUT(80,' Sorry, DIST not available for this view!^')
C
 5000 CONTINUE
C
      RETURN
      END

C   21/03/83 807251813  MEMBER NAME  TRN4V    (S)           FORTRAN
      SUBROUTINE TRN4V(MODE,IPPATR,ISTART,NLENG,NCONT,ISTAT,IER)
C----------------------------------------------------------------
C---     VERSION ???      P.STEFFEN
C---     STORE 4-VECTORS OF CHARGED TRACKS + NEUTRALS IN COMMON /CTRCK0
C---     MODIFICATION  24.2.86                R.RAMCKE
C---     MODE = 0 INCLUSIVE NEUTRALS
C---          = -1  WITHOUT NEUTRALS
C---     MODIFICATION  19.9.86                R.RAMCKE
C---     MODIFICATION  23.1.87                R.RAMCKE
C---     MODIFICATION  16.4.87                R.RAMCKE
C---     MODIFICATION   2.7.87                J.HAGEMANN     IER SET
C---     MODIFICATION  25.11.87               J.HAGEMANN     UPDATED
C        CUT FOR MOMENTUM-RESCALING SET BY DEFAULT OR ENTRY TRNSET
C        INPUT  MODE
C               IPPATR = POINTER TO PATR-BANK
C               ISTART = ISTARTINDEX OF STATISTICS ARRAY
C               NLENG  = LENGTH OF STATITICS ARRAY
C               NCONT  = ISTART + NUSED + 1 : FIRST FREE IN STAT ARRAY
C               ISTAT  =  STATISTICS ARRAY
C        OUTPUT   COMMON / CTRCK0 / NTCH,NTALL,P(20,200),INDTRK(200)
C               NTCH = USED CHARGED TRACKS
C               NTALL = IF MODE = 0 THEN NTALL = NTCH + NEUTRALS
C                                   ELSE NTALL = NTCH
C               FOR EACH TRACK I:
C               P(1,I)  = PX
C               P(2,I)  = PY
C               P(3,I)  = PZ
C               P(4,I)  = E = SQRT(P**2 + M(PI)**2)
C               P(5,I)  = M(PI)
C               P(6,I)  = P TOTAL
C               P(7,I)  = CHARGED +-1.0
C               P(8,I)  = RAPIDITY
C               P(9,I)  = P TRANSVERS
C              IP(10,I) = TRACK# IN PATR BANK
C         ADDITIONAL INFOMATION
C               PE(1,I)  = DIST TO RUN-VTX + OUTSIDE - INSIDE CIRCLE
C               PE(2,I)  = X } CLOSEST APPROACH TO VERTEX
C               PE(3,I)  = Y
C               PE(4,I)  = DX }  DIRECTION OF PARTICLE
C               PE(5,I)  = DY }  AT THE VERTEX
C               PE(6,I)  = SIGMA RPHI OF TRACK
C              IPE(7,I)  = # OF ALL HITS FOR FIT
C              IPE(8,I)  = # OF VTXC HITS FOR FIT
C               PE(9,I)  = COSPHI TO JETAXIS
C              IPE(10,I) = 1) JADE PARTICLE-TYPE*1000
C                          2) ORIGIN FLAG FROM PARORG * 100
C                          3) LEPTON QUALITY (*1 FOR E, *10 FOR MU)
C
C               INDTRK(IPATTRK#) = POS IN P-ARRAY
C------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
#include "calibr.for"
C                         MACRO FOR TRACK-INFO
#include "mtrinf.for"
C
C
      DIMENSION RES(10),ISTAT(NLENG)
C
C     /////////////////// STANDARD-CUTS ON TRACKS////////////////////
      DATA SIG / 0.60 / , MHITS / 12 /, SIGZ /120.0 /, MZHITS / 12 /,
     *     ZDIS / 200.0 /,TRKL2/ 75635.0 /,DRPHI / 20.0 /
C     ////////////////////////////////////////////////////////////////
C
      DATA LBINIT /0/ ,CUT / 17.5 /
C
      IF(LBINIT.NE.0) GOTO 100
         LBINIT = 1
         IQHEAD = IBLN('HEAD')
CCC      IQPATR = IBLN('PATR')
         IQLGCL = IBLN('LGCL')
         WRITE(6,876) CUT
 876     FORMAT(/' ++++ TRN4V ++++  MOMENTUM RESCALING : ' ,F8.2/)
C
         AMPI = .140
C
         ELGMIN = .100
         ELGTRK = .450
         NUSED = 5
         NCONT = ISTART + NUSED
C
  100 CONTINUE
C
        IER    = 0
        NTALL = 0
        NTCH = 0
        DO 23 I = 1,400
          ITRFLG(I) = 0
  23      INDTRK(I) = 0
C
C       GET RUN # + EVENT #
        IPHEAD = IDATA(IQHEAD)*2
        NRUN = HDATA(IPHEAD+10)
C
C       CHECK IF PATR-BANK WITH >1 TRACK
CCC     IPPATR = IDATA(IQPATR)
        IF(IPPATR.LE.0) GOTO 900
C       CHECK IF >0 TRACKS
        NTR=IDATA(IPPATR+2)
        IF(NTR.LE.0) GOTO 900
C
C       GET X-Y-VERTEX
        CALL VTXCRV( NRUN, XO, YO ,XDX, YDY)
C
COLD    IPV    = ICALIB(10)
COLD    XO     = ACALIB(IPV+ 1)
COLD    YO     = ACALIB(IPV+ 3)
C
C
        L0=IDATA(IPPATR+1)
        LTR=IDATA(IPPATR+3)
        IPTR1=IPPATR+L0-LTR
C
        DO 39 ITR=1,NTR
           IPTR1 = IPTR1 + LTR
C                                          DETERMINE 4-MOMENTUM
           CALL TRPVTX(IPTR1,XO,YO,RES)
C
C            RES(1)   : DR = DISTANCE (XV,YV)-TRACK(IPTR)
C                                  +VE IF OUTSIDE CIRCLE
C                                  -VE IF INSIDE CIRCLE
C            RES(2)   : X-POSITION OF CLOSEST POINT
C            RES(3)   : Y-POSITION OF CLOSEST POINT
C            RES(4)   : X-DIRECTION AT CLOSEST POINT (ONLY IN R-FI)
C            RES(5)   : Y-DIRECTION AT CLOSEST POINT (ONLY IN R-FI)
C            RES(6)   : )
C            RES(7)   : )  DIRECTION COSINES IN SPACE
C            RES(8)   : )
C            RES(9)   : PT, TRANSVERSE MOMENTUM
C            RES(10)  : P , MOMENTUM
C
C                                          CHECK R-FI-FIT, # OF HITS
 33        ISTAT(ISTART) = ISTAT(ISTART)+ 1
           IF(ADATA(IPTR1+23) .GT. SIG .OR.
     *        IDATA(IPTR1+24).LE. MHITS) GOTO 38
C                                          CHECK ZFIT, # OF HITS
           ISTAT(ISTART+1) = ISTAT(ISTART+1)+ 1
           IF(ADATA(IPTR1+32) .GT. SIGZ .OR.
     *        IDATA(IPTR1+33) .LE. MZHITS)  GOTO 38
C                                          Z(TRACK) < 100. MM
           ISTAT(ISTART+2) = ISTAT(ISTART+2)+ 1
           IF(ABS(ADATA(IPTR1+31)) .GT. ZDIS) GOTO 38
C                                          MEASURED LENGTH > 275 MM
           ALMSQ = (ADATA(IPTR1+12) - ADATA(IPTR1+5))**2
     *           + (ADATA(IPTR1+13) - ADATA(IPTR1+6))**2
           ISTAT(ISTART+3) = ISTAT(ISTART+3)+ 1
           IF(ALMSQ .LT. TRKL2) GOTO 38
C                                        CHECK IF TRACK FROM MAIN VERTEX
           ISTAT(ISTART+4) = ISTAT(ISTART+4)+ 1
           IF(ABS(RES(1)) .GT. DRPHI) GOTO 38
C                                        REGISTRER NEW TRACK
           ISTAT(ISTART+5) = ISTAT(ISTART+5)+ 1
           NTALL = NTALL + 1
           ITRFLG(NTALL) = 1
           RES(10) = AMIN1(RES(10),CUT)
           P ( 1,NTALL) = RES(10) * RES(6)
           P ( 2,NTALL) = RES(10) * RES(7)
           P ( 3,NTALL) = RES(10) * RES(8)
           P ( 4,NTALL) = SQRT(RES(10)**2 + AMPI**2)
           P ( 5,NTALL) = AMPI
           P ( 6,NTALL) = RES(10)
           P ( 7,NTALL) =-SIGN(1.,ADATA(IPTR1+25))
           P ( 8,NTALL) = 0.
           P ( 9,NTALL) = RES( 9)
           IP(10,NTALL) = IDATA(IPTR1+1)
C
           DO 32 K = 1,5
 32           PE(K,NTALL) = RES(K)
           PE (6,NTALL) = ADATA(IPTR1+23)
           IPE(7,NTALL) = IDATA(IPTR1+24)
           IPE(8,NTALL) = 0
           IF(LTR .EQ. 64) IPE(8,NTALL) = IDATA(IPTR1+59)
C
           IDTRCK = IDATA(IPTR1+1)
           IF(IDTRCK.GT.0 .AND. IDTRCK.LE.400) INDTRK(IDTRCK) = NTALL
C
C
           GOTO 39
   38      CONTINUE
   39   CONTINUE
C
        NTCH = NTALL
        IF(MODE .EQ. -1) GOTO 900
C
C       SET # OF CHARGED TRACKS
C
C                                      --- ADD NEUTRALS ---
      IPLGCL = IDATA(IQLGCL)
      NCLST = IDATA(IPLGCL+7)
      IF (NCLST.LE.0) GOTO 900
C
  120 IP3 = IDATA(IPLGCL+3)
      LCLST = IDATA(IPLGCL+25)
      IP1 = IPLGCL + IP3 -1
      IP7 = IP1 + (NCLST-1) * LCLST
      JC = 0
C                                      --- LOOP OVER ALL CLUSTERS ---
      DO 150 L=IP1,IP7,LCLST
         JC = JC + 1
         ECL = ADATA(L+2)
         ICON = IDATA(L+8) / 100
         ITR  = IDATA(L+8) - ICON*100
         IF(ICON .GT. 1) ITR  =-ITR
         IF(ICON .LT. 0) GOTO 150
C          SUBTR. EQUIV. ENERGY FOR TRACKS FROM CLUSTER ---
           ETOT = ECL - ELGTRK*ICON
           IF (ETOT.LT.ELGMIN) GOTO 150
           NTALL = NTALL + 1
           ITRFLG(NTALL) = 2
           P ( 1,NTALL) = ETOT * ADATA(L+ 9)
           P ( 2,NTALL) = ETOT * ADATA(L+10)
           P ( 3,NTALL) = ETOT * ADATA(L+11)
           P ( 4,NTALL) = ETOT
           P ( 5,NTALL) = 0.
           P ( 6,NTALL) = ETOT
           P ( 7,NTALL) = 0.
           IP( 8,NTALL) = ITR
           P ( 9,NTALL) = ETOT * SQRT(1.-ADATA(L+11)**2)
           IP(10,NTALL) = JC
  150 CONTINUE
C
C
  900 CONTINUE
C                                  FIND JET TO WHICH BELONGS TRACK
      NH = NTALL
      NH1 = NH+1
      CALL SPTHAK(1,NH,0,THR,NH1,SPHR,0,AKO,IER )
C
      IF(IER .NE. 0) RETURN
C
      DO 1000 I = 1,NTALL
         RNORM = SQRT((P(1,NH1)**2 + P(2,NH1)**2)*
     *           (P(1,I)**2 + P(2,I)**2))
C
         PE(9,I) = -100.
         IF( RNORM .GT. 0.0)
     *      PE(9,I) = (P(1,I)*P(1,NH1) + P(2,I)*P(2,NH1))/RNORM
 1000 CONTINUE
C
C
      RETURN
      ENTRY TRNSET(X)
      CUT = X
      RETURN
C
      END

C--------------START OF MACRO CMUFRCH-----------------------------------
C
C /CMUNIT/,/CMFFIX/,/CMFSUR/,/CMCFIX/,/CMCSUR/,/CMCELE/ AND /CMCSTA/ ARE
C   DESCRIBED ON 'F22ALL.JADEMUS(@MUINFOM)'. THEY CAN BE READ FROM
C   A OS DATA SET (PRESENTLY 'F22ALL.MUSQUEEZ.DATA'), OR FROM
C   THE APPROPRIATE MU CALIBRATION DATA BOS RECORD, E.G.,
C   'F22ALL.MUCALIB.DATA0001'.
C
      COMMON /CMUCDV/NVERSN,DESCRP(15)
C
      COMMON /CMUNIT/HOVALL(6)
C
      COMMON/CMFFIX/HMFFIX(740)
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C
      COMMON/CMFSUR/HMFSUR(492)
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C
      COMMON/CMCFIX/HMCFIX(636)
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C
      COMMON/CMCSUR/HMCSUR(1268)
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C
      COMMON/CMCELE/HMCELE(4440)
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C
      COMMON/CMCSTA/HMCSTA(634)
C
C---------------END OF MACRO CMUFRCH------------------------------------

C   18/10/79 912170202  MEMBER NAME  ANOM83   (S)           FORTRAN
      SUBROUTINE ANOM83(IRUN)
C---  ANOMALIES OF RUNS 1846 - 1865
C---  15.46 GEV      OCTOBER 1979 (AFTER SHUT-DOWN)
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     17.12.79     02:00
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1846,1847,1848,1849,1850,1851,1852,1853,1854,1855,1856,1857,
     &      1858,1859,1860,1861,1862,1863,1864,1865),IRUN
   13 RETURN
C
 1846 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 135
      KCONST(162) = -1
      LIMIT(162) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(190) = -1
      LIMIT(190) = 90
C
      RETURN
C
 1847 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1848 PRELIMINARY
 1848 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1849 PRELIMINARY
 1849 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1850 PRELIMINARY
 1850 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1851 PRELIMINARY
 1851 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1852 PRELIMINARY
 1852 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1853 PRELIMINARY
 1853 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1854 PRELIMINARY
 1854 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1855 PRELIMINARY
 1855 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 390
      KCONST(187) = -1
      LIMIT(187) = 390
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1856 PRELIMINARY
 1856 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1857 PRELIMINARY
 1857 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(178) = -1
      LIMIT(178) = 120
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1858 PRELIMINARY
 1858 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
      LCHANN(186) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1859 PRELIMINARY
 1859 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
      LCHANN(186) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1860 PRELIMINARY
 1860 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
      LCHANN(186) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1861 PRELIMINARY
 1861 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
      LCHANN(186) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 90
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 120
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1862 PRELIMINARY
 1862 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1863 PRELIMINARY
 1863 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1864 PRELIMINARY
 1864 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
C1865 PRELIMINARY
 1865 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
      END

C   11/12/78 003112237  MEMBER NAME  LGAVDE   (SOURCE)      FORTRAN
      SUBROUTINE LGAVDE(ZAV,NPCLS,JEG,DEP)
C
C     S.YAMADA  11-12-78  14:55
C     LAST MODIFICATION    08-03-79   22:35
C     LAST MODIFICATION    13-09-79   20:00 BY Y.WATANABE
C
C----   AVERAGE DEPTH OF THE SHOWER IS CALCULATED BY ITERATION.
C                    FOR END CAP PARTS
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(6000)
      INTEGER *2 HDATA(12000)
      REAL ADATA(6000)
      EQUIVALENCE (HDATA(1),IDATA(1)), (ADATA(1),IDATA(1))
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX
      COMMON /CLGMSB/ MSGVAL,AMSGV1,AMSG2
      DATA JEGBB/1/
C     SPECIAL VERSION FOR BHABHA
C
      EMEV =ADATA(NPCLS+2)*1000.
      ZAV1 = ABS(ZAV-ZVRTX)
      DEPO = 0.
      R2   = ADATA(NPCLS+4)**2+ADATA(NPCLS+5)**2
C
C---- AVERAGE SHOWER DEPTH ALONG THE AXIS = SM
      SM = SHMAX(EMEV,JEGBB)
C
      NTRY = 0
    4 NTRY = NTRY+1
      IF(NTRY.GT.20) GO TO 21
      DEP = SM/SQRT(1.0+R2/(ZAV1+DEPO)**2)
      IF(ABS(DEP-DEPO)/DEP.LE.0.01) GO TO 3
      DEPO = DEP
      GO TO 4
C
   21 MSGVAL = NTRY
      AMSGV1 = DEPO
      AMSGV2 = DEP
      CALL LGMESG( 10,1)
C
    3 RETURN
      END

C   26/10/81 709102206  MEMBER NAME  LGCR56Y  (S)           FORTRAN
      SUBROUTINE LGCR56(T,DEPTH,ALPHA,BETA2,XU,JBC)
C
C     S.YAMADA     07-03-78  10:35
C     COPIED FROM (LGCRGN) IN LGSOURCE FOR JADE STANDARD M.C.
C     LAST MODIFICATION   26-10-81  22:00
C-----THIS ADDS SHOWER CONTRIBUTION INTO LG-DATA COMMON CLGHIT/.
C     NEW CALIBRATION CONS IS SET IN LGMCIN. NOW DATA IS IN MEV.
C
C   MODIFIED FROM LGCRGN TO ACCOUNT FOR DIFFERENCES BETWEEN SF5/SF6
C       23.1.1986   J.OLSSON
C
C    SF5 OR SF6 IS GIVEN BY VALUE OF IMATTR   (2 OR 3)
C
C---- INPUTS
C     T = TRACK SEGMENT LENGTH IN RAD.LENGTH
C     ALPHA = PROJ.COSINE TO THE COUNTER SURFACE NORMAL.
C     DEPTH = THE AVERAGE DEPTH OF THE SEGMENT
C     BETA = VELOCITY OF THE TRACK
C     XU(1-3) = THE POSITION (AND THE DIRECTION) OF THE SEGMENT
C        THE UNIT OF THE POSITION IS RAD.LENGTH
C     JBC=+-1 FOR END CAP,JBC=0 FOR BARREL PART.
C
      IMPLICIT INTEGER *2 (H)
C
      DIMENSION XU(3)
      DIMENSION RVN2(2),AN2(2),AN21R(2)
      COMMON /CMATTR/ IMATTR,IMTLIS(10),XCM(10)
      COMMON /CLGHIT/ RDARRY(2880)
      COMMON /CLGG56/ CONS(2),ECUTCR,ARED(2),IADCTH
C
C  SHOWER MC COMMON
C
      COMMON /CLGD56/ RADIUS(6),ZEND(2),ZWID,ZGAP,PHWID,
     2                ECXLST(24), ECYLST(24),ZECAP(4),ZPV(4),TPV,
     3                TH(4),THECP
C
      COMMON / COLSON/ IPRO
C
C     CONSTANTS FOR N=1.6725,    SF5 REFRACTIVE INDEX
C     CONSTANTS FOR N=1.805      SF6 REFRACTIVE INDEX
C
C RVN2 = 1/N**2
C AN2  = N**2
C AN21R IS NOT KNOWN, HOWEVER, IT MULTIPLIES (N**2 - 1/BETA**2)
C        THEREFORE IT SHOULD CONTAIN 1/N**2 AND THE VALUE USED HERE
C        IS BASED ON THIS ASSUMPTION        22.4.87, J.O.
C
      DATA RVN2/0.35738,0.30693/, AN2/2.7973,3.2580/
      DATA AN21R/0.5564,0.4777/
C                                 PHIDEV IS DELTAPHI FOR ONE BLOCK
      DATA PHIDEV/7.47998E-2/
      DATA ICAL56/0/
C
      ICAL56 = ICAL56 + 1
      IF(ICAL56.EQ.1.OR.IPRO.GT.1) WRITE(6,4220) IMATTR
4220  FORMAT('   LGCR56 CALLED, IMATTR = ',I3)
C
      IF(IMATTR.NE.2.AND.IMATTR.NE.3) GO TO 3333
C
      XJJ = XCM(IMATTR)*10.
      IF(ICAL56.EQ.1.OR.IPRO.GT.1) WRITE(6,4221) XJJ
4221  FORMAT('   LGCR56:    XJJ = ',E12.4)
C
C---- CHECK VELOCITY
      IF(IPRO.GT.1) WRITE(6,931) BETA2,RVN2(IMATTR-1)
931   FORMAT(' LGCR56: BETA2 RVN2 ',2E12.4)
      IF(BETA2.LE.RVN2(IMATTR-1)) RETURN
C
      RAT = AN21R(IMATTR-1)*(AN2(IMATTR-1)-1./BETA2)
      IF(IPRO.GT.1) WRITE(6,932) IMATTR,RAT,JBC
932   FORMAT(' LGCR56: IMATTR,RAT ',I4,E12.4,'  JBC ',I3)
      IF(RAT.LE.0.) RETURN
C
C---- FIND WHICH ADC TO INCREASE
C
      IF(JBC) 2000,1000,2000
C
C###############
C          BARREL
C###############
C
 1000 PHI = ATAN2(XU(2),XU(1))
      IF(PHI.LT.0.) PHI = PHI+6.283184
      IPHI = PHI/PHIDEV
      IF(IPHI.GE.84) IPHI = IPHI-84
      IF(IPRO.GT.1) WRITE(6,4223) (XU(I),I=1,3),ZEND(1),ZWID,ZGAP
4223  FORMAT('   LGCR56:    XU = ',3E12.4,' ZEND1 ZWID,GAP ',3E12.4)
      IZ =(XU(3)*XJJ-ZEND(1))/(ZWID+ZGAP)+1.0
C********************************************************
C     WRITE(6,6001) IPHI,IZ
C6001 FORMAT(' LGCR56: IPHI,IZ=',2I5)
C********************************************************
      IF(IPRO.GT.1) WRITE(6,933) IZ,PHI,IPHI
933   FORMAT(' LGCR56 IZ ',I10,'  PHI IPHI ',E12.4,I4)
      IF(IZ.LT.1.OR.IZ.GT.32) RETURN
      ICNT = IZ+32*IPHI
      JBC12 = 1
      GO TO 3000
C
C###############
C          ENDCAPS
C###############
C               INPUT TO LGNMEC IS RAD.LENGTH
C
 2000 CALL LGNMEC(XU(1),XU(2),ICNT)
C********************************************************
C     WRITE(6,6000) XU(1),XU(2),ICNT
C6000 FORMAT(' ICNT FOR (',F8.2,1H,,F8.2,')=',I4)
C********************************************************
      IF(IPRO.GT.1) WRITE(6,934) XU(1),XU(2),ICNT
934   FORMAT(' LGCR56 ENDCAP XU1-2 ICNT ',2E13.5,I5)
      IF(ICNT.LE.0) RETURN
      IF(JBC.GT.0) ICNT = ICNT+96
      ICNT = ICNT+2688
      IF(IPRO.GT.1) WRITE(6,935) ICNT
935   FORMAT(' LGCR56 ENDCAP SECOND ICNT ',I10)
      IF(ICNT.GT.2880) RETURN
      JBC12 = 2
C
C---- NO.OF PHOTO-ELECTRONS / RADIATION LENGTH
C
 3000 CONTINUE
      IF(IPRO.GT.1) WRITE(6,4224) DEPTH,ALPHA
4224  FORMAT('   LGCR56:    DEPTH ALPHA ',2E12.4)
      IF(IMATTR.EQ.2) CALL NPECER( JBC12, DEPTH, ALPHA, PE)
      IF(IMATTR.EQ.3) CALL NPECR6( DEPTH, ALPHA, PE)
      IM = IMATTR-1
C
C PE*T IS NR OF PHOTOELECTRONS, CONS IS ADJUSTABLE (MEV RESPONSE)
C ARED (VALUE 0.25) IS OF UNKNOWN ORIGIN
C ECUTCR IS A CORRECTION FACTOR FOR ECUT
C
      RDARRY(ICNT) = RDARRY(ICNT)+PE*RAT*CONS(IM)*ECUTCR*ARED(IM)*T
C
      IF(IPRO.GT.1.OR.IPRO.LT.0) WRITE(6,936) ICNT,IM,
     $ RDARRY(ICNT),PE,T,RAT,CONS(IM),ECUTCR,ARED(IM)
936   FORMAT(' LGCR56 ICNT IM RDARRY ETC ',2I4,7E12.4)
C
      RETURN
C
3333  WRITE(6,8610) IMATTR
8610  FORMAT(' ############     WRONG MATTER INDEX IN LGCR56:  ',I10)
      RETURN
      END
C
      BLOCK DATA
C    S.YAMADA  01-09-78  12:15
C---- LAST MODIFICATION  06-11-81  18:20    INCLUDE P.V.END CAPS.
C---- LAST MODIFICATION  23.1.86  J.OLSSON  VERSION NUMBER FOR SF5-6 MC
C
C---- BLOCK DATA FOR THE LG-COUNTER GEOMETRICAL CONSTANTS
C
C
C  SHOWER MC COMMON
C
      COMMON /CLGD56/ RADIUS(6),ZEND(2),ZWID,ZGAP,PHWID,
     2                ECXLST(24), ECYLST(24),ZECAP(4),ZPV(4),TPV,
     3                TH(4),THECP
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVRSN/4*0, 178090112, 15*0/
C
C---- VERSION NUMBER FOR THE SF5-6 SHOWER MC
C----   THIS NUMBER IS STORED IN WORD 16 OF THE HEAD BANK
C
      COMMON /CVER56/ IVER56
C IVER56=2:  E- AND E+ SEPARATELY TREATED IN IONIZATION ENERGY LOSS
C IVER56=3:  SAME AS IVER56=2, BUT CONS RESCALED
C IVER56=4:  SAME AS IVER56=3, BUT CONS RESCALED:  1.031, 2.0071
C            INTRODUCED ON 10.9.1987
      DATA IVER56 /4/
C
C---- RADIUS IN MM
C     RADIUS(1,2) = DISTANCE TO THE COIL SURFACES(INNER AND OUTER)
C     RADIUS(3,4) = DISTANCE TO THE LEAD GLASS SURFACES(TYPE A)
C     RADIUS(5,6) = DISTANCE TO THE LEAD GLASS SURFACES(TYPE A-PR)
C
      DATA RADIUS/ 900.0, 986.4, 1100.0, 1400.0, 1150.0, 1400.0/
C
C---- THICKNESSES OF COIL, |COIL-INNER LG|, LG, LG
      DATA TH/ 86.4, 115.6, 300.0, 250.0/
C
C---- THE BARREL ENDS
      DATA ZEND/ -1705.45, 1705.45/
C
C---- COUNTER SIZE IN MM (BARREL)
      DATA ZWID/ 103.2/,  PHWID/80.8/
C
C---- COUNTER GAP
      DATA ZGAP/3.5/
C
C---- END CAP WALL POSITIONS
      DATA ZECAP/ -1510.0, -1736.0, 1510.0, 1736.0/
      DATA THECP/ 226.0/
C
C---- ECXLST,ECYLST   X AND Y POSITIONS OF THE ENDCAP COUNTERS
      DATA ECXLST/400., 350., 210., 70., 540., 490., 350., 210.,
     1          70., 680., 630., 490., 350., 210., 70., 820.,
     2          770., 2*630., 2*490., 350., 210., 70./
      DATA ECYLST/70., 210., 350., 400., 70., 210., 350., 490.,
     1          540., 70., 210., 350., 490., 630., 680., 70.,
     2          210., 350., 2*490., 2*630., 770., 820./
C
C
C----- PRESSURE VESSELS
      DATA ZPV/ -1380.0,-1490.90, 1380.0, 1490.90/
      DATA TPV/ 26.15/
      END

C   11/03/79 C9073101   MEMBER NAME  PRITOL   (SOURCE)      FORTRAN
      SUBROUTINE PRITOL(MODE)
C
C     S.YAMADA   18-01-79   18:20
C     LAST MODIFICATION   29-07-79  23:51  CLGWORK2
C
      IMPLICIT INTEGER *2 (H)
C
C
#include "clgwork2.for"
C
      DIMENSION IPHIL(10),IZL(10)
C
      IF(MODE.EQ.2) GO TO 1000
C
C---- DUMP THE SIMULATED CLUSTERS DUE TO THE INNER TRACKS.
C
      KE = NCHCLS+1
      WRITE(6,600) NCHCLS,NPOINT,(MAPCCL(K),K=1,KE)
  600 FORMAT('0 DUMP OF THE SIMULATED CLUSTERS   NCHCLS=',I3,'  NPOINT='
     $,         I4,/' MAPCCL',(10I5,3X,10I5,/'       '))
C
      IF(NPOINT) 2,2,1
    1 WRITE(6,601)
  601 FORMAT(' SIMULATED HITS')
      NP = NPOINT
      IF(NP.GT.300) NP=300
      N = NP/10
      NR = NP-10*N
      N1 = N
      IF(NR.GT.0) N1 = N1+1
      NS = -9
        DO 8 NN=1,N1
        NS = NS+10
        NE = NS+9
        IF(NN.EQ.N1.AND.NR.GT.0) NE = NS+NR-1
C----   POSITION   IPHI-IZ OR TOP/BOT-NUM
   13     DO 13  0 NW=NS,NE
          ID = HCLADR(NW)
          IF(ID.GE.2688) GO TO 131
          IPHI = ID/32
          IZ = ID-32*IPHI
          GO TO 133
  131     IZ = ID-2687
          IF(IZ.GE.96) GO TO 132
          IPHI = 90
          GO TO 133
  132     IZ = IZ-96
          IPHI = 91
  133     INDX = NW-NS+1
          IPHIL(INDX) = IPHI
          IZL(INDX) = IZ
  130     CONTINUE
        WRITE(6,613) NS,(IPHIL(NW),IZL(NW),NW=1,INDX)
  613   FORMAT(' ',I3,10(I4,1H-,I2,1H,))
    8   CONTINUE
C
    2 IF(MODE.EQ.1) RETURN
C
C---- PRINT CONNECTED LG-CLUSTERS FOR EACH INNER TRACK AND CONNECTED
C     INNER TRACKS FOR EACH LG-CLUSTER.
C
 1000 WRITE(6,602)
  602 FORMAT('0 INNER TR.  #OF CON.CL  --INDECES OF LG-CLUSTERS--',
     1    8X,' LG-CLUST.  #OF CON.TR   --INDECES OF INNER TRACKS--')
C
      MIN = NCHCL2
      IF(MIN.GT.NCLST2) MIN = NCLST2
      IF( MIN ) 15,15,11
C
   11   DO 10 N=1,MIN
        WRITE(6,603) N,(HCLIST(K,N),K=1,4),N,(HCLLSO(K,N),K=1,4)
  603   FORMAT(' ',I7,I10,I12,2I6,10X,'I',2I10,I12,2I6)
   10   CONTINUE
C
   15 MIN = MIN+1
      IF(NCLST2-NCHCL2) 1001,100,1002
C
 1001   DO 20 N=MIN,NCHCL2
        WRITE(6,603) N,(HCLIST(K,N),K=1,4)
   20   CONTINUE
      RETURN
C
 1002   DO 30 N=MIN,NCLST2
        WRITE(6,604) N,(HCLLSO(K,N),K=1,4)
  604   FORMAT(' ',51X,'I',2I10,I12,2I6)
   30   CONTINUE
C
  100 RETURN
      END

C   05/11/82 602210950  MEMBER NAME  COPYLB   (JADESR)      FORTRAN
      SUBROUTINE AANAL
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /WRT/ NWRFL
      DATA IZAEL /0/
C
C  ***********                           ***************
C  ***********    COPY OF BOS DATA SETS  ***************
C  ***********                           ***************
C
C      ----------------    SET DATA  -------------------
C
      DATA NSCIP   /      0   /
      DATA NEND    /    200   /
C
      DATA NRUNSC  /      0   /
      DATA NRUNED  / 100000   /
C      -------------------------------------------------
      NWRFL=0
C
      IZAEL=IZAEL+1
      IRUN=HDHEAD(10)
C
      IF (IZAEL.GT.NSCIP .AND. IRUN.GT.NRUNSC) NWRFL=1
      IF (IZAEL.GT.NEND  .OR.  IRUN.GT.NRUNED) NWRFL=0
C
      IF (NWRFL.EQ.0) GOTO 30
      XRUN=IRUN
      CALL HIST(10,XRUN)
C
   30 RETURN
      END

C   07/06/96 606071917  MEMBER NAME  UTABL    (S4)          FORTG1
      SUBROUTINE UTABL(KA,I,J)
      COMMON/BCS/IW(1)
      INTEGER NC/0/
      INTEGER*2 NH(2),NCH(2)
      EQUIVALENCE (NH(1),NW),(NC,NCH(1))
      IF(KA.LE.0) GOTO 100
      IF(I.LT.0.OR.I.GT.255) GOTO 100
      IF(J.LT.0.OR.J.GT.15) GOTO 100
C
      II=I/16
      IJ=I-II*16
      JJ=J/2
      JI=J-JJ*2+1
      NC=KA*16+II
   10 CALL BLOC(IND,'TAB*',NC,&200)
C
      IND=IND+IJ*8+JJ+1
      NW=IW(IND)
      NCH(2)=NH(JI)
      NC=NC+1
      IF(NCH(2).EQ.0) GOTO 100
      NH(JI)=NCH(2)
      IW(IND)=NW
  100 RETURN
  200 CALL BCRE(IND,'TAB*',NC,128,&100,IER)
      IF(IER.NE.0) GOTO 100
      GOTO 10
      END

C   01/11/84 903021643  MEMBER NAME  JADEBD   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
C     J A D E B D   B L O C K   D A T A
C-----------------------------------------------------------------------
C
C     THIS MEMBER CONTAINS A DUMMY SUBROUTINE JADEBD WHICH IS
C     REFERENCED SO THAT THE BLOCK DATA SUBPROGRAM IS LOADED
C     CORRECTLY. THIS BLOCK DATA INITIALISES JADE ANALYSIS PACKAGES.
C
C-----------------------------------------------------------------------
C
      SUBROUTINE JADEBD
      RETURN
      END
C
C-----------------------------------------------------------------------
      BLOCKDATA BL3             ! PMF 01/07/99 add name
C-----------------------------------------------------------------------
C
C
C        MOD  J. HAGEMANN 22/04/83 :  CORRECTION OF SOME GEOMETRICAL AND
C             R. RAMCKE            :  PHYSICAL PARAMETERS
C        MOD  C. BOWDERY  19/12/83 :  JADEBD CREATED. RECOMMENTED.
C        MOD  C. BOWDERY   9/01/84 :  DELETE COMMON /CUNIT/. OBSOLETE.
C        MOD  C. BOWDERY   8/02/84 :  COMMON /CADMIN/ NOW INCLUDED.
C        MOD  C. BOWDERY  13/03/84 :  CDTL DEFAULTS CHANGED.
C        MOD  J. HAGEMANN 21/09/84 :  VERTEX CHAMBER GEOMETRY INCLUDED
C                                     IN NEW COMMONS
C        MOD  C. BOWDERY  20/04/85 :  NEW COMMON / CKALPR /
C        MOD  J. OLSSON   10/06/85 :  NEW COMMON / TODAY /
C                                UPDATE OF VTX CH CONSTANTS (J.HAGEMANN)
C        MOD  J. HAGEMANN 16/07/85 :  UPDATE OF XRLPIV, XRLVXC IN COMMON
C                                     / CGEOV /
C        MOD  J. OLSSON   10/06/87 :  UPDATE OF ZSFIT COMMONS
C        MOD  C. BOWDERY  24/07/87 :  INCLUDE Z CHAMBER COMMONS
C        MOD  C. BOWDERY  29/07/87 :  ZCHWW ADDED TO /CCMZCT/
C        MOD  J. OLSSON   16/11/87 :  CGEO3 UPDATED FOR OUTER RADIUS
C   LAST MOD  J. OLSSON   16/11/87 :  /CDEDXU/ UPDATED ACC. TO K. AMBRUS
C
C------------------  D E C L A R A T I O N S  --------------------------
C
C- - - - - - - - -   CTLIM   - - - - - - - - - - - - - - - - - - - - - -
C
C                            TIMEOUT VALUE FOR SUPERV ( SET TO 2 SECS)
C
      COMMON / CTLIM  / ISECLF
C
      DATA ISECLF/2/
C
C- - - - - - - - -   CADMIN  - - - - - - - - - - - - - - - - - - - - - -
C
C                            GENERAL ADMINISTRATION COMMON
C
#include "cadmin.for"
C
      DATA IEVTP,NRREAD,NRWRIT,NRERR / -1,0,0,0 /, LBREAD / 4*.FALSE. /
      DATA IFLG / 0 /, IERCAL / 0 /, ISMEAR / 0 /, IJETCI / 0 /
      DATA NFLAGS / 0,0,-1,1,0,  0,0,0,0,0 /
C
C- - - - - - - - -   CBSTR   - - - - - - - - - - - - - - - - - - - - - -
C
C                            WRITE PARAMETERS FOR SUPERV
C
      COMMON / CBSTR  / MODE,MAXRL,SAFEOF
C
      LOGICAL SAFEOF
C
      DATA MODE / 2 /, MAXRL / 1558 /, SAFEOF / .FALSE. /
C
C- - - - - - - - -   CIOUNI  - - - - - - - - - - - - - - - - - - - - - -
C
C                            INPUT/OUTPUT LOGICAL UNIT NUMBERS (SUPERV)
C
C                            IUNIT   = EVENT INPUT
C                            JUNIT   = EVENT OUTPUT
C                            NCALI   = MAX NO. OF CALIBRATION FILES
C                            KUNITA  = ASTART CALIBRATION FILES (DEAD)
C                            LUNITA  = AUPDAT/BUPDAT CALIBRATION FILES
C
#include "ciouni.for"
C
      DATA IUNIT  /  2           /
      DATA JUNIT  /  3           /
      DATA NCALI  /  2           /
      DATA KUNITA /  0,  0, 8*0  /
      DATA LUNITA / 21, 22, 8*0  /
C
C- - - - - - - - -   CGRAPH  - - - - - - - - - - - - - - - - - - - - - -
C
C                            GRAPHICS PARAMETERS FOR SUPERV
C
#include "cgraph.for"
C
      DATA NDDINN,NDDOUT,MAXREC,IREADM,LABEL / 3*0,1,0 /
      DATA FREEZE / 30*.FALSE. /, JUSCRN / 6 /, LASTVW / 0 /, IPSVAR /1/
C
      DATA DSPDTL/3*.TRUE.,.FALSE.,2*.TRUE.,2*.FALSE.,.TRUE.,2*.FALSE.,
     + 3*.TRUE., 5*.FALSE., 2*.TRUE., 6*.FALSE., .TRUE., 2*.FALSE. /
      DATA LSTCMD/1/
C
C- - - - - - - - -   CMCCAL  - - - - - - - - - - - - - - - - - - - - - -
C
C                            KLREAD FLAGS FOR MC CALIBRATION READING
C                            0 = DONT READ    1 = READ  (SEE KLREAD)
C
***  wird nur in KLREAD benoetigt, ist dort aber schon definiert
***  wird auskommentiert 02.02.98
***      COMMON / CMCCAL / LBMC(15) 
***C
***      DATA LBMC / 0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0 /
C
C- - - - - - - - -   CJCELL  - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CJCELL / NCELL(3), NWIRES(3)
C
C                            NCELL  = NUMBER OF CELLS PER RING
C                            NWIRES = NUMBER OF WIRES PER CELL
C
      DATA NCELL  / 24,24,48 /
      DATA NWIRES / 16,16,16 /
C
C- - - - - - - - -   CJDRCH  - - - - - - - - - - - - - - - - - - - - - -
C
#include "cjdrch.for"
C
C                            RDEC   = MEAN RADII OF CHAMBER WALLS
C                            PSIIN  = ANGULAR INCREMENT OF FIRST WIRE
C                                     LINE.
C                            FIRSTW = RADII OF FIRST MAIN POTENTIAL
C                                     WIRES IN EACH RING
C                            FSENSW = RADII OF FIRST SENSE WIRES IN
C                                     EACH RING
C                            RINCR  = DISTANCE BETWEEN TWO POTENTIAL
C                                     WIRES
C                            RDEPTH = DIFFERENCE OF TWO CHAMBER RADII
C                            SWEDPL = WIRE STAGGERING, .GT.0 MEANS IN
C                                     POS PHI FOR ZEROTH WIRE
C
C                            YSUSPN = MAXIMUM VERTICAL DEPLACEMENT OF
C                                     WIRE DUE TO GRAVITATION
C                            TIMDEL = RESOLUTION IN EACH CHAMBER IN MM.
C                            ZMAX   = SENSITIVE HALF LENGTH OF WIRES
C                            ZOFFS  = OFFSET OF WIRES
C                            ZRESOL = RESOLUTION IN Z
C                            ZNORM |
C                            ZAL   |= PARAMETERS FOR CALCULATION OF
C                            ZSCAL |  Z AMPLITUDES
C                            DRIDEV|
C                            DRICOS|= TILT ANGLE, COS, SIN
C                            DRISIN|
C                            PEDES  = OLD OVERALL Z AMPLIFIER  PEDESTAL.
C                                     UNUSED.
C                            TZERO(3) = OVERALL DRIFT TIME  ZEROES  FOR
C                                       EACH OF THE THREE  JET  CHAMBER
C                                       RINGS.
C
C                            TOFIX(3) = TEMPORARY TZEROS  FOR  TOF  AND
C                                       PROP.TIME     CORRECTIONS    IN
C                                       PATTERN RECOGNITION
C
C                            ABERR(8) = ABERRATION CORRECTION CONSTANTS
C                                       USED IN FXYZ,JETXYZ
C                            DRIROT(96,2),SINDRI(96,2),COSDRI(96,2)
C                                       INDEPENDENT LORENTZ ANGLES  FOR
C                                       THE 96 JET  CHAMBER  CELLS  AND
C                                       TWO DRIFT  DIRECTIONS  AND  THE
C                                       CORRESPONDING     SINES     AND
C                                       COSINES.
C                            ARRAY   ABERR(8)   SET   TO   MC   VALUES,
C                            OVERWRITTEN BY KALIBR FOR REAL DATA
C                                                 J.OLSSON  17.9.80
C
      DATA RDEC   / 196., 396.4 , 596.4, 797.33 /
      DATA PSIIN  / 0.1309 , 0.1309 , 0.065450 /
      DATA FIRSTW / 206., 416., 627.33 /
      DATA FSENSW / 211., 421., 632.33 /
      DATA RINCR  / 10., 10., 10.      /
      DATA RDEPTH / 200.4 /
      DATA SWDEPL / 0.2   /
      DATA YSUSPN / 0.0   /
C                            NOTE THAT TIMDEL IS ALWAYS OVERWRITTEN
      DATA TIMDEL / 6*0.005 /
C
      DATA ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL
     *            / 1180., -10., 1., 1000., 2687., 10. /
      DATA DRIDEV /-0.349066 /,
     *     DRICOS / 0.939693 /,
     *     DRISIN /-0.342020 /
C                           PEDES IS UNUSED
      DATA PEDES  / 50.  /
      DATA TZERO  / 3*0. /
      DATA DRIROT / 192*-0.349066 /
      DATA SINDRI / 192*-0.342020 /
C
      DATA COSDRI / 192*0.939693  /
      DATA T0FIX  / 0.65, 0.71, 0.76 /
      DATA ABERR  / 0., 5., 5., 2.5,0.,0., 99999.,0. /
      DATA DUMJDC / 20*0. /
C
C- - - - - - - - -   CJIONI  - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CJIONI / POTBEA, ZAROBE,
     *                  POTTRI, ZAROTR,
     *                  POTIVE, ZAROIV,
     *                  POTRH0, ZAROR0,
     *                  POTJET, ZAROJE,
     *                  POTRH1, ZAROR1,
     *                  POTRH2, ZAROR2,
     *                  POTRH3, ZAROR3,
     *                  POTOVE, ZAROOV,
     *                  POTTOF, ZAROTO,
     *                  POTVES, ZARVES,
     *                  POTZJL, ZAROJL,
     *                  POTZJR, ZAROJR
C
C                            GIVES  AVERAGE  IONISATION  POTENTIAL  AND
C                            VALUE FOR Z*RHO/A FOR BETHE BLOCH  FORMULA
C                            FOR : BEAMPIPE, BEAM PIPE  COUNTER,  INNER
C                            VESSEL WALL, 4 DIFFERENT ROHACELL  LAYERS,
C                            DRIFTGAS , OUTER VESSEL WALL, TOF COUNTER,
C                            VESSEL WALL  IN  Z,  LEFT  AND  RIGHT  ALU
C                            SUPPORTS FOR WIRES AND ROHACELL  (  VALUES
C                            FOR THE AVERAGE  IONISATION  POTENTIAL  OF
C                            ALUMINIUM FROM SOVIET JOURNAL  OF  NUCLEAR
C                            PHYSICS 9, PAGE 583 F., 1969 )
C
      DATA  POTBEA , ZAROBE        / 160.3,1.3      /
      DATA  POTTRI , ZAROTR        / 36.1,.59       /
      DATA  POTIVE , ZAROIV        / 160.3,1.3      /
      DATA  POTRH0 , ZAROR0        / 102., 0.11     /
      DATA  POTJET , ZAROJE        / 284.4,.00295   /
      DATA  POTRH1 , ZAROR1        / 102.,.07       /
      DATA  POTRH2 , ZAROR2        / 102.,.07       /
      DATA  POTRH3 , ZAROR3        / 102. , .09     /
      DATA  POTOVE , ZAROOV        / 160.3,1.3      /
      DATA  POTTOF , ZAROTO        / 36.1,.59       /
      DATA  POTVES , ZARVES        / 160.3,1.3      /
      DATA  POTZJL , ZAROJL        / 160.3, 1.3     /
      DATA  POTZJR , ZAROJR        / 160.3, 1.3     /
C
C- - - - - - - - -   CJSWLO  - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
C
      LOGICAL  ELOSS, MULSC
C
C                            ITIMOD DETERMINES TYPE OF DRIFT TIME
C                            CALCULATION ( SEE JDTIM ).
C
C                            MULSC: IF TRUE MULTIPLE SCATTERING INCLUDED
C                            ELOSS: IF TRUE ENERGY LOSS IS INCLUDED
C
      DATA ITIMOD, MULSC, ELOSS / 1 , .TRUE., .TRUE. /
C
C- - - - - - - - -   CJTRIG  - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CJTRIG / PI,TWOPI,PIHALF,PI3HAF
      DATA  PI,TWOPI / 3.141593 , 6.283185 / , PIHALF / 1.5707963 /
      DATA  PI3HAF   / 4.712389 /
C
C- - - - - - - - -   CGEO1   - - - - - - - - - - - - - - - - - - - - - -
C
C                            JADE GEOMETRICAL CONSTANTS
C
#include "cgeo1.for"
C
C             BKGAUS = MAGNETIC FIELD IN KGAUSS
C             RPIP   = RADIUS OF BEAM PIPE
C             DRPIP  = THICKNESS OF BEAM PIPE IN MM
C             XRLPIP =     "     "    "    "   " RADL
C
C             RBPC   = RADIUS OF BEAM PIPE COUNTERS
C             DRBPC  = THICKNESS OF BEAM PIPE COUNTERS IN MM
C             XRLBPC =     "     "    "    "      "     " RADL
C
      DATA BKGAUS                    / -4.85               /
      DATA RPIP, DRPIP, XRLPIP       / 123.,  5.3, 0.0596  /
      DATA RBPC, DRBPC, XRLBPC       / 150., 10., 0.0238   /
C
C             RITNK  = INNER RADIUS OF THE TANK
C             DRITNK = THICKNESS OF INNER TANK WALL IN MM
C             XRLTKI =     "     "    "     "   "   "  RADL
C
C             R0ROH  = RADIUS OF ZEROTH ROHACELL SUPPORT
C             DR0ROH = THICKNESS OF ZEROTH ROHACELL SUPPORT IN MM
C             XR0ROH =     "     "     "      "        "     " RADL
C
      DATA RITNK, DRITNK, XRLTKI     / 167.,  7., 0.0787   /
      DATA R0ROH, DR0ROH, XR0ROH     / 181., 15., 0.0076   /
C
C             R1ROH  = RADIUS OF FIRST ROHACELL SUPPORT
C             DR1ROH = THICKNESS OF FIRST ROHACELL SUPPORT IN MM
C             XR1ROH =     "     "    "      "        "     " RADL
C
C             R2ROH  = RADIUS OF SECOND ROHACELL SUPPORT
C             DR2ROH = THICKNESS OF SECOND ROHACELL SUPPORT IN MM
C             XR2ROH =     "     "    "       "        "     " RADL
C
      DATA R1ROH, DR1ROH, XR1ROH     / 376., 30.,0.0109    /
      DATA R2ROH, DR2ROH, XR2ROH     / 586., 30.,0.0109    /
C
C             R3ROH  = RADIUS OF THIRD ROHACELL SUPPORT
C             DR3ROH = THICKNESS OF THIRD ROHACELL SUPPORT IN MM
C             XR3ROH =     "     "    "      "        "     " RADL
C
C             ROTNK  = INNER RADIUS OF OUTER WALL OF THE TANK
C             DROTNK = THICKNESS OF OUTER TANK WALL IN MM
C             XRLTKO =     "     "    "     "   "    " RADL
C
      DATA R3ROH, DR3ROH, XR3ROH     / 799.04, 25., 0.0147 /
      DATA ROTNK, DROTNK, XRLTKO     / 835., 12., 0.1348   /
C
C             RTOF   = RADIUS OF TOF COUNTERS
C             DRTOF  = THICKNESS OF TOF COUNTERS IN MM
C             XRTOF  =     "     "   "     "      " RADL
C
C             RCOIL  = RADIUS OF COIL
C             DRCOIL = THICKNESS OF COIL IN MM
C             XRCOIL =     "     "    "   " RADL
C
C             ZJM    = Z COORDINATE OF ALU SUPPORT FOR ROHACELL ( - Z )
C             DZJM   = THICKNESS IN MM
C             XRZJM  =     "      " RADL
C
      DATA RTOF,  DRTOF,  XRTOF      / 920., 20., 0.0476   /
      DATA RCOIL, DRCOIL, XRCOIL     / 968., 90., 0.756    /
      DATA ZJM ,  DZJM,   XRZJM      / -1180., -30., 0.337 /
C
C             ZJP    = Z COORDINATE OF ALU SUPPORT FOR ROHACELL ( + Z )
C             DZJP   = THICKNESS IN MM
C             XRZJP  =     "      " RADL
C
C             ZTKM   = Z COORD. OF TANK WALL FOR INNER DETECTOR ( - Z )
C             DZTKM  = THICKNESS IN MM
C             XRZTKM =     "      " RADL
C
C             ZTKP   = Z COORD. OF TANK WALL FOR INNER DETECTOR ( + Z )
C             DZTKP  = THICKNESS IN MM
C             XRZTKP =     "      " RADL
C
      DATA ZJP, DZJP, XRZJP          /  1180.,  30., 0.337 /
      DATA ZTKM,DZTKM,XRZTKM         / -1350., -74., 0.832 /
      DATA ZTKP,DZTKP,XRZTKP         /  1350.,  74., 0.832 /
C
C             ZTOFPL = MAX Z COORDINATE COVERED BY TOF COUNTERS AT +Z
C             ZTOFMI = MAX Z COORDINATE COVERED BY TOF COUNTERS AT -Z
C             ZBPPL  = MAX Z COORDINATE OF BEAM PIPE COUNTERS AT +Z
C             ZBPMI  = MAX Z COORDINATE OF BEAM PIPE COUNTERS AT -Z
C             XRJETC = RADL OF CHAMBER GAS IN MM
C
      DATA ZTOFPL,ZTOFMI             /  1500., -1500.      /
      DATA ZBPPL, ZBPMI              /   750.,  -750.      /
      DATA XRJETC                    / 29910.              /
C
C
C                            LEAD GLASS DATA
C
C
C             RLG    = INNER RADIUS OF LEAD GLASS ARRAY
C             ZLGPL  = MAXIMUM +Z-COMPONENT OF CENTRAL LEAD GLASS ARRAY
C             ZLGMI  = MAXIMUM -Z-COMPONENT OF CENTRAL LEAD GLASS ARRAY
C
      DATA  RLG, ZLGPL, ZLGMI / 1100.,1696.,-1696. /
C
C             OUTR2  = (RLG + BLDEP)
C             CTLIMP = COS THMAX FOR PARTICLES HITTING THE CENTRAL LG
C             CTLIMM = COS THMAX FOR PARTICLES HITTING THE CENTRAL LG
C
      DATA  OUTR2, CTLIMP, CTLIMM / 1400.,0.839,-0.839 /
C
C             DELFI  = ANGULAR INCREMENT CORRESPONDING TO ONE BLOCK
C             BLXY   = DIMENSION OF ONE LEAD GLASS BLOCK IN XY DIRECTION
C             BLZ    = DIMENSION OF ONE LEAD GLASS BLOCK IN Z DIRECTION
C             BLDEP  = DEPTH OF A LEAD GLASS BLOCK
C             BLFI   = DIMENSION OF A BLOCK IN PHI
C
      DATA  DELFI, BLXY, BLZ, BLDEP, BLFI / 0.0748,140.,106.,300.,82.28/
C
C             ZENDPL = Z COORDINATE FOR END CAP LG FACE AT +Z
C             ZENDMI = Z COORDINATE FOR END CAP LG FACE AT -Z
C             DEPEND = DEPTH OF LG COUNTER END CAP
C
      DATA  ZENDPL, ZENDMI, DEPEND / 1514.,-1514.,226. /
C
C             XHOL1,XHOL2  PARAMETERS FOR HOLE AROUND PIPE
C             YHOL1,YHOL2  PARAMETERS FOR HOLE AROUND PIPE
C
      DATA  XHOL1, XHOL2 / 140., 320. /
      DATA  YHOL1, YHOL2 / 140., 320. /
C
C- - - - - - - - -   CGEO2  *  CGEO2COM  - - - - - - - - - - - - - - - -
C
#include "cgeo2com.for"
#include "cgeo2.for"
C
      DATA FENDC / 81. /, XYHOL1, XYHOL2 / 141.,151.5 /, BLDPFW / 400. /
      DATA ZMINBL, ZPLUBL / -5250., 5250. /
      DATA XSC / 230.,150. /, YSC / 150.,70. /, RSC / 152.48,192.48 /
      DATA ZMISC / -4235.,-4135. /, ZPLSC / 4235.,4135. /, DZSC / 6. /
C
      DATA CHX / -140., -400., 140., -140., -400., 140.,
     +           -140., -400., 140., -140., -400., 140. /
C
      DATA CHY / -400., 140., -400., -400., 140., -400.,
     +           -400., 140., -400., -400., 140., -400. /
C
      DATA CHZ / -4770., -4720., -4770., -4020., -4070., -4020.,
     +            4020.,  4070.,  4020.,  4770.,  4720.,  4770. /
C
      DATA WLEN / 800. /, PITCH / 25. /, WZDIS / 10. /
C
C- - - - - - - - -   CGEO3  *  CGEO3COM  - - - - - - - - - - - - - - - -
C
#include "cgeo3com.for"
#include "cgeo3.for"
C
      DATA ZMINM2,ZPLUM2 / -2950.,2950. /
      DATA NRPBSC / 8 /
      DATA PBSCR  / 104.02,120.02,152.02,264.02 /
C 4TH COMPONENT UPDATED 16.11.87, AFTER CORRECTION FROM ALEX FINCH
C 4TH COMPONENT UPDATED 02.03.89, IT WAS CORRECT AFTER ALL !   J.O.
C     DATA PBSCR  / 104.02,120.02,152.02,232.02 /
      DATA PBSCZ  / -3470.,-2950.,2950.,3470.   /
C
C- - - - - - - - -   CDLATC  - - - - - - - - - - - - - - - - - - - - - -
C
C
C                            THRESHOLDS FOR LEADGLASS LATCHES
C                            THIS IS USED IN STLATC. THIS IS  OUTDATED,
C                            SINCE LATC BANK  IS  DELETED  AND  CREATED
C                            ANEW IN THE TRIGGER SIMULATION ROUTINES.
C
      COMMON / CDLATC / LGBRT, LGQT, LGET(4)
C
C                            LGBRT = THRESHOLD FOR LG ROW LATCHES
C                            LGQT  = THRESHOLD FOR LG END CAP QUADS
C                            LGET  = THRESHOLDS FOR LG TOTAL ENERGY
C                                    (ALL IN MEV)
C
      DATA LGBRT / 10 /
      DATA LGQT  / 10 /
      DATA LGET  / 500, 1000, 2000, 5000 /
C
C- - - - - - - - -   CJVCEL  - - - - - - - - - - - - - - - - - - - - - -
C
#include "cjvcel.for"
C
C                            MCELL = NUMBER OF CELLS IN VERTEX CHAMBER
C                            MWIRE = NUMBER OF WIRES PER CELL IN VTXCH
C
      DATA MCELL / 24 /
      DATA MWIRE /  7 /
C
C- - - - - - - - -   CJVTXC  - - - - - - - - - - - - - - - - - - - - - -
C
#include "cjvtxc.for"
C
C                            RVEC   = OUTER RADIUS OF BEAM PIPE
C                            ANG1   = ANGLE BETWEEN FIRST SIGNAL WIRE
C                                     LINE AND X-AXIS OF DETECTOR
C                                     COORDINATE SYSTEM
C                            ANG2   = BETWEEN TWO MAIN POTENTIAL WIRE
C                                     LINES
C
      DATA RVEC, ANG1, ANG2          / 93., .06545, .2618 /
C
C                            DISTPW = DISTANCE BETWEEN TWO POTENTIAL
C                                     WIRES
C                            FIRSTP = RADIUS OF FIRST MAIN POTENTIAL
C                                     WIRE
C                            DISTW1 = RADIUS OF FIRST SENSE WIRE
C
      DATA DISTPW, FIRSTP, DISTW1    / 9., 103.5, 99. /
C
C                            ANGL   = TILT ANGLE
C                            COSLOR = COS(ANGL)
C                            SINLOR = SIN(ANGL)
C
      DATA ANGL, COSLOR, SINLOR      / -0.279301, 0.961248, -0.275684 /
C
C                            ZRESV  = Z-RESOLUTION
C                            ZMAXV  = EFFECTIVE WIRE LENGTH ?
C                            ZOFFV  = OFFSET OF VERTEX DETECTOR IN
C                                     Z-DIRECTION
C                            ZNAMP  =   PARAMETERS FOR CALCULATION OF
C                            ZALV   =   Z-AMPLITUDES
C
      DATA ZRESV, ZMAXV, ZOFFV       / 20.0, 517.0, 0.0 /
      DATA ZNAMP, ZALV               / 78.0, 1034.0 /
C
C                            TIMEV  = VERTEX CHAMBER DRIFT TIME BIN
C                                     WIDTH  (MM)
      DATA TIMEV                     / 0.001 /
C
C                            DRILOR =  LORENTZ-ANGLE IN EVERY CELL
C                            SNLORA, CSLORA = SIN, COS (DRILOR)
      DATA DRILOR                    / 24*-0.279301 /
      DATA SNLORA                    / 24*-0.275684 /
      DATA CSLORA                    / 24*0.961248  /
C
C                            DRVELO = DRIFT VELOCITY IN EACH CELL
      DATA DRVELO                    / 24*0.001 /
C
C- - - - - - - - -   CIJONV  - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CIJONV / POTVXC, ZAROVC,
     *                  POTVGA, ZAROVG
C
C                            GIVES AVERAGE IONISATION POTENTIAL
C                            AND VALUE FOR Z*RHO/A IN
C                            BETHE BLOCH FORMULA FOR :
C                               1) BEAMPIPE AND OUTER VERTEX CHAMBER
C                                  WALL (ALUMINIUM)
C                               2) CHAMBER GAS
C
      DATA POTVXC,ZAROVC             / 160.3, 1.3      /
      DATA POTVGA,ZAROVG             / 284.4, 0.00080  /
C
C
C- - - - - - - - -   CGEOV   - - - - - - - - - - - - - - - - - - - - - -
C
#include "cgeov.for"
C
C                            RPIPV  = INNER RADIUS OF NEW BEAM PIPE
C                            DRPIPV = THICKNESS OF BEAM PIPE (MM)
C                            XRLPIV = THICKNESS OF BEAM PIPE (RADL)
C                           ( 3 MM ALUMINIUM +                0.03371
C                             20 MU KAPTON + ARALDIT +        0.00011
C                             75 MU KAPTON + 1*17.5 MU CU +   0.00148
C                             50 MU KAPTON + 2*17.5 MU CU +   0.00262
C                             2 COOLING PIPES                 0.00107 )
C
CCC   DATA RPIPV, DRPIPV, XRLPIV     / 90., 3., 0.0337 /
      DATA RPIPV, DRPIPV, XRLPIV     / 90., 3., 0.03899 /
C
C                            RVXC   = RADIUS OF OUTER VERTEX CHAMBER
C                                     WALL
C                            DRVXC  = THICKNESS IN (MM)
C                            XRLVXC = THICKNESS IN (RADL)
C                           ( 1 MM ALUMINIUM +                0.01124
C                             0.5 MM G10 +                    0.00258
C                             50 MU KAPTON + 2*17.5 MU CU +   0.00262 )
C
CCC   DATA RVXC, DRVXC, XRLVXC       / 159., 1., 0.0112 /
      DATA RVXC, DRVXC, XRLVXC       / 159., 1., 0.01644 /
C
C                            ZVXCM  = Z-COORDINATE OF VERTEX CHAMBER
C                                     END PLATE ( -Z )
C                            DZVCM  = THICKNESS IN (MM)
C                            XRZVCM = THICKNESS IN (RADL)
      DATA ZVXCM,DZVCM,XRZVCM        / -380., -15., 0.1685 /
C
C                            ZVXCP  = Z-COORDINATE OF VERTEX CHAMBER
C                                     END PLATE ( +Z )
C                            DZVCP  = THICKNESS IN (MM)
C                            XRZVCP = THICKNESS IN (RADL)
      DATA ZVXCP,DZVCP,XRZVCP        /  380.,  15., 0.1685 /
C
C                            XRVTXC = RADL OF CHAMBER GAS IN (MM)
      DATA XRVTXC                    / 29910. /
C
C- - - - - - - - -   CIEVS   - - - - - - - - - - - - - - - - - - - - - -
C
C                            IEVMIN = 1ST  EVENT REQUESTED FOR TRACKING
C                            IEVMAX = LAST EVENT REQUESTED FOR TRACKING
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
      DATA IEVMIN /      1 /
      DATA IEVMAX / 999999 /
C
C- - - - - - - - -   CVFLAG  *  CVERR  - - - - - - - - - - - - - - - - -
C
C                            MESSAGES AND FLAGS USED (MAINLY) FOR INPUT
C                            ERROR CHECKING IN THE MONTE CARLO
C
      LOGICAL VTEST
C
      COMMON / CVFLAG / VTEST(20)
      COMMON / CVERR  / MESSAG(20)
C
      DATA MESSAG / 20 * 0      /
      DATA VTEST  / 20 * .TRUE. /
C
C- - - - - - - - -   CFLAG   - - - - - - - - - - - - - - - - - - - - - -
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE SLOW!!!!!
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                 BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C
C           ====> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.
C
      LOGICAL * 1 LFLAG
C
      COMMON / CFLAG  / LFLAG(10)
C
      DATA LFLAG  / .TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.,5*.FALSE. /
C
C- - - - - - - - -   TODAY   - - - - - - - - - - - - - - - - - - - - - -
C
C /TODAY/ HOLDS A DATE TO SPECIFY VERSION OF JADE DETECTOR IN MC
C                         TRACKING JOBS.
C
C       HDATE(1) GIVES SECONDS, HDATE(2) GIVES MINUTES
C       HDATE(3) GIVES HOURS,   HDATE(4) GIVES DAYS
C       HDATE(5) GIVES MONTHS,  HDATE(6) GIVES YEARS
C               (17.5 IS THE NORWEGIAN NATIONAL DAY...)
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
      DATA HDATE /1,1,1,17,5,1985/
C
C
C- - - - - - - - -   CKALPR  - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CKALPR / NOHEAD, IBADF, IBADEN, LASTR1, LASTR2
C
      DATA  NOHEAD / 0 /, IBADF / 0 /, IBADEN / 0 /
      DATA  LASTR1 / -1 /, LASTR2 / -1 /
C
C------  USER COMMON - DEDXBN
C
      COMMON /CDEDXU/ NHFCUT,PMCUT
      DATA NHFCUT / 10 /, PMCUT/0.01/
C
C   COMMON FOR USE IN FLIGHT TIME CORRECTION, SUBR. JFTNEW
C
      COMMON /CFLMAS/ AFLMAS
      DATA  AFLMAS /0.511E-3/
C
C   COMMON FOR USE FOR CUTS IN SUBR. ZSRFTV
C
      COMMON/ CCMZCT / DIMPCT, ZCUTV, ZCUTVV, IZVCST(5), ZCHWW
      DATA  DIMPCT /15./, ZCUTV /800./, ZCUTVV /1600./, IZVCST/5*0/
      DATA  ZCHWW /50.0 /
C
C   Z-RESOLUTION FOR DIFFERENT PERIODS  (SUBR. AMPS2Z)
C
#include "czsprm.for"

      DATA NZSPRD / 1 /
C  FOLLOWING LINE CHANGED 20/5/88  J.H./ E.E.
CCCC  DATA AZSRS0 / 4., 4., 13. /, AZSRSA / 4480., 7000., 10000. /
      DATA AZSRS0 / 10., 10., 13. /, AZSRSA / 4480., 7000., 10000. /
      DATA AZSCT1 / 140., 140., 225. /,
     *     AZSCT2 / 100., 100., 150. /,
     *     AZSCT3 / 100., 100., 150. /,
     *     AZSCT4 / 100., 100., 180. /,
     *     AZSSHT /12.3, .183, .011 , .365, .106,
     *             7.5, .045, .0015, .200, .055 ,
     *             7.5, .045, .0015, .200, .055 /,
     *     AZSSHD / 3., 3., 2. /,
     *     AZSSAV / 19., 19., 32. /,
CCCC *     AZSSAV / 13., 17., 32. /,  CHANGED 20/5/88  J.H./E.E.
     *     LZSPDF / .FALSE. /
C
C- - - - - - - - -   CZGEO, CZCAL, CZMKON   - - - - - - - - - - - - - -
C
C                            Z CHAMBER CONSTANTS
C
C
C
C                            RZCHI  = RADIUS FOR BARLOW
C                            RZCHA  = RADIUS FOR BARHIGH
C                            NZRPHI = NUMBER OF CELLS IN R-PHI
C                            NZZ    = NUMBER OF CELLS IN Z
C                            Z1ZCH  = LOWER END OF Z-CHAMBER
C                            Z2ZCH  = UPPER END OF Z-CHAMBER
C
C                            WIRE POSITIONS INSIDE ONE CELL
C
C                            ZCHA  = DIST. OF 1ST WIRE FROM BARLOW: 5 MM
C                            ZCHB  = DIST. OF 2ND WIRE FROM BARLOW:15 MM
C                            ZCHSS = STAGGERING OF THE WIRES:       1 MM
C
C                            DEAD SPACES OF WHOLE Z CHAMBER
C
C                            ZCHDL = DEAD SPACES FOR EACH HALF SHELL ON
C                                    TOP AND BOTTOM, JEWEILS +/- DL
C                            ZCHDLL= DEAD SPACES RIGHT AND LEFT FOR GAS
C                                    IN/OUTFLOW, JEWEILS +/- DLL
C
C                            DLZZ   = SEGMENT LENGTH IN Z
C                            DLZPMI = INNER SEGMENT LENGTH IN R-PHI
C                            DLZW1  = WIRE LENGTH OF WIRE1 IN ONE SEG.
C                            DLZW2  =      ....      WIRE2  ....
C
       COMMON / CZGEO / RZCHI,RZCHA,NZRPHI,NZZ,Z1ZCH,Z2ZCH,
     +                  ZCHA, ZCHB, ZCHSS, ZCHDL, ZCHDLL,
     +                  DLZZ, DLZPMI, DLZW1, DLZW2
C
       DATA  RZCHI,RZCHA  / 864.5,884.5 /
       DATA  NZRPHI,NZZ   / 24,16 /
       DATA  Z1ZCH,Z2ZCH  /-1200.,1200. /
       DATA  ZCHA, ZCHB, ZCHSS   / 5., 15., 1. /
       DATA  ZCHDL, ZCHDLL    /100., 20. /
       DATA  DLZZ, DLZPMI, DLZW1, DLZW2  /150., 227.63, 228.94, 231.58/
C
C                            CHAMBER CONSTANTS PULSEHEIGHTS, RESOLUTIONS
C
C                            ZSIGX  = SPAT. RES. TRANS. TO WIRE (0.3 MM)
C                            ZA0    = MEAN (?) AMPLITUDE    1000
C                            ZDA0   = WIDTH OF PULSE HEIGHT SPEC. +/-30000064653
C                            ZSIGAL = SPATIAL RES. ALONG WIRE 25MM .. 1%
C                            ZDPAUF = DOUBLE PULSE RESOLUTION  (4 MM)
C
C                            WIRE-SUPPORT
C
C                            ZDSPAC = SPACE IN R-PHI AT ONE SIDE OF
C                                     ONE OF 24 R/PHI-SEGMENTS
C                                     WITH REDUCED EFFICIENCY ZEFF.
C                                     THE REAL DEADSPACE FOR ONE WIRE
C                                     SUPPORT IS THEN TWICE AS BIG AS
C                                     ZDSPAC.   1.25 MM
C
C                            ZEFF   = EFFICIENCY IN DEAD SPACE   10%
C                            NZ00   = AVERAGE NUMBER OF RANDOM HITS
C                            NZDD   = FLUCTUATION OF N00 -GLEICHVERTEILT
C
      COMMON / CZCAL /  ZSIGX, ZA0, ZDA0, ZSIGAL, ZDPAUF,
     +                  ZDSPAC, ZEFF, NZ00, NZDD
C
      DATA  ZSIGX, ZA0, ZDA0, ZSIGAL / 0.30, 1000.,300., 25. /
      DATA  ZDPAUF                   / 4. /
      DATA  ZDSPAC, ZEFF             / 1.25, .10 /
      DATA  NZ00, NZDD               / 5, 2 /
C
C                            CHAMBER CONSTANTS FOR MC.
C
C                            ZCVDR = DRIFT VELOCITY IN MM/TIMEBIN
C                            ZCXCH = (A2-A1)/A = XCH*(L1-L2)/L
C                                    CONSTANT FOR CHARGE DIVISION
C                            ZCTZER= TIME PEDESTAL
C                            ZCAPED= AMPLITUDE PEDESTAL
C                            ZXLI  = ZXCH * L  (INNER WIRE )
C                            ZXLO  = ZXCH * L  ( OUTER WIRE )
C
      COMMON / CZMKON / ZCVDR, ZCXCH, ZCTZER, ZCAPED, ZXLI, ZXLO
C
      DATA ZCVDR, ZCXCH, ZCTZER, ZCAPED   / 0.34, 1., 0., 0. /
      DATA ZXLI, ZXLO  / 2547.28, 2578.96 /
C
C   COMMONS BELOW BELONG TO F22KLE.JVTXC.GS/GL    <<<<========
C
C-
C   --- FOR COMFIT-COMMON / CCOMF / :
C"
C
#include "mccomf.for"
C
C-  IF SCF1 OR SCF2 < 0, CALCULATION OF SCF1 OR SCF2 INDIVIDUALLY FOR
C                                                        EACH TRACK
C   SCF1   : 1/SIGMA_ID**2
C   SCF2   : 1/SIGMA_VTXC**2
C   SCF3   : FACTOR FOR  1/RMS_THETA**2 (SCATTERING ANGLE R-PHI)
C   DCF1   : MAXIMUM ALLOWED RESIDUAL FOR PREFIT OF VTXC-HITS
C   DCF2   : MAXIMUM RESIDUAL FOR COMFIT
C   ITMX   : MAXIMUM NUBER OF ITERATIONS IN COMFIT
C   IVHMN  : MINIMUM NUMBER OF REMAINING VTXC-HITS AFTER ITERATION
C   IPRBN  : PATR BANK NUMBER AS INPUT FOR COMFIT
C            (AUTOMATICALLY SET BY VTXCSV BY INPUT PARAMETER NBPCFT)
C   CFPMIN : TRACKS WITH A TRANSVERSE MOMENTUM < CFPMIN WILL NOT BE
C            TAKEN FOR COMFIT
C   MODECF : MODE FLAG FOR COMFIT
C       THE TWO FOLLOWING PARAMETER CAN BE SET AUTOMATICALLY BY
C       CALLING THE SUBROUTINE VTXCSF JUST BEFORE THE CALL TO VTXCSV
C   CFSFAC : FUDGE FACTOR FOR ADDITIONAL TRACK SMEARING
C   VCWGHT : WEIGHT FOR RUN VERTEX
C
C========== D O   N   O   T   C H A N G E ==============================
C                F R O M
C"
      DATA SCF1   / -25.0 /
      DATA SCF2   / 44.0 /
      DATA SCF3   / 1.0 /
      DATA SCF4   / 0.01 /
      DATA DCF1   / 0.500 /
      DATA DCF2   / 0.600 /
      DATA ITMX   / 5 /
      DATA IVHMN  / 3 /
C-                 T O
C========== D O   N   O   T   C H A N G E ==============================
C"
      DATA IPRBN  / 10 /
      DATA CFPMIN / 0.100 /
      DATA MODECF / 0 /
      DATA CFSFAC / 1.00 /
      DATA VCWGHT / 1.00 /
C
C   END OF COMMONS FROM TO F22KLE.JVTXC.GS/GL    <<<<========
C
C
      END

C   05/02/87 801121144  MEMBER NAME  TPTAGS   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTAGS
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       5/02/87:  Process tagging system
C               A. Finch
C
C     Last mod: C. Bowdery      12/01/88:  Remove excess C's in col 1
C
C     Routine to perform tagging analysis (if wanted) and place
C     the summary information to the TP banks.
C     Unwanted banks are deleted at the end.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

C------------------  C O D E  ------------------------------------------

C                            Analyse tagging system (may do nothing)

      CALL TPTAGA

C                            Add tagg information to banks (if wanted)

      CALL TPTAGT

C                            Delete tagging banks as requested

      CALL TPTAGD


      RETURN
      END

C   16/12/80 104100758  MEMBER NAME  MURES2   (JADEMUS)     FORTRAN
C   26/03/80 010121510  MEMBER NAME  MURES2   (JADEMUS1)    FORTRAN
C LAST CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C        LAST CHANGE 18.40  17/12/80  HUGH MCCANN.
      SUBROUTINE MURES2(I0,I1,I2,I3,I4)
C
C  THIS ROUTINE CONTROLS THE PRINTING OF THE MUON ANALYSIS
C  PHILOSOPHY2 RESULTS BANKS.IF ANY OF I0,I1 ETC IS
C  SET TO 1 , THE CORRESPONDING MUR2 BANK IS PRINTED OUT.
C  (N.B. AT PRESENT (17/12/80) ROUTINES EXIST ONLY TO
C  OUTPUT BANKS 0,1,2 AND 3 . IT IS INTENDED TO ADD THE
C  NECESSARY ROUTINES FOR THE OTHERS AS THE NEED ARISES.)
C
      IMPLICIT INTEGER*2 (H)
#include "cmubcs.for"
      COMMON /CMUIEV/IEV,NEV,IRD,KRUN,KREC,
     *ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
C PICK UP HEADER POINTER.
      IPHEAD=IDATA(IBLN('HEAD'))
C PICK UP RUN NUMBER ,RECORD NUMBER ETC
      ISECS = HDATA(2*IPHEAD+3)
      IMINS = HDATA(2*IPHEAD+4)
      IHOURS= HDATA(2*IPHEAD+5)
      IDAY  = HDATA(2*IPHEAD+6)
      IMONTH= HDATA(2*IPHEAD+7)
      IYEAR = HDATA(2*IPHEAD+8)
      KRUN  = HDATA(2*IPHEAD+10)
      KREC  = HDATA(2*IPHEAD+11)
C
C  WRITE EVENT HEADER.
C
      WRITE(6,1000)KRUN,KREC,IEV,IHOURS,IMINS,
     *ISECS,IDAY,IMONTH,IYEAR
 1000 FORMAT('0**********',2X,'RUN',I6,2X,'RECORD',I6,
     *2X,'EVENT (FILE)',I6,2X,'TIME =',I3,':',I2,':',I2,
     *2X,'DATE =',I3,':',I2,':',I4)
C
C LOOK THROUGH ARGUMENTS AND PRINT OUT REQUESTED BANKS.
C
      IF(I0.EQ.1)GO TO 10
  100 CONTINUE
      IF(I1.EQ.1)GO TO 11
  110 CONTINUE
      IF(I2.EQ.1)GO TO 12
  120 CONTINUE
      IF(I3.EQ.1)GO TO 13
  130 CONTINUE
      IF(I4.EQ.1)GO TO 14
  140 CONTINUE
      GO TO 200
C
C
   10 CONTINUE
C---------OUTPUT BANK 0 .
      CALL MUPR20
      GO TO 100
   11 CONTINUE
C
C--------OUTPUT BANK 1 . FIRST , WRITE HEADER.
      WRITE(6,1099)
 1099 FORMAT('0 1        38       4     6     11      14 ',
     *'   15    21      22     24     25      26     30   31  ',
     *' 32   33   34   35   36   37')
      WRITE(6,1101)
 1101 FORMAT(' TRK CH MOMENTUM HIT INF QUAL CHPRMU  ELOSS',
     *2X,'NABS  PIDK   PISNK   KDK   MUPROB   PIPROB FPI   FK   ',
     *'FP  FAP  FPI2 FK2  FP2  FAP2')
      WRITE(6,1102)
 1102 FORMAT(' --- -- -------- ------- ---- ------  -----',
     *2X,'----  ----- ------  ------ ------  ------- ---- ---- -',
     *'--- ---- ---- ---- ---- ----')
      CALL MUPR21
      GO TO 110
   12 CONTINUE
C--- OUTPUT BANK 2. FIRST, WRITE HEADER.
      WRITE(6,1201)
 1201 FORMAT('0 HIT   ASSIGNED TO FOLLOWING TRACK(S):')
      WRITE(6,1202)
 1202 FORMAT('  ---   --------------------------------')
      CALL MUPR22
      GO TO 120
   13 CONTINUE
C--- OUTPUT BANK 3. FIRST, WRITE HEADER.
      WRITE(6,1301)
 1301 FORMAT('0 HIT   FOLLOWING AMBIGUITIES WERE USED IN ABOVE:')
      WRITE(6,1302)
 1302 FORMAT('  ---   ------------------------------------------')
      CALL MUPR23
      GO TO 130
   14 CONTINUE
      GO TO 140
  200 CONTINUE
      RETURN
      END

C   20/01/83 606061623  MEMBER NAME  LIMINT   (S)           FORTRAN
      SUBROUTINE LIMINT(IBLOCK,IPART,IER,XL1,XL2,XL3,XU1,XU2,XU3)
C
C     RETURNS INTEGRATION LIMITS USED BY VEGAS FOR INTEGRATION
C     OF THE SHOWER FUNCTION OVER THE BLOCK IBLOCK
C
C     XLI/ XUI  ARE IN CYLINDRICAL COORDINATES OR CARTESIAN COORDINATES
C               FOR BARREL OR ENDCAPS RESPECTIVELY
C
C
C                                       04/06/82
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      XL1 = 0.
      XL2 = 0.
      XL3 = 0.
      XU1 = 0.
      XU2 = 0.
      XU3 = 0.
      IER = 0
      IB = IBLOCK
C
      IF((IB.GE.0).AND.(IB.LE.2879)) GO TO 13
      IER = 1
      GO TO 2000
C
   13 CONTINUE
      IF(IPART.NE.0) GO TO 12
      IF(IB.LE.2687) GOTO 14
      IER = 1
      GOTO 2000
   14 NFI =  IB/32
      NZET = IB - NFI*32
      PC = NFI*DELFI + DELFI/2.
      ZC = ZLGMI + NZET*BLZ + BLZ/2.
      XL1 = RLG
      XU1 = RLG + BLDEP
      XL2 = PC - DELFI/2.
      XU2 = PC + DELFI/2.
      XL3 = ZC - BLZ/2.
      XU3 = ZC + BLZ/2.
      GO TO 2000
C
   12 CONTINUE
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     CHECK FOR CONSIST. IPART - BLOCK# HAS TO BE WRITTEN   !!!!!!
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      BLXY2 = BLXY/2.
C     REDUCE TO NUMBERS 1 - 192
      IB = IB - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (IB - 1)/96
C     REDUCE TO 1 - 96
      IB = IB - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (IB - 1)/24
C     REDUCE TO 1 - 24
      IB = IB - NQ*24
C     CALCULATE CENTER COORDINATES
      IF(.NOT.((IB.EQ.1).OR.(IB.EQ.5).OR.(IB.EQ.10).OR.(IB.EQ.16)))
     1GO TO 43
      YC = BLXY2
      XC = 3.4*BLXY - BLXY2 + (IB/5)*BLXY
   43 CONTINUE
      IF(.NOT.((IB.EQ.2).OR.(IB.EQ.6).OR.(IB.EQ.11).OR.(IB.EQ.17)))
     1GO TO 44
      YC = BLXY2 + BLXY
      XC = 3.*BLXY - BLXY2 + (IB/5)*BLXY
   44 CONTINUE
      IF(.NOT.((IB.EQ.3).OR.(IB.EQ.7).OR.(IB.EQ.12).OR.(IB.EQ.18)))
     1GO TO 45
      YC = BLXY2 + 2.*BLXY
      XC = 2.*BLXY - BLXY2 + (IB/5)*BLXY
   45 CONTINUE
      IF(.NOT.((IB.EQ.8).OR.(IB.EQ.13).OR.(IB.EQ.19).OR.(IB.EQ.20)))
     1GO TO 46
      YC = BLXY2 + BLXY*3.
      K = IB/5
      IF(K.GT.2) K = 7 - K
      XC = (K+1)*BLXY-BLXY2
   46 CONTINUE
      IF(.NOT.((IB.EQ.4).OR.(IB.EQ.9).OR.(IB.EQ.15).OR.(IB.EQ.24)))
     1GO TO 47
      XC = BLXY - BLXY2
      K = (IB-1)/5
      IF(K.EQ.4) K = 3
      YC = 2.4*BLXY + BLXY2 + K*BLXY
   47 CONTINUE
      IF(.NOT.((IB.EQ.14).OR.(IB.EQ.23)))
     1GO TO 48
      XC = 2.*BLXY - BLXY2
      YC = 4.*BLXY + BLXY2 + (IB/15)*BLXY
   48 CONTINUE
      IF(.NOT.((IB.EQ.21).OR.(IB.EQ.22)))
     1GO TO 49
      YC = 4.*BLXY + BLXY2
      XC = - BLXY2 + 4.*BLXY - ((IB-2)/20)*BLXY
   49 CONTINUE
C     ROTATE TO CORRECT QUADRANT
      IF(NQ.NE.1) GO TO 50
      REM = XC
      XC = - YC
      YC = REM
      GO TO 2001
   50 CONTINUE
      IF(NQ.NE.2) GO TO 51
      XC = - XC
      YC = - YC
      GO TO 2001
   51 CONTINUE
      IF(NQ.NE.3) GO TO 2001
      REM = YC
      YC = - XC
      XC = REM
C
 2001 XL1 = XC - BLXY/2.
      XU1 = XC + BLXY/2.
      XL2 = YC - BLXY/2.
      XU2 = YC + BLXY/2.
      XL3 = ZENDPL
      XU3 = ZENDPL+DEPEND
      IF(IPART.EQ.-1) XL3=-XU3
      IF(IPART.EQ.-1) XU3=-XL3
C
 2000 CONTINUE
C
      RETURN
      END
C
      FUNCTION ICHECK(P1,P2,IPART)
C
C     CHECK WETHER IMPACT POINT (P1,P2) IS ON LG-SURFACE
C
C     ICHECK = 1 -->  O.K.
C                                       04/06/82
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
      DIMENSION MAP(6,6)
C
      ICHECK = 0
C
      IF(IPART.EQ.0) GO TO 1
C
      MAP(1,1)=   -1
      MAP(2,1)=   -1
      MAP(3,1)= 2688
      MAP(4,1)= 2692
      MAP(5,1)= 2697
      MAP(6,1)= 2703
      MAP(1,2)=   -1
      MAP(2,2)=   -1
      MAP(3,2)= 2689
      MAP(4,2)= 2693
      MAP(5,2)= 2698
      MAP(6,2)= 2704
      MAP(1,3)= 2691
      MAP(2,3)= 2690
      MAP(3,3)= 2694
      MAP(4,3)= 2699
      MAP(5,3)= 2705
      MAP(6,3)=   -1
      MAP(1,4)= 2696
      MAP(2,4)= 2695
      MAP(3,4)= 2700
      MAP(4,4)= 2707
      MAP(5,4)= 2706
      MAP(6,4)=   -1
      MAP(1,5)= 2702
      MAP(2,5)= 2701
      MAP(3,5)= 2709
      MAP(4,5)= 2708
      MAP(5,5)=   -1
      MAP(6,5)=   -1
      MAP(1,6)= 2711
      MAP(2,6)= 2710
      MAP(3,6)=   -1
      MAP(4,6)=   -1
      MAP(5,6)=   -1
      MAP(6,6)=   -1
      X = P1
      Y = P2
      IF((ABS(X).LT.(2.*BLXY)).AND.(ABS(Y).LT.(2.*BLXY))) GO TO 100
      IF((X.GT.0.).AND.(Y.GE.0.)) IQUAD=1
      IF((X.LE.0.).AND.(Y.GT.0.)) IQUAD=2
      IF((X.LT.0.).AND.(Y.LE.0.)) IQUAD=3
      IF((X.GE.0.).AND.(Y.LT.0.)) IQUAD=4
C
C     ROTATE (X,Y) INTO THE FIRST QUADRANT.
C
      JQUAD=0
    2 CONTINUE
      JQUAD=JQUAD+1
      IF(JQUAD.GE.IQUAD) GO TO 3
      XS = Y
      YS =-X
      X  =XS
      Y  =YS
      GO TO 2
    3 CONTINUE
      IF(Y.LT.BLXY) X=X-50.
      IF(X.LT.BLXY) Y=Y-50.
      IX=1.+X/BLXY
      IY=1.+Y/BLXY
      IF((IX.GT.6).OR.(IY.GT.6)) GO TO 100
      IBLK=MAP(IX,IY)
      IF(IBLK.LT.0) GO TO 100
      ICHECK = 1
      GO TO 100
C
    1 Z = P2
      IZ=(Z-ZLGMI)/BLZ
      IF((IZ.LT.1).OR.(IZ.GT.30)) GO TO 100
      ICHECK = 1
C
  100 RETURN
      END

C   17/05/88 805171202  MEMBER NAME  JOBFIN   (S)           FORTRAN77
      SUBROUTINE JOBFIN( ICODE, IEV, * )
C----------------------------------------------------------
C  VERSION OF 14/10/80    LAST MOD 14/10/80    E.ELSEN
C  PRINT OUT MESSAGES AT END OF JOB AND DURING JOB PROCESSING
C  RETURN IS RETRUN 1
C----------------------------------------------------------
C
      GO TO ( 100, 200, 300, 400 ), ICODE
      RETURN
C
C                                           DATA END
  100 WRITE(6,9101) IEV
 9101 FORMAT(1X,20(1H-),'   DATA END  AFTER ',I7,' EVENTS ',20(1H-) )
      GO TO 8000
C
C                                           TIME OUT
  200 WRITE(6,9102) IEV
 9102 FORMAT(1X,20(1H-),'   TIME OUT  AFTER ',I7,' EVENTS ',20(1H-) )
      GO TO 8000
C
C                                           RAD ERROR
  300 WRITE(6,9103) IEV
 9103 FORMAT(1X,20(1H-),'  READ ERROR AFTER ',I7,' EVENTS ',20(1H-) )
      GO TO 8000
C                                           RAD ERROR
  400 WRITE(6,9104) IEV
 9104 FORMAT(1X,20(1H-),' IRECMX EXCEEDED AFTER ',I7,' EVENTS ',20(1H-))
C
 8000 CONTINUE
      RETURN 1
      END

************************************************************************
* BIBY
* ====
*
*     Emulation of IBM/370 FORTRAN intrinsic functions and of former 
*     DESYLIB bit and byte manipulation routines.
*
*     08/01/98  P.A. Movilla Fernandez
*
*     09/06/99  PMF     HLAND, HLOR, HINT, MACHINE added
*                       MVCL, SETSL modified
*     25/06/99  PMF     MVCL2, MVC2 added
*     09/12/99  PMF     LCOMPL  added
*
*
*     The original routines are ported to Fortran using CERNLIB routines
*     contained in the package BITBYT (M421). 
*     
*     original   present
*     procedure  release     type    CERNLIB routines used
*     --------   -------     ----    ---------------------
*     LAND       LAND(I,J)    I*4    MBYTET
*               HLAND(I,J)    I*2    MBYTET
*     LOR         LOR(I,J)    I*4    MBYTOR
*                HLOR(I,J)    I*2    MBYTOR
*     LXOR       LXOR(I,J)    I*4    SBIT0,SBIT1,JBIT
*     AND         AND(I,J)    R*4    MBYTET
*     OR           OR(I,J)    R*4    MBYTOR
*     LCOMPL   LCOMPL(I,J)    I*4
*     BITON    IBITON(I,J)    I*4    MSBIT0
*     BITOFF  IBITOFF(I,J)    I*4    MSBIT1
*     TBIT       TBIT(I,J)    L*4    JBIT
*     SHFTL    ISHFTL(I,J)    I*4    CBYT
*     SHFTR    ISHFTR(I,J)    I*4    CBYT
* 
*     MVB         MVB                CBYT
*     MVCL        MVCL               CBYT
*                 MVCL2              CBYT,UCOPY
*     MVC         MVC                ->MVCL
*                 MVC2               ->MVCL2
*     SETSL       SETSL              CBYT
*     SETS        SETS               ->SETSL
*
*     Help routines:
*     HINT(I)                 I*2
*     MACHINE
* 
*************************************************
      INTEGER FUNCTION LAND(IW,JW)
      IMPLICIT NONE
*
*  Usage: IX = LAND(IW,JW)
*         
*         IW,JW: INTEGER*4
*         IX = logical AND of IW and JW
*
      INTEGER IW,JW,MBYTET
C
      LAND = MBYTET(IW,JW,1,32)
C
      RETURN
      END
*************************************************
      INTEGER FUNCTION LOR(IW,JW)
      IMPLICIT NONE
*
*  Usage: IX = LOR(IW,JW)
*          
*         IW,JW:  INTEGER*4
*         IX = logical OR of IW and JW
*
      INTEGER IW,JW,MBYTOR
C
      LOR = MBYTOR(IW,JW,1,32)
C
      RETURN
      END
*************************************************
      INTEGER FUNCTION LXOR(IW,JW)
      IMPLICIT NONE
*
*  Usage: IX = LXOR(IW,JW)
*         
*         IW,JW: INTEGER*4
*         IX = logical EXCLUSIVE OR of IW and JW
*
      INTEGER IW,JW,I
      INTEGER JBIT 
C
      DO 10 I = 1, 32
         IF (   (JBIT(IW,I).EQ.1).AND.(JBIT(JW,I).EQ.0) 
     +      .OR.(JBIT(IW,I).EQ.0).AND.(JBIT(JW,I).EQ.1) ) THEN
            CALL SBIT1(LXOR,I)
         ELSE
            CALL SBIT0(LXOR,I)
         ENDIF
 10   CONTINUE
C
      RETURN
      END
************************************************
      INTEGER FUNCTION LCOMPL(IW)
      IMPLICIT NONE
*
* Usage: IX = LCOMPL(IW)
*
*        IW: INTEGER*4
*        IX = binary 1-complement of IW
*
      INTEGER IW,IZ
      DATA IZ/ZFFFFFFFF/
C
      LCOMPL=IZ-IW
C
      RETURN
      END
************************************************
      REAL FUNCTION AND(IW,JW)
      IMPLICIT NONE
*
*  Usage: X = AND(A,B)
*         
*         A,B: INTEGER*4, REAL*4
*
*     X = logical AND of A and B
*
*
      INTEGER IW,JW,MBYTET
      INTEGER JAND
      REAL RAND
      EQUIVALENCE(JAND,RAND)
C
      JAND=MBYTET(IW,JW,1,32)
      AND=RAND
C
      RETURN
      END
************************************************
      REAL FUNCTION OR(IW,JW)
      IMPLICIT NONE
*
*  Usage: X = OR(A,B)
*         
*         A,B: INTEGER*4, REAL*4
*         X = logical OR of A and B
*
      INTEGER IW,JW,MBYTOR
      INTEGER JOR
      REAL ROR
      EQUIVALENCE(JOR,ROR)
C
      JOR=MBYTOR(IW,JW,1,32)
      OR=ROR
C
      RETURN
      END
************************************************
      INTEGER*2 FUNCTION HLAND(I,J)
      IMPLICIT NONE
*
*  Usage: HX = HLAND(I,J)
*
*         I,J: INTEGER*2
*         HX = logical AND of I and J
*
*  HLAND uses S/R MACHINE to check the endian convention.
*
      INTEGER MBYTET
      INTEGER*2 I,J
      INTEGER*2 II(2),JJ(2)
      DATA II(1)/0/,JJ(1)/0/
C Byteorder from subroutine MACHINE:
      INTEGER ITYPE,IST
      COMMON / CIST / ITYPE,IST(4)
C
      IF( ITYPE.EQ.0 ) CALL MACHINE
      II(ITYPE)=I
      JJ(ITYPE)=J
      HLAND=MBYTET(II,JJ,1,32)
C
      RETURN
      END
************************************************
      INTEGER*2 FUNCTION HLOR(I,J)
      IMPLICIT NONE
*
*  Usage: HX = HLOR(I,J)
*
*         I,J: INTEGER*2
*         HX = logical OR of I and J
*
*  HLOR uses S/R MACHINE to check the endian convention.
*
      INTEGER MBYTOR
      INTEGER*2 I,J
      INTEGER*2 II(2),JJ(2)
      DATA II(1)/0/,JJ(1)/0/
C Byteorder from subroutine MACHINE:
      INTEGER ITYPE,IST
      COMMON / CIST / ITYPE,IST(4)
C
      IF( ITYPE.EQ.0 ) CALL MACHINE
      II(ITYPE)=I
      JJ(ITYPE)=J
      HLOR=MBYTOR(II,JJ,1,32)
C
      RETURN
      END
************************************************
      INTEGER FUNCTION IBITOFF(IW,J)
      IMPLICIT NONE
*
*  Usage: IX = IBITOFF(IW,J)
*
*         IW,J: INTEGER*4
*         
*     Returns IW in IX with bit J set to 0.    
*     IW is also modified.
*     J = 0 ... 31
* NB: IBM Convention
*     J=0  : most significant bit
*     J=31 : least significant bit
*
      INTEGER IW,J,MSBIT0
C
      IW = MSBIT0(IW,32-J)
      IBITOFF = IW
C
      RETURN
      END
*************************************************
      INTEGER FUNCTION IBITON(IW,J)
      IMPLICIT NONE
*
*  Usage: IX = IBITON(IW,J)
*
*         IW,J: INTEGER*4
*         
*     Returns IW in IX with bit J set to 1    
*     IW is also modified.
*     J = 0 ... 31
* NB: IBM Convention
*     J=0  : most significant bit
*     J=31 : least significant bit
*
      INTEGER IW,J,MSBIT1
C
      IW = MSBIT1(IW,32-J)
      IBITON = IW
C
      RETURN
      END
************************************************
      LOGICAL FUNCTION TBIT(IW,J)
      IMPLICIT NONE
*
*  Usage: LX = TBIT(IW,J)
*
*         IW, J: INTEGER
*         
*         LX = .TRUE.  if bit J is set in IW 
*         LX = .FALSE. if bit J is not set in IW 
*         J = 0 ... 31
* NB: IBM Convention
*     J=0  : most significant bit
*     J=31 : least significant bit
*
      INTEGER IW,J,JBIT
C
      IF (JBIT(IW,32-J).EQ.1) TBIT = .TRUE.
      IF (JBIT(IW,32-J).EQ.0) TBIT = .FALSE.
C
      RETURN
      END
************************************************
      INTEGER FUNCTION ISHFTL(IW,K)
      IMPLICIT NONE
*
*  Usage: IX = ISHFTL(IW,K)
*
*     IW,K: INTEGER
*     Returns IW in IX with the bits in IW 
*     shifted left by K units. The upper bits 
*     are lost, the lower bits are filled with 0.
*
      INTEGER IW,K
C
      IF (K.LT.0.OR.K.GT.32) THEN
         WRITE(6,1001) K
 1001    FORMAT(' ISHFTL bad argument !!   Nr. of shifts ',I9)
         STOP
      ENDIF
C
      ISHFTL=0
C      K=MOD(K,64)
      CALL CBYT(IW,1,ISHFTL,K+1,32-K)
C
      RETURN
      END
************************************************
      INTEGER FUNCTION ISHFTR(IW,K)
      IMPLICIT NONE
*
*  Usage: IX = ISHFTR(IW,K)
*
*     IW,K: INTEGER
*     Returns IW in IX with the bits in IW
*     shifted right by K units. The lower bits
*     are lost, the upper bits are filled with 0.
*
      INTEGER IW,K
C
      IF (K.LT.0.OR.K.GT.32) THEN
         WRITE(6,1001) K
 1001    FORMAT(' ISHFTR bad argument !!   Nr. of shifts ',I9)
         STOP
      ENDIF
C
      ISHFTR=0
C      K=MOD(K,64)
      CALL CBYT(IW,K+1,ISHFTR,1,32-K)
C
      RETURN
      END
************************************************
      SUBROUTINE MVB(A,NA,B,NB,M)
      IMPLICIT NONE
*     
*  MVB calling sequence is
*    CALL MVB (A,      NA,     B,      NB,      M)
*              Target  start   origin  start    Bits to be copied
*      Start is the first bit of the range to be copied!
*
*      NA, NB = 0 ... 31
*
      INTEGER A,B,NA,NB,M
C
      IF (M.LE.0.OR.M.GT.32) THEN
         WRITE(6,1001) M
 1001    FORMAT(' MVB bad argument !!   Nr. of bits ',I9)
         STOP
      ENDIF
C
      CALL CBYT(B,NB+1,A,NA+1,M)
C
      RETURN
      END
************************************************
      SUBROUTINE MVC(A,NA,B,NB,M)
      IMPLICIT NONE
*
*  MVC calling sequence is
*   CALL MVC (A,      NA,     B,      NB,      M)
*              Target  start   origin  start    Bytes to be copied
*      Start is the last byte BEFORE the range to be copied!
*
      INTEGER A(1),B(1),NA,NB,M
C
      CALL MVCL(A,NA,B,NB,M)
C
      RETURN
      END
************************************************
      SUBROUTINE MVC2(A,NA,B,NB,M)
      IMPLICIT NONE
*
*  MVC calling sequence is
*   CALL MVC2 (A,      NA,     B,      NB,      M)
*              Target  start   origin  start    Bytes to be copied
*      Start is the last byte BEFORE the range to be copied!
*
      INTEGER*2 A(1),B(1)
      INTEGER NA,NB,M
C
      CALL MVCL2(A,NA,B,NB,M)
C
      RETURN
      END
************************************************
      SUBROUTINE MVCL(A,NA,B,NB,M)
      IMPLICIT NONE
*
*  MVCL calling sequence is
*   CALL MVCL (A,      NA,     B,      NB,      M)
*              Target  start   origin  start    Bytes to be copied
*      Start is the last byte BEFORE the range to be copied!
*
*   Example:   CALL MVCL(A,56,B,0,40)  copies B(1:10) into A(15:24)
*
*  The CERN routine CBYT (package M421, BITBYT) has the calling sequence
*   CALL CBYT (IA,      JA,         IX,        J,         NBITS)
*              origin   Byte LSB    Target     Byte LSB   bits/byte
*
*   Example:   CALL CBYT(IA,9,IX,17,16) copies 2 middle bytes of word IA
*                                       into 2 upper bytes of word IX.
*
*   Author:  J. Olsson   28.12.97
*            PMF         25.06.99 last modified
*            PMF         16.05.00 last mod
*
      INTEGER A(1),B(1),NA,NB,M
      INTEGER KA,KB,JAW,JBW,IAB,IBB
C Byteorder from subroutine MACHINE:
      INTEGER IST,ITYPE
      COMMON / CIST / ITYPE,IST(4)
C
      IF( ITYPE.EQ.0 ) CALL MACHINE
C
      IF(M.LE.0) THEN 
         WRITE(6,1001) M
 1001    FORMAT(' MVCL bad argument !!   Nr. of bytes ',I9
     +         ,', will not copy.' )
         GOTO 9999
      ENDIF
      IF(NA.LT.0) THEN 
         WRITE(6,1002) NA
 1002    FORMAT(' MVCL bad argument !!   Target address ',I9)
         STOP
      ENDIF
      IF(NB.LT.0) THEN 
         WRITE(6,1003) NB
 1003    FORMAT(' MVCL bad argument !!   Source address ',I9)
         STOP
      ENDIF
C
      KA = NA	
      DO 100 KB = NB+1,NB+M
         KA = KA + 1 
         JAW = (KA-1)/4 + 1
         JBW = (KB-1)/4 + 1
         IAB = IST(MOD(KA-1,4) +1)
         IBB = IST(MOD(KB-1,4) +1)
         CALL CBYT(B(JBW),IBB,A(JAW),IAB,8)
 100  CONTINUE
C
 9999 RETURN
      END
************************************************
      SUBROUTINE MVCL2(A,NA,B,NB,M)
      IMPLICIT NONE
*
*  MVCL2 calling sequence is
*   CALL MVCL2 (A,      NA,     B,      NB,      M)
*              Target  start   origin  start    Bytes to be copied
*      Start is the last byte BEFORE the range to be copied!
*
* This is a modified version of MVCL working also with *misaligned* 
* data arrays arguments, as may be sometimes the case. Use MVCL2 instead
* of MVCL if one array argument is a half integer array with even index!
*
* The adressed part of the original data arrays A, B are
* put into the extra arrays HA, HB with the desired working memory
* alignment. The copy procedure is then performed with these arrays, 
* with the results transferred to respective part of the original 
* target array. 
*
* MVCL2 handles both integer and half integer arguments correctly, 
* but the faster routine MVCL is recommended in the normal case.
*
* -----
* NB.: It is not possible to relate the arrays IA, IB used as arguments 
* for CBYT to HA, HB via the EQUIVALENCE statement.
* -----
      INTEGER*2 A(1),B(1)
      INTEGER NA,NB,M,I
      INTEGER*2 HA((NA+M+1)/2),HB((NB+M+1)/2)
      INTEGER IA((NA+M+3)/4),IB((NB+M+3)/4)
C     
      INTEGER KA,KB,JAW,JBW,IAB,IBB
C Byteorder from subroutine MACHINE:
      INTEGER IST,ITYPE
      COMMON / CIST / ITYPE,IST(4)
C
      IF( ITYPE.EQ.0 ) CALL MACHINE
C
      IF(M.LE.0) THEN 
         WRITE(6,1001) M
 1001    FORMAT(' MVCL bad argument !!   Nr. of bytes ',I9)
         STOP
      ENDIF
      IF(NA.LT.0) THEN 
         WRITE(6,1002) NA
 1002    FORMAT(' MVCL bad argument !!   Target address ',I9)
         STOP
      ENDIF
      IF(NB.LT.0) THEN 
         WRITE(6,1003) NB
 1003    FORMAT(' MVCL bad argument !!   Source address ',I9)
         STOP
      ENDIF
C
      DO 40 I=1,INT((NB+M+1)/2)
 40      HB(I)=B(I)
      DO 50 I=1,INT((NA+M+1)/2)
 50      HA(I)=A(I)
      CALL UCOPY(HB,IB,(NB+M+3)/4)
      CALL UCOPY(HA,IA,(NA+M+3)/4)
C
      KA = NA   
      DO 100 KB = NB+1,NB+M
         KA = KA + 1 
         JAW = (KA-1)/4 + 1
         JBW = (KB-1)/4 + 1
         IAB = IST(MOD(KA-1,4) +1)
         IBB = IST(MOD(KB-1,4) +1)
         CALL CBYT(IB(JBW),IBB,IA(JAW),IAB,8)
 100  CONTINUE
C
      CALL UCOPY(IA,HA,(NA+M+3)/4)
      DO 150 I=1,INT((NA+M+1)/2)
 150     A(I)=HA(I)
C
      RETURN
      END
************************************************
      SUBROUTINE SETS(A,NA,M,C)
      IMPLICIT NONE
*
*  SETS calling sequence is
*   CALL SETS (A,      NA,     M,                  C)
*              target  start   Bytes in target     origin     
*                              to be overwritten 
*
*      Start is the last byte BEFORE the range to be copied!
*
*   Example:   CALL SETS(A,56,12,C)  copies C(1) into A(15),A(16),A(17)
*
      INTEGER A,C,NA,M
C
      CALL SETSL(A,NA,M,C)
C
      RETURN
      END
************************************************
      SUBROUTINE SETSL(A,NA,M,C)
      IMPLICIT NONE
*
*  SETSL calling sequence is
*   CALL SETSL (A,      NA,     M,                  C)
*               target  start   Bytes in target     origin     
*                               to be overwritten 
*
*      Start is the last byte BEFORE the range to be copied!
*
*   Example:   CALL SETSL(A,56,12,C)  copies C(1) into A(15),A(16),A(17)
*
      INTEGER   A(1),NA,M
      INTEGER*1 C(1)
      INTEGER KA,JAW,IAB
C Byteorder from subroutine MACHINE:
      INTEGER IST,ITYPE
      COMMON / CIST / ITYPE,IST(4)
C
      IF( ITYPE.EQ.0 ) CALL MACHINE
C
      IF(M.LE.0) THEN 
         WRITE(6,1001) M
 1001    FORMAT(' SETSL bad argument !!   Nr. of bytes ',I9)
         STOP
      ENDIF 
      IF(NA.LT.0) THEN 
         WRITE(6,1002) NA
 1002    FORMAT(' SETSL bad argument !!   Target address ',I9)
         STOP
      ENDIF
C
      DO 100 KA = NA+1 ,NA+M 
         JAW = (KA-1)/4 + 1
         IAB = IST(MOD(KA-1,4) +1)
         CALL CBYT(C(1),1,A(JAW),IAB,8)
 100  CONTINUE
C
      RETURN
      END
************************************************
      INTEGER*2 FUNCTION HINT(I)
      IMPLICIT NONE
*
* Usage: H = HINT(I)
*
*        I: INTEGER*4
*        H: INTEGER*2
*
*     Performs a conversion of an 
*     INTEGER*4 to an INTEGER*2
*        
*
      INTEGER I
C
      HINT=I
C
      RETURN
      END
************************************************
      SUBROUTINE MACHINE
      IMPLICIT NONE
*
* Usage: CALL MACHINE
*
*     Returns in ITYPE the present type of byte order 
*     in an INTEGER*4 word
*     COMMON / CIST / IST(4) contains the byte order
*     realised on the present platform;
*     IST(1...4) = bit numbers of 4 consecutive bytes
*                  in a word (lsb/msb)
*
*      ITYPE = 1: IBM-like byte order
*      ITYPE = 2: DEC/ALPHA-like byte order
*      
      LOGICAL FIRST
      DATA FIRST /.TRUE./
      SAVE FIRST
C
      INTEGER IBYTE
      INTEGER*2 HBYTE(2)
      EQUIVALENCE (HBYTE(1),IBYTE)
      DATA IBYTE/1/
C
      INTEGER IST,ITYPE
      COMMON / CIST / ITYPE,IST(4)
C
      IF(HBYTE(1).EQ.0) THEN
         ITYPE=2
         IST(1) = 25
         IST(2) = 17
         IST(3) = 9
         IST(4) = 1
         IF( FIRST ) THEN  
            PRINT *,'* MACHINE: Big endian (IBM like), ITYPE=',ITYPE
            FIRST = .FALSE.
         ENDIF
      ELSEIF(HBYTE(2).EQ.0) THEN
         ITYPE=1
         IST(1) = 1
         IST(2) = 9
         IST(3) = 17
         IST(4) = 25
         IF( FIRST ) THEN
            PRINT *,'* MACHINE: Little endian, ITYPE=',ITYPE
            FIRST = .FALSE.
         ENDIF
      ELSE
         ITYPE=-1
         PRINT *,'* MACHINE: Unknown type, ITYPE=',ITYPE
         STOP
      ENDIF
C
      RETURN
      END
      BLOCK DATA CISTBLK
      IMPLICIT NONE
      INTEGER ITYPE,IST
      COMMON / CIST / ITYPE,IST(4)
      DATA ITYPE /0/
      END
***********************************************

C   23/02/79 C9062501   MEMBER NAME  DIAGIN   (JADEGS)      FORTRAN
      SUBROUTINE DIAGIN(HTEXT,N,K1,K2,K3,K4,K5,K6)
C---
C---     PRINT HTEXT AND UP TO 6 INTEGER NUMBERS, FOR DIAGNOSTICS
C---
      IMPLICIT INTEGER*2 (H)
      DIMENSION K(6),HTEXT(10),HWORK(40)
C---
      IF(N.LT.1.OR.N.GT.6) RETURN
      DO 1  I = 1,6
1     K(I) = 0.
      IF(N.GT.0) K(1) = K1
      IF(N.GT.1) K(2) = K2
      IF(N.GT.2) K(3) = K3
      IF(N.GT.3) K(4) = K4
      IF(N.GT.4) K(5) = K5
      IF(N.GT.5) K(6) = K6
      ILIM = 20 + N*9
      CALL CORE(HWORK,ILIM)
      WRITE(10,100) (HTEXT(I),I=1,10),(K(I),I=1,N)
100   FORMAT(10A2,6I9)
      CALL TRMOUT(ILIM,HWORK)
      RETURN
      END

C   07/12/83 807251615  MEMBER NAME  MULDSP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MULDSP
C-----------------------------------------------------------------------
C
C LAST CHANGE 13.14 15/02/88 J. HAGEMANN  - USE BCMD TO CHANGE FACTOR
C      CHANGE 22.15 15/03/84 CHRIS BOWDERY- TIDYING UP
C      CHANGE 14.00 15/03/84 PAUL HILL    - DRAW TYPE 9 MUONS ONLY
C      CHANGE 14.00 26/01/84 PAUL HILL    - DRAW TYPE 5 MUONS ONLY
C      CHANGE 14.00  7/12/83 CHRIS BOWDERY- NEW MUCUTS CRITERIA
C      CHANGE 14.00  8/11/83 CHRIS BOWDERY- TO CONFORM WITH MUCUTS
C      CHANGE 19.50 20/10/81 CHRIS BOWDERY- TO CORRECT A CDTL 36 BUG
C      CHANGE 17.41 28/09/81 CHRIS BOWDERY- COMMENT OUT PHIL 1 DISPLAY
C      CHANGE 13.13 24/09/81 CHRIS BOWDERY- MAJOR CHANGES(HITS MARKED..)
C NEW VERSION 20.30  7/07/81 CHRIS BOWDERY- SINGLE TRACK DISPLAY
C
C        THIS ROUTINE DISPLAYS MUON TRACKS AND 'ELLIPSES' ON SCREEN.
C        'INDEX'= TRAILING NUMBER WITH 'MUPT' COMMAND
C
C        IF 'INDEX' = 0    ALL TRACKS ARE DRAWN.
C        IF 'INDEX' < 0    A RE-ANALYSIS OCCURS AND ALL TRACKS ARE DRAWN
C        IF 'INDEX' > 0    ONLY TRACK NUMBER 'INDEX' IS DRAWN UNLESS ...
C
C        IF 'INDEX' = 100  ALL TRACKS WITH MUQUALITY > 0 AND < 100 DRAWN
C        IF 'INDEX' = 200  ALL TRACKS WITH MUQUALITY > 100  DRAWN
C        IF 'INDEX' = 300  ALL TRACKS WITH MUQUALITY = 0  DRAWN IF THEY
C                          ARE ASSOCIATED WITH A HIT OUTSIDE THE YOKE.
C        IF 'INDEX' = 1000 TRACKS WITH MUCUTS FLAG GT 0  ARE DRAWN
C        IF 'INDEX' = 5000 TRACKS WITH MUCUTS FLAG GE 5  ARE DRAWN
C        IF 'INDEX' = 9000 TRACKS WITH MUCUTS FLAG GE 9  ARE DRAWN
C
C        INDEX IS FOUND FROM ACMD IN THE COMMON CGRAPH
C        FL18 = .TRUE. IF THE SIDE PROJECTIONS ARE BEING DONE. MESSAGES
C                          WILL BE INHIBITED IN THIS CASE. (CDTL 17 ON)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL VALID,VALIL,LOST1,END,DSPDTM,M100,M200,M300,M1000,NODRAW
      LOGICAL M5000,M9000
      LOGICAL XYVIEW,ZXVIEW,ZYVIEW,GOODMU,MUOK
      LOGICAL FL18,FL22,FL24
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C   20/10/81 408081453  MEMBER NAME  CMUFFL   (S)           FORTRAN
C
C LAST CHANGE 15.00 08/08/84 - CKB PWA     - ADD NALLWM,PMXFLG
C      CHANGE 15.00 03/12/83 - HUGH MCCANN - NEW LEAD GLASS PARAMETERS.
C      CHANGE 08.00 12/10/81 - HUGH MCCANN - TO ADD OVLCUT(FOR OVERLAPS)
C      CHANGE 09.33 17/06/81 - JOHN ALLISON - TO ADD RESOLUTIONS.
C
C-------------START OF MACRO CMUFFL-------------------------------------
C
      COMMON / CMUFFL / XYSTEP,RCOILI,RCOILO,PGMID,WMU,WMUSQ,DUMF1(4),
     +                  NSPECI,XPBAR,XPROT,XPION,XKAON,DUMF2(5),
     +                  TBP,GMBP,ABBP,RDBP,DEBP,
     +                  TJETI,GMJETI,ABJETI,RDJETI,DEJETI,
     +                  TJET1,GMJET1,ABJET1,RDJET1,DEJET1,
     +                  TJET2,GMJET2,ABJET2,RDJET2,DEJET2,
     +                  TJET4,GMJET4,ABJET4,RDJET4,DEJET4,
     +                  TJETO,GMJETO,ABJETO,RDJETO,DEJETO,
     +                  TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL,
     +                  ZJETE,TJETE,GMJETE,ABJETE,RDJETE,DEJETE,
     +                  ZEPLG,TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG,
     +                  RLG,ZLG,TLG,GMLG,ABLG,RDLG,DELG,
     +                  ZEP,TEP,GMEP,ABEP,RDEP,DEEP,
     +                  GMG(3),ABG(3),RDG(3),DEG(3),
     +                  VDRES,VLRES,
     +                  REST1,REST2,RESTMX,RESL,RESLMX,FACTOR,OVLCUT,
     +                  ZLGHAF,TLGHAF,ZLGC,GMLGC,ABLGC,RDLGC,DELGC,
     +                  NALLWM,PMXFLG
C
C FOR EXPLANATION SEE BLOCK DATA AFTER SUBROUTINE MUFFLE.
C
C--------------END OF MACRO CMUFFL--------------------------------------
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CMUGRA / IMR112,IMR122,IMUR20,IMUR21,NTRKS,NWHIT,
     +                  NTPH,NWMUR,IMR222,IMR232,NHITS,MUOK
C
      DIMENSION HC(9),HAMB(2),HAMBA(2),XX(2),YY(2)
C
C------------------  C O D E  ------------------------------------------
C
      INDEX = ACMD
C
      IF( BCMD .GT. 0.0 ) FACTOR = BCMD
      MUOK  = .TRUE.
C
C                       PICK  UP  POINTERS  TO  THE  BANKS  USING  BOS
C                       FUNCTION IBLN
C
      IPMU  = IBLN('MUEV')
      IPATR = IBLN('PATR')
C
C                       RETURN IF NO RAW MUON DATA BANK 'MUEV'  EXISTS
C                       ELSE  RE-ANALYSE  THE  MUON  DATA  IF   (MUPT)
C                      'INDEX'  NEGATIVE.    THIS   ENTAILS   DELETING
C                       EXISTING MUON BANKS (IF ANY).
C
      IF( IDATA(IPMU) .LT. 1 ) GO TO 40
      IF( INDEX .GE. 0  .OR.  FL18 ) GO TO 2
C
C                       IF ANY MU BANKS EXIST, DELETE THEM
C
      CALL BMLT(2,'MUR1MUR2')
      CALL BDLM
C
C                       IF NO 'PATR' BANK, SET  FLAG  ==>  NO  PHIL  2
C                       ANALYSIS
C
 3    IMUARG = 1
      IF( IDATA(IPATR) .LT. 1 ) IMUARG = 0
      CALL MUANA(IMUARG)
C
C                       IF NOT  APPROPRIATE  VIEW  OR  IF  CDTL  9  IS
C                       OFF,  DRAW NOTHING
C
 2    IF( LASTVW .GT. 11 ) RETURN
      IF( LASTVW .LE.  3  .OR.  .NOT. DSPDTL(9) ) GO TO 5
        IF( FL18 ) RETURN
        CALL TRMOUT(80,'PLEASE REDRAW WITH PROJECT MODE - CDTL 9^')
        RETURN
C
C                       IF NO 'MUR1' BANKS , RETURN
C                       IF NO PHIL 1 RESULTS IN 'MUR1'  BANKS,  GO  TO
C                       PHIL 2 RESULTS
C
 5    CALL CLOC( IMUR10, 'MUR1', 0 )
      IF( IMUR10 .GT. 0 ) GO TO 7
 6      IF( INDEX .LT. 0 ) GO TO 40
        IF(.NOT. FL18) CALL TRMOUT(80,'NO RESULTS. PLEASE USE MUPT -1^')
        RETURN
 40     IF(.NOT. FL18) CALL TRMOUT(80,'NO MUON HITS^')
        RETURN
C
 7    CALL CLOC( IMUR11, 'MUR1', 1 )
      IF( IMUR11 .LT. 1 ) GO TO 40
      IMR112 = IMUR11*2
      CALL CLOC( IMUR12, 'MUR1', 2 )
      IF( IMUR12 .LT. 1 ) GO TO 6
      IMR122 = IMUR12 * 2
C
C                       DEFINE NWHIT AND NHITS FOR PHIL 2
C
      NHITS  = IDATA( IMUR10 + 1 )
      NWHIT  = IDATA( IMUR10 + 3 )
C
C-----------------------------------------------------------------------
C             IF NO 'MUR2' BANKS OR IF THEY ARE EMPTY, RETURN
C-----------------------------------------------------------------------
C
      CALL CLOC( IMUR20, 'MUR2', 0 )
      IF(IMUR20 .LE. 0 ) GO TO 6
      NTRKS  = IDATA( IMUR20 + 1 )
      IF(NTRKS .LE. 0 )  RETURN
C
C                       GET NO. OF WORDS PER TRACK/ NO. OF  WORDS  PER
C                       HIT ETC.
C
      NWMUR  = IDATA( IMUR20 + 2 )
      NTPH   = IDATA( IMUR20 + 3 )
      NPL    = IDATA( IMUR20 + 4 )
C
C                       GET POINTERS TO 'MUR2' BANKS 1,2,3,4 AND 5
C
      CALL CLOC( IMUR21, 'MUR2', 1 )
      CALL CLOC( IMUR22, 'MUR2', 2 )
      CALL CLOC( IMUR23, 'MUR2', 3 )
      CALL CLOC( IMUR24, 'MUR2', 4 )
      CALL CLOC( IMUR25, 'MUR2', 5 )
C
      IF( IMUR21 .LE. 0     .OR.
     +    IMUR22 .LE. 0     .OR.
     +    IMUR23 .LE. 0     .OR.
     +    IMUR24 .LE. 0     .OR.
     +    IMUR25 .LE. 0            )  GO TO 6
C
C                       HALF WORD POINTERS FOR S/R MUHIT (SEE  COMMON)
C
      IMR222 = IMUR22 * 2
      IMR232 = IMUR23 * 2
C
C-----------------------------------------------------------------------
C             ***  PHILOSOPHY 2 MUON ANALYSIS RESULTS DISPLAY  **
C-----------------------------------------------------------------------
C
      XYVIEW = LASTVW .EQ.  3
      ZXVIEW = LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7
      ZYVIEW = LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11
C
C                       REMEMBER SPECIAL INDEX VALUES
C
      M100   = INDEX .EQ. 100
      M200   = INDEX .EQ. 200
      M300   = INDEX .EQ. 300
      M1000  = INDEX .EQ. 1000
      M5000  = INDEX .EQ. 5000
      M9000  = INDEX .EQ. 9000
C
C                       DEFINE RANGE OF DO LOOP (ALL TRACKS)
C
      ITRKL  = 1
      ITRKH  = NTRKS
C
C                       SET DO LOOP TO DRAW ONLY TRACK #INDEX IF INDEX>0
C                       OR ALLOW THE SPECIAL VALUES OF INDEX
C
      IF( M100 .OR. M200 .OR. M300 .OR. M1000 .OR. M5000 .OR. M9000
     + .OR.  INDEX .LE. 0 ) GO TO 20
C
C                       IF NOT SPECIAL INDEX , RETURN IF TOO HIGH
C
        IF( INDEX .GT. NTRKS ) RETURN
        ITRKL  = INDEX
        ITRKH  = INDEX
C
C                       LOOP OVER ALL/REQUESTED TRACKS
C
 20   DO  200  ITRK = ITRKL,ITRKH
        IPL    = 3*NPL*(ITRK-1)
        IPMU   = NWMUR*(ITRK-1)
C
C                            GET TRACK MU QUALITY AND MUCUTS FLAG
C
        MUQUAL = IDATA(IMUR21+IPMU+6)
        MUFLAG = HDATA(IMUR21*2+IPMU*2+53)
        GOODMU = MUQUAL .GT. 0  .AND.  MUQUAL .LT. 100
C
C                            INFORM SCANNER OF GOOD MUONS
C                            BUT NOT FOR SINGLE TRACK DISPLAY
C
        IF( MUFLAG .LE.   0                        ) GO TO 22
        IF( INDEX  .EQ. 200  .OR.   INDEX .EQ. 300 ) GO TO 22
        IF( MUFLAG .LT. INDEX/1000  .OR.  FL18     ) GO TO 22
          WRITE(JUSCRN,21) ITRK,MUFLAG
  21      FORMAT(' TRACK ',I2,' IS A TYPE ',I2,' GOOD MUON')
C
C                            TEST MU QUALITY IF SPECIAL INDEX
C
  22    NODRAW = M100 .AND. .NOT.( GOODMU )
     +           .OR.            ( M200   .AND. MUQUAL .LT. 100 )
     +           .OR.            ( M300   .AND. MUQUAL .NE. 0   )
     +           .OR.            ( M1000  .AND. MUFLAG .LE. 0   )
     +           .OR.            ( M5000  .AND. MUFLAG .LE. 4   )
     +           .OR.            ( M9000  .AND. MUFLAG .LE. 8   )
        IF( MUQUAL .LT. 0  .OR.  NODRAW ) GO TO 200
C
C                       GET TRACK INFORMATION
C                            NAHITS=NUMBER OF ASSOC. HITS
C                            NLOYWH=NO. OF LAYERS OUTSIDE YOKE WITH
C                                              WITH ASSOCIATED HITS
C
          INFO   = IDATA(IMUR21 + 4 +IPMU)
          NAHITS = MOD(INFO,100)
          NLOYWH = MOD(INFO,10000) / 200
          IF( NLOYWH .EQ. 0  .AND.  M300 ) GO TO 200
          IF( NAHITS .EQ. 0 ) GO TO 10
C
C                       ICON IS A RUNNING  VARIABLE  TO  COMPARE  WITH
C                       NAHITS
C
          ICON   = 1
C
C                       LOOK THROUGH MUR2/2 LOOKING FOR A  MENTION  OF
C                       TRACK ITRK
C
          DO  8  IHIT = 1,NHITS
            DO  9  I = 1,NTPH
              JTRK = HDATA(IMR222 + (IHIT-1)*NTPH + I)
              JTRK = IABS(JTRK)
C
C                       IF THERE  WERE  NO  TRACKS  ASSOC.  WITH  THIS
C                       HIT, SKIP TO THE END OF THE LOOP.
C
              IF( JTRK .EQ. 0 ) GO TO 8
C
C                       IS THIS TRACK THE ONE WE WANT ? SKIP IF NOT
C
              IF( JTRK .NE. ITRK ) GO TO 9
C
C                       GET HIT INFORMATION USING S/R MUHIT
C                       (POSITION,HIT VALIDITY,ASSOCIATION CODES)
C
              CALL MUHIT(HC,IHIT,ITRK,LOST1,VALID,VALIL,HAMB,END)
C
C
C-----------------------------------------------------------------------
C  NOTE ORIENTATION OF THIS CHAMBER (FROM HC(2) = 10*LAYER+ORIENTATION)
C      IOR          ORIENTATION
C      ---     ----------------------------
C       1      NORMAL TO DRIFT PLANE IS PARALLEL TO THE X-AXIS
C       2        "    "   "     "    "     "     "   "  Y-AXIS
C       3        "    "   "     "    "     "     "   "  Z-AXIS
C-----------------------------------------------------------------------
C
              IC  = HC(2)
              IOR = MOD(IC,10)
C
C                       IS CDTL 24 SET ?
C
              IF( DSPDTL(24) )GO TO 11
C
C-----------------------------------------------------------------------
C  CDTL 24 IS NOT SET. THEREFORE , ONLY DRAW HITS AS FOLLOWS :
C    LASTVW=3    (XY) DRAW ONLY HITS ON CHAMBERS WHOSE IOR=1 OR 2
C      "    6,7  (XZ)   "   "    "    "    "       "    "  1 OR 3
C      "    10,11(YZ)   "   "    "    "    "       "    "  2 OR 3
C-----------------------------------------------------------------------
C
              IF( XYVIEW  .AND.  IOR .NE. 3 ) GO TO 11
              IF( ZXVIEW  .AND.  IOR .NE. 2 ) GO TO 11
              IF( ZYVIEW  .AND.  IOR .NE. 1 ) GO TO 11
              GO TO 12
C
C                       GET BOTH AMBIGUITIES
C
  11          DO  30  J = 1,2
                IX   = 3 * (J - 1) + 3
                IY   = IX + 1
                IZ   = IX + 2
                XCOR = HC(IX)
                YCOR = HC(IY)
                ZCOR = HC(IZ)
C
C                       CONVERT 3 D SPACE POINT TO 2 D DISPLAY
C                       COORDINATES IN THE X,Y VIRTUAL SPACE.
C
                CALL XYMUD(XCOR,YCOR,ZCOR,XX(J),YY(J))
  30          CONTINUE
C
C                       DRAW BOTH AMBIGUITIES
C
              DO  13  J = 1,2
C
C                       IF CDTL 36 IS ON, DON'T DRAW THE UNPHYSICAL
C                            AMBIGUITY WHERE THIS HAS BEEN RESOLVED.
C
                IF( .NOT. DSPDTM(6) ) GO TO 31
C
C                            IF AMBIGUITY HAS BEEN REJECTED IGNORE IT
C
                IF( HAMB(3-J) .GE. 2  .AND.  HAMB(J) .LT. HAMB(3-J)
     +                                .AND.  HAMB(J) .LT. 3 ) GO TO 13
C
C                            HAS THIS AMBIGUITY BEEN DRAWN IN MUHDSP ?
C
                IF( HAMB(J) .GT. 2 ) GO TO 31
                CALL MUHIT(HC,IHIT,0,LOST1,VALID,VALIL,HAMBA,END)
C
C                            IF NOT DO NOT DRAW A HIT SYMBOL
C
                IF( HAMBA(J) .LT. HAMBA(3-J)  .AND.  HAMBA(J) .LT. 3
     +                   .AND.  HAMBA(3-J) .GE. 2 ) GO TO 13
C
C                            IF CDTL 37 IS ON , DO NOT DRAW ANY SYMBOL
C                            FOR AMBIGUITY CODES LESS THAN 3
C
 31             IF( DSPDTM(7)  .AND.  HAMB(J) .LT. 3 ) GO TO 13
C
C                            WHEN BOTH AMBIGUITIES ARE AT SAME PLACE
C                            DON'T DRAW 2 DIFFERENT SYMBOLS
C
                X = XX(J)
                Y = YY(J)
                IF( X .EQ. XX(3-J)  .AND.  Y .EQ. YY(3-J)  .AND.
     +                HAMB(J) .LT. HAMB(3-J) ) GO TO 13
C
C                       DRAW NOTHING FOR HAMB CODE = 0 NOT  ASSOCIATED
C                       DRAW A  BOX  FOR HAMB CODE = 1  ONLY ASSOCIATED
C                       DRAW A   8   FOR HAMB CODE = 2  MUQUAL = 0
C                       DRAW A  <>   FOR HAMB CODE = 3  MUQUAL > 99
C                       DRAW A   +   FOR HAMB CODE = 4  GOOD MUON HIT
C
                IAMB = HAMB(J)
                IF( IAMB .EQ. 0 ) GO TO 13
                SIZE = 10.
                IF( VALID ) SIZE = 20.
C
C                       DRAW THE ASSOCIATION SYMBOL FOR CODES  1,2,3,4
C                       UNLESS CDTL 8 IS OFF
C
                IF( .NOT. DSPDTL(8)  .AND.  IAMB .NE. 4 ) GO TO 13
                CALL MOVEA(X+SIZE,Y-SIZE)
                GO TO (15,16,17,14) , IAMB
C
C                       A BOX
C
 15               CALL DRAWA(X+SIZE,Y+SIZE)
                  CALL DRAWA(X-SIZE,Y+SIZE)
                  CALL DRAWA(X-SIZE,Y-SIZE)
                  CALL DRAWA(X+SIZE,Y-SIZE)
                  GO TO 13
C
C                       A VERTICAL DIAMOND PAIR 8
C
 16               CALL DRAWA(X     ,Y - 1.5*SIZE)
                  CALL DRAWA(X-SIZE,Y -     SIZE)
                  CALL MOVEA(X+SIZE,Y +     SIZE)
                  CALL DRAWA(X     ,Y + 1.5*SIZE)
                  CALL DRAWA(X-SIZE,Y +     SIZE)
                  GO TO 13
C
C                       A HORIZONTAL DIAMOND PAIR <X>
C
 17               CALL DRAWA(X + 1.5*SIZE,Y     )
                  CALL DRAWA(X +     SIZE,Y+SIZE)
                  CALL MOVEA(X -     SIZE,Y-SIZE)
                  CALL DRAWA(X - 1.5*SIZE,Y     )
                  CALL DRAWA(X -     SIZE,Y+SIZE)
                  GO TO 13
C
C                       A + ==> STAR (*)
C
 14               CALL MOVEA(X,Y-SIZE)
                  CALL DRAWA(X,Y+SIZE)
                  CALL MOVEA(X-SIZE,Y)
                  CALL DRAWA(X+SIZE,Y)
 13             CONTINUE
C
C                       INCREMENT NUMBER OF FOUND HITS
C
 12             ICON = ICON + 1
                IF( ICON .GT. NAHITS ) GO TO 10
                GO TO 8
  9           CONTINUE
 8          CONTINUE
C
C                       NOW DRAW THE  TRACK  LINES  USING  INFORMATION
C                       FROM MUR2/4
C
 10       JPL = IPL
          DO  201  J = 1,NPL
            XCOR = ADATA(IMUR24+JPL+1)
            YCOR = ADATA(IMUR24+JPL+2)
            IF( XCOR .EQ. 0.0  .AND.  YCOR .EQ. 0.0 )GO TO 210
              ZCOR = ADATA(IMUR24+JPL+3)
              CALL XYMUD(XCOR,YCOR,ZCOR,X,Y)
              IF( J .EQ. 1                  ) CALL MOVEA(X,Y)
              IF( J .NE. 1  .AND.  J .NE. 5 ) CALL DRAWA(X,Y)
              IF( J .EQ. 5                  ) CALL DASHA(X,Y,45)
 210        JPL  = JPL + 3
 201      CONTINUE
C
C                       DRAW TRACK NUMBER IF CDTL 38 IS ON
C                       TYPE 5 MUONS ARE UNDERLINED
C                       TYPE 9 MUONS ARE OVERLINED
C
      IF( DSPDTM(8) ) CALL DNUM(ITRK,X+SIGN(80.,X),Y+SIGN(80.,Y),80.,0.)
      IF( .NOT. DSPDTM(8) ) GO TO 200
      IF( (MUFLAG .NE. 5) .AND. (MUFLAG .NE. 9) )   GO TO 200
      IF( MUFLAG .EQ. 5) TYPSIZ = -20.0
      IF( MUFLAG .EQ. 9) TYPSIZ = 100.0
C
      CALL MOVEA(X+SIGN(80.,X),Y+SIGN(80.,Y)+TYPSIZ)
C
C                        FOR ITRK > 9 UNDERLINING IS TWICE AS LONG
C
      IF( ITRK .GT. 9 ) GO TO 112
      CALL DRAWA(X+SIGN(80.,X)+50.,Y+SIGN(80.,Y)+TYPSIZ)
      GO TO 200
 112  CALL DRAWA(X+SIGN(80.,X)+120.,Y+SIGN(80.,Y)+TYPSIZ)
C
 200  CONTINUE
C
C                       NOW FOR MULTIPLE SCATTERING ELLIPSES
C
      NELIPS = IDATA(IMUR25)
      IF( NELIPS .EQ. 0 ) RETURN
C
C                       CONVERT TO 'INTEGER*2 POINTER'
C
      IMR252 = 2*IMUR25
      I2     = 0
C
      DO  300  I = 1,NELIPS,7
        IOR  = HDATA(IMR252+I2+8)
C
C                       FIND THE 7 TH HALF  WORD  (TRACK  NUMBER)  FOR
C                       THIS ELLIPSE
C
        ITRK = HDATA(IMR252+(I-1)*2+7)
C
C                       DETERMINE IF THIS TRACK  WAS  DRAWN.  IF  NOT,
C                       FORGET ELLIPSES
C
        IF(INDEX.GT.0 .AND. ITRK.NE.INDEX .AND. INDEX.LT.100) GO TO 399
        IPMU   = NWMUR*(ITRK-1)
        MUQUAL = IDATA(IMUR21+IPMU+6)
        MUFLAG = HDATA(IMUR21*2+IPMU*2+53)
        GOODMU = MUQUAL.GT.0 .AND. MUQUAL.LT.100
C
        NODRAW = M100 .AND. .NOT.( GOODMU )
     +           .OR.            ( M200   .AND. MUQUAL .LT. 100 )
     +           .OR.            ( M300   .AND. MUQUAL .NE. 0   )
     +           .OR.            ( M1000  .AND. MUFLAG .LE. 0   )
     +           .OR.            ( M5000  .AND. MUFLAG .LE. 4   )
     +           .OR.            ( M9000  .AND. MUFLAG .LE. 8   )
C
C                  GET TRACK INFORMATION : NLOYWH=NO. OF LAYERS OUTSIDE
C                                            YOKE WITH ASSOCIATED HITS
C
          INFO   = IDATA(IMUR21 + 4 +IPMU)
          NLOYWH = MOD(INFO,10000) / 200
          IF(NLOYWH.EQ.0 .AND. M300 .OR. NODRAW) GO TO 399
C
C                       IF CDTL 24 SET, THEN DRAW ELLIPSES
C
        IF(DSPDTL(24))GO TO 301
C
C-----------------------------------------------------------------------
C            IF NOT DRAW ELLIPSE PROJECTIONS ONLY
C IF LASTVW=3    (XY) DRAW ONLY  ON CHAMBERS WHOSE IOR=1 OR 2
C      "    6,7  (XZ)   "   "     "    "       "    "  1 OR 3
C      "    10,11(YZ)   "   "     "    "       "    "  2 OR 3
C-----------------------------------------------------------------------
C
        IF( XYVIEW  .AND.  IOR .NE. 3 ) GO TO 301
        IF( ZXVIEW  .AND.  IOR .NE. 2 ) GO TO 301
        IF( ZYVIEW  .AND.  IOR .NE. 1 ) GO TO 301
        GO TO 399
C
 301    XC  = ADATA(IMUR25+I  )
        YC  = ADATA(IMUR25+I+1)
        ZC  = ADATA(IMUR25+I+2)
        VT  = ADATA(IMUR25+I+4)
        VL  = ADATA(IMUR25+I+5)
        CTL = ADATA(IMUR25+I+6)
        IF( ABS(VT-VL) .LT. 1E-6 ) GO TO 305
          PHI = 0.5 * ATAN( 2 * CTL / (VT - VL) )
          GO TO 306
 305    PHI    = 3.14159/4.
 306    COSPHI = COS(PHI)
        SINPHI = SIN(PHI)
        V1     = VT*COSPHI**2 + VL*SINPHI**2 + 2*CTL*SINPHI*COSPHI
        V2     = VT*SINPHI**2 + VL*COSPHI**2 - 2*CTL*SINPHI*COSPHI
        SD1    = SQRT(V1)
        SD2    = SQRT(V2)
C
        DO  307  J = 1,37
          T  = 3.14159*J/18.
          C1 = SD1*COS(T)
          C2 = SD2*SIN(T)
          CT = C1*COSPHI - C2*SINPHI
          CL = C1*SINPHI + C2*COSPHI
          IF( IOR .EQ. 3 ) GO TO 303
            ZCOR = ZC + CL
            IF( IOR .EQ. 2 ) GO TO 302
              XCOR = XC
              YCOR = YC + CT
              GO TO 308
 302        XCOR = XC + CT
            YCOR = YC
            GO TO 308
 303      XCOR = XC + CT
          YCOR = YC + CL
          ZCOR = ZC
 308      CALL XYMUD(XCOR,YCOR,ZCOR,X,Y)
          IF( J .EQ. 1 ) CALL MOVEA(X,Y)
          IF( J .NE. 1 ) CALL DRAWA(X,Y)
 307    CONTINUE
C
 399  I2 = I2 + 14
C
 300  CONTINUE
C-----------------------------------------------------------------------
      IF( INDEX .GE. 0  .OR.  FL18 ) RETURN
        CALL TRMOUT(80,'YOU MAY HAVE TO REDRAW^')
      RETURN
      END

C   07/06/96 606071803  MEMBER NAME  BCHL     (S4)          FORTG1
      SUBROUTINE BCHL(NW,*)
C     BOS SUBPROGRAM =1.19=
#include "acs.for"
      COMMON/BCS/IW(1)
      CALL BCHM(LIND,NW,IER)
      GOTO 100
C
      ENTRY BMVE(NW,*)
      CALL BCHM(NW,0,IER)
      LIND=NW
C
  100 IF(IER.EQ.2) GOTO 101
      RETURN
  101 RETURN 1
      END

C   26/03/80 003261950  MEMBER NAME  VTM      (JADEGS)      FORTRAN
       SUBROUTINE VTM(V,A,N,MS)
C
C        CHANGE FROM VECTOR TO ARRAY STORAGE
C
       DIMENSION V(1),A(N,N)
       DO 5 I=1,N
       DO 5 J=1,N
       CALL LOC(I,J,K,N,N,MS)
       A(J,I)=V(K)
    5 CONTINUE
       RETURN
       END

      SUBROUTINE FZFITV(IPPATR,IPJHTL,NTRVTX,Z0,ERRFAC,MODEF)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(HPZR0 ,HPWRK(20)),(HPZR9 ,HPWRK(21)),(HLDZR ,HPWRK(22))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
      NTRVTX = 0
      MODE   = MODEF
      IPTR1 = IDATA(IPPATR+1) + IPPATR
      LDTR  = IDATA(IPPATR+3)
      NTR   = IDATA(IPPATR+2)
      IF(
     - NTR.GT.0
     -)THEN
        IF(LAND(MODE,2).NE.0) CALL ZRFITO(-1,2001)
      DO 13000 ITR=1,NTR
          ITYPE =-IDATA(IPTR1+4)
      IF(
     - ITYPE .GT. 0
     -)THEN
            CALL FRFITV(IPTR1,IPJHTL,ERRFAC)
            IP    = HPTR0 - 1
            SIG   =  WRK(IP+23)
      IF(
     - LAND(IWRK(IP+ 2),32).EQ.0
     -)THEN
              SIG   = 1000.
              SIG0  =    0.
      ELSE
              SIG   =  WRK(IP+23)
              SIG0  = ADATA(IPTR1+23)
              ANHT  = IWRK(IP+24)
              IF(LAND(IWRK(IP+ 4),16).NE.0) ANHT = ANHT * 1.5
              ANHT0 = IDATA(IPTR1+24)
              IF(ANHT/ANHT0.LT..8) SIG = SIG + .5
      ENDIF
      IF(
     - SIG0.GT.SIG .OR. SIG.LT..35
     -)THEN
              NTRVTX = NTRVTX + 1
              CALL MVC(IDATA(IPTR1+1),0,IWRK(HPTR0),0,112)
              IDATA(IPTR1+4) = LOR(IDATA(IPTR1+4),ITYPE)
              INDZR = 0
      IF(
     - LAND(MODE,2) .NE. 0
     -)THEN
                 ADATA(IPTR1+17) = WRK(HPTR0+30)
                 CALL ZRFITO(INDZR,IPTR1)
      ENDIF
      IF(
     - LAND(MODE,2) .EQ. 0 .OR. INDZR.NE.0
     -)THEN
                 TGTH = ADATA(IPTR1+30)
                 Z0TR = ADATA(IPTR1+31)
                 CSTH = 1./SQRT(TGTH**2+1.)
                 SNTH = CSTH * TGTH
                 ADATA(IPTR1+ 8) = ADATA(IPTR1+ 8) * CSTH
                 ADATA(IPTR1+ 9) = ADATA(IPTR1+ 9) * CSTH
                 ADATA(IPTR1+15) = ADATA(IPTR1+15) * CSTH
                 ADATA(IPTR1+16) = ADATA(IPTR1+16) * CSTH
                 ADATA(IPTR1+17) = SNTH
                 ADATA(IPTR1+ 7) = ADATA(IPTR1+ 7) * TGTH + Z0TR
                 ADATA(IPTR1+14) = ADATA(IPTR1+14) * TGTH + Z0TR
      ENDIF
      ELSE
              IDATA(IPTR1+4) = 0
      ENDIF
      ENDIF
        IPTR1 = IPTR1 + LDTR
13000 CONTINUE
13001 CONTINUE
      IF(
     - NTRVTX.GT.0
     -)THEN
          INDZR = 1
          IF(LAND(MODE,2).NE.0) CALL ZRFITO(INDZR,Z0)
      ENDIF
      ENDIF
      RETURN
      END

C   02/06/80 104011142  MEMBER NAME  MUR2DS   (JADEGS)      FORTRAN
      SUBROUTINE MUR2DS
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
      CALL RSDISP(LASTVW)
      IF(LASTVW.EQ.13) CALL YAMADA(0)
      IF(DSPDTL(17).AND.(LASTVW.LT.4.OR.LASTVW.EQ.14))
     $ CALL PROJEC(LASTVW)
      RETURN
      END

      SUBROUTINE BSTORE
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      IF(HNREL(NTR).EQ.9) RETURN
      HNREL(NTR) = HNREL(NTR) + 1
      KR = HNREL(NTR)
      HISTR(KR,NTR) = IKX*LR
      HUSE(IKX) = 1
      RETURN
      END
      FUNCTION SLCOR(SL,LRS)
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
      IF(LRS.EQ.-1)SLCOR=DRICOS*SL/(1.+SL*DRISIN)
      IF(LRS.EQ.1) SLCOR=DRICOS*SL/(1.-SL*DRISIN)
      RETURN
      END
      SUBROUTINE CHOOSE
      IMPLICIT INTEGER*2 (H)
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
      ICHOOS=1
      IT=IRL-1
15000 CONTINUE
      IF(
     - ICHOOS.EQ.1
     -)THEN
      DO 13000 I=1,IT
      ITMP=I+1
      DO 13002 J=ITMP,IRL
      IF(
     - DTEMP(I).GT.DTEMP(J)
     -)THEN
      TEMP=DTEMP(I)
      DTEMP(I)=DTEMP(J)
      DTEMP(J)=TEMP
      DO 13004 JK=1,4
      TEMP=ITK(I,JK)
      ITK(I,JK)=ITK(J,JK)
      ITK(J,JK)=TEMP
13004 CONTINUE
13005 CONTINUE
      ENDIF
13002 CONTINUE
13003 CONTINUE
13000 CONTINUE
13001 CONTINUE
      IP=ITK(1,4)
      IC=ITK(1,1)
      IF(
     - DTEMP(1).NE.100.
     -)THEN
      IF(
     - IP.NE.K
     -)THEN
      DO 13006 J=1,IRL
      IF(
     - DTEMP(J).NE.100.
     -)THEN
      IF(ITK(J,4).EQ.IP.OR.ITK(J,1).EQ.IC) DTEMP(J)=100.
      ENDIF
13006 CONTINUE
13007 CONTINUE
      ELSE
      GOTO 15001
      ENDIF
      ELSE
      GOTO 15001
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      IF(
     - DTEMP(1).NE.100.
     -)THEN
      ITWO=2
      ITHREE=ITWO+1
      ELSE
      IRIFLG=0
      ENDIF
      RETURN
      END
      SUBROUTINE INTJN1(KK,KX,INTFLG,DTMP)
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
      DIMENSION HTEMP(9)
      DATA MSKCR1 /Z100/,MSKFIT/Z20000/,MSKAIT/ZFFFDFFFF/
      MAMB=0
      IF(NRHT(KK).GE.IBKK(19).AND.NRHT(KX).GE.IBKK(19)
     * .AND.IBKK(20).NE.0) MAMB=1
      INTFLG=0
      IWX=ITRKAR(KX,6)
      IOL=IBKK(1)-1
      IGAP=IBKK(2)+1
      IF(
     - IWX.LE.IW+IOL.AND.IWX.GE.IW-IGAP
     -)THEN
      ICROSS=1
      SLA=SL1(KK)/RINCR(KRING)
      SLB=SL2(KX)/RINCR(KRING)
      JT=IKX
      IKX=KX
      CALL LFRT(LRA)
      IKX=KK
      CALL LFRT(LR2)
      IKX=JT
      IF(IUDFLG.EQ.3.AND.LR.NE.0.AND.LRA.EQ.0) LRA=LR
      IF(IUDFLG.EQ.6.AND.LR.NE.0.AND.LR2.EQ.0) LR2=LR
      IDIW=IW-IWX
      IF(IDIW.LT.0) IDIW=0
      IF(
     - MAMB.NE.0.AND.LAND(MSKCR1,LBL(KK)).EQ.0.AND.
     ¢ LAND(MSKCR1,LBL(KX)).EQ.0
     -)THEN
      IF(LRA.NE.LR2) ICROSS=-1
      IF(LRA.EQ.0.OR.LR2.EQ.0) ICROSS=0
      ENDIF
      DSEX=TRKAR(KK,4)-SL1(KK)*IDIW
      DX=DSEX-TRKAR(KX,7)
      IF(
     - MAMB.EQ.0.OR.ICROSS.EQ.0
     -)THEN
      IF(SL2(KX).LT.0..AND.SL1(KK).GT.0..AND.LAND(LBL(KK),MSKCR1).EQ.0
     * .AND.LAND(LBL(KX),MSKCR1).EQ.0.AND.(DS1(KK).LT.BKK(5)
     ¢ .OR.DS2(KX).LT.BKK(5))) ICROSS=-1
      ENDIF
      IF(
     - ICROSS.EQ.-1
     -)THEN
      SLA=-SLA
      DX=TRKAR(KX,7)+DSEX
      ENDIF
      IF(
     - LAND(LBL(KK),MSKCR1).NE.0.AND.LAND(LBL(KX),MSKCR1).NE.0
     -)THEN
      DX=TRKAR(KX,7)+DSEX
      SLA=-SLA
      IF(MAMB.NE.0.AND.LRA*LR2.LT.0) DX=1000000.
      ENDIF
      IF(ICROSS.EQ.0) ICROSS=1
      IF(LAND(MSKCR1,LBL(KK)).EQ.0.AND.LAND(MSKCR1,LBL(KX)).NE.0
     * .AND.LRA*LR2.GT.0.AND.MAMB.NE.0) DX=10000000.
      IF(LAND(MSKCR1,LBL(KX)).EQ.0.AND.LAND(MSKCR1,LBL(KK)).NE.0
     * .AND.LRA*LR2.LT.0.AND.MAMB.NE.0) DX=10000000.
      IF(
     - ABS(DX).LT.DCELL
     -)THEN
      SLOLIM=(ABS(SLA)+ABS(SLB))/2.*BKK(14)+BKK(15)
      DTMP=ABS(SLA-SLB)
      IF(
     - DTMP.LT.SLOLIM
     -)THEN
      IB=0
      IF(
     - IBKK(16).NE.0.AND.IBFIT.EQ.0
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      IF(
     - IB.EQ.0
     -)THEN
      INTFLG=ICROSS
      DTMP=ABS(DTMP*DX)
      ENDIF
      ENDIF
      KMP1=HISTR(1,NTR)
      KMP1=IABS(KMP1)
      KMP1=IPCL(KMP1)
      IF(KMP1.EQ.IPCL(KX).AND.IBKK(20).NE.0.AND.MAMB.EQ.0) IJFLG=1
      ENDIF
      ENDIF
      RETURN
17000 CONTINUE
      IB=0
      IF(
     - HNREL(NTR).LT.9
     -)THEN
      CALL MVC2(HTEMP(1),0,HISTR(1,NTR),0,18) !PMF 28/06/99 MVC -> MVC2
      IKST=IPST
      IKFLG=IJFLG
      IBJ=IKX
      IKX=KX
      LR3=1
      IF(ICROSS.EQ.-1.OR.(LAND(LBL(KX),MSKCR1).NE.0.AND.
     * LAND(LBL(KK),MSKCR1).EQ.0)) LR3=-1
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      HNREL(NTR)=HNREL(NTR)+1
      LRC=LR2
      HISTR(HNREL(NTR),NTR)=LRC*KX
      CALL BAKFIT(IB,1)
      IAB=HNREL(NTR)
      HNREL(NTR)=HNREL(NTR)-1
      CALL MVC2(HISTR(1,NTR),0,HTEMP(1),0,18) !PMF 28/06/99 MVC -> MVC2
      IKX=IBJ
      IJFLG=IKFLG
      IPST=IKST
      ENDIF
      GOTO IZZZ01
17002 CONTINUE
      CALL LFRT(LR2)
      IF(
     - LR2.EQ.0
     -)THEN
      IF(
     - LR.NE.0
     -)THEN
      LR2=LR*LR3
      ELSE
      LR2=LR3
      IJFLG=1
      IPST=1
      ENDIF
      ELSE
      IF(
     - LR.EQ.0
     -)THEN
      IF(LR2*LR3.EQ.-1) HISTR(1,NTR)=-HISTR(1,NTR)
      ELSE
      IF(
     - LR2.NE.LR*LR3
     -)THEN
      LR2=-LR2
      ENDIF
      ENDIF
      ENDIF
      GOTO IZZZ02
      END
      SUBROUTINE COREC
      IMPLICIT INTEGER*2 (H)
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
      ITMP=HNREL(NTR)
      DO 13000 I=1,ITMP
      HISTR(I,NTR)=-HISTR(I,NTR)
13000 CONTINUE
13001 CONTINUE
      IJFLG=0
      RETURN
      END
      SUBROUTINE SIDE1
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C----------------------------------------------------------------------
C           MACRO CDSMAX .... PATTERN RECOGNITION CONSTANTS.
C----------------------------------------------------------------------
      COMMON/CDSMAX/DSMAX(16,3,2),DIRWR1(24,2),DIRWR3(48,2)
     *             ,DHALF(16,3,2),DTWICE(16,3,2),HMCH(16,3,2)
     *             ,IBCK(9),DBCK(30),TRMATS(96,2),TRMATC(96,2)
C------------------------ END OF MACRO CDSMAX -------------------------
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
      DIMENSION LSTCL(3),LFTCL(3),NCELL(3),TANDEL(3)
      EQUIVALENCE (IBCK(1),LSTCL(1)),(IBCK(4),LFTCL(1))
      EQUIVALENCE (IBCK(7),NCELL(1)),(DBCK(1),TANDEL(1))
      DIMENSION HTEMP(9)
      DATA MSKCR1 /Z100/,MSKFIT/Z20000/,MSKAIT/ZFFFDFFFF/
      IIWW=IW+1
      IF(IIWW.GT.16) IIWW=16
      IF(IIWW.LT.1) IIWW=1
      BSL=A
      IF(IUDFLG.EQ.6) BSL=-BSL
      DRIFT=DS+.5*BSL
      IRT=LR1
      IM1=6
      IM2=3
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      IWEX=HMCH(IIWW,KRING,LR1)+1
      IF(IWEX.GT.16) IWEX=16
      IF(IWEX.LT.1) IWEX=1
      IF(
     - DTMP.LT.2.*CLIM.OR.DTMP.LT.2.
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - IKX.GT.0
     -)THEN
      IF(
     - LRCORN.EQ.0
     -)THEN
      ICX=ICT
      IRIFLG=1
      KT=IKX
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      RETURN
17002 CONTINUE
      IKX=0
      ICNFLG=0
      IF(LRCORN.EQ.0) IRL=0
      NTRLX1 = HNTCEL(ICT)
      NTRLX2 = HNTCEL(ICT+1)-1
      DO 13000 KX = NTRLX1,NTRLX2
      IF(
     - HUSE(KX).EQ.0
     -)THEN
      IPER=0
      IF(
     - IBKK(20).NE.0.AND.NRHT(KX).GE.IBKK(19)
     -)THEN
      JT=IKX
      IKX=KX
      CALL LFRT(LK)
      IKX=JT
      IF(LAND(MSKCR1,LBL(KX)).NE.0.AND.IUDFLG.EQ.6) LK=-LK
      IF(LK.NE.3-2*LR1) IPER=1
      IF(LK.EQ.0) IPER=0
      ENDIF
      IF(
     - IPER.EQ.0
     -)THEN
      IIWW= ITRKAR(KX,IUDFLG)+1
      IF(IIWW.GT.16) IIWW=16
      IF(IIWW.LT.1) IIWW=1
      BSL=TRKAR(KX,IUDFLG+2)
      IF(IUDFLG.EQ.3) BSL=-BSL
      DRIFT=TRKAR(KX,IUDFLG+1)+.5*BSL
      IRT=3-LR1
      IM1=3
      IM2=6
      ASSIGN 17004 TO IZZZ01
      GOTO 17000
17004 CONTINUE
      IWX=IIWW
      IF(
     - DTMP.LT.2.*CLIM.OR.DTMP.LT.2.
     -)THEN
      IF(
     - IABS(IWX-IWEX).LE.IBKK(6)-1
     -)THEN
      LRS=2*LR1-3
      SLB=A/RINCR(KRING)
      SL=SLCOR(SLB,LRS)
      T=TANDEL(KRING)
      SLEX=(T-SL)/(1.+SL*T)
      LRS=-LRS
      SLE=TRKAR(KX,IUDFLG+2)/RINCR(KRING)
      SLC=SLCOR(SLE,LRS)
      SLOLIM=(ABS(SLE)+ABS(SLB))/2.*BKK(12)+BKK(13)
      DTMP=SLEX-SLC
      IF(
     - ABS(DTMP).LT.SLOLIM
     -)THEN
      IF(
     - LRCORN.NE.0
     -)THEN
      IKX=KX
      GOTO 13001
      ENDIF
      IB=0
      IF(
     - IBKK(17).NE.0.AND.IBFIT.EQ.0
     -)THEN
      ASSIGN 17006 TO IZZZ03
      GOTO 17005
17006 CONTINUE
      ENDIF
      IF(
     - IB.EQ.0
     -)THEN
      IRL=IRL+1
      DTEMP(IRL)=ABS(DTMP)
      ITK(IRL,1)=KX
      ITK(IRL,4)=KT
      ICNFLG=1
      ELSE
      ICNFLG=0
      ENDIF
      ELSE
      ICNFLG=0
      ENDIF
      IF(IRL.GT.0.AND.LRCORN.EQ.0) ICNFLG=1
      ENDIF
      ENDIF
      ELSE
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      IF(
     - ICNFLG.EQ.1
     -)THEN
      IF(
     - IRL.GT.1
     -)THEN
      CALL CHOOSE
      ENDIF
      IKX=ITK(1,1)
      ENDIF
      GOTO IZZZ02
17000 CONTINUE
      CLIM=.5*BSL
      DXNEW=DSMAX(IIWW,KRING,IRT)-DRIFT
      DXOLD=9999.
15000 CONTINUE
      IF(
     - DXNEW.GT.CLIM
     -)THEN
      IF(
     - IIWW.EQ.16.OR.IIWW.EQ.1
     -)THEN
      GOTO 15001
      ENDIF
      DRIFT=DRIFT+BSL
      IF(IUDFLG.EQ.IM1) IIWW=IIWW-1
      IF(IUDFLG.EQ.IM2) IIWW=IIWW+1
      DSMX=DSMAX(IIWW,KRING,IRT)
      DXNEW=DSMX-DRIFT
      IF(
     - ABS(DXNEW).GT.ABS(DXOLD)
     -)THEN
      DTMP=100.
      GOTO 15001
      ENDIF
      IF(
     - DXNEW.LT.1.
     -)THEN
      GOTO 15001
      ELSE
      DXOLD=DXNEW
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      DTMP=DXNEW
      GOTO IZZZ01
17005 CONTINUE
      IB=0
      IF(
     - HNREL(NTR).LT.9
     -)THEN
      IKFLG=IJFLG
      CALL MVC2(HTEMP(1),0,HISTR(1,NTR),0,18)  !PMF 28/06/99 MVC -> MVC2
      IF(LR.EQ.-1.AND.LR1.EQ.2.OR.LR.EQ.1.AND.LR1.EQ.1) CALL COREC
      IF(LR.EQ.0.AND.LR1.EQ.1) HISTR(1,NTR)=-HISTR(1,NTR)
      HNREL(NTR)=HNREL(NTR)+1
      IF(LR1.EQ.2) LRC=-1
      IF(LR1.EQ.1) LRC=1
      IF(LAND(LBL(KX),MSKCR1).NE.0.AND.IUDFLG.EQ.6) LRC=-LRC
      IKRA=HISTR(1,NTR)
      IKRA=IABS(IKRA)
      IF(IKRA.EQ.KT.AND.IUDFLG.EQ.3.AND.LAND(MSKCR1,LBL(KT)).NE.0)
     * CALL COREC
      HISTR(HNREL(NTR),NTR)=KX*LRC
      IAB=HNREL(NTR)
      CALL BAKFIT(IB,3)
      HNREL(NTR)=HNREL(NTR)-1
      CALL MVC2(HISTR(1,NTR),0,HTEMP(1),0,18) !PMF 28/06/99 MVC -> MVC2
      IJFLG=IKFLG
      ENDIF
      GOTO IZZZ03
      END
      SUBROUTINE LFRT(LR2)
      IMPLICIT INTEGER*2 (H)
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      DATA MSKLFT,MSKRT/Z400,Z800/
      LR2=0
      IPST=0
      I1=LAND(LBL(IKX),MSKLFT)
      I2=LAND(LBL(IKX),MSKRT)
      IF(I1.NE.0) LR2=-1
      IF(I2.NE.0) LR2=1
      IF(I1*I2.NE.0) LR2=0
      IF(LR2.NE.0) IPST=1
      RETURN
      END

C   05/05/79 109062131  MEMBER NAME  REALNM   (JADEGS)      FORTRAN
      SUBROUTINE REALNM(RNUM1,RNUM2,RNUM3,RNUM4)
C--
C-- READ REAL NUMBERS FROM SCREEN
C--
C--                                   LATEST CHANGE 06.09.81, (J.OLSSON)
C--
      IMPLICIT INTEGER*2 (H)
      DIMENSION HNUMB(10),HWORD(2)
      COMMON/CWORK1/HWORK(40),HINN(80)
      EQUIVALENCE(HWORD(1),IWORD)
      DATA HBLANK/'  '/,HPOINT/' .'/,HMINUS/' -'/
      DATA HNUMB/' 0',' 1',' 2',' 3',' 4',' 5',' 6',' 7',' 8',' 9'/
      DATA IHIGH/ZFF000000/,HHIGH/ZFF00/,HLOW/Z00FF/,ICALL/0/
C---
      RNUM1 = 0.
      RNUM2 = 0.
      RNUM3 = 0.
      RNUM4 = 0.
      IF(ICALL.NE.0) GO TO 1
C---
C---     ON FIRST CALL ZERO THE HIGH ORDER BYTES OF CHARACTER CONSTANTS.
C---     THE LOW ORDER BYTES CONTAIN THE CHARACTERS. MOVE THE INDIVIDUAL
C---     NON-BLANK CHARACTERS OF THE COMMAND CODES INTO THE LOW ORDER
C---     BYTES OF INTEGER*2 ARRAY VARIABLES AND ZERO THE HIGH ORDER BYTE
C---     THIS IS DONE SO THAT INDIVIDUAL CHARACTERS MAY BE ADDRESSED
C---     WITHOUT USING LOGICAL*1 (NOT AVAILABLE ON THE NORD) OR CHARACTE
C---     VARIABLES (NOT AVAILABLE ON THE IBM).
C---
      HBLANK=IAND2(HBLANK,HLOW)
      HPOINT=IAND2(HPOINT,HLOW)
      HMINUS=IAND2(HMINUS,HLOW)
      DO 2 I=1,10
      HNUMB(I)=IAND2(HNUMB(I),HLOW)
    2 CONTINUE
      ICALL=1
    1 CONTINUE
C---
 15   CALL TRMIN(80,HWORK)
      HWORD(1)=0
      DO 5 I=1,70
C---
C---     PACK BYTES INTO THE LOW ORDER BYTES OF INTEGER*2 VARIABLES
C---     IN SAME WAY AS WAS DONE FOR THE COMMAND CODES.
C---
      HWORD(2)=IAND2(HHIGH,HWORK(I))
      IWORD=SHFTR(IWORD,8)
      HINN(2*I-1)=HWORD(2)
      HINN(2*I)=IAND2(HLOW,HWORK(I))
    5 CONTINUE
C---
C---     FIND BEGINNING AND END OF THE TWO NUMBERS
C---
      IFIRST=0
      ISECND=0
      ITHIRD=0
      IFOURT=0
      ILS1=0
      ILS2=0
      ILS3=0
      ILS4=0
      DO 6 I=1,80
      IF(HINN(I).EQ.HBLANK.AND.IFIRST.NE.0.AND.ILS1.EQ.0) ILS1=I-1
      IF(HINN(I).EQ.HBLANK.AND.ISECND.NE.0.AND.ILS2.EQ.0) ILS2=I-1
      IF(HINN(I).EQ.HBLANK.AND.ITHIRD.NE.0.AND.ILS3.EQ.0) ILS3=I-1
      IF(HINN(I).EQ.HBLANK.AND.IFOURT.NE.0.AND.ILS4.EQ.0) ILS4=I-1
      IF(HINN(I).EQ.HBLANK) GO TO 6
      IF(IFIRST.EQ.0) IFIRST=I
      IF(ILS1.NE.0.AND.ISECND.EQ.0) ISECND=I
      IF(ILS2.NE.0.AND.ITHIRD.EQ.0) ITHIRD=I
      IF(ILS3.NE.0.AND.IFOURT.EQ.0) IFOURT=I
    6 CONTINUE
      IF(IFIRST.EQ.0) GO TO 111
      IF(ILS1.EQ.0) GO TO 111
C---
C---     FIRST NUMBER, DECODE IT
C---
      NDIG=0
      NBP=-1
      N=0
      SIGN=1.
      DO 12 I=IFIRST,ILS1
      IF(HINN(I).EQ.HMINUS) SIGN=-1.
      IF(HINN(I).EQ.HMINUS) GO TO 12
      IF(HINN(I).EQ.HPOINT) NBP=0
      IF(HINN(I).EQ.HPOINT) GO TO 12
      IDIG=10
      DO 13 J=1,10
      IF(HINN(I).NE.HNUMB(J)) GO TO 13
      IDIG=J-1
   13 CONTINUE
      IF(IDIG.EQ.10) GO TO 14
      N=10*N+IDIG
      NDIG=NDIG+1
      IF(NBP.GE.0) NBP=NBP+1
   12 CONTINUE
      IF(NBP.EQ.-1) NBP=0
      A=SIGN*N/(10.**NBP)
      RNUM1 = A
      IF(ISECND.EQ.0) GO TO 111
      IF(ILS2.EQ.0) GO TO 111
C---
C---     THERE IS A SECOND NUMBER. DECODE IT.
C---
      NDIG=0
      NBP=-1
      N=0
      SIGN=1.
      DO 19 I=ISECND,ILS2
      IF(HINN(I).EQ.HMINUS) SIGN=-1.
      IF(HINN(I).EQ.HMINUS) GO TO 19
      IF(HINN(I).EQ.HPOINT) NBP=0
      IF(HINN(I).EQ.HPOINT) GO TO 19
      IDIG=10
      DO 18 J=1,10
      IF(HINN(I).NE.HNUMB(J)) GO TO 18
      IDIG=J-1
   18 CONTINUE
      IF(IDIG.EQ.10) GO TO 14
      N=10*N+IDIG
      NDIG=NDIG+1
      IF(NBP.GE.0) NBP=NBP+1
   19 CONTINUE
      IF(NBP.EQ.-1) NBP=0
      A=SIGN*N/(10.**NBP)
      RNUM2 = A
      IF(ITHIRD.EQ.0) GO TO 111
      IF(ILS3.EQ.0) GO TO 111
C---
C---     THERE IS A THIRD NUMBER. DECODE IT.
C---
      NDIG=0
      NBP=-1
      N=0
      SIGN=1.
      DO 79 I=ITHIRD,ILS3
      IF(HINN(I).EQ.HMINUS) SIGN=-1.
      IF(HINN(I).EQ.HMINUS) GO TO 79
      IF(HINN(I).EQ.HPOINT) NBP=0
      IF(HINN(I).EQ.HPOINT) GO TO 79
      IDIG=10
      DO 78 J=1,10
      IF(HINN(I).NE.HNUMB(J)) GO TO 78
      IDIG=J-1
   78 CONTINUE
      IF(IDIG.EQ.10) GO TO 14
      N=10*N+IDIG
      NDIG=NDIG+1
      IF(NBP.GE.0) NBP=NBP+1
   79 CONTINUE
      IF(NBP.EQ.-1) NBP=0
      A=SIGN*N/(10.**NBP)
      RNUM3 = A
      IF(IFOURT.EQ.0) GO TO 111
      IF(ILS4.EQ.0) GO TO 111
C---
C---     THERE IS A FOURTH NUMBER. DECODE IT.
C---
      NDIG=0
      NBP=-1
      N=0
      SIGN=1.
      DO 89 I=IFOURT,ILS4
      IF(HINN(I).EQ.HMINUS) SIGN=-1.
      IF(HINN(I).EQ.HMINUS) GO TO 89
      IF(HINN(I).EQ.HPOINT) NBP=0
      IF(HINN(I).EQ.HPOINT) GO TO 89
      IDIG=10
      DO 88 J=1,10
      IF(HINN(I).NE.HNUMB(J)) GO TO 88
      IDIG=J-1
   88 CONTINUE
      IF(IDIG.EQ.10) GO TO 14
      N=10*N+IDIG
      NDIG=NDIG+1
      IF(NBP.GE.0) NBP=NBP+1
   89 CONTINUE
      IF(NBP.EQ.-1) NBP=0
      A=SIGN*N/(10.**NBP)
      RNUM4 = A
      GO TO 111
   14 CONTINUE
      CALL TRMOUT(80,'ILLEGAL CHARACTER ENTERED, TRY AGAIN ^')
      GO TO 15
111   RETURN
      END

      FUNCTION SAGCIR(FPP,CP,G,SP,EPS)
      FP=FPP*CP
      U=-(G*FP)*FP
      S=-.5*G*FPP
      IF(
     - ABS(U).GT..3
     -)THEN
      IF(
     - U.LT..98
     -)THEN
            SAGCIR=(SQRT(1.-U)-1.)/FP
      ELSE
            SAGCIR=0.
            PRINT 100,FPP,CP,G
100         FORMAT(1X,' SAGCIR',3E16.7)
      ENDIF
         SP=SAGCIR/CP
         RETURN
      ENDIF
      VAL=-S*(1.+.25*U+.125*U**2)
      Q=S*U**3/12.8
      N=5
15000 CONTINUE
      IF(
     - ABS(Q).GT.EPS .AND.N.LT.15
     -)THEN
         VAL=VAL-Q
         Q=Q*U*(1.-1.5/N)
         N=N+1
      GOTO 15000
      ENDIF
15001 CONTINUE
      SP=VAL
      SAGCIR=SP*CP
      RETURN
      END

C   19/02/84 402192331  MEMBER NAME  RDRDMH   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDRDMH( IRN, HITS )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    25/04/79 :  CREATE RANDOM HITS
C
C        MOD: E. ELSEN    29/09/83 :
C   LAST MOD: J. HAGEMANN 22/04/83 :  NO RANDOM HITS OUTSIDE CELLS
C             R. RAMCKE            :
C
C     CREATE IRN(I) RANDOM HITS FOR EVERY RING I AND STORE HITS
C     IN ARRAY HITS WITH INCREASING WIRE NUMBER.
C
C     RANDOM HITS OUTSIDE CELLS ARE NOW NOT POSSIBLE.
C     MAXIMUM DRIFTSPACE DRIMAX FOR EACH RING SET IN A DATA
C     STATEMENT.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
C
      COMMON / CBINMC / BINMC(6)
C
      DIMENSION HITS(2), IRN(3), IWOFF(3), WRANGE(3)
      DIMENSION HWBUF(8)
      DIMENSION DRIMAX(3)
C
      DATA WRANGE / 384., 384., 768. /
      DATA IWOFF / 0, 384, 768 /
      DATA DRIMAX / 47.5, 75.1, 51.2 /
C
C------------------  C O D E  ------------------------------------------
C
      IL = 1
      IH = 1
C
C                          LOOP OVER RINGS
      DO 2000 JR = 1, 3
      IHTOT = IRN(JR)
      IF( IHTOT .EQ. 0 ) GO TO 2000
C
C                          COMPUTE NEW HITS
      DO 100 J=1,IHTOT
C                          WIRE NUMBER
          IWIR = IFIX( WRANGE(JR)*RN(DUM) + .5 ) + IWOFF(JR)
      HITS(IH) = IWIR*8 + 1
C                          Z - AMPLITUDES
CCCC      XL = ( ZMAX*(1.-2.*RN(DUM)) - ZOFFS ) / ZAL
          XL = ( ZMAX*(1.-2.*RN(DUM))) / ZAL
          XA = ZNORM / ( .2 + .8*RN(DUM) )
      HITS(IH+1) = HFIX((  XL + .5 ) * XA)
      HITS(IH+2) = HFIX(( -XL + .5 ) * XA)
C                          DRIFT TIME
CCCCC HITS(IH+3) = 256.*RN(DUM) + .5
C----------------  N E W -----------------------------
      HITS(IH+3) = HFIX(256.*RN(DUM) + .5)
      IF(BINMC(JR) .GT. 0.)
     *         HITS(IH+3) = HFIX(DRIMAX(JR)*RN(DUM)/BINMC(JR) + .5)
C-----------------------------------------------------
  100 IH = IH + 4
C
C
CCC  ORDER HITS FOR THIS RING
      IW4 = IHTOT*4
      M = IHTOT
  200 M = M / 2
      IF( M .LE. 0 ) GO TO 500
      M4 = M*4
      K = IH - M4 - 4
      DO 400 J = IL, K, 4
             I = J
  300        IF( I .LT. IL ) GO TO 400
             IM = I + M4
          IF( HITS(I) .LT. HITS(IM) ) GO TO 400
          IF(HITS(I).EQ.HITS(IM) .AND. HITS(I+3).GE.HITS(IM+3)) GOTO 400
                  IM2 = ( IM - 1 ) * 2
                  I2 = ( I - 1 ) * 2
                  CALL MVC( HWBUF, 0, HITS, IM2, 8 )
                  CALL MVC( HITS, IM2, HITS, I2, 8 )
                  CALL MVC( HITS, I2, HWBUF, 0, 8 )
                  I = I - M4
                  GO TO 300
  400 CONTINUE
      GO TO 200
  500 CONTINUE
 2000 IL = IH
      RETURN
      END

      SUBROUTINE BAKFIT(IB,ITYP)
      IMPLICIT INTEGER*2 (H)
#include "cpatlm.for"
#include "cworkeq.for"
#include "cworkpr.for"
       DIMENSION CHITR(9),HITIN(10)
       EQUIVALENCE (ADWRK(91),CHITR(1)),(HITIN(1),ADWRK(86))
       IB=0
       IREM=IXYF(1)
       IXYF(1)=LOR(IXYF(1),9)
       HPOLD=HPFREE
       IBTRK=NTR
       CALL FXYZ(IBTRK)
       HPTR0=HPFREE
       HPTR9=HPTR0+49
       HLDTR=50
      HPFREE=HPTR9+1
      IF(
     - HPFREE.LE.HPLAST
     -)THEN
      CALL XYFIT
      RES=CHITR(HNREL(NTR))
      RMS=WRK(HPTR0+22)
      NTOT=IWRK(HPTR0+23)
      NHT=HITIN(HNREL(NTR))
      IF(NHT.GT.0) RES=RES/FLOAT(NHT)
      IF(ITYP.EQ.1.AND.(RMS.GT.YBKK(2).OR.RES.GT.YBKK(3))) IB=-1
      IF(ITYP.EQ.2.AND.(RMS.GT.YBKK(4).OR.RES.GT.YBKK(5))) IB=-1
      IF(ITYP.EQ.3.AND.(RMS.GT.YBKK(6).OR.RES.GT.YBKK(7))) IB=-1
      IF(ITYP.EQ.4.AND.RMS.GT.YBKK(8)) IB=-1
      ELSE
      PRINT 33
 33   FORMAT(' +++++++++  NOT ENOUGH SPACE IN CWORK  +++++++')
      ENDIF
      IXYF(1)=IREM
      HPFREE=HPOLD
      RETURN
      END

C   12/03/84 709172208  MEMBER NAME  TAGAN    (S)           FORTRAN
C
C
C
C------   T A G A N   ------   T A G A N   ------   T A G A N   ------
C
C------   T A G A N   ------   T A G A N   ------   T A G A N   ------
C
C------   T A G A N   ------   T A G A N   ------   T A G A N   ------
C
C
C
      SUBROUTINE TAGAN(IER,NRUN)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C TAGAN IS THE CONTROLLING ROUTINE FOR FORWARD DETECTOR ANALYSIS
C              ITS CHIEF PURPOSE IS TO DECIDE WHAT ROUTINE TO CALL
C              EITHER ANATAG OR TAGGTP
C
C     TAGGTP IS WRITTEN BY A.J.FINCH TO ANALYSE 1981 ONWARDS DATA
C     ANATAG IS WRITTEN BY H.WRIEDT  TO ANALYSE PRE 1981 DATA
C
C INPUT - NRUN -> THIS IS USED TO OVERIDE THE ATTEMPT BY
C                  TAGAN TO DECIDE WHAT SIMULATION HAS BEEN DONE
C                  WHEN MONTE CARLO DATA IS ANALYSED.
C
C                 IF NRUN = 0 TAGAN LOOKS AT THE FIRST WORD OF
C                  ATAG BANK DATA -
C                              - IF IT EQUALS ZERO THIS IS MARK 1
C                              - IF IT EQUALS ONE THIS IS MARK 2
C                              - IF IT EQUALS TWO THIS IS MARK 3
C
C                    (IN MCJADE THIS WORD IS SET IN STATAG/STAG81/..)
C
C OUTPUT - IER -> ERROR CODE:
C                     0 - ATAG EXISTS AND CLUSTERS WERE FOUND
C                     1 - ATAG EXISTS BUT CLUSTERS WERE NOT FOUND
C                     2 - ANALYSIS COMPLETED BUT NOT ENOUGH SPACE
C                         TO CREATE ONE OR MORE OUTPUT BANK
C                    10 - ATAG BANK NOT FOUND - NO ANALYSIS DONE
C                    11 - HEAD BANK NOT FOUND - NO ANALYSIS DONE
C
C 24/2/84 A.J.FINCH
C
C INSTALLED ON TAGG.S 12/3/84
C
C      MOD  J. NYE  24/05/84  CALLS TAGMRK
C      MOD  J. NYE  22/06/84  CHANGES MADE TO OUTPUT
C LAST MOD  J. NYE  13/09/84  CHANGES MADE TO OUTPUT
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
C
C FOLLOWING ARE ALL THE COMMONS USED BY TAGGTP ROUTINES
C
#include "comtag.for"
C
#include "cwktag.for"
C
#include "ctaggo.for"
C
       COMMON / CONTRL / JWRITE
       LOGICAL NFIRST
       DATA NFIRST  / .FALSE. /
       DATA NDEBUG  /      25 /
       DATA MARK0 / -1 /
C
C
C------------------------ C O D E --------------------------------------
C
C
C
C---                                    CHECK ATAG BANK EXISTS
C
C
CCC    JWRITE = 0
CCC    IF ( NDEBUG .GT. 0 ) JWRITE = 1
CCC    NDEBUG = NDEBUG - 1
       IWRITE = JWRITE
       IER = 0
       CALL BLOC(IND,'ATAG',0,&100)
       GOTO 200
  100  IER = 10
       RETURN
C
C
C---                                    CHECK HEAD BANK EXISTS
C
C
  200  IHEAD = IDATA(IBLN('HEAD'))
       IF ( IHEAD .GT. 0 ) GOTO 400
  300  IER = 11
       RETURN
  400  CONTINUE
C
C
C---                                    GET DATA FROM HEAD BANK
C
C
       IHHEAD = IHEAD + IHEAD
       NDATE  = HDATA(IHHEAD +  8)
       NEXP   = HDATA(IHHEAD +  9)
       NRUNTG = HDATA(IHHEAD + 10)
       NEVEN  = HDATA(IHHEAD + 11)
       NERGY  = HDATA(IHHEAD + 29)
       IF ( (NERGY .GT. 30000) .OR. (NERGY .LT. 5000) ) NERGY = 17500
       ERGY   = 0.001 * FLOAT( NERGY )
C
C
C---                                    DECIDE A) MC OR REAL DATA
C---                                           B) WHICH DETECTOR
C
C
C
C   CALL TAGMRK - RETURNS 1 IF NO HEAD BANK
C   SETS  IMC = 1 IF MC DATA
C   SETS MARK = 0,1,OR 2 FOR 79/80,81/82, AND 83
C                             DETECTORS
C
        CALL TAGMRK(&300)
C
C
C----------------------------------------MONTE CARLO DATA ONLY----------
C
C
C
C---                                    IF MC DATA AND NRUN GIVEN THEN
C---                                    FORCE MARK TO AGREE WITH NRUN
C
C
C
       IF ( (IMC .EQ. 0) .OR. (NRUN .EQ. 0) ) GOTO 5
C
       NRUNTG = NRUN
       IF (  NRUNTG .LT.  6000 )                            MARK = 0
       IF ( (NRUNTG .GE.  6000) .AND. (NRUNTG .LT. 12948) ) MARK = 1
       IF (  NRUNTG .GE. 12948 )                            MARK = 2
C
C-----------------------------------------------------------------------
C
    5  CONTINUE
C
C
C---                                    PRINT MARK USED ETC
C  NOTE  :  PRINTS REAL MARK (1-3)
C  RATHER THAN SOFTWARE MARK (0-2)
C
CCC    IF ( NFIRST ) GOTO 1
       IF ( MARK .EQ. MARK0 ) GOTO 1
       MARK0  = MARK
       NYMARK = MARK + 1
       WRITE(6,601)
       IF (  IMC .EQ. 0 ) WRITE(6,602) NYMARK
       IF (  IMC .EQ. 1 ) WRITE(6,603) NYMARK
       IF ( MARK .EQ. 0 ) WRITE(6,605)
       IF ( MARK .EQ. 1 ) WRITE(6,606)
       IF ( MARK .EQ. 2 ) WRITE(6,607)
       IF ( (IMC .EQ. 1) .AND. (NRUN.NE.0) ) WRITE(6,608) NRUN
       WRITE(6,604)
       NFIRST = .TRUE.
  601  FORMAT(/,/,
     * /,' ++++ T A G A N ++++++++ T A G A N ++++++++ T A G A N ++++',
     * /,' +                                                       +')
  602  FORMAT(
     *   ' +  REAL DATA ',9X,' MARK ',I3,'   TAGGER                +',
     * /,' +                                                       +')
  603  FORMAT(
     *   ' +  MC DATA   ',9X,' MARK ',I3,'   TAGGER SIMULATION     +',
     * /,' +                                                       +')
  605  FORMAT(
     *   ' +                      1979 - 1980                      +')
  606  FORMAT(
     *   ' +                      1981 - 1982                      +')
  607  FORMAT(
     *   ' +                      1983 - 1986                      +')
  608  FORMAT(
     *   ' +                                                       +',
     * /,' +  FORCED  BY  NRUN  =  ',I6,'                          +')
  604  FORMAT(
     *   ' +                                                       +',
     * /,' +++++++++++++++++++++++++++++++++++++++++++++++++++++++++',
     * /,/)
C
C
C
C---                                    CALL ANALYSIS ROUTINES
C
C
    1  CONTINUE
       IF ( MARK .GT. 0    ) GOTO 2
C
C
C----------------------------------------MARK = 0 ONLY------------------
C
C
C
C---                                    CALL ANATAG FOR PRE 1981 DATA
C
C
       IF ( IMC .EQ. 0 ) CALL ANATAG(IER1)
       IF ( IMC .EQ. 1 ) CALL AMCTAG(IER1)
       GOTO 1000
C
C
C----------------------------------------MARK = 1 OR 2 ONLY-------------
C
C
C---                                    CALL TAGGTP ROUTINE
C
C
C IWRITE CAN BE SET TO 1 TO TURN ON DEBUGGING INFO
C
C RETURN 1 FROM TAGGTP IS DONE IF ATAG NOT FOUND - SHOULD BE
C REDUNDANT WHEN CALLED FROM TAGAN
C RETURN 2 FROM TAGGTP IS DONE IF ERROR IN TAGSTO -
C  IE NO ROOM FOR TAGG BANKS IN COMMON/BCS/
C
    2  CALL TAGGTP(IWRITE,ERGY,&100,&100)
C
C
C-----------------------------------------------------------------------
C
C
C
C---                                    CHECK TAGG/0 BANK FOR CLUSTERS
C
C
 1000  CONTINUE
       CALL BLOC(INTAG0,'TAGG',0,&1001)
       NCLST = HDATA( INTAG0 + INTAG0 + 6 )
       IF ( NCLST .LE. 0 ) IER = 1
       RETURN
 1001  IER = 2
       RETURN
       END

C   10/02/86 604291105  MEMBER NAME  PRATOFR  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRATOF( XS, YS , DEL, SIZE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 29/04/86 :  PRINT BOS BANK ATOF
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
C
      COMMON / CWORK1 / HWORK(70)
      COMMON / CWORK  / HDUM(8000),
     +                  HADC(2,42),HTDC(2,42),HTDC1(2,42),HADCF(2,16),
     +                  HTDCF(2,16),HTSPAR(16)
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*140
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C
C------------------  C O D E  ------------------------------------------
C
      CALL CORE(HWORK,107)
      WRITE(cHWORK,1)           ! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
    1 FORMAT(' NR   ADC(L)  ADC(R)   TDC(L)  TDC(R)   TDC1(L)  TDC1(R)
     & ADCF(L)  ADCF(R)   TDCF(L)  TDCF(R)   TDC(SPARE)')
      CALL SYSSYM(XS,YS,SIZE,HWORK,107,0.)
      YS = YS - .9*DEL
      DO 6 I = 1,42
         IF( I .GT. 16 ) GO TO 3
            CALL CORE(HWORK,106)
            WRITE(cHWORK,2) I,(HADC(J,I),J=1,2),(HTDC(J,I),J=1,2), ! PMF 17/11/99: JUSCRN changed to cHWORK
     &         (HTDC1(J,I),J=1,2),(HADCF(J,I),J=1,2),(HTDCF(J,I),J=1,2),
     &                                                         HTSPAR(I)
    2       FORMAT(' ',I2,2X,I6,2X,I6,3X,I6,2X,I6,3(3X,I7,2X,I7),3X,I10)
            CALL SYSSYM(XS,YS,SIZE,HWORK,106,0.)
            GO TO 5
    3    CALL CORE(HWORK,55)
         WRITE(cHWORK,4) I,(HADC(J,I),J=1,2),(HTDC(J,I),J=1,2), ! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
     &                     (HTDC1(J,I),J=1,2)
    4    FORMAT(' ',I2,2X,I6,2X,I6,3X,I6,2X,I6,3X,I7,2X,I7)
         CALL SYSSYM(XS,YS,SIZE,HWORK,55,0.)
    5    YS = YS - .9*DEL
         IF( MOD(I,10) .EQ. 0 ) YS = YS -.2*DEL
    6 CONTINUE
      RETURN
      END

C   10/02/86 604291114  MEMBER NAME  PRTPVXR  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRTPVX( IPTPVX, XS, YS , DEL, SIZE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 29/04/86 :  PRINT BOS BANK TPVX
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
C
      COMMON / CWORK1 / HWORK(70)
C
C
C------------------  C O D E  ------------------------------------------
C
      LIM2   = IPTPVX
      LIMLIM = 2*LIM2
      CALL CORE(HWORK,13)
      WRITE(JUSCRN,1) HDATA(LIMLIM+1),HDATA(LIMLIM+2)
    1 FORMAT(' ',I4,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,13,0.)
      YS = YS - DEL
      CALL CORE(HWORK,108)
      WRITE(JUSCRN,2) (ADATA(LIM2+1+I),I=1,7),IDATA(LIM2+9),
     &                 ADATA(LIM2+10)
    2 FORMAT(' ',3E12.4,2X,3E12.4,2X,E12.4,I4,3X,E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,108,0.)
      YS = YS - DEL
      CALL CORE(HWORK,51)
      WRITE(JUSCRN,3) (HDATA(LIMLIM+20+I),I=1,10)
    3 FORMAT(' ',10I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,51,0.)
      MULSEC = HDATA(LIMLIM+22)
      IF( MULSEC .LE. 0 ) GO TO 100
         IVX = 30
    4    IVX1 = 20
         IF( MULSEC+30 .LT. IVX+IVX1 ) IVX1 = MULSEC + 30 - IVX
         YS = YS - DEL
         CALL CORE(HWORK,101)
         WRITE(JUSCRN,5) (HDATA(LIMLIM+IVX+I),I=1,IVX1)
    5    FORMAT(' ',20I5)
         LIMLO = IVX1*5 + 1
         CALL SYSSYM(XS,YS,SIZE,HWORK,LIMLO,0.)
         IVX = IVX + 20
         IF( IVX .GT. 30+MULSEC ) GO TO 100
            GO TO 4
  100 CONTINUE
      RETURN
      END

C   04/08/86 611261031  MEMBER NAME  CL2PRC   (JADEGS)      FORTRAN77
      INTEGER FUNCTION CL2PRC( CELL )
C-----------------------------------------------------------
C  VERSION OF 04/08/86    LAST MOD 04/08/86    E ELSEN
C  CONVERT JETC CELL NUMBER ( 0-95 ) TO PROCESSOR NUMBER
C-----------------------------------------------------------
C
      INTEGER CELL
      INTEGER PRMAP(0:31) /
     *  26, 27,  8,  9, 10, 11, 24, 25,
     *  30, 31, 12, 13, 14, 15, 28, 29,
     *  20, 21, 22, 23,  0,  1,  2,  3,
     *   4,  5,  6,  7, 16, 17, 18, 19 /
C
      IF( CELL .LT. 0 .OR. CELL .GT. 95 ) THEN
        CL2PRC = -1
      ELSE
        CL2PRC = PRMAP(CELL/3)
      ENDIF
      END
      INTEGER FUNCTION PRC2CL( PROC )
C-----------------------------------------------------------
C  VERSION OF 04/08/86    LAST MOD 04/08/86    E ELSEN
C  CONVERT PROCESSOR NUMBER ( 0-31 ) TO NUMBER OF FIRST
C  CELL IN THAT PROC
C-----------------------------------------------------------
C
      INTEGER PROC, CL2PRC
      INTEGER CLMAP(0:31)
      INTEGER ICALL / 0 /
      IF( ICALL .EQ. 0 ) THEN
        ICALL = 1
        DO 10 I=0,95,3
          CLMAP(CL2PRC(I)) = I
   10   CONTINUE
      ENDIF
C
      IF( PROC .LT. 0 .OR. PROC .GT. 31 ) THEN
        PRC2CL = -1
      ELSE
        PRC2CL = CLMAP(PROC)
      ENDIF
      END
      REAL FUNCTION CL2HEU( CELL )
C-----------------------------------------------------------
C   VERSION OF 19/08/86     LAST MOD 19/08/86    E ELSEN
C   CONVERT CELL NUMBER INTO HEUER FORMAT
C-----------------------------------------------------------
      INTEGER CELL
      IF( CELL .LT. 48 ) THEN
        K = (MOD(CELL,24)+1)*10 + CELL/24 + 1
      ELSE
        K = (MOD(CELL/2,24)+1)*10 + 3+MOD(CELL,2)
      ENDIF
      CL2HEU = .1*K
      END
      FUNCTION IT0GLB( IRUN )
C-----------------------------------------------------------
C  VERSION OF 14/08/86          LAST MOD 05/11/86  E ELSEN
C  GLOBAL T0 THAT WAS SUBTRACTED FROM RAW JETC TIMES
C-----------------------------------------------------------
      INTEGER IRUN
C                                           PRE DL300 DATA
      IF( IRUN.LT. 24201 ) THEN
        IT0GLB = 0
C                                           MATSUS T0 BOX FROM HERE ON
      ELSEIF( IRUN.GT. 24698 ) THEN
        IT0GLB = 1088
C                                           HERE IS THE INITIAL TRYING
C                                           FIRST WEEK
      ELSEIF( IRUN.LT. 24227 ) THEN
        IT0GLB = 1283
C                                           BY MISTAKE TO TIGHT
      ELSEIF( IRUN.LT. 24246 ) THEN
        IT0GLB = 1430
C                                           PRE MATSU
      ELSE
        IT0GLB = 1130
      ENDIF
      RETURN
      END
      FUNCTION T0EFFC( IRUN )
C-----------------------------------------------------------
C  VERSION OF 05/11/86          LAST MOD 05/11/86  E ELSEN
C  EFFECTIVE T0 TO BE APPLIED TO JETC DATA TAKING INTO
C  ACCOUNT THE SOFTWARE CHANGES OF IT0GLB AND THE EFFECT
C  OF HARDWARE CHANGES DUE TO CHANGED GATES ETC.
C  UNITS ARE OLD DL8 COUNTS
C-----------------------------------------------------------
      INTEGER IRUN
C                                           PRE DL300 DATA
      IF( IRUN.LT. 24200 ) THEN
        T0EFFC = 0.
C                                           MATSUS T0 BOX FROM HERE ON
C                                           THIS IS THE REFERENCE
      ELSEIF( IRUN.GT. 24698 ) THEN
        T0EFFC = 0.
C                                           HERE IS THE INITIAL TRYING
C                                           FIRST WEEKS
      ELSEIF( IRUN.LT. 24227 ) THEN
        T0EFFC =  2.3125
      ELSEIF( IRUN.LT. 24233 ) THEN
        T0EFFC =  4.6094
      ELSEIF( IRUN.LT. 24246 ) THEN
        T0EFFC =  6.9531
      ELSEIF( IRUN.LT. 24405 ) THEN
        T0EFFC =  2.3125
      ELSE
        T0EFFC = -0.0781
      ENDIF
      RETURN
      END

C   07/06/96 606071911  MEMBER NAME  SORTP    (S4)          FORTG1
      SUBROUTINE SORTP(X,NSTP,LIST,NA,NB)
      REAL X(NSTP,1),NEW
      INTEGER LIST(1)
C
C     STORE IN   LIST(NA) TO LIST(NB)  INDICES
C     FOR ELEMENTS X(1,INDEX), INDEX = NA . . . NB
C     IN ASCENDING ORDER
C
      IF(NA.GT.NB) GOTO 100
      I=NA
      GOTO 40
   10 IF(I.GE.NB) GOTO 100
      NEW=X(1,I+1)
      K=I
      GOTO 30
C     EXCHANGE
   20 LIST(K+1)=LIST(K)
      K=K-1
      IF(K.LT.NA) GOTO 40
   30 IF(NEW.LT.X(1,LIST(K))) GOTO 20
   40 LIST(K+1)=I+1
      I=I+1
      GOTO 10
  100 RETURN
      END

C   24/06/85 506241019  MEMBER NAME  DRFTIM   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      FUNCTION DRFTIM( NCHA, IA1, IA2, IPED, NCD )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   17/10/84 :  FUNCTION TO CALCULATE DRIFT
C                                        TIME FOR VERTEX CHAMBER HITS
C                                        IN UNITS OF ( 0.1 NS )
C  LAST MOD:   J. HAGEMANN   21/06/85 :  NOW IN OWN MEMBER
C
C                       NCHA   :  CHANNEL NUMBER WHERE THE HIT BEGINS
C                       IA1    :  AMPLITUDE OF FIRST HIT CHANNEL
C                       IA2    :  AMPLITUDE OF SECOND HIT CHANNEL
C                       IPED   :  PEDASTAL
C                       NCD    :  HELP COUNTER FOR DOUBLE HITS
C
C-----------------  C O D E  -------------------------------------------
C
C
      IH1    = MIN0( IA1, 64 ) - IPED
      IH2    = MIN0( IA2, 64 ) - IPED
C
      DRFTIM = (FLOAT(NCHA+NCD) + FLOAT(IH2)/FLOAT(IH1 + IH2))*100.0
C
      RETURN
      END

C   01/03/80 003061009  MEMBER NAME  DISTRI   (JADESR)      FORTRAN
      SUBROUTINE DISTRI
      IMPLICIT INTEGER*2 (H)
C---
C---    DISTRIBUTES THE CONTENTS OF AN INPUT, UNREFORMATTED TAPE OVER
C---    UP TO FOUR SCRATCH FILES.
C---                                   L.H. O'NEILL, MARCH 1, 1980
C---
      DIMENSION IBUF(1558)
      NREC=0
    1 CONTINUE
      READ(2,ERR=1000,END=2000) IBUF
      NREC=NREC+1
      NUNIT=3
      IF(NREC.GT. 5700) NUNIT=4
      IF(NREC.GT.11400) NUNIT=8
      IF(NREC.GT.17100) NUNIT=9
      WRITE(NUNIT) IBUF
      GO TO 1
 1000 CONTINUE
      WRITE(6,100) NREC
  100 FORMAT(1H1' ****** READ ERROR FROM DISTRI AFTER',I8,' RECORDS.')
      STOP
 2000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(1H0,' DISTRI HAS COPIED',I8,' RECORDS.',//)
      IF(NUNIT.LT.4) END FILE 4
      IF(NUNIT.LT.8) END FILE 8
      IF(NUNIT.LT.9) END FILE 9
      RETURN
      END

C   14/10/82            MEMBER NAME  BSCOM4   (S)           FORTRAN77
      SUBROUTINE BSCOM
C
C
C
C
C     4.  DEFINING SETS OF BANKS
C
C     SEVERAL SUBROUTINES WORK ON SET OF BANKS. THESE SETS ARE
C     DEFINED BY DEFINING A LIST OF NAMES, EVERY BANK WITH A NAME,
C     WHICH IS CONTAINED IN THE LIST, BELONGS TO THE SET OF BANKS.
C     THERE ARE TWO LISTS, ONE CALLED THE CURRENT LIST AND THE OTHER
C     THE SPECIAL LIST. THE CURRENT LIST IS USED IN THE SUBROUTINES
C            BDLM AND BDLG      TO DELETE A SET OF BANKS,
C            BPRM               TO PRINT A SET OF BANKS,
C            BWRITE ETC.        TO WRITE A SET OF BANKS (EVENT).
C     THE SPECIAL LIST IS DEFINED BY THE INPUT ROUTINES, IT CONTAINS
C     AFTER THE INPUT OF ONE EVENT ALL NAMES BELONGING TO THAT
C     EVENT, AND IS LATER USED TO WRITE THE BANKS AND TO DELETE
C     THE BANKS. IF NEW BANKS ARE CREATED, THEIR NAMES CAN BE ADDED
C     TO THE SPECIAL LIST.
C
C
C     4.1  DEFINING TH CURRENT LIST
C
C     THERE ARE THREE CALL TO DEFINE THE CURRENT LIST.
C
C               - ----
C     CALL BMLT(N,LIST)
C
C        WHERE LIST = ARRAY OF N NAMES
C
C     CALL BSLT
C
C     ALL NAMES OF THE SPECIAL LIST ARE DEFINED AS THE CUURENT LIST.
C
C     CALL BSLW
C
C     THE NAMES OF THE SPECIAL LIST WITH THE MARKER = 1 ARE DEFINED
C     AS THE CURRENT LIST.
C
C     THE LATTER TWO CALL ARE USUALLY USED IN THE FOLLOWING
C     CONNECTION.
C
C     CALL BSLW
C     CALL BWRITE(IUN)      WRITE AN EVENT OF BANKS WITH NAMES OF
C                           THE SPECIAL LIST WITH MARKER +1.
C
C     CALL BSLT
C     CALL BDLG             DELETE ALL BANKS WITH NAMES OF THE
C                           SPECIAL LIST AND MAKE A GARBAGE
C                           COLLECTION.
C
C     EXAMPLE
C
C     CALL BMLT(2,'HEADGEOM')
C
C
C     10. SPECIAL SET OF BANKS
C
C     FOR THE USE IN AN EVENT-BY-EVENT PROCESSING A SPECIAL LIST
C     OF BANK NAMES IS SUPPORTED BY THE SYSTEM. THIS LIST CONTAINS
C     ALL NAMES OF BANKS BELONGING TO THE CURRENT EVENT. EACH
C     NAME HAS ASSOCIATED A MARKER, WITH A VALUE =1, IF BANKS
C     WITH THIS NAME SHOULD BE WRITTEN IN THE OUTPUT RECORD.
C     AFTER INPUT (BREAD/BINP) THE SPECIAL LIST CONSISTS OF
C     ALL NAMES OF BANKS JUST READ IN, WITH MARKER =1.
C     THE LIST CAN BE UPDATED DURING EVENT PROCESSING.
C
C     4.2  UPDATING THE SPECIAL LIST
C
C
C                - ----
C      CALL BSAT(N,LIST)
C
C                - ----
C      CALL BSAW(N,LIST)
C
C
C         WHERE LIST( ) = ARRAY OF N NAMES
C
C     IN BOTH CASES THE NAMES ARE ADDED TO THE SPECIAL LIST
C     (IF NOT ALREADY PRESENT), AND THE MARKER IS SET
C     =0 FOR BSAT AND =1 FOR BSAW.
C
C     THE CONNECTION BETWEEN THE TWO LISTS AND THE DIFFERENT
C     CALLS IS ILLUSTRATED IN THE FLOW DIAGRAM BELOW
C
C
C
C
C                        +---------------+
C                        I               I
C                        I SPECIAL LIST  I
C                        I     OF NAMES  I
C                ADDS    I               I
C        BSAW   ->->->->-I->->->-+-<-<-<-I-<-<-<-<-   INPUT ROUTINE
C                CHANGES I       |       I DEFINES
C                        I       V       I
C                        I       |       I
C                        I       V       I
C                ADDS    I       |       I
C        BSAT   ->->->->-I->-+-<-+->-+   I
C                CHANGES I   |       |   I
C                        I   V       V   I
C                        I   |       |   I
C                        +---------------+
C                            |       |
C                            V       V
C                            |       |
C
C          (USUALLY FOR    BSLT    BSLW   (USUALLY FOR
C       DELETING BANKS)                   WRITING BANKS)
C                            |       |
C                            V       V
C                            |DEFINES|
C                            V       V
C                            |       |
C                        +---------------+
C                        I               I
C                        I CURRENT LIST  I
C                        I     OF NAMES  I
C                DEFINES I               I
C        BMLT   ->->->->-I               I
C                        I               I
C                        I               I
C                        I               I
C                        +---------------+
C                                |
C                                V
C                                |
C                                V
C
C                        USED IN BPRM
C                                BDLM, BDLG
C                                OUTPUT ROUTINES
C
C
C
     RETURN
     END

C   07/06/96 606071804  MEMBER NAME  BDAR     (S4)          FORTG1
      SUBROUTINE BDAR(NAME,N,INDA,NLIM)
C     BOS SUBPROGRAM =1.8=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      INTEGER INDA(1)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAMEV),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      K=LFDI+1
      DO 10 I=1,NLIM
      K=IW(K-1)
      IF(K.EQ.0) GOTO 100
   10 INDA(I)=K
      I=NLIM+1
  100 N=I-1
      RETURN
      END

      SUBROUTINE PATREC(IDRENT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cworkpr.for"
#include "cworkeq.for"
#include "cdata.for"
      COMMON /CHEADR/ IHEADR(54)
      DIMENSION HEARR(200)
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 0
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
        IQJETC = IBLN('JETC')
        IQHEAD = IBLN('HEAD')
      ENDIF
      IPHEAD=IDATA(IQHEAD)
      IF(IPHEAD.GE.1) CALL MVCL(IHEADR(1),0,IDATA(IPHEAD-3),0,216)
      CALL PATRC1(IDRENT)
      IF(
     - NTR.GT.0
     -)THEN
      DO 13000 IMO=1,NTR
          HEARR(IMO)=IMO
13000 CONTINUE
13001 CONTINUE
        ITRK=NTR
        NTRLM = 0
        CALL KNTREL(HEARR,ITRK)
      ENDIF
      RETURN
      END

C   22/10/83 805261726  MEMBER NAME  MUFFLT   (JADEMUS)     FORTRAN
C
C LAST CHANGE  9.40 14/04/88 J. HAGEMANN - CORRECT CALC. OF EXTR. ERRORS
C      CHANGE 22.00 22/10/83 HUGH MCCANN - PARALLEL MUFFLY CHANGES.
C      CHANGE 03.10 14/07/83 HUGH MCCANN - VARIOUS CHANGES.
C      CHANGE 18.27 16/03/82 CHRIS BOWDERY- FOR THE 'LET-OFF' TEST
C      CHANGE 14.50 08/02/82 HUGH MCCANN  - KDEPTH LIMIT INCREASED TO 4.
C      CHANGE 17.20 23/09/81 CHRIS BOWDERY- REMOVE RESL * REST FROM
C                                           'LET OFF' TEST. KILLS BUG.
C      CHANGE 15.07 04/08/81 CHRIS BOWDERY- INCLUDE Z EDGE TEST AGAIN
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLT
C-----------------------------------------------------------------------
C
C MUFFLT TAKES THE REFITTED TRACK AND TRACKS IT THROUGH THE FILTER AGAIN
C LOOKING FOR INEFFICIENCIES. REGIONS WILL BE 'LET OFF' IF THE TRACK DID
C NOT PASS THROUGH THE ACTIVE PART OF THE REGION , IF THE TRACK COULD
C HAVE SCATTERED INTO A DEAD CHAMBER OR SCATTERED OUT OF THE ACTIVE AREA
C
C-----------------------------------------------------------------------
C
C NCEPTS  IS THE NUMBER OF INTERCEPTS FOUND BY MUREGY.
C INEFF   IS NO. OF TIMES A HIT WAS NOT FOUND AND THERE WAS NO
C           DEAD CHAMBER TO EXPLAIN ITS ABSENCE.
C NHLAYR  IS RELATED TO THE NO. OF LAYERS WITH HITS WHICH ARE
C           ASSOCIATED WITH THIS TRACK.
C NGLAYR  IS AS NHLAYR - BUT APPLIES TO ALL INTERCEPTED LAYERS WHETHER
C           THEY HAD A HIT OR NOT.
C INFLAG  IS SET = 1 IF AN INEFFICIENCY IS FOUND, AND SET = 0 IF A HIT
C           IS FOUND WITHIN CUTS.  SO IF IT IS STILL 1 WHEN THIS ROUTINE
C           HAS FINISHED IT MEANS THERE WAS AN INEFFICIENCY IN THE LAST
C           LAYER INTERCEPTED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LETDCE,LCOVAR
C
C             COMMONS AND ARRAY DECLARATIONS
C
C   20/10/81 408081453  MEMBER NAME  CMUFFL   (S)           FORTRAN
C
C LAST CHANGE 15.00 08/08/84 - CKB PWA     - ADD NALLWM,PMXFLG
C      CHANGE 15.00 03/12/83 - HUGH MCCANN - NEW LEAD GLASS PARAMETERS.
C      CHANGE 08.00 12/10/81 - HUGH MCCANN - TO ADD OVLCUT(FOR OVERLAPS)
C      CHANGE 09.33 17/06/81 - JOHN ALLISON - TO ADD RESOLUTIONS.
C
C-------------START OF MACRO CMUFFL-------------------------------------
C
      COMMON / CMUFFL / XYSTEP,RCOILI,RCOILO,PGMID,WMU,WMUSQ,DUMF1(4),
     +                  NSPECI,XPBAR,XPROT,XPION,XKAON,DUMF2(5),
     +                  TBP,GMBP,ABBP,RDBP,DEBP,
     +                  TJETI,GMJETI,ABJETI,RDJETI,DEJETI,
     +                  TJET1,GMJET1,ABJET1,RDJET1,DEJET1,
     +                  TJET2,GMJET2,ABJET2,RDJET2,DEJET2,
     +                  TJET4,GMJET4,ABJET4,RDJET4,DEJET4,
     +                  TJETO,GMJETO,ABJETO,RDJETO,DEJETO,
     +                  TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL,
     +                  ZJETE,TJETE,GMJETE,ABJETE,RDJETE,DEJETE,
     +                  ZEPLG,TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG,
     +                  RLG,ZLG,TLG,GMLG,ABLG,RDLG,DELG,
     +                  ZEP,TEP,GMEP,ABEP,RDEP,DEEP,
     +                  GMG(3),ABG(3),RDG(3),DEG(3),
     +                  VDRES,VLRES,
     +                  REST1,REST2,RESTMX,RESL,RESLMX,FACTOR,OVLCUT,
     +                  ZLGHAF,TLGHAF,ZLGC,GMLGC,ABLGC,RDLGC,DELGC,
     +                  NALLWM,PMXFLG
C
C FOR EXPLANATION SEE BLOCK DATA AFTER SUBROUTINE MUFFLE.
C
C--------------END OF MACRO CMUFFL--------------------------------------
C   20/10/81 202041521  MEMBER NAME  CMUFWORK (JADEMUS)     FORTRAN
C   12/10/81 110152138  MEMBER NAME  CMUFWORK (JADEMUS1)    FORTRAN
C-------------START OF MACRO CMUFWORK-----------------------------------
C LAST CHANGED 21.30 15/10/81 HUGH MCCANN  - EXTEND IOVLAP TO ALLOW
C                                            > 10 ASSOC HITS IN MUFFLY.
C LAST CHANGED 10.00 04/10/81 HUGH MCCANN  - FOR USE OF OVERLAP HITS.
C LAST CHANGED 14.46 17/06/81 JOHN ALLISON - TO ADD 'OVER' VARIABLES.
C LAST CHANGED 23.00 09/04/81 HUGH MCCANN - JADEMUS UPDATE.
C
      COMMON /CWORK/X,Y,Z,DCX,DCY,DCZ,P,PSQ,E,ESQ,D,GM,AB,RD,DE,PPIDK,
     *PKDK,PPBPEN,PPPEN,PPIPEN,PKPEN,DUMW1(29),X8,Y8,Z8,DCX8,DCY8,
     *DCZ8,P8,PSQ8,E8,ESQ8,D8,GM8,AB8,RD8,DE8,PPIDK8,PKDK8,PPBPE8,
     *PPPEN8,PPIPE8,PKPEN8,DUMW28(29),X0,Y0,Z0,DCX0,DCY0,DCZ0,P0,PSQ0,
     *E0,ESQ0,D0,GM0,AB0,RD0,DE0,PPIDK0,PKDK0,PPBPE0,PPPEN0,PPIPE0,
     *PKPEN0,DUMW2(29),X9,Y9,Z9,DCX9,DCY9,DCZ9,P9,PSQ9,E9,ESQ9,D9,GM9,
     *AB9,RD9,DE9,PPIDK9,PKDK9,PPBPE9,PPPEN9,PPIPE9,PKPEN9,DUMW29(29),
C-----200 WORDS UP TO HERE----------------------------------------------
     *X1,Y1,Z1,X2,Y2,Z2,XMID,YMID,ZMID,X3,Y3,Z3,D1,D2,D3,DTC,DUMW3(4),
     *DSTEP,GMSTEP,ABSTEP,RDSTEP,DESTEP,DUMW4(15),ADCZ,COSEC,STPINI,CURV
     *,DANG,DX,DY,DZ,R,RSQ,PT,DPINA,DKNA,DUMW5(7),VX,VY,VZ,RMSXY,RMSZ,
     *VTXYD,VTZD,VTXYAN,VTZANG,VMSANG,VMSD,CMS,DUMW6(8),SDS(10),DUMW7(1000002000
C
C    *SDX,SDY,SDZ,SDTXYD,SDTZD,SDTXYA,SDTZAN,SDMSAN,SDMSD,SDCMS,DM7(10),
C
C NOTE ABOVE CARD SHORTENED TO SDS(10),DUMW7(10), SO THAT STATEMENT DOES
C   NOT EXCEED 19 CONTINUATION CARDS.  I THINK SD--'S ARE NOT USED.
     *),CHISQT,NDFT,CHIPRT,CHISTL,NDFTL,CHIPTL,NBADCH,DUMW8(13),IDTRK,
     *NCEPTS,NTHIS,INEFF,NHLAYR,INFLAG,NELIPS,NGLAYR,DUMW9(72),IREG(200)
C-----600 WORDS UP TO HERE----------------------------------------------
     *,RDOTD(200),CINT(3,200),NFLAG(200),ITEM(200),EM(30,30),DALONG(10),
C-----2710 WORDS UP TO HERE---------------------------------------------
     *DEV(30),VXYDA(10),VZDA(10),CXYA(10),CZA(10),INCUT(30),BADA(30),G(200003100
     *0,20),DEVA(20),IPERM(10),MWORK(20),ITHISA(10),IJA(10),EM1(20,20),E
     *MG(20,20),ELIPSE(700),INCHAM(10),INREG(10),IAPPRO(30),HBADCH(1000)
     *,CTDASH(10),CLDASH(10),VTDASH(10),VLDASH(10),IHTREG(20),LAYRAB,IEF
C-----5421 WORDS UP TO HERE---------------------------------------------
     *FRG(10),DUMW10(69),AAA(10),BBB(10),CCC(10),DDD(10),DOVER,GMOVER,AB
     *OVER,RDOVER,DEOVER,DUMW11(55),X7(50),IHTP(30),IOVLAP(20,20)
C-----6080 WORDS UP TO HERE---------------------------------------------
      DIMENSION ILIPSE(700)
      INTEGER*2 HLIPSE(1400)
      DIMENSION IHTPER(10),IHTEMP(10),IPTEMP(10)
      EQUIVALENCE (ILIPSE(1),HLIPSE(1),ELIPSE(1))
      EQUIVALENCE (IHTP(1) ,IHTPER(1)),
     *            (IHTP(11),IHTEMP(1)),
     *            (IHTP(21),IPTEMP(1))
      LOGICAL INCUT,BADA
C
C-----------------------------------------------------------------------
C
C THE FIRST 50 LOCATIONS ARE RESERVED FOR SPECIAL WORKING VARIABLES.
C THE NEXT 150 LOCATIONS ARE RESERVED FOR COPIES OF THESE SPECIAL
C    VARIABLES, IF, E.G., ONE WISHES TO PRESERVE THEIR VALUES AT
C    THE BEGINNING OF A STEP.
C THE COPIES HAVE A SUFFIX 0 FOR VALUES AT LAST ASSOCIATED HIT.
C THE COPIES HAVE A SUFFIX 7 FOR VALUES AFTER LEAD-GLASS BARREL OR
C    YOKE END-PLUG (X7 IS LATER IN COMMON - SEE BELOW).
C THE COPIES HAVE A SUFFIX 8 FOR VALUES AT LAST BUT ONE GOOD
C    CHAMBER LAYER.
C THE COPIES HAVE A SUFFIX 9 FOR VALUES AT LAST GOOD CHAMBER LAYER.
C NSPECI (SET IN BLOCK DATA BEHIND MUFFLE) IS THE NUMBER OF SUCH
C    VARIABLES ACTUALLY USED.
C
C SPECIAL VARIABLES....
C
C X,Y,Z       = CURRENT COORDINATES.
C DCX,DCY,DCZ = CURRENT DIRECTION COSINES OF TRACK.
C P,PSQ       = CURRENT MOMENTUM (AND ITS SQUARE).
C E,ESQ       = CURRENT ENERGY (AND ITS SQUARE).
C D           = CURRENT DISTANCE FROM VERTEX (MM).
C GM          = MATERIAL TRAVERSED TO CURRENT POSITION (GM CM**-2).
C AB          = ABSORPTION LENGTHS SO FAR.
C RD          = RADIATION LENGTHS SO FAR.
C DE          = ENERGY LOSS (GEV).
C PPIDK       = PROBABILITY OF PION DECAYING TO MUON BEFORE INTERACTING.
C PKDK        = PROBABILITY OF KAON DECAYING TO MUON BEFORE INTERACTING.
C PPBPEN      = ANTI-PROTON ) ( PENETRATION PROBABILITY, I.E. PROBAB-
C PPPEN       = PROTON      ) ( ILITY OF NOT BEING ABSORBED BY A NUCLEUS
C PPIPEN      = PI          ) ( AND NOT DECAYING.  SEE SUBROUTINE
C PKPEN       = K           ) ( MUFFLS FOR FURTHER DETAILS.
C
C-----------------------------------------------------------------------
C
C THE NEXT 200 LOCATIONS ARE RESERVED FOR VARIABLES THAT DO NOT NEED
C    SPECIAL PRESERVATION.
C
C OTHER VARIABLES...
C
C X1,Y1,Z1    = COORDS OF 1ST POINT ON TRACK.
C X2,Y2,Z2    = COORDS OF LAST POINT ON TRACK.
C XMID,YMID,ZMID = COORDS OF MID POINT ON TRACK.
C X3,Y3,Z3    = COORDS OF POINT WHERE TRACK LEAVES MAGNETIC FIELD.
C D1          = DISTANCE TRAVELLED TO (X1,Y1,Z1).
C D2          = DISTANCE TRAVELLED TO (X2,Y2,Z2).
C D3          = DISTANCE TRAVELLED TO (X3,Y3,Z3).
C DTC         = DISTANCE TRAVELLED TO MID-POINT OF TRACK.
C
C DSTEP       = STEP LENGTH THIS STEP (FOR MUFFLU) (MM).
C GMSTEP      = MATERIAL THIS STEP (GM CM**-2).
C ABSTEP      = ABSORPTION LENGTHS THIS STEP.
C RDSTEP      = RADIATION LENGTHS THIS STEP.
C DESTEP      = ENERGY LOSS OF MINIMUM IONISING PARTICLE THIS STEP,
C
C ADCZ        = ABS(DCZ)
C COSEC       = ABS(COSEC(THETA)), WHERE THETA IS ANGLE TO BEAM.
C STPINI      = STEP LENGTH IN INITIAL TRACKING TO COIL OR END PLUG.
C CURV        = CURVATURE FROM 'PATR' BANK.
C DANG        = ANGLE OF TURN FOR EACH STEP.
C DX,DY,DZ    = CHANGES OF X,Y,Z.
C R,RSQ       = DISTANCE FROM BEAM (RADIUS) AND ITS SQUARE.
C PT          = MOMENTUM COMPONENT PERPENDICULAR TO BEAM.
C DPINA       = INTEGRAL OF (DECAY LENGTH)*(PROBABILTY OF NOT INTER-
C                 ACTING) FOR PION. (NO LONGER USED. CAN BE RESURECTED
C DKNA        = SIMILARLY FOR KAON. (BY UN-COMMENTING IN MUFFLS.
C
C VX,VY,VZ    = CURRENT VARIANCES ON X,Y,Z.
C RMSXY       = RMS DEV. NORMAL TO CHORD IN XY FIT.     )
C RMSZ        = RMS Z DEV. IN RZ FIT.                   ) FROM
C VTXYD       = VARIANCE ON DEVIATION NORMAL TO         ) TRACK
C                 TRACK IN XY PLANE AT TRACK CENTRE.    ) RECON-
C VTZD        = VARIANCE ON DEVIATION NORMAL TO         ) STRUCTION
C                 TRACK IN RZ PLANE AT TRACK CENTRE.    ) ERRORS.
C VTXYAN      = VARIANCE ON ANGLE IN XY PLANE (PHI)     )
C VTZANG      = VARIANCE ON ANGLE IN RZ PLANE (THETA)   )
C VMSANG      = VARIANCE OF MULTIPLE SCATTERING ANGLE.
C VMSD        = VARIANCE OF MULTIPLE SCATTERING DEVIATION NORMAL TO
C                 TRACK.
C CMS         = COVARIANCE OF ABOVE TWO QUANTITIES.
C SD--        = CORRESPONDING STANDARD DEVIATIONS (SQUARE ROOTS).
C
C CHISQT      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFT        = NUMBER OF DEGREES OF FREEDOM.           ) (DRIFT)
C CHIPRT      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C CHISTL      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFTL       = NUMBER OF DEGREES OF FREEDOM.           ) & LONG'L
C CHIPTL      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C NBADCH      = NO. OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C
C IDTRK       = INNER DETECTOR TRACK NUMBER.
C NCEPTS      = NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS       = NUMBER OF MUON HITS ASSOCIATED WITH PROJECTED INNER
C                DETECTOR TRACK.
C INEFF       = NUMBER OF INEFFICIENCIES IN MUON SYSTEM FOUND THIS TRACK
C NHLAYR      = NUMBER WHICH REPRESENTS NUMBER OF MUON LAYERS WITH
C                ASSOCIATED MUON HITS. ADD 1 FOR THE INNER LAYER AND
C                2 FOR EACH SUBSEQUENT LAYER.
C INFLAG      = 1 IF LAST LAYER INTERCEPTED WAS INEFFICIENT.
C NELIPS      = NUMBER OF MULTIPLE SCATTERING ELIPSES ENTERED IN ELIPSE.
C NGLAYR      = AS NHLAYR, BUT FOR 'GOOD' LAYERS WHETHER THERE WAS AN
C                ASSOCIATED HIT OR NOT.
C
C-----------------------------------------------------------------------
C
C THE NEXT 1400 LOCATIONS USED BY MUREGY (CALCULATES REGION INTERCEPTS).
C
C IREG        = REGION NUMBER.                           )(IN PAIRS,I.E.
C RDOTD       = R.DOT.(DIR. COSINES) FOR EACH INTERCEPT. )( 2 INTERCEPTS
C CINT        = X,Y,Z COORDINATES OF EACH INTERCEPT.     )( PER REGION.
C NFLAG       = USED INTERNALLY BY MUREGY.
C ITEM        = USED INTERNALLY BY MUREGY.
C
C-----------------------------------------------------------------------
C
C THE NEXT 3600 LOCATIONS USED BY MUFFLE, ETC., TO ACCUMULATE
C   QUANTITIES NEEDED FOR CALCULATING CHI-SQUARED. IN THE DESCRIPTION
C   BELOW I,J GO AS FOLLOWS..
C     1   LEFT DRIFT COORDINATE    )  OF 1ST
C     2   RIGHT DRIFT COORDINATE   )  ASSOCIATED
C     3   LONGITUDINAL COORDINATE  )  HIT
C     4    ETC. FOR NEXT ASSOCIATED HIT.
C   K REFERS TO K'TH ASSOCIATED HIT.
C
C EM(I,J)     = 'ERROR MATRIX', I.E. VARIANCE (I=J) OR COVARIANCE (I.NE.
C                J) FOR COORDINATE I,J.
C DALONG(K)   = DISTANCE OF ASSOCIATED HIT K ALONG TRACK.
C DEV(I)      = DEVIATION OF COORDINATE I FROM EXTRAPOLATED INNER
C                DETECTOR TRACK.
C VXYDA(K)    = VARIANCE ON DEVIATION IN XY PLANE FOR HIT K.
C VZDA(K)     = VARIANCE ON DEVIATION IN RZ PLANE FOR HIT K.
C CXYA(K)     = COVARIANCE BETWEEN DEVIATION AND ANGLE IN XY PLANE.
C CZA(K)      = COVARIANCE BETWEEN DEVIATION AND ANGLE IN RZ PLANE.
C INCUT(I)    = .TRUE. IF COORDINATE I IS IN CUT (SEE MUFFLY).
C BADA(I)     = .TRUE. IF COORDINATE I IS BAD.
C G           = INVERSE ERROR MATRIX.
C DEVA        = CORRESPONDING DEVIATIONS.
C IPERM(K)    = USED TO PERMUTE LEFT/RIGHT AMBIGUITIES.
C MWORK       = USED BY MATRIX INVERTING ROUTINE AS WORKING SPACE.
C ITHISA(K)   = HIT NUMBER OF K'TH ASSOCIATED HIT.
C IJA(K)      = INDEX FOR K'TH ASSOCIATED HIT FOR ENTRY IN BANKS 2 & 3.
C EM1         = COPY OF RELEVANT PART OF ERROR MATRIX FOR TEST PURPOSES.
C EMG         = PRODUCT OF ERROR MATRIX AND ITS INVERSE. SHOULD BE UNIT
C                MATRIX. USED FOR TEST PURPOSES.
C ELIPSE      = TEMPORARY STORAGE FOR MULTIPLE SCATTERING ELIPSES.
C INCHAM      = LIST OF INEFFICIENT CHAMBERS ON THIS TRACK.
C INREG       = LIST OF INEFFICIENT REGIONS (PLANES) ON THIS TRACK.
C IAPPRO      = USED AS WORKING SPACE IN MUFFLX.
C HBADCH      = LIST OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C CTDASH(K)   = TRANSVERSE COORD. ESTIMATED FROM I.D. PROJECTION.
C CLDASH(K)   = LONGITUD'L COORD. ESTIMATED FROM I.D. PROJECTION.
C VTDASH(K)   = VARIANCE ON CTDASH.
C VLDASH(K)   = VARIANCE ON CLDASH (FOR K'TH ASSOCIATED HIT).
C
C-----------------------------------------------------------------------
C
C THE NEXT  380 LOCATIONS USED FOR VARIOUS IMPROVEMENTS TO MUFFLE, ETC.
C
C IHTREG      = FOR EACH ASSOCIATED HIT, THE REGION NO. IN WHICH
C               THE HIT OCCURS.
C LAYRAB      = ABSOLUTE NO. OF LAYERS WHICH HAVE ASSOCIATED HITS.
C IEFFRG      = LIST OF REGION NOS. OF THOSE REGIONS WHICH HAVE AN
C               ASSOCIATED HIT.
C   IHTPER = FLAG FOR EACH ASSOCIATED HIT TO TELL IF IT'S TO
C            GO FORWARD INTO THE CHI**2 CALCULATION . ONLY ONE
C            HIT PER LAYER IS TO BE USED ,APART FROM OVERLAP HITS.
C   IHTEMP = LIST OF HITS WHICH ARE TEMPORARILY IN THE HIT PERMUTATION
C            DUE TO OVERLAPS WITH THE CURRENT AMBIGUITYOF ONE OF THE
C            HITS IN IHTPER.
C   IPTEMP =  AS IHTEMP, BUT FOR L/R AMBIGUITIES.
C IOVLAP   =  MATRIX OF OVERLAP HITS. IOVLAP(I,J)=1 MEANS THAT THERE
C             IS AN OVERLAP BETWEEN ASSOCIATED HITS I & J ( I & J BOTH
C             IN THE RANGE 1 TO NTHIS ).
C AAA(K)      = TRANSFORMATION COEFF. A FOR K'TH ASSOCD. HIT.
C BBB(K)      = TRANSFORMATION COEFF. B FOR K'TH ASSOCD. HIT.
C CCC(K)      = TRANSFORMATION COEFF. C FOR K'TH ASSOCD. HIT.
C DDD(K)      = TRANSFORMATION COEFF. D FOR K'TH ASSOCD. HIT.
C
C DOVER, ETC. = STORES QUANTITIES LEFT OVER AFTER LEAVING LAST ABSORBER.
C
C X7          = VALUES OF SPECIAL VARIABLES AFTER LEAD-GLASS BARREL OR
C               YOKE END-PLUG - USED FOR RE-FITTING, ETC.
C
C-------------END OF MACRO CMUFWORK-------------------------------------
C------------START OF MACRO CMUREG--------------------------------------
C
      COMMON /CMUREG/NREGS,XRLO(100),XRHI(100),YRLO(100),YRHI(100),
     * ZRLO(100),ZRHI(100),HRMASK(100),HRFACE(100),HRTYPE(100),
     * HRORI(100),HRFIRS(100),HRLAST(100)
C
C NREGS IS NUMBER OF REGIONS.
C XRLO ETC. ARE REGION BOUNDARIES.
C HRMASK =1 (FACE 1), =2 (FACE 2), =4 (FACE 3), =8 (FACE 4), ETC.
C HRFACE = FACE NUMBER, =1-6 FOR -X,+X,-Y,+Y,-Z,+Z.
C HRTYPE =1, MU CHAMBER SENSITIVE REGION,
C        =2, CONCRETE REGION,
C        =3, IRON REGION,
C        =4, LEAD GLASS. (IRTYPE=4 USED ONLY IN MUFFLD.)
C HRORI  = ORIENTATION OF NORMAL, =1 (|| X), =2 (||Y), =3 (|| Z).
C HRFIRS = FIRST CHAMBER NUMBER.
C HRLAST = LAST CHAMBER NUMBER.
C
C------------END OF MACRO CMUREG----------------------------------------
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
      COMMON /CMUIEV/ IEV,NEV,IRD,KRUN,KREC,
     +                ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                REGZE(60),LOCHRS(60),ABLOCH(60)
      COMMON /CMUPTC/ XEXTRP,YEXTRP,ZEXTRP,VTZCV,LCOVAR
C
      DIMENSION KTYPE(4),KREGN(4)
C
C             CHAMBER RESOLUTIONS PICKED UP FROM /CMUFFL/.
C
C-----------------------------------------------------------------------
C
C             START OF EXECUTABLE STATEMENTS.
C
      IF(NCEPTS.LE.0) RETURN
C
C             SET KDEPTH, WHICH RECORDS HOW MANY REGIONS ONE IS IN
C             AT ANY ONE TIME. NORMALLY THIS IS 0 OR 1 BUT CAN BE
C             UP TO 4 BECAUSE CHAMBER REGIONS ARE ARTIFICIALLY
C             EXTENDED IN MUREG AND CAN THEREFORE OVERLAP.
C
      KDEPTH=0
C
C             CLEAR THE ARRAY STORING THE START AND STOP POSITIONS
C             OF DEAD CHAMBERS AND REGION EDGES USED IN 'LET-OFFS'
C
      CALL VZERO(REGDCE,60)
      CALL VZERO(REGZE,60)
      IDCEP = 1
      IZEP  = 1
C
C-----------------------------------------------------------------------
C START OF MAIN LOOP ---------------------------------------------------
C-----------------------------------------------------------------------
C
C                  LOOK THROUGH INTERCEPTS.
C
      DO 1000  ICEPT = 1,NCEPTS
C
C                  PROPAGATE TO INTERCEPT.
C
        JTYPE=0
        DSTEP=RDOTD(ICEPT)
        IF(ICEPT.GT.1) DSTEP = DSTEP - RDOTD(ICEPT-1)
        IF(KDEPTH.NE.0) GO TO 1010
          GMSTEP=0.
          ABSTEP=0.
          RDSTEP=0.
          DESTEP=0.
          GO TO 1011
C
C                  FIND DENSEST TYPE - JTYPE.
C
 1010   DO 1015  K=1,KDEPTH
          IF( JTYPE.LT.KTYPE(K) ) JTYPE = KTYPE(K)
          IF( JTYPE.EQ.KTYPE(K) ) IRONRG= KREGN(K)
 1015   CONTINUE
C
C           OCTOBER 1983 :  FIX-UP FOR YOKE END PLATES .
C           THEY ARE COMPLETELY DEFINED BY HRFACE/IUNIT(IREGN)=5,6/3  ,
C           SINCE THEY ARE THE ONLY PARTS OF UNIT 3 (= MAGNET * PLINTH)
C           WHICH ARE IN FACES 5 AND 6.
C           IF MOST DENSE REGION IS NOT YOKE END PLATE, CARRY ON.
          IF( JTYPE.NE.3 )  GO TO 1016
C               THE REGION NO. OF THE IRON REGION WAS NOTED ABOVE.
C               NOTE : CAN'T BE IN 2 IRON REGIONS AT SAME TIME.
              IF(HRFACE(IRONRG).NE.5.AND.HRFACE(IRONRG).NE.6)GO TO 1016
                  IF(HUNIT(IRONRG).NE.3)GO TO 1016
                      JCEPT=ICEPT
                      CALL MUENDP(JCEPT,IRONRG,FACSTP)
C
C                        N.B.  DSTEP IS NOT CHANGED.
                      GMSTEP = (FACSTP*DSTEP)*GMG(JTYPE)
                      ABSTEP = (FACSTP*DSTEP)*ABG(JTYPE)
                      RDSTEP = (FACSTP*DSTEP)*RDG(JTYPE)
                      DESTEP = (FACSTP*DSTEP)*DEG(JTYPE)
                      GO TO 1011
 1016     CONTINUE
C
C
        GMSTEP=DSTEP*GMG(JTYPE)
        ABSTEP=DSTEP*ABG(JTYPE)
        RDSTEP=DSTEP*RDG(JTYPE)
        DESTEP=DSTEP*DEG(JTYPE)
 1011   CONTINUE
C+++
C     WRITE(6,8935)JTYPE
C8935 FORMAT(' JTYPE',I5)
C+++
C
C                  CALCULATE ENERGY LOSS,MULTIPLE SCATTERING ETC.
C                  IF THE TRACK STOPS, GO DIRECT TO CALL OF MULOCH
C
        CALL MUFFLS(*99)
C
C-----------------------------------------------------------------------
C
C                  FIND OUT WHAT TYPE OF INTERCEPT.
C
        IREGN=IREG(ICEPT)
        ITYPE=HRTYPE(IREGN)
C                  IS THIS A NEW REGION BOUNDARY?
        IF(KDEPTH.EQ.0) GO TO 1012
        DO 1013 K=1,KDEPTH
          IF( IREGN.EQ.KREGN(K) ) GO TO 1014
 1013   CONTINUE
        GO TO 1012
C IT MUST BE AN EXIT POINT - DELETE REFERENCE AND DECREMENT KDEPTH.
C  (THIS MAY SEEM UNNECESSARILY COMPLICATED BUT WITH OVERLAPPING
C   REGIONS AN EXIT POINT DOES NOT NECCESARILY FOLLOW THE CORRESPONDING
C   ENTRY POINT.)
 1014   JDEPTH=0
        DO 1019 K=1,KDEPTH
          IF(IREGN.EQ.KREGN(K)) GO TO 1019
          JDEPTH=JDEPTH+1
          IF(JDEPTH.EQ.K) GO TO 1019
          KREGN(JDEPTH)=KREGN(K)
          KTYPE(JDEPTH)=KTYPE(K)
 1019   CONTINUE
        KDEPTH=JDEPTH
C+++
C       WRITE(6,1657)            KDEPTH,KREGN,KTYPE
C1657   FORMAT('            KDEPTH,KREGN,KTYPE',I15,2(I15,3I5))
C+++
        GO TO 1000
C
C                  IT IS A NEW REGION - INCREMENT KDEPTH.
C
 1012   IF(KDEPTH.LT.4) GO TO 97
          CALL MUERRY('MUFFLT',KDEPTH,'REGIONS OVERLAPPING TOO MUCH.^')
          GO TO 1000
 97     KDEPTH=KDEPTH+1
        KREGN(KDEPTH)=IREGN
        KTYPE(KDEPTH)=ITYPE
C+++
C       WRITE(6,1656)IREGN,ITYPE,KDEPTH,KREGN,KTYPE
C1656   FORMAT(' IREG,ITYPE,KDEPTH,KREGN,KTYPE',3I5,2(I15,3I5))
C+++
C
C                  GO TO NEXT INTERCEPT IF NOT A CHAMBER REGION.
C
        IF(ITYPE.NE.1) GO TO 1000
C
C-----------------------------------------------------------------------
C
C                  CHAMBER INTERCEPTED.
C
        IFIRST=HRFIRS(IREGN)
        ILAST=HRLAST(IREGN)
        IOR=HRORI(IREGN)
        IFRAME=HFR(IFIRST)
        IFRAML=HFR(ILAST)
C
C******  AS OF 16/03/83 , APPLY SOFTWARE SHIFT TO WIRE POSITION FOR ALL
C******  DATA AFTER BEGINNING OF 1980 :
C
C  FIRST FOR THE LOW EDGE OF THE REGION :
        ISHIFE=0
        IF(IYEAR.GE.1980)ISHIFE=HLSF(4,IFIRST)
        IF(IABS(ISHIFE).GT.300)ISHIFE=0
C**** DON'T APPLY SOFTWARE SHIFTS TO MONTE-CARLO DATA.
        IF(KRUN.EQ.0)ISHIFE=0
C  THEN FOR THE HIGH EDGE OF THE REGION :
        ISHIFL=0
        IF(IYEAR.GE.1980)ISHIFL=HLSF(4,ILAST)
        IF(IABS(ISHIFE).GT.300)ISHIFL=0
C**** DON'T APPLY SOFTWARE SHIFTS TO MONTE-CARLO DATA.
        IF(KRUN.EQ.0)ISHIFL=0
C
C
C  FOR CALCULATION OF ANGLE CORRECTION OF FRAME POSITION WITH "Z" :
C  LOW EDGE OF REGION :
        IANGE=HANG(IFRAME)
C  HIGH EDGE OF REGION :
        IANGL=HANG(IFRAML)
C  ASSUME THAT FRAMES IN ANY REGION HAVE SAME END POSITIONS :
        ZMID=0.5*( HCLLO(IFRAME) + HCLHI(IFRAME) )
        ZHAF=0.5*( HCLHI(IFRAME) - HCLLO(IFRAME) )
C
        IOVALL=HOVALL(HUNIT(IFRAME))
        LINC=2
        IF( HLAYER( HFR( IFIRST) ).EQ.1 ) LINC = 1
C
C                  WAS THERE A HIT IN THIS REGION?
C
        DO 1022 I=1,LAYRAB
          IF( IREGN.EQ.IEFFRG(I) ) GO TO 1023
 1022   CONTINUE
        GO TO 1024
C
C-----------------------------------------------------------------------
C
C AT LEAST ONE HIT HAS BEEN FOUND FOR THIS TRACK IN THIS REGION.
C UPDATE SPECIAL VARIABLES, BUT NOT IF THERE HAS BEEN MORE THAN 1
C   INEFFICIENCY PRIOR TO THIS.
C
 1023   IF(INEFF.LE.1) CALL UCOPY(X,X0,NSPECI)
C
C INCREMENT NHLAYR , DEPENDING ON LAYER AS FOLLOWS:
C  IF THIS IS A LAYER 1 HIT , INCREMENT =1 ; IF IT'S ANY OTHER
C  LAYER , INCREMENT = 2.  THEN , IF SUM OF NHLAYR IS ODD, THE
C  TRACK IS KNOWN TO HAVE AN INNER LAYER HIT ASSOCIATED.
C
        INFLAG=0
        NHLAYR=NHLAYR+LINC
        GO TO 4000
C
C-----------------------------------------------------------------------
C
C NO HIT IN THIS CHAMBER REGION - SEARCH FOR A REASON.
C
C***********************************************************************
C FROM HERE TO NEXT ROW OF STARS IS A TEMPORARY MEASURE. ULTIMATELY
C   THE RESULTS OF RE-FITTING THE MUON HITS (MUFFLR) WILL BE USED TO
C   ESTIMATE THE TRACK UNCERTAINTIES.
C
C ADD MULTIPLE SCATTERING AND TRACK FITTING ERRORS TO PRODUCE VARIANCES
C   ON DEVIATIONS AND COVARIANCES BETWEEN ANGLES AND DEVIATIONS
C   NORMAL TO TRACK IN THE 2 PLANES (THE A- * B-PLANES OF JADE NOTE 68.
C   NOTE THAT THE A-PLANE GETS THE LABEL 'Z' * THE B-PLANE 'XY' HERE.)
C
 1024 IF( LCOVAR ) GOTO 995
         VZP = VTZD + VTZANG*(D-DTC)**2
         VZD = VMSD + VZP
         CZ  = CMS + VTZANG*(D-DTC)
         GOTO 996
 995  CONTINUE
         R0P = SQRT(X**2 + Y**2)
         VZP = VTZD + 2.0*R0P*VTZCV + R0P**2*VTZANG
         VZD = VMSD + VZP
         CZ  = CMS + (R0P*VTZANG+VTZCV)/COSEC
C
CCC   VXYD  = VMSD + VTXYD + VTXYAN*(D-DTC)**2
 996  DFXY2 = (X-XEXTRP)**2 + (Y-YEXTRP)**2
      VXYP  = VTXYD + VTXYAN*DFXY2
      VXYD  = VMSD + VXYP
CCC   CXY   = CMS + VTXYAN*(D-DTC)*COSEC
      CXY   = CMS + VTXYAN*SQRT(DFXY2)
C+++
C     WRITE(6,7491)VMSD,CMS,VZP,VZD,CZ,VXYP,CXY
C7491 FORMAT(' MUFFLT: VMSD,CMS,VZP,VZD,CZ,VXYP,CXY',/7G15.5)
C+++
C
C NOW PREPARE COEFFICIENTS FOR PROJECTING ONTO CHAMBER PLANES.
C
        IF(IOR.EQ.3) GO TO 1003
        AA=-COSEC
        CC=0.
        IF(IOR.EQ.2) GO TO 1005
        BB=DCY*DCZ*COSEC/DCX
        DD=1./(DCX*COSEC)
        GO TO 1002
C
 1005   BB=-DCX*DCZ*COSEC/DCY
        DD=-1./(DCY*COSEC)
        GO TO 1002
C
 1003   AA=DCY*COSEC/DCZ
        BB=DCX*COSEC
        CC=DCX*COSEC/DCZ
        DD=-DCY*COSEC
 1002   CONTINUE
C+++
C       WRITE(6,2398)AA,BB,CC,DD
C2398   FORMAT(' AA,BB,CC,DD',4G15.5)
C+++
C
C WORK OUT VARIANCES IN DRIFT (TRANSVERSE) AND WIRE (LONG.) DIRECTIONS.
C
        VL1  = AA**2*VZD+BB**2*VXYD
        VT1  = CC**2*VZD+DD**2*VXYD
C       CTL1 = AA*CC*VZD+BB*DD*VXYD
C+++
C       WRITE(6,2399)VL1,VT1,CTL1
C2399   FORMAT(' VL1,VT1,CTL1',3G15.5)
C+++
C***********************************************************************
C
C PREPARE DEVIATIONS. PROJECT TO MEAN CHAMBER PLANE.
C
        D1MEAN=0.5*(HD1(IFIRST)+HD1(IFIRST+1))
        GO TO (2101,2102,2103),IOR
C
 2101   DDC=(HDIST(IFRAME)+D1MEAN+IOVALL-X)/DCX
        CT=DCY*DDC+Y
        CL=DCZ*DDC+Z
        GO TO 2200
C
 2102   DDC=(HDIST(IFRAME)+D1MEAN-Y)/DCY
        CT=DCX*DDC+X
        CL=DCZ*DDC+Z
        GO TO 2200
C
 2103   DDC=(HDIST(IFRAME)+D1MEAN-Z)/DCZ
        CT=DCX*DDC+X
        CL=DCY*DDC+Y
C
C
C-----------------------------------------------------------------------
C
C  FIRST , LOOK TO SEE IF THE EDGE OF THE SENSITIVE REGION OF THIS
C  FRAME IS WITHIN N*SIGMA(DRIFT)/3*SIGMA(LONGL) OF THE EXTRAPOLATED
C  TRACK (WHERE SIGMA=  SIGMA(TRACK)  * N IS THE FACTOR (SEE CMUFFL)).
C  IF SO,THAT EXPLAINS ABSENCE OF HIT,SO DON'T RECORD AN INEFFICIENCY.
C  ALL 'LET-OFF' CLAIMS ARE CHECKED BY SUBROUTINE MULOCH.
C
 2200   ALLOWT=FACTOR*SQRT(VT1)
        ALLOWL=FACTOR*SQRT(VL1)
        LETDCE = .FALSE.
C
C          CALCULATE ANGLE CORRECTION OF FRAME POSITION WITH TRACK "Z" :
C
        CHAMZ = CL-ZMID
        IF(ABS(CHAMZ).GT.ZHAF)CHAMZ=SIGN(ZHAF,CHAMZ)
        CANGE = CHAMZ*FLOAT(IANGE)/10000.
        CANGL = CHAMZ*FLOAT(IANGL)/10000.
C
CCC     CTLO=HCTLO(IFRAME)
        CTLO=HCTLO(IFRAME)-ISHIFE+CANGE
C THIS NEXT STATEMENT REALLY DOES SAY IFRAML - 'L' FOR 'LAST'.
CCC     CTHI=HCTHI(IFRAML)
        CTHI=HCTHI(IFRAML)-ISHIFL+CANGL
        IFACE  = HFACE(IFRAME)
        IF(IOR.EQ.1) GO TO 2300
        CTLO=CTLO+IOVALL
        CTHI=CTHI+IOVALL
 2300   CLLO=HCLLO(IFRAME)
        CLHI=HCLHI(IFRAME)
C+++
C       WRITE(6,1278)CT,ALLOWT,CTLO,CTHI
C1278   FORMAT(' CT,ALLOWT,CTLO,CTHI',4G15.5)
C       WRITE(6,1279)CL,ALLOWL,CLLO,CLHI
C1279   FORMAT(' CL,ALLOWL,CLLO,CLHI',4G15.5)
C+++
        IFAZ = 1
        IF(CL+ALLOWL.LT.CLHI ) GO TO 3008
          REGZE(IZEP)   = IREGN
          REGZE(IZEP+1) = AB
          IF(IFACE.EQ.6) IFAZ = -1
          RZE1          = IFAZ * (CLHI-CL) /SQRT(VL1)
          RZE2          = IFAZ * (CLHI+5000-CL) /SQRT(VL1)
          REGZE(IZEP+2) = AMIN1(RZE1,RZE2)
          REGZE(IZEP+3) = AMAX1(RZE1,RZE2)
          IZEP  = IZEP + 4
          LETDCE = .TRUE.
          IFAZ = 1
 3008   IF(CL-ALLOWL.GT.CLLO ) GO TO 3009
          REGZE(IZEP)   = IREGN
          REGZE(IZEP+1) = AB
          IF(IFACE.EQ.5) IFAZ = -1
          RZE1          = IFAZ * (CLLO-CL) /SQRT(VL1)
          RZE2          = IFAZ * (CLLO-5000-CL) /SQRT(VL1)
          REGZE(IZEP+2) = AMIN1(RZE1,RZE2)
          REGZE(IZEP+3) = AMAX1(RZE1,RZE2)
          IZEP  = IZEP + 4
          LETDCE = .TRUE.
C                         WHEN A TRACK CHANGES FACES THE DEVIATIONS
C                         MUST HAVE THE SAME LEFT/RIGHT SIGN CONV.
 3009   IFAS = 1
        IF(IFACE.EQ.2 .OR. IFACE.EQ.3) IFAS = -1
        IF( CT+ALLOWT.LT.CTHI ) GO TO 3003
C
C                       SAVE THE REGION NUMBER AND UPPER AND LOWER
C                       LIMITS OF THE TRUE REGION EDGE IN SIGMA UNITS
C
          REGDCE(IDCEP)   = IREGN
          REGDCE(IDCEP+1) = AB
          RDCE1           = IFAS * (CTHI-CT) /SQRT(VT1)
          RDCE2           = IFAS * (CTHI+5000-CT) /SQRT(VT1)
          REGDCE(IDCEP+2) = AMIN1(RDCE1,RDCE2)
          REGDCE(IDCEP+3) = AMAX1(RDCE1,RDCE2)
          IDCEP  = IDCEP + 4
          LETDCE = .TRUE.
 3003   IF( CT-ALLOWT.GT.CTLO ) GO TO 3007
          REGDCE(IDCEP)   = IREGN
          REGDCE(IDCEP+1) = AB
          RDCE1           = IFAS * (CTLO-CT-5000) /SQRT(VT1)
          RDCE2           = IFAS * (CTLO-CT) /SQRT(VT1)
          REGDCE(IDCEP+2) = AMIN1(RDCE1,RDCE2)
          REGDCE(IDCEP+3) = AMAX1(RDCE1,RDCE2)
          IDCEP  = IDCEP + 4
          LETDCE = .TRUE.
C***********************************************************************
C
C  LOOK FOR DEAD CHAMBER WHICH MIGHT EXPLAIN ABSENCE OF HIT.
C  AT SAME TIME,LOOK FOR NEAREST GOOD CHAMBER SO ITS INEFFICIENCY
C    CAN BE RECORDED (IF THERE WAS NO DEAD CHAMBER NEARBY).
C
 3007   ADTMIN=1.E6
        DO 2500 ICHAM=IFIRST,ILAST
C
C  GET WIRE CTW,FRAME NO. FOR THIS CHAM,ORIENTATION,X OVAL DISP.
C
C
C******  AS OF 16/03/83 , APPLY SOFTWARE SHIFT TO WIRE POSITION FOR ALL
C******  DATA AFTER BEGINNING OF 1980 :
C
          ISHIFT=0
          IF(IYEAR.GE.1980)ISHIFT=HLSF(4,ICHAM)
          IF(IABS(ISHIFT).GT.300)ISHIFT=0
C             **** DON'T APPLY SOFTWARE SHIFTS TO MONTE-CARLO DATA.
          IF(KRUN.EQ.0)ISHIFT=0
CCC       ICWIRE=HCTW(ICHAM)
          ICWIRE=HCTW(ICHAM)-ISHIFT
C
C          CALCULATE ANGLE CORRECTION TO CHAMBER POSITION WITH "Z" :
C
          IFRAME=HFR(ICHAM)
          IANG=HANG(IFRAME)
          ZMID=0.5*( HCLLO(IFRAME) + HCLHI(IFRAME) )
          ZHAF=0.5*( HCLHI(IFRAME) - HCLLO(IFRAME) )
          CHAMZ=CL-ZMID
          IF(ABS(CHAMZ).GT.ZHAF)CHAMZ=SIGN(ZHAF,CHAMZ)
          CANG =CHAMZ*FLOAT(IANG)/10000.
          ICWIRE=ICWIRE+CANG
C
          IF(IOR.GT.1)ICWIRE=ICWIRE+IOVALL
          DT = ICWIRE - CT
          ADT=ABS(DT)
C
C FIND SMALLEST DT AND RECORD CHAMBER NUMBER.
C
          IF(ADT.GE.ADTMIN) GO TO 2461
          ADTMIN=ADT
          JCHAM=ICHAM
C
C CHECK FOR DEAD CHAMBER WITHIN ALLOWT+15CMS OF TRACK. IF FOUND, KEEP
C                                                                GOING.
 2461     IF(HMCSTA(ICHAM).EQ.0) GO TO 2500
C+++
C         WRITE(6,8723)ADT,ALLOWT
C8723     FORMAT(' ADT,ALLOWT',2G15.5)
C+++
          IF(ADT.GT.ALLOWT+150.) GO TO 2500
C
C                       SAVE THE REGION NUMBER,ABSORBER SO FAR AND
C                       THE UPPER AND LOWER LIMITS OF THE DEAD
C                       CHAMBER IN SIGMA UNITS.
C
            LETDCE = .TRUE.
            REGDCE(IDCEP)   = IREGN
            REGDCE(IDCEP+1) = AB
            RDCE1           = IFAS * ( DT - 150. )/SQRT(VT1)
            RDCE2           = IFAS * ( DT + 150. )/SQRT(VT1)
            REGDCE(IDCEP+2) = AMIN1(RDCE1,RDCE2)
            REGDCE(IDCEP+3) = AMAX1(RDCE1,RDCE2)
            IDCEP = IDCEP + 4
C
 2500   CONTINUE
        IF(LETDCE) GO TO 1000
C
C DID NOT FIND EDGE OR DEAD CHAMBER WHICH CAN EXPLAIN ABSENCE OF HIT.
C THEREFORE , MUST HAVE CHAMBER INEFFICIENCY . INCREMENT INEFF.
C ---- BUT KEEP TRACKING !
C
        INFLAG=1
        INEFF=INEFF+1
        IF(INEFF.GT.10) GO TO 4000
        INCHAM(INEFF)=JCHAM
        INREG(INEFF)=IREGN
        GO TO 4000
C
C-----------------------------------------------------------------------
C
C UPDATE A FEW THINGS FOR THIS 'GOOD' CHAMBER LAYER.
C
C
C UPDATE X8, ETC., THE VALUES AT LAST BUT ONE GOOD CHAMBER LAYER.
C
 4000   CALL UCOPY(X9,X8,NSPECI)
C
C UPDATE X9, ETC., THE VALUES AT LAST GOOD CHAMBER LAYER.
C
        CALL UCOPY(X,X9,NSPECI)
        NGLAYR=NGLAYR+LINC
C
 1000 CONTINUE
C
C-----------------------------------------------------------------------
C END OF MAIN LOOP OVER REGIONS. ---------------------------------------
C-----------------------------------------------------------------------
C
C             PERFORM MULOCH - THE MUON 'LET-OFF' CHECK
C
 99   CALL MULOCH
C
      RETURN
      END

C   16/05/87 705201759  MEMBER NAME  TJOCK1   (S)           FORTRAN
      SUBROUTINE TJOCK(COSTHE,XLEN90,XLEN)
C
C SUBROUTINE TO CALCULATE ACTUAL THICKNESS OF ABSORBER IN FRONT OF
C  LEADGLASS BARREL.
C
C    INPUT IS COSTHE=COS(THETA), THETA WITH RESPECT TO BEAM
C
C    OUTPUT IS XLEN, THE ACTUAL RADIATION LENGTH
C    OUTPUT IS XLEN90, CORRESPONDING RAD.LENGTH AT RIGHT ANGLE
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
C
      COMMON /CJTRIG/ PI,TWOPI,PIHALF
C
C RAD.LENGTH FOR RESIN ASSUMED, MEAN OF PLEXIGLAS AND SCINTILLATOR
C
      DATA XRESIN /400./
      DATA XWATER /3610./
      DATA XALUMI /89./
C
C RAD.LENGTH FOR REST OF ABSORB MATERIAL FROM JCN
C THIS VALUE IS ADJUSTED FOR TWO ADDITIONAL LAYERS OF RESIN ABOVE AND
C BELOW THE COIL, EACH 3MM THICK (2 * 0.0075 X0)
C
C    19779-1983 VALUE
      DATA XRESI1 /.3235/
C    19784-1986 VALUE
      DATA XRESI2 /.3860/
C ZDRES IS THICKNESS OF RESIN SEPARATING WINDINGS IN Z-DIRECTION
      DATA ZDRES /1.2/
C----------------
C
      XRESID = XRESI1
      IF(HDATE(6).GT.1983) XRESID = XRESI2
C
      XLEN = 0.
C
      XLH2O = 0.
      XLAL = 0.
      TOTLEN = 77.
C
      COST = COSTHE
      IF(COST.LT.0) COST = - COST
C
C  GET Z-VALUE AT IMPACT ON INSIDE OF COIL, RADIUS IS SET TO 950 MM
C
C
C     WRITE(6,323) COST
323   FORMAT(' TJOCK WITH COST ',E14.6)
C
      IF(COST.LT..00158) GO TO 1050
      THE = ARCOS(COST)
C
C     WRITE(6,331) THE
331   FORMAT(' TJOCK WITH FIRST THE ',E14.6)
C
      THE = PIHALF - THE
      TANTHE = TAN(THE)
      COST1 = COS(THE)
C
      Z = 950. * TANTHE
C
C     WRITE(6,327) Z,TANTHE,THE
327   FORMAT(' TJOCK WITH Z AND TANTHE THE',3E14.6)
C
      IF(Z.GT.1700.) GO TO 9999
C
C GET LOCAL LINE EQUATION. 3 MM RESIN SEPARATES THE COIL WINDINGS. THESE
C ARE DISPLACED WITH RESPECT TO EACH OTHER BY HALF A UNIT
C
C   THE UNIT IN X(Z) IS THEN ZDRES*.5 RESIN, 31 MM AL, .5*ZDRES MM RESIN
C
C   THE LINE EQUATION IS THEN Y = Y0 + A*X
C
      ZUNIT = 31. + ZDRES
      ZFRAC = Z / ZUNIT
      X0 = Z - IFIX(ZFRAC) * ZUNIT
      A = 1./TANTHE
      Y0 = - A*X0
C
C     WRITE(6,344) A,X0,Y0
344   FORMAT(' TJOCK WITH A X0 Y0',3E14.6)
C
C ***********************************
C    GET TOTAL LENGTH
C
      XLOW = X0
      YLOW = 0.
      YUPP = 77.
      XUPP = (YUPP - Y0) / A
      TOTLEN = SQRT((YUPP-YLOW)**2 + (XUPP-XLOW)**2)
C
C     WRITE(6,324) XLOW,XUPP,TOTLEN
324   FORMAT(' TJOCK WITH XLOW XUPP TOTLEN',3E14.6)
C
C
C     LOOP OVER COILWINDINGS
C
      XORI = ZDRES*.5
      YORI = 0.
      XC = XORI + 15.5
      YC = 18.5
C
100   IF(XORI.GT.XUPP) GO TO 1000
      CALL LINSQU(Y0,A,XORI,YORI,FLEN)
      XLAL = XLAL + FLEN
      CALL LINCIR(Y0,A,XC,YC,FLEN)
      XLH2O = XLH2O + FLEN
C
      YORI = YORI + 40.
      YC = YC + 40.
      XORI = XORI - ZUNIT*.5
      XC = XC - ZUNIT*.5
      CALL LINSQU(Y0,A,XORI,YORI,FLEN)
      XLAL = XLAL + FLEN
      CALL LINCIR(Y0,A,XC,YC,FLEN)
      XLH2O = XLH2O + FLEN
C
      XORI = XORI + ZUNIT*1.5
      XC = XC + ZUNIT*1.5
      YORI = YORI - 40.
      YC = YC - 40.
      GO TO 100
C###################################
1000  CONTINUE
      XRES = TOTLEN - XLAL - 3.
      XLAL = XLAL - XLH2O
C
      XLEN = XLAL/XALUMI + XLH2O/XWATER + XRES/XRESIN
C
C     WRITE(6,325) XRES,XLAL,XLH2O,XLEN
325   FORMAT(' TJOCK WITH XRES XLAL XLH2O XLEN ',4E14.6)
C
C
C  XLEN IS LENGTH AT CERTAIN DIRECTION. GET CORRESPONDING LENGTH AT
C  RIGHT ANGLE
C
      XLEN1 = XLEN * COST1
      GO TO 1100
1050  XLEN1 = 74./XRESIN
      XLEN = 74./XRESIN
C
C  ADD THE RESIDUAL RADIATION LENGTH FROM CONSTANT THICKNESS MATERIALS
C
1100  XLEN2 = XLEN1 + XRESID
      XLEN3 = XLEN + XRESID
C
C     WRITE(6,326) XLEN,XLEN1,XLEN2,XLEN3
326   FORMAT(' TJOCK WITH XLEN XLEN1-3 AT END ',4E14.6)
C
      XLEN90 = XLEN2
      XLEN = XLEN3
C
9999  CONTINUE
      RETURN
      END
      SUBROUTINE LINSQU(Y0,A,XORI,YORI,FLEN)
C
C  CALCULATE LENGTH OF LINE Y = Y0 + A*X INSIDE THE RECTANGLE WITH
C  BOTTOM LEFT CORNER AT XORI, YORI  AND SIDE LENGTHS 31 (X) AND 37 (Y)
C
      FLEN = 0.
C
C     WRITE(6,1541) Y0,A,XORI,YORI
1541  FORMAT(' LINSQU WITH Y0 A X-YORI ',4E14.6)
C
C-----------------
C      CUT SIDE 1 ?
C
      Y1 = YORI
      X1 = (Y1 - Y0)/A
      IF(X1.GE.XORI.AND.X1.LE.XORI+31.) GO TO 100
C
C-----------------
C      CUT SIDE 2 ?
C
      X1 = XORI
      Y1 = Y0 + A * X1
      IF(Y1.GE.YORI.AND.Y1.LE.YORI+37.) GO TO 100
C
C
C     WRITE(6,1542) Y0,A,XORI,YORI
1542  FORMAT(' LINSQU EXIT WITHOUT HIT ',4E14.6)
C
      GO TO 999
C
100   CONTINUE
C-----------------
C      CUT SIDE 3 ?
C
      Y2 = YORI + 37.
      X2 = (Y2 - Y0)/A
      IF(X2.GE.XORI.AND.X2.LE.XORI+31.) GO TO 200
C
C-----------------
C      CUT SIDE 4 ?
C
      X2 = XORI + 31.
      Y2 = Y0 + A * X2
      IF(Y2.GE.YORI.AND.Y2.LE.YORI+37.) GO TO 200
C
      WRITE(6,6777) X0,A,XORI,YORI
6777  FORMAT(' LINSQU ERROR: X0 A XORI,YORI ',4E14.6)
      GO TO 999
C
200   CONTINUE
      FLEN = SQRT((Y2-Y1)**2 + (X2-X1)**2)
C
C     WRITE(6,1543) FLEN,Y2,Y1,X2,X1
1543  FORMAT(' LINSQU EXIT WITH FLEN Y2-1 X2-1',5E14.6)
C
999   CONTINUE
      RETURN
      END
      SUBROUTINE LINCIR(Y0,A,XC,YC,FLEN)
C
C  CALCULATE LENGTH OF LINE Y = Y0 + A*X INSIDE THE CIRCLE WITH
C  CENTER AT XC,YC  AND RADIUS 10 MM
C
      FLEN = 0.
C
      FA = 1. + A*A
C
      FQ = XC**2 + (Y0-YC)**2 - 100.
      FQ = FQ / FA
C
      FP = (A*Y0 - XC - A*YC)/FA
C
      D = FP**2 - FQ
      IF(D.LE.0.) GO TO 999
C
C     D > 0, THERE ARE TWO REAL CROSS POINTS
C
      DSQ = SQRT(D)
      X1 = -FP + DSQ
      X2 = -FP - DSQ
      Y1 = Y0 + A*X1
      Y2 = Y0 + A*X2
C
      FLEN = SQRT((Y2-Y1)**2 + (X2-X1)**2)
C
999   CONTINUE
      RETURN
      END

C   06/01/83 311291231  MEMBER NAME  FCRANG   (S)           FORTRAN
      FUNCTION FCRANG(COSTH,A,B)
C
C
      FCRANG=0.
      IF(COSTH.LT.0. .OR. COSTH.GT.1.) RETURN
C
      FCRANG=(1.-A)*EXP(B*(COSTH-1.))+A
C
      RETURN
      END

C   19/02/84 402192309  MEMBER NAME  RDINEF   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDINEF( EPS, NHITS, HITS, IERASE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    25/04/79 :  SIMULATE WIRE INEFFICIENCIES
C
C   LAST MOD: E. ELSEN    18/05/81 :
C
C     SET SOME DRIFT WIRES IN ARRAY HITS WITH NHITS HITS TO
C     ZERO TO ACOUNT FOR EFFICIENCIES EPS(I) IN RING I.
C     NUMBER OF EREASED HITS IS IERASE.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION EPS(3), HITS(2)
C
C------------------  C O D E  ------------------------------------------
C
      IERASE = 0
      IF( NHITS .LE. 0 ) RETURN
      IF( EPS(1)*EPS(2)*EPS(3) .GT. .999 ) RETURN
C
C    LOOP OVER ALL HITS AND ZERO SOME RANDOM WIRES
C
      N4 = NHITS*4 - 3
      DO 1000 J = 1, N4, 4
      IF( HITS(J) .EQ. 0 ) GO TO 1000
          IR = MIN0( HITS(J)/3072 + 1, 3 )
      IF( RN(DUM) .LE. EPS(IR) ) GO TO 1000
      HITS(J) = 0
      IERASE = IERASE + 1
 1000 CONTINUE
      RETURN
      END

C   05/12/84 412051658  MEMBER NAME  TAGPHI   (S)           FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      FUNCTION TAGPHI(I)
C
C
C   CALCULATE THE AZIMUTHAL ANGLE PHI OF THE CENTRE
C   OF A BLOCK WITH ADC SOFTWARE ADDRESS I
C
C   VALID FOR 1983 -->  DETECTOR ONLY
C
C
C
C-----------------------  C O D E  -----------------------------------
C
      DATA PIBY4 / 0.785398163 /
      DATA PIBY8 / 0.392699081 /
C
      ISAVE = I
C
C
      IF ( (I .GE.  1) .AND. (I .LE.  6) ) J = I + 2
      IF ( (I .GE.  7) .AND. (I .LE.  8) ) J = I - 6
      IF ( (I .GE.  9) .AND. (I .LE. 14) ) J = I + 2 -  8
      IF ( (I .GE. 15) .AND. (I .LE. 16) ) J = I - 6 -  8
      IF ( (I .GE. 17) .AND. (I .LE. 22) ) J = I + 2 - 16
      IF ( (I .GE. 23) .AND. (I .LE. 24) ) J = I - 6 - 16
      IF ( (I .GE. 25) .AND. (I .LE. 26) ) J = I + 6 - 24
      IF ( (I .GE. 27) .AND. (I .LE. 32) ) J = I - 2 - 24
      IF ( (I .GE. 33) .AND. (I .LE. 34) ) J = I + 6 -  8 - 24
      IF ( (I .GE. 35) .AND. (I .LE. 40) ) J = I - 2 -  8 - 24
      IF ( (I .GE. 41) .AND. (I .LE. 42) ) J = I + 6 - 16 - 24
      IF ( (I .GE. 43) .AND. (I .LE. 48) ) J = I - 2 - 16 - 24
C

      TAGPHI = (J * PIBY4) - PIBY8
C
      I = ISAVE
      RETURN
      END

C   06/11/87 711061733  MEMBER NAME  TPTRCB   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTRCB
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       6/11/87:  Do PATR to VECT connection
C
C
C     Routine to perform PATR to VECT connection if needed.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  MC

      INTEGER  IERR

C------------------  C O D E  ------------------------------------------

C                            Is this a MC event?

      CALL TPMC( MC )

C                            If MC then do traceback link.

      IF( MC ) THEN

        CALL BMLT( 1, 'TR4V' )
        CALL BDLM
        CALL MCTR4V( 0, IERR )

        IF( IERR .NE. 0 ) THEN
          CALL TPERRH
        ENDIF

        CALL TPDIAG()

      ENDIF


      RETURN
      END

C   07/06/96 606071854  MEMBER NAME  LSBCOM   (S4)          FORTG1
      SUBROUTINE LSBCOM
C
C     EXAMPLE FOR INPUT AND OUTPUT OF LSB-RECORDS
C
C
C
           COMMON/BCS/IW(10000)
C          CALL BINT(10000,4000,500,0)
C     C
C     C    INPUT OF ONE EVENT
C     C
           NREC=0
           CALL BRDO(1,1610,10)
C10        IF(IUHR(5).EQ.2) GOTO 50
  10       CALL BRDS(1,NBUFL,INIR)
           IF(INIR.EQ.0) GOTO 20
           CALL BFRD(1,IW(INIR),IW(INIR+1))
           IF(IW(INIR).LT.0) GOTO 50
           NREC=NREC+1
           GOTO 10
 20        CONTINUE
C     C
C     C    ANALYSE EVENT
C     C
C          CALL PRIBLO(2)
C     C
C     C    WRITE ONE EVENT
C     C
C          CALL BSLW
C       30 CALL LSBOUT(NTOT,INIW,&40)
C          CALL FWRT(2,NTOT,IW(INIW))
C          GOTO 30
C       40 CONTINUE
C    C
C    C     DELETE BANKS FROM LAST EVENT
C    C
           CALL BDLG(IGA)
C          CALL BSLT
C          CALL BDLM
C          CALL BGAR(IGA)
           GOTO 10
C    C
C    C     WRITE BUFFER
C    C
 50        CALL BMLT(0,BLA)
C          CALL LSBOUT(NTOT,INIW,&60)
C          CALL FWRT(2,NTOT,IW(INIW))
C       60 CONTINUE
C    C
C    C     FINAL STATISTIC AND END
C    C
C          CALL BSTA
C      100 CONTINUE
C          STOP
C          END
      WRITE(6,101) NREC
      RETURN
  101 FORMAT(1X,I8,' RECORDS INPUT'/)
      END

C   26/10/82         8  MEMBER NAME  KALIBR01 (JADEGS)      FORTRAN
      SUBROUTINE KALIBR
      IMPLICIT INTEGER*2 (H)
C--- **************************************************************
C--- ******************* VERSION FOR NOZAKIS NEW JET CONSTANTS ****
C--- **************************************************************
C---
C---     TEMPORARY KLUGE TO PUT IN SOMEWHAT BETTER CALIBRATION DATA
C---     IN THE CASE OF REAL DATA THAN THE MONTE CARLO VALUES. THE
C---     "TWISTING ANGLE" IS LEFT AT 20 DEGREES FOR THE TIME BEING
C---     BUT ITS SIGN IS REVERSED COMPARED TO THE MONTE CARLO CONVEN-
C---     TION IN ORDER TO CONFORM TO THE DATA TAKEN SO FAR, FOR WHICH
C---     THE MAGNETIC FIELD POINTS ALONG THE MINUS Z AXIS. THE TIMING-
C---     BINS-TO-MILLIMETERS CONVERSION FACTORS ARE ALL SET TO 0.382
C---     AND THE EFFECTIVE LENGTH OF THE WIRES TO 2792.9, BOTH VALUES
C---     OBTAINED FROM MR. NOSAKI TODAY.
C---                                   TUESDAY, MARCH 27, 1979
C---                                   L.H. O'NEILL
C---     ADDED: BKGAUS = -4.9          J.OLSSON 2.4.79
C---     DIVIDED TIMDELS BY 64.        L.H. O'NEILL 11 JUNE, 1979.
C---     UPDATED SETTING OF BKGAUS, CALL TO INPATR OUT
C---                                   J.OLSSON 23.6.79
C---
C---     NEW VERSION SETS WIRE STAGGERING TO 200 MICRONS INSTEAD OF
C---     150 AND INCREASES WIRE RADII BY 0.5 MM.
C---
C---                                   L.O'NEILL 02.08.79 14.50
C---     BKGAUS IS TESTED UPON TO INSURE THAT IT IS NEGATIVE
C---                                   J OLSSON 18.08.79
C---     MANY CHANGES IN ALFA AND TZERO VALUES , NOZAKIS NEW CONSTANTS
C---     INTRODUCED 14.9.80                 J.OLSSON
C---     LORENTZ ANGLE VARIES WITH MAGNETC FIELD VALUE IF VARIATION
C---     IF VARIATION > 1%                  P.STEFFEN 81/05/12
C---     YEAR UPDATE FOR RUNS 7417-28       J.OLSSON 81/05/29
C---     29 FEBRUARY UPDATE                 J.OLSSON 81/06/05
C---  NEW 81 RUNS WITH YEAR 0 DISCOVERED, CORRECTED  J.OLSSON 81.06.22
C---
C---     T0 + LORENZ ANGLES FOR 1981              P. STEFFEN 81/10/09
C---
C---  NOZAKI POINTED OUT THAT THE STATEMENT GO TO 8 IS MISSING BETWEEN
C---  1981 AUTUMN AND 1982  T0 SETTING    THIS LEADS TO 1982 CONSTANTS
C---  BEING USED FOR 1981 AUTUMN DATA !!!!
C---  CHANGED THIS EVENING,  12.3.1982     J.OLSSON
C---
C---  E-BEAM SET TO 17300 MEV FOR RUN 11790       P. STEFFEN 82/09/21
C---
C---
C---  NEW TWANG, DRIVELS AND T0 ADDED FOR RUNS > 11036
C---  OLD VERSION RETAINED AS KALIBR0 !!!!
C---                                             G.F.PEARCE 18/05/82
C---
C---  RUNS > 10000 : YEAR FORCED TO 1982
C---                                             P. STEFFEN 82/06/15
C---
C---
C---     T0 FOR 1982 (CORRECTED)                 P. STEFFEN 82/06/21
C---
#include "cdata.for"
#include "cgeo1.for"
#include "cjdrch.for"
C------
      COMMON /CJTRIG/ PI,TWOPI
      COMMON /CALIBR/ IPOINT(100)
      DIMENSION XCAL(1000)
      EQUIVALENCE (IPOINT(1),XCAL(1))
C---
      DATA OKGAUS /9999999./
      DATA TWANG /9999999./
C
C2001 FORMAT('0KALIBR:',10F10.5)
C2901 FORMAT('KALIBR',/,(1X,12F8.5))
C
      IPHEAD=IDATA(IBLN('HEAD'))
      IHHEAD=IPHEAD*2
      NRUN=HDATA(IHHEAD+10)
C---     FIX YEAR SCREW UP.
         IYEAR = HDATA(IHHEAD+8)
         IF(NRUN.LT.  100.AND.IYEAR.EQ.1982) HDATA(IHHEAD+8)=1981
         IF(NRUN.LT.  100.AND.IYEAR.EQ.1982) HDATA(IHHEAD+7)=1
         IF(NRUN.GE. 2570.AND.NRUN.LE.2802) HDATA(IHHEAD+8)=1980
         IF(NRUN.GT. 6000.AND. IYEAR.LT.1981) HDATA(IHHEAD+8)=1981
         IF(NRUN.GT.10000.AND. IYEAR.LT.1982) HDATA(IHHEAD+8)=1982
         IF(HDATA(IHHEAD+8).EQ.1984) GO TO 5410
C FIX 29 FEBRUARY 1981 SCREW UP
         IF(HDATA(IHHEAD+7).NE.2) GO TO 5410
         IF(HDATA(IHHEAD+6).EQ.29) HDATA(IHHEAD+7) = 3
         IF(HDATA(IHHEAD+6).EQ.29) HDATA(IHHEAD+6) = 1
5410     IF(NRUN.EQ.11908) HDATA(IHHEAD+30) = -4848
         IF(NRUN.LT.12255.OR.NRUN.GT.12270) GO TO 5411
C    RESET MAGNETIC FIELD FOR PERIOD WHEN READ OUT SET IT TO 0
         HDATA(IHHEAD+30) = -4847
5411     IF(NRUN.LT.10000.OR.NRUN.GT.12500) GO TO 5408
C        SET BEAM ENERGY FOR RUN 11790
         IF(NRUN.EQ.11790) HDATA(IHHEAD+29) = 17300
      IFIELD = HDATA(IHHEAD+30)
      IF(IABS(IFIELD).LT.100) WRITE(6,5407) NRUN,HDATA(IHHEAD+30)
5407  FORMAT(' * ## ## ## ## *   WARNING: RUN ',I6,' HAS MAGNETIC FIELD
     $ = ',I6,' GAUSS ')
5408  CALL KLREAD(KALRET)
      IF(KALRET.NE.0) STOP
C---
      CALL MUREG(0)
      IF(NRUN.LE.0) RETURN
      BKGAUS = .001*HDATA(IHHEAD+30)
      IF(BKGAUS.GT.0.) BKGAUS = - BKGAUS
      MAGON=1
      IF(ABS(BKGAUS).LT.1.) MAGON=0
C ---
C ---
C ---     SET TZERO PER RING
C ---
C ---
      TZERO(1)=-3.9
      TZERO(2)=-3.9
      TZERO(3)=-3.0
      IF(NRUN.LT.1497) GO TO 1000
      TZERO(1)= 2.4
      TZERO(2)= 2.4
      TZERO(3)= 2.4
      IF(NRUN.LT.1967) GO TO 1000
      TZERO(1)=0.2
      TZERO(2)=0.2
      TZERO(3)=0.2
      IF(NRUN.LT.2521) GO TO 1000
      TZERO(1)=-2.5
      TZERO(2)=-2.5
      TZERO(3)=-2.5
      IF(NRUN.LT.3730) GO TO 1000
      TZERO(1)=-6.1
      TZERO(2)=-6.1
      TZERO(3)=-6.1
      IF(NRUN.LT.6185) GO TO 1000
      TZERO(1)=1.20
      TZERO(2)=1.20
      TZERO(3)=1.20
      IF(NRUN.LT.7592) GO TO 1000
      TZERO(1)=1.45
      TZERO(2)=1.45
      TZERO(3)=1.45
      IF(NRUN.LT.10000) GO TO 1000
      TZERO(1)=3.60
      TZERO(2)=3.60
      TZERO(3)=3.60
      IF(NRUN.LT.10267) GO TO 1000
      TZERO(1)=1.60
      TZERO(2)=1.60
      TZERO(3)=1.60
      IF(NRUN.LT.11038) GOTO 1000
      TZERO(1)=1.80
      TZERO(2)=1.80
      TZERO(3)=1.80
 1000 CONTINUE
C ---
C ---
C ---     SET DRIFT VELOCITIES
C ---
C ---
      DO 2000 I=1,3
      IF(NRUN.GE.6185) GO TO 1100
      RNGTM1=0.3769/64.
      RNGTM2=0.3753/64.
      RNGTM3=0.3826/64.
      GO TO 1200
 1100 IF(NRUN.GE.7592) GO TO 1101
      RNGTM1=0.3784/64.
      RNGTM2=0.3773/64.
      RNGTM3=0.3827/64.
      GOTO 1200
 1101 IF(HDATA(IHHEAD+8).GE.1982) GOTO 1102
      RNGTM1=0.3817/64.
      RNGTM2=0.3799/64.
      RNGTM3=0.3856/64.
      GOTO 1200
 1102 IF(NRUN.GE.11037) GOTO 1103
      RNGTM1=0.3845/64.
      RNGTM2=0.3825/64.
      RNGTM3=0.3882/64.
      GOTO 1200
 1103 CONTINUE
      RNGTM1=0.3813/64.
      RNGTM2=0.3791/64.
      RNGTM3=0.3858/64.
 1200 CONTINUE
      ICLMIN=1+24*(I-1)
      ICLMAX=24*I
      IF(I.EQ.3) ICLMAX=96
C
      TIMDEL(1,1)=RNGTM1
      TIMDEL(2,1)=RNGTM1
      TIMDEL(1,2)=RNGTM2
      TIMDEL(2,2)=RNGTM2
      TIMDEL(1,3)=RNGTM3
      TIMDEL(2,3)=RNGTM3
      DO 2000 K=1,24
         DRIVEL(K   ,1)=RNGTM1
         DRIVEL(K   ,2)=RNGTM1
         DRIVEL(K+24,1)=RNGTM2
         DRIVEL(K+24,2)=RNGTM2
         DRIVEL(K+48,1)=RNGTM3
         DRIVEL(K+48,2)=RNGTM3
         DRIVEL(K+72,1)=RNGTM3
         DRIVEL(K+72,2)=RNGTM3
 2000 CONTINUE
C ---
C ---
C ---  SET NOMINAL LORENTZ ANGLE + MAGNETIC FIELD
C ---
C ---
C
      IF(NRUN.GE.3730)GOTO2100
      TWANG=18.5
      AKGAUS =-4.50
      IF(NRUN.GE.2521) TWANG=19.5
      GOTO 3000
C
 2100    AKGAUS =-4.82
         TWANG=21.0
         IF(NRUN.LT.6185) GOTO 3000
         IF(NRUN.GE.6185) TWANG=20.5
         IF(NRUN.GE.7592) TWANG=19.5
         IF(HDATA(IHHEAD+8).GE.1982) TWANG = 20.5
      IF(NRUN.GE.11037) TWANG=21.25
 3000 CONTINUE
      DRIDEV=-MAGON*TWANG*PI/180.

C
C     CHECK IF CHANGE OF MAG. FIELD
      DALF = 0.
      IF(BKGAUS.EQ.OKGAUS) GOTO 10
         OKGAUS = BKGAUS
         IF(ABS((BKGAUS-AKGAUS)/AKGAUS).LT..01) GOTO 10
         DALF = ASIN(SIN(DRIDEV)*BKGAUS/AKGAUS) - DRIDEV
   10 CONTINUE
C     PRINT 2001, OKGAUS,BKGAUS,AKGAUS,DRIDEV,TWANG,TWANG0,DALF
C
C     CHECK IF ANY CHANGE IN LORENTZ ANGLE
      IF(TWANG.EQ.TWANG0 .AND. DALF.EQ.0.) GOTO 20
      TWANG0 = TWANG
C
         DRIDEV=-MAGON*TWANG*PI/180. + DALF
         DRISIN=SIN(DRIDEV)
         DRICOS=COS(DRIDEV)
         ANGLOR = TWANG*PI/180. - DALF
C        PRINT 2001, DRIDEV,DRISIN,DRICOS,TWANG,DALF
C
         IPCAL = IPOINT(5)
         IPCAL = IPCAL + 960
         DO 2 J=1,96
            ALFCOR = XCAL(IPCAL+J)
            ANGLR1 = ANGLOR + ALFCOR
            ANGLR1= - MAGON*ANGLR1
            SINLOR=SIN(ANGLR1)
            COSLOR=COS(ANGLR1)
            DRIROT(J,1)=ANGLR1
            SINDRI(J,1)=SINLOR
            COSDRI(J,1)=COSLOR
            DRIROT(J,2)=ANGLR1
            SINDRI(J,2)=SINLOR
            COSDRI(J,2)=COSLOR
    2    CONTINUE
   20 CONTINUE
C
      ZAL=2792.9
      FIRSTW(1)=206.50
      FIRSTW(2)=416.50
      FIRSTW(3)=627.83
      FSENSW(1)=211.50
      FSENSW(2)=421.50
      FSENSW(3)=632.83
      ABERR(1) = 0.000217
      ABERR(2) = 4.0
      ABERR(3) = 6.8
      ABERR(5) = .048
      ABERR(6) = .000167
      ABERR(7) = 15.0
      ABERR(8) = 1.0
      IF(MAGON.EQ.0) ABERR(2) = 5.
      IF(MAGON.EQ.0) ABERR(3) = 5.
C
C     PRINT 2901,TIMDEL,DRIDEV,DRISIN,DRICOS
C     PRINT 2901,DRIVEL
C     PRINT 2901,DRIROT,SINDRI,COSDRI
C
      RETURN
      END

C   30/01/79 C9101501   MEMBER NAME  LGDCPF   (SOURCE)      FORTRAN
      SUBROUTINE LGDCPF( NP, LGER1)
C
C     S.YAMADA     26-01-79  17:30
C     LAST MODIFICATION  30-01-78  21:35
C
C---- VERSION FOR BOS DATA.  COMPATIBLE WITH THE FINAL NORD-DATA-FORMAT
C
C---- COPIES RAW DATA FROM 'ALGN' TO /CWORK/.
C     BOTH FORMAT CONVERSION AND CALIBRATION ARE SUPPOSED TO BE DONE.
C
C---- OUTPUT:   NP=THE POINTER TO THE 'ALGN'-BANK.
C               LGER1=ERROR CODE,(=0 IF NO ERROR)
C
      IMPLICIT INTEGER *2 (H)
      COMMON /CDATA/ ID(6000)
      INTEGER *2 HD(12000)
      EQUIVALENCE (HD(1),ID(1))
C
#include "clgwork1.for"
      DATA JMAX/4000/
C
      COMMON /CMSGCT/ MSGDUM(10),LGMMAX,LGMSG1,LGMSG2,LGMSG3,LGMSG4
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/179012617/
      NVRSN(1) = NVCODE
C
C---- LOOK FOR THE POINTER OF THE LG-DATA
      LNG = 0
      LGER1 = 0
      NP = ID(75)
      IF(NP.LT.100) GO TO 90
C
C---- FOR THE INPUT DATA ID(NP)=# OF DATA IN HBD INCLUDING SUB-POINTERS
C     AND THE NORD-STATUS WORD.
      LNG = ID(NP)
      NNP = NP+NP
C
C---- EXAMINE IF FORMAT CHANGE IS ALREADY DONE.
C---- ONE CAN ALSO CHECK HBD(HNP+1)
C
      IF(HD(NNP+1)-100) 91,200,200
C
C---- FORMAT IS ALREADY CHANGED.
C     DATA IS SIMPLY COPIED  AFTER THE LENGTH CHECK.
  200 LNGC = 4*LNG
      IF(LNGC.LE.8012) GO TO 201
      LNGC = 8012
  201 CALL MVCL(HNORD,0,HD,4*NP,LNGC)
      IF(2003-LNG) 92,100,100
C
C---- ERROR
   90 LGER1 = 1
      MESERR = NP
      GO TO 900
C
   91 LGER1 = 2
      MESERR = HPOINT(1)
      GO TO 900
C
   92 LGER1 = 3
      MESERR = LNG
C
  900 IF(LGMSG1) 100,901,901
  901 LGMSG1 = LGMSG1+1
      IF(LGMSG1.LE.LGMMAX) WRITE(6,690) LGER1,MESERR
  690 FORMAT('0 **** ERROR IN LGDCPY ****,LGER1=',I3,'   PARM=',I5)
C
  100 RETURN
      END

C   14/10/82            MEMBER NAME  MEMBERS4 (S)           FORTRAN77
#include "blocda.for"
#include "blocda.for"
#include "binlda.for"
#include "bloada.for"
#include "bunlda.for"
#include "poda.for"
#include "dada.for"
#include "rdda.for"
#include "bpasda.for"
#include "bgar.for"
#include "bint.for"
#include "bdmp.for"

C   19/04/79 606111933  MEMBER NAME  STHEAD1  (S)           FORTRAN
      SUBROUTINE STHEAD( LENGTH, IHEAD )
C-----------------------------------------------------------
C
C  VERSION OF 18/04/79  LAST MOD 03/11/81    E.ELSEN
C     CHANGED TO SET WORD 16 IN HEAD BANK TO 1, TO MARK THE USAGE OF
C     NEW, CORRECTED VERSION OF TRKGAM    SEE JCN NR     .
C                       MOD. 15.2.1986       J.OLSON
C     CHANGED TO SET WORD 18 IN HEAD BANK TO -1, TO MARK IF TRACKING WAS
C     DONE WITHOUT MULTIPLE SCATTERING AND ENERGY LOSS (FLAGS= ELOSS,
C                                                              MULSC)
C     CHANGED TO SET WORD 17 IN HEAD BANK TO 1, IF LFLAG(4)=.TRUE.
C     THIS MARKS THE USE OF MEIER/MAGNUSSEN LEAD GLASS SIMULATION.
C
C                  LAST MOD. 10.06.1986       J.HAGEMANN
C                  LAST MOD. 11.06.1986       J.OLSSON
C
C  SET FIRST 50 WORDS OF BANK 'HEAD', CONTAINING EVENT AND
C  RUN INFORMATION ( SEE JADE COMPUTER NOTE 23 )
C  EXTRA ENTRY LHHEAD RETURN LENGTH ONLY.
C----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
      DIMENSION IHEAD(50)
C
      LOGICAL  ELOSS, MULSC
      COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
C
      LOGICAL*1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
      COMMON / CGEO1 / BKGAUS
      DIMENSION HELP(2)
      EQUIVALENCE (IHELP,HELP(1))
      DATA HRCTYP / 1 /, HROPAT / Z61CC /
      DATA ICALL / 0 /
C
      IF( ICALL .GT. 0 ) GO TO 1
      ICALL = 1
      IPVECT = IBLN('VECT')
    1 CONTINUE
      IBEAM = 0
      NR = 0
      NPVECT = IW(IPVECT)
      IF( NPVECT .LE. 0 ) GO TO 2
      NR = IW(NPVECT+3)
      L0 = IW(NPVECT+1)
      IF( L0 .LE. 12 ) GO TO 2
      IBEAM = IW(NPVECT+13)
    2 CONTINUE
C
C
      CALL DATEMC( IHEAD(2) )
C
      HELP(1) = NR
      HELP(2) = HRCTYP
      IHEAD(6) = IHELP
C
      HELP(1) = HROPAT
      HELP(2) = 0
      IHEAD(7) = IHELP
C
C   NEW TRKGAM MARKER,   SEE JCN NR     .     15.2.1986
C
      HELP(1) = 0
      HELP(2) = 1
      IHEAD(8) = IHELP
C
C   NEW MARKER FOR USE OF MEIER/MAGNUSSEN LG TRACKING     11.06.86
C
      HELP(1) = 0
      IF(.NOT.LFLAG(4)) GO TO 647
      HELP(1) = 1
C
C   NEW MARKER FOR MULTIPLE SCATTERING AND ENERGY LOSS    10.06.86
C
647   HELP(2) = 0
      IF( .NOT.ELOSS .AND. .NOT.MULSC ) HELP(2) = -1
      IHEAD(9) = IHELP
C
      HELP(1) = IBEAM
      HELP(2) = BKGAUS * 1000.
      IHEAD(15) = IHELP
C
C-----------------------------------------------------------
      ENTRY LHHEAD( LENGTH )
C-----------------------------------------------------------
      LENGTH = 100
      RETURN
      END

C   23/05/79 C9052301   MEMBER NAME  PARCHN1  (JADEGS)      FORTRAN
      SUBROUTINE PARCHN
      IMPLICIT INTEGER*2 (H)
C--
C--      ALLOWS SCANNER TO CHANGE MONTE CARLO PARAMETERS.
C--
      LOGICAL FREE
#include "cgraph.for"
#include "cbin.for"
#include "clbpgm.for"
      COMMON/CWORK/HWORK(40),IANSW
      DIMENSION ICBIN(19),ACBIN(19),AFREE(4)
      EQUIVALENCE (ICBIN(1),TIME(1))
      EQUIVALENCE (ACBIN(1),TIME(1))
      DATA AFREE1/'FREE'/
      DATA AFREE2/'    '/
      DATA AFREE3/'FROZ'/
      DATA AFREE4/'EN  '/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
      AFREE(1)=AFREE1
      AFREE(2)=AFREE2
      AFREE(3)=AFREE3
      AFREE(4)=AFREE4
C---
C---     SET FLAG TELLING MONTE CARLO READ TO LOOK AT CBIN CONTENTS.
C---
      IREADM=2
      CALL TRMOUT(80,'M.C. PARAMETER CHANGE ROUTINE.^')
    1 CONTINUE
      LOOP=0
      CALL TRMOUT(80,'PLEASE ENTER INDEX OF PARAMETER TO BE CHANGED.^')
      CALL TRMOUT(80,'ZERO OR RETURN GIVES INDEX KEY.^')
      CALL TRMOUT(80,'MINUS ONE GIVES ALL CURRENT VALUES.^')
      CALL TRMOUT(80,'100 PLUS THE INDEX FREES THE PARAMETER SO THAT^')
      CALL TRMOUT(80,'WHEN CONSTANTS RECORDS ARE ENCOUNTERED THEY SET^')
      CALL TRMOUT(80,'THE PARAMETER.^')
      CALL TRMOUT(80,'200 FREES ALL PARAMETERS.^')
    4 CONTINUE
      INDEX=TERNUM(DUMMY)
      IF(INDEX.NE.200) GO TO 15
      IREADM=1
      DO 16 I=1,19
      FREEZE(I)=.FALSE.
   16 CONTINUE
      CALL TRMOUT(80,'ALL PARAMETERS FREED.^')
      RETURN
   15 CONTINUE
      FREE=.FALSE.
      IF(INDEX.GT.100) FREE=.TRUE.
      IF(FREE) INDEX=INDEX-100
      IF((INDEX.GE.1).AND.(INDEX.LE.23)) GO TO 5
      IF(INDEX.EQ. 0) GO TO 2
      IF(INDEX.EQ.-1) GO TO 6
      CALL TRMOUT(80,'ILLEGAL INDEX. PLEASE ENTER AGAIN.^')
      GO TO 4
    6 CONTINUE
      LOOP=1
      INDEX=1
      GO TO 5
    2 CONTINUE
      CALL TRMOUT(80,' 1 -  6  TIME ARRAY^')
      CALL TRMOUT(80,'      7  ZOF^')
      CALL TRMOUT(80,'      8  ZRS^')
      CALL TRMOUT(80,'      9  ZL^')
      CALL TRMOUT(80,'     10  ZSC^')
      CALL TRMOUT(80,'11 - 13  EPSI ARRAY^')
      CALL TRMOUT(80,'14 - 16  DOUB ARRAY^')
      CALL TRMOUT(80,'17 - 19  IRN ARRAY^')
      CALL TRMOUT(80,'     20  ENTIRE TIME ARRAY^')
      CALL TRMOUT(80,'     21  ENTIRE EPSI ARRAY^')
      CALL TRMOUT(80,'     22  ENTIRE DOUB ARRAY^')
      CALL TRMOUT(80,'     23  ENTIRE IRN ARRAY^')
  101 FORMAT('PARAMETER TIME(1). CURRENT VALUE=',F12.4,'  ',2A4)
  102 FORMAT('PARAMETER TIME(2). CURRENT VALUE=',F12.4,'  ',2A4)
  103 FORMAT('PARAMETER TIME(3). CURRENT VALUE=',F12.4,'  ',2A4)
  104 FORMAT('PARAMETER TIME(4). CURRENT VALUE=',F12.4,'  ',2A4)
  105 FORMAT('PARAMETER TIME(5). CURRENT VALUE=',F12.4,'  ',2A4)
  106 FORMAT('PARAMETER TIME(6). CURRENT VALUE=',F12.4,'  ',2A4)
  107 FORMAT('PARAMETER     ZOF. CURRENT VALUE=',F12.4,'  ',2A4)
  108 FORMAT('PARAMETER     ZRS. CURRENT VALUE=',F12.4,'  ',2A4)
  109 FORMAT('PARAMETER      ZL. CURRENT VALUE=',F12.4,'  ',2A4)
  110 FORMAT('PARAMETER     ZSC. CURRENT VALUE=',F12.4,'  ',2A4)
  111 FORMAT('PARAMETER EPSI(1). CURRENT VALUE=',F12.4,'  ',2A4)
  112 FORMAT('PARAMETER EPSI(2). CURRENT VALUE=',F12.4,'  ',2A4)
  113 FORMAT('PARAMETER EPSI(3). CURRENT VALUE=',F12.4,'  ',2A4)
  114 FORMAT('PARAMETER DOUB(1). CURRENT VALUE=',F12.4,'  ',2A4)
  115 FORMAT('PARAMETER DOUB(2). CURRENT VALUE=',F12.4,'  ',2A4)
  116 FORMAT('PARAMETER DOUB(3). CURRENT VALUE=',F12.4,'  ',2A4)
  117 FORMAT('PARAMETER  IRN(1). CURRENT VALUE=',I12,  '  ',2A4)
  118 FORMAT('PARAMETER  IRN(2). CURRENT VALUE=',I12,  '  ',2A4)
  119 FORMAT('PARAMETER  IRN(3). CURRENT VALUE=',I12,  '  ',2A4)
  120 FORMAT('ARRAY        TIME. ALL VALUES=   ',F12.4,'  ',2A4)
  121 FORMAT('ARRAY        EPSI. ALL VALUES=   ',F12.4,'  ',2A4)
  122 FORMAT('ARRAY        DOUB. ALL VALUES=   ',F12.4,'  ',2A4)
  123 FORMAT('ARRAY         IRN. ALL VALUES=   ',I12,  '  ',2A4)
      CALL TRMOUT(80,'PLEASE ENTER INDEX YOU WISH.^')
      GO TO 4
    5 CONTINUE
      CALL CORE(HWORK,80)
      JNDEX=INDEX
      IF(INDEX.EQ.20) JNDEX=1
      IF(INDEX.EQ.21) JNDEX=11
      IF(INDEX.EQ.22) JNDEX=14
      IF(INDEX.EQ.23) JNDEX=17
      L1=1
      IF(FREEZE(JNDEX)) L1=3
      L2=L1+1
      IF(INDEX.EQ. 1) WRITE(cHWORK,101) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 2) WRITE(cHWORK,102) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 3) WRITE(cHWORK,103) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 4) WRITE(cHWORK,104) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 5) WRITE(cHWORK,105) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 6) WRITE(cHWORK,106) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 7) WRITE(cHWORK,107) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 8) WRITE(cHWORK,108) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ. 9) WRITE(cHWORK,109) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.10) WRITE(cHWORK,110) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.11) WRITE(cHWORK,111) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.12) WRITE(cHWORK,112) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.13) WRITE(cHWORK,113) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.14) WRITE(cHWORK,114) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.15) WRITE(cHWORK,115) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.16) WRITE(cHWORK,116) ACBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.17) WRITE(cHWORK,117) ICBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.18) WRITE(cHWORK,118) ICBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.19) WRITE(cHWORK,119) ICBIN(INDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.20) WRITE(cHWORK,120) ACBIN(JNDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.21) WRITE(cHWORK,121) ACBIN(JNDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.22) WRITE(cHWORK,122) ACBIN(JNDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      IF(INDEX.EQ.23) WRITE(cHWORK,123) ICBIN(JNDEX),(AFREE(L),L=L1,L2)! PMF 17/11/99: UNIT=JUSCRN changed to cHWORK
      CALL TRMOUT(55,HWORK)
      INDEX=INDEX+LOOP
      IF((LOOP.EQ.1).AND.(INDEX.LE.19)) GO TO 5
      IF(LOOP.EQ.1) GO TO 1
      IF(.NOT.FREE) CALL TRMOUT(80,'DO YOU WISH TO CHANGE THIS?^')
      IF(FREE) CALL TRMOUT(80,'DO YOU WISH TO FREE THIS?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.2) GO TO 3
      IF(.NOT.FREE) CALL TRMOUT(80,'ENTER NEW VALUE.^')
      IF(.NOT.FREE) TVAL=TERNUM(DUMMY)
      IF((.NOT.FREE).AND.(INDEX.LE.16)) ACBIN(INDEX)=TVAL
      IF(INDEX.LE.16) FREEZE(INDEX)=.NOT.FREE
      IF((.NOT.FREE).AND.(INDEX.GE.17).AND.(INDEX.LE.19))
     1ICBIN(INDEX)=TVAL
      IF(INDEX.LE.19) GO TO 5
      JNDEX=INDEX-20
      GO TO (8,10,12),JNDEX
      DO 9 IJK=1,6
      IF(.NOT.FREE) TIME(IJK)=TVAL
      FREEZE(IJK)=.NOT.FREE
    9 CONTINUE
      GO TO 5
    8 CONTINUE
      DO 11 IJK=1,3
      IF(.NOT.FREE) EPSI(IJK)=TVAL
      FREEZE(10+IJK)=.NOT.FREE
   11 CONTINUE
      GO TO 5
   10 CONTINUE
      DO 13 IJK=1,3
      IF(.NOT.FREE) DOUB(IJK)=TVAL
      FREEZE(13+IJK)=.NOT.FREE
   13 CONTINUE
      GO TO 5
   12 CONTINUE
      DO 14 IJK=1,3
      IF(.NOT.FREE) IRN(IJK)=TVAL
      FREEZE(16+IJK)=.NOT.FREE
   14 CONTINUE
      GO TO 5
    3 CONTINUE
      CALL TRMOUT(80,'DO YOU WISH TO CHANGE ANOTHER PARAMETER?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 1
C---
C---     BACKSPACE INPUT FILE AND CALL "RDMTCO" AND THE ENTRY "JDJETC"
C---     FOR THE SAME EVENT.
C---
      BACKSPACE NDDINN
      CALL RDMTCO('SE')
      CALL RDJETC
      RETURN
      END

C   17/04/85 504171440  MEMBER NAME  ECAPCY   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE ECAPCY( ADX, ADY, FC )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON       ?    :  DRAW LG ENDCAP DET IN RFI VIEWS
C
C  LAST MOD:   C. BOWDERY  17/04/85 :  COSMETIC CHANGES ONLY
C
C     DRAW LEAD GLASS ENDCAP HARDWARE IN RFI VIEWS
C     FC IS A MAGNIFICATION FACTOR FOR THE USE IN CYLINDER VIEW
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CWORK1 / HWORK(40)
C
#include "cgeo1.for"
#include "cgraph.for"
C
C------------------  C O D E  ------------------------------------------
C
      LLL = 14
      Y1  = 0.0
      Y3  = - BLXY
C
      DO  12  I = 1,6
        Y1 = Y1 + BLXY
        Y3 = Y3 + BLXY
        Y2 = Y1
        Y4 = Y3
        IF( I .NE. 1 ) GO TO 34
        X1 = 2.0*BLXY
        X2 = X1 + 4.0*BLXY + 60.0
        X3 = X1 + 60.0
        X4 = X2
        GO TO 1005
  34    IF( I .NE. 2 ) GO TO 35
        X1 = X1 - BLXY
        X2 = X2 - 60.0
        X3 = - BLXY
        X4 =   BLXY
        Y3 = 2.0*BLXY + 60.0
        Y4 = Y3
        GO TO 1005
  35    IF( ( I .NE. 3 )  .AND.  ( I .NE. 5 ) ) GO TO 36
        X2 = X2 - BLXY
  36    IF( I .EQ. 6 ) X2 = X2 - 2.0*BLXY
C
C                            LEAD GLASS ENDCAPS
C
 1005   CALL DRACAP((ADX+X1)*FC,(ADY+Y1)*FC,(ADX+X2)*FC,(ADY+Y2)*FC,
     +              (ADX-X1)*FC,(ADY-Y1)*FC,(ADX-X2)*FC,(ADY-Y2)*FC,LLL)
        CALL DRACAP((ADX+Y1)*FC,(ADY+X1)*FC,(ADX+Y2)*FC,(ADY+X2)*FC,
     +              (ADX-Y1)*FC,(ADY-X1)*FC,(ADX-Y2)*FC,(ADY-X2)*FC,LLL)
        CALL DRAMOV((ADX+X3)*FC,(ADY+Y3)*FC,(ADX+X4)*FC,(ADY+Y4)*FC,LLL)
        CALL DRAMOV((ADX+Y3)*FC,(ADY+X3)*FC,(ADX+Y4)*FC,(ADY+X4)*FC,LLL)
        IF( I .NE. 1 ) GO TO 32
        CALL DRAMOV((ADX-X3)*FC,(ADY+Y3)*FC,(ADX-X4)*FC,(ADY+Y4)*FC,LLL)
        CALL DRAMOV((ADX+Y3)*FC,(ADY-X3)*FC,(ADX+Y4)*FC,(ADY-X4)*FC,LLL)
        GO TO 12
  32    CALL DRAMOV((ADX-Y3)*FC,(ADY+X3)*FC,(ADX-Y4)*FC,(ADY+X4)*FC,LLL)
        CALL DRAMOV((ADX+X3)*FC,(ADY-Y3)*FC,(ADX+X4)*FC,(ADY-Y4)*FC,LLL)
   12 CONTINUE
C
      RETURN
      END

C   27/04/81 705171421  MEMBER NAME  LGCLWAR  (S)           FORTRAN
      SUBROUTINE USER(INDEX)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C--       SPECIAL VERSION FOR READING EVENTS WITH RESO BANK
C--       DELETE LGCL BANK AND SCALE ALGN WITH LEAKAGE CORRECTION
C--       RECREATE LGCL, UPDATE RESO
C                                                 LAST CHANGE 15.05.87
      IMPLICIT INTEGER*2 (H)
C
      COMMON // BLCOMM(4000)
#include "cgraph.for"
#include "cgeo1.for"
#include "cdata.for"
#include "creso.for"
#include "ctrgmn.for"
#include "cintrg.for"
#include "cextra.for"
#include "cpoint.for"
      COMMON /CHEADR/ HEAD(108)
      COMMON /CTLIM/ ISECLF
      COMMON /CJTRIG/ PI,TWOPI
      DIMENSION IGG(10),JIGG(10)
      COMMON /CWORK1/ IER,NTRR,TRES(10,60)
      DIMENSION ITRES(10,60),PARX(4,4),P41(4),P42(4)
      EQUIVALENCE (TRES(1,1),ITRES(1,1))
      LOGICAL*1 TEXT
      DIMENSION TEXT(72)
      DATA ICNT4 /0/
C--
C---
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   MUON CHAMBER TRACKING HAS BEEN DONE.
C              9   MUON AND INNER DETECTOR TRACKS HAVE BEEN ASSOCIATED.
C             10   UNUSED
C---
C---     CHECK WHETHER CALL AT END OF JOB
      IF(INDEX.EQ.100) GOTO 9900
C
      GO TO (100,200,300,400,500,600,700,800,900,1000),INDEX
C---
C---     INDEX=0 INITIALIZATION.
C---
C
      DO 99 I = 1,10
      JIGG(I) = 0
99    IGG(I) = 0
      ISECLF = 2
      IRESO = 0
      IVXCOR = 6
      WRITE (6,6666)
6666  FORMAT(' LGCLVAR  VERSION FROM    2.05.87')
C
      READ 7608, TEXT
      WRITE(6,7508) TEXT
7608  FORMAT(72A1)
7508  FORMAT(' ',72A1)
C
      READ 7610, MAXEV1,MAXEV2,HRUNMI,HRUNMX,IHIST,IPRO,IBANK
      WRITE(6,7510) MAXEV1,MAXEV2,HRUNMI,HRUNMX,IHIST,IPRO,IBANK
7610  FORMAT(7I10)
7510  FORMAT(' ',7I10)
      READ 7608, TEXT
      WRITE(6,7508) TEXT
      READ 7611, SCLGC5,SCLGC6
      WRITE(6,7511) SCLGC5,SCLGC6
7611  FORMAT(7F10.3)
7511  FORMAT(' ',7F10.3)
C
C JBWTOR TO ENABLE OPERATOR TO CANCEL IN ORDERED FASHION...
C
      CALL JBWTOR(&2727)
      GO TO 2728
2727  WRITE(6,2729)
2729  FORMAT(' $$$$$$$$   JBWTOR INIT ERROR   $$$$$$$   ')
C     STOP
2728  CONTINUE
      RETURN
C -------------------------------------------------------------------
100   CONTINUE
      JIGG(1) = JIGG(1) + 1
      HRUN = HEAD(18)
      EBM = EBEAM(HRUN)*.001
      EBM3 = EBM/3.
      NRUN = HRUN
      ELCUTT = EBM*.25
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
200   CONTINUE
C                                    SELECT EVENT
C
C CHECK IF OPERATOR ISSUED STOP OF JOB
C
      CALL JBWTOR(&3454)
C
      JIGG(2) = JIGG(2) + 1
      HEVENT = HEAD(19)
C
      IF((JIGG(2)/500)*500.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' -*-*-*-*-*-*-*-*-*-*- RECORD RUN EVENT ',3I8)
C
      IF(HRUN.LT.HRUNMI) GO TO 7171
      IF(JIGG(2).LT.MAXEV1) GO TO 7171
      IF(HRUN.GT.HRUNMX) GO TO 7171
      IF(JIGG(2).GT.MAXEV2) GO TO 7171
C
C GET BANK RESO, UPDATE COMMON /CRESO/
C
      IPRESO = IDATA(IBLN('RESO'))
      IF(IPRESO.GT.0) GO TO 2007
      ICNT4 = ICNT4 + 1
      IF(ICNT4.LT.10) WRITE(6,2008) HRUN,HEVENT
2008  FORMAT(' WARNING ***** NO RESO BANK, EVENT NOT WRITTEN',2I8)
      GO TO 1
C FILL COMMON /CRESO/
2007  NWRES = IDATA(IPRESO)
      NWRES4 = 4*IDATA(IPRESO)
      IPRES1 = 4*IPRESO
      CALL MVCL(ARRESO,0,IDATA,IPRES1,NWRES4)
C               TO        FROM      BYTES
C
C
C  IF NO UNCONVERTED PHOTONS, WRITE EVENT OUT AGAIN
C
      IF(NMOMGM.NE.0) GO TO 967
      WRITE(6,968) HRUN,HEVENT
968   FORMAT(' EVENT WITH NMOMGM ZERO ',2I8)
      GO TO 1
967   ICNV = 0
C
      DO 964  IGM = 1,NMOMGM
      IF(HGMTYP(IGM).EQ.-2) ICNV = ICNV + 1
964   CONTINUE
      IF(NMOMGM.EQ.ICNV) GO TO 11
C
      CALL BDLS('LGCL',1)
C
C  SCALE ALL ENERGIES IN ALGN WITH FACTOR SCLGCL
C
      IALGN=IBLN('ALGN')
      IPJ=IDATA(IALGN)
      IF(IPJ.LE.0) GO TO 1
C
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 1
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
C
      DO 5004 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      IEBLO=HDATA(IJK)
      EBLO = FLOAT(IEBLO)
      ISF6 = 0
      IF(IAD.GT.2687) GO TO 5009
      NFI = IAD/32
      NZ = IAD - NFI*32
      IF(NZ.GE.13.AND.NZ.LE.18) ISF6 = 1
      CALL BBLEAK(NZ,RLEAK)
      EBLO = EBLO/(1.-RLEAK)
C
5009  CONTINUE
      SCALE = SCLGC5
      IF(ISF6.EQ.1) SCALE = SCLGC6
C
      EBLO = SCALE * EBLO
C
      HDATA(IJK) = IFIX(EBLO)
C
5004  CONTINUE
C
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
300   CONTINUE
C                                    LEAD GLASS CALIBRATION DONE
      JIGG(3) = JIGG(3) + 1
C                                                    ******************
C                                                    *  LRJCT = 11-20 *
C                                                    ******************
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
400   CONTINUE
C                                    ZVERTEX CALCULATED
      JIGG(4) = JIGG(4) + 1
C                                                    ******************
C                                                    *  LRJCT = 21-30 *
C                                                    ******************
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
500   CONTINUE
C                                    PATREC PERFORMED
      JIGG(5) = JIGG(5) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
600   CONTINUE
C                                    CLUSTER ANALYSIS PERFORMED
      JIGG(6) = JIGG(6) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
700   CONTINUE
C                                LGCDIR HAS BEEN CALLED
      JIGG(7) = JIGG(7) + 1
C
C LOOP OVER PHOTONS
C
      IPLGCL=IDATA(IBLN('LGCL'))
      IF(IPLGCL.GT.0) GO TO 1233
      WRITE(6,1234) HRUN,HEVENT
1234  FORMAT(' NO LGCL BANK, AFTER DELETE AND NEW ANALYSIS..',2I8)
      GO TO 11
C
1233  CONTINUE
C
      IF(IPRO.GT.0) CALL RESOWR
C
      NCLST = IDATA(IPLGCL+7)
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
C
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
C
C IS THIS A USED CLUSTER
C
      KMOMGM = 0
C
      DO 1006  IK = 1,NMOMGM
      IF(KGGTR(IK).EQ.IGM) KMOMGM = IK
      IF(KGGTR(IK).EQ.IGM) GO TO 1010
1006  CONTINUE
      GO TO 522
C
1010  CONTINUE
C
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
C
      FITRA(NMOMTR+KMOMGM) = FI
      TETRA(NMOMTR+KMOMGM) = THE
      PETRA(NMOMTR+KMOMGM) = PT
      PETOT(NMOMTR+KMOMGM) = PTOT
      DPETOT(KMOMGM) = ADATA(IP+3)
522   CONTINUE
C
      IF(NMOMGM.GT.0) CALL UVXCR1
C
      CALL BDLS('RESO',0)
      CALL RESBNK
C
      IF(IPRO.GT.0) CALL RESOWR
C
      GO TO 11
C -------------------------------------------------------------------
800   CONTINUE
      JIGG(8) = JIGG(8) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
900   CONTINUE
      JIGG(9) = JIGG(9) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
1000  CONTINUE
      JIGG(10) = JIGG(10) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C---     END OF JOB: FINAL CALCULATIONS + PRINTOUT
9900  CONTINUE
      WRITE(JUSCRN,9901) JIGG
      WRITE(JUSCRN,9902) IGG
9901  FORMAT(' JIGG ',12I10)
9902  FORMAT(' IGG ',10I10)
      CALL BSTA
      IF(IHIST.NE.0) CALL HISTDO
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---     'GO TO 11' MEANS ACCEPT EVENT, WRITE IT AND GO TO NEXT EVENT
C---     'GO TO 12' MEANS END THE JOB, WRITE FINAL RESULTS AND PLOTS
C---
1     CONTINUE
7171  INDEX = 1
      RETURN
2     INDEX = 2
      RETURN
3     INDEX = 3
      RETURN
4     INDEX = 4
      RETURN
5     INDEX = 5
      RETURN
6     INDEX = 6
      RETURN
7     INDEX = 7
      RETURN
8     INDEX = 8
      RETURN
9     INDEX = 9
      RETURN
10    INDEX = 10
      RETURN
11    INDEX = 11
      RETURN
3454  CONTINUE
C
C  OPERATOR STOP
C
      WRITE(6,1470)  NNREC
1470  FORMAT(' $ $ $ $ $ $  OPERATOR STOP  $ $ $ $ $  EVENT ',I6)
12    INDEX = 12
      RETURN
      END

C   01/11/84 411011456  MEMBER NAME  RDDOUV   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDDOUV( DIFV, NHITV, HITV, IERASE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 27/06/83 :  SIMULATION OF DOUBLE PULSE
C             R. RAMCKE               RESOLUTION IN VERTEX CHAMBER
C
C   LAST MOD  J. HAGEMANN 01/10/84 :  CHANGED SCALE (DIFV (MM))
C
C      USED FOR DOUBLE PULS RESOLUTION OF THE VERTEX CHAMBER
C      RESOLUTION IS DESCRIBED BY THREE PARAMETERS:
C
C         DIFV(1) = SLOPE OF DOUBLE HIT RESOLUTION
C                   EFFICIENCY DISTRIBUTION
C         DIFV(2) = ALL HITS WITH A DISTANCE LESS
C                   THAN DIFV(1) ARE NOT SEPARATED
C         DIFV(3) = ALL HITS WITH A DISTANCE GREATER
C                   THAN DIFV(3) ARE FULLY SEPARATED
C
C     EFFICIENCY
C     1 I            * * * I * * *
C       I          *     DIFV(3)
C       I         *
C       I        * DIFV(1)
C       I       *
C       I      *
C     0 I*****I------------------------- DISTANCE BETWEEN TWO HITS
C        DIFV(2)
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cjvtxc.for"
C
      DIMENSION HITV(2), HAREA(15), DIFV(3)
C
C------------------  C O D E  ------------------------------------------
C
C                            FUNCTION OF EFFICIENCY DISTRIBUTION
C
      EFF(DR) = 1. - EXP(-A1*(DR - A2))
C
      A1 = 1./DIFV(1)
      A2 = DIFV(2)
C
      IERASE = 0
      IF( NHITV .LT. 2 )  RETURN
C
C                            LOOP OVER ALL HITS AND SET
C                            AFFECTED WIRES TO ZERO
      N4  = NHITV*4
      N44 = N4 - 4
      IL  = 1
C
  100 IF( HITV(IL) .NE. 0 ) GO TO 200
         IL = IL + 4
         IF( IL .LT. N44 ) GO TO 100
            GO TO 2000
C
  200 IH = IL + 4
      ICALL = 0
C
  210 IF( IH .GT. N4 ) GO TO 2000
      IF( HITV(IH) .NE. 0 ) GO TO 300
C
  250 IH = IH + 4
      GO TO 210
C
  300 IF( HITV(IL) .NE. HITV(IH) ) GO TO 600
        ICALL = ICALL + 1
        HAREA(ICALL) = IH
        GO TO 250
  600 IF( ICALL .EQ. 0 ) GO TO 1000
         IDR = HITV(HAREA(1)+3) - HITV(IL+3)
         DR = ABS(FLOAT(IDR))*TIMEV
         IF( DR .GE. DIFV(3) )            GO TO 700
            IF( DR .LT. A2 )              GO TO 650
               IF( RN(DUM) .LE. EFF(DR) ) GO TO 700
  650    HITV(HAREA(1)) = 0
         IERASE = IERASE + 1
  700 IF( ICALL .LT. 2 ) GO TO 1000
         IEND = ICALL - 1
         DO 800 I = 1,IEND
            IDR = HITV(HAREA(I+1)+3) - HITV(HAREA(I)+3)
            DR = ABS(FLOAT(IDR))*TIMEV
            IF( DR .GE. DIFV(3) )            GO TO 800
               IF( DR .LT. A2 )              GO TO 750
                  IF( RN(DUM) .LE. EFF(DR) ) GO TO 800
  750       HITV(HAREA(I+1)) = 0
            IERASE = IERASE + 1
  800 CONTINUE
C
 1000 IL = IL + (1 + ICALL)*4
      GO TO 100
C
 2000 RETURN
      END

C   02/10/78 606101308  MEMBER NAME  JRCHCK9  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JRCHCK( X, P, IRING, IPOS, IRETRN, *, CA, SA, DRMAX)
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    02/01/79 :  CHECKS FRAME CONDITIONS FOR DRIFT
C                                     SPACE IN RING IRING IN JET CHAMBER
C
C        MOD  E. ELSEN    07/10/81 :
C   LAST MOD  J. HAGEMANN 21/09/84 :  NEW VERSION OF SUBROUTINE JRCHCK
C                                     IMPLEMENTED
C
C      IN RING 3 PARAMETER IPOS INDICATES COORDINATE SYSTEM
C      OF PROPAGATION.
C      PARTICLE IS PROPAGATED THROUGH SEPARATING WALL BETWEEN CELLS
C      IN RING 3.
C
C      IRETRN IS RETURN CODE:
C          IRETRN = 0 : NEXT ELEMENT, INCREASING X
C                 = 1 : NEXT ELEMENT, DECREASING X
C                 = 2 : NEXT ELEMENT, INCREASING Z
C                 = 3 : NEXT ELEMENT, DECREASING Z
C                 = 4 : PARTICLE STOPPED IN SYSTEM OR DECAY CONDITION
C                       REACHED.
C                 = 5 : NEXT ELEMENT, CHANGING PHI
C                 = 6 : NEXT ELEMENT, CHANGING PHI TOWARDS THE
C                       NEIGHBORINGSPACE IN SAME CELL
C                       ( ONLY VALID FOR RING THREE ).
C
C      IF PARTICLE IS IN FRAME RETURN ELSE RETURN 1.
C-----------------------------------------------------------------------
C
      COMMON / CJIONI / POTBEA, ZAROBE,
     *                  POTTRI, ZAROTR,
     *                  POTIVE, ZAROIV,
     *                  POTRH0, ZAROR0,
     *                  POTJET, ZAROJE,
     *                  POTRH1, ZAROR1,
     *                  POTRH2, ZAROR2,
     *                  POTRH3, ZAROR3,
     *                  POTOVE, ZAROOV,
     *                  POTTOF, ZAROTO,
     *                  POTVES, ZARVES,
     *                  POTZJL, ZAROJL,
     *                  POTZJR, ZAROJR
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
C
      COMMON / CJXDAT / XSLOPE, YSLOPE, XL(3), XH(3), R3P, RD3P,
     *                  S, S2,
     *                  XSL3L, X3L, XSL3H, X3H, YSL3L, Y3L, YSL3H,
     *                  YHWIDT, SINHLF, COSHLF, DRITAN
C
      DIMENSION X(3), P(7)
C
      DATA EPSIL0, EPSIL1 / 1.E-3 , 5.E-3 /
C
C------------------  C O D E  ------------------------------------------
C
C    -----    CHECK FRAME CONDITIONS    -----
C
   10 IF( IRING .EQ. 3 ) GO TO 110
C
      IF( X(1) .LE. XH(IRING) + EPSIL0 ) GO TO 20
                          IRETRN = 0
                          RETURN 1
   20 IF( X(1) .GE. XL(IRING) - EPSIL0 ) GO TO 30
                          IRETRN = 1
                          RETURN 1
   30 IF( ABS(X(2)) .LE. YSLOPE*X(1)+EPSIL1 ) GO TO 40
                          IRETRN = 5
                          RETURN 1
C
C
  110 IF( IPOS .NE. 0 )  GO TO 210
      IF( X(1) .LE. XSLOPE*ABS(X(2))+R3P + EPSIL0 ) GO TO 120
                          IRETRN = 0
                          RETURN 1
  120 IF( X(1) .GE. XL(3) - EPSIL0 ) GO TO 130
                          IRETRN = 1
                          RETURN 1
  130 IF( ABS(X(2)) .GE. YHWIDT - EPSIL1 ) GO TO 30
            CALL JTRAPZ( 3, X, P, XL(3), R3P, ZJM, ZJP,
     *                   POTRH3, ZAROR3, DR3ROH/XR3ROH, IRETRN,
     *                   CA, SA, DRMAX)
                 IF( IRETRN .EQ. 5 ) RETURN
                 RETURN 1
C
C  PART FOR IPOS .NE. 0
C
  210 IF( X(1) .LE. XSL3H*ABS(X(2)) + X3H + EPSIL0 ) GO TO 220
                               IRETRN = 0
                               RETURN 1
  220 IF( X(1) .GE. XSL3L*ABS(X(2)) + X3L - EPSIL0 ) GO TO 230
                               IRETRN = 1
                               RETURN 1
C
C       -----  RING 3 IPOS NE 0
  230 IF( IPOS .EQ. -1 ) GO TO 250
      IF( X(2) .LE. YSL3H*X(1) + EPSIL1  ) GO TO 240
                               IRETRN = 5
                               RETURN 1
  240 IF( X(2) .GE. YSL3L*X(1) + Y3L - EPSIL0 ) GO TO 40
                               IRETRN = 6
                               RETURN 1
C
C
  250 IF( X(2) .GE. -YSL3H*X(1) - EPSIL1  ) GO TO 260
                               IRETRN = 5
                               RETURN 1
  260 IF( X(2) .LE. -YSL3L*X(1) - Y3L + EPSIL0 ) GO TO 40
                               IRETRN = 6
                               RETURN 1
C
C
C      -----  PART FOR TESTS IN + - Z
   40 IF( X(3) .LE. ZJP ) GO TO 50
                          IRETRN = 2
                          RETURN 1
   50 IF( X(3) .GE. ZJM ) RETURN
                          IRETRN = 3
                          RETURN 1
      END

C   07/06/96 606071909  MEMBER NAME  SMOPER   (S4)          FORTG1
      SUBROUTINE SMOPER(Y,N,IOP)
      REAL Y(N),EP(3,2),ZI(3)
      DIAN3(A,B,C)=AMAX1(AMIN1(A,B),AMIN1(B,C),AMIN1(C,A))
C
C     PERFORM SMOOTHING OPERATIONS ON ARRAY Y( ) OF DIMENSION N.
C     THE FOLLOWING OPERATIONS ARE POSSIBLE.
C
C     OP-CODE          OPERATION
C       1      MED3    REPLACE EACH VALUE BY MEDIAN OF THREE VALUES
C       2      MED5    REPLACE EACH VALUE BY MEDIAN OF FIVE  VALUES
C       3      MED3C   REPLACE EACH VALUE BY MEDIAN OF THREE VALUES,
C                      EXCEPT FIRST AND LAST VALUE
C       4         Q    CORRECT FLAT AREAS OF LENGTH THREE BY
C                      QUADRATIC INTERPOLATION
C       5         F    REPL.EACH VALUE BY AVERAGE OF THREE VALUES (FOLD)
C       6         U    INVERSE OPERATION TO F (UNFOLD)
C       7         MQ   REPL. EACH VALUE BY AVERAGE OF VALUE AND
C                      QUADRATIC FIT VALUE
C       8 = 321        353C COMBINED OPERATION
C       9 = 54321      353CQF COMBINED OPERATION
C
C
C     THE ORDER OF OPERATIONS IS CHOSEN BY ONE INTEGER IOP, CONTAINING
C     THE OP-CODES FROM RIGHT TO LEFT, E.G. 54321 MEANS
C     MED3 FOLLOWED BY MED5, MED3C, Q AND F.
C
C     USAGE          - - ---
C        CALL SMOPER(Y,N,IOP)
C                    -
C     THE VALUE IOP = 54321= 9 IS RECOMMENDED.
C
      JSTE=IOP
   10 LSTE=JSTE/10
      KSTE=JSTE-10*LSTE
      JSTE=LSTE
      IF(KSTE.LE.0.OR.KSTE.GT.9) GOTO 100
      GOTO (20,30,40,50,60,70,80,20,20),KSTE
C
C
C     (1) = MED3
C     REPLACE EACH VALUE BY MEDIAN OF 3 VALUES
C
   20 NM=N-2
      IF(NM.LT.1) GOTO 10
      EP(1,1)=Y(1)
      EP(1,2)=Y(N)
      ZL=Y(1)
      DO 22 I=1,NM
      ZN=DIAN3(Y(I),Y(I+1),Y(I+2))
      Y(I)=ZL
   22 ZL=ZN
      Y(N-1)=ZL
      EP(2,1)=Y(2)
      EP(2,2)=Y(N-1)
      EP(3,1)=3.0*Y(2)-2.0*Y(3)
      EP(3,2)=3.0*Y(N-1)-2.0*Y(N-2)
      Y(1)=DIAN3(EP(1,1),EP(2,1),EP(3,1))
      Y(N)=DIAN3(EP(1,2),EP(2,2),EP(3,2))
      IF(KSTE.EQ.1) GOTO 10
C
C     (2) = MED5
C     REPLACE EACH VALUE BY MEDIAN OF 5 VALUES
C
   30 NM=N-4
      IF(NM.LT.1) GOTO 10
      ZL=Y(1)
      ZN=DIAN3(Y(1),Y(2),Y(3))
      ZE=DIAN3(Y(N-2),Y(N-1),Y(N))
      DO 36 I=1,NM
C
C     MEDIAN OF 5 VALUES
C
      IF(Y(I).GT.Y(I+4)) GOTO 31
      MIN=0
      MAX=4
      GOTO 32
   31 MIN=4
      MAX=0
   32 DO 35 M=1,3
      ZZ=Y(I+M)
      IF(ZZ.GT.Y(I+MIN)) GOTO 33
      ZI(M)=Y(I+MIN)
      MIN=M
      GOTO 35
   33 IF(ZZ.LT.Y(I+MAX)) GOTO 34
      ZI(M)=Y(I+MAX)
      MAX=M
      GOTO 35
   34 ZI(M)=ZZ
   35 CONTINUE
      ZM=DIAN3(ZI(1),ZI(2),ZI(3))
      Y(I)=ZL
      ZL=ZN
   36 ZN=ZM
      Y(N-3)=ZL
      Y(N-2)=ZN
      Y(N-1)=ZE
      IF(KSTE.EQ.2) GOTO 10
C
C     (3) = MED3C
C     REPLACE EACH VALUE BY MEDIAN OF 3 VALUES, COPYING FIRST AND LAST
C
   40 NM=N-2
      IF(NM.LT.1) GOTO 10
      ZL=Y(1)
      DO 42 I=1,NM
      ZN=DIAN3(Y(I),Y(I+1),Y(I+2))
      Y(I)=ZL
   42 ZL=ZN
      Y(N-1)=ZL
      IF(KSTE.NE.9) GOTO 10
C
C     (4) = Q
C     CORRECT FLAT AREAS OF THREE EQUAL VALUES BY QUADRATIC INTERPOL.
C
   50 IA=3
      IB=N-2
      IF(IB.LT.IA) GOTO 10
      DO 52 I=IA,IB
      IF(Y(I).NE.Y(I-1).OR.Y(I).NE.Y(I+1)) GOTO 52
      A=Y(I)-Y(I-2)
      B=Y(I)-Y(I+2)
      IF(A*B.LE.0) GOTO 52
      J=1
      IF(ABS(A).GT.ABS(B)) J=-1
      Y(I-J)=Y(I+J)-0.5*(Y(I+J+J)-Y(I-J-J))
      Y(I)=(8.0*Y(I+J)-3.0*Y(I+J+J)+Y(I-J-J))/6.0
   52 CONTINUE
      IF(KSTE.NE.9) GOTO 10
C
C     (5) = FOLD
C     REPLACE EACH VALUE BY THE AVERAGE OVER 3 VALUES
C
   60 NM=N-2
      IF(NM.LT.1) GOTO 10
      ZL=0.25*(3*Y(1)+Y(2))
      DO 62 I=1,NM
      ZN=0.25*(Y(I)+Y(I+1)+Y(I+1)+Y(I+2))
      Y(I)=ZL
   62 ZL=ZN
      Y(N)=0.25*(3.0*Y(N)+Y(N-1))
      Y(N-1)=ZL
      GOTO 10
C
C     (6) = UNFOLD
C     UNFOLD IS INVERSE OPERATION TO FOLD
C
   70 NM=N-1
      A=1.0
      DO 72 I=1,NM
      B=A+2.0
      Y(I+1)=Y(I+1)-Y(I)*A/B
   72 A=B
      Y(N)=0.5*Y(N)/(1.0+1.0/A)
      DO 74 II=1,NM
      I=N-II
      B=A-2.0
      Y(I)=(Y(I)-Y(I+1))*B/A
      Y(I+1)=4.0*Y(I+1)
   74 A=B
      Y(1)=4.0*Y(1)
      GOTO 10
C
C     (7) = MQ
C     REPLACE EACH VALUE BY AVERAGE OF VALUE AND QUADRATIC FIT VALUE
C
   80 NM=N-4
      IF(NM.LT.1) GOTO 10
      ZL=Y(1)
      ZN=(12.0*Y(1)+17.0*Y(2)+12.0*Y(3)-3.0*Y(4))/38.0
      ZE=(12.0*Y(N)+17.0*Y(N-1)+12.0*Y(N-2)-3.0*Y(N-3))/38.0
      DO 82 I=1,NM
      ZM=(-3.0*Y(I)+12.0*Y(I+1)+17.0*Y(I+2)+12.0*Y(I+3)-3.0*Y(I+4))/35.000017300
      Y(I)=ZL
      ZL=ZN
   82 ZN=ZM
      Y(N-3)=ZL
      Y(N-2)=ZN
      Y(N-1)=ZE
      GOTO 10
C
  100 RETURN
      END

C   14/10/82            MEMBER NAME  BSCOM10  (S)           FORTRAN77
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------900000200
C     9.  UNFORMATED INPUT/OUTPUT OF BANKS
C
C     BANK RECORDS ARE OF THE FORM
C        NTOT, BANK1, BANK2, . . . BANKN
C     WITH NTOT = NR OF WORDS OF ALL BANKS, THE TOTAL NR OF (USED)
C     WORDS IN A RECORD IS THEREFORE NRECL = NTOT +1.
C     THE RECORD CONSISTS OF NTOT + 1 WORDS, WHERE
C     FIRST WORD IN RECORD   = NTOT
C     NEXT WORD              = NAME
C     NEXT WORD              = NUMBER OF FIRST BANK
C     NEXT WORD              = POINTER
C     NEXT WORD              = NR.OF WORDS OF THE FIRST BANK
C     ETC.
C
C
C
C     10.1 STANDARD OUTPUT AND INPUT
C
C     OUTPUT IS DONE BY FIRST SELECTING THE NAMES OF ALL BANKS
C     TO BE WRITTEN AND THEN BY CALLING THE OUTPUT PROGRAM. THE
C     SET OF BANKS DEFINES ONE EVENT. IF THE EVENT IS WRITTEN,
C     THE ORDER OF THE BANKS IS ALWAYS THE SAME AS WITHIN THE LIST,
C     WITH BANKS OF THE SAME NAME IN THE ORDER OF INCREASING NUMBER.
C     ALL BANKS OF ONE EVENT ARE READ INTO THE COMMON/BCS/ BY
C     ONE CALL OF THE INPUT PROGRAM
C
C     OUTPUT OF ONE EVENT
C        CALL BSLT               OR  CALL BMLT(N,LIST OF NAMES)
C
C        CALL BWRITE(IUN)
C
C     AFTER THE LAST EVENT, A ZERO LIST OF NAMES HAS TO BE DEFINED
C     AND BWRITE HAS TO BE CALLED AGAIN.
C
C        CALL BMLT(0,DUMMY)
C        CALL BWRITE(IUN)
C
C     INPUT OF ONE EVENT
C        CALL BREAD(IUN,&1,&2)         CALL CREAD(IUN,IER)
C
C     SPECIAL CONDITIONS
C
C                      BREAD                    CREAD
C
C     READ ERROR       RETURN1 (&1)             IER=1
C     END-OF-DATA      RETURN2 (&2)             IER=2
C
C
C
C     10.2 OUTPUT MODES AND RECORD TYPES
C
C     THERE ARE TWO TYPES OF RECORDS AND THREE MODES OF OUTPUT.
C
C    TYPES OF RECORDS
C
C    S-RECORDS     ONE RECORD CONTAINS ONE EVENT
C    M-RECORDS     ONE RECORD MAY CONTAIN SEVERAL EVENTS OR PARTS
C                  OF EVENTS. WITHIN THE RECORD, EVENTS OR PARTS
C                  OF EVENTS ARE WITHIN BANKS WITH THE NAME 'HIDD'.
C
C     FOR BOTH RECORD TYPES, THE INPUT PROGRAM ALLWAYS PUTS THE
C     BANKS OF ONE EVENT INTO COMMON/BCS/.
C
C     THE OUTPUT MODE AND A MAXIMUM RECORD LENGTH IS DEFINED BY ONE
C     CALL (BEFORE THE FIRST CALL OF THE OUTPUT PROGRAM).
C
C        CALL BWR0(IUNIT,NRECL,MODE)
C
C     IF NOT CALLED, MODE = 0 IS ASSUMED WIRH NRECL TAKEN FROM THE
C     BOS INITIALIZATION PROGRAM BINT (SEE CH. 1).
C
C
C     MODES OF OUTPUT
C
C     MODE = 0     S-RECORDS ARE WRITTEN. THE EVENT IS NOT WRITTEN, IF
C                  THE LENGHT OF THE EVENT EXCEEDS NRECL WORDS.
C     MODE = 1     S-RECORDS OR M-RECORDS ARE WRITTEN. M-RECORDS ARE
C                  WRITTEN, IF THE LENGTH OF ONE EVENT EXCEEDS NRECL
C                  WORDS.
C     MODE = 2     M-RECORDS ARE WRITTEN.
C
C     THE RECORD LENGTH WILL NEVER EXCEED NRECL WORDS. IT IS POSIBLE
C     (AND DONE IN BWRITE), TO WRITE RECORDS OF FIXED LENGTH NRECL
C     (ADDING UNUSED WORDS, IF NTOT IS LESS THAN NRECL - 1)
C
C
C     10.3 USER WRITE AND READ STATEMENTS
C
C     THE USER CAN USE HIS OWN WRITE AND READ STATEMENTS, TO ALLOW
C     E.G. USING THE FORTRAN DIRECT ACCESS STATEMENTS. FOR OUTPUT
C     THE STATEMENT CALL BWRITE(IUN) HAS TO BE REPLACED BY THE
C     FOLLOWING STATEMENTS.
C
C        1  CALL BWRS(IUN,NREC,INIW)
C           IF(INIW.EQ.0) GOTO 2
C           WRITE ONE RECORD ON UNIT IUN OF TOTAL NREC WORDS
C           IW(INIW),IW(INIW+1), . . . IW(INIW+NREC-1)
C           GOTO 1
C        2  CONTINUE
C
C     REMARK. IW(INIW) CONTAINS NTOT. FOR MODE = 0 OR = 1, NREC
C     IS EQUAL TO NTOT+1, FOR MODE = 2 NREC IS EQUAL TO NRECL
C     (FIXED NUMBER OF WORDS).
C
C     FOR INPUT THE STATEMENT CALL BREAD(IUN,&1,&2) HAS TO BE
C     REPLACED BY THE FOLLOWING STATEMENTS.
C
C
C        1  CALL BRDS(IUN,NREC,INIR)
C           IF(INIR.EQ.0) GOTO 2
C           READ ONE RECORD FROM UNIT IUN INTO WORDS
C           IW(INIR),IW(INIR+1), . . .
C           (SEE REMARKS BELOW)
C           GOTO 1
C        2  CONTINUE
C
C     REMARKS. THE ARGUMENT NREC IS (FOR INIR NOT EQUAL 0) EQUAL
C     TO THE LARGEST ALLOWED NUMBER OF WORDS, WHICH CAN BE READ.
C     SAFE INPUT IS POSSIBLE USING A SUITABLE ASSEMBLER READ ROUTINE.
C     THE END-OF-DATA CONDITION HAS TO BE HANDLED BY THE USER. IN
C     CASE OF READ ERRORS THIS CONDITION CAN BE SIGNALLED TO THE
C     BRDS PROGRAM BY DEFINING IW(INIR) = 0 AND GOTO 1.
C
C     10.4   BUFFER BANKS
C
C     FOR EACH INPUT/OUTPUT UNIT IUN A BANK ('$BUF',IUN) IS USED
C     WITH BWTWEEN 11 AND 10 +NRECL WORDS DEPENDING ON RECORD TYPE.
C     THESES BANKS ALSO CONTAIN STATISTIC ON INPUT/OUTPUT,
C     WHICH IS PRINTED BY CALLING THE STATUS PRINT ROUTINE BSTA.
C     AFTER THE END OF INPUT/OUTPUT THESE BANKS CAN BE DELETED BY THE
C     USUAL CALL
C        CALL BDLS('$BUF',IUN)
C     THIS IS NECESSARY, IF THE SAME UNIT NUMBER IUN IS USED AFTERWARDS.
C
C
C     10.5    STANDARD EVENT READING/WRITING
C
C     FOR THE STANDARD REPEATED CHAIN
C
C             INPUT OF ONE EVENT
C             PROCESS EVENT
C             OUTPUT OF EVENT
C             DELETEIN BANKS AND GARBAGE COLLECTION
C
C     THERE IS THE PROGRAM BSEQ.


C

      SUBROUTINE ZSRFT1(IPTR,LDTR,IPCO0,IPRES,LHIT,IQUAL,IOPT)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "calibr.for"
      COMMON/CWORK/NDIWRK,WRK(200)
      DIMENSION IWRK(200),HWRK(400)
      EQUIVALENCE (WRK(1),IWRK(1),HWRK(1))
      INTEGER DATE(5), IDAY /0/
      INTEGER NCHECK(5)/5*8/
      REAL RCHECK(12,2,5)/
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1./
      REAL RESCUT/600./
      DIMENSION ISORT1(71),ISORT2(3,71),IRESHT(71),ISORT3(91)
     +,ISORT4(2,91),KSORT3(91),KSZSRT(91,2)
      DATA IQHEAD/0/,MASK4/ZFFFFCFFF/
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
         LBINIT = 1
         IQHEAD = IBLN('HEAD')
         CALL DAY2(DATE)
         IDAY = DATE(1)*1000 + DATE(2)
         WRITE(6,137)
 137     FORMAT(/,' *** ZSRFT1 ***  (J.SPITZER) VERSION OF 13/5/88'/
     +   ' SEVERE BUGS CORRECTED, WHICH AFFECT LOW-MOMENTUM TRACKS',/,
     +   ' AS WELL AS CONVERSIONS, K0, LAMBDAS, ETC...',/,
     +   ' COVARIANCE MATRIX IS PROVIDED',/,
     +   ' IF THE TRACK AREA LONG ENOUGH, THE NUMBER',/,
     +  ' OF HITS USED IN THE FIT IS AT LEAST 4.',
     +   /)
      ENDIF
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      NEV  = HDATA(IPHEAD+11)
      ITRK = IDATA(IPTR+1)
      IF(
     - LDATYP(DUMMY) .EQ. 1
     -)THEN
         SRESO=24.
         STPFAC=.85
      ELSE
         SRESO=32.
         STPFAC=.92
      ENDIF
      SIGMIN=(SRESO/1.6)**2
      SIGFAC=(.14/30.)**2
      PAR1=ADATA(IPTR+30)
      PAR2=ADATA(IPTR+7)
      NHALL=0
      NHWIR=0
      NHPOT=0
      NHPOTT=0
      IPCO=IPCO0
      IPCO9=IPRES-LHIT
16000 CONTINUE
         NHWIR=NHWIR+1
      IF(
     - NHWIR.GT.70
     -)THEN
            IQUAL=-1
            RETURN
      ENDIF
         ISORT1(NHWIR)=NHWIR
         ISORT2(1,NHWIR)=IPCO
         ISORT2(3,NHWIR)=0
         IW0=IWRK(IPCO)
         LFL=0
         LFL1=0
         LFL2=0
15000 CONTINUE
      IF(
     - IPCO.LE.IPCO9
     -)THEN
            IW9=IWRK(IPCO)
      IF(
     - IW9.EQ.IW0
     -)THEN
               NHALL=NHALL+1
      IF(
     - NHALL.GT.90
     -)THEN
                  IQUAL=-2
                  RETURN
      ENDIF
               IF(ISORT2(3,NHWIR).EQ.0) ISORT2(2,NHWIR)=NHALL
               ISORT2(3,NHWIR)=ISORT2(3,NHWIR)+1
               KSORT3(NHALL)= NHALL
               LZGOOD=HWRK(2*IPCO+1)
      IF(
     - LZGOOD.NE.0
     -)THEN
                  ISORT3(NHALL)=-1
                  KSZSRT(NHALL,1)= 100000
      ELSE
                  ISORT3(NHALL)= 1
      IF(
     - LFL2.EQ.0
     -)THEN
                     KSZSRT(NHALL,1)= WRK(IPCO+6)
                     KSZSRT(NHALL,2)= WRK(IPCO+5)
                     LFL2=1
      ELSE
                     KSZSRT(NHALL,1)= 100000
      ENDIF
                  LFL=1
      IF(
     - ABS(WRK(IPCO+5)-PAR1*WRK(IPCO+6)-PAR2).LT.RESCUT
     -)THEN
      IF(
     - LFL1.EQ.0
     -)THEN
                        LFL1=1
                        NHPOTT=NHPOTT+1
      ENDIF
      ENDIF
      ENDIF
               IPCO=IPCO+LHIT
      ELSE
      GOTO 15001
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      IF(
     - LFL.EQ.1
     -)THEN
            NHPOT=NHPOT+1
      ELSE
            ISORT3(ISORT2(2,NHWIR))=-2
      ENDIF
      IF(.NOT.(
     - IPCO.GT.IPCO9
     -))GOTO 16000
16001 CONTINUE
      IF(
     - NHPOT.LT.2
     -)THEN
         IQUAL=-3
         RETURN
      ENDIF
      KFLIP=2
      NHFIT=NHPOTT
      LFOUND=-1
      IF(
     - NHPOTT.LT.6.OR.NHPOTT.LT.NHPOT*.75
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      INDMAX=NHFIT/4+1
      IF(INDMAX.GT.13) INDMAX=13
      INDFIT=0
15002 CONTINUE
      IF(
     - INDFIT.LT.INDMAX
     -)THEN
         INDFIT=INDFIT+1
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - LNOCON.EQ.1
     -)THEN
            IQUAL=-4
            RETURN
      ENDIF
      IF(
     - SIG.LT.SIGMIN
     -)THEN
      GOTO 15003
      ENDIF
      IF(
     - INDFIT.GE.2
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      IF(
     - LSTOP.EQ.1
     -)THEN
               INDFIT=INDFIT-1
               KFLIP=3-KFLIP
               NHFIT=NHFTLS
               PAR1=PAR1LS
               PAR2=PAR2LS
               SIG=SIGLST
               S0=S0LS
               S1=S1LS
               S2=S2LS
               S3=S3LS
               S4=S4LS
      GOTO 15003
      ENDIF
      ENDIF
      IF(
     - INDFIT.EQ.INDMAX.OR.NHFIT.EQ.2
     -)THEN
      GOTO 15003
      ENDIF
         NHFTLS=NHFIT
         PAR1LS=PAR1
         PAR2LS=PAR2
         SIGLST=SIG
         S0LS=S0
         S1LS=S1
         S2LS=S2
         S3LS=S3
         S4LS=S4
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      GOTO 15002
      ENDIF
15003 CONTINUE
      ASSIGN 17009 TO IZZZ05
      GOTO 17008
17009 CONTINUE
      IQUAL=1
      RETURN
17002 CONTINUE
      LNOCON=0
      KFLIP=3-KFLIP
      NHF1=0
      S0 = 0.
      S1 = 0.
      S2 = 0.
      S3 = 0.
      S4 = 0.
      DO 13000 IHWIR=1,NHWIR
         IH=ISORT2(2,IHWIR)
         NNH=ISORT2(3,IHWIR)
      DO 13002 JNH=1,NNH
            ISORT4(KFLIP,IH+JNH-1)=0
13002 CONTINUE
13003 CONTINUE
      IF(
     - ISORT3(IH).EQ.1 .OR. ISORT3(IH).EQ.-1.AND.NNH.GT.1
     -)THEN
            RESMIN=10000.
      DO 13004 JNH=1,NNH
               JH=IH+JNH-1
      IF(
     - ISORT3(JH).EQ.1
     -)THEN
                  IPCO=ISORT2(1,IHWIR)+(JNH-1)*LHIT
                  SA = WRK(IPCO+6)
                  ZA = WRK(IPCO+5)
                  WA = WRK(IPCO+7)
                  DZRESA=ZA-PAR1*SA-PAR2
                  DF0=ABS(DZRESA)
      IF(
     - DF0.LT.RESMIN
     -)THEN
                     RESMIN=DF0
                     S=SA
                     W=WA
                     DZRES=DZRESA
                     JHUSE=JH
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - RESMIN.LT.RESCUT
     -)THEN
               NHF1=NHF1+1
               S0=S0+W
               S1=S1+S*W
               S2=S2+S**2*W
               S3=S3+DZRES*W
               S4=S4+DZRES*S*W
               ISORT4(KFLIP,JHUSE)=1
      ELSE
               ISORT3(IH)=-2
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      IF(
     - NHF1.LT.2 .OR. S2.LT.1.
     -)THEN
         LNOCON=1
      ELSE
         NHFIT=NHF1
         F1 = 1. / S2
         XX12 = S1*F1
         YY1  = S4*F1
         PARR2=(S3-S1*YY1)/(S0-S1*XX12)
         PAR1=YY1-PARR2*XX12+PAR1
         PAR2=PAR2+PARR2
         CHISQ = 0.
         NHF1=0
      DO 13006 IHWIR=1,NHWIR
            IRESHT(IHWIR)=-1
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      IF(
     - ISORT3(IH).GE.0 .OR. ISORT3(IH).EQ.-1.AND.NNH.GT.1
     -)THEN
               RESMIN=10000.
      DO 13008 JNH=1,NNH
                  JH=IH+JNH-1
      IF(
     - ISORT3(JH).GE.0
     -)THEN
                     IFLG=ISORT3(JH)
                     IPCO=ISORT2(1,IHWIR)+(JNH-1)*LHIT
                     SA = WRK(IPCO+6)
                     ZA = WRK(IPCO+5)
                     WA = WRK(IPCO+7)
                     DF0=ABS(ZA-PAR1*SA-PAR2)
      IF(
     - DF0.LT.RESMIN
     -)THEN
                        RESMIN=DF0
                        W=WA
      ENDIF
      ENDIF
13008 CONTINUE
13009 CONTINUE
      IF(
     - RESMIN.LT.8000.
     -)THEN
                  RESMIN=RESMIN*SQRT(W)
                  IRESHT(IHWIR)=RESMIN*1.E4
      IF(
     - IFLG.EQ.1
     -)THEN
                     CHISQ=CHISQ+RESMIN**2
                     NHF1=NHF1+1
      ENDIF
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
      IF(
     - NHF1.LT.2
     -)THEN
            LNOCON=1
      ELSE
      IF(
     - NHF1.EQ.2
     -)THEN
               SIG=1.E-5
      ELSE
               SIG=CHISQ/(NHF1-2)
      ENDIF
      ENDIF
         NHFIT=NHF1
      ENDIF
      GOTO IZZZ02
17006 CONTINUE
         CALL SHELL9(IRESHT,ISORT1,NHWIR)
         KOMIT=0
      DO 13010 J1=1,NHWIR
            IHWIR=ISORT1(NHWIR+1-J1)
            IPCO=ISORT2(1,IHWIR)
            NNH=ISORT2(3,IHWIR)
            IH=ISORT2(2,IHWIR)
            LFLG=0
      DO 13012 JNH=1,NNH
               IHA=IH+JNH-1
               IQA=ISORT3(IHA)
      IF(
     - IQA.GT.-1
     -)THEN
      IF(
     - LFLG.EQ.0
     -)THEN
                     LFLG=1
                     KOMIT=KOMIT+1
      ENDIF
      IF(
     - KOMIT.LE.INDFIT
     -)THEN
                     ISORT3(IHA)=0
      ELSE
                     ISORT3(IHA)=1
      ENDIF
      ENDIF
13012 CONTINUE
13013 CONTINUE
13010 CONTINUE
13011 CONTINUE
      GOTO IZZZ04
17004 CONTINUE
      IF(
     - INDFIT.LE.6
     -)THEN
            INDCK=INDFIT-1
      ELSE
            INDCK=5
      ENDIF
         ICHCK=NCHECK(INDCK)
15004 CONTINUE
      IF(
     - SIGLST*SIGFAC.LT.RCHECK(ICHCK,1,INDCK)
     -)THEN
            ICHCK=ICHCK-1
      GOTO 15004
      ENDIF
15005 CONTINUE
         IF(ICHCK.LT.1) ICHCK=1
      IF(
     - SIG/SIGLST*STPFAC.GT.RCHECK(ICHCK,2,INDCK)
     -)THEN
            LSTOP=1
      ELSE
            LSTOP=0
      ENDIF
      GOTO IZZZ03
17008 CONTINUE
      CTGTH=PAR1
      CSTH = 1./SQRT(CTGTH**2 + 1.)
      SNTH  = CSTH * CTGTH
         IFREE=NDIWRK-100
         CALL MVCL(IWRK(IFREE),0,IDATA(IPTR+1),0,4*LDTR)
         IP    = IFREE - 1
         IWRK(IP+ 2) = LAND(IWRK(IP+2),MASK4)
         IWRK(IP+ 2) = LOR(IWRK(IP+2),4096)
         WRK (IP+ 7) = PAR2
         A=SQRT(WRK(IP+8)**2+WRK(IP+9)**2)
         WRK (IP+ 8) = WRK (IP+ 8)/A*CSTH
         WRK (IP+ 9) = WRK (IP+ 9)/A*CSTH
         WRK (IP+10) = SNTH
         CURVXY=WRK(IP+25)
         IF(ABS(CURVXY).LT.1.E-9) CURVXY = SIGN(1.E-9,CURVXY)
         UU=SQRT((WRK(IP+12)-WRK(IP+5))**2+(WRK(IP+13)-WRK(IP+6))**2)
         ARGARG = .5*CURVXY*UU
         IF(ABS(ARGARG).GT.1.) ARGARG = SIGN(1.,ARGARG)
         IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*ARSIN(ARGARG)/CURVXY
         WRK (IP+14) = PAR2+UU*PAR1
         A=SQRT(WRK(IP+15)**2+WRK(IP+16)**2)
         WRK (IP+15) = WRK (IP+15)/A*CSTH
         WRK (IP+16) = WRK (IP+16)/A*CSTH
         WRK (IP+17) = SNTH
         IWRK(IP+33) = NHFIT
         WRK (IP+32) = SQRT(SIG)
         IWRK(IP+29) = 2
         WRK (IP+30) = PAR1
         DDR0=DISTXY(ADATA(IPTR+5),ADATA(IPTR+6),ADATA(IPTR+8),
     +   ADATA(IPTR+9),1./CURVXY,0.,0.,XP,YP,FI)
         UU=SQRT((XP-WRK(IP+5))**2+(YP-WRK(IP+6))**2)
         ARGARG = .5*CURVXY*UU
         IF(ABS(ARGARG).GT.1.) ARGARG = SIGN(1.,ARGARG)
         IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*ARSIN(ARGARG)/CURVXY
         WRK (IP+31) = PAR2-PAR1*UU
      IF(
     - LDTR.GE.59 .AND. NHFIT.GE.4 .AND. LNOCON.EQ.0
     -)THEN
            DET=S0*S2-S1**2
            FACT=SIG/DET
            WRK(IP+56)=SIG*(NHFIT-2)/20.**2
            WRK(IP+57)=(S2+2.*UU*S1+UU**2*S0)*FACT
            WRK(IP+58)=-(UU*S0+S1)*FACT
            WRK(IP+59)=S0*FACT
      ENDIF
         LFL=0
      DO 13014 IHWIR=1,NHWIR
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      DO 13016 JNH=1,NNH
               IPCO=ISORT2(1,IHWIR)+(JNH-1)*LHIT
               HWRK(2*IPCO+3)=ISORT4(KFLIP,IH+JNH-1)
               IF(HWRK(2*IPCO-1).GT.100.AND.HWRK(2*IPCO+3).EQ.1) LFL=1
13016 CONTINUE
13017 CONTINUE
13014 CONTINUE
13015 CONTINUE
         IF(LFL.EQ.1) IWRK(IP+ 2) = LOR(IWRK(IP+2),16384)
         CALL MVCL(IDATA(IPTR+1),0,IWRK(IFREE),0,4*LDTR)
      IF(
     - IOPT.GT.8
     -)THEN
            CALL CCRE(NPZSPD,'ZSPD',ITRK,5*NHALL+1,IERR)
      IF(
     - IERR.EQ.0
     -)THEN
               CALL BSAW(1,'ZSPD')
               NPZSP1=NPZSPD+1
               IDATA(NPZSP1)=5
      DO 13018 IHWIR=1,NHWIR
                  IH=ISORT2(2,IHWIR)
                  NNH=ISORT2(3,IHWIR)
      DO 13020 JNH=1,NNH
                     IPCO=ISORT2(1,IHWIR)+(JNH-1)*LHIT
                     IFL=ISORT4(KFLIP,IH+JNH-1)
      IF(
     - IFL.EQ.1
     -)THEN
                        IFL=0
      ELSE
                        IFL=16
      ENDIF
                     IDATA(NPZSP1+1)=HWRK(2*IPCO+4)
                     ADATA(NPZSP1+2)=WRK(IPCO+6)
                     ADATA(NPZSP1+3)=WRK(IPCO+5)
                     IDATA(NPZSP1+4)=IFL
                     ADATA(NPZSP1+5)=WRK(IPCO+7)
                     NPZSP1=NPZSP1+5
13020 CONTINUE
13021 CONTINUE
13018 CONTINUE
13019 CONTINUE
      ENDIF
      ENDIF
      GOTO IZZZ05
17000 CONTINUE
         CALL SHELL9(KSZSRT(1,1),KSORT3,NHALL)
         NH9=NHALL
15006 CONTINUE
      IF(
     - KSZSRT(KSORT3(NH9),1).GT.99999
     -)THEN
            NH9=NH9-1
      GOTO 15006
      ENDIF
15007 CONTINUE
         NH99=NH9
         NH1=1
         LFOUND=0
         NHMAX=0
         CI2MAX=1.E10
15008 CONTINUE
      IF(
     - NH9.GT.NH1
     -)THEN
      DO 13022 KK=1,3
      IF(
     - KK.EQ.1
     -)THEN
                  JH1=NH1
                  JH9=NH9
      ELSE
      IF(
     - KK.EQ.2
     -)THEN
                     JH9=JH9-1
      ELSE
                     JH9=JH9+1
                     JH1=JH1+1
      ENDIF
      ENDIF
      IF(
     - JH9.GT.JH1
     -)THEN
                  AS1=KSZSRT(KSORT3(JH1),1)
                  AS9=KSZSRT(KSORT3(JH9),1)
      IF(
     - AS9.LT.AS1+5.
     -)THEN
      GOTO 15009
      ENDIF
                  AZ1=KSZSRT(KSORT3(JH1),2)
                  AZ9=KSZSRT(KSORT3(JH9),2)
                  PAR1=(AZ9-AZ1)/(AS9-AS1)
                  PAR2=AZ1-PAR1*AS1
                  NHFIT=0
                  CI2=0.
      DO 13024 I=1,NH99
                     DZ=ABS(KSZSRT(KSORT3(I),2)-PAR1*KSZSRT(KSORT3(I),1)
     +               -PAR2)
      IF(
     - DZ.LT.RESCUT
     -)THEN
                        NHFIT=NHFIT+1
                        CI2=CI2+DZ**2
      ENDIF
13024 CONTINUE
13025 CONTINUE
      IF(
     - NHFIT.GT.NHPOT*.75
     -)THEN
                     LFOUND=1
      GOTO 15009
      ENDIF
      IF(
     - NHFIT.GT.NHMAX .OR.NHFIT.EQ.NHMAX.AND.CI2.LT.CI2MAX
     -)THEN
                     NHMAX=NHFIT
                     P1MAX=PAR1
                     P2MAX=PAR2
                     CI2MAX=CI2
      ENDIF
      ENDIF
13022 CONTINUE
13023 CONTINUE
            NH1=NH1+1
            NH9=NH9-1
      GOTO 15008
      ENDIF
15009 CONTINUE
      IF(
     - LFOUND.EQ.0 .AND. NHMAX.GT.0
     -)THEN
            NHFIT=NHMAX
            PAR1=P1MAX
            PAR2=P2MAX
      ENDIF
      GOTO IZZZ01
      END

C   07/06/96 606071841  MEMBER NAME  DEFIND   (S4)          FORTG1
      SUBROUTINE DEFIND
      COMMON/BCS/IW(1000)
      COMMON/BNKIND/ISTAT,IRN,IHD,IVT,INDT(32),INDZ,MASK,INDH
      CALL BGAR(IGA)
      CALL VZERO(ISTAT,39)
      CALL BLOC(IRN,'RUN ',0,&1)
    1 CALL BLOC(IVT,'VERT',1,&2)
    2 CALL BLOC(IHD,'HEAD',0,&3)
    3 CONTINUE
      NTR=IW(IVT+2)
      CALL BLOC(IND,'PART',32,&4)
      GOTO 5
    4 CALL BCRE(IND,'PART',32,20,&100,IER)
      CALL BSAW(1,'PART')
      IW(IND+6)=3
      IW(IND+7)=1
    5 INDT(32)=IND
      IF(NTR.EQ.0) GOTO 15
      DO 10 I=1,NTR
      N=IW(IVT+10+I)
      CALL BLOC(IND,'PART',N,&6)
      GOTO 7
    6 CALL BLOC(IND,'TRAC',N,&10)
      CALL TRPART(IND,&10)
      CALL BLOC(IND,'PART',N,&10)
    7 INDT(N)=IND
   10 CONTINUE
   15 CONTINUE
  100 RETURN
      END

C   07/06/96 606071848  MEMBER NAME  IBANK    (S4)          FORTG1
      FUNCTION IBANK(NAME,NR,NCA)
C
C
C     BAS04     FUNCTION IBANK  /  VERSION FOR F1EBLO.BOSLIB.S/L
C
C     IBANK CREATES OR CHANGES THE BANK (NAME,NR) AND RETURNS THE
C     INDEX OF THE BANK
C
C               ---- -- ----
C     IND=IBANK(NAME,NR,IOPT)
C     ---
C
C
C     IOPT   GE    0   CREATE THE BANK (NAME,NR) WITH IOPT DATA WORDS.
C                      ALL DATA WORDS ARE SET TO ZERO.
C
C     IOPT    = 'DL'   DELETE BANK (NAME,NR).
C
C     IOPT    = 'DLGC' DELETE BANK (NAME,NR) AND DO A GARBAGE COLLECTION
C                      IN THE REGION OF AND ABOVE THE DELETED BANK.
C
C     IOPT    = 'MV'   MOVE BANK (NAME,NR) TO THE END.
C
C     IOPT    = 'RN'   CHANGE THE NAME AND THE NUMBER OF THE BANK
C                      PREVIOUSLY USED IN IBANK OR ILINK TO (NAME,NR).
C
C     IOPT    = 'CP'   CREATE A BANK (NAME,NR) WITH THE SAME LENGTH AND
C                      CONTENT AS THE BANK PREVIOUSLY USED IN IBANK OR
C                      IN ILINK.
C
C     IOPT    = 'PR'   PRINT BANK (NAME,NR).
C
C     IND=IBANK(0,0,0)
C
C                      RETURN INDEX FOR THE FIRST UNUSED WORD BEHIND
C                      BANKS. THE LENGTH OF THE UNUSED SPACE IS STORED
C                      IN IW(IND)=NUS. THERE IS ENOUGH SPACE TO CREATE A
C                      BANK OF UP TO NUS WORDS, IF NUS IS NE 0.
C
C     ********************   ERROR CONDITIONS   **********************
C     IOPT
C     GE 0   IBANK=0, IF NOT ENOUGH SPACE.
C            IF THE BANK ALREADY EXISTS AND THE IOPT AGGREES WITH THE
C            ACTUAL LENGTH, THE INDEX IS RETURNED WITHOUT CHANGING TH
C            BANK CONTENT. IF THE LENGTH DIFFER, THE LENGTH OF THE BANK
C            IS CHANGED TO IOPT, ADDITIONAL WORDS ARE SET TO ZERO. IF
C            THE LENGTH DIFFER, THE CHANGE MAY REQUIRE A MOVE. IBANK=0
C            IN THIS CASE, IF THERE IS NOT ENOUGH SPACE. THUS THE CALL
C            MAY RETURN ZERO, ALTHOUGH THE BANK EXISTS.
C
C     'DL'   IBANK=0 IN ANY CASE. NO BANK IS DELETED, IF THE BANK CANNOT
C            BE FOUND.
C
C     'DLGC' IBANK=0 IN ANY CASE. NO BANK IS DELETED AND NO GARBAGE
C            COLLECTION IS DONE, IF THE BANK CANNOT BE FOUND.
C
C     'MV'   IBANK=0, IF NOT ENOUGH SPACE.
C
C     'RN'   IBANK=0, IF PREVIOUS BANK WAS NOT FOUND OR NEW BANK ALREADY
C            EXITS.
C
C     'CP'   IBANK=0, IF PREVIOUS BANK WAS NOT FOUND OR NEW BANK ALREADY
C            EXISTS OR NOT ENOUGH SPACE.
C
C     'PR'   IBANK=0, IF BANK CANNOT BE FOUND.
C
C
C
C     --------------------------------------------------------------
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1,
     9   JNAM,NLK,NLM,ILKNA,ILKIN,ILKND,LKNAME,LKNR,ICUST,IREV,
     *   NUNTB,DUMMY(9)
C     --------------------------------------------------------------
      COMMON/BCS/IW(1)
C     --------------------------------------------------------------
      EQUIVALENCE (XNAME,INAME)
      REAL FF/Z000000FF/
      INTEGER ISTAR/Z0000005C/,NSUFF/10/
      INTEGER NTEXT(6)/2HDL,4HDLGC,2HMV,2HRN,2HCP,2HPR/
      REAL AND
      EXTERNAL AND
      NC=IABS(NCA)
      IF(NAME.NE.0)          GOTO 10
      IF(NR.NE.0.OR.NC.NE.0) GOTO 10
C
C     IBANK(0,0,0) - RETURN INDEX OF NEXT FREE WORD
C
      IBANK=NEXT
      IW(IBANK)=MAX0(0,NLST-NEXT-4)
      GOTO 110
C
C     CHECK TYPE OF ENTRY
C
   10 IF(NC.LE.NLST) GOTO 20
      DO 12 L=1,6
      IF(NCA.EQ.NTEXT(L)) GOTO 14
   12 CONTINUE
      GOTO 99
   14 NC=-L
   16 IF(NC+4.NE.0.AND.NC+5.NE.0) GOTO 20
C
C     FOR RENAME AND COPY SAVE PREVIOUS INDICES
C
      IF(LFDI.EQ.0) GOTO 99
      LFDKS=LFDK
      LFDIS=LFDI
      NL=0
      INAME=IW(LFDI-3)
      XNAME=AND(XNAME,FF)
      IF(INAME.EQ.ISTAR) NL=-IW(LFDI)-4
C
C     REDUCE LOOPS TO FIND INDEX, IF PREVIOUS BANK IS NEAR PRESENT BANK
C
C  20 IF(JNAM.EQ.0.OR.IW(INAMV+JNAM).NE.NAME) GOTO 21
C     IF(LFDI.EQ.0)      GOTO 23
C     IF(IW(LFDI-2)-NR) 24,25,23
   20 CONTINUE
C
C     LOOP TO FIND INDEX TO NAME (INLINE IBLN)
C
   21 IW(INAMV)=NAME
      JNAM=MOD(IABS(NAME),NPRIM)+NAMAX1
   22 JNAM=IW(JNAM+IPLST)
      IF(IW(JNAM+INAMV).NE.IW(INAMV)) GOTO 22
      IF(JNAM.NE.0) GOTO 23
      JNAM=IBLN(IW(INAMV))
C
C     LOOP TO FIND BANK WITH NUMBER NR
C
   23 LFDI=JNAM+1
   24 LFDK=LFDI
      LFDI=IW(LFDI-1)
      IF(LFDI.EQ.0)      GOTO 80
      IF(IW(LFDI-2)-NR) 24,25,80
   25 IBANK=LFDI
C
C     1.CASE - BANK IS FOUND     ----------
C
      INAME=NAME
      XNAME=AND(XNAME,FF)
      IF(NC.GE.0)  GOTO 52
      IBR=-NC
      IF(IBR.LE.2) GOTO 30
      IF(IBR.EQ.3.AND.LFDI+IW(LFDI)+1.EQ.NEXT) GOTO 110
      IF(IBR.EQ.3) GOTO 60
      IF(IBR-6)   99,40,50
C
C     DELETE WITHOUT OR INCLUDING GARBAGE COLLECTION
C
   30 NN=4+IW(LFDI)
      IW(LFDK-1)=IW(LFDI-1)
      IW(LFDI  )=-NN
      IF(INAME.EQ.ISTAR) NCPL=NCPL-NN
      IF(LFDI+NN-3.NE.NEXT) GOTO 32
      NEXT=NEXT-NN
      GOTO 34
   32 NFRE=NFRE+NN
      ILOW=MIN0(ILOW,IBANK)
   34 IBANK=0
      LFDJ=LFDI
      LFDI=0
      IF(NC+1.EQ.0) GOTO 100
      JLOW=ILOW
      ILOW=LFDJ
C                           V---------------------
      CALL BGAR(IGA)
C                           A---------------------
      IF(JLOW.LT.LFDJ) ILOW=JLOW
      GOTO 99
C
C     PRINT BANK (OPTION PR)
C
   40 IF(NUNTB.LE.0) GOTO 110
      WRITE(NUNTB,111) IW(INAMV),(IW(LFDI-3+K),K=1,3),LFDI
C                           V---------------------
      CALL UWU(IW(IBANK+1),1,IW(IBANK))
C                           A---------------------
      GOTO 110
C
C     CHANGE LENGTH OF BANK
C
   50 NC=0
   52 NW=NC-IW(LFDI)
      IF(NW.EQ.0) GOTO 100
      IF(LFDI+IW(LFDI)+1.EQ.NEXT) GOTO 70
      IF(NW)      54,110,60
   54 IF(NW+4.GT.0) GOTO 60
      IW(LFDI)=NC
      IND=LFDI+NC+4
      ILOW=MIN0(ILOW,IND)
      IW(IND)=NW
      NFRE=NFRE-NW
      IF(INAME.EQ.ISTAR) NCPL=NCPL+NW
      GOTO 110
C
C     MOVE BANK (OPTION MV)
C
   60 IF(NEXT+4+MAX0(IW(LFDI),NC).GE.NLST) GOTO 80
      NN=4+IW(LFDI)
      CALL UCOPY2(IW(LFDI-3),IW(NEXT),NN)
      ILOW=MIN0(ILOW,LFDI)
      IBANK=NEXT+3
      IW(LFDI  )=-NN
      LFDI=IBANK
      IW(LFDK-1)=LFDI
      NEXT=NEXT+NN
      NFRE=NFRE+NN
      IF(IBR.EQ.3) GOTO 100
C
C     CHANGE LAST BANK
C
   70 IF(NEXT+NW.GE.NLST) GOTO 98
      IF(INAME.NE.ISTAR)  GOTO 72
      IF(NCPL+NW.LT.NSPL) GOTO 72
      IF(NW.LT.0)         GOTO 72
      NHISTL(11)=NHISTL(11)+1
      GOTO 99
   72 ILOCC=IBANK+IW(IBANK)
      IW(IBANK)=IW(IBANK)+NW
      NEXT=NEXT+NW
      IF(INAME.EQ.ISTAR) NCPL=NCPL+NW
      IF(NW.LE.0) GOTO 100
      LL=ILOCC
      LT=LL+NW
      MC=NW/4
      GOTO 93
C
C     2.CASE - BANK IS NOT FOUND ----------
C
   80 LFDI=0
      INAME=NAME
      XNAME=AND(XNAME,FF)
      IF(NC.GE.0) GOTO 90
      IBR=-NC
      IF(IBR-4)  99,82,81
   81 IF(IBR-6)  84,99,86
C
C     RENAME BANK (OPTION RN)
C
   82 IW(LFDKS-1)=IW(LFDIS-1)
      IW(LFDIS-1)=IW(LFDK -1)
      IW(LFDK -1)=LFDIS
      IW(LFDIS-3)=NAME
      IW(LFDIS-2)=NR
      IBANK=LFDIS
      LFDI=LFDIS
      LFDK=LFDKS
      IF(INAME.EQ.ISTAR) NL=NL+IW(LFDIS)+4
      NCPL=NCPL+NL
C                            V--------------------
C     CALL BUPDTL(0)
C                            A--------------------
      JNAM=0
      GOTO 110
C
C     COPY BANK (OPTION CP)
C
   84 NC=IW(LFDIS)
      GOTO 90
C
C     CREATE BANK
C
   86 NC=0
   90 NN=4+NC
C
C     CHECK REMAINING SPACE
C
      IF(NEXT+NN.GE.NLST) GOTO 98
      IF(INAME.NE.ISTAR)  GOTO 92
      IF(NCPL+NN.LT.NSPL) GOTO 91
      NHISTL(11)=NHISTL(11)+1
      GOTO 99
   91 NCPL=NCPL+NN
   92 IBANK=NEXT+3
      LFDI=IBANK
C
C     INSERT BANK, UPDATE POINTER
C
      IW(LFDI-3)=NAME
      IW(LFDI-2)=NR
      IW(LFDI-1)=IW(LFDK-1)
      IW(LFDI  )=NC
      IW(LFDK-1)=LFDI
      NEXT=NEXT+NN
      LIND=LFDI
      IF(NC.EQ.0)    GOTO 100
      IF(IBR.EQ.5) GOTO  97
C
C     CLEAR BANK CONTENT
C
      LL=LFDI
      LT=LL+NC
      MC=NC/4
   93 IF(NC.LE.0) GOTO 100
      IF(MC .LE.0) GOTO 95
      DO 94 L=1,MC
      IW(LL+1)=0
      IW(LL+2)=0
      IW(LL+3)=0
      IW(LL+4)=0
   94 LL=LL+4
   95 DO 96 L=1,4
      IF(LL.EQ.LT) GOTO 100
      LL=LL+1
   96 IW(LL)=0
      GOTO 100
C
C     COPY BANK CONTENT
C
   97 CALL UCOPY(IW(LFDIS+1),IW(LFDI+1),NC)
      GOTO 100
C
C     INSUFFICIENT SPACE, INCREASE COUNTER
C
   98 NHISTH(11)=NHISTH(11)+1
      IF(NSUFF.LE.0) GOTO 99
      IF(NUNTB.LE.0) GOTO 99
      IF(NC.GE.0) WRITE(NUNTB,112) NAME,NR,NCA
      IF(NC.LT.0) WRITE(NUNTB,113) NAME,NR,NCA
      NSUFF=NSUFF-1
C
C     RETURN WITH FUNCTION VALUE ZERO
C
   99 IBANK=0
      LFDI=0
      GOTO 110
C
C     UPDATE INDEX ARRAYS AND RETURN
C                            V--------------------
  100 GOTO 110
C 100 IF(NLK.EQ.0) GOTO 110
C     DO 109 I=1,NLK
C     IF(JNAM.NE.IW(ILKNA+I)) GOTO 109
C     L=IW(ILKIN+I)
C     IF(IW(ILKND+I)-1) 101,102,103
C     BANK (NAME,0)
C 101 IF(NR.NE.0) GOTO 109
C     IW(L)=IBANK
C     GOTO 109
C 102 IW(L)=IW(JNAM)
C     GOTO 109
C     BANK (NAME,NR)
C 103 IF(NR.LE.0.OR.NR.GT.IW(ILKND+I)) GOTO 109
C     IW(L+NR)=IBANK
C     IF(IBANK.EQ.0) GOTO 104
C     IW(L)=MAX0(IW(L),NR)
C     GOTO 109
C 104 N=IW(L)+1
C 105 N=N-1
C     IF(N.EQ.0)       GOTO 106
C     IF(IW(L+N).EQ.0) GOTO 105
C 106 IW(L)=N
C 109 CONTINUE
C                            A--------------------
C     RETURN WITHOUT UPDATE
C
  110 RETURN
  111 FORMAT('0 BANK ',A4,5I12)
  112 FORMAT('0---- INSUFFICIENT SPACE FOR BANK (',A4,',',I8,
     1   ' WITH',I4,' WORDS')
  113 FORMAT('0---- INSUFFICIENT SPACE FOR BANK (',A4,',',I8,
     1   ' OPTION ',A4)
      END

C   29/03/84 806071705  MEMBER NAME  MUCUTS   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUCUTS
C-----------------------------------------------------------------------
C
C LAST CHANGE 17.00  07/06/88   J. HAGEMANN  - SET RMSZUP YEAR DEPEND.
C      CHANGE 16.00  30/03/84   CHRIS BOWDERY - INCREASE ARRAY SIZES
C      CHANGE 16.00  25/02/84   HUGH MCCANN   - TYPE 9 MUONS FLAGGED
C      CHANGE 20.50  23/01/84   CHRIS BOWDERY - COUNT MUONS AND MU EVNTS
C      CHANGE 15.00  23/01/84   TIM GREENSHAW - ERROR OUTPUT ALTERED
C      CHANGE 11.00  07/12/83   HUGH MCCANN  - TYPE 5 MUONS FLAGGED
C      CHANGE 03.15  14/07/83   HUGH MCCANN  - CHANGE ORDER OF CUTS.
C      CHANGE 17.10  11/10/82   HUGH MCCANN  - CLEAR FLAG FOR ALL TRACKS
C
C
C      SUBROUTINE TO ANALYSE MU RESULTS.        HUGH MCCANN 02/02/82 .
C
C      AT PRESENT TYPES 1, 5 AND 9 "GOOD" MUONS ARE DEFINED.
C
C-----------------------------------------------------------------------
C
C  NMHTR(TRACK NO.)    = NO. OF HITS IN THE BEST HIT PERMN FOR TRACK.
C  IHTR(TR#,1..NMHTR)  = HIT NO. OF ASS'D HIT.
C  PROBTR(TRACK NO.)   = PROB OF TRACK.
C
C  IMUCAN STORES THE PATR TRACK NOS. OF THE SELECTED CANDIDATE MUONS.
C
C  PMOMTR(TRACK NO.)   = MOMENTUM OF TRACK.
C  XABSTR(  "      )   = NO. OF ABSORPTION LENGTHS PENETRATED ;
C  IQUTR (  "      )   = TRACK QUALITY ;
C  MISHIT(  "      )   = NO. OF INEFFICIENT LAYERS ON TRACK .
C
C
C       N.B.    NOW THAT THE NO. OF ARRAYS HAS GROWN QUITE LARGE, IT
C               WOULD BE A GOOD IDEA TO JUST USE THE STORED TRACK NO.
C               AS A POINTER AT THE TRACK MODIFYING STAGE, THUS SAVING
C               SOME SPACE.
C
C CUTP    = THE LOWER LIMIT ON TRACK MOMENTA (GEV/C);
C CUTABS  = THE LOWER LIMIT ON NO. OF ABSORPTION LENGTHS PENETRATED
C                                 TO THE LAST ASSOCIATED HIT;
C CUTPRO  = THE LOWER LIMIT ON CHI**2 PROBABILITY ;
C CUTLEV  = THE LOWER LIMIT ON THE MAGNETIC LEVER ARM IN JETCHAMBER (MM)
C NHXYLO  = THE LOWER LIMIT ON NO. OF HITS IN XY PATREC FIT;
C NHZLO   = THE LOWER LIMIT ON NO. OF HITS IN RZ PATREC FIT;
C RMSZUP  = THE UPPER LIMIT ON THE RMS OF THE RZ PATREC FIT (MM).
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL MUEVNT
C
C                            COMMONS.
C
#include "cmubcs.for"
#include "cmustat.for"
C
      COMMON / CMUPRN / MUPRIN
      COMMON / CMUIEV / IEV,NEV,IRD,KRUN,KREC,
     +                  ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
C
      DIMENSION NMHTR(60),PROBTR(60),IHTR(60,20),IMUCAN(10),PMOMTR(60),
     +          XABSTR(60),IQUTR(60),MISHIT(60),NOLAYR(60)
C
      DATA CUTP/1.8/,CUTABS/4.8/,CUTPRO/0.01/,CUTLEV/290./,
     +     NHXYLO/17/,NHZLO/10/,RMSZUP/90./
C
      DATA IYEARO / -1111 /
C
C------------------  C O D E  ------------------------------------------
C
      MUEVNT = .FALSE.
C
      IF( IYEAR .EQ. IYEARO ) GOTO 100
         IYEARO = IYEAR
         RMSZUP = 90.0
         IF( IYEAR .EQ. 1986 ) RMSZUP = 180.0
  100 CONTINUE
C                            PATREC
C
      IPPATR = IDATA(IBLN('PATR'))
      ISTART = IDATA(IPPATR+1) + 1
      NWTRK  = IDATA(IPPATR+3)
      IPT    = IPPATR+ISTART - 1
C
C                            MUON ANALYSIS BANKS
C
      IBANK  = 0
      CALL CLOC(IMUR10,'MUR1',IBANK)
      NMHITS = IDATA(IMUR10+1)
C
      IBANK  = 0
      CALL CLOC(IMUR20,'MUR2',IBANK)
      IF( IMUR20 .LE. 0 ) GO TO 111
      NUMTRK = IDATA(IMUR20+1)
      NMUW   = IDATA(IMUR20+2)
      NTPH   = IDATA(IMUR20+3)
C
      IBANK  = 1
      CALL CLOC(IMUR21,'MUR2',IBANK)
      IF( IMUR21 .LE. 0 ) GO TO 11
C
      IBANK  = 2
      CALL CLOC(IMUR22,'MUR2',IBANK)
      IF( IMUR22 .LE. 0 ) GO TO 11
      J22    = 2 * IMUR22
C
      IBANK  = 3
      CALL CLOC(IMUR23,'MUR2',IBANK)
      IF( IMUR23 .LE. 0 ) GO TO 11
      J23    = 2 * IMUR23
C
      CALL VZERO( NMHTR,  60 )
      CALL VZERO( IHTR, 1200 )
      CALL VZERO( PROBTR, 60 )
      CALL VZERO( IMUCAN, 10 )
C
      CALL VZERO( PMOMTR, 60 )
      CALL VZERO( XABSTR, 60 )
      CALL VZERO( IQUTR,  60 )
      CALL VZERO( MISHIT, 60 )
      CALL VZERO( NOLAYR, 60 )
C
      NOMU = 0
C
C                            LOOP ROUND TRACKS TO FIND MUON CANDIDATES
C
      J=IMUR21
      J2=J+J
C
C                            PREVENT ARRAY OVERFLOW
C
      IF( NUMTRK .LE. 60 ) GO TO 1
        CALL MUERRY('MUCUTS',NUMTRK,' = NO. OF PATR TRACKS, EXCEEDS LIMI
     +T OF 60. EXCESS IGNORED !^')
        NUMTRK = 60
C
   1  DO  99  I = 1,NUMTRK
C
C                            FIRST, CLEAR HALF-WORD 53 FOR EACH  TRACK.
C
        HDATA(J2+53) = 0
C
C                            CUT ON QUALITY.
C
        IQUAL = IDATA(J+6)
C
        IF( IQUAL .LE. 0 ) GO TO 9
C
        CHIP  = ADATA(J+11)
        XABS  = ADATA(J+15)
C
        P     = ADATA(J+38)
C
C                            CUT ON MOMENTUM.
C
        IF( P .LT. 1.2 ) GO TO 9
        PMOMTR(I) = P
        IQUTR(I)  = IQUAL
        XABSTR(I) = XABS
        MISHIT(I) = IDATA(J+4)/10000
        INF       = IDATA(J+4)/100
        NOLAYR(I) = MOD(INF,100)/2
C
        PROBTR(I) = CHIP
C
C                            PICK UP PATREC DATA.
C
        NHXY = IDATA(IPT+24)
        NHZ  = IDATA(IPT+33)
        RMSZ = ADATA(IPT+32)
C
        X1   = ADATA(IPT+5)
        Y1   = ADATA(IPT+6)
        Z1   = ADATA(IPT+7)
C
        X2   = ADATA(IPT+12)
        Y2   = ADATA(IPT+13)
        Z2   = ADATA(IPT+14)
C
        R2   = SQRT(X2**2 + Y2**2)
        R1   = SQRT(X1**2 + Y1**2)
C
C                            CALCULATE LENGTH OF LEVER ARM .
C
        RLEV = R2 - R1
        IF( RLEV .LT. CUTLEV  .OR.
     +      NHXY .LT. NHXYLO  .OR.
     +      NHZ  .LT. NHZLO   .OR.
     +      RMSZ .GT. RMSZUP        ) GO TO 9
C
C                            TRACK HAS SURVIVED CUTS SO FAR.  COUNT IT
C
        NOMU         = NOMU + 1
C
C                            PREVENT OVERFLOW AFTER 10 CANDIDATES
C
        IF( NOMU .LE. 10 ) GO TO 2
          CALL MUERRY('MUCUTS',I,' = PATR TRACK FOUND TO BE A MUON CANDI
     +DATE THAT EXCEEDS LIMIT OF 10^')
          NOMU = 10
          GO TO 99
C
   2    IMUCAN(NOMU) = I
C
C                            DIG AROUND IN MUR2/2 AND MUR2/3 .
C
        IP22J = J22
        IP23J = J23
C
        DO  22  JHIT = 1,NMHITS
          DO  21  INTPH = 1,NTPH
            ITK      = HDATA(IP22J+INTPH)
            IF( IABS(ITK) .NE. I ) GO TO 21
            IAMB     = HDATA(IP23J+INTPH)
            IF( IABS(MOD(IAMB,10)) .NE. 2 ) GO TO 21
            NMHTR(I) = NMHTR(I) + 1
            IHTR(I,NMHTR(I)) = JHIT
   21     CONTINUE
          IP22J = IP22J + NTPH
          IP23J = IP23J + NTPH
   22   CONTINUE
C+++
C       WRITE(6,236)I,NMHTR(I),(IHTR(I,J),J=1,10)
C 236   FORMAT('0 TRACK/NO. OF HITS/HIT NOS. :',I3,I5,5X,10I3)
C+++
C
    9   J   = J   + NMUW
        J2  = J   + J
        IPT = IPT + NWTRK
C+++
C       WRITE(6,995) I,NUMTRK
C 995   FORMAT(3X,I6,' OUT OF ',I6)
C+++
   99 CONTINUE
C
C                            IF NO MUON CANDIDATES , RETURN.
C
      IF( NOMU .EQ. 0 ) GO TO 500
C
C                            IF ONLY 1 MUON CANDIDATE, GO TO
C                            BANK-MODIFYING STAGE
C
      IF( NOMU .EQ. 1 ) GO TO 400
C
C
C        OTHERWISE, LOOK INTO SHARING OF HITS . THE FOLLOWING HIERARCHY
C        OF SELECTIONS IS USED:
C
C        1)   IF 2 TRACKS SHARE HITS AND  1  HAS  MORE  HITS  THAN  THE
C             OTHER, THEN THAT ONE IS SELECTED;
C
C        2)   IF 2 TRACKS SHARE HITS AND THEY HAVE EQUAL NOS. OF  HITS,
C             THEN THE ONE WITH THE GREATER PROBABILITY IS SELECTED.
C
C        IN EITHER CASE, THE  'LOSER'  HAS  ITS  FLAG  IN  IMUCAN  MADE
C        NEGATIVE. A TRACK WHICH LOSES ONE SHOOT-OUT IS STILL  USED  IN
C        FURTHER SHOOT-OUTS, BUT IT WILL NEVER HAVE ITS FLAG IN  IMUCAN
C        MADE POSITIVE AGAIN.
C
C
      DO  199  IMU = 1,NOMU
        IF( IMU .EQ. NOMU ) GO TO 199
        I      = IABS(IMUCAN(IMU))
        NHIMU  = NMHTR(I)
        IPLUS1 = IMU + 1
C
        DO  189  JMU = IPLUS1,NOMU
          J      = IABS(IMUCAN(JMU))
          NHJMU  = NMHTR(J)
          NSHARE = 0
C
          DO  179  K = 1,NHIMU
            DO  169  L = 1,NHJMU
              IF( IHTR(I,K) .NE. IHTR(J,L) ) GO TO 169
              NSHARE = NSHARE + 1
  169       CONTINUE
  179     CONTINUE
C
C+++
C         WRITE(6,1796)I,J,NSHARE
C1796     FORMAT('0 TRACKS ',I3,' &',I3,' SHARE ',I3,' HITS.')
C+++
          IF( NSHARE .EQ. 0 ) GO TO 189
          LOSER = IMU
          IF( NHIMU .EQ. NHJMU ) GO TO 185
            IF( NHIMU .GT. NHJMU ) LOSER = JMU
            GO TO 187
C
  185       IF( PROBTR(I) .GT. PROBTR(J) ) LOSER = JMU
C
  187     IF( IMUCAN(LOSER) .GT. 0 ) IMUCAN(LOSER) = - IMUCAN(LOSER)
C
  189   CONTINUE
  199 CONTINUE
C
C
C        FINAL STAGE  :  MODIFY  MUR2/1  BANK  FOR  THE  SELECTED  MUON
C        CANDIDATES. FOR A SELECTED MUON , PUT I*2 WORD  53  OF  MUR2/1
C        EQUAL TO 1/5/9. OTHERWISE, IT REMAINS ZERO.
C
C
  400 DO  450  I = 1,NOMU
        IF( IMUCAN(I) .LE. 0 ) GO TO 450
C
        ITRAK = IABS(IMUCAN(I))
C
        IF(     PROBTR(ITRAK) .LT. CUTPRO
     +     .OR. PMOMTR(ITRAK) .LT. CUTP
     +     .OR. IQUTR(ITRAK)  .GE. 100
     +     .OR. XABSTR(ITRAK) .LT. CUTABS  )  GO TO 450
C
C+++
C       WRITE(6,445)IMUCAN(I)
C 445   FORMAT('0     SELECTED MUON TRACK ',I4)
C+++
C
C                            THIS IS A MUON EVENT SO SET FLAG
C
        MUEVNT = .TRUE.
C
        HDATA( 2*IMUR21 + 2*NMUW*(IMUCAN(I)-1) + 53 ) = 1
C
C                            MARK TRACKS WITH HIGHER NO. OF ABS LENGTHS
C                            AND NO MISSING HITS.
C
        IF(MISHIT(ITRAK).GT.0  .OR.  XABSTR(ITRAK) .LT. 5.8 ) GO TO 447
          HDATA( 2*IMUR21 + 2*NMUW*(IMUCAN(I)-1) + 53 ) = 5
C
C                            MARK TRACKS  WITH  AT  LEAST  THREE  OUTER
C                            LAYERS....TYPE 9.
C                            INCREMENT STATISTICS FOR TYPE 9
C
          IF( NOLAYR(ITRAK) .LT. 3 ) GO TO 446
            HDATA( 2*IMUR21 + 2*NMUW*(IMUCAN(I)-1) + 53 ) = 9
            NMU(14) = NMU(14) + 1
            GO TO 450
C
C                            INCREMENT STATISTICS FOR TYPE 5
C
  446       NMU(13) = NMU(13) + 1
            GO TO 450
C
C                            INCREMENT STATISTICS FOR TYPE 1
C
  447   NMU(12) = NMU(12) + 1
C
  450 CONTINUE
C
C                            COUNT THE NUMBER OF MUON EVENTS
C
  500 IF( MUEVNT ) NMU(11) = NMU(11) + 1
      GO TO 550
C
C                            PROBLEMS , PROBLEMS , .......
C
C                            RECORD OCCURRENCES OF MISSING  MUR2/0  FOR
C                            STATISTICS
C
  111 NMU(5) = NMU(5) + 1
      GO TO 112
C
C                            CHECK IF MU HITS AND PATR TRACKS  IN  THIS
C                            EVENT.IF BOTH YES THEN THIS IS A REAL BANK
C                            MISSING ERROR.INCREMENT STATISTICS COUNTER
C
   11 MUHITS = IDATA(IMUR10 + 1)
      IF( .NOT. ((MUHITS .GT. 0) .AND. (NUMTRK .GT. 0)) ) GO TO 550
      NMU(6) = NMU(6) + 1
  112 CALL MUERRY('MUCUTS',IBANK,' = I, ''MUR2/I'' EXPECTED BUT NOT FOUN
     +D. SERIOUS ERROR^')
C
C
  550 CONTINUE
      RETURN
      END

C   11/03/80 106101752  MEMBER NAME  ERRPRT   (JADEGS)      FORTRAN
      SUBROUTINE ERRPRT(IRETCD,IERRNO)
C
C     PRINTOUT OF RUN + EVENT # FOR EACH ERROR OCCURRENCE
C     P. STEFFEN 11/03/80
C
      IMPLICIT INTEGER*2 (H)
C
#include "cheadr.for"
      LOGICAL*1 LBREAD
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG
      EQUIVALENCE (HHEADR(18),HRUN) , (HHEADR(19),HEV)
C
  100 FORMAT(' *** ERROR TRAP ***')
      WRITE(6,100)
      WRITE(6,100)
      WRITE(6,100)
      PRINT 2001, IERRNO,NRREAD,HRUN,HEV
 2001 FORMAT(' ERROR',I4,' AT',I6,' TH EVENT. RUN, EVNT. NOS. = ',2I6)
      WRITE(6,100)
      WRITE(6,100)
      WRITE(6,100)
      IF(IERRNO.EQ.214) WRITE(6,2002)
 2002 FORMAT(1X,' ERROR 214 HAS OCCURRED. CALL ABEND.')
      IF(IERRNO.EQ.214) CALL ABEND
      IRETCD = 0
      RETURN
      END

C   20/01/79 C9092001   MEMBER NAME  PRCLGC   (SOURCE)      FORTRAN
      SUBROUTINE PRCLGC
C
C      S.YAMADA   20-01-79   23:05
C     LAST MODIFICATION   10-08-79  05:55
C
C     PRINT THE COMMON BLOCK /CLGCHG/
C
      IMPLICIT INTEGER * 2 (H)
#include "clgwork2.for"
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
      DIMENSION JBCCHG(9,100)
      EQUIVALENCE (CXDCHG(1,1),JBCCHG(1,1))
C---- NCHIND=NO. OF CHARGED PARTICLES DETECTED BY THE INNER DET.
C---- NSTEP=1:TRACING FOR THE L.G. COUNTERS,   =2:TRACED FURTHER.
C---- CXDCHG  CONTAINS INNER TRACK INFORMATION
C     JBCCHG(1,N)     HITTING PART
C     CXDCHG(2,N)     CHARGE
C     CXDCHG(3-5,N)   HITTING POSITION ON THE COILOR ON THE END CAP
C     CXDCHG(6-8,N)   DIRECTION COSIGNS
C     CXDCHG(9,N)     ABSOLUTE MOMENTUM
C
      WRITE(6,600) NCHIND
  600 FORMAT('0DUMP OF CLGCHG,    NCHIND=',I5,/,5X,'N  JBC CHARGE',10X,
     $  'X,Y,Z',20X,'DX,DY,DZ',5X,'PABS',5X,'LG CONNECTIONS')
        DO 1 NNN=1,NCHIND
        WRITE(6,601) NNN,JBCCHG(1,NNN),(CXDCHG(MM,NNN),MM=2,9),
     $  (HCLIST(K,NNN),K=1,4)
  601   FORMAT(' ',2I5,F5.1,3X,3F7.1,3X,4F7.4,3X,4I5)
    1   CONTINUE
      RETURN
      END

C   18/05/79 807031524  MEMBER NAME  WERTEX   (JADEGS)      FORTRAN
      SUBROUTINE VERTEX 
C*800623*DITTMANN****************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VERTEX)   18.9.86
C*                                                                  *
C*    THIS VERSION WAS INSTALLED AS A FORERUNNER OF THE NEW VERTEX- *
C*    PACKAGE. THE LATTER WAS RELEASES IN WINTER 87/88 AND DEVIATES *
C*    CONSIDERABLY FROM THE PRESENT MEMBER WERTEX. SINCE WERTEX IS  *
C*    STILL USED FOR BACKWARD COMPATIBILITY, IT IS KEPT ON JADEGS/GL*
C*    THERE IS HOWEVER NOW A CONFLICT WITH THE OLD MACRO MEMBERS ON *
C*    F11GOD.PATRECSR: THESE ARE THE ONES USED IN THIS MEMBER WERTEX*
C*    AND ARE DIFFERENT FROM THE MACROS WITH THE SAME NAMES WHICH   *
C*    ARE SITUATED ON F22KLE.VERTEX.S AND USED IN THE NEW VERSIONS  *
C*    OF THE ROUTINES. FOR THIS REASONS, ALL MACROS IN THIS MEMBER  *
C*    WERE EXPANDED ON 3.7.88. A ROUTINE USED INTERNALLY ONLY HAS   *
C*    BEEN RENAMED:   VTXCRV IS NOW WTXCRV                          *
C*                                                 J.O.  3.7.88     *
C*                                                                  *
C*  UPDATES :  860217 C.K. : PROPER ERRORS DDX,DDY (SPHI,CPHI)      *
C*                           (SPHI,CPHI -DEPENDENCE) INTRODUCED     *
C*                                                                  *
C*  UPDATES :  860316 C.K. : PROPER ERRORS DXY,DPHI INTRODUCED      *
C*                           ( ACCOUNTING OF CURVATURE-ERROR )      *
C*                                                                  *
C*  MODIFICATION OF 20.5.86                  KLE/RAM                *
C*  MAX NO OF TRACKS FOR VERTEX-FIT NOW 20 ( OLD 7)                 *
C*  COMMON CWORK1 NOW IN MACRO MVERTEX                              *
C*  MODIFICATION OF 27.5.86                  KLE/RAM                *
C*  MODES 2, 3, 4 AND STATISTICS                                    *
C*                                                                  *
C*  MODIFICATION OF 03.06.86                 KLE                    *
C*     END OF ITERAION IF MAX(|DS|) NOT SUM(|DS|) < DSCONV          *
C*                                                                  *
C*    +++ BIG MODIFICATION +++                    860611 C.K.       *
C*                                                                  *
C*    * FOR EACH TRACK NOW 40 INSTEAD OF 30 WORDS IN T()            *
C*                                                                  *
C*    * FITS IN RPHI AND ZS ARE TREATED INDEPENDENT                 *
C*      ( DIFFERENT FIRST POINT, MULT. SCATTERING POSSIBLE,         *
C*        THIS IS NECCESSARY FOR 'COMFIT'TED TRACKS         )       *
C*                                                                  *
C*    +++ END MODIFICATION +++                                      *
C*                                                                  *
C*    - HELIX- AND ERROR-CALCULATIONS WITH VTXS (SEE VTXPNT)        *
C*                                                                  *
C%MACRO VTXDEF
C********************************************************************
C*                                                                  *
C*             X - Y - Z   V E R T E X   F I T                      *
C*                                                                  *
C*       INPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)            *
C*       ================                                           *
C*       NT    = TOTAL NR OF TRACKS OF EVENT                        *
C*       IT(1) =         FLAG (0 = TRACK INCOMPLETE OR BAD, NOT USED*
C*                             1 = GOOD, BUT DO NOT USE IN VERTEXFIT*
C*                             2 = GOOD)                            *
C*       T( 2) = +-R     RADIUS(+ MEANS ANTICLOCKWISE LOOKING TO -Z)*
C*          3  = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          4  = THETA   POLAR ANGLE TO XY-PLANE(0=VERTICAL TO BEAM)*
C*          5  = XT      .                                          *
C*          6  = YT      . FIRST MEASURED POINT ON TRACK            *
C*          7  = ZT      .                                          *
C*          8  = DPHI    ERROR OF PHI                               *
C*          9  = DTHETA  ERROR OF THETA                             *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         13  = NPT     NUMBER OF POINTS ON TRACK (INTEGER)        *
C*         14  = 0       NOT USED ON INPUT                          *
C*         15  = S0      INITIAL ARCLENGTH ( = 0. OR CLOSEST        *
C*                          APPROACH TO RUNVERTEX )                 *
C*         16-40         FOR INTERNAL USE (SEE BELOW)               *
C*        (41-80)        2. TRACK                                   *
C*         .....         ........                                   *
C*                                                                  *
C*       OUTPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)           *
C*       =================                                          *
C*       FOR TRACKS WITH IT(1) GT 0                                 *
C*       IT(1) =         FLAG (3 = TRACK WAS USED IN VERTEXFIT)     *
C*       T( 3) = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          5  = XT      .                                          *
C*          6  = YT      . POINT ON TRACK NEAREST TO VERTEX         *
C*          7  = ZT      .                                          *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         14  = NV      NUMBER OF VERTEX TO WHICH TRACK BELONGS (I)*
C*         15  = S       EXTRAPOLATED ARC LENGTH (USUALLY NEGATIVE) *
C*       ALL OTHER T'S ARE UNCHANGED                                *
C*                                                                  *
C*       NV    = TOTAL NUMBER OF VERTICES                           *
C*       IV(1) =         FLAG (0 = NO VERTEX FIT                    *
C*                             1 = BAD VERTEX FIT                   *
C*                             2 = VERTEX OF 1- OR COLLINEAR 2-PRONG*
C*                             3 = GOOD VERTEX FIT                  *
C*                             4 = E+E- PAIR VERTEX                 *
C*                             5 = ISOLATED SINGLE TRACK VERTEX)    *
C*       V( 2) = X       .                                          *
C*          3  = Y       . VERTEX COORDINATES                       *
C*          4  = Z       .                                          *
C*          5  = DX      .                                          *
C*          6  = DY      . ERROR OF X,Y,Z                           *
C*          7  = DZ      .                                          *
C*       IV(8) = NTR     NUMBER OF TRACKS USED IN VERTEX FIT        *
C*       V( 9) = CHI2    CHISQARE OF FIT (N.D.F. = 2*NTR-3)         *
C*       IV(10)= NTRALL  NUMBER OF TRACKS BELONGING TO THIS VERTEX  *
C*        (11-20)        2. VERTEX                                  *
C*         .....         .........                                  *
C*                                                                  *
C*       INTERNAL PARAMETERS                                        *
C*       ===================                                        *
C*       IT(1) IS SET NEGATIV TEMPORARILY IF TRACK BELONGS TO VERTEX*
C*       T(16) = COULOMB SCATTERING ERROR ( TANKWALL )              *
C*       T(17) = COULOMB SCATTERING ERROR ( NEW BEAMPIPE ONLY )     *
C*       T(18) = S TO TANKWALL NEAR                                 *
C*       T(19) = S TO BEAMPIPE NEAR                                 *
C*       T(20) = PROJ. TRACKLENGTH IN RPHI                          *
C*       T(21) = SIN(PHI0)                                          *
C*       T(22) = COS(PHI0)                                          *
C*       T(23) = TAN(THETA)                                         *
C*       T(24) = COS(THETA)                                         *
C*       T(25)   UNUSED                                             *
C*       T(26) = S TO TANKWALL FAR                                  *
C*       T(27) = S TO TANKWALL NEAR                                 *
C*       T(28) = S.D. X                                             *
C*       T(29) = S.D. Y                                             *
C*       T(30) = S.D. Z                                             *
C*                                                                  *
C*       NEW INTERNAL PARAMETERS ( 31 - 40 )               BY KLE   *
C*       -----------------------                                    *
C*       IT(31)= 1 FOR 'COMFIT'TED TRACKS, 0 ELSE                   *
C*                                      ( COVAR. DEFAULTS :   )     *
C*       T(32) = RPHI COVARIANCE : X**4 ( 180 SIG**2/N / L**4 )     *
C*       T(33) = RPHI COVARIANCE : X**3 ( 0.0 )                     *
C*       T(34) = RPHI COVARIANCE : X**2 ( -18 SIG**2/N / L**2 )     *
C*       T(35) = RPHI COVARIANCE : X**1 ( 0.0 )                     *
C*       T(36) = RPHI COVARIANCE : X**0 ( 9/4 SIG**2/N )            *
C*       T(37) = SIG**2/NPT IN ZS                                   *
C*       T(38) = PROJ. TRACKLENGTH IN ZS                            *
C*       T(39) = S0(ZS) - S0(RPHI)                                  *
C*       T(40) = COVARIANCE TERM FOR ANGULAR ERROR                  *
C*                                                                  *
C********************************************************************
C*                                                                  *
C*   MODES :                                                        *
C*  =========                                                       *
C*   BIT 31 ON --> STARTPOINT IS RUNVERTEX ( NOT FIRST MEASURED )   *
C*   BIT 30 ON --> RUNVERTEX CONSTRAIN                              *
C*   BIT 29 ON --> AXIS CONSTRAIN                                   *
C*   BIT 28 ON --> FITS IN RPHI AND Z ARE INDEPENDENT               *
C*   BIT 27 ON --> LOCAL STATISTICS FROM VERTEX                     *
C*   BIT 26 ON --> OVERWRITE PATR-BANK FOR TYP 2 WITH HELIX-        *
C*                 PARAMETERS                                       *
C*   BIT 25 ON --> MESSAGE FROM VTXEE IF FAILED                     *
C*                                                                  *
C********************************************************************
C*                                                                  *
C*       THIS ROUTINE CALLS SUBROUTINE SMINVD FOR SOLVING THE       *
C*       MATRIX EQUATION                                            *
C*                                                                  *
C*       MAINING OF TAXIS:                                          *
C*              1,2,3: X,Y,Z OF RUN-VERTEX                          *
C*              4,5,6: DX**2,DY**2,DZ**2 ERROR**2 OF RUN-VERTEX     *
C*              7,8,9: EX,EY,EZ UNIT-VECTOR OF CONSTRAIN-AXIS       *
C*              10,11,12: ERROR**2 OF CONSTRAIN-AXIS                *
C*                                                                  *
C*                                                                  *
C*   FOR DETAILS OF STATISTICS SEE VTXSTA                           *
C*                                                                  *
C********************************************************************
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR
C
      REAL*8 A,B,DET
C
      LOGICAL LWARN
      LOGICAL LOR, LAXIS, LRVCON, LRVST, LNOZ, LOCSTA
C**
      DATA NCALL / 0 /,LWARN / .TRUE. /
C
      LRVST  = TBIT(MODE,31)
      LRVCON = TBIT(MODE,30)
      LAXIS  = TBIT(MODE,29)
      LNOZ   = TBIT(MODE,28)
      LOCSTA = TBIT(MODE,27)
      LOR    = LRVCON .OR. LAXIS
C
      IERR = 1
      IF(NV.LE.0 .OR. NV.GT.20) GOTO 100
C
      NCALL = NCALL + 1
      IF (NCALL.EQ.1) WRITE(6,9000)
 9000 FORMAT(/
     &' *** NEW VERSION OF VERTEX-PACKAGE IS RUNNING. 24.7.86 C.K. ***'/
     &' ( 40 WORDS PER TRACK IN T(), XY-ERRORS FROM COVARIANCE MATRIX )'
     &/)
      IF (NCALL.EQ.1 .AND. LAXIS) WRITE(6,9001)
 9001 FORMAT(
     & ' *******  SPECIAL VERSION OF VTXPRE/VERTEX  ********',/
     & ' *******     AXIS-CONSTRAINT IS RUNNING     ********'/)
      IF (NCALL.EQ.1 .AND. LRVCON) WRITE(6,9002)
 9002 FORMAT(
     & ' *******  SPECIAL VERSION OF VTXPRE/VERTEX  ********',/
     & ' *******   RUNVERTEX-CONSTRAINT IS RUNNING  ********'/)
C
      LV = (NV-1)*10
      IV(LV+1) = 0
      IERR = 2
      IF(NT.LE.0) GOTO 100
C**
      IF(.NOT.LOR) GOTO 55
         TERR = TAXIS(4)*TAXIS(5)*TAXIS(6)
         IF(TERR .GT. 0.0) GOTO 55
         IF(LWARN) WRITE(6,881)
 881     FORMAT(/' ==== WARNING FROM VERTEX: TAXIS NOT SET',
     &          ' , BUT REQUIRED --> FLAG IGNORED ==== '/)
         LWARN  = .FALSE.
         LAXIS  = .FALSE.
         LRVCON = .FALSE.
 55   CONTINUE
C**
      NREJ  = 0
      NREJV = 0
C                                           ITERATION-LOOP
    1 CONTINUE
      NTRV = 0
      ITER = 0
      CHI2 = 0.
      ITFIN = 0
C                                           CHECK TRACKS
C                                           IF MORE THAN 20,REJECT
C                                           WITH FEWEST MEASURED POINTS
      N = 0
      J = 0
      DO 5 I=1,NT
         IF(IT(J+1).LE.1) GOTO 5
         N = N + 1
         IF(N.GT.20) GOTO 2
            K = N
            GOTO 4
    2    MINPT = 48
         DO 3 K=1,20
            L = NTIND(K)
            IF(IT(L+13).GE.MINPT) GOTO 3
            IMIN = K
            MINPT = IT(L+13)
    3    CONTINUE
         IF(IT(J+13).LE.MINPT) GOTO 5
         K = IMIN
    4    NTIND(K) = J
C        S(K) = 0.
         S(K) = T(J+15)
    5    J = J + 40
C**
      SVR  = 0.0
      DSMAX = 0.0
      IMAX = 0
C**
      IF(N.GT.20) N=20
      NTR = N
      B(1) = 0.0D0
      B(2) = 0.0D0
      IF (LAXIS) N = N + 1
      IERR = 3
      IF(N.LE.0) GOTO 100
      IF (LRVCON) GOTO 10
      IERR = 8
      IF(N.EQ.1) GOTO 50
      IF(N.NE.2) GOTO 10
C                                           CHECK IF COLLINEAR 2-PRONG
      J1 = NTIND(1)
      J2 = NTIND(2)
      COSW = T(J1+24)*T(J2+24) * (T(J1+21)*T(J2+21)+T(J1+22)*T(J2+22))
     *       + SIN(T(J1+4))*SIN(T(J2+4))
      COSW = ABS(COSW)
      IERR = 9
      IF(COSW.GT.COLL2) GOTO 50
C
C                                           VERTEX FIT
   10 CONTINUE
         N = NTR + 3
C**
         IF (LOR) N = N + 1
C**
         L = (N*(N+1))/2
         DO 11 I=1,L
   11       A(I) = 0.D0
         IF(ITFIN.EQ.1) GOTO 13
            DO 12 I=1,N
   12          B(I) = 0.D0
   13    CONTINUE
C**
         IF(.NOT.LOR) GOTO 130
            DDAX = 1./(TAXIS(4) + SVR**2*TAXIS(10))
            DDAY = 1./(TAXIS(5) + SVR**2*TAXIS(11))
            DDAZ = 1./(TAXIS(6) + SVR**2*TAXIS(12))
            XAXIS = TAXIS(1) + SVR*TAXIS(7)
            YAXIS = TAXIS(2) + SVR*TAXIS(8)
            ZAXIS = TAXIS(3) + SVR*TAXIS(9)
            DDAZZ = DDAZ
            IF (LNOZ) DDAZ = 0.
 130     CONTINUE
C**
         DO 19 I=1,NTR
            J = NTIND(I)
            N = I + 3
            L = (N*(N-1))/2
C
C   VTXS IS AN ENTRY POINT IN VTXPNT      J.O. COMMENT
C
            CALL VTXS(J,S(I),XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,DPHIT)
C
            SPHI = SIN(PHIT)
            CPHI = COS(PHIT)
C
            DDX = 1. / DXT2
            DDY = 1. / DYT2
            DDZ = 1. / DZT2
C
            DDZZ = DDZ
            IF (LNOZ) DDZ = 0.
            IF(ITFIN.EQ.0) GOTO 15
               IT(J+1) = 3
               CHITR(I) = DDX*(XT-B(1))**2 + DDY*(YT-B(2))**2
     &                                     + DDZ*(ZT-B(3))**2
               CHI2 = CHI2 + CHITR(I)
               IF ((T(J+5)**2+T(J+6)**2).LT.RTANK**2) NTRV = NTRV + 1
               GOTO 16
   15       CONTINUE
            B(1) = B(1) + DBLE(XT)*DBLE(DDX)
            B(2) = B(2) + DBLE(YT)*DBLE(DDY)
            B(3) = B(3) + DBLE(ZT)*DBLE(DDZZ)
            B(N) = - XT*CPHI*DDX - YT*SPHI*DDY - ZT*T(J+23)*DDZ
   16       A(1) = A(1) + DDX
            A(3) = A(3) + DDY
            A(6) = A(6) + DDZZ
            A(L+1) = -CPHI*DDX
            A(L+2) = -SPHI*DDY
            A(L+3) = -T(J+23)*DDZ
            A(L+N) = CPHI**2*DDX + SPHI**2*DDY + T(J+23)**2*DDZ
   19    CONTINUE
C**
         IF (.NOT.LOR) GOTO 200
            N = NTR + 4
            L = N*(N-1)/2
            IF(ITFIN .EQ. 1) GOTO 190
               B(1) = B(1) + DBLE(XAXIS)*DBLE(DDAX)
               B(2) = B(2) + DBLE(YAXIS)*DBLE(DDAY)
               B(3) = B(3) + DBLE(ZAXIS)*DBLE(DDAZZ)
               B(N) = - XAXIS*TAXIS(7)*DDAX
     &                - YAXIS*TAXIS(8)*DDAY
     &                - ZAXIS*TAXIS(9)*DDAZ
  190       CONTINUE
            A(1) = A(1) + DDAX
            A(3) = A(3) + DDAY
            A(6) = A(6) + DDAZZ
            A(L+1) = -TAXIS(7)*DDAX
            A(L+2) = -TAXIS(8)*DDAY
            A(L+3) = -TAXIS(9)*DDAZ
            A(L+N) = TAXIS(7)**2*DDAX +
     &               TAXIS(8)**2*DDAY +
     &               TAXIS(9)**2*DDAZ
  200    CONTINUE
C**
         IF(ITFIN.EQ.1) GOTO 30
C                                          SOLVE MATRIX EQUATION
C======
C        WRITE(6,8990)ITFIN,N
C8990    FORMAT(' ---> FOR SMINVD ITFIN,N: ',2I5)
C        WRITE(6,8997)(A(JJ),JJ= 1,L)
C8997    FORMAT(' A: ',9G13.4)
C        WRITE(6,8998)(B(JJ),JJ= 1,N)
C8998    FORMAT(' B: ',9G13.4)
C========
         CALL SMINVD(A,B,N,1,DET)
         IERR = 4
         IF(DET.EQ.0.0) GOTO 100
C======
C        WRITE(6,8928)(B(JJ),JJ= 1,N)
C8928    FORMAT(' B  ',9G13.4)
C========
         DSUM  = 0.
         DSMAX = 0.
         IMAX  = 0
         DO 23 I=1,NTR
            J = NTIND(I)
            DS  = B(I+3)
            ADS = ABS(DS)
            IF(ABS(DS/T(J+2)).GT.1.5) GOTO 25
            DSUM = DSUM + ADS
            S(I) = S(I) + DS
            T(J+15) = S(I)
            IF (ADS.LE.DSMAX) GOTO 23
               IMAX = I
               DSMAX = ADS
   23    CONTINUE
C**
         IF (.NOT.LAXIS) GOTO 230
            DS = B(NTR + 4)
            ADS = ABS(DS)
            DSUM = DSUM + ADS
            SVR = SVR + DS
            IF (ADS.LE.DSMAX) GOTO 230
               IMAX = -IMAX
               DSMAX = ADS
  230    CONTINUE
C**
         ITER = ITER + 1
CHANGED  IF(ITER.LT.MITER .AND. DSUM.GT.DSCONV) GOTO 10
         IF(ITER.LT.MITER .AND. DSMAX.GT.DSCONV) GOTO 10
C                                          FIT FINISHED, REPEAT ONCE
C                                          MORE WITH PROPER ERRORS
         ITFIN = 1
C
      GOTO 10
C                         EXTRAPOLATION OF TRACK I EXCEEDS 90 DEG
C                         REMOVE TRACK AND RESTART IF MORE THAN ONE LEFT
   25 IERR = 5
      IF(NTR.LE.2) GOTO 100
      IT(J+1) = 1
      NREJ = NREJ + 1
      IF ((T(J+5)**2+T(J+6)**2).LT.RTANK**2) NREJV = NREJV + 1
C
      GOTO 1
C
   30 CALL SMINVD(A,DUMMY,N,0,DET)
      IERR = 6
      IF(A(1).LT.0.0 .OR. A(3).LT.0.0 .OR. A(6).LT.0.0) GOTO 100
      NDF = 2*NTR - 3
      IF (LNOZ) NDF = NTR - 2
C**
      IF (.NOT.LOR) GOTO 300
         NDF = NDF + 2
         CHI2 = CHI2 + DDAX*(XAXIS-B(1))**2
     &               + DDAY*(YAXIS-B(2))**2
     &               + DDAZ*(ZAXIS-B(3))**2
 300  CONTINUE
C**
      PR = 1.
      IF (NDF.GT.0) PR = PROB(CHI2,NDF)
      IV(LV+1) = 1
      IF(PR.GT.PRCUT) IV(LV+1)=3
      V(LV+2) = B(1)
      V(LV+3) = B(2)
      V(LV+4) = B(3)
      V(LV+5) = DSQRT(A(1))
      V(LV+6) = DSQRT(A(3))
      V(LV+7) = DSQRT(A(6))
      IV(LV+8) = NTR
      V(LV+9) = CHI2
      IERR = -1
      IF(IREJTR.EQ.0) GOTO 100
      IF(IV(LV+1).EQ.3) GOTO 100
      IERR = 7
      IF(NTR.LE.2) GOTO 100
C                                         BAD CHISQUARE
C                                         CHECK IF THERE IS ONE TRACK
C                                         WHICH CONTRIBUTES MOST TO CHI200047300
      CHIMAX = 0.
      DO 32 I=1,NTR
         IF(CHITR(I).LT.CHIMAX) GOTO 32
         CHIMAX = CHITR(I)
         NTMAX = I
   32 CONTINUE
      CHICUT = 3. / NTR
      IF(CHICUT.GT..9) CHICUT=.9
      CHICUT = CHICUT * CHI2
      IERR = 0
      IF(CHIMAX.LT.CHICUT) GOTO 100
      J = NTIND(NTMAX)
      IT(J+1) = 1
      NREJ = NREJ + 1
      IF ((T(J+5)**2+T(J+6)**2).LT.RTANK**2) NREJV = NREJV + 1
C
      GOTO 1
C
C                                           1-PRONG OR COLLINEAR 2-PRONG
C
   50 CONTINUE
      IV(LV+1) = 2
      J = NTIND(1)
      CALL VTXPNT(J,XB,YB,XT1,YT1,ZT1,DXT21,DYT21,DZT21,PHIT,DPHIT,ST)
      IT(J+1) = 3
      IF(NTR.EQ.2) GOTO 52
      V(LV+2) = XT1
      V(LV+3) = YT1
      V(LV+4) = ZT1
      V(LV+5) = SQRT(DXT21)
      V(LV+6) = SQRT(DYT21)
      V(LV+7) = SQRT(DZT21)
      IV(LV+8) = 1
      V(LV+9) = 0.
      IV(LV+10) = 1
      GOTO 100
   52 J = NTIND(2)
      CALL VTXPNT(J,XB,YB,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT,DPHIT,ST)
      IT(J+1) = 3
      V(LV+2) = (XT1+XT2)/2.
      V(LV+3) = (YT1+YT2)/2.
      V(LV+4) = (ZT1+ZT2)/2.
      V(LV+5) = SQRT((DXT21+DXT22)/2.)
      V(LV+6) = SQRT((DYT21+DYT22)/2.)
      V(LV+7) = SQRT((DZT21+DZT22)/2.)
      IV(LV+8) = 2
      V(LV+9) = 0.
      IV(LV+10) = 2
      SDXY1 = SQRT(((XT1-V(LV+2))**2/DXT21 + (YT1-V(LV+3))**2/DYT21)/2.)
      IF(SDXY1.GT.3.) IV(LV+1)=1
      SDXY2 = SQRT(((XT2-V(LV+2))**2/DXT22 + (YT2-V(LV+3))**2/DYT22)/2.)
      IF(SDXY2.GT.3.) IV(LV+1)=1
      SDZ1 = ABS(ZT1-V(LV+4))/SQRT(DZT21)
      IF(SDZ1.GT.3.) IV(LV+1)=1
      SDZ2 = ABS(ZT2-V(LV+4))/SQRT(DZT22)
      IF(SDZ2.GT.3.) IV(LV+1)=1
C
  100 CONTINUE
      IF (.NOT.LOCSTA) GOTO 120
      IF (IERR.LE.0) GOTO 110
      CALL VTXERR(IERR)
      GOTO 120
  110 CONTINUE
      WRITE(6,9345) LRVST,LRVCON,LAXIS,LNOZ,NTR,NTRV,NREJ,NREJV,
     &              ITER,DSMAX,NDF,CHI2
 9345 FORMAT(' START AT RV, RV-CON., AXIS-CON., NO Z : ',4L2/
     &       ' NTR,NREJ           : ',4I6/
     &       ' ITER,DSMAX,NDF,CHI2 : ',I6,G13.4,I6,G13.4)
C
  120 CONTINUE
      HVTXST( 1) = IERR
      HVTXST(19) = ITER
      IDSMAX = 30000
      IF (DSMAX.LT.30.) IDSMAX = IFIX( DSMAX * 1000. )
      HVTXST(20) = IDSMAX
      HVTXST( 2) = HVTXST(2) + 1
      HVTXST(4+IERR) = HVTXST(4+IERR) + 1
      IF (LRVST)  HVTXST(14) = HVTXST(14) + 1
      IF (LRVCON) HVTXST(15) = HVTXST(15) + 1
      IF (LAXIS)  HVTXST(16) = HVTXST(16) + 1
      IF (LNOZ)   HVTXST(17) = HVTXST(17) + 1
      IF (IERR.GT.0) RETURN
C
      HVTXST(18) = IFIX(PR*10000.)
      IF (NTR .GT.19) NTR  = 19
      IF (NTRV.GT.19) NTRV = 19
      HVTXST(21+NTR)  = HVTXST(21+NTR)  + 1
      HVTXST(41+NTRV) = HVTXST(41+NTRV) + 1
      IF (NREJ .GT.19) NREJ  = 19
      IF (NREJV.GT.19) NREJV = 19
      HVTXST(61+NREJ)  = HVTXST(61+NREJ)  + 1
      HVTXST(81+NREJV) = HVTXST(81+NREJV) + 1
      IF (ITER.GT.20) ITER = 20
      HVTXST(100+ITER)  = HVTXST(100+ITER)  + 1
C
      RETURN
      END

C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C

      SUBROUTINE REDONE (INDREJ,LBWRT,IWRT)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CREDON/LIMHIT,LIMHT1,CRVTAG,CRVNTG
      COMMON /CIPRI/ IPRI
      COMMON /CHEADR/ HEAD(108)
      EQUIVALENCE (HRUN,HEAD(18)),(HEVENT,HEAD(19))
      DATA ETAGLM /300./
      DATA MKTAGE /Z400/, MKLGLE /Z200/, MKLUMI /Z100/, MKFWMU/Z800/
      DATA MKMUCN /Z00F/
        IQHEAD = IBLN('HEAD')
        IQTRIG = IBLN('TRIG')
        IQALGN = IBLN('ALGN')
        IQZVTX = IBLN('ZVTX')
        IQJETC = IBLN('JETC')
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
      IPHEAD=IDATA(IQHEAD)
      CALL MVCL(HEAD(1),0,IDATA(IPHEAD-3),0,216)
      INDREJ = 0
      LBWRT = 0
        IWRT = 0
        IFLW= 0
        IF(HEAD(23).NE.0) IFLW = 1
        LBTRBT = 0
        IPTRIG = IDATA(IQTRIG)
        IF(IPTRIG.GT.0 .AND. IDATA(IPTRIG-2).EQ.1)
     ?  LBTRBT = HDATA(IPTRIG*2+10)
        ILUMI = 0
        IF(LAND(LBTRBT,MKLUMI).NE.0) ILUMI = 1
        IMUACC=0
        IF(LAND(LBTRBT,MKFWMU).NE.0) CALL MEWT3(IMUACC)
      IF(
     - IMUACC.LE.0
     -)THEN
        CALL TRGCHK(LBTRCK,LBTRBT)
        INDREJ =  1
        IF(IPRI.GT.0.AND.LBTRCK.EQ.0) WRITE(6,4810)
4810  FORMAT(' REJECTED BY TRIGGER CHECK  ')
        IF(LBTRCK.EQ.0) RETURN
        IACC = 0
        CALL LGCUTX(IACC,ECYL,ECAMI,ECAPL,ETOT)
        IF(LAND(LBTRBT,MKLGLE).EQ.0) IACC = 0
        IFTG = 0
        IF(LAND(LBTRBT,2).NE.0) CALL TAGFLG(IFTG)
        ETAG = 0.
        IF(IFTG.NE.0. .AND. LAND(LBTRBT,MKTAGE).NE.0) ETAG = ETOT
        IF(IACC.NE.     0) IWRT = 1
        IF(IFLW.NE.     0) IWRT = IWRT + 2
      IF(
     - ETAG.GT.ETAGLM .AND. IWRT.EQ.0
     -)THEN
          ECENTR = 0.
          IF(IFTG.EQ.11) ECENTR = ETOT - ECAMI
          IF(IFTG.EQ.12) ECENTR = ETOT - ECAPL
          IF(IFTG.GT.12) ECENTR = ETOT
          IF(ECENTR.GT.100.) IWRT = IWRT + 4
      ENDIF
        INDREJ =  2
        IF(IPRI.GT.0.AND.LBTRCK.EQ.16.AND.IWRT.EQ.0) WRITE(6,4811)
4811  FORMAT(' REJECTED BY TRIGGER CHECK, WITH IWRT = 0 ,NO TRACKS ')
        IF(IWRT.EQ.0 .AND. LBTRCK.EQ.16) RETURN
      ELSE
        IWRT=1
        LBWRT=16
        INDREJ = 0
        IF(IPRI.GT.0) WRITE(6,4521)
4521  FORMAT(' ACCEPTED AS FW MU TRIGGER WITH MU TRACKS ')
        RETURN
      ENDIF
        IPJCA  = IDATA(IQJETC)
      IF(
     - IPJCA.LE.0
     -)THEN
          INDREJ =  3
        IF(IPRI.GT.0.AND.IWRT.EQ.0) WRITE(6,4812)
4812  FORMAT(' NO HITS IN INNER DET.,WITH IWRT = 0  REJECTED ')
          IF(IWRT.EQ.0) RETURN
          INDREJ = 0
          LBWRT =  1
        IF(IPRI.GT.0) WRITE(6,4813)
4813  FORMAT(' NO HITS IN INNER DET.,WITH IWRT = 1  ACCEPTED ')
          RETURN
      ENDIF
        INDREJ = 0
        LBWRT = 2
        IF(IPRI.GT.0.AND.(IWRT.EQ.1.OR.IWRT.EQ.4)) WRITE(6,4814)
4814  FORMAT('  IWRT = 1,4 ACCEPTED ')
        IF(LAND(IWRT,5).NE.0) RETURN
        LBWRT = 0
        IPJCA  = IDATA(IQJETC)
        IPJCA2 = IPJCA*2
        IPZV   = IDATA(IQZVTX)
      IF(
     - IPZV.GT.0
     -)THEN
          IFLAG  = IDATA(IPZV+6)
          ZVTX   = ADATA(IPZV+1)
          PEAK   = ADATA(IPZV+4)
          IF(IFLAG.LT.3 .AND. LBTRCK.EQ.8) IFLAG = 0
      IF(
     - IFLAG.LE.0
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
                INDREJ=4
                IF(IPRI.GT.0) WRITE(6,4347)
4347  FORMAT('  NO ZVTX FOUND,IWRT=0   REJECTED ')
      ELSE
                LBWRT = 14
                IF(IPRI.GT.0) WRITE(6,4387)
4387  FORMAT('  NO ZVTX FOUND,IWRT>0   ACCEPTED ')
      ENDIF
             RETURN
      ELSE
      IF(
     - ABS(ZVTX).GT.350.
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
                INDREJ=5
                IF(IPRI.GT.0) WRITE(6,9347)
9347  FORMAT('  ZVTX > 350,IWRT=0   REJECTED ')
      ELSE
                LBWRT = 15
                IF(IPRI.GT.0) WRITE(6,9387)
9387  FORMAT('  ZVTX > 350,IWRT>0   ACCEPTED ')
      ENDIF
             RETURN
      ENDIF
      ENDIF
      ELSE
      IF(
     - IWRT.EQ.0
     -)THEN
             INDREJ=6
        IF(IPRI.GT.0) WRITE(6,4817)
4817  FORMAT('  NO ZVTX BANK,IWRT=0   REJECTED ')
      ELSE
             LBWRT = 6
        IF(IPRI.GT.0) WRITE(6,4887)
4887  FORMAT('  NO ZVTX BANK,IWRT>0   ACCEPTED ')
      ENDIF
          RETURN
      ENDIF
        IPPATR = IDATA(IQPATR)
      IF(
     - IPPATR.LE.0
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
              INDREJ = 7
        IF(IPRI.GT.0) WRITE(6,4818)
4818  FORMAT('  NO PATR BANK,IWRT=0   REJECTED ')
      ELSE
              LBWRT = 7
        IF(IPRI.GT.0) WRITE(6,4888)
4888  FORMAT('  NO PATR BANK, IWRT>0  ACCEPTED ')
      ENDIF
           RETURN
      ENDIF
        NTR    = IDATA(IPPATR+2)
        LDTR   = IDATA(IPPATR+3)
        IPTR0  = IPPATR + IDATA(IPPATR+1)
        IPTR9  = IPTR0 + (NTR-1)*LDTR
      IF(
     - NTR.LE.0
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
             INDREJ = 8
             IF(IPRI.GT.0) WRITE(6,4819)
4819  FORMAT('  NO TRACKS, IWRT=0   REJECTED ')
      ELSE
             LBWRT = 8
             IF(IPRI.GT.0) WRITE(6,4889)
4889  FORMAT('  NO TRACKS, IWRT>0   ACCEPTED ')
      ENDIF
          RETURN
      ENDIF
      IF(
     - IFTG.NE.0
     -)THEN
          ACRV=1000.
          ZMIN = 1000.
      DO 13000 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+24).GT.LIMHIT
     -)THEN
              CRV = ADATA(IPTR+25)
              IF(ABS(CRV).LT.ACRV) ACRV=ABS(CRV)
      IF(
     - ABS(CRV)      .LE.CRVTAG
     -)THEN
                AZV = ADATA(IPTR+31)
                IF(ABS(AZV).LT.ABS(ZMIN)) ZMIN = AZV
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      IF(
     - ABS(ZMIN).GT.300.
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
               INDREJ = 9
               IF(IPRI.GT.0) WRITE(6,4829)
4829  FORMAT('  TAGGED EVENT, ZMIN > 300 MM IWRT=0   REJECTED ')
      ELSE
               LBWRT = 9
               IF(IPRI.GT.0) WRITE(6,4869)
4869  FORMAT('  TAGGED EVENT, ZMIN > 300 MM IWRT>0   ACCEPTED ')
      ENDIF
            RETURN
      ENDIF
          IWRT = IWRT + 16
          INDREJ = 0
          LBWRT = 3
        IF(IPRI.GT.0) WRITE(6,4830)
4830  FORMAT('  TAGGED EVENT, ZMIN < 300 MM  ACCEPTED ')
          RETURN
      ENDIF
        LBLONG = 0
        NE100 = 0
        ZSUM = 0.
        LBEHIG = 0
        ACRV=1000.
        ZAV=0.
        ZMIN = 1000.
        IKNT=0
      DO 13002 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+33).GT.LIMHIT
     -)THEN
            LBLONG = 1
            CRV = ADATA(IPTR+25)
            AZV = ADATA(IPTR+31)
            IF(ABS(CRV).LT.ACRV) ACRV=ABS(CRV)
      IF(
     - ABS(CRV)      .LE.CRVNTG
     -)THEN
              LBEHIG = 1
              ZAV=ZAV+AZV
              IKNT=IKNT+1
              IF(ABS(AZV).LT.ABS(ZMIN)) ZMIN = AZV
      ELSE
      IF(
     - ABS(CRV).LT.CRVTAG.AND.ABS(AZV).LE.300.
     -)THEN
                RSQ = ADATA(IPTR+5)**2+ADATA(IPTR+6)**2
      IF(
     - RSQ.LT.250000.
     -)THEN
                   NE100 = NE100 + 1
                   ZSUM = AZV + ZSUM
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
        ISTAR = LBEHIG*2 + LBLONG
        IF(NE100.GE.2) ISTAR = ISTAR + 4
        IF(IKNT.GT.0) ZAV=ZAV/FLOAT(IKNT)
        IF(NE100.GE.2.AND.LBEHIG.EQ.0) ZMIN = ZSUM/FLOAT(NE100)
      IF(
     - LBLONG.EQ.0
     -)THEN
          ETOTX = ECAMI + ECAPL
          ACRV=1000.
          IKNT=0
      DO 13004 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+24).GT.LIMHT1
     -)THEN
              LBLONG = 1
              CRV = ADATA(IPTR+25)
              IF(ABS(CRV).LT.ACRV) ACRV=ABS(CRV)
              IKNT=IKNT+1
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - LBLONG.EQ.0
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
               INDREJ = 10
               IF(IPRI.GT.0) WRITE(6,4831)
4831  FORMAT('  NOTAG EVENT, ONLY SHORT TRACKS  IWRT=0    REJECTED ')
      ELSE
               LBWRT = 10
               IF(IPRI.GT.0) WRITE(6,4851)
4851  FORMAT('  NOTAG EVENT, ONLY SHORT TRACKS  IWRT>0  ACCEPTED ')
      ENDIF
            RETURN
      ENDIF
          INDREJ = 0
          LBWRT = 4
        IF(IPRI.GT.0) WRITE(6,4832)
4832  FORMAT('  NOTAG EVENT, LONG TRACKS RFI, SHORT RZ, ACCEPTED ')
          IWRT = IWRT + 32
          RETURN
      ENDIF
      IF(
     - LBEHIG.EQ.0.AND.NE100.LT.2
     -)THEN
          ETOTX = ECAMI + ECAPL
      IF(
     - IWRT.EQ.0
     -)THEN
             INDREJ = 11
             IF(IPRI.GT.0) WRITE(6,4833)
4833  FORMAT(' LONG TRKS < 600 , < 2 WEAK TRACKS, IWRT=0  REJECTED')
      ELSE
             LBWRT = 11
             IF(IPRI.GT.0) WRITE(6,4873)
4873  FORMAT(' LONG TRKS < 600 , < 2 WEAK TRACKS, IWRT>0  ACCEPTED')
      ENDIF
          RETURN
      ENDIF
      IF(
     - ABS(ZMIN).GT.300.
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
             INDREJ = 12
             IF(IPRI.GT.0) WRITE(6,4834)
4834  FORMAT(' LONG TRKS > 600, OR<2 WEAK TR.ZMIN>300 IWRT=0 REJECTED')
      ELSE
             LBWRT = 12
             IF(IPRI.GT.0) WRITE(6,4884)
4884  FORMAT(' LONG TRKS > 600, OR<2 WEAK TR.ZMIN>300 IWRT>0 ACCEPTED')
      ENDIF
          RETURN
      ENDIF
        RMIN=10000.
      DO 13006 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+33).GT.LIMHIT
     -)THEN
            CRV = ADATA(IPTR+25)
            AZV = ADATA(IPTR+31)
      IF(
     - ABS(CRV)      .LE.CRVTAG.AND.ABS(AZV).LE.300.
     -)THEN
              CALL PRTOCI(IPTR,DUM1,RM,DUM2,DUM3)
              IF(RM.LT.RMIN) RMIN=RM
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
      IF(
     - RMIN.GT.60.
     -)THEN
      IF(
     - IWRT.EQ.0
     -)THEN
              INDREJ = 13
              IF(IPRI.GT.0) WRITE(6,4835)
4835  FORMAT(' LONG>600,OR<2 WEAK TR.ZMN>300 IWRT=0 RMIN>60 REJECTED')
      ELSE
              LBWRT = 13
              IF(IPRI.GT.0) WRITE(6,4895)
4895  FORMAT(' LONG>600,OR<2 WEAK TR.ZMN>300 IWRT>0 RMIN>60 ACCEPTED')
      ENDIF
           RETURN
      ENDIF
        INDREJ = 0
        LBWRT  = 5
        IF(IPRI.GT.0) WRITE(6,4836)
4836  FORMAT(' LONG TR>600 OR 2 WEAK TR., ZMIN<300 RMIN<60  ACCEPTED')
        IWRT = IWRT + 64
        RETURN
      END
      BLOCK DATA
      COMMON /CREDON/LIMHIT,LIMHT1,CRVTAG,CRVNTG
      COMMON /CIPRI/IPRI
      DATA IPRI /0/
      DATA LIMHIT/12/, LIMHT1/20/
      DATA CRVTAG/.00150/, CRVNTG/.00025/
C      STOP
      END
      SUBROUTINE TRGCHK(LBTRCK,LBTRBT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cdata.for"
#include "cheadr.for"
      COMMON /CWORK/ ILGE(84),HCLWR(96)
      DATA MKTREV /Z653/, MKT2AC /Z53/, MKEHIG /Z600/
      INTEGER MKTRBT( 7) /1,2,4,8,16,32,64/
      INTEGER NCTOF ( 7) /2,3,3,3,3,3,3/
      INTEGER ICTOF ( 7) /0,1,2,3,4,5,6/
      LBTRCK = 0
      IF(LAND(LBTRBT,MKTREV).EQ.0) RETURN
      IF(LAND(LBTRBT,MKEHIG).NE.0) LBTRCK = 16
      IF(LAND(LBTRBT,MKT2AC).EQ.0) RETURN
      CALL SETSL(ILGE(1),0,528,0)
16000 CONTINUE
        IPALGN = IDATA(IBLN('ALGN'))
      IF(
     - IPALGN.LE.0
     -)THEN
      GOTO 16001
      ENDIF
      IF(
     - IDATA(IPALGN).LE. 3
     -)THEN
      GOTO 16001
      ENDIF
        IPLG2 = IPALGN*2
        NBARR = HDATA(IPLG2+ 4) - HDATA(IPLG2+ 3)
      IF(
     - NBARR.LE.0
     -)THEN
      GOTO 16001
      ENDIF
        IP0 = IPLG2 + 7
        IP9 = IP0 + NBARR - 1
      DO 13000 IP=IP0,IP9,2
          NBL  = HDATA(IP)
          IROW = ISHFTR(NBL,5)
          ILGE(IROW) = ILGE(IROW) + HDATA(IP+1)
13000 CONTINUE
13001 CONTINUE
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16000
16001 CONTINUE
      IPJETC = IDATA(IBLN('JETC'))
      IF(IPJETC.LE.0) RETURN
      IF(IDATA(IPJETC).LE.50) RETURN
      IPJC2 = IPJETC*2
      NHTR3 = HDATA(IPJC2+99) - HDATA(IPJC2+51)
      IF(NHTR3.LE.0) RETURN
      IP0 = IPJC2 + 100 + HDATA(IPJC2+51)
      IP9 = IP0 + NHTR3 - 1
      IWIR0 =-1
      DO 13002 IP=IP0,IP9,4
        IWIR = HDATA(IP)
        IWIR = ISHFTR(IWIR,3)
        HCLL = ISHFTR(IWIR,3) - 95
        IF(IWIR.NE.IWIR0) HCLWR(HCLL) = HCLWR(HCLL) + 1
        IWIR0 = IWIR
13002 CONTINUE
13003 CONTINUE
      IPLATC = IDATA(IBLN('LATC'))
      IF(IPLATC.LE.0) RETURN
      IPLT2 = IPLATC*2
      IP0 = IPLT2 + 6
      IP9 = IP0 + 5
      ITLST =-100
      ITOF0 = 0
      ICLL0 = 0
      NTRCK = 0
      NTREL = 0
16002 CONTINUE
        ITRBT = HDATA(IP0)
      DO 13004 JTOF=1,7
      IF(
     - LAND(MKTRBT(JTOF),ITRBT) .NE. 0
     -)THEN
            ITOF = ITOF0 + JTOF
            JCTOF = (ICTOF(JTOF) + ICLL0)*2 - 1
            LBTRK = 0
      IF(
     - ITOF-ITLST.LE.2
     -)THEN
              HCLL9 = NCTOF(JTOF)*2 + JCTOF - 1
              HCLL1 =-99
              MTRK = 0
      DO 13006 ICLL=HCLL0,HCLL9
      IF(
     - HCLWR(ICLL).GE.6
     -)THEN
                  HDCLL = ICLL - HCLL1
      IF(
     - HDCLL.EQ.1
     -)THEN
                    HCLL1 = -99
      ELSE
      IF(
     - HDCLL.NE.3 .OR. TBIT(ICLL,31)
     -)THEN
                      MTRK = MTRK + 1
                      HCLL1 = ICLL
      ENDIF
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
              IF(MTRK.GE.2) LBTRK = 1
      ELSE
              NHIT5 = 0
              NHIT6 = 0
      IF(
     - JCTOF.LT.0
     -)THEN
                NHIT1 = HCLWR(95)
                NHIT2 = HCLWR(96)
                NHIT3 = HCLWR( 1)
                NHIT4 = HCLWR( 2)
                IF(NHIT2.GE.3 .AND. HCLWR(93).GE.6) NHIT2 = 8
                IF(NHIT4.GE.3 .AND. HCLWR( 3).GE.6) NHIT4 = 8
      ELSE
                NHIT1 = HCLWR(JCTOF  )
                NHIT2 = HCLWR(JCTOF+1)
                NHIT3 = HCLWR(JCTOF+2)
                NHIT4 = HCLWR(JCTOF+3)
      IF(
     - NCTOF(JTOF).EQ.3
     -)THEN
                  NHIT5 = HCLWR(JCTOF+4)
                  NHIT6 = HCLWR(JCTOF+5)
      ELSE
                  IF(NHIT2.GE.3 .AND. HCLWR(JCTOF-2).GE.6) NHIT2 = 8
                  IF(NHIT4.GE.3 .AND. HCLWR(JCTOF+4).GE.6) NHIT4 = 8
      ENDIF
      ENDIF
              IF(MAX0(NHIT1,NHIT2,NHIT3,NHIT4,NHIT5,NHIT6).GE.6) LBTRK=100062700
      ENDIF
      IF(
     - LBTRK.NE.0
     -)THEN
              NTRCK = NTRCK + 1
              ITLST = ITOF
              HCLL0 = JCTOF
              IR = ITOF*2 - 3
      IF(
     - ITOF.EQ.1
     -)THEN
                ILGENG = ILGE(83)+ILGE(  84)+ILGE(   1)+ILGE(   2)
      ELSE
      IF(
     - ITOF.EQ.42
     -)THEN
                  ILGENG = ILGE(82)+ILGE(  83)+ILGE(  84)+ILGE(   1)
      ELSE
                  ILGENG = ILGE(IR)+ILGE(IR+1)+ILGE(IR+2)+ILGE(IR+3)
      ENDIF
                IF(ILGENG.GT.1000) NTREL = NTREL + 1
      ENDIF
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
      ICLL0 = ICLL0 + 8
      ITOF0 = ITOF0 + 7
      IP0   = IP0   + 1
      IF(.NOT.(
     - IP0.GT.IP9
     -))GOTO 16002
16003 CONTINUE
      LB1TCL = 0
      IF(
     - NTRCK.EQ.1 .AND. NTREL.EQ.0
     -)THEN
        IPJC2 = IPJETC*2
        NHTR1 = HDATA(IPJC2+27) - HDATA(IPJC2+ 3)
      IF(
     - NHTR1.GT.96 .AND. NHTR1.LT.196
     -)THEN
          CALL SETS(HCLWR(1),0,48,0)
          IP0 = IPJC2 + 100 + HDATA(IPJC2+ 3)
          IP9 = IP0 + NHTR1 - 1
          IWIR0 =-1
      DO 13008 IP=IP0,IP9,4
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            HCLL = ISHFTR(IWIR,3) + 1
            IF(IWIR.NE.IWIR0) HCLWR(HCLL) = HCLWR(HCLL) + 1
            IWIR0 = IWIR
13008 CONTINUE
13009 CONTINUE
          MTRK = 0
          HCLL1 =-99
      DO 13010 ICLL=1,48
      IF(
     - HCLWR(ICLL).GE.6
     -)THEN
              HDCLL = ICLL - HCLL1
      IF(
     - HDCLL.EQ.1
     -)THEN
                HCLL1 = -99
      ELSE
      IF(
     - HDCLL.NE.3 .OR. TBIT(ICLL,31)
     -)THEN
                  MTRK = MTRK + 1
                  HCLL1 = ICLL
      ENDIF
      ENDIF
      ENDIF
13010 CONTINUE
13011 CONTINUE
          IF(MTRK.EQ.2 .OR. MTRK.EQ.3) LB1TCL = 1
      ENDIF
      ENDIF
      IF(NTRCK .GE.2) LBTRCK = LBTRCK + 2
      IF(NTRCK .EQ.1 .AND. LAND(LBTRBT,2).NE.0) LBTRCK = LBTRCK + 1
      IF(NTREL .EQ.1) LBTRCK = LBTRCK + 4
      IF(LB1TCL.EQ.1) LBTRCK = LBTRCK + 8
      RETURN
      END

C   07/06/96 606071842  MEMBER NAME  DOPART   (S4)          FORTG1
C   05/12/76 C8050101   MEMBER NAME  DEFIND   (QLIBS)       FORTRAN
      SUBROUTINE DOPART
      COMMON/BCS/IW(1)
      COMMON/BNKIND/ISTAT,IRN,IHD,IVT
C
C     DOPART - NEW VERSION OF DEFIND
C              MAKES PART-BANKS FROM TRAC-BANKS ACC. TO
C              LIST IN BANK ('VERT',1)
C              BUT NO PREPARATION FOR KINEMATICAL FIT
C                  --------------
C              DELETES OLD BANK ('PART',32), IF EXISTING
      CALL VZERO(ISTAT,4)
      CALL BLOC(IRN,'RUN ',0,&1)
    1 CALL BLOC(IVT,'VERT',1,&100)
    2 CALL BLOC(IHD,'HEAD',0,&3)
    3 CONTINUE
      NTR=IW(IVT+2)
      CALL BLOC(IND,'PART',32,&5)
      IF(IW(IND+6).NE.3.OR.IW(IND+7).NE.1) GOTO 5
      CALL BDLS('PART',32)
    5 CALL BSAW(1,'PART')
      IF(NTR.EQ.0) GOTO 15
      DO 10 I=1,NTR
      N=IW(IVT+10+I)
      CALL BLOC(IND,'PART',N,&6)
      GOTO 7
    6 CALL BLOC(IND,'TRAC',N,&10)
      CALL TRPART(IND,&10)
      CALL BLOC(IND,'PART',N,&10)
    7 CONTINUE
   10 CONTINUE
   15 CONTINUE
  100 RETURN
      END

C   07/06/96 606071823  MEMBER NAME  BLOCDA   (S4)          FORTG1
      SUBROUTINE BLOCDA(IUNDA,IND,NAME,NR,*)
C     BOS SUBPROGRAM  =4.1=
      COMMON/BCS/IW(1)
#include "ccs.for"
      REAL*8 DATE(2)
      INTEGER IPR/0/
      IUND=IUNDA
      CALL BLOC(IND,NAME,NR,&10)
      GOTO 100
   10 LISTE(1)=NAME
      LISTE(2)=NR
      CALL PODA(1,LISTE,1)
      IF(INDT.EQ.0) GOTO 101
      CALL BCRE(IND,NAME,NR,0,&101,IER)
      INDC=IND
      CALL DADA(1,&12)
      IF(LISTE(4).NE.IW(IND)) GOTO 12
      GOTO 100
   12 CALL BDLS(NAME,NR)
      GOTO 101
C
      ENTRY BDLSDA(IUNDA,NAME,NR)
      ID=25
      JD=-1
      IUND=IUNDA
      LISTE(1)=NAME
      LISTE(2)=NR
      CALL PODA(1,LISTE,1)
      IF(IW(INDA+20).NE.0) GOTO 100
      IF(INDT.EQ.0) GOTO 100
      CALL CHDIR
      NPT=IW(INDT+3)
      CALL DADA(2,&50)
      CALL PODA(2,LISTE,1)
      IW(INDA+51)=IW(INDA+51)+1
      IF(IW(INDA+51).LE.100) WRITE(6,104) NAME,NR,IUNDA
      IF(IW(INDA+51).EQ.100) WRITE(6,109)
      GOTO 40
C
      ENTRY BCREDA(IUNDA,INDAR)
      ID=25
      JD=1
      IUND=IUNDA
      INDC=INDAR
      IF(IW(INDAR).LE.0) GOTO 60
      IF(IW(INDAR).GT.3200) GOTO 60
      LISTE(1)=IW(INDAR-3)
      LISTE(2)=IW(INDAR-2)
      CALL PODA(1,LISTE,1)
      IF(IW(INDA+20).NE.0) GOTO 100
      IF(IW(INDA+7)+2+IW(INDAR)/1610.GT.IW(INDA+6)) GOTO 60
      CALL CHDIR
      ICO=1
      IF(INDT.EQ.0) GOTO 20
      IW(INDA+34)=IW(INDA+34)-1
      ICO=2
      IF(IW(INDAR).EQ.LISTE(4)) GOTO 22
      CALL DADA(2,&50)
      CALL PODA(2,LISTE,1)
   20 CALL DADA(3,&50)
      CALL PODA(3,LISTE,1)
      GOTO 24
   22 CALL DADA(4,&50)
   24 IW(INDA+51)=IW(INDA+51)+1
      IF(IW(INDA+51).GT.100) GOTO 40
      GOTO (26,28),ICO
   26 WRITE(6,102) LISTE(1),LISTE(2),IUNDA
      GOTO 30
   28 WRITE(6,103) LISTE(1),LISTE(2),IUNDA
   30 IF(IW(INDA+51).EQ.100) WRITE(6,109)
C
   40 CALL DAY(DATE(1),DATE(2))
      CALL UCOPY(DATE,IW(INDA+ID),4)
      IW(INDA+34)=IW(INDA+34)+JD
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      GOTO 100
   50 CALL WRDA(1,IW(INDA+1),IW(INDA+2))
   60 IPR=IPR+1
      IF(IPR.GT.100) GOTO 100
      IF(JD.EQ.1) WRITE(6,107) IW(INDAR-3),IW(INDAR-2),IW(INDAR)
      IF(JD.NE.1) WRITE(6,108) NAME,NR
      GOTO 100
C
      ENTRY BCHKDA(IUNDA,NAME,NR,NWD)
      IUND=IUNDA
      LISTE(1)=NAME
      LISTE(2)=NR
      CALL PODA(1,LISTE,1)
      NWD=0
      IF(INDT.EQ.0) GOTO 100
      NWD=LISTE(4)
C
  100 RETURN
  101 RETURN 1
  102 FORMAT(' ---- BCREDA',5X,'BANK (',A4,',',I10,')   ADDED TO   ',
     1   'DATA SET',I3)
  103 FORMAT(' ---- BCREDA',5X,'BANK (',A4,',',I10,') REPLACED IN  ',
     1   'DATA SET',I3)
  104 FORMAT(' ---- BDLSDA',5X,'BANK (',A4,',',I10,') DELETED FROM ',
     1   'DATA SET',I3)
  107 FORMAT('0---- BCREDA     UNABLE TO STORE BANK (',A4,',',I10,
     1   ')',I10,' WORDS')
  108 FORMAT('0---- BDLSDA     UNABLE TO DELETE BANK (',A4,',',I10,')')
  109 FORMAT(' ---- BCREDA/BDLSDA - PRINTOUT SUPPRESSED')
      END

C   17/05/88 805171201  MEMBER NAME  EBGENL   (S)           FORTRAN77
      FUNCTION EBGENL( DUMMY )
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1)
      EQUIVALENCE (HW(1),IW(1))
      COMMON / CPROD / NEV, BEAM
      DATA ICALL / 0 /
C
      IF( ICALL .GT. 0 ) GO TO 1
      IBHEAD = IBLN('HEAD')
      ICALL = 1
    1 CONTINUE
      NPHEAD = IW(IBHEAD)
      IF( NPHEAD .LE. 0 ) GO TO 100
      HRUN = HW( NPHEAD*2+10)
      EBGENL= EBEAM( HRUN ) / 1000.
      RETURN
C                                           BEAM FROM CPROD
  100 EBGENL = BEAM
      RETURN
      END

C   05/08/84 507171442 MEMBER NAME  WALLOC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE WALLOC
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON      ?     :  ALLOCATE OUTPUT DATASET
C
C        MOD: J. OLSSON    3/11/82 :
C   LAST MOD: C. BOWDERY  17/07/85 :  SMALL CHANGES, NEW NAME
C
C      ALLOCATE OUTPUT DATA SET IN GRAPHICS, JADE ROUTINE
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      REAL*8 DDN
C
#include "cgraph.for"
#include "ciouni.for"
C
      COMMON / CBSTR  / MODE,MAXRL
      COMMON / CSVCW1 / NDDSVE,NRWR
      COMMON / CWALLK / IOUTSV(11)
      DIMENSION IDATAL(11),HVOLSR(4)
      DATA ICONT /'CONT'/
      DATA HBLANK/'  '/
*** PMF 02/12/99
      INTEGER LI
      CHARACTER CDATAL*44
      EQUIVALENCE (CDATAL,IDATAL(1))
*** PMF (end)
C
C-------------------  C O D E  -----------------------------------------
C
   1  CALL TRMOUT(80,'Please enter FULL NAME of catalogued dataset for e
     $vent output:^')
      CALL TRMIN(44,IDATAL)
C
C                            TEST FOR THE STRING CONTINUE.
C
      IF(IDATAL(1).NE.ICONT) GO TO 9
      NDDOUT = 0
      GO TO 200
C
C                            ALLOCATE UNIT NUMBER TO OUTPUT DATA SET.
C
9     CONTINUE
      DO 111  I = 1,11
111   IOUTSV(I) = IDATAL(I)
   16 CONTINUE
      DO 3 I=1,4
    3 HVOLSR(I)=HBLANK
      NDDOUT=0
      CALL TRMOUT(80,'The dataset will now be allocated. Please be patie
     $nt for a few moments.^')
*** PMF 02/12/99: add suffix '.EVENT@' to the file name.
*     '@' tells GETPDD that the specified output file does
*     not need to exist before allocation.
      LI= MIN(INDEX(CDATAL,' '),38)
      CDATAL=CDATAL(1:LI-1)//'.EVENT@'
*** PMF(end)
      CALL GETPDD(IDATAL,HVOLSR,DDN,NDDOUT,HERR)
      IF(HERR.EQ.0) GO TO 5
C
C                            ERROR HAS OCCURRED ON ALLOCATION.
C
      CALL TRMOUT(80,'The name is incorrect or HMS/MSS is jammed.^')
44    CALL TRMOUT(80,'Please try again or continue session by "CONTINUE"
     $.^')
      GO TO 1
C---
C---     SUCCESSFULLY ALLOCATED DATA SET. NOW COUNT THE RECORDS
C---     AND LOAD THE FORTRAN REFERENCE NUMBER AND NUMBER OF RECORDS
C---     INTO THE TRANSFER COMMON FOR THE USE OF OTHER ROUTINES.
C---
    5 JUNIT = NDDOUT
      CALL TRMOUT(80,' Output dataset allocated.^')
      CALL TRMOUT(80,
     $'Do you want to overwrite the records on this dataset?^')
      CALL TRMOUT(80,'If not you will add records to the existing ds.^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 12
      CALL TRMOUT(80,' This option is presently not working, unfortunate
     $ly^')
      CALL TRMOUT(80,' Do you wish another output file? If not, you will
     $overwrite this one.^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 1
C     CALL TRMOUT(80,
C    $'IF YOU CHOOSE TO ADD EVENTS TO THE EXISTING ONES,^')
C     CALL TRMOUT(80,
C    $'THEN THE CURRENT EVENT WILL NOT BE WRITTEN. IS THIS OK?^')
C     CALL DECIDE(IANSW)
C     IF(IANSW.EQ.2) GO TO 12
C     CALL GNUREC(NDDOUT,NUMEVN,NUMREC)
C     NRWR = NUMEVN
C     WRITE(JUSCRN,101) NUMEVN,NUMREC
C 101 FORMAT(' DATA SET HAS NUMBER OF EVENTS, NUMBER OF RECORDS = ',2I4)
C     CALL TRMOUT(80,'EVENTS WILL BE ADDED TO THE ALREADY EXISTING ONES.
C    $^')
C     CALL STWADD(NDDOUT,&4)
C     GO TO 100
C4     CALL TRMOUT(80,'THE DATA SET GIVES READ ERROR OR IS EMPTY.^')
C      GO TO 44
C100   CALL BWRO(JUNIT,MAXRL,MODE)
12    CALL TRMOUT(80,'EVENTS WILL BE OVERWRITTEN. BOS S FORMAT IS DEFAUL
     $T.^')
      MODE = 0
      MAXRL = 33000
      NRWR = 0
      CALL BWRO(JUNIT,MAXRL,MODE)
200   CONTINUE
      RETURN
      END

C   27/02/80 403191842  MEMBER NAME  SUBOLD   (S)           FORTRAN
      SUBROUTINE SUBOLD(INIT)
C---  SUBTRACT ADC-PEDESTALS (MICROPROCESSOR VALUES)
C---  & CREATE NEW VALUES FOR LNG, HPOINT, AND HGGADC
C---  (DEALS WITH 240 ADC-CHANNELS)
C---  READ PEDESTAL-CONSTANTS FROM DATASET
C
C     H.WRIEDT     12.06.79       14:00
C     LAST MODIFICATION     27.02.80      23:30
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
      COMMON /CADCPL/ HADCPL(102,240),HPBHIS(192),IPBPHD(192),
     &                IERR(3)
C
      COMMON /CWORK/ IWORK(42),LNG,HPOINT(4),HGGADC(2,240)
C
      COMMON /CSUBCP/ HSUBPD(240)
C
      COMMON /CRUNCO/ HRUN
C
      INTEGER*2 HGGPED(2,240)
C

      DATA ICOUNT/0/

      DATA IDONT/0/
      IER = 0

C
      IF (INIT.GT.1) GOTO 2
    1 READ(19,ERR=999,END=1000) IRUN,NDAT
      IF (NDAT.GT.0) READ(19,ERR=999,END=1000)
     1((HGGPED(K,J),K=1,2),J=1,NDAT)
      IF (IRUN.GT.HRUN) GOTO 300
      IF (IRUN.LT.HRUN) GOTO 1
      IF (NDAT.EQ.0) GOTO 301
        DO 50 I = 1,NDAT
        HADR = HGGPED(1,I)
C---    STORE PEDESTAL-CONSTANT FOR EACH CHANNEL
   11   HSUBPD(HADR) = HGGPED(2,I)
C       WRITE(6,603) HGGPED(1,I),HSUBPD(HADR),INIT
  603   FORMAT(' SUBTRACTION-CONSTANT FOR BLOCK NO. ',I3,' DETERMINED',
     &         ' TO ',I5,' IN EVENT NO. ',I3)
   50   CONTINUE
C
    2 NDAT = LNG - 2
        DO 100 I = 1,NDAT
        HADR = HGGADC(1,I)
C---
        IF (HADR.EQ.0.OR.HADR.EQ.47.OR.HADR.EQ.48.OR.HADR.EQ.95.OR.HADR
     &      .EQ.96.OR.HADR.EQ.143.OR.HADR.EQ.144.OR.HADR.EQ.191) GOTO 9900003160
        HGGADC(2,I) = HGGADC(2,I) + HSUBPD(HADR)
        IF (HGGADC(2,I).GE.50) GOTO 101
C---    CUTOFF OF ADCS WITH LOW CONTENT
C       (THRESHOLD: 49 CHANNELS)
   99   HGGADC(2,I) = 0
        GOTO 100
C---    SCRATCH UNPHYSICAL ADC-ADDRESSES (I.E. ADDRESSES 208 - 215,
C---    >229) AND CONTENTS
  101   IF ((HADR.GE.208.AND.HADR.LE.215).OR.(HADR.GE.230))
     &   HGGADC(2,I) = 0
  100   CONTINUE
C
      CALL GGSRTH(0,NDAT)
      LNG = 2
        DO 200 I = 1,NDAT
        IF (HGGADC(2,I).LE.0) GOTO 201
  200   LNG = I+2
  201 NDAT = LNG-2
      CALL GGSORT
C
C---  SET UP NEW POINTERS
      HPOINT(1) = 1
      HPOINT(2) = 1
      HPOINT(3) = 1
      IF (NDAT.LE.0) GOTO 211
        DO 210 I = 1,NDAT
        HADDR = HGGADC(1,I)
        IF (HADDR.LE.95) HPOINT(2) = 2*I+1
        IF (HADDR.LE.191) HPOINT(3) = 2*I+1
  210   CONTINUE
  211 HPOINT(4) = 2*NDAT+1
      RETURN
C
  300 IF(ICOUNT.LT.10)WRITE(6,600) IRUN,HRUN
  600 FORMAT(/' *** ERROR IN SUBOLD DURING READING OF PEDESTAL',
     &        '-CONSTANTS'/'    CORRECT RUN NOT FOUND'/2(2X,I6))
      IF (IER.EQ.1) GOTO 599
      REWIND 19
      IER = 1
      GOTO 1
  599 RETURN
C
  301 IF(ICOUNT.LT.10)WRITE(6,601) IRUN,NDAT
       ICOUNT = ICOUNT + 1
  601 FORMAT(/' *** ERROR IN SUBOLD DURING READING OF PEDESTAL',
     &        '-CONSTANTS'/'    NO PEDESTAL-CONSTANTS FOUND'/2(2X,I6))
      RETURN
C AJF ADDED THESE ERROR MESSAGES
999   WRITE(6,699)
699   FORMAT(/,/,'  READ ERROR IN SUBOLD ON UNIT 19 (TAG ''79 CALIBRATIO
     1N FILE) REST OF THIS CALIBRATION SKIPPED ')
      IDONT = 1
      RETURN
1000  WRITE(6,700)
700   FORMAT(/,/,' END OF DATA ENCOUNTERED WHILE  READING TAG 79
     1CALIBRATION FILE ')
      IDONT = 1
      RETURN
      END

*******************************************************************
*
*     HIGZ colour parameters for graphics action in JADEZ
*
*     This file is included when compiling SETCOL
*
      LOGICAL LCOL,LINIT
      INTEGER NCOL,IFORE,IBACK,IFORE2,IBACK2
      REAL WID
      PARAMETER (NCOL=10)
      REAL RED,GREEN,BLUE
      CHARACTER TCOL*4
      COMMON /PLTCOL/ LCOL,LINIT,IFORE,IBACK,IFORE2,IBACK2
     _     ,RED(NCOL),GREEN(NCOL),BLUE(NCOL),TCOL(NCOL),WID(NCOL)

      INTEGER PLTFLG
      COMMON /CPLTC2/ PLTFLG
*******************************************************************      

C   08/04/87 704102020  MEMBER NAME  EXPATR   (JADEGS)      FORTRAN
      SUBROUTINE EXPATR( NPPATR, LTRNEW, IER )
C-----------------------------------------------------------
C  Version of 08/04/87     last mod 08/04/87  E Elsen
C  Extend PATR bank at BOS position NPPATR to have
C  track data length LTRNEW if shorter, to make room
C  for the covariance matrix.
C  The new positions are set to zero.
C  IER = 0, if no error occured during expansion of bank
C-----------------------------------------------------------
      COMMON / BCS / IW(1)
C                                           CHECK PATR NAME
      INTEGER NAME / 'PATR' /, LTRMAX / 64 /
      DATA NPRT / 30 /, KPRT / 0 /
C
      IF( NPPATR.LE.0 .OR. IW(NPPATR-3) .NE. NAME ) GOTO 9000
C
      LTR=LTRNEW
      IF(LTR.LE.LTRMAX) GOTO 100
         IF(KPRT.GT.NPRT) GOTO 90
            KPRT=KPRT+1
            WRITE(6,20) LTRNEW,LTRMAX
 20         FORMAT(' *** EXPATR *** REQUESTED TRACK LENGTH',I8,
     +      ' IS SET TO MAXIMUM ALLOWED:',I4)
 90      LTR=LTRMAX
100   CONTINUE
C
      L0 = IW(NPPATR+1)
      L1 = IW(NPPATR+3)
      N  = IW(NPPATR+2)
      IP0 = NPPATR + L0
      IF( L1.GE.LTR ) GO TO 8000
C                                           BANK NEEDS EXPANSION
      LOLD = IW(NPPATR)
      CALL BCHM( NPPATR, N*(LTR-L1), IERR )
      IF( IERR.NE. 0 ) GOTO 9100
      IP0 = NPPATR + L0
C                                           ANYTHING BEHIND LAST TRACK?
      IF( LOLD.LE.L0+N*L1) GO TO 1000
C                                           YES, SO COPY
         L = LOLD-(L0+N*L1)
         DO 900 I=1,L
  900       IW(IP0+N*LTR+L-I+1) = IW(IP0+N*L1+L-I+1)
 1000 CONTINUE
C                                           COPY TRACK BY TRACK
      L11 = L1 + 1
      IP9 = IP0 + N*L1
      NP9 = IP0 + N*LTR
 2000 IF( IP9.LE.IP0 ) GO TO 2100
         IP9 = IP9 - L1
         NP9 = NP9 - LTR
         DO 2050 I=1,L1
 2050       IW(NP9+L1+1-I) = IW(IP9+L1+1-I)
C                                      SET NEW ELEMENTS TO ZERO
         DO 2060 I=L11,LTR
 2060       IW(NP9+I)=0
         GO TO 2000
 2100 CONTINUE
      IW(NPPATR+3) = LTR
 8000 IER = 0
      RETURN
C
 9000 IF(KPRT.GT.NPRT) GOTO 9999
         KPRT=KPRT+1
         IF(NPPATR.GT.0) GOTO 9050
            WRITE(6,9010) IW(NPPATR-3)
 9010       FORMAT(' *** EXPATR *** CALLED WITH NAME  ',A4)
            GOTO 9999
 9050    WRITE(6,9060) NPPATR
 9060    FORMAT(' *** EXPATR *** CALLED WITH NONPOSITIVE ',
     +   'BANK POSITION:',I10)
         GOTO 9999
C
 9100 IF(KPRT.GT.NPRT) GOTO 9999
         KPRT=KPRT+1
         WRITE(6,9110) IERR
 9110    FORMAT(' *** EXPATR ***    ERROR CODE FROM BCHM:',I8)
C
 9999 IER=1
      RETURN
      END

C   25/06/78 C9011701   MEMBER NAME  SEKBN1   (LGSOURCE)    FORTRAN
      FUNCTION SEKBN1(FUNC,A,B,N)
C     THIS SUBPROGRAM GIVES THE INTEGRATED VALUE OF FUNCTION FUNC(X),IN
C     INTERVAL (A,B).FUNC(X) MUST BE GIVEN IN THE FORM OF FUNCTION SUBPR
C     OGRAM.N IS THE NUMBER OF STEPS AND MUST BE INTEGER.
      DOUBLE PRECISION DS
      IF(N-1) 800,200,200
  200 M=N+1
      H=(B-A)/FLOAT(N)
      IF(M-2) 10,10,20
   10 SEKBN1=0.5*(FUNC(A)+FUNC(B))*H
      GO TO 6
   20 IF(M-4) 40,30,40
   30 SEKBN1=0.0
      GO TO 5
   40 IF(M/2-(M-1)/2) 1,1,2
    1 NN=M
      GO TO 3
    2 NN=M-3
    3 BB=A+FLOAT(NN-1)*H
1000  QFA=FUNC(A)
      QFBB=FUNC(BB)
      DS =QFA-QFBB
      DO 4 I=2,NN,2
      X=A+FLOAT(I-1)*H
    4 DS = DS + 4.0*FUNC(X)+2.0*FUNC(X+H)
      SEKBN1=DS*H/3.0
      IF(M-NN) 6,6,5
    5 SEKBN1=SEKBN1+0.375*H*(FUNC(B-3.0*H)+3.0*FUNC(B-2.0*H)+3.0*FUNC(B-
     1H)+FUNC(B))
      GO TO 6
  800 WRITE(6,900) N
  900 FORMAT(1H0,'(SUBR. SEKBN1) N=',I4,', N MUST BE LARGER THAN 0.')
    6 RETURN
      END
C
C    DEFAULT VALUE
C
      BLOCK DATA
      COMMON/M0PAR/CUTM
      COMMON /RUNMOD/ IRNMD
      COMMON /SFCPA/SF,SFE
      DATA IRNMD/0/
      DATA CUTM/.5/
      DATA SF,SFE/1.,2./
      END

C   29/11/77 C8100201   MEMBER NAME  JPRFRE0  (CS7)         FORTRAN
      SUBROUTINE JPRFRE( R, P, PENETR, PENETZ, RDOWN, RUP,
     *                   ZDOWN, ZUP, *, *, *, * )
C  *--------------------------------------------------------
C  *
C  *  VERSION OF 02/10/78
C  *  PROPAGATES PARTICLE IN NON ABSORBING MEDIUM
C  *  DEFINED BY RDOWN, RUP, ZDOWN, ZUP.
C  *  UPON RETURN PENET((R) OR (Z)) IS PENETRATION LENGTH
C  *  IN NEXT ELEMENT IN R OR Z DIRECTION.
C  *  RETURN  : NEXT ELEMENT, INCREASING R
C  *  RETURN1 : NEXT ELEMENT, DECREASING R
C  *  RETURN2 : NEXT ELEMENT, INCREASING Z
C  *  RETURN3 : NEXT ELEMENT, DECREASING Z
C  *  RETURN4 : PARTICLE STOPPED IN SYSTEM
C  *--------------------------------------------------------
C
       DIMENSION R(5), P(7)
      COMMON / CJTRLE / TOTLEN, STPLEN
C
      IF( R(4) .GT. RUP ) RETURN
      IF( R(4) .LT. RDOWN ) RETURN1
      IF( R(3) .GT. ZUP ) RETURN2
      IF( R(3) .LT. ZDOWN ) RETURN3
C
      PENETZ = 0.
      PENETR = 0.
      DO 100 ITERAT = 1,300
      IF( R(4) .LE. RUP  ) GO TO 20
          PENETR = R(4) - RUP
          RETURN
   20 IF( R(4) .GE. RDOWN ) GO TO 30
          PENETR = RDOWN - R(4)
          RETURN 1
   30 IF( R(3) .LE. ZUP ) GO TO 40
          PENETZ = R(3) - ZUP
          RETURN 2
   40 IF( R(3) .GE. ZDOWN ) GO TO 50
          PENETZ = ZDOWN - R(3)
          RETURN 3
C
   50 CALL JSTEP( R, P, DRTOT )
        R(4) =  SQRT( R(1)*R(1) + R(2)* R(2) )
C        TOTAL TRACK LENGTH BIGGER THAN MAXIMUM VALUE?
            TOTLEN = TOTLEN  + DRTOT
            IF( TOTLEN .GT. STPLEN ) RETURN4
  100 CONTINUE
C
      RETURN 4
      END

C   26/06/87 712141919  MEMBER NAME  ADPATR   (S)           FORTRAN77
      SUBROUTINE ADPATR( NRUN )
C-----------------------------------------------------------
C   VERSION OF 26/06/87     LAST MOD 08/12/87   E ELSEN
C   ADJUST RUN DEPENDENT PATREC LIMITS
C-----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
#include "cpatlm.for"
      COMMON /BCS/ HW(1)
      INTEGER IW(1)
      EQUIVALENCE (IW(1),HW(1))
      INTEGER IPHEAD / 0 /
C
      IF( IPHEAD .LE. 0 ) IPHEAD = IBLN('HEAD')
      NPHEAD = IW(IPHEAD)
C
      IF( NRUN .GE. 24200 .OR.
     *  ( NRUN .LT. 100 .AND. HW(NPHEAD*2+8) .GT. 1985 ) ) THEN
        FLINLM(2) = 1.0
        GFP(3) = 2.0
        ZFITLM(1) = 70.
        ZFITLM(2) = 40.
      ELSE
        FLINLM(2) = 3.0
        GFP(3) = 4.5
        ZFITLM(1) = 50.
        ZFITLM(2) = 20.
      ENDIF
      END

C   25/11/83 402061213  MEMBER NAME  JGETEV   (S)           FORTRAN
C
C----------------------------------------------------------------------
      SUBROUTINE JGETEV( * , * ) ! PMF 22/06/00: add branch on RETURN2
C----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    02/11/81 :  GET NEXT EVENT
C
C        MOD  J. OLSSON   30/08/83 :  TRACK A SUBSET OF THE DATASET
C        MOD  C. BOWDERY  17/11/83 :  CHANGE ERROR MESSAGE FROM BRVECT
C        MOD  W. BARTEL   29/11/83 :  CHANGE /CIEV/ DEFAULT IN BLDAT
C        MOD  C. BOWDERY   2/12/83 :  ALTER COMMON /CVERR/
C   LAST MOD  C. BOWDERY   6/02/84 :  IEV --> KIEV IN FORTRAN LINE 7000
C
C   Last mod.
C    P. Movilla Fernandez 22/06/00 :  Introduce `RETURN2' replacing `GO TO 95'
C   Last mod.
C    P. Movilla Fernandez 21/12/00 :  Use subroutine CPREAD to read
C                                     CPROD file with different endian format
C
C   GET NEXT EVENT BY CALLING BRVECT.
C
C   TO ALLOW FOR TRACKING ONLY A SELECTED PART OF THE
C   INPUT 4-VECTOR FILE. EVENT COUNT IS PASSED TO MCJADE VIA /CIEV/IEV
C
C   RETURN 1 IF END OF INPUT SEQUENCE (EOF)   OR
C            IF READING PASSES MAXIMUM EVENT NR ALLOWED
C
C   RETURN 2 If BRVECT detects an error when reading an event.
C            This is necessary in order to synchronize the event counter
C            IEV here and in subroutine MCJADE. Otherwise the counter
C            KIEV is not handled correctly.
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
      COMMON / CVERR / MESSAG(20)
C
      DATA IRUNIT / 3 / , ICALL/ 0 /
C PMF, 21/12/2000:
C MAXCP is the size of the CPROD common, see 'cprod.for'
      INTEGER MAXCP
      PARAMETER( MAXCP=7512 )
      INTEGER NBUFF(MAXCP)
C PMF, 21/12/00: IFORM tells us the endian format of the CPROD file
      INTEGER IFORM
      COMMON /CPFORM/ IFORM
C
C------------------  C O D E  -----------------------------------------
C
      ICALL = ICALL + 1
      IF(ICALL.NE.1) GO TO 95
      IEV = 0
      KIEV = 0
95    IEV = IEV + 1
1001  IF(IEV.GE.IEVMIN) GO TO 2001
*** PMF 23/06/00: Print out number of read events
*   (usefull in case of large CPROD files)
      if( mod(iev,1000).eq.0 ) write(*,'(A,I7,A)')
     >     'JGETEV:',IEV,' events read.'
*** PMF (end)
C
C             READ EVENTS, UNTIL EVENT IEVMIN REACHED, THEN CALL BRVECT
C
      IEV = IEV + 1
      IF( IFORM.GE.0 ) THEN
         READ(IRUNIT,ERR=1100,END=8100) NR
      ELSE
C PMF, 21/12/00: Read binary with different endian format using CFGET      
         CALL CPREAD(NBUFF,' ',*1100,*8100)
      ENDIF
      GO TO 1001
C
2001  IF(IEV.GT.IEVMAX) GO TO 90
C
      KIEV = KIEV + 1
      CALL BRVECT( IRUNIT, *1000, *8100 )
      RETURN
C
C             MESSAGES
C
 1000 MESSAG(20) = MESSAG(20) + 1
      IF( MESSAG(20) .GT. 100 ) RETURN 2 ! PMF 22/06/00: RETURN2 instead of GO TO 95
      WRITE(6,8002) IEV
 8002 FORMAT(' *** WARNING ***   ERROR DETECTED IN JGETEV FOR EVENT ',
     +        'ON FILE AT POSITION ',I6,'.    EVENT SKIPPED     ***'/)
      IF( MESSAG(20) .EQ. 100 ) WRITE(6,8003)
 8003 FORMAT(/' *** WARNING ***   NO FURTHER ERROR MESSAGES FROM JGETEV'
     +       ,' WILL BE PRINTED.  SEE ERROR SUMMARY AT END    ***'/)
      RETURN 2 ! PMF 22/06/00: RETURN2 instead of GO TO 95
C
 1100 WRITE(6,1102) IEV
 1102 FORMAT(/' *** READ ERROR  *** DETECTED IN JGETEV FOR EVENT ON ',
     +       'FILE AT POSITION ',I8,'. EVENT SKIPPED     ***'/)
      RETURN 2 ! PMF 22/06/00: RETURN2 instead of GO TO 95
C
 90   WRITE(6,8012)
 8012 FORMAT(/' -----   MAX NR OF EVENTS READ   -----')
      GO TO 7000
C
 8100 WRITE(6,8101)
 8101 FORMAT(/' -----   E O F   E O F   E O F   E O F   ----- ')
C
 7000 KIEV = KIEV - 1
      RETURN 1
      END

C   16/07/79 301121201  MEMBER NAME  RZTRCK   (JADEGS)      FORTRAN
      SUBROUTINE RZTRCK(NN,ITP,A,B,C,D,XB,YB,XE,YE,AZ,BZ,XP,YP,ZP,
     * X2,Y2,Z2,IFLGX)
C---
C---    SUBROUTINE TO COMPUTE POINT OF IMPACT OF CHARGED TRACK FROM ID
C---    IN RZ CHAMBERS. ITP = 1 MEANS CIRCLE, ITP = 2 PARABOLA
C---    THE PARABOLA PARAMETERS ARE:
C---                        A = ANGLE BETWEEN LOCAL X-AXIS AND DETECTOR
C---                        B = X COORDINATE OF LOCAL MINIMUM POINT.
C---                        C = Y COORDINATE OF LOCAL MINIMUM POINT.
C---                        D = PARABOLA PARAMETER IN  Y = D * X*X
C---    THE CIRCLE PARAMETERS ARE:
C---                        A = CURVATURE
C---                        B = RMIN
C---                        C = PHIMIT
C---                        D = NOT USED
C---     THE Z-COORDINATE IS GOTTEN FROM THE R-Z FIT:  Z = AZ + BZ*R
C---                     OR FROM THE Z-FI(HELIX) FIT:  Z = AZ + BZ*FI
C---                     THE LATTER ONLY IN CASE OF CIRCLE FIT
C---    RETURNED ARE IMPACT POINT XP,YP,XP
C---                 POINT OF EXIT X2,Y2,Z2 (ON EXIT SIDE OF RZ CHAMBER)
C---                 LABEL IFLGX:
C---    IFLGX = 0 FOR NO IMPACT POINT (CURLING ELECTRON)
C---    IFLGX = 1 FOR IMPACT POINT IN ENDCAPS (INCLUDING GAP ENDCAP-CYL)
C---    IFLGX = 2 FOR IMPACT POINT IN RZ CHAMBER
C---   UPON ENTRY IFLGX GIVES TYPE OF Z-FIT
C---
C---     J.OLSSON          3.11.82        LAST CHANGE  3.11.82
C---
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
#include "cgeo1.for"
      COMMON /CZGEO/ RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,ZCHSS,
     $               ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      COMMON /CZKON/ ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
      COMMON /CJTRIG/ PI,TWOPI
C---
      ITYP = IFLGX
      IF(ITP.NE.2) GO TO 100
      IF(ITYP.NE.1) RETURN
C------------------------------- PARABOLAS
      COSA = COS(A)
      SINA = SIN(A)
      XPB = (XB-B)*COSA + (YB-C)*SINA
      XPE = (XE-B)*COSA + (YE-C)*SINA
      YPB = D*XPB*XPB
      DELX = (XPE - XPB)/NN
      XP = (XPB)*COSA - (YPB)*SINA + B
      YP = (XPB)*SINA + (YPB)*COSA + C
      RP = SQRT(XP*XP + YP*YP)
      ZP = AZ + BZ*RP
C DETERMINE IF TRACK HITS CYLINDER OR ENDCAPS
      ZP1 = AZ + BZ*RZCHI
      ZLIM = ZLGPL
      LIMTYP = 2
      IF(ABS(ZP1).GT.ZLGPL) ZLIM = ZENDPL
      IF(ABS(ZP1).GT.ZLGPL) LIMTYP = 1
C
      IFLGX = 0
      NNN = 0
      R2 = RP
      Z2 = ZP
551   XPB = XPB + DELX
555   YPB = D*XPB*XPB
      NNN = NNN + 1
      XP = (XPB)*COSA - (YPB)*SINA + B
      YP = (XPB)*SINA + (YPB)*COSA + C
      RP = SQRT(XP*XP + YP*YP)
      ZP = AZ + BZ*RP
      IF(IFLGX.NE.0) GO TO 561
CHECK LIMITS
      IF(ABS(ZP).LT.ZLIM) GO TO 554
      IFLGX = 1
      FAT = ABS((ABS(ZP) - ZLIM)/(ZP - Z2))
552   XPB = XPB - FAT*DELX
      GO TO 555
554   IF(RP.LT.RZCHI) GO TO 553
      IFLGX = 2
      FAT = (RP-RZCHI)/(RP-R2)
      GO TO 552
553   R2 = RP
      Z2 = ZP
      GO TO 551
561   X3 = XP
      Y3 = YP
      Z3 = ZP
      R3 = RP
      XPB = XPB + DELX
      YPB = D*XPB*XPB
      X2 = (XPB)*COSA - (YPB)*SINA + B
      Y2 = (XPB)*SINA + (YPB)*COSA + C
C  GET STRAIGHT LINE BETWEEN LAST TWO POINTS
      BLG = (Y2-Y3)/(X2-X3)
      ALG = Y3 - X3*BLG
      DELX = X2 - X3
      IFLGX = 0
      IF(LIMTYP.EQ.1) ZLIM = ZLIM + DEPEND
571   X2 = X2 + DELX
575   Y2 = ALG + BLG*X2
      NNN = NNN + 1
      R2 = SQRT(X2*X2 + Y2*Y2)
      Z2 = AZ + BZ*R2
      IF(IFLGX.NE.0) IFLGX = LIMTYP
      IF(IFLGX.NE.0) GO TO 557
CHECK LIMITS
      IF(ABS(Z2).LT.ZLIM) GO TO 574
      IFLGX = 1
      FAT = ABS((ABS(Z2) - ZLIM)/(Z2 - Z3))
572   X2 = X2 - FAT*DELX
      GO TO 575
574   IF(R2.LT.RZCHA) GO TO 573
      IFLGX = 2
      FAT = (R2-RZCHA)/(R2-R3)
      GO TO 572
573   R3 = R2
      Z3 = Z2
      GO TO 571
100   IF(ITP.NE.1) GO TO 557
C------------------------------- CIRCLES
C---
      IF(ABS(A).GT.1.E-08) GO TO 700
      CALL TRMOUT(44,'CURVATURE ZERO ENCOUNTERED IN SUBR. RUTRCK^')
      RETURN
700   RAD = ABS(1./A)
      YC = RAD + B
      XC = YC*COS(C)
      YC = YC*SIN(C)
C--
      FI1 = ATAN2(YB-YC,XB-XC)
      FI2 = ATAN2(YE-YC,XE-XC)
      IF(ITYP.EQ.1) GO TO 755
      FISTRT = FI1
      IF(FISTRT.LT.0.) FISTRT = FISTRT + TWOPI
      FIHEL1 = C + PI
      IF(FIHEL1.GT.TWOPI) FIHEL1 = FIHEL1 - TWOPI
      FISTRT = ABS(FISTRT - FIHEL1)
755   FIB = FI1
      ARC = ARCMIN(FI2-FI1)
      DEFI = ARC/NN
      XP = XC + RAD*COS(FI2)
      YP = YC + RAD*SIN(FI2)
      RP = SQRT(XP*XP + YP*YP)
      IF(ITYP.EQ.1) GO TO 233
      FIHEL = FI2
      IF(FIHEL.LT.0.) FIHEL = FIHEL + TWOPI
      FIHEL = ABS(FIHEL - FIHEL1) - FISTRT
      ZP = BZ*FIHEL + AZ
      ZDEL = BZ*ABS(DEFI)
      ZDELR = ZDEL
      GO TO 235
233   ZP = AZ + BZ*RP
235   IFLGX = 0
      NNN = 0
      R2 = RP
      Z2 = ZP
C DETERMINE IF TRACK HITS CYLINDER OR ENDCAPS
      ZP1 = AZ + BZ*RZCHI
      ZLIM = ZLGPL
      LIMTYP = 2
      IF(ABS(ZP1).GT.ZLGPL) ZLIM = ZENDPL
      IF(ABS(ZP1).GT.ZLGPL) LIMTYP = 1
751   FI2 = FI2 + DEFI
      NNN = NNN + 1
      IF(NNN.GT.200.OR.(ABS(FI2-FIB).LT.TWOPI+2.*DEFI.AND.ABS(FI2-FIB)
     $.GT.TWOPI-2.*DEFI)) RETURN
759   XP =   XC + RAD*COS(FI2)
      YP =   YC + RAD*SIN(FI2)
      RP = SQRT(XP*XP + YP*YP)
      IF(ITYP.EQ.1) GO TO 238
      ZP = ZP + ZDEL
      GO TO 239
238   ZP = AZ + BZ*RP
239   IF(RP.LT.RITNK) RETURN
      IF(IFLGX.NE.0) GO TO 753
CHECK LIMITS
      IF(ABS(ZP).LT.ZLIM) GO TO 754
      IFLGX = 1
      FAT = ABS((ABS(ZP) - ZLIM)/(ZP - Z2))
752   FI2 = FI2 - FAT*DEFI
      IF(ITYP.EQ.2) ZDEL = -FAT*ZDEL
      GO TO 759
754   IF(RP.LT.RZCHI) GO TO 753
      IFLGX = 2
      FAT = (RP-RZCHI)/(RP-R2)
      GO TO 752
753   R2 = RP
      Z2 = ZP
      IF(IFLGX.EQ.0) GO TO 751
      IFLGX = 0
      X3 = XP
      Y3 = YP
      Z3 = ZP
      R3 = RP
      IF(ITYP.EQ.2) ZDEL = ZDELR
      FI2 = FI2 + DEFI
      X2 =   XC + RAD*COS(FI2)
      Y2 =   YC + RAD*SIN(FI2)
      R2 = SQRT(X2*X2 + Y2*Y2)
      IF(ITYP.EQ.1) GO TO 738
      Z2 = Z2 + ZDEL
      GO TO 739
738   Z2 = AZ + BZ*R2
C  GET STRAIGHT LINE BETWEEN LAST TWO POINTS
739   BLG = (Y2-Y3)/(X2-X3)
      ALG = Y3 - X3*BLG
      DELX = X2 - X3
      IF(LIMTYP.EQ.1) ZLIM = ZLIM + DEPEND
771   X2 = X2 + DELX
775   Y2 = ALG + BLG*X2
      NNN = NNN + 1
      R2 = SQRT(X2*X2 + Y2*Y2)
      IF(ITYP.EQ.1) GO TO 783
      Z2 = Z2 + ZDEL
      GO TO 784
783   Z2 = AZ + BZ*R2
C  GET STRAIGHT LINE BETWEEN LAST TWO POINTS
784   CONTINUE
      IF(IFLGX.NE.0) IFLGX = LIMTYP
      IF(IFLGX.NE.0) GO TO 557
CHECK LIMITS
      IF(ABS(Z2).LT.ZLIM) GO TO 774
      IFLGX = 1
      FAT = ABS((ABS(Z2) - ZLIM)/(Z2 - Z3))
772   X2 = X2 - FAT*DELX
      GO TO 775
774   IF(R2.LT.RZCHA) GO TO 773
      IFLGX = 2
      FAT = (R2-RZCHA)/(R2-R3)
      GO TO 772
773   R3 = R2
      Z3 = Z2
      GO TO 771
557   CONTINUE
      RETURN
      END

C   04/07/79 208161521  MEMBER NAME  VTXPRE   (JADEGS)      FORTRAN
      SUBROUTINE VTXPRE(IH,IP)
C*800623*DITTMANN***************************************************
C*                                                                 *
C*   P R E P A R A T I O N   F O R   X Y Z   V E R T E X   F I T   *
C*                                                                 *
C*       IH = POINTER TO 'HEAD' BANK                               *
C*       IP = POINTER TO 'PATR' BANK (AS IN JADE COMP NOTE 12).    *
C*                                                                 *
C*       VTXPRE COPIES ALL TRACKS INTO /CWORK1/, FLAGS TRACKS WHICH*
C*       SHOULD NOT BE USED IN VERTEX FIT, AND ADDS COULOMB        *
C*       SCATTERING ERRORS IN MATERIAL BEFORE FIRST WIRE.          *
C*       FOR DETAILS OF THE T-ARRAY SEE COMMENT IN SUBR. VERTEX.   *
C*                                                                 *
C*       SUBR. VTXINI MUST BE CALLED BEFORE FIRST CALL TO VTXPRE   *
C*******************************************************************
C
C   MAGNETIC FIELD CORRECTION   16.8.1982     J.OLSSON
C
C*******************************************************************
#include "cdata.for"
      INTEGER*2 HDATA
C
      COMMON /CWORK1/ NT,T(1500)
      DIMENSION IT(2)
      EQUIVALENCE (T(1),IT(1))
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1
      REAL*8 AA,BB,CC,DD,EE
C
      NT = 0
      IF(IH.EQ.0) RETURN
      IH2 = 2*IH
      NRUN = HDATA(IH2+10)
C    RESET MAGNETIC FIELD FOR PERIOD WHEN READ OUT SET IT TO 0
      IF(NRUN.EQ.11908) HDATA(IH2+30) = -4848
      IF(NRUN.GE.12254.AND.NRUN.LE.12270) HDATA(IH2+30) = -4847
      FIELD = HDATA(IH2+30)
      H03 = .00003 * ABS(FIELD)
      IF(IP.EQ.0) RETURN
      NT = IDATA(IP+2)
      IF(NT.LE.0) RETURN
      IF(NT.GT.50) NT=50
      L0 = IDATA(IP+1)
      LT = IDATA(IP+3)
C
      KT = IP + L0
      JT = 0
      DO 19 I=1,NT
      DO 11 J=1,30
   11 IT(JT+J) = 0
      IPFLAG = IDATA(KT+44)
C        MOST OF THE FOLLOWING TRACK REJECT CRITERIA ARE DUE
C        TO FAULTS IN THE PATR BANK
      IF(ADATA(KT+25).EQ.0.) GOTO 18
      PT = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      IF(PT.EQ.0.) GOTO 18
      IF(ADATA(KT+10).EQ.0.) GOTO 18
      T(JT+2) = -1. / ADATA(KT+25)
      T(JT+3) = ATAN2(ADATA(KT+9),ADATA(KT+8))
      TTH = ADATA(KT+10) / PT
      CTH = 1. / SQRT(1.+TTH**2)
      T(JT+4) = ATAN(TTH)
      T(JT+5) = ADATA(KT+5)
      T(JT+6) = ADATA(KT+6)
      T(JT+7) = ADATA(KT+7)
      SIGX = ADATA(KT+23)
      SIGZ = ADATA(KT+32)
C----     THIS CLUDGE SHOULD SOMEHOW ACCOUNT FOR SYSTEMATIC ERRORS
      SIGX = SIGX * SIGFAC
      SIGZ = SIGZ * SIGFAC
C----
      XNPT = IDATA(KT+24)
      ZNPT = IDATA(KT+33)
C        CHECK RESIDUAL
      IF(SIGX.EQ.0..OR.SIGZ.EQ.0.) GOTO 18
      IF(SIGX.GT.SIG1*SIGX0) GOTO 18
      IF(SIGZ.GT.SIG1*SIGZ0) GOTO 18
C        CHECK NUMBER OF POINTS ON TRACK
      IF(XNPT.LT.PNTMIN .OR. ZNPT.LT.PNTMIN) GOTO 18
      PROJL = ABS((ADATA(KT+14)-ADATA(KT+7))/TTH)
      IF(PROJL.LT.1.) GOTO 18
      SXNPT = SQRT(XNPT)
      SZNPT = SQRT(ZNPT)
      T(JT+8) = SIGX * 14./(PROJL*SXNPT)
      T(JT+9) = SIGZ * 4.*CTH**2/(PROJL*SZNPT)
      T(JT+10) = SIGX * 3. / SXNPT
      T(JT+11) = T(JT+10)
      T(JT+12) = SIGZ * 2.45 / SZNPT
      IT(JT+13) = IDATA(KT+24)
      T(JT+21) = SIN(T(JT+3))
      T(JT+22) = COS(T(JT+3))
      T(JT+23) = TTH
      T(JT+24) = CTH
      IT(JT+1) = 2
      IF(IPFLAG.EQ.2) GOTO 14
C----   THIS CLUDGE CORRECTS AN ERROR IN THE PATR BANK
      AA = - T(JT+5) + T(JT+2)*T(JT+21)
      BB = - T(JT+6) - T(JT+2)*T(JT+22)
      IF(IDATA(KT+18).EQ.2) AA=AA+ADATA(KT+20)
      IF(IDATA(KT+18).EQ.2) BB=BB+ADATA(KT+21)
      DR1M = DSQRT(AA**2+BB**2)
      DR = DR1M - ABS(T(JT+2))
      IF(IDATA(KT+18).NE.2) DR=DR-ADATA(KT+20)
      T(JT+5) = T(JT+5) + DR*AA/DR1M
      T(JT+6) = T(JT+6) + DR*BB/DR1M
      T(JT+7) = ADATA(KT+31) + ADATA(KT+30)*SQRT(T(JT+5)**2+T(JT+6)**2)
C----
C      PROJECTED ARC LENGTH TO INTERSECT WITH INNER TANK
   14 XM = T(JT+5) - T(JT+2)*T(JT+21)
      YM = T(JT+6) + T(JT+2)*T(JT+22)
      AA = XM
      BB = YM
      AA = AA**2 + BB**2
      BB = T(JT+2)
      BB = BB**2
      CC = RTANK**2
      DD = (AA-BB+CC)/2.D0
      EE = AA*CC - DD**2
C        ANY INTERSECT ?
      IF(EE.LE.0.D0) GOTO 17
      EE = DSQRT(EE)
      XT1 = (XM*DD + YM*EE) / AA
      YT1 = (YM*DD - XM*EE) / AA
      XT2 = (XM*DD - YM*EE) / AA
      YT2 = (YM*DD + XM*EE) / AA
      D1 = SQRT((XT1-T(JT+5))**2+(YT1-T(JT+6))**2)
      D2 = SQRT((XT2-T(JT+5))**2+(YT2-T(JT+6))**2)
      IF(D1.LT.D2) GOTO 16
      XT = XT2
      YT = YT2
      XT2 = XT1
      YT2 = YT1
      XT1 = XT
      YT1 = YT
   16 SR = SIGN(1.,T(JT+2))
      PHI = ATAN2(-SR*(XM-XT1),SR*(YM-YT1))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+27) = T(JT+2)*THETA
      PHI = ATAN2(-SR*(XM-XT2),SR*(YM-YT2))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+26) = T(JT+2)*THETA
C        MULT. SCATTERING IN INNER TANK WALL AND BEAMPIPE
      PT = H03*T(JT+2)
      BETA = 1.
      TH2 = (15./(PT*BETA))**2 * X0INN * T(JT+24)
      T(JT+16) = SQRT(TH2)
   17 CONTINUE
   18 JT = JT + 30
   19 KT = KT + LT
C
C
      RETURN
      END

C   11/07/79 C9071101   MEMBER NAME  ZBOS12   (S)           FORTRAN
      SUBROUTINE BSCOM
C     ------------------------------------------------------------------
C
C
C     APPENDIX B.    APPLICATION PROGRAMS
C
C
C
C     THE SUBROUTINE DESCRIBED HERE USE BANK STORAGE OF LOW
C     PRIORITY. THEY CAN BE USED FOR COUNTING, HISTOGRAMMING,
C     STORING OF VECTORS ETC. AND MAY BE USEFUL IN THE TESTING
C     PHASE OF LARGE PROGRAMS.
C     THE TOTAL NUMBER OF WORDS USED IN THE BANK COMMON /BCS/ CAN
C     NEVER EXCEED NADD WORDS (NADD IS AN ARGUMENT OF BINT).
C     THE SUBROUTINES START WITH A LETTER U FOR A NEW ENTRY, AND
C     WITH A LETTER P FOR PRINTOUT.
C
C     THE ARGUMENT N IN THE CALLS SHOULD ALWAYS BE A POSITIVE
C     INTEGER WITH LESS THAN 9 DIGITS.
C
C
C     B.1  PRINTOUT AND COMMENTS
C
C     FOR ALL APPLICATION PROGRAMS DESCRIBED IN APPENDIX A.2 TO A.6
C     PRINTOUT CAN BE DONE USING ONE CALL
C
C     CALL PALL
C
C
C
C     FOR SEVERAL APPLICATION PROGRAMS DESCRIBED IN THIS APPENDIX
C     COMMENT CAN BE DEFINED BY THE FOLLOWING CALLS. THIS COMMENT
C     IS PRINTED TOGETHER WITH THE RESULT
C
C                                         -NOT YET AVAILABLE-
C     CALL TCOND(N,'COMMENT    $')
C        COMMENT FOR UCOND
C
C     CALL TTABL(N,'COMMENT    $')
C        COMMENT FOR UTABL
C
C     CALL THIST(N,'COMMENT    $')
C        COMMENT FOR UHIST
C
C     CALL TCORR(N,'COMMENT    $')
C        COMMENT FOR UCORR
C
C     CALL TSTOR(N,'COMMENT    $')
C        COMMENT FOR USTOR/USTOS
C
C     CALL TMEAN(N,'COMMENT    $')
C        COMMENT FOR UMEAN
C
C     CALL TPEAK(N,'COMMENT    $')
C        COMMENT FOR UPEAK
C
C     CALL TLIND(N,'COMMENT    $')
C        COMMENT FOR ULIND
C
C     CALL TEMPF(N,'COMMENT    $')
C        COMMENT FOR UEMPF
C
C     THE COMMENT-TEXT IS DELIMITED BY A $ SIGN, MAXIMUM NUMBER
C     OF CHARACTERS IS 60.
C
C
C     A BANK WITH NAME 'TEX*' IS USED FOR EACH COMMENT.
C
C
C     B.2  COUNT IN A 32768 * 32768 ARRAY
C
C                - -
C     CALL UCOND(I,J)
C        INCREASE COUNT IN ELEMENT I,J BY ONE.
C        0 .LE. I .LE. 32767  AND 0 .LE. J .LE. 32767
C
C     CALL PCOND
C        PRINT ALL ELEMENTS .NE. 0. ALL BANKS USED ARE DELETED.
C
C                - -
C     CALL QCOND(I,J,NR)
C                    --
C        WHERE I,J = INDICES OF ELEMENT
C               NR = NUMBER OF COUNTS IN ELEMENT
C
C     BANKS (CON*,IJ) OF LENGTH 8(+4) ARE USED, WHERE IJ IS CALCULATED
C     FROM I AND J.
C
C
C     B.3  COUNT IN A 256 * 16 ARRAY
C
C                - - -
C     CALL UTABL(N,I,J)
C        INCREASE COUNT IN ELEMENT I,J BY ONE.
C        0 .LE. I .LE. 255  AND  0 .LE. J .LE. 15.
C        MAXIMUM COUNT IN ONE ELEMENT IS 65535.
C
C                -
C     CALL PTABL(N)
C        THE I/J ARRAY NUMBER N IS PRINTED. FOR N=0 ALL ARRAYS
C        ARE PRINTED.
C
C                - -
C     CALL QTABL(N,I,AR)
C                    --
C        WHERE AR( ) = ARRAY OF LENGTH 16 CONTAINING THE COUNTS
C                      IN THE I-ROW OF ARRAY NUMBER N.
C
C     A BANK (TAB*,N*16+I/16) OF LENGTH 128(+4) IS USED FOR EACH
C     FILLED 16 * 16 SUBARRAY.
C
C
C     B.4  HISTOGRAM
C
C                - -
C     CALL UHIST(N,X)
C        ADD NEW ENTRY X INTO HISTOGRAM N WITH 100 BINS. THE BIN SIZE
C        IS CHOOSEN AUTOMATICALLY, UNLESS DHIST IS USED.
C
C                - -- --
C     CALL DHIST(N,XL,XH)
C        FOR HISTOGRAM N THE VALUES XL AND XH ARE DEFINED AS LOWER
C        AND UPPER LIMITS, RESP.. (MUST BE CALLED BEFORE UHIST).
C
C                -
C     CALL PHIST(N)
C        THE HISTOGRAM N IS PRINTED, TOGETHER WITH MEAN VALUES ETC.
C        FOR N=0 ALL HISTOGRAMS ARE PRINTED.
C
C                -
C     CALL QHIST(N,Q)
C                  -
C
C        WHERE Q( ) = ARRAY OF LENGTH 115 FOR CONTENT OF
C        HISTOGRAM N (SEE BELOW).
C
C        I               Q(I)
C
C        1 . . . 100     CONTENT OF HISTOGRAM BINS
C        101             NR OF ENTRIES (TOTAL)
C        102             LOWEST BIN LEFT EDGE
C        103             BIN SIZE
C        104             NR OF ENTRIES OUTSIDE LOW
C        105             NR OF ENTRIES OUTSIDE HIGH
C        106             MIMIMUM VALUE OF X
C        107             MAXIMUM VALUE OF X
C        108             MEAN VALUE
C        109             MEDIAN (50 PC VALUE)
C        110             STANDARD DEVIATION
C        111                   . . .        FROM QUANTILES
C        112             QUANTILES   16 PC
C        113                . . .    84 PC
C        114                . . .   2.3 PC
C        115                . . .  97.7 PC
C
C     A BANK (HST*,N) OF LENGTH 120(+4) IS USED FOR EACH HISTOGRAM.
C
C
C     B.5  CORRELATION PLOT
C
C                - - -
C     CALL UCORR(N,Y,X)
C        ADD NEW ENTRY Y,X TO CORRELATION PLOT N WITH
C        50 * 100 BINS. BIN SIZE IS ALWAYS CHOOSEN AUTOMATICALLY.
C
C                -
C     CALL PCORR(N)
C        THE CORRELATION PLOT N IS PRINTED ON ONE PAGE TOGETHER
C        WITH PROJECTIONS AND MEAN VALUES.
C        BINS WITH CONTENT .NE. 0 ARE PRINTED AS A X. FOR N=0
C        ALL CORRELATION PLOTS ARE PRINTED.
C
C     A BANK (COR*,N) OF LENGTH 380(+4) IS USED FOR EACH
C     CORRELATION PLOT.
C
C
C
C     B.6  STORE VECTORS
C
C                - -- ----
C     CALL USTOR(N,AR,NDIM)
C        STORE VECTOR AR(1) . . . AR(NDIM) IN STORAGE N. THE
C        ARGUMENT NDIM SHOULD ALWAYS BE THE SAME FOR A GIVEN
C        STORAGE N.
C
C     NOTE. USTOR IS AN ENTRY OF USTOS. IF USTOS IS NOT CALLED,
C     USE A STATEMENT
C        EXTERNAL USTOS
C
C
C
C
C                - -- -- -- --
C     CALL USTOS(N,A1,A2,A3,A4)
C        STORE VECTOR A1, . . . IN STORAGE N. THE NUMBER OF ELEMENTS
C        IN A VECTOR MAY BE BETWEEN 1 AND 4 (VARIABLE NR OF ARGUMENTS
C        ALLOWED), BUT SHOULD ALWAYS BE THE SAME FOR A GIVEN
C        STORAGE N.
C
C     THE NUMBER OF VECTORS STORED IN A STORAGE IS LIMITED TO 100.
C     THIS LIMIT CAN BE CHANGED BY DSTOR.
C
C                ---
C     CALL DSTOR(LIM)
C        THE LIMIT ON THE NR OF VECTORS IS SET TO LIM.
C
C                -
C     CALL PSTOR(N)
C        THE VECTORS STORED IN STORAGE N ARE PRINTED. FOR N=0
C        THE VECTORS OF ALL STORAGES ARE PRINTED.
C
C     A BANK (STO*,N) IS USED FOR EACH STORAGE. THE STORAGE IS USED
C     AS FOLLOWS.
C
C     INDEX OF THE BANK       CONTENT
C            +1               NUMBER OF STORED VECTORS
C            +2               LENGTH OF ONE VECTOR
C            +3               (USED INTERNAL)
C            +4               1. ELEMENT OF 1. VECTOR
C            +5               2. ELEMENT OF 1. VECTOR
C            +6                    ETC
C
C
C     B.7  DETERMINE MEAN VALUES
C
C     THE MEAN VALUE IS DETERMINED FOR ENTRIES X. ENTRIES
C     HAVING A LARGE DEVIATION FROM THE AVERAGE X VALUE ARE
C     NOT USED. INTERNALLY A SMALL HISTOGRRAM IS MADE.
C     THREE DIFFERENT MEASURES FOR THE CENTER OF THE DISTRI-
C     BUTION ARE CALCULATED, THE USUAL MEAN FOR THE ENTRIES
C     INSIDE THE HISTOGRAM, THE TRIMMED MEAN, WHICH DETERMINES
C     THE MEAN FROM THE INNER 54 PERCENT OF THE HISTOGRAM,
C     AND THE MEDIAN (50 PERCENT VALUE OF HISTOGRAM). USUALLY
C     THE TRIMMED MEAN IS THE BEST MEASURE.
C
C                -- -- -
C     CALL UMEAN(N,KA,X)
C
C        ADD NEW ENTRY X TO MEAN VALUES N,KA.
C        THE KA-VALUE MAY BE BETWEEN 0 AND KAMAX,
C        IF SPACE IS RESERVED BY DMEAN(NA,KAMAX)
C
C                -- -----
C     CALL DMEAN(N,KAMAX)
C
C        FOR MEAN VALUES N,0 TO N,KAMAX SPACE IS RESERVED.
C        IF NOT CALLED, KAMAX=0 IS ASSUMED.
C
C
C                --
C     CALL PMEAN(N)
C        MEAN VALUES N,... ARE PRINTED. FOR N=0 ALL
C        MEAN VALUES ARE PRINTED.
C
C                -- --
C     CALL QMEAN(N,KA,Q)
C                      -
C        WHERE Q( ) = ARRAY OF LENGTH 10 FOR MEAN VALUE
C                     INFORMATION
C
C         I       Q(I)
C         1       NR OF ENTRIES TOTAL
C         2       MEAN
C         3       TRIMMED MEAN
C         4       MEDIAN
C         5       SIGMA (AVERAGE)
C         6       SIGMA (LEFT)
C         7       SIGMA (RIGHT)
C         8       NR OF ENTRIES OUTSIDE X-RANGE
C         9       LOWER LIMIT OF X-RANGE
C        10       UPPER LIMIT OF X-RANGE
C
C     A BANK (MEA*,N) IS USED WITH LENGTH 50*(KAMAX+1).
C
C
C
C     B.8  DETERMINE PEAK VALUES        -NOT YET AVAILABLE-
C
C     THE PEAK VALUE IS SEARCHED FOR IN THE DISTRIBUTION OF
C     ENTRIES X. INTERNALLY A HISTOGRRAM IS MADE, WHICH IS
C     ANALYSED USING STATISTICAL METHODS TO FIND THE LARGEST
C     PEAK CONSISTENT WITH A RAW DESCRIPTION.
C
C                -- -- -
C     CALL UPEAK(N,KA,X)
C
C        ADD NEW ENTRY X TO PEAK SEARCH N,KA.
C        THE KA-VALUE MAY BE BETWEEN 0 AND KAMAX,
C        AS GIVEN IN DPEAK.
C
C                - ----- -- -- ----
C     CALL DPEAK(N,KAMAX,XA,XZ,FWHM)
C
C        FOR PEAK SEARCHES N,0 TO N,KAMAX SPACE IS RESERVED.
C        IF NOT CALLED, FOLLOWING CALLS TO UPEAK ARE IGNORED.
C        THE ARGUMENTS GIVE A RAW DESCIPTION OF THE PEAK.
C        XA,XZ  = LOWER AND UPPER POSSIBLE VALUES OF PEAK POSITION
C        FWHM   = EXPECTED FULL WIDTH AT HALF MAXIMUM OF THE PEAK
C
C                -
C     CALL PPEAK(N)
C        RESULTS ON PEAK SEARCHES N,... ARE PRINTED, TOGETHER WITH
C        HISTOGRAMS. FOR N=0 ALL RESULTS ARE PRINTED, BUT WITHOUT
C        HISTOGRAMS.
C
C
C                - --
C     CALL QPEAK(N,KA,Q)
C                     -
C        WHERE Q( ) = ARRAY OF LENGTH 6 FOR PEAK SEARCH RESULTS
C
C         I       Q(I)
C         1       NR OF ENTRIES TOTAL
C         2       PEAK POSITION
C         3       SIGMA
C         4       FWHM
C         5       FRACTION OF ENTRIES WITHIN +- 1 STANDARD DEVIATIONS
C         6       FRACTION OF ENTRIES WITHIN +- 3 STANDARD DEVIATIONS
C
C     A BANK (PEA*,N) IS USED WITH LENGTH UP TO 10+100*(KAMAX+1).
C
C
C
C     B.9  STORE SINGLE VALUES
C
C                - -- -
C     CALL USSTO(N,KA,X)
C        STORE VALUE X IN STORAGE N,KA. KA VALUES ARE ALLOWED
C        BETWEEN 0 AND KAMAX, IF SPACE IS RESERVED BY
C        DSSTO(N,KAMAX).
C
C
C                - ----- ---
C     CALL DSSTO(N,KAMAX,IEN)
C        FOR STORAGE N,0 TO N,KAMAX SPACE IS RESERVED FOR UP TO
C        IEN ENTRIES EACH. IF NOT CALLED, KAMAX=0 AND IEN=100.
C
C                - --
C     CALL QSSTO(N,KA,Q,NQ,NENT)
C                     - -- ----
C
C        WHERE Q( ) = ARRAY OF LENGTH IEN, CONTAINING NQ SINGLE
C                     X-VALUES FROM A TOTAL OF NENT X-VALUES
C
C     A BANK (SST*,N) IS USED WITH LENGTH 1+(IEN+1)*KAMAX.
C
C
C
C
C     B.10  BIN DEFINITION
C
C     THE BIN NUMBER LB OF A VALUE X IN A BIN DEFINITION
C     DEFINED BY A BANK ('$BIN',NC) IS OBTAINED BY
C              -- -
C     LB = LBN(NX,X)
C
C     THE BANK ('$BIN',NX) MAY BE DEFINED BY DATA CARDS, READ BY
C     BREADC, AND MUST BE OF ONE OF THE FOLLOWING FORMS.
C
C     $BIN NX  XL XH                        ( NB=100 ASSUMED)
C     $BIN NX  XL XH NB                     ( NB LESS EQUAL 1000)
C     $BIN NX  X1 X2 X3 X4 . . . XL         ( NB = L-1, L AT LEAST 4)
C
C     XL AND XH ARE THE LOWER AND UPPER LIMITS OF ALL NB BINS.
C     X1, X2, X3 . . . ARE THE LOWER LEFT EDGES OF THE BINS,
C     SORTED IN ASCENDING ORDER.
C
C     FUNCTION LBN(N,X) RETURNS WITH 0, IF NO CORRESPONDING
C     BANK IS STORED. IT RETURNS 0 OR NB+1 FOR X VALUES OUTSIDE
C     THE BIN DEFINITION.
C
C     THE LIMITS XL AND XH OF A GIVEN BIN NR LB FOR BIN DEFINITION NX
C     IS OBTAINED BY
C               -- --
C     CALL VLBN(NX,LB,XL,XH,NB)
C                     -- -- --
C     NB IS THE TOTAL NR OF BINS.
C
C
C     B.11  INTERPOLATION OF TABULATED DATA
C
C     USING THE SPLINE INTERPOLATION PROGRAM CUBSPL THE FUNCTION
C     BFUN GIVES THE INTERPOLATED FUNCTION VALUE (BDER THE FIRST
C     DERIVATIVE) AT A GIVEN X VALUE FOR TABULATED DATA, WHICH ARE
C     STORED IN A BANK ('$FUN',N) AND E.G. READ IN FROM CARDS
C     BY BREADC.
C
C     $FUN N  Y1 X1  Y2 X2  Y3 X3  Y4 X4 . . .
C
C     (X VALUES IN ASCENDING ORDER, AT LEAST 3 Y,X PAIRS)
C
C                 - -
C     YI   = BFUN(N,X)        INTERPOLATED FUNCTION VALUE
C
C                 - -
C     YDER = BDER(N,X)        FIRST DERIVATIVE
C
C
C     AT THE FIRST ENTRY A BANK ('+FUN',N) IS CREATED, WHICH CONTAINS
C     THE SPLINE COEFFICIENTS. ITSLENGTH IS 5*NR OF Y,X PAIRS.
C
C     A PLOT OF THE FUNCTION N IS OBTAINED BY
C
C     CALL PFUN(N)
C
C
C     B.11  DETERMINATION OF A LINEAR DEPENDENCE Y(X)-NOT YET AVAILABLE-
C
C     A LINEAR DEPENDENCE OF Y ON X CAN BE DETERMINED BY THE FOLLOWING
C     CALL FROM PAIRS OF Y,X VALUES. INTERNALLY USSTO IS USED.
C
C                -- ----- --- -- -- -- --
C     CALL DLIND(NA,KAMAX,IEN,YL,YH,XL,XH)
C
C     FOR LINEAR DEPENDENCES N,0 TO N,KAMAX SPACE IS RESERVED FOR UP
C     TO IEN PAIRS. YL,YH AND XL,XH ARE THE LIMITS FOR THE Y AND
C     X VALUES.
C
C
C
C                - -- - -
C     CALL ULIND(N,KA,Y,X)
C
C     ADD NEW Y,X PAIR TO LINEAR DEPENDENCE N,KA, IF Y AND X ARE
C     WITHIN THE LIMITS DEFINED BY DLIND.
C
C                -
C     CALL PLIND(N)
C
C     THE RESULT INCLUDING INTERCEPT AND SLOPE OF THE LINEAR
C     DEPENDENCES NA,0 TO NA,KAMAX ARE PRINTED.
C
C                - --
C     CALL QLIND(N,KA,Q)
C                     -
C
C        WHERE Q( ) = ARRAY OF LENGTH 10 FOR INFORMATION ON
C                     LINEAR DEPENDENCE N,KA
C
C      I      Q(I)
C      1      NR OF ENTRIES STORED
C      2      INTERCEPT
C      3      SLOPE
C      4      ERROR OF SLOPE
C      5      MEAN X
C      6      MEAN Y
C      7      ERROR OF MEAN Y
C      8      MEAN SIGMA OF SINGLE POINT
C      9      NR OF DELETED POINTS
C     10      NR OF TOTAL ENTRIES
C
C     THE METHOD USED FOR THE DETERMINATION OF THE LINEAR
C     DEPENDENCE ALLOWS A BACKGROUND CONTRIBUTION OF ABOUT
C     20 PERCENT OF RANDOMLY DISTRIBUTED Y,X PAIRS. THE FRACTION
C     OF DELETED POINTS BEFORE THE ACTUAL LINEAR FIT IS GIVEN
C     IN Q(9).
C
C     A BANK (LIN*,N) IS USED OF LENGTH 6 WORDS PLUS THE
C     CORRESPONDING BANK (SST*,N)
C
C
C
C     B.13  DETERMINATION OF AN EMPIRICAL FUNCTION
C
C
C     A FUNCTIONAL DEPENDENCE OF Y ON X CAN BE DETREMINED BY THE
C     FOLLOWING CALLS FROM PAIRS OF Y,X VALUES. INTERNALLY UMEAN
C     IS USED, THE RESULT IS STORED A BANK $FUN,N.
C
C                - --
C     CALL DEMPF(N,NX)
C
C     FOR EMPIRICAL FUNCTION N, THE BIN DEFINITION NX IS TO BE
C     USED FOR THE X-VALUES. THE MEAN OF THE Y-VALUES WITHIN
C     EACH X-BIN WILL BE DETERMINED.
C
C
C                - - -
C     CALL UEMPF(N,Y,X)
C
C     ADD NEW Y VALUE INTO THE BIN DEFINED BY THE X VALUE AND THE
C     BIN DEFINITION NX.
C
C     CALL PEMPF(N)
C
C     THE RESULT IS PRINTED, A BANK $FUN,N IS CREATED WITH MEAN
C     Y VALUES AND THE CENTRAL X VALUE FOR EACH BIN.
C
C     THE METHOD ALLOWS A CERTAIN BACKGROUND IN THE DATA.
C
C     A BANK (EMP*,N) IS USED OF LENGTH 2+LENGTH OF $BIN BANK
C     PLUS THE CORRESPONDING BANK (MEA*,N).
C
C
C
C
C
C
C
      RETURN
      END

C   08/11/78 203012152  MEMBER NAME  LGNBCK   (S)           FORTRAN
      SUBROUTINE LGNBCK( HPOS,NNBRO,LST)
C
C     S.YAMADA   26-12-77
C     LAST MODIFICATION   04-11-78  14:45
C     MODIFIED BY S.KOMAMIYA   5-11-79     COPIED FROM LGNBCL
C
C---- FILL THE NEIGHBOUR POSITIONS INTO LIST FOR THE POSITION HPOS.
C
      IMPLICIT INTEGER *2 (H)
      DIMENSION LST(5), HMAPEC(25),HLSTEC(92)
C---- HMAPEC,HLSTEC CONTAIN THE MAP AND THE NEIGHBOUR LIST OF
C     EACH COUNTER FOR THE ENDCAP PART.
C
      DATA HMAPEC/ 1,5,8,11,15,20,25,29,34,39,44,49,53,
     1             57,62,67,70,73,76,78,82,84,87,90,93/
C
      DATA HLSTEC/ 2,5,6,76, 1,6,7, 4,7,8, 3,8,9,25, 1,6,10,11,81,
     1            1,5,2,11,12, 2,3,12,13, 3,4,9,13,14, 4,8,14,15,29,
     2            5,11,16,17,87, 5,6,10,17,18, 6,7,18,20, 7,8,20,22,
     3            8,9,15,22,23, 9,14,23,24,34, 10,17,96, 10,11,16,
     4            11,12,19, 18,20, 12,13,19,21, 20,22, 13,14,21,
     5            14,15,24, 15,23,40/
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/178110414/
      NVRSN(14) = NVCODE
C
      IPOS = HPOS
      NNBR = 0
      IF(IPOS.GE.2688) GO TO 10
C
C---- THE BARREL PART.
      IZ = IPOS-IPOS/32*32
C
C---- +1 FOR IZ
      IF(IZ.EQ.31) GO TO 1
      NNBR = NNBR+1
      LST(NNBR) = IPOS+1
C---- -1 FOR IZ
    1 IF(IZ.EQ.0) GO TO 2
      NNBR = NNBR+1
      LST(NNBR) = IPOS-1
C
C----  +/-1 FOR PHI
    2 NNBR = NNBR+1
      IF(IPOS-2656) 5,6,6
    5 LST(NNBR) = IPOS+32
      GO TO 7
    6 LST(NNBR) = IPOS-2656
      GO TO 9
C
    7 IF(IPOS-32) 8,9,9
    8 NNBR = NNBR+1
      LST(NNBR) = IPOS+2656
      GO TO 50
    9 NNBR = NNBR+1
      LST(NNBR) = IPOS-32
C
C-- EXTRAPORATION OF THE DIFINITION FOR NEAREST NEIGHBOUR (BY S.K.)
C
C                IZ-1       IZ       IZ+1
C             +-----------------------------+
C     IPHI-1  | IPOS-33 | IPOS-32 | IPOS-31 |
C             +-----------------------------+
C     IPHI    | IPOS-1  |  IPOS   | IPOS+1  |
C             +-----------------------------+
C     IPHI+1  | IPOS+31 | IPOS+32 | IPOS+33 |
C             +-----------------------------+
C
      IPHI=IPOS/32
C-----IPOS-33
   50 IF(IZ.EQ.0) GO TO 51
      IF(IPHI.NE.0) GO TO 52
      NNBR=NNBR+1
      LST(NNBR)=IPOS+2655
      GO TO 51
   52 NNBR=NNBR+1
      LST(NNBR)=IPOS-33
C-----IPOS-31
   51 IF(IZ.EQ.31) GO TO 61
      IF(IPHI.NE.0) GO TO 62
      NNBR=NNBR+1
      LST(NNBR)=IPOS+2657
      GO TO 61
   62 NNBR=NNBR+1
      LST(NNBR)=IPOS-31
C-----IPOS+31
   61 IF(IZ.EQ.0) GO TO 71
      IF(IPHI.NE.83) GO TO 72
      NNBR=NNBR+1
      LST(NNBR)=IPOS-2657
      GO TO 71
   72 NNBR=NNBR+1
      LST(NNBR)=IPOS+31
C-----IPOS+33
   71 IF(IZ.EQ.31) GO TO 100
      IF(IPHI.NE.83) GO TO 82
      NNBR=NNBR+1
      LST(NNBR)=IPOS-2655
      GO TO 100
   82 NNBR=NNBR+1
      LST(NNBR)=IPOS+33
      GO TO 100
C
C---- THE ENDCAP PART
   10 CONTINUE
      ITB = 1
      IPOS = IPOS-2687
      IF(IPOS.LE.96) GO TO 11
C---- BOTTOM
      ITB = 2
      IPOS = IPOS-96
      IF(IPOS.GT.96) GO TO 90
   11 MM = (IPOS-1)/24
      MBASE = 24*MM
      IPTMP = IPOS-MBASE
C---- NEIGHBOUR LIST IS MADE BY LOOKING UP THE TABLE.
C---- THE TABLE IS PREPARED FOR THE 1-ST QUADRUNT,WHICH IS REFERENCED
C     BY IPTMP(MODULOUS 24 OF THE POSITION).
   12 NS = HMAPEC(IPTMP)
      NEXT = HMAPEC(IPTMP+1)
      LNG = NEXT-NS
      NB= NS-1
        DO 13 NN=1,LNG
        LSTNN = HLSTEC(NN+NB)+MBASE
        IF(LSTNN.GT.96) LSTNN = LSTNN-96
        LSTNN = LSTNN+2687
        IF(ITB.EQ.2) LSTNN = LSTNN+96
        LST(NN) = LSTNN
   13   CONTINUE
      NNBRO = LNG
      RETURN
   90 LST(1) = 0
  100 NNBRO = NNBR
      RETURN
      END

C   12/03/81 104071458  MEMBER NAME  DEADCL0  (PATRECSR)    FORTRAN
C
      LOGICAL FUNCTION DEADCL(ICELL,NRUN)
C
C     LAST UPDATE :   26/04/80
C     LAST UPDATE :   04/11/80
C     LAST UPDATE :   01/03/81
C     LAST UPDATE :   11/03/81
C     FUNCTION DEADCL NOW RUN# DEPENDENT
C     FUNCTION DEADCL ACCEPTS ONLY CELLNUMBERS BETWEEN 1 AND 96 INCL.
C     FUNCTION DEADCL RETURNS .TRUE.  IF THE CELL 'ICELL' IS DEAD
C     FUNCTION DEADCL RETURNS .FALSE. IF THE CELL 'ICELL' IS STILL ALIVE
C     FUNCTION DEADCL NOW ALSO APPLICABLE FOR MC-DATA:   MC INPUT IS
C                            READ IN FROM COMMON /CRDSTA/ AT EACH EVENT
C-----------------------------------------------------------------------
      INTEGER*2 HITD,HCELLD
      LOGICAL IC(96),LC(96),LCS(96)
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10)
      EXTERNAL RDMTCO
C
      DATA MERR/0/
      DATA   IC /
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .TRUE. ,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.TRUE. ,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.TRUE. ,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .TRUE. ,.TRUE. ,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .TRUE. ,.TRUE. ,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,
     ,  .FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE./
C
C                                      --- CHECK CELL NUMBER ---
  100 IF (ICELL.GE.1.AND.ICELL.LE.96) GOTO 110
      DEADCL = .TRUE.
      MERR = MERR + 1
      IF (MERR.LT.100) PRINT 6000, ICELL
 6000 FORMAT(' ********** ILLEGAL CELL NUMBER',I10,' FOUND **********')
      RETURN
C
C                                      --- CHECK RUN NUMBER ---
  110 IF (NRUN.LE.100) GOTO 300
C
C                                      --- REAL DATA ---
      DATA NCA /0/
      IF (NCA.EQ.0) PRINT 6101
 6101 FORMAT('0---->  DEADCL FUNCTION  <----  LAST UPDATE 11/03/81'/' ')
      NCA = NCA + 1
C
  113 IF (NRUN.LT.6286) GOTO 114
      DEADCL = .FALSE.
      RETURN
C
  114 IF (NRUN.LT.5800) GOTO 115
      DEADCL = .FALSE.
      IF (ICELL.EQ.65 .OR. ICELL.EQ.66) DEADCL = .TRUE.
      RETURN
C
  115 IF (NRUN.LT.5548) GOTO 120
      DEADCL = IC(ICELL)
      RETURN
C                                      --- OLD RUNS ---
  120 CALL UCOPY(IC(1),LC(1),96)
      IF (NRUN.NE.5547) GOTO 190
      DO 180 J=25,48
  180 LC(J) = .TRUE.
      GOTO 200
  190 LC(28) = .FALSE.
      IF (NRUN.GE.3311) GOTO 200
      LC(73) = .TRUE.
      LC(74) = .TRUE.
      IF (NRUN.GE.2789) GOTO 200
      LC(81) = .FALSE.
      LC(82) = .FALSE.
      IF (NRUN.GE.2776) GOTO 200
      LC(65) = .FALSE.
      LC(66) = .FALSE.
      IF (NRUN.GE.2745) GOTO 200
      LC(73) = .FALSE.
      LC(74) = .FALSE.
      IF (NRUN.GE.2304) GOTO 200
      LC(37) = .FALSE.
  200 DEADCL = LC(ICELL)
      RETURN
C
C                                      --- MONTE CARLO DATA ---
  300 CONTINUE
      DATA NCALL / 0 /
      NCALL = NCALL + 1
      DO 310 J=1,96
  310 LC(J) = .FALSE.
C                                      --- READ DEAD CELLS FROM /CRDSTA/
      MCDEAD = 0
      IF (NCDEAD.LE.0 .OR. NCDEAD.GT.10) GOTO 330
      MCDEAD = NCDEAD
      DO 320 K=1,NCDEAD
      KC = HCELLD(K)
      IF (KC.LE.0 .OR. KC.GT.96) GOTO 320
      LC(KC) = .TRUE.
  320 CONTINUE
C                                       --- AT 1. CALL:
C                                           PRINT DEAD CELL STATUS ---
  330 IF (NCALL.GT.1) GOTO 340
      PRINT 6600
      IF (MCDEAD.EQ.0) PRINT 6601
      IF (MCDEAD.NE.0) PRINT 6602, MCDEAD,(HCELLD(IPR),IPR=1,MCDEAD)
      PRINT 6603
 6600 FORMAT('0',16('DEADCELL'),'DEAD'/'       LOGICAL FUNCTION ',
     ,       '  D E A D C L   CALLED FOR MONTE CARLO DATA')
 6601 FORMAT('       NO DEAD CELLS FOUND IN COMMON/CRDSTA/')
 6602 FORMAT(' ',6X,I2,' DEAD CELLS FOUND IN COMMON/CRDSTA/ :',10I4)
 6603 FORMAT('       NO FURTHER CELLS SET TO <DEAD>'/
     ,       ' ',16('CELLDEAD'),'CELL'/' ')
      IF (NCALL.NE.1) GOTO 350
C
      DO 335 J=1,96
  335 LCS(J) = LC(J)
      GOTO 350
C                                      --- AT ALL LATER CALLS:
C                                          CHECK STATUS OF DEAD CELLS --
  340 ICHECK = 0
      DO 345 J=1,96
  345 ICHECK = ICHECK + LXOR(LC(J),LCS(J))
      IF (ICHECK.EQ.0) GOTO 350
C                                       --- PRINT NEW STATUS ---
      PRINT 6604
 6604 FORMAT('0',16('DEADCELL'),'DEAD'/'       STATUS OF DEAD CELLS IN',
     ,       ' MONTE CARLO CHANGED, NEW STATUS IS:')
      PRINT 6602, MCDEAD,(HCELLD(IPR),IPR=1,MCDEAD)
      PRINT 6603
C
      DO 348 J=1,96
  348 LCS(J) = LC(J)
C                                      --- CHECK CHANGE OF DEAD CELLS --
  350 DEADCL = LC(ICELL)
C
      RETURN
      END

C   05/03/79 810042026  MEMBER NAME  SPHRCY   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SPHRCY( P, NMOM, SPHITY , AXIS )
C-----------------------------------------------------------------------
C
C    ORIGINAL VERSION OF 23/02/79
C
C         MOD 14.05.87    R.RAMCKE    AXIS(1..3,4..6,7..9)  NORMALISED
C    LAST MOD  4.10.88    C.BOWDERY   PROTECT AGAINST DIVISION BY ZERO
C
C    COMPUTE SPHERICITY FOR A SET OF MOMENTA
C    P IS ARRAY OF MOMENTA P(1..4,1..NMOM), WHERE P(1..4)=PX,PY,PZ,PTOT
C
C    SPHITY IS ARRAY OF NORMALISED EIGENVALUES
C
C    AXIS(1..3)  EIGENVECTOR WITH SMALLEST EIGENVALUE
C    AXIS(4..6)  EIGENVECTOR
C    AXIS(7..9)  EIGENVECTOR WITH BIGGEST EIGENVALUE
C
C-----------------------------------------------------------------------
C
      DIMENSION P(4,NMOM),T(6),R(9),AXIS(9), SPHITY(3)
C
C--------------  C O D E  ----------------------------------------------
C
C
C                            LOAD MOMENTUM TENSOR
C
       DO 10 I=1,6
   10  T(I)=0.
       DO 20 J=1,NMOM
       T(1) = T(1) + P(2,J)*P(2,J) + P(3,J)*P(3,J)
       T(2) = T(2) - P(1,J)*P(2,J)
       T(3) = T(3) + P(1,J)*P(1,J) + P(3,J)*P(3,J)
       T(4) = T(4) - P(1,J)*P(3,J)
       T(5) = T(5) - P(2,J)*P(3,J)
   20  T(6) = T(6) + P(1,J)*P(1,J) + P(2,J)*P(2,J)
C
C                            DIAGONALIZE MOMENTUM TENSOR T
C
       CALL EIGEN( T, R, 3, 0 )
C
C                            LOAD SPHERICTY AND JET AXIS
C
       SUM = T(1) + T(3) + T(6)
C
       IF( SUM .NE. 0.0 ) GO TO 25
         WRITE(6, 23)
   23    FORMAT(' * * * * *   DIVISION BY ZERO PREVENTED IN SPHRCY. ',
     +          ' RESULTS PROBABLY MEANINGLESS!')
         SUM = 1.0
C
   25  SPHITY(1) = 3.* T(6) / SUM
       SPHITY(2) = 3.* T(3) / SUM
       SPHITY(3) = 3.* T(1) / SUM
       DO 30 I=1,3
   30  AXIS(I) = R(I+6)
       DO 40 I=4,6
   40  AXIS(I)= R(I)
       DO 50 I=7,9
   50  AXIS(I)= R(I-6)
C
       K = -3
       DO 60 I = 1,3
         K = K + 3
         ASC   = SQRT(AXIS(K+1)**2 + AXIS(K+2)**2 + AXIS(K+3)**2)
         IF( ASC .NE. 0.0 ) GO TO 53
           WRITE(6,23)
           ASC = 1.0
C
 53      ASCAL = 1.0/ASC
         DO 55 J = 1,3
 55         AXIS(K+J) = AXIS(K+J)*ASCAL
 60    CONTINUE
C
      RETURN
      END

C   08/08/83 308081857  MEMBER NAME  MUSAFE   (JADEMUS)     FORTRAN
C(************************************************)
C(*                                              *)
C(*  ROUTINE TO DECIDE IF AN ANGULAR COORDINATE  *)
C(*  FALLS IN THAT AREA OF THE MUON FILTER WHERE *)
C(*  IT IS LIKELY NOT TO BE RECOGNISED.          *)
C(*     USED TO SET THE ACCEPTANCE FLAG IN THE   *)
C(*  MUR2 BANK. RETURNS VALUES:-                 *)
C(*         0  -  DEFINITELY IN ACCEPTANCE       *)
C(*         2  -  DEFINITELY OUT OF ACCEPTANCE   *)
C(*                                              *)
C(************************************************)
      INTEGER FUNCTION MUSAFE(COSTHE,PHI)
      IMPLICIT REAL(C,P)
C
C     (* CONSTANTS THAT PARAMETRISE MISSED MUON MAP *)
      DATA COST1, COST2, COST3, COST4/-0.89,-0.82,-0.65,-0.62/
      DATA COST5, COST6, COST7, COST8/-0.58,-0.04,+0.12,+0.53/
      DATA COST9,COST10,COST11,COST12/+0.60,+0.67,+0.80,+0.89/
      DATA PHI1, PHI2, PHI3, PHI4/-135.0,-120.0,-103.0,-103.0/
      DATA PHI5, PHI6, PHI7, PHI8/-74.0, -73.0, -56.0, -43.0/
      DATA PHI9,PHI10,PHI11,PHI12/+33.0, +79.0, +99.0,+145.0/
C
C     (* CONE AROUND BEAM PIPE *)
      IF (COSTHE.LE.COST1 .OR. COSTHE.GE.COST12) GOTO 1
C
C     (* GAP BELOW BEAM PIPE AT EACH ENDWALL *)
      IF ((COSTHE.LE.COST3 .AND. PHI.GE.PHI3 .AND. PHI.LE.PHI5).OR.
     &    (COSTHE.GE.COST10.AND. PHI.GE.PHI4 .AND. PHI.LE.PHI6)) GOTO 1
C
C     (* SIDE EDGES OF PLINTH *)
      IF (COSTHE.GE.COST5 .AND. COSTHE.LE.COST8 .AND.
     &    ((PHI.GE.PHI1 .AND. PHI.LE.PHI2).OR.
     &     (PHI.GE.PHI7 .AND. PHI.LE.PHI8))) GOTO 1
C
C     (* GAPS BETWEEN CHAMBERS IN EACH ARCH *)
      IF (PHI.GE.PHI9 .AND. PHI.LE.PHI12 .AND.
     &    COSTHE.GE.COST6 .AND. COSTHE.LE.COST7) GOTO 1
C
C     (* GAP BETWEEN ARCHES *)
      IF (PHI.GE.PHI10 .AND. PHI.LE.PHI11) GOTO 1
C
C     (* END EDGES OF ROOF *)
      IF (PHI.LE.PHI12 .AND.
     &    PHI.LE.(PHI12-PHI11)/(COST2+1)*(COSTHE+1)+PHI11 .AND.
     &    PHI.GE.(PHI12-PHI10)/(COST4-COST1)*(COSTHE-COST1)+PHI10)GOTO 1
      IF (PHI.GE.PHI9 .AND.
     &    PHI.GE.(PHI9-PHI10)/(COST2+1)*(COSTHE+1)+PHI10 .AND.
     &    PHI.LE.(PHI9-PHI11)/(COST4-COST1)*(COSTHE-COST1)+PHI11) GOTO 1
      IF (PHI.LE.PHI12 .AND.
     &    PHI.LE.(PHI11-PHI12)/(1-COST11)*(COSTHE-1)+PHI11 .AND.
     &    PHI.GE.(PHI10-PHI12)/(COST12-COST9)*(COSTHE-COST12)+PHI10)
     &       GOTO 1
      IF (PHI.GE.PHI9 .AND.
     &    PHI.GE.(PHI10-PHI9)/(1-COST11)*(COSTHE-1)+PHI10 .AND.
     &    PHI.LE.(PHI11-PHI9)/(COST12-COST9)*(COSTHE-COST12)+PHI11)
     &       GOTO 1
C
C     (* IF NONE OF ABOVE CONDITIONS TRUE *)
      MUSAFE=0
      RETURN
C
C     (* IF ANY OF ABOVE CONDITIONS TRUE *)
    1 MUSAFE=2
      RETURN
      END

C   08/07/85 507081853  MEMBER NAME  SAFCHK   (S)           FORTRAN
C   07/11/79 911071729  MEMBER NAME  SAFCHK   (JADEGS)      FORTRAN
      SUBROUTINE SAFCHK(JUNIT)
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
      COMMON/CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR
      COMMON/CSVCW1/NDDSVE,NRWR
      REWIND JUNIT
      NREC=0
    1 CONTINUE
      READ(JUNIT,ERR=1000,END=2000) NDUMMY
      NREC=NREC+1
      GO TO 1
 1000 CONTINUE
      WRITE(JUSCRN,100) NREC
  100 FORMAT(' *** READ ERROR IN SAFCHK AFTER',I8,' RECORDS. ***')
    3 CONTINUE
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' THERE IS A READ ERROR ON YOU OUTPUT FILE.^')
      CALL TRMOUT(80,' THIS IS MOST GRAVE. PLEASE END YOUR GRAPHICS.^')
      CALL TRMOUT(80,' SESSION, KEEP YOUR CWORK CONTENTS SAFETY FILE ^')
      CALL TRMOUT(80,' AND INVESTIGE THE CONTENTS OF THE OUTPUT FILE^')
      CALL TRMOUT(80,' FROM BATCH.^')
      CALL TRMOUT(80,' ENTER THE NUMBER 777 TO INDICATE YOU HAVE^')
      CALL TRMOUT(80,' UNDERSTOOD THESE GRIM TIDINGS. ENTER ANY ^')
      CALL TRMOUT(80,' OTHER NUMBER IF THE MESSAGE HAS FLASHED BY^')
      CALL TRMOUT(80,' TOO FAST. ^')
      NDUM=TERNUM(NDDY)
      IF(NDUM.NE.777) GO TO 3
      RETURN
 2000 CONTINUE
      WRITE(JUSCRN,101) NRWR,NRWRIT,NREC
  101 FORMAT(' SAFCHK. NRWR, NRWRIT, NREC = ',3I8)
      IF((NRWR+NRWRIT).EQ.NREC) CALL TRMOUT(80,'SAFETY CHECK OK.^')
      IF((NRWR+NRWRIT).EQ.NREC) RETURN
    2 CONTINUE
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' ***** WARNING *****^')
      CALL TRMOUT(80,' YOU HAVE BEEN SCREWED BY AN OBSCURE BOS^')
      CALL TRMOUT(80,' FEATURE. LAST EVENT NOT, EMPHASIS NOT WRITTEN!^')
      CALL TRMOUT(80,' KEEP YOUR SAFETY FILE WITH THE CWORK CONTENTS^')
      CALL TRMOUT(80,' AND USE MODULE F11LHO.GRAPHL(JADED) TO RECOVER^')
      CALL TRMOUT(80,' AND WRITE YOUR EDITING RESULTS. DO NOT ATTEMPT^')
      CALL TRMOUT(80,' TO USE THIS MODULE FOR OTHER PURPOSES.^')
      CALL TRMOUT(80,' ENTER THE NUMBER 777 TO INDICATE YOU HAVE^')
      CALL TRMOUT(80,' UNDERSTOOD THESE GRIM TIDINGS. ENTER ANY ^')
      CALL TRMOUT(80,' OTHER NUMBER IF THE MESSAGE HAS FLASHED BY^')
      CALL TRMOUT(80,' TOO FAST. ^')
      NDUM=TERNUM(NDDY)
      IF(NDUM.NE.777) GO TO 2
      RETURN
      END

C   14/08/79 003171304  MEMBER NAME  BWRITEKW (JADESR)      FORTRAN
C
        SUBROUTINE BWRITE(IUN,LENG,ID)
C---
C---     COPIED OVER FROM 'F22KAW.MTLINKS(STWAD1)' 17.20 16.08.79
C---
C
C             CODED BY S.KAWABATA AT 06.08.79
C             LAST MODIFIED       AT 14.08.79
C
        COMMON/  CPK/ NTOT,NTOLD,NBLK,NEV,NS
        COMMON/CPACK/ IX(1557)
        DIMENSION JD(52),JD2(52)
        DIMENSION ID(1)
        DATA IHD,JD2/'HIDD',52*0/
        DATA N1538,N1548,N1557/ 1538,1548,1557/
C
      IF(NTOT.GE.0) GO TO 999
C---
C---     OUTPUT FILE IS S FORMAT.
C---
      CALL SFORWT(IUN,LENG,ID)
      RETURN
  999 CONTINUE
        IF(NEV.NE.0) GO TO 10
C
C=======================> INITIALIZATION <============================
C
                         NBLK = 0
                         NTOT = 0
                         NS   = 0
   10   NEV  = NEV + 1
        NAMEB = 0
        IX(NTOT+1) = IHD
        IX(NTOT+2) = NEV
        IX(NTOT+3) = 0
        NTOLD= NTOT
        NTOT = NTOT+LENG+5
C                        A THIS 5 IS FOR EVENT HEADER
        IF(NTOT.GT.N1557) GO TO 100
C
C=======================> COMPLETE EVENT <==============================
C
        IX(NTOLD+4) = LENG+1
C                          A THIS 1 IS FOR IC-FLAG
        IX(NTOLD+5) = 0
        CALL UCOPY2(ID(1),IX(NTOLD+6),LENG)
        IF(NTOT.GE.N1538) GO TO 400
        RETURN
C
C======================> IMCOMPLETE EVENT <=============================
C
C=============> CHECK FORMAT AND SAVE ADDRESS OF LAST WORD OF BANKS
C
  100   IB = 1
        DO 110 I=2,51
        IF(IB.GT.LENG) GO TO 115
        IBJ = IB
        IB  = IB+ID(IB+3)+4
        IB1 = IB-1
        JD2(I) = IB1
  110   CONTINUE
C
C=============> INVERSE THE ORDER
C
  115   MBANK = I-1
        CALL UCOPIV(JD2,JD,MBANK)
        NW = 0
        ICON = 0
C
C---- NW  : NO. OF WORDS OF THE EVENT ALREADY WRITTENIN IN THE RECORD.
C---- ICON: WORD-COUNT FOR BANCK HEADER
C          ICON = 0, IF NEXT RECORD HAS NON DUPLICATE BANK HEADR.(IFL=1)
C          ICON = 4, IF NEXT RECORD HAS DUPLICATE BANK HEADR.(IFL=2)
C
  120    CONTINUE
C/////////
C         WRITE(6,9120) MBANK,(JD2(KK),KK=1,MBANK)
C9120     FORMAT(20I6)
C        CALL KDEBUG(120,3,NW,ICON,NS)
C
        NTOLD4 = NTOLD+4
        NTOLD5 = NTOLD+5
C
C=============> CHECK LAST PART OF RECORD
C
        DO 130 I=1,MBANK
        NWBNK = JD(I)
        LW     = NTOLD5+ICON+NWBNK-NW
        IF(LW.GE.N1548 .AND. LW.LE.N1557) GO TO 150
        IF(LW.LT.N1548 .AND. NTOT.GT.N1557) GO TO 170
  130   CONTINUE
        WRITE(6,9130)
 9130   FORMAT(1X,'ERROR : TYPE 130')
        RETURN
C
C==============> SET FLAG
C
C-------- NON DUPLICATE BANK HEADR
  150   JJ = NWBNK-NW
        IFL= 1
        GO TO 200
C-------- DUPLICATE BANK HEADR
  170   JJ = N1557-NTOLD5-ICON
        IFL= 2
  200   IX(NTOLD4) = JJ+ICON+1
        ICF= 1
        IF(NS.EQ.1) ICF= 2
        IX(NTOLD5)= ICF
        CALL UCOPY2(ID(NW+1),IX(NTOLD5+ICON+1),JJ)
C
        IF(IFL.EQ.2) GO TO 300
C
C==============> NON DUPLICATE BANK HEADR
C
        NTOT1 = NTOLD5+ICON+JJ
        WRITE(IUN) NTOT1,IX
        NBLK= NBLK+1
        CALL UZERO(IX,N1538,N1557)
        NS= 1
        NTOT1 = NTOT-NTOT1
        NTOT= NTOT1+5
        IX(1)= IHD
        IX(2)= NEV
        IX(3)= 0
        IA1= NWBNK+1
        IA2= 6
        IF(NTOT.LE.N1557) GO TO 350
        ICON = 0
        GO TO 460
C
C==============> DUPLICATE BANK HEADER
C
  300   CONTINUE
        NAMEA= ID(NWBNK+1)
        NUMBA= ID(NWBNK+2)
        IF(NAMEA.NE.NAMEB) GO TO 310
        IF(NUMBA.EQ.NUMBB) GO TO 320
  310   IBSTOL= 0
        NAMEB= NAMEA
        NUMBB= NUMBA
  320   LNB= LW
        IF(LW.LT.6) LNB= 5
        IBSTOR= N1557-LNB-4
        IBSTOL= IBSTOL+IBSTOR
        IX(LNB+4)= IBSTOR
        WRITE(IUN) N1557,IX
        NBLK= NBLK+1
        CALL UZERO(IX,N1538,N1557)
        NS= 1
        NTOT1= NTOT-N1557
        NTOT= NTOT1+9
        IX(1)= IHD
        IX(2)= NEV
        IX(3)= 0
        IX(6)= NAMEA
        IX(7)= NUMBA
        IX(8)= ID(NWBNK+3)
        IX(9)= ID(NWBNK+4)-IBSTOL
        IA1= NW+JJ+1
        IA2= 10
        IF(NTOT.GT.N1557) GO TO 450
  350   CALL UCOPY2(ID(IA1),IX(IA2),NTOT1)
        IX(4)= NTOT-4
        IX(5)= 3
        IBSTOL = 0
        NS= 0
        IF(NTOT.LT.N1538) RETURN
  400   WRITE(IUN) NTOT,IX
        NBLK= NBLK+1
        NTOT= 0
        CALL UZERO(IX,N1538,N1557)
        RETURN
  450   ICON= 4
  460   NW= NW+JJ
        MBANK= I
        NS= 1
        NTOLD= 0
        GO TO 120
C
C=============================> BWTEND <================================
C
        ENTRY BWTEND(IUN)
C
        IF(NTOT.LT.0) RETURN
        IF(NTOT.EQ.0) GO TO 1300
        NT1= NTOT+1
        IF(NT1.GT.N1557) GO TO 1100
        CALL UZERO(IX,NT1,N1557)
 1100   WRITE(IUN) NTOT,IX
         NBLK= NBLK+1
         NTOT= 0
 1300    NS= 0
         RETURN
         END
C
      SUBROUTINE SFORWT(IUN,LENG,ID)
      IMPLICIT INTEGER*2 (H)
      DIMENSION ID(LENG)
      WRITE(IUN) LENG,ID
      RETURN
      END
C
C>>>>>>>>>>>>>>> BLOCK DATA <<<<<<<<<<<<<<<<<<<<<
C
       BLOCK DATA
C
        COMMON/  CPK/ NTOT,NTOLD,NBLK,NEV,NS
        DATA NTOT/ 0/
        DATA NEV/ 0/
        END

C   29/07/79 004240754  MEMBER NAME  ORDLG    (S)           FORTRAN
      SUBROUTINE ORDLG
C-----------------------------------------------------------
C   VERSION OF 29/07/79      LAST MOD    24/04/80   BARTEL/ELSEN
C   PUT LEAD GLASS BLOCKS WITH AMPLITUDES .NE.0 INTO ARRAY HAMPL
C      HAMPL(1,I) = BLOCK NUMBER
C      HAMPL(2,I) = PULSEHEIGHT IN MEV
C   ERASE BLOCKS IN FIRST AND LAST RING ( THESE RINGS HAVE NOT
C   BEEN BUILT IN ).
C   ERROR CORRECTED IN ROW NUMBER FOR ERASED BLOCKS.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON/CLGHIT/AMPLG(3000)
      COMMON/CLGAMP/LGLONG,HAMPL(2,1000)
      DATA NBLIM / 2688 /
C
      LGLONG=0
      I1=0
C
      DO 1 I=1,3000
      IF(AMPLG(I).EQ.0.) GO TO 1
C                                           END CAP CHECK
      IF( I .GT. NBLIM ) GO TO 2
C                                           ERASE EXTREME RINGS
      IF( MOD(I,32) .EQ. 0 ) GO TO 1
      IF( MOD(I+31,32) .EQ. 0 ) GO TO 1
C                                           STORE BLOCK AND ENERGY
    2 LGLONG=LGLONG+2
      I1=I1+1
      HAMPL(1,I1)=I
      HAMPL(2,I1)=AMPLG(I)
    1 CONTINUE
      RETURN
      END

C   13/06/85 506131758  MEMBER NAME  TEMP     (S)           FORTRAN
   1 $INFO
   2 ##STATUS
   3 #JOB
   4 #START
   5 #TAGDOC
   6 #TAGDOC2
   7 ACOL
   8 AFTP83
   9 AMCTAG
  10 ANAL79
 110 CALAD
 111 CLSPS
 112 CLUSFN
 113 COMFIL
 114 CONVER
 115 CTAGGO
 116 CUTPED
 117 CUTP81
 118 CWKTAG2
 119 DATE
 120 FFITYP
 121 FHTOS
 122 FHTOS0
 123 FITAG
 124 FRTYPE
 125 FSTOH
 126 GGBLCK
 127 GGCCTL
 128 GGCLPC
 129 GGCLSD
 130 GGCLUS
 131 GGFAC1
 132 GGFAC2
 133 GGFAC3
 134 GGFAC4
 135 GGFAC5
 136 GGFAC6
 137 GGRESQ
 138 GGSORT
 139 GGSRTH
 140 GSCRUB
 141 HDDUMP
 142 INGAM1
 143 LISTGN
 144 LUCHEK
 145 LUMONS
 146 OUTGAW
 147 PEDFIX
 148 RCOORD
 149 REPACK
 150 SORT
 151 SORT1
 152 SORT2
 153 SRSUM
 154 SUBNEW
 155 SUBOLD
 156 TAGADC
 157 TAGALL
 158 TAGAN
 159 TAGCHK
 160 TAGCLS
 161 TAGCOL
 162 TAGDAT
 163 TAGDIR
 164 TAGFIT
 165 TAGFTY
 166 TAGF82
 167 TAGGTP
 168 TAGH2S
 169 TAGINT
 170 TAGKAL
 171 TAGMRK
 172 TAGNEB
 173 TAGNOTE
 174 TAGNOTE2
 175 TAGPD1
 176 TAGPD2
 177 TAGPED
 178 TAGPHI
 179 TAGPOS
 180 TAGPS1
 181 TAGPS2
 182 TAGRAW
 183 TAGRTY
 184 TAGSET
 185 TAGSR1
 186 TAGSR2
 187 TAGSTO
 188 TAGSUM
 189 TAGS2H
 190 TGDCOS
 191 TRACKS
 192 UMCPAK










-------------- LINECOMMANDS IN DIRECTORY DISPLAY -----------------------
 LINECOMMANDS ARE TO BE STARTED IN THE FIRST COLUMN
 CH    : CHANGE MEMBER              PR : PRINT MEMBER(S)
 SUBH  : SUBMIT MEMBER(S) WITH HOLD SUB: SUBMIT MEMBER(S)
 SC    : SCRATCH MEMBER(S)          RT : RESET MEMBER(S)
 COLOAD: COMPILE MEMBER WITH LOAD   CO : COMPILE MEMBER
 LIST  : LIST MEMBER                DUP: DUPLICATE MEMBER
 L     : POSITION LISTING           SCL: SCRATCH LOAD MEMBER
 GO    : EXECUTE LOAD MODULE        EX : EXECUTE CLIST
 C,CC  : COPY SINGLE LINES OR A RANGE OF LINES TO A MEMBER
 RENAME: RENAME PS AND/OR PL MEMBERS BY OVERWRITING THE NAMES
         IN THE CORRESPONDING PS/PL MEMBERS COLUMNS
 S     : SAVE MEMBER(S)

 YOU MAY ENTER SC,RT,S,RENAME,SCL,SUB,SUBH COMMANDS IN
 ARBITRARY NUMBER, BUT ONLY ONE OF CH,LIST,CO,GO,EX COMMANDS.
 IF YOU USE THE DUP COMMAND, OVERWRITE THE NAME BY A NEW NAME
------------------------------------------------------------------------
    18/03/84 403222224  MEMBER NAME  #TAGDOC  (S)           FORTRAN

THIS IS SOME RATHER HAPHAZARD DOCUMENTATION FOR THE ROUTINES USED
FOR ANALYSING TAGGING INFORMATION FROM 1981 ONWARDS AS WRITTEN BY
A.J.FINCH 21/3/84

ADDITIONAL NOTES CONCERNING 'TAGAN'-
====================================

 SOME DEBUGGING INFO CAN BE TURNED ON BY THE FOLLOWING PROCEDURE

      COMMON/CONTRL/JWRITE
      JWRITE=1      -> TURNS  ON INFO
      JWRITE=0      -> TURNS  OFF INFO


      SUBROUTINE TAGINT(*)
      ====================



  THIS IS THE INITIALISATION ROUTINE THAT SHOULD BE CALLED ONCE,BEFORE
  ANALYSING ANY EVENTS  USING  THE  ROUTINES  IN  THIS  PACKAGE.TO  BE   0000800
  PRECISE IT MUST CALLED ONCE PER EVENT TO SET UP THE CWORK COMMON       0000900
                                                                         0001000

  IT DOES A RETURN 1 IF TAGMRK DOES A RETURN 1 ,WHICH IT DOES IF 'HEAD'
   DOESNT EXIST




      SUBROUTINE COMFIL(IWRITE,*)
     ============================

    THIS SUBROUTINE TAKES THE DATA FROM HDATA BLOCK
    'ATAG' AND PUTS THE ADC CONTENTS IN THE ARRAY CATAG
                         IN ORDER OF ADC ADDRESS

     IWRITE IS A FLAG TO TELL WHETHER TO PRINT THE BANK 'CATAG' AFTER
     IT HAS BEEN FILLED.

    NOTE:- IT ALSO MULTIPLIES CHANNEL NUMBER TIMES A FACTOR TO MAKE IT
    APPROXIMATELY EQUAL TO ENERGY IN MEV



    SUBROUTINES PEDFIX,PEDFX2,PEDFX3
    ================================

 PEDFIX IS CONTROL ROUTINE WHICH CALLS ONE OF THE OTHER TWO TO DO THE
        WORK - ALTHOUGH THEY ARE SIMILAR IN CONCEPT IT AS TOO MUCH
            WORK TO COMBINE THEM INTO ONE ROUTINE

  ROUTINES  TO DO PEDESTAL SUBTRACTION

 PEDFX3   - 1983 ..ONLY
 ======
      ROUTINE TO ATTEMPT OFFLINE SUBTRACTION OF PEDESTALS
      FOR EACH 'SUPERBLOCK' OF 3 LEAD SCINTILLATOR ELEMENTS IT
    CHECKS THAT
     NO ONE CHANNEL IS GREATER THAT 500 MEV,IF THIS IS THE CASE ALL
   THREE BLOCKS ARE IGNORED , OTHERWISE THE VALUES IN THE BLOCKS ARE
    USED TO ESTIMATE A MEAN ADC PEDESTAL , WHICH IS THEN SUBTRACTED
   FROM ALL BLOCKS.


 PEDFX2  - 1981/2 ONLY
 ======
        SAME PROCEDURE AS PEDFX3 BUT 'SUPERBLOCKS' REPLACE 'CAKESLICES'


MEANING OF TERM 'SUPERBLOCK' USED IN COMMENTS OF THIS PROGRAM

  1/4 OF A TAGGING SYSTEM =

                                ___________
                                I    I    I
                      __________I    I    I
                      I    I    L____L____I
                      I    I    I    I    I
                      L____L____I    I    I
                      I    I    L____L____I
                      I    I    I
                   ___L____L____I
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I__
                      I    I    L
                      I    I    I__________
                      L____L____I    I    I
                      I    I    L    I    I
                      I    I    I____L____I
                      L____L____I    I    I
                                I    I    I
                                L____L____I

    'SUPERBLOCK' =

                   ___________
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I




 SUBROUTINE SRSUM(JPART,SUM,*)
 =============================


     THIS SUBROUTINES SUMS ALL  ADC DATA IN ARRAY CATAG ONE END OR THE
     OTHER TO GIVE THE VALUE OF SUM.

  JPART - INPUT - SIGN DETERMINES WHICH END TAGGER IS ANALYSED
                   JPART > 0 => +Z
                   JPART < 0 => -Z

   SUM - OUTPUT - SUM OF ENERGY

  RETURN 1 IF SUM IS A  CRAZY VALUE



 SUBROUTINE CALAD(IWRITE)
 ========================

    THIS SUBROUTINE   CALIBRATES ADC'S USING FACTORS IN
   COMMON CALIBR

  INPUT - IWRITE - IF THIS IS EQUAL TO ONE THE ROUTINE
                   WRITES OUT SOME DEBUGGING INFORMATION


 FUNCTION FSTOH(I)
 =================

  CONVERT SOFTWARE ADDRESS TO HARDWARE ADDRESS
  SEE ALSO FHTOS  - INPUT I = SOFTWARE ADDRESS TO BE CONVERTED



 SUBROUTINE FHTOS(ISAD,IHAD,*)
 =============================


  THIS ROUTINE CONVERTS HARDWARE ADDRESSES TO SOFTWARE ADDRESSES

  ISAD - OUTPUT - SOFTWARE ADDRESS
  IHAD - INPUT  - HARDWARE ADDRESS

  RETURN 1 IF IT CAN'T DO IT ( ILLEGAL ADDRESS SUPPLIED )


    THE PATTERN FOR 1983 ONWARDS IS -

    HARDWARE ADDRESS                              SOFTWARE ADDRESS

         0 - 3             NOT USED
         4 - 7           INNER RING - Z               1 - 4
         8 - 11            "      "                   5 - 8
        12 - 15            NOT USED
        16 - 19             "   "
        20 - 23           MIDDLE RING - Z             9- 12
        24 - 27              "  "                     13-16
        28 - 31            NOT USED
        32 - 35             "   '



     FOR 1981/2 SOFTARE ADDRESS = HARDWARE ADDRESS + 1


    18/03/84 503161535  MEMBER NAME  #TAGDOC2 (S)           FORTRAN

THIS IS SOME RATHER HAPHAZARD DOCUMENTATION FOR THE ROUTINES USED
FOR ANALYSING TAGGING INFORMATION FROM 1981 ONWARDS AS WRITTEN BY
A.J.FINCH 21/3/84

ADDITIONAL NOTES CONCERNING 'TAGAN'-
====================================

 SOME DEBUGGING INFO CAN BE TURNED ON BY THE FOLLOWING PROCEDURE

      COMMON/CONTRL/JWRITE
      JWRITE=1      -> TURNS  ON INFO
      JWRITE=0      -> TURNS  OFF INFO


      SUBROUTINE TAGINT(*)
      ====================



  THIS IS THE INITIALISATION ROUTINE THAT SHOULD BE CALLED ONCE,BEFORE
  ANALYSING ANY EVENTS  USING  THE  ROUTINES  IN  THIS  PACKAGE.TO  BE   0000800
  PRECISE IT MUST CALLED ONCE PER EVENT TO SET UP THE CWORK COMMON       0000900
                                                                         0001000

  IT DOES A RETURN 1 IF TAGMRK DOES A RETURN 1 ,WHICH IT DOES IF 'HEAD'
   DOESNT EXIST




      SUBROUTINE TAGADC(IWRITE,*)
     ============================

    THIS SUBROUTINE TAKES THE DATA FROM HDATA BLOCK
    'ATAG' AND PUTS THE ADC CONTENTS IN THE ARRAY CATAG
                         IN ORDER OF ADC ADDRESS

     IWRITE IS A FLAG TO TELL WHETHER TO PRINT THE BANK 'CATAG' AFTER
     IT HAS BEEN FILLED.

    NOTE:- IT ALSO MULTIPLIES CHANNEL NUMBER TIMES A FACTOR TO MAKE IT
    APPROXIMATELY EQUAL TO ENERGY IN MEV



    SUBROUTINES TAGPED,TAGPD1,TAGPD2
    ================================

 TAGPED IS CONTROL ROUTINE WHICH CALLS ONE OF THE OTHER TWO TO DO THE
        WORK - ALTHOUGH THEY ARE SIMILAR IN CONCEPT IT AS TOO MUCH
            WORK TO COMBINE THEM INTO ONE ROUTINE

  ROUTINES  TO DO PEDESTAL SUBTRACTION

 TAGPD2   - 1983 ..ONLY
 ======
      ROUTINE TO ATTEMPT OFFLINE SUBTRACTION OF PEDESTALS
      FOR EACH 'SUPERBLOCK' OF 3 LEAD SCINTILLATOR ELEMENTS IT
    CHECKS THAT
     NO ONE CHANNEL IS GREATER THAT 500 MEV,IF THIS IS THE CASE ALL
   THREE BLOCKS ARE IGNORED , OTHERWISE THE VALUES IN THE BLOCKS ARE
    USED TO ESTIMATE A MEAN ADC PEDESTAL , WHICH IS THEN SUBTRACTED
   FROM ALL BLOCKS.


 TAGPD1  - 1981/2 ONLY
 ======
        SAME PROCEDURE AS TAGPD2 BUT 'SUPERBLOCKS' REPLACE 'CAKESLICES'


MEANING OF TERM 'SUPERBLOCK' USED IN COMMENTS OF THIS PROGRAM

  1/4 OF A TAGGING SYSTEM =

                                ___________
                                I    I    I
                      __________I    I    I
                      I    I    L____L____I
                      I    I    I    I    I
                      L____L____I    I    I
                      I    I    L____L____I
                      I    I    I
                   ___L____L____I
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I__
                      I    I    L
                      I    I    I__________
                      L____L____I    I    I
                      I    I    L    I    I
                      I    I    I____L____I
                      L____L____I    I    I
                                I    I    I
                                L____L____I

    'SUPERBLOCK' =

                   ___________
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I




 SUBROUTINE TAGSUM(JPART,SUM,*)
 =============================


     THIS SUBROUTINES SUMS ALL  ADC DATA IN ARRAY CATAG ONE END OR THE
     OTHER TO GIVE THE VALUE OF SUM.

  JPART - INPUT - SIGN DETERMINES WHICH END TAGGER IS ANALYSED
                   JPART > 0 => +Z
                   JPART < 0 => -Z

   SUM - OUTPUT - SUM OF ENERGY

  RETURN 1 IF SUM IS A  CRAZY VALUE



 SUBROUTINE TAGKAL(IWRITE)
 ========================

    THIS SUBROUTINE   CALIBRATES ADC'S USING FACTORS IN
   COMMON CALIBR

  INPUT - IWRITE - IF THIS IS EQUAL TO ONE THE ROUTINE
                   WRITES OUT SOME DEBUGGING INFORMATION


 FUNCTION TAGS2H(I)
 =================

  CONVERT SOFTWARE ADDRESS TO HARDWARE ADDRESS
  SEE ALSO TAGH2S  - INPUT I = SOFTWARE ADDRESS TO BE CONVERTED



 SUBROUTINE TAGH2S(ISAD,IHAD,*)
 =============================


  THIS ROUTINE CONVERTS HARDWARE ADDRESSES TO SOFTWARE ADDRESSES

  ISAD - OUTPUT - SOFTWARE ADDRESS
  IHAD - INPUT  - HARDWARE ADDRESS

  RETURN 1 IF IT CAN'T DO IT ( ILLEGAL ADDRESS SUPPLIED )


    THE PATTERN FOR 1983 ONWARDS IS -

    HARDWARE ADDRESS                              SOFTWARE ADDRESS

         0 - 3             NOT USED
         4 - 7           INNER RING - Z               1 - 4
         8 - 11            "      "                   5 - 8
        12 - 15            NOT USED
        16 - 19             "   "
        20 - 23           MIDDLE RING - Z             9- 12
        24 - 27              "  "                     13-16
        28 - 31            NOT USED
        32 - 35             "   '



     FOR 1981/2 SOFTARE ADDRESS = HARDWARE ADDRESS + 1


 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74



    JADE COMPUTER NOTE NUMBER 74
===========================================


   SUBJECT: Analysis Routines for Tagging System
   =============================================


                                                Author:A.J.Finch
                                                ================


 This note can be found in 'F11LHO.TAGG.S(TAGNOTE)'




 Summary:
 ========

     This  note  desribes  briefly  the  analysis  routines  installed
     recently on F11LHO.TAGG.S and F11LHO.TAGG.L whose purpose  is  to
     produce the output banks 'ACLS', 'TAGG' /0,/1,/2 whose content is
     described  in  Jade  Computer  Note  No.16.The  input  to  these
     routines is the 'ATAG' bank which contains the raw  adc  contents
     from the tagging adcs.They also utilise a new set of  calibration
     constants installed on the  standard  Jade  calibration  file,and
     obtained in the usual way by calling  KALIBR  for  every  run.The
     programs were originally written by H.Wriedt ,A.Finch, and  J.Nye.




Introduction:
=============

      One part of JADE  that has undergone slightly more changes than
      most is the tagging system .  In  1979  and  1980 there was the
      Mark 1 . For  1981 with the arrival of mini - betas  Mark 2 was
      installed suspended on the muon chambers. In order to solve the
      problems of browning lead glass encountered with this location,
      Mark 3  was  installed for  1983  running  onwards .  All these
      systems require different software to analyse them due to their
      differing geometries etc.



The Software:
============

      The minimum information a user needs to use the package
      that  runs these analysis programs is:

       1) Have F11LHO.TAGG.L in his list of load libraries.
       2) CALL KALIBR for every run.
       3) CALL TAGAN once per event.

       4) For 1979/80 data only :
            He must also have the private calibration file
            'F22HOW.PEDESTAL.ALLSP80' attached to fortran
             stream 19.


The routine TAGAN
=================



      TAGAN(IERTAG,NRUN)



     Arguments:
     ==========

           IERTAG - OUTPUT RETURN CODE

           NRUN   - INPUT DUMMY RUN NUMBER TO OVERIDE CONTROL  OF  WHICH
                          ANALYSIS ROUTINE IS  CALLED  FOR  MONTE  CARLO
                          DATA
                         ++++++++++++++++++++++++++++++++++++++++++
                         + IN 99% OF CASES THIS CAN AND SHOULD BE +
                         + SET TO ZERO                            +
                         ++++++++++++++++++++++++++++++++++++++++++

     Description:
     ============

      This  routine  controls the  analysis  routines.   Its first job
      is to  check that the  input event can be  analysed.  Classes of
      events that can not be analysed are :
          a) Pedestal events.
          b) Events with no 'HEAD' bank.
          c) Events with no 'ATAG' bank.
      The  routine must then  decide which of the  three possible sets
      of routines to call (one for each version of the tagging sytem).
      It does this by  using the  information in the  HEAD  bank.  For
      real data it simply uses the run number. For Monte Carlo  events
      it is neccesary to tell the program which Mark of tagging system
      to expect this is done by one of two methods:-
              On encountering  Monte Carlo  data, the routine looks at
              the  input argument  'nrun' . If this number is not zero
              it takes,  and uses,  it as the  run number,  so -

   Use of NRUN:
   ============
               NRUN                ASSUMED SIMULATION
               ====                ==================

               <6000                Mark 1
          6000>    <12947           Mark 2
               >12948               Mark 3

         If nrun is set to zero there is a second line of attack which
         is to look at the 2nd half word of the bank 'ATAG'. The value
         of this determines which simulation  was  done  according  to
         following scheme.

                   Value of word             Simulation
                   =============             ==========

                         0                    Mark 1    (or real data !)
                         1                    Mark 2
                         2                    Mark 3

        (Provided this scheme has been adopted in the simulation then
          NRUN can be set to zero)

         N.B. Tagan issues a messsage the first time it is called saying
              what it thinks it is analysing, and again if it encounters
              a change from one tagger type to another.





     Meaning of return code 'IERTAG':
     ================================

                   Value of IERTAG             Meaning
                   ===============             =======

                         0             No Problems - and clusters found.

                         1            No Problems - but  no  clusters
                                      found ('ATAG',and 'HEAD' exist)

                         2             Analysis was completed but
                                        at least one of the output
                                       banks could not be created due
                                       to lack of space.

                         10           No 'ATAG' banks - no analysis done

                         11           No 'HEAD' bank - no analysis done




Stucture of the main anlysis routines:
======================================

      The routines that TAGAN calls are-

      ANATAG  for 1979/80 data
      AFTP83  for 1981 onwards data (with a flag to tell whether data
                                     is from 1981/2 or 1983 onwards)

      The structure of AFTP83 is briefly described at the end of  this
      note for anyone who is interested, for more detail refer to  the
      commented version on F11LHO.TAGG.S.




Using analysis routines for other purposes:
===========================================

 Users may wish to use a small sample of the  routines for their own
 purposes. E.g. for fast selection routines. It is possible for 1981
 data onwards to use the following sheme:


          DATA THRESH/6000.0/

          CALL TAGSET(IMARK) - Force analysis to assume  IMARK  tagger,
                               IMARK = 2 or 3.  -  optional  for  monte
                               carlo data if simulation didn't set  flag
                               in 'ATAG

          CALL TAGINT(&100)  - Initialisation - to be called once  per
                              event ; RETURN 1 if can't work  out  which
                              tagger this is ( due to no head bank).

          CALL COMFIL(IWRITE,&100)    - Gets the ATAG data,if  IWRITE=
                                      1 writes out some debugging info
                                      Applies  nominal calibration to
                                      convert channel number to MeV.

          CALL PEDFIX   - pedestal fixing - optional
                                       (no disaster if not done)

           CALL CALAD(IWRITE)    -   Calibration - optional
                                       (no disaster if not done)

           CALL SRSUM(-1,SUMM,&100) - work out sum of -z and + z
           CALL SRSUM(+1,SUMP,&100) - return 1 if sum has 'impossible'
                                                  value
C
C SUMM,SUMP,THRESH are in MeV
C

           IF((SUMM.GT.THRESH).OR.(SUMP.GT.THRESH))....
 100       CONTINUE


 | For more detailed information about these and other routines
 | in this package see 'F11LHO.TAGG.S(#TAGDOC)'

 ____________________________________________________________________


 For completeness there now follows a brief description of
 the procedure adopted in the routine 'AFTP83' for analysing
 all data from 1981 onwards.


---------------------------------------------------------------------


=======================================================================
 PROCESS            | ROUTINE NAME   |   NOTES
                    | ( if not done  |
                    |  in AFTP83)    |
========================================================================
                    |                |
 Initialisation     | TAGINT         |
                    |                |
                    |                |
                    |                |
                    |                |
 Read data in 'ATAG'| COMFIL         |1) An overall calibration that
                    |                |   converts adc channel number to
                    |                |   MeV is applied.
                    |                |2) Software addresses are used
                    |                |   from here on.
                    |                |
 Subtract pedestals | PEDFIX         |These are caused by fluctuating
                    |                |pedestals due to 50HZ AC pickup
                    |                | on signal cables.It is only
                    |                | treated in those events where
                    |                | it exceeds the cut off at 20
                    |                | channels applied by the
                    |                | Le Croy ADC controler.Ammount
                    |                | to be subtracted is estimated on
                    |                | an event by event basis.
                    |                |
 Apply calibration  | CALAD          | Factors obtained from Kalibr.
  factors.          |                |
                    |                |
  Work out the sum  |SRSUM(JPART,SUM)| Works out SUM for JPART end
 of energy in -Z and|                | (JPART = +/- 1)
+Z tagger.          |                |
                    |                |
                    |                |
LOOP1 <This section once for -Z then once for +Z>>>>>>>>>>>>>>>
                    |                |
  Sort adcs into    | SORT1          |
 order of decreasing|                |
  energy contents.  |                |
                    |                |
  Use sorted list to| CLUSFN         |
  find clusters of  |                |
  deposited energy. |                |
    Store results in|                |
   cluster map.     |                |
                    |                |
=======================================================================
 PROCESS            | ROUTINE NAME   |   NOTES
                    | ( if not done  |
                    |  in AFTP83)    |
========================================================================
                    |                |
 LOOP2 <start loop over all clusters (this end) >>>
                    |                |
 Fill the cluster   |                |
 map 'ACLS' + save  |                |
 pointers for TAGG1 |                |
                    |                |
                    |                |
 Find position of   | CLSPS          | This is the main routine where
   centre of each   |                | geometrical differences effect
    cluster,in face |                | the software.
  of blocks.        |                |   The procedure adopted compares
                    |                |   the ratio of energies in the
                    |                |   hit block and its neighbours
                    |                |   to known distributions of
                    |                |   energy within e/m showers
                    |                |   to estimate how far to move
                    |                |   the centre of the shower from
                    |                |   the centre of the block with
                    |                |   the largest ammount of energy,
                    |                |   towards its neighbours with the
                    |                |   next largest ammounts of energy
                    |                |   N.B. A large fraction of hits
                    |                |   lose some significant fraction
                    |                |   of their energy out of the
                    |                |  inner or outer edges,which makes
                    |                |   position determination
                    |                |   difficult.
   Save information |                |   (Hardware addresses are used
   on individual    |                |   in the output)
   clusters to put  |                |
   in TAGG/2        |                |
                    |                |
 <end of LOOP2 over each cluster>    |
                    |                |
 repeat LOOP1 for +Z|                |
                    |                |
Calculate angle     |                |
 between clusters   |                |
 found above.Flag   |                |
 colinear pairs of  |                |
  clusters in TAGG2 |                |
                    |                |
 Create output      | TAGSTO         |
  banks             |                |
                    |                |
 Return to TAGAN    |                |
                    |                |
========================================================================
 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74 74

 ==== UPDATE ==== THIS NOTE REPLACES OLD JADE C.N. 74==================


    JADE COMPUTER NOTE NUMBER 74
===========================================


   SUBJECT: Analysis Routines for Tagging System
   =============================================


                                                Author:A.J.Finch
                                                ================


 This note can be found in 'F11LHO.TAGG.S(TAGNOTE)'




 Summary:
 ========

     This  note  desribes  briefly  the  analysis  routines  installed
     recently on F11LHO.TAGG.S and F11LHO.TAGG.L whose purpose  is  to
     produce the output banks 'ACLS', 'TAGG' /0,/1,/2 whose content is
     described  in  Jade  Computer  Note  No.16.The  input  to  these
     routines is the 'ATAG' bank which contains the raw  adc  contents
     from the tagging adcs.They also utilise a new set of  calibration
     constants installed on the  standard  Jade  calibration  file,and
     obtained in the usual way by calling  KALIBR  for  every  run.The
     programs were originally written by H.Wriedt ,A.Finch, and  J.Nye.




Introduction:
=============

      One part of JADE  that has undergone slightly more changes than
      most is the tagging system .  In  1979  and  1980 there was the
      Mark 1 . For  1981 with the arrival of mini - betas  Mark 2 was
      installed suspended on the muon chambers. In order to solve the
      problems of browning lead glass encountered with this location,
      Mark 3  was  installed for  1983  running  onwards .  All these
      systems require different software to analyse them due to their
      differing geometries etc.



The Software:
============

      The minimum information a user needs to use the package
      that  runs these analysis programs is:

       1) Have F11LHO.TAGG.L in his list of load libraries.
       2) CALL KALIBR for every run.
       3) CALL TAGAN once per event.

       4) For 1979/80 data only :
            He must also have the private calibration file
            'F22HOW.PEDESTAL.ALLSP80' attached to fortran
             stream 19.


The routine TAGAN
=================



      TAGAN(IERTAG,NRUN)



     Arguments:
     ==========

           IERTAG - OUTPUT RETURN CODE

           NRUN   - INPUT DUMMY RUN NUMBER TO OVERIDE CONTROL  OF  WHICH
                          ANALYSIS ROUTINE IS  CALLED  FOR  MONTE  CARLO
                          DATA
                         ++++++++++++++++++++++++++++++++++++++++++
                         + IN 99% OF CASES THIS CAN AND SHOULD BE +
                         + SET TO ZERO                            +
                         ++++++++++++++++++++++++++++++++++++++++++

     Description:
     ============

      This  routine  controls the  analysis  routines.   Its first job
      is to  check that the  input event can be  analysed.  Classes of
      events that can not be analysed are :
          a) Pedestal events.
          b) Events with no 'HEAD' bank.
          c) Events with no 'ATAG' bank.
      The  routine must then  decide which of the  three possible sets
      of routines to call (one for each version of the tagging sytem).
      It does this by  using the  information in the  HEAD  bank.  For
      real data it simply uses the run number. For Monte Carlo  events
      it is neccesary to tell the program which Mark of tagging system
      to expect this is done by one of two methods:-
              On encountering  Monte Carlo  data, the routine looks at
              the  input argument  'nrun' . If this number is not zero
              it takes,  and uses,  it as the  run number,  so -

   Use of NRUN:
   ============
               NRUN                ASSUMED SIMULATION
               ====                ==================

               <6000                Mark 1
          6000>    <12947           Mark 2
               >12948               Mark 3

         If nrun is set to zero there is a second line of attack which
         is to look at the 2nd half word of the bank 'ATAG'. The value
         of this determines which simulation  was  done  according  to
         following scheme.

                   Value of word             Simulation
                   =============             ==========

                         0                    Mark 1    (or real data !)
                         1                    Mark 2
                         2                    Mark 3

        (Provided this scheme has been adopted in the simulation then
          NRUN can be set to zero)

         N.B. Tagan issues a messsage the first time it is called saying
              what it thinks it is analysing, and again if it encounters
              a change from one tagger type to another.





     Meaning of return code 'IERTAG':
     ================================

                   Value of IERTAG             Meaning
                   ===============             =======

                         0             No Problems - and clusters found.

                         1            No Problems - but  no  clusters
                                      found ('ATAG',and 'HEAD' exist)

                         2             Analysis was completed but
                                        at least one of the output
                                       banks could not be created due
                                       to lack of space.

                         10           No 'ATAG' banks - no analysis done

                         11           No 'HEAD' bank - no analysis done




Stucture of the main anlysis routines:
======================================

      The routines that TAGAN calls are-

      ANATAG  for 1979/80 data
      TAGGTP  for 1981 onwards data (with a flag to tell whether data
                                     is from 1981/2 or 1983 onwards)

      The structure of TAGGTP is briefly described at the end of  this
      note for anyone who is interested, for more detail refer to  the
      commented version on F11LHO.TAGG.S.




Using analysis routines for other purposes:
===========================================

 Users may wish to use a small sample of the  routines for their own
 purposes. E.g. for fast selection routines. It is possible for 1981
 data onwards to use the following sheme:


          DATA THRESH/6000.0/

          CALL TAGSET(IMARK) - Force analysis to assume  IMARK  tagger,
                               IMARK = 2 or 3.  -  optional  for  monte
                               carlo data if simulation didn't set  flag
                               in 'ATAG

          CALL TAGINT(&100)  - Initialisation - to be called once  per
                              event ; RETURN 1 if can't work  out  which
                              tagger this is ( due to no head bank).

          CALL TAGADC(IWRITE,&100)    - Gets the ATAG data,if  IWRITE=
                                      1 writes out some debugging info
                                      Applies  nominal calibration to
                                      convert channel number to MeV.

          CALL TAGPED   - pedestal fixing - optional
                                       (no disaster if not done)

           CALL TAGKAL(IWRITE)    -   Calibration - optional
                                       (no disaster if not done)

           CALL TAGSUM(-1,SUMM,&100) - work out sum of -z and + z
           CALL TAGSUM(+1,SUMP,&100) - return 1 if sum has 'impossible'
                                                  value
C
C SUMM,SUMP,THRESH are in MeV
C

           IF((SUMM.GT.THRESH).OR.(SUMP.GT.THRESH))....
 100       CONTINUE


 | For more detailed information about these and other routines
 | in this package see 'F11LHO.TAGG.S(#TAGDOC)'

 ____________________________________________________________________


 For completeness there now follows a brief description of
 the procedure adopted in the routine 'TAGGTP' for analysing
 all data from 1981 onwards.


---------------------------------------------------------------------


=======================================================================
 PROCESS            | ROUTINE NAME   |   NOTES
                    | ( if not done  |
                    |  in TAGGTP)    |
========================================================================
                    |                |
 Initialisation     | TAGINT         |
                    |                |
                    |                |
                    |                |
                    |                |
 Read data in 'ATAG'| TAGADC         |1) An overall calibration that
                    |                |   converts adc channel number to
                    |                |   MeV is applied.
                    |                |2) Software addresses are used
                    |                |   from here on.
                    |                |
 Subtract pedestals | TAGPED         |These are caused by fluctuating
                    |                |pedestals due to 50HZ AC pickup
                    |                | on signal cables.It is only
                    |                | treated in those events where
                    |                | it exceeds the cut off at 20
                    |                | channels applied by the
                    |                | Le Croy ADC controler.Ammount
                    |                | to be subtracted is estimated on
                    |                | an event by event basis.
                    |                |
 Apply calibration  | TAGKAL          | Factors obtained from Kalibr.
  factors.          |                |
                    |                |
  Work out the sum  |TAGSUM(JPART,SUM)| Works out SUM for JPART end
 of energy in -Z and|                | (JPART = +/- 1)
+Z tagger.          |                |
                    |                |
                    |                |
LOOP1 <This section once for -Z then once for +Z>>>>>>>>>>>>>>>
                    |                |
  Sort adcs into    | TAGSR1          |
 order of decreasing|                |
  energy contents.  |                |
                    |                |
  Use sorted list to| TAGCLS         |
  find clusters of  |                |
  deposited energy. |                |
    Store results in|                |
   cluster map.     |                |
                    |                |
=======================================================================
 PROCESS            | ROUTINE NAME   |   NOTES
                    | ( if not done  |
                    |  in TAGGTP)    |
========================================================================
                    |                |
 LOOP2 <start loop over all clusters (this end) >>>
                    |                |
 Fill the cluster   |                |
 map 'ACLS' + save  |                |
 pointers for TAGG1 |                |
                    |                |
                    |                |
 Find position of   | TAGPOS          | This is the main routine where
   centre of each   |                | geometrical differences effect
    cluster,in face |                | the software.
  of blocks.        |                |   The procedure adopted compares
                    |                |   the ratio of energies in the
                    |                |   hit block and its neighbours
                    |                |   to known distributions of
                    |                |   energy within e/m showers
                    |                |   to estimate how far to move
                    |                |   the centre of the shower from
                    |                |   the centre of the block with
                    |                |   the largest ammount of energy,
                    |                |   towards its neighbours with the
                    |                |   next largest ammounts of energy
                    |                |   N.B. A large fraction of hits
                    |                |   lose some significant fraction
                    |                |   of their energy out of the
                    |                |  inner or outer edges,which makes
                    |                |   position determination
                    |                |   difficult.
   Save information |                |   (Hardware addresses are used
   on individual    |                |   in the output)
   clusters to put  |                |
   in TAGG/2        |                |
                    |                |
 <end of LOOP2 over each cluster>    |
                    |                |
 repeat LOOP1 for +Z|                |
                    |                |
Calculate angle     |                |
 between clusters   |                |
 found above.Flag   |                |
 colinear pairs of  |                |
  clusters in TAGG2 |                |
                    |                |
 Create output      | TAGSTO         |
  banks             |                |
                    |                |
 Return to TAGAN    |                |
                    |                |
========================================================================

C   01/11/84            MEMBER NAME  PBGSUM   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PBGSUM(INDEX)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  SUM UP LG ENERGIES
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON /CWORK1/ R,FI,XA,COSFI,X1,Y1,YA,SINFI,X2,Y2,ZET,X3,Y3,X4,Y400001800
     +               ,IMW(200)
C
C-----------------  C O D E  -------------------------------------------
C
C SUM UP ALL LEAD GLASS COLUMN AND ROW ARRAYS, INCLUDING END CAPS
C--
C-- IMW 1-84   RFI- ROWS
C-- IMW 85 - 108  CROSS SUMS IN ENDCAPS     DIFFERENT FOR ZX OR ZY VIEWS
C-- IMW 109 - 172   CROSS SUMS IN BARREL      --------- SAME ---------
C--
      DO 1 NI=1,172
1     IMW(NI)=-1
      IF(INDEX.EQ.1.OR.INDEX.EQ.4.OR.INDEX.EQ.8.OR.INDEX.GT.11) RETURN
      IPJ = IDATA(IBLN('ALGN'))
      IF(IPJ.LE.0) RETURN
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) RETURN
      IPJ=2*IPJ+7
      LIM2=IPJ+2*NWO - 7
      DO 2 NI=IPJ,LIM2,2
      NO=HDATA(NI)
      IF(NO.GT.2687) GO TO 3
      NROW=NO/32+1
      IMW(NROW)=IMW(NROW)+HDATA(NI+1)
      NPHI = NO/32
      NROW = NO - NPHI*32 + 109
      NQ = NO/672
      IF(INDEX.LT.8.AND.(NQ.EQ.1.OR.NQ.EQ.2)) NROW = NROW + 32
      IF(INDEX.GT.7.AND.NQ.GT.1) NROW = NROW + 32
      IF(IMW(NROW).EQ.-1) IMW(NROW) = 0
      IMW(NROW) = IMW(NROW) + HDATA(NI+1)
      GO TO 2
 3    IF(INDEX.LT.5) RETURN
      CALL XYBLK(NO,XEB,YEB,DXEB,DYEB)
      IF((NO-2687).LE.96) XEB=-XEB+898.50
      IF((NO-2687).GT.96) XEB=-XEB+6013.02
      YEB=YEB-900.
      IF(INDEX.LE.7) IECIND=(XEB-0.5*DXEB+7.*DXEB)/DXEB
      IF(INDEX.GT.7) IECIND=(YEB+0.5*DYEB+7.*DYEB)/DYEB
      IF(IECIND.LT.1) IECIND=1
      IF(IECIND.GT.12) IECIND=12
      IF((NO-2687).GT.96) IECIND=IECIND+12
      IMW(84+IECIND)=IMW(84+IECIND)+HDATA(NI+1)
    2 CONTINUE
      RETURN
      END

C   25/11/80 011262001  MEMBER NAME  PREDIT   (JADEGS)      FORTRAN
      SUBROUTINE PREDIT
      IMPLICIT INTEGER*2 (H)
C
C     MAIN SUBROUTINE FOR PATREC IN JET CHAMBERS
C     PETER STEFFEN 15/ 9/79
C *****  GRAPHICS EDITING VERSION ** LAST CHANGE 21.02.80   J.OLSSON ***
C *****  CHANGED TO NEW FORMATS FOR HITLABEL ARRAY AND MIDOUT        ***
#include "cworkpr.for"
#include "cgraph.for"
#include "cpatlm.for"
      IF(ACMD.EQ.0.) GO TO 92
      CALL PATRC1(0)
      CALL TRMOUT(80,' EDIT ENTERED AFTER BACKTRACE, NO CALL TO FIT AND
     +ADMINISTRATION PROGRAM DONE^')
      CALL TRMOUT(80,' TO STOP AUTOMATIC DELETION OF LOW ENERGY TRACKS,
     +USE COMMAND NR 33^')
      GO TO 93
92    CALL PATREC(0)
93    NTRLM = 0
      ACMD = 0.
      CALL CREDIT
      RETURN
      END

C   22/04/80 403232136  MEMBER NAME  MUTIM    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUTIM(SECS,*)
C-----------------------------------------------------------------------
C
C        NOVEMBER 1979  HARRISON B. PROSPER
C
C THIS ROUTINE FINDS HOW MUCH TIME IS LEFT FOR PROCESSING.IT CAN BE
C USED TO FORCE AN EXIT ( FROM A LOOP FOR EXAMPLE )
C SECS IS A TIME-OUT LIMIT AFTER WHICH A RETURN 1 WILL OCCUR
C
C------------------  C O D E  ------------------------------------------
C
C                        NTIME(DUM) GIVES THE TIME LEFT IN 1/100 SECS
C
      BIGBEN = NTIME(DUM)
      BIGBEN = BIGBEN/100
C
      IF( BIGBEN .LE. (SECS + 0.001) ) RETURN1
      RETURN
      END

C   19/03/79 C9083001   MEMBER NAME  LGDECD   (JADENS)      FORTRAN
      SUBROUTINE LGDECD
      IMPLICIT INTEGER*2 (H)
C---
C---     ROUTINE TO CREATE CALIBRATED LEAD GLASS ENERGY BANK.
C---
C---                                   TUESDAY, MARCH 20, 1979
C---                                   L.H. 0'NEILL
C---
#include "cgraph.for"
#include "cdata.for"
      COMMON/CALIBR/JPOINT(16)
      DIMENSION HCALIB(2)
      EQUIVALENCE (HCALIB(1),JPOINT(1))
      IF(IDATA(IBLN('ALGN')).NE.0) RETURN
      IPHALF=2*JPOINT(1)
      IPJ0=IDATA(IBLN('ALGL'))
      IF(IPJ0.LT.1) RETURN
      NW=IDATA(IPJ0)
      IF(NW.LT.4) RETURN
      CALL CLOC(IHEAD,'HEAD',0)
      IF(HDATA(2*IHEAD+10).EQ.0) GO TO 10
      CALL CCRE(IPJ1,'ALGN',1,NW,IER)
      IF(IER.NE.0) GO TO 4
      CALL BSAW(1,'ALGN')
      DO 1 I=1,3
      IDATA(IPJ1+I)=IDATA(IPJ0+I)
    1 CONTINUE
      IPH0=2*IPJ0
      IPH1=2*IPJ1
C---
C---     SET SECOND HALF-WORD OF BANK DESCRIPTOR TO ONE TO INDICATE
C---     THAT CALIBRATION HAS BEEN DONE.
C---
      HDATA(IPH1+2)=1
      LOC0=IPH0+5
      LOC1=IPH1+5
      LIM=IPH0+2*NW
    3 CONTINUE
      LOC0=LOC0+2
      LOC1=LOC1+2
      IF(LOC0.GE.LIM) GO TO 2
      IADD=HDATA(LOC0)
      HDATA(LOC1)=IADD
      IADD=IPHALF+IADD*2
      IPEDL=HCALIB(IADD+1)
      IGAIN=HCALIB(IADD+2)
      ICHAN=HDATA(LOC0+1)
      ICHAN=SHFTL(ICHAN,4)
C---
C---     THE ADDITION OF 8192 (2*13) BELOW CAUSES THE SUBSEQUENT RIGHT
C---     SHIFT BY 14 BITS TO RESULT IN A ROUND OFF RATHER THAN A TRUN-
C---     CATION.
C---
      ICHAN=IGAIN*(ICHAN-IPEDL)+8192
      MEV  =SHFTR(ICHAN,14)
      HDATA(LOC1+1)=MEV
      GO TO 3
    2 CONTINUE
      RETURN
   10 CONTINUE
      CALL CCRE(IPJ1,'ALGN',1,NW,IER)
      IF(IER.NE.0) GO TO 4
      CALL BSAW(1,'ALGN')
      CALL BSTR(IPJ1,IDATA(IPJ0),NW)
      RETURN
    4 CONTINUE
      IF(IER.GT.1) WRITE(JUSCRN,100) IER
  100 FORMAT(' ERROR NUMBER',I4,' IN ATTEMPT TO CREATE ALGN.')
      RETURN
      END

C   15/01/88 807222029  MEMBER NAME  TPVCI1   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPVCI1( ANALYS )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      22/07/88:  Get instr. about VTXC anal
C
C
C     Routine to provide yes/no answer about need for vertex chamber
C     analysis.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     ANALYS    Out      L*4      TRUE if analysis step is to be done
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  VTXC*8, CANALY*20

      LOGICAL  ANALYS, ANAL, FIRST

      SAVE  FIRST, ANAL

      DATA  FIRST  / .TRUE. /
      DATA  VTXC   / 'VTXC' /
      DATA  CANALY / 'ANALYSE'   /

C------------------  C O D E  ------------------------------------------

C                            If not first call, ANAL already SAVEd.

      IF( FIRST ) THEN

C                            Get user option relating to VTXC analysis
C                            that is, ANALYSE.

        CALL TPUOPT( VTXC, CANALY, ANAL )

        FIRST = .FALSE.

      ENDIF

      IF( ANAL ) THEN

        ANALYS = .TRUE.


      ELSE

        ANALYS = .FALSE.

      ENDIF

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

      PROGRAM FEHLTEST
      CALL FEHLTX( 1,'ERROR CREATING ZEHD-BANK')
      CALL FEHLTX( 2,'NO PATR / LGCL BANK ')
      CALL FEHLTX( 3, 'NUMBER OF CHARGED TRACKS <= 0 IN PATR')
      CALL FEHLTX( 4, 'ERROR WHILE CREATING ZIM1-BANK')
      CALL FEHLTX( 5, 'NO TRACKS IN ZE4V-BANK')
      CALL FEHLTX( 11,'NUMBER OF HITS IN R-PHI LT CUT')
      CALL FEHLTX( 12,'NUMBER OF HITS IN R-Z LT CUT')
      CALL FEHLTX( 13,'Z- CUT NOT PASSED')
      CALL FEHLTX( 14,'RMIN CUT NOT PASSED')
      CALL FEHLTX( 15,'MOMENTUM CUT NOT PASSED')
      CALL FEHLTX( 17,'NO CONNECTED LG-CLUSTER')
      CALL FEHLTX( 18,'JCLUS > 0 BUT NO LGCL-BANK')
      CALL FEHLTX( 19,'CORR. ECL < 0 (NO CL. IN LGANAL)')
      CALL FEHLTX( 19,'BLA')
      CALL FEHLER( 1, &1 )
 100  CALL FEHLER( 11, &11 )
 200  CALL FEHLER( 19, &19 )
      PRINT *,'ALLES OK'
      STOP
 1    PRINT *,'FEHLER=1'
      GOTO 100
 11   PRINT *,'FEHLER=11'
      GOTO 200
 19   PRINT *,'FEHLER=19'
      STOP
      END

C   14/12/81 705141358  MEMBER NAME  LGECORY  (S)           FORTRAN
      SUBROUTINE LGECOR(BDATA,DEP,IFLAG)
C
      IMPLICIT INTEGER*2 (H)
C
C  THIS PROGRAM CALCULATE THE INCIDENT ENERGY
C  FROM THE MEASURED ENERGY.
C
C      05/3/1979     HIROSHI TAKEDA
C      LAST MODIFICATION   22/09/79
C      LAST MODIFICATION   04/10/79 Y.WATANABE
C      LAST MODIFICATION   09/02/80 H.TAKEDA(TYPED BY Y.WATANABE)
C         IMPLEMENTED ON 21/2/80 18:00
C      LAST MODIFICATION   08/09/80 Y.W. LGPOSC FOR BARREL.
C      LAST MODIFICATION   14/12/81 H.T. ENGLOS FOR END-CAP.
C      LAST MODIFICATION   14/12/81 H.T. THICKNESS FOR BARREL MATERIALS
C      LAST MODIFICATION   06/04/82 S.ODAKA
C                          BRLGN FOR BARREL INSTEAD OF LGPOSC
C  BDATA : DATA BUFFER OF THE FOLLOWING PARAMETERS.
C
C    IDATA(1)   0   BARREL
C                    -1   BOTTOM END CAP
C                    +1   TOP    END CAP
C    BDATA(2)   CLUSTER ENERGY IN GEV
C    BDATA(3)   SIGMA(ENERGY)
C    BDATA(4)   WEIGHTED AVERAGE PHI        BARREL
C                                       X        END CAP
C    BDATA(5)   WEIGHTED AVERAGE  Z         BARREL
C                                       Y        END CAP
C    BDATA(6)   SIGMA PHI (WEIGHTED)        BARREL
C                            X                   END CAP
C    BDATA(7)   SIGMA  Z (WEIGHTED)         BARREL
C                            Y                   END CAP
C    IDATA(8)   NUMBER OF CORRESPONDING INNER TRACKS
C    BDATA(9--11) DIRECTION COSIGNS CORRECTED FOR SHOWER DEPTH
C
C  DEP  :  SHOWER DEPTH IN MM
C  IFLAG   0    NORMAL RETURN
C          1    ITERATION OVERFLOW
C          2    HIT OUTSIDE END-CAP
C          3    TOO MUCH ENERGY LOSS
C          4    OTHER ILLEGAL RETURNS
C
      DIMENSION BDATA(2)
      COMMON /CLLLLL/  IPRO
      COMMON /CLGDMS/  X0,RADIUS(6),RADSX0(6),
     1  THX0(4),ZEND(2),ZENDX0(2),
     2  ZWID(2),ZGAP(2),PHWID(2),
     3  ZECAP(4),ZECAPX(4),THECPX(2),
     4  ECXLST(24),ECYLST(24)
C
C  THECPX(1)   THICKNESS OF END CAP COUNTER IN MM
C        (2)                                   X0
C  RADIUS(1,2) DISTANCE TO THE COIL SURFACE (INNER AND OUTER)
C        (3,4) DISTANCE TO THE LEAD GLASS SURFACE (TYPE A)
C  ZEND(1)     END POINT OF BARREL PART COUNTERS  (-)
C      (2)                                        (+)
C  ZGAP(1)     COUNTER GAP OF BARREL PART IN MM
C  THX0(1)     MAGNET COIL THICKNESS IN X0
C              X0 = 8.9 CM FOR ALUMINUM
C
#include "cdata.for"
      COMMON /TODAY/ HDATE(6)
C
      EQUIVALENCE (PHI,XCO),(ZCO,YCO),(IBE,BE)
      DATA ETHRE/0.01/,PAI2/6.283185/
C
C  INITIAL SET UP
C
      BE   =BDATA(1)
      ENERGY=BDATA(2)
C CHANGE 30.4.87 TO AVOID SYSTEMATIC EFFECTS AT LOW ENERGIES
      ETHRE = .05*ENERGY
      IF(ETHRE.GT..01) ETHRE = .01
      COSX  =BDATA(9)
      COSY  =BDATA(10)
      COSZ  =BDATA(11)
      PHI   =BDATA(4)
      ZCO   =BDATA(5)
C     WRITE(6,900) BE,ENERGY,COSX,COSY,COSZ,PHI,ZCO,DEP
C900  FORMAT(10F10.3)
      IFLAG=0
C
      IF(IBE.EQ.0) GO TO 1
CCCCCCCCCCCCCCCCCCCCC
C
C  END CAP COUNTERS
C
CCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF THE LIGHT GUIDE
C
      R=(THECPX(1)-DEP)/COSZ
      R=ABS(R)
      XX=XCO+R*COSX
      YY=YCO+R*COSY
C
      THETA=ARCOS(COSZ)
      THETA=ABS(THETA)*57.2958
      IF(IBE.EQ.-1) THETA=180.0-THETA
C     WRITE(6,900) R,XX,YY,THETA
C
C   ITERATION FOR INCIDENT ENERGY
C
      ETEMP1=ENERGY
      ITERA=1
      JTERA=1
C
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
      X=XX/X0
      Y=YY/X0
      CALL LGNMEC(X,Y,ID)
C
C   CHECK IF HIT IS INSIDE THE COUNTER
C
C
      IF(ID.GT.0) GO TO 60
      X=XCO/X0
      Y=YCO/X0
      CALL LGNMEC(X,Y,ID)
C
      IF(ID.GT.0) GO TO 60
      IFLAG=2
      RETURN
C
   60 MB=(ID-1)/24 +1
      ID=MOD(ID-1,24)+1
      U=ECXLST(ID)
      V=ECYLST(ID)
      GO TO (4,5,6,7),MB
    4 X=U
      Y=V
      GO TO 8
    5 X=-V
      Y=U
      GO TO 8
    6 X=-U
      Y=-V
      GO TO 8
    7 X=V
      Y=-U
    8 R=0.1*SQRT((X-XX)*(X-XX)+(Y-YY)*(Y-YY))
      DDR=SQRT(XX*XX+YY*YY)-SQRT(X*X+Y*Y)
      IF(ABS(R).GT.1.E-10) DDR=0.1*DDR/R
C
C     ENERGY LOSS
C
      THICK=1.17*8.9/ABS(COSZ)
   10 CALL ENGLOS(ETEMP1,THICK,DELTAE,&80)
      ETEMP3=ETEMP1-DELTAE
      IF(ETEMP3.GT.0.) GO TO 32
      ETEMP1=ETEMP1+ETHRE
      GO TO 10
C
C     POS DEP
C
   32 CALL POSEND(ETEMP3,R,DDR,FAC,&80)
C
      ETEMP2=ENERGY/FAC+DELTAE
      EDIF=ABS(ETEMP2-ETEMP1)
      IF(EDIF.LE.ETHRE) GO TO 9
      ITERA=ITERA+1
      IF(ITERA.GE.10) GO TO 40
      ETEMP1=ETEMP2
      GO TO 10
C
   40 ITERA=1
      ETEMP1=0.5*(ETEMP1+ETEMP2)
      JTERA=JTERA+1
      IF(JTERA.LT.5) GO TO 10
      IFLAG=1
      RETURN
C
    9 BDATA(2)=ETEMP2
       IF(IPRO.GT.0) WRITE(6,940) ITERA,JTERA,ETEMP1,FAC,X,Y,R,DDR
 940   FORMAT(' ITER JTER ETEMP1 FAC X Y R DDR ',2I4,6E12.4)
      RETURN
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  BARREL PART COUNTERS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF LIGHT GUIDE
C
    1 R=RADIUS(3)+DEP
      COSPHI=COS(PHI)
      SINPHI=SIN(PHI)
C       X Y POSITION AT THE SHOWER MEDIAN.
      X=R*COSPHI
      Y=R*SINPHI
C
C     DISTANCE FROM THE SHOWER MAX POINT TO THE EXTRAPOLATED POINT
C           AT THE END FACE OF LEAD GLASS
      A=COSX*COSX+COSY*COSY
      B=X*COSX+Y*COSY
      C=X*X+Y*Y-RADIUS(4)*RADIUS(4)
      RDIF=(SQRT(B*B-A*C)-B)/A
C      X Y Z POSITION AT THE END FACE OF LG
      X=X+RDIF*COSX
      Y=Y+RDIF*COSY
CCC   Z=ZCO+RDIF*COSZ
C     WRITE(6,900) COSPHI,SINPHI,X,Y,Z,A,B,C,RDIF
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
CCC   Z=Z-ZEND(1)+0.5*ZGAP(1)
CCC   PERIOD=ZWID(1)+ZGAP(1)
CCC   IZ=Z/PERIOD+1
CCC   IF(IZ.LE.1) IZ=2
CCC   IF(IZ.GE.32) IZ=31
CCC   Z=Z-PERIOD*(IZ-0.5)
C
      THETA=ATAN2(Y,X)
      IF(THETA.LT.0.) THETA=THETA+PAI2
      STEP=PAI2/84.
      ITH=THETA/STEP
CCC   THETA=(THETA-(ITH+0.5)*STEP)*RADIUS(4)
C
CCC   R=0.1*SQRT(Z*Z+THETA*THETA)
CCCCCCC    CCC ARE NEEDED ONLY FOR POSITION CORRECTION.....
C
C       INCIDENT ANGLE
      ANGNOR=(ITH+0.5)*STEP
      COSNOR=COS(ANGNOR)
      SINNOR=SIN(ANGNOR)
      THETA=COSNOR*COSX+SINNOR*COSY
C     ABSORBER THICKNESS TRAVERSED BY THE PARTICLE.
C     D=7.88/ABS(THETA)    <--- OLD VERSION
      D=0.97*8.9/ABS(THETA)
C
C  FOR MC EVENTS, GET CORRECT THICKNESS FOR 1984-86
C
      IPHEAD = IDATA(IBLN('HEAD'))
      IPHEA2 = 2*IPHEAD
      HRUN = HDATA(IPHEA2+10)
C
      IF(HRUN.LT.100.AND.HDATE(6).GT.1983) D=1.04*8.9/ABS(THETA)
      THETA=ARCOS(THETA)*57.2958
      IF(IPRO.NE.0) WRITE(6,910) ITH,ANGNOR,COSNOR,SINNOR,THETA,D
 910  FORMAT(' ITH ',I4,' ANGN COSN SINN TH D ',5E12.4)
      IF(D.LT.50.) GO TO 70
      IFLAG=3
      RETURN
C
C     ITERATION
70    ITERA=1
      EINC=ENERGY
C
C        ENERGY LOSS IN THE COIL
C
21    CONTINUE
C
      IF(IPRO.NE.0) WRITE(6,2361) EINC,D,ETHRE
2361  FORMAT(' FOR ENGLOS  EINC D ETHRE ',3E12.4)
C
      CALL ENGLOS(EINC,D,DELTAE,&80)
      EEXP=EINC-DELTAE
C
      IF(IPRO.NE.0) WRITE(6,2362) EEXP,DELTAE
2362  FORMAT(' AFT ENGLOS  EEXP DELTAE ',3E12.4)
C
      IF(EEXP.GT.0.) GO TO 22
      EINC=EINC+ETHRE
      GO TO 21
C
C       ANGLE DEPENDENCE
C
22    CONTINUE
C
      IF(IPRO.NE.0) WRITE(6,2363) EEXP,THETA
2363  FORMAT(' FOR ANGBAR  EEXP THETA ',3E12.4)
C
      CALL ANGBAR(EEXP,THETA,AFAC,&80)
      EEXP= EEXP*AFAC
C
      IF(IPRO.NE.0) WRITE(6,2364) EEXP,AFAC
2364  FORMAT(' AFT ANGBAR  EEXP AFAC ',3E12.4)
C
C
C       FINE POSITION DEPENDENCE
C
      PFAC= BRLGN( EINC, BDATA(11), BDATA(4) )
      EEXP= EEXP*PFAC
C
      IF(IPRO.NE.0) WRITE(6,2365) EEXP,PFAC,BDATA(11),BDATA(4)
2365  FORMAT(' AFT BRLGN  EEXP PFAC BDATA 11 4 ',4E12.4)
C
C
      EDIF= ENERGY -EEXP
C
      IF(IPRO.NE.0) WRITE(6,2366) ITERA,ENERGY,EEXP,EDIF,ETHRE
2366  FORMAT(' ITER ENERGY EEXP EDIF ETHRE ',I3,4E12.4)
C
      IF(ABS(EDIF).LE.ETHRE) GO TO 20
      ITERA=ITERA+1
      IF(ITERA.GT.10) GO TO 50
      EINC=EINC+EDIF
C
      IF(IPRO.NE.0) WRITE(6,2367) ITERA,EINC
2367  FORMAT(' ITER EINC ',I3,4E12.4)
C
      GO TO 21
C
   50 CONTINUE
      IFLAG=1
      RETURN
C
   20 BDATA(2)=EINC
CC      WRITE(6,10100) ENERGY,BDATA(4),BDATA(11),D,
CC     &  EINC,DELTAE,AFAC,PFAC,ITERA
CC10100 FORMAT(' <LGECOR> E',F8.3,', PHI',F6.3,', COSZ',F6.3,', D',F8.3,
CC     &  ', EINC',F8.3,', ELOSS',F6.3,', AFAC',F6.3,', PFAC',F6.3,
CC     &  ', ITERA',I3)
      RETURN
C
C     ILLEGAL RETURN
C
   80 BDATA(2)=ENERGY
      RETURN
C************************************
      ENTRY LGECR0(NVR)
C
C  VERSION NUMBER (DATE)   82  6 13
C
      DATA IVR/820613/
      NVR=IVR
      RETURN
      END

C   20/12/85 512202036  MEMBER NAME  LGCLST   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE LGCLST
C-----------------------------------------------------------------------
C
C
C    DISPLAY TABLE OF RESULTS FOR CLUSTER ANALYSIS BANK  "LGCL"
C        IPO:          START ADRESS OF BANK CONTENT
C        NBK:          BOS NUMBER OF BANK
C        INDEX:        VIEW INDEX ACCORDING TO DISPLAY PROGRAM
C            J.OLSSON,  18.07.79           LAST CHANGE 01.12.79
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      LOGICAL DSPDTM
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
     $,PMOM,PZ,PTRANS,RMS,NHTF,RAD,RAD1,THE,PHI,XXX,YYY,SSS,IPP,IHO,IVE
     $,DUMM,NTRRES,IW52
      COMMON /CJTRIG/ PI,TWOPI
C
      DATA INAME /'LGCL'/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      IPP = IPO
      ICNT = 0
      IFL = 0
C
C LSTCMD=111,112: NEXT EVENT, WRIT EVENT   SPECIAL FOR AUTO DISPLAY
C
      IF(DSPDTL(14).AND.ACMD.NE.0..AND.LSTCMD.NE.111.AND.LSTCMD.NE.112)
     $ IFL = 1
C---
      XXX = XMIN
      YYY = YMIN+.76*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,2)
C     IF(DSPDTL(14).AND.ACMD.NE.0..AND.LASTVW.EQ.13) GO TO 2277
      IF(IFL.NE.0.AND.LASTVW.EQ.13) GO TO 2277
C
C                            IF OPT 46 IS ON AND OPT 13 IS OFF
C                            FOR PUBLICATION PICTURES WITHOUT CAPTIONS,
C                            SUPPRESS THE RESULTS HEADER.
C
      IF( DSPDTM(16)  .AND.  .NOT. DSPDTL(13) ) GO TO 2277
C
      CALL CORE(HWORK,80)
      WRITE(cHWORK,220) INAME,NBK,NCLST ! PMF 17/11/99: UNIT=10 changed to cHWORK
220   FORMAT('BANK ',A4,I2,' NR OF CLUSTERS',I3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
C
2277  IF( .NOT. DSPDTL(13) ) GO TO 21
      YYY = YYY - 3.*SSS
      IGMX = 0
200   ICNT = ICNT + 1
      IF(ICNT.GT.NCLST.OR.ICNT.GT.26) GO TO 21
      IPP = IPP + NWPCL
      IF(IDATA(IPP+8).EQ.0) IGMX = IGMX + 1
      CALL GMTEXT(IPP,NTRRES,ICNT,IGMX)
      GO TO 200
21    CONTINUE
      XXX = XMIN+.33*(XMAX-XMIN)
      YYY = YMIN+.01*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,1)
      IF(IFL.NE.0.AND.LASTVW.EQ.13) GO TO 2278
C     IF(DSPDTL(14).AND.ACMD.NE.0..AND.LASTVW.EQ.13) GO TO 2278
C
C                            IF OPT 46 IS ON AND OPT 13 IS OFF
C                            FOR PUBLICATION PICTURES WITHOUT CAPTIONS,
C                            SUPPRESS THE RESULTS HEADER.
C
      IF( DSPDTM(16)  .AND.  .NOT. DSPDTL(13) ) RETURN
C
      CALL CORE(HWORK,80)
      IPLGCL=IDATA(IBLN('LGCL'))
      WRITE(cHWORK,865) 
     +     ADATA(IPLGCL+11),ADATA(IPLGCL+16),IDATA(IPLGCL+15) ! PMF 17/11/99: UNIT=10 changed to cHWORK
865   FORMAT(' TOTAL CLUSTER ENERGY ',F7.3,'  PHOTON ENERGY ',F7.3,' NR
     $OF PHOTONS ',I3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,70,0.)
2278  CONTINUE
      RETURN
      END

C   12/04/84 404121125  MEMBER NAME  RZDET    (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RZDET
C-----------------------------------------------------------------------
C
C   AUTHOR: S. CARTWRIGHT 11/04/84 :  RZ CHAMBERS, ROLLED OUT VIEW
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CZGEO  / RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,
     +                  ZCHSS,ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
C
C------------------- C O D E -------------------------------------------
C
C                            DRAW CHAMBER BOUNDARIES
C
      ADY = 1500.
      X1  =  0.
      X2  =  6. * DLZPHI
      X3  = 12. * DLZPHI
      X4  = 18. * DLZPHI
      X5  = 24. * DLZPHI
      Y1  = ADY
      Y2  = ADY + 16.*DLZZ
      CALL RECTAN(X1+ZCHDLL, Y1, X2-ZCHDL,  Y2, 0)
      CALL RECTAN(X2+ZCHDL,  Y1, X3-ZCHDLL, Y2, 0)
      CALL RECTAN(X3+ZCHDLL, Y1, X4-ZCHDL,  Y2, 0)
      CALL RECTAN(X4+ZCHDL,  Y1, X5-ZCHDLL, Y2, 0)
C
C                            DRAW CELL WALLS
C
      Y0 = Y1 - DLZZ
      DO  10  I  = 1,17
        Y0 = Y0 + DLZZ
        CALL DRAMOV(X1+ZCHDLL, Y0, X2-ZCHDL,  Y0, 0)
        CALL DRAMOV(X2+ZCHDL,  Y0, X3-ZCHDLL, Y0, 0)
        CALL DRAMOV(X3+ZCHDLL, Y0, X4-ZCHDL,  Y0, 0)
        CALL DRAMOV(X4+ZCHDL,  Y0, X5-ZCHDLL, Y0, 0)
 10   CONTINUE
C
C                            DRAW PHI-SECTOR BOUNDARIES
C
      X0 = - DLZPHI
      DO  20  I  = 1,25
        X0 = X0 + DLZPHI
        IF(MOD(I,6) .EQ. 1) GO TO 20
        CALL DRAMOV(X0,Y1,X0,Y2,14)
 20   CONTINUE
C
C                            ADD AXIS LABELLING
C
      SH3 = 0.4*DLZZ
      Y0  = ADY - 0.6*DLZPHI
      DO  30  I = 1,3
        LABT = 103+I
        X0   = (I-1) * (0.5*X5 - 0.4*DLZPHI)
        CALL RUTEXT(LABT,X0,Y0,SH3)
 30   CONTINUE
C
      X0  = -0.8*DLZPHI
      DO  40  I = 1,3
        LABT = 100+I
        Y0   = ADY + (I-1)*7.8*DLZZ
        CALL RUTEXT(LABT,X0,Y0,SH3)
 40   CONTINUE
C
      RETURN
      END

C   20/08/87 806081033  MEMBER NAME  ZE4VEA   (S)           FORTRAN77
      SUBROUTINE ZE4VEA
C-----------------------------------------------------------
C  VERSION OF 20/08/87     LAST MOD 08/06/88    E ELSEN
C  PERFORM ELECTRON ANALYSIS FOR ALL TRACKS SPECIFIED
C  IN ZE4V
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      INTEGER LADD(-1:2)
      LOGICAL FIRST /.TRUE./
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IPZE4V = IBLN('ZE4V')
      ENDIF
C
      NPZE4V = IW(IPZE4V)
      IF( NPZE4V.GT.0 ) THEN
        NT = HW(NPZE4V*2 + 6)
        LT = HW(NPZE4V*2 + 5)
        LADD(-1) = LT
        LADD(0) = HW(NPZE4V*2 + 9) + LT
        LADD(1) = HW(NPZE4V*2 + 7) + LT
        LADD(2) = HW(NPZE4V*2 +11) + LT
        NREL = HW(NPZE4V*2+1)
C
        DO 10 J=1,NT
          ITPF = HW((NPZE4V+NREL)*2+18)
          IF( ITPF.EQ.1 ) THEN
            CALL ZE4VET( NPZE4V, NREL+NPZE4V, JCAND, ESHM )
            NPZE4V = IW(IPZE4V)
            IF( JCAND .EQ. 0 ) THEN
C                                      CANDIDATE
              RW(NPZE4V+NREL+LT+3) = ESHM
              HW((NPZE4V+NREL)*2+8) = HW((NPZE4V+NREL)*2+8)/100*100 + 2
            ELSE
C                                      NO CANDIDATE
              RW(NPZE4V+NREL+LT+3) = 0.
*** PMF 09/12/99              IF( MOD( HW((NPZE4V+NREL)*2+8), 100 ) .EQ. 2 )
* Shuffle first MOD argument into an integer*4 variable.
              ihelp= HW((NPZE4V+NREL)*2+8)
              IF( MOD( ihelp, 100 ) .EQ. 2 )
*** PMF(end)
     *          HW((NPZE4V+NREL)*2+8) = HW((NPZE4V+NREL)*2+8)/100*100
            ENDIF
            CALL EAFLST( JCAND, RW(NPZE4V+NREL+3) )
          ENDIF
          NREL = NREL + LADD(ITPF)
   10   CONTINUE
      ENDIF
      END

C   10/10/79 202222230  MEMBER NAME  MUDCHK   (JADEMUS)     FORTRAN
C
C LAST CHANGE 13.30 22/02/82 HUGH MCCANN - FOR IMPROVED ERROR OUTPUT.
C                                          ONLY GET O/P FOR MUPRIN>=5.
C      CHANGE 17.15  01/10/81  HUGH MCCANN  - PROTECT MUFFLE SQRTS.
C      CHANGE 06.27  24/04/80  JOHN ALLISON - TO PRINT ONLY IF DESCREP-
C                               -ANCY IS LARGE.
C      CHANGE 14.52  01/04/80  HUGH MCCANN (PRINT OPTION) .
C      CHANGE 10.35  29/03/80  JOHN ALLISON. (D -> DHARRY!!!!)
C      CHANGE 14.00  15/03/80  HARRISON PROSPER
      SUBROUTINE MUDCHK(I)
#include "cmufwork.for"
      COMMON/CMUPRN/MUPRIN
      U = DCX*DCX + DCY*DCY + DCZ*DCZ
      DHARRY = ABS(1.0 - U)
      IF  ( DHARRY.LT.0.001)  GO TO 600
C
C  PRINT OUT MESSAGE IF PRINT FLAG IS SET.
C
      IF(MUPRIN.LT.5)GO TO 500
C
C PRINT ONLY IN CASE OF LARGE DECREPANCY.
C
      IF(DHARRY.LT.0.1)GO TO 500
C
      WRITE(6,100) I
 100  FORMAT('0DIRECTION COSINE CHECK AT POSITION ',I2)
      WRITE(6,200)
 200  FORMAT(1X,9X,'    L ....... M ....... N',6X,'  MAGNITUDE')
      WRITE(6,300) DCX,DCY,DCZ,U
 300  FORMAT(1X,6X,3F10.6,10X,F10.6/)
C
 500  CONTINUE
C.....RENORMALISE DIRECTION COSINES
      DCX = DCX/SQRT(U)
      DCY = DCY/SQRT(U)
      DCZ = DCZ/SQRT(U)
C
C PROTECT MUFFLE SQRTS.
  600 IF(DCX*DCX.GT.1.000001)DCX=SIGN(1.0,DCX)
      IF(DCY*DCY.GT.1.000001)DCY=SIGN(1.0,DCY)
      IF(DCZ*DCZ.GT.1.000001)DCZ=SIGN(1.0,DCZ)
      RETURN
      END

C   03/08/85 508052020  MEMBER NAME  RENMAC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RENMAC
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   5/08/85 :  RENAME AN EXISTING MACRO
C
C
C     THIS ROUTINE PROMPTS FOR A MACRO NAME, DISPLAYS THE MACRO
C     DEFINITION AND ALLOWS THE USER TO RENAME THE MACRO.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS
      LOGICAL*1  CBLNK
      LOGICAL*1  CDEF
      LOGICAL*1  CCMD
C
      COMMON / CGRAP4 / IPOS4,CCMD(8,200),HCMD(5,200)
      COMMON / CWORK  / NFIELD, CHARS(80), ISTAFL(80), IENDFL(80)
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
      DATA  CBLNK / ' ' /
C
C------------------  C O D E  ------------------------------------------
C
   5  WRITE(6,10)
  10  FORMAT(' Please enter the NAME of the macro to be renamed')
      READ(5,40) CHARS
  40  FORMAT(80A1)
C
C                            FIND THE NAME
C
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .EQ. 0 ) RETURN
C
C                            CORRECT LENGTH AND ONLY ONE?
C
      LEN = IENDFL(1) - ISTAFL(1) + 1
      IF( NFIELD .EQ. 1  .AND.  LEN .LE. 8 ) GO TO 60
        WRITE(6,50)
  50    FORMAT(' Sorry. Only one name of 8 letters or less and no ";"',
     +         '. Please try again')
        GO TO 5
C
C                            DOES THE MACRO EXIST?
C
  60  CALL FINABR( CHARS(ISTAFL(1)), LEN, ICMD, MAXARG, IS )
      IMAC = ICMD - MACSTA
      IF( IMAC .GT. 0 ) GO TO 70
        WRITE(6,65)
  65    FORMAT(' No macro with that name exists.',
     +         ' Try again or press ENTER to end RENAMAC')
        GO TO 5
C
C                            DISPLAY DEFINITION
C
  70  WRITE(6,80) (CDEF(K,IMAC),K=1,80)
  80  FORMAT(' The following definition currently exists for this',
     +       ' macro:'/
     +       1X,80A1/' Please enter NEW NAME    or just press ',
     +               'ENTER to retain old name')
C
  85  READ(5,90) CHARS
  90  FORMAT(80A1)
C
C                            NULL LINE?
C
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .GT. 0 ) GO TO 100
        WRITE(6,95)
  95    FORMAT(' Old name retained.')
        RETURN
C
C                            CORRECT LENGTH AND ONLY ONE?
C
 100  LEN = IENDFL(1) - ISTAFL(1) + 1
      IF( NFIELD .EQ. 1  .AND.  LEN .LE. 8 ) GO TO 160
        WRITE(6,50)
        GO TO 85
C
C                            IS THE NEW NAME UNIQUE?
C
 160  CALL FINABR( CHARS(ISTAFL(1)), LEN, ICMD1, MAXARG, IS )
      IMAC1 = ICMD1 - MACSTA
      IF( ICMD1 .LE. 0 ) GO TO 170
      IF( IMAC1 .NE. IMAC ) GO TO 164
        WRITE(6,95)
        RETURN
C
 164    WRITE(6,165)
 165    FORMAT(' This name is already in use.',
     +         ' Try again or press ENTER to end RENAMAC')
        GO TO 85
C
 170  CALL LOCMAC( ICMD, LOCAT )
      IF( LOCAT .GT. 0 ) GO TO 175
        WRITE(6,172)
 172    FORMAT(' SYSTEM ERROR in RENMAC. Call the GRAPHICS EXPERT!')
        RETURN
C
 175  KK1 = ISTAFL(1)
      KK2 = IENDFL(1)
      WRITE(6,180) (CCMD(K,LOCAT),K=1,8), (CHARS(KK),KK=KK1,KK2)
 180  FORMAT(' Macro ',8A1,' renamed to ',8A1)
C
      DO  190  I = 1,8
        IP = KK1 + I - 1
        IF( IP .GT. 80 ) GO TO 185
          CCMD(I,LOCAT) = CHARS( IP )
          GO TO 190
C
 185      CCMD(I,LOCAT) = CBLNK
C
 190  CONTINUE
C
      RETURN
      END

C
C Routine RCONV reads data from a binary calibration file and
C shows the contents of a bank specified by variable BANK
C 
C
C Date:    16/11/98   Author:  P.M. Fernandez
C
      PROGRAM RCONV
      IMPLICIT NONE
C
C Insert HERE name of file to be converted
      CHARACTER CIN*100 /'aupdat1.b'/
      INTEGER NUNIT/10/
C 
C Insert HERE name, number and validation date of a bank
**      CHARACTER*4 BANK /'VTXC'/  
**      INTEGER NR /1/,IDATE /225118651/
*      CHARACTER*4 BANK /'JTPL'/  
*      INTEGER NR /1/,IDATE /14688000/
      CHARACTER*4 BANK /'MUCA'/  
      INTEGER NR /2/,IDATE /171331200/
C
      INTEGER ICYCL
      LOGICAL SEE/.FALSE./
C
      REAL ABUF(10000)
      INTEGER IBUF(10000)
      INTEGER*2 HBUF(20000)
      CHARACTER*4 CBUF(10000)
      EQUIVALENCE (ABUF(1),IBUF(1)),(CBUF(1),IBUF(1)),(HBUF(1),IBUF(1))
      INTEGER NWORD,NREC,IOUT,IRET,I,K
      CHARACTER*1 GOON
C
C Open unformatted input file
      OPEN (NUNIT,FILE=CIN,STATUS='UNKNOWN',FORM='UNFORMATTED')
      WRITE(*,'(A15,A)') 'Input file: ',CIN
      NREC=0
C
C Read length of record
 10   READ(NUNIT,ERR=1000,END=2000) NWORD
      BACKSPACE(NUNIT)
C
C Read one record
      CALL RDAT(NUNIT,NWORD,IBUF,IRET)
      IF(IRET.EQ.1) GOTO 1000
      IF(IRET.EQ.2) GOTO 2000
C
      NREC=NREC+1
      IOUT=NWORD
      IF(IOUT.GT.9) IOUT=9  
C
C Print out header
      IF (NWORD.EQ.1) THEN
         WRITE(6,901)  NWORD,IBUF(1)
         NREC=0
      ENDIF
      IF (NWORD.GT.1) WRITE(6,900)  NREC,NWORD,(IBUF(I),I=1,IOUT)
C
C Print out content
      IF(.NOT.SEE.AND.
     +     BANK.EQ.CBUF(1).AND.NR.EQ.IBUF(2).AND.IDATE.EQ.IBUF(6))
     +     SEE=.TRUE.
C
      IF(NWORD.GT.9.AND.SEE) THEN
         DO I=9,NWORD-1,10
            ICYCL=MIN(10,NWORD-I)
            print *,icycl,nword,i
            WRITE(6,902) NREC,CBUF(1),I
            WRITE(6,'(10I16)')  (I+K,K=1,ICYCL)
            WRITE(6,'(20I8)')  (I+K,K=1,2*ICYCL)
            WRITE(6,'(80('' .''))')
            WRITE(6,'(10I16)')  (IBUF(I+K),K=1,ICYCL)
            WRITE(6,'(20I8)')  (HBUF(2*I+K),K=1,2*ICYCL)
            WRITE(6,'(10E16.5)')  (ABUF(I+K),K=1,ICYCL)
            WRITE(6,'(10A16)')  (CBUF(I+K),K=1,ICYCL)
            WRITE(*,'(''Press RET or eXit'')')
            READ(*,'(A)') GOON
            IF(GOON.EQ.'X'.OR.GOON.EQ.'x') GOTO 100
         ENDDO
      ENDIF
C
 100  CONTINUE
      IF(.NOT.SEE) GOTO 10
      WRITE(*,'(''Continue with next bank ? (y/...)'')')
      READ (*,'(A1)') GOON
      IF (GOON.EQ.'y'.OR.GOON.EQ.'Y') GOTO 10
      GOTO 9999
C
 900  FORMAT(/1X,'Record number:',I5,4X,'Words:',I6
     +     ,2X,'Header:',' ',A4,' ',2I2,I2,2I10,I6,I10,I2)
 901  FORMAT(/1X,'Record number:',I5,4X,'Validation time:',I12)
 902  FORMAT(160('-')/1X,'Record number: ',I6,'   Bank: '
     +     ,A4,'   Word: ',I6)
C
 1000 CONTINUE
      WRITE(6,101) NREC
 101  FORMAT(//' *** READ ERROR ENCOUNTERED AFTER ',I6,' RECORDS.')
      GOTO 9999
 2000 CONTINUE
      WRITE(6,102) NREC
 102  FORMAT(//' NORMAL END OF FILE AFTER',I6,' RECORDS.')
      GOTO 9999
C
 9999 CONTINUE
      CLOSE(NUNIT)
      STOP
      END
C----------------------------------------
      SUBROUTINE RDAT(NUNIT,NWORD,IBUF,IRET)
      IMPLICIT NONE
      INTEGER IBUF,NWORD,IRET,NUNIT,I
      DIMENSION IBUF(NWORD)
      READ(NUNIT,ERR=1,END=2) NWORD,IBUF
      IRET=0
      RETURN
    1 CONTINUE
      IRET=1
      RETURN
    2 IRET=2
      RETURN
      END

      SUBROUTINE BSIDE
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C----------------------------------------------------------------------
C           MACRO CDSMAX .... PATTERN RECOGNITION CONSTANTS.
C----------------------------------------------------------------------
      COMMON/CDSMAX/DSMAX(16,3,2),DIRWR1(24,2),DIRWR3(48,2)
     *             ,DHALF(16,3,2),DTWICE(16,3,2),HMCH(16,3,2)
     *             ,IBCK(9),DBCK(30),TRMATS(96,2),TRMATC(96,2)
C------------------------ END OF MACRO CDSMAX -------------------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
      DIMENSION LSTCL(3),LFTCL(3),NCELL(3),TANDEL(3)
      EQUIVALENCE (IBCK(1),LSTCL(1)),(IBCK(4),LFTCL(1))
      EQUIVALENCE (IBCK(7),NCELL(1)),(DBCK(1),TANDEL(1))
      DATA MSKCR1 /Z100/
      LRCORN=0
      KT=K
      IRIFLG=0
      IWT=ILIM-1
      ICX=ICL
15000 CONTINUE
      IF(
     - IWT.LT.ILIM
     -)THEN
      DS=TRKAR(KT,10-IUDFLG)
      IW=ITRKAR(KT,9-IUDFLG)
      IKX=0
      A=TRKAR(KT,11-IUDFLG)
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ICT=ICX+1
      IF(ICT.GT.LSTCL(KRING)) ICT=ICT-NCELL(KRING)
      LR1=2
      IF(
     - IPER.GE.0
     -)THEN
      IF(
     - HNTCEL(ICT+1)-HNTCEL(ICT).GT.0
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - LR.EQ.1.OR.IMARK.EQ.0.OR.LR.EQ.0
     -)THEN
      CALL SIDE1
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      IF(
     - IKX.NE.0
     -)THEN
      IF(
     - LR.EQ.-1
     -)THEN
      CALL COREC
      ENDIF
      LR=-1
      IWT=HMCH(ITRKAR(IKX,9-IUDFLG)+1,KRING,2)
      IF(IUDFLG.EQ.6) IWT=-IWT
      CALL BSTORE
      IPST=0
      LR=1
      IJFLG=0
      ENDIF
      IF(
     - IKX.EQ.0
     -)THEN
      ICT=ICX-1
      IF(ICT.LT.LFTCL(KRING)) ICT=ICT+NCELL(KRING)
      LR1=1
      IF(
     - IPER.LE.0
     -)THEN
      IF(
     - HNTCEL(ICT+1)-HNTCEL(ICT).GT.0
     -)THEN
      ASSIGN 17004 TO IZZZ02
      GOTO 17002
17004 CONTINUE
      IF(
     - LR.EQ.-1.OR.IMARK.EQ.0.OR.LR.EQ.0
     -)THEN
      CALL SIDE1
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      IF(
     - IKX.NE.0
     -)THEN
      IF(
     - LR.EQ.0
     -)THEN
      HISTR(1,NTR)=-HISTR(1,NTR)
      ENDIF
      IF(
     - LR.EQ.1
     -)THEN
      CALL COREC
      ENDIF
      LR=1
      IWT=HMCH(ITRKAR(IKX,9-IUDFLG)+1,KRING,1)
      IF(IUDFLG.EQ.6) IWT=-IWT
      CALL BSTORE
      IPST=0
      IJFLG=0
      LR=-1
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      RETURN
17002 CONTINUE
      IMARK=0
      KC1=HISTR(1,NTR)
      KC1=IPCL(IABS(KC1))
      KC2=HISTR(HNREL(NTR),NTR)
      KC2=IPCL(IABS(KC2))
      IF(
     - KC1.NE.KC2
     -)THEN
      IF(
     - KC1.LE.48
     -)THEN
      IF(KC1-KC2.NE.24) IMARK=1
      ELSE
      IMARK=1
      ENDIF
      ENDIF
      GOTO IZZZ02
17000 CONTINUE
      IPER=0
      IF(
     - IBKK(20).NE.0.AND.LR.NE.0.AND.NRHT(KT).GE.IBKK(19)
     -)THEN
      IPER=LR
      IF(LAND(MSKCR1,LBL(KT)).NE.0.AND.IUDFLG.EQ.3) IPER=-IPER
      ENDIF
      GOTO IZZZ01
      END

C   10/05/79 105081149  MEMBER NAME  USPATT   (JADEGS)      FORTRAN
      SUBROUTINE USER(INDEX)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C---
      IMPLICIT INTEGER*2 (H)
C
C PMF 05/11/98     LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C This declaration is just contained in macro cgraph.for 
      DIMENSION KU(2)
C
      COMMON /CTLIM/ ISECLF
C
#include "cgraph.for"
#include "cpatlm.for"
C
#include "cheadr.for"
#include "cdata.for"
#include "ccycp.for"
C
#include "cworkpr.for"
#include "cworkeq.for"
C
#include "cjdrch.for"
C
      COMMON/CADMIN/ IEVTP,NRREAD,NRWRIT,LBREAD(4)
      LOGICAL*1 LBREAD
C
#include "cbin.for"
C---
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   MUON CHAMBER TRACKING HAS BEEN DONE.
C              9   MUON AND INNER DETECTOR TRACKS HAVE BEEN ASSOCIATED.
C             10   UNUSED
C---
C---     CHECK IF CALL AT END OF JOB
      IF(INDEX.EQ.100) GOTO 1100
C
      GO TO (1001,1002,1003,1004,1005,1006,1007,1008,1009,1010),INDEX
C---
C---     INDEX=0 INITIALIZATION.
C---
C
      ISECLF= 0
      INDEX=INDEX+1
      RETURN
C
 1001 CONTINUE
C        TIMDEL(1,1) = .005900
C        TIMDEL(2,1) = .005900
C        TIMDEL(1,2) = .005900
C        TIMDEL(2,2) = .005900
C        TIMDEL(1,3) = .005900
C        TIMDEL(2,3) = .005900
C        TZERO(1) = -3.
C        TZERO(2) = -3.
C        TZERO(3) =  0.
C        DRIDEV = 0.
C        DRISIN = 0.
C        DRICOS = 1.
C        XYF(1) = 0.4 / SQRT(12.)
C        XYF(3) = 1.0
C        XYF(8) = 1.0
C        XYF(9) = 1.0
C
         IEVTP = 0
C        CALL INPATR
C        CALL INPATC
C     CALL INBTLM
      INDEX=INDEX+1
      RETURN
C
 1002 CONTINUE
C     DATA JHTL,PATR /'JHTL','PATR'/
C     CALL JBDLM(PATR,IER)
C     CALL JBDLM(JHTL,IER)
C                                                 SELECT EVENT
      DATA NREC/ 0/
      NREC = NREC + 1
      IF(NREC.LT. 1) GOTO 1
      PRINT 2991, HHEADR(17),HHEADR(18),HHEADR(19),NREC
 2991 FORMAT(' **********************   EVENT:',4I6,'   *************')
C                                       CHECK IF HITS IN ID OR LG-ENERGY
      IF(IDATA(IBLN('JETC')).LE.0) GOTO 1
        NWRD2 = NWORD*2
C     PRINT 2901, NREC, NWORD,(HDATA(I1), I1=1,NWRD2)
2901    FORMAT(1H1,'EVENT =',2I6,/,(1X,20I6))
      INDEX=INDEX+1
      RETURN
C
 1003 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1004 CONTINUE
C                                                 CHECK IF GOOD VERTEX
      INDEX=INDEX+1
      RETURN
C
 1005 CONTINUE
C                              STOP EVENT ANALYSIS AFTER PATREC
C
      CALL USTART(KU,1,0,1)
      CALL PATREC(0)
      CALL USTOP(KU,1,0,1)
      DTM  = KU(2) * .026
      IPPATR = IDATA(IBLN('PATR'))
      NTR = IDATA(IPPATR+2)
      DTMT = 0.
      IF(NTR.NE.0) DTMT = DTM / NTR
      PRINT 2904, NREC,DTM,DTMT,NTR
 2904 FORMAT('0NREC:',I6,',    TIME(PATREC):',F8.3,' :',F7.3,' (',I2,
     ,       ' TRACKS)')
C     PRINT OUT OF TRACK BANKS
      DATA NPR /0/
      NPR = NPR + 1
      IF(NPR.LE. 4)
     ,CALL PRPATR
C
51    GOTO 11
C                                       CHANGE LIMITS + REPEAT PATREC
      INDEX=INDEX+1
      RETURN
C
 1006 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1007 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1008 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1009 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1010 CONTINUE
      INDEX=INDEX+1
      RETURN
C---     END OF JOB: FINAL CALCULATIONS + PRINTOUT
 1100 CONTINUE
      NPR = NPR - 1
      PRINT 2999, NREC,NPR
 2999 FORMAT('0END OF JOB:',I6,' EVENTS READ,',I6,' EVENTS WRITTEN')
      STOP
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---
    1 CONTINUE
      INDEX=1
      RETURN
    2 CONTINUE
      INDEX=2
      RETURN
    3 CONTINUE
      INDEX=3
      RETURN
    4 CONTINUE
      INDEX=4
      RETURN
    5 CONTINUE
      INDEX=5
      RETURN
    6 CONTINUE
      INDEX=6
      RETURN
    7 CONTINUE
      INDEX=7
      RETURN
    8 CONTINUE
      INDEX=8
      RETURN
    9 CONTINUE
      INDEX=9
      RETURN
   10 CONTINUE
      INDEX=10
      RETURN
   11 CONTINUE
      INDEX=11
      RETURN
      END

C   25/06/78            MEMBER NAME  BOUND    (LGSOURCE)    FORTRAN
      FUNCTION BOUND(PA0)
C
C     A. SATO  28-10-77
C
      DIMENSION PA0(3,3)
      X=PA0(1,2)
      IF(X.GE.0.)GOTO1
      BOUND=-1.
      RETURN
1     BOUND=B-X
      RETURN
C
      ENTRY BOUNDI(BIN)
      B=BIN
      RETURN
      END

C   08/11/84            MEMBER NAME  PRTPEV   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE  PRTPEV( JUNIT )
C-----------------------------------------------------------------------
C
C   AUTHOR:    C. BOWDERY     8/11/84 : PRINTS OUT THE TPEV BANK
C
C      MOD:    C. BOWDERY    11/12/84 : CORRECT MISTAKE IN Q1,Q2,Q3
C LAST MOD:    C. BOWDERY     2/10/86 : UNIT NUMBER IS A PARAMETER
C
C
C      INPUT:     JUNIT  = LOGICAL UNIT NUMBER FOR OUTPUT
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2  (H)
C
#include "cdata.for"
C
C------------------  C O D E  ------------------------------------------
C
      IUNIT = JUNIT
      IF( JUNIT .LT. 1  .OR.  JUNIT .GT. 99 ) IUNIT = 6
C
      CALL CLOC( ITPEV, 'TPEV', 1 )
      IF( ITPEV .GT. 0 ) GO TO 5
        WRITE(IUNIT,1)
   1    FORMAT(' ***  WARNING  ***  PRTPEV FOUND NO TPEV/1 BANK'//)
        RETURN
C
C                           TPEV BANK/1 IS THERE
C
   5  ITPEV2 = ITPEV * 2
      WRITE(IUNIT,7) IDATA( ITPEV )
   7  FORMAT('1'//20X,
     +     '*****   T P E V   *****'//6X,'BANK:  1',8X,'LENGTH:',I5/)
C
C
C                            PARTICLES
C
C
      WRITE(IUNIT,9) IDATA( ITPEV + 1 ), IDATA( ITPEV + 2 )
   9  FORMAT(6X,'VERSION NUMBER:',I3,8X,'PRODUCTION DATE AND TIME:',I10)
C
      NTR  = HDATA( ITPEV2 +  5 )
      NTRP = HDATA( ITPEV2 +  6 )
      NTRM = HDATA( ITPEV2 +  7 )
      NTRX = HDATA( ITPEV2 +  8 )
      NTRN = HDATA( ITPEV2 +  9 )
      NTRB = HDATA( ITPEV2 + 10 )
      NTRF = HDATA( ITPEV2 + 11 )
C
      WRITE(IUNIT,12) NTR, NTRP, NTRM, NTRX, NTRN, NTRB, NTRF
  12  FORMAT(/'   PARTICLES     TOTAL   +    -    ?   Q=0   B    F'/
     +        '                 -----  ---  ---  ---  ---  ---  ---'//
     +        18X,I3,6(3X,I2) /)
C
C
C                            NUMBER OF VERTICES
C
C
      NVX  = HDATA( ITPEV2 + 12 )
      NVXN = HDATA( ITPEV2 + 13 )
      NVXC = HDATA( ITPEV2 + 14 )
C
      WRITE(IUNIT,15) NVX, NVXN, NVXC
  15  FORMAT(/'   VERTICES      TOTAL   N    C'/
     +        '                 -----  ---  ---'//
     +        18X,I2,1X,2(3X,I2) /)
C
C
C                            PARTICLE TYPES
C
C
      NPHOT = HDATA( ITPEV2 + 15 )
      NEP   = HDATA( ITPEV2 + 16 )
      NEM   = HDATA( ITPEV2 + 17 )
      NMUP  = HDATA( ITPEV2 + 18 )
      NMUM  = HDATA( ITPEV2 + 19 )
C
      NPIP  = HDATA( ITPEV2 + 20 )
      NPIM  = HDATA( ITPEV2 + 21 )
      NPI0  = HDATA( ITPEV2 + 22 )
      NKP   = HDATA( ITPEV2 + 23 )
      NKM   = HDATA( ITPEV2 + 24 )
      NK0S  = HDATA( ITPEV2 + 25 )
C
      NETA  = HDATA( ITPEV2 + 26 )
      NP    = HDATA( ITPEV2 + 27 )
      NPBAR = HDATA( ITPEV2 + 28 )
      NLAMB = HDATA( ITPEV2 + 29 )
      NX    = HDATA( ITPEV2 + 30 )
C
      NFLAG = HDATA( ITPEV2 + 31 )
      NSP1  = HDATA( ITPEV2 + 32 )
      NSP2  = HDATA( ITPEV2 + 33 )
      NSP3  = HDATA( ITPEV2 + 34 )
C
      WRITE(IUNIT,18) NPHOT, NEP, NEM, NMUP, NMUM, NPIP, NPIM, NPI0,
     +            NKP, NKM, NK0S, NETA, NP, NPBAR, NLAMB, NX,
     +            NFLAG, NSP1, NSP2, NSP3
  18  FORMAT(/'   TYPES       GAM   E+   E-  MU+  MU-  PI+  PI-  PI0',
     +                     '   K+   K-  K0S  ETA   P    P-  LAM   ? ',
     +                     '  FLAG   3 SPARE'/
     +                   13X,16('  ---'),'  ----   -------'//
     +        12X,16(3X,I2),3X,I4,1X,3(2X,I1) / )
C
C
C                            VISIBLE ENERGY, MISSING MOMENTUM
C
C
      EVISC  = ADATA( ITPEV + 18 )
      SIGEVC = ADATA( ITPEV + 19 )
      EVISN  = ADATA( ITPEV + 20 )
      SIGEVN = ADATA( ITPEV + 21 )
C
      PMISSX = ADATA( ITPEV + 22 )
      PMISSY = ADATA( ITPEV + 23 )
      PMISSZ = ADATA( ITPEV + 24 )
      SIGPMX = ADATA( ITPEV + 25 )
      SIGPMY = ADATA( ITPEV + 26 )
      SIGPMZ = ADATA( ITPEV + 27 )
C
      WRITE(IUNIT,22) EVISC, SIGEVC, EVISN, SIGEVN, PMISSX, PMISSY,
     +            PMISSZ,SIGPMX, SIGPMY, SIGPMZ
  22  FORMAT(/'   EVIS,PMISS               VISIBLE ENERGY           ',
     +        '                       MISSING MOMENTUM'
     +       /'                 CHARGED  SIGMA(C)  NEUTRAL  SIGMA(N)',
     +        '       X       Y      Z     SIGMA(X)  SIGMA(Y)  SIGMA(Z)'
     +       /'                 -------  --------  -------  --------',
     +        '    ------  ------  ------  --------  --------  --------'
     +      //'                 ',F6.3,4X,F6.3,3X,F6.3,4X,F6.3,
     +         4X,F7.3,1X,F7.3,1X,F7.3,2X,F7.3,3X,F7.3,3X,F7.3/)
C
C
C                            SPHERICITY
C
C
      ISPHFL = HDATA( ITPEV2 + 55 )
      ISPHTR = HDATA( ITPEV2 + 56 )
C
      ALPHA1 = ADATA( ITPEV + 29 )
      ALPHA2 = ADATA( ITPEV + 30 )
      ALPHA3 = ADATA( ITPEV + 31 )
C
      DCX1   = ADATA( ITPEV + 32 )
      DCY1   = ADATA( ITPEV + 33 )
      DCZ1   = ADATA( ITPEV + 34 )
      DCX2   = ADATA( ITPEV + 35 )
      DCY2   = ADATA( ITPEV + 36 )
      DCZ2   = ADATA( ITPEV + 37 )
      DCX3   = ADATA( ITPEV + 38 )
      DCY3   = ADATA( ITPEV + 39 )
      DCZ3   = ADATA( ITPEV + 40 )
C
      WRITE(IUNIT,25) ISPHFL, ISPHTR, ALPHA1, ALPHA2, ALPHA3,
     +            DCX1, DCY1, DCZ1,
     +            DCX2, DCY2, DCZ2, DCX3, DCY3, DCZ3
  25  FORMAT(/'   SPHERICITY      FLAG  TRACKS   ALPHA1 ALPHA2 ALPHA3 ',
     + ' DCX1   DCY1   DCZ1   DCX2   DCY2   DCZ2   DCX3   DCY3   DCZ3'/
     +        '                   ----  ------   ------ ------ ------ ',
     + ' ----   ----   ----   ----   ----   ----   ----   ----   ----'//
     +        '                     ',I1,5X,I2,5X,3(F5.3,2X),
     +     9(F6.3,1X)  /)
C
C
C                            THRUST
C
C
      ITHTR1 = HDATA( ITPEV2 + 81 )
      ITHTR2 = HDATA( ITPEV2 + 82 )
C
      THRUST = ADATA( ITPEV + 42 )
      DCTHX  = ADATA( ITPEV + 43 )
      DCTHY  = ADATA( ITPEV + 44 )
      DCTHZ  = ADATA( ITPEV + 45 )
C
      UNUSE1 = ADATA( ITPEV + 46 )
      UNUSE2 = ADATA( ITPEV + 47 )
      UNUSE3 = ADATA( ITPEV + 48 )
      UNUSE4 = ADATA( ITPEV + 49 )
      UNUSE5 = ADATA( ITPEV + 50 )
C
      WRITE(IUNIT,28) ITHTR1, ITHTR2, THRUST, DCTHX, DCTHY, DCTHZ,
     +            UNUSE1, UNUSE2, UNUSE3, UNUSE4, UNUSE5
  28  FORMAT(/'   THRUST          TRACKS  USED   THRUST    DCX     DCY',
     +        '     DCZ         5 UNUSED'/
     +        '                   ------  ----   ------    ---     ---',
     +        '     ---         --------'//
     +        '                     ',I2,5X,I2,5X,F5.3,2X,3(F7.3,1X),
     +             5(2X,F3.1) /)
C
C
C                            2 PRONG DATA
C
C
      BPTOF  = ADATA( ITPEV + 51 )
      DTOF   = ADATA( ITPEV + 52 )
      COLLIN = ADATA( ITPEV + 53 )
      ACOPL  = ADATA( ITPEV + 54 )
      UNUSE6 = ADATA( ITPEV + 55 )
C
      WRITE(IUNIT,32) BPTOF, DTOF, COLLIN, ACOPL, UNUSE6
  32  FORMAT(/'   2 PRONGS        BPTOF  DIFTOF  COLLIN  ACOPL  UNUSED'/
     +        '                   -----  ------  ------  -----  ------'/
     +       /18X,F7.3,1X,F6.3,2X,F6.3,1X,F6.3,4X,F3.1/)
C
C
C                            ERROR FLAGS
C
C
      IERRPT = HDATA( ITPEV2 + 111 )
      IERRVF = HDATA( ITPEV2 + 112 )
      IERRTF = HDATA( ITPEV2 + 113 )
      IERRDX = HDATA( ITPEV2 + 114 )
      IERRLG = HDATA( ITPEV2 + 115 )
      IERRMU = HDATA( ITPEV2 + 116 )
      IERRFW = HDATA( ITPEV2 + 117 )
      IERRV0 = HDATA( ITPEV2 + 118 )
      IERRJA = HDATA( ITPEV2 + 119 )
      IERRNU = HDATA( ITPEV2 + 120 )
C
      WRITE(IUNIT,35) IERRPT, IERRVF, IERRTF, IERRDX, IERRLG, IERRMU,
     +            IERRFW, IERRV0, IERRJA, IERRNU
  35  FORMAT(/'   ERROR FLAGS     PATR    VXFIT    TOF     DEDX',
     +        '     LG     MUON   FWDET   VEES    JETAN     -   '/
     +        '                   -----   -----   -----   -----',
     +        '   -----   -----   -----   -----   -----   -----'//
     +        '                ',10(3X,I5) /)
C
      RETURN
      END

C   15/02/80 002271401  MEMBER NAME  ZINTER   (JADESR)      FORTRAN
C   13/03/79         4  MEMBER NAME  ORZINTER (JADESR)      FORTRAN
C   13/03/79 C9031301   MEMBER NAME  ZINTER8  (JADESR)      FORTRAN
      SUBROUTINE ZINTER
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
#include "clbpgm.for"
#include "cdata.for"
C
#include "czvpar.for"
                      DIMENSION AZVPAR(12),IZVPAR(12)
                      EQUIVALENCE(AZVPAR(1),IZVPAR(1),ZLOW)
C
#include "cworkzv.for"
C     COMMON /CZINTR/ ZVTX,DZV1,DZV2,PEAK,BACK,IFLAG,
C    ,                HUFLO,HOFLO,MAXZ ,HIST(100)
C                     DIMENSION ZVRSLT(58)
C                     EQUIVALENCE (ZVRSLT(1),ZVTX)
C
      DATA INSTRC/1/
C
 2002 FORMAT(8X,F7.0,2F6.0,2F6.1,4I6)
 2003 FORMAT(8X,F7.0,2F6.0,2F6.1,I6,' : FROM /CDATA/   ')
 2004 FORMAT(' ',3F7.0,2F7.1,I7)
 2005 FORMAT(' ',F6.0,F6.1,6I6,F6.1,F6.3)
 2006 FORMAT(' ',F7.0,2F7.1,2F7.0,I7)
C
C
      ITHIS=0
      IF(INSTRC.EQ.1)  CALL TRMOUT(80,
     1   'WELCOME TO ZINTER (MENU OF INST. KEYS: TYPE 1 !)^')
C
1     CALL TRMOUT(80,'ZV..^')
      INSTR=TERNUM(DUMMY)
      IF(INSTR.LT.1 .OR. INSTR.GT.13) RETURN
      GOTO (100,200,300,400,500,600,700,800,900,1000,
     ,     1100,1200,1300), INSTR
C
C
C                                     **********************************
C                                     *       MENU OF INSTR. KEYS      *
C                                     **********************************
 100  CONTINUE
      CALL TRMOUT(80,' 0: EXIT                  1: INSTRUCTION LIST
     1 2: HARDCOPY            ^')
      CALL TRMOUT(80,' 3: JOYSTICK              4: RESET SCALE
     1 5: COMMENT OPTION      ^')
      CALL TRMOUT(80,' 6: SHOW EVENT            7: CALL ZVERTF
     1 8: CHANGE PARAMETERS   ^')
      CALL TRMOUT(80,' 9: RESET PARAMETERS     10: CHANGE RESULTS
     111: PRINT RESULTS       ^')
      CALL TRMOUT(80,'12: SHOW HISTOGRAM       13: RESULTS TO /CDATA/
     114: EXIT                ^')
      GOTO 1
C
C
C                                     **********************************
C                                     *      HARDCOPY                 *
C                                     **********************************
200   CALL HDCOPY
      GO TO 1
C
C
C                                     **********************************
C                                     *      JOYSTICK                  *
C                                     **********************************
300   CALL JOYS(0,0.) ! PMF 02/12/99 : second argument added
      GO TO 1
C
C
C                                     **********************************
C                                     *      RESET SCALE               *
C                                     **********************************
400   CALL SETSCL(ISTANV)
      GO TO 1
C
C
C                                     **********************************
C                                     *      COMMENT                   *
C                                     **********************************
500   CALL COMENT
      GO TO 1
C
C
C                                     **********************************
C                                     *   DISPLAY EVENT +  RESULTS     *
C                                     **********************************
  600 CONTINUE
      CALL ERASE
      CALL JADISP(4)
      CALL EVDISP(4)
C                                        DRAW VERTEX HISTOGRAM
      GOTO 1200
C
C
C                                     **********************************
C                                     *      CALL ZVERTF               *
C                                     **********************************
  700 CONTINUE
      CALL ZVERTF
      GOTO 1
C
C
C                                     **********************************
C                                     *   CHANGE PARAMETERS + LIMITS   *
C                                     **********************************
  800 CONTINUE
      CONTINUE !CALL ERASE PMF 02/12/99
      CALL TRMOUT(80,'ZVERT PARAMETERS:^')
      CALL TRMOUT(80,
     ,'  Z0:1 BIN:2 NBN:3 NR1:4 NC0:5 NC1:6 NC2:7 NPK:8 S/B:9 DFI:10^')
      WRITE(6,2005) (AZVPAR(I1),I1=1,7),NPKMIN,SBRAT,DFIMAX
 801  CALL TRMOUT(80,
     ,'CHANGE PAR. BY ENTERING INDEX AND NEW VALUE^')
      DO 810 I1=1,20
        CALL TONUM(IND,PAR)
        IF(IND.LE.0 .OR. IND.GT.10) GOTO 820
        IF(IND.GT.7) IND = IND + 2
        IF(IND.LE.2 .OR. IND.GT.10) GOTO 802
        IZVPAR(IND) = PAR+.5
        GOTO 810
  802   AZVPAR(IND) = PAR
  810   CONTINUE
  820 CONTINUE
      CALL TRMOUT(80,'NEW ZVERT PARAMETERS:^')
      CALL TRMOUT(80,
     ,'  Z0:1 BIN:2 NBN:3 NR1:4 NC0:5 NC1:6 NC2:7 NPK:8 S/B:9 DFI:10^')
      WRITE(6,2005) (AZVPAR(I1),I1=1,7),NPKMIN,SBRAT,DFIMAX
      CALL TRMOUT(80,'OK, YES OR NO?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.2) GOTO 801
      GOTO 1
C
C
C                                     **********************************
C                                     *  RESET PARAMETERS TO DEFAULT   *
C                                     **********************************
  900 CONTINUE
      CALL TRMOUT(80,'DEFAULT ZVERT PARAMETERS RESTORED:^')
      CALL INITZV
      CALL TRMOUT(80,
     ,'  Z0:1 BIN:2 NBN:3 NR1:4 NC0:5 NC1:6 NC2:7 NPK:8 S/B:9 DFI:10^')
      WRITE(6,2005) (AZVPAR(I1),I1=1,7),NPKMIN,SBRAT,DFIMAX
      GOTO 1
C
C
C                                     **********************************
C                                     *     CHANGE RESULTS             *
C                                     **********************************
 1000 CONTINUE
      CONTINUE !CALL ERASE PMF 02/12/99
      CALL TRMOUT(80,'CHANGE RESULTS OF ZVERTF^')
      CALL TRMOUT(80,' ZVTX:1 DZV1:2 DZV2:3 PEAK:4 BACK:5 FLAG:6^')
      WRITE(6,2004) ZVTX,DZV1,DZV2,PEAK,BACK,IFLAG
1001  CALL TRMOUT(80,'CHANGE PAR. BY ENTERING INDEX AND NEW VALUE^')
      DO 1010 I1=1,20
        CALL TONUM(IND,PAR)
        IF(IND.LE.0 .OR. IND.GT. 6) GOTO 1020
        IF(IND.LT.6) GOTO 1002
        IFLAG = PAR+.5
        GOTO 1010
 1002   FZRSLT(IND) = PAR
 1010   CONTINUE
 1020 CONTINUE
      CALL TRMOUT(80,'NEW ZVERT RESULTS:^')
      CALL TRMOUT(80,' ZVTX:1 DZV1:2 DZV2:3 PEAK:4 BACK:5 FLAG:6^')
      WRITE(6,2006) ZVTX,DZV1,DZV2,PEAK,BACK,IFLAG
      CALL TRMOUT(80,'OK, YES OR NO?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.2) GOTO 1001
      GOTO 1
C
C
C                                     **********************************
C                                     *         PRINT RESULTS          *
C                                     **********************************
 1100 CONTINUE
      CALL TRMOUT(63,
     ,'           ZVTX  DZV1  DZV2  PEAK  BACK  FLAG  UFLO  OFLO   MAX')
      I0 = IDATA(IBLN('ZVTX')) + 1
      IF(I0.LE.1) GOTO 1102
      I9 = I0 + 5
      WRITE(6,2003) (IDATA(I1),I1=I0,I9)
 1102 WRITE(6,2002) ZVTX,DZV1,DZV2,PEAK,BACK,IFLAG,
     ,                   HUFLO,HOFLO,MAXZ
      GOTO 1
C
C
C                                     **********************************
C                                     *    SHOW HISTOGRAM + RESULT     *
C                                     **********************************
 1200 X=ZLOW
      Y=0.
      CALL MOVEA(X,Y)
      IF(NBINZ.LT.1) GOTO 1
      DO 1210 I=1,NBINZ
      Y=100.*HIST(I)/(MAXZ+0.01)
      CALL DRAWA(X,Y)
      X=ZLOW+BINZ*I
      CALL DRAWA(X,Y)
 1210 CONTINUE
      Y=0.
      CALL DRAWA(X,Y)
C                                       DRAW ZVERTEX WITH ERRORS
      X1  = ZVTX - DZV1
      X11 = ZVTX - DZV2
      X2  = ZVTX + DZV1
      X22 = ZVTX + DZV2
      Y0  = - 70.
      Y1  = - 90.
      Y2  = - 50.
      CALL MOVEA(X1  , Y1)
      CALL DRAWA(X1  , Y2)
      CALL MOVEA(X1  , Y0)
      CALL DRAWA(X2  , Y0)
      CALL MOVEA(X2  , Y1)
      CALL DRAWA(X2  , Y2)
      CALL MOVEA(X22 , Y2)
      CALL DRAWA(X22 , Y1)
      CALL MOVEA(ZVTX, Y1)
      CALL DRAWA(ZVTX, Y2)
      CALL MOVEA(X11 , Y2)
      CALL DRAWA(X11 , Y1)
      CALL MOVEA(X1  , Y1)
      GOTO 1
C
C
C                                     **********************************
C                                     *    COPY RESULTS TO /CDATA/     *
C                                     **********************************
 1300 CONTINUE
      CALL TRMOUT(80,'NEW RESULTS TO /CDATA/: YES OR NO?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.2) GOTO 1
      IPZV = IDATA(IBLN('ZVTX'))
      IF(IPZV.GT.0) GOTO 1302
         NWRES = 6
         NBNK = 99
         CALL CCRE(IPZV,'DEDX',NBNK,NWRES,IERR)
         IF(IERR.NE.0) GO TO 1307
         CALL BSAW(1,'ZVTX')
         GOTO 1304
 1302 CONTINUE
         IDATA(IPZV-2) = 99
 1304 CONTINUE
         ADATA(IPZV+1) = FZRSLT(1)
         ADATA(IPZV+2) = FZRSLT(2)
         ADATA(IPZV+3) = FZRSLT(3)
         ADATA(IPZV+4) = FZRSLT(4)
         ADATA(IPZV+5) = FZRSLT(5)
         ADATA(IPZV+6) = FZRSLT(6)
      GOTO 1
1307  CALL TRMOUT(80,' ERROR IN CREATING BANK ZVTX ^')
      GO TO 1
C
C
      END

C   19/02/84 402192303  MEMBER NAME  RDMERG   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDMERG( N1, H1, N2, H2 )
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    25/04/79 :  MERGE TRUE HITS WITH RANDOM HITS
C
C        MOD  E. ELSEN    02/05/79 :
C   LAST MOD  C. BOWDERY  30/08/83 :  POINTERS FROM OLD TO NEW HITS
C
C             MERGE N1 DRIFT DATA FROM H1 WITH N2 DRIFT DATA FROM H2
C             IN ARRAY H2 IN INCREASING WIRE NUMBER. PROGRAM ASSUMES
C             DATA OF H2 TO START IN H2(N1*4+1). IN ORDER TO KEEP
C             TRACK OF INFORMATION RELATED TO THE 4 VECTOR/JETC HIT
C             ASSOCIATION, ALSO STORE AN ARRAY OF POINTERS FROM THE
C             ORIGINAL HITS TO THEIR NEW POSITIONS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CWORK  / HWORK(20000)
      COMMON / CWORK1 / JHITS, H4VJH(4000), H4VMRG(5000)
C
      DIMENSION H1(1), H2(1)
C
C-----------------------  C O D E  -------------------------------------
C
      IL1 = 1
      IL2 = N1*4 + 1
      IH1 = IL2 - 4
      IH2 = IH1 + N2*4
      ILN = 0
C
      JHITS = 0
      JNEW  = 1
C
  100 IF( ILN .GT. IH2 ) RETURN
C
C                       CHECK IF DATA LEFT IN H2
C
      IF( IL2 .GT. IH2 ) GO TO 400
C
C                       CHECK IF DATA LEFT IN H1
C
      IF( IL1 .GT. IH1 ) GO TO 500
C
C                       COMPARE WIRE NUMBERS.
C                       IF SAME NUMBER COMPARE DRIFT TIMES
C
      IF( H1(IL1) .LT. H2(IL2) ) GO TO 200
      IF( H1(IL1).EQ.H2(IL2) .AND. H1(IL1+3).GE.H2(IL2+3) ) GO TO 200
C
C                       TAKE THE NEXT RANDOM HIT AND PLACE INTO OUTPUT
C                       AREA WHICH STARTS FROM BEGINNING OF H2. IE.
C                       MOVE DATA FROM HIGH END OF H2 TO ILN  POSITION
C
      CALL MVC( H2, ILN*2, H2, (IL2-1)*2, 8 )
      IL2 = IL2 + 4
      GO TO 300
C
C                       TAKE THE NEXT REAL HIT AND PLACE INTO OUTPUT
C                       AREA WHICH STARTS FROM BEGINNING OF H2. IE.
C                       MOVE DATA FROM H1 TO H2 TO ILN POSITION.
C
  200 CALL MVC( H2, ILN*2, H1, (IL1-1)*2, 8 )
      IL1 = IL1 + 4
C
      JHITS = JHITS + 1
      H4VJH(JHITS) = JNEW
C
  300 ILN  = ILN  + 4
      JNEW = JNEW + 1
      GO TO 100
C
C                       RANDOM HITS EXHAUSTED SO COPY REST OF TRUE HITS.
C                       MOVE REST OF H1 DATA TO H2 AFTER ILN POSITION.
C
  400 NL = IH1 - IL1 + 4
      IF( NL .LE. 0 ) RETURN
      CALL MVCL( H2, ILN*2, H1, (IL1-1)*2, NL*2 )
C
      JN =  NL / 4
      DO  450  J = 1,JN
        JHITS = JHITS + 1
        H4VJH(JHITS) = JNEW + J - 1
 450  CONTINUE
C
      RETURN
C
C                       TRUE HITS EXHAUSTED SO COPY REST OF RANDOM HITS.
C                       MOVE REST OF H1 DATA TO H2 AFTER ILN POSITION.
C
  500 NL = IH2 - IL2 + 4
      IF( NL .LE. 0 ) RETURN
      CALL MVCL( H2, ILN*2, H2, (IL2-1)*2, NL*2 )
C
      RETURN
      END

      SUBROUTINE FLINEL
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      I9 = HPHL0 + 39
      IP1 = HPHT0
      IP9 = HPHT9
      IPD = HLDHT
      IP8 = IP9 - IPD
      IP7 = IP8 - IPD
      IP  = IP1 - IPD
15000 CONTINUE
      IF(
     - IP.LT.IP7
     -)THEN
      IP = IP + IPD
      IF(
     - IWRK(IP+7).EQ.0
     -)THEN
        ILAY0 = IWRK(IP)
        DS0 = WRK(IP+2)
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      RETURN
17000 CONTINUE
        IPHT = IP
        IPA = IP
        IPALST = 0
15002 CONTINUE
      IF(
     - IPA.LT.IP8
     -)THEN
        IPA = IPA + IPD
          IDLAYR = IWRK(IPA) - ILAY0
          DS = WRK(IPA+2)
      IF(
     - IDLAYR.EQ.2
     -)THEN
      IF(
     - IPALST.EQ.0
     -)THEN
              IF(IWRK(IPHT+7).EQ.0) IWRK(IPHT+7) = -1
      GOTO 15003
      ENDIF
            IPHT = IPALST
      IF(
     - IWRK(IPHT+7).GT.0
     -)THEN
      GOTO 15003
      ENDIF
            IPA = IPHT + IPD
            ILAY0 = IWRK(IPHT)
            DS0 = WRK(IPHT+2)
            IDLAYR = IWRK(IPA) - ILAY0
            DS = WRK(IPA+2)
            IPALST = 0
      ENDIF
      IF(
     - IDLAYR.GT.1
     -)THEN
      GOTO 15003
      ENDIF
          DDS = DS-DS0
      IF(
     - ABS(DDS).LT.FLINLM(1)
     -)THEN
      IF(
     - IDLAYR.EQ.1
     -)THEN
      IF(
     - IWRK(IPHT+7).LE.0
     -)THEN
                WRK (IPHT+10) = DDS
                IWRK(IPHT+ 7) = IPA
                IPALST = IPA
      ELSE
                IWRK(IPHT+4) = LOR(IWRK(IPHT+4),32)
      IF(
     - ABS(DDS).LT.ABS(WRK(IPHT+10))
     -)THEN
                  WRK (IPHT+10) = DDS
                  IWRK(IPHT+ 7) = IPA
                  IPALST = IPA
      ENDIF
      ENDIF
      IF(
     - IWRK(IPA+5).EQ.0
     -)THEN
                IWRK(IPA+ 5) = IPHT
                WRK (IPA+ 8) = DDS
      ELSE
                IWRK(IPA +4) = LOR(IWRK(IPA +4), 8)
      IF(
     - ABS(DDS).LT.ABS(WRK(IPA+ 8))
     -)THEN
                  IWRK(IPA+ 5) = IPHT
                  WRK (IPA+ 8) = DDS
      ENDIF
      ENDIF
      ELSE
      IF(
     - IWRK(IPHT+6).EQ.0
     -)THEN
                IWRK(IPHT+ 6) = IPA
                WRK (IPHT+ 9) = DDS
      ELSE
      IF(
     - ABS(DDS).LT.ABS(WRK(IPHT+ 9))
     -)THEN
                  IWRK(IPHT+ 6) = IPA
                  WRK (IPHT+ 9) = DDS
      ENDIF
      ENDIF
      IF(
     - IWRK(IPA+6).EQ.0
     -)THEN
                IWRK(IPA+ 6) = IPHT
                WRK (IPA+ 9) = DDS
      ELSE
      IF(
     - ABS(DDS).LT.ABS(WRK(IPA+ 9))
     -)THEN
                  IWRK(IPA+ 6) = IPHT
                  WRK (IPA+ 9) = DDS
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      GOTO 15002
      ENDIF
15003 CONTINUE
      GOTO IZZZ01
17002 CONTINUE
      IPHT = IP1
16000 CONTINUE
      IF(
     - LAND(IWRK(IPHT+4),40).NE.0
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ENDIF
      IPHT = IPHT + IPD
      IF(.NOT.(
     - IPHT.GT.IP9
     -))GOTO 16000
16001 CONTINUE
      DO 13000 IPHT = IP1,IP9,IPD
        IPAL = IWRK(IPHT+5)
        IPAH = IWRK(IPHT+7)
        DDS = 100000.
      IF(
     - IPAH.GT.0
     -)THEN
      IF(
     - IPAL.GT.0
     -)THEN
            SL = WRK(IPAH+2) - WRK(IPAL+2)
            DDS= WRK(IPAH+2)+WRK(IPAL+2) - WRK(IPHT+2)*2
            LB = 3
            IF(ABS(DDS).LE.FLINLM(2)) LB = 7
      ELSE
            SL = (WRK(IPAH+2) - WRK(IPHT+2)) * 2
            LB = 2
      ENDIF
      ELSE
          IF(IPAH.LT.0) IWRK(IPHT+7) = 0
      IF(
     - IPAL.GT.0
     -)THEN
            SL = (WRK(IPHT+2) - WRK(IPAL+2)) * 2
            LB = 1
      ELSE
            SL = 0
            LB = 0
      ENDIF
      ENDIF
        IF(IWRK(IPHT+6).NE.0) LB = LOR(LB,16)
        WRK (IPHT+ 3) = SL
        IWRK(IPHT+ 4) = LOR(IWRK(IPHT+4),LB)
        WRK (IPHT+ 8) = 0
        WRK (IPHT+ 9) = 0
        WRK (IPHT+10) = 0
        WRK (IPHT+11) = DDS
13000 CONTINUE
13001 CONTINUE
      DO 13002 IPHT = IP1,IP9,IPD
        IPAL = IWRK(IPHT+5)
        IPAH = IWRK(IPHT+7)
        LB   = IWRK(IPHT+4)
      IF(
     - IPAL.GT.0
     -)THEN
          IPALH = IWRK(IPAL+7)
      IF(
     - IPALH.NE.IPHT
     -)THEN
            LB = LOR(LB, 256)
            IWRK(IPALH+4) = LOR(IWRK(IPALH+4), 512)
            IWRK(IPAL +4) = LOR(IWRK(IPAL +4),1024)
      ENDIF
      ENDIF
      IF(
     - IPAH.GT.0
     -)THEN
          IPAHL = IWRK(IPAH+5)
      IF(
     - IPAHL.NE.IPHT
     -)THEN
            LB = LOR(LB, 256)
            IWRK(IPAHL+4) = LOR(IWRK(IPAHL+4), 512)
            IWRK(IPAH +4) = LOR(IWRK(IPAH +4),1024)
      ENDIF
      ENDIF
        IWRK(IPHT +4) = LB
13002 CONTINUE
13003 CONTINUE
      GOTO IZZZ02
17004 CONTINUE
        IPAL = IWRK(IPHT+5)
        IPAH = IWRK(IPHT+7)
      IF(
     - IPAH.GT.0 .AND. IPAL.GT.0
     -)THEN
        DDS = WRK(IPHT+10) - WRK(IPHT+ 8)
      IF(
     - ABS(DDS).GT.FLINLM(2)
     -)THEN
          ILAY0 = IWRK(IPHT)
          DS0 = WRK(IPHT+2)
          DSLM = 100000.
          IPUP = IPHT
15004 CONTINUE
      IF(
     - IPUP.LT.IP8
     -)THEN
          IPUP = IPUP + IPD
      IF(
     - IWRK(IPUP)-ILAY0.GT.0
     -)THEN
      IF(
     - IWRK(IPUP)-ILAY0.GT.1
     -)THEN
      GOTO 15005
      ENDIF
              SLH = WRK(IPUP+2) - DS0
              IPDW = IPHT
15006 CONTINUE
      IF(
     - IPDW.GT.IP1
     -)THEN
              IPDW = IPDW - IPD
      IF(
     - ILAY0-IWRK(IPDW).GT.0
     -)THEN
      IF(
     - ILAY0-IWRK(IPDW).GT.1
     -)THEN
      GOTO 15007
      ENDIF
                  SLL = DS0 - WRK(IPDW+2)
                  DSL = ABS(SLH-SLL)
      IF(
     - DSL.LT.DSLM
     -)THEN
                    DSLM = DSL
                    IPAL = IPDW
                    IPAH = IPUP
      ENDIF
      ENDIF
      GOTO 15006
      ENDIF
15007 CONTINUE
      ENDIF
      GOTO 15004
      ENDIF
15005 CONTINUE
          IWRK(IPHT+ 5) = IPAL
          IWRK(IPHT+ 7) = IPAH
          WRK (IPHT+ 8) = DS0 - WRK(IPAL+2)
          WRK (IPHT+10) = WRK(IPAH+2) - DS0
          IF(IWRK(IPAL+ 7).LE.0)  WRK(IPAL+10) = WRK(IPHT+ 8)
          IF(IWRK(IPAL+ 7).LE.0) IWRK(IPAL+ 7) = IPHT
          IF(IWRK(IPAH+ 5).LE.0)  WRK(IPAH+ 8) = WRK(IPHT+10)
          IF(IWRK(IPAH+ 5).LE.0) IWRK(IPAH+ 5) = IPHT
          DATA IPR /0/
          IPR = IPR + 1
      ENDIF
      ENDIF
      GOTO IZZZ03
      END

C   11/01/87 702191103  MEMBER NAME  ZE4VUN   (S)           FORTRAN77
      SUBROUTINE ZE4VUN( NST, N, IMODE )
C-----------------------------------------------------------
C MODIFIED 17-11-86 M.ZIMMER
C LAST MOD 19-02-87 G.ECKERLIN  (SCIP OF RECONSTR. PART.)
C NEW FORMAT OF BANK INCLUDED
C UNPACK MOMENTA FROM ZE4V INTO VECSUB COMMON
C IMODE = 0 UNCONNECTED LG-CLUSTERS AND PATR
C       = 1 UNCONNECTED LG-CLUSTERS
C       = 2 ALL CLUSTERS AND PATR
C       = 3 ALL CLUSTERS
C       = 4 CHARGED ONLY ( ALL MASSES PI )
C THE PARTICLES ARE STORED IN
C NST+1..NST+N, WHERE N IS SET ON EXIT
C    THE INDIVIDUAL POSITIONS ARE:
C   P( 1..7,*)   PX,PY,PZ,E,M,P,CHARGE
C  HP(15   ,*)   NOT USED
C  HP(16   ,*)   PARTICLE TYPE ( JADE MC-CONVENTION )
C  HP(17   ,*)   PATR NUMBER OF PHOT PARTNER
C  HP(18   ,*)   PART # IN ZE4V BANK
C  HP(19   ,*)   PALL NUMBER
C  HP(20   ,*)   ELECTRON ORIGIN
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON P(10,400)
      DIMENSION IP(10,100),HP(20,1)
      EQUIVALENCE (P(1,1),IP(1,1),HP(1,1))
C
      DIMENSION LADD(-1:2)
C
C                                           PARTICLE TYPES
C         UNKNOWN, GAMMA,   E,    MU,     PI,    K,    P/N,  LAM
      REAL*4 XMAS(8) /
     *     .1396,   0., .511E-3, .1067, .1396, .4937, .939, 1.1156 /

C
      N = 0
      NPZE4V = IW(IBLN('ZE4V'))
      IF( NPZE4V.LE.0 ) GO TO 7000
C                                      PTF-CODE
C                                      -1=LT/0=LTNE/1=LTCH/2=LTRE
      LADD(-1) = HW( NPZE4V*2 + 5 )
      LADD(0) = HW( NPZE4V*2 + 9 ) + LADD(-1)
      LADD(1) = HW( NPZE4V*2 + 7 ) + LADD(-1)
      LADD(2) = HW( NPZE4V*2 + 11) + LADD(-1)
      NT = HW(NPZE4V*2 + 6 )
      NP = NPZE4V + HW( NPZE4V*2 + 1 )
      DO 6200 J=1,NT
            INFO = HW( NP*2 + 18 )
            CHARGE = RW( NP + 7)
            NUMMRN = HW( NP*2 + 13 )
            NUMMEV = HW( NP*2 + 14 )
            IF ( INFO .LT. -1 .OR. INFO .GT. 2 ) THEN
              WRITE (6,*) '------->>>>> INFO  ',INFO,
     &        '    NUMBER OF PARTICLES  ',NT,
     &        '  RUN#  ',NUMMRN,'  EVT#  ',NUMMEV
              RETURN
            ENDIF
            IF( CHARGE.EQ.0. .AND. IMODE.EQ.4 ) GO TO 6100
            IF( CHARGE.NE.0. .AND. IMODE.EQ.3 ) GO TO 6100
            IF( CHARGE.NE.0. .AND. IMODE.EQ.1 ) GO TO 6100
C                                      SCIP RECONSTRUCTED PARTICLES
            IF( HW( NP*2 + 18 ) .EQ. 2 ) GO TO 6100
C                                      SCIP SECONDARIES
CCC         IF( HW( NP*2 + 9 ) .GT. 1 ) GO TO 6100
               N = N + 1
               CALL UCOPY( RW(NP+1), P(1,NST+N), 7 )
               CALL SMUL( NST+N, NST+N, P(6,NST+N) )
               ITYP = HW(NP*2+8)
               P(5,NST+N) = XMAS(ITYP+1)
               P(4,NST+N) = SQRT( P(6,NST+N)**2 + P(5,NST+N)**2 )
               P( 8,NST+N) = 0
               HP(16,NST+N) = HW(NP*2 + 8)
               HP(17,NST+N) = HW(NP*2 + 7)
               HP(18,NST+N) = J
               HP(19,NST+N) = HW(NP*2 +15)
               HP(20,NST+N) = HW(NP*2 +16)
 6100       CONTINUE
            NP = NP + LADD( HW( NP*2 + 18 ))
 6200    CONTINUE
 7000 CONTINUE
      RETURN
C
C
C
      ENTRY ZE4VAX( NAST, NA )
C-----------------------------------------------------------
C UNPACK AXES FROM ZE4V INTO VECSUB COMMON
C STORED:  NAST+1      SPHERICITY AXIS AND VALUE
C          NAST+2      2ND AXIS AND VALUE
C          NAST+3      3RD AXIS AND VALUE
C          NAST+4      THRUST AXIS AND VALUE
C          NAST+5      AKOPLANARITY AXIS AND VALUE
C NA = 4 ON NORMAL RETURN
C-----------------------------------------------------------
C
C
      NA = 0
      NPZE4V = IW(IBLN('ZE4V'))
      IF( NPZE4V.LE.0 ) GO TO 8000
         CALL UCOPY( RW(NPZE4V+ 9), P(1,NAST+1), 4 )
         CALL UCOPY( RW(NPZE4V+13), P(1,NAST+2), 4 )
         CALL UCOPY( RW(NPZE4V+17), P(1,NAST+3), 4 )
         CALL UCOPY( RW(NPZE4V+21), P(1,NAST+4), 4 )
         CALL UCOPY( RW(NPZE4V+25), P(1,NAST+5), 4 )
         NA = 4
 8000 CONTINUE
      RETURN
      END

C   18/05/79 006251731  MEMBER NAME  VERTEX   (JADEGS)      FORTRAN
      SUBROUTINE VERTEX
C*800623*DITTMANN****************************************************
C*                                                                  *
C*             X - Y - Z   V E R T E X   F I T                      *
C*                                                                  *
C*       INPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)            *
C*       ================                                           *
C*       NT    = TOTAL NR OF TRACKS OF EVENT                        *
C*       IT(1) =         FLAG (0 = TRACK INCOMPLETE OR BAD, NOT USED*
C*                             1 = GOOD, BUT DO NOT USE IN VERTEXFIT*
C*                             2 = GOOD)                            *
C*       T( 2) = +-R     RADIUS(+ MEANS ANTICLOCKWISE LOOKING TO -Z)*
C*          3  = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          4  = THETA   POLAR ANGLE TO XY-PLANE(0=VERTICAL TO BEAM)*
C*          5  = XT      .                                          *
C*          6  = YT      . FIRST MEASURED POINT ON TRACK            *
C*          7  = ZT      .                                          *
C*          8  = DPHI    ERROR OF PHI                               *
C*          9  = DTHETA  ERROR OF THETA                             *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         13  = NPT     NUMBER OF POINTS ON TRACK (INTEGER)        *
C*         14  = 0.      NOT USED ON INPUT                          *
C*         15  = 0.      NOT USED ON INPUT                          *
C*         16-30         FOR INTERNAL USE (SEE BELOW)               *
C*        (31-60)        2. TRACK                                   *
C*         .....         ........                                   *
C*                                                                  *
C*       OUTPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)           *
C*       =================                                          *
C*       FOR TRACKS WITH IT(1) GT 0                                 *
C*       IT(1) =         FLAG (3 = TRACK WAS USED IN VERTEXFIT)     *
C*       T( 3) = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          5  = XT      .                                          *
C*          6  = YT      . POINT ON TRACK NEAREST TO VERTEX         *
C*          7  = ZT      .                                          *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         14  = NV      NUMBER OF VERTEX TO WHICH TRACK BELONGS (I)*
C*         15  = S       EXTRAPOLATED ARC LENGTH (USUALLY NEGATIVE) *
C*       ALL OTHER T'S ARE UNCHANGED                                *
C*                                                                  *
C*       NV    = TOTAL NUMBER OF VERTICES                           *
C*       IV(1) =         FLAG (0 = NO VERTEX FIT                    *
C*                             1 = BAD VERTEX FIT                   *
C*                             2 = VERTEX OF 1- OR COLLINEAR 2-PRONG*
C*                             3 = GOOD VERTEX FIT                  *
C*                             4 = E+E- PAIR VERTEX                 *
C*                             5 = ISOLATED SINGLE TRACK VERTEX)    *
C*       V( 2) = X       .                                          *
C*          3  = Y       . VERTEX COORDINATES                       *
C*          4  = Z       .                                          *
C*          5  = DX      .                                          *
C*          6  = DY      . ERROR OF X,Y,Z                           *
C*          7  = DZ      .                                          *
C*       IV(8) = NTR     NUMBER OF TRACKS USED IN VERTEX FIT        *
C*       V( 9) = CHI2    CHISQARE OF FIT (N.D.F. = 2*NTR-3)         *
C*       IV(10)= NTRALL  NUMBER OF TRACKS BELONGING TO THIS VERTEX  *
C*        (11-20)        2. VERTEX                                  *
C*         .....         .........                                  *
C*                                                                  *
C*       INTERNAL PARAMETERS                                        *
C*       ===================                                        *
C*       IT(1) IS SET NEGATIV TEMPORARILY IF TRACK BELONGS TO VERTEX*
C*       T(16) = COULOMB SCATTERING ERROR                           *
C*       T(17) =                                                    *
C*       T(21) = SIN(PHI0)                                          *
C*       T(22) = COS(PHI0)                                          *
C*       T(23) = TAN(THETA)                                         *
C*       T(24) = COS(THETA)                                         *
C*       T(26) = S TO TANKWALL FAR                                  *
C*       T(27) = S TO TANKWALL NEAR                                 *
C*       T(28) = S.D. X                                             *
C*       T(29) = S.D. Y                                             *
C*       T(30) = S.D. Z                                             *
C*                                                                  *
C*       THIS ROUTINE CALLS SUBROUTINE SMINVD FOR SOLVING THE       *
C*       MATRIX EQUATION                                            *
C********************************************************************
      COMMON /CWORK1/ NT,T(1500),NV,V(200),A(55),B(10),NTIND(7),S(7),
     *                CHITR(7)
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
      REAL*8 A,B,DET
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR
C
      IF(NV.LE.0 .OR. NV.GT.20) RETURN
      LV = (NV-1)*10
      IV(LV+1) = 0
      IF(NT.LE.0) RETURN
    1 ITER = 0
      CHI2 = 0.
      ITFIN = 0
C****    CHECK TRACKS
C****    IF MORE THAN 7, REJECT THOSE WITH FEWEST MEASURED POINTS
      N = 0
      J = 0
      DO 5 I=1,NT
      IF(IT(J+1).LE.1) GOTO 5
      N = N + 1
      IF(N.GT.7) GOTO 2
      K = N
      GOTO 4
    2 MINPT = 48
      DO 3 K=1,7
      L = NTIND(K)
      IF(IT(L+13).GE.MINPT) GOTO 3
      IMIN = K
      MINPT = IT(L+13)
    3 CONTINUE
      IF(IT(J+13).LE.MINPT) GOTO 5
      K = IMIN
    4 NTIND(K) = J
      S(K) = 0.
    5 J = J + 30
      IF(N.GT.7) N=7
      NTR = N
      IF(NTR.EQ.0) RETURN
      IF(NTR.EQ.1) GOTO 50
      IF(NTR.NE.2) GOTO 10
C        CHECK IF COLLINEAR 2-PRONG
      J1 = NTIND(1)
      J2 = NTIND(2)
      COSW = T(J1+24)*T(J2+24) * (T(J1+21)*T(J2+21)+T(J1+22)*T(J2+22))
     *     + SIN(T(J1+4))*SIN(T(J2+4))
      COSW = ABS(COSW)
      IF(COSW.GT.COLL2) GOTO 50
C****
C****    VERTEX FIT
   10 CONTINUE
      N = NTR + 3
      L = (N*(N+1))/2
      DO 11 I=1,L
   11 A(I) = 0.D0
      IF(ITFIN.EQ.1) GOTO 13
      DO 12 I=1,N
   12 B(I) = 0.D0
   13 DO 19 I=1,NTR
      J = NTIND(I)
      N = I + 3
      L = (N*(N-1))/2
      PHI = T(J+3) + S(I)/T(J+2)
      SPHI = SIN(PHI)
      CPHI = COS(PHI)
      XT = T(J+5) + T(J+2)*(SPHI-T(J+21))
      YT = T(J+6) - T(J+2)*(CPHI-T(J+22))
      ZT = T(J+7) + S(I)*T(J+23)
      SSPACE = S(I)
      SSCOUL = S(I)-T(J+27)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      DXY = T(J+10)**2 + (T(J+8)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DZ = (T(J+9)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(DXY))
      DDX = 1. / DXY
      IF(DDX.LT.DXYLIM) DDX=DXYLIM
      DDY = 1. / DXY
      IF(DDY.LT.DXYLIM) DDY=DXYLIM
      DDZ = 1. / (T(J+12)**2 + DZ/(T(J+24)**2)**2)
      IF(ITFIN.EQ.0) GOTO 15
      IT(J+1) = 3
      DDX = DDX * SPHI**2
      DDY = DDY * CPHI**2
      CHITR(I) = DDX*(XT-B(1))**2 + DDY*(YT-B(2))**2+ DDZ*(ZT-B(3))**2
      CHI2 = CHI2 + CHITR(I)
      GOTO 16
   15 B(1) = B(1) + XT*DDX
      B(2) = B(2) + YT*DDY
      B(3) = B(3) + ZT*DDZ
      B(N) = - XT*CPHI*DDX - YT*SPHI*DDY - ZT*T(J+23)*DDZ
   16 A(1) = A(1) + DDX
      A(3) = A(3) + DDY
      A(6) = A(6) + DDZ
      A(L+1) = -CPHI*DDX
      A(L+2) = -SPHI*DDY
      A(L+3) = -T(J+23)*DDZ
      A(L+N) = CPHI**2*DDX + SPHI**2*DDY + T(J+23)**2*DDZ
   19 CONTINUE
      IF(ITFIN.EQ.1) GOTO 30
C        SOLVE MATRIX EQUATION
      CALL SMINVD(A,B,N,1,DET)
      IF(DET.EQ.0.0) GOTO 100
      DSUM = 0.
      DO 23 I=1,NTR
      J = NTIND(I)
      DS = B(I+3)
      IF(ABS(DS/T(J+2)).GT.1.5) GOTO 25
      DSUM = DSUM + ABS(DS)
   23 S(I) = S(I) + DS
      ITER = ITER + 1
      IF(ITER.LT.MITER .AND. DSUM.GT.DSCONV) GOTO 10
C        FIT FINISHED, REPEAT ONCE MORE WITH PROPER ERRORS
      ITFIN = 1
      GOTO 10
C        EXTRAPOLATION OF TRACK I EXCEEDS 90 DEG
C        REMOVE TRACK AND RESTART IF MORE THAN ONE LEFT
   25 IF(NTR.LE.2) GOTO 100
      IT(J+1) = 1
      GOTO 1
   30 CALL SMINVD(A,DUMMY,N,0,DET)
      IF(A(1).LT.0.0 .OR. A(3).LT.0.0 .OR. A(6).LT.0.0) GOTO 100
      NDF = 2*NTR - 3
      PR = PROB(CHI2,NDF)
      IV(LV+1) = 1
      IF(PR.GT.PRCUT) IV(LV+1)=3
      V(LV+2) = B(1)
      V(LV+3) = B(2)
      V(LV+4) = B(3)
      V(LV+5) = DSQRT(A(1))
      V(LV+6) = DSQRT(A(3))
      V(LV+7) = DSQRT(A(6))
      IV(LV+8) = NTR
      V(LV+9) = CHI2
      IF(IREJTR.EQ.0) GOTO 100
      IF(IV(LV+1).EQ.3) GOTO 100
      IF(NTR.LE.2) GOTO 100
C        BAD CHISQARE
C        CHECK IF THERE IS ONE TRACK WHICH CONTRIBUTES MOST TO CHI2
      CHIMAX = 0.
      DO 32 I=1,NTR
      IF(CHITR(I).LT.CHIMAX) GOTO 32
      CHIMAX = CHITR(I)
      NTMAX = I
   32 CONTINUE
      CHICUT = 3. / NTR
      IF(CHICUT.GT..9) CHICUT=.9
      CHICUT = CHICUT * CHI2
      IF(CHIMAX.LT.CHICUT) GOTO 100
      J = NTIND(NTMAX)
      IT(J+1) = 1
      GOTO 1
C****
C****    1-PRONG OR COLLINEAR 2-PRONG
   50 IV(LV+1) = 2
      J = NTIND(1)
      CALL VTXPNT(J,XB,YB,XT1,YT1,ZT1,DXT21,DYT21,DZT21,PHIT,ST)
      IT(J+1) = 3
      IF(NTR.EQ.2) GOTO 52
      V(LV+2) = XT1
      V(LV+3) = YT1
      V(LV+4) = ZT1
      V(LV+5) = SQRT(DXT21)
      V(LV+6) = SQRT(DYT21)
      V(LV+7) = SQRT(DZT21)
      IV(LV+8) = 1
      V(LV+9) = 0.
      IV(LV+10) = 1
      GOTO 100
   52 J = NTIND(2)
      CALL VTXPNT(J,XB,YB,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT,ST)
      IT(J+1) = 3
      V(LV+2) = (XT1+XT2)/2.
      V(LV+3) = (YT1+YT2)/2.
      V(LV+4) = (ZT1+ZT2)/2.
      V(LV+5) = SQRT((DXT21+DXT22)/2.)
      V(LV+6) = SQRT((DYT21+DYT22)/2.)
      V(LV+7) = SQRT((DZT21+DZT22)/2.)
      IV(LV+8) = 2
      V(LV+9) = 0.
      IV(LV+10) = 2
      SDXY1 = SQRT(((XT1-V(LV+2))**2/DXT21 + (YT1-V(LV+3))**2/DYT21)/2.)
      IF(SDXY1.GT.3.) IV(LV+1)=1
      SDXY2 = SQRT(((XT2-V(LV+2))**2/DXT22 + (YT2-V(LV+3))**2/DYT22)/2.)
      IF(SDXY2.GT.3.) IV(LV+1)=1
      SDZ1 = ABS(ZT1-V(LV+4))/SQRT(DZT21)
      IF(SDZ1.GT.3.) IV(LV+1)=1
      SDZ2 = ABS(ZT2-V(LV+4))/SQRT(DZT22)
      IF(SDZ2.GT.3.) IV(LV+1)=1
C
  100 RETURN
      END

C   09/10/85            MEMBER NAME  MUANAC   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUANAC
C-----------------------------------------------------------------------
C
C LAST CHANGE 15.40  8/10/85 CHRIS BOWDERY - EXPAND HC AND HLUN ARRAYS
C      CHANGE 23.30 29/09/84 CHRIS BOWDERY - CALIBRATION CHECKING CODE
C      CHANGE 12.00  9/03/84 CHRIS BOWDERY - NEW MUCOOR DATE.
C      CHANGE 10.00 13/01/84 CHRIS BOWDERY - NEW MUCOOR DATE.
C      CHANGE 12.00 25/10/83 HUGH MCCANN   - NEW MUCOOR DATE.
C      CHANGE 11.00 16/03/83 HUGH MCCANN   - NEW MUCOOR DATE.
C
C-----------------------------------------------------------------------
C
C        THIS IS THE  FIRST  ROUTINE  OF  THE  MUON  ANALYSIS  CHAIN.IT
C        CONVERTS THE THE MUON RAW DATA (IBM FORMAT) TO COORDINATES AND
C        STORES THEM, AND OTHER INFORMATION, IN 'MUR1' BANKS 0,1,AND 2.
C        (FOR DESCRIPTION OF BANKS SEE @MUINFOM).
C
C        NOTE BANK 0 IS CREATED EVEN IF THERE ARE NO MUON HITS.
C
C        THERE ARE 2 SIGNAL TO COORDINATE CONVERSION ROUTINES...
C
C    1)  MUTINY, WHICH USES  A  CONDENSED  SET  OF  CALIBRATION  DATA
C        PREPARED BY MUCONT (FOR MONTE  CARLO  OUTPUT  -  SEE  MCJADE),
C        WHICH CALLS A VERSION OF MUDOWN.
C
C    2)  MUCOOR, WHICH USES THE FULL MUON CALIBRATION DATA PREPARED BY
C        MUCON (FOR MONTE CARLO OUTPUT - SEE MCJADE).
C
C HMU IS THE RAW MU DATA.
C LMU IS THE LENGTH OF THE RAW DATA BANK MEASURED IN I*4 WORDS.
C
C HC IS THE MU COORDINATE OUTPUT ARRAY IN 9'S.....
C               WORD  1     -  4*CHAMBER NUMBER + (HIT NUMBER -1).
C               WORD  2     -  10*LAYER NUMBER + ORIENTATION PARAMETER.
C               WORDS 3 - 8 -  X,Y,Z(LEFT),X,Y,Z(RIGHT) (MM).
C               WORD  9     -  POINTER TO RAW DATA
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            COMMONS.
C
#include "cmubcs.for"
#include "cmucalib.for"
C
      COMMON /CWORK/ HC(3600),HLUN(400)
C
C                            DATA INITIALISATION STATEMENTS.
C
C                            NWHIT IS NO. OF WORDS PER HIT
      DATA NWHIT/9/
C
C                            NHITMX  IS  THE  MAXIMUM   NO.   OF   HITS
C                            CONVERTED.
      DATA NHITMX/400/
C
C------------------  C O D E  ------------------------------------------
C
C                            FIND MUON DATA BANK POINTER.
C
      IPMU = IDATA(IBLN('MUEV'))
      IF( IPMU .NE. 0 ) GO TO 1
C
C                            NO MUON BANK PRESENT.
      NHITS = 0
      GO TO 2
C
C                            CHECK THE CALIBRATION TO SEE IF MISSING
C                            IF 2 CONSTANTS ARE ZERO, THEN NO CALIB.
C
  1   IF( IZOEP1 .EQ. 0  .AND.  IZOEP3 .EQ. 0 ) GO TO 95
C
C
C                            CALL MUCOOR TO GET COORDINATES, ETC.
C
      CALL MUCOOR(IDATA(IPMU+1),NHITS,HC(1),NHITMX,IDATA(IPMU),HLUN(1),
     +            NWHIT)
C-----------------------------------------------------------------------
C
C                            CREATE 'MUR1' BANK 0 - MUON GENERAL INFO
C
 2    CONTINUE
C                            ADD  'MUR1'  TO  SPECIAL  LIST  READY  FOR
C                            WRITING.
      CALL BSAW(1,'MUR1')
      IBANK=0
      CALL CCRE(IP0,'MUR1',IBANK,9,IER)
      IF(IER.NE.0)GO TO 96
C                            NO. OF HITS.
      IDATA(IP0+1) = NHITS
C                            NO. OF I*2 WORDS  PER  HIT  IN  COORDINATE
C                            BANK.
      IDATA(IP0+3) = NWHIT
C                            DATE OF VERSION OF MUCOOR  WHICH  PRODUCES
C                            COORDINATES.
      IDATA(IP0+8) = 840929
C                            CALIBRATION DATA ISSUE.
      IDATA(IP0+9) = NVERSN
C
C-----------------------------------------------------------------------
C
C                            CREATE 'MUR1' BANK  1  -  MUON  COORDINATES
C
      IF(NHITS.LE.0)GO TO 98
      LB1=(NWHIT*NHITS+1)/2
      IBANK=1
      CALL CCRE(IP1,'MUR1',IBANK,LB1,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(HC(1),IDATA(IP1+1),LB1)
C
C
C-----------------------------------------------------------------------
C
C                            CREATE 'MUR1' BANK 2 - HIT STATUS BANK.
C
      IF(NHITS.LE.0) RETURN
      LB2=(NHITS+1)/2
      IBANK=2
      CALL CCRE(IP2,'MUR1',IBANK,LB2,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(HLUN(1),IDATA(IP2+1),LB2)
C
      RETURN
C
C-----------------------------------------------------------------------
C
C                            ERROR CONDITIONS.
C
 95   CALL MUERRY('MUANAC',0,'WARNING: NO CALIBRATION FOUND. IF MC DATA,
     + WAS EVREAD USED TO PROCESS CALIB. RECORDS? MUCOOR NOT CALLED.^')
      RETURN
C
 96   IF( IER .GT. 1 ) GO TO 97
      CALL MUERRY('MUANAC',IBANK,'''MUR1'' ALREADY PRESENT.^')
      RETURN
C
 97   CALL MUERRY('MUANAC',IBANK,'NOT ENOUGH SPACE FOR ''MUR1''.^')
      RETURN
C
 98   IF( IPMU .NE. 0 ) RETURN
      CALL MUERRY('MUANAC',0,' WARNING: MUEV BANK NOT LOCATED.^')
      RETURN
C
      END

C   06/02/87            MEMBER NAME  TPTGCY   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE TPTGCY( ITRACK, IB, IW, AW, HW )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery        6/02/87:  Copy TAGG/2 track to IW array
C
C     Based on routine by Y. Watanabe 29/08/79
C
C     Routine to copy information about one tagging cluster to a work
C     array IW.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     ITRACK   In        I*4      Current TAGG track/cluster
C     IB       In        I*4      Pointer into TAGG/2 bank
C     IW            Out  I*4      Filled work array
C     AW            Out  R*4      Filled work array equivalenced to IW
C     HW            Out  I*2      Filled work array equivalenced to IW
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      PARAMETER  ( NW = 40, NW2 = 2*NW )

#include "bosdata.for"

      COMMON / CLGPRM / ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX,DZVRTX

      DIMENSION  IW( NW ), AW( NW ), HW( NW2 )

C------------------  C O D E  ------------------------------------------

      HW(1)  = 1
      HW(3)  = 1
      HW(5)  = 0
      HW(13) = ITRACK

C                            HW(17) = 2 or 20      set in TPTGT1  <----

      AW(12) = ZVRTX
      AW(15) = DZVRTX

      AW(23) = 100.0

C                            Charge is not determined.   Set to 100.

      AW(24) = ADATA( IB + 5 )
      AW(25) = ADATA( IB + 6 )

C                            Direction

      IW(26) =  1
      AW(27) = ADATA( IB + 11 )
      AW(28) = ADATA( IB + 12 )
      AW(29) = ADATA( IB + 13 )

C                            Unknown particles

      HW(68) = 0
      AW(35) = 0.14

C                            Check if edge blocks (implemented?)

      HW(77) = 2
      IF( HDATA( IB*2 + 6 ) .GT. 500 ) HW(77) = 1

C                            Energy

      AW(36) = AW(24)
      AW(37) = AW(36)
      AW(38) = AW(25)

      RETURN
      END

C   26/01/79 002210634  MEMBER NAME  LGDCPY   (SOURCE)      FORTRAN
      SUBROUTINE LGDCPY( NP, LGER1)
C
C     S.YAMADA     26-01-79  17:30
C     LAST MODIFICATION  15-10-79  23:20 Y.WATANABE
C
C---- VERSION FOR BOS DATA.  COMPATIBLE WITH THE FINAL NORD-DATA-FORMAT
C
C---- COPIES RAW DATA FROM 'ALGN' TO /CWORK/.
C     BOTH FORMAT CONVERSION AND CALIBRATION ARE SUPPOSED TO BE DONE.
C
C---- OUTPUT:   NP=THE POINTER TO THE 'ALGN'-BANK.
C               LGER1=ADDITIVE ERROR CODE,(=0 IF NO ERROR)
C                    +1  NO CALIBRATION
C                    +2  BUFFER OVERFLOW
C                    +1024  NO REFORMATTING
C
      IMPLICIT INTEGER *2 (H)
#include "cdata.for"
C
#include "clgwork1.for"
C
      COMMON /CLGMSB/ MESVAL(2)
      COMMON/ CLGVRN/ NVRSN(20)
C
      DATA NVCODE/279021615/
      DATA INITP/0/
      IF(INITP.GT.0) GO TO 5
      INITP=1
      IP= IBLN('ALGN')
5     CONTINUE
      NVRSN(1) = NVCODE
C
C---- LOOK FOR THE POINTER OF THE LG-DATA
      LNG = 0
      LGER1 = 0
C     CALL CLOC( NP, 'ALGN',1 )
      NP=IDATA(IP)
      IF(NP.LE.0) GO TO 300
C
C---- FOR THE INPUT DATA
C----        IDATA(NP)=# OF DATA IN HDATA INCLUDING SUB-POINTERS
C                        AND THE NORD-STATUS WORD.
      LNG = IDATA(NP)
      NNP = NP+NP
C
C---- CALIBRATION CHECK
      IF(HDATA(NNP+2).GT.0) GO TO 1
      LGER1 = 1
      MESVAL(2) = HDATA(NNP+2)
    1 CONTINUE
C
C---- EXAMINE IF FORMAT CHANGE IS ALREADY DONE. EXAMINE POINTERS
C
      IF(HDATA(NNP+3).NE.1) GO TO 92
      IPO = 1
        DO 2 K=1,3
        IPK = HDATA(NNP+K+3)
        IF(IPK.LT.IPO) GO TO 92
        IF(MOD(IPK,2).NE.1) GO TO 92
        IPO = IPK
    2   CONTINUE
      IF((IPO-1)/2+3.NE.LNG) GO TO 92
C
C---- FORMAT IS ALREADY CHANGED.
C     DATA IS SIMPLY COPIED  AFTER THE LENGTH CHECK.
  200 LNGC = 4*LNG
      IF(LNGC.LE.11532) GO TO 201
      LNGC = 11532
  201 CALL MVCL(HNORD,0,HDATA,4*NP,LNGC)
      IF(2883-LNG) 91,900,900
C
C
C---- CREATE TEMPORARY 'ALGN'/1
  300 LNG = 3
      HNORD = 0
      HNORML = 0
      LGER1 = 1024
        DO 301 K=1,4
  301   HPOINT(K) = 1
      CALL BCRE(NP,'ALGN',1,LNG,&93,IER)
      CALL BSAW(1,'ALGN')
      CALL BSTR( NP, HNORD, LNG)
      GO TO 100
C
   93 MESVAL(1) = IER
      CALL LGMESG( 3,2)
      GO TO 100
C
C
C---- ERRORS
C
C---- TOO MANY HITS
   91 LGER1 = LGER1+2
        DO 3 K=2,4
        IF( HPOINT(K).GT.5761 ) HPOINT(K) = 5761
    3   CONTINUE
      GO TO 900
C
C---- NO FORMAT CONVERSION HAS BEEN DONE.
   92 LGER1 = LGER1+1024
C
  900 IF(LGER1.EQ.0) GO TO 100
  901 MESVAL(1) = LGER1
      CALL LGMESG( 3, 1)
C
  100 RETURN
      END

C   24/06/80 101072233  MEMBER NAME  KALIB2                 FORTRAN
      SUBROUTINE KALIB2
C     JUST CALL KALIBR WITH THE BLOCK DATA ATTACHED.
C     CODED ON 18.8.80 BY Y.WATANABE
C
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
      DATA INIT/0/,HRAN/0/
C
      IF(INIT.GT.0) GO TO 10
          IPHD = IBLN('HEAD')
      INIT=1
C
10        NPHD = IDATA(IPHD)
          IF(NPHD.LE.0) RETURN
          NHPHD = NPHD+NPHD
          HEXP=HDATA(NHPHD+ 9)
          HRUN=HDATA(NHPHD+10)
      IF(HRUN.LE.0) RETURN
      IF(HRUN.EQ.HRAN) RETURN
C       IF EQ ALREADY INITIALIZED FOR THE RUN.
      HRAN=HRUN
      CALL KALIBR
      RETURN
      END
      SUBROUTINE MUREG(DUMMY)
      RETURN
      END
C
      BLOCK DATA
      COMMON /CTLIM/ ISECLF
      COMMON/CBSTR/MODE
#include "ciouni.for"
      DATA ISECLF/2/
      DATA MODE/2/
      DATA NCALI/2/
      DATA KUNITA/23,24,8*0/
      DATA LUNITA/21,22,8*0/
      COMMON /CUNIT/ LUNMUC,LUNMUE,LUBADC
      COMMON /CALTEM/ICALUN,CALJET(4,1536)
#include "cgraph.for"
      DATA NDDINN,NDDOUT,MAXREC,IREADM,LABEL/3*0,1,0/
      DATA FREEZE/30*.FALSE./,JUSCRN/6/,LASTVW/0/,IPSVAR/1/
      DATA DSPDTL/6*.TRUE.,2*.FALSE.,.TRUE.,21*.FALSE./
      DATA LSTCMD/1/,LUNMUC,LUNMUE,LUBADC /10,11,13/,ICALUN/10/
      END
      BLOCKDATA
C  *--------------------------------------------------------
C  *  VERSION OF 09/10/78
C  *--------------------------------------------------------
C
      COMMON / CJCELL / NCELL(3),
     *                  NWIRES(3)
C       NCELL = NUMBER OF CELLS PER CHAMBER
C       NWIRES = NUMBER OF WIRES PER CELL
      DATA NCELL /24,24,48/
      DATA NWIRES /16,16,16/
C
#include "cjdrch.for"
C  ARRAY ABERR(8) SET TO MC VALUES, OVERWRITTEN BY KALIBR FOR REAL DATA
C                                                 J.OLSSON  17.9.80
C--------- END OF MACRO CJDRCH ------------
C       RDEC = MEAN RADII OF CHAMBER WALLS
C       PSIIN = ANGULAR INCREMENT OF FIRST WIRE LINE.
C       FIRSTW =  RADII OF FIRST MAIN POTENTIAL WIRES IN EACH RING
C       FSENSW =  RADII OF FIRST SENSE WIRES IN EACH RING
C       RINCR = DISTANCE BETWEEN TWO POTENTIAL WIRES
C       RDEPTH = DIFFERENCE OF TWO CHAMBER RADII
C       SWEDPL = WIRE STAGGERING, .GT.0 MEANS IN POS PHI FOR ZEROTH WIRE
C       YSUSPN = MAXIMUM VERTICAL DEPLACEMENT OF WIRE DUE TO GRAVITATION
C       TIMDEL = RESOLUTION IN EACH CHAMBER IN MM.
C       ZMAX = SENSITIVE HALF LENGTH OF WIRES
C       ZOFFS = OFFSET OF WIRES
C       ZRESOL = RESLUTION IN Z
C       ZNORM, ZAL, ZSCAL = PARAMETERS FOR CALCULATION OF Z - AMPLITUDES
C       DRIDEV, DRICOS, DRISIN = TILT ANGLE, COS, SIN
C       PEDES = OLD OVERALL Z AMPLIFIER PEDESTAL. UNUSED.
C       TZERO(3) = OVERALL DRIFT TIME ZEROES FOR EACH OF THE THREE JET
C               CHAMBER RINGS.
C       TOFIX(3) = TEMPORARY TZEROS FOR TOF AND PROP.TIME CORRECTIONS IN
C               PATTERN RECOGNITION
C       ABERR(8) = ABERRATION CORRECTION CONSTANTS USED IN FXYZ,JETXYZ
C       DRIROT(96,2),SINDRI(96,2),COSDRI(96,2) INDEPENDENT LORENTZ
C       ANGLES FOR THE 96 JET CHAMBER CELLS AND TWO DRIFT DIRECTIONS
C       AND THE CORRESPONDING SINES AND COSINES.
      DATA RDEC /196., 396.4 , 596.4, 797.33 /
      DATA PSIIN / 0.1309 , 0.1309 , 0.065450 /
      DATA FIRSTW / 206., 416., 627.33 /
      DATA FSENSW / 211., 421., 632.33 /
      DATA RINCR /10., 10., 10. /
      DATA RDEPTH / 200.4 /
      DATA SWDEPL / 0.20 /
      DATA YSUSPN / 0.07 /
      DATA TIMDEL / 6*0.35 /
      DATA ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL
     *          / 1180., -10., 1., 1000., 2687., 10. /
      DATA DRIDEV /0.349066 /,
     *     DRICOS /0.939693 /,
     *     DRISIN /0.342020 /
      DATA PEDES /50./
      DATA TZERO /3*0./
      DATA DRIROT/192*0.349066/
      DATA SINDRI/192*0.342020/
      DATA COSDRI/192*0.939693/
      DATA T0FIX /0.65, 0.71, 0.76/
      DATA ABERR / 0., 5., 5., 2.5,0.,0., 99999.,0./
      DATA DUMJDC /20*0./
C
C     COMMON / CJIONI / POTBEA, ZAROBE,
C    *                  POTTRI, ZAROTR,
C    *                  POTIVE, ZAROIV,
C    *                  POTRH0, ZAROR0,
C    *                  POTJET, ZAROJE,
C    *                  POTRH1, ZAROR1,
C    *                  POTRH2, ZAROR2,
C    *                  POTRH3, ZAROR3,
C    *                  POTOVE, ZAROOV,
C    *                  POTTOF, ZAROTO,
C    *                  POTVES, ZARVES,
C    *                  POTZJL, ZAROJL,
C    *                  POTZJR, ZAROJR
C       GIVES AVERAGE IONISATION POTENTIAL AND VALUE FOR Z*RHO/A FOR
C       BETHE BLOCH FORMULA FOR : BEAMPIPE, BEAM PIPE COUNTER, INNER
C       VESSEL WALL, 4 DIFFERENT ROHACELL LAYERS, DRIFTGAS , OUTER
C       VESSEL WALL, TOF COUNTER, VESSEL WALL IN Z, LEFT AND RIGHT
C       ALU SUPPORTS FOR WIRES AND ROHACELL
C     DATA POTBEA,ZAROBE        / 213.,1.3      /
C     DATA POTTRI,ZAROTR        / 36.1,.59      /
C     DATA POTIVE,ZAROIV        / 213.,1.3      /
C     DATA POTRH0, ZAROR0       / 102., 0.11 /
C     DATA POTJET,ZAROJE        / 284.4,.00295   /
C     DATA POTRH1,ZAROR1        / 102.,.07     /
C     DATA POTRH2,ZAROR2        / 102.,.07     /
C     DATA POTRH3, ZAROR3       / 102. , .09  /
C     DATA POTOVE,ZAROOV        / 213.,1.3     /
C     DATA POTTOF,ZAROTO        / 36.1,.59      /
C     DATA POTVES,ZARVES        / 213.,1.3     /
C     DATA POTZJL, ZAROJL       / 213., 1.3       /
C     DATA POTZJR, ZAROJR       / 213., 1.3       /
C
C
C     COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
C     LOGICAL  ELOSS, MULSC
C       ITIMOD DETERMINES TYPE OF DRIFT TIME CALCULATION ( SEE JDTIM )
C       MULSC           IF TRUE MULTIPLE SCATTERING IS INCLUDED
C       ELOSS           IF TRUE ENERGY LOSS IS INCLUDED
C     DATA ITIMOD, MULSC, ELOSS / 1 , .TRUE., .TRUE. /
C
      COMMON / CJTRIG / PI, TWOPI
      DATA  PI, TWOPI / 3.141593, 6.283185 /
C
C     GEOMETRICAL CONST
C
#include "cgeo1.for"
C
C      BKGAUS = MAGNETIC FIELD IN KGAUSS
C      RPIP   = RADIUS OF BEAM PIPE
C      DRPIP, XRLPIP = THICKNESS OF BEAM PIPE IN MM AND RADL
C      RBPC   = RADIUS OF BEAM PIPE COUNTERS
C      DRBPC, XRLBPC = THICKNESS OF BEAM PIPE COUNTERS IN MM AND RADL
C      RITNK = INNER RADIUS OF THE TANK
C      DRITNK, XRLTKI = THICKNESS OF INNER TANK WALL IN MM AND RADL
C      R0ROH  = RADIUS OF ZEROTH ROHACELL SUPPORT
C      DR0ROH, XR0ROH = THICKNESS OF ZEROTH ROHACELL SUPPORT ( MM,RADL )
C      R1ROH  = RADIUS OF FIRST ROHACELL SUPPORT
C      DR1ROH, XR1ROH = THICKNESS OF FIRST ROHACELL SUPPORT ( MM, RADL )
C      R2ROH  = RADIUS OF SECOND ROHACELL SUPPORT
C      DR2ROH, XR2ROH = THICKNESS OF SECOND ROHACELL SUPPORT ( MM, RADL)
C      R3ROH  = RADIUS OF THIRD ROHACELL SUPPORT
C      DR3ROH, XR3ROH = THICKNESS OF THIRD ROHACELL SUPPORT ( MM, RADL)
C      ROTNK = OUTER RADIUS OF THE TANK
C      DROTNK, XRTKO  = THICKNESS OF OUTER TANK WALL ( MM, RADL )
C      RCOIL  = RADIUS OF COIL
C      DRCOIL, XRCOIL = THICKNESS OF COIL IN MM AND RADL
C      ZJM = Z COORDINATE OF ALU SUPPORT FOR ROHACELL ( - Z )
C      DZJM,XRZJM = THICKNESS IN MM AND RADL
C      ZJP = Z COORDINATE OF ALU SUPPORT FOR ROHACELL ( + Z )
C      DZJP,XRZJP = THICKNESS IN MM AND RADL
C      ZTKM = Z COORDINATE OF TANK WALL FOR INNER DETECTOR ( - Z )
C      DZTKM,XRZTKM = THICKNESS IN MM AND RADL
C      ZTKP = Z COORDINATE OF TANK WALL FOR INNER DETECTOR ( + Z )
C      DZTKP,XRZTKP = THICKNESS IN MM AND RADL
C      ZTOFPL = MAX Z COORDINATE COVERED BY TOF COUNTERSAT +Z
C      ZTOFMI = MAX Z COORDINATE COVERED BY TOF COUNTERSAT -Z
C      ZBPPL  = MAX Z COORDINATE OF BEAM PIPE COUNTERS AT +Z
C      ZBPMI  = MAX Z COORDINATE OF BEAM PIPE COUNTERS AT -Z
C      XRJETC = RADL OF CHAMBER GAS IN MM ( NOT THICKNESS OF GAS!! )
C
      DATA BKGAUS / 5. /
      DATA RPIP, DRPIP, XRLPIP       / 123.,  5.3, 0.05 /
      DATA RBPC, DRBPC, XRLBPC       / 150., 10., 0.02 /
      DATA RITNK, DRITNK, XRLTKI     / 165.,  7., 0.08 /
      DATA R0ROH, DR0ROH, XR0ROH     / 181., 15., 0.008/
      DATA R1ROH, DR1ROH, XR1ROH     / 376., 30.,0.011/
      DATA R2ROH, DR2ROH, XR2ROH     / 586., 30.,0.011/
      DATA R3ROH, DR3ROH, XR3ROH     / 799.04, 25., 0.008 /
      DATA ROTNK, DROTNK, XRLTKO     / 847., 12., 0.14 /
      DATA RTOF, DRTOF, XRTOF        / 920., 20., 0.05 /
      DATA RCOIL, DRCOIL, XRCOIL     / 950., 90., 1.   /
      DATA ZJM , DZJM, XRZJM         / -1180., -5., 0.06 /
      DATA ZJP , DZJP, XRZJP         / 1180.,  5., 0.06 /
      DATA ZTKM,DZTKM,XRZTKM         / -1470.,  -7., 0.08 /
      DATA ZTKP,DZTKP,XRZTKP         / 1470.,  7., 0.08 /
      DATA ZTOFPL,ZTOFMI        /1615.,-1615./
      DATA ZBPPL,ZBPMI          / 750.,-750. /
      DATA XRJETC               / 29910.        /
C
C      LEAD GLASS DATA
C
C
C      RLG = INNER RADIUS OF LEAD GLASS ARRAY
C      ZLGPL,ZLGMI = MAXIMUM Z-COMPONENT OF CENTRAL LEAD GLASS ARRAY
      DATA RLG,ZLGPL,ZLGMI/1100.,1696.,-1696./
C
C      OUTR2 = (RLG + BLDEP)
C      CTLIMP = COS THMAX FOR PARTICLES HITTING THE CENTRAL LGARR
C      CTLIMM = COS THMAX FOR PARTICLES HITTING THE CENTRAL LGARR
      DATA OUTR2,CTLIMP,CTLIMM/1400.,0.839,-0.839/
C
C      DELFI = ANGULAR INCREMENT CORRESPONDING TO ONE BLOCK
C      BLXY  = DIMENSION OF ONE LEAD GLASS BLOCK IN XY DIRECTION
C      BLZ   = DIMENSION OF ONE LEAD GLASS BLOCK IN Z DIRECTION
C      BLDEP = DEPTH OF A LEAD GLASS BLOCK
C      BLFI = DIMENSION OF A BLOCK IN PHI
      DATA DELFI,BLXY,BLZ,BLDEP,BLFI/0.0748,140.,106.,300.,82.28/
C
C      ZENDPL = Z COORDINATE FOR END CAP LG FACE AT +Z
C      ZENDMI = Z COORDINATE FOR END CAP LG FACE AT -Z
C      DEPEND = DEPTH OF LG COUNTER END CAP
      DATA ZENDPL,ZENDMI,DEPEND/1514.,-1514.,226./
C
C      XHOL1,XHOL2  PARAMETRES FOR HOLE AROUND PIPE
C      YHOL1,YHOL2  PARAMETERS FOR HOLE AROUND PIPE
      DATA XHOL1,XHOL2/140.,320./
      DATA YHOL1,YHOL2/140.,320./
C
C
      END

C   07/09/84 508191705  MEMBER NAME  FITTYP   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FITTYP( IPATR, IFIT )
C-----------------------------------------------------------------------
C
C   AUTHOR:    C. BOWDERY      7/09/84 : DETERMINE FIT USED IN PATR BANK
C
C        MOD:  C. BOWDERY     27/06/85 : NEW ALGORITHM
C   LAST MOD:  C. BOWDERY     19/08/85 : IFIT TYPES WERE REVERSED.
C
C    IPATR  IS POINTER TO THE PATR BANK
C    IFIT = 0  ON RETURN IF FIT IS UNKNOWN
C         = 1  ON RETURN IF FIT IS ELSEN'S HELIX FIT
C         = 2  ON RETURN IF FIT IS PARABOLIC
C
C    METHOD:  EXAMINE THE NUMBER OF WORDS PER TRACK  (WORD 3 OF PATR)
C             48 = PARABOLA FIT (STEFFEN)
C             62 = HELIX FIT    (ELSEN)
C-----------------------------------------------------------------------
C
      IMPLICIT  INTEGER*2 (H)
C
#include "cdata.for"
C
C------------------  C O D E  ------------------------------------------
C
      LTR  = IDATA( IPATR + 3 )
C
      IFIT = 0
      IF( LTR .EQ. 62 ) IFIT = 1
      IF( LTR .EQ. 48 ) IFIT = 2
C
      RETURN
      END

C   12/03/84 412041824  MEMBER NAME  TAGSET   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE TAGSET(IMARK)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS IS A SPECIAL ROUTINE PROVIDED FOR USERS TO FORCE
C ANALYSIS ROUTINES TO USE A PARTICULAR ANALYSIS - I.E.
C MARK 1 OR 2 OF TAGGTP WHEN NOT USING THE TAGAN ROUTINE
C
C IMARK - INPUT - REQUIRED MARK OF TAGGER
C                 MARK 1 = PRE 1981
C                 MARK 2 = 1981/2
C                 MARK 3 = 1983 ONWARDS
C
C A.J.FINCH 6/3/83
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
#include "cwktag.for"
C
      MARK = IMARK - 1
      IF(MARK.EQ.1)RETURN
      IF(MARK.EQ.2)RETURN
      WRITE(6,600)
600   FORMAT(' WARNING - VALUE OF MARK PROVIDED TO TAGSET IS
     1ILLEGAL THIS IS PROBABLY DISASTEROUS   ')
      RETURN
      END

C   07/02/87 809301223  MEMBER NAME  TPTOFA   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTOFA
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       7/02/87:  Call TOF analysis
C
C          mod: C. Bowdery      16/12/87:  & replaced by *
C          mod: C. Bowdery       1/02/88:  No analysis if only PATR/12
C     Last mod: C. Bowdery      29/09/88:  CALL TPSEFL
C
C     Routine to call for TOF analysis if user options request it.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  ANALYS

      INTEGER  IRUN, IPATR, IATOF, NPATR

#include "bosdata.for"

C------------------  C O D E  ------------------------------------------

C                            Get instruction about TOF analysis

      CALL TPTFI1( ANALYS )

C                            If analysis wanted, delete old banks first

      IF( ANALYS ) THEN
C
        CALL BMLT( 1, 'TOFR')
        CALL BDLM

C                            Get ATOF bank and latest PATR bank

        CALL CLOC( IATOF, 'ATOF', 0 )

        IF( IATOF .GT. 0 ) THEN

          IPATR = IDATA( IBLN('PATR'))
          IF( IPATR .GT. 0 ) THEN
            NPATR = IDATA( IPATR - 2 )
            IF( NPATR .NE. 12 ) THEN

C                            Perform TOF analysis

              CALL TPRUN( IRUN )
              CALL TOFINT( IRUN, IATOF, IPATR, *5 )

              CALL TPDIAG()

            ENDIF

          ENDIF

        ENDIF

      ENDIF

      RETURN

C                            Error return from TOFINT

  5   CALL TPWARN
      RETURN

      END

      SUBROUTINE REFITO(IPTR,IPJHTL,XO,YO,WGHTO)
      IMPLICIT INTEGER*2 (H)
#include "cheadr.for"
      EQUIVALENCE (HHEADR(18),HRUN)
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      COMMON/CALIBR/JPOINT(100),
     1HMUCAL(8370),HLGMAI(5760),HTAGSY(384),HJPULS(9216),
     1DELTA0(96,2),DELTA1(96,2),DELTA2(96,2),DELTA5(96,2),DELTA6(96,2)
      INTEGER DATE(5), IDAY /0/
      DIMENSION ITRCLL(6), NCNCK(24)
      INTEGER MKLRT1 /Z1000000/, MKLRT2 /Z100/
      INTEGER MKBDCL(3) /Z10,Z20,Z40/
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 1
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      HPFREE = 1
      HPFRE1 = HPFREE
      HPCO0  = HPFREE
      HLDCO  = 14
      HPFREE = HLDCO*100 + HPCO0
      HPCO9 = HPFREE - 1
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      HPTR0 = HPFREE
      CALL MVC(IWRK(HPTR0),0,IDATA(IPTR+1),0,192)
      ITRK = IDATA(IPTR+1)
      IF(
     - IDATA(IPTR+18).EQ.1
     -)THEN
        ALFA  = ADATA(IPTR+21)
        CRV   = ADATA(IPTR+19)
        IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
        RAD   =  1./CRV + ADATA(IPTR+20)
        XCIRC = COS(ALFA) * RAD
        YCIRC = SIN(ALFA) * RAD
        CHARGE = SIGN(1.,ADATA(IPTR+25))
      ELSE
        CRV   = ADATA(IPTR+22)*2.
        IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
        ALFA  = ADATA(IPTR+19)
        XCIRC =-SIN(ALFA)/CRV + ADATA(IPTR+20)
        YCIRC = COS(ALFA)/CRV + ADATA(IPTR+21)
        CHARGE =-SIGN(1.,ADATA(IPTR+22))
      ENDIF
      ZVERT = ADATA(IPTR+31)
      ZSLOP = ADATA(IPTR+30)
      COSTHI = SQRT(ZSLOP**2 + 1.)
      XX    = ADATA(IPTR+12)
      YY    = ADATA(IPTR+13)
      RR    = SQRT(XX**2+YY**2)
      CSROT = XX / RR
      SNROT = YY / RR
      X0   = XO*CSROT + YO*SNROT
      Y0   =-XO*SNROT + YO*CSROT
      WGHT0 = AMIN1(WGHTO,1.0)
      WGHT0 = AMAX1(WGHTO,0.0)
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      KCLL = 0
      NHIT = 0
      IPCO = HPCO0
      JRING = 0
      LBCELL = 0
16000 CONTINUE
      JRING = JRING + 1
        NHRNG = 0
        NCLL = 0
16002 CONTINUE
        NCLL = NCLL + 1
        KCLL = KCLL + 1
          JCELL = ITRCLL(KCLL)
      IF(
     - JCELL.NE.0
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
            NHRNG = NHRNG + JHIT
      ENDIF
      IF(.NOT.(
     - NCLL.EQ.2
     -))GOTO 16002
16003 CONTINUE
        IF(JCELL.NE.0) LBCELL = LOR(MKBDCL(JRING),LBCELL)
      IF(.NOT.(
     - KCLL.EQ.6
     -))GOTO 16000
16001 CONTINUE
      HPCO9 = IPCO - 1
      JRINGL = 3
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      ALBLM1 = 0.6
      ALBLM2 = 3.0
      ASSIGN 17009 TO IZZZ05
      GOTO 17008
17009 CONTINUE
      ASSIGN 17010 TO IZZZ04
      GOTO 17006
17010 CONTINUE
      ASSIGN 17011 TO IZZZ05
      GOTO 17008
17011 CONTINUE
      ASSIGN 17013 TO IZZZ06
      GOTO 17012
17013 CONTINUE
      IF(
     - ABS(PAR1).GT..00030 .AND. SIG.GT..06
     -)THEN
      IF(
     - SIG.GT..10 .OR. IDATA(IPTR+24)-INT(S0).GT.8
     -)THEN
          ALBLM1 = 1.5
          ALBLM2 = 3.0
      ASSIGN 17014 TO IZZZ05
      GOTO 17008
17014 CONTINUE
          JRINGL = 2
      ASSIGN 17015 TO IZZZ04
      GOTO 17006
17015 CONTINUE
          ALBLM1 = 0.6
      ASSIGN 17016 TO IZZZ05
      GOTO 17008
17016 CONTINUE
      ASSIGN 17017 TO IZZZ04
      GOTO 17006
17017 CONTINUE
      ASSIGN 17018 TO IZZZ05
      GOTO 17008
17018 CONTINUE
      IF(
     - SIG.LT..10
     -)THEN
      ASSIGN 17020 TO IZZZ07
      GOTO 17019
17020 CONTINUE
      ENDIF
      ENDIF
      ENDIF
      HPFREE = HPFRE1
      RETURN
17006 CONTINUE
      S0 = WGHT0
      S1 = 0.
      S2 = 0.
      S3 = 0.
      S4 = 0.
      S5 = 0.
      S6 = 0.
      S7 = Y0 * WGHT0
      IPCO = HPCO0
16004 CONTINUE
      IF(
     - IWRK(IPCO+ 7).EQ.0 .AND. IWRK(IPCO+12).LE.JRINGL
     -)THEN
          X = WRK(IPCO+3)
          Y = WRK(IPCO+4)
          X2 = X**2
          S1 = S1 + X
          S2 = S2 + X2
          S3 = S3 + X*X2
          S4 = S4 + X2**2
          S5 = S5 + Y*X2
          S6 = S6 + Y*X
          S7 = S7 + Y
          S0 = S0 + 1.
      ENDIF
      IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16004
16005 CONTINUE
      IF(
     - S0.LT.2.5
     -)THEN
        SIG = 1000.
      ELSE
        F1 = 1. / S4
        XX12 = S3*F1
        XX13 = S2*F1
        YY1  = S5*F1
        XX22 = S2 - S3*XX12
        XX23 = S1 - S3*XX13
        YY2  = S6 - S3*YY1
        XX32 = S1 - S2*XX12
        XX33 = S0 - S2*XX13
        YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
          XX23 = XX23 / XX22
          YY2  = YY2  / XX22
          PAR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
          PAR2 = YY2 - XX23*PAR3
      ELSE
          XX33 = XX33 / XX32
          YY3  = YY3  / XX32
          PAR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
          PAR2 = YY3 - XX33*PAR3
      ENDIF
        PAR1 = YY1 - XX12*PAR2 - XX13*PAR3
        DEG = S0 - WGHT0 - 2.
        CHISQ = 0.
        DCHIM1 = 0.
        IHITM1 = 0
        IHSTRT = 0
        IPCO = HPCO0
16006 CONTINUE
      IF(
     - IWRK(IPCO+ 7).EQ.0 .AND. IWRK(IPCO+12).LE.JRINGL
     -)THEN
            IF(IHSTRT.EQ.0) IHSTRT = IPCO
            IHEND = IPCO
            X = WRK(IPCO+3)
            Y = WRK(IPCO+4)
            F = (PAR1 *X + PAR2 )*X + PAR3
            DCHI = Y - F
            WRK(IPCO+13) = DCHI
            CHISQ = CHISQ + DCHI**2
      ENDIF
        IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16006
16007 CONTINUE
        SIG    =      CHISQ  / DEG
        SIGLM = TRELLM(16)**2
      ENDIF
      GOTO IZZZ04
17002 CONTINUE
      DO 13000 I=1,6
          ITRCLL(I) = 0
13000 CONTINUE
13001 CONTINUE
        IPC0 = IPTR + 34
        IPC9 = IPC0 +  5
        ICELL = 0
      DO 13002 IPC = IPC0,IPC9
          JCELL = IDATA(IPC)
      IF(
     - JCELL.GT. 0 .AND. JCELL.LE.96
     -)THEN
            JRING = 1
            IF(JCELL.GT.24) JRING = 2
            IF(JCELL.GT.48) JRING = 3
            JPC = JRING*2 - 1
      IF(
     - ITRCLL(JPC).EQ.0
     -)THEN
              ITRCLL(JPC) = JCELL
      ELSE
              IF(ITRCLL(JPC).NE.JCELL) ITRCLL(JPC+1) = JCELL
      ENDIF
            ICELL = JCELL
            IRING = JRING
      ENDIF
13002 CONTINUE
13003 CONTINUE
      GOTO IZZZ02
17004 CONTINUE
      IF(
     - JRING.NE.3
     -)THEN
          IC1 = JCELL
          IF(IC1.GT.24) IC1 = IC1 - 24
          CSROT0 = DIRWR1(IC1,1)
          SNROT0 = DIRWR1(IC1,2)
      ELSE
          IC1 = JCELL - 48
          CSROT0 = DIRWR3(IC1,1)
          SNROT0 = DIRWR3(IC1,2)
      ENDIF
        DRICS  = TRMATC(JCELL,2)
        DRISN  = TRMATS(JCELL,2)
        DRITG  = DRISN/DRICS
        DRISNF = DRISN * .05
        R0 = FSENSW(JRING)
        DR = RINCR (JRING)
        R1   = DR*7.5 + R0
        DX   = R1 * CSROT0 - XCIRC
        DY   = R1 * SNROT0 - YCIRC
        RR   = SQRT(DX**2 + DY**2) * CHARGE
        CSB  = DX / RR
        SNB  = DY / RR
        TGB  = CSB/SNB
        DSBIN1 = DRIVEL(JCELL,1)
        IF(NRUN.GT.100) DS0 = T0FIX(JRING)*DSBIN1*64.
        IF(NRUN.LE.100) DS0 = DSBIN1*.5
        TANBET = ABS((TGB-DRITG)/(TGB*DRITG+1.))
        CCST01 = DELTA0(JCELL,1)*TANBET
        CCST02 = DELTA0(JCELL,2)*TANBET
        CCST11 = DELTA1(JCELL,1)
        CCST12 = DELTA1(JCELL,2)
        CCST21 = DELTA2(JCELL,1)
        CCST22 = DELTA2(JCELL,2)
        CCST51 = DELTA5(JCELL,1) * 10.
        CCST52 = DELTA5(JCELL,2) / 121.15
        CCST61 = DELTA6(JCELL,1) * 10.
        CCST62 = DELTA6(JCELL,2) / 121.15
        JHIT = 0
        NHIT   = 0
        NHGOOD = 0
        ILAYL =-99
        IPCO = IPCO - HLDCO
        IPJETC = IDATA(IQJETC)*2
        IP0    = IPJETC + 100
        IPCLL  = IPJETC + 2 + JCELL
        IP     = HDATA(IPCLL  ) + IP0
        IP9    = HDATA(IPCLL+1) + IP0
        IPHL   = IPJHTL + 2 + HDATA(IPCLL)/4
15000 CONTINUE
      IF(
     - IP.LT.IP9
     -)THEN
          LB   = IDATA(IPHL)
          ITR1 = LAND(ISHFTR(LB,17),127)
          ITR2 = LAND(ISHFTR(LB, 1),127)
      IF(
     - ITR1.EQ.ITRK .OR. ITR2.EQ.ITRK
     -)THEN
            LBLR = 0
            IF(ITR1.EQ.ITRK) LBLR = LAND(LB,MKLRT1)
            IF(ITR2.EQ.ITRK) LBLR = LAND(LB,MKLRT2)
            LBSIDE =-1
            IF(LBLR.NE.0) LBSIDE = 1
            LBLR = LBSIDE
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            ILAY = LAND(IWIR,15)
            DS =(HDATA(IP+3)) * DSBIN1
      DATA NPRHT /0/
      NPRHT = NPRHT + 1
            X1   = ILAY * DR + R0
            Z1   = X1*ZSLOP + ZVERT
            DDS = (1222.9-ABS(Z1))*ABERR(1) + ABERR(6)*R1*COSTHI
            DSC = DS - DDS + DS0
            Y1   = SWDEPL
            IF(LAND(ILAY,1).NE.0) Y1 =-Y1
            Y1   = (7-ILAY)*(CCST52*Z1+CCST51) - CCST62*Z1-CCST61 + Y1
            X    = X1*CSROT0 - Y1*SNROT0
            Y    = X1*SNROT0 + Y1*CSROT0
      IF(
     - DS.LE.DRC
     -)THEN
      IF(
     - DS.LT.4.0
     -)THEN
      IF(
     - DS.GT.DSD1
     -)THEN
                  DSC = (DSD1-DSD0)*DRV0 + (DS-DSD1)*DRV1
      ELSE
                  DSC = (DS-DSD0)*DRV0
      ENDIF
                IF(DSC.LT.0.1) DSC = 0.1
      ENDIF
              DXR  = DSC * CSB
              DYR  = DSC * SNB
              DXL =-DXR
              DYL =-DYR
      ELSE
      IF(
     - ILAY.LT. 3
     -)THEN
                DILAY =-(ILAY- 3)**2
                DSCL  = (DILAY*CCST11 + 1.) * DSC
                DSCR  = (DILAY*CCST12 + 1.) * DSC
      ELSE
      IF(
     - ILAY.GT.12
     -)THEN
                DILAY =-(ILAY-12)**2
                DSCL  = (DILAY*CCST21 + 1.) * DSC
                DSCR  = (DILAY*CCST22 + 1.) * DSC
      ELSE
                DSCL = DSC
                DSCR = DSC
      ENDIF
      ENDIF
      IF(
     - DSC.GT.ABERR(7)
     -)THEN
                DWIR  = ILAY - 7.5
                DWIRC = DSC*DRISNF
                DWIRL = DWIR + DWIRC
                DWIRR = DWIR - DWIRC
                DSCL  = (DSCL-ABERR(7))*DWIRL*CCST01 + DSCL
                DSCR  =-(DSCR-ABERR(7))*DWIRR*CCST02 + DSCR
      ENDIF
              DXR  = (DSCR-DRC)*DRISN + DRC*CSB
              DYR  = (DSCR-DRC)*DRICS + DRC*SNB
              DXL  =-(DSCL-DRC)*DRISN - DRC*CSB
              DYL  =-(DSCL-DRC)*DRICS - DRC*SNB
      ENDIF
            XL   = DXL + X
            YL   = DYL + Y
            XXL  = XL*CSROT + YL*SNROT
            YYL  =-XL*SNROT + YL*CSROT
            XR   = DXR + X
            YR   = DYR + Y
            XXR  = XR*CSROT + YR*SNROT
            YYR  =-XR*SNROT + YR*CSROT
            NLRSOL = 1
            IF(DS.LT.2.0) NLRSOL = 2
            ILRSOL = 0
16008 CONTINUE
            ILRSOL = ILRSOL + 1
      IF(
     - NLRSOL.EQ.1 .AND. LBSIDE.LT.0  .OR.
     ?           NLRSOL.EQ.2 .AND. ILRSOL.EQ.1
     -)THEN
                LBSIDE =-1
                XX  = XXL
                YY  = YYL
      ELSE
                LBSIDE = 1
                XX  = XXR
                YY  = YYR
      ENDIF
              LBGOOD = 0
              IF(LBSIDE.NE.LBLR) LBGOOD = 1
      IF(
     - ILAY.NE.ILAYL .OR. LBGDL.LE.1.AND.LBGOOD.LE.1
     -)THEN
                LBREG = 1
                JHIT = JHIT + 1
                IPCO = IPCO + HLDCO
      ELSE
                LBREG = 0
                IF(LBGOOD.LT.IWRK(IPCO+7)) LBREG = 1
      ENDIF
      IF(
     - LBREG.NE.0
     -)THEN
                NHIT   = NHIT   + 1
                IF(LBGOOD.LE.1) NHGOOD = NHGOOD + 1
                IWRK(IPCO   ) = ILAY
                IWRK(IPCO+ 1) = IP
                IWRK(IPCO+ 2) = LBSIDE
                WRK (IPCO+ 3) = XX
                WRK (IPCO+ 4) = YY
                WRK (IPCO+ 5) = 0.
                WRK (IPCO+ 6) = 0.
                IWRK(IPCO+ 7) = LBGOOD
                WRK (IPCO+ 8) = DS
                IWRK(IPCO+ 9) = JCELL
                IWRK(IPCO+10) = LBGOOD
                WRK (IPCO+11) = TGB
                IWRK(IPCO+12) = JRING
                WRK (IPCO+13) = 0.
                ILAYL = ILAY
                LBGDL = LBGOOD
      ENDIF
      IF(.NOT.(
     - ILRSOL.GE.NLRSOL
     -))GOTO 16008
16009 CONTINUE
      ENDIF
        IPHL = IPHL + 1
        IP   = IP   + 4
      GOTO 15000
      ENDIF
15001 CONTINUE
        IPCO = IPCO + HLDCO
      IF(
     - NHIT.LE.2
     -)THEN
16010 CONTINUE
      IF(
     - JCELL.EQ.17
     -)THEN
      IF(
     - NRUN.GE.539
     -)THEN
                LBCELL = LOR(LBCELL,1)
                JHIT = 16
                NHIT = 16
      ENDIF
      GOTO 16011
      ENDIF
      IF(
     - JCELL.EQ.37
     -)THEN
      IF(
     - NRUN.GE.2303
     -)THEN
                LBCELL = LOR(LBCELL,2)
                JHIT = 16
                NHIT = 16
      ENDIF
      GOTO 16011
      ENDIF
      IF(
     - JCELL.EQ.65 .OR. JCELL.EQ.66 .OR.
     ?         JCELL.EQ.81 .OR. JCELL.EQ.82
     -)THEN
      IF(
     - NRUN.GE.2783
     -)THEN
                LBCELL = LOR(LBCELL,4)
                JHIT = 16
                NHIT = 16
      ENDIF
      GOTO 16011
      ENDIF
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16010
16011 CONTINUE
      ENDIF
      GOTO IZZZ03
17012 CONTINUE
      XST  = WRK(IHSTRT+ 3)
      YST  = WRK(IHSTRT+ 4)
      XEN  = WRK(IHEND + 3)
      YEN  = WRK(IHEND + 4)
      TGST = PAR1*XST*2 + PAR2
      DXST = 1./SQRT(TGST**2+1.)
      DYST = DXST * TGST
      TGEN = PAR1*XEN*2 + PAR2
      DXEN = 1./SQRT(TGEN**2+1.)
      DYEN = DXEN * TGEN
      XMIN = -PAR2*.5 / PAR1
      YMIN = (PAR1*XMIN + PAR2)*XMIN + PAR3
      CURV =-PAR1 * 2.
      ZV0  = ADATA(IPTR+31)
      TGTH = ADATA(IPTR+30)
      CSTH = 1./SQRT(TGTH**2+1.)
      SNTH = CSTH * TGTH
      IP    = HPTR0 - 1
      IWRK(IP+ 1) = ITRK
      IWRK(IP+ 2) = 32
      IWRK(IP+ 3) = IDAY
      IWRK(IP+ 4) = 8
      WRK (IP+ 5) = XST *CSROT - YST *SNROT
      WRK (IP+ 6) = XST *SNROT + YST *CSROT
      WRK (IP+ 7) = SQRT(WRK(IP+ 5)**2 + WRK(IP+ 6)**2) * TGTH + ZV0
      WRK (IP+ 8) = (DXST*CSROT - DYST*SNROT)*CSTH
      WRK (IP+ 9) = (DXST*SNROT + DYST*CSROT)*CSTH
      WRK (IP+10) = SNTH
      IWRK(IP+11) = 0
      WRK (IP+12) = XEN *CSROT - YEN *SNROT
      WRK (IP+13) = XEN *SNROT + YEN *CSROT
      WRK (IP+14) = SQRT(WRK(IP+12)**2 + WRK(IP+13)**2) * TGTH + ZV0
      WRK (IP+15) = (DXEN*CSROT - DYEN*SNROT)*CSTH
      WRK (IP+16) = (DXEN*SNROT + DYEN*CSROT)*CSTH
      WRK (IP+17) = SNTH
      IWRK(IP+18) = 2
      WRK (IP+19) = ATAN2(SNROT,CSROT)
      WRK (IP+20) = XMIN*CSROT - YMIN*SNROT
      WRK (IP+21) = XMIN*SNROT + YMIN*CSROT
      WRK (IP+22) = PAR1
      WRK (IP+23) = SQRT(SIG)
      IWRK(IP+24) = S0 + .001
      WRK (IP+25) = CURV
      WRK (IP+26) = 0.
      WRK (IP+27) = CURV
      WRK (IP+28) = CURV
      I0 = IP+ 1
      I9 = IP+28
      GOTO IZZZ06
17019 CONTINUE
      XST  = WRK(IHSTRT+ 3)
      YST  = WRK(IHSTRT+ 4)
      TGST = PAR1*XST*2 + PAR2
      DXST = 1./SQRT(TGST**2+1.)
      DYST = DXST * TGST
      XMIN = -PAR2*.5 / PAR1
      YMIN = (PAR1*XMIN + PAR2)*XMIN + PAR3
      CURV =-PAR1 * 2.
      ZV0  = ADATA(IPTR+31)
      TGTH = ADATA(IPTR+30)
      CSTH = 1./SQRT(TGTH**2+1.)
      SNTH = CSTH * TGTH
      IP    = HPTR0 - 1
      IWRK(IP+ 4) = 16
      WRK (IP+ 5) = XST *CSROT - YST *SNROT
      WRK (IP+ 6) = XST *SNROT + YST *CSROT
      WRK (IP+ 7) = SQRT(WRK(IP+ 5)**2 + WRK(IP+ 6)**2) * TGTH + ZV0
      WRK (IP+ 8) = (DXST*CSROT - DYST*SNROT)*CSTH
      WRK (IP+ 9) = (DXST*SNROT + DYST*CSROT)*CSTH
      WRK (IP+10) = SNTH
      IWRK(IP+18) = 2
      WRK (IP+19) = ATAN2(SNROT,CSROT)
      WRK (IP+20) = XMIN*CSROT - YMIN*SNROT
      WRK (IP+21) = XMIN*SNROT + YMIN*CSROT
      WRK (IP+22) = PAR1
      WRK (IP+23) = SQRT(SIG)
      IWRK(IP+24) = S0 + .001
      WRK (IP+25) = CURV
      WRK (IP+26) = 0.
      WRK (IP+27) = CURV
      WRK (IP+28) = CURV
      I0 = IP+ 1
      I9 = IP+28
      GOTO IZZZ07
17008 CONTINUE
        IWL = -999
      DO 13004 IP = HPCO0,HPCO9,HLDCO
          IW0 = IWRK(IP)
          X   = WRK(IP+3)
          Y   = WRK(IP+4)
          F   = (PAR1*X + PAR2)*X + PAR3
          DF  = F - Y
          LBGOOD = 4
          IF(ABS(DF).LT.ALBLM2) LBGOOD = 1
          IF(ABS(DF).LT.ALBLM1) LBGOOD = 0
          IWRK(IP+ 7) = LBGOOD
          WRK (IP+13) = DF
      IF(
     - IWL.EQ.IW0
     -)THEN
      IF(
     - ABS(DFL).LT.ABS(DF)
     -)THEN
              IWRK(IP +7) = 16
      ELSE
              IWRK(IPL+7) = 16
      ENDIF
      ENDIF
          IWL = IW0
          IPL = IP
          DFL = DF
13004 CONTINUE
13005 CONTINUE
      GOTO IZZZ05
17000 CONTINUE
        IQJETC = IBLN('JETC')
        IQHEAD = IBLN('HEAD')
        IWRK(IP+ 3) = IDAY
        CALL DAY2(DATE)
        IDAY = DATE(1)*1000 + DATE(2)
        DRC = RINCR(1)*.5 * DRICOS
      IF(
     - NRUN.LE.100
     -)THEN
          DSD0   = .0
          DSD1   = 5.0
          DSD2   = 5.0
          DRV0   = 1.0
          DRV1   = 1.0
      ELSE
          DSD0   =-.63
          DSD1   = 1.8
          DSD2   = 4.0
          DRV0   = 0.8
          DRV1   = (DSD2 - (DSD1-DSD0)*DRV0) / (DSD2-DSD1)
      ENDIF
      GOTO IZZZ01
      END

C   06/03/82 705211118  MEMBER NAME  DEDXB10  (S)           FORTRAN
      SUBROUTINE DEDXB1(ITR)
C-----------------------  LAST CHANGE: 24.03.86   L.BECKER  ---C
C-----------------------  LAST CHANGE: 04.06.86  J.A.J.SKARD --C
C-----------------------  LAST CHANGE: 06.06.86  J.A.J.SKARD --C
C-----------------------  LAST CHANGE: 27.08.86  J.OLSSON    --C
C-  IMPLICIT INTEGER*2 -  LAST CHANGE: 20.05.87  J.OLSSON    --C
C                                                              C
C     DEDX FOR ONE TRACK ITR IN 'PATR' BANK                    C
C     SLIGHTLY MODIFIED VERSION OF DEDXBN                      C
C     PUTS ENERGY DEPOSITS FOR EACH WIRE INTO ARRAY EWIR(60),  C
C     CORRESPONDING X,Y,R, AND FITTED Z-VALUES INTO ARRAYS     C
C     XWIR(60),YWIR(60),RWIR(60), AND ZWIR(60), RESPECTIVELY   C
C                                                              C
C     CALCULATION OF DE/DX, SIGMA(DE/DX)      -   P.DITTMANN   C
C     COMPARISON WITH THE THEORETICAL VALUE   -   J.SKARD      C
C     RESULTS ARE WRITTEN INTO COMMON /CWORK1/                 C
C     THE ARRAY TRES(10,ITR) HOLDS THE FOLLOWING RESULTS       C
C                                                              C
C     ITRES(1,ITR)  =  NHIT, QUALITY OF DEDX                   C
C      TRES(2,ITR)  =  DEDX                                    C
C      TRES(3,ITR)  =  SIGMA(DEDX)                             C
C      TRES(4,ITR)  =  CHISQ(ELECTRON)                         C
C      TRES(5,ITR)  =  CHISQ(PION)                             C
C      TRES(6,ITR)  =  CHISQ(KAON)                             C
C      TRES(7,ITR)  =  CHISQ(PROTON)                           C
C     ITRES(8,ITR)  =  JMIN, NUMBER FOR MINIMUM CHISQUARE      C
C                      1 = P, 2 = K, 3 = PI, 4 = E, 0=NO DEDX  C
C      TRES(9,ITR)  =  MOMENTUM (GEV)                          C
C     TRES(10,ITR)  =  MOMENTUM ERROR                          C
C--------------------------------------------------------------C
C----------------DEDX RESULTS-----------------------
C      COMMON /CWORK1/ IER,NTRR,TRES(10,60)
       COMMON /CWORK1/ IER,NTRR,TRES(10,60),EWIR(60),XWIR(60),YWIR(60),
     *                 RWIR(60),ZWIR(60)
       DIMENSION ITRES(10,60)
       EQUIVALENCE (TRES(1,1),ITRES(1,1))
C----------------END--------------------------------
C
C HDATA IS DECLARED INTEGER*2 IN MACRO CDEDEDX
C
#include "cdata.for"
#include "cgraph.for"
#include "cjdrch.for"
C
#include "cdededx.for"
       COMMON/CDEJAS/DEBEST,PBEST
      DIMENSION ICEL(60),XYRZ(6)
C
      DATA IWARN / 0 /
C
      IPVERS=JPOINT(IPN+1)
      ICALL =ICALL+1
      IF(ICALL.GT.1)GO TO 9
      IPJETC = IBLN('JETC')
      IPJETV = IBLN('JETV')
      IPJHTL = IBLN('JHTL')
      IPPATR = IBLN('PATR')
      IPHEAD = IBLN('HEAD')
    9 CONTINUE
C
      IJETC = IDATA( IPJETC )
      IJETV = IDATA( IPJETV )
      IJHTL = IDATA( IPJHTL )
      IPATR = IDATA( IPPATR )
      IX    = 2*IDATA( IPHEAD )
      IRUN=HDATA(IX+10)
C        MONTE CARLO - RETURN
      IF(IRUN.EQ.0) RETURN
      IPN = JPOINT(8)
      IF(ICALL.EQ.1 .AND. NDDINN .EQ. 0 ) PRINT 901, IPVERS
  901 FORMAT(/'  ***********  DEDX - RECALIBRATION  VERSION',I8/)
      IF(IJETC.EQ.0 .OR.IJHTL.EQ.0 .OR.IPATR.EQ.0) GOTO 56
      IJETC2 = IJETC*2
      IJETV2 = IJETV*2 + 2
      NT = IDATA(IPATR+2)
C     IF(NT.LE.0 .OR. NT.GT.NTRTOT) GOTO 57
      IF(NT.LE.0 .OR. NT.GT.NTRTOT .OR. ITR.GT.NT) GOTO 57
      IER=0
      NTRR=NT
C        DATE FOR RUN-DEPENDENT CORRECTIONS
      IFLAG = 0
      IPERD = 1
      IF(IRUN.GE.1400) IPERD=2
      IF(IRUN.GE.2600) IPERD=3
      IF(IRUN.GE.3730) IPERD=4
      IF(IRUN.GE.6000) IPERD=5
      IF(IRUN.GE.7592) IPERD=6
      IF(IRUN.GE.10000) IPERD=7
      IF(IRUN.GE.11021) IPERD=8
      IF(IRUN.GE.13088) IPERD=9
      IF(IRUN.GE.14605) IPERD=10
      IF(IRUN.GE.15690) IPERD=11
      IF(IRUN.GE.16803) IPERD=12
      IF(IRUN.GE.17988) IPERD=13
      IF(IRUN.GE.19068)          IFLAG=1
C        Z RECALIBRATION (IF NOT YET DONE)
      IHH=HDATA(IJETC2+2)
      MODE=1
      IF(IPERD.LT.9  .AND. IHH.NE.8305) CALL ZSFIT(MODE,0,0,0,0,1)! PMF 03/12/99: four dummy arguments + 6th argument added
      IF(IPERD.EQ.9  .AND. IHH.NE.8404) CALL ZSFIT(MODE,0,0,0,0,1)! PMF 03/12/99: four dummy arguments + 6th argument added
      IF(IPERD.EQ.10 .AND. IHH.NE.8404) CALL ZSFIT(MODE,0,0,0,0,1)! PMF 03/12/99: four dummy arguments + 6th argument added
      IF(IPERD.EQ.11 .AND. IHH.NE.8412) CALL ZSFIT(MODE,0,0,0,0,1)! PMF 03/12/99: four dummy arguments + 6th argument added
      IF(IPERD.EQ.12 .AND. IHH.NE.8412) CALL ZSFIT(MODE,0,0,0,0,1)! PMF 03/12/99: four dummy arguments + 6th argument added
      IF(IPERD.EQ.13 .AND. IHH.NE.8412) CALL ZSFIT(MODE,0,0,0,0,1)! PMF 03/12/99: four dummy arguments + 6th argument added
C
      FIELD = HDATA(IX+30)
      NDAY=HDATA(IX+7)*30+HDATA(IX+6)-30
      MDAY=NDAY
      IF (IFLAG.EQ.1) GOTO 60
   70 CONTINUE
C              --- SPECIAL CORRECTIONS:
      IF (IRUN.GT.12644) CA(8)=0.248
C
      NDAY = NDAY - ID0(IPERD)
      DAY = NDAY
C --------------------------------------- GAS PRESSURE
      PREFAC = 1. / (1.+CP(IPERD)*BP(IPERD)*DAY/AP(IPERD))
C --------------------------------------- SUBPERIODS
      DO 5 L=1,3
      IF(NDAY.LT.LSP(L,IPERD)) GOTO 6
    5 CONTINUE
      L = 1
    6 SUBFAC = SPF(L,IPERD)
C --------------------------------------- ELECTRON ATTACHMENT
      ICLBIN = DAY/10. + 1.5
      IF(ICLBIN.LE.0) ICLBIN=1
      IF(ICLBIN.GT.19) ICLBIN=19
      FRACT = DAY/10. - ICLBIN + 1
      TIMCOR = CA(IPERD) * (CL(ICLBIN)+FRACT*(CL(ICLBIN+1)-CL(ICLBIN)))
      TIMCOR = TIMCOR/1000.
C --------------------------------------- LOOP OVER ALL TRACKS
C ---------- LOOP TAKEN OUT ----------
      L0 = IDATA(IPATR+1)
      LT = IDATA(IPATR+3)
CCC   KT = IPATR + L0
CCC   DO 59 I=1,NT
C--------
      I=ITR
      KT = IPATR + L0 + (ITR-1)*LT
      DEBEST=0.
      PBEST=0.
C--------
      CALL MOMENP(KT,PX,PY,PZ,PTRANS,PMOM,PHI,THE)
C--------
      IF (PMOM.LT.0.06) GOTO 58
      NHIT = 0
      CALL VZERO(IZB,60)
      NSAME = 0
      CALL VZERO(EWIR,300)
      IF(ADATA(KT+25).EQ.0.) GOTO 58
      R = -1. / ADATA(KT+25)
      SR = SIGN(1.,R)
      CTH = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      STH = ADATA(KT+10)
      TTH = ABS(STH/CTH)
      IF (TTH.GT.6.) GOTO 58
C
      CPHI = ADATA(KT+8) / CTH
      SPHI = ADATA(KT+9) / CTH
      X0 = ADATA(KT+5)
      Y0 = ADATA(KT+6)
      XM = X0 - R*SPHI
      YM = Y0 + R*CPHI
      R0 = SQRT(X0**2+Y0**2)
      XE = ADATA(KT+12)
      YE = ADATA(KT+13)
      SE = R * ATAN2(SR*(CPHI*(XE-X0)+SPHI*(YE-Y0)),
     *               SR*(SPHI*(XE-X0)-CPHI*(YE-Y0)+R))
      IF(ABS(R).GT.1.E5) SE=SQRT((XE-X0)**2+(YE-Y0)**2)
C
C --------------------------------------- ORDER CELLS
      NC = 0
      DO 12 J=1,6
      KC = IDATA(KT+40-J)
      IF(KC.LE.0 .OR. KC.GT.96) GOTO 12
      IF(NC.EQ.0) GOTO 11
      IF(KC.GT.IC(NC)) GOTO 11
      DO 10 K=1,NC
      IF(KC.GT.IC(K)) GOTO 10
      IF(KC.EQ.IC(K)) GOTO 12
      JC = IC(K)
      IC(K) = KC
      KC = JC
   10 CONTINUE
   11 NC = NC + 1
      IC(NC) = KC
   12 CONTINUE
C --------------------------------------- LOOP OVER CELLS
      IM2 = I*2
      IM1 = IM2*65536
      DO 19 J=1,NC
      NCP = IJETC2 + IC(J) + 2
      NHCELL = (HDATA(NCP+1)-HDATA(NCP))/4
      KHCELL = (HDATA(NCP)-1)/4
      DO 14 L=1,16
   14 IHDT(L) = 0
C --------------------------------------- LOOP OVER HITS
      DO 18 K=1,NHCELL
      KA = IJHTL + KHCELL + K + 1
      IF(IDATA(KA).EQ.0) GOTO 18
      LRFLAG = 0
      ZFLAG = 0
      IMH=LAND(IDATA(KA),MTRNO1)
      IF(IMH.NE.IM1) GOTO 13
      IF(TBIT(IDATA(KA),15)) ZFLAG=1
      IF(TBIT(IDATA(KA), 7)) LRFLAG=1
      KABIT = 15
      GOTO 15
   13 IMH=LAND(IDATA(KA),MTRNO2)
      IF(IMH.NE.IM2) GOTO 18
      IF(TBIT(IDATA(KA),31)) ZFLAG=1
      IF(TBIT(IDATA(KA),23)) LRFLAG=1
      KABIT = 31
C ------------------------------------- HIT FOUND IN CELL IC(J), TRACK I
   15 IF (NHIT.EQ.60) GOTO 20
      NHIT = NHIT + 1
      NH1 = IJETC2 + (KHCELL+K-1)*4 + 101
      IJC(NHIT) = NH1
      ICEL(NHIT) = IC(J)
      IJH(NHIT) = KA
      IF(KABIT.EQ.15) IJH(NHIT)=-IJH(NHIT)
      LRFL(NHIT) = LRFLAG
      MHIT = HDATA(NH1)
      NW(NHIT) = MHIT / 8
      LH(NHIT) = LAND(MHIT,7) + 1
      ILAY = LAND(NW(NHIT),15) + 1
      IF (ILAY.LE.0 .OR. ILAY.GT.16) GOTO 18
      IHDT(ILAY) = NHIT
      IZB(NHIT) = 0
      IF(ZFLAG.EQ.0) GOTO 18
      IZB(NHIT) = LH(NHIT)
   18 CONTINUE
C
C --------------------------------------- X-TALK MATRIX
      DO 119 L=1,16
      K = IHDT(L)
      IF(K.LE.0 .OR. K.GT.60) GOTO 119
      DO 114 M=1,4
      IXL(K,M) = 0
      IXH(K,M) = 0
      IF(L.LE.M) GOTO 112
      IF(IHDT(L-M).EQ.0) GOTO 112
      IXL(K,M) = IHDT(L-M)
  112 IF(L.GE.17-M) GOTO 114
      IF(IHDT(L+M).EQ.0) GOTO 114
      IXH(K,M) = IHDT(L+M)
  114 CONTINUE
  119 CONTINUE
   19 CONTINUE
   20 CONTINUE
C --------------------------------------- LOOP OVER ALL HITS OF TRACK I
      NHF = 0
      NCL = -1
C
      DO 29 J=1,NHIT
      IF(IZB(J).EQ.0) GOTO 29
      NC = NW(J) / 16
      NR = NC / 24
      IF(NR.LT.3) NR=NR+1
      INR = (NR-1)*2
      NL = LAND(NW(J),15)
      NH1 = IJC(J)
C --------------------------------------- AMPLITUDES & DRIFT TIME
      AR = HDATA(NH1+1)
      AL = HDATA(NH1+2)
      T = HDATA(NH1+3) / 64.
C
      ILR = LRFL(J) + 1
      TM = VDREL(IPERD)*(TMAX(ILR,NR)+TSLP(ILR,NR)*NL)
      XT = T / TM
      AMP = AL + AR
      AMP = AMP / 8.
C --------------------------------------- REMOVE HITS IN CELL CORNERS
      IF(NL.GT.0 .AND. NL.LT.14) GOTO 21
      IF(T.LT.90.) GOTO 21
      IF(NL.EQ.15.AND.LRFL(J).EQ.1) GOTO 26
      IF(NL.EQ. 0.AND.LRFL(J).EQ.0) GOTO 26
      IF(NR.EQ.2.AND.NL.EQ.14.AND.LRFL(J).EQ.1.AND.T.GT.180.) GOTO 26
   21 IF(XT.GT.0.97) GOTO 26
      IF(T.LE.4.) GOTO 26
      IF(IPERD.EQ.1 .AND. NC.EQ.9) GOTO 26
C --------------------------------------- X - TALK
      DW(J) = 0
      DO 124 M=1,4
      JXT = 1
      K = IXL(J,M)
      IF(K.LE.0 .OR. K.GT.60) GOTO 122
  121 NHX = IJC(K)
      AMPX = (HDATA(NHX+1)+HDATA(NHX+2))/8.
      TX = HDATA(NHX+3)/64.
      GATE = T - TX - 1.0
      IF(GATE.LT.0.) GOTO 125
      IF(GATE.GT. 9.) GOTO 122
      BT = GATE
      GOTO 126
  125 BT = 10. + GATE
      IF(BT.LE.0.) GOTO 122
  126 FXT = 1.-BT/5.*(1.-BT/20.)
      IF(GATE.LT.0.) FXT=1.-FXT
      AMP = AMP + AMPX*CTALK(M)*FXT
      DW(J) = DW(J) + AMPX*CTALK(M)
  122 JXT = JXT + 1
      IF(JXT.GT.2) GOTO 124
      K = IXH(J,M)
      IF(K.NE.0) GOTO 121
  124 CONTINUE
      DL(J) = AMP
C --------------------------------------- GAIN
      GAIN=ACALIB(IPN+6+NW(J))
      AMP = AMP * GAIN
C --------------------------------------- WIRE STAGGERING
      IMH=LAND(NL,1)
      IF(IMH.NE.LRFL(J)) AMP=AMP*0.92
C -------------------- COMPUTE TRACK LENGTH IN DRIFTSPACE, ANODE CURRENT
C ----IF(ABS(R).GT.4000. .AND. NC.EQ. NCL) GOTO 24----
      IF(NC.EQ.NCL) GOTO 23
      NCL = NC
      CURR = 0.
      IF(IJETV.EQ.0) GOTO 22
      NS = NC - (NR-1)*24
      IF(NR.EQ.3) NS=NS/2
      KR = NR
      IMH=LAND(NC,1)
      IF(NR.EQ.3 .AND. IMH.EQ.1) KR=4
      ICURR = HDATA(IJETV2+NS*4+KR)
      CURR = LAND(ICURR,2047)
      IF (CURR.GT.80.) CURR=0.
   22 PHIW = 0.1309 + 0.2618*NC
      IF(NC.GE.48) PHIW=PHIW/2.
      CPHW = COS(PHIW)
      SPHW = SIN(PHIW)
C ----CPHD =  SPHW*CALF - CPHW*SALF----
C ----SPHD = -CPHW*CALF - SPHW*SALF----
      CPHD =  SPHW*DRICOS + CPHW*DRISIN
      SPHD = -CPHW*DRICOS + SPHW*DRISIN
   23 RW = 211.*NR + 10.*NL
      XW = RW * CPHW
      YW = RW * SPHW
      SGAM = ((XW-XM)*SPHD-(YW-YM)*CPHD)/R
      IF(ABS(SGAM).GT..87) GOTO 26
      CGAM = SQRT(1.-SGAM**2)
      TGAM = SGAM/CGAM
C --------------------------------------- TRACK LENGTH
   24 AMP = AMP * CGAM*CTH
      DT(J) = TGAM
C --------------------------------------- ANODE CURRENT
      AMP = AMP / (1.-0.00011*CURR**2)
C --------------------------------------- FINITE GATE LENGTH
      AMP = AMP / (1.-0.25*TGAM-0.60*TGAM**2)
C --------------------------------------- SATURATION
      AMP = AMP/(1.-SATTO(INR+1,IPERD)*EXP(-SATTO(INR+2,IPERD)*SQRT(T)))
      AMP = AMP/(1.-SATQUA(NR,IPERD)*T**2/1000.)
      AMP = AMP*9.67/SATFAC(NR,IPERD)
C
C --------------------------------------- GAS PRESSURE
      AMP = AMP * PREFAC
C --------------------------------------- SUBPERIODS
      AMP = AMP * SUBFAC
C --------------------------------------- DAY/4 CORRECTION
      IDAY4=MDAY/4 + (NR-1)*100 + 1
      ADAY4=ACALIB(IPN+1541+IDAY4)
      AMP = AMP * ADAY4
C --------------------------------------- ATTACHMENT
      AMP = AMP * EXP(TIMCOR*T)
C --------------------------------------- GAIN SATURATION
      AMP = AMP/(1.-SATSO(INR+1,IPERD)*EXP(-SATSO(INR+2,IPERD)*
     *                                   SQRT(TTH**2+SATSO(7,IPERD)*T)))
C --------------------------------------- EDGE FIELD DISTORTIONS
      IF(NL.GT.3 .AND. NL.LT.12) GOTO 25
      IL = NL
      IF(NL.GT.8) IL=15-NL
      ICORN = 0
      IF(NL.LT.8 .AND. LRFL(J).EQ.1) ICORN=1
      IF(NL.GT.8 .AND. LRFL(J).EQ.0) ICORN=1
      ICORN = ICORN*4 + IL + 1
      XTORT = XT - 0.5
      IF(XTORT.LT.0.) XTORT=0.
      AMP = AMP * FTORT(1,ICORN)*(1.+FTORT(2,ICORN)*XTORT)
   25 CONTINUE
      IF (NHF.EQ.60) GOTO 30
      NHF = NHF + 1
      G(NHF) = AMP
      S(J) = AMP
      CALL JFXYRZ(KT,NH1,LRFL(J),NSAME,ICEL(J),XYRZ)
      NSAME = 1
      EWIR(NHF) = AMP
      XWIR(NHF) = XYRZ(1)
      YWIR(NHF) = XYRZ(2)
      RWIR(NHF) = XYRZ(5)
      ZWIR(NHF) = XYRZ(6)
      GOTO 29
   26 IZB(J) = 0
   29 CONTINUE
   30 CONTINUE
C
      IF(NHF.LT.NHFCUT) GOTO 58
      CALL DSORT(NHF,G,TRCM,DTRCM)
      IF(TRCM.LT.0.1) GOTO 58
C
C-------------  RESULTS  ----------------------------------------------
C
      ITRES(1,I)=NHF
      TRES(2,I)=TRCM
      TRES(3,I)=2.6*DTRCM
C     TRES(3,I)=2.0*DTRCM
      TRES(9,I)=PMOM
C
      PP2=TRCM
      SIGDE=TRES(3,I)
C
       CHMIN=1000000.
       SIGPP=1000000.
       JMIN=0
      CALL ERRMOM(KT,PMOM,ELMASS,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,ELMASS,PDEELC,DEDELC,CHIELC)
       IF(CHMIN .LT. CHIELC) GOTO 250
       CHMIN=CHIELC
       SIGPP=SIGMP
       DEBEST=DEDELC
       PBEST=PDEELC
       JMIN=4
250   CALL ERRMOM(KT,PMOM,PIOMAS,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,PIOMAS,PDEPIO,DEDPIO,CHIPIO)
       IF(CHMIN .LT. CHIPIO) GOTO 251
       CHMIN=CHIPIO
       SIGPP=SIGMP
       DEBEST=DEDPIO
       PBEST=PDEPIO
       JMIN=3
251   CALL ERRMOM(KT,PMOM,FKAMAS,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,FKAMAS,PDEKAO,DEDKAO,CHIKAO)
       IF(CHMIN .LT. CHIKAO) GOTO 252
       CHMIN=CHIKAO
       SIGPP=SIGMP
       DEBEST=DEDKAO
       PBEST=PDEKAO
       JMIN=2
252   CALL ERRMOM(KT,PMOM,PROTMA,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,PROTMA,PDEPRO,DEDPRO,CHIPRO)
       IF(CHMIN .LT. CHIPRO) GOTO 253
       CHMIN=CHIPRO
       SIGPP=SIGMP
       DEBEST=DEDPRO
       PBEST=PDEPRO
       JMIN=1
253    TRES(4,I)=CHIELC
       TRES(5,I)=CHIPIO
       TRES(6,I)=CHIKAO
       TRES(7,I)=CHIPRO
       ITRES(8,I)=JMIN
       TRES(10,I)=SIGPP
       GOTO 59
C
   58 CONTINUE
      ITRES(1,I)=-1
      TRES(2,I)=0.
      TRES(3,I)=0.
      TRES(4,I)=-1.
      TRES(5,I)=-1.
      TRES(6,I)=-1.
      TRES(7,I)=-1.
      ITRES(8,I)=0
      TRES(9,I)=PMOM
      TRES(10,I)=1000000.
C
C-------------  END OF RESULTS  ---------------------------------------
C
CCC59 KT = KT + LT
C----
   59 CONTINUE
C----
C
      RETURN
C
   56 PRINT 561
  561 FORMAT ('  ***** ERROR IN DEDXB1: BANK POINTER = 0')
      IER=1000
      NTRR=0
      RETURN
C
   57 PRINT 571
  571 FORMAT ('  ***** ERROR IN DEDXB1: # OF TRACKS < 0 , > 60 , OR GIVE
     *N TRACK NO. > MAX.')
      IER=4000
      NTRR=0
      RETURN
C
   60 NDAY=75 + ID0(IPERD)
      IWARN=IWARN+1
      IF(IWARN.EQ.1) PRINT 601, IRUN
  601 FORMAT(/'  ***********  WARNING: DEDX CALIBRATION CONSTANTS NOT VA
     +LID FOR THESE DATA !!!'/'  ***********  RUN #  :',I10,'  AND LATER
     +'/)
      GOTO 70
C
      END

C   10/05/79 C9051401   MEMBER NAME  BOUNDJ   (LGSOURCE)    FORTRAN
      FUNCTION BOUND(PA0)
C
C     A. SATO  28-10-77
C     LAST MODIFICATION  08-05-79  19:00  BY Y.YANAGISAWA
C     LAST MODIFICATION  10-05-79  14:00  BY S.YAMADA
C
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     1                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     2                ZECAP(4),ZECAPX(4),THECPX(2),
     3                ECXLST(24), ECYLST(24)
C
      DIMENSION PA0(3,3)
C
      X=PA0(1,2)
      IF(X.GE.0.) GO TO 1
      BOUND=-1.
      RETURN
    1 BOUND=B-X
      IF(BOUND.LT.0.) RETURN
C
C---- CHECK SIDE BND(DISTINGUISHED BY THE BOUNDARY, SEE LGBLCK & LGSTRC)
      IF(B-65.) 3,3,2
C---- END CAP
    2 CALL BONDEC( PA0(2,2), PA0(3,2), IN)
      IF( IN ) 4,4,100
    4 BOUND = -2.
  100 RETURN
C
C---- BARREL
    3 IF(PA0(3,2).GE.ZENDX0(1).AND.PA0(3,2).LE.ZENDX0(2)) RETURN
      BOUND = -3.
      RETURN
C
C*******************************************************
C
      ENTRY BOUNDI(BIN)
      B=BIN
      RETURN
      END

C   07/06/96 606071834  MEMBER NAME  BSIN     (S4)          FORTG1
      SUBROUTINE BSIN(NRW,ICD)
C     BOS SUBPROGRAM =0.8=
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL FF/Z000000FF/
      EQUIVALENCE (INAME,XNAME)
      INTEGER ISTAR/Z0000005C/
      INTEGER IONE/1/
      EQUIVALENCE (IONE,ONE)
C     CREATE POINTER FOR NEW BANKS
    2 ICD=0
      NRIN=NRIN+1
      IEB=0
      NEXTS=NEXT
      IF(NRW.LT.4) GOTO 81
      NS=0
      NTOT=NRW
C     CHECK BANK LENGTH AND GET INDEX FOR NAME
   10 LENG=IW(NEXT+3)
      IF(LENG.LT.0) GOTO 83
      LENG=LENG+4
      IF(LENG.GT.NTOT) GOTO 83
      LNAM=IW(NEXT)
      IW(INAMV)=LNAM
      LFDI=MOD(IABS(LNAM),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      KL  =LFDI
      IF(NS.GE.NLIST) STOP 35
      NS=NS+1
      RW(IOLST+KL)=OR(RW(IOLST+KL),ONE)
      IW(ISLST+NS)=KL
      IW(IMLST+NS)=1
      IF(IW(KL).EQ.0) GOTO 50
C     BANK ALREADY THERE, CHECK THIS RECORD
      DO 4 IS=1,NS
      IF(IW(ISLST+NS).EQ.IW(ISLST+IS)) GOTO 6
    4 CONTINUE
      IS=NS
    6 IF(IS.EQ.NS) GOTO 12
C     IN THIS RECORD
      NS=NS-1
      I=KL+1
    8 I=IW(I-1)
      IF(IW(I-1).NE.0) GOTO 8
      IF(IW(I-2).GE.IW(NEXT+1)) GOTO 84
      K=I
      INAME=LNAM
      XNAME=AND(XNAME,FF)
      GOTO 60
C     DELETE BANKS OF THE SAME NAME
   12 IEB=1
   15 INAME=IW(INAMV+KL)
      XNAME=AND(XNAME,FF)
      LENGS=0
      I=IW(KL)
      IW(KL)=0
   20 LENG=4+IW(I)
      LENGS=LENGS+LENG
      IW(I)=-LENG
      NFRE=NFRE+LENG
      I=IW(I-1)
      IF(I.NE.0) GOTO 20
      LENG=IW(NEXT+3)+4
      IF(INAME.EQ.ISTAR) NCPL=NCPL-LENGS
      GOTO 50
C     CHECK LENGTH OF BANK
   30 LENG=IW(NEXT+3)
      IF(LENG.LT.0) GOTO 82
      LENG=LENG+4
      IF(LENG.GT.NTOT) GOTO 83
C     CHECK BANK NR
      IF(IW(NEXT+1)-IW(K-2)) 84,40,60
C     SAME, APPEND
   40 IW(K)=IW(K)+LENG-4
      CALL UCOPY2(IW(NEXT+4),IW(NEXT),NTOT-4)
      NEXT=NEXT+LENG-4
      IF(INAME.EQ.ISTAR) NCPL=NCPL+LENG-4
      GOTO 70
C     NEW NAME
   50 K=KL+1
      INAME=IW(INAMV+KL)
      XNAME=AND(XNAME,FF)
C     LARGER NR
   60 IW(K-1)=NEXT+3
      K=NEXT+3
      IW(K-1)=0
      NEXT=NEXT+LENG
      IF(INAME.EQ.ISTAR) NCPL=NCPL+LENG
C     CHECK COMPLETE RECORD
   70 NTOT=NTOT-LENG
      IF(NTOT.EQ.0) GOTO 90
      IF(NTOT.LT.4) GOTO 85
      IF(IW(NEXT).EQ.LNAM) GOTO 30
      GOTO 10
C     ERRORS
C     RECORD END WRONG
   85 ICD=ICD+1
C     WRONG ORDER IN BANK NR
   84 ICD=ICD+1
C     BANK LENGTH TO LARGE
   83 ICD=ICD+1
C     BANK LENGTH NEGATIVE
   82 ICD=ICD+1
C     RECORD LENGTH LESS THAN 4
   81 ICD=ICD+1
      NER(ICD)=NER(ICD)+1
   89 CALL BMLT(0,0)
      CALL BDLM
      NEXT=NEXTS
      NS=0
      GOTO 100
   90 IF(IEB.EQ.0) GOTO 100
      NER(10)=NER(10)+1
C
  100 RETURN
      END

C   10/06/86 807251616  MEMBER NAME  SCANNR   (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SCANNR(INDEX,IRFLG)
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON   19/06/79 :  GRAPHICS & OTHER COMMANDS
C
C        MOD: C. BOWDERY  16/03/84 :  COMMAND ND50 ADDED
C        MOD: C. BOWDERY  20/06/84 :  REVERSE JADISP AND EVDISP CALLS
C        MOD: C. BOWDERY   5/07/84 :  FOR DS CHANGING DURING SESSION
C        MOD: J. HAGEMANN 19/10/84 :  FOR NEW COMMAND VAC (130)
C        MOD: C. BOWDERY  17/07/85 :  COMMANDS REMOVED, TIDYING UP.
C        MOD: C. BOWDERY  18/07/85 :  CHANGES FOR NAMED MACROS
C        MOD: C. BOWDERY   3/08/85 :  IMPROVED TERMINATION, + EDITMAC
C        MOD: C. BOWDERY   5/08/85 :  RENAMAC AND DELMAC ADDED
C        MOD: C. BOWDERY   9/08/85 :  CSTV2 AND STANDARD VIEW BUG FIXED
C        MOD: C. BOWDERY  12/08/85 :  COMMAND LIM REMOVED
C        MOD: C. BOWDERY  10/06/86 :  NEW COMMON FOR STANDARD VIEW DATA
C        MOD: G. ECKERLIN 31/07/86 :  NEW COMMAND J68K (135) ADDED
C        MOD: J. HAGEMANN 08/09/86 :  FOR BDLS WITH ARGUMENTS
C   LAST MOD: G. ECKERLIN 15/05/87 :  NEW COMMAND ZFIT (136) ADDED
C
C        ROUTINE CALLED FROM USER TO REQUEST SCANNER GUIDANCE.
C
C-----------------------------------------------------------------------
C
C  INDEX CONTAINS CURRENT USER INDEX VALUE.
C  W A R N I N G :   INDEX IS INCREMENTED ON RETURN.
C
C  XMIN,XMAX,YMIN,YMAX   HOLD CURRENT VIEW DIMENSIONS
C  SXIN,SXAX,SYIN,SYAX   HOLD CURRENT STANDARD VIEW DIMENSIONS
C               (OBTAINED BY CALLING SETSCL(0), SET BY GPHMAIN)
C  XMINR,YMINR,XMAXR,YMAXR  HOLD CURRENT MAGNIFIED DIMENSIONS
C               (SET BY SUBROUTINE JOYS)
C
C  ISTVW: 1 IF CURRENT VIEW IS STANDARD VIEW, OTHERWISE 0
C  FL18  TRUE IF PROJECTION
C  FL22  TRUE IF MAGNIFICATION ON
C  FL24  TRUE IF STANDARD VIEW IS MAGNIFIED
C
C  HCSTV2 SET TO 1 IF AUTO DISPLAY IS ON (DEFAULT)
C  HDISPN IS SET = HCSTV2. USED SEPARATELY IN COMMAND FIND
C  HCSTV3 IS SET TO 1 IF AUTO DETECTOR DISPLAY IS ON (DEFAULT -1)
C
C  IRFLG IS CARRYING FLAG NUMBER IN COMMAND SETF
C
C  HREVT IS USED IN COMMAND FIND, IS SET TO 1 IF EVENT FOUND
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL SSTPSR(10)
      LOGICAL DSPDTM
      LOGICAL FL18,FL22,FL24,DSPREM
C
      COMMON / CPROJ / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CVX   / NNPATR,ICRSTR,NNJETC
C
C                  NNPATR : FOR CHANGING PATR BANK NR
C                  NNJETC : FOR CHANGING JETC BANK NR
C                  ICRSTR STEERS RECORD FINDING IN COMMANDS WRIT N,
C                  WHERE SEVERAL EVENTS
C                  MAY BE READ BY SUPERV, BEFORE THE WANTED ONE APPEARS.
C                  SPECIAL CARE BY REWINDING UPON EOF ENCOUNTER.
C
#include "cgraph.for"
#include "cjdrch.for"
#include "cgeo1.for"
#include "clbpgm.for"
#include "cdata.for"
#include "cadmin.for"
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CSVCW1 / NDDSVE,NRWR
      COMMON / CHEADR / HEAD(108)
      COMMON / CSTANV / HDISPN, HCSTV2, HCSTV3
C
      EQUIVALENCE (NAME,A1)
C
      DATA  JETC/ 'JETC' /
      DATA  HREVT/ 0 /, IENTW/ 0 /
C
C
C------------------  C O D E  ------------------------------------------
C
C                            LSTCMD=112 IS COMMAND WRIT.
C                            IF WRIT N WAS GIVEN, SCANNR WILL RETURN TO
C                            READ A NEW EVENT UNTIL ICREC
C                            AND ICRSTR AGREE.
C
 2000 IF( LSTCMD .EQ. 112  .AND.  ICREC .NE. ICRSTR ) GO TO 2001
      IF( HREVT .EQ. 0 ) GO TO 2002
      IF( HEAD(18) .EQ. NRREQU  .AND.  HEAD(19) .EQ. NEREQU ) GO TO 2003
      IF( ICREC .NE. ICRSTR ) GO TO 2001
      CALL TRMOUT(80,' Requested event NOT FOUND on file.^')
      CALL PROMPT
C
2003  DO 2004  I = 1,10
        SSTPS(I) = SSTPSR(I)
2004  CONTINUE
      HREVT = 0
      IF( .NOT. SSTPS(2) ) GO TO 108
      GO TO 2002
2001  INDEX = 0
C
C                            RETURN TO USER, READ NEXT EVENT
C
      RETURN
C
2002  IRFLG =  0
      ISTVW =  1
      JTVW  = 60
      CALL SETSCL(0)
C                            SET CURRENT VIEW TO STANDARD VIEW
      LASTVW = ISTANV
C
      IF( HDISPN .NE. 1 ) GO TO 1
      DSPREM = DSPDTL(9)
      IF( ISTANV .EQ.  6  .OR.  ISTANV .EQ.  7  .OR.
     +    ISTANV .EQ. 10  .OR.  ISTANV .EQ. 11     ) DSPDTL(9) = .FALSE.
      IF( ISTANV .EQ. 17)  CALL SETSCL(ISTANV)
      CALL ERASE
      CALL EVDISP(ISTANV)
      IF( HCSTV3 .EQ. 1 ) then
         call setcol('JADE')    ! PMF 23/11/99: set colour
         CALL JADISP(ISTANV)
         call setcol(' ')       ! PMF 23/11/99: reset colour
      endif
      IF( DSPDTL(16)    ) CALL RSDISP(ISTANV)
      DSPDTL(9) = DSPREM
      IF( DSPDTL(17)    ) CALL PROJEC(ISTANV)
      HDISPN = 0
C
C                            ASK FOR A COMMAND
C
   1  CALL KOMMAN
      A  = ACMD
      AB = BCMD
      N  = A
      NB = AB
C
C                            EXECUTE COMMAND
C
C                            COMMANDS 1 - 100 ARE HANDLED BY DISPLY
C                            SINCE THESE DO NOT CHANGE /CWORK/ AND CAN
C                            BE CALLED FROM THE EDIT SUBSYSTEM.
C                            COMMANDS 1 - 30 ARE VIEWS
C
      IF( LSTCMD .GT. 100 ) GO TO 2
C
        CALL DISPLY
        GO TO 1
C
   2  ICOMD1 = ( LSTCMD - 101 ) / 10  +  1
      ICOMD2 = MOD( LSTCMD - 100, 10 )
      IF( ICOMD2 .EQ. 0 ) ICOMD2 = 10
C
      GO TO ( 1110, 1120, 2130, 3140 ) , ICOMD1
C
   5  CALL TRMOUT(80,'Software Error!  Please contact graphics expert^')
      CALL TRMOUT(80,'Command interpreter overflow in SCANNR^')
      RETURN
C
 1110 GO TO ( 101, 102, 103, 104, 105, 106, 107, 108, 109, 110) , ICOMD2
 1120 GO TO ( 111, 112, 113, 114, 115, 116, 117, 118, 119, 120) , ICOMD2
 2130 GO TO ( 121, 122, 123, 124, 125, 126, 127, 128, 129, 130) , ICOMD2
 3140 GO TO ( 131, 132, 133, 134, 135, 136,   5,   5,   5,   5) , ICOMD2
C
C
C             COMMAND  SPVA  (SPARE VIEW)
C
 101  CALL SPARE
      GO TO 1
C
C             COMMAND CLUS   (LG CLUSTER RESULTS DISPLAY)
C
 102  CALL YAMADA(N)
      GO TO 1
C
C             COMMAND   ZV
C
 103  DSPREM = DSPDTL(9)
      IF( LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7 ) DSPDTL(9) = .FALSE.
      IF( LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11 ) DSPDTL(9) = .FALSE.
      IF( N .EQ. 0 ) GO TO 1032
      DO  1031  I=1,30
        LBPGM(I) = 0
 1031 CONTINUE
      CALL ZVERTF
 1032 CALL ZINTER
      DSPDTL(9) = DSPREM
      GO TO 1
C
C             COMMAND GVTX   (VERTEX FIT OF CHOSEN TRACKS)
C
 104  CALL GVTXFT
      GO TO 1
C
C             COMMAND MUPT   (MUON RESULTS DISPLAY)
C             COMMAND MUONS  (= MUPT 1000 UNLESS ARGUMENT GIVEN)
C
 106  IF( ACMD .EQ. 0.0 ) ACMD = 1000.0
 105  DSPREM = DSPDTL(9)
      IF( LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7 ) DSPDTL(9) = .FALSE.
      IF( LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11 ) DSPDTL(9) = .FALSE.
      CALL MULDSP
      DSPDTL(9) = DSPREM
      IF( DSPDTL(17) ) CALL PROJEC(LASTVW)
      GO TO 1
C
C             COMMAND BDLS   (DELETE SINGLE BANK)
C
 107  IF( A .EQ. 0.0 ) GO TO 10700
         A1 = A
         GO TO 10701
10700 CALL TRMOUT(80,'PLease enter name of bank to be deleted:^')
      CALL TRMIN(4,NAME)
10701 IPNAME = IDATA(IBLN(NAME))
      IF( IPNAME .LT. 1 ) GO TO 1071
      LIM1 = IPNAME - 2
      NBOS = IDATA(LIM1)
      IF( NAME .NE. JETC ) GO TO 1072
C
C                            SPECIAL FOR JETC BANK
C
      IPNNEX = IDATA(IPNAME-1)
      NBOS2  = IDATA(IPNNEX-2)
      CALL BDLS('JETC',NBOS)
      CALL BRNM(JETC,NBOS2,JETC,NBOS)
      GO TO 1079
 1071 CALL TRMOUT(80,'The specified bank does not exist.^')
      GO TO 1
C
C                            CHECK IF MORE THAN ONE BANK
C                            WITH SAME NAME. IF SO, REQUEST NUMBER.
C
 1072 IF(IDATA(LIM1+1).EQ.0) GO TO 1077
      IF( AB .EQ. -100.0 ) GO TO 1078
      IF( AB .LE. 0.0  .OR.  AB .GT. 99.0 ) GO TO 10703
         NBOS = IFIX(AB)
         GO TO 1075
10703 CALL TRMOUT(80,'The following BOS bank numbers are present:^')
      LM1 = LIM1
 1073 CALL DIAGIN('                    ',1,IDATA(LM1),N,N,N,N,N)
      IF(IDATA(LM1+1).EQ.0) GO TO 1074
      LM1 = IDATA(LM1+1)-2
      GO TO 1073
 1074 CALL TRMOUT(80,'Please enter desired BOS bank number.^')
      CALL TRMOUT(80,'Enter -100 to delete ALL banks of this name:^')
      NBOS = TERNUM(DUMMY)
      IF( NBOS .EQ. -100 ) GO TO 1078
 1075 IF( NBOS .EQ. IDATA(LIM1) ) GO TO 1077
      IF( IDATA(LIM1+1) .NE. 0 ) GO TO 1076
      GO TO 1071
 1076 LIM1 = IDATA(LIM1+1) - 2
      GO TO 1075
 1077 NAME = IDATA(LIM1-1)
      CALL BDLS(NAME,NBOS)
      GO TO 1079
 1078 CALL BMLT(1,NAME)
      CALL BDLM
 1079 CALL BGAR(IGA)
      GO TO 1
C
C        COMMANDS WHICH CONTROL FURTHER PROGRESS THROUGH THE STEPS IN
C        USER
C
C             COMMAND    C   (CONTINUE TO NEXT STOPPING LEVEL)
C
 108  HDISPN = HCSTV2
      FL22   = FL24
      IF( .NOT. FL24) RETURN
9865  XMINR = SXIN
      XMAXR = SXAX
      YMINR = SYIN
      YMAXR = SYAX
      RETURN
C
C             COMMAND JUMP   (JUMP TO SPECIFIED LEVEL)
C
 109  IF( N .NE. 0 ) GO TO 1093
 1091 WRITE(JUSCRN,1092) INDEX
 1092 FORMAT(' Currently at USER level ',I4/
     +       ' Please enter next USER level:')
      N=TERNUM(DUMMY)
 1093 IF( N .GE. 0  .AND.  N .LE. 10 ) GO TO 1095
      WRITE(JUSCRN,1094) N
 1094 FORMAT('Illegal level ',I4,' requested. Please try again.')
      GO TO 1091
 1095 INDEX  = N - 1
      HDISPN = HCSTV2
      FL22   = FL24
      IF( .NOT. FL24 ) RETURN
      XMINR = SXIN
      XMAXR = SXAX
      YMINR = SYIN
      YMAXR = SYAX
      RETURN
C
C             UNUSED COMMAND
C
 110  CONTINUE
      GO TO 1
C
C        COMMANDS WHICH STEER THE PROCESSING OF FURTHER EVENTS.
C
C             COMMAND    N   (GO TO NEXT EVENT)
C
 111  INDEX = 0
 1111 IF( N .EQ. 0 ) N = 1
      NDES = ICREC + N
      IF( NDES .GT. 0 ) GO TO 3202
      WRITE(6,1112) ICREC,N
 1112 FORMAT(' Error: Negative EVENT NUMBER requested.'/
     +  ' The current EVENT NUMBER and the INCREMENT requested = ',2I6/
     +  ' Please enter a new command.')
      GO TO 1
 3202 IF( N .GT. 0 ) GO TO 1113
        REWIND NDDINN
        ICREC = 0
        CALL BDLS('+BUF',NDDINN)
        GO TO 1114
 1113 NDES = NDES - ICREC
C
C                           GET THE SUPERVISOR TO READ THE REQUIRED
C                           EVENT. HERE JUST SKIP N-1 EVENTS
C
 1114 NDES = NDES - 1
      IF( NDES .EQ. 0 ) GO TO 3201
C
      DO  3203  I = 1,NDES
        CALL BSLT
        CALL BDLG
        CALL BREAD(NDDINN,&3204,&3205)
        IF( IDATA(IBLN('HEAD')) .LE. 0 ) GO TO 3206
3207    ICREC = ICREC + 1
        GO TO 3203
3206    IFLG = 100
        CALL EVREAD(NDDINN,IRETU)
        IFLG = 0
        GO TO 3207
 3204   CALL MESSAG(1)
        GO TO 3203
 3205   REWIND NDDINN
        CALL BDLS('+BUF',NDDINN)
        CALL TRMOUT(80,'No such event. End-of-file encountered.^')
      CALL TRMOUT(80,'Action: Return to beginning of input file.^')
      WRITE(JUSCRN,1946) ICREC
 1946 FORMAT(' Note: There are ',I6,' events on this file.')
      CALL PROMPT
      ICREC = 0
      N=0
      GO TO 1111
 3203 CONTINUE
 3201 HDISPN = HCSTV2
      FL22   = FL24
      IF( .NOT. FL24 ) RETURN
      XMINR  = SXIN
      XMAXR  = SXAX
      YMINR  = SYIN
      YMAXR  = SYAX
      RETURN
C
C             COMMAND WRIT   (WRITE OUT EVENT(S) AND GO TO NEXT)
C
 112  INDEX  = 10
      IENTW  = IENTW + 1
      IF( IENTW .EQ. 1 ) CALL WALLOC
      NRTOT  = NRWR + NRWRIT + 1
      NRWRIY = NRWRIT + 1
      WRITE(6,2705) NRWRIY,NRTOT
2705  FORMAT(' No. of events written: ',I4,3X,
     +       ' No. of events on output file: ',I4)
      ICRSTR = ICREC + 1
      IF( N .NE. 0 ) ICRSTR = ICREC + N
      HDISPN = HCSTV2
      FL22   = FL24
      IF( FL24 ) GO TO 9865
      RETURN
C
C             COMMAND  STOP, END, EXIT, QUIT
C
 113  INDEX = 11
      CALL CLRCON
      RETURN
C
C        COMMANDS WHICH PERMANENTLY ALTER PARAMETERS, I.E. FOR CURRENT
C        AND SUBSEQUENT EVENTS.
C
C
C             COMMAND  CSTL  (CHANGE STANDARD STOPPING LEVELS)
C
 114  CALL STPLST
      GO TO 1
C
C             COMMAND  CSTV  (CHANGE STANDARD DEFAULT VIEW)
C
 115  IF( N .NE. 0 ) GO TO 3603
 3604 CALL TRMOUT(80,'List of options:^')
      CALL TRMOUT(80,' 1 Make the current view the  Standard View.^')
      CALL TRMOUT(80,' 2 Turn ON/OFF automatic display of new event.^')
      CALL TRMOUT(80,' 3 Turn ON/OFF detector with Standard View.^')
      CALL TRMOUT(80,'Please enter option number:^')
      N=TERNUM(DUMMY)
      IF(N.GE.1.AND.N.LE.3) GO TO 3603
      CALL TRMOUT(80,'No such option exists. Please try again.^')
      GO TO 3604
3603  IF(N.EQ.2) HCSTV2=-HCSTV2
      IF(N.EQ.3) HCSTV3=-HCSTV3
      IF(N.NE.1) GO TO 1
      ISTANV=LASTVW
      SXIN=XMIN
      SXAX=XMAX
      SYIN=YMIN
      SYAX=YMAX
      FL24 = FL22
      GO TO 1
C
C             UNUSED COMMAND
C
 116  CONTINUE
      GO TO 1
C
C             UNUSED COMMAND
C
 117  CONTINUE
      GO TO 1
C
C             COMMAND  EDIT  (EDIT PATTERN RECOGNITION RESULTS)
C
C
C             BEFORE CALLING PREDIT DO GARBAGE COLLECTION TO ASSURE THAT
C             JETC WILL NOT MOVE DURING EDITING. THIS WOULD DESTROY THE
C             VALIDITY OF THE PATTERN RECOGNITION'S CYCLIC POINTERS.
C
 118  CALL BGAR(IGARBA)
      CALL PREDIT
      GO TO 1
C
C             COMMAND  DEDX  (DISPLAY DEDX RESULTS ON SCREEN)
C
 119  call setcol('TEXT') ! PMF 25/11/99: set color
      CALL DEDXDS
      call setcol(' ') ! PMF 25/11/99: reset color
      GO TO 1
C
C             COMMAND  QP    (DISPLAY Q-PLOT & OTHER Q-OPTIONS)
C
 120  call setcol('TEXT') ! PMF 25/11/99: set color
      CALL QPLOTS
      call setcol(' ') ! PMF 25/11/99: reset color
      GO TO 1
C
C             COMMAND  TOF   (DISPLAY TOF RESULTS ON SCREEN )
C
 121  call setcol('TEXT') ! PMF 25/11/99: set color
      CALL TOFDS
      call setcol(' ') ! PMF 25/11/99: reset color
      GO TO 1
C
C             COMMAND  FIND  (DISPLAY TOF RESULTS ON SCREEN )
C
 122  IF( NB .NE. 0 ) GO TO 6203
 622  CALL TRMOUT(80,'Please enter desired RUN and EVENT numbers.^')
      CALL FYRINT(N,NB,IDM3,IDM4)
 6203 WRITE(JUSCRN,6201) N,NB
 6201 FORMAT(' Search will begin for RUN, EVENT',2I8)
      CALL TRMOUT(80,'Is this correct?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.2) GO TO 622
      DO 6221  I = 1,10
      SSTPSR(I) = SSTPS(I)
6221  SSTPS(I) = .FALSE.
      SSTPS(2) = .TRUE.
      NRREQU = N
      NEREQU = NB
      HDISPN=1
      HREVT=1
      ICRSTR=ICREC
      GO TO 2001
C
C             COMMAND  AX    (DISPLAY JET AXES AND RELATED RESULTS)
C
 123  DSPREM = DSPDTL(9)
      IF(LASTVW.EQ.6.OR.LASTVW.EQ.7) DSPDTL(9) = .FALSE.
      IF(LASTVW.EQ.10.OR.LASTVW.EQ.11) DSPDTL(9) = .FALSE.
      CALL AXSHOW
      DSPDTL(9) = DSPREM
      IF(.NOT.DSPDTL(17)) GO TO 1
      IF(LASTVW.GT.3.AND.LASTVW.NE.14) GO TO 1
      FL18 = .TRUE.
      LAST = LASTVW
      JVIEW = LASTVW + 3
      IF(LASTVW.EQ.14) JVIEW = 4
      ISTX = 3095
      IADD = 1000
      ISTY = 2250
      IF(JVIEW.NE.5) GO TO 1621
      ISTX = 3195
      IADD = 900
1621  CALL TWINDO (ISTX,ISTX+IADD,0,IADD)
      CALL SETSCL(JVIEW)
      DSPDTL(9) = .NOT.DSPDTL(9)
      CALL JADISP(JVIEW)
      LASTVW = JVIEW
      CALL AXSHOW
      CALL TWINDO (ISTX,ISTX+IADD,ISTY,ISTY+IADD)
      JVIEW = JVIEW + 4
      CALL SETSCL(JVIEW)
      CALL JADISP(JVIEW)
      LASTVW = JVIEW
      CALL AXSHOW
      DSPDTL(9) = .NOT.DSPDTL(9)
      CALL TWINDO (0,4095,0,4095)
      LASTVW = LAST
      CALL SETSCL(LAST)
      FL18 = .FALSE.
      IF(.NOT.FL22) GO TO 1
      XMIN = XMINR
      XMAX = XMAXR
      YMIN = YMINR
      YMAX = YMAXR
      CALL DWINDO (XMIN,XMAX,YMIN,YMAX)
      GO TO 1
C
C             COMMAND  FADC  (DISPLAY FLASH ADC RESULTS FOR TEST WIRES)
C
 124  CALL DSFADC
      GO TO 1
C
C             COMMAND  ZTRG  (DISPLAY FLASH ADC RESULTS FOR Z-TRIGGER)
C
 125  CALL ZTRGVW
      GO TO 1
C
C             COMMAND  NWCL  (RECAL. OF LG AND JETC DATA + REANALYSIS)
C
 126  CALL NEWCAL
      GO TO 1
C
C             COMMAND  FAMP  (DISPLAY OF FAMP RESULT (PATREC RESULTS..))
C
 127  CALL FAMPDS
      GO TO 1
C
C             COMMAND  ND50  (DISPLAY OF NORD 50 FOUND TRACKS)
C
 128  CALL N50SDS
      GO TO 1
C
C             COMMAND  MORE  (ALLOCATE ANOTHER INPUT DATASET)
C
 129  CALL MORE( IRETU )
      IF( IRETU .NE. 0 ) GO TO 1
        INDEX  = 0
        HDISPN = HCSTV2
        FL22   = FL24
        IF( .NOT. FL24 ) RETURN
        XMINR  = SXIN
        XMAXR  = SXAX
        YMINR  = SYIN
        YMAXR  = SYAX
        RETURN
C
C             COMMAND  VAC   (DRAW SIGNAL AMPLITUDES FOR SELECTED
C                             VERTEX CHAMBER CELL)
C
 130  CALL DSVAC
      GO TO 1
C
C
C        COMMANDS WHICH DEAL WITH MACROS
C
C             COMMAND  MACRO (DEFINE A SEQUENCE OF COMMANDS = MACRO)
C
 131  CALL DEFMAC
      GO TO 1
C
C             COMMAND  EDITMAC (EDIT A MACRO)
C
 132  CALL EDIMAC
      GO TO 1
C
C             COMMAND  DELMAC (DELETE A MACRO)
C
 133  CALL DELMAC
      GO TO 1
C
C             COMMAND  RENAMAC (RENAME A MACRO)
C
 134  CALL RENMAC
      GO TO 1
C
C             COMMAND  J68KDS (DISPLAY JET-CHAMBER RAWDATA)
C
 135  CALL J68KDS
      GO TO 1
C
C             COMMAND  ZFIT (DISPLAY Z-FIT WITH REJECTED/ACCEPTED HITS)
C
 136  CALL ZFIT
      GO TO 1
C
      END

C----------------------------------------------------------------------
C      MACRO CGEO3COM..  COMMENTS TO CONTENT OF COMMON /CGEO3/
C----------------------------------------------------------------------
C  ZMINM2 AND ZPLUM2 ARE DISTANCES FROM INTERACTION POINT TO FRONT SUR-
C  FACE OF -Z AND +Z FORWARD LEADGLASS, 1981-82 VERSION. THE BLOCK
C  DIMENSIONS ARE THE SAME AS FOR 1979-80, IN CGEO2
C
C  1983- ... TAGGING APPARATUS: LEAD SCINTILLATER UNITS
C  NRPBSC ARE NUMBER OF MODULES ON ONE SIDE IN Z
C  PBSCR1-4 ARE THE RADII FROM BEAMLINE TO SEGMENT JOINTPOINTS
C  PBSCZ1-4 GIVE THE Z COORDINATES, FROM MINUS Z TO PLUS Z
C------------------------ END OF MACRO CGEO3COM -----------------------

C   08/06/86 606092157  MEMBER NAME  SETUPG   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SETUPG
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   8/06/86 :  SETS UP DEFAULT GRAPHICS VALUES
C
C
C     SETS UP THE STANDARD VIEW, USER LEVEL STOP SETTING ETC.
C     DEFINES THE GRAPHICS COMMANDS USING DEFCMD. READS PROFILE.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
C
C------------------  C O D E  -----------------------------------------
C
C                            DEFINE THE STANDARD COMMANDS
C
      CALL DEFCMD
C
C                            READ THE PROFILE IF EXISTING
C
      CALL PROFIL
C
C                            EXECUTE THE DEFAULT SETTINGS MACRO
C
      CALL SETDEF
C
C                            SCALE SETTING
C
      CALL SETSCL(ISTANV)
C
      SXIN   = XMIN
      SXAX   = XMAX
      SYIN   = YMIN
      SYAX   = YMAX
C
      DO  10  I = 1,10
        SSTPS(I) = .FALSE.
        LSTPS(I) = 0
  10  CONTINUE
C
C                            SET THE DEFAULT STOPPING LEVELS
C
      SSTPS(2) = .TRUE.
      SSTPS(6) = .TRUE.
C
      CALL TRMOUT(80,'Stops will be made at the  USER LEVELS  2 and  6.
     +      ^')
      CALL TRMOUT(80,'They can be changed at any time by the command  CS
     +TL or LEVELS.^')
      CALL TRMOUT(80,'Use command "C" for going from LEVEL 2 to LEVEL 6^
     +')
      CALL TRMOUT(80,' ^')
      CALL TRMOUT(80,'Please type in your command when the arrow appears
     +.^')
      CALL TRMOUT(80,'Commands MENU and HELP list the available commands
     +.^')
      CALL TRMOUT(80,' ^')
C
      RETURN
      END

C   24/11/78 C9032101   MEMBER NAME  TERNUM   (JADEGS)      FORTRAN
      FUNCTION TERNUM(DUMMY)
      IMPLICIT INTEGER*2 (H)
      COMMON/CWORK1/HINN(5)
      LOGICAL*1 BLANK,POINT,MINUS,TNN(10)
      EQUIVALENCE(HINN(1),TNN(1))
      DATA BLANK/' '/
      DATA POINT/'.'/
      DATA MINUS/'-'/
    4 CONTINUE
      CALL TRMIN(10,HINN)
      NBP=0
      NREL=0
      SIGN=1.
      A=0.
      DO 1 I=1,10
      IF(TNN(I).EQ.BLANK) GO TO 1
      IF(TNN(I).EQ.MINUS) SIGN=-1.
      IF(TNN(I).EQ.MINUS) GO TO 1
      IF(TNN(I).NE.POINT) GO TO 2
      NREL=1
      GO TO 1
    2 IF(TNN(I).LT.240-192) GO TO 3 !PMF 19/11/99: substract 192 ( EBCDIC-> ASCII Code for numbers)
      IF(TNN(I).GT.249-192) GO TO 3 !PMF 19/11/99: substract 192
      INTD=TNN(I)-240+192         !PMF 19/11/99: substract 192
      A=10.*A+INTD
      NBP=NBP+NREL
    1 CONTINUE
      TERNUM=A/(10.**NBP)*SIGN
      GO TO 5
    3 CALL TRMOUT(80,'ILLEGAL CHARACTER. TRY AGAIN. STRING WAS:^')
      CALL TRMOUT(10,HINN)
      GO TO 4
    5 CONTINUE
      RETURN
      END

C   28/05/82 206291132  MEMBER NAME  CMUEDWRK (JADEMUS)     FORTRAN
C   27/05/82 205271447  MEMBER NAME  CMUEDWRK (S)           FORTRAN
C   17/06/81 106170953  MEMBER NAME  CMUED    (JADEMUS1)    FORTRAN
C   12/06/81 106151117  MEMBER NAME  CMUED    (S)           FORTRAN
C
C LAST CHANGE 11.20 29/06/82 HUGH MCCANN  - FIX BUG..PUT NCHAN IN/CMUED/
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C
      COMMON /CWORK/KTIME,HUPDAT(8370),HLOC(8370),IALPH,NHMUCA
C       N.B.  SEE  ALSO  CMUED.
C
C  THIS FITS IN WITHIN THE MAXIMUM SIZE OF CWORK....PATREC CWORK
C  IS APPROX 40 KBYTES.
C
      DIMENSION HMUCAL(8370)
      EQUIVALENCE (HMUCAL(1),MUCAL(1))
C  KTIME IS THE TIME AT WHICH THIS SET OF EDITS IS TO BE IMPLEMENTED
C         ( IN SECONDS FROM THE START OF 1979 VIA KTMCON)
C  HUPDAT IS AN ARRAY CONTAINING THESE NEW VALUES  (HUPDAT(I),I=1,NCHAN)
C  HLOC   IS AN ARRAY CONTAINING THEIR HALF-WORD ADDRESSES IN THE MUCAL
C         PART OF THE JADE CALIBRATION COMMON.
C  IALPH  IS THE NUMERICAL INDEX (1-20) OF THE ALPHABETIC IDENTIFIER OF
C         CURRENT MUCONE EDIT (ONLY USED DURING MUCONE OPERATIONS) .
C  NHMUCA IS THE HMUCAL LOCATION OF THE HMUCAL WORD WHICH IS CURRENTLY
C         BEING CHANGED ( ONLY USED DURING MUCONE OPERATIONS ).

C   19/04/79 111031114  MEMBER NAME  STHEAD0  (S)           FORTRAN
      SUBROUTINE STHEAD( LENGTH, IHEAD )
C-----------------------------------------------------------
C
C  VERSION OF 18/04/79  LAST MOD 03/11/81    E.ELSEN
C  SET FIRST 50 WORDS OF BANK 'HEAD', CONTAINING EVENT AND
C  RUN INFORMATION ( SEE JADE COMPUTER NOTE 23 )
C  EXTRA ENTRY LHHEAD RETURN LENGTH ONLY.
C----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
      DIMENSION IHEAD(50)
C
      COMMON / CGEO1 / BKGAUS
      DIMENSION HELP(2)
      EQUIVALENCE (IHELP,HELP(1))
      DATA HRCTYP / 1 /, HROPAT / Z61CC /
      DATA ICALL / 0 /
C
      IF( ICALL .GT. 0 ) GO TO 1
      ICALL = 1
      IPVECT = IBLN('VECT')
    1 CONTINUE
      IBEAM = 0
      NR = 0
      NPVECT = IW(IPVECT)
      IF( NPVECT .LE. 0 ) GO TO 2
      NR = IW(NPVECT+3)
      L0 = IW(NPVECT+1)
      IF( L0 .LE. 12 ) GO TO 2
      IBEAM = IW(NPVECT+13)
    2 CONTINUE
C
C
      CALL DATEMC( IHEAD(2) )
C
      HELP(1) = NR
      HELP(2) = HRCTYP
      IHEAD(6) = IHELP
C
      HELP(1) = HROPAT
      HELP(2) = 0
      IHEAD(7) = IHELP
C
      HELP(1) = IBEAM
      HELP(2) = BKGAUS * 1000.
      IHEAD(15) = IHELP
C
C-----------------------------------------------------------
      ENTRY LHHEAD( LENGTH )
C-----------------------------------------------------------
      LENGTH = 100
      RETURN
      END

CCC
      SUBROUTINE SHOWB(IUN,SBANK)
***********************************************************
*
*     Show contents of selected BOS banks
*
*     Mar./99:   Pedro Movilla Fernandez
*
*     INPUT:  IUN:   Logical unit number for fortran output
*             SBANK: String containing the names of the BOS
*                    banks, separated by blanks
*
***********************************************************
C
      IMPLICIT NONE
      INTEGER IND,IUN
      CHARACTER SBANK*(*)
C
C--- BOS Parameters
      INTEGER IW
      INTEGER*2 HW
      REAL RW
      COMMON /BCS/ IW(60000)
      DIMENSION HW(120000),RW(60000)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C
      INTEGER NBANKS
      PARAMETER (NBANKS=50)
C
      CHARACTER BK*4,SBK*200
      INTEGER I,K,IBLN,N
      LOGICAL FIRST
C
C Print names of available banks   
      CALL UBLANK(SBK,1,50)
      K=1
      WRITE(IUN,'(/'' SHOWB:'',/,T2,6(''=''))')
      DO I=1,NBANKS
         WRITE(BK,'(A4)') IW(IW(I)-3)  
         IF(IW(I).NE.0.AND.IBLN(BK).EQ.I) THEN
            SBK(K:K+3)=BK
            K=K+5
         ENDIF
      ENDDO
      WRITE(IUN,'('' Available banks:'',$)')
      WRITE(IUN,'(2X,A)') SBK
C
C Print names of selected banks   
      FIRST=.TRUE.
      DO I=1,NBANKS
         WRITE(BK,'(A4)') IW(IW(I)-3)  
         IF(IW(I).NE.0.AND.INDEX(SBANK,BK).NE.0.AND.IBLN(BK).EQ.I) THEN
            IF(FIRST) THEN
               WRITE(IUN,'('' Selected banks:'')')
               FIRST=.FALSE.
            ENDIF
            WRITE(IUN,'(T16,I3,2X,A4)') I,BK
         ENDIF
      ENDDO
      IF(FIRST) RETURN
C Show contents of selected banks
C      WRITE(IUN,'('' SHOW BANKS:'')')
      DO I=1,NBANKS
         WRITE(BK,'(A4)') IW(IW(I)-3)  
         IF(IW(I).NE.0.AND.INDEX(SBANK,BK).NE.0.AND.IBLN(BK).EQ.I)
     +        CALL SHWB1(IW(I),IUN)
      ENDDO
C
      RETURN
      END
CCC
      SUBROUTINE SHWB1(IND0,IUN)
      IMPLICIT NONE
**********************************************************
*
*     Shows contents of a BOS bank
*
*     Mar./99:   Pedro Movilla Fernandez
*
*     INPUT:  IUN:   Logical unit number for fortran output
*             IND0:  Index of the bank
*
**********************************************************
      INTEGER IND0,IUN
C BOS
      INTEGER IW
      INTEGER*2 HW
      REAL RW
      COMMON /BCS/ IW(60000)
      DIMENSION HW(120000),RW(60000)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      CHARACTER*4 NAME
C
      INTEGER K,M,I,N,IP,IQ,NR,IND
      INTEGER*2 H
C
      IND=IND0
      NR=0
      WRITE(IUN,'(/'' SHWB1:'',/,T2,6(''=''))')
 1000 WRITE(NAME,'(A4)') IW(IND-3)
C      WRITE(IUN,'(/)')
      WRITE(IUN,100) (IW(IND+K),K=-3,0),IND
C     
C Print bank contents
C
C
C------ LGCL-------
C
      IF(NAME.EQ.'LGCL') THEN
C General information
         WRITE(IUN,'(A)') '> GENERAL INFORMATION'
         CALL LPRI(IUN,IND,1,4,4,'I')
         CALL LPRI(IUN,IND,IW(IND+1),IW(IND+1)+5,6,'I')
         CALL LPRI(IUN,IND,IW(IND+1)+6,IW(IND+1)+9,4,'E')
         CALL LPRI(IUN,IND,IW(IND+1)+10,IW(IND+1)+10,1,'I')
         CALL LPRI(IUN,IND,IW(IND+1)+11,IW(IND+1)+14,4,'E')
         CALL LPRI(IUN,IND,IW(IND+1)+15,IW(IND+1)+20,6,'I')
C Cluster map
         WRITE(IUN,'(A)') '> CLUSTER MAP'
         CALL LPRI(IUN,IND,IW(IND+2),IW(IND+2)
     +             +IW(IND+IW(IND+1)+2),10,'H')
C Cluster information
         WRITE(IUN,'(A)') '> CLUSTER INFORMATION'
         DO N=1,IW(IND+IW(IND+1)+2)
            WRITE(IUN,'(A9,I3)') '> CLUSTER',N
            IP=IW(IND+3)+(N-1)*IW(IND+IW(IND+1)+20)-1
            CALL LPRI(IUN,IND,IP+1,IP+1,1,'I')
            CALL LPRI(IUN,IND,IP+2,IP+7,6,'E')
            CALL LPRI(IUN,IND,IP+8,IP+8,1,'I')
            CALL LPRI(IUN,IND,IP+9,IP+11,3,'E')
            CALL LPRI(IUN,IND,IP+12,IP+16,5,'E')
         ENDDO
C
C------ PATR ------
C
      ELSEIF(NAME.EQ.'PATR') THEN
         WRITE(IUN,'(A)') '> GENERAL INFORMATION'
         CALL LPRI(IUN,IND,1,3,3,'I')
         CALL LPRI(IUN,IND,4,4,1,'B')
         CALL LPRI(IUN,IND,5,8,4,'I')
         WRITE(IUN,'(A)') '> TRACK INFORMATION'
         DO N=1,IW(IND+2)
            WRITE(IUN,'(A)') '>'
            WRITE(IUN,'(A7,I3)') '> TRACK',N
            WRITE(IUN,'(A)') '>'
            IP=IW(IND+1)+(N-1)*IW(IND+3)
            CALL LPRI(IUN,IND,IP+1,IP+1,1,'I')
            IF (IW(IND-2).EQ.12) THEN
               CALL LPRI(IUN,IND,IP+2,IP+2,1,'H')
            ELSE
               CALL LPRI(IUN,IND,IP+2,IP+2,1,'B')
            ENDIF
            CALL LPRI(IUN,IND,IP+3,IP+3,1,'I')
            WRITE(IUN,'(A)') '> First and last point'
            CALL LPRI(IUN,IND,IP+4,IP+4,1,'I')
            CALL LPRI(IUN,IND,IP+5,IP+10,6,'E')
            CALL LPRI(IUN,IND,IP+11,IP+11,1,'I')
            CALL LPRI(IUN,IND,IP+12,IP+17,6,'E')
            WRITE(IUN,'(A)') '> Fit in xy-plane'
            CALL LPRI(IUN,IND,IP+18,IP+18,1,'I')
            CALL LPRI(IUN,IND,IP+19,IP+22,4,'E')
            CALL LPRI(IUN,IND,IP+23,IP+23,1,'E')
            CALL LPRI(IUN,IND,IP+24,IP+24,1,'I')
            CALL LPRI(IUN,IND,IP+25,IP+28,4,'E')
            WRITE(IUN,'(A)') '> Fit in rz-plane'
            CALL LPRI(IUN,IND,IP+29,IP+29,1,'I')
            CALL LPRI(IUN,IND,IP+30,IP+31,2,'E')
            CALL LPRI(IUN,IND,IP+32,IP+32,1,'E')
            CALL LPRI(IUN,IND,IP+33,IP+33,1,'I')
            WRITE(IUN,'(A)') '> Cells'
            CALL LPRI(IUN,IND,IP+34,IP+39,6,'I')
            WRITE(IUN,'(A)') '> Clusters'
            CALL LPRI(IUN,IND,IP+40,IP+43,4,'I')
            WRITE(IUN,'(A)') '> -'
            CALL LPRI(IUN,IND,IP+44,IP+44,1,'I')
            CALL LPRI(IUN,IND,IP+45,IP+46,2,'E')
            CALL LPRI(IUN,IND,IP+47,IP+47,1,'I')
            CALL LPRI(IUN,IND,IP+48,IP+48,1,'B')
            IF(IW(IND+3).EQ.62) THEN
               CALL LPRI(IUN,IND,IP+49,IP+52,4,'I')
               CALL LPRI(IUN,IND,IP+53,IP+56,4,'E')
               CALL LPRI(IUN,IND,IP+57,IP+58,2,'E')
               CALL LPRI(IUN,IND,IP+59,IP+59,6,'I')
               CALL LPRI(IUN,IND,IP+60,IP+62,3,'E')
            ENDIF
C
         ENDDO
C
C------ PALL ------
C
      ELSEIF(NAME.EQ.'PALL') THEN
         CALL LPRI(IUN,IND,1,6,6,'I')
         CALL LPRI(IUN,IND,7,8,2,'E')
         CALL LPRI(IUN,IND,9,9,1,'I')
         DO N=1,IW(IND+4)
            IP=IW(IND+1)+(N-1)*IW(IND+2)
            WRITE(IUN,'(A10,I3)') '> PARTICLE',N
            CALL LPRI(IUN,IND,IP+1,IP+5,5,'E')
            CALL LPRI(IUN,IND,IP+6,IP+9,5,'I')
         ENDDO
C
C------ VECT ------
C
      ELSEIF(NAME.EQ.'VECT') THEN
         IF (NR.EQ.0) THEN
            CALL LPRI(IUN,IND,1,6,6,'I')
            CALL LPRI(IUN,IND,7,8,2,'E')
            CALL LPRI(IUN,IND,9,9,1,'I')
            CALL LPRI(IUN,IND,10,13,4,'I')
            DO N=1,IW(IND+4)
               IP=IW(IND+1)+(N-1)*IW(IND+2)
               WRITE(IUN,'(A10,I3)') '> PARTICLE',N
               CALL LPRI(IUN,IND,IP+1,IP+5,5,'E')
               CALL LPRI(IUN,IND,IP+6,IP+7,2,'I')
               CALL LPRI(IUN,IND,IP+8,IP+10,3,'E')
            ENDDO
         ELSEIF(NR.EQ.1) THEN
            CALL LPRI(IUN,IND,1,4,4,'I')
            DO N=1,IW(IND+4)
               IP=IW(IND+1)+(N-1)*IW(IND+2)
               WRITE(IUN,'(A10,I3)') '> PARTICLE',N
               CALL LPRI(IUN,IND,IP+1,IP+5,5,'E')
               CALL LPRI(IUN,IND,IP+6,IP+7,2,'I')
               CALL LPRI(IUN,IND,IP+8,IP+10,3,'E')
               CALL LPRI(IUN,IND,IP+11,IP+11,1,'H')
               CALL LPRI(IUN,IND,IP+12,IP+12,1,'E')
            ENDDO
         ELSE
            WRITE(IUN,'(A5,I8,A)') '> NR=',NR
     +           ,' Something is wrong with VECT in SHWB1!!!'
            STOP
         ENDIF
C
C----- JETC  ------
C
      ELSEIF(NAME.EQ.'JETC') THEN
         CALL LPRI(IUN,IND,1,50,6,'H')
         CALL LPRI(IUN,IND,51,IW(IND),6,'H')
C
C----- ZVTX ------
C
      ELSEIF(NAME.EQ.'ZVTX') THEN
         CALL LPRI(IUN,IND,1,5,5,'E')
         CALL LPRI(IUN,IND,6,6,1,'I')
C
C----- VTXC ------
C
      ELSEIF(NAME.EQ.'VTXC') THEN
         CALL LPRI(IUN,IND,1,5,5,'I')
         CALL LPRI(IUN,IND,6,IW(IND),10,'H')
C
C----- JHTL LATC ------
C
      ELSEIF(NAME.EQ.'JHTL'.OR.NAME.EQ.'LATC') THEN
         CALL LPRI(IUN,IND,1,1,1,'H')
         CALL LPRI(IUN,IND,2,IW(IND),2,'B')
C
C----- ATOF ------
C
      ELSEIF(NAME.EQ.'ATOF') THEN
         CALL LPRI(IUN,IND,1,1,1,'H')
         CALL LPRI(IUN,IND,2,IW(IND),6,'H')
C
C----- TRIG ------
C
      ELSEIF(NAME.EQ.'TRIG') THEN
         CALL LPRI(IUN,IND,1,1,1,'H')
         CALL LPRI(IUN,IND,2,IW(IND),2,'B')
C
C
C----- HALFWORD BANKS ------
C
      ELSE
         CALL LPRI(IUN,IND,1,IW(IND),6,'H')
      ENDIF
      WRITE(IUN,'(/)')
C
 100  FORMAT(/'> BANK=',A6,'  NR= ',I6,'  PTR= '
     +     ,I6,'  N=   ',I6,'  IND=',I6) 
C     
      IF (IW(IND-1).NE.0) THEN
         IND=IW(IND-1)
         NR=NR+1
         GOTO 1000
      ENDIF
C
      RETURN
      END
CCC
      SUBROUTINE LPRI(IUN,IND,IA0,IB0,IC0,TYPE)
      IMPLICIT NONE
**********************************************************
*
*     Formatted line printing of bank contents
*
*     Mar./99:   Pedro Movilla Fernandez
*
*     INPUT:  IUN:  Logical unit number for fortran output
*             IND:  Index of the bank
*             IA0:  First word to be printed  
*             IB0:  Last word to be printed
*             IC0:  Number of words per line to be printed
*             TYPE: Print format:
*                   H:  INTEGER*2           ... I7
*                   I:  INTEGER*4           ... I14
*                   B:  Bit pattern         ... I1
*                   E:  Mantissa * Exponent ... E14.3
*
*
**********************************************************
C
      INTEGER IUN,IND,IA0,IB0,IC0,INDS
      SAVE INDS
      CHARACTER*1 TYPE 
      INTEGER IHELP
      DIMENSION IHELP(100)
C
C BOS Parameters
      INTEGER IW
      INTEGER*2 HW
      REAL RW
      COMMON /BCS/ IW(60000)
      DIMENSION HW(120000),RW(60000)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      CHARACTER*4 NAME
C      
      INTEGER K,M,I,IA,IB,IC,ICH,L,JBIT
      INTEGER*2 H
      CHARACTER FMT1*50,FMT2*100,CIA*4,CIB*4,CIC*2,CT*1,CW*2
C
C Check input
      IF(TYPE.EQ.'H') THEN
         IC=MIN(IC0,6)
      ELSEIF(TYPE.EQ.'E') THEN
         IC=MIN(IC0,8)
      ELSEIF(TYPE.EQ.'B') THEN
         IC=MIN(IC0,2)
      ELSE
         IC=MIN(IC0,10)
      ENDIF
      IB=MIN(IB0,IW(IND))
      IA=MIN(IA0,IB0)
C
C Compose format string
      WRITE(CIA,'(I4)') IA
      WRITE(CIB,'(I4)') IB
      WRITE(CIC,'(I2)') IC
      FMT1='('//'''> WORDS:'',T12,'//CIC//'I'//'18,/,'//'''>'''//')'
C
C Print out lines      
      IF(INDS.NE.IND) THEN
         WRITE(IUN,FMT=FMT1) (I,I=1,IC)
      ENDIF
      DO K=IA-1,IB-1,IC
         M=MIN(IB-K,IC)
         IF(TYPE.EQ.'H') THEN
            FMT2='('//'''> '''//',I4,'//'''-'''//',I4,3X,'
     +           //CIC//'(''|'',2I7,3X'//')'//')'
            DO I=1,2*M
               IHELP(I)=FLOAT(HW(2*IND+2*K+I))
            ENDDO
            WRITE(IUN,FMT=FMT2) K+1,K+M,(IHELP(I),I=1,2*M)
         ELSEIF(TYPE.EQ.'E') THEN
            FMT2='('//'''> '''//',I4,'//'''-'''//',I4,3X,'
     +           //CIC//'(''|'',E14.3,3X'//')'//')'
            WRITE(IUN,FMT=FMT2) K+1,K+M,(RW(IND+K+I),I=1,M)
         ELSEIF(TYPE.EQ.'B') THEN
            FMT2='('//'''> '''//',I4,'//'''-'''//',I4,3X,'
     +           //CIC//'(''|'',2(X,8I1,X),''/'',2(X,8I1,X)'//')'//')'
            DO I=1,2*M
               IHELP(I)=FLOAT(HW(2*IND+2*K+I))
            ENDDO
            WRITE(IUN,FMT=FMT2) K+1,K+M
     +           ,((JBIT(IHELP(I),L),L=16,1,-1),I=1,2*M)
         ELSE
            FMT2='('//'''> '''//',I4,'//'''-'''//',I4,3X,'
     +           //CIC//'(''|'',I14,3X'//')'//')'
            WRITE(IUN,FMT=FMT2) K+1,K+M,(IW(IND+K+I),I=1,M)
         ENDIF
      ENDDO
C
      INDS=IND
C
      RETURN
      END
C      

C   14/08/83 401161419  MEMBER NAME  CHIFT1   (S)           FORTRAN
      SUBROUTINE CHIFT1(X0,SIGX,Y0,SIGY,FITFCN,EPS,XB,YB,CHISQR)
C
C        ROUTINE TO FIND THE 'BEST' POINT (XB,YB) ON THE CURVE
C        Y=FITFCN(X), GIVEN THE INDEPENDENTLY MEASURED VALUES
C        X0 AND Y0, WITH STANDARD DEVIATIONS SIGX AND SIGY.
C
C        THE 'BEST' POINT IS THE POINT WHICH MINIMIZES CISQUARE,
C        GIVEN BY  CHISQ = ((X0-XB)/SIGX)**2 + ((Y0-YB)/SIGY)**2 .
C
C        THE ITERATION STOPS WHEN THE VALUES OF CHISQ FROM TWO CON-
C        SECUTIVE ITERATIONS DIFFER BY LESS THAN CHISQ*EPS,
C        OR WHEN THE NUMBER OF ITERATIONS REACHES ITRMAX (SET IN
C        DATA STATEMENT).
C
C        IF INPUT PARAMETERS ARE HOPELESS, NO FIT IS ATTEMPTED, AND
C        CHISQR IS SET TO 1.0E30.
C
C                                                  J.A.J.SKARD, 14/8/83
C                                                  J.A.J.SKARD,  6/1/84
C
      EXTERNAL FITFCN
C        MAX ITERATIONS
      DATA ITRMAX/10/
C        STEP SIZE IN X (FRACTION OF SIGX)
      DATA FACSTP/1.0/
C        STEP SIZE REDUCTION FACTOR FOR SUCCESSIVE ITERATIONS
      DATA FACRED/0.1/
C        LIMIT FOR PRINTOUT OF DIAGNOSTICS
      DATA IPRMAX/10/,IPR/0/
C        DEFINE CISQUARE AS AN INTERNAL STATEMENT FUNCTION
C        NOTE: LOGARITHMIC X-SCALE IS USED
      CHISQ(X)=(X0-EXP(X))**2*HX+(Y0-FITFCN(EXP(X)))**2*HY
C        GUARD AGAINST SOME OBVIOUS DISASTERS...
      IF(X0.LE.1.E-15)GO TO 10
      IF(SIGX.LT.1.E-15.OR.SIGY.LE.1.E-15)GO TO 10
      IF(ABS(Y0-FITFCN(X0)).LT.SIGY*1.E15.AND.SIGX.GT.1.E-15)GO TO 1
   10 IPR=IPR+1
      IF(IPR-IPRMAX)2,3,4
    2 WRITE(6,997)X0,SIGX,Y0,SIGY
  997 FORMAT(' *** CHIFT1: HOPELESS PARAMETERS. NO FIT ***',/,
     * 13X,'X0,SIGX,Y0,SIGY:',4E12.4)
      GO TO 4
    3 WRITE(6,998)
    4 XB=X0
      YB=Y0
      CHISQR=1.E30
      GO TO 100
C        PARAMETERS ARE NOT UTTERLY HOPELESS - TRY FITTING
    1 HX=1./(SIGX*SIGX)
      HY=1./(SIGY*SIGY)
C        CHANGE TO LOGARITHMIC X-SCALE
      X=ALOG(X0)
      DELX=AMIN1(FACSTP*SIGX/X0,5.)
      CHIM1=CHISQ(X)
      ITER=0
   11 CHI1=CHIM1
      ITER=ITER+1
   41 X=X+DELX
      CHI2=CHISQ(X)
C        CHECK IF WE STARTED OUT IN THE RIGHT DIRECTION
      IF(CHI1-CHI2)51,61,61
C        WE DID NOT. REVERSE DIRECTION.
   51 DELX=-DELX
      X=X+DELX
      SAVE=CHI1
      CHI1=CHI2
      CHI2=SAVE
C        KEEP STEPPING ALONG...
   61 X=X+DELX
      CHI3=CHISQ(X)
C        CHECK NEW CHISQUARE
      IF(CHI3-CHI2)71,81,81
C        STILL DECREASING, ONE MORE STEP..
   71 CHI1=CHI2
      CHI2=CHI3
      GO TO 61
C        FIND MINIMUM OF PARABOLA DEFINED BY LAST THREE POINTS
   81 DENOM=AMAX1(CHI3-2.*CHI2+CHI1,1.0E-10)
      X=X-DELX*((CHI3-CHI2)/DENOM+0.5)
      CHIM2=CHISQ(X)
C        ARE WE NEAR ENOUGH?
      IF(ABS(CHIM2-CHIM1).LT.CHIM1*EPS)GO TO 91
C        NOT YET - CHECK LIMIT OF ITERATIONS
      IF(ITER.LT.ITRMAX)GO TO 85
C        LIMIT OF ITERATIONS REACHED
      IPR=IPR+1
      IF(IPR-IPRMAX)82,83,91
   82 WRITE(6,999)ITRMAX
  999 FORMAT(' *** CHIFT1: LIMIT OF',I4,' ITERATIONS REACHED, FIT STOPPE
     *D ***')
      GO TO 91
   83 WRITE(6,998)
  998 FORMAT(' *** CHIFT1: DIAGNOSTICS TURNED OFF, LIMIT REACHED ***')
      GO TO 91
C        RESET PARAMETERS AND DO IT AGAIN
   85 CHIM1=CHIM2
C        REDUCE STEP SIZE
      DELX=DELX*FACRED
      GO TO 11
C        GOOD ENOUGH - TIDY UP AND QUIT
   91 CHISQR=CHISQ(X)
      XB=EXP(X)
      YB=FITFCN(XB)
  100 RETURN
      END

C   25/07/79 C9072601   MEMBER NAME  PRTOCI   (CS11)        FORTRAN
      SUBROUTINE PRTOCI( IND, CAP, RMIN, PHIMIT, SIG )
C *---------------------------------------------------------
C *  VERSION OF 25/07/79   LAST MOD  26/07/79   E.ELSEN
C *  FIND CIRCLE PARAMETERS FOR TRACK WITH POINTER IN IN PATR
C *  FOR PARABOLA FIT PARAMTERS IN PATR THE AREA BETWEEN CIRCLE
C *  AND PARBOLA IS MINIMIZED.
C *---------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
      DATA EPS / 1.E-7 /
C                                           BRANCH ACCORDING TO FIT TYPE
      IF( IW(IND+18) .EQ. 1 ) GO TO 1000
C                                           FIND LENGTH OF PARABOLA BRAN
      PSI = RW(IND+19)
      COSPSI = COS( PSI )
      SINPSI = SIN( PSI )
      X = (RW(IND+20)-RW(IND+5))*COSPSI + (RW(IND+21)-RW(IND+6))*SINPSI
      CURV = -RW(IND+22) * 2.
      SIG =1.
      IF( CURV .LT. 0. ) SIG = -1.
      CAP = CURV * SIG
      C = CAP
      EPSLOC = AMAX1( EPS, CAP * .001 )
C                                           INITIALISATION FOR NEWTON
C                                           APPROXIMATION
      ITER = 0
      A = 20. / ( 3.*X*X )
C                                           LOOP
  100 IF( ITER .GE. 10 ) GO TO 300
      ITER = ITER + 1
      PC = C*C*C + A*( C - CAP )
      PPC = 3.*C*C + A
      DC = - PC / PPC
      C = C + DC
      IF( ABS( DC ) .GT. EPSLOC ) GO TO 100
      CAP = C
C                                           COMPUTE STANDARD
C                                           PARAMETERS
  300 CONTINUE
      RHO = SIG / AMAX1( CAP, 1.E-8 )
      XCEN = RW(IND+20) + RHO*SINPSI
      YCEN = RW(IND+21) - RHO*COSPSI
      PHIMIT = ATAN2( YCEN, XCEN )
      RMIN = SQRT( YCEN*YCEN + XCEN*XCEN ) - ABS( RHO )
      RETURN
C
C                                           CIRCLE PARAMETERS
 1000 CAP = ABS( RW(IND+19) )
      RMIN = RW( IND+20 )
      PHIMIT = RW(IND+21)
      SIG = 1.
      IF( RW(IND+27) .LT. 0. ) SIG = -1.
      RETURN
      END

C   27/03/85 504191407  MEMBER NAME  MUANAB   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE  MUANAB
C-----------------------------------------------------------------------
C
C        THIS ROUTINES BEGINS MUON ANALYSIS BY EXTRACTING HEADER DATA
C
C      CHANGE 15.00 27/03/85 CHRIS BOWDERY- NEW ROUTINE
C LAST CHANGE 14.00 19/04/85 CHRIS BOWDERY- 29 FEB BUG CORRECTED
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            COMMONS
C
      COMMON / CMUPRN / MUPRIN,MUHPR
      COMMON / CMUIEV / IEV,NEV,IRD,KRUN,KREC,
     *                  ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C------------------  C O D E  ------------------------------------------
C
C                            INITIALISE HEADER PRINT CONTROL
C                            FLAG FOR THIS EVENT( USED IN MUERRY).
C
      MUHPR = 0
C
C                            COUNT THE EVENTS
C
      IEV = IEV + 1
C
C                            EXTRACT EVENT INFORMATION FROM HEADER BANK
C
      IPHEAD = IDATA(IBLN('HEAD'))
C
      ISECS  = HDATA(2*IPHEAD+3)
      IMINS  = HDATA(2*IPHEAD+4)
      IHOURS = HDATA(2*IPHEAD+5)
      IDAY   = HDATA(2*IPHEAD+6)
      IMONTH = HDATA(2*IPHEAD+7)
      IYEAR  = HDATA(2*IPHEAD+8)
      KRUN   = HDATA(2*IPHEAD+10)
      KREC   = HDATA(2*IPHEAD+11)
C
C                            CORRECT YEAR/RUN ANOMALIES
C
      IF( KRUN .GE.  2570  .AND.  KRUN  .LE. 2802 ) IYEAR = 1980
      IF( KRUN .GT.  6000  .AND.  IYEAR .LT. 1981 ) IYEAR = 1981
      IF( KRUN .GT. 10000  .AND.  IYEAR .LT. 1982 ) IYEAR = 1982
C
C                            FIX 29 FEBRUARY MISTAKE FOR NON-LEAP YEARS
C                            IT HAPPENED IN 1981.
C
      IF( IYEAR  .EQ. 1980  .OR.
     +    IYEAR  .EQ. 1984  .OR.
     +    IMONTH .NE. 2     .OR.
     +    IDAY   .NE. 29           ) GO TO 1
        IMONTH = 3
        IDAY   = 1
   1  CONTINUE
C
      RETURN
C
      END

C   23/03/97 703231223  MEMBER NAME  JEOSUM2  (SOURCE)      FORTRAN
C   19/02/80 002200259  MEMBER NAME  @CHK     (SOURCE)      FORTRAN
C        CHECK NEW ROUTINES
      DIMENSION IF(29)
      E=15.
      R=350.*SQRT(2.)
      YY=425
      DO 40 JY=1,29
      YY=YY-5.
      XX=275.
      DO 30 JX=1,29
      XX=XX+5.
      RR=XX*XX+YY*YY
      DR=SQRT((XX-350.)**2+(YY-350.)**2)
      DDR=0.
      IF(ABS(DR).GT.0.) DDR=(SQRT(RR)-R)/DR
      CALL POSEND(E,0.1*DR,DDR,FACT,&30)
      IF(JX)=FACT*1000.+0.5
30    CONTINUE
      WRITE(6,900) IF
900   FORMAT(29I4)
40    CONTINUE
      STOP
      END
C   09/03/79 002200411  MEMBER NAME  @CHKRTN  (SOURCE)      FORTRAN
C        CHECK NEW ROUTINES
      DIMENSION IF(29),A(15)
      EQUIVALENCE (A(1),IBE)
      DATA A/15*0./
      CALL LGINIT
      ZE=1522.
      ZE2=ZE*ZE
      IBE=1
      DO 40 I=10,20,5
      E=I
      DEP0=SHMAX(E*1000.,1)
      WRITE(6,950) E,DEP0
 950  FORMAT(' E,DEP=',2F12.3)
      YY=425
      DO 20 JY=1,29
      YY=YY-5.
      XX=275.
      DO 10 JX=1,29
      XX=XX+5.
      R=XX*XX+YY*YY
      RZ=SQRT(ZE2+R)
      R=SQRT(R)
      DEP=DEP0*ZE/RZ
      A(2)=E
      A(11)=ZE/RZ
      A(9)=XX/RZ
      A(10)=YY/RZ
      A(4)=XX
      A(5)=YY
      CALL LGECOR(A,DEP,IFLAG)
      IF(JX)=100.*E/A(2)
10    CONTINUE
      WRITE(6,900) IF
900   FORMAT(29I4)
20    CONTINUE
40    CONTINUE
      STOP
      END
C   10/03/79 209031402  MEMBER NAME  @LGHIST  (SOURCE)      FORTRAN
C
C    S.YAMADA   09-03-79  10:25
C     LAST MODIFICATION   09-03-79  23:25
C
C---- SIMPLE TEST PROGRAM FOR LGANAL FOR REAL DATA.
C
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(6000)
      DIMENSION  RDATA(6000),HDATA(12000)
      EQUIVALENCE (IDATA(1),RDATA(1)), (HDATA(1),IDATA(1))
C
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2000),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,CLMPRP(801)
      DIMENSION  MAPCL(51), HLGAD1(1000)
      EQUIVALENCE (MAPCL(1),CLMPRP(1)), (HLGADC(1,1),HLGAD1(1))
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON /CLGMSB/ AMSGVL(5)
      DIMENSION MSGVAL(5)
      EQUIVALENCE (AMSGVL(1),MSGVAL(1))
      COMMON /CTPCNS/ EBMGEV, BKGAUS
C
C---- INITIALIZATION
      CALL BINT(6000,4000,500,0)
C
      CALL LGINIT
      BKGAUS = 0.01
      ITH = 45
C
      NEV = 0
C
        DO 1000 N=1,300
C
C----   CHECK TIME
        IF( NTIME(DUM).LT.200 ) GO TO 100
C
        DATA NUNITI/1/
        CALL BREAD(NUNITI,&1000,&200)
C
        CALL KALIBR
        CALL CLOC( NPR,    'ALGN',1 )
        IF( NPR.GT. 0 ) GO TO 1
C
        CALL LGCALB(&1000)
C       LG-HIT MAP
    1   CALL LGHITM(JDMP)
        IF(JDMP.EQ.0) GO TO 30
        DATA JDCNT/0/
        JDCNT = JDCNT+1
        IF(JDCNT.GT.3) GO TO 30
                    WRITE(6,6666) N
 6666               FORMAT('0======== N=',I3,' ========')
                    CALL HPRS( 'HEAD',0)
                    CALL LGADCD(2,8)
                    CALL HPRS( 'ALGL',0)
C                   CALL BPRS( 'ALGN',1)
C                   CALL BPRS( 'ALGN',1)
C
   30   CALL LGANAL
C
C----   DUMP THE RESULTS
C       CALL LGSHOW
C       CALL LGADCD(2,5)
C----   SECOND STEP ANALYSIS
C       POINTERS OF THE NECESSARY BANKS
        NPPATR = 0
        NPR = 0
        NPCL = 0
        IPP = IBLN('PATR')
        NPPATR = IDATA(IPP)
C----   SHIFT NPPATR BY 1 TO SKIP THE BANK-DESCRIPTER WORD.
C----   TAKE ONLY 2-TRACK EVENTS
        IF( IDATA(NPPATR+2).NE.2) GO TO 20
        NEV = NEV+1
C
        CALL CLOC( NPR,    'ALGN',1 )
        CALL BLOC( NPCL,   'LGCL',1, &90)
        GO TO 10
C
C----   SOME BANK IS MISSING
   90   MSGVAL(1) =  NPPATR
        MSGVAL(2) =  NPR
        MSGVAL(3) =  NPCL
        CALL LGMESG( 1, 2 )
        GO TO 20
C
   10   CONTINUE
C***    CALL LGCDIR( NPPATR, NPR, NPCL )
        CALL LGHIST( NPCL )
C
C
   20   CALL BSLT
        CALL BDLG
C
 1000   CONTINUE
      GO TO 100
  200 MSGVAL(1) = N
      CALL LGMESG( 1,1 )
  100 WRITE(6,6100) N,NEV
 6100 FORMAT('0 NO.OF READ AND PLOTTED EVENTS=',2I6)
      CALL LGHITL
      CALL HISTDO
      STOP
      END
C
C/////////////////////////////////////////////////////
C
C
C---- DUMMY ENERGY CORRECTION
      SUBROUTINE LGECOR(ADATA,DEP,IFLAG)
C
C  THIS PROGRAM CALCULATE THE INCIDENT ENERGY
      IFLAG=0
      RETURN
C************************************
      ENTRY LGECR0(NVR)
C
C  VERSION NUMBER (DATE)   79 03 12    DUMMY SUB.
C
      DATA IVR/790312/
      NVR=IVR
      RETURN
      END
C   14/12/79 912140748  MEMBER NAME  @LGPROD  (SOURCE)      FORTRAN
C
C    S.YAMADA   09-03-79  10:25
C     LAST MODIFICATION   09-03-79  23:25
C
C---- SIMPLE TEST PROGRAM FOR LGANAL FOR REAL DATA.
C
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(24000)
      DIMENSION  ADATA(24000),HDATA(48000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
C
      COMMON /CLGMSB/ MSGVAL(5)
C
C---- INITIALIZATION
      DATA NUNITO,RPATR,RHEAD,RALGN,RLGCL/2,4HPATR,4HHEAD,4HALGN,4HLGCL/
      CALL BINT(24000,4000,500,0)
      CALL BINT1(200,100,10,0)
      CALL BWRO( NUNITO, 1558, 2)
C
      CALL LGINIT
C
        DO 1000 N=1,99999
        NTIM=JUHR(2)
        IF(NTIM.EQ.2) GO TO 300
C
        DATA NUNITI/1/
        CALL BREAD(NUNITI,&200,&200)
          IPNPHD = IBLN(RHEAD)
          NPHD = IDATA(IPNPHD)
          IF(NPHD.LE.0) GO TO 20
          NHPHD = NPHD+NPHD
C         HEXP=HDATA(NHPHD+ 9)
C         HRUN=HDATA(NHPHD+10)
C
          IPP = IBLN(RPATR)
          NPPR = IDATA(IPP)
        CALL LGANAL
C
C----   SECOND STEP ANALYSIS
C       POINTERS OF THE NECESSARY BANKS
        NPR = 0
        NPCL = 0
C----   SHIFT NPPATR BY 1 TO SKIP THE BANK-DESCRIPTER WORD IF IT'S THERE
        CALL CLOC( NPR,    RALGN,1)
        CALL CLOC( NPCL,   RLGCL,1)
        IF(NPCL) 90,90,10
C
C----   SOME BANK IS MISSING
   90   MSGVAL(1) =  NPPR
        MSGVAL(2) =  NPR
        MSGVAL(3) =  NPCL
        CALL LGMESG( 1, 2 )
        GO TO 20
C
   10   CALL LGCDIR( NPPR, NPR, NPCL )
20      CONTINUE
        CALL BSLW
        CALL BWRITE(NUNITO)
        CALL BSLT
        CALL BDLG
C
 1000   CONTINUE
      GO TO 100
  200 MSGVAL(1) = N
      CALL LGMESG( 1,1 )
      GO TO 100
300   WRITE(6,6200) N,(HDATA(HNPHD+J),J=9,11)
6200  FORMAT(' TIME OUT AT REC#,EXP#,RUN#,EV#',10I6)
100   CONTINUE
      CALL BMLT(0,DUMMY)
      CALL BWRITE(NUNITO)
      CALL BSLT
      CALL BDLG
      STOP
      END
C   09/03/79 008180717  MEMBER NAME  @LGTEST                FORTRAN
C
C    S.YAMADA   09-03-79  10:25
C     LAST MODIFICATION   09-03-79  23:25
C
C---- SIMPLE TEST PROGRAM FOR LGANAL FOR REAL DATA.
C
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(24000)
      DIMENSION  ADATA(24000),HDATA(48000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
C
#include "clgwork1.for"
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX,DZ
C
      COMMON /CLGMSB/ MSGVAL(5)
      COMMON /CTPCNS/ EBMGEV, BKGAUS
      DATA HRAN/0/
C
C---- INITIALIZATION
      DATA NUNITO,RPATR,RHEAD,RALGN,RLGCL/2,4HPATR,4HHEAD,4HALGN,4HLGCL/
      DATA RTRIG/4HTRIG/
      CALL BINT(24000,4000,500,0)
      CALL BINT1(200,100,10,0)
C     CALL BWRO( NUNITO, 1558, 2)
C        SET UP POINTERS BEFOREHAND
          IPHEAD = IBLN(RHEAD)
          IPTRIG = IBLN(RTRIG)
          IPPATR = IBLN(RPATR)
          IPALGN= IBLN(RALGN)
          IPLGCL= IBLN(RLGCL)
C
      CALL LGINIT
C     ITH = 45
C
C
        DO 1000 N=1,50
C       NTIM=JUHR(2)
C       IF(NTIM.EQ.2) GO TO 300
C
        DATA NUNITI/1/
        CALL BREAD(NUNITI,&200,&200)
C----   TEMPORARY SUBROUTINE TO MODIFY THE M.C. 'PATR' FORMAT.
C
C        CALL HPRS(RHEAD,0)
          NPHEAD = IDATA(IPHEAD)
          IF(NPHEAD.LE.0) GO TO 20
          NHHEAD = NPHEAD+NPHEAD
          HEXP=HDATA(NHHEAD+ 9)
          HRUN=HDATA(NHHEAD+10)
          CALL KALIB2
          HRAN=HRUN
        NPTRIG=IDATA(IPTRIG)
        IF(NPTRIG.LT.1) GO TO 20
        HBIT  =HDATA(NPTRIG+NPTRIG+10)
      WRITE(6,6000) N,HEXP,HRUN,HDATA(NHHEAD+11),HBIT
 6000 FORMAT(1H0,20(1H*),'REC#,EXP,RUN,EV#,TRG',4I6,Z8,50(1H*),/)
C
C
C----     TEST DUMP
         CALL PRALGN(0,0,10)
C        CALL PRALGN(1,0,10)
         CALL LGCALB(&20)
         CALL PRALGN(1,0,10)
C     IF(II.EQ.II) GO TO 20
C     PRALGN(I,J,K); I;0='ALGL'/0, 1='ALGN'/1
C                    J;0=NODECODING, 1=CRATE-SLOT, 2=IPHI-Z
C                    K=NO. DATA TO BE PRINTED PER LINE
          NPPATR = IDATA(IPPATR)
C       CALL PRLGCL
        CALL LGANAL
C
C----   DUMP THE RESULTS
CCCC    CALL LGSHOW
C       CALL LGADCD(2,5)
C       CALL PRALGN(1,0,10)
C       CALL PRALGN(1,2,10)
C
C----   CLUSTER DUMP
C       CALL PRLGCL
C
C----   SECOND STEP ANALYSIS
C       POINTERS OF THE NECESSARY BANKS
        NPALGN =IDATA(IPALGN)
        NPLGCL=IDATA(IPLGCL)
        IF(NPLGCL) 90,90,10
C
C----   SOME BANK IS MISSING
   90   MSGVAL(1) =  NPPATR
        MSGVAL(2) =  NPALGN
        MSGVAL(3) =  NPLGCL
        CALL LGMESG( 1, 2 )
        GO TO 20
C
   10   CALL LGCDIR( NPPATR, NPALGN, NPLGCL )
C
C       CALL BPRS(RPATR,NNN)
C       PRINT INNER DET.CHARGE TRACK TRACING RESULT
        CALL PRCLGC
C----   PRINT CHARGE AND LG-CLUSTER MATCHING TABLE
C       CALL PRITOL(3)
CCC     CALL PRCLGC
C       CALL PRLGCL
C       CALL LGESHW
        CALL PRLGCL
C----               PRINT 'PATR'
C                   NNN = IDATA(NPPR-2)
C                   CALL BPRS(RPATR,NNN)
C
20      CONTINUE
C       CALL BSLW
C       CALL BFIXP
C       CALL BWRITE(NUNITO)
        CALL BSLT
        CALL BDLG
C
 1000   CONTINUE
C//////////////
CCCC  CALL TMLOG(0)
C//////////////
      GO TO 100
  200 MSGVAL(1) = N
      CALL LGMESG( 1,1 )
      GO TO 100
300   WRITE(6,6200) N,(HDATA(HNPHD+J),J=9,11)
6200  FORMAT(' TIME OUT AT REC#,EXP#,RUN#,EV#',10I6)
100   CONTINUE
C     CALL BMLT(0,DUMMY)
C     CALL BFIXP
C     CALL BWRITE(NUNITO)
      CALL BSLT
      CALL BDLG
      STOP
      END
C   29/04/82 208252238  MEMBER NAME  @LGTOFCL (SOURCE)      FORTRAN
C
C        MAIN ROUTINE FOR LG-TOF CALIBRATION
C
C     S.YAMADA  29-04-82   09:40
C     LAST MODIFICATION  24-08-82   18:10
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON //BSPACE(35000)
      COMMON /BCS/ IDATA(40000)
      DIMENSION ADATA(40000)
      INTEGER *2 HDATA(80000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
      DATA LDATA/40000/
C
      COMMON /CTPMCT/ ICREC,MAXREC, NRUN,NRUN1,NRUN2,KRUN1,KRUN2,
     $                NTLEFT,NTOUT
C
      DATA ISTART/0/, ITD/0/
C
C---- INPUT UNIT=IUNIT,  OUTPUT UNIT=JUNIT
      IUNIT=1
      JUNIT=2
C
C---- SET THE RUN EXP-NUMBER RANGE TO BE COPIED.
C     NORMAL SEQUENCE IS ASSUMED.
      READ(5,500) MAXREC,NRUN1,NRUN2,MESG, ITD
  500 FORMAT(5I10)
C
      WRITE(6,602) MAXREC,NRUN1,NRUN2
  602 FORMAT('0*********** INPUT CONDITIONS ***********',
     $        /' MAXREC=',I10,'      NRUN1,NRUN2=',2I10)
C
      ICREC = 0
      ICRECO = 0
      JCREC = 0
      JCRECO = 0
      KRUN2 = 0
      CALL HBOOK1(1,'BTDC$',100,0.,2000.,0)
      CALL HBOOK2(20,'BADC VS ETOTB$',100,0.,40.,52,0.,2080.,0)
      CALL HBOOK2(22,'ETOTB(GEV) VS BTDC(CH)$',100,0.,2000.,50,0.,50.,0)
      CALL HBOOK2(2,'BADC VS BTDC$',100,0.,2000.,50,0.,2500.,0)
      CALL HBPROY(2,0)
      CALL HBOOK2(10, 'ETOTB VS CORRECTED TOF$',
     $                              100,-20.,20.,50,0.,50.,0)
      CALL HBPROX(10,0)
      CALL HSQUEZ( 3HYES )
C
      CALL BINT(LDATA,2000,1000,0)
CC    CALL BWRO( JUNIT, 1558, 2)
C
 1000 IF(ICREC.GE.MAXREC .AND. JCREC.GE.MAXREC ) GO TO 300
C
C----    CHECK TIME
      NTLEFT = NTIME(DUM)
      IF(NTLEFT.LT.100) GO TO 400
C
      CALL BREAD(IUNIT,&1001,&100)
      ICREC=ICREC+1
C
C          SET THE LAST RUN NO.
      CALL BLOC( NPHD, 'HEAD', 0, &1002 )
      NPHD2 = 2*NPHD
      NRUN=HDATA(NPHD2+9)*100000+HDATA(NPHD2+10)
C
      IF( NRUN.LT.NRUN1 ) GO TO 1010
      IF( NRUN.GT.NRUN2 ) GO TO 200
      IF( NRUN.EQ.KRUN2 ) GO TO 2000
      IF( KRUN1.EQ.0 ) GO TO 10
C
C---     NEW  RUN
      NEVIN  = ICREC-ICRECO-1
      NEVOUT = JCREC-JCRECO
      IF(MESG.GT.0) WRITE(6,600) KRUN2,ICRECO,NEVIN,NEVOUT,JCREC
  600 FORMAT(' RUN#',I8,' ICREC=',I7,'  EV.READ=',I6,' EV.WRITTEN=',
     $               I5,' JCREC=',I6)
C
C---  LG-TOF CALIBRATION OUTPUT
      IF(SUM.LE.0.) SUM = 1.0
      AVT = STDC/SUM
      WRITE(6,606) KRUN2, SUM,STDC,AVT
  606 FORMAT(' KRUN2=',I10,'  SUM,STDC,=',2F10.2,10X,'AVTOF=',F10.3,/)
      IF( SUM.GT.1. .AND. ABS( AVT-AVTO ).GT.50.0 )   CALL HPRINT(1)
      LRUN = HDATA(NPHD2+10)
      CALL HFILL(100,LRUN,AVT,1.0)
      SUM = 0.
      STDC = 0.
      AVTO = AVT
      CALL HRESET(1)
C---- BIG CHANGE BOUNDARY
      IF( KRUN2.NE.2010241 .AND. KRUN2.NE.2010263 .AND.
     *    KRUN2.NE.2010361 ) GO TO 10
C---- GET THE AVERAGE OF THE GROUP
      IF( BIGSUM.LE.0. ) BIGSUM = 1.0
      BIGAV = BIGTDC/BIGSUM
      WRITE(6,620 ) KRUN2, BIGSUM, BIGAV
  620 FORMAT('0BIG AVERAGE TILL RUN',I10,'   SUM=',F10.1,'  AV=',F10.2)
      BIGSUM = 0.
      BIGTDC = 0.
C---
   10 KRUN2 = NRUN
      ICRECO = ICREC
      JCRECO = JCREC
      IF( ISTART ) 20,20,2000
C---     NEW EVENT BEFORE ANY ANALYSIS.  REMEMBER THE FIRST RUN #.
   20               KRUN1 = NRUN
C----      SET UP FOR HITOGRAM FOR AV.TOF
           LRUN1 = HDATA(NPHD2+10)
           LRUN2 = LRUN1+500
           CALL HBOOK2(100,'AV.TOF VS RUN NO.$',100,LRUN1,LRUN2,
     *                                          60,700.,1300.,0)
           BIGSUM = 0.
           BIGTDC = 0.
                    ISTART = 1
C
C************  EVENT HIST ***************
 2000 CONTINUE
C---- CHECK TRIGGER
      NPTRG = IDATA( IBLN('TRIG') )
      JT1ACP = HDATA( 2*NPTRG+8 )
      JTB = MOD(JT1ACP,4096)/2048
      IF( JTB.NE.1 )                         GO TO 1010
C---- CHECK BARREL TDC
      NPATST = IDATA( IBLN('ATST') )*2
      BADC = HDATA(NPATST+4)
      BTDC = HDATA(NPATST+17)
      CBTDC = BTDC+280.0-70.0*(2.0-0.001*BADC)**2
        SUM = SUM+1.0
        STDC = STDC+CBTDC
        BIGSUM = BIGSUM+1.0
        BIGTDC = BIGTDC+CBTDC
      CALL HFILL( 1, CBTDC, BADC, 1.0)
      CALL HFILL( 2, CBTDC, BADC, 1.0)
C---- CORRELATION OF ETOTB AND BADC
      NPCL = IDATA( IBLN('LGCL') )
      ETOTB = ADATA( NPCL+12 )
      CALL HFILL(20,ETOTB, BADC, 1.0 )
      CALL HFILL(22, BTDC,ETOTB, 1.0)
C---- ALREADY CORRECTED ONE
      CALL LGBTDC( CTDC, JFLAG )
      IF( JFLAG.LE.0 ) CALL HFILL( 10, CTDC, ETOTB, 1.0 )
C
 2001 GO TO 1010
C
C---     READ ERROR ON INPUT DATA SET
 1001 CALL TPMESG(1)
      GO TO 1010
C
C----    HEADER IS MISSING
 1002 CALL TPMESG(2)
C
C----    ERASE ALL BANKS FOR THE NEXT EVENT.
 1010 CALL BSLT
      CALL BDLG
      GO TO 1000
C
  100 CALL TPMESG(21)
      GO TO 10000
  200 CALL TPMESG(22)
      GO TO 10000
  300 CALL TPMESG(23)
      GO TO 10000
  400 CALL TPMESG(24)
C
10000 CONTINUE
C---- GET THE AVERAGE OF THE GROUP
      IF( BIGSUM.LE.0. ) BIGSUM = 1.0
      BIGAV = BIGTDC/BIGSUM
      WRITE(6,620 ) KRUN2, BIGSUM, BIGAV
      NEVIN  = ICREC-ICRECO
      NEVOUT = JCREC-JCRECO
      IF(MESG.GT.0) WRITE(6,600) KRUN2,ICRECO,NEVIN,NEVOUT,JCREC
      CALL BSTA
      CALL HSQUEZ( 2HNO )
      CALL HPRINT(2)
      CALL HPRINT(10)
      CALL HPRINT(20)
      CALL HPRINT(22)
      CALL HPRINT(100)
      STOP
      END
C   16/02/79 107080122  MEMBER NAME  CDATA    (SOURCE)      FORTRAN
C
      COMMON /BCS/ IDATA(24000)
      DIMENSION ADATA(24000)
      INTEGER *2 HDATA(48000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
      DATA LDATA/24000/
C
C   16/02/79 107080122  MEMBER NAME  CLGKALB  (SOURCE)      FORTRAN
C     LHO'S GENERAL CONSTANT SCHEME
C     20/09/79.
      COMMON/CALIBR/NCAL(10000)
      INTEGER*2 HCAL(20000)
      EQUIVALENCE  (NCAL(1),HCAL(1))
C
C   16/02/79 107080122  MEMBER NAME  CLGWORK1 (SOURCE)      FORTRAN
C     USED IN LGANAL PART OF PROGRAMS
C        NO CUTS ON MAX FIRIED #CHANNELS (I.E. DIMENSION=2880)
C        CHANGE SIZE OF THE CLUSTER BANK TO 16.. 13/6/80
C        CHANGED BY Y.WATANABE ON 23/09/79. 00:30
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,
     3               MAPCL(81),  CLPRP(1280)
      INTEGER *2 HMAPCL(2,81)
      DIMENSION ICLSPR(16,80),CLSPRP(16,80), CLMPRP(1361)
      EQUIVALENCE (HMAPCL(1,1),MAPCL(1)), (CLMPRP(1),MAPCL(1))
      EQUIVALENCE (ICLSPR(1,1),CLPRP(1)),  (CLSPRP(1,1),CLPRP(1))
C
C   16/02/79 107080122  MEMBER NAME  CLGWORK2 (SOURCE)      FORTRAN
C     USED IN LGCDIR PART OF ANALYSIS
C     INCREASE UP TO 100 TRACKS ON 20/9/79
      COMMON /CWORK/ NCHCLS,NPOINT,MAPCCL(101),HCLADR(1600),
     $               NCHCL2,HCLIST(4,100),  NCLST2,HCLLSO(4,80)
      DATA NPMAX/1600/

C   31/08/79 C9083101   MEMBER NAME  PATDUM   (JADENS)      FORTRAN
      SUBROUTINE INPATC
      RETURN
      END
      SUBROUTINE INPATR
      RETURN
      END
      SUBROUTINE PATREC
      RETURN
      END

C   05/02/79 C9032101   MEMBER NAME  REPSIT   (JADEGS)      FORTRAN
      SUBROUTINE REPSIT(IUNIT)
C---
C---     REPOSITIONS A FILE SO THAT THE SECOND LOGICAL RECORD IS READY
C---     TO BE READ.
C---
      REWIND IUNIT
      READ(IUNIT) IDUMMY
      RETURN
      END

C   19/08/82 411121150  MEMBER NAME  TOFDSBN  (S)           FORTRAN
      SUBROUTINE TOFDS
C--
C--     TOF DISPLAY FOR JADE, USING TOF PROGRAM FROM B.NAROSKA,KAWABATA
C--     TOF DISPLAY FOR JADE LEAD GLASS, USES YAMADA PROGRAM LGBTOF
C--     14.05.80       LAST CHANGE 28.05.82          J.OLSSON
C--     14.05.80       LAST CHANGE 1.7.82          B.NAROSKA
C---
      IMPLICIT INTEGER*2 (H)
      LOGICAL FL18,FL22,FL24
      COMMON /CHEADR/ HEAD(108)
      COMMON /CWORK1/ HMW(112)
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      DIMENSION RE(14,50),HTYP(4,4)
      EQUIVALENCE (RE(1,1),IR(1,1))
#include "cgraph.for"
#include "cdata.for"
      DATA HTYP /'  ','PR','OT','ON','  ','  ','KA','ON',
     $           '  ','  ','PI','ON','EL','EC','TR','ON'/
      DATA HBLANK /'  '/
C----------------------------------------
      NN = ACMD
      IF(NN.EQ.-3) GO TO 2110
      IPPATR = IDATA(IBLN('PATR'))
      IF(IPPATR.GT.0) GO TO 98
      WRITE(6,97)
97    FORMAT(' ERROR ----->>   PATR BANK DOES NOT EXIST')
      RETURN
98    IPATOF = IDATA(IBLN('ATOF'))
      IF(IPATOF.GT.0) GO TO 96
      WRITE(6,95)
95    FORMAT(' ERROR ----->>   ATOF BANK DOES NOT EXIST')
96    CONTINUE
      DO 107  I = 1,50
      DO 107  J = 1,14
107   IR(J,I) = 0
C---   CALL TOF PROGRAM HERE
      NRUN = HEAD(18)
      CALL TOFINT(NRUN,IPATOF,IPPATR,&1000)
      IF(NN.GE.0) GO TO 99
      IF(NN.EQ.-1) GO TO 91
C SHOW DIAGRAM BETA VS MOMENTUM
      CALL TOFVW
      RETURN
91    CALL TOFBK
      RETURN
2110  IF(HEAD(18).GT.10000) GO TO 2111
      CALL TRMOUT(80,'LEAD GLASS TOF NOT AVAILABLE FOR RUNS < 10000^')
      RETURN
2111  CALL LGBTDC(BLGTOF,LGFLA)
      IF(LGFLA.LT.2) GO TO 2112
      WRITE(6,4415) BLGTOF
4415  FORMAT(' WARNING **** ERROR FLAG >= 2, LG TOF VALUE ',E12.4)
      RETURN
2112  IF(LGFLA.LT.1) GO TO 2113
      WRITE(6,4416) BLGTOF
4416  FORMAT(' WARNING * LAST CALIBRATION RUN EXCEEDED, LGTOF = ',F8.2)
      RETURN
2113  WRITE(6,4417) BLGTOF
4417  FORMAT(' ERROR CODE = 0,  LGTOF = ',F8.2)
      RETURN
C---
99    CONTINUE
C--   LOOP OVER TRACKS
      WRITE(6,1381)
 1381 FORMAT(' TR.IFL.CN..MOM...TIME..PATH.TAUM1.TAUP1.IE..BETA..ZTOF..Z
     *TOFE.TDCL/R..ADCL/R'/)
      NCON = INFM(1)
      DO 111  ITR = 1,NCON
      LTR = IR(1,ITR)
      IF(NN.GT.0.AND.NN.NE.LTR) GO TO 111
      PP = TRK(4,LTR)
      IF(ABS(PP).LT.1.) PP = PP*1000.
      WRITE(6,1379) (IR(I,ITR),I=1,3),PP,(RE(I,ITR),I=4,5),(RE(I,ITR),I=
     & 10,11),IR(12,ITR),(RE(I,ITR),I=13,14),TRK(1,LTR),
     & (RE(I,ITR),I=6,9)
1379  FORMAT(' ',3I3,F7.1,F5.1,F7.0,2F6.1,I3,F6.2,2F6.0,1X,4F4.0)
111   CONTINUE
C
      RETURN
1000  WRITE(6,1001)
1001  FORMAT(' ERROR RETURN 1 FORM TOFINT ****')
      RETURN
      END

C   20/12/85 512202013  MEMBER NAME  GMTEXT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE GMTEXT(IPP,NTRRES,KCNT,IGMX)
C-----------------------------------------------------------------------
C
C     WRITE RESULT TABLE FOR A SINGLE CLUSTER
C         J.OLSSON,  18.07.79           LAST CHANGE 11.12.81
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON /CJTRIG/ PI,TWOPI
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
     $,PMOM,PZ,PTRANS,RMS,NHTF,RAD,RAD1,THE,PHI,XXX,YYY,SSS
C
      DIMENSION HSIGN(3),HDETEC(3,2),HPART(3,2),HTRCK(3)
C
      DATA HDETEC/'BA','RR','EL','EN','DC','AP'/
      DATA HPART/'PH','OT','ON','CH','AR','GE'/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------   C O D E  -----------------------------------------
C
      JPART = IDATA(IPP + 1)
      JPART = IABS(JPART) + 1
      DO 2354  I = 1,3
2354  HSIGN(I) = HDETEC(I,JPART)
      JTYP = IDATA(IPP + 8)
      IF(JTYP.NE.0) JTYP = 1
      DO 2355  I = 1,3
2355  HTRCK(I) = HPART(I,JTYP+1)
C** WRITE OUT VALUES
      IF(DSPDTL(14).AND.NTRRES.NE.KCNT.AND.NTRRES.NE.0.AND.LASTVW.EQ.13)
     $ GO TO 2287
      CALL CORE(HWORK,80)
      IF(JTYP.EQ.1)
     + WRITE(cHWORK,221) KCNT,(HSIGN(I),I=1,3),(HTRCK(I),I=1,3)! PMF 17/11/99: UNIT=10 changed to cHWORK
     $ ,IDATA(IPP+8)
221   FORMAT('NR ',I2,'   ',3A2,'   ',3A2,' ',I3)
      IF(JTYP.EQ.0) 
     +     WRITE(cHWORK,227) KCNT,(HSIGN(I),I=1,3),(HTRCK(I),I=1,3)! PMF 17/11/99: UNIT=10 changed to cHWORK
     $ ,IGMX
227   FORMAT('NR ',I2,'   ',3A2,'   ',3A2,' ',I2)
      IF(JTYP.EQ.1) NLGT = 27
      IF(JTYP.EQ.0) NLGT = 26
      CALL SYSSYM(XXX,YYY,SSS,HWORK,NLGT,0.)
      YYY = YYY - 1.5*SSS*.75 !PMF 20/11/99: add factor .75
      PHI = ATAN2(ADATA(IPP+10),ADATA(IPP+9))
      IF(PHI.LT.0.) PHI = PHI + TWOPI
      COSTH = ADATA(IPP+11)
C     IF(JPART.EQ.2) GO TO 2356
C     PHI = ADATA(IPP+4)
C     THE = ATAN2(ADATA(IPP+5),RLG)
C     THE = PI*.5 - THE
C     GO TO 2357
C2356  RR = SQRT(ADATA(IPP+4)**2 + ADATA(IPP+5)**2)
C      THE = ATAN2(RR,ZENDPL)
C      IF(IDATA(IPP+1).LT.0) THE = PI - THE
C      PHI = ATAN2(ADATA(IPP+5),ADATA(IPP+4))
C      IF(PHI.LT.0.) PHI = PHI + TWOPI
2357  PHI = PHI*180./PI
C     COSTH = COS(THE)
      CALL CORE(HWORK,80)
      WRITE(cHWORK,222) ADATA(IPP+2),PHI,COSTH ! PMF 17/11/99: UNIT=10 changed to cHWORK
222   FORMAT('E ',F7.3,' FI ',F5.1,' COST',F6.3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
      GO TO 2277
2287  YYY = YYY - 1.5*SSS*.75 !PMF 20/11/99: add factor .75
2277  YYY = YYY - 2.*SSS*.75 !PMF 20/11/99: add factor .75
      RETURN
      END

C   12/03/84 406222019  MEMBER NAME  SORT2    (S)           FORTRAN
C
C
C
C
       SUBROUTINE SORT2(ICLUS)
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   THIS ROUTINE SORTS A SINGLE CLUSTER INTO ORDER OF ENERGY
C   SO THAT BY THE END CLUS(I,1) = ADDRESS,CLUS(I,2) = ENERGY
C   AND CLUS(I,2 ) >CLUS(I + 1,2)
C
C  ICLUS - INPUT - POINTER TO CLUSTER IN CLUSTER MAP CMAP(10,9)
C                  PRODUCED BY CLSPS
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
#include "comtag.for"
CC
#include "cwktag.for"

       DIMENSION STEMP(2)
C
       NNEI = NLIST(CMAP(ICLUS,1),1,MARK)
       IEND = NNEI + 1
       DO 5 I = 1,IEND
C
C                                   GET ADDRESS FROM CLUSTER MAP
C                                   AND ENERGY FROM CATAG
C
          CLUS(I,1) = CMAP(ICLUS,I)
          CLUS(I,2) = CATAG(CLUS(I,1))
    5  CONTINUE
C
C                                   RIPPLE SORT
C
       DO 10 J = 1 ,NNEI
          DO 11 K = 1,NNEI
             IF ( CLUS(K,2) .GT. CLUS(K+1,2) )  GOTO 11
             STEMP(1)    = CLUS(K,1)
             STEMP(2)    = CLUS(K,2)
             CLUS(K,1)   = CLUS(K+1,1)
             CLUS(K,2)   = CLUS(K+1,2)
             CLUS(K+1,1) = STEMP(1)
             CLUS(K+1,2) = STEMP(2)
   11     CONTINUE
   10  CONTINUE
  100  RETURN
       END

C   01/11/84 605221021  MEMBER NAME  JADISP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JADISP(INDEX)
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON   PREHISTORY :  DRAW JADE DETECTOR
C
C        MOD: C. BOWDERY     9/04/84 :  IMPROVED Z CHAMBER DISPLAY
C        MOD: S. CARTWRIGHT 11/04/84 :  STILL BETTER Z-CH DISPLAY
C        MOD: C. BOWDERY    26/04/84 :  RADICAL CHANGES TO STRUCTURE
C        MOD: C. BOWDERY    24/05/84 :  FWCAP CALL CHANGED TO DRAWFD(1)
C        MOD: C. BOWDERY     7/06/84 :  NEW COMMAND NUMBERS
C        MOD: C. BOWDERY    18/06/84 :  VRXCIR NO LONGER CALLED HERE
C        MOD: C. BOWDERY    20/06/84 :  SET DETDRW FLAG WHEN CALLED
C        MOD: C. BOWDERY    27/06/84 :  CHANGES FOR VERTEX CHAM/BP CNTRS
C        MOD: J. HAGEMANN   19/10/84 :  SPECIAL VERTEX CHAMBER VIEW
C                                       ADDED (INDEX = 20)
C   LAST MOD: J. HAGEMANN   22/05/86 :  FLAG NEWDET NOW SWITCHED BY FLAG
C                                       LVTXC IN COMMON / CVCEX / FOR
C                                       MC DATA AND BY FLAG LNHARD FOR
C                                       REAL DATA
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL INNERC,LEADGL,MUONFL,PHNUMS,PHHIST
      LOGICAL DSPDTM,ZCHAMR,NEWDET,ZCBK,VXBK,VTXCHR,DRVTXC
      LOGICAL DETDRW,REDRDT,LVTXC,LNHARD
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CVCEX  / LVTXC
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CGRAP6 / DETDRW
C
      COMMON / CWORK1 / VTXCHR,JNDEX,INNERC,LEADGL,MUONFL,
     +                  PHNUMS,PHHIST,ZCHAMR,NEWDET,ZCBK,VXBK,DRVTXC
C
#include "cgraph.for"
#include "cadmin.for"
#include "cgeo1.for"
#include "cdata.for"
C
C------------------  C O D E  ------------------------------------------
C
      JNDEX  = INDEX
      IF( INDEX .GT. 7 ) JNDEX = INDEX - 4
C
      IF( INDEX .GT.  0  .AND.  INDEX .LT. 21 ) GO TO 1
      RETURN
C
   1  LASTVW = INDEX
      DETDRW = .TRUE.
C
C                            NEW DETECTOR HARDWARE IN MONTE-CARLO DATA?
C                            THEN LVTXC IS TRUE (FLAG IS CHECKED AND
C                                                SET IN RDMTCO)
C
      LNHARD = (HEAD(15) .GE. 5  .AND.  HEAD(16) .EQ. 1984)
     +                          .OR.   HEAD(16) .GE. 1985
      NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
     +
      INNERC = JNDEX .LE. 7  .AND.  DSPDTL(1)
C
      LEADGL = ( JNDEX .EQ. 2  .OR.  JNDEX .EQ. 3 .OR.
     +           JNDEX .EQ. 5  .OR.  JNDEX .EQ. 6 .OR.
     +           JNDEX .EQ. 7                        )  .AND.  DSPDTL(2)
C
      MUONFL = ( JNDEX .EQ. 3  .OR.  JNDEX .EQ. 6  .OR.  JNDEX .EQ. 7 )
     +                        .AND.  DSPDTL(3)
      PHNUMS = LEADGL  .AND.  ( .NOT. DSPDTL(7) )
      PHHIST = LEADGL  .AND.  DSPDTL(7)
C
C                            SET Z CHAMBER DRAWING FLAG
C                            IF CDTL 41 SET  AND 1 OF THE FOLLOWING:
C                             - CDTL 42 SET (DRAWING FORCED)
C                             - DATE OF EVENT IS MAY 1984 OR AFTER
C                             - Z CHAMBER BANK PRESENT
C
      ZCBK   = IDATA( IBLN( 'ZETC' ) ) .GT. 0
      ZCHAMR = DSPDTM(11)  .AND.  (DSPDTM(12)  .OR.  NEWDET  .OR.  ZCBK)
C
C                            SET VERTEX CHAMBER AND NEW SMALL BEAM PIPE
C                            FLAG IF ONE OF THE FOLLOWING IS TRUE
C                             - CDTL 44 SET (DRAWING FORCED)
C                             - DATE OF EVENT IS MAY 1984 OR AFTER
C                             - VERTEX CHAMBER BANK PRESENT
C                            DRAW VERTEX CHAMBER IF ABOVE FLAG SET AND
C                            IF CDTL 43 SET.
C
      VXBK   = IDATA( IBLN( 'VTXC' ) ) .GT. 0
      VTXCHR = DSPDTM(14)  .OR.  NEWDET  .OR.  VXBK
      DRVTXC = DSPDTM(13)  .AND.  VTXCHR
C
      NECC   = ACMD
      IF(  INDEX .EQ. 20 ) GO TO 10
      IF(  JNDEX .GT.  3  .AND.  INDEX .NE. 17 ) GO TO 3
C
C                            LSTCMD = 38   IS DET
C
      IF( LSTCMD .EQ. 38  .AND.   NECC .NE.  0 ) GO TO 2
C
C
C                            ***************
C                            *  RFI-VIEWS  *
C                            ***************
C
C                                      BEAM PIPE
C
   10 CALL DRAWBP( 1 , VTXCHR )
C
C                                      BEAM PIPE COUNTERS
C
      IF( .NOT. VTXCHR ) CALL BARSEC(PI/24.0,0.,0.,RBPC,
     +                               RBPC+DRBPC,0.,0.,24,PI/12.0,0.)
C
C                                      VERTEX CHAMBER
C
      IF( DRVTXC ) CALL DRAWVC( 1 , JNDEX )
C
C                                      INNER DETECTOR
C
      IF( INDEX .EQ. 20 ) INNERC = .TRUE.
C
      IF( INNERC ) CALL DRAWID( 1 )
C
      IF( INDEX .EQ. 20 ) RETURN
C
C                                      Z CHAMBER
C
      IF( ZCHAMR ) CALL DRAWZC( 1 )
C
C                                      TOF COUNTERS
C
      CALL BARSEC(PI/42.0,0.,0.,RTOF,RTOF+DRTOF,0.,0.,42,PI/21.0,0.)
C
C                                      LEAD GLASS BARREL
C
      IF( LEADGL ) CALL BARSEC(0.,0.,0.,RLG,OUTR2,0.,0.,84,TWOPI/84.,0.)
C
C
C
C                                      MUON FILTER
C
      IF( (JNDEX .LE. 3)  .AND.  MUONFL ) CALL MUPIC
C
      IF( JNDEX .LT. 4  .OR.  INDEX .EQ. 17 ) RETURN
C
C                            IF DET 1/2/3 WAS REQUESTED, DRAW ENDCAP
C                            AND/OR FORWARD DETECTOR HARDWARE.
C
  2   IF( NECC  .EQ. 1  .OR.  NECC  .EQ.  3 ) CALL ECAPCY(0.,0.,1.0)
      IF( NECC  .EQ. 2  .OR.  NECC  .EQ.  3 ) CALL DRAWFD(1)
C
      RETURN
C
C
C
  3   IF( JNDEX .GT. 7 ) GO TO 5
C
C                            ***************************
C                            *  ZX-VIEWS AND ZY-VIEWS  *
C                            ***************************
C
C                                      BEAM PIPE
C
      CALL DRAWBP( 2 , VTXCHR )
C
C                                      VERTEX CHAMBER
C
      IF( DRVTXC ) CALL DRAWVC( 2 )
C
C                                      INNER DETECTOR
C
      IF( INNERC ) CALL DRAWID( 2 )
C
C                                      Z CHAMBER
C
      IF( ZCHAMR ) CALL DRAWZC( 2 )
C
C                                      TOF COUNTERS IN RZ VIEW
C
      IF( JNDEX .EQ. 4 ) GO TO 4
      CALL RECTAN(ZTOFMI,-RTOF-DRTOF,ZTOFPL,-RTOF,      0)
      CALL RECTAN(ZTOFMI, RTOF,      ZTOFPL, RTOF+DRTOF,0)
C
C                                      LEAD GLASS CYLINDER AND ENDCAPS
C
  4   IF( LEADGL ) CALL DRAWLG( 2 )
C
C                                      MUON FILTER
C
      IF( JNDEX .GE. 4  .AND.  JNDEX .LE. 7  .AND.  MUONFL) CALL MUPIC
      IF( JNDEX .EQ. 6  .OR.   JNDEX .EQ. 7 ) CALL FWMUCN
      IF( JNDEX .EQ. 7                      ) CALL DRAWFD( 2 )
  5   IF( JNDEX .LT. 8 ) RETURN
C
C                            ******************************
C                            *  FORWARD DETECTOR DISPLAY  *
C                            ******************************
C
      IF( INDEX .EQ. 12 ) CALL DRAWFD( 3 )
C
C                            ***************************************
C                            *  ROLLED OUT VIEW OF LG AND TAGGING  *
C                            ***************************************
C
      IF( INDEX .EQ. 13 ) CALL DRAWLG( 3 )
C
C                            *************************************
C                            *  PERSPECTIVE VIEW OF LG CYL + ID  *
C                            *************************************
C
      IF( INDEX .EQ. 14 ) CALL DRAWLG( 4 )
C
C                            ***************************
C                            *  FORWARD MUON COUNTERS  *
C                            ***************************
C
      IF( INDEX .EQ. 15      .AND.
     +  ( HEAD(18) .GT. 3730  .OR.  HEAD(18) .LT. 100 ) ) CALL FWMUCN
C
C                            *******************************
C                            *  Z CHAMBER ROLLED OUT VIEW  *
C                            *******************************
C
      IF( INDEX .EQ. 16 ) CALL DRAWZC( 3 )
      RETURN
      END

C   13/03/84 403132043  MEMBER NAME  LINKDS   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
         SUBROUTINE  LINKDS(LUNC,JNAME,HERR,DDN)
C-----------------------------------------------------------------------
C
C   AUTHOR:  C. BOWDERY    ??/??/81 : LINKS A HSM/MSS DATASET
C
C
C
C         THIS SUBROUTINE LINKS AN HSM/MSS DATASET TO A LOGICAL
C         UNIT NUMBER AND HANDLES ERRORS.
C
C         JNAME   -   ARRAY OF 44 CHARS CONTAINING DSNAME
C         LUNC    -   VARIABLE HOLDING LOGICAL UNIT NO.
C         HERR    -   RETURN ERROR VARIABLE
C         DDN     -   DOUBLE PRECISION (REAL*8) VARIABLE
C                     (CONTAINS 'FT..F001' ON RETURN)
C         IF LUNC=0 ON ENTRY, THE VALUE OF LUNC ON EXIT WILL BE
C         DECIDED BY SUBROUTINE GETPDD (FROM R02SCH.TSOIPS.LOAD).
C         IF JNAME HAS LEADING BLANKS, THEY WILL BE REMOVED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1 JNAME,BLANK
      REAL*8 DDN,VOLSR
C
      DIMENSION JNAME(44)
C
      DATA BLANK/' '/,VOLSR/'        '/
C
C------------------  C O D E  ------------------------------------------
C
C                  SCAN ARRAY JNAME CONTAINING THE DSNAME TO FIND
C                  LEADING BLANKS AND SHIFT LEFT TO REMOVE THEM.
C
      IF( JNAME(1) .NE. BLANK ) GO TO 4
      DO  5  I = 2,44
        IF( JNAME(I) .NE. BLANK ) GO TO 2
 5    CONTINUE
C                  IF NO NAME GIVEN (ONLY 'ENTER')
C                  THEN RETURN WITH 'NO NAME GIVEN' ERROR (=100)
      HERR = 100
      RETURN
C
C                  SHIFT LEFT TO REMOVE BLANKS BUT KEEP TRAILING BLANKS
C
 2    DO  6  J = 1,44
        JNAME(J) = BLANK
        K = 44 - I + 1
        IF( J .LE. K ) JNAME(J) = JNAME(J+I-1)
 6    CONTINUE
C
C
C                  CALL GETPDD TO ALLOCATE LOGICAL UNIT NUMBER LUNC
C                  TO THE CALIBRATION DATASET. IF LUNC IS ZERO, GETPDD
C                  CHOOSES A VALUE. ON RETURN, HERR SHOULD BE ZERO.
C
 4    CALL GETPDD(JNAME,VOLSR,DDN,LUNC,HERR)
C
C                  IF HERR IS 'DDNAME ALREADY ALLOCATED',FREE THE DDNAME
C
      IF( HERR .NE. 1040 ) RETURN
        REWIND LUNC
        CALL FREEDD(DDN,HERROR)
        IF( HERROR .EQ. 0 ) GO TO 4
        HERR = - HERROR
        RETURN
      END

C   22/03/97 703221802  MEMBER NAME  JEOSUM1  (JADEGS)      FORTRAN
C   22/03/97 703221757  MEMBER NAME  #CALNEWS (JADEGS)      FORTRAN
         THIS MEMBER DESCRIBES CHANGES TO THE STANDARD
          CALIBRATION FILES MADE SINCE 14 NOVEMBER 1980

          NEW TOF CALIBRATION CONSTANTS INSTALLED FOR RUN 4863 ON.
          (1 SEPT. 1980 0H 59MIN 21 SEC). INSTALLATION DONE 19.45
          ON 25 NOVEMBER 1980.

          THE TOF CALIBRATION CONSTANTS WHICH WENT INTO EFFECT FROM
          RUN 4863 ON (1 SEPT. 1980 0H 59MIN 21 SEC) HAVE BEEN
          MOVED SO THAT THEY GO INTO EFFECT FROM RUN 4993 ON
          (1 OCT. 1980 3H 52MIN 7SEC). A NEW SET OF TOF UPDATES WAS
          INTRODUCED AND GOES INTO EFFECT FROM RUN 4842 ON
          (29 AUG. 1980 22H 7MIN 30 SEC). CHANGES INSTALLED 16.39 ON
          6 DECEMBER 1980. FILE F11LHO.CUPDAT1 ALSO CHANGED IN THE
          SAME WAY.

          THE "BIG FIASCO" CHANGEOVER OF THE STANDARD CALIBRATION
          DATA TO INCLUDE THE LATEST GREATEST NOSAKI CORRECTIONS
          WAS IMPLEMENTED BETWEEN 20.35 AMD 20.45 ON 8 DECEMBER 1980.

          A COMPLETE NEW SET OF MUON CALIBRATION CONSTANTS HAS BEEN
          INSTALLED.
                                  22.54 ON 17 DECEMBER 1980.

          DURING THE NIGHT OF JANUARY 11 TO JANUARY 12, 1981 THE
          FILE F11LHO.ASTART0 WAS SOMEHOW DESTROYED. BACKUP WAS
          RESTORED ABOUT 12.00 ON 12 JANUARY OF THE 8 DECEMBER 1980
          VERSION, WHICH DOES NOT INCLUDE THE LATEST NOSAKI CONSTANTS
          OR THE LATEST MUON CALIBRATION DATA. THE FILE WAS LATER
          DESTROYED AGAIN FOR UNKNOWN REASONS. FINALLY ABOUT 14.45
          ON 12 JANUARY 1981 A FULLY CORRECTED F11LHO.ASTART0 WAS
          RESTORED, WITH ALL THE LATEST CALIBRATION DATA. BACKUP
          COPIES F11LHO.KB81012A, B, C AND D CONTAIN DATA OF F11LHO.
          ASTART0, AUPDAT0, ASTART1 AND AUPDAT1 RESPECTIVELY AFTER THE
          LATEST JET CHAMBER AND MUON DATA WERE REINSTALLED.
                                  15.04 ON 12 JANUARY 1981.

          THE JTPL BANK RECORDS ON ASTART1 WERE CHANGED TO ACCOMODATE
          THE NEW JET CHAMBER WIRE RESISTANCES. ASTART1 NOW GOES INTO
          EFFECT AT 0H, 0MIN, 0SEC ON 12 FEB. 1981. CHANGE EFFECTIVE
                                  13.24 ON 26 FEBRUARY 1981.
          THE JTPL AND JTAB BANKS ON ASTART1 WERE CHANGED TO INCORPORATE
          NEW JET CHABER CONSTANTS EFFECTIVE RETROACTIVELY TO THE START
          OF 1981 RUNNING.
                                  21.55 ON 25 MARCH 1981.

          INSTALLED NEW MUON CALIBRATION RECORDS ON ASTART0 AND ASTART1.
          NEW AUPDAT1 IS READY TO BE OVERWRITTEN FROM WRKSPE1, BUT NEED
          MORE SPACE ON STOR05.
                                  00.30 ON 10 APRIL 1981.
          AUPDAT0 NOW 120 TRACKS LONG AND UPDATED WITH NEW MUON
          CONSTANTS.
                                  10.00 ON 10 APRIL 1981.
          FIXED SHIFT OF ONE I*4 ADDRESS IN MUCA DATA ON ASTART0
          AND ASTART1.
                                  22.24 ON 01 MAY 1981.
          BETWEEN 19-20.5.81 ASTART0 WAS OVERWRITTEN AGAIN, THE THIRD
          TIME THIS YEAR. IT WAS REPAIRED AT 20.5.81, AT 18.15, BY
          OVERWRITING IT WITH THE CONTENT OF THE LATEST BACKUP, THE
          FILE F11LHO.KB81121A, WHICH PRESUMABLY CONTAINS THE STATUS
          FROM 1.5.81
                                     J.OLSSON   20.5.81   18.18

          AT 22.00 ON 20.5.81, F22MCC OVERWROTE ASTART0 AGAIN. IT WAS
          REPAIRED WITH HELP OF KB81121A ON 21.5.81, AT 10.00. HOPE-
          FULLY IT WILL NOT HAPPEN AGAIN....

    FROM 2.6.81 P. STEFFEN TOOK OVER UPDATING OF CALIBRATION FILES

    THAT WAS THE END OF THIS MEMBER

    ALL FURTHER NEWS AND CHANGES CAN BE FOUND ON
               'F11PST.LHOLIB.S(#CALNEWS)'
                IN CASE IT SHOULD BE EMIGRATED: THERE ARE NO NEWS


   BACKUPS EXISTING ON 20.5.1981:

F11LHO.KB81012A                              M08931 32008003 00070
F11LHO.KB81012B                              M08588 32008003 00087
F11LHO.KB81012C                              M08931 32008003 00069
F11LHO.KB81012D                              M08712 32008003 00013
F11LHO.KB81047A                              M00955 32008003 00013
F11LHO.KB81047B                              M08491 32008003 00030
F11LHO.KB81047C                              M07898 32008003 00042
F11LHO.KB81047D                              M08896 32008003 00027
F11LHO.KB81057A                              M03127 32008003 00083
F11LHO.KB81057B                              M08948 32008003 00025
F11LHO.KB81057C                              M03127 32008003 00084
F11LHO.KB81057D                              M03959 32008003 00005
F11LHO.KB81072A                              M05819 32008003 00089
F11LHO.KB81072B                              M10476 32008003 00001
F11LHO.KB81072C                              M05819 32008003 00090
F11LHO.KB81072D                              M05047 32008003 00021
F11LHO.KB81084C                              M05154 32008003 00083
F11LHO.KB81099A                              M05947 32008003 00087
F11LHO.KB81099B                              M00786 32008003 00047
F11LHO.KB81099C                              M05947 32008003 00091
F11LHO.KB81099D                              M05562 32008003 00069
F11LHO.KB81100B                              M03736 32008003 00022
F11LHO.KB81121A                              M03823 32008003 00005
F11LHO.KB81121B                              M09264 32008003 00057
F11LHO.KB81121C                              M03823 32008003 00004
F11LHO.KB81121D                              M03823 32008003 00055
C   22/03/97 703221757  MEMBER NAME  #GRAPHIX (JADEGS)      FORTRAN




     THIS MEMBER WAS ONCE USED TO CREATE GRAPHICS MODULES.



                   N O   M O R E !



     PLEASE USE THE MEMBER 'F11LHO.GRAFIX.S(#GRAPHIX)'.



C   22/03/97 703221757  MEMBER NAME  #JADE    (JADEGS)      FORTRAN
F11AMB
F11BAR
F11BEK
F11BET
F11BOC
F11DIE
F11DIK
F11HAG
F11HEI
F11HEL
F11HEU
F11HUG
F11JVK
F11KUH
F11LAU
F11MEI
F11NOZ
F11OLS
F11PEA
F11PIE
F11PRC
F11PST
F11RAM
F11RIE
F11SPI
F11WAG
F11WIE
F22ALL
F22BAC
F22BOW
F22CAR
F22CHR
F22COD
F22COR
F22DUE
F22FEL
F22FIN
F22FKL
F22GLE
F22GRE
F22HAG
F22HAI
F22HEM
F22HIL
F22HOW
F22JTB
F22KAD
F22KAN
F22KLE
F22KMT
F22KOB
F22KOM
F22KRB
F22MCC
F22MIN
F22NAR
F22NOZ
F22ODA
F22ORI
F22PAU
F22PET
F22PWA
F22RAM
F22RIP
F22RJB
F22ROW
F22SAT
F22SAU
F22SMN
F22SNE
F22TAK
F22TKE
F22TOT
F22VAL
F22WEN
F22YAM
F32BOB
F32BSZ
F32DSD
F32GLA
F32GTZ
F32GUS
F32HJU
F32JAS
F32KNA
F32KNE
F32KNI
F32RGG
F32WAG
C   22/03/97 703221757  MEMBER NAME  #START0  (JADEGS)      FORTRAN
ALLOC F(MACRO) DA('F11GOD.PATRECSR')
./ SHOW '  THIS IS THE "FULL BOS" STANDARD LIBRARY.                    '
./ SHOW '     EFFECTIVE 08.45 06.09.79.                                '
./ SHOW '  MUON ROUTINES ARE NOW ALL ON F22ALL.JADEMUL.                '
./ SHOW '  OLD MINIBOS LIBRARIES, WITH MUON ROUTINES ARE BACKED UP     '
./ SHOW '  AS F11LHO.MBGRAPHS, F11LHO.MBGRAPHL, F11LHO.MBJADEGS AND    '
./ SHOW '  F11LHO.MBJADEGL.                                            '
./ SHOW 'REPLACED KLREAD AND OVERWROTE F11LHO.ASTART0, ASTART1,       '
./ SHOW 'AUPDAT0, AUPDAT1. TOF DATA NOW IN STANDARD CALIBRATION       '
./ SHOW 'SCHEME.   12.00 10.09.79                 L.H. ONEILL         '
./ SHOW 'CHANGED MUINI CALLING SEQUENCE IN SUPERV IN COORDINATION   '
./ SHOW 'WITH J. ALLISON AND H. PROSPER. INTRODUCED CALL TO MUREG   '
./ SHOW 'IN KALIBR RIGHT AFTER KLREAD CALL. GOT RID OF INITIALIZATION'
./ SHOW 'OF MUON CALIBRATION UNIT NUMBERS IN GPHMAIN AND SUPERV.     '
./ SHOW 'IT IS NOT NECESSARY TO ATTACH THESE FILES. ASKED J. A. AND   '
./ SHOW 'H. P. TO INFORM USERS.              L. ONEILL 21.28 25.09.79 '
./ SHOW '  TOOK OUT MUCON CALL IN EVREAD.  11.40 05.10.79. L.H. ONEILL '
./ SHOW 'COPIED F1EBLO.BOSLIB.S/L TO F11LHO.BOSBAK.S/L AND ANTIFASTED. '
./ SHOW '                            L.H. ONEILL 09.10.79 19.49        '
./ SHOW 'COPIED NEW RDMTCO AND RDTRG1, RDTRG2 AND TAGSIM FROM          '
./ SHOW 'F22ELS.JMC.S                L.H. ONEILL 18.46 11.10.79        '
./ SHOW 'REINSTALLED MUCON CALL IN EVREAD FOR MONTE CARLO AND       '
./ SHOW 'TAUGHT KLREAD TO IGNORE MUON CALIBRATION DATA ON DISK      '
./ SHOW 'IN THE CASE OF MONTE CARLO DATA. RELINKED GRAPHL(JADEZ)    '
./ SHOW '                  DONE 19.30      18.10.79    L.H. ONEILL  '
./ SHOW 'GOT RID OF 9 SPECIAL MUON COMMONS IN EVWRIT AND INSTALLED '
./ SHOW 'CALL TO MUCONW.               L.H. ONEILL 14.50. 14.11.79   '
./ SHOW '  INSTALLED NEW RDMTCO FROM F22ELS.JMC.S. L.H. ONEILL      '
./ SHOW '                                    10.22 04.12.79         '
./ SHOW 'CORRECTED BUG IN JETCAL CAUSING AMPLITUDE SLEWING CORRECTION '
./ SHOW 'TO BE APPLIED FOR LARGE RATHER THAN SMALL PULSE HEIGHTS.     '
./ SHOW '                              19.02 15.01.80. L.H. ONEILL.   '
./ SHOW 'INSTALLED DITTMANNS VERTEX PROGRAM + DISPLAY. FOLLOWING'
./ SHOW 'ROUTINES NEWLY INSTALLED OR UPDATED:   RSDISP VXDISP TRKROL'
./ SHOW 'VERTEX VTXAFT VTXPRE VTXEE VTXSRC VTXINI SUPERV VTXBNK VTXPNT'
./ SHOW 'KOMMAN DISPLY SCANNR BANKPR                 J.OLSSON 08.02.80'
./ SHOW 'UPDATED VXDISP                              J.OLSSON 09.02.80'
./ SHOW 'UPDATED VXDISP VERTEX VTXSRC VTXEE BANKPR   J.OLSSON 11.02.80'
./ SHOW 'CHANGED SUPERV TO SET IPFAST IN CPATLM TO 2 BEFORE USER(0).  '
./ SHOW '                              19.25 12.02.80. L.H. ONEILL.   '
./ SHOW 'INSTALLED COMMAND DEDX.  FOLLOWING ROUTINES UPDATED OR NEW:'
./ SHOW 'DEDXAN DEDXDS DEDXBK KOMMAN DISPLY SCANNR BANKPR NEWS MENU   '
./ SHOW 'UPDATED CHANGE AND JBMENU AND VTXSRC       J.OLSSON 16.02.80'
./ SHOW 'INSTALLED SR TRACK,MOMGAM,PARMIN FOR DEDX  J.OLSSON 17.02.80'
./ SHOW 'INSTALLED COMMAND BL   INVOLVED ROUTINES ARE: '
./ SHOW ' KOMMAN SCANNR DISPLY BLSHOW BLNUMB SPINNR'
./ SHOW 'CHANGED SUPERV TO OVERWRITE WRONG YEAR IN EVENT HEADER.     '
./ SHOW '                              12.43 25.02.80. L.H. ONEILL.   '
./ SHOW 'REMOVED LAST USELESS CHANGE - ONLY EFFECTIVE AT USER(2)     '
./ SHOW 'AND REINSTALLED IUHR SINCE TEST JOB AT 15.48 SHOWS IT WORKS.'
./ SHOW '                              16.41 25.02.80. L.H. ONEILL.   '
./ SHOW 'ZVERTF CHANGED', OLD VERSION "ZVERTF0"  P.ST. 03.03.80'
./ SHOW 'INSTALLED DISPLAY OF TOF COUNTER NUMBERS IN THE R-PHI VIEWS '
./ SHOW 'FOR THOSE COUNTERS ACTUALLY HIT, AND INSTALLED DISPLAY OF   '
./ SHOW 'TOF COUNTERS THEMSELVES IN THE Z-X AND Z-Y VIEWS. THESE     '
./ SHOW 'DISPLAYS INVOLVE CHANGES TO EVDISP AND JADISP RESPECTIVELY. '
./ SHOW 'IN SUPERV CHANGED THE TOF HALF-LENGHTS FROM 1500 TO 1615 MM '
./ SHOW 'IN BLOCK DATA ACCORDING TO INFORMATION RECEIVED FROM        '
./ SHOW 'B. NAROSKA. INSTALLED EXTERNAL STATEMENT AND ERRSET CALLS   '
./ SHOW 'FOR NEW PST IBCOM ERROR TRAP ROUTINE ERRPRT, ALSO IN SUPERV.'
./ SHOW '                              17.51 11.03.80. L.H. ONEILL.   '
./ SHOW 'CRTREL RENAMED TO CRTREL0. CRTREL COPIED TO PATRECSR. '
./ SHOW 'THIS IS TO PREPARE FOR CHANGE OF /CCYCP/ IN PATREC PACKAGE'
./ SHOW 'ALL INVOLVED ROUTINES ON PATRECSR        J.OLSSON 18.3.80'
./ SHOW 'INSTALLED COMMAND QP, TO SHOW KOBAYASHI Q-PLOTS'
./ SHOW 'INVOLVED ROUTINES ARE : KOMMAN DISPLY SCANNR MENU NEWS'
./ SHOW 'AND THE PACKAGE QPLOTS: '
./ SHOW '     SUBROUTINES QPLOTS EVIPR4 EVIPR2 BOX BOX3 TRIANQ PSCALE'
./ SHOW '                 PLIMIT SUMPAT CHCLSP SPHRIX EHIST OUTPRD '
./ SHOW '                 MOTAPR MTOPRM KIPRCR'
./ SHOW '  THEY CAN ALL BE OVERLAYED IN ONE BRANCH'
./ SHOW '  THEY REQUIRE FURTHER THE ROUTINES EIGEN AND LOC'
./ SHOW '                                       J.OLSSON  24.03.80'
./ SHOW 'INSTALLED NEW SUPERV VERSION WITH SINGLE CALLS TO IBLN   '
./ SHOW 'AND OTHER MINOR CHANGES                L.H.O 11.04 28.03.80'
./ SHOW 'CHANGED BUG IN KLREAD CAUSING CLEARING OF MUON CALIBRATION'
./ SHOW 'DATA IN MONTE CARLO CASE.              L.H.O 17.25 02.04.80'
./ SHOW 'UPDATE OF DEDXBN: THIS IS THE GRAPHICS VERSION OF DEDXAN ON '
./ SHOW 'THE TP-LIBRARY. IT IS DIFFERENT IN THE FOLLOWING ASPECTS:'
./ SHOW '   THE MEMBER CONTAINS THE SUBROUTINE POLINT'
./ SHOW '   TRACK LOOP OVER PATR AND NOT OVER TP TRACK BANKS'
./ SHOW '   RESULTS WRITTEN INTO COMMON /CWORK1/, NOT INTO TP BANK'
./ SHOW '   MOMENTUM COMPUTED FROM PATR BANK VIA SUBROUTINE TRACK '
./ SHOW '   SUBROUTINE DEDXDS ALSO UPDATED TO CALL DEDXBN '
./ SHOW '                           J.OLSSON 16.04.80'
./ SHOW ' UPDATED GAMDIS AND SPINNR              J.OLSSON  24.4.80'
./ SHOW ' UPDATED SCANNR, SPINNR AND BANKPR   J.OLSSON  28.4.80'
./ SHOW ' UPDATED DEDXBN,DEDXDS,EBEAM,SPINNR,NEWS  J.OLSSON  08.5.80'
./ SHOW ' INSTALLED DEDXVW, UPDATED NOTICE     J.OLSSON  08.5.80'
./ SHOW ' UPDATED SPINNR,DEDXDS,DEDXVW,BANKPR,NEWS,MENU,NOTICE'
./ SHOW ' INSTALLED COMMAND -TOF- INVOLVED MEMBERS ARE TOFDS,TOFVW'
./ SHOW '    AS WELL AS KOMMAN,SCANNR,DISPLY    THE MEMBER TOFDS IS A'
./ SHOW '    PACKAGE OF ROUTINES THAT CAN ALL BE OVERLAYED, SEE MEMBER'
./ SHOW '    JADEOVLY IN F11PEA.DATA           J.OLSSON  15.5.80'
./ SHOW ' INSTALLED NEW VERSIONS OF THE FOLLOWING MONTE CARLO READING'
./ SHOW ' ROUTINES, COPIED FROM F22ELS.JMC.S ON 31.5.80:              '
./ SHOW '  RDMTCO (WITH ENTRY RDJETC), RDMODN, RDDDCL, RDDOUB, RDINEF,'
./ SHOW '  RDMERG, RDPOIN, RDRDMH, RDPATR, RDRESO, NVERT, RDTRG1, '
./ SHOW '  RDTRG2, TAGSIM, RDSTAT. THESE ARE NOW ALL UNDER MEMBER '
./ SHOW '  RDMTCO AND THE DUPLICATE OLD MEMBERS HAVE BEEN SCRATCHED.'
./ SHOW '                                    L. ONEILL 15.55 04.06.80 '
./ SHOW 'UPDATED EVDISP(TRIG DISPLAY), EBEAM AND SPINNR           '
./ SHOW 'CORRECTED LONGSTANDING ERROR IN RDMTCO(RDJETC) CAUSING NON-'
./ SHOW 'CREATION OF TRIGGER BANKS IF JETC DATA MISSING (NEUTRALS)'
./ SHOW '                                      J.OLSSON  08.6.80'
./ SHOW 'CORRECTED 3 ERRORS IN VTXSRC, AFTER DITTMANNS DIRECTIONS   '
./ SHOW 'THEY CAUSED TIME LOOPS AND WRONG NR IN BANKS             '
./ SHOW '                                      J.OLSSON  09.6.80'
./ SHOW '  INSTALLED CALL TO MUHDSP IN TRKHIT.                      '
./ SHOW '                                    L. ONEILL 21.30 16.06.80 '
./ SHOW '  CHANGED TWISTING ANGLE IN KALIBR FOR DATA FROM RUN 3730. '
./ SHOW '                                    L. ONEILL 11.18 17.06.80 '
./ SHOW '  INSTALLED FWMUCN AND FWMUHT, COUNTER AND HIT DISPLAY     '
./ SHOW '  ROUTINES FOR THE FORWARD MUON COUNTERS. NEW COMMAND      '
./ SHOW '  FWMU SHOWS THESE IN X-Y PLANE.                           '
./ SHOW '  THESE ROUTINES CAN BE OVERLAYED IN THE JADISP    '
./ SHOW '  AND EVDISP BRANCHES RESPECTIVELY.                        '
./ SHOW '                                    L. ONEILL 19.58 17.06.80 '
./ SHOW '  TOOK ZOFFS OFFSET OUT OF EVDISP.                         '
./ SHOW '                                    L. ONEILL 11.06 01.07.80 '
./ SHOW '  UPDATED DEDXBN,TOFDS ON UNDEF VARIABLES, ERRORS          '
./ SHOW '  UPDATED NUMBWR,DISPLY ON UNDEF. VARIABLES         '
./ SHOW '  UPDATED EBEAM,IDFUN               J.OLSSON 08.07.80 '
./ SHOW '  ZVERTF: ALLOW FOR DEAD CELL IN RING 1  P.STEFFEN 25/07/80'
./ SHOW '  UPDATED EBEAM,EFMASS,INSTALLED JEGAIN '
./ SHOW '  UPDATED CREDIT,KOMMAN,DISPLY,SCANNR    J.OLSSON 25/07/80'
./ SHOW '  UPDATED JADISP,BANKPR   J.OLSSON 28/07/80'
./ SHOW ' INSTALLED COMMAND -VRES- INVOLVED MEMBERS ARE VXDISP,'
./ SHOW '   RSDISP,LINDIS,CIRDIS,PARDIS,DISPLY,KOMMAN,SCANNR,NOTICE'
./ SHOW '   MENU AND NEWS.  UPDATED EBEAM,IDFUN    J.OLSSON  30.07.80'
./ SHOW '  CORRECTED MASS ERROR IN EFMASS    J.OLSSON  30.07.80'
./ SHOW '  CORRECTED TOFDS AND TOFVW. IN LINKING NEW MODULE, ONE'
./ SHOW '  HAS TO LINK IN F22NAR.TOFLIB.L.    ALSO NEW OVERLAY, SEE'
./ SHOW '  E.G. F11OLS.JADESR(JBOVER)          J.OLSSON  24.8.80'
./ SHOW '  UPDATED EBEAM.  INSTALLED SUBROUTINES REDONE,REDTVA AS '
./ SHOW '  DESCRIBED IN COMP.NOTE 60.  INVOLVED SUPPORT ROUTINES ARE:'
./ SHOW '  TRGCHK,LGCUT,TAGFLG,HWORLD,TOFCHK,RDATA.  J.OLSSON 25.8.80'
./ SHOW '  INSTALLED NEW VERSIONS OF RDSTAT AND RDTRG1 UNDER MEMBER '
./ SHOW '  RDMTCO.                           L. ONEILL 19.00 26.08.80 '
./ SHOW ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - '
./ SHOW '  JETCAL CHANGED (OLD VERSION = JETCAL0):                   '
./ SHOW '                 NEGATIVE DRIFT TIMES ALLOWED'              '
./ SHOW '                 BANK DESCRIPTOR INCREASED BY 200          '
./ SHOW '                                  P. STEFFEN 11.00 12.09.80 '
./ SHOW '  SUPERV CHANGED TO BLOCK DATA SET NEW CJDRCH               '
./ SHOW '  TOFBK NOW SEPARATE ROUTINE, PREVIOUSLY IN MEMBER TOFDS    '
./ SHOW '                                  J. OLSSON 14.50 18.09.80 '
./ SHOW ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - '
./ SHOW '  UPDATED BANKPR                     J.OLSSON 01.10.80    '
./ SHOW '  UPDATED EBEAM AND RDATA            J.OLSSON 07.10.80    '
./ SHOW '  UPDATED TRGCHK AND JOINED IT TO MEMBER REDONE '
./ SHOW '  REDONE AND REDTVA ALSO UPDATED TO LATEST STAND OF REDUC1,2'
./ SHOW '  ADDED SUBR. MEWT3 FOR THOSE WHO DO NOT LINK JADEPR.JADELD'
./ SHOW '                                                 J.O. 17.10.80'
./ SHOW '  UPDATED EBEAM AND RDATA            J.OLSSON 21.10.80    '
./ SHOW '  UPDATED TAGCHK AND FWCHEV          J.OLSSON 25.10.80    '
./ SHOW '  NOZAKIS NEW CONSTANT SCHEME INTRODUCED UNDER ALIAS NAMES'
./ SHOW '  MEMBERS : SUPERVN,JETCALN,KALIBRN,KLREADN   J.O.  25.10.80'
./ SHOW '  UPDATED EBEAM                      J.OLSSON 02.11.80    '
./ SHOW '  REMOVED CALL TO CORLAR IN SUPERV AND SCRATCHED TOFSMP   '
./ SHOW '                    15.20 ON 03.11.80. L.H. ONEILL        '
./ SHOW '  INSERTED NRUN IN ARGUMENT FIELD OF TOFSMP CALL IN EVDISP.'
./ SHOW '                    19.30 ON 04.11.80. L.H. ONEILL        '
./ SHOW '  INSERTED ARGUMENT NRUN IN TOFCHK/TOFSMP CALL IN REDTVA'
./ SHOW '  AND UPDATED SPINNR                 J.OLSSON 05.11.80    '
./ SHOW '  UPDATED KALIBRN,SUPERVN FOR A MC-VALUE  J.OLSSON 10.11.80'
./ SHOW '  UPDATED EBEAM                      J.OLSSON 10.11.80    '
./ SHOW '  CHANGED SUPERV SO THAT PATTERN RECOGNITION IS NOT CALLED '
./ SHOW '  EVEN IF PATR BANK IS NOT PRESENT IF THE CURRENT EVENT HAS'
./ SHOW '  ALREADY BEEN PROCESSED BY REDUC1, I.E. IF THE 27TH I*2   '
./ SHOW '  DATA WORD OF THE HEADER BANK IS NOT ZERO.                '
./ SHOW '                    12.12 ON 14.11.80. L.H. ONEILL        '
./ SHOW '  UPDATED PREDIT,CREDIT,SPINNR            J.OLSSON 17.11.80'
./ SHOW '  INSTALLED SERVICE MEMBERS USREDUC2&JBREDUC2  J.O. 22.11.80'
./ SHOW '  UPDATED PREDIT,CREDIT                   J.OLSSON 26.11.80'
./ SHOW '  CHANGED SUPERV SO THAT PATTERN RECOGNITION IS CALLED EVEN'
./ SHOW '  IF 27TH I*2 WORD OF HEADER IS NON-ZERO IF SUPERV IS RUNNING'
./ SHOW '  UNDER GRAPHICS.   18.39 ON 28.11.80. L.H. ONEILL           '
./ SHOW '  UPDATED BANKPR         J.OLSSON 29.11.80'
./ SHOW '  IMPLEMENTED THE CHANGEOVER TO ROUTINES WHICH HANDLE THE    '
./ SHOW '  NEW NOSAKI JET CHAMBER CALIBRATION CONSTANTS.             '
./ SHOW '  ROUTINES CHANGED ARE SUPERV, KALIBR, KLREAD JETCAL        '
./ SHOW '  AND JRECAL. BACKUP VERSIONS ARE KEPT UNDER THE NAMES      '
./ SHOW '  SUPERV1, KALIBR1, ETC.                                    '
./ SHOW '                    20.35 ON 08.12.80. L.H. ONEILL           '
./ SHOW '  UPDATED DEDXBN         J.OLSSON 06.01.81'
./ SHOW '  UPDATED CREDIT AND SPINNR    J.OLSSON 12.01.81'
./ SHOW '  CORRECTED CREDIT  J.OLSSON 13.01.81'
./ SHOW '  CHANGED THE PARTICLE LIST OPTION IN TRUTH.'
./ SHOW '                    14.10 ON 14.01.81. L.H. ONEILL           '
./ SHOW '  UPDATED BANKPR  J.OLSSON 05.02.81'
./ SHOW '  UPDATED RSDISP VXDISP LINDIS KOMMAN SETSCL NEWS  '
./ SHOW '                                J.OLSSON 06.02.81'
./ SHOW '  UPDATED EVDISP, FWCHEV, JADISP, TAGCHK AND XYTAG,'
./ SHOW '  AND ADDED XYTAGD.                                '
./ SHOW '                    11.34 ON 27.02.81. L.H. ONEILL'
./ SHOW '  CHANGED SUPERV, SCANNR, DISPLY AND KOMMAN IN ORDER TO '
./ SHOW '  IMPLEMENT NEW COMMAND REVT.                      '
./ SHOW '                    21.31 ON 02.03.81. L.H. ONEILL'
./ SHOW '  INSTALLED NEW RDMTCO FROM F22ELS.JMC.S(RDMESS) '
./ SHOW '                    15.55 ON 19.03.81. L.H. ONEILL'
./ SHOW '  CHANGED KALIBR AND JETCAL FOR NEW CONSTANTS. OLD VERSIONS'
./ SHOW '  AS KALIBO AND JETCAL8'
./ SHOW '                    21.50 ON 25.03.81. L. ONEILL AND T. NOZAKI'
./ SHOW '  UPDATED RSDISP VXDISP GAMDIS BANKPR FOR PHOTON DISPLAY  '
./ SHOW '                                J.OLSSON 29.03.81'
./ SHOW '  KILLED YAMADA CALL IN RSDISP AND INTRODUCED IT FOR RU VIEW'
./ SHOW '  INTO THE FIVE ROUTINES WHICH CALL RSDISP: SCANNR, DISPLY,'
./ SHOW '  PROJEC, CREDIT AND MUR2DS.                               '
./ SHOW '                    11.57 ON 01.04.81. L.H. ONEILL            '
./ SHOW '  AGAIN INSTALLED NEW RDMTCO FROM F22ELS.JMC.S(RDMESS) '
./ SHOW '                    11.09 ON 10.04.81. L.H. ONEILL'
./ SHOW '  UPDATED EBEAM USREDUC2 REDTVA   (NEW TRIGGERS) '
./ SHOW '                                J.OLSSON 14.04.81'
./ SHOW '  UPDATED SPINNR,USREDUC2    J.OLSSON  22.4.81'
./ SHOW '  UPDATED LINDIS,USREDUC2    J.OLSSON  23.4.81'
./ SHOW '  UPDATED RDATA   J.OLSSON  24.4.81'
./ SHOW '  INTRODUCED NEW FORWARD TAGGING GAIN AND PEDESTAL FOR THE  '
./ SHOW '  TIME AFTER RUN 2781. TOOK THE NUMBERS WHICH ARE IN FWCHEV.'
./ SHOW '                    14.15 ON 27.04.81. L.H. ONEILL            '
./ SHOW '  ----------------------------------------------------------- '
./ SHOW '  F11GOD.PATRECSR(CWORKZV) CORRECTED + ZVERTF RECOMPILED '
./ SHOW '                    11.50 ON 28.04.81. P S T                  '
./ SHOW '  MEMBER MCGJET ADDED, ON REQUEST OF M.GODDARD.  7.5.81  J.O.'
./ SHOW '  CORRECTED ERROR IN TRUTH    8.5.81  J.O.'
./ SHOW '--------------------------------------------------------------'
./ SHOW '  KALIBR: LORENTZ ANGLE VRIATION WITH MAGNETIC FIELD          '
./ SHOW '          IF FIELD VARIATION > 1%                           '
./ SHOW '  KALIBR0 = OLD VERSION             P. STEFFEN 81/05/12  10.05'
./ SHOW '--------------------------------------------------------------'
./ SHOW '  UPDATED JBOVER  J.O.  13.5.81'
./ SHOW '  CORRECTED ERROR IN RUTRCK   J.O.  13.5.81'
./ SHOW '  CORRECTED ERROR IN COMMAND FIND, PREVIOUSLY REVT.  INVOLVED'
./ SHOW '  ROUTINES DISPLY,SCANNR,KOMMAN,MENU,NEWS      J.O.  19.5.81'
./ SHOW '  UPDATED RDMTCO FROM JMC.S   NEW VERSION HAS SPURIOUS ID HITS'
./ SHOW '  ALSO IN NEUTRAL EVENTS. OLD VERSION RDMTCO0.   SUBR. TAGSIM'
./ SHOW '  REMOVED FROM MEMBER RDMTCO (NO LONGER CALLED IN SYSTEM),  '
./ SHOW '  BUT KEPT AS INDEPENDENT SUBR. TO SATISFY POSSIBLE OVERLAY '
./ SHOW '  PROGRAMS THAT STILL HAS IT IN.       J.O. 19.5.81  '
./ SHOW '  KILLED DSPDTL30 PRINT IN SUPERV !    J.O. 25.5.81  '
./ SHOW '  UPDATED RDMTCO FROM F11ELS.JMC.S(RDMESS)   ELSEN HAS '
./ SHOW '  CORRECTED UNIMPORTANT BUG IN JETC SMEARING   J.O. 26.5.81'
./ SHOW '  UPDATED KALIBR TO CORRECT YEAR 0 IN RUNS 7423-28.  REMOVED'
./ SHOW '  DEBUG PRINT IN JETCAL (DSPDTL30)             J.O. 29.5.81'
./ SHOW '  EXTENDED /CJTRIG/ AND /CADMIN/, TO DOCUMENT NR OF CALIBRA-'
./ SHOW '  TION ERRORS IN SUPERV PRINT. AFFECTED ROUTINES SUPERV,'
./ SHOW '  KALIBR,KTMCON,EVREAD              J.OLSSON  30.5.81'
./ SHOW '  INTRODUCED FWMU AS STANDARD VIEW. GENERAL UPDATE OF MANY'
./ SHOW '  ROUTINES :  KOMMAN, SCANNR, DISPLY, TRKHIT, SETSCL, FWMUCN'
./ SHOW '  FWMUHT, GPHMAIN, MENU, EVDISP, JADISP,CREDIT, NEWS, NOTICE'
./ SHOW '   OVERLAY UPDATED IN JBOVER        J.OLSSON  04.06.81'
./ SHOW '  KALIBR UPDATED (29.FEBRUARY...)   J.OLSSON  05.06.81'
./ SHOW '  TRNUMB UPDATED (SMALL NR IN ZC)   J.OLSSON  09.06.81'
./ SHOW '  ZVERTF CORRECTED(BACKGR. SUBTR.)  P.STEFFEN 10.06.81'
./ SHOW '  LGCUT DELETED (ITS ON JADEPR.JADESR)  P.STEFFEN 10.06.81'
./ SHOW '  MEWT3 DELETED (ITS ON JADEPR.JADESR)  P.STEFFEN 10.06.81'
./ SHOW '  MEWT3 AND LGCUT REINSTALLED . MEWT3 SHOULD NOT BE DELETED'
./ SHOW '  WITHOUT TELLING PEOPLE THAT REDONE LINKS IT IN AND THAT'
./ SHOW '  JADEPR.JADELD HAS TO BE LINKED IN STANDARDLY. MOREOVER,'
./ SHOW '  LGCUT IS DIFFERENT (NO CALL TO HFILL, NO STATUS) AND '
./ SHOW '  SHOULD NOT BE DELETED AT ALL.       J.OLSSON  10.06.81'
./ SHOW '                                                        '
./ SHOW '  THE ABOVE PROBLEM SHOULD NEVER HAVE ARISEN. WHENEVER A '
./ SHOW '  NON-STANDARD COPY OF A STANDARD ROUTINE ON A STANDARD  '
./ SHOW '  LIBRARY IS MADE AND STORED ON ANOTHER STANDARD LIBRARY '
./ SHOW '  THEN THE COPY SHOULD ALWAYS HAVE A DIFFERENT NAME. THIS'
./ SHOW '  SYSTEM WAS AGREED LONG AGO AND MAKES A LOT OF SENSE. TO'
./ SHOW '  HAVE MANY DIFFERENT VERSIONS OF A ROUTINE SCATTERED ABOUT'
./ SHOW '  THE VARIOUS STANDARD LIBRARIES ALL WITH THE SAME NAME IS'
./ SHOW '  DANGEROUS AND CAUSES PEOPLE (LIKE ME) MANY PROBLEMS.     '
./ SHOW '  IN MY OPINION SUCH ILLEGAL ROUTINES SHOULD ALWAYS BE     '
./ SHOW '  DELETED ON SIGHT.  G.F.P (12/6/81)                       '
./ SHOW '                                                        '
./ SHOW '  LGCUT RENAMED TO LGCUTX, REDONE CHANGED  J.O. 11.6.81'
./ SHOW '  CORRECTED ERROR IN TRKHIT AND CREDIT, DUE TO H.E.M. OPTI-'
./ SHOW '  MIZATION. UPDATED DISPLY AND JBOVER. CHANGED CAPMRK IN'
./ SHOW '  EVDISP, FULFILLING BEATES LATEST WISH(CAMACTIME) J.O.11.6.81'
./ SHOW '  CORRECTED SLIGHT BUG IN GPHMAIN                  J.O.12.6.81'
./ SHOW '  UPDATED SPINNR                                   J.O.13.6.81'
./ SHOW '  CORRECTED SEVERAL ERRORS IN GRAPHICS DISPLAY OF MONTE CARLO '
./ SHOW '  INVOLVED ROUTINES: TAGCHK,FWCHEV,BLNUMB,BLSHOW,TRUTH,XYTAG  '
./ SHOW '                                  J.O.16.6.81'
./ SHOW '  UPDATED DEDXBN(FUNC DRUCK) ACC. TO R.EICHLER     J.O.17.6.81'
./ SHOW '  KILLED XYTAGD (IDENT. TO XYTAG), UPDATED JADISP  J.O.17.6.81'
./ SHOW '  UPDATED KALIBR, FOR YEAR 0 SCREW UP IN 1981      J.O.22.6.81'
./ SHOW '  UPDATE OF GRAPHICS ROUTINES: DEDXBN(LONGSTANDING ERROR), '
./ SHOW '      TOFDS, TOFVW, CAPMRK(IN EVDISP), DEDXDS, BLSHOW'
./ SHOW '      JBOVER,DEDXVW,EFMASS                     J.O. 1.7.81'
./ SHOW '  UPDATE OF EFMASS, IDFUN                      J.O. 2.7.81'
./ SHOW '  UPDATE OF TRNUMB, DISPLY,SCANNR,IDFUN        J.O.16.7.81'
./ SHOW '  QPLOTS MODIFIED FOR TRACING 0C4              J.O.16.7.81'
./ SHOW '  JBOVER CHANGED, PSCALE OUT OF OVERLAY        J.O.16.7.81'
./ SHOW '  UPDATED SETSCL AND NEWS                      J.O.20.7.81'
./ SHOW '  KALIBR T0 SET FOR RUNS > 7592                PST 20.7.81'
./ SHOW '  VRTPOS INSTALLED (EVENT VERTEX OF RUNS)      PST 24.7.81'
./ SHOW '  UPDATE OF REDTVA,DISPLY,EVDISP               J.O.28.7.81'
./ SHOW '  UPDATE OF GPHMAIN,GAMDIS,DISPLY,EVDISP  '
./ SHOW '  JBOVER CHANGED, (SPINNR OUT OF OVERLAY)      J.O.02.8.81'
./ SHOW '  UPDATE OF SCANNR,DISPLY,KOMMAN,VXDISP,BLSHOW,NEWS'
./ SHOW '  INSTALLED DRAWER,REALNM   (COMMAND DRAW)     '
./ SHOW '  UPDATE OF USREDUC2 AND REDTVA         J.O. 07.08.81'
./ SHOW '  UPDATE OF JBMENU                      J.O. 15.08.81'
./ SHOW '  CORRECTION OF ERROR IN REALNM         J.O. 06.09.81'
./ SHOW '  COMMAND HX INSTALLED, CHANGED ROUTINES ARE: KOMMAN,SCANNR,'
./ SHOW '          DISPLY,NEWS,MENU          J.O.  07.09.81'
./ SHOW '  UPDATED TOFCHK AND USREDUC2       J.O.  09.09.81'
./ SHOW '  KLREAD CHANGED (NEW CALIBRATION FILES)                 '
./ SHOW '         OLD VERSION KLREAD0 MUST BE USED WITH OLD   '
./ SHOW ' CALIBRATION FILES F11PST.BUPDAT0 + BUPDAT1  PST.14.9.81,12.45'
./ SHOW '  GPHMAIN UPDATED FOR NEW CAL.FILE SITUATION  J.O.15.9.81,'
./ SHOW '  COMMAND AX INSTALLED, CHANGED ROUTINES ARE: KOMMAN,SCANNR,'
./ SHOW '  DISPLY,NEWS,MENU.  ALSO INSTALLED IS THE NEW MEMBER AXSHOW,'
./ SHOW '  WITH THE ROUTINES AXSHOW,ARROW,SPHERC  '
./ SHOW '  JBOVER ALSO UPDATED IN RSDISP BRANCH        J.O.  15.9.81'
./ SHOW '  SPINNR UPDATED TO COVER SUMMER 1981         J.O.  25.9.81'
./ SHOW '-----------------------------------------------------------'
./ SHOW '  KALIBR: T0 + LORENZ ANGLES FOR 81                        '
./ SHOW '          OLD VERSION = KALIBR0                PST  9.10.81'
./ SHOW '  KALIBR: T0, LORENZ ANG. + DRIFT VELOC. FOR SUMMER 81'
./ SHOW '          OLD VERSION = KALIBR0                PST 14.10.81'
./ SHOW '-----------------------------------------------------------'
./ SHOW '  BANKPR UPDATED, FORMAT FOR TPVX BANKS       J.O. 16.10.81'
./ SHOW '  TRKHIT UPDATED, MUON DISPLAY DETAILS        J.O. 17.10.81'
./ SHOW ' REPLACED RDMTCO WITH RDMESS FROM F22ELS.JMC.S    THIS IS  '
./ SHOW '    REPAIR FOR ..JETC BANK ALREADY EXISTING... ERROR '
./ SHOW '                                              J.O. 19.10.81'
./ SHOW '  NEW VERSION OF MUON ANALYSIS AND GRAPHICS INSTALLED. NEW '
./ SHOW '  VERSIONS OF GPHMAIN,SUPERV,SCANNR,DISPLY,NEWS,NOTICE HAVE'
./ SHOW '  BEEN INSTALLED. OLD ROUTINES ARE NOW SUPERV0,SCANNR0,    '
./ SHOW '   DISPLY0. ALSO JBOVER CHANGED(MUFFLT).  XYMUD RENAMED TO '
./ SHOW ' XYMUD0. NEW VERSION OF XYMUD ON JADEMUS/L    J.O. 20.10.81'
./ SHOW ' CORRECTED BUGS IN GPHMAIN AND DISPLY(JOYS)   J.O. 21.10.81'
./ SHOW ' REMOVED OLD DEBUG PRINT IN EVDISP            J.O. 23.10.81'
./ SHOW ' UPDATED MCGJET AND JBOVER                    J.O. 26.10.81'
./ SHOW ' UPDATED EFMASS                               J.O. 28.10.81'
./ SHOW ' UPDATED BANKPR                              J.O. 29.10.81'
./ SHOW ' * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *'
./ SHOW ' UPDATED VRTPOS                              PST   6.11.81'
./ SHOW ' UPDATED EVWRIT TO ACCOM.CHANGE TO MUCONW    J.O. 12.11.81'
./ SHOW ' UPDATED CREDIT, ARGUMENT CHANGE IN JOYS     J.O. 12.11.81'
./ SHOW ' UPDATED BANKPR,TRUTH                        J.O. 13.11.81'
./ SHOW ' UPDATED  TRUTH AGAIN, ERROR FOUND..   J.O. 16.11.81'
./ SHOW ' REPLACED RDMTCO WITH RDMESS FROM ELSENS LIBRARY. OLD RDMTCO '
./ SHOW ' IS RENAMED TO RDMTCO0 AND OLD RDMTCO0 SCRATCHED. DEFAULT  '
./ SHOW ' TRIGGER AND DETECTOR CONDITIONS ARE NOW FOR 1981   '
./ SHOW '                                       J.O. 19.11.81'
./ SHOW ' CORRECTED ERROR IN COMMAND STVW: INVOLVED ROUTINES ARE'
./ SHOW ' GPHMAIN,SCANNR,DISPLY,JADISP          J.O. 20.11.81'
./ SHOW ' ANOTHER SUBTLE BUG IN DISPLY CHANGED  J.O. 22.11.81'
./ SHOW ' RDMTCO COPLANAR ERROR TEMPORARILY CORRECTED  J.O. 22.11.81'
./ SHOW ' UPDATE OF GRPHMAIN,SCANNR,DISPLY FOR DSPDTL9 J.O. 25.11.81'
./ SHOW ' UPDATE OF LINDIS AND PARDIS                  J.O. 25.11.81'
./ SHOW ' UPDATE OF SUPERV (CGEO1 BLOCK DATA)          J.O. 25.11.81'
./ SHOW ' UPDATE OF CREDIT AND DISPLY  (COM.STVW)      J.O. 27.11.81'
./ SHOW ' ADJUSTED ZXC,ZYC VIEW IN SETSCL              J.O. 27.11.81'
./ SHOW ' CORRECTED SMALL ERROR IN MOMGAM              J.O. 03.12.81'
./ SHOW ' CORRECTED SMALL ERROR IN LINDIS              J.O. 04.12.81'
./ SHOW ' CORRECTED SMALL ERRORS IN GAMDIS AND RSDISP  J.O. 11.12.81'
./ SHOW ' UPDATE OF SPINNR FOR AUTUMN 1981             J.O. 14.12.81'
./ SHOW ' UPDATE OF BANKPR                             J.O. 17.12.81'
./ SHOW ' VRTPOS: VERTEX = 0. FOR MC-EVENTS            P.S. 22.12.81'
./ SHOW ' CORRECTED SERIOUS ERROR IN RDMTCO (SUBR. RDALGN)          '
./ SHOW '   THIS ERROR MAKES ANY PHOTON OR LEADGLASS ANALYSIS IN MC '
./ SHOW '   EVENTS PRACTICALLY USELESS, SINCE 19.11.1981  '
./ SHOW '                                          J.O.  22.12.1981'
./ SHOW ' ADDED EVREADX: ALLOWS PROGRAM TO CONTINUE IF MC DATA HAS NO'
./ SHOW '  MUON CONSTANTS RECORD AFTER THE ID CONSTANTS   J.O. 7.1.82'
./ SHOW ' EVREAD NOW IDENTICAL TO EVREADX             J.O. 7.1.1982'
./ SHOW ' ADDED PRINT IN USREDUC2                    J.O. 20.1.1982'
./ SHOW ' INSTALLED COMMAND TRLG: BG AND TOF TRIGGER FOR NEW DATA'
./ SHOW ' INVOLVED ROUTINES: KOMMAN,DISPLY,SCANNR,NEWS,MENU,NOTICE'
./ SHOW ' NEW ROUTINES: TBGDIS,TBGSTR,ECAPQ,CIRSEG,   ALL IN THE '
./ SHOW ' MEMBER TBGDIS.  JBOVER CHANGED ACCORDINGLY   J.O. 02.2.1982'
./ SHOW ' UPDATED TBGDIS AND FWMUHT FOR NEW DATA       J.O. 05.2.1982'
./ SHOW ' SCRATCH MEWT3: DUPLICATE ON JADEPR.JADESR    J.O. 09.2.1982'
./ SHOW ' JBOVER UPDATED WITH NEW TOF SUBROUTINE TFARNW  J.O. 10.2.1982'
./ SHOW ' DRTRCK INSTALLED : DISTANCE (TRACK-VERTEX)     P.S. 12.2.1982'
./ SHOW ' KALIBR CORRECTED  (YEAR WAS SET TO 1981)       P.S. 12.2.1982'
./ SHOW ' UPDATE OF TBGDIS AND CAPMRK. CAPMRK NOW MEMBER BY ITS OWN'
./ SHOW ' AND NO LONGER CONTAINED IN EVDISP.  INSTALLED COMMAND FADC'
./ SHOW ' CONCERNED ROUTINES ARE KOMMAN,SCANNR,DISPLY,MENU,DSFADC'
./ SHOW ' JBOVER UPDATED WITH NEW BRANCH                 J.O. 12.2.1982'
./ SHOW ' KALIBR UPDATED (DRIFT VEL.,LOR.ANGLE, T0)      PST. 24.2.1982'
./ SHOW ' SHIFTED KALPRE FROM JADEPR.JADESR TO F11LHO.JADEGS FOR       '
./ SHOW ' CONSISTENCY AND SIMPLICITY                        GFP 27/2/82'
./ SHOW ' VRTPOS (VERTEX X-Y FOR DIFFERENT RUNS) UPDATED  PST 82/03/09'
./ SHOW ' KALIBR CORRECTED FOR SERIOUS ERROR !!     J.O.  12.3.1982'
./ SHOW ' KALIBR CORRECTED FOR FEB 29.              PST.  30.3.1982'
C   22/03/97 703221757  MEMBER NAME  #START1  (JADEGS)      FORTRAN
FREE F(MACRO,CLIST)
ALLOC F(MACRO) DA('F11GOD.PATRECSR') SHR
ALLOC F(CLIST) DA('F11PEA.JDCLIST') SHR
CLEBR
./ SHOW '  ALL OLD MESSAGES CAN BE FOUND IN MEMBER #START0  '
./ SHOW '                                        P. STEFFEN 81/12/04'
./ SHOW '***********************************************************'
./ SHOW ' KALIBR UPDATED WITH CONSTANTS FOR RUNS > 11036           '
./ SHOW ' OLD VERSION RETAINED AS KALIBR0           GFP   17.5.1982'
./ SHOW ' UPDATED SPINNR, SMALL CHANGES IN BLSHOW,SCANNR'
./ SHOW '                                           J.O.  18.5.1982'
./ SHOW ' SUPERV EXTENDED TO 27000 WORDS IN BCS,BINT  J.O.  20.5.1982'
./ SHOW ' UPDATED SPINNR,CAPMRK,DEDXVW,TOFDS,TOFVW  J.O.  28.5.1982'
./ SHOW ' KALIBR CHANGED: 1982 FORCED FOR RUNS > 10000'
./ SHOW '                                           P.S.  82/06/15 '
./ SHOW ' UPDATED BANKPR,JBOVER                     J.O.  19.6.1982'
./ SHOW ' KALIBR UPDATED, NEW TZEROS FOR 1982       P.S.  21.6.1982'
./ SHOW ' UPDATED BANKPR                            J.O.  21.6.1982'
./ SHOW ' UPDATED SPINNR,DRAWER                     J.O.  22.6.1982'
./ SHOW ' JRECAL CORRECTED                          P.S.  22.6.1982'
./ SHOW ' INSTALLED COMMAND GVTX: VERTEX FIT FOR SELECTED TRACKS'
./ SHOW ' INVOLVED ROUTINES: GVTXFT,DISPLY,SCANNR,NEWS,MENU,NOTICE'
./ SHOW '                    KOMMAN,JBOVER   J.O.  23.6.82'
./ SHOW ' DELETED AXSHOW AND INSTALLED IT ON GRAPHS, TOGETHER WITH'
./ SHOW ' MODIFIED VERSION OF MCGJET (ALL COMMONS IN CWORK) IN ORDER'
./ SHOW ' TO GAIN SOME 10 KBYTES OF SPACE    J.O.  23.6.82'
./ SHOW ' CHANGED EBEAM INTO MORE SPACE SAVING FORM AND CORRECTED OLD'
./ SHOW ' ERROR (RUNS 4600-4700). OLD VERSION EBEAM0  J.O.  25.6.82'
./ SHOW ' KLREADSC + KALIBRSC INSTALLED (SPECIAL VERSION FOR IMPROVED'
./ SHOW '            MOMENTUM RESOLUTION FOR SPRING 82 DATA          '
./ SHOW '                                             P.ST. 82/06/28 '
./ SHOW ' KLREAD CHANGED TO PRINT FIRST EVENT DATE. SUBR. RDDATE     '
./ SHOW ' COPIED FROM JMC.S, WITH DEFAULT SETTING OF MC TIME TO JAN.81'
./ SHOW ' RDMTCO CHANGED TO CALL RDDATE.  ALL THIS WAS DONE TO COPE  '
./ SHOW ' WITH KLREAD ERROR, REASON UNKNOWN AT PRESENT  J.O. 13.7.82 '
./ SHOW ' KALIBR ALSO CHANGED, TO OVERWRITE YEAR 1982 IN MONTE CARLO '
./ SHOW ' WITH 1981. THIS IS BECAUSE TPMAIN PROGRAM CALLS KALIBR     '
./ SHOW ' BEFORE RDJETC !!!!                            J.O. 14.7.82 '
./ SHOW ' UNDEFINED VARIABEL IMUR2 IN SUPERV CHANGED !!  OUR THANKS  '
./ SHOW ' GO TO R.BARLOW...                             J.O. 16.7.82 '
./ SHOW ' KLREAD: CHANGE OF EOF HANDLING:                            '
./ SHOW '         GENERATE DUMMY DATA WITH YEAR ==2000               '
./ SHOW '         OLD VERSION = KLREAD0                              '
./ SHOW '         OLD KLREAD0 + KLREAD1 SCRATCHED       P.S.  5.8.82 '
./ SHOW ' KLREAD: ALLOW FOR ONLY 1 CALIBR. FILE,                     '
./ SHOW '         HANDLE "RVTX" CONSTANTS (RUN VERTICES)             '
./ SHOW '         OLD VERSION = KLREAD0 (KLREAD0 -> KLREAD1)         '
./ SHOW '                                               P.S. 11.8.82 '
./ SHOW ' KALIBR: RUNS 12255-12270 GET NOW MAGNETIC FIELD WRITTEN INTO'
./ SHOW '         THE HEADER BANK. IN RAW DATA IT IS ==0  J.O. 11.8.82'
./ SHOW ' REFITV: TRACK FITTING ROUTINE WITH VERTEX CONSTRAINT       '
./ SHOW '         USING NEW CHAMBER CALIBRATION + RUN VERTICES'
./ SHOW '                                               P.S. 12.8.82 '
./ SHOW ' KALIBR: RUNS 11908       GET NOW MAGNETIC FIELD WRITTEN INTO'
./ SHOW '         THE HEADER BANK. IN RAW DATA IT IS ==0  J.O. 16.8.82'
./ SHOW ' VTXPRE CHANGED TO MODIFY HEAD BANK IN SAME WAY AS KALIBR, FOR'
./ SHOW '      RUNS WITH MAGNETIC FIELD=0 ERRONEOUSLY     J.O. 16.8.82'
./ SHOW ' RESTRUCTURING OF GRAPHICS; INVOLVED ROUTINES ARE:'
./ SHOW '  GPHMAIN SUPERV KLREAD KOMMAN DISPLY SCANNR STPLST STWADD'
./ SHOW '  WALLOK JADISP CAPMRK TOFVW RETTEN CREDIT GRAPHS(USER) MENU'
./ SHOW '  NOTICE NEWS JBOVER.    BACKUPS: GPHMAIN0 SCANNR0 STPLST0 '
./ SHOW '  RETTEN0 GRAPHS(USER0) STWADD0 NEWS0 NOTICE0 SUPERV0'
./ SHOW '  OBS: SUPERV NOW HAS /BCS/IDATA(33000)  TO COPE WITH RECENT'
./ SHOW '       COMPLAINTS ABOUT LOST EVENTS IN BOS.      J.O. 01.9.82'
./ SHOW '   THE ABOVE CHANGES LEAD TO PROBLEMS IN PATREC. THEREFORE    '
./ SHOW '   THE OLD SUPERV0 WAS REINSTALLED AND THE NEW SUPERV AGAIN  '
./ SHOW '   MADE TO SUPERVX. TEMPORARILY FOR GRAPHICS: SUPERVY. JBOVER'
./ SHOW '   WAS CHANGED TO ACCOUNT FOR THE TEMPORARY VERSIONS, UNTIL  '
./ SHOW '   THE PATREC PROBLEM HAS BEEN FOUND.            J.O. 02.9.82'
./ SHOW '   ERROR IN SUPERVX FOUND (MISSING INPATC,PST) J.O. 02.9.82'
./ SHOW '   SUPERVX NOW MADE STANDARD, AFTER TESTING    J.O. 03.9.82'
./ SHOW '   JBMENU, NOTICE, GPHMAIN UPDATED             J.O. 04.9.82'
./ SHOW '   KLREAD: SET LABEL(NO LG-CALIBR.) FOR LGCALB    P.S. 06.9.82'
./ SHOW '   SUPERV: CALL LGCALB ONLY IF ALGL-BANK EXISTING P.S. 07.9.82'
./ SHOW '   KLREAD: CONSTANTS = 0 FOR MC-EVENTS            P.S. 08.9.82'
./ SHOW '           OLD VERSION = KLREAD0                              '
./ SHOW '   UPDATED NOTICE AND RSDISP, SMALL BUGS          J.O. 14.9.82'
./ SHOW '   KALIBR: E-BEAM=17300 FOR RUN 11790             P.S. 21.9.82'
./ SHOW '   UPDATED BLSHOW AND SPINNR                     J.O. 12.10.82'
./ SHOW '   UPDATED EFMASS AND IDFUN                      J.O. 21.10.82'
./ SHOW '   UPDATED DISPLY, OLD VERSION DISPLY0           J.O. 22.10.82'
./ SHOW '   KALIBR01, KLREAD01: COPIES OF KALIBR + KLREAD P.S. 26.10.82'
./ SHOW '   PREPARATION FOR CHANGE ANNOUNCED FOR 28TH.                 '
./ SHOW '   KALIBR + KLREAD  REPLACED BY NEW VERSION      P.S. 28.10.82'
./ SHOW '   KLREAD CORRECTED (CALIBR NOT PROPERLY ZEROED) P.S. 29.10.82'
./ SHOW 'CORRECTIONS IN WALLOK AND SCANNR (WRIT)          J.O. 03.11.82'
./ SHOW 'UPDATE OF DEDXDS, DISPLY, CAPMRK                 J.O. 03.11.82'
./ SHOW 'KALIBR: NO YEAR-CHANGE FOR RUNS <100             P.S. 18.11.82'
./ SHOW 'KLREAD: GET MUCA-CONSTANTS FOR RUNS<100                       '
./ SHOW '        OLD VERSION = KLREAD0                    P.S. 19.11.82'
./ SHOW 'RDMTCO: CALL TO RDDATE COMMENTED OUT UNTIL FURTHER NOTICE. THE'
./ SHOW '        UPDATING OF RDMTCO WILL BE INVESTIGATED  J.O. 19.11.82'
./ SHOW 'DEDXDS UPDATED: PROTECT AGAINST MC DATA          J.O. 22.11.82'
./ SHOW 'IDFUN UPDATED                                   J.O. 23.11.82'
./ SHOW 'UPDATE FOR JADISP,EVDISP,RSDISP,KOMMAN,SETSCL,GPHMAIN,'
./ SHOW 'BANKPR,DEDXBN.  INSTALLED RZROLL,RZTRCK.  ALL CONCERNED WITH '
./ SHOW 'THE NEW VIEW RZ.   JBOVER STRUCTURE UPDATED.    J.O. 01.12.82'
./ SHOW 'UPDATED KALIBR,EBEAM FOR RUNS 12804-805         J.O. 08.12.82'
./ SHOW 'GRAPHICS UPDATE:  RSDISP,EVDISP,JADISP,KOMMAN,SCANNR,DISPLY,'
./ SHOW '        IDFUN,CROAX,MENU,NEWS,JBOVER,GPHMAIN    J.O. 08.12.82'
./ SHOW ' INSTALLED USRED282,JBRED282,TWOELS (REDUC2 1982)J.O. 08.12.82'
./ SHOW 'KLREAD: NEW T0, V-DRIFT, ALFA FOR DATA OF FALL 82             '
./ SHOW '        REVISED T0, V-DRIFT, ALFA FOR SUMMER 82  P.S.  8.12.82'
./ SHOW ' CORRECTED UNDEFINED VARIABLES, ALL OF MINOR OR NO IMPORTANCE '
./ SHOW '  HELDIS: IJ --> IF, IN PRINT STATEMENT'
./ SHOW '  REDTVA: RLG,ZENDPL NEED CGEO1. USED IN COLL.CHECK FOR NTR=0'
./ SHOW '  USREDUC2: MSKLM1=Z100, FROM 100.   SOME LUMITRIGGERS MAY BE'
./ SHOW '            ON REDUC2 TAPES..........         J.O.  6.1.1983'
./ SHOW '  KLREAD: CORRECT UNDEFINE VARIABLE "IDRUN0"  P.S. 10.1.1983 '
./ SHOW '  FITEVR: CORRECT UNDEFINE VARIABLE "IQZVTX"  P.S. 10.1.1983 '
./ SHOW '  RZTRCK: CORRECT UNDEFINE VARIABLE "RRZCHI"  J.O. 12.1.1983 '
./ SHOW '  TRUTH: CORRECTED DARCOS ERROR               J.O. 26.1.1983 '
./ SHOW '  CORRECTED ERROR IN RDMTCO, SUBR. RDTRG1 CONCERNING T1 POST-'
./ SHOW '  PONE SIMULATION. SAME ERROR EXISTS ON JMC.S !!  AFFECTS THE'
./ SHOW ' COPLANAR TRIGGER CONDITION                   J.O. 30.1.1983 '
./ SHOW ' CORRECTED LOOP STRUCTURE IN RDMTCO(RDTRG1), WHICH CAUSES '
./ SHOW ' ERROR IN RUTHERFORD. JMC.S ALREADY HAD IT OK.   J.O. 11.2.83 '
./ SHOW '  TRUTH: CORRECTED DARCOS ERROR AGAIN         J.O. 17.2.1983 '
./ SHOW 'TR3DSP UPDATED (ERROR CORRECTED BY C.BOWDERY)  J.O. 22.2.1983 '
./ SHOW 'EFMASS UPDATED (SMALL BUG IN PHOTON CONV.)     J.O. 22.2.1983 '
./ SHOW 'EFMASS UPDATED (BUG WAS STILL PRESENT !        J.O. 04.3.1983 '
./ SHOW 'SUPERV: TRY IUHR TWICE IF TIME LIMIT           P.S. 15.3.1983 '
./ SHOW 'KLREAD: INCREASE AREA FOR JTAB CONSTANTS                      '
./ SHOW '        OLD VERSION = KLREAD0                  P.S. 19. 4.1983'
./ SHOW 'JETCAL,JRECAL SET AMPLITUDES = 0 IF OVERFLOW   P.S. 21. 4.1983'
./ SHOW 'KLREAD: UPDATE T0,ALFA,VD FOR RUNS 13000..     P.S. 29. 4.1983'
./ SHOW 'ZSREAD DELETED. IT IS NOW AGAIN ON F11DIT.HELIX  J.O. 3.5.1983'
./ SHOW '  COMMAND PATR INSTALLED IN GRAPHICS; INVOLVED ROUTINES ARE:'
./ SHOW ' KOMMAN,SCANNR,DISPLY,VXDISP,GVTXFT,EFMASS,NEWS,MENU,JBMENU.'
./ SHOW ' IDFUN UPDATED                                   J.O. 4.5.1983'
./ SHOW ' JRECAL CHANGED (SLEWING CORRECTION RUNS 6185..) P.S.11.5.1983'
./ SHOW ' UPDATED RSDISP,BANKPR,TRUTH                     J.O.16.5.1983'
./ SHOW ' Z-RECALIBRATION + FIT ROUTINES INSTALLED:       P.S.17.5.1983'
./ SHOW ' MVB, ZRECAL, ZSFIT, ZSLINE, ZSPUR, ZSREAD, ZSSPEC, ZSXY      '
./ SHOW ' CORRECTED ERROR IN BANKPR                       J.O.18.5.1983'
./ SHOW ' UPDATED BANKPR WITH N50S PRINT OPTION;  ALSO UPDATED IDFUN'
./ SHOW ' INSTALLED TEMPORARY MEMBER MUHITSX, TO BE USED IN GRAPHICS   '
./ SHOW '    UNTIL OVERLAY ERROR WITH PRESENT MUHITS ON JADEMUL HAS '
./ SHOW ' BEEN CLEARED UP, JBOVER CHANGED ACCORDINGLY     J.O.28.5.1983'
./ SHOW ' MUHITSX SCRATCHED, MUHITS OK AGAIN              J.O.30.5.1983'
./ SHOW ' BANKPR UPDATED, N50S AND MPRS PRINT ENHANCED    J.O.30.5.1983'
./ SHOW ' IDFUN UPDATED   J.O.04.6.1983'
C   22/03/97 703221757  MEMBER NAME  #START2  (JADEGS)      FORTRAN
./ SHOW '  ALL OLD MESSAGES CAN BE FOUND IN MEMBERS #START0,#START1'
./ SHOW '                                        J.OLSSON   83/08/08'
./ SHOW '***********************************************************'
./ SHOW 'KLREADMI: T0-CHANGE (SPEC.VERS. FOR MINOWA)    P.S. 10. 6.1983'
./ SHOW 'KALIBR UPDATED, B=0 IN RUNS 13651-53 CORRECTED J.O. 13. 6.1983'
./ SHOW 'DEDXDS,DEDXVW UPDATED                          J.O. 14. 6.1983'
./ SHOW 'KALIBR UPDATED, EBEAM  RUNS 13707-14 CORRECTED J.O. 14. 6.1983'
./ SHOW 'KLREAD: IMPROVED T0,VD FOR RUNS 13000..        P.S. 16. 6.1983'
./ SHOW 'FRFITV, REFIT, REFITV: CLOSE WIRE CORR. ACTIV. P.S. 16. 6.1983'
./ SHOW 'KLREAD: CHANGED FIRST PRINT TO RECOGNIZE IT..  J.O. 19. 6.1983'
./ SHOW 'ZSSPEC: CORRECTED BUG, EFFECTIVE FOR 1983 DATA J.O. 27. 6.1983'
./ SHOW 'UPDATED BANKPR (FAMP=BK17), DEDXVW(OPTION-5)   J.O. 04. 7.1983'
./ SHOW 'AND STPLST (TRAILING NUMBER)                   J.O. 04. 7.1983'
./ SHOW 'KLREAD9: IMPROVED T0 FOR RUNS 13000...(TEST)   P.S. 21. 7.1983'
./ SHOW 'KLREAD: IMPROVED T0,VD FOR RUNS 13000..        P.S. 16. 6.1983'
./ SHOW 'UPDATED SUPERV BLOCK DATA, NEG. LOR.ANGLE      J.O.  1. 8.1983'
./ SHOW '   THE CHANGE WAS REMADE AT 15.23 DUE TO ERROR J.O.  1. 8.1983'
./ SHOW 'BEAM ENERGY CORRECTIONS IN KALIBR AND EBEAM    J.O.  1. 8.1983'
./ SHOW ' IDFUN UPDATED   J.O.   01. 8. 1983'
./ SHOW ' BEAMENERGY WARNING IN KALIBR AMENDED   J.O. 2.8.1983'
./ SHOW ' BEAMENERGY FOR R13826 IN KALIBR,EBEAM MENDED  J.O. 5.8.1983'
./ SHOW '  SUPERV UPDATED TO CORRECT ALL EVENTS IN CERTAIN RUNS FOR  '
./ SHOW '         FAULTY MAGFIELD, EBEAM ETC. OLD SUPERV NOW SUPERV0'
./ SHOW ' ALSO UPDATED VTXPRE ACC. TO BOB GLASSER   '
./ SHOW '       OLD VTXPRE NOW VTXPRE0          J.O.  6.8.83'
./ SHOW 'CORRECT R10666 IN EBEAM,SUPERV,KALIBR  J.O.  8.8.83'
./ SHOW 'KLREADNC, JFETCHNC, FRFITVNC, REFITNC:                       '
./ SHOW '         NEW ROUTINES FOR NEW CALIBRATION     P.S. 10. 8.1983'
./ SHOW 'FRFITVNC,REFITVNC,REFITNC CORRECTED           P.S. 15. 8.1983'
./ SHOW 'FITEVR CORRECTED                              P.S. 15. 8.1983'
./ SHOW '  LOGICAL ERROR IN LAST CHANGE OF SUPERV NOW CORRECTED'
./ SHOW '    COMMON /CHEADR/ WAS NOT FILLED FOR FIRST EVENT IN THE RUN'
./ SHOW ' AT LEVEL 1, ONLY AT LEVEL2         ERROR WAS ACTIV BETWEEN'
./ SHOW '  5.8.83 AND 17.30 ON 15.8.83                 J.O. 15. 8.1983'
./ SHOW ' BARRY WHITTAKER COMPLAINS ABOUT THE LAST CHANGE OF SUPERV'
./ SHOW ' UNTIL IT IS CLEAR IF ERROR IS IN SUPERV, THE OLD VERSION,   '
./ SHOW '  SAVED AS SUPERV0, IS RENAMED SUPERV. THE NEW VERSION IS NOW'
./ SHOW '  SUPERV9                J.O. 16. 8.1983,   20.25'
./ SHOW 'JFETCH: FETCH TRACK-HITS + CALC. COORDINATES  P.S. 29. 8.1983'
./ SHOW 'FRFITV,REFITV,REFIT: NEW REFIT-ROUTINES        P.S. 29. 8.1983'
./ SHOW '       OLD VERSIONS ARE FRFITV0,REFITV0,REFIT0                '
./ SHOW 'KLREAD: NEW VERSION (CELL DEPENDENT DRIFT VEL.) P.S. 30.8.1983'
./ SHOW '        USED FOR NEW VERSION OF CALIBR. CONSTANTS             '
./ SHOW '        OLD VERSIONS IS KLREAD0                               '
./ SHOW 'TRKROL: UPDATE FOR COMMAND RES N                J.O. 30.8.1983'
./ SHOW '  UPDATE OF MINOR BUG IN COMMAND WRIT, AFFECTED ROUTINES ARE  '
./ SHOW '  SUPERV AND SCANNR   (SUPERV9 ALSO UPDATED)    J.O. 31.8.1983'
./ SHOW 'KLREAD: NEW T0,VD,ALFA FOR MAY82 DATA           P.S.  7.9.1983'
./ SHOW 'JFETCH: MINOR ERROR CORRECTED                   P.S. 12.9.1983'
./ SHOW 'KLREADFI: TEST VERSION FOR TAGF-CONSTANTS       P.S. 15.9.1983'
./ SHOW 'KLREAD: NEW T0,VD,ALFA FOR SUMMER-82 DATA       P.S. 16.9.1983'
./ SHOW 'FRFITV: CORRECT OCCASIONAL -VE SQRT             P.S. 20.9.1983'
./ SHOW 'FZFITV, ZRFITO: ELIMINATE PRINTOUT              P.S. 20.9.1983'
./ SHOW 'FITEVF: NO REFIT IF PT < 20 MEV                 P.S. 22.9.1983'
./ SHOW 'REFIT : ELIMINATE PRINTOUT                      P.S. 22.9.1983'
./ SHOW 'SMALL UPDATES, TO PREPARE FOR COMMAND ZTRG. INVOLVED ROUTINES '
./ SHOW 'ARE: CAPMRK,BANKPR,DEDXVW,DSFADC,TOFVW,DISPLY   J.O. 24.9.1983'
./ SHOW 'FRFITV: CORRECT OCCASIONAL DIV.CHECK            P.S. 27.9.1983'
./ SHOW 'INSTALLED COMMAND ZTRG IN GRAPHICS.  INVOLVED ROUTINES ARE:'
./ SHOW ' KOMMAN,SCANNR,DISPLY,MENU,NEWS,ZTRGVW,JBOVER   J.O. 27.9.1983'
./ SHOW 'FRFITV: CORRECT OCCASIONAL DIV.CHECK            P.S. 30.9.1983'
./ SHOW 'INSTALLED COMMAND JETC IN GRAPHICS.  INVOLVED ROUTINES ARE:'
./ SHOW ' KOMMAN,SCANNR,DISPLY,EVDISP,MENU,NEWS          J.O. 4.10.1983'
./ SHOW 'KLREAD: TAGF-CONSTANTS --> /CALIBR/             P.S. 6.10.1983'
./ SHOW '        OLD VERSION = KLREAD0                   P.S. 6.10.1983'
./ SHOW 'INSTALLED DEDXDN: NEW VERSION OF DEDXBN, TO REPLACE PRESENT'
./ SHOW ' ONE AFTER INTRODUCTION TO JADE MEETING         J.O. 6.10.1983'
./ SHOW 'CHANGE OF DEDXDN: A BUG REPAIR BY J.A. SKARD DOES NOT DO THE'
./ SHOW ' JOB. THE OLD BUG REPAIR OF J.O. REASSUMED.     J.O. 9.10.1983'
./ SHOW 'KLREAD: NEW T0,VD,ALFA FOR FALL-82 DATA         PST 13.10.1983'
./ SHOW 'KLREAD: NEW T0,VD (PROV.) FOR FALL-83 DATA      PST 18.10.1983'
./ SHOW ' INSTALLED MCTRCB AND MCTR4V  (JCN 69)         J.O. 19.10.1983'
./ SHOW ' INSTALLED RDMTCOGS AND RDTRIGGS, TO REPLACE RDMTCO TOMORROW.'
./ SHOW ' TOGETHER WITH RDDATE THEY CONSTITUE A COMPLETE SET OF THE NEW'
./ SHOW ' SMEARING AND TRIGGER SIMULATION ROUTINES      J.O. 19.10.83'
./ SHOW '   MAJOR REPLACEMENT OF GRAPHIC AND OTHER ROUTINES          '
./ SHOW '  INVOLVED ROUTINES:  SUPERV,SUPERV9,GPHMAIN,SCANNR,SETSCL, '
./ SHOW '    JADISP,EVDISP,RSDISP,FWCHEV,BLNUMB,XYTAG,CROAX,TAGCHK,  '
./ SHOW '    TRKHIT,SPINNR,EVREAD,EVWRIT,RDMTCO,RDTRIG,RDDATE,BLSHOW '
./ SHOW '    JADEOVLY,JBOVER.  COMMENTS, SEE  JADEPR.TEXT(JBIMPNOT)  '
./ SHOW '                               J.O.  20.10.1983             '
./ SHOW 'REFIT : CORRECTED (1. + LAST POINT OF TRACK)    PST 20.10.1983'
./ SHOW 'JFETCH: COORD.CORR. OF MC = 0.                  PST 20.10.1983'
./ SHOW 'UPDATED JADEOVLY,MCTRCB AND INSTALLED MCHTRB   J.O. 26.10.1983'
./ SHOW 'UPDATED SPINNR                                 J.O. 26.10.1983'
./ SHOW 'UPDATED JADEOVLY (ERROR IN OVERLAY DISCOVERED) J.O. 27.10.1983'
./ SHOW 'UPDATE JBOVER (RENAME TAGGING.L --> TAGG.L)    J.O. 28.10.1983'
./ SHOW 'MCTR4V HAD A SERIOUS BUG FOR ABOUT 8 HOURS     J.O. 31.10.1983'
C   22/03/97 703221757  MEMBER NAME  #START3  (JADEGS)      FORTRAN
./ SHOW 'OLD MESSAGES CAN BE FOUND IN MEMBERS #START0,#START1,#START2'
./ SHOW '                                        C.BOWDERY  21/02/84'
./ SHOW '***********************************************************'
./ SHOW 'SUPERV CHANGED TO CALL LGCDIR (ALSO SUPERV9)   J.O. 09.11.1983'
./ SHOW 'RDTRIG SPLIT UP IN RDTRIG,RDTRG1,RDTRG2,RDHEAD.  REASON IS A'
./ SHOW 'A CURIOUS COMPILER ERROR. RDTRG2 DOESNT WORK IF COMPILED WITH '
./ SHOW 'THE REST, IN OPT(2), OR OPT(3)                 J.O. 11.11.1983'
./ SHOW 'NEWS AND NOTICE ALTERED.                       C.B. 11.11.1983'
./ SHOW 'S/R HELPUS ON MEMBER MENU UPDATED              C.B. 14.11.1983'
./ SHOW 'JBOVER UPDATED IN VARIOUS UNIMPORTANT WAYS     J.O. 14.11.1983'
./ SHOW 'UPDATE OF BANKPR AND JBOVER                    J.O. 16.11.1983'
./ SHOW 'ADD RDDATEMC FOR CURE OF MUON MC CALIBR.CONST. J.O. 18.11.1983'
./ SHOW 'NEW DEDX ROUTINES + CALIBR.CONST. INSTALLED    PST  21.11.1983'
./ SHOW '  DEDXBN,MOMENP,DSORT,ERRMOM,DECHIF,CHIFT1,DETHRY,THDEDX'
./ SHOW 'FURTHER CHANGES:  DEDXVW AND JADEOVLY      J.O.   23.11.83'
./ SHOW 'KLREAD: T0, VD, LOR.ANGLE FOR RUNS 6184-7591    PST 24.11.1983'
./ SHOW 'EVREAD,RDTRIG AND RDDATE MODIFIED TO USE                      '
./ SHOW 'NEW CADMIN MACRO CONTAINING COMMON CADMIN.                    '
./ SHOW 'RDDATE ALSO INCLUDES CODE TO FORCE JETC SMEARING              '
./ SHOW 'DATE TO BE MUON TRACKING DATE WHEN MUEV BANK                  '
./ SHOW 'FOUND. RDDATEMC SCRATCHED AS NOW OBSOLETE       C.B. 24/11/83 '
./ SHOW 'DEDXBN GRAPHICS PRINTING PROBLEM SOLVED  &                    '
./ SHOW 'NOTICE UPDATED. JADE RELINKED.                  C.B. 25/11/83 '
./ SHOW 'GRAPHICS COMMAND NWCL INTRODUCED. AFFECTED MEMBERS ARE: '
./ SHOW 'GPHMAIN,KOMMAN,SCANNR,DISPLY,MENU,NEWS,NOTICE,NEWCAL,JADEOVLY '
./ SHOW 'MEMBER JBMENU WAS MOVED TO JADEPR.TEXT(JBJCN34) J.O. 26/11/83 '
./ SHOW 'MEMBER IDFUN UPDATED                            J.O. 26/11/83 '
./ SHOW 'KLREAD: NEW TREATMENT OF MC-MU-CHAMBER CONST.   PST 28.11.1983'
./ SHOW 'KLREADCA = OLD VERSION                                        '
./ SHOW 'CORRECTION TO NEWCAL                            J.O. 28/11/83 '
./ SHOW 'KLREAD: NEW T0,VD, LORENTZ ANGLE FOR FALL 81    PST 29.11.1983'
./ SHOW 'KLREAD0 = OLD VERSION                                         '
./ SHOW 'KLREADBK = TEST VERSION FOR ZCAL CONSTANTS                    '
./ SHOW 'NEW ZCAL ROUTINES + CALIBR.CONST. INSTALLED    PST  05.12.1983'
./ SHOW '  NEW ROUTINES: KLREAD,ZSFIT,ZRECAL,ZSLINE,ZSPUR,ZSREAD       '
./ SHOW '  OLD ROUTINES: KLREAD0,ZSFIT0, ...                           '
./ SHOW 'KLREAD: NEW T0,VD, LORENTZ ANGLE FOR SUMMER 81  PST  8.12.1983'
./ SHOW '        REVISED T0, LORENTZ ANGLE FOR FALL82'
./ SHOW 'KLREAD0 = OLD VERSION                                         '
./ SHOW 'UPDATE OF NEWCAL, ADJUST TO NEW ZSFIT CHANGES   J.O. 08/12/83 '
./ SHOW 'NEW DEDXB1 ROUTINE INSTALLED                     PST   9.12.83'
./ SHOW 'CORRECT PRINT STATEMENT IN DEDXB1                J.O. 12.12.83'
./ SHOW 'INSTAL NEW COMMAND FAMP. AFFECTED ROUTINES ARE KOMMAN,MENU,'
./ SHOW '  SCANNR,DISPLY,NEWS,FAMPDS,FAMPFT,JADEOVLY      J.O. 12.12.83'
./ SHOW 'EVREAD CHANGE: JUSCRN SET TO 6 IF UNDEFINED                   '
./ SHOW '             : CALL TO MUREG ADDED AFTER MUCON   C.B. 13.12.83'
./ SHOW ' GVTXFT UPDATED                                  J.O. 13.12.83'
./ SHOW ' JADEOVLY CHANGED, DUE TO MUREG MOVE YESTERDAY   J.O. 14.12.83'
./ SHOW ' RECOMMENTED  USER/USER0/USERB/USERCP/USERRJ     C.B. 14.12.83'
./ SHOW 'AXSHOW MOVED TO JADEGS/L FROM GRAPHS/L           J.O. 15.12.83'
./ SHOW 'ERROR IN RDMTCO CORRECTED...                     J.O. 15.12.83'
./ SHOW 'KLREAD UPDATE: DONT READ FILES IF ALL LBMC=0, MC J.O. 15.12.83'
./ SHOW 'UPDATE REDONE AND LGCUTX FOR PRTOCI CALL, INSTALLED PRTOCI'
./ SHOW 'TO COINCIDE WITH PRTOCI ON TPSOURCE             J.O.  17.12.83'
./ SHOW 'MOFRCI MOVED FROM TPSOURCE TO HERE.             C.B.  19.12.83'
./ SHOW 'CORRECT ERROR FOR MUON MC IN KLREAD        J.O.,C.B.  20.12.83'
./ SHOW 'CORRECT DEAD LOOP IN RDMODN (RDMTCO)  J.O.,J.HAGEMANN 23.12.83'
./ SHOW 'NEW SUPERV RELEASED ALONG WITH THE                            '
./ SHOW 'NEW BLOCK DATA MEMBER JADEBD. OLD USER                        '
./ SHOW 'ROUTINES SCRATCHED AND CURRENT USER REDUCED TO                '
./ SHOW 'MINIMUM CODE ONLY. KALIBR AND KLREAD NOW HAVE                 '
./ SHOW 'EXTERNAL JADEBD TO ENSURE JADEBD IS LOADED.    C.B.    9/01/84'
./ SHOW 'ADDED LIST OF JADE MEMBERS INTO #JADE          C.B.    9/01/84'
./ SHOW 'JDMAIN0 EDITED TO REMOVE  JUSCRN=6 & CGRAPH    C.B.   11/01/84'
./ SHOW 'USER NOW CALLS BSTA AT LEVEL 100               C.B.   11/01/84'
./ SHOW 'SUPERV NOW PRINTS A HEADLINE BANNER            C.B.   16/01/84'
./ SHOW 'SUPERV AND GPHMAIN HAVE /BCS/IDATA(40000)      C.B.   16/01/84'
./ SHOW 'NEW DEDXBN DEDXB1,CHIFT1,THDEDX,/CDEDEDX/      PST    17.01.84'
./ SHOW 'MCTR4V SPEEDED UP CONSIDERABLY                 C.B.   17/01/84'
./ SHOW 'UPDATE JADEOVLY,RDMODN(MEMBER RDMTCO) AND ZSFIT J.O.  19/01/84'
./ SHOW 'NEW CBCSMX MACRO USED IN SUPERV & GPHMAIN      C.B.   19/01/84'
./ SHOW 'UPDATE SPINNR FOR RUNS > 14216                 J.O.   27/01/84'
./ SHOW 'CHANGES TO NEWS AND HELPUS (LATTER IS ON MENU) C.B.   01/02/84'
./ SHOW 'SERIOUS BUG IN DEDXVW AND TOFVW REMOVED        C.B.   03/02/84'
./ SHOW 'NEW VERSION OF DEDXVW WITH SMALLER SYMBOLS     C.B.   03/02/84'
./ SHOW 'SMALL CORRECTION OF DATE IN RDTRIG BLOCKDATA   J.O.   04/02/84'
./ SHOW 'RDMTCO1 WITH CHANGED RDALGN,RDRESO'
./ SHOW '  TO BE CHANGED AFTER CIRCULATION OF JCN 66A   J.O.   08.02.84'
./ SHOW 'IDFUN UPDATED FOR ROBIN MIDDLETON F22MID       C.B    08.02.84'
./ SHOW 'COMPRESSED TAGGING CODE IN EVDISP. AFFECTED ROUTINES FWCHEV'
./ SHOW 'AND JADEOVLY                                   J.O.   08.02.84'
./ SHOW '/CADMIN/ BLOCKDATA SET IN JADEBD NOW NOT EVREAD.              '
./ SHOW 'CADMIN MACRO MOVED TO PATRECSR. THE FOLLOWING                 '
./ SHOW 'HAVE BEEN CHANGED AND RECOMPILED:                             '
./ SHOW 'CORRECTED ERROR PRINT IN DEDXBN                J.O.   09.02.84'
./ SHOW 'RDTRIG AND RDMTCO UPDATED ACCORDING TO SPECIFICATION IN '
./ SHOW 'JCN 66 ADDENDUM  RDMTCO1 SCRATCHED             J.O.   09.02.84'
./ SHOW 'RDALGN IN RDMTCO NO LONGER PRINTS IN JADEZ     C.B.   13.02.84'
./ SHOW 'EVREAD ERROR MESSAGES IMPROVED                 C.B.   13.02.84'
./ SHOW 'SMALL CHANGE TO BANKPR TO AVOID ERROR MESSAGE  C.B.   13.02.84'
./ SHOW 'SMALL COSMETIC CHANGE TO EVREAD                C.B.   14.02.84'
./ SHOW 'IMPROVED VERSION OF SUPERV RELEASED            C.B.   15.02.84'
./ SHOW 'DEDXVW REPLACED BY DEDXVW,DRTHCV AND DRAWPI    C.B.   16.02.84'
./ SHOW 'JADEOVLY UPDATED BY ADDING DRTHCV              C.B.   16.02.84'
./ SHOW 'SERIOUS BUG IN SUPERV CORRECTED WRT RE-PATREC                 '
./ SHOW 'FOR REAL DATA. MC DATA AND UNANALYSED DATA WERE               '
./ SHOW 'NOT AFFECTED.  NEW JADEZ CREATED.              C.B.   17.02.84'
./ SHOW 'CHANGES TO GRAPHICS. NEW COMMAND CDST ADDED                   '
./ SHOW 'ALONG WITH CODE FOR VRX,VRZX & VRZY COMMANDS WHICH            '
./ SHOW 'ARE NOT ACTIVE YET. NEW MEMBERS ADDED:                        '
./ SHOW 'CDST , PROJEC , JOYS                                          '
./ SHOW 'CHANGED MEMBERS: SCANNR,DISPLY,KOMMAN,CREDIT,JADEOVLY,MENU,   '
./ SHOW 'NEWS , NOTICE .  S/R CDTLCO HAS GONE.     C.B. P.H.   17.02.84'
$   28/06/85            MEMBER NAME  #START4  (JADEGS)      NEWLIB
CLEAR
./ SHOW 'OLD MESSAGES NOW IN MEMBERS #START0,#START1,#START2,#START3'
./ SHOW 'NEW MESSAGES ARE IN #START              C.BOWDERY  28/06/85'
./ SHOW '***********************************************************'
./ SHOW '  NEW STANDARD VIEWS VRX,VRZX,VRZY INTRODUCED IN GRAPHICS'
./ SHOW '  INVOLVED MEMBERS ARE:    CAPMRK,CIRDIS,CROAX,EVDISP,TRNUMB,'
./ SHOW '  GAMDIS,LINDIS,PARDIS,JADISP,RSDISP,SAEGE,TRUTH,SETSCL,'
./ SHOW '  VRXCIR,VXDISP,NEWS,MENU,NOTICE,JADEOVLY      J.O.   19.02.84'
./ SHOW 'NEW VERSION OF EVREAD ALONG WITH NEW S/R EVBKPR            '
./ SHOW 'TO PRINT BANK LIST. ALSO USED BY BANKPR WHICH IS ALSO      '
./ SHOW 'NEWLY REPLACED ON JADEGS. NEW JADEZ MADE.      C.B.   19.02.84'
./ SHOW 'RDMTCO HAS BEEN SPLIT. MANY NEW MEMBERS.                      '
./ SHOW 'RDMTCO ONLY HAS ENTRY RDJETC AND BLOCKDATA.    C.B.   19.02.84'
./ SHOW 'IMPROVED EVWRIT. PRINTS WARNING IF NO HEAD.    C.B.   20.02.84'
./ SHOW 'IMPROVED EVWRIT AND EVREAD. ZSSPEC0 SCRATCHED  C.B.   21.02.84'
./ SHOW '2000 K REGION SIZE STANDARD NOW FOR TSO -----                 '
./ SHOW 'NEW GRAPHICS LINKING JOB CALLED #GRAPHIX                      '
./ SHOW 'INSTALLED WHICH DOES NOT HAVE OVERLAYS.        C.B.   21.02.84'
./ SHOW 'SMALL BUT FAIRLY SERIOUS BUG IN MCHTRB KILLED  C.B.   22.02.84'
./ SHOW ' BUG IN RDTRG1 CORRECTED                       J.O.   27.02.84'
./ SHOW ' GVTXFT UPDATED (FOR VIEWS VRX..)              J.O.   28.02.84'
./ SHOW 'UPDATE OF PRINT IN RDSTAT,GPHMAIN,NOTICE       J.O.   02.03.84'
./ SHOW 'CORRECT UNINIT.ARRAY NHTRNG IN REFITV          J.O.   02.03.84'
./ SHOW 'CORRECT UNINIT PARAMETER IQZVTX IN FITEVR      J.O.   03.03.84'
./ SHOW '  NOTE: THIS ERROR MAY AFFECT PHYSICS RESULTS !!'
./ SHOW '                    NO, IT DOESN T !!'
./ SHOW 'CORRECT UNINIT.ARRAY NHTRNG IN REFIT           J.O.   03.03.84'
./ SHOW 'PROTECT JRECAL AGAINST MONTE CARLO EVENTS J.O.,C.B.   07.03.84'
./ SHOW 'PROTECT JOYS AGAINST ZERO AREA BOX ERROR       C.B.   09.03.84'
./ SHOW 'SEVERAL IMPROVEMENTS TO JOYS. NOTICE CHANGED.  C.B.   11.03.84'
./ SHOW 'JOYS PROTECTED AGAINST -VE MAGNIFICATION.      C.B.   12.03.84'
./ SHOW 'PROMPT IMPROVED.                               C.B.   12.03.84'
./ SHOW 'ERROR IN ZSFIT CORRECTED.                 L.B.,C.B.   13.03.84'
./ SHOW 'CDTL 12/13/20/21/31/32: MEANING AND DEFAULTS REVERSED'
./ SHOW 'BECAUSE CDST COMMENTS DISAGREE WITH VALUES'
./ SHOW 'CHANGED ROUTINES: TRNUMB,CREDIT,EVDISP,RSDISP  '
./ SHOW '                  GPHMAIN,JADEBD,GPHMAINX      '
./ SHOW 'RSDISP FOUND TO HAVE 2 DIR ENTRIES. REPORTED   '
./ SHOW 'THIS TO BUTENSHOEN.  CIRDIS TOO.               C.B.   13.03.84'
./ SHOW 'MAJOR OVERHAUL OF GPHMAIN. LINKDS,GETDS AND DSERR ADDED'
./ SHOW 'CIRDIS CHANGED TO CHANGE POSITION OF TRACK NO. C.B.   13.03.84'
./ SHOW 'CIRDIS & RSDISP CORRUPTION CURED BY BUTENSHOEN C.B.   14.03.84'
./ SHOW 'CIRDIS GOT FROM BACK-UP. 13.03.84 CHANGES LOST C.B.   15.03.84'
./ SHOW 'NOTICE,MENU AND NEWS UPDATED ==> MUPT CHANGES  C.B.   15.03.84'
./ SHOW 'MENU CORRECTED                                 C.B.   16.03.84'
./ SHOW 'N50SDS AND N50SCO ADDED TO DRAW N50 RESULTS.                  '
./ SHOW 'FAMPDS AND FAMPCO ADDED/CHANGED.                              '
./ SHOW 'SCANNR,KOMMAN,DISPLY,NEWS,NOTICE,MENU UPDATED.                '
./ SHOW 'TOFVW HAS BEEN IMPROVED. NOT FINISHED COMPLETELY.             '
./ SHOW 'BUG IN EVDISP (NOT CALLING FWCHEV) CORRECTED.                 '
./ SHOW 'DEDXVW IMPROVED. BETTER MESSAGE IF NO TRACKS.                 '
./ SHOW 'FWCHEV,BLNUMB & TAGCHK UPGRADED.               C.B.   21.03.84'
./ SHOW 'TRKHIT IMPROVED BY K.-H. HELLENBRAND                  21.03.84'
./ SHOW 'NOTICE UPDATED AGAIN. JADEOVLY UPDATED FOR N50 C.B.   21.03.84'
./ SHOW 'SMALL BUG IN EVDISP CORRECTED.                 C.B.   23.03.84'
./ SHOW 'JADISP SPLIT INTO SEPARATE ROUTINES. JADEOVLY UPDATED.        '
./ SHOW 'BARREL REPLACED BY BARSEC WHICH DRAWS AN ARC                  '
./ SHOW 'WITH OPTIONS FOR THE START AND END.            C.B.   10.04.84'
./ SHOW 'RZDET ADDED TO DRAW Z CHAMBER IN ROLLED OUT VIEW              '
./ SHOW 'CODE REMOVED FROM JADISP. JADEOVLY UPDATED  S.C. C.B. 12.04.84'
./ SHOW 'SPINNR UPDATED FOR SPRING 1984                   J.O. 29.04.84'
./ SHOW 'TAGCHK CHANGED TO REMOVE BUG                     C.B. 14.05.84'
./ SHOW 'ADD NEW RUNS WITH VERTICES FROM J.SPITZER        W.B. 17.05.84'
./ SHOW 'RDALGN LOCAL VAR NWORD CHANGED TO NWRD      J.O. C.B. 16.06.84'
./ SHOW 'NEW DEDXBN                                       L.B. 23.08.84'
./ SHOW 'BUG IN DEDXVW CORRECTED                          J.O. 23.08.84'
./ SHOW 'BUG IN EVREAD,IF REAL DATA FOLLOWS MC, KILLED    C.B. 17.09.84'
./ SHOW 'PRSTAT SEPARATED FROM RDTRIG. NOW IN OWN MEMBER  C.B. 17.09.84'
./ SHOW 'DSERR CHANGED TO RECOGNISE ERROR 584 FROM GETPDD C.B. 20.09.84'
./ SHOW 'UPDATE KALIBR,EBEAM FOR RUN 16342                J.O. 27.09.84'
./ SHOW 'NEW KLREAD RUNVTX FROM RUN 16803 ON              W.B. 08.10.84'
./ SHOW 'DEDXB1 (OLD) MOVED TO F11BEK.DEDX.S              L.B. 17.10.84'
./ SHOW 'FAMPDS AND BANKPR UPDATED                        J.O. 28.10.84'
./ SHOW 'JADEBD,RDMTCO,RDRESO UPDATED                C.B. J.H.  1.11.84'
./ SHOW 'RDDOUV,RDIEFV,RDMODV,RDMRGV,RDPOIV,RDRESV,                    '
./ SHOW 'RDRNHV   ROUTINES ADDED FOR VERTEX CHAMBER  C.B. J.H.  1.11.84'
./ SHOW 'MANY GRAPHICS ROUTINES SCRATCHED HERE       C.B. J.H.  1.11.84'
./ SHOW 'SAFCHK WAS FOUND REMOVED, REINSTALLED 18.30 1.11.84'
./ SHOW 'MCGJET TOO.                       C.B., J.O.           1.11.84'
./ SHOW 'VERTEX CHAMBER CHANGES TO KLREAD. C.B., J.H.           1.11.84'
./ SHOW 'EVWRIT,RDMTCO UPDATED             C.B., J.H.           9.11.84'
./ SHOW 'UPDATE EBEAM WARNING PRINT                       J.O. 14.11.84'
./ SHOW 'EXTENDED VERSION OF FITEVR ADDED                 C.B. 10.12.84'
./ SHOW 'ZSFIT CHANGED                                    L.B. 13.12.84'
./ SHOW 'BLSHOW CORRECTED, TO CARE FOR ERROR IN LGDEAD    J.O. 16.12.84'
C   22/03/97 703221757  MEMBER NAME  #START5  (JADEGS)      FORTRAN
FREE F(MACRO,CLIST)
ALLOC F(MACRO) DA('F11GOD.PATRECSR') SHR
ALLOC F(CLIST) DA('F22BOW.JADE.CLISTS','F11PEA.JDCLIST') SHR
CLEAR
./ SHOW 'OLD MESSAGES NOW IN MEMBERS #START0,#START1,#START2,#START3'
./ SHOW 'AND #START4                             C.BOWDERY  28/06/86'
./ SHOW '***********************************************************'
./ SHOW 'NEW DEDXBN                                       L.B. 06.02.85'
./ SHOW 'TOFBK: CALL TO BSAT REPLACED WITH BSAW           J.O. 01.03.85'
./ SHOW 'UPDATE OF DECHIF    (J.A.SKARD)                  J.O. 04.03.85'
./ SHOW 'CORRECTED QPLOTS   KOMAMIYA/OLSSON                    02.04.85'
./ SHOW 'NEW VERSION OF SUPERV - CALL KALIBR AND INPATC FOR            '
./ SHOW 'EVERY EVENT NOW                                C.B.   15.04.85'
./ SHOW 'TBGDIS UPDATED FOR TRIG 1, BANKDESCR.4         J.O.   15.04.85'
./ SHOW 'KLREAD CHANGED FOR VERTEX CHAMBER DRVELO       C.B.   24.04.85'
./ SHOW 'NEW VERSION OF KALIBR + NEW RUNFIX ADDED       C.B.   29.04.85'
./ SHOW 'FITTYP ADDED (WAS TPFITF ON TP LIBRARY)        C.B.   28.06.85'
./ SHOW 'MANY GRAPHICS ROUTINES SCRATCHED --> GRAFIX.S  C.B.    8.07.85'
./ SHOW 'EFMASS MOVED TO GRAFIX.S AND SCRATCHED HERE    C.B.   17.07.85'
./ SHOW 'SUPERV RENAMED TO SUPERV0.                     C.B.   17.07.85'
./ SHOW 'NEW SUPERV HAS SMALL CHANGE FOR GRAPHICS (L11) C.B.   17.07.85'
./ SHOW 'UPDATE OF SPINNR                               J.O.   31.07.85'
./ SHOW 'DELETE TAGCHK, IT NOW SITS UPDATED ON TAGG.S   J.O.   16.08.85'
./ SHOW 'FITTYP WAS GIVING EXACT OPPOSITE ANSWERS       C.B.   19.08.85'
./ SHOW 'MOMENT PROTECTED AGAINST ATAN2 ERROR           J.O.    7.09.85'
./ SHOW 'ZSFIT CORRECTED                                L.B.   11.09.85'
./ SHOW 'DEBUG PRINT IN REFIT,REFITV REMOVED            J.O.   16.09.85'
./ SHOW 'RUNFIX UPDATED FOR BAD BEAM IN R22357          J.O.   16.10.85'
./ SHOW 'KLREAD: PRINT(T0) MOVED TO END OF KLREAD       P.S.   14.11.85'
./ SHOW '2 NEW FUNCTIONS ADDED: RBPIPE, XBPIPE          C.B.   18.12.85'
./ SHOW 'KLREAD: T0,VD,LORENTZ ANG. FOR RUNS 16800...   P.S.   19.12.85'
./ SHOW 'RUNFIX:  PRINT EXTENDED ...                    J.O.   14. 1.86'
./ SHOW 'NEW DEDXBN                                     L.B.   23.01.86'
./ SHOW 'FITEVR + FITEVF CORRECTED                      P.S.   23.01.86'
./ SHOW 'JETCAL ,JRECAL : NEW VERSIONS FOR FADC-READOUT'
./ SHOW 'JETCAL0,JRECAL0: OLD VERSIONS                  P.S.   05.02.86'
./ SHOW 'RUNFIX WARNING FORMAT MODIFIED FOR GRAPHICS    J.O.   09.02.86'
./ SHOW 'EBEAM UPDATED FOR RUN 22357                    J.O.   10.02.86'
./ SHOW 'RUNFIX9 WITH 29.2.86 BUG CORRECTED             J.O.   04.03.86'
./ SHOW 'DL300 SWITCH IN ZRECAL                         L.B.   10.03.86'
./ SHOW 'MC RETURN FOR ZSFIT AND DEDXBN                 L.B.   24.03.86'
./ SHOW 'KLREAD CHANGED (SPITZER)                 W.B./ L.B.   02.06.86'
./ SHOW 'UPDATE OF XBPIPE,RBPIPE,RDMTCO, ACC. TO J.HAGEMANN    09.06.86'
./ SHOW 'UPDATE OF RADIATION LENGTH IN XBPIPE              .   09.06.86'
./ SHOW 'THE OLD VERSIONS ARE RDMTCO0, RBPIPE0,XBPIPE0  J.O.   09.06.86'
./ SHOW 'RDMTCO INSTALLED YESTERDAY HAD BY MISTAKE WRONG SMEARING      '
./ SHOW 'THE CORRECT ONE INSTALLED 11.50                J.O.   10.06.86'
./ SHOW 'JADEBD UPDATE: VTXCH CONSTANTS AND /TODAY/     J.O.   10.06.86'
./ SHOW 'GETINT ADDED FROM F22HAG.GRAPHV.S              C.B.   10.06.86'
./ SHOW 'UPDATE OF RADIATION LENGTH IN XBPIPE           J.O.   11.06.86'
./ SHOW 'UPDATE OF RDMTCO (VTXC BANK NUMBER)      J.H./ J.O.   16.06.86'
./ SHOW 'UPDATE OF RUNFIX AND EBEAM                     J.O.   21.06.86'
./ SHOW 'UPDATE OF RUNFIX AND EBEAM    (R 26435)        J.O.   10.07.86'
./ SHOW 'UPDATE OF SPINNR FOR END 1985,BEG 1986 DATA    J.O.   11.07.86'
./ SHOW 'UPDATE OF JADEBD (VERTEX CH RAD LENGTH)    J.H./J.O.  17.07.86'
./ SHOW 'UPDATE OF RUNFIX  (R 4841)                      J.O.  29.07.86'
./ SHOW 'CORRECT BUG IN FRFITV  (OR WITH 32..)           J.O.  11.08.86'
./ SHOW 'UPDATE OF RUNFIX  (R 4544,5662)                 J.O.  13.08.86'
./ SHOW 'UPDATE OF RUNFIX  (R13106-13145)                J.O.  25.08.86'
./ SHOW 'NEW USER COMMON IN DEDXBN                       L.B.  27.08.86'
./ SHOW 'UPDATE OF RUNFIX  (R11396) MAG FIELD            J.O.  27.08.86'
./ SHOW 'CL2PRC: DL300 FADC SERVICE ROUTINE INSTALLED    J.O.  27.08.86'
./ SHOW 'DEDXBN: MINOR MODIFICATIONS IN PRINT      J.A.S./J.O. 28.08.86'
./ SHOW 'INSTALLED SUBR. PRAGAI, UPDATE OF RDMTCO,PRSTAT,'
./ SHOW 'RDALGN,RDDATE,RDMTCO,RDTRG1,RDTRG2,RDTRIG. CHANGES ONLY IN'
./ SHOW 'SOURCE, UNTIL CHANGEOVER SHALL TAKE PLACE, SOON. ALL THESE'
./ SHOW 'CHANGES ARE DESCRIBED IN SUPPL.2, JCN 66        J.O.  28.08.86'
./ SHOW 'UPDATE OF RUNFIX  (R24354) JUNK WARNING         J.O.  28.08.86'
./ SHOW 'THE ABOVE RD-ROUTINES COMPILED TO LOAD. OLD VERSIONS AVAILABLE'
./ SHOW 'AS -0 VERSIONS                                  J.O.  29.08.86'
./ SHOW 'ERROR IN PRSTAT KORREKTED, GAVE WRONG PRINTOUT  J.O.  29.08.86'
./ SHOW 'UPDATE OF RUNFIX AND EBEAM, R25688 COSMIC WARN. J.O.  02.09.86'
./ SHOW 'INSTAL KTMCON9 FOR MORE PRINT IN KTMCON ERRORS. J.O.  02.09.86'
./ SHOW 'UPDATE RUNFIX R28382  EBEAM                     J.O.  03.09.86'
./ SHOW 'UPDATE KTMCON ACC. TO KTMCON9                   J.O.  03.09.86'
./ SHOW 'ERROR PRINT IN JETCAL, IF DIVIDE WITH 0         J.O.  08.09.86'
./ SHOW 'MORE PRINT IN JETCAL FOR DEBUG PURPOSE          J.O.  10.09.86'
./ SHOW 'INSTAL MEMBER WERTEX: MODIFIED ROUTINES AND FUNCTIONS FOR     '
./ SHOW 'THE VERTEX FINDING PROGRAM VERTEX. CONTAINED SUBROUTINES ARE: '
./ SHOW ' VERTEX,VTXINI,VTXPRE,VTXSRC,VTXEE,VTXAFT,VTXEER,VTXERR,      '
./ SHOW ' VTXBNK,VTXPNT,VTXCRV.   FUNCTIONS:  PARKOR,XFWID,XFWVXC.     '
./ SHOW 'INSTALLED ALSO FUNCTION DRPIPE: BEAMPIPE THICKNESS.           '
./ SHOW '                                                J.O.  02.10.86'
./ SHOW 'PRINT LIMIT IN RDDATE INSTALLED                 J.O.  29.10.86'
./ SHOW 'TYPE ERROR IN PRAGAI CORRECTED                  J.O.  07.11.86'
./ SHOW 'RUNFIX UPDATE FOR RUN 6185                      J.O.  10.11.86'
./ SHOW 'JETCAL CORRECTED FOR LONGSTANDING BUG       E.E,J.O.  26.11.86'
./ SHOW 'KLREAD UPDATED FOR 1986                     E.E,J.O.  26.11.86'
./ SHOW 'CL2PRC UPDATED                              E.E,J.O.  26.11.86'
$   21/12/87 903021645  MEMBER NAME  #START   (JADEGS)      NEWLIB
FREE F(MACRO,CLIST)
ALLOC F(MACRO) DA('F11GOD.PATRECSR') SHR
ALLOC F(CLIST) DA('F22BOW.JADE.CLISTS','F11PEA.JDCLIST') SHR
CLEAR
./ SHOW 'OLD MESSAGES NOW IN MEMBERS #START0,#START1,#START2,#START3'
./ SHOW '#START4 AND #START5                 J.OLSSON  28/05/87'
./ SHOW '***********************************************************'
./ SHOW 'RUNFIX UPDATED, RUN 29828                       J.O.  30.01.87'
./ SHOW 'RUNFIX UPDATED, COSMIC RUNS AT END OF 1986      J.O.  11.02.87'
./ SHOW 'UPDATE KALIBR AND JFETCH, JFETCH0 BACKUP                      '
./ SHOW 'INSTAL CNEWID,JFTNEW,                       J.O.,J.S. 13.03.87'
./ SHOW 'INSTAL DISTXY,SAGCIR,SHELL9,SQTVAL,XYRFTV,XYRFT1              '
./ SHOW '  ALL MEMBERS USED IN SPITZERS NEW FITTING  J.O.,J.S.,13.03.87'
./ SHOW 'INSTAL KOMAKS: KOMAMIYAS V0 FINDER          P.H.,J.O.,13.03.87'
./ SHOW 'UPDATE KOMAKS: PREVIOUS WAS WRONG VERSION!  P.H.,J.O.,15.03.87'
./ SHOW 'UPDATE JFETCH,JFTNEW,                       J.O.,J.S. 18.03.87'
./ SHOW 'UPDATE        JFTNEW                        J.O.,J.S. 19.03.87'
./ SHOW 'CHANGE JFETCH (CORRECT EVAL. OF CIRCLE PARAM.)   P.S. 25.03.87'
./ SHOW 'CHANGE XYRFT1                     J.O.,J.S. 25.03.87, 27.03.87'
./ SHOW 'CHANGE XYRFT1                     J.O.,J.S. 01.04.87'
./ SHOW 'UPDATE JFTNEW                     J.O.,J.S. 04.04.87'
./ SHOW 'UPDATE XYRFTV,XYRFT1 (NEW ARG.LIST)         J.O.,J.S.10.4.87'
./ SHOW 'INSTAL EXPATR                     J.O.,J.S. 10.04.87'
./ SHOW 'CHANGE XYRFT1,                           J.O.,J.S  12.04.87'
./ SHOW 'CNEWID WITH NEW.CAL. DEFAULT J.O.,J.S   12.04.87'
./ SHOW 'MOMENT CHANGE ARCOS TO ACOS  W.BA.   28.4.87'
./ SHOW 'MOMENT CHANGE PZ FOR HELIX TYPE FIT  J.O.,J.S.  29.4.87'
./ SHOW 'JADEBD AND DEDXBN UPDATED, COMMON /CDEDXU/   J.O.  04.5.87'
./ SHOW 'UPDATE MOMENP, ACC. TO RECENT CHANGES IN MOMENT    J.O.04.5.87'
./ SHOW 'AMBRUS NEW DEDX PROGRAM INSTALLED, UNDER NAME OF DEDXCN '
./ SHOW '       IT IS AN UPDATE OF DEDXBN. THE MEMBER DEDXCN CONTAINS'
./ SHOW '       SEVERAL NEW SUBROUT. AND FUNCTIONS, AS WELL AS CHANGED '
./ SHOW '       VERSIONS OF CHIFT1, DECHIF, DETHRY, ERRMOM. AFTER TEST'
./ SHOW '       THE PRESENT DEDXBN WILL BE REPLACED BY THE NEW DEDXCN'
./ SHOW '                                           J.O.     04.5.87'
./ SHOW 'UPDATE DEDXBN WITH NEW SMOLIK DATA         W.B.     04.5.87'
./ SHOW ' UPDATE JFETCH,JFTNEW, INSTAL AMPS2Z,ZSRFTV,ZSRFT1'
./ SHOW ' INSTAL  NEW VERSIONS OF ZSFIT,ZSLINE,ZSPUR UNDER THE NAMES'
./ SHOW ' ZSFIT9,ZSLINE9,ZSPUR9 FOR TESTS (WITH DEDXBN)'
./ SHOW '                                           J.O.,J.S. 07.5.87'
./ SHOW ' ZSFIT9,ZSLINE9,ZSPUR9 RENAMED TO STANDARD VERSIONS. THE OLD'
./ SHOW ' VERSIONS ARE NOW ZSFIT0,ZSLINE0,ZSPUR0         J.O. 14.5.87'
./ SHOW ' INTEGER*2 HDATA INTRODUCED IN SEVERAL ROUTINES:'
./ SHOW '  ERRMOM, KOMAKS, PREVTX, RDPATR, WERTEX    J.O. E.E. 21.5.87'
./ SHOW ' UPDATE OF RDALGN, READOUT THRESHOLD 1986        J.O. 25.5.87'
./ SHOW 'DEDXBN UPDATED AGAIN, COMMON /CDEDXU/,LOST BY LAST CHANGE BY'
./ SHOW 'W.B. ON 4.5.87 (SAME DAY !)                      J.O.  28.5.87'
./ SHOW 'UPDATE OF JADEBD WITH 2 COMMONS FROM JFTNEW,ZSRFTV. AT THE'
./ SHOW 'SAME TIME, UPDATE OF JFTNEW AND ZSRFTV     J.O.,J.S.  01.06.87'
./ SHOW 'GENERAL UPDATE OF DEDXCN                  J.O.,K.A.  04.06.87'
./ SHOW 'UPDATE OF XYRFT1 TO DOUBLE PRECISION      J.O.,J.S.  05.06.87'
./ SHOW 'CORRECTED SMALL BUG IN RDTRG1 (KREHBIEL TR.)   J.0.  08.06.87'
./ SHOW 'UPDATE OF JADEBD, ZSRFTV COMMONS               J.0.  10.06.87'
./ SHOW 'UPDATE OF ZSFIT (OLD VERSION ZSFIT0), NEW ROUTINE ZSPDBK     '
./ SHOW 'UPDATE OF JADEBD, CZSPRM COMMON, AND AMPS2Z E.E J.0.  16.06.87'
./ SHOW 'UPDATE OF ZSRFTV                             J.S. J.O. 17.6.87'
./ SHOW 'CORRECTION OF MISPRINT IN XYRFT1             J.S. J.O. 18.6.87'
./ SHOW ' UPDATE OF ZRECAL,AMPS2Z,DEDXBN,DEDXCN, ACC. TO JCN 96      '
./ SHOW ' DELETE ANCIENT VERSION DEDXDN                              '
./ SHOW ' OLD VERSIONS KEPT: ZRECAL0,DEDXBN0,AMPS2Z0  E.E.,J.O. 20.6.87'
./ SHOW ' UPDATED MEMBER DEDXCN WHICH HAS NEW DEDXBN  E.E.,CKB. 20.7.87'
./ SHOW ' MEMBERS PARCIR AND ADJCIR HERE FROM TPSOURCE     CKB. 22.7.87'
./ SHOW ' JADEBD NOW INCLUDES Z CHAMBER BLOCK DATA         CKB. 24.7.87'
./ SHOW ' RDTRIG UPDATED WITH 1986 Z-RESOLUTION FOR JETC   JO. 26.7.87'
./ SHOW ' Z CHAMBER ROUTINES ADDED FROM F11SPI.ZS                     '
./ SHOW ' JADEBD BLOCK DATA CHANGED. ONE NEW VARIABLE ADDED.          '
./ SHOW ' ALSO JFETCH AND JFTNEW REPLACED             J.S. CKB 29.7.87'
./ SHOW ' UPDATE XYRFTV,ZSRFTV,ZSRFT1 WITH PRINT AND BIT SETTINGS'
./ SHOW '                                            J.S. J.O.  4.8.87'
./ SHOW ' UPDATE ZCFTNW AND JADEBD WITH PRINT ETC.  J.S. J.O. 12.8.87'
./ SHOW ' MEMBER TRCROS COPIED FROM (TPSOURCE) TPTCRS    CKB  26.8.87'
./ SHOW ' BACKUP OF DEDXBN = DEDXBN0                                   '
./ SHOW ' UPDATE DEDXBN TO STATUS OF DEDXCN, NEW VERSION BY K.AMBRUS   '
./ SHOW ' MEMBER DEDXCN KEPT FOR A WHILE, TO ALLOW USE OF INCLUDE STILL'
./ SHOW '                                        J.O.   1.9.1987       '
./ SHOW ' UPDATE OF DEDXBN FOR MC SIMULATION OF DEDX INFO. NEW INSTAL- '
./ SHOW ' MENT OF SUBR. IZT2RN,DXMCSP,DXMCSS. UPDATE OF ZSFIT          '
./ SHOW ' OLD VERSIONS DEDXBN00 AND ZSFIT0    E.E., J.O   16.11.1987 '
./ SHOW ' REMOVED DIRECT SETTING OF MOMENTUM AND HIT LIMITS IN DEDXBN, '
./ SHOW ' SINCE THEY ARE SET IN JADEBD AND CAN BE REMOTELY CHANGED. '
./ SHOW ' UPDATED JADEBD ON A MISTAKE IN TAGGING DETECTOR DIMENSIONS.  '
./ SHOW '                                          J.O.  17.11.87     '
./ SHOW ' FURTHER CHANGES IN DEDX FOR MC: UPDATE OF DEDXBN,ZSPDBK     '
./ SHOW '  OLD VERSION IS ZSPDBK0             E.E.,J.O.  20.11.87     '
./ SHOW ' CORRECTION OF RARE DIVIDE CHECK IN DEDXBN  '
./ SHOW '                                     E.E.,J.O.  26.11.87     '
./ SHOW ' CORRECTION OF SMALL, UNIMPORTANT BUG IN DEDXBN,DEDXBK'
./ SHOW '                                     E.E.,J.O.  30.11.87     '
./ SHOW ' GENERAL UPDATE AFTER SOFTWARE MEETING, CHANGED ROUTINES:     '
./ SHOW ' EVWRIT,PRPATR,PRAGAI,RDMTCO,RDRESO,RDRESV,RDTRIG.  BACKUPS:  '
./ SHOW ' EVWRIT0,PRPATR0,PRAGAI0,RDMTCO0,RDRESO0,RDRESV0,RDTRIG0  '
./ SHOW '                                     E.E.,J.O.  14.12.87     '
./ SHOW ' RDDATE CHANGED ACCORDING TO NEW SMEARING DATE SCHEME.       '
./ SHOW ' OLD COPY IS RDDATE0.                C.B.       17/12/87     '
./ SHOW ' RDTRIG BLOCKDATA FOR /CBINV/ CORRECTED  J.O., J.H. 18.12.87 '
./ SHOW ' EVREAD UPDATED WITH INFO PRINT FOR MC-EVENTS  '
./ SHOW ' OLD EVREAD IS NOW EVREAD0                 J.O. 20.12.1987 '
./ SHOW ' #START now has line zero, language NEWLIB and ASIS=MIX    '
./ SHOW ' RDDATE updated. Old version is RDDATE00   E.E., C.B. 21/12/87'
./ SHOW ' RDiefv and nvert updated        c.k. j.h.  j.o. 22/12/87'
./ SHOW ' UPDATE OF XYRFTV AND XYRFT1       J.S.  J.O.    11.01/88'
./ SHOW ' UPDATE OF XYRFT1, ZSRFT1,ZSRFTV   J.S.  J.O.    12.01/88'
./ SHOW ' UPDATE OF KLREAD FOR VTX CONSTS                         '
./ SHOW '        OLD VERSION IN KLREAD2     E E.          15.01/88'
./ SHOW ' LIBRARY RATIONALISATION:                               '
./ SHOW ' MEMBERS NUMFUN AND LOCFLD MOVED HERE FROM GRAFIX.S     '
./ SHOW ' MEMBERS IDFELD, STRNUM AND CMPDCT MOVED HERE FROM TP9.S'
./ SHOW '                                   C.B.           18/01/88'
./ SHOW ' CORRECT BUG IN XYRFT1             E E         19/01/88 '
./ SHOW ' CORRECT BUG IN DEDXBK             E E         21/01/88 '
./ SHOW ' MINOR CHANGES TO FORMAT STATEMENTS IN KLREAD AND CNEWID'
./ SHOW ' PLUS MCREDU MOVED HERE FROM JMC.S       C.B.  29/01/88 '
./ SHOW ' UPDATE OF ZSRFT1, (Z-CHAMBER FLAG)     J.S,J.O. 15/02/88 '
./ SHOW ' UPDATE OF JFETCH,JFTNEW WITH VTXC ADDITIONS '
./ SHOW ' OLD VERSIONS KEPT AS JFETCH0 AND JFTNEW0, J.O., J.S. 18/02/88'
./ SHOW ' CHANGE MVC TO MVCL IN ROUTINES THAT COPY MORE THAN 256 BYTES '
./ SHOW ' INVOLVED ROUTINES ZSRFTV, ZSRFT1, XYRFT1  J.H. J.O. 22/2/88  '
./ SHOW ' LDATYP TO DISTINGUISH DL8 AND DL300 DATA                     '
./ SHOW ' INTRODUCE INTO    ZSRFTV, ZSRFT1, XYRFT1                     '
./ SHOW ' UPDATE AMPS2Z FOR 2 TRACK LIMIT IN MC     E.E.      18/3/88  '
./ SHOW ' ZSFIT NEW HIT COUNTING (ALSO OK FOR MC NOW)  E.E.   18/3/88  '
./ SHOW ' UPDATED VERSIONS OF RDTRIG,RDRESO,RDMTCO,PRSTAT,PRAGAI '
./ SHOW ' INSTALLED AS 9-VERSIONS, FOR TEST BEFORE MAKING STANDARD.'
./ SHOW ' THEY INTRODUCE NON-GAUSSIAN TAILS IN Z-SMEARING  J.O. 25.3.88'
./ SHOW ' UPDATE ZSRFTV FOR MINOR BUG        '
./ SHOW '   OLD VERSION KEPT AS ZSRFTV0         J.O. J.S.  25.3.88'
./ SHOW ' SUPERV CHANGED TO GIVE MORE LOW PRIORITY BANK SPACE          '
./ SHOW ' AND TOTAL SPACE ALSO INCREASED BY 5000 (CBCSMX)  CKB  28.3.88'
./ SHOW ' UPDATE EBEAM AND RDATA                          J.O.  30.3.88'
./ SHOW ' NEW VERSIONS FOR EVWRIT,RDTRIG,RDRESO,RDMTCO,PRSTAT,PRAGAI'
./ SHOW ' INTRODUCING DOUBLE GAUSS SMEARING IN Z           EE   31.3.88'
./ SHOW ' DEDXBN,DXMCSS UPDATE FOR HIT CLEANING IN MC      EE   31.3.88'
./ SHOW ' OLD VERSIONS AVAILABLE AS 0-VERSIONS             EE   31.3.88'
./ SHOW '                                                        '
./ SHOW ' CORRECT VDFACT BUG IN DEDXBN                     EE   05.4.88'
./ SHOW ' RDTRIG: VTXC CHAMBER INEFF 0.995 -> .871    JH,  EE   05.4.88'
./ SHOW ' ZCHCAL: PEDESTAL SETTING FOR RUN<20000           EE   06.4.88'
./ SHOW ' RDRESO: NO NEG AMPLITUDES                   JH,  EE   28.4.88'
./ SHOW ' ZSRFTV,ZSRFT1:  SEVERE BUGS CORRECTED, AFFECTING LOW-MOMENTUM'
./ SHOW '                 TRACKS, CONVERSIONS, V-PARTICLES, ETC.    '
./ SHOW ' OLD VERSIONS: ZSRFTV2,ZSRFT12    J.H., G.E., J.O.  13.5.1988'
./ SHOW ' AFTER TEST OF ABOVE CORRECTIONS, A NEW CORRECTION WAS MADE '
./ SHOW ' TO ZSRFT1 (TEST OF ARGUMENT OF ARSIN)!    G.E.  J.O. 14.5.88'
./ SHOW ' AND TO ZSRFTV (ARSIN)                     E.E.       16.5.88'
./ SHOW ' EXTEND COMMON ZCTRK IN ZCDATA, ZCFTNW AND ZCASS AND ADD     '
./ SHOW ' CODE TO AVOID DIVIDE CHECK FOR Z-SLOPE=0 E.E.       20.5.88'
./ SHOW ' JADEBD AMPS2Z WEIGHT TUNED               E.E., J.H. 20.5.88'
./ SHOW ' ZSRFT1 SMOOTH CUTOFF PROCEDURE           E.E., J.H. 24.5.88'
./ SHOW ' DEDXBN CORRECT FOR COS(THETA) DEPENDENCE       E.E. 10.6.88'
./ SHOW ' ZSRFTV EXTRA COMMENT IN SUBR. DESCRIPTION      E.E. 27.6.88'
./ SHOW ' ZCFTNW CORRECT IMI TYPING ERROR                E.E. 27.6.88'
./ SHOW ' BOS COMMON SIZE INCREASED TO 60000 (MACRO CBCSMX ON PATRECSR,'
./ SHOW ' SUPERV BINT CALL WITH BINT(LDATA,LDATA,...) '
./ SHOW ' JADEBD UPDATED WITH CONTENT OF BDVTXC ON F22KLE.JVTXC.GS   '
./ SHOW '                                     J.H.,G.E.,J.O.  29.6.88'
./ SHOW ' MEMBER WERTEX RESTRUCTURED. SEE LONG COMMENT IN MEMBER ITSELF'
./ SHOW '                                               J.O.  03.7.88'
./ SHOW ' UPDATED PRAGAI, MORE PRINT, BETTER FORMAT      J.O. 23.7.88'
./ SHOW ' CORRECT TYPO IN ZCASS                          E.E. 25.7.88'
./ SHOW ' LEAP YEAR PROBLEM IN IDATTM CORRECT.      C.B. J.P. 25.7.88'
./ SHOW ' IMPROVED VERSIONS OF NUMFUN, EVBKPR       C.B. J.H. 25.7.88'
./ SHOW ' SPHRCY, AKOP, THRUNB FROM JVTXC.S         C.B. J.H. 25.7.88'
./ SHOW ' THRUST  FROM TPSOURCE FOR COMPLETENESS    C.B. J.H. 25.7.88'
./ SHOW ' UPDATE OF RDMTCO (SMEARING BUG), PRAGAI        J.O. 25.7.88'
./ SHOW '      THE PRAGAI CHANGE STEERS EVWRIT CONSTANT WRITING   '
./ SHOW ' INSTAL MUCON WITHOUT UNNECESSARY PRINTING      J.O. 25.7.88'
./ SHOW '    (NOTE: OLD VERSION OF MUCON ON JADEMUS/L NOT CHANGED  '
./ SHOW ' SCRATCH MUCON AGAIN, CHANGE WILL BE MADE ON JADEMUS/L  '
./ SHOW '                                           C.B.,J.O. 26.7.88'
./ SHOW ' STRNUM CHANGED TO ENSURE "/" IS ILLEGAL        C.B. 26.7.88'
./ SHOW ' XYRFTV SETS EXTRA BITS FOR STRONG/WEAK CONSTR  E E. 27.7.88'
./ SHOW ' THE CHANGE IN PRAGAI DOESNOT WORK:'
./ SHOW '    DATA SETS WITHOUT CONSTANTS BANKS ARE SOMETIMES WRITTEN'
./ SHOW '    THEY CAN NOT BE READ BY EVREAD     OLD PRAGAI0 NOW RENAMED'
./ SHOW '    TO PRAGAI, THE NEW VERSION IS NOW PRAGAI9 UNTIL FURTHER'
./ SHOW '                                        J.O.  1.8.88, 11:15'
./ SHOW 'PRAGAI9 DELETED, EVWRIT9 RDMTCO9 INSTALLED. NFLAGS(9) NOW USED'
./ SHOW 'BY RDMTCO9-EVWRIT9, SOLVES PRAGAI PROBLEM. WHEN MORE TESTS'
./ SHOW 'HAVE BEEN MADE, 9-VERSIONS SHOULD BE STANDARD    J.O.  11.8.88'
./ SHOW ' XYRFT1   COVARIANCE MATRIX CORRECTED       C.K., E.E.  2.9.88'
./ SHOW ' RDMTCO9: PRINT STATEMENT REMOVED                 J.O. 10.9.88'
./ SHOW ' ZCFTNW INHIBIT EXCESSIVE P/O FOR EVENT NR<0      E E. 20.9.88'
./ SHOW ' PROTECT AGAINST DIVISION BY ZERO IN SPHRCY       C.B. 4.10.88'
./ SHOW ' CORRECT TAGGING BUG IN RDTRG1 (RD82T1)     A.W. J.O. 28.11.88'
./ SHOW ' OLD VERSION RDTRG10    '
./ SHOW ' CORRECT WRONG PRINT IN IZT2RN  (IZT2RN)         J.O. 19.12.88'
./ SHOW ' IDFELD AND CMPDCT DELETED AND PUT ON TP9.S      C.B.  9.1.89'
./ SHOW ' IZT2RN WRITE COMMENTED OUT FOR TESTS *TEMP*     C.B. 10.1.89'
./ SHOW ' IZT2RN WRITE PUT IN DOWHILE OUT                 E.E. 11.1.89'
./ SHOW ' ZSPDBK & REPLACED BY * FOR STANDARD FORTRAN 77  C.B. 10.1.89'
./ SHOW ' DXMCSP REMOVE DO .. WHILE'S                     E.E. 13.1.89'
./ SHOW ' DEDXBN REPLACE LAND/SHFTL BY IAND/ISHFT         C.B. 16.1.89'
./ SHOW ' JADEBD UPDATE OF TAGGING DIMENSIONS             J.O. 02.3.89'
./ SHOW '                                                        '
./ SHOW '                                                        '
./ SHOW ' ----> DELETE THIS LINE WHEN KLREAD BUG (MC) IS FIXED!    '

C   07/06/96 606071832  MEMBER NAME  BRNM     (S4)          FORTG1
      SUBROUTINE BRNM(NA,NB,NC,ND)
C     BOS SUBPROGRAM =1.1=
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
#include "star.for"
      CALL BLOC(IND,NA,NB,*100)
      KK=LFDK
      IS=IW(KK-1)
      IW(KK-1)=IW(LFDI-1)
      CALL BLOC(JND,NC,ND,*20)
      IW(KK-1)=IS
      GOTO 100
   20 IW(IND-1)=IW(LFDK-1)
      IW(LFDK-1)=IND
      IW(IND-3)=NC
      IW(IND-2)=ND
      NN=0
      INAME=NA
      IF(NOTLOW(XNAME)) GOTO 22
      NN=NN-IW(IND)-4
   22 INAME=NC
      IF(NOTLOW(XNAME)) GOTO 24
      NN=NN+IW(IND)+4
   24 NCPL=NCPL+NN
      GOTO 100
C
      ENTRY BSPC(NA,NB,NC,ND)
      NA=NEXT
      NB=NLST-NEXT+1
      NC=NFRE
      ND=NS
  100 RETURN
C
      END

C   01/11/84 608051143  MEMBER NAME  ZTRGVW   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE ZTRGVW
C-----------------------------------------------------------------------
C
C  AUTHOR:    J. OLSSON     20/09/83  :  SHOW Z FOR FADC INFO IN ZTRG
C
C       MOD:  J. OLSSON     27/09/83  :
C       MOD:  J.H.  C.B.     1/11/84  :  ROTNK CHANGE UPDATE
C  LAST MOD:  J.O.           4/08/86  :  EXTENSION FOR ZTRG:2
C
C     SHOW POSITION OF Z FOR FADC INFORMATION IN ZTRG BANK
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM,VTXCHR
C
#include "cgeo1.for"
#include "cjdrch.for"
#include "cgraph.for"
#include "cdata.for"
#include "chsym.for"
C
      COMMON / CJCELL / NCELL(3),
     +                  NWIRES(3)
      COMMON / CWORK1 / HWORK(100)
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION  HELP(2),HZBAD(8),HZSTOR(16)
C
      EQUIVALENCE  (HELP(1),IZWORD)
C
      DATA  HELP / 0,0 /
      DATA  RZ   / 10.0 /
      DATA MASKZ/Z3F/,MSKSUB/Z3/,MSKSLO/Z7C/,MSKCRA/Z380/
C
C-----------------------------------------------------------------------
C---
C--  LOCATE ZTRG BANK
C---
      IPZTRG = IDATA(IBLN('ZTRG'))
      IF(IPZTRG.GT.0) GO TO 6241
      WRITE(6,6242)
6242  FORMAT(' >>>>>  NO  ZTRG  BANK .....')
      GO TO 9999
6241  LEZTRG = IDATA(IPZTRG)
      IF(LEZTRG.GT.1) GO TO 6245
      WRITE(6,6243)
6243  FORMAT(' >>>>>  ZTRG  BANK WITH LENGTH 0 OR 1 ....')
      GO TO 9999
C
6245  ZFACTO = 2.*ZMAX/63.
      IF(ACMD.NE.0.) ZFACTO = ACMD
C
C OLD OR NEW DATA ?
C
      IPZTRG = 2 * IPZTRG
      HBDSCR = HDATA(IPZTRG + 1)
      IF(HBDSCR.GT.1) GO TO 5000
C
C   OLD DATA
C
      CALL ERASE
      CALL TWINDO(0,4095,0,4095)
      XMINRE = XMIN
      XMAXRE = XMAX
      YMINRE = YMIN
      YMAXRE = YMAX
      XMIN=-1800.
      XMAX= 1500.
      YMIN=-1300.
      YMAX = YMIN + XMAX - XMIN
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
C
C  DRAW DETECTOR:
C
C--   FIRST DRAW BOX
      CALL DRAMOV(ZTKM,RITNK,ZTKM,ROTNK+DROTNK,0)
      CALL DRAWA(ZTKP,ROTNK+DROTNK)
      CALL DRAWA(ZTKP,RITNK)
      CALL DRAWA(ZTKM,RITNK)
C--   DRAW NOW BEAM PIPE
      CALL DRAMOV(ZENDMI,RPIP,ZENDPL,RPIP,0)
C--                               MARK THE BEAM AND AXIS DIRECTION
      CALL MOVEA(-40.,  0.)
      CALL DRAWA( 40.,  0.)
      CALL MOVEA(  0.,-40.)
      CALL DRAWA(  0., 40.)
      CALL MOVEA(   0.,   0.)
      SIGN=1.
      CALL DRAWA((SIGN* 80.),   0.)
      CALL DRAWA((SIGN* 80.),  20.)
      CALL DRAWA((SIGN*100.),   0.)
      CALL DRAWA((SIGN* 80.), -20.)
      CALL DRAWA((SIGN* 80.),   0.)
C--   DRAW WIRES OF INNER DETECTOR
      X1 = -ZMAX + ZOFFS
      X2 = ZMAX + ZOFFS
         DO 7 J = 1,3
         RADD = RINCR(J)
         R = FSENSW(J) - 2.*RADD
         NWE = NWIRES(J)
         IF(J.EQ.3) GO TO 9
           DO 8 K = 1,NWE,2
           R = R + 2.*RADD
           CALL DRAMOV(X1,R,X2,R,14)
    8      CONTINUE
         GO TO 7
    9    R = R + 2.*RADD
           DO 10 K = 1,2
           R = R + (K-1)*RADD*(NWE-1)
           CALL DRAMOV(X1,R,X2,R,14)
   10      CONTINUE
    7    CONTINUE
C
C
      HPOINT = 2*( IPZTRG + 1 )
      HZLENG = 2*( LEZTRG - 1 )
      IF( HZLENG.LE.256) GO TO 6251
      WRITE(6,6244)
6244  FORMAT(' >>>>> ZTRG BANK WITH > 256 HALF WORDS ....')
      GO TO 999
6251  CONTINUE
C
C  LOOP OVER THE RAW DATA AND DECODE
C
C    BIT 15:    > NMAX (=4)
C    BIT 14-11: CHANNEL (WIRE NR., 0-15)
C    BIT 10:    FIFO OVERFLOW
C    BIT 9-8:   HIT COUNTER, NRHIT - 1    (I.E. 0 MEANS 1 HIT)
C    BIT 7:     UNDERFLOW
C    BIT 6:     OVERFLOW
C    BIT 5-0:   Z VALUE, CODED
C
      IOLDWD = -1
      KANOLD = 99999
C
      DO 1130  I = 1,8
1130  HZBAD(I) = 0
C
      DO 1198 IHIT = 1,HZLENG
        HELP(2) = HDATA(HPOINT+IHIT)
C
C  768 = #300, BITS 8 AND 9. ACCEPT ONLY DATA WITH ONE HIT
C
        IF(LAND(IZWORD,768).EQ.0) GO TO 1201
C       WRITE(6,1202) IHIT
1202    FORMAT(' >>>>> WORD NR ',I3,' HAS MORE THAN 1 HIT..')
        HZBAD(1) = HZBAD(1) + 1
        GO TO 1200
C
C  TEST ON BIT NR 15, INDICATOR FOR > NMAX
C
1201    IF(.NOT.TBIT(IZWORD,16)) GO TO 1203
C       WRITE(6,1204) IHIT
1204    FORMAT(' >>>>> WORD NR ',I3,' HAS HIGH COUNT BIT SET..')
        HZBAD(2) = HZBAD(2) + 1
        GO TO 1200
C
C  CHANNEL NR, BITS 14-11
C  Z VALUE, BITS 5-0
C
1203    KANAL = LAND( SHFTR(IZWORD,11),15)
        IZWERT = LAND( IZWORD,63 )
        IF(LAND(IZWORD,64).EQ.0) GO TO 1205
C       WRITE(6,1206) IHIT
1206    FORMAT(' >>>>> WORD NR ',I3,' OVERFLOW FLAG SET..')
        HZBAD(3) = HZBAD(3) + 1
        GO TO 1200
1205    IF(LAND(IZWORD,128).EQ.0) GO TO 1207
C       WRITE(6,1208) IHIT
1208    FORMAT(' >>>>> WORD NR ',I3,' UNDERFLOW FLAG SET..')
        HZBAD(4) = HZBAD(4) + 1
        GO TO 1200
1207    IF(LAND(IZWORD,1024).EQ.0) GO TO 1209
C       WRITE(6,1210) IHIT
1210    FORMAT(' >>>>> WORD NR ',I3,' FIFO OVERFLOW FLAG SET..')
        HZBAD(5) = HZBAD(5) + 1
        GO TO 1200
1209    IF(KANAL.LT.KANOLD) GO TO 1211
C       WRITE(6,1212) IHIT
1212    FORMAT(' >>>>> WORD NR ',I3,' WITH NONDECREASING CHANNEL NR ')
        HZBAD(6) = HZBAD(6) + 1
        GO TO 1200
1211    IF(IOLDWD.NE.IZWORD) GO TO 1213
C       WRITE(6,1214) IHIT
1214    FORMAT(' >>>>> WORD NR ',I3,' WITH DATA IDENTICAL TO PREVIOUS')
        HZBAD(7) = HZBAD(7) + 1
        GO TO 1200
1213    IBADF = 0
C
C --  DISPLAY Z VALUE
C
1611  JW = 1
      IF(KANAL.GT.7) JW = 2
      KANAL1 = KANAL
      IF(KANAL1.GT.7) KANAL1 = KANAL1 - 8
      RADD = RINCR(JW)
      RVAL = FSENSW(JW)
      RVAL = RVAL + KANAL1*RADD*2.
      ZVAL = IZWERT*ZFACTO - ZMAX
C     WRITE(6,1671) IHIT,JW,KANAL,RADD,RVAL,FSENSW(JW),IZWERT
1671  FORMAT(' IH JW K RD RV FSW IZW ',3I4,3E12.4,I4)
      Z0 = 15.
      NZ = 3
      IF(IBADF.EQ.1) Z0 = 8.
      IF(IBADF.EQ.1) NZ = 6
      CALL PLYGON(NZ,Z0,ZVAL,RVAL,0)
C
      GO TO 1199
 1200 CONTINUE
      HZBAD(8) = HZBAD(8) + 1
      KANAL = LAND( SHFTR(IZWORD,11),15)
      IZWERT = LAND( IZWORD,63 )
      IBADF = 1
      GO TO 1611
1199  IOLDWD = IZWORD
      KANOLD = KANAL
1198  CONTINUE
C
      CALL CHRSIZ(4)
      CALL CSIZE(IX,IXT)
      SIZE = IXT*.8
      DEL = 1.7*SIZE
      XS = ZENDMI
      YS = RPIP + 5.
      CALL MOVEA(XS,YS)
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
      IILIM = 50
      CALL CORE(HWORK,IILIM)
      WRITE(JUSCRN,9010) HZLENG,HZBAD(8)
 9010 FORMAT(' NR OF DATA WORDS:',I4,'   NR OF BAD DATA WORDS:',I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
      YS = YS - DEL
      IILIM = 78
      CALL CORE(HWORK,IILIM)
      WRITE(JUSCRN,9070) (HZBAD(I),I=1,7)
 9070 FORMAT(' >1HIT:',I3,'  B15:',I3,'  OVFLW:',I3,'  UNFLW:',I3,
     $'  FIFLW:',I3,'  NONDECR.:',I3,'  IDENT.:',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
C
C   NOW PRINT DATA BELOW THE DETECTOR DISPLAY
C
      CALL MOVEA(XMIN,-70.)
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
C                    WRITE HEADER
      IILIM = 50
      CALL CORE(HWORK,IILIM)
      WRITE(JUSCRN,9011)
 9011 FORMAT(' DATA  B15 CHANNEL FIFOF HITCN UFLOW OFLOW Z-VALUE')
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
      IPASSZ = 0
C
      DO 1300 IHIT = 1,HZLENG
        HELP(2) = HDATA(HPOINT+IHIT)
        KANAL = LAND( SHFTR(IZWORD,11),15)
        HITCN = LAND( SHFTR(IZWORD,8),3)
        IBIT15 = 0
        IF(TBIT(IZWORD,16)) IBIT15 = 1
        IZWERT = LAND( IZWORD,63 )
        IOVERF= 0
        IF(LAND(IZWORD,64).NE.0) IOVERF = 1
        IUNDEF= 0
        IF(LAND(IZWORD,128).NE.0) IUNDEF = 1
        IFIFOF= 0
        IF(LAND(IZWORD,1024).NE.0) IFIFOF = 1
9965    YS = YS - DEL
        IF(YS.GT.50.) GO TO 9012
C
C SWITCH COLUMN
C
        IF(IPASSZ.NE.0) GO TO 1301
        XS = XMIN + (XMAX-XMIN)*.5
        YS = -70.
        CALL MOVEA(XS,YS)
        CALL SEELOC(IXT,IYT)
        XS = IXT
        YS = IYT
        CALL MOVEA(XS,YS)
C                    WRITE HEADER
        IILIM = 50
        CALL CORE(HWORK,IILIM)
        WRITE(JUSCRN,9011)
        CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
        IPASSZ = 1
        GO TO 9965
C
9012    IILIM = 48
        CALL CORE(HWORK,IILIM)
        WRITE(JUSCRN,9013) IZWORD,IBIT15,KANAL,IFIFOF,HITCN,IUNDEF,
     $  IOVERF,IZWERT
 9013   FORMAT(' ',Z4,3X,I1,4X,I2,5X,I1,5X,I1,5X,I1,5X,I1,4X,I5)
        CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 1300 CONTINUE
 1301 CONTINUE
C
C   DISPLAY Z-COORDINATES FROM SECTOR 7 IN JETC BANK
C
      IPJ = IDATA(IBLN('JETC'))
      IF(IPJ.GT.0) GO TO 2461
      WRITE(6,2462)
2462  FORMAT('  NO JETC BANK...')
      GO TO 999
2461  NWO = (HDATA(2*IPJ+99)-HDATA(2*IPJ+3)+100)/2
      IF(NWO.GT.2) GO TO 2463
      WRITE(6,2464)
2464  FORMAT('  NO DATA IN JETC BANK...')
      GO TO 999
2463  IPJH = 2*IPJ
      NI = IPJH + 101
   93 CONTINUE
C     LOOP OVER WIRES
      NIW = HDATA(NI)
      NIW = SHFTR(NIW,3) + 1
      IF(NIW.GT.1536.OR.NIW.LE.0) GO TO 9191
      INCL = SHFTR(NIW-1,4) + 1
C                     CELLS IN SECTOR 7:   7,31,61,62
      IF(INCL.EQ.7.OR.INCL.EQ.31) GO TO 2354
      IF(INCL.EQ.61.OR.INCL.EQ.62) GO TO 2354
      GO TO 9191
2354  NRING = (NIW-1)/384 + 1
      IF(NRING.GT.3) NRING = 3
      RADD = RINCR(NRING)
      R = FSENSW(NRING) - RADD
      NEW = NIW - (NRING-1)*384
      NCE = SHFTR(NEW-1,4)
      NWE = NEW - NCE*16
      R = R + NWE*RADD
      NI = NI + 1
C  GET Z-COORDINATE
      IA1 = HDATA(NI)
      NI = NI + 1
      IA2 = HDATA(NI)
      IF(IA1+IA2.GT.0) GO TO 1013
      ZET = 0.
      GO TO 1014
1013  ZET = ZAL*.5*(IA2 - IA1)/(IA1+IA2)
1014  NI = NI + 2
C DISPLAY HIT
      CALL MOVEA(ZET-RZ, R)
      CALL DRAWA(ZET+RZ, R)
      CALL MOVEA(ZET,R-RZ)
      CALL DRAWA(ZET,R+RZ)
C
      GO TO 9333
9191  NI = NI + 4
 9333 IF(NI.LE.(IPJH + 2*NWO)) GO TO 93
      GO TO 999
C
C   NEW DATA (1986)
C
5000  CALL ERASE
      CALL TWINDO(0,4095,0,4095)
      XMINRE = XMIN
      XMAXRE = XMAX
      YMINRE = YMIN
      YMAXRE = YMAX
      XMIN=-1800.
      XMAX= 1500.
      YMIN=-1300.
      YMAX = YMIN + XMAX - XMIN
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
C
C  DRAW INNER DETECTOR:
C
C                            FIRST DRAW BOX
C
  20  CALL DRAMOV(ZTKM, RITNK,ZTKM, ROTNK,0)
      CALL DRAWA( ZTKP, ROTNK)
      CALL DRAWA( ZTKP, RITNK)
      CALL DRAWA( ZTKM, RITNK)
      CALL DRAMOV(ZTKM,-RITNK,ZTKM,-ROTNK,0)
      CALL DRAWA( ZTKP,-ROTNK)
      CALL DRAWA( ZTKP,-RITNK)
      CALL DRAWA( ZTKM,-RITNK)
C--                                      DRAW NOW BEAM PIPE/VTX-CHAMB
      VTXCHR = .TRUE.
      CALL DRAWBP( 2 , VTXCHR )
      CALL DRAWVC( 2 )
C--                               MARK THE BEAM AND AXIS DIRECTION
      CALL MOVEA(-40.,  0.)
      CALL DRAWA( 40.,  0.)
      CALL MOVEA(  0.,-40.)
      CALL DRAWA(  0., 40.)
      CALL MOVEA(   0.,   0.)
      SIGN=1.
      CALL DRAWA((SIGN* 80.),   0.)
      CALL DRAWA((SIGN* 80.),  20.)
      CALL DRAWA((SIGN*100.),   0.)
      CALL DRAWA((SIGN* 80.), -20.)
      CALL DRAWA((SIGN* 80.),   0.)
C--                               DRAW WIRES OF INNER DETECTOR
      X1 = -ZMAX + ZOFFS
      X2 = ZMAX + ZOFFS
         DO 107 J = 1,3
         RADD = RINCR(J)
         R = FSENSW(J) - 2.*RADD
         NWE = NWIRES(J)
         IF(J.EQ.3) GO TO 109
           DO 108 K = 1,NWE,2
           R = R + 2.*RADD
           CALL DRAMOV(X1,R,X2,R,14)
           CALL DRAMOV(X1,-R,X2,-R,14)
  108      CONTINUE
         GO TO 107
  109    R = R + 2.*RADD
           DO 110 K = 1,2
           R = R + (K-1)*RADD*(NWE-1)
           CALL DRAMOV(X1,R,X2,R,14)
           CALL DRAMOV(X1,-R,X2,-R,14)
 110      CONTINUE
  107    CONTINUE
C
      HZLENG = HDATA(IPZTRG+3)
      IPZTRG = IPZTRG + 3
C
C  LOOP OVER THE DATA, DECODE AND DISPLAY
C
C
C    BIT 15:    ADRESS BIT, IF ON ADRESS WORD
C
C  DATA WORD FORMAT:
C
C    BIT 5-0:   Z VALUE, CODED
C    BIT   6:   OVERFLOW INDICATOR
C    BIT   7:   LOWER LEVEL INDICATOR
C    BIT   8:   UPPER LEVEL INDICATOR
C    BIT   9:   FIFO OUTPUT READY, MEANING NOT CLEAR, IGNORE...
C
C  ADRESS WORD FORMAT:
C
C    BIT 0-1:   SUBADRESS (0-3)
C    BIT 2-6:   CARD, SLOT ADRESS (0-19)
C    BIT 7-9:   CRATE ADRESS  (0-2)
C
      NZHIT = 0
C
      DO 1500 IHIT = 1,HZLENG
C
        HELP(2) = HDATA(IPZTRG+IHIT)
C
        IF(HELP(2).LT.0) GO TO 2500
C
C DATA WORD, STORE Z-VALUE IN ARRAY FOR LATER DISPLAY WHEN WIRE KNOWN
C
        NZHIT = NZHIT + 1
        IF(NZHIT.LE.16) GO TO 2001
        WRITE(6,1499)
1499  FORMAT('  ERROR**   MORE THAN 16 HITS ON WIRE ')
        GO TO 1500
2001    HZSTOR(NZHIT) = LAND(MASKZ,IZWORD)
        GO TO 1500
C
C ADRESS WORD, DECODE AND DISPLAY IF HITS HAD BEEN FOUND
C
2500  IF(NZHIT.LE.0) GO TO 1500
C
C NOTE THAT FOR BANK DESCRIPTOR 2, MANY EMPTY WIRES OCCUR, DUE TO
C LOGICAL ERROR IN INTERFACE.
C
      ISUBA = LAND(MSKSUB,IZWORD)
      ISLOZ = LAND(MSKSLO,IZWORD)
      ISLOZ = SHFTR(ISLOZ,2)
      ICRAZ = LAND(MSKCRA,IZWORD)
      ICRAZ = SHFTR(ICRAZ,7)
C
      NWIRE = IWCARD(ICRAZ,ISLOZ,ISUBA)
      IF(NWIRE.LT.0) GO TO 2600
      NIW = NWIRE + 1
C
C THERE ARE NZHIT HITS ON WIRE NWIRE, DISPLAY
C
      NRING = (NIW-1)/384 + 1
      IF(NRING.GT.3) NRING = 3
      RADD = RINCR(NRING)
      NCL = NCELL(NRING)
      R = FSENSW(NRING) - RADD
      NEW = NIW - (NRING-1)*384
      NCE = SHFTR(NEW-1,4)
      NWE = NEW - NCE*16
      R = R + NWE*RADD
C                         POSITIVE OR NEGATIVE R ?, ASSUMING ZY-VIEW
      IF(NIW.GE.193.AND.NIW.LE.384) R = -R
      IF(NIW.GE.577.AND.NIW.LE.768) R = -R
C
      DO 2510  I = 1,NZHIT
C     ZVAL = HZSTOR(I)*ZFACTO - ZMAX
      ZVAL = ZMAX - HZSTOR(I)*ZFACTO
      Z0 = 15.
      NZ = 3
      CALL PLYGON(NZ,Z0,ZVAL,R,0)
2510  CONTINUE
C
2600  NZHIT = 0
C
1500  CONTINUE
C
C   DISPLAY NORMAL ZY-VIEW OF INNER DETECTOR HITS
C
      IPJ = IDATA(IBLN('JETC'))
      IF(IPJ.GT.0) GO TO 2761
      WRITE(6,2462)
      GO TO 999
C
2761  NWO = (HDATA(2*IPJ+99)-HDATA(2*IPJ+3)+100)/2
      IF(NWO.GT.2) GO TO 2763
      WRITE(6,2464)
      GO TO 999
C
2763  IPJH = 2*IPJ
      NI = IPJH + 101
 2793 CONTINUE
C     LOOP OVER WIRES
      NIW = HDATA(NI)
      NIW = SHFTR(NIW,3) + 1
      IF(NIW.GT.1536.OR.NIW.LE.0) GO TO 2791
      INCL = SHFTR(NIW-1,4) + 1
      NRING = (NIW-1)/384 + 1
      IF(NRING.GT.3) NRING = 3
      RADD = RINCR(NRING)
      R = FSENSW(NRING) - RADD
      NEW = NIW - (NRING-1)*384
      NCE = SHFTR(NEW-1,4)
      NWE = NEW - NCE*16
      R = R + NWE*RADD
      IF(NIW.GE.193.AND.NIW.LE.384) R = -R
      IF(NIW.GE.577.AND.NIW.LE.768) R = -R
      IF(NIW.GE.1153.AND.NIW.LE.1536) R = -R
      NI = NI + 1
C  GET Z-COORDINATE
      IA1 = HDATA(NI)
      NI = NI + 1
      IA2 = HDATA(NI)
      IF(IA1+IA2.GT.0) GO TO 2713
      ZET = 0.
      GO TO 2714
2713  ZET = ZAL*.5*(IA2 - IA1)/(IA1+IA2)
2714  NI = NI + 2
C DISPLAY HIT
      CALL MOVEA(ZET-RZ, R)
      CALL DRAWA(ZET+RZ, R)
      CALL MOVEA(ZET,R-RZ)
      CALL DRAWA(ZET,R+RZ)
C
      GO TO 2733
2791  NI = NI + 4
 2733 IF(NI.LE.(IPJH + 2*NWO)) GO TO 2793
C***
C***                    WRITE CAPTION
C***
999   INDES = -4
      CALL CAPMRK(INDES,IESUM)
      CALL TWINDO(0,4095,0,4095)
      XMIN = XMINRE
      XMAX = XMAXRE
      YMIN = YMINRE
      YMAX = YMAXRE
      CALL SETSCL(LASTVW)
9999  RETURN
      END
      FUNCTION IWCARD(IC,ISLOT,ISUBA)
C
C RETURNS WIRE NUMBER CORRESPONDING TO CRATE,SLOT AND SUBADRESS IN
C  Z-TRIGGER HARDWARE
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION HOFSET(48)
C
      DATA HOFSET /  48,  56, 432, 440,  64,  72, 448, 456,  80,  88,
     $              464, 472,  96, 104, 480, 488, 112, 120, 496, 504,
     $              128, 136, 512, 520,
     $              240, 248, 624, 632, 256, 264, 640, 648, 272, 280,
     $              656, 664, 288, 296, 672, 680, 304, 312, 688, 696,
     $              320, 328, 704, 712/
C
C  TEST INPUT VALUES
C
      NN = IC*20 + ISLOT + 1
      IF(NN.GE.1.AND.NN.LE.48.AND.ISUBA.GE.0.AND.ISUBA.LE.3) GO TO 1
      WRITE(6,1000) IC,ISLOT,ISUBA
1000  FORMAT(' WICARD ERROR: CRATE,SLOT,SUBADR. ',3I8)
      IWCARD = -100
      GO TO 999
C
C CORRESPONDING WIRE NUMBER, FOR CORRECT INPUT DATA
C
1     IWCARD = HOFSET(NN) + ISUBA * 2
999   CONTINUE
      RETURN
      END

C   24/04/87 712211517  MEMBER NAME  BBLEAK   (S)           FORTRAN
C
C    CORRECTION FOR LEAKAGE OF BHABHA-SHOWERS      D.PITZL  13.12.87
C
C    THIS IS NOT CONSIDERED IN THE LG-CALIBRATION WHEN THE 'EXPECTED'
C    ENERGY OF A BHABHA-SHOWER IS CALCULATED. SO THE CALIBRATION
C    CONSTANTS WHICH MULTIPLY THE MEASURED ENERGY TO AGREE WITH
C    THE EXPECTED ENERGY ARE SYSTEMATICALLY TOO HIGH.
C
C    MATERIAL IN FRONT OF LEAD GLASS IS INCLUDED AS 1.22 X0 ALU
C
C    DATA FROM EGS4
C
C    3 PERIODS:
C         -- YEARS 1979-82: ONLY SF5-BLOCKS
C                           BEAM ENERGY 17.5 GEV
C         -- YEARS 1983-86: SF5 AND SF6-BLOCKS
C                           BEAM ENERGY 17.5 OR 22 GEV
C
C    RADIATION LENGTH IN SF5 = 2.475 CM (EGS4-VALUE)
C                     IN SF6 = 1.66  CM (EGS4-VALUE)
C
C=======================================================================
      SUBROUTINE BBLEAK ( NRING, RLEAK )
C=======================================================================
C
C    INPUT  : NRING = NUMBER OF LG-RING IN BARREL ( 0-31 )
C    OUTPUT : RLEAK = FRACTION OF LEAKING BHABHA-ENERGY
      IMPLICIT INTEGER*2 (H)
#include "'f11god.patrecsr.for"
C
      DATA ICALLS / 0 /
C
      DIMENSION R35SF6 (16)
      DIMENSION R44SF6 (16)
      DIMENSION R35SF5 (16)
C
C
C   RING# /
C
C           ECM = 35 GEV, LG WITH SF6 + SF6 ( 1986    ) :
C
      DATA R35SF6 /    .0634, .0634, .0634, .0123, .0143, .0196, .0265,
     +   .0346, .0451, .0572, .0697, .0829, .0951, .0172, .0194, .0204/
C
C           ECM = 44 GEV, LG WITH SF6 + SF6 ( 1983-85 ) :
C
      DATA R44SF6 /    .0659, .0659, .0659, .0148, .0169, .0223, .0292,
     +   .0375, .0479, .0598, .0722, .0856, .0978, .0203, .0226, .0237/
C
C           ECM = 35 GEV, LG ONLY SF5 ( 1979-82 ) :
C
      DATA R35SF5 /    .0634, .0634, .0634, .0123, .0143, .0196, .0265,
     +   .0346, .0451, .0572, .0697, .0829, .0951, .1062, .1138, .1177/
C
      IHEAD  = IDATA( IBLN('HEAD') )
      NRUN   = HDATA( 2*IHEAD + 10 )
      NREC   = HDATA( 2*IHEAD + 11 )
      NYEAR  = HDATA( IHEAD*2 +  8 )
      EBM    = EBEAM ( NRUN ) / 1000.
C
      NRINGW = NRING
C---                                              SYMMETRY AROUND Z=0
      IF ( NRINGW .GT. 15 ) NRINGW = 31 - NRINGW
      NRINGW = NRINGW + 1
C
C---              BRANCH ACCORDING TO YEAR AND ENERGY
C
      IF ( NYEAR .GT. 1982 ) GOTO 20
         RLEAK = R35SF5 ( NRINGW )
         IF ( ICALLS .EQ. 0 ) PRINT 1000, NYEAR
         ICALLS = 1
         GOTO 99
 20   CONTINUE
      IF ( EBM .LT. 19.75 ) GOTO 30
         RLEAK = R44SF6 ( NRINGW )
         IF ( ICALLS .EQ. 0 ) PRINT 1001, NYEAR, EBM
         ICALLS = 1
         GOTO 99
 30   CONTINUE
         RLEAK = R35SF6 ( NRINGW )
         IF ( ICALLS .EQ. 0 ) PRINT 1002, NYEAR, EBM
         ICALLS = 1
 99   CONTINUE

 1000 FORMAT ( /T2,' JADELG.LOAD (BBLEAK) CALLED:',
     +  ' ONLY SF5-BLOCKS IN YEAR ', I4 /)
 1001 FORMAT ( /T2,' JADELG.LOAD (BBLEAK) CALLED:',
     + ' SF5 AND SF6-BLOCKS IN YEAR ',I4,
     + ' ,EBEAM = ',F7.3,' GEV, VALUES FOR 22.0 GEV TAKEN'/)
 1002 FORMAT ( /T2,' JADELG.LOAD (BBLEAK) CALLED:',
     + ' SF5 AND SF6-BLOCKS IN YEAR ',I4,
     + ' ,EBEAM = ',F7.3,' GEV, VALUES FOR 17.5 GEV TAKEN'/)

      RETURN
      END

C   07/06/96 606071845  MEMBER NAME  GPR      (S4)          FORTRAN77
      SUBROUTINE GPR(IPAGE)
C
C
C
C
C
C
C
C
C
C                 ----------------------------
C                 ----- PLOT PROGRAM GPR -----
C                 ----------------------------
C
C
C     PURPOSE
C        PLOT IN 60 * 120 BINS  COUNTS, NUMBERS, TEXT, SYMBOLS
C
C     CALL GPR(IPAGE)           PRINT ONE PLOT (NEW PAGE FOR IPAGE=1,
C                               BUFFER IS CLEARED AFTER PRINTOUT,
C                               BUT NOT SCALES AND TEXT)
C     CALL GPL(LIM)             ALLOW ADDITIONAL LIM PLOTS TO BE
C                               PRINTED (DEFAULT IS 20)
C     CALL GTE('TEXT$')         ADD TEXT (DELIMITED BY $) TO THE
C                               PLOT (PRINTED ABOVE THE PLOT)
C     CALL GNE(NE)              ADD NE (POSITIVE INTEGER UP TO
C                               8 DIGITS) TO THE PLOT (PRINTED ABOVE
C                               THE PLOT), UP TO SIX NUMBERS CAN BE
C                               STORED
C
C
C                               DEFINITION OF SCALES
C                               --------------------
C                               60 BINS FOR Y, 120 BINS FOR X
C     CALL GRY(YA,YB)           Y-RANGE YA TO YB (ROUNDED)
C     CALL GRX(XA,XB)           X-RANGE XA TO XB (ROUNDED)
C     CALL GEY(YA,YB)           Y-RANGE YA TO YB (EXACT)
C     CALL GEX(XA,XB)           X-RANGE XA TO XB (EXACT)
C     CALL GMY(Y,N)             Y-RANGE FROM MIN AND MAX (SEVERAL
C                               CALLS ALLOWED)
C     CALL GMX(X,N)             X-RANGE FROM MIN AND MAX (SEVERAL
C                               CALLS ALLOWED)
C
C
C
C                               ADD TO PLOT (OVERWRITING PREVIOUS CONT.)
C                               ----------------------------------------
C     CALL GCN(YI,XJ)           INCREASE BIN I/J BY ONE
C     CALL GNR(YI,XJ,NR)        ADD NR (INTEGER UP TO 7 DIGITS) IN
C                               BIN I/J, I/J-1, . . .THE PRINTED NUMBER
C                               IS PRECEEDED BY BLANK OR -SIGN (OR *, IF
C                               SPACE INSUFFICIENT)
C     CALL GTX(YI,XJ,'TEXT$')   ADD TEXT (DELIMITED BY $) IN
C                               BIN I/J, I/J+1, . . .
C     CALL GPT(Y,X,N,'C')       ADD N POINTS Y,X (CONNECTED BY STRAIGHT
C     CALL GPT(Y,X,N,IS)        LINES) WITH CHARACTER 'C' OR CHAR IS
C                               (IS BETWEEN 0 AND 40)
C
C     ARGUMENTS YI OR XJ MAY BE INTEGERS I=1 TO 60 OR J=1 TO 120 RESP.
C     OR FLOATING POINT NUMBERS (SCALES ARE USED TO CONVERT TO BINS).
C     I/J = 1/1 IS LOWER LEFT EDGE. IN GPT Y AND X ARE NOT ALLOWED
C     TO BE INTEGERS EXCEPT FOR N = 1.
C
C          IS    0  1  2  3  4  5  6  7  8  9
C             +-------------------------------
C           0 I  0  1  2  3  4  5  6  7  8  9      E.G. IS = 22
C          10 I  A  B  C  D  E  F  G  H  I  J      EQUIV. TO 'M'
C          20 I  K  L  M  N  O  P  Q  R  S  T
C          30 I  U  V  W  X  Y  Z  +  -  *  .
C          40 I BLK
C
C
C
C
C
C
C
C
C
      INTEGER AR(31,62),BLK/'    '/
      LOGICAL*1 LR(124,62)
      EQUIVALENCE (LR(1,1),AR(1,1))
      LOGICAL OUT
      OUT(K,LIM)=K.LT.1.OR.K.GT.LIM
      REAL SYA/-1.0/,SYB/1.0/,SXA/-1.0/,SXB/1.0/
      INTEGER IDX/0/,IDY/0/,IEN/0/
      INTEGER TE(15)
      LOGICAL*1 LT(60)/60*' '/
      EQUIVALENCE (TE(1),LT(1))
      LOGICAL*1 LCN(4)
      INTEGER NCN/0/
      EQUIVALENCE (NCN,LCN(1))
      LOGICAL*1 LIST(42)/
     1   '0','1','2','3','4','5','6','7','8','9',
     2   'A','B','C','D','E','F','G','H','I','J',
     3   'K','L','M','N','O','P','Q','R','S','T',
     4   'U','V','W','X','Y','Z','+','-','*','.',' ','$'/
      REAL TS(12)
      REAL*8 TF(12)
      REAL X(1),Y(1)
      INTEGER LIMA/0/,LIMP/20/
      EQUIVALENCE (FE,NE)
      LOGICAL*1 LISYM(4),TEXT(60)
      EQUIVALENCE (ISYM,LISYM(1))
      LOGICAL*1 RL(8)
      REAL*8 R
      EQUIVALENCE (R,RL(1))
      REAL*8 TEXTNR(6)/6*'        '/,BLANK/'        '/
      INTEGER IT/0/
C
C     PRINTOUT
      IF(IEN.EQ.0) GOTO 86
      IEN=0
      IF(LIMA.GE.LIMP) GOTO 86
      LIMA=LIMA+1
      DO 6 J=2,61
      DO 4 I=1,31
      IF(AR(I,J).EQ.BLK) GOTO 4
      KB=4*I
      KA=KB-3
      DO 2 K=KA,KB
      LCN(4)=LR(K,J)
      IF(NCN.GT.36) GOTO 2
      LR(K,J)=LIST(NCN+1)
    2 CONTINUE
    4 CONTINUE
    6 CONTINUE
      DO 8 I=1,7
      T=FLOAT(I-1)/6.0
    8 TS(I)=T*SYA+(1.0-T)*SYB
      CALL BFMT(TS,7,TF,EF)
      IP=0
      IF(IPAGE.EQ.1) IP=1
      WRITE(6,101) IP,TEXTNR,LT,EF
      DO 10 J=1,62
      IF(MOD(J,10).EQ.2) WRITE(6,102) TF((J+8)/10),(AR(I,J),I=1,31)
      IF(MOD(J,10).NE.2) WRITE(6,103)              (AR(I,J),I=1,31)
   10 CONTINUE
      DO 12 J=1,12
      T=FLOAT(J-1)/12.0
   12 TS(J)=T*SXB+(1.0-T)*SXA
      CALL BFMT(TS,12,TF,EF)
      WRITE(6,104) TF,EF
      GOTO 86
C
C     DELIMIT PRINTOUT
      ENTRY GPL(LIM)
      LIMP=LIM
      LIMA=0
      GOTO 100
C
C     TEXT DEFINITION
      ENTRY GTE(TEXT)
      DO 14 I=1,15
   14 TE(I)=BLK
      DO 16 I=1,60
      IF(TEXT(I).EQ.LIST(42)) GOTO 100
      IF(TEXT(I).EQ.LIST(41)) GOTO 16
      LCN(4)=TEXT(I)
      IF(NCN.GE.0.AND.NCN.LE.74) GOTO 100
      IF(NCN.GE.128.AND.NCN.LE.191) GOTO 100
   16 LT(I)=TEXT(I)
      GOTO 100
C
C     NR DEFINITION
      ENTRY GNE(NE)
      IF(IT.GE.6) GOTO 100
      IT=IT+1
      CALL ITODA(IABS(NE),TEXTNR(IT),-8)
      GOTO 100
C
C     SCALE DEFINITION
      ENTRY GRY(YA,YB)
      IF(IEN.NE.0) GOTO 100
      IF(YA.EQ.YB) GOTO 20
      CALL XBINS(YA,YB,60,SYA,ST)
      SYB=SYA+60.0*ST
      GOTO 100
      ENTRY GRX(XA,XB)
      IF(IEN.NE.0) GOTO 100
      IF(XA.EQ.XB) GOTO 22
      CALL XBINS(XA,XB,120,SXA,ST)
      SXB=SXA+120.0*ST
      GOTO 100
      ENTRY GEY(YA,YB)
      IF(IEN.NE.0) GOTO 100
      IF(YA.EQ.YB) GOTO 20
      SYA=YA
      SYB=YB
      GOTO 100
      ENTRY GEX(XA,XB)
      IF(IEN.NE.0) GOTO 100
      IF(XA.EQ.XB) GOTO 22
      SXA=XA
      SXB=XB
      GOTO 100
   20 SYA=-1.0
      SYB=+1.0
      GOTO 100
   22 SXA=-1.0
      SXB=+1.0
      GOTO 100
      ENTRY GMY(Y,N)
      IF(IEN.NE.0) GOTO 100
      IF(IDY.EQ.0) YMIN=Y(1)
      IF(IDY.EQ.0) YMAX=Y(1)
      IDY=1
      DO 24 I=1,N
      YMIN=AMIN1(YMIN,Y(I))
   24 YMAX=AMAX1(YMAX,Y(I))
      GOTO 100
      ENTRY GMX(X,N)
      IF(IEN.NE.0) GOTO 100
      IF(IDX.EQ.0) XMIN=X(1)
      IF(IDX.EQ.0) XMAX=X(1)
      IDX=1
      DO 26 I=1,N
      XMIN=AMIN1(XMIN,X(I))
   26 XMAX=AMAX1(XMAX,X(I))
      GOTO 100
C
C     INCREASE COUNT IN BIN I/J
      ENTRY GCN(YI,XJ)
      IGT=1
      IF(IEN.EQ.0) GOTO 70
   30 GOTO 90
   32 LCN(4)=LR(1+J,62-I)
      IF(NCN.GT.36) NCN=0
      NCN=NCN+1
      IF(NCN.GT.36) NCN=36
      LR(1+J,62-I)=LCN(4)
      GOTO 100
C
C     INSERT NR
      ENTRY GNR(YI,XJ,NR)
      IGT=2
      IF(IEN.EQ.0) GOTO 70
   40 GOTO 90
   41 CALL ITODA(IABS(NR),R,-8)
      DO 48 K=1,8
      LR(1+J,62-I)=RL(9-K)
      J=J-1
      IF(J.GE.1) GOTO 44
   42 LR(2+J,62-I)=LIST(39)
      GOTO 100
   44 IF(RL(9-K).NE.LIST(41)) GOTO 46
      IF(NR.LT.0) LR(2+J,62-I)=LIST(38)
      GOTO 100
   46 IF(K.EQ.8) GOTO 42
   48 CONTINUE
      GOTO 100
C
C     INSERT TEXT
      ENTRY GTX(YI,XJ,TEXT)
      IGT=3
      IF(IEN.EQ.0) GOTO 70
   50 GOTO 90
   51 DO 52 K=1,120
      IF(TEXT(K).EQ.LIST(42)) GOTO 100
      IF(TEXT(K).EQ.LIST(41)) GOTO 53
      LCN(4)=TEXT(K)
      IF(NCN.GE.0.AND.NCN.LE.74) GOTO 100
      IF(NCN.GE.128.AND.NCN.LE.191) GOTO 100
   53 LR(1+J,62-I)=TEXT(K)
      J=J+1
      IF(J.GT.120) GOTO 100
   52 CONTINUE
      GOTO 100
C
C     INSERT POINTS
      ENTRY GPT(Y,X,N,IS)
      IF(N.LE.0) GOTO 100
      IGT=4
      ISYM=IS
      IF(OUT(ISYM+1,41)) GOTO 60
      LSYM=LIST(ISYM+1)
      GOTO 61
   60 LSYM=LISYM(1)
   61 IF(IEN.EQ.0) GOTO 70
      IF(N.EQ.1) GOTO 90
      IL=0
      DO 68 I=1,N
      II=1.0+60.0*(Y(I)-SYA)/(SYB-SYA)
      JJ=1.0+120.0*(X(I)-SXA)/(SXB-SXA)
      IF(OUT(II, 60)) GOTO 66
      IF(OUT(JJ,120)) GOTO 66
      LR(1+JJ,62-II)=LSYM
      IF(IL.EQ.0) GOTO 64
      F=(IL-II)**2+(JL-JJ)**2
      IF(F.LE.2.0) GOTO 64
      DT=1.0/SQRT(F)
      T=0.0
   62 YM=(1.0-T)*Y(I)+T*Y(I-1)
      XM=(1.0-T)*X(I)+T*X(I-1)
      IK=1.0+60.0*(YM-SYA)/(SYB-SYA)
      JK=1.0+120.0*(XM-SXA)/(SXB-SXA)
      LR(1+JK,62-IK)=LSYM
      T=T+DT
      IF(T.LT.1.0) GOTO 62
   64 IL=II
      JL=JJ
      GOTO 68
   66 IL=0
   68 CONTINUE
      GOTO 100
   69 LR(1+J,62-I)=LSYM
      GOTO 100
C
C     FIRST ENTRY

   70 IEN=1
      IF(IDY.EQ.0) GOTO 74
      IDY=0
      IF(YMIN.NE.YMAX) GOTO 72
      SYA=-1.0
      SYB=+1.0
      GOTO 74
   72 CALL XBINS(YMIN,YMAX,60,SYA,ST)
      SYB=SYA+60.0*ST
   74 IF(IDX.EQ.0) GOTO 78
      IDX=0
      IF(XMIN.NE.XMAX) GOTO 76
      SXA=-1.0
      SXB=+1.0
      GOTO 78
   76 CALL XBINS(XMIN,XMAX,120,SXA,ST)
      SXB=SXA+120.0*ST
   78 CONTINUE
C
C     CLEAR
   80 DO 81 J=1,62
      DO 81 I=1,31
   81 AR(I,J)=BLK
      DO 82 J=1,62
      LR(1,J)=LIST(19)
   82 LR(122,J)=LIST(19)
      DO 83 I=1,122
      LR(I,1)=LIST(38)
   83 LR(I,62)=LIST(38)
      DO 84 J=2,62,10
      LR(1,J)=LIST(37)
   84 LR(122,J)=LIST(37)
      DO 85 I=1,121,10
      LR(I,1)=LIST(37)
   85 LR(I,62)=LIST(37)
      LR(1,1)=LIST(37)
      LR(122,1)=LIST(37)
      LR(122,62)=LIST(37)
      GOTO (30,40,50,61),IGT
   86 IF(IT.LE.0) GOTO 100
      DO 88 I=1,6
   88 TEXTNR(I)=BLANK
      IT=0
      GOTO 100
C
C     GET I/J INDEX
   90 IF(IGT.NE.4) FE=YI
      IF(IGT.EQ.4) FE=Y(1)
      IF(OUT(NE,60)) GOTO 92
      I=NE
      GOTO 94
   92 I=1.0+60.0*(FE-SYA)/(SYB-SYA)
      IF(OUT(I,60)) GOTO 100
   94 IF(IGT.NE.4) FE=XJ
      IF(IGT.EQ.4) FE=X(1)
      IF(OUT(NE,120)) GOTO 96
      J=NE
      GOTO 98
   96 J=1.0+120.0*(FE-SXA)/(SXB-SXA)
      IF(OUT(J,120)) GOTO 100
   98 GOTO (32,41,51,69),IGT
  100 RETURN
  101 FORMAT(I1,10X,6(A8,2X),60A1/5X,A4)
  102 FORMAT(1X,A8,1X,30A4,A2)
  103 FORMAT(10X,     30A4,A2)
  104 FORMAT(5X,12(A8,2X),A4)
      END

C   20/12/85 807251626  MEMBER NAME  TRTEXT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRTEXT(IPPATR,IPP,XXX,YYY,SSS) 
C-----------------------------------------------------------------------
C
C     WRITE INFORMATION FROM BANK 'PATR' FOR ONE TRACK, GIVEN BY IPO,IPP
C     POSITION AND SIZE OF TEXT GIVEN BY XXX,YYY,SSS
C          J.OLSSON,  19.10.79           LAST CHANGE 28.01.80
C            LAST CHANGE 15.01.88  J. HAGEMANN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C
#include "cdata.for"
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON /CHEADR/ HEAD(108)
      COMMON /CJTRIG/ PI,TWOPI
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
     $,PMOM,PZ,PTRANS,RMS,NHTF,RAD,RAD1,THE,PHI,DUM(6),HSIGN,HDUM,NTRRES
     $,IW52
C
      DATA HBLANK/'  '/, HPLUS/'+ '/,HMINUS/'- '/
      DATA HPLCFT/'+¢'/, HMICFT/'-¢'/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      ITR   = IDATA(IPP + 1)
      IF(DSPDTL(14).AND.NTRRES.NE.ITR.AND.NTRRES.NE.0) GO TO 7722
      HSIGN = HBLANK
      RMS   = ADATA(IPP + 23)
      RMSZ  = ADATA(IPP + 32)
      NHTF  = IDATA(IPP + 24)
      NHTZ  = IDATA(IPP + 33)
      NBK   = IDATA(IPPATR-2)
      IF(NBK.EQ.12) RMS = RMS/NHTF
      LTR   = IDATA(IPPATR + 3)
      CALL MOMENT(IPP,PX,PY,PZ,PTRANS,PMOM,FI,THE)
      RAD = ADATA(IPP+25)
      IF( LTR .LT. 64 ) GOTO 641
         ICD = IDATA(IPP + 2)
         IRC  = -100
         IF( ICD .EQ. 301 ) ICD = 65536
         VERVAL = -100.0
         IF( LTR .GT. 62 ) VERVAL = ABS(ADATA(IPP+51))
         IF(TBIT(ICD,19) .AND. LTR.EQ.64 .AND. VERVAL.GT.0.01)
     &                     ICD = IBITON(ICD,15)
         IF( TBIT(ICD,15) .AND. LTR .GE. 64 ) IRC = IDATA(IPP + 62)
         IF(.NOT.TBIT(ICD,15) .OR. IRC.NE.0) GOTO 641
            HSIGN = HPLCFT
            IF(RAD*BKGAUS.LT.0.) HSIGN = HMICFT
            GOTO 642
 641  CONTINUE
         HSIGN = HPLUS
         IF(RAD*BKGAUS.LT.0.) HSIGN = HMINUS
 642  CONTINUE
C** WRITE OUT VALUES
      IF( .NOT. DSPDTL(13) ) GO TO 7544
      FI = FI*180./PI
      CALL CORE(HWORK,80)
      WRITE(cHWORK,221) ITR,HSIGN,RMS,NHTF,RMSZ,NHTZ,FI! PMF 17/11/99: UNIT=10 changed to cHWORK
221   FORMAT(I2,1X,A2,1X,F4.2,'/',I2,1X,F5.1,'/',I2,1X,F5.1)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
7722  YYY = YYY - 1.5*SSS*.75 !PMF 20/11/99: add factor .75
      IF(DSPDTL(14).AND.NTRRES.NE.ITR.AND.NTRRES.NE.0) GO TO 7723
      COSTH = COS(THE)
      CALL CORE(HWORK,80)
      WRITE(cHWORK,222) PMOM,PZ,PTRANS,COSTH ! PMF 17/11/99: UNIT=10 changed to cHWORK
222   FORMAT(F6.3,1X,F7.3,1X,F6.3,1X,F6.3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
7723  YYY = YYY - 2.*SSS*.75 !PMF 20/11/99: add factor .75
7544  RETURN
      END

C   26/09/79            MEMBER NAME  MUEVPR   (S)           FORTRAN
C   20/09/79 C9092101   MEMBER NAME  MUEVPR   (S)           FORTRAN
      SUBROUTINE MUEVPR(KEV,KRUN,KREC)
C
C-----------------------------------------------------------------------
C PRINTS OUT THE BANK MUEV IN AN INTELLIGIBLE FORM.
C
C INPUT VARIABLES...
C HMU/HDATA   THE RAW MU DATA.                  / THESE ARE OBTAINED BY
C LMU         THE LENGTH OF THE RAW DATA BANK.  / A CALL TO BOS.
C    THE NUMBERS KEV,KRUN,KREC ARE PRINTED AS PART OF THE TITLE.
C    THERE IS ONE OUTPUT WORD FOR EACH INPUT WORD.
C    IF THE STRING CANNOT BE RECOGNIZED THE TEN WORDS SPANNING THE
C    BAD WORD ARE PRINTED AND THE BANK IS DUMPED USING HPRS.
C        WARNING THIS CODE FREQUENTLY USES '+' FOR CARRIAGE CONTROL
C        I.E. NO ADVANCE,  SO THE NUMBER OF LINES SENT TO THE LINE
C        PRINTER(LINES LIMITED) IS LARGER THAN THE NUMBER SEEN ON
C        ON THE PRINTED OUTPUT.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
#include "cmubcs.for"
      DIMENSION HMU(1)
      EQUIVALENCE (HDATA(1),HMU(1))
      LOGICAL*1 CRCNTL, PLUS/'+'/, SPACE/' '/
      DATA IEOD/3840/
C
C START OF EXECUTABLE PROGRAM.
C SET UP LOOP TO FIND MU HIT DATA. (SKIP BANK DESCRIPTOR WORD)
      A=A
      IPMU = IDATA(IBLN('MUEV'))
      IF(IPMU.EQ.0) GOTO 91
      LMU = IDATA(IPMU)
      IP = IPMU*2 + 2
C  IP POINTS TO HALF WORD BEFORE FIRST MUON DATA WORD
C THERE ARE 2*LMU DATA WORDS, MUON DATA STARTS IN WORD 3
      IPLAST=2*LMU + 2*IPMU
      JCHAM = 0
C
C  WRITE OUT TITLE AND HEADINGS
      WRITE(6,130)KEV,KRUN,KREC
  130 FORMAT('0MUEVPR - EVENT',I4,'  RUN',I5,' REC',I5,'  ',10('****')
     1 / ' CRT  TREF',4('  CHM/H  TDR  TLG')    )
C
      GOTO 1001
C
C-----------------------------------------------------------------------
C START OF MAIN LOOP ---------------------------------------------------
C
C
 2000 CONTINUE
C  RETURN HERE AFTER PRINTING LAST CHAM/HIT TD TL
C  THE NEXT WORD COULD BE 'END OF DATA' OR 'NEXT CRATE'
C  OR 'NEXT CHAM/HIT'
      IP=IP+1
      IF(IP.GE.IPLAST) GOTO 200
      NW = HMU(IP)
C  TEST FOR END OF DATA(0F00)
      IF(NW.EQ.3840) GOTO 1003
C  TEST FOR NEXT CHAM/HIT WORD
      IF(NW.GE.4 .AND. NW.LE.2539 ) GOTO 1013
C  SO IT MUST BE THE NEXT CRATE
      GOTO 1002
C
C  OUTPUT THE END OF DATA WORD AFTER CHAMBER DATA
 1003 IF(NH.EQ.1)WRITE(6,121)IEOD
      IF(NH.EQ.2)WRITE(6,122)IEOD
      IF(NH.EQ.3)WRITE(6,123)IEOD
      IF(NH.EQ.4)WRITE(6,124)IEOD
  121 FORMAT('+',28X,I4,':')
  122 FORMAT('+',45X,I4,':')
  123 FORMAT('+',62X,I4,':')
  124 FORMAT('+',79X,I4,':')
      GOTO 1001
C
C  OUTPUT THE END OF DATA WORD  WHEN NO HITS IN THE CRATE
 1004 WRITE(6,105)IEOD
  105 FORMAT('+', 3X,I6,':')
      GOTO 1001
C
C  THIS IS THE ENTRY POINT, FIRST WORD SHOULD BE A CRATE WORD
 1001 IP=IP+1
      IF(IP.GE.IPLAST) GOTO 200
      NW = HMU(IP)
C TEST FOR VALID CRATE NUMBER
 1002 ICRATE = NW - 3840
      IF( ICRATE.LT.1 .OR. ICRATE.GT.14 )  GOTO 901
      WRITE(6,101) ICRATE
  101 FORMAT(' ',I3)
      CRCNTL = PLUS
C
C  NEXT WORD MUST BE END OF DATA OR THE TIME REF FOR THE CRATE
C  BUT THE TIME REF COULD BE ABSENT IF THERE ARE NO HITS
      IP=IP+1
      NW = HMU(IP)
      IF(NW.EQ.3840) GOTO 1004
      IREF = NW - 3584
C TEST FOR VALID TIME REF
      LOGICAL TIMREF
      TIMREF = IREF.GE.0 .AND. IREF.LE.255
      IF(.NOT.TIMREF)IP=IP-1
      IF(TIMREF)WRITE(6,102)IREF
  102 FORMAT('+',3X,I6)
C
C  NEXT WORD MUST BE A CHAMBER/HIT WORD
 1012 IP=IP+1
      IF(IP.GE.IPLAST) GOTO 200
      NW = HMU(IP)
 1013 ICHAM = NW/4
C CHECK IS A VALID CHAMBER NUMBER
      IF( ICHAM.LT.1 .OR. ICHAM.GT.634 ) GOTO 904
      IHIT = NW - 4*ICHAM + 1
C IHIT IS BY DEFINITION IN THE RANGE 1 - 4
C TEST IF SAME OR NEW CHAMBER
      LOGICAL SAMCHM
      SAMCHM = ICHAM.EQ.JCHAM
      IF(.NOT.SAMCHM) NH = 0
      JCHAM = ICHAM
C
C  NEXT TWO WORDS ARE TD & TL  OR  SCALER COUNTS AND TIME
      NH = NH + 1
      IP=IP+1
      IITD = HMU(IP)
      IP=IP+1
      IITL = HMU(IP)
      IF(NH.EQ.1)WRITE(6,111)CRCNTL,ICHAM,IHIT,IITD,IITL
      IF(NH.EQ.2)WRITE(6,112)ICHAM,IHIT,IITD,IITL
      IF(NH.EQ.3)WRITE(6,113)ICHAM,IHIT,IITD,IITL
      IF(NH.EQ.4)WRITE(6,114)ICHAM,IHIT,IITD,IITL
      IF(NH.LT.1.OR.NH.GT.4) GOTO 916
      CRCNTL = SPACE
  111 FORMAT( A1,  9X, I5,'/',I1,I5,I5 )
  112 FORMAT('+', 26X, I5,'/',I1,I5,I5 )
  113 FORMAT('+', 43X, I5,'/',I1,I5,I5 )
  114 FORMAT('+', 60X, I5,'/',I1,I5,I5 )
      GOTO 2000
C
C END OF MAIN LOOP -----------------------------------------------------
C-----------------------------------------------------------------------
C
C CHECK THE POSITION OF THE POINTER WHEN EXIT FROM THE LOOP
  200 IF(IP.EQ.IPLAST+1) GOTO 201
      IF(IP.NE.IPLAST) GOTO 911
      IF( HMU(IP).EQ.0 ) GOTO 201
      IF( HMU(IP).EQ.3840 ) GOTO 1003
      GOTO 911
C
C ERROR, HAVE TO GIVE UP AND CALL HPRS.
C  901 CRATE OUT OF RANGE
C  904 CHAMBER OUT OF RANGE
C  911 LENGTH ERROR
C  916 INVALID COUNT OF HITS
  916 CONTINUE
  901 CONTINUE
  904 CONTINUE
  911 CONTINUE
      I1 = IP - 5
      I2 = I1 + 9
      IP = IP - 2*IPMU - 2
      WRITE(6,120)IP, (HMU(I),I=I1,I2)
  120 FORMAT(' MUEVPR - ERROR AT WORD',I3,'       ****',
     *   /' ',10X, 10I6 , '  GIVE UP AND CALL HPRS' )
      CALL HPRS('MUEV',0)
      GO TO 201
C
C  MUEV BANK NOT PRESENT
   91 WRITE(6,160) KEV, KRUN, KREC
  160 FORMAT(' MUEVPR - EVNT',I4,'  RUN',I4,'  REC',I4,
     1   '  ----MUEV BANK MISSING----' )
      GOTO 201
C
  201 RETURN
      END

C   19/02/84 712202038  MEMBER NAME  EVREAD   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EVREAD( NUNIT, IRET )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON PREHISTORY :  READ A JADE EVENT FROM NUNIT
C             E. ELSEN
C
C        MOD: C. BOWDERY  12/12/83 :  JUSCRN = 6 IF NOT SET | CALL MUREG
C        MOD: C. BOWDERY  08/02/84 :  MACRO CADMIN NOW ON PATRECSR
C                                  :  BLOCKDATA SET IN JADEBD
C                                  :  EXTRA ERROR MESSAGES AND TIDY-UP
C        MOD: C. BOWDERY  13/02/84 :  NRECS COUNTS LOGICAL RECORDS NOW
C NEW VERSION C. BOWDERY  16/02/84 :  CODE RE-WRITTEN
C        MOD: C. BOWDERY  20/02/84 :  SET NFLAGS(8) IF CONSTANTS FOUND
C        MOD: C. BOWDERY  14/09/84 :  REAL DATA AFTER MC - BUG KILLED
C
C  LAST  MOD: J. OLSSON  06/12/87  :  INFO PRINT IN MC EVENTS
C
C  Last mod:
C   P. Movilla Fernandez 12/06/00  : Introduce a smearing veto for MC events
C                   
C
C-----------------------------------------------------------------------
C
C     GENERAL READ ROUTINE FOR REAL AND MONTE CARLO DATA. DATA  HAVE  TO
C     BE IN JADE BOS FORMAT AND ARE READ INTO COMMON /CBS/
C
C     IF MONTE CARLO, SMEARING IS AUTOMATICALLY  INVOKED  IF  PREVIOUSLY
C     UNSMEARED; ALREADY SMEARED MC DATA ARE TREATED AS  REAL  DATA.  IF
C     DATA ARE  PRECEDED  BY  CONSTANTS  RECORDS,  THESE  CONSTANTS  ARE
C     AUTOMATICALLY FED INTO CORRESPONDING COMMONS.
C
C     IRET = 2 IF END OF FILE ENCOUNTERED, OTHERWISE 0.
C
C     READ ERRORS ARE NOT RETURNED, PROGRAM STOPS AFTER 10 READ ERRORS.
C
C     THREE EVENT TYPES ARE DISTINGUISHED, CHARACTERIZED BY VARIABLE
C     IEVTP IN COMMON /CADMIN/ :
C
C               IEVTP = 0           REAL DATA
C               IEVTP = 1           UNSMEARED MONTE CARLO DATA
C               IEVTP = 2           SMEARED MONTE CARLO DATA
C
C     FOR ALL MONTE CARLO DATA (IEVTP = 1 OR 2), THE PROGRAM EXPECTS TWO
C     CONSTANTS RECORDS TO PRECEDE THE DATA.
C
C     LBREAD(1) =  .TRUE. :  ID CALIB. RECORD ('MTCO') HAS BEEN READ,
C     LBREAD(2) =  .TRUE. :  MU CALIB. RECORD ('MUCO') HAS BEEN READ.
C     LBREAD(3) =  .TRUE. :  BOTH CALIB RECORDS HAVE BEEN READ, OR IF
C                                           REAL DATA ARE BEING READ
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C                                      JADE BLOCK DATA
      EXTERNAL JADEBD
C
      LOGICAL FLG100
C
#include "cadmin.for"
#include "cgraph.for"
#include "cdata.for"
C
C                            NFLAGS(5) IN /CADMIN/ COUNTS RECORDS READ
C                            NFLAGS(8) SET WHEN CONSTANTS HAVE BEEN READ
C
      EQUIVALENCE (NRECS , NFLAGS(5) )
C
      DATA IPRCL /0/
*** PMF 14/06/00:
* Introduce a MC smearing veto when reading MC events.
      LOGICAL NOSMEAR
      COMMON /CMCSMEAR/ NOSMEAR
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      IF( JUSCRN .LE. 0  .OR. JUSCRN .GT. 99 ) JUSCRN = 6
C
      IRET  = 0
      IHEAD = IBLN('HEAD')
      IMTCO = IBLN('MTCO')
      IMUCO = IBLN('MUCO')
C                                            CADMIN FLAG
      FLG100 = .FALSE.
      IF( IFLG .EQ. 100 ) FLG100 = .TRUE.
      IF( FLG100 ) GO TO 1
C
C                            MAIN READ STATEMENT.
C
 1000 CALL BSLT
      CALL BDLG
      NRECS = NRECS + 1
      CALL BREAD(NUNIT,&60,&70)
      CALL USER(20)              ! PMF 07/07/99 added for additional checks
                                !     14/06/00 set MC smearing veto in user routine
C
C                            DO WE HAVE A 'HEAD' BANK I.E. AN EVENT ?
C                            IF NOT THEN SKIP NEXT SECTION
C
   1  IF( IDATA(IHEAD) .LE. 0 ) GO TO 10
        IHD  = IDATA( IHEAD )
        IRUN = HDATA( IHD*2 + 10 )
C
C                            IS IT LEGAL HERE ?
C
        IF( FLG100  .OR. LBREAD(3) )    GO TO 2
        IF( .NOT. ( LBREAD(1) .AND. .NOT. LBREAD(2) ) ) GO TO 3
C
C                            BANK 'MTCO' WAS LAST SO THIS OUGHT TO BE
C                            A RECORD WITH 'MUCO' NOT 'HEAD'
C
          WRITE(JUSCRN,69) NRECS
  69      FORMAT(/' *****  ERROR  *****  EVREAD DETECTED BAD DATA',
     +            ' STRUCTURE AT INPUT RECORD: ',I6//
     +            ' EVENT RECORD FOUND AFTER ''MTCO'' BANK RECORD.',
     +            ' EVREAD EXPECTED A RECORD WITH A ''MUCO'' BANK.'/
     +            ' I.E. MU CONSTANTS RECORDS DID NOT FOLLOW ID',
     +            ' CONSTANTS. MUON COMMONS NOT FILLED !!!')
          WRITE(JUSCRN,42)
          LBREAD(2) = .TRUE.
          LBREAD(3) = .TRUE.
C
C                            RECOVER FROM THIS ERROR
C
          GO TO 2
C
C                            MONTE CARLO DATA WITHOUT CALIBRATION
C                            FAKING REAL DATA? PRINT WARNING AND STOP
C
   3      IF( IRUN .GE. 100 ) GO TO 5
C
            WRITE(JUSCRN,44) NRECS
  44        FORMAT(/' *****  ERROR  *****  EVREAD DETECTED BAD DATA',
     +              ' STRUCTURE AT INPUT RECORD: ',I6//
     +              ' RUN NUMBER INDICATED MONTE CARLO DATA BUT NO',
     +              ' CALIBRATION RECORDS WERE FOUND.')
C
            WRITE(JUSCRN,42)
            WRITE(JUSCRN,43)
C
            CALL BSTA
            STOP 888
C
C                            SET FLAGS TO INDICATE REAL DATA DETECTED
C
  5     LBREAD(3) = .TRUE.
        IEVTP     = 0
C
C                            WE HAVE AN EVENT. COUNT IT. IF UNSMEARED
C                            MONTE CARLO, CALL SMEARING ROUTINES.
C                            CHECK RUN NUMBER BEFORE EVENT TYPE IN CASE
C                            REAL DATA EVENTS FOLLOW MC EVENTS.
C
  2     NRREAD = NRREAD + 1
        IF( IRUN .GE. 100 ) IEVTP = 0
        IF( IEVTP .EQ. 1 .and. .not. nosmear) CALL RDJETC ! PMF 14/06/00: MC smearing veto introduced
C
C PRINT INFO FOR FIRST MONTE CARLO EVENT
C
        IF(IPRCL.NE.0.OR.IEVTP.EQ.0) RETURN
        IPRCL = IPRCL + 1
        ITRKGM = HDATA(IHD*2+16)
        ILEADG = HDATA(IHD*2+17)
        ISF5F6 = HDATA(IHD*2+14)
        IELOSS = HDATA(IHD*2+18)
C
        IF(ITRKGM.EQ.0) WRITE(6,1451)
1451  FORMAT(' ## EVREAD --->>    TRKGAM WITH ERRORS BEFORE JCN 87 ')
        IF(ITRKGM.EQ.1) WRITE(6,1452)
1452  FORMAT(' ## EVREAD --->>    TRKGAM CORRECTED ACC. TO JCN 87 ')
        IF(ILEADG.EQ.0.AND.ITRKGM.NE.0) WRITE(6,1453)
1453  FORMAT(' ## EVREAD --->>    STANDARD 1-DIM LEAD GLASS TRACKING')
        IF(ILEADG.EQ.1) WRITE(6,1454)
1454  FORMAT(' ## EVREAD --->>    MEIER-MAGNUSSEN LEAD GLASS TRACKING')
        IF(ILEADG.EQ.2) WRITE(6,1455)
1455  FORMAT(' ## EVREAD --->>    TOKYO SHOWER LEAD GLASS TRACKING')
        IF(ILEADG.EQ.2) WRITE(6,1456) ISF5F6
1456  FORMAT('           --->>    WITH VERSION NUMBER ',I4)
        IF(IELOSS.NE.0) WRITE(6,1457)
1457  FORMAT(' ## EVREAD --->>    MULTIPLE SCATTERING AND ENERGY LOSS WA
     $S DISABLED IN TRACKING')
C
        RETURN
C
C                            DO WE HAVE AN 'MTCO' BANK RECORD? IF SO
C                            CHECK THAT THE LAST RECORD WAS NOT 'MTCO'
C                            OR 'MUCO', THEN SET FLAGS AND PROCESS BANK.
C
  10  IF( IDATA(IMTCO) .LE. 0 ) GO TO 20
        IF( FLG100 .OR. LBREAD(3) .OR. NRECS .EQ. 1 ) GO TO 11
C
          IF( LBREAD(1) .AND. .NOT. LBREAD(2) ) WRITE(JUSCRN,12) NRECS
C
          IF( LBREAD(2) .AND. .NOT. LBREAD(1) ) WRITE(JUSCRN,13) NRECS
C
  12      FORMAT(/' *****  ERROR  *****  EVREAD DETECTED BAD DATA',
     +            ' STRUCTURE AT INPUT RECORD: ',I6//
     +            ' THIS RECORD CONTAINED AN ''MTCO'' BANK',
     +            ' BUT SO DID THE PREVIOUS RECORD.',
     +            ' THE NEW CONSTANTS WILL REPLACE THE OLD ONES.')
C
  13      FORMAT(/' *****  ERROR  *****  EVREAD DETECTED BAD DATA',
     +            ' STRUCTURE AT INPUT RECORD: ',I6//
     +            ' THIS RECORD CONTAINED AN ''MTCO'' BANK BUT THE',
     +            ' PREVIOUS RECORD HAD A ''MUCO'' BANK.'/
     +            ' THUS THERE WERE CALIBRATION CONSTANTS BUT NO',
     +            ' EVENTS. HOWEVER THE NEW ''MTCO'' WILL BE ACCEPTED.')
C
          WRITE(JUSCRN,42)
C
  11    LBREAD(1) = .TRUE.
        LBREAD(2) = .FALSE.
        LBREAD(3) = .FALSE.
C
C                            PROCESS 'MTCO' BANK.
C
C                            SET NFLAGS(8) TO TELL EVWRIT THAT NEW
C                            CONSTANTS HAVE BEEN FOUND.
C
        IEVTP     = 1
        NFLAGS(8) = 1
        IPMTCO    = IDATA(IMTCO)
C
C                            IS THIS A SMEARED MC EVENT?
C
        IF( IDATA(IPMTCO+1) .NE. 0 ) IEVTP = 2
C
        WRITE(JUSCRN,14) IEVTP,IDATA(IPMTCO+2)
  14    FORMAT(/' ---> EVREAD READ A TYPE  ',I1,
     +          '  MONTE CARLO EVENT WITH IFLAG2 = ',I4/)
C
C                            COPY THE CALIBRATION CONSTANTS INTO COMMON
C
        CALL RDMTCO( 'DE' )
C
        GO TO 1000
C
C                            DO WE HAVE AN 'MUCO' BANK RECORD? THIS IS
C                            ONLY LEGAL AFTER AN 'MTCO' BANK RECORD.
C
 20   IF( IDATA(IMUCO) .LE. 0 ) GO TO 30
C
        IF( FLG100 ) GO TO 21
        IF( LBREAD(1) .AND. .NOT. LBREAD(2) ) GO TO 21
          WRITE(JUSCRN,22) NRECS
C
  22      FORMAT(/' *****  ERROR  *****  EVREAD DETECTED BAD DATA',
     +            ' STRUCTURE AT INPUT RECORD: ',I6//
     +            ' THIS RECORD CONTAINED A ''MUCO'' BANK WITH MUON',
     +            ' CONSTANTS BUT THE PREVIOUS RECORD DID NOT HAVE AN',
     +            ' ''MTCO'' BANK WITH ID CONSTANTS.')
C
          WRITE(JUSCRN,42)
          WRITE(JUSCRN,43)
          CALL BSTA
          STOP 666
C
C                            PROCESS 'MUCO' AND OTHER MUON BANKS
C                            TRANSFER MUON CALIBRATION TO /CALIBR/
C                            EXTRACT MUON REGIONS FROM THE CALIBRATION
C
  21    CALL MUCON
        CALL MUREG(0)
        LBREAD(2) = .TRUE.
        LBREAD(3) = .TRUE.
        GO TO 1000
C
  30  WRITE(JUSCRN,31) NRECS
  31  FORMAT(/' *****  ERROR  *****  EVREAD DETECTED BAD DATA',
     +        ' STRUCTURE AT INPUT RECORD: ',I6//
     +        ' THIS RECORD WAS NOT EXPECTED. IT DID NOT HAVE',
     +        ' A ''HEAD'' BANK OR AN ''MTCO'' (M.C. CONSTANTS)',
     +        ' BANK (BOTH OF WHICH WOULD BE LEGAL HERE).'/
     +        ' ALSO IT DID NOT HAVE A ''MUCO'' BANK WHICH WOULD HAVE',
     +        ' BEEN ILLEGAL ANYWAY. BOS BANK NAMES WILL BE PRINTED.')
C
      WRITE(JUSCRN,42)
C
C                            PRINT LIST OF BANKS IN THIS EVENTS
C
      CALL EVBKPR(IDUM)
      WRITE(JUSCRN,32)
  32  FORMAT(/' RECOVERY ACTION:  RECORD WILL BE SKIPPED AND COUNTED',
     +        ' AS A READ ERROR.'/)
C
      NRERR  = NRERR  + 1
      NRREAD = NRREAD + 1
      GO TO 63
C
C                            READ ERROR
C
  60  NRERR  = NRERR  + 1
      NRREAD = NRREAD + 1
      WRITE (JUSCRN,61) NRERR, NRECS
  61  FORMAT(/' *****  ERROR  *****  EVREAD ENCOUNTERED BOS READ ERROR'
     +      //' OCCURRENCE NO. ',I2,'.  SEQUENTIAL RECORD NO. ',I8,
     +        '.   EVENT/RECORD SKIPPED.'//)
C
  63  IF( NRERR .LT. 10 ) GO TO 1000
C
C                            TOO MANY READ ERRORS
C
      WRITE(JUSCRN,64) NRREAD, NRWRIT, NRERR
  64  FORMAT(//' *****  TOO MANY READ ERRORS  *****  FOUND BY EVREAD'//
     +       '   NR OF EVENTS READ: ',I6,'   NR OF EVENTS WRITTEN: ',I6,
     +       '   NR OF READ ERRORS: ',I3//)
      WRITE(JUSCRN,43)
      CALL BSTA
      STOP 777
C
C                            END-OF-FILE
C
  70  IF( LBREAD(3) ) GO TO 99
C
C                            NOT EXPECTED
C
      IF( NRECS .GT. 1 ) GO TO 95
        WRITE(JUSCRN,96)
  96    FORMAT(/' *****  WARNING  *****  EVREAD ANOMALOUS CONDITION'//
     +          ' THE INPUT EVENT DATASET IS EMPTY.')
        GO TO 94
C
  95    WRITE(JUSCRN,97) NRECS
  97    FORMAT(/' *****  WARNING  *****  EVREAD ANOMALOUS CONDITION',
     +          ' AT INPUT RECORD: ',I6//
     +          ' EOF ENCOUNTERED BEFORE ALL M.C. CONSTANTS READ')
C
  94  WRITE(JUSCRN,42)
      WRITE(JUSCRN,43)
      CALL BSTA
      STOP 999
C
  99  IRET = 2
      RETURN
C
C                            FORMAT STATEMENTS USED IN SEVERAL PLACES
C
  42  FORMAT( ' WERE THESE EVENTS WRITTEN CORRECTLY?  DID YOU USE S/R',
     +        ' EVWRIT?  IT ENSURES CORRECT STRUCTURE AUTOMATICALLY.'/)
  43  FORMAT( ' PROGRAM WILL STOP AFTER BOS STATISTICS PRINTOUT.'//)
C
      END

C   28/10/81 202121751  MEMBER NAME  DRTRCK   (JADESR)      FORTRAN
      SUBROUTINE DRTRCK(IPTR,XO,YO,DR)
C
C     CALCULATION : DR = DISTANCE (XO,YO)-TRACK(IPTR)
C                        +VE IF OUTSIDE CIRCLE
C                        -VE IF INSIDE CIRCLE
C     P. STEFFEN  10.2.82
C
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
      REAL*8 XC,YC,RC
C
C                                       CURVATURE + RADIUS OF TRACK
C                                       1. POINT + DIRECTION
      X1    = ADATA(IPTR+ 5)
      Y1    = ADATA(IPTR+ 6)
      DRI   = SQRT(ADATA(IPTR+8)**2 + ADATA(IPTR+9)**2)
      DX1   = ADATA(IPTR+8) / DRI
      DY1   = ADATA(IPTR+9) / DRI
      CRV   = ADATA(IPTR+25)
C     PRINT 2001, X1,Y1,DX1,DY1,CRV,XO,YO
C2001 FORMAT(' DRTRCK     :',10F10.5)
C
C                                       MOMENTUM > 1.7 GEV ?
      IF(ABS(CRV).LT..00010) GOTO 200
C     IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
C
C                                       CIRCLE EXTRAPOLATION
         RC    = 1. / CRV
         XC    = DY1*RC + X1
         YC    =-DX1*RC + Y1
         RC    = DABS(RC)
         DR    = ( ( (XO-XC)**2+(YO-YC)**2 ) / RC - RC) *.5
C     PRINT 2003, CRV,XC,YC,RC,DR
C2003 FORMAT(' DRTRCK(CIR):',10E13.5)
         RETURN
C
C                                       PARABOLA EXTRAPOLATION
  200 CONTINUE
         DRP =-((XO-X1)*DX1 + (YO-Y1)*DY1)**2 * CRV * .5
         DRO = (YO-Y1)*DX1 - (XO-X1)*DY1
         DR  = (DRO - DRP) * SIGN(1.,CRV)
C     PRINT 2002, CRV,DRP,DRO,DR
C2002 FORMAT(' DRTRCK(PAR):',11F10.5)
         RETURN
C
      END

C   02/06/80 104011142  MEMBER NAME  MUR2DS   (JADEGS)      FORTRAN
      SUBROUTINE MUR2DS
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
      CALL RSDISP(LASTVW)
      IF(LASTVW.EQ.13) CALL YAMADA(0)
      IF(DSPDTL(17).AND.(LASTVW.LT.4.OR.LASTVW.EQ.14))
     $ CALL PROJEC(LASTVW)
      RETURN
      END

      REAL FUNCTION PARKOR*8(IP) 
C COPIED AND RENAMED FROM F22KLE.JVTXC.S(PARCOR)   18.9.1986
C
C     IP : POINTER TO TRACK IN PATR-BANK
C
C     CURVATURE-CORRECTION FOR CIRCLES FITTED WITH A PARABOLA
C
C PMF 03.11.98 
      LOGICAL TBIT
      REAL*8 P,Q,R,CM,D,U,V,C
C
      INTEGER*2 HDATA
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C *** MEASURED CURVATURE
      CM = -ADATA(IP+22)
      C  =  ADATA(IP+25) * 0.5
      IF (IDATA(IP+18).NE.2) GOTO 100
C *** MEASURED PROJ. TRACKLENGTH
      R  = ABS( ( ADATA(IP+7) - ADATA(IP+14) ) / ADATA(IP+30) ) * 0.5
C
C     CARDANS RULE
C
      P =  7.D0/(18.D0*R*R)
      Q = -7.D0*CM/(12.D0*R*R)
C
      D = DSQRT(Q*Q+P*P*P)
      U = (-Q+D)**(1./3.)
      V = ( Q+D)**(1./3.)
      C = U-V
C
  100 CONTINUE
      PARKOR = C * 2.0D0
C
      RETURN
      END

C   12/03/84 504301316  MEMBER NAME  TAGCOL   (S)           FORTRAN
C
C
C
      SUBROUTINE TAGCOL(IM,IP,THETA)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE CALCULATES THE ANGLE BETWEEN A CLUSTER IN - Z TAGGER
C AND ONE IN + Z TAGGER
C
C IM - INPUT - POINTER TO CLUSTER IN - Z PART OF ATAGG2
C IP - INPUT - POINTER TO CLUSTER IN + Z PART OF ATAGG2
C
C THETA - OUTPUT - ANGLE BETWEEN THEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IMPLICIT INTEGER * 2 (H)
C   12/03/84 412041226  MEMBER NAME  CTAGGO   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C HERE ARE THE COMMONS THAT EVENTUALLY BECOME THE TP BANKS ACCLS -
C TAGG/O ,1,2,3
C CONVENTION IN NAMING -
C
C FIRST LETTER -
C         C - NAME OF COMMON
C         H - NAME OF VARIABLES *2 TYPE      INTEGER
C         I -   "       "       *4 TYPE         "
C         A -   "       "                    REAL
C
C REST OF NAME AS FOR TAGG BANKS SEE JADE COMPUTER NOTE 16 FOR MORE DETA
C
C ACTUALLY ALL THIS COULD ALSO GO IN WORKSPACE BUT I CANT BE BOTHERED!
C
C**** IMPORTANT :  IF YOU CHANGE THE SIZE OF THESE COMMONS PLEASE
C                  REMEMBER TO CHANGE 'TAGINT' WHICH CLEARS THEM.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      COMMON / CACLS  / HID1,HID2,HIPM,HIPZ,HDUM,HIPL,HDUMM1(134)
      DIMENSION HACLS(140)
      EQUIVALENCE ( HACLS(1) , HID1 )
C
      COMMON / CTAGG0 / HID3,HID4,HTRACK,HTRZMI,HTRZPL,HCLST,
     *                  HCLZMI,HCLZPL,HNEUT,HCOL,HTYPE,HER,HCORR,
     *                  HPBLAT,HDUM1,HDUM2,HSCAL(36),HWPCL,HWPTR,
     *                  HDUMM2(14)
      DIMENSION     ATAGG0(34)
      EQUIVALENCE ( HID3 , ATAGG0(1) )
C
      COMMON / CTAGG1 / HMAP(2,20)
C
      COMMON / CTAGG2 / ATAGG2(260)
      DIMENSION         ITAGG2(260)
      INTEGER*2         HTAGG2(520)
      EQUIVALENCE ( HTAGG2(1) , ITAGG2(1) , ATAGG2(1) )
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       DATA NPRNT / 0 /
C
C------------------- C O D E -------------------------------------------
C
C
C                                   CALCULATE POINTERS
C
      IBM = (IM - 1) * HWPCL
      IBP = (IP - 1) * HWPCL
C
C                                   FETCH DIRECTION COSINES
C
      AMDX = ATAGG2(IBM + 11)
      AMDY = ATAGG2(IBM + 12)
      AMDZ = ATAGG2(IBM + 13)
      APDX = ATAGG2(IBP + 11)
      APDY = ATAGG2(IBP + 12)
      APDZ = ATAGG2(IBP + 13)
C
C                                   CHECK FOR ERROR
C
       AAMDX = ABS( AMDX )
       AAMDY = ABS( AMDY )
       AAMDZ = ABS( AMDZ )
       AAPDX = ABS( APDX )
       AAPDY = ABS( APDY )
       AAPDZ = ABS( APDZ )
C
       IF (( AAMDX .GT. 1.0E-20).AND.(AAMDX.LT.1.0E+20).AND.
     *     ( AAMDY .GT. 1.0E-20).AND.(AAMDY.LT.1.0E+20).AND.
     *     ( AAMDZ .GT. 1.0E-20).AND.(AAMDZ.LT.1.0E+20).AND.
     *     ( AAPDX .GT. 1.0E-20).AND.(AAPDX.LT.1.0E+20).AND.
     *     ( AAPDY .GT. 1.0E-20).AND.(AAPDY.LT.1.0E+20).AND.
     *     ( AAPDZ .GT. 1.0E-20).AND.(AAPDZ.LT.1.0E+20)  ) GOTO 10
       NPRNT = NPRNT + 1
       IF ( NPRNT .LT. 100 )
     * WRITE(6,11) IM,IP,IBM,IBP,HWPCL,AMDX,AMDY,AMDZ,APDX,APDY,APDZ
   11  FORMAT(' ++++ TAGCOL ERROR ',4I3,I5,2X,6(E12.4,1X))
       THETA = 0.0
       RETURN
   10  CONTINUE
C
C                                   CALCULATE THETA
C
      ARG1  =     ( AMDX * APDX  +  AMDY * APDY  +  AMDZ * APDZ )
      IF ( ABS(ARG1) .LE. 1.0 ) GOTO 20
       NPRNT = NPRNT + 1
       IF ( NPRNT .LT. 100 )
     * WRITE(6,11) IM,IP,IBM,IBP,HWPCL,AMDX,AMDY,AMDZ,APDX,APDY,APDZ
       THETA = 0.0
       RETURN
   20  CONTINUE
      THETA = ACOS( ARG1 )
      RETURN
      END

C   04/06/81 106211108  MEMBER NAME  ANGBARSP (SOURCE)      FORTRAN
      SUBROUTINE ANGBAR(ENERGY,ANGLE,FACT,*)
C     ANGLE DEPENDENCE FOR BARREL COUNTERS
C     ENERGY   INPUT ENERGY IN GEV
C     ANGLE    INCIDENT ANGLE IN DEG
C     FACT     CORRECTION FACTOR   FACT=EOBS/EINC
C                        WRITTEN BY H.TAKEDA  15/02/80
C                        TYPED BY Y.WATANABE  19/02/80
C          SPECIAL VERSION FOR OLSSON         04/06/81
C             INCLUDE THE ENERGY CORRECTION OF J.N.73.
      DIMENSION BANG(8),BENG(3),COR(8,3)
      DATA BANG/0.,10.,20.,30.,40.,50.,60.,180./
      DATA BENG/0.,1.,5./
      DATA COR /8*1.,
     1          1., 0.976, 0.938, 0.932, 0.930, 3*0.929,
     1          1., 0.996, 0.962, 0.932, 0.914, 0.906, 2*0.904/
      DATA IERR1,IERR2,IERCNT/0,0,5/
      FACT=1.
C         CHECK FOR BAD INPUTS
      IF(ENERGY.GT.0.) GO TO 10
      IERR1=IERR1+1
      IF(IERR1.GT.IERCNT) RETURN1
      WRITE(6,600) ENERGY
600   FORMAT('0 **NEG. ENERGY INTO LGECOR(ANGBAR) E=',F10.3)
      RETURN1
C
10    IF(ANGLE.GE.0. .AND. ANGLE.LE.180.) GO TO 20
      IERR2=IERR2+1
      IF(IERR2.GT.IERCNT) RETURN1
      WRITE(6,610) ANGLE
610   FORMAT('0 **BAD ANGLE INTO LGECOR(ANGBAR) ANGLE=',F10.3)
      RETURN1
20    J=ANGLE/10.+2
      IF(J.GT.8) J=8
      APORT=(ANGLE -BANG(J-1))/(BANG(J)-BANG(J-1))
C
      IF(ENERGY.GT.5.) GO TO 30
      I=2
      IF(ENERGY.GT.1.) I=3
      EPORT=(ENERGY-BENG(I-1))/(BENG(I)-BENG(I-1))
C
      FACT1=COR(J-1,I-1)+EPORT*(COR(J-1,I)-COR(J-1,I-1))
      FACT2=COR(J  ,I-1)+EPORT*(COR(J  ,I)-COR(J  ,I-1))
      GO TO 40
30    FACT1=COR(J-1,3)
      FACT2=COR(J,3)
C
40    FACT=FACT1+APORT*(FACT2-FACT1)
      IF(ENERGY.LT.2.0) FACT=FACT*(1.-0.846/EXP(4.27*ENERGY))
C        SPECIAL LOW ENERGY CORRECTION BASED ON J.N. 73.
      RETURN
      END

C   10/08/87 805171201  MEMBER NAME  EALGCL   (S)           FORTRAN77
      SUBROUTINE EALGCL( JTRK, ESHM )
C-----------------------------------------------------------
C  Version of 14/08/87     E Elsen
C  Record of changes:
C  16/5/88   EE  Cosmetics for NEICL init, commenting
C  13/5/88   MZ  NEICL init
C
C  PROPAGATE PARTICLE JTRK INTO LG USING TRKBL9
C  MARK HIT BLOCKS IN MEICL.
C  ADD BLOCKS CLOSE TO TRACK USING SHADO9
C  PERFORM LGANAL AND LGCLUS ON THESE BLOCKS
C  RESULTING OUTPUT BANKS ARE ALSA AND LGSA, WHICH ARE
C  THE EQUIVALENTS OF ALGN AND LGCL
C  ADAPTED FROM F11HEL.NEUFS(PBEN9)
C  INPUT:
C     JTRK   TRACK NUMBER
C  OUTPUT:
C     ESHM  CORRECTED CLUSTER ENERGY
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C--------- START KHH COMMONS -------------------------------------
C
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
      DIMENSION IRKL(2,50)
      EQUIVALENCE(IRKL(1,1),TRKL(1,1))
      DIMENSION WIDTH(5)
      DATA WIDTH / 0.5 , 0.5 , 0.5 ,0.5 , 0.5 /
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      LOGICAL FIRST / .TRUE. /
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IPALGN = IBLN('ALGN')
        IPPATR = IBLN('PATR')
        IPALZW = IBLN('ALZW')
        IPLGCL = IBLN('LGCL')
      ENDIF
C
      NCLU = -1
      NBLO = -1
      ESHM = -1.
      NPPATR = IW(IPPATR)
      NPALGN = IW(IPALGN)
      IF( NPPATR .GT. 0 ) THEN
        IP = NPPATR + IW(NPPATR+1) + IW(NPPATR+3)*(JTRK-1)
        ILIPS = 1
        CALL TRKBL9( IP, NPALGN, ITER1, ITER2, ILIPS )
        IF( IBLCHK .NE. 1 ) THEN
          CALL SHADO9( WIDTH, ILIPS )
          EBITER = EBITER + ENEW
C                                           FILL BLOCKS BELONGING TO
C                                           CLUSTER INTO MEICL, FOUND
C                                           BOTH IN TRKBL9 AND SHADO9
          NBLO = 0
          DO 100 I=1,NBLK
  100     MEICL(I) = IRKL(1,I)
          NBLO = NBLK
          DO 200 I=1,NNEW
  200     MEICL(NBLO+I) = NLIST(I)
          NBLO = NBLO + NNEW
C                                           INIT TO ZERO ENERGY
          DO 210 I=1,NBLO
  210     NEICL(I) = 0
C                                           RENAME STANDARD ALGN, LGCL
          CALL BRNM( 'ALGN', 1, 'ALZW', 2 )
          CALL BRNM( 'LGCL', 1, 'LGZW', 2 )
C                                           CREATE NEW ALGN, FULL LENGTH
          NPALZW = IW(IPALZW)
          NWA = IW(NPALZW)
          CALL CCRE( NPALGN, 'ALGN', 1, NWA, IER )
C                                           FIND ALL BLOCKS IN ALZW
C                                           ALSO CONTAINED IN MEICL
C                                           COPY THOSE TO ALGN
          NPALZW = IW(IPALZW)
          IF( NPALGN .GT. 0 ) THEN
            IW(NPALGN+1) = IW(NPALZW+1)
            JP0 = NPALZW*2 + 6 + HW(NPALZW*2+3)
            JP9 = NPALZW*2 + 6 + HW(NPALZW*2+6) - 2
            IPC = 1
            NWA = 3
            DO 340 J=JP0,JP9,2
C                                           FIX POINTERS IN ALGN
              DO 310 WHILE( J-NPALZW*2-6 .EQ. HW(NPALZW*2+2+IPC) )
                HW(NPALGN*2+2+IPC) = (NWA-3)*2 + 1
                IPC = IPC + 1
  310         CONTINUE
C                                           BLOCK IN LIST?
              IBLK = HW(J)
              I = 1
              DO 320 WHILE( I.LE.NBLO .AND. IBLK.NE.MEICL(I) )
                I = I + 1
  320         CONTINUE
              IF( I.LE.NBLO .AND. HW(J+1).GT.0 ) THEN
C                                           STORE BLOCK NUMBER AND
C                                           ENERGY IN ALGN
                NWA = NWA + 1
                IW(NPALGN+NWA) = IW((J+1)/2)
C                                           STORE ENERGY ASSOCIATED
C                                           WITH BLOCK MEICL(I)
                NEICL(I) = HW(J+1)
              ENDIF
  340       CONTINUE
            DO 350 I=IPC,4
  350       HW(NPALGN*2+2+I) = (NWA-3)*2 + 1
C                                           CHOP UNUSED PART OF ALGN
            ICHOP = NWA - IW(NPALGN)
            IF( ICHOP.NE.0 ) CALL BCHM( NPALGN, ICHOP, IER )
C                                           CLUSTER ANALYSIS
C                                           WITH THESE BLOCKS
            NCLU = 0
            IF( NWA .GT. 3 ) THEN
              CALL LGANAL
              NPLGCL = IW(IPLGCL)
              IF( NPLGCL.GT. 0 ) NCLU = IW(NPLGCL+IW(NPLGCL+1)+2)
              IF( NCLU.GT.0 ) THEN
                NPPATR = IW(IPPATR)
                CALL LGCDIR( NPPATR, NPALGN, NPLGCL )
C                                           CORRECTED CLUSTER E
                ESHM = RW(NPLGCL+IW(NPLGCL+1)+6)
                NCLU = IW(NPLGCL+IW(NPLGCL+1)+3)
C                                           SAVE RESULT IN BANKS
                CALL BRNM( 'ALGN', 1, 'ALSA', JTRK )
                CALL BRNM( 'LGCL', 1, 'LGSA', JTRK )
                CALL BSAW( 2, 'ALSALGSA' )
              ENDIF
            ENDIF
          ENDIF
          CALL BDLS( 'ALGN', 1 )
          CALL BDLS( 'LGCL', 1 )
          CALL BRNM( 'ALZW', 2, 'ALGN', 1 )
          CALL BRNM( 'LGZW', 2, 'LGCL', 1 )
        ENDIF
      ENDIF
      END
      REAL FUNCTION DGAUS2(X1,X2,A1,A2,SIG1,SIG2)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     2 - DIM. GAUSS - DISTRIBUTION                                    C
C     CORRELATION = 0                                                  C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      DGAUS2 = 0.
C
      B1 = ((X1 - A1)/SIG1)**2
      B2 = ((X2 - A2)/SIG2)**2
      ARGUM = -.5*(B1 + B2)
C
      IF(ARGUM.LE.-180.) RETURN
C
      DGAUS2 = (1./(6.283185*SIG1*SIG2))*EXP(ARGUM)
C     DGAUS2 = EXP(ARGUM)
C
      RETURN
      END
      FUNCTION NUMBLC(XA,YA,ZA,IREG)
C
C     RETURNS BLOCK NUMBER FOR GIVEN COORDINATES AND LG-PART
C
C                                           05/07/82
C
#include "cgeo1.for"
C
      COMMON /CJTRIG/ PI,TWOPI
      DIMENSION MAP(6,6)
C
      DATA ICALL/0/
      IF(ICALL.NE.0) GO TO 9999
      ICALL=1
      MAP(1,1)=   -1
      MAP(2,1)=   -1
      MAP(3,1)= 2688
      MAP(4,1)= 2692
      MAP(5,1)= 2697
      MAP(6,1)= 2703
      MAP(1,2)=   -1
      MAP(2,2)=   -1
      MAP(3,2)= 2689
      MAP(4,2)= 2693
      MAP(5,2)= 2698
      MAP(6,2)= 2704
      MAP(1,3)= 2691
      MAP(2,3)= 2690
      MAP(3,3)= 2694
      MAP(4,3)= 2699
      MAP(5,3)= 2705
      MAP(6,3)=   -1
      MAP(1,4)= 2696
      MAP(2,4)= 2695
      MAP(3,4)= 2700
      MAP(4,4)= 2707
      MAP(5,4)= 2706
      MAP(6,4)=   -1
      MAP(1,5)= 2702
      MAP(2,5)= 2701
      MAP(3,5)= 2709
      MAP(4,5)= 2708
      MAP(5,5)=   -1
      MAP(6,5)=   -1
      MAP(1,6)= 2711
      MAP(2,6)= 2710
      MAP(3,6)=   -1
      MAP(4,6)=   -1
      MAP(5,6)=   -1
      MAP(6,6)=   -1
C
 9999 IBLK=-1
      X=XA
      Y=YA
      Z=ZA
      IF(IREG.EQ.0) GO TO 1
      IF((ABS(X).LT.(2.*BLXY)).AND.(ABS(Y).LT.(2.*BLXY))) GO TO 100
      IF((X.GT.0.).AND.(Y.GE.0.)) IQUAD=1
      IF((X.LE.0.).AND.(Y.GT.0.)) IQUAD=2
      IF((X.LT.0.).AND.(Y.LE.0.)) IQUAD=3
      IF((X.GE.0.).AND.(Y.LT.0.)) IQUAD=4
C
C     ROTATE (X,Y) INTO THE FIRST QUADRANT.
C
      JQUAD=0
    2 CONTINUE
      JQUAD=JQUAD+1
      IF(JQUAD.GE.IQUAD) GO TO 3
      XS = Y
      YS =-X
      X  =XS
      Y  =YS
      GO TO 2
    3 CONTINUE
      IF(Y.LT.BLXY) X=X-50.
      IF(X.LT.BLXY) Y=Y-50.
      IX=1.+X/BLXY
      IY=1.+Y/BLXY
      IF((IX.GT.6).OR.(IY.GT.6)) GO TO 100
      IBLK=MAP(IX,IY)
      IF(IBLK.LT.0) GO TO 100
      IBLK=IBLK+24*(IQUAD-1)+48*(IREG+1)
      GO TO 100
    1 CONTINUE
      PHI=ATAN2(Y,X)
      IF(PHI.LT.0.) PHI=PHI+TWOPI
      IPHI=84.*PHI/TWOPI
      IF(IPHI.GT.83) IPHI=83
      IZ=(Z-ZLGMI)/BLZ
      IF((IZ.LT.1).OR.(IZ.GT.30)) GO TO 100
      IBLK=IZ+32*IPHI
  100 CONTINUE
      NUMBLC=IBLK
      RETURN
      END

C   19/02/84 807251712  MEMBER NAME  EVBKPR   (JADEGS)      FORTRAN
C
C----------------------------------------------------------------------
      SUBROUTINE EVBKPR(IRET)
C----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL     ?     :  PRINT LIST OF BOS BANK NAMES/NOS.
C
C        MOD: C. BOWDERY  16/02/84 :  CREATE THIS AS SEPARATE S/R
C   LAST MOD: J. HAGEMANN 04/03/88 :  PRINT ALSO POINTER OF BANK
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
      DIMENSION NALIST(200)
C
      DATA NLMAX / 200 /
C
C------------------  C O D E  -----------------------------------------
C
      IRET = 1
      CALL BSLT
      CALL BMRT(NL,NALIST,NLMAX)
      IF(NL.LE.0) RETURN
C
      IRET = 0
      DO  1  INL = 1,NL
        LNAM   = NALIST(INL)
        IPLNAM = IDATA(IBLN(LNAM))
C
C                            BANK NAME IN LIST BUT NO BANKS EXIST NOW
C
        IF( IPLNAM .LE. 0 ) GO TO 1
C
  4     WRITE(6,3) LNAM, IDATA( IPLNAM - 2), IDATA(IPLNAM), IPLNAM
  3     FORMAT('  NAME:  ',A4,'    BOS NR: ',I3,'    LENGTH: ',I6,
     *         '   POINTER: ',I6)
C
        IPLNAM = IDATA(IPLNAM-1)
        IF( IPLNAM .GT. 0 ) GO TO 4
  1   CONTINUE
C
      RETURN
      END

C   07/06/96 606071823  MEMBER NAME  BLOADA   (S4)          FORTG1
      SUBROUTINE BLOADA(IUNDA,IUNTP,IPASS)
C     BOS SUBPROGRAM  =4.3=
      COMMON/BCS/IW(1)
C   07/06/96 606071821  MEMBER NAME  CCS      (S4)          FORTG1
      COMMON/CCS/IUND,INDT,INDC,NPT,INDA,LISTE(5),IPAS
      REAL*8 DATE(2)
      INTEGER DIRA/'+DIR'/,IBOS/'BOSS'/
C     DISP = OLD
      CALL DAY(DATE(1),DATE(2))
      WRITE(6,102) IUNDA,IUNTP
      IUND=IUNDA
      INDT=0
      CALL BDLS('+DIR',IUNDA)
      CALL BGAR(IGA)
      CALL BCRE(INDA,'+DIR',IUNDA,52,*101,IER)
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.LT.1610) GOTO 101
      CALL RDDA(1,IW(INDA+1),IW(INDA+2))
      IF(IW(INDA+2).NE.IW(INDA-3)) GOTO 101
      IF(IW(INDA+19).EQ.0) GOTO 5
      IF(IW(INDA+19).EQ.IPASS) GOTO 5
      IF(IPASS.EQ.IBOS) GOTO 5
      WRITE(6,103)
      STOP
    5 CALL BCRE(INDL,'+DIR',-1,2000,*101,IER)
      CALL BCRE(INDB,'+DIR',-2,3204,*101,IER)
      NREC=IW(INDA+6)
      NPRIME=NREC/20
      IF(NPRIME.LE.3) NPRIME=3
      NPRIME=NPRIME-2
   10 NPRIME=NPRIME+2
      A=NPRIME
      J=SQRT(A)
      DO 20 K=3,J,2
      NDIV=NPRIME/K
      IF(NDIV*K.EQ.NPRIME) GOTO 10
   20 CONTINUE
      IF(NPRIME.NE.IW(INDA+8)) GOTO 101
   22 IW(INDA+1)=4
      IW(INDA+2)=DIRA
      IW(INDA+3)=0
      IW(INDA+4)=0
      IW(INDA+5)=0
      IW(INDA+6)=NREC
      IW(INDA+7)=NPRIME+2
      IW(INDA+8)=NPRIME
      DO 24 K=1,NPRIME
      IW(INDA+3)=K+1
   24 CALL WRDA(K+1,IW(INDA+1),IW(INDA+2))
      IW(INDA+1)=0
      CALL WRDA(NPRIME+2,IW(INDA+1),IW(INDA+2))
      IW(INDA+1)=49
      IW(INDA+3)=0
      IW(INDA+5)=45
      CALL UCOPY(DATE,IW(INDA+21),4)
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      NBK=0
      N=0
      NCT=0
      NERR=0
      IF(IUNTP.EQ.0) GOTO 40
   30 CALL RDSQ(IUNTP,NTOT,IW(INDB+1),*36)
      NCT=NCT+1
      IF(NTOT.LE.0.OR.NTOT.GT.3204) GOTO 32
      IF(NTOT-4.NE.IW(INDB+4)) GOTO 32
      GOTO 34
   32 NERR=NERR+1
      GOTO 30
   34 IF(NCT.EQ.0) GOTO 36
      LISTE(1)=IW(INDB+1)
      LISTE(2)=IW(INDB+2)
      LISTE(3)=0
      LISTE(4)=IW(INDB+4)
      LISTE(5)=2+MOD(IABS(LISTE(1)+LISTE(2)),IW(INDA+8))
      INDC=INDB+4
      CALL DADA(3,*101)
      CALL UCOPY2(LISTE,IW(INDL+5*N+1),5)
      NBK=NBK+1
      N=N+1
      IF(N.LT.400) GOTO 30
   36 IF(N.EQ.0) GOTO 40
      CALL SORTIR(IW(INDL+1),N,5,5)
      CALL PODA(3,IW(INDL+1),N)
      IF(N.NE.400) GOTO 40
      N=0
      GOTO 30
   40 IW(INDA+33)=NBK
      IW(INDA+34)=NBK
      IW(INDA+35)=NBK
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      NCT=NCT-NERR
      CALL BDLS('+DIR',-2)
      CALL BDLS('+DIR',-1)
      CALL BDLS('+DIR',IUNDA)
      CALL BPASDA(IUND,IPASS)
      CALL BLOCDA(IUND,INDBLA,'+DIR',0,*90)
      CALL BDLS('+DIR',0)
   90 CALL BDLS('+DIR',IUNDA)
      CALL BGAR(IGA)
      WRITE(6,104) NCT,NERR
C
  100 RETURN
  101 CALL BDMPA(14)
      GOTO 100
  102 FORMAT('0---- BLOADA    START FOR DA-DATASET',I3,5X,' LOAD ',
     1   'FROM SQ-DATASET',I3)
  103 FORMAT('0---- BLOADA    STOP, DA-DATASET PROTECTED, USE',
     1   ' CORRECT PASSWORD'/)
  104 FORMAT('0---- BLOADA    END,',I6,' RECORDS(BANKS)',
     1   ' COPIED,',I6,' ILLEGAL RECORDS'/)
      END

C   22/04/87 705201641  MEMBER NAME  ZFITDS   (S)        M  FORTRAN77
      SUBROUTINE ZFITDS( ITRK )
C-----------------------------------------------------------
C  Version of 22/04/87      last mod 20/05/87   E Elsen
C     (..+1) = IJC(I),       REL POINTER IN JETC
C     (..+2) = S(I),         TRACK LENGTH
C     (..+3) = Z(I),         Z
C     (..+4) = FLAG(I),      0 IF OK
C     (..+5) = 1/SIGMA(I)**2
C----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C  COMMON FOR Z-RESOLUTION PARAMETERS,   USED IN SUBR. AMPS2Z
C
      COMMON / CZSPRM / NZSPRD,
C                                           PARMS FOR RESOLUTIONS
     * AZSRS0(3), AZSRSA(3),
C                                           PARMS FOR CUTS
     * AZSCT1(3), AZSCT2(3), AZSCT3(3), AZSCT4(3),
C                                           SECOND HIT
     * AZSSHT(5,3),
C                                           SECOND HIT DISTANCE
     * AZSSHD(3),
C                                           AVE RESOLUTIONS
     * AZSSAV(3),
C                                           ZSPD BANK FILL FLAG
     * LZSPDF
      LOGICAL LZSPDF
C                                           MODEGA = 1 FOR GA
      COMMON / CGAMOD / MODEGA, GAHEX
C
      REAL SBTICK / 100. /, SSTICK / 20. /
      REAL ZBTICK / 200. /, ZSTICK / 20. /
      REAL ABTICK / 1000. /, ASTICK / 200. /
      INTEGER NSOFF / 2 / , NZOFF / 0 /, NAOFF / 0 /
      INTEGER IXTOFF/ 100 /, IYTOFF / 100 /
      INTEGER PLOTW(4) / 210, 4085, 10, 3000 /
      INTEGER GRAPHW(4), AMPSW(4)
      INTEGER FLAG
      LOGICAL OWNZ / .FALSE. /, LHELP
      CHARACTER*8 DEST / 'L2      ' /
      CHARACTER*1 ANSWER
      CHARACTER*132 CLINE
      CHARACTER*50 CNUMB
      CHARACTER*3  CTOG
      CHARACTER*4  CHELP
      CHARACTER*1  ZERO / '0' /, NINE / '9' /
      CHARACTER*8 DATTIM(2)
C
      IX(S) = GRAPHW(1) + SCALEX*(S-SL)
      IY(Z) = GRAPHW(3) + SCALEY*(Z-ZL)
      IA(IAM) = AMPSW(3) + SCALAY*IAM
C
      CALL BLOC( NPZSPD, 'ZSPD', ITRK, *8000, IER )
C                                           EXTREME VALUES
      NTRW = IW(NPZSPD+1)
      NHIT = (IW(NPZSPD)-1)/NTRW
      SMIN = 1.E10
      SMAX = -SMIN
      ZMIN = 1.E10
      ZMAX = -ZMIN
      DO 10 J=1,NHIT
        S = RW(NPZSPD+(J-1)*NTRW+3)
        Z = RW(NPZSPD+(J-1)*NTRW+4)
        IF( SMIN.GT.S ) SMIN = S
        IF( SMAX.LT.S ) SMAX = S
        IF( ZMIN.GT.Z ) ZMIN = Z
        IF( ZMAX.LT.Z ) ZMAX = Z
   10 CONTINUE
      IF( SMIN.GE.0. ) THEN
        SL = INT(SMIN/SBTICK)*SBTICK
      ELSE
        SL = INT(SMIN/SBTICK-1.)*SBTICK
      ENDIF
      SL = SL - NSOFF*SSTICK
      IF( SMAX.GE.0. ) THEN
        SH = INT(SMAX/SBTICK+1.)*SBTICK
      ELSE
        SH = INT(SMAX/SBTICK)*SBTICK
      ENDIF
      IF( ZMIN.GE.0. ) THEN
        ZL = INT(ZMIN/ZBTICK)*ZBTICK
      ELSE
        ZL = INT(ZMIN/ZBTICK-1.)*ZBTICK
      ENDIF
      ZL = ZL - NZOFF*ZSTICK
      IF( ZMAX.GE.0. ) THEN
        ZH = INT(ZMAX/ZBTICK+1.)*ZBTICK
      ELSE
        ZH = INT(ZMAX/ZBTICK)*ZBTICK
      ENDIF
C
      CALL ERASE
      CALL TWINDO( PLOTW(1), PLOTW(2), PLOTW(3), PLOTW(4) )
      GRAPHW(1) = PLOTW(1) + 300
      GRAPHW(2) = PLOTW(2) - 200
      GRAPHW(3) = PLOTW(3) + 200
      GRAPHW(4) = PLOTW(4) - 1024
      AMPSW(1) = GRAPHW(1)
      AMPSW(2) = GRAPHW(2)
      AMPSW(3) = GRAPHW(4) + 100
      AMPSW(4) = PLOTW(4) - 100
      CALL MOVABS( PLOTW(1), PLOTW(3) )
      CALL DRWABS( PLOTW(2), PLOTW(3) )
      CALL DRWABS( PLOTW(2), PLOTW(4) )
      CALL DRWABS( PLOTW(1), PLOTW(4) )
      CALL DRWABS( PLOTW(1), PLOTW(3) )
C                                           DRAW RUN AND EVENT NUMBER
      NPHEAD = IW(IBLN('HEAD'))
      IF( NPHEAD.GT.0 ) THEN
        WRITE(CLINE,9004)
     *         HW(NPHEAD*2+10), HW(NPHEAD*2+11), ICREC, ITRK, IDATSV
 9004   FORMAT(2I7,I4,' Track',I3,'  DSN=',11A4)
        CALL MOVABS( PLOTW(1)+400, PLOTW(4)-75  )
        CALL EOUTST( 77, CLINE )
        CALL DAY( DATTIM(1), DATTIM(2) )
        WRITE(CLINE,9005) DATTIM
 9005   FORMAT(' JADE z-s and Amplitude Display at ',A8,1X,A8)
        CALL MOVABS( AMPSW(1)+1000, AMPSW(3)-75  )
        CALL EOUTST( 52, CLINE )
      ENDIF
C                                           SET SCALES
      SCALEX = (GRAPHW(2)-GRAPHW(1))/(SH-SL)
      SCALEY = (GRAPHW(4)-GRAPHW(3))/(ZH-ZL)
C                                           DRAW AXES
      CALL MOVABS( IX(SL), IY(ZH) )
      CALL DRWABS( IX(SL), IY(ZL) )
      CALL DRWABS( IX(SH), IY(ZL) )
      NT = (SH-(SL+NSOFF*SSTICK))/SBTICK+1.5
      I0 = IY(ZL) - 20
      I9 = 40
      DO 110 J=1,NT
        S = SL + (J-1)*SBTICK + NSOFF*SSTICK
        CALL MOVABS( IX(S), I0 )
  110   CALL DRWREL( 0, I9 )
      NT = (SH-SL)/SSTICK+1.5
      I0 = IY(ZL) - 10
      I9 = 20
      DO 120 J=1,NT
        S = SL + (J-1)*SSTICK
        CALL MOVABS( IX(S), I0 )
  120   CALL DRWREL( 0, I9 )
      NT = (ZH-(ZL+NZOFF*ZSTICK))/ZBTICK+1.5
      I0 = IX(SL) - 20
      I9 = 40
      DO 130 J=1,NT
        Z = ZL + (J-1)*ZBTICK + NZOFF*ZSTICK
        CALL MOVABS( I0, IY(Z) )
  130   CALL DRWREL( I9, 0 )
      NT = (ZH-ZL)/ZSTICK+1.5
      I0 = IX(SL) - 10
      I9 = 20
      DO 140 J=1,NT
        Z = ZL + (J-1)*ZSTICK
        CALL MOVABS( I0, IY(Z) )
  140   CALL DRWREL( I9, 0 )
C                                           DRAW NUMBERS
      S = SL + NSOFF*SSTICK
      I = S
      WRITE(CNUMB,9121) I
 9121 FORMAT(I5)
      CALL MOVABS( IX(S)-100, IY(ZL)-IYTOFF )
      CALL EOUTST( 5, CNUMB )
      S = SH
      I = S
      WRITE(CNUMB,9121) I
      CALL MOVABS( IX(S)-100, IY(ZL)-IYTOFF )
      CALL EOUTST( 5, CNUMB )
      CLINE = 'S'
      CALL MOVABS( IX(S)-400, IY(ZL)-IYTOFF )
      CALL EOUTST( 1, CLINE )
      Z = ZL + NZOFF*ZSTICK
      I = Z
      WRITE(CNUMB,9121) I
      CALL MOVABS( IX(SL)-250, IY(Z)-20 )
      CALL EOUTST( 5, CNUMB )
      Z = ZH
      I = Z
      WRITE(CNUMB,9121) I
      CALL MOVABS( IX(SL)-250, IY(Z)-20 )
      CALL EOUTST( 5, CNUMB )
      CLINE = 'Z'
      CALL MOVABS( IX(SL)-250, IY(Z)-420 )
      CALL EOUTST( 1, CLINE )
C
C                                           DRAW HITS
      IDS = IX(5.) - IX(0.)
      DZ0 = AZSSAV(NZSPRD)
      NPJETC = IW(IBLN('JETC'))
      DO 1000 J=1,NHIT
        S = RW(NPZSPD+(J-1)*NTRW+3)
        Z = RW(NPZSPD+(J-1)*NTRW+4)
        IF( RW(NPZSPD+(J-1)*NTRW+6).GT.0. ) THEN
          DZ = DZ0/SQRT(RW(NPZSPD+(J-1)*NTRW+6))
        ELSE
          DZ = DZ0
        ENDIF
        FLAG = IW(NPZSPD+(J-1)*NTRW+5)
        IF( FLAG .EQ. 0 ) THEN
          CALL MOVABS( IX(S)-IDS, IY(Z) )
          CALL DRWREL( 2*IDS, 0 )
          CALL MOVABS( IX(S), IY(Z-DZ) )
          CALL DRWABS( IX(S), IY(Z+DZ) )
        ELSE
          CALL MOVABS( IX(S)-IDS, IY(Z-DZ) )
          CALL DRWABS( IX(S)-IDS, IY(Z+DZ) )
          CALL DRWABS( IX(S)+IDS, IY(Z+DZ) )
          CALL DRWABS( IX(S)+IDS, IY(Z-DZ) )
          CALL DRWABS( IX(S)-IDS, IY(Z-DZ) )
        ENDIF
        IF( NPJETC.GT.0 .AND. OWNZ ) THEN
          IP = NPJETC*2+IW(NPZSPD+(J-1)*NTRW+2)
          CALL AMPS2Z( IP, NPJETC, ZOWN, W, IFL )
          IF( ZOWN.GT.ZL .AND. ZOWN.LT.ZH ) THEN
            DZ = DZ0/SQRT(W)
            CALL MOVABS( IX(S)-IDS, IY(ZOWN   ) )
            CALL DRWABS( IX(S)    , IY(ZOWN+DZ) )
            CALL DRWABS( IX(S)+IDS, IY(ZOWN   ) )
            CALL DRWABS( IX(S)    , IY(ZOWN-DZ) )
            CALL DRWABS( IX(S)-IDS, IY(ZOWN   ) )
          ENDIF
        ENDIF
 1000 CONTINUE
C
      NPPATR = IW(IBLN('PATR'))
      IF( NPPATR.GT.0 ) THEN
        L0 = IW(NPPATR+1)
        L1 = IW(NPPATR+3)
        NTRK = IW(NPPATR+2)
        IF( 0.LT.ITRK .AND. ITRK .LE. NTRK ) THEN
          DZDS = RW(NPPATR+L0+(ITRK-1)*L1+30)
C         Z0   = RW(NPPATR+L0+(ITRK-1)*L1+31)
          Z0   = RW(NPPATR+L0+(ITRK-1)*L1+ 7)
          S1 = SMIN
          Z1 = Z0 + S1*DZDS
          IF( Z1.LT.ZL ) THEN
            S1 = (ZL-Z0)/DZDS
            Z1 = ZL
          ELSEIF( Z1.GT.ZH ) THEN
            S1 = (ZH-Z0)/DZDS
            Z1 = ZH
          ENDIF
          S9 = SMAX
          Z9 = Z0 + S9*DZDS
          IF( Z9.GT.ZH ) THEN
            S9 = (ZH-Z0)/DZDS
            Z9 = ZH
          ELSEIF( Z9.LT.ZL ) THEN
            S9 = (ZL-Z0)/DZDS
            Z9 = ZL
          ENDIF
          CALL MOVABS( IX(S1), IY(Z1) )
          CALL DRWABS( IX(S9), IY(Z9) )
        ENDIF
      ENDIF
C                                           DRAW AMPLITUDES
C                                           FIND MAXIMUM
      NPJETC = IW(IBLN('JETC'))
      IF( NPJETC.GT.0 ) THEN
C                                           FIND MAX AMPLITUDE
        IMAXA = 0
        DO 1700 J=1,NHIT
          IAR = HW(NPJETC*2+IW(NPZSPD+(J-1)*NTRW+2)+1)
          IAL = HW(NPJETC*2+IW(NPZSPD+(J-1)*NTRW+2)+2)
          IF( IAR .GT. IMAXA ) IMAXA = IAR
          IF( IAL .GT. IMAXA ) IMAXA = IAL
 1700   CONTINUE
        IAH = INT(IMAXA/ABTICK+1.)*ABTICK+.5
        SCALAY = FLOAT(AMPSW(4)-AMPSW(3))/AMAX0(IAH,1)
C                                           DRAW AMPLITUDE AXES
        CALL MOVABS( IX(SL), IA(IAH) )
        CALL DRWABS( IX(SL), IA(0) )
        CALL DRWABS( IX(SH), IA(0) )
        CLINE = 'Charge'
        CALL MOVABS( IX(SL)-250, IA(IAH)-IYTOFF )
        CALL EOUTST( 6, CLINE )
C                                           DRAW TICKS
        NT = ( IAH-NAOFF*ASTICK ) / ABTICK + 1.5
        I0 = IX(SL) - 20
        I9 = 40
        DO 1710 J=1,NT
          IAL = (J-1)*ABTICK + NAOFF*ASTICK + .5
          CALL MOVABS( I0, IA(IAL) )
 1710     CALL DRWREL( I9, 0 )
        NT = IAH / ASTICK + .5
        I0 = IX(SL) - 10
        I9 = 20
        DO 1720 J=1,NT
          IAL = (J-1)*ASTICK + .5
          CALL MOVABS( I0, IA(IAL) )
 1720     CALL DRWREL( I9, 0 )
        NT = (SH-(SL+NSOFF*SSTICK))/SBTICK+1.5
        I0 = IA(0) - 20
        I9 = 40
        DO 1730 J=1,NT
          S = SL + (J-1)*SBTICK + NSOFF*SSTICK
          CALL MOVABS( IX(S), I0 )
 1730     CALL DRWREL( 0, I9 )
        NT = (SH-SL)/SSTICK+1.5
        I0 = IA(0) - 10
        I9 = 20
        DO 1740 J=1,NT
          S = SL + (J-1)*SSTICK
          CALL MOVABS( IX(S), I0 )
 1740     CALL DRWREL( 0, I9 )
        WRITE(CNUMB,9121) IAH
        CALL MOVABS( IX(SL)-250, IA(IAH)-20 )
        CALL EOUTST( 5, CNUMB )
        IDS = IDS/2
        DO 1810 J=1,NHIT
          S = RW(NPZSPD+(J-1)*NTRW+3)
          IAR = HW(NPJETC*2+IW(NPZSPD+(J-1)*NTRW+2)+1)
          CALL MOVABS( IX(S)-IDS, IA( 0 ) )
          CALL DRWABS( IX(S)-IDS, IA(IAR) )
          CALL DRWABS( IX(S)    , IA(IAR) )
          CALL DRWABS( IX(S)    , IA( 0 ) )
          IAL = HW(NPJETC*2+IW(NPZSPD+(J-1)*NTRW+2)+2)
          CALL DRWABS( IX(S)    , IA(IAL) )
          CALL DRWABS( IX(S)+IDS, IA(IAL) )
          CALL DRWABS( IX(S)+IDS, IA( 0 ) )
 1810   CONTINUE
      ENDIF
C                                           ENTER EDITOR
      IF( MODEGA .EQ. 1 ) THEN
        CALL CLEAR
        LHELP = .TRUE.
      ELSE
        CALL TRMOUT( 80,
     +   ' Enter track number or Character or HELP^')
        LHELP = .FALSE.
      ENDIF
 2000 CONTINUE
      IF( LHELP ) THEN
        CTOG = 'ON '
        IF( .NOT. OWNZ ) CTOG = 'OFF'
        CLINE = 'Z-S FIT PACKAGE^'
        CALL TRMOUT( 80, CLINE )
        CLINE = '---------------^'
        CALL TRMOUT( 80, CLINE )
        CLINE = ' Track Level:^'
        CALL TRMOUT( 80, CLINE )
        CLINE = ' ^'
        CALL TRMOUT( 80, CLINE )
        CLINE = '   Select Option by entering Leading Character,^'
        CALL TRMOUT( 80, CLINE )
        CLINE = '   enter next track number or hit RETURN:^'
        CALL TRMOUT( 80, CLINE )
        CLINE = '     HardCopy.......................^'
        CALL TRMOUT( 80, CLINE )
        WRITE(CLINE,9201) DEST
 9201   FORMAT('     Set DEST (',A8,')............^')
        CALL TRMOUT( 80, CLINE )
        CLINE = '     Dump Data......................^'
        CALL TRMOUT( 80, CLINE )
        WRITE(CLINE,9205) CTOG
 9205   FORMAT('     with standard Z (AMPS2Z)?.(',A3,')^')
        CALL TRMOUT( 80, CLINE )
        CLINE = '     Cursor Hit.....................^'
        CALL TRMOUT( 80, CLINE )
        CLINE = '     Legend.........................^'
        CALL TRMOUT( 80, CLINE )
      ENDIF
 2001 CALL TRMIN(50,CNUMB)
      ANSWER = CNUMB(1:1)
      CHELP = CNUMB(1:4)
      IF( CHELP .EQ. 'HELP' ) THEN
        LHELP = .TRUE.
        GO TO 2000
      ENDIF
C
      LHELP = MODEGA .EQ. 1
      IF( ANSWER .EQ. 'h' .OR. ANSWER .EQ. 'H' ) THEN
        CALL HDCDST( DEST )
        LHELP = .FALSE.
        GO TO 2000
      ELSEIF( ANSWER .EQ. 'l' .OR. ANSWER .EQ. 'L' ) THEN
        CLINE =  'Position Cursor to add legend^'
        CALL TRMOUT( 80, CLINE )
        CALL SCURSR( ICHR, IXP0, IYP0 )
        IXP = IXP0
        IYP = IYP0
        IDS = 20
        CALL MOVABS( IXP-IDS, IYP )
        CALL DRWREL( 2*IDS, 0 )
        CALL MOVABS( IXP, IYP-IDS )
        CALL DRWREL( 0, 2*IDS )
        CLINE= 'Associated Hits'
        CALL MOVABS( IXP+40, IYP-15 )
        CALL EOUTST( 15, CLINE )
        IYP = IYP - 70
        CALL MOVABS( IXP-IDS, IYP-IDS )
        CALL DRWABS( IXP-IDS, IYP+IDS )
        CALL DRWABS( IXP+IDS, IYP+IDS )
        CALL DRWABS( IXP+IDS, IYP-IDS )
        CALL DRWABS( IXP-IDS, IYP-IDS )
        CLINE= 'Rejected Hits'
        CALL MOVABS( IXP+40, IYP-15 )
        CALL EOUTST( 13, CLINE )
        IF( OWNZ ) THEN
          IYP = IYP - 70
          CALL MOVABS( IXP-IDS, IYP     )
          CALL DRWABS( IXP    , IYP+IDS )
          CALL DRWABS( IXP+IDS, IYP     )
          CALL DRWABS( IXP    , IYP-IDS )
          CALL DRWABS( IXP-IDS, IYP     )
          CLINE= 'Standard z'
          CALL MOVABS( IXP+40, IYP-15 )
          CALL EOUTST( 10, CLINE )
        ENDIF
        IF( MODEGA.EQ.1 ) CALL CLEAR
        GO TO 2000
      ELSEIF( ANSWER .EQ. 'w' .OR. ANSWER .EQ. 'W' ) THEN
        OWNZ = .NOT. OWNZ
        IF( MODEGA.EQ.1 ) CALL CLEAR
        GO TO 2000
      ELSEIF( ANSWER .EQ. 's' .OR. ANSWER .EQ. 'S' ) THEN
        CLINE = ' Enter Destination^'
        CALL TRMOUT( 80, CLINE )
        DEST = ' '
        CALL TRMIN( 8, DEST )
        IF( .NOT. (
     *        DEST .EQ. 'L1      '   .OR.
     *        DEST .EQ. 'L2      '   .OR.
     *        DEST .EQ. 'L3      '   .OR.
     *        DEST .EQ. 'L4      '   .OR.
     *        DEST .EQ. 'EXT     '   ) ) THEN
          WRITE(CLINE,9204) DEST
 9204     FORMAT(' Unknown Destination:',A8,' L1 will be assumed^')
          CALL TRMOUT( 80, CLINE )
          DEST = 'L1      '
        ENDIF
        IF( MODEGA.EQ.1 ) CALL CLEAR
        GO TO 2000
      ELSEIF( ANSWER .EQ. 'c' .OR. ANSWER .EQ. 'C' ) THEN
        IF( LHELP ) THEN
          WRITE(6,9202)
 9202     FORMAT(' The Cursor ( Haircross ) is used to obtain'/
     *     ' additional information on specified hits:'/
     *     ' The horizontal coordinate of the cross is used to find',
     *     ' the closest hit,'/
     *     ' the position of the cross is used to place the text',
     *     ' in format:'/
     *   '   Hit Multiplicity      Wire Number    Quality Code(0=good)'/
     *     '        and then for each hit'/
     *     '   Amplitude left       Amplitude Right    Time'//
     *     '   Enter Cursor Position on Graphics Screen')
        ENDIF
        CALL SCURSR( ICHR, IXP, IYP )
        IXP0 = IXP
        IYP0 = IYP
        I = 0
        IDIST = 99999
        DO 2100 J=1,NHIT
          IDEL = IABS(IX(RW(NPZSPD+(J-1)*NTRW+3))-IXP)
          IF( IDEL .LT. IDIST ) THEN
            IDIST = IDEL
            I = J
          ENDIF
 2100   CONTINUE
        IF( I.GT.0 ) THEN
          NPJETC = IW(IBLN('JETC'))
          IF( NPJETC.GT. 0 ) THEN
            IP0 = NPJETC*2+IW(NPZSPD+(I-1)*NTRW+2)
            NPJET1 = IW(NPJETC-1)
            IF( NPJET1.GT. 0 ) THEN
              IP1 = NPJET1*2+IW(NPZSPD+(I-1)*NTRW+2)
              NW = HW(IP0)/8
              MULT = 1
              IP = IP0 - 4
 2110         IF( IP.GT.NPJETC*2+100 .AND. HW(IP)/8.EQ.NW ) THEN
                IP = IP - 4
                MULT = MULT + 1
                GO TO 2110
              ENDIF
              IP = IP0 + 4
 2120         IF( IP.LT.NPJETC*2+HW(NPJETC*2+99)+100 .AND.
     *                         HW(IP)/8.EQ.NW ) THEN
                IP = IP + 4
                MULT = MULT + 1
                GO TO 2120
              ENDIF
              WRITE(CLINE,9162) MULT, NW, IW(NPZSPD+(I-1)*NTRW+5)
              CALL MOVABS( IXP, IYP )
              CALL EOUTST( 18, CLINE )
              WRITE(CLINE,9162) HW(IP0+1), HW(IP0+2), HW(IP0+3)
 9162         FORMAT(3I6)
              IYP = IYP - 50
              CALL MOVABS( IXP, IYP )
              CALL EOUTST( 18, CLINE )
              IP = IP0 - 4
 2130         IF( IP.GT.NPJETC*2+100 .AND. HW(IP)/8.EQ.NW ) THEN
                IYP = IYP - 50
                WRITE(CLINE,9162) HW(IP+1), HW(IP+2), HW(IP+3)
                CALL MOVABS( IXP, IYP )
                CALL EOUTST( 18, CLINE )
                IP = IP - 4
                GO TO 2130
              ENDIF
              IP = IP0 + 4
 2140         IF( IP.LT.NPJETC*2+HW(NPJETC*2+99)+100 .AND.
     *                         HW(IP)/8.EQ.NW ) THEN
                IYP = IYP - 50
                WRITE(CLINE,9162) HW(IP+1), HW(IP+2), HW(IP+3)
                CALL MOVABS( IXP, IYP )
                CALL EOUTST( 18, CLINE )
                IP = IP + 4
                GO TO 2140
              ENDIF
              CALL MOVABS( IXP0, IYP0-50 )
              CALL DSHABS( IX(RW(NPZSPD+(I-1)*NTRW+3)),
     *                       IY(RW(NPZSPD+(I-1)*NTRW+4)), 1 )
            ENDIF
          ENDIF
        ENDIF
        IF( MODEGA.EQ.1 ) CALL CLEAR
        GO TO 2000
      ELSEIF( ANSWER .EQ. 'd' .OR. ANSWER .EQ. 'D' ) THEN
        NPJETC = IW(IBLN('JETC'))
        WRITE(CLINE,9152)
 9152   FORMAT(' HIT JETC POI    s       z     Flag      Weight',
     *           '    z      Flag   Weight')
        CALL TRMOUT( 80, CLINE )
        DO 7900 J=NPZSPD+1,NPZSPD+IW(NPZSPD)-1,NTRW
          I = (J-(NPZSPD+1))/NTRW+1
          IF( NPJETC.GT.0 ) THEN
            IP = NPJETC*2+IW(NPZSPD+(I-1)*NTRW+2)
            CALL AMPS2Z( IP, NPJETC, ZOWN, W, IFL )
          ELSE
            ZOWN = 0.
            W = 0.
            IFL = 0
          ENDIF
          WRITE(CLINE,9151)  I,
     *                   IW(J+1), RW(J+2), RW(J+3), IW(J+4), RW(J+5),
     *                   ZOWN, IFL, W
 9151     FORMAT(I6,I7,2F8.2,I6,E12.3,F8.2,I6,E12.3,'^')
          CALL TRMOUT( 80, CLINE )
 7900   CONTINUE
        IF( MODEGA.EQ.1 ) CALL CLEAR
        GO TO 2000
      ELSEIF( ICHAR(ANSWER) .GT. ICHAR(ZERO) .AND.
     *          ICHAR(ANSWER) .LE. ICHAR(NINE) ) THEN
        READ(CNUMB,*) ITRK
        ITRK = -ITRK
        RETURN
      ENDIF
 8000 CONTINUE
      END

C   12/08/87 805102006  MEMBER NAME  EXPECT3  (S)           FORTRAN77
      SUBROUTINE EXPECT(IPART,E,VAR,VERT,NBLOCK,IBLIST,BLCFRC,AVGSUM)
C
C   COPIED FROM F11HEL.ES(EXPECT)     LAST MOD 19/04/88 MZ
C
C
C     CALCULATE EXPECTED FRACTIONS OF ELECTROMAGNETIC SHOWER
C     IN NBLOCK BLOCKS GIVEN IN A BLOCKLIST IBLIST
C
C     I/P : IPART        DETECTOR PART -1,0,+1
C           E            SHOWER ENERGY (DEFAULT 500 MEV)
C           VAR          IMPACT POINTS ON LEAD-GLASS SURFACE
C                        VAR(1),VAR(2) = PHI,Z IN BARREL CASE
C                        VAR(1),VAR(2) =   X,Y IN ENDCAP CASE
C           VERT         EVENT VERTEX (X,Y,Z)
C           NBLOCK       LENGTH OF BLOCKLIST
C           IBLIST       LIST OF BLOCKS FOR WHICH THE FRACTIONS
C                        SHOULD BE CALCULATED
C
C     O/P : BLCFRC       FRACTION FOR EACH REQUESTED BLOCK
C           AVGSUM       ENERGY FRACTION IN BLOCKS CONTAINED IN IBLIST
C
C                                       06/08/82
      EXTERNAL SF
C
#include "cgeo1.for"
C
      COMMON /TRAFO/ STR,CTR,SPR,CPR,CTRCPR,CTRSPR,STRCPR,STRSPR,
     *               JPART,XMOV,YMOV,ZMOV
      COMMON /PARAME/ P(6)
      COMMON / CJTRIG / PI,TWOPI
      DIMENSION VAR(2),VERT(3)
      DIMENSION EL(6),AL(6),ALL(6),BL(6),ED(5),AD(5),ALD(5),BD(5)
      DIMENSION XL(3),XU(3)
      DIMENSION IBLIST(1),BLCFRC(1)
C
C     SHOWER FUNCTION PARAMETERS ACCORDING TO E.LONGO ET. AL.
C
      DATA EL     /100.   ,300.   ,500.   ,700.   ,1000.  ,5000.  /
      DATA AL     /  4.54 ,  7.18 ,  8.24 ,  8.32 ,  8.58 , 10.88 /
      DATA ALL    /  1.   ,  1.45 ,  1.65 ,  1.84 ,  2.03 ,  2.74 /
      DATA BL     /   .515,   .493,   .476,   .470,   .468,   .454/
C
      DATA ED     /100.   ,200.   ,200.   ,300.   ,4000.   /
      DATA AD     /  2.64 ,  1.06 ,   .08 ,   .26 ,   2.3  /
      DATA ALD    /   .45 ,   .2  ,   .19 ,   .19 ,    .71 /
      DATA BD     /  -.022,  -.017,  -.006,  -.002,   -.014/
C
CHANGED 19/04/88 MZ
      CALL RNSET(1)
C
      JPART = IPART
      DO 115 IBL = 1,NBLOCK
      BLCFRC(IBL) = 0.
  115 CONTINUE
      AVGSUM = 0.
C
C     IMPACT POINT ON LG SURFACE ??
C
      IF(ICHECK(VAR(1),VAR(2),IPART).NE.1) RETURN
C
C     TRANSFORMATION PARAMETERS
C
      IF(IPART.EQ.0) GOTO 1
      ZENDCP = IPART*ZENDPL
      DX = VAR(1)-VERT(1)
      DY = VAR(2)-VERT(2)
      DZ = ZENDCP-VERT(3)
      XMOV = VAR(1)
      YMOV = VAR(2)
      ZMOV = ZENDCP
      GOTO 2
    1 DX = RLG*COS(VAR(1))-VERT(1)
      DY = RLG*SIN(VAR(1))-VERT(2)
      DZ = VAR(2)-VERT(3)
      XMOV = RLG*COS(VAR(1))
      YMOV = RLG*SIN(VAR(1))
      ZMOV = VAR(2)
    2 CTR = DZ/SQRT(DX*DX+DY*DY+DZ*DZ)
      STR = SQRT(1.-CTR*CTR)
      PR=ATAN2(DY,DX)
      IF(PR.LT.0.) PR=PR+TWOPI
      SPR = SIN(PR)
      CPR = COS(PR)
      CTRCPR = CTR*CPR
      CTRSPR = CTR*SPR
      STRCPR = STR*CPR
      STRSPR = STR*SPR
C
C     SHOWER PARAMETERS (PLO'I' ARE INTERPOLATED FROM THE LONGO PARAM.)
C
      IF(E.LE.0.) E=500.
      IF(E.LT.5000.) GOTO 3
      PLO1 = AL(6)
      PLO2 = ALL(6)
      PLO3 = BL(6)
      GOTO 9
    3 IF(E.LT.1000.) GOTO 4
      EFAC = (E-EL(5))/ED(5)
      PLO1 = AL(5)+AD(5)*EFAC
      PLO2 = ALL(5)+ALD(5)*EFAC
      PLO3 = BL(5)+BD(5)*EFAC
      GOTO 9
    4 IF(E.LT.700.)  GOTO 5
      EFAC = (E-EL(4))/ED(4)
      PLO1 = AL(4)+AD(4)*EFAC
      PLO2 = ALL(4)+ALD(4)*EFAC
      PLO3 = BL(4)+BD(4)*EFAC
      GOTO 9
    5 IF(E.LT.500.)  GOTO 6
      EFAC = (E-EL(3))/ED(3)
      PLO1 = AL(3)+AD(3)*EFAC
      PLO2 = ALL(3)+ALD(3)*EFAC
      PLO3 = BL(3)+BD(3)*EFAC
      GOTO 9
    6 IF(E.LT.300.)  GOTO 7
      EFAC = (E-EL(2))/ED(2)
      PLO1 = AL(2)+AD(2)*EFAC
      PLO2 = ALL(2)+ALD(2)*EFAC
      PLO3 = BL(2)+BD(2)*EFAC
      GOTO 9
    7 IF(E.LT.100.)  GOTO 8
      EFAC = (E-EL(1))/ED(1)
      PLO1 = AL(1)+AD(1)*EFAC
      PLO2 = ALL(1)+ALD(1)*EFAC
      PLO3 = BL(1)+BD(1)*EFAC
      GOTO 9
    8 PLO1 = AL(1)
      PLO2 = ALL(1)
      PLO3 = BL(1)
C
    9 P(1) = PLO2
      P(2) = PLO1*2.023
      P(3) = PLO3
      P(4) = 2.04604
      P(5) = PLO1*.17
      P(6) = .597942
C
C     NORMALIZE INTEGRAL
C
      P2A1=PLO2+1.
      FNORM = 66678.5*PLO1*GAMMA(P2A1)/PLO3**P2A1
C
C     INTEGRATION
C
C
C     CHECK TOTAL VALUE ON REQUEST
C
      IF(NBLOCK.GT.0) GOTO 113
      XL(1) = RLG
      IF(IPART.NE.0) XL(1) = VAR(1)-500.
      XL(2) = VAR(1)-2.
      IF(IPART.NE.0) XL(2) = VAR(2)-500.
      XL(3) = VAR(2)-500.
      IF(IPART.EQ. 1) XL(3) = ZENDPL
      IF(IPART.EQ.-1) XL(3) = ZENDMI-1000.
      XU(1) = RLG+1000.
      IF(IPART.NE.0) XU(1) = VAR(1)+500.
      XU(2) = VAR(1)+2.
      IF(IPART.NE.0) XU(2) = VAR(2)+500.
      XU(3) = VAR(2)+500.
      IF(IPART.EQ. 1) XU(3) = ZENDPL+1000.
      IF(IPART.EQ.-1) XU(3) = ZENDMI
      CALL VEGAS(SF,.001,1000,9,XL,XU,AVG,SD,C2)
      AVG = AVG/FNORM
      SD = SD/FNORM
      WRITE(6,1133) AVG,SD,C2
 1133 FORMAT(10X,'---> VEGAS INTEGRAL RESULT : ',F12.5,/,
     *       10X,'---> ERROR + CHI**2 VALUE  : ',2F12.5)
      RETURN
C
C     PERFORM INTEGRATION OVER REQUESTED BLOCKS
C
  113 DO 114 IBL = 1,NBLOCK
      IBLOCK = IBLIST(IBL)
      CALL LIMINT(IBLOCK,IPART,IER,XL(1),XL(2),XL(3),XU(1),XU(2),XU(3))
      IF(IER.GT.0) GOTO 114
      CALL VEGAS(SF,.01,200,3,XL,XU,AVG,SD,C2)
      AVG = AVG/FNORM
      SD = SD/FNORM
      AVGSUM = AVGSUM+AVG
      BLCFRC(IBL) = AVG
  114 CONTINUE
C
      AVGDIF = 1.-AVGSUM
C
      RETURN
      END
C
      REAL FUNCTION SF(X)
C
C     FUNCTION TO BE INTEGRATED BY VEGAS
C                                       16/06/82
C
      COMMON /TRAFO/ STR,CTR,SPR,CPR,CTRCPR,CTRSPR,STRCPR,STRSPR,
     *               JPART,XMOV,YMOV,ZMOV
      COMMON /PARAME/ P(6)
      REAL X(3)
      DATA X0 /22.39/
C
      SF = 0.
C
C     TRANSFORM INTO CARTESIAN DETECTOR SYSTEM
C
      IF(JPART.NE.0) GOTO 1
      XDET = X(1)*COS(X(2))
      YDET = X(1)*SIN(X(2))
      ZDET = X(3)
      FJACOB = X(1)
      GOTO 2
    1 XDET = X(1)
      YDET = X(2)
      ZDET = X(3)
      FJACOB = 1.
C
C     LINEAR TRANSFORMATION TO SHOWER START POINT
C
    2 XLTR = XDET-XMOV
      YLTR = YDET-YMOV
      ZLTR = ZDET-ZMOV
C
C     ROTATE INTO SHOWER SYSTEM (FIRST CHECK SIGN OF ZSHW)
C
      ZSHW  =  XLTR * STRCPR   +   YLTR * STRSPR   +   ZLTR * CTR
C
      IF(ZSHW.LE.0.0) RETURN
C
      XSHW  =  XLTR * CTRCPR   +   YLTR * CTRSPR   -   ZLTR * STR
      YSHW  = -XLTR * SPR      +   YLTR * CPR
C
C     SCALE IN RADIATION LENGTHS
C
      RSHS = SQRT(XSHW*XSHW+YSHW*YSHW)/X0
      ZSHS = ZSHW/X0
C
C     COMPRESS SHOWER FUNCTION
C
      P3Z = P(3)*ZSHS
      REX = -1.*P(1)*ALOG(ZSHS)
      EX1 = -1.*(REX+P3Z+P(4)*RSHS)
      EX2 = -1.*(REX+P3Z+P(6)*RSHS)
      IF(EX1.LT.-10..OR.EX2.LT.-10.) RETURN
C
      SF =  P(2)*EXP(EX1) + P(5)*EXP(EX2)
C
C     JACOBIAN
C
      SF = SF*FJACOB
C
      RETURN
      END
C
      SUBROUTINE VEGAS(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C
C     SUBROUTINE PERFORMS N-DIMENSIONAL MONTE CARLO INTEGRATION
C     - BY PETER LEPAGE  SEPT 1976/(REV)APR 1978
C
C     COPIED FROM T00VER.AXOLIB.S       02/04/82
C     CHANGED                           20/06/82
C
C     ****                                                          ****
C     ****  THIS IS A MODIFIED VERSION OF THE ORIGINAL VEGAS        ****
C     ****  ROUTINE IN 'T00VER.AXOLIB.S'                            ****
C     ****  THE MAIN CHANGES ARE :                                  ****
C     ****  - ONLY FOR 3-DIMENSIONAL INTEGRATION                    ****
C     ****  - ALL REDUNDANT STATEMENTS REMOVED TO OBTAIN FASTER     ****
C     ****    EXECUTION                                             ****
C     ****  - NO DIVIDE CHECKS FOR INTEGRATION REGIONS WITH 'KINK'  ****
C     ****  - REDUCED NUMBER OF INPUT PARAMETERS                    ****
C     ****                                                          ****
C
      DIMENSION D(50,3),DI(50,3),XIN(50),R(50),DX(3),IA(3)
     1,KG(3),DT(3),XI(50,3)
      DIMENSION XL(3),XU(3)
      DIMENSION QRAN(3),X(3)
      DATA NDMX,ONE,MDS/50,1.,1/
      DATA XI /150*1./
      DSQRT(XXX)=SQRT(XXX)
      DLOG(XXX)=ALOG(XXX)
      NDO=1
      DO 1 J=1,3
    1 XI(1,J)=ONE
      ENTRY VEGAS1(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C      -INITIALIZES CUMMULATIVE VARIABLES, BUT NOT GRID
      IT=0
      SI=0.
      SI2=SI
      SWGT=SI
      SCHI=SI
      SCALLS=SI
      ENTRY VEGAS2(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C      - NO INITIALIZATION
      ND=NDMX
      NG=1
      IF(MDS.EQ.0)GO TO 2
      NG=(NCALL/2.)**.333
      MDS=1
      IF((2*NG-NDMX).LT.0)GO TO 2
      MDS=-1
      NPG=NG/NDMX+1
      ND=NG/NPG
      NG=NPG*ND
    2 K=NG*NG*NG
      NPG=NCALL/K
      IF(NPG.LT.2)NPG=2
      CALLS=NPG*K
      DXG=ONE/NG
      DV2G=DXG*DXG*DXG*DXG*DXG*DXG/NPG/NPG/(NPG-ONE)
      XND=ND
      NDM=ND-1
      DXG=DXG*XND
      XJAC=ONE
      DO 3 J=1,3
      DX(J)=XU(J)-XL(J)
    3 XJAC=XJAC*DX(J)
      IF(ND.EQ.NDO)GO TO 8
      RC=NDO/XND
      DO 7 J=1,3
      K=0
      XN=0.
      DR=XN
      I=K
    4 K=K+1
      DR=DR+ONE
      XO=XN
      XN=XI(K,J)
    5 IF(RC.GT.DR)GO TO 4
      I=I+1
      DR=DR-RC
      XIN(I)=XN-(XN-XO)*DR
      IF(I.LT.NDM)GO TO 5
      DO 6 I=1,NDM
    6 XI(I,J)=XIN(I)
    7 XI(ND,J)=ONE
      NDO=ND
      ACC=BCC
    8 CONTINUE
      ENTRY VEGAS3(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C      - MAIN INTEGRATION LOOP
    9 IT=IT+1
      ITS=IT
      TI=0.
      TSI=TI
      DO 10 J=1,3
      KG(J)=1
      DO 10 I=1,ND
      D(I,J)=TI
   10 DI(I,J)=TI
   11 FB=0.
      F2B=FB
      K=0
   12 K=K+1
      DO 112 J=1,3
  112 QRAN(J)=RN(0)
      WGT=XJAC
      DO 15 J=1,3
      XN=(KG(J)-QRAN(J))*DXG+ONE
      IA(J)=XN
      IAJ=IA(J)
      IF(IAJ.GT.1)GO TO 13
      XO=XI(IAJ,J)
      RC=(XN-IA(J))*XO
      GO TO 14
   13 XO=XI(IAJ,J)-XI(IAJ-1,J)
      RC=XI(IAJ-1,J)+(XN-IAJ)*XO
   14 X(J)=XL(J)+RC*DX(J)
   15 WGT=WGT*XO*XND
      F=FXN(X)*WGT
      F1=F/CALLS
      W=WGT/CALLS
      F2=F*F
      FB=FB+F
      F2B=F2B+F2
      DO 16 J=1,3
      IAJ=IA(J)
      DI(IAJ,J)=DI(IAJ,J)+F/CALLS
   16 IF(MDS.GE.0)D(IAJ,J)=D(IAJ,J)+F2
      IF(K.LT.NPG)GO TO 12
      F2B=DSQRT(F2B*NPG)
      F2B=(F2B-FB)*(F2B+FB)
      TI=TI+FB
      TSI=TSI+F2B
      IF(MDS.GE.0)GO TO 18
      DO 17 J=1,3
      IAJ=IA(J)
   17 D(IAJ,J)=D(IAJ,J)+F2B
   18 K=3
   19 KG(K)=MOD(KG(K),NG)+1
      IF(KG(K).NE.1)GO TO 11
      K=K-1
      IF(K.GT.0)GO TO 19
      TI=TI/CALLS
      TSI=TSI*DV2G
C
C     CHECK FOR TSI
C
      IF(TSI.GT.0.) GOTO 29
      AVGI = 0.
      SD = 0.
      CHI2A = 0.
      RETURN
C
   29 TI2=TI*TI
      WGT=TI2/TSI
      SI=SI+TI*WGT
      SI2=SI2+TI2
      SWGT=SWGT+WGT
      SCHI=SCHI+TI2*WGT
      SCALLS=SCALLS+CALLS
      AVGI=SI/SWGT
      SD=SWGT*IT/SI2
      CHI2A=0.
      IF(IT.GT.1)CHI2A=SD*(SCHI/SWGT-AVGI*AVGI)/(IT-.999)
      SD=DSQRT(ONE/SD)
      SDAV=SD/AVGI
      IF(ABS(SDAV).LE.ACC.OR.IT.GE.ITMX)NOW=2
      DO 23 J=1,3
      XO=D(1,J)
      XN=D(2,J)
      D(1,J)=(XO+XN)/2.
      DT(J)=D(1,J)
      DO 22 I=2,NDM
      D(I,J)=XO+XN
      XO=XN
      XN=D(I+1,J)
      D(I,J)=(D(I,J)+XN)/3.
   22 DT(J)=DT(J)+D(I,J)
      D(ND,J)=(XN+XO)/2.
   23 DT(J)=DT(J)+D(ND,J)
      DO 28 J=1,3
      RC=0.
      DO 24 I=1,ND
      R(I)=0.
      IF(D(I,J).LE.0)GO TO 24
      XO=DT(J)/D(I,J)
      R(I)=((XO-ONE)/XO/DLOG(XO))
   24 RC=RC+R(I)
      RC=RC/XND
      K=0
      XN=0
      DR=XN
      I=K
   25 K=K+1
      DR=DR+R(K)
      XO=XN
      XN=XI(K,J)
   26 IF(RC.GT.DR)GO TO 25
      I=I+1
      DR=DR-RC
      XIN(I)=XN-(XN-XO)*DR/R(K)
      IF(I.LT.NDM)GO TO 26
      DO 27 I=1,NDM
   27 XI(I,J)=XIN(I)
   28 XI(ND,J)=ONE
      SDAV=SD/AVGI
      IF(IT.LT.ITMX.AND.ACC.LT.ABS(SDAV))GO TO 9
      RETURN
      END
C
      SUBROUTINE LIMINT(IBLOCK,IPART,IER,XL1,XL2,XL3,XU1,XU2,XU3)
C
C     RETURNS INTEGRATION LIMITS USED BY VEGAS FOR INTEGRATION
C     OF THE SHOWER FUNCTION OVER THE BLOCK IBLOCK
C
C     XLI/ XUI  ARE IN CYLINDRICAL COORDINATES OR CARTESIAN COORDINATES
C               FOR BARREL OR ENDCAPS RESPECTIVELY
C
C
C                                       03/06/82
#include "cgeo1.for"
C
      XL1 = 0.
      XL2 = 0.
      XL3 = 0.
      XU1 = 0.
      XU2 = 0.
      XU3 = 0.
      IER = 0
      IB = IBLOCK
C
      IF((IB.GE.0).AND.(IB.LE.2879)) GO TO 13
      IER = 1
      GO TO 2000
C
   13 CONTINUE
      IF(IPART.NE.0) GO TO 12
      IF(IB.LE.2687) GOTO 14
      IER = 1
      GOTO 2000
   14 NFI =  IB/32
      NZET = IB - NFI*32
      PC = NFI*DELFI + DELFI/2.
      ZC = ZLGMI + NZET*BLZ + BLZ/2.
      XL1 = RLG
      XU1 = RLG + BLDEP
      XL2 = PC - DELFI/2.
      XU2 = PC + DELFI/2.
      XL3 = ZC - BLZ/2.
      XU3 = ZC + BLZ/2.
      GO TO 2000
C
   12 CONTINUE
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     CHECK FOR CONSIST. IPART - BLOCK# HAS TO BE WRITTEN   !!!!!!
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      BLXY2 = BLXY/2.
C     REDUCE TO NUMBERS 1 - 192
      IB = IB - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (IB - 1)/96
C     REDUCE TO 1 - 96
      IB = IB - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (IB - 1)/24
C     REDUCE TO 1 - 24
      IB = IB - NQ*24
C     CALCULATE CENTER COORDINATES
      IF(.NOT.((IB.EQ.1).OR.(IB.EQ.5).OR.(IB.EQ.10).OR.(IB.EQ.16)))
     1GO TO 43
      YC = BLXY2
      XC = 3.4*BLXY - BLXY2 + (IB/5)*BLXY
   43 CONTINUE
      IF(.NOT.((IB.EQ.2).OR.(IB.EQ.6).OR.(IB.EQ.11).OR.(IB.EQ.17)))
     1GO TO 44
      YC = BLXY2 + BLXY
      XC = 3.*BLXY - BLXY2 + (IB/5)*BLXY
   44 CONTINUE
      IF(.NOT.((IB.EQ.3).OR.(IB.EQ.7).OR.(IB.EQ.12).OR.(IB.EQ.18)))
     1GO TO 45
      YC = BLXY2 + 2.*BLXY
      XC = 2.*BLXY - BLXY2 + (IB/5)*BLXY
   45 CONTINUE
      IF(.NOT.((IB.EQ.8).OR.(IB.EQ.13).OR.(IB.EQ.19).OR.(IB.EQ.20)))
     1GO TO 46
      YC = BLXY2 + BLXY*3.
      K = IB/5
      IF(K.GT.2) K = 7 - K
      XC = (K+1)*BLXY-BLXY2
   46 CONTINUE
      IF(.NOT.((IB.EQ.4).OR.(IB.EQ.9).OR.(IB.EQ.15).OR.(IB.EQ.24)))
     1GO TO 47
      XC = BLXY - BLXY2
      K = (IB-1)/5
      IF(K.EQ.4) K = 3
      YC = 2.4*BLXY + BLXY2 + K*BLXY
   47 CONTINUE
      IF(.NOT.((IB.EQ.14).OR.(IB.EQ.23)))
     1GO TO 48
      XC = 2.*BLXY - BLXY2
      YC = 4.*BLXY + BLXY2 + (IB/15)*BLXY
   48 CONTINUE
      IF(.NOT.((IB.EQ.21).OR.(IB.EQ.22)))
     1GO TO 49
      YC = 4.*BLXY + BLXY2
      XC = - BLXY2 + 4.*BLXY - ((IB-2)/20)*BLXY
   49 CONTINUE
C     ROTATE TO CORRECT QUADRANT
      IF(NQ.NE.1) GO TO 50
      REM = XC
      XC = - YC
      YC = REM
      GO TO 2001
   50 CONTINUE
      IF(NQ.NE.2) GO TO 51
      XC = - XC
      YC = - YC
      GO TO 2001
   51 CONTINUE
      IF(NQ.NE.3) GO TO 2001
      REM = YC
      YC = - XC
      XC = REM
C
 2001 XL1 = XC - BLXY/2.
      XU1 = XC + BLXY/2.
      XL2 = YC - BLXY/2.
      XU2 = YC + BLXY/2.
      XL3 = ZENDPL
      XU3 = ZENDPL+DEPEND
      IF(IPART.EQ.-1) XL3=-XU3
      IF(IPART.EQ.-1) XU3=-XL3
C
 2000 CONTINUE
C
      RETURN
      END
C
      FUNCTION ICHECK(P1,P2,IPART)
C
C     CHECK WETHER IMPACT POINT (P1,P2) IS ON LG-SURFACE
C
C     ICHECK = 1 -->  O.K.
C                                       03/06/82
C
#include "cgeo1.for"
      DIMENSION MAP(6,6)
C
      ICHECK = 0
C
      IF(IPART.EQ.0) GO TO 1
C
      MAP(1,1)=   -1
      MAP(2,1)=   -1
      MAP(3,1)= 2688
      MAP(4,1)= 2692
      MAP(5,1)= 2697
      MAP(6,1)= 2703
      MAP(1,2)=   -1
      MAP(2,2)=   -1
      MAP(3,2)= 2689
      MAP(4,2)= 2693
      MAP(5,2)= 2698
      MAP(6,2)= 2704
      MAP(1,3)= 2691
      MAP(2,3)= 2690
      MAP(3,3)= 2694
      MAP(4,3)= 2699
      MAP(5,3)= 2705
      MAP(6,3)=   -1
      MAP(1,4)= 2696
      MAP(2,4)= 2695
      MAP(3,4)= 2700
      MAP(4,4)= 2707
      MAP(5,4)= 2706
      MAP(6,4)=   -1
      MAP(1,5)= 2702
      MAP(2,5)= 2701
      MAP(3,5)= 2709
      MAP(4,5)= 2708
      MAP(5,5)=   -1
      MAP(6,5)=   -1
      MAP(1,6)= 2711
      MAP(2,6)= 2710
      MAP(3,6)=   -1
      MAP(4,6)=   -1
      MAP(5,6)=   -1
      MAP(6,6)=   -1
      X = P1
      Y = P2
      IF((ABS(X).LT.(2.*BLXY)).AND.(ABS(Y).LT.(2.*BLXY))) GO TO 100
      IF((X.GT.0.).AND.(Y.GE.0.)) IQUAD=1
      IF((X.LE.0.).AND.(Y.GT.0.)) IQUAD=2
      IF((X.LT.0.).AND.(Y.LE.0.)) IQUAD=3
      IF((X.GE.0.).AND.(Y.LT.0.)) IQUAD=4
C
C     ROTATE (X,Y) INTO THE FIRST QUADRANT.
C
      JQUAD=0
    2 CONTINUE
      JQUAD=JQUAD+1
      IF(JQUAD.GE.IQUAD) GO TO 3
      XS = Y
      YS =-X
      X  =XS
      Y  =YS
      GO TO 2
    3 CONTINUE
      IF(Y.LT.BLXY) X=X-50.
      IF(X.LT.BLXY) Y=Y-50.
      IX=1.+X/BLXY
      IY=1.+Y/BLXY
      IF((IX.GT.6).OR.(IY.GT.6)) GO TO 100
      IBLK=MAP(IX,IY)
      IF(IBLK.LT.0) GO TO 100
      ICHECK = 1
      GO TO 100
C
    1 Z = P2
      IZ=(Z-ZLGMI)/BLZ
      IF((IZ.LT.1).OR.(IZ.GT.30)) GO TO 100
      ICHECK = 1
C
  100 RETURN
      END

C   07/06/96 606071836  MEMBER NAME  BWRITE   (S4)          FORTG1
      SUBROUTINE BWRITE(IUN)
C     BOS SUBPROGRAM =3.3=
      COMMON/BCS/IW(1)
      EXTERNAL BFRD
   10 CALL BWRS(IUN,NBUFL,INIW)
      IF(INIW.EQ.0) GOTO 100
      CALL BFWR(IUN,NBUFL,IW(INIW))
      GOTO 10
  100 RETURN
      END

C   10/05/79 C9051001   MEMBER NAME  BONDEC   (LGSOURCE)    FORTRAN
      SUBROUTINE BONDEC(X,Y,IN)
C
C     S.YAMADA /Y.YANAGISAWA  10-05-79 14:35
C     LAST MODIFICATION  10-05-79  14:40  BY S.YAMADA
C
C---- CHECK IF THE POINT(X,Y) IS IN THE END CAP
C     INPUT:
C           (X,Y) IN IN RAD.LENGTH
C     OUTPUT:
C            IN=0 IF OUTSIDE, =1 IF INSIDE.
C
      DIMENSION YENDR(7),XENDR(14)
      DATA YENDR/ 6.253, 12.51, 14.83, 25.01, 31.26, 37.52, 39.84/
      DATA XENDR/ 14.83, 12.51, 6.253,    0.,    0.,    0.,   0.,
     &            39.84, 37.52, 31.26, 31.26, 25.01, 12.51, 6.253/
C
      IN = 1
C
      XX = X
      IF(XX.LT.0.) XX = -XX
      YY = Y
      IF(YY.LT.0.) YY = -YY
        DO 30 I=1,7
        IF(YY.LE.YENDR(I))GO TO 31
   30   CONTINUE
      IN = 0
      RETURN
C
   31 IF((XX.GT.XENDR(I+7)) .OR. (XX.LT.XENDR(I))) IN = 0
      RETURN
      END

C   05/08/79 002080919  MEMBER NAME  VTXAFT   (JADEGS)      FORTRAN
      SUBROUTINE VTXAFT
C*800124*DITTMANN***************************************************
C*                                                                 *
C*          F I N I S H   X Y Z   V E R T E X   F I T              *
C*                                                                 *
C*       CALCULATE TRACK PARAMETERS AT VERTEX-NEAREST POINT        *
C*       FOR DETAILS OF THE T,V-ARRAYS SEE COMMENT IN SUBR. VERTEX.*
C*                                                                 *
C*******************************************************************
C
      COMMON /CWORK1/ NT,T(1500),NV,V(200)
      DIMENSION IV(2),IT(2)
      EQUIVALENCE (V(1),IV(1)),(T(1),IT(1))
C
      IF(NV.EQ.0) RETURN
C****
C****    EXTRAPOLATE ALL TRACKS TO VERTEX
      J = 0
      DO 9 I=1,NT
      IF(IT(J+1).EQ.0) GOTO 9
      IF(IT(J+14).EQ.0) GOTO 9
      LV = (IT(J+14)-1)*10
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,SS)
      T(J+3) = PHI
      T(J+5) = XT
      T(J+6) = YT
      T(J+7) = ZT
      T(J+10) = SQRT(DXT2)
      T(J+11) = SQRT(DYT2)
      T(J+12) = SQRT(DZT2)
      T(J+15) = SS
    9 J = J + 30
C
  100 RETURN
      END

C   11/01/88 801131646  MEMBER NAME  TPTGI1   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTGI1( ANALYS )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      11/01/88:  Get instructions about tagan
C
C     Last mod: C. Bowdery      13/01/88:  NPACLS --> IACLS
C
C     Routine to provide yes/no answer about need for tagging analysis.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     ANALYS    Out      L*4      TRUE if analysis step is to be done
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  TAGG*8, CIFND*20, CANALY*20

      LOGICAL  ANALYS, ANAL, IFND, FIRST

      INTEGER  LISTBK(10), IACLS

      SAVE  FIRST, ANAL, IFND

      DATA  FIRST / .TRUE. /
      DATA  TAGG  / 'TAGG' /, CIFND  / 'IFNOTDONE' /
      DATA                    CANALY / 'ANALYSE'   /

C------------------  C O D E  ------------------------------------------

C                            If not first call, ANAL/IFND already SAVEd.

      IF( FIRST ) THEN

C                            Get user option relating to tagg analysis
C                            that is, ANALYSE & IFNOTDONE

        CALL TPUOPT( TAGG, CANALY, ANAL )
        CALL TPUOPT( TAGG, CIFND,  IFND )

        FIRST = .FALSE.

      ENDIF

      IF( ANAL ) THEN

        ANALYS = .TRUE.

        IF( IFND ) THEN

C                            Find the compulsory tagging banks

          CALL CLOC( IACLS, 'ACLS', 0 )
          CALL BDAR( 'TAGG', MAXNUM, LISTBK, 10 )

C                            No 'ACLS'/0 or less than 3 'TAGG' banks?

          IF( IACLS .GT. 0  .AND.  MAXNUM .EQ. 3 ) THEN

C                            If 'TAGG'/0-2 all present and re-analysis
C                            not requested then do nothing


            ANALYS = .FALSE.

          ENDIF

        ENDIF

      ELSE

        ANALYS = .FALSE.

      ENDIF

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   25/07/79 006070613  MEMBER NAME  LGCHC2   (SOURCE)      FORTRAN
      SUBROUTINE LGCHC2
C
C     Y.WATANABE 25-07-79  03:50    VERSION 2,  COPIED FROM LGCHC2
C     LAST MODIFICATION 20-09-79  16:10 CXDCHG DIM=30 TO 100
C
C---- CHARGED PARTICLE CLUSTER IN THE LEAD GLASS COUNTER IS GENEATED
C     TO CONNECT THE INNER TRACK AND THE LG CLUSTER.
C     USED IN THE 2-ND STEP LG ANALYSIS.
C
C---- VERSION 2 INCLUDES THE EFFECT OF MULTIPLE SCATTERING IN THE COIL.
C     EXAMINES ALL THE INNER TRACKS.THE TRACKS WHICH DO NOT HIT THE
C     LEAD GLASS COUNTER ARE REGISTERED WITH EMPTY CLUSTERS.
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
      DIMENSION JBCCHG(9,100)
      EQUIVALENCE (CXDCHG(1,1),JBCCHG(1,1))
C---- CXDCHG  CONTAINS INNER TRACK INFORMATION
C     JBCCHG(1,N)     HITTING PART 0=BARREL, +/-1=+/-Z END CAP
C     CXDCHG(2,N)     CHARGE
C     CXDCHG(3-5,N)   HITTING POSITION ON THE COIL OR ON THE END CAP
C     CXDCHG(6-8,N)   DIRECTION COSIGNS
C     CXDCHG(9,N)     ABSOLUTE MOMENTUM IN GEV/C
C
#include "clgwork2.for"
C---- /CWORK/ STORES CLUSTERS EXPECTED FOR THE CHARGED TRACKS.
C     NCHCLS=NCHIND, MAPCCL(J)=START INDEX OF CLUSTER DATA IN HCLADR
C                              FOR THE J-TH CHARGED TRACK
C
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     1                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     2                ZECAP(4),ZECAPX(4),THECPX(2),
     3                ECXLST(24), EXYLST(24)
C
      DATA INIT/0/
      DIMENSION XZ(3,2),RAD2(2),DXY(2),XY(2,4)
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/379072623/
C
      IF(INIT.GT.0) GO TO 10
      NVRSN(11) = NVCODE
      INIT=1
      RAD2(1)=RADIUS(3)**2
      RAD2(2)=RADIUS(4)**2
      DEL=(RADIUS(1)+RADIUS(2))/2.
      DEL=(RADIUS(3)-DEL)*0.04
      BDR2=(RADIUS(4)-RADIUS(3))**2
      EDR2=THECPX(1)**2
      PHIDEV=RADIUS(3)*6.283184/84.
      DLBMIN=ZWID(1)
      DLEMIN=140.
      ZDEV=(ZEND(2)-ZEND(1)+ZGAP(1))/32.
      ZMEND=ZEND(1)-ZGAP(1)/2.
C     WRITE(6,590) DLBMIN,DLEMIN,DEL
C590  FORMAT('0 LGCDIR/LGCHC2. WINDOW SIZE FOR BARREL AND END CAP',
C    1  ' (CHGD TRACK TO LG) IN MM',5F12.4)
10    CONTINUE
C
      NPOINT = 0
      NCHCLS = NCHIND
      IF(NCHIND.EQ.0) RETURN
C
      IF(NCHIND.GT.100) NCHIND = 100
      DO 300 N=1,NCHIND
C
C---- MAP FOR THE CHARGE CLUSTERS
      MAPCCL(N) = NPOINT+1
C
      IBE=JBCCHG(1,N)
C     WRITE(6,600) N,IBE,(CXDCHG(J,N),J=2,9)
C600  FORMAT(' LGCHC2',2I5,10F10.4)
      IF(IABS(IBE).GT.1) GO TO 300
      IF(IBE) 200,100,200
C
C
C--------------   THE BARREL PART  ---------------------------
C----   TRACE TO THE FRONT SURFACE OF THE LEAD GLASS.
100   CONTINUE
      A=CXDCHG(6,N)**2+CXDCHG(7,N)**2
      B=CXDCHG(3,N)*CXDCHG(6,N)+CXDCHG(4,N)*CXDCHG(7,N)
      C=CXDCHG(3,N)**2+CXDCHG(4,N)**2
      B2=B*B
      DO 110 I=1,2
      XX=B2-A*(C-RAD2(I))
      IF(XX.LT.0.) XX=0.
      XX=SQRT(XX)
      TI=(XX-B)/A
      IF(XX.EQ.0.) TI=0.
      DO 110 J=1,3
      XZ(J,I)=CXDCHG(J+2,N)+TI*CXDCHG(J+5,N)
110   CONTINUE
C     WRITE(6,610) XZ
C610  FORMAT(' XZ',10F10.4)
C
C     UPDATE CXDCHG
      DO 112 J=1,3
112   CXDCHG(J+2,N)=(XZ(J,1)+XZ(J,2))/2.
      NSTEP=2
C     CHANGE TO PHI AND Z
      DO 120 I=1,2
      PHI=ATAN2(XZ(2,I),XZ(1,I))+6.283184
C     AVOID USING NEGATIVE NUMBERS
      XZ(1,I)=PHI
      XZ(2,I)=XZ(3,I)
120   CONTINUE
C     BE CAREFUL WITH THE PHI=0 BOUNDARY
      IF(ABS(XZ(1,1)-XZ(1,2)).LT.3.14159266) GO TO 130
      IF(XZ(1,1)-XZ(1,2)) 122,122,124
C     WORK AT LARGE POSITIVE PHI
122   XZ(1,1)=XZ(1,1)+6.283184
      GO TO 130
124   XZ(1,2)=XZ(1,2)+6.283184
130   DO 140 I=1,2
      XZ(1,I)=XZ(1,I)*RADIUS(3)
      XZ(2,I)=XZ(2,I)-ZMEND
140   CONTINUE
C     Z IS COUNTED FROM -ZEND
C
C     NOW CALCULATE THE POSITION UNCERTAINTY
C     DLT=0.04/PABS*SQRT(1X0)*(Z-ZCOIL)
      PABS=CXDCHG(9,N)
      IF(PABS.GT.16.) PABS=16.
      IF(PABS.LT.0.1) PABS=0.1
      DS=DEL/PABS
      IF(DS.LT.DLBMIN) DS=DLBMIN
      DR2=BDR2
      GO TO 220
C
C-------------   END CAP PART  ----------------------
C
200   CONTINUE
      NSTEP=2
      DZ=THECPX(1)/CXDCHG(8,N)
      DO 210 I=1,3
      XZ(I,1)=CXDCHG(I+2,N)
      XZ(I,2)=XZ(I,1)+DZ*CXDCHG(I+5,N)
210   CONTINUE
      DO 215 I=1,3
215   CXDCHG(I+2,N)=(XZ(I,1)+XZ(I,2))/2.
C     WRITE(6,610) XZ
      DS=DLEMIN
      DR2=EDR2
C
C--------------- COMMON TO BARREL AND END CAP ---------
C
220   CONTINUE
      DX=XZ(1,2)-XZ(1,1)
      IF(DX.GE.0.) GO TO 240
C     INTERCHANGE SO THAT DX>0
      DO 230 J=1,2
      DY=XZ(J,2)
      XZ(J,2)=XZ(J,1)
      XZ(J,1)=DY
230   CONTINUE
      DX=-DX
240   DY=XZ(2,2)-XZ(2,1)
      DSQ=DX*DX+DY*DY
      DL=DS*SQRT(1.+DSQ/DR2)
C
C     THE ERROR CIRCLE BECOMES AN ELLIPSE BY PROJECTION
C     DL AND DS ARE THE LONGER AND SHORTER WIDTH.
      DSQ=SQRT(DSQ)
      IF(DSQ.LT.1.E-15) DSQ=1.E-15
      DX=DX/DSQ
      DY=DY/DSQ
      IF(DSQ.LE.1.E-15) DX=1.
C     APPROXIMATE THE BOUNDARY BY A RECTANGLE
      DXY(1)=DL*DX
      DXY(2)=DL*DY
      DO 242 J=1,2
      XZ(J,1)=XZ(J,1)-DXY(J)
      XZ(J,2)=XZ(J,2)+DXY(J)
242   CONTINUE
      DXY(1)=-DS*DY
      DXY(2)=DS*DX
      IF(DXY(1).GT.0.) GO TO 244
      DXY(1)=-DXY(1)
      DXY(2)=-DXY(2)
244   CONTINUE
C     THIS IS TO DEFINE SUCH THAT X1<X2, AND X3<X4
C     WRITE(6,610) XZ
C     WRITE(6,615) DS,DL,DLMIN,DX,DY,DXY
C615  FORMAT(' DS,DL,..',10F10.3)
      DO 250 J=1,2
      XY(J,1)=XZ(J,1)-DXY(J)
      XY(J,2)=XZ(J,1)+DXY(J)
      XY(J,3)=XZ(J,2)-DXY(J)
      XY(J,4)=XZ(J,2)+DXY(J)
250   CONTINUE
C     XY ARE THE FOUR CORNERS OF THE ERROR RECTANGLE
C     WRITE(6,620) XY
C620  FORMAT(' XY',10F10.4)
      IF(IBE) 280,260,280
260   CONTINUE
C
C     BARREL PART AGAIN
C     SCALE THE COORDINATE INTO THE COUNTER SIZE
      DO 270 I=1,4
      XY(1,I)=XY(1,I)/PHIDEV
      XY(2,I)=XY(2,I)/ZDEV
270   CONTINUE
C     WRITE(6,620) XY
      CALL LGBHIT(XY,*400)
      GO TO 300
C
C     END CAP AGAIN
280   CONTINUE
      DO 290 I=1,4
      DO 290 J=1,2
290   XY(J,I)=XY(J,I)/140.
C     SCALE THEM TO THE COUNTER SIZE.
C     WRITE(6,620) XY
      CALL LGEHIT(XY,IBE,*400)
300   CONTINUE
      MAPCCL(NCHIND+1)=NPOINT+1
      RETURN
C
400   CALL LGMESG( 9, 1)
      NPOINT=NPMAX
      NCHIND=N
      NCHCLS=NCHIND
      MAPCCL(N+1)=NPOINT+1
      RETURN
      END

C   10/01/79 C9011001   MEMBER NAME  READSD   (JADELGS)     FORTRAN
      SUBROUTINE READSD(NUNIT,*)
C
C     S.YAMADA    10-01-79  10:20
C
C---- SIMPLE PROGRAM TO READ SEQUENTIAL DATA INTO /CDATA/.
C     IT IS USED TO AVOID THE APPEARENCE OF /CDATA/ IN THE @TESTLG.
C
      COMMON /CDATA/ LNGID,ID(4000)
C
      READ(NUNIT,END=100) LNGID,(ID(L),L=1,LNGID)
      RETURN
C
  100 RETURN 1
      END

C   11/08/87 708141527  MEMBER NAME  TPCNTR   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPCNTR
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      14/08/87:  Count no. of each track type
C
C
C
C     Routine to count no. of each particle type and charge and no.
C     of vertices and store these statistics in the TPEV bank.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      INTEGER  IFLAG( 4 )

C                            Array of bank pointers (TPTR, later TPVX)
C                            MAXLIM is maximum no. of  banks handled

      PARAMETER ( MAXLIM = 200 )

      INTEGER  INDA( MAXLIM )

#include "bosdata.for"

C------------------  C O D E  ------------------------------------------

      CALL CLOC( ITPEV, 'TPEV', 1 )
      IF( ITPEV .GT. 0 ) THEN
        ITPEV2 = ITPEV * 2

        DO  10  I = 1,4
          IFLAG(I) = 0
 10     CONTINUE

C                            Process TPTR banks to increment statistics
C                            on the no., type and charge for the event

        CALL BDAR( 'TPTR', NTRACK, INDA, MAXLIM )
        IF( NTRACK .EQ. MAXLIM ) THEN
          CALL TPWARN
        ENDIF

        DO  20  ITRK = 1,NTRACK
          CALL TPCNT1( ITPEV2, INDA( ITRK ), IFLAG )
 20     CONTINUE

C                            Set the flag to indicate seen particles

        HDATA( ITPEV2 + 31 ) = IFLAG(4)*1000 +
     +                         IFLAG(3)*100  +
     +                         IFLAG(2)*10   +
     +                         IFLAG(1)

C                            Collect vertex statistics (total, 0,+/-)

        NCVTX   = 0
        NNVTX   = 0

        CALL BDAR( 'TPVX', NVTX, INDA, MAXLIM )
        IF( NVTX .EQ. MAXLIM ) THEN
          CALL TPWARN
        ENDIF

        DO  30  IVTX = 1,NVTX
          ITPVX  = INDA( IVTX )
          ITPVX2 = ITPVX * 2
          IF( HDATA( ITPVX2 + 21 ) .EQ. 0 ) THEN

C                            Count this neutral vertex if not primary

            IF( IDATA( ITPVX - 2 ) .NE. 1 ) NNVTX = NNVTX + 1

          ELSE

            NCVTX = NCVTX + 1

          ENDIF
  30    CONTINUE

        HDATA( ITPEV2 + 12 ) = NVTX
        HDATA( ITPEV2 + 13 ) = NNVTX
        HDATA( ITPEV2 + 14 ) = NCVTX

      ELSE

        CALL TPERRH

      ENDIF

      RETURN
      END

C   14/05/80 411201608  MEMBER NAME  TOFVW    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TOFVW
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON   14/05/80 :  TOF V MOMENTUM DIAGRAM FOR 1 EVENT
C
C        MOD: J. OLSSON   28/05/82 :
C   LAST MOD: C. BOWDERY  19/03/84 :  IMPROVED LAYOUT
C
C        SHOW TOF VS MOMENTUM DIAGRAM FOR ONE EVENT
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
#include "cdata.for"
#include "chsym.for"
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CWORK1 / HMW(132)
      COMMON / CWORK  / NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),
     +                  TRK(5,50),ITRC(50),NTC,ITRK(5,42),
     +                  INFM(4),IR(14,50)
C
      DIMENSION    RE(14,50) , ARMAS(4)
      EQUIVALENCE  (RE(1,1),IR(1,1))
C
      DATA ARMAS / 0.000511, 0.139567, 0.49367, 0.93828 /
C
C-------------------  C O D E  -----------------------------------------
C
C                            OPTION 2 DRAWS A FULL SIZE PICTURE
C                            OPTION 4 DRAWS A SMALL PICTURE
C
      NN = ACMD
      IF( NN .NE. -4 ) GO TO 1
        CALL TWINDO(3265,4095,-30,800)
        GO TO 2
C
   1    CALL ERASE
        CALL TWINDO(0,4095,0,4095)
C
   2  XMINRE = XMIN
      XMAXRE = XMAX
      YMINRE = YMIN
      YMAXRE = YMAX
      XMIN   = -0.3
      YMIN   = -0.45
      XMAX   =  1.7
      YMAX   =  2.15
C
C                            DEFINE THE COORDINATE SYSTEM
C
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
C
C                            DRAW DIAGRAM FRAME
C
      FRAC  = ALOG10( 5.0 )
      XVMAX = 2.0 - FRAC * 0.5
      CALL MOVEA(   0.0, 0.0 )
      CALL DRAWA( XVMAX, 0.0 )
      CALL DRAWA( XVMAX, 1.2 )
      CALL DRAWA(   0.0, 1.2 )
      CALL DRAWA(   0.0, 0.0 )
C
C                            DRAW SCALE MARKERS EXCEPT FOR SMALL VIEW
C
      IF( NN .EQ. -4 ) GO TO 6
      CALL CHRSIZ(2)
      CALL MOVEA( -0.08, -0.08 )
      CALL CORE(HMW,5)
      WRITE(JUSCRN,4)
   4  FORMAT(' 0.05')
      CALL EOUTST(5,HMW)
C
   6  FRAC1 = (1.0 - FRAC) * 0.5
      CALL MOVEA( FRAC1, 0.0  )
      CALL DRAWA( FRAC1, 0.03 )
C
      IF( NN .EQ. -4 ) GO TO 10
      CALL MOVEA( FRAC1 - 0.06, -0.08 )
      CALL CORE(HMW,4)
      WRITE(JUSCRN,8)
   8  FORMAT(' 0.1')
      CALL EOUTST(4,HMW)
C
  10  CALL MOVEA( FRAC1 + FRAC * 0.5, 0.0   )
      CALL DRAWA( FRAC1 + FRAC * 0.5, 0.02  )
      CALL MOVEA( FRAC1 + 0.5       , 0.0   )
      CALL DRAWA( FRAC1 + 0.5       , 0.03  )
C
      IF( NN .EQ. -4 ) GO TO 14
      CALL MOVEA( FRAC1 + 0.47      , -0.08 )
      CALL CORE(HMW,2)
      WRITE(JUSCRN,12)
  12  FORMAT(' 1')
      CALL EOUTST(2,HMW)
C
  14  CALL MOVEA( FRAC1 + (1.0 + FRAC) * 0.5, 0.0  )
      CALL DRAWA( FRAC1 + (1.0 + FRAC) * 0.5, 0.02 )
      CALL MOVEA( FRAC1 + 1.0, 0.0  )
      CALL DRAWA( FRAC1 + 1.0, 0.03 )
C
      IF( NN .EQ. -4 ) GO TO 18
      CALL MOVEA( FRAC1 + 0.96, -0.08 )
      CALL CORE(HMW,3)
      WRITE(JUSCRN,16)
  16  FORMAT(' 10')
      CALL EOUTST(3,HMW)
C
  18  CALL MOVEA( FRAC1 + (2.0 + FRAC) * 0.5, 0.   )
      CALL DRAWA( FRAC1 + (2.0 + FRAC) * 0.5, 0.02 )
C
      IF( NN .EQ. -4 ) GO TO 22
      CALL MOVEA( FRAC1 + 1.45, -0.08 )
      CALL CORE(HMW,4)
      WRITE(JUSCRN,20)
  20  FORMAT(' 100')
      CALL EOUTST(4,HMW)
C
      CALL MOVEA( -0.09, 0.18 )
      CALL CORE(HMW,3)
      WRITE(JUSCRN,21)
  21  FORMAT(' .2')
      CALL EOUTST(3,HMW)
C
  22  CALL MOVEA( 0.0,  0.2 )
      CALL DRAWA( 0.03, 0.2 )
C
      IF( NN .EQ. -4 ) GO TO 26
      CALL MOVEA( -0.09, 0.38 )
      CALL CORE(HMW,3)
      WRITE(JUSCRN,24)
  24  FORMAT(' .4')
      CALL EOUTST(3,HMW)
C
  26  CALL MOVEA( 0.0,  0.4 )
      CALL DRAWA( 0.03, 0.4 )
C
      IF( NN .EQ. -4 ) GO TO 30
      CALL MOVEA( -0.09, 0.58)
      CALL CORE(HMW,3)
      WRITE(JUSCRN,28)
  28  FORMAT(' .6')
      CALL EOUTST(3,HMW)
C
  30  CALL MOVEA( 0.0,  0.6 )
      CALL DRAWA( 0.03, 0.6 )
C
      IF( NN .EQ. -4 ) GO TO 34
      CALL MOVEA( -0.09, 0.78 )
      CALL CORE(HMW,3)
      WRITE(JUSCRN,32)
  32  FORMAT(' .8')
      CALL EOUTST(3,HMW)
C
  34  CALL MOVEA( 0.0,  0.8 )
      CALL DRAWA( 0.03, 0.8 )
      IF( NN .EQ. -4 ) GO TO 38
      CALL MOVEA( -0.09, 0.98 )
      CALL CORE(HMW,3)
      WRITE(JUSCRN,36)
  36  FORMAT(' 1.')
      CALL EOUTST(3,HMW)
C
  38  IF( NTRK .NE. 0 ) GO TO 40
        CALL TRMOUT(80,'NO TRACKS TO DISPLAY^')
        GO TO 998
C
  40  DO  100  ITR = 1,NTRK
      LTR = IR(1,ITR)
      PP = TRK(4,LTR)
        IF( IR(2,ITR) .NE. 1  .AND.  IR(2,ITR) .NE. 2 ) GO TO 100
        BETA  = RE(13,ITR)
        DBETA = RE(7,ITR)
        PBETA = ABS(TRK(4,LTR))
        IF( BETA  .LT.   0.0  .OR.   BETA .GT. 1.3  ) GO TO 100
        IF( PBETA .GT. 100.0  .OR.  PBETA .LT. 0.05 ) GO TO 100
        PBETA = ALOG10(PBETA)
        PBETA = FRAC1 + (1.0 + PBETA) * 0.5
C
        CALL PLYGON( 10, 0.012, PBETA, BETA, 0 )
C
        CALL MOVEA( PBETA, BETA + 0.012 )
        CALL DRAWA( PBETA, BETA + DBETA )
        CALL MOVEA( PBETA, BETA - 0.012 )
        CALL DRAWA( PBETA, BETA - DBETA )
C
        DESIZE = 0.032
        IF( NN .EQ. -4 ) DESIZE = 0.11
        CALL DNUM( ITR, PBETA + 0.02, BETA + 0.02, DESIZE, 0.0 )
C
 100  CONTINUE
C
C                            DRAW "THEORETICAL" CURVES IN PLOT
C
      CALL MOVEA( 0.0, 1.0 )
      CALL DASHA( XVMAX, 1.0, 14 )
C
      DO  200  IMS = 2,4
        FMASS  = ARMAS(IMS)
        FMASS2 = FMASS**2
        PXX    = 0.0
        IMMM   = 0
        PADD   = 0.002
        DO  150  IMM = 1,1500
          IF( IMM .EQ.  500 ) PADD = 0.02
          IF( IMM .EQ. 1000 ) PADD = 0.2
          PXX = PXX + PADD
          PX  = PXX
          IF( PX .GT. 100.0  .OR.  PX .LT. 0.05 )  GO TO 150
          BETA = PX / SQRT( PX * PX + FMASS2 )
          IF( BETA .LT. 0.0  .OR.  BETA .GT. 1.0 ) GO TO 150
          PX   = ALOG10(PX)
          PX   = FRAC1 + (1.0 + PX) * 0.5
          IMMM = IMMM  + 1
          IF( IMMM .EQ. 1 ) CALL MOVEA( PX, BETA )
          IF( IMMM .NE. 1 ) CALL DRAWA( PX, BETA )
 150    CONTINUE
 200  CONTINUE
C
      IF( NN .EQ. -4 ) GO TO 998
      CALL MOVEA( 1.5, -0.12 )
      CALL CHRSIZ(2)
      CALL CORE(HMW,6)
      WRITE(JUSCRN,209)
 209  FORMAT(' GeV/c')
      CALL EOUTST(6,HMW)
      CALL MOVEA( -0.24, 0.9 )
      CALL CORE(HMW,6)
      WRITE(JUSCRN,211)
 211  FORMAT(' Beta ')
      CALL EOUTST(6,HMW)
C
C                            WRITE CAPTION
C
      INDES = -2
      CALL CAPMRK(INDES,IESUM)
998   CALL TWINDO(0,4095,0,4095)
      XMIN = XMINRE
      XMAX = XMAXRE
      YMIN = YMINRE
      YMAX = YMAXRE
C
      CALL SETSCL(LASTVW)
C
      RETURN
      END

C   21/05/81 105211757  MEMBER NAME  USREPTIL (JADESR)      FORTRAN
C   21/04/81 104211851  MEMBER NAME  USERRECL (S)           FORTRAN
      SUBROUTINE USER(INDEX)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C---
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C---
      COMMON /CTLIM/ ISECLF
      DIMENSION IGG(30)
      DATA NREC/ 0/
C---
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   MUON CHAMBER TRACKING HAS BEEN DONE.
C              9   MUON AND INNER DETECTOR TRACKS HAVE BEEN ASSOCIATED.
C             10   UNUSED
C             11   WRITE EVENT IMMEDIATELY WITHOUT FURTHER ANALYSIS.
C             12   END PROGRAM.
C---
C---     CHECK WHETHER CALL AT END OF JOB
      IF(INDEX.EQ.100) GOTO 1100
C
      GO TO (1001,1002,1003,1004,1005,1006,1007,1008,1009,1010),INDEX
C---
C---     INDEX=0 INITIALIZATION.
C---
      ISECLF=5
      IHEAD=IBLN('HEAD')
      IJETC=IBLN('JETC')
      IJHTL=IBLN('JHTL')
      IPATR=IBLN('PATR')
      NWRIT=0
      DO 3910  I = 1,30
3910  IGG(I) = 0
      INDEX=INDEX+1
      RETURN
C
 1001 CONTINUE
      IHHEAD=2*IDATA(IHEAD)
      NRUN=HDATA(IHHEAD+10)
      INDEX=INDEX+1
      RETURN
C
 1002 CONTINUE
      NREC=NREC+1
      IHHEAD=IDATA(IHEAD)*2
      NEVT=HDATA(IHHEAD+11)
C
C     NO NEW PATREC IF NO PATR-BANK OR NO TRACKS
C
      IPPATR=IDATA(IPATR)
      IGG(1) = IGG(1) + 1
C     IF(IPPATR.LE.0) GO TO 11
C     IF(IDATA(IPPATR+2).LE.0) GOTO 11
C
C     CHANGED TO NO PATREC IF OLD EXISTS 18.5.81 A. PETERSEN
      IF(IPPATR.GT.0.AND.IDATA(IPPATR+2).GT.0) IGG(2) = IGG(2) + 1
      IF(IPPATR.GT.0.AND.IDATA(IPPATR+2).GT.0) GOTO 11
C
      IPJETC=IDATA(IJETC)
      IF(IPJETC.LE.0) WRITE(6,100) NREC,NRUN,NEVT
  100 FORMAT(1X,' NO JETC BANK. SEQ NO. RUN AND EVENT = ',3I6)
      IF(IPJETC.LE.0) IGG(3) = IGG(3) + 1
      IF(IPJETC.LE.0) GO TO 11
      IGG(4) = IGG(4) + 1
      NA=IDATA(IPJETC-3)
      NR=IDATA(IPJETC-2)
      IPJETC=IDATA(IPJETC-1)
C     IF(IPJETC.LE.0) WRITE(6,101) NREC,NRUN,NEVT
C 101 FORMAT(1X,' NO SECOND JETC BANK. SEQ NO. RUN AND EVENT = ',3I6)
      IF(IPJETC.LE.0) IGG(5) = IGG(5) + 1
      IF(IPJETC.LE.0) GO TO 13
      CALL BDLS(NA,NR)
   13 CONTINUE
      IPJHTL=IDATA(IJHTL)
      IF(IPJHTL.LE.0) GO TO 14
      NA=IDATA(IPJHTL-3)
      NR=IDATA(IPJHTL-2)
      CALL BDLS(NA,NR)
      GO TO 13
   14 CONTINUE
      IPPATR=IDATA(IPATR)
      IF(IPPATR.LE.0) GO TO 15
      NA=IDATA(IPPATR-3)
      NR=IDATA(IPPATR-2)
      CALL BDLS(NA,NR)
      GO TO 14
   15 CONTINUE
      CALL BGAR(IGA)
      IF(IGA.NE.1) IGG(6) = IGG(6) + 1
      IF(IGA.NE.1.AND.IPJETC.GT.0) IGG(7) = IGG(7) + 1
      IF(IGA.NE.1.AND.IPJETC.GT.0) WRITE(6,102) IGA,NREC,NRUN,NEVT
  102 FORMAT(1X,' BGAR ERROR     ',I6,'    SEQ NO RUN AND EVT = ',3I6)
      CALL JETCAL
      IND=0
      CALL PATREC(IND)
      GO TO 11
C
 1003 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1004 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1005 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1006 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1007 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1008 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1009 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1010 CONTINUE
      INDEX=INDEX+1
      RETURN
C---     END OF JOB: FINAL CALCULATIONS + PRINTOUT
 1100 CONTINUE
      WRITE(6,1291) IGG
1291  FORMAT(' IGG ',10I8)
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---
    1 CONTINUE
      INDEX=1
      RETURN
    2 CONTINUE
      INDEX=2
      RETURN
    3 CONTINUE
      INDEX=3
      RETURN
    4 CONTINUE
      INDEX=4
      RETURN
    5 CONTINUE
      INDEX=5
      RETURN
    6 CONTINUE
      INDEX=6
      RETURN
    7 CONTINUE
      INDEX=7
      RETURN
    8 CONTINUE
      INDEX=8
      RETURN
    9 CONTINUE
      INDEX=9
      RETURN
   10 CONTINUE
      INDEX=10
      RETURN
   11 CONTINUE
      INDEX=11
      RETURN
   12 CONTINUE
      INDEX=12
      RETURN
      END

C   15/02/82 704231156  MEMBER NAME  ATOFUN   (S)           FORTRAN
      SUBROUTINE ATOFUN(IPTOF)
C
C  ROUTINE TO UNPACK ATOF BANK
C  TOF COUNTERS WILL BE IN ARRAYS HADC,HTDC
C  FORWRD MUON COUNTERS WILL BE IN ARRAYS HADCF,HTDCF
C
      IMPLICIT INTEGER*2 (H)
#include "chead.for"
***PMF include "ddatas.for"
#include "ddata.for"
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HSTAT(42),HON(42)
      COMMON/FWPED/ HADCF(2,16),HTDCF(2,16),HFSTAT(16),HFON(16)
      COMMON/TFPED1/HTDC1(2,42),HON1(42),HTSPAR(16)
C
      DATA IBUG /10/,IERR,IERRAD/2*0/
C
      IBUG = IBUG + 1
      NRUN = HEADR(18)
      IEV  = HEADR(19)
C
      CALL SETSL(HON,0,42*2,0)
      CALL SETSL(HFON,0,16*2,0)
      CALL SETSL(HON1,0,42*2,0)
      JPTOF = IPTOF*2
      NLENG = IDATA(IPTOF)*2
      ITOFE =  JPTOF+NLENG
      HADC(1,1) = -99
C
C  BANK DESCRIPTOR
      IBDSCR = HDATA(JPTOF+1)
C
C  FOR MONTE CARLO
      IF(NRUN.EQ.0.AND.IBDSCR.EQ.0) IBDSCR = 1
      IF(IBDSCR.LT.1.OR.IBDSCR.GT.4)  GOTO  999
      GOTO  (100,200,300,400),IBDSCR
  999 IERR = IERR + 1
      IF(IERR.GT.10) RETURN
      PRINT 901,NRUN,IEV,IERR,IBDSCR,JPTOF
  901 FORMAT(' MESSAGE FROM TOF PROGRAM : BANK DESCR ERROR, PRINTING
     1 WILL STOP AFTER 20 ERRORS!',5I8)
      CALL ATOFRW(IPTOF)
      RETURN
C
  100 CONTINUE
      ITOFA =  2
      ITOFT = 93
      IMUA =  201
      IMUT =  240
      DO   1   I=1,44
      IF1 = 2*I-1
      IF2 = IF1 + 1
      JTOFT = JPTOF + ITOFT + IF1 + (IF1-1)/8
      JTOFA = JPTOF + ITOFA + IF1 + (IF1-1)/12
      IF(JTOFA+1.GT.ITOFE) GOTO  998
      IF(I.GT.16)  GOTO  2
C FORWARD MUON COUNTERS
      JMUT = JPTOF + IMUT + IF1 + (IF1-1)/8
      JMUA = JPTOF + IMUA + IF1 + (IF1-1)/12
      HADCF(1,I) = HDATA(JMUA)
      HADCF(2,I) = HDATA(JMUA+1)
      HTDCF(1,I) = HDATA(JMUT)
      HTDCF(2,I) = HDATA(JMUT+1)
      IF(HTDCF(1,I).LT.2048.OR.HTDCF(2,I).LT.2048) HFON(I) = I
    2 IF(I.GT.42)  GOTO  3
C TOFCOUNTERS
      HADC(1,I) = HDATA(JTOFA)
      HADC(2,I) = HDATA(JTOFA+1)
      HTDC(1,I) = HDATA(JTOFT)
      HTDC(2,I) = HDATA(JTOFT+1)
      IF(HTDC(1,I).LT.2048.OR.HTDC(2,I).LT.2048) HON(I) = I
      GOTO  1
    3 CONTINUE
C SPARE TDCS
      HTDC1(1,I-42) = HDATA(JTOFT)
      HTDC1(2,I-42) = HDATA(JTOFT+1)
      IF(HTDC1(1,I-42).LT.2048.OR.HTDC1(2,I-42).LT.2048)HON1(I-42)=I-42
    1 CONTINUE
      RETURN
  998 IERR = IERR + 1
      IF(IERR.GT.10) RETURN
      PRINT 903,NRUN,IEV,IERR,JPTOF,NLENG
  903 FORMAT(' MESS. FROM TOFPROG: WRONG BANKLENGTH PRINTING WILL STOP
     1 AFTER 20 !',7I8)
      CALL ATOFRW(IPTOF)
      RETURN
C
  200 CONTINUE
      CALL SETSL(HADC,0,42*4,0)
      CALL SETSL(HADCF,0,32*4,0)
      DO   35   I=1,42
      IF(I.LE.16) HTSPAR(I) = 2048
      DO   35   L=1,2
      HTDC1(L,I) = 2048
      HTDC(L,I) = 2048
      IF(I.LE.16) HTDCF(L,I) = 2048
   35 CONTINUE
      ITOFA =  JPTOF +4
      ITOFAA=  ITOFA
   30 IADD = HDATA(ITOFA)
      IAD = IADD
      IF(IAD.LE.0)  GOTO  39
      ITDC1 = HDATA(ITOFA+1)
      ITDC2 = HDATA(ITOFA+2)
      IADC1 = HDATA(ITOFA+3)
      IADC2 = HDATA(ITOFA+4)
   36 CONTINUE
      IF(IAD.GT.42)  GOTO  37
      HTDC(1,IAD)=ITDC1
      HTDC(2,IAD)=ITDC2
      HADC(1,IAD)=IADC1
      HADC(2,IAD)=IADC2
      IF(HTDC(1,IAD).LT.2048.OR.HTDC(2,IAD).LT.2048) HON(IAD) = IAD
      GOTO  31
   37 IF(IAD.GE.100) GOTO  38
      IBD = IAD-42
      IF(IBD.GT.42)  GOTO  39
      HTDC1(1,IBD) = ITDC1
      HTDC1(2,IBD) = ITDC2
      IF(HTDC1(1,IBD).LT.2048.OR.HTDC1(2,IBD).LT.2048) HON1(IBD) = IBD
      GOTO  31
   38 CONTINUE
      IAD = IAD - 99
      IF(IAD.GT.16)  GOTO  39
      HTDCF(1,IAD)=ITDC1
      HTDCF(2,IAD)=ITDC2
      IF(HTDCF(1,IAD).LT.2048.OR.HTDCF(2,IAD).LT.2048) HFON(IAD) = IAD
      HADCF(1,IAD)=IADC1
      HADCF(2,IAD)=IADC2
   31 CONTINUE
      GOTO  33
   39 IERRAD = IERRAD + 1
      IF(IERRAD.LE.10) PRINT 902,NRUN,IEV,IBUG,IERRAD,IADD,IAD,IBD
  902 FORMAT(' MESS. FROM TOF PROG : NRUN,IEV,NEV ',3I8,
     *    ' ERROR IN TOF ADDR',7I5)
      IF(IERRAD.LE.10) CALL ATOFRW(IPTOF)
C TRY TO FIND NEW ADDRESS
   34 ITOFA = ITOFA + 1
      IAD = HDATA(ITOFA)
      IF(ITOFA+4.GT.ITOFE)  RETURN
      IF(IAD.GT.0)  GOTO  34
      ITOFA = ITOFA + 1
      GOTO 32
C
   33 ITOFA = ITOFA + 6
   32 IF(ITOFA+4.LE.ITOFE)  GOTO  30
C
      RETURN
C
  300 CONTINUE
C CRATE 3
C TOFCOUNTERS  1-30, SPARES 1-8
      ITOFA =  2
      ITOFT = 76
      DO  51   I=1,30
      IF1 = 2*I-1
      JTOFA = JPTOF + ITOFA + IF1 + (IF1-1)/12
      IF4 = 4*I-3
      JTOFT = JPTOF + ITOFT + IF4 + (IF4-1)/8
      IF(JTOFT+3.GT.ITOFE) GOTO  998
      HADC(1,I) = HDATA(JTOFA)
      HADC(2,I) = HDATA(JTOFA+1)
      HTDC(1,I) = HDATA(JTOFT)
      HTDC(2,I) = HDATA(JTOFT+1)
      HTDC1(1,I) = HDATA(JTOFT+2)
      HTDC1(2,I) = HDATA(JTOFT+3)
      IF(HTDC(1,I).LT.2048.OR.HTDC(2,I).LT.2048) HON(I) = I
      IF(HTDC1(1,I).LT.2048.OR.HTDC1(2,I).LT.2048) HON1(I) = I
   51 CONTINUE
C CRATE 4
C TOFCOUNTERS  31-42,SPARES 9-16
      ITOFA =  211
      ITOFT =  237
      IA = 30
      DO  55   J=31,42
      I = J - IA
      IF1 = 2*I-1
      JTOFA = JPTOF + ITOFA + IF1 + (IF1-1)/12
      IF4 = 4*I-3
      JTOFT = JPTOF + ITOFT + IF4 + (IF4-1)/8
      IF(JTOFT+3.GT.ITOFE) GOTO  998
      HADC(1,J) = HDATA(JTOFA)
      HADC(2,J) = HDATA(JTOFA+1)
      HTDC(1,J) = HDATA(JTOFT)
      HTDC(2,J) = HDATA(JTOFT+1)
      HTDC1(1,J) = HDATA(JTOFT+2)
      HTDC1(2,J) = HDATA(JTOFT+3)
      IF(HTDC(1,J).LT.2048.OR.HTDC(2,J).LT.2048) HON(J) = J
      IF(HTDC1(1,J).LT.2048.OR.HTDC1(2,J).LT.2048) HON1(J) = J
   55 CONTINUE
C
C FORWARD MUON COUNTERS
      IMUA =  300
      IMUT =  339
      DO   61   I=1,16
      IF1 = 2*I-1
      IF2 = IF1 + 1
      JMUT = JPTOF + IMUT + IF1 + (IF1-1)/8
      JMUA = JPTOF + IMUA + IF1 + (IF1-1)/12
      HADCF(1,I) = HDATA(JMUA)
      HADCF(2,I) = HDATA(JMUA+1)
      HTDCF(1,I) = HDATA(JMUT)
      HTDCF(2,I) = HDATA(JMUT+1)
      IF(HTDCF(1,I).LT.2048.OR.HTDCF(2,I).LT.2048) HFON(I) = I
   61 CONTINUE
C
C SPARE TDCS
      ISP1 =  67
      ISP2 =  291
      DO   65   I=1,8
      JSP1 = JPTOF + ISP1 + I
      JSP2 = JPTOF + ISP2 + I
      HTSPAR(I) = HDATA(JSP1)
      HTSPAR(I+8) = HDATA(JSP2)
   65 CONTINUE
      RETURN
C
  400 CONTINUE
      CALL SETSL(HADC,0,42*4,0)
      CALL SETSL(HADCF,0,32*4,0)
      DO  405   I=1,42
      IF(I.LE.16) HTSPAR(I) = 2048
      DO  405   L=1,2
      HTDC1(L,I) = 2048
      HTDC(L,I) = 2048
      IF(I.LE.16) HTDCF(L,I) = 2048
  405 CONTINUE
      ITOFA =  JPTOF+4
      ITOFAA =  ITOFA
  410 IADD = HDATA(ITOFA)
      ITFAD = 8
      IF(IADD.GT.99)  GOTO 460
      IF(ITOFA+ITFAD-2.GT.ITOFE)  RETURN
      IF(IADD.LT.1)  GOTO 450
      IF(IADD.GT.42)  GOTO 450
      HTDC(1,IADD)= HDATA(ITOFA+1)
      HTDC(2,IADD)= HDATA(ITOFA+2)
      HTDC1(1,IADD)= HDATA(ITOFA+3)
      HTDC1(2,IADD)= HDATA(ITOFA+4)
      HADC(1,IADD)= HDATA(ITOFA+5)
      HADC(2,IADD)= HDATA(ITOFA+6)
      IF(HTDC(1,IADD).LT.2048.OR.HTDC(2,IADD).LT.2048)HON(IADD) = IADD
      IF(HTDC1(1,IADD).LT.2048.OR.HTDC1(2,IADD).LT.2048)HON1(IADD)=IADD
      GOTO 480
  450 IBD = IADD+1
      ITFAD = 8
      IF(IBD.LT.1.OR.IBD.GT.44)  GOTO 470
      IF(IBD.GE.44)  IBD = 9
      DO  453  L=1,6
      HTSPAR(IBD-1+L) = HDATA(ITOFA+L)
  453 CONTINUE
      GOTO  480
  460 CONTINUE
      ITFAD = 6
      IF(ITOFA+ITFAD-2.GT.ITOFE)  RETURN
      IAD = IADD - 99
      IF(IAD.LT.1)  GOTO  470
      IF(IAD.GT.16)  GOTO  470
      HTDCF(1,IAD)=HDATA(ITOFA+1)
      HTDCF(2,IAD)=HDATA(ITOFA+2)
      IF(HTDCF(1,IAD).LT.2048.OR.HTDCF(2,IAD).LT.2048) HFON(IAD) = IAD
      HADCF(1,IAD)=HDATA(ITOFA+3)
      HADCF(2,IAD)=HDATA(ITOFA+4)
C     PRINT 1401,(HDATA(ITOFA+L),L=1,4),HFON
      GOTO  480
  470 IERRAD = IERRAD + 1
      IF(IERRAD.LE.10) PRINT 902,NRUN,IEV,IBUG,IERRAD,IADD,IAD,IBD
      IF(IERRAD.LE.10) CALL ATOFRW(IPTOF)
C TRY TO FIND NEW ADDRESS
  475 ITOFA = ITOFA + 1
      IAD = HDATA(ITOFA)
      IF(ITOFA+ITFAD.GT.ITOFE)  RETURN
      IF(IAD.GT.0)  GOTO  475
      ITOFA = ITOFA + 1
      GOTO 410
C
  480 ITOFA = ITOFA + ITFAD
      GOTO  410
C
  500 RETURN
      END

C   23/03/97 703231219  MEMBER NAME  JEOSUM1  (SOURCE)      FORTRAN
C   04/11/81 809081600  MEMBER NAME  $HIST    (SOURCE)      FORTRAN
C
C   04-11-81   16:00      CHANGED MEMBERS (DEBUGGED)
C        ELGOBS, ENGLOS
C
C   11-12-81   XX:00      CHANGED MEMBERS
C        POSENDN          NEW VERSION OF POSEND.(DEBUGGED BY TAKEDA)
C
C   14-12-81   09:00      CHANGED MEMBERS
C        LGMESG           MODIFIED FOR DETAIED MESSAGE.
C
C   14-12-81   16:25      CHANGED MEMBERS
C        POSEND           DEBUGGED.    ENERGY CORRECTION WAS NOT
C                         CORRECT FOR END-CAP CLUSTER < 600 MEV.
C                         THE OLD VERSION WAS RENAMED AS POSEND0.
C   14-12-81   16:25
C        LGECOR           ENERGY LOSS WAS INCORPOLATED FOR THE END-
C                         CAP CLUSTERS.  THE THICKNESS OF MATERIALS
C                         IN FRONT OF LEAD GLASS IS 1.17 X0.
C                         ALSO THE THICKNESS OF MATERIALS FOR
C                         BARREL PART WAS CHANGED.
C                            OLD THICKNESS   7.88 CM
C                            NEW THICKNESS   0.97*8.9 CM
C   13-06-81   21:45      CHANGED
C        LGECOR           CORRECTION FOR FINE POSITION DEPENDENCE IN
C                         BARREL PART WAS CHANGED TO USE A NEW ROUTINE
C                         'BRLGN' INSTEAD OF 'LGPOSC'.
C                         THE ITERATION METHOD OF ENERGY CORRECTION
C                         WAS ALSO CHANGED.
C                         THE OLD VERSION WAS RENAMED AS 'LGECOR1'.
C   14-06-82   14:40      CHANGED AND LOAD
C       LGADCD            IF THE LG-DATA IS EMPTY, RETURN AFTER
C                         THE LNGTH IS PRINTED.
C   06-09-82   13:40      NEW LGINIT IS LOADED. COMMON /CLGPRM/ IS
C                         MODIFIED TO INCLUDE JCALFL.
C   12-10-82   15:00      DEAD COUNTER INFORMATION UPDATED.
C     LGDEAD              TAKEDA
C   20-08-84    9:00      NEW LG...
C   24-01-86   11:00      CORRECTED VERSIONS FROM M.KUHLEN INSTALLED.
C     LGANAL,LGERSE       OLD VERSION NOW LGANAL0,LGERSE0    J.OLSSON
C   03-09-86   20:30      CORRECTED BUG IN LGCDIR (MC CLUSTERS).
C     LGCDIR              OLD VERSION NOW LGCDIR0            J.OLSSON
C   16-09-86   19:00      ADDED SEVERAL DEAD COUNTERS TO THE
C     LGDEAD              LGDEAD LIST. #753 IS DEAD SINCE 1984
C                         ALREADY !                        N.MAGNUSSEN
C   19-01-87   15:00      UPDATED ELGOBS TO CORRECT MATERIAL THICKNESS
C     ELGOBS              IN FRONT OF BARREL. ENDCAP LOSS ALSO INCLUDED
C                         OLD VERSION = ELGOBS0            J.OLSSON
C   21-12-87   21:00      UPDATED ENGLOS,LGECOR,LGCLPB, ADDED NEW SUB-
C     ENGLOS,ETC...       ROUTINES LKCORR,ENLOSG,THCORR,BBLEAK.
C                         AS PRESENTED IN JADE MEETING 14.12.87
C                         OLD VERSIONS LGECOR0,ENGLOS0,LGCLPB0
C                            J.O. D.P.
C   14-01-88   10:30      LGECOR WAS CHANGED 12.19 13.1.88 BY MISTAKE
C     LGECOR              THE VERSION EXISTED TILL 14.1.88, 1030 AND DID
C                         NOT PERFORM CORRECTIONS AS IT SHOULD. PRESENT
C                         VERSION IDENTICAL TO OLD ONE FROM 21.12.87
C                            J.O. D.P.
C   06-04-88   17:30      SECOND HALFWORD IN ALGN-BANK ( HNORML IN
C     LGCLPB              WORK-COMMON ) STEERS CALL TO BBLEAK. D.PITZL
C   22-06-88   16:30      NEW CORRECTION VALUES IN THCORR FROM GEANT-MC
C     THCORR              ESPECIALLY FOR YEARS 79-82.          D.PITZL
C   11-07-88   11:00      CHANGED LGECOR TO AGREE WITH NEW VERSION OF
C     LGECOR              THCORR                               D.PITZL
C   25-07-88   12:15      IDATTM SCRATCHED. IT HAS A BUG; AN IDENTICAL
C     IDATTM              VERSION ON F11LHO.JADEGS/GL IS UPDATED J.O.
C   02-08-88   17:00      NEW VERSIONS OF SEVERAL ROUTINES FOR BETTER
C                         PHOTON RECONSTRUCTION (D.PITZL)
C     LGANAL9             LGANAL9 CALLS CALCOR
C       CALCOR            CALCOR PERFORMS LG CALIBRATION CORRECTION
C         BBCORR          BBCORR HAS CALIBRATION CORRECTION CONSTANTS
C       LGCLPB9           LGCLPB9 RESET TO VERSION BEFORE 12/87.
C     LGCDIR9             LGCDIR9 PASSES # OF BLOCKS TO LGECOR9
C       LGECOR9           LGECOR9 HAS # OF BLOCKS AS ARGUMENT
C                         FOR CHARGED CLUSTERS: ENGLOS, ANGBAR, BRLGN
C                         FOR PHOTONS IN DATA AND SHOWER-MC: ENCORR,
C                                              THCOFA
C                         FOR PHOTONS IN MEI-MAG-MC: ENGLOS, THCORR,
C                                      THCOFA, ANGBAR
C         ENCORR          ENERGY CORRECTION FOR PHOTONS
C         THCOFA          THRESHOLD CORRECTION FOR 1- AND MORE BLOCK
C                         PHOTONS ( T.OEST)
C   12-08-88   10:20      REMOVED BUG FOR PHOTONS WITH |COS THETA|
C     ENCORR, THCOFA      > 0.80                   T.OEST, D.PITZL
C   08-09-88   16:00      LOADED LGDEAD, THIS WAS NOT DONE SINCE
C     LGDEAD              AUG 85                   T.OEST, D.PITZL
C   04/11/81 809081600  MEMBER NAME  $MEMO    (SOURCE)      FORTRAN
  LG PROGRAM MEMO

         NEW LG CALIBRATION CONST AND THE CORRESPONDING PROGRAM CHANGE
         HAS BEEN INSTALLED.
         MONDAY,20.08.1984  10:20

C   04/11/81 809081600  MEMBER NAME  #BRLSEL0 (SOURCE)      FORTRAN
//F22TAKTE JOB 10622622,CLASS=E,MSGLEVEL=(1,1),REGION=1000K,TIME=(0,10)
//*MAIN ORG=EXT,RELPRI=HIG,LINES=(400)
//* EXEC NEWFAST
// EXEC FCLG
//SYSIN DD *
C
      IMPLICIT INTEGER *2 (H)
      COMMON / / HMEMOR(30000)
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000)
      EQUIVALENCE (HDATA(1),IDATA(1)),(ADATA(1),IDATA(1))
C
C  BOS INITIALIZATION
C
      CALL BINT(40000,40000,500,0)
      IUNIT=1
      CALL LGINIT
C
C  MAIN EVENT LOOP
C
   10 CALL BREAD(IUNIT,&1000,&1001)
C
      IPHEAD=2*IDATA(IBLN('HEAD'))
      IF(IPHEAD.LE.0) GO TO 3
      NRUN=HDATA(IPHEAD+10)
      NEVT=HDATA(IPHEAD+11)
C
      IF(NRUN.NE.11094) GO TO 3
      IF(NEVT.NE.2944) GO TO 3
C
      CALL LGANAL
      IALGN=IDATA(IBLN('ALGN'))
      ICLST=IDATA(IBLN('LGCL'))
      IPATR=IDATA(IBLN('PATR'))
      CALL LGCDIR(IPATR,IALGN,ICLST)
      STOP
C
    3 CALL BSLT
      CALL BDLG
      GO TO 10
C
C  BOS READ ERROR
C
 1000 WRITE(6,100)
  100 FORMAT(1H0,' BOS READ ERROR')
      GO TO 3
C
C  END OF FILE
C
 1001 STOP
      END
C---------------------------------------------------------------------
C   11/03/79 008260241  MEMBER NAME  INTOLG                 FORTRAN
      SUBROUTINE INTOLG(NPCL,HCLMAP,HLGADC,NPPREC)
C
C     S.YAMADA   11-12-78  14:10    COPIED FROM INTOLG(LGSOURCE)
C     LAST MODIFICATION   26-10-79 17:57 BY Y.WATANABE
C      (THE CONNECTED LG# IS WRITTEN INTO THE PATR BANK)
C
C---- CONNECT CALCULATED INNER TRACK CLUSTESTERS TO THE OBSERVED LG.CLUS
C     CHOOSE AT MOST ONE CLUSTER PAR ONE TRACK
C     THE CRITERION IS;MAX OVERLAPPING CLUSTER. IF OVERLAPPING IS EQUAL,
C     CHOOSE THE CLOSEST ONE AMONG THEM.
C
C     NPCL  =THE BOS POINTER TO THE LG-RESULT BANK ('LGCL')
C     NPPREC =THE BOS POINTER TO THE LATEST PATR BANK
C                                GIVEN AS AN ARGUMENT 26/8/80
      IMPLICIT INTEGER *2 (H)
C
C
#include "clgwork2.for"
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
      DIMENSION JBCCHG(9,100)
      EQUIVALENCE (CXDCHG(1,1),JBCCHG(1,1))
C---- CXDCHG  CONTAINS INNER TRACK INFORMATION
C     JBCCHG(1,N)     HITTING PART 0=BARREL, +/-1=+/-Z END CAP
C     CXDCHG(2,N)     CHARGE
C     CXDCHG(3-5,N)   HITTING POSITION ON THE COIL OR ON THE END CAP
C     CXDCHG(6-8,N)   DIRECTION COSIGNS
C     CXDCHG(9,N)     ABSOLUTE MOMENTUM IN GEV/C
C
#include "cdata.for"
C---- SEE  JADE COMPUTER-NOTE #14.
C     IDATA(NPCLS+1)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     ADATA(NPCLS+2)=CLUSTER ENERGY IN GEV
C     ADATA(NCLST+3)=SIGMA(ENERGY)
C     ADATA(NPCLS+4)=WEIGHTED AVERAGE PHI
C     ADATA(NPCLS+5)=WEIGHTED AVERAGE Z
C     ADATA(NPCLS+6)=SIGMA PHI (WEIGHTED)
C     ADATA(NPCLS+7)=SIGMA Z (WEIGHTED)
C     IDATA(NPCLS+8)=NUMBER OF CORRESPONDING INNER TRACKS
C     ADATA(NPCLS+9-11)=DIRECTION COSIGNS CORRECTED FOR SHOWER DEPTH.
C
      DIMENSION HCLMAP(2,2), HLGADC(2,2)
C
C
      DATA IFLAG/0/
      IF(IFLAG.GT.0) GO TO 5
      IFLAG=1
C     IPTR= IBLN('PATR')
5     CONTINUE
      IF(NCHCLS.LT.1) RETURN
      NPCGI = NPCL+IDATA(NPCL+1)-1
C---- GET NO.OF CLUSTERS
      NCLST = IDATA(NPCGI+3)
      IF(NCLST.LT.1) RETURN
C
      NCHCL2 = NCHCLS
      IF(NCHCL2.GT.100) NCHCL2 = 100
      NCLST2 = NCLST
      LSTEP = IDATA(NPCGI+21)
      NPCL0 = NPCL+IDATA(NPCL+3)-1-LSTEP
      RM=(RADIUS(3)+RADIUS(4))/2.
C     LOCATE PATR BANK AND SET POINTER TO THE WORD. 26-10-79
C     NPTR = IDATA(IPTR)
      NPTR = NPPREC
      LTR=IDATA(NPTR+3)
      NPTR=NPTR+IDATA(NPTR+1)+40 -LTR
C
      WRITE(6,201) NCHCL2
  201 FORMAT(1H0,'NCHCL2=',I6)
C
        DO 100 N=1,NCHCL2
        NPTR=NPTR+LTR
        IDATA(NPTR)=0
        NS = MAPCCL(N)
        NE = MAPCCL(N+1)-1
C
      WRITE(6,202) N,NS,NE
  202 FORMAT(1H0,' N NS NE =',3I7)
        MARK=-2
        IF(NS.GT.NE) GO TO 99
        JCHB=JBCCHG(1,N)
        IF(IABS(JCHB).GT.1) GO TO 99
C
C----   GO THROUGH ALL THE OBSERVED CLUSTERS
          NPCLS=NPCL0
          COMAX=0.
          DR2MIN=1.E15
      WRITE(6,203) NCLST
  203 FORMAT(1H0,'NCLST=',I7)
          DO 80 L=1,NCLST
          NPCLS=NPCLS+LSTEP
          LS = HCLMAP(1,L)
          LE = HCLMAP(2,L)
      WRITE(6,204) L,LS,LE
  204 FORMAT(1H0,' L LS LE =',3I5)
          IF(LE.LT.LS) GO TO 80
C----     COMPARE  ALL THE COMPONENTS OF THE N-TH SIMULATED CLUSTER
C         AND L-TH OBSERVED CLUSTER.
          IF(IDATA(NPCLS+1).NE.JCHB) GO TO 80
C         (CHECK IF IS THE SAME PART OF THE APPARATUS)
            COM=0.
            DO 30 NN=NS,NE
            HADR = HCLADR(NN)
C----       TRY TO FIND HADR AMONG THE OBSERVED CLUSTER COMPONENTS.
              DO 10 LL=LS,LE
              IF(HLGADC(1,LL).EQ.HADR) GO TO 20
10            CONTINUE
              GO TO 30
20          COM=COM+1.
30          CONTINUE
      WRITE(6,205) COM
  205 FORMAT(1H0,'COM=',F10.1)
            IF(COM.LE.0.) GO TO 80
          COM=COM/(NE-NS+1)
          IF(HCLIST(1,N).LT.1) GO TO 40
      WRITE(6,200) COM,COMAX
  200 FORMAT(1H0,' COM COMAX =',2F10.3)
          IF(COM-COMAX) 80,40,70
C
C         THE SAME DEGREE OF OVERLAPP. CHOOSE THE CLOSER ONE
40        IF(JCHB.NE.0) GO TO 50
C         BARREL PART
          PHI=ADATA(NPCLS+4)
          DX=RM*COS(PHI)-CXDCHG(3,N)
          DY=RM*SIN(PHI)-CXDCHG(4,N)
          DR2=DX*DX+DY*DY+(ADATA(NPCLS+5)-CXDCHG(5,N))**2
          GO TO 60
50        DX=ADATA(NPCLS+4)-CXDCHG(3,N)
          DY=ADATA(NPCLS+5)-CXDCHG(4,N)
          DR2=DX*DX+DY*DY
60        IF(DR2.GT.DR2MIN) GO TO 80
          DR2MIN=DR2
70        COMAX=COM
          HCLIST(1,N)=1
          HCLIST(2,N)=L
          IDATA(NPTR)=L
80        CONTINUE
C
C     FILL IN INVERSE LIST
        IF(HCLIST(1,N).LT.1) GO TO 90
        L=HCLIST(2,N)
        LCOM=HCLLSO(1,L)+1
        IF(LCOM.LE.3) HCLLSO(LCOM+1,L)=N
        HCLLSO(1,L)=LCOM
        GO TO 100
C----   IF THERE IS NO MATCHED LG-CLUSTER,MARK IT.
90      MARK = -2
        JSUMC = 0
C----   JSUMC IS THE COUNTER FOR THE EDGE BLOCKS.
          DO 95 NN= NS,NE
          CALL LGCRN2( HCLADR(NN), JSUMC )
95        CONTINUE
        DR2=FLOAT(JSUMC)/(NE-NS+1)
        IF(DR2.GT.0.5) MARK=-1
99      HCLIST( 1,N ) = MARK
100     CONTINUE
      RETURN
      END
/*
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R02BUT.CERNLIB
//GO.FT01F001 DD UNIT=FAST,DISP=SHR,DSN=F22NAR.MSJAD1.MC1.R451509
C   04/11/81 809081600  MEMBER NAME  #CHK     (SOURCE)      FORTRAN
//F22WATTS JOB '10622622,LGTEST',WATANABE,CLASS=E,TIME=(0,01)
//*MAIN ORG=EXT
// EXEC FCLG,FORT=XL
#include "@chk.for"
#include "posend.for"
C   04/11/81 809081600  MEMBER NAME  #CHKRTN  (SOURCE)      FORTRAN
//F22WATTS JOB '10622622,LGTEST',WATANABE,CLASS=E,TIME=(0,06)
//*MAIN ORG=EXT
// EXEC FCLG,FORT=XL
#include "@chkrtn.for"
#include "lgecorn.for"
#include "angbar.for"
#include "posend.for"
#include "englos.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
C   04/11/81 809081600  MEMBER NAME  #LGHIST  (SOURCE)      FORTRAN
//F22YAMLB JOB '10622622,TEST',CLASS=E,MSGLEVEL=(2,0),TIME=(0,12)
//*MAIN ORG=EXT
// EXEC FORTHCLG,PARM.FORT=XL,REGION.GO=1000K
#include "@lghist.for"
#include "lghist.for"
#include "lghitm.for"
#include "lgcalb.for"
#include "lginit.for"
      BLOCK DATA
#include "ciouni.for"
      DATA NCALI/2/
      DATA KUNITA/23,24,8*0/
      DATA LUNITA/21,22,8*0/
      END
//LKED.SYSLIB DD
// DD
// DD DSN=JADELG.LOAD,DISP=SHR
// DD DSN=F11LHO.JADEGL,DISP=SHR
// DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
// DD DSN=R01UTL.HBOOKL,DISP=SHR
// DD DSN=R02BUT.CERNLIB,DISP=SHR
// DD DSN=R01UTL.SSPLIB,UNIT=FAST,DISP=SHR
// DD DSN=F22ALL.JADEMUL,DISP=SHR
//*KED.SYSIN DD *
//* INCLUDE SYSLIB()
//GO.FT21F001 DD DSN=F11LHO.BUPDAT0,DISP=SHR,UNIT=FAST
//GO.FT22F001 DD DSN=F11LHO.BUPDAT1,DISP=SHR,UNIT=FAST
//GO.FT01F001 DD DSN=F22YAM.DSK1GMC.Y82MAY,DISP=SHR
//* 11/11/81 408201036  MEMBER NAME  #LGRECAL (SOURCE)      JCL
//JADELGRC JOB 10622622,RECAL,CLASS=K,MSGLEVEL=(2,0),TIME=(3,00),
//  REGION=999K
//*MAIN ORG=EXT,RELPRI=MED,LINES=(10)
//*      *********************************************
//*      *  LG RECALIBRATION                         *    NOT READY
//*      *  BY USING THE UPDATED STANDARD CONST.FILE *
//*      *********************************************
//RECAL EXEC FCLG,FORT=XL,REGION.GO=999K
C
      IMPLICIT INTEGER*2 (H)
      COMMON /BCS/ IDATA(40000)
      DIMENSION ADATA(40000)
      INTEGER *2 HDATA(80000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
C
C -- INPUT UNIT=IUNIT,  OUTPUT UNIT=JUNIT
      DATA IUNIT/1/,JUNIT/2/
C
C -- INITIALIZATION
C
      CALL BINT(40000,4000,500,0)
      CALL BWRO(2, 1558, 2)
      CALL LGINIT
C
      JPHEAD = IBLN('HEAD')
      JPPATR = IBLN('PATR')
      JPALGN = IBLN('ALGN')
      JPLGCL = IBLN('LGCL')
C
      NREV= 0
      NWEV= 0
C
C ===== START OF MAIN LOOP =====
C
 1000 CONTINUE
C
C -- CHECK TIME
C
      IF( NTIME(DUM).LT.200 ) GOTO 8003
C
C -- READ A EVENT
C
      CALL BREAD(IUNIT,&8000,&8001)
      NREV= NREV+1
C
      IPHEAD = IDATA(JPHEAD)
      IF( IPHEAD.GT.0 ) GOTO 1001
       WRITE(6,1100)
 1100  FORMAT(' ??? "HEAD"-BANK MISSING ???')
      GOTO 7000
C
 1001 KPHEAD = 2*IPHEAD
      HRUN= HDATA( KPHEAD +10 )
      HEVT= HDATA( KPHEAD +11 )
      HENR= HDATA( KPHEAD +29 )
      ENRG = HENR*0.001
C
      IF( 500*(NREV/500).EQ.NREV )
     &  WRITE(6,1200) HRUN,HEVT,HENR,NREV,NWEV
 1200 FORMAT(' ***** RUN#',I6,', EVENT#',I6,', ENERGY',I6,
     &  ' --',I6,' EVENTS READ',I6,' EVENTS WRITTEN')
C
C -- RECALIBRATION
C
      CALL KALIB2
      CALL LGCALB( &7000 )
C-- GET TOTAL LG ENERGY    ADDED BY H.TAKEDA & M.MINOWA
C                           13:30  31/OCT/1983
C     CALL ERGTOT(ECYL,END1,END2)
C     ETOT=ECYL+END1+END2
C     RTOT=ETOT/HENR
C     IF(RTOT.LE.0.3) GO TO 7000
C        ; GAIN CORRECTION
      CALL LGANAL
C        ; CLUSTER ANALYSIS
      IPPATR = IDATA(JPPATR)
      IPALGN = IDATA(JPALGN)
      IPLGCL = IDATA(JPLGCL)
      CALL LGCDIR( IPPATR, IPALGN, IPLGCL )
C
C----------------- TEST ----- MONITOR PLOT ---------
      CALL PLCLEN(ENRG)
C
C -- WRITE A EVENT
C
      NWEV= NWEV+1
      CALL BSLW
      CALL BWRITE(JUNIT)
C
C -- ERASE ALL BANKS FOR THE NEXT EVENT.
C
 7000 CONTINUE
      CALL BSLT
      CALL BDLG
C
      GOTO 1000
C
C ===== END OF MAIN LOOP =====
C
C -- MESSAGES
C
 8000 WRITE(6,8100)
 8100 FORMAT(/' ??? BOS READ-ERROR ???'/)
      GOTO 7000
 8001 WRITE(6,8300)
 8300 FORMAT(/' ***** END-OF-DATA *****'/)
      GOTO 9000
 8003 WRITE(6,8400)
 8400 FORMAT(/' ***** TIME-OUT *****'/)
      GOTO 9000
C
C -- ENDING ROUTINE
C
 9000 CONTINUE
      CALL BMLT(0,DUMMY)
      CALL BWRITE(JUNIT)
      CALL BSTA
      WRITE(6,9100) NREV,NWEV
 9100 FORMAT(///10X,I10,' EVENTS WERE READ.'/
     &          10X,I10,' EVENTS WERE RECALIBRATED.'//)
C
      STOP
      END
#include "brlgnt.for"
#include "brlgn6.for"
//LKED.SYSLIB DD
//            DD
//            DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//            DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//            DD DSN=F1EBLO.BOSLIB.L,DISP=SHR,UNIT=FAST
//            DD DSN=R01UTL.SSPLIB,UNIT=FAST,DISP=SHR
//            DD DSN=R01UTL.CERN.KERNLIB4,UNIT=FAST,DISP=SHR
//*--<<  INPUT DATA  >> ----------
//*O.FT01F001 DD UNIT=TAPE,DISP=OLD,DSN=F22WAT.BRLBBGG.REDUC2.G533615
//GO.FT01F001 DD UNIT=TAPE,DISP=OLD,DSN=F22WAT.BRLBBGG.REDUC2.G616664
//    DD UNIT=AFF=FT01F001,DISP=OLD,DSN=F22WAT.BRLBBGG.REDUC2.G665705
//*--<<  OUTPUT DATA  >> ---------
//GO.FT02F001 DD DSN=&&OUTPUT,DISP=(,PASS),UNIT=DISK,
// DCB=(R01DCB.VBS,LRECL=6236),SPACE=(CYL,(150,50))
//*O.FT02F001 DD DUMMY
//*--<<  CALIBRATION CONSTANT  >>
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.BUPDAT0
//*O.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.BUPDAT1
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.INTERM.BUPDAT1
//*--<<  COPY  >> ----------------
//COPY EXEC PGM=IEBGENER
//SYSUT1 DD DSN=&&OUTPUT,DISP=(OLD,DELETE),UNIT=DISK
//SYSUT2 DD UNIT=TAPE,DSN=F22KMT.BRLBBGG.REDUC2.RECALX.G616705,
// DISP=(NEW,CATLG,DELETE),DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948)
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
C   04/11/81 809081600  MEMBER NAME  #LGTEST  (SOURCE)      FORTRAN
//F22WATTY JOB '10622622,LGTEST',WATANABE,CLASS=E,TIME=(0,15)
//*MAIN ORG=EXT,RELPRI=LOW
//*EXEC NEWFAST
// EXEC FCLG,FORT=XL,REGION=1000K
#include "@lgtest.for"
#include "lgersen.for"
#include "kalib2.for"
#include "lgsubc.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
// DD DSN=F1EBLO.BOSLIB.L,DISP=SHR,UNIT=FAST
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//GO.FT01F001 DD DISP=SHR,UNIT=FAST,DSN=JADELG.DSKSCRCH
 //*                CALIBRATION
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//GO.FT23F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
//GO.FT24F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART1
C   04/11/81 809081600  MEMBER NAME  #LGTOFCL (SOURCE)      FORTRAN
//JADELGTG JOB 10622622,CLASS=A,MSGLEVEL=(2,0),TIME=(2,00)
//*MAIN RELPRI=MED
//*   =====  CALIBRATION OF THE BARREL LG-TOF =====
// EXEC FCLG,REGION.GO=512K
#include "@lgtofcl.for"
#include "lgbtdc.for"
//LKED.SYSLIB DD
//     DD
// DD DSN=F22YAM.PHANAL.L,UNIT=FAST,DISP=SHR
// DD DSN=R01UTL.SSPLIB,DISP=SHR,UNIT=FAST
// DD DSN=R01UTL.HBOOK321.L,UNIT=FAST,DISP=SHR
// DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
// DD DSN=F1EBLO.BOSLIB.L,DISP=SHR,UNIT=FAST
// DD DSN=F11LHO.JADEGL,DISP=SHR,UNIT=FAST
// DD DSN=F22YAM.TPLOAD,DISP=SHR,UNIT=FAST
//LKED.SYSIN DD *
     INCLUDE SYSLIB( TPMESGLG )
//*  INCLUDE SYSLIB( TPMESGLG )  ****
//*            INPUT
//*O.FT01F001 DD DSN=F22YAM.ONEGAMCW.G408450,DISP=OLD,UNIT=TAPE
//* DD DSN=F22YAM.ONEGAMCW.G451472,UNIT=AFF=FT01F001,DISP=OLD
//* DD DSN=F22YAM.ONEGAMCW.G473480,UNIT=AFF=FT01F001,DISP=OLD
//*O.FT01F001 DD DSN=F22WAT.BRLBBGG.REDUC2.G408427,DISP=OLD,UNIT=TAPE
//*O.FT01F001 DD DSN=F22WAT.BRLBBGG.REDUC2.G428450,DISP=OLD,UNIT=TAPE
//GO.FT01F001 DD DSN=F22KAN.BRLBBGG.REDUC2.G451454,DISP=OLD,UNIT=TAPE
//            DD DSN=F22KAN.BRLBBGG.REDUC2.G455459,DISP=OLD,
//            UNIT=AFF=FT01F001
//            DD DSN=F22KAN.BRLBBGG.REDUC2.G460664,DISP=OLD,
//            UNIT=AFF=FT01F001
//*O.FT01F001 DD DSN=F22YAM.ONEGAMC.R1G408,DISP=SHR,UNIT=FAST
//*       DD DSN=JADEPR.REDUCONE.G0430V00,DISP=OLD,UNIT=AFF=FT01F001
//GO.SYSIN DD *
   1000000   0000000   9999999         1         0     14500
    MAXREC     NRUN1     NRUN2      MESG       ITD    LIMREC
C   04/11/81 809081600  MEMBER NAME  #MTCOPY  (SOURCE)      FORTRAN
//F22WATCP JOB 10622622,WATANABE,CLASS=A,TIME=(0,15)
//*MAIN LINES=(2),ORG=EXT
// EXEC FCLG,REGION=800K
#include "@mtcopy.for"
#include "bread.for"
#include "bwrite.for"
//LKED.SYSLIB DD
// DD
// DD DSN=R02BUT.CERNLIB,DISP=SHR
//GO.FT01F001 DD DISP=SHR,UNIT=TAPE,DSN=F22ORI.REDUC2D.R4404.R4434
//GO.FT02F001 DD DSN=JADELG.DSKSCRCH,DISP=(,CATLG,DELETE),
// DCB=R01DCB.VBS,SPACE=(TRK,(20,10),RLSE),UNIT=FAST
//* THE RANGE OF RUNS TO BE COPIED, AND # OUTPUT TAPES
 4433 9999    1
C   04/11/81 809081600  MEMBER NAME  #PRJNOT  (SOURCE)      FORTRAN
//JADELGL4 JOB 10622622,JADELG,CLASS=A,MSGLEVEL=(0,0),TIME=(0,5)
// EXEC FCLG
//FORT.SYSIN DD *
      DIMENSION A(80)
      DATA NCOPY/10/
      DATA DOL/1H$/
      DO 2 N=1,NCOPY
      WRITE(6,102)
      DO 1 I=1,100000
      READ(5,100,END=99) A
  100 FORMAT(80A1)
C     IF(MOD(I,33).EQ.0) WRITE(6,102)
  102 FORMAT(1H1,/)
      IF(A(1).NE.DOL) GO TO 3
      WRITE(6,102)
      GO TO 1
3     WRITE(6,101) A
  101 FORMAT(3X,72A1,30X,8A1)
C     WRITE(6,103)
  103 FORMAT(/)
    1 CONTINUE
   99 REWIND 5
    2 CONTINUE
      STOP
      END
//GO.FT06F001 DD SYSOUT=K
//GO.SYSIN DD *
  JADE COMPUTER NOTE 14D

                                      16. MAY  1984     S.YAMADA


  ANALYSIS PROGRAM FOR LEAD GLASS (LG) COUNTERS.
   ( REVISED VERSION OF THE JADE COMP.NOTES 14,14A,14B,14C
     BY S.YAMADA AND Y.WATANABE
    UPDATED AND MORE INFORMATION IS GIVEN HERE)

A SMALL CHANGE HAS BEEN MADE TO THE LG LIBRALY JADELG.SOURCE/LOAD.
THE NUMBER OF WORDS/CLUSTER IS NOW 16, BUT THERE SHOULD BE NO PROBLEM
AS LONG AS THE RIGHT WORD FOR IT IS USED IN THE PROGRAM.

THIS CHANGE IS TO ACCOMODATE A REQUEST TO INCLUDE UNCORRECTED ENERGY
IN TO THE BANK. FOR MONTE CARLO DATA, THIS WORD CONTAINS UNSMEARED
ENERGY WHEN SMEARING IS DONE AT THE LG ANALYSIS STAGE, WHICH IS
THE NORMAL PRACTICE FROM NOW ON.

THE STRUCTURE OF THE LIBRARY ,SOME DESCRIPTION OF TECHNIQUES USED IN
THE PROGRAM AND THAT OF INPUT/OUTPUT BANKS ARE GIVEN BELOW.


1. THE STRUCTURE OF THE LIBRARY

IT CONSISTS OF BANCH OF SUBROUTINES, WHICH CAN BE DIVIDED INTO 4 GROUPS.
EACH OF THE GROUPS CAN BE REPRESENTED BY ONE SUBROUTINE.

 A. SUBROUTINE LGINIT

     FUNCTION    LOAD IN VARIOUS CONSTANTS AND CUTS.
                 (IN THE FORM OF BLOCK DATA).
                 SHOULD BE CALLED AT THE BEGINNING.
                 THE SET CONSTANTS CAN BE OVERRIDDEN BY
                 SETTING TO DESIRED VALUES AFTERWARD.

 B. SUBROUTINE LGCALB(*)

     INPUT  BANK 'ALGL'/0 (RAW PULSE HEIGHTS)
     OUTPUT BANK 'ALGN'/1 (UNIT IS IN MEV)

     FUNCTION    CONVERTS ADC PULSE HEIGHTS TO MEV.
                 SUBTRACT SOME COUNTS FROM SPINNING BLOCKS AND
                 DELETE BAD AND/OR NON-EXISTING CHANNELS
                 WHEN THEY FIRE. (LGERSE)
                 (NOW USES L.H.O'NEILL'S SCHEME OF CONSTANTS)

     ERROR RETURN OCCURS IF THE INPUT DATA ARE ABNORMAL.

 C. SUBROUTINE LGANAL

     INPUT  BANK 'ALGN'/1
     OUTPUT BANK 'LGCL'/1 (SOME PART IS TO BE FILLED BY LGCDIR)

     FUNCTION    FINDS CLUSTERS AND STORES THE INFORMATION
                 IN 'LGCL'/1.
                 THE BANK 'ALGN'/1 IS REORDERED IN SUCH A WAY
                 THAT HITS BELONGING TO A CLUSTER ARE GROUPED TOGETHER.

$
 D. SUBROUTINE LGCDIR(NPPATR,NPALGN,NPLGCL)

       WHERE THE ARGUMENTS ARE POINTERS TO THE CORRESPONDING BANKS.

     INPUT  BANK 'LGCL'/1
     OUTPUT BANK 'LGCL'/1 (I.E. JUST MODIFIES THE CONTENTS)
     FUNCTION    LINKS TRACKS FOUND IN THE JET CHAMBER
                 TO LG CLUSTERS
                 PERFORMS ENERGY CORRECTION FOR DATA(J.C.NOTE#35)
                 AND ENERGY SMEARING FOR MC DATA. (LGESMR)
                 CALCULATES THE DIRECTION COSINES TAKING
                 INTO ACCOUNT THE EVENT VERTEX AND SHOWER
                 DEPTH.

       LGCDIR CAN BE CALLED INDEPENDENT OF LGANAL FOR ONCE
       ANALYSED DATA.


2. SHORT DESCRIPTION OF CLUSTER FINDING

     A. THE LIST IN 'ALGN'/1 IS ORDERED FROM THE HIGHEST ENERGY

     B. TAKE THE BLOCK WITH THE HIGHEST ENERGY AS A PARENT.
        CALL THIS BL1.  E(BL1) > ITH (DEFAULT IS 45 MEV)

     C. LOOK FOR A NEIGHBOR IN THE LIST. IF FOUND MOVE IT TO THE NEXT
        TO BL1.  CALL THIS BL2 (NEIGHBORS ARE ADJUCENT COUNTERS)

     D. FOR EACH BL2, LOOK FOR A NEIGHBOR OF BL2.  CALL THIS BL3.

     F. INCLUDE BL3 IRRESPECTIVE OF THE ENERGY IF E(BL2) > E(BL1)/5.
        IF NOT,INCLUDE BL3 IF E(BL3) < E(BL1)/2 .AND. E(BL3) < E(BL2)*3.
        IF INCLUDED TO THE FAMILY, MOVE IT NEXT TO BL2.

     G. FIND ALL NEIGHBORS OF BL2 ( GO TO C ;BL3 IS NOW BL2)

     H. AFTER ALL NEIGHBORS OF BL1 FAMILY IS FOUND, REPEAT ABOVE
        FOR UNASSIGNED BLOCKS IN THE LIST ( GO TO B )

     NOTE. DETECTOR IS DIVIDED INTO 3 PARTS; BARREL, -Z AND +Z
           END CAPS, AND CLUSTER SEARCH IS MADE SEPARATELY.
     THE THRESHOLDS USED IN THE CLUSTER SEARCH ARE STORED IN THE
     COMMON /CLGPRM/ ITH, MAXCLS, IRLTHD, IRLTH2, IRLTH3.
                    (45MEV)         5        2       3  <--- DEFAULT
     THESE VALUES CAN BE CHANGED BY USERS AFTER CALLING LGINIT.

3. CALUCULATION OF CLUSTER POSITION

      THE COORDINATES (PHI,Z) FOR BARREL AND (X,Y) FOR END CAP  ARE
      OBTAINED BY WEIGHTED AVERAGE. THE EXPONENT IN THE WEIGHT
      WAS DETERMINED BY R.EICHLER IN ORDER TO OBTAIN THE BEST
      PI-0 INVARIANT MASS BY A 3-DIMENSIONAL MONTE CARLO SHOWER
      USING THE A.SATO'S SHOWER PROGRAM.

        X = SUM (XI*EI**0.33) / SUM(EI**0.33)   (SIMILAR FOR PHI)
        Y = SUM (YI*EI**0.33) / SUM(EI**0.33)   (   "     "   Z )

      THEN THE DIRECTION COSINE IS CALUCUATED TAKING THE SHOWER
      DEPTH AND THE EVENT VERTEX(IF 'TPVX' IS THERE) INTO ACCOUNT.
$
        DEPTH = 22.39*LN(E/E0) (MM)    E0=4.979MEV FOR E+-,
                                       E0=1.725MEV FOR GAMMA.
         OR   = HALFWAY THROUGH THE LEAD GLASS
                IF E<600 MEV OR E/P < 0.75
              ("IDENTIFIED" AS A NONSHOWERING CHARGED PARTICLE)

      TO OBTAIN THE DIRECTION COSINE, E.G. FOR A BARREL CLUSTER,
      THE ADDITIONAL PARAMETER R IS ITTERATIVELY SEARCHED FOR,
      FIXING (PHI,Z), UNTIL THE DEPTH REACHES TO THE EXPECTED VALUE.

      A FURTHER CORRECTION OF THE DIRECTION IS APPLIED AS A FUNCTION
      OF THE HIT POSITION AND THE ENERGY. THE CORRECTION FUNCTION WAS
      OBTAINED BY A MONTE CARLO METHOD.


4. 'ALGN'/1 BANK

  WORD   TYPE  CONTENTS

     0    I*4  THE LENGTH OF THE BANK
     1#   I*2  >100
          I*2  10003 FOR DATA .
               FOR MONTE CARLO DATA, 1=ENERGY UNSMEARED, 2=SMEARED
               AT THE GENERATION STAGE.  ADD 4 IF SMEARING IS DONE
               BY LGESMR IN LGCDIR.
     2    I*2  POINTER=1
          I*2  POINTER TO ADDRESS OF THE DATA ( -Z END CAP)
     3    I*2  POINTER TO ADDRESS OF THE DATA ( +Z END CAP)
          I*2  POINTER TO THE LAST WORD+1
     4    I*2  ADC CHANNEL NUMBER (0 THROUGH 2879)
          I*2  THE PULSE HEIGHT IN MEV.
     5    I*2  ADC CHANNEL NUMBER (0 THROUGH 2879)
          I*2  THE PULSE HEIGHT IN MEV.
           "        "
           "        "

           ( ALL NONZERO BLOCKS
               IN THE ORDER OF THE BLOCK NUMBERS (AFTER LGCALB)
               IN FAVOR OF CLUSTERS FOUND        (AFTER LGANAL)

AN EXAMPLE  FOR THE DATA LOOK AS FOLLOWS,

   ADC  MEV   ADC  MEV   ADC  MEV   ADC  MEV   ADC  MEV
   912 4886   880  540   913  194   911  162   944  113
   881   81   879   71 /2257 3879  2289 1227  2256   92
  2225   38  2290   86  2288   76 /2400   15//2715 1661
  2720 1370//2810   76 /2800   15

 POINTERS(WORD#2-5) HAVE THE VALUES OF  1,29,33,37
        ( // INDICATES THE BOUNDARY OF DETECTOR PARTS )
        ( / INDICATES THE BOUNDARY OF CLUSTERS IN ONE PART. )
        ( IN TOTAL 6 CLUSTERS ARE FOUND )
$
5. 'LGCL'/1 BANK

   THE FORMAT OF THE BANK IS GIVEN BELOW FOR CONVENIENCE.IT IS
   ESSENTIALLY THE SAME AS THE ONE DESCRIBED IN J.C.NOTE 14 - 14B.

  WORD   TYPE  CONTENTS

     0    I*4  THE LENGTH OF THE BANK
     1     "   IP1= 5;THE POINTER TO THE GENERAL INFORMATION
     2     "   IP2=26;THE POINTER TO THE CLUSTER MAP
     3     "   IP3   ;THE POINTER TO THE CLUSTER INFORMATION(NCLST+27)
     4     "   IP4   ;THE POINTER TO THE LAST WORD +1


  /GENERAL INFORMATION/

  WORD   TYPE  CONTENTS

  IP1     I*4  VERSION# OF THE PROGRAM.
  IP1+ 1   "   THE DATE AND TIME OF THE BANK GENERATION.
  IP1+ 2   "   #CLUSTERS     TOTAL (NCLST)
  IP1+ 3   "       "         BARREL
  IP1+ 4   "       "         Z<0 ENDCAP
  IP1+ 5   "       "         Z>0 ENDCAP
  IP1+ 6  R*4  SHOWER ENERGY TOTAL
  IP1+ 7   "       "         BARREL
  IP1+ 8   "       "         Z<0 ENDCAP
  IP1+ 9   "       "         Z>0 ENDCAP
  IP1+10  I*4  #PHOTONS
  IP1+11  R*4  PHOTON ENERGY TOTAL
  IP1+12   "       "         BARREL
  IP1+13   "       "         Z<0 ENDCAP
  IP1+14   "       "         Z>0 ENDCAP
  IP1+15  I*4  ERROR FLAG. 0=NO ERROR, 1=NOT CALIBRATED, 2=NOT ENOUGH
               SPACE TO COPY INPUT DATA,1024=FORMAT CONVERSION NOT DONE
               ADD 10 IF TOO MANY CLUSTERS FOUND
               ADD 100 IF NOT ENOUGH SPACE IN /BCS/
  IP1+16   "   THE STAGE OF ANALYSIS 1=LGANAL, 2=LGCDIR.
  IP1+17   "   THE VERSION # FOR THE ENERGY CORRECTION.
  IP1+18   "   1 IF TRACK CONNECTION IS DONE.
  IP1+19   "   FLAG=HDATA(2*NPVRTX+2) SEE J.C.NOTE FOR TP.
  IP1+20#  "   #WORDS/CLUSTER (NWPCL=16 CHANGED FROM 15)
        # INDICATES MODIFICATION


  /CLUSTER MAP/

  WORD      TYPE  CONTENTS

  IP2       I*2   H(1);THE START ADDRESS OF CLUSTER 1 IN RESHUFFLED
                    'ALGN'/1 BANK.
             "    H(2);THE LAST  ADDRESS
  IP2+1      "     . . . . . . . . .
   .         "     . . . . . . . . .
   .         "     . . . . . . . . .
  IP2+NCLST  "    H(1);POINTS TO THE LAST ADC DATA +1

  FOR THE ABOVE EXAPMLE, THE VALUES OF H(1),... ARE
    1,7, 8,13, 14,16, 17,17, 19,0   RESPECTIVELY
$
  /CLUSTER INFORMATION/

   IB = IP3 + (N-1) * NWPCL - 1 (ADD ABSOLUTE POINTER TO THIS)

  WORD   TYPE  CONTENTS

  IB+ 1   I*4  DETECTOR PART; 0=BARREL, +/-1=+/1 Z END CAP
  IB+ 2   R*4  CLUSTER ENERGY IN GEV.
  IB+ 3    "   EXPECTED SIGMA OF THE ENERGY
  IB+ 4    "   PHI/X FOR BARREL/ENDCAP (RAD./MM)
  IB+ 5    "   Z  /Y FOR BARREL/ENDCAP (IN MM)
  IB+ 6    "   SIGMA(PHI)/SIGMA(X) FOR BARREL/ENDCAP (IN MM)
  IB+ 7    "   SIGMA(  Z)/SIGMA(Y) FOR BARREL/ENDCAP (IN MM)
  IB+ 8#  I*4  (#CONNECTED TRACKS)*100+1ST TRACK#, 0= A PHOTON
  IB+ 9   R*4  DX
  IB+10    "   DY  FROM EVENT VERTEX (SHOWER DEPTH CONSIDERED)
  IB+11    "   DZ
  IB+12    "   EW(2)/EW(1)                   (SIGX**2   SIGXY)
  IB+13    "   EW(2)+EW(1)  EIGEN VALUES OF  (SIGXY   SIGY**2)
  IB+14    "   THE ANGLE OF EIGEN VECTOR
  IB+15    "   THE FRACTION OF ENERGY IN THE EDGE BLOCKS.
               (IF IT IS >0.5, SAY, THE ENERGY OF THE CLUSTER COULD
                BE GROSSLY UNDERESTIMATED)
  IB+16#   "   THE ENERGY OBTAINED BY ADDING THE BLOCKS.
                (I.E. UNCORRECTED ENERGY FOR DATA, AND UNSMEARED FOR MC)

       # INDICATES MODIFICATION.
          (IN THE PATR BANK OF THE SMALLEST NR, 40TH WORD NOW CONTAINS
           THE CLUSTER NUMBER THAT IS CONNECTED TO THE TRACK.
           THIS CONNECTION IS DEFINED TO BE UNIQUE.)

$
 6  DUMP UTILITIES

       THE BOS BANK /ALGL/,/ALGN/ AND /LGCL/ CAN BE PRINTED
       BY SUBROUTINES  PRALGN AND PRLGCL.


    SUBROUTINE PRALGN(LORN,J,MM)
      DUMP THE LEAD GLASS ADC BANK('ALGN') TO LP

    ARGUMENTS (ALL ARE INPUT)
      LORN=0  FOR 'ALGL'/0,  LORN=1 FOR 'ALGN'/1
      THE ADDRESS PART IS DECODED ACCORDING TO THE INPUT J
      J=0, NO DECODING
      J=1,FOR INPUT CODE I.E. CRATE-SLOT-SUBADDRESS
      J=2,FOR POSITION CODE I.E. IPHI-IZ FOR THE BARREL PART
                            I.E. TOP/BOTTOM-NUM FOR THE ENDCAP
      MM IS NO. OF DATA TO BE PRINTED IN A LINE. (5--10 ARE RECOMENDED)
      THIS ARGUMENT IS PREPARED TO USE THE SUBROUTINE BOTH FOR
      LP AND OTHER DISPLAY DEVICES.


      SUBROUTINE PRLGCL

      PRINT THE BANK /LGCL/.
      THE CLUSTER HIT MAP, GENERAL INFORMATION AND EACH CLUSTER DATA
      ARE PRINTED.

$
 6. COMMON /CWORK/

    THE SUBROUTINE LGANAL USES THE COMMON /CWORK/, WHICH IS COPIED INTO
    THE BOS BANK /LGCL/. THE SUBROUTINE LGCDIR USES THE COMMON
    AGAIN IN LINKING THE INNER CHAMBER TRACK TO THE LG CLUSTERS.
    TO MAKE THE LINK, ALL INNER CHAMBER TRACKS ARE EXTENDED TO THE
    LEAD GLASS COUNTERS AND HIT BLOCKS ARE LISTED. POSSIBLE CLUSTERS
    DUE TO CHARGED TRACKS ARE GENERATED AND MATCHING OF THE COUNTERS
    BETWEEN THE OBSERVED CLUSTERS ARE EXAMINED. AFTER THE ANALYSIS
    THE EXPECTED LG HITS BY CHARGED TRACKS AND
    THE LINK TABLES BETWEEN THE OBSERVED LG CLUSTERS AND CHARGED TRACKS
    ARE KEPT IN THE WORK COMMON, WHICH CAN BE USED IMMEDIATELY AFTER
    THE LGCDIR-CALL IF DETAILED LINK INFORMATION IS REQUIRED.

      THE STRUCTURE OF THE COMMON
                   (  USED IN LGCDIR PART OF ANALYSIS )
      COMMON /CWORK/ NCHCLS,NPOINT,MAPCCL(101),HCLADR(1600),
     $               NCHCL2,HCLIST(4,100),  NCLST2,HCLLSO(4,80)

       NCHCLS   NUMBER OF EXPECTED CLUSTERS DUE TO CHARGED PARTICLES.
       NPOINT   TOTAL NUMBER OF HIT COUNTERS
       MAPCCL   MAP OF THE CHARGED TRACK CLUSTERS, ONLY START ADDRESS
                IS STORED.
       HCLADR   COUNTER ADDRESSES
       NCHCL2   =NCHCLS
       HCLIST(1,K)    NUMBER OF CONNECTED CLUSTERS FOR THE K-TH TRACK
             (2-4,K)  THE CLUSTER NUMBERS OF THE OBSERBED CLUSTERS
                      WHICH ARE LINKED TO THE K-TH TRACK.
       NCLST2   =NCLST
       HCLLSO(1,L)    NUMBER OF LINKED TRACKS FOR THE L-TH CLUSTER
             (2-4,L)  THE TRACK NUMBERS OF THE TRACKS WHICH ARE
                      LINKED TO THE CLUSTER

       UP TO 3 LINKS ARE STORED IN THE TABLE
       NOTE THAT IN THE /LGCL/ ONLY ONE OF THEM (THE HIGHEST ENERGY
       CLUSTER) IS STORED.
       THIS TABLE CAN BE PRINTED BY SUBROUTINE PRITOL.

           SUBROUTINE PRITOL(MODE)

       MODE=1, HIT MAP AND ADDRESS ONLY
           =2, LINK TABLES ONLY
           >2, BOTH


####################################################################
 NOTE THAT THE ADDRESS IS ONLY RELATIVE. ONE HAS TO ADD THE POINTER
 TO THE BANK TO GET A CORRECT ADDRESS.
####################################################################

********************************************************************

 ******TO OBTAIN THIS PRINT OUT, SUB 'JADELG.SOURCE(#PRJNOT)'******

*JADE*JADE*JADE*JADE*JADE*JADE*JADE*JADE*JADE*JADE*JADE*JADE*JADE*JADE
C   04/11/81 809081600  MEMBER NAME  #PRMEMO  (SOURCE)      FORTRAN
//JADELGL4 JOB 10622622,JADELG,CLASS=A,MSGLEVEL=(0,0),TIME=(0,5)
// EXEC FCLG
//FORT.SYSIN DD *
      DIMENSION A(80)
      DATA NCOPY/50/
      DATA DOL/1H$/
      DO 2 N=1,NCOPY
      WRITE(6,102)
      DO 1 I=1,100000
      READ(5,100,END=99) A
  100 FORMAT(80A1)
C     IF(MOD(I,33).EQ.0) WRITE(6,102)
  102 FORMAT(1H0,/)
      IF(A(1).NE.DOL) GO TO 3
      WRITE(6,102)
      GO TO 1
3     WRITE(6,101) A
  101 FORMAT(3X,72A1,30X,8A1)
C     WRITE(6,103)
  103 FORMAT(/)
    1 CONTINUE
   99 REWIND 5
    2 CONTINUE
      STOP
      END
//GO.SYSIN DD *
 *******************************************************************
  JADE COMPUTER MEMO

                                      16. AUG. 1984     S.YAMADA

 *******************************************************************
   PROGRAM CHANGE FOR LEAD GLASS (LG) CALIBRATION

    IN CONNECTION WITH THE NEW CALIBRATION CONST FOR THE SF6 LEAD GLASS,
    POSITION DEPENDENCE CORRECTION SUBROUTINE WILL BE CHANGED
    ON MONDAY MORNING   20.08.1984 ( 9:00 )
    TOGETHER WITH THE CONSTANT FILE.

   <<<<<  WARNING>>>>>

   IF YOUR JOB IS RUNNING AT THAT TIME, IT MAY BE AFFECTED
   BY THIS MODIFICATION.

   THERE WILL BE A MESSAGE IN THE MEMBER 'JADELG.SOURCE($MEMO)'
   WHEN ALL CHANGES ARE FINISHED.
   YOU WILL GET BETTER ENERGY RESOLUTION AFTER THE CHANGE.

*****************************************************************

C   14/12/78 C9061201   MEMBER NAME  DRCHCH   (JADEGS)      FORTRAN
      SUBROUTINE DRCHCH
C---
C---     SUBROUTINE TO ALLOW CHANGING CONTENTS ON COMMON "CJDRCH"
C---                                   L.H. O'NEILL
C---                                   THRUSDAY, DECEMBER 14, 1978
C---
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
      DIMENSION DRCH(37),IDRCH(37)
CMACRO CJDRCH
C==MACRO CJDRCH=======================================
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     * RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,ZRESOL,ZNORM,ZAL,
     * ZSCAL,DRIDEV,DRICOS,DRISIN,PEDES,TZERO(2)
C==ENDMACRO CJDRCH====================================
      EQUIVALENCE(IDRCH(1),RDEC(1))
      EQUIVALENCE (IDRCH(1),DRCH(1))
      COMMON/CWORK/HWORK(40)
      DATA MESS/1/
      DATA IVER/1/

*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C---
   50 CONTINUE
      LOOP=0
      IF(MESS.EQ.0) GO TO 1
      CALL TRMOUT(80,'OPTION TO CHANGE COMMON "CJDRCH".^')
      CALL TRMOUT(80,'TO CHANGE ITH (REAL*4) VARIABLE IN COMMON^')
      CALL TRMOUT(80,'ENTER I AND THE NEW VALUE YOU WISH.^')
      CALL TRMOUT(80,'ENTER 50 AND VALUE TO ASSIGN THIS VALUE^')
      CALL TRMOUT(80,'TO ALL DRCH(20-25).^')
      CALL TRMOUT(80,'ENTER 0 TO EXIT ROUTINE.^')
      CALL TRMOUT(80,'ENTER 100 TO SEE ALL CURRENT VALUES.^')
      CALL TRMOUT(80,'ENTER 200 TO TURN OFF (OR ON) THESE MESSAGES.^')
      CALL TRMOUT(80,'ENTER 300 TO TURN OFF (OR ON) VERIFICATION.^')
    1 CONTINUE
      CALL TONUM(IND,PAR)
      IF(IND.EQ.0) RETURN
      IF(IND.EQ.200) MESS=0
      IF(IND.EQ.300) IVER=0
      IF(IND.GT.100) GO TO 50
      IF(IND.NE.100) GO TO 2
      DO 3 I=1,37
      CALL CORE(HWORK,80)
      WRITE(cHWORK,101) I,DRCH(I)! PMF 17/11/99: JUSCRN changed to cHWORK
  101 FORMAT(I6,F12.6)
      CALL TRMOUT(18,HWORK)
    3 CONTINUE
      GO TO 50
    2 CONTINUE
      IF(IND.EQ.50) LOOP=1
      IF(IND.EQ.50) IND=20
      IF((IND.GE.1).AND.(IND.LE.37)) GO TO 4
      CALL TRMOUT(80,'NO SUCH INDEX IS AVAILABLE. PLEASE TRY AGAIN.^')
      GO TO 50
    4 CONTINUE
      IF(IVER.EQ.0) GO TO 5
      CALL CORE(HWORK,80)
      WRITE(cHWORK,102) IND,DRCH(IND),PAR! PMF 17/11/99: JUSCRN changed to cHWORK
  102 FORMAT('DRCH OF',I6,' WILL BE CHANGED FROM ',F12.6,' TO ',F12.6)
      CALL TRMOUT(63,HWORK)
      IF(LOOP.EQ.1) CALL TRMOUT(80,
     1'DRCH(21-25) WILL BE CHANGED TO THE SAME NEW VALUE.^')
      CALL TRMOUT(80,
     1'ARE YOU COMPLETELY COMFORTABLE WITH THIS PROSPECT?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.2) CALL TRMOUT(80,'NO ACTION TAKEN.^')
      IF(IANSW.EQ.2) CALL TRMOUT(80,
     1'RETURNING TO TOP OF ROUTINE.^')
      IF(IANSW.EQ.2) GO TO 50
    5 CONTINUE
      DRCH(IND)=PAR
      IF(LOOP.EQ.0) GO TO 6
      DO 7 I=21,25
      DRCH(I)=PAR
    7 CONTINUE
    6 CONTINUE
      CALL TRMOUT(80,'CHANGE MADE. DO YOU WISH TO MAKE MORE CHANGES?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 50
      RETURN
      END

C   25/02/82 203051112  MEMBER NAME  LGBRPS   (JADESR)      FORTRAN
C
      SUBROUTINE LGBRCS(JCOSM)
C
C    S.YAMADA   15-02-82  14:00
C     LAST MODIFICATION   05-03-82  10:10
C                         DEBUGGED.
C
C---- SIMPLE PROGRAM FOR LG-BARREL COSMIC RAY REJECTION
C---- OUTPUT
C     JCOSM=0 IF NOT COSMIC LIKE.
C     JCOSM=1 IF DOUBTED TO BE A BARREL COSMIC EVENT.
C     JCOSM=2 IF BARREL COSMIC EVENT.
C
      IMPLICIT INTEGER *2 (H)
C
#include "clgwork1.for"
C
      DIMENSION EAB(2,3),COSA(2),COSB(2),COSD(2)
C*****

C****   COSMIC LIKE EVENTS.
C
      JCOSM = 0
    1   CALL LGKOSM(KFLAG,EAB,NHITA,NHITB,COSA,COSB,COSD,DNORM)
      EXTRA = ETOT(1)-EAB(1,3)-EAB(2,3)
      EXTRAB = ETOT(2)-EAB(1,3)-EAB(2,3)
      RA1 = 0.
      IF( EAB(1,1).GT.0. ) RA1 = EAB(1,2)/EAB(1,1)
      RB1 = 0.
      IF( EAB(2,1).GT.0. ) RB1 = EAB(2,2)/EAB(2,1)
C
C---- CHECK COSMIC OR NOT
      IF( KFLAG.NE.0 )                            GO TO 100
      IF( NCLST.LE.0 )                            GO TO 100
      IF(NCLST.GT.2 .AND.(EXTRA.GT.2.0 .OR. EXTRAB.GT.0.5)) GO TO 100
C---- SAVE POSSIBLE BHABHA/GG
      IF( EAB(1,3).GT.5.0 .AND. EAB(2,3).GT.5.0)  GO TO 100
C---- CHECK THE 1-ST CLUST
C
C--     BIG AND LONG CLUSTER
        IF( EAB(1,1).GT.30000..AND. RA1.LE.0.08)    GO TO 1000
C--     MEDIUM SIZE;  CHECK DIRECTION IN PHI-Z PLANE
        IF( EAB(1,1).GT.20000. .AND. RA1.LT.0.2 .AND.
     *      ABS(COSA(1)).GT.0.50 )               GO TO 1000
C
C---  CHECK THE 2-ND CLUSTER
C--     BIG AND LONG CLUSTER
        IF( EAB(2,1).GT.30000..AND. RB1.LE.0.08)  GO TO 1000
C--     MEDIUM SIZE;  CHECK DIRECTION IN PHI-Z PLANE
        IF( EAB(2,1).GT.20000. .AND. RB1.LT.0.2 .AND.
     *      ABS(COSB(1)).GT.0.50 )                GO TO 1000
C
C---- SMALL SIZE    CHECK DIRECTIONS OF BOTH CLUSTER
        IF(EAB(1,1).GT.15000. .AND. RA1.LT.0.2 .AND. EAB(1,3).GE.1.0
     *  .AND. EAB(2,1).GT.15000 .AND. RB1.LT.0.2 .AND. EAB(2,3).GE.0.5
     *  .AND. ABS(COSA(1)).GT.0.5 .AND. ABS(COSB(1)).GT.0.5)
     *                                           GO TO 1000
C
C---- TIGHTER CUT
  200 ELPSCT = EAB(1,3)*200 + 20000.0
      IF( NCLST.LE.1 ) GO TO 100
      IF( EAB(1,3).LT.0.8 .OR. EAB(2,3).LT.0.4) GO TO 100
      IF( EAB(1,1).LT.ELPSCT) GO TO 100
      IF( EAB(2,1).LT.ELPSCT) GO TO 100
      JCOSM = 1
      GO TO 100
C
 1000 JCOSM = 2
  100 RETURN
      END

C   25/02/80 102141944  MEMBER NAME  TOFSM2   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFSM2 
C
C           COMPUTES ROUGH TOF (NO PULSEHEIGHT CORRECTION
C           NO Z-DEPENDENCE)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
      COMMON/TFPRM/ NRNC1,NRNC2,DYC(4),IFLC(42),CM(42),CP(42),
     -DTAU(42),WM(42),WP(42),SV(42),DM(42),DP(42),PEDLM(42),PEDLP(42)
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
      COMMON/BCS/IDATA(1)
      DIMENSION HDATA(2),HELP(2)
      EQUIVALENCE  (HDATA(1),IDATA(1)),(ICAMWD,HELP(1))
      DATA ITOFST/93/,HELP /0,0/
      DATA IENTRY/0/
C
      IF(IENTRY.NE.0)  GOTO  10
      IENTRY = 1
      CALL CORCST(NRUN)
   10 CONTINUE
C
      MTOF = 0
      NTOF = 0
      CALL SETSL(TTOF,0,42*4,0.)
      CALL SETSL(HTOF,0,42*2,0.)
      IPTOF  = IDATA(IBLN('ATOF'))
      IF(IPTOF.LE.0)  RETURN
      IPTOF = IPTOF*2
      IPJ = IDATA(IBLN('LATC'))
      IF(IPJ.LE.0) RETURN
      IF(IDATA(IPJ).LE.3) RETURN
      IPJ = 2*IPJ
      J1 = IPJ + 6
      J2 = IPJ + 11
      NBIT=7
      DO 32 JK = J1,J2
      HELP(2) = HDATA(JK)
      ICAMWD = ISHFTL(ICAMWD,1)
      DO 32 IBT = 1,NBIT
      ICAMWD = ISHFTR(ICAMWD,1)
      IE = (JK-J1)*NBIT
      IF(.NOT.TBIT(ICAMWD,31)) GO TO 32
      IE = IE + IBT
      NTOF = NTOF + 1
      HTOF(IE) = 1
32    CONTINUE
C
      DO   1   I=1,42
      IF1 = 2*I-1
      IAD = ITOFST + IF1 + (IF1-1)/8
      ITDCL = HDATA(IPTOF+IAD)
      ITDCR = HDATA(IPTOF+IAD+1)
      IF(ITDCL.LT.10.OR.ITDCL.GE.2048)  GOTO  1
      IF(ITDCR.LT.10.OR.ITDCR.GE.2048)  GOTO  1
      TDCL = ITDCL*DM(I)-CM(I)
      TDCR = ITDCR*DP(I)-CP(I)
      TTOF(I) = .5*(TDCL+TDCR)
      MTOF = MTOF + 1
    1 CONTINUE
C/////////
       RETURN
       END

C   10/02/86 604291051  MEMBER NAME  PRTPTRR  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRTPTR( IPTPTR, XS, YS , DEL, SIZE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 29/04/86 :  PRINT BOS BANK TPTR
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
C
      COMMON / CWORK1 / HWORK(70)
C
C
C------------------  C O D E  ------------------------------------------
C
      LIM2 = IPTPTR
      LIMH2 = 2*LIM2
      CALL CORE(HWORK,110)
      WRITE(JUSCRN,1) (HDATA(LIMH2+I),I=1,18)
    1 FORMAT('  ',18I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,110,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(JUSCRN,2) (ADATA(LIM2+I),I=10,19)
    2 FORMAT('  ',10E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,78)
      WRITE(JUSCRN,3) IDATA(LIM2+20),ADATA(LIM2+21),IDATA(LIM2+22),
     &               (ADATA(LIM2+I),I=23,25),IDATA(LIM2+26)
    3 FORMAT('  ',I6,E14.6,I6,3E14.6,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,78,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(JUSCRN,4)(ADATA(LIM2+I),I=27,33),(HDATA(LIMH2+I),I=67,68)
    4 FORMAT('  ',7E14.6,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(JUSCRN,5) (ADATA(LIM2+I),I=35,38),(HDATA(LIMH2+I),I=77,78),
     &                (ADATA(LIM2+I),I=40,42)
    5 FORMAT('  ',4E14.6,2I6,3E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,74)
      WRITE(JUSCRN,6) (HDATA(LIMH2+I),I=85,96)
    6 FORMAT('  ',12I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,74,0.)
      YS = YS - DEL
      CALL CORE(HWORK,120)
      WRITE(JUSCRN,7) (ADATA(LIM2+I),I=49,57)
    7 FORMAT('   ',9E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
      YS = YS - DEL
      CALL CORE(HWORK,86)
      WRITE(JUSCRN,8) IDATA(LIM2+58),(ADATA(LIM2+I),I=59,64)
    8 FORMAT('   ',I5,6E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,86,0.)
      YS = YS - DEL
      CALL CORE(HWORK,100)
      WRITE(JUSCRN,9) (ADATA(LIM2+I),I=65,71)
    9 FORMAT('  ',7E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,100,0.)
      YS = YS - DEL
      CALL CORE(HWORK,98)
      WRITE(JUSCRN,10) IDATA(LIM2+72),(ADATA(LIM2+I),I=73,78),
     &                (IDATA(LIM2+I),I=79,80)
   10 FORMAT('  ',I6,6E13.5,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,98,0.)
      RETURN
      END

C   07/06/96 606071854  MEMBER NAME  LINFIL   (S4)          FORTG1
      SUBROUTINE LINFIL(X,Y,N,A)
      REAL X(1),Y(1),A(7)
      REAL Z(200),XR(200),YR(200),Q(400),P(5,5),B(5),S(100)
      EQUIVALENCE (S(1),Q(101))
C
C     FILTER LINEAR DEPENDENCE OF Y ON X
C
C     A(1) = INTERCEPT
C     A(2) = SLOPE
C     A(3) = SIGMA (SINGLE POINT)
C     A(4) = LINEARITY
C            IF LINEAR TERM INSIGNIFICANT, DISTRIBUTED ACCORDING
C            TO THE CHISQUARE DISTRIBUTION WITH 1 DEGREE OF
C            FREEDOM. THEREFORE BELOW 3.84 WITH 95 PC C.L.
C     A(5) = NONLINEARITY
C            REDUCTION OF SIGMA BY POLYNOMIAL OF 2.DEGREE FOR
C            N LESS EQUAL 50 OR BY POLYNOMIAL OF 4.DEGREE FOR
C            LARGER N. SHOULD BE ABOUT 1 FOR NO NONLINEARITY.
C     A(6) = RATIO OF GOOD/TOTAL POINTS
C     A(7) = MEAN Y
C
      IF(N.LE.5) GOTO 90
      K=1+(N-1)/200
      DO 50 IG=1,2
      L=0
      IS=0
   10 NS=MIN0(N-IS,200)
      IF(IS+NS.LT.N.AND.N-IS-NS.LT.100) NS=(N-IS)/2
      GOTO (12,16),IG
   12 DO 14 I=1,NS
   14 Z(I)=Y(I+IS)
      GOTO 20
   16 DO 18 I=1,NS
   18 Z(I)=Y(I+IS)-A(1)-A(2)*X(I+IS)
   20 CALL SM353(Z,Z,NS)
      I=0
      M=0
   30 IF(I.EQ.NS) GOTO 40
      I=I+1
      IF(M.NE.0) GOTO 35
      SX=0.0
      SY=0.0
   35 M=M+1
      SX=SX+X(I+IS)
      SY=SY+Z(I)
      IF(M.NE.K.AND.I.NE.NS) GOTO 30
      L=L+1
      XR(L)=SX/FLOAT(M)
      YR(L)=SY/FLOAT(M)
      M=0
      IF(NS-I.GE.K) GOTO 30
      IF(NS+IS.EQ.N) GOTO 30
      NS=I
   40 IS=IS+NS
      IF(IS.LT.N) GOTO 10
      IF(K.GT.1) CALL SM353(YR,YR,L)
      IF(L.LE.12) GOTO 46
      LC=L
      L =0
      DO 44 I=1,LC
      IF(L.NE.0.AND.YR(L).EQ.YR(I).AND.M.LT.3) GOTO 42
C     NOT EQUAL
      L=L+1
      YR(L)=YR(I)
      M=1
      XS=XR(I)
      GOTO 44
C     EQUAL
   42 M=M+1
      XS=XS+XR(I)
   44 XR(L)=XS/FLOAT(M)
      CALL SM353(YR,YR,L)
   46 LS=1
      IF(L.GT.10) LS=2
      L=L+2-LS-LS
      IF(IG.EQ.2) GOTO 50
      CALL ORTPOL(XR(LS),YR(LS),1.0,-L,2,Q,P)
      CALL ORTOPL(P,A,NP)
   50 CONTINUE
C
      NDEG=5
      IF(L.LT.50) NDEG=3
      CALL ORTPOL(XR(LS),YR(LS),1.0,-L,NDEG,Q,P)
      FN=(L-NDEG)*P(5,2)
      FD=(L-   2)*P(5,NDEG)
      CALL ORTRED(P,-1.0,2,NP)
      CALL ORTOPL(P,B,NP)
      J=0
      DO 59 I=1,N,K
      J=J+1
      YF=Y(I)-A(1)-A(2)*X(I)
      CALL POLFUN(X(I),YP,DY,B,NP)
   59 Q(J)=ABS(YF-YP)
      CALL SORT4(Q,J)
      SF=Q((J+1)/2)
      IF(SF.LE.0.0) GOTO 90
      DO 51 I=1,100
   51 Q(I)=0.0
      DO 52 I=1,N
      YF=Y(I)-A(1)-A(2)*X(I)
      CALL POLFUN(X(I),YP,DY,B,NP)
      NB=1.0+ABS(YF-YP)/SF
      IF(NB.LE.100) Q(NB)=Q(NB)+1.0
   52 CONTINUE
      S(1)=Q(1)
      DO 53 I=2,100
   53 S(I)=S(I-1)+Q(I)
      DO 54 I=1,50
      IF(S(I).GT.0.5*S(100)) GOTO 55
   54 CONTINUE
      I=50
   55 SL=0.01+1.0/FLOAT(N)
      DO 56 J=I,50
      IF(S(J+J)-S(J).LT.SL*S(J)) GOTO 57
   56 CONTINUE
      J=50
   57 SU=0.0
      DO 58 I=1,J
   58 SU=SU+Q(I)*(FLOAT(I)-0.5)**2
      SF=SF*SQRT(SU/S(J))
      L=0
      M=0
      NN=0
C
      DO 80 I=1,N
      YF=Y(I)-A(1)-A(2)*X(I)
      CALL POLFUN(X(I),YP,DY,B,NP)
      CH=ABS(YF-YP)/SF
      IF(CH.LT.3.0) GOTO 60
      IF(I.EQ.N.AND.M.NE.0) GOTO 75
      GOTO 80
   60 IF(M.NE.0) GOTO 70
      SX=0.0
      SY=0.0
   70 M=M+1
      SX=SX+X(I)
      SY=SY+Y(I)
      NN=NN+1
      IF(M.NE.K.AND.I.NE.N) GOTO 80
   75 L=L+1
      XR(L)=SX/FLOAT(M)
      YR(L)=SY/FLOAT(M)
      M=0
   80 CONTINUE
      IF(L.LE.5) GOTO 90
C
      CALL ORTPOL(XR,YR,1.0,-L,2,Q,P)
      CALL ORTRED(P,-1.0,2,NP)
      CALL ORTOPL(P,A,NP)
      SIGS=SQRT(P(5,2)/FLOAT(L-2))
      A(3)=SIGS*SQRT(FLOAT(K))
      A(4)=(P(4,2)/SIGS)**2
      A(5)=1.0
      IF(FN*FD.NE.0.0) A(5)=SQRT(FN/FD)
      A(6)=FLOAT(N-NN)/FLOAT(N)
      CALL ORTRED(P,0.0,1,NP)
      CALL ORTOPL(P,A(7),NP)
      GOTO 100
C
   90 DO 95 I=1,7
   95 A(I)=0.0
      CALL SM353(Y,YR,N)
      IF(N.LT.2) GOTO 100
      CALL ORTPOL(X,YR,1.0,-N,2,Q,P)
      CALL ORTRED(P,-1.0,2,NP)
      CALL ORTOPL(P,A,NP)
      A(3)=SQRT(P(2,1))
      CALL ORTRED(P,0.0,1,NP)
      CALL ORTOPL(P,A(7),NP)
  100 RETURN
      END

C   07/06/96 606071922  MEMBER NAME  BANDSL   (S4)          FORTG1
      SUBROUTINE BANDSL(A,N,M,IER)
      REAL A(M,N)
      IER=1
      MM=M-1
C     DECOMPOSITION
      DO 40 L=1,N
      IF(A(1,L).LE.0.0) GOTO 100
      A(1,L)=SQRT(A(1,L))
      DO 10 J=2,MM
   10 A(J,L)=A(J,L)/A(1,L)
      IA=L+1
      IB=MIN0(N,L+MM-1)
      IF(IB.LT.IA) GOTO 40
      DO 30 I=IA,IB
      JB=MM+L-I
      IF(JB.LT.1) GOTO 30
      DO 20 J=1,JB
   20 A(J,I)=A(J,I)-A(I-L+1,L)*A(I-L+J,L)
   30 CONTINUE
   40 CONTINUE
C     FORWARD
      DO 60 L=1,N
      S=A(M,L)
      DO 50 J=2,MM
      LJ=L-J+1
      IF(LJ.LT.1) GOTO 60
   50 S=S-A(M,LJ)*A(J,LJ)
   60 A(M,L)=S/A(1,L)
C     BACKWARD
      DO 80 LB=1,N
      L=N+1-LB
      S=A(M,L)
      DO 70 J=2,MM
      LJ=L+J-1
      IF(LJ.GT.N) GOTO 80
   70 S=S-A(M,LJ)*A(J,L)
   80 A(M,L)=S/A(1,L)
      IER=0
  100 RETURN
      END

C   03/12/83 312030144  MEMBER NAME  BRVECT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BRVECT( IUNIT, *, * )
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN             :  READ MC EVENT AND FILL VECT/0
C
C        MOD  C. BOWDERY  29/06/83 :  ALSO CREATE PALL/0 BANK
C        MOD  C. BOWDERY  20/10/83 :  FOR CPROD  MACRO
C        MOD  C. BOWDERY  17/11/83 :  CALL TO MCVALI TO CHECK INPUT
C        MOD  C. BOWDERY  22/11/83 :  IMPROVED ERROR MESSAGE CONTROL
C   LAST MOD  C. BOWDERY   2/12/83 :  CHANGED MESSAG (13/14) TO (18/19)
C   LAST MOD
C    P. Movilla Fernandez 21/12/00 :  Use subroutine CPREAD to read
C                                     CPROD file with different endian format
C
C
C  READ EVENT AND FILL 4 VECTOR BANK VECT/0 AND PALL/0. THE LATTER HAS
C  INFORMATION ABOUT ALL THE PARTICLES THE GENERATOR MADE.
C
C  RETURN 1    FOR READ ERROR, NOT ENOUGH SPACE IN BCS OR BAD INPUT DATA
C  RETURN 2    FOR EOF
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL VALID
C
      COMMON / BCS /  IW(1)
C
      COMMON / CVERR / MESSAG(20)
C
#include "cprod.for"
C
C PMF, 21/12/2000:
C MAXCP is the size of the CPROD common, see 'cprod.for'
      INTEGER MAXCP
      PARAMETER( MAXCP=7512 )
      INTEGER NBUFF(MAXCP)
      REAL RBUFF(MAXCP)
      EQUIVALENCE( NBUFF(1), RBUFF(1) )
C PMF, 21/12/00: IFORM tells us the endian format of the CPROD file
      INTEGER IFORM
      COMMON /CPFORM/ IFORM
C
C-----------------------  C O D E  -------------------------------------
C
C                                           READ EVENTS
C
      IF( IFORM.GE.0 ) THEN
      READ(IUNIT,ERR=8000,END=8100)  NEV, BEAM, PT, PHI, THETA, IFLAVR,
     *     NP, NC, NN, ( (PP(I4,N), I4=1,4), XM(N), JCH(N), JTP(N),
     *     (JP(N,I2), I2=1,2), N=1,NP),
     *     NF, NCF, NNF, ( (PF(I4,N2),I4=1,4), XMF(N2), ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
      ELSE
C PMF, 21/12/00: Read binary with different endian format using CFGET
         CALL CPREAD(NBUFF,'I',*8000,*8100)
         NEV   =NBUFF(1)
         BEAM  =RBUFF(2)
         PT    =RBUFF(3)
         PHI   =RBUFF(4)
         THETA =RBUFF(5)
         IFLAVR=NBUFF(6)
         NP    =NBUFF(7)
         NC    =NBUFF(8)
         NN    =NBUFF(9)
         DO N=1,NP
            DO I4=1,4
               PP(I4,N) = RBUFF( 9 + 9*(N-1) + I4  )
            ENDDO
             XM(N) = RBUFF( 9 + 9*(N-1) + 5 )
             JCH(N)= NBUFF( 9 + 9*(N-1) + 6 )
             JTP(N)= NBUFF( 9 + 9*(N-1) + 7 )
             DO I2=1,2
                JP(N,I2) = NBUFF( 9 +  9*(N-1) + 7 + I2 )
             ENDDO
          ENDDO
          NF    =NBUFF( 9 + 9*NP + 1 )
          NCF   =NBUFF( 9 + 9*NP + 2 )
          NNF   =NBUFF( 9 + 9*NP + 3 )
          DO N2=1,NF
             DO I4=1,4
                PF(I4,N2) = RBUFF( 9 + 9*NP + 3 + 10*(N2-1) + I4  )
             ENDDO
             XMF(N2) =RBUFF( 9 + 9*NP + 3 + 10*(N2-1) + 5 )
             ICF(N2) =NBUFF( 9 + 9*NP + 3 + 10*(N2-1) + 6 )
             ITF(N2) =NBUFF( 9 + 9*NP + 3 + 10*(N2-1) + 7 ) 
             DO I3=1,3
                PSTRT(I3,N2) =RBUFF( 9 + 9*NP + 3 + 10*(N2-1) + 7 + I3 )
             ENDDO
          ENDDO
       ENDIF
C
C                                           CHECK INPUT
C
      CALL MCVALI( VALID )
      IF( .NOT. VALID ) RETURN 1
C
C                                           CREATE VECT BANK
C
      CALL LHVECT( LENGTH )
      CALL BCRE( NPVECT, 'VECT', 0 , LENGTH, *8200, IER )
      CALL STVECT( LENGTH, IW(NPVECT+1) )
      CALL BSAW( 1, 'VECT' )
C
C                                           CREATE PALL BANK
C
      CALL LHPALL( LENGTH)
      CALL BCRE( NPALL, 'PALL', 0, LENGTH, *8300, IER )
      CALL STPALL( LENGTH, IW(NPALL + 1) )
      CALL BSAW( 1, 'PALL' )
      RETURN
C                                           READ ERROR
 8000 MESSAG(18) = MESSAG(18) + 1
      IF( MESSAG(18) .GT. 20 ) RETURN 1
C
      WRITE(6,8005) IUNIT
 8005 FORMAT(/' *** READ ERROR ***  INPUT UNIT NUMBER = ',I4,'    ***'/)
      RETURN 1
C                                           BOS ERROR (VECT)
 8200 MESSAG(19) = MESSAG(19) + 1
      IF( MESSAG(19) .GT. 20 ) RETURN 1
C
      WRITE(6,8205) IER
 8205 FORMAT(/' *** BOS ERROR ***  BCRE RETURNED ERROR CODE ',I2,
     +        '   WHILE CREATING VECT/0 IN BRVECT    ***'/)
      RETURN 1
C                                           BOS ERROR (PALL)
 8300 MESSAG(19) = MESSAG(19) + 1
      IF( MESSAG(19) .GT. 20 ) RETURN 1
C
      WRITE(6,8305) IER
 8305 FORMAT(/' *** BOS ERROR ***  BCRE RETURNED ERROR CODE ',I2,
     +        '   WHILE CREATING PALL/0 IN BRVECT    ***'/)
      RETURN 1
C                                           EOF DETECTED
 8100 RETURN 2
      END
C
C
C
      SUBROUTINE CPREAD( NBUFF, COPT, *, *)
      IMPLICIT NONE
C-----------------------------------------------------------------------
C
C     21/12/2000      Pedro Movilla Fernandez
C
C     Reads a CPROD record using the CERNLIB package CFIO [Z310].
C     This routine should be used if the binary CPROD data has an endian
C     format different from the one of the current platform.
C
C-----------------------------------------------------------------------
      INTEGER NBUFF(*)
      CHARACTER*1 COPT
C Get file pointer (firstly set by CFOPEN in MCMAIN)
      INTEGER NREAD,IOS,NWORDS,IFORM,IPTR,NDUM
      COMMON /MYIO/ IPTR
C Get record length
      NREAD=1
      CALL CFGET(IPTR,0,1,NREAD,NWORDS,IOS)
      IF( IOS.EQ.-1 ) THEN
         RETURN 2
      ELSEIF( IOS.NE.0 ) THEN
         RETURN 1
      ENDIF
      CALL VXINVB(NWORDS,1)
      NWORDS=NWORDS/4
C Read record
      CALL CFGET( IPTR, 0, NWORDS, NREAD, NBUFF,IOS )
      IF( IOS.NE.0 .OR. NREAD.NE.NWORDS ) RETURN 1
C Read last word of fortran record (=record length)
      NREAD=1
      CALL CFGET( IPTR, 0, 1, NREAD, NDUM, IOS)
      IF( IOS.NE.0 ) RETURN 1
C Perform byte-by-byte inversion of buffer
      IF( COPT.EQ.'I' ) CALL VXINVB(NBUFF,NWORDS)
C
      RETURN
      END

C   10/01/82 201101910  MEMBER NAME  PRSMP    (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE PRSMP
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IMPLICIT INTEGER*2 (H)
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
C
      PRINT 100
  100 FORMAT(' TOFSMP RESULTS')
      DO   1   I=1,42
      IF(HTOF(I).LE.0)  GOTO  1
      PRINT 101,I,TTOF(I)
  101 FORMAT(' TOF',I5,F12.2)
    1 CONTINUE
      RETURN
       END

      SUBROUTINE TRCK82(LBACC,LBTRG1,LBTRG2,IERRLG) 
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
      REAL LBACC
      REAL AND,OR
      EXTERNAL AND,OR
#include "cutsr1.for"
      COMMON /CREDRS/ ACCB2,ACCB4,ACCB8,ACCT2M
      COMMON /CWORK/ SUM12(12),SUMWRD(12)
      COMMON /CRESR1/ ETOT,EBAR,EC1,EC2,E7MIN,
     ,               JEMPTY,UNBAL,IACCLG
#include "cdata.for"
#include "cheadr.for"
      EQUIVALENCE (HHEADR(18),HRUN) , (HHEADR(19),HEV)
      COMMON /CWORK/ HCLWR(96)
      DATA MKLUMI /    1/, MKEHIG /   2/, MKTAGE /   4/, MKMUT1 /   8/
      DATA MKEC12 / Z100/, MKBEC  /Z200/, MKTAGB /Z400/, MKEB   /Z800/
      DATA MKET12 /Z1000/, MKOLS /Z2000/, MKRAN  /Z8000/
      DATA MKTAG  / Z404/, MKENGY / Z1F06/
      DATA MKUNT1 /Z40F0/
      DATA MKMUT2 /  Z80/
      DATA MKTR1  /    4/, MKTR2  /   1/, MKTR3  /   2/, MKTR2C /    8/
      DATA MKAT1  / ZF00/, MKAT2  / Z3F/, MKAT3  / ZC0/, MKAT2C /ZF000/
      INTEGER MKATOF(4) /0,    0, ZB037, ZB037/
      INTEGER MKATBG(4) /0, Z300, Z4308, Z4348/
      INTEGER MKTRBT( 7) /1,2,4,8,16,32,64/
      INTEGER NCTOF ( 7) /2,3,3,3,3,3,3/
      INTEGER ICTOF ( 7) /0,1,2,3,4,5,6/
      DATA LBINIT /0/,  NLUMI /16/, ILUMI /0/
 2001 FORMAT(' TRCK82: NO TRIG-1 BANK FOR EVENT',2I6)
 2002 FORMAT(' TRCK82: EVENT',2I6,3(2X,Z4),6I6)
 2009 FORMAT(' TRCK82: EVENT',2I6,10(2X,Z4))
 2003   FORMAT('0EROW:',20I6,/,(6X,20I6))
 2004 FORMAT(' TRCK82: NO BEAM ENERGY FOR EVENT',2I6,'EBEAM =',F8.0,
     ,       ' USE EBEAM = 17 000 GEV INSTEAD  *********************')
 2005 FORMAT(' JETC:',20I6)
 2006 FORMAT('0HCLWR:',12I6,/,(7X,12I6))
 2007 FORMAT(' TRCK82: UNKNOWN TRIGGER FOR EVENT',2I6,3(2X,Z4),
     ,       2X,8('**'))
 2008 FORMAT('0LGCT82:',2I6,2(/,1X,12F8.0),/,1X,5F8.0,I8,F8.3,I8)
      LBACC  = 0
      ACCB2  = 0
      ACCB4  = 0
      ACCB8  = 0
      ACCT2M = 0
      IF(
     - LBINIT.EQ.0
     -)THEN
        LBINIT = 1
        NPRUN  = 0
        IQJETC = IBLN('JETC')
        IQTRIG = IBLN('TRIG')
        IQLATC = IBLN('LATC')
        IQALGN = IBLN('ALGN')
        EBEAM = HHEADR(37)
      IF(
     - EBEAM.LE.6000.
     -)THEN
          PRINT 2004, HRUN,HEV,EBEAM
          EBEAM = 1700.
      ENDIF
        EB35   = EBEAM * .35
        EB50   = EBEAM * .50
        EB65   = EBEAM * .65
      ENDIF
      IPTRIG = IDATA(IQTRIG)
      IF(
     - IPTRIG.LE.0 .OR. IDATA(IPTRIG-2).NE.1
     -)THEN
        PRINT 2001, HRUN,HEV
        LBTRG1 = 0
        LBTRG2 = 0
        RETURN
      ENDIF
      LBTRG1 = HDATA(IPTRIG*2+ 8)
      LBTRP1 = HDATA(IPTRIG*2+ 9)
      LBTRG2 = HDATA(IPTRIG*2+10)
      PRINT 2007, HRUN,HEV, LBTRG1,LBTRP1,LBTRG2
      I0 = IPTRIG*2 + 1
      I9 = I0 + IDATA(IPTRIG)*2 - 1
      IF(
     - AND(LBTRG1,MKUNT1).NE.0
     -)THEN
        NPRUN = NPRUN + 1
        IF(NPRUN.LE.10) PRINT 2007, HRUN,HEV, LBTRG1,LBTRP1,LBTRG2
      ENDIF
      IF(AND(LBTRG1,MKRAN).NE.0) LBACC = OR(LBACC,1)
      IF(AND(LBTRG1,MKRAN).NE.0) ACCB2 = OR(ACCB2,MKRAN)
      IF(
     - AND(LBTRG1,MKLUMI).NE.0
     -)THEN
        ILUMI = ILUMI + 1
      IF(
     - ILUMI.EQ.NLUMI
     -)THEN
          LBACC = OR(LBACC,1)
          ILUMI = 0
          ACCB2 = OR(ACCB2,MKLUMI)
      ENDIF
      ENDIF
      IF(AND(LBTRG1,MKMUT1) .NE.0) ACCB4 = OR(ACCB4,MKMUT1)
      IF(AND(LBTRG1,MKMUT1) .NE.0) LBACC = OR(LBACC,4)
      IF(
     - AND(LBTRP1,MKMUT2).NE.0
     -)THEN
        CALL MEWT3(IMUACC)
      IF(
     - IMUACC.NE.0
     -)THEN
          LBACC = OR(LBACC,4)
          ACCB8 = OR(ACCB8,MKMUT2)
      ENDIF
      ENDIF
      IACCLG = 0
      IPALGN = IDATA(IQALGN)
      IF(AND(LBTRG1,MKENGY).NE.0 .AND. IERRLG.EQ.0 .AND. IPALGN.GT.0)
     ?  CALL LGCT82(IPALGN)
      IF(
     - IACCLG.EQ.0
     -)THEN
        EBAR = 0.
        EC1  = 0.
        EC2  = 0.
        ETOT = 0.
      ELSE
        PRINT 2008, HRUN,HEV,(SUM12(I1),I1=1,24)
     ,            , ETOT,EBAR,EC1,EC2,E7MIN, ELGLM
      ENDIF
      LBCSM = 0
      IF(
     - AND(LBTRG1,MKTAG).NE.0
     -)THEN
        CALL TAGF82(IFTG)
      IF(
     - IFTG.GT.0
     -)THEN
      IF(
     - AND(LBTRG1,MKTAGB).NE.0
     -)THEN
            LBACC = OR(LBACC,2)
            ACCB2 = OR(ACCB2,MKTAGB)
      ELSE
            ECENTR = 0.
            IF(IFTG.EQ.11) ECENTR = ETOT - EC1
            IF(IFTG.EQ.12) ECENTR = ETOT - EC2
            IF(IFTG.GT.12) ECENTR = ETOT
      IF(
     - ECENTR.GT.100. .AND. ETOT.GT.ELGLM(3)
     -)THEN
              LBACC = OR(LBACC,2)
              ACCB2 = OR(ACCB2,MKTAGE)
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - AND(LBTRG1,MKEHIG).NE.0
     -)THEN
      IF(
     - ETOT.GT.EB65
     -)THEN
          LBACC = OR(LBACC,2)
          ACCB2 = OR(ACCB2,MKEHIG)
      ELSE
      IF(
     - ETOT.GT.ELGLM( 1)
     -)THEN
          IF(JEMPTY.LE.1) LBACC = OR(LBACC,2)
          IF(JEMPTY.LE.1) ACCB2 = OR(ACCB2,MKEHIG)
      ENDIF
      ENDIF
      ENDIF
      IF(
     - AND(LBTRG1,MKEC12).NE.0
     -)THEN
        E1 = AMIN1(EC1,EC2)
      IF(
     - E1.GT.EB35
     -)THEN
          LBACC = OR(LBACC,2)
          ACCB2 = OR(ACCB2,MKEC12)
      ELSE
          IF(E1.GT.ELGLM(6)) LBACC = OR(LBACC,4)
          IF(E1.GT.ELGLM(6)) ACCB4 = OR(ACCB4,MKEC12)
      ENDIF
      ENDIF
      IF(
     - AND(LBTRG1,MKET12).NE.0
     -)THEN
        E1       = AMIN1(EC1,EC2)
      IF(
     - E1.GT.ELGLM(8) .AND. ETOT.GT.ELGLM(2)
     -)THEN
          LBACC = OR(LBACC,4)
          ACCB4 = OR(ACCB4,MKET12)
      ENDIF
      ENDIF
      IF(
     - AND(LBTRG1,MKBEC).NE.0
     -)THEN
      IF(
     -  EBAR.GT.ELGLM(4)
     -)THEN
      IF(
     - EC1.GT. ELGLM(7) .OR. EC2.GT. ELGLM(7)
     -)THEN
      IF(
     - ETOT.GT.EB65
     -)THEN
            LBACC = OR(LBACC,2)
            ACCB2 = OR(ACCB2,MKBEC)
      ELSE
            IF(JEMPTY.LE.1) LBACC = OR(LBACC,2)
            IF(JEMPTY.LE.1) ACCB2 = OR(ACCB2,MKBEC)
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - AND(LBTRG1,MKEB).NE.0
     -)THEN
      IF(
     - EBAR.GE.ELGLM(2)
     -)THEN
          IF(LBCSM.EQ.0) CALL LGBRCS(IRBAR)
          LBCSM = 1
          IF(IRBAR.EQ.1 .AND. JEMPTY.GT.1) IRBAR =  2
          IF(IRBAR.LE.1) LBACC = OR(LBACC,2)
          IF(IRBAR.LE.1) ACCB2 = OR(ACCB2,MKEB)
      ENDIF
      ENDIF
      PRINT 2002, HRUN,HEV, LBTRG1,LBTRG2,LBACC,JEMPTY,UNBAL,IRBAR,LBCSM
      IF(AND(LBACC,2).NE.0) RETURN
      IF(AND(LBTRG2,15).EQ.0) RETURN
      IPJETC = IDATA(IQJETC)
      IF(
     - IPJETC.LE.0
     -)THEN
        PRINT 2002, HRUN,HEV, LBTRG1,LBRG2,LBACC
        RETURN
      ENDIF
      IF(IDATA(IPJETC).LE.50) RETURN
      IPJC2 = IPJETC*2
      NHTR3 = HDATA(IPJC2+99) - HDATA(IPJC2+51)
      IF(NHTR3.LE.0) RETURN
      CALL SETS(HCLWR(1),0,192,0)
      IP0 = IPJC2 + 100 + HDATA(IPJC2+51)
      IP9 = IP0 + NHTR3 - 1
      IWIR0 =-1
      DO 13000 IP=IP0,IP9,4
        IWIR = HDATA(IP)
        IWIR = ISHFTR(IWIR,3)
      IF(
     - HDATA(IP+1).GT.80 .AND. HDATA(IP+2).GT.80
     -)THEN
          HCLL = ISHFTR(IWIR,3) - 95
          IF(IWIR.NE.IWIR0) HCLWR(HCLL) = HCLWR(HCLL) + 1
      ENDIF
        IWIR0 = IWIR
13000 CONTINUE
13001 CONTINUE
      IPLATC = IDATA(IQLATC)
      IF(IPLATC.LE.0) RETURN
      IPLT2 = IPLATC*2
      IP0 = IPLT2 + 6
      IP9 = IP0 + 5
      IPTBG = IPTRIG*2 + 5
      ITBG  = 0
      ITLST =-100
      ITOF0 = 0
      ICLL0 = 0
      NTRCK = 0
      NTRBG = 0
      NTREL = 0
16000 CONTINUE
        ITRBT = HDATA(IP0)
      IF(
     - AND(ITBG,1).EQ.0.
     -)THEN
          ITRBG = HDATA(IPTBG)
          IPTBG = IPTBG + 1
          ITBG = ITBG + 1
      ELSE
          ITRBG = ISHFTR(ITRBG,8)
          ITBG = ITBG + 1
      ENDIF
      DO 13002 JTOF=1,7
      IF(
     - AND(MKTRBT(JTOF),ITRBT) .NE. 0
     -)THEN
            ITOF = ITOF0 + JTOF
            JCTOF = (ICTOF(JTOF) + ICLL0)*2 - 1
            LBTRK = 0
      IF(
     - ITOF-ITLST.LE.2
     -)THEN
              HCLL9 = NCTOF(JTOF)*2 + JCTOF - 1
              HCLL1 =-99
              MTRK = 0
      DO 13004 ICLL=HCLL0,HCLL9
      IF(
     - HCLWR(ICLL).GE.6
     -)THEN
                  HDCLL = ICLL - HCLL1
      IF(
     - HDCLL.EQ.1
     -)THEN
                    HCLL1 = -99
      ELSE
      IF(
     - HDCLL.NE.3 .OR. TBIT(ICLL,31)
     -)THEN
                      MTRK = MTRK + 1
                      HCLL1 = ICLL
      ENDIF
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
              IF(MTRK.GE.2) LBTRK = 1
      ELSE
              NHIT5 = 0
              NHIT6 = 0
      IF(
     - JCTOF.LT.0
     -)THEN
                NHIT1 = HCLWR(95)
                NHIT2 = HCLWR(96)
                NHIT3 = HCLWR( 1)
                NHIT4 = HCLWR( 2)
                IF(NHIT2.GE.3 .AND. HCLWR(93).GE.6) NHIT2 = 8
                IF(NHIT4.GE.3 .AND. HCLWR( 3).GE.6) NHIT4 = 8
      ELSE
                NHIT1 = HCLWR(JCTOF  )
                NHIT2 = HCLWR(JCTOF+1)
                NHIT3 = HCLWR(JCTOF+2)
                NHIT4 = HCLWR(JCTOF+3)
      IF(
     - NCTOF(JTOF).EQ.3
     -)THEN
                  NHIT5 = HCLWR(JCTOF+4)
                  NHIT6 = HCLWR(JCTOF+5)
      ELSE
                  IF(NHIT2.GE.3 .AND. HCLWR(JCTOF-2).GE.6) NHIT2 = 8
                  IF(NHIT4.GE.3 .AND. HCLWR(JCTOF+4).GE.6) NHIT4 = 8
      ENDIF
      ENDIF
              IF(MAX0(NHIT1,NHIT2,NHIT3,NHIT4,NHIT5,NHIT6).GE.6) LBTRK=100045400
      ENDIF
      IF(
     - LBTRK.NE.0
     -)THEN
              NTRCK = NTRCK + 1
              IF(AND(MKTRBT(JTOF),ITRBG) .NE. 0.) NTRBG = NTRBG + 1
              ITLST = ITOF
              HCLL0 = JCTOF
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
      ICLL0 = ICLL0 + 8
      ITOF0 = ITOF0 + 7
      IP0   = IP0   + 1
      IF(.NOT.(
     - IP0.GT.IP9
     -))GOTO 16000
16001 CONTINUE
      ACCT2M = 0.
      IF(AND(LBTRG2,MKTR1 ).NE.0.) ACCT2M = OR(ACCT2M,MKAT1 )
      IF(AND(LBTRG2,MKTR2 ).NE.0.) ACCT2M = OR(ACCT2M,MKAT2 )
      IF(AND(LBTRG2,MKTR3 ).NE.0.) ACCT2M = OR(ACCT2M,MKAT3 )
      IF(AND(LBTRG2,MKTR2C).NE.0.) ACCT2M = OR(ACCT2M,MKAT2C)
      ACCT2M = AND(ACCT2M,LBTRP1)
      IMK = MIN0(NTRCK,3)
      ACCTOF = AND(ACCT2M,MKATOF(IMK+1))
      IMK = MIN0(NTRBG,3)
      ACCTBG = AND(ACCT2M,MKATBG(IMK+1))
      ACCB8  = OR(ACCB8,ACCTOF)
      ACCB8  = OR(ACCB8,ACCTBG)
      IF(ACCTOF.NE.0 .OR. ACCTBG.NE.0) LBACC = OR(LBACC,8)
      PRINT 2009, HRUN,HEV,LBTRG1,LBTRG2,LBTRP1,ACCT2M,LBACC,NTRCK,NTRBG
     ,          , ACCTOF,ACCTBG
      RETURN
      END

C   29/04/82 208252238  MEMBER NAME  @LGTOFCL (SOURCE)      FORTRAN
C
C        MAIN ROUTINE FOR LG-TOF CALIBRATION
C
C     S.YAMADA  29-04-82   09:40
C     LAST MODIFICATION  24-08-82   18:10
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON //BSPACE(35000)
      COMMON /BCS/ IDATA(40000)
      DIMENSION ADATA(40000)
      INTEGER *2 HDATA(80000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
      DATA LDATA/40000/
C
      COMMON /CTPMCT/ ICREC,MAXREC, NRUN,NRUN1,NRUN2,KRUN1,KRUN2,
     $                NTLEFT,NTOUT
C
      DATA ISTART/0/, ITD/0/
C
C---- INPUT UNIT=IUNIT,  OUTPUT UNIT=JUNIT
      IUNIT=1
      JUNIT=2
C
C---- SET THE RUN EXP-NUMBER RANGE TO BE COPIED.
C     NORMAL SEQUENCE IS ASSUMED.
      READ(5,500) MAXREC,NRUN1,NRUN2,MESG, ITD
  500 FORMAT(5I10)
C
      WRITE(6,602) MAXREC,NRUN1,NRUN2
  602 FORMAT('0*********** INPUT CONDITIONS ***********',
     $        /' MAXREC=',I10,'      NRUN1,NRUN2=',2I10)
C
      ICREC = 0
      ICRECO = 0
      JCREC = 0
      JCRECO = 0
      KRUN2 = 0
      CALL HBOOK1(1,'BTDC$',100,0.,2000.,0)
      CALL HBOOK2(20,'BADC VS ETOTB$',100,0.,40.,52,0.,2080.,0)
      CALL HBOOK2(22,'ETOTB(GEV) VS BTDC(CH)$',100,0.,2000.,50,0.,50.,0)
      CALL HBOOK2(2,'BADC VS BTDC$',100,0.,2000.,50,0.,2500.,0)
      CALL HBPROY(2,0)
      CALL HBOOK2(10, 'ETOTB VS CORRECTED TOF$',
     $                              100,-20.,20.,50,0.,50.,0)
      CALL HBPROX(10,0)
      CALL HSQUEZ( 3HYES )
C
      CALL BINT(LDATA,2000,1000,0)
CC    CALL BWRO( JUNIT, 1558, 2)
C
 1000 IF(ICREC.GE.MAXREC .AND. JCREC.GE.MAXREC ) GO TO 300
C
C----    CHECK TIME
      NTLEFT = NTIME(DUM)
      IF(NTLEFT.LT.100) GO TO 400
C
      CALL BREAD(IUNIT,&1001,&100)
      ICREC=ICREC+1
C
C          SET THE LAST RUN NO.
      CALL BLOC( NPHD, 'HEAD', 0, &1002 )
      NPHD2 = 2*NPHD
      NRUN=HDATA(NPHD2+9)*100000+HDATA(NPHD2+10)
C
      IF( NRUN.LT.NRUN1 ) GO TO 1010
      IF( NRUN.GT.NRUN2 ) GO TO 200
      IF( NRUN.EQ.KRUN2 ) GO TO 2000
      IF( KRUN1.EQ.0 ) GO TO 10
C
C---     NEW  RUN
      NEVIN  = ICREC-ICRECO-1
      NEVOUT = JCREC-JCRECO
      IF(MESG.GT.0) WRITE(6,600) KRUN2,ICRECO,NEVIN,NEVOUT,JCREC
  600 FORMAT(' RUN#',I8,' ICREC=',I7,'  EV.READ=',I6,' EV.WRITTEN=',
     $               I5,' JCREC=',I6)
C
C---  LG-TOF CALIBRATION OUTPUT
      IF(SUM.LE.0.) SUM = 1.0
      AVT = STDC/SUM
      WRITE(6,606) KRUN2, SUM,STDC,AVT
  606 FORMAT(' KRUN2=',I10,'  SUM,STDC,=',2F10.2,10X,'AVTOF=',F10.3,/)
      IF( SUM.GT.1. .AND. ABS( AVT-AVTO ).GT.50.0 )   CALL HPRINT(1)
      LRUN = HDATA(NPHD2+10)
      CALL HFILL(100,LRUN,AVT,1.0)
      SUM = 0.
      STDC = 0.
      AVTO = AVT
      CALL HRESET(1)
C---- BIG CHANGE BOUNDARY
      IF( KRUN2.NE.2010241 .AND. KRUN2.NE.2010263 .AND.
     *    KRUN2.NE.2010361 ) GO TO 10
C---- GET THE AVERAGE OF THE GROUP
      IF( BIGSUM.LE.0. ) BIGSUM = 1.0
      BIGAV = BIGTDC/BIGSUM
      WRITE(6,620 ) KRUN2, BIGSUM, BIGAV
  620 FORMAT('0BIG AVERAGE TILL RUN',I10,'   SUM=',F10.1,'  AV=',F10.2)
      BIGSUM = 0.
      BIGTDC = 0.
C---
   10 KRUN2 = NRUN
      ICRECO = ICREC
      JCRECO = JCREC
      IF( ISTART ) 20,20,2000
C---     NEW EVENT BEFORE ANY ANALYSIS.  REMEMBER THE FIRST RUN #.
   20               KRUN1 = NRUN
C----      SET UP FOR HITOGRAM FOR AV.TOF
           LRUN1 = HDATA(NPHD2+10)
           LRUN2 = LRUN1+500
           CALL HBOOK2(100,'AV.TOF VS RUN NO.$',100,LRUN1,LRUN2,
     *                                          60,700.,1300.,0)
           BIGSUM = 0.
           BIGTDC = 0.
                    ISTART = 1
C
C************  EVENT HIST ***************
 2000 CONTINUE
C---- CHECK TRIGGER
      NPTRG = IDATA( IBLN('TRIG') )
      JT1ACP = HDATA( 2*NPTRG+8 )
      JTB = MOD(JT1ACP,4096)/2048
      IF( JTB.NE.1 )                         GO TO 1010
C---- CHECK BARREL TDC
      NPATST = IDATA( IBLN('ATST') )*2
      BADC = HDATA(NPATST+4)
      BTDC = HDATA(NPATST+17)
      CBTDC = BTDC+280.0-70.0*(2.0-0.001*BADC)**2
        SUM = SUM+1.0
        STDC = STDC+CBTDC
        BIGSUM = BIGSUM+1.0
        BIGTDC = BIGTDC+CBTDC
      CALL HFILL( 1, CBTDC, BADC, 1.0)
      CALL HFILL( 2, CBTDC, BADC, 1.0)
C---- CORRELATION OF ETOTB AND BADC
      NPCL = IDATA( IBLN('LGCL') )
      ETOTB = ADATA( NPCL+12 )
      CALL HFILL(20,ETOTB, BADC, 1.0 )
      CALL HFILL(22, BTDC,ETOTB, 1.0)
C---- ALREADY CORRECTED ONE
      CALL LGBTDC( CTDC, JFLAG )
      IF( JFLAG.LE.0 ) CALL HFILL( 10, CTDC, ETOTB, 1.0 )
C
 2001 GO TO 1010
C
C---     READ ERROR ON INPUT DATA SET
 1001 CALL TPMESG(1)
      GO TO 1010
C
C----    HEADER IS MISSING
 1002 CALL TPMESG(2)
C
C----    ERASE ALL BANKS FOR THE NEXT EVENT.
 1010 CALL BSLT
      CALL BDLG
      GO TO 1000
C
  100 CALL TPMESG(21)
      GO TO 10000
  200 CALL TPMESG(22)
      GO TO 10000
  300 CALL TPMESG(23)
      GO TO 10000
  400 CALL TPMESG(24)
C
10000 CONTINUE
C---- GET THE AVERAGE OF THE GROUP
      IF( BIGSUM.LE.0. ) BIGSUM = 1.0
      BIGAV = BIGTDC/BIGSUM
      WRITE(6,620 ) KRUN2, BIGSUM, BIGAV
      NEVIN  = ICREC-ICRECO
      NEVOUT = JCREC-JCRECO
      IF(MESG.GT.0) WRITE(6,600) KRUN2,ICRECO,NEVIN,NEVOUT,JCREC
      CALL BSTA
      CALL HSQUEZ( 2HNO )
      CALL HPRINT(2)
      CALL HPRINT(10)
      CALL HPRINT(20)
      CALL HPRINT(22)
      CALL HPRINT(100)
      STOP
      END

C   01/11/84            MEMBER NAME  PBGCYL   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PBGCYL(DEFIX)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  LG END CAPS ENERGIES (CYL-V.)
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgeo1.for"
#include "cgraph.for"
C
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  IMW(132)
C
      COMMON /CJTRIG/ PI,TWOPI
C
      DATA HCALL /0/
C
C-----------------  C O D E  -------------------------------------------
C
      HCALL = HCALL + 1
      IF(HCALL.GT.1) GO TO 3551
      ZDEEP = 5800.
      ZETMX = ZLGPL + ZDEEP
C     LEAD GLASS AMPLITUDES IN RZ VIEWS
3551  IPJ = IDATA(IBLN('ALGN'))
      IF(IPJ.LE.0) RETURN
      NWO = IDATA(IPJ)
      IF(NWO.LE.3) RETURN
      IPJ = 2*IPJ
      IPJH = HDATA(IPJ+3)
      IF(IPJH.LE.0) RETURN
      IF(IPJH.GE.HDATA(IPJ+4)) RETURN
      NI = IPJ + IPJH + 6
C     REGISTER LEAD GLASS HITS
   97 CONTINUE
      NO = HDATA(NI)
      IF(NO.GT.2687) GO TO 17
      IF(HDATA(NI+1).LT.1) GO TO 18
C     BLOCK NUMBER, COLUMN AND ROW
      NFI = NO/32
      NZET = NO - NFI*32
      FB1 = NFI*DEFIX
      FB2 = FB1 + DEFIX
      ZB1 = NZET*BLZ
      ZB2 = ZB1 + BLZ
C     PERSPECTIVE FACTORS
      RB1 = RLG*(ZETMX-ZB1)/ZETMX
      RB2 = RLG*(ZETMX-ZB2)/ZETMX
      CSFB1 = COS(FB1)
      SNFB1 = SIN(FB1)
      CSFB2 = COS(FB2)
      SNFB2 = SIN(FB2)
C     MARK OUT BLOCK WITH HIT
      X1 = - RB1*CSFB1
      Y1 = RB1*SNFB1
      X2 = - RB2*CSFB1
      Y2 = RB2*SNFB1
      X3 = - RB2*CSFB2
      Y3 = RB2*SNFB2
      X4 = - RB1*CSFB2
      Y4 = RB1*SNFB2
      CALL CRICRO(0.,0.)
   18 NI = NI + 2
   17 CONTINUE
      IF((NI.LE.(IPJ + 2*NWO)).AND.(NO.LE.2687)) GO TO 97
      RETURN
      END

C   08/09/79 109150908  MEMBER NAME  KALADD   (JADESR)      FORTRAN
      SUBROUTINE KALADD
      IMPLICIT INTEGER*2 (H)
C---
C---     FOR ADDING ON AND MODIFYING CALIBRATION RECORDS.
C---                                   L.H. O'NEILL 08.09.79
C---     LAST MODIFICATION 09:00 07-10-79 Y.WATANABE
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      DIMENSION HTIME(6),HDAT(3),HCAT(1)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
      EQUIVALENCE(HDAT(1),IDAT(1))
      EQUIVALENCE(HCAT(1),HDAT(3))
      DATA NAME/'MUCA','LGMA','TAGS','JTPL','JTAB','TOFC','LGST'/
C---
      ITIME(1)=0
      ITIME(2)=0
      ITIME(3)=0
      ITIME(4)=1
      ITIME(5)=1
      ITIME(6)=1979
      LASTIM=0
      IDMTIM=KTMCON(ITIME,KTWRIT,LASTIM)
      NREC=0
C---
C---     LOOP OVER THE RECORDS ON THE EXISTING CALIBRATION FILE (UNIT 3)
C---     MAKE DELETIONS AND MODIFICATIONS AND WRITE TO SCRATCH FILE
C---     UNIT 4.
C---
      REWIND 3
    1 CONTINUE
      CALL EVREA1(3,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
C---
C---     DELETE UWANTED RECORDS. CHECK CAREFULLY.
C---
      CALL KALBNK(4,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      STOP
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
C---
C---     ADD ON NEW RECORD(S) MADE FROM DATA ON UNIT 8 ETC.
C---     AND WRITE THESE TO UNIT 3 SCRATCH FILE.
C---
      JBUF(1)=NAME(7)
      JBUF(2)=1
      JBUF(3)=1
      JBUF(4)=0
      JBUF(5)=KTWRIT
      JBUF(6)=0
      JBUF(7)=1
      JBUF(8)=0
      JBUF(9)=0
      NREC=0
    4 CONTINUE
      CALL EVREAH(8,NWORDH,HCAT,IRET)
      IF(IRET.EQ.1) GO TO 1001
      IF(IRET.EQ.2) GO TO 2001
      NREC=NREC+1
C---
C---     SELECT RECORDS FROM INPUT UNIT(S).
C---
      IDAT(1)=NWORDH
         IF(IDAT(1).LE.10) GO TO 4
         IF(IDAT(2).LE.500) GO TO 4
C         IDAT(1)=LENG, IDAT(2)=#EV.  BETTER BE NO DATA THAN
C         HAVING SHORT DATA.
      NWORDH=NWORDH+2
      ITIME(1)=HCAT(5)
      ITIME(2)=HCAT(6)
      ITIME(3)=HCAT(7)
      ITIME(4)=HCAT(8)
      ITIME(5)=HCAT(9)
      ITIME(6)=HCAT(10)
      LASTIM=0
      JBUF(6)=KTMCON(ITIME,KTDUMM,LASTIM)
      IF(JBUF(6).EQ.0) GO TO 4
C---
C---     SUBTRACT 200 SECONDS FROM EFFECTIVE TIME TO MAKE SURECHANGE
C---     GOES INTO EFFECT AT START OF RUN.
C---
      JBUF(6)=JBUF(6)-200
C---     SET RUN #
      JBUF(8)=HCAT(4)
      NWORD=NWORDH/2
      IF((2*NWORD).NE.NWORDH) NWORD=NWORD+1
      NWORD=NWORD+9
      CALL KALBNK(4,NWORD,JBUF)
      GO TO 4
 1001 CONTINUE
      WRITE(6,201) NREC
  201 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS. (TWO)')
      STOP
 2001 CONTINUE
      WRITE(6,202) NREC
  202 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS ON ADD ON FILE.')
C---
C---     WRITE BACK FROM THE SCRATCH FILE ONTO THE ORIGINAL INPUT FILE.
C---
      NREC=0
      REWIND 3
      REWIND 4
    2 CONTINUE
      CALL EVREA1(4,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1002
      IF(IRET.EQ.2) GO TO 2002
      NREC=NREC+1
      CALL KALBNK(3,NWORD,JBUF)
      GO TO 2
 1002 CONTINUE
      WRITE(6,203) NREC
  203 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS. (THR)')
      STOP
 2002 CONTINUE
      WRITE(6,204) NREC
  204 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS ON SCRATCH FILE.')
      RETURN
      END

C   21/07/79 504191913  MEMBER NAME  GAMDIS   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE GAMDIS(INDEX,VX,VY,VZ)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON   21/07/79 :  DISPLAY PHOTONS
C
C       MOD:   J. OLSSON   15/02/84 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C  LAST MOD:   C. BOWDERY  19/04/85 :  RECOMMENTED. CHANGE MADE FOR VC
C
C     DISPLAY PHOTONS FROM THE BANK 'LGCL'
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CHEADR / HEAD(108)
      COMMON /CJTRIG/ PI,TWOPI
C
#include "cgraph.for"
#include "cdata.for"
#include "cgeo1.for"
C
      DATA  ZDEEP / 5800.0 /
C
C-----------------------------------------------------------------------
C
      IPLGCL=IDATA(IBLN('LGCL'))
      IF(IPLGCL.LE.0) RETURN
      IF(IDATA(IPLGCL).LE.26) RETURN
      IPALGN=IDATA(IBLN('ALGN'))
      IPPATR=IDATA(IBLN('PATR'))
      LASTRM = LASTVW
      IF(LASTVW.EQ.14) LASTVW = 1
      ISTEP = IDATA(IPLGCL+21)
      IF(ISTEP.NE.2) CALL LGCDIR(IPPATR,IPALGN,IPLGCL)
      IPLGCL=IDATA(IBLN('LGCL'))
      IPALGN=IDATA(IBLN('ALGN'))
      IPPATR=IDATA(IBLN('PATR'))
      NWPCL = IDATA(IPLGCL+25)
      IPO = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      NCLST = IDATA(IPLGCL+7)
      JUMPCL = IDATA(IPLGCL+2)
      RTS = RLG
      ZZPL = ZENDPL
      ZZMI = ZENDMI
      IF(INDEX.EQ.1.OR.INDEX.EQ.4.OR.INDEX.EQ.8) RTS = RTOF
      IF(INDEX.GE.17.AND.INDEX.LE.19) RTS = 0.33*(XMAX-XMIN)
      IF(INDEX.GE.17.AND.INDEX.LE.19) ZZPL = RTS
      IF(INDEX.GE.17.AND.INDEX.LE.19) ZZMI = -RTS
      IGAM = 0
C
      DO  1  I = 1,NCLST
        IPO   = IPO + NWPCL
        JTYP  = IDATA(IPO+8)
C
C                            IF THIS CLUSTER IS NOT A PHOTON, IGNORE
C
        IF( JTYP .NE. 0 ) GO TO 1
        IGAM  = IGAM + 1
C
C                            IF CLUSTER IS A SPINNER, IGNORE FOR CDTL 3400004810
C
        IF( .NOT. DSPDTM(4) ) GO TO 11
          IPBL  = HDATA(2*(IPLGCL+JUMPCL+I-1)-1)
          IPBL2 = HDATA(2*(IPLGCL+JUMPCL+I-1))
          NBL   = HDATA(2*(IPALGN + 3 + IPBL)-1)
          IER   = 0
          IF( IPBL .EQ. IPBL2 ) CALL SPINNR( NBL,IER,HEAD(18) )
          IF( IER .EQ. 0 ) GO TO 11
          GO TO 1
C
C                            CUT PHOTONS BELOW 200 MEV FOR CDTL 35
C
  11    IF( DSPDTM(5)  .AND.  ADATA(IPO+2) .LT. 0.200 ) GO TO 1
C
C                            CHECK LG DETECTOR PART ( JPART )
C
        JPART = IDATA(IPO+1)
        IF( JPART .NE. 0 ) GO TO 2
C
C                            DRAW BARREL PHOTONS  ( JPART = 0 )
C
        PHI  = ATAN2(ADATA(IPO+10),ADATA(IPO+9))
        IF( PHI .LT. 0.0 ) PHI = PHI + TWOPI
        THE  = ARCOS(ADATA(IPO+11))
        IF( VZ .EQ. 0.0 ) GO TO 14
          THE = ATAN2( ADATA(IPO+5) - VZ, RLG )
          THE = PI*0.5 - THE
  14    XP   = RTS*COS(PHI)
        YP   = RTS*SIN(PHI)
C
        ZP   = VZ
        IF( ABS(PI*0.5-THE) .GE. 0.001 ) ZP = RTS/TAN(THE) + VZ
        VXP  = VX
        VYP  = VY
        VZP  = VZ
C
C                            SKIP IF NOT CYLINDER VIEW
C
        IF( INDEX .NE. 14 ) GO TO 3
          FP   = (ZDEEP -  ZP) / (ZDEEP + ZLGPL)
          FP1  = (ZDEEP - VZP) / (ZDEEP + ZLGPL)
          XP   = FP*XP
          YP   = FP*YP
          VXP  = FP1*VXP
          VYP  = FP1*VYP
          GO TO 3
C
C                            ENDCAP PHOTONS  ( JPART NE 0 )
C
   2    PHI = ATAN2(ADATA(IPO+10),ADATA(IPO+9))
        IF(PHI.LT.0.) PHI = PHI + TWOPI
        THE = ARCOS(ADATA(IPO+11))
C
        ZZ  = ZZPL
        IF( JPART .LT. 0 ) ZZ = ZZMI
        RR  = ZZ*TAN(THE)
        XP  = RR*COS(PHI)
        YP  = RR*SIN(PHI)
        ZZ  = ZZ - VZ
C
        ZP  = ZZPL
        IF( JPART .LT. 0 ) ZP = ZZMI
        VXP = VX
        VYP = VY
        VZP = VZ
C
C                            SKIP IF NOT CYLINDER VIEW
C
        IF( INDEX .NE. 14 ) GO TO 3
          FP  = (ZDEEP -  ZP) / (ZDEEP + ZLGPL)
          FP1 = (ZDEEP - VZP) / (ZDEEP + ZLGPL)
          XP  = FP*XP
          YP  = FP*YP
          VXP = FP1*VXP
          VYP = FP1*VYP
C
C                            ACTUAL DISPLAY PART
C
C                            FIRST THE RPHI VIEWS EXCEPT CYLINDER
C
  3     IF( INDEX .GT. 3   .AND.  INDEX .NE. 14  .AND.
     +      INDEX .NE. 17  .AND.  INDEX .NE. 20        ) GO TO 4
          XX  = XP
          YY  = YP
          XX1 = VXP
          YY1 = VYP
C
          CALL TRNUMB(IGAM,0,XX,YY,DUM1)
          XX  = - XX
          XX1 = - XX1
          GO TO 5
C
C                            NEXT THE Z VIEWS INCL CYLINDER
C
  4      XX  = ZP
         XX1 = VZP
C
C                            IF PROJECT MODE (CDTL 9 OFF) DO 1ST BLOCK
C                            IF ROTATE  MODE (CDTL 9 ON ) DO 2ND BLOCK
C
        IF( DSPDTL(9) ) GO TO 6
          YY  = XP
          YY1 = VXP
          IF( INDEX .GT. 7  .AND.  INDEX .NE. 18 ) YY = YP
          IF( INDEX .GT. 7  .AND.  INDEX .NE. 18 ) YY1 = VYP
          GO TO 7
C
  6       YY = SQRT(XP*XP+YP*YP)
          YY1 = SQRT(VXP*VXP+VYP*VYP)
          IF( YP .LT. 0.0 .AND. INDEX.GT.7.AND.INDEX.NE.18) YY = - YY
          IF( XP .LT. 0.0 .AND. (INDEX.LT.8.OR.INDEX.EQ.18)) YY = - YY
          IF(VYP.LT.0..AND.INDEX.GT.7.AND.INDEX.NE.18) YY1 = - YY1
          IF(VXP.LT.0..AND.(INDEX.LT.8.OR.INDEX.EQ.18)) YY1 = - YY1
C
  7     CALL TRNUMB(IGAM,0,-XX,YY,DUM1)
C
  5     CALL MOVEA( XX1, YY1)
        CALL DASHA( XX, YY, 14)
  1   CONTINUE
C
      LASTVW = LASTRM
C
      RETURN
      END

C   19/08/80 008211142  MEMBER NAME  STATAG                 FORTRAN
      SUBROUTINE STATAG( LENGTH, ITAG )
C-----------------------------------------------------------
C
C   VERSION OF 10/05/79      LAST MOD    21/08/80       E.ELSEN
C   STORE FWD LEAD GLASS DATA IN ARRAR ITAG.
C   LENGTH IS TOTAL I*4 LENGTH OF ARRAY.
C   EXTRA ENTRY RETURNS LENGTH ONLY.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      DIMENSION ITAG(1), HP(4), IHP(2)
      EQUIVALENCE ( HP(1), IHP(1) )
      COMMON / CGGRAW / HGG(192)
      DIMENSION HELP(2)
      EQUIVALENCE ( HELP(1), IHELP )
C
C                                           INITIALISE POINTERS
      HP(1) = 1
      HP(2) = 0
      HP(3) = 0
      HP(4) = 0
C
      NBLIM = 96
      LENGTH = 3
      INX = 1
      DO 100 J = 1, 192
      IF( HGG(J) .LE. 0 ) GO TO 100
      LENGTH = LENGTH + 1
      HELP(1) = J
      HELP(2) = HGG(J)
      ITAG(LENGTH) = IHELP
      IF( J .LT. NBLIM ) GO TO 100
      INX = INX + 1
      HP(INX) = LENGTH*2 - 7
      NBLIM = NBLIM + 96
  100 CONTINUE
      IF( LENGTH .LE. 3 ) GO TO 8000
      HP(3) = LENGTH*2 - 5
      IF( HP(2) .EQ. 0 ) HP(2) = HP(3)
C
C                                           SET DESCRIPTOR AND POINTERS
      ITAG(1) = 0
      ITAG(2) = IHP(1)
      ITAG(3) = IHP(2)
C
C                                           LENGTH OF DATA STORED
C-----------------------------------------------------------
      ENTRY LHATAG( LENGTH )
C-----------------------------------------------------------
C
      LENGTH = 3
      DO 2000 J=1,192
      IF( HGG(J) .LE. 0 ) GO TO 2000
      LENGTH = LENGTH + 1
 2000 CONTINUE
      IF( LENGTH .LE. 3 ) GO TO 8000
      RETURN
C
 8000 LENGTH = 0
      RETURN
      END

C   09/11/84            MEMBER NAME  JTRNTR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JTRNTR( PV, R, * )
C-----------------------------------------------------------------------
C
C  VERSION OF 29/11/83                          W.BARTEL
C  TRACK NEUTRONS AND K0L
C  UP TO THE LEAD GLASS SURFACES OF BARREL COUNTERS AND END CAPS
C  CHANGED 16/02/84                        K.-H. HELLENBRAND
C  TO IMPLEMENT DECAYS OF K0L
C
C      PV = USUAL PARTICLE VECTOR OF DIMENSION 10
C           FIRST FOUR ARE FOURVECTOR COMPONENTS SEE TRCDET
C      R  = THREE DIMENSIONAL RADIUS VECTOR
C      PV AND R ARE OVER WRITTEN UPON RETURN
C  RETURN 1   PARTICLE MISSES LEAD GLASS
C             OR DECAYS BEFORE LEAD GLASS
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      DIMENSION PV(10),R(3),R0(3)
      DATA PMIN / 0.005 /, DKL/ 15540.0 /
C
C
C      TEST ON SOME KINEMATIC QUANTITIES
C *** TEST PARTICLE ENERGY
      IF( PV(6) .LT. PMIN ) RETURN 1
      PVX=PV(1)/PV(6)
      PVY=PV(2)/PV(6)
      PVZ=PV(3)/PV(6)
C *** TEST ON GAMMA ANGLE
      IF(ABS(PVZ).GT.0.968) RETURN 1
      PVXY=PVX**2+PVY**2
      IF(PVXY.LT.1.E-5) RETURN 1
C
      RDL=1.E4
      R0(1)=R(1)
      R0(2)=R(2)
      R0(3)=R(3)
      IF(ABS(PV(8)-6.).LT.1.E-5) GOTO 100
C..........................DETERMINE DECAY LENGTH FOR K0L
      BETA=PV(6)/PV(4)
      GA=PV(4)/PV(5)
      EFUN=ALOG(RN(DUM))
      RDL=-DKL*BETA*GA*EFUN
C
C      FOLLOW PARTICLE FROM THE IA POINT TO THE LEAD GLASS SURFACE
C
  100 STH=SQRT(1.-PVZ**2)
      R1=R(1)**2+R(2)**2
      DR2=(RLG**2-R1)/PVXY
      IF( DR2 .LE. 0. ) RETURN 1
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
      IF(R(3).GT.ZLGPL) GO TO 1000
      IF(R(3).LT.ZLGMI) GO TO 1000
C
C............CHECK WHETHER K0L DECAYS BEFORE LEAD GLAS BARREL
      RVD=DLENG(R(1),R(2),R(3),R0(1),R0(2),R0(3))
      IF(RVD.LT.RDL) RETURN
      GOTO 4000
C
C      FOLLOW PARTICLE TO THE FACE OF THE END CAP COUNTERS
C
 1000 CONTINUE
      RABS=R(1)**2 + R(2)**2 + R(3)**2
      RABS=SQRT(RABS)
      R(1) = R(1)/RABS
      R(2) = R(2)/RABS
      R(3) = R(3)/RABS
      ZLAM=ZENDPL/R(3)
      IF( R(3) .LT. 0. ) ZLAM=ZENDMI/R(3)
C
      R(1) = ZLAM*R(1)
      R(2) = ZLAM*R(2)
      R(3) = ZLAM*R(3)
C
C.....................CHECK WHETHER K0L DECAYS BEFORE END CAP
      RVD=DLENG(R(1),R(2),R(3),R0(1),R0(2),R0(3))
      IF(RVD.LT.RDL) GOTO 3000
      GOTO 4000
C
 3000 CALL ENDCLG(R,NCL,*3500)
      RETURN
 3500 RETURN 1
C
C................CALCULATE DECAY VERTEX AND CALL DECAY ROUTINE
 4000 R(1)=R0(1)+PVX*RDL
      R(2)=R0(2)+PVY*RDL
      R(3)=R0(3)+PVZ*RDL
      CALL TRKADC(PV,R,R0,RDL,*5000)
      RETURN 1
 5000 RETURN 1
      END
CCCCCCCCCCCCCCCCCCCCCCC
      FUNCTION DLENG(R1,R2,R3,RX,RY,RZ)
      DR=(R1-RX)**2 + (R2-RY)**2 + (R3-RZ)**2
      DLENG=SQRT(DR)
      RETURN
      END

C   29/11/77 310261800  MEMBER NAME  JPRABS0  (S)           FORTRAN
      SUBROUTINE JPRABS( R, P, PENETR, PENETZ, RDOWN, RUP,
     *                   ZDOWN, ZUP, POT, ZARO, XRAD, *, *, *, * )
C  *--------------------------------------------------------
C  *
C  *  VERSION OF 02/10/78    LAST MOD 01/10/81        E.ELSEN
C  *  VERSION OF 02/10/78    LAST MOD 25/10/83        W.BARTEL
C  *      CHANGED: STRAC IS SET FOR STEPPING OUT OF THE MATERIAL
C  *  PROPAGATES PARTICLE IN ABSORBING MEDIUM
C  *  DEFINED BY RDOWN, RUP, ZDOWN, ZUP.
C  *  UPON ENTRY PENET((R) OR (Z)) IS PENETRATION LENGTH
C  *  IN THIS ELEMENT IN R OR Z DIRECTION.
C  *  THE ENTRIES JPRTOF AND JPRBPC SET CORRESPONDING COUNTER.
C  *  RETURN  : NEXT ELEMENT, INCREASING R
C  *  RETURN1 : NEXT ELEMENT, DECREASING R
C  *  RETURN2 : NEXT ELEMENT, INCREASING Z
C  *  RETURN3 : NEXT ELEMENT, DECREASING Z
C  *  RETURN4 : PARTICLE STOPPED IN SYSTEM
C  *--------------------------------------------------------
C
      DIMENSION R(5), P(7)
      COMMON / CJTRLE / TOTLEN, STPLEN, TRCOFS
      COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
      LOGICAL  ELOSS, MULSC
      LOGICAL  LBPC, LTOF
C
      DATA PMIN / .01 /
C
      LTOF = .FALSE.
      LBPC = .FALSE.
      GO TO 1000
C
C
      ENTRY JPRBPC( R, P, PENETR, PENETZ, RDOWN, RUP,
     *                   ZDOWN, ZUP, POT, ZARO, XRAD, *, *, *, * )
      LBPC = .TRUE.
      LTOF = .FALSE.
      GO TO 1000
C
C
      ENTRY JPRTOF( R, P, PENETR, PENETZ, RDOWN, RUP,
     *                   ZDOWN, ZUP, POT, ZARO, XRAD, *, *, *, * )
      LBPC = .FALSE.
      LTOF = .TRUE.
C
C
C
 1000 IF( R(4) .GT. RUP ) RETURN
      IF( R(4) .LT. RDOWN ) RETURN1
      IF( R(3) .GT. ZUP ) RETURN2
      IF( R(3) .LT. ZDOWN ) RETURN3
C
C
C SET COUNTERS
            IF( LBPC ) CALL SETBPC( R )
            IF( LTOF ) CALL SETTOF( R )
            IF( LTOF ) CALL ACTOF(P,R,TOTLEN+TRCOFS)
C
C
      ADZDS = ABS( P(3))/ P(6)
      ADRDS = ABS( P(1)*R(1) + P(2)*R(2) ) / ( R(4)*P(6) )
      STRAC = 0.
      IF( PENETR .GT. 0. ) STRAC = PENETR / ADRDS
      IF( PENETZ .GT. 0. ) STRAC = PENETZ / ADZDS
      IF( MULSC ) CALL JMULSC( P, STRAC / XRAD )
      IF( ELOSS ) CALL JELOSS( P, STRAC, POT, ZARO, XRAD, R, 1., 0. )
C
      IF( P(6) .LT. PMIN ) RETURN 4
C
      PENETZ = 0.
      PENETR = 0.
C
      DO 100 ITERAT = 1,300
C
      R4OLD = R(4)
      R3OLD =  R(3)
C
      CALL JSTEP( R, P, DRTOT )
C
        R(4) = SQRT( R(1)*R(1) + R(2)* R(2) )
C        TOTAL TRACK LENGTH BIGGER THAN MAXIMUM VALUE?
            TOTLEN = TOTLEN  + DRTOT
            IF( TOTLEN .GT. STPLEN ) RETURN4
C
      IF( R(4) .LE. RUP  ) GO TO 20
      PENETR = R(4) - RUP
C  CHANGED:  STRAC MUST BE SET!
      STRAC = ABS( (RUP - R4OLD) / (P(1)*R(1)+P(2)*R(2)) * R(4)*P(6) )
C
      IF( MULSC ) CALL JMULSC( P, STRAC / XRAD )
      IF( ELOSS ) CALL JELOSS( P, STRAC, POT, ZARO, XRAD, R, 1., 0. )
      IF( P(6) .LT. PMIN ) RETURN4
      RETURN
C
   20 IF( R(4) .GE. RDOWN ) GO TO 30
      PENETR = RDOWN - R(4)
      STRAC = ABS( (R4OLD-RDOWN) / (P(1)*R(1)+P(2)*R(2)) * R(4)*P(6) )
      IF( MULSC ) CALL JMULSC( P, STRAC / XRAD )
      IF( ELOSS ) CALL JELOSS( P, STRAC, POT, ZARO, XRAD, R, 1., 0. )
      IF( P(6) .LT. PMIN ) RETURN4
      RETURN1
C
   30 IF( R(3) .LE. ZUP  ) GO TO 40
      PENETZ = R(3) - ZUP
      STRAC = ABS( ( ZUP - R3OLD ) / P(3) * P(6) )
      IF( MULSC ) CALL JMULSC( P, STRAC / XRAD )
      IF( ELOSS ) CALL JELOSS( P, STRAC, POT, ZARO, XRAD, R, 1., 0. )
      IF( P(6) .LT. PMIN ) RETURN4
      RETURN2
C
   40 IF( R(3) .GE. ZDOWN ) GO TO 50
      PENETZ = ZDOWN - R(3)
      STRAC = ABS( ( R3OLD - ZDOWN ) / P(3) * P(6) )
      IF( MULSC ) CALL JMULSC( P, STRAC / XRAD )
      IF( ELOSS ) CALL JELOSS( P, STRAC, POT, ZARO, XRAD, R, 1., 0. )
      IF( P(6) .LT. PMIN ) RETURN4
      RETURN3
C
   50 CONTINUE
      IF( MULSC ) CALL JMULSC( P, DRTOT / XRAD )
      IF( ELOSS ) CALL JELOSS( P, DRTOT, POT, ZARO, XRAD, R, 1., 0. )
      IF( P(6) .LT. PMIN ) RETURN4
  100 CONTINUE
C
      RETURN4
      END

C   07/06/96 606071922  MEMBER NAME  BANDPR   (S4)          FORTG1
      SUBROUTINE BANDPR(A,N,M)
      REAL A(M,N)
      WRITE(6,101)
      DO 10 I=1,N
      WRITE(6,101) (A(J,I),J=1,M)
   10 CONTINUE
      WRITE(6,101)
  100 RETURN
  101 FORMAT(1X,10G13.5)
      END

C   17/01/79 003201013  MEMBER NAME  TFSTOR   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TFSTOR(NTK,IFL,NCNT,TOF,PL,BETA,DBETA,EMAS2,DMAS,
     -                   PRO,PKA,PPI,PEL,DEDX)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
       DIMENSION RE(14,50)
       EQUIVALENCE (IR(1,1),RE(1,1))
            IR( 1,NTK)= NTK
            IR( 2,NTK)= IFL
            IR( 3,NTK)= NCNT
            RE( 4,NTK)= TOF
            RE( 5,NTK)= PL
            RE( 6,NTK)= BETA
            RE( 7,NTK)= DBETA
            EM= ABS(EMAS2)
            EM= SQRT(EM)
            IFG= 0
C PMF 06/11/98
C            IF(EM.LT.1.E-50) IFG= 1
            IF(EM.LT.1.E-33) IFG= 1
            IF(EMAS2.LT.0.) EM= -EM
            IF(IFG.EQ.0) GO TO 100
            RE( 8,NTK)= EM
            GO TO 200
100         RE( 8,NTK)= EM
C PMF 06/11/98
C 200         IF(DMAS.GT.1.E-50) GO TO 300
200         IF(DMAS.GT.1.E-33) GO TO 300
            RE( 9,NTK)= DMAS
            GO TO 400
300         RE( 9,NTK)= DMAS
400         RE(10,NTK)= PRO
            RE(11,NTK)= PKA
            RE(12,NTK)= PPI
            RE(13,NTK)= PEL
            RE(14,NTK)= DEDX
            RETURN
            END

C   25/06/78            MEMBER NAME  M0LLER   (LGSOURCE)    FORTRAN
      SUBROUTINE M0LLER(ENE,EPSI)
      COMMON/M0PAR/CUTM
      COMMON/SFCPA/SFP,SFE
      EKIN=ENE-1.
      BETA2=1.-1./ENE**2
      EP0=CUTM/EKIN
      XR=RN(DAM)
      CC2=1.-2.*EP0
      EPSI=EP0/(1.-CC2*XR)
      XR=RN(DAM)
      CON=EPSI/(1.-EPSI)
      G=(CC2/3.)*(1.+CON**2+(EPSI*EKIN/ENE)**2
     @                       -CON*(EKIN+ENE)/ENE)
      G=G/BETA2
      IF(XR*SFE-G)30,30,31
 30    RETURN
 31    EPSI=0.
      RETURN
      END

C   09/01/89 901091422  MEMBER NAME  CMPDCT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  CMPDCT( STRING, LENGTH, ICODE, IERROR )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery       21/12/87:  Get ICODE for input STRING
C
C
C
C     Routine to match input string against dictionary held in COMMON
C     and to return corresponding ICODE.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     STRING    In   CHAR*(*)     String of characters with no blanks
C     LENGTH    In       I*4      Length of STRING
C     ICODE     Out      I*4      Number code as in dictionary
C     IERROR    Out      I*4      Error code
C                                  0 : no error and match found
C                                  1 : no match found
C                                  2 : illegal input; no match possible
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER*(*)  STRING

      INTEGER  ICODE,  LENGTH,  IERROR

C                            The dictionary words for a given length

      INTEGER  SHORT, LONG

      PARAMETER ( SHORT = 8, LONG = 20 )

      CHARACTER  CDICTS*(SHORT),  CDICTL*(LONG)

      COMMON / CSDICT / CDICTS(1)
      COMMON / CLDICT / CDICTL(1)

C                            The associated code numbers plus
C                            the numbers of words of each length

      COMMON / CNSDCT / NS, ICODES(1)
      COMMON / CNLDCT / NL, ICODEL(1)

C------------------  C O D E  ------------------------------------------

      IF( LENGTH .LT. 1  .OR.  LENGTH .GT. LONG ) THEN
        IERROR = 2
        ICODE  = 0
      ELSE

C                            Examine dictionary entries according to
C                            the length of the input STRING
C                            If 8 or less, use short words dictionary
C                            and try long words only if no match found

        IERROR = 0

        IF( LENGTH .LE. SHORT ) THEN

          DO  10  I = 1,NS
            IF( STRING .EQ. CDICTS(I) ) THEN
              ICODE = ICODES(I)
              RETURN
            ENDIF
  10      CONTINUE

        ENDIF

C                            Try the long words dictionary (even if
C                            this is a short word - just in case)

        DO  20  I = 1,NL
          IF( STRING .EQ. CDICTL(I) ) THEN
            ICODE = ICODEL(I)
            RETURN
          ENDIF
  20    CONTINUE

C                            No match found

        IERROR = 1
        ICODE  = 0

      ENDIF

      RETURN
      END

C   18/07/79 308301506  MEMBER NAME  TRKROL   (JADEGS)      FORTRAN
      SUBROUTINE TRKROL
C---
C---   DISPLAY IN THE ROLLED OUT VIEW IMPACT POINTS OF CHARGED TRACKS
C---       J.OLSSON  18.07.79    LAST CHANGE 30.08.83
C---
      IMPLICIT INTEGER*2 (H)
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
     $,DUMMM(16),NTRRES,IW61
      COMMON /CJTRIG/ PI,TWOPI
#include "cgeo1.for"
#include "cgraph.for"
#include "cdata.for"
      DIMENSION AXD(2)
C
      IF(IPO.EQ.0) RETURN
      ADDEND = 84.*BLFI
      ADDRAD = ADDEND/TWOPI
      AXD(1) = .13*ADDEND
      AXD(2) = .87*ADDEND
      ICNT = 0
200   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 21
      IPO = IPO + LTR
      IF(ICNT.NE.NTRRES.AND.DSPDTL(14).AND.NTRRES.NE.0) GO TO 200
      ITR = IDATA(IPO + 1)
C** DISPLAY TRACKS
      IFLGX = IDATA(IPO+29)
      CALL RUTRCK(25,IDATA(IPO+18),ADATA(IPO+19),ADATA(IPO+20),
     $ ADATA(IPO+21),ADATA(IPO+22),ADATA(IPO+5),ADATA(IPO+6),
     $ ADATA(IPO+12),ADATA(IPO+13),ADATA(IPO+31),ADATA(IPO+30),
     $ XP,YP,ZP,XP2,YP2,ZP2,IFLGX)
      IF(IFLGX.NE.2) GO TO 198
      FIP = ATAN2(YP,XP)
      IF(FIP.LT.0.) FIP = FIP + TWOPI
      X1 = 0.
      X2 = X1 + FIP*ADDRAD
      Y1 = 2800.
      Y2 = Y1 + 16.*BLZ + ZP
201   CALL PLYGON(9,.7*BLZ,X2,Y2,0)
      SIZE = 60.
      CALL NUMBWR(30,ITR,X2+.8*BLZ,Y2,SIZE)
C     CALL TRNUMB(ITR,2,X2+.8*BLZ,Y2,DUM)
      CALL MOVEA(X2,Y2)
      IF(IFLGX.NE.2) GO TO 310
      FIP = ATAN2(YP2,XP2)
      IF(FIP.LT.0.) FIP = FIP + TWOPI
      X1 = 0.
      X2 = X1 + FIP*ADDRAD
      Y1 = 2800.
      Y2 = Y1 + 16.*BLZ + ZP2
      CALL DRAWA(X2,Y2)
      GO TO 200
198   IF(IFLGX.EQ.0) GO TO 200
      X1 = AXD(1)
      IF(ZP.GT.0.) X1 = AXD(2)
      Y1 = 900.
      X2 = X1 - XP
      Y2 = Y1 + YP
      GO TO 201
310   X2 = X1 - XP2
      Y2 = Y1 + YP2
      CALL DRAWA(X2,Y2)
      GO TO 200
21    CONTINUE
      RETURN
      END

C   21/11/77 007252320  MEMBER NAME  JEGAIN   (JADEGS)      FORTRAN
      SUBROUTINE JEGAIN( P, STRAC, POT, ZARO, * )
C  *---------------------------------------------------------
C  *
C  *  VERSION OF 21/11/77
C  *  FINDS ENERGY LOSS IN ABSORBER WITH POT AND ZARO
C  *  AND INCREASES ENERGY.
C  *  P IS CHANGED .
C  *---------------------------------------------------------
C
      DIMENSION P(6)
C
      DATA D / .1535E-4 /
C
C  FIND REDUCED VARIABLES
      A = 2. * D * ZARO * STRAC / P(5)
      B = 1.022E6 / POT
      XLOW = P(4) / P(5)
      IF( XLOW * XLOW .GT. 16.9205 ) GO TO 400
C
C  INITIALIZE GAUSS METHOD
      ITER = 0
      INCREM = 0
      DXOLD = 1.E13
      X = XLOW
C
  100 ITER = ITER + 1
      IF( ITER .GT. 15 ) RETURN1
      X2 = X * X
      X21 = X2 -1.
      FACLOG = ALOG( B * X21 )
      DX = ( XLOW - X + A * ( X2 / X21 * FACLOG - 1. ) ) /
     *     ( 1. + 2.*A/(X21*X21) * ( FACLOG - X2 ) )
      ADX = ABS( DX )
      INCREM = INCREM + 1
      IF( ADX .LE. DXOLD ) INCREM = 0
      IF( INCREM .GE. 9 ) RETURN1
      DXOLD = ADX
      X = X + DX
      IF( ADX .GT. 0.001 * ABS(X) ) GO TO 100
C
  200 P(4) = X * P(5)
      PTOT = SQRT( P(4)*P(4) - P(5)*P(5) )
      FACT = PTOT / P(6)
      P(6) = PTOT
      DO 300 I = 1,3
  300 P(I) = P(I) * FACT
      RETURN
C
  400 XLOW2 = XLOW * XLOW
      X = XLOW + A*(XLOW2/(XLOW2-1.)*ALOG(B*(XLOW2-1.)) - 1. )
      GO TO 200
C
      END
      BLOCK DATA
      COMMON / CJJONI / POTBEA, ZAROBE
     *                 ,POTTRI, ZAROTR
     *                 ,POTIVE, ZAROIV
     *                 ,POTRH0, ZAROR0
C    *                  POTJET, ZAROJE,
C    *                  POTRH1, ZAROR1,
C    *                  POTRH2, ZAROR2,
C    *                  POTRH3, ZAROR3,
C    *                  POTOVE, ZAROOV,
C    *                  POTTOF, ZAROTO,
C    *                  POTVES, ZARVES,
C    *                  POTZJL, ZAROJL,
C    *                  POTZJR, ZAROJR
C       GIVES AVERAGE IONISATION POTENTIAL AND VALUE FOR Z*RHO/A FOR
C       BETHE BLOCH FORMULA FOR : BEAMPIPE, BEAM PIPE COUNTER, INNER
C       VESSEL WALL, 4 DIFFERENT ROHACELL LAYERS, DRIFTGAS , OUTER
C       VESSEL WALL, TOF COUNTER, VESSEL WALL IN Z, LEFT AND RIGHT
C       ALU SUPPORTS FOR WIRES AND ROHACELL
      DATA POTBEA,ZAROBE        / 213.,1.3      /
      DATA POTTRI,ZAROTR        / 36.1,.59      /
      DATA POTIVE,ZAROIV        / 213.,1.3      /
      DATA POTRH0, ZAROR0       / 102., 0.11 /
C     DATA POTJET,ZAROJE        / 284.4,.00295   /
C     DATA POTRH1,ZAROR1        / 102.,.07     /
C     DATA POTRH2,ZAROR2        / 102.,.07     /
C     DATA POTRH3, ZAROR3       / 102. , .09  /
C     DATA POTOVE,ZAROOV        / 213.,1.3     /
C     DATA POTTOF,ZAROTO        / 36.1,.59      /
C     DATA POTVES,ZARVES        / 213.,1.3     /
C     DATA POTZJL, ZAROJL       / 213., 1.3       /
C     DATA POTZJR, ZAROJR       / 213., 1.3       /
      END

      FUNCTION DISTXY(X,Y,DX,DY,R,X0,Y0,XP,YP,PHIP)
      DATA PIVALU/3.141593/
      ALEN=SQRT(DX**2+DY**2)
      SINOM=DY/ALEN
      COSOM=DX/ALEN
      G=(X0-X)**2+(Y0-Y)**2+2.*R*((Y0-Y)*COSOM-(X0-X)*SINOM)
      DISTXY=SQTVAL(ABS(R),G,1.,1.E-4)
      IF(
     - R.GT.0.
     -)THEN
         SGNR=1.
      ELSE
         SGNR=-1.
      ENDIF
      A1=DISTXY/ABS(R)
      A2=1./(1.+A1)
      XP=A2*(X0+X*A1+SINOM*SGNR*DISTXY)
      YP=A2*(Y0+Y*A1-COSOM*SGNR*DISTXY)
      SINOMP=A2*((X-X0)/R+SINOM)
      COSOMP=A2*((Y0-Y)/R+COSOM)
      IF(COSOMP.GT.1.) COSOMP=1.
      IF(COSOMP.LT.-1.) COSOMP=-1.
      PHIP=ACOS(COSOMP)
      IF(SINOMP.LT.0.) PHIP=2.*PIVALU-PHIP
      RETURN
      END

C   09/10/79 910180047  MEMBER NAME  ANOM62   (S)           FORTRAN
      SUBROUTINE ANOM62(IRUN)
C---  ANOMALIES OF RUNS 1561 - 1576
C---  15.26 GEV      SEPTEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     18.10.79     00:35
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1561,1562,13,1564,1565,1566,1567,13,1569,1570,1571,13,
     &      1573,13,1575,1576),IRUN
   13 RETURN
C
 1561 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 120
      KCONST(101) = -1
      LIMIT(101) = 75
      KCONST(150) = -1
      LIMIT(150) = 45
      KCONST(155) = -1
      LIMIT(155) = 60
      KCONST(171) = -1
      LIMIT(171) = 75
C
      RETURN
C
 1562 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(148) = -1
      LIMIT(148) = 45
C
      RETURN
C
 1564 LCHANN(79) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1565 LCHANN(79) = .TRUE.
C
      RETURN
C
 1566 LCHANN(79) = .TRUE.
C
      KCONST(154) = -1
      LIMIT(154) = 45
C
      RETURN
C
 1567 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 60
C
      RETURN
C
 1569 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(154) = -1
      LIMIT(154) = 45
C
      RETURN
C
 1570 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
 1571 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 45
C
      RETURN
C
 1573 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1575 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 60
      KCONST(154) = -1
      LIMIT(154) = 45
C
      RETURN
C
 1576 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
C
      RETURN
C
      END

C   12/03/84 503161539  MEMBER NAME  TAGFIT   (S)           FORTRAN
C
      SUBROUTINE TAGFIT(J,XFIT,YFIT,IDEBUG,*)
C
C TAGFIT PERFORMS THE FIT TO FIND THE DISTANCE OF THE CENTRE OF THE
C SHOWER FROM A BOUNDARY BETWEEN TWO BLOCKS BY COMPARING THE RATIO
C OF THE ENERGY IN EACH
C
C INPUT  : J       -  POINTER TO WHICH BLOCK IS TO BE COMPARED
C                     TO LARGEST BLOCK IN CLUSTER - CLUS(1)
C          IDEBUG  -  = 1  FOR DEBUG PRINT-OUT
C
C OUTPUT : XFIT    -  RESULT OF FIT IN  X - DIRECTION
C          YFIT    -  RESULT OF FIT IN  Y - DIRECTION
C
C RETURN 1 ERROR CONDITION DETECTED
C
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C
C---------------  C O D E  ---------------------------------------------
C
C
      XFIT = 0.0
      YFIT = 0.0
      SIGMA = 10.0
C
      E1 = CLUS(1,2)
      ADDRES = CLUS(1,1)
      X1 = XMAP(ADDRES)
      Y1 = YMAP(ADDRES)
      E2 = CLUS(J,2)
      IF ( (E2 + E1) .NE. 0 ) GOTO 10
C
      WRITE(6,60)
 60   FORMAT('  ERROR DETECTED IN TAGFIT E2 + E1 IS ZERO ')
      RETURN  1
C
 10   ADDRES = CLUS(J,1)
      X2 = XMAP(ADDRES)
      Y2 = YMAP(ADDRES)
      RATIO = E2/(E2 + E1)
C
C THIS IS THE CRITICAL FORMULA
C
      A = RATIO/0.5
      R = LOG(A ) /( - 0.079)
C
C WORK OUT THE X AND Y CORRECTIONS REQUIRED
C
      YDIFF = Y2 - Y1
      XDIFF = X2 - X1
CCC   YSIGN = MSIGN(YDIFF)
CCC   XSIGN = MSIGN(XDIFF)
      YSIGN =  SIGN(1.0,YDIFF)
      XSIGN =  SIGN(1.0,XDIFF)
      THETA = 1.5708 * YSIGN
      IF ( X2 .NE. X1 ) THETA = ATAN((Y2 - Y1 ) /(X2 - X1) )
      XDIFF = X2 - X1
      YDIFF = Y2 - Y1
      ARG = YDIFF ** 2 + XDIFF ** 2
      AL = (SQRT(ARG) ) /2
      XFIT = ((AL - R) * COS(THETA) )
      YFIT = ((AL - R) * SIN(THETA) )
      XFIT = XSIGN * ABS(XFIT)
      YFIT = YSIGN * ABS(YFIT)
C
C-------------------------------------------- R E T U R N --------------
C
      IF ( IDEBUG .NE. 1 ) RETURN
C
C
C
C-------------------------------------------- D E B U G ----------------
C
      WRITE(6,601) E1,E2
      WRITE(6,603) XFIT,YFIT,XDIFF,YDIFF,THETA
      WRITE(6,604) AL,R,RATIO,E1,E2
  601  FORMAT('  E1 E2 ',2X,F10.2,2X,F10.2)
  603  FORMAT(' XFIT,YFIT,YDIF,XDIF,THET,AL,R,RAT,E1,E2',5(2X,F12.2))
  604  FORMAT('  ',5(2X,F12.2) )
      RETURN
CCC   END
CCC   FUNCTION MSIGN(X)
CCC   MSIGN = - 1
CCC   IF ( X .GE. 0 ) MSIGN = 1
CCC   RETURN
      END

C   08/06/86 606080751  MEMBER NAME  RALLOC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RALLOC( OK )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   8/06/86 :  ALLOCATE INPUT DATASET
C
C
C     ALLOCATES A DDNAME TO THE INPUT DSNAME WHICH IS GIVEN BY THE
C     USER. OK = .TRUE. IF THE ALLOCATION WAS SUCCESSFUL.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  OK
C
#include "cgraph.for"
C
      COMMON / CSVCW1 / NDDSVE,NRWR
C
C------------------  C O D E  -----------------------------------------
C
C                            ALLOCATE FORTRAN LUN TO INPUT DATA SET.
C
      NDDINN = 0
      CALL GETDS(NDDINN,'Please enter FULL NAME of the Dataset with the
     +Events  (without apostrophes)^',IDATSV,HERR)
C
      IF( HERR .EQ. 0 ) GO TO 85
C
C                            ERROR HAS OCCURRED ON ALLOCATION.
C
      WRITE(6,80)
  80  FORMAT(' Premature End of Graphics Program')
      OK = .FALSE.
      RETURN
C
C                            SUCCESSFULLY ALLOCATED DATA SET.
C
  85  MAXREC = 0
C
C                            NDDOUT SET TO ZERO HERE. IS SET TO O/P
C                            LUN AFTER FIRST CALL TO S/R WRIT.
C
      NDDOUT = 0
      NDDSVE = 0
      NRWR   = 0
C
      OK     = .TRUE.
C
      RETURN
      END

C   10/09/79 008242137  MEMBER NAME  CORCST                 FORTRAN
      SUBROUTINE CORCST(NRUN)
       REAL *8 DYC1,DYC2
       COMMON/TFPRM/ NRNC1,NRNC2,DYC1,DYC2,IFLC(42),CMC(42),CPC(42),
     -DTC(42),WMC(42),WPC(42),VELC(42),DMC(42),DPC(42),PDMC(42),PDPC(42)
C
      COMMON/CALIBR/JPOINT(8)
      DIMENSION ACALIB(8)
      EQUIVALENCE (ACALIB(1),JPOINT(1))
C
      DATA IENTRY/0/,IPRNT1/0/,IPRNT2/0/ ,IENMC/0/
C
      IENTRY = IENTRY + 1
      IF(NRUN.EQ.0)  GOTO  10
      IND = JPOINT(6)
      DO   1   N=1,378
      IDUM = 0
      IF(N.GT.84) IDUM = 42
      CMC(N+IDUM) = ACALIB(IND+N)
    1 CONTINUE
C     IF(IENTRY.EQ.1)PRINT 100,CMC,CPC,WMC,WPC,VELC,DMC,DPC,PDMC,PDPC
C 100 FORMAT(/4(1X,10F12.3/),1X,2F12.3)
      RETURN
C
C  CONSTANTS FOR MONTE CARLO
C
   10 CONTINUE
      IENMC = IENMC + 1
      DO   5   I=1,42
      CMC(I) = 40.+1500./162.
      CPC(I) = 40.+1500./162.
      DMC(I) = .05
      DPC(I) = .05
      WMC(I) = -50.
      WPC(I) = -51.
      VELC (I) = 162.
    5 CONTINUE
C     IF(IENMC.EQ.1)PRINT 100,CMC,CPC,WMC,WPC,VELC,DMC,DPC,PDMC,PDPC
      RETURN
      END

C   07/06/96 606071805  MEMBER NAME  BDLMX    (S4)          FORTG1
      SUBROUTINE BDLM
C     BOS SUBPROGRAM =0.6=
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL FF/Z000000FF/
      EQUIVALENCE (INAME,XNAME)
      INTEGER ISTAR/Z0000005C/
      REAL AND
      EXTERNAL AND
C
C     DELETE ALL BANKS WITH NAMES OF THE CURRENT LIST
      IF(IN.LE.0) GOTO 100
      ILS=0
      JLOW=NLST
      NDEL=0
      DO 20 J=1,IN
      K=IW(NLST+J)
      I=IW(K)
      IF(I.EQ.0) GOTO 20
      IW(K)=0
      NAMDEL=NDEL
      IF(ILS.EQ.0) ILS=I
      GOTO 15
   10 I=IW(I-1)
   15 IF(I.EQ.0) GOTO 18
      NN=4+IW(I)
      JLOW=MIN0(I,JLOW)
      NDEL=NDEL+NN
      IW(I)=-NN
      IF(ILS-IW(ILS).EQ.I) GOTO 16
      ILS=I
      GOTO 10
   16 IW(ILS)=IW(ILS)-NN
      GOTO 10
   18 INAME=IW(INAMV+K)
      XNAME=AND(XNAME,FF)
      IF(INAME.EQ.ISTAR) NCPL=NCPL-NDEL+NAMDEL
   20 CONTINUE
      IF(JLOW+NDEL-3.NE.NEXT) GOTO 22
C     LAST BANKS
      NK=1+((10*(NEXT-2))/NLAST)
      NHISTH(NK)=NHISTH(NK)+1
      NK=1+((10*NCPL)/NLAST)
      NK=MIN0(10,NK)
      NHISTL(NK)=NHISTL(NK)+1
      NCOL=NCOL+1
      NEXT=NEXT-NDEL
      GOTO 100
C     NOT LAST BANKS
   22 NFRE=NFRE+NDEL
      ILOW=MIN0(ILOW,JLOW)
C
  100 RETURN
      END

C   29/09/86 807212230  MEMBER NAME  TPSTAR   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPSTAR
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       3/10/86:  Initialise the TP program
C
C          mod: C. Bowdery       4/02/88:  Add CALL TPVOPT here
C     Last mod: C. Bowdery      21/07/88:  TPRDBR --> TPBANR
C
C     Routine to initialise the TP program before events are read.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      INTEGER  JU

      LOGICAL  ERR, ERR2

C------------------  C O D E  ------------------------------------------

C                            Prevent timer overflow by call to JUHR

      JU = JUHR( 2 )

C                            Get the required TP options.

      CALL TPGOPT( ERR )

C                            Print banner twice including COMMENTs

      CALL TPBANR
      CALL TPBANR

C                            Print message about options selected

      CALL TPPOPT

C                            Verify the options in the table

      CALL TPVOPT( ERR2 )

      IF( ERR  .OR.  ERR2 ) THEN

        WRITE(6,1)
  1     FORMAT(/////' P R E M A T U R E    E N D    O F    P R O G R A M
     +   D U E   T O   O P T I O N S    E R R O R')
        STOP  999

      ELSE
C                            Initialise BOS memory manager

        CALL TPBOSI

C                            Initialise the various packages to be used

        CALL TPPINT

      ENDIF

      RETURN
      END

C--------START OF MACRO CMUANP------------------------------------------
C
C MU ANALYSIS PARAMETERS. FOR DESCRIPTION SEE BLOCK DATA IN MUINI.
C
      COMMON/CMUANP/IMUANP(30)
      EQUIVALENCE (CUTP,IMUANP(1))
      EQUIVALENCE (WRES,IMUANP(2))
      EQUIVALENCE (CUTT,IMUANP(3))
      EQUIVALENCE (CUTL,IMUANP(4))
      EQUIVALENCE (FT,IMUANP(5))
      EQUIVALENCE (FL,IMUANP(6))
      EQUIVALENCE (DRES,IMUANP(7))
      EQUIVALENCE (DLRES,IMUANP(8))
      EQUIVALENCE (FS,IMUANP(9))
      EQUIVALENCE (CUTC,IMUANP(10))
      EQUIVALENCE (FR,IMUANP(11))
      EQUIVALENCE (FAT,IMUANP(12))
      EQUIVALENCE (FAL,IMUANP(13))
      EQUIVALENCE (CUTDT,IMUANP(14))
      EQUIVALENCE (CUTDL,IMUANP(15))
C
C-----END OF MACRO CMUANP-----------------------------------------------

C   25/06/78 C8062601   MEMBER NAME  PARSET   (LGSOURCE)    FORTRAN
      SUBROUTINE PARSET(FRAC,N,A,Z,CUTM,CUTB2,ROH,XX0,X0,ABR1,ABR2,
     @    ALPPA1,ALPPA2,ALPM,ALPBH,ACM,BGAM,AMEAN,ZMEAN)
C
C      A.SATO
C
      DIMENSION FRAC(N),Z(N),A(N),X0(N)
C     DIMENSION ABR1(10),ABR2(10),ALPPA1(10),ALPPA2(10)
      DATA CTCON/3.1764E-09/, CONM0/0.90162/
C     DATA CUTBT2/0.001/
C
      TIV0=0.
      AMEAN=0.
      ZMEAN=0.
      ABR1=0.
      ABR2=0.
      ALPPA1=0.
      ALPPA2=0.
      ALPM=0.
      ALPBH=0.
      ACM=0.
      FRACTT=0.
      DO1010I=1,N
      FRACTT=FRACTT+FRAC(I)
1010  CONTINUE
      DO1020I=1,N
      FRAC(I)=FRAC(I)/FRACTT
1020  CONTINUE
      DO 10 I=1,N
      CALL SRLICA(Z(I),A(I),1.,X0(I),AL,XI)
      PFR=FRAC(I)*X0(I)
      TIV0=TIV0+PFR
      AMEAN=AMEAN+FRAC(I)/A(I)
      ZMEAN=ZMEAN+FRAC(I)*Z(I)/A(I)
      ALF=AL-FF(Z(I))
      CON=ALF/AL
      ABR1=ABR1+CON*(1.333333+0.1111111/ALF)*PFR
      ABR2=ABR2+CON*0.5*PFR
      ALPPA1=ALPPA1+CON*(0.66666667+1./(36.*ALF))*PFR
C     ABR1(I)=CON*(1.33333+0.1111111/ALF)*PFR
C     ABR2(I)=CON*0.5*PFR
C     ALPPA1(I)=CON*(0.6666667+1./(36.*ALF))*PFR
 10   CONTINUE
      CUTB2=CTCON*ROH*ZMEAN
      BGAM=0.5*ALOG((1.+CUTB2)/CUTB2)
      XX0=1./TIV0
C     BGAM=0.5*ALOG((1.+CUTB2)/(CUTBT2+CUTB2))
C     DO 2010I=1,N
      ABR1=XX0*ABR1
      ABR2=XX0*ABR2
      ALPPA1=XX0*ALPPA1
      ALPPA2=ABR1/12.
      ABR1=ABR1*BGAM
 2010  CONTINUE
      ALPM=XX0*CONM0*ZMEAN/CUTM
      ALPBH=ALPM
      ACM=ALPM*CUTM/3.
      AMEAN=1./AMEAN
      ZMEAN=ZMEAN*AMEAN
      DO20I=1,N
20    X0(I)=1./X0(I)
      RETURN
      END

C   22/10/83 805261726  MEMBER NAME  MUFFLT   (JADEMUS)     FORTRAN
C
C LAST CHANGE  9.40 14/04/88 J. HAGEMANN - CORRECT CALC. OF EXTR. ERRORS
C      CHANGE 22.00 22/10/83 HUGH MCCANN - PARALLEL MUFFLY CHANGES.
C      CHANGE 03.10 14/07/83 HUGH MCCANN - VARIOUS CHANGES.
C      CHANGE 18.27 16/03/82 CHRIS BOWDERY- FOR THE 'LET-OFF' TEST
C      CHANGE 14.50 08/02/82 HUGH MCCANN  - KDEPTH LIMIT INCREASED TO 4.
C      CHANGE 17.20 23/09/81 CHRIS BOWDERY- REMOVE RESL & REST FROM
C                                           'LET OFF' TEST. KILLS BUG.
C      CHANGE 15.07 04/08/81 CHRIS BOWDERY- INCLUDE Z EDGE TEST AGAIN
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLT
C-----------------------------------------------------------------------
C
C MUFFLT TAKES THE REFITTED TRACK AND TRACKS IT THROUGH THE FILTER AGAIN
C LOOKING FOR INEFFICIENCIES. REGIONS WILL BE 'LET OFF' IF THE TRACK DID
C NOT PASS THROUGH THE ACTIVE PART OF THE REGION , IF THE TRACK COULD
C HAVE SCATTERED INTO A DEAD CHAMBER OR SCATTERED OUT OF THE ACTIVE AREA
C
C-----------------------------------------------------------------------
C
C NCEPTS  IS THE NUMBER OF INTERCEPTS FOUND BY MUREGY.
C INEFF   IS NO. OF TIMES A HIT WAS NOT FOUND AND THERE WAS NO
C           DEAD CHAMBER TO EXPLAIN ITS ABSENCE.
C NHLAYR  IS RELATED TO THE NO. OF LAYERS WITH HITS WHICH ARE
C           ASSOCIATED WITH THIS TRACK.
C NGLAYR  IS AS NHLAYR - BUT APPLIES TO ALL INTERCEPTED LAYERS WHETHER
C           THEY HAD A HIT OR NOT.
C INFLAG  IS SET = 1 IF AN INEFFICIENCY IS FOUND, AND SET = 0 IF A HIT
C           IS FOUND WITHIN CUTS.  SO IF IT IS STILL 1 WHEN THIS ROUTINE
C           HAS FINISHED IT MEANS THERE WAS AN INEFFICIENCY IN THE LAST
C           LAYER INTERCEPTED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LETDCE,LCOVAR
C
C             COMMONS AND ARRAY DECLARATIONS
C
#include "cmuffl.for"
#include "cmufwork.for"
#include "cmureg.for"
#include "cmucalib.for"
      COMMON /CMUIEV/ IEV,NEV,IRD,KRUN,KREC,
     +                ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                REGZE(60),LOCHRS(60),ABLOCH(60)
      COMMON /CMUPTC/ XEXTRP,YEXTRP,ZEXTRP,VTZCV,LCOVAR
C
      DIMENSION KTYPE(4),KREGN(4)
C
C             CHAMBER RESOLUTIONS PICKED UP FROM /CMUFFL/.
C
C-----------------------------------------------------------------------
C
C             START OF EXECUTABLE STATEMENTS.
C
      IF(NCEPTS.LE.0) RETURN
C
C             SET KDEPTH, WHICH RECORDS HOW MANY REGIONS ONE IS IN
C             AT ANY ONE TIME. NORMALLY THIS IS 0 OR 1 BUT CAN BE
C             UP TO 4 BECAUSE CHAMBER REGIONS ARE ARTIFICIALLY
C             EXTENDED IN MUREG AND CAN THEREFORE OVERLAP.
C
      KDEPTH=0
C
C             CLEAR THE ARRAY STORING THE START AND STOP POSITIONS
C             OF DEAD CHAMBERS AND REGION EDGES USED IN 'LET-OFFS'
C
      CALL VZERO(REGDCE,60)
      CALL VZERO(REGZE,60)
      IDCEP = 1
      IZEP  = 1
C
C-----------------------------------------------------------------------
C START OF MAIN LOOP ---------------------------------------------------
C-----------------------------------------------------------------------
C
C                  LOOK THROUGH INTERCEPTS.
C
      DO 1000  ICEPT = 1,NCEPTS
C
C                  PROPAGATE TO INTERCEPT.
C
        JTYPE=0
        DSTEP=RDOTD(ICEPT)
        IF(ICEPT.GT.1) DSTEP = DSTEP - RDOTD(ICEPT-1)
        IF(KDEPTH.NE.0) GO TO 1010
          GMSTEP=0.
          ABSTEP=0.
          RDSTEP=0.
          DESTEP=0.
          GO TO 1011
C
C                  FIND DENSEST TYPE - JTYPE.
C
 1010   DO 1015  K=1,KDEPTH
          IF( JTYPE.LT.KTYPE(K) ) JTYPE = KTYPE(K)
          IF( JTYPE.EQ.KTYPE(K) ) IRONRG= KREGN(K)
 1015   CONTINUE
C
C           OCTOBER 1983 :  FIX-UP FOR YOKE END PLATES .
C           THEY ARE COMPLETELY DEFINED BY HRFACE/IUNIT(IREGN)=5,6/3  ,
C           SINCE THEY ARE THE ONLY PARTS OF UNIT 3 (= MAGNET & PLINTH)
C           WHICH ARE IN FACES 5 AND 6.
C           IF MOST DENSE REGION IS NOT YOKE END PLATE, CARRY ON.
          IF( JTYPE.NE.3 )  GO TO 1016
C               THE REGION NO. OF THE IRON REGION WAS NOTED ABOVE.
C               NOTE : CAN'T BE IN 2 IRON REGIONS AT SAME TIME.
              IF(HRFACE(IRONRG).NE.5.AND.HRFACE(IRONRG).NE.6)GO TO 1016
                  IF(HUNIT(IRONRG).NE.3)GO TO 1016
                      JCEPT=ICEPT
                      CALL MUENDP(JCEPT,IRONRG,FACSTP)
C
C                        N.B.  DSTEP IS NOT CHANGED.
                      GMSTEP = (FACSTP*DSTEP)*GMG(JTYPE)
                      ABSTEP = (FACSTP*DSTEP)*ABG(JTYPE)
                      RDSTEP = (FACSTP*DSTEP)*RDG(JTYPE)
                      DESTEP = (FACSTP*DSTEP)*DEG(JTYPE)
                      GO TO 1011
 1016     CONTINUE
C
C
        GMSTEP=DSTEP*GMG(JTYPE)
        ABSTEP=DSTEP*ABG(JTYPE)
        RDSTEP=DSTEP*RDG(JTYPE)
        DESTEP=DSTEP*DEG(JTYPE)
 1011   CONTINUE
C+++
C     WRITE(6,8935)JTYPE
C8935 FORMAT(' JTYPE',I5)
C+++
C
C                  CALCULATE ENERGY LOSS,MULTIPLE SCATTERING ETC.
C                  IF THE TRACK STOPS, GO DIRECT TO CALL OF MULOCH
C
        CALL MUFFLS(&99)
C
C-----------------------------------------------------------------------
C
C                  FIND OUT WHAT TYPE OF INTERCEPT.
C
        IREGN=IREG(ICEPT)
        ITYPE=HRTYPE(IREGN)
C                  IS THIS A NEW REGION BOUNDARY?
        IF(KDEPTH.EQ.0) GO TO 1012
        DO 1013 K=1,KDEPTH
          IF( IREGN.EQ.KREGN(K) ) GO TO 1014
 1013   CONTINUE
        GO TO 1012
C IT MUST BE AN EXIT POINT - DELETE REFERENCE AND DECREMENT KDEPTH.
C  (THIS MAY SEEM UNNECESSARILY COMPLICATED BUT WITH OVERLAPPING
C   REGIONS AN EXIT POINT DOES NOT NECCESARILY FOLLOW THE CORRESPONDING
C   ENTRY POINT.)
 1014   JDEPTH=0
        DO 1019 K=1,KDEPTH
          IF(IREGN.EQ.KREGN(K)) GO TO 1019
          JDEPTH=JDEPTH+1
          IF(JDEPTH.EQ.K) GO TO 1019
          KREGN(JDEPTH)=KREGN(K)
          KTYPE(JDEPTH)=KTYPE(K)
 1019   CONTINUE
        KDEPTH=JDEPTH
C+++
C       WRITE(6,1657)            KDEPTH,KREGN,KTYPE
C1657   FORMAT('            KDEPTH,KREGN,KTYPE',I15,2(I15,3I5))
C+++
        GO TO 1000
C
C                  IT IS A NEW REGION - INCREMENT KDEPTH.
C
 1012   IF(KDEPTH.LT.4) GO TO 97
          CALL MUERRY('MUFFLT',KDEPTH,'REGIONS OVERLAPPING TOO MUCH.^')
          GO TO 1000
 97     KDEPTH=KDEPTH+1
        KREGN(KDEPTH)=IREGN
        KTYPE(KDEPTH)=ITYPE
C+++
C       WRITE(6,1656)IREGN,ITYPE,KDEPTH,KREGN,KTYPE
C1656   FORMAT(' IREG,ITYPE,KDEPTH,KREGN,KTYPE',3I5,2(I15,3I5))
C+++
C
C                  GO TO NEXT INTERCEPT IF NOT A CHAMBER REGION.
C
        IF(ITYPE.NE.1) GO TO 1000
C
C-----------------------------------------------------------------------
C
C                  CHAMBER INTERCEPTED.
C
        IFIRST=HRFIRS(IREGN)
        ILAST=HRLAST(IREGN)
        IOR=HRORI(IREGN)
        IFRAME=HFR(IFIRST)
        IFRAML=HFR(ILAST)
C
C******  AS OF 16/03/83 , APPLY SOFTWARE SHIFT TO WIRE POSITION FOR ALL
C******  DATA AFTER BEGINNING OF 1980 :
C
C  FIRST FOR THE LOW EDGE OF THE REGION :
        ISHIFE=0
        IF(IYEAR.GE.1980)ISHIFE=HLSF(4,IFIRST)
        IF(IABS(ISHIFE).GT.300)ISHIFE=0
C**** DON'T APPLY SOFTWARE SHIFTS TO MONTE-CARLO DATA.
        IF(KRUN.EQ.0)ISHIFE=0
C  THEN FOR THE HIGH EDGE OF THE REGION :
        ISHIFL=0
        IF(IYEAR.GE.1980)ISHIFL=HLSF(4,ILAST)
        IF(IABS(ISHIFE).GT.300)ISHIFL=0
C**** DON'T APPLY SOFTWARE SHIFTS TO MONTE-CARLO DATA.
        IF(KRUN.EQ.0)ISHIFL=0
C
C
C  FOR CALCULATION OF ANGLE CORRECTION OF FRAME POSITION WITH "Z" :
C  LOW EDGE OF REGION :
        IANGE=HANG(IFRAME)
C  HIGH EDGE OF REGION :
        IANGL=HANG(IFRAML)
C  ASSUME THAT FRAMES IN ANY REGION HAVE SAME END POSITIONS :
        ZMID=0.5*( HCLLO(IFRAME) + HCLHI(IFRAME) )
        ZHAF=0.5*( HCLHI(IFRAME) - HCLLO(IFRAME) )
C
        IOVALL=HOVALL(HUNIT(IFRAME))
        LINC=2
        IF( HLAYER( HFR( IFIRST) ).EQ.1 ) LINC = 1
C
C                  WAS THERE A HIT IN THIS REGION?
C
        DO 1022 I=1,LAYRAB
          IF( IREGN.EQ.IEFFRG(I) ) GO TO 1023
 1022   CONTINUE
        GO TO 1024
C
C-----------------------------------------------------------------------
C
C AT LEAST ONE HIT HAS BEEN FOUND FOR THIS TRACK IN THIS REGION.
C UPDATE SPECIAL VARIABLES, BUT NOT IF THERE HAS BEEN MORE THAN 1
C   INEFFICIENCY PRIOR TO THIS.
C
 1023   IF(INEFF.LE.1) CALL UCOPY(X,X0,NSPECI)
C
C INCREMENT NHLAYR , DEPENDING ON LAYER AS FOLLOWS:
C  IF THIS IS A LAYER 1 HIT , INCREMENT =1 ; IF IT'S ANY OTHER
C  LAYER , INCREMENT = 2.  THEN , IF SUM OF NHLAYR IS ODD, THE
C  TRACK IS KNOWN TO HAVE AN INNER LAYER HIT ASSOCIATED.
C
        INFLAG=0
        NHLAYR=NHLAYR+LINC
        GO TO 4000
C
C-----------------------------------------------------------------------
C
C NO HIT IN THIS CHAMBER REGION - SEARCH FOR A REASON.
C
C***********************************************************************
C FROM HERE TO NEXT ROW OF STARS IS A TEMPORARY MEASURE. ULTIMATELY
C   THE RESULTS OF RE-FITTING THE MUON HITS (MUFFLR) WILL BE USED TO
C   ESTIMATE THE TRACK UNCERTAINTIES.
C
C ADD MULTIPLE SCATTERING AND TRACK FITTING ERRORS TO PRODUCE VARIANCES
C   ON DEVIATIONS AND COVARIANCES BETWEEN ANGLES AND DEVIATIONS
C   NORMAL TO TRACK IN THE 2 PLANES (THE A- & B-PLANES OF JADE NOTE 68.
C   NOTE THAT THE A-PLANE GETS THE LABEL 'Z' & THE B-PLANE 'XY' HERE.)
C
 1024 IF( LCOVAR ) GOTO 995
         VZP = VTZD + VTZANG*(D-DTC)**2
         VZD = VMSD + VZP
         CZ  = CMS + VTZANG*(D-DTC)
         GOTO 996
 995  CONTINUE
         R0P = SQRT(X**2 + Y**2)
         VZP = VTZD + 2.0*R0P*VTZCV + R0P**2*VTZANG
         VZD = VMSD + VZP
         CZ  = CMS + (R0P*VTZANG+VTZCV)/COSEC
C
CCC   VXYD  = VMSD + VTXYD + VTXYAN*(D-DTC)**2
 996  DFXY2 = (X-XEXTRP)**2 + (Y-YEXTRP)**2
      VXYP  = VTXYD + VTXYAN*DFXY2
      VXYD  = VMSD + VXYP
CCC   CXY   = CMS + VTXYAN*(D-DTC)*COSEC
      CXY   = CMS + VTXYAN*SQRT(DFXY2)
C+++
C     WRITE(6,7491)VMSD,CMS,VZP,VZD,CZ,VXYP,CXY
C7491 FORMAT(' MUFFLT: VMSD,CMS,VZP,VZD,CZ,VXYP,CXY',/7G15.5)
C+++
C
C NOW PREPARE COEFFICIENTS FOR PROJECTING ONTO CHAMBER PLANES.
C
        IF(IOR.EQ.3) GO TO 1003
        AA=-COSEC
        CC=0.
        IF(IOR.EQ.2) GO TO 1005
        BB=DCY*DCZ*COSEC/DCX
        DD=1./(DCX*COSEC)
        GO TO 1002
C
 1005   BB=-DCX*DCZ*COSEC/DCY
        DD=-1./(DCY*COSEC)
        GO TO 1002
C
 1003   AA=DCY*COSEC/DCZ
        BB=DCX*COSEC
        CC=DCX*COSEC/DCZ
        DD=-DCY*COSEC
 1002   CONTINUE
C+++
C       WRITE(6,2398)AA,BB,CC,DD
C2398   FORMAT(' AA,BB,CC,DD',4G15.5)
C+++
C
C WORK OUT VARIANCES IN DRIFT (TRANSVERSE) AND WIRE (LONG.) DIRECTIONS.
C
        VL1  = AA**2*VZD+BB**2*VXYD
        VT1  = CC**2*VZD+DD**2*VXYD
C       CTL1 = AA*CC*VZD+BB*DD*VXYD
C+++
C       WRITE(6,2399)VL1,VT1,CTL1
C2399   FORMAT(' VL1,VT1,CTL1',3G15.5)
C+++
C***********************************************************************
C
C PREPARE DEVIATIONS. PROJECT TO MEAN CHAMBER PLANE.
C
        D1MEAN=0.5*(HD1(IFIRST)+HD1(IFIRST+1))
        GO TO (2101,2102,2103),IOR
C
 2101   DDC=(HDIST(IFRAME)+D1MEAN+IOVALL-X)/DCX
        CT=DCY*DDC+Y
        CL=DCZ*DDC+Z
        GO TO 2200
C
 2102   DDC=(HDIST(IFRAME)+D1MEAN-Y)/DCY
        CT=DCX*DDC+X
        CL=DCZ*DDC+Z
        GO TO 2200
C
 2103   DDC=(HDIST(IFRAME)+D1MEAN-Z)/DCZ
        CT=DCX*DDC+X
        CL=DCY*DDC+Y
C
C
C-----------------------------------------------------------------------
C
C  FIRST , LOOK TO SEE IF THE EDGE OF THE SENSITIVE REGION OF THIS
C  FRAME IS WITHIN N*SIGMA(DRIFT)/3*SIGMA(LONGL) OF THE EXTRAPOLATED
C  TRACK (WHERE SIGMA=  SIGMA(TRACK)  & N IS THE FACTOR (SEE CMUFFL)).
C  IF SO,THAT EXPLAINS ABSENCE OF HIT,SO DON'T RECORD AN INEFFICIENCY.
C  ALL 'LET-OFF' CLAIMS ARE CHECKED BY SUBROUTINE MULOCH.
C
 2200   ALLOWT=FACTOR*SQRT(VT1)
        ALLOWL=FACTOR*SQRT(VL1)
        LETDCE = .FALSE.
C
C          CALCULATE ANGLE CORRECTION OF FRAME POSITION WITH TRACK "Z" :
C
        CHAMZ = CL-ZMID
        IF(ABS(CHAMZ).GT.ZHAF)CHAMZ=SIGN(ZHAF,CHAMZ)
        CANGE = CHAMZ*FLOAT(IANGE)/10000.
        CANGL = CHAMZ*FLOAT(IANGL)/10000.
C
CCC     CTLO=HCTLO(IFRAME)
        CTLO=HCTLO(IFRAME)-ISHIFE+CANGE
C THIS NEXT STATEMENT REALLY DOES SAY IFRAML - 'L' FOR 'LAST'.
CCC     CTHI=HCTHI(IFRAML)
        CTHI=HCTHI(IFRAML)-ISHIFL+CANGL
        IFACE  = HFACE(IFRAME)
        IF(IOR.EQ.1) GO TO 2300
        CTLO=CTLO+IOVALL
        CTHI=CTHI+IOVALL
 2300   CLLO=HCLLO(IFRAME)
        CLHI=HCLHI(IFRAME)
C+++
C       WRITE(6,1278)CT,ALLOWT,CTLO,CTHI
C1278   FORMAT(' CT,ALLOWT,CTLO,CTHI',4G15.5)
C       WRITE(6,1279)CL,ALLOWL,CLLO,CLHI
C1279   FORMAT(' CL,ALLOWL,CLLO,CLHI',4G15.5)
C+++
        IFAZ = 1
        IF(CL+ALLOWL.LT.CLHI ) GO TO 3008
          REGZE(IZEP)   = IREGN
          REGZE(IZEP+1) = AB
          IF(IFACE.EQ.6) IFAZ = -1
          RZE1          = IFAZ * (CLHI-CL) /SQRT(VL1)
          RZE2          = IFAZ * (CLHI+5000-CL) /SQRT(VL1)
          REGZE(IZEP+2) = AMIN1(RZE1,RZE2)
          REGZE(IZEP+3) = AMAX1(RZE1,RZE2)
          IZEP  = IZEP + 4
          LETDCE = .TRUE.
          IFAZ = 1
 3008   IF(CL-ALLOWL.GT.CLLO ) GO TO 3009
          REGZE(IZEP)   = IREGN
          REGZE(IZEP+1) = AB
          IF(IFACE.EQ.5) IFAZ = -1
          RZE1          = IFAZ * (CLLO-CL) /SQRT(VL1)
          RZE2          = IFAZ * (CLLO-5000-CL) /SQRT(VL1)
          REGZE(IZEP+2) = AMIN1(RZE1,RZE2)
          REGZE(IZEP+3) = AMAX1(RZE1,RZE2)
          IZEP  = IZEP + 4
          LETDCE = .TRUE.
C                         WHEN A TRACK CHANGES FACES THE DEVIATIONS
C                         MUST HAVE THE SAME LEFT/RIGHT SIGN CONV.
 3009   IFAS = 1
        IF(IFACE.EQ.2 .OR. IFACE.EQ.3) IFAS = -1
        IF( CT+ALLOWT.LT.CTHI ) GO TO 3003
C
C                       SAVE THE REGION NUMBER AND UPPER AND LOWER
C                       LIMITS OF THE TRUE REGION EDGE IN SIGMA UNITS
C
          REGDCE(IDCEP)   = IREGN
          REGDCE(IDCEP+1) = AB
          RDCE1           = IFAS * (CTHI-CT) /SQRT(VT1)
          RDCE2           = IFAS * (CTHI+5000-CT) /SQRT(VT1)
          REGDCE(IDCEP+2) = AMIN1(RDCE1,RDCE2)
          REGDCE(IDCEP+3) = AMAX1(RDCE1,RDCE2)
          IDCEP  = IDCEP + 4
          LETDCE = .TRUE.
 3003   IF( CT-ALLOWT.GT.CTLO ) GO TO 3007
          REGDCE(IDCEP)   = IREGN
          REGDCE(IDCEP+1) = AB
          RDCE1           = IFAS * (CTLO-CT-5000) /SQRT(VT1)
          RDCE2           = IFAS * (CTLO-CT) /SQRT(VT1)
          REGDCE(IDCEP+2) = AMIN1(RDCE1,RDCE2)
          REGDCE(IDCEP+3) = AMAX1(RDCE1,RDCE2)
          IDCEP  = IDCEP + 4
          LETDCE = .TRUE.
C***********************************************************************
C
C  LOOK FOR DEAD CHAMBER WHICH MIGHT EXPLAIN ABSENCE OF HIT.
C  AT SAME TIME,LOOK FOR NEAREST GOOD CHAMBER SO ITS INEFFICIENCY
C    CAN BE RECORDED (IF THERE WAS NO DEAD CHAMBER NEARBY).
C
 3007   ADTMIN=1.E6
        DO 2500 ICHAM=IFIRST,ILAST
C
C  GET WIRE CTW,FRAME NO. FOR THIS CHAM,ORIENTATION,X OVAL DISP.
C
C
C******  AS OF 16/03/83 , APPLY SOFTWARE SHIFT TO WIRE POSITION FOR ALL
C******  DATA AFTER BEGINNING OF 1980 :
C
          ISHIFT=0
          IF(IYEAR.GE.1980)ISHIFT=HLSF(4,ICHAM)
          IF(IABS(ISHIFT).GT.300)ISHIFT=0
C             **** DON'T APPLY SOFTWARE SHIFTS TO MONTE-CARLO DATA.
          IF(KRUN.EQ.0)ISHIFT=0
CCC       ICWIRE=HCTW(ICHAM)
          ICWIRE=HCTW(ICHAM)-ISHIFT
C
C          CALCULATE ANGLE CORRECTION TO CHAMBER POSITION WITH "Z" :
C
          IFRAME=HFR(ICHAM)
          IANG=HANG(IFRAME)
          ZMID=0.5*( HCLLO(IFRAME) + HCLHI(IFRAME) )
          ZHAF=0.5*( HCLHI(IFRAME) - HCLLO(IFRAME) )
          CHAMZ=CL-ZMID
          IF(ABS(CHAMZ).GT.ZHAF)CHAMZ=SIGN(ZHAF,CHAMZ)
          CANG =CHAMZ*FLOAT(IANG)/10000.
          ICWIRE=ICWIRE+CANG
C
          IF(IOR.GT.1)ICWIRE=ICWIRE+IOVALL
          DT = ICWIRE - CT
          ADT=ABS(DT)
C
C FIND SMALLEST DT AND RECORD CHAMBER NUMBER.
C
          IF(ADT.GE.ADTMIN) GO TO 2461
          ADTMIN=ADT
          JCHAM=ICHAM
C
C CHECK FOR DEAD CHAMBER WITHIN ALLOWT+15CMS OF TRACK. IF FOUND, KEEP
C                                                                GOING.
 2461     IF(HMCSTA(ICHAM).EQ.0) GO TO 2500
C+++
C         WRITE(6,8723)ADT,ALLOWT
C8723     FORMAT(' ADT,ALLOWT',2G15.5)
C+++
          IF(ADT.GT.ALLOWT+150.) GO TO 2500
C
C                       SAVE THE REGION NUMBER,ABSORBER SO FAR AND
C                       THE UPPER AND LOWER LIMITS OF THE DEAD
C                       CHAMBER IN SIGMA UNITS.
C
            LETDCE = .TRUE.
            REGDCE(IDCEP)   = IREGN
            REGDCE(IDCEP+1) = AB
            RDCE1           = IFAS * ( DT - 150. )/SQRT(VT1)
            RDCE2           = IFAS * ( DT + 150. )/SQRT(VT1)
            REGDCE(IDCEP+2) = AMIN1(RDCE1,RDCE2)
            REGDCE(IDCEP+3) = AMAX1(RDCE1,RDCE2)
            IDCEP = IDCEP + 4
C
 2500   CONTINUE
        IF(LETDCE) GO TO 1000
C
C DID NOT FIND EDGE OR DEAD CHAMBER WHICH CAN EXPLAIN ABSENCE OF HIT.
C THEREFORE , MUST HAVE CHAMBER INEFFICIENCY . INCREMENT INEFF.
C ---- BUT KEEP TRACKING !
C
        INFLAG=1
        INEFF=INEFF+1
        IF(INEFF.GT.10) GO TO 4000
        INCHAM(INEFF)=JCHAM
        INREG(INEFF)=IREGN
        GO TO 4000
C
C-----------------------------------------------------------------------
C
C UPDATE A FEW THINGS FOR THIS 'GOOD' CHAMBER LAYER.
C
C
C UPDATE X8, ETC., THE VALUES AT LAST BUT ONE GOOD CHAMBER LAYER.
C
 4000   CALL UCOPY(X9,X8,NSPECI)
C
C UPDATE X9, ETC., THE VALUES AT LAST GOOD CHAMBER LAYER.
C
        CALL UCOPY(X,X9,NSPECI)
        NGLAYR=NGLAYR+LINC
C
 1000 CONTINUE
C
C-----------------------------------------------------------------------
C END OF MAIN LOOP OVER REGIONS. ---------------------------------------
C-----------------------------------------------------------------------
C
C             PERFORM MULOCH - THE MUON 'LET-OFF' CHECK
C
 99   CALL MULOCH
C
      RETURN
      END

C   14/03/84 403221753  MEMBER NAME  ANATAG   (S)           FORTRAN
C
C SPECIAL  VERSION OF ANATAG WRITTEN BY A.J.FINCH
C
C     SUBROUTINE ANAOLD(IER)
C
#include "cwktag.for"
C
       CALL ANAL79(IER)
C
       RETURN
       END

C   25/08/83 308251841  MEMBER NAME  JIPATR   (S1)          FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JIPATR( P, R )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     17/05/79 :  FILL COMMON /CJPATR/ ==> PATR/12
C
C        MOD  E. ELSEN     13/11/81 :
C        MOD  J. HAGEMANN  17/01/83 :  S/R DAY2 NOW CALLED ONLY ONCE PER
C             R  RAMCKE             :  EVENT (IN EVTINI).
C                                   :  NEW COMMON /CDAY/ INTRODUCED.
C   LAST MOD  C. BOWDERY   19/08/83 :  MODIFIED COMMON /CWORK/.
C                                   :  HLIST(1600) I.E. 400 HITS/TRACK
C
C        P AND R ARE MOMENTUM AND PLACE AS IN TRCDET.
C        TRACK INFORMATION IS STORED IN  CJPATR,  KPATR  INDICATING  THE
C        TOTAL LENGTH OF ARRAY APATR. ( JADE COMP.NOTE #12 )
C        OVERFLOW CAUSES OVERWRITING OF LAST TRACK RECORD.
C        TYPE OF STARTING POINT ( APATR(KPATR+4) ) MUST BE SUPPLIED FROM
C        CALLING ROUTINE. TRACK NO ALSO SUPPLIED  FROM  CALLING  PROGRAM
C        NOW JPATR(KPATR+2)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION P(10), R(5)
C
      COMMON / CWORK  / NHITS, INEXT, HLIST(1600)
C
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
C
      COMMON / CGEO1  / BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *                  RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *                  R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *                  R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *                  RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *                  ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *                  ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *                  ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *                  XRJETC,
     *                  RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *                  BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *                  XHOL1,XHOL2,YHOL1,YHOL2
C
      COMMON / CDAY   / IDAY(5)
      COMMON / CJPATR / KPATR, APATR(1976)
C
      DIMENSION IPATR(1976), HPATR(1)
      EQUIVALENCE (IPATR(1),APATR(1),HPATR(1))
C
      DATA SIG / 1. /
C
C---------------------  C O D E  ---------------------------------------
C
C                                                TRACK NO.
C
      IPATR( KPATR + 1 ) = KPATR/IPATR(3) + 1
C                                                PROGR. IDENTIFIER
C                                           =TRACK NO, PARTICLE TYPE NOW
      HPATR( (KPATR + 2)*2 ) = P(8)
C                                                DATE OF GENERATION
      IPATR( KPATR +  3 ) = IDAY(1)*1000+IDAY(2)
C                                             FIRST POINT AND DIREC. COS
      APATR( KPATR +  5 ) = R(1)
      APATR( KPATR +  6 ) = R(2)
      APATR( KPATR +  7 ) = R(3)
      APATR( KPATR +  8 ) = P(1) / P(6)
      APATR( KPATR +  9 ) = P(2) / P(6)
      APATR( KPATR + 10 ) = P(3) / P(6)
C                                                FIT PARAMETERS
      R0X = R(1) + P(7)/(.3E-4*BKGAUS)*P(2)
      R0Y = R(2) - P(7)/(.3E-4*BKGAUS)*P(1)
      PRAD = SQRT( P(1)*P(1) + P(2)*P(2) )
C                                                CURVATURE
      SIG = P(7) * SIGN( 1., BKGAUS )
      APATR( KPATR + 19 ) = 0.3E-4*ABS(BKGAUS)/PRAD
C                                                RMIN
      APATR( KPATR + 20 ) = SQRT( R0X*R0X+R0Y*R0Y)
     *                      -1./   APATR( KPATR + 19 )
C                                                PHI
      APATR( KPATR + 21 ) = ATAN2( R0Y, R0X )
C                                                NOT USED
      APATR( KPATR + 22 ) = 0.
C                                                FIT TYPE IN R Z
      IPATR( KPATR + 29 ) = 1
C                                                DZ/DR
      APATR( KPATR + 30 ) = P(3)*R(4) /
     *                      AMAX1( 1.E-4,ABS(P(1)*R(1) + P(2)*R(2)))
C                                                Z0
      APATR( KPATR + 31 ) = R(3) - APATR(KPATR+30) * R(4)
C
      RETURN
C
C-----------------------------------------------------------------------
      ENTRY JUPATR( P, R )
C-----------------------------------------------------------------------
C
C  LOAD PARAMETERS BEHIND CHAMBER
C
C-----------------------------------------------------------------------
C
      PTOT = AMAX1( P(6), .001 )
      PRAD =SQRT(AMAX1(P(1)*P(1)+P(2)*P(2),1.E-6))
CCC  SECOND POINT AND DIREC. COSINE
      APATR( KPATR + 12 ) = R(1)
      APATR( KPATR + 13 ) = R(2)
      APATR( KPATR + 14 ) = R(3)
      APATR( KPATR + 15 ) = P(1) / PTOT
      APATR( KPATR + 16 ) = P(2) / PTOT
      APATR( KPATR + 17 ) = P(3) / PTOT
CCC  FIT TYPE IN R PHI
      IPATR( KPATR + 18 ) = 1
CCC  CURVATURE AT FIRST POINT
      APATR( KPATR + 27 ) = APATR(KPATR+19)*SIG
CCC  CURVATURE AT LAST POINT
      APATR( KPATR + 28 )=0.3E-4*BKGAUS*P(7)/PRAD
CCC  AVERAGE CURVATURE
      APATR( KPATR + 25 ) = ( APATR(KPATR+27) +
     *    APATR(KPATR+28) ) * .5
CCC  ERROR IN CURVATURE
      APATR( KPATR + 26 ) = ABS( APATR(KPATR+27) -
     *         APATR(KPATR+25) )
C
      RETURN
C
      ENTRY JAPATR( ITYPE )
C--------------------------------------------------------
C  ACCEPT TRACK. ITYPE DETERMINES TYPE OF MEASURED TRACK
C  POINTS. ONLY TRACKS WITH MORE THAN 3 HITS ARE REGISTERED.
C--------------------------------------------------------
C
      IF( NHITS .LT. 3 ) RETURN
C
      IF( ITYPE .NE. 0 ) IPATR(KPATR+4) = ITYPE
C
CCC  FILL CELL INFORMATION  INTO TRACK ARRAY
      ICLP = 34
      ICLOLD = -1
      JHIG = INEXT - 1
      JLOW = 1
C
      DO  100  J = JLOW, JHIG, 4
         ICL = HLIST(J) / 16 + 1
         IF( ICL .EQ. ICLOLD ) GOTO 100
         IPATR(KPATR+ICLP) = ICL
         ICLOLD = ICL
         IF( ICLP .LT. 40) ICLP = ICLP+1
  100 CONTINUE
      DO 200 J= ICLP, 48
  200 IPATR( KPATR + J ) = 0
CCC  CHI**2 AND NDF FOR R PHI FIT
      APATR(KPATR+23) = TIMDEL(1)/3.464
      IPATR( KPATR + 24 ) = NHITS
CCC  CHI**2 AND NDF FOR R Z FIT
      APATR( KPATR + 32 ) = ZRESOL
      IPATR( KPATR + 33 ) = NHITS
CCC  TYPE OF LAST POINT
      IPATR(KPATR+11) = IPATR(KPATR+4)
C
CCC  ACCEPT EVENT BY INCREMENTING AND POINTER UPDATING-----
      IPATR(2) = IPATR(2) + 1
      IPATR(5) = IPATR(5) + NHITS
      IPATR(7) = IPATR(7) + 1
      IF( KPATR .GE. 1928 ) RETURN
      KPATR = KPATR + IPATR(3)
CCC  PRESET NO OF NEXT PARTICLE TO THIS NO
      HPATR((KPATR+2)*2-1) = HPATR((KPATR+2-IPATR(3))*2-1)
C
      RETURN
      END

C   26/10/81 705311433  MEMBER NAME  MCIN56MX (S)           FORTRAN
      SUBROUTINE MCIN56
C
C    S.YAMADA  20-04-78  14:40
C     LAST MODIFICATION  20-11-78  21:55
C
C---- INITIALIZE THE SHOWER MONTE CARLO PROGRAM BY A.SATO.
C-
C-   MODIFED FROM LGMCIN, TO WORK WITH 56 SHOWER  MC  (SF5+SF6)
C-
C--          CHANGE 16.1.1986    J.OLSSON
C--          CHANGE 25.4.1987    J.OLSSON     CONS(2)=1.724
C--          CHANGE 26.4.1987    J.OLSSON     CONS(2)=1.684
C--          CHANGE 20.5.1987    J.OLSSON     CONS(1,2) UPDATED
C--     LAST CHANGE 31.5.1987    J.OLSSON     CONS(1,2) UPDATED
C                                         FOR USE WITH ELENMX
C
      DIMENSION CP(10), A(10), Z(10), TIV(10)
C
      COMMON /SFCPA/SF,SFE
C
C  YAMADA COMMENT: SF AND SFE ARE ARBITRARY PARAMETERS AND CAN BE 1.2
C                  OR 1.05. CROSS SECTIOS ARE MODIFIED AND REMODIFIED
C                  BACK TO COMPENSATE THE EFFECT. THEY SERVE ONLY TO
C                  SPEED UP THE REFINEMENT...
C
      COMMON /M0PAR/ CUTM
C
C     COMMON /CLGGAN/ CONS,ECUTCR,ARED,IADCTH
      COMMON /CLGG56/ CONS(2),ECUTCR,ARED(2),IADCTH
C
C STILL OPEN QUESTION: IS ARED MATERIAL DEPENDENT? ECUTCR IS NOT(YAMADA)
C
      CUTM = 0.5
      SF = 1.2
      SFE = 1.2
C
C---- MONTE CARLO CONDITIONS
C
      ECUTMV = 1.2
      CALL SETECT(ECUTMV)
C
C---- CORRECTION FACTOR FOR ECUT
C
      ECUTCR = 1./(1.05415-0.08488*ECUTMV)
C
C---- NORMALIZATION CONS
CC    CONS = 0.1687  ( OLD CONS FOR 'LGAL'/1 )
C          NEW CONSTANT TO SIMULATE 'ALGN'/1
C
C  THIS CONSTANTS ARE USED IN LGCRGN, CALLED BY LSCCTC  (ENTRY LSCCTL)
C  THEY ARE DIFFERENT FOR SF5 AND SF6  (1,2)
C
C     CONS(1) = 0.86189
C     CONS(2) = 1.684
C  UPDATED ACC. TO   PLUS 7 %, PLUS 4 %
C     CONS(1) = 0.9222
C     CONS(2) = 1.7514
C  UPDATED ACC. TO   PLUS 13 %, PLUS 7 %, FOR USE WITH ENELMX
C  AVERAGE ENERGY LOSS INSTEAD OF RESTRICTED ENERGY LOSS (ENELS)
      CONS(1) = 1.0421
      CONS(2) = 1.8740
C
      ARED(1) = 0.25
      ARED(2) = 0.25
C
      IADCTH = 25
C
C IADCTH IS READ OUT THRESHOLD, TIME DEPENDENT
C   IT IS NOT USED ANYWHERE, AS FAR AS SEEN (NOT IN LGCR56)
C
      WRITE(6,600) CONS(1),ARED(1),IADCTH
  600 FORMAT(' LG SF5 CALIB CONS=',F8.5,'  ARED=',F6.2,'  IADCTH=',I6,/)
      WRITE(6,601) CONS(2),ARED(2),IADCTH
  601 FORMAT(' LG SF6 CALIB CONS=',F8.5,'  ARED=',F6.2,'  IADCTH=',I6,/)
C
      CALL INITJA
C
      RETURN
      END

C   27/08/83 310201409  MEMBER NAME  STVECT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE STVECT( LENGTH, IVECT )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     07/04/81 :  FILL FOUR VECTOR BANK 'VECT'/0
C
C        MOD  E. ELSEN     03/11/81 :
C        MOD  C. BOWDERY   27/08/83 :  EXPANDED COMMON /CPROD/.
C   LAST MOD  C. BOWDERY   20/10/83 :  NEW CPROD MACRO
C
C                 FILL FOUR VECT BANK VECT.
C
C  LENGTH = TOTAL LENGTH OF IVECT ARRAY
C
C  IVECT( 1) = LGTH OF HEADER=L0   IVECT( 2) = LENGTH OF 1PARTICLE DATA
C  IVECT( 3) = EVT #               IVECT( 4) = TOTAL # OF PARTICLES
C  IVECT( 5) = # OF CHARGED PART.  IVECT( 6) =  # OF NEUTRAL PARTICLES
C   VECT( 7) = PHI OF JET AXIS      VECT( 8) = COS(THETA) OF JET AXIS
C
C  IVECT( 9) = FLAVOUR OF THE EVENT
C  IVECT(10) = 0
C  IVECT(11) = 0
C  IVECT(12) = 0
C  IVECT(13) = BEAM ENERGY IN MEV
C
C  IVECT( L0 + 1 - 4 ) = MOMENTUM FOUR VECTOR
C  IVECT(L0+5) = MASS OF PARTICLE  IVECT(L0+6) = CHARGE OF PARTICLE
C  IVECT(L0+7) = PARTICLE TYPE
C  IVECT(L0 + 8 -10 ) = ORIGIN OF PARTICLE ( USUALLY (0,0,0) )
C
C  EXTRA ENTRY LHVECT RETURNS LENGTH ONLY
C  FIXUP FOR EVENTS WITH ONLY 2 INITIAL STATE PARTICLES INTRODUCED
C  FOR THE JET POINTERS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cprod.for"
C
      DIMENSION IVECT(1) , IPF(4,300) , IXMF(300) , IPSTRT(3,300)
C
      EQUIVALENCE (IPF(1,1),PF(1,1)) , (IXMF(1),XMF(1))
      EQUIVALENCE (IPSTRT(1,1),PSTRT(1,1)) , (IPHI,PHI) , (ITHETA,THETA)
C
      DATA L0 / 13 /, L1 / 10 /
C
C---------------------  C O D E  ---------------------------------------
C
C                  BANK HEADER
C
      IVECT( 1) = L0
      IVECT( 2) = L1
      IVECT( 3) = NEV
      IVECT( 4) = NF
      IVECT( 5) = NCF
      IVECT( 6) = NNF
      IVECT( 7) = IPHI
      IVECT( 8) = ITHETA
      IVECT( 9) = IFLAVR
      IVECT(10) = 0
      IVECT(11) = 0
      IVECT(12) = 0
      IVECT(13) = BEAM*1000.
      J = L0
C
C                  STORE DATA FOR EACH PARTICLE
C
      NJET = 0
      DO 10 K =1,NF
      IVECT(J+ 1) = IPF(1,K)
      IVECT(J+ 2) = IPF(2,K)
      IVECT(J+ 3) = IPF(3,K)
      IVECT(J+ 4) = IPF(4,K)
      IVECT(J+ 5) = IXMF(K)
      IVECT(J+ 6) = ICF(K)
      IVECT(J+ 7) = ITF(K)
      IVECT(J+ 8) = IPSTRT(1,K)
      IVECT(J+ 9) = IPSTRT(2,K)
      IVECT(J+10) = IPSTRT(3,K)
      IF( ITF(K) .LE. -100 ) NJET = NJET + 1
   10 J = J + L1
C                                           FIX UP POINTERS
      IF( NJET .EQ. 2 ) IVECT(12) = IVECT(11)
C
C----------------------------------------------------------
      ENTRY LHVECT( LENGTH )
C----------------------------------------------------------
C
C                                           LENGTH OF BANK
      LENGTH = NF*L1 + L0
      RETURN
      END

C   16/03/84 810171936  MEMBER NAME  DISPLY   (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DISPLY
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON  PREHISTORY:  DISPLAY ROUTINE. GRAPHICS ONLY
C
C        MOD: J. OLSSON   15/12/83 :  COMMANDS VRX,VRZX,VRZY
C        MOD: P. HILL     17/02/84 :  COMMAND CDST IN. SOME CODE OUT.
C        MOD: C. BOWDERY  16/03/84 :  COMMAND ND50 ADDED TO LIST.
C        MOD: C. BOWDERY  15/06/84 :  PARTIAL RE-WRITE DONE.
C        MOD: C. BOWDERY  20/06/84 :  CHANGES TO REDRAW DET AFTER JOYS
C        MOD: C. BOWDERY  20/12/85 :  LASER PRINTER HARDCOPY
C        MOD: J. HAGEMANN 06/03/86 :  SWITCH VTXC BANKS, PICK COORDI-
C                                     NATES FROM SCREEN .
C                                     DSPDTL(9) NOW SET CORRECTLY
C                                     FOR COMMAND TRUE
C        MOD: J. OLSSON   02/08/86 :  REPAIR LOGIC ERROR IN NNJETC
C        MOD: J. OLSSON   16/04/87 :  VARIOUS DESTINATIONS IN HLP/LASER
C        MOD: J. HAGEMANN 25/07/88 :  NEW COMMANDS ADDED
C                                     (EDVP,DAX,VCDO,DIST,MUTYP)
C   LAST MOD: J. HAGEMANN 17/10/88 :  For TR command
C
C     DISPLAY ROUTINE FOR GRAPHICS COMMAND THAT DO NOT CHANGE CWORK
C
C
C     ISTVW      = 1  FOR STANDARD VIEWS,  0 OTHERWISE
C     ISTVW      IS SET TO 1 BY COMMAND STVW AND PASSING SCANNR DISPLAY
C     JTVW       HOLDS LAST LSTCMD VALUE
C     IVIEW      IS CURRENT VIEW, 1-20
C
C      FL18      IS TRUE IF PROJECTION
C      FL22      IS TRUE IF MAGNIFICATION
C      FL24      IS TRUE IF STANDARD VIEW IS MAGNIFIED
C
C      NNPATR IS USED TO GIVE PATR BANK NR, FOR VARIOUS VERTEX COMMANDS
C      NNJETC IS USED TO GIVE JETC BANK NR, FOR VARIOUS DISPLAY COMMANDS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DETDRW,REDRDT,DSPREM
      LOGICAL FL18,FL22,FL24,DSPDTM
      LOGICAL LPRINT,FLVCDO
C
      REAL*8 DESTLP
C
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON / CGAMOD / MODEGA, GAHEX
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CGRAP6 / DETDRW
      COMMON / CHEADR / HEAD(108)
      COMMON / CVX    / NNPATR,NDUMM,NNJETC,NNVTXC
      COMMON / CGVCDO / FLVCDO(20)
C
      DIMENSION DESTLP(5), IARRAY(2,10)
C
      DATA DESTLP  / 'L1      ','L2      ','L3      ','L4      ',
     &               'L5      '/
      REAL*8 DESTIN  / 'PLOTTER ' /
      REAL*8 DESTEX  / 'EXTPLOTT' /
C
      DATA  HDCL /0/
C
C------------------  C O D E  ------------------------------------------
C
      LAST   = LASTVW
      REDRDT = .FALSE.
C
C                            GET ARGS (INTEGER AND FLOATING POINT FORMS)
C
      A  = ACMD
      AB = BCMD
      N  = A
      NB = AB
C
C                            ICOMD1 IS THE '10' DIGIT OF THE COMMAND
C                            ICOMD2 IS THE '1' DIGIT OF THE COMMAND
C
      ICOMD1 = ( LSTCMD - 1 ) / 10  +  1
      ICOMD2 = MOD( LSTCMD, 10 )
      IF( ICOMD2 .EQ. 0 ) ICOMD2 = 10
C
C                            BRANCH TO APPROPRIATE COMMAND
C                            N.B. COMMANDS 1 - 30 ARE VIEWS
C
      GO TO ( 1, 1, 1, 3140, 4150, 5160, 6170, 7180 ) , ICOMD1
C
  99  CALL TRMOUT(80,'Software Error!  Please contact graphics expert^')
      CALL TRMOUT(80,'Command interpreter overflow in DISPLY^')
      RETURN
C
 3140 GO TO (31,32,33,34,35,36,37,38,39,40) , ICOMD2
 4150 GO TO (41,42,43,44,45,46,47,48,49,50) , ICOMD2
 5160 GO TO (51,52,53,54,55,56,57,58,59,60) , ICOMD2
 6170 GO TO (61,62,63,64,65,66,67,68,99,99) , ICOMD2
 7180 GO TO (99,99,99,99,99,99,99,99,99,99) , ICOMD2
C
C
C                            COMMANDS FOR ALL VIEWS
C                            ( COMMANDS 1 - 30 BUT NOT ALL USED.)
C
   1  IVIEW  = LSTCMD
      IF( IVIEW .NE. 30 ) GO TO 2
C
C                            DRAW STANDARD VIEW
C
        ISTVW = 1
        IVIEW = ISTANV
        CALL SETSCL(0)
        FL22  = FL24
        GO TO 4
C
   2  IF( (LAST.EQ.IVIEW)  .AND.  (JTVW.NE.30) .AND.
     &    (IVIEW.NE.17.OR.FL22) ) GO TO 3
        CALL SETSCL(IVIEW)
        FL22 = .FALSE.
   3  ISTVW  = 0
C
   4  LAST   = IVIEW
      JTVW   = LSTCMD
      DSPREM = DSPDTL(9)
      IF( IVIEW .EQ.  6  .OR.  IVIEW .EQ.  7  .OR.
     +    IVIEW .EQ. 10  .OR.  IVIEW .EQ. 11     ) DSPDTL(9) = .FALSE.
C
      CALL ERASE
      CALL EVDISP(IVIEW)
C
C                                      DRAW DETECTOR IF REQUESTED
C
      IF(  N .NE. 0  .OR.  REDRDT ) then
         call setcol('JADE')    ! PMF 23/11/99: set colour
         CALL JADISP(IVIEW)
         call setcol(' ')    ! PMF 23/11/99: reset colour
      endif
C
C                                      DISPLAY RESULTS IF CDTL 16 SET
C
      IF( DSPDTL(16) ) CALL RSDISP(IVIEW)
      DSPDTL(9) = DSPREM
      IF( DSPDTL(17) ) CALL PROJEC(LAST)
      IF( IVIEW.EQ.17.AND.FL22 ) FL22 = .FALSE.
      RETURN
C
C                            OTHER GRAPHICS ONLY COMMANDS
C
C
C             COMMAND TRUE   (DRAW TRUE TRACKS FOR MC EVENTS)
C
  31  DSPREM = DSPDTL(9)
      IF( LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7  .OR.
     +    LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11     ) DSPDTL(9) = .FALSE.
      call setcol('TRUE') ! PMF 22/11/99: set colour
      CALL TRUTH(N)
      call setcol(' ') ! PMF 22/11/99: reset colour
      DSPDTL(9) = DSPREM
      RETURN
C
C             COMMAND   BW   (PRINT OUT BANK CONTENTS)
C
  32  CALL BANKPR
      RETURN
C
C             COMMAND    H   (INTERNAL PLOTTER HARDCOPY)
C
  33  HDCL = HDCL + 1
      IF( (HDCL/5)*5 .EQ. HDCL) CALL
     +  TRMOUT(80,'Do you know that hardcopies cost  DM 1 /metre?^')
      IF( N .LT. 1) N = 1
      IF( N .GT. 4) N = 4
C
      DO  331  I = 1,N
        CALL HDCDST(DESTIN)
 331  CONTINUE
      RETURN
C
C             COMMAND HX     (EXTERNAL PLOTTER HARDCOPY)
C
  34  CALL HDCDST(DESTEX)
      RETURN
C
C             COMMAND MENU   (DISPLAY LIST OF COMMANDS)
C
  35  CALL MENU
      RETURN
C
C             COMMAND   RS   (RESET PICTURE SCALE)
C
  36  IF( .NOT. FL22 ) RETURN
      CALL SETSCL(LAST)
      FL22 = .FALSE.
      IF( DETDRW ) REDRDT = .TRUE.
C
C                            REDRAW EVENT (DET AS WELL IF DRAWN ALREADY)
C
      LSTCMD = LASTVW
      LAST   = LASTVW
      N      = 0
      ACMD   = 0.0
      JTVW   = 0
      GO TO 1
C
C             COMMAND JOYS   (JOYSTICK INPUT FOR MAGNIFICATION ETC)
C
  37  CALL JOYS(N,A)
      IF( DETDRW ) REDRDT = .TRUE.
C
C                            REDRAW EVENT (DET AS WELL IF DRAWN ALREADY)
C
      LSTCMD = LASTVW
      LAST   = LASTVW
      ACMD   = 0.0
      N      = 0
      JTVW   = 0
      GO TO 1
C
C             COMMAND  DET   (DRAW DETECTOR HARDWARE)
C
  38  continue
      call setcol('JADE') ! PMF 23/11/99: set colour
      CALL JADISP(LAST)
      call setcol(' ') ! PMF 23/11/99: reset colour
      RETURN
C
C             COMMAND  COM   (ADD COMMENT TO THE PICTURE)
C
  39  CALL COMENT
      RETURN
C
C             COMMAND  PRO     (PROJECTIONS OF Z-X AND Z-Y SECTIONS)
C
  40  CALL PROJEC(LAST)
      RETURN
C
C             COMMAND CDTL   (CHANGE DISPLAY DETAILS)
C                            FIRST 30 FLAGS IN DSPDTL, THEN IN DSPDTM
C
  41  IF( N .GE. 1  .AND.  N .LE. 60 ) GO TO 412
 411  CALL CDST(0)
      CALL TRMOUT(80,'Enter option number to be changed:^')
C
      N = TERNUM(DUMMY)
      IF( N .GE. 1  .AND.  N .LE. 60 ) GO TO 412
      CALL TRMOUT(80,'No such option exists. Please try again.^')
      GO TO 411
C
 412  IF( N .LE. 30 ) DSPDTL(N)    = .NOT. DSPDTL(N)
      IF( N .GT. 30 ) DSPDTM(N-30) = .NOT. DSPDTM(N-30)
C
C                            DISPLAY NEW STATUS OF CONTROL-DETAIL N
C                            (SAME AS IF CDST COMMAND WAS GIVEN)
C
C
C             COMMAND  CDST  (DISPLAY CONTROL-DETAIL-FLAGS STATUS)
C                            THE CURRENT (MAY 84) TOTAL IS 44.
C                            IF NO TRAILING INDEX THEN
C                            DISPLAY STATUS OF ALL OPTIONS
C
  42  CALL CDST(N)
      RETURN
C
C             COMMAND TRLG   (DISPLAY LEAD GLASS TRIGGER)
C                            ONLY ACTIVE FOR NEW DATA (1982 - ...)
C
  43  CALL TBGDIS
      RETURN
C
C             COMMAND NEWS   (DISPLAY GRAPHICS NEWS)
C
  44  CALL NEWS
      RETURN
C
C             COMMAND  RES   (DISPLAY ANALYSIS RESULTS IN THIS VIEW)
C
  45  DSPREM = DSPDTL(9)
      IF( LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7  .OR.
     +    LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11     ) DSPDTL(9) = .FALSE.
      CALL RSDISP(LASTVW)
      call setcol(' ') ! PMF 23/11/99: reset colour set in RSDISP
      DSPDTL(9) = DSPREM
      IF( DSPDTL(17) ) CALL PROJEC(LASTVW)
      RETURN
C
C             COMMAND HELP   (DISPLAY DETAILED INFORMATION ON COMMANDS.)
C
  46  CALL HELPUS
      RETURN
C
C             COMMAND TR     (SPECIAL DISPLAY OF TRACK HITS)
C
  47  DSPREM = DSPDTL(9)
      IF( LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7  .OR.
     +    LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11     ) DSPDTL(9) = .FALSE.
      CALL TRKHIT
      DSPDTL(9) = DSPREM
      RETURN
C
C             COMMAND  RET   (RETURN TO EDIT SUBSYTEM)
C
  48  FL22 = FL24
      RETURN
C
C             COMMAND MASS   (PRINT EFFECTIVE MASS OF UP TO 6
C                             GIVEN PARTICLES ON SCREEN)
C
  49  CALL EFMASS
      RETURN
C
C             COMMAND TRG2   (T2 TRIGGER DISPLAY)
C
  50  CALL TRIG2
      RETURN
C
C             COMMAND SAVE   (SAVE /CWORK/ ON DISK)
C
  51  IF( N .NE. 0 ) GO TO 511
      CALL TRMOUT(80,'Please type  1  to save CWORK onto disk^')
      CALL TRMOUT(80,'or  2  to retrieve from disk and reset CWORK.^')
      N = TERNUM(DUMMY)
 511  IF( N .EQ. 1  .OR.  N .EQ. 2 ) GO TO 512
      CALL TRMOUT(80,'No such option. Command ignored.^')
      RETURN
 512  CALL RETTEN(N)
      RETURN
C
C             COMMAND  VRES  (TRACK+VERTEX RESULT DISPLAY)
C                            VRES IS IDENTICAL TO RES IN RU AND RZ VIEWS
C                            OTHER VIEWS, START WITH VX COMMAND
C
  52  IF( LASTVW .EQ. 13  .OR.  LASTVW .EQ. 16 ) GO TO 45
C
C             COMMAND   VX   (VERTEX RESULTS DISPLAY)
C
  53  DSPREM = DSPDTL(9)
      IF( LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7  .OR.
     +    LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11     ) DSPDTL(9) = .FALSE.
      CALL VXDISP(LASTVW)
      DSPDTL(9) = DSPREM
      IF( LSTCMD .EQ. 52  .AND.  DSPDTL(17) ) CALL PROJEC(LASTVW)
      RETURN
C
C             COMMAND   BL   (LG DISPLAY OPTIONS)
C
  54  CALL BLSHOW
      RETURN
C
C             COMMAND MUR2   (MUON TRACK INFORMATION)
C
  55  DSPREM = DSPDTL(9)
      IF( LASTVW .EQ.  6  .OR.  LASTVW .EQ.  7  .OR.
     +    LASTVW .EQ. 10  .OR.  LASTVW .EQ. 11     ) DSPDTL(9) = .FALSE.
      CALL MUR2DS
      DSPDTL(9) = DSPREM
      RETURN
C
C             COMMAND DRAW   (DRAW LINES ETC.)
C
  56  CALL DRAWER
      RETURN
C
C             COMMAND EC     (ADD ENDCAP)
C
  57  IF( LASTVW .LE. 3 ) CALL ECAPS(N)
      RETURN
C
C             COMMAND FC     (ADD TAGGING SYSTEM)
C
  58  IF( LASTVW .LE. 3 ) CALL FWCHEV
      RETURN
C
C             COMMAND PATR   (SWITCH PATR BANKS)
C
  59  NNPATR = N
      IF( N .GE. 0 ) GO TO 592
 591  CALL TRMOUT(80,'Enter PATR bank number:^')
      CALL FYRINT(NNPATR,ID2,ID3,ID4)
 592  IF( NNPATR .LT. 0 ) GO TO 591
      RETURN
C
C             COMMAND JETC   (SWITCH JETC BANKS)
C
  60  NNJETC = N
      IF( N .NE. 0 ) GO TO 602
         CALL TRMOUT(80,'Enter JETC bank number:^')
         CALL FYRINT(NNJETC,ID2,ID3,ID4)
 602  CONTINUE
      RETURN
C
C             COMMAND HLP / LASER   (LASER PRINTER HARDCOPY)
C
  61  CALL PTRANS(335,100)
      NDEST = N
      IF( N .GT. 0 .AND. N .LT. 6 ) GO TO 612
 611  CALL TRMOUT(80,'Enter destination for hardcopy on laser printer (L
     &1 .. L5) : (1 .. 5)^')
      CALL FYRINT(NDEST,ID2,ID3,ID4)
 612  IF( NDEST .LT. 1 .OR. NDEST .GT. 5 ) GO TO 611
      CALL HDCDST(DESTLP(NDEST))
      RETURN
C
C             COMMAND VTXC   (SWITCH VTXC BANKS)
C
  62  NNVTXC = N
      IF( N .GE. 0 .AND. N .LT. 100 ) GO TO 622
 621  CALL TRMOUT(80,'Enter VTXC bank number:^')
      CALL FYRINT(NNVTXC,ID2,ID3,ID4)
 622  IF( NNVTXC .LT. 0 .OR. NNVTXC .GT. 99 ) GO TO 621
      RETURN
C
C             COMMAND PICK   (PICK COORDINATES FROM SCREEN)
C
  63  CALL PICK
      RETURN
C
C             COMMAND EDVP   (EDIT VPAT-BANK)
C
  64  CALL EDVP
      RETURN
C
C             COMMAND DAX   (CALCUTATE AXIS AND DISPLAY IT)
C
  65  CALL DISAXI
      RETURN
C
C             COMMAND VCDO  (VERTEX CHAMBER DISPLAY OPTIONS)
C
  66  IF( N .GE. 1  .AND.  N .LE. 20 ) GO TO 662
 661  CALL VCDO(0)
      CALL TRMOUT(80,'Enter option number to be changed:^')
C
      N = TERNUM(DUMMY)
      IF( N .EQ. 0 ) GO TO 663
      IF( N .GE. 1  .AND.  N .LE. 20 ) GO TO 662
      CALL TRMOUT(80,'No such option exists. Please try again.^')
      GO TO 661
C
 662  FLVCDO(N)    = .NOT. FLVCDO(N)
C
C                            DISPLAY NEW STATUS OF CONTROL-DETAIL N
C
      CALL VCDO(N)
 663  CONTINUE
      RETURN
C
C             COMMAND DIST   (CALCULATE DISTANCE BETWEEN TWO POINTS
C                             GIVEN BY JOYSSTICK INPUT OR ONE POINT
C                             AND A TRACK)
  67  CALL CTDIST
      RETURN
C
C             COMMAND MUTYP (SHOW MUON TYPES)
C
  68  CALL MUONS( NUMBER, IARRAY, IERROR )
      IF( IERROR.NE.0 .OR. NUMBER.LE.0 ) GOTO 685
      DO 684 J = 1, NUMBER
         WRITE(6,683) IARRAY(1,J),IARRAY(2,J)
 683     FORMAT(' TRACK ',I2,' IS A TYPE ',I2,' GOOD MUON')
 684  CONTINUE
 685  CONTINUE
      RETURN
C
      END

C   05/08/85 508051152  MEMBER NAME  DELMAC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DELMAC
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   5/08/85 :  DELETE AN EXISTING MACRO
C
C
C     THIS ROUTINE PROMPTS FOR A MACRO NAME, WHICH IF EXISTING, IS
C     DELETED AFTER CONFIRMATION FROM THE USER.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CCMD
      LOGICAL*1  CHARS
      LOGICAL*1  CDEF
C
      COMMON / CWORK  / NFIELD, CHARS(80), ISTAFL(80), IENDFL(80)
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
      COMMON / CGRAP4 / IPOS4,CCMD(8,200),HCMD(5,200)
*** PMF 03/12/99
      CHARACTER*80 CHARS2
      EQUIVALENCE(CHARS2,CHARS(1))
*** PMF(end)
CC
C------------------  C O D E  ------------------------------------------
C
   5  WRITE(6,10)
  10  FORMAT(' Please enter the NAME of the macro to be deleted:')
C
      READ(5,15) CHARS
  15  FORMAT(80A1)
      CALL CLTOU(CHARS2)         ! PMF 03/12/99
C
C                            FIND THE NAME
C
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .EQ. 0 ) RETURN
C
C                            CORRECT LENGTH AND ONLY ONE?
C
      LEN = IENDFL(1) - ISTAFL(1) + 1
      IF( NFIELD .EQ. 1  .AND.  LEN .LE. 8 ) GO TO 60
        WRITE(6,50)
  50    FORMAT(' Sorry. Only one name of 8 letters or less and no ";"',
     +         '. Please try again')
        GO TO 5
C
C                            IS THE NAME UNIQUE?
C
  60  CALL FINABR( CHARS(ISTAFL(1)), LEN, ICMD, MAXARG, IS )
      IMAC = ICMD - MACSTA
      IF( IMAC .GT. 0 ) GO TO 70
        WRITE(6,65)
  65    FORMAT(' No macro with that name exists.',
     +         ' Try again or press ENTER to end DELMAC')
        GO TO 5
C
C                            DISPLAY DEFINITION
C
  70  WRITE(6,80) (CDEF(K,IMAC),K=1,80)
  80  FORMAT(' The following definition currently exists for this',
     +       ' macro:'/
     +       1X,80A1/' Do you really want to delete this macro? ',
     +               '  ( YES or <NO> )')
C
      CALL DECIDE( IANSW )
C
      IF( IANSW .EQ. 1 ) GO TO 100
        WRITE(6,95)
  95    FORMAT(' Macro not deleted.')
        RETURN
C
C                            DELETE MACRO ENTRY
C
 100  CALL LOCMAC( ICMD, LOCAT )
      IF( LOCAT .GT. 0 ) GO TO 110
        WRITE(6,105)
 105    FORMAT(' SYSTEM ERROR in DELMAC. Call the GRAPHICS EXPERT!')
        RETURN
C
 110  WRITE(6,120) ( CCMD(K,LOCAT),K=1,8)
 120  FORMAT(' Macro ',8A1,' deleted.')
C
C                            REMOVE ENTRY IN THE COMMAND LIST
C
      IPOS4 = IPOS4 - 1
      MACNR = MACNR - 1
      IF( LOCAT .GT. IPOS4 ) RETURN
      DO  130  I = LOCAT,IPOS4
C
        DO  123  J = 1,8
          CCMD(J,I) = CCMD(J,I+1)
 123    CONTINUE
C
        DO  127  J = 1,5
          HCMD(J,I) = HCMD(J,I+1)
 127    CONTINUE
C
 130  CONTINUE
C
C                            REMOVE ENTRY IN THE MACRO DEFINITION LIST
C
      DO  140  I = IMAC,MACNR
        DO  135  J = 1,80
          CDEF(J,I) = CDEF(J,I+1)
 135    CONTINUE
 140  CONTINUE
C
      RETURN
      END

C   07/06/96 606071828  MEMBER NAME  BREAD    (S4)          FORTG1
      SUBROUTINE BREAD(IUN,*,*)
C     BOS SUBPROGRAM =3.1=
      COMMON/BCS/IW(1)
   10 CALL BRDS(IUN,NBUFL,INIR)
      IF(INIR.EQ.0) GOTO 100
C
C PMF 28/10/98: Read IW(INIR) explicitly BEFORE calling BFWR and
C perform then a backspace. Otherwise BFWR does not work correctly
C on the current platforms.
C PMF 07/07/99: correct bug
      READ(IUN,ERR=101,END=102) IW(INIR)
      BACKSPACE (IUN)
C
      CALL BFRD(IUN,IW(INIR),IW(INIR+1))
      IF(IW(INIR)) 102,101,10
  100 RETURN
  101 RETURN 1
  102 RETURN 2
      END

C   03/12/81 502132004  MEMBER NAME  MUONS    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUONS( NUMBER, IARRAY, IERROR )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY     29/09/84 : RETURNS NUMBER OF MUCUTS MUONS
C
C LAST MOD:   C. BOWDERY     13/02/85 : .GT. 10  --> .GE. 10
C
C
C     THIS ROUTINE EXAMINES THE MUR2/1 BANK TO SEARCH FOR MUONS.
C
C     OUTPUT:   NUMBER         NO. OF MUONS IN THIS EVENT  (0,1,2,3....)
C               IARRAY(N,K)    ARRAY OF TRACK NUMBERS AND MUON TYPES
C                              N HAS RANGE 1..2
C                              K HAS RANGE 1..10   (1..NUMBER   DEFINED)
C                              N = 1   TRACK NUMBER
C                              N = 2   MUON TYPE  (1,5 OR 9)
C
C               IERROR         0 = NO ERROR
C                              1 = NO 'PATR' BANK
C                              2 = NO 'MUR2'/0 BANK = NO MU ANALYSIS
C                              3 = NO 'MUR2'/1 BANK = MAYBE NO MU HITS
C                                                     OR NO PATR TRACKS
C                              4 = ILLEGAL MUON TYPE FLAG FOUND. EVENT
C                                  PROCESSING STOPPED. (MESSAGE PRINTED
C                                  FOR THE FIRST 10 OCCURRENCES.)
C                              5 = MORE THAN 10 MUONS FOUND = POSSIBLY
C                                  ANALYSIS ERROR. (MESSAGE PRINTED FOR
C                                  THE FIRST 10 OCCURRENCES.)
C
C-----------------------------------------------------------------------
C
C      MUON TYPES
C      ----------
C
C      MUCUTS FLAGS TRACKS WITH A   0, 1, 5 OR 9. BECAUSE OF BACKGROUND,
C      SOME TRACKS WITH FLAG 1, 5 AND 9 WILL NOT BE PROMPT MUONS BUT
C      THE PROBABILITY DECREASES AS THE FLAG VALUE INCREASES. TRACKS
C      WITH FLAG 0 ARE MAINLY NON-PROMPT MUONS AND OTHER PARTICLES.
C
C      NEW SCHEME:  TYPE A MUONS INCLUDE ALL MUONS WITH FLAGS 1, 5 AND 900000527
C                   TYPE B MUONS INCLUDE ALL MUONS WITH FLAGS    5 AND 900000528
C                   TYPE C MUONS INCLUDE ALL MUONS WITH FLAG           900000529
C
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cmubcs.for"
C
      DIMENSION IARRAY(2,10)
C
      DATA  ICNT1 / 0 /, ICNT2 / 0 /
C
C------------------  C O D E  ------------------------------------------
C
      NUMBER = 0
      IERROR = 0
C
C                            FIND 'PATR' BANK. IF NOT THERE, RETURN WITH
C                            ERROR CODE 1
C
      IPATR  = IDATA( IBLN('PATR') )
      IF( IPATR .GT. 0 ) GO TO 1
        IERROR = 1
        RETURN
C
C                            FIND 'MUR2'/0 BANK. IF NOT THERE, RETURN
C                            WITH ERROR CODE 2
C
   1  CALL CLOC(MUR20, 'MUR2', 0 )
      IF( MUR20 .GT. 0 ) GO TO 2
        IERROR = 2
        RETURN
C
C                            FIND 'MUR2'/1 BANK. IF NOT THERE, RETURN
C                            WITH ERROR CODE 3
C
   2  CALL CLOC(MUR21, 'MUR2', 1 )
      IF( MUR21 .GT. 0 ) GO TO 3
        IERROR = 3
        RETURN
C
C                            FIND NUMBER OF PATR TRACKS AND NO. OF WORDS
C                            PER TRACK IN 'MUR2'/1
C
   3  NTRK = IDATA( MUR20 + 1 )
      NWRD = IDATA( MUR20 + 2 )
C
C                            LOOP OVER TRACKS TO FIND THOSE WITH
C                            A NON-ZERO MUCUTS FLAG ==> MUON
C
      DO  10  ITRK = 1,NTRK
        IP = ( ITRK - 1 ) * NWRD + MUR21
        IQ = HDATA( 2 * IP + 53 )
        IF( IQ .EQ. 0 ) GO TO 10
C
C                            VALID FLAG?  1, 5 OR 9 ?
C
        IF(                    .NOT.
     +      ( IQ .EQ. 1  .OR.  IQ .EQ. 5  .OR. IQ .EQ. 9 )
     +                                                     ) GO TO 15
C
        IF( NUMBER .GE. 10 ) GO TO 20
C
        NUMBER = NUMBER + 1
        IARRAY(1,NUMBER) = ITRK
        IARRAY(2,NUMBER) = IQ
  10  CONTINUE
C
      RETURN
C
C                            PROBLEMS
C
  15  ICNT1 = ICNT1 + 1
      IF( ICNT1 .GT. 10 ) RETURN
      IERROR = 4
      WRITE(6,16) IQ
  16  FORMAT(' ****   E R R O R   ****   ILLEGAL MUON TYPE FLAG (',I5,')
     + FOUND IN MUR2/1 BANK BY S/R MUONS. EVENT DROPPED')
      RETURN
C

  20  ICNT2 = ICNT2 + 1
      IF( ICNT2 .GT. 10 ) RETURN
C
      WRITE(6,21)
  21  FORMAT(' ****   W A R N I N G   ****    MORE THAN 10 MUONS IN THIS
     + EVENT FOUND BY S/R MUONS. POSSIBLE ANALYSIS ERROR!')
      IERROR = 5
      RETURN
C
      END

C   16/10/75 311291228  MEMBER NAME  RNGAU    (S)           FORTRAN
      FUNCTION RNGAU(AMEAN,SIG)
C
C     S = STANDARD DEVIATION, A = MEAN
C
      SUM = 0.
      DO 1 I = 1,12
    1 SUM = SUM + RN(DUM)
      RNGAU = (SUM - 6.)*SIG + AMEAN
      RETURN
      END

C   24/07/79 C9072401   MEMBER NAME  ANOM11   (S)           FORTRAN
      SUBROUTINE ANOM11(IRUN)
C---  ANOMALIES OF RUNS 699 - 709
C---  15.8 GEV     JULY 1979
C
C     H.WRIEDT    24.07.79     23:50
C     LAST MODIFICATION     24.07.79     23:50
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (699,12,701,12,12,704,705,706,707,12,709),IRUN
   12 RETURN
C
  699 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      RETURN
C
  701 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
      KCONST(190) = -1
      LIMIT(190) = 225
C
      RETURN
C
  704 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      RETURN
C
  705 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      RETURN
C
  706 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(85) = .TRUE.
C
      RETURN
C
  707 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      RETURN
C
  709 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(168) = -1
      LIMIT(168) = 255
      KCONST(178) = -1
      LIMIT(178) = 285
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
C
      RETURN
C
      END

      SUBROUTINE FTRKEL
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(MHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C----------------------------------------------------------------------
C           MACRO CDSMAX .... PATTERN RECOGNITION CONSTANTS.
C----------------------------------------------------------------------
      COMMON/CDSMAX/DSMAX(16,3,2),DIRWR1(24,2),DIRWR3(48,2)
     *             ,DHALF(16,3,2),DTWICE(16,3,2),HMCH(16,3,2)
     *             ,IBCK(9),DBCK(30),TRMATS(96,2),TRMATC(96,2)
C------------------------ END OF MACRO CDSMAX -------------------------
      DIMENSION HPBAK(16),HLYAR(16),HLBAR(16),DSPAR(16),RESAR(16)
      DATA MKGDLN / Z107/
      DATA MKDIVL / Z100/
      DATA LBNOCN / Z1/
      DATA LBKINK / Z2/
      DATA LBWALL / Z4/
      DATA LBWIRE / Z8/
      DATA LBTREL /Z1000/
      INTEGER LBLFRT(3) /Z10000,Z30000,Z20000/
      FPAR0(X) = (PAR10*X + PAR20)*X + PAR30
      FPAR (X) = (PAR1 *X + PAR2 )*X + PAR3
      MTRK = 0
      HPTR0= HPFREE
      HLDTR= 17
      IPTR = HPTR0
      IP=HPHT0
16000 CONTINUE
        LB = LAND(IWRK(IP+4),MKGDLN)
        IFREEU = IWRK(IP+5)
        IF(IFREEU.GT.0) IFREEU = IWRK(IFREEU+9)
        IFREED = IWRK(IP+7)
        IF(IFREED.GT.0) IFREED = IWRK(IFREED+9)
      IF(
     - IWRK(IP+8).EQ.0 .AND. LB.EQ.7
     .     .AND. ABS(WRK(IP+11)).GT..1
     .     .AND. IFREEU.EQ.0 .AND. IFREED.EQ.0
     -)THEN
          DS0 = WRK(IP+2)
          SL0 = WRK(IP+3)
          NLINEL = 1
          DDSOFF = SIGN(TRELLM(1),WRK(IP+11))
          IF(LAND(IWRK(IP),1).NE.0) DDSOFF =-DDSOFF
          INEXT = 5
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
          LBSTRT = LBEND
          IPL = IWRK(IPH+5)
          IWRK(IPH+8) = 1
          INEXT = 7
      ASSIGN 17002 TO IZZZ01
      GOTO 17000
17002 CONTINUE
          IPH = IWRK(IPH+7)
      IF(
     - NLINEL+2.GE.LMTREL(13)
     -)THEN
      ASSIGN 17004 TO IZZZ02
      GOTO 17003
17004 CONTINUE
      ENDIF
      ENDIF
      IP = IP + HLDHT
      IF(.NOT.(
     - IP.GT.HPHT9
     -))GOTO 16000
16001 CONTINUE
      HPFREE= IPTR
      HPTR9 = IPTR - 1
      NTRKEL = MTRK
      RETURN
17000 CONTINUE
          IPH   = IP
          IPA   = IWRK(IP+INEXT)
          LBEND = 0
15000 CONTINUE
      IF(
     - IPA.GT.0
     -)THEN
              IPNXT = IWRK(IPA+INEXT)
      IF(
     - IPNXT.LE.0
     -)THEN
                LBEND = LBNOCN
      GOTO 15001
      ENDIF
      IF(
     - IWRK(IPNXT+8).NE.0 .OR. LAND(IWRK(IPA+4),MKDIVL).NE.0
     -)THEN
                LBEND = LBKINK
      GOTO 15001
      ENDIF
              NLINEL = NLINEL + 1
              IPH    = IPA
              IPA    = IPNXT
      GOTO 15000
      ENDIF
15001 CONTINUE
      GOTO IZZZ01
17003 CONTINUE
        IHIT = 0
        IPA = IPL
16002 CONTINUE
          IWRK(IPA+8) = 1
          IHIT = IHIT + 1
          HPBAK(IHIT  ) = IPA
          HLYAR(IHIT  ) = IWRK(IPA  )
          DSPAR(IHIT) =  WRK(IPA+2)
        IPA = IWRK(IPA+ 7)
      IF(.NOT.(
     - IPA.GE.IPH
     -))GOTO 16002
16003 CONTINUE
        IWRK(IPA+8) = 1
        HPBAK(IHIT+1) = IPA
        HLYAR(IHIT+1) = IWRK(IPA  )
        DSPAR(IHIT+1) =  WRK(IPA+2)
        JHIT0 = 1
        JHIT9 = IHIT + 1
        IHIT9 = JHIT9
        IHIT0 = 1
        MHIT = IHIT9 - IHIT0 + 1
        MKCUT = 0
15002 CONTINUE
      IF(
     - MHIT.GE.LMTREL(13)
     -)THEN
          DSTAG0 = 0.
          NITER = LMTREL(6)
      ASSIGN 17006 TO IZZZ03
      GOTO 17005
17006 CONTINUE
      IF(
     - STAGSG.LE.SIGLM .AND. YPMIN.GE.TRELLM(10)
     -)THEN
            DSIGLR = ABS(SIGL-SIGR)
      IF(
     - DSIGLR.GT.TRELLM(19) .AND.
     ?         (MHIT.GT.6 .OR. STAGSG.LE.TRELLM(14)**2)
     -)THEN
              LBLR =-1
              IF(SIGR.LT.SIGL) LBLR = 1
      ELSE
              LBLR = 0
      ENDIF
      ASSIGN 17008 TO IZZZ04
      GOTO 17007
17008 CONTINUE
            MHIT = 0
      ELSE
      ASSIGN 17010 TO IZZZ05
      GOTO 17009
17010 CONTINUE
            MHIT = IHIT9 - IHIT0 + 1
      ENDIF
      IF(
     - MKCUT.NE.0 .AND. MHIT.LT.LMTREL(13)
     -)THEN
            IHIT0 = JHIT0
            IHIT9 = JHIT9
            MKCUT = 0
            MHIT = IHIT9 - IHIT0 + 1
      ENDIF
      GOTO 15002
      ENDIF
15003 CONTINUE
      GOTO IZZZ02
17009 CONTINUE
        IHITM1 = IHITM0
        IHITM2 = IHITM0
        MHIT = IHIT9 - IHIT0 + 1
16004 CONTINUE
      IF(
     - YPMIN.LT.TRELLM(10) .AND. STAGSG.LE.SIGLM
     -)THEN
            HLYMIN = XPMIN
      DO 13000 IHIT=IHIT0,IHIT9
              IF(HLYAR(IHIT).LE.HLYMIN) IHITM1 = IHIT
13000 CONTINUE
13001 CONTINUE
            IHITM2 = IHITM1 + 1
      GOTO 16005
      ENDIF
      IF(
     - YPMIN.LT.10. .AND. MHIT.GE.5
     -)THEN
            IHMIN  = IHIT0
            DSMIN  = 100000.
      DO 13002 IHIT=IHIT0,IHIT9
      IF(
     - DSPAR(IHIT).LT.DSMIN
     -)THEN
                DSMIN = DSPAR(IHIT)
                IHMIN = IHIT
      ENDIF
13002 CONTINUE
13003 CONTINUE
            IHMINS = IHMIN
            DDSP   = 1000.
      IF(
     - IHMIN.EQ.IHIT9
     -)THEN
              IHMIN = IHMIN - 1
      ELSE
      IF(
     - IHMIN.GT.IHIT0
     -)THEN
                DDSP = DSPAR(IHMIN+1) - DSPAR(IHMIN-1)
                IF(DDSP.GT.0) IHMIN = IHMIN - 1
      ENDIF
      ENDIF
            LBCUT = 0
      IF(
     - IHMIN-2.LT.IHIT0
     -)THEN
              IF(DSPAR(IHMIN+3)-DSPAR(IHMIN+1).GT.2.0) LBCUT = 1
      ELSE
      IF(
     - IHMIN+3.GT.IHIT9
     -)THEN
                IF(DSPAR(IHMIN-2)-DSPAR(IHMIN  ).GT.2.0) LBCUT = 1
      ELSE
                ZSL1 = DSPAR(IHMIN-2) - DSPAR(IHMIN  )
                ZSL2 = DSPAR(IHMIN+3) - DSPAR(IHMIN+1)
                IF(ZSL1.GT.2.0 .OR. ZSL2.GT.2.0) LBCUT = 1
      ENDIF
      ENDIF
      IF(
     - LBCUT.NE.0
     -)THEN
      IF(
     - ABS(DDSP).GT..6 .AND. DSMIN.GT..6
     -)THEN
                IHITM1 = IHMIN
                IHITM2 = IHMIN + 1
      ELSE
                IHITM1 = IHMINS - 1
                IHITM2 = IHMINS + 1
      ENDIF
      GOTO 16005
      ENDIF
      ENDIF
      IF(
     - MHIT.GE.6
     -)THEN
            DRES1 = 0.
            DRES2 = 0.
            IHMX1 =-1
            IHMX2 =-1
            DSL0  = PAR10*8.
            IHIT4 = IHIT0+4
      DO 13004 IHIT = IHIT0,IHIT9
              X = HLYAR(IHIT)
              Y = DSPAR(IHIT)
              F = FPAR0(X)
              DCHI = F - Y
              RESAR(IHIT) = DCHI
      IF(
     - IHIT.GT.IHIT0
     -)THEN
                DDRES1 = ABS(DCHI-DCHI1)
      IF(
     - DDRES1.GT.DRES1
     -)THEN
                  DRES1 = DDRES1
                  IHMX1 = IHIT
      ENDIF
      IF(
     - IHIT.GE.IHIT4
     -)THEN
                  DDRES2 = ABS(2.*DSPAR(IHIT-2)-DSPAR(IHIT-4)-Y + DSL0)
      IF(
     - DDRES2.GT.DRES2
     -)THEN
                    DRES2 = DDRES2
                    IHMX2 = IHIT-2
      ENDIF
      ENDIF
      ENDIF
              DCHI1 = DCHI
13004 CONTINUE
13005 CONTINUE
            DRES1 = DRES1 * 1.5
            DRES0 = TRELLM(16)*2.5
      IF(
     - DRES0.LT.DRES2 .OR. DRES0.LT.DRES1
     -)THEN
      IF(
     - DRES1-DRES2 .LT. TRELLM(14)*1.4
     -)THEN
      IF(
     - DSPAR(IHMX2).LT.TRELLM(10)
     -)THEN
      IF(
     - DSPAR(IHMX2-1).LT.DSPAR(IHMX2+1)
     -)THEN
                    IHITM2 = IHMX2
                    IHITM1 = IHMX2 - 1
      ELSE
                    IHITM1 = IHMX2
                    IHITM2 = IHMX2 + 1
      ENDIF
      ELSE
      IF(
     - DRES2.GT.TRELLM(14)*5.
     -)THEN
                    IHITM1 = IHMX2
                    IHITM2 = IHMX2
      ELSE
                    IHITM1 = IHMX2 - 1
                    IHITM2 = IHMX2 + 1
      ENDIF
      ENDIF
      ELSE
                IHITM1 = IHMX1 - 1
                IHITM2 = IHMX1
      ENDIF
      ENDIF
      ENDIF
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16004
16005 CONTINUE
      IF(
     - MKCUT.EQ.2  .OR.
     ?     ((IHITM1-IHIT0).GE.(IHIT9-IHITM2) .AND. MKCUT.EQ.0)
     -)THEN
      IF(
     - IHITM1.GT.IHIT0
     -)THEN
            IF(IHITM1.EQ.IHIT9) IHITM1 = IHITM1 - 1
            IHIT9 = IHITM1
            IF(MKCUT.NE.1) JHIT0 = MIN0(IHITM2,JHIT9)
            MKCUT = 2
      ELSE
            IHIT9 = JHIT9
            IHIT0 = IHIT0+1
            JHIT0 = IHIT0
            MKCUT = 0
      ENDIF
      ELSE
      IF(
     - IHITM2.LT.IHIT9
     -)THEN
            IF(IHITM2.EQ.IHIT0) IHITM2 = IHITM2 + 1
            IHIT0 = IHITM2
            IF(MKCUT.NE.2) JHIT9 = MAX0(IHITM1,JHIT0)
            MKCUT = 1
      ELSE
            IHIT0 = JHIT0
            IHIT9 = IHIT9-1
            JHIT9 = IHIT9
            MKCUT = 0
      ENDIF
      ENDIF
      GOTO IZZZ05
17007 CONTINUE
        DSTAG0 = SWDEPL*LBLR
        NITER = 0
      ASSIGN 17011 TO IZZZ03
      GOTO 17005
17011 CONTINUE
      IF(
     - MHIT.GE.LMTREL(13)
     -)THEN
      DO 13006 IHIT = IHIT0,IHIT9
      IF(
     - HLBAR(IHIT).EQ.0
     -)THEN
              IPA = HPBAK(IHIT)
              IWRK(IPA+10) = IWRK(IPA+9)
              IWRK(IPA+ 9) = IPTR
      ENDIF
13006 CONTINUE
13007 CONTINUE
          LRIND = ISHFTR(LBLR+3,1)
          IF(DSMAX(ILAY0+1,IRING,LRIND)-5. .LT. DS0)
     ?      LBSTRT = LOR(LBSTRT,LBWALL)
          IF(DS0.LT.1.5) LBSTRT = LOR(LBSTRT,LBWIRE)
          IF(DSMAX(ILAY9+1,IRING,LRIND)-5. .LT. DS9)
     ?      LBEND  = LOR(LBEND ,LBWALL)
          IF(DS9.LT.1.5) LBEND  = LOR(LBEND ,LBWIRE)
          LBTR = LOR(ISHFTL(LBEND,4),LBSTRT)
          LBTR = LOR(LBTR,LBTREL)
          LBTR = LOR(LBTR,LBLFRT(LBLR+2))
          IWRK(IPTR   ) = IPHIT0
          IWRK(IPTR+ 1) = IPHIT9
          IWRK(IPTR+ 2) = MHIT
          WRK (IPTR+ 3) = PAR1
          WRK (IPTR+ 4) = PAR2
          WRK (IPTR+ 5) = PAR3
          WRK (IPTR+ 6) = SQRT(SIG)
          IWRK(IPTR+ 7) = ILAY0
          WRK (IPTR+ 8) = DS0
          WRK (IPTR+ 9) = SLOP0
          IWRK(IPTR+10) = ILAY9
          WRK (IPTR+11) = DS9
          WRK (IPTR+12) = SLOP9
          IWRK(IPTR+13) = LBSTRT
          IWRK(IPTR+14) = LBEND
          IWRK(IPTR+15) = LBTR
          I9 = IPTR + HLDTR - 1
          MTRK = MTRK + 1
          IPTR = IPTR + HLDTR
      ENDIF
      GOTO IZZZ04
17005 CONTINUE
      ITER = 0
      IF(DSPAR(IHIT0).LT.1.5 .AND. DSPAR(IHIT0+1).GT.5.) IHIT0 = IHIT0+100053900
      IF(DSPAR(IHIT9).LT.1.5 .AND. DSPAR(IHIT9-1).GT.5.) IHIT9 = IHIT9-100054000
      IF(
     - NITER.GT.0
     -)THEN
      DO 13008 IHIT=IHIT0,IHIT9
          HLBAR(IHIT) = 0
13008 CONTINUE
13009 CONTINUE
      ENDIF
16006 CONTINUE
      ASSIGN 17013 TO IZZZ06
      GOTO 17012
17013 CONTINUE
      IF(
     - MHIT.LT.LMTREL(13)
     -)THEN
          STAGSG = 10000000.
          IHITM0 = IHIT0 + 1
      GOTO 16007
      ENDIF
        CHISQ = 0.
        STAGS1 = 0.
        STGSL1 = 0.
        STGSL2 = 0.
        STGSR1 = 0.
        STGSR2 = 0.
        DCHIM1 = 0.
        IHITM1 = 0
      DO 13010 IHIT = IHIT0,IHIT9
      IF(
     - HLBAR(IHIT).EQ.0
     -)THEN
            X = HLYAR(IHIT)
            DSTAG = DSTAG0
            IF(hLAND(HLYAR(IHIT),hint(1)).NE.0) DSTAG =-DSTAG0 ! PMF 10/06/99: hland,hint
            Y = DSPAR(IHIT) + DSTAG
            F = FPAR(X)
            DCHI = Y - F
            RESAR(IHIT) = DCHI
            CHISQ = CHISQ + DCHI**2
      IF(
     - ABS(DCHI).GE.DCHIM1
     -)THEN
              DCHIM1 = ABS(DCHI)
              IHITM1 = IHIT
      ENDIF
      IF(
     - hLAND(HLYAR(IHIT),hint(1)).NE.0 ! PMF 10/06/99: hland,hint
     -)THEN
              STAGS1 = STAGS1 + DCHI
              DCHIL = DCHI + SWDEPL
              DCHIR = DCHI - SWDEPL
      ELSE
              STAGS1 = STAGS1 - DCHI
              DCHIL = DCHI - SWDEPL
              DCHIR = DCHI + SWDEPL
      ENDIF
            STGSL1 = STGSL1 + DCHIL
            STGSL2 = STGSL2 + DCHIL**2
            STGSR1 = STGSR1 + DCHIR
            STGSR2 = STGSR2 + DCHIR**2
      ENDIF
13010 CONTINUE
13011 CONTINUE
        SIG    =      CHISQ  / DEG
        SIGL   = STGSL2 / DEG
        SIGR   = STGSR2 / DEG
        STAGSG = AMIN1(SIGL,SIGR)
        STAGAV = STAGS1 / S0
      IF(
     - ITER.EQ.0
     -)THEN
          PAR10 = PAR1
          PAR20 = PAR2
          PAR30 = PAR3
          IHITM0 = IHITM1
      ENDIF
        YPMIN = 1000.
        XPMIN = 1000.
        IF(PAR1.NE.0.) XPMIN = -.5 * PAR2 / PAR1
        IF(XPMIN.GT.HLYAR(IHIT0) .AND. XPMIN.LT.HLYAR(IHIT9))
     ?    YPMIN = FPAR(XPMIN)
      IF(
     - STAGSG.LE.SIGLM .OR. MHIT.LE.LMTREL(13)
     -)THEN
      GOTO 16007
      ENDIF
      IF(
     - MHIT.LE.6 .AND. ABS(PAR1).GT.TRELLM(9)
     -)THEN
      GOTO 16007
      ENDIF
      IF(
     - YPMIN.LT. 100.
     -)THEN
      GOTO 16007
      ENDIF
      IF(
     - MHIT.GE.6.AND.ABS(PAR1).LT..010.AND.STAGSG.LT.TRELLM(14)*1.5
     -)THEN
          DCHI = RESAR(IHITM1)
      IF(
     - hLAND(HLYAR(IHITM1),hint(1)).NE.0 ! PMF 10/06/99: hland,hint
     -)THEN
            DCHIL = DCHI + SWDEPL
            DCHIR = DCHI - SWDEPL
      ELSE
            DCHIL = DCHI - SWDEPL
            DCHIR = DCHI + SWDEPL
      ENDIF
          DCHI = DCHIL
          IF(SIGR.GT.SIGL) DCHI = DCHIR
      IF(
     - DCHI**2*.33 .LT. STAGSG
     -)THEN
            SIGLM = AMAX1(STAGSG*1.01,SIGLM)
      GOTO 16007
      ENDIF
      ENDIF
        IDHITM = IABS(IHITM1-IHITM0)
        DDCHIM = DCHIM1
        IF(IHITM1.NE.IHIT0 .AND. IHITM1.NE.IHIT9)
     ?  DDCHIM = ABS(RESAR(IHITM1)-(RESAR(IHITM1-1)+RESAR(IHITM1+1))*.5)
      IF(
     - IDHITM.EQ.1
     -)THEN
      GOTO 16007
      ENDIF
      IF(
     - DDCHIM**2.LT.SIGLM*4.0
     -)THEN
      GOTO 16007
      ENDIF
      IF(
     - IHITM1-IHIT0 .EQ. 1
     -)THEN
          SL0   = HLYAR(IHITM1)*PAR1*2. + PAR2
          DDSP1 = ABS(DSPAR(IHIT0+1)+SL0    - DSPAR(IHIT0+2))
          DDSP2 = ABS(DSPAR(IHIT0  )+SL0*2. - DSPAR(IHIT0+2))
          IF(DDSP1 .LT. DDSP2) IHITM1 = IHIT0
      ELSE
      IF(
     - IHIT9-IHITM1 .EQ. 1
     -)THEN
            SL0   = HLYAR(IHITM1)*PAR1*2. + PAR2
            DDSP1 = ABS(DSPAR(IHIT9-1)-SL0    - DSPAR(IHIT9-2))
            DDSP2 = ABS(DSPAR(IHIT9  )-SL0*2. - DSPAR(IHIT9-2))
            IF(DDSP1 .LT. DDSP2) IHITM1 = IHIT9
      ENDIF
      ENDIF
        IF(ITER.NE.NITER) HLBAR(IHITM1) = 1
        ITER = ITER + 1
      IF(.NOT.(
     - ITER.GT.NITER
     -))GOTO 16006
16007 CONTINUE
      IF(
     - ITER.GT.0 .AND. STAGSG.LE.SIGLM
     -)THEN
        IF(HLBAR(IHIT0).NE.0) IHIT0 = IHIT0 + 1
        IF(HLBAR(IHIT0).NE.0) IHIT0 = IHIT0 + 1
        IF(HLBAR(IHIT9).NE.0) IHIT9 = IHIT9 - 1
        IF(HLBAR(IHIT9).NE.0) IHIT9 = IHIT9 - 1
        IF(IHIT9.LT.JHIT0) JHIT0 = IHIT9
        IF(IHIT0.GT.JHIT9) JHIT9 = IHIT0
      ENDIF
      GOTO IZZZ03
17012 CONTINUE
      S0 = 0.
      S1 = 0.
      S2 = 0.
      S3 = 0.
      S4 = 0.
      S5 = 0.
      S6 = 0.
      S7 = 0.
      DO 13012 IHIT = IHIT0,IHIT9
      IF(
     - HLBAR(IHIT).EQ.0
     -)THEN
          IX = HLYAR(IHIT)
          X  = IX
          DSTAG = DSTAG0
          IF(LAND(IX,1).NE.0) DSTAG =-DSTAG0
          Y = DSPAR(IHIT) + DSTAG
          X2 = X**2
          S1 = S1 + X
          S2 = S2 + X2
          S3 = S3 + X*X2
          S4 = S4 + X2**2
          S5 = S5 + Y*X2
          S6 = S6 + Y*X
          S7 = S7 + Y
          S0 = S0 + 1.
      ENDIF
13012 CONTINUE
13013 CONTINUE
      MHIT = S0 + .5
      IF(
     - MHIT.LT.3
     -)THEN
        SIG = TRELLM(12)**2
        PAR1 = 0.
        PAR2 = 0.
        PAR3 = 0.
        DEG = 1.
        S0  = 1.
      ELSE
      IF(
     - MHIT.LE.4
     -)THEN
          ZW1  = (S6*S0 - S1*S7)
          ZW2  = (S2*S0 - S1**2)
          PAR1   = 0.
          PAR2   = ZW1 / ZW2
          PAR3   =(S7 - PAR2*S1) / S0
          DEG = S0 - 2.
      ELSE
          F1 = 1. / S4
          XX12 = S3*F1
          XX13 = S2*F1
          YY1  = S5*F1
          XX22 = S2 - S3*XX12
          XX23 = S1 - S3*XX13
          YY2  = S6 - S3*YY1
          XX32 = S1 - S2*XX12
          XX33 = S0 - S2*XX13
          YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
            XX23 = XX23 / XX22
            YY2  = YY2  / XX22
            PAR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
            PAR2 = YY2 - XX23*PAR3
      ELSE
            XX33 = XX33 / XX32
            YY3  = YY3  / XX32
            PAR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
            PAR2 = YY3 - XX33*PAR3
      ENDIF
          PAR1 = YY1 - XX12*PAR2 - XX13*PAR3
          DEG = S0 - 3.
      IF(
     - MHIT.LT.6 .AND. ABS(PAR1).GT.TRELLM(9)
     -)THEN
            ZW1  = (S6*S0 - S1*S7)
            ZW2  = (S2*S0 - S1**2)
            PAR1   = 0.
            PAR2   = ZW1 / ZW2
            PAR3   =(S7 - PAR2*S1) / S0
            DEG = S0 - 2.
      ENDIF
      ENDIF
      ENDIF
        ILAY0 = HLYAR(IHIT0)
        WR0   = ILAY0
        DS0   = FPAR(WR0)
        SLOP0 = WR0*PAR1*2. + PAR2
        ILAY9 = HLYAR(IHIT9)
        WR9   = ILAY9
        DS9   = FPAR(WR9)
        SLOP9 = WR9*PAR1*2. + PAR2
        MDHIT = IHIT9-IHIT0 + 1 - MHIT
      IF(
     - ABS(PAR1).GT..05 .OR. (MHIT.LT.6 .AND. MDHIT.GT.0)
     -)THEN
          SIGLM = TRELLM(16)**2
      ELSE
          SIG1 = TRELLM(16)
          SIG2 = 0.
          SIG3 = 0.
          IF(DSMAX(ILAY0+1,IRING,1)-5. .LT. DS0) SIG2 = TRELLM(17)
          IF(DS0.LT.1.5) SIG3 = TRELLM(18)
          IF(DSMAX(ILAY9+1,IRING,1)-5. .LT. DS9) SIG2 = SIG2+TRELLM(17)
          IF(DS9.LT.1.5) SIG3 = SIG3 + TRELLM(18)
          SIGLM = SIG1**2 + SIG2**2 + SIG3**2
      ENDIF
        SIGSL = 0.
        SLRAT =  AMIN1(ABS(SLOP0+SLOP9)*.1, 1.0)
        IF(ABS(PAR1).LT..5 .AND. SLRAT .GT. 0.2)
     ?  SIGSL = (SLRAT*TRELLM(17))**2 + TRELLM(16)**2
        IF(SIGSL.GT.SIGLM) SIGLM = SIGSL
      GOTO IZZZ06
      END

C   07/06/96 606071909  MEMBER NAME  SMOPS    (S4)          FORTG1
      SUBROUTINE SMOPS(YI,Y,N)
      REAL YI(120),Y(120),A(500)
      INTEGER NR/0/
C
      NR=NR+1
      DO 10 I=1,N
   10 Y(I)=YI(I)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMPTEQ(Y,N)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,5)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,1)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,2)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,3)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
C     CALL SMOPER(Y,N,4)
C     IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,5)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,7)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,7)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMOPER(Y,N,6)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL LSQSPL(Y,N,A,3+(N-1)/2,CHDF)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
C     CALL SMOPER(Y,N,6)
C     IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
      CALL SMEQTP(Y,N)
      IF(NR.EQ.50) CALL HISTPR(Y,N,0.0,1.0)
C
C
  100 RETURN
      END

      SUBROUTINE KNTREL(HEARR,NUMTRK)
      IMPLICIT INTEGER*2 (H)
      COMMON/CHEADR/HEAD(17),HRUN,HEV
      COMMON/CADMIN/IEVTP,NREC,NRWRIT,NRERR
      COMMON/CBKPAT/HTRK(100)
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2))
      DIMENSION HEARR(1)
#include "cpatlm.for"
      EQUIVALENCE (IXBKK(40),IXITER),(IXBKK(39),MAXITR),(JJPR,IXBKK(38))
      EQUIVALENCE (IXBKK(37),MINHIT),(IXBKK(36),ICUT)
      INTEGER DATE(5), IDAY /0/
      DIMENSION NCNT1(127),NCNT2(127),IXREF0(127)
      DIMENSION JCLLA(20),NCLLA(20)
      DATA MSKTR1/Z7F/
      DATA MSKDSP/Z2000/
      DATA MAXTRK/100/
      DATA MKBDHT /Z600/
 458  FORMAT(' ',20(X,Z4))
 675  FORMAT('  ***** HIT LABEL MAY BE ZEROED **********')
 754            FORMAT('  HPFREE , HPLAST ',2I10)
 97           FORMAT(1X,30('+'),' KNTREL ERROR',I2,4I7)
 674  FORMAT('  **** NOT ENOUGH SPACE IN CWORK TO MOVE HIT LABEL *******
     $ , HPFREE, HPLAST , NO OF WORDS ',3I7)
      IF(
     - IDAY.EQ.0
     -)THEN
        CALL DAY2(DATE)
        IDAY = DATE(1)*1000 + DATE(2)
        IQJHTL = IBLN('JHTL')
        IQPATR = IBLN('PATR')
      ENDIF
      IPJHTL = IDATA(IQJHTL)
      NHITT = (HPTSEC(97) - HPTSEC(1)) / 4
      IPPATR = IDATA(IQPATR)
      NTR0  = IDATA(IPPATR+2)
      ITRBK = NTR0
      LTRBK = IDATA(IPPATR+3)
      IPTRBK = IPPATR + IDATA(IPPATR+1) + ITRBK*LTRBK
      HPFRE0 = HPFREE
      CALL SETSL(IXREF0(1),0,508,0)
      IF(
     - NTR.GT.0 .AND. NUMTRK.GT.0
     -)THEN
        LBEVTR = 0
        IEDTK  = 0
        ITR    = 0
        MAXTR0 = MIN0(MAXTRK,NUMTRK)
15000 CONTINUE
      IF(
     - IEDTK.LT.MAXTR0
     -)THEN
        IEDTK=IEDTK+1
          ITR=HEARR(IEDTK)
      IF(
     - ITRBK.GT.MAXTRK .OR. ITR.GT.MAXTRK
     -)THEN
      GOTO 15001
      ENDIF
      IF(
     - HNREL(ITR).GT.0
     -)THEN
            HPFREE = HPFRE0
            CALL FXYZ(ITR)
            NHIT = (HPHT9-HPHT0+1) / HLDHT
      IF(
     - NHIT.GT.3
     -)THEN
              HPTR0 = HPFREE
              HPTR9 = HPTR0 + 49
              HLDTR = 50
              HPFREE= HPTR9 + 1
      IF(
     - HPFREE.LE.HPLAST
     -)THEN
                IWRK(HPTR0+47)=0
                CALL XYFIT
      IF(
     - WRK(HPTR0+22).LT.GFP(2)
     -)THEN
                  RMIN = 150.
                  RMAX = 850.
      IF(
     - NTRLM.GT.0
     -)THEN
      DO 13000 I=1,NTRLM
      IF(
     - LMRTR(1,I).EQ.ITR
     -)THEN
                        RMIN = RLMTR(2,I)
                        RMAX = RLMTR(3,I)
      GOTO 13001
      ENDIF
13000 CONTINUE
13001 CONTINUE
      ENDIF
                  CALL PATROL(RMIN,RMAX)
      ENDIF
                RMSFIT = WRK(HPTR0+22)
      IF(
     - RMSFIT.GE.1000. .OR.
     ?             IWRK(HPTR0+23).LT.5 .AND. IMCERT.EQ.0
     -)THEN
                  HNREL(ITR) = 0
      ELSE
                  NHGDZ = 0
                  IDHTLB=IPJHTL*2-HPHL0+3
      DO 13002 IIP=HPHT0,HPHT9,HLDHT
                    IPHTLB=IWRK(IIP+2)
                    IPHTL=HDATA(IPHTLB+IDHTLB)
                IF(LAND(IPHTL,MKBDHT).EQ.0.AND.IPHTL.NE.0) IWRK(IIP+7)=8
                    IF(IWRK(IIP+7).LT.8) NHGDZ = NHGDZ + 1
13002 CONTINUE
13003 CONTINUE
      IF(
     - NHGDZ.LT.3
     -)THEN
                    HNREL(ITR) = 0
      ELSE
                    CALL ZRFIT
                    CRV  = ABS(WRK(HPTR0+24))
                    ZINT = ABS(WRK(HPTR0+30))
      IF(
     - IYBKK(14).NE.0 .AND. CRV.GT.YBKK(12) .AND.
     ?                 ZINT.GT.YBKK(15)
     -)THEN
                      KP=HPTR0
                      CSTH=WRK(KP+4)*WRK(KP+7)+WRK(KP+5)*WRK(KP+8)
                      CSTH=CSTH/SQRT((WRK(KP+4)**2+WRK(KP+5)**2)*
     *                          (WRK(KP+7)**2+WRK(KP+8)**2))
                      IF(CSTH.LT.YBKK(13)) HNREL(ITR) = 0
      ENDIF
      IF(
     - HNREL(ITR).GT.0
     -)THEN
                      ITRBK = ITRBK + 1
                      IXREF0(ITRBK) = ITR
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      IF(
     - NHTREG.LT.5
     -)THEN
                        ITRBK  = ITRBK  - 1
                        IPTRBK = IPTRBK - LTRBK
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ELSE
                KERROR = 2
                PRINT97,KERROR,NREC,HRUN,HEV,ITR
                PRINT 754,HPFREE,HPLAST
      GOTO 15001
      ENDIF
      ELSE
              KERROR = 1
              PRINT97,KERROR,NREC,HRUN,HEV,ITR
              HNREL(ITR)=0
      ENDIF
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      HPFREE=HPFRE0
      ENDIF
      NDIFF = IPTRBK - IPPATR - IDATA(IPPATR)
      CALL BCHM(IPPATR,NDIFF,IRET)
      IDATA(IPPATR+2) = ITRBK
      IF(
     - IMCERT.EQ.0 .AND. ITRBK.GT.0
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
        IDATA(IPPATR+4)=LBEVTR
        IDATA(IPPATR+ 6) = NHITUC
      ENDIF
      ITR = 0
15002 CONTINUE
      IF(
     - ITR.LT.NTR
     -)THEN
      ITR = ITR + 1
        NELM = HNREL(ITR)
      IF(
     - NELM.LE.0
     -)THEN
          NBYTE = (NTR-ITR)*2
          NTR = NTR - 1
      IF(
     - NBYTE.GT.0
     -)THEN
            CALL MVCL2(HNREL(ITR),0,HNREL(ITR+1),0,NBYTE) !PMF 28/06/99 MVCL -> MVCL2
            NBYTE = NBYTE * 9
            CALL MVCL2(HISTR(1,ITR),0,HISTR(1,ITR+1),0,NBYTE) !PMF 28/06/99 MVCL -> MVCL2
      ENDIF
          ITR = ITR - 1
      ENDIF
      GOTO 15002
      ENDIF
15003 CONTINUE
      RETURN
17000 CONTINUE
      JP     = HPTR0
      LBTRCK = 0
      IR1=0
      IR2=0
      IR3=0
      NTRKEL=HNREL(ITR)
      DO 13004 ITN=1,NTRKEL
        ITH=HISTR(ITN,ITR)
        ITH=IABS(ITH)
        IF(LAND(LBL(ITH),MSKDSP).NE.0)LBTRCK=LOR(LBTRCK,2048)
        ITH=IPCL(ITH)
      IF(
     - ITH.LE.24
     -)THEN
          IR1=1
      ELSE
      IF(
     - ITH.GT.48
     -)THEN
            IR3=1
      ELSE
            IR2=1
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(IR1.EQ.0)LBTRCK=LOR(LBTRCK,512)
      IF(IR1.NE.0.AND.IR3.NE.0.AND.IR2.EQ.0) LBTRCK=LOR(LBTRCK,1024)
      IF(CRV.GT..002) LBTRCK=LOR(LBTRCK,64)
      TGTH       = WRK(JP+29)
      Z0         = WRK(JP+30)
      CSTH       = 1. / SQRT(TGTH**2+1.)
      SNTH       = CSTH * TGTH
      WRK(JP+ 6) = WRK(JP+ 6)*TGTH + Z0
      WRK(JP+13) = WRK(JP+13)*TGTH + Z0
      WRK(JP+ 7) = WRK(JP+ 7) * CSTH
      WRK(JP+ 8) = WRK(JP+ 8) * CSTH
      WRK(JP+ 9) = SNTH
      WRK(JP+14) = WRK(JP+14) * CSTH
      WRK(JP+15) = WRK(JP+15) * CSTH
      WRK(JP+16) = SNTH
      LBEVTR=LOR(LBEVTR,LBTRCK)
      HTRK(ITR)=ITRBK
      IP0 = IPTRBK + 1
      IP9 = IPTRBK + LTRBK
      DO 13006 IP = IP0,IP9
        IDATA(IP) = 0
13006 CONTINUE
13007 CONTINUE
      IDATA(IPTRBK+ 1) = ITRBK
      IDATA(IPTRBK+ 2) = IPFAST+1
      IDATA(IPTRBK+ 3) = IDAY
      IP1 = HPTR0+3
      IP9 = IP1+29
      JP  = IPTRBK + 3
      DO 13008 IP=IP1,IP9
        JP = JP + 1
        IDATA(JP) = IWRK(IP)
13008 CONTINUE
13009 CONTINUE
      IDATA(IPTRBK+47)=IWRK(HPTR0+46)
      IDATA(IPTRBK+48)=LBTRCK
      NPCLL  = 0
      ICELL0 = -1
      NHTREG = 0
      IDHTLB = IPJHTL*2-HPHL0+3
      IP     = HPHT0
16000 CONTINUE
      IF(
     - IWRK(IP+10).GE.0 .AND. IWRK(IP+10).LE.2
     -)THEN
          LBBDHT = IWRK(IP+10)
          LBBDHT=LAND(LBBDHT,3)
          LBBDHT = ISHFTL(LBBDHT,9)
          IPHTLB = IWRK(IP+ 2)
          LBHIT0 = HWRK(IPHTLB)
          LBHIT1 = HWRK(IPHTLB+1)
          ITREL = IABS(IWRK(IP+ 8))
          JTREL = NTREL(ITREL)*2
          LBHIT = ITRBK*2
          IF(IWRK(IP+8).GT.0) LBHIT = LOR(LBHIT,256)
          IPHTL1 = IPHTLB + IDHTLB
          IPHTL2 = IPHTLB + IDHTLB +1
          LBHIT1 = HDATA(IPHTL1)
          LBHIT2 = HDATA(IPHTL1+1)
          RES=WRK(IP+13)
          RES=ABS(RES)/.2
          IRES=IFIX(RES)
          IF(IRES.GT.31) IRES=31
          IRES=ISHFTL(IRES,11)
          LBHIT=LBHIT+IRES
          LBREG = 0
      IF(
     - LAND(MSKTR1,ISHFTR(LBHIT1,1)).NE.ITRBK
     ¢      .OR.LAND(LBHIT1,MKBDHT).NE.0
     -)THEN
      IF(
     - LAND(LBHIT1,MKBDHT).NE.0
     -)THEN
      IF(
     - LBBDHT.EQ.0
     -)THEN
              LBREG = 1
              LBHIT1 = LBHIT
              IF(IWRK(IP+7).EQ.0) LBHIT1 = LOR(LBHIT1,1)
      ELSE
              ITLND=LAND(LBHIT1,MKBDHT)
      IF(
     - LBBDHT.LT.ITLND
     -)THEN
                LBHIT1 = LOR(LBHIT,LBBDHT)
                LBREG = 1
                IF(IWRK(IP+7).EQ.0) LBHIT1 = LOR(LBHIT1,1)
      ENDIF
      ENDIF
      ELSE
      IF(
     - LBHIT1.EQ.0
     -)THEN
              LBHIT1 = LOR(LBHIT,LBBDHT)
              LBREG = 1
              IF(IWRK(IP+7).EQ.0) LBHIT1 = LOR(LBHIT1,1)
      ELSE
      IF(
     - LBBDHT.EQ.0 .AND. LBHIT2.EQ.0
     -)THEN
                LBHIT2 = LOR(LBHIT,LBBDHT)
                LBREG = 1
                IF(IWRK(IP+7).EQ.0) LBHIT2 = LOR(LBHIT2,1)
      ENDIF
      ENDIF
      ENDIF
          HDATA(IPHTL1) = LBHIT1
          HDATA(IPHTL2) = LBHIT2
          NHTREG = NHTREG + 1
          ICELL = IWRK(IP+9)
      IF(
     - LBREG.NE.0
     -)THEN
      IF(
     - ICELL.EQ.ICELL0
     -)THEN
              NCLLA(JPCLL) = NCLLA(JPCLL) + 1
      ELSE
              ICELL0 = ICELL
              JPCLL = 0
      IF(
     - NPCLL.GT.1
     -)THEN
      DO 13010 I1=1,NPCLL
                  IF(ICELL.EQ.JCLLA(I1)) JPCLL = I1
13010 CONTINUE
13011 CONTINUE
      ENDIF
      IF(
     - JPCLL.EQ.0
     -)THEN
                NPCLL        = NPCLL + 1
                JPCLL        = NPCLL
                JCLLA(JPCLL) = ICELL
                NCLLA(JPCLL) = 1
      ELSE
                NCLLA(JPCLL) = NCLLA(JPCLL) + 1
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IP = IP + HLDHT
      IF(.NOT.(
     - IP.GT.HPHT9
     -))GOTO 16000
16001 CONTINUE
15004 CONTINUE
      IF(
     - NPCLL.GT.6
     -)THEN
        NHTMIN = 99999
      DO 13012 I1=1,NPCLL
      IF(
     - NCLLA(I1).LT.NHTMIN
     -)THEN
            NHTMIN = NCLLA(I1)
            JPCLL = I1
      ENDIF
13012 CONTINUE
13013 CONTINUE
        JCLLA(JPCLL) = JCLLA(NPCLL)
        NCLLA(JPCLL) = NCLLA(NPCLL)
        NPCLL = NPCLL - 1
      GOTO 15004
      ENDIF
15005 CONTINUE
      IPCLL  = IPTRBK + 33
      DO 13014 I1 = 1,NPCLL
        IPCLL  = IPCLL + 1
        IDATA(IPCLL) = JCLLA(I1)
13014 CONTINUE
13015 CONTINUE
      IPTRBK = IPTRBK + LTRBK
      GOTO IZZZ01
17002 CONTINUE
      NTR1  = ITRBK
      LPATR = IDATA(IPPATR)
      IPHL0 = IPJHTL*2 + 3
      ILDHL = IDATA(IPJHTL)*2 - 2
      IPHL9 = ILDHL + IPHL0 - 1
      CALL SETSL(NCNT1(1),0,1016,0)
      NHITUC = 0
      DO 13016 I=IPHL0,IPHL9,2
        IZW1  = HDATA(I  )
        ITRK1 = LAND(ISHFTR(IZW1,1),127)
      IF(
     - ITRK1.GT.0
     -)THEN
          IZW2  = HDATA(I+1)
          ITRK2 = LAND(ISHFTR(IZW2,1),127)
      IF(
     - ITRK2.LE.0
     -)THEN
            NCNT1(ITRK1) = NCNT1(ITRK1) + 1
      ELSE
            NCNT2(ITRK1) = NCNT2(ITRK1) + 1
            NCNT2(ITRK2) = NCNT2(ITRK2) + 1
      ENDIF
      ELSE
          NHITUC = NHITUC + 1
      ENDIF
13016 CONTINUE
13017 CONTINUE
      MTR = 0
      LTRBK = IDATA(IPPATR+3)
      IPTR0 = IPPATR + IDATA(IPPATR+1)
      IPTR9 = (NTR1-1)*LTRBK + IPTR0
      DO 13018 ITR=1,NTR1
      IF(
     - NCNT1(ITR).GE.5 .AND. NCNT1(ITR)+NCNT2(ITR).LT.LMPATR(1)
     -)THEN
          IPTR1 = 0
          JTR = MTR + 1
      DO 13020 IP=IPTR0,IPTR9,LTRBK
      IF(
     - IDATA(IP+1).EQ.JTR
     -)THEN
              IPTR1 = IP
      GOTO 13021
      ENDIF
13020 CONTINUE
13021 CONTINUE
          IF(IPTR1.NE.0 .AND.ABS(ADATA(IPTR1+14)).LT.1000.)NCNT1(ITR)=1
      ENDIF
      IF(
     - NCNT1(ITR).LT.5
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
          NCNT1(ITR) =-NCNT1(ITR)
          JTR = IXREF0(ITR)
          HNREL(JTR) = 0
      ELSE
          MTR = MTR + 1
      ENDIF
13018 CONTINUE
13019 CONTINUE
      IDATA(IPPATR+2) = MTR
      LENG  = IDATA(IPPATR+2)*IDATA(IPPATR+3) + IDATA(IPPATR+1)
      NDIFF = LENG - IDATA(IPPATR)
      IF(NDIFF.NE.0) CALL BCHM(IPPATR,NDIFF,IRET)
      GOTO IZZZ02
17004 CONTINUE
        JTR = MTR + 1
        ITRDIF = ITR - JTR
      DO 13022 I=IPHL0,IPHL9,2
          IZW1  = HDATA(I  )
          ITRK1 = LAND(ISHFTR(IZW1,1),127)
          IZW2  = HDATA(I+1)
          ITRK2 = LAND(ISHFTR(IZW2,1),127)
      IF(
     - ITRK2.EQ.JTR
     -)THEN
            HDATA(I+1) = 0
            ITRK2 = 0
            IND1  = ITRK1 + ITRDIF
            NCNT1(IND1) = NCNT1(IND1) + 1
            NCNT2(IND1) = NCNT2(IND1) - 1
      ENDIF
      IF(
     - ITRK1.EQ.JTR
     -)THEN
            HDATA(I ) = HDATA(I+1)
            HDATA(I+1) = 0
            ITRK1 = ITRK2
            ITRK2 = 0
      IF(
     - ITRK1.GT.0
     -)THEN
              IND1  = ITRK1 + ITRDIF
              NCNT1(IND1) = NCNT1(IND1) + 1
              NCNT2(IND1) = NCNT2(IND1) - 1
      ENDIF
      ENDIF
          IF(ITRK1.GT.JTR) HDATA(I  ) = HDATA(I  )-2
          IF(ITRK2.GT.JTR) HDATA(I+1) = HDATA(I+1)-2
13022 CONTINUE
13023 CONTINUE
      DO 13024 IP=IPTR0,IPTR9,LTRBK
      IF(
     - IDATA(IP+1).EQ.JTR
     -)THEN
            IPTR1 = IP
      GOTO 13025
      ENDIF
13024 CONTINUE
13025 CONTINUE
      IF(
     - IPTR1.GT.0
     -)THEN
          IPTR2 = IPTR1 + LTRBK
          NBYTE = (IPTR9 -IPTR2 + LTRBK) * 4
          IPTR9 = IPTR9 - LTRBK
      IF(
     - NBYTE.GT.0
     -)THEN
            CALL MVCL(IDATA(IPTR1+1),0,IDATA(IPTR2+1),0,NBYTE)
      DO 13026 IP=IPTR1,IPTR9,LTRBK
              IDATA(IP+1) = IDATA(IP+1) - 1
13026 CONTINUE
13027 CONTINUE
      ENDIF
      ENDIF
      GOTO IZZZ03
      END

C   10/10/84 807241744  MEMBER NAME  DRVCRD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRVCRD( INDEX, IPBPCH, ILBPCH )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   17/10/84 :  MAIN PROGRAM FOR DRAWING
C                                        VERTEX CHAMBER RAW-DATA
C                                        FROM  B P C H - BANK
C
C       MOD:   J. HAGEMANN   24/10/84 :  FOR FORMAT CHANGE
C       MOD:   J. HAGEMANN   22/04/85 :  CHANGES DUE TO NEW MICRO-
C                                        PROCESSOR ONLINE PROGRAM
C       MOD:   J. HAGEMANN   07/10/85 :  CHANGES DUE TO NEW MICRO-
C                                        PROCESSOR ONLINE PROGRAM
C  LAST MOD:   J. HAGEMANN   00/06/86 :  IMPROVED PRINTOUT
C
C     THE COORDINATES OF HITS ARE DRAWN FROM THE VERTEX CHAMBER RAW
C     DATA ( BPCH - BANK ). THE HITS FROM DIFFERENT WIRE ENDS
C     ( +Z, -Z PART OF CHAMBER) ARE DRAWN WITH CROSSES AND CIRCLES.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      INTEGER*4 CONVRT
C
      LOGICAL TBIT, FL18, FL22, FL24
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CJVCEL     VERTEX CHAMBER CELLS/WIRES
C-----------------------------------------------------------------------
C
      COMMON / CJVCEL / MCELL,MWIRE
C
C--------------------------- END OF MACRO CJVCEL -----------------------
C
C-----------------------------------------------------------------------
C                            MACRO CJVTXC     VERTEX CHAMBER
C-----------------------------------------------------------------------
C
      COMMON / CJVTXC / RVEC, ANG1, ANG2, DISTPW, FIRSTP, DISTW1,
     +                  ANGL, COSLOR, SINLOR,
     +                  ZRESV, ZMAXV, ZOFFV, ZNAMP, ZALV, TIMEV,
     +                  DRILOR(24), SNLORA(24), CSLORA(24),
     +                  DRVELO(24)
C
C--------------------------- END OF MACRO CJVTXC -----------------------
C
C
      COMMON/CWORK1/R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,EX,EY,COSPH,SINPH
     +             ,KZAMP
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION IHA(150), HBYTE(150)
C
C-----------------  C O D E  -------------------------------------------
C
C                            POINTER OF BANK (I*2)
      IPHVCR = IPBPCH*2
C                            LENGTH OF BANK  (I*2)
      ILHVCR = ILBPCH*2
C                            SET ACTUAL POINTER IN BANK
      IAPOIN = IPHVCR + 2
C
      ILSUMB = 0
C
C                  MAIN LOOP OVER EVERY MICROPROCESSOR-STRING
C
C                            GET LENGTH OF MICROPROCESSOR-STRING (I*2)
 1000 ILMPST = HDATA(IAPOIN + 1)/2
C                            GET VERSION NUMBER OF MICROPROCESSOR PRGM.
      IVERS  = HDATA(IAPOIN + 6)/1024
C                            CHECK IF MP-STRING IS CORRECT
         IF( HDATA(IAPOIN + ILMPST) .NE. -2 ) GO TO 2000
             GO TO 4000
 2000    IF( HDATA(IAPOIN + ILMPST) .NE. -1  .OR.
     *       HDATA(IAPOIN + ILMPST - 1) .NE. -2 ) GO TO 9000
C
C                            PROCESS MICROPROCESSOR-STRING
C                            ERRORWORD AND NUMBER OF HITS IN MP-STRING
 4000    IPHELP = IAPOIN + 1
*** PMF 10/06/99
***         IERR  = LAND(HDATA( IPHELP+2 ),32767)
         IERR  = hLAND(HDATA( IPHELP+2 ),hint(32767))
*** PMF (end)
         NHITS = HDATA( IPHELP+3 )
C                            CHECK IF GOOD DATA
         IF( IERR .NE. 0 .OR. NHITS .EQ. 0 ) GO TO 5000
C                            SET ACTUAL POINTER
            IPMPST = IPHELP + 5
C
            ILSUMM = 0
C
C                  MAIN LOOP TO PROCESS WIRESIDE-STRING
C                            GET WIRESIDE-STRING LENGTH
 4100       ILWSID = HDATA( IPMPST+1 )/2
C                  CHECK IF WIRESIDE STRING IS CORRECT
            IF( HDATA( IPMPST + ILWSID) .NE. -8 ) GO TO 4900
C                            PROCESS WIRESIDE-STRING
C                            SET ACTUAL POINTER
               IPWSID = IPMPST + 2
C                            GET WIRESIDE NUMBER AND WIRE NUMBER
               NWSID  = HDATA( IPWSID )
               NWIR   = (CONVRT(NWSID) + 1)/2
C                            CHECK IF LEGAL WIRE NUMBER
               IF( NWIR .GT. 0 .AND. NWIR .LT. 169 ) GO TO 4150
                  CALL DIAGIN(' ILLEGAL WIRE NUMBER DETECTED',1,NWIR)
                  GO TO 4800
C                            GET CELL NUMBER AND WIRE NUMBER WITHIN CELL
 4150          NCEL  = (NWIR - 1)/MWIRE
               NWRC  = NWIR - NCEL*MWIRE
C
C                            IF FLAG SET FOR EVEN WIRE : CONTINUE
               IF( DSPDTL(26) .AND. TBIT(NWRC,31) ) GO TO 4800
               IF( FL18 .AND. FL22 )  GO TO 4800
C
C                            SET GEOMETRY VALUES
               R     = DISTW1 + DISTPW*FLOAT(NWRC-1)
               FI    = ANG1 + ANG2*FLOAT(NCEL)
               IF( FI .LT. 0 )     FI = FI + TWOPI
               IF( FI .GT. TWOPI ) FI = FI - TWOPI
               COSPH  = COS(FI)
               SINPH  = SIN(FI)
               XWIRE  = R*COSPH
               YWIRE  = R*SINPH
               EEX    = -SINPH*CSLORA(NCEL+1) - COSPH*SNLORA(NCEV+1)
               EEY    =  COSPH*CSLORA(NCEL+1) - SINPH*SNLORA(NCEV+1)
C
C
               ISIDE  = LAND(NWSID,1)
C
               ILSUMH = 0
C
               DO 4170 I = 1, 150
                  HBYTE(I) = 0
 4170          CONTINUE
C
               IEND   = ILWSID - 3
C                            CONVERT BYTES IN WIRESIDE-STRING INTO I*2
               DO 4180 I = 1, IEND
                  IHB = I*2 - 1
                  ILB = I*2
C
*** PMF 10/06/99
***                  HBYTE(IHB) = LAND( HDATA( IPWSID + I ), 65280 )/256
***                  HBYTE(ILB) = LAND( HDATA( IPWSID + I ), 255 )
                  HBYTE(IHB) = hLAND(HDATA( IPWSID+ I ),hint(65280))/256
                  HBYTE(ILB) = hLAND(HDATA( IPWSID+ I ),hint(255))
*** PMF
C
 4180          CONTINUE
C                  MAIN LOOP TO PROCESS HIT
C
               IPHELP = 0
C
 4200          DO 4300 I = 1, 75
C
                  IHA(I) = HBYTE( IPHELP + I )
C
                  IF( IHA(I) .LT. 248 ) GO TO 4300
                     ILHIT = I
                     IENDO = I
                     GO TO 4400
 4300          CONTINUE
C
 4400          IF( HEAD(18) .GT. 18778 ) GO TO 4420
                  NCHA   = IHA( 1 )/2
                  IPED   = IHA( 2 ) - 2
                  IWIDTH = IHA( 3 )
                  GO TO 4425
 4420          NCHA   = IHA( 2 )/2
               IPED   = IHA( 3 ) - 2
               IF( HEAD(18) .GT. 19121 ) IPED = (IHA(3) + 2)/4
               IWIDTH = IHA( 1 ) - 4
 4425          IF( IWIDTH .LT. 2 ) GO TO 4600
                  ICHA1  = IHA( 4 )
                  ICHA2  = IHA( 5 )
                  IF( IVERS .LT. 5 ) GO TO 4430
                     ICHA1  = IHA( 5 )
                     ICHA2  = IHA( 6 )
C
C                            CHECK IF SUM OF CHANNELS > 0
 4430             IF( ICHA1 + ICHA2 - 2*IPED .LT. 1 ) GO TO 4450
C                            CHECK IF ONE OF THE 2 CHANNELS
C                            IS AN ENDMARK
                  IF( ICHA1 .GT. 247 .OR. ICHA2 .GT. 247 ) GO TO 4600
C                            GET DRIFT TIME
                  DRFTME = DRFTIM( NCHA, ICHA1, ICHA2, IPED, 0 )
C                            GET DRIFT WAY
                  DRFWAY = DRFTME*DRVELO( NCEL+1 )
C
C                            CALCULATE COORDINATES OF DRIFT TIME IN
C                            R-FI-VIEW
C
                  CALL xCALCOR( XWIRE, YWIRE, EEX, EEY, DRFWAY )! PMF 11/04/00 CALCOR->xCALCOR
C
                  IF( ISIDE .EQ. 0 ) GO TO 4440
                     CALL HITMRK( INDEX, -X1, Y1, 1.0, IDC )
                     CALL HITMRK( INDEX, -X2, Y2, 1.0, IDC )
                     GO TO 4450
 4440             CALL PLYGON( 9, 1.25, -X1, Y1, 1 )
                  CALL PLYGON( 9, 1.25, -X2, Y2, 1 )

C
C                            BRANCH FOR DOUBLE HITS
 4450             NCD = 2
                  IST = 3
                  IF( IVERS .GT. 4 ) IST = 4
C
                  DO 4500 I = 3, IENDO
                     IF( IHA(I+3) .GT. 247 ) GO TO 4600
C
                     IF( IHA(I+3) .NE. 240 ) GO TO 4480
                     IF( I+4 .GT. IENDO .OR. I+5 .GT. IENDO ) GO TO 4600
                     IF( IHA(I+4) .GT. 247 .OR. IHA(I+5) .GT. 247 )
     *                                                      GO TO 4600
                     IF( IHA(I+4) + IHA(I+5) - 2*IPED .LT. 1 )
     *                                                      GO TO 4480
                        DRFTME = DRFTIM( NCHA, IHA(I+4), IHA(I+5),
     *                                   IPED, NCD )
                        DRFWAY = DRFTME*DRVELO( NCEL+1 )
C
                        CALL xCALCOR( XWIRE, YWIRE, EEX, EEY, DRFWAY )! PMF 11/04/00 CALCOR->xCALCOR
C
                        IF( ISIDE .EQ. 0 ) GO TO 4460
                           CALL HITMRK( INDEX, -X1, Y1, 1.0, IDC )
                           CALL HITMRK( INDEX, -X2, Y2, 1.0, IDC )
                           GO TO 4470
 4460                   CALL PLYGON( 9, 1.25, -X1, Y1, 1 )
                        CALL PLYGON( 9, 1.25, -X2, Y2, 1 )
 4470                   GO TO 4500
 4480                NCD = NCD + 1
 4500             CONTINUE
C
 4600             ILSUMH = ILSUMH + ILHIT
C
                  IF( ILSUMH .GT. (ILWSID*2 - 6) ) GO TO 4800
C
                  IF( ILSUMH .EQ. (ILWSID*2 - 6) .OR.
     *                ILSUMH .EQ. (ILWSID*2 - 7) )  GO TO 4800
                     IPHELP = IPHELP + ILHIT
                     GO TO 4200
 4800 CONTINUE
C
C                            CHECK IF LAST WS-STRING
C
            ILSUMM = ILSUMM + ILWSID
C                            SAFETY CHECK IF END OF MP-STRING
            IF( ILSUMM .GT. (ILMPST-7) ) GO TO 5000
C                            LAST WIRESIDE-STRING ?
            IF( ILSUMM .EQ. (ILMPST-7) .OR. ILSUMM .EQ. (ILMPST-8) )
     *                                         GO TO 5000
               IPMPST = IPMPST + ILWSID
               GO TO 4100
 4900    CALL TRMOUT(80,' DRVCRD: ERROR IN BPCH WIRESIDE-STRING^')
 5000 CONTINUE
C
C                            CHECK IF LAST MP-STRING
C
            ILSUMB = ILSUMB + ILMPST
C                            SAFETY CHECK IF END OF BANK
            IF( ILSUMB .GT. ILHVCR-2 ) GO TO 9999
C                            LAST MP-STRING ?
            IF( ILSUMB .EQ. ILHVCR-2 .OR. ILSUMB .EQ. ILHVCR-3 )
     *                                               GO TO 9999
               IAPOIN = IAPOIN + ILMPST
               GO TO 1000
 9000    CALL TRMOUT(80,' DRVCRD: ERROR IN BPCH MICROPROCESSOR-STRING^')
 9999 CONTINUE
      RETURN
      END

C   10/04/84            MEMBER NAME  FORWRD   (JADEGS)      FORTRAN
      SUBROUTINE FORWRD
      IMPLICIT INTEGER*2 (H)
C
C DRAW TAGGING APPARATUS IN SIDE VIEWS. RUN NR IS CHECKED FOR VERSION
C
#include "cgraph.for"
#include "cgeo2.for"
#include "cgeo3.for"
#include "cdata.for"
      COMMON /CHEADR/ HEAD(108)
      DIMENSION ZSC(2)
      EQUIVALENCE (ZSC(1),ZMINBL)
C
      IF(HEAD(18).LT.6000) GO TO 1
      IF(HEAD(18).LT.13000) GO TO 641
C 1983 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
      CALL FW83
      GO TO 1000
641   CALL FWNEW
C 1981-2 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
      GO TO 1000
    1 CONTINUE
C 1979-80 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
      K = 1
      IF(LASTVW.EQ.11) K = 2
C      DO 1602  I = 1,4
C      IF(K.EQ.1) CALL FWCHM2(I,CHZ(2,I),CHX(2,I),CHZ(3,I),CHX(3,I),
C     $ CHZ(1,I),CHX(1,I))
C      IF(K.EQ.2) CALL FWCHM1(I,CHZ(1,I),CHY(1,I),CHZ(2,I),CHY(2,I))
C1602  CONTINUE
      DO 1603  I = 1,2
      CALL FWCAP1(ZSC(I),0.,I,K)
C     J = 2*I-1
C     CALL FWSCN1(ZMISC(I),0.,J)
C     J = J + 1
C     CALL FWSCN1(ZPLSC(I),0.,J)
1603  CONTINUE
C
1000  CONTINUE
      RETURN
      END

C   14/10/82 606071832  MEMBER NAME  BSCOMT   (S4)          FORTRAN77
      SUBROUTINE BSCOMT
C
C                      BBBB    OOO    SSS
C                      B   B  O   O  S
C                      B   B  O   O  S
C                      BBBB   O   O   SSS
C                      B   B  O   O      S
C                      B   B  O   O      S
C                      BBBB    OOO   SSSS
C
C
C
C
C     -----------------------------------------------------
C     BANK ORGANISATION SYSTEM                      - BOS -
C     -----------------------------------------------------
C           DYNAMIC STORAGE ORGANISATION WITH FORTRAN
C
C
C
C
C
C     AUTHOR  -  V.BLOBEL
C                II.INSTITUTE F. EXP.PHYSIK
C                UNIVERSITY OF HAMBURG   AND   DESY
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C         TABLE OF CONTENT                      ENTRY NAMES
C     -----------------------------------------------------
C
C
C
C     1.  INTRODUCTION
C                                               BINT
C     2.  CREATION OF BANKS
C                                               BCRE   BCHL
C                                               BSTR   BMVE
C     3.  LOCATING BANKS
C                                               BLOC   BPOS
C                                               BNXT   BDAR
C     4.  INPUT FROM CARDS
C                                               BREADC
C     5.  DEFINING SETS OF BANKS
C                                               BMLT
C     6.  PRINTING OF BANKS
C                                               BPRS   BMLT
C     7.  DELETING BANKS
C                                               BDLS   BDLM
C     8.  GARBAGE COLLECTION
C                                               BGAR   BGAC
C     9.  UNFORMATED INPUT/OUTPUT OF BANKS
C                                               BWRITE BREAD
C     10. SPECIAL SET OF BANKS
C                                               BSAT   BSAW
C                                               BSLT   BSLW
C     11. PRINTING STATISTIC AND A DUMP
C                                               BSTA   BDMP
C     12. OPTIMIZATION
C                                               BDEF   IBLN
C     13. APPLICATION PROGRAMS
C                                               UCOND  PCOND
C                                               QCOND
C                                               UTABL  PTABL
C                                               QTABL
C                                               UHIST  PHIST
C                                               QHIST  DHIST
C                                               UCORR  PCORR
C                                               USTOR  USTOS
C                                               PSTOR  DSTOR
C                                               TCOND  TTABL
C                                               THIST  TCORR
C                                               TSTOR  TTEXT
C                                               PTEXT
C
C
C
C
C
C
C
C
C
C     -----------------------------------------------------------------100011100
C     1.  INTRODUCTION
C
C     LARGE AMOUNT OF DATA ARE TO BE ANALYSED IN HIGH-ENERGY
C     PHYSICS EXPERIMENTS. DATA ON ONE EVENT CONSIST OF DATA
C     FROM SEVERAL SOURCES, E.G. TRACK CHAMBER, SHOWER COUNTER
C     AND SCALER. DURING THE ANALYSIS NEW DATA MAY BE ADDED
C     BY COMPUTATION, E.G. DATA ON SINGLE TRACKS. ALSO DATA
C     MAY BE COMPRESSED BY DATA REDUCTION PROGRAMS.
C     THE COMPLEXITY OF ANALYSIS DEPENDS VERY MUCH ON THE
C     ORGANISATION OF THE DATA IN STORAGE AND ON MASS STORAGE
C     DEVICES, E.G. TAPES. A FLEXIBLE DATA ORGANISATION
C     SIMPLIFIES THE ANALYSIS.
C     THE SYSTEM DESCRIBED HERE IS DESIGNED ACCORDING TO THE
C     NEEDS OF HIGH-ENERGY PHYSICS EXPERIMENTS. ALL DATA ARE
C     STRUCTURED IN SO CALLED BANKS OF VARIABLE LENGTH. DATA
C     IN ONE BANK REFER E.G. TO A SINGLE PARTICLE TRACK. A
C     BANK HAS TWO IDENTIFIERS NA AND NR, CALLED NAME AND
C     NUMBER. NORMALLY THE IDENTIFIER NA CONSISTS OF UP TO
C     FOUR CHARACTERS (LEFT ADJUSTED), WHILE IDENTIFIER NR
C     IS AN INTEGER.
C     ALL BANKS ARE STORED IN A SINGLE COMMON/BCS/IW(NSPACE).
C     AN INDEX IND IS ASSIGNED TO EACH BANK, WHERE IW(IND)=NW
C     CONTAINS THE NUMBER OF DATA WORDS IN THAT BANK. DATA
C     ARE STORED IN IW(IND+1) TO IW(IND+NW). IN ADDITION
C     THERE ARE THREE WORDS CONTAINING NAME, NUMBER AND A
C     POINTER ACCORDING TO THE FOLLOWING SCHEMA.
C
C         I      IW(I)
C     --------   -----
C     IND -  3   NA (NAME)
C     IND -  2   NR (NUMBER)
C     IND -  1   POINTER TO NEXT BANK OF SAME NAME
C     IND        NW = NUMBER OF DATA WORDS IN THE BANK
C     IND +  1   1.DATA WORD
C     IND +  2   2.DATA WORD
C     ...        ...
C     IND + NW   LAST DATA WORD
C
C     NO LIMITATIONS EXIST FOR THE LENGTH OF A SINGLE BANK OR
C     THE NUMBER OF BANKS, EXCEPT FOR THE TOTAL LENGTH OF
C     ALL BANKS.
C     THE NUMBER OF DIFFERENT NAMES MAY NEVER EXCEED 200.
C     OUTPUT OF SETS OF BANKS IS SIMPLY DONE BY SPECIFYING
C     ALL NAMES OF BANKS, BELONGING TO THE OUTPUT RECORD.
C     BANK RECORDS MAY CONTAIN MANY BANKS, BANK AFTER BANK WITHOUT GAPS.
C     THE MAIN ADVANTAGES OF THE SYSTEM ARE -
C             - EFFICIENT USE OF STORAGE
C             - EASY ADDITION OF NEW BANKS
C             - FLEXIBLE INPUT/OUTPUT
C             - PRINTOUT OF BANK STRUCTURE FOR TEST PURPOSES
C
C
C     LIBRARIES. THE SUBROUTINES OF THE BANK-SYSTEM ARE ON
C     THE DESY-NEWLIB LIBRARIES
C              DSN=F1EBLO.DAHEP   (LOAD)
C         AND  DSN=F1EBLO.DAHEPS  (SOURCE)
C     A ORDERED LIST OF ALL SUBROUTINES FOLLOWS.
C
C     STANDARD SUBROUTINES
C
C     BINT    BFMT
C     BCRE    BDAR    BDEF    BDLM     BDLM    BDMP    BGAR
C     BLOC    BPOS    BPRM    BPUT     BREADC  BSAC    BWRITE
C     FSWRIT  IBLN    MOVERX  READFF   UCOPY2  UWP
C
C     ALTERNATIVE SUBROUTINES
C
C     CCRE    CLOC    CREAD   CPOS     CCHL
C
C     SUBROUTINES FROM DESYLIB
C
C     ITRACE  NTIME   NOARG
C
C     APPLICATION SUBROUTINES
C
C     CCOR    DEFST   IAF     ITODA   PCOND   PCORR   PHIST
C     PTABL   PSTOR   PVERT   SORT4   UCOND   UHIST   UTABL
C     USTOS   VALLPTEXT
C
C
C     COMPATIBILITY WITH NON-IBM FORTRAN. FOR ALL SUBROUTINES
C     WITH NUMBERED RETURN STATEMENTS (RETURN 1, RETURN 2,
C     STATEMENTNRS AS ARGUMENTS) THERE ARE ALTERNATIVES WITH
C     FIRST LETTER C, WHICH AVOID THIS POSSIBILITY OF IBM-FORTRAN.
C
C     INITIALIZATION IS DONE BY THE FOLLOWING STATEMENTS.
C
C     COMMON/BCS/IW(NSPACE)
C     REAL RW(NSPACE)
C     EQUIVALENCE (IW(1),RW(1))
C        WHERE NSPACE = INTEGER CONSTANT
C
C               ------ ---- ---- ----
C     CALL BINT(NSPACE,NREC,NDMP,NADD)
C
C
C        WHERE NREC  = MAX.NO OF WORDS IN A RECORD (1000)
C              NDMP  = NR OF WORDS, PRINTED IN A DUMP (500)
C              NADD  = NR OF WORDS FOR LOW PRIORITY BANKS(0)
C
C
C     NOTE. HERE AND IN THE FOLLOWING INPUT ARGUMENTS HAVE
C     A LINE ABOVE, OUTPUT ARGUMENTS HAVE A LINE BELOW.
C     ARGUMENTS, WHICH ARE CHANGED BY THE PROGRAM, HAVE A LINE
C     ABOVE AND BELOW.
C
C     IF ILLEGAL POINTER ARE DETECTED BY THE BANK PROGRAM,
C     A DUMP CONTAINING RELEVANT STATUS INFORMATION AND
C     NDMP WORDS OF COMMON/BCS/ IS PRINTED.
C     NAMES WITH A CHARACTER '*' AS THE FOURTH CHARACTER
C     (E.G. HST*) ARE CONSIDERED AS SPECIAL. THE TOTAL
C     SPACE ATTRIBUTED TO THEM NEVER EXCEEDS NADD WORDS.
C
C     -----------------------------------------------------------------200022500
C     2.  CREATION OF BANKS
C
C     2.1 CREATE A BANK
C
C                   -- -- --
C     CALL BCRE(IND,NA,NR,NW,&S1,IER)
C               ---          --- ---
C
C        WHERE NA = NAME OF THE BANK
C              NR = NUMBER OF THE BANK
C              NW = NUMBER OF WORDS OF THE BANK (NW.GE.0)
C        IND = INDEX OF BANK (IER=1, IF BANK ALREADY EXISTING)
C        ALL WORDS OF THE BANK ARE SET = 0
C        RETURN 1 (IER=2) IF NOT ENOUGH SPACE
C
C     ALTERNATIVE
C     CALL CCRE(IND,NA,NR,NW,IER)
C        TEST IER=2 EQUIVALENT TO RETURN 1
C
C     2.2 CHANGE LENGTH OF A BANK
C
C
C               --  --
C     CALL BCHM(IND,NW,IER)
C                      ---
C
C        WHERE NW = CHANGE IN LENGTH OF THE BANK (NW.LT.0 VALID)
C        IND= INDEX OF THE BANK TO BE CHANGED IN LENGTH
C
C     IF THE CHANGE NW IS GREATER THAN -5, THE BANK IS MOVED TO THE
C     END (IF THE BANK IS NOT ALREADY THERE). FOR NW=0, THE BANK
C     IS MOVED TO THE END.
C
C
C     A BANK LENGTH OF AT LEAST NW WORDS IS OBTAINED BY THE FOLLOWING
C     CALL.
C               --- --
C     CALL BCHF(IND,NW,IER)
C                      ---
C        WHERE NW = MINIMUM LENGTH OF THE BANK
C        IND = INDEX OF THE BANK
C
C     THE BANK LENGTH IS CHANGED, IF THE ACTUAL LENGTH IS LESS
C     THAN NW.
C
C        IER = 1 WRONG INDEX IND IN ARGUMENT, OR BANK LENGTH WILL
C                BECOME  NEGATIVE
C        IER = 2 NOT ENOUGH SPACE
C
C
C
C     2.2 CHANGE LENGTH OF THE LAST CREATED BANK
C
C
C               --
C     CALL BCHL(NW,&S1)
C                  ---
C
C        WHERE NW = CHANGE IN LENGTH OF THE BANK (NW.LT.0 VALID)
C
C        RETURN 1, IF NOT ENOUGH SPACE
C
C      ALTERNATIVE
C      CALL CCHL(NW,IER)
C         TEST IER=2 EQUIVALENT TO RETURN 1
C
C     NOTE, THAT ONLY THE LENGTH OF THE LAST CREATED BANK CAN
C     BE CHANGED DIRECTLY (SEE CHAPTER 2.4).
C
C
C     2.3 STORE DATA IN A BANK
C
C               --- -- --
C     CALL BSTR(IND,JW,NW)
C
C
C     WHERE IND = INDEX
C           JW  = ARRAY TO BE STORED
C           NW  = LENGTH OF JW
C     JW(1) IS STORED IN IW(IND+1) ETC
C
C     2.4 MOVING A BANK
C
C
C               ---
C     CALL BMVE(IND,&S1)
C               --- ---
C        WHERE IND = INDEX OF BANK TO BE MOVED
C     THE BANK IS MOVED TO THE END OF THE USED STORAGE, IND
C     IS CHANGED. AFTER BMVE THE LENGTH OF THE BANK CAN BE CHANGED
C     BY BCHL.
C        RETURN 1, IF NOT ENOUGH SPACE
C
C     ALTERNATIVE
C     CALL CMVE(IND,IER)
C        TEST IER=2 EQUIVALENT TO RETURN 1
C
C     -----------------------------------------------------------------300029100
C     3.  LOCATING BANKS
C
C     3.1 LOCATE A BANK
C
C
C                   -- --
C     CALL BLOC(IND,NA,NR,&S1)
C               ---       ---
C
C        WHERE NA = NAME OF THE BANK
C              NR = NUMBER OF THE BANK
C        IND = INDEX OF THE BANK (NORMAL RETURN)
C        RETURN 1, IF BANK NOT EXISTING (IND=0)
C
C     ALTERNATIVE
C     CALL CLOC(IND,NA,NR)
C        TEST IND=0 EQUIVALENT TO RETURN 1
C
C     3.2 LOCATING ALL BANKS OF A GIVEN NAME
C

C     LOCATING OF ALL BANKS OF A GIVEN NAME IN ASCENDING ORDER
C     OF NR IS DONE IN THE FOLLOWING WAY.
C
C               ----
C     CALL BPOS(NAME)
C
C        WHERE NAME = NAME OF THE BANKS
C
C               ---
C     CALL BNXT(IND,&S1)
C               --- ---
C
C        IND = INDEX OF NEXT BANK OF THE SAME NAME
C        RETURN 1 AFTER LAST BANK
C
C     ALTERNATIVE
C     CALL CPOS(NAME)
C     CALL CNXT(IND)
C        TEST IND=0 EQUIVALENT TO RETURN 1
C
C     EXAMPLE FOR A LOOP ON ALL BANKS OF THE SAME NAME
C        CALL BPOS(NAME)
C     10 CALL BNXT(IND,&20)
C        . . .
C        GOTO 10
C     20 CONTINUE
C
C     BPOS/BNXT-LOOPS MAY BE NESTED. BNXT MAY ALSO BE USED
C     WITHOUT BPOS TO OBTAIN THE INDEX OF THE NEXT BANK OF
C     THE SAME NAME. THE INDEX IND IS A INPUT- AND OUTPUT-
C     ARGUMENT IN BNXT, EXCEPT FOR THE FIRST CALL AFTER THE
C     CALL OF BPOS, WHERE IT IS AN OUTPUT-ARGUMENT.
C     SEE ALSO REMARKS IN CHAPTER 12.
C
C
C     3.3 ALTERNATIVE TO BPOS/BNXT
C
C     LOCATING ALL BANKS OF A GIVEN NAME CAN ALSO BE DONE WITH BDAR.
C
C
C                ----        ----
C     CALL  BDAR(NAME,N,INDA,NLIM)
C                     - ----
C
C        WHERE NAME = NAME OF THE BANKS
C              NLIM = NR.OF WORDS OF ARRAY INDA( )
C        INDA( ) = ARRAY CONTAING N INDICES (N.LE.NLIM)
C
C     EXAMPLE, EQUIVALENT TO THE ONE IN 3.2
C        INTEGER INDA(20)
C        CALL BDAR(NAME,N,INDA,20)
C        DO 20 I=1,N
C        IND=INDA(I)
C        . . .
C     20 CONTINUE
C
C     -----------------------------------------------------------------400036900
C     4.  INPUT FROM CARDS
C
C     DATA CAN BE READ FROM CARDS IN FREE FORMAT OR IN A FORMAT GIVEN
C     ON THE CARD ITSELF, AND STORED IN BANKS. THE LAST 8 COLS OF THE
C     CARDS ARE NOT USED IN FREE FORMAT MODE.
C
C     CALL BREADC
C
C     DATA ARE READ FROM CARDS (UNIT 5) UNTIL DATA END OR A CARD WITH
C     ENDQ IS READ.
C
C     4.1 FREE FORMAT
C
C     READING A CARD OF THE TYPE
C     NAME A B C . . .
C     CREATES A BANK WITH NA = NAME, NR = 0. A SECOND CARD WITH THE
C     SAME NAME CREATES A BANK WITH NA = NAME, NR = 1 ETC.
C
C     $NAM N A B C . . .
C     CREATES A BANK WITH NA = $NAM, NR = N. A SECOND CARD WITH THE
C     SAME $NAM AND N IS NOT STORED.
C
C     THE BANK NAME NA CONSISTS OF THE FIRST FOUR CHARACTERS OF
C     NAME OR $NAM, RESP. THE FIRST
C     CHARACTER OF $NAM IS THE DOLLAR-SIGN. N, A, B, C, . . .
C     ARE CONSTANTS, INTEGER CONSTANTS WRITTEN WITHOUT A DOT (.),
C     REAL CONSTANTS WITH DOT (.) AND OPTIONALLY WITH EXPONENT.
C     CONTINUATION CARDS STARTING IMMEDIATELY WITH CONSTANTS ARE
C     ALLOWED. NON-NUMERIC CHARACTERS BETWEEN CONSTANTS ARE
C     IGNORED.
C
C     4.2 FORMATED
C
C     AFTER READING A CARD
C     *NAM N NW 'FORMAT
C     NW WORDS ARE READ ACCORDING TO THE GIVEN FORMAT FROM CONSECUTIVE
C     CARDS AND STORED IN A BANK WITH NA = *NAM, NR = N. THE FORMAT
C     SHOULD START WITH 1X (SEE EXAMPLE), TO ALLOW ECHO-PRINTOUT
C     WITHOUT LINE SKIPPING.
C
C     4.3 SPECIAL CARDS
C
C     ENDQ
C     BREADC RETURNS.
C
C     POFF
C     PRINTING OF CARDS IS SWITCHED OFF. IT MAY BE SWITCHED ON AGAIN
C     BY THE CARD
C     PON
C
C     UNIT N
C     THE NEXT CARDS ARE READ FROM UNIT N UNTIL DATA END, THEN AGAIN
C     FROM UNIT 5.
C
C     4.4 EXAMPLE FOR CARDS AND BANKS STORED
C
C     CONSTANTS 1.7 2.3 7 1.23E-4
C     $RUN 2769 1.520 16.0
C     0.7 2.0
C     *TIT 2000 5 '(1X,5A4)
C      PI+ PI+ PI- PI- PI0
C     ENDQ
C
C     BANKS STORED
C
C     NAME             CONS   $RUN   *TIT
C     NUMBER              0   2769   2000
C     NR.OF WORDS         4      4      5
C
C     1.DATA WORD       1.7  1.520   PI+
C     2.DATA WORD       2.3   16.0   PI+
C     3.DATA WORD         7    0.7   PI-
C     4.DATA WORD   1.23E-4    2.0   PI-
C     5.DATA WORD                    PI0
C
C     INDICES ARE OBTAINED BY
C     CALL BLOC(IND,'CONS',0,&S1)
C     CALL BLOC(IND,'$RUN',2769,&S1)
C     CALL BLOC(IND,'*TIT',2000,&S1)   RESP.
C
C     -----------------------------------------------------------------500045000
C     5.  DEFINING SETS OF BANKS
C
C     DEFINITION. THE SET B(LIST) IS THE SET OF ALL BANKS WITH ALL
C     NAMES, APPEARING IN THE ARRAY LIST.
C
C     A SET  B(LIST) IS DEFINED BY THE FOLLOWING STATEMENT.
C
C               - ----
C     CALL BMLT(N,LIST)
C
C
C        WHERE LIST = ARRAY OF N NAMES
C
C     EXAMPLE
C
C     CALL BMLT(2,'HEADGEOM')
C
C     -----------------------------------------------------------------600046800
C     6.  PRINTING OF BANKS
C
C     6.1 PRINT A SINGLE BANK
C
C               -- --
C     CALL BPRS(NA,NR)
C
C
C        WHERE NA = NAME
C              NR = NUMBER OF BANK TO BE PRINTED
C
C     6.2 PRINT A SET OF BANKS
C
C     CALL BPRM
C
C     ALL BANKS OF THE PREVIOUS DEFINED SET B(LIST) ARE PRINTED.
C
C     THE PRINTING FORMAT OF EACH WORD IS CHOSEN AUTOMATICALLY
C     (TEXT, INTEGER, REAL), NOT ALWAYS CORRECT.
C
C     -----------------------------------------------------------------700048900
C     7.  DELETING BANKS
C
C     7.1 DELETE A SINGLE BANK
C
C
C               -- --
C     CALL BDLS(NA,NR)
C
C
C        WHERE NA = NAME
C              NR = NUMBER OF BANK TO BE DELETED
C
C     7.2 DELETE A SET OF BANKS
C
C     CALL BDLM
C
C     ALL BANKS OF THE PREVIOUS DEFINED SET B(LIST) ARE DELETED.
C
C     A DELETED BANK IS NO LONGER ACCESSIBLE BY A CALL BLOC, ALTHOUGH
C     IT IS STILL IN STORAGE UNTIL THE NEXT GARBAGE COLLECTION.
C
C     -----------------------------------------------------------------800051100
C     8.  GARBAGE COLLECTION
C
C     IN A GARBAGE COLLECTION THE ACTIVE (NOT DELETED) BANKS ARE
C     SHIFTED IN STORAGE, IF THERE ARE BANKS DELETED.
C
C
C
C     CALL BGAR(IGA)
C               ---
C
C        IGA = 0 NO GARBAGE COLLECTION DONE (IF NO BANKS WERE DELETED)
C        IGA = 1 GARBAGE COLLECTION DONE
C
C
C                   --
C     CALL BGAC(IGA,NW)
C               ---
C
C        WHERE NW = NR.OF WORDS OF A NEW BANK
C     NO GARBAGE COLLECTION IS DONE, IF THERE IS SPACE ENOUGH
C     FOR AN ADDITIONAL BANK WITH NW WORDS
C
C     WARNING. BECAUSE IN A GARBAGE COLLECTION, SOME BANKS (ALL BANKS
C     BEHIND DELETED BANKS) ARE SHIFTED, THE INDICES OF THE BANKS
C     CHANGE. AUTOMATIC GARBAGE COLLECTIONS ARE DONE IN THE INPUT-
C     OUTPUT ROUTINES (SEE 9.)
C
C     -----------------------------------------------------------------900053900
C     9.  UNFORMATED INPUT/OUTPUT OF BANKS
C
C     9.1 WRITING SETS OF BANKS
C
C
C
C                 ---
C     CALL BWRITE(IUN)
C
C     ALL BANKS OF THE PREVIOUS DEFINED SET  B(LIST) ARE WRITTEN ON
C     UNIT IUN. BECAUSE THE BANKS HAVE TO BE STORED CONSEC. IN
C     STORAGE BEFORE WRITING, THEY HAVE TO BE SHIFTED IN STORAGE.
C     IF NECESSARY, A GARBAGE COLLECTION IS DONE.
C     THE BANKS ARE NOT WRITTEN, IF THE TOTAL RECORD LENGTH IS LARGER
C     THAN NREC (SEE INTRODUCTION).
C
C     THE ORDER OF THE BANKS IN THE RECORD IS THE SAME AS WITHIN LIST,
C     BANKS WITH THE SAME NAME IN ASCENDING ORDER OF NUMBER.
C     THE RECORD CONSISTS OF N + 1 WORDS, WHERE
C     FIRST WORD IN RECORD   = N
C     NEXT WORD              = NAME
C     NEXT WORD              = NUMBER OF FIRST BANK
C     NEXT WORD              = POINTER
C     NEXT WORD              = NR.OF WORDS OF THE FIRST BANK
C     ETC.
C
C
C     9.2 READING
C
C                ---
C     CALL BREAD(IUN,&S1,&S2)
C                    --- ---
C
C     A RECORD IS READ FROM UNIT IUN (&S1 ERROR EXIT, &S2 END EXIT).
C     THE BANKS CONTAINED IN THE RECORD ARE STORED. IF BANKS WITH THE
C     SAME IDENTIFIERS ARE ALREADY EXISTING, THEY ARE DELETED.
C     A GARBAGE COLLECTION IS DONE AUTOMATICALLY.
C     IF THERE IS NOT ENOUGH SPACE FOR A RECORD OF NREC WORDS (SEE
C     INTRODUCTION), THE PROGRAM STOPS.
C
C     ALTERNATIVE
C     CALL CREAD(IUN,IER)
C        TEST IER=1 EQUIVALENT TO RETURN 1
C        TEST IER=2 EQUIVALENT TO RETURN 2
C
C
C     9.3 ALTERNATIVE FOR BWRITE/BREAD
C
C     INPUT-OUTPUT IS ALSO POSSIBLE WITH USER-WRITTEN SUBROUTINES IN
C     USER-CONTROLLED RECORDS.
C
C
C
C     CALL BOUTP(N,INIW)
C                - ----
C
C        THE N WORDS IW(INIW) TO IW(INIW+N-1) CONTAIN ALL BANKS
C        OF THE PREVIOUS DEFINED SET B(LIST).
C        N=0, IF RECORD TOO LARGE.
C
C
C               - --
C     CALL BINP(N,AR)
C
C
C        WHERE AR( ) = ARRAY OF N WORDS, CONTAINING BANKS.
C        THE BANKS CONTAINED IN THE ARRAY ARE STORED.
C
C     THE FOLLOWING STATEMENTS ARE EQUIVALENT
C
C     OUTPUT      CALL BWRITE(IUN)
C
C     ALTERNATIVE CALL BOUTP(N,INIW)
C                 IF(N.NE.0) WRITE(IUN) N,(IW(INIW+I-1),I=1,N)
C
C     INPUT       CALL BREAD(IUN,&S1,&S2)
C
C     ALTERNATIVE READ(IUN,ERR=&S1,END=&S2) N,(AR(I),I=1,N)
C                 CALL BINP(N,AR)
C
C     ----------------------------------------------------------------1000062000
C     10. SPECIAL SET OF BANKS
C
C     FOR THE USE IN AN EVENT-BY-EVENT PROCESSING A SPECIAL LIST
C     OF BANK NAMES IS SUPPORTED BY THE SYSTEM. THIS LIST CONTAINS
C     ALL NAMES OF BANKS BELONGING TO THE CURRENT EVENT. EACH
C     NAME HAS ASSOCIATED A MARKER, WITH A VALUE =1, IF BANKS
C     WITH THIS NAME SHOULD BE WRITTEN IN THE OUTPUT RECORD.
C     AFTER INPUT (BREAD/BINP) THE SPECIAL LIST CONSISTS OF
C     ALL NAMES OF BANKS JUST READ IN, WITH MARKER =1.
C     THE LIST CAN BE UPDATED DURING EVENT PROCESSING.
C
C     10.1 UPDATING THE SPECIAL LIST
C
C
C                - ----
C      CALL BSAT(N,LIST)
C
C                - ----
C      CALL BSAW(N,LIST)
C
C
C         WHERE LIST( ) = ARRAY OF N NAMES
C
C     IN BOTH CASES THE NAMES ARE ADDED TO THE SPECIAL LIST
C     (IF NOT ALREADY PRESENT), AND THE MARKER IS SET
C     =0 FOR BSAT AND =1 FOR BSAW.
C
C
C
C     10.2 DEFINING THE SET OF BANKS
C
C     CALL BSLT
C
C     CALL BSLW
C
C     THE SET B(LIST) IS DEFINED AS THE SET OF ALL NAMES OF THE
C     SPECIAL LIST FOR BSLT, AND AS THE SET OF ALL NAMES OF THE
C     SPECIAL LIST WITH MARKER =1 FOR BSLW.
C
C
C
C     10.3 EXAMPLE
C
C     THIS EXAMPLE EXPLAINS THE TYPICAL INPUT/OUTPUT -
C     PROCEDURE IN AN EVENT-BY-EVENT PROCESSING. ONE EVENT IS
C     READ IN BY BREAD. BY COMPUTATION NEW BANKS ARE CREATED.
C     SOME OF THESES BANKS SHOULD BE WRITTEN , BUT ALL BANKS
C     HAVE TO BE DELETED AFTER PROCESSING THE EVENT.
C
C
C     C     INPUT
C        10 CALL BREAD(IN-UNIT,&30,&40)
C     C
C     C     COMPUTATION
C           . . .
C           . . .
C     C
C     C      BANKS, WHICH ARE CREATED AND WHICH SHOULD NOT BE WRITTEN
C           CALL BSAT(NT,NAMT)
C
C     C      BANKS, WHICH ARE CREATED AND WHICH SHOULLD BE WRITTEN
C           CALL BSAW(NW,NAMW)
C
C     C     DECIDE ON OUTPUT FOR THIS EVENT
C           IF(.NOT.OUTPUT) GOTO 20
C
C     C
C     C     OUTPUT
C           CALL BSLW
C           CALL BWRITE(OUT-UNIT)
C     C
C     C     DELETE ALL EVENT-BANKS
C        20 CALL BSLT
C           CALL BDLM
C           GOTO 10
C     C     READ ERROR
C        30 WRITE(. . .)
C           GOTO 10
C     C     END OF DS
C        40 WRITE(. . .)
C           . . .
C
C
C     ----------------------------------------------------------------1100070400
C
C     11.   PRINTING STATISTIC AND A DUMP
C
C     A FINAL STATISTIC ON THE SYSTEM PERFORMANCE IS PRINTED BY
C
C     CALL BSTA
C
C
C
C     A DUMP CONTAINING RELEVANT STATUS INFORMATION AND NDMP
C     WORDS OF THE COMMON/BCS/IW(NSPACE) IS PRINTED BY
C
C     CALL BDMP
C
C     AND THE PROGRAM IS STOPPED.
C
C     ----------------------------------------------------------------1200072100
C
C     12.   OPTIMIZATION
C
C
C     LOCATING BANKS BY CALLS TO BLOC AND BPOS/BNXT IS DONE BY
C     FAST ALGORITHMS, BUT OF COURSE SOME TIME IS SPENT IN
C     THESE SUBROUTINES. HOWEVER, CALLS TO BLOC AND BPOS/BNXT
C     CAN BE REPLACED BY SOME FORTRAN-STATEMENTS, AVOIDING
C     THE SAVING AND RESTORING OF REGISTERS ETC IN THE
C     CALL/RETURN PROCEDURE.
C     THE METHOD USED FOR THE POINTERS TO BANKS IS AS FOLLOWS.
C     AT ANY TIME THE FIRST 200 WORDS OF THE COMMON /BCS/
C     CONTAIN THE INDICES FOR THE FIRST BANK OF EACH NAME.
C     THE ASSIGNMENT OF A NAME TO A LOCATION IS NEVER CHANGED
C     DURING PROGRAM EXECUTION. NORMALLY THE ASSIGNMENT IS DONE
C     IN THE ORDER OF APPEARENCE OF NAMES, BUT THE ASSIGNMENT
C     CAN ALSO BE FIXED AFTER INITIALIZATION OF THE SYSTEM
C     (AFTER CALL BINT) BY THE CALL
C                  - ----
C        CALL BDEF(N,LIST)
C           WHERE LIST( ) = ARRAY OF N NAMES
C
C     THE FIRST NAME OF THE ARRAY (LIST(1)) IS ASSIGNED TO
C     IW(1), THE SECOND TO IW(2) ETC.
C
C     EXAMPLE
C        CALL BDEF(3,'HEADTITLDATA')
C        CALL BDEF(2,'GEOMSHOW')
C
C     ASSUME THAT THE INDEX OF THE FIRST BANK WITH NAME 'GEOM'
C     IS NEEDED. THIS INDEX IS STORED IN IW(4).
C
C            IND=IW(4)
C            IF(IND.EQ.0) GOTO 10
C     C      USE IND
C            . . .
C            GOTO 20
C     C      NO BANK WITH NAME 'GEOM' EXISTS
C         10 CONTINUE
C
C     THE LOCATION ASSIGNED TO A NAME CAN ALSO BE OBTAINED
C     USING THE FUNCTION IBLN.
C               ----
C        I=IBLN(NAME)
C        -
C        IW(I) CONTAINS THE INDEX OF THE FIRST BANK WITH THE
C        THE GIVEN NAME OR 0, IF NO BANK IS EXISTING.
C
C     EXAMPLE
C        I=IBLN('GEOM')
C     WOULD YIELD I=4 IN THE PREVIOUS EXAMPLE.
C
C     A FAST (HASH) ALGORITHM IS USED IN THE FUNCTION IBLN,
C     WITH EXECUTION TIME NEARLY INDEPENDENT FROM THE TOTAL
C     NUMBER OF EXISTING NAMES.
C
C     ALL BANKS OF THE SAME NAME ARE CONNECTED BY (FORWARD)
C     POINTERS, STORED IN IW(IND-1) FOR A BANK WITH INDEX IND.
C     THE ORDER OF THE BANKS IS IN ASCENDING NUMBER. FROM A
C     GIVEN BANK WITH INDEX IND, THE NEXT BANK OF THE SAME
C     NAME CAN BE OBTAINED BY THE FOLLOWING STATEMENT.
C
C         IND=IW(IND-1)
C         IF(IND.EQ.0) GOTO 10
C     C   USE IND
C         . . .
C         GOTO 20
C     C   NO FURTHER BANK OF THE SAME NAME
C      10 CONTINUE
C
C     THUS LOCATING OF THE NEXT BANK OF A GIVEN NAME IS
C     ALWAYS FAST, BUT E.G. LOCATING ONLY THE LAST OF
C     MANY BANKS OF THE SAME NAME IS SLOW.
C
C     THE FOLLOWING EXAMPLE SHOWS THE REPLACEMENT OF THE
C     BPOS/BNXT USE BY SOME FORTRAN-STATEMENTS.
C
C     EXAMPLE
C
C         CALL BPOS(NAME)                 IND=IBLN(NAME)+1
C      10 CALL BNXT(IND,&20)           10 IND=IW(IND-1)
C         . . .                           IF(IND.EQ.0) GOTO 20
C         . . .                           . . .
C         . . .                           . . .
C         GOTO 10                         GOTO 10
C      20 CONTINUE                     20 CONTINUE
C          . . .                           . . .
C
C     NOTE, THAT ALSO THE USE OF IBLN CAN BE AVOIDED BY USING
C     BDEF AS EXPLAINED ABOVE.
C
C
C
C     ----------------------------------------------------------------1300081500
C     13.  APPLICATION PROGRAMS
C
C     THE SUBROUTINE DESCRIBED HERE USE BANK STORAGE OF LOW
C     PRIORITY. THEY CAN BE USED FOR COUNTING, HISTOGRAMMING,
C     STORING OF VECTORS ETC. AND MAY BE USEFUL IN THE TESTING
C     PHASE OF LARGE PROGRAMS.
C     THE TOTAL NUMBER OF WORDS USED IN THE BANK COMMON /BCS/ CAN
C     NEVER EXCEED NADD WORDS (NADD IS AN ARGUMENT OF BINT).
C     THE SUBROUTINES START WITH A LETTER U FOR A NEW ENTRY, AND
C     WITH A LETTER P FOR PRINTOUT. PRINTOUT CAN ALSO BE DONE FOR
C     ALL SUBROUTINES BY PALL.
C
C     CALL PALL
C        PRINTOUT FOR ALL SUBROUTINES
C
C     THE ARGUMENT N IN THE CALLS SHOULD ALWAYS BE A POSITIVE
C     INTEGER WITH LESS THAN 9 DIGITS.
C
C
C     13.1 COUNT IN A 32768 * 32768 ARRAY
C
C                - -
C     CALL UCOND(I,J)
C        INCREASE COUNT IN ELEMENT I,J BY ONE.
C        0 .LE. I .LE. 32767  AND 0 .LE. J .LE. 32767
C
C     CALL PCOND
C        PRINT ALL ELEMENTS .NE. 0. ALL BANKS USED ARE DELETED.
C
C                - -
C     CALL QCOND(I,J,NR)
C                    --
C        WHERE I,J = INDICES OF ELEMENT
C               NR = NUMBER OF COUNTS IN ELEMENT
C
C     BANKS (CON*,IJ) OF LENGTH 8(+4) ARE USED, WHERE IJ IS CALCULATED
C     FROM I AND J.
C
C     13.2   COUNT IN A 256 * 16 ARRAY
C
C                - - -
C     CALL UTABL(N,I,J)
C        INCREASE COUNT IN ELEMENT I,J BY ONE.
C        0 .LE. I .LE. 255  AND  0 .LE. J .LE. 15.
C        MAXIMUM COUNT IN ONE ELEMENT IS 65535.
C
C                -
C     CALL PTABL(N)
C        THE I/J ARRAY NUMBER N IS PRINTED. FOR N=0 ALL ARRAYS
C        ARE PRINTED.
C
C                - -
C     CALL QTABL(N,I,AR)
C                    --
C        WHERE AR( ) = ARRAY OF LENGTH 16 CONTAINING THE COUNTS
C                      IN THE I-ROW OF ARRAY NUMBER N.
C
C     A BANK (TAB*,N*16+I/16) OF LENGTH 128(+4) IS USED FOR EACH
C     FILLED 16 * 16 SUBARRAY.
C
C
C     13.3 HISTOGRAM
C
C                - -
C     CALL UHIST(N,X)
C        ADD NEW ENTRY X INTO HISTOGRAM N WITH 100 BINS. THE BIN SIZE
C        IS CHOOSEN AUTOMATICALLY, UNLESS DHIST IS USED.
C
C                - -- --
C     CALL DHIST(N,XL,XH)
C        FOR HISTOGRAM N THE VALUES XL AND XH ARE DEFINED AS LOWER
C        AND UPPER LIMITS, RESP.. (MUST BE CALLED BEFORE UHIST).
C
C                -
C     CALL PHIST(N)
C        THE HISTOGRAM N IS PRINTED, TOGETHER WITH MEAN VALUES ETC.
C        FOR N=0 ALL HISTOGRAMS ARE PRINTED.
C
C                -
C     CALL QHIST(N,AR)
C                  --
C
C        WHERE AR( ) = ARRAY OF LENGTH 115 FOR CONTENT OF
C        HISTOGRAM N (SEE BELOW).
C
C        I               AR(I)
C
C        1 . . . 100     CONTENT OF HISTOGRAM BINS
C        101             NR OF ENTRIES (TOTAL)
C        102             LOWEST BIN LEFT EDGE
C        103             BIN SIZE
C        104             NR OF ENTRIES OUTSIDE LOW
C        105             NR OF ENTRIES OUTSIDE HIGH
C        106             MIMIMUM VALUE OF X
C        107             MAXIMUM VALUE OF X
C        108             MEAN VALUE
C        109             MEDIAN (50 PC VALUE)
C        110             STANDARD DEVIATION
C        111                   . . .        FROM QUANTILES
C        112             QUANTILES   16 PC
C        113                . . .    84 PC
C        114                . . .   2.3 PC
C        115                . . .  97.7 PC
C
C     A BANK (HST*,N) OF LENGTH 120(+4) IS USED FOR EACH HISTOGRAM.
C
C
C     13.4   CORRELATION PLOT
C
C                - - -
C     CALL UCORR(N,Y,X)
C        ADD NEW ENTRY Y,X TO CORRELATION PLOT N WITH
C        50 * 100 BINS. BIN SIZE IS ALWAYS CHOOSEN AUTOMATICALLY.
C
C                -
C     CALL PCORR(N)
C        THE CORRELATION PLOT N IS PRINTED ON ONE PAGE TOGETHER
C        WITH PROJECTIONS, MEAN VALUES AND THE CORRELATION PARAMETER.
C        BINS WITH CONTENT .NE. 0 ARE PRINTED AS A X. FOR N=0
C        ALL CORRELATION PLOTS ARE PRINTED.
C
C     A BANK (COR*,N) OF LENGTH 380(+4) IS USED FOR EACH
C     CORRELATION PLOT.
C
C
C
C     13.5   STORE VECTORS
C
C                - -- ----
C     CALL USTOR(N,AR,NDIM)
C        STORE VECTOR AR(1) . . . AR(NDIM) IN STORAGE N. THE
C        ARGUMENT NDIM SHOULD ALWAYS BE THE SAME FOR A GIVEN
C        STORAGE N.
C
C     NOTE. USTOR IS AN ENTRY OF USTOS. IF USTOS IS NOT CALLED,
C     USE A STATEMENT
C        EXTERNAL USTOS
C
C                - -- -- -- --
C     CALL USTOS(N,A1,A2,A3,A4)
C        STORE VECTOR A1, . . . IN STORAGE N. THE NUMBER OF ELEMENTS
C        IN A VECTOR MAY BE BETWEEN 1 AND 4 (VARIABLE NR OF ARGUMENTS
C        ALLOWED), BUT SHOULD ALWAYS BE THE SAME FOR A GIVEN
C        STORAGE N.
C
C     THE NUMBER OF VECTORS STORED IN A STORAGE IS LIMITED TO 100.
C     THIS LIMIT CAN BE CHANGED BY DSTOR.
C
C                ---
C     CALL DSTOR(LIM)
C        THE LIMIT ON THE NR OF VECTORS IS SET TO LIM.
C
C                -
C     CALL PSTOR(N)
C        THE VECTORS STORED IN STORAGE N ARE PRINTED. FOR N=0
C        THE VECTORS OF ALL STORAGES ARE PRINTED.
C
C     A BANK (STO*,N) IS USED FOR EACH STORAGE. THE STORAGE IS USED
C     AS FOLLOWS.
C
C     INDEX OF THE BANK       CONTENT
C            +1               NUMBER OF STORED VECTORS
C            +2               LENGTH OF ONE VECTOR
C            +3               (USED INTERNAL)
C            +4               1. ELEMENT OF 1. VECTOR
C            +5               2. ELEMENT OF 1. VECTOR
C            +6                    ETC
C
C
C     13.6   COMMENT FOR APPLICATION PROGRAMS
C
C     CALL PTEXT
C        COMMENT IS PRINTED FOR ALL APPLICATION PROGRAMS
C
C     COMMENT IS DEFINED BY THE FOLLOWING CALLS.
C
C     CALL TCOND(N,'COMMENT    $')
C        COMMENT FOR UCOND
C
C     CALL TTABL(N,'COMMENT    $')
C        COMMENT FOR UTABL
C
C     CALL THIST(N,'COMMENT    $')
C        COMMENT FOR UHIST
C
C     CALL TCORR(N,'COMMENT    $')
C        COMMENT FOR UCORR
C
C     CALL TSTOR(N,'COMMENT    $')
C        COMMENT FOR USTOR/USTOS
C
C     CALL TTEXT(N,'COMMENT    $')
C        GENERAL COMMENT
C
C     THE COMMENT-TEXT IS DELIMITED BY A $ SIGN, MAXIMUM NUMBER
C     OF CHARACTERS IS 60.
C
C
C     A BANK WITH NAME 'TEX*' IS USED FOR EACH COMMENT.
C
C
C
      RETURN
      END

C   01/11/84            MEMBER NAME  RDRESV0  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDRESV( DTRSVV )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 07/12/82 :  SIMULATE SPACE RESOLUTION OF
C             R. RAMCKE               VERTEX CHAMBER
C
C   LAST MOD  J. HAGEMANN 11/10/84 :  IMPROVED CODE
C
C      SMEAR DRIFT TIMES AND Z-AMPLITUDES.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cmubcs.for"
C
#include "cjvtxc.for"
C
      DATA PI / 3.14159 /
C
C------------------  C O D E  ------------------------------------------
C
C     STATEMENT FUNCTION TO COMPUTE GAUSSIAN DISTRIBUTION
      G1(Z1,SQLOG)=SIN(PI*2.*Z1)*SQLOG
C
C
      IPVTXC = IDATA( IBLN('VTXC') )
      IF( IPVTXC .EQ. 0 ) RETURN
C
C                          FIRST AND LAST ADD. OF WIRE
      ILHD = IDATA(IPVTXC+1)
      ILV  = IPVTXC*2 + ILHD*2 + 1
      IHV  = ILV + (IDATA(IPVTXC) - ILHD)*2 - 4
C
C                          LOOP OVER ALL WIRES AND SET RESOLUTIONS
C
      DO  100  J = ILV, IHV, 4
C                          DRIFT TIME
         IDT   = HDATA(J + 3)
         DT    = FLOAT(IDT)*TIMEV
         Z1    = RN(DUM)
         SQLOG = SQRT(-2.*ALOG(RN(DUM)))
         DTREL = ABS(DT + G1(Z1,SQLOG)*DTRSVV)/TIMEV
         HDATA(J + 3) = HFIX(AMIN1( DTREL, 32767. ))
C                          LEFT AND RIGHT AMPLITUDES
         IAL = HDATA(J + 1)
         ZLA = FLOAT(IAL)
         CALL NVERT ( ZRESV, ZLA, ZSLA )
         HDATA(J + 1) = HFIX(ZNAMP*(1 - ZSLA/ZMAXV))
         HDATA(J + 2) = HFIX(ZNAMP*(1 + ZSLA/ZMAXV))
  100 CONTINUE
C
      RETURN
      END

C   07/06/96 606071824  MEMBER NAME  BNXT     (S4)          FORTG1
      SUBROUTINE BNXT(IND,*)
C     BOS SUBPROGRAM =1.10=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      IF(KPOS.EQ.0) GOTO 10
      IND=IW(KPOS)
      KPOS=0
      GOTO 20
   10 IND=IW(IND-1)
   20 IF(IND.EQ.0) GOTO 101
  100 RETURN
  101 RETURN 1
      END

C   07/06/96 606071856  MEMBER NAME  MODUL    (S4)          FORTRAN
  ->  SUBROUTINE modul(MODE,ISW)
C
C ->  PROGRAM MODUL  FOR ........................................
C
C
C ->  USAGE OF PROGRAM MODUL
C     =======================
C     THIS PROGRAM MODUL CAN BE CALLED IN THE MAIN PROGRAM AFTER GOREC
C     FOR EACH RECORD AND AT JOB END.
C
C     THE ARGUMENTS MODE AND ISW HAVE THE FOLLOWING MEANING -
C
C               MODE = 0   PROCESS EACH EVENT
C
C               MODE = 1   PROCESS EVENT, IF PROGRAM MODUL NOT YET
C                          APPLIED  *)
C
C               MODE = 2   PROCESS EVENT, IF CURRENT VERSION OF PROGRAM
C                          MODUL NOT YET APPLIED *)
C
C               ISW  = 0   PRODUCTION MODE (NO INTERNAL PRINTOUT)
C
C ->            ISW  = ... (depending on modul)
C
C
C
C
C
C     *) IF A RECORD IS PROCESSED WITH A MODUL, THIS FACT IS RECORDED
C     TOGETHER WITH THE PROGRAM VERSION-NR AND THE DATE OF PROCESSING
C     IN A BANK BOOK, BELONGING TO THAT RECORD. THIS INFORMATION IS
C     USED TO DECIDE, WETHER A PROGRAM MODUL HAS BEEN APPLIED TO THE
C     RECORD. THIS CAN NOT WORK OF COURSE FOR DATA PROCESSED BEFORE
C     THE INTRODUCTION OF THIS SYSTEM, IN THIS CASE ALL EVENTS WILL
C     BE PROCESSED FOR MODE =2 AND =3.
C
C     THE RETURN CODE (SEE BELOW) HAS THE FOLLOWING MEANING
C
C             JRETCD = 0   NO PROCESSING POSSIBLE
C
C ->          JRETCD = ... depending on modul
C
C ->  REQUIREMENT (INPUT DATA) - ......  (NAMES OF BANKS)
C
C ->  RESULT (OUTPUT DATA)     - ......  (NAMES OF BANKS)
C
C
C     STRUCTURE OF THIS PROGRAM
C     =========================
C     THE ARGUMENT ISW IS COPIED TO THE COMMON VARIABLE JSW.
C     IT CAN BE USED TO INDICATE E.G. A TEST MODE OR SIMILAR CONDITIONS.
C     IT SHOULD BE =0 FOR PRODUCTION, BUT IT IS NOT USED BY THE
C     GENERAL STEERING SUBROUTINE.
C     THE VARIABLE IVRCUR IS SET TO THE CURRENT VERSION-NR OF THE
C     PROGRAM MODUL. THIS SHOULD BE THE DATE OF INTRODUCTION AS AN
C     INTEGER IN THE FORM YYMMDD, E.G.
C         810827   FOR   27. AUGUST 1981.
C
C     THEN THE GENERAL STEERING SUBROUTINE GSTEER IS CALLED WITH
C         'MODULNAME'   = NAME OF PROGRAM MODUL (2A4, LEFT ADJUSTED)
C              IVRCUR   = CURRENT VERSION NR
C               MODE    = TAKEN FROM ARGUMENT
C
C     THE STEERING ROUTINE RETURNS IN THE COMMON/STEERC/ THE FOLLOWING
C     VARIABLES -
C              JGOTO    =  1, 2, 3, 4, 5 OR 6
C               NRUN    =  CURRENT RUN NR
C               LRUN    =  PREVIOUS RUN NR
C             JRETCD    =  0 (PROCESSING RETURN CODE, SEE BELOW)
C                JSW    =  COPY OF ARGUMENT ISW
C
C     IF NO BANK ('HEAD',0) CAN BE FOUND BY THE STEERING ROUTINE, OR
C     FOR A SPECIAL RECORD JGOTO WILL BE =6.
C     THE VARIABLE JGOTO IS THEN USED IN A COMPUTED GOTO-STMNT, TO
C     BRANCH TO THE VARIOUS STEPS IN THE PROGRAM.
C                 STEP
C            (1)  INITIALIZE PROGRAM MODUL
C            (2)  INITIALIZE FOR NEW RUN NRUN
C            (3)  PROCESS EVENT (DELETE FIRST OUTPUT BANKS, IF EXISTING)
C            (4)  END OF RUN LRUN
C            (5)  END OF JOB
C            (6)  RETURN TO CALLING PROGRAM
C
C
C     JGOTO = 1   (1) (2) (3)             (6)
C             2       (2) (3)             (6)
C             3           (3)             (6)
C             4               (4) (2) (3) (6)
C             5               (4) (5)     (6)
C             6                           (6)
C
C     (JGOTO WILL BE NEVER =2, BUT THIS NUMBER IS INCLUDED TO HAVE
C     A NICE NUMBERING OF STEPS)
C
C
C     THE RETURN CODE JRETCD CAN BE SET IN STEP (3) TO ANY VALUE
C     BETWEEN 1 AND 10. IF PROCESSSING IS NOT POSSIBLE DUE TO SOME
C     REASON, IT SHOULD REMAIN 0. A STATISTIC IS PRINTED AT THE
C     END FOR ALL PROGRAM MODULS.
C
C
C
      COMMON/BCS/IW(1)
      COMMON/STEERC/JGOTO,NRUN,LRUN,JRETCD,JSW
C
C     THE CURRENT VERSION-NR IS ...
 ->               IVRCUR=810827
C     ... AND SHOULD BE CHANGED FOR EACH CHANGE OF THE PROGRAM MODUL.
C
      JSW=ISW
  ->  CALL GSTEER('modulnam',IVRCUR,MODE)
      GOTO (1000,2000,3000,4000,4000,6000),JGOTO
C                              =
C     IF(JGOTO-3) 1000,3000,1         TO AVOID COMPUTED GOTO
C   1 IF(JGOTO-5) 4000,5000,6000      (168/E)
C
C     (1)  INITIALIZE PROGRAM MODUL
C
C     HERE THE PROGRAM IS INITIALIZED.
C
 1000 CONTINUE
  ->  ....
C
C     (2)  INITIALIZE FOR NEW RUN (NRUN)
C
C     FETCH CALIBRATION CONSTANTS FROM THE RUN LIBRARY, OR CHECK, THAT
C     THE CORRECT CONSTANTS ARE THERE. RESET COUNTERS, IF A STATISTIC IS
C     DONE FOR EACH RUN.
C
 2000 CONTINUE
  ->  ....
C
C     (3)  PROCESS EVENT
C
C     FIRST OUTPUT BANKS FROM THIS MODUL, IF EXISTING, SHOULD BE
C     DELETED. DURING PROCESSING THE VARIABLE JRETCD CAN BE SET TO
C     ANY VALUE BETWEEN 1 AND 10 (INITIALLY IS IS 0). IT SHOULD REMAIN 000013700
C     IF PROCESSING IS NOT POSSIBLE, BECAUSE NO INPUT BANKS EXIST.THE
C     VARIABLE JRETCD IS ONLY USED FOR THE STATISTIC PRINTOUT AT JOB
C     END. FINALLY THE NAMES OF THE OUTPUT BANKS SHOULD BE ADDED TO THE
C     SPECIAL LIST BY   CALL BSAW(NN,'NAMES...'). CREATED INTERMEDIATE
C     SHOULD BE DELETED.
C
 3000 CONTINUE
  ->  ....
      GOTO 6000
C
C     (4)  END OF RUN (LRUN)
C
C     HERE SOME STATISTIC MAY BE PRINTED FOR THE PREVIOUS RUN. IN CASE
C     OF PROGRAM MODULS, IN WHICH CALIBRATION CONSTANT ARE DETERMINED,
C     IT SHOULD BE CHECKED, WETHER THE DATA ARE SUFFICIENT ACCURATE
C     TO BE VALID FOR A CERTAIN RUN REGION (CHECK, WETHER JGOTO = 5
C     ALREADY INDICATES END OF JOB). CALIBRATION DATA SHOULD BE STORED
C     IN A BANK ON THE RUNLIBRARY OR AN EQUIVALENT PRIVATE LIBRARY.
C
 4000 CONTINUE
  ->  ....
      IF(JGOTO.EQ.4) GOTO 2000
C
C     (5)  END OF JOB
C
C     HERE SOME FINAL STATISTIC FOR THE MODUL MAY BE PRINTED.
C
 5000 CONTINUE
  ->  ....
C
C     (6)  RETURN TO CALLING PROGRAM
C
 6000 RETURN
      END

C   23/07/74 712221307  MEMBER NAME  NVERT    (S)           FORTRAN
C
C     PRODUCE NORMALLY DISTRIBUTED NUMBERS WITH SD S AROUND
C     MEAN VALUE AM
C     THE RESULT IS RETURNED IN V
C
C     GENERATE NORMAL DEVIATE BY COMPOSITION METHOD
C     OF AHRENS AND DIETER
C     THE AREA UNDER THE NORMAL CURVE IS DIVIDED INTO 5
C     DIFFERENT AREAS.
C
C     SOURCE FROM BOOK ' A GUIDE TO SIMULATION BY P. BRATLEY,
C     B.L. FOX AND L.E. SCHRAGE, SPRINGER-VERLAG, P. 318 '
C
C     INPUT : IX ( DUMMY )
C
C     AUXILIARY ROUTINE : UNIF(IX) FOR UNIFORM RANDOM NUMBERS
C
      SUBROUTINE NVERT(S,AM,V)
C
      UNIF(IX) = RN(DUM)
C
      U =  UNIF(IX)
      U0 = UNIF(IX)
      IF (U .GE. 0.919544) GOTO 160
C
C     AREA A , THE TRAPEZOID IN THE MIDDLE
C
      TRPNRM = 2.40376*( U0 + U*0.825339 ) - 2.11403
      V = AM + S*TRPNRM
      RETURN
C
  160 CONTINUE
      IF (U .LT. 0.965487) GOTO 210
C
C     AREA B
C
  180 CONTINUE
      TRPTMP = SQRT(4.46911 - 2.0*ALOG( UNIF(IX) ) )
      IF ( TRPTMP*UNIF(IX) .GT. 2.11403 ) GOTO 180
      GOTO 340
  210 CONTINUE
      IF (U .LT. 0.949991 ) GOTO 260
C
C     AREA C
C
  230 CONTINUE
      TRPTMP = 1.8404 + UNIF(IX) *0.273629
      IF ( 0.398942*EXP( -0.5*TRPTMP*TRPTMP) - 0.443299
     &     + TRPTMP*0.209694 .LT. UNIF(IX) * 4.27026E-2 ) GOTO 230
      GOTO 340
  260 CONTINUE
      IF (U .LT. 0.925852 ) GOTO 310
C
C     AREA D
C
  280 CONTINUE
      TRPTMP = 0.28973 + UNIF(IX)*1.55067
      IF ( 0.398942*EXP( -0.5*TRPTMP*TRPTMP) - 0.443299
     &     + TRPTMP*0.209694 .LT. UNIF(IX) * 1.59745E-2 ) GOTO 280
      GOTO 340
  310 CONTINUE
      TRPTMP = UNIF(IX)*0.28973
C
C     AREA E
C
      IF ( 0.398942*EXP( -0.5*TRPTMP*TRPTMP) - 0.382545
     &     .LT. UNIF(IX) * 1.63977E-2 ) GOTO 310
C
  340 IF (U0 .LE. 0.5) TRPTMP = -TRPTMP
      TRPNRM = TRPTMP
      V = AM + S*TRPNRM
      RETURN
      END

C   20/05/79 C9070401   MEMBER NAME  SMINVD   (JADEGS)      FORTRAN
      SUBROUTINE SMINVD(A,B,N,MV,DET)
      REAL*8 A(1),B(1),DET,AM,C,D,E,EPS
      LOGICAL*1 LR(400)
C
C     PURPOSE
C        OBTAIN SOLUTION OF A SYSTEM OF LINEAR EQUTIONS A * X = B WITH
C        SYMMETRIC MATRIX A AND INVERSE (FOR MV = 1) OR MATRIX
C        INVERSION ONLY (FOR MV = 0)
C        ALL REAL ARGUMENTS ARE IN DOUBLE PRECISION
C
C     USAGE
C                    - - - --
C        CALL SMINVD(A,B,N,MV,DET)
C                    - -      ---
C
C           A = SYMMETRIC N-BY-N MATRIX IN SYMMETRIC STORAGE MODE
C               A(1) = A11, A(2) = A12, A(3) = A22, A(4) = A13, . . .
C               REPLACED BY INVERSE MATRIX
C           B = N-VECTOR   (FOR MV = 0 USE A DUMMY ARGUMENT)
C               REPLACED BY SOLUTION VECTOR
C          MV = SEE ABOVE
C         DET = DETERMINANT OF A
C
C     RESTRICTION   N LE 400
C     METHOD OF SOLUTION IS BY ELIMINATION USING THE LARGEST PIVOTAL
C     DIVISOR AT EACH STAGE. A DETERMINANT OF ZERO INDICATES
C     A SINGULAR MATRIX. IN THIS CASE ALL REMAINING ROWS AND COLS OF
C     MATRIX A ARE SET TO ZERO.
C
      EPS=1.0D-12
      DET=1.0D0
C          CONSTRUCT TABLE
      DO 10 I=1,N
   10 LR(I)=.FALSE.
C          LOOP BEGIN
      DO 60 I=1,N
C          SEARCH FOR PIVOT
      K=0
      M=0
      AM=0.0
      DO 20 J=1,N
      M=M+J
      IF(LR(J)) GOTO 20
      IF(DABS(A(M)).LE.AM) GOTO 20
      AM=DABS(A(M))
      K=J
      KK=M
   20 CONTINUE
C          TEST FOR ZERO MATRIX
      IF(K.EQ.0) GOTO 90
C          TEST FOR LINEARITY
      IF(I.EQ.1) C=A(KK)
      IF(DABS(A(KK)/C).LT.EPS) GOTO 90
C          PREPARATION FOR ELIMINATION
      LR(K)=.TRUE.
      DET=DET*A(KK)
      D=1.0/A(KK)
      A(KK)=-D
      IF(MV.EQ.1) B(K)=B(K)*D
      JK=KK-K
      JL=0
C          ELIMINATION
      DO 50 J=1,N
      IF(J-K) 24,22,26
   22 JK=KK
      JL=JL+J
      GOTO 50
   24 JK=JK+1
      GOTO 28
   26 JK=JK+J-1
   28 E=A(JK)
      A(JK)=D*E
      IF(MV.EQ.1) B(J)=B(J)-B(K)*E
      LK=KK-K
      DO 40 L=1,J
      JL=JL+1
      IF(L-K) 34,32,36
   32 LK=KK
      GOTO 40
   34 LK=LK+1
      GOTO 38
   36 LK=LK+L-1
   38 A(JL)=A(JL)-A(LK)*E
   40 CONTINUE
   50 CONTINUE
C          LOOP END
   60 CONTINUE
C          CHANGE SIGN
      M=0
      DO 80 I=1,N
      DO 70 J=1,I
      M=M+1
   70 A(M)=-A(M)
   80 CONTINUE
      GOTO 100
   90 DET=0.0
C          CLEAR REST OF MATRIX
      M=0
      DO 95 I=1,N
      DO 95 J=1,I
      M=M+1
      IF(.NOT.LR(I)) A(M)=0.0
      IF(.NOT.LR(J)) A(M)=0.0
   95 A(M)=-A(M)
  100 RETURN
      END

C   24/11/78 106161822  MEMBER NAME  DECIDE   (JADEGS)      FORTRAN
      SUBROUTINE DECIDE(IANSW)
C---
C---     REQUESTS A ''YES'' OR ''NO'' DECISION FROM THE TERMINAL
C---     AND ACCORDINGLY RETURNS A 1 OR 2 RESPECTIVELY IN THE
C---     ARGUMENT FIELD.
C---
      IMPLICIT INTEGER*2 (H)
      DATA HYES/'YE'/,HY/'Y '/,HY1/' Y'/
      DATA HJA/'JA'/,HJ/'J '/,HJ1/' J'/
      DATA HHA/'HA'/,HH/'H '/,HH1/' H'/
C     DATA HNO/'NO'/
C   1 CONTINUE
      CALL TRMIN(2,HTEXT)
      IANSW=2
      IF(HTEXT.EQ.HYES.OR.HTEXT.EQ.HJA.OR.HTEXT.EQ.HHA) IANSW=1
      IF(HTEXT.EQ.HY.OR.HTEXT.EQ.HJ.OR.HTEXT.EQ.HH) IANSW=1
      IF(HTEXT.EQ.HY1.OR.HTEXT.EQ.HJ1.OR.HTEXT.EQ.HH1) IANSW=1
C     IF(HTEXT.EQ.HNO) IANSW=2
C     IF(IANSW.NE.0) GO TO 2
C     CALL TRMOUT(80,'ERROR. PLEASE ENTER EITHER YES OR NO.^')
C     GO TO 1
C   2 CONTINUE
      RETURN
      END

C   07/06/78 C8071801   MEMBER NAME  JMULSC0  (SOURCE)      FORTRAN
      SUBROUTINE JMULSC( P, XRAD )
C  *--------------------------------------------------------
C  *
C  *  VERSION OF 01/06/78
C  *  CALCULATE MULTIPLE SCATTERING .
C  *    P = MOMENTUM VECTOR OF INCIDENT PARTICLE
C  *         THIS VECTOR IS OVERWRITTEN BY SCATTERD MOMENTUM.
C  *    P(1) ... P(3) MOMENTUM COMPONENTS
C  *    P(4)          ENERGY OF PARTICLE
C  *    P(5)          REST MASS
C  *    P(6)          TOTAL MOMENTUM
C  *    XRAD = THICKNESS OF RADIATOR IN RADIATION LENGTH
C  *  TOTAL ANGLE IS RANDOMLY GENERATED.
C  *--------------------------------------------------------
C
C
      DIMENSION P(6),X2(3),X3(3)
      DATA PI/3.14159/
C
      IF( XRAD .LT. 1.E-30 ) RETURN
C
C  CHANGE P TO UNIT VECTOR
      DO 100 I =1,3
  100 P(I) = P(I)/ P(6)
C
C  FIND OTHER UNIT VECTORS THAT ARE PERPENDICULAR.
      CTH = P(3)
      IF(ABS(CTH).LT.1.E-30) GO TO 1
      STH = SQRT( 1. - CTH*CTH )
      IF(STH.LT.1.E-30) GO TO 2
      SPHI = P(2)/STH
      CPHI = P(1)/STH
      X2(1) = SPHI
      X2(2) = -CPHI
      X2(3) = 0.
      X3(1) = CPHI*CTH
      X3(2) = SPHI*CTH
      X3(3) = -STH
      GO TO 3
    1 X2(1) = P(2)
      X2(2) = -P(1)
      X2(3) = 0.
      X3(1) = 0.
      X3(2) = 0.
      X3(3) = -1.
      GO TO 3
    2 X2(1) = 0.
      X2(2) = -1.
      X2(3) = 0.
      X3(1) = 1.
      X3(2) = 0.
      X3(3) = 0.
C
C  FIND SCATTERING ANGLE
    3 THSTR = 21.E-3 / P(6) * P(4) / P(6) * SQRT(XRAD)
      CALL NVERT( THSTR, 0., TH1 )
C
      PHI = 2.*PI*RN(D)
      COSPHI = COS( PHI )
      SINPHI = SIN( PHI )
      PABS=0.
      DO 4 I = 1,3
      P(I) = P(I)+TH1*COSPHI*X2(I)+TH1*SINPHI*X3(I)
    4 PABS = PABS+P(I)**2
      PABS = SQRT(PABS)
C
C P IS CHANGED TO ACTUAL SIZE P(6).
      DO 5 I=1,3
    5 P(I) = P(I) / PABS * P(6)
      RETURN
      END

C   12/09/79 206221544  MEMBER NAME  TOFMASO  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFMAS
C
C THIS IS THE OLD VERSION WHICH HAS THE 2 TRACK ALGORITHM
C REPLACED ON 22.6.1982 BY TOFMAS4(NOW RENAMED INTO TOFMAS)
C
C  DETERMINES TOF FOR EACH TRACK AND ITS QUALITY
C  CREATES BANK TOFR
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "tcalcm.for"
#include "tfprm.for"
      INTEGER *2  HEADR(108)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      COMMON/PRPOS/PRPLS,CPOS
      DIMENSION IAGREE(3),ZT(2),TMNUS(2),TPLUS(2),DELT(2)
C
      DATA IENTRY/0/
      DATA CVEL/ 2.9979246E2/,DTAU1/1./
C
      NRUN = HEADR(18)
      IF(IENTRY.NE.0)  GOTO 66
      IENTRY = IENTRY + 1
   66 ZTOF = 0.
      ZTOF1 = 0.
      NNG= 0
      NOK= 0
      CALL SETSL(IW,0,704*4,0)
      CALL SETSL(TAUM,0,84*4,0.)
C
       DO 1000 I=1,42
       MTPY= ICRT1(2,I)
            IF(MTPY.EQ.0) GO TO 1000
            IF(MTPY.EQ.1) GO TO 300
            IF(MTPY.EQ.2) GO TO 400
C/////////
                 MTPY= MTPY+2
                 IF(MTPY.GE.6) MTPY=5
                 DO 200 K=3,MTPY
                      NTK= ICRT1(K,I)
                      IRELT(1,NTK)= NTK
                      IRELT(2,NTK)= -MTPY+2
                      IRELT(3,NTK)= I
                      NNG= NNG+1
 200             CONTINUE
            GO TO 1000
C
C=========  ONE TRACK IN THE COUNTER
C
  300 NTR1= ICRT1(MTPY+2,I)
      Z1= TRK(1,NTR1)
      PATH1= TRK(3,NTR1)
      PMEV1= TRK(4,NTR1)
      TAUP1= RAW(3,I)+Z1/VELSC
      TAUM1= RAW(2,I)-Z1/VELSC
      TAUM1 = TAUM1 - (TPARM(7)*PATH1+TPARM(8))
      TAUP1 = TAUP1 - (TPARM(7)*PATH1+TPARM(8))
C  BEAM CURRENT CORR
      IF(NRUN.LT.4993) GOTO  321
      TAUM1 = TAUM1 - CPOS *TPARM(21)
      TAUP1 = TAUP1 - CPOS *TPARM(22)
C  AD HOC CORR FOR BEGIN 1981
      TAUM1 = TAUM1 - TPARM(25)
      TAUP1 = TAUP1 - TPARM(25)
      IF(NRUN.GT.6000.AND.NRUN.LT.7592) TAUM1 = TAUM1 +3.07
      IF(NRUN.GT.6000.AND.NRUN.LT.7592) TAUP1 = TAUP1 +3.07
  321 TAUM(I) = TAUM1
      TAUP(I) = TAUP1
      NFLG= -1
            IF(HTDC(1,I).GT.10.AND.HTDC(1,I).LT.2048) GO TO 320
            TOF1= TAUP1
            GO TO 360
C
 320        IF(HTDC(2,I).LT.2048) GO TO 330
            TOF1= TAUM1
            GO TO 360
C
  330 IF(ABS(TAUM1-TAUP1).LE.3.*DTAU1) GO TO 350
                 IF(Z1.LT.0.) GO TO 340
                 TOF1= TAUP1
                 GO TO 360
 340  TOF1= TAUM1
      GO TO 360
C
 350  NFLG= 1
      ADCM = HADC(1,I) - PEDLM(I)
      ADCP = HADC(2,I) - PEDLP(I)
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
      IF(HADC(1,I).GT.1024) ADCM = 1024.
      IF(HADC(2,I).GT.1024) ADCP = 1024.
      VWM = TPARM(9)/ADCM+TPARM(10)
      VWP = TPARM(9)/ADCP+TPARM(10)
      VWM = 1./(VWM*VWM)
      VWP = 1./(VWP*VWP)
      TOF1 = (VWM*TAUM1+VWP*TAUP1)/(VWM+VWP)
      ZTOF1 = (RAW(2,I)-RAW(3,I))/2.*VELSC
 360  CALL CMASS( I,PMEV1,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -            PRO1,PKA1,PPI1,PEL1)
      CALL TFSTOR(NTR1,NFLG,I,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -            PRO1,PKA1,PPI1,PEL1,ZTOF1)
      NOK= NOK+1
CXXXXXXXXXX
      GO TO 1000
C
C=========   TWO HITS IN THE COUNTER
C
 400  NTR= ICRT1(3,I)
      Z= TRK(1,NTR)
      NTR1 = ICRT1(4,I)
      Z1 = TRK(1,NTR1)
            IF(Z.GT.Z1) GO TO 430
            NTRP= NTR
            NTR= NTR1
            NTR1= NTRP
            ZP1= Z
            Z= Z1
            Z1= ZP1
 430  PATH= TRK(3,NTR)
      P = TRK(4,NTR)
      P1 = TRK(4,NTR1)
      PATH1 = TRK(3,NTR1)
C//////////
      TOF = 100.
      TOF1 = 100.
      IFLG = -2
      IFLG1 =-2
      IF(HTDC(1,I).LT.10.OR.HTDC(1,I).GT.2047)  GOTO  550
      IF(HTDC(2,I).LT.10.OR.HTDC(2,I).GT.2047)  GOTO  550
      TMNUS(1) = RAW(2,I) - Z1/VELSC
      TPLUS(1) = RAW(3,I) + Z1/VELSC
      DELT(1) = TMNUS(1) - TPLUS(1)
      TMNUS(2) = RAW(2,I) - Z/VELSC
      TPLUS(2) = RAW(3,I) + Z/VELSC
      DELT(2) = TMNUS(2) - TPLUS(2)
      DELZ = (Z-Z1)/VELSC
      IF(ABS(DELZ).LE.2.)  GOTO  560
      DO   431   L=1,2
      IAGREE(L) = 0
      IF(ABS(DELT(L)).LE.2.) IAGREE(L) = 1
  431 CONTINUE
      IAGREE(3) = 0
      TMM = TMNUS(1)+DELZ-TPLUS(2)
      TPP = TPLUS(2)+DELZ-TMNUS(1)
      IF(TMM.GT.-1..AND.TPP.GT.-1.) IAGREE(3) = 1
C
      IF(DELZ.LE.2.)  GOTO  560
      IF(IAGREE(1)+IAGREE(2)+IAGREE(3).EQ.0)  GOTO  550
      IF(IAGREE(1)+IAGREE(2)+IAGREE(3).EQ.3)  GOTO  560
      IF(IAGREE(1).EQ.1.AND.IAGREE(2).EQ.0) GOTO  520
      IF(IAGREE(2).EQ.1.AND.IAGREE(1).EQ.0) GOTO  530
      IF(IAGREE(3).EQ.1.AND.IAGREE(1)+IAGREE(2).EQ.0) GOTO  540
      GOTO  550
  520 CONTINUE
      IFLG1 = 2
      TOF1= .5*(TMNUS(1)+TPLUS(1))
      CALL CMASS( I,P1,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -                 PRO1,PKA1,PPI1,PEL1)
      NOK = NOK + 1
      IF(IAGREE(3).GT.0)  GOTO  521
      NNG = NNG + 1
      GOTO  500
  521 IFLG1 = -2
      TOF = TPLUS(2)
      CALL CMASS( I,P,TOF,PATH,BET,DBET,EMAS2,DMAS,
     -                 PRO,PKA,PPI,PEL)
      NOK = NOK + 1
      GOTO  500
  530 CONTINUE
      IFLG = 2
      TOF = .5*(TMNUS(2)+TPLUS(2))
      CALL CMASS( I,P,TOF,PATH,BET,DBET,EMAS2,DMAS,
     -                 PRO,PKA,PPI,PEL)
      NOK = NOK + 1
      IF(IAGREE(3).GT.0)  GOTO  531
      NNG = NNG + 1
      GOTO 500
  531 IFLG = -2
      TOF1 = TMNUS(1)
      CALL CMASS( I,P1,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -                 PRO1,PKA1,PPI1,PEL1)
      NOK = NOK + 1
      GOTO  500
  540 CONTINUE
      IFLG = 2
      IFLG1 = 2
      TOF1= TMNUS(1)
      TOF  = TPLUS(2)
      CALL CMASS( I,P,TOF,PATH,BET,DBET,EMAS2,DMAS,
     -                 PRO,PKA,PPI,PEL)
      CALL CMASS( I,P1,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -                 PRO1,PKA1,PPI1,PEL1)
      NOK = NOK + 2
      GOTO  500
  560 CONTINUE
      TOF = .25*(TMNUS(1)+TPLUS(1)+TMNUS(2)+TPLUS(2))
      TOF1 = TOF
      CALL CMASS( I,P,TOF,PATH,BET,DBET,EMAS2,DMAS,
     -                 PRO,PKA,PPI,PEL)
      CALL CMASS( I,P1,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -                 PRO1,PKA1,PPI1,PEL1)
      NOK = NOK + 2
      GOTO  500
  550 NNG = NNG + 2
  500 CONTINUE
            CALL TFSTOR(NTR1,IFLG1,I,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -                  PRO1,PKA1,PPI1,PEL1,DEDX1)
            CALL TFSTOR(NTR,IFLG,I,TOF,PATH,BET,DBET,EMAS2,DMAS,
     -                  PRO,PKA,PPI,PEL,DEDX)

 1000  CONTINUE
C
C=========   HEADER PART
C
                 NXX= 0
                 DO 2000 I=1,NTRK
                 IF(IRELT(1,I).NE.0) GO TO 2000
                 CALL TFSTOR(I,10,0,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
                 NXX= NXX+1
 2000            CONTINUE
            INFM(1)= NTRK
            INFM(2)= NOK
            INFM(3)= NNG
            INFM(4)= NXX
            LTFR= 14*NTRK+4
C
C=========   STORE RESULT INTO CURRENT BUFFER
C
       CALL BCRE(INTR,'TOFR',0,LTFR,&3000,IER)
       IF(INTR.EQ.0.AND.IER.EQ.2) GO TO 3000
       CALL BSTR(INTR,IW,LTFR)
       CALL BSAT(1,'TOFR')
       RETURN
3000   CONTINUE
C/////////
             WRITE(6,9300)
9300         FORMAT(1X,'BOS ERROR IN TOFMAS')
       RETURN
       END

      SUBROUTINE ZSRFTV(MODE,IOPT)
      IMPLICIT INTEGER*2 (H)
      COMMON/CZSSTE/ NSETZS,NTSTZS(5),KTSTZS(100,2,5),XYSTZS(2,5),
     +SQCHZS(3,5)
      COMMON/CCMZCT/ DIMPCT, ZCUTV, ZCUTVV, IZVCST(5)
#include "cdata.for"
#include "calibr.for"
      COMMON/CWORK/NDIWRK,WRK(20000)
      DIMENSION IWRK(20000),HWRK(40000)
      EQUIVALENCE (WRK(1),IWRK(1),HWRK(1))
      INTEGER ITRREQ(100)
      REAL CORTRC(2,100)
      DATA LBINIT /0/, IQPATR/0/, IQJHTL/0/, IQHEAD/0/, IQJETC/0/
      DATA NPRLIM/50/,KPRLIM/0/
      KOPT=IOPT
      IF(KOPT.GT.8) KOPT=KOPT-8
      IF(
     - KOPT.NE.1 .AND. KOPT.NE.2 .AND. KOPT.NE.4
     -)THEN
      IF(
     - KPRLIM.LT.NPRLIM
     -)THEN
            KPRLIM=KPRLIM+1
            WRITE(6,100) IOPT
100         FORMAT(' **** ZSRFTV CALLED WITH INVALID OPTION :',I8)
      ENDIF
         RETURN
      ENDIF
      IF(
     - KOPT.EQ.4
     -)THEN
      IF(
     - NTSTZS(1).EQ.1
     -)THEN
            KTC=KTSTZS(1,1,1)
      IF(
     - KTC.LT.1 .OR. KTC.GT.100
     -)THEN
               LINCON=1
      ELSE
               LINCON=0
               NTRREQ=1
               ITRREQ(1)=KTC
               KTSTZS(1,2,1)=0
      ENDIF
      ELSE
      IF(
     - NSETZS.GE.1.AND.NSETZS.LE.5
     -)THEN
               NTRREQ=0
               LINCON=0
      DO 13000 ISET=1,NSETZS
                  SQCHZS(1,ISET)=0.
                  SQCHZS(2,ISET)=0.
                  SQCHZS(3,ISET)=0.
                  NTSETI=NTSTZS(ISET)
      IF(
     - NTSETI.LT.2 .OR. NTSETI.GT.100
     -)THEN
                     LINCON=1
      GOTO 13001
      ENDIF
      DO 13002 JT=1,NTSETI
                     KTC=KTSTZS(JT,1,ISET)
      IF(
     - KTC.LT.1 .OR. KTC.GT.100
     -)THEN
                        LINCON=1
      GOTO 13003
      ENDIF
                     KTSTZS(JT,2,ISET)=0
                     LPRES=0
      IF(
     - NTRREQ.GT.0
     -)THEN
      DO 13004 J=1,NTRREQ
      IF(
     - ITRREQ(J).EQ.KTC
     -)THEN
                              LPRES=1
      GOTO 13005
      ENDIF
13004 CONTINUE
13005 CONTINUE
      ENDIF
      IF(
     - LPRES.EQ.0
     -)THEN
      IF(
     - NTRREQ.EQ.100
     -)THEN
                           LINCON=1
      GOTO 13003
      ENDIF
                        NTRREQ=NTRREQ+1
                        ITRREQ(NTRREQ)=KTC
      ENDIF
13002 CONTINUE
13003 CONTINUE
      IF(
     - LINCON.NE.0
     -)THEN
      GOTO 13001
      ENDIF
13000 CONTINUE
13001 CONTINUE
      ELSE
               LINCON=1
      ENDIF
      ENDIF
      IF(
     - LINCON.NE.0
     -)THEN
      IF(
     - KPRLIM.LT.NPRLIM
     -)THEN
               KPRLIM=KPRLIM+1
               WRITE(6,200)
200            FORMAT(' **** ZSRFTV: INVALID REQUEST IN /CZSSTE/')
      ENDIF
            RETURN
      ENDIF
      ELSE
         SQCHZS(1,1)=0.
         SQCHZS(2,1)=0.
         SQCHZS(3,1)=0.
      DO 13006 J=1,100
            KTSTZS(J,2,1)=0
13006 CONTINUE
13007 CONTINUE
      ENDIF
      IF(
     - LBINIT .LE.0
     -)THEN
         LBINIT = 1
         IQPATR = IBLN('PATR')
         IQJHTL = IBLN('JHTL')
         IQHEAD = IBLN('HEAD')
         IQJETC = IBLN('JETC')
      ENDIF
      IF(IDATA(IQPATR).LE.0) RETURN
      IF(
     - MODE.EQ.1
     -)THEN
         IPPAT0 = IDATA(IQPATR)
         NBNK1  = IDATA(IPPAT0-2) - 1
         NWRD   = IDATA(IPPAT0)
         NBYTE  = NWRD*4
         CALL CCRE(IPPATR,'PATR',NBNK1,NWRD,IERR)
      IF(
     - IERR.NE.0
     -)THEN
            PRINT 2900, IERR
 2900       FORMAT(' CREATION OF NEW PATR-BANK RESULTED IN ERROR',I3)
            RETURN
      ENDIF
         CALL MVCL(IDATA(IPPATR+1),0,IDATA(IPPAT0+1),0,NBYTE)
      ENDIF
      IPPATR = IDATA(IQPATR)
      IPTR   = IDATA(IPPATR+1) + IPPATR
      LDTR   = IDATA(IPPATR+3)
      NTR    = IDATA(IPPATR+2)
      IF(NTR.LT.1) RETURN
      IF(
     - NTR.GT.100
     -)THEN
      IF(
     - KPRLIM.LT.NPRLIM
     -)THEN
            KPRLIM=KPRLIM+1
            WRITE(6,300) NTR
300         FORMAT(' **** ZSRFTV : NUMBER OF TRACKS IN PATR BANK :',
     +      I4,'. FIRST 100 WILL BE CONSIDERED.')
      ENDIF
         NTR=100
      ENDIF
      CALL JRECAL(IERR)
      IF(
     - IERR.NE.0
     -)THEN
         PRINT 6784,IERR
 6784    FORMAT(' *** ERROR IN JRECAL',I3)
         RETURN
      ENDIF
      IPJETC = IDATA(IQJETC)
      IPJHTL = IDATA(IQJHTL)
      MODEZ  = 1
      CALL ZSFIT(IPJETC,IDATA(IPJETC-1),IPJHTL,IPPATR,MODEZ,5) ! PMF 03/12/99: 6th argument added
      NDIWRK=20000
      NTRKS=0
      IDTR2=1
      LDTR2=11
      LHIT=8
      LTRREC=0
      IHIT1=NTR*LDTR2+1
      DO 13008 ITR=1,NTR
      IF(
     - IHIT1 .GT. NDIWRK-200-(70*LHIT+LTRREC)
     -)THEN
      GOTO 13009
      ENDIF
      IF(
     - KOPT.NE.4
     -)THEN
            LFIT=1
      ELSE
            LFIT=0
      DO 13010 J=1,NTRREQ
      IF(
     - ITRREQ(J).EQ.ITR
     -)THEN
                  LFIT=1
      GOTO 13011
      ENDIF
13010 CONTINUE
13011 CONTINUE
      ENDIF
      IF(
     - LFIT.EQ.1
     -)THEN
            INDFET = 4
            CALL JFETCH(IPTR,IPJHTL,WRK(IHIT1),LHIT,IPRES,INDFET,XD,YD)
            NHIT=(IPRES-1)/LHIT
      IF(
     - NHIT.GT.1
     -)THEN
               IPRES=IHIT1+IPRES-1
               CALL ZSRFT1(IPTR,LDTR,IHIT1,IPRES,LHIT,IQUAL,IOPT)
      IF(
     - KOPT.EQ.4
     -)THEN
      IF(
     - NTSTZS(1).EQ.1
     -)THEN
                     KTSTZS(1,2,1)=IQUAL
                     RETURN
      ELSE
      DO 13012 ISET=1,NSETZS
                        NTSETI=NTSTZS(ISET)
      DO 13014 JT=1,NTSETI
                     IF(KTSTZS(JT,1,ISET).EQ.ITR)KTSTZS(JT,2,ISET)=IQUAL
13014 CONTINUE
13015 CONTINUE
13012 CONTINUE
13013 CONTINUE
      ENDIF
      ELSE
                  KTSTZS(ITR,2,1)=IQUAL
      ENDIF
      IF(
     - IQUAL.GT.0 .AND. KOPT.NE.1
     -)THEN
                  NTRKS=NTRKS+1
                  IWRK(IDTR2  )=ITR
                  IWRK(IDTR2+1)=IPTR
                  IF(KOPT.EQ.2) IQUAL=2
                  IWRK(IDTR2+2)=IQUAL
                  IWRK(IDTR2+3)=IHIT1
                  IWRK(IDTR2+4)=IPRES
                  IHIT1=IPRES+LTRREC
                  IDTR2=IDTR2+LDTR2
      ENDIF
      ENDIF
      ENDIF
         IPTR=IPTR+LDTR
13008 CONTINUE
13009 CONTINUE
      IF(KOPT.EQ.1.OR.NTRKS.LT.2) RETURN
      IF(
     - KOPT.EQ.2
     -)THEN
         IRUN=HDATA( 2*IDATA(IQHEAD) + 10)
      IF(
     -  IRUN.GE.100
     -)THEN
            IPV    = ICALIB(10)
            XCOMM  = ACALIB(IPV+ 1)
            YCOMM  = ACALIB(IPV+ 3)
      ELSE
            XCOMM  = 0.
            YCOMM  = 0.
      ENDIF
         IVNEED=IZVCST(1)
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      IF(
     - KOPT.EQ.4
     -)THEN
      DO 13016 ISET=1,NSETZS
            NTSETI=NTSTZS(ISET)
            NTRFIT=0
            IDTR2=1
      DO 13018 JTR=1,NTRKS
               ITR=IWRK(IDTR2)
               IWRK(IDTR2+2)=1
      DO 13020 JT=1,NTSETI
      IF(
     - KTSTZS(JT,1,ISET).EQ.ITR
     -)THEN
                     NTRFIT=NTRFIT+1
                     IWRK(IDTR2+2)=2
      GOTO 13021
      ENDIF
13020 CONTINUE
13021 CONTINUE
               IDTR2=IDTR2+LDTR2
13018 CONTINUE
13019 CONTINUE
      IF(
     - NTRFIT.GE.2
     -)THEN
               XCOMM=XYSTZS(1,ISET)
               YCOMM=XYSTZS(2,ISET)
               IVNEED=IZVCST(ISET)
      ASSIGN 17002 TO IZZZ01
      GOTO 17000
17002 CONTINUE
      ENDIF
13016 CONTINUE
13017 CONTINUE
      ENDIF
      RETURN
17000 CONTINUE
         ZCUT=ZCUTV
         IF(KOPT.EQ.4) ZCUT=ZCUTVV
         IDTR2=1
         NTRFIT=0
         ZCOMM=0.
      DO 13022 JTR=1,NTRKS
      IF(
     - IWRK(IDTR2+2).EQ.2
     -)THEN
               IPTR=IWRK(IDTR2+1)
               CURVXY=ADATA(IPTR+25)
               IF(ABS(CURVXY).LT.1.E-9) CURVXY = SIGN(1.E-9,CURVXY)
               DDR0=DISTXY(ADATA(IPTR+5),ADATA(IPTR+6),ADATA(IPTR+8),
     +         ADATA(IPTR+9),1./CURVXY,XCOMM,YCOMM,CORTRC(1,JTR),
     +         CORTRC(2,JTR),FI)
      IF(
     - ABS(DDR0).LT.DIMPCT
     -)THEN
                  WRK(IDTR2+5)=COS(FI)
                  WRK(IDTR2+6)=SIN(FI)
                  DDR0=DISTXY(ADATA(IPTR+5),ADATA(IPTR+6),ADATA(IPTR+8),
     +            ADATA(IPTR+9),1./CURVXY,0.,0.,XP,YP,FI)
                  UU=SQRT((CORTRC(1,JTR)-XP)**2+(CORTRC(2,JTR)-YP)**2)
                  ARGARG = .5*CURVXY*UU
                  IF( ABS(ARGARG).GT.1.) ARGARG = SIGN( 1., ARGARG )
                  IF(ABS(CURVXY*UU).GT.1.E-5)
     +            UU=2.*ARSIN(ARGARG)/CURVXY
                  ZCOMM1=ADATA(IPTR+31)+ADATA(IPTR+30)*UU
      IF(
     - ABS(ZCOMM1) .LT. ZCUT
     -)THEN
                     WRK(IDTR2+7)=ZCOMM1
                     WRK(IDTR2+10)=CURVXY
                     ZCOMM=ZCOMM+ZCOMM1
                     NTRFIT=NTRFIT+1
      ELSE
                     IWRK(IDTR2+2)=1
      ENDIF
      ELSE
                  IWRK(IDTR2+2)=1
      ENDIF
      ENDIF
            IDTR2=IDTR2+LDTR2
13022 CONTINUE
13023 CONTINUE
      IF(
     - NTRFIT.GE.2
     -)THEN
            ZCOMM=ZCOMM/NTRFIT
            NHTOT=0
      IF(
     - IVNEED.EQ.1
     -)THEN
               S0=(20./10.)**2
               IF( LDATYP(DUMMY).EQ.2 ) S0=S0*4.
               S3=-ZCOMM*S0
               S7=ZCOMM**2*S0
      ELSE
               S0=0.
               S3=0.
               S7=0.
      ENDIF
            S5=0.
            S6=0.
            IDTR2=1
      DO 13024 JTR=1,NTRKS
      IF(
     - IWRK(IDTR2+2).EQ.2
     -)THEN
                     IPTR=IWRK(IDTR2+1)
                     CURVXY=WRK(IDTR2+10)
                     CTGTH=ADATA(IPTR+30)
                     S1=0.
                     S2=0.
                     S4=0.
                     IPCO =IWRK(IDTR2+3)
                     IPCO9=IWRK(IDTR2+4)-LHIT
      DO 13026 IP=IPCO,IPCO9,LHIT
      IF(
     - HWRK(2*IP+3).EQ.1
     -)THEN
                           UX=WRK(IP+3)-CORTRC(1,JTR)
                           UY=WRK(IP+4)-CORTRC(2,JTR)
                           UU=SQRT(UX**2+UY**2)
                           ARGARG = .5*CURVXY*UU
                           IF( ABS(ARGARG).GT.1.) ARGARG=SIGN(1.,ARGARG)
                           IF(ABS(CURVXY*UU).GT.1.E-5)
     +                     UU=2.*ARSIN(ARGARG)/CURVXY
                           IF(UX*WRK(IDTR2+5)+UY*WRK(IDTR2+6).LT.0.)
     +                     UU=-UU
                           DZ=WRK(IP+5)-ZCOMM-CTGTH*UU
                           W=WRK(IP+7)
                           NHTOT=NHTOT+1
                           S0=S0+W
                           S3=S3+DZ*W
                           S1=S1+UU*W
                           S2=S2+UU**2*W
                           S4=S4+DZ*UU*W
                           S7=S7+DZ**2*W
      ENDIF
13026 CONTINUE
13027 CONTINUE
                     WRK(IDTR2+7)=S4
                     WRK(IDTR2+8)=S1
                     WRK(IDTR2+9)=S2
                     S5=S5+S1*S4/S2
                     S6=S6+S1*S1/S2
      ENDIF
               IDTR2=IDTR2+LDTR2
13024 CONTINUE
13025 CONTINUE
               DZCOMM=(S3-S5)/(S0-S6)
               ZCOMMR=ZCOMM+DZCOMM
               ISETOP=1
               IF(KOPT.EQ.4) ISETOP=ISET
               SQCHZS(2,ISETOP)=NHTOT
               SQCHZS(3,ISETOP)=ZCOMMR
               SQCHZS(1,ISETOP)=S7+DZCOMM*(DZCOMM*S0-2.*S3)
               IDTR2=1
      DO 13028 JTR=1,NTRKS
      IF(
     - IWRK(IDTR2+2).EQ.2
     -)THEN
                     IPTR=IWRK(IDTR2+1)
      ASSIGN 17004 TO IZZZ02
      GOTO 17003
17004 CONTINUE
                     ITR=IWRK(IDTR2)
      IF(
     - KOPT.EQ.4
     -)THEN
      DO 13030 JT=1,NTSETI
                         IF(KTSTZS(JT,1,ISET).EQ.ITR)KTSTZS(JT,2,ISET)=200059400
13030 CONTINUE
13031 CONTINUE
      ELSE
                        KTSTZS(ITR,2,1)=2
      ENDIF
      ENDIF
                  IDTR2=IDTR2+LDTR2
13028 CONTINUE
13029 CONTINUE
               IF(SQCHZS(1,ISETOP).LT.1.E-5) SQCHZS(1,ISETOP)=1.E-5
               SQCHZS(1,ISETOP)=SQRT(SQCHZS(1,ISETOP)/(NHTOT-NTRFIT-1))
      ENDIF
      GOTO IZZZ01
17003 CONTINUE
      DCTGTH=(WRK(IDTR2+7)-DZCOMM*WRK(IDTR2+8))/WRK(IDTR2+9)
      SQCHZS(1,ISETOP)=SQCHZS(1,ISETOP)+DCTGTH*(DCTGTH*WRK(IDTR2+9)+
     +2.*DZCOMM*WRK(IDTR2+8)-2.*WRK(IDTR2+7))
      CTGTH=ADATA(IPTR+30)+DCTGTH
      CSTH = 1./SQRT(CTGTH**2 + 1.)
      SNTH  = CSTH * CTGTH
      CURVXY=WRK(IDTR2+10)
         IFREE=NDIWRK-100
         CALL MVCL(IWRK(IFREE),0,IDATA(IPTR+1),0,4*LDTR)
         IP    = IFREE - 1
         IWRK(IP+ 2) = LOR(IWRK(IP+2),8192)
         UX=WRK(IP+5)-CORTRC(1,JTR)
         UY=WRK(IP+6)-CORTRC(2,JTR)
         UU=SQRT(UX**2+UY**2)
         ARGARG = .5*CURVXY*UU
         IF( ABS(ARGARG).GT.1.) ARGARG = SIGN( 1., ARGARG )
         IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*ARSIN(ARGARG)/CURVXY
         IF(UX*WRK(IDTR2+5)+UY*WRK(IDTR2+6).LT.0.) UU=-UU
         WRK (IP+ 7) = ZCOMMR+CTGTH*UU
         A=SQRT(WRK(IP+8)**2+WRK(IP+9)**2)
         WRK (IP+ 8) = WRK (IP+ 8)/A*CSTH
         WRK (IP+ 9) = WRK (IP+ 9)/A*CSTH
         WRK (IP+10) = SNTH
         UX=WRK(IP+12)-CORTRC(1,JTR)
         UY=WRK(IP+13)-CORTRC(2,JTR)
         UU=SQRT(UX**2+UY**2)
         ARGARG = .5*CURVXY*UU
         IF( ABS(ARGARG).GT.1.) ARGARG = SIGN( 1., ARGARG )
         IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*ARSIN(ARGARG)/CURVXY
         IF(UX*WRK(IDTR2+5)+UY*WRK(IDTR2+6).LT.0.) UU=-UU
         WRK (IP+14) = ZCOMMR+CTGTH*UU
         A=SQRT(WRK(IP+15)**2+WRK(IP+16)**2)
         WRK (IP+15) = WRK (IP+15)/A*CSTH
         WRK (IP+16) = WRK (IP+16)/A*CSTH
         WRK (IP+17) = SNTH
         IWRK(IP+29) = 2
         WRK (IP+30) = CTGTH
         DDR0=DISTXY(ADATA(IPTR+5),ADATA(IPTR+6),ADATA(IPTR+8),
     +   ADATA(IPTR+9),1./CURVXY,0.,0.,XP,YP,FI)
         UX=XP-CORTRC(1,JTR)
         UY=YP-CORTRC(2,JTR)
         UU=SQRT(UX**2+UY**2)
         ARGARG = .5*CURVXY*UU
         IF( ABS(ARGARG).GT.1.) ARGARG = SIGN( 1., ARGARG )
         IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*ARSIN(ARGARG)/CURVXY
         IF(UX*WRK(IDTR2+5)+UY*WRK(IDTR2+6).LT.0.) UU=-UU
         WRK (IP+31) = ZCOMMR+CTGTH*UU
         CALL MVCL(IDATA(IPTR+1),0,IWRK(IFREE),0,4*LDTR)
      GOTO IZZZ02
      END

C   25/08/83 606101308  MEMBER NAME  JRING9   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JRING( IRING, ICELL, COSAL, SINAL,
     *                  X, P, IRETRN , DRMAX, * )
C-----------------------------------------------------------------------
C
C  AUTHOR:  E. ELSEN     07/12/78 : TRACK THROUGH JET CHAMBER RING
C
C       MOD E. ELSEN     07/10/81 :
C
C       MOD C. BOWDERY   18/08/81 : NEW CODE FOR 4V/JETC ASSOCIATION
C
C  LAST MOD J. HAGEMANN  28/08/84 : NEW VERSION OF SUBROUTINE JSTEP
C                                   INCLUDED
C
C       PROPAGATE PARTICLE IN CELL ICELL IN RING IRING.
C
C       X AND P ARE THE APROPRIATE COORDINATES IN CELL/RING.
C       COSAL AND SINAL ARE ASSOCIATED COS AND SIN OF ROTATION.
C       IRETRN IS RETURN CODE:
C
C       IRETRN = 0 : NEXT ELEMENT, INCREASING X
C              = 1 : NEXT ELEMENT, DECREASING X
C              = 2 : NEXT ELEMENT, INCREASING Z
C              = 3 : NEXT ELEMENT, DECREASING Z
C              = 4 : PARTICLE STOPPED OR DECAYED
C              = 5 : NEXT ELEMENT, CHANGING PHI
C
C       DRIFT INFORMATION IS STORED IN HLIST ARRAY
C
C         HLIST(4(HIT-1)+1) = WIRE NUMBER
C         HLIST(4(HIT-1)+2) = COORDINATE IN MM
C         HLIST(4(HIT-1)+3) = NORMALIZED AMPLITUDE
C         HLIST(4(HIT-1)+4) = DRIFT TIME
C
C       THE 4 VECTOR PARTICLE/JETC HIT ASSOCIATION IS STORED IN H4VHTR
C
C         HV4HTR( HIT )     = 2 * PARTICLE_NUMBER + VECT_BANK_NUMBER
C
C  RETURN 1 IF OVERFLOW IN HLIST REGISTER
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL FOUND, ENRLOS, ELOSS, MULSC
C
      DIMENSION X(3), P(7), X1(3), X1PRIM(2), X2PRIM(2), HDRIFT(4)
C
C             THESE 3 COMMONS STORE THE INFORMATION ABOUT
C             THE 4 VECTOR TRACK, WHICH VECT BANK IT IS IN AND
C             THE HIT INFORMATION THAT IS TO BE CREATED BY THIS S/R.
C
      COMMON / CJTCDC / IBANK, IPART
      COMMON / C4VHIT / H4VHTR(400), H4VHIT(4000)
      COMMON / CWORK  / NHITS, INEXT, HLIST(1600)
C
      EQUIVALENCE (HDRIFT(1),HNWTOT),(HDRIFT(2),HIAMPL),
     *            (HDRIFT(3),HIAMPR),(HDRIFT(4),HITIM)
C
      COMMON / CJCELL / NCELL(3),
     *                  NWIRES(3)
      COMMON / CJTRLE / TOTLEN, STPLEN
      COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
C
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
      COMMON / CJIONI / POTBEA, ZAROBE,
     *                  POTTRI, ZAROTR,
     *                  POTIVE, ZAROIV,
     *                  POTRH0, ZAROR0,
     *                  POTJET, ZAROJE,
     *                  POTRH1, ZAROR1,
     *                  POTRH2, ZAROR2,
     *                  POTRH3, ZAROR3,
     *                  POTOVE, ZAROOV,
     *                  POTTOF, ZAROTO,
     *                  POTVES, ZARVES,
     *                  POTZJL, ZAROJL,
     *                  POTZJR, ZAROJR
C
      COMMON / CGEO1  / BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *                  RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *                  R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *                  R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *                  RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *                  ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *                  ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *                  ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *                  XRJETC,
     *                  RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *                  BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *                  XHOL1,XHOL2,YHOL1,YHOL2
C
      COMMON / CJXDAT / XSLOPE, YSLOPE, XL(3), XH(3), R3P, RD3P,
     *                  S, S2,
     *                  XSL3L, X3L, XSL3H, X3H, YSL3L, Y3L, YSL3H,
     *                  YHWIDT, SINHLF, COSHLF, DRITAN
C
      DATA BINWID / 0.005 /
      DATA PMIN / 0.01 /
C
C---------------------------------- C O D E ----------------------------
C
      HNWOLD = 0
C
C                  CHECK FRAME CONDITIONS AND INITIALIZE ANGLES
C
  1   IPOS = 0
      CALL JRCHCK( X, P, IRING, IPOS, IRETRN, &2000, COSAL,SINAL, DRMAX)
      IRETRN = 4
      SINSUS = SINAL
      COSSUS = COSAL
C
      IF( IRING .NE. 3 ) GO TO 10
          IPOS   = SIGN( 1.2, X(2) )
          SINPHI = SIGN( SINHLF, X(2) )
          COSPHI = COSHLF
          SINSUS = SINAL*COSPHI + COSAL*SINPHI
          COSSUS = COSAL*COSPHI - SINPHI*SINAL
          CALL JROTAT( X, COSPHI, SINPHI )
          CALL JROTAT( P, COSPHI, SINPHI )
 10   NWBASE = ICELL*NWIRES(IRING)
      IF( IRING .LT. 3 ) GO TO 20
          NWBASE = NWBASE*2 + NWIRES(2)*NCELL(2)
          IF( IPOS  .GT. 0 ) NWBASE = NWBASE + NWIRES(3)
 20   IF( IRING .GT. 1 ) NWBASE = NWBASE + NCELL(1)*NWIRES(1)
C
C                  INITIALIZE ENERGY LOSS AND MULTIPLE SCATTERING  -----
C
      XTRACK = 0.
      XLIMIT = (( P(6)*P(6)/P(4)/21.E-3*BINWID)**2*XRJETC)**.333333
      XLIMIT = AMIN1( AMAX1(10.,XLIMIT), 100. )
      ETRACK = 0.
      ENRLOS = .FALSE.
      IF(ELOSS.AND.(P(4)/P(5).LT.3..OR.P(5).LT..001)) ENRLOS=.TRUE.
      ELIMIT = AMIN1( 100., 500.*P(6)*P(6))
C
C                  INITIALIZE FIRST PRIMED COORDINATES   -----
C
      XPROJ = X(1) + X(2)*DRITAN
      NW    = ( XPROJ - FSENSW(IRING) ) / RINCR(IRING) +1.5
      DIREC = SWDEPL
      IF( MOD(NW,2) .EQ. 0 ) DIREC = -DIREC
C
      YDOWN = ( X(3) - ZOFFS ) / ZMAX
      YDOWN = YSUSPN*( YDOWN*YDOWN - 1. )
      SX    = FSENSW(IRING) + (NW-1)*RINCR(IRING) + SINSUS*YDOWN
      SY    = DIREC + COSSUS*YDOWN
C
C               -----    START TRACKING ------
C
      DO  1000  ITERAT = 1,400
C
C
         X1(1)  = X(1)
         X1(2)  = X(2)
         X1(3)  = X(3)
         CALL JSTEP( X, P, DRTOT, DRMAX )
C
         TOTLEN = TOTLEN + DRTOT
         XTRACK = XTRACK + DRTOT
         ETRACK = ETRACK + DRTOT
C
C                      CHECK FRAME CONDITIONS FOR X -----
C
         CALL JRCHCK( X, P, IRING, IPOS, IRETRN,
     *                &2000, COSSUS, SINSUS, DRMAX)
C
C
         IF( NW .LT. 1 .OR. NW .GT. NWIRES(IRING) ) GO TO 600
C
             XHELP     = X1(1) - SX
             YHELP     = X1(2) - SY
             X1PRIM(1) = XHELP*DRICOS + YHELP*DRISIN
             X1PRIM(2) = YHELP*DRICOS - XHELP*DRISIN
             XHELP     = X(1) - SX
             YHELP     = X(2) - SY
             X2PRIM(1) = XHELP*DRICOS + YHELP*DRISIN
             X2PRIM(2) = YHELP*DRICOS - XHELP*DRISIN
C
C
C                      FIND DRIFT TIME  IN THIS COORDINATE SYSTEM  -----
C
             ASSIGN 600 TO LABEL
C
 400         CALL JDTIME( X1PRIM, X2PRIM, FOUND, DIST, SLOPE )
             IF( .NOT. FOUND ) GO TO 500
C                              -----    ABSOLUTE WIRE NUMBER
                HNWTOT = NWBASE + NW
C                              -----    DRIFT TIME BINNING
                NRH    = IRING*2
                IF( NW .LE. NWIRES(IRING)/2 ) NRH = NRH - 1
                AITIM  = AMIN1( DIST/TIMDEL(NRH), 32767. )
                HITIM  = AITIM
C                                  -----  Z - AMPLITUDES
                COSANG = SQRT( 1./(1.+SLOPE*SLOPE) +
     *                               (P(1)*P(1)+P(2)*P(2))/(P(6)*P(6)) )
C
                HIAMPL = X(3)+SIGN(0.5,X(3))
                HIAMPR = ZNORM/COSANG+0.5
C
C                            REGISTRATION OF DRIFT TIMES   -----
C
C                                     -----  SAME WIRE NUMBER AS BEFORE
C
                IF( HNWOLD .NE. HNWTOT ) GO TO 460
C
C                                     -----  SMALLER DRIFT TIME
C
                    IF( HLIST(INEXT-1) .LE. HITIM ) GO TO 500
                    GO TO 450
  460           NHITS = NHITS + 1
                INEXT = INEXT + 4
                IF( INEXT .LE. 1601 ) GO TO 450
                   WRITE(6,465)
  465              FORMAT('0MORE THAN 400 JET CHAMBER HITS FOR THIS',
     *                    ' TRACK. EXCESS HITS LOST.')
                   RETURN 1
C
  450           CALL MVC( HLIST, 2*INEXT-10, HDRIFT, 0, 8 )
                HNWOLD = HLIST(INEXT-4)
C
C                     ---- STORE THE TRACK NO. AND BANK NO.
C                     ---- FOR THIS HIT IN H4VHIT
C
                H4VHTR(NHITS) = 2 * IPART + IBANK
C
  500    GO TO LABEL, ( 600, 900 )
C
C
C       -----   CHECK DRIFT TIMES IN PRIMED SYSTEM OF SECOND POINT -----
C
C
C                                    -----  WIRE NUMBER FOR SECOND POINT
 600     NW1   = NW
         XPROJ = X(1) + X(2)*DRITAN
         NW    = ( XPROJ - FSENSW(IRING) ) / RINCR(IRING) + 1.5
         DIREC = SWDEPL
         IF( MOD(NW,2) .EQ. 0 ) DIREC = -DIREC
C
         YDOWN = ( X(3) - ZOFFS ) / ZMAX
         YDOWN = YSUSPN*( YDOWN*YDOWN - 1. )
         SX    = FSENSW(IRING) + (NW-1)*RINCR(IRING)+ SINSUS*YDOWN
         SY    = DIREC + COSSUS*YDOWN
C
C                     ----- END IF SAME NUMBER OR NW OUT OF BOUNDS
C
         IF( NW1.EQ.NW .OR. NW.LT.1 .OR. NW.GT.NWIRES(IRING) ) GO TO 900
C
C
            XHELP     = X1(1) - SX
            YHELP     = X1(2) - SY
            X1PRIM(1) = XHELP*DRICOS + YHELP*DRISIN
            X1PRIM(2) = YHELP*DRICOS - XHELP*DRISIN
            XHELP     = X(1) - SX
            YHELP     = X(2) - SY
            X2PRIM(1) = XHELP*DRICOS + YHELP*DRISIN
            X2PRIM(2) = YHELP*DRICOS - XHELP*DRISIN
C
            ASSIGN  900 TO LABEL
            GO TO 400
C
C
  900    CONTINUE
         IF( TOTLEN .GT. STPLEN ) GO TO 2000
         IF( .NOT. ENRLOS .OR. ETRACK .LT. ELIMIT ) GO TO 930
         CALL JELOSS(P,ETRACK, POTJET, ZAROJE, XRJETC, X, COSSUS,SINSUS)
         ETRACK = 0.
         IF( P(6) .LE. PMIN ) GO TO 2000
 930       IF( .NOT. MULSC .OR. XTRACK .LT. XLIMIT ) GO TO 1000
              CALL JMULSC( P, XTRACK/XRJETC )
              XTRACK = 0.
C
 1000 CONTINUE
C
C
C     ----- ROTATE BACK TO OLD SYSTEM AND REPEAT IF CHANGE IN RING 3 ---
C
 2000 IF( IPOS .EQ. 0 ) GO TO 2100
        CALL JROTAT( X, COSPHI, -SINPHI )
        CALL JROTAT( P, COSPHI, -SINPHI )
        IF( IRETRN .EQ. 6 ) GO TO 1
C
 2100 RETURN
      END

C   14/08/84 408271206  MEMBER NAME  MUPR11   (PWMUS)       FORTRAN
C   16/02/81 104100753  MEMBER NAME  MUPR11   (JADEMUS)     FORTRAN
C   11/02/81 102152052  MEMBER NAME  MUPR11P  (S)           FORTRAN
C   26/03/80 010211752  MEMBER NAME  MUPR11   (JADEMUS1)    FORTRAN
C
C LAST CHANGE 10.30 14/08/84 P. WARMING   - OUTPUT COMMENTED
C      CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C      CHANGE 15.05  19/02/81  HUGH MCCANN.
C                     26/03/80  HUGH MCCANN.
C-----------------------------------------------------------------------
C
      SUBROUTINE MUPR11(NHITS,NWHIT) 
C
C
C  ROUTINE TO PRINT THE MUR1 BANKS 1&2---I.E. THE RESULTS
C  OF THE SIGNAL-TO-COORDINATE CONVERSION PROCEDURE.
C
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
#include "cmubcs.for"
      LOGICAL BADT,BADL,BADX,BADY,BADZ,WOTZ,WOTY,WOTX,FOUR
C
C  FIND MUR1/1 & MUR1/2.
      CALL CLOC(IP11,'MUR1',1)
      IF(IP11.LE.0)GO TO 97
      CALL CLOC(IP12,'MUR1',2)
      IF(IP12.LE.0)GO TO 98
      J12=2*IP11-NWHIT
      J22=2*IP12
      DO 10 I=1,NHITS
      J12=J12+NWHIT
      ICHAM=HDATA(J12+1)/4
      IHIT= HDATA(J12+1)-4*ICHAM+1
      ITD=1
      ITL=1
      IX=1
      IY=1
      IZ=1
      JX=1
      JY=1
      JZ=1
      IFOUR=1
      J22=J22+1
      BADT=.NOT.TBIT(HDATA(J22),14)
      BADL=.NOT.TBIT(HDATA(J22),15)
      BADX=.NOT.TBIT(HDATA(J22),11)
      BADY=.NOT.TBIT(HDATA(J22),12)
      BADZ=.NOT.TBIT(HDATA(J22),13)
      WOTZ=.NOT.TBIT(HDATA(J22),10)
      WOTY=.NOT.TBIT(HDATA(J22),9)
      WOTX=.NOT.TBIT(HDATA(J22),8)
      FOUR=.NOT.TBIT(HDATA(J22),7)
      IF(BADT)ITD=0
      IF(BADL)ITL=0
      IF(BADX)IX=0
      IF(BADY)IY=0
      IF(BADZ)IZ=0
      IF(WOTX)JX=0
      IF(WOTY)JY=0
      IF(WOTZ)JZ=0
      IF(FOUR)IFOUR=0
      IF (I.EQ.1) WRITE(6,100)
      WRITE(6,101)I,ICHAM,IHIT,ITD,ITL,IZ,IY,IX,JZ,JY,JX,IFOUR
  100 FORMAT('0 MUR1/1    MUON COORDINATES'/
     * ' ',19X,'       ....VALIDITY OF....       NORMAL COOR 1.HIT'/
     * '    HIT# CHAMBER HIT       TIME LONG   Z  Y  X         Z  Y ',
     * ' X    LOST')
  101 FORMAT(' ',I5,I9,'  /',I2,5X,I6,I4,2X,3I3,7X,3I3,I8)
   10 CONTINUE
      RETURN
   97 CONTINUE
      WRITE(6,970)
  970 FORMAT('0 ******* MUR1/1 NOT FOUND ********')
      RETURN
   98 CONTINUE
      WRITE(6,980)
  980 FORMAT('0 ******* MUR1/2 NIT FOUND ********')
      RETURN
      END

C   07/06/96 606071817  MEMBER NAME  BGAR     (S4)          FORTG1
      SUBROUTINE BGAR(IGA)
C     BOS SUBPROGRAM =0.7=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
C
C     GARBAGE COLLECTION - ALL ACTIVE BANKS ARE SHIFTED TO BEGIN
      IGA=0
      IF(NFRE.EQ.0) GOTO 100
      NK=1+((10*(NEXT-2))/NLAST)
      NHISTH(NK)=NHISTH(NK)+1
      NK=1+((10*NCPL)/NLAST)
      NK=MIN0(10,NK)
      NHISTL(NK)=NHISTL(NK)+1
      NG  =0
      NSH =0
      LI  =2
      I=NFRS+3
      IF(ILOW.NE.NLST) I=ILOW
      GOTO 12
   10 I=I+NW
   12 IF(I.GT.NEXT) GOTO 30
      IF(IW(I).GE.0) GOTO 20
      IF(NSH.GT.0) GOTO 32
   14 NG=NG-IW(I)
      I=I-IW(I)
      GOTO 12
C
   20 NW=IW(I)+4
      IF(NG.EQ.0) GOTO 10
      LFDK=LI
      IF(I.EQ.IW(LI-1)) GOTO 24
      IF(NSH.EQ.0) GOTO 22
      CALL UCOPY2(IW(ISH),IW(ISH-NG),NSH)
      NSH=0
C     FIND POINTER TO THIS BANK
   22 IW(INAMV)=IW(I-3)
      LFDI=MOD(IABS(IW(I-3)),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 3
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)        GOTO    200
      IF(IW(LFDI-2).LT.IW(I-2)) GOTO 2
      IF(IW(LFDI-2).GT.IW(I-2)) GOTO    200
   24 IW(LFDK-1)=IW(LFDK-1)-NG
      LI=I
      IF(NSH.EQ.0) ISH=I-3
      NSH=NSH+NW
      GOTO 10
C
   30 IF(NSH.EQ.0) GOTO 40
   32 CALL UCOPY2(IW(ISH),IW(ISH-NG),NSH)
      NSH=0
      LI=2
      IF(I.LT.NEXT) GOTO 14
C
   40 NEXT=NEXT-NG
      NFRE=NFRE-NG
      NCOL=NCOL+1
      IGA=1
      ILOW=NLST
C
  100 RETURN
  200 LFDI=I
      CALL BDMPA(32)
      GOTO 100
      END

C   23/06/88 605161741  MEMBER NAME  ZE4VUN   (JADE.S)      F77                 
      SUBROUTINE ZE4VUN( NST, N, IMODE )                                        
C-----------------------------------------------------------                    
C Version of 23/06/88 E Elsen                                                   
C Last Mod   08/11/88 E Elsen                                                   
C                                                                               
C NEW ENTRY ZE4PUN MADE TO WORK                                                 
C NEW ENTRY INCLUDED ZE4PUN                                                     
C NEW FORMAT OF BANK INCLUDED                                                   
C UNPACK MOMENTA FROM ZE4V INTO VECSUB COMMON                                   
C IMODE = 0 charged and gamma                                                   
C       = 1                                                                     
C       = 2 charged and gamma using PID for gamma                               
C       = 3 all neutral clusters                                                
C       = 4 charged only ( all masses pi )                                      
C THE PARTICLES ARE STORED IN                                                   
C NST+1..NST+N, WHERE N IS SET ON EXIT                                          
C    THE INDIVIDUAL POSITIONS ARE:                                              
C   P( 1..7,*)   PX,PY,PZ,E,M,P,CHARGE                                          
C  HP(15   ,*)   Vertex chamber flag                                            
C  HP(16   ,*)   PARTICLE TYPE ( JADE MC-CONVENTION )                           
C  HP(17   ,*)   PART # IN ZE4V BANK                                            
C  HP(18   ,*)   PATR NUMBER OF PHOT PARTNER                                    
C  HP(19   ,*)   PALL NUMBER                                                    
C  HP(20   ,*)   ELECTRON ORIGIN                                                
C-----------------------------------------------------------                    
C                                                                               
      IMPLICIT INTEGER*2 (H)                                                    
C                                                                               
      COMMON / BCS / IW(1)                                                      
      DIMENSION RW(1), HW(1)                                                    
      EQUIVALENCE (HW(1),RW(1),IW(1))                                           
C                                                                               
      COMMON P(10,400)                                                          
      DIMENSION IP(10,100),HP(20,1)                                             
      EQUIVALENCE (P(1,1),IP(1,1),HP(1,1))                                      
C                                                                               
      DIMENSION LADD(-1:2)                                                      
      EQUIVALENCE (LADD(-1),LT)                                                 
C                                                                               
C                                           PARTICLE TYPES                      
C         UNKNOWN, GAMMA,   E,    MU,     PI,    K,    P/N,  LAM                
      REAL*4 XMAS(8) /                                                          
     *     .1396,   0., .511E-3, .1067, .1396, .4937, .939, 1.1156 /            
C                                                                               
      DATA ELGMIN /    .350 /                                                   
      DATA ELGPHM / .150 /                                                      
      LOGICAL FIRST / .TRUE. /, WCHR, WNEU, WPID, ACCEPT                        
      INTEGER PTF, PTFI, CLUST                                                  
C                                                                               
      IF( FIRST ) THEN                                                          
        WRITE(6,*) '+++  ZE4VUN Version of 11/08/88 with ',                     
     *             'Vertex chamber and muon flag'                               
        IPZE4V = IBLN('ZE4V')                                                   
        FIRST = .FALSE.                                                         
      ENDIF                                                                     
C                                                                               
C                                                                               
      N = 0                                                                     
      NPZE4V = IW(IPZE4V)                                                       
      IF( NPZE4V.GT.0 ) THEN                                                    
        WCHR = IMODE.EQ.0 .OR. IMODE.EQ.2 .OR. IMODE.EQ.4                       
        WNEU = IMODE.EQ.0 .OR. IMODE.EQ.2 .OR. IMODE.EQ.3                       
        WPID = IMODE.EQ.2                                                       
C                                      PTF-CODE                                 
C                                      -1=LT/0=LTNE/1=LTCH/2=LTRE               
        LADD(-1) = HW( NPZE4V*2 + 5 )                                           
        LADD(0) = HW( NPZE4V*2 + 9 ) + LADD(-1)                                 
        LADD(1) = HW( NPZE4V*2 + 7 ) + LADD(-1)                                 
        LADD(2) = HW( NPZE4V*2 + 11) + LADD(-1)                                 
        NT = HW(NPZE4V*2 + 6 )                                                  
        NP0 = NPZE4V + HW( NPZE4V*2 + 1 )                                       
        NP = NP0                                                                
        DO 6200 J=1,NT                                                          
          PTF = HW( NP*2 + 18 )                                                 
          IF( ( PTF.EQ.1 .AND. WCHR ) .OR.                                      
     *        ( PTF.EQ.0 .AND. WNEU ) ) THEN                                    
            PTOT = RW(NP+6)                                                     
            ACCEPT = .TRUE.                                                     
            IF( PTF.EQ.0 .AND. WPID ) THEN                                      
C                                           TRY TO FIND TRACK IN CLUSTER        
              CLUST = MOD(HW((NP+LT)*2+8),100)                                  
              JP = NP0                                                          
              DO 6050 I=1,NT                                                    
                PTFI = HW(JP*2+18)                                              
                IF( PTFI.EQ.1 .AND. I.NE.J .AND.                                
     *              CLUST.EQ.MOD(HW((JP+LT)*2+8),100) .AND.                     
     *              MOD(HW(JP*2+8),100).EQ.2 ) THEN                             
                  PTOT = PTOT-RW(JP+6)+ELGMIN/SQRT(1-RW(JP+3)**2)               
                ENDIF                                                           
                JP = JP + LADD(PTFI)                                            
 6050         CONTINUE                                                          
              ACCEPT = PTOT.GT.ELGPHM                                           
            ENDIF                                                               
            IF( ACCEPT ) THEN                                                   
              N = N + 1                                                         
              CALL UCOPY( RW(NP+1), P(1,NST+N), 7 )                             
              P(6,NST+N) = PTOT                                                 
              CALL SMUL( NST+N, NST+N, P(6,NST+N) )                             
              ITYPI = MOD(HW(NP*2+8),100)                                       
              ITYP = ITYPI                                                      
              IF( IMODE .EQ. 4 .AND. ITYP .GT. 1 ) ITYP = 4                     
              P(5,NST+N) = XMAS(ITYP+1)                                         
              P(4,NST+N) = SQRT( P(6,NST+N)**2 + P(5,NST+N)**2 )                
              IF( PTF.EQ.1 ) THEN                                               
                HP(15,NST+N) = HW((NP+LT)*2+26)                                 
              ELSE                                                              
                HP(15,NST+N) = 0                                                
              ENDIF                                                             
C                                           ADD MU QUALITY                      
              IF( ITYPI.EQ. 3 ) THEN                                            
                HP(15,NST+N) = HP(15,NST+N) + 100*IW(NP+LT+12)                  
              ENDIF                                                             
C                                                                               
              HP(16,NST+N) = HW(NP*2 + 8)                                       
              HP(17,NST+N) = J                                                  
              HP(18,NST+N) = HW(NP*2 + 7)                                       
              HP(19,NST+N) = HW(NP*2 +15)                                       
              HP(20,NST+N) = HW(NP*2 +16)                                       
            ENDIF                                                               
          ENDIF                                                                 
          NP = NP + LADD( PTF )                                                 
 6200   CONTINUE                                                                
      ENDIF                                                                     
      RETURN                                                                    
C                                                                               
C                                                                               
C                                                                               
      ENTRY ZE4VAX( NAST, NA )                                                  
C-----------------------------------------------------------                    
C UNPACK AXES FROM ZE4V INTO VECSUB COMMON                                      
C STORED:  NAST+1      SPHERICITY AXIS AND VALUE                                
C          NAST+2      2ND AXIS AND VALUE                                       
C          NAST+3      3RD AXIS AND VALUE                                       
C          NAST+4      THRUST AXIS AND VALUE                                    
C          NAST+5      AKOPLANARITY AXIS AND VALUE                              
C NA = 5 = # OF AXES FILLED ON NORMAL RETURN                                    
C-----------------------------------------------------------                    
C                                                                               
C                                                                               
      NA = 0                                                                    
      NPZE4V = IW(IBLN('ZE4V'))                                                 
      IF( NPZE4V.GT.0 ) THEN                                                    
         CALL UCOPY( RW(NPZE4V+ 9), P(1,NAST+1), 4 )                            
         CALL UCOPY( RW(NPZE4V+13), P(1,NAST+2), 4 )                            
         CALL UCOPY( RW(NPZE4V+17), P(1,NAST+3), 4 )                            
         CALL UCOPY( RW(NPZE4V+21), P(1,NAST+4), 4 )                            
         CALL UCOPY( RW(NPZE4V+25), P(1,NAST+5), 4 )                            
         NA = 5                                                                 
      ENDIF                                                                     
      RETURN                                                                    
      ENTRY ZE4PUN( NPST, NPART )                                               
C-----------------------------------------------------------                    
C UNPACK PARTONS FROM ZE4V INTO VECSUB COMMON                                   
C STORED:  NPST+1      1-ST PARTON 4-VECTOR                                     
C             :                                                                 
C          NPST+N      N-TH PARTON 4-VECTOR                                     
C                                                                               
C NPART = NUMBER OF PARTONS                                                     
C-----------------------------------------------------------                    
C                                                                               
C                                                                               
      NPART = 0                                                                 
      NPZE4V = IW(IBLN('ZE4V'))                                                 
      IF( NPZE4V.GT.0 ) THEN                                                    
                                                                                
        NVX = HW(NPZE4V*2 + 3 )                                                 
C                                      LOOK FOR PARTONS                         
        IF( 31+3*NVX .LT. HW(NPZE4V*2+1) ) THEN                                 
          NPART = HW((NPZE4V+31+3*NVX)*2+1)                                     
          DO 1101 I = 1, NPART                                                  
            CALL UCOPY( RW(NPZE4V+31+3*NVX+4*(I-1)+2), P(1,NPST+I), 4 )         
            CALL LENGTH( NPST+I, P(6,NPST+I) )                                  
            P(5,NPST+I) = SQRT(AMAX1(0.,P(4,NPST+I)**2-P(6,NPST+I)**2))         
            P(7,NPST+I) = 0.                                                    
 1101     CONTINUE                                                              
        ENDIF                                                                   
      ENDIF                                                                     
      RETURN                                                                    
      END                                                                       

C   07/06/96 606071903  MEMBER NAME  PRIBLO   (S4)          FORTG1
      SUBROUTINE PRIBLO(N)
C
C     PRINT ONE EVENT, IF NUMBER OF PRINTED EVENTS
C                      LESS THAN ARGUMENT N
C
      INTEGER M/0/
      IF(M.GE.N) RETURN
      M=M+1
      CALL BSLT
      CALL BPRM
      RETURN
      END

C   16/02/79 107080122  MEMBER NAME  CDATA    (SOURCE)      FORTRAN
C
      COMMON /BCS/ IDATA(24000)
      DIMENSION ADATA(24000)
      INTEGER *2 HDATA(48000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
      DATA LDATA/24000/
C

C   10/05/82 308102131  MEMBER NAME  RDHEAD   (S)           FORTRAN
      SUBROUTINE RDHEAD
C-----------------------------------------------------------
C                             LAST MOD 10/08/83   J.OLSSON
C   SAVE THE DATE IN HEAD WORDS 6-8,. IN HEAD WORDS 96-98
C   THIS IS TO SAVE INFORMATION OF DATE FOR TRACKING OF THE UNSMEARED
C   DATA, WHICH WILL LATER BE OVERWRITTEN BY RDDATE.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1)
      EQUIVALENCE ( HW(1), IW(1) )
      NPHEAD = IW(IBLN('HEAD'))
      IF( NPHEAD .LE. 0 ) GO TO 8000
C
      HW(NPHEAD*2+96) = HW(NPHEAD*2+6)
      HW(NPHEAD*2+97) = HW(NPHEAD*2+7)
      HW(NPHEAD*2+98) = HW(NPHEAD*2+8)
8000  RETURN
      END

C   12/03/84 412041859  MEMBER NAME  PEDFX3   (S)           FORTRAN
C
C
C
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C    SECOND ROUTINE TO ATTEMPT OFFLINE SUBTRACTION OF PEDESTALS
C     FOR EACH 'SUPERBLOCK' OF 3 LEAD SCINTILLATOR ELEMENTS IT
C   CHECKS THAT
C     NOONE CHANNEL IS GREATER THAT 500 MEV,IF THIS IS THE CASE ALL
C  THREE BLOCKS ARE IGNORED , OTHERWISE THE VALUES IN THE BLOCKS ARE
C   USED TO ESTIMATE A MEAN ADC PEDESTAL , WHICH IS THEN SUBTACTED
C   FROMALL BLOCKS.
C
C A.J.FINCH 11/12/82
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TAGPD2
C
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C
       VALUE  = 500.0
       APICKM = 0.0
       APICKP = 0.0
       NUMM   = 0
       NUMP   = 0
C
C
C---                                MINUS Z FIRST
C
C---                                LOOP OVER ALL 8 'CAKESLICES'
C
       DO 10 I = 1,8
C
C---                                LOOP OVER 3 PARTS OF 'CAKESLICE'
C---                                AND TEST FOR ENERGY > 'VALUE'
C
          DO 20 J = 1,17,8
             ITEST = J+I-1
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 10
   20     CONTINUE
C
C   NONE OF THE BLOCKS IN THE 'CAKESLICE' UNDER TEST HAVE FAILED
C   TO BE LESS THAN 'VALUE'
C
C
C---                                SUM ALL NON ZERO BLOCKS IN NON-HIT
C---                                'CAKESLICE' AND COUNT HOW MANY
C---                                THERE ARE
C
          DO 30 L = 1,17,8
             ITEST = I+L-1
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 30
             APICKM = APICKM + CATAG(ITEST)
             NUMM = NUMM + 1
   30     CONTINUE
   10  CONTINUE
C
C
C
C
C
C---                                NOW PLUS Z
C
C
C
C
C
C---                                LOOP OVER ALL 8 'CAKESLICES'
C
       DO 11 I = 25,32
C
C---                                LOOP OVER 3 PARTS OF 'CAKESLICE'
C---                                AND TEST FOR ENERGY > 'VALUE'
C
C
          DO 21 J = 1,17,8
             ITEST = J + I - 1
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 11
   21     CONTINUE
C
C   NONE OF THE BLOCKS IN THE SUPERBLOCK UNDER TEST HAVE FAILED
C   TO BE LESS THAN VALUE
C
C---                                SUM ALL NON ZERO BLOCKS IN NON-HIT
C---                                'CAKESLICE' AND COUNT HOW MANY
C---                                THERE ARE
          DO 31 L = 1,17,8
             ITEST = I + L - 1
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 31
             APICKP = APICKP + CATAG(ITEST)
             NUMP = NUMP + 1
   31     CONTINUE
   11  CONTINUE
C
C
C
C---------------------------------- SUBTRACT PEDESTAL FROM CATAG ARRAY
C
C
C NOW WE HAVE THE VALUE APICKP AND APICKM TO BE SUBTRACTED
C  DO THE SUBTRACTION FROM CATAG ARRAY
C
C
C
C---                                CALC THE MEAN NON ZERO PEDESTAL - Z
C
       IF ( NUMM .LE. 6 ) GOTO 50
       APICKM = APICKM / NUMM
C
C
       DO 40 I = 1,24
          IF ( CATAG(I) .EQ. 0 ) GOTO 40
          CATAG(I) = CATAG(I) - APICKM
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   40  CONTINUE
C
C
C---                                SAME FOR +Z
C
C

*** PMF 15/10/99: new GOTO label introduced behind the 'END DO'-CONTINUE statement at label 41
*   50  IF ( NUMP .LE. 6 ) GOTO 41
   50  IF ( NUMP .LE. 6 ) GOTO 42
*** PMF (end)
C      IF ( NUMP .LE. 4 ) GOTO 41
C
       APICKP = APICKP / NUMP
C
       DO 41 I = 25,48
          IF ( CATAG(I) .EQ. 0 ) GOTO 41
          CATAG(I) = CATAG(I) - APICKP
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   41  CONTINUE
*** PMF 15/10/99: new label added for a former GOTO statement
   42  CONTINUE
*** PMF (end) 
C
C
   51  RETURN
       END

C   29/09/86 901181551  MEMBER NAME  TPWRIT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPWRIT
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       1/10/86:  Write out an event for TP
C
C          mod: C. Bowdery      16/12/87:  LISTNW now CHARACTER array
C          mod: C. Bowdery      27/01/88:  Reduction done here
C          mod: C. Bowdery      23/07/88:  Add new bank names
C          mod: C. Bowdery      27/07/88:  Add TPCHOP
C     Last mod: C. Bowdery      18/01/89:  Add TPMCON
C
C     Routine to check an event and then write it out.
C     If reduction is wanted and the event is rejected, it is written
C     out to a 'reject' dataset.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

C                            Parameters for output unit numbers

#include "units.for"

      PARAMETER  ( NNEWBK = 15 )

      CHARACTER*4  LISTNW( NNEWBK )

      LOGICAL  REJECT

C                            COMMON for output statistics

      COMMON / CTPOUT / NACC, NREJ


      DATA  LISTNW / 'PATR', 'ALGN', 'LGCL', 'MUR1', 'MUR2',
     +               'TPEV', 'TPTR', 'TPVX', 'TOFR', 'JHTL',
     +               'VTXC', 'VPAT', 'VTHT', 'HWDS', 'HHTL'   /

C------------------  C O D E  ------------------------------------------

C                            Chop off the unused part of TPVX/1

      CALL TPCHOP

C                            Check the event

      CALL TPCHCK

C                            Add new bank names to the special list

      CALL BSAW( NNEWBK, LISTNW )

C                            If event reduction wanted, do it.
C                            If REJECT = .TRUE. write event onto
C                            'rejects' output dataset not standard one.

      CALL TPREDC( REJECT )

C                            Ensure that MC constants will be output
C                            if required. Flag may need setting!

      CALL TPMCON( REJECT )

C                            Steer event to the correct output stream:
C                            ACCEPT dataset or the REJECT dataset

      IF( REJECT ) THEN

        CALL EVWRIT( JUNITR )
        NREJ = NREJ + 1

      ELSE

        CALL EVWRIT( JUNITA )
        NACC = NACC + 1

      ENDIF

      CALL TPDIAG

      RETURN
      END

C   20/08/79 106101757  MEMBER NAME  OPUNIT   (JADEGS)      FORTRAN
      SUBROUTINE OPUNIT(JUNIT)
      IMPLICIT INTEGER*2 (H)
C---
C---     REPOSITIONS OUTPUT FILE JUST BEFORE EOF.
C---
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
      NREC=0
      REWIND JUNIT
      WRITE(6,99) JUNIT
   99 FORMAT(' OPUNIT HAS REWOUND THE OUTPUT UNIT, NUMBER',I4)
    1 CONTINUE
      READ(JUNIT,ERR=1000,END=2) NDUMMY
      NREC=NREC+1
      GO TO 1
 1000 CONTINUE
      WRITE(JUSCRN,100)
      WRITE(JUSCRN,101)
      WRITE(JUSCRN,102)
  100 FORMAT(' READ ERROR REPOSITIONING THE OUTPUT FILE.')
  101 FORMAT(' SAVE EDITING RESULTS, STOP SCAN SESSION')
  102 FORMAT(' AND INVESTIGATE OUTPUT FILE IN BATCH.')
      RETURN
    2 CONTINUE
      IF(NREC.LT.1) GO TO 1000
      WRITE(6,98) NREC
   98 FORMAT(' OPUNIT FOUND',I4,' RECORDS ON THE OUTPUT FILE.')
      REWIND JUNIT
      DO 3 IREC=1,NREC
      READ(JUNIT,ERR=1000,END=1000) NDUMMY
    3 CONTINUE
      WRITE(6,97) JUNIT,NREC
   97 FORMAT
     1(' OPUNIT HAS REWOUND UNIT',I4,' AGAIN AND READ',I4,' RECORDS.')
      RETURN
      END

C   20/09/79 102161800  MEMBER NAME  PRPATR   (PATRECSR)    FORTRAN
      SUBROUTINE PRPATR
C
C   ****************************
C   *    PRINT BANK 'PATR'     *
C   ****************************
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
C                              STOP EVENT ANALYSIS AFTER PATREC
C
C     PRINT OUT OF TRACK BANKS
      IP = IDATA(IBLN('PATR'))
   51 IF(IP.LE.0) GOTO 52
        PRINT 2101,IDATA(IP-3),IDATA(IP-2),IDATA(IP-1),IDATA(IP),
     ,             IDATA(IP+1),IDATA(IP+2),IDATA(IP+3),IP
 2101   FORMAT(1H0,A4,8I12)
        IP0 = IP-3
        IP9 = IP+IDATA(IP+1)
        PRINT 2201,(IDATA(I1),I1=IP0,IP9)
 2201   FORMAT(1H0,A4,20I6)
        NTR = IDATA(IP+2)
        LDTR = IDATA(IP+3)
        IF(NTR.LE.0) GOTO 59
          JP0 = IP+IDATA(IP+1) + 1
          JP9 = JP0 + LDTR*NTR - 1
          DO 56 JP1 = JP0,JP9,LDTR
            I0 = JP1
            I9 = I0 + LDTR - 1
            PRINT 2202,(IDATA(I1),I1=I0,I9)
 2202 FORMAT(1H0,2I3,I8,2(I4,3F6.1,3F6.3),
     ,     /,14X,I3,4E13.5,F6.2,I3,4E13.5,
     ,     /,14X,I3,2F8.3,F6.1,I3,10X,6I3,8I6,2X,Z4)
  56      CONTINUE
  59    CONTINUE
        IP = IDATA(IP-1)
      GOTO 51
  52  CONTINUE
C
      RETURN
C
      END

C   23/11/81 311291534  MEMBER NAME  RNCONT   (S)           FORTRAN
      FUNCTION RNCONT(A)
C
C     GENERATES RANDUM NUMBERS
C       F(X) = X**A(1)/(EXP(A(3))+X**A(1))*EXP(A(2)*X)
C
      COMMON /NRNDM/ NRNDM
      DIMENSION A(3)
      DIMENSION YMAX(150),AREA(150)
      DIMENSION Y(151)
      DATA IXDIV/ 15/
      DATA ISW/ 0/
      DATA FACT/ 1.2/
C
C
      XWID=1.5/FLOAT(IXDIV)
C
      ASUM=0.
C
      DO 5 I=1,IXDIV
      X=FLOAT(I-1)*XWID
      Y(I)=X**A(1)/(EXP(A(3))+X**A(1))*EXP(A(2)*X)
    5 CONTINUE
C
      X=1.5
      Y(IXDIV+1)=X**A(1)/(EXP(A(3))+X**A(1))*EXP(A(2)*X)
C
      DO 10 I=1,IXDIV
      YMAX(I)=AMAX1(Y(I),Y(I+1))
      AREA(I)=ASUM+YMAX(I)*XWID
      ASUM=AREA(I)
C     WRITE(6,620) I,XLOW,YMAX(I),AREA(I),ASUM
  620 FORMAT(1H ,I2,' X = ',F15.7,'  YMAX,AREA = ',2F15.7,
     &           '  ASUM = ',F15.7)
   10 CONTINUE
C
      IF(ISW.NE.0) GO TO 100
      ISW=1
      DO 50 I=1,IXDIV
C     WRITE(6,660) I,YMAX(I),AREA(I)
  660 FORMAT(1H ,I3,'  YMAX,AREA = ',2F15.7)
   50 CONTINUE
C
      NRNDM=0
C
  100 RNA=ASUM*RN(DUM)
C
      NRNDM=NRNDM+1
C
      DO 30 I=1,IXDIV
      IF(RNA.LT.AREA(I)) GO TO 200
   30 CONTINUE
C
      STOP
C
  200 XMIN=FLOAT(I-1)*XWID
C
      X=XMIN+XWID*RN(DUM)
      FVAL=RN(DUM)*YMAX(I)*FACT
      IF(FVAL.GT.X**A(1)/(EXP(A(3))+X**A(1))*EXP(A(2)*X)) GO TO 100
C
      RNCONT=X
      RETURN
C
      END

C   08/08/85 807251617  MEMBER NAME  PARDIS   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PARDIS(NN,A,B,C,D,XB,YB,XE,YE,AZ,BZ,XCE,YCE)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON    1/03/79 :  DRAW A PARABOLA SEGMENT
C
C       MOD:   J. OLSSON   10/02/84 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 22/10/84 :  FOR COMMAND VC
C       MOD:   C. BOWDERY   9/08/85 :  FIX CDTL 23 (LG EXTRAPOLATION)
C       MOD:   J. HAGEMANN 20/09/85 :  FOR MAGNIFIED VIEW VC
C       MOD:   J. HAGEMANN 10/12/85 :  FOR SIMFIT AND COMFIT
C       MOD:   J. HAGEMANN 14/04/86 :  CORRECT DISPLAY OF TRACKS IN
C                                      MAGNIFIED VRX VIEW
C       MOD:   J. HAGEMANN 11/07/86 :  CONVERT SOME CODE TO DOUBLE
C                                      PRECISION WERE NECESSARY
C  LAST MOD:   J. HAGEMANN 27/10/87 :  FOR VRX VIEW
C
C       DRAWS A SEGMENT FROM XB,YB TO XE,YE OF THE PARABOLA WITH PARA-
C       METERS A-D. NN IS THE SEGMENTATION OF THE POLYGON APPROXIMATION.
C       THE PARAMETERS ARE: A = ANGLE BETWEEN LOCAL X-AXIS AND DETECTOR
C                           B = X COORDINATE OF LOCAL MINIMUM POINT.
C                           C = Y COORDINATE OF LOCAL MINIMUM POINT.
C                           D = PARABOLA PARAMETER IN  Y = D * X*X
C        XCE,YCE IS THE POINT TO WHICH CLOSEST APPROACH IS FOUND.
C        THE PARABOLA IS "PROJECTED" ACCORDING TO THE Z-COORDINATE, TO
C        AGREE WITH THE PERSPECTIVE "CYLINDER" VIEW.
C        THE Z-COORDINATE IS GOTTEN FROM THE R-Z FIT:  Z = AZ + BZ*R
C
C        IF DSPDTL(23) = TRUE, TRACKS ARE PROLONGED TO LEADGLASS LIMITS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM, FL18, FL22, FL24
      LOGICAL FLVCDO
      LOGICAL TBIT
C
      REAL*8 P,Q,DET,BIGR,COSFI,FIHELP,Y1,Y2,Y3,DXPB,SIGN,U,V
C
#include "cgraph.for"
#include "cgrscl.for"
#include "cgeo1.for"
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CGVCDO / FLVCDO(20)
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
      COMMON / CVCPV  / ICD, DFX, DFY, IRC
      COMMON / CHEADR / HEAD(108)
C
      REAL*8 DTWOPI / 3.141592653589793D0 /
      DATA ZDEEP / 5800.0 /
C
C------------------  C O D E  ------------------------------------------
C
      COSA = COS(A)
      SINA = SIN(A)
C
C                            DEFINE MAX RADIUS FOR DRAWING LINES
C
      RTS  = RLG
      IF( LASTVW .EQ.  1 ) RTS = RTOF
      IF( LASTVW .EQ. 17 ) RTS = 0.33*(XMAX-XMIN)
      RDT = ABS(XMAX-XMIN)/ABS(XMAXST(20)-XMINST(20))
      IF( RDT .LT. 0.5 ) RDT = 1.0
      IF( LASTVW .EQ. 20 ) RTS = R1ROH*RDT*1.1
      XRV = 0.0
      YRV = 0.0
      IF( .NOT.FLVCDO(11) .OR. LASTVW.NE.17 ) GO TO 5
         CALL VTXCRV( INT(HEAD(18)) , XRV, YRV, DXR, DYR ) !PMF 08/11/99: add run argument HEAD(18)
    5 CONTINUE
C
C                            IF NOT VRES AND NOT DRAWING RES BACK TO 0,0
C
      IF( .NOT. DSPDTL(19)  .AND.  LSTCMD .NE. 52 ) GO TO 100
C--
C-- FIND POINT OF CLOSEST APPROACH TO XCE,YCE,BY SOLVING 3D DEGREE EQUA-
C-- TION ARISING FROM THE CONDITION D/DX (DIST)  =  0
C-- USE CARDAN'S FORMULA
C--
      Q   = DBLE( (XCE-B)*COSA + (YCE-C)*SINA)
      P   = DBLE(-(XCE-B)*SINA + (YCE-C)*COSA)
      P   = (1.0D0 - 2.0D0*DBLE(D)*P)/(6.0D0*DBLE(D)*DBLE(D))
      Q   = - Q/(4.*D*D)
      DET = Q*Q + P*P*P
      IF( DET .GT. 0.D0 ) GO TO 50
C                                     DET < 0,  3 REAL SOLUTIONS
         BIGR   = DSQRT(DABS(P))
         IF( Q .LT. 0.0D0 ) BIGR = -BIGR
         COSFI  = Q/(BIGR**3)
         FIHELP = DARCOS(COSFI)
         IF(FIHELP .LT. 0.0D0 ) FIHELP = FIHELP + DTWOPI
         FIHELP = FIHELP/3.0D0
         BIGR   = -2.0D0*BIGR
         Y1     = BIGR*DCOS(FIHELP)
         Y2     = BIGR*DCOS(FIHELP+DTWOPI/3.0D0)
         Y3     = BIGR*DCOS(FIHELP+2.0D0*DTWOPI/3.0D0)
         DXPB   = DMIN1(Y1,Y2,Y3)
         XPB    = SNGL(DXPB)
         GO TO 200
   50 CONTINUE
      DET  = DSQRT(DET)
      SIGN = 1.0D0
      IF( -Q+DET .LT. 0.0D0 ) SIGN = -1.0D0
      U    = (((-Q+DET)*SIGN)**0.3333333333333333D0)*SIGN
      SIGN = 1.0D0
      IF( -Q-DET .LT. 0.0D0 ) SIGN = -1.0D0
      V    = (((-Q-DET)*SIGN)**0.3333333333333333D0)*SIGN
      DXPB = U + V
      XPB  = SNGL(DXPB)
      GO TO 200
  100 CONTINUE
      XPB  = (XB-B)*COSA + (YB-C)*SINA
  200 CONTINUE
      XPE  = (XE-B)*COSA + (YE-C)*SINA
      YPB  = D*XPB*XPB
      DELX = ABS(XPE - XPB)/FLOAT(NN)
      IF( LASTVW .GE. 17 .AND. LASTVW .LE. 19 ) DELX = DELX * .01
      XP   = XPB*COSA - YPB*SINA + B
      YP   = XPB*SINA + YPB*COSA + C
      RP   = SQRT(XP*XP + YP*YP)
      ZP   = AZ + BZ*RP
      IF( LASTVW .NE. 14 ) GO TO 300
         FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
         XP = FP*XP
         YP = FP*YP
  300 CONTINUE
      CALL MOVEA(-XP,YP)
      DO 500  I = 1,NN
         XPB = XPB + DELX
         YPB = D*XPB*XPB
         XP  = XPB*COSA - YPB*SINA + B
         YP  = XPB*SINA + YPB*COSA + C
         RP  = SQRT(XP*XP + YP*YP)
         RP1 = SQRT((XP-XRV)**2 + (YP-YRV)**2)
         ZP  = AZ + BZ*RP
         IF( LASTVW .NE. 14) GO TO 400
            FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
            XP = FP*XP
            YP = FP*YP
  400    CONTINUE
         IF( LASTVW .NE. 20 ) GO TO 450
             IF( RP1 .LT. 35.0 .OR. RP1 .GT. 75.0 ) GO TO 450
                XTN = XP
                YTN = YP
  450    CONTINUE
         IF( RP1 .GT. RTS ) GO TO 600
         IF(.NOT.TBIT(ICD,15) .OR. (TBIT(ICD,15).AND..NOT.FLVCDO(10)) )
     *                                        CALL DRAWA(-XP,YP)
         IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .LT. 0 )
     *                                        CALL DRAWA(-XP,YP)
         IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .GE. 0 )
     *                                        CALL DASHA(-XP,YP,34)
  500 CONTINUE
  600 CONTINUE
      IF( LASTVW.NE.20 ) CALL TRNUMB(ITR,0,XP,YP,ZP)
      IF(LASTVW.EQ.20.AND.TBIT(ICD,14)) CALL TRNUMB(ITR,0,XTN,YTN,ZP)
      IF(LASTVW.EQ.20.AND..NOT.TBIT(ICD,14)) CALL TRNUMB(ITR,0,XB,YB,ZP)
C
      CALL MOVEA(-XP,YP)
C
C                             EXTEND TO TOF OR LG LIMIT
C
      IF(.NOT.DSPDTL(23) .OR. LASTVW.GT.16)  RETURN
      IFLGX = 0
      R2    = RP
      Z2    = ZP
  650 CONTINUE
      XPB   = XPB + DELX
  700 CONTINUE
      YPB   = D*XPB*XPB
      XP    = XPB*COSA - YPB*SINA + B
      YP    = XPB*SINA + YPB*COSA + C
      RP    = SQRT(XP*XP + YP*YP)
      ZP    = AZ + BZ*RP
      IF( IFLGX .NE. 0 ) GO TO 850
C                                   CHECK LIMITS
      IF( ABS(ZP) .LT. ZLGPL ) GO TO 800
         IFLGX = 1
         FAT   = ABS((ABS(ZP) - ZLGPL)/(ZP - Z2))
  750    CONTINUE
         XPB   = XPB - FAT*DELX
         GO TO 700
  800 CONTINUE
      IF( RP .LT. RTS ) GO TO 850
         IFLGX = 2
         FAT   = (RP-RTS)/(RP-R2)
         GO TO 750
  850 CONTINUE
      IF( LASTVW .NE. 14 ) GO TO 900
         FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
         XP = FP*XP
         YP = FP*YP
  900 CONTINUE
      R2 = RP
      Z2 = ZP
      IF(.NOT.TBIT(ICD,15) .OR. (TBIT(ICD,15).AND..NOT.FLVCDO(10)) )
     *                                        CALL DRAWA(-XP,YP)
      IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .LT. 0 )
     *                                        CALL DRAWA(-XP,YP)
      IF( TBIT(ICD,15) .AND. FLVCDO(10) .AND. IRC .GE. 0 )
     *                                        CALL DASHA(-XP,YP,34)
      IF( IFLGX .EQ. 0 ) GO TO 650
      IF( IFLGX .EQ. 1 ) CALL PLYGON(6,10.,-XP,YP,0)
      RETURN
      END

C   31/01/79 106101756  MEMBER NAME  KTMCON0  (JADEGS)      FORTRAN
      FUNCTION KTMCON(ITIME,NOW,INITL)
C---
C---     FUNCTION WHICH CONVERTS INPUT ARRAY "ITIME(6)", WHICH CONTAINS
C---     TIME AT WHICH THE CURRENT EVENT WAS RECORDED: SECONDS, MINUTES
C---     HOURS, DAY OF THE MONTH, MONTH AND YEAR, IN THAT ORDER, INTO
C---     SECONDS ELAPSED SINCE THE BEGINNING OF 1979. THE SECOND ARGU-
C---     MENT "INITL" GIVES A DEFAULT VALUE, WHICH THE FUNCTION ASSUMES
C---     IN CASE THE DATA IN "ITIME" ARE INVALID, E.G. IF THE TIME
C---     SPECIFIED IN "ITIME" IS BEFORE JANUARY 1, 1979 OR AFTER THE
C---     TIME AT WHICH THE PROGRAM IS EXECUTING, OR IF A NON-EXISTENT
C---     MONTH, DAY OR THE MONTH OR TIME OF DAY IS SPECIFIED.
C---
      IMPLICIT INTEGER*2 (H)
      LOGICAL*1 LBREAD
      COMMON/CWORK/HCORE(40)
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG,IERCAL
#include "cgraph.for"
      DIMENSION JETZT(5),ITIME(6),NDPM(12),INTDPM(12)
      DATA NDPM/31,28,31,30,31,30,31,31,30,31,30,31/
      DATA IERR/0/
      DATA ICALL/0/
      IF(ICALL.NE.0) GO TO 1
      ICALL=1
C---
C---     "NDPM" HOLDS THE NUMBER OF DAYS IN EACH OF THE TWELVE MONTHS
C---     OF A NORMAL (NON-LEAP) YEAR. NOW FILL THE ARRAY "INTDPM" WITH
C---     THE CUMULATIVE NUMBERS OF DAYS ELAPSED BETWEEN THE BEGINNING
C---     OF THE YEAR AND THE END OF THE PREVIOUS MONTH.
C---
      INTDPM(1)=0
      DO 2 I=2,12
      INTDPM(I)=INTDPM(I-1)+NDPM(I-1)
    2 CONTINUE
    1 CONTINUE
C---
C---     VERIFY VALIDITY OF INPUT DATA "ITIME".
C---
      IF(ITIME(6).LT.1979) GO TO 3
      IF(ITIME(6).GT.1999) GO TO 3
      IF(ITIME(5).LT.   1) GO TO 3
      IF(ITIME(5).GT.  12) GO TO 3
C---
C---     SET NUMBER OF DAYS IN MONTH SPECIFIED.
C---
      NDTM=NDPM(ITIME(5))
C---
C---     CORRECT IN CASE MONTH IS FEBRUARY AND SPECIFIED YEAR IS A LEAP
C---     YEAR. ALSO SET "NLEAP", THE NUMBER OF LEAP YEARS BETWEEN 1979
C---     AND THE YEAR SPECIFIED IN "ITIME", NOT INCLUDING THE LATTER
C---     YEAR IF IT ITSELF IS A LEAP YEAR.
C---
      LEAP=0
      NLEAP=(ITIME(6)-1977)/4
      IF((ITIME(6)-1977-4*NLEAP).EQ.3) LEAP=1
      IF((ITIME(5).EQ.2).AND.(LEAP.EQ.1)) NDTM=NDTM+1
      IF(ITIME(4).LT.   1) GO TO 3
      IF(ITIME(4).GT.NDTM) GO TO 3
      IF(ITIME(3).LT. 0) GO TO 3
      IF(ITIME(3).GT.23) GO TO 3
      IF(ITIME(2).LT. 0) GO TO 3
      IF(ITIME(2).GT.59) GO TO 3
      IF(ITIME(1).LT. 0) GO TO 3
      IF(ITIME(1).GT.59) GO TO 3
C---
C---     "NDAYS" IS THE NUMBER OF DAYS ELAPSED BETWEEN THE BEGINNING
C---     OF 1979 AND THE END OF THE DAY BEFORE THE DAY SPECIFIED IN
C---     "ITIME", THUS THE SUBTRACTION OF ONE AT THE LINE BELOW.
C---
      NDAYS=365*(ITIME(6)-1979)+NLEAP+INTDPM(ITIME(5))+ITIME(4)-1
C---
C---     CORRECT NDAYS IN CASE THE DATE SPECIFIED IN "ITIME" IS AFTER
C---     FEBRUARY 29 IN A LEAP YEAR.
C---
      IF(ITIME(5).GT.2) NDAYS=NDAYS+LEAP
      NSEC=86400*NDAYS+3600*ITIME(3)+60*ITIME(2)+ITIME(1)
C---
C---     "NSEC" IS THE NUMBER OF SECONDS FROM THE BEGINNING OF 1979
C---     UNTIL THE CURRENT EVENT WAS RECORDED. IDEALLY THE TIME THE
C---     EVENT WAS RECORDED SHOULD BE IN THE PAST. GET PRESENT TIME
C---     FROM THE IBM.
C---
      CALL DAY2(JETZT)
C---
C---     "JETZT(5)" HOLDS, IN THE FOLLOWING ORDER, THE LAST TWO DIGITS
C---     OF THE YEAR, THE DAY OF THE YEAR COUNTING JANUARY 1 AS DAY ONE,
C---     AND THE HOURS, MINUTES AND SECONDS OF THE TIME OF DAY.
C---
      NLEAP=(JETZT(1)-77)/4
      NDAYS=365*(JETZT(1)-79)+NLEAP+JETZT(2)-1
      NOW=86400*NDAYS+3600*JETZT(3)+60*JETZT(4)+JETZT(5)
      IF(NSEC.LT.NOW) GO TO 4
    3 CONTINUE
C---
C---     THE INPUT TIME IS INVALID. SET FUNCTION TO DEFAULT SPECIFIED
C---     IN THE ARGUMENT FIELD.
C---
      NSAVE=NSEC
      NSEC=INITL
      IERR=IERR+1
      IF(IERR.GT.20) GO TO 4
      WRITE(6,100)
  100 FORMAT('0KTMCON CALLED WITH INVALID INPUT.')
      WRITE(6,101) ITIME,NSAVE
  101 FORMAT(' ITIME AND NSAVE=',6I5,I15)
      WRITE(6,102) JETZT,NOW
  102 FORMAT(' JETZT AND NOW=  ',5I5,I20)
      WRITE(6,103) NSEC
  103 FORMAT(' FUNCTION SET TO DEFAULT:',I15)
    4 CONTINUE
      KTMCON=NSEC
      IERCAL = IERR
      RETURN
      END

C   12/03/84 412041852  MEMBER NAME  CLSPS1   (S)           FORTRAN
C
        SUBROUTINE TAGPS1(SUM,IWRITE)
C
C WORK OUT CENTRE OF CLUSTER FOR 1981/2 TAGGER
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C----------------------  C O D E  --------------------------------------
C
C
       TEST1 = SUM * 0.999
       TEST2 = SUM * 0.025
       XCORR = 0.0
       YCORR = 0.0
       SIGX  = 20.0
       SIGY  = 20.0
C
C
       CAND(1) = CLUS(1,2)
       IF ( CAND(1) .LT. 0.0 ) GOTO 9010
       ADDRES  = CLUS(1,1)
       CAND(2) = XMAP (ADDRES)
       CAND(3) = YMAP (ADDRES)
       IF ( CAND(1) .GT. TEST1 ) GOTO 10
C
C
C FIT TO RATIO OF ENERGIES FOR HIT BLOCK
C AND NEXT LARGEST HIT BLOCK
C
       CALL TAGFIT(2,XFIT,YFIT,IWRITE,*10)
C
       XCORR = XFIT
       YCORR = YFIT
C
C SOPHISTICATED CALCULATION OF ERROR ON X
C
       IF ( XCORR .GT. 5 ) SIGX = 5
       IF ( YCORR .GT. 5 ) SIGY = 5
C
C ALSO FIT TO 3RD BLOCK ,IF IT HAS SIGNIFICANT FRACTION OF ENERGY
C
       IF ( CLUS(3,2) .LT. TEST2 ) GOTO 10
       CALL TAGFIT(3,XFIT,YFIT,IWRITE,*10)
C
C CHOOSE ONE OF THE TWO FIT RESULTS - WHICHEVER IS THE LARGEST
C
       IF ( ABS(XFIT) .GT. ABS(XCORR) ) XCORR = XFIT
       IF ( ABS(YFIT) .GT. ABS(YCORR) ) YCORR = YFIT
C SOPHISTICATED CALCULATION OF ERROR ON X
       IF ( XCORR .GT. 5 ) SIGX = 5
       IF ( YCORR .GT. 5 ) SIGY = 5
C
C NOW ADD XCORR (CORRECTION ON X) TO X
C AND SIMILARLY Y
C
   10  CONTINUE
       CAND(2) = CAND(2) + XCORR
       CAND(3) = CAND(3) + YCORR
C
C CAND(1) = ENERGY OF CLUSTER - ONLY FIRST 4 MEMBERS
C
       CAND(1) = CLUS(1,2) + CLUS(2,2) + CLUS(3,2) + CLUS(4,2 )
       IF ( CAND(1) .LT. 0.0 ) GOTO 9010
       SIGEN = 0.20 * SQRT( CAND(1) )
C
C DEBUG - WRITE OUT RESULT
C
       IF ( IWRITE .EQ. 1 ) WRITE(6, 601) ((CLUS(I,J),I=1,9),J=1,2)
  601  FORMAT(' ++++ TAGPS1 : DEBUG  -  CLUS ARRAY ==>',/,
     *           2(9(1X,F8.2),/) )
       IF ( IWRITE .EQ. 1 ) WRITE(6,602) CAND(1 ) ,CAND(2 ) ,CAND(3)
  602  FORMAT(' CLUSTER INFO ENERGY X Y ',3(2X,F12.2) )
C
C---------------------------------------- R E T U R N ------------------
C
       RETURN
C
C
C---ERRORS :
C
C---                                      ENERGY < 0
C
 9010  WRITE(6,9011) ((CLUS(I,J),I=1,9),J=1,2)
       WRITE(6,602) CAND(1 ) ,CAND(2 ) ,CAND(3)
 9011  FORMAT(' ++++ TAGPS1 : NEGATIVE ENERGY  -  CLUS ARRAY ==>',/,
     *           2(9(1X,F8.2),/) )
       RETURN
       END

C   07/06/96 606071902  MEMBER NAME  PMEAN    (S4)          FORTG1
      SUBROUTINE PMEAN(NA)
      COMMON/BCS/IW(1)
      REAL Q(10)
      IF(NA.EQ.0) GOTO 10
      CALL BLOC(IND,'MEA*',NA,&100)
      GOTO 30
   10 CALL BPOS('MEA*')
   20 CALL BNXT(IND,&100)
   30 NNA=IW(IND-2)
      KAMAX=IW(IND)/50+1
      IP=0
      DO 40 K=1,KAMAX
      KA=K-1
      CALL QMEAN(NNA,KA,Q)
      IF(Q(1).EQ.0.0) GOTO 40
      IF(IP.EQ.1) GOTO 35
      WRITE(6,101) NNA
      IP=1
   35 WRITE(6,102) KA,Q
   40 CONTINUE
      IF(NA.EQ.0) GOTO 20
  100 RETURN
  101 FORMAT('0-------------'/' UMEAN',I8,' KA ENTRIES',5X,'MEAN',
     1   7X,'TRMEAN',7X,'MEDIAN',5X,'SIGMA',5X,'-LEFT',4X,'-RIGHT',
     2   5X,'OUT',4X,'X - RANGE')
  102 FORMAT(12X,I5,F8.0,3G13.5,3G10.3,F4.0,2G10.3)
      END

C   20/08/86 608281851  MEMBER NAME  PRJ68K   (S)           FORTRAN77
      SUBROUTINE PRJ68K( XS, YS, DEL, SIZE, IRETUR )
C-----------------------------------------------------------
C    VERSION OF 26/08/86    LAST MOD 26/08/86   E ELSEN
C    PRINT ROUTINE FOR J68K BANK UNDER GRAPHICS
C    IRETUR IS AN I/O ARGUMENT. FOR IRETUR.GT.0 P/O WILL
C    CONTINUE AFTER LAST LINE OUTPUT.
C    IF IRETUR.EQ.0 A NEW P/O WILL BE INITIALISED.
C    IRETUR > 0 ON EXIT IF P/O IS NOT YET COMPLETE
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C
      COMMON / CWORK1 / HWORK(80)
      CHARACTER*160 CLINE
      EQUIVALENCE (CLINE,HWORK(1))
C
C
      INTEGER PRC2CL
      INTEGER OLDWIR
C
      DATA IPRINT / 0 /, IPRLIM / 0 /
C
      EXTERNAL CL2PRC
C                                           INIT LINE COUNTER
      LINE = 0
      IF( IRETUR .EQ. 0 ) LINE = -1
C
      NPJ68K = IW(IBLN('J68K'))
      IF( NPJ68K.GT.0 ) THEN
C                                           PRINT J68K HEAD
        WRITE(CLINE,9101)
 9101   FORMAT(' J68K HEAD  STATUS(HEX) LENGTH       FEP',
     *         '   GENERAL SCAN_DATA  RAW-DATA')
        CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
        WRITE(CLINE,9102) (HW(NPJ68K*2+I),I=1,HW(NPJ68K*2+4))
 9102   FORMAT((2I5,8X,Z4,1I8,4I10))
        CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
C
C                                           FEP SECTION
        NPFEP = HW(NPJ68K*2+5)
        IF( NPFEP.GT.0 ) THEN
          NPFEP = NPFEP + NPJ68K*2
          L0 = HW(NPFEP+1)
          L1 = HW(NPFEP+2)
          WRITE(CLINE,9111) L0, L1
 9111     FORMAT('  FEP-SECTION:  PROCESSOR   STATUS(HEX)',
     *                         'TOTAL LENGTH=',I6,' WORDS/PROC=',I3)
          CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
          J = 2
  100     IF( J .LT. L0 ) THEN
            WRITE(CLINE,9112) (HW(NPFEP+J+I),I=1,L1)
 9112       FORMAT(20X,I4,10X,Z4)
            CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
            J = J + L1
            GO TO 100
          ENDIF
        ENDIF
C
C                                           SCAN DATA SECTION
        NPSCAN = HW(NPJ68K*2+7)
        IF( NPSCAN.GT.0 ) THEN
          NPSCAN = NPSCAN + NPJ68K*2
          NCRATE = HW(NPSCAN+1)
          WRITE(CLINE,9131) NCRATE
 9131     FORMAT('  SCAN-SECTION WITH DATA FOR ',I6,' DL300 CRATES')
          CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
          NPSCAN = NPSCAN + 1
C
          DO 390 ICRATE=1,NCRATE
            L2 = HW(NPSCAN+1)
            IDL300 = HW(NPSCAN+2)
            OLDWIR = -1
            WRITE(CLINE,9132) IDL300, PRC2CL(IDL300),
     *                      PRC2CL(IDL300)+2, L2
 9132       FORMAT('   LENGTH OF SCAN_DATA FOR DL300 CRATE',I3,
     *             ' (CELL ',I2,'-',I2,') IS ',I6,' HALF WORDS')
            CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
            IF( L2 .GT. 0 ) THEN
              NPSCAN = NPSCAN + 2
              LPT0 = 2
  310         IF( LPT0 .GE. L2 ) GO TO 380
                L3 =  HW(NPSCAN+1)
                LPT0 = LPT0 + L3
                IF( L3.GT.5 ) THEN
                  IWIRE = HW(NPSCAN+2)/256
                  ITOFF = HW(NPSCAN+2) - IWIRE*256
                  IPEDL = HW(NPSCAN+3)
                  IPEDR = HW(NPSCAN+4)
                  IAFAC = HW(NPSCAN+5)
                  IF( IWIRE .EQ. OLDWIR ) GO TO 370
                    WRITE(CLINE,9133)
                    CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
 9133               FORMAT('    WIRE->ABS   T0 PEDESTALS AFAC',
     *                     '  PULSETRAIN (  L/ R )')
  370             OLDWIR = IWIRE
                  NPSCAN = NPSCAN + 5
                  L3 = L3 - 5
                  WRITE(CLINE,9134) IWIRE, IWIRE+PRC2CL(IDL300)*16,
     *                          ITOFF, IPEDL, IPEDR, IAFAC,
     *                 (HW(NPSCAN+I)/256,LAND(HW(NPSCAN+I),255),
     *                                 I=1,MIN0(18,L3))
 9134             FORMAT(3X,6I5,18(I3,I3,'|'))
                  CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
                  DO 375 K=18, L3-1, 18
                    WRITE(CLINE,9135)
     *                   (HW(NPSCAN+K+I)/256,LAND(HW(NPSCAN+K+I),255),
     *                                   I=1,MIN0(L3-K,18))
 9135               FORMAT((33X,18(I3,I3,'|')))
                    CALL J68KLI( XS, YS, DEL, SIZE, LINE, &8000 )
  375             CONTINUE
                ENDIF
                NPSCAN = NPSCAN + L3
                GO TO 310
  380         CONTINUE
            ENDIF
  390     CONTINUE
        ENDIF
      ENDIF
C                                           NORMAL EXIT
C                                           P/O COMPLETE
      IRETUR = 0
      RETURN
C                                           SET DEFAULT IRETUR FOR
C                                           INCOMPLETE P/O
 8000 IRETUR = 27
      RETURN
      END
      SUBROUTINE J68KLI( XS, YS, DEL, SIZE, LINE, * )
      IMPLICIT INTEGER*2 (H)
      COMMON / CWORK1 / HWORK(80)
      CHARACTER*160 CLINE
      EQUIVALENCE (CLINE,HWORK(1))
      INTEGER LLINE / 0 /
C
      IF( LINE.LT.0 ) THEN
        LLINE = 0
        LINE = 0
      ENDIF
      IF( LINE .GE. LLINE ) THEN
        YS = YS - DEL
        IF( YS .LE. 50 ) RETURN 1
        L = LENGCH(CLINE)
        CALL SYSSYM( XS, YS, SIZE, HWORK, L, 0. )
        LLINE = LLINE + 1
      ENDIF
      LINE = LINE + 1
      END
      INTEGER FUNCTION LENGCH(STRING)
      CHARACTER*(*) STRING
      L = LEN(STRING)
  100 IF( L.GT.0 ) THEN
        IF( STRING(L:L) .NE. ' ' )  GO TO 200
        L = L - 1
        GO TO 100
      ENDIF
  200 LENGCH = L
      END

C   11/09/78 C8100201   MEMBER NAME  JPRTHI0  (CS7)         FORTRAN
      SUBROUTINE JPRTHI( R, P, PENETR, PENETZ, BARLOW, RHIGH,
     *                   ZLOW, ZHIGH, *, *, *, * )
C  *--------------------------------------------------------
C  *
C  *  VERSION OF 02/10/78
C  *  PROPAGATES PARTICLE IN NON ABSORBING MEDIUM
C  *  DEFINED BY BARLOW, RHIGH, ZLOW, ZHIGH.
C  *  UPON RETURN PENET((R) OR (Z)) IS PENETRATION LENGTH
C  *  IN NEXT ELEMENT IN R OR Z DIRECTION.
C  *  RETURN  : NEXT ELEMENT, INCREASING R
C  *  RETURN1 : NEXT ELEMENT, DECREASING R
C  *  RETURN2 : NEXT ELEMENT, INCREASING Z
C  *  RETURN3 : NEXT ELEMENT, DECREASING Z
C  *  RETURN4 : PARTICLE STOPPED IN SYSTEM OR DECAY CONDITION
C  *            REACHED.
C  *--------------------------------------------------------
C
       DIMENSION R(5), P(7)
      COMMON / CJTRLE / TOTLEN, STPLEN
C
      COMMON / CJCELL / NCELL(3),
     *                  NWIRES(3)
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
C
      DATA TWOPI / 6.283185 /
C
      IF( R(4) .GT. RHIGH ) RETURN
      IF( R(3) .GT. ZHIGH ) RETURN2
      IF( R(3) .LT. ZLOW  ) RETURN3
C
      PENETZ = 0.
      PENETR = 0.
      DPSI =  TWOPI / FLOAT( NCELL(1) )
C
      DO 100 ITERAT = 1,300
C
         R(5) = ATAN2( R(2), R(1) )
                IF( R(5) .LT. PSIIN(1) ) R(5) = R(5) + TWOPI
                NPHI = ( R(5) - PSIIN(1) ) / DPSI
                DPHI = R(5) - ( FLOAT( NPHI ) + .5 ) *DPSI - PSIIN(1)
      IF( R(4)*COS( DPHI ) .LT. BARLOW ) RETURN 1
C
      CALL JSTEP( R, P, DRTOT )
        R(4) =  SQRT( R(1)*R(1) + R(2)* R(2) )
C      TOTAL TRACK LENGTH BIGGER THAN MAXIMUM VALUE?
              TOTLEN = TOTLEN  + DRTOT
              IF( TOTLEN .GT. STPLEN ) RETURN4
C
      IF( R(4) .LE. RHIGH ) GO TO 110
          PENETR = R(4) - RHIGH
          RETURN
  110 IF( R(3) .LE. ZLOW .AND. R(3) .LE. ZHIGH )  GO TO 100
          PENETZ = ZLOW - R(3)
          IF( PENETZ .GT. 0. ) RETURN 3
          PENETZ = R(3) - ZHIGH
          IF( PENETZ .GT. 0. ) RETURN 2
C
C
  100 CONTINUE
C
      RETURN 4
      END

C   01/11/84 807251545  MEMBER NAME  FICOOV   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FICOOV( IFLAG, NIV, NWEV, IM, IPTRK )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   02/12/82 :  CALCULATE COORDINATES OF
C              R. RAMCKE                 VERTEX CHAMBER HITS
C
C         MOD: J. HAGEMANN   10/10/84  : NOW OWN MEMBER (FROM EVDISP)
C         MOD: J. HAGEMANN   05/03/86  : CHANGES FOR REAL AND MC DATA
C         MOD: J. HAGEMANN   18/04/86  : CHANGES FOR REAL DATA
C    LAST MOD: J. HAGEMANN   27/01/88  : FOR VTXC-9 CORRECTION
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL TBIT, FL18, FL22, FL24
C
#include "cgraph.for"
#include "cdata.for"
#include "cjvcel.for"
#include "cjvtxc.for"
#include "mvccal.for"
C
      COMMON/CWORK1/R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,EX,EY,COSPH,SINPH
     +             ,KZAMP
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CHEADR / HEAD(108)
      COMMON / CVX    / NNPATR,NDUMM,NNJETC,NNVTXC
C
C-----------------  C O D E  -------------------------------------------
C
      IPRJC = 0
C
C                       COMPUTE FI OF WIRE, RADIUS ETC.
      NIWV = HDATA(NIV)
      IF( NIWV .LE. 168 .AND. NIWV .GT. 0 ) GO TO 10
         CALL DIAGIN('ILLEGAL WIRE NO.    ',2,NIWV,NIV)
         CALL TRMOUT(80,'THIS CAN HAVE SEVERAL REASONS, E.G. WRONG POINT
     $ERS, WRONG BANK LENGTH OR^')
         CALL TRMOUT(80,'(LESS LIKELY), CORRUPT DATA. THE DISPLAY OF VER
     $TEX CHAMBER HITS STOPS HERE.^')
         NWEV = -1000
         RETURN
C
   10 NCEV = (NIWV - 1)/ 7
      NWEV = NIWV - NCEV*7
      VANG = 0.0
      IF( HEAD(18) .GT. 100 ) VANG = VROT
C
      IF( DSPDTL(26) .AND. TBIT(NWEV,31) ) GO TO 100
C
      R  = DISTW1 + FLOAT(NWEV-1)*DISTPW
      FI = ANG1 + NCEV*ANG2 + VANG
      IF( FI .LT. 0.0 )   FI = FI + TWOPI
      IF( FI .GT. TWOPI ) FI = FI - TWOPI
      IF( IFLAG .NE. 1 ) GO TO 20
C                        DECIDE POS/NEG X OR Y
      IF( DSPDTL(9) ) R = R*WRAP(FI)
C                        COORDINATE CALCULATIONS
   20 CONTINUE
      NIV = NIV + 1
C                        GET Z-COORDINATE
      IAV1 = HDATA(NIV)
      IAV2 = HDATA(NIV + 1)
      IF( (IAV1 + IAV2) .GT. 0 ) GOTO 30
        ZET = 0.
        GOTO 40
   30 ZET = ZALV * .5 * FLOAT(IAV1 - IAV2)/FLOAT(IAV1 + IAV2)
C
   40 NIV = NIV + 2
      IF( FL18 .AND. FL22 ) GO TO 50
      IF((IFLAG .EQ. 1).AND.DSPDTL(9).AND.(.NOT.DSPDTL(10))) GO TO 90
C                        DRIFT TIME
   50 NDTV = HDATA(NIV)
      RDTV = FLOAT(NDTV)
      COSPH = COS(FI)
      SINPH = SIN(FI)
      XXX = ABS(R)*COSPH
      YYY = ABS(R)*SINPH
C
      IF( HEAD(18) .GT. 100) GO TO 60
C                            MONTE CARLO
         FIDR = RDTV*DRVELO(NCEV+1)
         EX = -SINPH*COSLOR - COSPH*SINLOR
         EY =  COSPH*COSLOR - SINPH*SINLOR
         IF( IM .NE. 1 ) GO TO 55
C
            IF( IDATA(IPTRK + 18) .EQ. 1 ) GO TO 51
C
               ALF = ADATA(IPTRK + 19)
               CRV = ADATA(IPTRK + 22)*2.0
               IF( ABS(CRV) .LT. 1.0E-8 ) CRV = SIGN(1.0E-8,CRV)
               XC  = -SIN(ALF)/CRV + ADATA(IPTRK + 20)
               YC  =  COS(ALF)/CRV + ADATA(IPTRK + 21)
               CHG = -SIGN(1.0,ADATA(IPTRK + 22))
               GO TO 52
   51       CONTINUE
C
               ALF = ADATA(IPTRK + 21)
               CRV = ADATA(IPTRK + 19)
               IF( ABS(CRV) .LT. 1.0E-8 ) CRV = SIGN(1.0E-8,CRV)
               RAD = 1.0/CRV + ADATA(IPTRK + 20)
               XC  = COS(ALF)*RAD
               YC  = SIN(ALF)*RAD
               CHG = SIGN(1.0,ADATA(IPTRK + 25))
C
   52       CONTINUE
C
            RDF = DISTPW*0.5*COSLOR
            RF  = DISTW1 + 3.0*DISTPW
            XF  = RF*COSPH - XC
            YF  = RF*SINPH - YC
            RR  = SQRT(XF**2 + YF**2)*CHG
            CSB = XF/RR
            SNB = YF/RR
C
            IF( FIDR .LT. RDF ) GO TO 53
C
               XDR = (FIDR - RDF)*EX + RDF*CSB
               YDR = (FIDR - RDF)*EY + RDF*SNB
               GO TO 54
C
   53       CONTINUE
C
               XDR = FIDR*CSB
               YDR = FIDR*SNB
C
   54       CONTINUE
C
            X1 = XXX - XDR
            Y1 = YYY - YDR
            X2 = XXX + XDR
            Y2 = YYY + YDR
            GO TO 70
C
   55    AAA = FIDR*EX
         BBB = FIDR*EY
         X1  = XXX - AAA
         Y1  = YYY - BBB
         X2  = XXX + AAA
         Y2  = YYY + BBB
         GO TO 70
C                            REAL
   60 CONTINUE
      ADNSK2 = 0.0
      IF( NNVTXC .NE. 9 ) GOTO 199
         IPED   = MOD(IAV1,256)
         ICA1   =  IAV1/256 - IPED
         ICA2   =  MOD(IAV2,256) - IPED
         ADNSK2 = CRVT9(ICA1,ICA2)
  199 CONTINUE
      FIDR1 = (RDTV - T0)*VD*CVD(1,NIWV) - S0R(1,NIWV)
      CRR = 0.0
C
      DRIFT = FIDR1
      ISD = 1
      IF (DRIFT.GT.0.0) GOTO 201
         ISD = 2
         DRIFT = -DRIFT
  201 CONTINUE
C
      IDL = IFIX(DRIFT+0.5)
      IDH = IDL + 1
      IF (IDL.GE.1)  GOTO 202
      CRR = VIHCRR(NWEV,ISD,1)
      GOTO 205
C
  202 CONTINUE
      IF (IDH.LE.25)  GOTO 203
      CRR = VIHCRR(NWEV,ISD,25)
      GOTO 205
C
  203 CONTINUE
      WL = FLOAT(IDH) - 0.5 - DRIFT
      WH = DRIFT - FLOAT(IDL) + 0.5
      CRR = WL*VIHCRR(NWEV,ISD,IDL) + WH*VIHCRR(NWEV,ISD,IDH)
C
  205 CONTINUE
C
      FIDR1 = FIDR1 - CRR - ADNSK2
C
      FIDR2 = (RDTV - T0)*VD*CVD(2,NIWV) - S0R(2,NIWV)
      CRR = 0.
C
      DRIFT = FIDR2
      ISD = 2
      IF (DRIFT.GT.0.0) GOTO 211
         ISD = 1
         DRIFT = -DRIFT
  211 CONTINUE
C
      IDL = IFIX(DRIFT+0.5)
      IDH = IDL + 1
      IF (IDL.GE.1)  GOTO 212
      CRR = VIHCRR(NWEV,ISD,1)
      GOTO 215
C
  212 CONTINUE
      IF (IDH.LE.25)  GOTO 213
      CRR = VIHCRR(NWEV,ISD,25)
      GOTO 215
C
  213 CONTINUE
      WL = FLOAT(IDH) - 0.5 - DRIFT
      WH = DRIFT - FLOAT(IDL) + 0.5
      CRR = WL*VIHCRR(NWEV,ISD,IDL) + WH*VIHCRR(NWEV,ISD,IDH)
C
  215 CONTINUE
C
      FIDR2 = FIDR2 - CRR - ADNSK2
C
      ZH1 = 0.0
      ZH2 = 0.0
C
      XH1   = ABS(R) + FIDR1*SNLOR
      YH1   = -FIDR1*CSLOR
      XH2   = ABS(R) - FIDR2*SNLOR
      YH2   =  FIDR2*CSLOR
C
      IF( IM .NE. 1 ) GO TO 61
         P1   = ADATA(IPTRK+30)
         P2   = ADATA(IPTRK+31)
C
         RH1  = SQRT(XH1**2 + YH1**2)
         ZH1  = P1*RH1 + P2
         RH2  = SQRT(XH2**2 + YH2**2)
         ZH2  = P1*RH2 + P2
   61 CONTINUE
C
      VDXX1  = VDX + VZX*ZH1
      VDYY1  = VDY + VZY*ZH1
      VZROT1 = VFREE(50)*ZH1
      VDXX2  = VDX + VZX*ZH2
      VDYY2  = VDY + VZY*ZH2
      VZROT2 = VFREE(50)*ZH2
C
      SNNEW1 = SINPH + COSPH*VZROT1
      CSNEW1 = COSPH - SINPH*VZROT1
      SNNEW2 = SINPH + COSPH*VZROT2
      CSNEW2 = COSPH - SINPH*VZROT2
C
      X1 = XH1*CSNEW1 - YH1*SNNEW1 + VDXX1
      Y1 = YH1*CSNEW1 + XH1*SNNEW1 + VDYY1
      X2 = XH2*CSNEW2 - YH2*SNNEW2 + VDXX2
      Y2 = YH2*CSNEW2 + XH2*SNNEW2 + VDYY2
C
   70 R1  = SQRT(X1*X1 + Y1*Y1)
      FI1 = ATAN2(Y1,X1)
      R2  = SQRT(X2*X2 + Y2*Y2)
      FI2 = ATAN2(Y2,X2)
      IF( FI1 .LT. 0.0 ) FI1 = FI1 + TWOPI
      IF( FI2 .LT. 0.0 ) FI2 = FI2 + TWOPI
      IF( DSPDTL(9) ) R1 = R1*WRAP(FI1)
      IF( DSPDTL(9) ) R2 = R2*WRAP(FI2)
      IF( .NOT. FL22 .OR. .NOT. FL18 ) GO TO 80
         IF( -X1 .LT. XMINR .OR. -X1 .GT. XMAXR ) IPRJC = 1
         IF( -X2 .LT. XMINR .OR. -X2 .GT. XMAXR ) IPRJC = 1
         IF(  Y1 .LT. YMINR .OR.  Y1 .GT. YMAXR ) IPRJC = 1
         IF(  Y2 .LT. YMINR .OR.  Y2 .GT. YMAXR ) IPRJC = 1
   80 CONTINUE
   90 NIV = NIV + 1
      RETURN
  100 NWEV = 0
C                       ENTER HERE FOR MISSING EVEN WIRE HITS
      NIV = NIV + 4
      RETURN
      END

C   12/03/84 406221856  MEMBER NAME  ACOL     (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE ACOL(M,P,THETA)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE CALCULATES THE ANGLE BETWEEN A CLUSTER IN - Z TAGGER
C AND ONE IN + Z TAGGER
C
C M - INPUT - POINTER TO CLUSTER IN - Z PART OF ATAGG2
C P - INPUT - POINTER TO CLUSTER IN + Z PART OF ATAGG2
C
C THETA - OUTPUT - ANGLE BETWEEN THEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IMPLICIT INTEGER * 2 (H)
      INTEGER P
#include "ctaggo.for"
C
C
C------------------- C O D E -------------------------------------------
C
C
C                                   CALCULATE POINTERS
C
      MIB = (M - 1) * HWPCL
      PIB = (P - 1) * HWPCL
C
C                                   FETCH DIRECTION COSINES
C
      AMDX = ATAGG2(MIB + 11)
      AMDY = ATAGG2(MIB + 12)
      AMDZ = ATAGG2(MIB + 13)
      APDX = ATAGG2(PIB + 11)
      APDY = ATAGG2(PIB + 12)
      APDZ = ATAGG2(PIB + 13)
C
C                                   CALCULATE THETA
C
      THETA = ACOS( AMDX * APDX  +  AMDY * APDY  +  AMDZ * APDZ )
      RETURN
      END

C   13/07/79 008022059  MEMBER NAME  ILCTRC   (SOURCE)      FORTRAN
      SUBROUTINE ILCTRC(NCH,LCH,ID,RD)
C
C     S.YAMADA    01-12-78  13:30
C     LAST MODIFICATION  13-07-79    22:55
C
C---- TRACES INNER CHARGED TRCKS TO THE LEAD GLASS FRONT SURFACE
C
      DIMENSION ID(2),RD(2),P(7),R(3)
C
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
      DIMENSION JBCCHG(9,100)
      EQUIVALENCE (CXDCHG(1,1),JBCCHG(1,1))
C---- NCHIND=NO. OF CHARGED PARTICLES DETECTED BY THE INNER DET.
C---- NSTEP=1:TRACING FOR THE L.G. COUNTERS,   =2:TRACED FURTHER.
C---- CXDCHG  CONTAINS INNER TRACK INFORMATION
C     JBCCHG(1,N)     HITTING PART
C     CXDCHG(2,N)     CHARGE
C     CXDCHG(3-5,N)   HITTING POSITION ON THE COILOR ON THE END CAP
C     CXDCHG(6-8,N)   DIRECTION COSIGNS
C     CXDCHG(9,N)     ABSOLUTE MOMENTUM
C
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     1                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     2                ZECAP(4),ZECAPX(4),THECPX(2),
     3                ECXLST(24), ECYLST(24)
C
      COMMON /CLGMSB/ MSGVAL(5)
      DIMENSION AMSGVL(5)
      EQUIVALENCE (MSGVAL(1),AMSGVL(1))
C
      COMMON /CTPCNS/ EBMGEV, BKGAUS
      DATA INIT/0/
C
      IF(INIT) 1001,1000,1001
 1000 RAD1SQ = RADIUS(1)**2
      RAD3SQ = RADIUS(3)**2
      INIT = 1
C
 1001 NCHIND = 0
      NSTEP = 1
      IF(NCH.LE.0) RETURN
C
      NB = 0
        DO 1 N=1,NCH
C----   PICK UP EACH TRACK FROM THE INNER RESULT
        PABS = 0.
          DO 2 K=1,3
          P(K) = RD(NB+K+14)
    2     R(K) = RD(NB+K+11)
        RSQO = R(1)**2+R(2)**2
        PABS = P(1)**2+P(2)**2+P(3)**2
C////////////////////////////////
C       WRITE(6,900) N,R,(P(K),K=1,3),PABS
C900    FORMAT(' ILCTRC;#',I4,' R=',3F10.1,'   P,PABS=',4E12.4)
C////////////////////////////////
C
C----   CHECK THE POSITION
        IF( R(3).LT.ZEND(1) .OR. R(3).GT.ZEND(2) ) GO TO 8
        IF( RSQO.GT.RAD3SQ )  GO TO 8
        GO TO 6
C
C----   THE TRACK IS OUT OF THE INNER DETECTOR FROM THE BIGINNING.
    8   MSGVAL(1) = N
        AMSGVL(2) = R(1)
        AMSGVL(3) = R(2)
        AMSGVL(4) = R(3)
        CALL LGMESG( 8, 3)
        IF(R(3).LT.-1230.)  R(3)=-1230.
        IF(R(3).GT. 1130.)  R(3)= 1130.
        IF( RSQO.LE.RAD3SQ )  GO TO 6
        RSQO=790./SQRT(RSQO)
        R(1)=R(1)*RSQO
        R(2)=R(2)*RSQO
        GO TO 6
C       GO TO 25
C
C----   REMOVE STOPPING TRACKS
    6   IF( PABS ) 25,25,7
C
    7   IF(PABS.GT.0.8) GO TO 3
C
C----   FUNNY DIRECTION COS'ES.
        MSGVAL(1) = N
        AMSGVL(2) = PABS
        CALL LGMESG( 8,2 )
        GO TO 25
C
C----   RD(NB+25) IS CURVETURE IN 1./MM.
C----   PROTECTION FOR ZERO-FIELD CASE IS DONE TAKING 1-GAUSS.
        DATA EBMIN/0.3E-7/
    3   EB = 0.3E-4*BKGAUS
        IF( ABS(EB).LE.EBMIN ) EB = EBMIN
        PT = EB/RD(NB+25)
C       WRITE(6,910) N,EB,PT
C910    FORMAT(' N,EB,PT=',I4,2E12.4)
        IF(ABS(R(3)).LT.1.E-10 .AND. ABS(PT).LT.0.05) GO TO 25
        DXY = SQRT(P(1)**2+P(2)**2)
        P(6) = ABS(PT)/DXY
C
C----   CHARGE
        P(7) = 1.0
        IF(PT.LT.0.) P(7) = -1.
C
C----   TRACE THE TRACK UNTIL IT HITS THE END CAP OR THE COIL.
C       NO.OF CURLING
        NCURL = 0
        IPOUT = 1
C/////  CALL JSTEP(R,P)  /////   SUBROUTINE IS COPIED //////////
C           E.ELSEN   FOR JADE M.C.  COPIED FROM F11BAR.JMC.S
C               AND MODIFIED BY S.YAMADA05-12-78  11:20
C
            DATA           DRMAX/ 10.0/, DRMAXH/  5.0/
C                          DRMAXH = .5*DRMAX
C
C
            P(1) = P(1)*P(6)
            P(2) = P(2)*P(6)
            DZ = P(3)*DRMAX
C
            DT = DRMAX/ P(6)
            DTH = DRMAXH/ P(6)
            ODTH = EB * DTH
 4010       IF( PT.LT.0. ) ODTH = -ODTH
C
            CORREC = 1. - 2.*ODTH*ODTH
C
    4       DP1 =  P(2)*ODTH
            DP2 = -P(1)*ODTH
C
            R(1) = ( P(1) + DP1 ) * DT  + R(1)
            R(2) = ( P(2) + DP2 ) * DT  + R(2)
CCCCC       R(3) = P(3)*DT + R(3)
            R(3) = DZ + R(3)
C
            P(1) = ( P(1) + DP1+DP1 ) * CORREC
            P(2) = ( P(2) + DP2+DP2 ) * CORREC
C
C
C----   CHECK IF THE TRACK GOES THROUGH THE GAP OF THE L.G.COUNTERS.
        IF(R(3).LT.ZEND(1) .OR. R(3).GT.ZEND(2)) GO TO 25
        RSQ = R(1)**2+R(2)**2
        IF(RSQ.GE.RAD1SQ) GO TO 10
        IF(RSQ.GE.8.1E5) GO TO 4
        IF(R(3).LE.ZECAP(1)) GO TO 20
        IF(R(3).GE.ZECAP(3)) GO TO 21
C
C----   CHECK ENDLESS LOOP
        IF( RSQ-RSQO ) 41,40,40
   40   IPOUT = 1
        GO TO 44
C----   BACKWARD
   41   IF(IPOUT) 44,42,42
   42   IF(NCURL) 43,43,25
   43   IPOUT = -1
        NCURL = 1
C----   CONTINUE TRACING
   44   RSQO = RSQ
        GO TO 4
C
C----   COIL SURFACE IS HIT.
   10   JBC = 0
        GO TO 30
C
C----   Z<0 END CAP
   20   JBC = -1
        GO TO 30
C----   Z>0 END CAP
   21   JBC = 1
        GO TO 30
C
C----   THE TRACK DOES NOT HIT THE L.G.
   25   JBC = 100
C
   30   NCHIND = NCHIND+1
        IF(NCHIND.GT.100) GO TO 90
        JBCCHG(1,NCHIND) = JBC
C
          DO 31 K=1,3
   31     CXDCHG(K+2,NCHIND) = R(K)
        CXDCHG(6,NCHIND) = P(1)/P(6)
        CXDCHG(7,NCHIND) = P(2)/P(6)
        CXDCHG(8,NCHIND) = P(3)
C
        CXDCHG(2,NCHIND) = P(7)
        CXDCHG(9,NCHIND) = P(6)
C
C----   MOVE THE POINTER
        NB = NB+LCH
    1   CONTINUE
      RETURN
C
   90 MSGVAL(1) = NCHIND
      MSGVAL(2) = N
      CALL LGMESG( 8,1 )
      NCHIND=100
      RETURN
C
      END

C   12/03/84 412051642  MEMBER NAME  TAGRAW   (S)           FORTRAN
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE TAGRAW(IWRITE,*)
C
C THIS IS A VERSION OF TAGADC THAT HANDLES RAW DATA
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
#include "cgraph.for"
C
#include "cwktag.for"
C
       DIMENSION CALIB(2)
       DATA CALIB  / 10.0 , 6.6667 /
       DATA ICOUNT / 0 /
       LOGICAL NOMSG  / .FALSE. /
       LOGICAL LERROR / .FALSE. /
C
C
       IF ( NDDINN .NE. 0 ) NOMSG = .TRUE.
C
C FIND THE POINTERS ETC
C
C
       CALL BLOC(IND,'ATAG',0,&9001)
       I2S = ( IND * 2 ) + 3
       I2F = 2 * ( IND + IDATA(IND) )
       IF ( HDATA(I2F) .EQ. 0 ) I2F = I2F - 1
C
C
C  UNPACK ADC DATA
C
       IADD = 0
       DO  30 IS = I2S,I2F,1
          IDD = HDATA(IS)
C
C IDD GE 0 => DATA,OTHERWISE -(ADDRESS)
C
          IF ( IDD .GE. 0 ) GOTO 103
C
C HERE IF IDD IS AN ADDRESS - CONVERT IT TO A (POSITIVE) ADDRESS
C
          IADD = IDD + 32768
C
C NOW GOTO END OF LOOP - NEXT BIT OF DATA IS CONTENTS BELONGING
C TO THIS ADDRESS
C
          GOTO  30
C
  103     CONTINUE
C
C HERE FOR DATA
C
 5903     CONTINUE
          ITD = IS
          IF ( (IADD .GE. 96) .OR. (IADD .LT. 0) ) GOTO 20
C
C CONVERT HARDWARE ADDRESS TO SOFTWARE ADDRESS
C
          CALL TAGH2S(ISAD,IADD,&19)
C
          IF ( (ISAD .GT. IENDPZ) .OR. (ISAD .LT. 0) ) GOTO 19
C
C
C ISAD - SOFTWARE ADDRESS,IADD HARDWARE - ADDRESS,IDD - DATA
C NOW FILL CATAG LOCATION (ISAD) WITH CORRECT ENERGY FOR
C THIS BLOCK ( APPROXIMATELY IN MEV THANKS TO CALIB)
C
          CATAG(ISAD) = IDD * CALIB(MARK)
C
C
C CHECK FOR CRAZY DATA
C
          IF ( (IDD .GE. 0) .AND. (IDD .LE. 4090) ) GOTO 20
C
C
C
C---------------------------------- ERROR CONDITIONS-----------------
C
   18     CONTINUE
C
           IF ( .NOT. NOMSG ) WRITE(6, 11)ISAD,CATAG(ISAD)
   11      FORMAT(//,' +++  WARNING FROM TAGGING ROUTINE - TAGRAW -',
     *                '   CATAG(',I4,') HAS CRAZY VALUE -',F12.3,
     *                ' ---  IT HAS BEEN SET TO ZERO ')
C
C---                                     SET THE ARRAY TO ZERO
C
           CATAG(ISAD) = 0.0
           IF ( .NOT. NOMSG ) LERROR = .TRUE.
           GOTO 20
C
C--------------------------------------- HERE FOR ILLEGAL ADDRESS
C
   19      IF ( NOMSG ) GOTO 20
           LERROR = .TRUE.
           WRITE(6, 21)IHAD,ISAD
   21      FORMAT(' +++ ILEGAL ADDRESS FOUND IN TAGRAW IHAD,ISAD ',2I10)
C
C    END OF ERROR HANDLING
C
   20     CONTINUE
C
C INCREMENT ADDRESS
C
          IADD=IADD+1
   30  CONTINUE
C
C---                                     NOW TEST FOR ANY ERRORS
C
       IF ( NOMSG .OR. ( .NOT. LERROR ) )  RETURN
       LERROR = .FALSE.
C
C---                                     IF THERE WAS AN ERROR THEN
C---                                     DUMP OUT THE OFFENDING BANK
C
       CALL HPRS('ATAG',0)
C
C---                                     COUNT THE NUMBER OF ERRORS
C
       ICOUNT = ICOUNT + 1
       IF ( ICOUNT .NE. 10 ) RETURN
       NOMSG = .TRUE.
       WRITE(6, 31)
   31  FORMAT(///,'+++  MORE THAN TEN ERRORS DETECTED BY TAGRAW',
     *            '  -- NO MORE MESSAGES  +++',///)
   41  FORMAT(6(/,8(2X,F9.2)))
C
       RETURN
C
 9001  RETURN 1
C
       END

C   12/05/80 307101616  MEMBER NAME  GPHNAR   (S)           FORTRAN
      IMPLICIT INTEGER*2 (H)
C---
C---   SUMMER 1982 VERSION
C---
      REAL*8 DATE,TIME,DDN
      INTEGER*4 BINTIM
      COMMON/CBSTR/MODE
#include "cgraph.for"
#include "ciouni.for"
      COMMON /CNAROS/ IUNN1,IUNN2
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C----------------------------------------------------------------------
      COMMON /BCS/ IDATA(33000)
      DIMENSION HDATA(10),IPNT(50),ADATA(1)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C------------------------ END OF MACRO CDATA --------------------------
      COMMON/CSVCW1/NDDSVE,NRWR
      DIMENSION HTM1(4),HTM2(4)
       EQUIVALENCE (DATE,HTM1(1)),(TIME,HTM2(1))
      DIMENSION IDATAL(11),HVOLSR(4),HELP(10),IMUC(11,5)
      DIMENSION HNAM(8),HNAME(4)
      DATA HBLANK/'  '/
      COMMON/CWORK/DATE,TIME,DDN,
     1             IDATAL,DUMMY,ITIME,KNTERR,JUMPBK,IANSW,INDEX0,
     1             NUMEVN,HVOLSR,HERR,HWORK(40)
      EQUIVALENCE (HELP(1),DATE),(HNAM(1),HNAME(1))
      DATA IMUC /'F11L','HO.B','UPDA','T0  ','    ','    ',5*'    ',
     $           'F11L','HO.B','UPDA','T1  ','    ','    ',5*'    ',
     $           'F11P','ST.C','UPDA','T1  ','    ','    ',5*'    ',
     $           'F22N','AR.T','OFCA','L2.R','1354','2   ',5*'    ',
     $           'F22N','AR.T','OFCA','L2.R','1300','0   ',5*'    '/
C---
C---     MAIN ROUTINE FOR CONDENSED JADE GRAPHICS PROGRAM.
C---     STARTED WEDNESDAY, MAY 17, 1978.
C---     LAST CHANGE 28.8.82   J.OLSSON
C---
C---     INITIALIZE PLOT10, SEND OPENING MESSAGES TO SCREEN AND ALLOCATE
C---     FORTRAN REFERENCE NUMBERS FOR INPUT AND CALIBRATION DATA SETS.
C---
      CALL INITT(DUMMY)
      CALL TWINDO(0,4095,0,4095)
C---
      DO 1244 I = 1,8
1244  HNAM(I) = HBLANK
      CALL IDFUN(HNAME,NBOK)
      ITIME=BINTIM(DUMMY)/360000
      IF(ITIME.LT.12) WRITE(6,1237) (HNAM(IS),IS=1,5)
1237  FORMAT('           GOOD MORNING, ',4A2,'  NICE TO SEE YOU AGAIN ',
     $A2)
1238  FORMAT('         GOOD AFTERNOON, ',4A2,'  NICE TO SEE YOU AGAIN ',
     $A2)
1239  FORMAT('           GOOD EVENING, ',4A2,'   WORKING LATE AGAIN ? ',
     $A2)
      IF(ITIME.GE.12.AND.ITIME.LT.18) WRITE(6,1238) (HNAM(I),I=1,5)
      IF(ITIME.GE.18) WRITE(6,1239) (HNAM(IS),IS=1,5)
C---
      CALL TRMOUT(80,'JADE INTERACTIVE GRAPHICS PROGRAM.  ******* VERSIO
     1N FROM SUMMER 1982 ****^')
      CALL NOTICE
      CALL DAY(DATE,TIME)
      DO 4987  I = 1,4
4987  HWORK(I) = HTM1(I)
      HWORK(5) = HBLANK
      DO 4986  I = 1,4
4986  HWORK(I+5) = HTM2(I)
      WRITE(6,6033) (HWORK(I),I=1,9)
6033  FORMAT(' SCAN SESSION BEGINNING AT DATE AND TIME: ',9A2)
    1 CONTINUE
      CALL TRMOUT(80,'PLEASE ENTER FULL NAME OF THE CATALOGUED DATA SET
     $WITH THE EVENTS^')
      CALL TRMIN(44,IDATAL)
      CALL TRMOUT(80,'  ^')
C---
C---     ALLOCATE FORTRAN REFERENCE NUMBER TO INPUT DATA SET.
C---
      DO 8 I=1,11
    8 IDATSV(I)=IDATAL(I)
   16 CONTINUE
      DO 3 I=1,4
    3 HVOLSR(I)=HBLANK
      NDDINN=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,NDDINN,HERR)
      IF(HERR.EQ.0) GO TO 5
C---
C---     ERROR HAS OCCURRED ON ALLOCATION.
C---
      CALL TRMOUT(80,'AN ERROR HAS OCCURED IN ALLOCATING THE REQUESTED D
     $ATA SET.^')
      CALL TRMOUT(80,'THE NAME IS INCORRECT OR HMS/MSS IS JAMMED.^')
      CALL TRMOUT(80,'PLEASE TRY AGAIN OR CLOSE THE SESSION WITH CONTROL
     $/G.^')
      GO TO 1
C---
C---     SUCCESSFULLY ALLOCATED DATA SET.
C---
    5 CONTINUE
      MAXREC=0
C---
C---     NDDOUT WILL NORMALLY CONTAIN THE FORTRAN REFERENCE
C---     NUMBER OF THE OUTPUT DATA SET WITH WRITTEN EVENTS. IT IS HERE
C---     SET TO 0. FIRST CALL TO COMMAND WRIT WILL CALL FOR ALLOCATION
C---     OF THE OUTPUT DATA SET.
C---
      NDDOUT=0
      NDDSVE=0
      NRWR = 0
C=======================================================================
C---
C---     STANDARD VIEW, USER LEVEL STOP SETTING ETC.
C---
      ISTANV=2
      LASTVW=ISTANV
      CALL SETSCL(ISTANV)
      SXIN=XMIN
      SXAX=XMAX
      SYIN=YMIN
      SYAX=YMAX
C---
      DO 62 I=1,10
      SSTPS(I)=.FALSE.
62    LSTPS(I)=0
      SSTPS(2)=.TRUE.
      SSTPS(6)=.TRUE.
C---
      CALL TRMOUT(80,'DEFAULT STANDARD VIEW "RB" AND USER LEVELS 2 AND 600012400
     $ HAVE BEEN SET.    ^')
      CALL TRMOUT(80,'THEY CAN BE CHANGED AT ANY TIME BY THE COMMANDS CS
     $TV 1  AND CSTL.^')
      CALL TRMOUT(80,'USE COMMAND "C" FOR GOING FROM LEVEL 2 TO LEVEL 6^
     $')
      CALL TRMOUT(80,'  ^')
C---
      CALL TRMOUT(80,'NAME OF  OUTPUT DATA SET / EDIT BACKUP FILE  WILL
     $BE ASKED FOR ^')
      CALL TRMOUT(80,'AT THE FIRST COMMAND  "WRIT" OR "EDIT (SAVE)"^')
      CALL TRMOUT(80,'  ^')
C---
      CALL TRMOUT(80,'THE DEFAULT CALIBRATION DATA SET F11LHO.AUPDAT1 WI
     $LL NOW BE ALLOCATED.^')
      CALL TRMOUT(80,'IF YOU WISH THE BUPDAT0/BUPDAT1 FILES FOR LEAD GLA
     $SS CALIBR. (REFORM DATA),^')
      CALL TRMOUT(80,'THEN PRESS ANY CHARACTER+RETURN, ELSE PRESS RETURN
     $ FOR THE FIRST EVENT^')
      CALL TRMOUT(80,'  --->     PLEASE WAIT A LITTLE...^')
C---
C---       ALLOCATE THE CALIBRATION DATA SETS
C---
      NCALI = 1
      DO 898 I=1,11
  898 IDATAL(I)=IMUC(I,3)
      DO 893 I=1,4
  893 HVOLSR(I)=HBLANK
      LUNNNN=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,LUNNNN,HERR)
      IF(HERR.NE.0) GO TO 795
      LUNITA(1)=LUNNNN
      GO TO 801
C---     ERROR HAS OCCURRED ON ALLOCATION.
  795 CALL TRMOUT(80,'ERROR IN ALLOCATING CALIBRATION FILE.  THE SESSION
     $ IS STOPPED ...^')
      STOP
803   NCALI = 2
      DO 797  II = 1,2
      DO 798 I=1,11
  798 IDATAL(I)=IMUC(I,II)
      DO 793 I=1,4
  793 HVOLSR(I)=HBLANK
      LUNNNN=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,LUNNNN,HERR)
      IF(HERR.NE.0) GO TO 795
      LUNITA(II)=LUNNNN
  797 CONTINUE
C
C  HERE ALLOCATION OF PRIVATE FILES
C
  801 DO 197  II = 4,5
      DO 198 I=1,11
  198 IDATAL(I)=IMUC(I,II)
      DO 193 I=1,4
  193 HVOLSR(I)=HBLANK
      LUNNNN=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,LUNNNN,HERR)
      IF(HERR.NE.0) GO TO 195
      IF(II.EQ.4) IUNN1 = LUNNNN
      IF(II.EQ.5) IUNN2 = LUNNNN
  197 CONTINUE
      GO TO 196
  195 CALL TRMOUT(80,'ERROR IN ALLOCATING PRIVATE FILES.  THE SESSION CO
     $NTINUES ...^')
196   CALL TRMOUT(80,'  ---> ALLOCATION READY. ENTER FOR FIRST EVENT:^')
      CALL TRMIN(2,HDUM)
      CALL TRMOUT(80,'  ---> ALLOCATION READY.  ENTER ?^')
      CALL TRMIN(2,HDUM)
      IF(HDUM.EQ.HBLANK) GO TO 802
      GO TO 803
C---
C---     INITIALIZE BOS.
C---     CALL MAIN ANALYSIS SUPERVISOR ROUTINE.
C---
802   CALL BINT(33000,10000,200,1)
      CALL SUPERV
C---
C---     END SCAN SESSION AND TERMINATE PLOT10.
C---
      IF(NDDOUT.EQ.0) GO TO 9866
      WRITE(JUSCRN,9865) NRWR
9865  FORMAT(' THE NEWLY WRITTEN RECORDS ARE PRECEDED BY ',I5,' RECORDS
     $ON THE OUTPUT FILE')
9866  CALL DAY(DATE,TIME)
      DO 5087  I = 1,4
5087  HWORK(I) = HTM1(I)
      HWORK(5) = HBLANK
      DO 5086  I = 1,4
5086  HWORK(I+5) = HTM2(I)
      WRITE(6,5033) (HWORK(I),I=1,9)
5033  FORMAT(' SCAN SESSION ENDING AT DATE AND TIME: ',9A2)
      ITIME=BINTIM(DUMMY)/360000
      IF(ITIME.GT.4.AND.ITIME.LE.9) WRITE(6,1246) (HNAM(I),I=1,5)
      IF(ITIME.GT.9.AND.ITIME.LE.16) WRITE(6,1247) (HNAM(I),I=1,5)
      IF(ITIME.GT.16.AND.ITIME.LE.21) WRITE(6,1248) (HNAM(I),I=1,5)
      IF(ITIME.GT.21.OR.ITIME.LE.4) WRITE(6,1249) (HNAM(I),I=1,5)
1246  FORMAT('         HAVE A PLEASANT MORNING, ',4A2,'  ',A2)
1247  FORMAT('          A VERY GOOD DAY TO YOU, ',4A2,'  ',A2)
1248  FORMAT('         HAVE AN ENJOYABLE EVENING, ',4A2,'  ',A2)
1249  FORMAT('         GOOD NIGHT AND SLEEP WELL, ',4A2,'  ',A2)
      CALL FINITT(0,0)
      STOP
      END
      BLOCK DATA
      IMPLICIT INTEGER*2 (H)
#include "chsym.for"
#include "cgeo2.for"
#include "cgeo2com.for"
      LOGICAL FL18,FL22,FL24,DSPDTM
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24,KPROJ
      DATA HSYM /'0 ','1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 ','A ',
     $'B ','C ','D ','E ','F ','G ','H ','I ','J ','K ','L ','M ','N ',
     $'O ','P ','Q ','R ','S ','T ','U ','V ','W ','X ','Y ','Z '/
      DATA FL18,FL22,FL24  /3*.FALSE./,KPROJ/0/
      COMMON /CGRAP2/ BCMD,DSPDTM(30),ISTVW,JTVW
      DATA DSPDTM /7*.FALSE.,.TRUE.,22*.FALSE./,ISTVW/0/,JTVW/0/
      DATA FENDC/81./,XYHOL1,XYHOL2/141.,151.5/,BLDPFW/400./,
     1 ZMINBL,ZPLUBL /-5250.,5250./,
     2 XSC /230.,150./, YSC /150.,70./, RSC /152.48,192.48/,
     3 ZMISC/-4235.,-4135./, ZPLSC/4235.,4135./, DZSC/6./,
     4 CHX/-140.,-400.,140.,-140.,-400.,140.,
     5 -140.,-400.,140.,-140.,-400.,140./,
     6 CHY /-400.,140.,-400.,-400.,140.,-400.,
     7 -400.,140.,-400.,-400.,140.,-400./,
     8 CHZ /-4770.,-4720.,-4770.,-4020.,-4070.,-4020.,
     9 4020.,4070.,4020.,4770.,4720.,4770./,
     A WLEN/800./, PITCH /25./, WZDIS/10./
C    8 CHZ /-4770.,-4720.,-4770.,-4020.,-3970.,-4020.,
C    9 4020.,3970.,4020.,4770.,4720.,4770./,
      COMMON /CZGEO/ RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,ZCHSS,
     $               ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      DATA RZCHI,RZCHA /864.5, 884.5/
      DATA NZRPSI,NZZ /24,16/
      DATA Z1ZCH,Z2ZCH /-1200.,1200./
      DATA ZCHA,ZCHB,ZCHSS /5.,15.,1./
      DATA ZCHDL,ZCHDLL /100.,20./, DLZZ,DLZPHI /150.,227.63/
      DATA DLZW1,DLZW2 /228.94,231.58/
      COMMON /CZKON/ ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
      DATA ZCVDR/0.34/, ZCXCH/1.0/, ZCTZER/0.0/, ZCAPED/0.0/
      DATA XL1,XL2 /2547.28, 2578.96/
      END
      END

C   07/06/96 606071859  MEMBER NAME  NPDIR    (S4)          FORTRAN
      FUNCTION NPDIR(NAME,NR,IUNIT)
C
C     VERSION JULY 82
C
      COMMON/ACS/DUMMI(90),NUNTB
C
C
C     FIND ON DIRECT ACCESS DATA SET THE LARGEST NUMBER NN, WHICH IS
C     LESS OR EQUAL TO NR, FOR ALL BANKS WITH NAME.
C
C                 ---- -- -----
C        NN=NPDIR(NAME,NR,IUNIT)
C
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      NPDIR=0
      IUND=IUNIT
    1 INDD=ILINK('+NPD',IUNIT)
      IF(INDD.EQ.0) GOTO 20
C
C     SEARCH IN TABLE
C
   10 IF(NR.LT.IW(INDD+1)) GOTO 20
      IF(NR.GT.IW(INDD+2)) GOTO 20
C     IF(NR.GE.IW(INDD+2)) GOTO 20
      NA=IW(INDD+3)
      IF(NA.EQ.0) GOTO 100
      J=INDD+4
      DO 12 I=1,NA
      IF(NAME.EQ.IW(J)) GOTO 14
   12 J=J+3
      GOTO 100
   14 JA=IW(J+1)
      JB=IW(J+2)
      NPDIR=IW(INDD+JA)
      DO 16 J=JA,JB
      IF(NR.LT.IW(INDD+J)) GOTO 100
   16 NPDIR=IW(INDD+J)
      GOTO 100
C
C     CREATE A NEW LOCAL DIRECTORY BANK
C
C
C     BANK    ('+NPD',IUNIT) CONTENT
C
C       +1     LIMIT OF VALIDITY (LOW) INCLUSIVE
C        2     LIMIT OF VALIDITY (UP)  INCLUSIVE
C        3     NUMBER OF NAMES
C        4     NAME
C        5     INDEX LOW  (JA)
C        6     INDEX UP   (JB)
C        7     NAME
C        8     INDEX LOW
C        9     INDEX UP
C        ...   ...
C     (JA)     NR     )
C              ...    ) FOR ONE NAME
C     (JB)     NR     )
C
   20 CONTINUE
C
C     PREPARE DIRECTORY AND INTERMEDIATE BANKS AND READ DIR RECORDS
C
      CALL DIDA(0,LIST,1)
      INDD=IBANK('+NPD',IUNIT,'DL')
C     RECORD BUFFER
      INDB=IBANK('+NP2',0,NDAREC)
C     SORT BANK
      NAR=1000
      INDR=IBANK('+NP2',1,NAR)
C     NAME/NR DIRECTORY BANK
      NW=3
      INDD=IBANK('+NPD',IUNIT,NW)
      IF(INDB.EQ.0.OR.INDR.EQ.0.OR.INDD.EQ.0) GOTO 200
      NAS=0
      NRUP=0
      NPRIME=IW(INDA+8)
      NRT=IW(INDA+34)
      NRD=0
      JREC=1
   22 JREC=JREC+1
      IF(JREC.GT.NPRIME+1) GOTO 40
      NREC=JREC
   24 IF(NREC.GE.2.AND.NREC.LE.IW(INDA+7)) GOTO 25
      IF(NUNTB.NE.0) WRITE(NUNTB,103) NREC
  103 FORMAT('0ERROR IN NPDIR, RECORD NUMBER IS',I10/)
      GOTO 22
   25 CALL RDDA(NREC,NDAREC,IW(INDB+1))
      NREC=IW(INDB+4)
      K=INDB+2
      N=IW(K+3)/4+1
   26 N=N-1
      K=K+4
      IF(N.GT.0) GOTO 30
      IF(NREC) 24,22,24
C
C     CHECK (NAME,NR) AND STORE
C
   30 NRD=NRD+1
      IF(IW(K+1).LE.0) GOTO 26
      IF(NRUP.EQ.0) GOTO 32
      IF(IW(K+1).GT.NRUP) GOTO 26
C     COMPARE NAME WITH TABLE
   32 NL=(IW(INDD)-1)/3
      IF(NL.EQ.0) GOTO 36
      J=INDD+4
      DO 34 L=1,NL
      IF(IW(J).EQ.IW(K)) GOTO 38
   34 J=J+3
C     NEW NAME
   36 INDD=IBANK('+NPD',IUNIT,NW+3)
      NW=NW+3
      J=INDD+4+3*NL
      IW(J)=IW(K)
      L=NL+1
C     STORE IF INSIDE LIMITS
   38 IF(IW(K+1).GT.NR) GOTO 39
C     POSSIBLE LOWER LIMIT
      IF(IW(K+1).GT.IW(J+1)) IW(J+1)=IW(K+1)
      IF(IW(K+1).LT.IW(J+1)) GOTO 26
   39 IW(INDR+NAS+1)=L
      IW(INDR+NAS+2)=IW(K+1)
      NAS=NAS+2
      IF(NAS.LT.NAR) GOTO 26
C
C     CLEAN TABLE AND SORT
C
   40 INF=2147483647
C     DELETE ENTRIES BELOW LIMITS
      KA=INDR
      IF(NAS.EQ.0) GOTO 50
      DO 42 I=1,NAS,2
      J=INDD+2+3*IW(KA+1)
      IF(IW(KA+2).GE.IW(J)) GOTO 42
      IW(KA+2)=INF
   42 KA=KA+2
C     SORT ARRAY TO INCREASING NR
      CALL SORTAE(IW(INDR+1),2,NAS/2,2,0)
   44 IF(NAS.EQ.0) GOTO 46
      IF(IW(INDR+NAS).NE.INF) GOTO 46
      NAS=NAS-2
      GOTO 44
C  46 IF(JREC.GT.NPRIME+1) GOTO 48
C     XF=FLOAT(NRD)/FLOAT(NRT+1)
C     FAC=0.5*(0.2+0.7*(4.0-XF)*XF/3.0)
C     NAF=NAR*FAC
C     NAS=MIN0(2*NAF,NAS)
C     IF(NUNTB.NE.0) WRITE(NUNTB,102) NAS,NAR,NRUP,NAF,NRD,NRT,XF,FAC
C  48 NRUPC=NRUP
C     IF(NRUPC.EQ.0) NRUPC=IW(INDR+NAS)
C     NRUPC=MIN0(IW(INDR+NAS),NRUPC)
C     IF(NRUPC.GE.NR) NRUP=NRUPC
C     IF(NRUP.EQ.0) GOTO 50
C  49 IF(NAS.LE.0) GOTO 50
C     IF(IW(INDR+NAS).LT.NRUP) GOTO 50
C     NAS=NAS-2
C     GOTO 49
C
C     FINAL PREPARATION OF LOCAL DIRECTORY BANK
C
C
C     MODIFICATION 5.JULY 82
C
   46 IF(JREC.GT.NPRIME+1) GOTO 50
      XF=FLOAT(NRD)/FLOAT(NRT+1)
      FAC=0.5*(0.2+0.7*(4.0-XF)*XF/3.0)
   47 NAF=NAR*FAC
      NAF=MIN0(2*NAF,NAS)
   48 IF(IW(INDR+NAS).LE.IW(INDR+NAF)) GOTO 49
      NAS=NAS-2
      GOTO 48
   49 NRUP=IW(INDR+NAF)
      IF(NAS.LT.NAR) GOTO 50
      FAC=FAC*0.9
      GOTO 47
   50 IF(JREC.LE.NPRIME+1) GOTO 26
      CALL SORTAA(IW(INDR+1),2,NAS/2,0)
      IF(NAS.LE.0) NAS=0
      NAS2=NAS/2
      IF(NAS.EQ.0) GOTO 58
      J=NAS
      JNR=NAS
   52 L=IW(INDR+J-1)
      IW(INDD+3*L+3)=JNR-NAS2+NW
   54 IW(INDR+JNR)=IW(INDR+J)
      J=J-2
      JNR=JNR-1
      IF(J.LE.0) GOTO 56
      IF(IW(INDR+J-1).EQ.L) GOTO 54
   56 IW(INDD+3*L+2)=JNR+1-NAS2+NW
      IF(J.GT.0) GOTO 52
      CALL UCOPY(IW(INDR+1+NAS2),IW(INDR+1),NAS2)
   58 INDR=IBANK('+NP2',1,NAS2)
      INDB=IBANK('+NP2',0,'DLGC')
      INDD=IBANK('+NPD',IUNIT,NW+NAS2)
      INDR=ILINK('+NP2',1)
      CALL UCOPY(IW(INDR+1),IW(INDD+NW+1),NAS2)
      IW(INDD+1)=NR
      IW(INDD+2)=NRUP
      IF(NRUP.LE.0) IW(INDD+2)=INF
      IW(INDD+3)=NW/3-1
C     IF(NUNTB.NE.0)
C    1  WRITE(NUNTB,101) IUNIT,IW(INDD+1),IW(INDD+2),IW(INDD+3)
      INDR=IBANK('+NP2',1,'DLGC')
      GOTO 1
C
C
C
  100 RETURN
C 101 FORMAT('0---- UNIT',I3,' TABLE LIMITS',2I8,I12,' DIFFERENT NAMES')
C 102 FORMAT('0NAS/NAR=',2I10,'   NEW LIMIT IS ',4I10,2G12.4)
  200 INDD=IBANK('+NPD',IUNIT,'DL')
      INDR=IBANK('+NP2',    1,'DL')
      INDB=IBANK('+NP2',    0,'DLGC')
      CALL ABEND
      GOTO 100
      END

C   27/11/86 704161229  MEMBER NAME  ZE4VJBN  (S)           FORTRAN77
C
C   VERSION OF 04/02/85    E. ELSEN
C   MODIFIED   12/01/87    M. ZIMMER
C   MODIFIED   31/03/87    G. ECKERLIN
C   LAST MOD   16/04/87    G. ECKERLIN   EVENT SCIP AND SELECTION
C   COMPRESS EVENTBANKS INTO ZE4V FORMAT
C   WITH ZE4VTP FROM TPTR AS FAR AS POSSIBLE
C   WITH ZE4VPK FROM PATR AND LGCL BANK
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(80000)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C
      DATA IEVLIM / 10000/
      DATA IFILMX / 1000 /
      DATA IWRMAX /  0  /
      DATA IWZMAX / 10000 /
      DATA ISCIP / 0 /
C                  ZE4V DUMP FOR 'IDULIM' EVENTS
      DATA IDUMP / 1 /,IDULIM / 10 /
C                  FLAG TO SELECT ZE4VTP=1/ZE4VPK=2
      DATA ITPPK / 2 /
C
      DIMENSION HDSN(22), HVOL(3)
      REAL*8 DDIN / 'FT02F001' /
      REAL*8 DDOU / 'FT03F001' /
      REAL*8 DDZE / 'FT51F001' /
      INTEGER IDDIN(2)
      EQUIVALENCE(IDDIN(1),DDIN)
C                                      INPUT/OUTPUT FTXX..
C          INPUT   (2)   EVT-OUT (3)   ZE4V-OUT (51)
      DATA IRUNIT / 2 /, IWUNIT / 0 /, IUNZE4 /  51 /
C                                   READ IN DD* CARDS
      READ(5,5001) ITPPK,IEVLIM,IFILMX,IWRMAX,IWZMAX,IDULIM,ISCIP,
     &             ISELFL,ISELMU,ISELEL
 5001 FORMAT(20X,I10)
      WRITE(6,6001) IEVLIM,IFILMX,IWRMAX,IWZMAX,IDULIM,ISCIP,ITPPK,
     &             ISELFL,ISELMU,ISELEL
 6001 FORMAT(/' MAX # OF EVENTS TO READ   :',I8/
     &         ' MAX # OF INPUTFILES       :',I8/
     &         ' MAX # OF EVENTS ON UNIT 3 :',I8/
     &         ' MAX # OF EVENTS ON UNIT51 :',I8/
     &         ' MAX # OF ZE4V-BANK PRINTS :',I8/
     &         ' INITIAL EVENT SCIP        :',I8/
     &         ' TP/PK-FLAG (1=TP/2=PK)    :',I8/
     &         ' SELECTION (0:ENAB/1:DISAB):',I8/
     &         ' MUON QUALITY SELECTION    :',I8/
     &         ' ELEKTRON SELECTION        :',I8/)
C                                          INIT BOS AND GEP
      CALL BINT( 80000, 40000, 10000, 0 )
      CALL GEPIC
C                                           I/O UNIT SPECIFICATION
      CALL DDCHA( DDIN, HDSN, HERR, HVOL )
      WRITE(6,9111) HDSN, HVOL
 9111 FORMAT(/'      INPUT IS FROM DSN=',22A2,' VOL=',3A2)
      IF( IWUNIT.LE.0 ) GO TO 10
         CALL DDCHA( DDOU, HDSN, HERR, HVOL )
         WRITE(6,9112) HDSN, HVOL
 9112    FORMAT(/'      OUTPUT IS TO  DSN=',22A2,' VOL=',3A2)
   10 CONTINUE
C
      IF( IUNZE4.LE.0 ) GO TO 20
         CALL DDCHA( DDZE, HDSN, HERR, HVOL )
         WRITE(6,9122) HDSN, HVOL
 9122    FORMAT(/' ZE4V OUTPUT IS TO  DSN=',22A2,' VOL=',3A2/)
   20 CONTINUE
C
      IFIL = 1
      IEOF = 0
      IWRITE = 0
      IEV = 0
      IZE4V = 0
      IWZE4V = 0
C                                      INITIALISE FEHLER
      CALL FEHLIN
C
  100 IF( JUHR(2) .EQ. 2 ) GO TO 4000
      CALL BREAD( IRUNIT, &1000, &3000 )
CC    WRITE(6,*) '******* READ ENDED NORMALLY FOR EVENT ',IEV
      IEOF = 0
      IEV = IEV + 1
C                                      LOOK FOR HEAD BANK
      NPHEAD = IW(IBLN('HEAD'))
      IF( NPHEAD.LE.0 ) GO TO 200
C                                      INITIAL EVENT SCIP
      IF (IEV.LE.ISCIP) GOTO 2000
C                                      FILL CALIBRATION CONSTANTS
      CALL KLREAD
C                                      FILL ZE4V OVER TP-BANK
C
      IF (ITPPK.EQ.1) THEN
        NPTPEV = IW(IBLN('TPEV'))
        IF( NPTPEV.LE.0 ) GO TO 200
        IF (IZE4V.LE.0) THEN
          CALL ZE4VIN( 1 )
          IZE4V = 1
        ELSE
          CALL ZE4VTP( 1 )
        ENDIF
C                                      FILL ZE4V FROM PATR-BANK
      ELSEIF (ITPPK.EQ.2) THEN
        IF (IZE4V.LE.0) THEN
          CALL ZE4VIN( 1 )
          IZE4V = 1
        ELSE
          CALL ZE4VPK( 1 )
        ENDIF
      ELSE
        WRITE(6,9001) ITPPK
 9001   FORMAT(1X'FLAG NOT SUPPORTET : ',I4)
        GOTO 8100
      ENDIF
C
      IF (IDUMP.LE.IDULIM) THEN
        CALL ZE4VDP
        IDUMP = IDUMP + 1
      ENDIF
  200 CONTINUE
C
C                                          WRITE WHOLE EVENT
      IF( IWUNIT .GT. 0 .AND. IWRITE .LT. IWRMAX ) THEN
        IWRITE = IWRITE + 1
        CALL BSLW
        CALL BWRITE( IWUNIT )
      ENDIF
C
C                                          SCIP ZE4V WRITE IF MC RECORD
      IF( NPHEAD.LE.0 ) GO TO 2000
C                                          WRITE ZE4V BANK
      IF( IUNZE4 .GT. 0 .AND. IWZE4V .LT. IWZMAX ) THEN
        IWZE4V = IWZE4V + 1
C                                          EVENT SELECTION
        IACCFL=ISELFL
        NPZE4V=IW(IBLN('ZE4V'))
        IF (NPZE4V.GT.0) THEN
          MAXTR = HW(NPZE4V*2 + 6)
          LT = HW(NPZE4V*2 + 5)
          LTCH = HW(NPZE4V*2 + 7)
          LTNE = HW(NPZE4V*2 + 9)
          LTRE = HW(NPZE4V*2 + 11)
          NPOINT = NPZE4V + HW(NPZE4V*2 + 1)
CC      WRITE (6,*) 'EVENT :',IEV,'TRACKS :',MAXTR
          DO 111 ITR= 1, MAXTR
            IF (HW(NPOINT*2+18).EQ.1) THEN
              IF (IW(NPOINT+LT+12).GE.ISELMU.AND.ISELMU.GT.0) IACCFL=1
CC      WRITE (6,*) 'ITR,NPOINT,IACCFL,IW(NPOINT+LT+12) :',
CC   &               ITR,NPOINT,IACCFL,IW(NPOINT+LT+12)
              NPOINT = NPOINT + LTCH
            ELSEIF (HW(NPOINT*2+18).EQ.0) THEN
              NPOINT = NPOINT + LTNE
            ELSEIF (HW(NPOINT*2+18).EQ.2) THEN
              NPOINT = NPOINT + LTRE
            ENDIF
            NPOINT = NPOINT + LT
 111      CONTINUE
        ENDIF
C                                          FORCED ACCEPT OF FIRST EVENT
        IF (IW(IBLN('ZEHD')).GT.0) IACCFL=1
C                                          SCIP REJECTED EVENTS
        IF (IACCFL.LE.0) GOTO 2000
CC      WRITE (6,*) ' *******  EVENT ACCEPTED ***********',IEV
        CALL BMLT( 3, 'ZEHDZE4VPALL' )
CC      CALL BPRL(IDULIM)
        CALL BWRITE( IUNZE4 )
      ENDIF
      GO TO 2000
C
C
C                                           ERRORS
 1000 CONTINUE
      CALL JOBFIN( 3, IEV, &1100 )
 1100 IF( IEOF .NE. 0 ) GO TO 8000
C
C
 2000 CONTINUE
      CALL BSLT
      CALL BDLG
      IF( IEV .LT. IEVLIM ) GO TO 100
      CALL JOBFIN( 4, IEV, &8100 )
C
C                                           EOF ON IRUNIT
 3000 IF( IFIL .GE. IFILMX .OR. IEOF.NE.0 )  GO TO 8000
      IFIL = IFIL + 1
      IEOF = 1
      IDDIN(2) = IDDIN(2) + 1
      CALL DDCHA( DDIN, HDSN, HERR, HVOL )
      IF( HERR .NE. 0 ) GO TO 8000
      CALL BDLS( '+BUF', IRUNIT )
      WRITE(6,9104) IEV, IFIL
 9104 FORMAT(' +++++ AFTER',I6,' EVENTS FILE NUMBER CHANGED TO',I4,' +++
     *++')
      WRITE(6,9113) HDSN, HVOL
 9113 FORMAT(/' +++++ INPUT CONTINUES FROM DSN=',22A2,' VOL=',3A2)
      GO TO 100
C
C                                        TIME OUT
 4000 CALL JOBFIN( 2, IEV, &8100 )
C
C                                           END OF JOB
 8000 CONTINUE
      CALL JOBFIN( 1, IEV, &8100 )
 8100 CONTINUE
C                                      MCREDU STATISTICS
      CALL FEHLPR
      CALL MCRDFL
      CALL BSTA
      CALL GEPW
C
      STOP
      END

C   22/02/82 206220917  MEMBER NAME  OMUANA   (JADEMUS)     FORTRAN
C   17/02/82 202171432  MEMBER NAME  ERMUANA  (S)           FORTRAN
C   20/10/81 202041534  MEMBER NAME  MUANA    (JADEMUS)     FORTRAN
C   19/10/81 110191748  MEMBER NAME  MUANA    (JADEMUS1)    FORTRAN
C   18/05/79 005130909  MEMBER NAME  MUANA    (JADEMUS)     FORTRAN
C
C LAST CHANGE 09.15 22/06/82 HUGH MCCANN - FOR J.O. COSMIC REJECTION.
C      CHANGE 13.30 22/02/82 HUGH MCCANN - FOR IMPROVED ERROR OUTPUT.
C      CHANGE 15.30 04/02/82 HUGH MCCANN - NOW CALLS MUCUTS.
C      CHANGE 15.15 05/11/81 HUGH MCCANN - CORRECT BUG , IMP INT*2!!
C      CHANGE 17.46 19/10/81 CHRIS BOWDERY- INSERT MACRO CMUBCS
C      CHANGE 12.30 19/10/81 HUGH MCCANN  - INSERT COMMON CMUIEV.
C      CHANGE 09.12 13/05/80 JOHN ALLISON --COMMENT OUT CALL MUANAJ.
C      CHANGE 16.00 02/05/80 HUGH MCCANN ---COMMENT OUT CALL MUANAL.
C      CHANGE 10.56 18/05/79 JOHN ALLISON.
C
      SUBROUTINE MUANA(IJOIN)
      IMPLICIT INTEGER*2 (H)
C
C  COMMONS.
      COMMON /CMUPRN/MUPRIN,MUHPR
      COMMON /CMUIEV/IEV,NEV,IRD,KRUN,KREC,
     *ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
#include "cmubcs.for"
C
C  INITIALISE HEADER PRINT CONTROL FLAG FOR THIS EVENT( USED IN MUERRY).
      MUHPR=0
C
C  COUNT THE EVENTS.
      IEV=IEV+1
C
C  EXTRACT EVENT INFORMATION FROM THE HEADER BANK.
      IPHEAD=IDATA(IBLN('HEAD'))
      ISECS = HDATA(2*IPHEAD+3)
      IMINS = HDATA(2*IPHEAD+4)
      IHOURS= HDATA(2*IPHEAD+5)
      IDAY  = HDATA(2*IPHEAD+6)
      IMONTH= HDATA(2*IPHEAD+7)
      IYEAR = HDATA(2*IPHEAD+8)
      KRUN  = HDATA(2*IPHEAD+10)
      KREC  = HDATA(2*IPHEAD+11)
C
C-----------------------------------------------------------------------
C
C STANDARD MUON ANALYSIS PROCEDURE.
C
C IJOIN=0 SUPPRESSES CALLS TO ROUTINES WHICH USE BANKS OTHER THAN MUON
C         BANKS.
C
C-----------------------------------------------------------------------
C
C CONVERT MUON SIGNALS TO COORDINATES.
      CALL MUANAC
C
C FOLLOW EACH INNER DETECTOR TRACK OUT (PHILOSOPHY 2).  AT THE MOMENT
C    MUANAF AND MUANAL ARE COMPLETELY INDEPENDENT.
      IF(IJOIN.NE.0)CALL MUANAF
CCCCC IF(IJOIN.NE.0)CALL MUCUTS CCCCCCCCCCCCCCCCCCC     J.O. CHANGE  .
C
C ****** FROM 18/03/80 , ONLY WANT PHIL2 RUN IN STANDARD MU ANALYSIS.
C        THIS WILL BE DONE IF 'IJOIN' IS GREATER THAN ZERO .
C        THEREFORE , RETURN HERE.
C
      RETURN
C
C FIND MUON LINES - PHILOSOPHY 1 MUON PATTERN RECOGNITION.
C     CALL MUANAL
C
C ATTEMPT TO JOIN MUON CLUSTERS WITH INNER DETECTOR TRACKS AND WITH LEAD
C   GLASS CLUSTERS.  ALSO CORRELATE RESULTS OF PHILOSPHY 1 AND 2.
C     IF(IJOIN.NE.0)CALL MUANAJ
C
C-----------------------------------------------------------------------
C
C     RETURN
      END

C   29/10/82 501081659  MEMBER NAME  DIFFLB   (JADESR)      FORTRAN
      SUBROUTINE DIFFLB
      DATA NWR /0 /
      DATA NRD /0 /
      DATA NRR /0 /
C
    1 READ (10,END=100) IRD, IED
      NRD=NRD+1
      READ (20,END=100) IRR, IER
      NRR=NRR+1
      IF (IRD.GT.IRR .OR. IED.GT.IER) GOTO 20
      IF (IRD.EQ.IRR .AND. IED.EQ.IER) GOTO 1
    2 WRITE (30) IRD, IED
      NWR=NWR+1
C
      IF (NWR.LE.100) PRINT 50, IRD, IED, IRR, IER
   50 FORMAT('  IRD, IED, IRR, IER=',4I10)
C
      READ (10,END=100) IRD, IED
      NRD=NRD+1
      IF (IRD.GT.IRR .OR. IED.GT.IER) GOTO 20
      IF (IRD.EQ.IRR .AND. IED.EQ.IER) GOTO 1
      GOTO 2
C
  100 CONTINUE
      PRINT 101, NRD, NRR, NWR
  101 FORMAT(/'   NRD, NRR, NWR=',3I10)
      RETURN
C
   20 CONTINUE
      READ (20,END=100) IRR, IER
      NRR=NRR+1
      GOTO 1
C
      END

C   07/06/96 606071827  MEMBER NAME  BOUT     (S4)          FORTG1
      SUBROUTINE BOUT(NRW,INIW)
C     BOS SUBPROGRAM =0.9=
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      INTEGER ITWO/2/
      EQUIVALENCE (TWO,ITWO)
C     ASSEMBLE BANKS IN CONTIGUOUS LOCATIONS
   10 INIW=0
      NROUT=NROUT+1
      IORD=0
      NTOT=0
      INDA=0
      J=0
   20 J=J+1
      IF(J.GT.IN) GOTO 30
      IND=IW(NLST+J)
      NIND=IW(IND)
      IF(NIND.NE.0) RW(IOLST+IND)=OR(RW(IOLST+IND),TWO)
      IND=NIND
      IF(IND.EQ.0) GOTO 20
      IF(INDA.EQ.0) INDA=IND
   25 IF(IND.NE.INDA+NTOT) IORD=1
      NTOT=NTOT+4+IW(IND)
      IND=IW(IND-1)
      IF(IND) 20,20,25
   30 IF(NTOT.NE.0) INIW=INDA-3
      IF(NTOT.EQ.0) GOTO 100
C     ORDER LOOP
   60 IF(IORD.EQ.0) GOTO 100
      NEXTX=NEXT
      ISW=0
      IF(NEXT+NTOT.GT.NLST) ISW=-1
   70 J=0
   72 J=J+1
      IF(J.GT.IN) GOTO 82
      IND=IW(NLST+J)
      IND=IW(IND)
      IF(IND.LE.0) GOTO 72
C     BANK
   74 IF(ISW.NE.0) GOTO 76
      NW=IW(IND)+4
      CALL UCOPY2(IW(IND-3),IW(NEXTX),NW)
      NEXTX=NEXTX+NW
      GOTO 80
C     MOVE
   76 IF(ISW.GT.0) GOTO 78
      ISW=1
      NA1=IW(IND-3)
      NR1=IW(IND-2)
   78 IND=ILOC(NA1,NR1,-11)
      IF(IND.NE.0) GOTO 80
      NA2=IW(IND-3)
      NR2=IW(IND-2)
      CALL BGAR(IGA)
      IND=ILOC(NA2,NR2,0)
      IF(IND.EQ.0) GOTO 90
      IND=ILOC(NA2,NR2,-11)
      IF(IND.EQ.0) GOTO 90
C
   80 IND=IW(IND-1)
      IF(IND) 72,72,74
   82 INIW=NEXT
      IF(ISW) 90,100,84
   84 IND=ILOC(NA1,NR1,0)
      IF(IND.EQ.0) GOTO 90
      INIW=IND-3
      GOTO 100
C     ERROR OR TOO LARGE
   90 INIW=0
      NTOT=0
  100 NRW=NTOT
      RETURN
      END

C   01/11/84            MEMBER NAME  HODRFI   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE HODRFI
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  DRAW HODOSCOPE HITS
C
C       MOD:   J. OLSSON     07/03/80 :  ?
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL TBIT,DSPDTM
C
#include "cdata.for"
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON / CGRAP2 / BCMD, DSPDTM(30)
      COMMON / CWORK1 / R,FI,R1,COSF,X1,Y1,R2,SINF,X2,Y2,ZET,X3,Y3,X4,Y400002400
     +                 ,HMW(132)
C
      COMMON / CJTRIG / PI, TWOPI
      COMMON / SMPTOF / MTOF, TTOF(42)
C
      DIMENSION HELP(2)
C
      EQUIVALENCE (ICAMWD,HELP(1))
C
      DATA HELP /0,0/, PIDEG /57.29578/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHMW*264
      EQUIVALENCE (cHMW,HMW(1))
*** PMF(end)
C
C-----------------  C O D E  -------------------------------------------
C
      IPJ = IDATA(IBLN('LATC'))
      IF(IPJ.LE.0) RETURN
      IF(IDATA(IPJ).LE.3) RETURN
      IPJ = 2*IPJ
      IPJF = IDATA(IBLN('ATOF'))
      RF = RTOF + 1.7*DRTOF
      IF(LASTVW.EQ.3) RF = RF + DRTOF*1.5
      SH3 = DRTOF*1.3
      IF(LASTVW.EQ.3) SH3 = SH3*1.5
      IHHEA2=2*IDATA(IBLN('HEAD'))
      NRUN=HDATA(IHHEA2+10)
      CALL TOFSMP(NRUN)
      SH2=DRTOF
      call setcol('TOFH') ! PMF 23/11/99: set colour
      DO 31 IH = 1,2
      IF(IH.NE.2) GO TO 41
C** TOF COUNTERS HERE
      R1 = RTOF
      R2 = DRTOF + R1
      DEFI = TWOPI/42.
      J1 = IPJ + 6
      J2 = IPJ + 11
      NBIT=7
      GO TO 42
   41 CONTINUE
C** BEAM PIPE COUNTERS HERE
      R1 = RBPC
      R2 = DRBPC + R1
      DEFI = TWOPI/24.
      J1 = IPJ + 3
      J2 = IPJ + 5
      NBIT=8
   42 CONTINUE
      DEPLC = - DEFI*.5
      DO 32 JK = J1,J2
      HELP(2) = HDATA(JK)
      ICAMWD = ISHFTL(ICAMWD,1)
      DO 32 IBT = 1,NBIT
      ICAMWD = ISHFTR(ICAMWD,1)
      IE = (JK-J1)*NBIT
      IF(.NOT.TBIT(ICAMWD,31)) GO TO 32
      IE = IE + IBT
C---
C---     DRAW TOF COUNTER NUMBERS OUTSIDE COUNTER RING.
C---
      IF(IH.NE.2) GO TO 33
      IF(DSPDTM(3)) GO TO 33
      FI=PI/2.-(IE-1)*DEFI
C     X4=RTOF-2.*SH2
C     IF(IE.GT.22) X4=RTOF-SH2
      X4 = RF + SH3*1.25
      IF(IE.GT.22) X4 = X4 + SH2
      X1=-X4*SIN(FI)
      Y1= X4*COS(FI)
      IF(IE.GT.22) FI=FI+PI
      X1=X1-SH2*COS(FI)
      Y1=Y1-SH2*SIN(FI)
      CALL DNUM(IE,X1,Y1,SH2,FI)
   33 FI = DEPLC + (IE-1)*DEFI
      COSF = COS(FI)
      SINF = SIN(FI)
      X1 = - R1*COSF
      Y1 = R1*SINF
      X4 = - R2*COSF
      Y4 = R2*SINF
      FI = FI + DEFI
      COSF = COS(FI)
      SINF = SIN(FI)
      X2 = - R1*COSF
      Y2 = R1*SINF
      X3 = - R2*COSF
      Y3 = R2*SINF
      CALL CRICRO(0.,0.)
      IF(IH.NE.2.OR.IPJF.LE.0) GO TO 32
      IF(DSPDTM(3)) GO TO 32
C** DISPLAY TOF VALUES ABOVE THE COUNTERS
      WANGLE = .5*PI - (IE-1)*DEFI
      IF(IE.GT.22) WANGLE = WANGLE + PI
      WANGLE = WANGLE*PIDEG
      FI1 = FI - DEFI
      IF(IE.GT.22) FI1 = FI1 + DEFI
      RF1 = RF
      IF(IE.GT.22) RF1 = RF + SH3
      XT = RF1*COS(FI1)
      YT = RF1*SIN(FI1)
      CALL CORE(HMW,5)
      WRITE(cHMW,3258) TTOF(IE) ! PMF 17/11/99: UNIT=10 changed to cHMW
3258  FORMAT(F5.1)
      CALL USRSYM(-XT,YT,SH3,HMW,5,WANGLE)
C     IEC = (IE-1)/4
C     IE1 = IE - IEC*4
C     IPJHF = 2*(IPJF+1) + 91 + IEC*9 + 2*IE1- 2
C     WANGLE = .5*PI - (IE-1)*DEFI
C     IF(IE.GT.22) WANGLE = WANGLE + PI
C     FI = FI - DEFI*.8
C     IF(IE.GT.22) FI = FI + DEFI*.6
C     RADD = 0.
C     IF(IE.GT.22) RADD = SH3
C     X1 = (RF+RADD)*COS(FI)
C     Y1 = (RF+RADD)*SIN(FI)
C     ITDC = HDATA(IPJHF+1) + HDATA(IPJHF+2)
C     CALL DNUM(ITDC,-X1,Y1,SH3,WANGLE)
C     GO TO 32
   32 CONTINUE
   31 CONTINUE
      call setcol(' ') !PMF 23/11/99: reset colour
      RETURN
      END

C   03/12/83 606101227  MEMBER NAME  JINIT9   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE  JINIT
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    03/10/78 :  INITIALISE THE MC TRACKING PROGRAM
C
C        MOD  E. ELSEN    18/11/82 :
C        MOD  J. HAGEMANN 18/01/83 :  CHANGED RADIUS OF RADIAL ELECTRIC
C             R. RAMCKE            :  FIELD AROUND SIGNAL WIRES
C        MOD  C. BOWDERY  30/08/83 :  PRINT WARNING IF VALIDATION TESTS
C                                  :  ARE DISABLED VIA COMMON/CVFLAG/
C        MOD  C. BOWDERY   2/12/83 :  CHANGE /CVFLAG/
C   LAST MOD  J. HAGEMANN 21/09/84 :  INITIALIZE VERTEX CHAMBER DRIFT
C                                     SPACE CONSTANTS
C
C-----------------------------------------------------------------------
C
C
      LOGICAL*1 LFLAG
      LOGICAL   VTEST , ALLSET
C
      COMMON / CFLAG  / LFLAG(10)
C
      COMMON / CVFLAG / VTEST(20)
C
      COMMON / CJCELL / NCELL(3),
     +                  NWIRES(3)
C
      COMMON / CJDRCH / RDEC(4),
     +                  PSIIN(3),
     +                  RINCR(3),
     +                  FIRSTW(3),
     +                  FSENSW(3),
     +                  RDEPTH,
     +                  SWDEPL,
     +                  YSUSPN,
     +                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     +                  DRIDEV,DRICOS,DRISIN
C
      COMMON / CGEO1  / BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     +                  RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                  R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                  R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                  RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     +                  ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     +                  ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     +                  ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                  XRJETC,
     +                  RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     +                  BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                  XHOL1,XHOL2,YHOL1,YHOL2
C
      COMMON / CJVCEL / MCELL,
     +                  MWIRE
      COMMON / CJVTXC / RVEC, ANG1, ANG2, DISTPW, FIRSTP, DISTW1,
     +                  ANGL, COSLOR, SINLOR,
     +                  ZRESV, ZMAXV, ZOFFV, ZNAMP, ZALV, TIMEV
      COMMON / CGEOV  / RPIPV, DRPIPV, XRLPIV, RVXC, DRVXC, XRLVXC,
     +                  ZVXCM, DZVCM, XRZVCM, ZVXCP, DZVCP, XRZVCP,
     +                  XRVTXC
      COMMON / CJVDAT / XSLOPV, YSLOPV, XLV, XHV,
     +                  SV, SV2, TANLOR
C
      COMMON / CJXDAT / XSLOPE, YSLOPE, XL(3), XH(3), R3P, RD3P,
     +                  S, S2,
     +                  XSL3L, X3L, XSL3H, X3H, YSL3L, Y3L, YSL3H,
     +                  YHWIDT, SINHLF, COSHLF, DRITAN
C
C------------------  C O D E  ------------------------------------------
C
      PHI    = 6.2831853 / FLOAT( NCELL(3) )
      COSA   = COS( PHI )
      SINA   = SIN( PHI )
      YSLOPE = SINA / COSA
      XSLOPE = - YSLOPE
C
      PHI    = PHI / 2.
      SINHLF = SIN( PHI )
      COSHLF = COS( PHI )
      YHWIDT = 0.5
C
      XL(1)  = R0ROH + DR0ROH
      XL(2)  = R1ROH + DR1ROH
      XL(3)  = R2ROH + DR2ROH
      XH(1)  = R1ROH
      XH(2)  = R2ROH
      XH(3)  = R3ROH
C
      R3P    = R3ROH / COSA
      RD3P   = ( R3ROH + DR3ROH ) / COSA
      S      = RINCR(1)*DRICOS*.5
      S2     = S*S
C
      XSL3L  = SINHLF/COSHLF
      X3L    = XL(3) / COSHLF
      XSL3H  = - XSL3L
      X3H    = XH(3) / COSHLF
      YSL3H  = XSL3L
      YSL3L  = -XSL3L
      Y3L    = YHWIDT / COSHLF
      DRITAN = DRISIN / DRICOS
C                                 INITIALISATION CALLS
      CALL LGINIT
      CALL INIFWD
C
C                                 VERTEX CHAMBER
      IF ( .NOT. LFLAG(5) ) GO TO 5
         BET    = 3.1415927 / FLOAT( MCELL )
         SINBET = SIN( BET )
         COSBET = COS( BET )
C
         YSLOPV = SINBET / COSBET
         XSLOPV = - YSLOPV
C
         XLV    = RPIPV + DRPIPV
         XHV    = RVXC
         SV     = DISTPW*COSLOR*.5
         SV2    = SV*SV
         TANLOR = SINLOR / COSLOR
C
C                                 PRINT A WARNING IF ANY VALIDATION
C                                 TEST HAS BEEN DISABLED FOR MCVALI.
C
    5 ALLSET = .TRUE.
      DO  1  I = 1,20
         IF( VTEST(I) ) GO TO 1
         WRITE(6,10) I
 10      FORMAT(' *** WARNING ***    INPUT DATA TEST ',I2,' DISABLED')
         ALLSET = .FALSE.
  1    CONTINUE
C
C                                 IF ANY TEST IS DISABLED THEN PRINT
C                                 THE LIST OF TESTS.
C
       IF( ALLSET ) RETURN
C
       WRITE(6,20)
 20    FORMAT(/'  1 = BEAM ENERGY TEST        2 = PX, PY, PZ TEST'/
     +         '  3 = ENERGY TEST             4 = MASS(TYPE) TEST'/
     +         '  5 = E/P/MASS TEST           6 = VERTEX X,Y,Z TEST'/
     +         '  7 = VERTEX R TEST           8 = PTOT TEST'/
     +         '  9 = MASS TEST              10 = NULL TEST'/
     +         ' 11 = PARTICLE TYPE TEST     12 = CHARGE TEST'/
     +         ' 13 = EVENT NUMBER TEST      14 = NF TEST'/
     +         ' 15 = NCF TEST               16 = NNF TEST'/
     +         ' 17 = NF = NCF + NNF TEST    '//)
       RETURN
       END

C   20/09/79 102191201  MEMBER NAME  PCJDRC   (PATRECSR)    FORTRAN
      SUBROUTINE PCJDRC
#include "cjdrch.for"
C
C
C----------------------------------------------------------------------
C         --------------  SUBROUTINE PCJDRC  -----------------
C         --- G.F.PEARCE .. LAST UPDATE : 1800 ON 11/09/79 ---
C
C   SUBROUTINE TO DUMP ALL OF THE JET CHAMBER CONSTANTS COMMON /CJDRCH/
C
C  CONTENTS OF /CJDRCH/  ####### COMPILED BY G.F.PEARCE #######
C  ====================
C
C  RDEC  (I)   ..  MEAN RADII OF CHAMBER WALLS
C  PSIIN (I)   ..  ANGULAR INCREMENT OF FIRST WIRE LINE
C  RINCR (I)   ..  DISTANCE BETWEEN TWO POTENTIAL WIRES
C  FIRSTW(I)   ..  RADII OF FIRST MAIN POTENTIAL WIRES IN EACH RING
C  FSENSW(I)   ..  RADII OF FIRST SENSE WIRES IN EACH RING
C  RDEPTH      ..  DIFFERENCE OF TWO CHAMBER RADII
C  SWDEPL      ..  WIRE STAGGERING ( > 0 MEANS +VE PHI FOR ZEROTH WIRE)
C  YSUSPN      ..  MAXIMUM VERTICAL DISPLACEMENT OF WIRE DUE TO GRAVITY
C  TIMDEL(J,I) ..  SIZE OF JET CHAMBER TIMING BIN (IN MMS)
C                  I = 1,2,3 FOR RINGS 1,2,3 RESPECTIVELY
C                  J = 1,2 FOR LAYERS 0-7 AND 8-15 RESPECTIVELY
C  ZMAX        ..  SENSITIVE HALF LENGTH OF WIRES
C  ZOFFS       ..  OFFSET OF WIRES
C  ZRESOL      ..  RESOLUTION IN Z
C  ZNORM       ..  Z NORMALISATION
C  ZAL         ..  WIRE LENGTH
C  ZSCAL       ..
C  DRIDEV      ..  ANGLE OF DRIFT SPACE TO WIRE PLANE
C  DRICOS      ..  COSINE(DRIDEV)
C  DRISIN      ..  SINE(DRIDEV)
C  DRIROT(I,J) .. DRIDEV FOR EACH SIDE (J=1,2) OF EACH CELL (I)
C                 J = 1 GIVES LEFT SIDE.   J = 2 GIVES RIGHT SIDE
C  SINDRI(I,J) .. SINE(DRIROT)
C  COSDRI(I,J) .. COSINE(DRIROT)
C
C----------------------------------------------------------------------
C
C
      PRINT11
 11   FORMAT(
     # 1X,45('-')/
     # ' DUMP OF JET CHAMBER CONSTANTS COMMON /CJDRCH/'/
     # 1X,45('-'))
C
      PRINT12,(RDEC(I),I=1,4)
     #       ,(PSIIN(I),I=1,3)
     #       ,(RINCR(I),I=1,3)
     #       ,(FIRSTW(I),I=1,3)
     #       ,(FSENSW(I),I=1,3)
     #       , RDEPTH,SWDEPL,YSUSPN,ZMAX,ZOFFS,ZRESOL,ZNORM,ZAL,ZSCAL
     #       ,DRIDEV,DRISIN,DRICOS
 12   FORMAT(' RDEC   .. CHAMBER WALL RADII .................. ',4E11.4/
     #       ' PSIIN  .. ANGULAR INCREMENT OF FIRST WIRE ..... ',3E11.4/
     #       ' RINCR  .. POTENTIAL WIRE SEPERATION ........... ',3E11.4/
     #       ' FIRSTW .. RADII OF FIRST POTENTIAL WIRES ...... ',3E11.4/
     #       ' FSENSW .. RADII OF FIRST SENSE WIRES .......... ',3E11.4/
     #       ' RDEPTH .. DIFFERENCE OF TWO CHAMBER RADII ..... ', E11.4/
     #       ' SWDEPL .. WIRE STAGGERING ..................... ', E11.4/
     #       ' YSUSPN .. MAX. VERTICAL GRAVITY DISPLACEMENT .. ', E11.4/
     #       ' ZMAX   .. SENSITIVE HALF LENGTH OF WIRES ...... ', E11.4/
     #       ' ZOFFS  .. WIRE OFFSET ......................... ', E11.4/
     #       ' ZRESOL .. RESOLUTION IN Z ..................... ', E11.4/
     #       ' ZNORM  .. NORMALISATION IN Z .................. ', E11.4/
     #       ' ZAL    .. WIRE LENGTH ......................... ', E11.4/
     #       ' ZSCAL  ..                                       ', E11.4/
     #       ' DRIDEV .. FOLLOWED BY SINE AND COSINE ......... ',3E11.4)
C
      PRINT13,((TIMDEL(J,I),J=1,2),I=1,3)
 13   FORMAT(' TIMDEL .. SIZE OF TIMING BINS (MMS) ........... ',6E11.4)
      RETURN
      END

C   07/06/96 606071907  MEMBER NAME  READHL   (S4)          FORTRAN
      SUBROUTINE READHL(LC)
C     BOS SUBPROGRAM =3.2=
      COMMON/CONTEX/LABL,NSL,NF,FR(36),NB,LBT(72)
      LOGICAL*1 LC(80),LBT,LLAB(4),LH(4),LBLK/' '/
      INTEGER NH/0/,BLK/'    '/,NBT(18)
      REAL*8 ZZ,TEN/1.0D1/
      EQUIVALENCE (LABL,LLAB(1)),(NH,LH(1)),(NBT(1),LBT(1)),
     1   (IZL,FZL)
C
C     PURPOSE
C        CONVERT TEXT INTO NUMBERS
C
C     INPUT
C        LC( )  = ARRAY OF 72 CHARACTERS (A1)
C
C     RESULT
C        LABL   = LABEL, I.E. FIRST FOUR NONNUMERIC NONBLANK
C                 CHARACTERS OF LC( )
C        NSL    = 1, IF SLASH (/) AFTER FIRST NUMBER, OTHERWISE 0
C        NF     = NUMBER OF ENTRIES IN ARRAY FR( )
C        FR( )  = ARRAY OF NUMBERS (FLOATING POINT OR INTEGER)
C        NBT    = NUMBER OF BYTES IN ARRAY LBT( )
C        LBT( ) = ARRAY OF BYTES WITH TEXT AFTER APOSTROPH ('),
C                 FIRST AND LAST ARE NOT EQUAL BLANK
C
C     EXAMPLE
C        LC ( ) = NAME 1 / 3.1 4.9E01 'COMMENT
C     WILL RESULT IN
C        LABL   = 'NAME'
C        NSL    = 1
C        NF     = 3
C        FR(1)  = 1
C        FR(2)  = 3.1
C        FR(3)  = 49.0
C        NBT    = 7
C        LC(1)  = 'C'      ETC    LC(7)  = 'T'
C
      LABL=BLK
      DO 2 I=1,18
    2 NBT(I)=BLK
      NF =0
      NB =0
      NSL=0
      NZ=0
      LAB=0
      LJ=0
      LZL=0
      NV=0
      NI=0
C
      DO 40 I=1,73
      J=1
      IF(I.EQ.73) GOTO 20
C     UNPACK CHARACTER LC(I) INTO NH
      LH(4)=LC(I)
C     NUMBER
      IF(NH.GE.240.AND.NH.LE.249) J=2
C     DOT
      IF(NH.EQ. 75) J=3
C     PLUS - SIGN
      IF(NH.EQ. 78) J=4
C     MINUS - SIGN
      IF(NH.EQ. 96) J=5
C     ' (APOSTROPH)
      IF(NH.EQ.125) J=6
C     / (SLASH)
      IF(NH.EQ. 97) J=7
C     E (EXPONENT)
      IF(NH.EQ.197) J=8
C     BLANK
      IF(NH.EQ.64)  J=9
C
   10 GOTO(12,14,18,20,20,20,12,12,20),J
C     LABEL
   12 IF(LAB.GE.4) GOTO 20
      LAB=LAB+1
      LLAB(LAB)=LC(I)
      GOTO 40
C     NUMBER
   14 IF(NZ.NE.0) GOTO 16
      LAB=4
      ZZ=0.0D0
      NE=0
      NP=0
      IF(LJ.EQ.3) NP=1
   16 NZ=NZ+1
      ZZ=ZZ*TEN+DFLOAT(NH-240)
      NE=NE+NP
      GOTO 40
C     DOT
   18 IF(NZ.EQ.0.OR.NP.EQ.1) GOTO 20
      NP=1
      GOTO 40
C
   20 IF(NZ.EQ.0) GOTO 30
      IF(NP.EQ.0) GOTO 22
C     FLOATING POINT NUMBER
      FZL=ZZ/TEN**NE
      IF(NV.EQ.5) FZL=-FZL
      LZL=1
      GOTO 26
C     INTEGER NUMBER
   22 IZL=ZZ+DBLE(0.5)
      IF(NV.EQ.5) IZL=-IZL
      IF(NI.NE.8.OR.LZL.NE.1) GOTO 24
      FR(NF)=FR(NF)*TEN**IZL
      LZL=0
      GOTO 28
C     STORE NUMBER
   24 LZL=0
   26 NF=NF+1
      FR(NF)=FZL
   28 NZ=0
      NV=0
      NI=0
C
   30 GOTO (34,40,40,32,32,50,34,34,40),J
   32 NV=J
      GOTO 40
   34 NV=0
      NI=NI*10+J
      IF(NF.EQ.1.AND.NI.EQ.7) NSL=1
   40 LJ=J
      GOTO 100
   50 IA=I+1
      DO 52 I=IA,72
      IF(LC(I).NE.LBLK) GOTO 54
   52 CONTINUE
      GOTO 100
   54 IA=I
      J=0
      DO 56 I=IA,72
      J=J+1
      IF(LC(I).NE.LBLK) NB=J
      LBT(J)=LC(I)
   56 CONTINUE
C
  100 RETURN
      END

C   11/01/87 804281850  MEMBER NAME  ZE4VMC   (S)           FORTRAN77
***PMF09/12/99      SUBROUTINE ZE4VMC( ITRK, IRES, /IARG3/, /IARG4/, /IARG5/ )
      SUBROUTINE ZE4VMC( ITRK, IRES, IARG3, IARG4, IARG5 )
C-----------------------------------------------------------
C   VERSION OF 24/01/85    LAST MOD 28/04/88    MZ
C   PERFORM TRACEBACK FOR PARTICLE ITRK
C   Input:
C           ITRK   Patr track number
C   Output:
C           if called with >2 arguments
C             IRES =  Pall pointer of original particle
C             IARG3 =  PCode = IFLVC*10 + ISC for electrons
C                      and -PCode for all other particles
C             IARG4 = particle type (JADE convention)
C             IARG5 = VECT # and nr of particle in 2 HWs
C           else
C             IRES = Pall Pointer and PCode in 2HWs
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      DIMENSION IPART(3),IVECT(3),FRACT(3)
      DIMENSION HR(2)
      EQUIVALENCE (HR(1),IR)
      DIMENSION P9VECT(9,30), IPALL(30)
      INTEGER PARENT
      DATA IEV / 0 /, IEVLIM /  4 /, NWARN / 0 /
C

      IEV = IEV + 1
      IR = 0
      IRES = 0
      NPALL= 0
      IORI = 0
      ITYPE = 0
      IM = 0
C
***PMF09/12/99      CALL NOARG( NARGS )
      NARGS=5
C
      NPTR4V = IW(IBLN('TR4V'))
      NPPATR = IW(IBLN('PATR'))
      IF( NPTR4V.GT.0 .AND. NPPATR.GT.0 ) THEN
C                                           DELETE TR4V IF NR TRACKS
C                                           BETWEEN TR4V AND PATR DO
C                                           NOT MATCH
        IF( IW(NPTR4V+1) .NE. IW(NPPATR+2) ) THEN
          CALL BMLT( 1, 'TR4V' )
          CALL BDLM
        ENDIF
      ENDIF
C
      NPART = 0
      CALL MCTRCB( ITRK, NPART, IPART, IVECT, FRACT )
      IF( IEV.LT.IEVLIM .AND. NPART.GT.0 )
     *   WRITE(6,9101) ITRK, NPART, (IPART(I),IVECT(I),FRACT(I),
     *                 I=1,NPART)
 9101    FORMAT(' MCTRCB WAS CALLED FOR TRACK NUMBER ',I4,
     *       ' PARTICLES FOUND IN VECT BANK:',I4/
     *       (1X,2I10,F8.2))
      IF( NPART.GT.0 ) THEN
        IM = 1
        DO 10 I=2,NPART
          IF( FRACT(I).GT.FRACT(IM) ) IM = I
   10   CONTINUE
C
        IF( FRACT(IM).GE..50 ) THEN
C                                          PARTICLE FOUND
C                                          CATEGORIZE FLAVOR
          IFLC = 1
          NPPALL = IW(IBLN('PALL'))
          IF( NPPALL.GT.0 ) THEN
            IFLC = MAX0(IABS(IW(NPPALL+9))-2,1)
C                                           REDUCE TO VECT, 0
            IVECTM = IVECT(IM)
            IPARTM = IPART(IM)
            NPVECT = IW(IBLN('VECT'))
            IF( IVECTM.NE.0 ) THEN
              NPVECT = IW(NPVECT-1)
              DO 20 WHILE( IVECTM.GT.0 )

                IVECTM = HW((NPVECT + IW(NPVECT+1) +
     *                       (IPARTM-1)*IW(NPVECT+2))*2 + 21)
                IPARTM = HW((NPVECT + IW(NPVECT+1) +
     *                       (IPARTM-1)*IW(NPVECT+2))*2 + 22)
   20         CONTINUE
              IF( IEV.LT.IEVLIM )
     *          WRITE(6,9201) IVECT(IM), IPART(IM), IVECTM, IPARTM
 9201           FORMAT(' +++ ZE4VMC ',2I5,' TRACED TO ',2I5)
            ENDIF
C                                            FIND TYPE IN ORIGINAL BANK
            ITYPE = IABS(IW(NPVECT+
     *              IW(NPVECT+1)+(IPART(IM)-1)*IW(NPVECT+2)+7))
            IF( IEV.LT.IEVLIM )
     *        WRITE(6,9103) ITYPE, IFLC, IW(NPVECT-2)
 9103         FORMAT(' ITYPE=',I4,' IFLC=',I5,' IN VECT ',I2)
C
C
            ISC = 1
            CALL MCHTRB( IPARTM, NFOUND, P9VECT, IPALL, IFLAVR,
     *                   IQG, IPN )
            IF( IEV.LT.IEVLIM )
     *        WRITE(6,9102) IPART(IM), NFOUND, IFLAVR, IQG, IPN,
     *            (IPALL(J),(P9VECT(I,J),I=1,9),J=1,NFOUND)
 9102         FORMAT(' MCHTRB WAS CALLED FOR VECT TRACK NUMBER ',I4,
     *         ' PARTICLES FOUND IN PALL BANK:',I4/
     *         ' IFLAVR=',I4,' IQG=',I4,' IPN=',I4,/
     *         (1X,I10,9F10.3))
C
            HR(1) = IPALL(1)
            NPALL = HR(1)
            IF( NFOUND.GT.1 ) THEN
              PARENT = IPALL(1)
              PARENT = IW(NPPALL+IW(NPPALL+1)
     *                          +(PARENT-1)*IW(NPPALL+2)+8)
              ITYPP = IABS( IW(NPPALL+IW(NPPALL+1)+
     *                         (PARENT-1)*IW(NPPALL+2) + 7
     *                      )   )
              if(itypp.ge.100000) itypp=itypp-100000 ! PMF 09/12/99
              IF( ITYPP.GE.1000 ) THEN
                  KF = ITYPP - 1000
                  IF( KF.GE.100 .AND. .NOT.
     *                ( (101 .GT. KF .OR. KF .GT. 104) .AND.
     *                  (123 .GT. KF .OR. KF .GT. 126) .AND.
     *                  (145 .GT. KF .OR. KF .GT. 158) .AND.
     *                  (241 .GT. KF .OR. KF .GT. 246) .AND.
     *                  (293 .GT. KF .OR. KF .GT. 307)
     *                ) ) THEN
C                                            THIS IS A B-HAD
                    ISC = 3
                  ELSEIF( .NOT. (
     *                  ( 20 .GT. KF .OR. KF .GT.  22) .AND.
     *                  ( 53 .GT. KF .OR. KF .GT.  56) .AND.
     *                  ( 58 .GT. KF .OR. KF .GT.  60) .AND.
     *                  ( 80 .NE. KF) ) ) THEN
C                                          THIS IS A C-HAD
                    ISC = 2
                  ENDIF
C
                ENDIF
            ENDIF
            HR(2) =-10*IFLC - ISC
            IF( IFLC.EQ.ISC ) HR(2) =-ISC
            IF( ITYPE.EQ.2 .OR. ITYPE .EQ. 3) HR(2) = - HR(2)
            IORI = HR(2)
          ENDIF
        ELSE
          IM = 0
        ENDIF
      ENDIF
      IRES = IR
C
      IF( NARGS .GT. 2 ) THEN
        IRES = NPALL
        IARG3 = IORI
        IARG4 = ITYPE
        IF( NARGS .GT. 4 ) THEN
          IF( IM.GT.0 ) THEN
            HR(1) = IVECT(IM)
            HR(2) = IPART(IM)
            IARG5 = IR
          ELSE
            IARG5 = 0
          ENDIF
        ENDIF
      ELSEIF( NWARN .LT. 1) THEN
        NWARN = NWARN + 1
        WRITE(6,9301)
 9301   FORMAT(/' +++ ZE4VMC STILL CALLED WITH ONLY TWO ARGUMENTS'/
     *          '            PLEASE MODIFY YOUR PROGRAM')
      ENDIF
      END

C   27/03/97 703271227  MEMBER NAME  JEOSUM1  (JMC.S)       FVS
C   27/03/97 703271158  MEMBER NAME  $HISTORY (JMC.S)       FVS
         JMC.S HISTORY
         =============  (THE EARLIER HISTORY IS FOUND IN $HISTOR0)

-----------------------------------------------------------------------I
I  A LARGE NUMBER OF CHANGES INTRODUCED, AFFECTING THE TRACKING,       I
I  SMEARING AND TRIGGER SIMULATION. FOR DETAILS, SEE                   I
I           JADE COMPUTER NOTE 66                                      I
I----------------------------------------------------------------------I
16-08-83 BLDAT         CORRECTION OF SOME GEOMETRICAL AND
                       PHYSICAL PROPERTIES
16-08-83 EVTINI        SUBROUTINE DAY2 NOW CALLED HERE ONCE PER
                       EVENT AND NOT FOR EVERY PARTICLE IN SUBROTINE
                       JIPATR.COMMON / CDAY / INTRODUCED
16-08-83 JIPATR        SUBROUTINE DAY2 NOW CALLED ONLY ONCE PER EVENT
                       IN SUBROUTINE EVTINI. COMMON / CDAY / INTRODUCED
16-08-83 JINIT         CHANGED RADIUS S OF RADIAL SYMMETRIC ELECTRIC
                       FIELD AROUND SIGNAL WIRES
16-08-83 RDRDMH        RANDOM HITS OUTSIDE CELLS ARE NOW NOT POSSIBLE.
                       MAXIMUM DRIFTSPACE DRIMAX FOR EACH RING
                       SET IN A DATA STATEMENT.
17-08-83 RDMTCO        CHANGED WITH INTRODUCTION OF NEW COMMON /CTRIGG/
                       CALL TO RDTRIG AND RDHEAD IN RDJETC PART. LOGICAL
                       ERROR IN RDTRG SEQUENCE THEREBY CORRECTED.
                       SEVERAL OTHER CHANGES IN DETAILS.
17-08-83 RDTRIG        CHANGED VERSION OF RDTRG, DOES NOT CALL RDTRG1,2
                       INCLUDES TRIGGER VERSION OF 1982 AS DEFAULT. NEW
                       COMMON /CTRIGG/ INTRODUCED.
17-08-83 RDHEAD        CALLED IN RDJETC BEFORE RDTRIG. SAVES HEAD WORDS
                       6-8 (DATE) INTO HEAD WORDS 96-98.
17-08-83 RDTRG1        CHANGED TO CALL RD82T1 FOR 1982 AND LATER. A BUG
                       IN TOF WIDE COPLANAR TRIGGER CORRECTED.
17-08-83 RDTRG2        CHANGED TO CALL RD82T2 FOR 1982 AND LATER. A BUG
                       IN T2 COPLANARITY SIMULATION CORRECTED.
17-08-83 RDRESO        CHANGED TO PERFORM THE NEW SMEARING SCHEME,
                       SEE JADE COMPUTER NOTE 66.
18-08-83 MUCONW        OLD VERSION REJECTED, BECAUSE THE MACRO 'F22ALL.
                       JADEMUS(CMUEDWRK) WAS MISSING TO DIMENSION THE
                       TWO ARRAYS 'HLOC' AND 'HUPDAT'. NOW THE STANDARD
                       VERSION OF MUCONW ON 'F22ALL.JADEMUS' IS USED.
19-08-83 RDMTCO        SMALL CHANGE TO THE TP FUDGE PART
23-08-83 MUCONW        MUCONW IS IDENTICAL TO THE F22ALL.JADEMUS VERSION
                       IT IS NOW DELETED, LINK F22ALL.JADEMUL INSTEAD.
23-08-83 RDMTCO        PRINT UPDATED.
23-08-83 EVREAD        NO TEST ON IREADM VARIABLE FOR CALL TO RDMTCO
23-08-83 EVWRIT        COMPLETE UPDATE FOR MTCO BANK WRITING
23-08-83 RDDATE        SET DATE OF APRIL 1982 IN HEAD BANK
23-08-83 RDTRIG        BLOCK DATA FOR IHIST NOW APRIL 1982
23-08-83 #COPY         FAST READ AND WRITE BOS PROGRAM FOR COPY WITHOUT
                       SMEARING. ORIGINAL VERSION FROM E.ELSEN.
23-08-83 JOBINFO       TEXT MEMBER FOR INFORMATION ON VARIOUS JCL.
23-08-83 RDPETERS      DELETED, SINCE OUTDATED
23-08-83 TEXT          DELETED, SINCE OUTDATED
25-08-83 EVTINI        COMMON /CWSET/ INCREASED TO ALLOW 4000 JETC HITS
25-08-83 JSPOIN        COMMON /CWSET/ INCREASED TO ALLOW 4000 JETC HITS
25-08-83 JIPATR        COMMON /CWORK/ CHANGED TO ALLOW 400 HITS/TRACK
                       IN HLIST. THIS ARRAY ONLY HOLDS THE HITS FOR THE
                       CURRENT TRACK NOW. ARRAY POINTERS THUS SIMPLIFIED
25-08-83 TRCDET        COMMON /CWORK/ CHANGED AS ABOVE. CALLS JHITIN
                       (AS BEFORE) BUT NOW HAS AN ALTERNATIVE RETURN
                       IF 4000 JETC HITS EXCEEDED.
25-08-83 JRING         COMMON /CWORK/ CHANGED AS ABOVE. NEW COMMON
                       /C4VHIT/ ADDED ALONG WITH CODE TO STORE THE
                       ASSOCIATION OF 4 VECTOR TRACKS WITH JETC HITS.
                       SOME EXISTING CODE SIMPLIFIED.(STAGE 1)
25-08-83 JHITIN        COMMON /CWORK/ CHANGED AS ABOVE. NEW COMMON
                       /C4VHIT/ ADDED ALONG WITH CODE TO STORE THE
                       ASSOCIATION OF 4 VECTOR TRACKS WITH JETC HITS
                       AFTER THE HITS ARE SORTED. ALTERNATIVE RETURN
                       OCCURS IF MORE THAN 4000 HITS WERE TO BE ADDED
                       TO HITAR ARRAY BY EXECUTING THIS ROUTINE.
25-08-83 WRTMCB        COMMON /C4VHIT/ ADDED AND CODE TO CREATE THE
                       NEW 'HITL' BANK (NUMBER 8). S/R MVCL CALLED
                       TO COPY THE BYTES INTO BOS STORAGE AS S/R MVC
                       DOES NOT WORK PROPERLY. OLD 'HEAD' POINTER
                       SYSTEM REMOVED.
27-08-83 BRVECT        NEW VERSION WITH EXPANDED /CPROD/ COMMON.
                       IT NOW CALLS STPALL AFTER STVECT TO PRODUCE
                       THE 'PALL' BANK (CONTAINING ALL MC PARTICLES).
27-08-83 STVECT        NEW VERSION WITH EXPANDED /CPROD/ COMMON.
27-08-83 STPALL        NEW ROUTINE LIKE STVECT BUT CREATES THE 'PALL'
                       BANK FROM INFORMATION IN /CPROD/.
30-08-83 MCJADE,JGETEV CHANGED TO MAKE A CORRECT EVENT COUNT. ALSO
                       CHANGED SO THAT BY PRIVATE CHANGE OF PARAMETERS
                       IEVMIN AND IEVMAX IN JGETEV IT IS POSSIBLE TO
                       TRACK ONLY A SELECTED SECTION ON THE INPUT FILE,
                       E.G. EVENTS 201 - 400.
01-10-83 JHITIN        COMMENT CHANGED. FOR A GIVEN WIRE IN JETC BANK,
                       THE HITS ARE STORED IN ORDER OF DECREASING DRIFT
                       TIME. THE CODE WAS RIGHT BUT THE COMMENT WAS NOT.
04-10-83 RDMERG        MODIFIED TO HANDLE THE NEW 4V PARTICLE/JETC HIT
                       ASSOCIATION INFORMATION IN THE 'HITL' BANK.
                       STAGE 2
04-10-83 RDDOUB        MODIFIED AS FOR RDMERG
04-10-83 RDPOIN        MODIFIED AS FOR RDMERG
04-10-83 RDMODN        MODIFIED AS FOR RDMERG. CREATES NEW 'HTSL' BANK
                       WHICH ASSOCIATES THE UNSMEARED HITS WITH THE
                       SMEARED HITS.
04-10-83 MCTR4V        THIS NEW ROUTINE CREATES THE 'TR4V' BANK
                       WHICH STORES THE 4 VECTOR PARTICLE ORIGIN OF
                       EVERY 'PATR' TRACK  - STAGE 3
06-10-83 RDTRIG        TO CURE OVERLAY PRINT PROBLEM, LOCAL PRINT
                       IS NOW STEERED FROM COMMON /CPRIPR/, BLOCK DATA
                       SET IN RDTRIG.    J.O.
06-10-83 RDMTCO        ENTRY RDJETC CHANGED TO INCLUDE CREATION OF
                       UNSMEARED 'JETC'/9 BANK BEFORE CALL TO RDRESO.
06-10-83 RDMODN        'JETC'/9 CREATION CODE DELETED (NOW IN RDJETC)
06-10-83 MCTR4V        CORRECTED VERSION REPLACED EARLIER VERSION.
                       ALSO MCTR4V HAS 2 ARGUMENTS NOW TO HANDLE ERRORS
                       AND STEER ROUTINE WHEN A 'TR4V' BANK ALREADY
                       EXISTS.
13-10-83 @TPMAIN1      CORRECTED VERSION OF @TPMAIN, WITH CORRECT
                       HANDLING OF CONSTANTS RECORDS. CORRESPONDING JCL
                       IN MEMBER #TPMAIN1.         J.OLSSON
13-10-83 RDDOUB        BUG CORRECTED IN CASE WHERE SEVERAL HITS ARE LOST
                       IN DOUBLE HIT CUT.
17-10-83 RDDOUB        ABSORBED HITS NOW HAVE A NEGATIVE POINTER TO THE
                       SMEARED HITS THAT ABSORBED THEM.
17-10-83 RDPOIN        HANDLES THE NEGATIVE POINTER DESCRIBED ABOVE.
17-10-83 MCTR4V        HANDLES THE NEGATIVE POINTER DESCRIBED ABOVE.
                       THIS ROUTINE WILL PROBABLY BE MOVED TO JADEGS/L.
17-10-83 RDMTCO        THE GENERATION OF JETC/9 IS NOW CONDITIONAL ON
                       THE VALUE OF VARIABLE IJETCI, IN /CADMIN/
                       ALSO /CBINMC/ HAS BEEN ADDED.
17-10-83 EVREAD        VARIABLE IJETCI ADDED IN /CADMIN/ BLOCK DATA. IT
                       STEARS THE GENERATION OF JETC/9 IN RDMTCO.
17-10-83 TRCOIL        ERROR PRINT INSTALLED TO TRAP NEGATIVE SQRT.
18-10-83 @TPMAIN       OLD VERSION SCRATCHED, @TPMAIN1 RENAMED. THE JCL
                       MEMBER #TPMAINC CHANGED ACCORDINGLY.
18-10-83 BLDAT         UPDATED WITH MACROS CGEO2,CGEO3. CHANGED CJDRCH
                       AND CGEO1 INTO USE OF MACROS. UPDATED CJTRIG.
18-10-83 CPROD         THE MACRO WAS INTRODUCED AND CHANGED TO DIMENSION
         STPALL        500,300. BRVECT AND STVECT CHANGED TO USE MACRO
  BRVECT,STVECT        STPALL CHANGED TO THESE DIMENSIONS, NOT JET MACRO
 #RCPROD,GENMU,GENEE   ALSO #RCPROD,GENMU AND GENEE CHANGED ACCORDINGLY.
18-10-83 RDMTCOGS      THESE MEMBERS CONTAIN ALL ROUTINES FOR SMEARING
         RDTRIGGS      AND TRIGGER SIMULATION. THEY ARE INTENDED FOR USE
                       ON JADEGS,JADEGL; TOGETHER WITH RDDATE THEY MAKE
                       A FAST COPY OF ALL THE ROUTINES POSSIBLE.
                       THUS ANY CHANGE TO SMEAR AND TRIGGER SIMULATION
                       ROUTINES SHOULD BE DUPLICATED IN THESE MEMBERS.
19-10-83 MCTR4V        DELETED,AS IT WILL NOW RESIDE ON F11LHO.JADEGS/L
19-10-83 RDDATE        SMEARING MONTH CHANGED TO MAY.
19-10-83 CPROD         CPROD CHANGED BACK TO NATURAL ARRAY TYPES
         BRVECT        AND THE OTHER ROUTINES MODIFIED ACCORDINGLY
         STVECT        INCLUDING LOCAL ARRAY EQUIVALENCE WITH CPROD.
         STPALL        ALSO COMMENTING IMPROVED.
20-10-83 EVREAD,EVWRIT DELETED AFTER LIBRARY RENAMING, NOW ON JADEGS,GL
         TPINITX       DELETED AFTER LIBRARY RENAMING, NOW ON TPSOURCE,L
         #TPMAINC      CHANGED REFERENCE F22ELS.JMC.S1 TO JMC.S
20-10-83 CPROD         IPHI AND ITHETA CHANGED TO PHI AND THETA
         BRVECT         "    "     "      "     "  "   "    "
         STVECT        IPHI EQUIVALENCED TO PHI. ITHETA EQUIV. THETA
         STPALL         "         "       "  "     "      "      "
20-10-83 TRCOIL        NEGATIVE SQRT ERROR CORRECTED, NOW RETURN1 J.O.
24-10-83 RDRESO        IN THE OLD VERSION THERE WERE CASES WHERE FOR
                       HITS NEAR WIRE PLANE THE SMEARED DRIFTTIME GOT
                       NEGATIVE. NOW ONLY POSITIVE DRIFTTIMES ARE
                       POSSIBLE.
25-10-83 #TPMAINC      MISPRINTS CORRECTED (UNIT=FAST <-> DISP=SHR)
25-10-83 WRTMCB        ERROR CORRECTED. 'PALL' HAS TO BE PUT INTO THE
                       SPECIAL LIST FOR THE FIRST EVENT AS THE LIST IS
                       CLEARED IN ORDER TO OUTPUT THE CALIBRATION.
25-10-83 MCNEWS        NEWS UPDATED.
26-10-83 MCJADE,TRCOIL SMALL ERRORS CORRECTED IN THESE ROUTINES.
 TRCDET,JPRABS,MCNEWS
26-10-83 WRTMCB        ERROR RETURN (IN PALL CORRECTION ABOVE) CORRECTED
27-10-83 STPALL,MCNEWS IFLAVR  ==> IABS( IFLAVR ) ; MCNEWS FORMAT NICER
28-10-83 #TPMAINC      NAME CHANGE: F11LHO.TAGGING.L -> F11LHO.TAGG.L
28-10-83 TRCOIL        TYPING ERROR FROM 26.10 CORRECTED, CAUSE
                       OF DIVIDE CHECK IN TRLGL...     W.BARTEL,J.OLSSON
28-10-83 TRLGL         REMOVE MUONS INTERACTING IN LEAD GLASS W.BARTEL
28-10-83 #TPMAINC      SUBR. DUMMY INCLUDED AGAIN,CALLED BY TPSPRV
31-10-83 @TPMAIN       THE CALL TO BSAW, WITH THE LIST OF OUTPUT BANKS,
                       REINSTALLED AGAIN. IT IS NECESSARY, SINCE BSAW IS
                       NOT CALLED AT CREATION OF TPTR,TPVX,TPEV...
31-10-83 @TPMAIN       COMMENTING ALTERED TO CONFORM WITH TPSOURCE
                       VERSION IN ORDER TO MAKE COMPARISONS EASIER.
10-11-83 #TPMAINC      DUMMY AND @TPMAIN REMOVED - FORMER IS DEAD
                       WHILE THE LATTER IS CALLED AS A LOAD MODULE.
10-11-83 #PRODMU       DNAGLIB IN LKED.SYSLIB NOW
10-11-83 WRTMCB        BSAW CALLED FOR 'MUCH' AND 'MUHC' BANKS
14-11-83 RD-ROUTINES   THEY WERE SCRATCHED FROM JMC.S AND JMC.L, SINCE
 SCRATCHED WERE:       THEY ARE KEPT ON JADEGS,JADEGL. ON JADEGS, THEY
 RDMTCO,RDRESO,RDRDMH, ARE FOUND IN THE MEMBERS RDMTCO,RDTRG1,RDTRG2,
 RDPOIN,RDPATR,RDMODN, RDTRIG,RDDATE,RDHEAD.
 RDDDCL,RDINEF,RDDOUB,   THE SCRATCHED MEMBERS ARE STILL PRESENT ON THE
 RDMERG,RDALGN,RDDATE,   BACKUP F22ELS.ZZ.JMC.S.B831114
 RDHEAD,RDTRG1,RDTRG2,
 RDTRIG.
15-11-83 BRVECT0       OLD VERSION SCRATCHED
18-11-83 TOFMAK        LONG STANDING MISTAKE CORRECTED IN BANK DESCR.
DEC   83 #MCJADE,BLDAT,GENEE,GENMU,JELOSS,JGETEV,JGETVC,MCJADE,TRLGL,
         TRKGAM
                       KANZAKI ENERGY LOSS IN LEAD GLASS
                       TRACKING OF NEUTRONS AND K0L
                       3 DIM SHOWER FOR E/GAM (OPTIONAL, USE LFLAG(4))
                       BREMSSTRAHLUNG LOSS WITH EYGES EQUATION
                       START/STOP EVENT SET THROUGH /CIEV/
06-02-84 MCJADE        USES NEW JADEBD BLOCK DATA
         JGETEV        SMALL COUNTING ERROR CORRECTED
         MCVALI        IMPROVED ROUTINE. DOES NOT REJECT EVENTS WITH LOW
                       ENERGY PHOTONS (< 200 MEV) THAT ARE E/P/M WRONG.
         #PRODMU       NOW HAS ALL NECESSARY DATE/SEEDING CODE
         #MCJADE       BROUGHT UP TO DATE
09-02-84 BLDAT         SCRATCHED
09-02-84 JMULSC        NEW VERSION IMPLEMENTED FROM F22HAG.MCARL
16-02-84 MCVALI        PTOT=EBEAM NOW LEGAL
27-02-84 MCVALI        NO INPUT CHECKING FOR PARTONS AT ALL NOW.
28-02-84 MCVALI        .LT. ==> .LE. FOR TEST 9
28-02-84 MCVSUM        CORRECT PRINTOUT
25-03-84 MCREDU        BETTER VERSION FROM F22ELS.CS11 IMPLEMENTED
11-05-84 #MCJADE       CERN.KERNLIB4 UPDATE  J.O.
12-10-84 MCVALI        BEAM ENERGY TEST UPPER LIMIT NOW 32.767 GEV
                       BECAUSE HEAD BANK STORES EBEAM IN SIGNED I*2 WORD
12-10-84 MOST JOBS     CERN.KERNLIB4 UPDATE   C.B.
09-11-84 JTRNTR        IMPROVED VERSION FROM K-H.H (K DECAY BETTER)
         TRCDET           "        "      "    "    "   "      "
         TRKADC        NEW ROUTINE FROM K-H.H FOR K DECAY
06-11-85 MCTAG-ROUTINES   COPIED FOLLOWING ROUTINES FROM
                       F22FIN.MCTAG.S :    (ACC. TO J.C.N.  86)
      MCTAGI,MCTAGM,MCTAGB,MCTAGC,MCTAGS,MCTAGR,MCTAGF,MCTAGE,NINT
         IN ADDITION, EVTINI AND STATAG AND MCJADE WERE COPIED INTO
         MEMBERS EVTINI1,STATAG1 AND MCJADE1
         JOB MEMBER #MCJADE1 ALSO INSTALLED.
         THE LATTER 4 SHOULD BE RENAMED INTO THE STANDARD MEMBERS WHEN
         THE CHANGEOVER TAKES PLACE (7.11.85 OR LATER)    J.O.
07-11-85    THE ABOVE MENTIONED RENAMING WAS DONE. IN ADDITION, THE
         SUBROUTINE TAGS2H WAS COPIED FROM F11LHO.TAGG.S, IN ORDER
         TO PREVENT COLLAPS OF JOBS WHICH STILL HAS THE OLD JCL, WITHOUT
         LINKING F11LHO.TAGG.L, WHICH IS NOW REQUIRED. AFTER SOME TIME
         TAGS2H SHOULD BE DELETED FROM JMC.S AND JMC.L    J.O.
15-02-86    INSTALMENT OF TRKGAM9 AND STHEAD9, IN PREPARATION FOR THE
         CORRECTION OF PHOTON TRACKING ERROR, DESCRIBED IN JCN 87. J.O.
15-03-86    INSTALMENT OF TRKGMV9, IN PREPARATION FOR JCN 87   J.O.
06-06-86    INSTALMENT OF WEGAS (SAME AS VEGAS IN TRLGSH)
            WEGAS IS COMMON FOR THE SF5 (TRLGSH) AND SF6 (TRLGS6)
            INSTALMENT OF LIMINT, ALSO A COMMON ROUTINE OF TRLGSH AND
            TRLGS6.  FURTHER TRLGL9 INSTALLED TO ACCOUNT FOR BRANCHING
            BETWEEN THE 2 VERSIONS OF TRLGSH/6.  UNDER THE NAME OF
            TRLGS5, TRLGSH HAS VEGAS AND LIMINT REMOVED, CALL TO WEGAS
            INTRODUCED. BOTH TRLGS5 AND TRLGS6 HAVE FUNCTION ELSMR REMO-
            VED, SINCE IT IS IDENTICAL TO FUNCTION ELSMR IN TRLGL. THE
            BLOCKDATA FOR LFLAG HAS ALSO BEEN REMOVED IN BOTH VERSIONS,
            SINCE ANOTHER BLOCK DATA ALREADY EXISTS AND ANY EXPLICIT
            STATEMENT OVERRIDES THE BLOCK DATA. #MCJADE HAS A WRITTEN
            COMMENT THAT LFLAG(4)=.TRUE. SHOULD ALSO HAVE LFLAG(2)=.TRUE
                                          J.OLSSON / N.MAGNUSSEN
09-06-86    MCJADE CHANGED TO INSURE LFLAG(2) TRUE IF LFLAG(4) TRUE J.O.
10-06-86      PREPARATION FOR TURN OVER TO HAGEMANN VERSION OF TRACKING.
            INSTALLED NEW VERSIONS: EVTINI9,JCHAMB9,JINIT9,JPRABS9,
                                    JPRFRE9,JPRTHI9,JPRTLO9,JRCHCK9,
                                    JRING9,JSTEP9,JTRAPZ9,MCJADE9,
                                    MCMAIN9,MCNEWS9,TRCDET9,WRTMCB9
                                    JTRKGM9
            INSTALLED NEW MEMBERS: JFTEST,JVDTIM,JVTXCH,TRCDTV,#MCJADEM
                                   #MCPAIR
            REMOVED BLOCK DATA IN TRLGKA, UPDATED $JOBINFO,#MCJADE
 TURN OVER:  0-VERSIONS OF ALL 9 VERSIONS ABOVE INSTALLED, ALSO TRLGSH0
            STHEAD0, TRKGAM0 AND TRLGL0
            RENAMED ALL 9-VERSIONS TO STANDARD, TRLGS5 TO TRLGSH
             HOPE IT IS ALL DONE CORRECTLY!       J.OLSSON
11-06-86    TRKGAM,TRKGMV: CORRECTED RADIATION LENGTHS  J. HAGEMANN
11-06-86    STHEAD  SETTING OF HEAD WORD 17              J. OLSSON
11-06-86    TRLGS6,TRLGSH PRINT STATEMENTS COMMENTED OUT  J. OLSSON
11-06-86    MCJADE: T.O. LIMIT DEPENDS ON LFLAG(4)        J. OLSSON
02-07-86    TRLGSH: BUG, KILLING ALL PHOTONS, REMOVED     J. OLSSON
03-07-86    TRLGSH,TRLGS6  RATIO ESEEN/ENERGY ERROR CORR. J. OLSSON
17-07-86    STLATC UPDATED VERSION ADDED                  J. HAGEMANN
17-07-86    TRLGSH AND TRLGS6 WERE CORRECTED FOR 2 BUGS: POSITION
            VECTOR FOR ENDCAP PHOTONS AND ELECTRONS IS NOW UPDATED.
            PREVIOUSLY NO UPDATE, LEADING TO DOUBLE TRACKING OF THESE
            PARTICLES. ALSO THE SCALING OF BLOCK ENERGIES DUE TO READ-
            OUT THRESHOLD HAS BEEN REMOVED.          J.OLSSON
04-09-86    TRLGSHE INSTALLED FOR TEST PURPOSE, WITH OLD ERRORS  J.O.
            TRLGLE INSTALLED FOR TEST PURPOSE  J.O.
            UPDATED TRLGSH AND TRLGS6 ENDCAP POSVECTOR WITH 20 % EXTRA
            TO AVOID PRECISION PROBLEM IN TRLGL CUTS   J.OLSSON
15-09-86    CORRECT BUG IN MCVALI (EL.MASS .000551)  J.O./U.SCHNEEKL.
19-01-87    TRLGSH AND TRLGS6 UPDATED, WITH NEW VALUES OF THE INTERNAL
            PARAMETERS FACMC AND FNORM. THESE ARE PROBABLY NOT FINAL
            VALUES, EXTENSIVE STUDIES AT VARIOUS ENERGIES ARE STILL
            NEEDED. SHOULD BE OK FOR ORDINARY USE, THOUGH
                                       J.OLSSON  AND  N.MAGNUSSEN
30-01-87    TRLGS6 WITH THE FUNCTION SF65 WAS CORRECTED, AFTER A NEG.
            ARGUMENT APPEARED IN ALOG. THIS SHOULD BE VERY RARE, IF
            NOT IMPOSSIBLE. A DEBUG PRINT HAVE ALSO BEEN INTRODUCED,
                                       J.OLSSON  AND  N.MAGNUSSEN
02-02-87    SIMILAR UPDATE OF FUNC. SF56        J.O.  N.M.
             ( THE TRLGS6 FROM 30.1 KEPT AS TRLGS61 )
10-02-87    UPDATE OF MCTAGF, ACC. TO WISHES FROM A.FINCH
            OLD VERSION KEPT AS MCTAGF0                     J.O.
12-02-87    SIGN CORRECTION IN SF65,TRLGS6            N.M.(J.O.)
01-04-87    INCREASE DIMENSION LISTBL BLCFRC IN TRLGS6,TRLGSH
                                                      D.P. J.O.
13-04-87    TRLGS6,TRLGSH CHANGED: BLCFRC CORRECTED BY AVGSUM, IN ORDER
            TO KEEP RESOLUTION                        D.P. J.O.
02-05-87    TRLGS6,TRLGSH CHANGED: PROTECT AGAINST DIVIDE CHECK FOR THE
            CASE THAT AVGSUM = 0.                          J.O.
07-05-87    TRLGS6 FORMAT ERRORS CORRECTED           C.B,J.O.
10-05-87    PRINT STATEMENT IN TRKGMV COMMENTED OUT      J.O.
10-09-87    CORRECTED BUG IN STATAG      P.HILL, J.OLSSON
09-11-87    DATEMC NOW SETS DATE ACCORDING TO TODAY. E ELSEN
18-12-87    DATEMC PRODUCES CURRENT TIME AS BEFORE
            STHEAD CHANGED TO LOG PRODUCTION DATE AND
            CONFIGURATION DATE                       E ELSEN
21-12-87    REMOVED MULTIPLE VERSIONS OF DATEMC.
            NO DIFFERENECE FOR THE USER.             E ELSEN
22-12-87    UPDATED NVERT ACCORDING TO SPEC FROM C.KLEINWORT   J.O.
20-01-88    MCJADE NOW CALLS JBWTOR, ENABLES OPERATOR TO STOP LONG JOBS
            J.O. AND A. WEGENER
31-01-88    SOME MINOR BUGS AND INCONSISTENCIES WERE CHANGED IN THE
            FOLLOWING ROUTINES:   MCTAGM9, MCTAGB9, MCTAGR9, MCTAGS9
            THE STANDARD VERSIONS ARE NOT YET CHANGED, AND THE NEW ONES
            HAVE TO BE INCLUDED. THE TAGGING EFFICIENCY CHANGES BY C:A
            + 5 %, WHEN USING THE CORRECTED VERSIONS.
            THE NEW VERSIONS SHOULD BE CHECKED BY THE TAGGING EXPERTS,
            BEFORE THEY ARE MADE STANDARD.             J.OLSSON
16-04-88    INSTALLED MCTAGB8: ALEX FINCH PROVIDED IT TO ACCOUNT FOR
            THE WRONG DIMENSION OF MARKIII TAGGER. TEST VERSION!  J.O.
02-03-89    RENAMED MCTAGR, MCTAGS AND MCTAGB TO 0-VERSIONS.
            RENAMED MCTAGR9 AND MCTAGS9 TO STANDARD VERSIONS. SEE NOTE
            ABOVE (01/88) ON ERRORS IN THESE ROUTINES. RENAMED MCTAGB8
            TO STANDARD VERSION.  MCTAGB9 TO BE FORGOTTEN.
            MCTAGM WAS UPDATED (X0 FOR MARK III). MCTAGM9 ALSO TO BE
            FORGOTTEN. FOR PROPER HANDLING OF EDGE EFFECTS, USE GEANT MC
            BY CHRIS HOWARTH INSTEAD.                      J.O.
06-03-89    UPDATE MCTAGM: PV-VECTOR IS NOW UPDATED TO 0., FOR CASES
            OF HITTING TAGGER.
            UPDATE MCTAGB LANGUAGE TO FORTRAN IV, WAS F-77.   J.O.

C   27/03/97 703271158  MEMBER NAME  $HISTOR0 (JMC.S)       FVS
         JMC.S HISTORY     (8.1980   -   7.1982)
         =============

19-08-80 EVTINI     INITS FWD COMMON CGGRAW
19-08-80 INIFWD     DUMMY VERSION ON JMC.L
19-08-80 FWDDET     DUMMY VERSION ON JMC.L
19-08-80 WRTMCB     ATAG BANKS WRITTEN NOW
21-08-80 STATAG     CREATES ARRAY FOR ATAG BANK, CALLED IN WRTMCB

21-08-80 MCJADE     COMMON /CJTRLE/ CHANGED
21-08-80 TRCDET     COMMON /CJTRLE/ CHANGED + ADDITIONS
21-08-80 PRJABS     COMMON /CJTRLE/ CHANGED + ADDITIONS

22-08-80 TRKGAM     TOF TRACK LENGTH CORRECTED

22-08-80 COORD      COPIED FROM 'F22HOW.MCGAMGAM.S'
22-08-80 GGBLNO     COPIED FROM 'F22HOW.MCGAMGAM.S'

25-08-80 FWDDET     VERSION FROM 'F22HOW.MCGAMGAM.S(FWDDET)'
25-08-80 RDSTAT     NEW
25-08-80 RDTRG1     CREATES LATC NOW.

22-02-81 STALGN     EXTENDED FOR ADDITIONAL FLAG HANDLING

06-05-81 MCNEWS     CALLED IN MCJADE TO PRINT NEWS

08-05-81 LGINIT     CALLED IN MCJADE
08-05-81 TRLGL      NEW VERSION INCORPORATING O'NEILL'S SHOWER CALCULA.
                    THE ROUTINE REFERENCES OTHER NEW ROUTINES
08-05-81 JINIT      LGINIT, MUTRAK, INIFWD CALL FROM MCJADE NOW HERE
26-05-81 RDMTCO     JETC RANDOM HITS EVEN IF NO JETC BANK IN RAW EVENT
26-05-81 RDMODN     JETC RANDOM HITS EVEN IF NO JETC BANK IN RAW EVENT

13-11-81 JSTEP      MADE SAVE AGAINST MAG FILED < 0
13-11-81 JIPATR     MADE SAVE AGAINST MAG FILED < 0
13-11-81 BLDAT      BKGAUS NEGATIVE

19-11-81 BLDAT      XRCOIL ETC.
19-11-81 RDMESS         NEW VERSIONS OF RD-ROUTINES
19-11-81 RDMTCO         MAIN CHANGE IS INTRODUCTION OF
19-11-81 RDSTAT         NEW COLLINEAR TRIGGER FOR 1981
19-11-81 RDSTAT0179
19-11-81 RDSTAT0180
19-11-81 RDSTAT0280
19-11-81 RDSTAT0181
19-11-81 RDTRG1
19-11-81 RDTRG2
19-11-81 RDALGN        NEW ROUTINE TO LG-READOUT THRESHOLD

04-01-82 RDALGN        ERROR IN POINTER SETTING CORRCTED

04-02-82 MCJADE        TYPE < -100 NOT TRACKED

                       FOLLOWING ROUTINES NEW OR CHANGED TO
15-02-82 BRVECT        ALLOW FOR SECOND VECT BANK AND LATER
15-02-82 EVTINI        EXTENSIONS.
15-02-82 GENEE
15-02-82 JCHAMB
15-02-82 JELOSS
15-02-82 JGETEV
15-02-82 JGETVC
15-02-82 JPRABS
15-02-82 JRCHCK
15-02-82 JRING
15-02-82 JTRAPZ
15-02-82 JTRKGM
15-02-82 MCJADE
15-02-82 MCNEWS
15-02-82 STHEAD
15-02-82 STVECT
15-02-82 SVECT1
15-02-82 TRCDET
15-02-82 WRTMCB

15-02-82 JTRKGM        CONVERTED GAMMAS STILL DEPOSITED ENERGY DIRECTLY

                       THE FOLLOWING CHANGES ARE RELATED TO MAKING
                       THE SCHEME COMPATIBLE TO NEW MUON MONTE CARLO.
13-05-82 MUASOR        SCRATCHED
13-05-82 MUCONE        SCRATCHED
13-05-82 MUDEDX        SCRATCHED
13-05-82 MUENDP        SCRATCHED
13-05-82 MUERRZ        SCRATCHED
13-05-82 MUINIT        SCRATCHED
13-05-82 MUINTA        SCRATCHED
13-05-82 MULTSC        SCRATCHED
13-05-82 MUMATR        SCRATCHED
13-05-82 MUMESZ        SCRATCHED
13-05-82 MUPIDK        SCRATCHED
13-05-82 MUROT         SCRATCHED
13-05-82 MURTNE        SCRATCHED
13-05-82 MUSCAT        SCRATCHED
13-05-82 MUSIG         SCRATCHED
13-05-82 MUSTEP        SCRATCHED
13-05-82 MUSTOR        SCRATCHED
13-05-82 MUTRAK        SCRATCHED
13-05-82 MUYOKE        SCRATCHED
13-05-82 MUZERO        SCRATCHED
13-05-82 MUCONM        DUMMY VERSION NOW
13-05-82 MUMIPR        DUMMY VERSION NOW
13-05-82 MUORDR        DUMMY VERSION NOW
13-05-82 MUMESS        ATTACHED TO MUCONM
13-05-82 MUERRY        ATTACHED TO MUCONM
13-05-82 MCJADE        CHANGED TO ALLOW FOR MUON CALLS
13-05-82 EVTINI        CALLS TO MU ROUTINES REMOVED
13-05-82 JINIT         CALLS TO MU ROUTINES REMOVED
13-05-82 WRTMCB        MUCONW CALL INTRODUCED
13-05-82 MUCONW        COPIED FROM F22ALL.JADEMUS

13-05-82 RDMTCO        RDTRG CALL INTRODUCED
13-05-82 RDTRG1        CALLED IN RDTRG NOW
13-05-82 RDTRG2        NOW CALLED IN RDTRG
13-05-82 RDTRG         PICKS UP TRIGGER STATUS ACCORDING TO HEAD-DATE

03-06-82 TRCDET        PCUT BEFORE PIKDEC CALL INTRODUCED

21-07-82 WRTMCB        ZET-CHAMBER NOW WRITTEN
-----------------------------------------------------------------------I
I  THE CONTINUATION OF THE HISTORY FOLLOWS IN $HISTORY                 I
I----------------------------------------------------------------------I
C   27/03/97 703271158  MEMBER NAME  $JOBINFO (JMC.S)       FVS
***********************************************************************
*                                                                     *
*   INFORMATION ABOUT VARIOUS JCL MEMBER ON F22ELS.JMC.S              *
*                                                                     *
***********************************************************************

#COPY:          FAST READ AND WRITE PROGRAM FOR THE COPY OF BOS EVENTS
                WITHOUT SMEARING, ETC.

#JBLKMP         THIS JOB USES MEMBER MCMAIN TO MAKE A LINKING OF THE
                TRACKING PROGRAM.  THE LKED OUTPUT IS STORED ON A DISK-
                FILE WHICH CAN BE USED BY THE GRAPHICS PROGRAM LKEDXREF,
                TO PRODUCE LINK-TREES, SEARCH FOR CALLS, ETC.

#MCMUMU         THIS JOB CREATES 4-VECTORS FOR E+E- ---> MU+ MU- AND
                TRACKS THEM THROUGH DETECTOR. THESE EVENTS ARE USEFUL
                FOR RESOLUTION STUDIES. THE ROUTINE GENMU IS USED.

#MCPAIR         THIS JOB CREATES 4-VECTORS FOR E+E- ---> MU+ MU-,
                E+ E-, PI+ PI-  ETC. ANDTRACKS THEM THROUGH DETECTOR.
                THESE EVENTS ARE USEFUL FOR RESOLUTION STUDIES.
                THE ROUTINES GENMU OR GENEE ARE USED.

#MCJADE         GENERAL TRACKING JOB, USING THE ROUTINE MCJADE. THE JOB
                CONTAINS SEVERAL OPTIONS FOR INPUT AND OUTPUT AND IS A
                MERGED COMBINATION OF THE PREVIOUS JOB-MEMBERS #PROCT
                AND #PRCTJOB.

#MCJADEM        GENERAL TRACKING JOB, USING THE ROUTINE MCJADE. THE JOB
                CONTAINS SEVERAL OPTIONS FOR INPUT AND OUTPUT AND IS
                SIMILAR TO THE PREVIOUS #MCJADE BUT WITH MUON TRACKING.

#PRODUCT        SPECIAL VERSION OF THE PREVIOUS #MCJADE, USING AN EXTRA
                COPY STEP TO MOVE 4-VECTOR EVENTS TO A TEMPORARY DISK-
                FILE, THEN TRACK IN A SECOND STEP AND WRITE OUTPUT DATA
                ON A TAPE.

#PRODMU         PROGRAM TO USE THE GENERAL MUON FILTER TRACKING PROGRAM.
                THE JCL IS SIMILAR TO THE PREVIOUS #PRODUCT. IT HAS BEEN
                UPDATED TO NOT USE THE OUTDATED ASTART0, ASTART1 FILES.

#RCPROD         PROGRAM TO READ AND WRITE 4-VECTOR EVENTS IN THE CPROD-
                FORMAT.

                                               LAST UPDATE 10.06.1986
C   27/03/97 703271158  MEMBER NAME  #JBLKMP  (JMC.S)       FVS
//F11BAR   JOB MSGLEVEL=(1,0),CLASS=E,TIME=(0,10)
//*MAIN RELPRI=MED,ORG=EXT,LINES=(2)
//LKTREE EXEC LKED,PARM.LKED='MAP,LIST,XREF'
//SYSPRINT DD UNIT=FAST,DSN=F11BAR.MCLOAD,
// DCB=(BLKSIZE=968,LRECL=121,RECFM=FBA),
// DISP=(NEW,CATLG,DELETE),
// SPACE=(TRK,(20,5),RLSE)
//LKED.SYSLIB DD DSN=F11BAR.JMC.L,DISP=SHR
//            DD DSN=JADELG.LOAD,DISP=SHR
//            DD DSN=F11LHO.JADEGL,DISP=SHR
//            DD DSN=F22ALL.JADEMUL,DISP=SHR
//IPSLOADS DD DSN=R02SCH.TSOIPS.LOAD,DISP=SHR
 INCLUDE SYSLIB(MCMAIN)
 ENTRY MAIN
//
C   27/03/97 703271158  MEMBER NAME  #MCJADE  (JMC.S)       FVS
//F22ELS   JOB          CLASS=E,MSGLEVEL=(2,0),TIME=(0,15)
//*MAIN RELPRI=HIG
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//*         THIS JOB USES CERN STYLE JCL                               *
//*                                                                    *
//*            NEW VERSION OF TAGGING TRACKING INSTALLED               *
//*             DETAILS, SEE J.C.N. 86, BY A. FINCH                    *
//*                                                                    *
//**********************************************************************
//*
//TRACK EXEC FORTCG,CPRM=XL,LPRM='LIST,NOMAP',GRGN=550K
//*
//C.SYSIN DD *
C-----------------------------------------------------------------------
      COMMON / BCS / IW(33000)
C
      LOGICAL*1  LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C          LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C          LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C          LFLAG(3) = ABSORPTION LOSSES
C          LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE SLOW!!!!!
C          LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                   = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                   BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C
C                     ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C          IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C          IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C
C                   ==== > DEFAULT IEVMIN = 1
C                                  IEVMAX = 9999999
C
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
      HDATE(1) = 1
      HDATE(2) = 1
      HDATE(3) = 1
      HDATE(4) = 1
      HDATE(5) = 5
      HDATE(6) = 1985
C
      CALL BINT( 33000,10000, 500, 0 )
      CALL MCJADE( 0, 10 )
      CALL BSTA
      CALL PALL
      STOP
      END
//G.SYSLIB DD DSN=SYS1.FORTLIB,DISP=SHR
//         DD DSN=DESYLIB,DISP=SHR
//         DD DSN=F22ELS.JMC.L,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=F11LHO.TAGG.L,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=JADELG.LOAD,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=F22ALL.JADEMUL,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=F11LHO.JADEGL,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//         DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//*
//* UNIT3  INPUT:    4-VECTOR EVENTS IN THE CPROD-FORMAT
//*
//G.FT03F001 DD DISP=SHR,
//        DSN=F22HAG.FAST.VEC4.B436.T180D
//*G.FT03F001 DD DISP=OLD,UNIT=TAPE,
//*       DSN=F22PET.TRIJET.GBD2
//*
//* UNIT2  OUTPUT:    JADE EVENTS IN BOS FORMAT
//*
//G.FT02F001 DD DISP=(NEW,CATLG,CATLG),UNIT=FAST,DCB=R01DCB.VBS,
//       DSN=F11OLS.TESTNWMD,SPACE=(TRK,(20,10),RLSE)
//*G.FT02F001 DD DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*    DSN=F11OLS.XXXXXX.YYYYYY,
//*         MSVGP=VTMP,UNIT=3330V
//*G.FT02F001 DD DUMMY
//*G.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F22ELS.T2TRIJET.GBD2
C   27/03/97 703271158  MEMBER NAME  #MCJADEM (JMC.S)       FVS
//         JOB          CLASS=A,MSGLEVEL=(2,0),TIME=(1,00)
//*MAIN RELPRI=MED
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E M   TRACKING JOB  (WITH MUON TRACKING)         *
//*                                                                    *
//*         THIS JOB USES CERN STYLE JCL                               *
//*                                                                    *
//*            NEW VERSION OF TAGGING TRACKING INSTALLED               *
//*             DETAILS, SEE J.C.N. 86, BY A. FINCH                    *
//*                                                                    *
//**********************************************************************
//*
//TRACK EXEC FORTCG,CPRM=XL,LPRM='LIST,NOMAP',GRGN=912K
//*
//C.SYSIN DD *
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
      COMMON / TODAY / HDATE(6)
      COMMON / BCS / IW(33000)
C
      LOGICAL*1  LFLAG
      COMMON / CFLAG / LFLAG(10)
C
C          LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C          LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C          LFLAG(3) = ABSORPTION LOSSES
C          LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE (SLOW !!!!)
C          LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                   = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                   BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C
C                     ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C          IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C          IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C                   ==== > DEFAULF IEVMIN = 1
C                          IEVMAX = 9999999
C
C
C                  SET DATE AND TIME OF RUN  - 12 NOON ON 1ST MAY 1981
C                  ALSO SET MUON RANDOM NUMBER GENERATOR USING MUSEED
C                  WITH ANY INTEGER (DIFFERENT FOR EACH JOB).
C
      HDATE(1)=1
      HDATE(2)=1
      HDATE(3)=1
      HDATE(4)=1
      HDATE(5)=5
      HDATE(6)=1985
C
      CALL BINT( 33000,10000,100,100)
C                                               SEED GENERATOR
      CALL MUSEED(301)
C                            COMMENTED TO USE OLD HARDWARE
CCC   LFLAG(5) = .TRUE.
C
      CALL MCJADE(0,5)
      CALL BSTA
      CALL PALL
      STOP
      END
//G.SYSLIB DD DSN=SYS1.FORTLIB,DISP=SHR
//         DD DSN=DESYLIB,DISP=SHR
//         DD DSN=F22RJB.RLMC.L,DISP=SHR
//         DD DSN=F22ELS.JMC.L,DISP=SHR
//         DD DSN=F11LHO.JADEGL,DISP=SHR
//         DD DSN=JADELG.LOAD,DISP=SHR
//         DD DSN=F22ALL.JADEMUL,DISP=SHR
//         DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//         DD DSN=SYS1.NAGLIB,DISP=SHR,UNIT=FAST
//         DD DSN=SYS1.DNAGLIB,DISP=SHR,UNIT=FAST
//         DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//         DD DSN=F11LHO.TAGG.L,DISP=SHR
//*
//* UNIT3  INPUT:    4-VECTOR EVENTS IN THE CPROD-FORMAT
//*
//*G.FT03F001 DD DISP=SHR,
//*        DSN=F22MIN.LUNBVECT.GGG44.NORAD.FAST200
//*G.FT03F001 DD DISP=OLD,UNIT=TAPE,
//*       DSN=F22PET.TRIJET.GBD2
//*
//* UNIT2  OUTPUT:    JADE EVENTS IN BOS FORMAT
//*
//*G.FT02F001 DD DISP=(NEW,CATLG,CATLG),UNIT=FAST,DCB=R01DCB.VBS,
//*       DSN=F22ELS.XXXXYYYY,SPACE=(TRK,(80,10),RLSE)
//*G.FT02F001 DD DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*    DSN=F11OLS.XXXXXX.YYYYYY,
//*         MSVGP=VTMP,UNIT=3330V
//*G.FT02F001 DD DUMMY
//*G.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F22ELS.T2TRIJET.GBD2
//*                 CONSTANTS
//G.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//* 13/01/88 902131934  MEMBER NAME  #MCJGEAN (S)           JCL
//*
//*        JOB: JADE MC WITH GEANT
//*
//F11OLS    JOB CLASS=K,TIME=(02,00),MSGLEVEL=(2,0),NOTIFY=F22CPH
//*
//*MAIN RELPRI=HIG
//*                              SIEMENS FORTRAN 77:
//  EXEC JFORTCG,GRGN=2200K,
//*                     GRGN=2000K NOT SUFFICIENT 16.12.87
//*                                      UP TO 15 LOAD-LIBS
//       LLB1='F22CPH.GEANT.L',
//       LLB2='F22ELS.JMC.L',
//       LLB3='JADELG.LOAD',
//       LLB4='F22ALL.JADEMUL',
//       LLB5='F11LHO.JADEGL',
//       LLB6='F1EBLO.BOSLIB.L',
//       LLB7='DESYLIB',
//       LLB8='R01UTL.CERN.DLIBF77',
//       LLB9='R01UTL.CERN.PACKF77'
C
      IMPLICIT INTEGER*2 (H)

      COMMON / BCS / IW (40000)

      LOGICAL  LDEBUG
      COMMON / CDEBUG / LDEBUG

      CHARACTER*80 DATIN,DATOUT
C
      LOGICAL*1  LFLAG
      COMMON / CFLAG / LFLAG (10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES (TRLGL)
C                   SET = .TRUE. TO AVOID SMEARING IN TP-STEP
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C                   SET = .TRUE.
C        LFLAG(3) = ABSORPTION LOSSES = .TRUE.
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGS CODE, SLOW!!!!!
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                 BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C        LFLAG(6) = TOKYO-MC, NOT AVAILABLE
C        LFLAG(7) = GEANT LG TRACKING FOR HADRONS, NOT RECOMMENDED
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C     IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C     IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C
      COMMON / TODAY / HDATE (6)
C ---                     DATE = SEC,MIN,HOUR,DAY,MON,YEAR
      HDATE(1) = 1
      HDATE(2) = 1
      HDATE(3) = 1
      HDATE(4) = 14
      HDATE(5) = 7
      HDATE(6) = 1986

      LFLAG(1) = .TRUE.
      LFLAG(2) = .TRUE.
      LFLAG(3) = .TRUE.
      LFLAG(4) = .FALSE.
      LFLAG(5) = .TRUE.
      LFLAG(6) = .FALSE.
C
      INQUIRE ( UNIT=3, NAME=DATIN  )
      INQUIRE ( UNIT=2, NAME=DATOUT )
      PRINT 31, DATIN, DATOUT
  31  FORMAT(//1X,'INPUT  : ',A80/1X,'OUTPUT : ',A80//)

C---                             FIRST AND LAST EVENT # TO BE TRACKED
      IEVMIN =    1
      IEVMAX =    1
CCC   IEVMAX =   999999

CCC   LDEBUG = .TRUE.
      LDEBUG = .FALSE.

      PRINT 32, IEVMIN, IEVMAX
 32   FORMAT ( /T2, 'FIRST AND LAST EVENT # TO BE TRACKED: ',2I8 / )

C---                                BOS-INITIALIZATION:
      CALL BINT( 40000,10000, 500, 0 )

C---                           GEANT-MC-JADE:
      CALL MCJADE ( 0,  5 )
C---                           BOS-STATISTICS:
      CALL BSTA
C---
      CALL PALL


      END
C   25/11/83 902091216  MEMBER NAME  MCJADE   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCJADE( NREVS, IPRINT )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    11/05/79 :  MC TRACKING PROGRAM
C
C      MOD  E. ELSEN    10/06/82 :
C      MOD  J. OLSSON   30/08/83 :  SUBSET TRACKED & EVENT COUNTING
C      MOD  W. BARTEL   25/10/83 :  PARTICLES BEYOND COIL NOT TRACKED
C      MOD  C. BOWDERY  17/11/83 :  CALL TO MCVSUM FOR ERROR SUMMARY
C      MOD  C. BOWDERY  24/11/83 :  DELETE CALL TO TRCOIL FOR PHOTONS
C      MOD  W. BARTEL   29/11/83 :  IEVMIN/MAX (/CIEVS/) DEFLT. IN BLDAT
C      MOD  W. BARTEL   29/11/83 :  INTRODUCE N AND K0L TRACKING
C      MOD  W. BARTEL   29/11/83 :  EXTERNAL JADEBD  INSTEAD OF BLDAT
C      MOD  J. HAGEMANN 28/08/84 :  VERTEX CHAMBER TRACKING FACILITY
C           R. RAMCKE               IMPLEMENTED
C      MOD  J. HAGEMANN 19/04/86 :  FWDDET REPLACED BY MCTAGM
C      MOD  J.OLSSON    09/06/86 :  LFLAG(2) IS TRUE IF LFLAG(4) IS TRUE
C      MOD  J.OLSSON    11/06/86 :  NSEC T.O. LIMIT DEPENDS ON LFLAG(4)
C LAST MOD  J.O, A.WEG. 20/01/88 :  JBWTOR INSTALLED FOR OPERATOR STOP
C
C    ALLOWS SECTIONS OF THE INPUT FILE TO BE TRACKED.
C    MINIMUM AND MAXIMUM NR OF EVENT SET IN SUBR. JGETEV
C    EVENT COUNT PASSED VIA /CIEVS/ KIEV,IEVMIN,IEVMAX
C
C    WRITE NREVS MTC EVENTS ON UNIT 2. TAKE INPUT FOUR VECTORS
C    FROM ROUTINE JGETVC.
C    IF NREVS .EQ. 0, EVENTS ARE WRITTEN UNTIL EOF OR TIME OUT.
C    INPUT FOUR VECTORS FOR THE FIRST IPRINT ARE PRINTED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C                                      JADE BLOCK DATA IS NOW JADEBD
      EXTERNAL JADEBD
C
      COMMON / CJTCDC / IBANK, IPART
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
      COMMON / CGEO1  / BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *                  RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *                  R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *                  R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *                  RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *                  ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *                  ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *                  ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *                  XRJETC,
     *                  RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *                  BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *                  XHOL1,XHOL2,YHOL1,YHOL2
C
      DIMENSION PV(10),R0(5),RR(5)
      DIMENSION PVSAVE(10),R0SAVE(3)
C
      DATA NSEC / 4 /
      DATA NUNIT / 2 /
C
      LOGICAL*1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                 BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
C------------------  C O D E  ------------------------------------------
C
C                                           PRINT NEWS
      CALL MCNEWS
C
C     ***** JBWTOR ENABLE OPERATOR TO CANCEL IN ORDERED FASHION *****
C             INITIALIZE
C
      CALL JBWTOR(&2727)
      GO TO 2728
C
2727  WRITE(6,2729)
2729  FORMAT(/,'========== JBWTOR INIT ERROR =======')
2728  CONTINUE
C
C
C   LFLAG(2) MUST BE TRUE IF MEIER/MAGNUSSEN LG TRACKING IS USED
C
      IF(LFLAG(4).AND..NOT.LFLAG(2)) WRITE(6,681)
681   FORMAT(' ### WARNING ###  LFLAG(2) SET TRUE, SINCE LFLAG(4) TRUE')
      IF(LFLAG(4).AND..NOT.LFLAG(2)) LFLAG(2) = .TRUE.
C IF 3-D EGS CODE IS USED, LARGER TIME OUT LIMIT IS NEEDED
      IF(LFLAG(4)) NSEC = 6
C
C  LFLAG(5) MUST BE TRUE IF VERTEX CHAMBER GEOMETRY IS USED
C
      IF(LFLAG(5).AND.(HDATE(6).GT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).GE.5))) GO TO 692
      IF(.NOT.LFLAG(5).AND.(HDATE(6).LT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).LT.5))) GO TO 692
      IF(HDATE(6).GT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).GE.5)) LFLAG(5) = .TRUE.
      IF(HDATE(6).LT.1984.OR.
     $   (HDATE(6).EQ.1984.AND.HDATE(5).LT.5)) LFLAG(5) = .FALSE.
      WRITE(6,691)
691   FORMAT('  #####  WARNING ####  LFLAG(5) HAS BEEN SWITCHED TO AGREE
     $ WITH COMMON /TODAY/ SETTING OF DETECTOR HARDWARE')
692   CONTINUE
C                                           INPUT OF MUCHAMBER CALIBRATI
      CALL MUCONM
C
C                                           INITIALIZE PROGRAM
 2200 NEVTS = NREVS
      IF( NEVTS .EQ. 0 ) NEVTS = 999999
C
      IWRT = 0
      CALL BWRO( NUNIT, 1558, 2 )
      CALL JINIT
C
      CALL GEANTI
C
      IF(LFLAG(4)) WRITE(6,111)
  111 FORMAT(//,1X,'***********************************************',/,
     *          1X,'* LEAD GLASS SIMULATION IS DONE USING         *',/,
     *          1X,'*        F11MEI.MCSHOWS(TRLG3)                *',/,
     *          1X,'*                                             *',/,
     *          1X,'* CONTAINING :                                *',/,
     *          1X,'*                                             *',/,
     *          1X,'*     - EM. SHOWERS FROM INTEGRATION OVER     *',/,
     *          1X,'*       3 DIM SHOWER FUNCTION FOR PARTICLES   *',/,
     *          1X,'*       ABOVE 100 MEV                         *',/,
     *          1X,'*     - STANDARD EM-SHOWER PROCEDURE FOR      *',/,
     *          1X,'*       FOR LOW ENERGY PARTICLES              *',/,
     *          1X,'*     - HADRON INTERACTION USING THE KANZAKI  *',/,
     *          1X,'*       SCHEME BASED ON THE KEK MEASURMENTS   *',/,
     *          1X,'*       LIGHT GUIDES ARE INCLUDED FOR BARREL  *',/,
     *          1X,'*                                             *',/,
     *          1X,'*                           VERSION 20/09/83  *',/,
     *          1X,'***********************************************',//)
C
      IF(LFLAG(5)) WRITE(6,112)
  112 FORMAT(///,4X,'***********************************************',/,
     *           4X,'* -> V E R T E X  C H A M B E R  TRACKING <-  *',/,
     *           4X,'*               SWITCHED  O N                 *',/,
     *           4X,'*                           VERSION 28/08/84  *',/,
     *           4X,'***********************************************',/)
C
      DO 1001 IEV=1,NEVTS
C
C TEST FOR OPERATOR STOP
C
      CALL JBWTOR(&92)
C
      IF( JUHR(NSEC) .NE.50 ) GO TO 1011
      IF( JUHR(NSEC) .NE.50 ) GO TO 1011
      GO TO 90
C                                           INITIALISE EVENT
1011  CALL EVTINI
      IJETCP = 0
      IFWHIT = 0
      IPRI = 1
      IF( IWRT .GT. IPRINT-1 ) IPRI= 0
C                                           GET EVENT
      CALL JGETEV( &91 )
C
 1002 CONTINUE
C                                           NEXT PARTICLE
      CALL JGETVC( PV, R0, ICODE, IPRI )
      IF( ICODE .GT. 0 ) GO TO 1003
C
C                                           CHECK TIME FOR PARTICLES
C                                           NECESSARY IF MUONS INCLUDED
      IF( JUHR(NSEC) .NE.50 ) GO TO 1012
      IF( JUHR(NSEC) .NE.50 ) GO TO 1012
      KIEV = KIEV - 1
      GO TO 90
C
C     DON'T TRACK PARTICLES WHICH START ONLY BEYOND THE COIL OR
C     THE END CAP LEAD GLASS ARRAY
C                                   OCT. 25. 1983 W.BARTEL
C
1012  R4 = SQRT( R0(1)*R0(1) + R0(2)*R0(2) )
      IF( R4 .GT. RCOIL) GO TO 1000
      IF( ABS(R0(3)) .GT. ZENDPL) GO TO 1000
C
C                                           FWD TRACKING
CCC   CALL FWDDET( PV, R0, IFWHIT )
      CALL MCTAGM( PV, R0)
C                                           BRANCH ACCORDING
C                                           TO CHARGE OF PARTICLE
C                                           PHOTONS
      IF( PV(7) .EQ. 0. .AND. PV(8).LT.2.) GO TO 3
C                                           BRANCH OFF K0L AND N
      IF( PV(7) .EQ. 0. .AND. ABS(PV(8)-5.) . LT. 1.E-5) GO TO 4
      IF( PV(7) .EQ. 0. .AND. ABS(PV(8)-6.) . LT. 1.E-5) GO TO 4
C
C***********************************************************************
C                                           CHECK IF VERTEX CHAMBER
C                                           TRACKING IS WANTED
      IF( .NOT. LFLAG(5) )  CALL TRCDET(PV,R0,RR,&1004)
      IF(  LFLAG(5) )  CALL TRCDTV(PV,R0,RR,&1004)
C***********************************************************************
C
      IF( PV(6) .LT. .001 ) GO TO 1000
C
      CALL TRCOIL(PV,RR,&992 )
  992 R0(1) = RR(1)
      R0(2) = RR(2)
      R0(3) = RR(3)
      GO TO 996
C
C                                           TRACK PHOTONS
    3 CALL JTRKGM(PV,R0,&1000)
      GO TO 996
C                                           TRACK K0L , N
    4 CALL JTRNTR(PV,R0,&1000)
C                                           SAVE VECTORS
  996 R0SAVE(1) = R0(1)
      R0SAVE(2) = R0(2)
      R0SAVE(3) = R0(3)
      DO 995 ISA = 1,10
  995 PVSAVE(ISA) = PV(ISA)
C                                           LEAD GLASS
      CALL TRLGL(PV,R0,&997)
C
  997 CONTINUE
C
  998 IF( PV(6) .LT. .001 ) GO TO 1000
      CALL MURTNE(PVSAVE,R0SAVE)
      GO TO 1000
C
 1004 IF( IJETCP .GT. 0 ) GO TO 1000
      IJETCP = 1
      WRITE(6,151) IEV, IPART
  151 FORMAT(5X,' TOO MANY JET-CHAMBER HITS AT EVENT',I5,' TRACK',I4)
      GO TO 1000
C
C
 1000 CONTINUE
      GO TO 1002
C
 1003 CONTINUE
C
C***********************************************************************
C                                           SORT VERTEX CHAMBER HITS
      IF( LFLAG(5) ) CALL JSTORE
C***********************************************************************
      CALL JSPOIN
      CALL ORDLG
      CALL MUORDR
      CALL TOFMAK
      CALL WRTMCB( NUNIT )
      IWRT = IWRT + 1
C
 1001 CONTINUE
C                                           NO MORE EVENTS REQUESTED
C
      WRITE(6,9105)
 9105 FORMAT(/' --  END OF REQUESTED DATA  --')
      GO TO 91
C
C
C                                          OPERATOR STOP
C
   92 CONTINUE
      WRITE(6,9102)
 9102 FORMAT(/'======== OPERATOR STOP=========')
      GO TO 91
C
C
C                                           TIME OUT
C
   90 CONTINUE
      WRITE(6,9101)
 9101 FORMAT(/' ========= TIME OUT =========')
C
C                                           END OF DATA
   91 CONTINUE
      CALL BMLT( 0, DUMMY )
      CALL BWRITE( NUNIT )
C
C                                           PRINT INPUT ERROR SUMMARY
C
      CALL MCVSUM
C
      ILAST = IEVMIN + KIEV - 1
      WRITE(6,109) NEVTS, IEVMIN,ILAST,KIEV, IWRT
  109 FORMAT(//1X,I6,' EVENT(S) REQUESTED TO BE TRACKED.'/
     +  1X,I6,' IS RECORD NO. OF FIRST REQUESTED EVT FROM INPUT FILE.'/
     +  1X,I6,' IS RECORD NO. OF LAST EVENT READ FROM INPUT FILE.'/
     +  1X,I6,' EVENT(S) READ FROM THE INPUT FILE.'/
     +  1X,I6,' EVENT(S) WRITTEN OUT.'//)
      RETURN
      END
      SUBROUTINE GUOUT
C=======================================================================
C.
C.    *
C.    *       User routine called at the end of each event
C.    *
C.
      INTEGER*2 HGG

      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(30),NAMEC(30)
     + ,NSTEP ,MAXNST,DESTEP,SAFETY,SLENG ,STEP  ,SNEXT ,SFIELD,SNPHYS
     + ,TOFG  ,GEKRAT,IGNEXT,INWVOL,ISTOP ,IDECAD,IEKBIN
C
      COMMON /GCVOLU/ NLEVEL, NAMES(15), NUMBER(15),
     + LVOLUM(15),LINDEX(15),GTRAN(3,15),GRMAT(10,15),
     + NGPAR(15),GPAR(50,15),GONLY(15),GLX(3),
     + NJNEXT(2),JNEXT(15),INEXT(15),NNEXT(15)
C
      COMMON / GENPAR / WEIT(3),CNORM(3)
      COMMON / CEBLOK / EBLOCK(16,3)
C
#include "cmctag.for"
C
CC    CALL TVNEXT
CC    CALL GDRAWC( 'TAGS', 3,-300., 10., 10., 0.3, 0.3)
CC    CALL GDXYZ(0)
C                      Z-X-VIEW THROUGH WHOLE VOLUME
CC    CALL TVNEXT
CC    CALL GDRAWC ( 'TAGS', 2, 0.0, 10.0, 10.0, 0.025,0.2)
CC    CALL GDXYZ(0)
CC    CALL TVEND
C                      Z-X-VIEW THROUGH WHOLE VOLUME
CC    CALL TVNEXT
CC    CALL GDRVOL (2,NAMES,NUMBER,0,90.0,0.,0.0,10.0,10.0,0.025,0.2)
CC    CALL GDXYZ(0)
CC    CALL TVEND
C
      MARKMC = 3
      WRITE(6,*) '  '
      ETOTAL=0.0
      DO 10 ISEG=1,16
         DO 20 IRING=1,3
C
C---AZIMUTHAL PARAMETRISATION OF ENERGY RESPONSE
C
            CALL AZIRES(ISEG,IRING)
C
C---SMEAR THE ENERGIES
            CALL RANNOR(GRAN1,GRAN2)
            ESMEAR=GRAN1*.024*CNORM(IRING)
            EBLOCK(ISEG,IRING)=EBLOCK(ISEG,IRING)+ESMEAR
            WRITE(6,8001) ESMEAR,EBLOCK(ISEG,IRING)
 8001       FORMAT(1X,'ESMEAR ',F8.4,' EBLOCK ',F8.4)
C
C---NORMALISE AND WEIGHT THE ENERGIES
            EBLOCK(ISEG,IRING) =
     &           WEIT(IRING)*EBLOCK(ISEG,IRING)
            WRITE(6,8002) WEIT(IRING),CNORM(IRING),EBLOCK(ISEG,IRING)
 8002       FORMAT(1X,' WEIT ',F8.4,' CNORM ',F8.4,' EBLOCK ',F8.4)
C
C---CALCULATE TOTAL ENERGY DEPOSITED IN CALORIMETER
            ETOTAL=ETOTAL+EBLOCK(ISEG,IRING)
            WRITE(6,8003) ETOTAL
 8003       FORMAT(1X,' ETOTAL ',F8.4)
C
C---FILL IN HGG ARRAY ACCORDING TO STANDARD MARK III FORM
C   NOTE THE ARRAY CONSISTS OF ENERGIES
C
C--- -Z END
         IF(ISEG.GT.8) THEN
      IF(IRING.EQ.1) HGG(ISEG+3)=1000.*EBLOCK(ISEG,IRING)
      IF(IRING.EQ.2) HGG(ISEG+19)=1000.*EBLOCK(ISEG,IRING)
      IF(IRING.EQ.3) HGG(ISEG+35)=1000.*EBLOCK(ISEG,IRING)
C--- +Z END
         ELSE
            IOFF=+4
            IF(ISEG.GT.4) IOFF=-4
      IF(IRING.EQ.1) HGG(ISEG+IOFF+51)=1000.*EBLOCK(ISEG+IOFF,IRING)
      IF(IRING.EQ.2) HGG(ISEG+IOFF+67)=1000.*EBLOCK(ISEG+IOFF,IRING)
      IF(IRING.EQ.3) HGG(ISEG+IOFF+83)=1000.*EBLOCK(ISEG+IOFF,IRING)
         ENDIF
 20      CONTINUE
 10   CONTINUE
      WRITE(6,8004) (HGG(I),I=1,192)
 8004 FORMAT(18(11(I6,1X)/))
      RETURN
      END
C***********************************************************************
C SUBROUTINE TO MODIFY RECORDED ENERGY ACCORDING TO AN AZIMUTHAL
C PARAMETRISATION
C
      SUBROUTINE AZIRES(ISEG,IRING)
C
      COMMON / CEBLOK / EBLOCK(16,3)
      COMMON / PATDAT / PATVEC (10), PATPOS (3)
      COMMON / AZIPAR / AZIFIT
      PI=3.14159
C
C---CALCULATE INCIDENT PHI ANGLE
C
      PHI=ATAN(ABS(PATVEC(2)/PATVEC(1)))
      IF(PATVEC(1).LT.0.AND.PATVEC(2).GT.0) PHI=PI-PHI
      IF(PATVEC(1).LT.0.AND.PATVEC(2).LT.0) PHI=PI+PHI
      IF(PATVEC(1).GT.0.AND.PATVEC(2).LT.0) PHI=2*PI-PHI
C
      WRITE(6,8001) PATVEC(1),PATVEC(2),PHI
 8001 FORMAT(1X,'PX ',F8.4,' PY ',F8.4,' PHI ',F8.4)
      WRITE(6,8012) ISEG,IRING
 8012 FORMAT(1X,'ISEG ',I2,' IRING ',I2)
C
C---CONVERT TO DEG.
      PHI=360.*PHI/(2*PI)
C
      WRITE(6,8002) PHI
 8002 FORMAT(1X,' PHI (DEG) ',F8.4)
C
C---DETERMINE IN WHICH PHI GAP THE PARTICLE WAS INCIDENT
C
      DO 10 IGAP=1,8
         IF(IGAP.EQ.1) THEN
            PHIMIN=337.5
            PHIMAX=22.5
         ELSE
            PHIMIN=-22.5+(IGAP-1)*45.
            PHIMAX=22.5+(IGAP-1)*45.
         ENDIF
         IF(PHI.GT.PHIMIN.AND.PHI.LT.PHIMAX) THEN
            PHITRN=PHI-(IGAP-1)*45.
            GOTO 20
         ENDIF
 10   CONTINUE
C
C---CALCULATE CORRECTION FACTOR FROM PHI COORDINATE
C
C---CONVERT BACK TO RAD
 20   WRITE(6,8003) IGAP,PHIMIN,PHIMAX,PHITRN
 8003 FORMAT(1X,' IGAP ',I2,' PHIMIN ',F8.4,' PHIMAX ',
     &       F8.4,' PHITRN ',F8.4)
      PHITRN=2*PI*PHITRN/360.
      WRITE(6,8004) PHITRN,EBLOCK(ISEG,IRING)
 8004 FORMAT(1X,' PHITRN (MRAD) ',F8.4,' EBLOCK BEF COR ',F8.4)
C
      AZRES=(PI/8.0-AZIFIT*ABS(PHITRN))*8.0/PI
      EBLOCK(ISEG,IRING)=EBLOCK(ISEG,IRING)*AZRES
      WRITE(6,8005) AZIFIT,AZRES,EBLOCK(ISEG,IRING)
 8005 FORMAT(1X,' AZIFIT ',F8.4,' AZRES ',F8.4,' EBLOCK ',F8.4)
C
      RETURN
      END
//*
//**********************************************************************
//*  INPUT UNIT 3 :  4-VECTOR EVENTS IN THE CPROD-FORMAT
//**********************************************************************
//*
//G.FT03F001 DD DISP=SHR,
//   DSN=F22CPH.MC4V.PHI350A.MGEV17H.T50MRAD
//*
//**********************************************************************
//*  OUTPUT UNIT 2    JADE EVENTS IN BOS FORMAT
//**********************************************************************
//*
//*G.FT02F001 DD DUMMY
//*
//G.FT02F001 DD DSN=F22CPH.TESTGEAN.NR4,
//*      DISP=SHR
//*                SPACE: 4  TRACKS FOR 30  BHABHA-EVENTS
//    UNIT=FAST,SPACE=(TRK,(10,5),RLSE),
//    DISP=(NEW,CATLG,CATLG),
//    DCB=R01DCB.VBS
//*     MSVGP=VJAD,UNIT=3330V,
//*     MSVGP=VTMP,UNIT=3330V,
//*     UNIT=TAPE
//*
//*    OUTPUT PICTURES
//*
//* PICTURES ON UNIT 4
//*   ALLOCATE DATASET WITH
//*   DCB=R01DCB.VBS ;DSORG: PS ;  SPACE: 1 OR 2 TRACKS IS ENOUGH
//*   LOGON GRAPHIC TERMINAL:  IPS (TXPLOT) GA(---)
//*
//G.FT11F001 DD DUMMY
//*
//*G.FT11F001 DD DSN=F22CPH.TXPLOT.JADE,DISP=SHR
C   27/03/97 703271158  MEMBER NAME  #MCMUMU  (JMC.S)       FVS
//         JOB 10622622,MSGLEVEL=(2,0),CLASS=E,TIME=(,01)
//*MAIN ORG=EXT,RELPRI=MED
//*
//*
//*                    THIS USES THE CERN STYLE JCL PROCEDURE
//*
//*                          F O R T C G
//*
//TRACK EXEC FORTCG,CPRM=XL,LPRM='NOMAP,LIST',GRGN=800K
//*
//C.SYSIN DD *
C-----------------------------------------------------------------------
      LOGICAL*1  LFLAG
C
      COMMON / BCS / IW(30000)
      COMMON / TODAY / HDATE(6)
      COMMON / CFLAG / LFLAG(10)
C
C          LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C          LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C          LFLAG(3) = ABSORPTION LOSSES
C          LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE (SLOW !!!!)
C
C                   ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C          IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C          IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C                   ==== > DEFAULF IEVMIN = 1
C                          IEVMAX = 9999999
C
C
C                  SET DATE AND TIME OF RUN  - 12 NOON ON 1ST MAY 1981
C                  ALSO SET MUON RANDOM NUMBER GENERATOR USING MUSEED
C                  WITH ANY INTEGER (DIFFERENT FOR EACH JOB).
C
      HDATE(1)=0
      HDATE(2)=0
      HDATE(3)=12
      HDATE(4)=1
      HDATE(5)=5
      HDATE(6)=1981
C
      CALL MUSEED(301)
      CALL BINT( 30000, 5000, 500, 0 )
      CALL MCJADE(  30, 50 )
      CALL BSTA
      CALL PALL
      STOP
      END
C
C----------------------------------------------------------------------
      SUBROUTINE JGETEV( * )
C----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    02/11/81 :  PRODUCE NEXT EVENT
C
C   LAST MOD  J. HAGEMANN 20/12/83 :  SHORT VERSION OF SUBROUTINE
C                                     JGETEV TO BE USED IN MEMBER
C                                     #MCMUMU
C
C   PRODUCE NEXT EVENT BY CALLING GENMU OR GENEE.
C
C   RETURN 1 IF MAXIMUM NUMBER OF EVENTS TO BE PRODUCED IS REACHED
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
      DATA ICALL / 0 /
C
      LOGICAL VALID
C
C------------------  C O D E  -----------------------------------------
C
      ICALL = ICALL + 1
      IF(ICALL.NE.1) GO TO 10
      IEV = 0
      KIEV = 0
10    IEV = IEV + 1
C
      CALL GENMU( &1000 )
C
C                                           CHECK INPUT
C
      CALL MCVALI( VALID )
      IF( .NOT. VALID ) GO TO 10
C                                           CONTINUE HERE FOR VALID DATA
      KIEV = KIEV + 1
C
C                                           CREATE VECT BANK
C
      CALL LHVECT( LENGTH )
      CALL BCRE( IND, 'VECT', 0, LENGTH, &1000, IER )
      CALL STVECT( LENGTH, IW(IND+1) )
C
C                                           CREATE PALL BANK
C
      CALL LHPALL( LENGTH)
      CALL BCRE( NPALL, 'PALL', 0, LENGTH, &1000, IER )
      CALL STPALL( LENGTH, IW(NPALL + 1) )
      CALL BSAW( 1, 'PALL' )
      RETURN
 1000 IEV = IEV - 1
      RETURN 1
      END
#include "genee.for"
//G.SYSLIB DD DSN=SYS1.FORTLIB,DISP=SHR
//         DD DSN=DESYLIB,DISP=SHR
//         DD DSN=F22RJB.RLMC.L,DISP=SHR
//         DD DSN=F22ELS.JMC.L,DISP=SHR
//         DD DSN=F11LHO.JADEGL,DISP=SHR
//         DD DSN=JADELG.LOAD,DISP=SHR
//         DD DSN=F22ALL.JADEMUL,DISP=SHR
//         DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//         DD DSN=SYS1.NAGLIB,DISP=SHR
//         DD DSN=SYS1.DNAGLIB,DISP=SHR
//         DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//*
//*                 OUTPUT
//*
//*.FT02F001 DD UNIT=FAST,DISP=(,CATLG,DELETE),
//*       DCB=R01DCB.VBS,SPACE=(TRK,(20,2),RLSE),
//*       DSN=F22ELS.MCTEST3
//G.FT02F001 DD DUMMY
//*.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F22ELS.MCTEST3
//*
//*                 CONSTANTS
//*
//G.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
C   27/03/97 703271158  MEMBER NAME  #MCPAIR  (JMC.S)       FVS
//         JOB                MSGLEVEL=(0,0),CLASS=E,TIME=(,10)
//*MAIN ORG=EXT,RELPRI=MED
//*
//**********************************************************************
//*                                                                    *
//*         M C P A I R   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                       GENERATES 4-VECTORS OF PARTICLE PAIRS        *
//*                       (E+E-, MU+MU-, PI+PI- ETC.) AND TRACKS       *
//*                       THEM THROUGH DETECTOR                        *
//*                                                                    *
//*                    THIS USES THE CERN STYLE JCL PROCEDURE          *
//*                                                                    *
//*                          F O R T C G                               *
//*                                                                    *
//**********************************************************************
//TRACK EXEC FORTCG,CPRM=XL,LPRM='NOMAP,LIST',GRGN=912K
//*
//C.SYSIN DD *
C-----------------------------------------------------------------------
      LOGICAL*1  LFLAG
      COMMON / CFLAG / LFLAG(10)
      COMMON / TODAY / HDATE(6)
C
      COMMON / BCS / IW(33000)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE SLOW!!!!!
C        LFLAG(5) = .TRUE.   -->  WITH VERTEX CHAMBER TRACKING
C                 = .FALSE.  -->  WITHOUT VERTEX CHAMBER TRACKING
C                                 BUT OLD BEAM PIPE GEOMETRY AND
C                                 BEAM PIPE COUNTERS (BEFORE MAI 84)
C
C                     ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C          IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C          IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C
C                   ==== > DEFAULF IEVMIN = 1
C                                  IEVMAX = 9999999
C
      CALL BINT( 33000, 10000, 500, 0 )
C
      HDATE(1)=1
      HDATE(2)=1
      HDATE(3)=1
      HDATE(4)=1
      HDATE(5)=5
      HDATE(6)=1984
C                            COMMENTED TO USE OLD HARDWARE
CCC   LFLAG(5) = .TRUE.
C
      CALL MCJADE(   0, 50 )
      CALL BSTA
      CALL PALL
      STOP
      END
C
C----------------------------------------------------------------------
      SUBROUTINE JGETEV( * )
C----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    02/11/81 :  PRODUCE NEXT EVENT
C
C   LAST MOD  J. HAGEMANN 20/12/83 :  SHORT VERSION OF SUBROUTINE
C                                     JGETEV TO BE USED IN MEMBER
C                                     #MCMUMU
C
C   PRODUCE NEXT EVENT BY CALLING GENMU OR GENEE.
C
C   RETURN 1 IF MAXIMUM NUMBER OF EVENTS TO BE PRODUCED IS REACHED
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
      DATA ICALL / 0 /
C
      LOGICAL VALID
C
C------------------  C O D E  -----------------------------------------
C
      ICALL = ICALL + 1
      IF(ICALL.NE.1) GO TO 10
      IEV = 0
      KIEV = 0
10    IEV = IEV + 1
C
      CALL GENMU( &1000 )
C
C                                           CHECK INPUT
C
      CALL MCVALI( VALID )
      IF( .NOT. VALID ) GO TO 10
C                                           CONTINUE HERE FOR VALID DATA
      KIEV = KIEV + 1
C
C                                           CREATE VECT BANK
C
      CALL LHVECT( LENGTH )
      CALL BCRE( IND, 'VECT', 0, LENGTH, &1000, IER )
      CALL STVECT( LENGTH, IW(IND+1) )
C
C                                           CREATE PALL BANK
C
      CALL LHPALL( LENGTH)
      CALL BCRE( NPALL, 'PALL', 0, LENGTH, &1000, IER )
      CALL STPALL( LENGTH, IW(NPALL + 1) )
      CALL BSAW( 1, 'PALL' )
      RETURN
 1000 IEV = IEV - 1
      RETURN 1
      END
#include "genee.for"
//G.SYSLIB DD DSN=SYS1.FORTLIB,DISP=SHR
//         DD DSN=DESYLIB,DISP=SHR
//         DD DSN=F22ELS.JMC.L,DISP=SHR
//         DD DSN=F11LHO.JADEGL,DISP=SHR
//         DD DSN=JADELG.LOAD,DISP=SHR
//         DD DSN=F22ALL.JADEMUL,DISP=SHR
//         DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//         DD DSN=SYS1.NAGLIB,DISP=SHR
//         DD DSN=SYS1.DNAGLIB,DISP=SHR
//         DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//         DD DSN=F11LHO.TAGG.L,DISP=SHR
//*                 OUTPUT
//*G.FT02F001 DD UNIT=FAST,DISP=(,CATLG,DELETE),
//*       DCB=R01DCB.VBS,SPACE=(TRK,(20,2),RLSE),
//*       DSN=F22ELS.MCTEST3
//*G.FT02F001 DD DUMMY
//*G.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F22ELS.MCTEST3
//*                 CONSTANTS
//G.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
C   27/03/97 703271158  MEMBER NAME  #PRODMU  (JMC.S)       FVS
//         JOB 10622622,MSGLEVEL=(2,0),CLASS=E,TIME=(0,01)
//*MAIN RELPRI=MED
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (INCLUDING MUON TRACKING)      *
//*                                                                    *
//**********************************************************************
//*                                                                    *
//*         THIS VERSION IS SLOW AND SHOULD BE USED ONLY               *
//*         WHERE MUON RESULTS ARE REALLY NEEDED.                      *
//*         IF NOT USE MEMBER #PRODUCT.                                *
//*                                                                    *
//**********************************************************************
//*                                                                    *
//*  FIRST STEP      COPY INPUT 4 VECTORS TO DISK                      *
//*                                                                    *
//**********************************************************************
//*
//COPY EXEC PGM=IEBGENER
//*
//*        INPUT DATASET
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//        DSN=F22PET.ALIJET.C30
//*
//SYSUT2 DD UNIT=DISK,DISP=(,PASS),
//       DCB=R01DCB.VBS,
//       SPACE=(CYL,(50,0)),DSN=&&SCRTCH1
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//**********************************************************************
//*                                                                    *
//*  SECOND STEP     TRACKING             CERN STYLE JCL               *
//*                                                                    *
//**********************************************************************
//*
//MUTRACK EXEC FORTCG,CPRM='XL,NOSOURCE',LPRM='LIST,NOMAP',GRGN=912K
//*
//C.SYSIN DD *
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
      COMMON / TODAY / HDATE(6)
      COMMON / BCS / IW(30000)
C
      LOGICAL*1  LFLAG
      COMMON / CFLAG / LFLAG(10)
C
C          LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C          LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C          LFLAG(3) = ABSORPTION LOSSES
C          LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE (SLOW !!!!)
C
C                   ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C          IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C          IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C                   ==== > DEFAULF IEVMIN = 1
C                          IEVMAX = 9999999
C
C
C                  SET DATE AND TIME OF RUN  - 12 NOON ON 1ST MAY 1981
C                  ALSO SET MUON RANDOM NUMBER GENERATOR USING MUSEED
C                  WITH ANY INTEGER (DIFFERENT FOR EACH JOB).
C
      HDATE(1)=0
      HDATE(2)=0
      HDATE(3)=12
      HDATE(4)=1
      HDATE(5)=5
      HDATE(6)=1981
C
      CALL BINT( 30000,5000,100,100)
      N = JUHR(2)
C                                               SEED GENERATOR
      CALL MUSEED(301)
      CALL MCJADE(0,5)
      CALL BSTA
      CALL PALL
      STOP
      END
//G.SYSLIB DD DSN=SYS1.FORTLIB,DISP=SHR
//         DD DSN=DESYLIB,DISP=SHR
//         DD DSN=F22RJB.RLMC.L,DISP=SHR,UNIT=FAST
//         DD DSN=F22ELS.JMC.L,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=JADELG.LOAD,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=F22ALL.JADEMUL,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=F11LHO.JADEGL,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//         DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//         DD DSN=SYS1.NAGLIB,DISP=SHR
//         DD DSN=SYS1.DNAGLIB,DISP=SHR
//*
//*                 INPUT
//*
//G.FT03F001 DD UNIT=DISK,DISP=(OLD,PASS),DSN=&&SCRTCH1
//*
//*                 OUTPUT
//*
//G.FT02F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//        DCB=R01DCB.VBS,
//        DSN=F22ELS.T1ALIJET.C30
//*
//*                 CALIBRATION FOR THE MUON SYSTEM
//*
//G.FT22F001 DD UNIT=FAST,VOL=SER=STOR05,DISP=SHR,DSN=F11LHO.AUPDAT1
C   27/03/97 703271158  MEMBER NAME  #PRODUCT (JMC.S)       FVS
//         JOB 10622622,MSGLEVEL=(2,0),CLASS=E,TIME=(0,01)
//*MAIN RELPRI=MED
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*                                                                    *
//*  FIRST STEP      COPY INPUT 4 VECTORS TO DISK                      *
//*                                                                    *
//**********************************************************************
//*
//COPY EXEC PGM=IEBGENER
//*
//*        INPUT DATASET
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//        DSN=F22PET.ALIJET.C30
//*
//SYSUT2 DD UNIT=DISK,DISP=(,PASS),
//       DCB=R01DCB.VBS,
//       SPACE=(CYL,(50,0)),DSN=&&SCRTCH1
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//**********************************************************************
//*                                                                    *
//*  SECOND STEP     TRACKING           CERN STYLE JCL                 *
//*                                                                    *
//**********************************************************************
//*
//TRACK EXEC FORTCG,CPRM=XL,LPRM='LIST,NOMAP',GRGN=550K
//*
//C.SYSIN DD *
C-----------------------------------------------------------------------
      COMMON / BCS / IW(30000)
C
      LOGICAL*1  LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE SLOW!!!!!
C ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C     IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C     IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C ==== > DEFAULF IEVMIN = 1
C                IEVMAX = 9999999
C
      CALL BINT( 30000, 5000, 500, 0 )
      CALL MCJADE( 0, 5 )
      CALL BSTA
      CALL PALL
      STOP
      END
//G.SYSLIB DD DSN=SYS1.FORTLIB,DISP=SHR
//         DD DSN=DESYLIB,DISP=SHR
//         DD DSN=F22ELS.JMC.L,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=JADELG.LOAD,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=F11LHO.JADEGL,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=F22ALL.JADEMUL,DISP=SHR,UNIT=FAST,VOL=SER=STOR05
//         DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//         DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//         DD DSN=SYS1.NAGLIB,DISP=SHR
//*
//*                 INPUT
//*
//G.FT03F001 DD UNIT=DISK,DISP=(OLD,PASS),DSN=&&SCRTCH1
//*
//*                 OUTPUT
//*
//G.FT02F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//        DCB=R01DCB.VBS,
//        DSN=F22ELS.T1ALIJET.C30
C   27/03/97 703271158  MEMBER NAME  #RCPROD  (JMC.S)       FVS
//F22ELS   JOB 10622622,F22ELS,CLASS=A,MSGLEVEL=(0,0),TIME=(2,0)
//*MAIN ORG=EXT,RELPRI=MED
// EXEC FCLG
      COMMON/CPROD/ NR,BEAM,PT,XNC,XNN,ECM,
     *        NP,NC,NN,PP(4,500),XM(500),ICH(500),ITP(500),IP(500,2),
     *        NF,NCF,NNF,PF(4,300),XMF(300),ICF(300),ITF(300),
     *        PSTRT(3,300)
C
CCC  INITIALISE PROGRAM
      NEVTS = 100000
      DO 1001 IEV=1,NEVTS
      IF( JUHR(NSEC) .EQ. 2 ) GO TO 90
C
CCC  READ EVENTS FROM TAPE
      READ(3,ERR=1005,END=90) NR,BEAM,PT,XNC,XNN,ECM,
     *     NP,NC,NN,((PP(I4,N),I4=1,4),XM(N),ICH(N),ITP(N),
     *     (IP(N,I2),I2=1,2),N=1,NP),
     *     NF,NCF,NNF,((PF(I4,N2),I4=1,4),XMF(N2),ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
C
CCC  WRITE EVENTS TO DISC
      WRITE(2) NR,BEAM,PT,XNC,XNN,ECM,
     *     NP,NC,NN,((PP(I4,N),I4=1,4),XM(N),ICH(N),ITP(N),
     *     (IP(N,I2),I2=1,2),N=1,NP),
     *     NF,NCF,NNF,((PF(I4,N2),I4=1,4),XMF(N2),ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
C
      IF( IEV .GT. 20 ) GO TO 1001
      WRITE(6,9101) NR,BEAM,PT,XNC,XNN,ECM,
     *     NP,NC,NN,((PP(I4,N),I4=1,4),XM(N),ICH(N),ITP(N),
     *     (IP(N,I2),I2=1,2),N=1,NP)
 9101 FORMAT(1X,I10,5F10.3/1X,3I10/(1X,5F10.3,2I10,3F10.3,2I10))
      WRITE(6,9102)
     *     NF,NCF,NNF,((PF(I4,N2),I4=1,4),XMF(N2),ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
 9102 FORMAT(1X,3I10/(1X,5F10.3,2I10,3F10.3))
      GO TO 1001
C
 1005 WRITE(6,9107)
 9107 FORMAT(' **** READ ERROR *** IEV=',I8)
C
 1001 CONTINUE
C
   90 STOP
      END
//*                        INPUT:
//GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F22PET.QQGBOD.A34
//*                        OUTPUT:
//GO.FT02F001 DD UNIT=TAPE,DCB=R01DCB.VBS,DISP=(,CATLG,),
//    DSN=F22ELS.QQGBOD.A34
C   27/03/97 703271158  MEMBER NAME  #TESTLGL (JMC.S)       FVS
//    JOB         CLASS=E,MSGLEVEL=(1,0),TIME=(0,30)
//*MAIN ORG=EXT,LINES=(2),RELPRI=MED
//*
//* GENERAL TRACKING JOB
//*
// EXEC GEP,REGION=800K,
//  DN=DUMMY
      COMMON / BCS / IW(33000)
C
      LOGICAL*1  LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE SLOW!!!!!
C ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C     IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C     IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C ==== > DEFAULF IEVMIN = 1
C                IEVMAX = 9999999
C
      LFLAG(4) = .FALSE.
      CALL BINT( 33000,10000, 500, 0 )
      CALL MCJADE( 0, 10 )
      CALL GEPW
      CALL BSTA
      CALL PALL
      STOP
       END
#include "mist.for"
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DSN=F11BAR.JMC.L,DISP=SHR
//            DD DSN=JADELG.LOAD,DISP=SHR
//            DD DSN=F22ALL.JADEMUL,DISP=SHR
//            DD DSN=R02BUT.CERNLIB,DISP=SHR
//            DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//*
//* UNIT3  INPUT:    4-VECTOR EVENTS IN THE CPROD-FORMAT
//*
//GO.FT03F001 DD DISP=SHR,
//*       DSN=F22PET.LND51.TEST100
//        DSN=F11MEI.PIC500
//*
//* UNIT2  OUTPUT:    JADE EVENTS IN BOS FORMAT
//*
//GO.FT02F001 DD DUMMY
//*GO.FT02F001 DD DISP=(,CATLG,DELETE),UNIT=FAST,DCB=R01DCB.VBS,
//*       DSN=F11BAR.TEST.TRCK04,SPACE=(TRK,(10,10),RLSE)
C   27/03/97 703271158  MEMBER NAME  #TESTMC  (JMC.S)       FVS
//    JOB         CLASS=E,MSGLEVEL=(1,0),TIME=(0,30)
//*MAIN ORG=EXT,LINES=(2),RELPRI=MED
//*
//* GENERAL TRACKING JOB
//*
// EXEC FCLG,PARM.FORT=XL,PARM.LKED='LIST,MAP',
//  REGION.GO=512K
      COMMON / BCS / IW(33000)
C
      LOGICAL*1  LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE SLOW!!!!!
C ===> DEFAULT .TRUE.,.FALSE.,.TRUE.,.FALSE.
C
      COMMON / CIEVS  / KIEV,IEVMIN,IEVMAX
C
C     IEVMIN = FIRST EVENT TO BE READ FROM INPUT FILE
C     IEVMAX = LAST  EVENT TO BE READ FROM INPUT FILE
C ==== > DEFAULF IEVMIN = 1
C                IEVMAX = 9999999
C
      LFLAG(4) = .TRUE.
      CALL BINT( 33000,10000, 500, 0 )
      CALL MCJADE( 0, 10 )
      CALL BSTA
      CALL PALL
      STOP
       END
//LKED.SYSLIB DD
//            DD
//            DD DSN=F11BAR.JMC.L,DISP=SHR
//            DD DSN=JADELG.LOAD,DISP=SHR
//            DD DSN=F22ALL.JADEMUL,DISP=SHR
//            DD DSN=R02BUT.CERNLIB,DISP=SHR
//            DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//*
//* UNIT3  INPUT:    4-VECTOR EVENTS IN THE CPROD-FORMAT
//*
//GO.FT03F001 DD DISP=SHR,
//        DSN=F22PET.LND51.TEST100
//*
//* UNIT2  OUTPUT:    JADE EVENTS IN BOS FORMAT
//*
//*GO.FT02F001 DD DUMMY
//GO.FT02F001 DD DISP=(,CATLG,DELETE),UNIT=FAST,DCB=R01DCB.VBS,
//       DSN=F11BAR.TEST.TRCK04,SPACE=(TRK,(10,10),RLSE)

C   11/03/87 705211105  MEMBER NAME  KOMAKS   (JADEGS)      FORTRAN
C-----------------------------------------------------------------------
      SUBROUTINE KOMAKS(IPRINT,IKOMA,ITRYK,IERRK,IEERJ)
C-----------------------------------------------------------------------
C
C     THIS SUBROUTINE IS BASED ON THE PROGRAM KST1.. BY S.KOMAMIYA
C     IT CALLS ALL THE RELEVANT SUBROUTINES FOR K0S SEARCH AND VERTEX
C     OPTIMIZATION.
C
C     THE FLAG IKOMA = 0 FOR NORMAL RETURN
C                      1 FOR NO PATR BANK
C                      2 FOR <3 PATR TRACKS
C
C     THE WORD ITRYK GIVES THE NUMBER OF COMBINATIONS TRIED, IN LOOP 10
C
C    THE ARRAY IERRK CONTAINS A CODE FOR EACH OF THE 1ST 50 COMBS TRIED:
C     1: ARRAY IEEFG IS NONZERO:
C         VALUE 1: TRACK IS PART OF E+E- CONVERSION  (GIVEN BY VTXEE)
C         VALUE 2: NOT USED
C         VALUE 3: SIGSCT=R1I*R2I < 0   (GIVEN BY XYSCAT)
C                  TRACK FROM MAIN VERTEX, WITHIN SCATTERING ERRORS
C         VALUE 4: RMIN > ARLIM
C         VALUE 5: ZMIN > 350.
C         VALUE 6: TRACK IS JUDGED BAD BY VTXPRE
C     2: LESS THAN MNHIT HITS
C     3: RI*RJ PRODUCT, KTRCK(20,...
C     4: IFLAG,JFLAG SET FROM XYVRTX
C     5: KFLAG SET FROM XYVOPT
C     6: LFLAG SET FROM ZRVOPT
C     7: MOMENTA LESS THAN PCUTT
C     8: ERROR CODE FROM ELOSS
C     9: CANDIDATE FOR E+E- CONVERSION
C    10: DVL < DVLMIN
C    11: D > DK0MAX
C    12: SAME CHARGE   (DETERMINED FROM SIGNED CURVATURE IN XYVRTX)
C
C
C
C
C    IMPLEMENTATION BY J. OLSSON
C                 28.04.1986  VALUE OF CHI**2 (MAX) IN ZRVOPT CHANGED
C                             FROM 3600 TO 2500
C                 29.04.1986  ADD ARRAY IEERJ(50,2) TO PASS IEEFG
C                             CODES FOR EACH TRACK IN A COMB TO O/P
C
C--------------------------------------------------------------------
C    THE PROGRAM CAN BE STEERED BY THE FOLLOWING VARIABLES
C    STDEV: NR OF SIGMAS EXCLUDED IN THE SCATTERING ERROR OF TRACKORIGIN
C    ARLIM: MAXIMUM RMIN DISTANCE OF TRACK
C    IZRFIT: 0 NO OPTIMIZATION IN ZR
C            1    OPTIMIZATION IN ZR
C    MNHIT:  MINIMUM NR OF HITS ON A TRACK
C    PCUTT:  MINIMUM MOMENTUM OF A TRACK
C    DVLMIN:  MINIMUM DVL, RFI DECAY LENGTH OF V0 CANDIDATE
C    DK0MAX:  MAXIMUM OF MIN.DISTANCE MAIN VERTEX - V0 FLIGHT PATH
C    IEE3FL  0 NO REJECTION ON IEEFG(..)=3
C            1 REJECTION ON IEEFG(..)=3
C--------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
      COMMON /CKOMAK/NMAS,PCOMB1(4,50),PCOMB2(4,50),HTR1(50),HTR2(50),
     +            VMAS(50),DMAS(50),DVLK0(50),DK0(50),XYZK0(3,50),
     +            STDEV,ARLIM,IZRFIT,MNHIT,PCUTT,DVLMIN,DK0MAX,IEE3FL
C
#include "cgeo1.for"
#include "cgeov.for"
C
      COMMON/MAG/ BC
C
C                    DITTMANN'S VERTEX ROUTINE WORK AREA
C
      COMMON /CWORK1/NTDITT,TDITT(2000),NVDITT,VDITT(200)
      DIMENSION ITDITT(2000),IVDITT(200)
      DIMENSION IERRK(50)
      EQUIVALENCE (TDITT(1),ITDITT(1)),(VDITT(1),IVDITT(1))
C
      COMMON /VTR/ VTRK(20,100)
      DIMENSION KTRK(20,100)
      EQUIVALENCE (KTRK(1,1),VTRK(1,1))
C
      DIMENSION IEEFG(100),V(6),RMIN0(100),IEERJ(50,2)
C
C                            ORIGINAL VALUES, KEEP FOR POSTERITY.
C
C     DATA STDEV /3./
C     DATA ARLIM /4./
C     DATA IZRFIT /1/
C     DATA MNHIT /24/
C     DATA PCUTT /0.100/
C     DATA DVLMIN /10./
C     DATA DK0MAX /10./
C
C
      DATA PIM /0.13957/
      DATA VMKS /0.4977/
      DATA ICALLS /0/
C
C -------------------------- INITIALISATION
C
      IPRO = IPRINT
      ICALLS = ICALLS + 1
 1    IF(ICALLS.NE.1)                   GOTO 100
         WRITE(6,1000)
         WRITE(6,1010) STDEV,ARLIM,MNHIT,PCUTT,DVLMIN,DK0MAX,IZRFIT
         WRITE(6,1020) IEE3FL
 1000    FORMAT(' KOMAKS CALLED, VERSION FROM 10.03.1987   ')
 1010    FORMAT(' STDEV,ARLIM,MNHIT,PCUTT,DVLMIN,DK0MAX,IZRFIT',/,
     +          2F5.2,I5,3X,3(1XF5.2),I5)
 1020    FORMAT(' FLAG FOR IEEFG=3 REJECTION                 :',I5)
C
 100  CONTINUE
      NMAS  = 0
      IKOMA = 0
      ITRYK = 0
      CALL VZERO(IERRK,50)
      ZPOS  = 10000.
      BC    = ABS(BKGAUS*0.3E-4)
      RMAT  = RBPIPE(X0BTWN)
      DO 101 I=1,50
         DO 102 J=1,2
            IEERJ(I,J) = 0
102      CONTINUE
101   CONTINUE
C ------------------------------------- FILL WORK ARRAY VTRK,KTRK
      INHD  = IDATA(IBLN('HEAD'))
      NRUN  = HDATA( INHD   +  INHD  + 10)
      NEVT  = HDATA( INHD   +  INHD  + 11)
      INPA  = IDATA(IBLN('PATR'))
      IF(INPA.LE.0)                     GOTO 990
      NTR   = IDATA(INPA+2)
C
      CALL PATTRK(INPA,&980,&980)
C ------------------------------------- DITTMANN'S VERTEX ROUTINE
      CALL VTXPRE(INHD,INPA)
C ------------------------------------- IEEFG ARRAY MARKS BAD TRACKS
      CALL VZERO(IEEFG,100)
      DO 200 ITR=1,NTR
         I40 = (ITR-1)*40+1
         IF(ITDITT(I40).NE.0)           GOTO 210
C --------- TRACK IS JUDGED BAD BY THE VERTEX PROGRAM
            IEEFG(ITR) = 6
            GOTO 200
  210    CONTINUE
         CALL XYSCAT(NRUN,ITR,STDEV,R1I,R2I,RMINTR,MFLAG)
C ----------------------------------------------------------------------
C        R1I AND R2I ARE MEASURES OF DISTANCE FROM MAIN (RUN) VERTEX
C        IF PRODUCT < 0, RUN VERTEX IN POSSIBLE ORIGIN
C        KTRK(20,..) TELLS IF TRACK ORIGINATES BEFORE OR AFTER VERTEX
C ----------------------------------------------------------------------
         SIGSCT = R1I*R2I
         IF(IEE3FL.NE.0 .AND. SIGSCT.LE.0.)  IEEFG(ITR)   = 3
         IF(R1I.GT.0.   .AND. R2I.GT.0.)     KTRK(20,ITR) = 1
         IF(R1I.LT.0.   .AND. R2I.LT.0.)     KTRK(20,ITR) =-1
         IF(RMINTR.LT.ARLIM)                 IEEFG(ITR)   = 4
C
         ZMIN = ABS(VTRK(19,ITR))
         IF(ZMIN.GT.350.)                    IEEFG(ITR)   = 5
C
         RMIN0(ITR) = RMINTR
 200  CONTINUE
C ------------------------------------- E+E- VERTEX REJECTION
      NVDITT = 0
      CALL VTXEE
      IF(NVDITT.EQ.0)                   GOTO 300
C
      DO 310 ID=1,NVDITT
         JD  = 0
         K1D = 0
         DO 320 KD=1,NTDITT
            IF(ITDITT(JD+14).EQ.ID.AND.K1D.NE.0)  K2D = KD
            IF(ITDITT(JD+14).EQ.ID.AND.K1D.EQ.0)  K1D = KD
            JD = JD+40
 320     CONTINUE
         IEEFG(K1D) = 1
         IEEFG(K2D) = 1
 310  CONTINUE
C
 300  CONTINUE
      IF(IPRO.GT.1)                WRITE(6,1300) NVDITT
      IF(IPRO.GT.0)                WRITE(6,1310) NTR,(IEEFG(I),I=1,NTR)
1300  FORMAT(' KOMAKS,  NVDITT = ',I3)
1310  FORMAT(' KOMAKS,  NTR,IEEFG = ',I3,2X,20I3)
C
C ------------------------------------- TRACK LOOP
C
      DO 400 I=2,NTR
         II=I-1
         DO 500 J=1,II
            ITRYK = ITRYK + 1
C
C           REJECT TRACKS WHICH HAVE BEEN MARKED BAD IN IEEFG
C
            IF(IEEFG(I).NE.0 .OR. IEEFG(J).NE.0)  GOTO 900
            IF(IPRO.GT.1)
     *         WRITE(6,1500) I,J,KTRK(17,I),KTRK(17,J),
     *                           KTRK(20,I),KTRK(20,J)
 1500          FORMAT(' KOMAKS,  I J KTRK17 ',4I5,' KTRK20 ',2I4)
 901        IF( KTRK(17,I).LT.MNHIT)    GOTO 905
            IF( KTRK(17,J).LT.MNHIT)    GOTO 905
            RI = VTRK(10,I)
            RJ = VTRK(10,J)
            IF(IPRO.GT.1)               WRITE(6,1510) I,J,RI,RJ
 1510       FORMAT(' KOMAKS,  I J ',2I3,'  RI RJ ',2E14.6)
C
C                            CANDIDATES SHOULD HAVE THE SAME SIDE ORIGIN
C
            IF(IEE3FL.NE.0 .AND. IER3FL.EQ.0 .AND. RI*RJ.LT.0. .AND.
     +         KTRK(20,I)*KTRK(20,J).LE.0.)      GOTO 910
C
            CALL XYVRTX(I,J,V,DVL,D,JFLAG,IFLAG)
            D0 = D
            IF(IPRO.GT.1)               WRITE(6,1520) I,J,IFLAG,JFLAG
 1520       FORMAT(' KOMAKS,  I J ',2I3,'  I-JFLAG ',2I7)
C --------- JFLAG=100 FLAGS SAME CHARGE
            IF(JFLAG.EQ.100)            GOTO 955
            IF(JFLAG.NE.0)              GOTO 915
            IF(IFLAG.NE.0)              GOTO 915
C
C                            THIS ROUTINE SHOULD PERFORM THE VERTEX
C                            OPTIMISATION HOWEVER THE RESULTS ARE
C                            BY PASSED WITHIN THE ROUTINE SO IT ONLY
C                            SELECTS ON KFLAG VALUE.
C
C
            CALL XYVOPT(I,J,V,DVL,D,CHI1,ALPH12,PHUV,KFLAG)
C
            IF(IPRO.GT.1)               WRITE(6,1530) I,J,KFLAG
 1530       FORMAT(' KOMAKS,  I J ',2I3,'  KFLAG ',I4)
C
            IF(KFLAG.NE.0 .AND. KFLAG.NE.1)     GOTO 920
C --------- KFLAG=1 MEANS V0-VERTEX > 600MM FROM ORIGIN
C
C --------- EXCLUDE BEAMPIPE
CC          IF(DVL.GT.RMAT-30.AND.DVL.LT.RMAT+50.)     GOTO 500
C --------- MAKE CUT ON DECAY LENGTH DVL
            IF(DVL.LT.DVLMIN)                          GOTO 945
C --------- MAKE CUT ON DISTANCE D BETWEEN V0 FLIGHT PATH AND MAIN VX
            IF(D.GT.DK0MAX)                            GOTO 950
C
            ALPH12 = ALPH12 * 180./3.14159265
            VO     = SQRT(V(1)**2 + V(2)**2)
            R1I    = SQRT(VTRK(1,I)**2 + VTRK(2,I)**2)
            R1J    = SQRT(VTRK(1,J)**2 + VTRK(2,J)**2)
            ZVI    = VTRK(3,I) +
     *               (V0-R1I) * VTRK(6,I)/SQRT(1.-VTRK(6,I)**2)
            ZVJ    = VTRK(3,J) +
     *               (V0-R1J) * VTRK(6,J)/SQRT(1.-VTRK(6,J)**2)
            ZIJ    = ABS(ZVI-ZVJ)
            NRPATR = IDATA(INPA-2)
            DZI0   = VTRK(6,I)
            DZJ0   = VTRK(6,J)
C ------------------------------------- R-Z FIT
            IF(IZRFIT.EQ.0)             GOTO 510
               CALL ZRVOPT(NRPATR,I,J,V,DZI,DZJ,CHI21,CHI22,LFLAG,ZPOS)
               IF(IPRO.GT.1)            WRITE(6,1540) I,J,LFLAG
 1540          FORMAT(' KOMAKS,  I J ',2I3,'  LFLAG ',I4)
               IF(LFLAG.NE.0)           GOTO 925
               GOTO 520
 510        CONTINUE
C --------- NO R-Z FIT, TAKE COS THETA FROM PATR DIR.COS.
               DZI = VTRK(6,I)
               DZJ = VTRK(6,J)
 520        CONTINUE
            IF(DZI.GT. 0.99999)         DZI = 0.99999
            IF(DZI.LT.-0.99999)         DZI =-0.99999
            IF(DZJ.GT. 0.99999)         DZJ = 0.99999
            IF(DZJ.LT.-0.99999)         DZJ =-0.99999
C ---------------------------------------------------------------------
C --------- V(3-6) CONTAIN X,Y COMPONENTS OF RADII OF CURVATURE
            PXI = V(3)*BC
            PYI = V(4)*BC
            PXJ = V(5)*BC
            PYJ = V(6)*BC
            PX  = PXI+PXJ
            PY  = PYI+PYJ
            PTI = SQRT(V(3)**2 + V(4)**2) * BC
            PTJ = SQRT(V(5)**2 + V(6)**2) * BC
            PZI = PTI * DZI/SQRT(1.-DZI**2)
            PZJ = PTJ * DZJ/SQRT(1.-DZJ**2)
            PZ  = PZI+PZJ
C
            SPI = PTI**2+PZI**2
            SPJ = PTJ**2+PZJ**2
            PI  = SQRT(SPI)
            PJ  = SQRT(SPJ)
C
            IF(IPRO.GT.1)               WRITE(6,1550) I,J,PI,PJ
 1550       FORMAT(' KOMAKS,  I J ',2I3,'  PI PJ ',2E12.4)
C --------- MOMENTUM CUT
            IF(PI.LT.PCUTT .OR. PJ.LT.PCUTT) GOTO 930
C
            EINI = SQRT(PI**2+PIM**2)
            EINJ = SQRT(PJ**2+PIM**2)
            CALL ELOSS(PXI,PYI,PZI,IERRI)
            CALL ELOSS(PXJ,PYJ,PZJ,IERRJ)
            IF(IPRO.GT.1)               WRITE(6,1560) I,J,IERRI,IERRJ
 1560       FORMAT(' KOMAKS,  I J ',2I3,'  IERRI,J ',2I4)
            IF(IERRI.NE.0 .OR. IERRJ.NE.0)   GOTO 935
C
            PI    = SQRT(PXI**2 + PYI**2 + PZI**2)
            PJ    = SQRT(PXJ**2 + PYJ**2 + PZJ**2)
            EI    = SQRT(PI**2  + PIM**2)
            EJ    = SQRT(PJ**2  + PIM**2)
            ELOSI = EI-EINI
            ELOSJ = EJ-EINJ
C
            COSIJ = (PXI*PXJ + PYI*PYJ + PZI*PZJ)/(PI*PJ)
C
            PX    = PXI+PXJ
            PY    = PYI+PYJ
            PZ    = PZI+PZJ
            E     = EI+EJ
            PLTH  = PX*THX0 + PY*THY0 + PZ*THZ0
            P     = SQRT(PX**2 + PY**2 + PZ**2)
            PTTH  = SQRT(P**2  - PLTH**2)
            VMASS = SQRT(E**2  - P**2)
            X     = V(1)
            Y     = V(2)
            Z     = SQRT(X**2 + Y**2) * PZ/SQRT(PX**2 + PY**2)
            RVO   = SQRT(X**2 + Y**2 + Z**2)
C --------- MASS CUT TO REJECT PHOTON CONVERSION CANDIDATES
            PHMASS= SQRT(ABS((PI+PJ)**2 - P**2))
            IF(IPRO.GT.1)               WRITE(6,1570) I,J,PHMASS
 1570       FORMAT(' KOMAKS,  I J ',2I3,'  PHMASS ',E12.4)
            IF(PHMASS.LT.0.10)          GOTO 940
C
            TL    = DVL/(P * SQRT(1.-(PZ/P)**2)) * VMKS/26.75
            ALPH0 = (PX*X + PY*Y + PZ*Z)/(P*RVO)
            IF(ALPH0.GT.1.)             ALPH0 = 1.
            ALPH0 = ARCOS(ALPH0)
            ALPHA = ALPH0*180./3.14159265
C
            DM    = 0.
C
            IF(IPRO.GT.1)          WRITE(6,1580) I,J,D,DVL,COSIJ,CHI1
 1580       FORMAT(' KOMAKS, I J ',2I3,
     *             ' D DVL ',2E12.4,' COSIJ CHI1 ',2E12.4)
C
C *** SLC 12/3/86 ********************* NEXT 2 IF'S COMMENTED OUT
CC          IF(COSIJ.LT.-0.7)           GOTO 530
CC          IF(CHI1.GT.5.)              GOTO 530
C ------------------------------------- INCORPORATE RESOLUTION
               SIGPI = 0.033 * PI**2
               SIGPJ = 0.033 * PJ**2
               IF(PI.LT.2.)             SIGPI = 0.05*PI
               IF(PJ.LT.2.)             SIGPJ = 0.05*PJ
               DI    = (EJ*PI/EI - PJ*COSIJ) * SIGPI
               DJ    = (EI*PJ/EJ - PI*COSIJ) * SIGPJ
               DMP1  = SQRT(DI**2 + DJ**2)
               DMP   = DMP1/VMKS
               SINIJ = SQRT(1.-COSIJ**2)
               DMT   = PI*PJ * SINIJ * 0.01/VMKS
               DSCATI= 2.*1.41421356 * SCATT(PI,PZI/PI)
               DSCATJ= 2.*1.41421356 * SCATT(PJ,PZJ/PJ)
               DSCATT= SQRT(DSCATI**2 + DSCATJ**2)
               DMTS  = PI*PJ * SINIJ * DSCATT/VMKS
               DM    = SQRT(DMTS**2  + DMP**2)
               VMMIN = VMASS - 2.*DM
               VMMAX = VMASS + 2.*DM
C ------------------------------------- INVESTIGATE RESOLUTION
C                                       THIS HAS BEEN ADDED BY SLC
C                                       AND COMMENTED OUT (PVH)
C
C
C              PARAM(1) = VMASS
C              PARAM(2) = EI+EJ
C              PARAM(3) = DMP
C              PARAM(4) = DMTS
C              CALL DEKB(0)
C              CALL NTUPEL(901,PARAM)
 530        CONTINUE
C ------------------------------------- FILL RESULT COMMON/KOMAK/
            IF(NMAS.GE.50)              GOTO 540
               NMAS           = NMAS + 1
               PCOMB1(1,NMAS) = PXI
               PCOMB1(2,NMAS) = PYI
               PCOMB1(3,NMAS) = PZI
               PCOMB1(4,NMAS) = EI
               PCOMB2(1,NMAS) = PXJ
               PCOMB2(2,NMAS) = PYJ
               PCOMB2(3,NMAS) = PZJ
               PCOMB2(4,NMAS) = EJ
               XYZK0(1,NMAS)  = V(1)
               XYZK0(2,NMAS)  = V(2)
               XYZK0(3,NMAS)  = ZPOS
               VMAS(NMAS)     = VMASS
               DMAS(NMAS)     = DM
               DVLK0(NMAS)    = DVL
               DK0(NMAS)      = D
               HTR1(NMAS)     = I
               HTR2(NMAS)     = J
 540        CONTINUE
            IF(IPRO.LE.1)               GOTO 550
               WRITE(6,1600)NRUN,NEVT
               WRITE(6,1610)I,J,V(1),V(2),DVL,D,DD,ALPHA,
     *                      VMASS,COSIJ,P,PX,PY,PZ,
     *                     PI,ELOSI,PXI,PYI,PZI,
     *                      PJ,ELOSJ,PXJ,PYJ,PZJ,
     *                      CHI1,ALPH12,CHI22,TL,RMIN0(I),RMIN0(J),
     *                      DZI,DZJ,DZI0,DZJ0,VMMIN,VMMAX,ZPOS
C
 1600          FORMAT(/' KOMAKS: *****  RUN# =',I6,' -',I6)
 1610          FORMAT(' # KOMAKS # (I,J)=(',2I6,')  V(',2F9.3,')',
     *         ' DVL=',F10.3,' D,DD=',2F9.3,' ALPHA=',F8.3/
     *         ' #########  VMASS=',F7.3,'  COSIJ=',F7.3,'   P= ',F7.3,
     *         '  P(',3F10.3,')    '/
     *         '   #######  PI= ',F7.3,'  ELOSI=',F7.3,
     *         '   PI=(',3F10.3,')'/
     *         '     #####  PJ= ',F7.3,'  ELOSJ=',F7.3,
     *         '   PJ=(',3F10.3,')'/
     *         '       ### CHI**2=',F10.3,2X,F10.3,3X,F12.3,
     *         ' TL=',F10.3,'   RMIN(I,J)=',2F10.3/
     *         '         #  ',
     *         '      DZ(I,J)=(',2F10.3,')  DZ0(I,J)=(',2F10.3,') '/
     *         '  (VMMIN,VMMAX)=',2F9.3,' ZPOS ',E12.4)
C
 550        CONTINUE
            GOTO 500
C ------------------------------------- THE REJECTION SLIPS
 900        IERRKK = 1
            GOTO 960
 905        IERRKK = 2
            GOTO 960
 910        IERRKK = 3
            GOTO 960
 915        IERRKK = 4
            GOTO 960
 920        IERRKK = 5
            GOTO 960
 925        IERRKK = 100+LFLAG
            GOTO 960
 930        IERRKK = 7
            GOTO 960
 935        IERRKK = 8
            GOTO 960
 940        IERRKK = 9
            GOTO 960
 945        IERRKK = 10
            GOTO 960
 950        IERRKK = 11
            GOTO 960
 955        IERRKK = 12
 960        IF(ITRYK.GT.50) GOTO 500
               IERRK(ITRYK) = IERRKK
               IF(IERRKK .NE. 1) GOTO 500
                 IEERJ(ITRYK,1) = IEEFG(I)
                 IEERJ(ITRYK,2) = IEEFG(J)
C
 500     CONTINUE
 400  CONTINUE
C ------------------------------------- END OF TRACK LOOP
      RETURN
C
 980  CONTINUE
         IKOMA = 2
      RETURN
C
 990  CONTINUE
         IKOMA = 1
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION DET(A)
C-----------------------------------------------------------------------
C
C     FUNCTION TO CALCULATE DETERMINANT OF 3*3 MATRIX
C     S.KOMAMIYA      20.03.1980    22:55
C     MODIFIED        20.03.1980    22:55
C
C
C
C     COPIED FROM F22KOM.KS(DET)    27.11.1985
C
C
      DIMENSION A(3,3)
      DET=A(1,1)*A(2,2)*A(3,3)
     &   +A(1,2)*A(2,3)*A(3,1)
     &   +A(1,3)*A(2,1)*A(3,2)
     &   -A(1,1)*A(2,3)*A(3,2)
     &   -A(1,3)*A(2,2)*A(3,1)
     &   -A(1,2)*A(2,1)*A(3,3)
         RETURN
         END
C
C-----------------------------------------------------------------------
      SUBROUTINE ELOSS(PX,PY,PZ,IELOS)
C-----------------------------------------------------------------------
C
C     SUBROUTINE TO CALCULATE ENERGY LOSS IN BEAM PIPE AND PIPE COUNTERS
C     S.KOMAMIYA      19.03.1980    05:20
C     MODIFIED        14.03.1980    05:20
C    COPIED FROM F22KOM.KS(ELOSS)    27.11.1985
C     MODIFIED TO ACCOUNT FOR CHANGING GEOMETRY FROM 5/1984
C                     28.11.1985    J.OLSSON
C  TEMPORARY MODIFICATION TO CALL JFGAIN INSTEAD OF JEGAIN. THIS IS TO
C  AVOID CONFUSION WITH THE OLD JEGAIN THAT STILL SITS ON JADEGS/GL
C  WHICH USES /CJJONI/ INSTEAD OF /CJIONI/       3.12  1985
C
C   INPUT PARAMETERS
C     P   :MOMENTUM OF PROJECTILE PARTICLE
C     DZ  :COS(AZIMUTH ANGLE)
C
C       PROJECTILE PARTICLE IS ASSUMED TO BE PION
C
C   MATERIAL IN OLD GEOMETRY
C       AL 4.0+7.0 (MM)
C       SC 10.0(MM)
C   MATERIAL IN NEW GEOMETRY    Z/A*RHO  GIVEN IN COMMON /CIJONV/
C       AL 3.0 + 1.0 + 7.0 (MM)
C       VERTEX CHAMBER GAS
      IMPLICIT INTEGER*2 (H)
C- - - - - - - - -   CIJONV  - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CIJONV / POTVXC, ZAROVC,
     *                  POTVGA, ZAROVG
C
C                            GIVES AVERAGE IONISATION POTENTIAL
C                            AND VALUE FOR Z*RHO/A IN
C                            BETHE BLOCH FORMULA FOR :
C                               1) BEAMPIPE AND OUTER VERTEX CHAMBER
C                                  WALL (ALUMINIUM)
C                               2) CHAMBER GAS
C
C     DATA POTVXC,ZAROVC             / 160.3, 1.3      /
C     DATA POTVGA,ZAROVG             / 284.4, 0.00080  /
C
#include "cdata.for"
C
      DIMENSION P(6)
      DATA DAL0  /11.0/
      DATA DSC0  /10.0/
      DATA RHOAL /2.70/
      DATA RHOSC /1.03/
      DATA EIAL  /160.3/
      DATA EISC  /80.00/
      DATA ZAL   /13.0/
      DATA AAL   /26.0/
      DATA ZSC   /6.0/
      DATA ASC   /12.0/
      DATA DVTXG /65.0/
      DATA PIMASS/0.13975/
C     DATA ELEMAS/511.0/
C
C  USE DATE IN HEAD BANK TO DETERMINE IF OLD OR NEW GEOMETRY
C
       IPH2 = 2*IDATA(IBLN('HEAD'))
       IMAA = HDATA(IPH2+7)
       IAAR = HDATA(IPH2+8)
       IOLD = 0
       IF(IAAR.GT.1984) IOLD = 1
       IF(IAAR.EQ.1984.AND.IMAA.GT.4) IOLD = 1
C
      PTOT=SQRT(PX**2+PY**2+PZ**2)
      IF(PTOT .LE. 0.) GO TO 100
      E=SQRT(PTOT**2+PIMASS**2)
      P(1)=PX
      P(2)=PY
      P(3)=PZ
      P(4)=E
      P(5)=PIMASS
      P(6)=PTOT
      DZ=P(3)/PTOT
      SIN=SQRT(1.-DZ*DZ)
      IF(SIN.EQ.0.) GO TO 100
C
      DAL=DAL0/SIN
      DSC=DSC0/SIN
      IF(IOLD.EQ.1) DSC = DVTXG/SIN
      ZAROAL=ZAL/AAL*RHOAL
      ZAROSC=ZSC/ASC*RHOSC
      IF(IOLD.EQ.1) ZAROAL = ZAROVC
      IF(IOLD.EQ.1) ZAROSC = ZAROVG
      EISC1 = EISC
      IF(IOLD.EQ.1) EISC1 = POTVGA
C     CALL JEGAIN(P,DAL,EIAL,ZAROAL,&100)
C     CALL JEGAIN(P,DSC,EISC1,ZAROSC,&100)
      CALL JFGAIN(P,DAL,EIAL,ZAROAL,&100)
      CALL JFGAIN(P,DSC,EISC1,ZAROSC,&100)
      PX=P(1)
      PY=P(2)
      PZ=P(3)
      RETURN
100   IELOS=1
      RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE SOL(A,B,X,IFLAG)
C-----------------------------------------------------------------------
C     SUBROUTINE TO CALCULATE SOLUTION OF 3-VARIABLE LINEAR EQUATION
C     S.KOMAMIYA      20.03.1980    23:15
C     MODIFIED        20.03.1980    23:15
C
C       AX=B
C
C        A(I,J)    I=1,3  J=1,3
C        B(J)
C        X(I)
C
C    IDENTIC WITH THE MEMBER SOL  ON F22KOM.KS
C
      DIMENSION A(3,3),B(3),X(3),C1(3,3),C2(3,3),C3(3,3)
      IFLAG=1
      DA=DET(A)
        IF(DA.NE.0.) IFLAG=0
        IF(IFLAG.NE.0) RETURN
C
      DO 10 I=1,3
      DO 20 J=1,3
         C1(I,J)=A(I,J)
         C2(I,J)=A(I,J)
         C3(I,J)=A(I,J)
 20   CONTINUE
 10   CONTINUE
C
      DO 1 I=1,3
         C1(I,1)=B(I)
 1    CONTINUE
C
      DO 2 I=1,3
         C2(I,2)=B(I)
 2    CONTINUE
C
      DO 3 I=1,3
         C3(I,3)=B(I)
 3    CONTINUE
      X(1)=DET(C1)/DA
      X(2)=DET(C2)/DA
      X(3)=DET(C3)/DA
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE JFGAIN( P, STRAC, POT, ZARO, * )
C-----------------------------------------------------------------------
C
C     VERSION OF 21/11/77
C     FINDS ENERGY LOSS IN ABSORBER WITH POT AND ZARO
C     AND INCREASES ENERGY.
C     P IS CHANGED .
C                      COPIED FROM F22ELS   21/05/1980
C
C
      DIMENSION P(6)
C
      DATA D / .1535E-4 /
C
      IF(P(6).LT.0.) RETURN1
C  FIND REDUCED VARIABLES
      A = 2. * D * ZARO * STRAC / P(5)
      B = 1.022E6 / POT
      XLOW = P(4) / P(5)
      IF( XLOW * XLOW .GT. 16.9205 ) GO TO 400
C
C  INITIALIZE GAUSS METHOD
      ITER = 0
      INCREM = 0
      DXOLD = 1.E13
      X = XLOW
C
  100 ITER = ITER + 1
      IF( ITER .GT. 15 ) RETURN1
      X2 = X * X
      X21 = X2 -1.
      FACLOG = ALOG( B * X21 )
      DX = ( XLOW - X + A * ( X2 / X21 * FACLOG - 1. ) ) /
     *     ( 1. + 2.*A/(X21*X21) * ( FACLOG - X2 ) )
      ADX = ABS( DX )
      INCREM = INCREM + 1
      IF( ADX .LE. DXOLD ) INCREM = 0
      IF( INCREM .GE. 9 ) RETURN1
      DXOLD = ADX
      X = X + DX
      IF( ADX .GT. 0.001 * ABS(X) ) GO TO 100
C
  200 P(4) = X * P(5)
      PTOT = SQRT( P(4)*P(4) - P(5)*P(5) )
      FACT = PTOT / P(6)
      P(6) = PTOT
      DO 300 I = 1,3
  300 P(I) = P(I) * FACT
      RETURN
C
  400 XLOW2 = XLOW * XLOW
      X = XLOW + A*(XLOW2/(XLOW2-1.)*ALOG(B*(XLOW2-1.)) - 1. )
      GO TO 200
C
      END
C
C
C----------------------------------------------------------------------
       SUBROUTINE PATTRK(INDPR,*,*)
C----------------------------------------------------------------------
C            08/03/1980  11:40   CODED BY    S.KOMAMIYA
C            17/03/1980  01:30   MODIFIED BY S.KOMAMIYA
C                  CENTER OF THE CIRCLE
C            03/04/1980  06:10   MODIFIED BY S.KOMAMIYA
C                  ZMIN IN VTRK(19,I)
C            24/06/1980  02:15   MODIFIED BY S.KOMAMIYA
C
C    COPIED FROM F22KOM.KS(PATTRK1)     26.11.1985
C
C
C CONTENTS OF VTRK / KTRK :
C
C  VTRK(1,..):  X OF FIRST MEASURED POINT
C  VTRK(2,..):  Y OF FIRST MEASURED POINT
C  VTRK(3,..):  Z OF FIRST MEASURED POINT
C  VTRK(4,..):  DIRECTION COSINE AT FIRST MEASURED POINT
C  VTRK(5,..):  DIRECTION COSINE AT FIRST MEASURED POINT
C  VTRK(6,..):  DIRECTION COSINE AT FIRST MEASURED POINT
C  VTRK(7,..):  AVERAGE CURVATURE OF TRACK (SIGNED)
C  VTRK(8,..):  ERROR ON AVERAGE CURVATURE
C  VTRK(9,..):  CURVATURE OF TRACK (SIGNED) AT FIRST MEASURED POINT
C  VTRK(10,..): RADIUS OF CURVATURE (SIGNED) AT FIRST MEASURED POINT
C  VTRK(11,..): RADIUS OF CURVATURE (SIGNED) FOR AVERAGE
C  VTRK(12,..): X COORDINATE OF CENTER OF CURVATURE
C  VTRK(13,..): Y COORDINATE OF CENTER OF CURVATURE
C  VTRK(14,..): NOT USED
C  KTRK(15,..): TYPE OF RFI FIT:  1 CIRCLE, 2 PARABOLA
C  KTRK(16,..): NOT USED
C  KTRK(17,..): NR OF HITS IN THE RFI FIT
C  VTRK(18,..): RESIDUAL OF ZR FIT
C  VTRK(19,..): Z INTERCEPT OF ZR FIT
C  KTRK(20,..): MEASURE OF ORIGIN ABOVE OR BELOW VERTEX, SET IN KOMAKS
C
C
C
C
       COMMON/BCS/ IDATA(35000)
       DIMENSION ADATA(35000)
       INTEGER *2 HDATA(70000)
       EQUIVALENCE (IDATA(1),ADATA(1)),(HDATA(1),IDATA(1))
C
       COMMON/VTR/VTRK(20,100)
       DIMENSION KTRK(20,100)
       EQUIVALENCE (VTRK(1,1),KTRK(1,1))
            DO 10 I= 1,20
            DO 20 J= 1,100
            VTRK(I,J)= 0.0
 20         CONTINUE
 10         CONTINUE
C
       L0  =IDATA(INDPR+1)
       NTR =IDATA(INDPR+2)
       LTR =IDATA(INDPR+3)
C
       IF(NTR.LE.0) RETURN1
       IF(NTR.GT.100) RETURN2
C
C===== CHARGED TRACK LOOP
C
      DO 30 I=1,NTR
      LI=INDPR+L0+(I-1)*LTR
      VTRK(1,I)=ADATA(LI+5)
      VTRK(2,I)=ADATA(LI+6)
      VTRK(3,I)=ADATA(LI+7)
      VTRK(4,I)=ADATA(LI+8)
      VTRK(5,I)=ADATA(LI+9)
      VTRK(6,I)=ADATA(LI+10)
      VTRK(7,I)=ADATA(LI+25)
      VTRK(8,I)=ADATA(LI+26)
      VTRK(9,I)=ADATA(LI+27)
C
         VTRK(10,I)=10000000.
      IF(VTRK(9,I).NE.0.) VTRK(10,I)=1./VTRK(9,I)
         VTRK(11,I)=10000000.
      IF(VTRK(7,I).NE.0.) VTRK(11,I)=1./VTRK(7,I)
C
C
C
C     IF(VTRK(6,I).GT.1) GO TO 30
C        SNTH=SQRT(1.-VTRK(6,I)**2)
C        SNPH=VTRK(5,I)/SNTH
C        CNPH=VTRK(4,I)/SNTH
C
C     VTRK(12,I)=VTRK(1,I)+VTRK(10,I)*SNPH
C     VTRK(13,I)=VTRK(2,I)-VTRK(10,I)*CNPH
C
      KTRK(15,I)=IDATA(LI+18)
      IF(KTRK(15,I).EQ.2) GO TO 5
C CIRCLE FIT HERE
      D0=ABS(ADATA(LI+20)+1./ADATA(LI+19))
      VTRK(12,I)=D0*COS(ADATA(LI+21))
      VTRK(13,I)=D0*SIN(ADATA(LI+21))
      GO TO 50
 5    CONTINUE
C PARABOLA FIT HERE
      VTRK(12,I)=ADATA(LI+20)+VTRK(10,I)*SIN(ADATA(LI+19))
      VTRK(13,I)=ADATA(LI+21)-VTRK(10,I)*COS(ADATA(LI+19))
C
C
C
 50   CONTINUE
      KTRK(17,I)=IDATA(LI+24)
      VTRK(18,I)=ADATA(LI+32)
C
       ZMIN=ADATA(LI+30)
       VTRK(19,I)=ZMIN
C      WRITE(6,1000)I,ZMIN,(VTRK(J,I),J=10,13)
C1000  FORMAT(' /PATTRK/ I=',I3,' ZMIN,VTRK',5F11.3)
C
C
C
 30   CONTINUE
C
C
C
        RETURN
        END
C-----------------------------------------------------------------------
      FUNCTION RBPIPE(X0BTWN)
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
C RETURN THE CURRENT BEAMPIPE RADIUS, BASED ON DATE IN HEAD BANK
C ARGUMENT X0BTWN GIVES AMOUNT OF RADIATION LENGTH BETWEEN PIPE AND TANK
C
#include "cdata.for"
#include "cgeo1.for"
#include "cgeov.for"
C
      IH2 = 2*IDATA(IBLN('HEAD'))
C
      IDAG = HDATA(IH2+7)
      IAAR = HDATA(IH2+8)
      RBPIPE = RPIP
      X0BTWN = 0.16
      IF(IAAR.LT.1984) GO TO 3200
      IF(IAAR.EQ.1984.AND.IDAG.LT.5) GO TO 3200
C NEW GEOMETRY
      RBPIPE = RPIPV
      X0BTWN = 0.1312
3200  CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE RFDRPZ( NR, NTRK, IER )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN      1/11/79 :  CONVERT COORDS OF NTRK TO R-PHI-Z
C
C        MOD: E. ELSEN     19/09/80 :
C        MOD: P. STEFFEN   16/12/83 :  GET NEW RECALIBRATED HITS (R-PHI)
C   LAST MOD: C. BOWDERY   16/12/83 :  RECOMMENTING
C
C        CONVERT COORDINATES OF TRACK NTRK TO R-PHI-Z-COORDINATES
C        RESULT IS STORED IN BANK RFWK, 1.
C        BASIS FOR CONVERSION IS 'JHTL', NR.
C
C        RW(1) = RADIUS OF POINT
C        RW(2) = PHI VALUE OF POINT
C        RW(3) = Z
C        HW(7) = Z ERROR FLAG   ( 0 FOR GOOD Z COORDINATE )
C        HW(8) = NUMBER OF HIT
C
C        IER   = 4,   NOT ENOUGH SPACE IN BCS
C              = 3,   JHTL,NR OR PATR,NR NOT PRESENT
C              = 2,   JETC,0 NOT PRESENT
C              = 1,   TRACK NOT FOUND
C              = 0,   ELSE
C
C        NEW VERSION TO PROVIDE VARIABLES FOR PEARCE'S VERSION OF
C        HITXYZ.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1)), (RW(1),IW(1))
C
#include "cdsmax.for"
C                                           COMMON FOR OLD-DATA
      COMMON / CRFDAT / NTRKOL, DATOLD, IDOLD, NLIOLD, IEROLD
C
      COMMON /CWRK/ WRK(2000)
                    DIMENSION IWRK(2000)
                    EQUIVALENCE(IWRK(1),WRK(1))
C
      DIMENSION RLIST(150), ILIST(150)
C
      DIMENSION RESUL(17),IRESUL(17)
      EQUIVALENCE (IRESUL(1),RESUL(1))
      DIMENSION HELP(2), BUFF(4)
      EQUIVALENCE (IHELP,HELP(1))
C
      DATA LEN / 400/
      DATA LBINIT / 0/
C
C-----------------------------------------------------------------------
C
C                                           INITIALIZATION
      IF(LBINIT.NE.0) GOTO 10
         LBINIT = 1
         IQJETC = IBLN('JETC')
         IQPATR = IBLN('PATR')
         IQJHTL = IBLN('JHTL')
         IQRFWK = IBLN('RFWK')
       WRITE(6,9992)
9992  FORMAT(' RFDRPZ CALLED, NEW VERSION FROM TPSOURCE..')
   10 CONTINUE
C                                           PATR
      IER = 3
      IPPATR = IW(IQPATR)
   12 CONTINUE
         IF(IPPATR.LE.0) GOTO 1500
         IF(IW(IPPATR-2) .EQ. NR) GOTO 14
         IPPATR = IW(IPPATR-1)
         GOTO 12
   14 CONTINUE
C                                           BUFFER OLD ID AND DATE
      IER = 1
      IF( NTRK .GT. IW(IPPATR+2) ) GO TO 1500
      IPTR   = IPPATR + IW(IPPATR+1) +(NTRK-1)*IW(IPPATR+3)
      NTRKOL = NTRK
      NLIOLD = IW(IPPATR+7)
      IDOLD  = IW(IPTR+2)
      DATOLD = RW(IPTR+3)
      IEROLD = IW(IPTR+48)
C     I0 = IPTR + 1
C     I9 = IPTR + 48
C     PRINT 2005, (IW(I1),I1=I0,I9)
C2005 FORMAT(1H0,2I3,I8,2(I4,3F6.1,3F6.3),
C    ,     /,14X,I3,4E13.5,F6.2,I3,4E13.5,
C    ,     /,14X,I3,2F8.3,F6.1,I3,10X,6I3,8I6,2X,Z4)
C                                           JHTL
      IER = 3
      IPJHTL = IW(IQJHTL)
   16 CONTINUE
         IF(IPJHTL.LE.0) GOTO 1500
         IF(IW(IPJHTL-2) .EQ. NR) GOTO 18
         IPJHTL = IW(IPJHTL-1)
         GOTO 16
   18 CONTINUE
C                                           JETC
      IER = 2
      IPJETC = IW(IQJETC)
      IF(IPJETC .LE. 1 ) GO TO 1500
C
C
C                                     FETCH HITS, CALCULATE COORDINATES,
C                                     FILL ARRAY IN /CWORK/
      IPCO0  = 1
      LHIT   = 14
      INDFET = 1
      CALL JFETCH(IPTR,IPJHTL,WRK(1),LHIT,IPRES,INDFET)
      IPCO9  = IPRES - 1
      NHIT = IPRES / LHIT
C     PRINT 2002, NHIT,(WRK(I),I=IPCO0,IPCO9)
C2002 FORMAT('0TRACK:',I6,/,(1X,3I6,4F8.3,I4,F8.3,2I4,F8.3,I6,F8.2))
C
C                                       > 0 HITS ?
      IER = 1
      IF(NHIT .LT. 1) GO TO 1500
C
C
C                                       LOOP OVER FETCH-HITS
C                                       AND STORE RADII FOR ORDERING
      NH1 = 0
      RR0 = 0.
      LBORD = 0
      DO 120 IPCO = IPCO0,IPCO9,LHIT
        IF(IWRK(IPCO+10).GT.0) GOTO 120
          NH1 = NH1 + 1
          ILIST(NH1) = IPCO
          RLIST(NH1) = WRK(IPCO+6)
          IF(WRK(IPCO+6).LT.RR0) LBORD = 1
          RR0        = WRK(IPCO+6)
  120 CONTINUE
C
C
C                                       > 0 HITS ?
      IF(NH1  .LE. 1) GO TO 1500
C
C                                       CHECK IF ORDERING NECESSAIRY
      IF(LBORD.EQ.0) GOTO 190
C                                       ORDER RADII
        M = NH1
  130   M = M / 2
        IF(M.EQ.0) GOTO 160
        K = NH1 - M
        DO 150 J=1,K
           I = J
  140      IF(I.LT.1) GOTO 150
           IF(RLIST(I+M).GE.RLIST(I)) GOTO 150
              RZW        = RLIST(I+M)
              RLIST(I+M) = RLIST(I  )
              RLIST(I  ) = RZW
              IZW        = ILIST(I+M)
              ILIST(I+M) = ILIST(I  )
              ILIST(I  ) = IZW
              I = I - M
           GOTO 140
  150   CONTINUE
        GOTO 130
  160 CONTINUE
C     PRINT 2008, LBORD,(I1,RLIST(I1),ILIST(I1),I1=1,NH1)
C2008 FORMAT('1ORDERING:',I6,/,(5(I8,F8.0,I4)))
C
  190 CONTINUE
C
C                                           RFWK POINTERS
C     CREATE RFWK-BANK IF NOT JET EXISTING
      IF(IW(IQRFWK).GT.0) GOTO 20
         CALL BCRE( NPRFWK, 'RFWK', 1, LEN, &8100, IERR )
         CALL BSAT( 1, 'RFWK' )
   20 CONTINUE
C                                           ADJUST LENGTH OF RFWK
C     CALL BPRS('RFWK',1)
      IER = 0
      NPRFWK = IW(IQRFWK)
      J = NH1*4 - IW(NPRFWK)
      IF(J.NE.0) CALL BCHM( NPRFWK, J, IERR )
      NPRFWK = IW(IQRFWK)
      IRFWK = NPRFWK
C
C     CALL BPRS('RFWK',1)
C
C
      DO 1000 IH1 = 1,NH1
C                                           FIND COORDINATES
          IPCO = ILIST(IH1)
          RW( IRFWK   + 1 ) = WRK(IPCO+6)
          PHI = ATAN2(WRK(IPCO+4),WRK(IPCO+3))
          RW( IRFWK   + 2 ) = PHI
          RW( IRFWK   + 3 ) = WRK(IPCO+5)
          HW( IRFWK*2 + 7 ) = IWRK(IPCO+ 7)
          HW( IRFWK*2 + 8 ) = (IWRK(IPCO+1) - IPJETC*2 - 97) / 2 + 1
C         I1 = IRFWK + 1
C         RA  =  RW(I1  )
C         FI  =  RW(I1+1)
C         ZZ  =  RW(I1+2)
C         IZF =  HW(I1*2+5)
C         IPH =  HW(I1*2+6)
C         PRINT 2001, I2,I1,RA,FI,ZZ,IZF,IPH
C2001 FORMAT(' HIT',I3,I6,3F9.3,I4,I6)
          IRFWK = IRFWK + 4
 1000 CONTINUE
C
 1500 CONTINUE
C     PRINT 2003, IER
C2003 FORMAT('0RFDRPZ9:',I3)
C     I0 = NPRFWK + 1
C     I9 = IRFWK
C     I2 = 0
C     DO 90 I1=I0,I9,4
C        I2 = I2 + 1
C        RA  =  RW(I1  )
C        FI  =  RW(I1+1)
C        ZZ  =  RW(I1+2)
C        IZF =  HW(I1*2+5)
C        IPH =  HW(I1*2+6)
C        PRINT 2001, I2,I1,RA,FI,ZZ,IZF,IPH
C  90 CONTINUE
C
      RETURN
C
C                                           ERROR PART
 8100 WRITE(6,9101)
 9101 FORMAT(/' ++++ RFDRPZ ++++      NOT ENOUGH SPACE TO ACCOMODATE ALL
     * HITS IN BANK RFWK,1 '//)
      IER = 4
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION SCATT(P,DZ)
C-----------------------------------------------------------------------
C
C     S.KOMAMIYA      15.03.1980    00:10
C     MODIFIED        17.03.1980    15:30
C     MODIFIED        01.04.1980    00:30   SQRT(SQRT(1.-DZ**2))
C
C   COPIED FROM F22KOM.KS(SCATT)    26.11.1985
C
      DATA PIMASS/0.13957/
      E=SQRT(P**2+PIMASS**2)
      SCATT=0.006/(P**2/E)/SQRT(SQRT(1.-DZ**2))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE TWOCIR(A1,B1,R1,A2,B2,R2,V1,V2,DIST,IFLAG)
C-----------------------------------------------------------------------
C     SUBROUTINE TO CALCULATE INTERSECTION POINTS OF THE TWO CIRCLE
C     S.KOMAMIYA      07.03.1980    13:45
C     MODIFIED        14.03.1980    14:45
C
C    COPIED FROM F22KOM.KS(TWOCIR)   26.11.1985
C
C                          DIRECTION VECTORS AT VERTEX POINTS
C
C
C   INPUT PARAMETERS
C     A1  :X-COORD. OF CENTER OF CIRCLE1
C     B1  :Y-COORD. OF CENTER OF CIRCLE1
C     R1  :RADIUS OF CIRCLE1      (SIGNED!)
C     A2  :X-COORD. OF CENTER OF CIRCLE2
C     B2  :Y-COORD. OF CENTER OF CIRCLE2
C     R2  :RADIUS OF CIRCLE2
C
C
C   INTERNAL PARAMETERS
C
C
C   OUTPUT  PARAMETERS
C
C     V1(1) : X-COOR. OF VERTEX1
C     V1(2) : Y-COOR. OF VERTEX1
C     V1(3) : X-COMPONENT OF MOMENTUM DIRECTION AT VERTEX1 (PARTICLE 1)
C     V1(4) : Y-COMPONENT OF MOMENTUM DIRECTION AT VERTEX1 (PARTICLE 1)
C     V1(5) : X-COMPONENT OF MOMENTUM DIRECTION AT VERTEX1 (PARTICLE 2)
C     V1(6) : Y-COMPONENT OF MOMENTUM DIRECTION AT VERTEX1 (PARTICLE 2)
C     V2(1) : X-COOR. OF VERTEX2
C     V2(2) : Y-COOR. OF VERTEX2
C     V2(3) : X-COMPONENT OF MOMENTUM DIRECTION AT VERTEX2 (PARTICLE 1)
C     V2(4) : Y-COMPONENT OF MOMENTUM DIRECTION AT VERTEX2 (PARTICLE 1)
C     V2(5) : X-COMPONENT OF MOMENTUM DIRECTION AT VERTEX2 (PARTICLE 2)
C     V2(6) : Y-COMPONENT OF MOMENTUM DIRECTION AT VERTEX2 (PARTICLE 2)
C
C     DIST(1) : X OF THE NEAREST POINT ON LINE V1-V2 FROM THE ORIGIN
C     DIST(2) : Y OF THE NEAREST POINT ON LINE V1-V2 FROM THE ORIGIN
C
C
C    IFLAG = 0     : NORMAL TWO INTERSECTION POINTS
C          = 1     : ONLY ONE INTERSECTION POINT
C          = 10    : TWO CIRCLES DO NOT INTERSECT
C          = 100   :
C          = 1000  :
C
C
C
      DIMENSION V1(6)
      DIMENSION V2(6)
      DIMENSION DIST(2)
C===== INITIALIZATION
      DO 100 K=1,6
         V1(K)=0.
         V2(K)=0.
 100     CONTINUE
         IFLAG=-1000
C===== CALCULATE INTERSECTION POINTS
         AA =2.*(A2-A1)
         BB =2.*(B2-B1)
         CC1=A1**2+B1**2-R1**2
         CC2=A2**2+B2**2-R2**2
         CC=CC1-CC2
      IF(BB.NE.0.) GO TO 10
       IF(AA.NE.0.) GO TO 2
         IFLAG=100
         RETURN
C    IDENTICAL CIRCLES
 2       V1(1)=-CC/AA
         V2(1)=V1(1)
         D=R1**2-(CC/AA+A1)**2
         IF(D) 3,4,5
 3       IFLAG=100
         RETURN
C
 4       IFLAG=1
         GO TO 6
C
 5       IFLAG=0
 6       V1(2)=B1+SQRT(D)
         V2(2)=B1-SQRT(D)
         GO TO 200
C
 10      CONTINUE
         A=1.+(AA/BB)**2
         B=-2.*A1+2.*AA/BB*(CC/BB+B1)
         C=A1**2+(CC/BB+B1)**2-R1**2
         D=B**2-4.*A*C
         IF(D)11,12,13
 11      IFLAG=10
         RETURN
 12      IFLAG=1
         GO TO 14
 13      IFLAG=0
 14      V1(1)=(-B+SQRT(D))/2./A
         V2(1)=(-B-SQRT(D))/2./A
         V1(2)=-(AA*V1(1)+CC)/BB
         V2(2)=-(AA*V2(1)+CC)/BB
C
C===== GET DIRECTION OF THE MOMENTUM AT VERTICES
C   ESSENTIALLY X,Y COMPONENTS OF RADIUS OF CURVATURE
C   SWAP DIRECTION ACCORDING TO CHARGE (SIGN OF RADIUS CURV.)
C
 200     CONTINUE
C===== VERTEX-1
         V1(3)=B1-V1(2)
         V1(4)=V1(1)-A1
      IF(R1) 22,300,21
 21      V1(3)=-V1(3)
         V1(4)=-V1(4)
 22     CONTINUE
         V1(5)=B2-V1(2)
         V1(6)=V1(1)-A2
      IF(R2) 24,300,23
 23      V1(5)=-V1(5)
         V1(6)=-V1(6)
 24     CONTINUE
C===== VERTEX-2
         V2(3)=B1-V2(2)
         V2(4)=V2(1)-A1
      IF(R1) 26,300,25
 25      V2(3)=-V2(3)
         V2(4)=-V2(4)
 26     CONTINUE
         V2(5)=B2-V2(2)
         V2(6)=V2(1)-A2
      IF(R2) 28,300,27
 27      V2(5)=-V2(5)
         V2(6)=-V2(6)
 28     CONTINUE
         DIST(1)=-CC*AA/(AA**2+BB**2)
         DIST(2)=-CC*BB/(AA**2+BB**2)
 300  CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE VTX(NRUN,X,Y)
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2(H)
C     THIS ROUTINE RETURNS THE X AND Y COORDS OF THE RUN VERTEX.
C     FROM COMMON CALIBR (ON PATRECSR....THIS ALSO CONTAINS THE
C     ARRAY DECLARATIONS AND EQUIVILENCES.
C     NRUN IS A DUMMY VARIABLE TO SATISFY KOMAMIYAS CALL VTX
C
C
C                    WRITTEN 9.04.86
C
#include "calibr.for"
C
C                              FIND POINTER IN CALIB ARRAY
C
      IPVTX = ICALIB(10)
C
C                              NOW GET COORDS
C
      X     = ACALIB( IPVTX + 1)
      Y     = ACALIB( IPVTX + 3)
C
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE XYSCAT(NRUN,I,STDEV,R1,R2,RMINI,MFLAG)
C-----------------------------------------------------------------------
C
C     S.KOMAMIYA      12.05.1980    00:30
C     MODIFIED        13.05.1980    22:30     MAIN XY-VERTEX
C     COPIED FROM F22KOM.KS(XYSCAT6)     26.11.1985
C     MODIFIED TO TAKE ACCOUTN OF VARYING BEAMPIPE GEOMETRY  J.OLSSON
C     MODIFIED        07.11.1986    FOR WERTEX USE NEED 40 ENTRIES
C                                   IN CWORK1 FOR EACH TRACK  PH
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  R1,R2 ARE MEASURES OF SPREAD OF TRACK ORIGIN, DUE TO SCATTERING
C  IF R1*R2 < 0, THE RUN VERTEX IS COMPATIBLE WITH BEING THE TRACKORIGIN
C   THE VARIABLE STDEV MAGNIFIES THIS MEASURE, I.E. THE LARGER STDEV,
C   THE CLEARER THE V0 CANDIDATES MUST BE SEPARATED FROM THE MAIN VERTEX
C
      COMMON/VTR/VTRK(20,100)
      DIMENSION KTRK(20,100)
      EQUIVALENCE (VTRK(1,1),KTRK(1,1))
C--- USE DITTMANN'S VERTEX --------------- 16/07/1980 ------------------
C-----------   FILL /CWORK1/ -------------------------------------------
      COMMON /CWORK1/NT,T(2000)
C-----------------------------------------------------------------------
C
      DIMENSION VI1(6),VI2(6),VI(6)
      DIMENSION DISTI(2)
      COMMON/MAG/BC
C     DATA RMAT/152.4/
      RMAT = RBPIPE(X0BTWN)
      R1=0.
      R2=0.
C     R3=0.
C     R4=0.
C  RUN VERTEX   (CALLS VRTPOS)
      CALL VTX(NRUN,X0,Y0)
C
C
C
       AI=VTRK(12,I)
       BI=VTRK(13,I)
       RI=VTRK(10,I)
C------------------------------------- 29/05/1980 ----------------------
       RMINI=ABS(SQRT((AI-X0)**2+(BI-Y0)**2)-ABS(RI))
C-----------------------------------------------------------------------
       CALL TWOCIR(AI,BI,RI,0.,0.,RMAT,VI1,VI2,DISTI,IFLAGI)
       IF(IFLAGI.GT.0) GO TO 6002
       SIGVI1=VI1(1)*VI1(3)+VI1(2)*VI1(4)
       SIGVI2=VI2(1)*VI2(3)+VI2(2)*VI2(4)
       IF(SIGVI1)20,20,10
 10    DO 11 K=1,6
       VI(K)=VI1(K)
 11    CONTINUE
       GO TO 30
 20    IF(SIGVI2)6003,6003,21
 21    DO 22 K=1,6
       VI(K)=VI2(K)
 22    CONTINUE
 30    CONTINUE
C
C
C
      PTI=ABS(VTRK(10,I))*BC
      DZI=VTRK(6,I)
      COSZI=SQRT(1.-DZI**2)
      IF(COSZI .LT. 0.000000001) GO TO 6002
      PI=PTI/COSZI
      SPHIS=SCATT(PI,DZI)
C------------------------------------------- 29/01/1981 ----------------
      IDITT=(I-1)*40
      SFITI=T(IDITT+8)
      SPHI1=SQRT(SPHIS**2+SFITI**2)
      SPHI=SQRT(SPHIS**2+SFITI**2)*STDEV
C     WRITE(6,1000) I,SFITI,SPHIS,SPHI1,SPHI
C1000 FORMAT(' I=',I3,'  (FIT,SCATT,SIGPHI)=',3F10.4,'  *STD',F10.4)
C-----------------------------------------------------------------------
      COS1=COS(SPHI)
      SIN1=SIN(SPHI)
C     COS2=COS(2.*SPHI)
C     SIN2=SIN(2.*SPHI)
      AI1P= COS1*(AI-VI(1))+SIN1*(BI-VI(2))+VI(1)
      BI1P=-SIN1*(AI-VI(1))+COS1*(BI-VI(2))+VI(2)
      AI1M= COS1*(AI-VI(1))-SIN1*(BI-VI(2))+VI(1)
      BI1M= SIN1*(AI-VI(1))+COS1*(BI-VI(2))+VI(2)
C     AI2P= COS2*(AI-VI(1))+SIN2*(BI-VI(2))+VI(1)
C     BI2P=-SIN2*(AI-VI(1))+COS2*(BI-VI(2))+VI(2)
C     AI2M= COS2*(AI-VI(1))-SIN2*(BI-VI(2))+VI(1)
C     BI2M= SIN2*(AI-VI(1))+COS2*(BI-VI(2))+VI(2)
      R1=SQRT((AI1P-X0)**2+(BI1P-Y0)**2)-ABS(RI)
      R2=SQRT((AI1M-X0)**2+(BI1M-Y0)**2)-ABS(RI)
C     R3=SQRT((AI2P-X0)**2+(BI2P-Y0)**2)-ABS(RI)
C     R4=SQRT((AI2M-X0)**2+(BI2M-Y0)**2)-ABS(RI)
CCCCCCCCCCCCCCCC ONLY FOR TEST
C     WRITE(6,1000)I,PI,SPHI,R1,R2,R3,R4,BC
C1000 FORMAT('/XYSCAT/ I=',I3,' PI=',F7.3,' SPHI=',F7.3,' R(4)=',5F10.3)
CCCCCCCCCCCCCCCC
      GO TO 5000
C
 6001 MFLAG=201
      R1=0.
      R2=0.
C     R3=0.
C     R4=0.
      RETURN
 6002 MFLAG=202
      RETURN
 6003 MFLAG=203
      RETURN
C===
 5000 MFLAG=0
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE XYVOPT(I,J,V,DVL,D,CHI1,ALPH12,PHUV,KFLAG)
C-----------------------------------------------------------------------
C
C     S.KOMAMIYA      15.03.1980    00:10
C     MODIFIED        17.03.1980    15:30
C     MODIFIED        30.12.1980    17:30
C     SUBROUTINE TO OPTIMIZE VERTEX X,Y-POSITION OF TWO TRACKS
C     ---------- VERTEX IBIRI -----------
C
C
C    KFLAG = 0     : NORMAL END
C          = 1     :
C          = **    :
C          = 100   :
C          = 201   :   OUTSIDE OF BEAM PIPE
C
C
C    COPIED FROM F22KOM.KS(XYVOPT6)     27.11.1985
C    UPDATED FOR WERTEX USE             07.11.86    PAUL HILL
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      COMMON/VTR/VTRK(20,100)
      DIMENSION KTRK(20,100)
      EQUIVALENCE (VTRK(1,1),KTRK(1,1))
C
      DIMENSION VI1(6),VI2(6),VI(6),VJ1(6),VJ2(6),VJ(6)
      DIMENSION DISTI(2),DISTJ(2),DIST(2),V1(6),V2(6),V(6)
C----------
      DIMENSION U1(6),U2(6)
      DIMENSION DIST0(2)
C----------
      DIMENSION VBY(6)
C
      COMMON /CWORK1/ NT,T(2000)
C-----------------------------------------------------------------------
      COMMON/MAG/BC
C      DATA RMAT/152.4/
C
       RMAT = RBPIPE(X0BTWN)
C---------------------------- 29/04/1980 ------- BY PASS ---------------
      DO 9999 LLL=1,6
      VBY(LLL)=V(LLL)
 9999 CONTINUE
       D0=D
       DVL0=DVL
C-----------------------------------------------------------------------
C   NOTE:  D AND DVL ARE NOT UPDATED IN THIS ROUTINE, ALTHOUGH THEY
C          COULD HAVE BEEN!
C-----------------------------------------------------------------------
       KFLAG=-1000
       VO=SQRT(V(1)**2+V(2)**2)
       IF(VO.GE.RMAT) GO TO 6001
C
C
C
        AI=VTRK(12,I)
        BI=VTRK(13,I)
        RI=VTRK(10,I)
        AJ=VTRK(12,J)
        BJ=VTRK(13,J)
        RJ=VTRK(10,J)
       CALL TWOCIR(AI,BI,RI,AJ,BJ,RJ,U1,U2,DIST0,IFLAG0)
       IF(IFLAG0.GT.0) GO TO 6002
       CALL TWOCIR(AI,BI,RI,0.,0.,RMAT,VI1,VI2,DISTI,IFLAGI)
       IF(IFLAGI.GT.0) GO TO 6002
       SIGVI1=VI1(1)*VI1(3)+VI1(2)*VI1(4)
       SIGVI2=VI2(1)*VI2(3)+VI2(2)*VI2(4)
       IF(SIGVI1)20,20,10
 10    DO 11 K=1,6
       VI(K)=VI1(K)
 11    CONTINUE
       GO TO 30
 20    IF(SIGVI2)6003,6003,21
 21    DO 22 K=1,6
       VI(K)=VI2(K)
 22    CONTINUE
 30    CONTINUE
       CALL TWOCIR(AJ,BJ,RJ,0.,0.,RMAT,VJ1,VJ2,DISTJ,IFLAGJ)
       IF(IFLAGJ.GT.0) GO TO 6004
       SIGVJ1=VJ1(1)*VJ1(3)+VJ1(2)*VJ1(4)
       SIGVJ2=VJ2(1)*VJ2(3)+VJ2(2)*VJ2(4)
       IF(SIGVJ1)40,40,31
 31    DO 32 K=1,6
       VJ(K)=VJ1(K)
 32    CONTINUE
       GO TO 50
 40    IF(SIGVJ2)6005,6005,41
 41    DO 42 K=1,6
       VJ(K)=VJ2(K)
 42    CONTINUE
 50    CONTINUE
C
C
C
      PTI=ABS(VTRK(10,I))*BC
      PTJ=ABS(VTRK(10,J))*BC
C
      DZI=VTRK(6,I)
      DZJ=VTRK(6,J)
C
      PI=PTI/SQRT(1.-DZI**2)
      PJ=PTJ/SQRT(1.-DZJ**2)
C
      SPHI1=SCATT(PI,DZI)
      SPHJ1=SCATT(PJ,DZJ)
C------------------------------------------- 16/07/1980 ----------------
      IDITT=(I-1)*40
      CALL VTXPNT(IDITT,VI(1),VI(2),XI,YI,ZI,QXI,QYI,QZI,PHI,DPHI,STI)
      SPHI=SPHI1
C     IF(IFLAG.NE.0) GO TO 61
C   T(IDITT+8) CONTAINS THE ERROR IN FI FROM VTXPRE
      SPHI=SQRT(SPHI1**2+T(IDITT+8)**2)
C61    CONTINUE
C-----------------------------------------------------------------------
C------------------------------------------- 16/07/1980 ----------------
      JDITT=(J-1)*40
      CALL VTXPNT(JDITT,VJ(1),VJ(2),XJ,YJ,ZJ,QXJ,QYJ,QZJ,PHJ,DPHJ,STJ)
      SPHJ=SPHJ1
C     IF(JFLAG.NE.0) GO TO 62
      SPHJ=SQRT(SPHJ1**2+T(JDITT+8)**2)
C62   CONTINUE
C-----------------------------------------------------------------------
C
      SINPHI=VI(4)/SQRT(VI(3)**2+VI(4)**2)
      SINPHJ=VJ(4)/SQRT(VJ(3)**2+VJ(4)**2)
C
      COSPHI=VI(3)/SQRT(VI(3)**2+VI(4)**2)
      COSPHJ=VJ(3)/SQRT(VJ(3)**2+VJ(4)**2)
C
      AA1=(VJ(1)*COSPHJ+VJ(2)*SINPHJ)*RJ
      BB1=-(VI(1)*COSPHI+VI(2)*SINPHI)*RI
      CCI1=(VI(1)*SINPHI-VI(2)*COSPHI)*RI
      CCJ1=(VJ(1)*SINPHJ-VJ(2)*COSPHJ)*RJ
      CC1=CCJ1-CCI1
      IF(AA1.EQ.0. .OR. BB1.EQ.0.) GO TO 6006
      DPHJ1=-AA1*CC1/(BB1**2/SPHJ**2+AA1**2/SPHI**2)/SPHI**2
      DPHI1=-(AA1*DPHJ1+CC1)/BB1
C     AI=VI(1)+RI*(SINPHI*COS(DPHI)+COSPHI*SIN(DPHI))
C     BI=VI(2)-RI*(COSPHI*COS(DPHI)-SINPHI*SIN(DPHI))
C     AJ=VJ(1)+RJ*(SINPHJ*COS(DPHJ)+COSPHJ*SIN(DPHJ))
C     BJ=VJ(2)-RJ*(COSPHJ*COS(DPHJ)-SINPHJ*SIN(DPHJ))
      AAI1=VI(1)+RI*(SINPHI+COSPHI*DPHI1)
      BBI1=VI(2)-RI*(COSPHI-SINPHI*DPHI1)
      AAJ1=VJ(1)+RJ*(SINPHJ+COSPHJ*DPHJ1)
      BBJ1=VJ(2)-RJ*(COSPHJ-SINPHJ*DPHJ1)
C
      CHI1=(DPHI1/SPHI)**2+(DPHJ1/SPHJ)**2
C
      AA2=(VI(1)*COSPHI+VI(2)*SINPHI)*RI
      BB2=-(VJ(1)*COSPHJ+VJ(2)*SINPHJ)*RJ
      CCI2=(VI(1)*SINPHI-VI(2)*COSPHI)*RI
      CCJ2=(VJ(1)*SINPHJ-VJ(2)*COSPHJ)*RJ
      CC2=CCI2-CCJ2
      IF(AA2.EQ.0. .OR. BB2.EQ.0.) GO TO 6006
      DPHI2=-AA2*CC2/(BB2**2/SPHI**2+AA2**2/SPHJ**2)/SPHJ**2
      DPHJ2=-(AA2*DPHI2+CC2)/BB2
C     AI=VI(1)+RI*(SINPHI*COS(DPHI)+COSPHI*SIN(DPHI))
C     BI=VI(2)-RI*(COSPHI*COS(DPHI)-SINPHI*SIN(DPHI))
C     AJ=VJ(1)+RJ*(SINPHJ*COS(DPHJ)+COSPHJ*SIN(DPHJ))
C     BJ=VJ(2)-RJ*(COSPHJ*COS(DPHJ)-SINPHJ*SIN(DPHJ))
      AAI2=VI(1)+RI*(SINPHI+COSPHI*DPHI2)
      BBI2=VI(2)-RI*(COSPHI-SINPHI*DPHI2)
      AAJ2=VJ(1)+RJ*(SINPHJ+COSPHJ*DPHJ2)
      BBJ2=VJ(2)-RJ*(COSPHJ-SINPHJ*DPHJ2)
C
      CHI2=(DPHI2/SPHI)**2+(DPHJ2/SPHJ)**2
C
C
C
C
      VO=0.
      CALL TWOCIR(AAI1,BBI1,RI,AAJ1,BBJ1,RJ,V1,V2,DIST,IFLAGK)
       IF(IFLAGK.NE.0) GO TO 6000
C--------------------------------------
       X120=U1(1)-U2(1)
       Y120=U1(2)-U2(2)
       X12 =V1(1)-V2(1)
       Y12 =V1(2)-V2(2)
       SS0=SQRT(X120**2+Y120**2)
       SS=SQRT(X12**2+Y12**2)
       COS12=(X120*X12+Y120*Y12)/SS0/SS
       COS12=ABS(COS12)
       ALPH12=ARCOS(COS12)
C-----------------------------------------
        PV1X=V1(3)+V1(5)
        PV1Y=V1(4)+V1(6)
        PV2X=V2(3)+V2(5)
        PV2Y=V2(4)+V2(6)
C
       SIGV1=V1(1)*PV1X+V1(2)*PV1Y
       SIGV2=V2(1)*PV2X+V2(2)*PV2Y
C
       R1STI=SQRT(VTRK(1,I)**2+VTRK(2,I)**2)
       R1STJ=SQRT(VTRK(1,J)**2+VTRK(2,J)**2)
       R1ST=AMIN1(R1STI,R1STJ)
C
       VO1=SQRT(V1(1)**2+V1(2)**2)
       VO2=SQRT(V2(1)**2+V2(2)**2)
C
C
      IF(SIGV1.GE.0. .OR. SIGV2.GE.0) GO TO 200
      IF(VO1.GT.VO2) GO TO 110
      IF(VO1.LT.10.) GO TO 1000
      GO TO 3001
 110  IF(VO2.LT.10.) GO TO 2000
      GO TO 3002
C
 200  IF(SIGV1.LE.0. .OR. SIGV2.GE.0) GO TO 250
      IF(VO2.GT.20.) GO TO 210
      IF(VO1.LT.R1ST) GO TO 1000
      IF(VO1.GT.R1ST) GO TO 2000
 210  CONTINUE
      IF(VO1.LE.R1ST) GO TO 1000
      GO TO 3003
C
 250  IF(SIGV2.LE.0. .OR. SIGV1.GE.0) GO TO 300
      IF(VO1.GT.20.) GO TO 260
      IF(VO2.LT.R1ST) GO TO 2000
      IF(VO2.GT.R1ST) GO TO 1000
 260  CONTINUE
      IF(VO2.LE.R1ST) GO TO 2000
      GO TO 3004
C
 300  IF(SIGV1.LE.0. .OR. SIGV1.LE.0) GO TO 400
      IF(VO1.GE.VO2) GO TO 350
      IF(VO1.LE.R1ST) GO TO 1000
      GO TO 3005
 350  IF(VO2.GE.VO1) GO TO 400
      IF(VO2.LE.R1ST) GO TO 2000
      GO TO 3006
C
 400  IF(VO1.EQ.0.) GO TO 1000
      IF(VO2.EQ.0.) GO TO 2000
      GO TO 3007
C=== V1-QUE
 1000 DO 1100 K=1,6
      V(K)=V1(K)
 1100 CONTINUE
      VO=VO1
      SIGV=SIGV1
      GO TO 5000
C=== V2-QUE
 2000 DO 2100 K=1,6
      V(K)=V2(K)
 2100 CONTINUE
      VO=VO2
      SIGV=SIGV2
      GO TO 5000
C=== JUNK-VRETEX QUE
 3001 KFLAG=11
      RETURN
 3002 KFLAG=12
      RETURN
 3003 KFLAG=13
      RETURN
 3004 KFLAG=14
      RETURN
 3005 KFLAG=15
      RETURN
 3006 KFLAG=16
      RETURN
 3007 KFLAG=17
      RETURN
 4000 KFLAG=100
      RETURN
 6001 KFLAG=201
C---------------------------- 29/04/1980 ------- BY PASS ---------------
C     DO 9998 LLL=1,6
C     V(LLL)=VBY(LLL)
C9998 CONTINUE
C-----------------------------------------------------------------------
      CHI2=0.0
      CHI1=0.0
      RETURN
 6002 KFLAG=202
      RETURN
 6003 KFLAG=203
      RETURN
 6004 KFLAG=204
      RETURN
 6005 KFLAG=205
      RETURN
 6006 KFLAG=206
      RETURN
 6000 KFLAG=200
      RETURN
C=== SARANARU VERTEX-IBIRI
 5000 KFLAG=0
C
      UX=U1(1)-U2(1)
      UY=U1(2)-U2(2)
      UR=SQRT(UX**2+UY**2)
      UX=UX/UR
      UY=UY/UR
      VX=V1(1)-V2(1)
      VY=V1(2)-V2(2)
      VR=SQRT(VX**2+VY**2)
      VX=VX/VR
      VY=VY/VR
      SINUV=ABS(UX*VY-UY*VX)
      PHUV =ARSIN(SINUV)
C---------------------------- 29/04/1980 ------- BY PASS ---------------
      DO 9997 LLL=1,6
      V(LLL)=VBY(LLL)
 9997 CONTINUE
C-----------------------------------------------------------------------
      IF(VO.GT.600.) KFLAG=1
      DVL=DVL0
      D=D0
      RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE XYVRTX(I,J,V,DVL,D,JFLAG,IFLAG)
C-----------------------------------------------------------------------
C
C     S.KOMAMIYA      08.03.1980    12:30
C     MODIFIED        10.03.1980    01:30
C     MODIFIED        17.07.1980    23:30
C     SUBROUTINE TO CALCULATE VERTEX POSITION OF TWO TRACKS
C
C    IFLAG = 0     : NORMAL TWO INTERSECTION POINTS
C          = 1     : ONLY ONE INTERSECTION POINT
C          = 10    : TWO CIRCLES DO NOT INTERSECT
C
C    JFLAG = 0     : NORMAL END
C          = 1     : MOMENTUM DIRECTION AT VERTEX IS INCONSISTENT
C          = 10    : VERTEX IS TOO FAR FROM THE ORIGIN
C          = 100   : TWO PARTICLES :I,J HAVE SAME SIGN OF CHARGE
C
C
C    COPIED FROM F22KOM.KS(XYVRT6)     27.11.1985
C
      COMMON/VTR/VTRK(20,100)
      DIMENSION KTRK(20,100)
      EQUIVALENCE (VTRK(1,1),KTRK(1,1))
C
      DIMENSION V1(6),V2(6),V(6),DIST(2)
C===== INITIALIZATION
      DO 1 K=1,6
         V(K)=0.
 1       CONTINUE
         JFLAG=-1000
C=====
        AI=VTRK(12,I)
        BI=VTRK(13,I)
        RI=VTRK(10,I)
        AJ=VTRK(12,J)
        BJ=VTRK(13,J)
        RJ=VTRK(10,J)
C
C A,B,R IS X,Y OF CENTER OF CURVATURE AND RADIUS OF CURVATURE
C RADIUS OF CURVATURE IS SIGNED, USED TO REJECT EQUAL SIGN COMBINATIONS
C
       IF(RI*RJ.GT.0.) GO TO 4000
C
       CALL TWOCIR(AI,BI,RI,AJ,BJ,RJ,V1,V2,DIST,IFLAG)
       IF(IFLAG.NE.0) RETURN
        PV1X=V1(3)+V1(5)
        PV1Y=V1(4)+V1(6)
        PV2X=V2(3)+V2(5)
        PV2Y=V2(4)+V2(6)
C
       SIGV1=V1(1)*PV1X+V1(2)*PV1Y
       SIGV2=V2(1)*PV2X+V2(2)*PV2Y
C
       R1STI=SQRT(VTRK(1,I)**2+VTRK(2,I)**2)
       R1STJ=SQRT(VTRK(1,J)**2+VTRK(2,J)**2)
       R1ST=AMIN1(R1STI,R1STJ)
C
       VO1=SQRT(V1(1)**2+V1(2)**2)
       VO2=SQRT(V2(1)**2+V2(2)**2)
C
C
      IF(SIGV1.GE.0. .OR. SIGV2.GE.0) GO TO 200
      IF(VO1.GT.VO2) GO TO 110
      IF(VO1.LT.10.) GO TO 1000
      GO TO 3001
 110  IF(VO2.LT.10.) GO TO 2000
      GO TO 3002
C
 200  IF(SIGV1.LE.0. .OR. SIGV2.GE.0) GO TO 250
C--------------------------------------------------- 25/12/1980
C     IF(VO1.GT.R1STI .OR. VO1.GT.R1STJ) GO TO 1000
C     GO TO 3101
      GO TO 1000
C
 250  IF(SIGV2.LE.0. .OR. SIGV1.GE.0) GO TO 300
C--------------------------------------------------- 25/12/1980
C     IF(VO2.GT.R1STI .OR. VO2.GT.R1STJ) GO TO 2000
C     GO TO 3102
      GO TO 2000
C
 300  IF(SIGV1.LE.0. .OR. SIGV2.LE.0) GO TO 400
      IF(VO1.GT.VO2) GO TO 350
C     IF(VO2.LT.R1STI .OR. VO2.LT.R1STJ) GO TO 2000
C     THE UPPER LINE IS CHANGED TO THE LOWER LINE       25/12/1980
      IF(VO2.LT.R1STI .AND. VO2.LT.R1STJ) GO TO 2000
CCCCC IF(VO1.GT.R1STI .AND. VO1.GT.R1STJ) GO TO 400
      GO TO 1000
C350  IF(VO1.LT.R1STI .OR. VO1.LT.R1STJ) GO TO 1000
C     THE UPPER LINE IS CHANGED TO THE LOWER LINE       25/12/1980
 350  IF(VO1.LT.R1STI .AND. VO1.LT.R1STJ) GO TO 1000
CCCCC IF(VO2.GT.R1STI .AND. VO2.GT.R1STJ) GO TO 400
      GO TO 2000
C
 400  IF(VO1.EQ.0.) GO TO 1000
      IF(VO2.EQ.0.) GO TO 2000
      GO TO 3007
C=== V1-QUE
 1000 DO 1100 K=1,6
      V(K)=V1(K)
 1100 CONTINUE
      VO=VO1
      SIGV=SIGV1
      GO TO 5000
C=== V2-QUE
 2000 DO 2100 K=1,6
      V(K)=V2(K)
 2100 CONTINUE
      VO=VO2
      SIGV=SIGV2
      GO TO 5000
C=== JUNK-VERTEX QUE
 3001 JFLAG=11
      RETURN
 3002 JFLAG=12
      RETURN
 3007 JFLAG=17
      RETURN
C3101 JFLAG=101
C     RETURN
C3102 JFLAG=102
C     RETURN
 4000 JFLAG=100
      RETURN
C=== SARANARU VERTEX-IBIRI
 5000 JFLAG=0
      IF(VO.GT.600.) JFLAG=1
      DVL=SQRT((V(1)-DIST(1))**2+(V(2)-DIST(2))**2)
      DVL=DVL*SIGN(1.0,SIGV)
      D=SQRT(DIST(1)**2+DIST(2)**2)
C     IF(VO.GT.R1STI .AND. VO.GT.R1STJ) JFLAG=500
C-----------------------------------------------------------------------
C      WRITE(6,9000) IFLAG,JFLAG,R1STI,R1STJ,VO,VO1,VO2
C9000  FORMAT(' FLAG(I,J)=',2I5,'   R1ST(I,J)=',2F10.3,'    VO=',3F10.3)
C-----------------------------------------------------------------------
      RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE ZRVOPT(NPATR,I,J,V,DZIOPT,DZJOPT,CHI1,CHI2,LFLAG,ZPOS)
C-----------------------------------------------------------------------
C
C     S.KOMAMIYA      21/03/1980    18:10
C     MODIFIED        22/03/1980    22:30
C     MODIFIED        08/04/1980    18:30
C     SUBROUTINE TO OPTIMIZE COSTH
C     ---------- THETA IBIRI -----------
C
C    LFLAG = 0     : NORMAL END
C          < 0     : ABNORMAL END
C
C
C
C     COPIED FROM F22KOM.KS(ZRTST)     27.11.1985
C     MODIFIED TO CALCULATE Z-COORDINATE OF SECONDARY VERTEX  2.12.85
C     LAST MOD. 28.04.86 LOWER HIT NUMBER LIMIT CHANGED 20-->12
C                        AS MORE SUITABLE FOR GAMMA GAMMA EVENTS.
C
C
C             LAST MOD:  26.05.86 RESET CHI2 TO 3600.
C
C
      COMMON/BCS/ IDATA(35000)
      DIMENSION ADATA(35000)
      INTEGER *2 HDATA(70000)
      EQUIVALENCE (IDATA(1),ADATA(1)),(HDATA(1),IDATA(1))
C
#include "cgeo1.for"
C
      COMMON/VTR/VTRK(20,100)
      DIMENSION KTRK(20,100)
      EQUIVALENCE (VTRK(1,1),KTRK(1,1))
C
      DIMENSION V(6)
      DIMENSION RI(100) ,ZI(100) ,RJ(100) ,ZJ(100)
C     DIMENSION RIM(100),ZIM(100),RJM(100),ZJM(100)
      DIMENSION IZFT(100) ,JZFT(100) ,FZI(100) ,FZJ(100)
C     DIMENSION IZFTM(100),JZFTM(100),FZIM(100),FZJM(100)
      DIMENSION A(3,3),B(3),X(4)
      COMMON/MAG/BC
C     DATA RMAT/152.4/        IS NOT USED IN THIS ROUTINE
C
C------------------------------------------------
       LFLAG=-1000
       R0=SQRT(V(1)**2+V(2)**2)
C
       DZIOPT=0.
       DZJOPT=0.
C
      DO 50 LL=1,100
       ZI(LL)=0.
       RI(LL)=0.
       FZI(LL)=0.0
       IZFT(LL)=0
       ZJ(LL)=0.
       RJ(LL)=0.
       FZJ(LL)=0.0
       JZFT(LL)=0
 50   CONTINUE
C
      IHTREJ=0
      JHTREJ=0
      IERI=0
      IERJ=0
      CHMAX=0.0
      CHIMAX=0.0
      CHJMAX=0.0
C
C
C===== FILL R-Z HIT MAP OF I-TH TRACK
       CALL RFDRPZ(NPATR,I,IERI)
       IF(IERI) 1001,100,1001
 100   CALL BLOC(NRFWK,'RFWK',1,&1002)
       ILENG=IDATA(NRFWK)
       NHITI=ILENG/4
C
       NHITIB=0
       DO 11 KI0=1,NHITI
       KI4=(KI0-1)*4
       RI(KI0)=ADATA(NRFWK+KI4+1)
       IF(RI(KI0) .LT. R0)  NHITIB=NHITIB+1
       ZI(KI0)=ADATA(NRFWK+KI4+3)
       IZFT(KI0)=HDATA((NRFWK+KI4)*2+7)
 11    CONTINUE
C
C===== FILL R-Z HIT MAP OF J-TH TRACK
      CALL RFDRPZ(NPATR,J,IERJ)
        IF(IERJ) 1003,200,1003
 200  CALL BLOC(NRFWK,'RFWK',1,&1004)
        JLENG=IDATA(NRFWK)
        NHITJ=JLENG/4
C
      NHITJB=0
      DO 21 KJ0=1,NHITJ
       KJ4=(KJ0-1)*4
       RJ(KJ0)=ADATA(NRFWK+KJ4+1)
       IF(RJ(KJ0) .LT. R0)  NHITJB=NHITJB+1
       ZJ(KJ0)=ADATA(NRFWK+KJ4+3)
       JZFT(KJ0)=HDATA((NRFWK+KJ4)*2+7)
 21   CONTINUE
C
       NHITB=NHITIB+NHITJB
C      IF(NHITB.GE.1) GO TO 1010
       IF(NHITIB.GT.2  .OR. NHITJB.GT.2) LFLAG=500
C
       CHI1=0.0
       CHI10=0.0
       DZI1=0.0
       DZJ1=0.0
C
C
C
      DO 1100 NN=1,50
        SI=0.
        SRI=0.
        SZI=0.
        SSRI=0.
        SSZI=0.
        SRZI=0.
C
C
      DO 10 KI1=1,NHITI
       CHI10=CHI1
       IF(IZFT(KI1).NE.0) GO TO 10
       SI=SI+1.
       SRI=SRI+RI(KI1)
       SZI=SZI+ZI(KI1)
       SSRI=SSRI+RI(KI1)**2
       SSZI=SSZI+ZI(KI1)**2
       SRZI=SRZI+RI(KI1)*ZI(KI1)
 10   CONTINUE
C
C
        SJ=0.
        SRJ=0.
        SZJ=0.
        SSRJ=0.
        SSZJ=0.
        SRZJ=0.
C
C
      DO 20 KJ1=1,NHITJ
       IF(JZFT(KJ1).NE.0) GO TO 20
       SJ=SJ+1.
       SRJ=SRJ+RJ(KJ1)
       SZJ=SZJ+ZJ(KJ1)
       SSRJ=SSRJ+RJ(KJ1)**2
       SSZJ=SSZJ+ZJ(KJ1)**2
       SRZJ=SRZJ+RJ(KJ1)*ZJ(KJ1)
 20   CONTINUE
C                           UNHANGED!!!!!!!!!!!
C
      A(1,1)=SSRI+SJ*R0
      A(1,2)=SRJ*R0-SJ*R0**2
      A(1,3)=SJ*R0
      A(2,1)=SRJ*R0-SJ*R0**2
      A(2,2)=SSRJ-2.*SRJ*R0+SJ*R0**2
      A(2,3)=SRJ-SJ*R0
      A(3,1)=SRI+SJ*R0
      A(3,2)=SRJ-SJ*R0
      A(3,3)=SI+SJ
C
C
C
      B(1)=SRZI+SZJ*R0
      B(2)=SRZJ-SZJ*R0
      B(3)=SZI+SZJ
C
C
C
      CALL SOL(A,B,X,LFLAG1)
      IF(LFLAG1) 1005,300,1005
 300  IF(X(1).NE.0.) GO TO 1
      DZI=0.
      GO TO 2
 1    CONTINUE
      DZI=X(1)/SQRT(1.+X(1)**2)
 2    CONTINUE
      IF(X(2).NE.0.) GO TO 3
      DZJ=0.
      GO TO 4
 3    CONTINUE
      DZJ=X(2)/SQRT(1.+X(2)**2)
 4    CONTINUE
C
      X(4)=X(1)*R0-X(2)*R0+X(3)
C
C
C
      CHI1=X(1)**2*SSRI+X(3)**2*SI+SSZI
     &    +2.*(X(1)*X(3)*SRI-X(3)*SZI-X(1)*SRZI)
     &    +X(2)**2*SSRJ+X(4)**2*SJ+SSZJ
     &    +2.*(X(2)*X(4)*SRJ-X(4)*SZJ-X(2)*SRZJ)
      SIJ=SI+SJ-3.
      CHI1=CHI1/SIJ
      IF(NN.EQ.1) CHIMIN=CHI1
      IF(CHI1.GT.CHIMIN) GO TO 25
      CHIMIN=CHI1
      DZIOPT=DZI
      DZJOPT=DZJ
 25   CONTINUE
C---------------------------- 08/04/1980 -------------------------------
C
      DO 18 KI2=1,NHITI
      FZI(KI2)=0.
 18   CONTINUE
C
       CHIMAX=0.0
       KIMAX=0
      DO 30 KI=1,NHITI
       IF(IZFT(KI).NE.0) GO TO 16
       FZI(KI)=(ZI(KI)-X(1)*RI(KI)-X(3))**2
 16    CONTINUE
C-----------------------------------------------------------------------
C      WRITE(6,9100)KI,R0,RI(KI),ZI(KI),IZFT(KI),FZI(KI),KIMAX
C9100  FORMAT(' KI=',I3,'   R0=',F10.3,'   RI=',F10.5,'    ZI=',F10.3,
C    &      '     IZFT=',I5,'     FZI=',F10.3,'  KIMAX=',I3)
C-----------------------------------------------------------------------
       IF(CHIMAX.GE.FZI(KI)) GO TO 30
       KIMAX=KI
       CHIMAX=FZI(KI)
 30   CONTINUE
C
C
      DO 19 KJ2=1,NHITJ
      FZJ(KJ2)=0.
 19   CONTINUE
C
       CHJMAX=0.0
       KJMAX=0
      DO 40 KJ=1,NHITJ
       IF(JZFT(KJ).NE.0) GO TO 17
       FZJ(KJ)=(ZJ(KJ)-X(2)*RJ(KJ)-X(4))**2
 17    CONTINUE
C-----------------------------------------------------------------------
C      WRITE(6,9200)KJ,R0,RJ(KJ),ZJ(KJ),JZFT(KJ),FZJ(KJ),KJMAX
C9200  FORMAT(' KJ=',I3,'   R0=',F10.3,'   RJ=',F10.5,'    ZJ=',F10.3,
C    &      '     JZFT=',I5,'     FZJ=',F10.3,'  KJMAX=',I3)
C-----------------------------------------------------------------------
       IF(CHJMAX.GT.FZJ(KJ)) GO TO 40
       KJMAX=KJ
       CHJMAX=FZJ(KJ)
 40   CONTINUE
C
C-----------------------------------------------------------------------
C     WRITE(6,9000)I,J,SIJ,CHI1,CHI10,DZI,DZJ,DZIOPT,DZJOPT,CHMAX,CHIMIN
C9000 FORMAT(' (I,J)=',2I5,' SIJ=',F5.1,
C    &      ' CHI1(',2F10.2,') DZ=((',2F6.3,' ))',
C    &      ' DZOPT=(',2F6.3,') CHMAX,CHIMIN=',2F10.1/)
C-----------------------------------------------------------------------
      IF(CHIMAX-CHJMAX) 23,22,22
 22   IZFT(KIMAX)=100
      IHTREJ=IHTREJ+1
      GO TO 24
 23   JZFT(KJMAX)=100
      JHTREJ=JHTREJ+1
 24   CONTINUE
      IHTREM=NHITI-IHTREJ
      JHTREM=NHITJ-JHTREJ
      IF(IHTREM.LE.20 .OR. JHTREM.LE.20) GO TO 1200
      CHMAX=AMAX1(CHIMAX,CHJMAX)
      IF(CHMAX.LT.3600.0) GO TO 1200
 1100 CONTINUE
 1200 CONTINUE
C
C-----------------------------------------------------------------------
      PTI=ABS(VTRK(10,I))*BC
      PTJ=ABS(VTRK(10,J))*BC
C
      DZI0=VTRK(6,I)
      DZJ0=VTRK(6,J)
C
      PI=PTI/SQRT(1.-DZI0**2)
      PJ=PTJ/SQRT(1.-DZJ0**2)
C
      STHI=SCATT(PI,DZI0)
      STHJ=SCATT(PJ,DZJ0)
C
      THI=ARCOS(DZI)
      THJ=ARCOS(DZJ)
      THI0=ARCOS(DZI0)
      THJ0=ARCOS(DZJ0)
C
      CHI2=((THI-THI0)/STHI)**2+((THJ-THJ0)/STHJ)**2
C     LFLAG=0
      IF(LFLAG.NE.500)  LFLAG=0
C-----------------------------------------------------------------------
C     WRITE(6,9300) DZI0,DZJ0,DZI,DZJ,DZIOPT,DZJOPT,SIJ,PI,PJ,
C    &              THI0,THJ0,THI,THJ,CHI1,
C    &              CHI2,CHMAX,(X(LL),LL=1,4)
C9300 FORMAT(' ########## DZ0=(',2F7.3,')  DZ=(',2F7.3,')  ',
C    &      '  DZ1=(',2F7.3,')    SIJ=',F5.1/
C    &      '  PI,PJ=',2F7.3,' TH0=',2F8.3,' TH=',2F8.3/
C    &      '  CHI1,CHI2=',2F10.4,'    CHMAX=',F10.3,' X(4)',4F9.3/)
C-----------------------------------------------------------------------
C
C1010 LFLAG=500
C-----------------------------------------------------------------------
C     IF(LFLAG.NE.500) GO TO 1011
C     WRITE(6,9400) I,J,DZI0,DZJ0,DZI,DZJ,DZIOPT,DZJOPT,SIJ,PI,PJ,
C    &              THI0,THJ0,THI,THJ,CHI1,
C    &              CHIMIN,CHMAX,(X(LL),LL=1,4),NHITIB,NHITJB,LFLAG
C9400 FORMAT(' (I,J)=',2I5,'  DZ0=(',2F6.3,') DZ=(',2F6.3,') ',
C    &      ' DZ1=(',2F6.3,') SIJ=',F5.1/
C    &      '  PI,PJ=',2F7.3,' TH0=',2F8.3,' TH=',2F8.3/
C    &      '  CHI1,CHIMIN=',2F10.4,'    CHMAX=',F10.3,' X(4)',4F9.3,
C    &      '  NHITIB,NHITJB=',2I3,'  LFLAG=',I4/)
C1011  CONTINUE
C-----------------------------------------------------------------------
C   CALCULATE Z-COORDINATE OF THE SECONDARY VERTEX
C
      ZPOS = X(1)*R0 + X(3)
C
      RETURN
C
C=== JUNK-VRETEX QUE
 1001 LFLAG=10+IERI
      RETURN
 1002 LFLAG=20
      RETURN
 1003 LFLAG=30+IERJ
      RETURN
 1004 LFLAG=40
      RETURN
 1005 LFLAG=50
      RETURN
C  LFLAG=16 IS NOT USED
C1006 LFLAG=16
C     RETURN
C     RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE BKKOKS
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
C WRITE RESULT OF KOMAKS OUT IN A BOS BANK   "KOKS"
C
C     LAST CHANGE 27.02.1986  TAKE OUT COMMONS CGRAPH AND CHEADR
C  +++++++++++++++++++++++++++++++++++++++++++++++
C     COMMON /CHEADR/ HEAD(108)
C     EQUIVALENCE (HEAD(18),HRUN),(HEAD(19),HEVENT)
C%MACRO 'F11GOD.PATRECSR(CGRAPH)'
C  +++++++++++++++++++++++++++++++++++++++++++++++
C
#include "cdata.for"
C
      COMMON /CKOMAK/NMAS,PCOMB1(4,50),PCOMB2(4,50),HTR1(50),HTR2(50),
     $               VMAS(50),DMAS(50),DVLK0(50),DK0(50),XYZK0(3,50),
     $         STDEV,ARLIM,IZRFIT,MNHIT,PCUTT,DVLMIN,DK0MAX,IEE3FL
C
      DATA IERK /0/, IVERSK/1/
C//////////////////////////////////////////////////////////////////////
C
C.....   DELETE BANK KOKS IF ALREADY EXISTING
C
      IPHT = IDATA(IBLN('KOKS'))
      IF(IPHT.LE.0) GO TO 230
      NBNK = IDATA(IPHT-2)
      CALL BDLS('KOKS',NBNK)
      CALL BGAR(DUMK)
C
C @@@@@@@   RESULT BANK   K O K S  @@@@@@@
C
230   NWRES = 8
      IF(NMAS.LE.0) GO TO 600
      NWRES = NWRES + NMAS*16
600   CONTINUE
      IPPATR = IDATA(IBLN('PATR'))
      NBNK = IDATA(IPPATR-2)
      CALL CCRE(IPHT,'KOKS',NBNK,NWRES,IERR)
      IF(IERR.NE.0) GO TO 9998
      CALL BSAW(1,'KOKS')
      IPHT2 = 2*IPHT
      HDATA(IPHT2+1) = IVERSK
      HDATA(IPHT2+2) = NMAS
      ADATA(IPHT+2) = STDEV
      ADATA(IPHT+3) = ARLIM
      ADATA(IPHT+4) = PCUTT
      ADATA(IPHT+5) = DVLMIN
      ADATA(IPHT+6) = DK0MAX
      HDATA(IPHT2+13) = IZRFIT
      HDATA(IPHT2+14) = MNHIT
      HDATA(IPHT2+15) = IEE3FL
      IF(NMAS.LE.0) GO TO 8000
C
      ITRX = 7
      DO 9980  IMA = 1,NMAS
      ITRX = ITRX + 1
9980  ADATA(IPHT+ITRX) = VMAS(IMA)
      DO 9981  IMA = 1,NMAS
      ITRX = ITRX + 1
9981  ADATA(IPHT+ITRX) = DMAS(IMA)
      DO 9979  IMA = 1,NMAS
      ITRX = ITRX + 1
9979  ADATA(IPHT+ITRX) = DVLK0(IMA)
      DO 9978  IMA = 1,NMAS
      ITRX = ITRX + 1
9978  ADATA(IPHT+ITRX) = DK0(IMA)
C
      DO 9982  IMA = 1,NMAS
      DO 9983  I = 1,4
      ITRX = ITRX + 1
9983  ADATA(IPHT+ITRX) = PCOMB1(I,IMA)
9982  CONTINUE
C
      DO 9984  IMA = 1,NMAS
      DO 9985  I = 1,4
      ITRX = ITRX + 1
9985  ADATA(IPHT+ITRX) = PCOMB2(I,IMA)
9984  CONTINUE
C
      DO 9986  IMA = 1,NMAS
      DO 9987  I = 1,3
      ITRX = ITRX + 1
9987  ADATA(IPHT+ITRX) = XYZK0(I,IMA)
9986  CONTINUE
C
      ITRX2 = 2*ITRX
C
      DO 9988  IHT = 1,NMAS
      ITRX2 = ITRX2 + 1
9988  HDATA(IPHT2+ITRX2) = HTR1(IHT)
      DO 9989  IHT = 1,NMAS
      ITRX2 = ITRX2 + 1
9989  HDATA(IPHT2+ITRX2) = HTR2(IHT)
C
C                              END BANK
C
      GO TO 8000
C
9998  CONTINUE
      IERK = IERK + 1
      IF(IERK.LT.11) WRITE(6,7666) IERR,NBNK
7666  FORMAT(' ####   WARNING ######      ERROR ',I4,
     $  ' IN CREATING BANK KOKS WITH NUMBER ',I5)
C
8000  CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE KOKSRE(IERR)
C-----------------------------------------------------------------------
C     UNPACKS THE KOKS BANK INTO THE CKOMAKS COMMON.
C     IERR = 0 FOR NORMAL RETURN
C     IERR = 1 MEANS KOKS BANK DOES NOT EXIST
C
C             WRITTEN 26.02.86
C          LAST MOD.  15.04.86 SECOUND  ARGUMENT (IVERSK) TAKEN OUT
C
      IMPLICIT INTEGER*2 (H)
      COMMON / CKOMAK /NMAS,PCOMB1(4,50),PCOMB2(4,50),HTR1(50),HTR2(50),
     +              VMAS(50),DMAS(50),DVLK0(50),DK0(50),XYZK0(3,50),
     +              STDEV,ARLIM,IZRFIT,MNHIT,PCUTT,DVLMIN,DK0MAX,IEE3FL
      COMMON / BCS    / IDATA(40000)
C
      INTEGER*2 HDATA(80000)
      REAL ADATA(40000)
      EQUIVALENCE (IDATA(1),HDATA(1),ADATA(1))
C
      IERR = 0
C
C                             GET POINTER TO KOKS BANK
C
      IPKOKS = IDATA(IBLN('KOKS'))
      IF( IPKOKS .LE. 0 ) IERR = 1
      IF( IERR   .EQ. 1 ) RETURN
      IPKOK2 = IPKOKS * 2
C
C                               BEGIN FILLING THE COMMON
C
C     IVERSK = HDATA( IPKOK2 + 1 )
      IVERSK = 2
      NMAS   = HDATA( IPKOK2 + 2 )
      STDEV  = ADATA( IPKOKS + 2 )
      ARLIM  = ADATA( IPKOKS + 3 )
      PCUTT  = ADATA( IPKOKS + 4 )
      DVLMIN = ADATA( IPKOKS + 5 )
      DK0MAX = ADATA( IPKOKS + 6 )
      IZRFIT = HDATA( IPKOK2 + 13)
      MNHIT  = HDATA( IPKOK2 + 14)
      IEE3FL = HDATA( IPKOK2 + 15)
C
C                             IF NO CANDIDATES FOUND THEN RETURN
C
      IF ( NMAS .LE. 0) RETURN
      NSTART  = 8
      III = IPKOKS + NSTART
C
C                             FILL THE CANDIDATE INFORMATION.
C
      DO 10  IMA = 1,NMAS
         III = III + 1
         VMAS(IMA) = ADATA( III )
10    CONTINUE
C
      DO 20    IMA = 1,NMAS
        III = III + 1
        DMAS(IMA) = ADATA( III )
20    CONTINUE
C
      DO 30    IMA = 1,NMAS
         III = III + 1
         DVLK0(IMA) = ADATA( III )
30    CONTINUE
C
      DO 40    IMA = 1,NMAS
         III = III + 1
         DK0(IMA) = ADATA( III )
40    CONTINUE
C
      DO 50    IMA = 1,NMAS
         DO 51    I = 1,4
            III = III + 1
            PCOMB1(I,IMA) = ADATA( III )
51       CONTINUE
50    CONTINUE
C
      DO 60    IMA = 1,NMAS
         DO 61    I = 1,4
            III = III + 1
            PCOMB2(I,IMA) = ADATA( III )
61       CONTINUE
60    CONTINUE
C
      DO 70    IMA = 1,NMAS
         DO 71    I = 1,3
            III = III + 1
            XYZK0(I,IMA) = ADATA( III )
71       CONTINUE
70    CONTINUE
C
      III2 = 2*III
C
      DO 80    IHT = 1,NMAS
         III2 = III2 + 1
         HTR1(IHT) = HDATA( III2 )
80    CONTINUE
C
      DO 90    IHT = 1,NMAS
         III2 = III2 + 1
         HTR2(IHT) = HDATA( III2 )
90    CONTINUE
C
      RETURN
      END

C   07/06/96 606071824  MEMBER NAME  BMLT     (S4)          FORTG1
      SUBROUTINE BMLT(NL,LIST)
C     BOS SUBPROGRAM =0.4=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
C
      INTEGER LIST(1)
C
      IF(NL.LT.0) GOTO 20
      IN=NL
      IF(NL.EQ.0) GOTO 100
      DO 10 I=1,IN
   10 IW(NLST+I)=IBLN(LIST(I))
      GOTO 100
C
   20 IN=0
      IF(NS.EQ.0) GOTO 100
      MARK=LIST(1)
      DO 30 I=1,NS
      IF(MARK.EQ.0) GOTO 25
      IF(IW(IMLST+I).EQ.0) GOTO 30
   25 IN=IN+1
      IW(NLST+IN)=IW(ISLST+I)
   30 CONTINUE
  100 RETURN
      END

C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
C  NOTE (JEO 23.3.97) THAT ORIGINAL MVERTEX1 HAS SOME DIFFERENCE
C    SEE F22KLE.VERTEX.S  LIBRARY
      DIMENSION IT(2),IV(8)     ! PMF 26/08/99 IV(2) changed to IV(8)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))

C   17/01/88 802041825  MEMBER NAME  TPSOPT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPSOPT( CTPOPT, COPT, IERROR )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery       17/01/88:  Store TP options
C
C
C
C     Routine to store TP options for option group COPT.
C     Special records (COPT = 'SPECIAL ') are not stored here.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     CTPOPT    In   CHAR*20      Array of options
C     COPT      In    CHAR*8      Option group name
C                                 = 'SPECIAL ' if special option record
C     IERROR    Out      I*4      Error code variable
C                                  11 :  Duplicate option record
C                                  12 :  Option keyword not in TABLE ?
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      PARAMETER  ( NOPT = 20 )

      INTEGER  IERROR

#include "tables.for"

      LOGICAL  DONE(NOPTG)

      CHARACTER   COPT*8, CTPOPT( NOPT )*20

      SAVE  DONE

      DATA DONE / NOPTG* .FALSE. /

C------------------  C O D E  ------------------------------------------

      IERROR = 0

      IF( COPT .EQ. 'SPECIAL ' ) RETURN


      DO  30  I = 1,NOG

        IF( COPT .EQ. NTABLE(I) ) THEN

C                            First check that this group has not already
C                            appeared on a previous input record.

          IF( .NOT. DONE(I) ) THEN

            DONE(I) =.TRUE.

            DO  20  J = 1,NOPT
              IF( CTPOPT(J) .EQ. ' ' ) RETURN
              DO  10  K = 1,NOK
                IF( CTPOPT(J) .EQ. OTABLE(K) ) THEN
                  ATABLE(I,K) = .TRUE.
                  GO TO 20
                ENDIF
  10          CONTINUE

C                            Should never get here

              IERROR = 12
              CALL TPSOEA( 81, IERROR )
              CALL TPERRH
              RETURN

  20        CONTINUE
          ELSE

C                            Duplicate option record. Set error array

            IERROR = 11
            CALL TPSOEA( 81, IERROR )

          ENDIF

C                            Record processed so end loop now

          RETURN

        ENDIF

  30  CONTINUE

C                            Should never get here

      IERROR = 12
      CALL TPSOEA( 81, IERROR )
      CALL TPERRH

      RETURN
      END

C   26/04/84 406081534  MEMBER NAME  DRAWLG   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWLG( IVIEW )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY    26/04/84 :  DRAW LEAD GLASS SHOWER COUNTERS
C
C  LAST MOD:   C. BOWDERY     8/06/84 :  NEW COMMAND NUMBERS
C
C     DRAW THE LG SYSTEM FOR THE VIEW IVIEW.
C       IVIEW = 1   : NOT USED
C       IVIEW = 2   : RZ VIEWS
C       IVIEW = 3   : ROLLED OUT VIEW
C       IVIEW = 4   : PERSPECTIVE VIEW OF LG
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CHEADR / HEAD(108)
C
#include "cgeo1.for"
#include "cgeo2.for"
#include "cgraph.for"
C
      DIMENSION AXD(2)
C
C------------------  C O D E  ------------------------------------------
C
      GO TO ( 1 , 2 , 3 , 4 ) , IVIEW
C
C                            R PHI VIEW DRAWN BY JADISP
C
   1  RETURN
C
C                            Z VIEWS
C
C                            DRAW BARREL BLOCKS
C
   2  CALL DRAMOV(ZLGMI, RLG,  ZLGPL, RLG,  0)
      CALL DRAMOV(ZLGMI,-RLG,  ZLGPL,-RLG,  0)
      CALL DRAMOV(ZLGMI, OUTR2,ZLGPL, OUTR2,0)
      CALL DRAMOV(ZLGMI,-OUTR2,ZLGPL,-OUTR2,0)
      PBW = ZLGMI - BLZ
      DO  21  I = 1,33
        PBW = PBW + BLZ
        CALL DRAMOV(PBW, RLG,PBW, OUTR2,0)
        CALL DRAMOV(PBW,-RLG,PBW,-OUTR2,0)
  21  CONTINUE
C
C                            DRAW ENDCAP BLOCKS
C
      YL1   = -6.*BLXY
      HSIDE =  0
   29 CONTINUE
      XL1   = ZENDMI-DEPEND*HSIDE
      CALL DRAMOV(XL1,YL1,XL1,-YL1,0)
      XL1   = ZENDPL+DEPEND*HSIDE
      CALL DRAMOV(XL1,YL1,XL1,-YL1,0)
      HSIDE = HSIDE+1
      IF( HSIDE .LT. 2) GO TO 29
      DO  23  I = 1,13
        YL1 = (I-7)*BLXY
        CALL DRAMOV(ZENDMI,YL1,ZENDMI-DEPEND,YL1,0)
        CALL DRAMOV(ZENDPL,YL1,ZENDPL+DEPEND,YL1,0)
  23  CONTINUE
C
      RETURN
C
C                            DRAW ROLLED OUT VIEW OF BARREL AND ENDCAPS
C
C-------------- ENDCAPS ---------------------
C
   3  ADDEND = 84.0 * BLFI
      AXD(1) = ADDEND * 0.13
      AXD(2) = ADDEND * 0.87
      ADY    = 900.
      DO  31  J = 1,2
        ADX = AXD(J)
        CALL ECAP(ADX,ADY)
  31  CONTINUE
C
C                           WRITE TEXT ON ENDCAPS
C
      SH3 = 0.6*BLXY
      Y1  = ADY+BLXY
      DO  33  I = 1,2
        LABT = 101 + (I-1)*2
        X1   = AXD(I) - 0.5*BLXY
        CALL RUTEXT(LABT,X1,Y1,SH3)
  33  CONTINUE
C
      Y1   =  ADY - 0.3*BLZ
      SH3  =  0.6*BLZ
      FACT = -2.2
      DO  34  I = 1,2
        LABT = 103 + I
        IF( I .EQ. 2 ) FACT = 0.5
        DO  35  J = 1,2
          X1 = AXD(J) + FACT*BLXY
          CALL RUTEXT(LABT,X1,Y1,SH3)
  35    CONTINUE
  34  CONTINUE
C
C-------------- FORWARD DETECTOR LG SYSTEM --
C
      AXD(1) = ADDEND*.5 - 1100.
      AXD(2) = AXD(1)    + 2200.
      FC     = 1.
      IF( HEAD(18) .LT. 13000 ) GO TO 36
      AXD(1) = ADDEND*.5 -  750.
      AXD(2) = AXD(1)    + 1500.
      FC     = 2.
C
C FOR 1983-84 VERSION, MAGNIFY TAGGING APPARATUS FACTOR 2 IN RU VIEW
C
  36  LL     = 0
      IF( DSPDTL(15) ) LL = 14
      DO  37  J = 1,2
        ADX = AXD(J)
        CALL FWCAP(ADX,ADY,LL,FC,0)
  37  CONTINUE
C
C-------------- LG CYLINDER -----------------
C
      ADY = 3.*ADY + 100.
      Y1  = ADY - BLZ
      X1  = 0.
      X2  = X1 + ADDEND
      DO  38  I = 1,33
        Y1 = Y1 + BLZ
        CALL DRAMOV(X1,Y1,X2,Y1,LL)
  38  CONTINUE
      X1  = -BLFI
      Y1  = ADY
      Y2  = Y1 + 32.*BLZ
      DO  39  I = 1,85
        X1 = X1 + BLFI
        CALL DRAMOV(X1,Y1,X1,Y2,LL)
  39  CONTINUE
C
C                 WRITE TEXT ON CYLINDER MAP
C
      SH3 = 0.6 * BLZ
      Y1  = ADY - BLXY
      DO  301  I = 1,3
        LABT = 103+I
        X1   = (I-1) * (ADDEND*.5 - 1.5*BLFI)
        CALL RUTEXT(LABT,X1,Y1,SH3)
 301  CONTINUE
      X1  = -1.8 * BLFI
      DO  302  I = 1,3
        LABT = 100 + I
        Y1   = ADY + (I-1)*15.7*BLZ
        CALL RUTEXT(LABT,X1,Y1,SH3)
 302  CONTINUE
C
      RETURN
C
C                            PERSPECTIVE VIEW OF LG
C
   4  DEFIX = TWOPI / 84.0
      ZDEEP = 5800.0
      ZETMX = ZDEEP + ZLGPL
      ZETMI = ZDEEP + ZLGMI
      NECC  = ACMD
C
C                            LSTCMD = 38   IS  THE  DET COMMAND
C
      IF( LSTCMD .EQ. 38  .AND.  NECC .NE. 0 ) GO TO 45
      LLX   = 0
      IF( DSPDTL(15) ) LLX = 14
      R     = ZETMI * RLG/ZETMX
      FISX  = -DEFIX
C
C                            DRAW ROW VECTORS
C
      DO  41  IIJ = 1,84
        FISX = FISX + DEFIX
        CSFX = COS(FISX)
        SNFX = SIN(FISX)
        CALL DRAMOV(RLG*CSFX,RLG*SNFX,R*CSFX,R*SNFX,LLX)
 41   CONTINUE
      Z = ZETMX + BLZ
C
C                            DRAW POLYGONS
C
      DO  42  IIJ = 1,33
        Z = Z - BLZ
        R = Z * RLG/ZETMX
        CALL PLYGON(84,R,0.,0.,LLX)
  42  CONTINUE
      RETURN
C
C-------------- ENDCAPS ---------------------
C
  45  AXD(1) = 0.
      AXD(2) = 0.
      ADY    = 0.
      DO  47  J = 1,2
        IF( NECC .NE. J  .AND.  NECC .NE. 3 ) GO TO 47
        FACTOR = 1.
        IF( J .EQ. 2 ) FACTOR = ZETMI/ZETMX
        ADX    = AXD(J)
        CALL ECAPCY(ADX,ADY,FACTOR)
  47  CONTINUE
C
      RETURN
      END

C     USED IN LGANAL PART OF PROGRAMS
C        NO CUTS ON MAX FIRIED #CHANNELS (I.E. DIMENSION=2880)
C        CHANGE SIZE OF THE CLUSTER BANK TO 16.. 13/6/80
C        CHANGED BY Y.WATANABE ON 23/09/79. 00:30
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,
     3               MAPCL(81),  CLPRP(1280)
      INTEGER *2 HMAPCL(2,81)
      DIMENSION ICLSPR(16,80),CLSPRP(16,80), CLMPRP(1361)
      EQUIVALENCE (HMAPCL(1,1),MAPCL(1)), (CLMPRP(1),MAPCL(1))
      EQUIVALENCE (ICLSPR(1,1),CLPRP(1)),  (CLSPRP(1,1),CLPRP(1))
C

C   04/07/79 006251728  MEMBER NAME  VTXINI   (JADEGS)      FORTRAN
      SUBROUTINE VTXINI
C*800623*DITTMANN***************************************************
C*                                                                 *
C* I N I T I A L I S A T I O N   O F   X Y Z   V E R T E X   F I T *
C*                                                                 *
C*       TO BE CALLED ONCE AND BEFORE FIRST CALL TO VTXPRE, VERTEX *
C*******************************************************************
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV
C
C        MEAN VERTEX COORDINATES
      XB = 0.
      YB = 0.
      ZB = 0.
C        OUTER RADIUS OF INNER TANK WALL
      RTANK = 174.
C        OUTER DISTANCE BEAM PIPE TO TANK WALL
      DTANK = 50.
C        RADIATION LENGTH BETWEEN BEAM AND FIRST WIRE
      X0INN = 0.16
C        MEAN TRACK RESIDUAL IN XY AND ZR PLANE
      SIGX0 = 0.55
      SIGZ0 = 30.
C        ARTIFICIAL FACTOR TO ACCOUNT FOR SYSTEMATIC ERRORS
      SIGFAC = 2.0
      SIGX0 = SIGX0 * SIGFAC
      SIGZ0 = SIGZ0 * SIGFAC
C        MINIMUM NUMBER OF POINTS IN XY AND Z TRACK
      PNTMIN = 5.
C        MAXIMUM TRACK RESIDUAL IN XY AND Z (SIG<SIG1*SIGX0)
      SIG1 = 4.
C        MAXIMUM DISTANCE OF TRACKS TO AVERAGE BEAM
C        USED IN PRIMARY VERTEX SEARCH
      DISTB = 20.
C        MAXIMUM OPENING ANGLE OF COLLINEAR 2-PRONGS
      COLL2 = 0.98
C        MAXIMUM NUMBER OF ITERATIONS IN VERTEX FIT
      MITER = 7
C        CONVERGENCE PARAMETER
      DSCONV = 0.1
C        MINIMUM PROBABILITY FOR GOOD VERTEX
      PRCUT = 0.001
C        REJECT BAD TRACKS DURING VERTEX FIT (0=NO, 1=YES)
      IREJTR = 1
C        EE PAIRS: MINIMUM AND MAXIMUM MEASURED PHI DIFFERENCE (RADIAN)
      EEDPMN = -0.07
      EEDPMX =  0.8
C        EE PAIRS: MAXIMUM THETA DIFFERENCE (STD.DEV.)
      EEDTMX = 3.0
C        EE PAIRS: MAXIMUM DISTANCE WHERE TRACKS ARE PARALLEL (STD.DEV.)
      EEDRMX = 3.0
C        EE PAIRS: MAXIMUM POSITIVE XY DISTANCE, NO ST.DEV. CUT (MM)
      EEXYMN = 4.0
C        EE PAIRS: MAXIMUM XY DISTANCE WHERE TRACKS ARE PARALLEL (MM)
      EEXYMX = 20.
C        MAXIMUM TRACK EXTRAPOLATION AND INTRAPOLATION(ARC LENGTH)
      SEMAX = -300.
      SIMAX = 25.
C        MAXIMUM TRACK EXTRAPOLATION (PHI)
      PHEMAX = 1.0
C        MAXIMUM TRACK DISTANCE TO VERTEX DURING FIT (STD.DEV.)
      SIG2 = 2.
C        MAXIMUM TRACK DISTANCE TO VERTEX AFTER FIT (STD.DEV.)
      SIG3 = 4.
C        SEC. VERTICES: MINIMUM COS OF TRACK TO MAIN VERTEX (OR XB,YB)
      CSECV = -0.15
C
      RETURN
      END

C   21/01/83 403132002  MEMBER NAME  GPHMAINX (JADEGS)      FORTRAN
      IMPLICIT INTEGER*2 (H)
C---
C---   SUMMER 1982 VERSION, SPECIAL VERSION FOR PUBLIC RELATIONS
C---
      REAL*8 DATE,TIME,DDN
      INTEGER*4 BINTIM
      COMMON/CBSTR/MODE
#include "cgraph.for"
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C----------------------------------------------------------------------
      COMMON /BCS/ IDATA(33000)
      DIMENSION HDATA(10),IPNT(50),ADATA(1)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C------------------------ END OF MACRO CDATA --------------------------
#include "ciouni.for"
      COMMON/CSVCW1/NDDSVE,NRWR
      DIMENSION HTM1(4),HTM2(4)
       EQUIVALENCE (DATE,HTM1(1)),(TIME,HTM2(1))
      DIMENSION IDATAL(11),HVOLSR(4),HELP(10),IMUC(11,3)
      DIMENSION HNAM(8),HNAME(4)
      DATA HBLANK/'  '/
      COMMON/CWORK/DATE,TIME,DDN,
     1             IDATAL,DUMMY,ITIME,KNTERR,JUMPBK,IANSW,INDEX0,
     1             NUMEVN,HVOLSR,HERR,HWORK(40)
      EQUIVALENCE (HELP(1),DATE),(HNAM(1),HNAME(1))
      DATA IMUC /'F11L','HO.B','UPDA','T0  ','    ','    ',5*'    ',
     $           'F11L','HO.B','UPDA','T1  ','    ','    ',5*'    ',
     $           'F11L','HO.A','UPDA','T1  ','    ','    ',5*'    '/
C---
C---     MAIN ROUTINE FOR CONDENSED JADE GRAPHICS PROGRAM.
C---     STARTED WEDNESDAY, MAY 17, 1978.
C---     LAST CHANGE 13.3.84   C.BOWDERY,S.CARTWRIGHT
C---
C---     INITIALIZE PLOT10, SEND OPENING MESSAGES TO SCREEN AND ALLOCATE
C---     FORTRAN REFERENCE NUMBERS FOR INPUT AND CALIBRATION DATA SETS.
C---
      CALL INITT(DUMMY)
      CALL TWINDO(0,4095,0,4095)
C---
      DO 1244 I = 1,8
1244  HNAM(I) = HBLANK
      CALL IDFUN(HNAME,NBOK)
      ITIME=BINTIM(DUMMY)/360000
      IF(ITIME.LT.12) WRITE(6,1237) (HNAM(IS),IS=1,5)
1237  FORMAT('           GOOD MORNING, ',4A2,'  NICE TO SEE YOU AGAIN ',
     $A2)
1238  FORMAT('         GOOD AFTERNOON, ',4A2,'  NICE TO SEE YOU AGAIN ',
     $A2)
1239  FORMAT('           GOOD EVENING, ',4A2,'   WORKING LATE AGAIN ? ',
     $A2)
      IF(ITIME.GE.12.AND.ITIME.LT.18) WRITE(6,1238) (HNAM(I),I=1,5)
      IF(ITIME.GE.18) WRITE(6,1239) (HNAM(IS),IS=1,5)
C---
      CALL TRMOUT(80,'JADE INTERACTIVE GRAPHICS PROGRAM.  ******* VERSIO
     1N FROM SUMMER 1982 ****^')
      CALL NOTICE
      CALL DAY(DATE,TIME)
      DO 4987  I = 1,4
4987  HWORK(I) = HTM1(I)
      HWORK(5) = HBLANK
      DO 4986  I = 1,4
4986  HWORK(I+5) = HTM2(I)
      WRITE(6,6033) (HWORK(I),I=1,9)
6033  FORMAT(' SCAN SESSION BEGINNING AT DATE AND TIME: ',9A2)
    1 CONTINUE
      CALL TRMOUT(80,'PLEASE ENTER FULL NAME OF THE CATALOGUED DATA SET
     $WITH THE EVENTS^')
      CALL TRMIN(44,IDATAL)
      CALL TRMOUT(80,'  ^')
C---
C---     ALLOCATE FORTRAN REFERENCE NUMBER TO INPUT DATA SET.
C---
      DO 8 I=1,11
    8 IDATSV(I)=IDATAL(I)
   16 CONTINUE
      DO 3 I=1,4
    3 HVOLSR(I)=HBLANK
      NDDINN=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,NDDINN,HERR)
      IF(HERR.EQ.0) GO TO 5
C---
C---     ERROR HAS OCCURRED ON ALLOCATION.
C---
      CALL TRMOUT(80,'AN ERROR HAS OCCURED IN ALLOCATING THE REQUESTED D
     $ATA SET.^')
      CALL TRMOUT(80,'THE NAME IS INCORRECT OR HMS/MSS IS JAMMED.^')
      CALL TRMOUT(80,'PLEASE TRY AGAIN OR CLOSE THE SESSION WITH CONTROL
     $/G.^')
      GO TO 1
C---
C---     SUCCESSFULLY ALLOCATED DATA SET.
C---
    5 CONTINUE
      MAXREC=0
C---
C---     NDDOUT WILL NORMALLY CONTAIN THE FORTRAN REFERENCE
C---     NUMBER OF THE OUTPUT DATA SET WITH WRITTEN EVENTS. IT IS HERE
C---     SET TO 0. FIRST CALL TO COMMAND WRIT WILL CALL FOR ALLOCATION
C---     OF THE OUTPUT DATA SET.
C---
      NDDOUT=0
      NDDSVE=0
      NRWR = 0
C=======================================================================
C---
C---     STANDARD VIEW, USER LEVEL STOP SETTING ETC.
C---
      ISTANV=2
      LASTVW=ISTANV
      CALL SETSCL(ISTANV)
      SXIN=XMIN
      SXAX=XMAX
      SYIN=YMIN
      SYAX=YMAX
C---
      DO 62 I=1,10
      SSTPS(I)=.FALSE.
62    LSTPS(I)=0
      SSTPS(2)=.TRUE.
      SSTPS(6)=.TRUE.
C---
      CALL TRMOUT(80,'DEFAULT STANDARD VIEW "RB" AND USER LEVELS 2 AND 600012400
     $ HAVE BEEN SET.    ^')
      CALL TRMOUT(80,'THEY CAN BE CHANGED AT ANY TIME BY THE COMMANDS CS
     $TV 1  AND CSTL.^')
      CALL TRMOUT(80,'USE COMMAND "C" FOR GOING FROM LEVEL 2 TO LEVEL 6^
     $')
      CALL TRMOUT(80,'  ^')
C---
      CALL TRMOUT(80,'NAME OF  OUTPUT DATA SET / EDIT BACKUP FILE  WILL
     $BE ASKED FOR ^')
      CALL TRMOUT(80,'AT THE FIRST COMMAND  "WRIT" OR "EDIT (SAVE)"^')
      CALL TRMOUT(80,'  ^')
C---
      CALL TRMOUT(80,'THE DEFAULT CALIBRATION DATA SET F11LHO.AUPDAT1 WI
     $LL NOW BE ALLOCATED.^')
      CALL TRMOUT(80,'IF YOU WISH THE BUPDAT0/BUPDAT1 FILES FOR LEAD GLA
     $SS CALIBR. (REFORM DATA),^')
      CALL TRMOUT(80,'THEN PRESS ANY CHARACTER+RETURN, ELSE PRESS RETURN
     $ FOR THE FIRST EVENT^')
      CALL TRMOUT(80,'  --->     PLEASE WAIT A LITTLE...^')
C---
C---       ALLOCATE THE CALIBRATION DATA SETS
C---
      NCALI = 1
      DO 898 I=1,11
  898 IDATAL(I)=IMUC(I,3)
      DO 893 I=1,4
  893 HVOLSR(I)=HBLANK
      LUNNNN=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,LUNNNN,HERR)
      IF(HERR.NE.0) GO TO 795
      LUNITA(1)=LUNNNN
      GO TO 801
C---     ERROR HAS OCCURRED ON ALLOCATION.
  795 CALL TRMOUT(80,'ERROR IN ALLOCATING CALIBRATION FILE.  THE SESSION
     $ IS STOPPED ...^')
      STOP
803   NCALI = 2
      DO 797  II = 1,2
      DO 798 I=1,11
  798 IDATAL(I)=IMUC(I,II)
      DO 793 I=1,4
  793 HVOLSR(I)=HBLANK
      LUNNNN=0
      CALL GETPDD(IDATAL,HVOLSR,DDN,LUNNNN,HERR)
      IF(HERR.NE.0) GO TO 795
      LUNITA(II)=LUNNNN
  797 CONTINUE
      CALL TRMOUT(80,'  ---> ALLOCATION READY. ENTER FOR FIRST EVENT:^')
      CALL TRMIN(2,HDUM)
      GO TO 802
801   CALL TRMOUT(80,'  ---> ALLOCATION READY.  ENTER ?^')
      CALL TRMIN(2,HDUM)
      IF(HDUM.EQ.HBLANK) GO TO 802
      GO TO 803
C---
C---     INITIALIZE BOS.
C---     CALL MAIN ANALYSIS SUPERVISOR ROUTINE.
C---
802   CALL BINT(33000,10000,200,1)
C SET SOME CONVENIENT DEFAULTS FOR PUBLIC RELATION DISPLAYS
      DSPDTL(13) = .FALSE.
      DSPDTL(17) = .TRUE.
      DSPDTL(15) = .TRUE.
      DSPDTL(12) = .FALSE.
      DSPDTL(23) = .TRUE.
      CALL SUPERV
C---
C---     END SCAN SESSION AND TERMINATE PLOT10.
C---
      IF(NDDOUT.EQ.0) GO TO 9866
      WRITE(JUSCRN,9865) NRWR
9865  FORMAT(' THE NEWLY WRITTEN RECORDS ARE PRECEDED BY ',I5,' RECORDS
     $ON THE OUTPUT FILE')
9866  CALL DAY(DATE,TIME)
      DO 5087  I = 1,4
5087  HWORK(I) = HTM1(I)
      HWORK(5) = HBLANK
      DO 5086  I = 1,4
5086  HWORK(I+5) = HTM2(I)
      WRITE(6,5033) (HWORK(I),I=1,9)
5033  FORMAT(' SCAN SESSION ENDING AT DATE AND TIME: ',9A2)
      ITIME=BINTIM(DUMMY)/360000
      IF(ITIME.GT.4.AND.ITIME.LE.9) WRITE(6,1246) (HNAM(I),I=1,5)
      IF(ITIME.GT.9.AND.ITIME.LE.16) WRITE(6,1247) (HNAM(I),I=1,5)
      IF(ITIME.GT.16.AND.ITIME.LE.21) WRITE(6,1248) (HNAM(I),I=1,5)
      IF(ITIME.GT.21.OR.ITIME.LE.4) WRITE(6,1249) (HNAM(I),I=1,5)
1246  FORMAT('         HAVE A PLEASANT MORNING, ',4A2,'  ',A2)
1247  FORMAT('          A VERY GOOD DAY TO YOU, ',4A2,'  ',A2)
1248  FORMAT('         HAVE AN ENJOYABLE EVENING, ',4A2,'  ',A2)
1249  FORMAT('         GOOD NIGHT AND SLEEP WELL, ',4A2,'  ',A2)
      CALL FINITT(0,0)
      STOP
      END
C-----------------------------------------------------------------------
      BLOCK DATA
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      LOGICAL FL18,FL22,FL24,DSPDTM
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24,KPROJ
#include "chsym.for"
      DATA HSYM /'0 ','1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 ','A ',
     $'B ','C ','D ','E ','F ','G ','H ','I ','J ','K ','L ','M ','N ',
     $'O ','P ','Q ','R ','S ','T ','U ','V ','W ','X ','Y ','Z '/
      DATA FL18,FL22,FL24  /3*.FALSE./,KPROJ/0/
      COMMON /CGRAP2/ BCMD,DSPDTM(30),ISTVW,JTVW
      DATA DSPDTM /2*.TRUE., 5*.FALSE.,.TRUE.,22*.FALSE./
      DATA ISTVW  / 0 /, JTVW   / 0 /
#include "cgeo2.for"
#include "cgeo2com.for"
      DATA FENDC/81./,XYHOL1,XYHOL2/141.,151.5/,BLDPFW/400./,
     1 ZMINBL,ZPLUBL /-5250.,5250./,
     2 XSC /230.,150./, YSC /150.,70./, RSC /152.48,192.48/,
     3 ZMISC/-4235.,-4135./, ZPLSC/4235.,4135./, DZSC/6./,
     4 CHX/-140.,-400.,140.,-140.,-400.,140.,
     5 -140.,-400.,140.,-140.,-400.,140./,
     6 CHY /-400.,140.,-400.,-400.,140.,-400.,
     7 -400.,140.,-400.,-400.,140.,-400./,
     8 CHZ /-4770.,-4720.,-4770.,-4020.,-4070.,-4020.,
     9 4020.,4070.,4020.,4770.,4720.,4770./,
     A WLEN/800./, PITCH /25./, WZDIS/10./
C    8 CHZ /-4770.,-4720.,-4770.,-4020.,-3970.,-4020.,
C    9 4020.,3970.,4020.,4770.,4720.,4770./,
      COMMON /CZGEO/ RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,ZCHSS,
     $               ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      DATA RZCHI,RZCHA /864.5, 884.5/
      DATA NZRPSI,NZZ /24,16/
      DATA Z1ZCH,Z2ZCH /-1200.,1200./
      DATA ZCHA,ZCHB,ZCHSS /5.,15.,1./
      DATA ZCHDL,ZCHDLL /100.,20./, DLZZ,DLZPHI /150.,227.63/
      DATA DLZW1,DLZW2 /228.94,231.58/
      COMMON /CZKON/ ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
      DATA ZCVDR/0.34/, ZCXCH/1.0/, ZCTZER/0.0/, ZCAPED/0.0/
      DATA XL1,XL2 /2547.28, 2578.96/
      END

C   25/06/78 705272213  MEMBER NAME  PARST2   (S)           FORTRAN
      SUBROUTINE PARST2(Z,A,T0,PCUTM,PLE)
C
C     A.SATO
C
C     SET PARAMETERS FOR IONIZATION LOSS
C     THIS ROUTINE VALID ONLY FOR DENSE MATERIAL WITH
C      (Z.GE.6) AND (I.GE.100.).
C     HERE I IS IONIZATION POTENTIAL IN EV.
C     IN THE PROGRAM IT IS WRITTEN AS RI.
C---- REFERENCE   R.M.STEINHEIMER ET AL,PHYS.REV.B3,3681(1971)
C
C  COMMENTS BY J.OLSSON   27.5.1987
C
C    AI AND BI COME FROM FORMULAS (25) AND (26)
C    I IS GIVEN BY FORMULA (13)
C    NOTE THAT THE NORMALIZATION CONSTANT AI, WHICH IN THE REF. HAS
C    THE NUMBER 0.1536 IN IT, HERE IS GIVEN IN UNITS OF EL.MASS, I.E.
C    0.1536/ME = 0.3006
C    NOTE THAT THE STERNHEIMER FORMULA GIVES ENERGY LOSS IN UNIT OF
C    MEV CM**2 / G. THIS IS TURNED INTO UNIT OF MEV BY MULTIPLICATION
C    WITH T0, WHICH HAS UNIT OF G/CM**2
C    26.96 = LN(ME) + LN(10**6)
C
C
      COMMON /ILPAR/AI,BI,CUTM
      COMMON /DFPAR/CI,SAI,RMI,X0,X1
C
      RI=(9.76+58.8*Z**(-1.19))*Z
      AI=0.3006*Z*T0/A
      BI=26.96-2.*ALOG(RI)
      CUTM=PCUTM*0.511
C
      CUTM=ALOG(CUTM)
C
      RMI=3.
      X1=3.
      CI=-2.*ALOG(RI/PLE)-1.
      BCI=-CI
      X0=0.2
      IF(BCI.GE.5.215) X0=0.326*BCI-1.5
      SAI=(BCI-4.606*X0)/(X1-X0)**RMI
      RETURN
      END

C   09/05/82 205271820  MEMBER NAME  LGBTDC   (SOURCE)      FORTRAN
      SUBROUTINE LGBTDC( CBTDC, JFLLGT )
C
C     S.YAMADA   09-05-82   12:00      COPIED FROM F22YAM.PHANAL.S
C                                      ON 27-05-82
C---- LG-BARREL TOF
C
#include "cdata.for"
C
      INTEGER *4 NRUNBN(4)/2010241,2010263,2010361,2010973/
      DATA NMAX/4/
      REAL       TBASE(4)/ 804.40, 1195.07,988.52, 1198.86/
C
      CBTDC = 0.
      JFLLGT = 0
C
C---- RUN NUMBER
      NPHD2 = 2*IDATA( IBLN('HEAD') )
      IF( NPHD2.LE.0 ) GO TO 90
      NRUN = HDATA(NPHD2+9)*100000 + HDATA(NPHD2+10)
      IF( NRUN.LT.2010055 ) GO TO 90
C     GET THE RUN-BIN NUMBER
        DO 1 N=1,NMAX
        IF( NRUN.LE.NRUNBN(N) ) GO TO 2
    1   CONTINUE
C
C---- CALIBRATION IS NOT READY YET.
      IFLLGT = 1
      N = NMAX
C
    2 TBASEN = TBASE(N)
C
C---- 'ATST' BANK
      NPATST = IDATA( IBLN('ATST') )*2
      IF( NPATST.EQ.0 ) GO TO 90
      BADC = HDATA( NPATST+4 )
      BTDC = HDATA( NPATST+17 )
      CBTDC = (BTDC + 280.0-70.*(2.0-0.001*BADC)**2 - TBASEN)*0.1
      RETURN
C
   90 JFLLGT = 2
      RETURN
      END

C   23/08/85 903042127  MEMBER NAME  STATAGPL (S)           FORTRAN
C
C
      SUBROUTINE STATAG( LENGTH, ITAG )
C
C  TEST PLOT VERSION
C
C-----------------------------------------------------------
C
C   VERSION OF 27/01/84      LAST MOD    27/01/84       E.ELSEN
C   STORE FWD LEAD GLASS DATA IN ARRAR ITAG.
C   LENGTH IS TOTAL I*4 LENGTH OF ARRAY.
C   EXTRA ENTRY RETURNS LENGTH ONLY.
C                            LAST MOD    10/09/87       P.HILL,J.OLSSON
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      DIMENSION ITAG(1), HP(4), IHP(2) ,HMARK(2) ,IMARK(1)
      EQUIVALENCE ( HP(1), IHP(1) )
      EQUIVALENCE ( HMARK(1), IMARK(1) )
      DIMENSION HELP(2)
      EQUIVALENCE ( HELP(1), IHELP )
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      COMMON / CWORK / IIMARK
C
C IIMARK IS REQUIRED TO CONTROL TAGS2H
C
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cmctag.for"

      COMMON / BCS / IW(1)
      COMMON / TODAY / HDATE(6)
C
C DEFAULT INMARK = 0
C
      IIMARK = INMARK
      ISTMZ  = 1
      ISTPZ  = 97
      IENDMZ = 96
      IENDPZ = 192

C
      IF(INMARK.LT.1)GOTO 10
      IF(INMARK.EQ.2)GOTO 5
C
C INMARK = 1
C
      ISTMZ = 1
      ISTPZ = 33
      IENDMZ = 32
      IENDPZ = 64
      GOTO 10
C
C
C INMARK = 2
C
5      ISTMZ = 1
      ISTPZ = 25
      IENDMZ = 24
      IENDPZ = 48
C
C ALL INMARKS
C
 10   CONTINUE
C                                           INITIALISE POINTERS
      HP(1) = 1
      HP(2) = 0
      HP(3) = 0
      HP(4) = 0
C
      NBLIM = IENDMZ
      LENGTH = 3
      INX = 1
C
C SET DATE IN HEAD BANKS WORDS 93 - 95, FROM COMON/TODAY/
C
       CALL BLOC(IND,'HEAD',0,&30)
         IW(IND+93) = HDATE(4)
         IW(IND+94) = HDATE(5)
         IW(IND+95) = HDATE(6)
30     CONTINUE
C
C LOOP TO FILL ARRAY ITAG - FROM ARRAY HGG
C

      DO 100 J = 1, IENDPZ
C
        IF( HGG(J) .LE. 0 ) GO TO 100
        LENGTH = LENGTH + 1
        IF(LENGTH.GT.195)GOTO 20
C
C SOFTWARE ADDRESS MUST BE CONVERTED TO HARDWARE ADDRESS
C FOR  OUTPUT - SAME SCHEME AS TP PROGRAMS
C
        JJ = J
C
C
C INMARK IS TAGAN MARK - 0 FOR 1979/80,1 FOR 1981,2 2 FOR 1983 ..
C
C FOR MARK 0 TAGGER HARDWARE ADDRESSES ARE USED THROUGHOUT SO
C  DONT CONVERT THEM !
C
        IF(INMARK.EQ.0)JHARD = JJ
        IF(INMARK.GT.0)JHARD = TAGS2H(JJ)
C
C CONVERT TO TWO HALF WORDS
C
C
C
        HELP(1) = JHARD
        HELP(2) = HGG(J)
C
C
C FILL ITAG
C
        ITAG(LENGTH) = IHELP
C
C       IF( J .LT. NBLIM ) GO TO 100
C
C  CHANGE 10.9.1987, AGE-OLD BUG!!!    J.O, P.H.
C
        IF( J .LE. NBLIM ) GO TO 100
          INX = INX + 1
          HP(INX) = LENGTH*2 - 7
          NBLIM = IENDPZ
  100 CONTINUE
C
      IF( LENGTH .LE. 3 ) GO TO 8000
 20   HP(3) = LENGTH*2 - 5
      IF( HP(2) .EQ. 0 ) HP(2) = HP(3)
C
C                                           SET DESCRIPTOR AND POINTERS
C
      HMARK(1)=0.0
      HMARK(2)=INMARK
      ITAG(1) = IMARK(1)
      ITAG(2) = IHP(1)
      ITAG(3) = IHP(2)
C
      RETURN
C000  LENGTH = 0
C     RETURN
C     END
C
C                                           LENGTH OF DATA STORED
C-----------------------------------------------------------
      ENTRY      LHATAG( LENGTH )
C-----------------------------------------------------------
C
C LHATAG RETURNS LENGTH OF BOS BANK REQUIRED, HAVING FIRST
C
C  1) ADDED RANDOM HITS  USING MCTAGR
C  2) SMEARED ALL BLOCKS USING MCTAGS
C
C NOTE: IN ORDER TO AVOID WRITING PEDESTAL ONLY BANKS, THE ABOVE
C       IS ONLY DONE IF THERE ARE 'REAL' HITS ALREADY
C------------------------------------------------------------
C
C     IMPLICIT INTEGER*2 (H)
CMACRO CMCTAG
      DATA  ICALLP/0/
C
      IF(ICALLP.NE.0) GO TO 1
C
      CALL HBOOK1(2001,'STATAG: ETOT BEFORE MCTAGR$',100,0.,50.)
      CALL HBOOK1(2002,'STATAG: ETOT BEFORE MCTAGS$',100,0.,50.)
      CALL HBOOK1(2003,'STATAG: ETOT AFTER MCTAGS$',100,0.,50.)
      ICALLP = 1
1     CONTINUE
C
C    WRITE(6,600)(HGG(I),I=1,192)
  600 FORMAT(' ARRAY IN LHATAG ',16(/,12I6))
C IF NO HITS - SKIP IT
      IF(IHIT.LE.0)GOTO 8000
C
C
         SUMPLO = 0.
         LENGTH = 3
C
C WORK OUT LENGTH - TO SEE IF THERE ARE REALLY ANY HITS
C
         DO 2000 J=1,192
         IF(HGG(J).GT.0) SUMPLO = SUMPLO + .001*HGG(J)
 2000    IF( HGG(J) .GT. 0.0 ) LENGTH = LENGTH + 1
          IF(LENGTH.LE.3)GOTO 8000
C
C          MCTAGR ADDS RANDOM HITS AND PEDESTAL FLUCTUATIONS
C
         CALL HFILL(2001,SUMPLO,0,1.)
            CALL MCTAGR
C    WRITE(6,602)(HGG(I),I=1,192)
  602 FORMAT(' ARRAY IN LHATAG AFTER MCTAGR',16(/,12I6))
C      MCTAGS- SMEARS ALL DEPOSITED ENERGIES,BY SIGMA,AND CONVERTS FROM
C            ENERGY TO ADC CHANNEL NUMBER USING CALIB
         SUMPLO = 0.
         DO 2001 J=1,192
         IF(HGG(J).GT.0) SUMPLO = SUMPLO + .001*HGG(J)
 2001    CONTINUE
         CALL HFILL(2002,SUMPLO,0,1.)
             CALL MCTAGS
C    WRITE(6,601)(HGG(I),I=1,192)
  601 FORMAT(' ARRAY IN LHATAG AFTER SMEAR',16(/,12I6))
         SUMPLO = 0.
         DO 2002 J=1,192
         IF(HGG(J).GT.0) SUMPLO = SUMPLO + .001*HGG(J)
 2002    CONTINUE
         CALL HFILL(2003,SUMPLO,0,1.)
C
C NOW WORK OUT LENGTH AGAIN
C
            LENGTH = 3
            DO 3000 J=1,192
 3000       IF( HGG(J) .GT. 0.0 ) LENGTH = LENGTH + 1
C
            IF( LENGTH .GT. 3 ) RETURN
8000  LENGTH = 0
      RETURN
      END

C   07/06/96 606071843  MEMBER NAME  EPCONS   (S4)          FORTG1
C   11/07/79 C9071201   MEMBER NAME  EPCONS   (QLIBS)       FORTRAN
      SUBROUTINE EPCONS(LPART,NPT,LBAEC,NBC,RELE,*)
C
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (IW(1),RW(1))
C     INPUT ARRAYS WITH NRS OF PART-BANKS AND NRS OF BAEC BANKS
      INTEGER LPART(32),LBAEC(32)
C     INTERNAL ARRAYS
      INTEGER LP(100),ICHARG(100)
      COMMON/HBLO/
     1     EP(64),VS(6),QU(3,12),QF(3,12),VR(6),VH(6),RSUM(4),R(4),D(12)
     2     ,DYM(24)
C
      EXTERNAL VECSUB
      COMMON/CONF1/NY,NF,V(1275),DELY(50),F(20),B(1000),PL(50),
     1   IEF,ND,CHSQ,PR,IDIAG,IUNPH
      COMMON P(10,200)
      INTEGER IP(10,100)
      EQUIVALENCE (IP(1,1),P(1,1))
C
C
C     PLEASE READ ALL COMMENT CARDS BEFORE USING
C
C     PLEASE CALL AT BEGIN . . .
C
C     CALL CONDIA(10,3,3)       IF OUTPUT OF 3 EVENTS FROM FITPGMWANTED
C
C     CALL CONDEF(10,30,10,10,0.0,0.1,0.1,1.0)  FOR ADJUSTMENT OF
C                                               CONSTANTS
C
C     . . . AND AT JOB END
C     CALL CONSTA               FOR FINAL STAISTIC PRINTOUT
C
C     IMEYER = 0    NO ANGLE CORRECTION
C     IMEYER = 1    Z AVERAGING AND ANGLE CORRECTION
C     GEM WUNSCH HJD AM 19.07.79 13.23 IMEYER AUF 1 GESETZT
      IMEYER = 1
      CALL VZERO(EP,200)
      CALL BLOC(IVT,'VERT',1,&101)
      CALL BLOC(IRN,'RUN ',0,&101)
      CALL BSAW(1,'PART')
      ECMS=RW(IRN+19)
      ZAV=RW(IVT+6)
C
C     SIGMA OF Z OF INTERACTION POINT ABOUT 30 MM
C     WILL BE NEGLEGLIBLE IF MANY TRACKS ARE PRESENT
      SUMW=1.E-3
      SUMZ=ZAV*SUMW
C
C     DETERMINE AVERAGE Z FROM ALL CHARGED
C     MAKE LIST OF ALL PARTICLE ENERGIES AND
C     SORT THIS LIST
C
      NP=0
C     CHARGED
      IF(NPT.LE.0) GOTO 8
      DO 6 I=1,NPT
      CALL BLOC(IND,'PART',LPART(I),&2)
      GOTO 4
    2 CALL BLOC(IND,'TRAC',LPART(I),&101)
      CALL TRPART(IND,&101)
      CALL BLOC(IND,'PART',LPART(I),&101)
    4 XMS=0.0
      IF(IW(IND+8).EQ.0) GOTO 5
      WZ=1.0/RW(IND+20)
      SUMZ=SUMZ+RW(IND+4)*WZ
      SUMW=SUMW+WZ
      XMS=0.0194789
    5 NP=NP+1
      LP(NP)=NP
      ICHARG(NP)=IW(IND+8)
      EP(NP)=-SQRT(XMS+1.0/RW(IND+1)**2)
    6 CONTINUE
      ZAV=SUMZ/SUMW
C     NEUTRAL
    8 IF(NBC.LE.0) GOTO 12
      DO 10 I=1,NBC
      CALL BLOC(IND,'BAEC',LBAEC(I),&101)
      NP=NP+1
      LP(NP)=NP
      ICHARG(NP)=0
   10 EP(NP)=-1.0E-3*RW(IND+1)
C     SORT
   12 CALL SORTXY(EP(1),LP(1),NP)
C
C     INITIALIZE FIT PROGRAM, USE ALL PARTICLES, IF LESS EQUAL 12
C     OTHERWISE USE THE 8 HIGH ENERGY PARTICLES AND THE REMAINING
C     AS ONE PARTICLE
C
      CALL CONPAR(10)
      NY=3*NP
      IF(NP.GT.12) NY=27
      NY=NY+3
      IF(RELE.NE.0.0) NY=NY+1
      NF=4
      CALL CONLES(1)
      CALL VZERO(B,NY*NF)
C
C
C
C
      CALL VZERO(QU,36)
      CALL VZERO(RSUM,4)
      CALL VZERO(VR,6)
      DO 20 I=1,NP
      J=LP(I)
      II=I
      IF(NP.GT.12.AND.I.GT.8) II=11
      IF(J.GT.NPT) GOTO 13
C     PART BANKS
      CALL BLOC(IND,'PART',LPART(J),&101)
      QU(1,II)=ABS(RW(IND+1))
           QU(2,II)=RW(IND+2)
      IF(IMEYER.NE.0.AND.ICHARG(I).NE.0)
     1     QU(2,II)=RW(IND+2)+(ZAV-RW(IND+4))*RW(IND+18)/RW(IND+20)
      QU(3,II)=RW(IND+3)
      XMS=0.0194789
      IF(ICHARG(I).EQ.0) XMS=0.0
      FAC=1.0-RW(IND+18)**2/(RW(IND+13)*RW(IND+20))
      CALL UCOPY(RW(IND+11),VS,6)
      IF(IMEYER.EQ.0.OR.ICHARG(I).EQ.0) GOTO 14
      VS(3)=VS(3)*FAC
      FAC=SQRT(FAC)
      VS(2)=VS(2)*FAC
      VS(5)=VS(5)*FAC
      GOTO 14
C     NEUTRALS (BAEC BANKS)
   13 J=J-NPT
      CALL BLOC(IND,'BAEC',LBAEC(J),&101)
      EN=1.0E-3*RW(IND+1)
      IF(IW(IND+5).EQ.0) GOTO 113
C
C     CORRECTION OF NEUTRAL ENERGY - SUBTRACT MIN IONIZATION
C                                    (MEYER/DEVENISH)
C
      FAC=ABS(RW(IND+10))
      IF(FAC.LT.1.0) FAC=1
      CEN=0.080*FAC
      IF(EN-CEN.LT.0.050) GOTO 113
      EN=EN-CEN
  113 ZB=RW(IND+3)-ZAV
      RB=RW(IND+4)
      QU(1,II)=1.0/EN
      QU(2,II)=ATAN(ZB/RB)
      QU(3,II)=RW(IND+2)
      CALL VZERO(VS,6)
      DEN=0.5*SQRT(EN)
      IF(EN.LE.1.0) DEN=0.5*EN
      VS(1)=DEN/(EN*EN)
      VS(3)=(0.020)**2/(1.0+(ZB/RB)**2)
      VS(6)=(0.015)**2
      XMS=0.0
C
   14 IF(NP.LE.12.OR.I.LE.8) GOTO 18
C     SUM UP PARTICLES
      CALL TADER(QU(1,II),XMS,R,D)
      CALL SMAVAT(VS,D(4),VH,3,3)
      DO 15 K=1,4
   15 RSUM(K)=RSUM(K)+R(K)
      DO 16 K=1,6
   16 VR(K)=VR(K)+VH(K)
      GOTO 20
C
   18 CALL SSVW(V,3*I-2,VS,3)
C
   20 CONTINUE
      IF(RELE.NE.0.0) V((NY*NY+NY)/2)=(RELE*ECMS)**2
C
      IF(NP.LE.12) GOTO 24
      XMSQ=RSUM(1)**2-RSUM(2)**2-RSUM(3)**2-RSUM(4)**2
      DO 22 K=1,3
   22 QU(K,9)=RSUM(K+1)
      CALL SSVW(V,25,VR,3)
C
   24 CALL CONLES(2)
C
C     COPY P-VECTORS 1 . . . 100 TO  101 . . . 200
C
      CALL PCOP(1,100,101)
      CALL PZER(1,NP+1)
C
C     ADD CORRECTIONS TO UNFITTED VALUES
C
      ITER=0
      ECMF=ECMS
   30 ITER=ITER+1
      N=0
      NPY=NY/3
      DO 33 K=1,NPY
      DO 32 L=1,3
      N=N+1
   32 QF(L,K)=QU(L,K)+DELY(N)
      IF(K.EQ.NPY) GOTO 33
      IF(NP.GT.12.AND.K.GT.8) GOTO 33
      IF(QF(1,K).LE.0.0) IUNPH=1
   33 CONTINUE
      IF(RELE.NE.0.0) ECMF=ECMS+DELY(NY)
C
C     COMPUTE CONSTRAINTS
C
      CALL VZERO(F,4)
      F(1)=-ECMF
      DO 50 I=1,NPY
      J=LP(I)
      XMS=0.0194789
      IF(ICHARG(I).EQ.0) XMS=0.0
      IF(J.GT.NPT) XMS=0.0
      IF(I.EQ.NPY) GOTO 40
      IF(NP.GT.12.AND.I.GT.8) GOTO 40
C     VARIABLES 1/0, L, PHI - TRANSFROM TO E, PX, PY, PZ
      CALL TADER(QF(1,I),XMS,R,D)
      DO 34 K=1,4
   34 F(K)=F(K)+R(K)
C     FILL COVARIANCE MATRIX B( )
      ID=0
      IB=3*I-3
      DO 38 K=1,4
      DO 36 L=1,3
      ID=ID+1
      IB=IB+1
   36 B(IB)=D(ID)
   38 IB=IB+NY-3
      GOTO 50
C
C     VARIABLES PX, PY, PZ
   40 IF(ITER.NE.1.OR.I.NE.NPY) GOTO 41
C     START VALUES FOR MISSING VECTOR
      QU(1,I)=-F(2)
      QU(2,I)=-F(3)
      QU(3,I)=-F(4)
      QF(1,I)=-F(2)
      QF(2,I)=-F(3)
      QF(3,I)=-F(4)
      XMISQ=F(1)**2-F(2)**2-F(3)**2-F(4)**2
      P(1,NP+1)=-F(2)
      P(2,NP+1)=-F(3)
      P(3,NP+1)=-F(4)
      P(4,NP+1)=-F(1)
      P(5,NP+1)=SQRT(ABS(XMISQ))
      IF(XMISQ.LT.0.0) P(5,NP+1)=-P(5,NP+1)
      CALL PCOP(NP+1,NP+1,NP+2)
      P(9,NP+1)=F(1)+ECMF
      CALL UCORR(4711,XMISQ,-F(1))
C
C     IF MISSING ENERGY NEGATIVE OR MISSING MASS SQUARED NEGATIVE,
C     THAN THE FIT USES MISSING MASS SQUARED = 0
C
      IF(F(1).GT.0.0.OR.XMISQ.LT.0.0) XMISQ=0.0
C
   41 XMS=0.0
      IF(I.EQ.9)   XMS=XMSQ
      IF(I.EQ.NPY) XMS=XMISQ
      EN=XMS
      DO 42 K=1,3
      F(K+1)=F(K+1)+QF(K,I)
   42 EN=EN+QF(K,I)**2
      EN=SQRT(EN)
      F(1)=F(1)+EN
C     FILL COVARIANCE MATRIX
      IB=3*I-3
      B(IB+1)=QF(1,I)/EN
      B(IB+2)=QF(2,I)/EN
      B(IB+3)=QF(3,I)/EN
      IB=IB+NY
      DO 46 K=1,3
      DO 44 L=1,3
      IB=IB+1
      B(IB)=0.0
      IF(L.EQ.K) B(IB)=1.0
   44 CONTINUE
   46 IB=IB+NY-3
C
   50 CONTINUE
      IF(RELE.NE.0.0) B(NY)=-1.0
C
C
      XMSTOT=F(1)**2-F(2)**2-F(3)**3-F(4)**2
C     CHECK CONVERGENCE
      CALL CONCHK(IBR)
      IF(IBR.NE.0) GOTO (30,60,160),IBR
C     CALCULATE CORRECTIONS
      CALL CONLES(3)
      GOTO 30
C     CALCULATE COVARIANCE MATRIX
   60 CALL CONLES(4)
C     FILL P-VECTORS 1, 4 . . . (NPT+NBC+1)
  160 DO 70 I=1,NP
      J=LP(I)
      IF(NP.GT.12.AND.I.GT.8) GOTO 63
      II=I
C     PARTICLE WAS USED IN THE FIT, USE FITTED VALUES
      IF(J.GT.NPT) GOTO 61
C     PART BANK
      CALL BLOC(IND,'PART',LPART(J),&101)
      P(7,J)=3-IW(IND+8)
      IF(IW(IND+8).EQ.0) P(7,J)=0.0
      P(9,J)=LPART(J)
      P(6,J)=QF(3,II)
      XMS=0.0194789
      IF(ICHARG(I).EQ.0) XMS=0.0
      GOTO 62
C     NEUTRAL (BAEC)
   61 XMS=0.0
      P(9,J)=LBAEC(J-NPT)
C     BOTH
   62 P(6,2)=QF(3,II)
      CALL TADER(QF(1,II),XMS,R,D)
      GOTO 69
C     PARTICLE WAS NOT DIRECTLY USED IN THE FIT, USE UNFITTED VALUES
   63 II=11
      IF(J.GT.NPT) GOTO 64
C     PART BANK
      CALL BLOC(IND,'PART',LPART(J),&101)
      QU(1,II)=ABS(RW(IND+1))
           QU(2,II)=RW(IND+2)
      IF(IMEYER.NE.0.AND.ICHARG(I).NE.0)
     1     QU(2,II)=RW(IND+2)+(ZAV-RW(IND+4))*RW(IND+18)/RW(IND+20)
      QU(3,II)=RW(IND+3)
      XMS=0.0194789
      P(7,J)=3-2*IW(IND+8)
      IF(ICHARG(I).EQ.0) P(7,J)=0.0
      IF(ICHARG(I).EQ.0) XMS=0.0
      P(9,J)=LPART(J)
      P(6,J)=QU(3,II)
      GOTO 65
C     NEUTRALS (BAEC)
   64 CALL BLOC(IND,'BAEC',LBAEC(J-NPT),&101)
      EN=1.0E-3*RW(IND+1)
      IF(IW(IND+5).EQ.0) GOTO 164
      FAC=ABS(RW(IND+10))
      IF(FAC.LT.1.0) FAC=1
      CEN=0.080*FAC
      IF(EN-CEN.LT.0.050) GOTO 164
      EN=EN-CEN
  164 ZB=RW(IND+3)-ZAV
      RB=RW(IND+4)
      QU(1,II)=1.0/EN
      QU(2,II)=ATAN(ZB/RB)
      QU(3,II)=RW(IND+2)
      XMS=0.0
      P(6,J)=QU(3,II)
      P(9,J)=LBAEC(J-NPT)
C
   65 CALL TADER(QU(1,II),XMS,R,D)
C
   69 P(1,J)=R(2)
      P(2,J)=R(3)
      P(3,J)=R(4)
      P(4,J)=R(1)
      P(5,J)=SQRT(XMS)
      CALL LENGTH(J,XL)
      P(8,J)=XL
   70 CONTINUE
      P(1,NP+1)=QF(1,NPY)
      P(2,NP+1)=QF(2,NPY)
      P(3,NP+1)=QF(3,NPY)
      P(5,NP+1)=SQRT(XMISQ)
      CALL LENGTH(NP+1,XL)
      P(4,NP+1)=SQRT(XL*XL+XMISQ)
      ESEEN=0.0
      DO 80 I=1,NP
   80 ESEEN=ESEEN+P(4,I)
      P(10,NP+1)=ESEEN
      CALL UCORR(4712,P(9,NP+1),P(10,NP+1))
  100 RETURN
  101 RETURN 1
      END

C   29/11/77 606101229  MEMBER NAME  JPRFRE9  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JPRFRE( R, P, PENETR, PENETZ, RDOWN, RUP,
     *                   ZDOWN, ZUP, DRMAX, *, *, *, * )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     02/10/78 :  PROPAGATES PARTICLE IN NON
C                                      ABSORBING MEDIUM DEFINED BY
C                                      PARAMETERS  ( RDOWN, RUP,
C                                                    ZDOWN, ZUP )
C
C  LAST MOD J. HAGEMANN    28/08/84 :  NEW VERSION OF SUBROUTINE JSTEP
C                                      INCLUDED
C
C        UPON RETURN PENET((R) OR (Z)) IS PENETRATION
C        LENGTH IN NEXT ELEMENT IN R OR Z DIRECTION.
C
C           RETURN  : NEXT ELEMENT, INCREASING R
C           RETURN1 : NEXT ELEMENT, DECREASING R
C           RETURN2 : NEXT ELEMENT, INCREASING Z
C           RETURN3 : NEXT ELEMENT, DECREASING Z
C           RETURN4 : PARTICLE STOPPED IN SYSTEM
C-----------------------------------------------------------------------
C
      COMMON / CJTRLE / TOTLEN, STPLEN
C
      DIMENSION R(5), P(7)
C
C------------------------  C O D E  ------------------------------------
C
      IF( R(4) .GT. RUP ) RETURN
      IF( R(4) .LT. RDOWN ) RETURN1
      IF( R(3) .GT. ZUP ) RETURN2
      IF( R(3) .LT. ZDOWN ) RETURN3
C
      PENETZ = 0.
      PENETR = 0.
      DO 100 ITERAT = 1,300
      IF( R(4) .LE. RUP  ) GO TO 20
          PENETR = R(4) - RUP
          RETURN
   20 IF( R(4) .GE. RDOWN ) GO TO 30
          PENETR = RDOWN - R(4)
          RETURN 1
   30 IF( R(3) .LE. ZUP ) GO TO 40
          PENETZ = R(3) - ZUP
          RETURN 2
   40 IF( R(3) .GE. ZDOWN ) GO TO 50
          PENETZ = ZDOWN - R(3)
          RETURN 3
C
   50 CALL JSTEP( R, P, DRTOT, DRMAX )
        R(4) =  SQRT( R(1)*R(1) + R(2)* R(2) )
C        TOTAL TRACK LENGTH BIGGER THAN MAXIMUM VALUE?
            TOTLEN = TOTLEN  + DRTOT
            IF( TOTLEN .GT. STPLEN ) RETURN4
  100 CONTINUE
C
      RETURN 4
      END

C   07/06/96 606071849  MEMBER NAME  IBFL     (S4)          FORTRAN
      FUNCTION IBFL(NA,NB,NC,ND)
#include "acs.for"
      COMMON/BCS/IW(1)
#include "star.for"
      IGOTO=1
      GOTO 10
      ENTRY IBLC(NA,NB,NC,ND)
      IGOTO=2
      GOTO 10
      ENTRY IBCR(NA,NB,NC,ND)
      IGOTO=3
      GOTO 10
      ENTRY IBRN(NA,NB,BC,ND)
      IGOTO=4
   10 IW(INAMV)=NA
      LFDI=MOD(IABS(NAME),NPRIM)+NAMAX1
   12 K=LFDI
      LFDI=IW(K+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 12
      IF(LFDI.NE.0) GOTO 14
      IF(NCI.GE.NAMAX) GOTO 200
      NCI=NCI+1
      LFDI=NCI
      IW(INAMV+LFDI)=NAME
      IW(K+IPLST)=LFDI
   14 IF(IGOTO.NE.1) GOTO 20
      IBFL=LFDI
      GOTO 100
   20 LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 23
   22 LFDK=LFDI
      LFDI=IW(LFDI-1)
   23 IF(LFDI.EQ.0)      GOTO 30
      IF(IW(LFDI-2)-NR) 22,24,30
   24 IF(IGOTO.NE.2) GOTO 100
      IBFL=LFDI
      GOTO 100
   30 IBFL=0
      IF(IGOTO.EQ.2) GOTO 100
C     CREATE (NOT YET EXISTING)
      IF(NEXT+NC+4.GE.NLST) GOTO 110
      INAME=NA
      IF(NOTLOW(XNAME)) GOTO 34
      IF(NCPL+NC+4.GE.NSPL) GOTO 120
      NCPL=NCPL+NC+4
   34 IND=NEXT+3
      ISV=IW(LFDK-1)
      IW(IND-3)=NA
      IW(IND-2)=NB
      IW(IND-1)=ISV
      IW(IND  )=NC
      IW(LFDK-1)=IND
      NEXT=NEXT+4+NC
      LIND=IND
      IBFL=IND
      GOTO 100
   90 IBFL=0
  100 RETURN
  110 NHISTH(11)=NHISTH(11)+1
      GOTO 90
  120 NHISTL(11)=NHISTL(11)+1
      GOTO 90
  200 STOP
      END

      REAL FUNCTION PARKOR*8(IP) 
C COPIED AND RENAMED FROM F22KLE.JVTXC.S(PARCOR)   18.9.1986
C
C     IP : POINTER TO TRACK IN PATR-BANK
C
C     CURVATURE-CORRECTION FOR CIRCLES FITTED WITH A PARABOLA
C
C PMF 03.11.98 
      LOGICAL TBIT
      REAL*8 P,Q,R,CM,D,U,V,C
C
      INTEGER*2 HDATA
#include "cdata.for"
C
C *** MEASURED CURVATURE
      CM = -ADATA(IP+22)
      C  =  ADATA(IP+25) * 0.5
      IF (IDATA(IP+18).NE.2) GOTO 100
C *** MEASURED PROJ. TRACKLENGTH
      R  = ABS( ( ADATA(IP+7) - ADATA(IP+14) ) / ADATA(IP+30) ) * 0.5
C
C     CARDANS RULE
C
      P =  7.D0/(18.D0*R*R)
      Q = -7.D0*CM/(12.D0*R*R)
C
      D = DSQRT(Q*Q+P*P*P)
      U = (-Q+D)**(1./3.)
      V = ( Q+D)**(1./3.)
      C = U-V
C
  100 CONTINUE
      PARKOR = C * 2.0D0
C
      RETURN
      END

C   21/12/82 606071922  MEMBER NAME  BCFILE   (S)           FORTRAN
      SUBROUTINE BCFILE(LUN,NRECA,NBLOCK,IPASS,IOPT)
      COMMON/ACS/DUMMI(90),NUNTB
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
C
C     IUND   =   UNIT
C     INDT   =   INDEX OF DIRECTOTY ENTRY
C     INDC   =   INDEX OF BANK TO BE COPIED
C     NPTR   =   RECORD NR WITH DATA
C     INDA   =   INDEX OF MASTER DIRECTORY BANK
C     LISTE  =   NAME, NR, DATA RECORD NR, NR OF WORDS
C     IPAS   =   PASSWORD
C     NDAREC =   NR OF WORDS/RECORD
C
      REAL*8 DATE(2)
      INTEGER IOPNEW/3HNEW/,IOPOLD/3HOLD/,IOP0LD/3H0LD/,DIRA/4H+DIR/
C
C     FORMAT AND CONTENT OF MASTER DIRECTORY RECORD (RECORD NR 1)
C
C     INDEX      CONTENT
C     ---------- ----------------
C         1      = 49
C         2      = 'DIRA'
C         3      = 0
C         4      = 0
C         5      = 45
C         6      TOTAL NR OF RECORDS
C         7      NR OF USED RECORD
C         8      NPRIME FOR HASH FUNCTION
C         9      = 0 OR NAME OF ADDED/CHANGED BANK
C        10      = 0 OR NR OF ADDED/CHANGED BANK
C        11      NR OF WORDS/RECORD
C        12      = 0 OR (DAY) TIME OF UPDATE IN 1/100 SEC
C        13
C        14
C        15
C        16
C        17
C        18
C        19      (PASSWORD)
C        20      = 0 CHANGES ALLOWED, = 1 CHANGES NOT ALLOWED
C     21-24      DATE/TIME OF LAST LOAD
C     25-28      DATE/TIME OF LAST UPDATE
C     29-32      DATE/TIME OF LAST UNLOAD
C        33      NR OF BANKS AT LAST LOAD
C        34      NR OF BANKS AT LAST UPDATE
C        35      NR OF BANKS AT LAST UNLOAD
C         .
C        50
C     ---------- ----------------
C        51      PRINTOUT COUNTER
C        52
C
C
C
C     FORMAT AND CONTENT OF DIRECTORY RECORDS (RECORD NRS 2, 3 ...)
C
C     INDEX      CONTENT
C     ---------- ----------------
C         1      = 4 + 3*NE        FOR NE ENTRIES
C         2      = 'DIRA'
C         3      = 0
C         4      = 0
C     ---------- ----------------
C         5      NAME
C         6      NR
C         7      NR OF DATA RECORD
C         8      NR OF WORDS
C         9      NAME ETC
C        10
C        11
C        12
C        13
C        14
C        15
C
      NREC=NRECA
      IOP=0
      IF(IOPT.EQ.IOPNEW) IOP=1
      IF(IOPT.EQ.IOPOLD) IOP=2
      IF(IOPT.EQ.IOP0LD) IOP=2
      CALL DAY(DATE(1),DATE(2))
      IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,NREC,NBLOCK,IPASS,IOPT
      IF(IOP.EQ.0) GOTO 201
      IUND=LUN
      IPAS=IPASS
      IF(IOP.EQ.1) GOTO  10
C
C     OLD DATA SET / CHECK NR OF RECORDS AND NR OF WORDS/RECORD
C
      CALL DIDA(0,LISTE,1)
C
C     'OLD BOS' DATA SET IS INDICATED BY NREC=-1610
C
      IF(NREC+1610.EQ.0) NREC=IW(INDA+6)
      IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,NREC,NBLOCK,IPASS,IOPT
      IF(IW(INDA+6).NE.NREC)    GOTO 203
      IF(IW(INDA+11).NE.NBLOCK) GOTO 203
      IF(IW(INDA+20).NE.0)      GOTO 203
      IW(INDA+34)=0
      GOTO 12
C
C     DETERMINE PRIME NUMBER FOR HASH SEARCH ALGORITHM
C
   10 IF(NUNTB.NE.0) WRITE(NUNTB,101) LUN,NREC,NBLOCK,IPASS,IOPT
      INDA=IBANK(4H+DIR,IUND,2HDL)
      INDA=IBANK(4H+DIR,IUND,52)
      IF(INDA.EQ.0) GOTO 204
   12 NPRIME=NREC/20
      IF(NPRIME.LE.5) NPRIME=5
      NPRIME=(NPRIME/2)*2+1
      NPRIME=NPRIME-2
   14 NPRIME=NPRIME+2
      A=NPRIME
      J=SQRT(A)
      DO 16 K=3,J,2
      NDIV=NPRIME/K
      IF(NDIV*K.EQ.NPRIME) GOTO 14
   16 CONTINUE
C
C     INITIAL DEFINITION OF THE FIRST RECORD
C
      IW(INDA+1)=4
      IW(INDA+2)=DIRA
      IW(INDA+3)=0
      IW(INDA+4)=0
      IW(INDA+5)=0
      IW(INDA+6)=NREC
      IW(INDA+7)=NPRIME+2
      IW(INDA+8)=NPRIME
      IW(INDA+9)=0
      IW(INDA+10)=0
      IW(INDA+11)=NBLOCK
      IW(INDA+19)=IPASS
      CALL DAY(DATE(1),DATE(2))
      CALL UCOPY(DATE,IW(INDA+21),4)
      IF(IOP.EQ.1) CALL UCOPY(DATE,IW(INDA+25),4)
      IF(IOP.EQ.1) CALL UCOPY(DATE,IW(INDA+29),4)
C
C     WRITE EMPTY DIRECTORY RECORDS
C
      DO 18 K=1,NPRIME
      IW(INDA+3)=K+1
   18 CALL WRDA(K+1,IW(INDA+1),IW(INDA+2))
C
C     WRITE EMPTY NEXT RECORD
C
      IW(INDA+1)=0
      CALL WRDA(NPRIME+2,IW(INDA+1),IW(INDA+2))
C
C     DEFINE AND WRITE MASTER DIRECTORY RECORD
C
      IW(INDA+1)=49
      IW(INDA+3)=0
      IW(INDA+5)=45
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
C
C     MAKE PRINTOUT AND DELETE MASTER DIRECTORY BANK
C
      INDA=IBANK(4H+DIR,IUND,2HDL)
      IPAS=IPASS
      CALL DIDA(0,LISTE,1)
      CALL BGAR(IGA)
C
C
C
  100 RETURN
  101 FORMAT('0---- DIR-UNIT',I3,9X,'INITIALIZE/CLEAR',I8,' RECORDS *',
     1   I5,' WORDS, PASSWORD = ',A4,'   OPTION = ',A4,4X,'(BCFILE)')
C
C     ILLEGAL ARGUMENT IN BCFILE
C
  201 CALL BDMPA(201)
C
C     DIFFERENCE IN DATA SET
C
  203 CALL BDMPA(203)
C
C     INSUFFICIENT SPACE FOR DIRECTORY BANK
C
  204 CALL BDMPA(204)
      GOTO 100
      END

C   20/01/87 804271520  MEMBER NAME  ZE4VEK   (S)           FORTRAN77
C
      SUBROUTINE ZE4VEK(NPSPUR,IKAND)
C-------------------------------------------------------------
C
C  LAST MOD 18/08/87 E ELSEN
C  TPTR POINTER BUG FIXED                           18/08/87 E ELSEN
C
C  RENAME OF COMMON TO CZRECU AND SUBR. TO ZJHBIT   12/08/87 E ELSEN
C ROUTINE TO DETERMINE WHETHER A TRACK IS AN ELECTRON CANDIDATE
C
C INPUT  NPSPUR = POINTER TO TRACK IN ZE4V BANK
C
C STANDARD CUTS SEE BLOCK DATA
C
C OUTPUT  IKAND=0 ELEKTRON CANDIDATE
C              .NE.0 NO CANDIDATE
C
C-------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT, LCONV
C
      COMMON /BCS/ IW(1)
      DIMENSION HW(1), RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C
      LOGICAL LFIRST / .TRUE. /
C
      COMMON / CZRECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT
C
      IF ( LFIRST ) THEN
        LFIRST = .FALSE.
        WRITE(6,9001)
 9001   FORMAT(/,1X,' ELECTRON SELECTION CRITERIA',/)
        CALL ZJHBIT(ICUT)
C
        CALL FEHLTX( 31,'ZE4VEK: NO ZE4V-BANK')
        CALL FEHLTX( 32,'ZE4VEK: NO CORESPONDING TPTR BANK')
        CALL FEHLTX( 33,'ZE4VEK: NO PHOT-BANK FILLED')
      ENDIF
C
      IKAND=0
C                                      CHECK IF BANKS ARE FILLED
      NPZE4V = IW( IBLN('ZE4V') )
      IF( NPZE4V .LE. 0 ) CALL FEHLER( 31, &7000 )
C
      NTPTR = HW( NPSPUR*2 + 17)
      CALL CLOC( NPTPTR, 'TPTR', NTPTR )
      IF( NPTPTR .LE. 0 ) THEN
        IF( TBIT( ICUT, 26))    CALL FEHLER( 32, &7000 )
        IF( TBIT( ICUT, 25))    CALL FEHLER( 32, &7000 )
        IF( TBIT( ICUT, 24))    CALL FEHLER( 32, &7000 )
      ENDIF
C
      NPPHOT = IW( IBLN('PHOT') )
      IF (NPPHOT .LE. 0 ) THEN
        IF( TBIT( ICUT, 19))    CALL FEHLER( 33, &7000 )
        IF( TBIT( ICUT, 18))    CALL FEHLER( 33, &7000 )
      ENDIF
C
      LT = HW(NPZE4V*2 + 5)
C                                      TRACK # IN PATR - BANK
      INR = HW( NPSPUR*2 + LT*2 + 9 )
C------------------------------------------------- COS(THETA)
      COSTH = ABS( RW( NPSPUR + 3 ))
      IF( COSTH .GT. COSCUT .AND. TBIT(ICUT,29)) IKAND=IKAND+4
C
C------------------------------------------------- MOMENTUM CUT
      PTOT = RW(NPSPUR + 6)
      IF(PTOT .LT. 0.001) PTOT = 0.001
      IF(PTOT .LT. PCUT .AND. TBIT(ICUT,28)) IKAND=IKAND+8
C
C----------DE/DX--------DE/DX--------DE/DX-------- DE/DX CUTS
C
C                                      LOOK INTO TPTR-BANK
      IF( NPTPTR .LE. 0 ) GOTO 2110
C
      NDEX = IW( NPTPTR + 72 )
      DEDX = RW( NPTPTR + 73 )
      IF(DEDX.LT.0.001) DEDX=0.001
      SIGDE = RW( NPTPTR + 74 )
      IF(SIGDE.LE.0.0) SIGDE=10.0
      RELDE = SIGDE / DEDX
C
C---------------------------------------------------------- DE/DX HITS
      IF(NDEX.LT.NDCUT.AND.TBIT(ICUT,26)) IKAND=IKAND+32
C
C------------------------------------------------------ RELATIVE SIGMA
      IF(RELDE.GT.RSCUT.AND.TBIT(ICUT,25)) IKAND=IKAND+64
C
C---------------------------------------------------------- DE/DX
      IDCUT=0
      GOTO (100,110), IDVERS
C                               SIGMA CUT
  100 DELO = 10.0 - DLOCUT*SIGDE
      DEHI = 10.0 + DHICUT*SIGDE
      GOTO 120
C                               FIXED DE/DX CUT
  110 DELO = DFLCUT
      DEHI = DFHCUT
  120 IF( DEDX .LT. DELO .OR. DEDX .GT. DEHI) IDCUT=1
      IF(IDCUT.EQ.1.AND.TBIT(ICUT,24)) IKAND=IKAND+128
C
C--------LEAD GLASS--------LEAD GLASS--------LEAD GLASS------ LG CUTS
C
C                                      LOOK FOR BANKS
 2110 CONTINUE
C
      ESHOWM = RW( NPSPUR + LT + 3 )
C
C-------- GAMMA CONVERSIONS -------- GAMMA CONVERSIONS --------
C
      IF( NPPHOT .LE. 0 ) GOTO 2130
C
      XMINV = 1000.
      IPPHOT = IBLN('PHOT')
        LCONV = .FALSE.
        NPHOT = IPPHOT + 1
  210   NPHOT = IW(NPHOT-1)
        IF( NPHOT.LE.0 ) GO TO 220
        IF( IW(NPHOT+24) .EQ. INR .OR. IW(NPHOT+25) .EQ. INR ) THEN
          LCONV = .TRUE.
          XMINV = RW( NPHOT + 5 )
          GOTO 220
        ENDIF
        GO TO 210
  220 CONTINUE
      IF(LCONV .AND. TBIT(ICUT,19)) IKAND=IKAND+4096
C
      IF(XMINV.LT.AMICUT.AND.TBIT(ICUT,18)) IKAND=IKAND+8192
C
C
 2130 CONTINUE
C
C
C---------------------------------------------------- E/P
      VEREL=AMAX1(0.01,ESHOWM / PTOT)
      IF(VEREL.LT.EPCUT.AND.TBIT(ICUT,12)) IKAND=IKAND+524288
      IF(VEREL.GT.EPHCUT.AND.TBIT(ICUT,11)) IKAND=IKAND+1048576
C
      RETURN
C
 7000 CONTINUE
C
      IKAND = 1000
      RETURN
C
      END
C=======================================================================
C
      BLOCK DATA
C
C     STANDARD SELECTION CUTS FOR ELECTRON CANDIDATES
C
      COMMON  / CZRECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT
C
C
C          STANDARD CUT CRITERIA
      DATA ICUT/ Z001800EC /
C     DATA ICUT/ Z001830EC /
C
C          SCAN FLAG,                 COS(THETA),      MOMENTUM
      DATA ISCUT/ 1 /,  ICHCUT/ 3 /,  COSCUT/ 0.76 /,  PCUT/ 1.0 /
C
C          DE/DX HITS,  RELATIVE SIGMA, DE/DX CUT VERSION
      DATA NDCUT/ 15 /, RSCUT/ 0.175 /, IDVERS/ 1 /
C
C          LOWER          UPPER SIGMA CUT
      DATA DLOCUT/ 1.0 /, DHICUT/ 2.0 /
C
C          LOWER          UPPER FIXED DE/DX CUT
      DATA DFLCUT/ 9.0 /, DFHCUT/ 12.5 /
C
C          UNIQUENESS,     NEAR BY LG ENERGY
      DATA SUMCUT/ 0.15 /, ENECUT/ 0.30 /
C
C          P(CHI**2),       SHADOW ENERGY
      DATA PCHCUT / 0.05 /, ESHCUT/ -0.5 /
C
C          E/P VERSION,  LOWER         UPPER E/P CUT
      DATA JEVERS/ 1 /,  EPCUT/ 0.8 /, EPHCUT/ 2.0 /
C
C          MINIMUM INVARIANT MASS
      DATA AMICUT/ 0.050 /
C
      END
C======================================================================
C
      SUBROUTINE ZJHBIT(KA)
C
C     WRITE BIT PATTERN OF KA
C
      COMMON  / CZRECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT
      DIMENSION JHBIT(32)
C
      INTEGER ONE / 1 /
      DO 103 IB1=1,32
        IF( LAND(KA,SHFTL(ONE,32-IB1)) ) THEN
          JHBIT(IB1) = 1
        ELSE
          JHBIT(IB1) = 0
        ENDIF
  103 CONTINUE
C
      WRITE(6,1014) JHBIT,KA
 1014 FORMAT(1X,32I2,I12)
C
      WRITE(6,9101) JHBIT(32),ISCUT,
     *              JHBIT(31),ICHCUT,
     *              JHBIT(30),COSCUT,
     *              JHBIT(29),PCUT,
     *              JHBIT(28),
     *              JHBIT(27),NDCUT,
     *              JHBIT(26),RSCUT,
     *              JHBIT(25),DLOCUT,DHICUT,IDVERS
 9101 FORMAT(' CUTS USED IN ZE4VEK (0=CUT IS DISABLED)'/
     *       ' --------------------------------------'/
     *       2X,I3,2X,'ISCAN      <',I3,T40,
     *       2X,I3,2X,'ICHECK     >=',I3/
     *       2X,I3,2X,'COSTH      <=',F6.3,T40,
     *       2X,I3,2X,'P          > ',F6.3/
     *       2X,I3,2X,'TRACK IN ZE4V?',T40,
     *       2X,I3,2X,'NDEDX      > ',I3/
     *       2X,I3,2X,'RELDE      < ',F6.3,T40,
     *       2X,I3,2X,F6.3,' < DELDEDX/SIGMA < ',F6.3,' IDVERS=',I3)
      WRITE(6,9102) JHBIT(24),SUMCUT,
     *              JHBIT(23),ENECUT,
     *              JHBIT(22),PCHCUT,
     *              JHBIT(21),ESHCUT,
     *              JHBIT(20),
     *              JHBIT(19),AMICUT
 9102 FORMAT(2X,I3,2X,'UNIQUENESS < ',F6.3,T40,
     *       2X,I3,2X,'NEAR BY E  < ',F6.3/
     *       2X,I3,2X,'P(CHI**2)  > ',F6.3,T40,
     *       2X,I3,2X,'LG10(ESHAD)> ',F6.3/
     *       2X,I3,2X,'PHOT PARTNER?',T40,
     *       2X,I3,2X,'MIN(MIJ)   < ',F6.3)
      WRITE(6,9103) JHBIT(18),
     *              JHBIT(17),
     *              JHBIT(16),
     *              JHBIT(15),
     *              JHBIT(14),
     *              JHBIT(13),EPCUT,JEVERS,
     *              JHBIT(12),EPHCUT
 9103 FORMAT(2X,I3,2X,'OBSOLETE',T40,
     *       2X,I3,2X,'OBSOLETE'/
     *       2X,I3,2X,'OBSOLETE',T40,
     *       2X,I3,2X,'OBSOLETE'/
     *       2X,I3,2X,'OBSOLETE',T40,
     *       2X,I3,2X,'E/P        > ',F6.3,' JEVERS=',I3/
     *       2X,I3,2X,'E/P        < ',F6.3)
      RETURN
      END

C   07/06/96 606071832  MEMBER NAME  BRNM     (S4)          FORTG1
      SUBROUTINE BRNM(NA,NB,NC,ND)
C     BOS SUBPROGRAM =1.1=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
C   30/04/96 604301841  MEMBER NAME  STAR     (BOSLIB.S)    FORTRAN
      REAL STAR/Z0000005C/,FF/Z000000FF/
      EQUIVALENCE (XNAME,INAME)
      LOGICAL NOTLOW
      REAL AND
      EXTERNAL AND
      NOTLOW(XNAME)=AND(XNAME,FF).NE.STAR
      CALL BLOC(IND,NA,NB,*100)
      KK=LFDK
      IS=IW(KK-1)
      IW(KK-1)=IW(LFDI-1)
      CALL BLOC(JND,NC,ND,*20)
      IW(KK-1)=IS
      GOTO 100
   20 IW(IND-1)=IW(LFDK-1)
      IW(LFDK-1)=IND
      IW(IND-3)=NC
      IW(IND-2)=ND
      NN=0
      INAME=NA
      IF(NOTLOW(XNAME)) GOTO 22
      NN=NN-IW(IND)-4
   22 INAME=NC
      IF(NOTLOW(XNAME)) GOTO 24
      NN=NN+IW(IND)+4
   24 NCPL=NCPL+NN
      GOTO 100
C
      ENTRY BSPC(NA,NB,NC,ND)
      NA=NEXT
      NB=NLST-NEXT+1
      NC=NFRE
      ND=NS
  100 RETURN
C
      END

C   22/04/87 706161856  MEMBER NAME  ZFIT     (S)           FORTRAN77
      SUBROUTINE ZFIT
C-----------------------------------------------------------
C  Version of 14/05/87          Last Mod 05/06/87  E Elsen
C  Display z-s-Fit results for ZSFIT or ZSRFTV depending
C  on selection of parameters.
C-----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
C
C  COMMON FOR Z-RESOLUTION PARAMETERS,   USED IN SUBR. AMPS2Z
C
      COMMON / CZSPRM / NZSPRD,
C                                           PARMS FOR RESOLUTIONS
     * AZSRS0(3), AZSRSA(3),
C                                           PARMS FOR CUTS
     * AZSCT1(3), AZSCT2(3), AZSCT3(3), AZSCT4(3),
C                                           SECOND HIT
     * AZSSHT(5,3),
C                                           SECOND HIT DISTANCE
     * AZSSHD(3),
C                                           AVE RESOLUTIONS
     * AZSSAV(3),
C                                           ZSPD BANK FILL FLAG
     * LZSPDF
      LOGICAL LZSPDF
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
      COMMON / CGRAP2 / BCMD, DSPDTM(30), ISTVW, JTVW
C                                           MODEGA = 1 FOR GA
      COMMON / CGAMOD / MODEGA, GAHEX
C
      INTEGER PLOTW(4)
      LOGICAL LDISPL, LZSPD, LHELP
      CHARACTER*80 CLINE
      CHARACTER*1 ANSWER
      CHARACTER*4 CHELP
C
C
      LZSPD = IW(IBLN('ZSPD')).GT.0
      NPPATR = IW(IBLN('PATR'))
      IF( NPPATR.GT.0 ) THEN
        NTR = IW(NPPATR+2)
      ELSE
        NTR = 0
      ENDIF
C
C                                           ZSFIT( 1 ) HAS TO BE DONE TO
C                                           INIT RUN RANGES PROPERLY.
      MODE = 1
      CALL ZSFIT( MODE ,0,0,0,0,1) ! PMF 03/12/99: four dummy arguments + 6th argument added
C                                           ADDITIONAL PARMS
C                                           ON INPUT?
      IF( ACMD.GT.0. .AND. ACMD .LT. 5. ) THEN
        ANSWER = CHAR(IFIX(ACMD+.5)+ICHAR('0'))
      ELSE
        ANSWER = ' '
      ENDIF
      IF( BCMD.GT.0. ) THEN
        ITR = BCMD + .5
      ELSE
        ITR = 0
      ENDIF
C
   10 NPZSPD = IW(IBLN('ZSPD'))
      LDISPL = .FALSE.
      IF(  ANSWER .EQ. ' ' ) THEN
C                                           SELECT FIT TYPE
C                                           IF NOT YET DONE
        IF( MODEGA .EQ. 1 ) THEN
          CALL CLEAR
          LHELP = .TRUE.
        ELSE
          CALL TRMOUT( 80,
     +       ' Z-S-FIT Package. Enter Selection Number (0-4 or HELP)^')
          LHELP = .FALSE.
        ENDIF
   11   IF( LHELP ) THEN
          CALL TRMOUT(80, ' Z-S Fit Package^')
          CALL TRMOUT(80, ' ---------------^')
          CALL TRMOUT(80, ' Display Selection Level:^')
          CALL TRMOUT(80, '                         ^')
          CALL TRMOUT(80, '   0.Quit...........................^')
          IF( LZSPD ) THEN
            CALL TRMOUT(80, '   1.ZSPD Bank......................^')
            CALL TRMOUT(80,
     *             '   or select fit type (overwriting ZSPD banks)^')
          ELSE
            CALL TRMOUT(80, '   or select fit type ^')
          ENDIF
          CALL TRMOUT(80, '   2.ZSFIT single track (PD ).......^')
          CALL TRMOUT(80, '   3.ZSRFTV single track.(JS * EE)..^')
          CALL TRMOUT(80, '   4.ZSRFTV common Z-Fit.(JS * EE)..^')
        ENDIF
        CALL TRMIN(80,CLINE)
        NB = 1
        DO 12 WHILE( CLINE(NB:NB) .EQ. ' ' .AND. NB.LT.80 )
          NB = NB + 1
   12   CONTINUE
        CHELP = CLINE(NB:MIN0(NB+3,80))
        IF( CHELP .EQ. 'HELP' ) THEN
          LHELP = .TRUE.
          GO TO 11
        ENDIF
        ANSWER = CLINE(NB:NB)
      ENDIF
      IF( ANSWER .EQ. '1' .AND. LZSPD ) THEN
C                                           USE AVAILABLE INPUT
        LDISPL = .TRUE.
      ELSEIF( ANSWER .EQ. '2' ) THEN
        CALL BMLT(1,'ZSPD')
        CALL BDLM
        LZSPD = .FALSE.
        LZSPDF = .TRUE.
        MODE = 0
        CALL ZSFIT( MODE,0,0,0,0,1 )! PMF 03/12/99: four dummy arguments + 6th argument added
        LZSPDF = .FALSE.
        LDISPL = .TRUE.
      ELSEIF( ANSWER .EQ. '3' ) THEN
        CALL BMLT(1,'ZSPD')
        CALL BDLM
        LZSPD = .FALSE.
        IOPT = 1 + 8
        MODE = 0
        CALL ZSRFTV( MODE, IOPT )
        LDISPL = .TRUE.
      ELSEIF( ANSWER .EQ. '4' ) THEN
        CALL BMLT(1,'ZSPD')
        CALL BDLM
        LZSPD = .FALSE.
        IOPT = 2 + 8
        MODE = 0
        CALL ZSRFTV( MODE, IOPT )
        LDISPL = .TRUE.
      ENDIF
C                                           RESET ANSWER
      ANSWER = ' '
C
      IF( LDISPL ) THEN
        CALL SEETW ( PLOTW(1), PLOTW(2), PLOTW(3), PLOTW(4) )
  110   IF( ITR .EQ. 0 ) THEN
          WRITE(CLINE,9101) NTR
 9101     FORMAT(' Enter Track Number (1-',I2,')^')
          CALL TRMOUT(80, CLINE )
          CALL TRMIN(80, CLINE)
          NB = 1
          DO 111 WHILE( CLINE(NB:NB) .EQ. ' ' .AND. NB.LT.80 )
            NB = NB + 1
  111     CONTINUE
          ANSWER = CLINE(NB:NB)
          IF( ANSWER .NE. ' ' ) READ(CLINE,*) ITR
        ENDIF
  120   IF( ITR.NE.0 ) THEN
          ITROLD = ITR
          CALL ZFITDS( ITR )
          IF( ITR .NE. ITROLD ) THEN
            ITR = IABS(ITR)
            GO TO 120
          ENDIF
C         ITR = 0
C         GO TO 110
        ENDIF
        ITR = 0
        CALL TWINDO( PLOTW(1), PLOTW(2), PLOTW(3), PLOTW(4) )
        CALL SETSCL(JTVW )
        LDISPL = .FALSE.
        ANSWER = ' '
        GO TO 10
      ENDIF
      IF( .NOT. LZSPD ) THEN
        CALL BMLT(1,'ZSPD')
        CALL BDLM
      ENDIF
      END

C   01/11/84 601301622  MEMBER NAME  COMWRD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE COMWRD
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY  17/05/84 :  DEFINE COMMAND WORDS DICTIONARY
C
C       MOD:   J. HAGEMANN 19/10/84 :  WORD 'AMPLITUDES' DEFINED
C  LAST MOD:   J. HAGEMANN 30/01/86 :  WORDS 'VTXC' AND 'PICK' DEFINED
C
C     THIS ROUTINE SETS UP A LIST OF WORDS THAT DEFINE THE
C     COMMAND LANGUAGE OF THE JADE GRAPHICS PROGRAM.
C     MACRO CGRCOM  CONTAINS VARIABLES WHICH STORE THE POINTERS
C     TO THESE COMMAND WORDS AND IS NEEDED BY S/R DEFCMD.
C
C     SUGGESTION: ADD NEW COMMAND WORDS IN ALPHABETICAL ORDER
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C
C-----------------------------  MACRO CGRCOM  --------------------------
C
C                            THIS MACRO DEFINES THE NAMES OF THE
C                            VARIABLES WHICH POINT TO COMMAND WORDS.
C
C
      COMMON / CGRCO1 /   HADC,   HADD,   HALTER, HAMPL,  HAXES,
     +                    HBANK,  HCAPS,  HCHAM,  HCHANG, HCLUST,
     +                    HCOMMD, HCOMEN, HCONT,  HCOPY,  HCOUNT,
     +                    HCWORK, HCYL,   HDATA,  HDEDX,  HDEL,
     +                    HDETLS, HDET,   HDISP,  HDRAW,  HEDIT,
     +                    HENDC,  HEVENT, HEXT
C
      COMMON / CGRCO2 /   HFAMP,  HFILTR, HFIND,  HFIT,   HFLAG,
     +                    HFLASH, HFORWD, HFRONT, HFW,    HGLASS,
     +                    HGOOD,  HHARD,  HHELP,  HID,    HINNER,
     +                    HJET,   HJETC,  HJUMP,  HLEAD,  HLEVEL,
     +                    HLG,    HLIMIT, HLIST,  HMAP,   HMASS,
     +                    HMENU,  HMUON,  HMUPT
C
      COMMON / CGRCO3 /   HNEWS,  HNEXT,  HNO,    HNORD,  HNR,
     +                    HNUMB,  HOPT,   HPARAM, HPARMS, HPATR,
     +                    HPATRN, HPHI,   HPICK,  HPLOTS, HPROJ,
     +                    HQ,     HRECAL, HRECOG, HREGN,  HRESET,
     +                    HRESLT, HRETRN, HR,     HRZ,    HSAVE,
     +                    HSCALE, HSET,   HSHOW
C
      COMMON / CGRCO4 /   HSIDE,  HSTAND, HSTAT,  HTAGG,  HTOF,
     +                    HTOP,   HTRACK, HTRUE,  HTRIG,  HT1,
     +                    HT2,    HT3,    HVERTX, HVIEW,  HVTXC,
     +                    HWRK,   HWRITE, HXY,    HXZ,    HZ
C
C----------------------------  END OF MACRO CGRCOM  --------------------
C
C
C------------------  C O D E  ------------------------------------------
C
      CALL DEFWRD( HADC,   'ADC^'           )
      CALL DEFWRD( HADD,   'ADD^'           )
      CALL DEFWRD( HALTER, 'ALTER^'         )
      CALL DEFWRD( HAMPL,  'AMPLITUDES^'    )
      CALL DEFWRD( HAXES,  'AXES^'          )
      CALL DEFWRD( HBANK,  'BANK^'          )
C
      CALL DEFWRD( HCAPS,  'CAPS^'          )
      CALL DEFWRD( HCHAM,  'CHAMBER^'       )
      CALL DEFWRD( HCHANG, 'CHANGE^'        )
      CALL DEFWRD( HCLUST, 'CLUSTERS^'      )
      CALL DEFWRD( HCOMMD, 'COMMANDS^'      )
C
      CALL DEFWRD( HCOMEN, 'COMMENTS^'      )
      CALL DEFWRD( HCONT,  'CONTINUE^'      )
      CALL DEFWRD( HCOPY,  'COPY^'          )
      CALL DEFWRD( HCOUNT, 'COUNTERS^'      )
      CALL DEFWRD( HCWORK, 'CWORK^'         )
C
      CALL DEFWRD( HCYL,   'CYLINDER^'      )
      CALL DEFWRD( HDATA,  'DATA^'          )
      CALL DEFWRD( HDEDX,  'DEDX^'          )
      CALL DEFWRD( HDEL,   'DELETE^'        )
      CALL DEFWRD( HDETLS, 'DETAILS^'       )
C
      CALL DEFWRD( HDET,   'DETECTOR^'      )
      CALL DEFWRD( HDISP,  'DISPLAY^'       )
      CALL DEFWRD( HDRAW,  'DRAW^'          )
      CALL DEFWRD( HEDIT,  'EDIT^'          )
      CALL DEFWRD( HENDC,  'ENDCAPS^'       )
C
      CALL DEFWRD( HEVENT, 'EVENT^'         )
      CALL DEFWRD( HEXT,   'EXTERNAL^'      )
      CALL DEFWRD( HFAMP,  'FAMP^'          )
      CALL DEFWRD( HFILTR, 'FILTER^'        )
      CALL DEFWRD( HFIND,  'FIND^'          )
C
      CALL DEFWRD( HFIT,   'FIT^'           )
      CALL DEFWRD( HFLAG,  'FLAG^'          )
      CALL DEFWRD( HFLASH, 'FLASH^'         )
      CALL DEFWRD( HFORWD, 'FORWARD^'       )
      CALL DEFWRD( HFRONT, 'FRONT^'         )
C
      CALL DEFWRD( HFW,    'FW^'            )
      CALL DEFWRD( HGLASS, 'GLASS^'         )
      CALL DEFWRD( HGOOD,  'GOOD^'          )
      CALL DEFWRD( HHARD,  'HARDCOPY^'      )
      CALL DEFWRD( HHELP,  'HELP^'          )
C
      CALL DEFWRD( HID,    'ID^'            )
      CALL DEFWRD( HINNER, 'INNER^'         )
      CALL DEFWRD( HJET,   'JET^'           )
      CALL DEFWRD( HJETC,  'JETC^'          )
      CALL DEFWRD( HJUMP,  'JUMP^'          )
C
      CALL DEFWRD( HLEAD,  'LEAD^'          )
      CALL DEFWRD( HLEVEL, 'LEVEL^'         )
      CALL DEFWRD( HLG,    'LG^'            )
      CALL DEFWRD( HLIMIT, 'LIMITS^'        )
      CALL DEFWRD( HLIST,  'LIST^'          )
C
      CALL DEFWRD( HMAP,   'MAP^'           )
      CALL DEFWRD( HMASS,  'MASS^'          )
      CALL DEFWRD( HMENU,  'MENU^'          )
      CALL DEFWRD( HMUON,  'MUON^'          )
      CALL DEFWRD( HMUPT,  'MUPT^'          )
C
      CALL DEFWRD( HNEWS,  'NEWS^'          )
      CALL DEFWRD( HNEXT,  'NEXT^'          )
      CALL DEFWRD( HNO,    'NO^'            )
      CALL DEFWRD( HNORD,  'NORD50^'        )
      CALL DEFWRD( HNR,    'NR^'            )
C
      CALL DEFWRD( HNUMB,  'NUMBER^'        )
      CALL DEFWRD( HOPT,   'OPTIONS^'       )
      CALL DEFWRD( HPARAM, 'PARAMETERS^'    )
      CALL DEFWRD( HPARMS, 'PARMS^'         )
      CALL DEFWRD( HPATR,  'PATR^'          )
C
      CALL DEFWRD( HPATRN, 'PATTERN^'       )
      CALL DEFWRD( HPHI,   'PHI^'           )
      CALL DEFWRD( HPICK,  'PICK^'          )
      CALL DEFWRD( HPLOTS, 'PLOTS^'         )
      CALL DEFWRD( HPROJ,  'PROJECTIONS^'   )
      CALL DEFWRD( HQ,     'Q^'             )
C
      CALL DEFWRD( HRECAL, 'RECALIBRATE^'   )
      CALL DEFWRD( HRECOG, 'RECOGNITION^'   )
      CALL DEFWRD( HREGN,  'REGION^'        )
      CALL DEFWRD( HRESET, 'RESET^'         )
      CALL DEFWRD( HRESLT, 'RESULTS^'       )
C
      CALL DEFWRD( HRETRN, 'RETURN^'        )
      CALL DEFWRD( HR,     'R^'             )
      CALL DEFWRD( HRZ,    'RZ^'            )
      CALL DEFWRD( HSAVE,  'SAVE^'          )
      CALL DEFWRD( HSCALE, 'SCALE^'         )
C
      CALL DEFWRD( HSET,   'SET^'           )
      CALL DEFWRD( HSHOW,  'SHOW^'          )
      CALL DEFWRD( HSIDE,  'SIDE^'          )
      CALL DEFWRD( HSTAND, 'STANDARD^'      )
      CALL DEFWRD( HSTAT,  'STATUS^'        )
C
      CALL DEFWRD( HTAGG,  'TAGGING^'       )
      CALL DEFWRD( HTOF,   'TOF^'           )
      CALL DEFWRD( HTOP,   'TOP^'           )
      CALL DEFWRD( HTRACK, 'TRACK^'         )
      CALL DEFWRD( HTRUE,  'TRUE^'          )
C
      CALL DEFWRD( HTRIG,  'TRIGGER^'       )
      CALL DEFWRD( HT1,    'T1^'            )
      CALL DEFWRD( HT2,    'T2^'            )
      CALL DEFWRD( HT3,    'T3^'            )
      CALL DEFWRD( HVERTX, 'VERTEX^'        )
C
      CALL DEFWRD( HVIEW,  'VIEW^'          )
      CALL DEFWRD( HVTXC,  'VTXC^'          )
      CALL DEFWRD( HWRK,   'WORK^'          )
      CALL DEFWRD( HWRITE, 'WRITE^'         )
      CALL DEFWRD( HXY,    'XY^'            )
C
      CALL DEFWRD( HXZ,    'XZ^'            )
      CALL DEFWRD( HZ,     'Z^'             )
C
      RETURN
      END

      SUBROUTINE TRLORD
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
      DIMENSION HORD(9)
      CALL SETSL(HORD(1),0,18,0)
      IF(NTR.LE.0) RETURN
      DO 13000 I=1,NTR
      NELM=HNREL(I)
      IF(
     - NELM.GT.1
     -)THEN
      DO 13002 IJ=1,NELM
      ITK=HISTR(IJ,I)
      ITK=IABS(ITK)
      IF(
     - ITK.GT.0
     -)THEN
      IC=IPCL(ITK)
      IF(IC.LE.24) IRING=1
      IF(IC.GT.24.AND.IC.LE.48) IRING=2
      IF(IC.GT.48) IRING=3
      IW=NWR2(ITK)
      ISORT=ISHFTL(IRING,5)
      ISORT=ISORT+IW
      HORD(IJ)=ISORT
      ENDIF
13002 CONTINUE
13003 CONTINUE
      IT=NELM-1
      DO 13004 I1=1,IT
      ITMP=I1+1
      DO 13006 I2=ITMP,NELM
      IF(
     - HORD(I1).LT.HORD(I2)
     -)THEN
      IEMP=HORD(I1)
      HORD(I1)=HORD(I2)
      HORD(I2)=IEMP
      IEMP=HISTR(I1,I)
      HISTR(I1,I)=HISTR(I2,I)
      HISTR(I2,I)=IEMP
      ENDIF
13006 CONTINUE
13007 CONTINUE
13004 CONTINUE
13005 CONTINUE
      ENDIF
13000 CONTINUE
13001 CONTINUE
      NUM=100-NTR
      IF(
     - NUM.GT.0
     -)THEN
      DO 13008 I=1,NUM
      HNREL(NTR+I)=0
      DO 13010 J=1,9
      HISTR(J,NTR+I)=0
13010 CONTINUE
13011 CONTINUE
13008 CONTINUE
13009 CONTINUE
      ENDIF
      RETURN
      END

C   07/06/96 606071850  MEMBER NAME  ILINK    (S4)          FORTG1
      FUNCTION ILINK(NAME,NR)
C
C     BAS05     FUNCTION ILINK  /  VERSION FOR F1EBLO.BOSLIB.S/L
C
C     ILINK RETURNS THE INDEX OF THE BANK (NAME,NR) OR ZERO
C
C               ---- --
C     IND=ILINK(NAME,NR)
C     ---
C
C     IND=INDEX TO BANK (NAME,NR), IF THE BANK EXISTS
C     IND=0 OTHERWISE (IN THIS CASE THE NAME IS NOT ADDED TO THE
C     INTERNAL LIST (SEE IBLN)
C
C     --------------------------------------------------------------
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1,
     9   JNAM,NLK,NLM,ILKNA,ILKIN,ILKND,LKNAME,LKNR,ICUST,IREV,
     *   NUNTB,DUMMY(9)
C     --------------------------------------------------------------
      COMMON/BCS/IW(1)
C     --------------------------------------------------------------
      ILINK=0
      LKNAME=NAME
      LKNR  =NR
C
C     REDUCE LOOPS, IF PREVIOUS BANK IS NEAR PRESENT BANK
C
C  20 IF(JNAM.EQ.0.OR.IW(INAMV+JNAM).NE.NAME) GOTO 21
C     IF(LFDI.EQ.0)      GOTO 23
C     IF(IW(LFDI-2)-NR) 24,25,23
C
C     LOOP TO FIND INDEX TO NAME (INLINE IBLN)
C
   21 IW(INAMV)=NAME
      JNAM=MOD(IABS(NAME),NPRIM)+NAMAX1
   22 JNAM=IW(JNAM+IPLST)
      IF(IW(JNAM+INAMV).NE.IW(INAMV)) GOTO  22
      IF(JNAM.EQ.0)                   GOTO 100
C
C     LOOP TO FIND BANK WITH NUMBER NR
C
   23 LFDI=JNAM+1
   24 LFDK=LFDI
      LFDI=IW(LFDI-1)
      IF(LFDI.EQ.0)      GOTO 100
      IF(IW(LFDI-2)-NR) 24,25,100
C
C     INDEX TO BANK FOUND
C
   25 ILINK=LFDI
  100 RETURN
      END

C   19/02/84 705211107  MEMBER NAME  RDPATR   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDPATR
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     2/05/79 :  INSERT DEVIATIONS IN PATR BANK
C
C   LAST MOD: E. ELSEN    10/04/81 :
C
C    INSERT APPROPRIATE AVERAGE DEVIATIONS FOR FITS IN R-PHI-
C    AND R-Z-PLANE IN PATR, 12
C    SET NTR PROPERLY IN CASES WHERE THERE ARE TOO MANY
C    TRACKS WHICH HAVE NOT BEEN PROPERLY RECORDED IN PATR BANK 12
C
C-----------------------------------------------------------------------
C
      INTEGER*2 HDATA
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C
      COMMON / CJDRCH / RDEC(4),
     *                  PSIIN(3),
     *                  RINCR(3),
     *                  FIRSTW(3),
     *                  FSENSW(3),
     *                  RDEPTH,
     *                  SWDEPL,
     *                  YSUSPN,
     *                  TIMDEL(6), ZMAX, ZOFFS, ZRESOL, ZNORM,ZAL,ZSCAL,
     *                  DRIDEV,DRICOS,DRISIN
C
      DATA S12 / 3.4641016 /
C
C------------------  C O D E  ------------------------------------------
C
      CALL BLOC( IPJ, 'PATR', 12, *8000 )
      NTR = IDATA(IPJ+2)
      IF( NTR .LE. 0 ) RETURN
C                                           FIX UP FOR LONG PATR BANKS
      NWNTR = (IDATA(IPJ)-IDATA(IPJ+1))/IDATA(IPJ+3)
      IF( NWNTR .LT. NTR ) NTR = NWNTR
      IDATA(IPJ+2) = NTR
C
      SRPHI = TIMDEL(1) / S12
      SRZ = ZRESOL
C
      IP = IPJ + IDATA(IPJ+1)
      LTR = IDATA(IPJ+3)
      IEND = IP + ( NTR - 1 ) * LTR
C
      DO 1000 J = IP, IEND, LTR
      ADATA(J+23) = SRPHI
 1000 ADATA(J+32) = SRZ
C
 8000 RETURN
      END

C   12/03/84 406222025  MEMBER NAME  TGDCOS   (S)           FORTRAN
C
C
C
C
C  SUBROUTINE TO CALCULATE DIRECTON COSINES GIVEN X,Y,Z
C
C X,Y,Z - INPUT
C DX,DY,DZ - OUTPUT
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TGDCOS(X,Y,Z,DX,DY,DZ)
C
       R = SQRT(X**2 + Y**2 + Z**2)
       DX = X / R
       DY = Y / R
       DZ = Z / R
       RETURN
       END

C   11/01/81 704021959  MEMBER NAME  TFARNW   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE TFARNW(INLA,INTF,IFLG,*)
C==================================================
C  MODIFIED TO CHECK ON TDCS INSTEAD OF LATCHES
C==================================================
C          CONVERTS THE TOF DATA FROM CAMAC FORMAT
C       TO ANALYSIS FORMAT :
C                   IRAW(1,NCN)= NCN  ; COUNTER#
C      RAW(2,NCN)= TDC(-)-CM(NCN)
C      RAW(3,NCN)= TDC(+)-CP(NCN)
C       OR
C      RAW(2,NCN)= TDC(-) , IF IFLG= 1.
C      RAW(3,NCN)= TDC(+) , IF IFLG= 1.
C                   RAW(4,NCN) = ADC(-)
C                   RAW(5,NCN) = ADC(+)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
      COMMON/TFPRM/ CORNOR(84),COROVF(84),TPARM(41),VELSC,TCALM(42),
     1 TCALP(42),PEDLM(42),PEDLP(42),DUM(90)
      COMMON/TFADC/ CADCA(84),CADCB(84)
      COMMON/PRPOS/PRPLS,CPOS
      INTEGER *2  HADC,HTDC,HEADR(108),HTDC1,HON1,HTSPAR
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42)
      COMMON/TFPED1/HTDC1(2,42),HON1(42),HTSPAR(16)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      DIMENSION MASK(16)
      DIMENSION IRAW(5,42)
      EQUIVALENCE (IRAW(1,1),RAW(1,1))
C
      DATA MASK/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     1          16384,32768/
      DATA IENTRY/0/,LERR/0/,IBUG/0/
      DATA ADCLIM/1./
      IF(IENTRY.NE.0)  GOTO 320
      IENTRY = IENTRY + 1
C
 320  CONTINUE
C
C========= ADDRESSING
C
C     CALL SETSL(RAW,0,20*42,0)
      NRUN = HEADR(18)
      CPOS = HEADR(31)/1000.
       INLA2= INLA*2
       INTF2= INTF*2
       IL0= INLA2+6
       IA0= INTF2+3
       IT0= INTF2+94
C//////////
C     IBUG = IBUG + 1
      BADC = TPARM(1)
      AADC = TPARM(2)
      CALL ATOFUN(INTF)
C
      DO 3000 NCN= 1,42
      IRAW(1,NCN) = 0
      ADCM = HADC(1,NCN)- PEDLM(NCN)
      ADCP = HADC(2,NCN)-PEDLP(NCN)
      IF(NRUN.LE.2306.OR.NCN.LE.38)  GOTO  75
      IF(NRUN.GE.3182)  GOTO  75
      ADCM = ADCM*2
      ADCP = ADCP*2
   75 CONTINUE
C
      IF(NCN.NE.25.AND.NCN.NE.26)  GOTO  76
      IF(NRUN.LT.3728.OR.NRUN.GT.4426)  GOTO  76
      ITDC25 = HTDC(1,25)
      ITDC26 = HTDC(1,26)
      IF(NCN.EQ.25) HTDC(1,25) = ITDC26
      IF(NCN.EQ.26) HTDC(1,25) = ITDC25
   76 CONTINUE
      TDCM = HTDC(1,NCN)
      TDCP = HTDC(2,NCN)
C NEW FOR 1986
      IF(NRUN.GE.24200)
     *TDCM = HTDC(1,NCN)-HTSPAR(3)+465.
      IF(NRUN.GE.24200)
     *TDCP = HTDC(2,NCN)-HTSPAR(3)+465.
C
C========= CHECK THAT BOTH TDC'S HAVE FIRED
C
      IF(HTDC(1,NCN).LT. 5.OR.HTDC(1,NCN).GE.2048)  GOTO  3000
      IF(HTDC(2,NCN).LT. 5.OR.HTDC(2,NCN).GE.2048)  GOTO  3000
C
C========= THEY HAVE
C
 1500 CONTINUE
C
C  COMPUTE PULSEHEIGHT CORRECTION FOR TOF
C
      CORADM = 0.
      CORADP = 0.
      IF(HADC(1,NCN).GE.1024) ADCM = 1024.
      IF(HADC(2,NCN).GE.1024) ADCP = 1024.
      IF(ADCM.LE.1.) ADCM = 1.
      IF(ADCP.LE.1.) ADCP = 1.
      ADCMIV = 1000./ADCM
      ADCPIV = 1000./ADCP
      CORADM =  AADC + BADC*ADCMIV
      CORADP =  AADC + BADC*ADCPIV
      IF(NRUN.LT.3728)  GOTO  20
      CORADM =   CADCB(2*NCN-1)*SQRT(ADCMIV)
      CORADP =   CADCB(2*NCN  )*SQRT(ADCPIV)
   20 IF(ADCM.LT.1024.) CMS = CORNOR(2*NCN-1)
      IF(ADCP.LT.1024.) CPS = CORNOR(2*NCN)
      IF(ADCM.GE.1024.) CMS = COROVF(2*NCN-1)
      IF(ADCP.GE.1024.) CPS = COROVF(2*NCN)
C
C     IF(IBUG.LE.10) PRINT 106,NCN,CADCA(2*NCN-1),CADCB(2*NCN-1),
C    1 CADCA(2*NCN),CADCB(2*NCN)
C     IF(IBUG.LE.10) PRINT 106,NCN,ADCM,ADCP,CORADM,CORADP,CMS,CPS
C 106 FORMAT(' TOFARD',I5,10F10.3)
      IF(TDCM.LT.10..OR.TDCM.GT.2048.)  GOTO  2000
      IF(ADCM.LT.ADCLIM)  GOTO  2000
      TDCM0= TDCM
      IF(IFLG.EQ.1) GO TO 1600
      TDCM0= TDCM0*TCALM(NCN)
      TDCM0= TDCM0-CMS-CORADM
C     IF(IBUG.LE.10) PRINT 106,NCN,TDCM0
 1600 IRAW(1,NCN)= NCN
      RAW(2,NCN)= TDCM0
      RAW(4,NCN)= ADCM
C
 2000 CONTINUE
      IF(TDCP.LT.10..OR.TDCP.GT.2048.)  GOTO  2100
      IF(ADCP.LT.ADCLIM)  GOTO  2100
      TDCP0= TDCP
      IF(IFLG.EQ.1) GO TO 2050
2010  TDCP0= TDCP0*TCALP(NCN)
      TDCP0= TDCP0-CPS-CORADP
C     IF(IBUG.LE.10) PRINT 106,NCN,TDCP0
2050  IRAW(1,NCN)= NCN
      RAW(3,NCN)= TDCP0
      RAW(5,NCN)= ADCP
2100  CONTINUE
C
 3000 CONTINUE
C/////////
      RETURN
      END

C   19/02/84 402192304  MEMBER NAME  RDDOUB   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDDOUB( IDIFF, NHITS, HITS, IERASE )
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    25/04/79 :  DOUBLE HIT RESOLUTION HIT LOSSES
C
C        MOD  E. ELSEN    02/05/79 :
C        MOD  C. BOWDERY  28/09/83 :  POINTERS FROM OLD TO NEW HITS
C        MOD  C. BOWDERY  13/10/83 :  CORRECT PROBLEM OF POINTER TO DEAD
C                                  :  HITS.
C   LAST MOD  C. BOWDERY  17/10/83 :  NEGATIVE POINTER FOR ABSORBED HIT
C
C        SET SOME DRIFT WIRES IN ARRAY HITS WITH NHITS HITS TO
C        ZERO TO ACCOUNT FOR FINITE DOUBLE PULSE RESOLUTION IDIFF.
C        IDIFF IS MINIMUM RESOLVED DISTANCE IN TIMING BINS IN EVERY
C        RING. NUMBER OF ERASED HITS IS IERASE.
C
C-----------------------------------------------------------------------
C
C                  DOUBLE HIT RESOLUTION
C                  ---------------------
C
C        WHEN A HIT REACHES A WIRE IN THE JET CHAMBER, THE ELECTRONICS
C        FOR THAT WIRE ARE NOT SENSITIVE TO ANOTHER HIT FOR ABOUT 120NS.
C        IF ANOTHER HIT ARRIVES WITHIN THAT PERIOD, IT IS LOST BUT THE
C        ELECTRONICS THEN NEEDS A FURTHER 120NS TO RECOVER.
C
C        IN THIS ROUTINE THE HITS ARE PROCESSED IN ORDER OF DECREASING
C        DRIFT TIMES FOR A GIVEN WIRE.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CWORK  / HWORK(20000)
      COMMON / CWORK1 / JHITS, H4VJH(4000), H4VMRG(5000)
C
      DIMENSION IDIFF(3), HITS(2)
C
C------------------  C O D E  ------------------------------------------
C
      IERASE = 0
      DO 10  I = 1,NHITS
        H4VMRG(I) = 0
 10   CONTINUE
C
      IF( NHITS .LT. 2 )  RETURN
C
C                  LOOP OVER ALL HITS AND SET AFFECTED WIRES TO ZERO
C
      N4  = NHITS * 4
      N44 = N4 - 4
      IL  = 1
      KL  = 1
C
  100 IF( HITS(IL) .NE. 0 ) GO TO 200
          IL = IL + 4
          KL = KL + 1
          IF( IL .LT. N44 ) GO TO 100
          GO TO 2000
C
  200 IH = IL + 4
      KH = KL + 1
  210 IF( IH .GT. N4 ) GO TO 2000
      IF( HITS(IH) .NE. 0 ) GO TO 300
          IH = IH + 4
          KH = KH + 1
          GO TO 210
C
C                            HITS BELONG TO THE SAME WIRE ?
C
  300 IF( HITS(IL)/8 .NE. HITS(IH)/8 ) GO TO 1000
          IRING = MIN0( HITS(IL)/3072 + 1, 3 )
          IDR   = HITS(IL+3)-HITS(IH+3)
C
C                            TEST IF DRIFT TIME DIFFERENCE IS SMALLER
C                            THAN 2 HIT RESOLUTION TIME FOR THIS RING
C
          IF( IABS( IDR ) .GT. IDIFF(IRING) ) GO TO 1000
             IF( HITS(IH+1) .LT. HITS(IL+1) )   HITS(IH+1) = HITS(IL+1)
             IF( HITS(IH+2) .LT. HITS(IL+2) )   HITS(IH+2) = HITS(IL+2)
             HITS(IL) = 0
             IERASE = IERASE + 1
C
C                            STORE THE HIT NUMBER THAT THIS HIT WAS
C                            TOO CLOSE TO. SET IT NEGATIVE.
C
             H4VMRG(KL) = -KH
C
C                            FIND ANY POINTERS TO THIS DEAD HIT AND SET
C                            THEM TO THE HIT THAT KILLED THIS HIT.
C                            ONLY SEARCH BACKWARDS UP TO 8 HITS.
C
             KKB = KL - 8
             IF(KKB .LT. 1) KKB = 1
             KKT = KL - 1
             IF(KKT .LT. 1) GO TO 1000
C
             DO  301  KK = KKB,KKT
               IF(H4VMRG(KK) .EQ. -KL ) H4VMRG(KK) = -KH
  301        CONTINUE
C
 1000 IL = IL + 4
      KL = KL + 1
      GO TO 100
C
C                  UPDATE THE ARRAY OF POINTER FROM THE ORIGINAL HITS
C                  TO THE CURRENT HITS FOR EACH HIT MERGED WITH ANOTHER
C                  SO THAT A COMPLETE HISTORY EXISTS.
C

 2000 DO  2010  I = 1,JHITS
        IF( H4VMRG( H4VJH(I) ) .NE. 0 ) H4VJH(I) = H4VMRG( H4VJH(I) )
 2010 CONTINUE
C
      RETURN
      END

C   07/06/96 606071829  MEMBER NAME  BREADC   (S4)          FORTRAN
      SUBROUTINE BREADC
C     BOS SUBPROGRAM =3.1=
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (IW(1),RW(1))
      COMMON/CONTEX/LABL,NSL,NF,FR(36),NB,LBT(72)
      REAL*8 LCD(10)
      LOGICAL*1 LC(80),LBT,PAL/'('/,PAR/')'/,DOLL/'$'/,LH(4)
      INTEGER NFR(36),LIST(4)/'ENDQ','POFF','PON ','UNIT'/,BLK/'    '/
      EQUIVALENCE (LCD(1),LC(1)),(NFR(1),FR(1)),(LABL,LH(1))
      IUN=5
      IPR=1
      IND=0
      WRITE(6,104)
   10 I=1
      READ(IUN,101,END=61) LCD
      CALL READHL(LC)
      DO 20 I=1,4
      IF(LABL.EQ.LIST(I)) GOTO 60
   20 CONTINUE
C     NO SPECIAL CARD
      IF(IND) 22,26,24
   22 IF(LABL.NE.BLK) GOTO 26
      IF(IPR.EQ.1) WRITE(6,104) LCD
      GOTO 10
   24 IF(LABL.EQ.BLK) GOTO 50
C     NEW BANK, DETERMINE TYPE
   26 IND=0
      IF(LABL.EQ.BLK.AND.NF.EQ.0) GOTO 10
      IF(NB.EQ.0) GOTO 40
      IF(LBT(1).NE.PAL.OR.LBT(NB).NE.PAR) GOTO 40
      IF(NF.EQ.2) GOTO 28
      WRITE(6,102) LCD
      CALL BDMPA(41)
   28 CALL BLOC(IND,LABL,NFR(1),&30)
      WRITE(6,103) LCD
      NW=NFR(2)
      CALL BSPC(IUC,NUS,IDUN1,IDUM2)
      IF(NUS.LT.NW) GOTO 90
      READ(IUN,LBT) (IW(IUC+I),I=1,NW)
      IF(IPR.EQ.1) WRITE(6,LBT) (IW(IUC+I),I=1,NW)
      IND=0
      GOTO 10
C     FORMATED INPUT
   30 IF(IPR.EQ.1) WRITE(6,102) LCD,LABL,NFR(1)
      CALL BCRE(IND,LABL,NFR(1),NFR(2),&90,IER)
      NW=NFR(2)
      READ(IUN,LBT) (IW(IND+I),I=1,NW)
      IF(IPR.EQ.1) WRITE(6,LBT) (IW(IND+I),I=1,NW)
      IND=0
      GOTO 10
C     FREE FORMAT INPUT
   40 IF(LH(1).EQ.DOLL.OR.NSL.EQ.1) GOTO 44
      NW=NF
      NR=0
   42 CALL BLOC(IND,LABL,NR,&46)
      NR=NR+1
      GOTO 42
   44 NW=NF-1
      NR=NFR(1)
      CALL BLOC(IND,LABL,NR,&46)
      WRITE(6,103) LCD
      IND=-1
      GOTO 10
   46 IF(IPR.EQ.1) WRITE(6,102) LCD,LABL,NR
      CALL BCRE(IND,LABL,NR,NW,&90,IER)
      IF(NW.EQ.NF) CALL BSTR(IND,FR(1),NW)
      IF(NW.NE.NF) CALL BSTR(IND,FR(2),NW)
      GOTO 10
   50 IF(IPR.EQ.1) WRITE(6,104) LCD
      IF(NF.EQ.0) GOTO 10
      CALL BCHM(IND,NF,IER)
      IF(IER.NE.0) GOTO 90
      INDH=IND+IW(IND)-NF
      CALL BSTR(INDH,FR,NF)
      GOTO 10
C     SPECIAL CARD
   60 WRITE(6,102) LCD
   61 IND=0
      GOTO (62,64,66,68),I
C     END-OF-DATA OR ENDQ-CARD
   62 IF(IUN.EQ.5) GOTO 100
      IUN=5
      GOTO 10
C     POFF-CARD
   64 IPR=0
      GOTO 10
C     PON-CARD
   66 IPR=1
      GOTO 10
C     UNIT-CARD
   68 IUN=NFR(1)
      GOTO 10
C     ERROR, NO SPACE LEFT
   90 WRITE(6,105)
      WRITE(6,104) LCD
      CALL BDMPA(11)
  100 WRITE(6,104)
      RETURN
  101 FORMAT(10A8)
  102 FORMAT(' -------- ',10A8,10X,A4,I10)
  103 FORMAT(' -------- ',10A8,' DOUBLY DEFINED - IGNORED')
  104 FORMAT(10X,10A8)
  105 FORMAT(' --ERROR- INSUFFICIENT SPACE AFTER CARD . . .')
      END

C   26/08/87 708271117  MEMBER NAME  DXMCSP   (S)           FORTRAN77
      SUBROUTINE DXMCSP( NBIN, ISPECT, XBIN )
C----------------------------------------------------------
C  Version of 26/08/87       Last Mod 26/08/87   E Elsen
C  Choose XBIN according to spectrum ISPECT
C  Input:  NBIN   number of bins contained in ISPECT
C          ISPECT differential spectrum (will be integrated)
C  Output  ISPECT integrated spectrum
C          XBIN   bin chosen, interpolated within bins
C----------------------------------------------------------
      INTEGER ISPECT(NBIN)
      LOGICAL FIRST / .TRUE. /
      INTEGER IDELMX / 0 /
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IBINMX = NBIN/2
        DO 10 I=2,NBIN
          IF( ISPECT(I) .GT. IDELMX ) THEN
             IDELMX = ISPECT(I)
             IBINMX = I
          ENDIF
          ISPECT(I) = ISPECT(I-1) + ISPECT(I)
   10   CONTINUE
      ENDIF
C
      X = RN(DUMMY)
      IBX = X*ISPECT(NBIN)
      IBIN = IBINMX
      NS = 1
      NE = NBIN
      DO 100 WHILE( NS.LT.NE-1 )
        IF( IBX .LT. ISPECT(IBIN) ) THEN
          NE = IBIN
        ELSE
          NS = IBIN
        ENDIF
        IBIN = (NE+NS)/2
  100 CONTINUE
C
      IL = NS
      DO 110 WHILE( IL.GT.1 .AND. ISPECT(IL-1).EQ.ISPECT(NS) )
        IL = IL - 1
  110 CONTINUE
C
      IH = NE
      DO 120 WHILE( IH.LT.NBIN .AND. ISPECT(IH+1).EQ.ISPECT(NE) )
        IH = IH + 1
  120 CONTINUE
C                                           INTERPOLATE
      IF( IH.LT.NBIN ) THEN
        XBIN = FLOAT(IH+1-IL)/(ISPECT(IH+1)-ISPECT(IL))*
     *                (ISPECT(NBIN)*X-ISPECT(IL)) + IL
      ELSE
        XBIN = FLOAT(IH-1-IL)/(ISPECT(IH)-ISPECT(IL-1))*
     *                (ISPECT(NBIN)*X-ISPECT(IL-1)) + IL - 1
      ENDIF
      END

C   09/02/87 809301316  MEMBER NAME  TPTRSM   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTRSM
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      22/07/87:  Create track summary banks
C
C          mod: C. Bowdery      26/07/87:  HNPV --> INPV
C          mod: C. Bowdery       6/11/87:  Renamed from TPTRTP
C          mod: C. Bowdery       6/11/87:  No PATR is not an error
C          mod: C. Bowdery      11/01/88:  SETSL--> VZERO
C          mod: C. Bowdery       1/02/88:  No tracks is not an error
C     Last mod: C. Bowdery      30/09/88:  CALL TPSEFL now
C
C     Routine to create summary TPTR banks for ID tracks from PATR bank.
C     Based upon TPPATR by S. Yamada.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      INTEGER  NVLM, PATR

C                            NVLM = no. of words in the TPVX/1 bank

      PARAMETER  ( NVLM   = 100, PATR = 1 )

C                            IV: work space for the event vertex

      INTEGER    IV( NVLM )
      INTEGER*2  HV( 2*NVLM )

      EQUIVALENCE ( HV(1), IV(1) )

C------------------  C O D E  ------------------------------------------

C                            Get magnetic field in gauss --> kgauss

      CALL TPMAGF( BGAUSS )
      BKG = BGAUSS * 0.001

C                            Clear the vertex bank array  IV

      CALL VZERO( IV, NVLM )

C                            Initialise pointer in vertex bank for
C                            storing next track number
      INPV = 30

C                            Get the number of PATR tracks

      IPATR = IDATA( IBLN( 'PATR') )
      IF( IPATR .EQ. 0 ) THEN
        CALL TPWARN
        CALL TPSEFL( PATR, 1000 )
      ELSE

        NTRK = IDATA( IPATR + 2 )
        IF( NTRK .LE. 0 ) THEN

C                            No tracks. Look into this

          CALL TPWARN
          CALL TPSEFL( PATR, 1000 )

        ELSE

C                            NTPTR is the next TPTR bank no. to be made
          NTPTR = 1

C                            Process each track, updating NTPTR

          DO  10  ITRK = 1,NTRK

            CALL TPTRTS( IPATR, ITRK, BKG, NTPTR, HV, INPV, IER )

            IF( IER .NE. 0 ) THEN
              CALL TPSEFL( PATR, 2000 )
              CALL TPWARN
              RETURN
            ENDIF

   10     CONTINUE

C                            Create the TPVX/1 bank with full length
C                            and copy contents of IV into it.

          CALL CCRE( NPVX, 'TPVX',1, NVLM, IER)

          IF( IER .NE. 0 ) THEN

            CALL TPERRH
            CALL TPSEFL( PATR, 2000 )

          ELSE

            CALL BSTR( NPVX, IV, NVLM )

C + + +                      debug start
C           CALL BPRS( 'TPVX',1 )
C + + +                      debug end

          ENDIF

        ENDIF

      ENDIF

      RETURN
      END

C   24/11/78 001151615  MEMBER NAME  XYBLK    (JADEGS)      FORTRAN
      SUBROUTINE XYBLK(NRET,X0,Y0,DX,DY)
C---
C---     DELIVERS THE COORDINATES OF THE LOWER, LEFF-HAND CORNER (X0,Y0)
C---     OF LEAD GLASS BLOCK NUMBER NO IN THE ROLLED-OUT VIEW, AS WELL
C---     AS THE HORIZONTAL AND VERTICAL SIZE OF SAME (DX,DY). CODING
C---     LARGELY COPIED OVER FROM EVDISP. L.H.ON. 13.10.78.
C---
#include "cgraph.for"
      COMMON/CWORK1/DUMMY(15),HWORK(40)
#include "cgeo1.for"
      DATA ICALL/0/
C---
      IF(ICALL.EQ.1) GO TO 1000
      ICALL=1
      OFST1=0.
      OFST2=1.-OFST1
      ADX = 0.
      ADY = 2800.
      YADD = 900.
      ADDEND = 84.*BLFI
      BLSEX = OFST1*BLXY
 1000 CONTINUE
      NO=NRET
      IF((NO.GE.0).AND.(NO.LE.2879)) GO TO 13
C     CALL CORE(HWORK,80)
      WRITE(JUSCRN,101) NO
  101 FORMAT('XYBLK CALLED WITH ILLEGAL BLOCK NO:',I10)
C     CALL TRMOUT(45,HWORK)
      X0=0.
      Y0=0.
      DX=100.
      DY=100.
      GO TO 2000
   13 CONTINUE
      IF(NO.GT.2687) GO TO 12
      DX=BLFI
      DY=BLZ
      NFI =  NO/32
      NZET = NO - NFI*32
      X0 = ADX + NFI*BLFI + BLFI*OFST1
      Y0 = ADY + NZET*BLZ + BLZ*OFST1
      GO TO 2000
   12 CONTINUE
      DX=BLXY
      DY=BLXY
C     REDUCE TO NUMBERS 1 - 192
      NO = NO - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (NO - 1)/96
C     REDUCE TO 1 - 96
      NO = NO - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (NO - 1)/24
C     REDUCE TO 1 - 24
      NO = NO - NQ*24
C     COMPUTE CORNER OF BLOCK IN FIRST QUADRANT
      IF(.NOT.((NO.EQ.1).OR.(NO.EQ.5).OR.(NO.EQ.10).OR.(NO.EQ.16)))
     1GO TO 43
      Y0 = BLSEX
      X0 = 3.4*BLXY - BLSEX + (NO/5)*BLXY
   43 CONTINUE
      IF(.NOT.((NO.EQ.2).OR.(NO.EQ.6).OR.(NO.EQ.11).OR.(NO.EQ.17)))
     1GO TO 44
      Y0 = BLSEX + BLXY
      X0 = 3.*BLXY - BLSEX + (NO/5)*BLXY
   44 CONTINUE
      IF(.NOT.((NO.EQ.3).OR.(NO.EQ.7).OR.(NO.EQ.12).OR.(NO.EQ.18)))
     1GO TO 45
      Y0 = BLSEX + 2.*BLXY
      X0 = 2.*BLXY - BLSEX + (NO/5)*BLXY
   45 CONTINUE
      IF(.NOT.((NO.EQ.8).OR.(NO.EQ.13).OR.(NO.EQ.19).OR.(NO.EQ.20)))
     1GO TO 46
      Y0 = BLSEX + BLXY*3.
      K = NO/5
      IF(K.GT.2) K = 7 - K
      X0 = (K+1)*BLXY-BLSEX
   46 CONTINUE
      IF(.NOT.((NO.EQ.4).OR.(NO.EQ.9).OR.(NO.EQ.15).OR.(NO.EQ.24)))
     1GO TO 47
      X0 = BLXY - BLSEX
      K = (NO-1)/5
      IF(K.EQ.4) K = 3
      Y0 = 2.4*BLXY + BLSEX + K*BLXY
   47 CONTINUE
      IF(.NOT.((NO.EQ.14).OR.(NO.EQ.23)))
     1GO TO 48
      X0 = 2.*BLXY - BLSEX
      Y0 = 4.*BLXY + BLSEX + (NO/15)*BLXY
   48 CONTINUE
      IF(.NOT.((NO.EQ.21).OR.(NO.EQ.22)))
     1GO TO 49
      Y0 = 4.*BLXY + BLSEX
      X0 = - BLSEX + 4.*BLXY - ((NO-2)/20)*BLXY
   49 CONTINUE
C     ROTATE TO CORRECT QUADRANT
      IF(NQ.NE.1) GO TO 50
      REM = X0
      X0 = - Y0
      Y0 = REM - OFST2*BLXY
      GO TO 52
   50 CONTINUE
      IF(NQ.NE.2) GO TO 51
      X0 = - X0 + OFST2*BLXY
      Y0 = - Y0 - OFST2*BLXY
      GO TO 52
   51 CONTINUE
      IF(NQ.NE.3) GO TO 52
      REM = Y0
      Y0 = - X0
      X0 = REM + OFST2*BLXY
   52 CONTINUE
      REM = 0.13
      IF(NE.EQ.1) REM = 1.-REM
      Y0 = Y0 + YADD
      X0 = - X0 + REM*ADDEND
 2000 CONTINUE
      RETURN
      END

C   01/11/84 804281525  MEMBER NAME  RDRESO   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDRESO( BINMC )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    25/04/79 :  SIMULATION OF SPACE RESOLUTION
C                                     IN JET CHAMBER
C        MOD  E. ELSEN    30/05/79 :  ?
C        MOD  J. HAGEMANN 12/01/83 :  DRIFT TIME: A HALF BIN WIDTH HAS
C             R. RAMCKE               BEEN REMOVED
C        MOD  J. OLSSON   12/01/83 :  DRIFT TIME: NEW SMEARING SCHEME
C                                                 AS USED BY W. BARTEL
C        MOD  J. HAGEMANN 07/06/83 :  NOW NO SHIFT IN Z-DIRECTION
C             R. RAMCKE
C        MOD  J. OLSSON   04/08/83 :  NOW ONLY ONE ACTUAL PARAMETER
C        MOD  J. HAGEMANN 08/02/84 :  DRIFT TIME: IMPROVED SMEARING
C             J. OLSSON               SCHEME. RESOLUTION NOW DRIFT
C                                     TIME DEPENDENT
C                                     PARAMETER (0.677E-3) GIVEN BY
C                                     J.SPITZER RESEARCH
C        MOD  J. HAGEMANN 11/10/84 :  FORBID NEGATIVE DRIFT TIMES
C        MOD  E ELSEN   10/12/87   :  R-PHI RESOLUTION (2 GAUSS SCHEME)
C        MOD  E ELSEN   18/03/88   :  R-Z   RESOLUTION (2 GAUSS SCHEME)
C   LAST MOD  E E, J H  28/04/88   :  NO NEG AMPLITUDES
C
C  THE SMEARING ACC. TO BARTEL IS NOW MODIFIED (BY J.HAGEMANN) TO OMIT
C    THE DL8 BINNING. THE SMEARING IS THEREFORE GIVEN ONLY BY RJITT. IN
C    THIS WAY A BETTER AGREEMENT WITH MOMENTUM RESOLUTION, CHISQ. AND
C    VERTEX DISTRIBUTION IS OBTAINED.
C
C   THE VARIABLES IN COMMON/CBIN/....,BINDL8,RJITT
C   ARE BLOCKDATA SET IN SUBROUTINE RDMTCO.
C   SCALE DRIFT TIMES AND COMPUTE Z-AMPLITUDES FROM RAW DATA
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1 LJUMP
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
      COMMON / CADMIN / DUMM(7), ISMEAR
      COMMON / CJDRCH / DRCH(34)
      COMMON / CBIN   / TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3),
     +                BINDL8(6),RJITT, DLRSLN(3), DLZSLN(3)
C
      DIMENSION BINMC(6)
C
      DATA  ICALL /0/
C
C------------------  C O D E  ------------------------------------------
C
      IF( ICALL.EQ.1 ) GO TO 1
         ICALL = 1
         ISMEAR = 1
    1 CONTINUE
C
      IPJ = IDATA( IBLN('JETC') )
      IF( IPJ .EQ. 0 ) RETURN
C
C
      LJUMP = .FALSE.
      IF(BINDL8(1) .EQ. .005 .AND. RJITT .EQ. .0) LJUMP = .TRUE.
      IL4 = IPJ*2 + 101
      IH4 = IL4 + HDATA(IPJ*2+99 ) - 4
C
C                       LOOP OVER ALL WIRES AND SET RESOLUTIONS
      DO 100  J = IL4, IH4, 4
         IF( LJUMP ) GO TO 50
            NWIR   = HDATA(J) / 8
            IR     = MIN0( NWIR/384+1 , 3 )
            ICL    = IR * 2
            IF( MOD(NWIR,16).LT. 8 ) ICL = ICL - 1
C
C                       SET DRIFT TIMES
            IDRI   = HDATA(J+3)
            DRIINT = FLOAT(IDRI)*BINMC(ICL)
            CALL NVERT( 1., 0., G1R )
C                       DRIFT TIME DEPENDENT SMEARING
            RJITT1 = DRIINT*.677E-3 + RJITT
C                                           DOUBLE GAUSSIAN
            IF( RN(DUM).GT.DLRSLN(1) ) GO TO 10
              RJITT1 = G1R*RJITT1
              GO TO 20
   10       CONTINUE
C                                           SHIFTED GAUSSIAN
              RJITT1 = (G1R*DLRSLN(3)-DLRSLN(2))*RJITT1
   20       CONTINUE
            DRIINT = DRIINT + RJITT1
C---------------------------------------------------------------------
            HDATA(J+3) = HFIX(ABS(DRIINT/BINMC(ICL)))
C
C                       SET LEFT AND RIGHT AMPLITUDES
CCCC          XL = HDATA(J+1) - DRCH(27)
   50    IAL  = HDATA(J+1)
         XL   = FLOAT(IAL)
         CALL NVERT( 1., 0., G1R )
         XLL = DRCH(28)
C                                           DOUBLE GAUSSIAN
         IF( RN(DUM).GT.DLZSLN(1) ) GO TO 51
           XLL = XLL*G1R
           GO TO 52
   51    CONTINUE
           XLL = (G1R*DLZSLN(3)-DLZSLN(2))*XLL
   52    CONTINUE
         XLL = XL + XLL
         XL   = XLL / DRCH(30)
         IAR  = HDATA(J+2)
         XR   = FLOAT(IAR)*DRCH(31)
         IAR  = HFIX((XL+.5)*XR)
         IAL  = HFIX((-XL+.5)*XR)
         IF( IAL .LT. 0 .OR. IAL.GT.32767 ) IAL = 0
         IF( IAR .LT. 0 .OR. IAR.GT.32767 ) IAR = 0
         HDATA(J+2) = IAR
         HDATA(J+1) = IAL
  100 CONTINUE
      RETURN
      END

C   07/06/96 606071909  MEMBER NAME  SMOP     (S4)          FORTG1
      SUBROUTINE SMOP(X,Y,DY,N,SY)
      COMMON/FDST/LLA,LLB,LLC,NKA,NKB
      REAL X(120),Y(120),DY(120),SY(120)
      REAL YI(120),W(120)
C
      IP=-1
      DO 10 I=1,N
      IF(DY(I).NE.0.0) IP=0
   10 YI(I)=Y(I)
      IF(IP.NE.0) GOTO 30
      IP=1
      DO 20 I=1,N
      IF(DY(I).LE.0.0) GOTO 20
      IF(Y(I).LE.0.0)  GOTO 30
      SE=SQRT(Y(I))
      IF(ABS(SE-DY(I)).GT.1.E-4*SE) GOTO 30
   20 CONTINUE
      IP=0
C
C
   30 CALL SMHIST(YI,SY,DY,N,IP)
      CALL DEKB(NKB)
      DO 40 I=1,N
   40 CALL GEND(NKA,100,SY(I),X(I))
      CALL PSAF(NKA)
  100 RETURN
      END

C   17/02/81            MEMBER NAME  PRCYCP   (PATRECSR)    FORTRAN
      SUBROUTINE PRCYCP
C
C     SETUP POINTER ARRAY FOR ALL CELLS: P.STEFFEN(78/11/15)
C
      IMPLICIT INTEGER*2 (H)
      COMMON /CDATA/ NWORD,HJCA(120),IPJCA4
      COMMON /CCYCP/ HPTSEC(98)
      COMMON /CLBPGM/ LBPGM(30)
C
C     SET PROGRAM LABEL
      LBPGM(1) = LBPGM(1) + 1
C     ADDRESS OF POINTERS TO CELLS (-1)
      IPJCA2 = IPJCA4 * 2
C
C     COPY CELL POINTERS + CALC. LENGTH
      IP0 = IPJCA2 + 98
      DO 100 ISEG=1,96
        ISEGO = ISEG + IPJCA2
        HPTSEC(ISEG) = HJCA(ISEGO) + IP0
 100  CONTINUE
      HPTSEC(97) = HJCA(ISEGO+1) + IP0
      HPTSEC(98) = 0
      RETURN
      END

C   16/02/84 408232216  MEMBER NAME  DEDXVW   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DEDXVW
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON    05/05/80 :  DRAW DEDX V. MOMENTUM DIAGRAM
C
C        MOD: J. OLSSON    22/11/83 :  NEW THEORETICAL CURVES
C        MOD: C. BOWDERY   02/02/84 :  SMALLER CIRCLES FOR EACH TRACK
C        MOD: C. BOWDERY   03/02/84 :  BUG WITH ERROR BAR REMOVED
C        MOD: C. BOWDERY   15/02/84 :  ADD LABELS TO CURVES
C   LAST MOD: C. BOWDERY   21/03/84 :  BETTER MESSAGE IF NO TRACKS
C        MOD: J. OLSSON    23/08/84 :  NO CALL TO DEDXBN, DONE IN DEDXDS
C
C         SHOW DEDX VS MOMENTUM DIAGRAM FOR ONE EVENT
C
C         DEDX -2    DRAWS STANDARD DIAGRAM
C         DEDX -4    DRAWS THE SAME DIAGRAM BUT SMALLER ON CURRENT VIEW
C         DEDX -5    DRAWS DIAGRAM WITH LARGER DEDX SCALE
C
C         THE TRAILING INTEGER FROM DEDX COMMAND IS IN ACMD IN /CGRAPH/
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL SMALL, LARGE
C
#include "cgraph.for"
#include "cdata.for"
#include "chsym.for"
C
      COMMON / CALIBR / IPOINT(100)
      COMMON / CHEADR / HEAD(108)
      COMMON / CWORK1 / IER, NTR, TRES(10,60), HMW(132)
C
      DIMENSION XCAL(1000), ITRES(10,60)
      EQUIVALENCE (IPOINT(1),XCAL(1))
      EQUIVALENCE (TRES(1,1),ITRES(1,1))
C
C------------------  C O D E  ------------------------------------------
C
      NN = ACMD
C                            NN = -4:  SMALL VIEW
C                            NN = -2:  STANDARD VIEW
C                            NN = -5:  LARGE SCALE VIEW
      SMALL = .TRUE.
      LARGE = .FALSE.
      IF( NN .EQ. -5 ) LARGE = .TRUE.
      IF( NN .NE. -4 ) SMALL = .FALSE.
C
C                            DEFINE WINDOW SIZE
C
      IF( NN .NE. -4 ) GO TO 2801
        CALL TWINDO(370,1200,-30,800)
        GO TO 2802
2801  CALL ERASE
        CALL TWINDO(0,4095,0,4095)
2802  XMINRE = XMIN
      XMAXRE = XMAX
      YMINRE = YMIN
      YMAXRE = YMAX
      XMIN   = -10.
      YMIN   = -10.
      XMAX   =  50.
      YMAX   =  50.
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
C
C                            DRAW DIAGRAM FRAME
C
      FRAC  = ALOG10(5.)
      XVMAX = 60.0 - FRAC * 15.0
      CALL MOVEA(0.,0.)
      CALL DRAWA(XVMAX,0.)
      CALL DRAWA(XVMAX,25.)
      CALL DRAWA(0.,25.)
      CALL DRAWA(0.,0.)
C
C                            DRAW SCALE MARKERS
C
      CALL CHRSIZ(2)
      CALL MOVEA(-2.0, -2.0)
      IF( NN .EQ. -4 ) GO TO 501
C
C                            WRITE TO INTERNAL ARRAY HMW
C                            THEN OUTPUT EBCDIC CHARACTERS ON SCREEN
C
      CALL CORE(HMW,5)
      WRITE(JUSCRN,245)
245   FORMAT(' 0.05')
      CALL EOUTST(5,HMW)
C
501   FRAC1 = (1.0 - FRAC) * 15.0
      CALL MOVEA(FRAC1, 0.0)
      CALL DRAWA(FRAC1, 0.7)
      CALL MOVEA(FRAC1 - 2.0, -2.0)
      IF(NN.EQ.-4) GO TO 502
      CALL CORE(HMW,4)
      WRITE(JUSCRN,247)
247   FORMAT(' 0.1')
      CALL EOUTST(4,HMW)
C
502   CALL MOVEA(FRAC1 + FRAC * 15.0, 0.0)
      CALL DRAWA(FRAC1 + FRAC * 15.0, 0.4)
      CALL MOVEA(FRAC1 + 15.0,  0.0)
      CALL DRAWA(FRAC1 + 15.0,  0.7)
      CALL MOVEA(FRAC1 + 14.0, -2.0)
      IF(NN.EQ.-4) GO TO 503
      CALL CORE(HMW,2)
      WRITE(JUSCRN,228)
228   FORMAT(' 1')
      CALL EOUTST(2,HMW)
C
503   CALL MOVEA(FRAC1 + (1.0 + FRAC) * 15.0, 0.0)
      CALL DRAWA(FRAC1 + (1.0 + FRAC) * 15.0, 0.4)
      CALL MOVEA(FRAC1 + 30.0,  0.0)
      CALL DRAWA(FRAC1 + 30.0,  0.7)
      CALL MOVEA(FRAC1 + 29.0, -2.0)
      IF(NN.EQ.-4) GO TO 504
      CALL CORE(HMW,3)
      WRITE(JUSCRN,229)
229   FORMAT(' 10')
      CALL EOUTST(3,HMW)
C
504   CALL MOVEA(FRAC1 + (2.0 + FRAC) * 15.0, 0.0)
      CALL DRAWA(FRAC1 + (2.0 + FRAC) * 15.0, 0.4)
      CALL MOVEA(FRAC1 + 42.5, -2.0)
      IF(NN.EQ.-4) GO TO 505
      CALL CORE(HMW,4)
      WRITE(JUSCRN,230)
230   FORMAT(' 100')
      CALL EOUTST(4,HMW)
C
505   CALL MOVEA(0.0, 5.0)
      CALL DRAWA(0.7, 5.0)
C
      IF(NN .NE. -4 .AND. .NOT. LARGE) CALL DNUM(5,-2.0,4.5,1.0,0.0)
      IF(LARGE) CALL DNUM(40,-2.5,4.5,1.0,0.0)
      CALL MOVEA(0.0, 10.0)
      CALL DRAWA(0.7, 10.0)
C
      IF(NN .NE. -4 .AND. .NOT. LARGE) CALL DNUM(10,-2.5,9.5,1.0,0.0)
      IF(LARGE) CALL DNUM(80,-2.5,9.5,1.0,0.0)
      CALL MOVEA(0.0, 15.0)
      CALL DRAWA(0.7, 15.0)
C
      IF(NN .NE. -4 .AND. .NOT. LARGE) CALL DNUM(15,-2.5,14.5,1.0,0.0)
      IF(LARGE) CALL DNUM(120,-3.0,14.5,1.0,0.0)
      CALL MOVEA(0.0, 20.0)
      CALL DRAWA(0.7, 20.0)
C
      IF(NN .NE. -4 .AND. .NOT. LARGE) CALL DNUM(20,-2.5,19.5,1.0,0.0)
      IF(LARGE) CALL DNUM(160,-3.0,19.5,1.0,0.0)
C
      IF(NN .NE. -4 .AND. .NOT. LARGE) CALL DNUM(25,-2.5,24.5,1.0,0.0)
      IF(LARGE) CALL DNUM(200,-3.0,24.5,1.0,0.0)
C
C                            DEDX ANALYSIS
C
C     CALL DEDXBN
      NTRR = MIN0(NTR,60)
      IF( NTRR .NE. 0 ) GO TO 3201
      CALL TRMOUT(80,'THERE ARE NO TRACKS TO DRAW^')
      GO TO 998
C
 3201 DO  3202  ITR = 1,NTRR
        DEDX   = TRES(2,ITR)
        ERDEDX = TRES(3,ITR)
        PDEDX  = TRES(9,ITR)
C
        IF(DEDX  .LT. 0.1)                      GO TO 3202
        IF(DEDX  .GT. 80  .AND. .NOT. LARGE)    GO TO 3202
        IF(PDEDX .GT. 100 .OR. PDEDX .LT. 0.05) GO TO 3202
C
        PDEDX  = ALOG10(PDEDX)
        PDEDX  = FRAC1 + (1.0 + PDEDX) * 15.0
        DEDXSC = DEDX
        ERRDSC = ERDEDX
C
        IF(LARGE) DEDXSC = DEDX   * 0.125
        IF(LARGE) ERRDSC = ERDEDX * 0.125
        BAR = .15
        IF(LARGE) BAR = BAR * 0.125
C
C                            DRAW 'SOLID' CIRCLE AT DATA POINT
C
        CALL PLYGON(16,BAR,PDEDX,DEDXSC,0)
C
        CALL MOVEA( PDEDX-BAR, DEDXSC )
        CALL DRAWA( PDEDX+BAR, DEDXSC )
C
C                            NOTE THAT SQRT(2.3) IS AN EMPIRICAL FACTOR
C
        CALL MOVEA( PDEDX+BAR/SQRT(2.3), DEDXSC+BAR/SQRT(2.3) )
        CALL DRAWA( PDEDX-BAR/SQRT(2.3), DEDXSC-BAR/SQRT(2.3) )
        CALL MOVEA( PDEDX+BAR/SQRT(2.3), DEDXSC-BAR/SQRT(2.3) )
        CALL DRAWA( PDEDX-BAR/SQRT(2.3), DEDXSC+BAR/SQRT(2.3) )
C
C                            DRAW ERROR BAR
C
        CALL MOVEA(PDEDX,DEDXSC+ERRDSC)
        CALL DRAWA(PDEDX,DEDXSC-ERRDSC)
C
C                            DRAW TRACK NUMBER
C
        DESIZE = .5
        IF(NN.EQ.-4) DESIZE = 1.5
        CALL DNUM(ITR, PDEDX + 0.35, DEDXSC + 0.35, DESIZE, 0.0)
3202  CONTINUE
C
C                            DRAW "THEORETICAL" CURVES FROM A.WAGNER
C
       CALL DRTHCV( FRAC1, LARGE, SMALL )
C
C                            DRAW AXES CAPTIONS (LOWER CASE!)
C
1441  IF(NN.EQ.-4) GO TO 998
      CALL CHRSIZ(2)
      CALL MOVEA(40.,-2.5)
      CALL CORE(HMW,6)
      WRITE(JUSCRN,3209)
3209  FORMAT(' GeV/c')
      CALL EOUTST(6,HMW)
C
      CALL MOVEA(22.,-2.5)
      CALL CORE(HMW,9)
      WRITE(JUSCRN,3210)
3210  FORMAT(' Momentum')
      CALL EOUTST(9,HMW)
C
      CALL MOVEA(-6.,22.5)
      CALL CORE(HMW,7)
      WRITE(JUSCRN,3211)
3211  FORMAT(' keV/cm')
      CALL EOUTST(7,HMW)
C
      CALL MOVEA(-6.,12.5)
      CALL CORE(HMW,6)
      WRITE(JUSCRN,3212)
3212  FORMAT(' dE/dx')
      CALL EOUTST(6,HMW)
C***
C***                    WRITE CAPTION
C***
      INDES = -1
      CALL CAPMRK(INDES,IESUM)
998   CALL TWINDO(0,4095,0,4095)
      XMIN = XMINRE
      XMAX = XMAXRE
      YMIN = YMINRE
      YMAX = YMAXRE
      CALL SETSCL(LASTVW)
      RETURN
      END

C----------- START OF MACRO CMUSTAT ------------------------------------
C   LAST CHANGE 12.47 15/06/79 JOHN ALLISON.
C      /CMUSTT/
C
      COMMON / CMUSTT / MUTIT(100),NMU(100)
      REAL*8 MUTIT, MUT1(50), MUT2(50)
      EQUIVALENCE(MUTIT(1),MUT1(1)),(MUTIT(51),MUT2(1))
C
C  NMU ARE USED FOR STATISTICS COUNTING IN THE MUON ROUTINES
C
C------------ END OF MACRO CMUSTAT -------------------------------------

C   09/07/85 508061822 MEMBER NAME  HELPUS   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE HELPUS
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   9/07/85 :  GIVE HELP IN GRAPHICS
C
C LAST MOD:   C. BOWDERY   3/08/85 :  GIVE HELP FOR MACROS NOW
C
C
C     DETERMINES THE RECORD NUMBER ON THE DIRECT ACCESS DATASET WHICH
C     CONTAINS THE HELP INFORMATION FOR THE REQUIRED ITEM. THIS IS
C     THEN READ AND THE CONTENTS SENT TO THE SCREEN. MACROS ARE
C     TREATED DIFFERENTLY (DISPLAY DEFINITION FROM COMMON).
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS, CQUEST
      LOGICAL*1  CDEF
C
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
      COMMON / CWORK3 / CHARS(80), ISTAFL(80), IENDFL(80), IAR(240)
C
      DATA  CQUEST / '?' /
C
*** PMF 21/10/99:  needed by INQUIRE
      LOGICAL OP
      CHARACTER*44 FNAM    
*** PMF (end)
*** PMF 03/12/99
      CHARACTER*80 CHARS2
      EQUIVALENCE(CHARS2,CHARS(1))
*** PMF(end)
CC
C-------------------  C O D E  -----------------------------------------
C
*** PMF 19/10/99
*      DEFINE FILE 50 ( 200, 1024, E, I1 )
      INQUIRE(UNIT=50,OPENED=OP,NAME=FNAM)
      IF(OP) THEN
         CLOSE(50)
         OPEN(UNIT=50,FILE=FNAM,ACCESS='DIRECT',RECL=1024,
     +        FORM='FORMATTED',STATUS='OLD')
         IREC=1
      ENDIF
* PMF (end)
C
C                            CLRCON CLEARS COMMAND INPUT SCREEN
C
   7  CONTINUE !CALL CLRCON PMF 03/12/99
C
C                            WHAT HELP IS WANTED?
C
      CALL HELPLI
  20  WRITE(6,30)
  30  FORMAT(/' HELP:  Enter name of item you want help for ',
     + '    (or press ENTER to end HELP)')
C
C                            FURTHER HELP LOOP BEGINS HERE
C
  22  READ(5,40) CHARS
  40  FORMAT(80A1)
      CALL CLTOU(CHARS2)
C
C                            WHICH RECORD NUMBER HAS THE INFO
C
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .EQ. 0 ) RETURN
      LEN = IENDFL(1) - ISTAFL(1) + 1
      CALL FINABR( CHARS(ISTAFL(1)), LEN, IREC, MAXARG, IS )
      IF( IREC .GT. 0 ) GO TO 50
      IF( CHARS(ISTAFL(1)) .EQ. CQUEST  .AND.  LEN .EQ. 1
     +    .AND.  NFIELD .EQ. 1                           ) GO TO 7
C
      WRITE(6,45)
  45  FORMAT(' Sorry. No information available about that.'/)
      WRITE(6,47)
  47  FORMAT(' HELP:  Enter name of next item   or   ? (= List)',
     + '   or press ENTER (= end HELP)')
      GO TO 22
C
C                            COMMAND OR MACRO? MACROS START AT MACSTA
C
  50  IF( IREC .LT. MACSTA ) GO TO 55
        CALL HLPMAC( IREC, CHARS(ISTAFL(1)), LEN )
        WRITE(6,47)
        GO TO 22
C                            GET RECORD FROM DIRECT ACCESS DATASET
C
*** PMF 09/08/99
*     55  READ(50'IREC,60) LEN,(IAR(K),K=1,LEN)
 55   CONTINUE
      IF( OP ) THEN
         READ(50,REC=IREC,FMT=60) LEN,(IAR(K),K=1,LEN)
         IREC=IREC+1
      ENDIF
*** PMF (end)
  60  FORMAT(I4,240A4)
C
C                            CLEAR SCREEN AND WRITE OUT INFO
C
      CONTINUE ! CALL CLRCON PMF 03/12/99
C
  80  WRITE(6,90) (IAR(K),K=1,LEN)
  90  FORMAT(/X,20A4//15(X,20A4/))
C
      WRITE(6,47)
      GO TO 22
      END

C   31/08/78 704251604  MEMBER NAME  NEWDIR   (S)           FORTRAN
      SUBROUTINE NEWDIR(DIR,TH)
C
C---- CHANGE DIRECTION COSIGNS FOR BENDING ANGLE OF TH.
C
C     A.SATO   XX-09-77
C     LAST MODIFICATION  19-11-81  13:30   S.YAMADA
C
      DIMENSION DIR(3),A(3),B(3)
      REAL *8 A,B,AL,AM,AN,CONRVS,CON,ALAM2,ALAM,ALMN(3)
      EQUIVALENCE (ALMN(1),AL),(ALMN(2),AM),(ALMN(3),AN)
C
      CTH=COS(TH)
      STH=SIN(TH)
      GO TO 1
C
C*******
C      MODIFIED  18-05-78  17:20
C
      ENTRY NEWDR1(DIR,CTH,STH)
C
C---- MODIFIED  18-11-81   13:25
C     CHECK CTH AND STH
      IF( ABS(CTH).GT.1.0 .OR. ABS(STH).GT.1.0 ) GO TO 92
      CS2 = CTH*CTH+STH*STH
      IF( CS2.LT.0.999 .OR. CS2.GT.1.001 ) STH = SQRT(1.0-CTH*CTH)
C
C**GET RANDOM AZIMUTHAL COS, SIN
    1 XR1=RN(DAM)
      XR2=RN(DAM)
      IF(XR1.EQ.0. .AND. XR2.EQ.0.) GO TO 90
      XR1=2.*(XR1-.5)
      X=XR1*XR1+XR2*XR2
      IF(X-1.) 2,2,1
    2 C=(XR1*XR1-XR2*XR2)/X
      S=2.*XR1*XR2/X
      GO TO 8
C***********************************************************
      ENTRY NEWDR2(DIR,CTH,STH,C,S)
C
C     CHECK CTH,STH, C AND S
      IF( ABS(CTH).GT.1.0 .OR. ABS(STH).GT.1.0 ) GO TO 93
      CS2 = CTH*CTH+STH*STH
      IF( CS2.LT.0.999 .OR. CS2.GT.1.001 ) STH = SQRT(1.0-CTH*CTH)
      CS2 = C*C+S*S
      IF( CS2.LT.0.999 .OR. CS2.GT.1.001 ) GO TO 94
C
    8 AL=DIR(1)
      AM=DIR(2)
      ALAM2 = AL**2+AM**2
      IF( ALAM2.LE.1.D0 ) GO TO 5
          ALAM = DSQRT(ALAM2)
          AL = AL/ALAM
          AM = AM/ALAM
          AN = 0.D0
          ALAM2 = 1.D0
          GO TO 6
    5 AN=DSQRT(1.D0-ALAM2)
      IF(DIR(3).LT.0.) AN = -AN
C---- CHECK ALMOST BACKWARD CASES
    6 CONRVS = AN+1.
      IF( CONRVS.GT.0.02) GO TO 3
      CONRVS = 0.5*ALAM2
      IF( CONRVS.GT.0. ) GO TO 3
      A(1) = 1.0
      A(2) = 0.
      A(3) = 0.
      B(1) = 0.
      B(2) = 1.
      B(3) = 0.
      GO TO 4
C
    3 CON=1./CONRVS
      A(1)=AL*AL*CON-1.
      A(2)=AL*AM*CON
      A(3)=AL
      B(1)=A(2)
      B(2)=AM*AM*CON-1.
      B(3)=AM
    4 SUM = 0.
        DO 10 I=1,3
        DIR(I)=ALMN(I)*CTH+(C*A(I)+S*B(I))*STH
   10   SUM = SUM+DIR(I)**2
C
      IF(SUM.GE.0.99 .AND. SUM.LE.1.01) GO TO 100
C
C*****  CORRECT THE ROUNDING ERROR  *******************
      DATA IERR/0/
      IERR = IERR+1
      TH2 = CTH**2+STH**2
      CS2 = C*C+S*S
C     IF(IERR.LE.10 .OR. SUM.LE.0. .OR. SUM.GT.1.1 )
      IF(IERR.LE.3 .AND.( SUM.LE.0. .OR. SUM.GT.1.1 ))
     $          WRITE(6,6000) DIR,SUM,AL,AM,AN,A,B,CTH,STH,TH2,C,S,CS2
 6000 FORMAT('0 ****  ERROR ,DIR=',3F10.4,'  SUM2=',E10.3,
     1       /'   AL,AM,AN=',3F10.4,'  A,B=',6E10.3,
     2       /'   CTH,STH,TH2,C,S,CS2=',6E11.3)
C
      IF(SUM.LE.0. .OR. CS2.LE.0.) GO TO 91
      SUM = SQRT(SUM)
        DO 20 K=1,3
   20   DIR(K) = DIR(K)/SUM
      GO TO 100
C*************************************************
C
C---- WARNING
   92 WRITE( 6,692 ) CTH,STH
  692 FORMAT('0 WRONG ANGLE FOR NEWDR1; CTH,STH=',2E12.4,'  <===ERROR=')
      GO TO 100
   93 WRITE( 6,693 ) CTH,STH
  693 FORMAT('0 WRONG ANGLE FOR NEWDR2; CTH,STH=',2E12.4,'  <===ERROR=')
      GO TO 100
   94 WRITE( 6,694 ) C,S
  694 FORMAT('0 WRONG ANGLE FOR NEWDR2; C,S=',2E12.4,'  <===ERROR=')
C
  100 RETURN
C
   90 WRITE(6,690)
  690 FORMAT('0**** 2 SUCCESSIVE RANDOM NUMBERS ARE 0.IN NEWDR1.***',
     1        /'  EMERGENCY STOP')
      GO TO 200
   91 WRITE(6,691) SUM,C,S,CS2
  691 FORMAT('0**SUM=0 OR  WRONG INPUT C,S FOR NEWDR2 ********',
     1       /' SUM=',E12.4,'   C,S,C*C+S*S=',3E12.4,
     2       /'   EMERGENCY STOP')
  200 STOP
      END

C   14/05/84 510232119  MEMBER NAME  TAGCHK   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TAGCHK(IPHTGM,IPHTGP)
C-----------------------------------------------------------------------
C
C   AUTHOR:      ?      PREHISTORY :  TAGGING SYSTEM COMPUTATIONS
C
C        MOD: J. OLSSON    6/10/83 :
C        MOD: A. FINCH    12/03/84 :  TO CONFORM WITH TAGGING CHANGES
C   LAST MOD: J. NYE      14/05/84 :  INITIALIZE CAPSUMS  TO ZERO
C   LAST MOD: J. OLSSON   23/10/85 :  MONTE CARLO PEDESTALS PROPER
C
C
C
C        COMPUTE ENERGY SUMS FOR FORWARD TAGGING LEADGLASS
C        IPHTGM,IPHTGP ARE MINUS AND PLUS Z CAPSUMS
C        SUBTRACT STANDARD PEDESTAL OF 500 COUNTS, APPLY STANDARD
C        CALIBRATION FACTOR OF 5 MEV / COUNT
C        AFTER RUN 2782, PEDESTAL IS 50 COUNTS, CALIBR. FACTOR 7.5
C
C        FOR 1981 - 82 LEADGLASS, USE CALIBRATION FROM A.FINCH
C        FOR 1983 - ..            USE CALIBRATION FROM FINCH....
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER * 2 (H)
C
#include "cdata.for"
#include "cwktag.for"
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION NPBPED(3 ) ,CALTAG(3)
C
      DATA NPBPED /500,50,0/, CALTAG /5.,7.5,5.5/
C
C------------------ C O D E ------------------------------------------
C
C
C---                                     INITIALIZATION
C
C
      PPHM = 0.0
      PPHP = 0.0
      CALL TAGINT(&300)
      IPNTR = IDATA( IBLN( 'ATAG' ) )
      IF ( IPNTR .LT. 1 ) GOTO 300
      IF ( MARK .GT. 0 ) GOTO 1919
C
C
C----------------------------------------1979/80 APPARATUS ONLY---------
C
C
C ENTER HERE FOR 1979 - 80 VERSION OF THE TAGGING APPARATUS
C
      IRUN = 1
      IF ( HEAD(18) .GT. 2781 ) IRUN = 2
      IF ( IMC.EQ.1 ) IRUN = 3
      IADD = 2 * IPNTR + 6
      IFLUMI = IADD + HDATA(IADD - 1)
C
200   IADD = IADD + 1
      IF ( IADD .GE. IFLUMI ) GOTO 300
      NB = HDATA(IADD)
      IADD = IADD + 1
      IF ( NB .EQ. 0 ) GOTO 200
      IF ( NB .GT.  46 .AND. NB .LT.  49 ) GOTO 200
      IF ( NB .GT.  94 .AND. NB .LT.  97 ) GOTO 200
      IF ( NB .GT. 142 .AND. NB .LT. 145 ) GOTO 200
      IF ( NB .GT. 190 ) GOTO 300
      HPH = HDATA(IADD)
      HPH = HPH - NPBPED(IRUN)
      IF ( HPH .LT. 0 ) GOTO 200
      PPH = CALTAG(IRUN) * HPH
      IF ( NB .LE. 96 ) PPHM = PPHM + PPH
      IF ( NB .GT. 96 ) PPHP = PPHP + PPH
      GOTO 200
C
C
C----------------------------------------1981--> APPARATUS ONLY---------
C
C
C
C
C  ENTER HERE FOR 1981 - .. APPARATUS
C
1919  CONTINUE
      CALL TAGADC(0,&300)
      CALL TAGPED
      CALL TAGKAL(0)
      CALL TAGSUM(-1,PPHM,&299)
299   CALL TAGSUM(+1,PPHP,&300)
300   IPHTGM = PPHM
      IPHTGP = PPHP
      RETURN
      END

C   21/11/86 702231849  MEMBER NAME  ZE4VVX   (S)           FORTRAN77
      SUBROUTINE ZE4VVX( R, NTRZ )
C-----------------------------------------------------------
C  VERSION OF 24 JAN 85         LAST MOD 23 FEB 87   M ZIMMER
C  LOAD EVENT VERTEX.
C  X,Y POSITION:  FROM CALIB IF IT IS LOADED OTHERWISE (0,0)
C  Z   POSITION:  CALCULATE FROM PATR, ACCEPTING TRACKS WITH
C                 MORE THAN NHZCT HITS ONLY AND
C                 LESS THAN ZMXCT MM FROM 0
C-----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
#include "calibr.for"
      REAL*4 R(3)
      INTEGER NHZCT / 7 /
      REAL*4 ZMXCT / 80. /
      INTEGER IPVXDF / 16389 /
      INTEGER IEV / 0 /
C
      IEV = IEV + 1
      DO 1 I=1,3
    1 R(I) = 0.
C
      ICX = ICALIB(10)
      IF( ICX.NE.IPVXDF ) GO TO 50
C                                           LOAD BHABHA VERTEX
         R(1) = ACALIB(ICX+1)
         R(2) = ACALIB(ICX+3)
      GO TO 100
   50 CONTINUE
         IF( IEV.GT.1 ) GO TO 100
            WRITE(6,9101) ICX,IPVXDF
 9101       FORMAT(' EAVXGL WARNING: ICALIB(10)=',I6,
     *             ' DOES NOT MATCH DEFAULT ',I6)
  100 CONTINUE
C
C
      NTRZ = 0
      ZV = 0.
      SZH = 0.
C
C
      NPPATR = IW(IBLN('PATR'))
      IF( NPPATR .EQ. 0 ) GO TO 1000
         NTR = IW( NPPATR + 2 )
         IF( NTR .LE. 0 ) GO TO 1000
            IP0 = IW( NPPATR + 1 ) + NPPATR
            LP = IW( NPPATR + 3 )
            IP9 = IP0 + ( NTR - 1) * LP
C                                           LOOP OVER TRACKS
            DO 300 J = IP0, IP9, LP
               IF( IW(J+33) .LT. NHZCT ) GO TO 300
                  AZV = ABS(RW(J+31))
               IF( AZV .GT. ZMXCT ) GO TO 300
                  ZV = ZV +  RW(J+31)*IW(J+33)
                  SZH = SZH + IW(J+33)
                  NTRZ = NTRZ + 1
  300       CONTINUE
            IF( NTRZ.LE.0 ) GO TO 1000
               ZV = ZV / SZH
 1000 CONTINUE
      R(3) = ZV
      RETURN
      END

C   22/05/84 507222026  MEMBER NAME  SETCMD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SETCMD( NUMCMD, CABBRV, MAXARG, HPR1, HPR2, HPR3 )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  11/05/84 :  SET UP A COMMAND
C
C
C     THIS ROUTINE SETS UP A SINGLE COMMAND IN THE COMMAND LIST.
C     EACH COMMAND HAS A SHORT FORM (UP TO 8 LETTERS), AN IDENTITY
C     NUMBER WHICH DOES NOT HAVE TO BE UNIQUE TO A GIVEN STRING, MAX NO.
C     OF ARGUMENTS AND ASSOCIATED COMMAND WORDS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CABBRV(8), CCMD
C
      COMMON / CGRAP4 / IPOS4,CCMD(8,200),HCMD(5,200)
C
C------------------  C O D E  ------------------------------------------
C
C
      IF( IPOS4 .LT. 200 ) GO TO 10
         WRITE(6,5)
   5     FORMAT(' Error: Command definition array exceeded (200).',
     +          ' Report this to graphics expert!')
         RETURN
C
  10  IPOS4 = IPOS4 + 1
C
C                            ADD THE COMMAND ABBREVIATION (8 CHARS.)
C                            STORED IN THE CABBRV ARRAY.
C
      DO  20  I = 1,8
        CCMD(I,IPOS4) = CABBRV(I)
  20  CONTINUE
C
C                            ADD THE COMMAND NUMBER AND MAX. NO. OF ARGS
C
      HCMD(1,IPOS4) = NUMCMD
      HCMD(2,IPOS4) = MAXARG
C
C                            ADD THE COMMAND WORD POINTERS
C
      HCMD(3,IPOS4) = HPR1
      HCMD(4,IPOS4) = HPR2
      HCMD(5,IPOS4) = HPR3
C
      RETURN
      END

C   07/02/83 409202146 MEMBER NAME  DSERR    (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DSERR(HERR,JERR,DDN,*)
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY    ??/??/81 : HANDLES GETPDD ERRORS
C
C   LAST MOD: C. BOWDERY    20/09/84 : NEW ERROR MESSAGE
C
C     HERR      LINKDS/GETPDD ERROR NUMBER (INTEGER*2)
C     JERR      ERROR COUNT
C     DDN       DDNAME (REAL*8) FROM LINKDS
C     *         RETURN FOR ANOTHER LINK ATTEMPT
C               NORMAL RETURN FOR TOO MANY ERRORS (3)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8 DDN
C
C------------------  C O D E  ------------------------------------------
C
C                  IF HERR IS NEGATIVE = ERROR FREEING A DDNAME
C
      JUSCRN = 6
      IF( HERR .GT. 0 ) GO TO 15
        HERROR = - HERR
        WRITE(JUSCRN,17) HERROR,DDN
 17     FORMAT(' ****  RUN TIME PROGRAM ERROR  ++++  FATAL  ****'/
     +  ' Error ',I5,' occurred while freeing ',A8,' in S/R LINKDS')
            RETURN
C
C                  HANDLE THE OTHER GETPDD ERRORS.
C
 15   JERR = JERR + 1
      IF( HERR .NE. 100 ) GO TO 20
        IF( JERR .GT. 1 ) RETURN
          WRITE(JUSCRN,21)
 21       FORMAT(' No name given. Enter a name or <ENTER> to terminate')
          RETURN 1
C
 20   IF( HERR .EQ. 860  .OR.
     +    HERR .GE. 5888 .AND. HERR .LE. 6143 ) HERR = 3
      IF( HERR .EQ. 3 ) WRITE(JUSCRN,5)
 5      FORMAT(' Dataset non-existent  or  name wrongly entered')
      IF( HERR .EQ. 536 ) WRITE(JUSCRN,18)
 18     FORMAT(' Dataset migrated to tape. "FAST" it or')
C
      IF( HERR .EQ. 528 ) WRITE(JUSCRN,26)
 26     FORMAT(' Dataset already in use.Try later')
C
      IF( HERR .EQ. 1   ) WRITE(JUSCRN,25)
 25     FORMAT(' All DDNAMEs between FT11F001 and FT60F001 have been use
     +d'/' Use the NEWLIB FREE command to release one and try again')
C
      IF( HERR .EQ. 584 ) WRITE(JUSCRN,30)
 30     FORMAT(' The dataset is on an MSS volume that cannot be',
     +  ' mounted at the moment.'/
     +  ' This happens occasionally. Don''t panic (yet)!')
C
      IF( HERR .GT. 3  .AND.  HERR .NE. 528  .AND.  HERR .NE. 536
     +    .AND.  HERR .NE. 584 ) WRITE(JUSCRN,19)HERR
 19     FORMAT(' Dataset Allocation Error ',I5,' in GETPDD called by',
     +         ' LINKDS'/' I don''t know what caused it.',
     +         ' Try the dataset again later is my advice')
      IF( JERR .GT. 2  .OR.  HERR .EQ. 1 ) RETURN
        WRITE(JUSCRN,22)
 22     FORMAT(' Enter another name or press <ENTER> to terminate ....')
        RETURN 1
        END

C   25/06/78            MEMBER NAME  BHABHA   (LGSOURCE)    FORTRAN
      SUBROUTINE BHABHA(ENE,EPSI)
      COMMON/M0PAR/CUTM
      COMMON/SFCPA/SFP,SFE
      EKIN=ENE-1.
      BETA2=1.-1./ENE**2
      EP0=CUTM/EKIN
      XR=RN(DAM)
      CC2=1.-EP0
      EPSI=EP0/(1.-CC2*XR)
      XR=RN(DAM)
      Y=1./(EKIN+2.)
      G=(CC2/3.)*(1./BETA2-EPSI*((2.-Y**2)-EPSI*((3.-
     @    Y*(6.-Y*(1.-2.*Y)))-EPSI*(2.-Y*(10.-Y*(16.-8.*Y))
     @    -EPSI*(1.-Y*(6.-Y*(12.-8.*Y)))))))
      IF(XR*SFE-G)30,30,31
 30    RETURN
 31    EPSI=0.
      RETURN
      END

C   14/08/84 408271206  MEMBER NAME  MUPR10   (PWMUS)       FORTRAN
C   16/02/81 104100752  MEMBER NAME  MUPR10   (JADEMUS)     FORTRAN
C   11/02/81 102112042  MEMBER NAME  MUPR10P  (S)           FORTRAN
C   26/03/80 010211751  MEMBER NAME  MUPR10   (JADEMUS1)    FORTRAN
C
C LAST CHANGE 10.30 14/08/84 P. WARMING   - OUTPUT COMMENTED
C      CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C      CHANGE 20.45  11/02/81  HUGH MCCANN.
C                       26/03/80 HUGH MCCANN.
C-----------------------------------------------------------------------
C
C
      SUBROUTINE MUPR10(NHITS,NWHIT)
C
C  ROUTINE TO PRINT MUR1/0 RESULTS BANK.
C
      IMPLICIT INTEGER*2 (H)
#include "cmubcs.for"
C
C  FIND MUR1/0
      IP0=IDATA(IBLN('MUR1'))
      IF(IP0.LE.0)GO TO 10
      NHITS=IDATA(IP0+1)
      NWHIT=IDATA(IP0+3)
      WRITE(6,100)NHITS,NWHIT
  100 FORMAT('0 MUR1/0    NO. OF MU HITS =',I4,2X,
     *       'NO. OF 2-BYTE WORDS/HIT IN COORD BANK =',I3)
      RETURN
   10 CONTINUE
      WRITE(6,20)
   20 FORMAT('0 ******* MUR1/0 NOT FOUND ******')
      RETURN
      END

C   20/03/81 606061614  MEMBER NAME  TRLGL9   (S)           FORTRAN
      SUBROUTINE TRLGL(PV,R,*)
C
C      THIS ROUTINE TRACKS PARTICLES THROUGH THE LEAD GLASS
C      ARRAYS AND ACCUMULATES PULSEHIGHTS
C      PV = INCOMING 4 VECTOR IS CHANGED DUE TO ENERGY LOSS
C      R  = 3 VECTOR POINTING TO THE FACE OF THE LEAD GLASS
C      RETURN 1 IS USED IF THE INCIDENT MOMENTUM IS LESS THAN
C               10 MEV
C     LAST CHANGE NOV.28. 1983   W BARTEL
C ==> CHANGED :  USE THE SIMULATION BY THE RESULTS OF KEK TEST EXP.
C ==> CHANGED :  USE LFLAG TO STEER SHOWER CALCULATION.
C J.O./ 6.6.1986:  MODIFIED TO INCLUDE MAGNUSSENS SF5/SF6 SHOWER SIM.
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      COMMON/CLGHIT/AMPLG(3000)
      DIMENSION DC(3)
      LOGICAL * 1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
C        LFLAG(1) = SMEAR GAMMA AND ELECTRON ENERGIES
C        LFLAG(2) = GAMMA CONVERSION IN OUTER TANK AND COIL (TRKGAM)
C        LFLAG(3) = ABSORPTION LOSSES
C        LFLAG(4) = 3 DIM SHOWER PROFILE FIT TO EGGS CODE
C
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
      DATA TWOPI/6.28319/
      REAL RADL/25.4/
      DIMENSION R(3),PV(10)
      DIMENSION R0(3)
C
C
C      FIND INDEX FOR ENERGY LOSS
C       LOSS = 0  PHOTON
C       LOSS = 1  ELECTRON
C       LOSS = 2  MINIMUM IONIZING PARTICLE
C
      IF(PV(6).LT.0.01) RETURN 1
C   K-H MEIER / N MAGNUSSEN EGS PROFILE SHOWER SIMULATION
      IF(.NOT.LFLAG(4)) GO TO 471
      IYEA = HDATE(6)
      IF(IYEA.LT.1983) CALL TRLGSH(PV,R,*999)
      IF(IYEA.GT.1982) CALL TRLGS6(PV,R,*999)
471   CONTINUE
C
      OUTR=OUTR2*OUTR2
      ELOSS=0.
      ELS  =0.
      EDEPOT = 0.
      LOSS=2
      IF(PV(5).LT.1.E-03) LOSS=1
      IF(PV(5).EQ.0.)     LOSS=0
C
C                                           ENERGIES IN MEV
      ENERGY=PV(4)*1000.
      EINC = ENERGY / 1000.
C
C                                           THE DIRECTION OF THE TRACKIN
C                                           VECTOR IS NOT CHANGED
C                                           WHEN TRACKED THROUGH THE
C                                           BLOCKS
      PV(6)=SQRT(PV(1)**2+PV(2)**2+PV(3)**2)
      PVX=PV(1)/PV(6)
      PVY=PV(2)/PV(6)
      PVZ=PV(3)/PV(6)
      PVXY=PVX**2+PVY**2
      IF(PVXY.LT.1.E-5) RETURN
      DC(1) = PVX
      DC(2) = PVY
      DC(3) = PVZ
      X1=0.
      R1=R(1)**2+R(2)**2
      RADIUS = SQRT( R1 )
      IF(RADIUS.GT.OUTR2 .OR. R(3).GT.ZENDPL+DEPEND
     *  .OR. R(3).LT.ZENDMI-DEPEND) RETURN
      IF( .NOT.
     *  ( ZLGMI+5..LE.R(3).AND.R(3).LE.ZLGPL-5..AND.RADIUS.GT.RLG-5. ))
     *                             GO TO 1000
C
C                                           CENTRAL PART
C
C
C                                           ANTI ENERGY CORRECTION
C                                           ABSORPTION IN COIL
      IBE = 0
      IF( LOSS .LT.2 .AND. LFLAG(3) ) ENERGY=ELGOBS(IBE,DC,EINC)*1000.
C                                           ENERGY SMEARING
      ENERGY = AMAX1( ENERGY, 1. )
      EINC = ENERGY/1000.
      IF( LOSS .LT.2 .AND. LFLAG(1) ) ENERGY=ELSMR(IBE,DC,EINC)*1000.
C
C                                           CALCULATE THICKNESS OF SLAB
C                                           OF LEAD GLASS CORRESPONING
C                                           TO 1CM TRACK LENGTH
C
      PVR=ABS(R(1)*PVX+R(2)*PVY)
      DELR=PVR/RADIUS
      TRKL=BLDEP/DELR
C
C                                           DETERMINE STEP SIZE
      NSTEP=BLDEP/(10.*DELR)+1
      XL=10.
      DX=XL/RADL
C
C                                           ENERGY LOSS FOR HADRONS
      IF( LOSS.LT.2 ) GO TO 26
C
C     CALCULATE EXITIN POINT AT THE BACK SURFACE OF THE LEAD GLASS
C
      R0(1)=R(1)+PVX*TRKL
      R0(2)=R(2)+PVY*TRKL
      R0(3)=R(3)+PVZ*TRKL
C
C     CALCULATE PATH LENGTH THROUGH LIGHT GUIDE
C
      IFLG=2
      CALL PLLIGD(PLLI,R(1),R(2),R(3),R0(1),R0(2),R0(3),IFLG)
      ICHG=INT(PV(7))
      ITYP=INT(PV(8))
      CALL HDECLS(EDEPOT,ICHG,ITYP,PV,IBE,TRKL,PLLI)
      ED=EDEPOT
      EDEPOT=10.*EDEPOT/TRKL*1000.
C     WRITE(6,600) ICHG,ITYP,PV(4),IBE,TRKL,PLLI,ED,EDEPOT
  600 FORMAT(1H ,2I3,F8.3,I5,2F8.2,2X,2F8.3)
   26 CONTINUE
      N0 = 1
C
C                                           DEPTH OF CONVERSION
C                                           FOR PHOTONS IN THE LEAD GLAS
C                                           ASSUME UNIFORM CONVERSION
C                                           PROBABILITY WITHIN
C                                           THE FIRST 2 X0
      IF(LOSS.NE.0) GO TO 23
      X0=51.*RN(DUM)
      N0=X0/(10.*DELR)+1
   23 CONTINUE
C
      ISTEP=0
   21 ISTEP=ISTEP+1
C
C                                           CALCULATE INDEX FOR BLOCKS
C                                           WHICH ARE HIT
      PHI=ATAN2(R(2),R(1))
      IF(PHI.LT.0.) PHI=TWOPI+PHI
      NFI=PHI/DELFI
      IF(ABS(R(3)).GT.ZLGPL) GO TO 22
      DZ=R(3)-ZLGMI
      NZ=DZ/BLZ+1
      NBL=NZ+32*NFI
C
C                                           ACCUMULATE PULSEHEIGHTS
C                                           IN BLOCKS
      IF(LOSS.GE.2) GO TO 25
C                                           PHOTONS AND E
      EDEPOT=0.
      IF(ISTEP.LT.N0) GO TO 24
      X1=X1+DX
      EDEPOT=SHOWR(ENERGY,X1,DX)
      IF(X1.GT.9.) EDEPOT=ENERGY-ELOSS
      ELOSS=ELOSS+EDEPOT
      IF(ELOSS.GT.ENERGY) GO TO 24
      AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      IF(X1.GT.9.) RETURN
      GO TO 24
C
C                                           HADRONS
   25 AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      ELS=ELS+EDEPOT
      IF(ELS.GE.ENERGY) GO TO 22
C
C                                           PROPAGATE TRACK
   24 R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
C                                           CHECK WHETHER PARTICLE IS
C                                           STILL IN THE LEAD GLASS
      R1=R(1)**2+R(2)**2
      IF(R1.GT.OUTR) GO TO 22
      IF(ZLGPL.LT.R(3).OR.R(3).LT.ZLGMI) GO TO 22
      GO TO 21
   22 CONTINUE
      IF(ELOSS.EQ.0.) RETURN
      RX=(PV(4)-ELOSS/2000.)/PV(4)
      IF(ELOSS.GE.ENERGY) RX=0.001
      IF(ELS  .GE.ENERGY) RX=0.001
      RX=ABS(RX)
      PV(1)=PV(1)*RX
      PV(2)=PV(2)*RX
      PV(3)=PV(3)*RX
      PV(4)=PV(4)*RX
      PV(6)=PV(6)*RX
      RETURN
C
C                                           END CAP LEAD GLASS
C                                           FOLLOW PHOTON TO THE FACE
C                                           OF THE END CAP COUNTERS
 1000 CONTINUE
      RABS=R(1)**2 + R(2)**2 + R(3)**2
      RABS=SQRT(RABS)
      R(1)=R(1)/RABS
      R(2)=R(2)/RABS
      R(3)=R(3)/RABS
      DISTZ=ZENDPL
      IF(R(3).LT.0) DISTZ=ABS(ZENDMI)
      ZLAM=ABS(DISTZ/R(3))
      R(1)=ZLAM*R(1)
      R(2)=ZLAM*R(2)
      R(3)=ZLAM*R(3)
      CALL ENDCLG(R,NBL,*9000)
      IF(NBL.LT.2689 .OR. NBL.GT.2880) GO TO 9000
C
C                                           ANTI ENERGY CORRECTION
C                                           ABSORPTION IN COIL
      IBE = 1
      IF( R(3) .LT. 0. ) IBE = -1
      IF( LOSS .LT.2 .AND. LFLAG(3) ) ENERGY=ELGOBS(IBE,DC,EINC)*1000.
C                                           ENERGY SMEARING
      ENERGY = AMAX1( ENERGY, 1. )
      EINC = ENERGY/1000.
      IF( LOSS .LT.2 .AND. LFLAG(1) ) ENERGY=ELSMR(IBE,DC,EINC)*1000.
C
C                                           CALCULATE DELZ OF SLAB
C                                           OF LEAD GLASS CORRESPONDING
C                                           1CM TRACK LENGTH IN LEAD GLA
      DELZ=ABS(PVZ*10.)
      TRKL=DEPEND/ABS(PVZ)
C
C                                           DETERMINE STEP SIZE
      NSTEP=DEPEND/DELZ +1
      XL=10.
      DX=XL/RADL
C
C                                           ENERGY LOSS FOR HADRONS
      IF( LOSS.LT.2 ) GO TO 260
      PLLI=0.
      ICHG=INT(PV(7))
      ITYP=INT(PV(8))
      CALL HDECLS(EDEPOT,ICHG,ITYP,PV,IBE,TRKL,PLLI)
      ED=EDEPOT
      EDEPOT=10.*EDEPOT/TRKL*1000.
C     WRITE(6,600) ICHG,ITYP,PV(4),IBE,TRKL,PLLI,ED,EDEPOT
  260 CONTINUE
      N0 = 1
C
      IF(LOSS.NE.0) GO TO 230
C
C                                           DEPTH OF CONVERSION
C                                           FOR PHOTONS IN THE LEAD GLAS
C                                           ASSUME UNIFORM CONVERSION
C                                           PROBABILITY WITHIN
C                                           THE FIRST 2 X0
      IF(LOSS.NE.0) GO TO 230
      X0=51.*RN(DUM)
      N0=X0/DELZ +1
  230 CONTINUE
C
      ISTEP=0
  210 ISTEP=ISTEP+1
C
C                                           CALCULATE INDEX FOR
C                                           BLOCKS WHICH ARE HIT AND
C                                           CHECK WHETHER PARTICLE IS
C                                           STILL IN THE LEAD GLASS
      CALL ENDCLG(R,NBL,*9000)
      IF(NBL.LT.2689 .OR. NBL.GT.2880) GO TO 9000
C
C                                           ACCUMULATE PULSEHEIGHTS
      IF(LOSS.GE.2) GO TO 250
C                                           PHOTONS AND E
      EDEPOT=0.
      IF(ISTEP.LT.N0) GO TO 240
      X1=X1+DX
      EDEPOT=SHOWR(ENERGY,X1,DX)
      IF(X1.GT.8.) EDEPOT=ENERGY-ELOSS
      ELOSS=ELOSS+EDEPOT
      IF(ELOSS.GT.ENERGY) GO TO 240
      AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      IF(X1.GT.8.) RETURN
      GO TO 240
C                                           HADRONS
  250 AMPLG(NBL)=AMPLG(NBL)+EDEPOT
      ELS=ELS+EDEPOT
      IF(ELS.GE.ENERGY) GO TO 9000
C                                           PROPAGATE TRACK
  240 R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
      GO TO 210
C
C                                           DE/DX ENERGY LOSS
 9000 IF(ELOSS.EQ.0.) RETURN
      RX=(PV(4)-ELOSS/2000.)/PV(4)
      IF(ELOSS.GE.ENERGY) RX=0.001
      IF(ELS  .GE.ENERGY) RX=0.001
      RX=ABS(RX)
      PV(1)=PV(1)*RX
      PV(2)=PV(2)*RX
      PV(3)=PV(3)*RX
      PV(4)=PV(4)*RX
      PV(6)=PV(6)*RX
C
      RETURN
  999 RETURN 1
      END
C
      FUNCTION ELSMR( IBE, DC, EINC )
C-----------------------------------------------------------
C  VERSION OF 12/02/81     LAST MOD 31/03/81    E.ELSEN
C  ENERGY SMEARING ACCORDING TO WATANABES LGESMR
C  ENERGIES IN GEV
C-----------------------------------------------------------
C
      DIMENSION DC(3)
      REAL*8 FNORM
      DATA ICALL/0/
      ICALL=ICALL+1
      IF(ICALL.LE.1) WRITE(6,9101)
 9101 FORMAT(2X,5(1H%),' E SMEAR IS CALLED',5(1H%))
C
      IF( IBE ) 200, 100, 200
C                                           BARREL PART
  100 CONTINUE
      IF(EINC.GT.6.) GO TO 120
      SIG=AMAX1( 0.055, SQRT(0.0036/EINC+0.001225)  )
      GO TO 240
  120 SIG=AMAX1( 0.04, 0.055-(ABS(DC(3))-0.4)*(EINC-6.)/144.)
      GO TO 240
C
C                                           END CAP
  200 CONTINUE
      SIG= AMAX1( 0.12, 0.28/SQRT(EINC) )
C
  240 ELSMR=EINC*(1.+FNORM(0.)*SIG)
      ELSMR = AMAX1( ELSMR, 0.001 )
      RETURN
      END

C   25/06/78 705271813  MEMBER NAME  IPRDIV   (S)           FORTRAN
      FUNCTION IPRDIV(PR,N)
C     A. SATO 29-05-78
C     CONVERTED TO FORTRAN FROM ASSEMBLER VERSION.
C
      DIMENSION PR(N)
C
      XR=RN(DAM)
      IPRDIV=0
1     IPRDIV=IPRDIV+1
      IF(N-IPRDIV) 2,2,3
3     XR=XR-PR(IPRDIV)
      IF(XR) 2,2,1
2     RETURN
      END

C   01/11/84            MEMBER NAME  SETSCL   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SETSCL(INDEX)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON       ?    :  SET SCALE
C
C       MOD:   J. OLSSON   15/12/83 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C  LAST MOD:   J. HAGEMANN 19/10/84 :  SET SCALE FOR SPECIAL VERTEX
C                                      CHAMBER VIEW
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
C
C------------------  C O D E  ------------------------------------------
C
      HNDEX=INDEX
      IF( INDEX .GT. 7 ) HNDEX = INDEX - 4
      GO TO (1,2,3,4,5,6,7,8,9,10,11,12),HNDEX
      IF( INDEX .EQ. 20 ) GO TO 16
      IF( INDEX .GE. 17 .AND. INDEX .LE. 19 ) GO TO 75
      GO TO 20
C                            VIEW RA
1     XMIN = -1400.
      YMIN = -1100.
      GO TO 999
C                            VIEW RB
2     XMIN = -2050.
      XMAX =  1950.
      YMIN = -1550.
      GO TO 999
C                            VIEW RC
3     XMIN = -4900.
      YMIN = -3350.
      GO TO 999
C                            VIEW ZXA,ZYC
    4 XMIN = -1800.
      XMAX =  1500.
      YMIN = -1300.
      GO TO 999
C                            VIEW ZXB,ZYB
    5 XMIN = -2400.
      XMAX =  2000.
      YMIN = -1700.
      GO TO 999
C                            VIEW ZXC,ZYC
    6 XMIN = -5600.
      XMAX =  4400.
      YMIN = -3900.
      GO TO 999
C                            VIEW ZXD,ZYD
    7 XMIN = -5500.
      YMIN = - 3900.
      GO TO 999
C                            VIEW FW
    8 XMIN = -1200.
      XMAX =  1200.
      YMIN = -800.
      GO TO 999
C                            VIEW RU
    9 XMIN = -1610.
      XMAX =  7890.
      YMIN = -25.
      GO TO 999
C                            VIEW CYL
10    XMIN = -1800.
      YMIN = -1300.
      GO TO 999
C                            VIEW FWMU
11    XMIN = -1610.
      XMAX =  7890.
      YMIN = -25.
      GO TO 999
C                            VIEW RZ
12    XMIN = -1250.
      XMAX =  5530.
      YMIN =  0.
      GO TO 999
C                            VIEW VC
16    XMIN = -345.
      XMAX =  345.
      YMIN = -260.
      GO TO 999
C                            VIEWS VRX,VRZX,VRZY
75    XMIN = -8.5
      XMAX =  7.0
      YMIN = -6.0
      GO TO 999
999   IF((HNDEX.LT.4.OR.HNDEX.EQ.7.OR.HNDEX.EQ.10).AND.HNDEX.NE.2)
     $ XMAX = - XMIN
      YMAX = YMIN + XMAX - XMIN
      GO TO 1000
   20 XMIN =SXIN
      XMAX = SXAX
      YMIN = SYIN
      YMAX = SYAX
 1000 CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
      RETURN
C
      END

C   07/06/96 606071804  MEMBER NAME  BCRE     (S4)          FORTG1
      SUBROUTINE BCRE(IND,NAME,NR,NWORD,*,IER)
C     BOS SUBPROGRAM =1.3=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
C   30/04/96 604301841  MEMBER NAME  STAR     (BOSLIB.S)    FORTRAN
      REAL STAR/Z0000005C/,FF/Z000000FF/
      EQUIVALENCE (XNAME,INAME)
      LOGICAL NOTLOW
      REAL AND
      EXTERNAL AND
      NOTLOW(XNAME)=AND(XNAME,FF).NE.STAR
      IND=0
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAMEV),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 3
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)        GOTO    10
      IF(IW(LFDI-2).LT.NR) GOTO 2
      IF(IW(LFDI-2).GT.NR) GOTO    10
      IND=LFDI
      IER=1
      NSV=IW(IND)
      IF(NSV.GE.NWORD) GOTO 100
      CALL BCHF(IND,NWORD,IER)
      IF(IER.GE.1) IER=2
      IF(IER.EQ.2) GOTO 101
      CALL VZERO(IW(IND+NSV+1),NWORD-NSV)
      IER=1
      GOTO 100
   10 IER=2
      NW=MAX0(0,NWORD)
      NN=NW+4
      IF(NEXT+NN.LT.NLST) GOTO 20
      NHISTH(11)=NHISTH(11)+1
      GOTO 101
   20 INAME=NAME
      IF(NOTLOW(XNAME)) GOTO 40
      IF(NCPL+NN.LT.NSPL) GOTO 30
      NHISTL(11)=NHISTL(11)+1
      GOTO 101
   30 NCPL=NCPL+NN
   40 IER=0
      IND=NEXT+3
      IW(IND-3)=NAME
      IW(IND-2)=NR
      IW(IND)=NW
      ISV=IW(LFDK-1)
      IW(LFDK-1)=IND
      IW(IND -1)=ISV
      IF(NW.GT.0) CALL VZERO(IW(IND+1),NW)
      NEXT=NEXT+NN
   50 LIND=IND
  100 RETURN
  101 RETURN 1
      END

C   10/09/79 612121325  MEMBER NAME  RD0880   (S)           FORTRAN
      SUBROUTINE RD0880(NRUN)
      COMMON/TFPRM/ CORNOR(84),COROVF(84),TPARM(41),VELSC,TCALM(42),
     1 TCALP(42),PEDLM(42),PEDLP(42),DUM(90)
      COMMON/TFADC/ CADCA(84),CADCB(84)
C
      COMMON/CALIBR/JPOINT(8)
      DIMENSION ACALIB(8)
      EQUIVALENCE (ACALIB(1),JPOINT(1))
C
      DATA IENTRY/0/
C
      IENTRY = IENTRY + 1
      IND = JPOINT(6)
      NC = 378
      CALL UCOPY(ACALIB(IND+1),CORNOR(1),378)
      IF(NRUN.GE.3728) CALL UCOPY(ACALIB(IND+379),CADCA(1),168)
      IF(NRUN.GE.10000) CALL UCOPY(CORNOR(1),COROVF(1),84)
      IF(IENTRY.NE.1)  RETURN
      LRUN = IFIX(TPARM(20) - 900000.)
  101 FORMAT(' RD0880: CONSTANTS FILE RUN ',I5)
      PRINT 101,LRUN
      RETURN
      PRINT 102,VELSC
      PRINT 102,CORNOR
      PRINT 102,COROVF
      PRINT 102,TPARM
      PRINT 102,TCALM
      PRINT 102,TCALP
      PRINT 102,PEDLM
      PRINT 102,PEDLP
      IF(NRUN.GE.3728) PRINT 102,CADCA
      IF(NRUN.GE.3728) PRINT 102,CADCB
  102 FORMAT(/(1X,10F10.3))
C
      RETURN
      END

C   28/02/79 209070859  MEMBER NAME  LGMESG   (SOURCE)      FORTRAN
C
      SUBROUTINE LGMESG(INDPR,INDEX)
C
C     T. KOBAYASHI     26.02.79    11:00
C     MODIFIED ON      07.09.82     8:55   BY S.YAMADA
C
C     THIS IS A SUBROUTINE TO PRINT ERROR MESSAGES ON L-P.
C
C --- INDPR IS GIVEN AN OWN NUMBER CORRESPONDING TO EACH CALLING
C     PROGRAMS.
C        1 = @TESTBOS
C        2 = LGANAL
C        3 = LGDCPY
C        4 = LGCLUS
C        5 = LGAVRZ
C        6 = LGCLPB/LGCLPC
C        7 = LGCDIR
C        8 = ILCTRC
C        9 = LGCHC2
C       10 = LGAVDP
C     INDEX(=1,2,3,---) : INDEX FOR DIFFERENT MESSAGES IN A
C                         CALLING PROGRAM
C
C --- PARAMETERS TO BE PRINTED ARE HANDED VIA COMMON /CLGMSB/.
C --- COMMON /CMSGCT/ IS USED AS ERROR COUNTERS.
C
      IMPLICIT INTEGER *2 (H)
C
#include "cdata.for"
      COMMON /CMSGCT/LGMMAX,LGMSG(20)
      COMMON /CLGMSB/MSGVAL(5)
      DIMENSION AMSGVL(5)
      EQUIVALENCE (MSGVAL(1),AMSGVL(1))
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3,ZVRTX,DZVTX
C
      REAL*8 SUBP(10)
      DATA SUBP/'@MAIN-LG','LGANAL  ','LGDCPY  ','LGCLUS  ',
     @          'LGAVRZ  ','LGCLPB/C','LGCDIR  ','ILCTRC  ',
     @          'LGCHC2  ','LGAVDP  '/
C
      IF(INDPR.LE.0.OR.INDPR.GE.11) RETURN
C
C ----- PRINT ERROR MESSAGE
C
      IF(LGMSG(INDPR).LT.0) RETURN
      LGMSG(INDPR)=LGMSG(INDPR)+1
      IF(LGMSG(INDPR).GT.LGMMAX) RETURN
C
      IF(INDEX.EQ.0) GO TO 100
C
C ----- PRINT EVENT#
C
      DATA INITP/0/
      IF(INITP.GT.0) GO TO 44
      INITP=1
      NPPNHD= IBLN('HEAD')
44    CONTINUE
C      NPPNHD = IBLN('HEAD')
       NHEAD = IDATA(NPPNHD)
       NHEAD = NHEAD+NHEAD
       IF(NHEAD.LE.0) GO TO 900
       IEXP=HDATA(NHEAD+9)
       IRUN=HDATA(NHEAD+10)
       IREC=HDATA(NHEAD+11)
       GO TO 300
CC
  900 WRITE(6,200)
  200 FORMAT(' ***** ERROR IN LGMESG   ''HEAD'' NOT FOUND *****')
      GO TO 100
C
  300 WRITE(6,600) SUBP(INDPR), IEXP, IRUN, IREC
  600 FORMAT('0*****  ERROR IN ',A8,' *****',10X,
     1         'IEXP =',I5,5X,'IRUN =',I5,5X,'IREC =',I5)
C
C
  100 GO TO (1,2,3,4,5,6,7,8,9,10),INDPR
      RETURN
C
    1 GO TO (101,102),INDEX
      GO TO 1000
  101 WRITE(6,110) MSGVAL(1)
  110 FORMAT(' DATA END AT N =',I6)
      GO TO 1000
  102 WRITE(6,120) (MSGVAL(I),I=1,3)
  120 FORMAT(' NPPATR,NPR,NPCL =',3I6)
      GO TO 1000
C
    2 IF( INDEX-2) 201,202,203
  201 WRITE(6,210) ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
  210 FORMAT('0***** LG-CLUSTER ANALYSIS PARAMETERS *****'/
     1    ' THRESHOLD OF CLUSTER SEARCH START=',I3/' MAX.CLUSTER#=',
     2     I3/' IRLTHD,IRLTH2,IRLTH3=',3I5)
      GO TO 1000
  202 WRITE(6,220) MSGVAL(1)
  220 FORMAT(' NOT ENOUGH SPACE IN /BCS/ TO PUT "LGCL", IER =',I2)
      GO TO 1000
  203 WRITE(6,230) MSGVAL(1)
  230 FORMAT(' WARNING; "LGCL" EXISTS ALREADY.BUT RECREATED., IER =',I2)
      GO TO 1000
C
    3 IF(INDEX-1) 1000, 301, 302
  301 WRITE(6,310) (MSGVAL(I),I=1,2)
  310 FORMAT(' LGER1 =',I5,5X,'PARM =',I5)
C     DUMP 'ALGN'/1                 <ADDED ON 14-12-81>
      CALL HPRS('ALGN',1)
      GO TO 1000
  302 WRITE(6,320) MSGVAL(1)
  320 FORMAT(' IER IN BCRE=',I3)
      GO TO 1000
C
    4 IF(INDEX-1) 1000,401,1000
  401 WRITE(6,410)
  410 FORMAT(' TOO MANY LG-CLUSTERS')
      GO TO 1000
C
    5 IF(INDEX-1) 1000,501,1000
  501 WRITE(6,510) MSGVAL(1),AMSGVL(2),AMSGVL(3)
  510 FORMAT(' NON-CONVERGENCE FOR DEPAV.  NTRY,DEPO,DEP =',I3,2F10.2)
      GO TO 1000
C
    6 IF(INDEX-1) 1000, 601, 602
  601 WRITE(6,610) (MSGVAL(I),I=1,3)
  610 FORMAT(' LG ENDCAP FORMAT ERROR.  ID,HLGADC(1,',I4,') =',2I5)
      GO TO 1000
  602 WRITE(6,620) AMSGVL(1)
  620 FORMAT(' NEGTV ENERGY BLOCK.W=',E10.3,' (CLEARED TO GET POSTN.)')
      GO TO 1000
C
    7 IF(INDEX-1) 1000, 701, 1000
  701 WRITE(6,710) (MSGVAL(I),I=1,3)
  710 FORMAT(' NPPREC,NPR,NPCL =',3I5)
      GO TO 1000
C
    8 IF(INDEX-2)  801,802,803
  801 WRITE(6,810) (MSGVAL(I),I=1,2)
  810 FORMAT(' BUFFER OVERFLOW.  NCHIND =',I3,'   AT N =',I6)
      GO TO 1000
  802 WRITE(6,820) MSGVAL(1),AMSGVL(2)
  820 FORMAT(' TOO SMALL DIR.COS. AT NTRK=',I3,'  DIRC**2=',E10.3)
      GO TO 1000
  803 WRITE(6,830) MSGVAL(1),(AMSGVL(K),K=2,4)
  830 FORMAT(' TRACK IS OUT OF I.C. AT NTRK=',I3,'  R=',3E10.3,'MM')
      GO TO 1000
C
    9 IF(INDEX-1) 1000,901,1000
  901 WRITE(6,910)
  910 FORMAT(' TOO MANY BLOCKS HIT BY CHARGED TRACKS. HCLADR OVERFLOW')
      GO TO 1000
C
   10 IF(INDEX-1) 1000,1001,1000
 1001 WRITE(6,510) MSGVAL(1),AMSGVL(2),AMSGVL(3)
CC
 1000 RETURN
      END

      SUBROUTINE FTRELO
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cheadr.for"
      EQUIVALENCE (HRUN,HHEADR(18)) , (HEV,HHEADR(19))
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(MHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      DIMENSION HPBAK(16),HLYAR(16),HLBAR(16),DSPAR(16),
     ,          XTRAR(16),YTRAR(16),RESAR(16)
      DIMENSION HST( 80), HSTL(5),HSTR(5)
      DATA XCV /152.7/
      REAL SGCRV(3) /.000062,.000035,.000025/
      ITRK = 0
      DR =  RINCR(IRING)
      R0 = FSENSW(IRING)
      DRC = RINCR(1)*.5 * DRICOS
      DO 13000 IP = HPHT0,HPHT9,HLDHT
        ILAY = IWRK(IP  )
        Y    = SWDEPL
        IF(LAND(ILAY,1).NE.0) Y =-Y
        X    = ILAY * DR + R0
        DS   =  WRK(IP+2)
      IF(
     - DS.LE.DRC
     -)THEN
          DX   = 0.
          DY   = DS
      ELSE
          DX   =-(DS-DRC)*DRISIN
          DY   = (DS-DRC)*DRICOS + DRC
      ENDIF
        WRK(IP+5) = X - DX
        WRK(IP+7) = X + DX
        WRK(IP+6) = Y - DY
        WRK(IP+8) = Y + DY
13000 CONTINUE
13001 CONTINUE
      IPHT1 = HPHT9 - HLDHT + 1
16000 CONTINUE
        IL1 = IWRK(IPHT1  )
      IF(
     - IL1.LT. 2
     -)THEN
      GOTO 16001
      ENDIF
        DSP1 =  WRK(IPHT1+2)
      IF(
     - DSP1.GT.0.7 .AND. IWRK(IPHT1+9).LE.0
     -)THEN
          IL2 =  IL1 - 1
          IL3 =  IL2 - 1
          DSLM = 1000.
          IPHT2 = IPHT1 - HLDHT
15000 CONTINUE
      IF(
     - IPHT2.GE.HPHT0 .AND. IWRK(IPHT2).GE.IL2
     -)THEN
            DSP2 = WRK(IPHT2+2)
      IF(
     - DSP2.GT.0.7.AND.IWRK(IPHT2).EQ.IL2.AND.IWRK(IPHT2+9).LE.0
     -)THEN
      IF(
     - ABS(DSP2-DSP1).LE.12.5
     -)THEN
                IPHT3 = IPHT2 - HLDHT
15002 CONTINUE
      IF(
     - IPHT3.GE.HPHT0 .AND. IWRK(IPHT3).GE.IL3
     -)THEN
                  DSP3 = WRK(IPHT3+2)
      IF(
     - DSP3.GT.0.7 .AND.
     ?               IWRK(IPHT3).EQ.IL3 .AND. IWRK(IPHT3+9).LE.0
     -)THEN
                    DSL = DSP2*2.-DSP3-DSP1
      IF(
     - ABS(DSL).LT.DSLM .AND. DSP1+DSP2+DSP3.GT.3.0
     -)THEN
      IF(
     - IWRK(IPHT1+9).EQ.0 .OR. IWRK(IPHT2+9).EQ.0
     ?                   .OR. IWRK(IPHT3+9).EQ.0
     -)THEN
                        DSLM  = ABS(DSL)
                        SDSLM = DSL
                        MP1 = IPHT1
                        MP2 = IPHT2
                        MP3 = IPHT3
      ENDIF
      ENDIF
      ENDIF
                IPHT3 = IPHT3 - HLDHT
      GOTO 15002
      ENDIF
15003 CONTINUE
      ENDIF
      ENDIF
          IPHT2 = IPHT2 - HLDHT
      GOTO 15000
      ENDIF
15001 CONTINUE
16002 CONTINUE
            LBLRLE = LAND(IL2,1)*2 - 1
            IF(SDSLM.LT.0) LBLRLE =-LBLRLE
      IF(
     - DSLM.GE.2.0
     -)THEN
      GOTO 16003
      ENDIF
            LBLRLE = LAND(IL2,1)*2 - 1
            IF(SDSLM.LT.0) LBLRLE =-LBLRLE
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
            LRLOOP = 1
            SIGLM = .250
            SIG0 = 1000.
15004 CONTINUE
      IF(
     - LRLOOP.LE.2
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - NHTTR.LT.4
     -)THEN
      GOTO 15005
      ENDIF
              WGHT0 = 0.01
              Y0    = 0.
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      IF(
     - ABS(PAR3).GT.3.0
     -)THEN
                WGHT0 = 0.1
      IF(
     - PAR1*PAR3.LE.0.
     -)THEN
                  Y0 =-SIGN(2.,PAR1)
      ASSIGN 17006 TO IZZZ03
      GOTO 17004
17006 CONTINUE
      ELSE
                  DORMX = XCV**2*PAR1 + SIGN(2.,PAR1)
      IF(
     - ABS(PAR3).GT.ABS(DORMX)
     -)THEN
                    Y0 = DORMX
      ASSIGN 17007 TO IZZZ03
      GOTO 17004
17007 CONTINUE
      ENDIF
      ENDIF
      ENDIF
              SIGLM = .50
      IF(
     - SIG.GT.SIGLM
     -)THEN
                SIG1 = (SIG*DEG - DCHIM1**2) / (DEG-1.)
      IF(
     - SIG1.GT.SIGLM .AND. LRLOOP.EQ.1
     -)THEN
      GOTO 16003
      ENDIF
      ENDIF
              FETLIM = 0.65
      ASSIGN 17009 TO IZZZ04
      GOTO 17008
17009 CONTINUE
              WGHT0 = .01
      IF(
     - NHTTR.GE.4
     -)THEN
      ASSIGN 17010 TO IZZZ03
      GOTO 17004
17010 CONTINUE
      IF(
     - ABS(PAR3).GT.3.0
     -)THEN
                  WGHT0 = 0.1
      IF(
     - PAR1*PAR3.LE.0.
     -)THEN
                    Y0 =-SIGN(2.,PAR1)
      ASSIGN 17011 TO IZZZ03
      GOTO 17004
17011 CONTINUE
      ELSE
                    DORMX = XCV**2*PAR1 + SIGN(2.,PAR1)
      IF(
     - ABS(PAR3).GT.ABS(DORMX)
     -)THEN
                      Y0 = DORMX
      ASSIGN 17012 TO IZZZ03
      GOTO 17004
17012 CONTINUE
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      IF(
     - SIG.GT.SIGLM
     -)THEN
                SIG1 = (SIG*DEG - DCHIM1**2) / (DEG-1.)
      IF(
     - SIG1.GT.SIGLM .AND. LRLOOP.EQ.1
     -)THEN
      GOTO 16003
      ENDIF
      ENDIF
              SIGCOR = SIG
      IF(
     - LRLOOP.EQ.2
     -)THEN
                DDSTG = DSTAG - DSTAG0
                SIGCOR = SIG - (DEG-DEG0)*.01 + DDSTG*.1 + .01
      ENDIF
      IF(
     - SIGCOR .LT. SIG0
     -)THEN
                LBLR0 = LBLRTR
                SIG0  = SIG
                SIGLM0= SIGLM
                PAR10 = PAR1
                PAR20 = PAR2
                PAR30 = PAR3
                DSTAG0= DSTAG
                DEG0  = DEG
      IF(
     - SIG.LT..08
     -)THEN
      GOTO 15005
      ENDIF
      ENDIF
            LBLRTR =-LBLRTR
            LRLOOP = LRLOOP + 1
      GOTO 15004
      ENDIF
15005 CONTINUE
      IF(
     - SIG0.GT..25
     -)THEN
      GOTO 16003
      ENDIF
            LBLRTR = LBLR0
            SIG    = SIG0
            PAR1   = PAR10
            PAR2   = PAR20
            PAR3   = PAR30
            ITRK = ITRK + 1
            ALBLM1 = 0.7
            ALBLM2 = 2.0
      ASSIGN 17014 TO IZZZ05
      GOTO 17013
17014 CONTINUE
      IF(
     - SIG0.GT..10 .AND. ICELL.LE.48
     -)THEN
      GOTO 16003
      ENDIF
      IF(
     - ABS(PAR1).GT..00040 .OR. NHTGD.LT.4
     -)THEN
      GOTO 16003
      ENDIF
            HPFRE1 = HPFREE
            CALL TRACEO(ITRK,PAR1,PAR2,PAR3)
            HPFREE = HPFRE1
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16002
16003 CONTINUE
      ENDIF
      IPHT1 = IPHT1 - HLDHT
      IF(.NOT.(
     - IPHT1.LT.HPHT0
     -))GOTO 16000
16001 CONTINUE
      RETURN
17000 CONTINUE
      CALL SETS(HST(1),0,160,0)
      DCRV =  SGCRV(IRING)
      CRV1 = -DCRV*20.
      IW1 = IL2
      ILRSOL =-3
16004 CONTINUE
      ILRSOL = ILRSOL + 2
      IF(
     - ILRSOL.LT.0
     -)THEN
          ZW1L = (WRK(MP1+5)+WRK(MP2+5)+WRK(MP3+5)) / 3.
          ZW2L = (WRK(MP1+6)+WRK(MP2+6)+WRK(MP3+6)) / (ZW1L*3.)
          ZW1  = ZW1L
          ZW2  = ZW2L
          X    = WRK(MP1+5)
          Y    = WRK(MP1+6)
          CV1  = (ZW2*X - Y) / ((ZW1-X)*X)
          X    = WRK(MP3+5)
          Y    = WRK(MP3+6)
          CV3  = (ZW2*X - Y) / ((ZW1-X)*X)
          CRVL = (CV1 + CV3) * .5 + CRV1
          CRV0 = CRVL
      ELSE
          ZW1R = (WRK(MP1+7)+WRK(MP2+7)+WRK(MP3+7)) / 3.
          ZW2R = (WRK(MP1+8)+WRK(MP2+8)+WRK(MP3+8)) / (ZW1R*3.)
          ZW1  = ZW1R
          ZW2  = ZW2R
          X    = WRK(MP1+7)
          Y    = WRK(MP1+8)
          CV1  = (ZW2*X - Y) / ((ZW1-X)*X)
          X    = WRK(MP3+7)
          Y    = WRK(MP3+8)
          CV3  = (ZW2*X - Y) / ((ZW1-X)*X)
          CRVR = (CV1 + CV3) * .5 + CRV1
          CRV0 = CRVR
      ENDIF
        CALL SETS(HST(1),0,160,0)
      DO 13002 IP0 = HPHT0,HPHT9,HLDHT
      IF(
     - IWRK(IP0).NE.IW1
     -)THEN
            X    = WRK(IP0+5)
            Y    = WRK(IP0+6)
            DX   = ZW1 - X
            IBNL = 1000
            IBNR = 1000
      IF(
     - ABS(DX).GT.5.0
     -)THEN
              CRV = (ZW2*X - Y) / (DX*X)
              IBNL = (CRV-CRV0) / DCRV + 1
      ENDIF
            X   = WRK(IP0+7)
            Y   = WRK(IP0+8)
            DX  = ZW1 - X
      IF(
     - ABS(DX).GT.5.0
     -)THEN
              CRV = (ZW2*X - Y) / (DX*X)
              IBNR = (CRV-CRV0) / DCRV + 1
      ENDIF
      IF(
     - IABS(IBNL-IBNR).GT.3
     -)THEN
              IF(IBNL.GT.0 .AND. IBNL.LE.40) HST(IBNL) = HST(IBNL) + 1
              IF(IBNR.GT.0 .AND. IBNR.LE.40) HST(IBNR) = HST(IBNR) + 1
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
        MHST = 0
        IMAX = 0
      DO 13004 I=19,22
          NHST = HST(I-1) + HST(I  ) + HST(I+1)
      IF(
     - NHST.GE.MHST
     -)THEN
            MHST = NHST
            IMAX = I
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - ILRSOL.LT.0
     -)THEN
          MHSTL = MHST
          IMAXL = IMAX
          CALL MVC2(HSTL(1),0,HST(IMAX-2),0,10) !PMF 28/06/99 MVC -> MVC2
      ELSE
          MHSTR = MHST
          IMAXR = IMAX
          CALL MVC2(HSTR(1),0,HST(IMAX-2),0,10) !PMF 28/06/99 MVC -> MVC2
      ENDIF
      IF(.NOT.(
     - ILRSOL.EQ.1
     -))GOTO 16004
16005 CONTINUE
      LBLRTR = 1
      IF(MHSTL.GT.MHSTR) LBLRTR =-1
      IF(IABS(MHSTL-MHSTR).LE.1 .AND. LBLRTR.NE.LBLRLE) LBLRTR=-LBLRTR
      GOTO IZZZ01
17002 CONTINUE
      IF(
     - LBLRTR.LT.0
     -)THEN
        MHST = MHSTL
        IMAX = IMAXL
        CALL MVC(HST(1),0,HSTL(1),0,10)
        ZW1 = ZW1L
        ZW2 = ZW2L
        CRV0 = CRVL
      ELSE
        MHST = MHSTR
        IMAX = IMAXR
        CALL MVC(HST(1),0,HSTR(1),0,10)
        ZW1 = ZW1R
        ZW2 = ZW2R
        CRV0 = CRVR
      ENDIF
      IF(
     - IMAX.EQ.19 .AND.
     ?   HST(1).GT.0 .AND. HST(1).GT.HST(2) .AND. HST(5).NE.0
     -)THEN
        IMAX = IMAX + 1
      ENDIF
      IF(
     - IMAX.EQ.22 .AND.
     ?   HST(5).GT.0 .AND. HST(5).GT.HST(4) .AND. HST(1).NE.0
     -)THEN
        IMAX = IMAX - 1
      ENDIF
      IM1 = IMAX - 1
      IM3 = IMAX + 1
      NHST  = HST(2) + HST(3) + HST(4)
      NHTTR = 0
      IF(
     - NHST.GE.3
     -)THEN
        IHIT = 0
        ILAYL = -1
        LBHDEL = 0
        CALL SETS(HLBAR(1),0,32,0)
      DO 13006 IP0 = HPHT0,HPHT9,HLDHT
          IBNL = -1000
          IBNR = -1000
      IF(
     - IABS(IWRK(IP0)-IW1).LE.1
     -)THEN
      IF(
     - LBLRTR.LT.0
     -)THEN
              IF(IP0.EQ.MP1.OR.IP0.EQ.MP2.OR.IP0.EQ.MP3) IBNL = IMAX
      ELSE
              IF(IP0.EQ.MP1.OR.IP0.EQ.MP2.OR.IP0.EQ.MP3) IBNR = IMAX
      ENDIF
      ELSE
            X   = WRK(IP0+5)
            Y   = WRK(IP0+6)
            DX  = ZW1 - X
      IF(
     - ABS(DX).GT.5.0
     -)THEN
              CRV = (ZW2*X - Y) / (DX*X)
              IBNL = (CRV-CRV0) / DCRV + 1
      ENDIF
            X   = WRK(IP0+7)
            Y   = WRK(IP0+8)
            DX  = ZW1 - X
      IF(
     - ABS(DX).GT.5.0
     -)THEN
              CRV = (ZW2*X - Y) / (DX*X)
              IBNR = (CRV-CRV0) / DCRV + 1
      ENDIF
      ENDIF
      IF(
     - IABS(IBNL-IBNR).GT.3
     -)THEN
            ILAY = IWRK(IP0)
      IF(
     - IBNL.GE.IM1 .AND. IBNL.LE.IM3
     -)THEN
      IF(
     - ILAY.EQ.ILAYL
     -)THEN
                IF(LBHDEL.EQ.0) IHIT = IHIT - 1
                LBHDEL = 1
      ELSE
                IHIT = IHIT + 1
                HPBAK(IHIT  ) = IP0
                HLYAR(IHIT  ) = ILAY
                HLBAR(IHIT  ) =   1
                DSPAR(IHIT  ) = WRK(IP0+2)
                XTRAR(IHIT  ) = WRK(IP0+5)
                YTRAR(IHIT  ) = WRK(IP0+6)
                ILAYL = ILAY
                LBHDEL = 0
      ENDIF
      ELSE
      IF(
     - IBNR.GE.IM1 .AND. IBNR.LE.IM3
     -)THEN
      IF(
     - ILAY.EQ.ILAYL
     -)THEN
                IF(LBHDEL.EQ.0) IHIT = IHIT - 1
                LBHDEL = 1
      ELSE
                IHIT = IHIT + 1
                HPBAK(IHIT  ) = IP0
                HLYAR(IHIT  ) = ILAY
                HLBAR(IHIT  ) =   1
                DSPAR(IHIT  ) = WRK(IP0+2)
                XTRAR(IHIT  ) = WRK(IP0+7)
                YTRAR(IHIT  ) = WRK(IP0+8)
                ILAYL = ILAY
                LBHDEL = 0
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
        NHTTR = IHIT
      ENDIF
      GOTO IZZZ02
17008 CONTINUE
        IHIT = 0
        IWL  =-1
        CALL SETS(HLBAR(1),0,32,0)
      DO 13008 IP0 = HPHT0,HPHT9,HLDHT
          IW0 = IWRK(IP0)
          X   = WRK(IP0+5)
          Y   = WRK(IP0+6)
          F   = (PAR1 *X + PAR2 )*X + PAR3
          DFL = F - Y
      IF(
     - ABS(DFL).LT.FETLIM
     -)THEN
      IF(
     - IWL.EQ.IW0
     -)THEN
              IHIT = IHIT - 1
      ELSE
              IHIT = IHIT + 1
              HPBAK(IHIT  ) = IP0
              HLYAR(IHIT  ) = IW0
              HLBAR(IHIT  ) =   1
              DSPAR(IHIT  ) = WRK(IP0+2)
              XTRAR(IHIT  ) = WRK(IP0+5)
              YTRAR(IHIT  ) =   Y
              IWL = IW0
      ENDIF
      ENDIF
          X   = WRK(IP0+7)
          Y   = WRK(IP0+8)
          F   = (PAR1 *X + PAR2 )*X + PAR3
          DF  = F - Y
      IF(
     - ABS(DF).LT.FETLIM
     -)THEN
      IF(
     - IWL.EQ.IW0
     -)THEN
              IHIT = IHIT - 1
      ELSE
              IHIT = IHIT + 1
              HPBAK(IHIT  ) = IP0
              HLYAR(IHIT  ) = IW0
              HLBAR(IHIT  ) =   1
              DSPAR(IHIT  ) = WRK(IP0+2)
              XTRAR(IHIT  ) = WRK(IP0+7)
              YTRAR(IHIT  ) =   Y
              IWL = IW0
      ENDIF
      ENDIF
13008 CONTINUE
13009 CONTINUE
        NHTTR = IHIT
      GOTO IZZZ04
17004 CONTINUE
      S0 = WGHT0
      S1 = 0.
      S2 = 0.
      S3 = 0.
      S4 = 0.
      S5 = 0.
      S6 = 0.
      S7 = Y0 * WGHT0
      DO 13010 IHIT = 1,NHTTR
          X = XTRAR(IHIT)
          Y = YTRAR(IHIT)
          X2 = X**2
          S1 = S1 + X
          S2 = S2 + X2
          S3 = S3 + X*X2
          S4 = S4 + X2**2
          S5 = S5 + Y*X2
          S6 = S6 + Y*X
          S7 = S7 + Y
          S0 = S0 + 1.
13010 CONTINUE
13011 CONTINUE
      MHIT = S0
      F1 = 1. / S4
      XX12 = S3*F1
      XX13 = S2*F1
      YY1  = S5*F1
      XX22 = S2 - S3*XX12
      XX23 = S1 - S3*XX13
      YY2  = S6 - S3*YY1
      XX32 = S1 - S2*XX12
      XX33 = S0 - S2*XX13
      YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
        XX23 = XX23 / XX22
        YY2  = YY2  / XX22
        PAR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
        PAR2 = YY2 - XX23*PAR3
      ELSE
        XX33 = XX33 / XX32
        YY3  = YY3  / XX32
        PAR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
        PAR2 = YY3 - XX33*PAR3
      ENDIF
      PAR1 = YY1 - XX12*PAR2 - XX13*PAR3
      DEG = S0 - WGHT0 - 2.
      CHISQ = 0.
      DCHIM1 = 0.
      IHITM1 = 0
      NEVN   = 0
      CHEVN  = 0.
      NUNE   = 0
      CHUNE  = 0.
      IHSTRT = 0
      DO 13012 IHIT = 1,NHTTR
          IF(IHSTRT.EQ.0) IHSTRT = IHIT
          IHEND = IHIT
          X = XTRAR(IHIT)
          Y = YTRAR(IHIT)
          F   = (PAR1 *X + PAR2 )*X + PAR3
          DCHI = Y - F
          RESAR(IHIT) = DCHI
          CHISQ = CHISQ + DCHI**2
      IF(
     - ABS(DCHI).GE.DCHIM1
     -)THEN
            DCHIM1 = ABS(DCHI)
            IHITM1 = IHIT
      ENDIF
          ILAY = HLYAR(IHIT)
      IF(
     - ABS(DCHI).LT. 0.6
     -)THEN
      IF(
     - LAND(ILAY,1).EQ.0
     -)THEN
              NEVN  = NEVN  + 1
              CHEVN = CHEVN + DCHI
      ELSE
              NUNE  = NUNE  + 1
              CHUNE = CHUNE + DCHI
      ENDIF
      ENDIF
13012 CONTINUE
13013 CONTINUE
      SIG    =      CHISQ  / DEG
      DSTAG = -1000.
      IF(NEVN.GT.1.AND. NUNE.GT.1) DSTAG = ABS(CHEVN/NEVN - CHUNE/NUNE)
      SIGLM = .25
      GOTO IZZZ03
17013 CONTINUE
        NHTGD  = 0
      DO 13014 IP0 = HPHT0,HPHT9,HLDHT
          IW0 = IWRK(IP0)
          X   = WRK(IP0+5)
          Y   = WRK(IP0+6)
          F   = (PAR1 *X + PAR2 )*X + PAR3
          DFL = F - Y
          X   = WRK(IP0+7)
          Y   = WRK(IP0+8)
          F   = (PAR1 *X + PAR2 )*X + PAR3
          DFR = F - Y
          DF  = DFL
          IF(ABS(DFR).LT.ABS(DFL)) DF = DFR
      IF(
     - ABS(DF).LT.ALBLM2
     -)THEN
            ILBLR = 1
            IF(DF.EQ.DFR) ILBLR = 2
      IF(
     - ABS(DF).LT.ALBLM1
     -)THEN
              NHTGD  = NHTGD + 1
              IF(IWRK(IP0+ 9).LT.0) IWRK(IP0+ 9) = 0
              IF(IWRK(IP0+10).LT.0) IWRK(IP0+10) = 0
              IWRK(IP0+10) = IWRK(IP0+9)
              IWRK(IP0+ 9) = ITRK
      IF(
     - IWRK(IP0+10).NE.0
     -)THEN
                LB2 = LAND(IWRK(IP0+4),    3)*4
      ELSE
                LB2 = 0
      ENDIF
              LB1 = LAND(IWRK(IP0+4),MKLR1)
              LB1 = LOR(LB1,LB2)
              IWRK(IP0+4) = LOR(LB1,ILBLR)
      ELSE
      IF(
     - IWRK(IP0+ 9).LE.0
     -)THEN
                IWRK(IP0+10) = IWRK(IP0+9)
                IWRK(IP0+ 9) =-ITRK
      IF(
     - IWRK(IP0+10).NE.0
     -)THEN
                  LB2 = LAND(IWRK(IP0+4),    3)*4
      ELSE
                  LB2 = 0
      ENDIF
                LB1 = LAND(IWRK(IP0+4),MKLR1)
                LB1 = LOR(LB1,LB2)
                IWRK(IP0+4) = LOR(LB1,ILBLR)
      ENDIF
      ENDIF
      ENDIF
13014 CONTINUE
13015 CONTINUE
      GOTO IZZZ05
      END

C   16/12/83 312161621  MEMBER NAME  MULOCH   (JADEMUS)     FORTRAN
C
C   LAST CHANGE  16/12/83 CHRIS BOWDERY  VARIABLES RENAMED IN PLACES
C        CHANGE  12/07/82 CHRIS BOWDERY  TO CORRECT 3 BUGS
C
C-----------------------------------------------------------------------
      SUBROUTINE MULOCH
C-----------------------------------------------------------------------
C
C             THIS SUBROUTINE PERFORMS THE 'LET-OFF' CHECK
C
C    INPUT:   REGDEV : A VECTOR CONTAINING A SEQUENCE OF:
C                      < REGION NUMBER , ABSORBER ENCOUNTERED , HIT
C                        DEVIATION IN UNITS OF SIGMA >
C             REGDCE : A VECTOR CONTAINING A SEQUENCE OF :
C                      < REGION NUMBER , ABSORBER ENCOUNTERED , LOWER
C                        LIMIT OF 'DCE' , UPPER LIMIT OF 'DCE' >
C                      WHERE 'DCE' IS A DEAD CHAMBER OR EDGE
C             REGZE  : A VECTOR LIKE REGDCE BUT FOR LONGITUDINAL EDGES
C
C    OUTPUT:  INEFF  : INCREMENTED FOR EVERY 'MISSING' REGION FOUND
C             INFLAG : SET TO 2 IF THE TRACK IS OUTER LAYER 'MISSING'
C             LOCHRS : A VECTOR CONTAINING A FLAG FOR EVERY REGION
C                       0 = NOT AFFECTED
C                       1 = MULOCH COULD NOT TEST THE REGION
C       FLAG CODE =     2 = REGION WAS NOT 'LET-OFF'
C                       3 = REGION WAS GIVEN THE BENEFIT OF THE DOUBT
C                       4 = REGION WAS 'LET-OFF'
C
C             THE ACTUAL FLAG IS  10*(DRIFT CODE) + LONGITUDINAL CODE
C             ---> A 'MISSING' REGION HAS CODE '02' OR '20' OR '22'
C
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
C             COMMONS AND ARRAY DECLARATIONS
C
#include "cmufwork.for"
#include "cmureg.for"
#include "cmucalib.for"
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                REGZE(60),LOCHRS(60),ABLOCH(60)
C
      DIMENSION LVREGH(10),DEVIAT(10),ABSORB(10),SLOPE(9),AVEDEV(9)
      DIMENSION LVAL(10),LFLAG1(10)
C
C-------------------- CODE ---------------------------------------------
C
C             ARE THERE ANY 'LET-OFFS' TO BE CHECKED ?
C             ARE THERE ANY HITS ANYWAY ?
C             HAS THE TRACK ALREADY FAILED ?
C
      IF( (REGDCE(1).EQ.0 .AND. REGZE(1).EQ.0)
     +    .OR.   NTHIS.EQ.0
     +    .OR.   INEFF.GT.1                    ) RETURN
C
C             ARE THERE AT LEAST 2 ASSOCIATED HITS IN DIFFERENT
C             LAYERS OUTSIDE THE YOKE ?
C
      IF(NHLAYR.LT.4) RETURN
      CALL VZERO(LOCHRS,60)
      CALL VZERO(ABLOCH,60)
      CALL VZERO(LVREGH ,10)
C
C             UNPACK THE DEVIATIONS AND AVERAGE THE OVERLAP HITS
C             AND SEPARATE THE ABSORPTION VALUES.
C                LREGN   = PREVIOUS REGION NUMBER
C                NRGHIT  = NUMBER OF REGIONS WITH HITS
C                LVREGH  = VECTOR OF REGION NUMBERS WITH HITS
C
      LREGN  = 0
      NRGHIT = 0
C
      DO 1  I = 1,30,3
        IREGN  = REGDEV(I)
        IF(IREGN.EQ.0) GO TO 8
C
C                            BAD HITS HAVE DEVIATION=100 . IGNORE.
C
        IF(REGDEV(I + 2) .EQ.100.) GO TO 1
C
C                            LOOK FOR OVERLAP HITS AND AVERAGE
C
        IF(IREGN.NE.LREGN) GO TO 2
          DEVIAT(NRGHIT) = ( DEVIAT(NRGHIT) + REGDEV(I + 2) ) / 2.0
          LVAL(NRGHIT)   = 2
          GO TO 1
 2      LREGN  = IREGN
        NRGHIT = NRGHIT + 1
        LVREGH(NRGHIT)  = IREGN
        ABSORB(NRGHIT)  = REGDEV(I + 1)
        DEVIAT(NRGHIT)  = REGDEV(I + 2)
        LVAL(NRGHIT)    = 1
 1    CONTINUE
C
 8    KREGH = NRGHIT - 1
C+++
C     WRITE(6,97)(REGDCE(I),I=1,36)
C97   FORMAT(' REGDCE'/(12(X,F10.3) )   )
C     WRITE(6,96)(REGZE(I),I=1,24)
C96   FORMAT(' REGZE'/(12(X,F10.3) )   )
C     WRITE(6,98) NRGHIT,IDTRK,(DEVIAT(I),ABSORB(I),I=1,NRGHIT)
C98   FORMAT(' NRGHIT,IDTRK / DEVIAT,ABSORB ',2I3/2(X,F10.4) )
C+++
      IF(NRGHIT.GT.1) GO TO 3
C
C                  WE ONLY HAVE ONE HIT TO WORK ON. ASSUME THAT
C                  IT LIES ON A LINE WITH ZERO SLOPE IN UNITS OF
C                  SIGMA.
C
        KREGH    = 1
        SLOPE(1) = 0.0
        LFLAG1(1)= 1
        LFLAG2   = 0
        FCT      = 7.5
        IF(LVAL(1).EQ.2)     FCT = 6.0
        IF(DEVIAT(1).LT.0.5) FCT = 5.0
        GO TO 14
C
C                  TAKE EACH ADJACENT PAIR OF HITS AND CALCULATE
C                  THE SLOPE OF THE LINE JOINING THEM.
C
 3    DO 5  I = 1,KREGH
        DIFDEV =  DEVIAT(I + 1) - DEVIAT(I)
        SEPABS =  ABSORB(I + 1) - ABSORB(I)
        IF(SEPABS .LT. 0.1 ) SEPABS = 0.1
        SLOPE(I)  =  DIFDEV / SEPABS
        AVEDEV(I) =  ( DEVIAT(I + 1) + DEVIAT(I) ) / 2.0
C
C                  IS THE SLOPE REASONABLE ?
C
        LFLAG1(I) = 0
        IF(ABS(SLOPE(I) ) .GT. 1.5 ) LFLAG1(I) = 1
        IF(ABS(SLOPE(I) ) .GT. 5.0 ) SLOPE(I)  = 0.0
 5    CONTINUE
C
C                  ARE THE SLOPES CONSISTENT ?
C
 6    NPSLOP = KREGH - 1
      LFLAG2 = 0
      IF(NPSLOP.LT.1) GO TO 24
      DO 7  I = 1,NPSLOP
        IF(ABS(SLOPE(I)-SLOPE(I+1) ) .GT. 0.4 ) LFLAG2 = 1
        IF(ABS(SLOPE(I)-SLOPE(I+1) ) .GT. 1.0 ) LFLAG2 = 2
 7    CONTINUE
C
C             CALCULATE THE FACTORS USED FOR DETERMINING ALLOWANCES
C
 24   FCT = 4.5
      IF(LFLAG2.EQ.1) FCT =  7.0
      IF(LFLAG2.EQ.2) FCT = 10.0
      IF(LFLAG2.EQ.0 .AND. ABS(SLOPE(1))  .LT. 0.35) FCT = FCT - 1.0
      IF(LFLAG2.EQ.0 .AND. ABS(DEVIAT(1)) .LT. 0.35) FCT = FCT - 1.0
C
C             FIND THE LONGITUDINAL LET-OFFS AND CHECK THEIR
C             CONSISTENCY WITH THE HITS IN THE SAME UNIT.
C             THE PLINTH AND A SIDEWALL CAN BE TREATED TOGETHER HERE.
C             IF THERE IS A HIT AFTER A Z LET-OFF THEN THE LET-OFF
C             WAS WRONG PROVIDED THE CHAMBERS ARE THE SAME LENGTH.
C
 14   DO 17  I = 1,60,4
        IREGN = REGZE(I)
        IF(IREGN.EQ.0) GO TO 18
        ABSZE = REGZE(I+1)
        IFACE = HRFACE(IREGN)
C
C                       SELECT AS DEFAULT THE CODE FOR UNTESTABLE.
C
        IF(LOCHRS(IREGN).EQ.0) LOCHRS(IREGN) = 1
        ABLOCH(IREGN) = ABSZE
        DO 19  J = 1,NRGHIT
          JREGN = LVREGH(J)
C
C                            PLINTH AND SIDEWALLS ARE COMPATIBLE
C
          IF(HRFACE(JREGN).NE.IFACE .AND. .NOT.(IFACE.EQ.3 .AND.
     +        HRORI(JREGN).EQ.1)    ) GO TO 19
C
C                       SOME CHAMBERS ARE SHORTER THAN OTHERS
C                       SO THE CHECK CANNOT BE DONE. NOT FOR
C                       THE ENDWALLS.
C
          IF( HRORI(JREGN).EQ.3 ) GO TO 16
          IF( ABS(ZRLO(JREGN)-ZRLO(IREGN) ) .GT. 150. .OR.
     +        ABS(ZRHI(JREGN)-ZRHI(IREGN) ) .GT. 150.  ) GO TO 19
C
 16       IF(ABSZE.GE.ABSORB(J) ) GO TO 19
C
C                       IF THE TRACK IS ROUGHLY HEADING
C                       FOR THE Z GAP IN THE ROOF, WE
C                       CANNOT USE THE Z CONSISTENCY TEST.
C                       USE A COSEC THETA EXCLUSION CHECK.
C
C                       PASS TEST IF 120 < THETA < 60
C
          IF(IFACE.EQ.4 .AND. COSEC.LT.1.155 ) GO TO 19
C
          IF(LOCHRS(IREGN).LT.2) LOCHRS(IREGN) = 2
C
 19     CONTINUE
 17   CONTINUE
C
C             FIND THE DRIFT REGIONS THAT REQUEST TO BE 'LET-OFF'
C             AND DETERMINE WHETHER EXTRAPOLATION OR INTER-
C             POLATION CAN BE USED TO CHECK THEM.
C
 18   DO 10  I = 1,60,4
        IREGN = REGDCE(I)
        IF(IREGN.EQ.0) GO TO 28
C
C                       MARK THE REGION AS UNTESTABLE AS DEFAULT
C
        IF(LOCHRS(IREGN).LT.10 ) LOCHRS(IREGN) = LOCHRS(IREGN) + 10
        ABSDCE = REGDCE(I+1)
        ABLOCH(IREGN) = ABSDCE
C                            NEED EXTRAPOLATION BACKWARDS
        K = 1
        IF( ABSORB(K).LE.ABSDCE ) GO TO 12
C                            IS IT UNTESTABLE ? JUMP IF YES
          IF( HRORI(LVREGH(K)).EQ.3 .AND. HRORI(IREGN).EQ.1 ) GO TO 10
 38       IF(LVREGH(K+1).EQ.0) GO TO 41
          IF( HRORI(LVREGH(K)).NE.1 .OR. HRORI(LVREGH(K+1)).NE.3 )
     +                                           GO TO 39
 41         SLOPE(K) = 0.0
            ALW = (ABSORB(K)-ABSDCE) * 0.9
            IF(ALW.GT.2.0) ALW = 2.0
            IF(ALW.LT.0.3) ALW = 0.30
            GO TO 42
 39       IF(LFLAG1(K).EQ.1) FCT = FCT * 1.5
          ALW = FCT * (ABSORB(K)-ABSDCE) * 0.10
          IF(ALW.GT.2.0) ALW = 2.0
          IF(ALW.LT.0.3) ALW = 0.3
 42       CALL MULOC2 (LQ,I,ALW,SLOPE(K),ABSDCE,ABSORB(K),DEVIAT(K) )
          GO TO 15
C
C                            TAKE EACH ADJACENT HIT PAIR AND
C                            DETERMINE IF A 'LET-OFF' REGION LIES
C                            IN BETWEEN.
C
 12     DO 20  M = 1,KREGH
          IF( LVREGH(M+1).EQ.0) GO TO 20
          IF( ABSORB(M+1).LT.ABSDCE ) GO TO 20
C
C                            DON'T BOTHER IF THE 'LET-OFF' REGION IS
C                            IN A SIDEWALL AND THE HITS ARE IN THE
C                            PLINTH AND ENDWALL
C
            IF(HRORI(LVREGH(M)).EQ.2.AND.HRORI(IREGN).EQ.1 .AND.
     +         HRORI(LVREGH(M+1)).EQ.3) GO TO 10
C
C                            IF THE 2 HITS ARE IN THE PLINTH AND ENDWALL
C                            THEN INTERPOLATION BETWEEN THE HITS IS NOT
C                            POSSIBLE. USE EXTRAPOLATION.
C
          IF(HRORI(LVREGH(M)).EQ.1.AND.HRORI(LVREGH(M+1)).EQ.3) GO TO 3500025500
C
C                            --->   INTERPOLATE TO CHECK 'LET-OFF'  <---
C
              IF(LFLAG1(M).EQ.1) FCT = FCT * 1.5
              ALW = FCT * (ABSORB(M+1)-ABSORB(M) ) * 0.035
              IF(ALW .GT. 1.2 ) ALW = 1.2
              IF(ALW.LT.0.25) ALW = 0.25
              CALL MULOC2 (LQ,I,ALW,SLOPE(M),ABSDCE,ABSORB(M),DEVIAT(M))
              GO TO 15
C
 35           IF(HRORI(IREGN).EQ.3) GO TO 36
                K = M
                IF(K.EQ.1) GO TO 44
              GO TO 37
 36             K = M + 1
                IF(K.EQ.NRGHIT) GO TO 41
              GO TO 38
 20     CONTINUE
C                            --->  EXTRAPOLATION FORWARDS   <---
        K = KREGH
        IF(LVREGH(K+1).EQ.0) GO TO 44
C                            IS IT UNTESTABLE ? JUMP IF YES
        IF(HRORI(IREGN).EQ.3 .AND. HRORI(LVREGH(K+1)).EQ.1) GO TO 10
        IF(HRORI(IREGN).NE.3 .OR. HRORI(LVREGH(K)).NE.1) GO TO 37
          K = K +1
 44       SLOPE(K) = 0.0
          ALW = (ABSDCE-ABSORB(K) ) * 0.9
          IF(ALW.GT.2.0) ALW = 2.0
          IF(ALW.LT.0.3) ALW = 0.3
          GO TO 43
C
 37     IF(LFLAG1(K).EQ.1) FCT = FCT * 1.5
        ALW = FCT * (ABSDCE-ABSORB(K+1) ) * 0.10
        IF(ALW.GT.2.0)  ALW = 2.0
        IF(ALW.LT.0.3) ALW = 0.3
 43     CALL MULOC2 (LQ,I,ALW,SLOPE(K),ABSDCE,ABSORB(K),DEVIAT(K) )
 15     IF(LQ*10 .GT. LOCHRS(IREGN) )
     +        LOCHRS(IREGN) = LQ * 10 + MOD(LOCHRS(IREGN),10)
 10   CONTINUE
C
C             DETERMINE THE NUMBER OF TRUE INEFFICIENCIES FOR
C             THE TRACK.
C
 28   DO 30  IREGN = 1,60
        LCODE = LOCHRS(IREGN)
        IF(LCODE.NE.22 .AND. LCODE.NE.2 .AND. LCODE.NE.20 ) GO TO 30
          INEFF = INEFF + 1
C                       IF THIS IS THE LAST REGION, FLAG IT AS O.L.I.
          IF(ABLOCH(IREGN).GE.ABSORB(NRGHIT) ) INFLAG = 2
 30   CONTINUE
C
C+++
C     IF(INFLAG.EQ.2) WRITE(6,99)IDTRK
C99   FORMAT(' TRACK ',I2,' REJECTED BY MULOCH')
C     WRITE(6,99) INEFF,NHLAYR,INFLAG,LOCHRS
C99   FORMAT(' INEFF,NHLAYR,INFLAG / LOCHRS ',3I3/2(X,30I3/))
C+++
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE MULOC2 (LQUAL,IP,ALLOW,SLOPE,ABSDCE,ABSORB,DEVIAT)
C-----------------------------------------------------------------------
C
C             THIS SUBROUTINE CALCULATES THE EXPECTED DEVIATION
C             AT A REGION SITTING BEHIND 'ABSDCE' OF ABSORBER
C             USING A STRAIGHT LINE WITH SLOPE 'SLOPE' AND PASSING
C             THROUGH A POINT WITH DEVIATION 'DEVIAT' SITTING BEHIND
C             'ABSORB' OF ABSORBER.
C
C     IP     IS A POINTER TO THE 1ST WORD IN REGDCE FOR THIS REGION
C     LQUAL  IS THE RETURNED QUALITY FLAG
C               2 = TRACK WAS INSIDE ACTIVE REGION
C               3 = TRACK PROBABLY WAS OUTSIDE ACTIVE REGION
C               4 = TRACK WAS ALMOST CERTAINLY OUTSIDE ACTIVE REGION
C     ALLOW  IS THE QUANTITY USED TO DETERMINE WHETHER A TRACK WAS CLOSE
C            TO THE EDGE OF THE ACTIVE REGION
C
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(50),
     +                REGZE(50),LOCHRS(60),ABLOCH(60)
C
      ESTDEV = SLOPE * (ABSDCE - ABSORB) + DEVIAT
C
      IF(ESTDEV.GE.REGDCE(IP+2) .AND. ESTDEV.LE.REGDCE(IP+3))GO TO 2
        IF(ESTDEV+ALLOW.GE.REGDCE(IP+2)  .AND.
     +     ESTDEV-ALLOW.LE.REGDCE(IP+3)      ) GO TO 1
             LQUAL = 2
             RETURN
 1         LQUAL = 3
           RETURN
C
 2      LQUAL = 4
        RETURN
        END

C   15/02/82 704061535  MEMBER NAME  TAGF82   (S)           FORTRAN
      SUBROUTINE TAGF82(IFLAG)
C
C  INTRODUCED ON THIS LIBRARY ON 6.4., BY COPY FROM JADEPR.JADESR
C
C THE PREVIOUS VERSION SEEMS TO HAVE BEEN A TEST VERSION, IT GAVE
C WRONG RESULTS (DID NOT FIND THE MAJORITY OF TAGGED EVENTS)
C  (INTRODUCED IN MARCH 85 BY JOHN NYE, FROM GOD KNOWS WHERE)
C  (IT CAN BE INSPECTED IN TAGF820)
C
C                               6.4.87  J.OLSSON
C
C---  TAGF82 IS AN UPDATED VERSION (1982 ONWARDS) OF TAGFLG
C---  TAGF82 CHECKS THE CONTENT OF WORD 24 IN THE LATC-BANK
C---  IF FOR A TAGG-LATCH SET THE SMZ-/SPZ-BIT IS MISSING,
C---     THE CONTENT OF WORD 28 IS CHECKED AS WELL
C---  TAGF82 RETURNS THE SUM OF THE FOLLOWING NUMBERS VIA IFLAG:
C       0  IF NO LEAD-GLASS OF THE FORWARD DETECTOR IS HIT
C       1  IF THE LEAD-GLASS ENERGY OF THE MINUS Z-SIDE IS ABOVE
C             THRESHOLD (SMZ)
C       2  IF THE LEAD-GLASS ENERGY OF THE PLUS Z-SIDE IS ABOVE
C             THRESHOLD (SPZ)
C      10  IF THE TAGG-LATCH (SMZ.OR.SPZ) IS SET
C     100  IF THE LUMI-LATCH (SMZ.AND.SPZ) IS SET
C
C     H.WRIEDT     15.02.82     13:40
C     LAST MODIFICATION    23.02.82    13:10
C
      EXTERNAL BDLM
C
      COMMON /BCS/ IDATA(30000)
C
      DATA I2/2/,I5/5/,I6/6/,I7/7/,I13/13/,I15/15/,N3/3/
C
      IFLAG = 0
C---  FETCH LATC-POINTER
      IND = IDATA(IBLN('LATC'))
      IF (IND.EQ.0) RETURN
C---  FETCH LATC-DATA
C---  LATCH 22 (I*2-WORD 24)
      LAT = IDATA(IND+12)
C---  LUMI-BIT (#5)
      LLAT = JBIT(LAT,I5)
      IF (LLAT.EQ.1) IFLAG = 100
C---  TAGG-BITS (#2 - #4)
      LLAT = JBYT(LAT,I2,N3)
      IF (LLAT.NE.0) IFLAG = IFLAG + 10
C---  SMZ- AND SPZ-BITS
C     SMZ (#6)
      LLAT = JBIT(LAT,I6)
      IF (LLAT.EQ.1) IFLAG = IFLAG+1
C     SPZ (#7)
      LLAT = JBIT(LAT,I7)
      IF (LLAT.EQ.1) IFLAG = IFLAG+2
      IF (IFLAG.NE.10) RETURN
C---  IF SMZ- AND SPZ-BITS ARE MISSING ALTHOUGH THE TAGG-BIT IS SET,
C     LATCH 26 (I*2-WORD 28) IS CHECKED AS WELL
      LAT = IDATA(IND+14)
C---  SMZ- AND SPZ-BITS
C     SMZ-LO (#13)
      LLAT = JBIT(LAT,I13)
      IF (LLAT.EQ.1) IFLAG = IFLAG+1
C     SPZ-LO (#15)
      LLAT = JBIT(LAT,I15)
      IF (LLAT.EQ.1) IFLAG = IFLAG+2
      RETURN
      END

C   04/07/79 202081534  MEMBER NAME  MUFFLM   (JADEMUS)     FORTRAN
C LAST CHANGE 15.40 08/02/82 HUGH MCCANN  ---- WARNING RE NEW NTPH.
C      CHANGE 10.51 04/07/79 JOHN ALLISON.
      SUBROUTINE MUFFLM(NTRKS,HC,NHITS,NWHIT,IMUR,HMUR,NWMUR,HTC,NTPH)
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION HC(1),IMUR(1),HMUR(1),HTC(1)
C
C-----------------------------------------------------------------------
C
C NTRKS IS NUMBER OF TRACKS.
C HC CONTAINS MUON HIT COORDINATES.
C NHITS IS THE NUMBER OF MUON HITS.
C NWHIT IS THE NUMBER OF WORDS PER HIT IN HC.
C IMUR,HMUR IS MU-RESULTS 'MUR2' BANK 1.
C NWMUR IS NUMBER OF WORDS PER INNER DETECTOR TRACK IN 'MUR2' BANK 1.
C HTC IS HIT-TRACK CORRELLATION ARRAY.
C NTPH IS NUMBER OF TRACKS PER HIT ALLOCATED IN HTC.
C
C-----------------------------------------------------------------------
C
C SORTS OUT RESULTS OF TRACKING FOR SUMMARY RESULTS IN MUR2 BANK 1.
C
C-----------------------------------------------------------------------
C LOOK THROUGH HIT ASSOCIATION ARRAY HTC. ------------------------------
C-----------------------------------------------------------------------
C
      IP=0
      J=0
      DO 2000 IHIT=1,NHITS
      DO 3000 JENTRY=2,NTPH
      JTRK=HTC(J+JENTRY)
      IF(JTRK.EQ.0)GO TO 3002
C
C AMBIGUITY FOUND. FILL AMBIGUITY TABLES FOR TRACK KTRK.
      DO 4000 KENTRY=1,NTPH
      KTRK=HTC(J+KENTRY)
      IF(KTRK.EQ.0)GO TO 4001
      KTRK=IABS(KTRK)
C
      DO 5000 LENTRY=1,NTPH
      IF(LENTRY.EQ.KENTRY)GO TO 5000
      LTRK=HTC(J+LENTRY)
      IF(LTRK.EQ.0)GO TO 5001
      LTRK=IABS(LTRK)
      IPMU2=2*NWMUR*(KTRK-1)
      ILAYER=HC(IP+2)/10
      IF(ILAYER.GT.1)GO TO 5002
      K=HMUR(IPMU2+13)+1
      HMUR(IPMU2+13)=K
CCCCCCCC  N.B. LIMIT=3 , OLD VALUE OF NTPH. DO NOT INCREASE TO 4.
      IF(K.GT.3)GO TO 5000
      HMUR(IPMU2+K+13)=LTRK
      GO TO 5000
 5002 CONTINUE
      K=HMUR(IPMU2+17)+1
      HMUR(IPMU2+17)=K
CCCCCCCC  N.B. LIMIT=3 , OLD VALUE OF NTPH. DO NOT INCREASE TO 4.
      IF(K.GT.3)GO TO 5000
      HMUR(IPMU2+K+17)=LTRK
 5000 CONTINUE
 5001 CONTINUE
C
 4000 CONTINUE
 4001 CONTINUE
C
 3000 CONTINUE
 3002 CONTINUE
      J=J+NTPH
      IP=IP+NWHIT
 2000 CONTINUE
C
C-----------------------------------------------------------------------
C END OF MAIN LOOP OVER HTC. -------------------------------------------
C-----------------------------------------------------------------------
C
 99   CONTINUE
      RETURN
      END

C   17/08/80 009150308  MEMBER NAME  LGPOSC   (SOURCE)      FORTRAN
      SUBROUTINE LGPOSC(ADATA,DEP)
C       ROUGH ENERGY CORRECTION OF POS. DEPENDENCE FOR BARREL
C                               17/08/80  Y.WATANABE
      IMPLICIT INTEGER * 2 (H)
      COMMON /CLGDMS/  X0,RADIUS(6)
      DIMENSION ADATA(16)
      EQUIVALENCE (IBE,BE)
      DATA INIT/0/
      IF(INIT.GT.0) GO TO 10
      INIT=1
      DPHI=3.14159266/42.
10    CONTINUE
C
      BE=ADATA(1)
      IF(IBE.NE.0) GO TO 40
C     (0 FOR BARREL LG)
      E=ADATA(2)
      IF(E.LT.3.) GO TO 40
C
C     Z=ADATA(5)
      Z=1400.*ADATA(5)/(RADIUS(3)+DEP)
      IZ=(Z+1707.2)/106.7+1
      IF(IZ.LT.1 ) IZ=1
      IF(IZ.GT.32) IZ=32
      DZ=Z+1707.2-106.7*(IZ-0.5)
      IF(ABS(DZ).GT.40.) DZ=40.
C
      PHI=ADATA(4)
      IPHI=PHI/DPHI+1
      IF(IPHI.LT.1) IPHI=1
      IF(IPHI.GT.84) IPHI=84
      PHI=PHI-(IPHI-0.5)*DPHI
      PHI=PHI*1250.
      IF(ABS(PHI).GT.30.) PHI=30.
      A=4.5E-5
      IF(IZ.GT.16) IZ=33-IZ
      IF(IZ.LT.10) A=A*(0.5+0.05*IZ)
      CF=1.-A*PHI*PHI
C
      IF(IZ.LE.6) GO TO 30
      A=3.51E-6*(IZ-6)
      CF=CF*(1.-A*DZ*DZ)
30    ADATA(2)=E/CF
C
40    CONTINUE
      RETURN
      END

C   10/06/80 006140539  MEMBER NAME  LGESMR   (SOURCE)      FORTRAN
      SUBROUTINE LGESMR(ADATA)
C       PUT IN ENERGY SMEARING FOR EACH CLUSTER FOUND
C       WRITTEN BY Y.WATANABE   JUNE 10. 1980......
      DIMENSION ADATA(15),IDATA(15)
      REAL*8 FNORM
C     EQUIVALENCE (IDATA(1),ADATA(1)),(ESH,ADATA(2)),(COST,ADATA(7))
C
      DATA IC/0/
      IC=IC+1
      IF(IC.LT.5) WRITE(6,600)
600   FORMAT(2X,5(1H%),' E SMEAR IS CALLED',5(1H%))
C
      ESH=ADATA(2)
      IF(IABS(IDATA(1))-1) 10,30,90
10    CONTINUE
C     BARREL PART
      IF(ESH.GT.6.) GO TO 20
      SIG=SQRT(0.0036/ESH+0.001225)
      IF(SIG.LT.0.055) SIG=0.055
      GO TO 40
20    SIG=0.055-(ABS(ADATA(7))-0.4)*(ESH-6.)/144.
      IF(SIG.LT.0.04) SIG=0.04
      GO TO 40
C
C     END CAP
30    CONTINUE
      SIG=0.28/SQRT(ESH)
      IF(SIG.LT.0.12) SIG=0.12
C
40    ESH=ESH*(1.+FNORM(0.)*SIG)
      IF(ESH.LT.0.) ESH=0.
      ADATA(2)=ESH
90    RETURN
      END

      SUBROUTINE BACKTR
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C----------------------------------------------------------------------
C           MACRO CDSMAX .... PATTERN RECOGNITION CONSTANTS.
C----------------------------------------------------------------------
      COMMON/CDSMAX/DSMAX(16,3,2),DIRWR1(24,2),DIRWR3(48,2)
     *             ,DHALF(16,3,2),DTWICE(16,3,2),HMCH(16,3,2)
     *             ,IBCK(9),DBCK(30),TRMATS(96,2),TRMATC(96,2)
C------------------------ END OF MACRO CDSMAX -------------------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C------------------------------------------
C  MACRO CLBPGM ....
C------------------------------------------
      COMMON /CLBPGM/ LBPGM(30)
C--------- END OF MACRO CLBPGM ------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      DIMENSION HORD(200),HTEMP(10)
      DIMENSION LSTCL(3),LFTCL(3),NCELL(3),TANDEL(3)
      EQUIVALENCE (IBCK(1),LSTCL(1)),(IBCK(4),LFTCL(1))
      EQUIVALENCE (IBCK(7),NCELL(1)),(DBCK(1),TANDEL(1))
      EQUIVALENCE (ADWRK(486),HTEMP(1)),(ADWRK(491),HORD(1))
      DATA HPST/'PS'/
      DATA MSKCR1,MSKCR2,MSKZEN /Z100,Z200,Z80/,MSKERA/ZFFFFBFFF/
      DATA MSKLR0/Z1000/,MSKKIL/Z20000/,MSKLRA/ZFFFFEFFF/
      DATA MSKDSP,MSKERR,MSKSKP/Z2000,Z4000,Z8000/
      LBPGM(10)=1
      IF(HNTR.LE.0.OR.HPRO.NE.HPST) RETURN
      DO 13000 I=1,HNTR
      HORD(I)=I
13000 CONTINUE
13001 CONTINUE
      IF(
     - HNTR.GT.1
     -)THEN
      INR=HNTR-1
      DO 13002 IBK=1,INR
      IBC=IBK+1
      IF(
     - IPCL(IBK).EQ.IPCL(IBC)
     -)THEN
      IF(
     - NWR2(IBK).GT.NWR2(IBC).AND.NWR1(IBK).GT.NWR1(IBC)
     -)THEN
      TEMP=HORD(IBK)
      HORD(IBK)=HORD(IBC)
      HORD(IBC)=TEMP
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
      ENDIF
      IBFIT=0
      ISP=0
      ITOL1=2
      IS=0
      ZERO=0
      CALL SETSL(HUSE(1),0,400,ZERO)
      CALL SETSL(NTR,0,2004,ZERO)
      DO 13004 I=1,HNTR
      IF(LAND(LBL(I),MSKKIL).NE.0) HUSE(I)=1
13004 CONTINUE
13005 CONTINUE
      DO 13006 ITRL=1,HNTR
      K=HNTR-ITRL+1
      K=HORD(K)
      IF(
     - HUSE(K).EQ.0
     -)THEN
      IF(
     - NTR.LT.100
     -)THEN
      ICNT = 0
      ICL=IPCL(K)
      IJFLG=0
      LRING=1
      ITOL=1
      IF(ICL.GT.NCELL(1)) LRING=2
      IF(ICL.GT.NCELL(2)+NCELL(1)) LRING=3
      IF(
     - LRING.LE.ITOL1
     -)THEN
      IF(
     - IS.GT.0
     -)THEN
      ITOL=2
      INTR=NTR
      IIK=K
      ITOL1=ITOL1-1
      ILRNG=LRING
      IS1=IS
      IS=0
      DO 13008 IU=1,IS1
      NTR=HSP1(IU)
      K=HISTR(HNREL(NTR),NTR)
      LR=1
      IF(K.LT.0) LR=-1
      K=IABS(K)
      LBL(K)=LAND(LBL(K),MSKERA)
      ICL=IPCL(K)
      LRING=1
      IF(ICL.GT.NCELL(1)) LRING=2
      IF(ICL.GT.NCELL(2)+NCELL(1)) LRING=3
      KRING=LRING
      IPST=1
      IJFLG=0
      ITMP=HISTR(1,NTR)
      ITMP=IABS(ITMP)
      ITMP=IPCL(ITMP)
      IF(ICL.NE.ITMP) IPST=0
      IF(
     - LAND(LBL(K),MSKLR0).NE.0
     -)THEN
      ITMP=HNREL(NTR)
      DO 13010 IX=1,ITMP
      IJ=HISTR(IX,NTR)
      IJ=IABS(IJ)
      LBL(IJ)=LAND(LBL(IJ),MSKLRA)
13010 CONTINUE
13011 CONTINUE
      IF(
     - ITMP.EQ.1
     -)THEN
      LR=0
      ELSE
      IJFLG=1
      ENDIF
      ENDIF
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
13008 CONTINUE
13009 CONTINUE
      NTR=INTR
      ICNT=0
      IJFLG=0
      ITOL=1
      K=IIK
      LRING=ILRNG
      ENDIF
      ENDIF
      IF(
     - HUSE(K).EQ.0
     -)THEN
      ICL=IPCL(K)
      KRING=LRING
      NTR = NTR + 1
      IKX=K
      CALL LFRT(LR2)
      LR=LR2
      IF(LR.EQ.0) LR=1
      CALL BSTORE
      LR=LR2
      ASSIGN 17002 TO IZZZ01
      GOTO 17000
17002 CONTINUE
      ENDIF
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
      DO 13012 KTR=1,NTR
      ITMP=HNREL(KTR)
      ASSIGN 17004 TO IZZZ02
      GOTO 17003
17004 CONTINUE
      IF(KMP1.EQ.KMP2) LBL(ITKEL)=LOR(LBL(ITKEL),MSKLR0)
      IF(KMP1.EQ.KMP2) LBL(ITKEL1)=LOR(LBL(ITKEL1),MSKLR0)
      DO 13014 MG=1,ITMP
      JK=HISTR(MG,KTR)
      IKX=IABS(JK)
      CALL LFRT(LR2)
      IF(
     - JK*LR2.LT.0
     -)THEN
      IF(
     - IBKK(20).NE.0.AND.NRHT(IKX).GE.IBKK(19)
     -)THEN
      ELSE
      LBL(IKX)=LOR(LBL(IKX),MSKDSP)
      ENDIF
      ENDIF
13014 CONTINUE
13015 CONTINUE
13012 CONTINUE
13013 CONTINUE
      IF(
     - NTR.GT.1
     -)THEN
      DO 13016 KTR=1,NTR
      ASSIGN 17005 TO IZZZ02
      GOTO 17003
17005 CONTINUE
      IR1=1
      IR2=1
      IF(KMP1.GT.NCELL(1)) IR1=2
      IF(KMP1.GT.NCELL(1)+NCELL(2)) IR1=3
      IF(KMP2.GT.NCELL(1)) IR2=2
      IF(KMP2.GT.NCELL(1)+NCELL(2)) IR2=3
      IF(IR2.EQ.1.AND.IR1.EQ.3.AND.LAND(MSKSKP,LBL(ITKEL)).EQ.0)
     *  HORD(KTR)=1
      IF(IR2.EQ.1.AND.IR1.EQ.2) HORD(KTR)=6
      IF(LAND(MSKSKP,LBL(ITKEL)).NE.0) HORD(KTR)=2
      IF(IR2.EQ.2.AND.IR1.EQ.3) HORD(KTR)=3
      IF(
     - IR1.EQ.IR2
     -)THEN
      IF(IR1.EQ.3) HORD(KTR)=5
      IF(IR1.EQ.2) HORD(KTR)=4
      IF(IR1.EQ.1) HORD(KTR)=7
      ENDIF
13016 CONTINUE
13017 CONTINUE
      INR=NTR-1
      DO 13018 IBK=1,INR
      IUP=IBK+1
      DO 13020 IBC=IUP,NTR
      IF(
     - HORD(IBC).LT.HORD(IBK)
     -)THEN
      CALL MVC2(HTEMP(1),0,HISTR(1,IBC),0,18) !PMF 28/06/99 MVC -> MVC2
      CALL MVC2(HISTR(1,IBC),0,HISTR(1,IBK),0,18)!PMF 28/06/99 MVC -> MVC2
      CALL MVC2(HISTR(1,IBK),0,HTEMP(1),0,18) !PMF 28/06/99 MVC -> MVC2
      TEMP=HNREL(IBC)
      HNREL(IBC)=HNREL(IBK)
      HNREL(IBK)=TEMP
      TEMP=HORD(IBC)
      HORD(IBC)=HORD(IBK)
      HORD(IBK)=TEMP
      ENDIF
13020 CONTINUE
13021 CONTINUE
13018 CONTINUE
13019 CONTINUE
      IF(
     - IYBKK(11).NE.0
     -)THEN
      HPFRE0=HPFREE
      IMOSS=99
      CALL BAKPAK(IMOSS)
      HPFREE=HPFRE0
      ENDIF
      IF(
     - IYBKK(15).NE.0
     -)THEN
      HPFRE0=HPFREE
      IMOSS=0
      CALL BAKPAK(IMOSS)
      HPFREE=HPFRE0
      ENDIF
      IP0=0
      DO 13022 I=1,100
      IF(
     - HNREL(I).EQ.0
     -)THEN
      IP0=I
      GOTO 13023
      ENDIF
13022 CONTINUE
13023 CONTINUE
      IF(
     - IP0.NE.0
     -)THEN
      DO 13024 I=1,100
      IF(
     - IP0.LT.I
     -)THEN
      IF(
     - HNREL(I).NE.0
     -)THEN
      HNREL(IP0)=HNREL(I)
      HNREL(I)=0
      DO 13026 J=1,9
      HISTR(J,IP0)=HISTR(J,I)
      HISTR(J,I)=0
13026 CONTINUE
13027 CONTINUE
      IP0=IP0+1
      ENDIF
      ENDIF
13024 CONTINUE
13025 CONTINUE
      ENDIF
      ICOUNT=0
      DO 13028 I=1,100
      IF(HNREL(I).NE.0) ICOUNT=ICOUNT+1
13028 CONTINUE
13029 CONTINUE
      NTR=ICOUNT
      ENDIF
      RETURN
17000 CONTINUE
      ASSIGN 17007 TO IZZZ03
      GOTO 17006
17007 CONTINUE
      IF(
     - KRING.GT.0.AND.IRIFLG.NE.0
     -)THEN
      ASSIGN 17008 TO IZZZ03
      GOTO 17006
17008 CONTINUE
      IF(
     - KRING.GT.0.AND.IRIFLG.NE.0
     -)THEN
      ASSIGN 17009 TO IZZZ03
      GOTO 17006
17009 CONTINUE
      ENDIF
      ENDIF
      GOTO IZZZ01
17006 CONTINUE
      ICNT = ICNT + 1
      IF(
     - ICNT.EQ.1.AND.ITOL.EQ.1
     -)THEN
      IUDFLG=3
      ILIM=ILOUT
      KY=K
      ICY=ICL
      IDUM=0
15000 CONTINUE
      IF(
     - IDUM.EQ.0
     -)THEN
      ISTREL=HNREL(NTR)+1
      CALL BSIDE
      IF(
     - IRIFLG.NE.1
     -)THEN
      GOTO 15001
      ENDIF
      INTFLG=0
      IF(
     - HNTCEL(ICX+1)-HNTCEL(ICX).GT.1
     -)THEN
      NTRLX1=HNTCEL(ICX)
      NTRLX2=HNTCEL(ICX+1)-1
      IBFIT=-2
      DO 13030 KK=NTRLX1,NTRLX2
      IF(
     - HUSE(KK).EQ.0
     -)THEN
      IW=NWR1(KK)
      IF(
     - IW.GE.ILBOT
     -)THEN
      CALL  INTJN1(KK,KT,INTFLG,DT)
      IF(
     - INTFLG.NE.0
     -)THEN
      IKX=KK
      LR3=1
      IF(INTFLG.EQ.-1.OR.(LAND(LBL(KT),MSKCR1).NE.0.AND.LAND(LBL(IKX),
     * MSKCR1).EQ.0)) LR3=-1
      LRR=LR
      LR=-LR
      ASSIGN 17011 TO IZZZ04
      GOTO 17010
17011 CONTINUE
      LR=LR2
      CALL BSTORE
      K=IKX
      ASSIGN 17013 TO IZZZ05
      GOTO 17012
17013 CONTINUE
      ICL=ICX
      LR=LRR
      GOTO 13031
      ENDIF
      ENDIF
      ENDIF
13030 CONTINUE
13031 CONTINUE
      IBFIT=0
      ENDIF
      IF(
     - INTFLG.EQ.0
     -)THEN
      ASSIGN 17014 TO IZZZ05
      GOTO 17012
17014 CONTINUE
      GOTO 15001
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      ICL=ICY
      K=KY
      ASSIGN 17016 TO IZZZ06
      GOTO 17015
17016 CONTINUE
      ENDIF
      IW = NWR1(K)
      IUDFLG=6
      IF(
     - IW.GE.ILBOT
     -)THEN
      ASSIGN 17018 TO IZZZ07
      GOTO 17017
17018 CONTINUE
      ENDIF
      ILIM=-ILIN
      IDUM=0
15002 CONTINUE
      IF(
     - IDUM.EQ.0
     -)THEN
      CALL BSIDE
      ICL=ICX
      K=KT
      IF(
     - IRIFLG.EQ.0
     -)THEN
      GOTO 15003
      ENDIF
      ASSIGN 17019 TO IZZZ06
      GOTO 17015
17019 CONTINUE
      IW = NWR1(K)
      IF(
     - IW.GE.ILBOT
     -)THEN
      ASSIGN 17020 TO IZZZ07
      GOTO 17017
17020 CONTINUE
      IF(
     - ISUFLG.EQ.0
     -)THEN
      GOTO 15003
      ENDIF
      ELSE
      GOTO 15003
      ENDIF
      GOTO 15002
      ENDIF
15003 CONTINUE
      IRIFLG = 0
      IUDFLG=0
      IF(
     - KRING.GT.1
     -)THEN
      CALL RINCON
      ASSIGN 17021 TO IZZZ06
      GOTO 17015
17021 CONTINUE
      ENDIF
      IF(
     - IRIFLG.EQ.0
     -)THEN
      IF(
     - LRING.NE.1.AND.KRING.NE.LRING
     -)THEN
      LBL(K)=LOR(LBL(K),MSKERR)
      IF(
     - IS.LT.20
     -)THEN
      IS=IS+1
      HSP1(IS)=NTR
      ENDIF
      ENDIF
      IF(
     - IJFLG.EQ.1
     -)THEN
      ASSIGN 17023 TO IZZZ08
      GOTO 17022
17023 CONTINUE
      ENDIF
      IF(
     - KRING.EQ.2.AND.ITOL.EQ.1
     -)THEN
      IF(
     - ISP.LT.10
     -)THEN
      ISP=ISP+1
      ISKP(ISP)=NTR
      ENDIF
      ENDIF
      IF(
     - LR.EQ.0
     -)THEN
      LBL(K)=LOR(LBL(K),MSKLR0)
      ENDIF
      ENDIF
      IF(
     - LRING.EQ.1.AND.IRIFLG.EQ.0
     -)THEN
      IF(
     - LAND(LBL(K),MSKZEN).EQ.0.AND.ICNT.EQ.1.AND.ISP.GT.0
     -)THEN
      JTRK=HISTR(1,NTR)
      JTRK=IABS(JTRK)
      IC1=2*IPCL(JTRK)+47
      INM=HNREL(NTR)
      INTR=NTR
      DO 13032 I=1,ISP
      IJ=ISKP(I)
      IK=HISTR(HNREL(IJ),IJ)
      IC=IABS(IK)
      IK=IPCL(IC)
      IF(
     - IK.EQ.IC1.OR.IK.EQ.IC1+1
     -)THEN
      IF(
     - LAND(LBL(IC),MSKERR).NE.0
     -)THEN
      IF(
     - ABS(ABS(SL1(IC))-ABS(SL2(JTRK))).LT.BKK(10).AND.ABS(SL1(IC))
     * .LT.BKK(11).AND. ABS(SL2(JTRK)).LT.BKK(11)
     -)THEN
      IXYB=0
      IF(
     - IYBKK(1).NE.0
     -)THEN
      ASSIGN 17025 TO IZZZ09
      GOTO 17024
17025 CONTINUE
      ENDIF
      IF(
     - IXYB.EQ.0
     -)THEN
      NTR=IJ
      ASSIGN 17027 TO IZZZ10
      GOTO 17026
17027 CONTINUE
      INM=HNREL(NTR)
      DO 13034 JZ=1,INM
      IK=HISTR(JZ,NTR)
      IK=IABS(IK)
      LBL(IK)=LOR(LBL(IK),MSKSKP)
      LBL(IK)=LAND(LBL(IK),MSKLRA)
13034 CONTINUE
13035 CONTINUE
      LBL(IC)=LAND(LBL(IC),MSKERA)
      HNREL(INTR)=0
      NTR=INTR-1
      GOTO 13033
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13032 CONTINUE
13033 CONTINUE
      ENDIF
      ENDIF
      GOTO IZZZ03
17017 CONTINUE
      ISUFLG=0
      IF(
     - HNTCEL(ICL+1)-HNTCEL(ICL).GT.1
     -)THEN
      NTRLX1=HNTCEL(ICL)
      NTRLX2=HNTCEL(ICL+1)-1
15004 CONTINUE
      IF(
     - IW.GE.ILBOT
     -)THEN
      IRL=0
      KK=K
      CALL SETSL(ITK(1,1),0,160,ZERO)
      DO 13036 KX=NTRLX1,NTRLX2
      IF(
     - HUSE(KX).EQ.0
     -)THEN
      CALL INTJN1(KK,KX,INTFLG,DTMP)
      IF(
     - INTFLG.NE.0
     -)THEN
      ASSIGN 17029 TO IZZZ11
      GOTO 17028
17029 CONTINUE
      ENDIF
      ENDIF
13036 CONTINUE
13037 CONTINUE
      IF(
     - IRL.GT.0
     -)THEN
      IBFIT=-3
      IF(
     - HNTCEL(ICL+1)-HNTCEL(ICL).GT.2
     -)THEN
      IRT=IRL
      DO 13038 JK=1,IRT
      KX=ITK(JK,1)
      DO 13040 KK=NTRLX1,NTRLX2
      IF(
     - HUSE(KK).EQ.0
     -)THEN
      IW=NWR1(KK)
      IF(
     - IW.GE.ILBOT
     -)THEN
      CALL INTJN1(KK,KX,INTFLG,DTMP)
      IF(
     - INTFLG.NE.0
     -)THEN
      ASSIGN 17030 TO IZZZ11
      GOTO 17028
17030 CONTINUE
      ENDIF
      ENDIF
      ENDIF
13040 CONTINUE
13041 CONTINUE
13038 CONTINUE
13039 CONTINUE
      ENDIF
      IBFIT=0
      ENDIF
      IF(
     - IRL.GT.1
     -)THEN
      CALL CHOOSE
      ENDIF
      IW=-100
      IF(
     - ITK(1,4).EQ.K
     -)THEN
      IKX=ITK(1,1)
      LR3=1
      IF(ITK(1,3).EQ.-1.OR.(LAND(LBL(IKX),MSKCR1).NE.0
     * .AND.LAND(LBL(K),MSKCR1).EQ.0)) LR3=-1
      ASSIGN 17031 TO IZZZ04
      GOTO 17010
17031 CONTINUE
      LR=LR2
      IPST=1
      KTR=NTR
      ASSIGN 17032 TO IZZZ02
      GOTO 17003
17032 CONTINUE
      IF(KMP1.NE.KMP2) IPST=0
      CALL BSTORE
      K=IKX
      IW=NWR1(K)
      ISUFLG=1
      ENDIF
      GOTO 15004
      ENDIF
15005 CONTINUE
      ENDIF
      GOTO IZZZ07
17028 CONTINUE
      IF(
     - IRL.LT.10
     -)THEN
      IRL=IRL+1
      ITK(IRL,1)=KX
      ITK(IRL,3)=INTFLG
      ITK(IRL,4)=KK
      DTEMP(IRL)=DTMP
      ELSE
      ENDIF
      GOTO IZZZ11
17010 CONTINUE
      CALL LFRT(LR2)
      IF(
     - LR2.EQ.0
     -)THEN
      IF(
     - LR.NE.0
     -)THEN
      LR2=LR*LR3
      ELSE
      LR2=LR3
      IJFLG=1
      IPST=1
      ENDIF
      ELSE
      IF(
     - LR.EQ.0
     -)THEN
      IF(LR2*LR3.EQ.-1) HISTR(1,NTR)=-HISTR(1,NTR)
      ELSE
      IF(
     - LR2.NE.LR*LR3
     -)THEN
      LR2=-LR2
      ENDIF
      ENDIF
      ENDIF
      GOTO IZZZ04
17015 CONTINUE
      IF(
     - IRIFLG.EQ.1
     -)THEN
      IF(IUDFLG.EQ.6) LR=-LR
      IF(
     - LAND(LBL(K),MSKCR1).NE.0.AND.LAND(LBL(K),MSKCR2).EQ.0
     -)THEN
      LR=-LR
      HISTR(HNREL(NTR),NTR)=-HISTR(HNREL(NTR),NTR)
      ENDIF
      ENDIF
      GOTO IZZZ06
17022 CONTINUE
      ITMP=HNREL(NTR)
      DO 13042 I=1,ITMP
      JK=HISTR(I,NTR)
      IKX=IABS(JK)
      CALL LFRT(LR2)
      IF(
     - LR2.NE.0
     -)THEN
      IF(LR2*JK.LT.0) CALL COREC
      GOTO 13043
      ENDIF
13042 CONTINUE
13043 CONTINUE
      DO 13044 I=1,ITMP
      JK=HISTR(I,NTR)
      IKX=IABS(JK)
      LBL(IKX)=LOR(LBL(IKX),MSKLR0)
13044 CONTINUE
13045 CONTINUE
      GOTO IZZZ08
17012 CONTINUE
      I9=HNREL(NTR)
      DO 13046 IO=ISTREL,I9
      ITEM=HISTR(IO,NTR)
      J9=IO-2+1
      DO 13048 JO=1,J9
      HISTR(IO-JO+1,NTR)=HISTR(IO-JO,NTR)
13048 CONTINUE
13049 CONTINUE
      HISTR(1,NTR)=ITEM
13046 CONTINUE
13047 CONTINUE
      GOTO IZZZ05
17003 CONTINUE
      KMP1=HISTR(1,KTR)
      KMP1=IABS(KMP1)
      ITKEL1=KMP1
      KMP1=IPCL(KMP1)
      KMP2=HISTR(HNREL(KTR),KTR)
      KMP2=IABS(KMP2)
      ITKEL=KMP2
      KMP2=IPCL(KMP2)
      GOTO IZZZ02
17024 CONTINUE
      IXYB=0
      NTR=IJ
      IBCD=HNREL(NTR)
      CALL MVC2(HTEMP(1),0,HISTR(1,NTR),0,18) !PMF 28/06/99 MVC -> MVC2
      ASSIGN 17033 TO IZZZ10
      GOTO 17026
17033 CONTINUE
      IAB=HNREL(NTR)
      CALL BAKFIT(IXYB,4)
      CALL MVC2(HISTR(1,NTR),0,HTEMP(1),0,18) !PMF 28/06/99 MVC -> MVC2
      HNREL(NTR)=IBCD
      NTR=INTR
      GOTO IZZZ09
17026 CONTINUE
      IJLR=LR
      DO 13050 JZ=1,INM
      IKX=HISTR(JZ,INTR)
      IF(
     - IJLR.EQ.0.OR.IJFLG.NE.0
     -)THEN
      LR=1
      IF(LAND(IK,1).EQ.1) LR=-1
      ELSE
      LR=ISIGN(1,IKX)
      ENDIF
      IKX=IABS(IKX)
      CALL BSTORE
13050 CONTINUE
13051 CONTINUE
      LR=IJLR
      GOTO IZZZ10
      END

C   20/04/85 603042008  MEMBER NAME  RUNFIX   (JADESR)      FORTRAN
C
C-----------------------------------------------------------------------
         SUBROUTINE RUNFIX
C-----------------------------------------------------------------------
C
C      AUTHOR:  C. BOWDERY  20/05/85 :  FIX-UP SOME RUN DEPENDENT VALUES
C
C      CHANGE:  J. OLSSON   16/10/85 :  R22357 BEAM ENERGY FIXED
C      CHANGE:  J. OLSSON    9/02/86 :  NOTIFY FORMAT MODIFIED
C LAST CHANGE:  C. BOWDERY  10/02/86 :  CORRECT EARLIER BUG, ETC
C LAST CHANGE:  J. OLSSON   4/04/86 :  CORR.DATE 29.2-2.3
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
      COMMON / CKALPR / NOHEAD, IBADF, IBADEN, LASTR1, LASTR2
C
C------------------  C O D E  ------------------------------------------
C
      IQHEAD = IBLN('HEAD')
      IHHEAD = IDATA(IQHEAD)*2
C
      IF( IHHEAD .GT. 0 ) GO TO 10
        NOHEAD = NOHEAD + 1
        IF( NOHEAD .LE. 10 ) WRITE(6,5)
   5    FORMAT(/' ***  R U N F I X  ***      ERROR:  NO ''HEAD'' BANK')
        RETURN
C
  10  NRUN   = HDATA(IHHEAD+10)
C
C                            FIX YEAR SCREW UP.
C
      IYEAR  = HDATA(IHHEAD+8)
C
      IF( NRUN .GE.  2570  .AND.  NRUN  .LE. 2802 ) HDATA(IHHEAD+8)=198000003500
C
      IF( NRUN .GT.  6000  .AND.  IYEAR .LT. 1981 ) HDATA(IHHEAD+8)=198100003700
      IF( NRUN .GT. 10000  .AND.  IYEAR .LT. 1982 ) HDATA(IHHEAD+8)=198200003800
      IF( NRUN .GE. 20000  .AND.  IYEAR .LT. 1985 ) HDATA(IHHEAD+8)=198500003900
C
C                            FIX 29 FEBRUARY -2 MARCH 1986 SCREW UP
C
      IF( HDATA(IHHEAD+8) .NE. 1986 ) GO TO 101
      IF( HDATA(IHHEAD+7) .GT. 3 ) GO TO 101
      IF( HDATA(IHHEAD+7) .LT. 2 ) GO TO 101
      IF( HDATA(IHHEAD+7).EQ.3.AND.HDATA(IHHEAD+6).EQ.2.AND.
     $ HDATA(IHHEAD+5).LT.4) HDATA(IHHEAD+6) = 3
      IF( HDATA(IHHEAD+7).EQ.3.AND.HDATA(IHHEAD+6).EQ.1)
     $ HDATA(IHHEAD+6) = 2
      IF( HDATA(IHHEAD+7).NE.2.OR.HDATA(IHHEAD+6).NE.29) GO TO 101
      HDATA(IHHEAD+6) = 1
      HDATA(IHHEAD+7) = 3
C
C                            FIX 29 FEBRUARY 1981 SCREW UP
C
101   CONTINUE
      IF( HDATA(IHHEAD+8) .EQ. 1980 ) GO TO 15
      IF( HDATA(IHHEAD+8) .EQ. 1984 ) GO TO 15
      IF( HDATA(IHHEAD+6) .NE.   29 ) GO TO 15
      IF( HDATA(IHHEAD+7) .NE.    2 ) GO TO 15
        HDATA(IHHEAD+6) = 1
        HDATA(IHHEAD+7) = 3
C
C                            RESET MAGNETIC FIELD FOR PERIOD WHEN  READ
C                            OUT SET IT WRONGLY
C
  15  IF( NRUN .EQ. 11908        )     HDATA(IHHEAD+30) = -4848
C
      IF( NRUN .GE. 13651  .AND.
     +    NRUN .LE. 13653        )     HDATA(IHHEAD+30) = -4844
C
      IF( NRUN .GE. 12255  .AND.
     +    NRUN .LE. 12270        )     HDATA(IHHEAD+30) = -4847
C
      IF( NRUN .GE. 20329  .AND.
     +    NRUN .LE. 20333        )     HDATA(IHHEAD+30) = -4850
C
C                            CORRECT BEAM ENERGIES FOR SELECTED RUNS
C
      IBEAM = HDATA(IHHEAD+29)
C
      IF( NRUN .LT. 10000 ) GO TO 20
      IF( NRUN .GT. 11037  .AND.  NRUN .LT. 11053 ) IBEAM = 17243
      IF( NRUN .EQ. 11104  .OR.   NRUN .EQ. 10666 ) IBEAM = 17300
      IF( NRUN .EQ. 11790  .OR.   NRUN .EQ. 11791 ) IBEAM = 17300
      IF( NRUN .EQ. 12804  .OR.   NRUN .EQ. 12805 ) IBEAM = 19120
      IF( NRUN .GE. 13707  .AND.  NRUN .LE. 13713 ) IBEAM = 20725
      IF( NRUN .EQ. 13714 )                         IBEAM = 20740
      IF( NRUN .EQ. 13826 )                         IBEAM = 20795
      IF( NRUN .EQ. 16342 )                         IBEAM = 23240
      IF( NRUN .EQ. 22357 )                         IBEAM = 21800
C
      HDATA(IHHEAD+29) = IBEAM
C
C                            PRINTOUT(WARNING) LOW MAG.FIELD
C                            MAX 500 TIMES AND ONLY ONCE PER RUN
C
  20  IFIELD = HDATA(IHHEAD+30)
      IF( IABS(IFIELD) .GE. 1000 ) GO TO 30
      IF( NRUN .EQ. LASTR1       ) GO TO 30
        IBADF  = IBADF + 1
        LASTR1 = NRUN
        IF( IBADF .LE. 500 ) WRITE(6,25) NRUN,IFIELD
  25    FORMAT(/' ***  R U N F I X  ***   WARNING:  RUN ',I6,' HAS ',
     +        'A MAGNETIC FIELD VALUE SET TO ',I5,' GAUSS')
        IF( IBADF .LE. 10 ) WRITE(6,28)
  28    FORMAT(/'       PLEASE NOTIFY:   CHRIS BOWDERY    J.OLSSON
     + W.BARTEL   P.STEFFEN   ')
C
C                            PRINTOUT(WARNING) LOW BEAM ENERGY
C                            MAX 500 TIMES AND ONLY ONCE PER RUN
C
 30   IF( NRUN  .LT.   6000 ) GO TO 50
      IF( IBEAM .GE.   5000 ) GO TO 50
      IF( NRUN  .EQ. LASTR2 ) GO TO 50
        IBADEN  = IBADEN + 1
        LASTR2  = NRUN
        IF( IBADEN .LE. 500 ) WRITE(6,40) NRUN,IBEAM
 40     FORMAT(/' ***  R U N F I X  ***   WARNING:  RUN ',I6,' HAS',
     +          ' BEAM ENERGY = ',I6,' MEV')
        IF( IBADEN .LE. 10 ) WRITE(6,28)
C
 50   CONTINUE
C
C                            ROOM FOR FUTURE BODGES HERE
C
      RETURN
      END

C   06/05/83 805261725  MEMBER NAME  MUFFLE   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLE(IPATR,APATR,NTRKS,NWTRK,BGAUSS,HC,NHITS,NWHIT,
     +                  HLUN,IMUR,AMUR,NWMUR,HTC,HAMB,NTPH,
     +                  EXTRA,NPL,EBGEV)
C-----------------------------------------------------------------------
C
C LAST CHANGE  9.40 14/04/88 G.E./J.H.    -CORRECT CALC. OF EXTR. ERRORS
C      CHANGE 19.15 05/02/88 CHRIS BOWDERY-REMOVE CALL TO MUFFLM
C      CHANGE 15.00 08/08/84 PWA   CKB    -CHANGES FOR NALLWM,PMXFLG
C      CHANGE 19.20 22/03/84 CHRIS BOWDERY-STORE NGLAYR IN MUR2/1 WORD 700001200
C      CHANGE 15.00 09/03/84 CHRIS BOWDERY-MUSAFE CALLED EVEN FOR NON-MU
C      CHANGE 15.00 02/12/83 HUGH MCCANN - TO COPE WITH NEW LEAD GLASS.
C      CHANGE 22.00 22/10/83 HUGH MCCANN - BUGS REMOVED .
C      CHANGE 13.30 06/05/83 CHRIS BOWDERY- STRUCTURAL IMPROVEMENTS
C      CHANGE 18.10 21/03/83 CHRIS BOWDERY- NEW RESOLUTION/OVLCUT
C      CHANGE 17.41 29/10/82 IAN GLENDINNING - SET SAFE ACCEPTANCE FLAG.
C      CHANGE 19.07 16/03/82 CHRIS BOWDERY- CLEAR VARIABLES FOR MULOCH.
C      CHANGE 14.30 04/02/82 HUGH MCCANN  - CLEAR CWORK FOR EACH TRACK.
C
C
C    FOLLOWS INNER DETECTOR TRACKS OUT AND FINDS ASSOCIATED MUON CHAMBER
C    HITS (PHILOSOPHY 2).
C
C-----------------------------------------------------------------------
C
C                     D E F I N I T I O N S
C
C-----------------------------------------------------------------------
C
C  IPATR,APATR    I.D. PATREC DATA (SEE JADE COMP. NOTE 12, 23/2/79.)
C  NTRKS          NUMBER OF TRACKS.
C  NWTRK          NUMBER OF WORDS PER TRACK.
C  BGAUSS         MAGNETIC FIELD IN GAUSS.
C  HC             CONTAINS MUON HIT COORDINATES.
C  NHITS          NUMBER OF MUON HITS.
C  NWHIT          NUMBER OF WORDS PER HIT IN HIT COORDINATE ARRAY.
C  HLUN           HIT STATUS ARRAY.
C  IMUR,AMUR      MU-RESULTS 'MUR2' BANK 1 - FILLED BY MUFFLE.
C  NWMUR          NUMBER OF WORDS PER I. D. TRACK IN 'MUR2' BANK 1.
C  HTC            HIT-TRACK CORELLATION ARRAY - FILLED BY MUFFLE.
C  HAMB           AMBIGUITY FLAG FOR EACH ENTRY IN HTC.
C  NTPH           NUMBER OF TRACKS PER HIT ALLOCATED IN HTC.
C  EXTRA          STORES THE POINTS ON THE EXTRAPOLATED TRACK.
C  NPL            NUMBER OF POINTS PER EXTRAPOLATED TRACK.
C  EBGEV          BEAM ENERGY FOR THIS EVENT (IN GEV).
C  NHLAYR         NO. OF LAYERS WHICH WENT OFF FOR EACH TRACK.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                 LOGICAL VARIABLE FOR USE IN NEW LG CALCULATIONS:
      LOGICAL IHRING,LCOVAR
*xxx 13.01.98
      LOGICAL TBIT
*xxx
C
C             COMMONS.  (CMULOC IS USED IN THE 'LET-OFF' CHECK)
C
#include "cmucalib.for"
#include "cmuffl.for"
#include "cmufwork.for"
#include "cmureg.for"
C
      COMMON / CMUIEV / IEV,NEV,IRD,KRUN,KREC,
     +                  ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON / CMULOC / ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                  REGZE(60),LOCHRS(60),ABLOCH(60)
      COMMON / CMUPTC / XEXTRP,YEXTRP,ZEXTRP,VTZCV,LCOVAR,SIGFXY,SIGFCZ
C
      DIMENSION  IPATR(1),APATR(1),HC(1),HLUN(1),IMUR(1),AMUR(1),
     +           HTC(1),HAMB(1),EXTRA(1),CUTS(3)
C
C             CUTS IS VECTOR OF CUTS FOR MUREGY &  CHAMBER INEFFICIENCY.
C
      DATA  CUTS /3*0.0/ , CHINEF /0.05/
C
C------------------  C O D E  ------------------------------------------
C
CDEL1
C     WRITE(6,1863)BGAUSS
C1863 FORMAT(' BGAUSS =',F10.4)
CDEL2
C
C             RCOILM IS MEAN COIL RADIUS.  RCOISQ IS ITS SQUARE.
C***    NO    22/10/83 ...... USE RCOISQ=RCOILI**2 .
C
      RCOILM = 0.5*(RCOILI + RCOILO)
      RCOISQ = RCOILI**2
C
C             SET UP POINTERS FOR MAIN LOOP.
C             .   IPMU IS POINTER TO TRACK INFORMATION IN AMUR.
C             .   IPL IS POINTER TO TRACK INFORMATION IN EXTRA.
C             .   NELIPS IS NUMBER OF MULTIPLE SCATTERING ELIPSES
C                                               ENTERED IN ELIPSE.
C
      IPT   = 0
      IPMU  = 0
      IPL   = 0
      NELIPS= 0
C
C-----------------------------------------------------------------------
C                  S T A R T   O F   M A I N   L O O P
C-----------------------------------------------------------------------
C
C             LOOP OVER TRACKS.                      ***** START LOOP 1.
C
      DO  1000  ITRK = 1,NTRKS
C
C-----------------------------------------------------------------------
C
C             CLEAR  COUNTER  WHICH  COUNTS   NUMBER   OF   SUCCESSFULLY
C             ASSOCIATED HITS FOR THIS TRACK AND THE TWO WHICH COUNT THE
C             NUMBER OF LAYERS WITH HITS ASSOCIATED WITH THIS TRACK.
C
C
      NTHIS  = 0
      NHLAYR = 0
      LAYRAB = 0
      NGLAYR = 0
C
C             CLEAR HIT DEVIATIONS USED IN THE 'LET-OFF' CHECK (LOCH)
C
      CALL VZERO(ALLDEV,24)
      CALL VZERO(ALLABS,12)
C
C             CLEAR INEFFICIENCY FLAG (.NE. 0 IF INEFFICIENCY OCCURRED
C                                   IN LAST CHAMBER REGION INTERCEPTED).
C             CLEAR INEFFICIENCY COUNTER FOR THIS TRACK.
C             CLEAR ARRAY OF REGION NOS. OF ALL ASSOCIATED HITS.
C             CLEAR ARRAY OF REGION NOS. OF  THOSE  REGIONS  WHICH  HAVE
C                                                       ASSOCIATED HITS.
      INFLAG = 0
      INEFF  = 0
      CALL VZERO(IHTREG,20)
      CALL VZERO(IEFFRG,10)
C
C             CLEAR ERROR MATRIX AND OVERLAP HIT MATRIX FOR THIS TRACK
C
      CALL VZERO(EM,900)
      CALL VZERO(IOVLAP,100)
C
C-----------------------------------------------------------------------
C
C             CLEAR COMMON /CWORK/ FOR THIS  TRACK  (BUT  NOT  LOCATIONS
C             ELIPSE(700) WHICH STORES PARAMS OF  ALL  ELLIPSES  OF  THE
C             EVENT, OR NELIPS WHICH COUNTS THE NO. OF ELLIPSES  IN  THE
C             EVENT, OR HBADCH(1000) )
C
      NELOLD = NELIPS
      CALL VZERO(X,4110)
      CALL VZERO(INCHAM(1),50)
      CALL VZERO(CTDASH(1),720)
      NELIPS = NELOLD
C
C-----------------------------------------------------------------------
C
C             FILL FIRST 3 WORDS OF INFORMATION.
C             TRACK NUMBER, PROGRAM IDENTIFIER AND DATE OF THIS VERSION.
C
      IDTRK = IPATR(IPT+1)
      IMUR(IPMU+1) = IDTRK
      AMUR(IPMU+2) = PGMID
      IMUR(IPMU+3) = 880208
C
C++++
C     WRITE(6,1100)ITRK
C1100 FORMAT(/' TRACK :',I5)
C++++
C-----------------------------------------------------------------------
C                  S T E P   1
C-----------------------------------------------------------------------
C
C             FOLLOW INNER DETECTOR TRACK OUT.
C
 1111 CONTINUE
C
C             FROM 19/05/81 , EFFECTIVELY HAVE NO CUTS ON TRACK QUALITY.
C             ----- ONLY INSIST THAT NHZ & NHXY > 0  .
C
      NHXY  = IPATR(IPT+24)
      NHZ   = IPATR(IPT+33)
      IF(NHXY.LT.1 .OR. NHZ.LT.1) GO TO 1113
      RMSXY = APATR(IPT+23)
      RMSZ  = APATR(IPT+32)
C
C++++
C     WRITE(6,1105) NHXY,RMSXY,NHZ,RMSZ
C1105 FORMAT(' ','# RMS (XY,RZ) ',I5,F8.3,I5,F10.1)
C++++
C
C             IF RMSXY/RMSZ ARE CLAIMED TO BE BETTER THAN THE NOMINAL
C             VALUES ( NOZAKI NOTE & DRUMM ET AL. DESY 80/38 ),
C             SET TO NOMINAL. NO LONGER VALID SINCE BETTER CALIBRATION
C             AND FADC-READOUT 1986.
C
CCC   IF(RMSXY.LT.0.185) RMSXY =  0.185
CCC   IF(RMSZ .LT.20.0 ) RMSZ  = 20.0
C
C             SET UP STEPPING LOOP PARAMETERS AND OTHER PARAMETERS.
C
      X1 = APATR(IPT+5)
      Y1 = APATR(IPT+6)
      Z1 = APATR(IPT+7)
      D1 = SQRT(X1**2+Y1**2+Z1**2)
      X2 = APATR(IPT+12)
      Y2 = APATR(IPT+13)
      Z2 = APATR(IPT+14)
      D2 = SQRT(X2**2+Y2**2+Z2**2)
C
      PROJL2 = (X2-X1)**2 + (Y2-Y1)**2
      DDIF2  = PROJL2 + (Z2-Z1)**2
      XMID   = 0.5*(X1+X2)
      YMID   = 0.5*(Y1+Y2)
      ZMID   = 0.5*(Z1+Z2)
CCC   DTC    = 0.5*(D1+D2)
      DTC    = SQRT(XMID**2 + YMID**2 + ZMID**2)
C
      X = X2
      Y = Y2
      Z = Z2
      DCX = APATR(IPT+15)
      DCY = APATR(IPT+16)
      DCZ = APATR(IPT+17)
C
C             CHECK DIRECTION COSINES
C
      CALL MUDCHK(1)
C
      ADCZ   = ABS(DCZ)
      COSEC  = 1. / SQRT(1.00001-DCZ**2)
      COSSQ  = 1.0/(COSEC**2)
CCC   VTXYAN = 12. * RMSXY**2 / (NHXY*(D2-D1)**2)
CCC   VTZANG = 12. * RMSZ**2  / (NHZ*(D2-D1)**2*COSEC**2)
CCC   VTXYD  = RMSXY**2 / NHXY
C       XY-ERRORS NOW CALCULATED AT STATEMENTS 2222 AND 3333
C
C       IF PATR-BANK CONTAINS COVARIANCES TAKE THESE FOR Z-ERRORS
C
      SGFXY2 = SIGFXY**2
      SIGFZ2 = SIGFCZ**2
      IF( .NOT.TBIT(IPATR(IPT+2),19) .OR. NWTRK.LT.59 ) GOTO 1108
C             CHECK IF VALID COVARIANCES
         IF( APATR(IPT+57) .LE. 0.0 ) GOTO 1108
            LCOVAR = .TRUE.
            VTZANG = APATR(IPT+59)*COSSQ*SIGFZ2
            VTZD   = APATR(IPT+57)*COSSQ*SIGFZ2
            VTZCV  = APATR(IPT+58)*COSSQ*SIGFZ2
         GOTO 1109
 1108 VTZANG = 12. * RMSZ**2 * SIGFZ2 * COSSQ / (FLOAT(NHZ)*DDIF2)
      VTZD   = RMSZ**2 * SIGFZ2 * COSSQ / FLOAT(NHZ)
      LCOVAR = .FALSE.
 1109 CONTINUE
      STPINI = XYSTEP * COSEC
      CURV   = - APATR(IPT+28)
C
C             PARTICLE CHARGE IS SIGN OF APATR(IP+28)*BGAUSS.
C
      CHARGE = SIGN( 1.0 , -CURV*BGAUSS)
C**** DANG   = CURV  * STPINI  <-- REPLACED  22/10/83  BY :
      DANG   = CURV  * XYSTEP
      DZ     = DCZ   * STPINI
      PT     = 3.E-8 * BGAUSS / CURV
C
C++++
C             OUTPUT SOME TRACK INFO
C     WRITE(6,1101)DCX,DCY,DCZ,PT
C1101 FORMAT(' DIRECTION COSINES ',3F8.3,' PT ',F10.3)
C     WRITE(6,3498) VTZANG,VTZD,VTZCV
C3498 FORMAT(' VTZANG,VTZD,VTZCV',3E15.4)
C++++
C
C             REJECT TRACKS WITH VERY LOW TRANSVERSE MOMENTUM  .
C
      IF(ABS(PT).LT.0.1) GO TO 1112
C
C             FILL EXTRA
C
      EXTRA(IPL+1) = X2
      EXTRA(IPL+2) = Y2
      EXTRA(IPL+3) = Z2
      P = ABS(PT*COSEC)
      AMUR(IPMU+38)= P
C
C                  IF P > PMAX, PUT P=PMAX (FOR MU TRACKING PURPOSES).
C                  NORMALLY PMAX IS BEAM ENERGY UNLESS THE FLAG PMXFLG
C                  IS NON-ZERO. IN THIS CASE, PMAX = PMXFLG.
C
      PMXVAL = PMXFLG
      IF( PMXVAL .EQ. 0.0 ) PMXVAL = EBGEV
      IF( P .GT. PMXVAL ) P = PMXVAL
C
      PSQ = P**2
      ESQ = PSQ+WMUSQ
      E   = SQRT(ESQ)
      D   = 0.0
      GM  = 0.0
      AB  = 0.0
      RD  = 0.0
      DE  = 0.0
C
      PPIDK  = 0.0
      PKDK   = 0.0
      PPBPEN = 1.0
      PPPEN  = 1.0
      PPIPEN = 1.0
      PKPEN  = 1.0
      VMSANG = 0.0
      VMSD   = 0.0
      CMS    = 0.0
C
C             INITIALISE FLAG TO DISTINGUISH THOSE TRACKS FOR  WHICH  NO
C             INTERCEPTS ARE EXPECTED. IN THE BARREL, THIS  MEANS  THOSE
C             TRACKS WHICH DO NOT GO AS FAR AS THE RADIUS OF  THE  OUTER
C             SURFACE OF THE BARREL LEAD GLASS. IN THE END CAP REGIONS,
C             THIS MEANS THOSE TRACKS WHICH DO NOT  PENETRATE  PAST  THE
C             END CAP IRON.
C
      INSTOP = 1
C
C             STEP OUT TO COIL OR END CAP.         ***** START LOOP 2.
C
 2000 CONTINUE
      DR  = X*DCX + Y*DCY
      IF(DR.LT.0.) GO TO 1112
      X   = X + DCX*STPINI
      Y   = Y + DCY*STPINI
      Z   = Z + DZ
C        22/10/83 : AT LEAST THE NEW DCX SHOULD BE ASSIGNED TO A TEMP
C                   VARIABLE SO THAT THE NEW DCY IS CORRECTLY CALC'D .
C***  DCX = DCX - DCY*DANG       WRONG
C***  DCY = DCY + DCX*DANG       WRONG   REPLACED BY :
      DCXNEW = DCX - DCY*DANG
      DCYNEW = DCY + DCX*DANG
      DCX    = DCXNEW
      DCY    = DCYNEW
C
C             CHECK DIRECTION COSINES
C
      CALL MUDCHK(2)
C
      IF(ABS(Z).GT.ZEP) GO TO 2222
      RSQ = X**2 + Y**2
      IF(RSQ.GT.RCOISQ) GO TO 3333
C
C             END STEPPING LOOP.                   ***** END LOOP 2.
C
      GO TO 2000
C
C             TRACK CURLS BACK TOWARDS INTERACTION  POINT.  ENERGY  LOW.
C             IGNORE. OR TRACK HAS VERY LOW TRANSVERSE MOMENTUM.
C
 1112 IMUR(IPMU+6) = -1
      GO TO 1001
C
C             TRACK REJECTED
C
 1113 IMUR(IPMU+6) = -2
      GO TO 1001
C
C-----------------------------------------------------------------------
C                  S T E P   2
C-----------------------------------------------------------------------
C
C             TRACK THROUGH END-CAP LEAD-GLASS AND END-PLUG IRON.
C             (STEPS 2 AND 3 ARE ALTERNATIVES.)
C
C             FILL EXTRA.
C
 2222 EXTRA(IPL+4) = X
      EXTRA(IPL+5) = Y
      EXTRA(IPL+6) = Z
C
C             CALCULATE EXTRAPOLATION ERROR IN R-PHI-PLANE
      XEXTRP = X
      YEXTRP = Y
      ZEXTRP = Z
      RLEN2  = (X-XMID)**2 + (Y-YMID)**2
      VTXYAN = RMSXY**2 * SGFXY2/
     &                  (FLOAT(NHXY)*PROJL2)*(720.0*RLEN2/PROJL2 + 12.0)
      VTXYD  = RMSXY**2*SGFXY2/FLOAT(NHXY)*(180.0*(RLEN2/PROJL2)**2 -
     &             18.0*RLEN2/PROJL2 + 2.25)
C
C             ASSUME VERTEX IS INTERACTION POINT.
C             ASSUME TRACK HAS PASSED THROUGH END-CAP LEAD-GLASS.
C
C             BACK-TRACKING AND 1ST STEP SAME AS IN STEP 3.
C
      CALL MUFFLB
C
      CALL MUFFLS(&5555)
C
C-----------------------------------------------------------------------
C
C             STEP  FROM  MID-POINT  TO  END-CAP  LEAD-GLASS   SURFACE.
C             (ASSUME PARTICLE PASSES THROUGH 3RD SUPPORT AND END-PLATE,
C             BUT NOT THE OUTER CYLINDER OF THE PRESSURE VESSEL.)
C
      DSTEP  = D3/2.0 - TEPLG/ADCZ
      GMSTEP = GMJET2*COSEC + GMJETE/ADCZ
      ABSTEP = ABJET2*COSEC + ABJETE/ADCZ
      RDSTEP = RDJET2*COSEC + RDJETE/ADCZ
      DESTEP = DEJET2*COSEC + DEJETE/ADCZ
C
      CALL MUFFLS(&5555)
C
C-----------------------------------------------------------------------
C
C             PRESERVE SPECIAL VARIABLES HERE TO  GIVE  VALUES  AT  LAST
C             SEEN POINT TO GOOD APPROXIMATION.
C
      CALL UCOPY(X,X0,NSPECI)
C
C-----------------------------------------------------------------------
C
C             STEP THROUGH END-CAP LEAD-GLASS.
C
      DSTEP  = TEPLG /ADCZ
      GMSTEP = GMEPLG/ADCZ
      ABSTEP = ABEPLG/ADCZ
      RDSTEP = RDEPLG/ADCZ
      DESTEP = DEEPLG/ADCZ
C
      CALL MUFFLS(&5555)
C
C-----------------------------------------------------------------------
C
C             STEP THROUGH END-CAP.
C
      DSTEP  = TEP /ADCZ
      GMSTEP = GMEP/ADCZ
      ABSTEP = ABEP/ADCZ
      RDSTEP = RDEP/ADCZ
      DESTEP = DEEP/ADCZ
C
      CALL MUFFLS(&5555)
C
C             THIS PARTICLE PENETRATED THE EC LEAD GLASS AND THE EC.
C             FILL EXTRA.
C
      INSTOP = 0
      EXTRA(IPL+7) = X
      EXTRA(IPL+8) = Y
      EXTRA(IPL+9) = Z
C
C-----------------------------------------------------------------------
C
C             BEND IN FIELD OF ENDCAP. BENDING  DONE  ALL  IN  ONE  STEP
C             USING  INTEGRATED  B*DL.  ALSO  NOTE  BENDING  DONE  AFTER
C             PASSING THROUGH END CAP, WHICH IS NOT STRICTLY CORRECT BUT
C             SHOULD LEAD TO VERY SMALL ERRORS.
C
C             FOR  R.LT.RCOILM  THE FLUX IS  BCENT *PI * R**2. THEREFORE
C             INTEGRATED B*DL IS FLUX / (2 * PI * R) = BCENT*R / 2.
C
C             FOR  R.T.RCOIL  FLUX  IS BCENT * PI * RCOIL**2. THEREFORE
C             INTEGRATED B*DL IS FLUX / (2 * PI*R)=BCENT*RCOIL**2/(2*R).
C
C             THE COMPONENTS ARE BLX = SIGN(Z)*BL*X/R,
C                                BLY = SIGN(Z)*BL*Y/R,
C                                BLZ = 0.0
C
C             THEN DP=SIGN(CHARGE)*0.3E-3*(CROSS PRODUCT(DCOS*BL)),
C
C             WHERE DP     IS VECTOR CHANGE IN MOMENTUM,
C                   DCOS   IS UNIT VECTOR PARALLEL TO P,
C                   BL     IS INEGRATED B*DL VECTOR.
C
C             CALCULATE INTEGRATED B*DL.
C
 2224 CONTINUE
      BTESLA = 0.0001 * BGAUSS
      RSQ    = X**2 + Y**2
      R      = SQRT(RSQ)
      IF(R.GT.RCOILM) GO TO 2225
      BL     = BTESLA * R / 2.0
      GO TO 2226
 2225 CONTINUE
      BL     = BTESLA * RCOILM**2 / (2.0 * R)
 2226 CONTINUE
C
C             CALCULATE COMPONENTS OF BL.
C
      BLX = BL * X / R
      BLY = BL * Y / R
      IF(Z.GT.0) GO TO 2227
      BLX = - BLX
      BLY = - BLY
 2227 CONTINUE
C
C             CALCULATE CHANGE IN MOMEMTUM.
C
      CON = 0.3E-3 * CHARGE
      DPX = - CON * DCZ * BLY
      DPY =   CON * DCZ * BLX
      DPZ =   CON * (DCX * BLY  -  DCY * BLX)
C
C             CALCULATE NEW DIRECTION COSINES.
C
      DCX = DCX + DPX / P
      DCY = DCY + DPY / P
      DCZ = DCZ + DPZ / P
C
C             CHECK DIRECTION COSINES
C
      CALL MUDCHK(3)
C
      ADCZ  = ABS(DCZ)
      COSEC = 1.0 / SQRT(1.00001 - DCZ**2)
C
C             STORE VALUES OF SPECIAL VARIABLES ETC. FOR RE-TRACKING.
C
      CALL UCOPY(X,X7,NSPECI)
      X7(NSPECI+1) = VMSD
      X7(NSPECI+2) = CMS
      X7(NSPECI+3) = VMSANG
C
C             GO TO STEP 4.
C
      GO TO 4444
C
C-----------------------------------------------------------------------
C             S T E P   3
C-----------------------------------------------------------------------
C
C             TRACK THROUGH COIL AND BARREL LEAD GLASS.
C             (STEPS 2 AND 3 ARE ALTERNATIVES.)
C             FILL EXTRA.
C
 3333 EXTRA(IPL+4) = X
      EXTRA(IPL+5) = Y
      EXTRA(IPL+6) = Z
      XEXTRP = X
      YEXTRP = Y
      ZEXTRP = Z
      RLEN2  = (X-XMID)**2 + (Y-YMID)**2
      VTXYAN = RMSXY**2 * SGFXY2/
     &                  (FLOAT(NHXY)*PROJL2)*(720.0*RLEN2/PROJL2 + 12.0)
      VTXYD  = RMSXY**2*SGFXY2/FLOAT(NHXY)*(180.0*(RLEN2/PROJL2)**2 -
     &             18.0*RLEN2/PROJL2 + 2.25)
C
C             ASSUME VERTEX IS INTERACTION  POINT.  IGNORE  INCREASE  IN
C             LENGTH DUE TO CURVATURE.
C
C             BACK-TRACKING AND 1ST STEP SAME AS IN STEP 2.
C
      CALL MUFFLB
C
      CALL MUFFLS(&5555)
C
C-----------------------------------------------------------------------
C
C             STEP FROM MID-POINT TO COIL.
C
      DSTEP  = D3 / 2.0
      GMSTEP = (GMJET2 + GMJET4 + GMJETO) * COSEC
      ABSTEP = (ABJET2 + ABJET4 + ABJETO) * COSEC
      RDSTEP = (RDJET2 + RDJET4 + RDJETO) * COSEC
      DESTEP = (DEJET2 + DEJET4 + DEJETO) * COSEC
C
      CALL MUFFLS(&5555)
C
C-----------------------------------------------------------------------
C
C             PRESERVE SPECIAL VARIABLES HERE TO  GIVE  VALUES  AT  LAST
C             SEEN POINT TO GOOD APPROXIMATION.
C
      CALL UCOPY(X,X0,NSPECI)
C
C-----------------------------------------------------------------------
C
C             STEP THROUGH COIL.
C
       DSTEP  = TCOIL  * COSEC
C***     22/10/83 :
C        CHECK THAT THIS WON'T PUT THE TRACK INTO THE YOKE END PLATE.
      FACOIL=1.
      IF(  ABS(Z) + ABS(DSTEP*DCZ) .GT. (IZEIO-5.) )
     *           FACOIL = ( (IZEIO-5.) - ABS(Z) )  /  ABS(DSTEP*DCZ)
       DSTEP = DSTEP  * FACOIL
      GMSTEP = GMCOIL * ( COSEC * FACOIL )
      ABSTEP = ABCOIL * ( COSEC * FACOIL )
      RDSTEP = RDCOIL * ( COSEC * FACOIL )
      DESTEP = DECOIL * ( COSEC * FACOIL )
C
      CALL MUFFLS(&5555)
C
C-----------------------------------------------------------------------
C
C             PROJECT TO LEAD-GLASS BARREL  END  PLANES,  Z=+-ZLG.  THE
C             IDEA IS TO FIND OUT IF IT PASSES THROUGH  LEAD  GLASS  AT
C             ALL, AND IF SO, FIND OUT S,  THE  FRACTION  OF  THICKNESS
C             TRAVERSED (WHICH IS LESS THAN 1. IF IT CLIPS THE END).
C
C             HUGH MCCANN 02/12/83 :
C             ----------------------
C             UPDATE FOR CHANGES TO LEAD GLASS IN WINTER 82-83 SHUTDOWN:
C             (A)  2 NEW HALF-RINGS WERE ADDED AT -X+Z AND +X-Z
C                  ... SO THE ZLIMIT OF THE BARREL IS INCREASED TO
C                  ZLGHAF IN THESE QUADRANTS.
C                  INSTEAD OF JUST ZLG , WE HAVE TO USE A TEMPORARY
C                  VARIABLE ZLGBAR WHICH CAN VARY DEPENDING ON THE
C                  YEAR OF DATA-TAKING AND THE DIRECTION OF THE TRACK.
C                  JUST TO BE AWKWARD , THE HALF-RINGS ARE ONLY 25 CM
C                  DEEP COMPARED TO THE 30 CM DEPTH OF THE REST OF THE
C                  BARREL .  THIS IS TGHAF IN THE BLOCK DATA.
C                  SO , WE HAVE TO TEST R AT BOTH ZLG AND ZLGHAF.
C
C             (B)  HIGHER-DENSITY LEAD GLASS WAS PLACED IN THE CENTRAL
C                  PART OF THE BARREL, COVERING  -ZLGC TO +ZLGC .
C
C             XT,YT,ZT,RSQT,RT ARE TEMPORARY WORKING VARIABLES.
C
      ZLGBAR=ZLG
      IHRING=.FALSE.
      IF(IYEAR.LT.1983)GO TO 3330
           IF(  (DCX.LT.0. .AND. DCZ.GT.0. ) .OR.
     *          (DCX.GT.0. .AND. DCZ.LT.0. )      )IHRING=.TRUE.
           IF(IHRING)ZLGBAR=ZLGHAF
 3330 S = 1.0
      IF(ADCZ.LT.0.01) GO TO 3335
          IF(Z.LT..0) ZLGBAR=-ZLGBAR
             DZDCZ = (ZLGBAR-Z) / DCZ
C            FOR IHRING TRUE , ALSO NEED TO KNOW R AT ZLG :
             IF(.NOT.IHRING)GO TO 3336
                 DISZLG = (ZLG-Z) / DCZ
                 IF(Z.LT..0)DISZLG=(-ZLG-Z) / DCZ
 3336        CONTINUE
C
             XT   = X + DCX * DZDCZ
             YT   = Y + DCY * DZDCZ
             RSQT = XT**2 + YT**2
             RT   = SQRT(RSQT)
C            IF TRACK MISSED BARREL LG ALTOGETHER , GO TO 3338 :
             IF(RT.LT.RLG) GO TO 3338
C               IF IHRING NOT TRUE , CAN NOW JUST FOLLOW OLD PROCEDURE .
                IF(IHRING)GO TO 3331
C                   IF R AT ZLG IS GT R OF OUTER LG SURFACE, S IS 1.0 .
                    IF(RT.GT.RLG+TLG) GO TO 3335
C                       OTHERWISE , CALCULATE THICKNESS TRAVERSED.
                        GO TO 3337
C
C                    IN THE CASE WHERE IHRING IS TRUE :
C                    -----------------------------------
 3331            XTZLG  = X + DCX * DISZLG
                 YTZLG  = Y + DCY * DISZLG
                 RSQZLG = XTZLG**2 + YTZLG**2
                 RTZLG  = SQRT(RSQZLG)
C                IF R AT ZLG IS GT R OF OUTER LG SURFACE, S IS 1.0 .
                 IF(RTZLG.GT.RLG+TLG) GO TO 3335
C                        TO BE HERE , THIS TRACK HAS IHRING TRUE AND ITS
C                        VALUE OF R AT ZLG IS BETWEEN RLG AND (RLG+TLG).
C                        STILL HAVE 3 CASES :
C                        (A)  R(ZLGHAF) < RLG + TLGHAF
                      IF(RT.LT.RLG+TLGHAF)GO TO 3337
C                            (B)  R(ZLG) > RLG + TLGHAF
                         RT=RTZLG
                         IF(RT.GT.RLG+TLGHAF)GO TO 3337
C                                (C) FOR THIS ORDER OF TESTS, NOW
C                                    KNOW THAT THIS TRACK
C                                    LEAVES LG THRO' OUTSIDE RADIAL
C                                    SURFACE OF THE NEW HALF-RING .
                            RT=RLG+TLGHAF
3337  S  = (RT - RLG) / TLG
C
C-----------------------------------------------------------------------
C
C             STEP THROUGH BARREL LEAD-GLASS.
C
 3335 CONTINUE
C
C     CHECK IF TRACK TRAVERSES ANY SF6.
C     I.E. CHECK YEAR, AND , IF S .LT. 0.999 , CAN'T BE NEAR CENTRE.
      IF(IYEAR.LT.1983 .OR. S.LT.0.999)GO TO 3342
          IF(ADCZ.LT.0.01) GO TO 3340
C           CALCULATE R AT ZLGC.
            DLGC = (ZLGC-Z) / DCZ
            IF(Z.LT..0)DLGC=(-ZLGC-Z) / DCZ
            XT   = X + DCX * DLGC
            YT   = Y + DCY * DLGC
            RSQT = XT**2 + YT**2
            RT   = SQRT(RSQT)
C           IF TRACK HASN'T REACHED BARREL LG , GO TO 3342 :
            IF(RT.LT.RLG) GO TO 3342
C              IF R AT ZLGC IS GT R OF OUTER LG SURFACE, THEN ONLY
C              SF6 AND S IS 1.0.
               IF(RT.GT.RLG+TLG) GO TO 3340
C                 OTHERWISE , CALCULATE SF6 THICKNESS TRAVERSED.
                  S = ( RT - RLG ) / TLG
C
C              STEP THROUGH SF6 :
C              ------------------
 3340          DSTEP  = (S * COSEC) * TLG
               GMSTEP = (S * COSEC) * GMLGC
               ABSTEP = (S * COSEC) * ABLGC
               RDSTEP = (S * COSEC) * RDLGC
               DESTEP = (S * COSEC) * DELGC
C
               CALL MUFFLS(&5555)
C
C              CHECK IF STILL HAVE TO GO THRO' SOME SF5 .
               IF(S.GT.0.999)GO TO 3338
                   S = ( RLG+TLG - RT ) / TLG
C
C     STEP THROUGH SF5 :
C     ------------------
 3342 DSTEP  = (S * COSEC) * TLG
      GMSTEP = (S * COSEC) * GMLG
      ABSTEP = (S * COSEC) * ABLG
      RDSTEP = (S * COSEC) * RDLG
      DESTEP = (S * COSEC) * DELG
C
      CALL MUFFLS(&5555)
C
C             FIND INTERSECTION WITH INTERNAL CHAMBERS AND YOKE.
C
C
C             THIS PARTICLE DID NOT STOP BEFORE R = RADIUS OF THE OUTER
C             SURFACE OF THE BARREL LEAD GLASS.
C
 3338 INSTOP=0
C
C             BUT FIRST, STORE VALUES OF  SPECIAL  VARIABLES  ETC.  FOR
C             RE-TRACKING.
C
      CALL UCOPY(X,X7,NSPECI)
      X7(NSPECI+1) = VMSD
      X7(NSPECI+2) = CMS
      X7(NSPECI+3) = VMSANG
C
C             CALL MUREGM TO GET MASK FOR MUREGY.
C             THEN MULTIPLY BY 256 TO SELECT YOKE REGIONS.
C
      CALL MUREGM(DCX,CUTS,HMASK)
      HMASK = 256 * HMASK
C
C             CALL MUREGY.
C               1ST ARGUMENT =0 FOR ALL TYPES OF REGIONS.
C               2ND ARGUMENT .NE.0 TO SELECT ONLY +VE DIRECTION REGIONS.
C               3ND ARGUMENT SET TO -1 IF ALL OK.
C               4TH ARGUMENT IS X,Y,Z,DCX,DCY,DCZ.
C               5TH ARGUMENT SELECTION MASK.
C               6TH ARGUMENT NUMBER OF INTERCEPTS FOUND.
C
      CALL MUREGY(0,1,IER,X,HMASK,NCEPTS)
C
C++++
C     ASSIGN 3339 TO LABEL2
C     GO TO 200
C3339 CONTINUE
C++++
C
C             ONLY IER=-1 ACCEPTABLE  BECAUSE  IT  MUST,  REPEAT,  MUST
C             INTERCEPT SOMETHING. SO JUMP ON IF ACCEPTABLE.
C
      IF(IER.EQ.-1) GO TO 3350
C
C             HAVE WRONG IER FROM MUREGY , PUT WORD 6 OF  MUR2/1  =  -3
C             AND  LOOK  AT  REMAINING  TRACKS.  (THIS   SHOULD   NEVER
C             HAPPEN!!!! SORT IT OUT!!!!)
C
C             22/10/83 :  I T    I S    N O W    S O R T E D    O U T  !
C
        CALL MUERRY('MUFFLE',IER,'WRONG SIDE OF YOKE???????????^')
        IMUR(IPMU+6) = -3
C+++    WRITE(6,3346)KRUN,KREC,IDTRK,P,X2,Y2,Z2,
C    * APATR(IPT+15),APATR(IPT+16),APATR(IPT+17),
C    * EXTRA(IPL+4),EXTRA(IPL+5),EXTRA(IPL+6),
C    * X0,Y0,Z0,
C    * X,Y,Z,DCX,DCY,DCZ
C3346  FORMAT(//'0 RUN, RECORD, TRACK ',
C    *  3I6,'  MOMENTUM =',F7.3,/
C    *'0 ORIGINAL X, Y, Z, DCX, DCY, DCZ  =',3F9.1,3F9.4,/
C    *'0 BRANCH   X, Y, Z =',3F9.1,/
C    *'0 AFTER D3 X, Y, Z =',3F9.1,/
C+++ *'0  CURRENT X, Y, Z, DCX, DCY, DCZ  =',3F9.1,3F9.4,//)
        GO TO 1001
C
C
C-----------------------------------------------------------------------
C
C             LOOK THROUGH INTERCEPTS.
C
 3350 IF(NCEPTS.GT.0) GO TO 3360
        CALL MUERRY('MUFFLE',NCEPTS,'NO INTERCEPTS FOUND WITH YOKE.^')
        GO TO 1001
C
C             GO TO 5555 IF TRACK STOPS (I.E. RUNS OUT OF ENERGY).
C             NORMAL RETURN IF HIT FOUND AND PARTICLE NOT STOPPED.
C
 3360 CALL MUFFLY(HC,NHITS,NWHIT,HLUN,HTC,HAMB,NTPH,&5555)
C
C             BACK-TRACK  TO  LAST  NON-CHAMBER   REGION   EXIT   POINT
C             (I.E. YOKE). (THIS  IS  NECESSARY  BECAUSE   UNDER   SOME
C             CIRCUMSTANCES, NOW THAT THE CHAMBER REGIONS ARE  EXTENDED
C             IN MUREG, THE LAST EXIT POINT CAN BE FOR A CHAMBER REGION
C             IN THE ARTIFICIALLY EXTENDED PORTION.)
C
      DSTEP  = -DOVER
      GMSTEP = -GMOVER
      ABSTEP = -ABOVER
      RDSTEP = -RDOVER
      DESTEP = -DEOVER
C
      CALL MUFFLS(&5555)
C
C             FILL EXTRA.
C
      EXTRA(IPL+7) = X
      EXTRA(IPL+8) = Y
      EXTRA(IPL+9) = Z
C
C-----------------------------------------------------------------------
C
C             CHECK  WHICH  YOKE  PIECE.  GO  TO  END-CAP  ROUTINE   IF
C             APPROPRIATE.
C
      IF(HRFACE(IREG(NCEPTS)).GE.5) GO TO 2224
C
C-----------------------------------------------------------------------
C
C             BEND IN YOKE. (NOTE THAT BEND IS MADE AFTER YOKE HAS BEEN
C             TRAVERSED. THIS WILL INTRODUCE A SLIGHT ERROR.  A  BETTER
C             PLACE TO DO IT WOULD BE THE YOKE CENTRE OR DEAL  WITH  IT
C             IN MUFFLS. BUT THE ERROR WILL BE SMALL SO IGNORE  IT  FOR
C             NOW.)
C
C             MAG FIELD IN SIDE, TOP OR BOTTOM OF YOKE.
C
C             TOTAL FLUX = B*PI*R**2 = BL*PERIMETER, WHERE BL IS
C             INTEGRAL B*DL FOR YOKE. MULTIPLY BY 0.0001  TO  GET  FROM
C             GAUSS TO TESSLA.
C
      BL = 0.0001 * BGAUSS * 3.14159 * RCOILM**2 / 14680.
C
C             CONSTANTS (DONT FORGET VECTOR B=-BYOKE*Z(UNIT VEC)
C             CON = 0.3E-3 * MAGFIELD * PARTCHARGE
C
C             WITH THIS NORMALISATION ALL DIS SHOULD BE IN MM, ALL MTA
C             IN GEV AND ALL FIELDS IN TESLA.
C
      CON = 0.3E-3 * BL * CHARGE
C             CALCULATE THE CHANGE IN MTM
      DPX = -DCY * CON
      DPY =  DCX * CON
C
C             CALCULATE NEW DIRECTION COSINES.
C
      DCX = DCX + DPX / P
      DCY = DCY + DPY / P
C
C             CHECK DIRECTION COSINES
C
      CALL MUDCHK(4)
C
C             CONTINUE TO STEP 4.
C
C-----------------------------------------------------------------------
C                   S T E P   4
C-----------------------------------------------------------------------
C
C             CONTINUE TRACKING.
C
C             CALL MUREGM TO GET MASK FOR MUREGY. LEAVE HMASK UNTOUCHED
C             SO THAT IT SELECTS ONLY REGIONS OUTSIDE YOKE.
C
 4444 CALL MUREGM(DCX,CUTS,HMASK)
C     WRITE(6,3444) PROJL2,RLEN2,VTXYAN,VTXYD
C3444 FORMAT(' PROJL2,RLEN2,VTXYAN,VTXYD',4E15.4)
C
C             CALL MUREGY.
C               1ST ARGUMENT =0 FOR ALL TYPES OF REGIONS.
C               2ND ARGUMENT .NE.0 TO SELECT ONLY +VE DIRECTION REGIONS.
C               3ND ARGUMENT SET TO -1 IF ALL OK.
C               4TH ARGUMENT IS X,Y,Z,DCX,DCY,DCZ.
C               5TH ARGUMENT SELECTION MASK.
C               6TH ARGUMENT NUMBER OF INTERCEPTS FOUND.
C
      CALL MUREGY(0,1,IER,X,HMASK,NCEPTS)
C
C++++
C     ASSIGN 4465 TO LABEL2
C     GO TO 200
C4465 CONTINUE
C++++
C
C             THIS TIME ACCEPT  IER=2  TOO.  (IER=2  MEANS  NO  REGIONS
C             INTERCEPTED WHICH IS POSSIBLE IF TRACK GOES  THROUGH  THE
C             GAPS.) IF ERROR, GO TO POINT NEAR END OF DO LOOP.
C
      IF(IER.EQ.-1 .OR. IER.EQ.2) GO TO 4470
        CALL MUERRY('MUFFLE',IER,'WRONG ERROR CODE FROM MUREGY.^')
        IMUR(IPMU+6) = -2
        GO TO 1001
C
C             WE HAVE AN ACCEPTABLE CODE FROM MUREGY.
C             IF NO INTECEPTS FOUND, THERE ARE NO FURTHER CHAMBERS.
C
 4470 IF(NCEPTS.LE.0) GO TO 7777
C
C             TRACK THROUGH REGIONS.
C             GO TO 5555 IF PARTICLE STOPS (I.E. RUNS OUT OF ENERGY).
C             NORMAL RETURN IF HIT FOUND AND PARTICLE NOT STOPPED.
C
      CALL MUFFLY(HC,NHITS,NWHIT,HLUN,HTC,HAMB,NTPH,&5555)
C
      GO TO 7777
C
C-----------------------------------------------------------------------
C                  S T E P   5    -  PARTICLE STOPS
C-----------------------------------------------------------------------
C
 5555 CONTINUE
C++++
C     WRITE(6,5577)
C5577 FORMAT(' PARTICLE STOPS.')
C++++
C
C             FILL EXTRA.
C
      EXTRA(IPL+10) = X
      EXTRA(IPL+11) = Y
      EXTRA(IPL+12) = Z
C
C             CHECK WHETHER THIS PARTICLE STOPPED BEFORE  REACHING  THE
C             OUTSIDE SURFACE OF THE LEAD GLASS OR BEFORE REACHING  THE
C             OUTSIDE SURFACE OF THE END CAP.
C
      IF(INSTOP.EQ.0) GO TO 5556
C
C             THIS PARTICLE FAILED TO  REACH  THE  ABOVE  BOUNDARIES  .
C             THEREFORE , IT HAS NO INTERCEPTS.
C
      EXTRA(IPL+13) = 0.0
      EXTRA(IPL+14) = 0.0
      EXTRA(IPL+15) = 0.0
      GO TO 5557
C
C             THIS PARTICLE PENETRATED THE LEAD GLASS BARREL OR THE END
C             CAP. PUT THE COORDINATES OF THE LAST INTERCEPT  FOUND  BY
C             MUREGY INTO EXTRA (IPL+ 13,14,15) .
C
C
 5556 EXTRA(IPL+13) = CINT(1,NCEPTS)
      EXTRA(IPL+14) = CINT(2,NCEPTS)
      EXTRA(IPL+15) = CINT(3,NCEPTS)
C
 5557 CONTINUE
      GO TO 8888
C
C-----------------------------------------------------------------------
C                  S T E P   6     - DEFUNCT STEP
C-----------------------------------------------------------------------
C                  S T E P   7     - NO FURTHER CHAMBERS.
C-----------------------------------------------------------------------
C
C             NO FURTHER  CHAMBERS,  I.E.  TRACK  NOT  STOPPED  BUT  NO
C             CHAMBERS IN PATH. -
C
 7777 CONTINUE
C++++
C     WRITE(6,7788)
C7788 FORMAT(' NO FURTHER CHAMBERS.')
C++++
C
      EXTRA(IPL+10) = X
      EXTRA(IPL+11) = Y
      EXTRA(IPL+12) = Z
      EXTRA(IPL+13) = X
      EXTRA(IPL+14) = Y
      EXTRA(IPL+15) = Z
C
C             CONTINUE TO STEP 8
C
C-----------------------------------------------------------------------
C                  S T E P   8       -  RE-FIT, RE-TRACK, CLASSIFY AND
C                                       FILL RESULTS BANK (MUR2/1).
C-----------------------------------------------------------------------
C
C
C             PROCESS ONLY THOSE TRACKS WHICH MANAGE TO GET OUT OF  THE
C             BARREL LEAD-GLASS OR END-CAP.
C
 8888 IF(INSTOP.NE.0) GO TO 8889
C
C             CALL MUFFLX TO CALCULATE CHI-SQUARED, ETC. DO  THIS  EVEN
C             IF THERE IS ONLY 1 MUON HIT ASSOCIATED WITH THIS TRACK SO
C             THAT (A) AMBIGUITIES ARE RESOLVED WHEN POSSIBLE  AND  (B)
C             SHARED HITS CAN BE ASSIGNED TO THE BEST TRACK.
C
      IF(NTHIS.GT.0) CALL MUFFLX(HAMB)
C
C             CALL MUFFLR TO RE-FIT MUON HITS. PRODUCES  NEW  VALUE  OF
C             X,Y,Z, DCX,DCY,DCZ. IF THERE ARE LESS THAN  2  ASSOCIATED
C             HITS  THE  RE-FITTED   TRACK   LEFT   AS   THE   EXISTING
C             EXTRAPOLATED INNER DETECTOR TRACK.
C
      CALL MUFFLR(HAMB)
C
C             FIND  X,Y,Z  ON  NEW  TRACK  NEAR  TO  OLD  TRACK   AFTER
C             LEAD-GLASS BARREL OR YOKE END-CAP.
C
      DBACK = SQRT( (X-X7(1) )**2 + (Y-X7(2) )**2 + (Z-X7(3) )**2 )
      X = X - DCX * DBACK
      Y = Y - DCY * DBACK
      Z = Z - DCZ * DBACK
C
C             PICK UP VALUES  OF  SPECIAL  VARIABLES  PERTAINING  AFTER
C             LEAD-GLASS BARREL OR YOKE END-CAP (APART FROM  X,Y,Z  AND
C             DC'S).
C
      CALL UCOPY(X7(7),P,NSPECI-6)
      VMSD   = X7(NSPECI+1)
      CMS    = X7(NSPECI+2)
      VMSANG = X7(NSPECI+3)
C+++
C     WRITE(6,1865)X,Y,Z,DCX,DCY,DCZ,P
C1865 FORMAT(' X,Y,Z,DCX,DCY,DCZ,P',7G15.5)
C+++
C
C             CALL MUREGM TO GET MASK FOR MUREGY.
C             MULTIPLY BY 256 AND ADD TO SELECT ALL REGIONS.
C
      CALL MUREGM(DCX,CUTS,HMASK)
      HMASK = HMASK + 256*HMASK
      CALL MUREGY(0,1,IER,X,HMASK,NCEPTS)
C
C++++
C     ASSIGN 8887 TO LABEL2
C     GO TO 200
C8887 CONTINUE
C++++
C
C             RETRACK TO FIND THE 'MISSING' REGIONS AND THE CAUSES
C
      CALL MUFFLT
C
C-----------------------------------------------------------------------
C
C             CLASSIFY TRACK.
C++++
C             WRITE OUT NTHIS,NHLAYR,INEFF
C     WRITE(6,8890)NTHIS,NHLAYR,INEFF,INFLAG
C8890 FORMAT(1H0,5X,7HNTHIS =,I3,3X,8HNHLAYR =,I3,3X,7HINEFF =,I3,
C    * ', INFLAG =',I2)
C++++
C
C             FILL WORD 4 : 10000*INEFF + 100*NHLAYR + NTHIS
C             FILL WORD 7 : NGLAYR
C
      IMUR(IPMU+4) = 10000*INEFF + 100*NHLAYR + NTHIS
      IMUR(IPMU+7) = NGLAYR
C
C             INTERPRET NHLAYR AND INEFF.
C             FOR PRESENT , NHLAYR > 3 AND INEFF </= 1 ===>  GOOD  MUON
C             I.E. AT LEAST 2 LAYERS FIRING OUTSIDE  MAGNET  YOKE,  AND
C             NOT MORE THAN 'NALLWM' 'MISSING' CHAMBERS ON THIS TRACK.
C             NORMALLY NUMBER OF ALLOWED MISSING CHAMBERS = 1.
C
      IF( NHLAYR .LT. 4  .OR.  INEFF .GT. NALLWM ) GO TO 8889
C
C             ** GOOD MUON **
C++++
C     WRITE(6,8891)
C8891 FORMAT(1H+,70X,15H** GOOD MUON **)
C++++
C
C             FILL RESULTS BANK FOR 'GOOD' MUON.
C
C             FOR NOW, USE CHI-SQUARED PROBABILTY SIMPLY TO SET QUALITY
C             FLAG.  ALSO,  FOR  NOW,  JUST  USE   VALUE   FROM   DRIFT
C             INFORMATION ALONE.
C
      IQUAL = 1
      IF( CHIPRT .LT. 0.1 ) IQUAL = 2
C
C             FOR EACH 'MISSING' CHAMBER ADD 10 TO QUALITY FLAG.
C             ADD 100 TO QUALITY FLAG IF 'MISSING' CHAMBER IN LAST LAYER
C             EXPECTED TO HAVE A HIT.
C
      IQUAL = IQUAL +  10*INEFF
      IF( INFLAG .NE. 0 ) IQUAL = IQUAL + 100
      IMUR(IPMU+6)  = IQUAL
C
C             STORE  CHI-SQUARED  PROBABILTY  FROM  DRIFT   INFORMATION
C             ALONE, FOR NOW.
C
      AMUR(IPMU+11) = CHIPRT
C
C             THE IF STATMENT ABOVE SELECTS  A  'GOOD'  MUON.  SO  MUON
C             PROBABILITY IS 1,  EVEN  IF  THERE  IS  AN  INEFFICIENCY,
C             UNLESS THE INEFFICIENCY IS IN THE LAST LAYER INTERCEPTED.
C
      PMUON = 1.0
      IF(IQUAL.GT.100) PMUON = CHINEF
      AMUR(IPMU+25) = PMUON
C
C             (* SET SAFE ACCEPTANCE FLAG *)
C
 8889 IMUR(IPMU+5) = MUSAFE(DCZ,180.0*ATAN2(DCY,DCX)/3.14159)
C
C             FILL REST OF RESULTS BANK.
C
      AMUR(IPMU+12) = D0
      AMUR(IPMU+13) = GM0
      AMUR(IPMU+14) = DE0
      AMUR(IPMU+15) = AB0
      AMUR(IPMU+16) = E0
      AMUR(IPMU+17) = D
      AMUR(IPMU+18) = GM
      AMUR(IPMU+19) = DE
      AMUR(IPMU+20) = AB
      AMUR(IPMU+21) = PPIDK0
      AMUR(IPMU+22) = PPIPE0
      PPUN = 0.0
      IF(P.GT.5.) PPUN = 0.01
C
      AMUR(IPMU+23) = PPUN
      AMUR(IPMU+24) = PKDK0
      AMUR(IPMU+26) = PPIPE0 + PPUN + PPIDK0
      IF(NGLAYR.LT.4) GO TO 8892
C
      AMUR(IPMU+30) = PPIPE9 + PPUN + PPIDK9
      AMUR(IPMU+31) = PKPEN9 + PPUN + PKDK9
      AMUR(IPMU+32) = PPPEN9 + PPUN
      AMUR(IPMU+33) = PPBPE9 + PPUN
      IF(NGLAYR.GE.6) GO TO 8893
C
      AMUR(IPMU+34) = AMUR(IPMU+30)
      AMUR(IPMU+35) = AMUR(IPMU+31)
      AMUR(IPMU+36) = AMUR(IPMU+32)
      AMUR(IPMU+37) = AMUR(IPMU+33)
      GO TO 8892
 8893 CONTINUE
      AMUR(IPMU+34) = PPIPE8 + PPUN + PPIDK8
      AMUR(IPMU+35) = PKPEN8 + PPUN + PKDK8
      AMUR(IPMU+36) = PPPEN8 + PPUN
      AMUR(IPMU+37) = PPBPE8 + PPUN
 8892 CONTINUE
C
C             CALL GENERAL PURPOSE ROUTINE FOR EACH 'GOOD' MUON  TRACK.
C
      IGOOD = IMUR(IPMU+6)
      IF(IGOOD.GT.0 .AND. IGOOD.LT.1000)
     +  CALL MUFFLZ (HC,NHITS,NWHIT,HLUN,IMUR,AMUR,NWMUR,HTC,HAMB,NTPH)
C
C-----------------------------------------------------------------------
C
C             END OF MAIN LOOP.                       ***** END LOOP 1.
 1001 CONTINUE
      IPMU = IPMU + NWMUR
      IPT  = IPT  + NWTRK
      IPL  = IPL  + 3 * NPL
 1000 CONTINUE
C
C-----------------------------------------------------------------------
C                  E N D   O F  MAIN LOOP OVER INNER DETECTOR TRACKS.
C-----------------------------------------------------------------------
C
      RETURN
C
C-----------------------------------------------------------------------
C
C             PROCEDURE FOR PRINTING RESULTS OF MUREGY.
C++++
C200  CONTINUE
C     WRITE(6,203)NCEPTS
C203  FORMAT('0',I5,' INTERCEPTS FOUND IN MUREGY.',
C    *T43,'   REGION    RDOTD       X         Y         Z')
C     IF(NCEPTS.LE.0)GO TO 204
C     DO 201 I=1,NCEPTS
C     WRITE(6,202)IREG(I),RDOTD(I),(CINT(J,I),J=1,3)
C202  FORMAT(I50,4F10.4)
C201  CONTINUE
C204  CONTINUE
C     GO TO LABEL2,(3339,4465,8887)
C++++
C
      END
C
C-----------------------------------------------------------------------
C             B L O C K   D A T A
C-----------------------------------------------------------------------
C
      BLOCK DATA BL8            ! PMF 01/07/99 add name
C
#include "cmuffl.for"
C
C             SOME CONSTANTS ARE NOW SET IN MUANAF (YEAR DEPENDENT)
C             J.H. 21/04/1988
C
      DATA XYSTEP/10./
C
C             XYSTEP IS STEP LENGTH OF INITIAL EXTRAPOLATION UP TO COIL
C             OR END-CAP WITH MORE OR LESS FIXED LENGTH  IN  X-Y  PLANE
C             (MM). (STPINI IS THE ACTUAL INITIAL STEP LENGTH).
C
      DATA RCOILI/968./,RCOILO/1045./
C             RCOILI/O ARE INNER/OUTER RADII OF COIL (MM).
C
      DATA PGMID/'MUFF'/
C             PGMID IS PROGRAM IDENTIFIER.
C
      DATA WMU/.10566/,WMUSQ/.011164/
C             WMU,WMUSQ ARE MUON MASS (GEV) AND MASS-SQARED (GEV**2).
C
      DATA NSPECI/21/
C             NSPECI IS THE NUMBER OF SPECIAL  VARIBLES  ACTUALLY  USED
C             (SEE CMUFWORK).
C
      DATA XPBAR,XPROT,XPION,XKAON/100.,40.,25.,20./
C
C             THESE ARE NOMINAL CROSS-SECTIONS OF PARTICLES ON HYDROGEN
C             AT 1 GEV USED FOR SCALING INTERACTION LENGTH. (NOT  USED,
C             ACTUALLY - SEE MUFFLS).
C
C
C             THE FOLLOWING ARE
C                   R-- = RADIUS (MM),
C                   Z--  = Z COORDINATE,
C                   T--  = THICKNESS (MM),
C                   GM-- = THICKNESS (GM CM**-2),
C                   AB-- = THICKNESS (ABSORPTION LENGTHS, USING DATA
C                            BOOKLET, I.E. FOR PROTONS. SCALE FOR OTHER
C                            PARTICLES.)
C                   RD-- = THICKNESS (RADIATION LENGTHS),
C                   DE-- = ENERGY LOSS FOR MIN. IONISING PARTICLE (GEV).
C
C             BEAM PIPE AND BEAM PIPE COUNTERS (4 MM ALUMINIUM).
C             (ALUMINIUM HAS A DENSITY = 2.7 GM CM**-3,
C                    ABSORPTION LENGTH = 37.2 CM,
C                     RADIATION LENGTH = 8.9 CM,
C                         (-DE/DX) MIN = 4.37 MEV CM**-1).
      DATA TBP,GMBP,ABBP,RDBP,DEBP/4.,1.08,.011,.045,1.7E-3/
C
C             JET CHAMBER INNER PIPE (SEE JADE NOTE 17).
      DATA TJETI,GMJETI,ABJETI,RDJETI,DEJETI/0.,1.89,.019,.079,3.06E-3/
C
C             JET CHAMBER SUPPORT 1 (SEE JADE NOTE 17).
C             (SUPPORTS ASSUMED TO HAVE AN ABSORPTION LENGTH =  100  GM
C             CM**-2, (-DE/DX)MIN = 1.6 MEV GM**-1 CM**2).
C
      DATA TJET1,GMJET1,ABJET1,RDJET1,DEJET1/0.,.208,.002,.006,.33E-3/
C
C             JET CHAMBER SUPPORTS 2 AND 3 (SEE JADE NOTE 17).
      DATA TJET2,GMJET2,ABJET2,RDJET2,DEJET2/0.,.33,.003,.01,.53E-3/
C
C             JET CHAMBER SUPPORT 4 (SEE JADE NOTE 17).
      DATA TJET4,GMJET4,ABJET4,RDJET4,DEJET4/0.,.258,.003,.008,.41E-3/
C
C             JET CHAMBER OUTER WALL (SEE JADE NOTE 17).
      DATA TJETO,GMJETO,ABJETO,RDJETO,DEJETO/12.,3.42,.032,.135,5.24E-3/
C
C             COIL. ASSUMED TO BE...
C               3 MM EPOXY (MYLAR?),
C               20 MM WATER (THIS IS 2 20 MM DIAM. PIPES AVERAGED OUT),
C               57 MM ALUMINIUM.
      DATA TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL/77.,18.2,.181,.76,30.E-3/
C
C             JET CHAMBER END WALLS (JADE  NOTE  17  SAYS  'SIMILAR  TO
C             COIL', I.E. AS ABOVE, BUT I QUERY THIS).
C
      DATA ZJETE/1350./
      DATA TJETE,GMJETE,ABJETE,RDJETE,DEJETE/130.,28.2,.281,1.18,46.E-3/
C
C             TOKYO END-CAP LEAD-GLASS.  (SF5)
C                       DENSITY = 4.08 GM CM**-3  ) ( BASED ON TOKYO
C             ABSORPTION LENGTH = 318.4 MM        ) ( DATA INTERPRETED
C              RADIATION LENGTH = 22.39 MM        ) ( BY J. ALLISON.
C                   (-DE/DX)MIN = 5.708 MEV/CM    ) (
C
      DATA ZEPLG/1510./
      DATA TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG/226.,92.21,.71,10.09,.129/
C
C             (BARREL) LEAD-GLASS.
C             RLG IS INNER RADIUS OF BARREL LG.
C             ZLG IS Z COORDINATE OF END OF BARREL.
C
      DATA RLG,ZLG/1100.,1602.25/
      DATA TLG,GMLG,ABLG,RDLG,DELG/300.,122.4,.942,13.4,.171/
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C                 HUGH MCCANN  02/12/83 :
C                 -----------------------
C
C             CHANGES TO BARREL LEAD GLASS AT WINTER '82-'83 SHUTDOWN
C             REQUIRE THE FOLLOWING PARAMETERS ( SEE CODE ) :
C                    FOR THE HALF RINGS AT -X+Z  AND +X-Z  :
      DATA ZLGHAF,TLGHAF/1708.,250./
C                    FOR THE NEW LEAD GLASS RINGS (SF6) IN THE CENTRE
C                    OF THE BARREL :
C                              DENSITY =   5.20   GM/CC ; ( S.YAMADA)
C                    ABSORPTION LENGTH = 271.0   MM     ;
C                    RADIATION  LENGTH =  15.34  MM     ; ( S.YAMADA)
C                    (- DE/DX ) (MIN.) =   8.24  MEV/CM .
C            NOTE :  THE ABOVE NOS. WERE FOUND BY USING THE MUON
C                    MONTE-CARLO ROUTINE 'MUMAT', WHEREAS THE 'OLD'
C                    NOS. WERE COMPUTED BY A DIFFERENT PROCEDURE.
C                    IN PARTICULAR , THE 'NEW' DEDX WAS CALCULATED
C                    FOR  BETA = 0.98 .
      DATA GMLGC,ABLGC,RDLGC,DELGC/156.0,1.108,19.56,0.247/
      DATA ZLGC/319./
C       ABOVE NO. WAS PROVIDED BY T.KOBAYASHI  .
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C             MAGNET END-CAP.
C
      DATA ZEP/1755./
      DATA TEP,GMEP,ABEP,RDEP,DEEP/340.,267.,1.99,19.32,.394/
C
C             TEP,ETC., ARE (AVERAGE) FOR END-CAP (MM). (ASSUME IT  HAS
C             UNIFORM THICKNESS, AVERAGED TO SOMETHING LESS  THAN  REAL
C             THICKNESS TO TAKE  INTO  ACCOUNT  LEAD-GLASS  LIGHT-GUIDE
C             HOLES. FURTHER ASSUME DENSITY, ETC. OF IRON.)
C
C             GMG(3),ABG(3),RDG(3),DEG(3) ARE 'GENERAL' QUANTITIES  PER
C             MILLIMETRE FOR 1)CHAMBERS, 2)CONCRETE, 3)IRON.
C
      DATA GMG/0.05,0.536,0.787/
      DATA ABG/0.0005,0.00438,0.0058/
      DATA RDG/0.001,0.0368,0.0568/
      DATA DEG/0.07E-3,0.91E-3,1.16E-3/
C
C             SPECIFY NOMINAL CHAMBER RESOLUTION (IN S.D.
C             REST IS RESOLUTION IN TRANSVERSE (DRIFT) DIRECTION.
C             REST1 IS FOR BARREL FACES , REST2 IS FOR ENDWALLS.
C
C             RESTMX IS RESOLUTION IN TRANSVERSE DIRECTION FOR THE CASE
C             WHEN THE TRANSVERSE (DRIFT) COORDINATE IS  BAD.  THIS  IS
C             SET TO DRIFT DISTANCE =  150  MM,  RATHER  THAN  (CHAMBER
C             WIDTH), SINCE BOTH AMBIGUITIES ARE TRIED. FOR ASSOCIATION
C             OF HITS , IT IS ADDED LINEARLY TO THE SQUARE ROOT OF  THE
C             SUM OF THE SQUARES OF THE VARIANCES DUE TO  MULT  SCAT  &
C             PATREC FIT ERRORS. HOWEVER , FOR CALCULATION OF  CHI**2 ,
C             IT SHOULD BE ADDED QUADRATICALLY WITH THE OTHERS -- BUT ,
C             FOR  PRESENT,  BAD  HITS  ARE   NOT   USED   FOR   CHI**2
C             CALCULATION.
C
C             RESL IS RESOLUTION IN LONGITUDINAL (WIRE) DIRECTION.
C             RESLMX  IS  SIMILAR  TO  RESTMX,  I.E.  FOR   CASE   WHEN
C             LONGITUDINAL COORD. IS BAD. SET TO CHAMBER LENGTH.
C
      DATA REST1,REST2,RESTMX,RESL,RESLMX/ 5.,10.,150.,150.,5000./
C
C             FACTOR IS THE NO. OF STANDARD DEVIATIONS USED FOR HIT CUT
C
      DATA  FACTOR / 2.0 /
C
C             OVLCUT IS THE DIFFERENCE IN  DRIFT  DEVIATIONS  WHICH  IS
C             TOLERATED(MM) FOR HITS TO BE CONSIDERED AS OVERLAP  HITS.
C
      DATA  OVLCUT / 15.0 /
C
C             PMXFLG IS THE MAX MOMENTUM VALUE USED IN TRACKING.
C             NORMALLY IT IS A FLAG SET TO ZERO ==> USE BEAM ENERGY
C
      DATA  PMXFLG / 0.0 /
C
C             NALLWM IS THE NUMBER OF ALLOWED MISSING HITS = 1
C
      DATA  NALLWM / 1 /
C
      END

C   14/12/81 112141615  MEMBER NAME  LGECOR   (SOURCE)      FORTRAN
C   10/12/81 112101827  MEMBER NAME  LGECORN  (SOURCE)      FORTRAN
C   18/02/80 009080557  MEMBER NAME  LGECOR   (SOURCE)      FORTRAN
      SUBROUTINE LGECOR(ADATA,DEP,IFLAG)
C
C  THIS PROGRAM CALCULATE THE INCIDENT ENERGY
C  FROM THE MEASURED ENERGY.
C
C      05/3/1979     HIROSHI TAKEDA
C      LAST MODIFICATION   22/09/79
C      LAST MODIFICATION   04/10/79 Y.WATANABE
C      LAST MODIFICATION   09/02/80 H.TAKEDA(TYPED BY Y.WATANABE)
C         IMPLEMENTED ON 21/2/80 18:00
C      LAST MODIFICATION   08/09/80 Y.W. LGPOSC FOR BARREL.
C      LAST MODIFICATION   14/12/81 H.T. ENGLOS FOR END-CAP.
C      LAST MODIFICATION   14/12/81 H.T. THICKNESS FOR BARREL MATERIALS
C  ADATA : DATA BUFFER OF THE FOLLOWING PARAMETERS.
C
C    IDATA(1)   0   BARREL
C                    -1   BOTTOM END CAP
C                    +1   TOP    END CAP
C    ADATA(2)   CLUSTER ENERGY IN GEV
C    ADATA(3)   SIGMA(ENERGY)
C    ADATA(4)   WEIGHTED AVERAGE PHI        BARREL
C                                       X        END CAP
C    ADATA(5)   WEIGHTED AVERAGE  Z         BARREL
C                                       Y        END CAP
C    ADATA(6)   SIGMA PHI (WEIGHTED)        BARREL
C                            X                   END CAP
C    ADATA(7)   SIGMA  Z (WEIGHTED)         BARREL
C                            Y                   END CAP
C    IDATA(8)   NUMBER OF CORRESPONDING INNER TRACKS
C    ADATA(9--11) DIRECTION COSIGNS CORRECTED FOR SHOWER DEPTH
C
C  DEP  :  SHOWER DEPTH IN MM
C  IFLAG   0    NORMAL RETURN
C          1    ITERATION OVERFLOW
C          2    HIT OUTSIDE END-CAP
C          3    TOO MUCH ENERGY LOSS
C          4    OTHER ILLEGAL RETURNS
C
      DIMENSION ADATA(11)
      COMMON /CLGDMS/  X0,RADIUS(6),RADSX0(6),
     1  THX0(4),ZEND(2),ZENDX0(2),
     2  ZWID(2),ZGAP(2),PHWID(2),
     3  ZECAP(4),ZECAPX(4),THECPX(2),
     4  ECXLST(24),ECYLST(24)
C
C  THECPX(1)   THICKNESS OF END CAP COUNTER IN MM
C        (2)                                   X0
C  RADIUS(1,2) DISTANCE TO THE COIL SURFACE (INNER AND OUTER)
C        (3,4) DISTANCE TO THE LEAD GLASS SURFACE (TYPE A)
C  ZEND(1)     END POINT OF BARREL PART COUNTERS  (-)
C      (2)                                        (+)
C  ZGAP(1)     COUNTER GAP OF BARREL PART IN MM
C  THX0(1)     MAGNET COIL THICKNESS IN X0
C              X0 = 8.9 CM FOR ALUMINUM
C
      EQUIVALENCE (PHI,XCO),(ZCO,YCO),(IBE,BE)
      DATA ETHRE/0.01/,PAI2/6.283185/
C
C  INITIAL SET UP
C
      BE   =ADATA(1)
      ENERGY=ADATA(2)
      COSX  =ADATA(9)
      COSY  =ADATA(10)
      COSZ  =ADATA(11)
      PHI   =ADATA(4)
      ZCO   =ADATA(5)
C     WRITE(6,900) BE,ENERGY,COSX,COSY,COSZ,PHI,ZCO,DEP
C900  FORMAT(10F10.3)
      IFLAG=0
C
      IF(IBE.EQ.0) GO TO 1
CCCCCCCCCCCCCCCCCCCCC
C
C  END CAP COUNTERS
C
CCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF THE LIGHT GUIDE
C
      R=(THECPX(1)-DEP)/COSZ
      R=ABS(R)
      XX=XCO+R*COSX
      YY=YCO+R*COSY
C
      THETA=ARCOS(COSZ)
      THETA=ABS(THETA)*57.2958
      IF(IBE.EQ.-1) THETA=180.0-THETA
C     WRITE(6,900) R,XX,YY,THETA
C
C   ITERATION FOR INCIDENT ENERGY
C
      ETEMP1=ENERGY
      ITERA=1
      JTERA=1
C
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
      X=XX/X0
      Y=YY/X0
      CALL LGNMEC(X,Y,ID)
C
C   CHECK IF HIT IS INSIDE THE COUNTER
C
C
      IF(ID.GT.0) GO TO 60
      X=XCO/X0
      Y=YCO/X0
      CALL LGNMEC(X,Y,ID)
C
      IF(ID.GT.0) GO TO 60
      IFLAG=2
      RETURN
C
   60 MB=(ID-1)/24 +1
      ID=MOD(ID-1,24)+1
      U=ECXLST(ID)
      V=ECYLST(ID)
      GO TO (4,5,6,7),MB
    4 X=U
      Y=V
      GO TO 8
    5 X=-V
      Y=U
      GO TO 8
    6 X=-U
      Y=-V
      GO TO 8
    7 X=V
      Y=-U
    8 R=0.1*SQRT((X-XX)*(X-XX)+(Y-YY)*(Y-YY))
      DDR=SQRT(XX*XX+YY*YY)-SQRT(X*X+Y*Y)
      IF(ABS(R).GT.1.E-10) DDR=0.1*DDR/R
C
C     ENERGY LOSS
C
      THICK=1.17*8.9/ABS(COSZ)
   10 CALL ENGLOS(ETEMP1,THICK,DELTAE,&80)
      ETEMP3=ETEMP1-DELTAE
      IF(ETEMP3.GT.0.) GO TO 32
      ETEMP1=ETEMP1+ETHRE
      GO TO 10
C
C     POS DEP
C
   32 CALL POSEND(ETEMP3,R,DDR,FAC,&80)
C
      ETEMP2=ENERGY/FAC+DELTAE
      EDIF=ABS(ETEMP2-ETEMP1)
      IF(EDIF.LE.ETHRE) GO TO 9
      ITERA=ITERA+1
      IF(ITERA.GE.10) GO TO 40
      ETEMP1=ETEMP2
      GO TO 10
C
   40 ITERA=1
      ETEMP1=0.5*(ETEMP1+ETEMP2)
      JTERA=JTERA+1
      IF(JTERA.LT.5) GO TO 10
      IFLAG=1
      RETURN
C
    9 ADATA(2)=ETEMP2
C      WRITE(6,940) ITERA,JTERA,ETEMP1,FAC,X,Y,R,DDR
C940   FORMAT(2I4,10F10.3)
      RETURN
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  BARREL PART COUNTERS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF LIGHT GUIDE
C
    1 R=RADIUS(3)+DEP
      COSPHI=COS(PHI)
      SINPHI=SIN(PHI)
C       X Y POSITION AT THE SHOWER MEDIAN.
      X=R*COSPHI
      Y=R*SINPHI
C
C     DISTANCE FROM THE SHOWER MAX POINT TO THE EXTRAPOLATED POINT
C           AT THE END FACE OF LEAD GLASS
      A=COSX*COSX+COSY*COSY
      B=X*COSX+Y*COSY
      C=X*X+Y*Y-RADIUS(4)*RADIUS(4)
      RDIF=(SQRT(B*B-A*C)-B)/A
C      X Y Z POSITION AT THE END FACE OF LG
      X=X+RDIF*COSX
      Y=Y+RDIF*COSY
CCC   Z=ZCO+RDIF*COSZ
C     WRITE(6,900) COSPHI,SINPHI,X,Y,Z,A,B,C,RDIF
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
CCC   Z=Z-ZEND(1)+0.5*ZGAP(1)
CCC   PERIOD=ZWID(1)+ZGAP(1)
CCC   IZ=Z/PERIOD+1
CCC   IF(IZ.LE.1) IZ=2
CCC   IF(IZ.GE.32) IZ=31
CCC   Z=Z-PERIOD*(IZ-0.5)
C
      THETA=ATAN2(Y,X)
      IF(THETA.LT.0.) THETA=THETA+PAI2
      STEP=PAI2/84.
      ITH=THETA/STEP
CCC   THETA=(THETA-(ITH+0.5)*STEP)*RADIUS(4)
C
CCC   R=0.1*SQRT(Z*Z+THETA*THETA)
CCCCCCC    CCC ARE NEEDED ONLY FOR POSITION CORRECTION.....
C
C       INCIDENT ANGLE
      ANGNOR=(ITH+0.5)*STEP
      COSNOR=COS(ANGNOR)
      SINNOR=SIN(ANGNOR)
      THETA=COSNOR*COSX+SINNOR*COSY
C     ABSORBER THICKNESS TRAVERSED BY THE PARTICLE.
C     D=7.88/ABS(THETA)    <--- OLD VERSION
      D=0.97*8.9/ABS(THETA)
      THETA=ARCOS(THETA)*57.2958
C     WRITE(6,910) ITH,ANGNOR,COSNOR,SINNOR,THETA,D
C910  FORMAT(I4,10F12.4)
      IF(D.LT.50.) GO TO 70
      IFLAG=3
      RETURN
C
C     ITERATION
70    ITERA=1
      JTERA=1
      ETEMP1=ENERGY
C
C        ENERGY LOSS IN THE COIL
C
21    CALL ENGLOS(ETEMP1,D,DELTAE,&80)
      ETEMP3=ETEMP1-DELTAE
      IF(ETEMP3.GT.0.) GO TO 22
      ETEMP1=ETEMP1+ETHRE
      GO TO 21
C
C       ANGLE DEPENDENCE
C
22    CALL ANGBAR(ETEMP3,THETA,AFAC,&80)
C
C     CALL POSBAR(ETEMP3,R,THETA,PFAC,&80)
C
CCC   FAC=PFAC*AFAC
      ETEMP2=ENERGY/AFAC+DELTAE
      EDIF=ABS(ETEMP2-ETEMP1)
      IF(EDIF.LE.ETHRE) GO TO 20
      ITERA=ITERA+1
      IF(ITERA.GE.10) GO TO 50
      ETEMP1=ETEMP2
      GO TO 21
C
   50 ITERA=1
      ETEMP1=0.5*(ETEMP1+ETEMP2)
      JTERA=JTERA+1
      IF(JTERA.LT.5) GO TO 21
      IFLAG=1
      RETURN
C
   20 ADATA(2)=ETEMP2
      CALL LGPOSC(ADATA,DEP)
C      BARREL POS. CORRECTION
C     WRITE(6,920) ITERA,JTERA,ETEMP1,AFAC,DELTAE
C920  FORMAT(2I5,10F12.4)
      RETURN
C
C     ILLEGAL RETURN
C
   80 ADATA(2)=ENERGY
      RETURN
C************************************
      ENTRY LGECR0(NVR)
C
C  VERSION NUMBER (DATE)   81 12 14
C
      DATA IVR/811214/
      NVR=IVR
      RETURN
      END

C   07/06/96 606071850  MEMBER NAME  IBLN     (S4)          FORTG1
      FUNCTION IBLN(NAME)
C     BOS SUBPROGRAM =0.3=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAME),NPRIM)+NAMAX1
   10 K=LFDI
      LFDI=IW(K+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 10
      IF(LFDI.NE.0) GOTO 90
      IF(NCI.GE.NAMAX) CALL BDMPA(1)
      NCI=NCI+1
      LFDI=NCI
      IW(INAMV+LFDI)=NAME
      IW(K+IPLST)=LFDI
   90 IBLN=LFDI
  100 RETURN
      END

C   01/02/84 805261724  MEMBER NAME  MUANAF   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUANAF
C-----------------------------------------------------------------------
C
C LAST CHANGE 17.30 24/05/88 J. HAGEMANN - SETUP OF YEAR DEP. CONSTANTS
C      CHANGE 18.30 20/05/88 J. HAGEMANN - SETUP OF YEAR DEP. CONSTANTS
C      CHANGE  9.45 21/04/88 J. HAGEMANN - SETUP OF YEAR DEP. CONSTANTS
C      CHANGE 15.25 20/03/86 CHRIS BOWDERY - MOVE NREGS TEST TO LATER ON
C      CHANGE 16.00  9/03/84 CHRIS BOWDERY - CHECK THAT NREGS > 0
C      CHANGE 14.00 26/01/84 TIM GREENSHAW - MU BANKS LOC. WITH CLOC.
C                      VARIABLE JBANK INTRO. TO IMPROVE ERROR OUTPUT.
C      CHANGE 15.30 18/01/84 TIM GREENSHAW - ERROR PRINTOUT ALTERED
C      CHANGE 15.00 30/05/83 HUGH MCCANN - IF EBGEV = 0. , SET IT TO 50.
C                                          ..... FOR COSMIC RUNS.
C      CHANGE 10.00 24/05/82 HUGH MCCANN - TRIVIAL SPELLING MISTAKE.
C                                          EBGEV NOW CHECKED FOR > 50  .
C      CHANGE 23.00 22/02/82 HUGH MCCANN - FOR IMPROVED ERROR OUTPUT.
C      CHANGE 12.00 04/02/82 HUGH MCCANN -- TO MAKE NTPH=4.
C
C-----------------------------------------------------------------------
C
C THIS ROUTINE FOLLOWS INNER DETECTOR TRACKS TO FIND ASSOCIATED MUON
C   CHAMBER HITS AND STORES RESULTS IN 'MUR2' BANKS 0 - 6.
C NOTE THAT IF NO INNER DETECTOR TRACKS ARE PRESENT ONLY BANK 0 IS
C   CREATED.
C
C NOTE ALSO THAT BANK 0 IS CREATED WHETHER OR NOT ANY MUON HITS EXIST.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C COMMONS.
C
#include "cmubcs.for"
#include "cmureg.for"
#include "cmucalib.for"
#include "cmufwork.for"
#include "cmustat.for"
#include "cmuffl.for"
C
      COMMON / CMUIEV / IEV,NEV,IRD,KRUN,KREC,
     *                  ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON / CMUPTC / XEXTRP,YEXTRP,ZEXTRP,VTZCV,LCOVAR,SIGFXY,SIGFCZ
C
C-----------------------------------------------------------------------
C
C DATA INITIALISATION STATEMENTS.
C
      DATA NWMUR/38/
C NWMUR IS NUMBER OF WORDS PER INNER DETECTOR TRACK IN 'MUR2' BANK 1.
      DATA NTPH/4/
C NTPH IS NUMBER OF TRACKS PER HIT ALLOCATED IN 'MUR2' BANKS 2 AND 3.
      DATA NPL/5/
C NPL IS NUMBER OF POINTS PER EXTRAPOLATED INNER DET. TRACK IN BANK 4.
      DATA IYEARO / -1111 /
C
      LOGICAL FIRST / .TRUE. /
      IF( .NOT. FIRST ) GO TO 4711
        FIRST = .FALSE.
        WRITE(6,9101)
 9101   FORMAT(' +++ MUANAF SPECIAL VERSION OF 24/05/88...')
 4711 CONTINUE
C IYEARO IS YEAR OF LAST EVENT
C
C-----------------------------------------------------------------------
C
C FIND MAGNETIC FIELD FROM HEADER.
      IP=IDATA(IBLN('HEAD'))
      BGAUSS=HDATA(2*IP+30)
C FIND BEAM ENERGY - IN GEV!!!!!!
      EBGEV=EBEAM(HDATA(2*IP+10))/1000.
C  COSMIC RUNS HAVE ZERO BEAM ENERGY .  SET EBGEV TO 50. IN THAT CASE.
      IF(EBGEV.EQ.0.)EBGEV=50.
C
C  TEST THAT BEAM ENERGY IS BETWEEN 1.0 AND 50.0 GEV .
      IEBGEV=INT(EBGEV)
      IF(EBGEV.LT.1..OR.EBGEV.GT.50.)
     *CALL MUERRY('MUANAF',IEBGEV,' = BEAM ENERGY !!^')
      NTRKS=0
C
C  SETUP OF YEAR DEPENDENT CONSTANTS (DETECTOR STATUS 79-83, 84-86)
C
      IF( IYEAR .EQ. IYEARO ) GOTO 1
C                            SETTINGS FOR MONTE CARLO
         IYEARO = IYEAR
C                                           THE ACTUAL VALUES FOR MC:
C        SIGFCZ = 1.11+-0.04    FOR IYEAR<86
C        SIGFCZ = 1.26+-0.05    FOR IYEAR=86
C                                           BUT USE 1 FOR CLARITY
         SIGFXY = 1.0
         SIGFCZ = 1.0
         REST1  = 3.7
         REST2  =  6.5
         IF( KRUN .LE. 100 ) GOTO 101
C                            SIGFAC FOR DATA 79-84
            SIGFXY = 1.43
            SIGFCZ = 1.57
C                            CHAMBER RESOLUTION FOR DATA BEFORE 1984
            REST1  = 3.0
            REST2  = 6.0
 101     IF( IYEAR .GT. 1983 ) GOTO 102
C                            DETECTOR STATUS BEFORE 1984
            GMBP = 1.77
            ABBP = 0.0176
            RDBP = 0.0741
            DEBP = 2.86E-3
C
            GMJETO = 4.99
            ABJETO = 0.0497
            RDJETO = 0.2076
            DEJETO = 8.08E-3
C
            GOTO 1
 102     CONTINUE
C                            DETECTOR STATUS AFTER 1983
            GMBP = 1.39
            ABBP = 0.0139
            RDBP = 0.0580
            DEBP = 2.25E-3
C
            GMJETO = 6.49
            ABJETO = 0.0646
            RDJETO = 0.2701
            DEJETO = 10.5E-3
C
            IF( KRUN .LE. 100 ) GOTO 1
C                            CHAMBER RESOLUTION FOR DATA 1985
               REST1  = 7.5
               REST2  = 11.5
C                            SIGFAC FOR DATA OF 1985
               SIGFCZ = 1.31
               IF( IYEAR .NE. 1986) GOTO 1
C                            CHAMBER RESOLUTION FOR DATA OF 1986
                  REST1  = 6.7
                  REST2  = 9.5
C                            SIGFAC FOR DATA OF 1986
                  SIGFXY = 1.56
                  SIGFCZ = 1.40
C
C
C-----------------------------------------------------------------------
C
C FIND 'PATR' POINTER.
C
 1    CONTINUE
      IPPATR=IDATA(IBLN('PATR'))
      IF(IPPATR.LE.0)GO TO 3
      NTRKS=IDATA(IPPATR+2)
      NWTRK=IDATA(IPPATR+3)
      ISTART=IDATA(IPPATR+1)+1
C
C-----------------------------------------------------------------------
C
C FIND MUON COORDINATE BANK.
C
 2    CONTINUE
C
C   BANK NUMBERS OF MUR1 BANKS IN JBANK, OF MUR2 BANKS IN IBANK.
C
      JBANK=0
      CALL CLOC(IMUR10,'MUR1',JBANK)
C
C IF MUR1 DOES NOT EXIST ( IN PRINCIPLE NOT POSSIBLE, IF MUANAC IS USED)
C THEN GOT TO 3.
C
      IF(IMUR10.LE.0)GO TO 3
C

C PICK UP NO. OF HITS.
C
      NHITS=IDATA(IMUR10+1)
C
C PICK UP NO. OF WORDS PER HIT.
C
      NWHIT=IDATA(IMUR10+3)
C
C PICK UP COORDINATE BANK, 'MUR1' BANK 1.
C
      JBANK=1
      CALL CLOC(IMUR11,'MUR1',JBANK)
C
C  NO MUR1/1 BANK FOR THIS EVENT IMPLIES THAT MU-FILTER WAS NOT
C  OPERATIONAL, OR SIGNAL-COORDINATE CONVERSION HAS NOT BEEN DONE .
C  OR MAYBE MUON TRACKING WAS NOT DONE IF THIS IS MONTE CARLO.
C  BUT WANT TO MAKE MUR2/0 ANYWAY.
C
      IF(IMUR11.LE.0)GO TO 3
C
C PICK UP HIT STATUS BANK, 'MUR1' BANK 2.
C
      JBANK=2
      CALL CLOC(IMUR12,'MUR1',JBANK)
C
C-----------------------------------------------------------------------
C
C CREATE 'MUR2' RESULTS BANKS.
C
 3    CONTINUE
C
C ADD 'MUR2' TO SPECIAL LIST READY FOR WRITING.
C
      CALL BSAW(1,'MUR2')
      IBANK=0
      CALL CCRE(IMUR20,'MUR2',IBANK,4,IER)
      IF(IER.NE.0)GO TO 96
      IDATA(IMUR20+1) = NTRKS
      IDATA(IMUR20+2) = NWMUR
      IDATA(IMUR20+3) = NTPH
      IDATA(IMUR20+4) = NPL
C
      IF( NREGS .LE. 0 ) GO TO 94
C
      IF(IPPATR.LE.0)GO TO 98
C
      IF(IMUR10.LE.0)GO TO 97
C
      IF(IMUR11.LE.0.OR.IMUR12.LE.0)GO TO 975
C
      IF(NTRKS.LE.0)GO TO 99
C
C MAIN RESULTS BANK.
C
      IBANK=1
      CALL CCRE(IMUR21,'MUR2',IBANK,NTRKS*NWMUR,IER)
      IF(IER.NE.0)GO TO 96
C
C HIT-TRACK CORRELATION BANK.
C
      IBANK=2
      CALL CCRE(IMUR22,'MUR2',IBANK,(NTPH*NHITS+1)/2,IER)
      IF(IER.NE.0)GO TO 96
C
C HIT-TRACK AMBIGUITY BANK.
C
      IBANK=3
      CALL CCRE(IMUR23,'MUR2',IBANK,(NTPH*NHITS+1)/2,IER)
      IF(IER.NE.0)GO TO 96
C
C EXTRAPOLATED TRACK POINTS BANK.
C
      IBANK=4
      CALL CCRE(IMUR24,'MUR2',IBANK,3*NPL*NTRKS,IER)
      IF(IER.NE.0)GO TO 96
C
C-----------------------------------------------------------------------
C
C TRY IT. (HERE FOLLOWS THE INTRODUCTION TO MUFFLE FOR REFERENCE.)
C     SUBROUTINE MUFFLE(IPATR,APATR,NTRKS,NWTRK,
C    * BGAUSS,
C    * HC,NHITS,NWHIT,
C    * HLUN,
C    * IMUR,AMUR,NWMUR,
C    * HTC,HAMB,NTPH,
C    * EXTRA,NPL,EBEAM)
C
C     IMPLICIT INTEGER*2 (H)
C
C     DIMENSION IPATR(1),APATR(1),
C    * HC(1),
C    * HLUN(1),
C    * IMUR(1),AMUR(1),
C    * HTC(1),HAMB(1),
C    * EXTRA(1)
C
C-----------------------------------------------------------------------
C
C IPATR,APATR IS PATT. REC. DATA (SEE JADE COMP. NOTE 12, 23/2/79.)
C NTRKS IS NUMBER OF TRACKS.
C NWTRK IS NUMBER OF WORDS PER TRACK.
C BGAUSS IS MAGNETIC FIELD IN GAUSS.
C HC CONTAINS MUON HIT COORDINATES.
C NHITS IS THE NUMBER OF MUON HITS.
C NWHIT IS NUMBER OF WORDS PER HIT IN HIT COORDINATE ARRAY.
C HLUN IS HIT STATUS ARRAY.
C IMUR,AMUR IS MU-RESULTS 'MUR2' BANK 1 - FILLED BY MUFFLE.
C NWMUR IS NUMBER OF WORDS PER INNER DTECTOR TRACK IN 'MUR2' BANK 1.
C HTC IS HIT-TRACK CORELLATION ARRAY - FILLED BY MUFFLE.
C HAMB IS AMBIGUITY FLAG FOR EACH ENTRY IN HTC.
C NTPH IS NUMBER OF TRACKS PER HIT ALLOCATED IN HTC.
C EXTRA STORES THE POINTS ON THE EXTRAPOLATED TRACK.
C NPL IS THE NUMBER OF POINTS PER EXTRAPOLATED TRACK.
C EBEAM IS THE BEAM ENERGY IN GEV.
C
      CALL MUFFLE(IDATA(IPPATR+ISTART),IDATA(IPPATR+ISTART),
     * NTRKS,NWTRK,
     * BGAUSS,
     * IDATA(IMUR11+1),NHITS,NWHIT,
     * IDATA(IMUR12+1),
     * IDATA(IMUR21+1),IDATA(IMUR21+1),NWMUR,
     * IDATA(IMUR22+1),IDATA(IMUR23+1),NTPH,
     * IDATA(IMUR24+1),NPL,EBGEV)
C
C-----------------------------------------------------------------------
C
C NOW ADD BANK 5, THE MULTIPLE SCATTERING ELIPSES.
C
      IBANK=5
      CALL CCRE(IMUR25,'MUR2',IBANK,NELIPS,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(ELIPSE,IDATA(IMUR25+1),NELIPS)
C
C-----------------------------------------------------------------------
C
C NOW ADD BANK 6, THE BAD CHAMBER LIST.
C
      NBADCH=0
      DO 6 I=1,NCHAMS
      IF(HMCSTA(I).EQ.0)GO TO 6
      NBADCH=NBADCH+1
      HBADCH(NBADCH)=I
 6    CONTINUE
      IF(MOD(NBADCH,2).NE.0)HBADCH(NBADCH+1)=0
      IBANK=6
      NBADC2=(NBADCH+1)/2
      CALL CCRE(IMUR26,'MUR2',IBANK,NBADC2,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(HBADCH,IDATA(IMUR26+1),NBADC2)
C
C-----------------------------------------------------------------------
C
      GO TO 99
C
C-----------------------------------------------------------------------
C
C ERROR CONDITIONS.
C
 94   CALL MUERRY('MUANAF',0,'MU ANALYSIS ABORTED - NO MU REGIONS FOUND.
     + NO CALIBRATION?^')
      GO TO 99
C
 95   CALL MUERRY('MUANAF',IBANK,' = I, NOT ENOUGH SPACE FOR ''MUR2/I''.
     +^')
      GO TO 99
C
 96   IF(IER.GT.1)GO TO 95
      CALL MUERRY('MUANAF',IBANK,' = I, ''MUR2/I'' ALREADY PRESENT.^')
      GO TO 99
C
 97   NMU(10)=NMU(10)+1
      CALL MUERRY('MUANAF',JBANK,' = I, ''MUR1/I'' NOT LOCATED. HAS MUAN
     +AC BEEN CALLED?^')
      GO TO 99
C
 975  IF (NHITS .LE. 0) GO TO 99
      NMU(4) = NMU(4) + 1
      CALL MUERRY('MUANAF',JBANK,' = I, ''MUR1/I'' EXPECTED BUT MISSING,
     + SERIOUS ERROR.^')
      GO TO 99
C
 98   CALL MUERRY('MUANAF',0,'''PATR'' NOT LOCATED.^')
      NTRKS=0
      GO TO 3
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
      RETURN
      END

      SUBROUTINE ZRFITO(INDEX,IARG1,X0,Y0,Z0)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cjdrch.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(HPZR0 ,HPWRK(20)),(HPZR9 ,HPWRK(21)),(HLDZR ,HPWRK(22))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
      DIMENSION HST(200),IPTRZ(40,2),JPTRBK(40)
      DIMENSION SUMF(40,5),JTRZF(40),SLTRZ(40)
      EQUIVALENCE (ZWZ,IZW)
 2005 FORMAT(' ZRFITO(PST): TRACK',I6,I3,' NOT ACCEPTED')
      DATA LBINIT /0/
      IF(
     - LBINIT.EQ.0
     -)THEN
        LBINIT = 1
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
      ENDIF
16000 CONTINUE
      IF(
     - INDEX.LT.0
     -)THEN
        HPZR0 = IARG1
        HPZR9 = IARG1 - 1
        HLDZR = 3
        NTRZ  = 0
      GOTO 16001
      ENDIF
      IF(
     - INDEX.EQ.0
     -)THEN
        IPZR = HPZR9
        NHIT3 = 0
      DO 13000 IP=HPCO0,HPCO9,HLDCO
          IF(IWRK(IP+10).GT.1) IWRK(IP+7) = 16
      IF(
     - IWRK(IP+7).LT.8
     -)THEN
            IWRK(IPZR+1) = 0
            WRK (IPZR+2) = WRK(IP+6)
            WRK (IPZR+3) = WRK(IP+5)
             NHIT3 = NHIT3 + 1
            IPZR  = IPZR + HLDZR
      ENDIF
13000 CONTINUE
13001 CONTINUE
      IF(
     - NHIT3.GE.8
     -)THEN
          NTRZ = NTRZ + 1
          IPTRZ(NTRZ,1) = HPZR9 + 1
          IPTRZ(NTRZ,2) = IPZR
          JPTRBK(NTRZ)  = IARG1
          HPZR9 = IPZR
      ELSE
          IPTR1 = IARG1
      PRINT 2005,IPTR1, IDATA(IPTR1+1)
          INDEX =-2
      ENDIF
      GOTO 16001
      ENDIF
      IF(
     - INDEX.GT.0
     -)THEN
      IF(
     - NTRZ.LE.0
     -)THEN
      GOTO 16001
      ENDIF
        IZW = IARG1
        ZVTX0 = ZWZ
        ITRZ = 0
15000 CONTINUE
      IF(
     - ITRZ.LT.NTRZ
     -)THEN
        ITRZ = ITRZ + 1
          IP0 = IPTRZ(ITRZ,1)
          IP9 = IPTRZ(ITRZ,2)
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      GOTO 15000
      ENDIF
15001 CONTINUE
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ASSIGN 17006 TO IZZZ02
      GOTO 17002
17006 CONTINUE
      ASSIGN 17008 TO IZZZ04
      GOTO 17007
17008 CONTINUE
      GOTO 16001
      ENDIF
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16000
16001 CONTINUE
      RETURN
17000 CONTINUE
        CALL SETSL(HST(1),0,400,0)
        SL0   =-7.5
        BINSL = .075
        BINIV = 1. / BINSL
      DO 13002 IP1=IP0,IP9,3
          R1 = WRK(IP1+1)
          Z1 = WRK(IP1+2)
          SL = (Z1 - ZVTX0) / R1
          IBIN = (SL - SL0) * BINIV
          IF(IBIN.GT.0 .AND. IBIN.LT.200) HST(IBIN) = HST(IBIN) + 1
13002 CONTINUE
13003 CONTINUE
        IMAX = 1
        MHST = HST(1) + HST(2) + HST(3) + HST(4) + HST(5)
        NHST = MHST
      DO 13004 I= 2,196
          NHST = NHST + HST(I+4) - HST(I-1)
      IF(
     - NHST.GT.MHST
     -)THEN
            IMAX = I
            MHST = NHST
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - MHST.LT.5
     -)THEN
          SLP = 1000.
      ELSE
          ISL = HST(IMAX+1) + HST(IMAX+2)*2 + HST(IMAX+3)*3
     +        + HST(IMAX+4)*4
          SLP = (FLOAT(ISL) / MHST + IMAX + .5) * BINSL + SL0
      ENDIF
      DO 13006 IP1=IP0,IP9,3
          R1 = WRK(IP1+1)
          Z1 = WRK(IP1+2)
          F1 = R1*SLP + ZVTX0
          DF = F1 - Z1
      IF(
     - ABS(DF).LT.80.
     -)THEN
            IWRK(IP1) = 0
      ELSE
            IWRK(IP1) = 16
      ENDIF
13006 CONTINUE
13007 CONTINUE
      GOTO IZZZ01
17002 CONTINUE
        ITRZ = 0
        MTRZ = 0
        SUM0 = 0.
        SUM4 = 0.
15002 CONTINUE
      IF(
     - ITRZ.LT.NTRZ
     -)THEN
        ITRZ = ITRZ + 1
          IP0 = IPTRZ(ITRZ,1)
          IP9 = IPTRZ(ITRZ,2)
          S1 = 0.
          S2 = 0.
          S3 = 0.
          S4 = 0.
          S5 = 0.
      DO 13008 IP1=IP0,IP9,3
      IF(
     - IWRK(IP1).EQ.0
     -)THEN
              R1 = WRK(IP1+1)
              Z1 = WRK(IP1+2)
              S1 = 1.    + S1
              S2 = R1    + S2
              S3 = R1*R1 + S3
              S4 = Z1    + S4
              S5 = Z1*R1 + S5
      ENDIF
13008 CONTINUE
13009 CONTINUE
      IF(
     - S1.LT.7.5
     -)THEN
            JTRZF(ITRZ) = 0
      ELSE
            MTRZ = MTRZ + 1
            JTRZF(ITRZ) = MTRZ
            SUM0 = SUM0 + S1
            SUM4 = SUM4 + S4
            SUMF(MTRZ,1) = S1
            SUMF(MTRZ,2) = S2
            SUMF(MTRZ,3) = S3
            SUMF(MTRZ,4) = S4
            SUMF(MTRZ,5) = S5
      ENDIF
      GOTO 15002
      ENDIF
15003 CONTINUE
      IF(
     - MTRZ.GT.0
     -)THEN
          S0 = 0.
          S4 = 0.
      DO 13010 I=1,MTRZ
            S0 = SUMF(I,2)**2 / SUMF(I,3)        + S0
            S4 = SUMF(I,5)*SUMF(I,2) / SUMF(I,3) + S4
13010 CONTINUE
13011 CONTINUE
          S0 = SUM0 - S0
          S4 = SUM4 - S4
          ZVFIT = S4 / S0
      DO 13012 I=1,MTRZ
            SLTRZ(I) = (-SUMF(I,2)*ZVFIT + SUMF(I,5)) / SUMF(I,3)
13012 CONTINUE
13013 CONTINUE
      ENDIF
      GOTO IZZZ02
17004 CONTINUE
        ITRZ = 0
15004 CONTINUE
      IF(
     - ITRZ.LT.NTRZ
     -)THEN
        ITRZ = ITRZ + 1
          JTRZ = JTRZF(ITRZ)
      IF(
     - JTRZ.GT.0
     -)THEN
            SLP  = SLTRZ(JTRZ)
            IP0 = IPTRZ(ITRZ,1)
            IP9 = IPTRZ(ITRZ,2)
      DO 13014 IP1=IP0,IP9,3
              R1 = WRK(IP1+1)
              Z1 = WRK(IP1+2)
              F1 = R1*SLP + ZVFIT
              DF = F1 - Z1
      IF(
     - ABS(DF).LT.80.
     -)THEN
                IWRK(IP1) = 0
      ELSE
                IWRK(IP1) = 16
      ENDIF
13014 CONTINUE
13015 CONTINUE
      ENDIF
      GOTO 15004
      ENDIF
15005 CONTINUE
      GOTO IZZZ03
17007 CONTINUE
        ITRZ = 0
15006 CONTINUE
      IF(
     - ITRZ.LT.NTRZ
     -)THEN
        ITRZ = ITRZ + 1
          JTRZ = JTRZF(ITRZ)
      IF(
     - JTRZ.LE.0
     -)THEN
            IPTR1 = JPTRBK(ITRZ)
            TGTH = ADATA(IPTR1+30)
            Z0TR = ADATA(IPTR1+31)
            CSTH = 1./SQRT(TGTH**2+1.)
            SNTH = CSTH * TGTH
            ADATA(IPTR1+ 8) = ADATA(IPTR1+ 8) * CSTH
            ADATA(IPTR1+ 9) = ADATA(IPTR1+ 9) * CSTH
            ADATA(IPTR1+15) = ADATA(IPTR1+15) * CSTH
            ADATA(IPTR1+16) = ADATA(IPTR1+16) * CSTH
            ADATA(IPTR1+17) = SNTH
            ADATA(IPTR1+ 7) = ADATA(IPTR1+ 7) * TGTH + Z0TR
            ADATA(IPTR1+14) = ADATA(IPTR1+14) * TGTH + Z0TR
      ELSE
            SLP  = SLTRZ(JTRZ)
            IPTR1 = JPTRBK(ITRZ)
            IP0 = IPTRZ(ITRZ,1)
            IP9 = IPTRZ(ITRZ,2)
            S1 = 0.
      DO 13016 IP1=IP0,IP9,3
              R1 = WRK(IP1+1)
              Z1 = WRK(IP1+2)
              F1 = R1*SLP + ZVFIT
              DF = F1 - Z1
              IF(IWRK(IP1).EQ.0) S1 = DF**2 + S1
              WRK(IP1) = DF
13016 CONTINUE
13017 CONTINUE
            MHT = SUMF(JTRZ,1)
            SIG = SQRT(S1 / (MHT-1))
            CSTH = 1./SQRT(SLP**2+1.)
            SNTH = CSTH * SLP
            RVTX = ADATA(IPTR1+17)
            ADATA(IPTR1+ 7) = ADATA(IPTR1+ 7)*SLP + ZVFIT
            ADATA(IPTR1+14) = ADATA(IPTR1+14)*SLP + ZVFIT
            ADATA(IPTR1+ 8) = ADATA(IPTR1+ 8)*CSTH
            ADATA(IPTR1+ 9) = ADATA(IPTR1+ 9)*CSTH
            ADATA(IPTR1+10) = SNTH
            ADATA(IPTR1+15) = ADATA(IPTR1+15)*CSTH
            ADATA(IPTR1+16) = ADATA(IPTR1+16)*CSTH
            ADATA(IPTR1+17) = SNTH
            IDATA(IPTR1+29) = 1
            ADATA(IPTR1+30) = SLP
            ADATA(IPTR1+31) = RVTX*SLP + ZVFIT
            ADATA(IPTR1+32) = SIG
            IDATA(IPTR1+33) = MHT
            IDATA(IPTR1+ 2) = LOR(IDATA(IPTR1+ 2),64)
            IDATA(IPTR1+ 4) = LOR(IDATA(IPTR1+ 4),64)
      ENDIF
      GOTO 15006
      ENDIF
15007 CONTINUE
      GOTO IZZZ04
      END

C   07/06/78 402092120  MEMBER NAME  JMULSC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JMULSC( P, XRAD )
C-----------------------------------------------------------------------
C
C   AUTHOR:   W. BARTEL   01/06/78 :  CALCULATE MULTIPLE SCATTERING
C
C   LAST MOD  J. HAGEMANN 30/01/84 :  NEW FORMULA USED. GENERAL TIDY-UP
C
C-----------------------------------------------------------------------
C
C       CALCULATE MULTIPLE SCATTERING.
C       TOTAL ANGLE IS RANDOMLY GENERATED.
C
C       P             MOMENTUM VECTOR OF INCIDENT PARTICLE
C                     THIS VECTOR IS OVERWRITTEN BY SCATTERED MOMENTUM.
C
C       P(1) ... P(3) MOMENTUM COMPONENTS
C       P(4)          ENERGY OF PARTICLE
C       P(5)          REST MASS
C       P(6)          TOTAL MOMENTUM
C
C       XRAD          THICKNESS OF RADIATOR IN RADIATION LENGTH
C
C-----------------------------------------------------------------------
C
      DIMENSION  P(6), X2(3), X3(3)
C
      DATA  PI / 3.14159 /
C
C-------------------  C O D E  -----------------------------------------
C
      IF( XRAD .LT. 1.E-30 ) RETURN
C
C                            CHANGE P TO UNIT VECTOR
C
      DO  100  I = 1,3
        P(I) = P(I) / P(6)
  100 CONTINUE
C
C                            FIND OTHER UNIT VECTORS THAT ARE
C                            PERPENDICULAR.
C
      CTH = P(3)
      IF( ABS(CTH) .LT. 1.E-30 ) GO TO 1
      STH = SQRT( 1.0 - CTH * CTH )
      IF( STH .LT. 1.E-30 ) GO TO 2
C
      SPHI  =  P(2) / STH
      CPHI  =  P(1) / STH
C
      X2(1) =  SPHI
      X2(2) = -CPHI
      X2(3) =  0.0
C
      X3(1) =  CPHI * CTH
      X3(2) =  SPHI * CTH
      X3(3) = -STH
      GO TO 3
C
    1 X2(1) =  P(2)
      X2(2) = -P(1)
      X2(3) =  0.0
C
      X3(1) =  0.0
      X3(2) =  0.0
      X3(3) = -1.0
      GO TO 3
C
    2 X2(1) =  0.0
      X2(2) = -1.0
      X2(3) =  0.0
C
      X3(1) =  1.0
      X3(2) =  0.0
      X3(3) =  0.0
C
C                            FIND SCATTERING ANGLE
C
C                            THE OLD FORMULA WAS:
C
C              THSTR = 21.E-3 / P(6) * P(4) / P(6) * SQRT(XRAD)
C
C                            THE NEW FORMULA IS:
C
    3 THSTR = 20.E-3 / P(6)*P(4) / P(6) *SQRT(XRAD)*(1.+ALOG10(XRAD)/9.)
      CALL NVERT( THSTR, 0., TH1 )
C
      PHI    = 2.0 * PI * RN(D)
      COSPHI = COS( PHI )
      SINPHI = SIN( PHI )
      PABS   = 0.0
C
      DO  4  I = 1,3
        P(I) = P(I) + TH1 * COSPHI * X2(I) + TH1 * SINPHI * X3(I)
        PABS = PABS + P(I)**2
    4 CONTINUE
C
      PABS = SQRT(PABS)
C
C                            P IS CHANGED TO ACTUAL SIZE P(6).
C
      DO  5  I = 1,3
        P(I) = P(I) / PABS * P(6)
    5 CONTINUE
      RETURN
      END

C   19/03/79 C9032101   MEMBER NAME  HPRS     (JADEMUS1)    FORTRAN
C   12/03/79 C9031301   MEMBER NAME  HPRS     (S)           FORTRAN
C   05/03/79 C9030501   MEMBER NAME  HPRINT   (S)           FORTRAN
      SUBROUTINE HPRS(NAME,NUMBER)
C PRINTS BOS BANK NAME,NUMBER IN I*2 FORMAT.
      IMPLICIT INTEGER*2 (H)
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1)
      EQUIVALENCE (HDATA(1),IDATA(1))
      CALL CLOC(INDEX,NAME,NUMBER)
      IF(INDEX.LE.0)GO TO 99
      WRITE(6,100)
 100  FORMAT('0 HALF-WORD',8X,'NAME',10X,'NR',9X,'PTR',10X,'NW',
     * 8X,'INDX')
      NWORDS=IDATA(INDEX)
      WRITE(6,101)NAME,NUMBER,IDATA(INDEX-1),NWORDS,INDEX
 101  FORMAT(A23,4I12)
      IF(NWORDS.LE.0)GO TO 99
      IP2=2*INDEX
      NWORD2=2*NWORDS
      I1=1
 1    CONTINUE
      I2=MIN0(I1+19,NWORD2)
      I3=MOD(I2,1000)
      WRITE(6,102)I1,I3,(HDATA(IP2+I),I=I1,I2)
 102  FORMAT(I6,' -',I3,20I6)
      I1=I1+20
      IF(I2.LT.NWORD2)GO TO 1
 99   CONTINUE
      RETURN
      END

C   05/06/84 504242304  MEMBER NAME  JADARG   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JADARG( CARG, NCHAR, NUM, ARG )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   5/06/84 :  EXTRACT ARGUMENT FROM CARG STRING
C
C  LAST MOD:  C. BOWDERY  24/04/85 :  CORRECTION IF BAD ARGUMENT GIVEN
C
C     CARG IS A STRING CONTAINING NUMBERS AND OPTIONALLY '+-.' OF
C     LENGTH NCHAR. NUM IS THE ARGUMENT NUMBER FOR ERROR PRINTING
C     PURPOSES AND ARG IS DERIVED VALUE.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  HADONE
C
      LOGICAL*1  CARG(NCHAR), CHARS(15), CBLANK
C
      DATA  CBLANK / ' ' /
C
C------------------  C O D E  ------------------------------------------
C
C
C                            COPY INPUT STRING TO LOCAL STRING CHARS
C
      DO  1  I = 1,NCHAR
        CHARS(I) = CARG(I)
   1  CONTINUE
      NCHARS = NCHAR
C
   2  NDIG   =  0
      NBP    = -1
      N      =  0
      SIGN   =  1.0
      HADONE = .FALSE.
C                                                CONVERT CHAR TO NUMBER
      DO  6  I = 1,NCHARS
        MVAL = NUMFUN( CHARS(I) )
        IF( MVAL .LT. 0 ) GO TO 99
C                                                PLUS SIGN?
        IF( MVAL .NE. 10 ) GO TO 3
          IF( I .NE. 1 ) GO TO 99
          GO TO 6
C                                                MINUS SIGN?
   3    IF( MVAL .NE. 11 ) GO TO 4
          IF( I .NE. 1 ) GO TO 99
          SIGN = -1.0
          GO TO 6
C                                                POINT? ALREADY HAD ONE?
   4    IF( MVAL .NE. 12 ) GO TO 5
          IF( HADONE ) GO TO 99
          HADONE = .TRUE.
          NBP    = 0
          GO TO 6
C
   5    N    = 10 * N + MVAL
        NDIG = NDIG + 1
        IF( NBP .GE. 0 ) NBP = NBP + 1
C
C                            DANGER OF OVERFLOW ?
C
        IF( N .LT. 2**26 ) GO TO 6
C
C                            YES. IF WE ARE PROCESSING FRACTION THEN
C                            JUST DROP LAST DIGITS. OTHERWISE ERROR.
C
          IF( HADONE ) GO TO 7
          GO TO 99
C
   6  CONTINUE
C
   7  IF( NDIG .EQ. 0 ) GO TO 99
      IF( NBP .EQ. -1 ) NBP = 0
      ARG = N * SIGN / (10.0 ** NBP)
C
      RETURN
C
C                            HANDLE ANY ERRORS.
C
 99   WRITE(6,98) NUM, (CHARS(L),L=1,NCHARS)
 98   FORMAT(' Error: Argument ',I1,' is bad ---> ',80A1)
      WRITE(6,94)
 94   FORMAT(' Please re-enter this value:')
      READ(5,97) CHARS
 97   FORMAT(15A1)
C
      NSTA = 0
      DO  66  I = 1,15
        IF( CHARS(I) .NE. CBLANK ) GO TO 64
          IF( NSTA .GT. 0 ) GO TO 65
          GO TO 66
 64     IF( NSTA .EQ. 0 ) NSTA = I
 66   CONTINUE
      I = 16
C
 65   NCHARS = I - NSTA
      IF( NSTA .EQ. 0 ) GO TO 69
      IF( NSTA .EQ. 1 ) GO TO 2
C
      DO  68  K = 1,NCHARS
        CHARS(K) = CHARS(K+NSTA-1)
 68   CONTINUE
      GO TO 2
C
 69   ARG = 0.0
      RETURN
C
      END

      SUBROUTINE FITEVF(MODE)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(HPZR0 ,HPWRK(20)),(HPZR9 ,HPWRK(21)),(HLDZR ,HPWRK(22))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
      DATA LBINIT /0/
      IF(
     - LBINIT.EQ.0
     -)THEN
        LBINIT = 1
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
      ENDIF
        IF(IDATA(IQPATR).LE.0) RETURN
      IF(
     - LAND(MODE,1) .NE. 0
     -)THEN
          IPPAT0 = IDATA(IQPATR)
          NBNK1  = IDATA(IPPAT0-2) - 1
          NWRD   = IDATA(IPPAT0)
          NBYTE  = NWRD*4
          CALL CCRE(IPPATR,'PATR',NBNK1,NWRD,IERR)
      IF(
     - IERR.NE.0
     -)THEN
 2900 FORMAT(' FITEVF(PS): CREATION OF NEW PATR-BANK RESULTED',
     ,       ' IN ERROR',I3)
            INDEX = 1
            RETURN
      ENDIF
          CALL MVCL(IDATA(IPPATR+1),0,IDATA(IPPAT0+1),0,NBYTE)
      ENDIF
      IPPATR = IDATA(IQPATR)
      IPTR1  = IDATA(IPPATR+1) + IPPATR
      LDTR   = IDATA(IPPATR+3)
      NTR    = IDATA(IPPATR+2)
      IPJHTL = IDATA(IQJHTL)
      IF(
     - NTR.GT.0
     -)THEN
      DO 13000 ITR=1,NTR
      IF(
     - ABS(ADATA(IPTR1+25)) .LT. .007
     -)THEN
            CALL REFIT(IPTR1,IPJHTL)
            IP    = HPTR0 - 1
      IF(
     - LAND(IWRK(IP+ 2),16).EQ.0
     -)THEN
              SIG   = 1000.
              SIG0  =    0.
      ELSE
              SIG   =  WRK(IP+23)
              SIG0  = ADATA(IPTR1+23)
              ANHT  = IWRK(IP+24)
              ANHT0 = IDATA(IPTR1+24)
              IF(ANHT/ANHT0.LT..8) SIG = SIG + .5
      ENDIF
      IF(
     - SIG0.GT.SIG .OR. SIG.LT..35
     -)THEN
              CALL MVC(IDATA(IPTR1+1),0,IWRK(HPTR0),0,112)
      ENDIF
      ENDIF
        IPTR1 = IPTR1 + LDTR
13000 CONTINUE
13001 CONTINUE
      ENDIF
      RETURN
      END

C   01/11/84 508081235  MEMBER NAME  PROJEC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PROJEC( LAST )
C-----------------------------------------------------------------------
C
C    AUTHOR:      ?            ?    :  DRAW PROJECTIONS AT SIDE
C
C       MOD:   J. OLSSON   17/12/83 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   C. BOWDERY  21/09/84 :  CMD 106 RECOGNISED NOW
C       MOD:   J. HAGEMANN 19/10/84 :  FOR VIEW VC
C  LAST MOD:   C. BOWDERY   7/08/85 :  BUGS REMOVED. GENERAL TIDY UP
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  LFLAG
      LOGICAL  FL18, FL22, FL24, DSPDTM
C
#include "cgraph.for"
C
      COMMON / CPROJ /XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24,KPROJ
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW
C
      DIMENSION  KVIEW1(30), KVIEW2(30)
C
C                            TABLES THAT GIVES PROJECTION VIEWS FOR THE
C                            CURRENT VIEW
C
      DATA  KVIEW1
     +    / 4,5,6,  1,2,3,3,   1,2,3,3, 0,0,4,0,0, 18,17,17,4, 10 * 0 /
      DATA  KVIEW2
     +    / 8,9,10, 8,9,10,11, 4,5,6,7, 0,0,8,0,0, 19,19,18,8, 10 * 0 /
C
C------------------  C O D E  ------------------------------------------
C
C                            PRO ONLY DONE FOR RA,RB,RC,
C                                              ZXA,ZXB,ZXC,ZXD,
C                                              ZYA,ZYB,ZYC,ZYD,
C                                              CYL,VRX,VRZX,VRZY,VC
C
C                            READ KVIEW1 TABLE TO FIND FIRST PROJECTION
C
      IF( LAST .GT. 30 ) RETURN
      JVIEW = KVIEW1( LAST )
C
      IF( JVIEW .EQ. 0 ) RETURN
C
C                            SET FLAG TO INDICATE PROJECTION DRAWING
C
      NACMD = ACMD
      FL18  = .TRUE.
C
C                            DEFINE WINDOW SIZE VARIABLES
C
      ISTX  = 3095
      IADD  = 1000
      ISTY  = 2250
C
      IF( JVIEW .NE. 5 ) GO TO 2
C
        ISTX  = 3195
        IADD  =  900
C
C                            EVENT DISPLAY UNLESS LAST COMMAND WAS
C                            RES, MUR2, VRES, MUPT OR MUONS
C
   2  LFLAG = .TRUE.
      IF( LSTCMD .EQ. 45  .OR.  LSTCMD .EQ. 55  .OR.  LSTCMD .EQ. 52
     +   .OR.  LSTCMD .EQ. 105  .OR. LSTCMD .EQ. 106 ) LFLAG = .FALSE.
C
C                            CDTL 40 ON? THEN DON'T DRAW BOTTOM PROJ.
C
      IF( DSPDTM(10) ) GO TO 30
C
C                            DEFINE THE DRAWING WINDOW IN SCREEN COORDS
C                            FOR THE FIRST PROJECTION (BOTTOM RIGHT)
C
        CALL TWINDO( ISTX, ISTX+IADD, 0, IADD )
C
C                            DRAW THE PROJECTION JVIEW
C
        CALL PROJVW( JVIEW, LFLAG )
C
C                            DEFINE THE DRAWING WINDOW IN SCREEN COORDS
C                            FOR THE SECOND PROJECTION (TOP RIGHT)
C
  30  CALL TWINDO( ISTX, ISTX+IADD, ISTY, ISTY+IADD )
C
C                            USE KVIEW2 TABLE TO FIND PROJECTION VIEW
C
      JVIEW = KVIEW2( LAST )
C
C                            DRAW THE PROJECTION JVIEW
C
      CALL PROJVW( JVIEW, LFLAG )
C
C                            RESET THE DRAWING WINDOW TO FULL SIZE
C
      CALL TWINDO (0,4095,0,4095)
      LASTVW = LAST
C
      K = LAST
      IF( ISTVW .EQ. 1 ) K = 0
      CALL SETSCL( K )
C
C                            NOW WE CAN DRAW IN THE AXES BY THE PROJS.
C
      IF( DSPDTM(10) ) GO TO 50
        KPROJ = 1
        IF( NACMD .NE. 99  .AND.  LFLAG ) CALL CROAX( KVIEW1(LAST) )
C
  50  KPROJ = 2
      IF( NACMD .NE. 99  .AND.  LFLAG ) CALL CROAX( KVIEW2(LAST) )
C
C
      FL18 = .FALSE.
      IF( .NOT. FL22  .OR.  ISTVW .EQ. 1 ) RETURN
      XMIN = XMINR
      XMAX = XMAXR
      YMIN = YMINR
      YMAX = YMAXR
      CALL DWINDO (XMIN,XMAX,YMIN,YMAX)
      RETURN
C
      END

C   29/06/79 704291023  MEMBER NAME  MOMENT   (JADEGS)      FORTRAN
      SUBROUTINE MOMENT(IP,PX,PY,PZ,PTRANS,PTOT,PHI,THE)
      IMPLICIT INTEGER*2 (H)
C---
C---     GIVEN:  POINTER TO TRACK BANK IP
C---     RETURN: THREE COMPONENTS OF THE MOMENTUM
C---          J.OLSSON  29.06.79        LAST CHANGE  29.04.87
C---
#include "cdata.for"
#include "cgraph.for"
      COMMON /CJTRIG/ PI,TWOPI
      DATA VELH /.2998E-4/
C----------------------------------------
      IPHEAD=IDATA(IBLN('HEAD'))
      IHHEAD=IPHEAD*2
      VELHB = ABS(VELH*.001*HDATA(IHHEAD+30))
C
      PZ = 0.
      PTRANS = 0.
      RAD = ADATA(IP+25)
      RAD = ABS(RAD)
      IF(RAD.LT.1.E-09) GO TO 7300
      PTRANS = VELHB/RAD
7300  CONTINUE
C  PLONG AND PTOT COMPUTED FROM STRAIGHT LINE FIT INVOLVING Z
C     IF(IDATA(IP+29).NE.1) GO TO 7301
C  Z-R FIT
C    NOTE: THE CORRECT FITTING IS ALWAYS A Z-S FIT, THE Z-R FIT IS ONLY
C    AN APPROXIMATION, VALID AT HIGH MOMENTA FOR TRACKS IN RADIAL FLIGHT
C    DIRECTION (I.E., NOT FOR V0 TRACKS!). TYPE 2 CORRESPONDS TO SPITZER
C    HELIX-FIT, 'THE' FROM THE PARAMETER P1 (DR/DZ OR DR/DS) IS THE SAME
C    (FORMALLY) AS IN THE OLD Z-R FIT CASE.
C
      THE = ATAN(ADATA(IP+30))
      PTOT = PTRANS/COS(THE)
      PZ = SQRT(PTOT*PTOT - PTRANS*PTRANS)
      IF(THE.LT.0.) PZ = - PZ
      THE = PI*.5 - THE
      GO TO 7302
C  Z-S  FIT  CODE STILL TO BE IMPLEMENTED, IF NEEDED AT ALL
C7301  IF(IDATA(IP+29).NE.2) GO TO 7302
C      PZ = VELHB*ADATA(IP + 30)
7302  THE = ACOS(ADATA(IP+10))
      PFIX = ADATA(IP+8)
      PFIY = ADATA(IP+9)
      IF(PFIX.NE.0..OR.PFIY.NE.0.) GO TO 3633
      WRITE(6,3367) HDATA(IHHEAD+10),HDATA(IHHEAD+11)
3367  FORMAT(' MOMENT ### WARNING ##  RUN EV.',2I8,' WITH 0,0 DIR.COSINE
     $S !!')
      PHI = 0.
      GO TO 3670
3633  PHI = ATAN2(ADATA(IP+9),ADATA(IP+8))
      IF(PHI.LT.0.) PHI = PHI + TWOPI
3670  PX = PTRANS * COS(PHI)
      PY = PTRANS * SIN(PHI)
      PTOT = SQRT(PTRANS*PTRANS + PZ*PZ + .00000000001)
C     IF(DSPDTL(30)) WRITE(JUSCRN,1234) IP,RAD,VELHB,PTRANS,PTOT,PX,PY,
C    $PZ,PHI,THE
C1234  FORMAT(' MOMENT ',I5,9E11.3)
      RETURN
      END

C   07/12/81 705272126  MEMBER NAME  INITAL   (S)           FORTRAN
      SUBROUTINE INITAL(INDEL)
C
C  SPECIAL VERSION FOR TEST WITH JBENELS
C
C     S.YAMADA   07-12-81    11:55
C
C COPIED FROM F22YAM.LG.S(INITOP) ON 16.1.1986
C
C   INITIALIZE SHOWER PROGRAM FOR SEVERAL MATERIALS IN JADE
C          AL-ABS, SCINTILLATOR AND Z-CH., SF5 AND SF6 LEAD GLASS
C
C
      COMMON /CMATTR/ IMATTR,IMTLIS(10),XCM(10)
C
      DIMENSION CPAL(1), AAL(1), ZAL(1)
C     DIMENSION CPSC(3), ASC(3), ZSC(3)
      DIMENSION CPLG5(5), ALG5(5), ZLG5(5)
      DIMENSION CPLG6(6), ALG6(6), ZLG6(6)
C---- PARAMETER OF AL
      DATA NAMEAL/'AL  '/, RHOAL/2.70/, NCMPAL/1/
      DATA ZAL/13.0/, AAL/26.98/, CPAL/100.0/
C
C---- PARAMETER OF SCINT   (NOT USED)
C
C     DATA NAMESC/'SCIN'/, RHOSC/1.032/, NCMPSC/2/
C     DATA ZSC/   6.0,  1.0/,
C    1     ASC/ 12.01,  1.01/,
C    2     CPSC/92.25,  7.75/
C
C---- PARAMETER OF SF5
C
      DATA NAMLG5/'SF5 '/, RHOLG5/4.08/, NCPLG5/5/
      DATA ZLG5/  82.0,  19.0,  14.0,  11.0,  8.0/,
     1     ALG5/207.19, 39.10, 28.09, 22.99, 16.00/,
     2     CPLG5/53.75,  3.49, 18.95,  1.56, 22.25/
C
C---- PARAMETER OF SF6
C
      DATA NAMLG6/'SF6 '/, RHOLG6/5.201/, NCPLG6/6/
      DATA ZLG6/82.0,   19.0,  14.0,  11.0,  8.0,   33.0/
      DATA ALG6/207.19, 39.10, 28.09, 22.99, 16.00, 74.92/
      DATA CPLG6/65.948, 0.822, 12.70, 0.371, 19.932, 0.227/
C
C---- MATERIAL INITILIZATION
        DO 4000 I=1,10
 4000   IMTLIS(I) = 0
C
C     AL-COIL
C
      IF(INDEL.NE.1) GO TO 4110
      IMATTR = 1
      CALL INTSHW(CPAL,NCMPAL,AAL,ZAL,RHOAL,X0AL)
      WRITE(6,6000) NAMEAL
 6000 FORMAT('0 SHOWER PARAMETERS ARE SET FOR ',A4,//)
      GO TO 4130
C
C     SCINTILLATOR
C
C     IMATTR = 2
C     CALL INTSHW(CPSC,NCMPSC,ASC,ZSC,RHOSC,X0SC)
C     WRITE(6,6000) NAMESC
C
C     SF5 LG-BLOCKS
C
4110  IF(INDEL.NE.2) GO TO 4120
      IMATTR = 2
      CALL INTSHW(CPLG5,NCPLG5,ALG5,ZLG5,RHOLG5,X0LG5)
      WRITE(6,6000) NAMLG5
      GO TO 4130
C
C     SF6 LG-BLOCKS
C
4120  IF(INDEL.NE.2) GO TO 4130
      IMATTR = 3
      CALL INTSHW(CPLG6,NCPLG6,ALG6,ZLG6,RHOLG6,X0LG6)
      WRITE(6,6000) NAMLG6
C
4130  CONTINUE
      RETURN
      END

C   26/03/80 003281033  MEMBER NAME  OC4TRC   (JADEGS)      FORTRAN
      SUBROUTINE OC4TRC
C
C     PRINTOUT OF RUN + EVENT # FOR FATAL ERROR OCCURRENCE
C     L.H. O'NEILL 26.03.80
C
      IMPLICIT INTEGER*2 (H)
C
#include "cheadr.for"
      LOGICAL*1 LBREAD
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG
      EQUIVALENCE (HHEADR(18),HRUN) , (HHEADR(19),HEV)
C
  100 FORMAT(' *** ERROR TRAP ***')
      WRITE(6,100)
      WRITE(6,100)
      WRITE(6,100)
      PRINT 2001, NRREAD,HRUN,HEV
 2001 FORMAT(' FATAL ERROR AT',I6,' TH EVENT. RUN, EVNT. NOS. = ',2I6)
      WRITE(6,100)
      WRITE(6,100)
      WRITE(6,100)
      CALL ERRTRA
      CALL ABEND
      STOP
      END

C   29/01/88 802041650  MEMBER NAME  TPSOEA   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPSOEA( IPOS, IERROR )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      29/01/88:  Set option error array
C
C
C
C     Routine to set up array of marker positions and error numbers
C     associated with illegal input options.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     IPOS      In       I*4      Position of error within input string
C     IERROR    In       I*4      Error number
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      INTEGER  NINREC, IERRM, NINR, NERRM, KPOS

      PARAMETER  ( NINR = 25, NERRM = 10 )

      COMMON / CTPIR2 / NINREC, KPOS, IERRM(NINR,NERRM,2)

C------------------  C O D E  ------------------------------------------

      IF( KPOS .LT. NERRM ) THEN
        KPOS   = KPOS + 1
        IERRM(NINREC,KPOS,1) = IPOS
        IERRM(NINREC,KPOS,2) = IERROR

        IF( KPOS .NE. NERRM ) THEN
          IERRM(NINREC,KPOS+1,1) = 0
        ENDIF
      ENDIF

      RETURN
      END

C   24/11/83 610291843  MEMBER NAME  RDDATE   (JADEGS)      FORTRAN
C
C----------------------------------------------------------------------
      SUBROUTINE RDDATE
C----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    13/05/82 :  SET SMEARING DATE
C
C        MOD  J. OLSSON   23/08/83 :  CHANGED THE DATE
C        MOD  C. BOWDERY  19/10/83 :  CHANGED THE DATE AGAIN
C        MOD  C. BOWDERY  22/11/83 :  FORCE SMEARING DATE FOR MU EVENTS
C        MOD  C. BOWDERY   8/02/84 :  CADMIN MACRO NOW ON PATRECSR
C        MOD          17.8.1986    J.OLSSON
C        MOD 29.10.1986    J.OLSSON   RESTRICT MISMATCH PRINT
C
C   ROUTINE CALLED IN RDTRIG.
C   THIS ROUTINE CAN BE USED TO OVERWRITE THE DATE
C   IN THE BANK 'HEAD' BEFORE DETECTOR STATUS OF INPUT
C   IS ASSUMED.
C
C   THE SMEARING DATE IS GIVEN IN COMMON /TODAY/. IT IS OVERRIDDEN BY
C   THE PRESENCE OF A MUEV BANK; THE DETECTOR STATUS IS THEN FIXED BY
C   THE TRACKING DATE OF THE MUON FILTER, STORED AT END OF HEAD BANK.
C
C   THE /TODAY/ DATE IS ALSO CHECKED FOR VALIDITY WITH RESPECT TO THE
C   STATUS OF THE VERTEX CHAMBER;  IF THE FLAG LVTXC IN
C   COMMON /CVCEX/ IS TRUE AND A SMEARING DATE BEFORE 1984 IS REQUESTED,
C   OR VICE VERSA, A WARNING IS PRINTED OUT.
C
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cadmin.for"
C
      COMMON /TODAY/ HDATE(6)
C
      LOGICAL  LVTXC
      COMMON / CVCEX  / LVTXC
C
      COMMON / BCS / IW(1)
C
      DIMENSION HW(1)
      EQUIVALENCE ( HW(1), IW(1) )
C
      DATA IERPRI /0/
C
C------------------  C O D E  -----------------------------------------
C
      NPHEAD = IW( IBLN('HEAD') )
      IF( NPHEAD .LE. 0 ) RETURN
C
C                            IS THIS A MUON MONTE CARLO EVENT,
C                            THAT IS, IS THERE A 'MUEV' BANK PRESENT?
C
      MUEV = IW( IBLN('MUEV') )
      IF( MUEV .LE. 0 ) GO TO 1
C
C                            YES, SO SET THE JETC SMEARING DATE TO BE
C                            THE SAME AS THE MUON TRACKING DATE
C                            AS RECORDED IN THE 'HEAD' BANK.
C
        HW(NPHEAD*2+6) = HW(NPHEAD*2+96)
        HW(NPHEAD*2+7) = HW(NPHEAD*2+97)
        HW(NPHEAD*2+8) = HW(NPHEAD*2+98)
C
        NFLAGS(1) = NFLAGS(1) + 1
        IF( NFLAGS(1) .GT.1) RETURN
        WRITE(6,3) (HW(NPHEAD*2+I),I=6,8)
   3    FORMAT(/' ****  MUON MONTE CARLO EVENT TYPE ENCOUNTERED.'/
     +          ' ****  RDDATE SET JETC SMEARING DATE TO ',3I8/
     +          ' ****  SO AS TO AGREE WITH THE MUON TRACKING DATE'/)
C
C CHECK VALIDITY OF THIS DATE, AS COMPARED WITH VTXC STATUS
C
        IF(IERPRI.GT.10) RETURN
C
        IF(LVTXC.AND.HW(NPHEAD*2+8).LT.1984) IERPRI = IERPRI + 1
        IF(LVTXC.AND.HW(NPHEAD*2+8).LT.1984) WRITE(6,33)
  33    FORMAT(/' # # #  MISMATCH:  DATA HAVE VERTEX CHAMBER GEOMETRY',
     + /,'        AND SMEARING DATE < 1984   # # # #')
C
        IF(.NOT.LVTXC.AND.HW(NPHEAD*2+8).GT.1984) IERPRI = IERPRI + 1
        IF(.NOT.LVTXC.AND.HW(NPHEAD*2+8).GT.1984) WRITE(6,34)
  34    FORMAT(/' # # # #  MISMATCH:  DATA HAVE NO VERTEX CHAMBER GEOMET
     +RY',/,'        AND SMEARING DATE > 1983   # # # #')
C
        RETURN
C
C                       NOT A MUON MC EVENT SO SET SMEARING DATE
C                       TO COMMON /TODAY/ VALUE. FIRST CHECK IF
C                       THERE IS AGREEMENT WITH VERTEX CHAMBER STATUS.
C
  1   CONTINUE
        IF(LVTXC.AND.HDATE(6).GE.1984) GO TO 5900
        IF(.NOT.LVTXC.AND.HDATE(6).LT.1984) GO TO 5900
C       IF(.NOT.LVTXC) HDATE(6) = 1982
C       IF(LVTXC) HDATE(6) = 1985
        NFLAGS(1) = NFLAGS(1) + 1
C       IF( NFLAGS(1) .GT.1) GO TO 5900
        IF(IERPRI.GT.10) GO TO 5900
C
        IF(.NOT.LVTXC) IERPRI = IERPRI + 1
        IF(.NOT.LVTXC) WRITE(6,34)
C
        IF(LVTXC) IERPRI = IERPRI + 1
        IF(LVTXC) WRITE(6,33)
C
C       WRITE(6,35) HDATE
C 35    FORMAT(/'  --->>  SMEARING DATE FORCED TO ',5I3,I5)
C
5900  CONTINUE
      HW(NPHEAD*2+6) = HDATE(4)
      HW(NPHEAD*2+7) = HDATE(5)
      HW(NPHEAD*2+8) = HDATE(6)
C
      IF(NFLAGS(1).EQ.1) WRITE(6,1022) HDATE(4),HDATE(5),HDATE(6)
1022  FORMAT(' RDDATE: SMEARING DATE IS ',I2,'/',I2,' - ',I4)
C
      RETURN
      END

C   01/11/84 807241321  MEMBER NAME  DRHATC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRHATC( IVIEW , NPNT, RADIN, RADOUT, ZDOWN, ZUP )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   09/10/84 :  HATCH SIMPLE SHAPES ON SCREEN
C
C LAST  MOD:   J. HAGEMANN   14/02/86 :  DRAW CHAMBER IN TRUE POSITION
C                                        RELATIVE TO THE ORIGIN
C     IVIEW = 1  :  R PHI VIEW
C     IVIEW = 2  :  RZ VIEWS
C     NPNT       :  NUMBER HATCH LINES
C     RADIN      :  INNER RADIUS OF FIGUR
C     RADOUT     :  OUTER RADIUS OF FIGUR
C     ZDOWN      :  LOWER Z-COORDINATE OF FIGUR
C     ZUP        :  UPPER Z-COORDINATE OF FIGUR
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C   23/03/97 703231941  MEMBER NAME  MVCCAL   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVCCAL         SAVED BY F22KLE  ON 87/02/09  AT 17:52
C   27/06/85 702091751  MEMBER NAME  MVCCAL   (S)           FORTRAN
C
C         THIS MACRO CONTAINS THE DECLARATION FOR THE
C         VTXC-CALIBRATION-COMMON / CVCCAL / :
C
C------------------------------------------------- 03.03.86 J.H. -------
C
      REAL*8 VCDATE
      COMMON / CVCCAL / NVFREE, VFREE(50), VCDATE,
     &      T0, VD, CSLOR, SNLOR, VROT, VDX, VZX, VDY, VZY,
     &      S0R(2,168), CVD(2,168),
     &      VIHCRR(7,2,25)
C
C     NVFREE  : NUMBER OF FREE REAL WORDS IN VFREE
C     VFREE   : REAL ARRAY FOR CONSTANTS
C     T0      : GLOBAL T0                              (. 0.1 NS .)
C     VD      : GLOBAL DRIFTVELOCITY                   (. MM/(0.1 NS) .)
C     CSLOR   : COS( LORENTZ-ANGLE )
C     SNLOR   : SIN( LORENTZ-ANGLE )
C     VROT    : ROTATION VTXC - ID                     (. RADIAN .)
C     VDX     : DISPLACEMENT VTXC - ID IN X            (. MM .)
C     VZX     : SLOPE OF " IN Z
C     VDY     : DISPLACEMENT VTXC - ID IN Y            (. MM .)
C     VZY     : SLOPE OF " IN Z
C     S0R     : DISPLACEMENT FOR EACH WIRE (#)         (. MM .)
C     CVD     : DRIFTVEL.-CORRECTURE FOR EACH WIRE (#)
C
C     VIHCRR  : LAYER-DEPENDENT CORRECTIONS FOR INHOMOGENITIES
C                                                      (. MM . )
C
C     VFREE(50) : D(VROT)/D(Z)                         (. RADIAN/MM .)
C
C     VFREE(48,49) JOBNAME OF JOB GENERATING THIS CALIBRATION
C
C     (#)     : FOR EACH DRIFTSPACESIDE
C
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CHEADR / HEAD(108)
      COMMON / CHATCH / IHAT
C
C-----------------  C O D E  -------------------------------------------
C
      GO TO ( 1 , 2 ) , IVIEW
C
C                            R PHI VIEW
C
    1 DLTRAD = RADOUT - RADIN
      XDEV = 0.0
      YDEV = 0.0
      IF( (HEAD(18) .LE. 100) .OR. (IHAT .EQ. 0) ) GO TO 3
         XDEV = VDX
         YDEV = VDY
    3 TANBET = TAN(PI*0.125)
      ALP    = 0.0
      DALP   = TWOPI/FLOAT(NPNT)
      DO 5  I = 1, NPNT
C
         ALP = ALP + DALP
         COSALP = COS(ALP)
         SINALP = SIN(ALP)
C
         XSTEP1 = RADIN*COSALP + XDEV
         YSTEP1 = RADIN*SINALP + YDEV
         XSTEP2 = RADOUT*COSALP + DLTRAD*TANBET*SINALP + XDEV
         YSTEP2 = RADOUT*SINALP - DLTRAD*TANBET*COSALP + YDEV
C
        CALL DRAMOV( -XSTEP1, YSTEP1, -XSTEP2, YSTEP2, 0 )
C
    5 CONTINUE
C
      RETURN
C
C                            RZ VIEWS
C
    2 DLTRAD = ABS(RADOUT - RADIN)
      TANBET = TAN(PI*0.125)
      MPNT   = NPNT
      ZSTPMN = ABS(ZUP - ZDOWN)/FLOAT(MPNT)
C
      ZSTEP1 = ZDOWN - 0.5*ZSTPMN
C
      DO 15  I = 1, NPNT
C
        ZSTEP1 = ZSTEP1 + ZSTPMN
        ZSTEP2 = ZSTEP1 + TANBET*DLTRAD
C
        CALL DRAMOV( ZSTEP1, RADOUT, ZSTEP2, RADIN, 0 )
C
   15 CONTINUE
C
      RETURN
      END

C   20/03/79 003112233  MEMBER NAME  LGAVDP   (LGSOURCE)    FORTRAN
      SUBROUTINE LGAVDP(ZAV,EMEV,JEG,DEP)
C
C     S.YAMADA  11-12-78  14:55
C     LAST MODIFICATION    29-02-80   13:25   (CHARGED PARTICL)
C
C----   AVERAGE DEPTH OF THE SHOWER IS CALCULATED BY ITERATION.
C     INPUT
C     ZAV = AVERAGE Z IN MM
C     EMEV = SHOWER ENERGY IN MEV(JEG=0,1)
C          = KINETIC ENERGY OF THE TRACK (JEG=2)
C     JEG  =0(GAMMA), 1(ELECTRO & POSITRON), 2(OTHER CHARGED PARTICLE)
C     OUTPUT
C     DEP = RADIAL AVERAGE DEPTH IN MM
C
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX
      COMMON /CLGMSB/ MSGVAL,AMSGV1,AMSGV2
      DATA DP0/150./
C
      ZAV2 = (ZAV-ZVRTX)**2
      IF(JEG-2) 1,10,10
C
C---- ELECTROMAGNETIC SHOWER
    1 DEPO = 0.
C
C---- AVERAGE SHOWER DEPTH ALONG THE AXIS = SM
      SM = SHMAX(EMEV,JEG)
C
      NTRY = 0
    4 NTRY = NTRY+1
      IF(NTRY.GT.20) GO TO 21
      DEP = SM/SQRT(1.0+ZAV2/(RADIUS(3)+DEPO)**2)
      IF(ABS(DEP-DEPO)/DEP.LE.0.01) GO TO 100
      DEPO = DEP
      GO TO 4
C
   21 MSGVAL = NTRY
      AMSGV1 = DEPO
      AMSGV2 = DEP
      CALL LGMESG( 10,1 )
      GO TO 100
C
C---- PENETRATING CHARGED TRACK
   10 DEP = DP0
      RANGE = EMEV/10.2*X0
      EFDEP = RANGE/SQRT(1.0+ZAV2/(RADIUS(3)+DEP)**2)
      IF( EFDEP.LT.DEP ) DEP = EFDEP
C
  100 RETURN
      END

C   21/11/78 C9012301   MEMBER NAME  ZBOS06   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------600000200
C     6.  DELETING BANKS AND GARGAGE COLLECTION
C
C
C     6.1  SINGLE BANKS
C
C
C               -- --
C     CALL BDLS(NA,NR)
C
C
C        WHERE NA = NAME
C              NR = NUMBER OF BANK TO BE DELETED
C
C     IF THE DELETED BANK IS THE LAST IN STORAGE, ITS SPACE IS
C     IMMEDIATELY FREE FOR NEW BANKS, OTHERWISE BGAR HAS TO BE CALLED
C
C
C     6.2  SETS OF BANKS
C
C     CALL BDLM                   CALL BDLG
C
C     ALL BANKS OF THE CURRENT LIST OF NAMES ARE DELETED. IN BDLG
C     IN ADDITION A GARBAGE COLLECTION IS DONE.
C     A DELETED BANK IS NO LONGER ACCESSIBLE BY A CALL BLOC. IF THE
C     DELETED BANKS ARE THE LAST BANKS IN STORAGE, THEIR SPACE
C     IS IMMEDIATELY FREE FOR NEW BANKS ALSO FOR BDLM. OTHERWISE
C     THERE HAS TO BE AN EXTRA CALL OF BGAR.
C
C
C     6.3  GARBAGE COLLECTION
C
C     IN A GARBAGE COLLECTION THE ACTIVE (NOT DELETED) BANKS ARE
C     SHIFTED IN STORAGE, IF THERE ARE BANKS DELETED.
C
C
C
C     CALL BGAR(IGA)
C               ---
C
C        IGA = 0 NO GARBAGE COLLECTION DONE (IF NO BANKS WERE DELETED)
C        IGA = 1 GARBAGE COLLECTION DONE
C
C     WARNING. BECAUSE IN A GARBAGE COLLECTION, SOME BANKS (ALL BANKS
C     BEHIND DELETED BANKS) ARE SHIFTED, THE INDICES OF THE BANKS
C     CHANGE. AUTOMATIC GARBAGE COLLECTIONS ARE DONE IN THE INPUT-
C     OUTPUT ROUTINES (SEE 9.)
C
C
C     6.4   CALL OF THE PREVIOUS VERSION
C
C                   --
C     CALL BGAC(IGA,NW)
C               ---
C
C        WHERE NW = NR.OF WORDS OF A NEW BANK
C     NO GARBAGE COLLECTION IS DONE, IF THERE IS SPACE ENOUGH
C     FOR AN ADDITIONAL BANK WITH NW WORDS
C
C
      RETURN
      END

C   07/06/96 606071840  MEMBER NAME  DADA     (S4)          FORTG1
      SUBROUTINE DADA(IGOTO,*)
C     BOS SUBPROGRAM   =4.5=
      COMMON/BCS/IW(1)
#include "ccs.for"
      NWL=LISTE(4)
      IF(IGOTO.EQ.3) GOTO 20
      IF(IGOTO.EQ.4) LW=INDC
C     GET/DELETE
      NPT=LISTE(3)
   10 CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.LT.1610) GOTO 101
      CALL RDDA(NPT,IW(IA),IW(IA+1))
      INDH=IA+4
      INDL=IA+IW(IA)
      GOTO 14
   12 IF(NPT.NE.LISTE(3)) GOTO 100
      INDH=INDH+IW(INDH)+4
   14 IF(INDH.GT.INDL) GOTO 100
      IF(IW(INDH-3).NE.LISTE(1)) GOTO 12
      IF(IW(INDH-2).NE.LISTE(2)) GOTO 12
      LL=INDH+IW(INDH)-IA
      GOTO (16,18,20,15),IGOTO
   16 NW=IW(INDH)
      CALL BSTR(INDC+IW(INDC),IW(INDH+1),NW)
      CALL BCHL(NW,*101)
      IF(IW(INDC).GE.LISTE(4)) GOTO 100
      NPT=NPT+1
      GOTO 10
   18 NRED=4+IW(INDH)
      NWL=NWL-IW(INDH)
      IS=INDH+IW(INDH)
      NS=INDL-IS
      IF(NS.GT.0) CALL UCOPY2(IW(IS+1),IW(INDH-3),NS)
      IW(IA)=IW(IA)-NRED
   19 CALL WRDA(NPT,IW(IA),IW(IA+1))
      IF(NWL.LE.0) GOTO 100
      NPT=NPT+1
      GOTO 10
   15 NWT=IW(INDH)
      CALL BSTR(INDH,IW(LW+1),NWT)
      LW=LW+NWT
      NWL=NWL-NWT
      GOTO 19
C
   20 NW=IW(INDC)
      LW=INDC
      NPT=IW(INDA+7)
      LISTE(3)=0
      LISTE(4)=NW
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.LT.1610) GOTO 101
      CALL RDDA(NPT,IW(IA),IW(IA+1))
   22 NTOT=IW(IA)
      IF(NTOT.GT.1605) GOTO 24
      CALL BSTR(IA+NTOT,IW(INDC-3),4)
      NTOT=NTOT+4
      IW(IA)=NTOT
      NWT=MIN0(1609-NTOT,NW)
      IW(IA+NTOT)=NWT
      CALL BSTR(IA+NTOT,IW(LW+1),NWT)
      IF(LISTE(3).EQ.0) LISTE(3)=NPT
      NTOT=NTOT+NWT
      IW(IA)=NTOT
      NW=NW-NWT
      LW=LW+NWT
      CALL WRDA(NPT,IW(IA),IW(IA+1))
      IF(NW.EQ.0) GOTO 100
   24 IW(INDA+7)=IW(INDA+7)+1
      IW(IA)=0
      NPT=IW(INDA+7)
      GOTO 22
C
  100 RETURN
  101 RETURN 1
      END

C   22/03/97 703221950  MEMBER NAME  JEOSUM1  (TAGG.S)      FORTRAN
C   22/03/97 703221949  MEMBER NAME  $INFO    (TAGG.S)      FORTRAN
   LIBRARY STARTED 03.10.83.   LATER CHANGES FOLLOW BELOW
     ROUTINES WERE ORIGINALLY COPIED FROM F22FIN.MAIN.S
 ***********************************************************
  COPIED AND CHANGED TAGAN,AFTP82,AFTP83
  FROM THE BIG MEMBER AFTP82 FOLLOWING SUBROUTINES WERE REMOVED
  INTO SINGLE MEMBERS: TPUNPA,QSQ,TAGDMP.  THEY ARE NOT CALLED
  FROM AFTP82 AND ARE NOT NEEDED IN STANDARD ANALYSIS
  FROM THE BIG MEMBER AFTP83 FOLLOWING SUBROUTINES WERE REMOVED
  INTO SINGLE MEMBERS: TAGDM3, PREV. TAGDMP. IT IS NOT CALLED
  FROM AFTP83 AND IS NOT NEEDED IN STANDARD ANALYSIS
  MEMBERS CALAD,COMFIL,PEDFIX,CALA3,COMFI3,PEDFX3 WERE TAKEN
  OUT OF AFTP82,83. THEY ARE NEEDED AS SEPARATE ROUTINES FOR
  ENERGY CALIBRATION IN GRAPHICS..      J.O.  5.10.83

  CHANGES MADE BY A.J.FINCH _ 20.3.84
    New versions of all routines installed and ,commons
  changed see members tagnote and #TAGDOC for details.

  Also following routines changed in graphics to use
  new versions - TAGCHK,FWDCHEV,BLNUMB .

  +MESSAGES TURNED OFF IN ALL ROUTINES CALLED IN
   GRAPHICS

  Also attempted to install Hennings routines in final
  form.(INCLUDING RENAMING GCLEAR -> GSCRUB)

  SLIGHT MODIFICATION TO FHTOS 21/3/84

  REMOVED HENNINGS ROUTINES FROM STANDARD PACKAGE
  AS IT TOOK TP JOB REGION OVER 1MBYTE
    WARNING MESSAGE IS ISSUED  22/3/84

  JCN 74 ISSUED 23/3/94
    ADDITIONAL DOCUMENTATION ON #TAGDOC


  24/3/84 DISCOVERED PEDFIX AHD BEEN LOADED WITH
       WRONG VERSION OF CWKTAG ,ALSO CORRECT
       VALUE FOR OVERFLOW CHECK INSERTED IN
       COMFIL - MESSAGES TURNED OFF FOR GRAPHICS

  14/05/84   J. NYE   Corrected  FHTOS to stop swapping of 38 and 40
                      for all runs !

  24/05/84   J. NYE   Changed TAGMRK to use smearing date for MC data
                      if no ATAG bank present.

  22/06/84   J. NYE   Changed all routines to comply with new common
                      CWORK  plus minor cosmetic changes. CWKTAG now
                      contains IFLMRK and has been restructured.

  23/06/84   C. B.    TAGCHK moved here as it's name has TAG in it.

  13/09/84   J. NYE   Changed TAGAN to print 'real' mark of detector.

  16/03/85   J. NYE   Renamed all routines to begin with TAG.
                      TAGPS2 is new routine.
                      Old routines kept for the time being.

  17/04/85   C. B.    Installed new TAGPS2 for Alex

  22/04/85   J. NYE   TAGAN and TAGMRK changed (6332->6000)

  23/04/85   J. NYE   TAGCOL CHANGED TO INCLUDE ERROR PROTECTION

  16/08/85   A.J.F    TAGINT CHANGED TO HELP GRAPHICS PROGRAM

  30/08/85   A.J.F    GGFAC2 CHANGED - NOW HAS ALL OF BLOCK DATA FROM
                      GGBLCK, AS NOT CALLING ANAL79 STOPS THIS GETTING
                      PICKED UP. ANALYSIS OF 79/80 MC DATA SHOULD
                      NOW WORK.

  16/10/85   A.J.F    SMALL CHANGE TO TAGPS2 - SHOULD PRODUCE BETTER
                      ENERGY RESOLUTION AT SMALL ANGLES( CORRECTS
                       FOR SHOWER LOSS AT INNER EDGE )
  23/10/85   J.O.     IRUN VALUE IN TAGCHK NOW 3 FOR MC DATA, IN ORDER
                      TO SUBTRACT ZERO PEDESTAL AND USE CORRECT GAIN
  21/05/87   J.O.     INTEGER*2 HDATA INTRODUCED IN FHTOS AND TAGH2S
                      THE VARIABLE NRUN IN THESE ROUTINES IS MEANINGLESS
                      BUT HARMLESS, NO DAMAGE DONE...
  11/09/87   A.J.F.   FURTHER IMPROVEMENTS TO TAGPS2
  17/09/87   A.J.F.   TAGAN INTRODUCTORY MESSAGE CHANGED
  16/03/88   A.J.F.   FURTHER IMPROVEMENTS TO TAGPS2
                      THE OLD TAGPS2 WAS KEPT AS TAGPS287
  14/04/88     J.O.   NEW TAGPS2 FROM AJF INSTALLED AS STANDARD, AFTER
                      TESTING TOGETHER WITH NEW NYE CONSTANTS FOR 1986.
                      THESE CAL.CONSTANTS WERE ALSO MADE DEFAULT ON
                      BUPDAT1 AND AUPDAT1 TODAY, BY E. ELSEN
                      OLD TAGPS2 (FROM 16.3.88) KEPT AS TAGPS20
$   30/06/83 804141504  MEMBER NAME  #START0  (S)           NEWLIB
SET PF1='BACK'
SET PF2='LC'
SET PF3='KONT'
SET PF4='TSO'
SET PF5='DIR'
SET PF6='RETURN'
SET PF7='    '
SET PF9='STATUS'
SET PF10='TOP'
SET PF11='B'
SET PF12='T'
SET PF13='? VTOC'
SET PF14='RUN'
SET PF15='FET * FT06F001'
SET PF16='FET * ALL'
SET PF17='ALLOC OLD'
SET PF18='((COMPRESS))'
SET PF20='SDM'
SET PF23='RESHOW'
SET PF23='SHOW RESHOW'
SET PF24='SHOW PF'
SET TEST_REQ =' BACK'
SET BOT='1:BACK 2:LC 3:KONT '
SET BOT=SUBSTR(BOT,1,21)||'4:TSO 5:DIR 6:RETURN '
SET BOT=SUBSTR(BOT,1,42)||'7:SUBH 8:? 9:STATUS '
SET BOT=SUBSTR(BOT,1,63)||'10:TOP 11:B 12:T '
$
$---ALLOCATE CLISTS
$
IF DSN('CLIST') ^= '' FREE FILE(CLIST)
IF DSN('MACRO') ^= '' FREE FILE(MACRO)
ALLOC FILE(MACRO) DA('F11GOD.PATRECSR') SHR
$LLOC FILE(CLIST) DA('F22BOW.JADE.CLISTS','F11PEA.JDCLIST') SHR
ALLOC FILE(CLIST) DA('F22BOW.JADE.CLISTS','F22NYE.CLIST') SHR
SHOW '      ---->   NOTE NOTE NOTE NOTE  <----- '
SHOW '   ALL CHANGES ON THIS LIBRARY MUST BE NOTED IN  '
SHOW '      >>>>>>        $INFO         <<<<<<<       '
SHOW '      ---->         =====          <----- '
LIST $INFO
    18/03/84 403222224  MEMBER NAME  #TAGDOC  (S)           FORTRAN

THIS IS SOME RATHER HAPHAZARD DOCUMENTATION FOR THE ROUTINES USED
FOR ANALYSING TAGGING INFORMATION FROM 1981 ONWARDS AS WRITTEN BY
A.J.FINCH 21/3/84

ADDITIONAL NOTES CONCERNING 'TAGAN'-
====================================

 SOME DEBUGGING INFO CAN BE TURNED ON BY THE FOLLOWING PROCEDURE

      COMMON/CONTRL/JWRITE
      JWRITE=1      -> TURNS  ON INFO
      JWRITE=0      -> TURNS  OFF INFO


      SUBROUTINE TAGINT(*)
      ====================



  THIS IS THE INITIALISATION ROUTINE THAT SHOULD BE CALLED ONCE,BEFORE
  ANALYSING ANY EVENTS  USING  THE  ROUTINES  IN  THIS  PACKAGE.TO  BE
  PRECISE IT MUST CALLED ONCE PER EVENT TO SET UP THE CWORK COMMON


  IT DOES A RETURN 1 IF TAGMRK DOES A RETURN 1 ,WHICH IT DOES IF 'HEAD'
   DOESNT EXIST




      SUBROUTINE COMFIL(IWRITE,*)
     ============================

    THIS SUBROUTINE TAKES THE DATA FROM HDATA BLOCK
    'ATAG' AND PUTS THE ADC CONTENTS IN THE ARRAY CATAG
                         IN ORDER OF ADC ADDRESS

     IWRITE IS A FLAG TO TELL WHETHER TO PRINT THE BANK 'CATAG' AFTER
     IT HAS BEEN FILLED.

    NOTE:- IT ALSO MULTIPLIES CHANNEL NUMBER TIMES A FACTOR TO MAKE IT
    APPROXIMATELY EQUAL TO ENERGY IN MEV



    SUBROUTINES PEDFIX,PEDFX2,PEDFX3
    ================================

 PEDFIX IS CONTROL ROUTINE WHICH CALLS ONE OF THE OTHER TWO TO DO THE
        WORK - ALTHOUGH THEY ARE SIMILAR IN CONCEPT IT AS TOO MUCH
            WORK TO COMBINE THEM INTO ONE ROUTINE

  ROUTINES  TO DO PEDESTAL SUBTRACTION

 PEDFX3   - 1983 ..ONLY
 ======
      ROUTINE TO ATTEMPT OFFLINE SUBTRACTION OF PEDESTALS
      FOR EACH 'SUPERBLOCK' OF 3 LEAD SCINTILLATOR ELEMENTS IT
    CHECKS THAT
     NO ONE CHANNEL IS GREATER THAT 500 MEV,IF THIS IS THE CASE ALL
   THREE BLOCKS ARE IGNORED , OTHERWISE THE VALUES IN THE BLOCKS ARE
    USED TO ESTIMATE A MEAN ADC PEDESTAL , WHICH IS THEN SUBTRACTED
   FROM ALL BLOCKS.


 PEDFX2  - 1981/2 ONLY
 ======
        SAME PROCEDURE AS PEDFX3 BUT 'SUPERBLOCKS' REPLACE 'CAKESLICES'


MEANING OF TERM 'SUPERBLOCK' USED IN COMMENTS OF THIS PROGRAM

  1/4 OF A TAGGING SYSTEM =

                                ___________
                                I    I    I
                      __________I    I    I
                      I    I    L____L____I
                      I    I    I    I    I
                      L____L____I    I    I
                      I    I    L____L____I
                      I    I    I
                   ___L____L____I
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I__
                      I    I    L
                      I    I    I__________
                      L____L____I    I    I
                      I    I    L    I    I
                      I    I    I____L____I
                      L____L____I    I    I
                                I    I    I
                                L____L____I

    'SUPERBLOCK' =

                   ___________
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I




 SUBROUTINE SRSUM(JPART,SUM,*)
 =============================


     THIS SUBROUTINES SUMS ALL  ADC DATA IN ARRAY CATAG ONE END OR THE
     OTHER TO GIVE THE VALUE OF SUM.

  JPART - INPUT - SIGN DETERMINES WHICH END TAGGER IS ANALYSED
                   JPART > 0 => +Z
                   JPART < 0 => -Z

   SUM - OUTPUT - SUM OF ENERGY

  RETURN 1 IF SUM IS A  CRAZY VALUE



 SUBROUTINE CALAD(IWRITE)
 ========================

    THIS SUBROUTINE   CALIBRATES ADC'S USING FACTORS IN
   COMMON CALIBR

  INPUT - IWRITE - IF THIS IS EQUAL TO ONE THE ROUTINE
                   WRITES OUT SOME DEBUGGING INFORMATION


 FUNCTION FSTOH(I)
 =================

  CONVERT SOFTWARE ADDRESS TO HARDWARE ADDRESS
  SEE ALSO FHTOS  - INPUT I = SOFTWARE ADDRESS TO BE CONVERTED



 SUBROUTINE FHTOS(ISAD,IHAD,*)
 =============================


  THIS ROUTINE CONVERTS HARDWARE ADDRESSES TO SOFTWARE ADDRESSES

  ISAD - OUTPUT - SOFTWARE ADDRESS
  IHAD - INPUT  - HARDWARE ADDRESS

  RETURN 1 IF IT CAN'T DO IT ( ILLEGAL ADDRESS SUPPLIED )


    THE PATTERN FOR 1983 ONWARDS IS -

    HARDWARE ADDRESS                              SOFTWARE ADDRESS

         0 - 3             NOT USED
         4 - 7           INNER RING - Z               1 - 4
         8 - 11            "      "                   5 - 8
        12 - 15            NOT USED
        16 - 19             "   "
        20 - 23           MIDDLE RING - Z             9- 12
        24 - 27              "  "                     13-16
        28 - 31            NOT USED
        32 - 35             "   '



     FOR 1981/2 SOFTARE ADDRESS = HARDWARE ADDRESS + 1

    18/03/84 503161535  MEMBER NAME  #TAGDOC2 (S)           FORTRAN

THIS IS SOME RATHER HAPHAZARD DOCUMENTATION FOR THE ROUTINES USED
FOR ANALYSING TAGGING INFORMATION FROM 1981 ONWARDS AS WRITTEN BY
A.J.FINCH 21/3/84

ADDITIONAL NOTES CONCERNING 'TAGAN'-
====================================

 SOME DEBUGGING INFO CAN BE TURNED ON BY THE FOLLOWING PROCEDURE

      COMMON/CONTRL/JWRITE
      JWRITE=1      -> TURNS  ON INFO
      JWRITE=0      -> TURNS  OFF INFO


      SUBROUTINE TAGINT(*)
      ====================



  THIS IS THE INITIALISATION ROUTINE THAT SHOULD BE CALLED ONCE,BEFORE
  ANALYSING ANY EVENTS  USING  THE  ROUTINES  IN  THIS  PACKAGE.TO  BE   0000800
  PRECISE IT MUST CALLED ONCE PER EVENT TO SET UP THE CWORK COMMON       0000900
                                                                         0001000

  IT DOES A RETURN 1 IF TAGMRK DOES A RETURN 1 ,WHICH IT DOES IF 'HEAD'
   DOESNT EXIST




      SUBROUTINE TAGADC(IWRITE,*)
     ============================

    THIS SUBROUTINE TAKES THE DATA FROM HDATA BLOCK
    'ATAG' AND PUTS THE ADC CONTENTS IN THE ARRAY CATAG
                         IN ORDER OF ADC ADDRESS

     IWRITE IS A FLAG TO TELL WHETHER TO PRINT THE BANK 'CATAG' AFTER
     IT HAS BEEN FILLED.

    NOTE:- IT ALSO MULTIPLIES CHANNEL NUMBER TIMES A FACTOR TO MAKE IT
    APPROXIMATELY EQUAL TO ENERGY IN MEV



    SUBROUTINES TAGPED,TAGPD1,TAGPD2
    ================================

 TAGPED IS CONTROL ROUTINE WHICH CALLS ONE OF THE OTHER TWO TO DO THE
        WORK - ALTHOUGH THEY ARE SIMILAR IN CONCEPT IT AS TOO MUCH
            WORK TO COMBINE THEM INTO ONE ROUTINE

  ROUTINES  TO DO PEDESTAL SUBTRACTION

 TAGPD2   - 1983 ..ONLY
 ======
      ROUTINE TO ATTEMPT OFFLINE SUBTRACTION OF PEDESTALS
      FOR EACH 'SUPERBLOCK' OF 3 LEAD SCINTILLATOR ELEMENTS IT
    CHECKS THAT
     NO ONE CHANNEL IS GREATER THAT 500 MEV,IF THIS IS THE CASE ALL
   THREE BLOCKS ARE IGNORED , OTHERWISE THE VALUES IN THE BLOCKS ARE
    USED TO ESTIMATE A MEAN ADC PEDESTAL , WHICH IS THEN SUBTRACTED
   FROM ALL BLOCKS.


 TAGPD1  - 1981/2 ONLY
 ======
        SAME PROCEDURE AS TAGPD2 BUT 'SUPERBLOCKS' REPLACE 'CAKESLICES'


MEANING OF TERM 'SUPERBLOCK' USED IN COMMENTS OF THIS PROGRAM

  1/4 OF A TAGGING SYSTEM =

                                ___________
                                I    I    I
                      __________I    I    I
                      I    I    L____L____I
                      I    I    I    I    I
                      L____L____I    I    I
                      I    I    L____L____I
                      I    I    I
                   ___L____L____I
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I__
                      I    I    L
                      I    I    I__________
                      L____L____I    I    I
                      I    I    L    I    I
                      I    I    I____L____I
                      L____L____I    I    I
                                I    I    I
                                L____L____I

    'SUPERBLOCK' =

                   ___________
                   I    I    I
                   I    I    I
                   L____L____I
                   I    I    I
                   I    I    I
                   L____L____I




 SUBROUTINE TAGSUM(JPART,SUM,*)
 =============================


     THIS SUBROUTINES SUMS ALL  ADC DATA IN ARRAY CATAG ONE END OR THE
     OTHER TO GIVE THE VALUE OF SUM.

  JPART - INPUT - SIGN DETERMINES WHICH END TAGGER IS ANALYSED
                   JPART > 0 => +Z
                   JPART < 0 => -Z

   SUM - OUTPUT - SUM OF ENERGY

  RETURN 1 IF SUM IS A  CRAZY VALUE



 SUBROUTINE TAGKAL(IWRITE)
 ========================

    THIS SUBROUTINE   CALIBRATES ADC'S USING FACTORS IN
   COMMON CALIBR

  INPUT - IWRITE - IF THIS IS EQUAL TO ONE THE ROUTINE
                   WRITES OUT SOME DEBUGGING INFORMATION


 FUNCTION TAGS2H(I)
 =================

  CONVERT SOFTWARE ADDRESS TO HARDWARE ADDRESS
  SEE ALSO TAGH2S  - INPUT I = SOFTWARE ADDRESS TO BE CONVERTED



 SUBROUTINE TAGH2S(ISAD,IHAD,*)
 =============================


  THIS ROUTINE CONVERTS HARDWARE ADDRESSES TO SOFTWARE ADDRESSES

  ISAD - OUTPUT - SOFTWARE ADDRESS
  IHAD - INPUT  - HARDWARE ADDRESS

  RETURN 1 IF IT CAN'T DO IT ( ILLEGAL ADDRESS SUPPLIED )


    THE PATTERN FOR 1983 ONWARDS IS -

    HARDWARE ADDRESS                              SOFTWARE ADDRESS

         0 - 3             NOT USED
         4 - 7           INNER RING - Z               1 - 4
         8 - 11            "      "                   5 - 8
        12 - 15            NOT USED
        16 - 19             "   "
        20 - 23           MIDDLE RING - Z             9- 12
        24 - 27              "  "                     13-16
        28 - 31            NOT USED
        32 - 35             "   '



     FOR 1981/2 SOFTARE ADDRESS = HARDWARE ADDRESS + 1

C   13/06/85 506131758  MEMBER NAME  TEMP     (S)           FORTRAN
   1 $INFO
   2 ##STATUS
   3 #JOB
   4 #START
   5 #TAGDOC
   6 #TAGDOC2
   7 ACOL
   8 AFTP83
   9 AMCTAG
  10 ANAL79
 110 CALAD
 111 CLSPS
 112 CLUSFN
 113 COMFIL
 114 CONVER
 115 CTAGGO
 116 CUTPED
 117 CUTP81
 118 CWKTAG2
 119 DATE
 120 FFITYP
 121 FHTOS
 122 FHTOS0
 123 FITAG
 124 FRTYPE
 125 FSTOH
 126 GGBLCK
 127 GGCCTL
 128 GGCLPC
 129 GGCLSD
 130 GGCLUS
 131 GGFAC1
 132 GGFAC2
 133 GGFAC3
 134 GGFAC4
 135 GGFAC5
 136 GGFAC6
 137 GGRESQ
 138 GGSORT
 139 GGSRTH
 140 GSCRUB
 141 HDDUMP
 142 INGAM1
 143 LISTGN
 144 LUCHEK
 145 LUMONS
 146 OUTGAW
 147 PEDFIX
 148 RCOORD
 149 REPACK
 150 SORT
 151 SORT1
 152 SORT2
 153 SRSUM
 154 SUBNEW
 155 SUBOLD
 156 TAGADC
 157 TAGALL
 158 TAGAN
 159 TAGCHK
 160 TAGCLS
 161 TAGCOL
 162 TAGDAT
 163 TAGDIR
 164 TAGFIT
 165 TAGFTY
 166 TAGF82
 167 TAGGTP
 168 TAGH2S
 169 TAGINT
 170 TAGKAL
 171 TAGMRK
 172 TAGNEB
 173 TAGNOTE
 174 TAGNOTE2
 175 TAGPD1
 176 TAGPD2
 177 TAGPED
 178 TAGPHI
 179 TAGPOS
 180 TAGPS1
 181 TAGPS2
 182 TAGRAW
 183 TAGRTY
 184 TAGSET
 185 TAGSR1
 186 TAGSR2
 187 TAGSTO
 188 TAGSUM
 189 TAGS2H
 190 TGDCOS
 191 TRACKS
 192 UMCPAK

C   10/01/82 311161219  MEMBER NAME  TOFSM3   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFSM3(NRUN)
C
C      COMPUTES TOF WITHOUT CHECKING AGREEMENT OF THE 2 PHOTOTUBES
C  OUTPUT TTOF(I) : TIME OF FLIGHT IN COUNTER I(ONLY COMPUTED IF LATCH
C                   HAS FIRED) OTHERWISE SET TO -100
C  HTOF(I) = 0 IF LATCH OF COUNTER I HAS NOT FIRED
C          = 1 IF IT HAS
C  NTOF = NUMBER OF TOF LATCHES THAT HAVE FIRED
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IMPLICIT INTEGER*2 (H)
      COMMON/TFPRM/ CORNOR(84),COROVF(84),TPARM(41),VELSC,TCALM(42),
     1 TCALP(42),PEDLM(42),PEDLP(42),DUM(90)
      COMMON/TFADC/ CADCA(84),CADCB(84)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HSTAT(42),HON(42)
      COMMON/FWPED/ HADCF(2,16),HTDCF(2,16),HFSTAT(16),HFON(16)
      COMMON/TFPED1/HTDC1(2,42),HON1(42),HTSPAR(16)
C
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42),ZTOF(42)
      COMMON/BCS/IDATA(1)
      DIMENSION HDATA(2)
      EQUIVALENCE  (HDATA(1),IDATA(1))
      DIMENSION MASK(7),LIST(19),COR(42),COR1(42)
      DATA MASK/1,2,4,8,16,32,64/
      DATA IRUN/0/,IBUG/10/
      DATA MBAD/2/
      DATA LIST/8,11,17*0/
      DATA COR1/-19.,-32.,17*-19.,2*-17.,3*-19.,2*-17.,16*-19./
      DATA COR/42*0/
C
      NTOF = 0
      CALL SETSL(TTOF,0,42*4,0.)
      CALL SETSL(HTOF,0,42*2,0.)
      IF(NRUN.EQ.IRUN) GOTO  10
      IENTRY = IENTRY + 1
C     CALL UCOPY(COR1,COR,42)
C     IF(IENTRY.LE.1) PRINT 115,NRUN,COR
C     IF(NRUN.LE.10362) GOTO  10
C     DO   15   N=1,42
C  15 COR(N) = COR1(N) + 11.5
C     IF(I10362.GT.0)  GOTO  10
C     PRINT 115,NRUN,COR
C 115 FORMAT(' CONSTANTS TOFSM3 AT RUN',I10/(1X,20F6.1))
C     I10362 = 1
   10 IRUN = NRUN
      IPLTC  = IDATA(IBLN('LATC'))
      IF(IPLTC.LE.0)  RETURN
      IPTOF  = IDATA(IBLN('ATOF'))
      IF(IPTOF.LE.0)  RETURN
      JPTOF = IPTOF*2
      JPLTC = IPLTC*2
C
C  FILL ARRAY OF TOF-LATCHES
C
      DO   5   N=4,9
      ID = HDATA(JPLTC+N+2)
      IF(ID.EQ.0)  GOTO  5
      DO   6   M=1,7
      IF(LAND(ID,MASK(M)).LE.0)  GOTO  6
      KTOF = (N-4)*7 + M
      NTOF = NTOF + 1
      IF(NTOF.GT.42)  GOTO  6
      HTOF(KTOF) = 1
    6 CONTINUE
    5 CONTINUE
C
      IF(NTOF.LE.0) RETURN
C     CALL ATOFUN(IPTOF)
      CALL ATFUGR(IPTOF,*999)
C
      IBUG = IBUG + 1
C
      DO   1   I=1,42
      IF(HTOF(I).LE.0)  GOTO  1
      IF1 = 2*I-1
      ITDCL = HTDC(1,I)
      ITDCR = HTDC(2,I)
      IF(IBUG.GT.5)  GOTO  33
      PRINT 733,NRUN,I,ITDCL,ITDCR,HADC(1,I),HADC(2,I)
  733 FORMAT(' CHECK',10I8)
   33 IF(NRUN.LT.8712.OR.NRUN.GT.10000)  GOTO 12
      DO  19   ML=1,MBAD
      IF(I.NE.LIST(ML))  GOTO 19
      TTOF(I) = -20.
      GOTO  1
   19 CONTINUE
C
   12 IF(ITDCL.LT. 5.OR.ITDCL.GE.2048)  GOTO  1
      IF(ITDCR.LT. 5.OR.ITDCR.GE.2048)  GOTO  1
      CORADM = 0.
      CORADP = 0.
      ITIF = IABS(ITDCL-ITDCR)
      IF(NRUN.GT.6600.AND.ITIF.LE.1)  GOTO  20
      IADC =  IF1 + (IF1-1)/12
      IADCM = HADC(1,I)
      IADCP = HADC(2,I)
      ADCM = FLOAT(IADCM)
      ADCP = FLOAT(IADCP)
      IF(ADCM.LT.1024.) CMS = CORNOR(IF1)
      IF(ADCP.LT.1024.) CPS = CORNOR(IF1+1)
      IF(ADCM.GE.1024.) CMS = COROVF(IF1)
      IF(ADCP.GE.1024.) CPS = COROVF(IF1+1)
      ADCM = ADCM - PEDLM(I)
      ADCP = ADCP - PEDLP(I)
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
      ADCMIV = 1000./ADCM
      ADCPIV = 1000./ADCP
      SQADM = SQRT(ADCMIV)
      SQADP = SQRT(ADCPIV)
      BADCM= CADCB(2*I-1)
      BADCP= CADCB(2*I)
      IF(ADCM.GT.1.) CORADM =  BADCM*SQADM
      IF(ADCP.GT.1.) CORADP =  BADCP*SQADP
      IF(CORADM.GT.5.) CORADM = 5.
      IF(CORADP.GT.5.) CORADP = 5.
  20  TDCL = ITDCL*TCALM(I)-CMS-CORADM
      TDCR = ITDCR*TCALP(I)-CPS-CORADP
      TDCL = TDCL -TPARM(25)
      TDCR = TDCR -TPARM(25)
      IF(IBUG.LE.5) PRINT 320,I,ITDCL,TCALM(I),CMS,CORADM,TPARM(25),TDCL
      IF(IBUG.LE.5) PRINT 320,I,ITDCR,TCALP(I),CPS,CORADP,TPARM(25),TDCR
  320 FORMAT(' TOFSM3',2I5,5F12.4)
      TTOF(I) = .5*(TDCL+TDCR)
      IF(NRUN.GE.10000) TTOF(I) = TTOF(I) + 3.07
C     IF(NRUN.GT.12518) TTOF(I) = TTOF(I) + 11.
      ZTOF(I) = (TDCL-TDCR)/2.*VELSC
      IF(IBUG.LE.5) PRINT 734,I,TTOF(I)
  734 FORMAT(' CHECK',I5,F10.2)
    1 CONTINUE
C/////////
  999 RETURN
      END

C   07/06/96 606071919  MEMBER NAME  WCOND    (S4)          FORTG1
      SUBROUTINE UCOND(NCOND,NC)
      COMMON/BCS/IW(1)
      INTEGER*2 NH(2)
      EQUIVALENCE (NF,NH(1))
C
C     PURPOSE
C        COUNT NUMBER OF CONDITIONS, CHARACTERIZED BY
C        TWO INTEGERS NCOND,NC  (BOTH LT 32768)
C
C     USAGE
C        CALL UCOND(NCOND,NC)
C      = INCREASE COUNT FOR CONDITION (NCOND,NC) BY 1
C
C        CALL PCOND
C      = PRINT COUNTS AND RESET COUNTERS
C
C        CALL QCOND(NCOND,NC,NUMBER)
C      = GET NUMBER OF COUNTS OF CONDITION (NCOND,NC)
C
      IF(NCOND.LT.0.OR.NCOND.GE.32768) GOTO 100
      IF(NC   .LT.0.OR.NC   .GE.32768) GOTO 100
      NH(1)=NCOND
      NH(2)=NC
      NS=(NF/8)*8
      NR=MOD(NF,8)
C     WRITE(6,101) NS,NR,NF,NH
C 101 FORMAT(1X,10I12)
      CALL BLOC(I,'CON*',NS,&20)
   10 IW(I+NR+1)=IW(I+NR+1)+1
  100 RETURN
   20 CALL BCRE(I,'CON*',NS,8,&100,IER)
      GOTO 10
C
      ENTRY QCOND(NCOND,NC,NUMBER)
      NUMBER=0
      IF(NCOND.LT.0.OR.NCOND.GE.32768) GOTO 100
      IF(NC   .LT.0.OR.NC   .GE.32768) GOTO 100
      NH(1)=NCOND
      NH(2)=NC
      NS=(NF/8)*8
      NR=MOD(NF,8)
      CALL BLOC(I,'CON*',NS,&100)
      NUMBER=IW(I+NR+1)
      GOTO 100
      END
      SUBROUTINE PCOND
      COMMON/BCS/IW(1)
      INTEGER*2 NH(2)
      EQUIVALENCE (NF,NH(1))
      INTEGER NLT(16)
      NN=0
      M=0
      CALL BPOS('CON*')
   80 CALL BNXT(K,&98)
      IF(M.EQ.0) WRITE(6,101)
      M=1
      N=IW(K)
      NF=IW(K-2)
C     WRITE(6,103) NF,NH
C 103 FORMAT(1X,10I12)
      NF=NF
      IF(NN.EQ.0) GOTO 81
      IF(NH(1).EQ.NLT(1)) GOTO 90
      WRITE(6,102)      (NLT(J),J=1,NN)
   81 NN=1
   90 NLT(1)=NH(1)
      DO 96 L=1,8
      IF(IW(K+L).EQ.0) GOTO 96
      IF(NN.LT.16) GOTO 94
      WRITE(6,102)      (NLT(J),J=1,NN)
      NN=1
   94 NLT(NN+1)=IW(K+L)
      NLT(NN+2)=NH(1)
      NLT(NN+3)=NH(2)-1+L
C     NLT(NN+3)=NLT(NN+3)+L-1
C     NLT(NN+3)=NH(2)
      NN=NN+3
   96 IW(K+L)=0
      CALL BDLS('CON*',NF)
      GOTO 80
   98 IF(NN.EQ.0) GOTO 99
      WRITE(6,102)      (NLT(J),J=1,NN)
   99 CONTINUE
      RETURN
  101 FORMAT('0---',7('----')/' UCOND',4X,'ENTRIES *(    I,'
     1   ,'    J)')
  102 FORMAT(' I=',I5,5(I 9,' *(',I5,',',I5,')'))
      END

C   09/10/79 912071503  MEMBER NAME  ANOM66   (S)           FORTRAN
      SUBROUTINE ANOM66(IRUN)
C---  ANOMALIES OF RUNS 1639 - 1648
C---  15.30 GEV      SEPTEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     07.12.79     15:00
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1639,1640,1641,1642,1643,1644,1645,1646,1647,1648),IRUN
   13 RETURN
C
 1639 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
 1640 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(162) = -1
      LIMIT(162) = 90
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(183) = -1
      LIMIT(183) = 135
      KCONST(184) = -1
      LIMIT(184) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      LTHRES(50) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(56) = .TRUE.
      LTHRES(57) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(62) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(65) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(73) = .TRUE.
      LTHRES(74) = .TRUE.
      LTHRES(75) = .TRUE.
      LTHRES(76) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(81) = .TRUE.
      LTHRES(82) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(86) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(90) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
C
      RETURN
C
 1641 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 1642 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 1643 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 120
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(50) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(56) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(62) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(65) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(76) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(81) = .TRUE.
      LTHRES(82) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(86) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(90) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
C
      RETURN
C
 1644 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 135
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(50) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(56) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(62) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(65) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(76) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(81) = .TRUE.
      LTHRES(82) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(86) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(94) = .TRUE.
C
      RETURN
C
 1645 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 1646 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(162) = -1
      LIMIT(162) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 1647 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 1648 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 105
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
      END

C   28/11/79 112032028  MEMBER NAME  MOMGAM   (JADEGS)      FORTRAN
      SUBROUTINE MOMGAM(IP,PX,PY,PZ,PTRANS,PTOT,PHI,THE)
      IMPLICIT INTEGER*2 (H)
C---
C---     GIVEN:  POINTER TO CLUSTER BANK IP
C---     RETURN: THREE COMPONENTS OF THE MOMENTUM
C---          J.OLSSON  16.09.79        LAST CHANGE  06.11.81
C---
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
      COMMON /CJTRIG/ PI,TWOPI
C----------------------------------------
C
      PHI = ATAN2(ADATA(IP+10),ADATA(IP+9))
      IF(PHI.LT.0.) PHI = PHI + TWOPI
      THE = ARCOS(ADATA(IP+11))
C     JPART = IDATA(IP+1)
C     IF(JPART.NE.0) GO TO 2
C****************************** BARREL PHOTONS *****
C     PHI = ADATA(IP+4)
C     THE = ATAN2(ADATA(IP+5),RLG)
C     THE = PI*.5 - THE
C     GO TO 3
C****************************** ENDCAP PHOTONS *****
C2     XP = ADATA(IP+4)
C      YP = ADATA(IP+5)
C      RR = SQRT(XP*XP + YP*YP)
C      THE = ATAN2(RR,ZENDPL)
C      IF(JPART.LT.0) THE = PI - THE
C      PHI = ATAN2(YP,XP)
C      IF(PHI.LT.0.) PHI = PHI + TWOPI
3     CONTINUE
      EGAM = ADATA(IP+2)
      COSTH = COS(THE)
      PZ = EGAM*COSTH
      COSTH = SIN(THE)*EGAM
      PX = COSTH*COS(PHI)
      PY = COSTH*SIN(PHI)
      PTRANS = SQRT(PX*PX + PY*PY)
      PTOT = SQRT(PTRANS*PTRANS + PZ*PZ)
      RETURN
      END

C   07/06/96 606071823  MEMBER NAME  BLNA     (S4)          FORTG1
      SUBROUTINE BLNA
      COMMON/BCS/IW(1)
#include "acs.for"
      WRITE(6,101) NCI
      IF(NCI.EQ.0) GOTO 100
      WRITE(6,102) (IW(INAMV+I),I=1,NCI)
  100 RETURN
  101 FORMAT('0ORDERED LIST OF ALL',I4,' NAMES USED')
  102 FORMAT(20X,10A8)
      END

C   07/06/96 606071858  MEMBER NAME  NEWOLD   (S4)          FORTRAN
      SUBROUTINE BLOCDA(IUNDA,IND,NAME,NR,*)
C
C     INTERFACE TO NEW ROUTINES
C
      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
C
C
C
      IND=ILINK(NAME,NR)
      IF(IND.NE.0) GOTO 100
      CALL BDFILE(IUNDA)
      IND=INDDIR(NAME,NR,IUNDA,2HFE)
      IF(IND.EQ.0) GOTO 200
      GOTO 100
C
C
C
      ENTRY BDLSDA(IUNDA,NAME,NR)
      CALL BDFILE(IUNDA)
      IND=INDDIR(NAME,NR,IUNDA,2HDL)
      GOTO 100
C
C
C
      ENTRY BCREDA(IUNDA,INDAR)
      CALL BDFILE(IUNDA)
      IND=INDDIR(IW(INDAR-3),IW(INDAR-2),IUNDA,2HST)
      GOTO 100
C
C
C
      ENTRY BCHKDA(IUNDA,NAME,NR,NWD)
      CALL BDFILE(IUNDA)
      IUND=IUNDA
      LISTE(1)=NAME
      LISTE(2)=NR
      CALL DIDA(1,LISTE,1)
      NWD=0
      IF(INDT.EQ.0) GOTO 100
      NWD=LISTE(4)
C
C
C
  100 RETURN
C
C
C
  200 RETURN 1
      END
      SUBROUTINE BINLDA(IUNDA,NREC,IPASS)
      CALL BDFILE(IUNDA)
      CALL BCFILE(IUNDA,NREC,1610,IPASS,3HNEW)
  100 RETURN
      END
      SUBROUTINE BDFILE(IUNDA)
      INTEGER NUN(5)/5*0/
      IF(IUNDA.LT.16.OR.IUNDA.GT.20) GOTO 101
      NU=IUNDA-15
      IF(NUN(NU).EQ.1) GOTO 100
      NUN(NU)=1
      GOTO (10,20,30,40,50),NU
   10 CONTINUE
      DEFINE FILE 16(2000,1610,U,IVAR)
      GOTO 100
   20 CONTINUE
      DEFINE FILE 17(2000,1610,U,IVAR)
      GOTO 100
   30 CONTINUE
      DEFINE FILE 18(2000,1610,U,IVAR)
      GOTO 100
   40 CONTINUE
      DEFINE FILE 19(2000,1610,U,IVAR)
      GOTO 100
   50 CONTINUE
      DEFINE FILE 20(2000,1610,U,IVAR)
  100 RETURN
C
C     UNIT FOR DIRECT ACCESS OUT OF RANGE 16 ... 20
C
  101 CALL BDMPA(111)
      GOTO 100
      END
      SUBROUTINE BUNLDA(IUNDA,IUNTP,NREC,NPAG,IPASS)
      CALL BDFILE(IUNDA)
      CALL BFTDIR(IUNDA,IUNTP,2HTO)
  100 RETURN
      END
      SUBROUTINE BLOADA(IUNDA,IUNTP,IPASS)
      CALL BDFILE(IUNDA)
C
C     SECOND ARGUMENT = -1610 TO SIGNAL 'OLD DATA SET' TO BCFILE
C     NREC IS TAKEN FROM DIRECTORY
C
      CALL BCFILE(IUNDA,-1610,1610,IPASS,'OLD')
      CALL BFTDIR(IUNDA,IUNTP,2HFR)
  100 RETURN
      END
      SUBROUTINE BPASDA(IUNDA,IPASS)
      CALL BDFILE(IUNDA)
      CALL BPWDIR(IUNDA,IPASS)
  100 RETURN
      END

C   21/11/78 C9071601   MEMBER NAME  ZBOS01   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------100000200
C     1.  INTRODUCTION
C
C     LARGE AMOUNT OF DATA ARE TO BE ANALYSED IN HIGH-ENERGY
C     PHYSICS EXPERIMENTS. DATA ON ONE EVENT CONSIST OF DATA
C     FROM SEVERAL SOURCES, E.G. TRACK CHAMBERS, SHOWER COUNTERS
C     AND SCALERS. DURING THE ANALYSIS NEW DATA ARE ADDED
C     BY COMPUTATION, E.G. DATA ON SINGLE TRACKS. ALSO DATA
C     MAY BE COMPRESSED BY DATA REDUCTION PROGRAMS.
C     THE COMPLEXITY OF ANALYSIS DEPENDS VERY MUCH ON THE
C     ORGANISATION OF THE DATA IN STORAGE AND ON MASS STORAGE
C     DEVICES, E.G. TAPES. A FLEXIBLE DATA ORGANISATION
C     SIMPLIFIES THE ANALYSIS.
C     THE SYSTEM DESCRIBED HERE IS DESIGNED ACCORDING TO THE
C     NEEDS OF HIGH-ENERGY PHYSICS EXPERIMENTS. ALL DATA ARE
C     STRUCTURED IN SO CALLED BANKS OF VARIABLE LENGTH. DATA
C     IN ONE BANK REFER E.G. TO A SINGLE PARTICLE TRACK. A
C     BANK HAS TWO IDENTIFIERS NA AND NR, CALLED NAME AND
C     NUMBER. NORMALLY THE IDENTIFIER NA CONSISTS OF UP TO
C     FOUR CHARACTERS, WHILE IDENTIFIER NR IS AN INTEGER.
C
C     ALL BANKS ARE STORED IN A SINGLE COMMON/BCS/IW(NSPACE).
C     AN INDEX IND IS ASSIGNED TO EACH BANK, WHERE IW(IND)=NW
C     CONTAINS THE NUMBER OF DATA WORDS IN THAT BANK. DATA
C     ARE STORED IN IW(IND+1) TO IW(IND+NW). IN ADDITION
C     THERE ARE THREE WORDS CONTAINING NAME, NUMBER AND A
C     POINTER ACCORDING TO THE FOLLOWING SCHEMA.
C
C              I      IW(I)
C          --------   -------------------------------------
C          IND -  3   NA (NAME)
C          IND -  2   NR (NUMBER)
C          IND -  1   POINTER TO NEXT BANK OF SAME NAME
C                     -------------------------------------
C          IND        NW = NUMBER OF DATA WORDS IN THE BANK
C                     -------------------------------------
C          IND +  1   DATA WORD 1
C          IND +  2   DATA WORD 2
C          ...        ...
C          IND + NW   DATA WORD NW
C          --------   -------------------------------------
C
C     NO LIMITATIONS EXIST FOR THE LENGTH OF A SINGLE BANK OR
C     THE NUMBER OF BANKS, EXCEPT FOR THE TOTAL LENGTH OF
C     ALL BANKS.
C     OUTPUT OF SETS OF BANKS IS SIMPLY DONE BY SPECIFYING
C     ALL NAMES OF BANKS, BELONGING TO THE OUTPUT RECORD.
C     THE MAIN ADVANTAGES OF THE SYSTEM ARE -
C             - EFFICIENT USE OF STORAGE
C             - EASY ADDITION OF NEW BANKS
C             - FLEXIBLE INPUT/OUTPUT
C
C
C
C     THIS MANUAL DESCRIBES THE BOS VERSION RELEASED IN THE
C     BEGINNING OF 1979. THE MAIN CHANGES IN THIS VERSION TO
C     THE VERSION DESCRIBED IN THE INTERNAL REPORT DESY F14/76-01
C     ARE INTERNALLY, TO INCREASE THE SPEED ESPECIALLY FOR
C     INPUT AND OUTPUT. ALL CALLS OF THE PREVIOUS VERSION ARE ALSO
C     EXISTING IN THE CURRENT VERSION.
C     THE MAIN CHANGES ARE THE FOLLOWING
C     CHAPTER 2.   DIFFERENT ACTION IN CASE OF ERRORS IN BCRE
C     CHAPTER 4.   ADDITIONAL CALLS FOR LIST HANDLING
C     CHAPTER 6.   MODIFIED RULES FOR INPUT FROM DATA CARDS
C     CHAPTER 8.   NEW MODES FOR OUTPUT (AND INPUT)
C     CHAPTER 9.   NEW SUBROUTINES FOR DIRECT ACCESS DEVICES
C
C
C
C     LIBRARIES. THE SUBPROGRAMS OF THE BANK-SYSTEMS BOS AND
C     SBOS ARE ON THE DESY-NEWLIB LIBRARIES
C              DSN=F1EBLO.BOSLIB.L    (LOAD)
C         AND  DSN=F1EBLO.BOSLIB.S    (SOURCE)
C
C     THE FULL BOS SYSTEM IS DESCRIBED IN CHAPTER 2 - 10. IN
C     APPENDIX A A SMALL SUBSYTEM CALLED SBOS IS DESCRIBED, WHICH
C     HAS A TOTAL PROGRAM LENGTH OF BELOW 10 K BYTES. THIS SMALLER
C     SYSTEM IS FULLY COMPATIBLE WITH THE FULL SYSTEM, SUBROUTINES
C     FROM BOTH SYSTEMS MAY BE USED TOGETHER. THE SBOS SYSTEM IS
C     DEVELOPPED MAINLY FOR ONLINE APPLICATIONS. NEARLY ALL
C     FUNCTIONS DESCRIBED IN CHAPTER 2, 3, 4, 6 AND SOME OF THE
C     FUNCTIONS DESCRIBED IN CHAPTER 8 ARE POSSIBLE.
C     IN APPENDIX B APPLICATION PROGRAMS ARE DESCRIBED. THEY CAN
C     BE USED FOR COUNTING, MAKING HISTOGRAMS ETC AND MAY BE
C     USEFUL IN THE TESTING PHASE OF ANALYSIS PROGRAMS.
C
C     THE SBOS SYSTEM CONSISTS OF THE FOLLOWING SUBPROGRAMS.
C
C
C           SUBPROGRAM
C
C      0.1  BENT AND BDMPA
C      0.2  ILOC
C      0.3  IBLN                    (IDENTICAL IN BOS)
C      0.4  BMLT                    (IDENTICAL IN BOS)
C      0.5  BLST
C      0.6  BDLM                    (IDENTICAL IN BOS)
C      0.7  BGAR                    (IDENTICAL IN BOS)
C      0.8  BSIN
C      0.9  BOUT
C        +  ENTRIES VZERO, UCOPY AND UCOPY2
C
C     THE BOS SYSTEM (EXCLUDING THE APPLICATION PROGRAMS)
C     CONSISTS OF THE FOLLOWING SUBROUTINES.
C
C           SUBPROGRAM   ENTRIES
C
C      1.1  BINT         BINT1
C      1.2  BDMPA
C      1.3  IBLN         -
C      1.4  BRNM         BSPC
C      1.5  BCRE         -
C      1.6  CCRE         -
C      1.7  BLOC         -
C      1.8  CLOC         -
C      1.9  BCHM         BCHF   BSTR   BMRT
C      1.10 BDAR         -
C      1.11 BPOS         CPOS   BPRL
C      1.12 BNXT         -
C      1.13 CNXT         -
C      1.14 BMLT
C      1.15 BSAW         BDEF   BSAT   BSAD
C      1.15 BDLS         BPRS
C      1.17 BDLM
C      1.18 BDLG         BPRM   BSLW   BSLC   BSLT
C      1.19 BGAR         -
C      1.20 BDMP         BDMPF
C      1.21 BSTA         -
C      1.22 DUMP0C       -
C      1.23 BCHL         BMVE
C      1.24 CCHL         CMVE
C      1.25 BGAC         -
C      1.26 BSLS         BSLR
C      1.27 INDAR
C      + ENTRIES VZERO, UCOPY AND UCOPY2
C      + SUBR. UWP
C      + SUBR. DAY, ITRACE, NTIME FROM DESYLIB
C
C      2.1  BREADC       -
C      2.2  READHL       -
C
C      3.1  BREAD        -
C      3.2  CREAD        -
C      3.3  BWRITE       -
C      3.4  BRDS         -
C      3.5  BWRS         BWRO
C      3.6  BFRD         BFWR
C      3.7  BINP         BFRR
C      3.8  BOUTP        BORDP
C      3.9  BSEQ         BSEW   BSET   BSEL
C      3.10 RDVAR        WRVAR  WRFIX
C      3.11 MSGPR        MSGTXT MSGINT
C
C      4.1  BLOCDA       BDLSDA BCREDA BCHKDA
C      4.2  BINLDA       -
C      4.3  BLOADA       -
C      4.4  PODA         CHDIR
C      4.5  DADA         -
C      4.6  RDDA         WRDA   RDSQ   WRSQ
C      4.7  BPASDA       -
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C     INITIALIZATION IS DONE BY THE FOLLOWING STATEMENTS.
C
C     COMMON/BCS/IW(NSPACE)
C     REAL RW(NSPACE)
C     EQUIVALENCE (IW(1),RW(1))
C        WHERE NSPACE = INTEGER CONSTANT
C
C               ------ ---- ---- ----
C     CALL BINT(NSPACE,NREC,NDMP,NADD)
C
C
C        WHERE NREC  = MAX.NO OF WORDS IN A OUTPUT RECORD,
C                      IF BWRO IS NOT CALLED (SEE CH. 8.2)
C                      (DEFAULT 4000)
C              NDMP  = NR OF WORDS, PRINTED IN A DUMP
C                      (DEFAULT  500)
C              NADD  = NR OF WORDS FOR LOW PRIORITY BANKS
C                      (DEFAULT IS 10 PERCENT OF NSPACE)
C
C
C     HERE AND IN THE FOLLOWING INPUT ARGUMENTS HAVE
C     A LINE ABOVE, OUTPUT ARGUMENTS HAVE A LINE BELOW.
C     ARGUMENTS, WHICH ARE CHANGED BY THE PROGRAM, HAVE A LINE
C     ABOVE AND BELOW. THE ARGUMENT IER IN SOME CALLS IS AN
C     ERROR CODE WITH THE VALUE ZERO, IF NO ERROR WAS DETECTED.
C
C     THE DEFAULT VALUES ARE USED, IF THE ARGUMENTS ARE ZERO.
C     IF ERROR CONDITIONS E.G. ILLEGAL VALUES OF POINTERS ARE
C     DETECTED, THE DUMP PROGRAM BDMP IS CALLED AND THE PROGRAM
C     IS STOPPED WITH CALL ABEND. THE OUTPUT OF THE DUMP PROGRAM
C     IS EXPLAINED IN CH. 10.
C
C
C     BANKS WITH NAMES, WHERE THE FOURTH CHARACTER IS A '*',
C     E.G. 'HST*', ARE CONSIDERED AS BANKS OF LOW PRIORITY.
C     THEY CAN ONLY BE CREATED UP TO A TOTAL AMOUNT OF
C     NADD WORDS.
C
C     NAMES WITH CHARACTER '+' AS THE FIRST CHARACTER,
C     E.G. '+BUF', ARE NAMES OF SYSTEM BANKS. THE USER SHOULD
C     NOT USE NAMES STARTING WITH THE CHARACTER '+'.
C
C
C
C     OPTIONALLY THE USER CAN CALL BINT1 IMMEDIATELY AFTER
C     BINT, TO CHANGE SOME DEFAULT PARAMETERS OF THE SYSTEM.
C
C                --- --- --- ---
C     CALL BINT1(NNA,NNL,NNE,NNP)
C
C        WHERE NNA = MAX. NR OF DIFFERENT NAMES      (DEFAULT 200)
C              NNL = MAX. NR OF ENTRIES IN LISTS     (DEFAULT 100)
C              NNE = MAX. NR OF READ ERRORS ALLOWED  (DEFAULT  10)
C              NNP = MAX. NR OF LISTINGS FOR RECORDS
C                    WITH CERTAIN TYPES OF INPUT
C                    BANK ERRORS                     (DEFAULT   2)
C
C     THE DEFAULT VALUES ARE USED, IF BINT1 IS NOT CALLED. ABOUT
C     5*NNA + 3*NNL WORDS IN THE COMMON/BCS/ ARE USED FOR INTERNAL
C     TABLES (1312 WORDS FOR DEFAULT VALUES).
C
C     SOME INFORMATION ON THE FREE SPACE IN COMMON/BCS/ ETC
C     CAN BE OBTAINED BY
C
C     CALL BSPC(IND,NUS,NAS,NSL)
C               --- --- --- ---
C
C        WHERE IND = INDEX OF FIRST UNUSED WORD BEHIND THE BANKS
C              NUS = NR OF UNUSED WORDS BEHIND BANKS
C              NAS = NR OF ADDITIONAL FREE WORDS FROM DELETED BANKS
C              NSL = NR OF ENTRIES IN THE SPECIAL LIST
C
C     THE UNUSED SPACE  IW(IND) . . . IW(IND+NUS)  CAN BE USED
C     AS AN INTERMEDIATE STORAGE BETWEEN CALLS TO BOS SYSTEM
C     PROGRAMS.
C
      RETURN
      END

C   09/02/87 807222021  MEMBER NAME  TPVCPR   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPVCPR
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      22/07/88:  Process Vertex Chamber
C
C
C
C     Routine to process the Vertex Chamber and perform the COMFIT
C     that is, a combined fit along with the Jet Chamber.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  ANALYS, COMFIT

      INTEGER  MODE, IVRET1, IVRET2

C------------------  C O D E  ------------------------------------------

C                            Get instructions about VTXC analysis and
C                            combined fit with Jet Chamber.

      CALL TPVCI1( ANALYS )
      CALL TPVCI2( COMFIT )

      MODE = 0
      IF( ANALYS ) MODE = MODE + 1
      IF( COMFIT ) MODE = MODE + 2

      IF( MODE .GT. 0 ) THEN

C                            Set fudge factors then do analysis/comfit
C                            using lowest number PATR bank.

        CALL VTXCSF( IVRET1 )

        CALL VTXCSV( MODE, -1, -1, IVRET2 )

        CALL TPDIAG

      ENDIF

      RETURN
      END

C   30/11/79 001241835  MEMBER NAME  ANO160   (S)           FORTRAN
      SUBROUTINE ANO160(IRUN)
C---  ANOMALIES OF RUNS 2306 - 2385
C---  6.0 GEV      NOVEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     24.01.80     18:35
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (2306,2307,2308,2309,2310,2311,2312,13,13,13,13,2317,2318,
     &      2319,2320,2321,2322,2323,2324,2325,13,13,2328,2329,2330,
     &      2331,2332,2333,2334,2335,2336,2337,13,2339,2340,2341,2342,
     &      2343,2344,2345,2346,2347,2348,2349,2350,2351,2352,2353,2354,
     &      2355,2356,13,2358,2359,2360,2361,2362,2363,2364,2365,
     &      2366,2367,2368,2369,2370,2371,2372,2373,2374,2375,2376,
     &      2377,2378,2379,2380,2381,2382,2383,2384,2385),IRUN
   13 RETURN
C
 2306 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C2307 PRELIMINARY
 2307 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C2308 PRELIMINARY
 2308 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C2309 PRELIMINARY
 2309 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C2310 PRELIMINARY
 2310 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
C2311 PRELIMINARY
 2311 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(68) = +1
      LIMIT(68) = 360
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
C2312 PRELIMINARY
 2312 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C2317 PRELIMINARY
 2317 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C2318 PRELIMINARY
 2318 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(16) = +1
      LIMIT(16) = 390
      KCONST(111) = +1
      LIMIT(111) = 315
      KCONST(112) = +1
      LIMIT(112) = 75
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
C2319 PRELIMINARY
 2319 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2320 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2321 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2322 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(59) = +1
      LIMIT(59) = 360
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2323 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 180
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2324 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2325 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2328 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2329 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2330 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(151) = +1
      LIMIT(151) = 360
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2331 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2332 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2333 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2334 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2335 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(35) = +1
      LIMIT(35) = 375
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2336 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(57) = +1
      LIMIT(57) = 375
      KCONST(67) = +1
      LIMIT(67) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      LTHRES(154) = .TRUE.
C
      RETURN
C
 2337 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = -1
      LIMIT(7) = 105
      KCONST(49) = -1
      LIMIT(49) = 225
      KCONST(55) = -1
      LIMIT(55) = 165
      KCONST(57) = -1
      LIMIT(57) = 300
      KCONST(67) = -1
      LIMIT(67) = 75
      KCONST(155) = -1
      LIMIT(155) = 360
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(162) = .TRUE.
C
      RETURN
C
 2339 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2340 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2341 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 210
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2342 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2343 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2344 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2345 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2346 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 225
      KCONST(49) = +1
      LIMIT(49) = 315
      KCONST(55) = +1
      LIMIT(55) = 285
      KCONST(57) = +1
      LIMIT(57) = 360
      KCONST(60) = +1
      LIMIT(60) = 330
      KCONST(67) = +1
      LIMIT(67) = 165
      KCONST(154) = -1
      LIMIT(154) = 90
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2347 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(27) = +1
      LIMIT(27) = 270
      KCONST(35) = +1
      LIMIT(35) = 375
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2348 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2349 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(188) = +1
      LIMIT(188) = 195
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(57) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 2350 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2351 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2352 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2353 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2354 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2355 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2356 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2358 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(22) = +1
      LIMIT(22) = 390
      KCONST(23) = +1
      LIMIT(23) = 270
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(118) = +1
      LIMIT(118) = 270
      KCONST(119) = +1
      LIMIT(119) = 375
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2359 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(71) = +1
      LIMIT(71) = 360
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2360 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(82) = +1
      LIMIT(82) = 405
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2361 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2362 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2363 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2364 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2365 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(57) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2366 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2367 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2368 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2369 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(28) = +1
      LIMIT(28) = 345
      KCONST(124) = +1
      LIMIT(124) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2370 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(71) = +1
      LIMIT(71) = 360
      KCONST(80) = +1
      LIMIT(80) = 420
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(176) = +1
      LIMIT(176) = 255
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
 2371 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2372 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2373 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2374 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(71) = +1
      LIMIT(71) = 360
      KCONST(101) = -1
      LIMIT(101) = 210
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2375 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
 2376 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2377 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2378 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2379 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2380 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(81) = +1
      LIMIT(81) = 360
      KCONST(82) = +1
      LIMIT(82) = 390
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(177) = +1
      LIMIT(177) = 240
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2381 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2382 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(125) = +1
      LIMIT(125) = 375
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2383 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2384 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 90
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2385 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
      END

C   07/06/96 606071911  MEMBER NAME  SORTIR   (S4)          FORTG1
      SUBROUTINE SORTIR(A,N,M,IA)
      INTEGER A(2),AIM,AL
C
C     PURPOSE
C        SORT VECTORS A(*,J) OF ARRAY A(M,N) TO INCREASING ORDER
C        IN ELEMENT A(IA,J) (ASSUMED TO BE INTEGER)
C
C     USAGE
C                    - - - --
C        CALL SORTIR(A,N,M,IA)
C                    -
C        WHERE A( , ) = ARRAY
C              N      = NROF VECTORS
C              M      = LENGTH OF ONE VECTOR
C              IA     = INDEX OF SORTELEMENT IN VECTOR
C
C     EXAMPLE
C        INPUT     A  = 23.2  3  712.4  17.1  1  912.5
C        CALL      CALL SORTIR(A,2,3,2)
C        OUTPUT    A  = 17.1  1  912.5  23.2  3  712.4
C
C
      NM=(N-1)*M
      I=IA-M
   10 I=I+M
      IF(I.GT.NM) GOTO 100
      IF(A(I+M).GE.A(I)) GOTO 10
      AIM=A(I+M)
      K=I
   20 K=K-M
      IF(K.LE.0) GOTO 30
      IF(AIM.LT.A(K)) GOTO 20
   30 LM=K+M-IA+M
      DO 50 J=1,M
      L=I+M-IA+J
      AL=A(L)
   40 A(L)=A(L-M)
      L=L-M
      IF(L.GT.LM) GOTO 40
      A(L)=AL
   50 CONTINUE
      GOTO 10
  100 RETURN
      END

C   25/11/80 011262001  MEMBER NAME  PREDIT   (JADEGS)      FORTRAN
      SUBROUTINE PREDIT
      IMPLICIT INTEGER*2 (H)
C
C     MAIN SUBROUTINE FOR PATREC IN JET CHAMBERS
C     PETER STEFFEN 15/ 9/79
C *****  GRAPHICS EDITING VERSION ** LAST CHANGE 21.02.80   J.OLSSON ***
C *****  CHANGED TO NEW FORMATS FOR HITLABEL ARRAY AND MIDOUT        ***
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      IF(ACMD.EQ.0.) GO TO 92
      CALL PATRC1(0)
      CALL TRMOUT(80,' EDIT ENTERED AFTER BACKTRACE, NO CALL TO FIT AND
     +ADMINISTRATION PROGRAM DONE^')
      CALL TRMOUT(80,' TO STOP AUTOMATIC DELETION OF LOW ENERGY TRACKS,
     +USE COMMAND NR 33^')
      GO TO 93
92    CALL PATREC(0)
93    NTRLM = 0
      ACMD = 0.
      CALL CREDIT
      RETURN
      END

C   11/01/88 801112204  MEMBER NAME  TPTGI3   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTGI3( DELETE )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery       11/01/88:  Get instr on tagg bank delete
C
C
C
C     Routine to provide yes/no answers about deleting tagging banks.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     DELETE    Out      L*4      TRUE if delete step is to be done
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  TAGG*8, DELET*20

      LOGICAL  DELETE, DEL, FIRST

      SAVE  DEL, FIRST

      DATA  FIRST / .TRUE. /
      DATA  TAGG  / 'TAGG' /, DELET / 'DELETE' /

C------------------  C O D E  ------------------------------------------

C                            If not first call, DEL already SAVEd.

      IF( FIRST ) THEN

C                            Get user request relating to tagg delete

        CALL TPUOPT( TAGG, DELET, DEL )

        FIRST = .FALSE.

      ENDIF

C                            Set DELETE equal to DEL

      DELETE = DEL

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   01/11/84 901191957  MEMBER NAME  VXDISP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE VXDISP(INDEX) 
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON    1/02/80 :  VERTEX DISPLY FROM DITTMANN
C
C       MOD:   J. OLSSON    4/05/83 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 22/10/84 :  FOR COMMAND VC
C       MOD:   J. HAGEMANN 24/02/87 :  FOR CHANGED COMMON / CWORK1 /
C       MOD:   J. HAGEMANN 13/03/87 :  VRES LIMITED TO 50 TRACKS
C                                      OTHERWISE POINTER OUT OF RANGE
C                                      IN COMMON /CWORK1/
C       MOD:   J. O., J.S. 21/04/87 :  HELIX DISPLAY IN Z-VIEWS
C       MOD:   J. HAGEMANN 05/06/87 :  DUE TO UPDATE OF STANDARD VXDISP
C       MOD:   J. HAGEMANN 21/01/88 :  GENERAL UPDATE
C  LAST MOD:   J. O., D.P. 19/01/89 :  UNDEF. VAR. AH03 NOW SET
C
C     VERTEX DISPLAY FOR JADE, USING VERTEX PROGRAM FROM P.DITTMANN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL TBIT
      LOGICAL FL18,FL22,FL24,DSPD14
      LOGICAL FLVCDO
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C   23/03/97 703231948  MEMBER NAME  MVERTEX0 (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVERTEX0       SAVED BY F22HAG  ON 88/05/24  AT 17:56
C     PARAMETER MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV,
     *               ITDLEN,IVDLEN,SP0,SP1,DFMASS,SFMUSC, SIGFCZ
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
C  NOTE (JEO 23.3.97) THAT ORIGINAL MVERTEX1 HAS SOME DIFFERENCE
C    SEE F22KLE.VERTEX.S  LIBRARY
      DIMENSION IT(2),IV(8)     ! PMF 26/08/99 IV(2) changed to IV(8)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CHEADR / HEAD(108)
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
     +             ,DUMMM(16),NTRRES,IW61
      COMMON / CVX    / NNPATR
      COMMON / CVCPV  / ICD, DFX, DFY, IRC, PTOTCT
      COMMON / CGVCDO / FLVCDO(20)
C
      DATA  ZDEEP / 5800.0 /, DER/ 20.0 /
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      JNDEX=INDEX
      IF(JNDEX.GT.7) JNDEX=JNDEX-4
C-----
      IF(JNDEX.GT.0.AND.JNDEX.LT.11) GO TO 2801
      IF(INDEX.GE.17.AND.INDEX.LE.19) GO TO 2801
      IF(INDEX.EQ.20) GO TO 2801
      RETURN
2801  IF(NNPATR.LE.0) GO TO 2701
      CALL CLOC(IPPATR,'PATR',NNPATR)
      IF(IPPATR.GT.0) GO TO 2702
      WRITE(6,2703) NNPATR
2703  FORMAT(' PATR BANK NR',I3,' (GIVEN BY COMMAND PATR) NOT EXISTING')
2701  IPPATR = IDATA(IBLN('PATR'))
2702  IPHEAD = IDATA(IBLN('HEAD'))
      IF(IPPATR.LE.0.OR.IPHEAD.LE.0) RETURN
      IPHWDS = IDATA(IBLN('HWDS'))
      IF(.NOT.FLVCDO(15) .OR. IPHWDS.LE.0) GOTO 2704
         IPPATR = IPHWDS
2704  NN = ACMD
      IF( NN .LT. 0  .AND.  LSTCMD .NE. 52 ) RETURN
      IF( NN .GT. 4  .AND.  LSTCMD .NE. 52 ) RETURN
      IF( NN .EQ. 4  .AND.  LSTCMD .NE. 52 ) GO TO 101
C---
C---   CALL VERTEX PROGRAM HERE
      CALL VTXPRE(IPHEAD,IPPATR)
      CALL VTXSRC
      CALL VTXAFT
C---
      IF(NV.GT.0) GO TO 101
      WRITE(6,102)
102   FORMAT('  NO VERTEX FOUND, ERROR RETURN ')
      RETURN
101   IF( LSTCMD .EQ. 52 ) GO TO 1000
C                                                       ************
C ENTER HERE FOR COMMAND VX, VERTEX POSITION DISPLAY    ***  VX  ***
C                                                       ************
      IF(NN.EQ.3) CALL VTXBNK(IPPATR)
      IF(NN.EQ.3) RETURN
      IF(NN.EQ.4) GO TO 4710
C  SET PRINT POSITION, IF NN.EQ.1
      call setcol('VTX ')  ! PMF 04/12/99: set color
      IF(NN.NE.1.OR.FL18) GO TO 110
      XXX = XMIN
      YYY = YMIN+.76*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,0)
      YYY = YYY - 9.*SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,220)! PMF 17/11/99: UNIT=10 changed to cHWORK
220   FORMAT(' VERTICES')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,9,0.)
110   CONTINUE
C  ADJUST THE DEVIATION DER
      DERV = DER
      IF( LASTVW .GE. 17  .AND.  LASTVW .LE. 19 ) DERV = .01*DER
C---   LOOP OVER VERTICES
      DO 111  INV = 1,NV
      INVP = (INV-1)*IVDLEN
      IF(INV.GT.1.AND.NN.EQ.0) GO TO 112
      IVFLAG = IV(INVP+1)
      IF(NN.EQ.2.AND.IVFLAG.NE.4) GO TO 111
      XV = V(INVP+2)
      YV = V(INVP+3)
      ZV = V(INVP+4)
      VX = -XV
      VY = YV
      IF(INDEX.GT.3.AND.INDEX.LT.8) VY = XV
      IF(INDEX.EQ.18) VY = XV
      IF(INDEX.GT.3.AND.INDEX.LT.14) VX = ZV
      IF(INDEX.EQ.18.OR.INDEX.EQ.19) VX = ZV
      IF(JNDEX.LT.4.OR.INDEX.EQ.17.OR.INDEX.EQ.20) GO TO 113
      RV = SQRT(XV*XV + YV*YV)
      FIV = 0.
      IF(RV.GT..001) FIV = ATAN2(YV,XV)
      IF(RV.GT..001.AND.FIV.LT.0.) FIV = FIV + TWOPI
      IF((.NOT.DSPDTL(9)).OR.DSPDTL(10)) GO TO 113
      IF(JNDEX.EQ.10) GO TO 113
      IF(RV.GT..001) RV=RV*WRAP(FIV)
      VY = RV
113   IF(JNDEX.NE.10) GO TO 114
CYLINDER VIEW, Z CORRECTION FOR PERSPECTIVE FACTOR
      ZETMX = ZLGPL + ZDEEP
      RV = RV*(ZDEEP - ZV)/ZETMX
      VX = -RV*COS(FIV)
      VY = RV*SIN(FIV)
114   CONTINUE
      CALL MOVEA(VX-DERV,VY-DERV)
      CALL DRAWA(VX+DERV,VY+DERV)
      CALL MOVEA(VX+DERV,VY-DERV)
      CALL DRAWA(VX-DERV,VY+DERV)
      IF(INV.GT.1) CALL TRNUMB(INV,0,-VX,VY,VZ)
C  TEXT SECTION
112   IF(NN.NE.1.OR.FL18) GO TO 111
      YYY = YYY - 2.*SSS
      NDF = 2*IV(INVP+8) - 3
      CALL CORE(HWORK,80)
      WRITE(cHWORK,219) INV,IV(INVP+1),IV(INVP+10),V(INVP+9),NDF! PMF 17/11/99: UNIT=10 changed to cHWORK
219   FORMAT(' ',I2,' FLAG',I2,' NTR ',I2,' CHI/NDF ',F6.2,'/',I2)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,35,0.)
      YYY = YYY - 1.5*SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,218) V(INVP+2),V(INVP+3),V(INVP+4)! PMF 17/11/99: UNIT=10 changed to cHWORK
218   FORMAT(' XYZ ',3F7.1)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,26,0.)
111   CONTINUE
      call setcol(' ') ! PMF 04/12/99: reset color
      RETURN
4710  CONTINUE
C
C RUN VERTEX DISPLAY
C
      IF(JNDEX.LT.4.OR.JNDEX.EQ.10) GO TO 1001
      IF(INDEX.EQ.17) GO TO 1001
      IF(INDEX.EQ.20) GO TO 1001
      CALL TRMOUT(80,' NOT AVAILABLE IN THIS VIEW...^')
      RETURN
1001  NRUN = HEAD(18)
      CALL VRTPOS(NRUN,VX,VY,rdummy) ! PMF 06/12/99: add dummy argument
      IF(JNDEX.NE.10) GO TO 1002
CYLINDER VIEW, Z CORRECTION FOR PERSPECTIVE FACTOR
      RV = SQRT(VX*VX + VY*VY)
      FIV = 0.
      IF(RV.GT..001) FIV = ATAN2(VY,VX)
      ZETMX = ZLGPL + ZDEEP
      ZV = 0.
      RV = RV*(ZDEEP - ZV)/ZETMX
      VX = RV*COS(FIV)
      VY = RV*SIN(FIV)
1002  CALL MOVEA(-VX-DERV,VY-DERV)
      CALL DRAWA(-VX+DERV,VY+DERV)
      CALL MOVEA(-VX+DERV,VY-DERV)
      CALL DRAWA(-VX-DERV,VY+DERV)
      RETURN
1000  CONTINUE
C                                                       ************
C ENTER HERE FOR COMMAND VRES, VERTEX RESULTS DISPLAY   *** VRES ***
C                                                       ************
      IPO = IPPATR
      LO = IDATA(IPO+1)
      NBK = IDATA(IPO-2)
      NTR = IDATA(IPO+2)
      IF(NTR.LE.0) GO TO 1161
      IF(NTR.LE.50) GO TO 1010
         CALL TRMOUT(80,' MORE THAN 50 TRACKS! "VRES" NOT POSSIBLE.^')
         GOTO 1161
 1010 LTR = IDATA(IPO+3)
      call setcol('TRCK') ! PMF 04/12/99: set color
      IPO = IPO + LO - LTR
      IQO = IPO
      IFIELD  = HEAD(38)
      AH03 = 3.000E-8*FLOAT(IABS(IFIELD))
      DSPD14 = DSPDTL(14)
      DSPDTL(14) = .TRUE.
      IW61 = 0
      IF(ACMD.EQ.0) IW61 = 1
      IF(DSPDTL(29)) GO TO 2100
C---------------------------------- LOOP OVER TRACKS -----
      DO 2102  J = 1,NTR
      IPNOT = (J-1)*ITDLEN
      IQO = IQO+LTR
      ITR = IDATA(IQO + 1)
      IF(NN.GT.0.AND.NN.NE.ITR) GO TO 2102
      IF(NN.LT.0.AND.IABS(NN).NE.IT(IPNOT+14)) GO TO 2102
      IF(IT(IPNOT+1).LE.0) GO TO 2102
      NRV = IT(IPNOT+14)
      IPNRV = (NRV-1)*IVDLEN
      VXE = V(IPNRV+2)
      VYE = V(IPNRV+3)
      VZE = V(IPNRV+4)
      IF(JNDEX.GT.3.AND.JNDEX.LT.10) GO TO 2002
      IF(INDEX.EQ.18.OR.INDEX.EQ.19) GO TO 2002
C--                         RFI-VIEW OF INNER DETECTOR
C---                        **************************
      ICD  = IDATA(IQO + 2)
      DFX  = ADATA(IQO + 8)
      DFY  = ADATA(IQO + 9)
      IRC  = -100
      IF( ICD .EQ. 301 ) ICD = 65536
      IF( TBIT(ICD,19) .AND. LTR .EQ. 64 ) ICD = IBITON(ICD,15)
      IF( TBIT(ICD,15) .AND. LTR .GE. 64 ) IRC = IDATA(IQO + 62)
      CRV  = ADATA(IQO + 25)
      CST  = 1./SQRT(1.+ADATA(IQO+30)**2)
      PTOT = ABS(AH03/(CRV*CST))
      IF( FLVCDO(9) .AND. PTOT.LT.PTOTCT ) GOTO 2102
      IF( FLVCDO(9) .AND. PTOTCT.LT.0.0 .AND.
     *    ((TBIT(ICD,15) .AND. IRC.NE.0 ).OR.
     *     .NOT.TBIT(ICD,15)) ) GOTO 2102
C** DISPLAY TRACKS
      ITYPLI = IDATA(IQO+29)
C                     PARABOLA FITS
C     IF(IDATA(IQO+18).NE.1.AND.ITYPLI.EQ.1)
      IF(IDATA(IQO+18).NE.1)
     $ CALL PARDIS(25,ADATA(IQO+19),ADATA(IQO+20),ADATA(IQO+21),
     $ ADATA(IQO+22),ADATA(IQO+5),ADATA(IQO+6),ADATA(IQO+12),
     $ ADATA(IQO+13),ADATA(IQO+31),ADATA(IQO+30),VXE,VYE)
C                     CIRCLE FITS
      IF(IDATA(IQO+18).EQ.1.AND.(ITYPLI.EQ.1.OR.ITYPLI.EQ.2))
     $ CALL CIRDIS(25,SIGN(ADATA(IQO+19),ADATA(IQO+25)),
     $ ADATA(IQO+20),ADATA(IQO+21),
     $ ADATA(IQO+5),ADATA(IQO+6),ADATA(IQO+12),ADATA(IQO+13),
     $ ADATA(IQO+31),ADATA(IQO+30),ITYPLI,VXE,VYE)
C** WRITE TRACK NUMBER
C     CALL TRNUMB(ITR,0,ADATA(IQO+12),ADATA(IQO+13),ADATA(IQO+14))
      IF(JNDEX.NE.3) GO TO 2172
C--                         RFI-VIEW OF MU-CHAMBERS
C--                         ***********************
      REMEMB = DSPDTL(8)
      REMEMC = DSPDTL(9)
      DSPDTL(8) = .FALSE.
      DSPDTL(9) = .FALSE.
C MUON RESULTS TO BE CALLED HERE
      DSPDTL(8) = REMEMB
      DSPDTL(9) = REMEMC
      GO TO 2172
2002  IF(JNDEX.GT.7.AND.INDEX.NE.18.AND.INDEX.NE.19) GO TO 2102
C--                         XZ OR YZ-VIEW OF INNER DETECTOR
C--                         *******************************
C** DISPLAY TRACKS
C                     LINE FITS
      ITYPLI = IDATA(IQO+29)
C **MODIFY TO DRAW HELIX FIT RESULT    J.S. 16/4/87
      ACURXY=ABS(ADATA(IQO+25))
      LLLL=0
      IF(ACURXY.GT.1.E-4) LLLL=1
      IF(ITYPLI.EQ.2.AND.LLLL.EQ.1)
     +CALL HELDIS(ITR,INDEX,ADATA(IQO+5),ADATA(IQO+6),ADATA(IQO+7),
     +ADATA(IQO+12),ADATA(IQO+13),ADATA(IQO+14),ADATA(IQO+25))
      IF(ITYPLI.EQ.1.OR.ITYPLI.EQ.2.AND.LLLL.EQ.0)
     +CALL LINDIS(IQO,INDEX,VXE,VYE,VZE)
C ** END MODIFICATION
      IF(JNDEX.GT.5.AND.INDEX.NE.18.AND.INDEX.NE.19) GO TO 2004
      GO TO 2172
2004  CONTINUE
C                           YZ-VIEW OF MU-CHAMBERS
C                           **********************
C MUON RESULTS TO BE CALLED HERE
2172  IF(ACMD.EQ.0.) GO TO 2102
      ACMDR = ACMD
      ACMD = FLOAT(ITR)
      NTRRES = ITR
      IF(.NOT.FL18) CALL BANKLS(INDEX,IPPATR)
      ACMD = ACMDR
2102  CONTINUE
2100  CONTINUE
      NTRRES = 0
      IF(.NOT.FL18.AND.ACMD.EQ.0.) CALL BANKLS(INDEX,IPPATR)
1161  VXG = 0.
      VYG = 0.
      VZG = 0.
      IF(NTR.LE.0 .OR. NTR.GT.50 .OR. IV(1).EQ.4) GO TO 1920
C IF TRACKS EXIST, USE MAIN VERTEX FOR PHOTON ORIGEN
      VXG = V(2)
      VYG = V(3)
      VZG = V(4)
1920  IF((DSPDTL(28).OR.DSPDTL(29)).AND.(NN.EQ.0.OR.NN.EQ.-1))
     $ CALL GAMDIS(INDEX,VXG,VYG,VZG)
      DSPDTL(14) = DSPD14
      RETURN
      call setcol(' ') ! PMF 04/12/99: reset color
      END

C   28/11/79 001251642  MEMBER NAME  TRACK    (JADESR)      FORTRAN
      SUBROUTINE TRACK(IP,ITP,RMIN,NHT,FI,THETA,PTOT,PT,PL,PX,PY,PZ)
C---
C---     RETURNS VARIOUS TRACK PARAMETERS FOR A SINGLE TRACK
C---
C---     IP IS ADRESS IN PATR OR LGCL BANKS
C---     ITP = 0  ---> GAMMA
C---     ITP = 1  ---> CHARGED TRACK
C---     ALL UNITS IN MM,RAD,GEV
C---                                    J.OLSSON  28.11.79
C---            LATEST CHANGE  18.12.79
C---
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CJTRIG/ PI,TWOPI
      COMMON /CHEADR/ HEAD(108)
      DATA HERR/0/
C--
      IF(ITP.EQ.0) GO TO 1000
C                                             >>>>> CHARGED TRACK <<<<<<
      NHT = IDATA(IP+24)
      IF(IDATA(IP+33).GT.NHT) NHT = IDATA(IP+33)
      CALL MOMENT(IP,PX,PY,PZ,PT,PTOT,FI,THETA)
      CALL PARMIN(ADATA(IP+19),ADATA(IP+20),ADATA(IP+21),
     $ ADATA(IP+22),RMIN,IDATA(IP+18))
999   IF(ABS(PTOT).LT.ABS(PT)) HERR = HERR + 1
      IF(ABS(PTOT).LT.ABS(PT).AND.HERR.LT.10)
     $ WRITE(6,7575) HEAD(18),HEAD(19),
     $ IP,NHT,PX,PY,PZ,PT,PTOT,FI,THETA
7575  FORMAT(' R * EV.',2I6,' IP NHT ',2I6,' PX-Z,PT PTOT',5E11.3,' FI *
     $TH ',2F8.3)
      PL = PTOT*PTOT - PT*PT + .000001
      IF(PL.LE.0.000001) GO TO 9977
      PL = SQRT(PL)
      IF(THETA.GT.PI*.5) PL = - PL
      GO TO 9999
9977  PL = 0.
      GO TO 9999
C                                                  >>>>> PHOTON <<<<<
1000  RMIN = 0.
      NHT = 0
      CALL MOMGAM(IP,PX,PY,PZ,PT,PTOT,FI,THETA)
      GO TO 999
9999  RETURN
      END

      SUBROUTINE PATRC1(IDRENT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cheadr.for"
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
     ,         , (ITR   ,IDWRK(7)),(ITRNG ,IDWRK(8))
#include "cpatlm.for"
      COMMON /CLBPGM/ LBPGM(30)
      DIMENSION HEARR(30)
      DATA HPS /2HPS/
      DATA PATR /'PATR'/, LHEAD,LTRBK /8,48/
      DATA JHTL /'JHTL'/
      DATA JETC /'JETC'/
 2009 FORMAT('0CHANGE OF POINTERS:',10I8)
 2991 FORMAT('0/BCS/ TOO SHORT FOR TRACK BANK; EVENT:',3I6,
     ,       ', IRET=',I2,',NTR,LENGTH=',I3,1X,I4)
 2992 FORMAT('0/CWORK/ TOO SHORT FOR PATREC; EVENT:',3I6)
 2993 FORMAT('0/BCS/ TOO SHORT FOR PATREC; EVENT:',3I6,' ,IERR=',I2)
 2994 FORMAT('0WRONG POINTER IN JETC-BANK; EVENT:',3I6,' ,POINTER:',
     ,        (/,1X,24I5))
      NTR = 0
      IPJETC = IDATA(IBLN(JETC))
      IF(
     - IPJETC.LE.0
     -)THEN
        IPPATR = IDATA(IBLN(PATR))
      IF(
     - IPPATR.LE.0
     -)THEN
          NBNK = 10
          IZW = LHEAD
          CALL CCRE(IPPATR,PATR,NBNK,IZW,IERR)
          IF(IERR.NE.0) RETURN
          CALL BSAW(1,PATR)
          IDATA(IPPATR+1) = LHEAD
          IDATA(IPPATR+3) = LTRBK
      ENDIF
        RETURN
      ENDIF
      NHITJC = HDATA(IPJETC*2+99) / 4
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      HPFREE = 1
      HPLAST = LMPATR(5)
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - IERRFL.NE.0
     -)THEN
        I1 = IPJCA2 + 1
        I9 = I1 + 97
        WRITE(6,2994) HHEADR(17),HHEADR(18),HHEADR(19),
     ,                (HDATA(I),I=I1,I9)
        CALL BDLS(PATR,NBNK)
        CALL BDLS(JHTL,NBNK)
        RETURN
      ENDIF
      IF(
     - (HPFREE+NHITJC+96*12+10*17 - 1).LT.LMPATR(5)
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ELSE
        WRITE(6,2992) HHEADR(17),HHEADR(18),HHEADR(19)
        CALL BDLS(PATR,NBNK)
        CALL BDLS(JHTL,NBNK)
        RETURN
      ENDIF
      HPFRE0 = HPFREE
      HPRO = HPS
      ITR = 1
      IRINGO = 0
      JCELL=0
16000 CONTINUE
        JCELL = JCELL + 1
        HNTCEL(JCELL) = ITR
        MHIT = (HPTSEC(JCELL+1)-HPTSEC(JCELL)) / 4
      IF(
     - MHIT.GE.5
     -)THEN
          IRING = 3
          IF(JCELL.LE.48) IRING = 2
          IF(JCELL.LE.24) IRING = 1
      IF(
     - IRING.NE.IRINGO
     -)THEN
            IRINGO = IRING
            ITRNG = 1
      ENDIF
          ICELL = JCELL
          IERRCD = 0
          HPFREE = HPFRE0
          CALL SRTREL
      ENDIF
      IF(.NOT.(
     - JCELL.EQ.96
     -))GOTO 16000
16001 CONTINUE
      HNTCEL(97) = ITR
      HNTR = ITR - 1
      HPFREE = HPFRE0
      NTR = 0
      IF(HNTR.GT.0) CALL BACKTR(0,0)
      IF(
     - NTR.GT.0
     -)THEN
          LENGTR =(NTR+10)*LTRBK
          CALL BCHM(IPPATR,LENGTR,IRET)
      IF(
     - IRET.NE.0
     -)THEN
            WRITE(6,2991) HHEADR(17),HHEADR(18),HHEADR(19),
     ,                    IRET,NTR,LENGTR
            NTR = 0
            CALL BDLS(PATR,NBNK)
            CALL BDLS(JHTL,NBNK)
            RETURN
      ENDIF
          IPJETC = IDATA(IBLN(JETC))
          IP0 = IPJETC*2 + 101
      IF(
     - IP0.NE.HPTSEC(1)
     -)THEN
            PRINT 2009, IPJETC,IP0,HPTSEC(1)
      ASSIGN 17006 TO IZZZ02
      GOTO 17002
17006 CONTINUE
      ENDIF
      ENDIF
      RETURN
17000 CONTINUE
        IPJHTL = IDATA(IBLN(JHTL))
        IPPATR = IDATA(IBLN(PATR))
        NBKPAT = 10
        IF(IPPATR.GT.0) NBKPAT = IDATA(IPPATR-2) - 1
        NBKHTL = 10
        IF(IPJHTL.GT.0) NBKHTL = IDATA(IPJHTL-2) - 1
        NBNK = MIN0(10,NBKPAT,NBKHTL)
      IF(
     - IPJHTL.EQ.0 .OR. IDRENT.EQ.0
     -)THEN
          IZW = NHITJC + 1
          CALL CCRE(IPJHTL,JHTL,NBNK,IZW,IERR)
          LBRHTL = 0
          IF(IERR.NE.0) LBRHTL = 1
      ENDIF
      IF(
     - IPPATR.EQ.0 .OR. IDRENT.EQ.0
     -)THEN
          IZW = LHEAD
          CALL CCRE(IPPATR,PATR,NBNK,IZW,IERR)
      IF(
     - IERR.NE.0 .OR. LBRHTL.NE.0
     -)THEN
            WRITE(6,2993) HHEADR(17),HHEADR(18),HHEADR(19),IERR
            CALL BDLS(PATR,NBNK)
            CALL BDLS(JHTL,NBNK)
            RETURN
      ENDIF
          CALL BSAW(1,PATR)
          CALL BSAW(1,JHTL)
          IDATA(IPPATR+1) = LHEAD
          IDATA(IPPATR+2) = 0
          IDATA(IPPATR+3) = LTRBK
          IDATA(IPPATR+4) = IDATA(IPJHTL-2)
          IDATA(IPPATR+5) = NHITJC
          IDATA(IPPATR+6) = NHITJC
          IDATA(IPPATR+7) = NHITJC
          IDATA(IPPATR+8) = 0
      ELSE
          CALL CMVE(IPPATR,IERR)
      ENDIF
      GOTO IZZZ01
17002 CONTINUE
      IPJCA2 = IPJETC*2 + 2
      IP0 = IPJCA2 + 98
      IERRFL = 0
      IPCLL = IPJCA2
      DO 13000 ICLL=1,96
        IPCLL = IPCLL + 1
        HPTSEC(ICLL) = HDATA(IPCLL) + IP0
        IF(HDATA(IPCLL+1).LT.HDATA(IPCLL)) IERRFL = 1
13000 CONTINUE
13001 CONTINUE
      HPTSEC(97) = HDATA(IPCLL+1) + IP0
      HPTSEC(98) = 0
      GOTO IZZZ02
17004 CONTINUE
      HPHL0 = HPFREE*2 - 1
      HLDHL = NHITJC*2
      HPHL9 = HPHL0 + HLDHL - 1
      NBYTHT = HLDHL*2
      ZERO = 0
      CALL SETSL(HWRK(HPHL0),0,NBYTHT,ZERO)
      HPFREE = HPFREE + NHITJC
      GOTO IZZZ03
      END

C 31938  MEMBER NAME  JEOSUM3  (GRAFIX.S)    SHELTRAN
C Copyright Stanford  Mortran3.1   (FORTRAN 66 11JUN85)
      SUBROUTINE DISAXI
      IMPLICIT INTEGER*2 (H)
      LOGICAL FLVCDO
      LOGICAL LSETAX
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C   23/03/97 703231948  MEMBER NAME  MVERTEX0 (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVERTEX0       SAVED BY F22HAG  ON 88/05/24  AT 17:56
C     PARAMETER MACRO FOR VERTEX-FIT ROUTINES                           00000000
C01 MAY 80)    DISAXI    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.55.23       PAGE   2
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,     00000100
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,      00000200
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,    00000300
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV,                00000400
     *               ITDLEN,IVDLEN,SP0,SP1,DFMASS,SFMUSC, SIGFCZ        00000500
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )             00000100
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)                     00000200
C                                                                       00000300
C   NOTE (JEO 23.3.97)  THAT HVTXST HAS DIM. 140 ON F22KLE.VERTEX.S LIB 00000310
      DIMENSION IVTXST(1)                                               00000400
C                                                                       00000500
C   23/03/97 703231949  MEMBER NAME  MTRINF   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MTRINF         SAVED BY F22HAG  ON 87/04/03  AT 18:35
C
C     -------------- GENERALL TRACK-INFO COMMON -------------------
      DIMENSION IP(10,400)
      COMMON // P(10,400)
      EQUIVALENCE(IP(1,1),P(1,1))
C
      DIMENSION IPE(10,400)
      COMMON /CTRCK0 / NTCH,NTALL,PE(10,400),INDTRK(400),ITRFLG(400)
      EQUIVALENCE(IPE(1,1),PE(1,1))
C
      COMMON / CGVCDO / FLVCDO(20)
      COMMON / CHEADR / HEAD(108)
      COMMON / CVX / NNPATR, NDUMM, NNJETC, NNVTXC
      DIMENSION IDUM(20),PSAVE(4,60)
      DIMENSION HDM(5,6),HDL(5,2),HB1(5,8),HB2(5,8),HB3(5,12),HB4(5,10)
      DIMENSION HC(5)
      DATA HDM / 'D0','  ','  ','  ','  ', 'D0',' b','ar','  ','  ', 'D+
     *','  ','  ','  ','  ', 'D-','  ','  ','  ','  ', 'Ds','+ ','  ','
     * ','  ', 'Ds','- ','  ','  ','  ' /
      DATA HDL / 'La','mc','  ','  ',' +', 'La','mc',' b','ar',' -' /
      DATA HB1 / 'bu','(b','ar',') ','- ', 'b(','ba','r)','u ','+ ', 'bd
     *','(b','ar',') ','0 ', 'b(','ba','r)','d ','0 ', 'bs','(b','ar',')
     * ','0 ', 'b(','ba','r)','s ','0 ', 'bc','(b','ar',') ','- ', 'b(',
     *'ba','r)','c ','+ ' /
      DATA HB2 / 'bu','u1','  ','  ',' +', 'bu','u1',' b','ar',' -', 'bd
     *','u1','  ','  ',' 0', 'bd','u1',' b','ar',' 0', 'bd','d1','  ','
     * ',' -', 'bd','d1',' b','ar',' +', 'bs','u1','  ','  ',' 0', 'bs',
     *'u1',' b','ar',' 0' /
      DATA HB3 / 'bd','u0','  ','  ',' 0', 'bd','u0',' b','ar',' 0', 'bs
     *','u0','  ','  ',' 0', 'bs','u0',' b','ar',' 0', 'bs','d0','  ','
     * ',' -', 'bs','d0',' b','ar',' +', 'bc','u0','  ','  ',' +', 'bc',
     *'u0',' b','ar',' -', 'bc','d0','  ','  ',' 0', 'bc','d0',' b','ar'
     *,' 0', 'bc','s0','  ','  ',' 0', 'bc','s0',' b','ar',' 0' /
      DATA HB4 / 'bu','u*','  ','  ',' +', 'bu','u*',' b','ar',' -', 'bd
     *','u*','  ','  ',' 0', 'bd','u*',' b','ar',' 0', 'bd','d*','  ','
     * ',' -', 'bd','d*',' b','ar',' +', 'bs','u*','  ','  ',' 0', 'bs',
     *'u*',' b','ar',' 0', 'bs','d*','  ','  ',' -', 'bs','d*',' b','ar'
     *,' +' /
      IF  ((LASTVW.GT.4).AND.((LASTVW.NE.17).AND.(LASTVW.NE.20))) GO TO
     *20
      N = IFIX(ACMD)
      JMODE = N
      IF((N .GT. 0 .AND. N .LT. 6))GOTO 30
40    CONTINUE
      CALL TRMOUT(80,'ENTER MODE :^')
      CALL TRMOUT(80,'1 = Tau-fligth-direction^')
C01 MAY 80)    DISAXI    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.55.23       PAGE   3
      CALL TRMOUT(80,'2 = Sphericity axis^')
      CALL TRMOUT(80,'3 = Thrust axis^')
      CALL TRMOUT(80,'4 = Calculate impact-parameter^')
      CALL TRMOUT(80,'5 = Display C- or- B-hadron flight direction^')
      CALL FYRINT(JMODE,ID2,ID3,ID4)
30    CONTINUE
      IF((JMODE .LT. 1 .OR. JMODE .GT. 5))GOTO 40
      IF  (JMODE.NE.1) GO TO 60
      LSETAX = .FALSE.
      IPTTOP = IDATA(IBLN('TTOP'))
      IF  (IPTTOP.GT.0) GO TO 80
      CALL TRMOUT(80,' TTOP-bank not existing^')
      GOTO 90
80    CONTINUE
      LSETAX = .TRUE.
      XF3 = 0.5*(ADATA(IPTTOP+1) - ADATA(IPTTOP+16))
      YF3 = 0.5*(ADATA(IPTTOP+2) - ADATA(IPTTOP+17))
      ZF3 = 0.5*(ADATA(IPTTOP+3) - ADATA(IPTTOP+18))
      RF2 = SQRT(XF3**2 + YF3**2)
      XRV = 0.0
      YRV = 0.0
      DXR = 0.0
      DYR = 0.0
      IF  (.NOT.(FLVCDO(12))) GO TO 110
      CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) ! PMF 08/11/99: add run argument HEAD(18)
110   CONTINUE
      CALL SETTAX( XRV, YRV, DXR, DYR, XF3, YF3, ZF3 )
      IF  (RF2.LE.0.0) GO TO 130
      GOTO 140
130   CONTINUE
      GO TO 50
60    IF(JMODE.NE.2)GO TO 150
      LSETAX = .FALSE.
      CALL CLOC(IPPATR,'PATR',NNPATR)
      IPHWDS = IDATA(IBLN('HWDS'))
      IF((FLVCDO(15) .AND. IPHWDS .GT. 0))IPPATR = IPHWDS
      CALL TRN4V(0,IPPATR,1,20,NCONT,IDUM,IERR)
      IF  (IERR.EQ.0) GO TO 170
      CALL TRMOUT(80,'Select PATR-bank first !^')
      GOTO 90
170   CONTINUE
      NTRK = IDATA(IPPATR+2)
      LSETAX = .TRUE.
      WRITE(6,180)
180   FORMAT(' Enter number of track which should be omitted in SPHERIC'
     * ,'ITY calculation : (or press only )')
190   CONTINUE
      CALL TRMIN( 4, ICD )
      CALL GETINT( ICD, ITRK )
      IF((ITRK .GE. 0 .AND. ITRK .LE. NTRK))GOTO 200
      CALL TRMOUT(80,' Track number invalid!  Enter new number!^')
      GOTO 190
200   CONTINUE
      IF  (ITRK.LE.0) GO TO 220
      IPOSAR = INDTRK(ITRK)
      IF  (IPOSAR.LE.0.OR.IPOSAR.GT.60) GO TO 240
      DO 251 J=1,4
      PSAVE(J,IPOSAR) = P(J,IPOSAR)
      P(J,IPOSAR) = 0.0
C01 MAY 80)    DISAXI    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.55.23       PAGE   4
251   CONTINUE
252   CONTINUE
240   CONTINUE
220   CONTINUE
      NH = NTALL
      NSPH = NTALL + 1
      CALL SPTHAK(1,NH,0,THR,NSPH,SPHR,0,AKO,IER )
      IF  (ITRK.LE.0) GO TO 270
      DO 281 J=1,4
      P(J,IPOSAR) = PSAVE(J,IPOSAR)
281   CONTINUE
282   CONTINUE
270   CONTINUE
      XF3 = P(1,NSPH)
      YF3 = P(2,NSPH)
      ZF3 = P(3,NSPH)
      WRITE(6,290)XF3,YF3,ZF3
290   FORMAT(' SPHERICITY : ',3F8.3)
      RF2 = SQRT(XF3**2 + YF3**2)
      XRV = 0.0
      YRV = 0.0
      DXR = 0.0
      DYR = 0.0
      IF  (.NOT.(FLVCDO(12))) GO TO 310
      CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) ! PMF 08/11/99: add run argument HEAD(18)
310   CONTINUE
      MODE = 1
      TAXIS(1) = XRV
      TAXIS(2) = YRV
      TAXIS(3) = 0.0
      TAXIS(4) = DXR
      TAXIS(5) = DYR
      TAXIS(6) = 10000.0
      TAXIS(7) = XF3
      TAXIS(8) = YF3
      TAXIS(9) = ZF3
      TAXIS(10) = 0.0
      TAXIS(11) = 0.0
      TAXIS(12) = 0.0
      IDC = 23
      IF  (RF2.LE.0.0) GO TO 330
      GOTO 140
330   CONTINUE
      GO TO 50
150   IF(JMODE.NE.3)GO TO 340
      LSETAX = .FALSE.
      CALL CLOC(IPPATR,'PATR',NNPATR)
      IPHWDS = IDATA(IBLN('HWDS'))
      IF((FLVCDO(15) .AND. IPHWDS .GT. 0))IPPATR = IPHWDS
      CALL TRN4V(0,IPPATR,1,20,NCONT,IDUM,IERR)
      IF  (IERR.EQ.0) GO TO 360
      CALL TRMOUT(80,'Select PATR-bank first !^')
      GOTO 90
360   CONTINUE
      NTRK = IDATA(IPPATR+2)
      LSETAX = .TRUE.
      WRITE(6,370)
370   FORMAT(' Enter number of track which should be omitted in THRUST '
     * ,'calculation : (or press only )')
C01 MAY 80)    DISAXI    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.55.23       PAGE   5
380   CONTINUE
      CALL TRMIN( 4, ICD )
      CALL GETINT( ICD, ITRK )
      IF((ITRK .GE. 0 .AND. ITRK .LE. NTRK))GOTO 390
      CALL TRMOUT(80,' Track number invalid!  Enter new number!^')
      GOTO 380
390   CONTINUE
      IF  (ITRK.LE.0) GO TO 410
      IPOSAR = INDTRK(ITRK)
      IF  (IPOSAR.LE.0.OR.IPOSAR.GT.60) GO TO 430
      DO 441 J=1,4
      PSAVE(J,IPOSAR) = P(J,IPOSAR)
      P(J,IPOSAR) = 0.0
441   CONTINUE
442   CONTINUE
430   CONTINUE
410   CONTINUE
      NH = NTALL
      NH4 = NH+4
      CALL SPTHAK(1,NH,NH4,THR,0,SPHR,0,AKO,IER )
      IF  (ITRK.LE.0) GO TO 460
      DO 471 J=1,4
      P(J,IPOSAR) = PSAVE(J,IPOSAR)
471   CONTINUE
472   CONTINUE
460   CONTINUE
      XF3 = P(1,NH4)
      YF3 = P(2,NH4)
      ZF3 = P(3,NH4)
      WRITE(6,480)XF3,YF3,ZF3
480   FORMAT(' THRUST : ',3F8.3)
      RF2 = SQRT(XF3**2 + YF3**2)
      XRV = 0.0
      YRV = 0.0
      DXR = 0.0
      DYR = 0.0
      IF  (.NOT.(FLVCDO(12))) GO TO 500
      CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) ! PMF 08/11/99: add run argument HEAD(18)
500   CONTINUE
      MODE = 1
      TAXIS(1) = XRV
      TAXIS(2) = YRV
      TAXIS(3) = 0.0
      TAXIS(4) = DXR
      TAXIS(5) = DYR
      TAXIS(6) = 10000.0
      TAXIS(7) = XF3
      TAXIS(8) = YF3
      TAXIS(9) = ZF3
      TAXIS(10) = 0.0
      TAXIS(11) = 0.0
      TAXIS(12) = 0.0
      IDC = 1234
      IF  (RF2.LE.0.0) GO TO 520
      GOTO 140
520   CONTINUE
      GO TO 50
340   IF(JMODE.NE.4)GO TO 530
      IF  (.NOT.(.NOT. LSETAX)) GO TO 550
C01 MAY 80)    DISAXI    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.55.23       PAGE   6
      CALL TRMOUT(80, ' Axis is NOT set! Type DAX without argument.^')
      GOTO 90
550   CONTINUE
      CALL VTXINI
      IH = IDATA(IBLN('HEAD'))
      CALL CLOC(IPO,'PATR',NNPATR)
      IPHWDS = IDATA(IBLN('HWDS'))
      IF((FLVCDO(15) .AND. IPHWDS .GT. 0))IPO = IPHWDS
      IF((IPO .LE. 0))GOTO 90
      NTRK = IDATA(IPO+2)
      CALL VTXPRE(IH,IPO)
      CALL TRMOUT(80, ' Enter track number for impact-parameter calculat
     *ion :^')
560   CONTINUE
      CALL TRMIN( 4, ICD )
      CALL GETINT( ICD, ITRK )
      IF((ITRK .GT. 0 .AND. ITRK .LE. NTRK))GOTO 570
      CALL TRMOUT(80,' Track number invalid!  Enter new number!^')
      GOTO 560
570   CONTINUE
      CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) ! PMF 08/11/99: add run argument HEAD(18)
      J = (ITRK-1)*ITDLEN
      CALL VTXIMP(J,XRV,YRV,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,DPHIT,ST, TAXIS
     *(7),TAXIS(8),AIMP)
      CALL MOVEA( -XRV, YRV )
      CALL DRAWA( -XT , YT )
      IPOSAR = INDTRK(ITRK)
      IF  (IPOSAR.LE.0) GO TO 590
      RNORM = SQRT((TAXIS(7)**2 + TAXIS(8)**2)* (P(1,IPOSAR)**2 + P(2,IP
     *OSAR)**2))
      IF  (RNORM.LE.0.0) GO TO 610
      COSTRK = (P(1,IPOSAR)*TAXIS(7) + P(2,IPOSAR)*TAXIS(8))/RNORM
610   CONTINUE
      IF((COSTRK .LT. 0.0))AIMP = -AIMP
590   CONTINUE
      WRITE(6,620)ITRK,AIMP
620   FORMAT(' Impact-parameter for track',I3,' is :',F9.3)
      GO TO 50
530   IF(JMODE.NE.5)GO TO 630
      IF  (HEAD(18).LE.100) GO TO 650
      CALL TRMOUT(80,' DAX 5 not available for real data!^')
      GOTO 90
650   CONTINUE
      IPPALL = IDATA(IBLN('PALL'))
      IF((IPPALL .LE. 0))GOTO 90
      IFL = IDATA(IPPALL+9)
      IF((IFL .NE. 4 .AND. IFL .NE. 5))GOTO 90
      LPHEAD = IDATA(IPPALL+1)
      LPINF = IDATA(IPPALL+2)
      NPPAR = IDATA(IPPALL+4)
      DO 661 J=1,NPPAR
      IPPL = IPPALL + LPHEAD + (J-1)*LPINF
      ITYS = IDATA(IPPL+7)
      ITYP = IABS(ITYS)
*** PMF 06/12/99: transform my code numbers for particles into
*** JETSET 6.3 CODE + 1000
      if(ityp.ge.100000) ityp=ityp-100000
*** PMF(end)
      IF((((ITYP.LT.1101 .OR. ITYP.GT.1104) .AND. (ITYP.LT.1145 .OR. ITY
     *P.GT.1148) .AND. (ITYP.LT.1241 .OR. ITYP.GT.1246) .AND. (ITYP.LT.1
     *293 .OR. ITYP.GT.1297)) .AND. IFL.EQ.5))GO TO661
      IF(((ITYP.LT.1020 .OR. ITYP.GT.1022) .AND. ITYP.NE.1058 .AND. IFL.
     *EQ.4))GO TO661
C01 MAY 80)    DISAXI    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.55.23       PAGE   7
      PX = ADATA(IPPL+1)
      PY = ADATA(IPPL+2)
      P2 = SQRT(PX**2+PY**2)
      EX = PX/P2
      EY = PY/P2
      CALL MOVEA(0.0,0.0)
      XE = -EX*5.50*16. !PMF 06/12/99: append factor 16.0
      YE = EY*5.50*16. !PMF 06/12/99: append factor 16.0
      CALL DRAWA(XE,YE)
      CALL MOVEA(XE+0.02,YE+0.02)
      CALL CHRSIZ(4)
      IF  (IFL.NE.4) GO TO 680
      IF  (ITYP.NE.1058) GO TO 700
      IA = 1
      IF((ITYS .LT. 0))IA = 2
      DO 711 K=1,5
      HC(K) = HDL(K,IA)
711   CONTINUE
712   CONTINUE
      GO TO 690
700   CONTINUE
      IA = 2*(ITYP-1020) + 1
      IF((ITYS .LT. 0))IA = IA + 1
      DO 721 K=1,5
      HC(K) = HDM(K,IA)
721   CONTINUE
722   CONTINUE
690   CONTINUE
      GO TO 670
680   CONTINUE
      IF  (ITYP.LT.1101.OR.ITYP.GT.1104) GO TO 740
      IA = 2*(ITYP-1101) + 1
      IF((ITYS .LT. 0))IA = IA + 1
      DO 751 K=1,5
      HC(K) = HB1(K,IA)
751   CONTINUE
752   CONTINUE
      GO TO 730
740   IF(ITYP.LT.1145.OR.ITYP.GT.1148)GO TO 760
      IA = 2*(ITYP-1145) + 1
      IF((ITYS .LT. 0))IA = IA + 1
      DO 771 K=1,5
      HC(K) = HB2(K,IA)
771   CONTINUE
772   CONTINUE
      GO TO 730
760   IF(ITYP.LT.1241.OR.ITYP.GT.1246)GO TO 780
      IA = 2*(ITYP-1241) + 1
      IF((ITYS .LT. 0))IA = IA + 1
      DO 791 K=1,5
      HC(K) = HB3(K,IA)
791   CONTINUE
792   CONTINUE
      GO TO 730
780   IF(ITYP.LT.1293.OR.ITYP.GT.1297)GO TO 800
      IA = 2*(ITYP-1293) + 1
      IF((ITYS .LT. 0))IA = IA + 1
      DO 811 K=1,5
      HC(K) = HB4(K,IA)
C01 MAY 80)    DISAXI    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.55.23       PAGE   8
811   CONTINUE
812   CONTINUE
730   CONTINUE
800   CONTINUE
670   CONTINUE
      CALL EOUTST(10,HC)
661   CONTINUE
662   CONTINUE
50    CONTINUE
630   CONTINUE
      GOTO 90
140   CONTINUE
      XF2 = XF3/RF2
      YF2 = YF3/RF2
      RAB = RTOF - 50.0
      IF((LASTVW .EQ. 17))RAB = 6.0
      IF((LASTVW .EQ. 20))RAB = RITNK + 110.0
      XX = RAB*XF2
      YY = RAB*YF2
      CALL MOVEA( -XX-XRV, YY+YRV )
      CALL DASHA( XX-XRV, -YY+YRV, IDC )
20    CONTINUE
90    CONTINUE
      RETURN
      END

C   12/10/78 C9022601   MEMBER NAME  MASS2G   (LGSOURCE)    FORTRAN
      SUBROUTINE MASS2G
C
C     S.YAMADA   12-10-78   9:45
C     LAST MODIFICATION  16-10-78  08:55
C
C---- PLOT INVARIANT MASSES OF GAMMA PAIRS
C
      IMPLICIT INTEGER *2 (H)
C
C**** COMMON /CLGCLS/ NCLST,NCLBEC(3),HCLMAP(52),CLSPRP(10,51)
#include "cwork.for"
      DATA EMIN/0.04/, EMAX/2.0/
C
      IF(NCLST.LE.1) RETURN
      NC1 = NCLST-1
        DO 10 N=1,NC1
        IF(CLSPRP(8,N)) 10,11,10
   11   IF(CLSPRP(2,N).LT.EMIN.OR.CLSPRP(2,N).GT.EMAX) GO TO 10
        MS = N+1
          DO 20 M=MS,NCLST
          IF(CLSPRP(8,M)) 20,21,20
   21     IF(CLSPRP(2,M).LT.EMIN .OR. CLSPRP(2,M).GT.EMAX) GO TO 20
CCC       IF(CLSPRP(2,M).LT.CLSPRP(2,N)*0.1) GO TO 20
          COST = 0.
            DO 22 K=9,11
   22       COST = COST+CLSPRP(K,N)*CLSPRP(K,M)
          IF(COST.GT.1.0) COST = 1.0
          AMASS = SQRT(2.0*CLSPRP(2,N)*CLSPRP(2,M)*(1.0-COST))
          E2G = CLSPRP(2,N)+CLSPRP(2,M)
C//////////////////
C         WRITE(6,6000) N,M,CLSPRP(2,N),CLSPRP(2,M),COST,AMASS,E2G
C6000     FORMAT(' N,M=',2I4,'  E(N),E(M)=',2F6.3,'  COST,AMASS,E2G=',
C    $    3E11.3)
C//////////////////
C----     PLOT
          CALL HFILL(1,AMASS,E2G,1.0)
   20     CONTINUE
   10   CONTINUE
      RETURN
C
C*****************************************************************
C
      ENTRY INMS2G
C
      CALL HBOOK2(1,'TWO GAMMA MASS$',100,0.0,1.0, 50,0.0,5.0)
      CALL HBPRO(1,0)
      RETURN
C
C******************************************************************
C
      ENTRY ENMS2G
      CALL HISTDO
      RETURN
C
      END

C   02/07/79 406081620  MEMBER NAME  FAMPFT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FAMPFT(NN,RAD,RMIN,PHM,XB,YB,XE,YE,XCE,YCE)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON    2/07/83 :  DRAW A CIRCLE SEGMENT FOR FAMP
C
C       MOD:   J. OLSSON    3/07/83 :
C  LAST MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C
C     MODIFIED VERSION OF CIRDIS, TO DISPLAY CIRCLE APPROXIMATION OF
C     THE PARABOLA FIT IN PATREC OF "FAMP"
C
C        DRAWS A CIRCLE SEGMENT FROM XB,YB TO XE,YE OF THE CIRCLE WITH
C        PARAMETERS RAD,RMIN,PHM.    NN IS THE SEGMENTATION OF THE
C        POLYGON APPROXIMATION.
C        XCE,YCE IS THE POINT TO WHICH CLOSEST APPROACH IS FOUND
C          (I.E., THE POINT WHICH IS THE ORIGIN OF THE TRACK)
C        IF DSPDTL(19) = TRUE, TRACKS ARE PROLONGED TO CLOSEST APPROACH
C                              TO ORIGIN.
C        IF DSPDTL(23) = TRUE, TRACKS ARE PROLONGED TO TOF OR LEAD GLASS
C                              RADIUS LIMIT.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
#include "cgeo1.for"
      COMMON / CJTRIG / PI,TWOPI
C
C------------------  C O D E  ------------------------------------------
C
      RRA = ABS(RAD)
      YC = RRA + RMIN
      XC = YC*COS(PHM)
      YC = YC*SIN(PHM)
C     WRITE(6,2311) RAD,XC,YC,RMIN,PHM
2311  FORMAT(' FT: RAD XYC RMN PHM ',5E14.6)
      RTS = RLG
      IF(LASTVW.EQ.1) RTS = RTOF
C--
      PHMIT = ATAN2(YC-YCE,XC-XCE)
      FI1 = PHMIT - PI
      IF(.NOT.DSPDTL(19).AND.LSTCMD.NE.52) FI1 = ATAN2(YB-YC,XB-XC)
      FI2 = ATAN2(YE-YC,XE-XC)
      IF(FI1.LT.-PI) FI1= FI1 + TWOPI
      FIB = FI1
      ARC = ARCMIN(FI2-FI1)
C     WRITE(6,2313) ARC,FI1,FI2
2313  FORMAT(' FT: ARC FI1 FI2 ',3E14.6)
      IF(ARC*RAD.GT.0.) ARC = SIGN(TWOPI-ABS(ARC),-ARC)
      DEFI = ARC/NN
      XP = - XC - RRA*COS(FI1)
      YP = YC + RRA*SIN(FI1)
C     WRITE(6,2312) PHMIT,XP,YP
2312  FORMAT(' FT: PHMIT XP YP ',3E14.6)
      CALL MOVEA(XP,YP)
      DO 501  I = 1,NN
      FI1 = FI1 + DEFI
      XP = - XC - RRA*COS(FI1)
      YP =   YC + RRA*SIN(FI1)
      IF(I.EQ.NN) RP = SQRT(XP**2+YP**2)
501   CALL DRAWA(XP,YP)
      IF(.NOT.DSPDTL(23))  RETURN
C---------- SECTION FOR EXTENSION TO TOF OR PBG LIMIT
      NNN = 0
551   FI1 = FI1 + DEFI
      NNN = NNN + 1
      IF(NNN.GT.200.OR.ABS(ARCMIN(FI1-PHM)).LT.ABS(DEFI)) RETURN
      XP = - XC - RRA*COS(FI1)
      YP =   YC + RRA*SIN(FI1)
      RP = SQRT(XP*XP + YP*YP)
      IF(RP.LT.RITNK) GO TO 559
      IF(RP.GT.RTS) GO TO 559
      CALL DRAWA(XP,YP)
      GO TO 551
559   RETURN
      END
C*****************************
      FUNCTION ARCMIN(A)
C
C THIS IS A ROUTINE USED IN PLUTO PATREC. IT FINDS THE SHORTEST ARC
C     BETWEEN TWO ANGLES.
C
      COMMON/CJTRIG/ PI,TWOPI
C
      ARCMIN=A
      IF (ABS(A).LE.PI) GOTO 2
      ARCMIN=AMOD (A+5.*PI,TWOPI)-PI
    2 RETURN
      END
      DOUBLE PRECISION FUNCTION DRCMIN(AA)
      COMMON/CJTRIG/ PI,ZWEIPI
      REAL*8 AA
      DRCMIN=AA
      IF (DABS(AA).LE.PI) GOTO 3
      ARGUM = AA + 2.*ZWEIPI + PI
      DRCMIN=AMOD (ARGUM,ZWEIPI)-PI
    3 RETURN
      END

C   25/06/78            MEMBER NAME  PAIRC2   (LGSOURCE)    FORTRAN
      SUBROUTINE PAIRC2(ENE,EPSI)
      COMMON /BRPAR/BRA,BRB,BDEL
      COMMON /SFCPA/SF,SFE
      BH(X)=4.184*ALOG(X+0.952)-0.280
      DIMENSION XRR(3),XRH(3)
      DO10 I=1,3
      XR=RN(DAM)
      XRR(I)=XR
 10    CONTINUE
      DO11 I=1,3
 11    XRH(I)=ABS(XRR(I)-0.5)
      RHMAX=XRH(1)
      I=1
      IF(RHMAX-XRH(2))15,16,16
 15    RHMAX=XRH(2)
      I=2
 16    IF(RHMAX-XRH(3))17,18,18
 17    I=3
 18    EPSI=XRR(I)
      XR=RN(DAM)
      DEL=BDEL/(ENE*EPSI*(1.-EPSI))
      IF(DEL-1.)20,20,21
 20    G2=1.-BRA*DEL*(3.898-0.9805*DEL)
      GO TO 2
 21    G2=1.-BRA*BH(DEL)
 2    IF(SF*XR-G2)30,30,31
 30    RETURN
 31    EPSI=0.
      RETURN
      END

C   08/06/86 606101931  MEMBER NAME  SETDEF   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SETDF ! PMF 18/11/99: SETDEF changed to SETDF
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY  10/06/86 :  SETS UP DEFAULT VIEW FROM PROFILE
C
C
C     READS THE MACRO "DEFVIEW" AND SETS UP THE DEFAULT VIEW IT CONTAINS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8    DCHARS, DVIEW
      LOGICAL*1 CVIEW(8), CBLANK, CHARS(80)
C
#include "cgraph.for"
C
      COMMON / CSTANV / HDISPN, HCSTV2, HCSTV3
C
      DIMENSION  ISTAFL(80), IENDFL(80)
C
      EQUIVALENCE  ( DCHARS, CHARS(1) )
      EQUIVALENCE  ( DVIEW,  CVIEW(1) )
C
      DATA  DCHARS    / 'DEFVIEW ' /
      DATA  DVIEW     / 'RB      ' /
C
      DATA  CBLANK    / ' '  /
      DATA  ISTAFL(1) /  1   /
      DATA  IENDFL(1) /  7   /
      DATA  NFL       /  1   /
C
C------------------  C O D E  -----------------------------------------
C
C                            SET UP INTERNAL DEFAULT VIEW
C
      ISTANV = 2
C
C                            IS THERE A MACRO CALLED DEFVIEW?
C
      CALL JADCMD( CHARS, NFL, ISTAFL, IENDFL, LCOM, A, B )
C
      IF( LCOM .EQ. 0 ) GO TO 15
C
C                            EXPAND THIS MACRO INTO CHARS BUFFER
C
        NEXFLD = 8
        CALL EXPMAC( LCOM, CHARS, NEXFLD, IERR )
        IF( IERR .NE. 0 ) GO TO 10
C
C                            LOCATE THE FIELDS IN THE MACRO COMMAND
C
        CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
        IF( NFIELD .GT. 2 ) GO TO 10
C
C                            IF ONLY ONE OR TWO FIELDS, DECODE THEM
C
        CALL JADCMD( CHARS, NFIELD, ISTAFL, IENDFL, LCOM, A, B )
C
        IF( LCOM .LT. 1  .OR.  LCOM. GT. 30 ) GO TO 10
          ISTANV = LCOM
          IF( A .NE. 0.0 ) HCSTV3 = 1
C
C                            COPY THE NAME OF THE VIEW INTO CVIEW
C
          LEN = IENDFL(1) - ISTAFL(1) + 1
          DO  5  I = 1,8
            IF( I .LE. LEN ) GO TO 3
              CVIEW(I) = CBLANK
              GO TO 5
C
   3          CVIEW(I) = CHARS( ISTAFL(1) + I - 1 )
   5      CONTINUE
C
C                            RESTORE THE MACRO TO CLEAN THE STACK
C
  10  CALL RESMAC( CHARS, NEXFLD )
C
C                            SET LAST VIEW TO CURRENT VIEW
C
  15  LASTVW = ISTANV
C
      WRITE(6,20) CVIEW
  20  FORMAT(' Standard view is ',8A1/
     +       ' It can be changed by selecting a new view'/
     +       ' and making it the standard using the command CSTV 1'/)
C
      RETURN
      END

C   23/02/84 402231603  MEMBER NAME  MUFSTA   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE  MUFSTA( IMONTH, IYEAR )
C-----------------------------------------------------------------------
C
C NEW SUBR    15.35  23/02/84   C. BOWDERY - FIX-UP CHAMBER STATUS
C
C     THIS ROUTINE ALTERS THE STATUS OF CERTAIN CHAMBERS FOR THOSE
C     PERIODS WHERE THE CALIBRATION FILES HAVE NOT BEEN UPDATED.
C     USE TIME TO IMPLEMENT THESE BODGES, RATHER RUN NO. SO THAT
C     MONTE-CARLO WILL PICK UP CORRECT CHAMBER STATUS.
C
C     INPUT:   IMONTH    =  MONTH WHEN EVENT WAS RECORDED
C              IYEAR     =  YEAR  WHEN EVENT WAS RECORDED
C
C     OUTPUT:  HMCSTA(N) =  1  (= OFF) FOR CERTAIN VALUES 'N'
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C                                           CALIBRATION COMMON
#include "cmucalib.for"
C
C------------------  C O D E  ------------------------------------------
C
      ITIME  = IYEAR * 100  +  IMONTH
C
C                            BODGE FOR 1980 SUSPECT CHAMBERS
C
C                             1/1979  -  9/1980  ---   NO CHANGES
C                            10/1980  -  5/1981  ---   15 CHAMBERS OFF
C
      IF( ITIME .GE. 198200 ) GO TO 2
      IF( ITIME .LT. 198010 ) GO TO 1
      IF( ITIME .GT. 198105 ) GO TO 1
C
          HMCSTA(6)   = 1
          HMCSTA(22)  = 1
          HMCSTA(26)  = 1
          HMCSTA(111) = 1
          HMCSTA(120) = 1
          HMCSTA(168) = 1
          HMCSTA(170) = 1
          HMCSTA(178) = 1
          HMCSTA(217) = 1
          HMCSTA(232) = 1
          HMCSTA(246) = 1
          HMCSTA(253) = 1
          HMCSTA(256) = 1
          HMCSTA(257) = 1
          HMCSTA(258) = 1
C
C                            ALL DATA UP TILL END OF 1981,
C                            SWITCH 210-213 OFF ALWAYS (DIGITISER)
C
  1       HMCSTA(210) = 1
          HMCSTA(211) = 1
          HMCSTA(212) = 1
          HMCSTA(213) = 1
C
  2   CONTINUE
      RETURN
      END

C   07/06/96 606071916  MEMBER NAME  UEMPF    (S4)          FORTG1
      SUBROUTINE UEMPF(NA,Y,X)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL Q(10)
      EXTERNAL LBN
      CALL BLOC(IND,'EMP*',NA,&100)
      LB=LLBN(IND+2,X)
      CALL UMEAN(NA,LB,Y)
      GOTO 100
C
      ENTRY DEMPF(NA,NX)
      CALL BLOC(IND,'EMP*',NA,&2)
      GOTO 100
    2 CALL BLOC(J,'$BIN',NX,&100)
      NJ=IW(J)+2
      CALL BCRE(IND,'EMP*',NA,NJ,&100,IER)
      IW(IND+1)=NX
      CALL BSTR(IND+1,IW(J),NJ-1)
      CALL VLBN(NX,1,XL,XH,NB)
      CALL DMEAN(NA,NB+1)
      GOTO 100
C
      ENTRY PEMPF(NA)
      CALL BLOC(IND,'EMP*',NA,&100)
      NXX=IW(IND+1)
      WRITE(6,101) NA
      CALL PMEAN(NA)
      CALL VLBN(NXX,1,XL,XH,NB)
      IF(NB.LE.0) GOTO 100
      I=0
      DO 10 LB=1,NB
      CALL QMEAN(NA,LB,Q)
      IF(Q(1).LE.2.0) GOTO 10
      I=I+1
      CALL VLBN(NXX,LB,XL,XH,NT)
      XQ=0.5*(XL+XH)
      YQ=Q(3)
      IF(I.NE.1) GOTO 5
      CALL BCRE(IND,'$FUN',NA,0,&10,IER)
    5 CALL BCHM(IND,2,JER)
      IF(IER+JER.NE.0) GOTO 10
      RW(IND+2*I-1)=YQ
      RW(IND+2*I  )=XQ
   10 CONTINUE
      II=I+I
      WRITE(6,102) NA
      WRITE(6,103) (RW(IND+I),I=1,II)
C
  100 RETURN
  101 FORMAT(' UEMPF',I6)
  102 FORMAT(' CONTENT OF BANK  $FUN,',I9/)
  103 FORMAT(5(1X,2G12.4,1X))
      END

C   30/01/800003040507  MEMBER NAME  FAKAL2   (SOURCE)      FORTRAN
      SUBROUTINE FAKAL2(*)
C     PUT IN BAD CHANNEL INFO. INTO COMMON/CALIBR/
C     HEXP  :  INPUT EXPERIMENTAL #
C     HRUN  :  INPUT RUN#
C     HBUF  :  BUFFER FOR BAD CHANNELS. FOR THE OUTPUT OF THE PROG,
C              (J,I),J;1=ADC#,2=#CHANNELS TO BE SUBTRACTED.
C     CODED BY Y.WATANABE 19/9/79  09:05
C     LAST MODIFICATION  Y.WATANABE 30/1/80  09:05
      IMPLICIT INTEGER *2 (H)
#include "cdata.for"
#include "clgkalb.for"
      EQUIVALENCE (NEVNT,HBAD(1)),(HHEXP,HBAD(3)),(HHRUN,HBAD(4))
      EQUIVALENCE (HBUF(1),NCAL(3002))
      DIMENSION  HBBB(11526),HIN(4,2880),HBUF(1000),HBAD(1000)
      EQUIVALENCE (HIN(1,1),HBBB(7))
      EQUIVALENCE (HCAL(100),HBBB(1))
      DATA INIT/0/,HARUN/0/,HRAN/0/
C
C     PUT IN CALIBRATION DATA
      IF(INIT.GT.0) GO TO 30
C
C     PUT IN CALIBRATION CONSTS.
          IPHD = IBLN('HEAD')
      CALL SETSL(HCAL,0,20000,0)
      READ(20) LENG,(HBBB(I),I=1,LENG)
C     WRITE(6,890) LENG,(HBBB(I),I=1,20)
C890  FORMAT(21I6)
      HP=10
      NCAL(2)=HP
      HP=HP+HP+1
      DO 10 I=1,2880
      HCAL(HP)=HIN(2,I)
      HCAL(HP+1)=HIN(4,I)
      HP=HP+2
10    CONTINUE
C     WRITE(6,900) (HCAL(I),I=22,5782,2)
C900  FORMAT(20I6)
      INIT=1
      JNIT=0
C
30        NPHD = IDATA(IPHD)
          IF(NPHD.LE.0) RETURN1
          NHPHD = NPHD+NPHD
          HEXP=HDATA(NHPHD+ 9)
          HRUN=HDATA(NHPHD+10)
      IF(HRUN.LE.0) RETURN1
      IF(HRUN.EQ.HRAN) RETURN
C       IF EQ ALREADY INITIALIZED FOR THE RUN.
      HRAN=HRUN
      IFG=0
      NCAL(7)=3000
C
40    READ(21,END=60) LENG,(HBAD(I),I=1,LENG)
      IF(LENG.LE.10) GO TO 40
      IF(NEVNT.LT.500) GO TO 55
      IF(JNIT.LT.1) GO TO 45
      IF(HHRUN.GT.HRUN) GO TO 60
45    NCAL(3001)=LENG
      DO 50 I=1,LENG
50    HBUF(I)=HBAD(I)
      JNIT=1
55    IF(HHRUN.LT.HRUN) GO TO 40
C     WRITE(6,920) (HBAD(J),J=1,LENG)
      LENG=NCAL(3001)
C     WRITE(6,610) HRUN
C 610 FORMAT(1X,'$$$ RUN # ',I4,' FOUND$$$ GOOD GOOD ')
      HARUN=HHRUN
      REWIND 21
C     WRITE(6,920) (HBUF(J),J=1,LENG)
C920   FORMAT(10(2I6,1X))
C
      RETURN
C
60    REWIND 21
C     WRITE(6,600) HRUN,HARUN
C 600 FORMAT(1X,'*** RUN # ',I4,' NOT FOUND***  *USE',I4)
      RETURN
      END

C   23/06/78 701061213  MEMBER NAME  CERNKV66 (S)           FORTRAN
      SUBROUTINE CERNKV(DEPTH,DIR,EE,T)
C
C     S.YAMADA    12-11-77    XX:XX
C     LAST MOD.   28-04-81    SIDE WALL REFLECTION.
C     MOD TO SF6  27-09-85    J.OLSSON (S.YAMADA)
C     ERROR CORR   2-01-86    J.OLSSON
C     N=1.8047     5-01-87    J.OLSSON
C
C     THIS VERSION IS A FIRST ATTEMPT TO USE CORRECT REFRACTIVE INDEX
C     FOR SF6. THE PREVIOUS VERSION FOR SF6, CERNKV6, USES THE SAME
C     VALUE FOR N AS THE OLD SF5 ONE, NAMELY: 1.6725, ACC. TO COMMENT.
C     THE CALCULATED VALUE USED IN ANL, 592.23 CORRESPONDS HOWEVER TO
C     N=1.764.   THIS POINT SHOULD BE CLARIFIED...
C     FURTHERMORE, SOME OTHER VARIABLES MAY HAVE TO BE CHANGED, E.G.
C     ANGLE OF TOTAL REFLECTION...
C
C---- TRACE CERENKOV LIGHT TO THE BACK SURFACE OF THE LEAD GLASS
C     COUNTER AND EXAMINE PHOTOELECTRIC CONVERSION
C---- DEPTH = INITIAL POINT DEPTH OF THE SOURCE  ELECTRON IN RAD LNG.
C---- DIR = DIRECTION COSIGNS OF THE  SOURCE ELECTRON.
C---- EE = SOURCE ELECTON ENERGY.(USED  FOR HISTOGRAM BINNING ONLY)
C---- T  =  PATH LENGTH OF  THE SOURCE ELECTRON IN RAD LENGTH.
C
      DIMENSION  DIR(3)
C
      COMMON /CONSTB/ CONVMX, BK7, TOTL
C---- CONVMX=MAX CONVERSION EFFICIENCY OF R594.
C---- BK7=LENGTH OF THE BK7 LIGHT GUIDE
C-        NOTE:  SF6 WITH NO LIGHTGUIDES
C
      COMMON /CCERSR/ SOURCE(20,25),CRNKSC(20,25), ISPCT(20,40),
     1                 NEP,NACP
C
C---  NEP   NR OF EMITTED PHOTONS
C---  NACP  NR OF ACCEPTED PHOTONS (GENERATING PHOTOELECTRON)
C---- SOURCE(IDEPTH,IEE)   INPUT ELECTRON SPECTRUM FOR EACH DEPTH.
C---- CRNKSC(IDEPTH,IEE)   CERENKOV CONTRIBUTING ELECTRON SPECTRUM.
C---- ISPCT(IDEPTH,LAMDA)    CERENKOV  LIGHT SPECTRUM SEEN AT
C                          THE BACK SURFACE.IDEPTH=EMMISION DEPTH
C SF5 PARAMETERS, N=1.6725
C     DATA RAD/2.23/,  COST/0.5979/,SINT/0.8016/
C
C PARAMETERS FOR SF6, N=1.8047
      DATA RAD/1.53/,  COST/0.55411/,SINT/0.83244/
C
C---- DEFAULT VALUE FOR C,S
      DATA C/1.0/,  S/0.0/
      DATA ICALL6/0/
C
C---- CALCULATE TOTAL CERENKOV QUANTA NUMBER.
C     NL=(2*3.14/137.)/C*(1-1/N**2)*(DELTA  NEU)*T(IN CM)
C     DELTA NEU =  FREQUENCY RANGE,HERE BETWEEN  429000 AND 1000000
C                  GHZ,DNEU=571000GHZ.
C     N =  REFLACTIVE INDEX (=1.8047 IS USED)   SF6 (KOBAYASHI, 10.2.86)
C     (1-1/N**2)=0.6425      SF5   (N=1.6725)
C     (1-1/N**2)=0.69296     SF6   (N=1.8047)
C     C=LIGHT VELOCITY(=30CM/NSEC)
C
      ICALL6 = ICALL6 + 1
C
      TCM =  RAD*T
C
C     ANL = 592.23*TCM     SF5 VALUE, NOTE, WRONG, EQUIV. N=1.76
C     ANL = 560.86*TCM     SF5 VALUE CORRESPONDING TO N=1.6725
C
      ANL = 604.90*TCM
C
      IF(ICALL6.EQ.1) WRITE(6,772) ANL
772   FORMAT(' CERNKV66, CORRECTED VERSION FROM 5.1.1987, ANL=',E14.5)
      NL = ANL
      ANL1 = NL
      NL = NL+1
      FRCANL = ANL-ANL1
C
      TCMZ = TCM*ABS(DIR(3))
      DEPTCM = DEPTH*RAD
C----   SET INDECES  FOR HISTOGRAMS
      IDEP  = DEPTH+1.
      IF(IDEP.GT.20) IDEP =  20
      IEE =  5.*ALOG10(EE)+3.
      IF(IEE.LT.1) IEE =  1
      IF(IEE.GT.25) IEE =25
C
      SOURCE(IDEP,IEE) = SOURCE(IDEP,IEE)+T
C
C---- REPEAT FOR NL-PHOTONS
        DO 1 I=1,NL
C----   CORRECT FRACTIONAL TRIAL NUMBERS.(RANDOMLY CORRECTED.)
        IF(I.EQ.NL.AND.RN(DUM).GT.FRCANL) GO TO 1
C
        NEP = NEP+1
C       CALCULATE  PHOTON DIRECTION COSINE Z-COMPONENT.
        CALL RANAZI(C,S)
        ANN = DIR(3)*COST+(DIR(1)*C+DIR(2)*S)*SINT
C----    CHECK TOTAL REFLECTION CONDITION BETWEEN NORMAL GLASS(N=1.52)
        ABSANN = ABS(ANN)
C-----  TOTAL REFLECTION CHECK IS CHANGED. 02-12-77
C       DATA MESS/0/
C       IF(MESS.EQ.0) WRITE(6,600)
C 600   FORMAT('0******** TRANSPARENCY CHECK AT THE SF5/BK7 BOUNDARY',
C 600   FORMAT('0******** TRANSPARENCY CHECK AT THE SF6/PM BOUNDARY',
C    1  /' ',20X,'CHANGED 02-12-77   ********')
C       MESS = 1
        IF(ABSANN.LT.0.4172) GO TO 1
        TRNS = 1.-0.0065/(ABSANN-0.410)
        IF(RN(DUM).GT.TRNS) GO TO 1
C
C        SET  FREQUENCY
        FREQ = 429000.+RN(DUM)*571000.
C----    ALAMDA=WAVE LENGTH IN NANO-METER.
        ALAMDA = 3.E8/FREQ
C
C----    EMMITTED POSITION Z-CORDINATE IN CM.
        ZS = DEPTCM+RN(DUM)*TCMZ
        IF(ANN.LT.0.) ZS = -ZS
C        ABSORPTION LENGTH TO THE BACK SURFACE AND THROUGH LIGHT GUIDE
C       ABSL = ((TOTL-ZS)/AVABS(ALAMDA)+BK7/BK7ABS(ALAMDA))/ABSANN
        ABSL = ((TOTL-ZS)/AVABS(ALAMDA))/ABSANN
        IF(ABSL.LT.0.) GO TO 1
        IF(ABSL.GT.20.) GO TO  1
C        ABSORPTION  PROBABILITY  CHECK
        IF(RN(DUM).GT.EXP(-ABSL)) GO TO 1
C
C----   REFLECTION AT SIDE WALLS
C  ERROR CORRECTED 2.1.1986   J.O.
C       IF( ABSANN.GE. 0.5979) GO TO 2
        IF( ABSANN.GE. COST )  GO TO 2
C       NOT TOTALLY REFLECTED.
C       COUNT NUMBER OF REFLECTION.
        XY = (TOTL-ZS)*SQRT(1.0-ABSANN**2)/ABSANN
        NREF = XY*0.2
        IF( NREF.LT.1 ) GO TO 2
C       REFLECTION EFFICIENCY IS TAKEN TO BE 0.8.
C  NOTE: OTHER VERSIONS OF YAMADA USE 0.9 AS REFLECTION EFFICIENCY
        IF( RN(DUM).GT.0.8**NREF ) GO TO 1
    2   CONTINUE
C
C         PHOTON REACHES THE BACK SURFACE
C       CHECK CONVERSION
C----   TO KEEP MONTE CARLO EFFICIENCY CONVMX IS MULTIPLIED TO THE RANDU
         IF(CONVMX*RN(DUM).GT.CONVEF(ALAMDA)) GO TO 1
C       PHOTON  IS DETECTED.
         LAMD10 = ALAMDA*0.1-30.
         IF(LAMD10.LT.1) LAMD10 = 1
         IF(LAMD10.GT.40) LAMD10 = 40
         CRNKSC(IDEP,IEE) = CRNKSC(IDEP,IEE)+1.
         ISPCT(IDEP,LAMD10) = ISPCT(IDEP,LAMD10)+1
         NACP = NACP+1
    1    CONTINUE
      RETURN
      END

C   13/03/84 403140007  MEMBER NAME  GETDS    (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
         SUBROUTINE  GETDS(LUNC,MESS,INAME,HERR)
C-----------------------------------------------------------------------
C
C   AUTHOR:  C. BOWDERY    ??/??/81 : OUTPUTS MESSAGE AND LINKS A DS
C
C        THIS SUBROUTINE OUTPUTS MESSAGE MESS AND READS IN A
C        DSNAME AND LINKS IT TO LUNC USING S/R LINKDS
C
C            INAME   -   ARRAY OF LENGTH 11 CONTAINING DSNAME
C            LUNC    -   VARIABLE HOLDING LOGICAL UNIT NO.
C            HERR    -   ERROR VARIABLE
C            MESS    -   MESSAGE ARRAY TERMINATED WITH ^
C
C        IF LUNC=0 ON ENTRY, THE VALUE OF LUNC ON EXIT WILL BE
C        DECIDED BY SUBROUTINE GETPDD (FROM R02SCH.TSOIPS.LOAD).
C        IF INAME HAS LEADING BLANKS, THEY WILL BE REMOVED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8 DDN
      LOGICAL*1 MESS(1),BAR
C
      DIMENSION INAME(11)
      DATA BAR/'^'/
C
C-------------------  C O D E  -----------------------------------------
C
      JERR = 0
C
 4    IF( MESS(1)   .EQ. BAR ) GO TO 5
      DO  10  M = 1,80
      IF( MESS(M+1) .EQ. BAR ) GO TO 11
 10   CONTINUE
C
 11   WRITE(6,1) (MESS(J),J=1,M)
 1    FORMAT(X,80A1)
 5    READ(5,2) INAME
 2    FORMAT(11A4)
C
C
C             CALL LINKDS TO ALLOCATE LOGICAL UNIT NUMBER LUNC
C             TO THE CALIBRATION DATASET. IF LUNC IS ZERO, GETPDD
C             CHOOSES A VALUE. ON RETURN, HERR SHOULD BE ZERO.
C             IF NOT, 3 ATTEMPTS ARE MADE TO ASK FOR A DSNAME.
C
      CALL LINKDS(LUNC,INAME,HERR,DDN)
      IF( HERR .EQ. 0 ) RETURN
        WRITE(6,3) INAME
 3      FORMAT(' DSNAME ---> ',11A4)
        CALL DSERR(HERR,JERR,DDN,&11)
        RETURN
      END

C   28/05/82 504211226  MEMBER NAME  MUCHAN   (JADEMUS)     FORTRAN
C   27/05/82 205271455  MEMBER NAME  MUCHAN   (S)           FORTRAN
C   27/10/81 110271013  MEMBER NAME  MUCHAN   (JADEMUS1)    FORTRAN
C   12/06/81 110261518  MEMBER NAME  MUCHAN   (S)           FORTRAN
C
C LAST CHANGE 11.40 29/06/82 HUGH MCCANN  - ADD /CMUED/ .
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C      CHANGE 10.15  27/10/81   HUGH MCCANN  -CORRECT HVDRFT BUG.
C
      SUBROUTINE MUCHAN(I)
      IMPLICIT INTEGER*2 (H)
C COMMONS.
#include "cmucalib.for"
#include "cmuedwrk.for"
#include "cmued.for"
      DIMENSION HPOINT(20)
      DATA HPOINT/  33,1415,1497,1579,1661,1743,1815,2541,1907,6981,
     *            3176,3810,4444,7615,8249,8255,8261,8267,8273,1907/
C
C*********************************************************************
C  THIS ROUTINE CHECKS WHETHER LOCATION NHMUCA HAS BEEN CHANGED BY
C  A PREVIOUS EDIT ( IN THE CURRENT SET ).
C  IF SO , LOCEDT IS SET TO THE LOCATION OF THE PREVIOUS CHANGED
C  VALUE IN HUPDAT.
C  THEN HUPDAT(LOCHAN) IS SET TO THE NEW VALUE OF HMUCAL(NHMUCA).
C
C  ONLY ACCEPT IALPH=6 (CTLO) OR IALPH=7 (CTHI) CHANGES IF ONE OR
C  MORE HALF-WORDS IN THE RANGE OF LOCATIONS 1907-2540 ( INC. )
C  HAVE CHANGED ( I.E. IF AND ONLY IF ONE OR MORE CTW'S HAVE CHANGED.)
C
      IF(IALPH.NE.6.AND.IALPH.NE.7)GO TO 20
      IF(NCHAN.EQ.0)RETURN
      DO 10 J=1,NCHAN
      IF(HLOC(J).GE.1907.AND.HLOC(J).LE.2540)GO TO 20
   10 CONTINUE
      RETURN
C
   20 NCHAN=NCHAN+1
      LOCHAN=NCHAN
      NHMUCA=HPOINT(IALPH)+I-1
      IF(I.EQ.99999)NHMUCA=3175
      IF(NCHAN.EQ.1)GO TO 3002
      DO 3001 J=1,8370
      IF(HLOC(J).NE.NHMUCA) GO TO 3001
      LOCHAN=J
      NCHAN=NCHAN-1
      GO TO 3002
 3001 CONTINUE
 3002 HUPDAT(LOCHAN)=HMUCAL(NHMUCA)
      HLOC(LOCHAN)=NHMUCA
      RETURN
      END
C
      BLOCK DATA
C
      IMPLICIT INTEGER*2 (H)
C
C
#include "cmued.for"
C
      DATA NCHAN/0/
      END

C   29/08/78 C8082901   MEMBER NAME  SETSCV   (LGSOURCE)    FORTRAN
      SUBROUTINE SETSCV(E)
C
C     S.YAMADA    29-08-78  21:30
C
C---- NORMALIZED INTEGRAL SHOWER CURVE IS MADE FOR E-MEV ELECTRON.
C
      COMMON /CLEPTB/ ESPRFL(100)
      DIMENSION EB(22),EPFMST(100,22)
      DATA JRD/0/
C
      IF(JRD) 1,1,10
C
C---- READ THE DISK DATA AND MAKE THE MAIN TABLE.
    1   DO 2 K=1,22
        READ(11,END=4) LNG,EB(K),(EPFMST(KK,K),KK=1,100)
    2   CONTINUE
      GO TO 4
    3 WRITE(6,600) K
  600 FORMAT(' **** DATA ENDS BEFORE K=22  AT K=',I4)
    4 JRD = 1
C
C---- SEARCH THE ENERGY INTERVAL.
   10   DO 11 K=1,22
        IF(E.LT.EB(K)) GO TO 12
   11   CONTINUE
C
C---- OVER THE MAX ENERGY. FIXED TO THE MAX ENERGY BIN.
      K = 22
      GO TO 20
C
C---- TOO LOW ENERGY IS ALSO FIXED TO THE MIN.ENERGY BIN.
   12 IF(K.EQ.1) GO TO 20
C---- INTERPOLATION
      D = (E-EB(K-1))/(EB(K)-EB(K-1))
        DO 13 KK=1,100
        ESPRFL(KK) = EPFMST(KK,K-1)+D*(EPFMST(KK,K)-EPFMST(KK,K-1))
   13   CONTINUE
      RETURN
C
C---- USE OF THE END VALUES.
   20   DO 21 KK=1,100
   21   ESPRFL(KK) = EPFMST(KK,K)
C
      RETURN
      END

C   10/04/84            MEMBER NAME  FWC83    (JADEGS)      FORTRAN
      SUBROUTINE FWC83(ADX,ADY,LLL,FC,ITXT)
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CGEO2 .... JADE TAGGING GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO2 / FENDC,XYHOL1,XYHOL2,BLDPFW,ZMINBL,ZPLUBL,
     +                 XSC(2),YSC(2),RSC(2),ZMISC(2),ZPLSC(2),DZSC,
     +                 CHX(3,4),CHY(3,4),CHZ(3,4),WLEN,PITCH,WZDIS
C
C--------------------------- END OF MACRO CGEO2 ------------------------
C
C----------------------------------------------------------------------
C      MACRO CGEO3 .... JADE FORWARD DETECTOR GEOMETRY, 1981-3 VERSION
C----------------------------------------------------------------------
C
      COMMON / CGEO3 / ZPLUM2,ZMINM2,NRPBSC,PBSCR(4),PBSCZ(4)
C
C------------------------ END OF MACRO CGEO3 --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
      COMMON / CJTRIG / PI,TWOPI
C
C DRAW FRONT VIEW OF TAGGING SYSTEM IN 1983-.. VERSION.
C   FC IS A MAGNIFICATION FACTOR (IT IS TOO SMALL IN RU VIEW..)
C
      R1   = PBSCR(1)*FC
      R4   = PBSCR(4)*FC
      DEFI = TWOPI/FLOAT(NRPBSC)
      CALL BARSEC(0.,0.,0.,R1,R4,ADX,ADY,NRPBSC,DEFI,LLL)
      CALL PLYGON(NRPBSC,PBSCR(2)*FC,ADX,ADY,LLL)
      CALL PLYGON(NRPBSC,PBSCR(3)*FC,ADX,ADY,LLL)
      IF(ITXT.EQ.0) RETURN
C     WRITE TEXT
C  WRITE +- Z  BELOW CAPS
      SH3 = 0.6*FENDC
      Y1 = ADY - R4 - FENDC
      I = 1
      IF(ADX.GT.0.) I = 2
      LABT = 101 + (I-1)*2
      X1 = ADX-0.5*FENDC
      CALL RUTEXT(LABT,X1,Y1,SH3)
C  DRAW BEAM CROSS INSIDE CAP
      CALL MOVEA(ADX,ADY-20.)
      CALL DRAWA(ADX,ADY+20.)
      CALL MOVEA(ADX+20.,ADY)
      CALL DRAWA(ADX-30.,ADY)
      CALL DRAWA(ADX-30.,ADY+15.)
      CALL DRAWA(ADX-45.,ADY)
      CALL DRAWA(ADX-30.,ADY-15.)
      CALL DRAWA(ADX-30.,ADY)
      RETURN
      END

C   07/06/96 606071855  MEMBER NAME  LSQSPL   (S4)          FORTG1
      SUBROUTINE LSQSPL(Y,N,A,NSP,CHDF)
      REAL Y(N),A(5,NSP),S(4)
C
C     PERFORM A LEAST SQUARE SPLINE FIT TO THE ARRAY Y( ) OF
C     DIMENSION N WITH NSP SPLINE REFERENCE POINTS. THE ARRAY Y( ) IS
C     REPLACED BY TH FITTED VALUES OF THE INTERPOLATING SPLINE
C     FUNCTION. THE NSP REFERENCE POINTS ARE CHOSEN EQUIDISTANT,
C     WTIH THE FIRST AND THE LAST ONE OUTSIDE THE X-RANGE.
C
C     LOWEST VALUE OF NSP  = 4
C                            ONE CUBIC POLYNOMIAL THROUGH ALL POINTS
C
C     LARGEST VALUE OF NSP = 2+(N+1)/2
C                            CUBIC POLYNOMIAL FOR EACH TWO PONTS
C
C     H( ) = AUXILIARY ARRAY OF LENGTH 5*NSP (AT LEAST).
C
C     IEQ = +1 OR -1   Y-VALUES AT EQUIDISTANT ABSCISSA VALUES X
C                      (ARGUMENT X CAN BE DUMMY)
C     IEQ = +2 OR -2   Y-VALUES AT GIVEN X-VALUES
C
C     IEQ = +1 OR +2   WEIGTHS W FOR ALL Y-VALUES GIVEN
C
C     IEQ = -1 OR -2   ALL WEIGTHS EQUAL (ASSUMED TO BE 1.0)
C                      (ARGUMENT W CAN BE DUMMY)
      CHDF=0.0
      IF(N.LT.3.OR.NSP.LT.4) GOTO 100
      DX=FLOAT(N-1)/FLOAT(NSP-3)
      DO 10 I=1,NSP
      DO 10 J=1,5
   10 A(J,I)=0.0
C
      DO 40 L=1,N
      XL=FLOAT(L-1)/DX
      IF(XL.LT.0.0) XL=0.0
      LX=XL
      LX=MIN0(LX,NSP-4)
      XL=FLOAT(LX+1)-XL
      DO 20 J=1,4
      IF(J/2.EQ.1) GOTO 15
      S(J)=XL*XL*XL
      GOTO 20
   15 S(J)=1.0+3.0*(1.0+XL*(1.0-XL))*XL
      IF(J.EQ.2) XL=1.0-XL
   20 CONTINUE
      DO 30 I=1,4
      A(5,LX+I)=A(5,LX+I)+Y(L)*S(I)
      DO 30 J=1,I
      IJ=I+1-J
   30 A(IJ,LX+J)=A(IJ,LX+J)+S(I)*S(J)
   40 CONTINUE
C
      CALL BANDSL(A,NSP,5,IER)
      IF(IER.NE.0) GOTO 100
C
      DO 60 L=1,N
      XL=FLOAT(L-1)/DX
      IF(XL.LT.0.0) XL=0.0
      LX=XL
      LX=MIN0(LX,NSP-4)
      XL=FLOAT(LX+1)-XL
      SUM=0.0
      DO 50 J=1,4
      IF(J/2.EQ.1) GOTO 45
      SX=XL*XL*XL
      GOTO 50
   45 SX=1.0+3.0*(1.0+XL*(1.0-XL))*XL
      IF(J.EQ.2) XL=1.0-XL
   50 SUM=SUM+SX*A(5,LX+J)
      CHDF=CHDF+(SUM-Y(L))**2
      Y(L)=SUM
   60 CONTINUE
      CHDF=CHDF/FLOAT(N+2-NSP)
  100 RETURN
      END

C   23/08/85 511061956  MEMBER NAME  MCTAGF0  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      REAL FUNCTION MCTAGF(X,MARKMC)
C
C WEIGHTING FUNCTION FOR INTEGRATION OF TAGGING MC ENERGY DEPOSTION
C
C A.J.FINCH 8/3/84
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
CCCC  DATA SLOPE/0.025/
      DATA XMAX/190.0/
      DIMENSION SLOPE(10)
      DATA SLOPE  /3*0.025,7*0.0675/
      DATA SLOPE2/0.0325/
C  BEST SO FAR: 180,0.0675,0.035,0.40
      DATA PERCEN/0.45/
      LOGICAL FIRST/.TRUE./
C
      IF(FIRST)CUTOFF=-(LOG(PERCEN)/SLOPE(4))
      FIRST = .FALSE.
C
      IF(MARKMC.GE.4.AND.X.GE.CUTOFF)GOTO 4
         MCTAGF=EXP(-1.0*X*SLOPE(MARKMC))
         RETURN
C
C SPECIAL SECTION FOR MARKMC = 4 , AT LARGE X
 4    CONTINUE
         MCTAGF=PERCEN*EXP(-1.0*SLOPE2*(X-CUTOFF))
         IF(X.GT.XMAX)MCTAGF = 0.0
         RETURN
      END

C   17/07/80 705252116  MEMBER NAME  MCRDVC   (S)           FORTRAN
      SUBROUTINE MCRDVC( NST, N, * )
C-----------------------------------------------------------
C  VERSION OF 17/07/80      LAST MOD 03/09/80     E.ELSEN
C  CUTS FOR MC REDUCTION WORKIN ON 4-VECTORS
C  ERASES INVISIBLE PARTICLES
C  NST = START POSITION IN P(10,**)
C  N = NUMBER OF PARTICLES ( CHANGED IN PLACE )
C  RETURN 1 IF NOT ACCEPTED.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1),HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON P(10,100)
C
      DIMENSION JLONG(2)
C
      DIMENSION PCENTI(20)
      INTEGER NREJ(20) / 20*0 /
      DATA PMINC / .05/, COSS /.9703/, COSL /.92 /
      DATA ELGCUT / .05/, COSBAR /.793/, COSENL /.97/, COSENU /.89/
      DATA EMINIO / .25 /
C                                           EXTRA TRACK CUTS
      DATA ELGPHM /.15/
      DATA PMIN  / .1 /
C

      DATA NCALL / 0 /, NACC / 0 /
      DATA EBEAMI / 1.E10 /, EBEAMA / 0. /
      DATA IHIST / 0 /
C
      IF( IHIST .NE. 1 ) GO TO 2
      CALL THIST( 10001,'#OF LONG TRACKS$' )
      CALL DHIST( 10001, 0., 100. )
      CALL THIST( 10002,'#OF TRACKS$' )
      CALL DHIST( 10002, 0., 100. )
      CALL THIST( 10003,'RMIN2 BEFORE PATR CUT$' )
      CALL DHIST( 10003, 0., 200. )
      CALL THIST( 10004,'ACOPLANARITY--COS PHI$' )
      CALL DHIST( 10004, -1., .02  )
      CALL THIST( 10005,'SUMPL$' )
      CALL DHIST( 10005, 0., 60. )
      CALL THIST( 10006,'SHOWER TOTAL$' )
      CALL DHIST( 10006, 0., 60. )
      CALL THIST( 10007,'E-SHOWER BARREL$' )
      CALL DHIST( 10007, 0., 60. )
      CALL THIST( 10008,'SHOWER + P$' )
      CALL DHIST( 10008, 0., 60. )
      CALL THIST( 10009,'SHOWER + PL$' )
      CALL DHIST( 10009, 0., 60. )
      CALL THIST( 10015,'ETOTSL$' )
      CALL DHIST( 10015, 0., 60. )
      CALL THIST( 10020,'#OF LONG TRACKS AFTER CUT$' )
      CALL DHIST( 10020, 0., 100. )
      CALL THIST( 10021,'#OF TRACKS$ AFTER CUT' )
      CALL DHIST( 10021, 0., 100. )
      CALL THIST( 10022,'SHOWER TOTAL AFTER CUT$' )
      CALL DHIST( 10022, 0., 60. )
      CALL THIST( 10023,'E SHOWER BARREL AFTER CUT$' )
      CALL DHIST( 10023, 0., 60. )
      CALL THIST( 10024,'SUMPL AFTER CUT$' )
      CALL DHIST( 10024, 0., 60. )
    2 CONTINUE
C
C
      NCALL = NCALL + 1
C
  100 CONTINUE
C                                           ENERGY
  110 CONTINUE
      EBEA = EBGENL( 0 )
      IF( EBEA .LT. EBEAMI ) EBEAMI = EBEA
      IF( EBEA .GT. EBEAMA ) EBEAMA = EBEA
C
C                                           CHARGED TRACKS
      IF( N .GT. 0 ) GO TO 210
      NREJ( 3) = NREJ( 3) + 1
      GO TO 8000
C
  210 SUMPL = 0.
      SUMLZ = 0.
      SUMP = 0.
      SUMZ = 0.
      NTRKL = 0
      NTRK = 0
      RMIN1 = 10000.
      RMIN2 = 10000.
      ZMIN = 1000000.
      AZMIN = 1000000.
      EBAR = 0.
      ENDP = 0.
      ENDM = 0.
      SHWZ = 0.
C
C                                           LOOP OVER TRACKS
      J1 = NST + 1
      JN = NST + N
      JCOPY = NST
      DO 1000 J=J1, JN
      ACOSZ = ABS(P(3,J))/ P(6,J)
C     P(10,J) = J - NST
      IF( P(7,J) .EQ. 0. ) GO TO 1500
C                                           CHARGED
      IF( P(6,J) .LT. PMINC ) GO TO 1000
      IF( ACOSZ .GT. COSS ) GO TO 1000
      NTRK = NTRK + 1
      ZMIN = 0.
      SUMP = SUMP + P(6,J)
      SUMZ = SUMZ + P(3,J )
C                                           LG FOR CHARGED=MIN IONI.
      EZ = EMINIO * P(3,J) / P(6,J)
      IF( ACOSZ .GT. COSBAR ) GO TO 1420
      EBAR = EBAR + EMINIO
      SHWZ = SHWZ+ EZ
      GO TO 1440
C
 1420 IF( ACOSZ.GT.COSENL .OR. ACOSZ .LT.COSENU ) GO TO 1440
      SHWZ = SHWZ + EZ
      IF( EZ .LT. 0. ) GO TO 1430
      ENDP = ENDP + EMINIO
      GO TO 1440
 1430 ENDM = ENDM + EMINIO
 1440 CONTINUE
C                                           I.D.CUTS
      IF( ACOSZ .GT. COSL .OR. P(6,J).LT.PMIN ) GO TO 1900
      NTRKL = NTRKL + 1
      SUMPL = SUMPL + P(6,J)
      SUMLZ = SUMLZ + P(3,J)
      IF( NTRKL .GT. 2 ) GO TO 1900
      JLONG(NTRKL) = JCOPY + 1
      GO TO 1900
C
C                                           NEUTRALS
 1500 CONTINUE
      IF( P(5,J) .GT. .0001  ) GO TO 1000
C                                           ONLY GAMMA HERE
      IF( P(6,J) .LT. ELGCUT ) GO TO 1000
      IF( ACOSZ .GT. COSBAR ) GO TO 1520
      EBAR = EBAR + P(6,J)
      SHWZ = SHWZ+ P(3,J)
      GO TO 1900
C
 1520 IF( ACOSZ.GT.COSENL .OR. ACOSZ .LT.COSENU ) GO TO 1000
      SHWZ = SHWZ + P(3,J)
      IF( P(3,J) .LT. 0. ) GO TO 1530
      ENDP = ENDP + P(6,J)
      GO TO 1540
 1530 ENDM = ENDM + P(6,J)
 1540 CONTINUE
C
 1900 CONTINUE
C                                           EXTRA TRACK CUTS (NOT COUNTE
      IF( P(7,J) .EQ. 0. ) GO TO 1910
      IF( P(6,J) .LT. PMIN   ) GO TO 1000
      GO TO 1920
 1910 IF( P(6,J) .LT. ELGPHM ) GO TO 1000
 1920 CONTINUE
C
      JCOPY = JCOPY + 1
      IF( JCOPY .EQ. J ) GO TO 1000
      CALL PCOP( J, J, JCOPY )
C
 1000 CONTINUE
      N = JCOPY - NST
C
      IF( NTRK .GT. 0 ) GO TO 220
      NREJ(11) = NREJ(11) + 1
      GO TO 8000
C
  220 CONTINUE
C
      IF( IHIST .EQ. 1 ) CALL UHIST( 10001, FLOAT(NTRKL) )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10002, FLOAT(NTRK) )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10005, SUMPL )
C
C                                           PATR CUTS
      IF( NTRKL .GE. 2 .AND. NTRK .GE. 4 ) GO TO 310
      NREJ( 5) = NREJ( 5) + 1
      GO TO 8000
C
  310 CONTINUE
C
  320 IF( ABS(ZMIN) .LE. 400. ) GO TO 330
      NREJ( 7) = NREJ( 7) + 1
      GO TO 8000
C
  330 CONTINUE
C                                           ACOPLANARITY
      ACOP = 1.5
      IF( NTRKL .NE. 2 ) GO TO 400
      ACOP = ( P(1,JLONG(1))*P(1,JLONG(2)) +
     *         P(2,JLONG(1))*P(2,JLONG(2)) )/
     *       SQRT( ( P(1,JLONG(1))*P(1,JLONG(1)) +
     *               P(2,JLONG(1))*P(2,JLONG(1)) ) *
     *             ( P(1,JLONG(2))*P(1,JLONG(2)) +
     *               P(2,JLONG(2))*P(2,JLONG(2)) ))
      IF( IHIST .EQ. 1 ) CALL UHIST( 10004, ACOP )
      IF( ACOP .GT. -.9848 ) GO TO 400
      NREJ( 8) = NREJ( 8) + 1
      GO TO 8000
C
C
  400 CONTINUE
C
  410 CONTINUE
      ETOT = EBAR + ENDP + ENDM
      ESUM = SUMP + ETOT
      ESUML = SUMPL + ETOT
      IF( IHIST .EQ. 1 ) CALL UHIST( 10006, ETOT )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10007, EBAR )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10008, ESUM )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10009, ESUML )
      IF( EBAR .GT. 3. ) GO TO 420
      IF( ENDM.GT..4 .AND. ENDP.GT..4 ) GO TO 420
      NREJ( 9) = NREJ( 9) + 1
      GO TO 8000
C
  420 CONTINUE
C
      ETOTSL = SUMPL + ETOT
      RSL = ( SUMLZ + SHWZ ) / ETOTSL
      IF( IHIST .EQ. 1 ) CALL UCORR( 10004, RSL, ETOTSL )
C                                           MOMENTUM BALANCE
      IF( ABS(RSL) .LT. .4 ) GO TO 510
      NREJ(10) = NREJ(10) + 1
      GO TO 8000
C                                           TOTAL ENERGY
  510 IF( IHIST .EQ. 1 ) CALL UHIST( 10015, ETOTSL )
      IF( ETOTSL .GT. EBEA ) GO TO 520
      NREJ(14) = NREJ(14) + 1
      GO TO 8000
C
  520 CONTINUE
      IF( IHIST .NE. 1 ) GO TO 530
      CALL UHIST( 10020, FLOAT(NTRKL) )
      CALL UHIST( 10021, FLOAT(NTRK) )
      CALL UHIST( 10022, ETOT )
      CALL UHIST( 10023, EBAR )
      CALL UHIST( 10024, SUMPL )
C
C
  530 NACC = NACC + 1
      RETURN
C
C                                           REJECTED
 8000 RETURN 1
C
C
      ENTRY MCRDVF
C----------------------------------------------------------
C ENTRY TO PRINT STATISTICS
C TO BE CALLED AT END OF JOB .
C----------------------------------------------------------
      IF( NCALL .LE. 0 ) RETURN
      PCBAS = MAX0( NCALL, 1 ) * .01
      PCENT = NACC / PCBAS
      PCENTE = SQRT( FLOAT(NCALL - NACC) ) / PCBAS
      DO 8101 I=1,14
      PCENTI(I) = NREJ(I) / PCBAS
 8101 CONTINUE
      WRITE(6,9101) NCALL, NACC, PCENT, PCENTE, EBEAMI, EBEAMA
 9101 FORMAT(//10X,' SUMMARY FOR THIS FILE'/
     *       10X,'   EVENTS ANALYSED ',I8/
     *       10X,'   EVENTS ACCEPTED ',I8,'=',F7.2,' % +-',F5.2,' %',
     *                                   ,20X,F7.3,'=< EBEAM =<',F7.3,
     *           '  TAKEN FROM EBGENL'/)
      WRITE(6,9102) (NREJ(I),PCENTI(I),I=1,14)
 9102 FORMAT(10X,' REASONS FOR REJECTION'/
     */10X,'OBSOLETE                 ',I8,' =',F7.1,' %',
     */10X,'OBSOLETE                 ',I8,' =',F7.1,' %',
     */10X,'OBSOLETE                 ',I8,' =',F7.1,' %',
     */10X,'OBSOLETE                 ',I8,' =',F7.1,' %',
     */10X,'NTRKL < 2 AND NTRK < 4   ',I8,' =',F7.1,' %',
     */10X,'OBSOLETE                 ',I8,' =',F7.1,' %',
     */10X,'ZMIN > 400.              ',I8,' =',F7.1,' %',
     */10X,'ACOPL > 10 DEG           ',I8,' =',F7.1,' %',
     */10X,'E - BARREL < 3 GEV       ',
     */10X,'E+ OR E- < 400 MEV       ',I8,' =',F7.1,' %',
     */10X,'MOM BALANCE < .4         ',I8,' =',F7.1,' %',
     */10X,'NO TRACKS                ',I8,' =',F7.1,' %',
     */10X,'TOO MANY TRACKS          ',I8,' =',F7.1,' %',
     */10X,'OBSOLETE                 ',I8,' =',F7.1,' %',
     */10X,'ETOTSL < EBEAM           ',I8,' =',F7.1,' %')
C
C                                           CLEAR COUNTERS
      NACC = 0
      NCALL = 0
      CALL VZERO( NREJ, 20 )
      IF( IHIST .NE. 1 ) GO TO 8900
      CALL PHIST( 10001 )
      CALL PHIST( 10002 )
      CALL PHIST( 10003 )
      CALL PHIST( 10004 )
      CALL PHIST( 10005 )
      CALL PHIST( 10006 )
      CALL PHIST( 10007 )
      CALL PHIST( 10008 )
      CALL PHIST( 10009 )
      CALL PHIST( 10015 )
      CALL PHIST( 10020 )
      CALL PHIST( 10021 )
      CALL PHIST( 10022 )
      CALL PHIST( 10023 )
      CALL PHIST( 10024 )
      CALL PCORR( 10004 )
      CALL BDLS( 'HST*',  10001 )
      CALL BDLS( 'HST*',  10002 )
      CALL BDLS( 'HST*',  10003 )
      CALL BDLS( 'HST*',  10004 )
      CALL BDLS( 'HST*',  10005 )
      CALL BDLS( 'HST*',  10006 )
      CALL BDLS( 'HST*',  10007 )
      CALL BDLS( 'HST*',  10008 )
      CALL BDLS( 'HST*',  10009 )
      CALL BDLS( 'HST*',  10015 )
      CALL BDLS( 'HST*',  10020 )
      CALL BDLS( 'HST*',  10021 )
      CALL BDLS( 'HST*',  10022 )
      CALL BDLS( 'HST*',  10023 )
      CALL BDLS( 'HST*',  10024 )
      CALL BDLS( 'COR*',  10004 )
 8900 RETURN
      END

C   20/10/81 406182141  MEMBER NAME  MUPIC    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUPIC
C-----------------------------------------------------------------------
C
C LAST CHANGE 21.00 18/06/84 CHRIS BOWDERY - DRAW NOTHING IF NO CAL.
C      CHANGE 12.15  9/04/83 CHRIS BOWDERY - USE NEW MUFSTA FOR BODGE
C      CHANGE 12.30 31/03/82 HUGH MCCANN   - MODIFY BAD CHAMBER BODGE.
C      CHANGE 14.30 16/03/82 HUGH MCCANN   - TO BODGE GRAPHICS LIKE
C                                            MUCOOR RE DEAD CHAMS.
C      CHANGE 08.30 14/10/81 HUGH MCCANN   - TO DRAW (LONG) BASE OF YOKE
C      CHANGE 11.30 11/10/81 HUGH MCCANN   - TO DRAW Z-ENDS OF WIRES.
C      CHANGE 19.55 22/04/80 JOHN ALLISON  - TO DASH THE DEAD CHAMBERS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cmubcs.for"
#include "cgraph.for"
#include "cmucalib.for"
C
C------------------  C O D E  ------------------------------------------
C
      IPHEAD = IDATA(IBLN('HEAD'))
      IMONTH = HDATA(2*IPHEAD+7)
      IYEAR  = HDATA(2*IPHEAD+8)
      KRUN   = HDATA(2*IPHEAD+10)
      KREC   = HDATA(2*IPHEAD+11)
C
C                           FIX UP GRAPHICS PICTURE. DEAD CHAMBER BODGE.
C
      CALL MUFSTA( IMONTH, IYEAR )
C
C
      IF((LASTVW.LT.1).OR.(LASTVW.GT.11)) RETURN
      IVWN=3
      IF(LASTVW.GT.3) IVWN=2
      IF(LASTVW.GT.7) IVWN=1
C
C                            NO CALIBRATION? THEN RETURN
C
      IF( IZOEP1 .EQ. 0  .AND.  IZOEP3 .EQ. 0 ) RETURN
C
C
C
C                       IVWN = 1,2,3 FOR ZY,ZX,XY VIEWS RESPECTIVELY.
C
      GO TO (1,2,3),IVWN
C
 1    CONTINUE
C ZY VIEW - NO WIRES.
C FACE 3 AND 4 BLOCKS.
      X1=0.
      X2=0.
      DO 11 IFACE=3,4
      Z1=HBLLO(IFACE)
      Z2=HBLHI(IFACE)
      J=6*IFACE-5
      DO 11 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 11   CONTINUE
C FACE 5 AND 6 BLOCKS.
      DO 12 IFACE=5,6
      Y1=HBLLO(IFACE)
      Y2=HBLHI(IFACE)
      J=6*IFACE-5
      DO 12 IBLOCK=1,3
      Z1=HBNLIM(J)
      Z2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 12   CONTINUE
C
C DRAW YOKE.
      DO 19 I=1,2
      S=-1.
      IF(I.EQ.2)S=1.
      CALL MOVEA(FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(FLOAT(IZOEP5),S*IREP4)
      IF(S)14,14,16
   14 IYKLDM=HYKLDM(3)
      CALL DRAWA(FLOAT(IZOEP5),S*IXYEP5)
      CALL DRAWA(FLOAT(IYKLDM),S*IXYEP5)
      CALL DRAWA(FLOAT(IYKLDM),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IYKLDM),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IYKLDM),S*IXYEP5)
      CALL DRAWA(-FLOAT(IZOEP5),S*IXYEP5)
      GO TO 18
   16 CALL DRAWA(FLOAT(IZOEP5),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IZOEP5),S*HYKNMO(2))
   18 CALL DRAWA(-FLOAT(IZOEP5),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(-FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP1),S*IREP1)
 19   CONTINUE
      IFLO=3
      IFHI=6
      GO TO 4
C
 2    CONTINUE
C ZX VIEW - END WALL WIRES DISPLAYED.
      DO 21 ICHAM=443,634
      CALL MUWIRE(ICHAM,X,Y,Z)
      IF(HMCSTA(ICHAM).EQ.0)GO TO 201
      CALL XYMUD(X-150.,Y,Z,XS,YS)
      CALL MOVEA(XS,YS)
      CALL XYMUD(X+150.,Y,Z,XS,YS)
      CALL DASHA(XS,YS,45)
      GO TO 21
 201  CONTINUE
      CALL XYMUD(X,Y,Z,XS,YS)
      CALL POINTA(XS,YS)
 21   CONTINUE
C FACE 1 AND 2 BLOCKS.
      Y1=0.
      Y2=0.
      DO 22 IFACE=1,2
      Z1=HBLLO(IFACE)
      Z2=HBLHI(IFACE)
      J=6*IFACE-5
      DO 22 IBLOCK=1,3
      X1=HBNLIM(J)+HOVALL(IFACE)
      X2=HBNLIM(J+1)+HOVALL(IFACE)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 22   CONTINUE
C FACE 5 AND 6 BLOCKS - LEFT.
      DO 23 IFACE=5,6
      X1=HBTLO(IFACE)+HOVALL(4)
      X2=-50+HOVALL(4)
      J=6*IFACE-5
      DO 23 IBLOCK=1,3
      Z1=HBNLIM(J)
      Z2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 23   CONTINUE
C FACE 5 AND 6 BLOCKS - RIGHT.
      DO 24 IFACE=5,6
      X1=50+HOVALL(5)
      X2=HBTHI(IFACE)+HOVALL(5)
      J=6*IFACE-5
      DO 24 IBLOCK=1,3
      Z1=HBNLIM(J)
      Z2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 24   CONTINUE
C
C DRAW YOKE .
      DO 41 I=1,2
      S=-1.
      IF(I.EQ.2)S=1.
      CALL MOVEA(FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(FLOAT(IZOEP5),S*IREP4)
      CALL DRAWA(FLOAT(IZOEP5),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IZOEP5),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IZOEP5),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(-FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP1),S*IREP1)
 41   CONTINUE
      IFLO=1
      IFHI=2
C
  4   CONTINUE
C  DRAW LONGITUDINAL SENSITIVE LIMITS (ZY & ZX VIEWS ONLY ).
C  XS--- & YS--- REFER TO HORIZL & VERTL COORDS ON SCREEN.
C
      DO 49 IFACE=IFLO,IFHI
          DO 49 ILAYER=1,5
              IF(IFACE.GT.4.AND.ILAYER.EQ.1)GO TO 49
              DO 47 IFRAME=1,82
                  IFR=IFRAME
                  IF(HFACE(IFR).NE.IFACE)GO TO 47
                  IF(HLAYER(IFR).NE.ILAYER)GO TO 47
                  IF(IFACE.GT.4)GO TO 45
  43              CONTINUE
                  XSLO=HCLLO(IFR)
                  XSHI=HCLHI(IFR)
                  YSFIXD=HDIST(IFR)
                  IF(IFACE.LE.2.AND.ILAYER.GT.1)
     *            YSFIXD=YSFIXD+HOVALL(IFACE)
                  CALL MOVEA(XSLO+20.,YSFIXD-20.)
                  CALL DRAWA(XSLO    ,YSFIXD-20.)
                  CALL DRAWA(XSLO    ,YSFIXD+20.)
                  CALL DRAWA(XSLO+20.,YSFIXD+20.)
                  CALL MOVEA(XSHI-20.,YSFIXD-20.)
                  CALL DRAWA(XSHI    ,YSFIXD-20.)
                  CALL DRAWA(XSHI    ,YSFIXD+20.)
                  CALL DRAWA(XSHI-20.,YSFIXD+20)
                  IF(IFACE.NE.4)GO TO 49
                  IF(ILAYER.EQ.1.OR.ILAYER.EQ.2)GO TO 49
                  IF(IFR.EQ.47.OR.IFR.EQ.55.OR.IFR.EQ.63)GO TO 49
                  IFR=IFR+4
                  GO TO 43
   45             XSFIXD=HDIST(IFR)
                  YSLO=HCLLO(IFR)
                  YSHI=HCLHI(IFR)
                  CALL MOVEA(XSFIXD-20.,YSLO+20.)
                  CALL DRAWA(XSFIXD-20.,YSLO    )
                  CALL DRAWA(XSFIXD+20.,YSLO    )
                  CALL DRAWA(XSFIXD+20.,YSLO+20.)
                  CALL MOVEA(XSFIXD-20.,YSHI-20.)
                  CALL DRAWA(XSFIXD-20.,YSHI    )
                  CALL DRAWA(XSFIXD+20.,YSHI    )
                  CALL DRAWA(XSFIXD+20.,YSHI-20.)
                  GO TO 49
   47         CONTINUE
   49 CONTINUE
      GO TO 99
C
 3    CONTINUE
C XY VIEW - WIRES IN 'BARREL'.
      DO 31 ICHAM=1,442
      CALL MUWIRE(ICHAM,X,Y,Z)
      IF((ICHAM.GE.323.AND.ICHAM.LE.346)
     * .OR. (ICHAM.GE.371.AND.ICHAM.LE.394)
     * .OR. (ICHAM.GE.419.AND.ICHAM.LE.442))Y=Y+10.
      IF(HMCSTA(ICHAM).EQ.0)GO TO 301
      IFRAME=HFR(ICHAM)
      IF(HTRANS(IFRAME).GT.1)GO TO 302
      CALL XYMUD(X-150.,Y,Z,XS,YS)
      CALL MOVEA(XS,YS)
      CALL XYMUD(X+150.,Y,Z,XS,YS)
      CALL DASHA(XS,YS,45)
      GO TO 31
 302  CONTINUE
      CALL XYMUD(X,Y-150.,Z,XS,YS)
      CALL MOVEA(XS,YS)
      CALL XYMUD(X,Y+150.,Z,XS,YS)
      CALL DASHA(XS,YS,45)
      GO TO 31
 301  CONTINUE
      CALL XYMUD(X,Y,Z,XS,YS)
      CALL POINTA(XS,YS)
 31   CONTINUE
C FACE 1 AND 2 BLOCKS.
      Z1=0.
      Z2=0.
      DO 32 IFACE=1,2
      Y1=HBTLO(IFACE)
      Y2=HBTHI(IFACE)
      J=6*IFACE-5
      DO 32 IBLOCK=1,3
      X1=HBNLIM(J)+HOVALL(IFACE)
      X2=HBNLIM(J+1)+HOVALL(IFACE)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 32   CONTINUE
C FACE 3 BLOCKS.
      X1=HBTLO(3)
      X2=HBTHI(3)
      J=13
      DO 33 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 33   CONTINUE
C FACE 4 BLOCKS.
      X1=HBTLO(4)+HOVALL(4)
      X2=-50+HOVALL(4)
      J=19
      DO 34 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 34   CONTINUE
      X1=50+HOVALL(5)
      X2=HBTHI(4)+HOVALL(5)
      J=19
      DO 35 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 35   CONTINUE
C
C DRAW YOKE.
      XLO=HYKNMI(1)
      CALL MUVIER(XLO,XLO,-XLO,-XLO)
      XLO=HYKNMO(1)
      CALL MUVIER(XLO,XLO,-XLO,-XLO)
C
      GO TO 99
C
 99   CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE MUVIER(XLO,YLO,XHI,YHI)
C DRAWS A RECTANGLE.
      CALL MOVEA(XLO,YLO)
      CALL DRAWA(XLO,YHI)
      CALL DRAWA(XHI,YHI)
      CALL DRAWA(XHI,YLO)
      CALL DRAWA(XLO,YLO)
      RETURN
      END

C   02/11/81 312061508  MEMBER NAME  JTRKGM0  (S)           FORTRAN
      SUBROUTINE JTRKGM( PV, R0, * )
C--------------------------------------------------------
C
C  VERSION OF 02/11/81   LAST MOD 29/03/82      E.ELSEN
C  TRACK PHOTONS AND COPE WITH CONVERTING ONES.
C--------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      DIMENSION PV(10),R0(3),RR(3)
      DIMENSION P1(10),P2(10)
      COMMON / CJTRLE / TOTLEN, STPLEN, TRCOFS
C                                           TRACK PHOTONS
      CALL TRKGAM(PV,R0,RR,P1,P2,&34,&1000)
C
C                                           PHOTON CONVERTED, STORE ELEC
      TRCOFS = TRCOFS + SQRT(RR(1)**2 + RR(2)**2 + RR(3)**2)
      P1(8) = 2.
      P2(8) = 2.
      CALL SVECT1( P1 , RR )
      CALL SVECT1( P2 , RR )
      GO TO 1000
C
   34 CONTINUE
      DO 35 J=1,3
   35 R0(J) = RR(J)
      RETURN
C
 1000 CONTINUE
      RETURN 1
      END

C   24/11/78 C9082901   MEMBER NAME  ELGTOT   (JADENS)      FORTRAN
      SUBROUTINE ELGTOT(ESUM1)
C
C     TOTAL ENERGY IN LEAD GLASS COUNTERS: P.STEFFEN(78/11/15)
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
      ESUM = 0
C                                       CHECK IF ANY ENERGIES
      IALGL=IBLN('ALGL')
      IPLGL4=IDATA(IALGL)
      IF(IPLGL4.LE.0) GO TO 100
C                                       POINTER TO FIRST AND LAST ENERGY
      IP0 = IPLGL4*2+5
      IP9 = IP0 + HDATA(IP0-1) - 1
C                                       SUM ALL LG-ENERGIES
      DO 10 IP=IP0,IP9,2
         ESUM = ESUM + HDATA(IP+1)
  10  CONTINUE
C
 100  CONTINUE
      ESUM1 = ESUM
      RETURN
      END

C   10/02/86 604291350  MEMBER NAME  PRN50SR  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRN50S( IPN50S, XS, YS , DEL, SIZE ) 
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 29/04/86 :  PRINT BOS BANK N50S
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C
#include "cdata.for"
#include "cgraph.for"
C
      COMMON / CWORK1 / HWORK(70)
      COMMON / CWORK  / HDUM(8000),
     +                  HADC(2,42),HTDC(2,42),HTDC1(2,42),HADCF(2,16),
     +                  HTDCF(2,16),HTSPAR(16)
C
      DIMENSION HSX(13,16), HELP(2)
      EQUIVALENCE (IZWORD,HELP(1))
C
      DATA MASKMH  / Z001F /
      DATA HSX/
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'*M','UL','TI','HA','DR','ON','IC',' E','VE','NT','**','  ','  ',
     $'*N','ON','-B','AR','RE','L ','BH','AB','HA',' E','VE','NT','**',
     $'*B','AR','RE','L ','BH','AB','HA',' E','VE','NT','**','  ','  ',
     $'*2','-P','HO','TO','N ','EV','EN','T*','* ','  ','  ','  ','  ',
     $'*M','UO','N-','PA','IR',' E','VE','NT','**','  ','  ','  ','  ',
     $'*B','EA','M-','BE','AM',' E','VE','NT','**','  ','  ','  ','  ',
     $'*C','OS','MI','C ','EV','EN','T*','* ','  ','  ','  ','  ','  ',
     $'*B','EA','M-','GA','S ','EV','EN','T*','* ','  ','  ','  ','  ',
     $'*H','AL','O ','EV','EN','T*','* ','  ','  ','  ','  ','  ','  ',
     $'*L','UM','I ','EV','EN','T*','* ','  ','  ','  ','  ','  ','  ',
     $'*U','NI','DE','NT','IF','IE','D ','EV','EN','T*','* ','  ','  ',
     $'*R','EJ','EC','TE','D ','EV','EN','T*','* ','  ','  ','  ','  '/
C
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*140
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      LIM2 = IPN50S
      LH2  = LIM2*2
      YS   = YS - DEL
      CALL CORE(HWORK,86)
      WRITE(cHWORK,1) HDATA(LH2+3),HDATA(LH2+11),HDATA(LH2+12) ! PMF 17/11/99: JUSCRN changed to cHWORK
    1 FORMAT(' N50 PROGRAM VERSION ',I6,' ANALYSIS FLAG ',Z4,'  LOOSE MU
     &LTIHADRON SELECTION FLAG ',I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,86,0.)
C TRIGGERS
      NTRI = HDATA(LH2+4)
      IF( NTRI .GT. 0 ) GO TO 3
         YS = YS - DEL
         CALL CORE(HWORK,28)
         WRITE(cHWORK,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
    2    FORMAT(' ---> NO TRIGGER INFORMATION')
         CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
         GO TO 5
    3 YS = YS - DEL
      CALL CORE(HWORK,77)
      WRITE(cHWORK,4) (HDATA(LH2+NTRI+K),K=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
    4 FORMAT(' #T2 TRACKS ',I3,' R3 TRACKS CELLS 33-48 ',Z4,'  CELLS 17-
     &32 ',Z4,'  CELLS 1-16 ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,77,0.)
C COUNTERS
    5 NCOU = HDATA(LH2+5)
      IF( NCOU .GT. 0 ) GO TO 7
         YS = YS - DEL
         CALL CORE(HWORK,28)
         WRITE(cHWORK,6) ! PMF 17/11/99: JUSCRN changed to cHWORK
    6    FORMAT(' ---> NO COUNTER INFORMATION')
         CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
         GO TO 9
    7 AA = HDATA(LH2+NCOU+2)*.1
      YS = YS - DEL
      CALL CORE(HWORK,53)
      WRITE(cHWORK,8) HDATA(LH2+NCOU+1),AA,HDATA(LH2+NCOU+3), ! PMF 17/11/99: JUSCRN changed to cHWORK
     &                HDATA(LH2+NCOU+4)
    8 FORMAT(' #TOFS ',I3,' TDIF(NS) ',F8.1,' ZVTOF ',I6,' ZVLG ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,53,0.)
C LEAD GLASS
    9 NL = HDATA(LH2+6)
      IF( NL .GT. 0 ) GO TO 11
         YS = YS - DEL
         CALL CORE(HWORK,31)
         WRITE(cHWORK,10) ! PMF 17/11/99: JUSCRN changed to cHWORK
   10    FORMAT(' ---> NO LEAD GLASS INFORMATION')
         CALL SYSSYM(XS,YS,SIZE,HWORK,31,0.)
         GO TO 13
   11 AA1 = HDATA(LH2+NL+5)*.001
      AA2 = HDATA(LH2+NL+6)*.001
      AA3 = HDATA(LH2+NL+7)*.001
      AA4 = HDATA(LH2+NL+8)*.001
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(cHWORK,12) (HDATA(LH2+NL+K),K=1,4),AA1,AA2,AA3,AA4, ! PMF 17/11/99: JUSCRN changed to cHWORK
     &                 (HDATA(LH2+NL+KK),KK=9,10)
   12 FORMAT(' NR CLUSTERS TOTAL,BARREL,-EC,+EC : ',4I5,' ENERGIES: ',
     &4F8.3,' NHCLI ',I6,' ERES ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
C INNER DETECTOR ANALYSIS
   13 ND = HDATA(LH2+7)
      IF( ND .GT. 0 ) GO TO 15
         YS = YS - DEL
         CALL CORE(HWORK,35)
         WRITE(cHWORK,14) ! PMF 17/11/99: JUSCRN changed to cHWORK
   14    FORMAT(' ---> NO INNER DETECTOR INFORMATION')
         CALL SYSSYM(XS,YS,SIZE,HWORK,35,0.)
         GO TO 24
   15 CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(cHWORK,16) (HDATA(LH2+ND+K),K=1,3) ! PMF 17/11/99: JUSCRN changed to cHWORK
   16 FORMAT(' ID ZVTX FLAG ',I3,'  ZVTX IN MM ',I6,' INRGZV ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
      YS   = YS - DEL
      NTR  = HDATA(LH2+ND+4)
      NTRT = HDATA(LH2+ND+5)
      CALL CORE(HWORK,47)
      IF( NTR .LT. 0 ) WRITE(cHWORK,17) ! PMF 17/11/99: JUSCRN changed to cHWORK
   17 FORMAT(' PATTERN RECOGNITION NOT PERFORMED             ')
      IF( NTR .EQ. 0 ) WRITE(cHWORK,18) ! PMF 17/11/99: JUSCRN changed to cHWORK
   18 FORMAT(' PATTERN RECOGNITION PERFORMED, NO TRACKS FOUND')
      IF( NTR .LE. 0 ) CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      IF( NTR .LE. 0 ) GO TO 24
      WRITE(cHWORK,19) NTR ! PMF 17/11/99: JUSCRN changed to cHWORK
   19 FORMAT(' PATTERN RECOGNITION PERFORMED,',I3,' TRACKS FOUND')
      CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      LORT = HDATA(LH2+ND+6)
      LTRT = HDATA(LH2+ND+7)
      IPLT = LH2 + ND + LORT - LTRT
      YS   = YS - DEL
      CALL CORE(HWORK,48)
      WRITE(cHWORK,20) NTRT,LORT,LTRT ! PMF 17/11/99: JUSCRN changed to cHWORK
   20 FORMAT(' TRACKS LISTED ',I4,'  LO AND LT FOR EACH ',2I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,48,0.)
C
      DO 23  ITR = 1,NTRT
         IPLT    = IPLT + LTRT
         X1      = HDATA(IPLT+1)*.1
         Y1      = HDATA(IPLT+2)*.1
         Z1      = HDATA(IPLT+3)*.1
         X2      = HDATA(IPLT+4)*.1
         Y2      = HDATA(IPLT+5)*.1
         Z2      = HDATA(IPLT+6)*.1
         HELP(1) = HDATA(IPLT+8)
         HELP(2) = HDATA(IPLT+9)
         RR      = FLOAT(IZWORD)*.1
         SIGXY   = HDATA(IPLT+10)*10.
         NXY     = HDATA(IPLT+11)
         TANTH   = HDATA(IPLT+12)
         Z0      = HDATA(IPLT+13)*.1
         SIGZ    = HDATA(IPLT+14)*.1
         NZ      = HDATA(IPLT+15)
         YS      = YS - DEL
         CALL CORE(HWORK,114)
         WRITE(cHWORK,21) ITR,X1,Y1,Z1,X2,Y2,Z2,RR,SIGXY,NXY ! PMF 17/11/99: JUSCRN changed to cHWORK
   21    FORMAT(' ',I2,' XYZ1 ',3F8.1,' XYZ2 ',3F8.1,' RADIUS ',E14.6,
     &'  SIGXY(MY) ',F10.0,' NXY ',I2)
         CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
C
         YS = YS - DEL
         CALL CORE(HWORK,114)
         WRITE(cHWORK,22) TANTH,Z0,SIGZ,NZ ! PMF 17/11/99: JUSCRN changed to cHWORK
   22    FORMAT(' ',59X,' TANTHETA ',F10.0,' Z0 ',F8.1,' SIGZ(MM) ',
     &   F6.1,' NZ ',I2)
         CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
C
   23 CONTINUE
C
   24 NM = HDATA(LH2+8)
      IF( NM .GT. 0 ) GO TO 26
         YS = YS - DEL
         CALL CORE(HWORK,25)
         WRITE(cHWORK,25) ! PMF 17/11/99: JUSCRN changed to cHWORK
   25    FORMAT(' ---> NO MUON INFORMATION')
         CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
         GO TO 29
   26 CONTINUE
      YS  = YS - DEL
      NMU = HDATA(LH2+NM)
      IF( NMU .GT. 5 ) NMU = 5
      NCORE = 44 + NMU*4
      NMU   = 2*NMU + 1
      CALL CORE(HWORK,64)
      WRITE(cHWORK,27) HDATA(LH2+NM),HDATA(LH2+NM+1), ! PMF 17/11/99: JUSCRN changed to cHWORK
     &                (HDATA(LH2+NM+K),K=2,NMU,2)
   27 FORMAT(' NR MUON TRACKS ',I2,'   IN BARREL ',I3,' POSITION ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
      YS = YS - DEL
      CALL CORE(HWORK,64)
      WRITE(cHWORK,28) (HDATA(LH2+NM+K+1),K = 2,NMU,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
   28 FORMAT('                ',3X,'             ',3X,' QUALITY ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
C
   29 CONTINUE
      NTG = HDATA(LH2+9)
      IF( NTG .GT. 0 ) GO TO 31
         YS = YS - DEL
         CALL CORE(HWORK,25)
         WRITE(cHWORK,30) ! PMF 17/11/99: JUSCRN changed to cHWORK
   30    FORMAT(' ---> NO TAGG INFORMATION')
         CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
         GO TO 33
   31 CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,50)
      WRITE(cHWORK,32) (HDATA(LH2+NTG+K),K=1,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
   32 FORMAT(' TAGGING ENERGIES(MEV) IN -Z, +Z: ',2I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
C
   33 CONTINUE
C WRITE NOW N50 ACTION WORD, FROM THE HEADBANK
      IPHEA  = IDATA(IBLN('HEAD'))
      N50ACT = HDATA(2*IPHEA+26)
      YS     = YS - DEL
      CALL CORE(HWORK,45)
      WRITE(cHWORK,34) N50ACT ! PMF 17/11/99: JUSCRN changed to cHWORK
   34 FORMAT('  NORD 50 ACTION WORD FROM HEAD BANK 26: ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,45,0.)
C
      IF( LAND(N50ACT,MASKMH) .NE. 0 ) GO TO 38
         N50ACT = ISHFTL(N50ACT,1)
         DO 37 IBT = 1,16
            N50ACT = ISHFTR(N50ACT,1)
            IF( IBT .LT. 6 ) GO TO 37
            IF( .NOT. TBIT(N50ACT,31) ) GO TO 37
C BIT IBT IS ON, WRITE CORRESPONDING INFORMATION
               DO 35  I = 1,13
                  HDUM(I) = HSX(I,IBT)
   35          CONTINUE
               YS = YS - 2*DEL
               CALL CORE(HWORK,43)
               WRITE(cHWORK,36) (HDUM(I),I=1,13) ! PMF 17/11/99: JUSCRN changed to cHWORK
   36          FORMAT('  CLASSIFICATION ',13A2)
               CALL SYSSYM(XS,YS,SIZE,HWORK,43,0.)
   37    CONTINUE
         GO TO 41
   38 MUH = LAND(N50ACT,MASKMH)
      DO 39  I = 1,13
         HDUM(I) = HSX(I,5)
   39 CONTINUE
      YS = YS - 2*DEL
      CALL CORE(HWORK,61)
      WRITE(cHWORK,40) (HDUM(I),I=1,13),MUH ! PMF 17/11/99: JUSCRN changed to cHWORK
   40 FORMAT('  CLASSIFICATION ',13A2,' MULTIPLICITY ',I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,61,0.)
   41 CONTINUE
      RETURN
      END

C   08/07/80 301061240  MEMBER NAME  USREDUC2 (JADEGS)      FORTRAN
C   04/06/80 006061316  MEMBER NAME  USREDUC2 (JADESR)      FORTRAN
      SUBROUTINE USER(INDEX)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C---     SPECIAL VERSION FOR SECOND DATA REDUCTION STEP
C--   J.OLSSON    09.07.79        LAST CHANGE 20.01.82
      IMPLICIT INTEGER*2 (H)
C
      COMMON // BLCOMM(27000)
#include "cgraph.for"
#include "cgeo1.for"
#include "cpatlm.for"
#include "cjdrch.for"
      COMMON /CLERGY/ ECYLM,ECYLP
      COMMON /CREDON/LIMHIT,LIMHT1,CRVTAG,CRVNTG
      COMMON /CREDTV/ CRVLIM,LMHITS,RPLIM,RPLIM1,RATLIM,COSCUT,ZVTXLM,
     $ ZVXLM1,ZVXLM2,ETOTLM,ETOTKP,ETCYKP,ETE1KP,ETE2KP,ZMLIM,FIDEL,
     $ XLM,YLM,ZLM,ERGL,ETAGLM,ETOTCT,TSUMC1,TSUMC2
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
      COMMON /CTLIM/ ISECLF
      COMMON /CHEADR/ HEAD(108)
      EQUIVALENCE (HRUN,HEAD(18)),(HEVENT,HEAD(19))
#include "cdata.for"
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR
      COMMON /CJTRIG/ PI,TWOPI
      COMMON /CIGG/ IPRN,IGG(80),JIGG(80)
      DIMENSION HELP(2),HELP2(2),THHELP(3)
      EQUIVALENCE (ICAMWD,HELP(1)),(HELP2(1),ICMWD2)
      DATA MSKLUM /Z102/,MSKLM1/Z100/,MKFWMU/Z800/,MKFWM1/Z80/
      DATA  HELP/0,0/,HELP2/0,0/
C--------------------------------------------
C---
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   MUON CHAMBER TRACKING HAS BEEN DONE.
C              9   MUON AND INNER DETECTOR TRACKS HAVE BEEN ASSOCIATED.
C             10   UNUSED
C---
C---     CHECK WHETHER CALL AT END OF JOB
      IF(INDEX.EQ.100) GOTO 9900
C
      GO TO (100,200,300,400,500,600,700,800,900,1000),INDEX
C---
C---     INDEX=0 INITIALIZATION.
C---
C
      DO 50  I = 1,80
      JIGG(I) = 0
50    IGG(I) = 0
      ISECLF = 15
      HRUNTP = -4
      NNREC = 1
      NMREC = 0
      EBMSTR = 0.
C  IHIST FOR HISTOGRAMS;  IRED1 FOR REDUC1;   IPRN FOR DEBUG PRINT;
C  ICALIB FOR RECALIBRATION OF LEAD GLASS, ICALJC FOR INNER DETECTOR
C  IREPAT FOR PATTERN RECOGNITION, WITH FOLLOWING OPTIONS:
C  1: SLOW FOR ALL, 2 EXISTING ONE FOR SELECT, REDO SLOW
C  3: FAST FOR ALL, REDO SLOW FOR SELECTED EVENTS;  0 FOR NO PATREC
      READ 6310,IHIST,IRED1,MAXEVS,IPRN,ICALIB,ICALJC,IREPAT
      READ 6310,NNRMIN,NNRMAX,HRUNMI,HRUNMX,IREFRM,ITMLOG,IPATRJ
6310  FORMAT(7I10)
      WRITE(6,6312) IHIST,IRED1,ICALIB,ICALJC,IREPAT,IPRN
6312  FORMAT(' IHIST IRED1 ICALIB ICALJC IREPAT IPRN ',6I8)
      WRITE(6,6313) NNRMIN,NNRMAX,MAXEVS,HRUNMI,HRUNMX
6313  FORMAT(' NNRMIN NNRMAX MAXEVS ',3I10,'   RUN LIMITS ',2I10)
      WRITE(6,6314) IREFRM,ITMLOG,IPATRJ
6314  FORMAT(' IREFRM ITMLOG IPATRJ ',3I10)
      IF(IREPAT.EQ.3) IPFAST = 0
      IF(IHIST.EQ.0) ISECLF = 2
      IF(ITMLOG.EQ.1) CALL TMLOG(10,8HUSER    )
      CALL HBOOK1(1,'ETOT ALL $',100,    0., 40000.)
      CALL HBOOK1(2,'ETOT ALL $',100,    0., 5000.)
      CALL HBOOK1(3,'ETOT FOR TAGGED EVENTS $',100,    0., 20000.)
      CALL HBOOK1(4,'ETOT FOR IAC=-1 EVENTS $',100,    0., 20000.)
      CALL HBOOK1(5,'ETOT FOR IAC.GE.0 EVENTS $',100,    0., 40000.)
      CALL HBOOK1(6,'ECYL FOR IAC.GE.0 EVENTS $',100,    0., 40000.)
      CALL HBOOK1(7,'ECAMI FOR IAC.GE.0 EVENTS $',100,    0., 40000.)
      CALL HBOOK1(8,'ECAPL FOR IAC.GE.0 EVENTS $',100,    0., 40000.)
      CALL HBOOK1(9,'ETOT FOR EVENTS WITHOUT ZVTX$',100,    0., 40000.)
      CALL HBOOK1(10,'ZVTX  $',100, -500., 500.)
      CALL HBOOK2(11,'ETOT VS ZVTX$',100,-500.,500.,50,0.,40000.)
      CALL HBOOK1(12,'ZVTX,ETOT>2 GEV $',100, -500., 500.)
      CALL HBOOK2(13,'ETOT VS ZVTX,IWRT=0$',100,-500.,500.,50,0.,10000.)
      CALL HBOOK2(14,'ETOT VS ZVTX,IWRT=1$',100,-500.,500.,50,0.,40000.)
      CALL HBOOK1(15,'NTR AFTER ZVTX REJECTS$',100,-.5,49.5)
      CALL HBOOK1(16,'ETOT FOR NTR=0 EVENTS $',100,    0., 40000.)
      CALL HBOOK1(17,'ZVTX, NTR=0 $',100, -500., 500.)
      CALL HBOOK1(18,'ETOT FOR ISTAR = 0 & 2  EVENTS$',100,0.,20000.)
      CALL HBOOK1(19,'ETOT FOR ISTAR=1 EVENTS$',100,0.,20000.)
C     CALL HBOOK1(20,'ETOT FOR ISTAR=2 EVENTS$',100,0.,20000.)
      CALL HBOOK1(21,'RATIO     $',100,0.01,1.01)
C     CALL HBOOK2(22,'RATIO VS ZVTX$',100,-500.,500.,51,0.,1.02)
C     CALL HBOOK2(23,'ICNTR VS IGDNTR$',50,0.,12.5,50,0.,12.5)
      CALL HBOOK2(24,'E VS ZVX,RATIO FAIL$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK2(25,'E VS ZVX,NTR.NE.2$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK2(26,'E VS ZVX,NTR=2,BF TH$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK2(27,'E VS ZVX,NTR=2,AF TH$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK1(28,'ABS THETA-PI TWOPRONG$',100,0.,4.)
      CALL HBOOK1(29,'T-DIFF. IN LOW-E TWOPRONGS$',100,-10.,30.)
      CALL HBOOK2(30,'EVSZVX,COSMIC 2PRNGS$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK2(31,'E VS ZVX, R2 OK$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK2(32,'EVSZVX,R2 OK,ICOSM=1$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK2(33,'E VS ZVX, R2 NOK$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK1(34,'NCLST $',100,-.5,49.5)
      CALL HBOOK1(35,'ETOT FOR NCLST.LE.1 EVENTS$',100,0.,5000.)
      CALL HBOOK1(36,'ETOT FOR HWORLD REJECTS$',100,0.,40000.)
      CALL HBOOK1(37,'ETOT FOR COLLINEAR REJECTS$',100,0.,5000.)
      CALL HBOOK2(38,'E VS ZVX,COLL. RJCTS$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK1(39,'ETOT FOR COLLINEAR ACCEPTS$',100,0.,5000.)
      CALL HBOOK2(40,'E VS ZVX,COLL. ACPTS$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK1(41,'NTR FOR COLLINEAR ACCEPTS$',100,-.5,49.5)
      CALL HBOOK2(42,'E VS ZV REJECTED EV$',100,-500.,500.,50,0.,5000.)
      CALL HBOOK1(43,'ETOT FOR REJECTED EVS$',100,0.,5000.)
      CALL HBOOK1(44,'REJECT FLAG AND WRITE FLAG$',100,-.25,49.75)
      CALL HBOOK2(45,'E VS ZV ACCEPTED EV$',100,-500.,500.,50,0.,40000.)
      CALL HBOOK1(46,'ZVTX     ACCEPTED EVENTS $',100, -500., 500.)
      CALL HBOOK1(47,'ETOT     ACCEPTED EVENTS$',100,0.,40000.)
      CALL HBOOK1(48,'NTR FOR  ACCEPTED EVENTS$',100,-.5,49.5)
      CALL HBOOK1(49,'COS OF COLLINEARITY ANGLE$',100,-1.,-0.7)
C     CALL HBOOK1(50,'IBM ACTION FOR REJECTS $',100,0.,100.)
C     CALL HBOOK1(51,'IBM ACTION FOR ACCEPTS $',100,0.,100.)
      CALL HBOOK1(52,'ZVTX     REJECTED EVENTS $',100, -500., 500.)
      CALL HBOOK1(53,'ETOT,TAGS WITH NTR=0 $',100,    0., 4000.)
      CALL HBOOK1(54,'TOF SUM, COLL.FEWPRONGS$',100, -50., 250.)
      CALL HBOOK2(55,'TOFSUM VS TOFDIF$',100,-10.,30.,100,-50.,250.)
      CALL HBOOK2(57,'EVSZV TRGCHK RJC$',100,-500.,500.,50,0.,8000.)
      CALL HBOOK1(61,'ZVTX LUMI TRIGGER REJECTS$',100, -500., 500.)
      CALL HBOOK1(62,'ZVTX ZVTX > LIMITS REJCTS$',100, -500., 500.)
      CALL HBOOK1(63,'ZVTX SPECIAL RATIO,ZVTX  $',100, -500., 500.)
      CALL HBOOK1(64,'ZVTX SPECIAL RATIO,ZVTX  $',100, -500., 500.)
      CALL HBOOK1(65,'ZVTX COSMIC REJECTS      $',100, -500., 500.)
      CALL HBOOK1(66,'ZVTX RATIO FAILURE FEWPR $',100, -500., 500.)
      CALL HBOOK1(67,'ZVTX LGCL ERROR,REJECTS  $',100, -500., 500.)
      CALL HBOOK1(69,'ZVTX  NCLST=1,NO ECAPS RJ$',100, -500., 500.)
      CALL HBOOK1(70,'ZVTX ALGN MISSING,REJECTS$',100, -500., 500.)
      CALL HBOOK1(71,'ZVTX HWORLD REJECTS      $',100, -500., 500.)
      CALL HBOOK1(72,'ZVTX NTR=0,IDHITS>1000   $',100, -500., 500.)
      CALL HBOOK1(73,'ZVTX NO COLLINEAR REJECTS$',100, -500., 500.)
      CALL HBOOK1(75,'ZVTX  REDUC1 REJECTS     $',100, -500., 500.)
      CALL HBOOK1(76,'ZVTX  TRGCHK REJECTS     $',100, -500., 500.)
      CALL HBOOK1(81,'ZVTX  WRITFLAG AND TRACKS$',100, -500., 500.)
      CALL HBOOK1(82,'ZVTX  NTRNE2,NE3 RATIO OK$',100, -500., 500.)
      CALL HBOOK1(83,'ZVTX  2,3 PRONGS,NONCOLL.$',100, -500., 500.)
      CALL HBOOK1(84,'ZVTX  COLL NOCOSM, RAT OK$',100, -500., 500.)
      CALL HBOOK1(85,'ZVTX  COLLIN CLUSTERS    $',100, -500., 500.)
      CALL HBOOK1(86,'ZVTX  FEW CLUST, GOOD E  $',100, -500., 500.)
      CALL HBOOK1(87,'ZVTX  NEUTRAL TAGS       $',100, -500., 500.)
      CALL HBOOK1(88,'ZVTX  1 CLUST, ECAP ERGY $',100, -500., 500.)
      CALL HBOOK1(89,'ZVTX TAGGED NTR=1 ACCEPTS$',100, -500., 500.)
      CALL HBOOK1(101,'NR OF HITS IN RZ$',100,-0.75,99.25)
      CALL HBOOK1(102,'THETA OF TRACKS$',100,-2.0,2.0)
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C *******************************************************************
C -------------------------------------------------------------------
100   CONTINUE
C                                    BEGIN OF EACH RUN
      IF(IPRN.GT.0) WRITE(6,1709) HRUN
1709  FORMAT(' RUN ',I10)
      IF(IGG(2).NE.0.AND.IPRN.EQ.2) WRITE(6,1717) (IGG(I),I=1,80)
      DO 9785 I = 2,80
      JIGG(I) = JIGG(I) + IGG(I)
 9785 IGG(I) = 0
      NRUN = HEAD(18)
C   RUN NO.
      IGG(1) = HRUN
      WRITE(JUSCRN,102) HRUN,HEVENT,HEAD(20)
102   FORMAT(' ****** RUN NR ',I5,' FIRST EVENT IS ',I8,' REC.TYPE ',I8)
      WRITE(JUSCRN,2027) IGG(80)
2027  FORMAT(' NR OF EVENTS WRITTEN SO FAR  ----- >>>> ',I10)
      IF(HRUN.GT.1400) ZFITLM(1) = 70.
      IF(HRUN.GT.1400) ZFITLM(2) = 35.
      EBM = EBEAM(HRUN)
      IF(EBM.NE.EBMSTR) GO TO 1612
      GO TO 1021
1612  EBMSTR = EBM
      MMREC = NNREC + 1
C DECIDE BEAM ENERGY AND LIMITS
      IF(EBM.GT.9000.) GO TO 1029
C ENTER HERE FOR    NEW LIMITS   FOR LOW ENERGY DATA
      WRITE(6,1671) MMREC,HRUN,HEVENT,EBM
1671  FORMAT(' LOW ENERGY DATA, RECORD,RUN EVENT ',3I8,' EBEAM ',E12.4)
C SCALE 6 GEV LIMITS TO BEAM ENERGY
      EBMFRA = EBM/6000.
      ETOTKP = 2500.*EBMFRA
      ETCYKP = 1250.*EBMFRA
      ETE1KP = 1500.*EBMFRA
      ETE2KP = 500.
      RPLIM = 40.
      RPLIM1 = 15.
      GO TO 1024
C ENTER HERE FOR    NEW LIMITS   FOR HIGH ENERGY DATA
1029  WRITE(6,1672) MMREC,HRUN,HEVENT,EBM
1672  FORMAT(' HIGH ENERGY DATA ,RECORD,RUN EVENT ',3I8,' EBEAM ',E12.4)
      EBMFRA = EBM/15000.
      ETOTKP = 7000.*EBMFRA
      ETCYKP = 3500.*EBMFRA
      ETE1KP = 4000.*EBMFRA
      ETE2KP = 500.
      RPLIM = 30.
      RPLIM1 = 10.
1024  WRITE(6,1022)
1022  FORMAT(' ZVTXLM  LMHITS  ETOTKP  ETOTCT  ETAGLM  COSCUT   ZMLIM
     $RPLIM  RPLIM1  RATLIM  CRVLIM  ZVXLM1  ZVXLM2')
      WRITE(6,1023) ZVTXLM,LMHITS,ETOTKP,ETOTCT,ETAGLM,COSCUT,ZMLIM,
     $ RPLIM,RPLIM1,RATLIM,CRVLIM,ZVXLM1,ZVXLM2
1023  FORMAT(' ',F6.1,I8,F8.1,F8.1,F8.1,F8.1,F8.1,F8.3,F8.3,F8.3,F8.5,
     $ F8.1,F8.1)
      WRITE(6,1027) ETCYKP,ETE1KP,ETE2KP,TSUMC1,TSUMC2
1027  FORMAT(' ETCYKP  ETE1KP  ETE2KP  ',3F8.1,' TSUMC1-2 ',2F8.1)
      WRITE(6,1037) LIMHIT,LIMHT1,CRVTAG,CRVNTG
1037  FORMAT(' REDUC1 LIMITS: LIMHIT LIMHT1 CRVTAG & NTG ',2I5,2E12.4)
1021  INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C *******************************************************************
C -------------------------------------------------------------------
200   CONTINUE
C                                                         SELECT EVENT
      IGG(2) = IGG(2) + 1
      NNREC = IGG(2) + JIGG(2)
      IF((NNREC/100)*100.EQ.NNREC) WRITE(6,2702)NNREC,HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
      IF(IREFRM.EQ.1.AND.HEAD(19).LT.13) GO TO 7171
      IF(HEAD(18).LT.HRUNMI) GO TO 7171
      IF(NNREC.LT.NNRMIN) GO TO 7171
      IF(HEAD(18).GT.HRUNMX) GO TO 12
      IF(NNREC.GT.NNRMAX) GO TO 12
      NMREC = NMREC + 1
      ZVTX = -600.
      IFLAG=-1
      LRJCT = 0
      LWRIT = 0
      CALL RDATA(IER,HEAD(18))
      IF(IER.NE.0) GO TO 1752
      IF(HEAD(20).EQ.1.OR.HEAD(20).EQ.13) GO TO 1751
      IF(HRUNTP.NE.HEAD(18)) WRITE(6,1753) HEAD(18),HEAD(20)
1753  FORMAT(' * * * * RUN NR ',I8,'   HAS RECORD TYPE ',I8)
      HRUNTP = HEAD(18)
      GO TO 1751
1752  LRJCT = 16
      IGG(70) = IGG(70) + 1
      GO TO 1
C--- EVENT NOT REAL DATA  ------------------------>>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 16      ***
C                                              ************************
1751  ISTAR = 0
      NTR= 0
C   OVERFLOW MARKER
      IFLW= 0
      IF(HEAD(23).NE.0) IFLW = 1
      IF(IFLW.EQ.1) IGG(3)=IGG(3)+1
      IF(IREFRM.EQ.1) GO TO 2457
      IPPO = IDATA(IBLN('PATR'))
      IF(IPPO.GT.0) GO TO 2457
      ITRG = IDATA(IBLN('TRIG'))
      HELP(2) = HDATA(2*ITRG + IDATA(ITRG)*2)
      IF(ICAMWD.EQ.MSKLUM.OR.ICAMWD.EQ.MSKLM1) GO TO 2457
      WRITE(6,2458) HEAD(18),HEAD(19)
2458  FORMAT(' EVENT WITH NO PATR BANK AT LEVEL 2',2I8)
C
C     RECALIBRATION HERE IF REQUESTED, PARAMETER ICALIB
C
2457  IF(ICALIB.EQ.0.OR.HRUN.LT.100) GO TO 2010
      CALL BDLS('ALGN',1)
      CALL BDLS('LGCL',1)
C     CALL BGAR(IGA)
2010  IF(ICALJC.EQ.0.OR.HRUN.LT.100) GO TO 2011
C     RECALIBRATE JETC BANK
      IPNJET=IDATA(IBLN('JETC'))
      IF(IPNJET.GT.20000) WRITE(6,445) IPNJET,HRUN,HEVENT
445   FORMAT('0UNORTHODOX IPNJET = ',I10,' AT: ',2I8)
      IF(IPNJET.LT.4.OR.IPNJET.GT.20000) GO TO 1
      NUMJET=IDATA(IPNJET-2)
      IPNNEX=IDATA(IPNJET-1)
      IF(IPNNEX.GT.20000) WRITE(6,446) IPNNEX,HRUN,HEVENT
446   FORMAT('0UNORTHODOX IPNNEX = ',I10,' AT: ',2I8)
      IF(IPNNEX.LT.4.OR.IPNNEX.GT.20000) GO TO 1
      NUMNEX=IDATA(IPNNEX-2)
      CALL BDLS('JETC',NUMJET)
      IPNJET=IDATA(IBLN('JETC'))
      IF(IPNJET.GT.20000) WRITE(6,447) IPNJET,HRUN,HEVENT
447   FORMAT('0UNORTHODOX IPNJET (TWO) = ',I10,' AT: ',2I8)
      IF(IPNJET.LT.4.OR.IPNJET.GT.20000) GO TO 1
      CALL BRNM('JETC',NUMNEX,'JETC',NUMJET)
C   REDO PATTERN RECOGNITION IF REQUESTED, PARAMETER IREPAT
2011  IF((IREPAT.NE.1.AND.IREPAT.NE.3).OR.HRUN.LT.100) GO TO 2013
      IPPR =IDATA(IBLN('PATR'))
      IF(IPPR.LE.0) GO TO 2013
      NUMPPR=IDATA(IPPR-2)
      CALL BDLS('PATR',NUMPPR)
2013  INDEX=INDEX+1
      IPPR =IDATA(IBLN('PATR'))
      IF(IPPR.LE.0) IGG(77) = IGG(77) + 1
      RETURN
C -------------------------------------------------------------------
C *******************************************************************
C -------------------------------------------------------------------
300   CONTINUE
C                                           LEAD GLASS CALIBRATION DONE
CALL TRIGGER CHECK, USED IN REDUC1
      IF(IRED1.EQ.0) GO TO 3011
      LBTRBT = 0
      ITRG = IDATA(IBLN('TRIG'))
      IF(ITRG.EQ.0) GO TO 3011
      IF(IDATA(ITRG-2).NE.1) GO TO 3011
      LBTRBT = HDATA(2*ITRG  + 10)
C  SKIP TRGCHK FOR FORWARD MUON TRIGGER
      IMUACC=0
      IF(LAND(LBTRBT,MKFWMU).NE.0) CALL MEWT3(IMUACC)
      IF(LAND(LBTRBT,MKFWM1).NE.0) CALL MEWT3(IMUACC)
      IF(IMUACC.GT.0) GO TO 3011
      CALL TRGCHK(LBTRCK,LBTRBT,IPRN)
      IF(IPRN.GT.0) WRITE(6,3012) LBTRCK,LBTRBT
3012  FORMAT(' TRGCHK RETURN : LBTRCK AND LBTRBT ',I8,1X,Z4)
      IF(LBTRCK.NE.0) GO TO 3011
      IF(IREFRM.EQ.1) GO TO 3013
      IPZV = IDATA(IBLN('ZVTX'))
      IF(IPZV.LE.0) IGG(74) = IGG(74) + 1
      IF(IPZV.LE.0) GO TO 3013
      IFLAG  = IDATA(IPZV+6)
      IF(IFLAG.LT.0) IGG(75) = IGG(75) + 1
      IF(IFLAG.LT.0) GOTO 3013
      ZVTX   = ADATA(IPZV+1)
      CALL ERGTOT(ECYL,ECAMI,ECAPL)
      ETOT = ECYL + ECAMI + ECAPL
      CALL HFILL(57,ZVTX,ETOT,1.)
3013  LRJCT = 18
      IGG(73) = IGG(73) + 1
      GO TO 1
C--- TRIGGER CHECK NOT OK ------------------------>>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 18      ***
C                                              ************************
3011  CALL ERGTOT(ECYL,ECAMI,ECAPL)
      ETOT = ECYL + ECAMI + ECAPL
      CALL HFILL(1,ETOT,0,1.)
      CALL HFILL(2,ETOT,0,1.)
      IPPO = IDATA(IBLN('PATR'))
      IF(IPPO.GT.0) GO TO 3532
      ITRG = IDATA(IBLN('TRIG'))
      HELP(2) = HDATA(2*ITRG + IDATA(ITRG)*2)
      IF(ICAMWD.EQ.MSKLUM.OR.ICAMWD.EQ.MSKLM1) GO TO 3532
      IF(IFLW.EQ.1.AND.ETOT.GT.500.) LWRIT = 10
      IF(LWRIT.EQ.10) IGG(71) = IGG(71) + 1
      IF(LWRIT.EQ.10) GO TO 11
C--- NO PATR BANK, HIGH ENERGY, OVERFLOW ---   ********* WRITTEN *******
C                                         --------------------------
C                                       --        LWRIT = 10        --
C                                         --------------------------
C
3532  IF(ETOT.GT.ETOTCT) GO TO 305
      IGG(4) = IGG(4) + 1
      ITRG = IDATA(IBLN('TRIG'))
      IF(ITRG.GT.0) GO TO 327
      WRITE(6,326) HEAD(18),HEAD(19)
326   FORMAT(' RUN & EVENT ',2I8,'  NO TRIGGER BANK ')
      GO TO 305
327   IF(IDATA(ITRG-2).EQ.1) GO TO 328
      WRITE(6,325) HEAD(18),HEAD(19)
325   FORMAT(' RUN & EVENT ',2I8,'  FIRST TRIGGER BANK NOT NR 1 ')
      GO TO 305
328   HELP(2) = HDATA(2*ITRG + IDATA(ITRG)*2)
      IF(ICAMWD.NE.MSKLUM.AND.ICAMWD.NE.MSKLM1) GO TO 305
      IGG(5) = IGG(5) + 1
C--- ENERGY < 100 MEV   LUMI TRIGGER ------------->>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 1       ***
C                                              ************************
      LRJCT = 1
      GO TO 1
C  SET FLAG FOR ENERGY IN FORWARD TAGGING BLOCKS
C            IFTG < 11     NO ENERGY
C            IFTG = 11     ENERGY ABOVE LIMIT IN NEG. FW ARM
C            IFTG = 12     ENERGY ABOVE LIMIT IN POS. FW ARM
C            IFTG = 113,13 ENERGY ABOVE LIMIT IN BOTH FW ARMS(LUMI)
305   CALL TAGFLG(IFTG)
      IF(IFTG.GT.10) IGG(6) = IGG(6) + 1
      IF(IFTG.LT.11) IGG(7) = IGG(7) + 1
      IF(IFTG.GT.10.AND.ETOT.GT.ETAGLM) IGG(8) = IGG(8) + 1
      IF(IFTG.GT.10) CALL HFILL(3,ETOT,0,1.)
      IAC = 0
      IF(ETOT.GT.ETOTKP) IAC = 1
      IF(ECYL.GT.ETCYKP) IAC = 1
      IF(ECAMI.GT.ETE1KP.AND.ECYL.GT.ETE2KP) IAC = 1
      IF(ECAPL.GT.ETE1KP.AND.ECYL.GT.ETE2KP) IAC = 1
      IF(IAC.EQ.0) IGG(9) = IGG(9) + 1
C
C TEST HERE WHETHER ALL THE ENERGY (95 %) SITS IN ONE ENDCAP BLOCK.
C IF SO, MARK IT WITH IAC = -1
C PERFORM THIS TEST ONLY IF TOTAL ENERGY HIGHER THAN ETOTLM.
C
      IF(ETOT.LT.ETOTLM) GO TO 301
      IF(ECAMI/ETOT.GT..95.OR.ECAPL/ETOT.GT..95) GO TO 302
      GO TO 301
C CHECK WHETHER MORE THAN 95 % OF ENERGY IN ONE ENDCAP BLOCK
302   IPJ=IDATA(IBLN('ALGN'))
      IF(IPJ.LE.0) GO TO 301
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 301
      IGG(10) = IGG(10) + 1
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
      DO 303 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      IF(IAD.LE.2687) GO TO 303
C TEST HERE TO EXCLUDE EDGE BLOCKS FROM THE CHECK
C     REDUCE TO NUMBERS 1 - 192
      NO = IAD - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (NO - 1)/96
C     REDUCE TO 1 - 96
      NO = NO - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (NO - 1)/24
C     REDUCE TO 1 - 24
      NO = NO - NQ*24
      IF(NO.LT.5) GO TO 303
      IF(NO.GT.15.AND.NO.NE.20) GO TO 303
C BLOCK NOT AT EDGE, CHECK FURTHER:
      ETEST = HDATA(IJK)
      IF(ETEST/ETOT.LT..95) GO TO 303
      IGG(11) = IGG(11) + 1
      WRITE(6,3002) HEAD(18),HEAD(19),IAD,ETEST,ETOT
3002  FORMAT(' RU&EV '2I8,' BLOCK ',I5,' WITH ENERGY AND ETOT ',2E12.4)
      IAC = -1
      GO TO 301
303   CONTINUE
301   CONTINUE
      IF(IAC.EQ.1) IGG(12) = IGG(12) + 1
      IF(IAC.EQ.-1) CALL HFILL(4,ETOT,0,1.)
CHECK HERE IF IFLW SET, IF SO CHECK IF DUE TO MASSIVE BAD LEAD GLASS
C           OR TO PICKUP EVENT WITH MORE THAN 1200 ID HITS
      IF(IFLW.EQ.0) GO TO 3087
      IDHITS = 0
      IPJETC = IDATA(IBLN('JETC'))
      IF(IPJETC.EQ.0) GO TO 3087
      IPJETC = 2*(IPJETC+1)
      IDHITS = (HDATA(IPJETC+97) - HDATA(IPJETC+1))/4
      IF(IDHITS.GT.800.AND.IDHITS.LT.1200) GO TO 3087
CHECK FIRST IF OVERFLOW EVENT HAS > 1200 HITS AND NO E,THEN REJECT EVENT
      IF(IDHITS.LE.800) GO TO 3057
      IF(ETOT.GT.500.) GO TO 3087
      WRITE(6,3058) NNREC,HEAD(18),HEAD(19),IDHITS,ETOT
3058  FORMAT(' ** OVERFLOW ** RECORD RUN EVENT ',3I8,' WITH INNER DETECT
     $OR HITS AND ETOT = ',I6,E12.4)
C                                 ---------------->>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 15      ***
C                                              ************************
      LRJCT = 15
      IGG(65) = IGG(65) + 1
      GO TO 1
3057  IPALGL = IDATA(IBLN('ALGL'))
      IPALGN = IDATA(IBLN('ALGN'))
      IF(IPALGL.GT.0.AND.IPALGN.GT.0) GO TO 3085
      WRITE(6,3084) HEAD(18),HEAD(19)
3084  FORMAT(' RUN&EV,  ALGL AND ALGN DO NOT EXIST ',2I8)
      GO TO 3087
3085  LALGL = IDATA(IPALGL)
      LALGN = IDATA(IPALGN)
      IF(LALGL.GT.10*LALGN) IFLW = 0
      IF(LALGL.GT.10*LALGN) IGG(61) = IGG(61) + 1
3087  IF(IFLW.EQ.1) IGG(62) = IGG(62) + 1
C  SET FLAG FOR LOW OR BAD ENERGY, OVERFLOW, TAGGING
      IWRT = 1
      IF(IAC.LE.0.AND.IFLW.EQ.0.AND.(IFTG.LT.11.OR.ETOT.LT.ETAGLM))
     $ IWRT = 0
      IF(IWRT.EQ.0) IGG(13) = IGG(13) + 1
      IF(IWRT.NE.0) IGG(14) = IGG(14) + 1
      IF(IWRT.NE.0.AND.IFTG.GT.10.AND.ETOT.GT.ETAGLM) IGG(63)=IGG(63)+1
      IF(IAC.NE.-1) CALL HFILL(5,ETOT,0,1.)
      IF(IAC.NE.-1) CALL HFILL(6,ECYL,0,1.)
      IF(IAC.NE.-1.AND.ECAMI.GT.0.) CALL HFILL(7,ECAMI,0,1.)
      IF(IAC.NE.-1.AND.ECAPL.GT.0.) CALL HFILL(8,ECAPL,0,1.)
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C *******************************************************************
C -------------------------------------------------------------------
400   CONTINUE
C                                                     ZVERTEX CALCULATED
      IGG(15) = IGG(15) + 1
      IPZV = IDATA(IBLN('ZVTX'))
      IF(IPZV.LE.0) GO TO 401
      IGG(16) = IGG(16) + 1
      IFLAG  = IDATA(IPZV+6)
      IF(IFLAG.LT.0) CALL HFILL(9,ETOT,0,1.)
      IF(IFLAG.LT.0) GOTO 401
      IGG(17) = IGG(17) + 1
      ZVTX   = ADATA(IPZV+1)
      CALL HFILL(10,ZVTX,0,1.)
      CALL HFILL(11,ZVTX,ETOT,1.)
      IF(ETOT.GT.2000.) CALL HFILL(12,ZVTX,0,1.)
      IF(IWRT.EQ.0) CALL HFILL(13,ZVTX,ETOT,1.)
      IF(IWRT.EQ.1) CALL HFILL(14,ZVTX,ETOT,1.)
C
C
C                                 ---------------->>>>  * REJECT *  <<<<
C                                              ************************
C                                             ***    LRJCT = 2       ***
C                                              ************************
      IF(ABS(ZVTX).GT.ZVTXLM.AND.IWRT.NE.1.AND.IFLAG.GT.1) LRJCT = 2
      IF(LRJCT.EQ.2) IGG(60) = IGG(60) + 1
      IF(LRJCT.EQ.2) GO TO 1
      IF(ABS(ZVTX).GT.ZVXLM1.AND.IFLAG.EQ.3.AND.ECAMI.LT..05*ETOT.AND.
     $ ECAPL.LT..05*ETOT) IAC = 0
      IWRT = 1
      IF(IAC.LE.0.AND.IFLW.EQ.0.AND.(IFTG.LT.11.OR.ETOT.LT.ETAGLM))
     $ IWRT = 0
      IF(ABS(ZVTX).GT.ZVTXLM) IGG(18) = IGG(18) + 1
      IGG(19) = IGG(19) + 1
401   INDEX = INDEX + 1
      RETURN
C -------------------------------------------------------------------
C *******************************************************************
C -------------------------------------------------------------------
500   CONTINUE
C                                                       PATREC PERFORMED
      IF(IRED1.EQ.0) GO TO 555
      CALL REDONE(INDRJ1,KBWRT1,KWRT,IPRN)
C                                 ---------------->>>>  * REJECT *  <<<<
C                                                    ******************
C                                                    *   LRJCT = 17   *
C                                                    ******************
      IF(IPRN.GT.0) WRITE(6,1881) INDRJ1,KBWRT1,KWRT
1881  FORMAT(' REDUC1   INDREJ,KBWRT,KWRT ',3I4)
      IF(KBWRT1.EQ.0) LRJCT = 17
      IF(LRJCT.EQ.17) IGG(72) = IGG(72) + 1
      IF(LRJCT.EQ.17) GO TO 1
C
555   IPPATR = IDATA(IBLN('PATR'))
C IF NO PATR BANK, PROCEED TO CLUSTER CHECK   (NTR = 0 AT READ EVENT)
      IF(IPPATR.EQ.0) GO TO 503
      IGG(21) = IGG(21) + 1
      LO = IDATA(IPPATR+1)
      NTR = IDATA(IPPATR+2)
      LTR = IDATA(IPPATR+3)
      IF(NTR.EQ.0) CALL HFILL(16,ETOT,0,1.)
      IF(IFLAG.GE.0.AND.NTR.EQ.0) CALL HFILL(17,ZVTX,0,1.)
C                                        ************* WRITTEN *********
      IF(NTR.EQ.0.AND.IFTG.GT.10.AND.ETOT.GT.50.) LWRIT = 7
      IF(LWRIT.EQ.7) CALL HFILL(53,ETOT,0,1.)
C                                         --------------------------
C                                       --        LWRIT = 7         --
C                                         --------------------------
      IF(LWRIT.EQ.7) IGG(59) = IGG(59) + 1
      IF(LWRIT.EQ.7) GO TO 11
C
      IF(NTR.EQ.0) GO TO 503
      CALL HFILL(15,NTR,0,1.)
      IGG(22) = IGG(22) + 1
      IF(IFTG.GT.10) GO TO 562
      IF(IFLAG.NE.3) GO TO 562
C HERE CHECK EVENTS WITH HIGH ENERGY IN CYLINDER AND ZVTX GT 200.
C  THEY ARE PASSED ON TO NORMAL TRACK CHECK
      IF(ABS(ZVTX).GT.ZVXLM2.AND.ECAMI.LT..05*ETOT.AND.ECAPL.LT..05*ETOT
     $ ) GO TO 578
      IGG(23) = IGG(23) + 1
C  WRITE  1-PRONG  TAGGED EVENTS
C                                        ************* WRITTEN *********
C                                              ------------------------
C                                             ---    LWRIT = 9       ---
C                                              ------------------------
562   IF(NTR.EQ.1.AND.IFTG.GT.10) LWRIT = 9
      IF(LWRIT.EQ.9) IGG(67) = IGG(67) + 1
      IF(LWRIT.EQ.9) GO TO 11
C NOW WRITE ALL EVENTS WITH THE WRITE FLAG IWRT SET
C                                        ************* WRITTEN *********
      IF(IWRT.EQ.1) LWRIT = 1
      IF(IWRT.EQ.1) IGG(24) = IGG(24) + 1
C                                         --------------------------
C                                       --        LWRIT = 1         --
C                                         --------------------------
      IF(IWRT.EQ.1) GO TO 11
C-
C-
578   IGG(25) = IGG(25) + 1
      IO = IPPATR
      IO = IO + LO - LTR
C  EVENTS ARE HERE DIVIDED INTO THREE CLASSES : ISTAR = 0,1,2
C    ISTAR = 0 HAS ONLY SHORT TRACKS   (NR OF ZHITS < LMHITS)
C    ISTAR = 2 HAS LONG AND WEAK TRACKS
C    ISTAR = 1 HAS AT LEAST ONE LONG FAST TRACK
C    ONLY ISTAR = 1 EVENTS UNDERGO SERIOUS TRACK CHECKS
C
      ICNTR = 0
      IGDNTR = 0
      ICNT = 0
      ISTAR = 0
      ICNTS = 0
      THESUM = 0.
501   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 502
      IO = IO + LTR
      CALL HFILL(101,IDATA(IO+33),0,1.)
      IF(IPATRJ.EQ.24.AND.IDATA(IO+33).LT.2.AND.IDATA(IO+24).GT.10)
     $ LRJCT = 99
      IF(LRJCT.EQ.99) GO TO 1
      THEX = ATAN(ADATA(IO+30))
      IF(IPATRJ.EQ.24.AND.THEX.EQ.0.) LRJCT = 99
      IF(LRJCT.EQ.99) GO TO 1
      CALL HFILL(102,THEX,0,1.)
      IF(IDATA(IO+33).LE.LMHITS.AND.IDATA(IO+24).LE.LMHITS) GO TO 5027
      IF(ISTAR.EQ.0) ISTAR = 2
      CRV = ADATA(IO+25)
      AZV = ABS(ADATA(IO+31))
      IF(ABS(CRV).GT.CRVLIM) GOTO 5027
C         COMPUTE MINIMUM DISTANCE OF PARABOLA TO ORIGIN, RFI-PLANE
      ISTAR=1
      IGDNTR = IGDNTR + 1
      CALL
     $    PARMIN(ADATA(IO+19),ADATA(IO+20),ADATA(IO+21),ADATA(IO+22),RP,
     $ IDATA(IO+18))
      IF(RP.LT.RPLIM.AND.AZV.LT.ZMLIM) ICNTR = ICNTR + 1
      THE = ATAN(ADATA(IO+30))
      THE = PI*.5 - THE
      IF(NTR.EQ.3) THHELP(ICNT) = THE
      THESUM = THESUM + THE
      IF(RP.LT.RPLIM1.AND.AZV.LT.ZMLIM) ICNTS = ICNTS + 1
      GO TO 501
5027  IF(NTR.NE.3) GO TO 501
      THE = ATAN(ADATA(IO+30))
      THE = PI*.5 - THE
      THHELP(ICNT) = THE
      GO TO 501
502   IF(ISTAR.EQ.0) IGG(26) = IGG(26) + 1
      IF(ISTAR.EQ.1) IGG(27) = IGG(27) + 1
      IF(ISTAR.EQ.2) IGG(28) = IGG(28) + 1
      IF(ISTAR.EQ.0.OR.ISTAR.EQ.2) CALL HFILL(18,ETOT,0,1.)
      IF(ISTAR.EQ.1) CALL HFILL(19,ETOT,0,1.)
C     IF(ISTAR.EQ.2) CALL HFILL(20,ETOT,0,1.)
      IF(ISTAR.EQ.1) GO TO 5035
C-----------------------------------------------------------------------
C    PROCEED TO CLUSTER CHECK      THESE EVENTS HAVE NO FAST TRACKS
      GO TO 503
C-----------------------------------------------------------------------
C
C  ONLY ISTAR = 1 EVENTS PASS THE FOLLOWING TESTS
C
C NOW COMPUTE RATIO BETWEEN TOTAL GOOD TRACKS (STAR = 1 TRACKS) AND
C TRACKS CLOSE TO THE WWP (GIVEN BY RPLIM AND ZMLIM)
C
5035  RATIO = FLOAT(ICNTR)/FLOAT(IGDNTR)
      CALL HFILL(21,RATIO,0,1.)
C     IF(IFLAG.GE.0) CALL HFILL(22,ZVTX,RATIO,1.)
C     CALL HFILL(23,IGDNTR,ICNTR,1.)
C
C  SEPARATE EVENTS WITH RATIO > RATLIM AND   EVENTS WITH RATIO < RATLIM
C
      IF(RATIO.GT.RATLIM) GO TO 517
      IF(RATIO.GT..5*RATLIM.AND.IGDNTR.GT.6) GO TO 517
C
C HERE FOR EVENTS WHICH DO NOT PASS RATIO CHECK - - - - - - - - - - -
      IGG(29) = IGG(29) + 1
      IF(IFLAG.GE.0) CALL HFILL(24,ZVTX,ETOT,1.)
C   NOW REJECT EVENTS IF
C                     OR GOOD ZVERTEX OUTSIDE LIMITS AND >3 GOOD TRACKS
C                     OR RATIO = 0.   AND >10 GOOD TRACKS
      IF(IFLAG.GT.0.AND.ABS(ZVTX).GT.ZVTXLM.AND.IGDNTR.GT.3) LRJCT = 3
      IF(LRJCT.EQ.3) GO TO 5038
      IF(RATIO.EQ.0..AND.IGDNTR.GT.10) LRJCT = 4
      IF(LRJCT.EQ.4) GO TO 5038
      IF(NTR.EQ.2) GO TO 4923
      IF(NTR.EQ.3) GO TO 517
C   OTHERWISE PROCEED TO CLUSTER CHECK
      GO TO 503
C-----------------------------------------------------------------------
C                                        >>>>>>>>>>> REJECT <<<<<<<<<
C                                              ************************
C                                             ***    LRJCT = 3 AND 4 ***
C                                              ************************
5038  IGG(32) = IGG(32) + 1
      GO TO 1
C-----------------------------------------------------------------------
C
C FOR TWOPRONG COSMIC CANDIDATES, PERFORM TOF CHECK AND
C                   PERFORM SPECIAL INTERACTION POINT TEST  (.5*RPLIM )
517   IF(NTR.NE.3) GO TO 5217
      ICOSM = 0
      ABS12 = ABS(THHELP(1)+THHELP(2)-PI)
      ABS13 = ABS(THHELP(1)+THHELP(3)-PI)
      ABS23 = ABS(THHELP(2)+THHELP(3)-PI)
      ABSM12 = ABS(THHELP(1)-THHELP(2))
      ABSM13 = ABS(THHELP(1)-THHELP(3))
      ABSM23 = ABS(THHELP(2)-THHELP(3))
      IF(IPRN.GE.2) WRITE(6,7574) ABS12,ABS13,ABS23,ABSM12,ABSM13,ABSM2300069600
7574  FORMAT(' ABS12 13 23 ABSM ',6F8.4)
      IF(ABS12.LT..25.AND.(ABSM13.LT..31.OR.ABSM23.LT..31)) GO TO 4924
      IF(ABS13.LT..25.AND.(ABSM23.LT..31.OR.ABSM12.LT..31)) GO TO 4924
      IF(ABS23.LT..25.AND.(ABSM13.LT..31.OR.ABSM12.LT..31)) GO TO 4924
      IF(RATIO.LT.RATLIM) GO TO 503
C---------------------------------------------******* WRITTEN **********
5217  IF(NTR.NE.2) LWRIT = 2
C                                         --------------------------
C                                       --        LWRIT = 2         --
C                                         --------------------------
      IF(NTR.NE.2) CALL HFILL(25,ZVTX,ETOT,1.)
      IF(LWRIT.EQ.2) IGG(34) = IGG(34) + 1
      IF(LWRIT.EQ.2) GO TO 11
      IGG(35) = IGG(35) + 1
C
4923  ICOSM = 0
C TEST ON COLLINEARITY IN THETA
      ABSTHE = ABS(THESUM-PI)
      CALL HFILL(28,ABSTHE,0,1.)
      CALL HFILL(26,ZVTX,ETOT,1.)
C---------------------------------------------******* WRITTEN **********
      IF(ABSTHE.GT..25.AND.RATIO.GT.RATLIM) LWRIT = 3
C                                         --------------------------
C                                       --        LWRIT = 3         --
C                                         --------------------------
      IF(LWRIT.EQ.3) IGG(33) = IGG(33) + 1
      IF(LWRIT.EQ.3) GO TO 11
      IF(ABSTHE.GT..25) GO TO 503
      CALL HFILL(27,ZVTX,ETOT,1.)
C
4924  IGG(36) = IGG(36) + 1
C PERFORM TOF TEST ONLY IF ETOT < 800 MEV, TO AVOID BREMS STRAHLUNG
      IF(ETOT.GT.800.) GO TO 5123
      IGG(37) = IGG(37) + 1
      ICOSM = 1
C
C SPECIALLY HARD CHECK FOR COSMIC CANDIDATES ( TWOPRONG )
CHECK TOF FOR COSMIC.  CODE TAKEN FROM NORD 50; P.DITTMANNS PROGRAM
4925  CALL TOFCHK(TDIF,TSUM,NRUN)
      NCOSM = 0
      CALL HFILL(29,TDIF,0,1.)
      CALL HFILL(54,TSUM,0,1.)
      CALL HFILL(55,TDIF,TSUM,1.)
C TIME IN NANOSECONDS
C-----------------------------------------------------------------------
C                                        >>>>>>>>>>>> REJECT <<<<<<<<<<<
      IF(TDIF.GT.COSCUT.AND.TSUM.GT.TSUMC1) NCOSM = 1
      IF(TDIF.GT.COSCUT.AND.TSUM.LT.TSUMC2) NCOSM = 1
      IF(NCOSM.EQ.1) IGG(42) = IGG(42) + 1
      IF(NCOSM.EQ.1.AND.IFLAG.GE.0) CALL HFILL(30,ZVTX,ETOT,1.)
      IF(IPATRJ.EQ.25.OR.IPATRJ.EQ.26) NCOSM = 0
      IF(NCOSM.EQ.1) LRJCT = 5
C                                              ************************
C                                             ***    LRJCT = 5       ***
C                                              ************************
      IF(NCOSM.EQ.1) GO TO 1
C-----------------------------------------------------------------------
C    NEW RATIO FOR COSMIC CANDIDATES      EXTRA STRONG DEMAND ON RPLIM
5123  IF(ICNTS.GT.0) IGG(43) = IGG(43) + 1
      IF(IFLAG.LT.0) GO TO 5031
      IF(ICNTS.GT.0.AND.IFLAG.GE.0) CALL HFILL(31,ZVTX,ETOT,1.)
C-----------------------------------------------------------------------
C---------------------------------------------******* WRITTEN **********
5031  IF(ICNTS.GT.0) LWRIT = 4
C                                         --------------------------
C                                       --        LWRIT = 4         --
C                                         --------------------------
      IF(ICNTS.GT.0.AND.ICOSM.EQ.1) CALL HFILL(32,ZVTX,ETOT,1.)
      IF(ICNTS.GT.0) GO TO 11
C-----------------------------------------------------------------------
C
C    NOW REJECT FAILING RATIO EVENTS
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IGG(44) = IGG(44) + 1
      IF(IFLAG.GE.0) CALL HFILL(33,ZVTX,ETOT,1.)
      LRJCT = 6
C                                              ************************
C                                             ***    LRJCT = 6       ***
C                                              ************************
      GO TO 1
C-----------------------------------------------------------------------
503   IGG(45) = IGG(45) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C *******************************************************************
C -------------------------------------------------------------------
600   CONTINUE
C                                    CLUSTER ANALYSIS PERFORMED
      IGG(46) = IGG(46) + 1
      IPCL = IDATA(IBLN('LGCL'))
C-----------------------------------------------------------------------
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF (IPCL.EQ.0) LRJCT = 7
C                                              ************************
C                                             ***    LRJCT = 7       ***
C                                              ************************
      IF (IPCL.EQ.0) GO TO 1
      IGG(47) = IGG(47) + 1
      IER = IDATA(IPCL+20)
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(IER.NE.0) LRJCT = 8
C                                              ************************
C                                             ***    LRJCT = 8       ***
C                                              ************************
      IF(IER.NE.0) GO TO 1
      IGG(48) = IGG(48) + 1
      NCLST = IDATA(IPCL+7)
      CALL HFILL(34,NCLST,0,1.)
      IF(NCLST.LE.1) CALL HFILL(35,ETOT,0,1.)
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(NCLST.LE.1) LRJCT = 9
C                                              ************************
C                                             ***    LRJCT = 9       ***
C                                              ************************
      IF(LRJCT.EQ.9) GO TO 1
      IGG(49) = IGG(49) + 1
C-----------------------------------------------------------------------
C     IF(NCLST.LE.1) LWRIT = 8
C     ITRG = IDATA(IBLN('TRIG'))
C     HELP(2) = HDATA(2*ITRG + IDATA(ITRG)*2)
C     IF(LWRIT.EQ.8.AND.ICAMWD.EQ.MKFWMU) LRJCT = 14
C     IF(LWRIT.EQ.8.AND.ICAMWD.EQ.MKFWMU) LWRIT = 0
C                                         --------------------------
C                                       --        LWRIT = 8         --
C                                         --------------------------
C     IF(LWRIT.EQ.8) GO TO 11
C     IGG(50) = IGG(50) + 1
C-----------------------------------------------------------------------
      EBM = EBEAM(HRUN)
      IF(NTR.NE.0) GO TO 519
      IGG(66) = IGG(66) + 1
      IF(IWRT.NE.0) IGG(68) = IGG(68) + 1
      IF(IWRT.NE.0.AND.IFTG.GT.10.AND.ETOT.GT.ETAGLM) IGG(69)=IGG(69)+1
C                ENTER HERE FOR EVENTS WITH NO TRACKS
      IALGN = IDATA(IBLN('ALGN'))
      IF(IALGN.EQ.0) IGG(51) = IGG(51) + 1
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(IALGN.EQ.0) LRJCT = 10
C                                              ************************
C                                             ***    LRJCT = 10      ***
C                                              ************************
      IF(IALGN.EQ.0) GO TO 1
C- NEUTRAL EVENTS ARE NOW CHECKED FOR MOMENTUM BALANCE -----------------
      CALL HWORLD(IALGN,JEMPTY,UNBAL)
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      IF(JEMPTY.GT.1.OR.UNBAL.LT..05) LRJCT = 11
      IF(LRJCT.EQ.11) IGG(52) = IGG(52) + 1
      IF(LRJCT.EQ.11) CALL HFILL(36,ETOT,0,1.)
C                                              ************************
C                                             ***    LRJCT = 11      ***
C                                              ************************
      IF(LRJCT.EQ.11) GO TO 1
C-----------------------------------------------------------------------
C
      IDHITS = 0
      IPJETC = IDATA(IBLN('JETC'))
      IF(IPJETC.EQ.0) GO TO 519
      IPJETC = 2*(IPJETC+1)
      IDHITS = (HDATA(IPJETC+97) - HDATA(IPJETC+1))/4
5191  IF(IDHITS.GT.1000) IGG(53) = IGG(53) + 1
C-----------------------------------------------------------------------
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
C  NO TRACKS BUT MORE THAN 1000 HITS IN I.D.
      IF(IDHITS.GT.1000) LRJCT = 12
C                                              ************************
C                                             ***    LRJCT = 12      ***
C                                              ************************
      IF(IDHITS.GT.1000) GO TO 1
C-----------------------------------------------------------------------
C  WRITE HERE NEUTRAL EVENTS WITH ETOT < 3.*EBM AND < 10 CLUSTERS
C---------------------------------------------******** WRITTEN *********
      IF(ETOT.LT.3.*EBM.AND.NCLST.LT.10) LWRIT = 6
      ITRG = IDATA(IBLN('TRIG'))
      HELP(2) = HDATA(2*ITRG + IDATA(ITRG)*2)
      IF(LWRIT.EQ.6.AND.(ICAMWD.EQ.MKFWMU.OR.ICAMWD.EQ.MKFWM1))
     $ LWRIT = 0
C                                         --------------------------
C                                       --        LWRIT = 6         --
C                                         --------------------------
      IF(LWRIT.EQ.6) IGG(58) = IGG(58) + 1
      IF(LWRIT.EQ.6) GO TO 11
C--
519   IP3 = IDATA(IPCL+3)
      NPWCL = IDATA(IPCL+25)
      MARK = 0
      NNCL = NCLST - 1
C                          SEARCH HERE FOR COLLINEAR CLUSTERS
      DO 610  I = 1,NNCL
      IB1 = IPCL + IP3 + (I-1)*NPWCL - 1
      IF(ADATA(IB1+2).LT.ERGL) GO TO 610
      JPRT1 = IDATA(IB1+1)
      NN = I + 1
      DO 611  J = NN,NCLST
      IB2 = IPCL + IP3 + (J-1)*NPWCL - 1
      JPRT2 = IDATA(IB2+1)
      IF(JPRT1+JPRT2.NE.0) GO TO 611
      IF(ADATA(IB2+2).LT.ERGL) GO TO 611
      IF(JPRT1.NE.0) GO TO 612
C
C  CHECK OF TWO CLUSTERS IN BARREL
C
      FI1 = ADATA(IB1+4)
      FI2 = ADATA(IB2+4)
      ZE1 = ADATA(IB1+5)
      ZE2 = ADATA(IB2+5)
      ABF = ABS(FI2-FI1)
      ABZ = ABS(ZE1+ZE2)
      IF(ABZ.GT.ZLM) GO TO 611
      IF(ABF.LT.PI-FIDEL.OR.ABF.GT.PI+FIDEL) GO TO 611
C TOTALLY NEUTRAL COLLINEARS MUST HAVE MORE THAN 7 % OF ETOT
      IF(NTR.EQ.0.AND.ADATA(IB1+2)+ADATA(IB2+2).LT..00007*ETOT)GO TO 61100090800
      MARK = 1
      IGG(54) = IGG(54) + 1
      THE1 = ATAN2(ZE1,RLG)
      THE2 = ATAN2(ZE2,RLG)
      THE1 = PI*.5 - THE1
      THE2 = PI*.5 - THE2
      GO TO 619
C
C  CHECK OF TWO CLUSTERS IN ENDCAPS
C
612   X1 = ADATA(IB1+4)
      X2 = ADATA(IB2+4)
      Y1 = ADATA(IB1+5)
      Y2 = ADATA(IB2+5)
      ABX = ABS(X1+X2)
      ABY = ABS(Y1+Y2)
      IF(ABX.GT.XLM) GO TO 611
      IF(ABY.GT.YLM) GO TO 611
C TOTALLY NEUTRAL COLLINEARS MUST HAVE MORE THAN 7 % OF ETOT
      IF(NTR.EQ.0.AND.ADATA(IB1+2)+ADATA(IB2+2).LT..00007*ETOT)GO TO 61100092800
      MARK = 1
      FI1 = ATAN2(Y1,X1)
      IF(FI1.LT.0.) FI1 = FI1 + TWOPI
      FI2 = ATAN2(Y2,X2)
      IF(FI2.LT.0.) FI2 = FI2 + TWOPI
      RR = SQRT(X1*X1 + Y1*Y1)
      THE1 = ATAN2(RR,ZENDPL)
      IF(JPRT1.LT.0) THE1 = PI - THE1
      RR = SQRT(X2*X2 + Y2*Y2)
      THE2 = ATAN2(RR,ZENDPL)
      IF(JPRT2.LT.0) THE2 = PI - THE2
      IGG(55) = IGG(55) + 1
      GO TO 619
C
611   CONTINUE
C
610   CONTINUE
      IGG(56) = IGG(56) + 1
      CALL HFILL(37,ETOT,0,1.)
      IF(IFLAG.GE.0) CALL HFILL(38,ZVTX,ETOT,1.)
C--------------------------------------------->>>>>>>> REJECT <<<<<<<<<<
      LRJCT = 13
C                                              ************************
C                                             ***    LRJCT = 13      ***
C                                              ************************
      GO TO 1
C
C
619   IGG(64) = IGG(64) + 1
      ICOSM = 0
C IF COLLINEARS FOUND IN FEWPRONG EVENT AND LOW ENERGY, CHECK TOF.
      IF(NTR.GT.2.AND.NTR.LT.8.AND.ETOT.LT.700..AND.ISTAR.EQ.1)
     $ GO TO 4925
      IGG(57) = IGG(57) + 1
      CALL HFILL(39,ETOT,0,1.)
      IF(IFLAG.GE.0) CALL HFILL(40,ZVTX,ETOT,1.)
      IF(NTR.GT.0) CALL HFILL(41,NTR,0,1.)
      COSS = SIN(THE1)*SIN(THE2)*(COS(FI1)*COS(FI2)+SIN(FI1)*SIN(FI2))
     $  + COS(THE1)*COS(THE2)
      CALL HFILL(49,COSS,0,1.)
C---------------------------------------------******** WRITTEN *********
      LWRIT = 5
C                                         --------------------------
C                                       --        LWRIT = 5         --
C                                         --------------------------
      GO TO 11
C
C
C -------------------------------------------------------------------
C *******************************************************************
C -------------------------------------------------------------------
700   CONTINUE
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
800   CONTINUE
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
900   CONTINUE
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
1000  CONTINUE
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C---     END OF JOB: FINAL CALCULATIONS + PRINTOUT
9900  CONTINUE
      DO 9781 I = 2,80
 9781 JIGG(I) = JIGG(I) + IGG(I)
      PERCEN = FLOAT(JIGG(2) - JIGG(70))
      PERCEN = FLOAT(NRWRIT)/PERCEN*100.
      WRITE(6,1101) PERCEN
1101  FORMAT(' TOTAL REDUCTION FACTOR ',F7.2,' % ')
      WRITE(6,1717) (IGG(I),I=1,80)
 1717 FORMAT(' COUNTERS ',10I8)
C     CALL STATR2
      WRITE(6,1718) (JIGG(I),I=1,80)
 1718 FORMAT(' TOTAL COUNTS ',10I8)
      DO 1719  I = 1,80
 1719 IGG(I) = JIGG(I)
C     IF(IPRN.GE.2) IPRN = 1
      CALL STATR2
      IF(IHIST.EQ.1) CALL HISTDO
      IF(ITMLOG.EQ.1) CALL TMLOG(0)
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---     'GO TO 11' MEANS ACCEPT EVENT, WRITE IT AND GO TO NEXT EVENT
C---
1     IF(IREFRM.EQ.1.AND.(LRJCT.EQ.1.OR.LRJCT.EQ.15.OR.LRJCT.EQ.18))
     $  GO TO 7172
      IF(IFLAG.GE.0) CALL HFILL(42,ZVTX,ETOT,1.)
      IF(IFLAG.GE.0) CALL HFILL(52,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.1) CALL HFILL(61,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.2) CALL HFILL(62,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.3) CALL HFILL(63,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.4) CALL HFILL(64,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.5) CALL HFILL(65,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.6) CALL HFILL(66,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.(LRJCT.EQ.7.OR.LRJCT.EQ.8))
     $ CALL HFILL(67,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.9) CALL HFILL(69,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.10) CALL HFILL(70,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.11) CALL HFILL(71,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.12) CALL HFILL(72,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.13) CALL HFILL(73,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.17) CALL HFILL(75,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LRJCT.EQ.18) CALL HFILL(76,ZVTX,0,1.)
C     LHEAD = HEAD(35)
C     CALL HFILL(50,LHEAD,0.,1.)
      CALL HFILL(43,ETOT,0.,1.)
7172  CALL HFILL(44,LRJCT,0,1.)
      IGG(79) = IGG(79) + 1
      IF(IPRN.GT.0)
     $ WRITE(6,7739) HEAD(18),HEAD(19),NNREC,LRJCT
7739  FORMAT('  RUN&EV  ',2I8,30X,' REC AND CODE ',2I5,' >>> RJCT <<< ')
      IF(IPATRJ.EQ.11) GO TO 1111
      IF(IPATRJ.EQ.22.AND.LRJCT.EQ.8) GO TO 1111
      IF(IPATRJ.EQ.23.AND.LRJCT.EQ.17) GO TO 1111
      IF(IPATRJ.EQ.23.AND.LRJCT.EQ.18) GO TO 1111
      IF(IPATRJ.EQ.24.AND.LRJCT.EQ.99) GO TO 1111
      IF(IPATRJ.EQ.26.AND.LRJCT.EQ.11) GO TO 1111
      IF(IPATRJ.EQ.27.AND.LRJCT.EQ.5) GO TO 1111
7171  INDEX = 1
      RETURN
2     INDEX = 2
      RETURN
3     INDEX = 3
      RETURN
4     INDEX = 4
      RETURN
5     INDEX = 5
      RETURN
6     INDEX = 6
      RETURN
7     INDEX = 7
      RETURN
8     INDEX = 8
      RETURN
9     INDEX = 9
      RETURN
10    INDEX = 10
      RETURN
11    IGG(80) = IGG(80) + 1
      IF(IPRN.GT.0) WRITE(6,7738) HEAD(18),HEAD(19),NNREC,LWRIT
C     LHEAD = HEAD(35)
C     CALL HFILL(51,LHEAD,0.,1.)
      IF(IFLAG.GE.0) CALL HFILL(45,ZVTX,ETOT,1.)
      IF(IFLAG.GE.0) CALL HFILL(46,ZVTX,0.,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.1) CALL HFILL(81,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.2) CALL HFILL(82,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.3) CALL HFILL(83,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.4) CALL HFILL(84,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.5) CALL HFILL(85,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.6) CALL HFILL(86,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.7) CALL HFILL(87,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.8) CALL HFILL(88,ZVTX,0,1.)
      IF(IFLAG.GE.0.AND.LWRIT.EQ.9) CALL HFILL(89,ZVTX,0,1.)
      CALL HFILL(47,ETOT,0.,1.)
      CALL HFILL(48,NTR,0.,1.)
      LWRIT = LWRIT + 30
      CALL HFILL(44,LWRIT,0.,1.)
      IF(IGG(80)+JIGG(80).GT.MAXEVS) GO TO 12
      IF(IPATRJ.EQ.11) GO TO 7171
      IF(IPATRJ.EQ.22) GO TO 7171
      IF(IPATRJ.EQ.23) GO TO 7171
      IF(IPATRJ.EQ.24) GO TO 7171
      IF(IPATRJ.EQ.26) GO TO 7171
      IF(IPATRJ.EQ.27) GO TO 7171
      IF(IPATRJ.EQ.28.AND.LWRIT.NE.34) GO TO 7171
7738  FORMAT('  RUN&EV  ',2I8,40X,' REC AND CODE ',2I5,'*** WRIT *** ')
      IF((IREPAT.NE.2.AND.IREPAT.NE.3).OR.HRUN.LT.100) GO TO 1111
      IPPR =IDATA(IBLN('PATR'))
      IF(IPPR.LE.0) GO TO 1174
      NUMPPR=IDATA(IPPR-2)
      CALL BDLS('PATR',NUMPPR)
1174  CALL BGAR(IBAGA)
      IPFAST = 2
      CALL INPATR
      CALL PATREC(0)
      IPFAST = 0
      CALL INPATR
      ZFITLM(1) = 70.
      ZFITLM(2) = 35.
1111  INDEX = 11
      RETURN
12    INDEX = 12
      RETURN
      END
      SUBROUTINE STATR2
      COMMON /CIGG/ IPRN,IGG(80)
C  STATUS FOR DATA REDUCTION STEP 2
      DATA ETAGLM /100./ ,RATLIM /.20/ ,ZVTXLM /350./,ETOTCT/100./
      WRITE(6,1) IGG(1)
  1    FORMAT(' ',25X,'++++++++   STATISTICS FOR RUN',I7,'         +++++
     *++++++++')
      WRITE(6,2) IGG(2),IGG(3),IGG(62)
  2   FORMAT('   EVENTS READ ',I8,'   OVERFLOW EVENTS',I8,'   OVERFLOW E
     $VENTS AFTER LEAD GLASS AND PICKUP CHECK ',I8)
      WRITE(6,222) IGG(70)
222   FORMAT('   EVENTS REJECTED AS NOT BEING REAL DATA ---->>',I8)
      EVS=FLOAT(IGG(2)-IGG(70))
      IF(EVS.EQ.0.) GO TO 2347
      GFAIL=FLOAT(IGG(73))/EVS*100.
      WRITE(6,765) IGG(73),GFAIL
765   FORMAT(' ',I10,' EVENTS FAILING TRIGGER CHECK IN REDUC1  ',F10.2
     *,'%','               >>>>> REJECTED <<<<<')
      GFAIL=FLOAT(IGG(65))/EVS*100.
      WRITE(6,665) IGG(65),GFAIL
665   FORMAT(' ',I10,' EVENTS WITH > 1200 IDHITS, < 500 MEV    ',F10.2
     *,'%','               >>>>> REJECTED <<<<<')
      GFAIL=FLOAT(IGG(5))/EVS*100.
      WRITE(6,5) IGG(5),ETOTCT,GFAIL
 5    FORMAT(' ',I10,' LUMI   WITH TOTAL ENERGY < ',F10.2,'     ',F10.2
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(60)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,56) IVAR,ZVTXLM,GFAIL
 56   FORMAT(' ',I10,' EVENTS WITH ZVTX  > ',F10.2,' AND IWRT=0 ',F10.2
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(72)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,132) IVAR,GFAIL
 132   FORMAT(' ',I10,' EVENTS REJECTED BY NEW REDUC1 STEP       ',F10.200115500
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(32)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,57) IVAR,GFAIL
 57   FORMAT(' ',I10,' EVENTS WITH BAD RATIO, SPECIAL CONDITIONS ',F10.200116000
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(42)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,58) IVAR,GFAIL
 58   FORMAT(' ',I10,' EVENTS LABELLED AS COSMICS                ',F10.200116500
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(44)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,59) IVAR,GFAIL
 59   FORMAT(' ',I10,' EVENTS FAILING RATIO AND WITH FEW PRONGS  ',F10.200117000
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(46) - IGG(47)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,60) IVAR,GFAIL
 60   FORMAT(' ',I10,' EVENTS WITH NO BANK LGCL                  ',F10.200117500
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(47) - IGG(48)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,61) IVAR,GFAIL
 61   FORMAT(' ',I10,' EVENTS WITH NONZERO ERRORCODE IN LGCL     ',F10.200118000
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(48) - IGG(49)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,62) IVAR,GFAIL
 62   FORMAT(' ',I10,' EVENTS WITH < 2 CLUSTERS,NO GOOD TRACKS   ',F10.200118500
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(51)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,63) IVAR,GFAIL
 63   FORMAT(' ',I10,' EVENTS WITH NO BANK ALGN                  ',F10.200119000
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(52)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,64) IVAR,GFAIL
 64   FORMAT(' ',I10,' EVENTS WITH NTR=0, HWORLD IMBALANCE       ',F10.200119500
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(53)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,65) IVAR,GFAIL
 65   FORMAT(' ',I10,' EVENTS WITH NTR=0, > 1000 IDHITS          ',F10.200120000
     *,'%','               >>>>> REJECTED <<<<<')
      IVAR = IGG(56)
      GFAIL=FLOAT(IVAR)/EVS*100.
      WRITE(6,66) IVAR,GFAIL
 66   FORMAT(' ',I10,' EVENTS WITH NO COLLINEARS FOUND           ',F10.200120500
     *,'%','               >>>>> REJECTED <<<<<')
      WRITE(6,1119)
1119  FORMAT(' ',90(1H-))
      EVSW = IGG(80)
      GOOD=EVSW/EVS*100.
      WRITE(6,86) IGG(80),GOOD
 86   FORMAT(' ',I10,' EVENTS WRITTEN                            ',F10.200121200
     *,'%','            OF ALL READ EVENTS')
      IF(IGG(80).LE.0) GO TO 2347
      IVAR = IGG(24)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,7) IVAR,GOOD
 7    FORMAT(' ',I10,' EVENTS WITH WRITE FLAG SET, NTR > 0       ',F10.200121800
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(71)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,1161) IVAR,GOOD
1161   FORMAT(' ',I10,' EVENTS WITH ETOT>500, OVERFLOW, NO PATR  ',F10.200122300
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(67)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,161) IVAR,GOOD
 161   FORMAT(' ',I10,' EVENTS WITH NTR=1 AND TAGFLAG SET        ',F10.200122800
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(34)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,71) IVAR,GOOD
 71   FORMAT(' ',I10,' EVENTS WITH GOOD RATIO, NTR > 3           ',F10.200123300
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(33)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,72) IVAR,GOOD
 72   FORMAT(' ',I10,' EVENTS WITH GOOD RATIO, NTR=2,3 SUMTHE<PI ',F10.200123800
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(43)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,73) IVAR,GOOD
 73   FORMAT(' ',I10,' EVENTS WITH RATIO OK, FEWPRONG,NO COSMICS ',F10.200124300
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(57)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,74) IVAR,GOOD
 74   FORMAT(' ',I10,' EVENTS WITH COLLINEARS FOUND              ',F10.200124800
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(58)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,741) IVAR,GOOD
 741  FORMAT(' ',I10,' EVENTS WITH ETOT<3*EBM, NCLST<10, NTR=0   ',F10.200125300
     $,'%','                     ****** WRITTEN *****')
      IVAR = IGG(59)
      GOOD=FLOAT(IVAR)/EVSW*100.
      WRITE(6,742) IVAR,GOOD
 742  FORMAT(' ',I10,' EVENTS WITH TAGFLAG SET AND NTR=0         ',F10.200125800
     $,'%','                     ****** WRITTEN *****')
2347  RETURN
      END
      SUBROUTINE TOFCHK(TDIF,TSUM,NRUN)
      IMPLICIT INTEGER*2 (H)
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
      TDIF = 0.
      TSUM = 0.
      CALL TOFSMP(NRUN)
      IF(NTOF.LE.0) GO TO 5123
      NRS = 0
      DO 32 JK = 1,21
      IF(HTOF(JK).EQ.0.OR.ABS(TTOF(JK)).EQ.0.) GO TO 32
      IF(TTOF(JK).EQ.-20.) GO TO 32
      TOF1 = TTOF(JK)
      JK1 = JK + 18
      NRT = 0
      TOF2 = 0.
      DO 33 IBT = 1,5
      JK2 = JK1 + IBT
      IF(JK2.GT.42) JK2 = 42
      IF(HTOF(JK2).EQ.0.OR.ABS(TTOF(JK2)).EQ.0.) GO TO 33
      IF(TTOF(JK2).EQ.-20.) GO TO 33
      NRT = NRT + 1
      TOF2 = TOF2 + TTOF(JK2)
33    CONTINUE
      IF(NRT.EQ.0) GO TO 32
      TOF2 = TOF2/NRT
      NRS = NRS + 1
      TDIF = TDIF + TOF1 - TOF2
      TSUM = TSUM + TOF1 + TOF2
   32 CONTINUE
      IF(NRS.EQ.0) GO TO 5123
      TDIF = - TDIF / NRS
      TSUM = TSUM / NRS
5123  RETURN
      END
      BLOCK DATA
      COMMON /CREDTV/ CRVLIM,LMHITS,RPLIM,RPLIM1,RATLIM,COSCUT,ZVTXLM,
     $ ZVXLM1,ZVXLM2,ETOTLM,ETOTKP,ETCYKP,ETE1KP,ETE2KP,ZMLIM,FIDEL,
     $ XLM,YLM,ZLM,ERGL,ETAGLM,ETOTCT,TSUMC1,TSUMC2
      DATA ERGL /.200/
      DATA ETAGLM /100./
      DATA ETOTCT /100./
      DATA CRVLIM/.00135/, LMHITS/16/
      DATA RPLIM /30./
      DATA RPLIM1/10./
      DATA RATLIM /.20/
      DATA ZMLIM /350./
      DATA FIDEL /.200/
      DATA ZLM /500./
      DATA XLM /350./
      DATA YLM /350./
      DATA COSCUT /5.5/
      DATA ZVTXLM /350./
      DATA ZVXLM1 /500./
      DATA ZVXLM2 /200./
      DATA  ETOTLM /5000./
      DATA  ETOTKP /7000./
      DATA  ETCYKP /3500./
      DATA  ETE1KP /4000./
      DATA  ETE2KP /500./
      DATA  TSUMC1 /30./
      DATA  TSUMC2 /-20./
      END

C   03/12/81 112151000  MEMBER NAME  ATOFRW   (S)           FORTRAN
      SUBROUTINE ATOFRW(IPTOF)
      IMPLICIT INTEGER*2 (H)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      COMMON/BCS/IDATA(1)
      DIMENSION HDATA(2),HEADR(108)
      EQUIVALENCE  (HDATA(1),IDATA(1))
      DATA NRUNB,IEVB/0,0/,IBUG/0/
C
      IBUG = IBUG + 1
      NRUN = HEADR(18)
      IEV  = HEADR(19)
      IF(NRUN.EQ.NRUNB.AND.IEV.EQ.IEVB) GOTO 70
      IA = IPTOF-2
      PRINT 101,NRUN,IEV,IBUG,IDATA(IA-1),(IDATA(I),I=IA,IPTOF)
  101 FORMAT(//1X,' *** ATOFRW ',3I5,' ***',A5,3I5)
      IA = IPTOF*2+1
      IB = IA + 1
      PRINT 105,(HDATA(I),I=IA,IB)
  105 FORMAT(' BANK DESCRIPTOR',2I5)
      IA = IPTOF*2+3
      IB = IPTOF*2 + IDATA(IPTOF)*2
      PRINT 102,(HDATA(I),I=IA,IB)
      PRINT 104
      PRINT 104
  102 FORMAT(1X,20I6)
  104 FORMAT(/)
   70 NRUNB = NRUN
      IEVB = IEV
      RETURN
      END

C   19/03/84            MEMBER NAME  CONVER   (S)           FORTRAN
C   16/09/79 C9091601   MEMBER NAME  CONVER   (JADPRIVS)    FORTRAN
      SUBROUTINE CONVER
C---  SET HPOINT(4) TO 0 (IT WAS NOT DONE FOR SOME DATA)
C
C     H.WRIEDT       16.09.79       18:45
C     LAST MODIFICATION       16.09.79      18:45
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ HCOINC(16),HLUMON(16),HGGLAT(16),HSCALE(36),
     *               LNG,HPOINT(4)
C
      HPOINT(4) = 0
      RETURN
      END

C   12/09/79 007081308  MEMBER NAME  NUMBWR   (JADEGS)      FORTRAN
      SUBROUTINE NUMBWR(IOPT,NR,XX,YY,SIZE)
C---
C---     WRITE THE NUMBER NR AT POSITION X,Y, WITH SIZE 'SIZE'
C---     THE NUMBER NR IS PRECEDED BY THE SYMBOL HSYM(IOPT)
C---     E.G.  T16 IS GIVEN BY IOPT = 30
C---     E.G.  B16 IS GIVEN BY IOPT = 12
C---     E.G.  C16 IS GIVEN BY IOPT = 13
C    IOPT LE 0 OR GT 36 WILL CAUSE THE NUMBER TO BE PRECEDED BY A BLANK
C---
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
      DIMENSION HMW(10)
#include "chsym.for"
      DATA HBLANK /'  '/,HMINUS/'- '/
C---
      KCNT = 1
      IF(IOPT.GT.0.AND.IOPT.LE.36) GO TO 1
      HMW(KCNT) = HBLANK
      GO TO 2
1     HMW(KCNT) = HSYM(IOPT)
2     NUMCAP = NR
      IF(NUMCAP.LT.0) KCNT=KCNT+1
      IF(NUMCAP.LT.0) HMW(KCNT)=HMINUS
      NUMCAP=IABS(NUMCAP)
      NDIG=1
      ACAP=NUMCAP
      IF(NUMCAP.GT.0) NDIG=1+ALOG10(ACAP+0.001)
      IF(NDIG.GT.8) NDIG=8
      DO 5002 JJJ=1,NDIG
      KKK=KCNT+NDIG-JJJ+1
      NTEN=NUMCAP/10
      IDIG=NUMCAP-10*NTEN
      HMW(KKK)=HSYM(IDIG+1)
 5002 NUMCAP=NTEN
      KCNT=KCNT+NDIG
      CALL HEMSYM(XX,YY,SIZE,HMW,KCNT,0.)
      RETURN
      END

      SUBROUTINE VTXSRC 
C*800623*DITTMANN********************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXSRC)   18.9.86
C*                                                          *
C*        X - Y - Z    V E R T E X    S E A R C H           *
C*                                                          *
C*       1. SEARCH FOR E+E- PAIRS                           *
C*       2. SEARCH FOR MAIN VERTEX AROUND AVERAGE BEAM      *
C*       3. SEARCH FOR SECONDARY VERTICES                   *
C*                                                          *
C*       A DESCRIPTION OF THE T AND V ARRAYS CAN BE FOUND   *
C*       IN SUBR. VERTEX                                    *
C************************************************************
C        CONSTANTS
C PMF 03.11.98 
      LOGICAL TBIT
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV
C
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C
      DIMENSION IV2(20,20)
      EQUIVALENCE (V2(1,1),IV2(1,1))
C
      LOGICAL VREP,RESTOR
C
      NV = 0
      IF(NT.LE.0) RETURN
      IPRVTX = 0
C****
C****    SEARCH FOR GAMMA CONVERSIONS
      CALL VTXEE
      IF(NV.EQ.0) GOTO 5
      LV = 0
      DO 4 I=1,NV
      J = 0
      DO 3 K=1,NT
      IF(IT(J+14).EQ.I) IT(J+1)=-IT(J+1)
    3 J = J + 40
    4 LV = LV + 10
C****
C****    SEARCH FOR PRIMARY VERTEX AROUND AVERAGE BEAM
    5 NTGOD = 0
      NTBAD = 0
      J = 0
      DO 7 I=1,NT
      IF(IT(J+1).LE.0) GOTO 7
      CALL VTXPNT(J,XB,YB,XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      DXY = SQRT((XT-XB)**2+(YT-YB)**2)
      IF(DXY.GT.DISTB) GOTO 6
      IF(SS.LT.SEMAX-RTANK) GOTO 6
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      GOTO 7
    6 IT(J+1) = 1
      NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
    7 J = J + 40
      IF(NTGOD.EQ.0) GOTO 39
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
      VREP = .FALSE.
      RESTOR = .FALSE.
C****
C****    VERTEX FIT
   10 CALL VERTEX
      IF(IV(LV+1).GE.1) GOTO 20
      IF(VREP) GOTO 60
      GOTO 40
C****
C****    CHECK VERTEX AND ITS TRACKS
   20 NTBAD = 0
      NTBAD3 = 0
      NTGOD = 0
      NTGOD3 = 0
      J = 0
      DO 25 I=1,NT
      IF(IT(J+1).LE.0) GOTO 25
C        SMALLEST DISTANCE TO VERTEX
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      DXT2 = DXT2 + V(LV+5)**2
      DYT2 = DYT2 + V(LV+6)**2
      DZT2 = DZT2 + V(LV+7)**2
      SDX = ABS(XT-V(LV+2)) / SQRT(DXT2)
      SDY = ABS(YT-V(LV+3)) / SQRT(DYT2)
      SDZ = ABS(ZT-V(LV+4)) / SQRT(DZT2)
      T(J+15) = SS
      T(J+28) = SDX
      T(J+29) = SDY
      T(J+30) = SDZ
      IF(IT(J+1).EQ.1) GOTO 23
      IF(SDX.GT.SIG2 .OR. SDY.GT.SIG2 .OR. SDZ.GT.SIG2) GOTO 23
C        EXTRAPOLATION LENGTH
      IF(SS.GT.SIMAX) GOTO 23
      SSJC = SS
      IF(T(J+27).EQ.0.) GOTO 22
      IF(SS.LT.T(J+26)-SIMAX) GOTO 23
      IF(SS.LT.T(J+27)) SSJC=T(J+27)
   22 IF(SSJC.LT.SEMAX) GOTO 23
      IF(ABS(SS/T(J+2)).GT.PHEMAX) GOTO 23
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      IF(IT(J+1).EQ.3) NTGOD3=NTGOD3+1
      GOTO 25
   23 NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
      IF(IT(J+1).EQ.3) NTBAD3=NTBAD3+1
   25 J = J + 40
      IF(RESTOR) GOTO 30
      IF(NTGOD3.EQ.20) GOTO 30
      IF(NTBAD3.EQ.0 .AND. NTGOD.EQ.NTGOD3) GOTO 30
      IF(.NOT.VREP .AND. NTGOD.LT.3) GOTO 40
      IF(NTGOD.LE.2) GOTO 60
C        REPEAT VERTEX FIT
      DO 27 I=1,NTGOD
      J = JTGOD(I)
   27 IT(J+1) = 2
      IF(NTBAD.EQ.0) GOTO 10
      DO 28 I=1,NTBAD
      J = JTBAD(I)
   28 IT(J+1) = 1
      GOTO 10
C****
C****    GOOD VERTEX FOUND
   30 IF(NTBAD.EQ.0) GOTO 37
      IF(IV(LV+8).EQ.1) GOTO 37
C        COLLECT ALL TRACKS FITTING TO VERTEX
      NTB = 0
      DO 33 I=1,NTBAD
      J = JTBAD(I)
      IF(T(J+28).GT.SIG3.OR.T(J+29).GT.SIG3.OR.T(J+30).GT.SIG3) GOTO 32
      IF(T(J+15).GT.SIMAX) GOTO 32
      SSJC = T(J+15)
      IF(T(J+27).EQ.0.) GOTO 31
      IF(T(J+15).LT.T(J+26)-SIMAX) GOTO 32
      IF(T(J+15).LT.T(J+27)) SSJC=T(J+27)
   31 IF(SSJC.LT.SEMAX) GOTO 32
      IF(ABS(T(J+15)/T(J+2)).GT.PHEMAX) GOTO 32
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      IT(J+1) = 1
      GOTO 33
   32 NTB = NTB + 1
      JTBAD(NTB) = J
   33 CONTINUE
      NTBAD = NTB
   37 IV(LV+10) = NTGOD
      DO 38 I=1,NTGOD
      J = JTGOD(I)
      IT(J+1) = -IT(J+1)
      IT(J+14) = NV
   38 CONTINUE
      IF(IPRVTX.NE.0) GOTO 39
      IF(ABS(V(LV+2)-XB).LT.3.*DISTB .AND. ABS(V(LV+3)-YB).LT.3.*DISTB)
     *   IPRVTX=NV
   39 IF(NTBAD.EQ.0) GOTO 90
      NTGOD = 0
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
C****
C****    VERTEX SEARCH
   40 IF(NTBAD.EQ.0) GOTO 241
      DO 41 I=1,NTBAD
      J = JTBAD(I)
   41 IT(J+1) = 1
  241 IF(NTGOD.EQ.0) GOTO 43
      DO 141 I=1,NTGOD
      J = JTGOD(I)
      NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
  141 IT(J+1) = 1
   43 NVL = NV
      NV2 = 0
      N1 = 1
      IF(NTBAD.LT.2) GOTO 50
C        TWO TRACK VERTEX
   42 J1 = JTBAD(N1)
      IT(J1+1) = 2
      N21 = N1 + 1
      IF(N21.GT.NTBAD) GOTO 45
      DO 44 N2=N21,NTBAD
      J2 = JTBAD(N2)
      IT(J2+1) = 2
      CALL VERTEX
      IF(IV(LV+1).LE.1) GOTO 44
C        CHECK THIS VERTEX
C        EXTRAPOLATION LENGTH TRACK 1
      CALL VTXPNT(J1,V(LV+2),V(LV+3),XT1,YT1,ZT1,DXT12,DYT12,DZT12,
     *            PHIT1,DPHIT1,ST1)
      IF(ST1.GT.SIMAX) GOTO 44
      SSJC = ST1
      IF(T(J1+27).EQ.0.) GOTO 143
      IF(ST1.LT.T(J1+26)-SIMAX) GOTO 44
      IF(ST1.LT.T(J1+27)) SSJC=T(J1+27)
  143 IF(SSJC.LT.SEMAX) GOTO 44
      IF(ABS(ST1/T(J1+2)).GT.PHEMAX) GOTO 44
C        EXTRAPOLATION LENGTH TRACK 2
      CALL VTXPNT(J2,V(LV+2),V(LV+3),XT2,YT2,ZT2,DXT22,DYT22,DZT22,
     *            PHIT2,DPHIT2,ST2)
      IF(ST2.GT.SIMAX) GOTO 44
      SSJC = ST2
      IF(T(J2+27).EQ.0.) GOTO 243
      IF(ST2.LT.T(J2+26)-SIMAX) GOTO 44
      IF(ST2.LT.T(J2+27)) SSJC=T(J2+27)
  243 IF(SSJC.LT.SEMAX) GOTO 44
      IF(ABS(ST2/T(J2+2)).GT.PHEMAX) GOTO 44
C        COMPARE TRACK DIRECTIONS WITH BEAM
      DZ = ABS(ZT1-ZT2)
      COSW12 = 0.
      IF(IPRVTX.EQ.0) GOTO 147
      LPV = (IPRVTX-1)*10
      DVX = V(LV+2) - V(LPV+2)
      DVY = V(LV+3) - V(LPV+3)
      DVZ = V(LV+4) - V(LPV+4)
      DV12 = SQRT(DVX**2+DVY**2+DVZ**2)
C#######################################################
C 03.6.86    PROTECTION AGAINST DIVIDE WITH ZERO    J.OLSSON
      IF(DV12.LE.10.E-8) GO TO 44
C#######################################################
      COSW1 = (COS(PHIT1)*T(J1+24)*DVX + SIN(PHIT1)*T(J1+24)*DVY +
     *         SIN(T(J1+4))*DVZ) / DV12
      IF(COSW1.LT.CSECV) GOTO 44
      COSW2 = (COS(PHIT2)*T(J2+24)*DVX + SIN(PHIT2)*T(J2+24)*DVY +
     *        SIN(T(J2+4))*DVZ) / DV12
      IF(COSW2.LT.CSECV) GOTO 44
      COSW12 = COSW1 * COSW2
      GOTO 47
  147 DVX = V(LV+2) - XB
      DVY = V(LV+3) - YB
      DV12 = SQRT(DVX**2+DVY**2)
      IF(DV12.LT.DISTB) GOTO 47
      COSW1 = (COS(PHIT1)*DVX + SIN(PHIT1)*DVY) / DV12
      IF(COSW1.LT.CSECV) GOTO 44
      COSW2 = (COS(PHIT2)*DVX + SIN(PHIT2)*DVY) / DV12
      IF(COSW2.LT.CSECV) GOTO 44
      COSW12 = COSW1 * COSW2
C        CHECK IF MORE TRACKS FIT
   47 NT2 = 2
      DO 149 K=1,NTBAD
      J = JTBAD(K)
      IF(IT(J+1).EQ.3) GOTO 149
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      SDX = ABS(XT-V(LV+2)) / SQRT(DXT2)
      SDY = ABS(YT-V(LV+3)) / SQRT(DYT2)
      SDZ = ABS(ZT-V(LV+4)) / SQRT(DZT2)
      IF(SDX.GT.SIG2 .OR. SDY.GT.SIG2 .OR. SDZ.GT.SIG2) GOTO 149
      IF(SS.GT.SIMAX) GOTO 149
      SSJC = SS
      IF(T(J+27).EQ.0.) GOTO 148
      IF(SS.LT.T(J+26)-SIMAX) GOTO 149
      IF(SS.LT.T(J+27)) SSJC=T(J+27)
  148 IF(SSJC.LT.SEMAX) GOTO 149
      IF(ABS(SS/T(J+2)).GT.PHEMAX) GOTO 149
      NT2 = NT2 + 1
  149 CONTINUE
C        TEMPORARY STORE OF ALL TWO TRACK VERTICES
      NV2 = NV2 + 1
      IV2(NV2,1) = NV
      IV2(NV2,2) = NT2
      IV2(NV2,3) = J1
      IV2(NV2,4) = J2
      V2(NV2,5) = COSW12
      V2(NV2,6) = DZ
      IV2(NV2,7) = IV(LV+1)
      IF(NV.EQ.20) GOTO 45
      NV = NV + 1
      LV = (NV-1)*10
C
   44 IT(J2+1) = 1
      IT(J1+1) = 1
      N1 = N1 + 1
      IF(N1.LE.NTBAD) GOTO 42
C        CHOOSE BEST TWO TRACK VERTEX
   45 IT(J1+1) = 1
      IT(J2+1) = 1
      IF(NV2.EQ.0) GOTO 50
      NT2MAX = 0
      DO 46 I=1,NV2
      IF(IV2(I,2).LT.NT2MAX) GOTO 46
      IF(IV2(I,2).EQ.NT2MAX) GOTO 144
      NT2MAX = IV2(I,2)
      LV2 = I
      GOTO 46
  144 IF(IV2(I,7).EQ.IV2(LV2,7)) GOTO 145
      IF(IV2(I,7).GT.IV2(LV2,7)) LV2=I
      GOTO 46
  145 IF(IPRVTX.EQ.0) GOTO 146
      IF(V2(I,5).GT.V2(LV2,5)) LV2=I
      GOTO 46
  146 IF(V2(I,6).LT.V2(LV2,6)) LV2=I
   46 CONTINUE
C        REPEAT VERTEX FIT
      J1 = IV2(LV2,3)
      J2 = IV2(LV2,4)
      NV = NVL
      LV = (NVL-1)*10
      LV2 = (IV2(LV2,1)-1)*10
      J1SAVE = J1
      J2SAVE = J2
      DO 48 K=1,10
      VSAVE(K) = V(LV2+K)
   48 V(LV+K) = V(LV2+K)
      DO 49 K=1,NTBAD
      J = JTBAD(K)
      IT(J+1)=2
   49 CONTINUE
      IT(J1+1) = 3
      IT(J2+1) = 3
      VREP = .TRUE.
      RESTOR = .FALSE.
      GOTO 20
C        SINGLE TRACK VERTEX
   50 DO 52 N1=1,NTBAD
      J1 = JTBAD(N1)
      IF(N1.EQ.1) GOTO 51
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
   51 IV(LV+1) = 5
      V(LV+2) = T(J1+5)
      V(LV+3) = T(J1+6)
      V(LV+4) = T(J1+7)
      V(LV+5) = T(J1+10)
      V(LV+6) = T(J1+11)
      V(LV+7) = T(J1+12)
      IV(LV+8) = 1
      V(LV+9) = 0.
      IV(LV+10) = 1
      IT(J1+1) = -3
      IT(J1+14) = NV
   52 CONTINUE
      GOTO 90
C        SEARCH NOT CONVERGING
C        EMERGENCY ACTION: RESTORE 2-TRACK VERTEX (OTHERWISE DEAD LOOP)
   60 J1 = J1SAVE
      J2 = J2SAVE
      DO 62 I=1,10
   62 V(LV+I) = VSAVE(I)
      IF(NTBAD.EQ.0) GOTO 66
      DO 63 I=1,NTBAD
      J = JTBAD(I)
      IT(J+1)=2
   63 CONTINUE
   66 IF(NTGOD.EQ.0) GOTO 69
      DO 67 I=1,NTGOD
      J = JTGOD(I)
      IT(J+1)=2
   67 CONTINUE
   69 IT(J1+1) = 3
      IT(J2+1) = 3
      RESTOR = .TRUE.
      GOTO 20
C****
C****    CLEAN UP
   90 IF(NV.EQ.0) GOTO 100
      J = 0
      DO 91 I=1,NT
      IF(IT(J+1).LT.0) IT(J+1)=-IT(J+1)
   91 J = J + 40
      IF(NV.EQ.1) GOTO 100
      IF(IPRVTX.NE.0) GOTO 93
      IPRVTX = 1
      DXYP = 1.E20
      LV = 0
      DO 92 I=1,NV
      DXY = V(LV+2)**2+V(LV+3)**2
      IF(DXY.GT.DXYP) GOTO 92
      IPRVTX = I
      DXYP = DXY
   92 LV = LV + 10
   93 IF(IPRVTX.EQ.1) GOTO 100
C        MOVE PRIMARY VERTEX TO FIRST POSITION
      M = IPRVTX - 1
      LV = M*10
      DO 94 I=1,10
   94 VSAVE(I) = V(LV+I)
      DO 96 I=1,M
      DO 95 J=1,10
   95 V(LV+J) = V(LV+J-10)
   96 LV = LV - 10
      DO 97 I=1,10
   97 V(I) = VSAVE(I)
      J = 0
      DO 99 I=1,NT
      IF(IT(J+1).EQ.0) GOTO 99
      IF(IT(J+14).EQ.IPRVTX) GOTO 98
      IF(IT(J+14).LT.IPRVTX) IT(J+14)=IT(J+14)+1
      GOTO 99
   98 IT(J+14) = 1
   99 J = J + 40
C
  100 RETURN
      END

C   07/06/96 606071916  MEMBER NAME  ULIND    (S4)          FORTG1
      SUBROUTINE ULIND(NA,KA,Y,X)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL Q(10),QQ(10)
      CALL BLOC(IND,'LIN*',NA,&100)
      BN=32768.0*(Y-RW(IND+3))/(RW(IND+4)-RW(IND+3))
      IF(BN.LT.0.0) GOTO 100
      NY=BN
      IF(NY.GE.32768) GOTO 100
      BN=32768.0*(X-RW(IND+5))/(RW(IND+6)-RW(IND+5))
      IF(BN.LT.0.0) GOTO 100
      NX=BN
      IF(NX.GE.32768) GOTO 100
      CALL USSTO(NA,KA,NY*32768+NX)
      GOTO 100
C
      ENTRY DLIND(NA,KAMAX,IEN,YL,YH,XL,XH)
      CALL BLOC(IND,'LIN*',NA,&10)
      GOTO 100
   10 CALL BCRE(IND,'LIN*',NA,6,&100,IER)
      IW(IND+1)=KAMAX
      IW(IND+2)=IEN
      RW(IND+3)=YL
      RW(IND+4)=YH
      RW(IND+5)=XL
      RW(IND+6)=XH
      CALL DSSTO(NA,KAMAX,IEN)
      GOTO 100
C
      ENTRY PLIND(NA)
      CALL BLOC(IND,'LIN*',NA,&100)
      IEN=IW(IND+2)
      CALL BCRE(J,'++++',0,3*IEN,&100,IER)
      IPR=0
      KAM=IW(IND+1)
      LA=0
      IRT=0
      GOTO 30
      ENTRY QLIND(NA,KA,Q)
      DO 20 I=1,10
   20 Q(I)=0.0
      CALL BLOC(IND,'LIN*',NA,&100)
      IEN=IW(IND+2)
      CALL BCRE(J,'++++',0,3*IEN,&100,IER)
      LA=KA
      IRT=1
   30 CALL QSSTO(NA,LA,IW(J+IEN+IEN+1),NQ,NENT)
      DO 35 I=1,10
   35 QQ(I)=0.0
      QQ(10)=NENT
      IF(NQ.LE.0) GOTO 50
      DO 40 I=1,NQ
      IYX=IW(J+IEN+IEN+I)
      IY=IYX/32768
      IX=IYX-32768*IY
      RY=FLOAT(IY)+0.5
      RX=FLOAT(IX)+0.5
      RY=RW(IND+3)+(RW(IND+4)-RW(IND+3))*RY/32768.0
      RX=RW(IND+5)+(RW(IND+6)-RW(IND+5))*RX/32768.0
      RW(J+I    )=RY
   40 RW(J+I+IEN)=RX
      CALL LINSEL(RW(J+1),RW(J+IEN+1),RW(J+IEN+IEN+1),NQ,QQ)
   50 IF(IRT.EQ.0) GOTO 60
      DO 55 I=1,10
   55 Q(I)=QQ(I)
      GOTO 70
   60 IF(NQ.EQ.0) GOTO 65
      IF(IPR.NE.0) GOTO 64
      IPR=1
      WRITE(6,101) NA
   64 WRITE(6,102) LA,(QQ(I),I=1,9)
   65 IF(LA.GE.KAM) GOTO 70
      LA=LA+1
      GOTO 30
   70 CALL BDLS('++++',0)
  100 RETURN
  101 FORMAT(' ULIND',I8,' KA ENTRIES INTERCEPT',8X,'SLOPE',
     1 8X,'ERROR',7X,'MEAN X',7X,'MEAN Y',8X,'ERROR',8X,'SIGMA',
     2 8X,'OUT')
  102 FORMAT(14X,I3,F8.0,1X,7G13.5,F8.0)
      END

C   30/06/80 007010946  MEMBER NAME  DEDSEL   (JADEGS)      FORTRAN
      SUBROUTINE SPARE
      IMPLICIT INTEGER*2 (H)
#include "cjdrch.for"
#include "cgraph.for"
#include "cdata.for"
      COMMON /CJTRIG/ PI,TWOPI
      DIMENSION LIST(2,8)
      DIMENSION INTR(2,8)
      DATA LIST/ 17,1, 13,2, 13,3, 13,4,  9,3,  9,4, 17,3, 17,4/
      DATA INTR/   539, 30000,
     1            2303, 30000,
     1            2570,  3311,
     1            2570,  3311,
     1            2775, 30000,
     1            2775, 30000,
     1            2783, 30000,
     1            2783, 30000/
C---
      IF(LASTVW.GT.3) GO TO 200
      IHHEAD=2*IDATA(IBLN('HEAD'))
      IF(IHHEAD.LT.1) GO TO 200
      NRUN=HDATA(IHHEAD+10)
      DO 1 IDED=1,8
      LIM1=INTR(1,IDED)
      LIM2=INTR(2,IDED)
      IF(NRUN.LT.LIM1) GO TO 1
      IF(NRUN.GE.LIM2) GO TO 1
      ISEC=LIST(1,IDED)
      ISEL=LIST(2,IDED)
      PHI0=TWOPI*(ISEC-1)/24.
      DPHI=TWOPI/48.
      IF(ISEL.EQ.3) DPHI=TWOPI/96.
      IF(ISEL.EQ.4) DPHI=TWOPI*3./96.
      PHI=PHI0+DPHI
      CSS=COS(PHI)
      SNN=SIN(PHI)
      R0=FSENSW(1)
      IF(ISEL.EQ.2) R0=FSENSW(2)
      IF(ISEL.GE.3) R0=FSENSW(3)
      R=R0+75.
      DS=TWOPI*R/48.
      IF(ISEL.GE.3) DS=TWOPI*R/96.
      X1=R-DS
      Y1= -DS
      X2=R+DS
      Y2=  DS
      X3=R-DS
      Y3=  DS
      X4=R+DS
      Y4= -DS
      X=CSS*X1-SNN*Y1
      Y=SNN*X1+CSS*Y1
      CALL MOVEA(-X,Y)
      X=CSS*X2-SNN*Y2
      Y=SNN*X2+CSS*Y2
      CALL DRAWA(-X,Y)
      X=CSS*X3-SNN*Y3
      Y=SNN*X3+CSS*Y3
      CALL MOVEA(-X,Y)
      X=CSS*X4-SNN*Y4
      Y=SNN*X4+CSS*Y4
      CALL DRAWA(-X,Y)
    1 CONTINUE
  200 CONTINUE
      RETURN
      END

C   10/02/89 903051753  MEMBER NAME  GUOUT    (S)           FORTRAN77
C=======================================================================
      SUBROUTINE GUOUT
C=======================================================================
C.
C.    *
C.    *       User routine called at the end of each event
C.    *
C.
C

      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(30),NAMEC(30)
     + ,NSTEP ,MAXNST,DESTEP,SAFETY,SLENG ,STEP  ,SNEXT ,SFIELD,SNPHYS
     + ,TOFG  ,GEKRAT,IGNEXT,INWVOL,ISTOP ,IDECAD,IEKBIN
C
      COMMON /GCVOLU/ NLEVEL, NAMES(15), NUMBER(15),
     + LVOLUM(15),LINDEX(15),GTRAN(3,15),GRMAT(10,15),
     + NGPAR(15),GPAR(50,15),GONLY(15),GLX(3),
     + NJNEXT(2),JNEXT(15),INEXT(15),NNEXT(15)
C
      COMMON / GENPAR / WEIT(3),CNORM(3)
      COMMON / CEBLOK / EBLOCK(16,3)
C
#include "cmctag.for"
C
      INTEGER*2 HGG
C
CC    CALL TVNEXT
CC    CALL GDRAWC( 'TAGS', 3,+340., 10., 10., 0.3, 0.3)
CC    CALL GDXYZ(0)
C                      Z-X-VIEW THROUGH WHOLE VOLUME
CC    CALL TVNEXT
CC    CALL GDRAWC ( 'TAGS', 2, 0.0, 10.0, 10.0, 0.025,0.2)
CC    CALL GDXYZ(0)
C                      Z-X-VIEW THROUGH WHOLE VOLUME
CC    CALL TVNEXT
CC    CALL GDRVOL (2,NAMES,NUMBER,0,90.0,0.,0.0,10.0,10.0,0.025,0.2)
CC    CALL GDXYZ(0)
CC    CALL TVEND
C
C     WRITE(6,*) '  '
      ETOTAL=0.0
      DO 10 ISEG=1,16
         DO 20 IRING=1,3
C
C---AZIMUTHAL PARAMETRISATION OF ENERGY RESPONSE
C
            CALL AZIRES(ISEG,IRING)
C
C---SMEAR THE ENERGIES
            CALL RANNOR(GRAN1,GRAN2)
            ESMEAR=GRAN1*.024*CNORM(IRING)
CC          EBLOCK(ISEG,IRING)=EBLOCK(ISEG,IRING)+ESMEAR
C           WRITE(6,8001) ESMEAR,EBLOCK(ISEG,IRING)
 8001       FORMAT(1X,'ESMEAR ',F8.4,' EBLOCK ',F8.4)
C
C---NORMALISE AND WEIGHT THE ENERGIES
            EBLOCK(ISEG,IRING) =
     &           WEIT(IRING)*EBLOCK(ISEG,IRING)
C           WRITE(6,8002) WEIT(IRING),CNORM(IRING),EBLOCK(ISEG,IRING)
 8002       FORMAT(1X,' WEIT ',F8.4,' CNORM ',F8.4,' EBLOCK ',F8.4)
C
C---CALCULATE TOTAL ENERGY DEPOSITED IN CALORIMETER
            ETOTAL=ETOTAL+EBLOCK(ISEG,IRING)
C           WRITE(6,8003) ETOTAL
 8003       FORMAT(1X,' ETOTAL ',F8.4)
C
C---FILL IN HGG ARRAY ACCORDING TO STANDARD MARK III FORM
C   NOTE THE ARRAY CONSISTS OF ENERGIES
C
C--- -Z END
         IF(ISEG.GT.8) THEN
            IF(IRING.EQ.1) HGG(17-ISEG)=1000.*EBLOCK(ISEG,IRING)
            IF(IRING.EQ.2) HGG(25-ISEG)=1000.*EBLOCK(ISEG,IRING)
            IF(IRING.EQ.3) HGG(33-ISEG)=1000.*EBLOCK(ISEG,IRING)
C--- +Z END
         ELSE
            IOFF=0
            IF(ISEG.GT.4) IOFF=+8
            IF(IRING.EQ.1) HGG(29-ISEG+IOFF)=1000.*EBLOCK(ISEG,IRING)
            IF(IRING.EQ.2) HGG(37-ISEG+IOFF)=1000.*EBLOCK(ISEG,IRING)
            IF(IRING.EQ.3) HGG(45-ISEG+IOFF)=1000.*EBLOCK(ISEG,IRING)
         ENDIF
 20      CONTINUE
 10   CONTINUE
CC    DO 30 I1=1,192
CC       HGG(I1)=0
CC       HGG(I1)=I1*100
C30   CONTINUE
C     WRITE(6,8004) (HGG(I),I=1,192)
 8004 FORMAT(16(12(I5,1X)/))
      RETURN
      END
C***********************************************************************
C SUBROUTINE TO MODIFY RECORDED ENERGY ACCORDING TO AN AZIMUTHAL
C PARAMETRISATION
C
      SUBROUTINE AZIRES(ISEG,IRING)
C
      COMMON / CEBLOK / EBLOCK(16,3)
      COMMON / PATDAT / PATVEC (10), PATPOS (3)
      COMMON / AZIPAR / AZIFIT
      PI=3.14159
C
C---CALCULATE INCIDENT PHI ANGLE
C
      PHI=ATAN(ABS(PATVEC(2)/PATVEC(1)))
      IF(PATVEC(1).LT.0.AND.PATVEC(2).GT.0) PHI=PI-PHI
      IF(PATVEC(1).LT.0.AND.PATVEC(2).LT.0) PHI=PI+PHI
      IF(PATVEC(1).GT.0.AND.PATVEC(2).LT.0) PHI=2*PI-PHI
C
C     WRITE(6,8001) PATVEC(1),PATVEC(2),PHI
 8001 FORMAT(1X,'PX ',F8.4,' PY ',F8.4,' PHI ',F8.4)
C     WRITE(6,8012) ISEG,IRING
 8012 FORMAT(1X,'ISEG ',I2,' IRING ',I2)
C
C---CONVERT TO DEG.
      PHI=360.*PHI/(2*PI)
C
C     WRITE(6,8002) PHI
 8002 FORMAT(1X,' PHI (DEG) ',F8.4)
C
C---DETERMINE IN WHICH PHI GAP THE PARTICLE WAS INCIDENT
C
      IF(PHI.GT.337.5) THEN
          PHITRN=PHI-360.0
          GOTO 20
      ENDIF
      IF(PHI.LT.22.5) THEN
          PHITRN=PHI
          GOTO 20
      ENDIF
      DO 10 IGAP=2,8
         PHIMIN=-22.5+(IGAP-1)*45.
         PHIMAX=22.5+(IGAP-1)*45.
         IF(PHI.GT.PHIMIN.AND.PHI.LT.PHIMAX) THEN
            PHITRN=PHI-(IGAP-1)*45.
            GOTO 20
         ENDIF
 10   CONTINUE
C
C---CALCULATE CORRECTION FACTOR FROM PHI COORDINATE
C
C---CONVERT BACK TO RAD
 20   PHITRN=2*PI*PHITRN/360.
C     WRITE(6,8003) IGAP,PHIMIN,PHIMAX,PHITRN
 8003 FORMAT(1X,' IGAP ',I2,' PHIMIN ',F8.4,' PHIMAX ',
     &       F8.4,' PHITRN ',F8.4)
C     WRITE(6,8004) PHITRN,EBLOCK(ISEG,IRING)
 8004 FORMAT(1X,' PHITRN (MRAD) ',F8.4,' EBLOCK BEF COR ',F8.4)
C
      AZRES=(PI/8.0-AZIFIT*ABS(PHITRN))*8.0/PI
      EBLOCK(ISEG,IRING)=EBLOCK(ISEG,IRING)*AZRES
C     WRITE(6,8005) AZIFIT,AZRES,EBLOCK(ISEG,IRING)
 8005 FORMAT(1X,' AZIFIT ',F8.4,' AZRES ',F8.4,' EBLOCK ',F8.4)
C
      RETURN
      END

C   09/03/79 002200411  MEMBER NAME  @CHKRTN  (SOURCE)      FORTRAN
C        CHECK NEW ROUTINES
      DIMENSION IF(29),A(15)
      EQUIVALENCE (A(1),IBE)
      DATA A/15*0./
      CALL LGINIT
      ZE=1522.
      ZE2=ZE*ZE
      IBE=1
      DO 40 I=10,20,5
      E=I
      DEP0=SHMAX(E*1000.,1)
      WRITE(6,950) E,DEP0
 950  FORMAT(' E,DEP=',2F12.3)
      YY=425
      DO 20 JY=1,29
      YY=YY-5.
      XX=275.
      DO 10 JX=1,29
      XX=XX+5.
      R=XX*XX+YY*YY
      RZ=SQRT(ZE2+R)
      R=SQRT(R)
      DEP=DEP0*ZE/RZ
      A(2)=E
      A(11)=ZE/RZ
      A(9)=XX/RZ
      A(10)=YY/RZ
      A(4)=XX
      A(5)=YY
      CALL LGECOR(A,DEP,IFLAG)
      IF(JX)=100.*E/A(2)
10    CONTINUE
      WRITE(6,900) IF
900   FORMAT(29I4)
20    CONTINUE
40    CONTINUE
      STOP
      END

C   26/07/79 C9073101   MEMBER NAME  LGEFIL   (SOURCE)      FORTRAN
      SUBROUTINE LGEFIL(I1,J1,J2,IE,*)
C     CODED BY Y.WATANABE ON 29/7/79 23:50
      IMPLICIT INTEGER*2 (H)
C     USED IN LGCDIR PART OF ANALYSIS
C     INCREASE UP TO 100 TRACKS ON 20/9/79
      COMMON /CWORK/ NCHCLS,NPOINT,MAPCCL(101),HCLADR(1600),
     $               NCHCL2,HCLIST(4,100),  NCLST2,HCLLSO(4,80)
      DATA NPMAX/1600/
      DIMENSION INDX(6,6),IAD(2,2),IPP(2,2)
      DATA IAD/0,24,72,48/,IPP/1,2,4,3/
      DATA INDX/0,0,1,5,10,16, 0,0,2,6,11,17, 4,3,7,12,18,0,
     1     9,8,13,20,19,0, 15,14,22,21,0,0, 24,23,4*0/
      IS=2
      IF(I1.GT.5) IS=1
      JS=2
C
      DO 10 J=J1,J2
      IF(J.GT.5) JS=1
      IP=IPP(IS,JS)
C
      GO TO (1,2,3,4),IP
1     IX=I1-5
      IY=J-5
      GO TO 5
2     IX=J-5
      IY=6-I1
      GO TO 5
3     IX=6-I1
      IY=6-J
      GO TO 5
4     IX=6-J
      IY=I1-5
5     N=INDX(IX,IY)
C
      IF(N.EQ.0) GO TO 10
      NPOINT=NPOINT+1
      IF(NPOINT.GE.NPMAX) RETURN1
      N=N+IAD(IS,JS)
      IF(IE.GT.0) N=N+96
      N=N+2687
      HCLADR(NPOINT)=N
C     WRITE(6,600) IE,I1,J,IS,JS,IP,IX,IY,N,NPOINT
C600  FORMAT(' LGFIL',12I8)
10    CONTINUE
C
      RETURN
      END

C   12/03/84            MEMBER NAME  FFITYPE  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C FFITYPE FINDS THE FFITYP OF ADC I RELATIVE TO ADC ONE
C (SOFTWARE ADDRESSES) - SEE CLSPS FOR EXPLANATION
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      FUNCTION FFITYP(IN,ONIN)
      INTEGER ONE,ONIN
C
      ONE=ONIN
      I = IN
C
C SUBTRACT 8 UNTILL 1<= X <=8
C
      DO 10 J=1,5
      IF(I.LE.8)GOTO 11
      I=I-8
  10   CONTINUE
  11       CONTINUE
C
C
C SUBTRACT 8 UNTILL 1<= X <=8
C
C
      DO 12 J=1,5
      IF(ONE.LE.8)GOTO 13
      ONE=ONE-8
 12   CONTINUE
 13   CONTINUE
C
C
C FIX FOR END BLOCKS
C
      IF((ONE.EQ.1).AND.(I.EQ.8))I=0
      IF((ONE.EQ.8).AND.(I.EQ.1))I=9
C
      FFITYP=(I-ONE)+2
C
C      WRITE(6,600) FFITYP,I,ONE
C 600  FORMAT(' FFITYP I ONE ',F3.2,2X,I2,2X,I3)
C
C
      ONIN = ONE
      IN = I
C
      RETURN
      END

C   22/02/82 206281614  MEMBER NAME  ONMUCOOR (JADEMUS)     FORTRAN
C   17/02/82 202171518  MEMBER NAME  ERMUCOOR (S)           FORTRAN
C   04/02/82 202041502  MEMBER NAME  MUCOOR   (JADEMUS)     FORTRAN
C   18/11/81 202041444  MEMBER NAME  MUCOOR   (S)           FORTRAN
C=======================================================================
C MUCOOR CONVERTS THE RAW DATA INTO CARTESIAN COORDINATES
C=======================================================================
C DON'T FORGET TO CHANGE MUANAC TO STORE DATE OF THIS VERSION IN BANK 0.
C=======================================================================
C LAST CHANGE 16.15  28/06/82   HUGH MCCANN  - DISREGARD CHAMBER STATUS.
C      CHANGE 12.30  31/03/82   HUGH MCCANN  - MODIFY BAD CHAMBER BODGE.
C      CHANGE 13.30  22/02/82   HUGH MCCANN  - FOR IMPROVED ERROR OUTPUT
C      CHANGE 14.30  04/02/82   HUGH MCCANN  - BODGE FOR BAD CHAMBERS
C      CHANGE 12.30  19/10/81   HUGH MCCANN  -CORRECT CRATE6 BAD GAS BUG
C      CHANGE 14.58  04/09/81   CHRIS BOWDERY- CORRECT HANG BUG
C      CHANGE 07.30  10/04/81   HUGH MCCANN  - JADEMUS UPDATE.
C      CHANGE 10.19  26/03/81   JOHN ALLISON - TO ADD ABOVE COMMENT
C                                           ABOUT MUANAC, DATE & BANK 0.
C      CHANGE 14.45  24/03/81   HUGH MCCANN -- ALLOW FOR CRATE 6 DURING
C                                              THE BAD GAS PERIOD.
C      CHANGE 15.00  19/02/81   HUGH MCCANN -- MORE TIDYING & DEBUGGING
C MAJOR TIDYING UP   10/09/80   IAN DUERDOTH
C      CHANGE 21.20  12/05/80   JOHN ALLISON - TO COMMENT OUT CMUDAT,ETC
C      CHANGE 15.00  21/04/80   HUGH MCCANN.
C
C
      SUBROUTINE MUCOOR(HMU,NHITS,HC,NHITMX,LMU,HLUN,NWHIT)
      IMPLICIT INTEGER*2 (H)
C
C COMMONS
CMACRO CMUSER
#include "cmucalib.for"
#include "cmustat.for"
CMACRO CMUHIST
#include "cmubcs.for"
      COMMON /CMUIEV/IEV,NEV,IRD,KRUN,KREC,
     *ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON /CMUPRN/IPRIN,MUHPR
C     COMMON /CMUDAT/HMUX(634),HMUY(634),HMUZ(634),
C    1  HLEN(634),HLST(634)
      LOGICAL FIRST/.TRUE./,ENOUGH
      LOGICAL PFG/.TRUE./
      LOGICAL TIMREF,  GOOD
      LOGICAL ADJCHM,SAMCHM,HIT12
      INTEGER  KHM/0/, NOUT/0/
      DIMENSION HMU(1),HC(1),HLUN(1)
      DIMENSION IDRIFT(4)
      DATA NER/0/, KMESS/0/
      DATA HB2/4/,HB3/8/,HB4/16/,HB5/32/,HB6/64/,HB7/128/
C
C
C
C
C     IEV IS THE EVENT NO.,NEV IS NO. OF EVENTS PROCESSED SO FAR...
C     KRUN IS THE RUN NO........
C     HSECT GIVES THE CRATE FOR EACH CHAMBER
C
C
C
C-----------------------------------------------------------------------
C
C     IDBLE IS THE 'DOUBLE PULSE' CUT. IF THE DRIFT TIME DIFFERENCE
C     OF TWO PULSES (WITHIN A GIVEN CHAMBER) IS LESS THAN IDBLE,THEN
C     ONE ASSUMES THAT THE LATER PULSE IS JUST THE 'ECHO' OF THE FIRST.
C     IN THIS CASE ONLY THE EARLIER PULSE IS ACCEPTED AS A 'GENUINE' HIT
      DATA IDBLE/15/
C
C     IMTDLO AND IMTDHI ARE RESPECTIVELY THE SMALLEST AND LARGEST
C     ACCEPTABLE VALUES OF THE DRIFT COORDINATE IN MM
      DATA IMTDLO/-5/,IMTDHI/160/
C
C     MAXMES IS THE MAXIMUM NUMBER OF ERROR MESSAGES TO BE PRINTED/JOB
C     THE NO. OF ERROR MESSAGES IN THE JOB IS COUNTED BY NMESS.
      DATA MAXMES/100/
C
C     MAXMUM IS THE MAXIMUM NUMBER OF SINGLES MESSAGES TO BE PRINTED/JOB
      DATA MAXMUM/100/
C
C     ICONST IS THE CONSTANT SUBTRACTED FROM THE DRIFT TIME OF HIT2
C     TO ESTIMATE THE DRIFT TIME OF HIT1 IN THE EVENT THAT THE DRIFT
C     INFORMATION OF HIT1 HAS BEEN LOST
      DATA ICONST/7/
C
C     MAXREC IS THE MAXIMUM NUMBER OF ATTEMPTS AT DATA RECOVERY
      DATA MAXREC/10/
C
C     IZEXTN  IS ALLOWED EXTENTION PAST THE ENDS OF THE CHAMBER IN
C     WHICH WE PULL THE HIT BACK TO THE PHYSICAL END OF THE CHAMBER
      DATA  IZEXTN/500/
C
C
C
C-----------------------------------------------------------------------
C          ________________
C          WHAT MUCOOR DOES
C          ----------------
C
C CONVERTS MU-CHAMBER SIGNALS TO COORDINATES USING FULL SET OF
C    CALIBRATION DATA.
C
C                              IF THE COORDINATE IS BAD THEN IT IS SET
C                              TO THE CENTRE OF THE CHAMBER,AND HLUN IS
C                              UPDATED APPROPRIATELY
C-----------------------------------------------------------------------
C                       INPUT VARIABLES
C
C HMU         THE RAW MU DATA.
C NHITMX      THE MAXIMUM NO OF HITS THAT CAN BE STORED IN OUTPUT
C               ARRAY HC.  THE DIMENSION OF HC IN THE CALLING ROUTINE
C               MUST BE AT LEAST NWHIT*NHITMX.
C LMU         THE LENGTH OF THE RAW DATA BANK.
C NWHIT       THE NUMBER OF WORDS PER HIT IN THE OUTPUT ARRAY HC
C
C-----------------------------------------------------------------------
C                       OUTPUT VARIABLES
C
C NHITS       THE NUMBER OF HITS,  OUTPUT TO THE ARRAY HC.
C HC          THE OUTPUT ARRAY, EACH HIT IS NWHIT WORDS.
C               WORD  1     -  4*CHAMBER NUMBER + (HIT NUMBER -1).
C               WORD  2     -  10*LAYER NUMBER + ORIENTATION PARAMATER.
C               WORDS 3-8   -  X,Y,Z(LEFT),X,Y,Z(RIGHT) (MM).
C               WORD  9     -  POINTER TO RAW DATA
C HLUN          STATUS BITS FOR EACH HIT IN HC
C
C-----------------------------------------------------------------------
C             BIT...15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
C STRUCTURE OF HLUN  0  0  0  0  0  0  0  A  B  C  D  X  Y  Z  T  L
C               ......THIS BIT NUMBERING RUNS OPPOSITE TO IBM CONVENTION
C                      I.E. MACHINE SEES 'L' FLAG IN BIT NO. 15.
C
C        (BIT) (TRUTH VALUE)
C HLUN  0  = 0(1)   IF LONGITUDINAL COORDINATE IS INVALID(VALID)
C
C HLUN  1  = 0(1)   IF TRANSVERSE   COORDINATE IS INVALID(VALID)
C        I.E. MOD(HLUN,4)= 0 ---> BOTH  COORDS. BAD
C                        = 1 ---> LONG. COORD OK ( TRANS. COORD. BAD)
C                        = 2 ---> TRANS COORD OK ( LONG.  COORD. BAD)
C                        = 3 ---> ALL OK
C
C HLUN  2  = 0(1)   IF Z  COORDINATE IS INVALID(VALID)
C
C HLUN  3  = 0(1)   IF Y  COORDINATE IS INVALID(VALID)
C
C HLUN  4  = 0(1)   IF X  COORDINATE IS INVALID(VALID)
C
C HLUN  5  = 0(1)   IF Z  COORDINATE IS NORMAL(DRIFT OR LONG)
C
C HLUN  6  = 0(1)   IF Y  COORDINATE IS NORMAL(DRIFT OR LONG)
C
C HLUN  7  = 0(1)   IF X  COORDINATE IS NORMAL(DRIFT OR LONG)
C
C HLUN  8  = 0(1)   IF HIT1 LOST BY HIT4 & RECOVERED FROM HIT2(ALL OK)
C
C NOTE:  THE 1'ST SET BIT(OF 5,6,7) IS ALWAYS THAT FOR  LONG. COORD.
C
C=======================================================================
C=======================================================================
C
C                START OF EXECUTABLE PROGRAM.
C
C***********  RE  MONTE-CARLO :  THIS VERSION OF MUCOOR TREATS ALL
C             INPUT MUEV BANKS IDENTICALLY, REGARDLESS OF WHETHER
C             THE INPUT IS MONTE-CARLO , UNDER THE ASSUMPTION THAT
C             M.C. MUEV BANKS ARE IDENTICAL TO REAL DATA. SO , IF
C             THIS IS A MUEV BANK OUTPUT FROM THE OLD M.C. , NO
C             PROCESSING IS ATTEMPTED.
C
          IF( HMU(1).EQ.0 ) RETURN
C********************************************************************
C
C     COUNT NUMBER OF CALLS TO MUCOOR
          NMU(1)=NMU(1)+1
C
C     OPTIONAL OUTPUT
      PFG = IPRIN.NE.0
      IF(FIRST) GOTO 861
      GOTO 862
C     ENTER HERE ON FIRST CALL.
  861 FIRST = .FALSE.
      NMESS=0
      IF(.NOT.PFG)GO TO 862
C     PRINT MEANING OF MUCOOR ERROR MESSAGES.
      WRITE(6,888)
  888 FORMAT(//' MEANING OF MUCOOR MESSAGE CODES'/
     *         ' ==============================='//
     *' (9)16...CHAMBER IN WRRONG CRATE'/
     *' (9)15...DRIFT TIME OF HIT ONE HAS BEEN LOST'/
     *' (9)13...SINGLES DATA WITH HIT NOT 1'/
     *' (9)12...LAST WORD IN HMU NOT 0 OR 3840'/
     *' (9)11...LENGTH ERROR IN HMU'/
     *' (9)10...OUTPUT ARRAY FULL'/
     *' (9)09...SINGLES COUNT.LT.0 OR COUNT TIME.LE.0'/
     *' (9)07...HIT NUMBER NOT DECREASED BY ONE'/
     *' (9)06...CHAMBER NUMBER OUT OF SEQUENCE'/
     *' (9)05...NEW CHAMBER WITH JHIT.NE.1'/
     *' (9)04...CHAMBER NUMBER OUTSIDE RANGE 1 TO 634'/
     *' (9)03...TIME REFERENCE WORD MISSING'/
     *' (9)02...CRATE NUMBER OUT OF ORDER'/
     *' (9)01...CRATE NUMBER OUTSIDE RANGE 1 TO 14'/
     *'  70+N...CRATE N MISSING'//)
  862 CONTINUE
C
C-----------------------------------------------------------------------
C         INITIALISE COUNTERS ETC
C
C         SET THE DRIFT TIME OUT-OF-SEQUENCE FLAG TO ZERO.
          ITDOS=0
C     CLEAR HIT COUNTER
      NHITS=0
      NDIG = 0
C     CLEAR COUNTER FOR THE NUMBER OF ATTEMPTS AT DATA RECOVERY
      NRECOV=0
C  HAS THE MAXIMUM NO. OF ERROR MESSAGES BEEN PRINTED IN THIS JOB?
      IF(NMESS.GE.MAXMES)PFG=.FALSE.
C
C     SET UP LOOP TO FIND MU HIT DATA
C     SET IP=2 TO POINT TO FIRST DATA WORD-1.(IE SKIP BANK DESCRIPTOR)
      IP=2
      IPLAST=2*LMU
      J2 = -NWHIT
      JHIT = 1
      JCHAM = 0
      JCRATE = 0
      IER = 0
      JER=0
      ITDH4=0
C     GET TYPE OF DATA
         GOTO 1001
C
C=======================================================================
C=======================================================================
C
C              START OF MAIN LOOP
C
C        ALL JUMPS IN THIS PROGRAM ARE FORWARDS, EXCEPT TWO:
C          GO TO 2000     &     GO TO 2200
C-----------------------------------------------------------------------
C
C         RETURN HERE AFTER CONVERTING LAST HIT TO COORDS.
C         AND AFTER A RECOVERABLE ERROR
 2000  CONTINUE
       IF(IER.NE.0) GOTO 2201
C
C         DECIDE WHERE TO RE-ENTER THE MAIN SEARCH PROGRAM
C         THE NEXT WORD COULD BE - END OF DATA
C                                - NEXT CRATE
C                                - NEXT CHAM/HIT
C         IF LAST HIT NUMBER WAS NOT 1, THERE MUST BE ANOTHER HIT
          IF(IHIT.NE.1) GOTO                1012
C         GET NEXT WORD
          IP=IP+1
          IF(IP.GE.IPLAST) GOTO                  200
          NW = HMU(IP)
C         TEST FOR END OF DATA(0F00)
          IF(NW.EQ.3840) GOTO               1001
C         TEST FOR NEXT CHAM/HIT WORD
          IF(NW.GE.4.AND. NW.LE.2539 ) GOTO 1013
C         SO IT MUST BE THE NEXT CRATE, BUT THIS IS NOT THE CORRECT
C         WAY TO COME UPON THE NEXT CRATE.
          IP=IP-1
          GOTO                              1001
C
C-----------------------------------------------------------------------
C
 2201 CONTINUE
         JER=IER
         JHIT=1
         JCHAM=0
C  TOLERATE AN ABITRARY NO. OF E.O.C. MARKERS.
              IF(IER.GT.1)GO TO 1990
              IF(ICRATE.NE.0)GO TO 1990
              IER=0
              GO TO 1001
 1990 CONTINUE
      IER = 0
      IF ( NRECOV.GT.MAXREC )  GOTO               201
      NRECOV = NRECOV + 1
 2200 CONTINUE
C  ERROR RECOVERY,  SEARCH FOR NEXT END-OF-CRATE OR CRATE-MARKER.
      NW = HMU(IP)
      IF(NW.EQ.3840)GO TO              2203
      IF(NW.GE.3841.AND.NW.LE.3854.AND.JER.NE.2) GOTO 2204
C IF JER=2 AND PRESENT CRATE HAS NO E.O.C.,NEED THE FOLLOWING
C STATEMENT TO START NEXT CRATE :
      IF(NW.GE.3841.AND.NW.LE.3854.AND.JER.EQ.2
     *   .AND.NW.GT.ICRATE+3840)GO TO 2204
      IP=IP+1
      IF(IP.GE.IPLAST)GO TO                      201
      GO TO 2200
 2203 NMU(22) = NMU(22) + 1
      GOTO 1001
 2204 NMU(23) = NMU(23) + 1
      IP=IP-1
      GOTO 1001
C
C-----------------------------------------------------------------------
C
C                  GET NEXT CRATE
 1001 CONTINUE
C     THIS IS THE INITIAL ENTRY POINT
C     NEXT WORD SHOULD BE A CRATE WORD
C     THE PROCESSING OF EVERY CRATE MUST START HERE AND , IN
C     NORMAL CIRCUMSTANCES, MUST END HERE---EXCEPT CRATE 14,
C     WHICH CAN GO TO 201 AT THE END WITHOUT COMING HERE.
C     AT THIS POINT, NOTE THOSE CRATES WHICH HAD A MISSING
C     E.O.C. MARKER.
          IF(JCRATE.GT.0.AND.HMU(IP).NE.3840)
     *         NMU(84+JCRATE)=NMU(84+JCRATE) + 1
          IP=IP+1
          IF(IP.GE.IPLAST) GOTO                  200
            NW = HMU(IP)
C           TEST FOR VALID CRATE NUMBER
            ICRATE = NW - 3840
            IF(ICRATE.LT.1.OR.ICRATE.GT.14) GOTO 901
C           CHECK THAT CRATE NUMBER HAS INCREASED
            IF( ICRATE.LE.JCRATE ) GOTO          902
            IF(ICRATE.EQ.JCRATE+1)GO TO 1003
                  JCR1=JCRATE+1
                  ICR1=ICRATE-1
CCC               INCREMENT 'CRATE MISSING' COUNTERS.
                  DO 1502 JJ=JCR1,ICR1
                  IER=70+JJ
                  MER=100*IP+IER
                  CALL MUERRY('MUCOOR',MER,' ERROR CODE.^')
 1502             NMU(70+JJ)=NMU(70+JJ)+1
                  NMESS=NMESS+1
 1003      CONTINUE
            JCRATE = ICRATE
            JCHAM = 0
            KF910 = 0
C
C-----------------------------------------------------------------------
C
C         THE NEXT WORD CAN BE,
C          EITHER 1)  END-OF-CRATE WORD, 3840 (HEX 0F00)
C              OR 2)  TIME REF FOR THE CRATE, IF THERE ARE HITS
C              OR 3)  CHAM/HIT WORD,IF THERE ARE NO HITS & ONLY SINGLES
             IP=IP+1
             NW = HMU(IP)
             IF(NW.EQ.3840) GOTO           1001
C
C              TEST FOR VALID TIME REF(WHICH IS ALWAYS ZERO)
               TIMREF = NW.EQ.3584
               IF(.NOT.TIMREF)IP=IP-1
C
C              NEXT WORD MUST BE A CHAMBER/HIT WORD
 1012          IP=IP+1
               IF(IP.GE.IPLAST) GOTO             200
               NW = HMU(IP)
 1013          ICHAM = NW/4
C              CHECK FOR A VALID CHAMBER NUMBER
               IF(ICHAM.LT.1.OR.ICHAM.GT.634) GOTO 904
C              CHECK IF CHAMBER IS IN THE CRATE
               IF(ICRATE.NE.HSECT(HFR(ICHAM)))
     *         GO TO                             916
               IHIT = NW - 4*ICHAM + 1
C              IHIT IS BY DEFINITION IN THE RANGE 1 THROUGH 4
C
C-----------------------------------------------------------------------
C
C     TEST IF CHAMBER NUMBER AND HIT NUMBER ARE CONSISTENT WITH THE LAST
             IF( JHIT.EQ.1 ) GOTO           1010
               IF( IHIT.NE.JHIT-1 ) GOTO         907
               IF( ICHAM.NE.JCHAM ) GOTO         905
               GOTO                    3906
 1010        IF(ICHAM.LE.JCHAM) GOTO 1906
               GOTO  3906
C              DEAL WITH CRATE 9 & 10 WHERE CHAMBERS ARE NOT IN SEQUENCE
 1906        IF(.NOT.(ICRATE.EQ.9.OR.ICRATE.EQ.10)) GOTO 906
             IF(KF910.EQ.1) GOTO              906
             IF( (ICRATE.EQ.9.AND.ICHAM.LE.286.AND.JCHAM.GE.323).OR.
     *       (ICRATE.EQ.10.AND.ICHAM.LE.298.AND.JCHAM.GE.335))
     *       GOTO 2906
C              WE DO HAVE AN ERROR
               GOTO 906
C              NOT AN ERROR BUT IT CAN ONLY HAPPEN ONCE PER CRATE
 2906     KF910 = 1
 3906 CONTINUE
C
C-----------------------------------------------------------------------
C
 1011 CONTINUE
          ADJCHM = ICHAM.EQ.JCHAM+1
          SAMCHM = ICHAM.EQ.JCHAM
          HIT12 = SAMCHM.AND.JHIT.EQ.2
          IF(.NOT.SAMCHM) ITDH4 = 0
C         SET ITDH4 TO 1 IF THERE ARE 4 HITS IN THIS CHAMBER
          IF(.NOT.SAMCHM.AND.IHIT.EQ.4) ITDH4 = 1
C         NEXT WORD IS A DRIFT TIME
          IP=IP+1
          IITD = HMU(IP)
          KKTD = IITD
C         AND THE NEXT IS A LONGITUDINAL TIME DIFFERENCE
          IP=IP+1
          IITL = HMU(IP)
          KKTL = IITL
C         IF NO TIME REF IN THIS CRATE THEN IT MUST BE SINGLES
          IF( IITD.LT.0 .OR. IITD.GT.255 .OR.
     *    IITL.LT.0 .OR. IITL.GT.255 ) GOTO 1200
C           ERROR IF STILL HERE AND THERE WAS NO TIME REF
             IF(.NOT.TIMREF) GOTO 903
             GOTO 1202
C
C-----------------------------------------------------------------------
C
 1200 CONTINUE
C     THIS SECTION HANDLES SINGLES RATES DATA
          NCNT =  IITD - 2048
          NTIM =  IITL - 2048
          IF(IHIT.NE.1) GOTO 913
          IF(NCNT.LT.0 .OR. NTIM.LE.0 ) GOTO 909
          RATE = NCNT
          RATE = 2.0*RATE/NTIM
CP    IF( ENOUGH ) GOTO 2004
CP    KMESS = KMESS + 1
CP    WRITE(6,80)ICHAM,NCNT,NTIM,RATE
CP 80 FORMAT(' MUCOOR SINGLES RATES. CHAM=',I3,'   COUNTS=',I3,
CP   *    '   TIME=',I3,'   CNTS/SEC=',F6.1 )
CP    ENOUGH = KMESS.GE.MAXMUM
 2004 CONTINUE
      GOTO 2002
C
C-----------------------------------------------------------------------
C
C
 1202  CONTINUE
C
C     TEST IF DRIFT TIMES ARE IN SEQUENCE
      IF(.NOT.SAMCHM)GOTO 1014
C     IF DRIFT TIMES ARE OUT OF SEQUENCE, SET ITDOS
C     AND FLAG ALL HITS IN THIS CHAMBER ASBAD.
C     DO THIS IS DONE AFTER PROCESSING HIT1.
          IF(IITD.LT.JITD)GO TO 1014
          ITDOS=1
          NMU(25) = NMU(25) + 1
CC        N.B. NORMALLY, WE DON'T WANT PRINTING FOR THIS ERROR
 1014 CONTINUE
C         INITIALISE BIT 8 OF HIT STATUS OK (I.E. HIT ONE NOT KILLED )
C         THIS FLAG IS ONLY MEANINGFUL FOR HIT1.
          HLUN3 = 2**(8)
      IF(.NOT.SAMCHM)GO TO 1015
C
C         SINCE THE 4'TH HIT DESTROYS THE DRIFT INFORMATION OF THE 1'ST
C        TRY TO RECOVER THIS INFORMATION BY SUBTRACTING A FIXED QUANTITY
C       FROM THE DRIFT TIME OF HIT 2.IF THERE WERE 4 HITS NOTE THE DRIFT
C         TIME FOR THE 2'ND HIT
C         RECORD TEMPORARILY THE DRIFT TIME FOR EACH HIT
          IDRIFT(IHIT) = IITD
C-----------------------------------------------------------------------

C     DO SOMETHING ABOUT HIT 4 KILLING HIT 1
      IF(IHIT.GT.1) GOTO 1015
        IF(ITDH4.EQ.1.AND.IITD.EQ.0.AND.IHIT.EQ.1) GOTO 915
          GOTO 1015
  915     NMU(65)=NMU(65)+1
CC        N.B. NORMALLY, WE DON'T WANT PRINTING FOR THIS ERROR
C         WE HAVE LOST HIT ONE,  RECOVER IT
          KKTD = IDRIFT(2) - ICONST
C         SET STATUS BANK THAT THIS HIT IS BODGED..( BIT 8,= 0)
          HLUN3 = 0
 1015 CONTINUE
C
C-----------------------------------------------------------------------
C     NOTE: KKTD,MAY AT THIS STAGE,BE DIFFERENT TO IITD IF HIT1 HAS BEEN
C     KILLED BY HIT4
          ITD = 0
          IF(KKTD.GE.5.AND.KKTD.LT.256) ITD = KKTD
C
          ITL = 0
          IF(KKTL.GE.4.AND.KKTL.LE.255 ) ITL = KKTL
C
C         COUNT NUMBER OF DIGITISINGS FOUND
          NDIG = NDIG + 1
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  BODGE FOR 1980 SUSPECT CHAMBERS :
C     PRE-AUTUMN 1980     ---   NO NEED TO SWITCH ANY CHAMBERS OFF ;
C     AUTUMN 1980 TILL 6/81 --- MUST SWITCH ALL 15 OFF , FROM RUN 4900.
C     ( AUTUMN 1980 = 1/10/80 )
C     USE TIME TO IMPLEMENT THESE BODGES, RATHER RUN NO. SO THAT
C     MONTE-CARLO WILL PICK UP CORRECT CHAMBER STATUS.
          IF(IYEAR.LT.1980)GO TO 4901
          IF(IYEAR.GT.1981)GO TO 4902
          IF(IYEAR.EQ.1980.AND.IMONTH.LT.10)GO TO 4901
          IF(IYEAR.EQ.1981.AND.IMONTH.GT.5)GO TO 4901
          HMCSTA(6)  =1
          HMCSTA(22) =1
          HMCSTA(26) =1
          HMCSTA(111)=1
          HMCSTA(120)=1
          HMCSTA(168)=1
          HMCSTA(170)=1
          HMCSTA(178)=1
          HMCSTA(217)=1
          HMCSTA(232)=1
          HMCSTA(246)=1
          HMCSTA(253)=1
          HMCSTA(256)=1
          HMCSTA(257)=1
          HMCSTA(258)=1
 4901 CONTINUE
C
C  ALL DATA UP TILL END OF 1981 , SWITCH 210-213 OFF ALWAYS (DIGITISER):
          HMCSTA(210)=1
          HMCSTA(211)=1
          HMCSTA(212)=1
          HMCSTA(213)=1
 4902     CONTINUE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C         GET THE STATUS OF THE CHAMBER
CCCCCCCC  GOOD = HMCSTA(ICHAM).EQ.0       CCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCC     CONSIDER ALL CHAMBERS ON. CCCCCCCCCCCCCCCCC
          GOOD = .TRUE.
C         IGNORE HITS FROM BAD CHAMBERS
          IF( GOOD )GO TO              1017
C           SIGNAL FROM CHAMBER WITH STATUS 'NOT OK'.
            NMU(12)=NMU(12)+1
            GO TO                                2001
C             SIGNAL FROM CHAMBER WITH STATUS 'OK'.
 1017 CONTINUE
C
C----------------------------------------------------------------------
C
C        REMOVE HITS FROM SECOND BEAM CROSSING.
C   NORMALLY , THIS MEANS A FIXED CUT OF 80 CLOCK PULSES (4.0 MICROSECS)
C   BUT , IF DRIFT VELOCITY DECREASES , NEED LARGER CUTOFF.
C   ---- THIS HAPPENED BETWEEN RUNS 4220 & 4482.
C   THE NORMAL DRIFT VELOCITY IS 2150 MICRONS PER CLOCK PULSE.
C   --- TO ABOUT 5 %, THAT IS. SO PUT ITMCUT=80*2260/NEW VDRIFT  .
C
      ITMCUT=80
      IF(KRUN.GE.4220.AND.KRUN.LE.4482)ITMCUT=180800/HVDRFT(ICHAM)
      IF ( ITD.GE.ITMCUT ) GOTO 2001
C
C-----------------------------------------------------------------------
C
C        DOUBLE PULSE CUT.
C        IF THE PREVIOUS HIT WAS IN THE SAME CHAMBER AND IF IT WAS
C        CLOSER THAN THE CUT, IDBLE (SET TO 15), THEN DELETE THE
C        PREVIOUSLY ENTERED HIT BY REDUCING NHITS BY ONE AND RESETTING
C        THE POINTER J2,  THEN PROCEDE TO PROCESS THE PRESENT HIT.
         IF(.NOT.SAMCHM) GOTO               1016
         IF(JITD-KKTD.GT.IDBLE.OR.JITD-KKTD.LE.0) GOTO 1016
C              CHECK IF PREVIOUS HIT WAS KEPT. IF NOT , DON'T DELETE
C              A HIT, JUST PROCESS THIS ONE.
               IF(JITD.GE.ITMCUT)GO TO 1016
C              SO ITS A CLOSE PULSE AND WE HAVE TO DELETE ONE
               NHITS = NHITS - 1
               J2 = J2 - NWHIT
               NMU(21) = NMU(21) + 1
 1016    CONTINUE
C
C-----------------------------------------------------------------------
C
C      WE NOW HAVE A SET OF VALID NUMBERS (ICRATE,ICHAM,IHIT,ITD,ITL)
C      WHICH HAVE SATISFIED ALL THE DATA CONSISTENCY REQUIREMENTS.
C      THESE WILL NOW BE CONVERTED INTO COORDINATES.
C      THEY CAN NO LONGER BE REJECTED, BUT ONLY FLAGGED.
C      ITD, ITL  MAY BE ZERO, INDICATING A HIT BUT NO POSITIONAL
C      INFORMATION.
C
C-----------------------------------------------------------------------
C
C         GET THE GLOBAL PARAMETERS
C         FRAME NUMBER.
          IFRAME=HFR(ICHAM)
C         ORIENTATION PARAMETER.
          IOR=HNORM(IFRAME)
C         CALCULATE THE NORMAL COORDINATE.
          ICNORM=HDIST(IFRAME)+HD1(ICHAM)
C
C         PROCESS THE LONGITUDINAL DATA
          IMMTL  = 0
          IF(ITL.NE.0)IMMTL=(HLSF(IHIT,ICHAM)*(ITL-HLTP(ICHAM)))/100
C         SET HLUN1 TO 1 (=0001)
          HLUN1 = 1
          LONG  = 1
C         CALCULATE THE LONGITUDINAL CENTRE OF THE CHAMBER, THEN
C         CALCULATE THE LONGITUDINAL COORDINATE, FLAG IF BAD.
          ICLCEN = (HCLLO(IFRAME)+HCLHI(IFRAME))*0.5
          ICLONG = ICLCEN + IMMTL
C         DATA IS GOOD IF POSITION IS WITHIN IZEXTN OF END OF CHAMBER
          IF( ITL.NE.0. .AND.
     *    ICLONG.GE.(HCLLO(IFRAME)-IZEXTN)  .AND.
     *    ICLONG.LE.(HCLHI(IFRAME)+IZEXTN)  ) GOTO  7
C            THE DATA IS BAD.
C            SET HLUN1 TO 0 (=0000)
             HLUN1 = 0
             LONG  = 0
C            SET ICLONG TO COORDINATE OF CENTRE OF CHAMBER
             ICLONG = ICLCEN
C            INCREMENT BAD LONGITUDINAL COUNT.
             NMU(6)=NMU(6)+1
    7     CONTINUE
          IF(ICLONG.LT.HCLLO(IFRAME).OR.ICLONG.GT.HCLHI(IFRAME))
     *    NMU(27) = NMU(27) + 1
C         IF POSITION IS OUTSIDE CHAMBER, PULL IT IN.
          IF(ICLONG.LT.HCLLO(IFRAME)) ICLONG = HCLLO(IFRAME)
          IF(ICLONG.GT.HCLHI(IFRAME)) ICLONG = HCLHI(IFRAME)
C   FOR THE HANG CORRECTION WE NEED THE CORRECTED IMMTL
          IMMTL = ICLONG - ICLCEN
C
C         ICLONG, HLUN1, LONG ARE NOW SET.
C
C         PROCESS THE DRIFT TIME DATA
          IMMTD = 0
          IF(ITD.NE.0)IMMTD=(HVDRFT(ICHAM)*(ITD-HDTP(ICHAM)))/1000
C   FOR CRATE 6, HAVE TO CORRECT THE SPECIAL UPDATES OF DRIFTVELOCITY
C   PERTAINING TO THE BAD GAS PERIOD (FOR THE CRATE 6 CLOCK PULSE.)
          IF(KRUN.GE.4220.AND.KRUN.LE.4482.AND.ICRATE.EQ.6)
     *    IMMTD=1.258*IMMTD
C         CALCULATE THE WIRE COORDINATE.
          ICWIRE=HCTW(ICHAM)
C         SET HLUN2 TO 2 (=0010)
          HLUN2 = 2
          NDRIF = 1
C       CALCULATE THE TWO (L/R AMBIGUOUS) TRANSVERSE COORDINATES.
             IF(IMMTD.LT.IMTDLO .OR. IMMTD.GT.IMTDHI) GOTO 85
C            DATA IS GOOD, BUT PULL IN IF JUST OUTSIDE PHYSICAL RANGE
             IF(IMMTD.LT.0.OR.IMMTD.GT.145) NMU(29)=NMU(29)+1
             IF(IMMTD.LT.0) IMMTD = 0
             IF(IMMTD.GT.145)IMMTD = 145
             IANG=(HANG(IFRAME)*IMMTL)/10000.
             ICT1=ICWIRE-IMMTD+IANG
             ICT2=ICWIRE+IMMTD+IANG
             GOTO 8
   85        CONTINUE
C            THE DATA IS BAD, SO SET HLUN2 TO 0 (=00000)
             HLUN2 = 0
             NDRIF = 0
C            SET IC1 & IC2 TO COORDINATE OF CENTRE OF CHAMBER
             ICT1 = ICWIRE
             ICT2 = ICWIRE
C            INCREMENT BAD DRIFT TIME COUNT.
             NMU(5)=NMU(5)+1
    8     CONTINUE
C         ICT1, ICT2, HLUN2, NDRIF ARE NOW SET.
C
C-----------------------------------------------------------------------
C
C     STORE THE RESULTING COORDINATES IN THE OUTPUT ARRAY HC.
      IF(NHITS.GE.NHITMX) GOTO 910
          NHITS = NHITS + 1
C         REMEMBER J2 WAS SET TO -NWHIT AT BEGINNING OF EVENT.
          J2 = J2 + NWHIT
C         FILL OUTPUT ARRAY HC.
C         4*(CHAMBER NUMBER) + (HIT NUMBER -1)
          HC(J2+1)=HMU(IP-2)
C         10*LAYER NUMBER + ORIENTATION PARAMETER (HOR).
          HC(J2+2)=10*HLAYER(IFRAME)+IOR
C         OVERALL X DISPLACEMENT.
          IX=HOVALL(HUNIT(IFRAME))
C         X,Y,Z COORDINATES
          GO TO (11,12,13),IOR
   11        CONTINUE
               HC(J2+3)=ICNORM+IX
               HC(J2+4)=ICT1
               HC(J2+5)=ICLONG
               HC(J2+6)=ICNORM+IX
               HC(J2+7)=ICT2
               HC(J2+8)=ICLONG
               HLUNY = HB6 + HB5 + HB4 + NDRIF*HB3 + LONG*HB2
             GO TO 20
   12        CONTINUE
               HC(J2+3)=ICT1+IX
               HC(J2+4)=ICNORM
               HC(J2+5)=ICLONG
               HC(J2+6)=ICT2+IX
               HC(J2+7)=ICNORM
               HC(J2+8)=ICLONG
               HLUNY = HB7 + HB5 + NDRIF*HB4 + HB3 + LONG*HB2
             GO TO 20
   13        CONTINUE
               HC(J2+3)=ICT1+IX
               HC(J2+4)=ICLONG
               HC(J2+5)=ICNORM
               HC(J2+6)=ICT2+IX
               HC(J2+7)=ICLONG
               HC(J2+8)=ICNORM
               HLUNY = HB7 + HB6 + NDRIF*HB4 + LONG*HB3 + HB2
   20     CONTINUE
C         POINTER TO CHAM/HIT DATA WORD IN RAW DATA
          HC(J2+9)=IP-2
C         PACK STATUS INFORM'N FOR THIS HIT IN THE FIRST 8 BITS OF HLUN
          HLUN(NHITS) = HLUN1 + HLUN2 + HLUN3 + HLUNY
C
C-----------------------------------------------------------------------
C
C       RECORD CURRENT PARAMETERS, (TO CHECK NEXT DIGITISING)
 2001 CONTINUE
          JITD = IITD
          JITL = IITL
          JTD = ITD
          JTL = ITL
          JHIT = IHIT
          JCHAM = ICHAM
C
C-----------------------------------------------------------------------
C
      IF(IHIT.GT.1)GO TO 2002
      IF(ITDOS.EQ.0)GO TO 2002
C           DRIFT TIMES ARE OUT OF SEQUENCE FOR THIS CHAMBER.
C         PROCEDURE FOR DRIFT TIMES OUT OF SEQUENCE :
C            LOOK BACK THRO' THE ARRAY HC AND COUNT THE NO. OF
C         HITS WHICH WERE KEPT FROM THIS CHAMBER. THEN CORRECT HLUN
C         ENTRY FOR THESE HITS BY MAKING BOTH DRIFT AND LONGITUDINAL
C         COORDINATES 'BAD'.
          IKEPT=0
          J1=J2-3*NWHIT
      DO 3010 JJ=J1,J2,NWHIT
          JHCHAM=HC(JJ+1)/4
          IF(JHCHAM.EQ.ICHAM)IKEPT=IKEPT+1
 3010 CONTINUE
          HLUN1=0
          HLUN2=0
          LONG=0
          NDRIF=0
      DO 3025 I=1,IKEPT
      GO TO (3011,3012,3013),IOR
 3011     HLUNY=HB6+HB5+HB4+NDRIF*HB3+LONG*HB2
      GO TO 3020
 3012     HLUNY=HB7+HB5+NDRIF*HB4+HB3+LONG*HB2
      GO TO 3020
 3013 HLUNY=HB7+HB6+NDRIF*HB4+LONG*HB3+HB2
 3020 HLUN(NHITS-IKEPT+I) = HLUN1 + HLUN2 + HLUN3 + HLUNY
 3025 CONTINUE
C
C      BEFORE GOING ON TO NEXT CHAMBER , SET ITDOS TO ZERO AND
C      INCREMENT NMU(64).
          ITDOS=0
          NMU(64)=NMU(64)+1
          GOTO 2002
C
C-----------------------------------------------------------------------
C
C       ERROR COUNTING
C
C       901 IS INVALID CRATE NUMBER
  901 NMU(51) = NMU(51) + 1
        IER = 1
        GOTO 930
C
C       902 IS CRATE NUMBER OUT OF ORDER
  902 NMU(52)=NMU(52)+1
        IER = 2
        GOTO 930
C
C       903 IS MISSING TIME REF WORD
  903 NMU(53) = NMU(53) + 1
        IER = 3
        GOTO 930
C
C       904 IS INVALID CHAMBER NUMBER
  904 NMU(54) = NMU(54) + 1
        IER = 4
        GOTO 930
C
C       905 IS NEW CHAMBER WITH JHIT = 1
  905 NMU(55) = NMU(55) + 1
        IER = 5
        GOTO 930
C
C       906 IS CHAMBER NO OUT OF SEQUENCEE
  906   NMU(56) = NMU(56) + 1
        IER = 6
        GOTO 930
C
C       907 IS HIT NUMBER NOT DECREASED BY ONE
  907   NMU(57) = NMU(57) + 1
        IER = 7
        GOTO 930
C
C       909 IS NEGATIVE COUNTS OR TIME IN SINGLES DATA
  909   NMU(59) = NMU(59) + 1
        IER = 9
        GOTO 930
C
C       913 IS SINGLES DATA WITH HIT NOT 1
  913 NMU(63) = NMU(63) + 1
        IER = 13
        GOTO 930
C
C       916 IS CHAMBER IN WRONG CRATE
  916 NMU(66) = NMU(66) + 1
        IER = 16
C
  930 CONTINUE
      NMESS=NMESS+1
      MER=100*IP+IER
      CALL MUERRY('MUCOOR',MER,' ERROR CODE.^')
C
C       AFTER ERROR JUMP BACK TO TRY TO START AGAIN
C-----------------------------------------------------------------------
C
C         JUMP BACK TO BEGINNING OF THE MAIN LOOP
 2002 CONTINUE
      GOTO  2000
C----------------------------------------------------------------------
C
C                  END OF MAIN LOOP
C=======================================================================
C=======================================================================
C
C         END OF INPUT DATA REACHED
C         CHECK THE POSITION OF THE POINTER
  200     IF(IP.EQ.IPLAST+1) GOTO 201
            IF(IP.NE.IPLAST) GOTO 911
            IF( HMU(IP).EQ.0 .OR. HMU(IP).EQ.3840 ) GOTO 201
              GOTO 912
  201  CONTINUE
C             NOTE WHETHER CRATE 14 HAD AN E.O.C. MARKER.
              IF(ICRATE.EQ.14.AND.(  HMU(IP).EQ.3840.OR.HMU(IP-1)
     *        .EQ.3840 )  ) GO TO 202
              NMU(98)=NMU(98)+1
  202 CONTINUE
C             INCREMENT NUMBER OF HITS AND 'NO DATA' COUNT
              NMU(4)=NMU(4)+NHITS
              IF(NHITS.LE.0)NMU(3)=NMU(3)+1
CP    WRITE(6,444)IEV,NHITS
CP444  FORMAT(1X,/,'++++ EVENT ',I3,' ++++ NUMBER OF HITS ',I3/)
      RETURN
C
C=======================================================================
C=======================================================================
C
C     PROCESS THE VARIOUS ERROR  CONDITIONS
C
C     910 IS OVERFLOW OF OUTPUT ARRAY
  910 NMU(60) = NMU(60) + 1
      IER = 10
      GOTO 998
C
C     911 IS LENGTH ERROR IN ARRAY HMU
  911 NMU(61) = NMU(61) + 1
      IER = 11
      GOTO 998
C
C     912 IS LAST WORD NOT 0 OR 3840 IN HMU
  912 NMU(62) = NMU(62) + 1
      IER = 12
      GOTO 998
C
  998 CONTINUE
      NMESS=NMESS+1
      MER=100*IP+IER
      CALL MUERRY('MUCOOR',MER,' ERROR CODE.^')
  999 CONTINUE
C     999 IS THE EXIT FOR ERRORS 10, 11, 12.
C     CAN PUT TYPE OUT HERE
      RETURN
C
C=======================================================================
C=======================================================================
C=======================================================================
C=======================================================================
C
C     WHAT IS SCALED IN THE COUNTERS NMU
C
C     1     CALLS TO MUCOOR
C     3     EVENTS WITH NO HITS
C     4     SUM(OVER EVENTS) OF NUMBER OF HITS
C     5     DRIFT COORD FLAGGED AS BAD
C     6     LONGITUDINAL COORD FLAGGED AS BAD
C    12     HIT FROM CHAMBER WITH STATUS NOT GOOD(1017)
C    21     HIT DELETED BY DOUBLE PULSE CUT(1016)
C    22     END-OF-CRATE FOUND IN RECOVER SEARCH (2203)
C    23     CRATE MARKER FOUND IN RECOVER SEARCH (2204)
C    25     IITD.GE.JITD
C    27     LONGL HIT PULLED IN TO END OF CHAMBER (7)
C    29     DRIFT COORD PULLED IN
C    51     INVALID CRATE NUMBER (901)
C    52     CRATE NUMBER OUT OF ORDER
C    53     TIME REFERENCE WORD NOT PRESENT
C    54     INVALID CHAMBER NUMBER
C    55     NEW CHAMBER, BUT LAST HIT WAS NOT HIT1
C    56     CHAMBER OUTOF SEQUENCE
C    57     HIT NUMBER NOT DECREASED BY ONE
C    59     IN SINGLES DATA, COUNTS OR TIME IS NEGATIVE
C    60     OVERFLOW OF OUTPUT ARRAY, I.E. MORE THAN 200 HITS
C    61     LENGTH ERROR IN HMU
C    62     LAST WORD OF HMU IS NOT 0 NOR 3840
C    63     SINGLES DATA, BUT NOT HIT1
C    64     OUTPUT HITS FLAGGED DUE TO OUT OF SEQUENCE DRIFT TIMES
C           N.B. #64 IS INCREMENTED ONLY ONCE PER CHAMBER IN ANY ONE
C                EVENT, WHEREAS #25 IS INCREMENTED FOR EVERY INSTANCE
C                WHERE WE HAVE  (SAMCHM).AND.IITD.GE.JITD  , WHICH
C                MORE THAN ONCE IN ANY ONE CHAMBER.
C    65     RECOVER OVERWRITTEN HIT1 WITH (HIT2-ICONST)
C    66     CHAMBER IN WRONG CRATE
C
C    70 + NN   COUNT OF NUMBER OF EVENTS WHERE CRATE NN WAS MISSING
C    84 + NN    "    "   "     "    "      "     "   "  HAD NO E.O.C.
      END

C   07/06/96 606071840  MEMBER NAME  CUBDER   (S4)          FORTG1
      SUBROUTINE CUBDER(P,Q,NU)
      REAL P(5,1),Q(5,1),RN
      REAL*8 SUM
      EXTERNAL CUBSPL
C
C     DIFFERENTIATION/INTEGRATION OF SPLINE FUNCTIONS
C
C
C     INPUT
C     P-ARRAY(RESULTING FROM CALL COBSPL)
C     NU POSITIVE MEANS NU-TH DERIVATIVE
C     NU ZERO     MEANS COPY
C     NU  =-1     MEANS INTEGRATION
C
C     RESULT
C     Q-ARRAY SPLINE FUNCTION OF DERIVATIVE/INTEGRAL
C
      NUN=NU
      N=P(5,1)
      DO 10 I=1,N
      DO 10 J=1,5
   10 Q(J,I)=P(J,I)
   20 IF(NUN) 30,100,50
C     INTEGRATION
   30 K=N-1
      DO 40 J=1,K
      I=N-J
      DX=Q(1,I+1)-Q(1,I)
   40 Q(2,I+1)=
     1     (((3.0*Q(5,I)*DX+4.0*Q(4,I))*DX+6.0*Q(3,I))*DX
     2     +12.0*Q(2,I))*DX/12.0
      Q(2,1)=0.0
      SUM=0.0
      DO 45 I=2,N
      SUM=SUM+Q(2,I)
   45 Q(2,I)=SUM
      NUN=NUN+1
      GOTO 70
C     DIFFERENTIATION
   50 K=N-1
      CALL CUBFUN(Q(1,N),D,Q(2,N),Q)
      DO 60 I=1,K
   60 Q(2,I)=Q(3,I)
      NUN=NUN-1
   70 CALL CUBCOP(N,Q)
      GOTO 20
  100 RETURN
      END

C   14/02/87 707080941  MEMBER NAME  ZE4VPK   (S)           FORTRAN77
      SUBROUTINE ZE4VPK( IGEN )
C-----------------------------------------------------------
C VERSION OF 21/11/86       M.ZIMMER
C MODIFIED   23/01/87       M.ZIMMER
C MODIFIED   14/02/87       G.ECKERLIN  (ZE4INI INCLUDED)
C MODIFIED   23/02/87       G.ECKERLIN / M.ZIMMER
C MODIFIED   02/04/87       G.ECKERLIN  (PARTONS INCLUDED FOR MC)
C LAST MOD   02/04/87       G.ECKERLIN  (NO CALL TO ZE4VEK FOR MC)
C NEW VERSION FOR NEW ZE4V-BANK
C PACK INFORMATION INTO ZE4V-BANK FROM PATR AND LGCL BANKS
C IMODE = 0 UNCONNECTED LG-CLUSTERS AND PATR
C       = 1 UNCONNECTED LG-CLUSTERS
C       = 2 ALL CLUSTERS AND PATR
C       = 3 ALL CLUSTERS
C       = 4 CHARGED ONLY ( ALL MASSES PI )
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON P(10,400)
      DIMENSION IP(10,100),HP(20,1)
      EQUIVALENCE (P(1,1),IP(1,1),HP(1,1))
C
      DIMENSION VECTB(1000)
C
      DIMENSION PACT(3), R(3), RDOCA(3)
      INTEGER NWARN(2) / 2*0 /
      DATA IEV / 0 /, IEVLIM / 0 /
C                                            FORMAT OF ZEHD BANK
      DIMENSION HRUN(2)
      EQUIVALENCE (IRUN,HRUN(1))
C                                   MC INFO IN ZEHD NOT IMPLEMENTED
      DATA LMCH / 0 /
      DATA MCFLAG / 0 /
C
      EXTERNAL VECSUB
C
C                                           CUT PARAMETERS
C                                           RMIN CUT
      DATA RMINCT /  50. /
C                                           Z-CUT
      DATA ZCT    / 350. /
C                                           MIN R-PHI-HITS
      DATA NRPHCT / 20 /
C                                           MIN R-Z-HITS
      DATA NRZCT  / 12 /
C                                           MOMENTUM CUT
      DATA PCT   / .05 /
C                                           LG MIN ENERGY
      DATA ELGPHM / .150 /
C                                           LG SUBTRACTION ENERGY
      DATA ELGMIN /    .350 /
C
      DATA IMODE / 2 /
C                                           FORMAT OF ZE4V BANK
      DATA  LH / 31 /, LT / 9 /, LVX / 3 /, LMC / 18 /,
     & LTCH / 12 /, LTNE / 5 /, LTRE / 5 /
C                                            FORMAT OF ZEHD BANK
      DATA HVERS/ 1 /, LZHD / 3 /
      DATA LCUT / 12 /
C
      LVECS = 0
      GO TO 1

      ENTRY ZE4VIN( IGEN )
C--------------------------------------------------------
C  ENTRY FOR FIRST EVENT
C  CREATES ZEHD BANK FIRST
C  CHECKS IF MONTE CARLO OR DATA
C--------------------------------------------------------
      NPZEHD = IW(IBLN('ZEHD'))
C                                   DELETE OLD BANK
      IF (NPZEHD.GT.0) CALL BDLS('ZEHD',IGEN)
C                                      INIT ERROR MESSAGES
      CALL FEHLTX( 1,'ERROR CREATING ZEHD-BANK')
      CALL FEHLTX( 2,'NO PATR / LGCL BANK ')
      CALL FEHLTX( 3, 'NUMBER OF CHARGED TRACKS <= 0 IN PATR')
      CALL FEHLTX( 4, 'ERROR WHILE CREATING ZIM1-BANK')
      CALL FEHLTX( 5, 'NO TRACKS IN ZE4V-BANK')
      CALL FEHLTX( 11,'NUMBER OF HITS IN R-PHI LT CUT')
      CALL FEHLTX( 12,'NUMBER OF HITS IN R-Z LT CUT')
      CALL FEHLTX( 13,'Z- CUT NOT PASSED')
      CALL FEHLTX( 14,'RMIN CUT NOT PASSED')
      CALL FEHLTX( 15,'MOMENTUM CUT NOT PASSED')
      CALL FEHLTX( 17,'NO CONNECTED LG-CLUSTER')
      CALL FEHLTX( 18,'JCLUS > 0 BUT NO LGCL-BANK')
      CALL FEHLTX( 19,'CORR. ECL < 0 (NO CL. IN LGANAL)')
C                                   CHECK IF MONTE CARLO
      IRUN = IRNEVT(DUMMY)
      IF (HRUN(1).LT.100) MCFLAG = 1
C                                   CALC LENGTH OF BANK
      LZEHD = LZHD + LCUT + LMCH
C                                   CREATE NEW BANK
      CALL BCRE(NPZEHD,'ZEHD',IGEN,LZEHD,&30,IER)
      CALL BSAW(1,'ZEHD')
C                                   FILL HEADER PART
      HW(NPZEHD*2 + 1) = HVERS
C                                   FLAG MC>1/DATA=0
      HW(NPZEHD*2 + 2) = MCFLAG
C                                   # OF WORDS FOR HEADER PART
      HW(NPZEHD*2 + 3) = LZHD
C                                   # OF WORDS FOR CUT INFO
      HW(NPZEHD*2 + 4) = LCUT
C                                   # OF WORDS FOR MC INFO
      HW(NPZEHD*2 + 5) = LMCH
C                                   NOT USED
      HW(NPZEHD*2 + 6) = 0
C                                   CUT INFO PART
      NPZECT = NPZEHD + LZHD
      RW(NPZECT + 1) = 0.
C
      RW(NPZECT + 2) = 0.
C
      HW(NPZECT*2 + 5) = NRPHCT
C
      HW(NPZECT*2 + 6) = NRZCT
C
      RW(NPZECT + 4) = RMINCT
C
      RW(NPZECT + 5) = ZCT
C
      RW(NPZECT + 6) = PCT
C
      RW(NPZECT + 7) = 0.
C
      RW(NPZECT + 8) = 0.
C
      RW(NPZECT + 9) = 0.
C
      RW(NPZECT + 10) = ELGMIN
C
      RW(NPZECT + 11) = ELGPHM
C
      RW(NPZECT + 12) = .5
C                                   MC INFO PART
C     NPZEMC = NPZECT + LCUT
C     DO 20 IC = 1, LMCH
C       RW(NPZECT + IC) = 0.       NOT IMPLEMENTED !!!!!
C20   CONTINUE
      LVECS = 0
      GOTO 1
C                                  ERROR IN BCRE
 30   CONTINUE
      LVECS = 0
      CALL FEHLER( 1, &1 )

      ENTRY ZE4VUP( NST, N, IGEN )
C--------------------------------------------------------
C  ENTRY FOR VECSUB OPTION
C  LEAVES PARTICLES IN BLANK COMMON
C--------------------------------------------------------
      LVECS = 1
    1 CONTINUE
      IEV = IEV + 1
C
C
C                                      LOOK FOR BANKS
CC    NPZE4V = IW( IBLN('ZE4V'))
CC    IF( NPZE4V .GT. 0 ) CALL BDLS( 'ZE4V',IGEN)
      CALL BDLS( 'ZE4V',IGEN)
C                                      PATR - NBANK
      NPPATR = IW( IBLN('PATR'))
      IF( NPPATR .LE. 0 .AND. IMODE .EQ. 4 ) CALL FEHLER( 2, &8000 )
      NPLGCL = IW( IBLN('LGCL'))
      IF( NPPATR .LE. 0 .AND. NPLGCL .LE. 0 ) CALL FEHLER (2,&8000 )
      IF( NPLGCL .LE. 0 .AND. IMODE .EQ. 1
     &.OR.NPLGCL .LE. 0 .AND. IMODE .EQ. 3 ) CALL FEHLER( 2, &8000 )
C                                      IF NOT MC LMC = 0
      IF (MCFLAG.EQ.0) LMC = 0
C
      NVX = 1
      LHEAD = LH + NVX*LVX + LMC
C                                           CREATE ZE4V HEAD
      CALL BCRE( NPZE4V, 'ZE4V', IGEN, LHEAD, &8100, IER )
      CALL BSAW( 1, 'ZE4V' )
      HW(NPZE4V*2+ 1) = LHEAD
C                                      VERTEX PART
      HW(NPZE4V*2+ 2) = LVX
      HW(NPZE4V*2+ 3) = NVX
C                                      MONTE-CARLO PART
      HW(NPZE4V*2+ 4) = LMC
C                                      GENARAL TRACK PART
      HW(NPZE4V*2+ 5) = LT
C                                      TOTAL NUMBER OF PARTICLES
      HW(NPZE4V*2+ 6) = 0
C                                      CHARGED TRACK PART
      HW(NPZE4V*2+ 7) = LTCH
      HW(NPZE4V*2+ 8) = 0
C                                      NEUTRAL TRACK PART
      HW(NPZE4V*2+ 9) = LTNE
      HW(NPZE4V*2+10) = 0
C                                      RECONSTRUCTED TRACK PART
      HW(NPZE4V*2+11) = LTRE
      HW(NPZE4V*2+12) = 0
C                                      RUN/EVENT #
      IW(NPZE4V  + 7) = IRNEVT( DUMMY )
C                                           EBEAM
      EBE = EBGENL( DUMMY )
      RW(NPZE4V  + 8) = EBE
C                                      NOT USED( E-VIS FROM TP CH.+ NE)
      RW(NPZE4V  +29) = 0.
C                                      NOT USED( E-VIS FROM TP NEUTRAL)
      RW(NPZE4V  +30) = 0.
C
C                                      ACCEPT EVENT BY MCREDU
      MRFLAG = -1
      CALL MCREDU( 0., &2040 )
C                                      EVENT ACCEPTED
      MRFLAG = 1
 2040 CONTINUE
      IW( NPZE4V + 31 ) = MRFLAG
      NTRVX = 0
      CALL ZE4VVX( R, NTRVX )
C                                           SET VERTEX HERE
      DO 20 I=1,3
         RW(NPZE4V  + LH + I) = R(I)
   20 CONTINUE
C
C$$$$$$---------------------------------    MC PART OF HEADER
C                                           FILLED FROM VECT BANK

      IF(MCFLAG.EQ.0) GOTO 4213
C
      NPVECT = IW(IBLN('VECT'))
      IF(NPVECT.GT.0) GO TO 4119
       WRITE(6,9212) HW(NPZE4V*2+14),HW(NPZE4V*2+13)
9212   FORMAT(' NO VECT BANK IN EVENT ',I8,'  RUN ',I8)
       GOTO 4213
4119  CONTINUE

C                                        START VECT-ANALYSIS
C
C                                        POINTER TO MC PART IN ZE4V
      NPMC = NPZE4V + LH + NVX*LVX
C
      HLENG = IW(NPVECT+1)
      IEVT = IW(NPVECT+3)
      NPARMC = IW(NPVECT+4)
      DO 4118 IMC=1,6
      VECTB(IMC) = FLOAT(IW(NPVECT+IMC))
4118  CONTINUE
      VECTB(7) = RW(NPVECT+7)
      VECTB(8) = RW(NPVECT+8)
      VECTB(9) = FLOAT(IW(NPVECT+9))
      NFLAV = IABS(IW(NPVECT+9))
      VECTB(10) = 0.
      DO 4320 IMC = 1,NPARMC
      JMC = 10 * IMC
      K = JMC + HLENG - 10
      VECTB(JMC+1) = RW(NPVECT+K+1)
      VECTB(JMC+2) = RW(NPVECT+K+2)
      VECTB(JMC+3) = RW(NPVECT+K+3)
      VECTB(JMC+4) = RW(NPVECT+K+4)
      VECTB(JMC+5) = RW(NPVECT+K+5)
      VECTB(JMC+8) = RW(NPVECT+K+8)
      VECTB(JMC+9) = RW(NPVECT+K+9)
      VECTB(JMC+10) = RW(NPVECT+K+10)
      VECTB(JMC+6) = FLOAT(IW(NPVECT+K+6))
      VECTB(JMC+7) = FLOAT(IW(NPVECT+K+7))
4320  CONTINUE
C
C                                        FIND NO OF JETS
C
      NJET = 0
      DO 4110 IMC=1,4
      IND = (NPARMC-IMC+1)*10
      IF(VECTB(IND+7).GE.-100.) GOTO 4313
      NJET = NJET + 1
      RW(NPMC + (IMC-1)*4 + 2) = VECTB(IND+1)
      RW(NPMC + (IMC-1)*4 + 3) = VECTB(IND+2)
      RW(NPMC + (IMC-1)*4 + 4) = VECTB(IND+3)
      RW(NPMC + (IMC-1)*4 + 5) = VECTB(IND+4)
      GOTO 4110
4313  CONTINUE
      RW(NPMC + (IMC-1)*4 + 2) = 0.
      RW(NPMC + (IMC-1)*4 + 3) = 0.
      RW(NPMC + (IMC-1)*4 + 4) = 0.
      RW(NPMC + (IMC-1)*4 + 5) = 0.
4110  CONTINUE
      HW(NPMC*2 + 1) = NJET
      HW(NPMC*2 + 2) = NFLAV
C
4213  CONTINUE
C
C                                           END OF MC PART
C
C$$$$$$---------------------
C
      IF( IMODE .EQ. 1 .OR. IMODE.EQ.3 ) GO TO 1000
C
C                                           PATR TRACKS
      IPPHOT = IBLN('PHOT')
      NPPHOT = IW( IPPHOT )

      NTR = IW( NPPATR + 2 )
      IF( NTR .LE. 0 )      CALL FEHLER( 3, &1000 )
C
C                                      PATR INTERNAL COPIED AND
C                                      POINTER 'NPPATR' OVERWRITTEN
C
      CALL ZE4VMI( NPPATR )
      IF ( NPPATR .EQ. 0 ) THEN
        CALL BDLS( 'ZE4V',IGEN)
        CALL FEHLER ( 4,&8000 )
      ENDIF
C
      IP0 = IW( NPPATR + 1 ) + NPPATR
      LP = IW( NPPATR + 3 )
      IP9 = IP0 + ( NTR - 1) * LP
C                                           LOOP OVER TRACKS
      DO 300 J = IP0, IP9, LP
        NUMTRK = IW( J + 1 )
        NRPHI = IW(J+24)
        IF( NRPHI .LT. NRPHCT ) CALL FEHLER ( 11, &300 )
        NRZ = IW(J+33)
        IF( NRZ .LT. NRZCT )  CALL FEHLER ( 12, &300 )
        AZV = ABS( RW(J+31) )
        IF( AZV .GT. ZCT )         CALL FEHLER ( 13, &300 )
        CALL PRTOCI( J, CAP, RMIN, PHIM, SIG )
        IF( ABS( RMIN ) .GT. RMINCT )    CALL FEHLER ( 14, &300 )
C                                      SET REFERNCE POINT FOR CRDOCA
        CALL CRDOCA( J, R, PACT, RDOCA, CHARGE )
        PTOT = SQRT( PACT(1)**2 + PACT(2)**2 + PACT(3)**2 )
        IF( PTOT .LT. PCT )      CALL FEHLER ( 15, &300 )
C                                      ACCEPT THIS TRACK

C                                      FILL GLOBAL PART FOR EACH TRACK
C                                      EXTEND BANK
        CALL BCHM( NPZE4V, LT+LTCH, IER )
C                                      POINTER TO NEXT ZE4V-WORD
      NP = NPZE4V + LHEAD + HW( NPZE4V*2 + 6) * LT
     &                    + HW( NPZE4V*2 + 8) * LTCH
     &                    + HW( NPZE4V*2 +10) * LTNE
     &                    + HW( NPZE4V*2 +12) * LTRE
        NP2 = NP * 2
C                                      SUM UP # OF TOTAL AND CH. TRKS
        HW(NPZE4V*2+8 ) = HW(NPZE4V*2+8) + 1
        HW(NPZE4V*2+6 ) = HW(NPZE4V*2+6) + 1
C                                      EX,EY,EZ
        DO 1200 I = 1,3
          RW( NP + I ) = PACT(I)/PTOT
 1200   CONTINUE
C                                      # OF VERTEX OF PARTICLE ORIGIN
CCC     HW( NP2 + 9) = 0
        HW( NP2 + 9) = 1
C                                      # OF SEC VERTEX
        HW( NP2 +10) = 0
C                                      MOMENTUM
        FAC = 1.
        IF( PTOT .GT. EBE ) FAC = .5*EBE /PTOT
        RW(NP + 6) = PTOT*FAC
        RW(NP + 7) =  CHARGE
C                                      LG-INFORMATION
        JCLUS1 = IW( J + 40 )
        NPLGCL = IW(IBLN('LGCL'))
        SIGECL = 0.
        ECL    = 0.
        JBAREC = -1000
        IF ( NPLGCL .GT. 0 .AND. JCLUS1 .GT. 0 ) THEN
          IPENDE = IW( NPLGCL + 4 )
          IP3 = IW( NPLGCL + 3 )
          NWPCL = IW( NPLGCL + 25 )
          NPOI = NPLGCL + IP3 + (JCLUS1-1) * NWPCL -1
C         IF ( NPOI .GT. ( NPLGCL + IPENDE )) CALL FEHLER( 16,&3123)
          ECL    = RW( NPOI + 2 )
          SIGECL = RW( NPOI + 3 )
          JBAREC = IW( NPOI + 1 )
        ELSEIF( NPLGCL .GT. 0 .AND. JCLUS1 .LE. 0 ) THEN
          CALL FEHLER( 17, &3123)
        ELSEIF( NPLGCL .LE. 0 .AND. JCLUS1 .GT. 0 ) THEN
          CALL FEHLER( 18, &3123)
        ENDIF
 3123   CONTINUE
C
        NPART = 0
        NPHOT = IPPHOT + 1
  210   NPHOT = IW(NPHOT-1)
        IF( NPHOT.LE.0 .OR. NPART.GT.0 ) GO TO 220
        IF(IW(NPHOT+24).EQ.IW(J+1)) NPART = IW(NPHOT+25)
        IF(IW(NPHOT+25).EQ.IW(J+1)) NPART = IW(NPHOT+24)
        GO TO 210
C                                      PATR NUMBER OF PHOT PARTNER
  220   HW( NP2 + 7 ) = NPART
C                                           MC PART
C                                      0 OR PART# IN PALL BANK (HW(+15))
C                                      0 OR ELECTRON ORIGIN    (HW(+16))
        IW( NP + 8 ) = 0
C                                      CHECK FOR MONTE CARLO
        IF( MCFLAG.GT.0 )
     *      CALL ZE4VMC( IW(J+1), IW( NP+8 ) )
C
C                                      NUMBER OF CORR. TPTR BANK
          HW(NP2 + 17 ) = NPTPFU( NUMTRK )
C                                      ADDITIONAL CH. TRACK PART
          HW(NP2 + 18 ) = 1
C                                      CLUSTER-ENRGY IN GEV
          RW(NP + LT + 1 ) = ECL
C                                      ERROR IN CLUSTER-ENRGY
          RW(NP + LT + 2 ) = SIGECL
C                                      DETECTOR FLAG
          JDETEC = 1000
          IF ( JBAREC .EQ. 0 ) JDETEC = JDETEC + 100
          IF ( IABS(JBAREC) .EQ. 1 ) JDETEC = JDETEC + 1
          HW( NP2 + LT*2 + 7) = JDETEC
C                                      #OF 1. AND 2. CONN. CLUSTER
          HW( NP2 + LT*2 + 8) = JCLUS1
C                                      # IN PATR-BANK
          HW( NP2 + LT*2 + 9) = NUMTRK
C                                      NRPHI + 100*NRZ
          HW( NP2 + LT*2 +10) = NRPHI + 100*NRZ
C                                      (X,Y,Z) TRACK AT DOCA
          RW( NP + LT + 6) = RDOCA( 1 )
          RW( NP + LT + 7) = RDOCA( 2 )
          RW( NP + LT + 8) = RDOCA( 3 )
C                                      FUNC GIVES CORRESPONDING TPTR-BNK
          DEDX = 0.
          SIDEDX = 0.
          MUONQU = 0
          NPTPTR = NPTPFU( NUMTRK )
C                                      DEDX
          IF( NPTPTR .GT. 0 ) THEN
            DEDX = RW( NPTPTR + 73 )
            SIDEDX = RW( NPTPTR + 74 )
C                                      MUON QUALITY FLAG OR 0
            MUONQU = HW( NPTPTR*2 + 96 )
          ENDIF
C
          RW( NP + LT + 9 ) = DEDX
          RW( NP + LT +10 ) = SIDEDX
          RW( NP + LT +11 ) = RMIN
          IW( NP + LT +12 ) = MUONQU
C                                      CORRECTED CLUSTER ENERGY( MEIER )
          CALL ZE4VML( NP, ECLCOR )
          IF (ECLCOR.LT.0) THEN
            ECLCOR = 0
            CALL FEHLER(19,&3222)
 3222     ENDIF
          RW(NP + LT + 3 ) = ECLCOR
C                                      PARTICLE TYPE DETECTION
C                                      WITH SPECIAL ROUTINES
          ITYP = 0
C                                      ELECTRON SEARCH (FOR DATA ONLY)
          IF (MCFLAG.EQ.0 ) THEN
            CALL ZE4VEK( NP , IEKA )
            IF ( IEKA .EQ. 0 ) ITYP = 2
          ENDIF
C                                      PARTICLE CODE (MC-CONV)
          HW( NP2 + 8) = ITYP
C
  300   CONTINUE
C
C                                      RESTORE ORIGINAL PATR-BANK
C                                      POINTER AGAIN OVERWRITTEN
      CALL ZE4VME( NPPATR )
C
C
C------------------------------------- NEUTRAL PRIMARY
C
C                                           LGCL BANKS
 1000 IF( IMODE .EQ. 4 ) GO TO 2050
C
      NPLGCL = IW(IBLN('LGCL'))
      IF( NPLGCL .EQ. 0 ) GO TO 2050
C
      NCLST = IW( NPLGCL + 7 )
      IF( NCLST .LE. 0 ) GO TO 2050
C                                           LOOP OF CLUSTERS
C                                           ALL CLUSTERS GET
C                                           CHARGE 0
      IP2 = IW( NPLGCL + 2 )
      IP3 = IW( NPLGCL + 3 )
      NWPCL = IW( NPLGCL + 25 )
      IP0 = NPLGCL + IP3 - 1
      IP9 = IP0 + (NCLST-1) * NWPCL
      JCL = 0
      DO 2000 J=IP0,IP9,NWPCL
        JCL = JCL + 1
C                                           CHECK IF CONNNECTED
        ICONN = IW( J + 8 )
        IF( ICONN.NE.0 .AND. IMODE.LT.2 ) GO TO 2000
        ECL  = RW( J + 2 )
        ETOT = ECL
        SIGECL = RW( J + 3 )
        JBAREC = IW( J + 1 )
C                                      # OF LG-BLOCKS IN  CLUSTER
C                                      MINUS NUMBER OF TRACKS CONN.
        NPCLMP = NPLGCL + IP2 + JCL - 1
        NBLOCK = HW( NPCLMP*2 ) - HW(NPCLMP*2 - 1) + 1 -ICONN/100
        IF (JBAREC .EQ. 0 ) JBAREC = 100
C                                           PATH LENGTH CORREC
        DZDS = 1.
        IF( IW(J+1).EQ.0 ) DZDS = 1./SQRT(1-RW(J+11)**2)
        IF( ICONN .NE. 0 ) ETOT = ETOT - ELGMIN*(ICONN/100)*DZDS
        IF( ETOT .LT. ELGPHM ) GO TO 2000
C
C                                           ACCEPT THIS TRACK
        CALL BCHM( NPZE4V, LT+LTNE, IER )
C                                      POINTER TO NEXT ZE4V-WORD
        NP = NPZE4V + LHEAD + HW( NPZE4V*2 + 6) * LT
     &                      + HW( NPZE4V*2 + 8) * LTCH
     &                      + HW( NPZE4V*2 +10) * LTNE
     &                      + HW( NPZE4V*2 +12) * LTRE
        NP2 = NP * 2
C                                      SUM UP # OF TOTAL AND NE. TRKS
        HW(NPZE4V*2+10) = HW(NPZE4V*2+10) + 1
        HW(NPZE4V*2+6 ) = HW(NPZE4V*2+6 ) + 1
C                                      EX,EY,EZ
        DO 1211 I = 1,3
           RW(NP+I) = RW(J+8+I)
 1211   CONTINUE
C                                      0 OR PATR # OF PHOT PARTNER
        HW( NP2 + 7) = 0
C                                      PART TYPE
        ITYP = 1
        HW( NP2 + 8) = ITYP
C                                      1./2. VERTEX
CCC     HW( NP2 + 9) = 0
        HW( NP2 + 9) = 1
        HW( NP2 +10) = 0
C                                      PTOT
        RW(NP  + 6) = ETOT
C                                      CHARGE
        RW(NP  + 7) = 0.
C                                      0 OR PART# IN PALL BANK
        HW( NP2 + 15) = 0
C                                      0 OR ELECTRON ORIGIN
        HW( NP2 + 16) = 0
C                                      TPTR NUMBER
        HW( NP2 + 17) = 0
C                                      0 FOR NEUTRAL PARTICLES
        HW( NP2 + 18) = 0
C                                      CLUSTER-ENERGY IN GEV
        RW( NP + LT + 1 ) = ECL
C                                      ERROR IN CLUSTER-ENERGY
        RW( NP + LT + 2 ) = SIGECL
C                                      CORRECTED CLUSTER ENERGY(NOT YET)
        RW( NP + LT + 3 ) = 0.
C                                      LG DETECTOR PART
        HW( NP2 + LT*2 + 7) = JBAREC
C                                      #OF 1. AND 2. CONN. CLUSTER
        HW( NP2 + LT*2 + 8) = ( J - IP0 ) / NWPCL + 1
C                                      # OF (BLOCKS - CH TRACKS) (1.CL)
        HW( NP2 + LT*2 + 9) = NBLOCK
C                                      # OF (BLOCKS - CH TRACKS) (2.CL)
        HW( NP2 + LT*2 +10) = 0
 2000 CONTINUE
C
C
 2050 CONTINUE
C
      IF( LVECS.NE.0 ) GO TO 2100
         N = HW( NPZE4V*2 + 6 )
         NST = 0
C                                           SAVE AWAY BLANK COMMON
         CALL BCRE( NPBUF, '--BU', 0 , 10*(N+5), &8200, IER )
         CALL UCOPY( P(1,NST+1), RW(NPBUF+1), 10*(N+5) )
 2100 CONTINUE
      IF( IEV.LT.IEVLIM) CALL BPRS( 'ZE4V', IGEN )
      CALL ZE4VUN( NST, N, 0 )
      IF( N.LE.0 ) GO TO 2150
         IF( IEV.LT.IEVLIM) CALL PWRT( NST+1, NST+N, 10000 )
         NPZE4V = IW(IBLN('ZE4V'))
         CALL SPTHAK( NST+1, NST+N, NST+N+4, THR,
     &                              NST+N+1, SPH,
     &                              NST+N+5, AKO, IER )
C                                      SPHERICITY
         CALL UCOPY( P(1,NST+N+1), RW(NPZE4V+ 9), 4 )
         CALL UCOPY( P(1,NST+N+2), RW(NPZE4V+13), 4 )
         CALL UCOPY( P(1,NST+N+3), RW(NPZE4V+17), 4 )
C                                      THRUST
         CALL UCOPY( P(1,NST+N+4), RW(NPZE4V+21), 4 )
C                                      AKOPLANARITY
         CALL UCOPY( P(1,NST+N+5), RW(NPZE4V+25), 4 )
         IF( IEV.LT.IEVLIM) CALL BPRS( 'ZE4V', IGEN )
         IF( IEV.LT.IEVLIM) CALL PWRT( NST+N+1, NST+N+5, 10000 )
C                                           RESTORE BLANK COMMON
 2150 CONTINUE
      IF( LVECS.NE.0 ) GO TO 2200
         CALL UCOPY( RW(NPBUF+1), P(1,NST+1), 10*(N+5) )
         CALL BDLS( '--BU', 0 )
 2200 CONTINUE
C
      GO TO 8000
C
C
C
C                                           BANK ZE4V
      ENTRY ZE4VST( NST, N, IGEN )
C-----------------------------------------------------------
C NEW VERSION  17-11-86    M.ZIMMER
C ONLY A VERY ELEMENTARY FORM OF ZE4V BANK IS FILLED
C ALL PARTICLES GET THE SAME NUMBER OF WORDS ( LT ) AND NO
C ADDITIONAL INFORMATION IS STORED
C STORE MOMENTA FROM VECSUB COMMON INTO ZE4V
C THE PARTICLES ARE STORED IN
C NST+1..NST+N, WHERE N IS SET ON EXIT
C-----------------------------------------------------------
C
      IF( N.LE.0 ) GO TO 5000
C                                           EBEAM
         EBE = EBGENL( DUMMY )
C
         CALL BCRE( NPZE4V, 'ZE4V', IGEN, LH+LT*N, &8100, IER )
         CALL BSAW( 1, 'ZE4V' )
         HW(NPZE4V*2+ 1) = LH
         HW(NPZE4V*2+ 2) = 0
         HW(NPZE4V*2+ 3) = 0
         HW(NPZE4V*2+ 4) = 0
         HW(NPZE4V*2+ 5) = LT
         HW(NPZE4V*2+ 6) = N
         HW(NPZE4V*2+ 7) = 0
         HW(NPZE4V*2+ 8) = 0
         HW(NPZE4V*2+ 9) = 0
         HW(NPZE4V*2+10) = 0
         HW(NPZE4V*2+11) = 0
         HW(NPZE4V*2+12) = 0
C                                      RUN/EVENT #
      IW(NPZE4V  + 7) = IRNEVT( DUMMY )
      RW(NPZE4V  + 8) = EBE
C
      CALL SPTHAK( NST+1, NST+N, NST+N+4, THR,
     &                           NST+N+1, SPH,
     &                           NST+N+5, AKO, IER )
C                                      SPHERICITY
      CALL UCOPY( P(1,NST+N+1), RW(NPZE4V+ 9), 4 )
      CALL UCOPY( P(1,NST+N+2), RW(NPZE4V+13), 4 )
      CALL UCOPY( P(1,NST+N+3), RW(NPZE4V+17), 4 )
C                                      THRUST
      CALL UCOPY( P(1,NST+N+4), RW(NPZE4V+21), 4 )
C                                      AKOPLANARITY
      CALL UCOPY( P(1,NST+N+5), RW(NPZE4V+25), 4 )
C
         NP = NPZE4V + LH
         N1 = NST + 1
         NN = NST + N
         DO 3000 J=N1,NN
            RW(NP  + 1) = P(1,J)/P(6,J)
            RW(NP  + 2) = P(2,J)/P(6,J)
            RW(NP  + 3) = P(3,J)/P(6,J)
            HW(NP*2+ 7) = HP(18,J)
            HW(NP*2+ 8) = HP(16,J)
            HW(NP*2+ 9) = 0
            HW(NP*2+10) = 0
            RW(NP  + 6) = P(6,J)
            RW(NP  + 7) = P(7,J)
            HW(NP*2+15) = HP(19,J)
            HW(NP*2+16) = HP(20,J)
            HW(NP*2 + 17) = 0
            HW(NP*2 + 18) = -1
C
            NP = NP + LT
 3000    CONTINUE
C
 5000 CONTINUE
      GO TO 8000
C
C
      ENTRY ZE4VDP
C-----------------------------------------------------------
C  DUMP BANK IN READABLE FORMAT
C-----------------------------------------------------------
      NPZE4V = IW(IBLN('ZE4V'))
      IF( NPZE4V.LE.0 ) GO TO 6000
C
      NZ2 = NPZE4V*2
      LLH = HW( NZ2 + 1 ) - HW( NZ2 + 3 )*HW( NZ2 + 2 )
     &                       - HW( NZ2 + 4)
      WRITE(6,9103) IW(NPZE4V-2), IW(NPZE4V),(HW(NZ2+I),I=1,14),
     *              RW(NPZE4V+8),(RW( NPZE4V+ LLH + I ),I=1,3),
     *              IW(NPZE4V+31)
 9103 FORMAT(//' DUMP OF ZE4V  ',I4,' LENGTH=',I5,5X,/,
     *1X,' LHD  LVX  NVX  LMC   LT   NP  LCH  NCH  LNE  NNE  LRE  NRE',
     *'   # RUN   # EVT   E-BEAM   X-VX1   Y-VX1   Z-VX1  MCREDU',/,
     * 1X,12(I4,1X),1X,I6,2X,I6,2X,F7.3,3(1X,F7.2),6X,I2/)
      J = NPZE4V+9
      K = NPZE4V+28
      WRITE(6,9104) (RW(I),I=J,K)
 9104 FORMAT( 5X,3F10.3,2X,F10.3,'            '/
     *        5X,3F10.3,2X,F10.3,'  SPHERICITY'/
     *        5X,3F10.3,2X,F10.3,'           '/
     *        5X,3F10.3,2X,F10.3,'  THRUST'/
     *        5X,3F10.3,2X,F10.3,'  AKOPLANARITY')
C
      N = HW( NZ2 + 6 )
      LTR = HW( NZ2 + 5 )
      LTRCH = HW( NZ2 + 7 )
      LTRNE = HW( NZ2 + 9 )
      LTRRE = HW( NZ2 + 11)
      J = 0
      NP = NPZE4V + HW(NZ2+1)
      IF( N.LE.0 ) GO TO 5100
      WRITE(6,9105)
 9105 FORMAT(1X,'NR    EX    EY    EZ   PTOT  Q',
     *       ' PH TY VO VS PL OR PT',
     *       '   ECL S_ECL M_ECL  DET CL12 PA RZRF',
     *       ' X-TRK Y-TRK Z-TRK  DEDX SDEDX  R-MIN')
 5100 IF( J.GE.N ) GO TO 6000
      J = J + 1
      NP2 = NP*2
         IF( HW(NP*2 +18 ) .EQ. 1 )  THEN
      WRITE(6,9108)J,RW(NP+1),RW(NP+2),RW(NP+3),RW(NP+6),INT(RW(NP+7)),
     *                    HW(NP2+7),HW(NP2+8),HW(NP2+9),HW(NP2+10),
     *                    HW(NP2+15),HW(NP2+16),HW(NP2+18),
     &                    (RW(NP+LTR+I),I=1,3),(HW(NP2+LTR*2+I),I=7,10),
     &                    (RW(NP+LTR+I),I=6,11)
 9108       FORMAT(1X,I2,1X,3(F5.2,1X),F6.3,1X,I2,1X,6(I2,1X),I2,
     &            3(1X,F5.2),2(1X,I4),1X,I2,1X,I4,3(1X,F5.1),
     &            2(1X,F5.2),1X,F6.2)
            NP = NP + LTR + LTRCH
C
          ELSEIF ( HW(NP*2 + 18) .EQ. 0 ) THEN
C
      WRITE(6,9109)J,RW(NP+1),RW(NP+2),RW(NP+3),RW(NP+6),INT(RW(NP+7)),
     *                    HW(NP2+7),HW(NP2+8),HW(NP2+9),HW(NP2+10),
     *                    HW(NP2+15),HW(NP2+16),HW(NP2+18),
     &                    (RW(NP+LTR+I),I=1,3),(HW(NP2+LTR*2+I),I=7,8)
 9109       FORMAT(1X,I2,1X,3(F5.2,1X),F6.3,1X,I2,1X,6(I2,1X),I2,
     &                 3(1X,F5.2),2(1X,I4))
            NP = NP + LTR + LTRNE
C
          ELSEIF( HW(NP*2 + 18) .EQ. 2 )  THEN
C
      WRITE(6,9110)J,RW(NP+1),RW(NP+2),RW(NP+3),RW(NP+6),INT(RW(NP+7)),
     *                    HW(NP2+7),HW(NP2+8),HW(NP2+9),HW(NP2+10),
     *                    HW(NP2+15),HW(NP2+16),HW(NP2+18),
     &                    (RW(NP+LTR+I),I=1,3),(HW(NP2+LTR*2+I),I=7,8)
 9110       FORMAT(1X,I2,1X,3(F5.2,1X),F6.3,1X,I2,1X,6(I2,1X),I2,
     &                 3(1X,F5.2),2(1X,I4))
            NP = NP + LTR + LTRRE
C
          ELSEIF( HW(NP*2 + 18) .EQ.-1 )  THEN
C
            NP = NP + LTR
C
         ENDIF
C
         GO TO 5100
 6000 CONTINUE
C
 8000 CONTINUE
      NPZE4V = IW( IBLN('ZE4V'))
      IF ( HW(NPZE4V*2+6).LE.0) THEN
        CALL FEHLER( 5, &8001 )
 8001   CALL BDLS( 'ZE4V',IGEN)
      ENDIF
      RETURN
C
 8100 NWARN(1) = NWARN(1) + 1
      IF( NWARN(1).LT.10 ) WRITE(6,9101) IER
 9101 FORMAT(' IER=',I4,' WHEN CREATING ZE4V')
      RETURN
C
 8200 NWARN(2) = NWARN(2) + 1
      IF( NWARN(2).LT.10 ) WRITE(6,9102) IER
 9102 FORMAT(' IER=',I4,' WHEN CREATING --BU')
C
      RETURN
      END
      INTEGER FUNCTION NPTPFU( NUMTRK )
C--------------------------------------------------------------------
C     VERSION 21-11-86   LAST MOD. 23-11-86  M.ZIMMER
C
C     LOOKS FOR CORRESPONDING TPTR-BANK TO GIVEN TRACK # IN PATR-BANK
C--------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      NPTPFU = 0
      NPTPTR = IW(IBLN('TPTR'))
C     IF(NPTPTR .LE. 0 ) CALL FEHLER( 37 , &8000 )
C                                      TRY FIRST TPTR-BANK WITH SAME NO.
      CALL BLOC( NPTPTR, 'TPTR', NUMTRK, &8000 )
      NRTPTR = HW( NPTPTR*2 + 4 )
      IF( NRTPTR .EQ. NUMTRK) THEN
        NPTPFU = NPTPTR
        RETURN
      ELSE
C                                      LOOP OVER TPTR BANKS
        CALL BPOS( 'TPTR' )
 2000   CALL BNXT( NPTPTR, &8000)
        NRTPTR = HW( NPTPTR*2 + 4 )
        IF( NRTPTR .EQ. NUMTRK ) THEN
C                                      NUMBER OF BANK
          NPTPFU = NPTPTR
          RETURN
        ENDIF
        GOTO 2000
      ENDIF
 8000 CONTINUE
      RETURN
      END

C   23/06/78 601062125  MEMBER NAME  BK7ABS   (JADEMC2)     FORTRAN
      FUNCTION BK7ABS(ALAMDA)
C
C---- S.YAMADA     17-11-77
C     LAST MODIFICATION  20-10-78  16:35
C
C---- CALCULATE ABSORPTION LENGTH IN THE BK7 LIGHT GUIDE.
C     THE NEW DATA FROM HTV IS USED.
C     ALAMDA IN NANO-METER,BK7ABS IN CM
C
      IF(ALAMDA-370.) 1,1,2
CC  1 BK7ABS = 10.**(0.0202*ALAMDA-5.445)
C---- FOR THE SCHOTT BK7
CC  1 BK7ABS = 10.0**(0.034*ALAMDA-10.38)
    1 BK7ABS = 10.0**(0.02275*ALAMDA-6.0026)
      RETURN
CC  2 BK7ABS = 10.**(0.001346*ALAMDA+1.531)
    2 BK7ABS = 10.**(0.00796*ALAMDA-0.531)
      RETURN
      END

C   18/01/88 807262112  MEMBER NAME  TPRFI1   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPRFI1( REFITR, MODE )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      18/01/88:  Get instr. about R-Phi refit
C
C          mod: C. Bowdery      22/07/88:  Add 32 to MODE for JHTL
C     Last mod: C. Bowdery      26/07/88:  Change to TPINQR and response
C
C     Routine to provide yes/no answer about need for inner detector
C     R-Phi refit and if wanted, the refitting mode. See JCN 94.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     REFITR    Out      L*4      TRUE if R-FI refit step is to be done
C     MODE      Out      I*4      MODE value needed for s/r XYRFTV
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  REFIT*8, CIFNOR*20, CRFI*20
      CHARACTER           COLDP*20, CWEAK*20, CSTRNG*20

      LOGICAL  RFI, IFNOR, FIRST, OLDPAT, WEAK, STRONG

      LOGICAL  REFITR, NOV, WEAKV, STRNGV

      INTEGER  MODE

      SAVE  FIRST, RFI, IFNOR, OLDPAT, WEAK, STRONG

      DATA  FIRST / .TRUE. /
      DATA  REFIT / 'REFIT' /,  CIFNOR  / 'IFNORFI' /
      DATA  COLDP / 'OLDPATR' /, CRFI   / 'RFI'   /
      DATA  CWEAK / 'WEAKVTX' /, CSTRNG / 'STRONGVTX' /

C------------------  C O D E  ------------------------------------------

C                            If not first call, IFNOR etc already SAVEd.

      IF( FIRST ) THEN

C                            Get user option relating to rfi refitting
C                            that is, RFI, IFNORFI, OLDPATR, WEAKVTX
C                            and  STRONGVTX.

        CALL TPUOPT( REFIT, CRFI,   RFI    )
        CALL TPUOPT( REFIT, CIFNOR, IFNOR  )
        CALL TPUOPT( REFIT, COLDP,  OLDPAT )
        CALL TPUOPT( REFIT, CWEAK,  WEAK   )
        CALL TPUOPT( REFIT, CSTRNG, STRONG )

        FIRST = .FALSE.

      ENDIF

C                            If RFI specified then set REFITR and MODE
C                            then handle IFNORFI condition if specified.

      IF( RFI ) THEN

        REFITR = .TRUE.

C                            Specify if new PATR bank to be created

        IF( OLDPAT ) THEN
          MODE = 0
        ELSE
          MODE = 1
        ENDIF

C                            Specify vertex constraint (no,weak,strong)

        IF( WEAK ) THEN
          MODE = MODE + 4
        ELSEIF( .NOT. STRONG ) THEN
          MODE = MODE + 16
        ENDIF

C                            Set the create/update option for JHTL

        MODE = MODE + 32

C                            Was IFNORFI condition specified? If so,
C                            determine whether refit needed.

        IF( IFNOR ) THEN

C                            No/weak/strong vertex constraint Spitzer
C                            fit on latest PATR bank?

          CALL TPINQR( NOV, WEAKV, STRNGV )

C                            If so and if it matches what is needed,
C                            then no new refit required.

          IF( ( WEAKV   .AND.  WEAK   )  .OR.
     +        ( STRNGV  .AND.  STRONG )  .OR.
     +        ( NOV     .AND.  .NOT. ( STRONG  .OR.  WEAK ) ) ) THEN
            REFITR = .FALSE.
            MODE   = 0
          ENDIF
        ENDIF

      ELSE

C                            No refit wanted.

        REFITR = .FALSE.
        MODE   = 0

      ENDIF

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   20/12/83 611261028  MEMBER NAME  KLREAD2  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE KLREAD
C-----------------------------------------------------------------------
C
C
C                                        21. 9. 82      P. STEFFEN
C
C        HANDLES ALL RUN DEPENDENT CONSTANTS
C        ALSO THOSE SET IN KALIBR
C
C        CORRECTION: UPDATE /CALIBR/ FOR MC-DATA IF LBMC(IBANK)=1
C                                        12.11. 82      P. STEFFEN
C
C        HANDLING OF CELL DEPENDENT DRIFT VELOCITY
C                                        30. 8. 83      P. STEFFEN
C
C        HANDLING OF NEW DEDX CONSTANTS
C
C        USE COMMON /CMCCAL/ LBMC(15)  TO INDICATE IF
C        CALIBR. CONST. SHALL BE USED (LBMC(IBANK) = 1)
C                                        28.11. 83      P. STEFFEN
C
C        NEW PERIOD OF RUNS (8712 - 9999)
C        HANDLING OF ZCAL CONSTANTS
C                                        28. 11. 83      P. STEFFEN
C
C        READ CALIBRATION FILES FOR MONTE CARLO EVENTS ONLY IF AT LEAST
C        ONE LBMC IS SET NON-ZERO          15.12.83   J.OLSSON
C        ERROR IN PREVIOUS CHANGE, CAUSED ERROR IN MUON MC. NOW CORRECT.
C                                          20.12.83   J.OLSSON,C.BOWDERY
C
C        ADDED EXTERNAL JADEBD              9.01.84   C.BOWDERY
C
C        NEW PERIOD OF RUNS (15699 - 99999)
C                                          16.05.84   J.SPITZER
C
C        NUMBER OF RUN PERIODS CHANGED
C        FROM 16 TO 24                      4.10.84   J.SPITZER
C
C        LOAD VERTEX CHAMBER CALIBRATION CONSTANTS
C                                          08.10.84   J.HAGEMANN
C
C        CHANGE TO VERTEX CHAMBER CONSTANT DRVELO
C                                          24.10.84   J.HAGEMANN
C
C        CHANGE T0, VD, LORENTZ ANGLE FOR RUNS 16800...
C                                          19.12.85   P. STEFFEN
C        RUN DEPENDENT ABERR(1) (PROPAGATION TIME FOR PULSE ON WIRE)
C                                          27.10.86   J.SPITZER/J.OLSSON
C        ADD BANK IDJS FOR SPITZER CALIBRATION
C        T0 UPDATES FOR FADC RUNS
C                                        17.10. 86      SPITZER/ELSEN
C        NEW VD AND LOR ANGLE AND T0EFFC CALL
C        INSERTED
C                                        11.11. 86      SPITZER/ELSEN
C        NEW T0, VD, AND LOR ANGLE
C                                        20.11. 86      SPITZER/ELSEN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C                            FORCE LOADING OF JADE BLOCK DATA
      EXTERNAL JADEBD
C
#include "cgraph.for"
#include "cdata.for"
#include "cjvtxc.for"
C
      COMMON/CWORK/HWORK(40)
C
#include "cgeo1.for"
      COMMON /CJTRIG/ PI,TWOPI
C
#include "cjdrch.for"
#include "cdsmax.for"
C
C
      COMMON /CALIBR/ JPOINT(100),
     1   CMUCA(4185),CLGMA(2880),CTAGS( 192),CJTPL(4608),CJTAB(1344),
     2   CTOFC( 546),CLGST( 500),CDEDX(1841),CSPTG( 193),CRVTX(   6),
     3   CZCAL(11329),CTAGF( 32),CIDJS(12000)
         DIMENSION ACALIB(100),HCALIB(100),ICALIB(100)
         EQUIVALENCE(JPOINT(1),ACALIB(1),HCALIB(1),ICALIB(1))
C
C
C                            LG ANALYSIS PARAMETERS
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX,DZVRTX
     $               ,IDUMM(2),ICALFL
C
      COMMON /CMCCAL/ LBMC(15)
      DIMENSION NAME(15),LENG(15),MAXL(15)
C
      DATA NBANKS /13/
      DATA NAME/'MUCA','LGMA','TAGS','JTPL','JTAB',
     1          'TOFC','LGST','DEDX','SPTG','RVTX',
     2          'ZCAL','TAGF','IDJS','    ','    '/
      DATA LENG /2,2,2,2,4,  4,2,2,2,4,  4,2,4,0,0 /
      DATA MAXL/  4185,  2880,   192, 4608,  1344,
     1             546,   500,  1841,  193,     6,
     2           11329,    32, 12000,    0,     0/
C
C
      DATA LBLGST /0/
      DATA LBCONS /0/
C
C
      DIMENSION ITIME(6),LSTIME(10)
      DIMENSION IBUF(2001),JBUF(2000),IKDAT(1),HBUF(21),HKDAT( 10)
C
C
      EQUIVALENCE(HBUF(1),IBUF(1))
      EQUIVALENCE(HKDAT(1),IKDAT(1))
      EQUIVALENCE(HKDAT(1),HBUF(21))
      EQUIVALENCE(IBUF(2),JBUF(1))
C
      EQUIVALENCE(IBUF(1),LREC)
      EQUIVALENCE(IBUF(2),NAMEBN)
      EQUIVALENCE(IBUF(3),NUMREC)
      EQUIVALENCE(IBUF(4),NTOREC)
      EQUIVALENCE(IBUF(5),KTMEAS)
      EQUIVALENCE(IBUF(6),KTWRIT)
      EQUIVALENCE(IBUF(7),NEXTTM)
      EQUIVALENCE(IBUF(8),IFADDR)
      EQUIVALENCE(IBUF(9),ISPAR1)
      EQUIVALENCE(IBUF(10),ISPAR2)
C
#include "ciouni.for"
C
C                                       RUN DEPENDENT CONSTANTS
C
      DIMENSION IRUNAR(24),TZ0AR (24,3),VDRAR (24,3),
     ,                     ALORAR(24)  ,AMAGAR(24)
      DATA NRUNAR /24/
      DATA IRUNAR /      1497, 1967, 2521, 3730, 6185, 7592, 8712,
     ,            10000,10267,11038,11473,12555,13000,14600,15699,
     ,            16800,20275,24200,99999,    0,    0,    0,    0,    0/
      DATA TZ0AR  /-3.9,  2.4,   .2, -2.5, -6.1, 2.00, 2.20, 2.20,
     ,             3.60, 1.60, 2.20, 2.20, 1.80, 1.20, 1.25, 1.25,
     ,             1.20, 1.20, 3.00,   0.,   0.,   0.,   0.,   0.,
     ,             -3.9,  2.4,   .2, -2.5, -6.1, 3.10, 3.30, 3.30,
     ,             3.60, 1.60, 2.20, 2.20, 1.80, 2.30, 2.35, 2.35,
     ,             2.30, 2.30, 3.90,   0.,   0.,   0.,   0.,   0.,
     ,             -3.0,  2.4,   .2, -2.5, -6.1, 1.60, 1.80, 1.80,
     ,             3.60, 1.60, 3.00, 3.00, 2.50, 2.00, 2.05, 2.05,
     ,             2.00, 2.00, 4.20,   0.,   0.,   0.,   0.,   0./
      DATA VDRAR  /                     5*.3769,.3742,.3768,.3770,
     ,            .3778,.3778,.3758,.3758,.3893,.3767,.3780,.3780,
     ,            .3781,.3781,.3787,   0.,   0.,   0.,   0.,   0.,
     ,                                  5*.3753,.3746,.3783,.3785,
     ,            .3789,.3789,.3768,.3767,.3902,.3775,.3788,.3788,
     ,            .3792,.3792,.3808,   0.,   0.,   0.,   0.,   0.,
     ,                                  5*.3826,.3780,.3817,.3819,
     ,            .3821,.3821,.3805,.3810,.3946,.3814,.3827,.3827,
     ,            .3833,.3833,.3786,   0.,   0.,   0.,   0.,   0./
      DATA ALORAR /          3*18.5, 19.5,21.00,18.41,18.40,18.27,
     ,            18.6 ,18.6 ,19.50,19.40,18.93,18.90,18.90,18.90,
     ,            19.05,19.05,19.54,   0.,   0.,   0.,   0.,   0./
      DATA AMAGAR /                4*-4.50,
     ,                            12*-4.82,8*-4.82/
      DATA VDR01,VDR02,VDR03 /3*99999./,
     ,     DRID0 /99999./, IDRUN0 /99999/
C
C
C                                           EXTERNAL NEEDED TO LOAD
C                                           DL300 SERVICE FUNCTIONS
      EXTERNAL CL2PRC
C
      DATA NHEAD / 9/
      DATA INTERV/0/
      DATA LASTIM/0/, LCONTM /2147483647/
      DATA ICALL/0/ ,ICALO/0/
C
C
C------------------  C O D E  ------------------------------------------
C
 2900 FORMAT(' FIRST CALL TO KLREAD, EVENT DATE: ',6I5,
     *             ' TZERO:',3F6.2)
 2901 FORMAT('0KLREAD WARNING : NO "SPINNING" BLOCK DATA, RECALIBR. OF L
     ,EADGLASS NOT POSSIBLE')
 2902 FORMAT(' KLREAD ERROR: EVENT TIME =',I12,'FOR EVENT',2I6)
 2903 FORMAT(' KLREAD ERROR CODE',I4,' FORCE NORMAL END OF PROGRAM.')
C
C
C2001 FORMAT(' HCALIB: I0, I9 =',2I8,(/,10(/,1X,10F8.3)))
C2002 FORMAT(' READ0 LUNIT =',I3)
C2003 FORMAT(' READ1 LUNIT =',I3)
 2004 FORMAT(' IB,IP,LB,IFADDR =',10I8)
 2005 FORMAT(' LH,LR,LH,IP(B+1)=',10I8)
C2006 FORMAT('0KALIBR:',10F10.5)
C2007 FORMAT('0KALIBR',/,(1X,12F8.5))
C2008 FORMAT(' HCALIB: I0, I9 =',3I6,(/,10(/,1X,  20I6)))
C2009 FORMAT(' HCALIB: I0, I9 =',3I6,(/,10(/,1X,10F8.3)))
C2011 FORMAT('0CORR :',5X,I10,1X,A4,8I10,(10(/,1X, 10I12),/,3X))
C2012 FORMAT('0CORR :',5X,I10,1X,A4,8I10,(10(/,1X,  20I6),/,3X))
C
C
C---                                    INITIALIZE RETURN LABEL
      KALRET=0
C
      ICALO = ICALO + 1
C                                       GET RUN #
      IPHEAD=IDATA(IBLN('HEAD'))
      IHHEAD=IPHEAD*2
      NRUN=HDATA(IHHEAD+10)
C
C                                      INITIALIZ. AT 1. CALL
      IF(ICALL.NE.0) GOTO 1
C
C CHECK IF MONTE CARLO EVENTS, WITH ALL LBMC SET TO ZERO. IN THIS CASE,
C     SKIP THE FURTHER READING OF THE FILES.
C
      ILBMCS = 0
      DO 1550  ILB = 1,15
1550  ILBMCS = ILBMCS+LBMC(ILB)
C     IF(ILBMCS.EQ.0.AND.NRUN.LE.100) GO TO 1
C---
C---     FIRST CALL ONLY. SET UP POINTERS TO BANKS WITHIN THE CALIBRA-
C---     TION COMMON. UNIT=1 BYTE FOR CONVENIENCE OF THE MVCL ROUTINE.
C---     ALSO FILL LIST OF TIMES FOR WHICH THE STARTING VALUES FILES
C---     SHOULD BE READ, CHECK THAT THESE TIMES COME IN ASCENDING ORDER,
C---     AND BE SURE THAT FOR EVERY STARTING VALUES FILE THERE IS AN
C---     UPDATES FILE WITH THE SAME STARTING TIME.
C---
         ICALL=1
         CALL SETSL(ACALIB(1),0,400,0)
         ICALIB(1)=100
         DO 2 I=1,NBANKS
            ICALIB(I+1) = ICALIB(I) + MAXL(I)
    2    CONTINUE
C---
C---     CLEAR ALL BANKS EXCEPT MUCA.
C---
         ISTRT = ICALIB(2) + 1
         LZERO = (ICALIB(NBANKS+1) - ICALIB(2)) * 4
         CALL SETSL(ACALIB(ISTRT),0,LZERO,0)
C
C                                       INITIALIZE LG-CAL. FLAG
         ICALFL = 0
C                                       RETURN IF MC-DATA
C
C
         IF(NCALI.LT.1) GOTO 301
         IF(NCALI.GT.10) GOTO 301
         LAST    = 2000000001
C---
C---     "NCALI" IS THE NUMBER OF PAIRS OF STARTING VALUES AND UPDATES
C---     FILES. "KUNITA" AND "LUNITA" ARE LISTS OF FORTRAN UNIT NUMBERS
C---     FOR THE STARTING AND UPDATE FILES RESPECTIVELY.
C---
         ITP = NCALI
         DO 30 I=1,NCALI
            LUNIT=LUNITA(ITP)
C     PRINT 2002, LUNIT
            READ(LUNIT,ERR=304,END=305) NDUUM,ITM1
            REWIND LUNIT
C                                       CHECK IF ONLY ONE FILE
C                                       DATE(LAST FILE) = 1. DATE ?
            IF(I.EQ.1 .AND. ITM1.LE. 14688000) GOTO 25
            IF(ITM1.GE.LAST) GOTO 307
            LAST=ITM1
            LSTIME(ITP)=ITM1
         ITP = ITP - 1
   30    CONTINUE
         GOTO 1
C                                       ONLY ONE CALIBRATION FILE
   25 CONTINUE
         NCALI = 1
         LSTIME(1) = ITM1
         LUNITA(1) = LUNIT
C
C
C
    1 CONTINUE
      IF(ILBMCS.EQ.0.AND.NRUN.LE.100) GO TO 10
C
C                                       INITIALIZE LABEL FOR NEW JTAB
      LBJTAB = 0
C
C---
C---     NOW BEGIN CODING WHICH IS EXECUTED EVERY CALL. GET THE TIME
C---     AT WHICH THE CURRENT EVENT WAS RECORDED.
C---
      ITIME(1)=HDATA(IHHEAD+3)
      ITIME(2)=HDATA(IHHEAD+4)
      ITIME(3)=HDATA(IHHEAD+5)
      ITIME(4)=HDATA(IHHEAD+6)
      ITIME(5)=HDATA(IHHEAD+7)
      ITIME(6)=HDATA(IHHEAD+8)
C     IF(ICALO.EQ.1) PRINT 8756
C8756 FORMAT(' XV ENLARGED BY .1')
      IEVTIM=KTMCON(ITIME,NOW,LASTIM)
C
C                          CHECK IF EVENT TIME IN RANGE OF CONSTANTS
      IF(IEVTIM.LT.LSTIME(1)) GOTO 9001
C
C                          CHECK IF CURRENT CONSTANTS STILL VALID
      IF(IEVTIM.LT.NEXTTM .AND. IEVTIM.GE.LCONTM) GOTO 10
C
C
   31 CONTINUE
C---
C---  IF TIME HAS MOVED BACKWARDS SINCE THE LAST EVENT, RESET THE
C---  INTERVAL INDEX TO ZERO TO FORCE READING (OR REREADING) OF THE
C---  APPROPRIATE STARTING VALUES FILE.
C---
      IF(IEVTIM.LT.LASTIM) INTERV=0
      LASTIM=IEVTIM
C---
C---  IN WHICH TIME INTERVAL ARE WE, I.E. WHICH STARTING VALUES
C---  FILE IS APPLICABLE?
C---
      NINTER=1
      IF(NCALI.LT.2) GOTO 5
         DO 4 I=2,NCALI
            IF(LSTIME(I).GT.IEVTIM) GOTO 5
            NINTER=I
    4    CONTINUE
    5 CONTINUE
      IF(NINTER.EQ.INTERV) GOTO 6
C                                       REWIND OLD UNIT
         REWIND LUNIT
C---
C---     WE HAVE MOVED INTO A NEW INTERVAL OR MOVED BACKWARD IN TIME
C---     SINCE THE LAST EVENT, OR THIS IS THE FIRST CALL.
C---
         INTERV=NINTER
         LUNIT=LUNITA(NINTER)
C     PRINT 2003, LUNIT
         REWIND LUNIT
         READ(LUNIT,ERR=320,END=321) NDUUM
         IREAD=1
    6 CONTINUE
C---
C---     NOW READ FIRST RECORD OF THE CURRENT UPDATES FILE AND CHECK
C---     WHEN THE FIRST UPDATE IS DUE.
C---
      IF(IREAD.EQ.1) CALL EVREA1(LUNIT,NWORDS,JBUF,IRET)
      IREAD=0
      IBUF(1)=NWORDS
      IF(IRET.EQ.1) GOTO 310
      IF(IRET.EQ.2) GOTO 311
    8 CONTINUE
      IF(IEVTIM.LT.NEXTTM) GOTO 10
C---
C---     IT IS TIME FOR AN UPDATE.
C---
      IREAD=1
      DO 11 I=1,NBANKS
         IBANK=I
         IF(NAMEBN.EQ.NAME(I)) GOTO 12
   11 CONTINUE
C---
C---     CURRENT BANK NAME NOT FOUND IN OUR LIST. THIS IS AN ALLOWABLE
C---     CONDITION.
C---
      GOTO 6
   12 CONTINUE
C****** TEMPORARY CHANGE TO COPE WITH KALWRK0 ERROR
C     IF(IBANK.NE.1 .OR. JBUF(8).NE.7298) GOTO 70
C     NOUT = IBUF(1)
C     IF(LENG(IBANK).EQ.2) NOUT = NOUT * 2
C     IF(LENG(IBANK).EQ.2) PRINT 2012,  (IBUF(I1),I1= 1,10),
C    ,                                         (HBUF(I2),I2=19,NOUT)
C     IF(LENG(IBANK).EQ.4) PRINT 2011,  (IBUF(I1),I1= 1,NOUT)
   70 CONTINUE
C---
C---     MARK EXISTANCE OF LGST-BANK
      IF(IBANK.EQ.7) LBLGST = 1
      IF(IBANK.EQ.7) ICALFL = 1
C---
C---     MARK EXISTANCE OF NEW JTAB-BANK
      IF(IBANK.EQ.5) LBJTAB = 1
C
C
C                              FOR MC-DATA: UPDATE ONLY LABELD BANKS
      IF(NRUN.LE.100 .AND. LBMC(IBANK).EQ.0) GOTO 6
C
C
C                                       KEEP DATE OF CURRENT CONSTANTS
      LCONTM = NEXTTM
C---
C---     CHECK TYPE OF UPDATE, LIST OF VALUES FOR CONTIGUOUS ADDRESSES
C---     OF ADDRESS, NEW VALUE, ADDRESS, NEW VALUE ETC.
C---
      IF(IFADDR.EQ.0) GOTO 18
C---
C---     WE HAVE A LIST OF REPLACEMENT VALUES FOR CONTIGUOUS ADDRESSES.
C---
      IPNTR = ICALIB(IBANK)*4 + (IFADDR-1)*LENG(IBANK)
      LENDH = (LREC-NHEAD) * 4
      IPMAX = IPNTR + LENDH
      IF(IPMAX .GT. ICALIB(IBANK+1)*4) GOTO 315
C     PRINT 2004, IBANK,ICALIB(IBANK),LENG(IBANK),IFADDR
C     PRINT 2005, LENDH,LREC,NHEAD,ICALIB(IBANK+1)
      CALL MVCL(ACALIB,IPNTR,HKDAT,0,LENDH)
      GOTO 7
C
C---
C---     WE HAVE AN ADDRESS, NEW VALUE, ADDRESS NEW VALUE REPLACEMENT.
C---
   18 CONTINUE
C     IF(IBANK.NE.6 .OR. IFADDR.NE.0) GOTO 6
C     I0 = ICALIB(6) + 1
C     I9 = ICALIB(7)
C     PRINT 2001, I0,I9,(ICALIB(I1),I1=I0,I9)
      IF(LENG(IBANK).EQ.4) GOTO 14
        IPNTR = ICALIB(IBANK)*2
        LOOP  = (LREC-NHEAD)*2
        IPMAX = ICALIB(IBANK+1)*2 - IPNTR
C       PRINT 2004, IBANK,IPNTR,LOOP,IPMAX
        DO 15 I=1,LOOP,2
          IP = HKDAT(I)
          IF(IP.LT.0) IP = IP + 65536
          IF(IP.GT.IPMAX) GOTO 316
C         IF(I.LT.20) PRINT 2004, IP,IPNTR,HKDAT(I+1)
          HCALIB(IPNTR+IP) = HKDAT(I+1)
   15   CONTINUE
      GOTO 7
   14 CONTINUE
        IPNTR = ICALIB(IBANK)
        LOOP  = LREC - NHEAD
        IPMAX = ICALIB(IBANK+1) - IPNTR
C       PRINT 2004, IBANK,IPNTR,LOOP,IPMAX
        DO 16 I=1,LOOP,2
          IP = IKDAT(I)
          IF(IP.LT.1 .OR. IP.GT.IPMAX) GOTO 317
C         IF(I.LT.20) PRINT 2004, IP,IPNTR,IKDAT(I+1)
          ICALIB(IPNTR+IP) = IKDAT(I+1)
   16   CONTINUE
    7 CONTINUE
C     IF(IBANK.NE.6 .OR. IFADDR.NE.0) GOTO 6
C     I0 = ICALIB(6)  + 1
C     I9 = ICALIB(7)
C     PRINT 2001, I0,I9,(ICALIB(I1),I1=I0,I9)
      GOTO 6
C
C
C     ???????????????????    ERROR RETURNS   ?????????????????????
C
  301 CONTINUE
      KALRET=1
      GOTO 400
  304 CONTINUE
      KALRET=4
      GOTO 400
  305 CONTINUE
      KALRET=5
      GOTO 400
  307 CONTINUE
      KALRET=7
      GOTO 400
  310 CONTINUE
      KALRET=10
      GOTO 400
  311 CONTINUE
C     KALRET=11
C     GOTO 400
C                      *******************  EOF ON CALIBR. FILE
C                      *******************  GENERATE DUMMY RECORD
C                      *******************  WITH YEAR = 2000
         NWORDS  = 9
         JBUF(1) = NAME(2)
         JBUF(2) = 1
         JBUF(3) = 1
         JBUF(4) = 0
         JBUF(5) = NOW
         JBUF(6) = 2000000000
         JBUF(7) = 0
         JBUF(8) = 2000000000
         JBUF(9) = 0
      GOTO 8
  315 CONTINUE
      PRINT 2004, IPMAX,ICALIB(IBANK+1),LENDH,LREC,NHEAD
      PRINT 2004, IBANK,ICALIB(IBANK),LENG(IBANK),IFADDR
      PRINT 2005, LENDH,LREC,NHEAD,ICALIB(IBANK+1)
      KALRET=15
      GOTO 400
  316 CONTINUE
      KALRET=16
      GOTO 400
  317 CONTINUE
      KALRET=17
      GOTO 400
  320 CONTINUE
      KALRET=20
      GOTO 400
  321 CONTINUE
      KALRET=21
  400 CONTINUE
      PRINT 2903, KALRET
      STOP
C
C
C
   10 CONTINUE
C
C
C
      IF(NRUN.GT.100) GOTO 200
C                                       SET RUN DEPENDENT CONSTANTS
  299 CONTINUE
C
C
C     WARNING PRINTOUT IF NO LGST-BANK
      IF(LBLGST.EQ.0) PRINT 2901
      LBLGST = 2
C
C
C     DO 510 IB=1,NBANKS
C     IF(LENG(IB).EQ.4) GOTO 504
C        I0 = ICALIB(IB  ) * 2 + 1
C        I9 = ICALIB(IB+1) * 2
C        PRINT 2008, IB,I0,I9,(HCALIB(I1),I1=I0,I9)
C        GOTO 510
C 504 CONTINUE
C        I0 = ICALIB(IB  )  + 1
C        I9 = ICALIB(IB+1)
C        PRINT 2009, IB,I0,I9,(ICALIB(I1),I1=I0,I9)
C 510 CONTINUE
C
      IF(ICALO.EQ.1) PRINT 2900, (ITIME(I),I=1,6),TZERO
C
      RETURN
C
C
C                                       SET RUN DEPENDENT CONSTANTS
C
  200 CONTINUE
C
C                                       MAGNETIC FIELD
      BKGAUS = .001*HDATA(IHHEAD+30)
      IF(BKGAUS.GT.0.) BKGAUS =-BKGAUS
      MAGON = 1
      IF(ABS(BKGAUS).LT.1.) MAGON = 0
C
C                                       FIND RUN PERIOD
      DO 210 IDRUN=1,NRUNAR
         IF(NRUN.LT.IRUNAR(IDRUN)) GOTO 211
  210 CONTINUE
  211 CONTINUE
C
C                                       CHECK IF NEW CONSTANTS
      IF(IDRUN.EQ.IDRUN0 .AND. LBJTAB.EQ.0) GOTO 270
      IDRUN0 = IDRUN
C
C                                       TIME OFFSET
      TZERO(1) = TZ0AR(IDRUN,1)
      TZERO(2) = TZ0AR(IDRUN,2)
      TZERO(3) = TZ0AR(IDRUN,3)
C
C                                       DRIFT VELOCITY
      RNGTM1   = VDRAR(IDRUN,1)/64.
      RNGTM2   = VDRAR(IDRUN,2)/64.
      RNGTM3   = VDRAR(IDRUN,3)/64.
         VDR01 = RNGTM1
         VDR02 = RNGTM2
         VDR03 = RNGTM3
C
         VD1 = 0.
         VD2 = 0.
         VD3 = 0.
         IPVD = ICALIB(5) + 1248
         DO 240 K=1,24
            IPVD = IPVD + 1
            DRIVEL(K   ,1)=RNGTM1 * (1. + ACALIB(IPVD   ))
            DRIVEL(K   ,2)=RNGTM1 * (1. + ACALIB(IPVD   ))
            DRIVEL(K+24,1)=RNGTM2 * (1. + ACALIB(IPVD+24))
            DRIVEL(K+24,2)=RNGTM2 * (1. + ACALIB(IPVD+24))
            DRIVEL(K+48,1)=RNGTM3 * (1. + ACALIB(IPVD+48))
            DRIVEL(K+48,2)=RNGTM3 * (1. + ACALIB(IPVD+48))
            DRIVEL(K+72,1)=RNGTM3 * (1. + ACALIB(IPVD+72))
            DRIVEL(K+72,2)=RNGTM3 * (1. + ACALIB(IPVD+72))
            VD1 = VD1 + DRIVEL(K   ,1)
            VD2 = VD2 + DRIVEL(K+24,1)
            VD3 = VD3 + DRIVEL(K+48,1) + DRIVEL(K+72,1)
  240    CONTINUE
         VD1 = VD1 / 24.
         VD2 = VD2 / 24.
         VD3 = VD3 / 48.
         TIMDEL(1,1) = VD1
         TIMDEL(2,1) = VD1
         TIMDEL(1,2) = VD2
         TIMDEL(2,2) = VD2
         TIMDEL(1,3) = VD3
         TIMDEL(2,3) = VD3
         VD1 = VD1 * 64.
         VD2 = VD2 * 64.
         VD3 = VD3 * 64.
C     PRINT 2023, VD1,VD2,VD3,VD4,VD5,(VDRAR(IDRUN,I1),I1=1,3)
C2023 FORMAT('0DRIFT VELOCITIES OF RINGS:',3F8.5,3X,2F8.5,6X,3F8.5)
C2024 FORMAT('0LORENTZ ANGLES   OF RINGS:',3F8.5,3X,2F8.5,6X,3F8.5)
C
C
C                                       CHECK IF CHANGE OF LORENTZ ANGLE
  270 CONTINUE
C
C       CORRECT ONLINE T0 CHANGES AT BEGINNING OF '86     J.S. 4/11/86
      IF(NRUN.LT.24200.OR.NRUN.GT.24698) GOTO 7831
        AM7=T0EFFC( NRUN )
        TZERO(1) = TZ0AR(IDRUN,1)-AM7
        TZERO(2) = TZ0AR(IDRUN,2)-AM7
        TZERO(3) = TZ0AR(IDRUN,3)-AM7
7831  CONTINUE
C
C
        TWANG  = ALORAR(IDRUN) * PI/180.
        AKGAUS = AMAGAR(IDRUN)
        DRIDEV = 0.
        IF(MAGON.NE.0) DRIDEV =-TWANG
        DALF = 0.
        IF(ABS((BKGAUS-AKGAUS)/AKGAUS).GE..01)
     ,     DALF = ASIN(SIN(DRIDEV)*BKGAUS/AKGAUS) - DRIDEV
        DRIDEV = DRIDEV + DALF
        IF(DALF.EQ.0. .AND. DRIDEV.EQ.DRID0 .AND. LBJTAB.EQ.0)
     ,     GOTO 295
C          PRINT 2006, BKGAUS,AKGAUS,DRIDEV,TWANG,DRID0,DALF
           DRID0 = DRIDEV
C
           DRISIN = SIN(DRIDEV)
           DRICOS = COS(DRIDEV)
C          PRINT 2006, DRIDEV,DRISIN,DRICOS,TWANG,DALF
C
C          I0 = ICALIB(5)  + 1
C          I9 = 96*14 + I0 - 1
C          PRINT 2010, (ACALIB(I1),I1=I0,I9)
C2010 FORMAT('1JTAB :',(8(/,1X,12F8.5),/))
           IPCAL  = ICALIB(5)
           IPCAL  = IPCAL + 960
           SIGMAG = MAGON
C          RLOR1  = 0.
C          RLOR2  = 0.
C          RLOR3  = 0.
C          RLOR4  = 0.
           DO 280 J=1,96
C             ANGLR1 = (DRIDEV - ACALIB(IPCAL+J)) * SIGMAG
              ANGLR1 = DRIDEV * SIGMAG
C             RLOR3 = RLOR3 + ANGLR1
C             IF(J.LE.24) RLOR1 = RLOR1 + ANGLR1
C             IF(J.LE.48) RLOR2 = RLOR2 + ANGLR1
C             IF(J.GT.48 .AND. AND(J,1).NE.0) RLOR4 = RLOR4 + ANGLR1
              SINLOR=SIN(ANGLR1)
              COSLOR=COS(ANGLR1)
              DRIROT(J,1)=ANGLR1
              SINDRI(J,1)=SINLOR
              COSDRI(J,1)=COSLOR
              DRIROT(J,2)=ANGLR1
              SINDRI(J,2)=SINLOR
              COSDRI(J,2)=COSLOR
  280      CONTINUE
C          RLOR3 = RLOR3 - RLOR2
C          RLOR2 = RLOR2 - RLOR1
C          RLOR5 = RLOR3 - RLOR4
C          RLOR1 = RLOR1 / 24.
C          RLOR2 = RLOR2 / 24.
C          RLOR3 = RLOR3 / 48.
C          RLOR4 = RLOR4 / 24.
C          RLOR5 = RLOR5 / 24.
C          PRINT 2024, RLOR1,RLOR2,RLOR3,RLOR4,RLOR5,DRIDEV
C
C RUN DEPENDENT ABERRATION CONSTANTS FOR INNER DETECTOR HIT CALCULATION
C
C
         ABERR(1) = 0.000217
         IF(NRUN.GE.24200) ABERR(1) = 0.
C
C  SET SOME CONSTANTS WHICH ARE NEVER CHANGED
C
      IF(LBCONS.NE.0) GOTO 295
         LBCONS = 1
         ZAL=2792.9
         FIRSTW(1)=206.50
         FIRSTW(2)=416.50
         FIRSTW(3)=627.83
         FSENSW(1)=211.50
         FSENSW(2)=421.50
         FSENSW(3)=632.83
C
         ABERR(2) = 4.0
         ABERR(3) = 6.8
         ABERR(5) = .048
         ABERR(6) = .000167
         ABERR(7) = 15.0
         ABERR(8) = 1.0
         IF(MAGON.EQ.0) ABERR(2) = 5.
         IF(MAGON.EQ.0) ABERR(3) = 5.
C
C        PRINT 2007,TIMDEL,DRIDEV,DRISIN,DRICOS
C        PRINT 2007,DRIVEL
C        PRINT 2007,DRIROT
C        PRINT 2007,SINDRI,COSDRI
C
C
  295 CONTINUE
C                            SET VERTEX CHAMBER CALIBRATION CONSTANTS
      ALRV = -0.345833
      SNLV = SIN(ALRV)
      CSLV = COS(ALRV)
C
      DO 700 I = 1, 24
        DRILOR(I) = ALRV
        SNLORA(I) = SNLV
        CSLORA(I) = CSLV
        DRVELO(I) = 0.0050
  700 CONTINUE
C
C     RESET LBJTAB
      LBJTAB = 0
      GOTO 299
C
C
C                    STOP ANALYSIS IF EVENT TIME TOO LOW
 9001 CONTINUE
      PRINT 2902, IEVTIM,NRUN,HDATA(IHHEAD+11)
      STOP 77
      END
      BLOCK DATA
C
C
      COMMON /CMCCAL/ LBMC(15)
      DATA LBMC /0,0,0,0,0,  0,0,0,0,0,  0,0,0,0,0/
C
      END

C   14/03/84            MEMBER NAME  DATE     (S)           FORTRAN
C   30/03/79 306031652  MEMBER NAME  DATE     (S)           FORTRAN
      INTEGER FUNCTION DATE(DUMMY)
C---  PROVIDE DATE AS I*2-WORD ACCORDING TO DDMMY, SO THE MAXIMUM
C     VALUE COULD BE 31129 (31.12.1979)
C
C     H.WRIEDT    13.03.79      18:10
C     LAST MODIFICATION     27.05.83       15:45
C
      IMPLICIT INTEGER*2 (H)
C
      INTEGER IINDEX, BINREP(8), RETC
      LOGICAL*1 CHREP(119)
C
      DIMENSION HDATE(3)
C
      DATA NERR/0/
C
C---  GET PRESENT DATE
      IINDEX = 0
      CALL CALDAT (IINDEX, CHREP, BINREP, RETC)
      IF (RETC.GT.0) GOTO 100
C---  DAY
      HDATE(1) = BINREP(1)
C---  MONTH
      HDATE(2) = BINREP(2)
C---  YEAR
      HDATE(3) = BINREP(3)
C---  PREPARE OUTPUT DATE
      HY1 = HDATE(3)/10
      HY2 = HY1*10
      DATE = HDATE(1)*1000 + HDATE(2)*10 + HDATE(3)-HY2
      RETURN
C---  ERROR MESSAGE FROM CALDAT
  100 DATE = 0
      IF (NERR.GT.5) RETURN
      NERR = NERR + 1
      WRITE(6,600) RETC
  600 FORMAT(' **** ERROR MESSAGE FROM F22HOW.JADEGAMS(DATE):',
     &       ' CALL CALDAT LEADS TO ERROR-CODE',I6/
     &       '      LOOK ITS MEANING UP WITH H CALDAT, PLEASE')
      RETURN
      END

      SUBROUTINE ZVTRCK(ZVTX,IND,IPPATR)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CWORK/ ZTR(120), HIST(100)
      EQUIVALENCE (Z1,ZTR(1)) , (Z2,ZTR(2)) , (Z3,ZTR(3))
      DZBIN  =  60.
      DZBIN2 = 120.
      Z0BIN  =-3000.
      IP = IPPATR
      IND = -3
      IF(IP.LE.0) RETURN
      IND = -2
      IF(IDATA(IP+2).LE.0) RETURN
      IND = -1
      NTR = IDATA(IP+2)
      LDTR = IDATA(IP+3)
      JP0 = IP+IDATA(IP+1)
      JP9 = JP0 + LDTR*NTR - 1
      MTR = 0
      DO 13000 JP1 = JP0,JP9,LDTR
          I0 = JP1+ 1
          I9 = I0 + LDTR
      IF(
     - ADATA(JP1+32).LT.60. .AND. IDATA(JP1+33).GT.12 .AND.
     ?     ABS(ADATA(JP1+25)).LT..00150
     -)THEN
          RSQ = ADATA(JP1+5)**2 + ADATA(JP1+6)**2
      IF(
     - RSQ.LT.250000.
     -)THEN
            MTR = MTR + 1
            ZTR(MTR) = ADATA(JP1+31)
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      IF(MTR.LE.0) RETURN
      IND = 0
      IF(
     - MTR.EQ.1
     -)THEN
        ZVTX = Z1
        RETURN
      ENDIF
      IF(
     - MTR.EQ.2
     -)THEN
      IF(
     - ABS(Z2-Z1).GT.DZBIN2
     -)THEN
          ZVTX = Z1
          IF(ABS(Z1).GT.ABS(Z2)) ZVTX = Z2
          RETURN
      ENDIF
        ZVTX = (Z1+Z2)*.5
        IND = 1
        RETURN
      ENDIF
      IF(
     - MTR.EQ.3
     -)THEN
      IF(
     - Z1.GT.Z2
     -)THEN
          ZW = Z2
          Z2 = Z1
          Z1 = ZW
      ENDIF
      IF(
     - Z2.GT.Z3
     -)THEN
      IF(
     - Z1.GT.Z3
     -)THEN
            ZW = Z3
            Z3 = Z2
            Z2 = Z1
            Z1 = ZW
      ELSE
            ZW = Z3
            Z3 = Z2
            Z2 = ZW
      ENDIF
      ENDIF
      IF(
     - ABS(Z2-Z1).GT.DZBIN2 .AND. ABS(Z3-Z2).GT.DZBIN2
     -)THEN
          ZVTX = Z1
          IF(ABS(Z2).LT.ABS(ZVTX)) ZVTX = Z2
          IF(ABS(Z3).LT.ABS(ZVTX)) ZVTX = Z3
          RETURN
      ENDIF
      IF(
     - ABS(Z3-Z1).LT.DZBIN2
     -)THEN
          ZVTX = (Z1+Z2+Z3) / 3.
          IND = 1
          RETURN
      ENDIF
      IF(
     - ABS(Z2-Z1).LT.DZBIN2 .AND. ABS(Z3-Z2).LT.DZBIN2
     -)THEN
          Z1 = (Z1+Z2) * .5
          Z2 = (Z2+Z3) * .5
          ZVTX = Z1
          IF(ABS(Z2).LT.ABS(ZVTX)) ZVTX = Z2
          IND = 1
          RETURN
      ENDIF
      IF(
     - ABS(Z2-Z1).GT.DZBIN2
     -)THEN
          Z1 = Z2
          Z2 = Z3
      ENDIF
        ZVTX = (Z1+Z2) * .5
        IND = 1
        RETURN
      ENDIF
      CALL SETS(HIST(1),0,200,0)
      DO 13002 I=1,MTR
        IZ = (ZTR(I)-Z0BIN) / DZBIN
      IF(
     - IZ.GT.0 .AND. IZ.LT.99
     -)THEN
          HIST(IZ  ) = HIST(IZ  ) + 1
          HIST(IZ+1) = HIST(IZ+1) + 2
          HIST(IZ+2) = HIST(IZ+2) + 1
      ENDIF
13002 CONTINUE
13003 CONTINUE
      MPEAK0 = 0
      ZVTX = -100000.
      LBPEAK = 0
      DO 13004 IZ=1,99
        MPEAK1 = HIST(IZ) + HIST(IZ+1)
      IF(
     - MPEAK1.GT.3
     -)THEN
      IF(
     - MPEAK1.GT.MPEAK0
     -)THEN
            MZ = IZ
            MPEAK = MPEAK1
            LBPEAK = 1
      ELSE
      IF(
     - MPEAK1.EQ.MPEAK0
     -)THEN
              LBPEAK = 2
      ELSE
      IF(
     - LBPEAK.NE.3
     -)THEN
                ZV0  = MZ*DZBIN + Z0BIN
                DZV0 = DZBIN
                IF(LBPEAK.EQ.2) ZV0  = DZBIN*.5 + ZV0
                IF(LBPEAK.EQ.2) DZV0 = DZBIN*1.5
      IF(
     - ABS(ZV0).LT.ABS(ZVTX)
     -)THEN
                  ZVTX = ZV0
                  DZVT = DZV0
      ENDIF
      ENDIF
              LBPEAK = 3
      ENDIF
      ENDIF
      ELSE
      IF(
     - LBPEAK.GT.0 .AND. LBPEAK.NE.3
     -)THEN
            ZV0  = MZ*DZBIN + Z0BIN
            DZV0 = DZBIN
            IF(LBPEAK.EQ.2) ZV0  = DZBIN*.5 + ZV0
            IF(LBPEAK.EQ.2) DZV0 = DZBIN*1.5
      IF(
     - ABS(ZV0).LT.ABS(ZVTX)
     -)THEN
              ZVTX = ZV0
              DZVT = DZV0
      ENDIF
      ENDIF
          LBPEAK = 0
      ENDIF
        MPEAK0 = MPEAK1
13004 CONTINUE
13005 CONTINUE
      ZVSUM = 0.
      NZVS  = 0
      DO 13006 I=1,MTR
      IF(
     - ABS(ZTR(I)-ZVTX).LE.DZVT
     -)THEN
          ZVSUM = ZVSUM + ZTR(I)
          NZVS  = NZVS + 1
      ENDIF
13006 CONTINUE
13007 CONTINUE
      IF(
     - NZVS.GT.1
     -)THEN
        ZVTX = ZVSUM / NZVS
        IND = 1
      ELSE
        ZVTX = -100000.
      DO 13008 I=1,MTR
          IF(ABS(ZTR(I)).LT.ABS(ZVTX)) ZVTX = ZTR(I)
13008 CONTINUE
13009 CONTINUE
      ENDIF
      RETURN
      END

C   29/01/80 004241343  MEMBER NAME  PCWORK   (PATRECSR)    FORTRAN
      SUBROUTINE PCWORK(IF1,IF2,IF3,IF4,IF5)
      IMPLICIT INTEGER*2(H)
C
C
C----------------------------------------------------------------------
C         --------------  SUBROUTINE PCWORK  -----------------
C         --- G.F.PEARCE .. LAST UPDATE : 1400 ON 10/09/79 ---
C
C   SUBROUTINE TO DUMP ALL OR PARTS OF THE PATTERN RECOGNITION /CWORK/
C   THE LEVEL OF OUTPUT IS CONTROLLED BY THE FLAGS 'IF' VIZ.
C
C   IF1 = 1/0 => PRINT/NOPRINT OF TRACK ELEMENT HIT LABEL ARRAY
C   IF2 = 1/0 => PRINT/NOPRINT OF TRACK ELEMENTS
C   IF3 = 1/0 => PRINT/NOPRINT OF BACKTR RESULTS (CONNECTED TR.ELEMENTS)
C   IF4 = 1/0 => PRINT/NOPRINT OF TRACK COORDINATES (FXYZ/PATROL)
C   IF5 = 1/0 => PRINT/NOPRINT OF CWORK TRACK BANK (XYFIT/ZRFIT/CNTREL)
C----------------------------------------------------------------------
C
C
C=======================================================================
C
C  CONTENTS OF /CWORK/  ####### COMPILED BY G.F.PEARCE #######
C  ====================
C                        IN JET CHAMBER PATTERN RECOGNITION PROGRAMS
C
C       ----------------------
C   1). POINTERS AND WORKSPACE
C       ----------------------
C  HPLAST     = POINTER TO LAST AVAILABLE LOCATION IN ARRAY WRK
C  HPFREE     = POINTER TO FIRST CURRENTLY AVAILABLE LOCATION IN WRK
C  HPWRK      = RESERVED FOR POINTERS (SEE HPHT0 ETC.. BELOW)
C  HPHT0      = POINTER TO FIRST WORD OF HIT COORDINATE ARRAY
C  HPHT9      = POINTER TO LAST  WORD OF HIT COORDINATE ARRAY
C  HLDHT      = NUMBER OF 4 BYTE WORDS STORED PER HIT IN COORD. ARRAY
C  HPHT0A     = POINTER TO FIRST WORD OF SECOND ARRAY OF HIT COORDINATES
C               THIS ARRAY IS USED IN CASES WHERE THE BACKTRACE ROUTINE
C               COULD NOT UNAMBIGUOUSLY RESOLVE THE L/R AMBIGUITY. IN
C               SUCH A CASE THE HIT COORDINATES ARE COMPUTED FOR BOTH
C               L/R SOLUTIONS AND THE SECOND SOLUTION STORED HERE.
C               WHEN THE L/R AMBIGUITY IS RESOLVED THIS POINTER IS -VE.
C               AND THE SECOND SET OF COORDINATES DO NOT EXIST.
C  HPHT9A     = POINTER TO LAST WORD OF SECOND HIT COORDINATE ARRAY
C  HLDHTA     = NUMBER OF 4 BYTE WORDS STORED PER HIT ISECOND ARRAY
C  HPHTLM     = LIMIT ON HPHT0 FOR ADDING NEW HITS
C  HPTR0      = POINTER TO FIRST WORD OF TRACK BANK
C  HPTR9      = POINTER TO LAST  WORD OF TRACK BANK
C  HLDTR      = NUMBER OF 4 BYTE WORDS STORED PER FIT IN TRACK BANK
C  HPHL0      = POINTER TO FIRST WORD OF HIT LABEL ARRAY
C  HPHL9      = POINTER TO LAST WORD OF HIT LABEL ARRAY
C  HLDHL      = NUMBER OF WORDS STORED FOR EACH HIT IN HIT LABEL
C
C  ADWRK    ..   WORK ARRAY 600 WORDS LONG.
C
C       -----------------------------------
C   2). OUTPUT FROM TRACK ELEMENT ROUTINES.
C       -----------------------------------
C
C  HPRO       = ?
C
C  HNTR       = TOTAL NUMBER OF TRACK ELEMENTS IN ALL RINGS
C
C  HNTCEL(I)  = ELEMENT NUMBER OF FIRST TRACK ELEMENT IN CELL I
C                (IF (I).EQ.(I+1) THERE IS NO ELEMENT IN CELL I)
C
C  ITRKAR(I,J) = INFORMATION FOR I'TH TRACK ELEMENT. J AS FOLLOWS
C   J   NAME               CONTENTS
C  --- ------             ----------
C   1  IPCL  = CELL NUMBER CONTAINING TRACK ELEMENT I
C   2  NRHT  = NUMBER OF HITS ON TRACK ELEMENT
C   3  NWR1  = WIRE NUMBER OF FIRST HIT ON TRACK ELEMENT (0->15)
C   4  DS1   = DRIFT DISTANCE OF FIRST HIT ON TRACK ELEMENT (MM)
C   5  SL1   = DRIFT SLOPE FOR 1ST HIT ON TRACK ELEMENT(MM/WIRE SPACING)
C              ( (DS(2)-DS(0))/2 WHERE DS(0)=DRIFT DISTANCE FOR WIRE 0)
C   6  NWR2  = WIRE NUMBER OF LAST HIT ON TRACK ELEMENT (0->15)
C   7  DS2   = DRIFT DISTANCE OF LAST HIT ON TRACK ELEMENT (MM)
C   8  SL2   = DRIFT SLOPE FOR LAST HIT ON TRACK ELEMENT ( SEE SL1 )
C   9  LBL   = TRACK ELEMENT BIT CODED HISTORY WORD
C              BIT 13 ON  =>  L/R AMBIGUITY UNSOLVED
C  10  NTREL = TRACK ELEMENT NUMBER WRITTEN INTO THE HIT LABEL OF
C              EACH HIT ON THIS TRACK ELEMENT.
C  11  ICRO  =  WIRE NUMBER OF FIRST WIRE STRUCK AFTER TRACK ELEMENT
C               CROSSED WIRE BOUNDARY. IF ZERO NO CROSSING HAS OCCURED.
C
C
C       -------------------------------
C   3). OUTPUT FROM BACKTRACING ROUTINE
C       -------------------------------
C
C   NTR        = TOTAL NUMBER OF TRACKS FOUND BY BACKTRACE PROGRAM.
C   HNREL(I)   = NUMBER OF TRACK ELEMENTS ASSOCIATED WITH TRACK I
C   HISTR(I,J) = TRACK ELEMENT NUMBER FOR EACH TRACK ELEMENT (J)
C                 ASSIGNED TO TRACK NUMBER I.
C   HRES(I)    = RESERVED FOR GRAPHICS
C
C
C       ----------------------------------
C   4). OUTPUT FROM HIT COORDINATE ROUTINE (FXYZ+PATROL)
C       ----------------------------------
C
C     RELEVANT POINTERS ARE HPHT0,HPHT9,HLDHT (SEE 'POINTERS' ABOVE)
C
C     LOCATION     ALIAS               CONTENTS
C     --------     -----               --------
C     WRK      ..   HIT AND FIT INFORMATION .. SEE BELOW
C
C     FOR EACH HIT THE FOLLOWING INFORMATION IS STORED IN WRK/IWRK
C     ( HIT 1 BEING USED AS AN EXAMPLE )
C
C     IWRK(HPHT0+ 0) = LAYER NUMBER (0-15)
C     IWRK(HPHT0+ 1) = POINTER TO FIRST DATA WORD (IN BCS)
C     IWRK(HPHT0+ 2) = POINTER TO TRACK ELEMENT HIT LABEL WORD IN CWORK
C     WRK (HPHT0+ 3) = X COORDINATE (MMS)
C     WRK (HPHT0+ 4) = Y COORDINATE (MMS)
C     WRK (HPHT0+ 5) = Z COORDINATE (MMS)
C     WRK (HPHT0+ 6) = R COORDINATE (MMS)
C     WRK (HPHT0+ 7) = Z-COORDINATE ERROR FLAG. 0 => GOOD HIT IN R-Z FIT
C                                               2 => BAD  HIT IN R-Z FIT
C                                              10 => BAD L/R AMPLITUDES
C     IWRK(HPHT0+ 8) = TRACK ELEMENT NUMBER ON WHICH HIT WAS FOUND
C                      CARRIES SIGN OF L/R AMBIGUITY(-VE=LEFT,+VE=RIGHT)
C                      IF THIS IS +/- 1000, THEN HIT WAS FOUND BY PATROL
C     IWRK(HPHT0+ 9) = CELL NUMBER
C     IWRK(HPHT0+10) = X-Y FIT ERROR FLAG. 0 => GOOD HIT USED IN XYFIT
C                                          1 => BAD  HIT USED IN XYFIT
C                                        > 1 => BAD  HIT NOT USED IN FIT
C     WRK (HPHT0+11) = 1/COSINE OF ANGLE OF TRACK TO THE NORMAL TO THE
C                      DRIFT SPACE USED FOR ABERATION CORRECTION.
C     IWRK(HPHT0+12) = RING NUMBER
C     WRK (HPHT0+13) = RESIDUAL (FITTED-MEASURED) OF HIT FROM X-Y FIT.
C
C
C
C       ---------------------------
C   4). OUTPUT FROM FITTING PROGRAM (XYFIT)..  I.E. TRACK BANK
C       ---------------------------
C
C     RELEVANT POINTERS ARE HPTR0,HPTR9,HLDTR .. SEE 'POINTERS' ABOVE.
C
C     IWRK(HPTR0+ 0) = TRACK NUMBER
C     IWRK(HPTR0+ 1) = IDENTIFIER OF PROGRAM
C     IWRK(HPTR0+ 2) = DATE OF PRODUCTION
C     IWRK(HPTR0+ 3) = TYPE OF POINT (FOR FIRST MEASURED POINT)
C     IWRK(HPTR0+ 4) = X COORDINATE  (FOR FIRST MEASURED POINT)
C     IWRK(HPTR0+ 5) = Y COORDINATE  (FOR FIRST MEASURED POINT)
C     WRK (HPTR0+ 6) = Z COORDINATE  (FOR FIRST MEASURED POINT)
C     WRK (HPTR0+ 7) = DX            (FOR FIRST MEASURED POINT)
C     WRK (HPTR0+ 8) = DY            (FOR FIRST MEASURED POINT)
C     WRK (HPTR0+ 9) = DZ            (FOR FIRST MEASURED POINT)
C     WRK (HPTR0+10) = TYPE OF POINT (FOR LAST  MEASURED POINT)
C     WRK (HPTR0+11) = X COORDINATE  (FOR LAST  MEASURED POINT)
C     WRK (HPTR0+12) = Y COORDINATE  (FOR LAST  MEASURED POINT)
C     WRK (HPTR0+13) = Z COORDINATE  (FOR LAST  MEASURED POINT)
C     WRK (HPTR0+14) = DX            (FOR LAST  MEASURED POINT)
C     WRK (HPTR0+15) = DY            (FOR LAST  MEASURED POINT)
C     WRK (HPTR0+16) = DZ            (FOR LAST  MEASURED POINT)
C     IWRK(HPTR0+17) = TYPE OF FITTING PROGRAM USED IN X-Y PLANE
C                    = 1 FOR CIRCLE FIT
C                    = 2 FOR PARABOLA FIT
C     IWRK(HPTR0+18) = FIRST FIT PARAMETER  FROM XYFIT
C     IWRK(HPTR0+19) = SECOND FIT PARAMETER FROM XYFIT
C     IWRK(HPTR0+20) = THIRD FIT PARAMETER  FROM XYFIT
C     IWRK(HPTR0+21) = FOURTH FIT PARAMETER FROM XYFIT
C     IWRK(HPTR0+22) = RMS PER D.F. FROM XYFIT
C     WRK (HPTR0+23) = NUMBER OF POINTS USED IN XYFIT
C     WRK (HPTR0+24) = TRACK CURVATURE
C     WRK (HPTR0+25) = DELTA CURVATURE
C     WRK (HPTR0+26) = TRACK CURVATURE AT FIRST MEASURED POINT
C     WRK (HPTR0+27) = TRACK CURVATURE AT LAST  MEASURED POINT
C     IWRK(HPTR0+28) = TYPE OF FITTING PROGRAM USED IN Z-R PLANE
C     WRK (HPTR0+29) = FIRST FIT PARAMETER FROM ZRFIT  (SLOPE)
C     WRK (HPTR0+30) = SECOND FIT PARAMETER FROM ZRFIT(INTERCEPT)
C     WRK (HPTR0+31) = RMS PER D.F. FROM ZRFIT
C     IWRK(HPTR0+32) = NUMBER OF POINTS USED IN ZRFIT
C     IWRK(HPTR0+33) = CELL NUMBERS THAT CONTAIN HITS ON THE TRACK
C     IWRK(HPTR0+34) =   "     "      "     "      "   "  "    "
C     IWRK(HPTR0+35) =   "     "      "     "      "   "  "    "
C     IWRK(HPTR0+36) =   "     "      "     "      "   "  "    "
C     IWRK(HPTR0+37) =   "     "      "     "      "   "  "    "
C     IWRK(HPTR0+38) =   "     "      "     "      "   "  "    "
C     IWRK(HPTR0+39) = POINTER TO CORRESPONDING LEAD GLASS CLUSTER
C     IWRK(HPTR0+40) = POINTER TO CORRESPONDING MUON CHAMBER HITS
C     IWRK(HPTR0+41) = POINTER TO CORRESPONDING TRACK BANK IN TP BANK
C     IWRK(HPTR0+42) = POINTER TO CORRESPONDING TOF BANK
C     IWRK(HPTR0+43) = FREE
C     IWRK(HPTR0+44) = FREE
C     IWRK(HPTR0+45) = FREE
C     IWRK(HPTR0+46) = FREE
C     IWRK(HPTR0+47) = BIT CODED ERROR CODE (ALL BITS OFF => ALL OK)
C                      BIT 31 => BAD FIT IN X-Y PLANE
C                      BIT 30 => L/R AMBIGUITY OF TRACK UNCERTAIN
C                      BIT 29 => XYFIT TRIED REJECTING THE TRACK ELEMENT
C                               WITH THE WORST CHI**2 TO RECOVER FROM A
C                               BAD INITIAL FIT.
C                      BIT 28 => XYFIT TRIED RESTARTING BY FITTING ONLY
C                               THE LONGEST TRACK ELEMENT IN ORDER TO
C                               RECOVER FROM A BAD INITIAL FIT AFTER
C                               THE BIT 29 PROCEDURE ABOVE FAILED.
C                      BIT 27 => PATROL ADDED > IXYF( ) (SEE CPATLM) NEW
C                                HITS TO THE TRACK WHICH ALSO BELONG TO
C                                ANOTHER TRACK IN THIS EVENT
C                      BIT 26 => PATROL CALLED FOR A RE-FIT TO THE TRACK
C                                AFTER FINDING SOME NEW HITS AND THIS
C                                FAILED (BAD CHI**2). THE FIT IN THE
C                                TRACK BANK WILL CORRESPOND TO THE LAST
C                                GOOD FIT OF THIS TRACK.
C                      BIT 25 => VERY LOW MOMENTUM TRACK
C                      BIT 24 => BAD FIT IN Z-R PLANE
C                      BIT 23 => > N POINTS REJECTED BY ZRFIT.
C                      BIT 22 => TRACK NOT CONNECTED INTO RING 1 BY
C                                BACKTRACE PROGRAM (ALTHOUGH IF SUCH
C                                HITS EXIST THEY WILL HAVE BEEN FOUND
C                                AT A LATER STAGE BY THE PATROL PROGRAM
C                                AND INCLUDED ON THE TRACK).
C                      BIT 21 => TRACK NOT CONNECTED INTO RING 2 BY
C                                BACKTRACE PROGRAM ALTHOUGH BOTH RINGS
C                                1 AND 3 WERE PRESENT.  (AGAIN IF SUCH
C                                HITS EXIST THEY WILL HAVE BEEN FOUND
C                                AT A LATER STAGE BY THE PATROL PROGRAM
C                                AND INCLUDED ON THE TRACK).
C
C=======================================================================
#include "cworkpr.for"
#include "cworkeq.for"
#include "cdata.for"
C
C
C----------------------------------------------------------------------
C                      DUMP OF CWORK HIT LABEL ARRAY
C----------------------------------------------------------------------
C
      IF (IF1.EQ.0) GOTO20
C=====
      PRINT11,HPHL0,HPHL9,HLDHL
 11   FORMAT(
     + 1X,46('-')/
     + ' DUMP OF TREL HIT LABEL ARRAY FROM PATREC CWORK',
     + ' .. HPHL0  =',I5,' HPHL9  =',I5,' HLDHL  =',I5/
     + 1X,46('-'))
      I1 = HPHL0
      I2 = HPHL9
      PRINT12,(HWRK(I),I=I1,I2)
 12   FORMAT(   13(    ' ',Z4,',',Z4     ) )
C
C----------------------------------------------------------------------
C              DUMP OF RESULTS OF TRACK ELEMENT ROUTINE
C----------------------------------------------------------------------
C
 20   IF (IF2.EQ.0) GOTO30
C=====
      PRINT21
 21   FORMAT(
     + 1X,40('-')/
     + ' DUMP OF TRACK ELEMENTS FROM PATREC CWORK'/
     + 1X,40('-'))
C=====
      PRINT22,HPRO,HNTR,(HNTCEL(I),I=1,98)
 22   FORMAT(
     +' HPRO =',I10,5X,'HNTR = TOTAL NO OF TRACK ELEMENTS =',I6/
     +' HNTCEL =',31I4/9X,31I4/9X,31I4/9X,4I4)
C=====
      PRINT23
 23   FORMAT(
     +' TREL IPCL NRHT',
     +'  NWR1    DS1    SL1 ',
     +'  NWR2    DS2    SL2 ',
     +'   LABEL   NTREL ICRO')
      IMAX = HNTR
C=====
      PRINT24,(I,IPCL(I),NRHT(I),NWR1(I),DS1(I),SL1(I),NWR2(I),
     +DS2(I),SL2(I),LBL(I),NTREL(I),ICRO(I),I=1,IMAX)
 24   FORMAT(1X,I3,1X, I4,1X, I4,1X, I5,1X, F7.1, F7.1, I6,1X,
     + F7.1 , F7.1 , 3X,Z8, I5,1X, I3)
C=====
      PRINT29
 29   FORMAT(1X,20('-'),' END OF TRACK ELEMENT DUMP ',20('-'))
C
C----------------------------------------------------------------------
C               DUMP OF RESULTS OF BACKTRACE PROGRAM
C----------------------------------------------------------------------
C
 30   IF (IF3.EQ.0) GOTO40
C=====
      PRINT31
 31   FORMAT(
     + 1X,42('-')/
     + ' DUMP OF BACKTRACE RESULT FROM PATREC CWORK'/
     + 1X,42('-'))
C=====
      PRINT32,NTR
 32   FORMAT(' NTR = NUMBER OF TRACKS =',I4)
C=====
      DO 34 I=1,NTR
      JJ=HNREL(I)
      PRINT33,I,JJ,(HISTR(J,I),J=1,JJ)
 33   FORMAT(' TRACK',I3,I6,' TRACK ELEMENTS =',9I4)
 34   CONTINUE
      PRINT39
 39   FORMAT(1X,20('-'),' END OF BACKTRACE DUMP ',20('-'))
C
C----------------------------------------------------------------------
C              DUMP OF HIT COORDINATE ARRAY (FXYZ)
C----------------------------------------------------------------------
C
 40   IF (IF4.EQ.0) GOTO50
C=====
      NHIT = 0
      IF (HLDHT.GT.0) NHIT = (HPHT9-HPHT0+1)/HLDHT
C=====
      PRINT41,HPHT0,HPHT9,HLDHT,HPHL0,HPHL9,HLDHL
     +       ,HPHT0A,HPHT9A,HLDHTA
     +       ,HPHTLM,NHIT
 41   FORMAT(
     + 1X,30('-'), ' .. HPHT0  =',I5,' HPHT9  =',I5,' HLDHT  =',I3,
     +             ' .. HPHL0  =',I5,' HPHL9  =',I5,' HLDHL  =',I5/
     +  ' FXYZ HIT ARRAY IN PATREC CWORK',
     +  ' .. HPHT0A =',I5,' HPHT9A =',I5,' HLDHTA =',I3/
     + 1X,30('-'), ' .. HPHTLM =',I4,' TOTAL NUMBER OF HITS =',I4)
C=====
      IF (HPHT0.LE.0) GOTO45
      IF (HLDHT.LE.0) GOTO45
      IF (HPHT9.LE.HPHT0) GOTO45
      IF (HPHT9.GT.10000) GOTO45
C=====
      PRINT42
 42   FORMAT(' LOCN'
     +,   ' RING CELL LAYER  TREL'
     +,   '  DATA  DRIFT   IAMPL  IAMPR'
     +,   ' HPHL'
     +,   '   BETA'
     +,   '     X        Y        Z        R   '
     +,   '  XY-CHI'
     +,   '  XYF ZRF')
C=====
      I1 = HPHT0
      I2 = HPHT9
      I3 = HLDHT
      DO 43 I=I1,I2,I3
      JJ  = IWRK(I+1)
      IAL = HDATA(JJ+1)
      IAR = HDATA(JJ+2)
      IDS = HDATA(JJ+3)
      PRINT44,I,
     + IWRK(I+12),IWRK(I+9),IWRK(I),IWRK(I+8),
     + IWRK(I+1),IDS,IAL,IAR,
     + IWRK(I+2),WRK(I+11),WRK(I+3),WRK(I+4),
     + WRK(I+5),WRK(I+6),WRK(I+13),IWRK(I+10),
     + IWRK(I+7)
 43   CONTINUE
 44   FORMAT(I5
     +,      I4 , I5 , I5 , I7
     +,      I7,I7,I7,I7
     +,      I6
     +,      F7.3
     +,      4(1X,F8.2)
     +,      F8.3
     +,      2I4)
      GOTO48
C=====
 45   PRINT46
 46   FORMAT(' ------ POINTER ERROR ------')
C=====
 48   CONTINUE
      PRINT49
 49   FORMAT(1X,20('-'),' END OF HIT COORDINATE DUMP ',20('-'))
C
C----------------------------------------------------------------------
C                    DUMP OF TRACK BANK FROM CWORK
C----------------------------------------------------------------------
C
 50   IF (IF5.EQ.0) GOTO60
C=====
      I = HPTR0
      PRINT51,IWRK(I),IWRK(I+1),IWRK(I+2) , HPTR0,HPTR9,HLDTR
 51   FORMAT(
     + 1X,35('-')/
     +  ' DUMP OF TRACK BANK FROM PATREC CWORK',
     +  ' .. TRACK',I3,' PROGRAM =',I3,' DATE =',I9/
     + 1X,35('-'),
     + 2X,'HPTR0 =',I5,2X,'HPTR9 =',I5,2X,'HLDTR =',I4)
C=====
      PRINT52
C      START POINT TYPE,X,Y,Z,DX,DY,DZ
     +,IWRK(I+3),WRK(I+4),WRK(I+5),WRK(I+6),WRK(I+7),WRK(I+8),WRK(I+9)
C      END   POINT TYPE,X,Y,Z,DX,DY,DZ
     +,IWRK(I+10),WRK(I+11),WRK(I+12),WRK(I+13),WRK(I+14),WRK(I+15)
     +           ,WRK(I+16)
C      FIT TYPE, FIT PARAMETERS, RMS AND NO. POINTS USED FOR X-Y PLANE
     +,IWRK(I+17),WRK(I+18),WRK(I+19),WRK(I+20),WRK(I+21),WRK(I+22)
     +,IWRK(I+23)
C      TRACK CURVATURES FROM X-Y FIT
     +,WRK(I+24),WRK(I+25),WRK(I+26),WRK(I+27)
C
 52   FORMAT(
     +' FIRST POINT ON TRACK ... TYPE =',I3,
     +' (X,Y,Z) = (',3E11.4,')',' (DX,DY,DZ) = (',3E11.4,')'/
C    #
     +' LAST  POINT ON TRACK ... TYPE =',I3,
     +' (X,Y,Z) = (',3E11.4,')',' (DX,DY,DZ) = (',3E11.4,')'/
C    #
     +' XYFIT .. PROGRAM TYPE =',I3,' FITTED PARAMETERS = (',4E11.4,')',
     +' RMS =',E11.4,' POINTS USED =',I4/
C    #
     + 28X,'CURVATURE =(',E11.4,' +-',E11.4,')',
     +'   CURVATURE AT START AND END POINTS = (',E11.4,',',E11.4,')')
C=====
      PRINT53,IWRK(I+28),WRK(I+29),WRK(I+30),WRK(I+31),IWRK(I+32)
 53   FORMAT(
     +' ZRFIT .. PROGRAM TYPE =',I3,' FITTED PARAMETERS = (',2E12.4,')',
     +' RMS =',E11.4,' POINTS USED =',I4)
C=====
      PRINT54,IWRK(I+33),IWRK(I+34),IWRK(I+35),IWRK(I+36),IWRK(I+37),
     +        IWRK(I+38)
 54   FORMAT(' CELLS CONTAINING HITS ON THE TRACK ARE',6I4)
C=====
      PRINT55,IWRK(I+39),IWRK(I+40),IWRK(I+41),IWRK(I+42)
 55   FORMAT(' POINTERS TO THE CONNECTED :',
     +'  1) LEAD GLASS CLUSTER =',I5,
     +'  2) MUON HITS =',I5,
     +'  3) TP TRACK BANK =',I5,
     +'  4) TOF BANK =',I5)
C=====
      PRINT58,IWRK(I+47)
 58   FORMAT(' TRACK ERROR CODE BIT STRUCTURE =',Z4)
C=====
      PRINT59
 59   FORMAT(1X,20('-'),' END OF TRACK BANK DUMP ',20('-'))
 60   CONTINUE
      RETURN
      END

C   07/06/96 606071854  MEMBER NAME  LINSEL   (S4)          FORTG1
      SUBROUTINE LINSEL(Y,X,H,N,Q)
      REAL X(N),Y(N),H(N),Q(9)
      EXTERNAL SMTWO
C
C                 - -   -
C     CALL LINSEL(Y,X,H,N,Q)
C                         -
C
C     FILTER LINEAR DEPENDENCE OF Y ON X, RESULT IN ARRAY Q( )
C     ARRAYS X( ) AND Y( ) ARE CHANGED, BUT ONLY IN THE ORDER
C     OF POINTS, H( ) IS AN AUXILIARY ARRAY.
C     POINTS WITH LARGE DEVIATION FROM THE MAIN LINEAR DEPENDENCE
C     ARE DELETED BY CUTS, BASED ON EMPIRICAL AND STATISTICAL
C     METHODS
C
C      I      Q(I)
C      1      NR OF ENTRIES (N)
C      2      INTERCEPT
C      3      SLOPE
C      4      ERROR OF SLOPE
C      5      MEAN X
C      6      MEAN Y
C      7      ERROR OF MEAN Y
C      8      ERROR (STANDARD DEVIATION SIGMA) OF SINGLE POINT
C      9      NR OF DELETED POINTS
C
C     PARAMETRIZATIONS
C
C     1.)  Y(X) = Q(2) + Q(3) * X
C          ERROR OF Q(2)            = SQRT OF Q(7)**2+(Q(3)*Q(4))**2
C          CORRELATION Q(2) Q(3)    = -Q(3)*Q(4)**2
C     2.)  Y(X) = Q(6) + Q(3) * (X-Q(5))
C          PROPAGATED ERROR OF Y(X) = SQRT OF Q(7)**2+(Q(4)*(X-Q(5))**2
C
      CALL SORTXY(X,Y,N)
      CALL LINALL(Y(1),X(1),N,Q)
      CALL SMONE(Y,H,N)
      IA=0
      IF(N.GT.10) IA=2
      IF(N.GT.30) GOTO 5
C     LESS THAN 31 POINTS
      CALL LINALL(Y(1),X(1),N,Q)
      QS=Q(8)
      CALL LINALL(H(1+IA),X(1+IA),N-2*IA,Q)
      IF(Q(8).LE.QS) GOTO 10
      CALL LINALL(Y(1),X(1),N,Q)
      Q(8)=0.75*Q(8)
      GOTO 10
C     MORE THAN 30 POINTS
    5 CALL SMONE(H,H,N)
      IA=4
      CALL LINALL(H(1+IA),X(1+IA),N-2*IA,Q)
C
   10 CONTINUE
      CUT=2.0
      CUT2=CUT*CUT
      CF=Q(7)**2+Q(8)**2
      LOOP=0
   15 LOOP=LOOP+1
      J=0
      K=N
      DO 20 I=1,N
      J=J+1
      YE=Q(6)+Q(3)*(X(J)-Q(5))
      CA=(YE-Y(J))**2
      IF(I.EQ.1) CAMIN=CA
      CAMIN=AMIN1(CAMIN,CA)
      CB=CF+((X(J)-Q(5))*Q(4))**2
      IF(CA.LE.CB*CUT2) GOTO 20
      XY=X(J)
      X(J)=X(K)
      X(K)=XY
      XY=Y(J)
      Y(J)=Y(K)
      Y(K)=XY
      J=J-1
      K=K-1
   20 CONTINUE
      IF(LOOP.GE.2.OR.K.GE.2) GOTO 30
      CF=CF+CAMIN
      GOTO 15
   30 CALL LINALL(Y,X,K,Q)
      Q(9)=FLOAT(N-K)
  100 RETURN
      END

      SUBROUTINE CNEWID(INDEX)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "calibr.for"
      DATA ISTEAR/-2/,IRLAST/-99999/,IPLAST/-99999/,IPOINT/0/,IRPLST/0/
      DATA ICLV /0/
      DATA NCAL1/0/,IPLHDR/0/,IPRLIM/100/,IPRLIN/0/
      COMMON/JSCALD/ JESCAL,JESKEY,JESDRW
      INTEGER NVERTS/0/,IVERTS/0/,NVRUN(300,2)/600*0/
      REAL XVRUN(300)/300*0./,YVRUN(300)/300*0./
      INTEGER IUPDJS(6,40),NUPDJS/0/
      REAL RUPDJS(6,40)
      EQUIVALENCE (IUPDJS(1,1),RUPDJS(1,1))
      IF(
     - INDEX.LT.0
     -)THEN
         ISTEAR=INDEX
      IF(
     - ISTEAR.LE.-2
     -)THEN
            PRINT 110,IRLAST
      IF(
     - ISTEAR.EQ.-2
     -)THEN
               PRINT 111
      ELSE
               PRINT 112
      ENDIF
      ELSE
            PRINT 120,IRLAST
      ENDIF
110   FORMAT(//,' **** USE NEW CALIBRATION WHEN AVAILABLE AFTER RUN',I7)
111   FORMAT(6X,'WITH NEW RUN VERTEX',//)
112   FORMAT(6X,'WITHOUT SETTING NEW RUN VERTEX',//)
120   FORMAT(//,' **** USE OF OLD CALIBRATION FORCED AFTER RUN',I7,//)
         RETURN
      ENDIF
      IF(
     - NCAL1.EQ.0
     -)THEN
         NCAL1=1
         IPLHDR=IBLN('HEAD')
         JESKEY=54321
         IPOINT=ICALIB(13)
      ENDIF
      IPHDR2=IDATA(IPLHDR)*2
      IRUN=HDATA(IPHDR2+10)
      IF(
     - ISTEAR.GT.-2 .OR. IRUN.LE.100
     -)THEN
         JESCAL=0
         RETURN
      ENDIF
      ICDNUM=ICALIB(IPOINT+1)
      IF(
     - ICDNUM.LT.654320.OR.ICDNUM.GT.654322
     -)THEN
      IF(
     - IPRLIN.LT.IPRLIM
     -)THEN
            PRINT 9821,IRUN
9821        FORMAT(' *** NO VALID RECORD FOR NEW CALIBRATION',
     +      ' PRESENT AT RUN',I8)
            IPRLIN=IPRLIN+1
      ENDIF
         JESCAL=0
         RETURN
      ENDIF
      IF(
     - IRUN.NE.IRLAST
     -)THEN
         IRLAST=IRUN
      IF(
     - ICALIB(IPOINT+2).NE.IPLAST
     -)THEN
            IPLAST=ICALIB(IPOINT+2)
            IRPLST=ICALIB(IPOINT+3)
      IF(
     - ICDNUM.EQ.654320
     -)THEN
               JESCAL=0
               PRINT 721, IPLAST,IRPLST
721            FORMAT(/' **** OLD ID CALIBRATION WILL BE USED FOR',
     +         ' RUNS',I6,' TO',I6)
      ELSE
               JESCAL=IPLAST
               NVERTS=ICALIB(IPOINT+4)
      IF(
     - NVERTS.GT.0
     -)THEN
      DO 13000 J=1,NVERTS
                     NVRUN(J,1)=ICALIB(3*J+IPOINT+10275)
                     XVRUN(J)=  ACALIB(3*J+IPOINT+10276)
                     YVRUN(J)=  ACALIB(3*J+IPOINT+10277)
13000 CONTINUE
13001 CONTINUE
                  NVRUN(1,1)=IPLAST
                  I=1
15000 CONTINUE
      IF(
     - I.LT.NVERTS
     -)THEN
                     NVRUN(I,2)=NVRUN(I+1,1)-1
                     I=I+1
      GOTO 15000
      ENDIF
15001 CONTINUE
                  NVRUN(NVERTS,2)=IRPLST
                  IVERTS=1
15002 CONTINUE
      IF(
     - IRUN.GT.NVRUN(IVERTS,2)
     -)THEN
                     IVERTS=IVERTS+1
      GOTO 15002
      ENDIF
15003 CONTINUE
      ENDIF
               NUPDJS=ICALIB(IPOINT+5)
      IF(
     - NUPDJS.GT.0
     -)THEN
      DO 13002 J2=1,NUPDJS
      DO 13004 J1=1,6
                        IUPDJS(J1,J2)=ICALIB(6*J2+J1+IPOINT+11171)
13004 CONTINUE
13005 CONTINUE
13002 CONTINUE
13003 CONTINUE
      ENDIF
               JESDRW=ICDNUM-654321
               PRINT 720, JESCAL,IRPLST
720            FORMAT(/' **** NEW ID CALIBRATION WILL BE USED FOR',
     +         ' RUNS',I6,' TO',I6)
      ENDIF
      ENDIF
      IF(
     - IRUN.LT.IPLAST.OR.IRUN.GT.IRPLST
     -)THEN
      IF(
     - IPRLIN.LT.IPRLIM
     -)THEN
               PRINT 9823,IRUN,IPLAST,IRPLST
9823           FORMAT(' *** RUN',I7,' OUT OF RANGE OF CURRENT',
     +         ' CALIBRATION PERIOD:',I7,' TO',I7)
               IF(JESCAL.GT.0) PRINT 9824
9824           FORMAT(' FIRST RUN IN THIS PERIOD ASSUMED FOR',
     +         ' VERTEX AND UPDATES')
               IPRLIN=IPRLIN+1
      ENDIF
            IRUN=IPLAST
      ENDIF
      IF(
     - JESCAL.GT.0 .AND. NVERTS.GT.0
     -)THEN
      IF(
     - IRUN.GT.NVRUN(IVERTS,2)
     -)THEN
16000 CONTINUE
                  IVERTS=IVERTS+1
      IF(.NOT.(
     - IRUN.LE.NVRUN(IVERTS,2)
     -))GOTO 16000
16001 CONTINUE
      ELSE
      IF(
     - IRUN.LT.NVRUN(IVERTS,1)
     -)THEN
16002 CONTINUE
                     IVERTS=IVERTS-1
      IF(.NOT.(
     - IRUN.GE.NVRUN(IVERTS,1)
     -))GOTO 16002
16003 CONTINUE
      ENDIF
      ENDIF
      ENDIF
      IF(
     - JESCAL.GT.0 .AND. NUPDJS.GT.0
     -)THEN
      DO 13006 J=1,NUPDJS
               IND=IUPDJS(4,J)*96+IUPDJS(3,J)-91+IPOINT
      IF(
     - IRUN.GE.IUPDJS(1,J).AND.IRUN.LE.IUPDJS(2,J)
     -)THEN
                  ACALIB(IND)=RUPDJS(5,J)
      ELSE
                  ACALIB(IND)=RUPDJS(6,J)
      ENDIF
13006 CONTINUE
13007 CONTINUE
      ENDIF
      ENDIF
      IF(
     - JESCAL.GT.0 .AND. NVERTS.GT.0 .AND. ISTEAR.EQ.-2
     -)THEN
      ICLV = ICLV + 1
      IF(ICLV.EQ.1) WRITE(6,864)
864   FORMAT('  CNEWID ***:  RUN VERTICES CORRESPONDING TO NEW ID CALIBR
     $ATION SET IN /CALIBR/')
         IPV  = ICALIB(10)
         ACALIB(IPV+ 1) = XVRUN(IVERTS)
         ACALIB(IPV+ 3) = YVRUN(IVERTS)
      ENDIF
      RETURN
      END

C   06/11/87 810041241  MEMBER NAME  TPTRTP   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTRTP
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       6/11/87:  Create track summary banks.
C
C          mod: C. Bowdery       7/06/88:  TPTRFM now an option.
C          mod: C. Bowdery      30/09/88:  CALL TPSEFL now
C     Last mod: C. Bowdery       4/10/88:  Extra TPSEFL call added.
C
C     Routine to create summary banks for tracks and post-process
C     these TPTR banks to find vertices and create TPVX banks.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  SUMMRY, VPROC

      INTEGER  PATR, VXFIT

      PARAMETER ( PATR = 1, VXFIT = 2 )

C------------------  C O D E  ------------------------------------------

C                            Get instruction relating to track summary

      CALL TPTRI1( SUMMRY )
C                            Get instruction relating to vertex proc.

      CALL TPTRI2( VPROC )

      IF( SUMMRY ) THEN

C                            Create summary banks from PATR bank.

        CALL TPTRSM
        CALL TPDIAG()

        IF( VPROC ) THEN

C                            Find vertices and determine fine momentum
C                            correction.

          CALL TPTRFM
          CALL TPDIAG()

        ELSE

C                            Set flag to indicate no vxfit

          CALL TPSEFL( VXFIT, 4000 )

        ENDIF

      ELSE

C                            Set flag to indicate no summary

        CALL TPSEFL( PATR,  4000 )

C                            Set flag to say vertex processing was
C                            not wanted or was not possible

        IF( VPROC ) THEN

          CALL TPSEFL( VXFIT, 1000 )

        ELSE

          CALL TPSEFL( VXFIT, 4000 )

        ENDIF

      ENDIF

      RETURN
      END

      SUBROUTINE PRHTAR
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C----------------------------------------------------------------------
C           MACRO CCYCP .... JET CHAMBER HIT POINTERS (PATREC)
C----------------------------------------------------------------------
      INTEGER*4 HPTSEC
      COMMON/CCYCP/HPTSEC(98)
C     HPTSEC(I) = CDATA POINTER TO 1ST I*2 WORD FOR 1ST HIT OF CELL I
C------------------------ END OF MACRO CCYCP --------------------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      EQUIVALENCE
     ,            (ICELL,IDWRK(1)),(NHIT,IDWRK(2)),(IRING,IDWRK(3))
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 0
        IQJHTL = IBLN('JHTL')
        DSD0   =-.63
        DSD1   = 1.8
        DSD2   = 4.0
        DRV0   = 0.8
        DRV1   = (DSD2 - (DSD1-DSD0)*DRV0) / (DSD2-DSD1)
      ENDIF
      DSBIN1 = TIMDEL(1,IRING)
      DSBIN2 = TIMDEL(2,IRING)
      IP0 = HPTSEC(ICELL)
      IP9 = HPTSEC(ICELL+1) - 1
      IPHL = (HPTSEC(ICELL)-HPTSEC(1))/4 + IDATA(IQJHTL) + 1
      HPHT0 = HPFREE
      HLDHT = 12
      IPHT  = HPHT0
      JHIT = 0
      NWRD2 = NWORD*2
      DO 13000 IP=IP0,IP9,4
        IPHL = IPHL + 1
      IF(
     - IDATA(IPHL).EQ.0
     -)THEN
      IF(
     - HDATA(IP+1).GT.0 .AND. HDATA(IP+2).GT.0
     -)THEN
          IWIR = HDATA(IP)
          IWIR = ISHFTR(IWIR,3)
          ILAYR = LAND(IWIR,15)
          IF(ILAYR.GE.8) DSBIN1 = DSBIN2
          DS =(HDATA(IP+3)) * DSBIN1
      IF(
     - DS.LT.4.0
     -)THEN
      IF(
     - DS.GT.DSD1
     -)THEN
              DS = (DSD1-DSD0)*DRV0 + (DS-DSD1)*DRV1
      ELSE
              DS = (DS-DSD0)*DRV0
      ENDIF
            IF(DS.LT.0.1) DS = 0.1
      ENDIF
          WRK(IPHT+2)  = AMAX1(DS,0.)
          IWRK(IPHT  ) = ILAYR
          IWRK(IPHT+1) = IP
          IWRK(IPHT+4) = 0
          IWRK(IPHT+5) = 0
          IWRK(IPHT+6) = 0
          IWRK(IPHT+7) = 0
          IPHT = IPHT + HLDHT
          JHIT = JHIT + 1
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      NHIT = JHIT
      HPHT9 = IPHT - 1
      HPFREE= IPHT
      RETURN
      END

C   07/06/96 606071854  MEMBER NAME  LINALL   (S4)          FORTG1
      SUBROUTINE LINALL(Y,X,N,Q)
      REAL X(N),Y(N),Q(8)
      REAL*8 XN,SX,SY,SXX,SXY,SYY
C                 - - -
C     CALL LINALL(Y,X,N,Q)
C                       -
C
C     FIT LINEAR DEPENDENCE OF Y ON X, RESULT IN ARRAY Q( )
C     ARRAYS X( ) AND Y( ) ARE NOT CHANGED.
C
C      I      Q(I)
C      1      NR OF ENTRIES (N)
C      2      INTERCEPT
C      3      SLOPE
C      4      ERROR OF SLOPE
C      5      MEAN X
C      6      MEAN Y
C      7      ERROR OF MEAN Y
C      8      MEAN SIGMA OF SINGLE POINT
C
C     PARAMETRIZATIONS
C
C     1.)  Y(X) = Q(2) + Q(3) * X
C          ERROR OF Q(2)            = SQRT OF Q(7)**2+(Q(3)*Q(4))**2
C          CORRELATION Q(2) Q(3)    = -Q(3)*Q(4)**2
C     2.)  Y(X) = Q(6) + Q(3) * (X-Q(5))
C          PROPAGATED ERROR OF Y(X) = SQRT OF Q(7)**2+(Q(4)*(X-Q(5))**2
C
      IF(N.EQ.0) GOTO 25
      XN=N
C
      SX=0.0
      SY=0.0
      DO 10 I=1,N
      SX=SX+X(I)
   10 SY=SY+Y(I)
      SX=SX/XN
      SY=SY/XN
C
      SXX=0.0
      SXY=0.0
      SYY=0.0
      DO 20 I=1,N
      XR=X(I)-SX
      YR=Y(I)-SY
      SXX=SXX+XR*XR
      SXY=SXY+XR*YR
   20 SYY=SYY+YR*YR
C
   25 DO 30 I=1,8
   30 Q(I)=0.0
      IF(N.EQ.0) GOTO 100
      Q(1)=XN
      Q(5)=SX
      Q(6)=SY
      IF(SXX.LE.0.0) GOTO 40
      Q(3)=SXY/SXX
      SYY=SYY-SXY*SXY/SXX
   40 IF(XN.LE.2.0) GOTO 50
      Q(8)=DSQRT(SYY/(XN-2.0D0))
      Q(4)=Q(8)/DSQRT(SXX)
      Q(7)=Q(8)/DSQRT(XN)
   50 Q(2)=Q(6)-Q(3)*Q(5)
  100 RETURN
      END

C   24/11/78 C9080401   MEMBER NAME  TONUM    (JADEGS)      FORTRAN
      SUBROUTINE TONUM(INT1,FLP1)
C
C     **********  FETCH PAIR OF NUMBERS FROM OPERATOR  **********
C
      LOGICAL*1 BLANK,POINT,MINUS,TNN(20),ZW
      DATA BLANK/' '/
      DATA POINT/'.'/
      DATA MINUS/'-'/
*** PMF 20/11/99: Variables added to avoid problems 
*   when calling TRMIN/TRMOUT with logical arguments
      CHARACTER CTNN*20
      EQUIVALENCE(CTNN,TNN(1))
*** PMF(end)
C
   10 CONTINUE
      CALL TRMIN(20,cTNN) ! PMF 20/11/99: TNN-> cTNN
C                                       GET INTEGER NUMBER
      INT = 0
      NUM1 = 0
      ISIGN = 1
      DO 20 I=1,20
        MKI = I
        ZW = TNN(I)
        IF(ZW.EQ.BLANK) GOTO 30
        IF(ZW.NE.MINUS) GOTO 22
        ISIGN = -1
        GOTO 20
   22   IF(ZW.LT.240-192 .OR. ZW.GT.249-192) GOTO 60!PMF 20/11/99: substract 192 ( EBCDIC-> ASCII Code for numbers)
        NUM1 = NUM1 + 1
        INTD = ZW-240+192!PMF 20/11/99: substract 192
        INT = 10*INT + INTD
   20 CONTINUE
C                                       CHECK IF MORE THAN 1 NUMBER
   30 INT1 = INT
      INT = INT * ISIGN
      IF(MKI .GT.8) GOTO 60
      IF(NUM1.EQ.0) GOTO 70
C                                       GET REAL NUMBER
      NBP=0
      NREL=0
      SIGN=1.
      FLP = 0.
      NUM2 = 0
      DO 40 I=MKI,20
        ZW = TNN(I)
        IF(ZW.EQ.BLANK) GOTO 40
        IF(ZW.NE.MINUS) GOTO 32
        SIGN = -1.
        GOTO 40
   32   IF(ZW.NE.POINT) GOTO 34
        NREL=1
        GOTO 40
   34   IF(ZW.LT.240-192 .OR. ZW.GT.249-192) GOTO 60!PMF 20/11/99: substract 192
        NUM2 = NUM2 + 1
        NBP=NBP+NREL
        INTD=ZW-240+192!PMF 20/11/99: substract 192
        FLP = 10.*FLP + INTD
   40 CONTINUE
C
      FLP1 = SIGN * FLP / (10.**NBP)
      GOTO 70
C
   60 CALL TRMOUT(80,'ILLEGAL CHARACTER. TRY AGAIN. STRING WAS:^')
      CALL TRMOUT(20,TNN)
      GOTO 10
C
   70 CONTINUE
      INT1 = INT
      RETURN
      END

C   20/10/81 303161051  MEMBER NAME  MUFFLS   (JADEMUS)     FORTRAN
C   28/03/81 106171601  MEMBER NAME  MUFFLS   (WORKS)       FORTRAN
C   24/03/80 004021728  MEMBER NAME  MUFFLS   (JADEMUS1)    FORTRAN
C   21/05/79 C9070301   MEMBER NAME  MUFFLS   (S)           FORTRAN
C LAST CHANGE 11.00 16/03/83 HUGH MCCANN  - BACK TO STANDARD M.SC. CONST
C      CHANGE 16.04 17/06/81 JOHN ALLISON - DPINA/DKNA CALCN. COMMENTED.
C      CHANGE 16.03 17/06/81 JOHN ALLISON - TO COPE WITH BACK-TRACKING.
C                              (ACTUALLY REQUIRED NO CHANGE. JA.)
C      CHANGE 08.00 10/04/80 HUGH MCCANN - CHANGE MULT. SCATT. CONSTANT
C      CHANGE 17.28 02/04/80 JOHN ALLISON.
C TAKEN FROM JADEMUS 20.15 24/03/80 TO ADD PIDK AND MULTSC.  JA.
C      CHANGE 01.28 03/07/79 JOHN ALLISON.
      SUBROUTINE MUFFLS(*)
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C
C STEPS THROUGH DETECTOR, CALCULATING ENERGY LOSS, MULTIPLE SCATTERING,
C    ETC.
C
C RETURN 1 IF PARTICLE STOPS.
C
C-----------------------------------------------------------------------
C
C COMMONS.
C
#include "cmuffl.for"
#include "cmufwork.for"
C
C-----------------------------------------------------------------------
C
C DATA INITILISATION, ETC,
C
C FOR CALCULATING PI AND K DECAY WE NEED A CONSTANT WHICH DEPENDS ON
C   MEANLIFE, ETC.  THE PROBABLITY OF DECAYING IN DISTANCE D IS
C   (BRANCHING RATIO)*D/(GAMMA*(MEANLIFE IN REST FRAME)*(VELOCITY))
C   = (BR)*(MASS)*D/((MOMENTUM)*(C-TAU)) WHERE C-TAU IS VELOCITY OF
C   LIGHT * (MEANLIFE IN REST FRAME) AND IS GIVEN, E.G., IN THE
C   PARTICLE DATA BOOKLET. GAMMA IS THE TIME-DILATION FACTOR.
C FOR THE PION, BR(PI->MU) = 1.,
C    C-TAU = 7804 MM, HENCE BR*M/(C-TAU) = 1.788E-05 GEV MM**-1.
C FOR THE KAON, BR(K->MU) = .64,
C    C-TAU = 3709 MM, HENCE BR*M/(C-TAU) = 8.518E-05 GEV MM**-1.
      DATA CPIDK,CKDK/1.788E-5,8.518E-5/
C
C FOR CALCULATING ABSORPTION PROBABILTY WE NED THE ABSORPTION CROSS-
C   SECTION.  THIS IS GIVEN FOR PROTONS ON VARIOUS NUCLEI IN THE
C   PARTICLE DATA BOOKLET.  WE HAVE USED THIS TO CALCULATE THE
C   ABSORPTION LENGTHS GIVEN IN THE BLOCK DATA STATEMENTS AFTER
C   SUBROUTINE MUFFLE (AND KEPT IN THE SAME MEMBER AS MUFFLE).
C   THEY FIGURES ARE A HIGH ENERGY (20GEV I BELIEVE) LIMIT. WE SHOULD
C   TAKE ACCOUNT OF THE ENERGY DEPENDENCE BUT FOR MOMENTA BELOW
C   ABOUT 1 GEV WE GET TOO MUCH BACKGROUND TO DISTIGUISH MUONS ANYWAY
C   AND SINCE 1 GEV IS 'HIGH ENERGY' IN THIS CONTEXT WE IGNORE THIS
C   EFFECT FOR THE TIME BEING.  HOWEVER WE DO INTRODUCE FACTORS
C   TO ACCOUNT FOR THE (SLIGHTLY) DIFFERENT CROSS-SECTIONS FOR PI,K,AND
C   P-BAR, AS FOLLOWS:
      DATA FACPB,FACPI,FACK/1.2,0.9,0.9/
C
C-----------------------------------------------------------------------
C
C LOOK AT ENERGIES AND DIVIDE STEP IF NECESSARY.
      NSTEP=1
      JSTEP=1
 1    CONTINUE
      IF(DESTEP.LT..05*E.OR.DESTEP.LT..010)GO TO 2
      NSTEP=2*NSTEP
      DSTEP=DSTEP/2.
      GMSTEP=GMSTEP/2.
      ABSTEP=ABSTEP/2.
      RDSTEP=RDSTEP/2.
      DESTEP=DESTEP/2.
      GO TO 1
C
C-----------------------------------------------------------------------
C
C START OF STEPPING LOOP.
 2    CONTINUE
C
C-----------------------------------------------------------------------
C
C CALCULATE ACTUAL ENERGY LOSS.
      DEACT=DESTEP*ESQ/PSQ
C
C-----------------------------------------------------------------------
C
C CHECK IF STOPPED - RETURN 1 IF SO.
      IF(E-DEACT.LT.WMU+.010)RETURN1
C
C-----------------------------------------------------------------------
C
C PROPAGATE HADRON ABSORPTION AND DECAY PARAMETERS.
C   PDK1=PROBABILITY OF DECAYING THIS STEP.
C   PSN1=PROBABILITY OF SNEAKING, I.E. NOT BEING ABSORBEB THIS STEP.
C   (FOR DESCRIPTION OF OTHER VARIABLES SEE CMUFWORK.)
C
C FOR P-BAR.
      PSN1=EXP(-FACPB*ABSTEP)
      PPBPEN=PPBPEN*PSN1
C
C FOR PROTON.
      PSN1=EXP(-ABSTEP)
      PPPEN=PPPEN*PSN1
C
C FOR PION.
      PDK1=CPIDK*DSTEP/P
      PSN1=EXP(-FACPI*ABSTEP)
      PPIDK=PPIDK+PPIPEN*PDK1
      PPIPEN=PPIPEN*PSN1*(1.-PDK1)
C     DPINA=DPINA+DSTEP*PPIPEN
C
C FOR KAON.
      PDK1=CKDK*DSTEP/P
      PSN1=EXP(-FACK*ABSTEP)
      PKDK=PKDK+PKPEN*PDK1
      PKPEN=PKPEN*PSN1*(1.-PDK1)
C     DKNA=DKNA+DSTEP*PKPEN
C
C-----------------------------------------------------------------------
C
C PROPAGATE MULTIPLE SCATTERING.
C   THE FORMULAE FOR PROPAGATION OF MULTIPLE SCATTERING ANGLES, ETC.,
C   ARE JUSTIFIED IN JADE NOTE 47. WE ASSUME THAT, E.G.,
C   RMS SCATTERING ANGLE PROJECTED ONTO A PLANE =
C     ((15 MEV/C)/(P*BETA))*SQRT(NUMBER OF RADIATION LENGTHS).
C   (SEE PARTICLE DATA BOOKLET FOR REFINEMENTS AND REFERENCES.)
C   (SEE CMUFWORK FOR DEFINITION OF VARIABLES.)
      CON=RDSTEP*(0.015*E/P**2)**2
      VMSD=VMSD+(VMSANG+CON/3.)*DSTEP**2+2.*CMS*DSTEP
      CMS=CMS+(VMSANG+CON/2.)*DSTEP
      VMSANG=VMSANG+CON
C
C-----------------------------------------------------------------------
C
C PROPAGATE OTHER QUANTITIES.
C
      X=X+DSTEP*DCX
      Y=Y+DSTEP*DCY
      Z=Z+DSTEP*DCZ
      E=E-DEACT
      ESQ=E**2
      PSQ=ESQ-WMUSQ
      P=SQRT(PSQ)
      D=D+DSTEP
      GM=GM+GMSTEP
      AB=AB+ABSTEP
      RD=RD+RDSTEP
      DE=DE+DESTEP
C
C-----------------------------------------------------------------------
C
C END OF STEPPING LOOP.
      JSTEP=JSTEP+1
      IF(JSTEP.LE.NSTEP)GO TO 2
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
C     IF(DSTEP.GE.0.)GO TO 999
C     WRITE(6,100)X,Y,Z,DCX,DCY,DCZ,E,P,D,GM,AB,RD,DE
C100  FORMAT(' X,Y,Z,DCX,DCY,DCZ,E,P,D,GM,AB,RD,DE',3F7.0,3F7.4,2F7.2,
C    * 2F7.0,3F7.2)
C     WRITE(6,101)PPIPEN,PPIDK,DPINA,PKPEN,PKDK,DKNA,PPPEN,PPBPEN
C101  FORMAT(' PPIPEN,PPIDK,DPINA,PKPEN,PKDK,DKNA,PPPEN,PPBPEN',8F10.4)
C     WRITE(6,102)CON,VMSANG,VMSD,CMS
C102  FORMAT(' CON,VMSANG,VMSD,CMS',4E15.4)
C999  CONTINUE
      RETURN
C     DEBUG INIT        (INSIST ON FORTRANG IF USE THIS.)
      END

C   24/04/85 807251625  MEMBER NAME  SETSCL   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SETSCL(INDEX)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON       ?    :  SET SCALE
C
C       MOD:   J. OLSSON   15/12/83 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 19/10/84 :  SET SCALE FOR SPECIAL VERTEX
C                                      CHAMBER VIEW
C       MOD:   C. BOWDERY  24/04/85 :  USE CGRSCL COMMON NOW
C  LAST MOD:   J. HAGEMANN 26/10/87 :  FOR VIEW VRX
C
C
C     FOR THE GIVEN VIEW INDEX, SET VIEW SCALE USING VALUES STORED
C     IN COMMON /CGRSCL/. INDEX = 0 MEANS STANDARD VIEW SCALES.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FLVCDO
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C-----------------------------------------------------------------------
C                            MACRO CGRSCL .... GRAPHICS VIEW SCALES
C-----------------------------------------------------------------------
C
      COMMON  / CGRSCL / XMINST(30), XMAXST(30), YMINST(30)
C
C------- END OF MACRO CGRSCL -------------------------------------------
C
C
      COMMON / CGVCDO / FLVCDO(20)
      COMMON / CHEADR / HEAD(108)
C
C------------------  C O D E  ------------------------------------------
C
      IF( INDEX .LT. 1  .OR.  INDEX .GT. 20 ) GO TO 1
C
        IF( INDEX.NE.17 .OR. HEAD(18).LE.100
     *                  .OR. .NOT. FLVCDO(11) ) GO TO 5
          CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) ! PMF 08/11/99: add run argument HEAD(18)
          XMIN = -XRV + XMINST( INDEX )
          XMAX = -XRV + XMAXST( INDEX )
          YMIN = YRV + YMINST( INDEX )
          YMAX = YMIN + XMAX - XMIN
          GO TO 10
   5    XMIN = XMINST( INDEX )
        XMAX = XMAXST( INDEX )
        YMIN = YMINST( INDEX )
        YMAX = YMIN + XMAX - XMIN
        GO TO 10
C
C                            FOR INDEX = 0 (ESPECIALLY), SET STANDARD
C                            VIEW SCALE (AS DEFINED BY THE USER)
C
   1    XMIN = SXIN
        XMAX = SXAX
        YMIN = SYIN
        YMAX = SYAX
C
  10  CALL DWINDO( XMIN, XMAX, YMIN, YMAX )
      RETURN
C
      END

C   14/03/84            MEMBER NAME  GGCLSD   (S)           FORTRAN
C   25/06/78 C9032701   MEMBER NAME  GGCLSD   (GAMTSTS)     FORTRAN
      SUBROUTINE GGCLSD
C
C     H.WRIEDT      30-11-78
C     LAST MODIFICATION   27-03-79  09:20
C
C     ORIGINALLY WRITTEN AS 'LGCLSD' BY S.YAMADA
C     AS TO BE FOUND ON YAMLGSRC.S
C
C---- DUMP CLUSTERS
C---- IF(MAP.NE.0) HCLMAP IS PRINTED.
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK1(500),
     &               ID,HTRACK(3),HCLST,HCLBEC(2),HNCLST,HCOL,HTYPE,HER,
     &               HCORR,HPBLAT,HDUMIN(2),HSCAL(36),HWORD(2),ACOLAN,
     &               ETOT(3),ENTOT(3),IWORK3(16),HCLMAP(2,51),
     &               CLSPRP(13,51)
C***  COMMON /CGGCLS/ NCLST,NCLBEC(2),HCLMAP(2,51),CLSPRP(10,51),ACOLAN,
C*** &                LCOLIN
      DIMENSION HCLSPR(26,51)
      EQUIVALENCE (HCLSPR(1,1),CLSPRP(1,1))
C--   RAD:  360/2*PI
C--   RAD2: RAD**2
      DATA RAD/57.2958/, RAD2/3282.81/
C
      COMMON/ CGGVRN/ NVRSN(20)
      DATA NVCODE/178120713/
      NVRSN(19) = NVCODE
C
      IF (HCLST.LE.0) RETURN
      WRITE(6,600) HCLST,HCLBEC
  600 FORMAT('0 FORWARD DETECCTORS LEAD GLASS CLUSTER DUMP',
     1      /'  NO.OF CLUSTERS=',I3,'  FORWARD DETECTOR(-Z) (',
     2      I3,')  FORWARD DETECTOR(+Z) (',I3,')')
      WRITE(6,601) ((HCLMAP(I,K),I=1,2),K=1,HCLST)
  601 FORMAT(' CLUSTER MAP',/' ',10(5(I5,2X,I5,3X),/' '))
C
C---- DUMP EACH CLUSTER PROPERTIES
C
      WRITE(6,603)
  603 FORMAT(' CLUSTER PROPERTIES',
     1  /' NO. MEMBR JBC ENERGY(GEV) SIG.EN  AV.X(MM)    AV.Y(MM)',3X,
     2    'SIG.X      SIG.Y   ',
     3     '   COS X  COS Y  COS Z   THE(DEG) (MRAD) PHI(DEG)')
      CON = RAD
      CON2 = RAD2
        DO 1 N=1,HCLST
        LNG = HCLMAP(2,N)-HCLMAP(1,N)+1
        IF (HCLSPR(2,N).EQ.0) GOTO 2
        THE = ARCOS(CLSPRP(13,N))
        THEDEG = RAD*THE
        IF (THEDEG.GT.10.) THE = 3.14159-THE
        THEMIL = 1.E+3*THE
        PHI = RAD*ATAN2(CLSPRP(12,N),CLSPRP(11,N))
        WRITE(6,602) N,LNG,HCLSPR(2,N),
     1             (CLSPRP(K,N),K=5,13),THEDEG,THEMIL,PHI
  602   FORMAT(' ',I2,2I5,F11.3,3X,F6.3,2E12.3,2E11.3,3F7.3,3F8.1)
        GOTO 1
  2     WRITE(6,605) N,LNG,HCLSPR(2,N)
  605   FORMAT(' ',I2,2I5,5X,'*****   WHOLE CLUSTER CONSISTS OF ILLEGAL'
     &             ,' COMPONENT NUMBERS   *****')
    1   CONTINUE
      ACORAD = 1.E+3*ACOLAN
      WRITE(6,604) ACORAD
  604 FORMAT(' ACOLLINEARITY ANGLE:',F8.1,' MRAD')
      RETURN
      END

C   12/03/84 412041858  MEMBER NAME  PEDFIX   (S)           FORTRAN
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TAGPED
C
C
C ROUTINE TO DO PEDESTAL SUBTRACTION
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
       IF ( MARK .EQ. 1 ) CALL TAGPD1
       IF ( MARK .EQ. 2 ) CALL TAGPD2
       RETURN
       END

C   20/03/79 C9062501   MEMBER NAME  DIAGHN   (JADEGS)      FORTRAN
      SUBROUTINE DIAGHN(HTEXT,N,H1,H2,H3,H4,H5,H6)
C---
C---     PRINT HTEXT AND UP TO 6 INTEGER*2 NUMBERS, FOR DIAGNOSTICS
C---
      IMPLICIT INTEGER*2 (H)
      DIMENSION H(6),HTEXT(10),HWORK(40)
C---
      IF(N.LT.1.OR.N.GT.6) RETURN
      DO 1  I = 1,6
1     H(I) = 0.
      IF(N.GT.0) H(1) = H1
      IF(N.GT.1) H(2) = H2
      IF(N.GT.2) H(3) = H3
      IF(N.GT.3) H(4) = H4
      IF(N.GT.4) H(5) = H5
      IF(N.GT.5) H(6) = H6
      ILIM = 20 + N*9
      CALL CORE(HWORK,ILIM)
      WRITE(10,100) (HTEXT(I),I=1,10),(H(I),I=1,N)
100   FORMAT(10A2,6I9)
      CALL TRMOUT(ILIM,HWORK)
      RETURN
      END

C   22/11/82 212080650  MEMBER NAME  TWOELS   (JADEGS)      FORTRAN
      SUBROUTINE TWOELS(ICOL,IPLGCL,ERGL)
      IMPLICIT INTEGER*2 (H)
C---
C---        *****  BHABHA REJECTION IN REDUC 2  ********
C---
C---  CHECK WHETHER COLLINEAR CLUSTERS WITH HIGH ENERGY EXIST
C---  IPLGCL = POINTER TO LGCL
C---  ICOL = 0 IF NO COLLINEARS
C---  ICOL = 1 IF COLLINEARS IN BARREL
C---  ICOL = 2 IF COLLINEARS IN ENDCAP
C---                                              J.OLSSON  22.11.82
#include "cdata.for"
      COMMON /CJTRIG/ PI,TWOPI
      DATA FIDEL /.200/
      DATA ZLM /500./
      DATA XLM /350./
      DATA YLM /350./
C---
      ICOL = 0
      NCLST = IDATA(IPLGCL+7)
      IF(NCLST.LE.1) RETURN
      IP3 = IDATA(IPLGCL+3)
      NPWCL = IDATA(IPLGCL+25)
      MARK = 0
      NNCL = NCLST - 1
C
      DO 610  I = 1,NNCL
      IB1 = IPLGCL + IP3 + (I-1)*NPWCL - 1
      IF(ADATA(IB1+2).LT.ERGL) GO TO 610
      JPRT1 = IDATA(IB1+1)
      NN = I + 1
      DO 611  J = NN,NCLST
      IB2 = IPLGCL + IP3 + (J-1)*NPWCL - 1
      JPRT2 = IDATA(IB2+1)
      IF(JPRT1+JPRT2.NE.0) GO TO 611
      IF(ADATA(IB2+2).LT.ERGL) GO TO 611
      IF(JPRT1.NE.0) GO TO 612
C
C  CHECK OF TWO CLUSTERS IN BARREL
C
      FI1 = ADATA(IB1+4)
      FI2 = ADATA(IB2+4)
      ZE1 = ADATA(IB1+5)
      ZE2 = ADATA(IB2+5)
      ABF = ABS(FI2-FI1)
      ABZ = ABS(ZE1+ZE2)
      IF(ABZ.GT.ZLM) GO TO 611
      IF(ABF.LT.PI-FIDEL.OR.ABF.GT.PI+FIDEL) GO TO 611
      ICOL = 1
      GO TO 619
C
C  CHECK OF TWO CLUSTERS IN ENDCAPS
C
612   X1 = ADATA(IB1+4)
      X2 = ADATA(IB2+4)
      Y1 = ADATA(IB1+5)
      Y2 = ADATA(IB2+5)
      ABX = ABS(X1+X2)
      ABY = ABS(Y1+Y2)
      IF(ABX.GT.XLM) GO TO 611
      IF(ABY.GT.YLM) GO TO 611
      ICOL = 2
      GO TO 619
611   CONTINUE
610   CONTINUE
C
619   RETURN
      END

C   25/07/79 C9073101   MEMBER NAME  LGBHIT   (SOURCE)      FORTRAN
      SUBROUTINE LGBHIT(XY,*)
C     WRITTEN BY WATANABE. 29/7/79, 00:50
C     LAST MODIFICATION ON  31/7/79,03:50
      DIMENSION XY(2,4),IXY(2,4),SLP(2)
C     XY(1-2,I); (PHI,Z) OF THE DIAMOND SHAPED REGION I=1,4
C     ALL UNITS ARE THAT OF THE LG COUNTER
C     THE FOLLOWING IS A STATEMENT FUNCTION
      YF(J,I)=SLP(J)*(II-XY(1,I))+XY(2,I)
C
      DO 10 I=1,4
      DO 10 J=1,2
10    IXY(J,I)=XY(J,I)
C     WRITE(6,600) IXY
C600  FORMAT(' LGBHIT; IXY',10I10)
      II=IXY(1,1)
      IF(IXY(1,1).NE.IXY(1,2).OR.IXY(1,3).NE.IXY(1,4)) GO TO 20
      IF(IXY(2,1).NE.IXY(2,3).OR.IXY(2,2).NE.IXY(2,4)) GO TO 20
      GO TO 200
20    IF(IXY(1,1).NE.IXY(1,3).OR.IXY(1,2).NE.IXY(1,4)) GO TO 30
      IF(IXY(2,1).NE.IXY(2,2).OR.IXY(2,3).NE.IXY(2,4)) GO TO 30
      GO TO 200
C
30    SLP(1)=XY(1,3)-XY(1,1)
      IF(ABS(SLP(1)).LT.1.E-10) SLP(1)=1.E-10
      SLP(1)=(XY(2,3)-XY(2,1))/SLP(1)
      SLP(2)=XY(1,2)-XY(1,1)
      IF(ABS(SLP(2)).LT.1.E-10) SLP(2)=1.E-10
      SLP(2)=(XY(2,2)-XY(2,1))/SLP(2)
      J1O=IXY(2,1)
      J2O=J1O
      Y1=YF(1,1)
      Y2=YF(2,1)
      II=II-1
      IF1=1
      IF2=2
C
C     SCAN OVER X, FINDING THE UPPER AND LOWER Y VALUES
C     WITHIN THE DIAMOND
40    II=II+1
      IF(II-IXY(1,4)) 44,42,250
42    Y1S=XY(2,4)
      Y2S=Y1S
C     THE END VALUES
      GO TO 80
44    IF(II.NE.IXY(1,3)) GO TO 50
      Y1=YF(2,3)
      IF1=2
50    Y1=Y1+SLP(IF1)
      IF(II.NE.IXY(1,2)) GO TO 60
      Y2=YF(1,2)
      IF2=1
60    Y2=Y2+SLP(IF2)
      J1N=MIN1(Y1,Y2)
      J2N=MAX1(Y1,Y2)
      Y1S=Y1
      Y2S=Y2
      IF(II.EQ.IXY(1,3)) Y1S=XY(2,3)
      IF(II.EQ.IXY(1,2)) Y2S=XY(2,2)
80    IF(Y2S.GT.Y1S) GO TO 90
      J1=Y2S
      J2=Y1S
      GO TO 100
90    J1=Y1S
      J2=Y2S
100   CONTINUE
      IF(J1.GT.J1O) J1=J1O
      IF(J2.LT.J2O) J2=J2O
C     WRITE(6,610)II,J1,J2,J1N,J2N,J1O,J2O,IF1,IF2
C610  FORMAT(' II,J1..',12I10)
C     WRITE(6,620) Y1,Y2,Y1S,Y2S,SLP
C620  FORMAT(' Y1,Y2..',10F10.4)
      J1O=J1N
      J2O=J2N
      IF(J1.GT.31) GO TO 40
      IF(J2.LT.0) GO TO 40
      IF(J1.LT.0) J1=0
      IF(J2.GT.31) J2=31
      CALL LGBFIL(II,J1,J2,&300)
      GO TO 40
C
C     SIMPLE CASES
200   CONTINUE
      I2=IXY(1,3)
      I2=IXY(1,4)
      J1=IXY(2,3)
      J2=IXY(2,2)
      IF(J2.GT.J1) GO TO 230
      I=J2
      J2=J1
      J1=I
230   CONTINUE
      IF(J1.GT.31) RETURN
      IF(J2.LT. 0) RETURN
      IF(J1.LT. 0) J1=0
      IF(J2.GT.31) J2=31
C     WRITE(6,630) II,I2,J1,J2
C630  FORMAT(' SIMPLE',12I10)
      DO 240 I=II,I2
240   CALL LGBFIL(I,J1,J2,&300)
250   RETURN
C
300   RETURN1
      END

C   25/06/78 C9032101   MEMBER NAME  GGSORT   (GAMTSTS)     FORTRAN
      SUBROUTINE GGSORT
C
C     H.WRIEDT    17-11-78
C     LAST MODIFICATION  21.03.79  18:00
C
C     ORIGINALLY WRITTEN AS 'LGSORT' BY S.YAMADA
C     AS TO BE FOUND ON YAMLGSRC.S
C
C---- REARRANGE THE SIMULATED LEAD GLASS ADC DATA IN ORDER.
C---- SORT FOLLOWING THE ALGORITHM 201 OF CACM,SEE P.66 DESY R-INFO
C
C
      IMPLICIT INTEGER*4 (G), INTEGER*2 (H)
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),GGADC(192)
C***  COMMON /CGGADC/ LNG,HPOINT(4),GGADC(192)
      DIMENSION HGGADC(2,192)
      EQUIVALENCE (GGADC(1),HGGADC(1,1))
      COMMON/ CGGVRN/ NVRSN(20)
      DATA NVCODE/178111717/
      NVRSN(16) = NVCODE
C
      NLNG = LNG-2
      IF(NLNG.LE.1) RETURN
C
C           ADDRESS SORT
      M = NLNG
   10 M = M/2
      IF(M.EQ.0) RETURN
      K = NLNG-M
        DO 50 J=1,K
        I = J
   20   IF(I.LT.1) GO TO 50
    1   IF(GGADC(I+M).GE.GGADC(I)) GO TO 50
C----   REPLACING
    3   IW = GGADC(I)
        GGADC(I) = GGADC(I+M)
        GGADC(I+M) = IW
        I = I-M
        GO TO 20
   50   CONTINUE
      GO TO 10
      END

C   26/10/81 712202140  MEMBER NAME  LGMC56   (S)           FORTRAN
       SUBROUTINE LGMC56(LGMDMP,PV,RH, JBC ,IMASS)
C**********************************************************************
C    MAIN ROUTINE FOR TOKYO SHOWER PROGRAM, AS CALLED FROM TRKGAM
C                 IN JADE MC TRACKING PROGRAM
C**********************************************************************
C
C      PROGRAM TO CREATE  EM SHOWER IN THE LG-DETECTER USING THE
C          FOUR VECTOR OF GAMMAS  AND PUT THE GENERATED LG-DATA
C          INTO RAW DATA.
C
C     S.YAMADA   26-10-81  22:25    COPIED FROM @LGMCINC,LGMCMM
C     LAST MODIFICATION       27-11-81   18:10
C                         END CAP ABSORBER THICKNESS INCREASED.
C                         LGMCIN (WITHOUT RANDOM NO.INIT.) IS ADDED.
C
C     MODIFIED FOR USE WITH 56 VERSION OF SHOWER MC  (SF5+SF6)
C     ONE MORE ARGUMENT (IMASS), FOR PHOTON (0) OR ELECTRON (1)
C     LAST MODIFICATION    16.1.1986     J.OLSSON
C
C   MADE STANDARD LGMC56  ON 20.12.1987
C
C  INPUT
C     LGMDMP= TEST DUMP FLAG, 0-NODUMP, 1-->3 MORE DETAILED DUMPS.
C     PV= MOM.FOUR VECTOR OF THE GAMMA TO BE TRACED IN GEV.
C         PV(1,2,3)=PX,PY,PZ   PV(4)=ENERGY
C     RH= HIT POINT COORDINATE EITHER ON THE COIL SURFACE IN MM.
C     JBC = 0         BARREL
C           +-1       +Z,-Z END CAP
C     IMASS           MASS INDEX, 0 --> PHOTON, 1 --> ELECTRON
C     **** IMPORTANT ****
C     *    MODIFIED FOR BOTH THE BARREL AND END CAP PARTS!!
C     *    USE FOR THE COIL INNER RADIUS  RADIUS(1) IN THE /CLGD56/.
C     *    USE FOR THE P.V. INNER DIST.   ZPV(1 OR 3) IN THE /CLGD56/.
C     *    (P.V. = PRESSURE VESSEL)
C     ********************************************************
C
      IMPLICIT INTEGER *2 (H)
C
C  SHOWER MC COMMON
C
      COMMON /CLGD56/ RADIUS(6),ZEND(2),ZWID,ZGAP,PHWID,
     2                ECXLST(24), ECYLST(24),ZECAP(4),ZPV(4),TPV,
     3                TH(4),THECP
C
      COMMON /ENECUT/ ECUT,ECUTLS(3)
C
      DIMENSION PRTCL(3,3)
      DIMENSION PV(4),RH(3)
C
      COMMON / COLSON/ IPRO,ELODIF
C
      DATA ELEMAS/0.000511/
      DATA  ISTART/0/
C
      IF( ISTART.GT.0 ) GO TO 1
C
C  INITIALIZE  * * * *
C
      CALL MCIN56
      ISTART = 1
1     CONTINUE
C
C---- CHECK USED TIME
C
      IF(NTIME(DUM).LT.200) GO TO 100
C
      IF(IPRO.NE.0) WRITE(6,551) PV(4)
551   FORMAT(' LGMC56: PV4 ',E12.4)
C
      IF( PV(4).LE.0. ) RETURN
C
C UPDATE THICKNESS OF ABSORBER, IN THIS VERSION THETA DEPENDENT
C   ONLY FOR JBC = 0
C
      IF(JBC.NE.0) GO TO 6210
      COSTPV = PV(3)/PV(4)
      CALL TJOCKI(COSTPV,XLEN90,XLENDM,ELODF)
      ELODIF = ELODF
C
      RADIUS(2) = RADIUS(1) + XLEN90*89.
C
      IF(IPRO.GT.0) WRITE(6,6209) PV(3),PV(4),COSTPV,XLEN90,RADIUS(2)
6209  FORMAT(' LGMC56TJ: PV3-4 COS XLEN90 RAD2 ELODIF ',6E12.4)
C
6210  CONTINUE
C
C---- TRANSFER EACH FINAL STATE (INCLUDING DECAY PRODUCTS) TO LGSTRC.
C----   COPY TRACK INFORMATION
C----
C----    PRTCL:    0.        ENERGY(ELMASS)          0.
C----            POS X         POS Y              POS Z      (MM)
C----           DIRCOS        DIRCOS             DIRCOS
C----
C
        PRTCL(1,1)=0.0
        PRTCL(2,1)=PV(4)/ELEMAS
        PRTCL(3,1)=0.
          DO 11 K=1,3
          PRTCL(K,2) = RH(K)
          PRTCL(K,3) = PV(K)/PV(4)
   11     CONTINUE
C
        IF(LGMDMP.GE.2.OR.IPRO.NE.0) WRITE(6,6002) PRTCL
 6002   FORMAT('0INPUT INF.',3F9.2,3F9.1,3F9.3)
C
C----   LEAD-GLASS SHOWER TRACING FOR THE BARREL AND ENDCAP PARTS.
C   MASS IN MEV/C**2
        AMG = 0.
        IF(IMASS.NE.0) AMG = 0.511
C
C  ON CALL, PRTCL POSITION COMPONENT (1-3,2,N) HAS UNIT MM.
C
C
      IF(IPRO.NE.0) WRITE(6,552)
552   FORMAT(' LGMC56: CALLING LGST56 ')
C
        CALL LGST56(JBC,PRTCL,PV(4)*1000.0, AMG,LGMDMP)
      RETURN
100   CONTINUE
      WRITE(6,5730)
5730  FORMAT('  TIME OUT IN LGMC56...')
      RETURN
      END

C   14/03/84 403202301  MEMBER NAME  FAMPCO   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FAMPCO( IPLT, X1, Y1, Z1, X2, Y2, Z2, RR )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  14/03/84 :  EXTRACT COORDINATES FROM FAMP BANK
C
C
C        THIS ROUTINE EXTRACTS COORDINATES FROM THE FAMP BANK 'BK17'
C        WHICH USES CYLINDRICAL POLAR VERSION OF 'PATR' FORMAT
C
C        INPUT:  IPLT        POINTER TO HDATA WHERE TRACK STARTS
C        OUTPUT: X1,Y1,Z1    COORDINATES OF FIRST POINT OF TRACK (MM)
C                X2,Y2,Z2         "      "  LAST    "   "    "   (MM)
C                RR          RADIUS OF CURVATURE                 (MM)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
      COMMON / CJTRIG / PI,TWOPI
C
      DIMENSION HRAD(2)
      EQUIVALENCE (IRAD,HRAD(1))
C
C------------------  C O D E  ------------------------------------------
C
      IFTR    = HDATA(IPLT)
      IF( IFTR .LT. 0 ) RETURN
C
C                            HALF WORDS 1,2,3 ARE R1,PHI1,Z1
C                            1ST POINT ON TRACK, UNITS: 1/10 (MM / DEG)
C
      RAD1    = HDATA(IPLT + 1) * 0.1
      PHI1D   = HDATA(IPLT + 2) * 0.1
      Z1      = HDATA(IPLT + 3) * 0.1
C
C                            HALF WORDS 4,5,6 ARE R2,PHI2,Z2
C                            LAST POINT ON TRACK, UNITS: 1/10 (MM / DEG)
C
      RAD2    = HDATA(IPLT + 4) * 0.1
      PHI2D   = HDATA(IPLT + 5) * 0.1
      Z2      = HDATA(IPLT + 6) * 0.1
C
C                            HALF WORDS 8,9   ARE R RADIUS OF TRACK
C                            (32 BIT WORD IN 2 PARTS, UNITS = 1/10 MM )
C
      HRAD(1) = HDATA(IPLT + 8)
      HRAD(2) = HDATA(IPLT + 9)
      RR      = FLOAT( IRAD )  * 0.1
C
C                            CONVERT PHI TO RADIANS
C
      PHI1R   = PHI1D * PI / 180.0
      PHI2R   = PHI2D * PI / 180.0
C
C                            REVERSE SIGN OF CURVATURE, TO CONFORM TO
C                            JADE STANDARD
C
      RR      = - RR
C
      X1      = RAD1 * COS( PHI1R )
      X2      = RAD2 * COS( PHI2R )
C
      Y1      = RAD1 * SIN( PHI1R )
      Y2      = RAD2 * SIN( PHI2R )
C
C     Z1      = SEE ABOVE
C     Z2      = SEE ABOVE
C
      RETURN
      END

C   24/04/79 406231924  MEMBER NAME  XYTAG    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE XYTAG( NO, X, Y, SLOPE )
C-----------------------------------------------------------------------
C
C    AUTHOR:   L. O'NEILL   24/04/79 :  COORDINATE CALCULATIONS FOR FW
C
C       MOD:   J. OLSSON    15/06/81 :  M.C. ERROR CORRECTED
C       MOD:   J. OLSSON     7/10/83 :
C       MOD:   J. NYE       24/05/84 :  USES TAGMRK
C  LAST MOD:   C. BOWDERY   23/06/84 :  FOR JOHN NYE'S CHANGE
C
C
C        THIS ROUTINE PROVIDES THE X AND Y COORDINATES (MM)
C        IN THE STANDARD DETECTOR COORDINATE SYSTEM,
C        OF THE CENTRE OF TAGGING SYSTEM COUNTER NUMBER "NB",
C        WHERE "NB" AND THE X AND Y COORDINATE VALUES APPEAR IN
C        ORDER IN THE ARGUMENT FIELD.
C
C        OBS: 1979-80 HAS BLOCK NRS 1-190
C        OBS: 1981-82 HAS BLOCK NRS 0-63
C        OBS: 1983-.. HAS BLOCK NRS 4-91. THIS IS PACKED INTO ARRAY 1-4800001500
C
C        THE COORDINATES REFER TO THE CORNER WHICH IS SUITABLE FOR
C        WRITING, I.E. LOWER LEFT CORNER
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
#include "cwktag.for"
#include "cgeo2.for"
#include "cgeo3.for"
C
      COMMON / CJTRIG / PI,TWOPI,PIHALF
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4
C
      DIMENSION  NCOLMN(6),AMID(6),WFACT(4)
C
      DATA  NCOLMN / 2,9, 18, 29, 37, 45 /
      DATA  AMID   / 1.0, 6.0, 14.0, 24.0, 33.5, 41.5 /
      DATA  WFACT  / -0.25, -0.75, 0.75, 0.25 /
      DATA  ICAL   / 0 /
C
C------------------  C O D E  ------------------------------------------
C
      IF( ICAL .NE. 0 ) GO TO 2121
      DFI  = PI*.25
      DDFI = DFI*.05
      ICAL = 1
C
C                            CALL TAGMRK TO CHOOSE 'MARK'
C                            IF IFLMRK = -1  ALREADY DONE
C
 2121 IF( IFLMRK .NE. -1 ) CALL TAGMRK(&2000)
      IF( (MARK .LT. -1) .OR. (MARK .GT. 2) ) CALL TAGMRK(&2000)
C
      IF( MARK .EQ. 1 ) GO TO 1000
      IF( MARK .EQ. 2 ) GO TO 2000
C
C                           1979-80 TAGGING APPARATUS
C
      NB = NO - 1
      IF((NB.GE.  0).AND.(NB.LE. 45)) GO TO 1
      IF((NB.GE. 48).AND.(NB.LE. 93)) GO TO 1
      IF((NB.GE. 96).AND.(NB.LE.141)) GO TO 1
      IF((NB.GE.144).AND.(NB.LE.189)) GO TO 1
101   WRITE(JUSCRN,100) NO
  100 FORMAT(' XYTAG CALLED WITH ILLEGAL BLOCK NUMBER',I10)
      X = 0.
      Y = 0.
      SLOPE = 0.
      RETURN
    1 CONTINUE
      IZ=-1
      IF(NB.GE.96) IZ=1
      IF(IZ.EQ.1) NB=NB-96
      IX=-1
      IF(NB.GE.48) IX=1
      IF(IX.EQ.1) NB=93-NB
      DO 202 I=1,6
      ICOL=I
      IF(NB.LE.NCOLMN(I)) GO TO 203
  202 CONTINUE
  203 CONTINUE
      X=(-6.5+ICOL)*FENDC
      Y=(AMID(ICOL)-NB)*FENDC
      SIGNY=1.
      IF(Y.LT.0.) SIGNY=-1.
      IF(ICOL.EQ.5) Y=Y+SIGNY*1.5*FENDC
      IF(ICOL.EQ.6) Y=Y+SIGNY*XYHOL2
      IF(ABS(Y).LT.(1.5*FENDC)) X=X+2.*FENDC-XYHOL1
      X=IX*IZ*X
      Y=IX*IZ*Y
      SLOPE = 0.
      RETURN
 1000 CONTINUE
C
C                             1981-82  TAGGING APPARATUS
C
      NB=NO
      IF((NB.GE.  0).AND.(NB.LE. 63)) GO TO 2
      GO TO 101
    2 CONTINUE
      IZ=-1
      IF(NB.GT.31) IZ=1
      IF(IZ.EQ.1) NB=NB-32
      IY=1
      IF(NB.GT.15) IY=-1
      IF(IY.EQ.-1) NB=31-NB
      IX=1
      IF(NB.GT.7) IX=-1
      IF(IX.EQ.-1) NB=15-NB
      MB=NB
      IF(NB.GT.1) MB=NB+1
      JY=MB/3
      JX=MB-3*JY
      YQ=(JY+0.5)*FENDC
      XQ=(2.5-JX)*FENDC
      IF(JX.EQ.2) YQ=YQ+0.25*FENDC
      IF(JY.EQ.0) XQ=XQ+0.25*FENDC
      X=-IZ*IX*XQ
      Y=-IZ*IY*YQ
      SLOPE = 0.
      RETURN
2000  CONTINUE
C
C                            1983-.. TAGGING APPARATUS
C
      NB=NO
      IZ=-1
      IF(NB.GT.24) IZ=1
      IF(NB.LT.1.OR.NB.GT.48) GO TO 101
C
C                            K GIVES LAYER NUMBER, L SERIAL 1 TO 8
C
      KNB = NB
      IF(IZ.GT.0) KNB = KNB - 24
      K = (KNB-1)/8 + 1
      L = KNB - (K-1)*8
      FISTRT = - FLOAT(IZ)*PIHALF
      IF(IZ.GT.0) GO TO 8021
C  MINUS Z  ENDCAP
      IF(L.GT.2.AND.L.LT.7) GO TO 8022
C UPPER HALF
      FI = FISTRT + (L-1)*DFI + DDFI
      RFI = PBSCR(K)
      IF(K.EQ.1) RFI = RFI -.02*FENDC
      GO TO 8030
8022  CONTINUE
C LOWER HALF
      FI = FISTRT + L*DFI - DDFI
      RFI = PBSCR(K+1) - 0.1*(PBSCR(K+1)-PBSCR(K))
      GO TO 8030
8021  CONTINUE
C  PLUS Z  ENDCAP
      IF(L.GT.2.AND.L.LT.7) GO TO 8024
C LOWER HALF
      FI = FISTRT + L*DFI - DDFI
      RFI = PBSCR(K+1) - 0.1*(PBSCR(K+1)-PBSCR(K))
      GO TO 8030
8024  CONTINUE
C UPPER HALF
      FI = FISTRT + (L-1)*DFI + DDFI
      RFI = PBSCR(K)
      IF(K.EQ.1) RFI = RFI -.02*FENDC
8030  CONTINUE
      LL = L - ((L-1)/4) * 4
      SLOPE = WFACT(LL)*PIHALF
      X = RFI*COS(FI)
      Y = RFI*SIN(FI)
C  GET IN ADDITION THE CORNER POINTS, FOR CRICRO DISPLAY
      FI1 = FISTRT + (L-1)*DFI
      FI2 = FI1 + DFI
      RFI1 = PBSCR(K)
      RFI2 = PBSCR(K+1)
C
      X1 = RFI1*COS(FI1)
      X2 = RFI2*COS(FI1)
      X3 = RFI2*COS(FI2)
      X4 = RFI1*COS(FI2)
      Y1 = RFI1*SIN(FI1)
      Y2 = RFI2*SIN(FI1)
      Y3 = RFI2*SIN(FI2)
      Y4 = RFI1*SIN(FI2)
C
      RETURN
      END

C   16/08/80 601241047  MEMBER NAME  LGERSE   (SOURCE)      FORTRAN
      SUBROUTINE LGERSE(HEXP,HRUN,*)
C  TWO STEPS IN HANDLING BAD ADC'S
C  1.CHECK IF MANY ADC'S FIRED. IF SO SUBTRACT A CONSTANT FROM THEM
C     (3 CASES; ALL CRATES, EACH CRATE, AND EACH ADC MODULE)
C     NOW DONE EVENT BY EVENT. LGSUBC GIVES THE CONST.
C  2.FOR EACH BAD ADC CHANNEL, SUBTRACT CONST GIVEN IN HBUF
C
C            MODIFICATION 23/05/79  13:15
C            MODIFICATION BY Y.WATANABE 16-08-80 23:00
C
C            13/01/86 : COPIED FROM JADELG.SOURCE(LGERSE) M. KUHLEN
C       MOD. 14/01/86 : FULL RINGS 0 AND 31 ERASED        M. KUHLEN
C  LAST MOD. 15/01/86 : PRINT MESSAGE PRIVATE VERSION     M. KUHLEN
C
C
      IMPLICIT INTEGER *2 (H)
C     USED IN LGANAL PART OF PROGRAMS
C        NO CUTS ON MAX FIRIED #CHANNELS (I.E. DIMENSION=2880)
C        CHANGE SIZE OF THE CLUSTER BANK TO 16.. 13/6/80
C        CHANGED BY Y.WATANABE ON 23/09/79. 00:30
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,
     3               MAPCL(81),  CLPRP(1280)
      INTEGER *2 HMAPCL(2,81)
      DIMENSION ICLSPR(16,80),CLSPRP(16,80), CLMPRP(1361)
      EQUIVALENCE (HMAPCL(1,1),MAPCL(1)), (CLMPRP(1),MAPCL(1))
      EQUIVALENCE (ICLSPR(1,1),CLPRP(1)),  (CLSPRP(1,1),CLPRP(1))
C
C     LHO'S GENERAL CONSTANT SCHEME
C     20/09/79.
      COMMON/CALIBR/NCAL(10000)
      INTEGER*2 HCAL(20000)
      EQUIVALENCE  (NCAL(1),HCAL(1))
C
      COMMON /CLGBCH/ HABAD(2,3)
      COMMON /CTEMPB/ HCHB(500)
      INTEGER*2 HCR(3)
C
      DATA HEXPO,HRUNO/0,0/
C                                   MESSAGE
      DATA NCALL /0/
      NCALL = NCALL + 1
      IF( NCALL .LT. 2 ) WRITE(6,990)
 990  FORMAT(1X,'LGERSE:  CORRECTED VERSION FROM 24.1.1986 CALLED')
C
      IF(HRUN.LE.100) RETURN1
      IF(HRUN.EQ.HRUNO) GO TO 10
C        NO TEST ON EXP#
      CALL LGBADC(HEXP,HRUN,*190)
C
      HRUNO =HRUN
      HEXPO =HEXP
      NP=NCAL(7)
      HBADC=HCHB(5)
      HBCHN=HCHB(6)
      KPE=7+HBADC+HBADC
10    HIT=LNG-3
C
C     CHECK IF ALL CRATES FIRED.
      HCHB(4)=0
C     IF(HSUB.LT.1) GO TO 30
      IF(HIT.LT.HABAD(1,1)) GO TO 30
      CALL LGSUBC(4,HSUB)
      HCHB(4)=HSUB
      DO 20 I=1,HIT
      HADC=HLGADC(2,I)-HSUB
      IF(HADC.LT.0) HADC=0
      HLGADC(2,I)=HADC
20    CONTINUE
C     WRITE(6,900) HIT
C900   FORMAT(' ALL CRATES FIRED',I5)
      GO TO 62
C
C     CHECK IF SOME CRATES FIRED
30    IF(HIT.LT.HABAD(1,2)) GO TO 62
C     IF(HCHB(1).GT.0) GO TO 32
C     IF(HCHB(2).GT.0) GO TO 32
C     IF(HCHB(3).GT.0) GO TO 32
C     GO TO 62
32    HCR(1)=0
      HCR(2)=0
      HCR(3)=0
C     COUNT #ADC CHANNELS FIRED PER CRATE.
      J=1
      DO 40 I=1,HIT
      IF(HLGADC(1,I).GE.960) J=2
      IF(HLGADC(1,I).GE.1920) J=3
      HCR(J)=HCR(J)+1
40    CONTINUE
C
      DO 60 J=1,3
      HCHB(J)=0
      IF(HCR(J).LT.HABAD(1,2)) GO TO 60
C     WRITE(6,910) J,HIT,HCR(J)
C910   FORMAT(' ONE CRATE  FIRED',5I5)
      CALL LGSUBC(J,HSUB)
      HCHB(J)=HSUB
      IF(HSUB.LT.1) GO TO 60
C     (BAD CRATE)
      I1=960*(J-1)
      I2=I1+960
      DO 50 I=1,HIT
      HADC=HLGADC(1,I)
      IF(HADC.LT.I1) GO TO 50
      IF(HADC.GE.I2) GO TO 50
      HADC=HLGADC(2,I)-HSUB
      IF(HADC.LT.0) HADC=0
      HLGADC(2,I)=HADC
50    CONTINUE
60    CONTINUE
C
C     CHECK IF ANY ADC FIRED.
62    KP=7
      IF(HBADC.LT.1) GO TO 115
      IF(HIT.LT.HABAD(1,3)) GO TO 115
      HMODO=-1
      HA1=0
      HA2=0
      DO 100 I=1,HIT
      HMOD=HLGADC(1,I)/48
      JC=HLGADC(1,I)/960+1
      IF(HMOD.EQ.HMODO) GO TO 90
      IF(HMODO.LT.0) GO TO 80
C     CHECK IF #HITS EXCEED THE LIMIT.
64    IF(HMODO.LT.HCHB(KP)) GO TO 80
      IF(HMODO.EQ.HCHB(KP)) GO TO 66
      KP=KP+2
      IF(KP.GE.KPE) GO TO 115
      GO TO 64
66    IF(HAHIT.LT.HABAD(1,3)) GO TO 80
      HSUB=HCHB(KP+1)-HCHB(JC)-HCHB(4)
      IF(HSUB.LT.1) GO TO 72
      DO 70 J=HA1,HA2
      HADC=HLGADC(2,J)-HSUB
      IF(HADC.LT.0) HADC=0
      HLGADC(2,J)=HADC
70    CONTINUE
C
72    CONTINUE
C     WRITE(6,920) HIT,HMODO,HAHIT,HA1,HA2
C920   FORMAT(' ADC MODULE FIRED',8I5)
75    KP=KP+2
      IF(KP.GE.KPE) GO TO 115
80    HAHIT=0
      HA1=I
      HA2=I
      IF(I.EQ.HIT) GO TO 110
90    HAHIT=HAHIT+1
      HA2=I
      HMODO=HMOD
      IF(I.EQ.HIT) GO TO 64
100   CONTINUE
110   CONTINUE
C
C     NOW INDIVIDUAL CHANNELS
115   KP=KPE
      IF(HBCHN.LT.1) GO TO 145
      I=1
      DO 140 N=1,HBCHN
      HB=HCHB(KP)
      DO 120 J=I,HIT
      IF(HB.GT.HLGADC(1,J)) GO TO 120
      IF(HB.NE.HLGADC(1,J)) GO TO 130
      HADC=HLGADC(2,J)-HCHB(KP+1)
      IF(HADC.LT.0) HADC=0
      IF(HCHB(KP+1).GT.1000.AND.HLGADC(2,J).GT.4000) HADC=0
C        KILL THE BAD ONE IF OVERFLOWS
      HLGADC(2,J)=HADC
      GO TO 130
120   CONTINUE
C
      GO TO 140
130   KP=KP+2
140   CONTINUE
C
C     ALSO BLOCKS NOT PRESENT MAY HAVE NONZERO VALUES SINCE THE
C     ELECTRONICS FOR THEM IS READ OUT AND MAY BE 'SPINNING'.
C
C     ERASE RING 0 AND 31 WHICH ARE UNPHYSICAL FOR THE MOMENT
C      (AUTOMATICALLY DONE IN LGCALB, I.E. THE GAIN FACTOR=0 FOR TNEM)
C
C     THESE TWO FULL RINGS ARE ERASED IN STANDARD PROCEDURES REGARDLESS
C     WHETHER THE TWO HALF RINGS (INSTALLED IN 1983) ARE ACTUALLY
C     PRESENT ORE NOT, IN ORDER TO KEEP ACCEPTANCE CALCULATIONS
C     COMPATIBLE WITH FORMER DATA.
C
145   CONTINUE
      DO 150 I=1,HIT
         IADC = HLGADC(1,I)
         IF(IADC.GT.2687) GO TO 150
         IRING=MOD(IADC,32)
C                                   ADC  #  0 - 2687   ( BARREL )
C                                   RING #  0 -   31
C                                   ROW  #  1 -   84
C     BLOCKS   A B S E N T : RING  0, ROW  1 TO 21 AND ROW 64 TO 84
C                            RING 31, ROW 22 TO 63
C
C     IT IS POSSIBLE TO KEEP THE TWO HALFRINGS WHICH ARE REALLY THERE:
C     REMOVE THE COMMENTING OF THE FOLLOWING 3 STATEMENTS AND
C     PRESENT BLOCKS WILL NOT BE KILLED.
C        IROW = 1 + IADC/32
C        IF( IRING.EQ. 0 .AND. (IROW.GE.22.AND.IROW.LE.63) ) GOTO 150
C        IF( IRING.EQ.31 .AND. (IROW.LE.21 .OR.IROW.GE.64) ) GOTO 150
C
         IF(IRING.EQ.0.OR.IRING.EQ.31) HLGADC(2,I)=0
 150  CONTINUE
      RETURN
C
C  RUN # NOT FOUND
190   CONTINUE
      DATA MESCNT/0/
      MESCNT = MESCNT+1
      IF(MESCNT.LE.10) WRITE(6,600) HRUN
600   FORMAT(1X,'*** RUN # ',I5,'  NOT FOUND ***',
     $       2X,'(MESSAGE FROM LGERSE)')
      RETURN1
      END

      SUBROUTINE TRGCHK(LBTRCK,LBTRBT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cdata.for"
#include "cheadr.for"
      COMMON /CWORK/ ILGE(84),HCLWR(96)
      DATA MKTREV /Z673/, MKT2AC /Z73/, MKEHIG /Z600/,MKUNTR /ZF88C/
      INTEGER MKTRBT( 7) /1,2,4,8,16,32,64/
      INTEGER NCTOF ( 7) /2,3,3,3,3,3,3/
      INTEGER ICTOF ( 7) /0,1,2,3,4,5,6/
      LBTRCK = 0
      IF(
     - LAND(LBTRBT,MKUNTR).NE.0
     -)THEN
        LBTRCK = 32
        RETURN
      ENDIF
      IF(LAND(LBTRBT,MKTREV).EQ.0) RETURN
      IF(LAND(LBTRBT,MKEHIG).NE.0) LBTRCK = 16
      IF(LAND(LBTRBT,MKT2AC).EQ.0) RETURN
      CALL SETSL(ILGE(1),0,528,0)
16000 CONTINUE
        IPALGN = IDATA(IBLN('ALGN'))
      IF(
     - IPALGN.LE.0
     -)THEN
      GOTO 16001
      ENDIF
      IF(
     - IDATA(IPALGN).LE. 3
     -)THEN
      GOTO 16001
      ENDIF
        IPLG2 = IPALGN*2
        NBARR = HDATA(IPLG2+ 4) - HDATA(IPLG2+ 3)
      IF(
     - NBARR.LE.0
     -)THEN
      GOTO 16001
      ENDIF
        IP0 = IPLG2 + 7
        IP9 = IP0 + NBARR - 1
      DO 13000 IP=IP0,IP9,2
          NBL  = HDATA(IP)
          IROW = ISHFTR(NBL,5)
          ILGE(IROW+1) = ILGE(IROW+1) + HDATA(IP+1)
13000 CONTINUE
13001 CONTINUE
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16000
16001 CONTINUE
      IPJETC = IDATA(IBLN('JETC'))
      IF(IPJETC.LE.0) RETURN
      IF(IDATA(IPJETC).LE.50) RETURN
      IPJC2 = IPJETC*2
      NHTR3 = HDATA(IPJC2+99) - HDATA(IPJC2+51)
      IF(NHTR3.LE.0) RETURN
      IP0 = IPJC2 + 100 + HDATA(IPJC2+51)
      IP9 = IP0 + NHTR3 - 1
      IWIR0 =-1
      DO 13002 IP=IP0,IP9,4
        IWIR = HDATA(IP)
        IWIR = ISHFTR(IWIR,3)
        HCLL = ISHFTR(IWIR,3) - 95
        IF(IWIR.NE.IWIR0) HCLWR(HCLL) = HCLWR(HCLL) + 1
        IWIR0 = IWIR
13002 CONTINUE
13003 CONTINUE
      IPLATC = IDATA(IBLN('LATC'))
      IF(IPLATC.LE.0) RETURN
      IPLT2 = IPLATC*2
      IP0 = IPLT2 + 6
      IP9 = IP0 + 5
      ITLST =-100
      ITOF0 = 0
      ICLL0 = 0
      NTRCK = 0
      NTREL = 0
16002 CONTINUE
        ITRBT = HDATA(IP0)
      DO 13004 JTOF=1,7
      IF(
     - LAND(MKTRBT(JTOF),ITRBT) .NE. 0
     -)THEN
            ITOF = ITOF0 + JTOF
            JCTOF = (ICTOF(JTOF) + ICLL0)*2 - 1
            LBTRK = 0
      IF(
     - ITOF-ITLST.LE.2
     -)THEN
              HCLL9 = NCTOF(JTOF)*2 + JCTOF - 1
              HCLL1 =-99
              MTRK = 0
      DO 13006 ICLL=HCLL0,HCLL9
      IF(
     - HCLWR(ICLL).GE.6
     -)THEN
                  HDCLL = ICLL - HCLL1
      IF(
     - HDCLL.EQ.1
     -)THEN
                    HCLL1 = -99
      ELSE
      IF(
     - HDCLL.NE.3 .OR. TBIT(ICLL,31)
     -)THEN
                      MTRK = MTRK + 1
                      HCLL1 = ICLL
      ENDIF
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
              IF(MTRK.GE.2) LBTRK = 1
      ELSE
              NHIT5 = 0
              NHIT6 = 0
      IF(
     - JCTOF.LT.0
     -)THEN
                NHIT1 = HCLWR(95)
                NHIT2 = HCLWR(96)
                NHIT3 = HCLWR( 1)
                NHIT4 = HCLWR( 2)
                IF(NHIT2.GE.3 .AND. HCLWR(93).GE.6) NHIT2 = 8
                IF(NHIT4.GE.3 .AND. HCLWR( 3).GE.6) NHIT4 = 8
      ELSE
                NHIT1 = HCLWR(JCTOF  )
                NHIT2 = HCLWR(JCTOF+1)
                NHIT3 = HCLWR(JCTOF+2)
                NHIT4 = HCLWR(JCTOF+3)
      IF(
     - NCTOF(JTOF).EQ.3
     -)THEN
                  NHIT5 = HCLWR(JCTOF+4)
                  NHIT6 = HCLWR(JCTOF+5)
      ELSE
                  IF(NHIT2.GE.3 .AND. HCLWR(JCTOF-2).GE.6) NHIT2 = 8
                  IF(NHIT4.GE.3 .AND. HCLWR(JCTOF+4).GE.6) NHIT4 = 8
      ENDIF
      ENDIF
              IF(MAX0(NHIT1,NHIT2,NHIT3,NHIT4,NHIT5,NHIT6).GE.6) LBTRK=100000185
      ENDIF
      IF(
     - LBTRK.NE.0
     -)THEN
              NTRCK = NTRCK + 1
              ITLST = ITOF
              HCLL0 = JCTOF
              IR = ITOF*2 - 3
      IF(
     - ITOF.EQ.1
     -)THEN
                ILGENG = ILGE(83)+ILGE(  84)+ILGE(   1)+ILGE(   2)
      ELSE
      IF(
     - ITOF.EQ.42
     -)THEN
                  ILGENG = ILGE(82)+ILGE(  83)+ILGE(  84)+ILGE(   1)
      ELSE
                  ILGENG = ILGE(IR)+ILGE(IR+1)+ILGE(IR+2)+ILGE(IR+3)
      ENDIF
                IF(ILGENG.GT.1000) NTREL = NTREL + 1
      ENDIF
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
      ICLL0 = ICLL0 + 8
      ITOF0 = ITOF0 + 7
      IP0   = IP0   + 1
      IF(.NOT.(
     - IP0.GT.IP9
     -))GOTO 16002
16003 CONTINUE
      LB1TCL = 0
      IF(
     - NTRCK.EQ.1 .AND. NTREL.EQ.0
     -)THEN
        IPJC2 = IPJETC*2
        NHTR1 = HDATA(IPJC2+27) - HDATA(IPJC2+ 3)
      IF(
     - NHTR1.GT.96 .AND. NHTR1.LT.196
     -)THEN
          CALL SETS(HCLWR(1),0,96,0)
          IP0 = IPJC2 + 100 + HDATA(IPJC2+ 3)
          IP9 = IP0 + NHTR1 - 1
          IWIR0 =-1
      DO 13008 IP=IP0,IP9,4
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            HCLL = ISHFTR(IWIR,3) + 1
            IF(IWIR.NE.IWIR0) HCLWR(HCLL) = HCLWR(HCLL) + 1
            IWIR0 = IWIR
13008 CONTINUE
13009 CONTINUE
          MTRK = 0
          HCLL1 =-99
      DO 13010 ICLL=1,48
      IF(
     - HCLWR(ICLL).GE.6
     -)THEN
              HDCLL = ICLL - HCLL1
      IF(
     - HDCLL.EQ.1
     -)THEN
                HCLL1 = -99
      ELSE
      IF(
     - HDCLL.NE.3 .OR. TBIT(ICLL,31)
     -)THEN
                  MTRK = MTRK + 1
                  HCLL1 = ICLL
      ENDIF
      ENDIF
      ENDIF
13010 CONTINUE
13011 CONTINUE
          IF(MTRK.EQ.2 .OR. MTRK.EQ.3) LB1TCL = 1
      ENDIF
      ENDIF
      IF(NTRCK .EQ.2 .AND. LAND(LBTRBT,64).NE.0) NTRCK = NTRCK - 1
      IF(NTRCK .GE.2) LBTRCK = LBTRCK + 2
      IF(NTRCK .EQ.1 .AND. LAND(LBTRBT,2).NE.0) LBTRCK = LBTRCK + 1
      IF(NTREL .EQ.1) LBTRCK = LBTRCK + 4
      IF(LB1TCL.EQ.1) LBTRCK = LBTRCK + 8
      RETURN
      END

C   24/06/79 C9062401   MEMBER NAME  KALBNK   (JADEGS)      FORTRAN
      SUBROUTINE KALBNK(IUNIT,LENG,IAOUT)
      IMPLICIT INTEGER*2 (H)
      DIMENSION IAOUT(LENG)
      WRITE(IUNIT) LENG,IAOUT
      RETURN
      END

C   09/04/84 504171534  MEMBER NAME  BARSEC   (ZS)          FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BARSEC(FI0,FIOF1,FIOF2,R1,R2,XC,YC,NSEC,DEFI,LLL)
C-----------------------------------------------------------------------
C
C   AUTHOR: S. CARTWRIGHT 10/04/84 :  DRAW CONCENTRIC POLYGONS
C
C
C     DRAW THE BARREL STRUCTURE OF SOME COMPONENTS IN THE JADE DETECTOR
C     BEAM PIPE COUNTERS, TOF COUNTERS, LEADGLASS CYLINDER, Z-CHAMBER
C     AND 1983-.. FORWARD TAGGING APPARATUS.
C
C     ADAPTED FROM SUBROUTINE BARREL TO ENABLE SECTIONS OF THE DOUBLE
C     POLYGON TO BE OMITTED (DEAD SPACES).
C
C     ARGUMENT LIST:
C         FI0          "STARTING" PHI-COORDINATE (CORNER OF POLYGON)
C         FIOF1        STARTING OFFSET (DRAWING WILL START AT FI0+FIOF1)
C         FIOF2        ENDING OFFSET (DRAWING WILL STOP AT FIEND-FI0F2)
C         R1           RADIUS OF INNER POLYGON
C         R2           RADIUS OF OUTER POLYGON
C         XC,YC        COORDINATES FOR CENTRE OF POLYGONS (USUALLY 0,0)
C         NSEC         NUMBER OF SECTORS TO BE DRAWN
C         DEFI         ANGLE SUBTENDED BY ONE SECTOR (TWOPI/NSIDES)
C         LLL          LINE PATTERN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CJTRIG / PI,TWOPI
C
C------------------  C O D E  ------------------------------------------
C
C                            DEFINE A ZEROTH POINT
C
      CFIOF1 = COS(FIOF1+FI0)
      SFIOF1 = SIN(FIOF1+FI0)
      X2     = XC + R1*CFIOF1
      Y2     = YC + R1*SFIOF1
      X3     = XC + R2*CFIOF1
      Y3     = YC + R2*SFIOF1
      FISX   = FI0
C
C                             DRAW SHAPE IN PHI SECTORS
C
          NSEC1 = NSEC - 1
      DO  10  I = 1,NSEC1
           X0   = X2
           Y0   = Y2
           X1   = X3
           Y1   = Y3
           FISX = FISX + DEFI
           CSFX = COS(FISX)
           SNFX = SIN(FISX)
           X2   = XC + R1*CSFX
           Y2   = YC + R1*SNFX
           X3   = XC + R2*CSFX
           Y3   = YC + R2*SNFX
C
           CALL DRAMOV(X2,Y2,X0,Y0,LLL)
C
C                             SELECT NORMAL OR DASHED LINE DISPLAY
C
           IF( LLL .EQ. 0 ) GO TO 5
               CALL DASHA(X1,Y1,LLL)
               CALL DASHA(X3,Y3,LLL)
           GO TO 10
C
  5        CALL DRAWA(X1,Y1)
           CALL DRAWA(X3,Y3)
 10   CONTINUE
C
C                            DRAW THE LAST SECTOR
C
      CFIOF2 = COS(FISX+DEFI-FIOF2)
      SFIOF2 = SIN(FISX+DEFI-FIOF2)
      X0     = X2
      Y0     = Y2
      X1     = X3
      Y1     = Y3
      X2     = XC + R1*CFIOF2
      Y2     = YC + R1*SFIOF2
      X3     = XC + R2*CFIOF2
      Y3     = YC + R2*SFIOF2
      CALL DRAMOV(X2,Y2,X0,Y0,LLL)
      IF( LLL .EQ. 0 ) GO TO 15
          CALL DASHA(X1,Y1,LLL)
          CALL DASHA(X3,Y3,LLL)
          CALL DASHA(X2,Y2,LLL)
      GO TO 20
 15   CALL DRAWA(X1,Y1)
      CALL DRAWA(X3,Y3)
      CALL DRAWA(X2,Y2)
 20   RETURN
      END

C   12/03/84 406221905  MEMBER NAME  CALAD    (S)           FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C   THIS SUBROUTINE RECALIBRATES ADC'S USING FACTORS IN
C  COMMON CALIBR
C
C INPUT - IWRITE - IF THIS IS EQUAL TO ONE THE ROUTINE
C                  WRITES OUT SOME DEBUGGING INFORMATION
C
C  A.J.FINCH 6/10/83
C  LAST MOD :   J. NYE  24/05/83  TIDIED UP
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE CALAD(IWRITE)
C
C
       IMPLICIT INTEGER * 2 (H)
#include "cdata.for"
C
#include "cwktag.for"
C
#include "calibr.for"
C
       DIMENSION FACTOR(64)
C
       DATA ICOUNT / 0 /
       DATA IDONT  / 0 /
C
C
C------------------------- C O D E -------------------------------------
C
C
C---                                     TEST FOR MONTE CARLO DATA
C---                                     - DONT CALIBRATE IF MC
C
       IF ( IMC .EQ. 1 ) GOTO 15
C
C
C===DEBUG  START=========================DEBUG  START===================
C
       IF ( IWRITE .NE. 1 ) GOTO 9
          WRITE(6,610)
          WRITE(6,605 ) CATAG
  610     FORMAT(1X,'CATAG ARRAY BEFORE RECALIBRATION ')
C
C===DEBUG  END===========================DEBUG  END=====================
C
C
C
C
C---                                     GET POINTER TO CALIBRATION
C---                                     CONSTANTS IN COMMON/CALIBR/
C
    9  IPOINT = 2 * ICALIB(12)
C
C---                                    ON FIRST CALL ONLY - CHECK
C---                                     CALIB CONSTANTS ARE SENSIBLE
C
       IF ( ICOUNT .EQ. 0 ) GOTO 8
       ICOUNT = 1
C
C                                        THIS LOOP ON FIRST EVENT ONLY
C
       DO 108 I = ISTMZ,IENDPZ
          J = IPOINT + I
          FACT = 0.01 * HCALIB(J)
          IF (  (FACT .LT. 0) .OR. (FACT .GT. 10.0) ) IDONT = 1
  108  CONTINUE
C
       IF ( IDONT .EQ. 1 ) WRITE(6,608)
  608  FORMAT(/,/,1X,'WARNING FROM TAGGING ANALYSIS ROUTINE -CALAD-',
     *        /,/,1X,'****   ILLEGAL CALIBRATION CONSTANT',
     *               ' FOUND IN FIRST CALL   ****')
C
C
C--------------------------------------- READ FACTORS FROM CALIBR
C
    8  CONTINUE
       IF ( IDONT .EQ. 1 ) GOTO 11
C
C
       DO 10 I = ISTMZ,IENDPZ
          J = IPOINT + I
          CATAG (I) = 0.01 * HCALIB(J) * CATAG(I)
          FACTOR(I) = 0.01 * HCALIB(J)
   10  CONTINUE
C
   11  CONTINUE
       IF ( IWRITE .NE. 1 ) RETURN
C
C
C
C
C--------------------------------------- D E B U G   O N L Y -----------
C
C
C
       IF ( IDONT .EQ. 0 ) WRITE(6,600)
       IF ( IDONT .EQ. 0 ) WRITE(6,605 ) FACTOR
       IF ( IDONT .EQ. 1 ) WRITE(6,607)
       IF ( IDONT .EQ. 1 ) WRITE(6,611)
       WRITE(6,606)
       WRITE(6,605 ) CATAG
  600  FORMAT(1X,'CALIBRATION CONSTANTS IN CALAD ')
  606  FORMAT(1X,'CATAG ARRAY AFTER RECALIBRATION ')
  605  FORMAT(6(/,8(2X,F8.2) ) )
  607  FORMAT(/,1X,'MESSAGE FROM CALAD --- NO RECALIBRATION OF TAGGING',
     *             ' DATA IS BEING PERFORMED ')
  611  FORMAT(1X,'  BECAUSE ILLEGAL CALIBRATION CONSTANTS WERE FOUND',
     *           ' IN FIRST EVENT')
C
       RETURN
C
C
C
C--------------------------------------- MONTE CARLO DEBUG -------------
C
C
15    CONTINUE
      IF ( IWRITE .EQ. 1 ) WRITE(6,607)
      IF ( IWRITE .EQ. 1 ) WRITE(6,612)
 612  FORMAT(1X,'  BECAUSE THIS IS MONTE CARLO DATA ')
      RETURN
      END

C   11/01/79 008141207  MEMBER NAME  TOFCOR                 FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFCOR
C
C         MATCHING BETWEEN THE TOF COUNTERS AND
C         THE PARTICLE TRAJECTORIES DEFINED
C         BY THE INNER DETECTORS.
C         CODED AT 07.11.78
C         CHANGED AT 3.3.1980 BEATE NAROSKA
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
       DIMENSION IRAW(5,42)
       EQUIVALENCE (IRAW(1,1),RAW(1,1))
C
       DATA PAI/3.1415927/,RTOF/920./
       DATA XPAI/.14960/,SQRAD/.36742/,DSTAN/.01/
      DATA IBUG/50/
C
C=========   ININTIALIZATION OF CORRESPONDENCE TABLE
C
      IBUG = IBUG + 1
       CALL SETSL(ICRT1,0,42*20,0)
       CALL SETSL(ICRT2,0,200,0)
C
C---------------------------------------------------------------------
C   SEARCH TRACKS HITTING A PARTICULAR COUNTER,THAT HAD EITHER EXACTLY
C   ONE TRACK EXTRAPOLATING TO IT OR NONE
C---------------------------------------------------------------------
C
       DO 1000 NCNT=1,42
C=========   COUNTER(NCNT) WAS HIT OR NOT
       IF(IRAW(1,NCNT).LE.0) GO TO 1000
       NC1=NCNT-1
       IF(NCNT.EQ.1) NC1=42
       NC2=NCNT+1
       IF(NCNT.EQ.42) NC2=1
C
C==========   ONE HIT IN THIS COUNTER
C
       IF(ITRK(2,NCNT).NE.1) GO TO 300
C
C
 200        ICNT= ICRT1(2,NCNT) + 1
            ICRT1(2,NCNT)= ICNT
            ICRT1(1,NCNT)= NCNT
            JTRK= ITRK(3,NCNT)
            ICRT2(JTRK)= NCNT
            ICRT1(ICNT+2,NCNT)= JTRK
            GO TO 1000
C
C  NO TRACK EXTRAPOLATES TO THIS COUNTER
C  LOOK FOR A TRACK WITHIN MLTPLE SCATTERING RESOLUTION
C
 300  IF(ITRK(2,NCNT).NE.0) GO TO 1000
      DO   350   N=1,2
      NC1 = NCNT-1+(N-1)*2
      IF(NC1.LT.1) NC1 = NC1 + 42
      IF(NC1.GT.42) NC1 = NC1 - 42
      PH1= (FLOAT(NCNT)-3./2.)*XPAI
      IF(N.EQ.2) PH1= PH1 + XPAI
      IF(PH1.LT.0.) PH1= PH1+2.*PAI
            MTRK=ITRK(2,NC1)
            PHMN=100.
            IF(MTRK.EQ.0) GO TO 350
            IF(IRAW(1,NC1).LE.0) GO TO 310
C  IF ADJACENT COUNTER WAS SET TAKE ONLY CASES WITH TWO OR MORE TRACKS
            IF(MTRK.EQ.1) GO TO 350
            IF(MTRK.GT.3) MTRK = 3
C SEARCH CLOSEST TRACK TO THE LOWER EDGE OF THE COUNTER
 310             DO 320 I=1,MTRK
                 K= ITRK(I+2,NC1)
                 DPH= ABS(TRK(2,K)-PH1)
                 IF(DPH.GE.PHMN) GO TO 320
                 PHMN= DPH
                 KTR= I
                 KCN= NC1
 320             CONTINUE
      IF(PHMN.GE.1.)  GOTO 350
C
      IF(IBUG.LE.20) PRINT 502,NCNT,KCN,KTR,PHMN
  502 FORMAT('  NO HIT IN',2I5,' TRACK ',I5,F10.2)
C COMPUTE ANGLE OF TRACK TO THE HIT COUNTER FROM THE SCATTERING
C CENTER AT R = 841 MM(OUTER TANK)
C     DL = PHMN*RTOF
C     PHSC = DL/80.
C CALCULATE MLTPL SCATTERING DEV ASSUMING PART IS A PION
C     DSCAT = DSTAN
      JTRK= ITRK(KTR+2,KCN)
C     PMEV = ABS(TRK(4,JTRK))*1000.
C     IF(PMEV.LT..050)  GOTO 30
C     BETA = PMEV/SQRT(PMEV**2+140.**2)
C     DSCAT = 15./PMEV/BETA*SQRAD
C     DSCAT = AMIN1(DSCAT,DSTAN)
      IF(IBUG.LE.20) PRINT 501,JTRK,NCNT,KCN,PHMN
   30 IF(PHMN.GT..03) GO TO 350
  501 FORMAT(/' TOFCOR ', 3I5,54F10.3)
C
C  CHECK QUALITY OF TOF DETERMINATION
      CALL TOFBRA(NCNT,JTRK,IFLG)
      IF(IBUG.LE.20) PRINT 501,IFLG
      IF(IFLG.NE.1)  GOTO  350
C FOUND A MATCHING TRACK
            ICNT= ICRT1(2,NCNT)+1
            ICRT1(2,NCNT)= ICNT
            ICRT2(JTRK)= NCNT
            ICRT1(1,NCNT)= NCNT
            IF(ICNT.GE.4) GO TO 1000
            ICRT1(ICNT+2,NCNT)= JTRK
      GOTO  1000
  350 CONTINUE
 1000  CONTINUE
C
C-----------------------------------------------------------------------
C ASSIGN COUNTERS WITH MULTIPLE HITS AND TRACKS THE CORRESPONDING
C LATCH OF WHICH WAS NOT SET
C-----------------------------------------------------------------------
C
            DO 2000 LTRK=1,NTRK
            IF(ICRT2(LTRK).GT.0) GO TO 2000
            NCN= ITRC(LTRK)
            IF(NCN.GE.1.AND.NCN.LE.42) GO TO 1050
            ICRT2(LTRK)= -1
            GO TO 2000
 1050       CONTINUE
C
C=========   MANY HITS IN A COUNTER
C
            IF(IRAW(1,NCN).LE.0) GO TO 1500
                 MTRK=ITRK(2,NCN)
                 IF(MTRK.GE.4) GO TO 1200
                 IF(MTRK.LE.1) GO TO 1500
                      MTRK1=MTRK+2
                      DO 1100 I=3,MTRK1
                      IF(LTRK.EQ.ITRK(I,NCN)) GO TO 1200
 1100                 CONTINUE
                      GO TO 1500
 1200            ICNT=ICRT1(2,NCN)+1
                 ICRT1(2,NCN)=ICNT
                 ICRT2(LTRK)= NCN
                 ICRT1(1,NCN)= NCN
                 IF(ICNT.GE.4) GO TO 2000
                 ICRT1(ICNT+2,NCN)=LTRK
                 GO TO 2000
 1500      CONTINUE
C
C=========   LATCH WAS NOT SET
C    LOOK IN ADJACENT COUNTERS
C
           DO 1700 I=1,2
           NC1=NCN-1+2*(I-1)
           IF(NCN.EQ.1.AND.I.EQ.1) NC1=42
           IF(NCN.EQ.42.AND.I.EQ.2) NC1=1
           IF(IRAW(1,NC1).LE.0) GO TO 1700
                PH1=(FLOAT(NCN)-3./2.)*XPAI
                IF(I.EQ.2) PH1=PH1+XPAI
                IF(PH1.LE.0.) PH1=PH1+2.*PAI
                DPH=ABS(TRK(2,LTRK)-PH1)
      IF(IBUG.LE.20) PRINT 503,LTRK,NCN,NC1,DPH
  503 FORMAT(' TRACK',I5,' HITS ',I5,' TRY CNTR ',I5,F10.2)
C     DL = DPH*RTOF
C     PHSC = DL/80.
C CALCULATE MLTPL SCATTERING DEV ASSUMING PART IS A PION
C     DSCAT = DSTAN
C     PMEV = ABS(TRK(4,LTRK))*1000.
C     IF(ABS(PMEV).LT..050)  GOTO  40
C     BETA = PMEV/SQRT(PMEV**2+140.**2)
C     DSCAT = 15./PMEV/BETA*SQRAD
      IF(IBUG.LE.20) PRINT 501,LTRK,NCN,NC1,DPH
C     DSCAT = AMIN1(DSCAT,DSTAN)
   40 IF(DPH.GT..03) GO TO 1700
C  CHECK QUALITY OF TOF DETERMINATION
      CALL TOFBRA(NC1,LTRK,IFLG)
      IF(IBUG.LE.20) PRINT 501,IFLG
      IF(IFLG.NE.1)  GOTO  1700
           ICNT=ICRT1(2,NC1)+1
           ICRT1(2,NC1)=ICNT
           ICRT2(LTRK)= NC1
           ICRT1(1,NC1)= NC1
           IF(ICNT.GE.4) GO TO 2000
           ICRT1(ICNT+2,NC1)= LTRK
           ICRT2(LTRK)= NC1
           ICRT1(1,NC1)= NC1
           GO TO 2000
 1700      CONTINUE
C
 2000  CONTINUE
           RETURN
           END

C   19/08/87 804221601  MEMBER NAME  ZE4VET   (S)           FORTRAN77
      SUBROUTINE ZE4VET( NPZE4V, NPKTRK, JCAND, ESHM )
C-----------------------------------------------------------
C  VERSION OF 18/08/87                          E ELSEN
C  PERFORM ELECTRON ANALYSIS FOR SINGLE TRACK SPECIFIED
C  BY NPKTRK IN ZE4V
C  INPUT:
C     NPZE4V  BOS POINTER TO ZE4V BANK
C     NPKTRK  ABSOLUTE POINTER TO TRACK IN ZE4V BANK
C  OUTPUT:
C     JCAND = 0  IF ELECTRON CANDIDATE
C           =    FIRST NONZERO EKAND RETURN CODE
C                NOT ALL CONDITIONS MAY HAVE BEEN CHECKED
C     ESHM  = CORRECTED LG SHOWER ENERGY (MEIER)
C             ONLY FILLED FOR JCAND = 0
C
C  RECORD OF CHANGES
C  22/04/88  NDEDX NOW FROM ZE4V
C            FULL TRACK RANGE CHECKED          E E
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
      DIMENSION IRKL(2,50)
      EQUIVALENCE(IRKL(1,1),TRKL(1,1))
      COMMON / CONNEC / ICON,SUMPI,CONC(3,10)
      COMMON / CONNEP / ICOP,CONP(5,30),SUPH(5)
C                                           SHORT FORM ONLY
      COMMON / CERECU / ICUT,
C  CUT VALUES
     + ISCUT,ICHCUT,COSCUT,PCUT,NDCUT,RSCUT,IDVERS,DLOCUT,DHICUT,DFLCUT,
     + DFHCUT,SUMCUT,ENECUT,PCHCUT,ESHCUT,JEVERS,EPCUT,EPHCUT,AMICUT
C
      REAL*4 RVTX(3), PACT(3), RDOCA(3)
      INTEGER ONE / 1 /
      LOGICAL LDEDX
      INTEGER LEVEL1 / 0 /, LEVEL2 / 0 /, LEVEL3 / 0 /
      LOGICAL FIRST / .TRUE. /
      EXTERNAL EKAND
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IPPATR = IBLN('PATR')
        CALL LGINIT
        CALL FJHBIT( ICUT )
C                                           STATE ALL CUTS HERE AS
C                                           THEY ARE APPLIED AT THE
C                                           DIFFERENT LEVELS
C                                           CUTS BEFORE LEVEL 1
        LEVEL1 = LOR(LEVEL1,SHFTL(ONE, 2))
        LEVEL1 = LOR(LEVEL1,SHFTL(ONE, 3))
        LEVEL1 = LOR(LEVEL1,SHFTL(ONE, 4))
        LEVEL1 = LOR(LEVEL1,SHFTL(ONE, 5))
        LEVEL1 = LOR(LEVEL1,SHFTL(ONE, 6))
        LEVEL1 = LOR(LEVEL1,SHFTL(ONE, 7))
        LEVEL1 = LOR(LEVEL1,SHFTL(ONE,12))
C                                           CUTS BEFORE LEVEL 2
        LEVEL2 = LOR(LEVEL2,SHFTL(ONE,11))
        LEVEL2 = LOR(LEVEL2,SHFTL(ONE,14))
C                                           CUTS BEFORE LEVEL 3
        LEVEL3 = LOR(LEVEL3,SHFTL(ONE, 8))
        LEVEL3 = LOR(LEVEL3,SHFTL(ONE, 9))
        LEVEL3 = LOR(LEVEL3,SHFTL(ONE,19))
        LEVEL3 = LOR(LEVEL3,SHFTL(ONE,20))
C
        LEVEL1 = LAND(ICUT,LCOMPL(LEVEL1))
        LEVEL2 = LAND(LEVEL1,LCOMPL(LEVEL2))
        LEVEL3 = LAND(LEVEL2,LCOMPL(LEVEL3))
      ENDIF
C
C
      JCAND = 0
C                         CUTS BASED ON ZE4V
      IF( NPZE4V.GT.0 ) THEN
        ITPF = HW(NPKTRK*2+18)
        IF( ITPF .EQ. 1 ) THEN
          LT = HW(NPZE4V*2 + 5)
          PTOT = RW(NPKTRK+6)
          ABSCOS = ABS(RW(NPKTRK+3))
          DEDX = RW(NPKTRK+LT+9)
          SDEDX = RW(NPKTRK+LT+10)
          NDEDX = HW((NPKTRK+LT)*2+25)
          RSDEDX = SDEDX/AMAX1(0.001,DEDX)
          IF( NDEDX .GT. 0 ) THEN
            IF( IDVERS .EQ. 1 ) THEN
              LDEDX = DEDX.LT.10.-DLOCUT*SDEDX.OR.
     *              DEDX.GT.10.+DHICUT*SDEDX
            ELSEIF( IDVERS .EQ. 2 ) THEN
              LDEDX = DEDX.LT.DFLCUT.OR.DEDX.GT.DFHCUT
            ELSE
              LDEDX = .FALSE.
            ENDIF
          ELSE
            LDEDX = .FALSE.
          ENDIF
          IPAR = HW(NPKTRK*2+7)
          JTRK = HW((NPKTRK+LT)*2+9)
          DO 30 I=1,3
   30     RVTX(I) = RW(NPZE4V+31+I)
C
          IF( ABSCOS.GT.COSCUT )        JCAND = LOR(JCAND,SHFTL(ONE, 2))
          IF( PTOT.LT.PCUT )            JCAND = LOR(JCAND,SHFTL(ONE, 3))
          IF( NDEDX.LT.NDCUT )          JCAND = LOR(JCAND,SHFTL(ONE, 5))
          IF( RSDEDX.GT.RSCUT )         JCAND = LOR(JCAND,SHFTL(ONE, 6))
          IF( LDEDX )                   JCAND = LOR(JCAND,SHFTL(ONE, 7))
          IF( IPAR.GT.0 )               JCAND = LOR(JCAND,SHFTL(ONE,12))
          JCAND = LAND( ICUT, JCAND )
C
          IF( JCAND .EQ.0 .AND. LEVEL1.NE.0 ) THEN
            CALL EAZERO
            CALL EALGCL( JTRK, ESHM )
            IF( ESHM .GT. 0 ) THEN
              SHADFR = AMAX1(0.011, ENEW/EBITER )
              IF( LOG10(SHADFR).GT.ESHCUT )
     *                                  JCAND = LOR(JCAND,SHFTL(ONE,11))
              JCAND = LAND( ICUT, JCAND )
              IF( JCAND .EQ. 0 .AND. LEVEL2.NE.0 ) THEN
                CALL EAUNIN( JTRK )
                SULPI = SUMPI/ESHM
                IF( SUMPI.GT. .3 ) THEN
                  ESHSUB = ESHM-0.08*SUMPI
                ELSE
                  ESHSUB = ESHM
                ENDIF
                IF( JEVERS .EQ. 1 ) THEN
                  VEREL = AMAX1(0.01,ESHSUB/PTOT)
                ELSE
                  VEREL = AMAX1(0.01,ESHM/PTOT)
                ENDIF
                SULH2 = SUPH(2)/ESHM
                IF( SULPI.GT.SUMCUT )   JCAND = LOR(JCAND,SHFTL(ONE, 8))
                IF( SULH2.GT.ENECUT )   JCAND = LOR(JCAND,SHFTL(ONE, 9))
                IF( VEREL.LT. EPCUT )   JCAND = LOR(JCAND,SHFTL(ONE,19))
                IF( VEREL.GT. EPCUT )   JCAND = LOR(JCAND,SHFTL(ONE,20))
                JCAND = LAND( ICUT, JCAND )
C
                NPPATR = IW(IPPATR)
                IF( JCAND.EQ.0 .AND. LEVEL3.NE.0 ) THEN
                  IF( NPPATR.GT.0 .AND.
     *                0.LT.JTRK .AND. JTRK.LE.IW(NPPATR+2) ) THEN
                    J = NPPATR + IW(NPPATR+1) + IW(NPPATR+3)*(JTRK-1)
                    CALL CRDOCA( J, RW(NPZE4V+32), PACT, RDOCA, CHARGE )
                    PTRANS = SQRT( PACT(1)**2+PACT(2)**2)
                    ZVER = RVTX(3)
                    ICLUR = 0
                    CALL CHIEN5( JTRK, PTRANS, ESHM, ZVER, CHARGE,
     *                           CHI2N, PCHI2, ICLUR )
                    IF( ICLUR.GT.0 ) THEN
                      IF( 2 .LE. ICHCUT )
     *                                  JCAND = LOR(JCAND,SHFTL(ONE, 2))
                    ELSEIF( PCHI2.LT.PCHCUT ) THEN
                                        JCAND = LOR(JCAND,SHFTL(ONE,10))
                    ENDIF
                  ELSE
                    JCAND =                     LOR(JCAND,SHFTL(ONE, 4))
                  ENDIF
                ENDIF
              ENDIF
            ELSE
                                        JCAND = LOR(JCAND,SHFTL(ONE,14))
              IF( 1 .LE. ICHCUT )       JCAND = LOR(JCAND,SHFTL(ONE, 2))
            ENDIF
          ENDIF
        ELSE
          JCAND =                               LOR(JCAND,SHFTL(ONE, 4))
        ENDIF
      ELSE
        JCAND =                                 LOR(JCAND,SHFTL(ONE,26))
      ENDIF
      JCAND = LAND( ICUT, JCAND )
      END

C   07/06/96 606071906  MEMBER NAME  QPEAK    (S4)          FORTG1
      SUBROUTINE QPEAK(NA,KA,Q)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL FC(50),YS(100),YU(100)
      REAL R(3),S(3),RES(18,2)
      REAL Q(10,3),RE(4)
      DO 4 I=1,10
      DO 4 J=1,3
    4 Q(I,J)=0.0
      IF(KA.LT.0) GOTO 100
      CALL BLOC(IND,'PEA*',NA,&100)
      KAMAX=IW(IND+8)
      IF(KA.GT.KAMAX) GOTO 100
      AW=RW(IND+5)
      ST=RW(IND+6)
      NB  =IW(IND+7)
      INDK=IND+10+KA*(NB+2)
      SUMI=0.0
      DO 5 K=1,NB
      YU(K)=RW(INDK+K)
    5 SUMI=SUMI+RW(INDK+K)
      Q(1,1)=SUMI+RW(INDK+NB+1)+RW(INDK+NB+2)
      IF(SUMI.EQ.0.0) GOTO 100
C
C
      CALL ANLSIM(YU,YS,NB,RE)
      IF(RE(4).GT.3.0) GOTO 10
      Q(3,1)=RE(2)
      Q(4,1)=RE(3)
      Q(2,1)=1.0
      Q(9,1)=RE(1)
      Q(10,1)=SQRT(RE(1))
      GOTO 20
   10 CALL SMHIST(YU,YS,DY,NB,0)
      CALL ANLDET(YS,NB,Q)
   20 Q(1,1)=SUMI+RW(INDK+NB+1)+RW(INDK+NB+2)
      JJ=Q(2,1)+0.5
      DO 30 J=1,JJ
      Q(3,J)=AW+ST*(Q(3,J)-0.5)
      DO 30 I=4,6
   30 Q(I,J)=ST*Q(I,J)
  100 RETURN
      END

      SUBROUTINE PATREC(IDRENT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      COMMON /CHEADR/ IHEADR(54)
      DIMENSION HEARR(200)
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 0
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
        IQJETC = IBLN('JETC')
        IQHEAD = IBLN('HEAD')
      ENDIF
      IPHEAD=IDATA(IQHEAD)
      IF(IPHEAD.GE.1) CALL MVCL(IHEADR(1),0,IDATA(IPHEAD-3),0,216)
      CALL PATRC1(IDRENT)
      IF(
     - NTR.GT.0
     -)THEN
      DO 13000 IMO=1,NTR
          HEARR(IMO)=IMO
13000 CONTINUE
13001 CONTINUE
        ITRK=NTR
        NTRLM = 0
        CALL KNTREL(HEARR,ITRK)
      ENDIF
      RETURN
      END

C   25/06/78 708272040  MEMBER NAME  ENELS    (S)           FORTRAN
      FUNCTION ENELS(E)
C
C THIS FUNCTION GIVES THE RESTRICTED IONIZATION LOSS, I.E. ENERGY LOSS
C UP TO A PREASSIGNED VALUE. THIS VALUE IS GIVEN BY /M0PAR/CUTM, WHICH
C IS SET IN MCIN56 TO 0.5 (MEV). THE FORMULA IS NR (60) IN STERNHEIMER,
C P.R.B (1971) 3681.
C NOTE THAT THIS IS NOT COMPLETELY TRUE, THE TERM -2BETA**2 SHOULD BE
C  ONLY -BETA**2 IN THIS FORMULA
C
C  NOTE THAT THE INPUT ENERGY COMES IN UNITS OF ME, I.E. == GAMMA,
C  THEREFORE     BETA**2 = 1 - 1/E**2
C  LN2 = .69315
C  CON = LN(P/MC) = LN(M BETA GAMMA/M) = LNE + .5 * LN(BETA**2)
C
C  COMMON/ILPAR/ IS SET IN PARST2, CALLED BY INTSHW
C
      COMMON/ILPAR/AI,BI,ALCUTM
      BE2=1.-1./E**2
      IF(BE2.LE.0.)GOTO10
      CON=ALOG(E)+ALOG(BE2)/2.
      ENELS=AI*(BI+0.69315+2.*CON+ALCUTM-2.*BE2
     @         -DENDEL(0.434294*CON))/BE2
C FUNCTION DENDEL CALCULATES DENSITY EFFECT CORRECTION.
      RETURN
 10   ENELS=0.
      RETURN
      END

C   25/06/78            MEMBER NAME  COMPT    (LGSOURCE)    FORTRAN
      SUBROUTINE COMPT(ENE,GAM,EPSI)
      COMMON /SFCPA/SF,SFE
      EP0=1./(1.+2.*ENE)
      XR=RN(DAM)
      EPSI=EP0*EXP(GAM*XR)
      IF(EPSI.GE.1.)GOTO31
      XR=RN(DAM)
      EK2=ENE**2
      G=(1.+EPSI*(EK2-2.*ENE-2.+EPSI*(1.+2.*ENE+EK2*EPSI)))/
     @        (2.*EPSI*EK2)
      IF(SF*XR-G)30,30,31
 30    RETURN
 31    EPSI=0.
      RETURN
      END

C   05/11/82 311221845  MEMBER NAME  DETHRY   (S)           FORTRAN
       FUNCTION DETHRY(PMOM)
C
C           RETURNS 'THEORETICAL' VALUE OF JADE DEDX FOR GIVEN
C        MOMENTUM PMOM, ASSUMING A PION MASS.
C        THE 'THEORETICAL' VALUES IN THE TABLE HAVE BEEN FOUND
C        USING A. WAGNER'S THEORETICAL-EMPIRICAL FUNCTION 'DEDXTH'.
C        THE FUNCTION IS BASED ON A MODIFIED STERNHEIMER TREATMENT.
C
C                                                  J.A.J.SKARD, 14/8/83
C
C        FUNCFL IS A FLAG TO DETERMINE WHETHER TO USE AN INTERPOLATION
C        OF THE TABLE VALUES, OR THE FUNCTION DEDXTH DIRECTLY.
C
C        ********   SR POLINT ON CERNLIB   ********
C
      LOGICAL FUNCFL/.TRUE./
C        EXPERIMENTAL VALUE FOR DE/DX AT MINIMUM
      DATA DEMIN/7.2/
C        ORDER OF POLYNOMIAL APPROXIMATION IN POLINT IS NORDR-1
       DATA NORDR/3/
       DIMENSION P(40),D(40)
       DATA P/0.009,.01,.02,.03,.04,.04463,.05,.06,.07,.08,
     1        .0848,.09,.1,.104,.119,.1339,.149,.2,.253,.3,
     2        .4,.5,.6,.7,.8,.9,1.,2.,3.,4.,
     3        6.,8.,10.,20.,30.,60.,100.,200.,300.,600./
       DATA D/
     1      1375.,1118.,283.3,129.1,75.12,61.46,50.16,36.59,28.43,23.14,
     2      21.24,19.52,16.93,16.10,13.71,12.10,10.95,8.856,7.952,7.567,
     3      7.252,7.199,7.224,7.273,7.330,7.390,7.449,7.919,8.227,8.451,
     4      8.771,8.978,9.108,9.435,9.577,9.746,9.823,9.879,9.893,9.899/
      IF(FUNCFL)GO TO 50
       DO 10 K=1,39
       IF(PMOM .LT. P(K)) GOTO 20
10     CONTINUE
20     IF(K .LT. 2) K=2
       CALL POLINT(D(K-1),P(K-1),NORDR,PMOM,DD)
       DETHRY=DD
       RETURN
C        USE THEORETICAL-EMPIRICAL FUNCTION DIRECTLY
50    BETGAM=PMOM/0.139
      BET=BETGAM/SQRT(1.0+BETGAM*BETGAM)
      GAM=BETGAM/BET
C     IF(BETGAM.LE.0..OR.GAM.LE.0..OR.BET.LE.0.) WRITE(6,999)
C    *       BETGAM,GAM,BET,PMOM
C 999 FORMAT(' *** DETHRY: BETGAM,GAM,BET,PMOM:',4E12.4)
      DETHRY=THDEDX(BET,GAM,DEMIN)
      RETURN
       END

C   31/10/76 C9070301   MEMBER NAME  UWP      (JADEGS)      FORTRAN
      SUBROUTINE UWP(BIN,NA,NB)
C *---------------------------------------------------------
C *
C * VERSION OF 02/07/79    LAST 02/07/79    E.ELSEN
C * UWP VERSION DISTINGUISHING BETWEEN I*4 AND I*2
C * ACCORDING TO VALUE OF I*4 WORD
C *---------------------------------------------------------
C
      REAL*4 BIN(2)
      REAL*8 FMT(13),FMTF/'  F12.4,'/,FMTG/'  G12.4,'/,
     1     FMTI/'    I12,'/,FMTA/'  8X,A4,'/,FMT1/'        '/,
     2     FMT2/'(11X,   '/,FMTI2/'  2I6,  '/
      INTEGER NEQ/0/,LIM(2,8)
      LOGICAL*1 LFMT(96),LL(8),LAST/')'/
      DATA FMT(1)/'(1X,I5, '/,FMT(2)/''' -'',I3,'/
      DATA LIM/75,80,91,97,107,111,123,136,
     1     193,201,209,217,226,233,240,249/
      EQUIVALENCE(FMT(1),LFMT(1)),(LL(1),REQ),(LL(5),NEQ)
      REAL*8 FMZ(11)
      EQUIVALENCE (FMT(3),FMZ(1))
      DIMENSION JOBUF(20),ROBUF(20)
      INTEGER*2 HELP(2)
      EQUIVALENCE (HELP(1), IHELP, RHELP),(ROBUF(1),JOBUF(1))
      DATA IWOLI / 10 /
C
C
C     PURPOSE
C        PRINT ARRAY WITH AUTOMATIC SELECTION OF INTEGER,
C        FLOATING POINT OR TEXT FORMAT FOR EACH WORD ACCORDING
C        TO CONTENT
C
C     USAGE       --- -- --
C        CALL UWP(BIN,NA,NB)
C
C        PRINTS ARRAY BIN(NA) . . . BIN(NB)
C
C                 -- -- ----
C        CALL UTP(VS,IT,TEXT)
C
C        PRINTS ARRAY VS(2) IN A-FORMAT AND FOR IT.GT.0 THE
C        ARRAY TEXT(1) . . . TEXT(IT) IN A-FORMAT   (IT.LE.10)
C
C        CALL UPP
C
C        NEW PAGE
C
      IUWU=0
    1 IF(NA.GT.NB) GOTO 100
      IZERO=0
      NF=((NA-1)/IWOLI)*IWOLI+1
      N=NB+1-NF
      DO 60 I=NF,NB,IWOLI
      IA=I
      IB=MIN0(I+IWOLI-1,NB)
      IF(IUWU.EQ.0) GOTO 8
      IF(IB.EQ.NB) GOTO 4
      DO 2 J=IA,IB
      IF(BIN(J).NE.0) GOTO 4
    2 CONTINUE
      IF(IZERO.EQ.0) IZERO=IA
      GOTO 60
    4 IF(IZERO.EQ.0) GOTO 8
      WRITE(6,103) IZERO
      IZERO=0
    8 M=3
      JO = 0
      DO 50 J=IA,IB
      REQ=BIN(J)
      M=M+1
      JO = JO + 1
      LA=0
      DO 20 K=1,4
      LL(8)=LL(K)
      IF(NEQ.EQ.64) GOTO 20
      DO 10 L=1,8
      IF(NEQ.LT.LIM(1,L)) GOTO 40
      IF(NEQ.GT.LIM(2,L)) GOTO 10
      IF(L.LE.4) LA=LA+1
      GOTO 20
   10 CONTINUE
      GOTO 40
   20 CONTINUE
      IF(LA.GT.2) GOTO 40
      ROBUF(JO) = BIN(J)
      FMT(M)=FMTA
      GOTO 50
   40 IF(ABS(REQ).GT.1.E20.OR.ABS(REQ).LT.1.E-20) GOTO 30
      IF(ABS(REQ).LT.10000.0.AND.ABS(REQ).GE.0.1) GOTO 45
      ROBUF(JO) = BIN(J)
      FMT(M)=FMTG
      GOTO 50
   45 FMT(M)=FMTF
      ROBUF(JO) = BIN(J)
      GOTO 50
   30 RHELP = BIN(J)
      IF( IHELP .GE. -32768.AND. IHELP .LE. 32767 ) GO TO 35
      JOBUF(JO) = HELP(1)
      JO = JO + 1
      JOBUF(JO) = HELP(2)
      FMT(M) = FMTI2
      GO TO 50
   35 JOBUF(JO) = IHELP
      FMT(M)=FMTI
   50 CONTINUE
      LFMT(8*M)=LAST
      IF(N.LE.IWOLI) GOTO 55
      FMT(3)=FMT1
      JB=MOD(IB,1000)
      WRITE(6,FMT) IA,JB,(ROBUF(II),II=1,JO)
      GOTO 60
   55 FMT(3)=FMT2
      WRITE(6,FMZ) (ROBUF(II),II=1,JO)
   60 CONTINUE
      GOTO 100
C     ENTRY WITH SPPRESSSION OF ZEROS IN SEVERAL LINES
      ENTRY UWU(BIN,NA,NB)
      IUWU=1
      GOTO 1
C
      ENTRY UTP(VS,IT,TEXT)
C
      INTEGER VS(2),TEXT(10)
      IF(IT.LE.0) GOTO 70
      WRITE(6,101) VS,(TEXT(I),I=1,IT)
      GOTO 100
   70 WRITE(6,101) VS
      GOTO 100
C
      ENTRY UPP
C
      WRITE(6,102)
  100 RETURN
  101 FORMAT('0  ',2A4,10(8X,A4))
  102 FORMAT('1')
  103 FORMAT(1X,I5,2X,'AND FOLLOWING ALL ZERO')
      END

C   15/02/82 202151341  MEMBER NAME  TAGF820  (S)           FORTRAN
      SUBROUTINE TAGF82(IFLAG)
C---  TAGF82 IS AN UPDATED VERSION (1982 ONWARDS) OF TAGFLG
C---  TAGF82 CHECKS ONLY THE CONTENT OF WORD 22 IN THE LATC-BANK
C---  TAGF82 RETURNS THE SUM OF THE FOLLOWING NUMBERS VIA IFLAG:
C       0  IF NO LEAD-GLASS OF THE FORWARD DETECTOR IS HIT
C       1  IF THE LEAD-GLASS ENERGY OF THE MINUS Z-SIDE IS ABOVE
C             THRESHOLD (SMZ)
C       2  IF THE LEAD-GLASS ENERGY OF THE PLUS Z-SIDE IS ABOVE
C             THRESHOLD (SPZ)
C      10  IF THE TAGG-LATCH (SMZ.OR.SPZ) IS SET
C     100  IF THE LUMI-LATCH (SMZ.AND.SPZ) IS SET
C
C     H.WRIEDT     15.02.82     13:40
C     LAST MODIFICATION    15.02.82    13:40
C
      EXTERNAL BDLM
C
      COMMON /BCS/ IDATA(30000)
C
      DATA I2/2/,I5/5/,I6/6/,I7/7/,N3/3/
      DATA ICOUNT/0/
C
      IFLAG = 0
      ICOUNT = ICOUNT + 1
C---  FETCH LATC-POINTER
      IND = IDATA(IBLN('LATC'))
      IF (IND.EQ.0) RETURN
C---  FETCH LATC-DATA
C---  LATCH 22
      LAT = IDATA(IND+11)
C---  LUMI-BIT (#5)
      LLAT = JBIT(LAT,I5)
      IF (LLAT.EQ.1) IFLAG = 100
C---  TAGG-BITS (#2 - #4)
      LLAT = JBYT(LAT,I2,N3)
      IF (LLAT.NE.0) IFLAG = IFLAG + 10
C---  SMZ- AND SPZ-BITS
C     SMZ (#6)
      LLAT = JBIT(LAT,I6)
      IF (LLAT.EQ.1) IFLAG = IFLAG+1
C     SPZ (#7)
      LLAT = JBIT(LAT,I7)
      IF (LLAT.EQ.1) IFLAG = IFLAG+2
      RETURN
      END

C   01/02/84 805261724  MEMBER NAME  MUANAF   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUANAF
C-----------------------------------------------------------------------
C
C LAST CHANGE 17.30 24/05/88 J. HAGEMANN - SETUP OF YEAR DEP. CONSTANTS
C      CHANGE 18.30 20/05/88 J. HAGEMANN - SETUP OF YEAR DEP. CONSTANTS
C      CHANGE  9.45 21/04/88 J. HAGEMANN - SETUP OF YEAR DEP. CONSTANTS
C      CHANGE 15.25 20/03/86 CHRIS BOWDERY - MOVE NREGS TEST TO LATER ON
C      CHANGE 16.00  9/03/84 CHRIS BOWDERY - CHECK THAT NREGS > 0
C      CHANGE 14.00 26/01/84 TIM GREENSHAW - MU BANKS LOC. WITH CLOC.
C                      VARIABLE JBANK INTRO. TO IMPROVE ERROR OUTPUT.
C      CHANGE 15.30 18/01/84 TIM GREENSHAW - ERROR PRINTOUT ALTERED
C      CHANGE 15.00 30/05/83 HUGH MCCANN - IF EBGEV = 0. , SET IT TO 50.
C                                          ..... FOR COSMIC RUNS.
C      CHANGE 10.00 24/05/82 HUGH MCCANN - TRIVIAL SPELLING MISTAKE.
C                                          EBGEV NOW CHECKED FOR > 50  .
C      CHANGE 23.00 22/02/82 HUGH MCCANN - FOR IMPROVED ERROR OUTPUT.
C      CHANGE 12.00 04/02/82 HUGH MCCANN -- TO MAKE NTPH=4.
C
C-----------------------------------------------------------------------
C
C THIS ROUTINE FOLLOWS INNER DETECTOR TRACKS TO FIND ASSOCIATED MUON
C   CHAMBER HITS AND STORES RESULTS IN 'MUR2' BANKS 0 - 6.
C NOTE THAT IF NO INNER DETECTOR TRACKS ARE PRESENT ONLY BANK 0 IS
C   CREATED.
C
C NOTE ALSO THAT BANK 0 IS CREATED WHETHER OR NOT ANY MUON HITS EXIST.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C COMMONS.
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C------------START OF MACRO CMUREG--------------------------------------
C
      COMMON /CMUREG/NREGS,XRLO(100),XRHI(100),YRLO(100),YRHI(100),
     * ZRLO(100),ZRHI(100),HRMASK(100),HRFACE(100),HRTYPE(100),
     * HRORI(100),HRFIRS(100),HRLAST(100)
C
C NREGS IS NUMBER OF REGIONS.
C XRLO ETC. ARE REGION BOUNDARIES.
C HRMASK =1 (FACE 1), =2 (FACE 2), =4 (FACE 3), =8 (FACE 4), ETC.
C HRFACE = FACE NUMBER, =1-6 FOR -X,+X,-Y,+Y,-Z,+Z.
C HRTYPE =1, MU CHAMBER SENSITIVE REGION,
C        =2, CONCRETE REGION,
C        =3, IRON REGION,
C        =4, LEAD GLASS. (IRTYPE=4 USED ONLY IN MUFFLD.)
C HRORI  = ORIENTATION OF NORMAL, =1 (|| X), =2 (||Y), =3 (|| Z).
C HRFIRS = FIRST CHAMBER NUMBER.
C HRLAST = LAST CHAMBER NUMBER.
C
C------------END OF MACRO CMUREG----------------------------------------
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C   20/10/81 202041521  MEMBER NAME  CMUFWORK (JADEMUS)     FORTRAN
C   12/10/81 110152138  MEMBER NAME  CMUFWORK (JADEMUS1)    FORTRAN
C-------------START OF MACRO CMUFWORK-----------------------------------
C LAST CHANGED 21.30 15/10/81 HUGH MCCANN  - EXTEND IOVLAP TO ALLOW
C                                            > 10 ASSOC HITS IN MUFFLY.
C LAST CHANGED 10.00 04/10/81 HUGH MCCANN  - FOR USE OF OVERLAP HITS.
C LAST CHANGED 14.46 17/06/81 JOHN ALLISON - TO ADD 'OVER' VARIABLES.
C LAST CHANGED 23.00 09/04/81 HUGH MCCANN - JADEMUS UPDATE.
C
      COMMON /CWORK/X,Y,Z,DCX,DCY,DCZ,P,PSQ,E,ESQ,D,GM,AB,RD,DE,PPIDK,
     *PKDK,PPBPEN,PPPEN,PPIPEN,PKPEN,DUMW1(29),X8,Y8,Z8,DCX8,DCY8,
     *DCZ8,P8,PSQ8,E8,ESQ8,D8,GM8,AB8,RD8,DE8,PPIDK8,PKDK8,PPBPE8,
     *PPPEN8,PPIPE8,PKPEN8,DUMW28(29),X0,Y0,Z0,DCX0,DCY0,DCZ0,P0,PSQ0,
     *E0,ESQ0,D0,GM0,AB0,RD0,DE0,PPIDK0,PKDK0,PPBPE0,PPPEN0,PPIPE0,
     *PKPEN0,DUMW2(29),X9,Y9,Z9,DCX9,DCY9,DCZ9,P9,PSQ9,E9,ESQ9,D9,GM9,
     *AB9,RD9,DE9,PPIDK9,PKDK9,PPBPE9,PPPEN9,PPIPE9,PKPEN9,DUMW29(29),
C-----200 WORDS UP TO HERE----------------------------------------------
     *X1,Y1,Z1,X2,Y2,Z2,XMID,YMID,ZMID,X3,Y3,Z3,D1,D2,D3,DTC,DUMW3(4),
     *DSTEP,GMSTEP,ABSTEP,RDSTEP,DESTEP,DUMW4(15),ADCZ,COSEC,STPINI,CURV
     *,DANG,DX,DY,DZ,R,RSQ,PT,DPINA,DKNA,DUMW5(7),VX,VY,VZ,RMSXY,RMSZ,
     *VTXYD,VTZD,VTXYAN,VTZANG,VMSANG,VMSD,CMS,DUMW6(8),SDS(10),DUMW7(1000002000
C
C    *SDX,SDY,SDZ,SDTXYD,SDTZD,SDTXYA,SDTZAN,SDMSAN,SDMSD,SDCMS,DM7(10),
C
C NOTE ABOVE CARD SHORTENED TO SDS(10),DUMW7(10), SO THAT STATEMENT DOES
C   NOT EXCEED 19 CONTINUATION CARDS.  I THINK SD--'S ARE NOT USED.
     *),CHISQT,NDFT,CHIPRT,CHISTL,NDFTL,CHIPTL,NBADCH,DUMW8(13),IDTRK,
     *NCEPTS,NTHIS,INEFF,NHLAYR,INFLAG,NELIPS,NGLAYR,DUMW9(72),IREG(200)
C-----600 WORDS UP TO HERE----------------------------------------------
     *,RDOTD(200),CINT(3,200),NFLAG(200),ITEM(200),EM(30,30),DALONG(10),
C-----2710 WORDS UP TO HERE---------------------------------------------
     *DEV(30),VXYDA(10),VZDA(10),CXYA(10),CZA(10),INCUT(30),BADA(30),G(200003100
     *0,20),DEVA(20),IPERM(10),MWORK(20),ITHISA(10),IJA(10),EM1(20,20),E
     *MG(20,20),ELIPSE(700),INCHAM(10),INREG(10),IAPPRO(30),HBADCH(1000)
     *,CTDASH(10),CLDASH(10),VTDASH(10),VLDASH(10),IHTREG(20),LAYRAB,IEF
C-----5421 WORDS UP TO HERE---------------------------------------------
     *FRG(10),DUMW10(69),AAA(10),BBB(10),CCC(10),DDD(10),DOVER,GMOVER,AB
     *OVER,RDOVER,DEOVER,DUMW11(55),X7(50),IHTP(30),IOVLAP(20,20)
C-----6080 WORDS UP TO HERE---------------------------------------------
      DIMENSION ILIPSE(700)
      INTEGER*2 HLIPSE(1400)
      DIMENSION IHTPER(10),IHTEMP(10),IPTEMP(10)
      EQUIVALENCE (ILIPSE(1),HLIPSE(1),ELIPSE(1))
      EQUIVALENCE (IHTP(1) ,IHTPER(1)),
     *            (IHTP(11),IHTEMP(1)),
     *            (IHTP(21),IPTEMP(1))
      LOGICAL INCUT,BADA
C
C-----------------------------------------------------------------------
C
C THE FIRST 50 LOCATIONS ARE RESERVED FOR SPECIAL WORKING VARIABLES.
C THE NEXT 150 LOCATIONS ARE RESERVED FOR COPIES OF THESE SPECIAL
C    VARIABLES, IF, E.G., ONE WISHES TO PRESERVE THEIR VALUES AT
C    THE BEGINNING OF A STEP.
C THE COPIES HAVE A SUFFIX 0 FOR VALUES AT LAST ASSOCIATED HIT.
C THE COPIES HAVE A SUFFIX 7 FOR VALUES AFTER LEAD-GLASS BARREL OR
C    YOKE END-PLUG (X7 IS LATER IN COMMON - SEE BELOW).
C THE COPIES HAVE A SUFFIX 8 FOR VALUES AT LAST BUT ONE GOOD
C    CHAMBER LAYER.
C THE COPIES HAVE A SUFFIX 9 FOR VALUES AT LAST GOOD CHAMBER LAYER.
C NSPECI (SET IN BLOCK DATA BEHIND MUFFLE) IS THE NUMBER OF SUCH
C    VARIABLES ACTUALLY USED.
C
C SPECIAL VARIABLES....
C
C X,Y,Z       = CURRENT COORDINATES.
C DCX,DCY,DCZ = CURRENT DIRECTION COSINES OF TRACK.
C P,PSQ       = CURRENT MOMENTUM (AND ITS SQUARE).
C E,ESQ       = CURRENT ENERGY (AND ITS SQUARE).
C D           = CURRENT DISTANCE FROM VERTEX (MM).
C GM          = MATERIAL TRAVERSED TO CURRENT POSITION (GM CM**-2).
C AB          = ABSORPTION LENGTHS SO FAR.
C RD          = RADIATION LENGTHS SO FAR.
C DE          = ENERGY LOSS (GEV).
C PPIDK       = PROBABILITY OF PION DECAYING TO MUON BEFORE INTERACTING.
C PKDK        = PROBABILITY OF KAON DECAYING TO MUON BEFORE INTERACTING.
C PPBPEN      = ANTI-PROTON ) ( PENETRATION PROBABILITY, I.E. PROBAB-
C PPPEN       = PROTON      ) ( ILITY OF NOT BEING ABSORBED BY A NUCLEUS
C PPIPEN      = PI          ) ( AND NOT DECAYING.  SEE SUBROUTINE
C PKPEN       = K           ) ( MUFFLS FOR FURTHER DETAILS.
C
C-----------------------------------------------------------------------
C
C THE NEXT 200 LOCATIONS ARE RESERVED FOR VARIABLES THAT DO NOT NEED
C    SPECIAL PRESERVATION.
C
C OTHER VARIABLES...
C
C X1,Y1,Z1    = COORDS OF 1ST POINT ON TRACK.
C X2,Y2,Z2    = COORDS OF LAST POINT ON TRACK.
C XMID,YMID,ZMID = COORDS OF MID POINT ON TRACK.
C X3,Y3,Z3    = COORDS OF POINT WHERE TRACK LEAVES MAGNETIC FIELD.
C D1          = DISTANCE TRAVELLED TO (X1,Y1,Z1).
C D2          = DISTANCE TRAVELLED TO (X2,Y2,Z2).
C D3          = DISTANCE TRAVELLED TO (X3,Y3,Z3).
C DTC         = DISTANCE TRAVELLED TO MID-POINT OF TRACK.
C
C DSTEP       = STEP LENGTH THIS STEP (FOR MUFFLU) (MM).
C GMSTEP      = MATERIAL THIS STEP (GM CM**-2).
C ABSTEP      = ABSORPTION LENGTHS THIS STEP.
C RDSTEP      = RADIATION LENGTHS THIS STEP.
C DESTEP      = ENERGY LOSS OF MINIMUM IONISING PARTICLE THIS STEP,
C
C ADCZ        = ABS(DCZ)
C COSEC       = ABS(COSEC(THETA)), WHERE THETA IS ANGLE TO BEAM.
C STPINI      = STEP LENGTH IN INITIAL TRACKING TO COIL OR END PLUG.
C CURV        = CURVATURE FROM 'PATR' BANK.
C DANG        = ANGLE OF TURN FOR EACH STEP.
C DX,DY,DZ    = CHANGES OF X,Y,Z.
C R,RSQ       = DISTANCE FROM BEAM (RADIUS) AND ITS SQUARE.
C PT          = MOMENTUM COMPONENT PERPENDICULAR TO BEAM.
C DPINA       = INTEGRAL OF (DECAY LENGTH)*(PROBABILTY OF NOT INTER-
C                 ACTING) FOR PION. (NO LONGER USED. CAN BE RESURECTED
C DKNA        = SIMILARLY FOR KAON. (BY UN-COMMENTING IN MUFFLS.
C
C VX,VY,VZ    = CURRENT VARIANCES ON X,Y,Z.
C RMSXY       = RMS DEV. NORMAL TO CHORD IN XY FIT.     )
C RMSZ        = RMS Z DEV. IN RZ FIT.                   ) FROM
C VTXYD       = VARIANCE ON DEVIATION NORMAL TO         ) TRACK
C                 TRACK IN XY PLANE AT TRACK CENTRE.    ) RECON-
C VTZD        = VARIANCE ON DEVIATION NORMAL TO         ) STRUCTION
C                 TRACK IN RZ PLANE AT TRACK CENTRE.    ) ERRORS.
C VTXYAN      = VARIANCE ON ANGLE IN XY PLANE (PHI)     )
C VTZANG      = VARIANCE ON ANGLE IN RZ PLANE (THETA)   )
C VMSANG      = VARIANCE OF MULTIPLE SCATTERING ANGLE.
C VMSD        = VARIANCE OF MULTIPLE SCATTERING DEVIATION NORMAL TO
C                 TRACK.
C CMS         = COVARIANCE OF ABOVE TWO QUANTITIES.
C SD--        = CORRESPONDING STANDARD DEVIATIONS (SQUARE ROOTS).
C
C CHISQT      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFT        = NUMBER OF DEGREES OF FREEDOM.           ) (DRIFT)
C CHIPRT      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C CHISTL      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFTL       = NUMBER OF DEGREES OF FREEDOM.           ) & LONG'L
C CHIPTL      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C NBADCH      = NO. OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C
C IDTRK       = INNER DETECTOR TRACK NUMBER.
C NCEPTS      = NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS       = NUMBER OF MUON HITS ASSOCIATED WITH PROJECTED INNER
C                DETECTOR TRACK.
C INEFF       = NUMBER OF INEFFICIENCIES IN MUON SYSTEM FOUND THIS TRACK
C NHLAYR      = NUMBER WHICH REPRESENTS NUMBER OF MUON LAYERS WITH
C                ASSOCIATED MUON HITS. ADD 1 FOR THE INNER LAYER AND
C                2 FOR EACH SUBSEQUENT LAYER.
C INFLAG      = 1 IF LAST LAYER INTERCEPTED WAS INEFFICIENT.
C NELIPS      = NUMBER OF MULTIPLE SCATTERING ELIPSES ENTERED IN ELIPSE.
C NGLAYR      = AS NHLAYR, BUT FOR 'GOOD' LAYERS WHETHER THERE WAS AN
C                ASSOCIATED HIT OR NOT.
C
C-----------------------------------------------------------------------
C
C THE NEXT 1400 LOCATIONS USED BY MUREGY (CALCULATES REGION INTERCEPTS).
C
C IREG        = REGION NUMBER.                           )(IN PAIRS,I.E.
C RDOTD       = R.DOT.(DIR. COSINES) FOR EACH INTERCEPT. )( 2 INTERCEPTS
C CINT        = X,Y,Z COORDINATES OF EACH INTERCEPT.     )( PER REGION.
C NFLAG       = USED INTERNALLY BY MUREGY.
C ITEM        = USED INTERNALLY BY MUREGY.
C
C-----------------------------------------------------------------------
C
C THE NEXT 3600 LOCATIONS USED BY MUFFLE, ETC., TO ACCUMULATE
C   QUANTITIES NEEDED FOR CALCULATING CHI-SQUARED. IN THE DESCRIPTION
C   BELOW I,J GO AS FOLLOWS..
C     1   LEFT DRIFT COORDINATE    )  OF 1ST
C     2   RIGHT DRIFT COORDINATE   )  ASSOCIATED
C     3   LONGITUDINAL COORDINATE  )  HIT
C     4    ETC. FOR NEXT ASSOCIATED HIT.
C   K REFERS TO K'TH ASSOCIATED HIT.
C
C EM(I,J)     = 'ERROR MATRIX', I.E. VARIANCE (I=J) OR COVARIANCE (I.NE.
C                J) FOR COORDINATE I,J.
C DALONG(K)   = DISTANCE OF ASSOCIATED HIT K ALONG TRACK.
C DEV(I)      = DEVIATION OF COORDINATE I FROM EXTRAPOLATED INNER
C                DETECTOR TRACK.
C VXYDA(K)    = VARIANCE ON DEVIATION IN XY PLANE FOR HIT K.
C VZDA(K)     = VARIANCE ON DEVIATION IN RZ PLANE FOR HIT K.
C CXYA(K)     = COVARIANCE BETWEEN DEVIATION AND ANGLE IN XY PLANE.
C CZA(K)      = COVARIANCE BETWEEN DEVIATION AND ANGLE IN RZ PLANE.
C INCUT(I)    = .TRUE. IF COORDINATE I IS IN CUT (SEE MUFFLY).
C BADA(I)     = .TRUE. IF COORDINATE I IS BAD.
C G           = INVERSE ERROR MATRIX.
C DEVA        = CORRESPONDING DEVIATIONS.
C IPERM(K)    = USED TO PERMUTE LEFT/RIGHT AMBIGUITIES.
C MWORK       = USED BY MATRIX INVERTING ROUTINE AS WORKING SPACE.
C ITHISA(K)   = HIT NUMBER OF K'TH ASSOCIATED HIT.
C IJA(K)      = INDEX FOR K'TH ASSOCIATED HIT FOR ENTRY IN BANKS 2 & 3.
C EM1         = COPY OF RELEVANT PART OF ERROR MATRIX FOR TEST PURPOSES.
C EMG         = PRODUCT OF ERROR MATRIX AND ITS INVERSE. SHOULD BE UNIT
C                MATRIX. USED FOR TEST PURPOSES.
C ELIPSE      = TEMPORARY STORAGE FOR MULTIPLE SCATTERING ELIPSES.
C INCHAM      = LIST OF INEFFICIENT CHAMBERS ON THIS TRACK.
C INREG       = LIST OF INEFFICIENT REGIONS (PLANES) ON THIS TRACK.
C IAPPRO      = USED AS WORKING SPACE IN MUFFLX.
C HBADCH      = LIST OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C CTDASH(K)   = TRANSVERSE COORD. ESTIMATED FROM I.D. PROJECTION.
C CLDASH(K)   = LONGITUD'L COORD. ESTIMATED FROM I.D. PROJECTION.
C VTDASH(K)   = VARIANCE ON CTDASH.
C VLDASH(K)   = VARIANCE ON CLDASH (FOR K'TH ASSOCIATED HIT).
C
C-----------------------------------------------------------------------
C
C THE NEXT  380 LOCATIONS USED FOR VARIOUS IMPROVEMENTS TO MUFFLE, ETC.
C
C IHTREG      = FOR EACH ASSOCIATED HIT, THE REGION NO. IN WHICH
C               THE HIT OCCURS.
C LAYRAB      = ABSOLUTE NO. OF LAYERS WHICH HAVE ASSOCIATED HITS.
C IEFFRG      = LIST OF REGION NOS. OF THOSE REGIONS WHICH HAVE AN
C               ASSOCIATED HIT.
C   IHTPER = FLAG FOR EACH ASSOCIATED HIT TO TELL IF IT'S TO
C            GO FORWARD INTO THE CHI**2 CALCULATION . ONLY ONE
C            HIT PER LAYER IS TO BE USED ,APART FROM OVERLAP HITS.
C   IHTEMP = LIST OF HITS WHICH ARE TEMPORARILY IN THE HIT PERMUTATION
C            DUE TO OVERLAPS WITH THE CURRENT AMBIGUITYOF ONE OF THE
C            HITS IN IHTPER.
C   IPTEMP =  AS IHTEMP, BUT FOR L/R AMBIGUITIES.
C IOVLAP   =  MATRIX OF OVERLAP HITS. IOVLAP(I,J)=1 MEANS THAT THERE
C             IS AN OVERLAP BETWEEN ASSOCIATED HITS I & J ( I & J BOTH
C             IN THE RANGE 1 TO NTHIS ).
C AAA(K)      = TRANSFORMATION COEFF. A FOR K'TH ASSOCD. HIT.
C BBB(K)      = TRANSFORMATION COEFF. B FOR K'TH ASSOCD. HIT.
C CCC(K)      = TRANSFORMATION COEFF. C FOR K'TH ASSOCD. HIT.
C DDD(K)      = TRANSFORMATION COEFF. D FOR K'TH ASSOCD. HIT.
C
C DOVER, ETC. = STORES QUANTITIES LEFT OVER AFTER LEAVING LAST ABSORBER.
C
C X7          = VALUES OF SPECIAL VARIABLES AFTER LEAD-GLASS BARREL OR
C               YOKE END-PLUG - USED FOR RE-FITTING, ETC.
C
C-------------END OF MACRO CMUFWORK-------------------------------------
C----------- START OF MACRO CMUSTAT ------------------------------------
C   LAST CHANGE 12.47 15/06/79 JOHN ALLISON.
C      /CMUSTT/
C
      COMMON / CMUSTT / MUTIT(100),NMU(100)
      REAL*8 MUTIT, MUT1(50), MUT2(50)
      EQUIVALENCE(MUTIT(1),MUT1(1)),(MUTIT(51),MUT2(1))
C
C  NMU ARE USED FOR STATISTICS COUNTING IN THE MUON ROUTINES
C
C------------ END OF MACRO CMUSTAT -------------------------------------
C   20/10/81 408081453  MEMBER NAME  CMUFFL   (S)           FORTRAN
C
C LAST CHANGE 15.00 08/08/84 - CKB PWA     - ADD NALLWM,PMXFLG
C      CHANGE 15.00 03/12/83 - HUGH MCCANN - NEW LEAD GLASS PARAMETERS.
C      CHANGE 08.00 12/10/81 - HUGH MCCANN - TO ADD OVLCUT(FOR OVERLAPS)
C      CHANGE 09.33 17/06/81 - JOHN ALLISON - TO ADD RESOLUTIONS.
C
C-------------START OF MACRO CMUFFL-------------------------------------
C
      COMMON / CMUFFL / XYSTEP,RCOILI,RCOILO,PGMID,WMU,WMUSQ,DUMF1(4),
     +                  NSPECI,XPBAR,XPROT,XPION,XKAON,DUMF2(5),
     +                  TBP,GMBP,ABBP,RDBP,DEBP,
     +                  TJETI,GMJETI,ABJETI,RDJETI,DEJETI,
     +                  TJET1,GMJET1,ABJET1,RDJET1,DEJET1,
     +                  TJET2,GMJET2,ABJET2,RDJET2,DEJET2,
     +                  TJET4,GMJET4,ABJET4,RDJET4,DEJET4,
     +                  TJETO,GMJETO,ABJETO,RDJETO,DEJETO,
     +                  TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL,
     +                  ZJETE,TJETE,GMJETE,ABJETE,RDJETE,DEJETE,
     +                  ZEPLG,TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG,
     +                  RLG,ZLG,TLG,GMLG,ABLG,RDLG,DELG,
     +                  ZEP,TEP,GMEP,ABEP,RDEP,DEEP,
     +                  GMG(3),ABG(3),RDG(3),DEG(3),
     +                  VDRES,VLRES,
     +                  REST1,REST2,RESTMX,RESL,RESLMX,FACTOR,OVLCUT,
     +                  ZLGHAF,TLGHAF,ZLGC,GMLGC,ABLGC,RDLGC,DELGC,
     +                  NALLWM,PMXFLG
C
C FOR EXPLANATION SEE BLOCK DATA AFTER SUBROUTINE MUFFLE.
C
C--------------END OF MACRO CMUFFL--------------------------------------
C
      COMMON / CMUIEV / IEV,NEV,IRD,KRUN,KREC,
     *                  ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON / CMUPTC / XEXTRP,YEXTRP,ZEXTRP,VTZCV,LCOVAR,SIGFXY,SIGFCZ
C
C-----------------------------------------------------------------------
C
C DATA INITIALISATION STATEMENTS.
C
      DATA NWMUR/38/
C NWMUR IS NUMBER OF WORDS PER INNER DETECTOR TRACK IN 'MUR2' BANK 1.
      DATA NTPH/4/
C NTPH IS NUMBER OF TRACKS PER HIT ALLOCATED IN 'MUR2' BANKS 2 AND 3.
      DATA NPL/5/
C NPL IS NUMBER OF POINTS PER EXTRAPOLATED INNER DET. TRACK IN BANK 4.
      DATA IYEARO / -1111 /
C
      LOGICAL FIRST / .TRUE. /
      IF( .NOT. FIRST ) GO TO 4711
        FIRST = .FALSE.
        WRITE(6,9101)
 9101   FORMAT(' +++ MUANAF SPECIAL VERSION OF 24/05/88...')
 4711 CONTINUE
C IYEARO IS YEAR OF LAST EVENT
C
C-----------------------------------------------------------------------
C
C FIND MAGNETIC FIELD FROM HEADER.
      IP=IDATA(IBLN('HEAD'))
      BGAUSS=HDATA(2*IP+30)
C FIND BEAM ENERGY - IN GEV!!!!!!
      EBGEV=EBEAM(HDATA(2*IP+10))/1000.
C  COSMIC RUNS HAVE ZERO BEAM ENERGY .  SET EBGEV TO 50. IN THAT CASE.
      IF(EBGEV.EQ.0.)EBGEV=50.
C
C  TEST THAT BEAM ENERGY IS BETWEEN 1.0 AND 50.0 GEV .
      IEBGEV=INT(EBGEV)
      IF(EBGEV.LT.1..OR.EBGEV.GT.50.)
     *CALL MUERRY('MUANAF',IEBGEV,' = BEAM ENERGY !!^')
      NTRKS=0
C
C  SETUP OF YEAR DEPENDENT CONSTANTS (DETECTOR STATUS 79-83, 84-86)
C
      IF( IYEAR .EQ. IYEARO ) GOTO 1
C                            SETTINGS FOR MONTE CARLO
         IYEARO = IYEAR
C                                           THE ACTUAL VALUES FOR MC:
C        SIGFCZ = 1.11+-0.04    FOR IYEAR<86
C        SIGFCZ = 1.26+-0.05    FOR IYEAR=86
C                                           BUT USE 1 FOR CLARITY
         SIGFXY = 1.0
         SIGFCZ = 1.0
         REST1  = 3.7
         REST2  =  6.5
         IF( KRUN .LE. 100 ) GOTO 101
C                            SIGFAC FOR DATA 79-84
            SIGFXY = 1.43
            SIGFCZ = 1.57
C                            CHAMBER RESOLUTION FOR DATA BEFORE 1984
            REST1  = 3.0
            REST2  = 6.0
 101     IF( IYEAR .GT. 1983 ) GOTO 102
C                            DETECTOR STATUS BEFORE 1984
            GMBP = 1.77
            ABBP = 0.0176
            RDBP = 0.0741
            DEBP = 2.86E-3
C
            GMJETO = 4.99
            ABJETO = 0.0497
            RDJETO = 0.2076
            DEJETO = 8.08E-3
C
            GOTO 1
 102     CONTINUE
C                            DETECTOR STATUS AFTER 1983
            GMBP = 1.39
            ABBP = 0.0139
            RDBP = 0.0580
            DEBP = 2.25E-3
C
            GMJETO = 6.49
            ABJETO = 0.0646
            RDJETO = 0.2701
            DEJETO = 10.5E-3
C
            IF( KRUN .LE. 100 ) GOTO 1
C                            CHAMBER RESOLUTION FOR DATA 1985
               REST1  = 7.5
               REST2  = 11.5
C                            SIGFAC FOR DATA OF 1985
               SIGFCZ = 1.31
               IF( IYEAR .NE. 1986) GOTO 1
C                            CHAMBER RESOLUTION FOR DATA OF 1986
                  REST1  = 6.7
                  REST2  = 9.5
C                            SIGFAC FOR DATA OF 1986
                  SIGFXY = 1.56
                  SIGFCZ = 1.40
C
C
C-----------------------------------------------------------------------
C
C FIND 'PATR' POINTER.
C
 1    CONTINUE
      IPPATR=IDATA(IBLN('PATR'))
      IF(IPPATR.LE.0)GO TO 3
      NTRKS=IDATA(IPPATR+2)
      NWTRK=IDATA(IPPATR+3)
      ISTART=IDATA(IPPATR+1)+1
C
C-----------------------------------------------------------------------
C
C FIND MUON COORDINATE BANK.
C
 2    CONTINUE
C
C   BANK NUMBERS OF MUR1 BANKS IN JBANK, OF MUR2 BANKS IN IBANK.
C
      JBANK=0
      CALL CLOC(IMUR10,'MUR1',JBANK)
C
C IF MUR1 DOES NOT EXIST ( IN PRINCIPLE NOT POSSIBLE, IF MUANAC IS USED)
C THEN GOT TO 3.
C
      IF(IMUR10.LE.0)GO TO 3
C

C PICK UP NO. OF HITS.
C
      NHITS=IDATA(IMUR10+1)
C
C PICK UP NO. OF WORDS PER HIT.
C
      NWHIT=IDATA(IMUR10+3)
C
C PICK UP COORDINATE BANK, 'MUR1' BANK 1.
C
      JBANK=1
      CALL CLOC(IMUR11,'MUR1',JBANK)
C
C  NO MUR1/1 BANK FOR THIS EVENT IMPLIES THAT MU-FILTER WAS NOT
C  OPERATIONAL, OR SIGNAL-COORDINATE CONVERSION HAS NOT BEEN DONE .
C  OR MAYBE MUON TRACKING WAS NOT DONE IF THIS IS MONTE CARLO.
C  BUT WANT TO MAKE MUR2/0 ANYWAY.
C
      IF(IMUR11.LE.0)GO TO 3
C
C PICK UP HIT STATUS BANK, 'MUR1' BANK 2.
C
      JBANK=2
      CALL CLOC(IMUR12,'MUR1',JBANK)
C
C-----------------------------------------------------------------------
C
C CREATE 'MUR2' RESULTS BANKS.
C
 3    CONTINUE
C
C ADD 'MUR2' TO SPECIAL LIST READY FOR WRITING.
C
      CALL BSAW(1,'MUR2')
      IBANK=0
      CALL CCRE(IMUR20,'MUR2',IBANK,4,IER)
      IF(IER.NE.0)GO TO 96
      IDATA(IMUR20+1) = NTRKS
      IDATA(IMUR20+2) = NWMUR
      IDATA(IMUR20+3) = NTPH
      IDATA(IMUR20+4) = NPL
C
      IF( NREGS .LE. 0 ) GO TO 94
C
      IF(IPPATR.LE.0)GO TO 98
C
      IF(IMUR10.LE.0)GO TO 97
C
      IF(IMUR11.LE.0.OR.IMUR12.LE.0)GO TO 975
C
      IF(NTRKS.LE.0)GO TO 99
C
C MAIN RESULTS BANK.
C
      IBANK=1
      CALL CCRE(IMUR21,'MUR2',IBANK,NTRKS*NWMUR,IER)
      IF(IER.NE.0)GO TO 96
C
C HIT-TRACK CORRELATION BANK.
C
      IBANK=2
      CALL CCRE(IMUR22,'MUR2',IBANK,(NTPH*NHITS+1)/2,IER)
      IF(IER.NE.0)GO TO 96
C
C HIT-TRACK AMBIGUITY BANK.
C
      IBANK=3
      CALL CCRE(IMUR23,'MUR2',IBANK,(NTPH*NHITS+1)/2,IER)
      IF(IER.NE.0)GO TO 96
C
C EXTRAPOLATED TRACK POINTS BANK.
C
      IBANK=4
      CALL CCRE(IMUR24,'MUR2',IBANK,3*NPL*NTRKS,IER)
      IF(IER.NE.0)GO TO 96
C
C-----------------------------------------------------------------------
C
C TRY IT. (HERE FOLLOWS THE INTRODUCTION TO MUFFLE FOR REFERENCE.)
C     SUBROUTINE MUFFLE(IPATR,APATR,NTRKS,NWTRK,
C    * BGAUSS,
C    * HC,NHITS,NWHIT,
C    * HLUN,
C    * IMUR,AMUR,NWMUR,
C    * HTC,HAMB,NTPH,
C    * EXTRA,NPL,EBEAM)
C
C     IMPLICIT INTEGER*2 (H)
C
C     DIMENSION IPATR(1),APATR(1),
C    * HC(1),
C    * HLUN(1),
C    * IMUR(1),AMUR(1),
C    * HTC(1),HAMB(1),
C    * EXTRA(1)
C
C-----------------------------------------------------------------------
C
C IPATR,APATR IS PATT. REC. DATA (SEE JADE COMP. NOTE 12, 23/2/79.)
C NTRKS IS NUMBER OF TRACKS.
C NWTRK IS NUMBER OF WORDS PER TRACK.
C BGAUSS IS MAGNETIC FIELD IN GAUSS.
C HC CONTAINS MUON HIT COORDINATES.
C NHITS IS THE NUMBER OF MUON HITS.
C NWHIT IS NUMBER OF WORDS PER HIT IN HIT COORDINATE ARRAY.
C HLUN IS HIT STATUS ARRAY.
C IMUR,AMUR IS MU-RESULTS 'MUR2' BANK 1 - FILLED BY MUFFLE.
C NWMUR IS NUMBER OF WORDS PER INNER DTECTOR TRACK IN 'MUR2' BANK 1.
C HTC IS HIT-TRACK CORELLATION ARRAY - FILLED BY MUFFLE.
C HAMB IS AMBIGUITY FLAG FOR EACH ENTRY IN HTC.
C NTPH IS NUMBER OF TRACKS PER HIT ALLOCATED IN HTC.
C EXTRA STORES THE POINTS ON THE EXTRAPOLATED TRACK.
C NPL IS THE NUMBER OF POINTS PER EXTRAPOLATED TRACK.
C EBEAM IS THE BEAM ENERGY IN GEV.
C
      CALL MUFFLE(IDATA(IPPATR+ISTART),IDATA(IPPATR+ISTART),
     * NTRKS,NWTRK,
     * BGAUSS,
     * IDATA(IMUR11+1),NHITS,NWHIT,
     * IDATA(IMUR12+1),
     * IDATA(IMUR21+1),IDATA(IMUR21+1),NWMUR,
     * IDATA(IMUR22+1),IDATA(IMUR23+1),NTPH,
     * IDATA(IMUR24+1),NPL,EBGEV)
C
C-----------------------------------------------------------------------
C
C NOW ADD BANK 5, THE MULTIPLE SCATTERING ELIPSES.
C
      IBANK=5
      CALL CCRE(IMUR25,'MUR2',IBANK,NELIPS,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(ELIPSE,IDATA(IMUR25+1),NELIPS)
C
C-----------------------------------------------------------------------
C
C NOW ADD BANK 6, THE BAD CHAMBER LIST.
C
      NBADCH=0
      DO 6 I=1,NCHAMS
      IF(HMCSTA(I).EQ.0)GO TO 6
      NBADCH=NBADCH+1
      HBADCH(NBADCH)=I
 6    CONTINUE
      IF(MOD(NBADCH,2).NE.0)HBADCH(NBADCH+1)=0
      IBANK=6
      NBADC2=(NBADCH+1)/2
      CALL CCRE(IMUR26,'MUR2',IBANK,NBADC2,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(HBADCH,IDATA(IMUR26+1),NBADC2)
C
C-----------------------------------------------------------------------
C
      GO TO 99
C
C-----------------------------------------------------------------------
C
C ERROR CONDITIONS.
C
 94   CALL MUERRY('MUANAF',0,'MU ANALYSIS ABORTED - NO MU REGIONS FOUND.
     + NO CALIBRATION?^')
      GO TO 99
C
 95   CALL MUERRY('MUANAF',IBANK,' = I, NOT ENOUGH SPACE FOR ''MUR2/I''.
     +^')
      GO TO 99
C
 96   IF(IER.GT.1)GO TO 95
      CALL MUERRY('MUANAF',IBANK,' = I, ''MUR2/I'' ALREADY PRESENT.^')
      GO TO 99
C
 97   NMU(10)=NMU(10)+1
      CALL MUERRY('MUANAF',JBANK,' = I, ''MUR1/I'' NOT LOCATED. HAS MUAN
     +AC BEEN CALLED?^')
      GO TO 99
C
 975  IF (NHITS .LE. 0) GO TO 99
      NMU(4) = NMU(4) + 1
      CALL MUERRY('MUANAF',JBANK,' = I, ''MUR1/I'' EXPECTED BUT MISSING,
     + SERIOUS ERROR.^')
      GO TO 99
C
 98   CALL MUERRY('MUANAF',0,'''PATR'' NOT LOCATED.^')
      NTRKS=0
      GO TO 3
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
      RETURN
      END

C   07/06/96 606071828  MEMBER NAME  BPRINT   (S4)          FORTG1
      SUBROUTINE BPRINT(N1,N2,N3)
#include "acs.for"
      COMMON/BCS/IW(1)
#include "ccs.for"
C     TEST PROGRAM
      LOGICAL CURR/.FALSE./
      WRITE(6,101) N1,N2
      IF(CURR) GOTO 10
      CURR=.TRUE.
      WRITE(6,102)
   10 CALL UWP(ICOND,1,80)
      CALL UWU(IW,1,N3)
  100 RETURN
  101 FORMAT('0BPRINT',2I10)
  102 FORMAT('0PRINTOUT OF COMMON/ACS/'/
     112X,' ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,'/
     212X,' NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,'/
     312X,' NHISTH(11),                              '/
     412X,'      NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,'/
     512X,' NER(10),                                 '/
     612X,' NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,'/
     712X,' NHISTL(11),                              '/
     812X,'      MARKWR,NOUT(3),IASW,NPRE,IDUMMY(2),NDUMP1 '/)
      END

C   07/08/79 311041222  MEMBER NAME  MNCOPY   (S)           FORTRAN
      SUBROUTINE MNCOPY
      IMPLICIT INTEGER *2(H)
      COMMON/BCS/IDATA(40000)
      COMMON/POINT/IPHEAD,IPLTCH,IPT1,IPTOF,IPCLST,IPR,IPPATR,IPNT(12),
     1             IPBP
      COMMON/TRKINF/NTRK,DX1(10),DY1(10),DZ1(10),DXL(10),DYL(10),
     1              DZL(10),NXY(10),NRZ(10),CHIXY(10),DRZ(10),CHIRZ(10),
     2              X1(10),Y1(10),Z1(10),XL(10),YL(10),ZL(10),ZVER(10),
     3              NGOOD,IGOOD(10),PMOM(10),FI1(10),FIL(10)
      DIMENSION RDATA(6000),HDATA(12000),PH(10),SIG(3)
      EQUIVALENCE(IDATA(1),RDATA(1)),(HDATA(1),IDATA(1))
      COMMON/PU/ NTOF,NBEAM,IHIT(200),DPHI
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/INOUT/WRITFL,EVWRIT
      LOGICAL WRITFL,EVWRIT
C
      DATA NUN/2/,IONE/1/,ITWO/2/,ITHR/3/,IFOU/4/,IFIV/5/
      DATA ISIX,ISEV,IEIG/6,7,8/
C
      IWRITE =0
      IFILE = 0
      WRITFL = .TRUE.
      CALL BINT(40000,4000,500,0)
      IF(WRITFL) CALL BWRO(3,1558,2)

      NEV = 0
      IRUN = 0
      NEVRUN = 0
      NEVA = 0
      NEVB = 500000
      DO   1   N=1,500000
 77    CONTINUE
      NEV = NEV + 1
      NEVRUN = NEVRUN + 1
      IF(IUHR(5).NE.1)  GOTO  7002
      CALL BSLT
      CALL BDLG
      CALL BREAD(NUN,&1000,&7000)
      IF(NEV.LE.NEVA)  GOTO  2
      IF(NEV.GT.NEVB)  GOTO  7000
      IPHEAD = IDATA(IBLN('HEAD'))
      IF(IPHEAD.LE.0)  GOTO  2000
      NRUN = HDATA(IPHEAD*2+10)
C     IF(NRUN.LT.10265)  GOTO  2
      IF(NRUN.GT.14605)  GOTO  7000
      IEV=HDATA(2*IPHEAD+11)
      IF(NRUN.EQ.IRUN)  GOTO  74
      PRINT 704,NRUN,NEV,NEVRUN,IEV,IWRITE
  704 FORMAT(' NEW RUN AT EVENT ',5I10)
      NEVRUN = 0
   74 IRUN = NRUN
  23  IWRITE = IWRITE+ 1
C     IF(IWRITE.GT.200)  GOTO  7000
      CALL BSLW
      CALL BWRITE(3)
    2 GOTO  1
 3000 PRINT 3010
 3010 FORMAT(' ERROR RETURN FROM TOFINT')
      GOTO  2
 3001 PRINT 3011
 3011 FORMAT(' ERROR RETURN FROM TOFMAS')
      GOTO  2
2000   WRITE(6,2001) IONE,NEV
       GOTO 77
2002   WRITE(6,2001) ITWO,NEV
       GOTO 77
2003   WRITE(6,2001) ITHR,NEV
       GOTO 77
2004   WRITE(6,2001) IFOU,NEV
       GOTO 77
2005   WRITE(6,2001) IFIV,NEV
      GOTO  77
 400   WRITE(6,2001) ISIX,NEV
      GOTO  77
 401   WRITE(6,2001) ISEV,NEV
      GOTO  77
 402   WRITE(6,2001) IEIG,NEV
      GOTO  77
      IMISS = 0
1000   WRITE(6,1001)I
1001   FORMAT(' ERROR IN BREAD  I=',I3)
2001   FORMAT(' ERROR IN BLOC   I=',2I5)
1      CONTINUE
 7002 PRINT 777
      PRINT 777
      PRINT 777
  777 FORMAT('  ********   TIMELIMIT   ********')
7000  WRITE(6,7001)NRUN,IEV,ITYP,NEV
      CALL BMLT(0,DUMMY)
      CALL BWRITE(3)
7001  FORMAT(' LAST RUN',I8,' IEV=',I5,' ITYP=',I3,' NEV=',I5)
      PRINT600,IWRITE
  600 FORMAT(' EVENTS WRITTEN ',I10)
      CALL BSTA
      RETURN
      END

C   28/03/97 703282257  MEMBER NAME  JEOSUM3  (JADE56.S)    FORTRAN
C   28/03/97            MEMBER NAME  JBTJ20   (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPRIV4.NR14
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR57
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     22401     22800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPRIV4.NR14
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR58
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     22801     23200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPRIV4.NR14
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR59
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     23201     23600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPRIV4.NR14
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR60
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     23601     24600    99999
C   28/03/97            MEMBER NAME  JBTJ20D  (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(21,00),CLASS=D
//*MAIN RELPRI=MED
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJ40,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPRIV4.NR12
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//*T02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*  SPACE=(TRK,(80,11),RLSE),DSN=F11OLS.ETAPRI86.NR57
//FT02F001 DD DISP=SHR,
//     DSN=F11OLS.ETAPRI.SUM2
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
         0      3200    99999
C   28/03/97            MEMBER NAME  JBTJ2016 (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR9
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      3201      3600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR10
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      3601      4000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR11
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      4001      4400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR12
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      4401      4800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR13
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      4801      5200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR14
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      5201      5600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR15
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      5601      6000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR16
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      6001      6400    99999
C   28/03/97            MEMBER NAME  JBTJ2024 (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR17
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      6401      6800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR18
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      6801      7200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR19
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      7201      7600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR20
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      7601      8000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR21
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      8001      8400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR22
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      8401      8800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR23
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      8801      9200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR24
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      9201      9600    99999
C   28/03/97            MEMBER NAME  JBTJ2032 (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR25
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      9601     10000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR26
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     10001     10400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR27
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     10401     10800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR28
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     10801     11200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR29
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     11201     11600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR30
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     11601     12000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR31
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     12001     12400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR32
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     12401     12800    99999
C   28/03/97            MEMBER NAME  JBTJ2040 (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR33
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     12801     13200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR34
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     13201     13600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR35
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     13601     14000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR36
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     14001     14400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR37
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     14401     14800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR38
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     14801     15200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR39
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     15201     15600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR40
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     15601     16000    99999
C   28/03/97            MEMBER NAME  JBTJ2048 (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR41
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     16001     16400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR42
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     16401     16800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR43
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     16801     17200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR44
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     17201     17600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR45
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     17601     18000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR46
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     18001     18400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR47
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     18401     18800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR48
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     18801     19200    99999
C   28/03/97            MEMBER NAME  JBTJ2056 (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR49
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     19201     19600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR50
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     19601     20000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR51
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     20001     20400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR52
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     20401     20800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR53
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     20801     21200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR54
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     21201     21600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR55
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     21601     22000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR56
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     22001     22400    99999
C   28/03/97            MEMBER NAME  JBTJ2064 (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR57
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     22401     22900    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR58
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     22901     23400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR59
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     23401     23900    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR60
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     23901     24400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR61
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     24401     24900    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR62
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     24901     25400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR63
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     25401     25900    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR1
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR64
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
     25901     27400    99999
C   28/03/97            MEMBER NAME  JBTJ208  (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR1
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
         0       400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR2
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
       401       800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR3
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
       801      1200    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR4
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      1201      1600    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR5
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      1601      2000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR6
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      2001      2400    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR7
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      2401      2800    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJEL,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPV4.NR2
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(40,11),RLSE),DSN=F11OLS.ETAPRI86.NR8
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
      2801      3200    99999
C   28/03/97            MEMBER NAME  JBTJ40E  (JADE56.S)    FORTRAN
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJ40,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.UNIGAM4V.E100D9
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(80,11),RLSE),DSN=F11OLS.UNIGAM86.E100D9
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
         0      2000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJ40,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.UNIGAM4V.E100DA
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(80,11),RLSE),DSN=F11OLS.UNIGAM86.E100DA
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
         0      2000    99999
//F11JLL97 JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(3,00),CLASS=K
//*MAIN RELPRI=LOW
//JOBLIB DD DSN=F11OLS.LKLDMC,DISP=SHR
//*
//**********************************************************************
//*                                                                    *
//*         M C J A D E   TRACKING JOB  (WITHOUT MUON TRACKING)        *
//*                                                                    *
//**********************************************************************
//*
//TRACKING EXEC PGM=LMDTJ40,REGION=840K
//*
//*                 INPUT
//FT03F001 DD DISP=SHR,DSN=F11OLS.UNIGAM4V.E100DB
//*
//*                 OUTPUT
//*FT02F001 DD DUMMY,DCB=R01DCB.VBS
//FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(80,11),RLSE),DSN=F11OLS.UNIGAM86.E100DB
//*GO.FT02F001 DD DISP=SHR,
//*    DSN=F11OLS.ETPRF.S1
//*GO.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.ETPRF.S1,
//*       MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*        DCB=R01DCB.VBS,
//*        DSN=F11OLS.TRACK1.FTAPRJ.B15
//FT06F001 DD SYSOUT=*
//FT05F001 DD *
    IEVMIN    IEVMAX
         0      2000    99999
C   28/03/97            MEMBER NAME  JBUNIGAM (JADE56.S)    FORTRAN
//F11OLS   JOB CLASS=K,MSGLEVEL=(1,0),TIME=(3,00)
//*MAIN RELPRI=LOW
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
./ I 7800
C LEVEL 7
      IPO = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
      IPVECT = IDATA(IBLN('VECT'))
      IF(IPALGN.LE.0.OR.IPLGCL.LE.0) GO TO 105
      NCLST = IDATA(IPLGCL+7)
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
C  4-VECTOR PHOTON ENERGY
      LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
      IP4 = IPVECT + LO
      PTRUE = ADATA(IP4+4)
      GO TO 999
105   WRITE(6,101) IPALGN,IPLGCL
101   FORMAT(' **** WARNING NO ALGN/LGCL BANKS,  POINTERS :',2I8)
      GO TO 1
999   NMOMGM = 0
      IF(NCLST.LE.0) GO TO 1027
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IP+8).NE.0) GO TO 522
      NMOMGM = NMOMGM + 1
      PTOTGM = PTOT
      PSEEN = ADATA(IP+NWPCL)
      COSTHG = COS(THE)
522   CONTINUE
1027  CONTINUE
      IF(NMOMGM.NE.1) GO TO 1
C
C ONE PHOTON FOUND, NOW COMPARE ENERGY
C
      IF(IPRIN.EQ.0) WRITE(6,4010) PTRUE
4010  FORMAT('      TRUE PHOTON ENERGY: ',E12.4)
      IF(IPRIN.EQ.0) IPRIN = 1
C
      RATIO1 = PTOTGM / PSEEN
      RATIO2 = PTOTGM / PTRUE
      RATIO3 = PSEEN / PTRUE
      CALL HFILL(1,RATIO1,0,1.)
      CALL HFILL(2,RATIO2,0,1.)
      CALL HFILL(3,RATIO3,0,1.)
      CALL HFILL(4,PSEEN,0,1.)
      CALL HFILL(5,PTOTGM,0,1.)
      CALL HFILL(6,PSEEN,0,1.)
      CALL HFILL(7,PTOTGM,0,1.)
      CALL HFILL(8,PSEEN,0,1.)
      CALL HFILL(9,PTOTGM,0,1.)
      CALL HFILL(21,COSTHG,0,1.)
      GO TO 11
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
      IF((JIGG(2)/100)*100.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
./ I 4400
C LEVEL 1
./ I 3800
C LEVEL 0
C  ITH,IRLTHD,IRLTH2,IRLTH3 ARE CLUSTER THRESHOLDS
C   IPHALG STEARS THE READOUT THRESHOLD IN MC EVENTS, DEFAULT NONZERO
      ITH = 25
C     IRLTHD = 1
C     IRLTH2 = 1
C     IRLTH3 = 1
      IPHALG = 1
      IPRIN = 0
      WRITE(6,1221) ITH,IPHALG
1221  FORMAT('  CLUSTER THRESHOLD, READOUT FLAG ',2I5)
C
      CALL HBOOK1(1,' CORRECTED ENERGY/SEEN ENERGY$',100,0.,3.)
      CALL HBOOK1(2,' CORRECTED ENERGY/TRUE ENERGY$',100,0.,3.)
      CALL HBOOK1(3,' SEEN ENERGY/TRUE ENERGY$',100,0.,3.)
      CALL HBOOK1(4,' SEEN ENERGY$',100,0.,0.5)
      CALL HBOOK1(5,'CORRECTED ENERGY$',100,0.,0.5)
      CALL HBOOK1(6,' SEEN ENERGY$',100,0.,1.0)
      CALL HBOOK1(7,'CORRECTED ENERGY$',100,0.,1.0)
      CALL HBOOK1(8,' SEEN ENERGY$',100,0.,1.5)
      CALL HBOOK1(9,'CORRECTED ENERGY$',100,0.,1.5)
      CALL HBOOK1(21,' COS THETA$',100,0.,1.)
1223  CONTINUE
./ I 1300
C DECLARATIVE LEVEL
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON / CRDSTA / IMCDUM(12),IPHALG
// EXEC FLG,PARM.LKED='SIZE=(600K,60K)',REGION.LKED=800K,
//  REGION.GO=1600K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F11OLS.UNIGAM.E400D3.SF5
//*  DD UNIT=AFF=FT02F001,DISP=OLD,DSN=F11LHO.JDATA08.REFORM.G0197V00
//*GO.FT02F001 DD DISP=SHR,DSN=F11OLS.LND52.UNTRACK
//*GO.FT02F001 DD UNIT=TAPE,DISP=OLD,LABEL=(1,NL),
//*   DCB=(R01DCB.VBS,LRECL=6229,BLKSIZE=6233,DEN=4),
//*   DSN=F22PET.NZNE.TPMH1,VOL=SER=F11106
//*                        OUTPUT:
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.TIMEOUT1,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(10,2),RLSE),DSN=F11OLS.BARRIES.PROBLEM
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0216V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*           DSN=F11OLS.REDUCTWO.G0196V00
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
C   28/03/97            MEMBER NAME  JBUNIGCV (JADE56.S)    FORTRAN
//F11OLS   JOB 00010622,CLASS=K,MSGLEVEL=(1,0),TIME=(3,00)
//*MAIN RELPRI=LOW
//*
//*  FOR GIVEN ENERGY, PLOT VARIOUS DIRECTIONS
//*
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
      WRITE(6,8881) PTRUE
8881  FORMAT(' TRUE ENERGY:',E12.4)
C
      DELDD = .01
      DPL =  .6 - .5*DELDD
C
      DO 3535  ID = 1,100
      DPL = DPL + DELDD
C
      RAT = 0.
      ERRHSW(ID) = 0.
      ISUM1= HSHW(ID)
      ISUM2= HNOSHW(ID)
      ISUM = ISUM1 + ISUM2
      SUM = FLOAT(ISUM)
      IF(SUM.GT.0.) RAT = FLOAT(ISUM1)/SUM
      CALL HFILL( 1,DPL,0,RAT)
C
C ERROR ARRAY
C
      SUM1 = FLOAT(ISUM1)
      ERRHSW(ID) = SQRT(SUM1 +SUM1*SUM1/SUM )/SUM
C
C
C  STANDARD FORMULA, AS USED IN TRKGAM
C
      QPROB=EXP(-DPL*7./9.)
      IF(PTRUE.LT.0.5) QPROB=EXP(-DPL*7./9.*(1.-6.2E-02/SQRT(PTRUE)))
C GO TO 3535 MEANS NO CONVERSION
C     IF(QPROB.GT.RN(DUM)) GO TO 3535
C
      WEIGHT = 1. - QPROB
      CALL HFILL( 2,DPL,0,WEIGHT)
C
3535  CONTINUE
C
      CALL HPAKE(1,ERRHSW(1))
C
./ I 7800
C LEVEL 7
      IPO = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
      IPVECT = IDATA(IBLN('VECT'))
      IF(IPALGN.LE.0.OR.IPLGCL.LE.0) GO TO 105
      NCLST = IDATA(IPLGCL+7)
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
C
C  4-VECTOR PHOTON ENERGY AND COSTHE
C
      LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
      IP4 = IPVECT + LO
      PTRUE = ADATA(IP4+4)
C
      COSTPV = ADATA(IP4+3)/PTRUE
      CALL TJOCK(COSTPV,XLEN90,XLENDM)
      DDD = XLENDM
C
      GO TO 999
C
105   WRITE(6,101) IPALGN,IPLGCL
101   FORMAT(' **** WARNING NO ALGN/LGCL BANKS,  POINTERS :',2I8)
      GO TO 1
999   NMOMGM = 0
      IF(NCLST.LE.0) GO TO 1027
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IP+8).NE.0) GO TO 522
      NMOMGM = NMOMGM + 1
      PTOTGM = PTOT
      PSEEN = ADATA(IP+NWPCL)
      COSTHG = COS(THE)
522   CONTINUE
1027  CONTINUE
      IF(NMOMGM.NE.1) GO TO 1
C
C ONE PHOTON FOUND, NOW HISTOGRAM AS FUNCTION OF DDD, SHOWER/NOSHOWER
C
      NSF56 = 0
      LSF56 = 0
      IPSF56 = IDATA(IBLN('SF56'))
      IF(IPSF56.LE.0) GO TO 3880
      NSF56 = IDATA(IPSF56+1)
      LSF56 = NSF56
      IF(NSF56.GT.10) LSF56 = 10
3880  CONTINUE
C
      DELDD = .01
      DPL =  .6
C
      DO 2525  ID = 1,100
      DPL = DPL + DELDD
      IF(DDD.GT.DPL) GO TO 2525
C
      NP = IDATA(IPSF56+2)
      IF(NP.EQ.1) HNOSHW(ID) = HNOSHW(ID) + 1
      IF(NP.GT.1) HSHW(ID) = HSHW(ID) + 1
      GO TO 2526
2525  CONTINUE
2526  CONTINUE
C
      GO TO 11
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
      IF((JIGG(2)/100)*100.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
./ I 4400
C LEVEL 1
./ I 3800
C LEVEL 0
C  ITH IS CLUSTER THRESHOLD
C   IPHALG STEARS THE READOUT THRESHOLD IN MC EVENTS, DEFAULT NONZERO
      ITH = 25
      IPHALG = 0
      WRITE(6,1221) ITH,IPHALG
1221  FORMAT('  CLUSTER THRESHOLD, READOUT FLAG ',2I5)
C
      ISECLF = 3
      PTRUEO = 0.
      ICOSM = 0
C
      CALL HBOOK1( 1,'RATIO CONV/ALL VS X0, SF5/6 PROG.$',100,0.6,1.6)
      CALL HBOOK1( 2,'RATIO CONV/ALL VS X0, STANDARD$',100,0.6,1.6)
1223  CONTINUE
./ I 1300
C DECLARATIVE LEVEL
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON / CRDSTA / IMCDUM(12),IPHALG
      COMMON / CTLIM / ISECLF
      DIMENSION HSHW(100), HNOSHW(100), ERRHSW(100)
//*
// EXEC GEP,PARM.LKED='LIST,SIZE=(600K,60K)',REGION.LKED=800K,
//      REGION.GO=1600K,VS=HBOOK,
//      DN='F11OLS.UNIGAMCV.E400'
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11OLS.JADE56.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0,LGECORZ)
//* INCLUDE SYSLIB(ENGLOSM)
//* INCLUDE SYSLIB(LGECORM)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME800
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME600
//GO.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME400
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME200A
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME200B
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME100A
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME100B
//*                        OUTPUT:
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(10,2),RLSE),DSN=F11OLS.BARRIES.PROBLEM
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0216V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*           DSN=F11OLS.REDUCTWO.G0196V00
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
C   28/03/97            MEMBER NAME  JBUNIGCW (JADE56.S)    FORTRAN
//F11JOL   JOB 00010622,CLASS=L,MSGLEVEL=(1,0),TIME=(3,40)
//*MAIN RELPRI=MED
//*
//*  FOR GIVEN ENERGY, PLOT VARIOUS DIRECTIONS
//*
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
      WRITE(6,8881) PTRUE
8881  FORMAT(' TRUE ENERGY:',E12.4)
C
      DELDD = .01
      DPL =  .6 - .5*DELDD
C
      DO 3535  ID = 1,100
      DPL = DPL + DELDD
C
      RAT = 0.
      ERRHSW(ID) = 0.
      ISUM1= HSHW(ID)
      ISUM2= HNOSHW(ID)
      ISUM = ISUM1 + ISUM2
      SUM = FLOAT(ISUM)
      IF(SUM.GT.0.) RAT = FLOAT(ISUM1)/SUM
      CALL HFILL( 1,DPL,0,RAT)
C
C ERROR ARRAY
C
      SUM1 = FLOAT(ISUM1)
      IF(SUM.GT.0.) ERRHSW(ID) = SQRT(SUM1 +SUM1*SUM1/SUM )/SUM
C
C
C  STANDARD FORMULA, AS USED IN TRKGAM
C
      QPROB=EXP(-DPL*7./9.)
      IF(PTRUE.LT.0.5) QPROB=EXP(-DPL*7./9.*(1.-6.2E-02/SQRT(PTRUE)))
C GO TO 3535 MEANS NO CONVERSION
C     IF(QPROB.GT.RN(DUM)) GO TO 3535
C
      WEIGHT = 1. - QPROB
      CALL HFILL( 2,DPL,0,WEIGHT)
C
3535  CONTINUE
C
      CALL HPAKE(1,ERRHSW(1))
C
./ I 7800
C LEVEL 7
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
      IF((JIGG(2)/100)*100.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
      IPVECT = IDATA(IBLN('VECT'))
C
C  4-VECTOR PHOTON ENERGY AND COSTHE
C
      LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
      IP4 = IPVECT + LO
      PTRUE = ADATA(IP4+4)
C
      COSTPV = ADATA(IP4+3)/PTRUE
      CALL TJOCK(COSTPV,XLEN90,XLENDM)
      DDD = XLENDM
C
C ONE PHOTON FOUND, NOW HISTOGRAM AS FUNCTION OF DDD, SHOWER/NOSHOWER
C
      NSF56 = 0
      LSF56 = 0
      IPSF56 = IDATA(IBLN('SF56'))
      IF(IPSF56.LE.0) GO TO 1
      NSF56 = IDATA(IPSF56+1)
      LSF56 = NSF56
      IF(NSF56.GT.10) LSF56 = 10
      NP = IDATA(IPSF56+2)
C
      CALL HFILL(3,NP,0,1.)
      IF(NP.LT.0.OR.NP.GT.200) GO TO 1
C
      DELDD = .01
      DPL =  .6
C
      DO 2525  ID = 1,100
      DPL = DPL + DELDD
      IF(DDD.GT.DPL) GO TO 2525
C
      IF(NP.EQ.1) HNOSHW(ID) = HNOSHW(ID) + 1
      IF(NP.NE.1) HSHW(ID) = HSHW(ID) + 1
      GO TO 2526
2525  CONTINUE
2526  CONTINUE
C
      GO TO 11
./ I 4400
C LEVEL 1
./ I 3800
C LEVEL 0
C  ITH IS CLUSTER THRESHOLD
C   IPHALG STEARS THE READOUT THRESHOLD IN MC EVENTS, DEFAULT NONZERO
      ITH = 25
      IPHALG = 0
      WRITE(6,1221) ITH,IPHALG
1221  FORMAT('  CLUSTER THRESHOLD, READOUT FLAG ',2I5)
C
      ISECLF = 3
      PTRUEO = 0.
      ICOSM = 0
C
      CALL HBOOK1( 1,'RATIO CONV/ALL VS X0, SF5/6 PROG.$',100,0.6,1.6)
      CALL HBOOK1( 2,'RATIO CONV/ALL VS X0, STANDARD$',100,0.6,1.6)
      CALL HBOOK1( 3,'NP FROM SF56',50,-1.5,48.5)
1223  CONTINUE
./ I 1300
C DECLARATIVE LEVEL
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON / CRDSTA / IMCDUM(12),IPHALG
      COMMON / CTLIM / ISECLF
      DIMENSION HSHW(100), HNOSHW(100), ERRHSW(100)
//*
// EXEC GEP,PARM.LKED='LIST,SIZE=(600K,60K)',REGION.LKED=800K,
//      REGION.GO=1600K,VS=HBOOK,
//      DN='F11OLS.UNIGAMCW.E100'
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11OLS.JADE56.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0,LGECORZ)
//* INCLUDE SYSLIB(ENGLOSM)
//* INCLUDE SYSLIB(LGECORM)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME800
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME600
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME400
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME200A
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME200B
//GO.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME100A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME100B
//*                        OUTPUT:
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(10,2),RLSE),DSN=F11OLS.BARRIES.PROBLEM
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0216V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*           DSN=F11OLS.REDUCTWO.G0196V00
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
C   28/03/97            MEMBER NAME  JBUNIGGP (JADE56.S)    FORTRAN
//F11OLS   JOB CLASS=K,MSGLEVEL=(1,0),TIME=(3,00)
//*MAIN RELPRI=LOW
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
      COSM = 0.
      IF(ICOSM.GT.0) COSM = COSMEA/FLOAT(ICOSM)
      WRITE(6,8881) COSM,COSMEA,ICOSM
8881  FORMAT(' MEAN COSTHETA:',E14.6,'  COSMEA ICOSM ',E14.6,I6)
./ I 7800
C LEVEL 7
      IPO = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
      IPVECT = IDATA(IBLN('VECT'))
      IF(IPALGN.LE.0.OR.IPLGCL.LE.0) GO TO 105
      NCLST = IDATA(IPLGCL+7)
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
C  4-VECTOR PHOTON ENERGY
      LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
      IP4 = IPVECT + LO
      PTRUE = ADATA(IP4+4)
      GO TO 999
105   WRITE(6,101) IPALGN,IPLGCL
101   FORMAT(' **** WARNING NO ALGN/LGCL BANKS,  POINTERS :',2I8)
      GO TO 1
999   NMOMGM = 0
      IF(NCLST.LE.0) GO TO 1027
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IP+8).NE.0) GO TO 522
      NMOMGM = NMOMGM + 1
      PTOTGM = PTOT
      PSEEN = ADATA(IP+NWPCL)
      COSTHG = COS(THE)
522   CONTINUE
1027  CONTINUE
      IF(NMOMGM.NE.1) GO TO 1
      COSMEA = COSMEA + COSTHG
      ICOSM = ICOSM + 1
C
C ONE PHOTON FOUND, NOW COMPARE ENERGY
C
      IF(PTRUE.NE.PTRUEO) IPRIN = 0
      IF(IPRIN.EQ.0) WRITE(6,4010) PTRUE
4010  FORMAT('      TRUE PHOTON ENERGY: ',E12.4)
      IF(IPRIN.EQ.0) PTRUEO = PTRUE
      IF(IPRIN.EQ.0) IPRIN = 1
C
      RATIO1 = PSEEN / PTRUE
      RATIO2 = PTOTGM / PTRUE
C
      IFILST = 0
      IF(PTRUE.GT..150) IFILST = IFILST + 10
      IF(PTRUE.GT..250) IFILST = IFILST + 10
      IF(PTRUE.GT..450) IFILST = IFILST + 10
      IF(PTRUE.GT..650) IFILST = IFILST + 10
C
      CALL HFILL(IFILST + 1,RATIO1,0,1.)
      CALL HFILL(IFILST + 2,RATIO2,0,1.)
      GO TO 11
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
      IF((JIGG(2)/100)*100.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
./ I 4400
C LEVEL 1
./ I 3800
C LEVEL 0
C  ITH IS CLUSTER THRESHOLD
C   IPHALG STEARS THE READOUT THRESHOLD IN MC EVENTS, DEFAULT NONZERO
      ITH = 25
      IPHALG = 1
      WRITE(6,1221) ITH,IPHALG
1221  FORMAT('  CLUSTER THRESHOLD, READOUT FLAG ',2I5)
C
      ISECLF = 3
      IPRIN = 0
      PTRUEO = 0.
      COSMEA = 0.
      ICOSM = 0
C
      CALL HBOOK1( 1,' SEEN ENERGY/TRUE ENERGY, E100 $',100,0.,2.)
      CALL HBOOK1( 2,' CORR ENERGY/TRUE ENERGY, E100 $',100,0.,2.)
      CALL HBOOK1(11,' SEEN ENERGY/TRUE ENERGY, E200 $',100,0.,2.)
      CALL HBOOK1(12,' CORR ENERGY/TRUE ENERGY, E200 $',100,0.,2.)
      CALL HBOOK1(21,' SEEN ENERGY/TRUE ENERGY, E400 $',100,0.,2.)
      CALL HBOOK1(22,' CORR ENERGY/TRUE ENERGY, E400 $',100,0.,2.)
      CALL HBOOK1(31,' SEEN ENERGY/TRUE ENERGY, E600 $',100,0.,2.)
      CALL HBOOK1(32,' CORR ENERGY/TRUE ENERGY, E600 $',100,0.,2.)
      CALL HBOOK1(41,' SEEN ENERGY/TRUE ENERGY, E800 $',100,0.,2.)
      CALL HBOOK1(42,' CORR ENERGY/TRUE ENERGY, E800 $',100,0.,2.)
1223  CONTINUE
./ I 1300
C DECLARATIVE LEVEL
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON / CRDSTA / IMCDUM(12),IPHALG
      COMMON / CTLIM / ISECLF
//*
// EXEC GEP,PARM.LKED='LIST,SIZE=(600K,60K)',REGION.LKED=800K,
//      REGION.GO=1600K,VS=HBOOK,
//      DN='F11OLS.UNIGAMGX.DIRB.SF6T1.ENGLOS'
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11OLS.JADE56.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0,LGECORX)
//*  INCLUDE SYSLIB(ENGLOSM)
//* INCLUDE SYSLIB(LGECORM)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//GO.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM.E100DB.SF6
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E200DB.SF6
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400DB.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400DB.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E600DB.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E600DB.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E800DB.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E800DB.SF6B
//*                        OUTPUT:
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*    DSN=F11OLS.TIMEOUT1,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(10,2),RLSE),DSN=F11OLS.BARRIES.PROBLEM
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0216V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*           DSN=F11OLS.REDUCTWO.G0196V00
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
C   28/03/97            MEMBER NAME  JBUNIGHP (JADE56.S)    FORTRAN
//F11OLS   JOB 00010622,CLASS=L,MSGLEVEL=(1,0),TIME=(7,00)
//*MAIN RELPRI=MED
//*
//*  FOR GIVEN ENERGY, PLOT VARIOUS DIRECTIONS
//*
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
      WRITE(6,8881) PTRUE
8881  FORMAT(' TRUE ENERGY:',E12.4)
./ I 7800
C LEVEL 7
      IPO = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
      IPVECT = IDATA(IBLN('VECT'))
      IF(IPALGN.LE.0.OR.IPLGCL.LE.0) GO TO 105
      NCLST = IDATA(IPLGCL+7)
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
C  4-VECTOR PHOTON ENERGY
      LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
      IP4 = IPVECT + LO
      PTRUE = ADATA(IP4+4)
      GO TO 999
105   WRITE(6,101) IPALGN,IPLGCL
101   FORMAT(' **** WARNING NO ALGN/LGCL BANKS,  POINTERS :',2I8)
      GO TO 1
999   NMOMGM = 0
      IF(NCLST.LE.0) GO TO 1027
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IP+8).NE.0) GO TO 522
      NMOMGM = NMOMGM + 1
      PTOTGM = PTOT
      PSEEN = ADATA(IP+NWPCL)
      COSTHG = COS(THE)
522   CONTINUE
1027  CONTINUE
      IF(NMOMGM.NE.1) GO TO 1
C
C ONE PHOTON FOUND, NOW COMPARE ENERGY
C
C
      RATIO1 = PSEEN / PTRUE
      RATIO2 = PTOTGM / PTRUE
C
      IFILST = 0
      IF(COSTHG.GT..090) IFILST = IFILST + 10
      IF(COSTHG.GT..180) IFILST = IFILST + 10
      IF(COSTHG.GT..280) IFILST = IFILST + 10
      IF(COSTHG.GT..390) IFILST = IFILST + 10
      IF(COSTHG.GT..485) IFILST = IFILST + 10
      IF(COSTHG.GT..580) IFILST = IFILST + 10
      IF(COSTHG.GT..650) IFILST = IFILST + 10
      IF(COSTHG.GT..705) IFILST = IFILST + 10
      IF(COSTHG.GT..750) IFILST = IFILST + 10
      IF(COSTHG.GT..788) IFILST = IFILST + 10
C
      CALL HFILL(IFILST + 1,RATIO1,0,1.)
      CALL HFILL(IFILST + 2,RATIO2,0,1.)
      GO TO 11
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
      IF((JIGG(2)/100)*100.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
./ I 4400
C LEVEL 1
./ I 3800
C LEVEL 0
C  ITH IS CLUSTER THRESHOLD
C   IPHALG STEARS THE READOUT THRESHOLD IN MC EVENTS, DEFAULT NONZERO
      ITH = 25
      IPHALG = 1
      WRITE(6,1221) ITH,IPHALG
1221  FORMAT('  CLUSTER THRESHOLD, READOUT FLAG ',2I5)
C
      ISECLF = 3
      PTRUEO = 0.
      ICOSM = 0
C
      CALL HBOOK1( 1,' SEEN ENERGY/TRUE ENERGY, D1 $',100,0.,2.)
      CALL HBOOK1( 2,' CORR ENERGY/TRUE ENERGY, D1 $',100,0.,2.)
      CALL HBOOK1(11,' SEEN ENERGY/TRUE ENERGY, D2 $',100,0.,2.)
      CALL HBOOK1(12,' CORR ENERGY/TRUE ENERGY, D2 $',100,0.,2.)
      CALL HBOOK1(21,' SEEN ENERGY/TRUE ENERGY, D3 $',100,0.,2.)
      CALL HBOOK1(22,' CORR ENERGY/TRUE ENERGY, D3 $',100,0.,2.)
      CALL HBOOK1(31,' SEEN ENERGY/TRUE ENERGY, D4 $',100,0.,2.)
      CALL HBOOK1(32,' CORR ENERGY/TRUE ENERGY, D4 $',100,0.,2.)
      CALL HBOOK1(41,' SEEN ENERGY/TRUE ENERGY, D5 $',100,0.,2.)
      CALL HBOOK1(42,' CORR ENERGY/TRUE ENERGY, D5 $',100,0.,2.)
      CALL HBOOK1(51,' SEEN ENERGY/TRUE ENERGY, D6 $',100,0.,2.)
      CALL HBOOK1(52,' CORR ENERGY/TRUE ENERGY, D6 $',100,0.,2.)
      CALL HBOOK1(61,' SEEN ENERGY/TRUE ENERGY, D7 $',100,0.,2.)
      CALL HBOOK1(62,' CORR ENERGY/TRUE ENERGY, D7 $',100,0.,2.)
      CALL HBOOK1(71,' SEEN ENERGY/TRUE ENERGY, D8 $',100,0.,2.)
      CALL HBOOK1(72,' CORR ENERGY/TRUE ENERGY, D8 $',100,0.,2.)
      CALL HBOOK1(81,' SEEN ENERGY/TRUE ENERGY, D9 $',100,0.,2.)
      CALL HBOOK1(82,' CORR ENERGY/TRUE ENERGY, D9 $',100,0.,2.)
      CALL HBOOK1(91,' SEEN ENERGY/TRUE ENERGY, DA $',100,0.,2.)
      CALL HBOOK1(92,' CORR ENERGY/TRUE ENERGY, DA $',100,0.,2.)
      CALL HBOOK1(101,' SEEN ENERGY/TRUE ENERGY, DB $',100,0.,2.)
      CALL HBOOK1(102,' CORR ENERGY/TRUE ENERGY, DB $',100,0.,2.)
1223  CONTINUE
./ I 1300
C DECLARATIVE LEVEL
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON / CRDSTA / IMCDUM(12),IPHALG
      COMMON / CTLIM / ISECLF
//*
// EXEC GEP,PARM.LKED='LIST,SIZE=(600K,60K)',REGION.LKED=800K,
//      REGION.GO=1600K,VS=HBOOK,
//      DN='F11OLS.UNIGAMGX.E400.SF6T1.ENGLOSM'
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11OLS.JADE56.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0,LGECORX)
 INCLUDE SYSLIB(ENGLOSM)
//* INCLUDE SYSLIB(LGECORM)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//GO.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D1.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D1.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D2.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D2.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D3.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D3.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D4.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D4.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D5.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D5.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D6.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D6.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D7.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D7.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D8.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D8.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D9.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400D9.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400DA.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400DA.SF6B
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400DB.SF6A
//            DD DISP=SHR,DSN=F11OLS.UNIGAM.E400DB.SF6B
//*                        OUTPUT:
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(10,2),RLSE),DSN=F11OLS.BARRIES.PROBLEM
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0216V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*           DSN=F11OLS.REDUCTWO.G0196V00
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
C   28/03/97            MEMBER NAME  JBUNIGIP (JADE56.S)    FORTRAN
//F11OLS   JOB 00010622,CLASS=L,MSGLEVEL=(1,0),TIME=(6,30)
//*MAIN RELPRI=MED
//*
//*  FOR GIVEN ENERGY, PLOT VARIOUS DIRECTIONS
//*
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
      WRITE(6,8881) PTRUE
8881  FORMAT(' TRUE ENERGY:',E12.4)
./ I 7800
C LEVEL 7
      IPO = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
      IPVECT = IDATA(IBLN('VECT'))
      IF(IPALGN.LE.0.OR.IPLGCL.LE.0) GO TO 105
      NCLST = IDATA(IPLGCL+7)
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
C  4-VECTOR PHOTON ENERGY
      LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
      IP4 = IPVECT + LO
      PTRUE = ADATA(IP4+4)
      GO TO 999
105   WRITE(6,101) IPALGN,IPLGCL
101   FORMAT(' **** WARNING NO ALGN/LGCL BANKS,  POINTERS :',2I8)
      GO TO 1
999   NMOMGM = 0
      IF(NCLST.LE.0) GO TO 1027
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IP+8).NE.0) GO TO 522
      NMOMGM = NMOMGM + 1
      PTOTGM = PTOT
      PSEEN = ADATA(IP+NWPCL)
      COSTHG = COS(THE)
522   CONTINUE
1027  CONTINUE
      IF(NMOMGM.NE.1) GO TO 1
C
C ONE PHOTON FOUND, NOW COMPARE SEEN ENERGY TO TRUE, SHOWER/NOSHOWER
C
      NSF56 = 0
      LSF56 = 0
      IPSF56 = IDATA(IBLN('SF56'))
      IF(IPSF56.LE.0) GO TO 3880
      NSF56 = IDATA(IPSF56+1)
      LSF56 = NSF56
      IF(NSF56.GT.10) LSF56 = 10
3880  CONTINUE
C
      RATIO1 = PSEEN / PTRUE
      RATIO2 = PTOTGM / PTRUE
C
      IFILST = 0
      IF(COSTHG.GT..090) IFILST = IFILST + 10
      IF(COSTHG.GT..180) IFILST = IFILST + 10
      IF(COSTHG.GT..280) IFILST = IFILST + 10
      IF(COSTHG.GT..390) IFILST = IFILST + 10
      IF(COSTHG.GT..485) IFILST = IFILST + 10
      IF(COSTHG.GT..580) IFILST = IFILST + 10
      IF(COSTHG.GT..650) IFILST = IFILST + 10
      IF(COSTHG.GT..705) IFILST = IFILST + 10
      IF(COSTHG.GT..750) IFILST = IFILST + 10
      IF(COSTHG.GT..788) IFILST = IFILST + 10
C
      CALL HFILL(IFILST + 1,RATIO1,0,1.)
      CALL HFILL(IFILST + 2,RATIO2,0,1.)
      IF(LSF56.EQ.0) GO TO 11
C
      NP = IDATA(IPSF56+2)
      IF(NP.GT.1)  CALL HFILL(IFILST + 3,RATIO1,0,1.)
      IF(NP.GT.1)  CALL HFILL(IFILST + 4,RATIO2,0,1.)
      IF(NP.EQ.1)  CALL HFILL(IFILST + 5,RATIO1,0,1.)
      IF(NP.EQ.1)  CALL HFILL(IFILST + 6,RATIO2,0,1.)
C
      GO TO 11
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
      IF((JIGG(2)/100)*100.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
./ I 4400
C LEVEL 1
./ I 3800
C LEVEL 0
C  ITH IS CLUSTER THRESHOLD
C   IPHALG STEARS THE READOUT THRESHOLD IN MC EVENTS, DEFAULT NONZERO
      ITH = 25
      IPHALG = 1
      WRITE(6,1221) ITH,IPHALG
1221  FORMAT('  CLUSTER THRESHOLD, READOUT FLAG ',2I5)
C
      ISECLF = 3
      PTRUEO = 0.
      ICOSM = 0
C
      CALL HBOOK1( 1,'SEEN ENERGY/TRUE ENERGY, D1 $',100,0.,2.)
      CALL HBOOK1( 2,'CORR ENERGY/TRUE ENERGY, D1 $',100,0.,2.)
      CALL HBOOK1( 3,'SEEN ENERGY/TRUE ENERGY SHOWER, D1 $',100,0.,2.)
      CALL HBOOK1( 4,'CORR ENERGY/TRUE ENERGY SHOWER, D1 $',100,0.,2.)
      CALL HBOOK1( 5,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D1 $',100,0.,2.)
      CALL HBOOK1( 6,'CORR ENERGY/TRUE ENERGY NOSHOWER, D1 $',100,0.,2.)
      CALL HBOOK1(11,'SEEN ENERGY/TRUE ENERGY, D2 $',100,0.,2.)
      CALL HBOOK1(12,'CORR ENERGY/TRUE ENERGY, D2 $',100,0.,2.)
      CALL HBOOK1(13,'SEEN ENERGY/TRUE ENERGY SHOWER, D2 $',100,0.,2.)
      CALL HBOOK1(14,'CORR ENERGY/TRUE ENERGY SHOWER, D2 $',100,0.,2.)
      CALL HBOOK1(15,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D2 $',100,0.,2.)
      CALL HBOOK1(16,'CORR ENERGY/TRUE ENERGY NOSHOWER, D2 $',100,0.,2.)
      CALL HBOOK1(21,'SEEN ENERGY/TRUE ENERGY, D3 $',100,0.,2.)
      CALL HBOOK1(22,'CORR ENERGY/TRUE ENERGY, D3 $',100,0.,2.)
      CALL HBOOK1(23,'SEEN ENERGY/TRUE ENERGY SHOWER, D3 $',100,0.,2.)
      CALL HBOOK1(24,'CORR ENERGY/TRUE ENERGY SHOWER, D3 $',100,0.,2.)
      CALL HBOOK1(25,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D3 $',100,0.,2.)
      CALL HBOOK1(26,'CORR ENERGY/TRUE ENERGY NOSHOWER, D3 $',100,0.,2.)
      CALL HBOOK1(31,'SEEN ENERGY/TRUE ENERGY, D4 $',100,0.,2.)
      CALL HBOOK1(32,'CORR ENERGY/TRUE ENERGY, D4 $',100,0.,2.)
      CALL HBOOK1(33,'SEEN ENERGY/TRUE ENERGY SHOWER, D4 $',100,0.,2.)
      CALL HBOOK1(34,'CORR ENERGY/TRUE ENERGY SHOWER, D4 $',100,0.,2.)
      CALL HBOOK1(35,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D4 $',100,0.,2.)
      CALL HBOOK1(36,'CORR ENERGY/TRUE ENERGY NOSHOWER, D4 $',100,0.,2.)
      CALL HBOOK1(41,'SEEN ENERGY/TRUE ENERGY, D5 $',100,0.,2.)
      CALL HBOOK1(42,'CORR ENERGY/TRUE ENERGY, D5 $',100,0.,2.)
      CALL HBOOK1(43,'SEEN ENERGY/TRUE ENERGY SHOWER, D5 $',100,0.,2.)
      CALL HBOOK1(44,'CORR ENERGY/TRUE ENERGY SHOWER, D5 $',100,0.,2.)
      CALL HBOOK1(45,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D5 $',100,0.,2.)
      CALL HBOOK1(46,'CORR ENERGY/TRUE ENERGY NOSHOWER, D5 $',100,0.,2.)
      CALL HBOOK1(51,'SEEN ENERGY/TRUE ENERGY, D6 $',100,0.,2.)
      CALL HBOOK1(52,'CORR ENERGY/TRUE ENERGY, D6 $',100,0.,2.)
      CALL HBOOK1(53,'SEEN ENERGY/TRUE ENERGY SHOWER, D6 $',100,0.,2.)
      CALL HBOOK1(54,'CORR ENERGY/TRUE ENERGY SHOWER, D6 $',100,0.,2.)
      CALL HBOOK1(55,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D6 $',100,0.,2.)
      CALL HBOOK1(56,'CORR ENERGY/TRUE ENERGY NOSHOWER, D6 $',100,0.,2.)
      CALL HBOOK1(61,'SEEN ENERGY/TRUE ENERGY, D7 $',100,0.,2.)
      CALL HBOOK1(62,' CORR ENERGY/TRUE ENERGY, D7 $',100,0.,2.)
      CALL HBOOK1(63,'SEEN ENERGY/TRUE ENERGY SHOWER, D7 $',100,0.,2.)
      CALL HBOOK1(64,'CORR ENERGY/TRUE ENERGY SHOWER, D7 $',100,0.,2.)
      CALL HBOOK1(65,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D7 $',100,0.,2.)
      CALL HBOOK1(66,'CORR ENERGY/TRUE ENERGY NOSHOWER, D7 $',100,0.,2.)
      CALL HBOOK1(71,' SEEN ENERGY/TRUE ENERGY, D8 $',100,0.,2.)
      CALL HBOOK1(72,' CORR ENERGY/TRUE ENERGY, D8 $',100,0.,2.)
      CALL HBOOK1(73,'SEEN ENERGY/TRUE ENERGY SHOWER, D8 $',100,0.,2.)
      CALL HBOOK1(74,'CORR ENERGY/TRUE ENERGY SHOWER, D8 $',100,0.,2.)
      CALL HBOOK1(75,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D8 $',100,0.,2.)
      CALL HBOOK1(76,'CORR ENERGY/TRUE ENERGY NOSHOWER, D8 $',100,0.,2.)
      CALL HBOOK1(81,' SEEN ENERGY/TRUE ENERGY, D9 $',100,0.,2.)
      CALL HBOOK1(82,' CORR ENERGY/TRUE ENERGY, D9 $',100,0.,2.)
      CALL HBOOK1(83,'SEEN ENERGY/TRUE ENERGY SHOWER, D9 $',100,0.,2.)
      CALL HBOOK1(84,'CORR ENERGY/TRUE ENERGY SHOWER, D9 $',100,0.,2.)
      CALL HBOOK1(85,'SEEN ENERGY/TRUE ENERGY NOSHOWER, D9 $',100,0.,2.)
      CALL HBOOK1(86,'CORR ENERGY/TRUE ENERGY NOSHOWER, D9 $',100,0.,2.)
      CALL HBOOK1(91,' SEEN ENERGY/TRUE ENERGY, DA $',100,0.,2.)
      CALL HBOOK1(92,' CORR ENERGY/TRUE ENERGY, DA $',100,0.,2.)
      CALL HBOOK1(93,'SEEN ENERGY/TRUE ENERGY SHOWER, DA $',100,0.,2.)
      CALL HBOOK1(94,'CORR ENERGY/TRUE ENERGY SHOWER, DA $',100,0.,2.)
      CALL HBOOK1(95,'SEEN ENERGY/TRUE ENERGY NOSHOWER, DA $',100,0.,2.)
      CALL HBOOK1(96,'CORR ENERGY/TRUE ENERGY NOSHOWER, DA $',100,0.,2.)
      CALL HBOOK1(101,' SEEN ENERGY/TRUE ENERGY, DB $',100,0.,2.)
      CALL HBOOK1(102,' CORR ENERGY/TRUE ENERGY, DB $',100,0.,2.)
      CALL HBOOK1(103,'SEEN ENERGY/TRUE ENERGY SHOWER, DB $',100,0.,2.)
      CALL HBOOK1(104,'CORR ENERGY/TRUE ENERGY SHOWER, DB $',100,0.,2.)
      CALL HBOOK1(105,'SEEN ENERGY/TRUE ENERGY NOSHOW, DB $',100,0.,2.)
      CALL HBOOK1(106,'CORR ENERGY/TRUE ENERGY NOSHOW, DB $',100,0.,2.)
1223  CONTINUE
./ I 1300
C DECLARATIVE LEVEL
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON / CRDSTA / IMCDUM(12),IPHALG
      COMMON / CTLIM / ISECLF
//*
// EXEC GEP,PARM.LKED='LIST,SIZE=(600K,60K)',REGION.LKED=800K,
//      REGION.GO=1600K,VS=HBOOK,
//      DN='F11OLS.UNIGAMGZ.E300.THR1.LGECORWT'
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11OLS.JADE56.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0,LGECORWT)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM86.SUME400
//GO.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D1
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D2
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D3
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D4
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D5
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D6
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D7
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D8
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300D9
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.E300DA
//*                        OUTPUT:
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(10,2),RLSE),DSN=F11OLS.BARRIES.PROBLEM
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0216V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*           DSN=F11OLS.REDUCTWO.G0196V00
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
C   28/03/97            MEMBER NAME  JBUNIGTH (JADE56.S)    FORTRAN
//F11OLS   JOB 00010221,CLASS=L,MSGLEVEL=(1,0),TIME=(9,00)
//*MAIN RELPRI=MED
//*
//*  FOR GIVEN ENERGY, PLOT VARIOUS DIRECTIONS
//*
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
      WRITE(6,8881) PTRUE
8881  FORMAT(' TRUE ENERGY:',E12.4)
C
      DO 1217 IP = 1,20
      ZST = 0.
      DO 1216 I = 1,100
C
      XM = 0.
      XM2 = 0.
      SG2 = 0.
      IF(IN(I,IP).GT.0) XM = YN(I,IP)/FLOAT(IN(I,IP))
      IF(IN(I,IP).GT.0) XM2 = YN2(I,IP)/FLOAT(IN(I,IP))
      INM = IN(I,IP) - 1
      IF(IN(I,IP).GT.1)
     $ SG2 = (XM2-XM**2)/FLOAT(INM)
      IF(SG2.GT.0.) SG2 = SQRT(SG2)
      YMEAN(I,IP) = XM
      ERR(I,IP) = SG2
C
      ZST = ZST + DZMN
      CALL HFILL(40+IP,ZST,0,XM)
C
1216  CONTINUE
C
      CALL HPAKE(40+IP,ERR(1,IP))
1217  CONTINUE
C
./ I 7800
C LEVEL 7
      IPO = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
      IPVECT = IDATA(IBLN('VECT'))
      IF(IPALGN.LE.0.OR.IPLGCL.LE.0) GO TO 105
      NCLST = IDATA(IPLGCL+7)
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
C  4-VECTOR PHOTON ENERGY
      LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
      IP4 = IPVECT + LO
      PTRUE = ADATA(IP4+4)
      COSTRU = ADATA(IP4+3)/PTRUE
      ZTRUE = 1100.*COSTRU/SQRT(1.-COSTRU*COSTRU)
      IF(JIGG(2).LT.10) WRITE(6,4661) ZTRUE
4661  FORMAT(' ZTRUE ',E12.4)
C
      GO TO 999
105   WRITE(6,101) IPALGN,IPLGCL
101   FORMAT(' **** WARNING NO ALGN/LGCL BANKS,  POINTERS :',2I8)
      GO TO 1
999   NMOMGM = 0
      IF(NCLST.LE.0) GO TO 1027
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IP+8).NE.0) GO TO 522
      NMOMGM = NMOMGM + 1
      PTOTGM = PTOT
      PSEEN = ADATA(IP+NWPCL)
      COSTHG = COS(THE)
522   CONTINUE
1027  CONTINUE
      IF(NMOMGM.NE.1) GO TO 1
C
C  COMPARE PSEEN WITH TOTAL ENERGY IN LEADGLASS
C
      ETOT = 0.
      IPJ=IDATA(IBLN('ALGN'))
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 1
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
      DO 5004 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      NAMP = HDATA(IJK)
      ETOT=ETOT+FLOAT(NAMP)*.001
C
C     WRITE(6,2243) IJK,IAD,NAMP,ETOT
C243  FORMAT(' 5004: IJK IAD NAMP ETOT ',3I6,3E12.4)
C
5004  CONTINUE
C
      DELTAS = ETOT - PSEEN
      IF(DELTAS.NE.0.) CALL HFILL(1,DELTAS,0,1.)
C
      IPHALG = 1
      CALL RDALGN
      IPHALG = 0
C
C  GET NEW ETOT
C
      ETOT1 = 0.
      IPJ=IDATA(IBLN('ALGN'))
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 1
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
      DO 5005 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      NAMP = HDATA(IJK)
      ETOT1=ETOT1+FLOAT(NAMP)*.001
C
C     WRITE(6,2244) IJK,IAD,NAMP,ETOT1
C244  FORMAT(' 5005: IJK IAD NAMP ETOT1 ',3I6,3E12.4)
C
5005  CONTINUE
C
      DELTAE = ETOT - ETOT1
C
C     WRITE(6,2233) ETOT,ETOT1,DELTAE
C233  FORMAT(' AFTER RDALGN, ETOT ETOT1 DELTAE ',3E12.4)
C
C
C   NEW CLUSTER ANALYSIS AND LGCL RECONSTRUCTION
C
C RDALGN DELETES ALSO LGCL
C     CALL BDLS('LGCL',1)
C
      CALL LGANAL
      IPPATR = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
C
C     WRITE(6,2234) IPPATR,IPALGN,IPLGCL
C234  FORMAT(' AFTER LGANAL, IPPATR,ALGN LGCL ',3I10)
C
      IF(IPPATR.LE.0.OR.IPALGN.LE.0.OR.IPLGCL.LE.0) GO TO 1
      CALL LGCDIR(IPPATR,IPALGN,IPLGCL)
C
C  NEW PHOTON FINDING
C
      IPLGCL = IDATA(IBLN('LGCL'))
C
C     WRITE(6,2235) IPLGCL
C235  FORMAT(' AFTER LGCDIR IPLGCL ',3I10)
C
      NCLST = IDATA(IPLGCL+7)
      IF(NCLST.LE.0) GO TO 1
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
      NMOMGM = 0
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      ITP = 0
      DO 422  IGM = 1,NCLST
      IP = IP + NWPCL
      CALL TRACK(IP,ITP,RMIN,NHT,FI,THE,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IP+8).NE.0) GO TO 422
      NMOMGM = NMOMGM + 1
      PTOTG1 = PTOT
      PSEEN1= ADATA(IP+NWPCL)
      COSTG1 = COS(THE)
422   CONTINUE
      IF(NMOMGM.NE.1) GO TO 1
C
      CALL HFILL(2,PSEEN1,PSEEN,1.)
C
C ONE PHOTON FOUND AGAIN, AFTER READOUT SUPRESSION
C
      NSF56 = 0
      LSF56 = 0
      IPSF56 = IDATA(IBLN('SF56'))
      IF(IPSF56.LE.0) GO TO 3880
      NSF56 = IDATA(IPSF56+1)
      LSF56 = NSF56
      IF(NSF56.GT.10) LSF56 = 10
3880  CONTINUE
C
      ZST = 0.
C
      DO 1333  I = 1,100
      ZST = ZST + DZMN
      IF(ZTRUE.GT.ZST) GO TO 1333
C
      IP = PSEEN1/.05 + 1
      IF(IP.GT.20) IP = 20
C
      IN(I,IP) = IN(I,IP) + 1
      YN(I,IP) = YN(I,IP) + DELTAE
      YN2(I,IP) = YN2(I,IP) + DELTAE**2
      CALL HFILL(10+IP,ZTRUE,DELTAE,1.)
      GO TO 1334
C
1333  CONTINUE
C
1334  CONTINUE
C
      GO TO 11
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
      IF((JIGG(2)/100)*100.EQ.JIGG(2))
     $ WRITE(6,2702) JIGG(2),HEAD(18),HEAD(19)
2702  FORMAT(' NNREC RUN EVENT ',3I8)
./ I 4400
C LEVEL 1
./ I 3800
C LEVEL 0
C  ITH IS CLUSTER THRESHOLD
C   IPHALG STEARS THE READOUT THRESHOLD IN MC EVENTS, DEFAULT NONZERO
      ITH = 25
      IPHALG = 0
      WRITE(6,1221) ITH,IPHALG
1221  FORMAT('  CLUSTER THRESHOLD, READOUT FLAG ',2I5)
C
      ISECLF = 3
      PTRUEO = 0.
C
      DZMN = 15.
C
      DO 1077 K = 1,20
      DO 1077 I = 1,100
      IN(I,K) = 0
      ERR(I,K) = 0.
      YN(I,K) = 0.
      YN2(I,K) = 0.
      YMEAN(I,K) = 0.
1077  CONTINUE
C
      CALL ACORE(40000)
C
      CALL HBOOK1( 1,'DELTA PSEEN - ETOT $',100,0.,.05)
      CALL HBOOK2( 2,'PSEEN VS PSEEN1 $',100,0.,1.,100,0.,1.)
C
      CALL HBOOK1(41,'MEAN50 VS Z $',100,0.,1500.)
      CALL HBOOK1(42,'MEAN100 VS Z $',100,0.,1500.)
      CALL HBOOK1(43,'MEAN150 VS Z $',100,0.,1500.)
      CALL HBOOK1(44,'MEAN200 VS Z $',100,0.,1500.)
      CALL HBOOK1(45,'MEAN250 VS Z $',100,0.,1500.)
      CALL HBOOK1(46,'MEAN300 VS Z $',100,0.,1500.)
      CALL HBOOK1(47,'MEAN350 VS Z $',100,0.,1500.)
      CALL HBOOK1(48,'MEAN400 VS Z $',100,0.,1500.)
      CALL HBOOK1(49,'MEAN450 VS Z $',100,0.,1500.)
      CALL HBOOK1(50,'MEAN500 VS Z $',100,0.,1500.)
      CALL HBOOK1(51,'MEAN550 VS Z $',100,0.,1500.)
      CALL HBOOK1(52,'MEAN600 VS Z $',100,0.,1500.)
      CALL HBOOK1(53,'MEAN650 VS Z $',100,0.,1500.)
      CALL HBOOK1(54,'MEAN700 VS Z $',100,0.,1500.)
      CALL HBOOK1(55,'MEAN750 VS Z $',100,0.,1500.)
      CALL HBOOK1(56,'MEAN800 VS Z $',100,0.,1500.)
      CALL HBOOK1(57,'MEAN850 VS Z $',100,0.,1500.)
      CALL HBOOK1(58,'MEAN900 VS Z $',100,0.,1500.)
      CALL HBOOK1(59,'MEAN950 VS Z $',100,0.,1500.)
      CALL HBOOK1(60,'MEAN1000 VS Z $',100,0.,1500.)
C
      CALL HBOOK2(11,'DELTASUPR VS Z, 50$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(12,'DELTASUPR VS Z, 100$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(13,'DELTASUPR VS Z, 150$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(14,'DELTASUPR VS Z, 200$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(15,'DELTASUPR VS Z, 250$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(16,'DELTASUPR VS Z, 300$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(17,'DELTASUPR VS Z, 350$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(18,'DELTASUPR VS Z, 400$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(19,'DELTASUPR VS Z, 450$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(20,'DELTASUPR VS Z, 500$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(21,'DELTASUPR VS Z, 550$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(22,'DELTASUPR VS Z, 600$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(23,'DELTASUPR VS Z, 650$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(24,'DELTASUPR VS Z, 700$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(25,'DELTASUPR VS Z, 750$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(26,'DELTASUPR VS Z, 800$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(27,'DELTASUPR VS Z, 850$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(28,'DELTASUPR VS Z, 900$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(29,'DELTASUPR VS Z, 950$',100,0.,1500.,100,0.,0.5)
      CALL HBOOK2(30,'DELTASUPR VS Z,1000$',100,0.,1500.,100,0.,0.5)
1223  CONTINUE
./ I 1300
C DECLARATIVE LEVEL
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON / CRDSTA / IMCDUM(12),IPHALG
      COMMON / CTLIM / ISECLF
C
      DIMENSION ERR(100,20)
      DIMENSION YN(100,20)
      DIMENSION YMEAN(100,20)
      DIMENSION YN2(100,20)
      DIMENSION IN(100,20)
C
//*
// EXEC GEP,PARM.LKED='LIST,SIZE=(600K,60K)',REGION.LKED=800K,
//      REGION.GO=1800K,VS=HBOOK,
//      DN='F11OLS.UNIGAMTH.EF300'
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11OLS.JADE56.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0,LGECORWT)
//* INCLUDE SYSLIB(ENGLOSM)
//* INCLUDE SYSLIB(LGECORM)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMEA00
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMFA00
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME800
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF800
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME700
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF700
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME600
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF600
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME500
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF500
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME400
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF400
//GO.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME300
//            DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF300
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME200A
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME200B
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF200A
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF200B
//*O.FT02F001 DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME100A
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUME100B
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF100A
//*           DD DISP=SHR,DSN=F11OLS.UNIGAM87.SUMF100B
//*                        OUTPUT:
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(10,2),RLSE),DSN=F11OLS.BARRIES.PROBLEM
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0216V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*           DSN=F11OLS.REDUCTWO.G0196V00
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
C   28/03/97            MEMBER NAME  JBMWFS   (JADE56.S)    FORTRAN
//F11OLS   JOB CLASS=E,MSGLEVEL=(1,0),TIME=(0,15)
//*MAIN RELPRI=LOW
// EXEC FCLG,PARM.FORT=XL
C   READ FAST FILE AND WRITE IT OUT AGAIN
C    LTYP HAS TO BE SPECIFIED ************
C                             J.OLSSON   12.3.81
C   LAST CHANGE  24.02.83
C
      IMPLICIT INTEGER*2 (H)
#include "creso.for"
#include "cintrg.for"
#include "ctrgmn.for"
#include "cextra.for"
      DIMENSION IWRIT(999),WRIT(999),HWRIT(1998)
      EQUIVALENCE (IWRIT(1),WRIT(1)),(HWRIT(1),IWRIT(1))
      COMMON/CWORK1/IER,NTRR,TRES(10,60)
      DIMENSION ITRES(10,60),CWARR(602)
      EQUIVALENCE (TRES(1,1),ITRES(1,1)),(CWARR(1),IER)
      COMMON/CWORK/TOFDUM(984),INFM(4),IRELT(14,50)
      DIMENSION IW(704),RELT(14,50),HELP(2)
      EQUIVALENCE (IW(1),INFM(1))
      EQUIVALENCE (RELT(1,1),IRELT(1,1)),(IHELP,HELP(1))
      COMMON /COSNEU/ ISWAP,HQUAL(2),MERR
      DATA ITALC /Z7/,HELP/0,0/
C---
      IEVCN = 0
      IVRIG = 0
      LTYP = 22
      IEVMIN = 0
      IEVMAX = 27000
100   READ(2,ERR=1005,END=90) KKK,(WRIT(I),I=1,KKK)
C FILL THE ARRAYS
1213  IF(IUHR(ISECLF).NE.1) GO TO 1212
      IEVCN = IEVCN + 1
      IF((IEVCN/500)*500.EQ.IEVCN) WRITE(6,3411) IEVCN
3411  FORMAT('  RECORDS READ ',I8)
      IF(IEVCN.LT.IEVMIN) GO TO 100
      IF(IEVCN.GT.IEVMAX) GO TO 9090
      GO TO 1214
1212  IF(IUHR(ISECLF).EQ.1) GO TO 1213
      WRITE(6,3554)
3554  FORMAT(' ********** ------>>>>> *****')
      WRITE(6,3555) IEVCN,IVRIG
3555  FORMAT(' TIME LIMIT TIME LIMIT   RECORDS READ ',I8,'WRITTEN ',I8)
      WRITE(6,3554)
      GO TO 9090
C
1214  IF(IEVCN.GT.5) GO TO 3000
      IF(LTYP.LT.10) GO TO 1900
      HRUN = HWRIT(1)
      HEVENT = HWRIT(2)
      NCLST = IWRIT(2)
      NTR = IWRIT(3)
      NMOM = IWRIT(4)
      NMOMTR = IWRIT(5)
      NMTR1 = NMOMTR + 1
      NMOMGM = IWRIT(6)
      NMOMBD = IWRIT(7)
      ICOL = IWRIT(8)
      IMDEAD = IWRIT(9)
      IMIDTG = IWRIT(10)
      IMGCLO = IWRIT(11)
      IER = IWRIT(12)
      IFTG = IWRIT(13)
      HELPTR = HWRIT(27)
      HTALC = HWRIT(28)
      JELL = IWRIT(15)
      IVX = IWRIT(16)
      NRVVX = IWRIT(17)
      ETOT = WRIT(18)
      TDIF = WRIT(19)
      TOFSUM = WRIT(20)
      EBM = WRIT(21)
      ZETSUM = WRIT(22)
      ZGRZ = WRIT(23)
      COSEPL = WRIT(24)
      VXX = WRIT(25)
      VXY = WRIT(26)
      VXZ = WRIT(27)
      BKG = WRIT(28)
      HNBLO = HWRIT(57)
      III = 30
      DO 5123  I = 1,NMOM
      XMAS(I) = WRIT(III+I)
      PETRA(I) = WRIT(III+NMOM+I)
      PETOT(I) = WRIT(III+2*NMOM+I)
      FITRA(I) = WRIT(III+3*NMOM+I)
5123  TETRA(I) = WRIT(III+4*NMOM+I)
      III = III + 5*NMOM - 4
      DO 5124  I = 1,NMOM
      III = III + 4
      DO 5125  J = 1,4
5125  PAR(I,J) = WRIT(III+J)
5124  CONTINUE
      DO 5126  I = 1,NMOM
      III = III + 4
      DO 5127  J = 1,4
5127  PARCOR(I,J) = WRIT(III+J)
5126  CONTINUE
      III = III + 4
      DO 5223  I = 1,NMOMTR
      KKKTR(I) = IWRIT(III+I)
      RMN(I) = WRIT(III+NMOMTR+I)
      ZTRCK(I) = WRIT(III+2*NMOMTR+I)
      COSTR(I) = WRIT(III+3*NMOMTR+I)
      SGN(I) = WRIT(III+4*NMOMTR+I)
      ARPHIX(I) = WRIT(III+5*NMOMTR+I)
      SLOPES(I) = WRIT(III+6*NMOMTR+I)
      CRVE(I) = WRIT(III+7*NMOMTR+I)
      NRHIT(I) = IWRIT(III+8*NMOMTR+I)
5223  ITYPP(I) = IWRIT(III+9*NMOMTR+I)
      III = III + 10*NMOMTR
      DO 5741  I = 1,NMTR1
      PCHA(I) = WRIT(III+I)
5741  ECHA(I) = WRIT(III+NMTR1+I)
      III = III + 2*NMTR1 - 10
      DO 5232 J = 1,NTR
      III = III + 10
      DO 5278 I = 1,10
5278  TRES(I,J) = WRIT(III+I)
5232  CONTINUE
      III = III + 10 - 14
      DO 5233 J = 1,NTR
      III = III + 14
      DO 5279 I = 1,14
5279  RELT(I,J) = WRIT(III+I)
5233  CONTINUE
      III = III + 14 - 10
      DO 5234  I = 1,NMOMTR
      III = III + 10
      DO 5235  J = 1,10
5235  PARM(J,I) = WRIT(III + J)
5234  CONTINUE
      III = III + 10 - 4
      DO 5236  I = 1,NMOMTR
      III = III + 4
      DO 5237  J = 1,4
5237  PARM2(J,I) = WRIT(III + J)
5236  CONTINUE
      IM = HNBLO
      IF(IM.LE.0) IM = 1
      III = III + 4
      IIIH = 2*III
      DO 5339  I = 1,IM
5339  HBLOCK(I) = HWRIT(IIIH + I)
      IIIH = IIIH + IM
      III = (IIIH+1)/2
      DO 5340  I = 1,IM
5340  EBLOCK(I) = WRIT(III+I)
      III = III + IM
      III = III + 1
      NRBTOF = IWRIT(III)
      IF(NRBTOF.EQ.0) GO TO 1281
      DO 1275  JJ = 1,NRBTOF
      JJJ = 2*III + JJ
      HNTOF(JJ) = HWRIT(JJJ)
1275  CONTINUE
      III = III + (NRBTOF-1)/2 + 1
1281  III = III + 1
      NLOWHT = IWRIT(III)
      III = III + 1
      NLOWP = IWRIT(III)
      IF(NMOMGM.EQ.0) GO TO 999
C *******************************************************
C      EVENTS WITH PHOTONS IN ADDITION TO CHARGED TRACKS
C *******************************************************
C FILL PHOTON ARRAYS
      DO 5423  I = 1,NMOMGM
      KGGTR(I) = IWRIT(III+I)
5423  DPETOT(I) = WRIT(III+NMOMGM+I)
      III = III + 2*NMOMGM
      IIIH = 2*III
      DO 5431  I = 1,NMOMGM
      HGMTYP(I) = HWRIT(IIIH+I)
5431  HIBLOC(I) = HWRIT(IIIH + NMOMGM + I)
      IIIH = IIIH + 2*NMOMGM
      III = (IIIH+1)/2
      GO TO 999
C *******************************************************
C      EVENTS WITH ONLY PHOTONS
C *******************************************************
1900  CONTINUE
C ENTER HERE FOR EVENTS WITH ONLY PHOTONS
      HRUN = HWRIT(1)
      HEVENT = HWRIT(2)
      NCLST = IWRIT(2)
      NTR = IWRIT(3)
      NMOM = IWRIT(4)
      NMOMTR = IWRIT(5)
      NMTR1 = NMOMTR + 1
      NMOMGM = IWRIT(6)
      NMOMBD = IWRIT(7)
      ICOL = IWRIT(8)
      IMDEAD = IWRIT(9)
      IMIDTG = IWRIT(10)
      IMGCLO = IWRIT(11)
      IER = IWRIT(12)
      IFTG = IWRIT(13)
      HELPTR = HWRIT(27)
      HTALC = HWRIT(28)
      JELL = IWRIT(15)
      IVX = IWRIT(16)
      NRVVX = IWRIT(17)
      ETOT = WRIT(18)
      TDIF = WRIT(19)
      TOFSUM = WRIT(20)
      EBM = WRIT(21)
      ZETSUM = WRIT(22)
      ZGRZ = WRIT(23)
      COSEPL = WRIT(24)
      VXX = WRIT(25)
      VXY = WRIT(26)
      VXZ = WRIT(27)
      BKG = WRIT(28)
      HNBLO = HWRIT(57)
      III = 30
      DO 7123  I = 1,NMOM
      XMAS(I) = WRIT(III+I)
      PETRA(I) = WRIT(III+NMOM+I)
      PETOT(I) = WRIT(III+2*NMOM+I)
      FITRA(I) = WRIT(III+3*NMOM+I)
7123  TETRA(I) = WRIT(III+4*NMOM+I)
      III = III + 5*NMOM - 4
      DO 7124  I = 1,NMOM
      III = III + 4
      DO 7125  J = 1,4
7125  PAR(I,J) = WRIT(III+J)
7124  CONTINUE
      DO 7126  I = 1,NMOM
      III = III + 4
      DO 7127  J = 1,4
7127  PARCOR(I,J) = WRIT(III+J)
7126  CONTINUE
      III = III + 4
      DO 7741  I = 1,NMTR1
      PCHA(I) = WRIT(III+I)
7741  ECHA(I) = WRIT(III+NMTR1+I)
      III = III + 2*NMTR1
      IF(NTR.LE.0) GO TO 7771
      DO 7232 J = 1,NTR
      DO 7278 I = 1,10
7278  TRES(I,J) = WRIT(III+I)
      III = III + 10
7232  CONTINUE
      DO 7233 J = 1,NTR
      DO 7279 I = 1,14
7279  RELT(I,J) = WRIT(III+I)
      III = III + 14
7233  CONTINUE
7771  IM = HNBLO
      IF(IM.LE.0) IM = 1
      IIIH = 2*III
      DO 7339  I = 1,IM
7339  HBLOCK(I) = HWRIT(IIIH + I)
      IIIH = IIIH + IM
      III = (IIIH+1)/2
      DO 7340  I = 1,IM
7340  EBLOCK(I) = WRIT(III+I)
      III = III + IM
      III = III + 1
      NRBTOF = IWRIT(III)
      IF(NRBTOF.EQ.0) GO TO 7281
      DO 7275  JJ = 1,NRBTOF
      JJJ = 2*III + JJ
      HNTOF(JJ) = HWRIT(JJJ)
7275  CONTINUE
      III = III + (NRBTOF-1)/2 + 1
7281  III = III + 1
      NLOWHT = IWRIT(III)
      III = III + 1
      NLOWP = IWRIT(III)
C FILL PHOTON ARRAYS
      IF(IENT.LT.3) WRITE(6,2636) NMOMGM,III
2636  FORMAT(' ENTRY 2636 NMOMGM III ',3I8)
      DO 7423  I = 1,NMOMGM
      KGGTR(I) = IWRIT(III+I)
7423  DPETOT(I) = WRIT(III+NMOMGM+I)
      III = III + 2*NMOMGM
      IIIH = 2*III
      DO 7431  I = 1,NMOMGM
      HGMTYP(I) = HWRIT(IIIH+I)
7431  HIBLOC(I) = HWRIT(IIIH + NMOMGM + I)
      IIIH = IIIH + 2*NMOMGM
      III = (IIIH+1)/2
      III = III + 1
      IDHITS = IWRIT(III)
      III = III + 1
      MUTREF = IWRIT(III)
C *******************************************************
C  END OF EVENTS WITH ONLY PHOTONS
C  COME HERE FOR ALL TYPES OF EVENTS, BRANCH ON MONTE CARLO TYPE
C *******************************************************
999   NTRR = NTR
      INFM(1) = NTR
      IF(HRUN.GT.99) GO TO 1111
C**********************************************************
C SPECIAL ENTRY FOR MC EVENTS
C***********************************************************
      DO 1471  I = 1,6
1471  DDUM(I) = 0.
      DO 1472  I = 1,12
1472  DDUN(I) = 0.
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C MASS WWW
      DDUM(1) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C TOF WIDTH IWI
      JDUM(2) = IWRIT(III)
      IF(III.GE.KKK) GO TO 1111
C
C   LTYP = 21  MONTE CARLO
C
      IF(LTYP.NE.21)  GO TO 997
      III = III + 1
C ENERGY GAMMA1
      DDUM(3) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C BLOCK NR1 GAMMA1
      JDUM(4) = IWRIT(III)
      GO TO 1111
C
C   LTYP = 22 AND LTYP = 2     MONTE CARLO
C
997   IF(LTYP.NE.22.AND.LTYP.NE.2)  GO TO 886
      III = III + 1
C ENERGY GAMMA1
      DDUM(3) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C ENERGY GAMMA2
      DDUM(4) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C BLOCK NR1 GAMMA1
      JDUM(5) = IWRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C BLOCK NR1 GAMMA1
      JDUM(6) = IWRIT(III)
      GO TO 1111
C
C   LTYP = 4  MONTE CARLO
C
886   IF(LTYP.NE.4)  GO TO 885
      III = III + 1
C ENERGY GAMMA1
      DDUM(3) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C ENERGY GAMMA2
      DDUM(4) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C ENERGY GAMMA3
      DDUM(5) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C ENERGY GAMMA4
      DDUM(6) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C PHI GAMMA1
      DDUN(1) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C PHI GAMMA2
      DDUN(2) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C PHI GAMMA3
      DDUN(3) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C PHI GAMMA4
      DDUN(4) = WRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C BLOCK NR1 GAMMA1
      JDUM(11) = IWRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C BLOCK NR1 GAMMA2
      JDUM(12) = IWRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C BLOCK NR1 GAMMA3
      JDUM(13) = IWRIT(III)
      IF(III.GE.KKK) GO TO 1111
      III = III + 1
C BLOCK NR1 GAMMA4
      JDUM(14) = IWRIT(III)
      IF(III.GE.KKK) GO TO 1111
      GO TO 1111
885   CONTINUE
C
C**********************************************************
C  END OF SECTION FOR MC EVENTS
C  COME HERE FOR ALL TYPES OF EVENTS, BRANCH ON ITYP82
C********************************************************
C
1111  ITYP82 = 0
      IF(III.EQ.KKK) GO TO 3000
      III = III + 1
      ITYP82 = IWRIT(III)
      IF(ITYP82.EQ.0) GO TO 2802
      IIIH = 2*III + 1
      HLPTR2 = HWRIT(IIIH)
      III = (IIIH+1)/2
      IF(III.GE.KKK) GO TO 2801
      III = III + 1
      LGFLA = IWRIT(III)
      III = III + 1
      BLGTOF = WRIT(III)
      III = III + 1
      IBADC = IWRIT(III)
2802  IF(III.GE.KKK) GO TO 2801
      DO 2783  I = 1,7
      III = III + 1
      L7(I) = IWRIT(III)
2783  CONTINUE
2801  IF(LTYP.NE.2) GO TO 2812
      IF(III.GE.KKK) GO TO 2812
      IIIH = 2*III+1
      HQUAL(1) = HWRIT(IIIH)
      HQUAL(2) = HWRIT(IIIH+1)
      ISWAP = HWRIT(IIIH+2)
      MERR = HWRIT(IIIH+3)
      III = (IIIH+4)/2
      IF(III.GE.KKK) GO TO 2812
      III = III+1
      NRFWMU = IWRIT(III)
2812  CONTINUE
C  VEC4MC
      IF(HRUN.GT.99) GO TO 3000
      IF(III.GE.KKK) GO TO 3000
      III = III + 1
      MCNFIN = IWRIT(III)
      DO 6031  I = 1,MCNFIN
      DO 6032  J = 1,4
6032  VEC4MC(J,I) = WRIT(III+J)
      III = III + 4
6031  CONTINUE
      IF(III.GE.KKK) GO TO 3000
      IIIH = 2*III
      DO 7576  IJ = 1,42
      IIIH = IIIH + 1
7576  HLGBR(IJ) = HWRIT(IIIH)
      III = IIIH/2
      WRITE (6,2531)
2531  FORMAT(' - - - - - - - - - > > > > > < < < < < - - - - -')
      WRITE(6,73) HRUN,HEVENT,HTALC,HELPTR,IFTG,ITYP82,EBM
73    FORMAT(' WFS: RUN & EV ',2I8,' HTALC HELPTR IFTG ',Z4,1X,Z4,I5,
     $' ITYP82 ',I2,' EBM ',E13.5)
      IF(ITYP82.NE.0) WRITE(6,2532) HLPTR2,LGFLA,IBADC,BLGTOF
2532  FORMAT(' HLPTR2 (T1POSTP.) ',Z4,' LGFLA IBADC BLGTOF ',2I5,F8.1)
      WRITE(6,2582) L7
2582  FORMAT(' LG SEPTANT ENERGIES ',7I5)
      WRITE(6,74)
      WRITE(6,75) KKK,NMOM,NMOMTR,NMOMGM,NMOMBD,ICOL,JELL,
     $ ZETSUM,ZGRZ,COSEPL,NCLST,BKG
74    FORMAT('  KKK  NMOM NMOMTR NMOMGM NMOMBD ICOL JELL    ZETSUM
     $ZGRZ    COSEPL   NCLST    BKG')
75    FORMAT(' ',I5,I5,I7,I7,I7,I5,I5,F10.2,F10.2,F10.4,I5,F10.4)
      WRITE(6,45) IMDEAD,IMIDTG,IMGCLO,NTR,NLOWHT,NLOWP
45    FORMAT(' IMDEAD IMIDTG IMGCLO ',3I5,' NTR ',I4,' NLOWHT NLOWP ',
     $ 2I4)
      WRITE(6,76) ((FITRA(I),TETRA(I),XMAS(I)),I=1,NMOM)
76    FORMAT(' FITRA TETRA XMAS',4(3F8.4,3X))
      WRITE(6,77) ((PETRA(I),PETOT(I)),I=1,NMOM)
77    FORMAT(' PETRA PETOT ',4(2E12.4,3X))
      IF(NMOMTR.EQ.0) GO TO 991
      WRITE(6,78) ((ZTRCK(I),RMN(I)),I=1,NMOMTR)
78    FORMAT(' ZTRCK RMN ',4(2E12.4,3X))
      WRITE(6,79) ((COSTR(I),ARPHIX(I),KKKTR(I)),I=1,NMOMTR)
79    FORMAT(' COSTR ARPHIX KKKTR',4(2F8.4,I4,3X))
      WRITE(6,80) ((SLOPES(I),SGN(I)),I=1,NMOMTR)
80    FORMAT(' SLOPES SIGN ',4(E12.4,F5.0,3X))
      WRITE(6,40) ((NRHIT(I),ITYPP(I),CRVE(I)),I=1,NMOMTR)
40    FORMAT(' NRHIT ITYP CURV ',4(2I3,E15.6,3X))
      WRITE(6,81) ((PCHA(I),ECHA(I)),I=1,NMTR1)
81    FORMAT(' PCHA ECHA',5(2E11.3,1X))
991   WRITE(6,82) ((PAR(I,J),J=1,4),I=1,NMOM)
82    FORMAT(' PAR ',2(4E12.4,3X))
      WRITE(6,63) ((PARCOR(I,J),J=1,4),I=1,NMOM)
63    FORMAT(' PARCOR ',2(4E12.4,3X))
      WRITE(6,754) HNBLO,ETOT,TDIF,TOFSUM
754   FORMAT(' NR OF 1-BLOCK CLUSTERS ',I5,' ETOT TDIF TOFSUM ',3E12.4)
      IF(HNBLO.GT.0) WRITE(6,755) ((HBLOCK(I),EBLOCK(I)),I=1,HNBLO)
755   FORMAT(' BL-NR AND E ',5(I6,E12.4))
      IF(HRUN.GT.100) GO TO 5211
      WRITE(6,2431) DDUM(1),JDUM(2),MCNFIN
2431  FORMAT(' MC TOTAL MASS ',E12.4,' COPL.WIDTH ',I3,' MCNFIN ',I4)
      IF(MCNFIN.GT.0) WRITE(6,6061) ((VEC4MC(J,I),J=1,4),I=1,MCNFIN)
6061  FORMAT(' VEC4MC ',4E12.4)
      IF(LTYP.EQ.21) WRITE(6,2432) DDUM(3),JDUM(4)
2432  FORMAT(' MONTE CARLO PHOTON ENERGY ',E12.4,' BLOCK NR ',I5)
      IF(LTYP.EQ.22.OR.LTYP.EQ.2) WRITE(6,2433) DDUM(3),JDUM(5)
      IF(LTYP.EQ.22.OR.LTYP.EQ.2) WRITE(6,2433) DDUM(4),JDUM(6)
2433  FORMAT(' MONTE CARLO PHOTON ENERGIES ',E12.4,' BLOCK NR ',I5)
      IF(LTYP.EQ.4) WRITE(6,2434) (DDUM(II),II=3,6),(JDUM(II),II=11,14)
2434  FORMAT(' MONTE CARLO PHOTON ENERGIES ',4E12.4,' BLOCKS ',4I5)
      IF(LTYP.EQ.4) WRITE(6,2435) (DDUN(II),II=1,4)
2435  FORMAT(' MONTE CARLO PHOTON FI DIRECTIONS ',4E12.4)
      IF(LTYP.EQ.2) WRITE(6,2436) (HQUAL(JQ),JQ=1,2),ISWAP,MERR
2436  FORMAT(' MUON QUALITY FOR PHOTONS :',2I5,' ISWAP MERR ',2I5)
      WRITE(6,246) (HLGBR(I),I=1,42)
246   FORMAT(' HLGBR ',6I7)
C
5211  WRITE(6,2871) NRBTOF
2871  FORMAT(' NRBTOF ',I4)
      IF(NRBTOF.GT.0) WRITE(6,2872) (HNTOF(I),I=1,NRBTOF)
2872  FORMAT(' TOF COUNTERS ',10I3)
      IF(NMOMTR.EQ.0) GO TO 951
      DO 952  I = 1,NTR
      WRITE(6,83) ITRES(1,I),(TRES(K,I),K=2,7),ITRES(8,I),TRES(9,I)
83    FORMAT(' DEDX ',I4,6E12.4,I5,E12.4)
952   CONTINUE
      DO 953  I = 1,NTR
      WRITE(6,33) (IRELT(K,I),K=1,3),(RELT(K,I),K=4,14)
33    FORMAT(' TOF ',3I3,F8.3,F8.1,4F8.4,4F12.3,E12.4)
953   CONTINUE
      WRITE(6,41) ((PARM(I,J),I=1,10),J=1,NMOMTR)
41    FORMAT(' PARM ',10E12.4)
      WRITE(6,37) ((IPARM2(1,J),PARM2(2,J),IPARM2(3,J),PARM2(4,J)),J=1,
     $ NMOMTR)
37    FORMAT(' PARM2 ',I4,E12.4,I4,E12.4)
951   IF(NMOMGM.EQ.0) GO TO 3247
      WRITE(6,833) (HGMTYP(I),I=1,NMOMGM)
833   FORMAT(' HGMTYP ',10I4)
      WRITE(6,835) (HIBLOC(I),I=1,NMOMGM)
835   FORMAT(' HIBLOC ',10I4)
      WRITE(6,834) (KGGTR(I),I=1,NMOMGM)
834   FORMAT(' KGGTR ',10I4)
      WRITE(6,837) (DPETOT(I),I=1,NMOMGM)
837   FORMAT(' DPETOT ',5E12.4)
      IF(LTYP.LT.10) WRITE(6,3231) IDHITS,MUTREF
3231  FORMAT(' IDHITS AND MUTREF ',2I6)
3247  WRITE(6,3236)
3236  FORMAT('                         * * * *   ')
3000  CONTINUE
C
C       WRITE THE EVENT OUT AGAIN
C
      WRITE(3) KKK,(WRIT(I),I=1,KKK)
      IVRIG = IVRIG + 1
      IF((IVRIG/500)*500.EQ.IVRIG) WRITE(6,3412) IVRIG
3412  FORMAT('  RECORDS WRITTEN ',I8)
      GO TO 100
C
1005  WRITE(6,9104) IEVCN,IVRIG
 9104 FORMAT(' *****  READ ERROR ****  LAST EVENT READ,WRITTEN ',2I8)
      STOP
   90 CONTINUE
      WRITE(6,109) HWRIT(1),HWRIT(2)
  109 FORMAT('   END OF FILE --------->>>>    LAST EVENT : ',2I8)
9090  WRITE(6,1109) IEVCN,IVRIG
 1109 FORMAT('  NR OF EVENTS READ ',I8,'   AND WRITTEN ',I8)
      WRITE(6,1209) HWRIT(1),HWRIT(2)
 1209 FORMAT('   END OF JOB --------->>>>    LAST EVENT : ',2I8)
      STOP
      END
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=F11OLS.JADELD
//*                        INPUT:
//*O.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F11OLS.TR12FS.NEU86A
//*   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=F11OLS.MSMUMU80.B167TRGB
//*   DD UNIT=FAST,DISP=SHR,DSN=F11OLS.DISKMSC
//GO.FT02F001 DD DISP=SHR,DSN=F11OLS.TR22FS.JSRFRZ.BBLEAKWT.ALL8386
//*           DD DISP=SHR,DSN=F11OLS.TR22FS.NJS86GL2
//*                        OUTPUT:
//GO.FT03F001 DD DISP=SHR,DSN=F11OLS.TR22FS.BBLEAK.ALL8386
//*O.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*  SPACE=(TRK,(120,50),RLSE),VOL=SER=STOR05,
//*  DSN=F11OLS.TR21FS.TAPE86C
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   DSN=F11OLS.TR20FS82.TPCUT82A
//*O.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*  MSVGP=VTMP,UNIT=3330V,DSN=F11OLS.TR21FS.JSRFRZ.TAPE82A
//*GO.FT03F001 DD DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*        SPACE=(TRK,(80,10),RLSE),
//*        UNIT=3350,VOL=SER=FAST06,DSN=F11OLS.MSET80FS.PART4
//*        EXEC BACKUP,PARM='/MOVE'
C   28/03/97            MEMBER NAME  JBMWRIT4V(JADE56.S)    FORTRAN
//F11JOL   JOB 00010622,OLSSON,MSGLEVEL=(1,0),TIME=(0,15),CLASS=E
//*MAIN RELPRI=LOW
// EXEC FCLG,PARM.FORT=XL,REGION.LKED=800K,
//  REGION.GO=800K
C
      COMMON/CPROD/ NR,BEAM,PT,XNC,XNN,ECM,
     *              NP,NC,NN,PP(4,30),XM(30),ICH(30),ITP(30),IP(30,2),
     *              NF,NCF,NNF,PF(4,100),XMF(100),ICF(100),ITF(100),
     *              PSTRT(3,100)
C
      DATA NSEC / 3 /
      DATA NUNIT / 2 /
C
      IEVMIN = 0
      IEVMAX = 100000
      IWRT = 0
      NEVPRT = 5
C
      DO 1001 IEV=1,IEVMAX
      IF( JUHR(NSEC) .EQ. 2 ) GO TO 9000
      IF((IEV/500)*500.EQ.IEV) WRITE(6,4411) IEV
4411  FORMAT(' EVENTS READ  ',I10)
C
      IF(IEV.GE.IEVMIN) GO TO 1151
      READ(3,ERR=1005,END=90) NR
      GO TO 1001
CCC  READ EVENTS FROM TAPE
1151  IF(IEV.GT.IEVMAX) GO TO 90
      READ(3,ERR=1005,END=90) NR,BEAM,PT,XNC,XNN,ECM,
     *     NP,NC,NN,((PP(I4,N),I4=1,4),XM(N),ICH(N),ITP(N),
     *     (IP(N,I2),I2=1,2),N=1,NP),
     *     NF,NCF,NNF,((PF(I4,N2),I4=1,4),XMF(N2),ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
C
      IWRT = IWRT + 1
      IF(IWRT.LT.NEVPRT) WRITE(6,9769) NR,BEAM,ECM,NP,NC,NN,NF,NCF,NNF
9769  FORMAT(' NR ',I6,' BEAM ECM ',2E12.4,' NP NC NN  NF NCF NNF ',6I4)
      IF(IWRT.LT.NEVPRT) WRITE(6,9702) (((PP(LI,N),LI=1,4),XM(N),
     $ ICH(N),ITP(N)),N=1,NP)
 9702  FORMAT(' PPROD ',4E12.4,' MS CH TP ',E12.4,2I5)
      IF(IWRT.LT.NEVPRT) WRITE(6,9701) (((PF(I,N),I=1,4),XMF(N),
     $ ICF(N),ITF(N)),N=1,NF)
 9701  FORMAT(' PFIN ',4E12.4,' MS CH TP ',E12.4,2I5)
C
      CALL WRIT4V(2)
      IF((IWRT/500)*500.EQ.IWRT) WRITE(6,4410) IEV,IWRT
4410  FORMAT(' EVENTS READ AND WRITTEN ',2I10)
      GO TO 1001
C
 1005 READ(3)
      WRITE(6,9104) IEV, IWRT
 9104 FORMAT(/' *****  READ ERROR AFTER OR AT EVENT ',I6,
     *        ' EVENTS WRITTEN UP TO NOW ',I6,' *****'/)
C
 1001 CONTINUE
      GO TO 90
C
9000  WRITE(6,9001)
9001  FORMAT('  --->> TIME LIMIT      --->> TIME LIMIT ')
C
   90 CONTINUE
      WRITE(6,109) IWRT, IEV
  109 FORMAT(//2X,I6,' EVENTS HAVE BEEN WRITTEN. LAST EVENT NO.',I8)
      STOP
      END
//LKED.SYSLIB DD
//            DD
//            DD DSN=F11OLS.JADELD,DISP=SHR
//            DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(MTSTRT)
//*                 INPUT
//GO.FT03F001 DD DISP=SHR,DSN=F11OLS.ETAPRIV4.NR8
//*GO.FT03F001 DD UNIT=TAPE,DISP=OLD,
//*     DSN=F11OLS.MCTRACK1.ETAPRI.B15
//*    DD UNIT=AFF=FT03F001,DISP=OLD,DSN=F11OLS.MCVEC442.MUTR2PCT.B16P7
//*                 OUTPUT
//GO.FT02F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT02F001 DD DISP=SHR,
//*        DSN=F11OLS.MSXY
//*O.FT02F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//*   DSN=F11OLS.ETAPRI5V,
//*        MSVGP=VTMP,UNIT=3330V
//*GO.FT02F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*  SPACE=(TRK,(50,20),RLSE),DSN=F11OLS.TESTMCA
//*1O.FT02F001 DD UNIT=TAPE,DISP=(,CATLG,DELETE),
//*         DCB=R01DCB.VBS,
//*         DSN=F11OLS.MCVECSUM.MSMU6NR2.B17P3
//*GO.FT02F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(180,20)),DSN=&&SCRTCH
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*          DSN=F11OLS.MSETAPRI.BEAM18.SUM1
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY

C   08/06/86 606102122  MEMBER NAME  ENDMES   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE ENDMES( OK )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   8/06/86 :  FINAL MESSAGES ABOUT GRAPHICS
C
C
C
C     OUTPUTS THE FINAL MESSAGES FROM THE GRAPHICS PROGRAM.
C     IF OK = .FALSE., SKIP MESSAGE ABOUT OUTPUT RECORDS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8    DATE,TIME
      INTEGER*4 BINTIM
      LOGICAL   OK
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CWORK  / DATE, TIME, DUMMY, ITIME, HWORK(40), HNAM(8)
      COMMON / CSVCW1 / NDDSVE,NRWR
C
      DIMENSION  HTM1(4), HTM2(4)
      DIMENSION  HNAME(4)
C
      EQUIVALENCE  ( DATE, HTM1(1) )
      EQUIVALENCE  ( TIME, HTM2(1) )
C
      EQUIVALENCE  ( HNAM(1), HNAME(1) )
C
      DATA  HBLANK /'  '/
C
C------------------  C O D E  -----------------------------------------
C
      IF( .NOT. OK      ) GO TO 170
      IF( NDDOUT .EQ. 0 ) GO TO 170
      WRITE(JUSCRN,165) NRWR
 165  FORMAT(' The newly written records are preceded by ',I5,' records
     $on the output file')
C
 170  CALL DAY(DATE,TIME)
      DO  180  I = 1,4
        HWORK(I) = HTM1(I)
 180  CONTINUE
      HWORK(5) = HBLANK
      DO  190  I = 1,4
        HWORK(I+5) = HTM2(I)
 190  CONTINUE
C
C                            CLEAR NAME STRING
C
      DO  195  I = 1,8
        HNAM(I) = HBLANK
 195  CONTINUE
C
C                            FIND USERID
C
      CALL IDFUN(HNAME,NBOK)
C
      WRITE(6,200) (HWORK(I),I=1,9)
 200  FORMAT(' Scan session ending at DATE and TIME: ',9A2)
C
      ITIME = BINTIM(DUMMY)/360000
C
      IF(ITIME.GT.4  .AND. ITIME.LE.9  ) WRITE(6,210) (HNAM(I),I=1,5)
      IF(ITIME.GT.9  .AND. ITIME.LE.16 ) WRITE(6,220) (HNAM(I),I=1,5)
      IF(ITIME.GT.16 .AND. ITIME.LE.21 ) WRITE(6,230) (HNAM(I),I=1,5)
      IF(ITIME.GT.21 .OR.  ITIME.LE.4  ) WRITE(6,240) (HNAM(I),I=1,5)
 210  FORMAT('         Have a pleasant morning, ',4A2,'  ',A2)
 220  FORMAT('         A very good day to you, ',4A2,'  ',A2)
 230  FORMAT('         Have an enjoyable evening, ',4A2,'  ',A2)
 240  FORMAT('         Good night and sleep well, ',4A2,'  ',A2)
C
      RETURN
      END

C   01/11/84            MEMBER NAME  CREDIT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE CREDIT
C-----------------------------------------------------------------------
C
C   AUTHOR : J. OLSSON     SUMMER 79 : HANDLES JOYS COMMAND
C
C      MOD : J. OLSSON     31/08/82  :
C      MOD : P. HILL/C.B.  17/02/84  : CDTLCO --> CDST
C      MOD : C. BOWDERY    07/03/84  : REVERSE CDTL 13/20
C      MOD : C. BOWDERY    06/06/84  : USES NEW KOMMAN AND DISPLY
C LAST MOD : J. HAGEMANN   17/10/84  : USES NEW HITMRK
C
C     EDITING PATTERN RECOGNITION RESULTS FOR THE JADE INNER DETECTOR
C
C-----------------------------------------------------------------------
C
C     ENTER THIS ROUTINE AFTER PERFORMING CELL PATTERN RECOGNITION AND
C     BACKTRACING, AND BEFORE LOOPING OVER TRACKS AND WRITING RESULTS
C     BANKS (PATR AND JHTL).      THE ROUTINE KNTREL IS BYPASSED AND
C     CALLED AFTER THE EDITING IS FINISHED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
      LOGICAL TBIT,REMEMB,REMB1,REMBDT,MEASY,TRHIT,TLHT,DSP22,DSP24
      LOGICAL DSP13,DSP20,DSP17,DSP4,DSP26
      LOGICAL FL18,FL22,FL24
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CLBPGM / LBPGM(30)
      COMMON / CHEADR / HEAD(108)
C
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  KZAMP,HWORK(400),XLTR(200),YLTR(200),XLST(100),
     +                  YLST(100),HKTRAR(100),HKTRS(100)
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CJCELL / NCELL(3),NWIRES(3)
C
#include "cworkpr.for"
#include "cworkeq.for"
#include "cpatlm.for"
#include "cdata.for"
C
#include "cjdrch.for"
#include "cgeo1.for"
#include "cgraph.for"
C
      DIMENSION HELP(2),LABERR(100),HAPPY(100),HIPPIE(9,100),LBLREM(200)
C
      EQUIVALENCE (LABL,HELP(1))
      EQUIVALENCE
     +           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     +         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
C
C                            MASKS FOR TRACK NO. IN HIT LABEL
C
      DATA MSKTR1/ZFE/,MSKILL /Z10000/, MSKEEP /ZFFFEFFFF/
C
C                            MASKS FOR BAD HIT (XYFIT)
C
      DATA NPATR /'PATR'/, JHTL /'JHTL'/, LHEAD /8/,LTRBK/48/
      DATA LAB8/Z80000/,LAB80/Z800000/,LAB1/Z10000/
      DATA LBL26/Z20/
      DATA LAB3/Z30000/,LAB4/Z40000/,LAB0/Z80000000/
C
      DATA HELP/0,0/,HCALL/0/,DM/0./
C
C------------------  C O D E  ------------------------------------------
C
      CALL TRMOUT(80,'PATREC EDIT,
     $    VERSION FROM 29.05.81.^')
      IF(HEAD(18).GT.1400) ZFITLM(1) = 70.
      IF(HEAD(18).GT.1400) ZFITLM(2) = 35.
      IJHTL=IBLN('JHTL')
      IJETC=IBLN('JETC')
      IPATR=IBLN('PATR')
      IPPATR = IDATA(IPATR)
C MOVE PATR BANK TO END OF BOS DATA AND RESET LENGTH TO 0 TRACKS
      CALL CMVE(IPPATR,IER)
      IZW = IDATA(IPPATR+2)*LTRBK
      CALL BCHM(IPPATR,-IZW,IER)
      IDATA(IPPATR+1) = LHEAD
      IDATA(IPPATR+2) = 0
      IDATA(IPPATR+3) = LTRBK
      IPJHTL=IDATA(IJHTL)
C ZERO SET JHTL BANK
      CALL SETSL(IDATA(IPJHTL+2),0,4*(IDATA(IPJHTL)-1),0)
      HCALL = HCALL + 1
      IF(HCALL.GT.1) GO TO 102
      SH1 = BLDEP*.10
      SH2 = BLFI*.16667
      SH3 = 4.*SH2
      DEFIX = TWOPI/84.
102   REMEMB = DSPDTL(6)
      REMB1 = DSPDTL(10)
      ISTOLD = ISTANV
      LSTOLD = LASTVW
      ISTVWL = ISTVW
      JTVWL  = JTVW
      ISTVW = 0
      JTVW = 0
      SXINR = SXIN
      SXAXR = SXAX
      SYINR = SYIN
      SYAXR = SYAX
      IXBKKR = IXBKK(40)
      DSP22 = FL22
      DSP24 = FL24
      DSP26 = DSPDTL(26)
      DSP20 = DSPDTL(20)
      DSP28 = DSPDTL(28)
      DSP14 = DSPDTL(14)
      DSP17 = DSPDTL(17)
      DSP4  = DSPDTL(4)
      DSPDTL(4) = .FALSE.
      DSPDTL(14) = .FALSE.
      DSPDTL(17) = .TRUE.
      DSPDTL(20) = .FALSE.
      DSPDTL(26) = .FALSE.
      DSPDTL(28) = .FALSE.
C  SET FLAGS FOR FITTING PROGRAM TO PROTECT EDITING RESULTS
      IGPLM7 = IGFP(1)
      IGPLIM = IXYF(1)
      LMCERT = IMCERT
C SET FLAG TO ENABLE BOTH PREPROCESSORS IN ZRFIT
C     LMZFIT(10) = 3
      IMCERT = 1
      CALL TRMOUT(80,'IMCERT NOW = 1 (DEFAULT), CHANGE BY COMMAND 35^')
      NTRLM = 0
C     XYFIT CONTROL WORD (VIA BIT STRUCTURE)
C     BIT ON MEANS :
C     BIT 31 .. MAKE A SINGLE FIT TO THE HITS AND STOP
C     BIT 30 .. NEVER PERFORM A CIRCLE FIT
C     BIT 29 .. RECALCULATE ABERRATIONS AND MAKE ONE MORE FIT
C     BIT 28 .. STORE TRACK ELEMENT CHI**2'S WHEN BIT 31 SET
C     BIT 27 .. STOP TRYING TO REJECT WORST TRACK ELEMENT
C     BIT 26 .. NEVER CHECK L/R SOLUTION WITH FIT  (ASSURED BY LBL26)
      IXYF(1) = LOR(IXYF(1),LBL26)
      JUMP = 0
      ICFIT = 0
      IMAGE = 0
      LABHED = 0
      DO 7646 I = 1,100
7646  LABERR(I) = 0
      TRHIT = .FALSE.
      TLHT = .FALSE.
      IPJCA=IDATA(IJETC)
      IPJ = 2*IPJCA + 2
      NWO = HDATA(IPJ+97)-HDATA(IPJ+1) + 98
      NHITS = (HDATA(IPJ+97)-HDATA(IPJ+1))/4
      HPFRE0 = HPFREE
      KK = 1
      GO TO 8001
112   CALL TRMOUT(80,'CODE 0: EXIT     CODE 1:  INSTRUCTION CODE LIST
     1  CODE 2: HARDCOPY^')
      CALL TRMOUT(80,'CODE 3: JOYSTICK     CODE 4: RESET SCALE     CODE
     15: COMMENT OPTION^')
      CALL TRMOUT(80,'CODE 6: SHOW EVENT     CODE 7: CHANGE DISPLAY VIEW
     1^')
      CALL TRMOUT(80,'CODE 8: CALL GRAPHICS DISPLAY ROUTINE     CODE 9:
     1WRITE BACKTRACE RESULTS^')
      CALL TRMOUT(80,'CODE 10: DISPLAY ALL HITS ASSOCIATED WITH TRACK EL
     1EMENTS^')
      CALL TRMOUT(80,'CODE 11: DISPLAY ALL HITS NOT ASSOCIATED WITH TRAC
     1K ELEMENTS^')
      CALL TRMOUT(80,'CODE 12: DISPLAY ALL HITS ASSOCIATED WITH A PARTIC
     1ULAR TRACK ELEMENT^')
      CALL TRMOUT(80,'CODE 13: DISPLAY ALL HITS ASSOCIATED WITH TRACK EL
     1EMENTS,LR SOLVED^')
      CALL TRMOUT(80,'CODE 14: DISPLAY ALL HITS ASSOCIATED WITH TRACK EL
     1EMENTS,LR UNSOLVED^')
      CALL TRMOUT(80,'CODE 15: DISPLAY ALL HITS ASSOCIATED WITH A PARTIC
     1ULAR TRACK ELEMENT,LR SOLVED^')
      CALL TRMOUT(80,'CODE 16: DISPLAY ALL HITS ASSOCIATED WITH TRACKS.^
     1')
      CALL TRMOUT(80,'CODE 17: DISPLAY ALL HITS NOT ASSOCIATED WITH TRAC
     1KS.^')
      CALL TRMOUT(80,'CODE 18: DISPLAY ALL HITS ASSOCIATED WITH PARTICUL
     1AR TRACKS.^')
      CALL TRMOUT(80,'CODE 19: DISPLAY ALL HITS, MARKING TRACK-ASSOCIATE
     1D ONES.^')
      CALL TRMOUT(80,'CODE 20: CHANGE DISPLAY DETAILS.    CODE 21: WRITE
     1 MIDOUT ARRAYS^')
      CALL TRMOUT(80,'CODE 22: TRIAL FIT AND DISPLAY OF ALL TRACKS^')
      CALL TRMOUT(80,'CODE 23: TRIAL FIT AND DISPLAY OF SELECTED TRACK(S
     $).^')
      CALL TRMOUT(80,'CODE 24: TRACK EDITING FACILITY^')
      CALL TRMOUT(80,'CODE 25: TRACK ELEMENT EDITING FACILITY^')
      CALL TRMOUT(80,'CODE 26: DISPLAY HITS ACCORDING TO HIT LABEL BANK
     $FROM TESTFIT^')
      CALL TRMOUT(80,'CODE 27: DISPLAY RAW EVENT, MARKING SELECTED TRACK
     $S,INCLUDING MIRRORS.^')
      CALL TRMOUT(80,'CODE 28: CHANGE LIMITS IN COMMON /CPATLM/ OR COMMO
     $N /CJDRCH/^')
      CALL TRMOUT(80,'CODE 29: CREATE BACKTRACE AND MIDOUT ARRAYS FROM P
     $REVIOUS HIT LABEL ARRAY.^')
      CALL TRMOUT(80,'CODE 30: SHOW RESULTS OF ALREADY EXISTING PATR BAN
     $KS.^')
      CALL TRMOUT(80,'CODE 31: ZX AND ZY PROJECTIONS^')
      CALL TRMOUT(80,'CODE 32: CREATE NEW TRACK ELEMENT BY JOYSTICK INPU
     $T.^')
      CALL TRMOUT(80,'CODE 33: ACTIVATE/DEACTIVATE AUTOMATIC DELETION OF
     * LOW ENERGY TRACKS^')
      CALL TRMOUT(80,'CODE 34: SAVE OR RECOVER STATUS OF EDITING^')
      CALL TRMOUT(80,'CODE 35: ACTIVATE/DEACTIVATE AUTOMATIC DELETION OF
     *OVERLAPPING TRACKS^')
      CALL TRMOUT(80,'CODE 36: ACTIVATE/DEACTIVATE DISPLAY OF HITS BY TR
     *ACK NUMBERS^')
      CALL TRMOUT(80,'CODE 37: ACTIVATE/DEACTIVATE DISPLAY OF HITS BY TR
     *ACK ELEMENT NUMBERS^')
      CALL TRMOUT(80,'CODE 38: SET INNER AND OUTER RANGE LIMITS FOR HITS
     * OF A TRACK^')
      CALL TRMOUT(80,'CODE 39: CALL SUBROUTINE SPARE^')
      CALL TRMOUT(80,'CODE 9999: EXPRESS EXIT FROM EDIT^')
1601  IQQ = 0
1602  CALL TRMOUT(80,'COMMAND? (1=LIST)^')
      IXBKK(40) = IXBKKR
      CALL FYRINT(NN,NN2,NN3,NN4)
1603  NN = NN + 1
      IF(NN.NE.24) ICFIT = 0
      IF(NN.EQ.10000) GO TO 9000
      IF(IQQ.NE.0)
     $ CALL DIAGIN('NN NN2 NN3 NN4      ',4,NN,NN2,NN3,NN4,I,I)
      HALO = NN/100
      IF(NN.GE.100) NN = NN - 100
2905  IF(NN.LT.1.OR.NN.GT.41) GO TO 1601
      JNDEX = ISTANV
      IF(ISTANV.GT.7) JNDEX = JNDEX - 4
      GO TO (100,112,300,400,500,600,700,800,900,1000,1100,1100,1100
     $ ,1100,1100,1100,1700,1700,1900,1700,2100,2200,2300,2400
     $ ,2500,2600,2300,2800,2900,3000,3100,3200,3300,3400,3500,3600
     $ ,3700,3800,3900,4000,4100),NN
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
300   CALL TRMOUT(80,'ENTER YES TO CONFIRM REQUEST FOR HARDCOPY !^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 1601
      IF(NN2.EQ.0) GO TO 2131
      CALL TRMOUT(80,' TRAILING NUMBER, COPY ON EXTERNAL PRINTER^')
      CALL HDCEXT
      GO TO 1601
2131  CALL TRMOUT(80,' NO TRAILING NUMBER, COPY ON INTERNAL PRINTER^')
      CALL HDCOPY
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
400   CALL JOYS(0,0.)
      IMAGE = ISTANV
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
500   CALL SETSCL(ISTANV)
      FL22 = .FALSE.
      IMAGE = 0
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
600   CALL COMENT
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
700   CALL ERASE
      IF(HALO.EQ.1) CALL JADISP(ISTANV)
      CALL EVDISP(ISTANV)
      IF((ISTANV.LT.4.OR.ISTANV.EQ.14).AND.DSPDTL(17))
     $ CALL PROJEC(ISTANV)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
800   IF(NN2.EQ.0) GO TO 842
      KK = NN2
      GO TO 8002
842   CALL TRMOUT(80,
     1'PLEASE ENTER NUMBER OF STANDARD VIEW YOU WOULD LIKE.^')
      CALL TRMOUT(80,
     1'RA=1. RB=2. RC=3. ZXA=4. ZXB=5. ZXC=6. ZXD=7. ZYA=8. ZYB=9. ZYC=100027500
     10. ZYD=11.^')
      CALL TRMOUT(80,'FW=12. RU=13. CYL=14.^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 8002
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
8002  IF(KK.EQ.1.OR.KK.EQ.2.OR.KK.EQ.4.OR.KK.EQ.5.
     $OR.KK.EQ.8.OR.KK.EQ.9.OR.KK.EQ.14) GO TO 8001
      CALL TRMOUT(80,'NOT AVAILABLE. PLEASE TRY AGAIN.^')
      GO TO 842
8001  ISTANV = KK
      CALL SETSCL(ISTANV)
      FL22 = .FALSE.
      LASTVW = ISTANV
      IF(IMAGE.NE.ISTANV) GO TO 8051
      FL22 = .TRUE.
      XMIN = XMINR
      YMIN = YMINR
      XMAX = XMAXR
      YMAX = YMAXR
      CALL DWINDO (XMIN,XMAX,YMIN,YMAX)
8051  SXIN=XMIN
      SYIN=YMIN
      SXAX=XMAX
      SYAX=YMAX
      XXXX = XMIN
      YYYY = YMIN+.76*(YMAX-YMIN)
      CALL CHRSIZ(4)
      CALL CSIZE(IHO,IVE)
      SSSS = IVE*(YMAX-YMIN)/6240.
      YYYY = YYYY - 15.*SSSS
      SSSS = IVE*.55
      CALL MOVEA(XXXX,YYYY)
      CALL SEELOC(IHO,IVE)
      XXXX = IHO
      YYYY = IVE
      YYYY = YYYY - 3.*SSSS
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
900   CALL TRMOUT(80,'TO RETURN PROPERLY FROM GRAPHICS DISPLAY, GIVE COM
     $MAND RET^')
      CALL TRMOUT(80,'WARNING: NON DISPLAY COMMANDS WILL DESTROY YOUR ED
     $ITING WORK ...^')
      KTREL = LSTCMD
C***
 901  CALL KOMMAN
      IF( LSTCMD .GT. 100 ) GO TO 100
      CALL DISPLY
      IF( LSTCMD .EQ. 48  ) GO TO 902
      GO TO 901
C***
 902  LSTCMD = KTREL
      REMEMB = DSPDTL(6)
      REMB1 = DSPDTL(10)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C
C  WRITE BACKTRACE RESULT ARRAYS; TRACK - TRACK ELEMENT ASSOCIATION
C
1000  CONTINUE
      DO 740  ITR = 1,NTR
740   IF(NN2.EQ.0.OR.ITR.EQ.NN2)
     $ WRITE(6,7400) ITR,HNREL(ITR),(HISTR(INR,ITR),INR=1,9)
7400  FORMAT(' TRACK:',I3,' NR OF ELEMENTS:',I4,' ELEMENTS:',9I4)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C
C  TRACK ELEMENTS DISPLAY
C
1100  JNDX = NN-10
      IF(JNDX.EQ.3.OR.JNDX.EQ.6) GO TO 1300
      GO TO 222
1300  IKTR = 0
1301  CALL TRMOUT(80,'PLEASE ENTER TRACK ELEMENT NR 1 TO 100, ANY OTHER
     $TO PROCEED^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 1392
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
1392  KTREL = KK
      IF(KTREL.LE.0.OR.KTREL.GT.100) GO TO 1321
      IKTR = IKTR + 1
      IF(IKTR.LE.HNTR) GO TO 1322
      IKTR = IKTR - 1
      GO TO 222
1322  HKTRAR(IKTR) = KTREL
      GO TO 1301
1321  IF(IKTR.GT.0) GO TO 222
      CALL TRMOUT(80,'NO VALID TRACK ELEMENT NUMBER HAS BEEN ENTERED^')
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C
C  TRACK DISPLAY
C
1700  KNDX = NN-16
      GO TO 802
2800  KNDX = 5
      GO TO 1901
1900  KNDX = 3
1901  IKTR = 0
      IKTRS = 0
      IF(NN.EQ.19.AND.NN2.EQ.0) GO TO 802
      IF(NN.EQ.28.AND.NN2.EQ.0) GO TO 802
1919  IF(NN2.NE.0) KTR = NN2
      IF(NN2.NE.0) GO TO 1939
1918  CALL TRMOUT(80,'ENTER TRACK NR.^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 1399
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
1399  KTR = KK
1939  IF(NN.NE.28.OR.KTR.LE.NTR) GO TO 1940
      DO 1941  KTR = 1,NTR
      HKTRAR(KTR) = KTR
1941  HKTRS(KTR) = KTR
      IKTR = NTR
      IKTRS = NTR
      GO TO 802
1940  IF(KTR.LE.0.OR.KTR.GT.NTR) GO TO 1921
      IKTR = IKTR + 1
      IKTRS = IKTRS + 1
      IF(IKTR.LE.NTR) GO TO 1922
      IKTR = IKTR - 1
      IKTRS = IKTRS - 1
      IF(JUMP.EQ.0) GO TO 802
      GO TO 2401
1922  HKTRAR(IKTR) = KTR
      HKTRS(IKTRS) = KTR
      IF(NN2.NE.0) GO TO 1921
      GO TO 1918
1921  IF(IKTR.GT.0.AND.JUMP.EQ.0) GO TO 802
      IF(IKTR.GT.0.AND.JUMP.NE.0) GO TO 2401
      CALL TRMOUT(80,'NO VALID TRACK NUMBER HAS BEEN ENTERED^')
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  CHANGE DISPLAY DETAILS;  CODE TAKEN FROM DISPLY -------------I
C--
2100  IF(NN2.NE.0) NDTL = NN2
      IF(NN2.NE.0) GO TO 2107
2108  CALL TRMOUT(80,'PLEASE ENTER OPTION; ENTER 0 FOR LIST^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 2199
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
2199  NDTL = KK
2107  IF(NDTL.GT.0.AND.NDTL.LT.61) GO TO 2103
      CALL CDST( 0 )
      GO TO 2108
 2103 IF(NDTL.LE.30.AND.NDTL.NE.26) DSPDTL(NDTL)=.NOT.DSPDTL(NDTL)
      IF(NDTL.GT.30) DSPDTM(NDTL-30)=.NOT.DSPDTM(NDTL-30)
      IF(NDTL.EQ.26) CALL TRMOUT(80,'CDTL 26 NOT AVAILABLE, SORRY^')
      REMEMB = DSPDTL(6)
      REMB1 = DSPDTL(10)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C
C  WRITE MIDOUT ARRAYS; DETAILED INFORMATION ABOUT TRACK ELEMENTS
C
2200  WRITE(6,503) HNTR
      WRITE(6,504) (HNTCEL(I),I=1,98)
      WRITE(6,505)
      WRITE(6,506) ((I,IPCL(I),NRHT(I),NWR1(I),DS1(I),SL1(I),NWR2(I),
     $ DS2(I),SL2(I),LBL(I),NTREL(I),ICRO(I)),I=1,HNTR)
503   FORMAT(' HNTR ',I10)
504   FORMAT(' HNTCEL ',15I4)
505   FORMAT(' EL CEL NHT  WR1       DS1       SL1  WR2       DS2
     $SL2  LBL NTREL ICRO')
506   FORMAT(' ',I2,I4,I4,I5,E10.2,E10.2,I5,E10.2,E10.2,1X,Z5,I6,I5)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  TRACK FITTING AND DISPLAY, ALL TRACKS -----------------------I
C--
C     MEMORIZE 1. FREE LOC. IN CWORK
2300  IF( NN .EQ. 23  .AND.  NN2 .EQ. 0 ) DSPDTL(13) = .NOT. DSPDTL(13)
      DO 2301 I = 1,NTR
2301  HKTRAR(I) = I
      IKTR = NTR
      GO TO 2459
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  TRACK FITTING AND DISPLAY, SELECTED TRACK(S) ----------------I
C--
2400  JUMP = 1
      IF(NTR.LE.0) GO TO 1601
C PREVENT KNTREL FROM ITERATING
      IXBKK(40) = 0
      IF(NN2.NE.0) ICFIT = ICFIT + 1
      IF(ICFIT.GT.27) ICFIT = 1
      GO TO 1901
2401  JUMP = 0
C
2459  HPFRE0 = HPFREE
      CALL TRLORD
C     DO 2402  I = 1,100
C     HAPPY(I) = HNREL(I)
C     DO 2402  J= 1,9
C2402  HIPPIE(J,I) = HISTR(J,I)
C      DO 2403  I = 1,200
C2403  LBLREM(I) = LBL(I)
C      NTRREM = NTR
      IF(IQQ.NE.0) WRITE(JUSCRN,2415) IKTR,NTR,HNTR
2415  FORMAT(' IKTR AND NTR,HNTR BEFORE KNTREL ',3I6)
      CALL KNTREL(HKTRAR,IKTR)
      IPPATR=IDATA(IPATR)
      IPJHTL=IDATA(IJHTL)
      IF(IQQ.NE.0) WRITE(JUSCRN,2416) IKTR,NTR,HNTR
2416  FORMAT(' IKTR AND NTR,HNTR AFTER KNTREL ',3I6)
      IF(NN.EQ.27) GO TO 2425
      IF(NN.EQ.23) CALL RSDISP(LASTVW)
      IF((NN.EQ.23).AND.(LASTVW.EQ.13)) CALL YAMADA(0)
      IF(NN.NE.24) GO TO 2427
      DSP13 = DSPDTL(13)
      DSPDTL(13) = .FALSE.
      CALL RSDISP(LASTVW)
      IF(LASTVW.EQ.13) CALL YAMADA(0)
      DSPDTL(13) = .TRUE.
      YYY = YYYY - (ICFIT-1)*3.5*SSSS
      IPP = IPPATR + LHEAD
      IF(IDATA(IPPATR+2).GT.0) CALL TRTEXT(IPPATR,IPP,XXXX,YYY,SSSS)
      DSPDTL(13) = DSP13
2427  REMBDT = DSPDTL(16)
      ACMDRB = ACMD
      BCMDRB = BCMD
      IF(NN.EQ.23.OR.NN.EQ.24) ACMD = 99.
      IF(DSPDTL(17)) DSPDTL(16) = .TRUE.
      IF(DSPDTL(17).AND.(ISTANV.LT.4.OR.ISTANV.EQ.14).AND.
     $ IDATA(IPPATR+2).GT.0) CALL PROJEC(ISTANV)
      DSPDTL(16) = REMBDT
      ACMD = ACMDRB
      BCMD = BCMDRB
      GO TO 2426
2425  IPJHTL=IDATA(IJHTL)
      ACMDRB = ACMD
      BCMDRB = BCMD
      BCMD = FLOAT(IDATA(IPJHTL-2))
      ACMD = FLOAT(NN2)
      IF(HALO.EQ.1) ACMD = ACMD + 100.
      CALL TRKHIT
      ACMD = ACMDRB
      BCMD = BCMDRB
      IF(DSPDTL(17).AND.(ISTANV.LT.4.OR.ISTANV.EQ.14))
     $ CALL PROJEC(ISTANV)
C     RESET POINTERS AND TRACKBANK TO INITIAL STATE
2426  IPPATR=IDATA(IPATR)
      IZW = IDATA(IPPATR+2)*LTRBK
      CALL BCHM(IPPATR,-IZW,IER)
      IDATA(IPPATR+1) = LHEAD
      IDATA(IPPATR+2) = 0
      IDATA(IPPATR+3) = LTRBK
      IPJHTL=IDATA(IJHTL)
      CALL SETSL(IDATA(IPJHTL+2),0,4*(IDATA(IPJHTL)-1),0)
C     IF(IMCERT.NE.1) GO TO 2488
C     DO 2407  I = 1,100
C     HNREL(I) = HAPPY(I)
C     DO 2407  J= 1,9
C2407  HISTR(J,I) = HIPPIE(J,I)
C      NTR = NTRREM
2488  CONTINUE
2671  IF( NN .EQ .23  .AND.  NN2 .EQ. 0 ) DSPDTL(13) = .NOT. DSPDTL(13)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  TRACK EDITING  ----------------------------------------------I
C--
C-*-      GET OLD AND NEW TRACK NUMBER
2500  IF(NN2.NE.0) NTRED = NN2
      IF(NN2.NE.0) NTRNEW = NN3
      IF(NN2.NE.0) GO TO 2588
2587  CALL TRMOUT(80,'ENTER OLD&NEW TRACK (999=DELETE)^')
      CALL FYRINT(NTRED,NTRNEW,IDDD1,IDDD2)
2588  IF(NTRED.LT.1.OR.NTRED.GT.NTR.OR.NTRNEW.EQ.0) GO TO 1601
C-*-      SET POLARITY SHIFT
      IPOL = ISIGN(1,NTRNEW)
      NTRNEW = IABS(NTRNEW)
      IF(NTRNEW.EQ.999) NTRNEW = 0
      IF(NTRNEW.LE.NTRED.OR.NTRNEW.GT.NTR) GO TO 2508
      CALL TRMOUT(80,'EDITED TRACK NR MUST BE GE. NEW TRACK NR^')
      GO TO 2587
2508  NTRLED = HNREL(NTRED)
      IF(NTRNEW.LE.NTR) GO TO 2526
C-- ENTER HERE FOR RENUMBERING TRACK TO NTR + 1  (REORDERING)
      NTRNEW = NTR + 1
      HNREL(NTRNEW) = HNREL(NTRED)
      DO 2521 ITREL = 1,9
2521  HISTR(ITREL,NTRNEW) = HISTR(ITREL,NTRED)
      NTR = NTRNEW
      GO TO 2519
2526  IF(NTRNEW.EQ.0) GO TO 2509
      NTRLNW = HNREL(NTRNEW)
C-*-      REARRANGE BACKTRACE RESULT ARRAYS HISTR AND HNREL
      DO 2515  INR = 1,NTRLED
      HISTR(INR,NTRED) = IPOL*HISTR(INR,NTRED)
      IF(NTRED.EQ.NTRNEW.OR.INR+NTRLNW.GT.9) GO TO 2515
      HISTR(INR+NTRLNW,NTRNEW) = HISTR(INR,NTRED)
2515  CONTINUE
      IF(NTRED.EQ.NTRNEW) GO TO 2516
      HNREL(NTRNEW) = HNREL(NTRNEW) + HNREL(NTRED)
      IF(HNREL(NTRNEW).GT.9) HNREL(NTRNEW) = 9
CHECK IF SAME TRACK ELEMENT OCCURS TWICE
      NNREL = HNREL(NTRNEW)
      IF(NNREL.EQ.1) GO TO 2509
      NEWNRL = 0
      DO 2579  LNRL = 1, NNREL
      IF(LNRL.EQ.NNREL) GO TO 2577
      LLINRL = HISTR(LNRL,NTRNEW)
      NNREL2 = LNRL + 1
      DO 2578  JNRL = NNREL2,NNREL
      KLINRL = HISTR(JNRL,NTRNEW)
      IF(IABS(LLINRL).NE.IABS(KLINRL)) GO TO 2578
      GO TO 2579
2578  CONTINUE
2577  NEWNRL = NEWNRL + 1
      HISTR(NEWNRL,NTRNEW) = HISTR(LNRL,NTRNEW)
2579  CONTINUE
      HNREL(NTRNEW) = NEWNRL
      GO TO 2509
2516  CONTINUE
      IF(IPOL.EQ.-1) LABERR(NTRNEW) = LOR(LABERR(NTRNEW),LAB8)
      IF(IQQ.EQ.1) WRITE(JUSCRN,2712) (LABERR(I),I=1,NTR)
2712  FORMAT(' LABERR 2712 ',7(1X,Z8))
      GO TO 2731
2509  LABHED = LOR(LABHED,LAB80)
C-- ENTER HERE FOR DELETION OF TRACKS
      IF(NTRNEW.NE.0) GO TO 2513
      DO 2514  ITRL = 1,NTRLED
      ITRLX = HISTR(ITRL,NTRED)
      ITRLX = IABS(ITRLX)
2514  LBL(ITRLX) = LOR(LBL(ITRLX),MSKILL)
2513  IF(NTRNEW.EQ.0) GO TO 2519
      LABERR(NTRNEW) = LOR(LABERR(NTRNEW),LAB3)
2519  JTR = 0
      IF(IQQ.EQ.1) WRITE(JUSCRN,2710) (LABERR(I),I=1,NTR)
2710  FORMAT(' LABERR 2710 ',7(1X,Z8))
      DO 2511  ITR = 1,NTR
      IF(ITR.EQ.NTRED) GO TO 2511
      JTR = JTR + 1
      IF(ITR.LT.NTRED) GO TO 2511
      LABERR(JTR) = LABERR(ITR)
      NRTREL = HNREL(ITR)
      HNREL(JTR) = NRTREL
      DO 2512  INR = 1,NRTREL
2512  HISTR(INR,JTR) = HISTR(INR,ITR)
2511  CONTINUE
      NTR = NTR - 1
      NTRNEW = NTR
      IF(IQQ.EQ.1) WRITE(JUSCRN,2711) (LABERR(I),I=1,NTR)
2711  FORMAT(' LABERR 2711 ',7(1X,Z8))
2731  CONTINUE
C- - -   UPDATE ARRAY RLMTR, IF NECESSARY
      IF(NTRLM.LE.0.OR.NTRED.EQ.NTRNEW) GO TO 2739
      DO 2738  ITRLM = 1,NTRLM
      KTRR = LMRTR(1,ITRLM)
      IF(KTRR.NE.NTRED) GO TO 2738
      IF(NTRNEW.NE.0) GO TO 2737
      JTRLM = 0
      DO 2736  KTRLM = 1,NTRLM
      IF(NTRED.EQ.LMRTR(1,KTRLM)) GO TO 2736
      JTRLM = JTRLM + 1
      LMRTR(1,JTRLM) = LMRTR(1,KTRLM)
      RLMTR(2,JTRLM) = RLMTR(2,KTRLM)
      RLMTR(3,JTRLM) = RLMTR(3,KTRLM)
2736  CONTINUE
      IIILM = JTRLM
      GO TO 27399
2737  LMRTR(1,ITRLM) = NTRNEW
      GO TO 2739
2738  CONTINUE
      GO TO 2739
27399 NTRLM = IIILM
2739  CONTINUE
C - - - ZERO REMAINING ELEMENTS IN ARRAY HISTR, FOR CONVENIENCE OF EDIT
      DO 2732  ITR = 1,NTR
      INREL = HNREL(ITR)
      IF(INREL.GT.8) GO TO 2732
      INREL = INREL + 1
      DO 2733  JTR = INREL,9
2733  HISTR(JTR,ITR) = 0
2732  CONTINUE
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C---------             TRACK ELEMENT EDITING
C--
C --*--   GET TRACKELEMENT NUMBER AND NEW TRACK NUMBER
2600  IF(NN2.NE.0) NTELD = NN2
      IF(NN2.NE.0) NTRNEW = NN3
      IF(NN2.NE.0) GO TO 2699
2677  CALL TRMOUT(80,'ENTER TR.EL.&NEW TRACK (999=DELETE)^')
      CALL FYRINT(NTELD,NTRNEW,IDDD1,IDDD2)
2699  IF(NTELD.LT.1.OR.NTELD.GT.HNTR.OR.NTRNEW.EQ.0) GO TO 1601
      IF(NTRNEW.EQ.999) NTRNEW = 0
      IPOL = 1
      IF(NTRNEW.EQ.0) GO TO 2609
      LBL(NTELD) = LAND(LBL(NTELD),MSKEEP)
      IPOL = ISIGN(1,NTRNEW)
      IPOL1 = IPOL
      NTRNEW = IABS(NTRNEW)
      IF(NTRNEW.GT.NTR) NTRNEW = NTR + 1
      IF(NTRNEW.LE.100) GO TO 2609
      CALL TRMOUT(80,'NEW TRACK NUMBER EXCEEDS MAX.NUMBER OF TRACKS = 1000068900
     $0 ^')
      GO TO 1601
2609  CALL TRELTR(NTELD,NTROLD,KTR2)
      IF(NTRNEW.EQ.0) LBL(NTELD) = LOR(LBL(NTELD),MSKILL)
      IF(NTROLD.EQ.0) GO TO 2617
      IPOL = ISIGN(1,NTROLD)*IPOL
      NTROLD = IABS(NTROLD)
      NTRLED = HNREL(NTROLD)
      IF(NTRLED.GT.1) GO TO 2601
      WRITE(6,2611) NTROLD
2611  FORMAT(' THIS TRACK ELEM.IS THE ONLY ONE FOR TRACK ',I3,'. USE TRA
     $CK EDITING INSTEAD')
      GO TO 1601
2601  IF(NTRNEW.EQ.0) GO TO 2612
      IF(NTRNEW.GT.NTR) HNREL(NTRNEW) = 1
      NTRLNW = HNREL(NTRNEW)
      IF(NTRLNW.LT.9) GO TO 2612
      IF(NTROLD.EQ.NTRNEW) GO TO 2612
      WRITE (6,2613) NTRNEW
2613  FORMAT(' TRACK ',I3,' HAS ALREADY 9 TRACK ELEMENTS')
      GO TO 1601
2612  IF(IPOL1.LT.0) GO TO 2615
      IF(NTRNEW.GT.NTR) GO TO 2615
      DO 2614  IJ = 1,NTRLNW
      INTRLD = HISTR(IJ,NTRNEW)
      IF(NTELD.NE.IABS(INTRLD)) GO TO 2614
      CALL TRMOUT(80,'THIS TRACK ELEMENT IS ALREADY ASSOCIATED WITH THIS
     $ TRACK^')
      GO TO 1601
2614  CONTINUE
2615  IJ = 0
      IF(IQQ.NE.0)
     $CALL DIAGIN('NTLD NTN NTO IPL NTL',6,NTELD,NTRNEW,NTROLD,IPOL,
     $ NTRLED,NTR)
C --*--   UPDATE BACKTRACE RESULT ARRAYS
      DO 2602  ITRL = 1,NTRLED
      IIJJ = HISTR(ITRL,NTROLD)
      IF(NTELD.EQ.IABS(IIJJ)) GO TO 2602
      IJ = IJ + 1
      HISTR(IJ,NTROLD) = HISTR(ITRL,NTROLD)
2602  CONTINUE
      NTRLED = NTRLED - 1
      HNREL(NTROLD) = NTRLED
      LABERR(NTROLD) = LOR(LABERR(NTROLD),LAB1)
      LABERR(NTROLD) = LOR(LABERR(NTROLD),LAB4)
      IF(IQQ.EQ.1) WRITE(JUSCRN,2713) (LABERR(I),I=1,NTR)
2713  FORMAT(' LABERR 2713 ',7(1X,Z8))
      IF(IQQ.NE.0)
     $CALL DIAGHN('HISTR 1-6 NTROLD    ',6,HISTR(1,NTROLD),HISTR(2,NTROL
     $D),HISTR(3,NTROLD),HISTR(4,NTROLD),HISTR(5,NTROLD),HISTR(6,NTROLD)
     $)
      IF(IQQ.NE.0)
     $CALL DIAGHN('HNREL(NTROLD)       ',1,HNREL(NTROLD),HISTR(2,NTROLD)
     $,HISTR(3,NTROLD),HISTR(4,NTROLD),HISTR(5,NTROLD),HISTR(6,NTROLD))
2617  IF(NTRNEW.EQ.0) GO TO 2731
      LABERR(NTRNEW) = LOR(LABERR(NTRNEW),LAB1)
      LABERR(NTRNEW) = LOR(LABERR(NTRNEW),LAB4)
      IF(IQQ.EQ.1) WRITE(JUSCRN,2714) (LABERR(I),I=1,NTR)
2714  FORMAT(' LABERR 2714 ',7(1X,Z8))
      IF(NTRNEW.LE.NTR) GO TO 2623
      HISTR(1,NTRNEW) = NTELD*IPOL
      HNREL(NTRNEW) = 1
      GO TO 2634
C --*--   SECTION FOR INTERCHANGING TRACK ELEMENT
2623  NTRLED = HNREL(NTRNEW)
      HISTR(NTRLED+1,NTRNEW) = NTELD*IPOL
      HNREL(NTRNEW) = NTRLED+1
2634  IF(NTRNEW.GT.NTR) NTR = NTRNEW
      IF(IQQ.NE.0) WRITE(JUSCRN,2637) NTR
2637  FORMAT(' NTR AFTER TRACK ELEMENT EDITING ',I6)
      GO TO 2731
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  CHANGE LIMITS IN COMMON /CPATLM/ OR COMMON /CJDRCH/ ---------I
C--
2900  IF(NN2.NE.0) GO TO 2901
      CALL TRMOUT(80,'ENTER 1 FOR CHANGE OF /CPATLM/, 2 FOR /CJDRCH/^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 2999
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
2999  NN2 = KK
2901  IF(NN2.NE.1.AND.NN2.NE.2) GO TO 1601
      CALL CHANGE(NN2)
      IXBKKR = IXBKK(40)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  CREATE BACKTRACE AND MIDOUT ARRAYS FROM PREVIOUS JHTL BANK --I
C--
3000  CALL TRMOUT(80,'ENTER YES TO CONFIRM RESTORING INTENTION^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 1601
      IF(NN2.NE.0) GO TO 3021
      CALL TRMOUT(80,' ENTER BOS NUMBER OF DESIRED HIT LABEL ARRAY:^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 3099
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
3099  NBOS = KK
      GO TO 3022
3021  NBOS = NN2
3022  CALL CLOC(IPJHN,'JHTL',NBOS)
      IF(IPJHN.GT.0) GO TO 3023
      CALL TRMOUT(80,'BANK JHTL WITH THIS NUMBER DOES NOT EXIST^')
      GO TO 1601
3023  CALL RSTBTR(IPJHN)
      GO TO 2671
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  RESULT DISPLAY OF ALREADY EXISTING PATR BANKS ---------------I
C--
3100  IF(NN2.NE.0) GO TO 3101
      CALL TRMOUT(80,'PLEASE ENTER DESIRED BANK NUMBER^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 3199
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
3199  NN2 = KK
3101  REM = ACMD
      BREM = BCMD
      ACMD = FLOAT(NN2)
      CALL RSDISP(ISTANV)
      IF(ISTANV.EQ.13) CALL YAMADA(0)
      ACMD = REM
      BCMD = BREM
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C-------  DISPLAY PROJECTIONS OF ZX AND ZY VIEWS ---------------I
C--
3200  CALL PROJEC(ISTANV)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C<><><><><>_____ CREATE NEW TRACK ELEMENT ______________<><><><><><><>
C--
3300  IF(HNTR.LT.200) GO TO 3301
      CALL TRMOUT(80,'MAXIMUM NUMBER OF TRACK ELEMENTS ALREADY EXISTS^')
       GO TO 1601
3301  IF(ISTANV.LE.3.OR.ISTANV.EQ.14) GO TO 3302
      CALL TRMOUT(80,'ELEMENTS CAN ONLY BE CREATED IN R-FI VIEWS.^')
      GO TO 1601
3302  IF(NN2.NE.0) NTRNEW = NN2
      IF(NN2.NE.0) GO TO 3365
      CALL TRMOUT(80,'ENTER TRACK DESTINATION (POSITIV!)^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 3399
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
3399  NTRNEW = KK
      IF(NTRNEW.EQ.0) GO TO 1601
3365  NTRNEW = IABS(NTRNEW)
      IF(NTRNEW.GT.NTR) NTRNEW = NTR+1
      IF(NTRNEW.LE.100) GO TO 3318
      CALL TRMOUT(80,' ALREADY 100 TRACKS !^')
      GO TO 1601
3318  IF(HNREL(NTRNEW).LT.9) GO TO 3317
      CALL TRMOUT(43,'THIS TRACK HAS ALREADY NINE TRACK ELEMENTS !')
      GO TO 1601
3317  IF(NN2.EQ.0) CALL TRMOUT(80,'GIVE JOYSTICK INPUT:^')
      CALL VCURSR(HDUM,XIN,YIN)
      XIN = - XIN
      CALL MOVEA(-XIN-20.,YIN-20.)
      CALL DRAWA(-XIN+20.,YIN+20.)
      CALL MOVEA(-XIN+20.,YIN-20.)
      CALL DRAWA(-XIN-20.,YIN+20.)
      RIN = SQRT(XIN*XIN + YIN*YIN)
      CALL TRMOUT(80,'---^')
CHECK IF INSIDE SENSITIVE VOLUME OF DETECTOR AND DETERMINE RING NUMBER
      DO 3304 IRING = 1,3
      IF(RIN.GT.FIRSTW(IRING)-5..AND.RIN.LT.
     $ FIRSTW(IRING)+16.*RINCR(IRING)+5.) GO TO 3305
3304  CONTINUE
      CALL TRMOUT(80,'THIS POINT IS NOT INSIDE THE SENSITIVE VOLUME.^')
      GO TO 1601
3305  FIN = ATAN2(YIN,XIN)
      IF(FIN.LT.0.) FIN = FIN + TWOPI
      FIDEL = TWOPI/NCELL(IRING)
      KCELL = FIN/FIDEL + 1
      KCELL = KCELL + (IRING-1)*24
C  ADRESSES IN HDATA
      NILOW = HDATA(KCELL + IPJ)
      NIHIGH = HDATA(IPJ + KCELL + 1)
      NILOW = NILOW + IPJ + 98
      NIHIGH = NIHIGH + IPJ + 98
      IF(IQQ.NE.0) WRITE(JUSCRN,3321) KCELL,IRING,FIN,XIN,YIN
3321  FORMAT(' ** ',2I5,3E11.4)
      IF(NIHIGH-NILOW.GT.3) GO TO 3306
      CALL TRMOUT(80,'NO HITS IN THIS CELL !^')
      GO TO 1601
3306  NIHIGH = NIHIGH - 1
      NTELD = 0
      DISTMN = 10000.
      NI = NILOW
3307  IF(NI.GE.NIHIGH) GO TO 3311
      NIJ = NI
      IVVX = 0
      CALL FICOOR(IVVX,NI,NWE)
      ISGN = 1
      DIST = (XIN-X1)*(XIN-X1) + (YIN-Y1)*(YIN-Y1)
      IF(IQQ.NE.0) WRITE(JUSCRN,3322) DIST,DISTMN,X1,Y1,X2,Y2
3322  FORMAT(' DIST,MN XY12 ',6E11.4)
3308  IF(DIST.GE.DISTMN) GO TO 3309
      DISTMN = DIST
      NTELD = NIJ*ISGN
3309  IF(ISGN.EQ.-1) GO TO 3307
      ISGN = -1
      DIST = (XIN - X2)*(XIN - X2) + (YIN - Y2)*(YIN - Y2)
      IF(IQQ.NE.0) WRITE(JUSCRN,3327) DIST,DISTMN,ISGN
3327  FORMAT(' DIST DISTMN ISGN ',2E11.4,I5)
      GO TO 3308
3311  IF(DISTMN.LT.100.) GO TO 3310
      CALL TRMOUT(80,'NO HITS CLOSE TO THE INPUT POINT ! CLOSE WALL -->>
     $ WRONG CELL ?^')
      GO TO 1601
3310  NTRNEW = NTRNEW * ISIGN(1,NTELD)
      IF(IQQ.NE.0) WRITE(JUSCRN,3398) NTRNEW,NTELD
3398  FORMAT(' NTRNEW AND NTELD ',2I6)
      NIJ = IABS(NTELD)
      CALL FICOOR(IVVX,NIJ,NWE)
      XX = X1
      YY = Y1
      IF(NTELD.LT.0) XX = X2
      IF(NTELD.LT.0) YY = Y2
      CALL CRTREL(NTELD,IERR)
      IF(IERR.NE.0) GO TO 3499
      CALL TRNUMB(NTELD,1,XX,YY,DM)
      NTRED = NTRNEW
      GO TO 2699
3499  CALL TRMOUT(80,' ERROR IN CREATING THE TRACK ELEMENT ^')
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C ****************************************************************
C **    SWITCH ON/OFF AUTOMATIC DELETION OF LOW ENERGY TRACKS    *
C ****************************************************************
3400  IYBKK(14) = IYBKK(14) - 1
      IF(IYBKK(14).LT.0) IYBKK(14) = 1
      IF(IYBKK(14).EQ.0) CALL TRMOUT(80,'IYBKK(14)=0, LOW ENERGY TRACKS
     $ WILL NOT BE AUTOMATICALLY DELETED ^')
      IF(IYBKK(14).EQ.1) CALL TRMOUT(80,'IYBKK(14)=1, LOW ENERGY TRACKS
     $ WILL BE AUTOMATICALLY DELETED ^')
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C--       SAVE/RECOVER  CWORK CONTENT ON SCRATCH DISK FILE
C--
3500  IF(NN2.NE.0) GO TO 3501
      CALL TRMOUT(80,'PLEASE ENTER 1 TO SAVE CWORK ONTO DISK^')
      CALL TRMOUT(80,'OR 2 TO RETRIEVE DISK AND RESET CWORK.^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 3599
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
3599  NN2=KK
3501  IF(NN2.EQ.1.OR.NN2.EQ.2) GO TO 3502
      CALL TRMOUT(80,'NONEXISTING OPTION ^')
      GO TO 1601
3502  CALL RETTEN(NN2)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C--  ACTIVATE/DEACTIVATE M.GODDARDS AUTOMATIC EDITING OPTION
C--
3600  IMCERT = IMCERT - 1
      IF(IMCERT.LT.0) IMCERT = 1
      IF(IMCERT.EQ.0) CALL TRMOUT(80,'IMCERT=0, OVERLAPPING TRACKS WILL
     $ NOT BE AUTOMATICALLY DELETED ^')
      IF(IMCERT.EQ.1) CALL TRMOUT(80,'IMCERT=1, OVERLAPPING TRACKS WILL
     $ AUTOMATICALLY BE DELETED ^')
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C----ACTIVATE / DEACTIVATE HIT DISPLAY WITH TRACK OR TR.ELEMENT NUMBERS
C--
3700  TRHIT = .NOT.TRHIT
      GO TO 1601
3800  TLHT = .NOT.TLHT
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C----SET INNER AND OUTER RANGE LIMITS FOR HITS BELONGING TO A TRACK
C--
3900  IF(NN2.NE.0) KTR = NN2
      IF(NN2.NE.0) GO TO 3951
      CALL TRMOUT(80,'ENTER TRACK NUMBER^')
      CALL FYRINT(KK,KK2,KK3,KK4)
      IF(KK2.EQ.0) GO TO 3959
      NN = KK
      NN2 = KK2
      NN3 = KK3
      NN4 = KK4
      GO TO 1603
3959  KTR = KK
3951  IF(KTR.LE.0.OR.KTR.GT.NTR) GO TO 1601
      ITRLM = 0
      IF(NTRLM.EQ.0) GO TO 3954
      DO 3955 IH = 1,NTRLM
3955  IF(LMRTR(1,IH).EQ.KTR) ITRLM = IH
      IF(ITRLM.NE.0) GO TO 3952
3954  NTRLM = NTRLM + 1
      CALL TRMOUT(80,' ^')
      ITRLM = NTRLM
      IF(NTRLM.LE.5) GO TO 3952
      CALL TRMOUT(80,'ERROR... ALL POSITIONS ALREADY OCCUPIED!^')
      GO TO 1601
3952  IF(NN2.EQ.0)
     $ CALL TRMOUT(80,'ENTER INNER & OUTER LIMITS (JOYSTICK)^')
      DO 3953  IH = 1,2
      CALL VCURSR(HDUM,XIN,YIN)
      CALL MOVEA(XIN-20.,YIN-20.)
      CALL DRAWA(XIN+20.,YIN+20.)
      CALL MOVEA(XIN+20.,YIN-20.)
      CALL DRAWA(XIN-20.,YIN+20.)
      RIN = SQRT(XIN*XIN + YIN*YIN)
3953  RLMTR(1+IH,ITRLM) = RIN
      LMRTR(1,ITRLM) = KTR
      IF(RLMTR(2,ITRLM).LT.RLMTR(3,ITRLM)) GO TO 3949
      VAG = RLMTR(2,ITRLM)
      RLMTR(2,ITRLM) = RLMTR(3,ITRLM)
      RLMTR(3,ITRLM) = VAG
3949  IF(IQQ.NE.0) WRITE(6,3961) KTR,NTRLM,ITRLM,RLMTR(2,ITRLM),RLMTR(3,
     $ITRLM)
3961  FORMAT(' KTR NTRLM ITRLM R1-2 ',3I5,2E12.4)
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C--------------------------CALL SUBROUTINE SPARE------I
C--
4000  ACMDR = ACMD
      BCMDR = BCMD
      ACMD = FLOAT(NN2)
      CALL SPARE
      ACMD = ACMDR
      BCMD = BCMDR
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C
C  DEBUG PRINT SECTION, NOT IN NORMAL CODE LIST !
C
4100  IF(NN2.EQ.0) GO TO 3901
      IPPATR=IDATA(IPATR)
      WRITE (JUSCRN,3002) IPPATR,ACMD,IDATA(IPPATR-1)
     ,,IDATA(IPPATR-2)
3002  FORMAT(' IPPATR ACMD IDATA-1-2 ',I6,E11.4,2I8)
      WRITE (JUSCRN,3003) LASTVW,ISTANV,FL18,FL22
      WRITE (JUSCRN,3004) XMIN,YMIN,XMAX,YMAX
      WRITE (JUSCRN,3005) SXIN,SYIN,SXAX,SYAX
3003  FORMAT(' LASTVW ISTANV DSPT 18 -22 ',4I4)
3004  FORMAT(' XYMIN XYMAX ',4E12.4)
3005  FORMAT(' SXYIN SXYAX ',4E12.4)
      GO TO 1601
3901  IQQ = 1
      IF(NDDOUT.EQ.0) GO TO 1602
      CALL TRMOUT(80,'ENTER YES TO CONFIRM PRINT OPTION !^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 1602
      GOTO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C--------------------------TRACK ELEMENT DISPLAY SECTION------I
C--
C--  LOOP OVER NR OF WORDS IN EVENT
222   NI = IPJ + 95
      IHIT = 0
      HIHIT = -1
      NTRCL1 = HNTCEL(25) - 1
      NTRCL2 = HNTCEL(49) - 1
      MICKY = 0
      DO 8765  IZ = 1,200
      XLTR(IZ) = 0.
8765  YLTR(IZ) = 0.
802   CALL ERASE
      IF(HALO.EQ.1) CALL JADISP(ISTANV)
C---     WRITE OUT EVENT CAPTION.
      CALL CAPMRK(ISTANV,IESUM)
C---     WRITE PATREC CAPTION
      XXX = .55*(XMAX-XMIN) + XMIN
      YYY = .72*(YMAX-YMIN) + YMIN
      CALL MOVEA(XXX,YYY)
      CALL CORE(HWORK,42)
      WRITE(10,6799) NTR,HNTR
6799  FORMAT(' NR OF TRACKS ',I3,'    NR OF TR.ELEMENTS ',I3)
      CALL EOUTST(42,HWORK)
      IF(DSPDTL(17).AND.(ISTANV.LT.4.OR.ISTANV.EQ.14))
     $ CALL PROJEC(ISTANV)
      IF((NN.GT.16.AND.NN.LT.21).OR.NN.EQ.28) GO TO 801
224   NI = NI + 4
201   IHIT = IHIT + 1
      IF(IHIT.GT.NHITS) GO TO 2055
      HIHIT = HIHIT + 2
      IHIT1 = HIHIT
      IHIT2 = HIHIT + 1
      HELP(2) = HWRK(HPHL0+IHIT1-1)
      IF(IQQ.NE.0) WRITE(6,7500) IHIT,NI,HELP(2)
7500  FORMAT(' IHIT,NI,HELP2 ',2I8,2X,Z4)
      IF(LABL.EQ.0.AND.JNDX.EQ.2) GO TO 221
      IF(LABL.EQ.0.AND.JNDX.NE.2) GO TO 224
      IF(JNDX.EQ.1.OR.JNDX.EQ.3) GO TO 221
      IF(TBIT(LABL,20).AND.(JNDX.EQ.4.OR.JNDX.EQ.6)) GO TO 221
      IF(.NOT.TBIT(LABL,20).AND.JNDX.EQ.5) GO TO 221
      GO TO 224
221   ITRP = 1
      ITREL = LAND(LABL,MSKTR1)
      ITREL = SHFTR(ITREL,1)
      IF(IQQ.NE.0)
     $ CALL DIAGIN('JNDX ITREL IHIT NI  ',4,JNDX,ITREL,IHIT,NI,I,I)
      IF(JNDX.NE.3.AND.JNDX.NE.6) GO TO 2233
      DO 9255  IKT = 1,IKTR
9255  IF(HKTRAR(IKT).EQ.ITREL) GO TO 2233
      GO TO 224
2233  ISGN = 0
      IF(IQQ.NE.0) WRITE(6,2575) LABL,ITREL
2575  FORMAT(' LABL,ITREL ',Z4,I8)
      IF(JNDX.LT.4.OR..NOT.TBIT(LABL,20)) GO TO 223
      IF(ITRP.EQ.1.AND.TBIT(LABL,23)) ISGN = 1
C     IF(ITRP.EQ.2.AND.TBIT(LABL,19)) ISGN = 1
      IF(ITRP.EQ.1.AND..NOT.TBIT(LABL,23)) ISGN = -1
C     IF(ITRP.EQ.2.AND..NOT.TBIT(LABL,19)) ISGN = -1
223   IF(IQQ.NE.0) WRITE(6,2576) LABL,ITRP,ISGN
2576  FORMAT(' LABL,ITRP,ISGN ',Z4,2I8)
      IVVX = 0
      IF(ISTANV.GT.3.AND.ISTANV.LT.12) IVVX = 1
      IF(ISTANV.EQ.14) IVVX = 2
      NWIR = HDATA(NI)
      NWIR = SHFTR(NWIR,3)
      IRNG = NWIR/384
      IF(IRNG.GT.2) IRNG = 2
      IF(IRNG.GT.0) MICKY = NTRCL1
      IF(IRNG.GT.1) MICKY = NTRCL2
      KZAMP = 0
      CALL FICOOR(IVVX,NI,NWE)
      IF(NWE.LT.-500) GO TO 225
      IF(ISTANV.LT.4.OR.ISTANV.EQ.14) GO TO 7589
      IF(DSPDTL(9)) Y0 = R
C      GET PROJECTED Y-COORDINATE
       IF(ISTANV.LE.7) YPRO =  R*COS(FI)
       IF(ISTANV.GT.7) YPRO =  R*SIN(FI)
      IF(.NOT.DSPDTL(9)) Y0 = YPRO
      IF(JNDX.EQ.2) GO TO 2205
      XLTR(ITREL+MICKY) = - ZET
      YLTR(ITREL+MICKY) = Y0
2205  CALL HITMRK( JNDEX, ZET, Y0, 4.0, 0 )
      GO TO 205
C     CONVERSION TO XY OF PICTURE
7589  IF(ISGN.LT.0) GO TO 204
      IF(JNDX.EQ.2) GO TO 2206
      XLTR(ITREL+MICKY) = X1
      YLTR(ITREL+MICKY) = Y1
2206  CALL HITMRK( ISTANV, -X1, Y1, 4.0, 0 )
204   IF(ISGN.GT.0) GO TO 205
      IF(JNDX.EQ.2) GO TO 2207
      XLTR(ITREL+MICKY) = X2
      YLTR(ITREL+MICKY) = Y2
2207  CALL HITMRK( ISTANV, -X2, Y2, 4.0, 0 )
205   IF(IQQ.NE.0) WRITE(6,207) ITREL,IRNG,NWE,X1,Y1,X2,Y2
207   FORMAT(' TREL&RING&NWE ',3I4,' XY1 XY2 ',4F10.2)
      IF(NI.LE.(IPJ+NWO)) GO TO 201
      IF(JNDX.EQ.2) GO TO 225
C** WRITE OUT TRACK ELEMENT NUMBERS ON SCREEN
2055  IF(IQQ.NE.0) WRITE(6,2057) HNTR
2057  FORMAT(' HNTR = ',I10)
      DO 9876  II = 1,HNTR
      XXPR = XLTR(II)
      YYPR = YLTR(II)
      IF(ABS(XXPR).LT..1.AND.ABS(YYPR).LT..1) GO TO 9876
      ITTREL = NTREL(II)
      CALL TRNUMB(ITTREL,0,XXPR,YYPR,DM)
9876  CONTINUE
225   IF(ISTANV.GT.1..AND.ISTANV.LT.4) CALL PBGRFI(SH1,SH2,SH3,DEFIX)
      IF(ISTANV.GT.4..AND.ISTANV.LT.12.AND.ISTANV.NE.8)
     $ CALL PBGRZ(ISTANV,SH1,SH2,SH3)
      IF(ISTANV.EQ.14) CALL PBGCYL(DEFIX)
      IF(ISTANV.LT.4) CALL HODRFI
      GO TO 1601
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C--------------------------TRACK DISPLAY SECTION------I
C--
801   GO TO (810,810,813,810,815), KNDX
810   CONTINUE
      DO 823  ITR = 1,NTR
823   HKTRAR(ITR) = ITR
      IKTR = NTR
      GO TO (811,812,813,814), KNDX
811   CALL HITDSP(IKTR,0,0,0,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
      GO TO 225
812   CALL HITDSP(IKTR,1,1,0,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
      GO TO 225
814   CALL HITDSP(IKTR,0,0,1,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
      CALL HITDSP(IKTR,1,1,0,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
      GO TO 225
813   IF(NN2.EQ.0) GO TO 824
      CALL HITDSP(IKTR,0,0,1,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
827   IKL = 0
      IF(IKTRS.LE.0) GO TO 1601
      DO 825  ITR = 1,NTR
      DO 826  IKS = 1,IKTRS
826   IF(ITR.EQ.HKTRS(IKS)) GO TO 825
      IKL = IKL + 1
      HKTRAR(IKL) = ITR
825   CONTINUE
      IKTR = IKL
      GO TO 811
824   IKTRS = 0
828   CALL TRMOUT(80,'ENTER TRACK NR.^')
      CALL FYRINT(KTR,NN2,NN3,NN4)
      IF(NN2.EQ.0) GO TO 8281
      NN = KTR
      GO TO 1603
8281  IF(KTR.LE.0.OR.KTR.GT.NTR) GO TO 827
      IKTRS = IKTRS + 1
      IF(IKTRS.GT.NTR) GO TO 225
      HKTRS(IKTRS) = KTR
      HKTRAR(1) = KTR
      CALL HITDSP(1,0,0,1,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
      GO TO 828
815   IF(NN2.EQ.0) GO TO 834
      CALL HITDSP(IKTR,0,1,1,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
831   CALL HITDSP(IKTR,1,1,0,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
      GO TO 225
834   IKTR = 0
838   IF(IKTR.GT.NTR) GO TO 225
      CALL TRMOUT(80,'ENTER TRACK NR.^')
      CALL FYRINT(KTR,NN2,NN3,NN4)
      IF(NN2.EQ.0) GO TO 8381
      NN = KTR
      GO TO 1603
8381  IF(KTR.LE.0.OR.KTR.GT.NTR) GO TO 837
      IKTR = IKTR + 1
      HKTRS(IKTR) = KTR
      HKTRAR(1) = KTR
      CALL HITDSP(1,0,1,1,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
      GO TO 838
837   IF(KTR.LE.0) GO TO 8371
      IKTR = 0
      DO 8372  IKT = 1,NTR
      IKTR = IKTR + 1
      HKTRS(IKTR) = IKT
      HKTRAR(1) = IKT
8372  CALL HITDSP(1,0,1,1,TRHIT,TLHT,JNDEX,REMEMB,REMB1,IQQ)
8371  IF(IKTR.LE.0) GO TO 1601
      DO 839  IKT = 1,IKTR
839   HKTRAR(IKT) = HKTRS(IKT)
      GO TO 831
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C--
C------------------------------ ACTIONS BEFORE LEAVING EDITING -------
C--
100   CALL TRMOUT(80,'DO YOU REALLY WANT TO LEAVE ?^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 1601
      ILEAVE = 0
      CALL TRMOUT(80,'SHALL PATREC RESULTS BE SAVED IN BANKS?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 95
      CALL TRMOUT(80,'ENTER YES TO DESTROY YOUR EDIT WORK !^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 100
9000  IPJHTL=IDATA(IJHTL)
      NBOS = IDATA(IPJHTL-2)
      CALL BDLS(JHTL,NBOS)
      IPPATR=IDATA(IPATR)
      NBOS = IDATA(IPPATR-2)
      CALL BDLS(NPATR,NBOS)
      GO TO 9999
C--------
95    ILEAVE = 1
C     CALL RETTEN(1)
      IPJHTL=IDATA(IJHTL)
      NBNK = IDATA(IPJHTL-2)
      IPPATR=IDATA(IPATR)
      NBNK2 = IDATA(IPPATR-2)
      WRITE(6,3335) NBNK,NBNK2
3335  FORMAT(' EDITED BANKS  JHTL ',I2,' AND PATR ',I2,' HAVE BEEN CREAT
     $ED')
C
C            LOOP OVER TRACKS, WRITE BANKS
C
      IF(NTR.LE.0) GO TO 980
C
C     MEMORIZE 1. FREE LOC. IN CWORK
      HPFRE0 = HPFREE
C
      DO 7876 I = 1,NTR
7876  HKTRAR(I) = I
      CALL TRLORD
      CALL KNTREL(HKTRAR,NTR)
      IPPATR=IDATA(IPATR)
      IPJHTL=IDATA(IJHTL)
C              SET EDITING MARKER
      IPTRBK = IPPATR + LHEAD
      NTR   = IDATA(IPPATR+ 2)
      DO 7877 ITR = 1,NTR
      IDATA(IPTRBK+LTRBK) = LOR(IDATA(IPTRBK+LTRBK),LABERR(ITR))
      LABHED = LOR(IDATA(IPTRBK+LTRBK),LABHED)
C     INCREASE POINTER TO TRACK BANK
7877  IPTRBK = IPTRBK + LTRBK
C
980   IDATA(IPPATR+LHEAD) = LOR(LABHED,IDATA(IPPATR+LHEAD))
C
C-- PROMPT SCANNER FOR HIS OPINION AND INFORMATION ON BAD TRACKS
969   CALL TRMOUT(80,'DO YOU THINK THAT THE TRACK ANALYSIS OF THIS EVENT
     $ IS CORRECT ?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 9999
      KITR = 0
970   CALL TRMOUT(80,'PLEASE ENTER FAULTY TRACK NUMBER;  ENTER 0 TO FINI
     $SH SEQUENCE^')
      ITR = TERNUM(DUM)
      IF(ITR.GE.0.AND.ITR.LE.NTR) GO TO 971
974   CALL TRMOUT(80,'NON-EXISTING TRACK NUMBER ENTERED, TRY AGAIN !^')
      GO TO 970
971   IF(ITR.GT.0) GO TO 972
      IF(KITR.GT.0) GO TO 9999
      CALL TRMOUT(80,'ATTEMPT TO FINISH WITHOUT GIVING FAULTY TRACK NR.,
     $ BACK TO BEGIN AGAIN^')
      GO TO 969
972   KITR = KITR + 1
      IPPATR=IDATA(IPATR)
      IF(KITR.EQ.1) IDATA(IPPATR+LHEAD) = BITON(IDATA(IPPATR+LHEAD),0)
C  MARK THE FAULTY NUMBER
      LO = IPPATR-40
      DO 973  JTR = 1,NTR
      LO = LO + 48
      IF(IQQ.EQ.1) WRITE(JUSCRN,2879) IPPATR,LO,ITR,IDATA(LO+1),IDATA(LO
     $+48)
2879  FORMAT(' IPPATR LO ITR IDLO1 IDLO48 ',4I6,2X,Z8)
      IF(IDATA(LO+1).NE.ITR) GO TO 973
      IDATA(LO+48) = BITON(IDATA(LO+48),0)
      IDATA(LO+48) = LOR(IDATA(LO+48),LAB0)
      GO TO 970
973   CONTINUE
      GO TO 974
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
9999  ISTANV = ISTOLD
      LASTVW = LSTOLD
      SXIN = SXINR
      SYIN = SYINR
      SXAX = SXAXR
      SYAX = SYAXR
      FL22 = DSP22
      FL24 = DSP24
      DSPDTL(28) = DSP28
      DSPDTL(26) = DSP26
      DSPDTL(20) = DSP20
      DSPDTL(17) = DSP17
      DSPDTL(14) = DSP14
      DSPDTL(4) = DSP4
      IXBKK(40) = IXBKKR
      CALL SETSCL(LASTVW)
      IXYF(1) = IGPLIM
      IGFP(1) = IGPLM7
      IMCERT = LMCERT
      DSPDTL(10) = REMB1
      DSPDTL(6) = REMEMB
C     IF(ILEAVE.EQ.1) CALL TRMOUT(80,'CHECK YOUR CREATED PATR BANK TO SE
C    $E THAT IT HAS REALLY BEEN CREATED!^')
      IF(ILEAVE.EQ.1) CALL TRMOUT(80,'USE COMMAND WRIT TO WRITE !^')
      RETURN
      END

C   09/03/84 406201632  MEMBER NAME  JOYS     (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JOYS(N,A)
C-----------------------------------------------------------------------
C
C   AUTHOR:  J. OLSSON         ?    : HANDLES JOYS COMMAND
C
C      MOD:  C. BOWDERY     9/03/84 : TRAP DIVIDE CHECK ERROR
C      MOD:  C. BOWDERY    11/03/84 : ENSURE PICTURE ALWAYS ON SCREEN
C LAST MOD:  C. BOWDERY    12/03/84 : PROTECT AGAINST -VE MAGNIFICATION
C
C     THIS ROUTINE HANDLES THE JOYSTICK IN THE GRAPHICS PROGRAM.
C
C     JOYS             A = 0.0     USER DEFINES A BOX
C     JOYS A           A > 0.0     USER DEFINES CENTRE, A = MAGNIF.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FL18,FL22,FL24
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CWORK1 / HWORK(40),SIZEWN,RANGE,XCENT,YCENT
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
C------------------  C O D E  ------------------------------------------
C
C                            STORE EXISTING COORDINATES IN CASE OF ERROR
C
      XMINOL = XMIN
      XMAXOL = XMAX
      YMINOL = YMIN
      YMAXOL = YMAX
C                            WAS THERE A TRAILING NON-ZERO NUMBER?
C
      IF( A .NE. 0.0 ) GO TO 3
C
C                            FLASH CURSOR ON SCREEN AND AWAIT RESULT
C
      CALL VCURSR(HWORK(1),XMIN,YMIN)
C
C                            DRAW CROSS LINES TO MARK POSITION
C
      CALL MOVEA( XMIN   , YMINOL )
      CALL DRAWA( XMIN   , YMAX   )
      CALL MOVEA( XMINOL , YMIN   )
      CALL DRAWA( XMAX   , YMIN   )
C
C                            FLASH CURSOR ON SCREEN AND AWAIT RESULT
C
      CALL VCURSR(HWORK(1),XMAX,YMAX)
C
C                            DRAW CROSS LINES TO MARK POSITION
C
      CALL MOVEA( XMAX   , YMINOL )
      CALL DRAWA( XMAX   , YMAXOL )
      CALL MOVEA( XMINOL , YMAX   )
      CALL DRAWA( XMAXOL , YMAX   )
C
C                            CHECK THAT THE USER HAS DEFINED A BOX
C                            WITH NON-ZERO DIMENSIONS
C
      IF( XMAX .NE. XMIN   .AND.   YMAX .NE. YMIN ) GO TO 1
        WRITE(JUSCRN,2)
  2     FORMAT( ' ===> ERROR:  BOX HAS ZERO AREA!'/
     +          ' ===> ACTION: COMMAND IGNORED')
        CALL PROMPT
        XMIN = XMINOL
        XMAX = XMAXOL
        YMIN = YMINOL
        YMAX = YMAXOL
        GO TO 8
C
C                            ENSURE 2ND CURSOR POSITION DRAWN
C
  1   CALL TRMOUT(80,'VIEW WILL BE RE-DRAWN^')
C
      XSIZE  = ABS(XMAX - XMIN)
      YSIZE  = ABS(YMAX - YMIN)
C
C                            ALLOW FOR MISSING TOP OF SCREEN PICTURE
C
      SIZEWN = AMAX1( XSIZE , 3.0 * YSIZE / 2.0 )
C
C                            IF SCALE DETERMINED BY YSIZE THEN CENTRE
C                            PICTURE IN X
C
      OFFSET = 0.0
      IF( SIZEWN .NE .XSIZE ) OFFSET = ( SIZEWN - XSIZE ) / 2.0
C
      IF( XMIN .LE. XMAX ) GO TO 4
      XMIN   = XMAX
  4   XMIN   = XMIN - OFFSET
      XMAX   = XMIN + SIZEWN
C
C                            IF SCALE DETERMINED BY XSIZE THEN CENTRE
C                            PICTURE IN Y
C
      OFFSET = 0.0
      IF( SIZEWN .EQ .XSIZE )
     +                OFFSET = ( 2.0 * SIZEWN / 3.0 - YSIZE ) / 2.0
C
      IF( YMIN .LE. YMAX ) GO TO 5
      YMIN   = YMAX
  5   YMIN   = YMIN - OFFSET
      YMAX   = YMIN + SIZEWN
      GO TO 6
C
C                            USER MUST PROVIDE CENTRE POINT ONLY
C
  3   IF( A .GT. 0.0 ) GO TO 30
        WRITE(JUSCRN,31)
 31     FORMAT(' ===> ERROR:  MAGNIFICATION CANNOT BE NEGATIVE'/
     +         ' ===> ACTION: COMMAND IGNORED BUT PICTURE RE-DRAWN')
        CALL PROMPT
        GO TO 8
 30   CALL VCURSR(HWORK(1),XCENT,YCENT)
      RANGE = (XMAX - XMIN)*0.5/A
C
C                            CENTRE OF SCREEN IS NOT CENTRE OF WINDOW
C                            (THE OFFSETS USE EMPIRICAL CONSTANTS)
C
      XMIN   = XCENT - RANGE
      XMAX   = XCENT + RANGE
      OFFSET = ( XMAX - XMIN ) * 0.01
      XMIN   = XMIN - OFFSET
      XMAX   = XMAX - OFFSET
C
      YMIN   = YCENT - RANGE
      YMAX   = YCENT + RANGE
      OFFSET = ( YMAX - YMIN ) * 0.1144
      YMIN   = YMIN + OFFSET
      YMAX   = YMAX + OFFSET
C
  6   CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
C
C                            MAGNIFIED VIEW
C
      FL22  = .TRUE.
C
  8   XMINR = XMIN
      YMINR = YMIN
      XMAXR = XMAX
      YMAXR = YMAX
C
      RETURN
      END

C   28/05/82 504230959  MEMBER NAME  MUCHAN   (JADEMUS)     FORTRAN
C   28/05/82 504221732  MEMBER NAME  MUCHAN2  (MUCALIB.S)   FORTRAN
C   28/05/82 504211226  MEMBER NAME  MUCHAN   (JADEMUS)     FORTRAN
C   27/05/82 205271455  MEMBER NAME  MUCHAN   (S)           FORTRAN
C   27/10/81 110271013  MEMBER NAME  MUCHAN   (JADEMUS1)    FORTRAN
C   12/06/81 110261518  MEMBER NAME  MUCHAN   (S)           FORTRAN
C
C LAST CHANGE 14.50 22/04/85 P. WARMING   - CTLO/CTHI HANDLING IMPROVED
C                                          FOR UPDATE MODE, ONLY THE
C                                          CHANGED VALUES ARE STORED.
C      CHANGE 11.40 29/06/82 HUGH MCCANN  - ADD /CMUED/ .
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C      CHANGE 10.15  27/10/81   HUGH MCCANN  -CORRECT HVDRFT BUG.
C
C
C*********************************************************************
C  THIS ROUTINE CHECKS WHETHER LOCATION NHMUCA HAS BEEN CHANGED BY
C  A PREVIOUS EDIT ( IN THE CURRENT SET ).
C  IF SO , LOCEDT IS SET TO THE LOCATION OF THE PREVIOUS CHANGED
C  VALUE IN HUPDAT.
C  THEN HUPDAT(LOCHAN) IS SET TO THE NEW VALUE OF HMUCAL(NHMUCA).
C
C  ONLY ACCEPT IALPH=6 (CTLO) OR IALPH=7 (CTHI) CHANGES IF ONE OR
C  MORE HALF-WORDS IN THE RANGE OF LOCATIONS 1907-2540 ( INC. )
C  HAVE CHANGED ( I.E. IF AND ONLY IF ONE OR MORE CTW'S HAVE CHANGED.)
C***********************************************************************
C
      SUBROUTINE MUCHAN(I)
C
C
      IMPLICIT INTEGER*2 (H)
C
C     COMMONS:
#include "cmucalib.for"
#include "cmuedwrk.for"
#include "cmued.for"
C
      DIMENSION HPOINT(21)
      DATA HPOINT/  33,1415,1497,1579,1661,1743,1825,2541,1907,
     *    3175,3176,3810,4444,7615,8249,8255,8261,8267,8273, 1907,1497/
C     COMMENTS:   OVAL,DIST, ANG,CLLO,CLHI,CTLO,CTHI, CTW,  D1,
C          VDR, DTP, LTP, LSF,MCST,BLLO,BLHI,BTLO,BTHI,BNLM, ACTW,AANG/
C
      INTEGER*2 HCHFST(83)
     *           /1,22,28,34,40,46,52,58,64,70,76,82,88,94,115,121,127,
     *     133,139,145,151,157,163,169,175,181,187,195,203,210,217,224,
     *     231,238,245,252,259,267,275,281,287,293,299,305,311,317,323,
     *     329,335,341,347,353,359,365,371,377,383,389,395,401,407,413,
     *     419,425,431,437,443,455,467,479,491,503,515,527,539,551,563,
     *     575,587,599,611,623,635/
C     COMMENT: NUMBER OF FIRST CHAMBER IN EACH FRAME.
C
C-----------------------------------------------------------------------
      IF(IALPH.NE.6.AND.IALPH.NE.7)GO TO 20
      IF(IALPH.EQ.7)RETURN
      IF(NCHAN.EQ.0)RETURN
C
      IF (HAC(1).EQ.1 .AND. HAL(1).NE.0) GOTO 11
      IF (NFRAMS.NE.82) WRITE(6,7701) NFRAMS
 7701 FORMAT(/' ++++++++++++ ATTENTION ++++++++++++++ IN S/R MUCHAN',
     *        ' VARIABLE NFRAMS.NE.82 BUT SET TO 82 <--------------'/)
      NFRAMS = 82
      DO 10 K=1,NFRAMS
         HAC(K) = HCHFST(K)
         HAL(K) = HCHFST(K+1) - 1
   10 CONTINUE
C
   11 CONTINUE
      LOCHAN = NCHAN
      DO 15 J=1,LOCHAN
         IF(HLOC(J).LE.1906 .OR. HLOC(J).GE.2541) GO TO 15
         DO 14 K=1,NFRAMS
            IF (HLOC(J)-1906.EQ.HAC(K)) GOTO 12
            IF (HLOC(J)-1906.EQ.HAL(K)) GOTO 13
            GOTO 14
   12       HCTLO(K) = HUPDAT(J) - 150
            NCHAN  = NCHAN + 1
            NHMUCA = HPOINT(6)-1 + K
            HLOC(NCHAN)  = NHMUCA
            HUPDAT(NCHAN)= HCTLO(K)
CCCCC       WRITE(6,9991)J,HLOC(J),HUPDAT(J), NCHAN,NHMUCA,HUPDAT(NCHAN)
C9991       FORMAT(' CHECK CTLO: J,LOC,CTW, NEW J,LOC,CTLO:',6I6)
            GOTO 14
   13       HCTHI(K) = HUPDAT(J) + 150
            NCHAN  = NCHAN + 1
            NHMUCA = HPOINT(7)-1 + K
            HLOC(NCHAN)  = NHMUCA
            HUPDAT(NCHAN)= HCTHI(K)
CCCCC       WRITE(6,9992)J,HLOC(J),HUPDAT(J), NCHAN,NHMUCA,HUPDAT(NCHAN)
C9992       FORMAT(' CHECK CTHI: J,LOC,CTW, NEW J,LOC,CTHI:',6I6)
            GOTO 14
   14    CONTINUE
   15 CONTINUE
      RETURN
C
   20 NCHAN=NCHAN+1
      LOCHAN=NCHAN
      NHMUCA=HPOINT(IALPH)+I-1
      IF(NCHAN.EQ.1)GO TO 3002
      JEND = NCHAN-1
      DO 3001 J=1,JEND
      IF(HLOC(J).NE.NHMUCA) GO TO 3001
      LOCHAN=J
      NCHAN=NCHAN-1
      GO TO 3002
 3001 CONTINUE
 3002 HUPDAT(LOCHAN)=HMUCAL(NHMUCA)
      HLOC(LOCHAN)=NHMUCA
      RETURN
      END
C
      BLOCK DATA
C
      IMPLICIT INTEGER*2 (H)
C
C
#include "cmued.for"
C
      DATA NCHAN/0/
      END

C   18/10/77 311301710  MEMBER NAME  EEPAIR   (S)           FORTRAN
      SUBROUTINE EEPAIR (PGAM,P1,P2,XRAD,*)
C
C     THIS ROUTINE CONVERTS PHOTONS INTO E+E-PAIRS IN A RADIATOR OF
C      THICKNESS XRAD IN RADIATION LENGTH
C     (ENERGIES IN GEV)
C
      DIMENSION PGAM(4),P(2,3),TH(2),PHI(2) ,P1(10),P2(10),
     *          PN1(3),PN2(3)
      REAL ME/.511E-03/ , PI/3.14159/
C
      IF(PGAM(4).LE.0) RETURN 1
C
C     THE PROBABILITY FOR PAIR PRODUCTION IS FITTED TO ROSSI DATA
C
      PPROB=EXP(-XRAD*7./9.*(1.-6.2E-02/SQRT(PGAM(4))))
      IF (PGAM(4).GE.5) PPROB=EXP(-XRAD*7./9.)
   13 IF(PPROB.GT.RN(DUM)) RETURN 1
C
C     DETERMINE THE ENRGIE OF EACH PARTICLE. THE HIGH ENERGY LIMIT IS
C     EXTRAPOLATED FROM LOWER ENERGIES (ROSSI P.83.)
C
    1 V=RN(DUM)
      IF((V-.5)) 8,8,9
    8 Y=V
      GOTO 11
    9 Y=(1.-V)
   11 VPROB=(V**2+(1.-V)**2+.6382*V*(1.-V))*(1.-3.2E-03/(PGAM(4)**.7*Y))
      IF (VPROB.LT.RN(DUM)) GOTO 1
C
C     DETERMINE THE MEAN SQUARE ANGLE BETWEEN THE ELKTRON AND
C     THE PRIMARY PHOTON.(ROSSI P.83/85)
C
      TH(1)=.56*V**(-.8)*ME/PGAM(4)*ALOG(PGAM(4)/ME)
      TH(2)=.56*(1.-V)**(-.8)*ME/PGAM(4)*ALOG(PGAM(4)/ME)
C
C     CALCULATE THE FOUR MOMENTUM VECTORS OF ELEKTRON AND POSITRON
C
      A=SQRT(PGAM(1)**2+PGAM(2)**2)
      DO 3 I=1,2
      PHI(I)=RN(DUM)*2*PI
      E1=PGAM(4)*V
      E2=PGAM(4)*(1.-V)
      IF(A) 4,4,5
    4 P(I,1)=TH(I)*COS(PHI(I))
      P(I,2)=TH(I)*SIN(PHI(I))
      P(I,3)=PGAM(3)/PGAM(4)
      GO TO 7
    5 P(I,1)=(TH(I)*(PGAM(3)*PGAM(1)*COS(PHI(I))/(PGAM(4)*A)+PGAM(2)*
     *SIN(PHI(I))/A)+PGAM(1)/PGAM(4))
      P(I,2)=(TH(I)*(PGAM(I)*SIN(PHI(I))/A-PGAM(3)*PGAM(2)*COS(PHI(I))/
     *A)+PGAM(2)/PGAM(4))
      P(I,3)=(PGAM(3)/PGAM(4)-TH(I)*COS(PHI(I))*A/PGAM(4))
    7 CONTINUE
    3 CONTINUE
      DO6 I=1,3
      PN1(I)=P(1,I)/SQRT(P(1,1)**2+P(1,2)**2+P(1,3)**2)
    6 PN2(I)=P(2,I)/SQRT(P(2,1)**2+P(2,2)**2+P(2,3)**2)
      DO15  I=1,3
      P1(I)=E1*PN1(I)
   15 P2(I)=E2*PN2(I)
      P1(4)=E1
      P2(4)=E2
      P1(5)=ME
      P2(5)=ME
      P1(6)=SQRT(P1(1)**2+P1(2)**2+P1(3)**2)
      P2(6)=SQRT(P2(1)**2+P2(2)**2+P2(3)**2)
      P1(7)=1.
      P2(7)=-1.
      RETURN
      END

C   07/12/84 412071452  MEMBER NAME  TAGPOS   (S)           FORTRAN
C
C
C
C
C
C
       SUBROUTINE TAGPOS(SUM,ISHALL)
C
C
C ROUTINE TO FIND POSITION OF CENTRE OF CLUSTER
C
C SUM - INPUT - SUM OF ENERGY IN CLUSTER
C ISHALL - INPUT - FLAG TO SAY TURN ON THE DEBUGG INFO
C                  (1 = YES 0 = NO )
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
C
       IF ( MARK .EQ. 1 ) CALL TAGPS1(SUM,ISHALL)
       IF ( MARK .EQ. 2 ) CALL TAGPS2(SUM,ISHALL)
       RETURN
       END

C   08/06/83 308081851  MEMBER NAME  MUFFLX   (JADEMUS)     FORTRAN
C
C LAST CHANGE 03.11 14/07/83 HUGH MCCANN - VARIOUS CHANGES.
C      CHANGE 12.17 05/05/83 CHRIS BOWDERY- GENERAL TIDY-UP. NEW HAMB=2200000400
C      CHANGE 22.04 27/04/83 CHRIS BOWDERY- FIX BUG WITH IAPPRO+BAD HIT
C      CHANGE 19.10 16/03/82 CHRIS BOWDERY- FOR 'LET-OFF' CHECK (LOCH)
C      CHANGE 14.30 04/02/82 HUGH MCCANN  - CORRECT TREATMENT OF CASE
C                                           WHERE ALL HITS ARE BAD.
C      CHANGE 11.30 18/10/81 HUGH MCCANN  - CORRECT MUR2/3 COCK-UP.
C      CHANGE 10.05 15/10/81 HUGH MCCANN  - PROTECT LAYRAB (<= 10).
C      CHANGE 08.30 12/10/81 HUGH MCCANN  - FOR OVERLAP HITS.
C
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLX(HAMB)
C-----------------------------------------------------------------------
C
C        THIS SUBROUTINE CALCULATES CHI-SQUARED AND SELECTS THE BEST
C        HIT COMBINATION.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C             COMMONS AND ARRAY DECLARATIONS
C
C   20/10/81 202041521  MEMBER NAME  CMUFWORK (JADEMUS)     FORTRAN
C   12/10/81 110152138  MEMBER NAME  CMUFWORK (JADEMUS1)    FORTRAN
C-------------START OF MACRO CMUFWORK-----------------------------------
C LAST CHANGED 21.30 15/10/81 HUGH MCCANN  - EXTEND IOVLAP TO ALLOW
C                                            > 10 ASSOC HITS IN MUFFLY.
C LAST CHANGED 10.00 04/10/81 HUGH MCCANN  - FOR USE OF OVERLAP HITS.
C LAST CHANGED 14.46 17/06/81 JOHN ALLISON - TO ADD 'OVER' VARIABLES.
C LAST CHANGED 23.00 09/04/81 HUGH MCCANN - JADEMUS UPDATE.
C
      COMMON /CWORK/X,Y,Z,DCX,DCY,DCZ,P,PSQ,E,ESQ,D,GM,AB,RD,DE,PPIDK,
     *PKDK,PPBPEN,PPPEN,PPIPEN,PKPEN,DUMW1(29),X8,Y8,Z8,DCX8,DCY8,
     *DCZ8,P8,PSQ8,E8,ESQ8,D8,GM8,AB8,RD8,DE8,PPIDK8,PKDK8,PPBPE8,
     *PPPEN8,PPIPE8,PKPEN8,DUMW28(29),X0,Y0,Z0,DCX0,DCY0,DCZ0,P0,PSQ0,
     *E0,ESQ0,D0,GM0,AB0,RD0,DE0,PPIDK0,PKDK0,PPBPE0,PPPEN0,PPIPE0,
     *PKPEN0,DUMW2(29),X9,Y9,Z9,DCX9,DCY9,DCZ9,P9,PSQ9,E9,ESQ9,D9,GM9,
     *AB9,RD9,DE9,PPIDK9,PKDK9,PPBPE9,PPPEN9,PPIPE9,PKPEN9,DUMW29(29),
C-----200 WORDS UP TO HERE----------------------------------------------
     *X1,Y1,Z1,X2,Y2,Z2,XMID,YMID,ZMID,X3,Y3,Z3,D1,D2,D3,DTC,DUMW3(4),
     *DSTEP,GMSTEP,ABSTEP,RDSTEP,DESTEP,DUMW4(15),ADCZ,COSEC,STPINI,CURV
     *,DANG,DX,DY,DZ,R,RSQ,PT,DPINA,DKNA,DUMW5(7),VX,VY,VZ,RMSXY,RMSZ,
     *VTXYD,VTZD,VTXYAN,VTZANG,VMSANG,VMSD,CMS,DUMW6(8),SDS(10),DUMW7(1000002000
C
C    *SDX,SDY,SDZ,SDTXYD,SDTZD,SDTXYA,SDTZAN,SDMSAN,SDMSD,SDCMS,DM7(10),
C
C NOTE ABOVE CARD SHORTENED TO SDS(10),DUMW7(10), SO THAT STATEMENT DOES
C   NOT EXCEED 19 CONTINUATION CARDS.  I THINK SD--'S ARE NOT USED.
     *),CHISQT,NDFT,CHIPRT,CHISTL,NDFTL,CHIPTL,NBADCH,DUMW8(13),IDTRK,
     *NCEPTS,NTHIS,INEFF,NHLAYR,INFLAG,NELIPS,NGLAYR,DUMW9(72),IREG(200)
C-----600 WORDS UP TO HERE----------------------------------------------
     *,RDOTD(200),CINT(3,200),NFLAG(200),ITEM(200),EM(30,30),DALONG(10),
C-----2710 WORDS UP TO HERE---------------------------------------------
     *DEV(30),VXYDA(10),VZDA(10),CXYA(10),CZA(10),INCUT(30),BADA(30),G(200003100
     *0,20),DEVA(20),IPERM(10),MWORK(20),ITHISA(10),IJA(10),EM1(20,20),E
     *MG(20,20),ELIPSE(700),INCHAM(10),INREG(10),IAPPRO(30),HBADCH(1000)
     *,CTDASH(10),CLDASH(10),VTDASH(10),VLDASH(10),IHTREG(20),LAYRAB,IEF
C-----5421 WORDS UP TO HERE---------------------------------------------
     *FRG(10),DUMW10(69),AAA(10),BBB(10),CCC(10),DDD(10),DOVER,GMOVER,AB
     *OVER,RDOVER,DEOVER,DUMW11(55),X7(50),IHTP(30),IOVLAP(20,20)
C-----6080 WORDS UP TO HERE---------------------------------------------
      DIMENSION ILIPSE(700)
      INTEGER*2 HLIPSE(1400)
      DIMENSION IHTPER(10),IHTEMP(10),IPTEMP(10)
      EQUIVALENCE (ILIPSE(1),HLIPSE(1),ELIPSE(1))
      EQUIVALENCE (IHTP(1) ,IHTPER(1)),
     *            (IHTP(11),IHTEMP(1)),
     *            (IHTP(21),IPTEMP(1))
      LOGICAL INCUT,BADA
C
C-----------------------------------------------------------------------
C
C THE FIRST 50 LOCATIONS ARE RESERVED FOR SPECIAL WORKING VARIABLES.
C THE NEXT 150 LOCATIONS ARE RESERVED FOR COPIES OF THESE SPECIAL
C    VARIABLES, IF, E.G., ONE WISHES TO PRESERVE THEIR VALUES AT
C    THE BEGINNING OF A STEP.
C THE COPIES HAVE A SUFFIX 0 FOR VALUES AT LAST ASSOCIATED HIT.
C THE COPIES HAVE A SUFFIX 7 FOR VALUES AFTER LEAD-GLASS BARREL OR
C    YOKE END-PLUG (X7 IS LATER IN COMMON - SEE BELOW).
C THE COPIES HAVE A SUFFIX 8 FOR VALUES AT LAST BUT ONE GOOD
C    CHAMBER LAYER.
C THE COPIES HAVE A SUFFIX 9 FOR VALUES AT LAST GOOD CHAMBER LAYER.
C NSPECI (SET IN BLOCK DATA BEHIND MUFFLE) IS THE NUMBER OF SUCH
C    VARIABLES ACTUALLY USED.
C
C SPECIAL VARIABLES....
C
C X,Y,Z       = CURRENT COORDINATES.
C DCX,DCY,DCZ = CURRENT DIRECTION COSINES OF TRACK.
C P,PSQ       = CURRENT MOMENTUM (AND ITS SQUARE).
C E,ESQ       = CURRENT ENERGY (AND ITS SQUARE).
C D           = CURRENT DISTANCE FROM VERTEX (MM).
C GM          = MATERIAL TRAVERSED TO CURRENT POSITION (GM CM**-2).
C AB          = ABSORPTION LENGTHS SO FAR.
C RD          = RADIATION LENGTHS SO FAR.
C DE          = ENERGY LOSS (GEV).
C PPIDK       = PROBABILITY OF PION DECAYING TO MUON BEFORE INTERACTING.
C PKDK        = PROBABILITY OF KAON DECAYING TO MUON BEFORE INTERACTING.
C PPBPEN      = ANTI-PROTON ) ( PENETRATION PROBABILITY, I.E. PROBAB-
C PPPEN       = PROTON      ) ( ILITY OF NOT BEING ABSORBED BY A NUCLEUS
C PPIPEN      = PI          ) ( AND NOT DECAYING.  SEE SUBROUTINE
C PKPEN       = K           ) ( MUFFLS FOR FURTHER DETAILS.
C
C-----------------------------------------------------------------------
C
C THE NEXT 200 LOCATIONS ARE RESERVED FOR VARIABLES THAT DO NOT NEED
C    SPECIAL PRESERVATION.
C
C OTHER VARIABLES...
C
C X1,Y1,Z1    = COORDS OF 1ST POINT ON TRACK.
C X2,Y2,Z2    = COORDS OF LAST POINT ON TRACK.
C XMID,YMID,ZMID = COORDS OF MID POINT ON TRACK.
C X3,Y3,Z3    = COORDS OF POINT WHERE TRACK LEAVES MAGNETIC FIELD.
C D1          = DISTANCE TRAVELLED TO (X1,Y1,Z1).
C D2          = DISTANCE TRAVELLED TO (X2,Y2,Z2).
C D3          = DISTANCE TRAVELLED TO (X3,Y3,Z3).
C DTC         = DISTANCE TRAVELLED TO MID-POINT OF TRACK.
C
C DSTEP       = STEP LENGTH THIS STEP (FOR MUFFLU) (MM).
C GMSTEP      = MATERIAL THIS STEP (GM CM**-2).
C ABSTEP      = ABSORPTION LENGTHS THIS STEP.
C RDSTEP      = RADIATION LENGTHS THIS STEP.
C DESTEP      = ENERGY LOSS OF MINIMUM IONISING PARTICLE THIS STEP,
C
C ADCZ        = ABS(DCZ)
C COSEC       = ABS(COSEC(THETA)), WHERE THETA IS ANGLE TO BEAM.
C STPINI      = STEP LENGTH IN INITIAL TRACKING TO COIL OR END PLUG.
C CURV        = CURVATURE FROM 'PATR' BANK.
C DANG        = ANGLE OF TURN FOR EACH STEP.
C DX,DY,DZ    = CHANGES OF X,Y,Z.
C R,RSQ       = DISTANCE FROM BEAM (RADIUS) AND ITS SQUARE.
C PT          = MOMENTUM COMPONENT PERPENDICULAR TO BEAM.
C DPINA       = INTEGRAL OF (DECAY LENGTH)*(PROBABILTY OF NOT INTER-
C                 ACTING) FOR PION. (NO LONGER USED. CAN BE RESURECTED
C DKNA        = SIMILARLY FOR KAON. (BY UN-COMMENTING IN MUFFLS.
C
C VX,VY,VZ    = CURRENT VARIANCES ON X,Y,Z.
C RMSXY       = RMS DEV. NORMAL TO CHORD IN XY FIT.     )
C RMSZ        = RMS Z DEV. IN RZ FIT.                   ) FROM
C VTXYD       = VARIANCE ON DEVIATION NORMAL TO         ) TRACK
C                 TRACK IN XY PLANE AT TRACK CENTRE.    ) RECON-
C VTZD        = VARIANCE ON DEVIATION NORMAL TO         ) STRUCTION
C                 TRACK IN RZ PLANE AT TRACK CENTRE.    ) ERRORS.
C VTXYAN      = VARIANCE ON ANGLE IN XY PLANE (PHI)     )
C VTZANG      = VARIANCE ON ANGLE IN RZ PLANE (THETA)   )
C VMSANG      = VARIANCE OF MULTIPLE SCATTERING ANGLE.
C VMSD        = VARIANCE OF MULTIPLE SCATTERING DEVIATION NORMAL TO
C                 TRACK.
C CMS         = COVARIANCE OF ABOVE TWO QUANTITIES.
C SD--        = CORRESPONDING STANDARD DEVIATIONS (SQUARE ROOTS).
C
C CHISQT      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFT        = NUMBER OF DEGREES OF FREEDOM.           ) (DRIFT)
C CHIPRT      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C CHISTL      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFTL       = NUMBER OF DEGREES OF FREEDOM.           ) & LONG'L
C CHIPTL      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C NBADCH      = NO. OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C
C IDTRK       = INNER DETECTOR TRACK NUMBER.
C NCEPTS      = NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS       = NUMBER OF MUON HITS ASSOCIATED WITH PROJECTED INNER
C                DETECTOR TRACK.
C INEFF       = NUMBER OF INEFFICIENCIES IN MUON SYSTEM FOUND THIS TRACK
C NHLAYR      = NUMBER WHICH REPRESENTS NUMBER OF MUON LAYERS WITH
C                ASSOCIATED MUON HITS. ADD 1 FOR THE INNER LAYER AND
C                2 FOR EACH SUBSEQUENT LAYER.
C INFLAG      = 1 IF LAST LAYER INTERCEPTED WAS INEFFICIENT.
C NELIPS      = NUMBER OF MULTIPLE SCATTERING ELIPSES ENTERED IN ELIPSE.
C NGLAYR      = AS NHLAYR, BUT FOR 'GOOD' LAYERS WHETHER THERE WAS AN
C                ASSOCIATED HIT OR NOT.
C
C-----------------------------------------------------------------------
C
C THE NEXT 1400 LOCATIONS USED BY MUREGY (CALCULATES REGION INTERCEPTS).
C
C IREG        = REGION NUMBER.                           )(IN PAIRS,I.E.
C RDOTD       = R.DOT.(DIR. COSINES) FOR EACH INTERCEPT. )( 2 INTERCEPTS
C CINT        = X,Y,Z COORDINATES OF EACH INTERCEPT.     )( PER REGION.
C NFLAG       = USED INTERNALLY BY MUREGY.
C ITEM        = USED INTERNALLY BY MUREGY.
C
C-----------------------------------------------------------------------
C
C THE NEXT 3600 LOCATIONS USED BY MUFFLE, ETC., TO ACCUMULATE
C   QUANTITIES NEEDED FOR CALCULATING CHI-SQUARED. IN THE DESCRIPTION
C   BELOW I,J GO AS FOLLOWS..
C     1   LEFT DRIFT COORDINATE    )  OF 1ST
C     2   RIGHT DRIFT COORDINATE   )  ASSOCIATED
C     3   LONGITUDINAL COORDINATE  )  HIT
C     4    ETC. FOR NEXT ASSOCIATED HIT.
C   K REFERS TO K'TH ASSOCIATED HIT.
C
C EM(I,J)     = 'ERROR MATRIX', I.E. VARIANCE (I=J) OR COVARIANCE (I.NE.
C                J) FOR COORDINATE I,J.
C DALONG(K)   = DISTANCE OF ASSOCIATED HIT K ALONG TRACK.
C DEV(I)      = DEVIATION OF COORDINATE I FROM EXTRAPOLATED INNER
C                DETECTOR TRACK.
C VXYDA(K)    = VARIANCE ON DEVIATION IN XY PLANE FOR HIT K.
C VZDA(K)     = VARIANCE ON DEVIATION IN RZ PLANE FOR HIT K.
C CXYA(K)     = COVARIANCE BETWEEN DEVIATION AND ANGLE IN XY PLANE.
C CZA(K)      = COVARIANCE BETWEEN DEVIATION AND ANGLE IN RZ PLANE.
C INCUT(I)    = .TRUE. IF COORDINATE I IS IN CUT (SEE MUFFLY).
C BADA(I)     = .TRUE. IF COORDINATE I IS BAD.
C G           = INVERSE ERROR MATRIX.
C DEVA        = CORRESPONDING DEVIATIONS.
C IPERM(K)    = USED TO PERMUTE LEFT/RIGHT AMBIGUITIES.
C MWORK       = USED BY MATRIX INVERTING ROUTINE AS WORKING SPACE.
C ITHISA(K)   = HIT NUMBER OF K'TH ASSOCIATED HIT.
C IJA(K)      = INDEX FOR K'TH ASSOCIATED HIT FOR ENTRY IN BANKS 2 & 3.
C EM1         = COPY OF RELEVANT PART OF ERROR MATRIX FOR TEST PURPOSES.
C EMG         = PRODUCT OF ERROR MATRIX AND ITS INVERSE. SHOULD BE UNIT
C                MATRIX. USED FOR TEST PURPOSES.
C ELIPSE      = TEMPORARY STORAGE FOR MULTIPLE SCATTERING ELIPSES.
C INCHAM      = LIST OF INEFFICIENT CHAMBERS ON THIS TRACK.
C INREG       = LIST OF INEFFICIENT REGIONS (PLANES) ON THIS TRACK.
C IAPPRO      = USED AS WORKING SPACE IN MUFFLX.
C HBADCH      = LIST OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C CTDASH(K)   = TRANSVERSE COORD. ESTIMATED FROM I.D. PROJECTION.
C CLDASH(K)   = LONGITUD'L COORD. ESTIMATED FROM I.D. PROJECTION.
C VTDASH(K)   = VARIANCE ON CTDASH.
C VLDASH(K)   = VARIANCE ON CLDASH (FOR K'TH ASSOCIATED HIT).
C
C-----------------------------------------------------------------------
C
C THE NEXT  380 LOCATIONS USED FOR VARIOUS IMPROVEMENTS TO MUFFLE, ETC.
C
C IHTREG      = FOR EACH ASSOCIATED HIT, THE REGION NO. IN WHICH
C               THE HIT OCCURS.
C LAYRAB      = ABSOLUTE NO. OF LAYERS WHICH HAVE ASSOCIATED HITS.
C IEFFRG      = LIST OF REGION NOS. OF THOSE REGIONS WHICH HAVE AN
C               ASSOCIATED HIT.
C   IHTPER = FLAG FOR EACH ASSOCIATED HIT TO TELL IF IT'S TO
C            GO FORWARD INTO THE CHI**2 CALCULATION . ONLY ONE
C            HIT PER LAYER IS TO BE USED ,APART FROM OVERLAP HITS.
C   IHTEMP = LIST OF HITS WHICH ARE TEMPORARILY IN THE HIT PERMUTATION
C            DUE TO OVERLAPS WITH THE CURRENT AMBIGUITYOF ONE OF THE
C            HITS IN IHTPER.
C   IPTEMP =  AS IHTEMP, BUT FOR L/R AMBIGUITIES.
C IOVLAP   =  MATRIX OF OVERLAP HITS. IOVLAP(I,J)=1 MEANS THAT THERE
C             IS AN OVERLAP BETWEEN ASSOCIATED HITS I & J ( I & J BOTH
C             IN THE RANGE 1 TO NTHIS ).
C AAA(K)      = TRANSFORMATION COEFF. A FOR K'TH ASSOCD. HIT.
C BBB(K)      = TRANSFORMATION COEFF. B FOR K'TH ASSOCD. HIT.
C CCC(K)      = TRANSFORMATION COEFF. C FOR K'TH ASSOCD. HIT.
C DDD(K)      = TRANSFORMATION COEFF. D FOR K'TH ASSOCD. HIT.
C
C DOVER, ETC. = STORES QUANTITIES LEFT OVER AFTER LEAVING LAST ABSORBER.
C
C X7          = VALUES OF SPECIAL VARIABLES AFTER LEAD-GLASS BARREL OR
C               YOKE END-PLUG - USED FOR RE-FITTING, ETC.
C
C-------------END OF MACRO CMUFWORK-------------------------------------
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                REGZE(60),LOCHRS(60),ABLOCH(60)
C
      DIMENSION HAMB(1)
      DIMENSION LHIT(10),LHC(10,10),LAMB(10),LPERM(10),LAYER(10)
      DIMENSION IHTMIN(10),ILRMIN(10),LOPERM(10),LOHPER(10)
C
C-----------------------------------------------------------------------
C             DEFINITIONS
C-----------------------------------------------------------------------
C
C   LHIT   = THE NO. OF ASSOCIATED HITS IN EACH OF THE 'LAYRAB'
C            LAYERS WHICH HAVE ASSOCIATED HITS.
C   LHC    = LAYER-HIT CORRELATION ARRAY :
C                  LHC(I,J) CONTAINS THE HIT NO. ( WITHIN 1 --> NTHISS )
C                           OF THE JTH. ASSOCIATED HIT IN THE ITH.
C                           LAYER WHICH HAS ASSOCIATED HITS.
C   NAMB   = THE NO. OF LAYERS WHICH HAVE > 1 ASSOCIATED HIT.
C   LAMB   = ARRAY CONTAINING THE INDEX ( WITHIN 1--> LAYRAB ) OF
C            THOSE LAYERS WHICH HAVE > 1 ASSOCIATED HIT.
C   LAYER  = FOR ASSD EACH HIT ( LABELLED 1 --> NTHISS ), ITS LAYER
C            NO. ( LABELLED 1 --> LAYRAB ) .
C
C   IHTPER = ARRAY (1 --> NTHISS ) WITH 1 OR 0 TO FLAG WHETHER A HIT IS
C            IN THE CURRENT HIT PERMUTATION
C   IHTEMP = ARRAY (1 --> NTHISS ) WITH 1 OR 0 TO FLAG WHETHER A HIT IS
C            AN ADDITIONAL, OVERLAP HIT IN THE CURRENT HIT PERMUTATION
C   LOHPER = IHTPER + IHTEMP OF CURRENT LOWEST CHI**2 /NDF FOR CURRENT
C            HIT PERMUTATION.
C   IPERM  = ARRAY (1 --> NTHISS ) WITH 1 OR -1 TO FLAG AMBIGUITY OF
C            HITS IN THE CURRENT PERMUTATION. 0 = HIT NOT IN THIS PERM.
C   IPTEMP = ARRAY (1 --> NTHISS ) WITH 1 OR -1 TO FLAG AMBIGUITY OF
C            ADDITIONAL OVERLAP HITS IN THE CURRENT PERMUTATION.
C   LOPERM = IPERM + IPTEMP OF CURRENT LOWEST CHI**2 /NDF FOR CURRENT
C            HIT PERMUTATION.
C   IHTMIN = ARRAY (1 --> NTHISS ) WITH IHTPER OF FINAL SOLUTION
C   ILRMIN = ARRAY (1 --> NTHISS ) WITH LOPERM OF FINAL SOLUTION
C
C            N.B. LOPERM * LOHPER ARE REQUIRED IN THIS VERSION, WHERE
C                 OVERLAP HITS ARE USED IN THE CHI**2 CALCULATION.
C                 SIMILARLY, FOR THE L/R AMBIGUITY PERMUTATION,
C                 CHI**2/NO. OF DEGREES OF FREEDOM IS NOW THE VARIABLE
C                 WHICH DEFINES THE BEST PERMUTATION.
C
C                 ALSO NOTE THAT NTHISS = NTHIS UNLESS NTHIS > 10
C
C--------- M E T H O D   O F   S O L U T I O N -------------------------
C
C  CHOVND = CHI**2 / NO. OF DEGREES OF FREEDOM (DRIFT COORDS ONLY)
C
C  THE SOLUTION IS THAT HIT * L/R PERMUTATION WITH LOWEST CHOVND.
C
C  DCHISQ / IDNDF = DRIFT CHI**2 / NDF OF SOLUTION
C  ZCHISQ / IZNDF = DRIFT + LONGL CHI**2 / NDF OF SOLUTION    (NOT DONE)
C
C-----------------------------------------------------------------------
C
C             INITIALISE THE ABOVE VARIABLES FOR THIS TRACK.
C
      CALL VZERO (REGDEV,30)
      CALL VZERO (IHTPER,10)
      CALL VZERO (IHTEMP,10)
      CALL VZERO (IPTEMP,10)
      CALL VZERO (LHIT  ,10)
      CALL VZERO (LHC  ,100)
      CALL VZERO (LAMB  ,10)
      CALL VZERO (LAYER ,10)
      CALL VZERO (IHTMIN,10)
      CALL VZERO (ILRMIN,10)
      CALL VZERO (LOPERM,10)
      CALL VZERO (LOHPER,10)
      NAMB   = 0
      CHOVND = 1.E19 ! 1.E50  PMF 06/11/98
      DCHISQ = 0.
      IDNDF  = 0
C
C++++
C     WRITE(6,2857)DALONG,DEV,VXYDA,VZDA,CXYA,CZA,INCUT,BADA,ITHISA,IJA,
C    *LAYRAB,IEFFRG,IHTREG
C
C2857 FORMAT('0DALONG',T20,10F10.1/
C    *' DEVIATIONS',T20,10F10.1/2(T20,10F10.1/)
C    *' VXYDA',T20,10F10.0/
C    *' VZDA',T20,10F10.0/
C    *' CXYA',T20,10F10.0/
C    *' CZA',T20,10F10.0/
C    *' INCUT',T20,30L2/
C    *' BADA',T20,30L2/
C    *' ITHISA',T20,10I5/
C    *' IJA',T20,10I5/
C    *' LAYRAB',I3,'  IEFFRG',10I5/
C    *' IHTREG',10I5)
C
C     DO  2849  I = 1,10
C       WRITE(6,2858) (IOVLAP(I,J),J=1,10)
C2858   FORMAT(10I2)
C2849 CONTINUE
C++++
C
C
      IF(LAYRAB.GT.10) LAYRAB = 10
      NTHISS = NTHIS
      IF(NTHIS.GT.10)  NTHISS = 10
      N2 = 2 * NTHISS
      N3 = 3 * NTHISS
C
C             FILL NAMB,LHIT * LHC.
C
      DO 10  I = 1,LAYRAB
C
        DO  5  J = 1,NTHISS
          IF(IHTREG(J).NE.IEFFRG(I)) GO TO 5
C+++
          IF(IHTREG(J).LT.0)GO TO 5
C+++
          LHIT(I) = LHIT(I) + 1
          LHC(I,LHIT(I)) = J
          LAYER(J) = I
    5   CONTINUE
C
CCCC    IF(LHIT(I).EQ.1) GO TO 8
C+++
        IF(LHIT(I).LE.1) GO TO 8
C+++
          NAMB       = NAMB + 1
          LAMB(NAMB) = I
          GO TO 10
    8   CONTINUE
C
C              FILL IHTPER FOR THOSE HITS IN
C              LAYERS WITH ONLY 1 ASSOCIATED HIT.
C
CCCC    IHTPER( LHC(I,1) ) = 1
C+++
        IF(LHIT(I).EQ.1)IHTPER( LHC(I,1) ) = 1
C+++
   10 CONTINUE
C
C
C     DO  2010  I = 1,10
C       WRITE(6,2009)(LHC(I,J),J=1,10),LHIT(I)
C2009   FORMAT('0 ',10I3,'  LHIT=',I3)
C2010 CONTINUE
C     WRITE(6,2015)NAMB,LAMB,IHTPER
C2015 FORMAT('0 NAMB=',I3,'  LAMB=',10I3/'0 IHTPER=',10I3)
C
C              FILL OUT REST OF ERROR MATRIX.
C
      N21 = N2 - 1
      DO  1  J = 1,N21
        J1  = J + 1
        DO  3  I = J1,N2
          EM(I,J) = EM(J,I)
 3      CONTINUE
 1    CONTINUE
C
C     WRITE(6,2856)((EM(I,J),I=1,12),J=1,12)
C2856 FORMAT('0FIRST 12 ENTRIES IN ERROR MATRIX'/(12F10.0))
C
C
C-----------------------------------------------------------------------
C
C             BEFORE GETTING FIRST PERMUTATION OF HITS IN AMBIGUOUS
C             LAYERS, INITIALISE LPERM TO ZERO.
C
      CALL VZERO(LPERM,10)
C
C             IF THERE ARE NO LAYERS WITH MORE THAN 1 ASSOCIATED HIT,
C             JUST PERMUTE THE LEFT/RIGHT AMBIGUITIES.
C
      IF(NAMB.EQ.0) GO TO 27
C
C-----------------------------------------------------------------------
C
C                  LOOP OVER PERMUTATIONS OF HITS
C                  ------------------------------
C
C             ALWAYS GO THRO 13 TO GET NEXT PERMUTATION OF HITS.
C
C LPERM(I) ( I=1,NAMB ) COUNTS HOW MANY TIME AMBIGUOUS LAYER 'I' HAS HAD
C             ITS HIT REPRESENTATIVE CHANGED IN THE PERMUTING ALGORITHM
C             SINCE THE (I-1)TH. LAYER LAST CHANGED ITS REPRESENTATIVE.
C             ALL PERMUTATIONS ARE EXHAUSTED WHEN :
C
C             LPERM(I)=LHIT( LAMB(I) )        FOR ALL I = 1,NAMB.
C
C-----------------------------------------------------------------------
C
  13  CONTINUE
C
C             GET NEXT PERMUTATION OF HITS.
C
      DO  25  I = 1,NAMB
        ILAYR = LAMB(I)
        NHL   = LHIT(ILAYR)
C
C             IF THIS IS THE LAST AMBIG. LAYER, CYCLE THRO' ALL ITS HITS
C             WITH THE CURRENT REPS OF AMBIG. LAYERS 1--> NAMB-1  FIXED.
C
        IF(I.EQ.NAMB) GO TO 17
C
C             THIS LAYER ONLY CHANGES ITS REP IF, FOR ITS CURRENT REP,
C             THE AMBIGUOUS LAYERS WITH HIGHER I HAVE ALL GONE THRO' ALL
C             POSSIBLE PERMUTATIONS I.E. LPERM(J)=LHIT(LAMB(J))
C                                                ALL J > I  ( COND A )
          I1 = I + 1
          DO  15  J = I1,NAMB
            IF(LPERM(I).NE.0.AND.LPERM(J).LT.LHIT(LAMB(J))) GO TO 25
 15       CONTINUE
C
C             CHANGE THE REP OF THIS AMBIG LAYER.
C
 17     DO  21  J = 1,NHL
          KHIT = LHC(ILAYR,J)
          IF(J.LT.LPERM(I)) GO TO 21
C******* THE STATEMENT BELOW MAY BE REDUNDANT ********
            IF(IHTPER(KHIT).EQ.1)GO TO 19
              IHTPER(KHIT)=1
              J1=J
   18         J1=J1+1
              IF(J1.GT.NHL)GO TO 23
                KHIT = LHC(ILAYR,J1)
                IHTPER(KHIT) = 0
              GO TO 18
   19       IHTPER(KHIT)=0
   21   CONTINUE
C
   23   LPERM(I)=LPERM(I)+1
        IF(I.EQ.NAMB)GO TO 25
C
C             COND A MUST HAVE BEEN SATISFIED FOR THIS LAYER. THEREFORE,
C             START ALL OVER AGAIN WITH THIS REP OF LAYER 'I'. SO , FOR
C             ALL J > I  ( UP TO NAMB ), MUST PUT LPERM(J)=0.
C
        DO  24  J = I1,NAMB
          LPERM(J) = 0
   24   CONTINUE
C
   25 CONTINUE
C
   27 CONTINUE
C
C++++
C     WRITE(6,2025)LPERM,IHTPER
C2025 FORMAT('0 LPERM=',10I3/'0 IHTPER=',10I3)
C++++
C
C-----------------------------------------------------------------------
C
C             CALCULATE CHI-SQUARED FOR DRIFT COORDINATES ALONE.
C
      CHINLO = 1.E19 ! 1.E50 PMF 06/11/98
      NDFTMI = 0
      NPERM  = 1
C
C             SET UP LEFT/RIGHT PERMUTATION VECTOR IPERM
C             IPERM = 0 IF NO AMBIGUITY.  INITIALLY SET TO -1 TO SELECT
C             LEFT AMBIGUITY IF AMBIGUITY EXISTS. THEN EACH NON-ZERO
C             VALUE OF IPERM IS SET TO +1 UNTIL ALL PERMUTATIONS HAVE
C             BEEN TRIED.
C
      DO  2  I = 1,NTHISS
        I1 = 3 * I - 2
        I2 = I1 + 1
        IT = 2 * I - 1
        IPERM(I) = 0
        IF(BADA(IT)) GO TO 2
C+++
        IF(IHTREG(I).LT.0)GO TO 2
C+++
        IF(IHTPER(I).NE.1) GO TO 2
        IF(INCUT(I1).AND.INCUT(I2)) IPERM(I) = -1
 2    CONTINUE
C
C             START OF LEFT/RIGHT AMBIGUITY PERMUTATION LOOP.
C
 30   CONTINUE
C
C             CLEAR IHTEMP , IPTEMP.
C
      CALL VZERO(IHTEMP,10)
      CALL VZERO(IPTEMP,10)
C
C             FOR THIS PERMUTATION OF HITS * AMBIGUITIES,
C             SELECT APPROPRIATE BITS OF DEVIATION VECTOR.
C
      CALL VZERO(IAPPRO,N3)
      DO  35  I = 1,NTHISS
        I1 = 3 * I - 2
        IT = 2 * I - 1
C
C             IS THIS HIT IN THE PRESENT HIT PERMUTATION ?
C
        IF(IHTPER(I).NE.1) GO TO 35
        IF(BADA(IT))       GO TO 35
        I2 = I1 + 1
        IF(IPERM(I)) 33,31,32
 31       IF(INCUT(I1))      GO TO 33
 32       II = I2
          JSIGN = 1
        GO TO 34
 33       II = I1
          JSIGN = -1
 34     IAPPRO(II) = 1
C
C             IS THERE AN OVERLAP HIT FOR THIS AMBIGUITY OF THIS HIT ?
C             IF THERE ARE NO AMBIGUOUS LAYERS , NO ;
C             IF THIS HIT IS NOT IN AN AMBIGUOUS LAYER, NO ;
C
        IF(NAMB.EQ.0) GO TO 35
        IF(LHIT(LAYER(I)).LT.2) GO TO 35
C
C             MAYBE, SO LOOK AT THE OVERLAP MATRIX :
C
        DO  345  K = 1,NTHISS
C
C             OF COURSE , ONLY CONSIDER OTHER HITS IN THE SAME LAYER.
C
          IF(LAYER(K).NE.LAYER(I)) GO TO 345
          IF(JSIGN.GT.0) GO TO 343
            IF(IOVLAP(I,K).EQ.0) GO TO 345
            GO TO 344
 343      IF(IOVLAP(K,I).EQ.0) GO TO 345
 344      IHTEMP(K) = 1
          IPTEMP(K) = -JSIGN
C
C                  DONT MAKE ENTRY IN IAPPRO IF BAD HIT
C
          IF(BADA(2*K-1)) GO TO 35
          KK = 3 * K - 1
          IF(JSIGN.EQ.1) KK = KK-1
          IAPPRO(KK) = 1
          GO TO 35
 345    CONTINUE
 35   CONTINUE
C
C             CALL MUFMAT TO GET ERROR MATRIX FOR THIS HIT PERMUTATION.
C             NOTE THAT THIS IS DONE FOR EVERY AMB PERM OF EVERY HIT
C             PERM. THIS IS NECESSARY DUE TO THE FACT THAT CHANGING THE
C             AMB PERM MAY ADD HITS TO THE HIT PERM DUE TO OVERLAPS. IN
C             PRINCIPLE , ONE COULD DO THIS ONLY WHEN AN OVERLAP DOES
C             EXIST. BUT THEN HAVE TO CALCULATE THE ERROR MATRIX AGAIN
C             FOR THE BASIC HIT PERM BEFORE NEXT AMB PERM, SO GAIN IS
C                                                               SMALL.
      CALL MUFMAT(NTHISS,MERR)
      IF(MERR.EQ.1)GO TO 53
C
C             FILL DEVA WITH APPROPRIATE BITS OF EM.
C
      K = 0
      DO  37  I = 1,N3
        IF(IAPPRO(I).EQ.0) GO TO 37
        K = K + 1
        DEVA(K) = DEV(I)
 37   CONTINUE
C
C++++
C     WRITE(6,2859)(DEVA(I),I=1,NDFT)
C2859 FORMAT(' DEVIATIONS'/(12F10.0))
C++++
C
C             K SHOULD EQUAL THE NUMBER OF DEGREES OF FREEDOM
C             IF THE PROGRAM IS WORKING CORRECTLY
C
      IF(K.EQ.NDFT) GO TO 38
        CALL MUERRY('MUFFLX',K,
     +  'SERIOUS--> NO. OF MARKED HITS .NE. NO. OF DEGREES OF FREEDOM^')
C
C             FORM CHI-SQUARED.
C
 38   CHISQT = 0.
      DO  50  I = 1,NDFT
        CH = 0.
C
        DO  51  J = 1,NDFT
          CH = CH + G(I,J)*DEVA(J)
 51     CONTINUE
C
        CHISQT = CHISQT + DEVA(I)*CH
 50   CONTINUE
C
      CHINDF = CHISQT / NDFT
      GO TO 55
 53   CHINDF = 1.1E19! 1.1E50 PMF 06/11/98
      NDFT=0
 55   CONTINUE
C
C++++
C     WRITE(6,2834)CHISQT,NDFT
C2834 FORMAT(' CHI-SQUARED',F10.4,'  NDFT',I4)
C++++
C
C             RECORD MINIMUM DRIFT CHI**2 PER DEGREE OF FREEDOM
C             FOR THIS HIT PERMUTATION.
C
      IF(CHINDF.GE.CHINLO) GO TO 60
      CHISMI = CHISQT
      NDFTMI = NDFT
      CHINLO = CHINDF
      MPERM  = NPERM
      DO  58  I = 1,NTHISS
        LOHPER(I) = IHTPER(I)
        IF(IHTEMP(I).NE.0) LOHPER(I) = IHTEMP(I)
        LOPERM(I) = IPERM(I)
        IF(IPTEMP(I).NE.0) LOPERM(I) = IPTEMP(I)
 58   CONTINUE
C
C             PERMUTE L/R AMBIGUITIES. GO BACK TO 30 IF ANOTHER
C             L/R AMBIGUITY IS STILL TO BE TRIED.
C
 60   NPERM=NPERM+1
      DO  63  I = 1,NTHISS
        IPERM(I) = - IPERM(I)
        IF(IPERM(I).EQ. 1) GO TO 30
 63   CONTINUE
C
      QUOT = 0.
      IF(NDFTMI.GT.0) QUOT = CHINLO
C
C++++
C     WRITE(6,1735)CHISMI,NDFTMI,QUOT
C1735 FORMAT(' CHISMI,NDFTMI',F10.4,I5,'  QUOT=',F10.3)
C++++
C
C-----------------------------------------------------------------------
C
C             CHECK HIT PERMUTATION.
C
      IF(NDFTMI.EQ.0) GO TO 170
C
C             IS THIS A NEW MINIMUM OF CHOVND ?  IF NO THEN JUMP.
C
      IF(QUOT.GT.CHOVND) GO TO 170
C
C             **  N.B. COULD HAVE MORE CONDITIONS ON THE ABOVE SELECTION
C             **       E.G. IF NDFTMI > IDNDF + 2 , ACCEPT PRESENT PERM
C             **          OVER CURRRENT MINIMUM IF QUOT < CHOVND + 0.05.
C
C             YES. SO RECORD CURRENT BEST HIT AND AMBIGUITY PERMUTATION
C                  AND NEW MIN CHOVND * CORRESPONDING QUANTITIES.
C
      DO  165  I = 1,NTHISS
        IHTMIN(I)=LOHPER(I)
        ILRMIN(I)=LOPERM(I)
  165 CONTINUE
C
      CHOVND = QUOT
      DCHISQ = CHISMI
      IDNDF  = NDFTMI
C
C             ARE THERE ANY FURTHER HIT PERMUTATIONS ? IF SO, GO TO 13.
C
 170  IF(NAMB.EQ.0) GO TO 180
      DO  175  I = 1,NAMB
        IF(LPERM(I) .LT. LHIT(LAMB(I)) ) GO TO 13
  175 CONTINUE
C
C             ALL PERMUTATIONS OF HITS ARE EXHAUSTED. CALCULATE THE
C             CHI**2 PROBABILITY.
C
 180  IF(IDNDF.GT.0) CHIPRT = PROB(DCHISQ,IDNDF)
C
C++++
C     WRITE(6,2185)IHTMIN,ILRMIN,CHOVND,DCHISQ,IDNDF,CHIPRT
C2185 FORMAT('0 IHTMIN=',10I3/'0 ILRMIN=',10I3/
C    *'0 CHOVND=',F10.3,' DCHISQ=',F10.3,' IDNDF=',I5,' CHIPRT=',G15.5)
C++++
C
C-----------------------------------------------------------------------
C
C ====>  AT PRESENT THE LONGITUDINAL CHI-SQUARED CALCULATION IS NOT DONE
C
      CHIPTL = 0.
C
C CALCULATE CHI-SQUARED FOR DRIFT AND LONGITUDINAL COORDINATES.
C
C SELECT APPROPRIATE BITS OF DEVIATION VECTOR.
C     CALL VZERO(IAPPRO,N3)
C     NDFTL=0
C     DO 136 I=1,NTHISS
C     I1=3*I-2
C     IT=2*I-1
C IS THIS HIT IN THE PRESENT HIT PERMUTATION ?
C     IF(IHTPER(I).NE.1)GO TO 136
C     IF(BADA(IT))GO TO 135
C     I2=I1+1
C     IF(IPERM(I))133,131,132
C131  IF(INCUT(I1))GO TO 133
C132  II=I2
C     GO TO 134
C133  II=I1
C134  IAPPRO(II)=1
C     NDFTL=NDFTL+1
C135  II=I1+2
C     IL=IT+1
C     IF(BADA(IL))GO TO 136
C     IAPPRO(II)=1
C     NDFTL=NDFTL+1
C136  CONTINUE
C     IF(NDFTL.LE.0)GO TO 152
C
C
C FILL G AND DEVA WITH APPROPRIATE INFORMATION.
C     K=1
C     DO 138 I=1,N3
C     IF(IAPPRO(I).EQ.0)GO TO 138
C     IE=2*((I-1)/3)+1
C     IF(MOD(I,3).EQ.0)IE=IE+1
C     L=1
C     DO 137 J=1,N3
C     IF(IAPPRO(J).EQ.0)GO TO 137
C     JE=2*((J-1)/3)+1
C     IF(MOD(J,3).EQ.0)JE=JE+1
C     G(K,L)=EM(IE,JE)
C     L=L+1
C137  CONTINUE
C     DEVA(K)=DEV(I)
C     K=K+1
C138  CONTINUE
C
C++++
C     WRITE(6,3848)NDFTL
C3848 FORMAT(I5,' COORDS IN DRIFT AND LONG. CALCULATION.',
C    *' SPECIFIC ERROR MATRIX IS')
C     DO 3849 I=1,NDFTL
C     WRITE(6,2858)(G(I,J),J=1,NDFTL)
C3849 CONTINUE
C     WRITE(6,2859)(DEVA(I),I=1,NDFTL)
C++++
C
C INVERT MATRIX.
C     CALL SYMIN4(G,20,NDFTL,MWORK,IER)
C     IF(IER.EQ.0)GO TO 98
C       CALL MUERRY('MUFFLX',IER,'ERROR RETURN FROM SYMIN4.^')
C       RETURN
C98   CONTINUE
C++++
C     WRITE(6,2861)IER
C     WRITE(6,2838)
C     DO 3839 I=1,NDFTL
C     WRITE(6,2840)(G(I,J),J=1,NDFTL)
C3839 CONTINUE
C++++
C
C
C FORM CHI-SQUARED.
C     CHISTL=0.
C     DO 150 I=1,NDFTL
C     CH=0.
C     DO 151 J=1,NDFTL
C151  CH=CH+G(I,J)*DEVA(J)
C150  CHISTL=CHISTL+DEVA(I)*CH
C     GO TO 153
C
C152  CONTINUE
C     CHISTL=0.
C
C153  CONTINUE
C     CHIPTL=PROB(CHISTL,NDFTL)
C++++
C     WRITE(6,3735)CHISTL,NDFTL,CHIPTL
C3735 FORMAT(' CHISTL,NDFTL,CHIPTL',F10.4,I5,G15.5)
C++++
C
C-----------------------------------------------------------------------
C
C             RECORD HIT AND L/R ASSIGNMENTS OF SOLUTION.
C             (IDEVP IS THE POINTER FOR REGDEV NEEDED BY MULOCH)
C
  155 IDEVP = 1
      DO  185  I = 1,NTHISS
        IF(IHTMIN(I).NE.1) GO TO 185
        I1 = 3*I-2
        I2 = I1+1
        IAMB = ILRMIN(I)
        IF(IAMB.NE.0) GO TO 186
C
C             PUT IAMB TO CORRECT VALUE FOR THOSE HITS  WHICH  HAD  ONLY
C             ONE AMB WITHIN  FACTOR*SIGMA ( * THEREFORE HAD IPERM = 0 *
C             ILRMIN = 0 ) .
C
        IAMB = -1
        IF(INCUT(I2)) IAMB =1
C
C             FOR LOCH ('LET-OFF' CHECK), COPY THE DEVIATION OF THE
C             SELECTED HIT AMBIGUITY INTO REGDEV AFTER SAVING THE
C             REGION NUMBER. (WE MAY HAVE 2 HITS PER REGION)
C
  186   REGDEV(IDEVP)   = IHTREG(I)
        REGDEV(IDEVP+1) = ALLABS(I)
        REGDEV(IDEVP+2) = ALLDEV(I,(IAMB+3)/2 )
        IDEVP           = IDEVP + 3
C
C             PRESENT SYSTEM :  IF ONLY LEFT/RIGHT AMB IS WITHIN 3 SIGMA
C             HAMB =  -2 / +2 . IF LEFT/RIGHT AMB IS IN THE BEST HIT/AMB
C                               PERM AND THE OTHER AMB IS WITHIN 3 SIGMA
C             HAMB = -12 / +12 .
C
        J = IJA(I)
        IF(J.LT.0) GO TO 185
        HAMB(J) = 2*IAMB
        IF( INCUT(I1).AND.INCUT(I2) ) HAMB(J) = HAMB(J) + IAMB*10
        IT = 2*I - 1
        IF(.NOT.BADA(IT)) GO TO 185
C
C             THIS IS A BAD HIT WHICH  FINDS  ITSELF  IN  THE  BEST  HIT
C             PERMUTATION. ARE BOTH AMBIGUITIES WITHIN 3 SIGMA OF  TRACK
C             OR WHICH ?   IF BOTH, MAKE HAMB = 22.
C
        IF(INCUT(I1)) HAMB(J) = -2
        IF(INCUT(I2)) HAMB(J) =  2
        IF( INCUT(I1).AND.INCUT(I2) ) HAMB(J) = 22
  185 CONTINUE
C
C++++
C     CALL BPRS('MUR2',2)
C     CALL BPRS('MUR2',3)
C++++
C
      RETURN
      END

C   07/06/96 606071823  MEMBER NAME  BLOC     (S4)          FORTG1
      SUBROUTINE BLOC(IND,NAME,NR,*)
C     BOS SUBPROGRAM =1.5=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAME),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 3
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)        GOTO    10
      IF(IW(LFDI-2)-NR) 2,4,10
    4 IND=LFDI
  100 RETURN
   10 IND=0
      RETURN 1
      END

C   07/06/96 606071838  MEMBER NAME  CCHL     (S4)          FORTG1
      SUBROUTINE CCHL(NW,IER)
C     BOS SUBPROGRAM =1.20=
#include "acs.for"
      COMMON/BCS/IW(1)
      CALL BCHM(LIND,NW,IER)
      GOTO  90
C
      ENTRY CMVE(NW,IER)
      CALL BCHM(NW,0,IER)
      LIND=NW
C
   90 IF(IER.EQ.2) GOTO 100
      IER=0
  100 RETURN
      END

C   08/06/86 807251549  MEMBER NAME  GPHMAIN  (S)           FORTRAN
C
C----------------------------------------------------------------------
C     MAIN PROGRAM FOR JADE GRAPHICS           JUNE       1986
C----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL  17/05/78 :  MAIN PROGRAM FOR GRAPHICS
C
C        MOD  C. BOWDERY  13/03/84 :  MAJOR OVERHAUL
C        MOD  C. BOWDERY  25/04/84 :  CDTL DEFAULTS CHANGED
C        MOD  C. BOWDERY  14/06/84 :  NEW COMMONS BLOCK DATA SET
C        MOD  C. BOWDERY  12/10/84 :  BLOCK DATA CHANGE
C        MOD  J. HAGEMANN 24/10/84 :  UPDATE PRINTOUT
C        MOD  C. BOWDERY  24/04/85 :  BLOCK DATA COMES FROM MACRO NOW
C        MOD  C. BOWDERY   9/07/85 :  LINK HELP DATASET (DIRECT ACCESS)
C        MOD  C. BOWDERY   3/08/85 :  TIDY UP SCREEN CLEARING
C        MOD  C. BOWDERY   8/06/86 :  CODE PUT INTO SUBROUTINES
C   LAST MOD  J. HAGEMANN 05/03/88 :  FOR OWN BLOCKDATA
C
C         THIS PROGRAM STARTS A GRAPHICS SESSION AND CALLS SUPERV
C   ==>   It contains lower case letters. Check ASIS mode!
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8   DDN,VOLSR
      LOGICAL  OK
C
C                            MACRO CBCSMX.... BOS COMMON + SIZE DEFINED
C
#include "cbcsmx.for"
#include "cgraph.for"
C
      COMMON / CGAMOD / MODEGA, GAHEX
C
      DIMENSION IHLP(11)
C
      DATA  VOLSR/'        '/
C
      DATA  IHLP /'F22B','OW.H','ELP.','DATA','SET ','    ',5*'    '/
C
C------------------  C O D E  -----------------------------------------
C
C                            INITIALISE PLOT10
C
      CALL INITT(DUMMY)
      CALL TWINDO(0,4095,0,4095)
C
C                            ARE WE RUNNING IN GA MODE? MODEGA = 1 ?
C                            IF YES, CLEAR THE TSO SCREEN
C
      CALL TESTGA( MODEGA, GAHEX )
C
      IF( MODEGA .EQ. 1 ) CALL CLEAR
C
C                            WELCOME THE USER
C
      CALL WELCME
C
C                            ALLOCATE FORTRAN LUN TO INPUT DATA SET.
C
      CALL RALLOC( OK )
      IF( .NOT. OK ) GO TO 10
C
C                            ALLOCATE THE DIRECT ACCESS HELP DATASET
C
      CALL GETPDD(IHLP,VOLSR,DDN,50,HERR)
      IF( HERR .NE. 0  .AND.  HERR .NE. 1040 )
     +                  CALL TRMOUT(80,'Warning: The HELP dataset could
     +not be allocated.^')
C
C                            ALLOCATE THE CALIBRATION DATASETS
C
      CALL CALLOC ( OK )
      IF( .NOT. OK ) GO TO 10
C
C                            CLEAR SCREEN AND INITIALISE BOS
C
      CALL CLRCON
      CALL BINT(LDATA,LDATA,200,1)
C
C                            SET UP DEFAULT GRAPHICS VALUES
C
      CALL SETUPG
C
C                            CALL MAIN ANALYSIS SUPERVISOR ROUTINE.
C
      CALL SUPERV
C
C                            END SCAN SESSION AND TERMINATE PLOT10.
C                            OK IS INPUT ARGUMENT.
C
  10  CALL ENDMES( OK )
C
C                            CLEAR GRAPHICS SCREEN IF IN GA MODE
C                            THEN TERMINATE PLOT10.
C
      IF( MODEGA .EQ. 1 ) CALL ERASE
      CALL FINITT(0,0)
C
      STOP
      END
C
C                            BLOCK DATA FOR GRAPHICS PROGRAM
C
#include "grblock.for"

C   07/06/96 606071836  MEMBER NAME  BSTA     (S4)          FORTG1
      SUBROUTINE BSTA
C     BOS SUBPROGRAM =1.17=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      INTEGER IDES(10),IBLK/'    '/,IODS(3)/' -I ',' --O',' -IO'/
      NZTA=NZT-NTIME(DUMMY)
      MINT=NZTA/6000
      NZTA=NZTA-6000*MINT
      SEC=0.01*FLOAT(NZTA)
      NBS=NLAST/10
      WRITE(6,101) MINT,SEC,NCOL,NBS,NHISTH,NHISTL,NCPL
C
      IF(NHISTH(11).NE.0) CALL MSGTXT('BCS-     ')
      IF(NHISTH(11).NE.0) CALL MSGTXT('OVERFLOWS')
      IO=0
      IOE=0
      IOT=0
      CALL BPOS('+BUF')
   30 CALL BNXT(IND,*37)
      IF(IW(IND+1).LT.1.OR.IW(IND+1).GT.2) GOTO 30
      IF(IO.EQ.0) WRITE(6,102)
      IO=IW(IND+1)
      IF(IO.EQ.1) IOE=IOE+IW(IND+3)
      IOT=IOT+IW(IND+6)
      NERAL=IW(IND+9)
      ISAVW=IW(IND+7)
      FBYT=4.0E-6*FLOAT(IW(IND+7))
      IF(IW(IND+5).NE.0) IW(IND+7)=ISAVW/IW(IND+5)
      GOTO (32,34),IO
   32 WRITE(6,103) IW(IND-2),IW(IND+2),IW(IND+3),NERAL,
     1 (IW(IND+L),L=4,5),IW(IND+7),IW(IND+6),IW(IND+8),FBYT
      GOTO 36
   34 WRITE(6,104) IW(IND-2),IW(IND+2),IW(IND+3),(IW(IND+L),L=4,5),
     1   IW(IND+7),IW(IND+6),IW(IND+8),FBYT
   36 IW(IND+7)=ISAVW
      GOTO 30
   37 IOB=0
      DO 38 I=1,10
      IOB=IOB+NER(I)
   38 CONTINUE
      IF(IOB.NE.0) GOTO 39
      WRITE(6,107)
      GOTO 40
   39 WRITE(6,108) NER
      CALL MSGTXT('    INPUT')
      CALL MSGINT(IOB,1,3)
      CALL MSGTXT('BNKERRORS')
C
   40 IF(IOE.EQ.0) GOTO 41
      CALL MSGTXT('    READ-')
      CALL MSGINT(IOE,1,3)
      CALL MSGTXT('   ERRORS')
   41 IF(IOT.EQ.0) GOTO 43
      CALL MSGTXT('     EVTS')
      CALL MSGINT(IOT,1,4)
      CALL MSGTXT('TOO LARGE')
   43 WRITE(6,105) NCI
      IF(NCI.LE.0) GOTO 50
      DO 44 I=1,NCI,10
      IZ=MIN0(I+9,NCI)
      DO 42 L=I,IZ
      J=IW(IOLST+L)
      IDES(L-I+1)=IBLK
      IF(J.LT.1.OR.J.GT.3) GOTO 42
      IDES(L-I+1)=IODS(J)
   42 CONTINUE
      WRITE(6,106) (IW(INAMV+L),IDES(L-I+1),L=I,IZ)
   44 CONTINUE
      WRITE(6,106)
C
   50 CALL BPOS('+DIR')
   52 CALL BNXT(INDA,*60)
      IUND=IW(INDA-2)
      WRITE(6,109) IUND,IW(INDA+6),IW(INDA+7),(IW(INDA+J),J=21,35)
      GOTO 52
   60 CONTINUE
      CALL MSGPR
  100 RETURN
  101 FORMAT(/'0STATUS/BANK ORGANISATION PROGRAM',7X,I6,' MIN',
     1   F8.2,' SEC'/'0',I7,' COLLECTIONS',4X,'HISTOGRAM OF STORAGE ',
     2   'USED (BINS OF',I5,' WORDS)',53X,'OVERFLOWS'/
     3   9X,'TOTAL',2X,5I10,1X,5I10,I15/'  LOW PRIORITY  ',
     4   5I10,1X,5I10,I15/' (',I5,' WORDS)')
  102 FORMAT('0SUMMARY OF INPUT/OUTPUT'//20X,'RECORD',18X,
     1   'IO-ERRORS',6X,'RECORDS     EVENTS',2X,'MEAN  NR    EVENTS  MA'
     2   ,'X   NR'/' UNIT',15X,'LENGTH      MODE        NR   ALLOWED',
     3'   -------   ACCEPTED  OF WORDS TOO LARGE  OF WORDS    MBYTES')
  103 FORMAT(1X,I4,' INPUT',5X,I10,10X,3I10,1X,4I10,F10.3)
  104 FORMAT(1X,I4,' OUTPUT',4X,2I10,20X,I10,1X,4I10,F10.3)
  105 FORMAT('0ORDERED LIST OF ALL',I6,' NAMES USED'/)
  106 FORMAT(20X,5(2X,2A4),1X,5(2X,2A4))
  107 FORMAT('0NO INPUT-BANK ERRORS'/)
  108 FORMAT('0INPUT-BANK ERRORS'/15X,I10,'  RECORD LENGTH LT 4'/
     1   15X,I10,'  BANK LENGTH NEGATIVE'/15X,I10,'  BANK LENGTH',
     2   ' EXCEEDS RECORD LENGTH'/15X,I10,'  WRONG ORDER IN BANK',
     3   ' NUMBERS'/15X,I10,'  RECORD LENGTH CONTRADICTION'/
     4   15X,I10,'  SEGMENT ORDER IC=2, 1'/15X,I10,
     5   '  SEGMENT ORDER IC=1 OR 2, 0'/15X,I10,'  SEGMENT ORDER',
     6   ' IC=0, 2 OR 3'/15X,I10,'  SEGMENT CODE LT 0 OR GT 3'/
     7   15X,I10,'  READ BANK NAMES ALREADY PRESENT (OLD BANKS ARE',
     8   ' DELETED)')
  109 FORMAT('0---- DA-UNIT',I3,10X,'TOTAL',I6,' RECORDS, USED',
     1   I6,' RECORDS'/'0',38X,'LAST LOAD',17X,'LAST UPDATE',17X,
     2   'LAST UNLOAD'/15X,' DATE',10X,3(2A4,2X,2A4,10X)/
     3   15X,' STORED BANKS',12X,3(I8,20X)/)
      END

C   16/02/81 104100757  MEMBER NAME  MURES1   (JADEMUS)     FORTRAN
C   11/02/81 102112050  MEMBER NAME  MURES1P  (S)           FORTRAN
C   26/03/80 102112028  MEMBER NAME  MURES1   (S)           FORTRAN
C LAST CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C  LAST CHANGE 15.05  19/02/81  HUGH MCCANN.
      SUBROUTINE MURES1(I0,I1,I2,I3,I4,I5,I6,I7)
C
C  THIS ROUTINE CONTROLS THE PRINTING OF THE MUON ANALYSIS
C  PHILOSOPHY1 RESULTS BANKS.IF ANY OF I0,I1 ETC IS
C  SET TO 1 , THE CORRESPONDING MUR1 BANK IS PRINTED OUT.
C  ******* N.B. I1 NON-ZERO CAUSES MUR1 BANKS 1 & 2 TO BE PRINTED.
C     AT PRESENT , ROUTINES EXIST ONLY FOR THE OUTPUT OF
C  BANKS 0,1 AND 2 . IT IS INTENDED TO ADD THE
C  NECESSARY ROUTINES FOR THE OTHERS AS THE NEED ARISES.)
C
      IMPLICIT INTEGER*2 (H)
#include "cmubcs.for"
      COMMON /CMUIEV/IEV,NEV,IRD,KRUN,KREC,
     *ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
C PICK UP HEADER POINTER.
      IPHEAD=IDATA(IBLN('HEAD'))
C PICK UP RUN NUMBER ,RECORD NUMBER ETC
      ISECS = HDATA(2*IPHEAD+3)
      IMINS = HDATA(2*IPHEAD+4)
      IHOURS= HDATA(2*IPHEAD+5)
      IDAY  = HDATA(2*IPHEAD+6)
      IMONTH= HDATA(2*IPHEAD+7)
      IYEAR = HDATA(2*IPHEAD+8)
      KRUN  = HDATA(2*IPHEAD+10)
      KREC  = HDATA(2*IPHEAD+11)
C
C  WRITE EVENT HEADER.
C
      WRITE(6,1000)KRUN,KREC,IEV,IHOURS,IMINS,
     *ISECS,IDAY,IMONTH,IYEAR
 1000 FORMAT('0**********',2X,'RUN',I6,2X,'RECORD',I6,
     *2X,'EVENT (FILE)',I6,2X,'TIME =',I3,':',I2,':',I2,
     *2X,'DATE =',I3,':',I2,':',I4)
C
C LOOK THROUGH ARGUMENTS AND PRINT OUT REQUESTED BANKS.
C
      IF(I0.EQ.1)GO TO 10
  100 CONTINUE
      IF(I1.EQ.1)GO TO 11
  110 CONTINUE
      IF(I2.EQ.1)GO TO 12
  120 CONTINUE
      IF(I3.EQ.1)GO TO 13
  130 CONTINUE
      IF(I4.EQ.1)GO TO 14
  140 CONTINUE
      IF(I5.EQ.1)GO TO 15
  150 CONTINUE
      IF(I6.EQ.1)GO TO 16
  160 CONTINUE
      IF(I7.EQ.1)GO TO 17
  170 CONTINUE
      GO TO 200
C
C
   10 CONTINUE
C
C---------OUTPUT BANK 0 .
      CALL MUPR10(IHNUM,IWNUM)
      GO TO 100
   11 CONTINUE
C
C--------OUTPUT BANKS 1 & 2 . FIRST , WRITE HEADER.
      WRITE(6,1101)
 1101 FORMAT('0HIT NO.  CHAMBER/HIT')
      WRITE(6,1201)
 1201 FORMAT('+',20X,'  QTRAN  QLONG QZ QY QX  ?Z ?Y ?X  FOUR?')
      WRITE(6,1102)
 1102 FORMAT(' -------  -----------')
      WRITE(6,1202)
 1202 FORMAT('+',20X,'  -----  ----- -- -- --  -- -- --  ----')
      N1=IHNUM
      N2=IWNUM
      CALL MUPR11(N1,N2)
      GO TO 110
   12 CONTINUE
      GO TO 120
   13 CONTINUE
      GO TO 130
   14 CONTINUE
      GO TO 140
   15 CONTINUE
      GO TO 150
   16 CONTINUE
      GO TO 160
   17 CONTINUE
      GO TO 170
  200 CONTINUE
      RETURN
      END

C   20/01/83 606061351  MEMBER NAME  WEGAS    (S)           FORTRAN
      SUBROUTINE WEGAS(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C
C     SUBROUTINE PERFORMS N-DIMENSIONAL MONTE CARLO INTEGRATION
C     - BY PETER LEPAGE  SEPT 1976/(REV)APR 1978
C
C     COPIED FROM T00VER.AXOLIB.S       02/04/82
C     CHANGED                           20/06/82
C
C     ****                                                          ****
C     ****  THIS IS A MODIFIED VERSION OF THE ORIGINAL VEGAS        ****
C     ****  ROUTINE IN 'T00VER.AXOLIB.S'                            ****
C     ****  THE MAIN CHANGES ARE :                                  ****
C     ****  - ONLY FOR 3-DIMENSIONAL INTEGRATION                    ****
C     ****  - ALL REDUNDANT STATEMENTS REMOVED TO OBTAIN FASTER     ****
C     ****    EXECUTION                                             ****
C     ****  - NO DIVIDE CHECKS FOR INTEGRATION REGIONS WITH 'KINK'  ****
C     ****  - REDUCED NUMBER OF INPUT PARAMETERS                    ****
C     ****                                                          ****
C
      DIMENSION D(50,3),DI(50,3),XIN(50),R(50),DX(3),IA(3)
     1,KG(3),DT(3),XI(50,3)
      DIMENSION XL(3),XU(3)
      DIMENSION QRAN(3),X(3)
      DATA NDMX,ONE,MDS/50,1.,1/
      DATA XI /150*1./
      DSQRT(XXX)=SQRT(XXX)
      DLOG(XXX)=ALOG(XXX)
      NDO=1
      DO 1 J=1,3
    1 XI(1,J)=ONE
      ENTRY VEGAS1(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C      -INITIALIZES CUMMULATIVE VARIABLES, BUT NOT GRID
      IT=0
      SI=0.
      SI2=SI
      SWGT=SI
      SCHI=SI
      SCALLS=SI
      ENTRY VEGAS2(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C      - NO INITIALIZATION
      ND=NDMX
      NG=1
      IF(MDS.EQ.0)GO TO 2
      NG=(NCALL/2.)**.333
      MDS=1
      IF((2*NG-NDMX).LT.0)GO TO 2
      MDS=-1
      NPG=NG/NDMX+1
      ND=NG/NPG
      NG=NPG*ND
    2 K=NG*NG*NG
      NPG=NCALL/K
      IF(NPG.LT.2)NPG=2
      CALLS=NPG*K
      DXG=ONE/NG
      DV2G=DXG*DXG*DXG*DXG*DXG*DXG/NPG/NPG/(NPG-ONE)
      XND=ND
      NDM=ND-1
      DXG=DXG*XND
      XJAC=ONE
      DO 3 J=1,3
      DX(J)=XU(J)-XL(J)
    3 XJAC=XJAC*DX(J)
      IF(ND.EQ.NDO)GO TO 8
      RC=NDO/XND
      DO 7 J=1,3
      K=0
      XN=0.
      DR=XN
      I=K
    4 K=K+1
      DR=DR+ONE
      XO=XN
      XN=XI(K,J)
    5 IF(RC.GT.DR)GO TO 4
      I=I+1
      DR=DR-RC
      XIN(I)=XN-(XN-XO)*DR
      IF(I.LT.NDM)GO TO 5
      DO 6 I=1,NDM
    6 XI(I,J)=XIN(I)
    7 XI(ND,J)=ONE
      NDO=ND
      ACC=BCC
    8 CONTINUE
      ENTRY VEGAS3(FXN,BCC,NCALL,ITMX,XL,XU,AVGI,SD,CHI2A)
C      - MAIN INTEGRATION LOOP
    9 IT=IT+1
      ITS=IT
      TI=0.
      TSI=TI
      DO 10 J=1,3
      KG(J)=1
      DO 10 I=1,ND
      D(I,J)=TI
   10 DI(I,J)=TI
   11 FB=0.
      F2B=FB
      K=0
   12 K=K+1
      DO 112 J=1,3
  112 QRAN(J)=RN(0)
      WGT=XJAC
      DO 15 J=1,3
      XN=(KG(J)-QRAN(J))*DXG+ONE
      IA(J)=XN
      IAJ=IA(J)
      IF(IAJ.GT.1)GO TO 13
      XO=XI(IAJ,J)
      RC=(XN-IA(J))*XO
      GO TO 14
   13 XO=XI(IAJ,J)-XI(IAJ-1,J)
      RC=XI(IAJ-1,J)+(XN-IAJ)*XO
   14 X(J)=XL(J)+RC*DX(J)
   15 WGT=WGT*XO*XND
      F=FXN(X)*WGT
      F1=F/CALLS
      W=WGT/CALLS
      F2=F*F
      FB=FB+F
      F2B=F2B+F2
      DO 16 J=1,3
      IAJ=IA(J)
      DI(IAJ,J)=DI(IAJ,J)+F/CALLS
   16 IF(MDS.GE.0)D(IAJ,J)=D(IAJ,J)+F2
      IF(K.LT.NPG)GO TO 12
      F2B=DSQRT(F2B*NPG)
      F2B=(F2B-FB)*(F2B+FB)
      TI=TI+FB
      TSI=TSI+F2B
      IF(MDS.GE.0)GO TO 18
      DO 17 J=1,3
      IAJ=IA(J)
   17 D(IAJ,J)=D(IAJ,J)+F2B
   18 K=3
   19 KG(K)=MOD(KG(K),NG)+1
      IF(KG(K).NE.1)GO TO 11
      K=K-1
      IF(K.GT.0)GO TO 19
      TI=TI/CALLS
      TSI=TSI*DV2G
C
C     CHECK FOR TSI
C
      IF(TSI.GT.0.) GOTO 29
      AVGI = 0.
      SD = 0.
      CHI2A = 0.
      RETURN
C
   29 TI2=TI*TI
      WGT=TI2/TSI
      SI=SI+TI*WGT
      SI2=SI2+TI2
      SWGT=SWGT+WGT
      SCHI=SCHI+TI2*WGT
      SCALLS=SCALLS+CALLS
      AVGI=SI/SWGT
      SD=SWGT*IT/SI2
      CHI2A=0.
      IF(IT.GT.1)CHI2A=SD*(SCHI/SWGT-AVGI*AVGI)/(IT-.999)
      SD=DSQRT(ONE/SD)
      SDAV=SD/AVGI
      IF(ABS(SDAV).LE.ACC.OR.IT.GE.ITMX)NOW=2
      DO 23 J=1,3
      XO=D(1,J)
      XN=D(2,J)
      D(1,J)=(XO+XN)/2.
      DT(J)=D(1,J)
      DO 22 I=2,NDM
      D(I,J)=XO+XN
      XO=XN
      XN=D(I+1,J)
      D(I,J)=(D(I,J)+XN)/3.
   22 DT(J)=DT(J)+D(I,J)
      D(ND,J)=(XN+XO)/2.
   23 DT(J)=DT(J)+D(ND,J)
      DO 28 J=1,3
      RC=0.
      DO 24 I=1,ND
      R(I)=0.
      IF(D(I,J).LE.0)GO TO 24
      XO=DT(J)/D(I,J)
      R(I)=((XO-ONE)/XO/DLOG(XO))
   24 RC=RC+R(I)
      RC=RC/XND
      K=0
      XN=0
      DR=XN
      I=K
   25 K=K+1
      DR=DR+R(K)
      XO=XN
      XN=XI(K,J)
   26 IF(RC.GT.DR)GO TO 25
      I=I+1
      DR=DR-RC
      XIN(I)=XN-(XN-XO)*DR/R(K)
      IF(I.LT.NDM)GO TO 26
      DO 27 I=1,NDM
   27 XI(I,J)=XIN(I)
   28 XI(ND,J)=ONE
      SDAV=SD/AVGI
      IF(IT.LT.ITMX.AND.ACC.LT.ABS(SDAV))GO TO 9
      RETURN
      END

C   14/08/84 408271210  MEMBER NAME  MUPR23   (PWMUS)       FORTRAN
C   16/12/80 104100755  MEMBER NAME  MUPR23   (JADEMUS)     FORTRAN
C
C  LAST CHANGE 11.00 14/08/84 P.WARMING    - OUTPUT COMMENTED
C       CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C       CHANGE 09.00 19/12/80  HUGH MCCANN.
C-----------------------------------------------------------------------
C
      SUBROUTINE MUPR23
C
C
C  THIS ROUTINE WRITES OUT BANK MUR2/3.
C
      IMPLICIT INTEGER*2 (H)
#include "cmubcs.for"
C
C  FIND MUR1/0 TO GET NO. OF MUON HITS IN THIS EVENT.
C
      CALL CLOC(IND10,'MUR1',0)
      IF(IND10.LE.0)GO TO 21
      NHITS=IDATA(IND10+1)
C
C  FIND MUR2/0 TO GET NO. OF TRACKS PER HIT KEPT IN MUR2/2.
C
      CALL CLOC(INDEX0,'MUR2',0)
      IF(INDEX0.LE.0)GO TO 2
      NTPH=IDATA(INDEX0+3)
C
C  FIND MUR2/2
C
      CALL CLOC(INDEX,'MUR2',2)
      IF(INDEX.LE.0)GO TO 1
C
C  FIND MUR2/3
C
      CALL CLOC(INDEX3,'MUR2',3)
      IF(INDEX3.LE.0)GO TO 31
C
      WRITE(6,600)
  600 FORMAT('0 MUR2/3    MUON HIT AMBIGUITY FLAG FOR EACH ENTRY IN',
     *       ' MUR2/2'/'    HIT#   1ST 2ND 3RD 4TH TRACK')
C
C  LOOP ROUND HITS.
      NP1=1
      IP2=INDEX3+INDEX3
      DO 10 I=1,NHITS
      NP2=NP1+NTPH-1
      WRITE(6,7)I,(HDATA(IP2+J),J=NP1,NP2)
    7 FORMAT(' ',I5,4X,10I4)
      NP1=NP1+NTPH
   10 CONTINUE
      RETURN
   21 CONTINUE
C
C  BANK MUR1/0 DOES NOT EXIST
C
      WRITE(6,121)
  121 FORMAT('0',21X,'*****  BANK MUR1/0 DOES NOT EXIST  *****')
      RETURN
C
    1 CONTINUE
C
C  BANK MUR2/2 DOES NOT EXIST
C
      WRITE(6,100)
  100 FORMAT('0',21X,'*****  BANK MUR2/2 DOES NOT EXIST  *****')
      RETURN
    2 CONTINUE
C
C  BANK MUR2/0 DOES NOT EXIST
C
      WRITE(6,110)
  110 FORMAT('0',21X,'*****  BANK MUR2/0 DOES NOT EXIST  *****')
      RETURN
   31 CONTINUE
C
C  BANK MUR2/3 DOES NOT EXIST
C
      WRITE(6,131)
  131 FORMAT('0',21X,'*****  BANK MUR2/3 DOES NOT EXIST  *****')
      RETURN
      END

C   12/03/84 407201854  MEMBER NAME  COMFIL   (NYES)        FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   THIS SUBROUTINE TAKES THE DATA FROM HDATA BLOCK
C   'ATAG' AND PUTS THE ADC CONTENTS IN THE ARRAY CATAG
C                        IN ORDER OF ADC ADDRESS
C
C   NOTE:- IT ALSO MULTIPLIES CHANNEL NUMBER TIMES A FACTOR TO MAKE IT
C   APPROXIMATELY EQUAL TO ENERGY IN MEV
C
C  A.J.FINCH 10/12/92
C       MOD. :  JOHN NYE 29/05/84   TEST FOR INVALID MARK & TIDY-UP
C  LAST MOD. :  JOHN NYE 20/07/84   CHANGED ERROR HANDLING
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE COMFIL(IWRITE,*)
C
C    IWRITE IS A FLAG TO TELL WHETHER TO PRINT THE BANK 'CATAG' AFTER
C    IT HAS BEEN FILLED.
C
       IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
#include "cgraph.for"
C
#include "comtag.for"
C
#include "cwktag.for"
C
       LOGICAL NOMSG / .FALSE. /
       LOGICAL LERROR  / .FALSE. /
       DIMENSION CALIB(2)
       DATA CALIB / 10.0 , 6.66667 /
       DATA ICOUNT / 0 /
C
C
C------------------------- C O D E -------------------------------------
C
C
C---                                     INITIALISATION
C
C
       IF ( NDDINN .NE. 0 ) NOMSG = .TRUE.
C
       CALL BLOC(IND,'ATAG',0,&1000)
       NW    = IDATA(IND)
       IHIND = IND + IND
       IHSTA = IHIND + 7
       IHSTO = IHIND + NW + NW - 1
C
C---                                     CLEAR THE CATAG ARRAY
C
       DO 10 I =1,64
   10     CATAG(I)= 0.0
C
C---                                     TEST FOR ILLEGAL MARK
C---                                     OR TAGMRK NOT CALLED
C
       IF ( (MARK .LT. 0) .OR. (MARK .GT. 2) ) CALL TAGMRK(&1000)
       IF ( IFLMRK .NE. -1 ) CALL TAGMRK(&1000)
C
C---                                     CHECK FOR RAW DATA
C
       IHRAW = IHIND + 3
       ILOOK = HDATA(IHRAW)
       IF ( ILOOK .LT. 0 ) GOTO 1100
C
C---                                     LOOP OVER ALL DATA IN ATAG
C---                                     AND COPY TO CATAG ARRAY
C
        DO 20 J = IHSTA , IHSTO , 2
C
           IHAD = HDATA(J)
C
C---                                     CONVERT HARDWARE ADDRESSIHAD
C---                                     TO SOFTWARE ADDRESS ISAD
C
           CALL FHTOS(ISAD,IHAD,&20)
C
           IF ( (ISAD .GT. IENDPZ) .OR. (ISAD .LT. 0) ) GOTO 19
C
C---                                     FILL CATAG ARRAY MEMBER
C---                                     ( SOFTARE ADDRESS ) WITH
C---                                     APPROX ENERGY IN MEV
C
           CATAG(ISAD) = HDATA(J+1) * CALIB(MARK)
C
C---                                     CHECK FOR CRAZY DATA
C
           IF ( (HDATA(J+1).LT.0) .OR. (HDATA(J+1) .GT. 4090) ) GOTO 18

C
           GOTO 20
C
C
C--------------------------------------- ERROR CONDITIONS --------------
C
C
C--------------------------------------- HERE FOR BAD ENERGY
C
   18      CONTINUE
C
           IF ( .NOT. NOMSG ) WRITE(6, 11)ISAD,CATAG(ISAD)
   11      FORMAT(//,' +++  WARNING FROM TAGGING ROUTINE - COMFIL -',
     *                '   CATAG(',I4,') HAS CRAZY VALUE -',F12.3,
     *                ' ---  IT HAS BEEN SET TO ZERO ')
C
C---                                     SET THE ARRAY TO ZERO
C
           CATAG(ISAD) = 0.0
           IF ( .NOT. NOMSG ) LERROR = .TRUE.
           GOTO 20
C
C--------------------------------------- HERE FOR ILLEGAL ADDRESS
C
   19      IF ( NOMSG ) GOTO 20
           LERROR = .TRUE.
           WRITE(6, 21)IHAD,ISAD
   21      FORMAT(' +++ ILEGAL ADDRESS FOUND IN COMFIL IHAD,ISAD ',2I10)
C
C
C--------------------------------------- END OF LOOP -------------------
C
   20  CONTINUE

C
C
C---                                     O.K. THAT'S THE COMMON FILLED
C---                                     NOW TEST FOR ANY ERRORS
C
       IF ( NOMSG .OR. ( .NOT. LERROR ) )  GOTO 90
       LERROR = .FALSE.
C
C---                                     IF THERE WAS AN ERROR THEN
C---                                     DUMP OUT THE OFFENDING BANK
C
       CALL HPRS('ATAG',0)
C
C---                                     COUNT THE NUMBER OF ERRORS
C
       ICOUNT = ICOUNT + 1
       IF ( ICOUNT .NE. 10 ) GOTO 90
       NOMSG = .TRUE.
       WRITE(6, 31)
   31  FORMAT(///,'+++  MORE THAN TEN ERRORS DETECTED BY COMFIL',
     *            '  -- NO MORE MESSAGES  +++',///)
C
C---                                     RETURN  IF NO DEBUG
C
   90  CONTINUE
       IF ( IWRITE .NE. 1 ) RETURN
C
       WRITE(6,911)CALIB(MARK)
  911  FORMAT(' CATAG ARRAY =  ADC VALUES TIMES ',F6.3)
C
       DO 900 I = 1,IENDPZ,8
          WRITE(6,921) CATAG(I),CATAG(I+1),CATAG(I+2),CATAG(I+3),
     *                 CATAG(I+4),CATAG(I+5),CATAG(I+6),CATAG(I+7)
  900  CONTINUE
  921  FORMAT(8(3X,F10.2))
       RETURN
C
 1000  RETURN 1
C
C----------------------------------------RAW DATA-----------------------
C
 1100  CONTINUE
       CALL CFLDSK(IWRITE,&1000)
       RETURN
       END
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE CFLDSK(IWRITE,*)
C
C THIS IS A VERSION OF COMFIL THAT HANDLES RAW DATA
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
#include "cgraph.for"
C
#include "cwktag.for"
C
       DIMENSION CALIB(2)
       DATA CALIB  / 10.0 , 6.6667 /
       DATA ICOUNT / 0 /
       LOGICAL NOMSG  / .FALSE. /
       LOGICAL LERROR / .FALSE. /
C
C
       IF ( NDDINN .NE. 0 ) NOMSG = .TRUE.
C
C FIND THE POINTERS ETC
C
C
       CALL BLOC(IND,'ATAG',0,&9001)
       I2S = ( IND * 2 ) + 3
       I2F = 2 * ( IND + IDATA(IND) )
       IF ( HDATA(I2F) .EQ. 0 ) I2F = I2F - 1
C
C
C  UNPACK ADC DATA
C
       IADD = 0
       DO  30 IS = I2S,I2F,1
          IDD = HDATA(IS)
C
C IDD GE 0 => DATA,OTHERWISE -(ADDRESS)
C
          IF ( IDD .GE. 0 ) GOTO 103
C
C HERE IF IDD IS AN ADDRESS - CONVERT IT TO A (POSITIVE) ADDRESS
C
          IADD = IDD + 32768
C
C NOW GOTO END OF LOOP - NEXT BIT OF DATA IS CONTENTS BELONGING
C TO THIS ADDRESS
C
          GOTO  30
C
  103     CONTINUE
C
C HERE FOR DATA
C
 5903     CONTINUE
          ITD = IS
          IF ( (IADD .GE. 96) .OR. (IADD .LT. 0) ) GOTO 20
C
C CONVERT HARDWARE ADDRESS TO SOFTWARE ADDRESS
C
          CALL FHTOS(ISAD,IADD,&19)
C
          IF ( (ISAD .GT. IENDPZ) .OR. (ISAD .LT. 0) ) GOTO 19
C
C
C ISAD - SOFTWARE ADDRESS,IADD HARDWARE - ADDRESS,IDD - DATA
C NOW FILL CATAG LOCATION (ISAD) WITH CORRECT ENERGY FOR
C THIS BLOCK ( APPROXIMATELY IN MEV THANKS TO CALIB)
C
          CATAG(ISAD) = IDD * CALIB(MARK)
C
C
C CHECK FOR CRAZY DATA
C
          IF ( (IDD .GE. 0) .AND. (IDD .LE. 4090) ) GOTO 20
C
C
C
C---------------------------------- ERROR CONDITIONS-----------------
C
   18     CONTINUE
C
           IF ( .NOT. NOMSG ) WRITE(6, 11)ISAD,CATAG(ISAD)
   11      FORMAT(//,' +++  WARNING FROM TAGGING ROUTINE - CFLDSK -',
     *                '   CATAG(',I4,') HAS CRAZY VALUE -',F12.3,
     *                ' ---  IT HAS BEEN SET TO ZERO ')
C
C---                                     SET THE ARRAY TO ZERO
C
           CATAG(ISAD) = 0.0
           IF ( .NOT. NOMSG ) LERROR = .TRUE.
           GOTO 20
C
C--------------------------------------- HERE FOR ILLEGAL ADDRESS
C
   19      IF ( NOMSG ) GOTO 20
           LERROR = .TRUE.
           WRITE(6, 21)IHAD,ISAD
   21      FORMAT(' +++ ILEGAL ADDRESS FOUND IN CFLDSK IHAD,ISAD ',2I10)
C
C    END OF ERROR HANDLING
C
   20     CONTINUE
C
C INCREMENT ADDRESS
C
          IADD=IADD+1
   30  CONTINUE
C
C---                                     NOW TEST FOR ANY ERRORS
C
       IF ( NOMSG .OR. ( .NOT. LERROR ) )  RETURN
       LERROR = .FALSE.
C
C---                                     IF THERE WAS AN ERROR THEN
C---                                     DUMP OUT THE OFFENDING BANK
C
       CALL HPRS('ATAG',0)
C
C---                                     COUNT THE NUMBER OF ERRORS
C
       ICOUNT = ICOUNT + 1
       IF ( ICOUNT .NE. 10 ) RETURN
       NOMSG = .TRUE.
       WRITE(6, 31)
   31  FORMAT(///,'+++  MORE THAN TEN ERRORS DETECTED BY COMFIL',
     *            '  -- NO MORE MESSAGES  +++',///)
   41  FORMAT(6(/,8(2X,F9.2)))
C
       RETURN
C
 9001  RETURN 1
C
       END
C
C
C
C
C
C
C   12/03/84            MEMBER NAME  TAGDAT   (S)           FORTRAN
C      BLOCK DATA TAGDAT
       BLOCK DATA
C
       COMMON / COMTAG / LISTOK,NLIST(64,9,2),
     1                   XMAP(64),YMAP(64)
C
       DIMENSION NDUM(64,4)
       DIMENSION NDIM(64,4)
       EQUIVALENCE (NLIST(1,5,1),NDUM(1,1)),(NLIST(1,1,1),NDIM(1,1))
       DATA NDIM/5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           3,4,6,7,4,3,6,7,8,9,10,5,12,11,13,14,
     *           16,15,17,17,20,19,22,20,21,25,26,21,28,31,1,1,
     *           64,64,33,37,36,35,36,36,37,41,42,37,41,42,45,45,
     *           47,47,49,49,60,51,51,52,56,57,58,53,60,58,61,61,
     *           4,3,7,6,7,4,3,4,5,12,13,8,15,10,14,13,
     *           15,16,18,19,23,20,19,21,24,28,29,24,26,32,2,2,
     *           63,63,34,34,39,36,35,37,40,43,45,40,42,43,46,46,
     *           48,48,50,50,52,52,52,53,53,60,61,56,57,59,62,62,
     *           2,1,4,3,8,7,4,5,12,13,14,9,10,13,16,15,
     *           18,17,20,21,24,23,20,23,28,30,30,25,27,29,32,31,
     *           34,33,36,35,40,39,38,39,42,44,46,41,43,45,48,47,
     *           50,49,52,51,55,55,53,55,58,61,62,57,58,64,64,63/
       DATA NDUM/31,32,2,2,9,0,5,12,13,14,0,10,11,15,17,18,
     *           20,20,23,23,25,0,21,25,29,29,0,26,30,27,30,30,
     *           36,36,38,38,41,0,37,41,45,45,0,42,44,47,49,49,
     *           51,51,54,53,56,0,54,57,60,62,0,58,59,63,33,33,
     *           32,31,1,1,12,0,8,9,10,11,0,13,14,16,18,17,
     *           19,19,22,22,28,0,24,28,26,27,0,29,31,26,29,29,
     *           35,35,39,39,44,0,40,44,44,46,0,45,46,48,50,50,
     *           52,52,55,54,57,0,56,60,61,59,0,61,62,64,34,34,
     *           0,5,0,5,2,6*0,15,16,0,12,0,0,21,0,24,18,
     *           6*0,31,32,0,28,0,0,37,0,40,34,6*0,47,47,0,44,0,0,
     *           53,0,55,50,6*0,63,64,0,60,0,3*0,8,8*0,9,6*0,18,
     *           8*0,25,6*0,33,8*0,48,6*0,56,8*0,63,3*0/
      DATA XMAP/216.5,135.5,204.5,123.5,42.5,204.5,123.5,42.5,
     *          56*0.0/
      DATA YMAP/40.5,40.5,121.5,121.5,136.0,202.5,202.5,217.0,
     *          56*0.0/
      END

C   17/11/75 311291845  MEMBER NAME  RTMI     (S)           FORTRAN
      SUBROUTINE RTMI(X,F,FCT,XLI,XRI,EPS,IEND,IER)
C
C  ROUTINE TO FIND 0'S OF AN ARBITRARY FUNCTION
C  COPIED FROM R01UTL.SSP.S BY W BARTEL ON 29/11/83
C
C
C        PURPOSE
C           TO SOLVE GENERAL NONLINEAR EQUATIONS OF THE FORM FCT(X)=0
C           BY MEANS OF MUELLER-S ITERATION METHOD.
C
C        USAGE
C           CALL DRTMI (X,F,FCT,XLI,XRI,EPS,IEND,IER)
C           PARAMETER FCT REQUIRES AN EXTERNAL STATEMENT.
C
C        DESCRIPTION OF PARAMETERS
C           X      - DOUBLE PRECISION RESULTANT ROOT OF EQUATION
C                    FCT(X)=0.
C           F      - DOUBLE PRECISION RESULTANT FUNCTION VALUE
C                    AT ROOT X.
C           FCT    - NAME OF THE EXTERNAL DOUBLE PRECISION FUNCTION
C                    SUBPROGRAM USED.
C           XLI    - DOUBLE PRECISION INPUT VALUE WHICH SPECIFIES THE
C                    INITIAL LEFT BOUND OF THE ROOT X.
C           XRI    - DOUBLE PRECISION INPUT VALUE WHICH SPECIFIES THE
C                    INITIAL RIGHT BOUND OF THE ROOT X.
C           EPS    - SINGLE PRECISION INPUT VALUE WHICH SPECIFIES THE
C                    UPPER BOUND OF THE ERROR OF RESULT X.
C           IEND   - MAXIMUM NUMBER OF ITERATION STEPS SPECIFIED.
C           IER    - RESULTANT ERROR PARAMETER CODED AS FOLLOWS
C                     IER=0 - NO ERROR,
C                     IER=1 - NO CONVERGENCE AFTER IEND ITERATION STEPS
C                             FOLLOWED BY IEND SUCCESSIVE STEPS OF
C                             BISECTION,
C                     IER=2 - BASIC ASSUMPTION FCT(XLI)*FCT(XRI) LESS
C                             THAN OR EQUAL TO ZERO IS NOT SATISFIED.
C
C        REMARKS
C           THE PROCEDURE ASSUMES THAT FUNCTION VALUES AT INITIAL
C           BOUNDS XLI AND XRI HAVE NOT THE SAME SIGN. IF THIS BASIC
C           ASSUMPTION IS NOT SATISFIED BY INPUT VALUES XLI AND XRI, THE
C           PROCEDURE IS BYPASSED AND GIVES THE ERROR MESSAGE IER=2.
C
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C           THE EXTERNAL DOUBLE PRECISION FUNCTION SUBPROGRAM FCT(X)
C           MUST BE FURNISHED BY THE USER.
C
C        METHOD
C           SOLUTION OF EQUATION FCT(X)=0 IS DONE BY MEANS OF MUELLER-S
C           ITERATION METHOD OF SUCCESSIVE BISECTIONS AND INVERSE
C           PARABOLIC INTERPOLATION, WHICH STARTS AT THE INITIAL BOUNDS
C           XLI AND XRI. CONVERGENCE IS QUADRATIC IF THE DERIVATIVE OF
C           FCT(X) AT ROOT X IS NOT EQUAL TO ZERO. ONE ITERATION STEP
C           REQUIRES TWO EVALUATIONS OF FCT(X). FOR TEST ON SATISFACTORY
C           ACCURACY SEE FORMULAE (3,4) OF MATHEMATICAL DESCRIPTION.
C           FOR REFERENCE, SEE G. K. KRISTIANSEN, ZERO OF ARBITRARY
C           FUNCTION, BIT, VOL. 3 (1963), PP.205-206.
C
C     ..................................................................
C
C     PREPARE ITERATION
      IER=0
      XL=XLI
      XR=XRI
      X=XL
      TOL=X
      F=FCT(TOL)
      IF(F)1,16,1
    1 FL=F
      X=XR
      TOL=X
      F=FCT(TOL)
      IF(F)2,16,2
    2 FR=F
      IF(SIGN(1.,FL)+SIGN(1.,FR))25,3,25
C
C     BASIC ASSUMPTION FL*FR LESS THAN 0 IS SATISFIED.
C     GENERATE TOLERANCE FOR FUNCTION VALUES.
    3 I=0
      TOLF=100.*EPS
C
C
C     START ITERATION LOOP
    4 I=I+1
C
C     START BISECTION LOOP
      DO 13 K=1,IEND
      X=.5*(XL+XR)
      TOL=X
      F=FCT(TOL)
      IF(F)5,16,5
    5 IF(SIGN(1.,F)+SIGN(1.,FR))7,6,7
C
C     INTERCHANGE XL AND XR IN ORDER TO GET THE SAME SIGN IN F AND FR
    6 TOL=XL
      XL=XR
      XR=TOL
      TOL=FL
      FL=FR
      FR=TOL
    7 TOL=F-FL
      A=F*TOL
      A=A+A
      IF(A-FR*(FR-FL))8,9,9
    8 IF(I-IEND)17,17,9
    9 XR=X
      FR=F
C
C     TEST ON SATISFACTORY ACCURACY IN BISECTION LOOP
      TOL=EPS
      A=ABS(XR)
      IF(A-1.)11,11,10
   10 TOL=TOL*A
   11 IF(ABS(XR-XL)-TOL)12,12,13
   12 IF(ABS(FR-FL)-TOLF)14,14,13
   13 CONTINUE
C     END OF BISECTION LOOP
C
C     NO CONVERGENCE AFTER IEND ITERATION STEPS FOLLOWED BY IEND
C     SUCCESSIVE STEPS OF BISECTION OR STEADILY INCREASING FUNCTION
C     VALUES AT RIGHT BOUNDS. ERROR RETURN.
      IER=1
   14 IF(ABS(FR)-ABS(FL))16,16,15
   15 X=XL
      F=FL
   16 RETURN
C
C     COMPUTATION OF ITERATED X-VALUE BY INVERSE PARABOLIC INTERPOLATION
   17 A=FR-F
      DX=(X-XL)*FL*(1.+F*(A-TOL)/(A*(FR-FL)))/TOL
      XM=X
      FM=F
      X=XL-DX
      TOL=X
      F=FCT(TOL)
      IF(F)18,16,18
C
C     TEST ON SATISFACTORY ACCURACY IN ITERATION LOOP
   18 TOL=EPS
      A=ABS(X)
      IF(A-1.)20,20,19
   19 TOL=TOL*A
   20 IF(ABS(DX)-TOL)21,21,22
   21 IF(ABS(F)-TOLF)16,16,22
C
C     PREPARATION OF NEXT BISECTION LOOP
   22 IF(SIGN(1.,F)+SIGN(1.,FL))24,23,24
   23 XR=X
      FR=F
      GO TO 4
   24 XL=X
      FL=F
      XR=XM
      FR=FM
      GO TO 4
C     END OF ITERATION LOOP
C
C
C     ERROR RETURN IN CASE OF WRONG INPUT DATA
   25 IER=2
      RETURN
      END

C   02/07/79 403132255  MEMBER NAME  CIRDIS   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE CIRDIS(NN,CURV,RMIN,PHM,XB,YB,XE,YE,A,B,ITYP,XCE,YCE)
C-----------------------------------------------------------------------
C
C        DRAWS A CIRCLE SEGMENT FROM XB,YB TO XE,YE OF THE CIRCLE WITH
C        PARAMETERS CURV,RMIN,PHM.    NN IS THE SEGMENTATION OF THE
C        POLYGON APPROXIMATION.
C        XCE,YCE IS THE POINT TO WHICH CLOSEST APPROACH IS FOUND
C        THE CIRCLE IS "PROJECTED" ACCORDING TO THE Z-COORDINATE, TO
C        AGREE WITH THE PERSPECTIVE "CYLINDER" VIEW.
C        THE Z-COORDINATE IS GOTTEN FROM THE R-Z FIT:  Z = A + B*R
C                        OR FROM THE Z-FI(HELIX) FIT:  Z = A + B*FI
C        J.OLSSON         01.03.79         LAST CHANGE 10.02.84
C        IF DSPDTL(19) = TRUE, TRACKS ARE PROLONGED TO CLOSEST APPROACH
C                              TO ORIGIN.
C        IF DSPDTL(23) = TRUE, TRACKS ARE PROLONGED TO TOF OR LEAD GLASS
C                              RADIUS LIMIT.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
#include "cgeo1.for"
      COMMON /CJTRIG/ PI,TWOPI
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
      DATA ZDEEP /5800./
C     MUMAX,MUMAYP,MUMAYN / 3320.,3320.,-3020./
C
C-----------------------------------------------------------------------
C
      IF(ABS(CURV).GT.1.E-08) GO TO 500
      CALL TRMOUT(44,'CURVATURE ZERO ENCOUNTERED IN CIRCLE DISPLAY')
      RETURN
500   RAD = ABS(1./CURV)
      YC = RAD + RMIN
      XC = YC*COS(PHM)
      YC = YC*SIN(PHM)
      RTS = RLG
      ZZPL = ZLGPL
      ZZMI = ZLGMI
      IF(LASTVW.EQ.1) RTS = RTOF
      IF(LASTVW.EQ.79) RTS = .33*(XMAX-XMIN)
      IF(LASTVW.EQ.79) ZZPL = RTS
      IF(LASTVW.EQ.79) ZZMI = RTS
C--
C     FI1 = PHM - PI
      PHMIT = ATAN2(YC-YCE,XC-XCE)
      FI1 = PHMIT - PI
      IF(.NOT.DSPDTL(19).AND.LSTCMD.NE.61) FI1 = ATAN2(YB-YC,XB-XC)
      FI2 = ATAN2(YE-YC,XE-XC)
      IF(FI1.LT.-PI) FI1= FI1 + TWOPI
      IF(ITYP.EQ.1) GO TO 455
      FISTRT = ATAN2(YB-YC,XB-XC)
      IF(FISTRT.LT.0.) FISTRT = FISTRT + TWOPI
      FIHEL1 = PHM + PI
      IF(FIHEL1.GT.TWOPI) FIHEL1 = FIHEL1 - TWOPI
      FISTRT = ABS(FISTRT - FIHEL1)
455   FIB = FI1
      ARC = ARCMIN(FI2-FI1)
      IF(ARC*CURV.GT.0.) ARC = SIGN(TWOPI-ABS(ARC),-ARC)
      DEFI = ARC/NN
      IF(LASTVW.GT.78.AND.LASTVW.LT.82) DEFI = DEFI * .01
      XP = - XC - RAD*COS(FI1)
      YP = YC + RAD*SIN(FI1)
      RP = SQRT(XP*XP + YP*YP)
      IF(ITYP.EQ.1) GO TO 233
      FIHEL = FI1
      IF(FIHEL.LT.0.) FIHEL = FIHEL + TWOPI
      FIHEL = ABS(FIHEL - FIHEL1) - FISTRT
      ZP = B*FIHEL + A
      ZDEL = B*ABS(DEFI)
      GO TO 235
233   ZP = A + B*RP
235   IF(LASTVW.NE.14) GO TO 499
      FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
      XP = FP*XP
      YP = FP*YP
499   CALL MOVEA(XP,YP)
      DO 501  I = 1,NN
        FI1 = FI1 + DEFI
        XP = - XC - RAD*COS(FI1)
        YP =   YC + RAD*SIN(FI1)
        RP = SQRT(XP*XP + YP*YP)
        IF(ITYP.EQ.1) GO TO 236
C       FIHEL = FI1
C       IF(FIHEL.LT.0.) FIHEL = FIHEL + TWOPI
C       FIHEL = ABS(FIHEL - FIHEL1) - FISTRT
C       ZP = B*FIHEL + A
        ZP = ZP + ZDEL
        GO TO 237
236     ZP = A + B*RP
237     IF(LASTVW.NE.14) GO TO 507
        FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
        XP = FP*XP
        YP = FP*YP
507     IF(RP.GT.RTS) GO TO 508
        CALL DRAWA(XP,YP)
C
C                            IF 2 POINTS FROM END OF CURVE, WRITE
C                            TRACK NUMBER (N.B. -VE X IS JADE COORD.)
C
        IF( I .NE. NN - 2 ) GO TO 501
          CALL TRNUMB(ITR,0,-XP,YP,ZP)
          CALL MOVEA(XP,YP)
501   CONTINUE
508   IF(.NOT.DSPDTL(23))  RETURN
C---------- SECTION FOR EXTENSION TO TOF OR PBG LIMIT
      IFLGX = 0
      NNN = 0
      R2 = RP
      Z2 = ZP
551   FI1 = FI1 + DEFI
      NNN = NNN + 1
      IF(NNN.GT.200.OR.ABS(ARCMIN(FI1-PHM)).LT.ABS(DEFI)) RETURN
C     IF(NNN.GT.200.OR.(ABS(FI1-FIB).LT.TWOPI+2.*DEFI.AND.ABS(FI1-FIB)
C    $.GT.TWOPI-2.*DEFI)) RETURN
555   XP = - XC - RAD*COS(FI1)
      YP =   YC + RAD*SIN(FI1)
      RP = SQRT(XP*XP + YP*YP)
      IF(RP.LT.RITNK) RETURN
      IF(ITYP.EQ.1) GO TO 238
C     FIHEL = FI1
C     IF(FIHEL.LT.0.) FIHEL = FIHEL + TWOPI
C     FIHEL = ABS(FIHEL - FIHEL1) - FISTRT
C     ZP = B*FIHEL + A
      ZP = ZP + ZDEL
      GO TO 239
238   ZP = A + B*RP
239   IF(IFLGX.NE.0) GO TO 553
CHECK LIMITS
      IF(ABS(ZP).LT.ZZPL) GO TO 554
      IFLGX = 1
      FAT = ABS((ABS(ZP) - ZLGPL)/(ZP - Z2))
552   FI1 = FI1 - FAT*DEFI
      IF(ITYP.EQ.2) ZDEL = -FAT*ZDEL
      GO TO 555
554   IF(RP.LT.RTS) GO TO 553
      IFLGX = 2
      FAT = (RP-RTS)/(RP-R2)
      GO TO 552
553   IF(LASTVW.NE.14) GO TO 557
      FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
      XP = FP*XP
      YP = FP*YP
557   R2 = RP
      Z2 = ZP
      CALL DRAWA(XP,YP)
      IF(IFLGX.EQ.0) GO TO 551
      IF(IFLGX.EQ.1) CALL PLYGON(6,10.,XP,YP,0)
C** EXTEND TO MUFILTER
      RETURN
C     IF(LASTVW.NE.3) RETURN
C     CALL MOVEA(XP,YP)
C     XP = - XP
C     ALF = ATAN2(XC-XP,YP-YC)
C     IF(CURV.LT.0.) ALF = ALF + PI
C     IF(ALF.GT.PI) ALF = ALF - TWOPI
C     TGA = TAN(ALF)
C- STRAIGHT LINE :     Y = YP + TGA*(X - XP)
C     XP1 = MUMAX
C     IF(ABS(ALF).GT.PI*.5) XP1 = - MUMAX
C     YP1 = YP + TGA*(XP1 - XP)
C     IF(YP1.LT.MUMAYP.AND.YP1.GT.MUMAYN) GO TO 661
C     YP1 = MUMAYP
C     IF(ALF.LT.0.) YP1 = MUMAYN
C     XP1 = (YP1 - YP + TGA*XP)/TGA
C661   CALL DRAWA(-XP1,YP1)
C      RETURN
      END
C*****************************
      FUNCTION ARCMIN(A)
C
C THIS IS A ROUTINE USED IN PLUTO PATREC. IT FINDS THE SHORTEST ARC
C     BETWEEN TWO ANGLES.
C
      COMMON/CJTRIG/ PI,TWOPI
C
      ARCMIN=A
      IF (ABS(A).LE.PI) GOTO 2
      ARCMIN=AMOD (A+5.*PI,TWOPI)-PI
    2 RETURN
      END
      DOUBLE PRECISION FUNCTION DRCMIN(AA)
      COMMON/CJTRIG/ PI,ZWEIPI
      REAL*8 AA
      DRCMIN=AA
      IF (DABS(AA).LE.PI) GOTO 3
      ARGUM = AA + 2.*ZWEIPI + PI
      DRCMIN=AMOD (ARGUM,ZWEIPI)-PI
    3 RETURN
      END

C   21/02/84 402211403  MEMBER NAME  MUCONW   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUCONW( IFLAG, LUNBOS, LUNJAD, HERR )
C-----------------------------------------------------------------------
C
C LAST CHANGE 15.50 20/02/84 C. BOWDERY   - NO ERROR IF BANKS EXIST
C      CHANGE 11.40 29/06/82 HUGH MCCANN  - ADD /CMUED/ .
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C NEW VERSION 08.34 12/06/81 HUGH MCCANN  - TO ACCOM NEW JADE SYSTEM.
C NEW VERSION 19.09 26/03/81 CHRIS BOWDERY- CHANGES ARGUMENTS
C
C
C-----------------------------------------------------------------------
C
C OUTPUTS MUON CALIBRATION DATA.
C
C               FULL SET                    IF IFLAG=1
C           CHANGES ONLY (HALF WORDS)       IF IFLAG=0
C      BOS FORMAT OUTPUT                    ON LUNBOS UNLESS SET TO 0 .
C     JADE FORMAT (SINGLE LOGICAL RECORD)   ON LUNJAD UNLESS SET TO 0 .
C
C HERR =  N    IF BOS COULD NOT CREATE BANK N ===> NO OUTPUT ATTEMPTED
C HERR = 20    IF LUNBOS = LUNJAD BUT .NE.0   ===> NO OUTPUT ATTEMPTED
C HERR = -1    WARNING:NO POSITIVE LOGICAL UNIT NO. GIVEN ===> NO OUTPUT
C HERR =  0    NORMAL RETURN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            COMMONS.
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C   28/05/82 206291132  MEMBER NAME  CMUEDWRK (JADEMUS)     FORTRAN
C   27/05/82 205271447  MEMBER NAME  CMUEDWRK (S)           FORTRAN
C   17/06/81 106170953  MEMBER NAME  CMUED    (JADEMUS1)    FORTRAN
C   12/06/81 106151117  MEMBER NAME  CMUED    (S)           FORTRAN
C
C LAST CHANGE 11.20 29/06/82 HUGH MCCANN  - FIX BUG..PUT NCHAN IN/CMUED/
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C
      COMMON /CWORK/KTIME,HUPDAT(8370),HLOC(8370),IALPH,NHMUCA
C       N.B.  SEE  ALSO  CMUED.
C
C  THIS FITS IN WITHIN THE MAXIMUM SIZE OF CWORK....PATREC CWORK
C  IS APPROX 40 KBYTES.
C
      DIMENSION HMUCAL(8370)
      EQUIVALENCE (HMUCAL(1),MUCAL(1))
C  KTIME IS THE TIME AT WHICH THIS SET OF EDITS IS TO BE IMPLEMENTED
C         ( IN SECONDS FROM THE START OF 1979 VIA KTMCON)
C  HUPDAT IS AN ARRAY CONTAINING THESE NEW VALUES  (HUPDAT(I),I=1,NCHAN)
C  HLOC   IS AN ARRAY CONTAINING THEIR HALF-WORD ADDRESSES IN THE MUCAL
C         PART OF THE JADE CALIBRATION COMMON.
C  IALPH  IS THE NUMERICAL INDEX (1-20) OF THE ALPHABETIC IDENTIFIER OF
C         CURRENT MUCONE EDIT (ONLY USED DURING MUCONE OPERATIONS) .
C  NHMUCA IS THE HMUCAL LOCATION OF THE HMUCAL WORD WHICH IS CURRENTLY
C         BEING CHANGED ( ONLY USED DURING MUCONE OPERATIONS ).
C   29/06/82 206291130  MEMBER NAME  CMUED    (JADEMUS)     FORTRAN
C             11.20 29/06/82 HUGH MCCANN
      COMMON /CMUED/NCHAN
C  NCHAN IS THE NO. OF I*2 WORDS WHICH ARE CHANGED BY THE CURRENT EDITS.
C    THIS APPROACH IS ADOPTED IN ORDER TO AVOID INITIALISING LOCATIONS
C  IN /CWORK/ .
C
      DIMENSION IHED(9)
      DIMENSION NAME(12) , NUMBER(12) , LENGTH(12)
C
C                            DATA INITIALISATION STATEMENTS.
C
      DATA NBANKS /   12   /
      DATA MUNAME / 'MUCA' /
      DATA NAME/'MUCO','MUCD','MUOV','MFFI','MCFI','MFSU',
     +          'MCSU','MCEL','MCST','MUFI','MUYO','MUEN'/
      DATA NUMBER/  1, 0,0,  2,  3,  4,  5,   6,  7, 8, 9,10 /
      DATA LENGTH/100,16,3,370,318,246,634,2220,317,36,10,15 /
      DATA IHED(2)/0/,IHED(3)/0/,IHED(4)/0/,IHED(5)/0/,IHED(8)/0/,
     *     IHED(9)/0/
C
C------------------  C O D E  ------------------------------------------
C
      IHED(1)=MUNAME
      IHED(6)=KTIME
      IHED(7)=IFLAG
C
C                            OUTPUT ENTRY MESSAGE THEN CHECK IF
C                            LUNBOS = LUNJAD. IF SO OUTPUT ERROR
C                            MESSAGE AND RETURN UNLESS BOTH 0 .
C
      CALL MUMESS('MUCONW',0,'CALLED TO OUTPUT MUON CALIBRATION.^')
      IF(LUNBOS.NE.LUNJAD) GO TO 3
      IF(LUNBOS.EQ.0) GO TO 99
C
        CALL MUERRY('MUCONW',LUNBOS,'=LOGICAL UNIT NO.  OF BOTH JADE AND
     + BOS DATASETS. NEITHER WRITTEN.^')
      HERR=20
      RETURN
C
C                            CREATE BANKS IF NOT ALREADY EXISTING,
C                            THAT IS, ALLOW IER = 1.
C
 3    HERR=0
      DO  1  I = 1,NBANKS
        CALL CCRE(IP,NAME(I),NUMBER(I),LENGTH(I),IER)
        IF( IER .GE. 2 ) GO TO 98
        IF(I.EQ.2)  CALL UCOPY(NVERSN,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.3)  CALL UCOPY(HOVALL,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.4)  CALL UCOPY(HMFFIX,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.5)  CALL UCOPY(HMCFIX,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.6)  CALL UCOPY(HMFSUR,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.7)  CALL UCOPY(HMCSUR,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.8)  CALL UCOPY(HMCELE,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.9)  CALL UCOPY(HMCSTA,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.10) CALL UCOPY(HFILDA,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.11) CALL UCOPY(HYKNMI,IDATA(IP+1),LENGTH(I))
        IF(I.EQ.12) CALL UCOPY(IZEII ,IDATA(IP+1),LENGTH(I))
  1   CONTINUE
C
C-----------------------------------------------------------------------
C
C                  OUTPUT BANKS.
C
C             IF LOGICAL UNIT NUMBER LUNBOS > 0 , OUTPUT BOS DATASET
C
      IF(LUNBOS.LE.0)GO TO 2
        CALL BMLT(NBANKS,NAME)
        CALL BWRITE(LUNBOS)
        CALL BDLG
        CALL MUMESS('MUCONW',LUNBOS,'=LOGICAL UNIT NO. OF BOS OUTPUT^')
C
C                            IF LOGICAL  UNIT  NUMBER  LUNJAD  >  0  ,
C                            OUTPUT A SINGLE  RECORD  OF  LENGTH  4194
C                            WORDS FOR THE JADE SYSTEM (STEFFEN)
C
 2    IF( LUNJAD .LE. 0 ) GO TO 99
      IF( IFLAG  .EQ. 0 ) GO TO 22
      NLONG = 4194
      WRITE(LUNJAD) NLONG, (IHED(I),I=1,9), (MUCAL(I),I=1,4185)
      CALL MUMESS('MUCONW',LUNJAD,'=LOGICAL UNIT NO. OF JADE OUTPUT^')
      GO TO 99
C
 22   NLONG = NCHAN + 9
      WRITE(LUNJAD) NLONG, (IHED(I),I=1,9),
     +              (HLOC(I),HUPDAT(I),I=1,NCHAN)
C
C++++++++ DEBUGGING :
C
      DO 26 I=1,NCHAN
        WRITE(6,66)HLOC(I),HUPDAT(I)
   66   FORMAT('0  LOCATION / NEW VALUE : ',2I5)
   26 CONTINUE
C
C++++++++
C
      CALL MUMESS('MUCONW',LUNJAD,'=LOGICAL UNIT NO. OF JADE OUTPUT^')
      GO TO 99
C
C                            ERROR CONDITIONS. HERR = NUMBER  OF  BANK
C                            CAUSING THE ERROR.
C
  98  CALL MUERRY('MUCONW',I,'INSUFFICIENT SPACE FOR BANK CREATION.^')
      HERR=I
C
 99   IF( LUNBOS .GT. 0 .OR. LUNJAD .GT. 0 ) RETURN
C
      CALL MUMESS('MUCONW',0,'NO OUTPUT PRODUCED AS NO POSITIVE LOGICAL
     +UNIT NUMBERS GIVEN^')
      HERR=-1
      RETURN
      END

C   08/08/79 912121807  MEMBER NAME  ANOM51   (S)           FORTRAN
      SUBROUTINE ANOM51(IRUN)
C---  ANOMALIES OF RUNS 1210 - 1397
C---  15.0 GEV      AUGUST 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     19.09.79     13:30
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1210,1211,1212,1213,1214,1215,13,13,1218,13,13,1221,
     &      13,1223,1224,1225,1226,1227,1228,1229,1230,1231,1232,1233,
     &      13,13,13,13,1238,13,1240,13,1242,1243,1244,13,13,
     &      13,13,1249,13,1251,1252,13,1254,13,1256,1257,1258,1259,
     &      1260,1261,1262,1263,13,1265,1266,1267,1268,1269,1270,1271,
     &      1272,1273,1274,1275,1276,1277,13,13,1280,1281,1282,1283,13,
     &      13,1286,1287,13,1289,1290,1291,1292,1293,1294,1295,1296,
     &      1297,13,1299,1300,1301,1302,1303,1304,13,13,13,13,13,1310,
     &      1311,1312,1313,1314,1315,13,1317,1318,1319,1320,1321,13,13,
     &      13,13,1326,1327,1328,1329,1330,1331,13,13,13,1335,1336,1337,
     &      13,1339,1340,1341,13,13,1344,1345,1346,1347,1348,13,13,13,
     &      13,1353,13,13,13,1357,1358,1359,1360,1361,1362,13,1364,1365,
     &      1366,1367,1368,1369,13,1371,1372,1373,13,1375,1376,1377,
     &      1378,1379,1380,1381,1382,1383,1384,1385,1386,13,13,13,13,13,
     &      13,1393,13,1395,13,1397),IRUN
   13 RETURN
C
 1210 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1211 PRELIMINARY
 1211 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1212 PRELIMINARY
 1212 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1213 PRELIMINARY
 1213 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1214 PRELIMINARY
 1214 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1215 PRELIMINARY
 1215 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1218 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(9) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1221 PRELIMINARY
 1221 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(9) = .TRUE.
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1223 PRELIMINARY
 1223 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1224 PRELIMINARY
 1224 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1225 PRELIMINARY
 1225 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(64) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(77) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(94) = .TRUE.
      LTHRES(151) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(165) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1226 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
        DO 12261 I = 97,190
12261   LTHRES(I) = .TRUE.
C
      RETURN
C
 1227 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1228 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1229 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1230 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 210
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1231 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1232 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1233 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 210
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1238 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
 1240 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(25) = .TRUE.
      LTHRES(79) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1242 PRELIMINARY
 1242 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(25) = .TRUE.
      LTHRES(79) = .TRUE.
      LTHRES(112) = .TRUE.
C
      RETURN
C
C1243 PRELIMINARY
 1243 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(25) = .TRUE.
      LTHRES(79) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
C1244 PRELIMINARY
 1244 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(25) = .TRUE.
      LTHRES(79) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1249 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(112) = +1
      LIMIT(112) = 105
      KCONST(116) = +1
      LIMIT(116) = 330
      KCONST(162) = +1
      LIMIT(162) = 330
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(168) = +1
      LIMIT(168) = 390
      KCONST(169) = +1
      LIMIT(169) = 315
      KCONST(183) = +1
      LIMIT(183) = 390
      KCONST(190) = +1
      LIMIT(190) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1251 PRELIMINARY
 1251 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(112) = +1
      LIMIT(112) = 105
      KCONST(116) = +1
      LIMIT(116) = 330
      KCONST(162) = +1
      LIMIT(162) = 330
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(168) = +1
      LIMIT(168) = 390
      KCONST(169) = +1
      LIMIT(169) = 315
      KCONST(183) = +1
      LIMIT(183) = 390
      KCONST(190) = +1
      LIMIT(190) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1252 PRELIMINARY
 1252 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(112) = +1
      LIMIT(112) = 105
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(169) = +1
      LIMIT(169) = 315
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1254 PRELIMINARY
 1254 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(112) = +1
      LIMIT(112) = 105
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(169) = +1
      LIMIT(169) = 315
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1256 PRELIMINARY
 1256 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(112) = +1
      LIMIT(112) = 105
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(169) = +1
      LIMIT(169) = 315
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1257 PRELIMINARY
 1257 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(112) = +1
      LIMIT(112) = 105
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(169) = +1
      LIMIT(169) = 315
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
 1258 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(156) = -1
      LIMIT(156) = 90
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1259 PRELIMINARY
 1259 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(156) = -1
      LIMIT(156) = 90
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(156) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1260 PRELIMINARY
 1260 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(156) = -1
      LIMIT(156) = 90
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1261 PRELIMINARY
 1261 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(156) = -1
      LIMIT(156) = 90
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1262 PRELIMINARY
 1262 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(156) = -1
      LIMIT(156) = 90
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(156) = .TRUE.
C
      RETURN
C
C1263 PRELIMINARY
 1263 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(156) = -1
      LIMIT(156) = 90
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(156) = .TRUE.
C
      RETURN
C
 1265 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(25) = +1
      LIMIT(25) = 345
      KCONST(43) = +1
      LIMIT(43) = 345
      KCONST(49) = +1
      LIMIT(49) = 390
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(107) = +1
      LIMIT(107) = 360
      KCONST(116) = +1
      LIMIT(116) = 330
      KCONST(132) = +1
      LIMIT(132) = 360
      KCONST(156) = +1
      LIMIT(156) = 30
      KCONST(162) = +1
      LIMIT(162) = 330
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(168) = +1
      LIMIT(168) = 390
      KCONST(183) = +1
      LIMIT(183) = 390
      KCONST(190) = +1
      LIMIT(190) = 375
C
      LTHRES(23) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(178) = .TRUE.
      LTHRES(180) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(184) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1266 PRELIMINARY
 1266 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(25) = +1
      LIMIT(25) = 345
      KCONST(43) = +1
      LIMIT(43) = 345
      KCONST(49) = +1
      LIMIT(49) = 390
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(107) = +1
      LIMIT(107) = 360
      KCONST(116) = +1
      LIMIT(116) = 330
      KCONST(132) = +1
      LIMIT(132) = 360
      KCONST(156) = +1
      LIMIT(156) = 30
      KCONST(162) = +1
      LIMIT(162) = 330
      KCONST(166) = +1
      LIMIT(166) = 525
      KCONST(168) = +1
      LIMIT(168) = 390
      KCONST(183) = +1
      LIMIT(183) = 390
      KCONST(190) = +1
      LIMIT(190) = 375
C
      LTHRES(23) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(178) = .TRUE.
      LTHRES(180) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(184) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1267 PRELIMINARY
 1267 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(25) = +1
      LIMIT(25) = 345
      KCONST(43) = +1
      LIMIT(43) = 345
      KCONST(49) = +1
      LIMIT(49) = 390
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(107) = +1
      LIMIT(107) = 360
      KCONST(132) = +1
      LIMIT(132) = 360
      KCONST(156) = +1
      LIMIT(156) = 30
      KCONST(166) = +1
      LIMIT(166) = 525
C
      LTHRES(23) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(178) = .TRUE.
      LTHRES(180) = .TRUE.
      LTHRES(184) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1268 PRELIMINARY
 1268 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 315
      KCONST(25) = +1
      LIMIT(25) = 345
      KCONST(43) = +1
      LIMIT(43) = 345
      KCONST(49) = +1
      LIMIT(49) = 390
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(107) = +1
      LIMIT(107) = 360
      KCONST(116) = +1
      LIMIT(116) = 330
      KCONST(132) = +1
      LIMIT(132) = 360
      KCONST(156) = +1
      LIMIT(156) = 30
      KCONST(166) = +1
      LIMIT(166) = 525
C
      LTHRES(23) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(178) = .TRUE.
      LTHRES(180) = .TRUE.
      LTHRES(184) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1269 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
        DO 12691 I = 97,190
12691   LTHRES(I) = 0
C
      RETURN
C
C1270 PRELIMINARY
 1270 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1271 PRELIMINARY
 1271 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1272 PRELIMINARY
 1272 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1273 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
C1274 PRELIMINARY
 1274 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1275 PRELIMINARY
 1275 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
 1276 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
        DO 12761 I = 97,190
12761   LTHRES(I) = .TRUE.
C
      RETURN
C
C1277 PRELIMINARY
 1277 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1280 PRELIMINARY
 1280 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1281 PRELIMINARY
 1281 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
 1282 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1283 PRELIMINARY
 1283 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1286 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1287 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(79) = .TRUE.
C
      RETURN
C
C1289 PRELIMINARY
 1289 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(79) = .TRUE.
C
      RETURN
C
C1290 PRELIMINARY
 1290 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(79) = .TRUE.
C
      RETURN
C
C1291 PRELIMINARY
 1291 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(79) = .TRUE.
C
      RETURN
C
 1292 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1293 PRELIMINARY
 1293 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1294 PRELIMINARY
 1294 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1295 PRELIMINARY
 1295 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1296 PRELIMINARY
 1296 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1297 PRELIMINARY
 1297 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1299 PRELIMINARY
 1299 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1300 PRELIMINARY
 1300 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1301 PRELIMINARY
 1301 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
 1302 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1303 PRELIMINARY
 1303 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
 1304 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) =  .TRUE.
C
      RETURN
C
C1310 PRELIMINARY
 1310 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) =  .TRUE.
C
      RETURN
C
C1311 PRELIMINARY
 1311 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) =  .TRUE.
C
      RETURN
C
C1312 PRELIMINARY
 1312 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) =  .TRUE.
C
      RETURN
C
C1313 PRELIMINARY
 1313 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) =  .TRUE.
C
      RETURN
C
C1314 PRELIMINARY
 1314 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) =  .TRUE.
C
      RETURN
C
C1315 PRELIMINARY
 1315 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) =  .TRUE.
C
      RETURN
C
 1317 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1318 PRELIMINARY
 1318 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1319 PRELIMINARY
 1319 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1320 PRELIMINARY
 1320 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
 1321 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1326 PRELIMINARY
 1326 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1327 PRELIMINARY
 1327 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1328 PRELIMINARY
 1328 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1329 PRELIMINARY
 1329 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1330 PRELIMINARY
 1330 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(49) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1331 PRELIMINARY
 1331 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1335 PRELIMINARY
 1335 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
C1336 PRELIMINARY
 1336 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(186) = .TRUE.
C
      RETURN
C
 1337 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1339 PRELIMINARY
 1339 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
C1340 PRELIMINARY
 1340 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(116) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1341 PRELIMINARY
 1341 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
 1344 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1345 PRELIMINARY
 1345 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1346 PRELIMINARY
 1346 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1347 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1348 PRELIMINARY
 1348 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1353 PRELIMINARY
 1353 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1357 PRELIMINARY
 1357 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1358 PRELIMINARY
 1358 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1359 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1360 PRELIMINARY
 1360 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
C1361 PRELIMINARY
 1361 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1362 PRELIMINARY
 1362 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1364 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(116) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1365 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1366 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
 1367 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1368 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(116) = .TRUE.
      LTHRES(171) = .TRUE.
C
      RETURN
C
 1369 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 210
      KCONST(183) = -1
      LIMIT(183) = 195
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1371 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
C1372 PRELIMINARY
 1372 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
C1373 PRELIMINARY
 1373 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
 1375 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1376 PRELIMINARY
 1376 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1377 PRELIMINARY
 1377 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1378 PRELIMINARY
 1378 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1379 PRELIMINARY
 1379 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1380 PRELIMINARY
 1380 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1381 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(11) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(27) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1382 PRELIMINARY
 1382 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(11) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(27) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(91) = .TRUE.
C
      RETURN
C
C1383 PRELIMINARY
 1383 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(11) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(27) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1384 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1385 PRELIMINARY
 1385 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1386 PRELIMINARY
 1386 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1393 PRELIMINARY
 1393 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1395 PRELIMINARY
 1395 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
C1397 PRELIMINARY
 1397 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      RETURN
C
      END

C   28/11/85 606091629  MEMBER NAME  XBPIPE0  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      FUNCTION XBPIPE(DUMMY)
C-----------------------------------------------------------------------
C
C
C     RETURNS THE NUMBER OF RADIATION LENGTHS FROM THE INSIDE OF THE
C     BEAM PIPE TO THE FIRST GAS MOLECULE IN THE JET CHAMBER TANK.
C     BASED ON DATE IN HEAD BANK.
C     IF A VTXC BANK IS PRESENT, NEW GEOMETRY IS FORCED.
C     ARGUMENT DUMMY IS IGNORED.
C
C   RADIATION LENGTH UPDATE, 9.6.1986    J.O.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
C------------------  C O D E  ------------------------------------------
C
      IH2    = 2*IDATA( IBLN( 'HEAD' ) )
      IVTXC  =   IDATA( IBLN( 'VTXC' ) )
      IF( IVTXC .GT. 0 ) GO TO 10
C
      IMONTH = HDATA(IH2+7)
      IYEAR  = HDATA(IH2+8)
C
C                            OLD GEOMETRY (PRIOR TO MAY 1984)
C
C   FOR VALUE OF RADIATION LENGTH, SEE JCN 87
C
      XBPIPE = 0.2027
C     XBPIPE = 0.16
C
      IF( IYEAR .LT. 1984  .OR.
     +    IYEAR .EQ. 1984  .AND.  IMONTH .LT. 5 ) RETURN
C
C                            NEW GEOMETRY
C
C 10  XBPIPE = 0.1312
  10  XBPIPE = 0.1853
C
      RETURN
      END

C   16/06/79 C9061801   MEMBER NAME  MUREGM   (S)           FORTRAN
C=======================================================================
C
C THIS ROUTINE PRODUCES A MASK (IE. A STRING OF 6 BITS) FROM A SET OF
C
C DIRECTION COSINES.THIS MASK 'TELLS' MUREGY WHICH FACES TO LOOK AT
C
C ACCORDING TO THE FOLLOWING SCHEME:
C
C          BIT        FACE
C           1........1  (-X)
C          10........2  (+X)
C         100........3  (-Y)
C        1000........4  (+Y)
C       10000........5  (-Z)
C      100000........6  (+Z)
C
C
C THE MASK WILL ENABLE A BIT BY BIT .AND. OF THE CORRESPONDING
C
C BITS OF HRMASK(I) * HMASK TO BE MADE IN MUREGY.THE RESULT IS THEN
C
C .OR.ED .IF THE 'TRUTH' VALUE IS 0 THEN THE GIVEN REGION 'I' IS IGNORED
C
C (AS IT DOES NOT BELONG TO A FACE SPECIFIED BY THE MASK).
C
C
C
C CUTS MAY BE APPLIED TO INDIVIDUAL DIRECTION COSINES SO THAT IF A
C
C DIRECTION COSINE 'L' SAY, IS LESS THAN OR EQUAL TO CUT(1) WITH RESPECT
C
C TO A GIVEN FACE ,THAT FACE IS IGNORED. NOTE: IF THE CUTS ARE 0 THEN
C
C THEY ARE IN EFFECT NOT APPLIED.
C
C=======================================================================
C
C
C  JUNE  1979   HARRISON B. PROSPER        J A D E
C
C
C=======================================================================
C
C
      SUBROUTINE MUREGM(C,CUT,HMASK)
      IMPLICIT INTEGER*2 (H)
      DIMENSION C(3),CUT(3)
C
C
C
C
C_____SET___A___BIT___FOR___EACH___DIRECTION___COSINE___________________
C
      HMASK = 0
C
      DO 53 J=1,3
C
                   IF(ABS(C(J)).LE.CUT(J))       GOTO 51
                   IF(C(J).LT.0.0)               GOTO 50
                   HRFA = 2**( 2*J - 1 )
                                                 GOTO 52
50                 HRFA = 2**( 2*J - 2 )
                                                 GOTO 52
51                 HRFA = 0
52                 HMASK = HMASK + HRFA
C
53    CONTINUE
C
C
C
C=======================================================================
C
C
C
C
      RETURN
      END

C   28/06/78 509272143  MEMBER NAME  CERGNR6  (JADEMC2)     FORTRAN
      SUBROUTINE CERGNR( XYZ, DIR, T, PENUM)
C     S.YAMADA    12-05-81
C     COPIED FROM CERNKV
C     LAST MODIFICATION  12-05-81  15:45
C
C---- THE POSITION DEPENDENCE ON THE PMT SURFACE IS INCLUDED.
C I.E.  TRACE CERENKOV LIGHT TO THE BACK SURFACE OF THE LEAD GLASS
C     COUNTER AND EXAMINE PHOTOELECTRIC CONVERSION ONLY IF THE LIGHT
C     GOES INTO THE LIGHT GUIDE.
C---- XYZ = INITIAL POINT DEPTH OF THE SOURCE  ELECTRON IN RAD LNG.
C---- DIR = DIRECTION COSIGNS OF THE  SOURCE ELECTRON.
C---- T  =  PATH LENGTH OF  THE SOURCE TRACK IN RAD LENGTH.
C
      DIMENSION  XYZ(3),DIR(3),PHDIR(3)
C
      DATA CONVMX/0.28/,   TOTL/30.0/, WID/10.47/, HWID/5.235/
C---- CONVMX=MAX CONVERSION EFFICIENCY OF R594.
C     TOTL = TOTAL LENGTH OF THE LEAD GLASS IN CM.
C
      DATA RAD/1.53/,  COST/0.55411/,SINT/0.83244/
C
C---- CALCULATE TOTAL CERENKOV QUANTA NUMBER.
C     NL=(2*3.14/137.)/C*(1-1/N**2)*(DELTA  NEU)*T(IN CM)
C     DELTA NEU =  FREQUENCY RANGE,HERE BETWEEN  429000 AND 882000
C                  GHZ,DNEU=453000GHZ.
C     N =  REFLACTIVE INDEX (=1.8047 IS USED)
C     (1-1/N**2)=0.69296
C     C=LIGHT VELOCITY(=30CM/NSEC)
C
      X = RAD*XYZ(1)
      Y = RAD*XYZ(2)
      Z = RAD*XYZ(3)
C
 1000 TCM =  RAD*T
      ANL = 479.55*TCM
      NL = ANL
      ANL1 = NL
      NL = NL+1
      FRCANL = ANL-ANL1
C
      TCMZ = TCM*ABS(DIR(3))
      NACP = 0
C
C---- REPEAT FOR NL-PHOTONS
        DO 1 I=1,NL
C----   RANDUMLY CORRECT FRACTIONAL TRIAL NUMBERS.
        IF(I.EQ.NL.AND.RN(DUM).GT.FRCANL) GO TO 1
C
C       CALCULATE  PHOTON DIRECTION COSIGN Z-COMPONENT.
          DO 2 K=1,3
    2     PHDIR(K) = DIR(K)
        CALL NEWDR1(PHDIR,COST,SINT)
C
C----    CHECK TOTAL REFLECTION CONDITION BETWEEN NORMAL GLASS(N=1.52)
        ABSANN = ABS(PHDIR(3))
C           STYCAST CASE
        IF(ABSANN.LT.0.5624) GO TO 1
        TRNS = 1.-0.0084/(ABSANN-0.554)
CCC         RTV  CASE
CCC     IF(ABSANN.LT.0.6264) GO TO 1
CCC     TRNS = 1.-0.0084/(ABSANN-0.618)
C
        IF(RN(DUM).GT.TRNS) GO TO 1
C
C        SET  FREQUENCY
        FREQ = 429000.+RN(DUM)*453000.
C
C----    ALAMDA=WAVE LENGTH IN NANO-METER.
        ALAMDA = 3.E8/FREQ
C
C----    EMMITTED POSITION Z-CORDINATE IN CM.
        ZS = Z+RN(DUM)*TCMZ
        IF(PHDIR(3).LT.0.) ZS = -ZS
    3   PATHL = (TOTL-ZS)/ABSANN
C       ABSORPTION LENGTH TO THE BACK SURFACE
        ABSL = PATHL/AVABS(ALAMDA)
        IF(ABSL.LT.0.) GO TO 1
        IF(ABSL.GT.14.) GO TO  1
C        ABSORPTION  PROBABILITY  CHECK
        IF(RN(DUM).GT.EXP(-ABSL)) GO TO 1
C
C       REFLECTION AT THE SIDE SURFACE,  NREF IS NUMBER OF REFLECTIONS.
        NREF = 0
C       X
        ABSALL = ABS(PHDIR(1))
        IF(ABSALL.LT.0.8324) GO TO 4
        NREF = PATHL*ABSALL/WID
C       Y
    4   ABSAMM = ABS(PHDIR(2))
        IF(ABSAMM.LT.0.8324) GO TO 5
        NREF = NREF + PATHL*ABSAMM/WID
    5   IF( NREF.EQ. 0 ) GO TO 6
        IF( RN(DUM).GT. 0.85**NREF ) GO TO 1
    6   CONTINUE
C
C-----  HIT POSITION CHECK ON THE REAR SURFACE
  1000  XHIT = X+PHDIR(1)*PATHL
        YHIT = Y+PHDIR(2)*PATHL
        IF(XHIT) 10,20,11
   10   IF(XHIT.GE.-HWID) GO TO 20
        XHIT = XHIT+WID
        GO TO 10
   11   IF(XHIT.LE. HWID) GO TO 20
        XHIT = XHIT-WID
        GO TO 11
   20   IF(YHIT) 21,30,22
   21   IF(YHIT.GE.-HWID) GO TO 30
        YHIT = YHIT+WID
        GO TO 21
   22   IF(YHIT.LE. HWID) GO TO 30
        YHIT = YHIT-WID
        GO TO 22
   30   RHIT = SQRT(XHIT**2+YHIT**2)
C----   THE LIGHT GUIDE DIAMETER IS 7.5CM.
        IF(RHIT.GT.3.75) GO TO 1
C
C       CHECK CONVERSION EFFICIENCY.
C----   TO KEEP MONTE CARLO EFFICIENCY CONVMX IS MULTIPLIED TO THE RANDU
   40    IF(CONVMX*RN(DUM).GT.CONVEF(ALAMDA)) GO TO 1
C
C       PHOTON  IS DETECTED.
        NACP = NACP+1
    1   CONTINUE
C
      PENUM = NACP*CONVMX
C
      RETURN
      END

C   19/05/81 105191642  MEMBER NAME  TAGSIM   (JADEGS)      FORTRAN
      SUBROUTINE TAGSIM( ITAG )
C-----------------------------------------------------------
C  VERSION OF 03/08/79     LAST MOD 03/08/79    E.ELSEN
C  SIMULATE TAGGING TRIGGER
C  ROUTINE CHECKS MC INPUT FOUR VECTOR BANK FOR ELECTRONS
C  ABOVE PCUT GEV MOMENTUM WITHIN THE ANGULAR ACCEPTANCE
C  OF THL AND THH
C  ITAG = 2 IF BOTH SIDES WERE HIT
C       = 1 IF ONLY ONE SIDE WAS HIT
C       = 0 ELSE
C-----------------------------------------------------------
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1),HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      DATA THL / .034 /
      DATA THH / .080 /
      DATA PCUT / 1.5 /
C
      ITAG = 0
C                                           GET VECT POINTER
      NPVECT = IW( IBLN('VECT'))
      IF( NPVECT .EQ. 0 ) RETURN
C
C                                           LOOP OVER PARTICLES
C                                           CHECK FOR PHOTONS OR
C                                           ELECTRONS
      IP0 = NPVECT + IW(NPVECT+1)
      L = IW( NPVECT + 2 )
      IP9 = IP0 + L * ( IW( NPVECT + 4 ) - 1 )
      ITAGP = 0
      ITAGM = 0
      DO 1000 J = IP0, IP9, L
      IF( IW(J+7) .GT. 2 ) GO TO 1000
      PTOT = SQRT(RW(J+1)**2 +RW(J+2)**2 + RW(J+3)**2 )
      IF( PTOT .LT. PCUT ) GO TO 1000
      COSP = RW(J+3)/PTOT
      IF( COS(THH).GT.ABS(COSP) .OR. ABS(COSP).GT.COS(THL) ) GO TO 1000
      IF( COSP .GE. 0. ) ITAGP = 1
      IF( COSP .LT. 0. ) ITAGM = 1
 1000 CONTINUE
C                                           TAGGING WORD
      ITAG = ITAGP + ITAGM
      RETURN
      END

C   01/11/84 807251625  MEMBER NAME  TRNUMB   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRNUMB(ITR,INDEX,X,Y,Z)
C-----------------------------------------------------------------------
C
C    AUTHOR:  J. OLSSON         ?    : TRACK NUMBER DISPLAY
C
C       MOD:  J. OLSSON     16/02/84 :
C       MOD:  C. BOWDERY    13/03/84 : REVERSE CDTL(12/31/32) MEANING
C       MOD:  C. BOWDERY     8/06/84 : NEW COMMAND NUMBERS
C       MOD:  J. HAGEMANN   22/10/84 : FOR NEW COMMAND VC
C  LAST MOD:  J. HAGEMANN   10/12/85 : IMPROVED DISPLAY FOR VC VIEW
C
C        WRITE THE NUMBER ITR AT POSITION X,Y
C        PROJECTED ACCORDING TO Z-COORDINATE, TO AGREE WITH PERSPECTIVE
C        CYLINDRICAL DISPLAY VIEW
C
C        INDEX = 0  :  NORMAL SIZE (SH5)
C        INDEX = 1  :  SMALL SIZE  (.6 * SH5)
C        INDEX = 2  :  LARGE SIZE  (2.*SH5)
C        INDEX = 3  :  EXTRA SMALL SIZE (.1*SH5)
C                             LATEST CHANGE 16.02.84   (J.OLSSON)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
      LOGICAL FL18,FL22,FL24
      LOGICAL TBIT
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CVCPV  / ICD, DFX, DFY, IRC
#include "cgraph.for"
#include "cgeo1.for"
C
      DATA ADD / 20.0 /, ZDEEP / 5800.0 /
C
C------------------  C O D E  ------------------------------------------
C
C                            DRAW NO NUMBERS IF CDTL 12/31/32 OFF
C                            FOR COMMAND RES/TR/VRES
C
      IF( .NOT. DSPDTL(12) .AND.  LSTCMD .EQ. 45 ) RETURN
      IF( .NOT. DSPDTM(1)  .AND.  LSTCMD .EQ. 47 ) RETURN
      IF( .NOT. DSPDTM(2)  .AND.  LSTCMD .EQ. 52 ) RETURN
C
      FACT =  1.0
      SH5  = 30.0
      ADDD = ADD
C
      IF( LASTVW .EQ. 3 .OR.
     +    LASTVW .EQ. 6 .OR.
     +    LASTVW .EQ. 7                       ) SH5  = 95.0
C
      IF( LASTVW .EQ. 10 .OR.  LASTVW .EQ. 11 ) SH5  = 95.0
      IF( LASTVW .GE. 17 .AND. LASTVW .LE. 19 ) SH5  =  0.01*(XMAX-XMIN)
      IF( LASTVW .GE. 17 .AND. LASTVW .LE. 19 ) ADDD = SH5
      IF( LASTVW .EQ. 20 ) SH5  = 8.0
      IF( LASTVW .EQ. 20 ) ADDD = 6.0
C
      IF( INDEX .EQ. 1                        ) SH5  = 18.0
      IF( INDEX .EQ. 1  .AND.  SH5 .LT. 1.0   ) SH5  =  0.01*(XMAX-XMIN)
      IF( INDEX .EQ. 2                        ) SH5  = 60.0
      IF( INDEX .EQ. 3                        ) SH5  =  9.0
C
      IF( FL18 ) FACT = 4.0
      SH5  = SH5 * FACT
C
      IF( INDEX .EQ. 1 ) FACT = - FACT
      IF( INDEX .EQ. 3 ) FACT = 0.0
      XX   = X + ADDD * FACT
      IF( X .LT. 0.0   ) XX   = X - ADDD * FACT
C
      FACT = ABS(FACT)
      YY   = Y + ADDD * FACT
      IF( Y .LT. 0.0   ) YY   = Y - ADDD * FACT
      IF( LASTVW.NE.20.OR..NOT.TBIT(ICD,15).OR.TBIT(ICD,14)) GO TO 300
         XX = X - DFX*60.0
         YY = Y - DFY*60.0
  300 IF( LASTVW .NE. 14  .OR.  LSTCMD .EQ. 104 ) GO TO 499
C
      FP   = (ZDEEP - Z) / (ZDEEP + ZLGPL)
      XX   = FP * XX
      YY   = FP * YY
  499 IF( LASTVW .NE. 13 ) CALL DNUM(ITR,-XX,YY,SH5,0.)
      IF( LASTVW .EQ. 13 ) CALL DNUM(ITR, XX,YY,SH5,0.)
C
      RETURN
      END

C   09/03/84 807251533  MEMBER NAME  EDVP     (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EDVP
C-----------------------------------------------------------------------
C
C   AUTHOR:  J. HAGEMANN   12/02/86 : EDIT VPAT-BANK
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
      LOGICAL FL18,FL22,FL24
C
#include "cdata.for"
#include "cgraph.for"
#include "cgrscl.for"
C
      COMMON / CGAMOD / MODEGA, GAHEX
      COMMON / CGRAP2 / BCMD, DSPDTM(30), ISTVW, JTVW
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CVX    / NNPATR, NDUMM, NNJETC, NNVTXC
C
      DIMENSION IDATUM(5)
      DIMENSION IPHT(7), HTEMP(246)
C
      DATA HYES / 'Y ' /
      DATA HBLK / '  ' /
C
C
C------------------  C O D E  ------------------------------------------
C
C                            CHECK IF WE ARE RUNNING IN GA-MODE
      IF( MODEGA .NE. 1 ) GO TO 9000
C                            CHECK IF EDVP IS POSSIBLE FOR THIS VIEW
      IF( LASTVW .NE. 20 ) GO TO 9100
      IF( .NOT. FL22  .OR.
     *    ABS(XMAX-XMIN) .GT. 0.2*ABS(XMAXST(20)-XMINST(20)) )
     *   GO TO 9200
C
      CALL CLEAR
      CALL CLOC( IPVPAT, 'VPAT', NNVTXC )
      IF( IPVPAT .GT. 0 ) GO TO 1002
         WRITE(6,1001) NNVTXC
 1001    FORMAT(' VPAT-bank ',I3,'  not existing!')
         CALL TRMOUT(80,' EDVP stops here!^')
         RETURN
 1002 WRITE(6,1003) NNVTXC
 1003 FORMAT(' VPAT-bank ',I3,'  selected!')
C
      IPVPT2 = IPVPAT*2
      ILVPT2 = IDATA(IPVPAT)*2
      NTRKV  = HDATA(IPVPT2+5)
      ILHD   = HDATA(IPVPT2+1)
      ITDL   = HDATA(IPVPT2+4)
C
      CALL TRMOUT(80,' 1: You can edit existing single tracks.^')
      CALL TRMOUT(80,' 2: You can add a new linked track.^')
      CALL TRMOUT(80,' Choose 1 or 2.  <1>,2^')
 1050 CALL TRMIN( 4, ICD )
      CALL GETINT( ICD, ICHO )
      IF( ICHO .EQ. 0 ) ICHO = 1
      IF( ICHO .GT. 0 .AND. ICHO .LT. 3 ) GO TO 1100
C
         CALL TRMOUT(80,' Don''t be so nervous!  1 or 2?^')
         GO TO 1050
C
 1100 CALL TRMOUT(80,' Are you sure? <Y>,N^')
      CALL TRMIN( 2, HCD )
      IF( HCD .EQ. HBLK ) HCD = HYES
      IF( HCD .NE. HYES ) GO TO 10000
C
         IF( ICHO .EQ. 2 ) GO TO 5000
C
C                                           BRANCH 1
 1200    CALL TRMOUT(80,' Enter number of ID-track to be edited.^')
         CALL TRMIN( 4, ICD )
         CALL GETINT( ICD, ITRK )
         IF( ITRK .GT. 0 .AND. ITRK .LT. 99 ) GO TO 1300
C
            CALL TRMOUT(80,' Illegal track number!  0 < ITRK < 99^')
            GO TO 1200
C
 1300    CALL TRMOUT(80,' Are you sure? <Y>,N^')
         CALL TRMIN( 2, HCD )
         IF( HCD .EQ. HBLK ) HCD = HYES
         IF( HCD .NE. HYES ) GO TO 1200
C
            HFND  = 0
            IPTRI = IPVPT2 + ILHD
            DO 1400 IT = 1, NTRKV
               ITID  = HDATA(IPTRI+1)
               IF( ITID .NE. ITRK ) GO TO 1350
C
                  CALL TRMOUT(80,' Enter total number of linked hits.^')
 1320             CALL TRMIN( 4, ICD )
                  CALL GETINT( ICD, NTOT )
                  IF( NTOT .GT. 0 .AND. NTOT .LT. 8 ) GO TO 1330
C
                     CALL TRMOUT(80,' Wrong input:   0 < NHIT < 8^')
                     GO TO 1320
C
 1330             CALL CLEAR
                  WRITE(6,1331) (HDATA(IPTRI+5+IZ),IZ=1,7)
 1331             FORMAT(' Old hit pointers:',7I6)
                  WRITE(6,1332) NTOT
 1332             FORMAT(' Now enter ',I3,' new hit pointers!')
C
                  HDATA(IPTRI+2) = 0
                  HDATA(IPTRI+3) = 0
                  HDATA(IPTRI+4) = 3
                  HDATA(IPTRI+5) = NTOT
C
                  READ(5,*) (IPHT(I),I=1,NTOT)
C
                  DO 1340 I7 = 1, 7
                     IF( I7 .GT. NTOT ) IPHT(I7) = 0
                     HDATA(IPTRI+5+I7) = IPHT(I7)
 1340             CONTINUE
                  HFND = 1
                  GO TO 1500
C
 1350          IPTRI = IPTRI + ITDL
               IF( IPTRI .GE. IPVPT2+ILVPT2 ) GO TO 1500
 1400       CONTINUE
C
 1500       IF( HFND .EQ. 0 )
     *         CALL TRMOUT(80,' Track not found in bank.^')
C
            CALL TRMOUT(80,' Any other existing track to be edited?
     * <N>,Y^')
            CALL TRMIN( 2, HCD )
            IF( HCD .EQ. HYES ) GO TO 1200
C
      GO TO 11000
C
C                                           BRANCH 2
 5000 IF( NTRKV .LT. 20 ) GO TO 5050
         WRITE(6,5001) NTRKV
 5001    FORMAT(' Buffer full. Number of linked tracks= ',I4,'  > 19!')
         GO TO 10000
C
 5050 NBYT = ILVPT2*2
      CALL MVCL( HTEMP, 0, IDATA, IPVPT2*2, NBYT )
C
      CALL CLEAR
      CALL TRMOUT(80,' Now editing can start!^')
 5100 CALL TRMOUT(80,' Enter ID-track number of selected track you want
     *to add!^')
      CALL TRMIN( 4, ICD )
      CALL GETINT( ICD, ITRK )
      IF( ITRK .GT. 0 .AND. ITRK .LT. 99 ) GO TO 5200
C
         CALL TRMOUT(80,' Illegal track number!  0 < ITRK < 99^')
         GO TO 5200
C
 5200 CALL TRMOUT(80,' Are you sure? <Y>,N^')
      CALL TRMIN( 2, HCD )
      IF( HCD .EQ. HBLK ) HCD = HYES
      IF( HCD .NE. HYES ) GO TO 5100
C
      CALL TRMOUT(80,' Enter total number of linked hits.^')
 5300 CALL TRMIN( 4, ICD )
      CALL GETINT( ICD, NTOT )
      CALL CLEAR
      IF( NTOT .GT. 0 .AND. NTOT .LT. 8 ) GO TO 5400
C
         CALL TRMOUT(80,' Wrong input:   0 < NHIT < 8^')
         GO TO 5300
C
 5400 WRITE(6,5401) NTOT
 5401 FORMAT(' Now enter ',I3,' new hit pointers!')
C
      IPTEMP = 6 + NTRKV*12
C
      HTEMP(IPTEMP+1) = ITRK
      HTEMP(IPTEMP+2) = 0
      HTEMP(IPTEMP+3) = 0
      HTEMP(IPTEMP+4) = 3
      HTEMP(IPTEMP+5) = NTOT
C
      READ(5,*) (IPHT(I), I = 1, NTOT )
C
      DO 5500 I7 = 1, 7
         IF( I7 .GT. NTOT ) IPHT(I7) = 0
            HTEMP(IPTEMP+5+I7) = IPHT(I7)
 5500 CONTINUE
C
      CALL DAY2(IDATUM)
      HTEMP(3) = (IDATUM(1)-85)*1000 + IDATUM(2)
      HTEMP(5) = HTEMP(5) + 1
      HTEMP(6) = HTEMP(6) + 1
C
      NWRD = 3 + (NTRKV+1)*6
      CALL BDLS( 'VPAT', NNVTXC )
      CALL CCRE( IPVPAT, 'VPAT', NNVTXC, NWRD, IERR)
      IF( IERR .NE. 0 ) GO TO 9300
         CALL MVCL( IDATA, IPVPAT*4, HTEMP, 0, NWRD*4 )
C
      GO TO 11000
C
 9000 CALL TRMOUT(80,' Sorry, EDVP only works in GA-mode!^')
      GO TO 10000
C
 9100 CALL TRMOUT(80,' Sorry, EDVP not available for this view!^')
      GO TO 10000
C
 9200 CALL TRMOUT(80,' You have to magnify the VC-view more than 5-times
     * in the interested region!^')
      GO TO 10000
C
 9300 CALL TRMOUT(80,' Error during creation of VPAT-bank!^')
      GO TO 10000
C
10000 CALL TRMOUT(80,' EDVP ended abnormally!^')
      GO TO 15000
C
11000 CALL TRMOUT(80,' EDVP ended normally!^')
C
C
15000 CONTINUE
C
      RETURN
      END

C   01/06/83 306011450  MEMBER NAME  MUFFLB   (JADEMUS1)    FORTRAN
C
C  NEW S/R   13.45  06/05/83  CHRIS BOWDERY
C
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLB
C-----------------------------------------------------------------------
C
C             PROCEDURE FOR BACK-TRACKING AND SETTING-UP 1ST PART
C             FOR MUFFLE STEPS 2 AND 3.
C
C-----------------------------------------------------------------------
C
C             COMMONS
C
C   20/10/81 202041521  MEMBER NAME  CMUFWORK (JADEMUS)     FORTRAN
C   12/10/81 110152138  MEMBER NAME  CMUFWORK (JADEMUS1)    FORTRAN
C-------------START OF MACRO CMUFWORK-----------------------------------
C LAST CHANGED 21.30 15/10/81 HUGH MCCANN  - EXTEND IOVLAP TO ALLOW
C                                            > 10 ASSOC HITS IN MUFFLY.
C LAST CHANGED 10.00 04/10/81 HUGH MCCANN  - FOR USE OF OVERLAP HITS.
C LAST CHANGED 14.46 17/06/81 JOHN ALLISON - TO ADD 'OVER' VARIABLES.
C LAST CHANGED 23.00 09/04/81 HUGH MCCANN - JADEMUS UPDATE.
C
      COMMON /CWORK/X,Y,Z,DCX,DCY,DCZ,P,PSQ,E,ESQ,D,GM,AB,RD,DE,PPIDK,
     *PKDK,PPBPEN,PPPEN,PPIPEN,PKPEN,DUMW1(29),X8,Y8,Z8,DCX8,DCY8,
     *DCZ8,P8,PSQ8,E8,ESQ8,D8,GM8,AB8,RD8,DE8,PPIDK8,PKDK8,PPBPE8,
     *PPPEN8,PPIPE8,PKPEN8,DUMW28(29),X0,Y0,Z0,DCX0,DCY0,DCZ0,P0,PSQ0,
     *E0,ESQ0,D0,GM0,AB0,RD0,DE0,PPIDK0,PKDK0,PPBPE0,PPPEN0,PPIPE0,
     *PKPEN0,DUMW2(29),X9,Y9,Z9,DCX9,DCY9,DCZ9,P9,PSQ9,E9,ESQ9,D9,GM9,
     *AB9,RD9,DE9,PPIDK9,PKDK9,PPBPE9,PPPEN9,PPIPE9,PKPEN9,DUMW29(29),
C-----200 WORDS UP TO HERE----------------------------------------------
     *X1,Y1,Z1,X2,Y2,Z2,XMID,YMID,ZMID,X3,Y3,Z3,D1,D2,D3,DTC,DUMW3(4),
     *DSTEP,GMSTEP,ABSTEP,RDSTEP,DESTEP,DUMW4(15),ADCZ,COSEC,STPINI,CURV
     *,DANG,DX,DY,DZ,R,RSQ,PT,DPINA,DKNA,DUMW5(7),VX,VY,VZ,RMSXY,RMSZ,
     *VTXYD,VTZD,VTXYAN,VTZANG,VMSANG,VMSD,CMS,DUMW6(8),SDS(10),DUMW7(1000002000
C
C    *SDX,SDY,SDZ,SDTXYD,SDTZD,SDTXYA,SDTZAN,SDMSAN,SDMSD,SDCMS,DM7(10),
C
C NOTE ABOVE CARD SHORTENED TO SDS(10),DUMW7(10), SO THAT STATEMENT DOES
C   NOT EXCEED 19 CONTINUATION CARDS.  I THINK SD--'S ARE NOT USED.
     *),CHISQT,NDFT,CHIPRT,CHISTL,NDFTL,CHIPTL,NBADCH,DUMW8(13),IDTRK,
     *NCEPTS,NTHIS,INEFF,NHLAYR,INFLAG,NELIPS,NGLAYR,DUMW9(72),IREG(200)
C-----600 WORDS UP TO HERE----------------------------------------------
     *,RDOTD(200),CINT(3,200),NFLAG(200),ITEM(200),EM(30,30),DALONG(10),
C-----2710 WORDS UP TO HERE---------------------------------------------
     *DEV(30),VXYDA(10),VZDA(10),CXYA(10),CZA(10),INCUT(30),BADA(30),G(200003100
     *0,20),DEVA(20),IPERM(10),MWORK(20),ITHISA(10),IJA(10),EM1(20,20),E
     *MG(20,20),ELIPSE(700),INCHAM(10),INREG(10),IAPPRO(30),HBADCH(1000)
     *,CTDASH(10),CLDASH(10),VTDASH(10),VLDASH(10),IHTREG(20),LAYRAB,IEF
C-----5421 WORDS UP TO HERE---------------------------------------------
     *FRG(10),DUMW10(69),AAA(10),BBB(10),CCC(10),DDD(10),DOVER,GMOVER,AB
     *OVER,RDOVER,DEOVER,DUMW11(55),X7(50),IHTP(30),IOVLAP(20,20)
C-----6080 WORDS UP TO HERE---------------------------------------------
      DIMENSION ILIPSE(700)
      INTEGER*2 HLIPSE(1400)
      DIMENSION IHTPER(10),IHTEMP(10),IPTEMP(10)
      EQUIVALENCE (ILIPSE(1),HLIPSE(1),ELIPSE(1))
      EQUIVALENCE (IHTP(1) ,IHTPER(1)),
     *            (IHTP(11),IHTEMP(1)),
     *            (IHTP(21),IPTEMP(1))
      LOGICAL INCUT,BADA
C
C-----------------------------------------------------------------------
C
C THE FIRST 50 LOCATIONS ARE RESERVED FOR SPECIAL WORKING VARIABLES.
C THE NEXT 150 LOCATIONS ARE RESERVED FOR COPIES OF THESE SPECIAL
C    VARIABLES, IF, E.G., ONE WISHES TO PRESERVE THEIR VALUES AT
C    THE BEGINNING OF A STEP.
C THE COPIES HAVE A SUFFIX 0 FOR VALUES AT LAST ASSOCIATED HIT.
C THE COPIES HAVE A SUFFIX 7 FOR VALUES AFTER LEAD-GLASS BARREL OR
C    YOKE END-PLUG (X7 IS LATER IN COMMON - SEE BELOW).
C THE COPIES HAVE A SUFFIX 8 FOR VALUES AT LAST BUT ONE GOOD
C    CHAMBER LAYER.
C THE COPIES HAVE A SUFFIX 9 FOR VALUES AT LAST GOOD CHAMBER LAYER.
C NSPECI (SET IN BLOCK DATA BEHIND MUFFLE) IS THE NUMBER OF SUCH
C    VARIABLES ACTUALLY USED.
C
C SPECIAL VARIABLES....
C
C X,Y,Z       = CURRENT COORDINATES.
C DCX,DCY,DCZ = CURRENT DIRECTION COSINES OF TRACK.
C P,PSQ       = CURRENT MOMENTUM (AND ITS SQUARE).
C E,ESQ       = CURRENT ENERGY (AND ITS SQUARE).
C D           = CURRENT DISTANCE FROM VERTEX (MM).
C GM          = MATERIAL TRAVERSED TO CURRENT POSITION (GM CM**-2).
C AB          = ABSORPTION LENGTHS SO FAR.
C RD          = RADIATION LENGTHS SO FAR.
C DE          = ENERGY LOSS (GEV).
C PPIDK       = PROBABILITY OF PION DECAYING TO MUON BEFORE INTERACTING.
C PKDK        = PROBABILITY OF KAON DECAYING TO MUON BEFORE INTERACTING.
C PPBPEN      = ANTI-PROTON ) ( PENETRATION PROBABILITY, I.E. PROBAB-
C PPPEN       = PROTON      ) ( ILITY OF NOT BEING ABSORBED BY A NUCLEUS
C PPIPEN      = PI          ) ( AND NOT DECAYING.  SEE SUBROUTINE
C PKPEN       = K           ) ( MUFFLS FOR FURTHER DETAILS.
C
C-----------------------------------------------------------------------
C
C THE NEXT 200 LOCATIONS ARE RESERVED FOR VARIABLES THAT DO NOT NEED
C    SPECIAL PRESERVATION.
C
C OTHER VARIABLES...
C
C X1,Y1,Z1    = COORDS OF 1ST POINT ON TRACK.
C X2,Y2,Z2    = COORDS OF LAST POINT ON TRACK.
C XMID,YMID,ZMID = COORDS OF MID POINT ON TRACK.
C X3,Y3,Z3    = COORDS OF POINT WHERE TRACK LEAVES MAGNETIC FIELD.
C D1          = DISTANCE TRAVELLED TO (X1,Y1,Z1).
C D2          = DISTANCE TRAVELLED TO (X2,Y2,Z2).
C D3          = DISTANCE TRAVELLED TO (X3,Y3,Z3).
C DTC         = DISTANCE TRAVELLED TO MID-POINT OF TRACK.
C
C DSTEP       = STEP LENGTH THIS STEP (FOR MUFFLU) (MM).
C GMSTEP      = MATERIAL THIS STEP (GM CM**-2).
C ABSTEP      = ABSORPTION LENGTHS THIS STEP.
C RDSTEP      = RADIATION LENGTHS THIS STEP.
C DESTEP      = ENERGY LOSS OF MINIMUM IONISING PARTICLE THIS STEP,
C
C ADCZ        = ABS(DCZ)
C COSEC       = ABS(COSEC(THETA)), WHERE THETA IS ANGLE TO BEAM.
C STPINI      = STEP LENGTH IN INITIAL TRACKING TO COIL OR END PLUG.
C CURV        = CURVATURE FROM 'PATR' BANK.
C DANG        = ANGLE OF TURN FOR EACH STEP.
C DX,DY,DZ    = CHANGES OF X,Y,Z.
C R,RSQ       = DISTANCE FROM BEAM (RADIUS) AND ITS SQUARE.
C PT          = MOMENTUM COMPONENT PERPENDICULAR TO BEAM.
C DPINA       = INTEGRAL OF (DECAY LENGTH)*(PROBABILTY OF NOT INTER-
C                 ACTING) FOR PION. (NO LONGER USED. CAN BE RESURECTED
C DKNA        = SIMILARLY FOR KAON. (BY UN-COMMENTING IN MUFFLS.
C
C VX,VY,VZ    = CURRENT VARIANCES ON X,Y,Z.
C RMSXY       = RMS DEV. NORMAL TO CHORD IN XY FIT.     )
C RMSZ        = RMS Z DEV. IN RZ FIT.                   ) FROM
C VTXYD       = VARIANCE ON DEVIATION NORMAL TO         ) TRACK
C                 TRACK IN XY PLANE AT TRACK CENTRE.    ) RECON-
C VTZD        = VARIANCE ON DEVIATION NORMAL TO         ) STRUCTION
C                 TRACK IN RZ PLANE AT TRACK CENTRE.    ) ERRORS.
C VTXYAN      = VARIANCE ON ANGLE IN XY PLANE (PHI)     )
C VTZANG      = VARIANCE ON ANGLE IN RZ PLANE (THETA)   )
C VMSANG      = VARIANCE OF MULTIPLE SCATTERING ANGLE.
C VMSD        = VARIANCE OF MULTIPLE SCATTERING DEVIATION NORMAL TO
C                 TRACK.
C CMS         = COVARIANCE OF ABOVE TWO QUANTITIES.
C SD--        = CORRESPONDING STANDARD DEVIATIONS (SQUARE ROOTS).
C
C CHISQT      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFT        = NUMBER OF DEGREES OF FREEDOM.           ) (DRIFT)
C CHIPRT      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C CHISTL      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFTL       = NUMBER OF DEGREES OF FREEDOM.           ) & LONG'L
C CHIPTL      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C NBADCH      = NO. OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C
C IDTRK       = INNER DETECTOR TRACK NUMBER.
C NCEPTS      = NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS       = NUMBER OF MUON HITS ASSOCIATED WITH PROJECTED INNER
C                DETECTOR TRACK.
C INEFF       = NUMBER OF INEFFICIENCIES IN MUON SYSTEM FOUND THIS TRACK
C NHLAYR      = NUMBER WHICH REPRESENTS NUMBER OF MUON LAYERS WITH
C                ASSOCIATED MUON HITS. ADD 1 FOR THE INNER LAYER AND
C                2 FOR EACH SUBSEQUENT LAYER.
C INFLAG      = 1 IF LAST LAYER INTERCEPTED WAS INEFFICIENT.
C NELIPS      = NUMBER OF MULTIPLE SCATTERING ELIPSES ENTERED IN ELIPSE.
C NGLAYR      = AS NHLAYR, BUT FOR 'GOOD' LAYERS WHETHER THERE WAS AN
C                ASSOCIATED HIT OR NOT.
C
C-----------------------------------------------------------------------
C
C THE NEXT 1400 LOCATIONS USED BY MUREGY (CALCULATES REGION INTERCEPTS).
C
C IREG        = REGION NUMBER.                           )(IN PAIRS,I.E.
C RDOTD       = R.DOT.(DIR. COSINES) FOR EACH INTERCEPT. )( 2 INTERCEPTS
C CINT        = X,Y,Z COORDINATES OF EACH INTERCEPT.     )( PER REGION.
C NFLAG       = USED INTERNALLY BY MUREGY.
C ITEM        = USED INTERNALLY BY MUREGY.
C
C-----------------------------------------------------------------------
C
C THE NEXT 3600 LOCATIONS USED BY MUFFLE, ETC., TO ACCUMULATE
C   QUANTITIES NEEDED FOR CALCULATING CHI-SQUARED. IN THE DESCRIPTION
C   BELOW I,J GO AS FOLLOWS..
C     1   LEFT DRIFT COORDINATE    )  OF 1ST
C     2   RIGHT DRIFT COORDINATE   )  ASSOCIATED
C     3   LONGITUDINAL COORDINATE  )  HIT
C     4    ETC. FOR NEXT ASSOCIATED HIT.
C   K REFERS TO K'TH ASSOCIATED HIT.
C
C EM(I,J)     = 'ERROR MATRIX', I.E. VARIANCE (I=J) OR COVARIANCE (I.NE.
C                J) FOR COORDINATE I,J.
C DALONG(K)   = DISTANCE OF ASSOCIATED HIT K ALONG TRACK.
C DEV(I)      = DEVIATION OF COORDINATE I FROM EXTRAPOLATED INNER
C                DETECTOR TRACK.
C VXYDA(K)    = VARIANCE ON DEVIATION IN XY PLANE FOR HIT K.
C VZDA(K)     = VARIANCE ON DEVIATION IN RZ PLANE FOR HIT K.
C CXYA(K)     = COVARIANCE BETWEEN DEVIATION AND ANGLE IN XY PLANE.
C CZA(K)      = COVARIANCE BETWEEN DEVIATION AND ANGLE IN RZ PLANE.
C INCUT(I)    = .TRUE. IF COORDINATE I IS IN CUT (SEE MUFFLY).
C BADA(I)     = .TRUE. IF COORDINATE I IS BAD.
C G           = INVERSE ERROR MATRIX.
C DEVA        = CORRESPONDING DEVIATIONS.
C IPERM(K)    = USED TO PERMUTE LEFT/RIGHT AMBIGUITIES.
C MWORK       = USED BY MATRIX INVERTING ROUTINE AS WORKING SPACE.
C ITHISA(K)   = HIT NUMBER OF K'TH ASSOCIATED HIT.
C IJA(K)      = INDEX FOR K'TH ASSOCIATED HIT FOR ENTRY IN BANKS 2 & 3.
C EM1         = COPY OF RELEVANT PART OF ERROR MATRIX FOR TEST PURPOSES.
C EMG         = PRODUCT OF ERROR MATRIX AND ITS INVERSE. SHOULD BE UNIT
C                MATRIX. USED FOR TEST PURPOSES.
C ELIPSE      = TEMPORARY STORAGE FOR MULTIPLE SCATTERING ELIPSES.
C INCHAM      = LIST OF INEFFICIENT CHAMBERS ON THIS TRACK.
C INREG       = LIST OF INEFFICIENT REGIONS (PLANES) ON THIS TRACK.
C IAPPRO      = USED AS WORKING SPACE IN MUFFLX.
C HBADCH      = LIST OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C CTDASH(K)   = TRANSVERSE COORD. ESTIMATED FROM I.D. PROJECTION.
C CLDASH(K)   = LONGITUD'L COORD. ESTIMATED FROM I.D. PROJECTION.
C VTDASH(K)   = VARIANCE ON CTDASH.
C VLDASH(K)   = VARIANCE ON CLDASH (FOR K'TH ASSOCIATED HIT).
C
C-----------------------------------------------------------------------
C
C THE NEXT  380 LOCATIONS USED FOR VARIOUS IMPROVEMENTS TO MUFFLE, ETC.
C
C IHTREG      = FOR EACH ASSOCIATED HIT, THE REGION NO. IN WHICH
C               THE HIT OCCURS.
C LAYRAB      = ABSOLUTE NO. OF LAYERS WHICH HAVE ASSOCIATED HITS.
C IEFFRG      = LIST OF REGION NOS. OF THOSE REGIONS WHICH HAVE AN
C               ASSOCIATED HIT.
C   IHTPER = FLAG FOR EACH ASSOCIATED HIT TO TELL IF IT'S TO
C            GO FORWARD INTO THE CHI**2 CALCULATION . ONLY ONE
C            HIT PER LAYER IS TO BE USED ,APART FROM OVERLAP HITS.
C   IHTEMP = LIST OF HITS WHICH ARE TEMPORARILY IN THE HIT PERMUTATION
C            DUE TO OVERLAPS WITH THE CURRENT AMBIGUITYOF ONE OF THE
C            HITS IN IHTPER.
C   IPTEMP =  AS IHTEMP, BUT FOR L/R AMBIGUITIES.
C IOVLAP   =  MATRIX OF OVERLAP HITS. IOVLAP(I,J)=1 MEANS THAT THERE
C             IS AN OVERLAP BETWEEN ASSOCIATED HITS I & J ( I & J BOTH
C             IN THE RANGE 1 TO NTHIS ).
C AAA(K)      = TRANSFORMATION COEFF. A FOR K'TH ASSOCD. HIT.
C BBB(K)      = TRANSFORMATION COEFF. B FOR K'TH ASSOCD. HIT.
C CCC(K)      = TRANSFORMATION COEFF. C FOR K'TH ASSOCD. HIT.
C DDD(K)      = TRANSFORMATION COEFF. D FOR K'TH ASSOCD. HIT.
C
C DOVER, ETC. = STORES QUANTITIES LEFT OVER AFTER LEAVING LAST ABSORBER.
C
C X7          = VALUES OF SPECIAL VARIABLES AFTER LEAD-GLASS BARREL OR
C               YOKE END-PLUG - USED FOR RE-FITTING, ETC.
C
C-------------END OF MACRO CMUFWORK-------------------------------------
C   20/10/81 408081453  MEMBER NAME  CMUFFL   (S)           FORTRAN
C
C LAST CHANGE 15.00 08/08/84 - CKB PWA     - ADD NALLWM,PMXFLG
C      CHANGE 15.00 03/12/83 - HUGH MCCANN - NEW LEAD GLASS PARAMETERS.
C      CHANGE 08.00 12/10/81 - HUGH MCCANN - TO ADD OVLCUT(FOR OVERLAPS)
C      CHANGE 09.33 17/06/81 - JOHN ALLISON - TO ADD RESOLUTIONS.
C
C-------------START OF MACRO CMUFFL-------------------------------------
C
      COMMON / CMUFFL / XYSTEP,RCOILI,RCOILO,PGMID,WMU,WMUSQ,DUMF1(4),
     +                  NSPECI,XPBAR,XPROT,XPION,XKAON,DUMF2(5),
     +                  TBP,GMBP,ABBP,RDBP,DEBP,
     +                  TJETI,GMJETI,ABJETI,RDJETI,DEJETI,
     +                  TJET1,GMJET1,ABJET1,RDJET1,DEJET1,
     +                  TJET2,GMJET2,ABJET2,RDJET2,DEJET2,
     +                  TJET4,GMJET4,ABJET4,RDJET4,DEJET4,
     +                  TJETO,GMJETO,ABJETO,RDJETO,DEJETO,
     +                  TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL,
     +                  ZJETE,TJETE,GMJETE,ABJETE,RDJETE,DEJETE,
     +                  ZEPLG,TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG,
     +                  RLG,ZLG,TLG,GMLG,ABLG,RDLG,DELG,
     +                  ZEP,TEP,GMEP,ABEP,RDEP,DEEP,
     +                  GMG(3),ABG(3),RDG(3),DEG(3),
     +                  VDRES,VLRES,
     +                  REST1,REST2,RESTMX,RESL,RESLMX,FACTOR,OVLCUT,
     +                  ZLGHAF,TLGHAF,ZLGC,GMLGC,ABLGC,RDLGC,DELGC,
     +                  NALLWM,PMXFLG
C
C FOR EXPLANATION SEE BLOCK DATA AFTER SUBROUTINE MUFFLE.
C
C--------------END OF MACRO CMUFFL--------------------------------------
C
C-----------------------------------------------------------------------
C
C             PRESERVE COORDS.
C
      CALL UCOPY(X,X0,NSPECI)
      X3 = X
      Y3 = Y
      Z3 = Z
C
C             CALCULATE DISTANCE  TRAVELLED  FROM  VERTEX  (INTERACTION
C             POINT), INCLUDING CORRECTION FOR CURVATURE.
C
      D3 = SQRT(X3**2 + Y3**2 + Z3**2)
      XYCHOR = SQRT(X3**2 + Y3**2)
      D3 = D3 + (CURV**2 * XYCHOR**3 / 24.) * COSEC
C
C             BACK-TRACK.
C
      X = X3 - DCX * D3
      Y = Y3 - DCY * D3
      Z = Z3 - DCZ * D3
C
C             MAKE A STEP TO MID-POINT OF TRACK. FOR  THIS  FIRST  STEP
C             THE QUANTITIES WHICH DETERMINE  MULTIPLE  SCATTERING  AND
C             ENERGY LOSS ARE SET TO  ZERO  BECAUSE  (A)  THE  MULTIPLE
C             SCATTERING IS DETERMINED BY THE TRACK FITTING  PARAMETERS
C             AT THE MID-POINT, AND (B) THE ENERGY IS DETERMINED BY THE
C             MOMENTUM EFFECTIVELY DETERMINED AT THE MID-POINT.
C
      DSTEP  = D3 / 2.0
      GMSTEP = (GMBP + GMJETI + GMJET1 + GMJET2) * COSEC
      ABSTEP = (ABBP + ABJETI + ABJET1 + ABJET2) * COSEC
      RDSTEP = 0.0
      DESTEP = 0.0
C
      RETURN
      END

C   07/06/96 606071853  MEMBER NAME  LBN      (S4)          FORTRAN
      FUNCTION LBN(NX,X)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      LB=0
      CALL BLOC(J,'$BIN',NX,&100)
    5 NJ=MIN0(IW(J),4)+1
      GOTO (100,100,10,15,40),NJ
   10 NB=100
      XB=100.0
      GOTO 20
   15 NB=IW(J+3)
      IF(NB.GT.1000.OR.NB.LE.0) GOTO 10
      XB=NB
   20 LB=XB*(X-RW(J+1))/(RW(J+2)-RW(J+1))+1.0
      IF(LB.GT.NB) GOTO 30
      IF(LB.GE.0)  GOTO 100
   25 LB=0
      GOTO 100
   30 LB=NB+1
      GOTO 100
   40 NB=IW(J)-1
      NL=J+1
      NH=J+IW(J)
      IF(X.LT.RW(NL)) GOTO 25
      IF(X.GE.RW(NH)) GOTO 30
   50 LB=(NL+NH)/2
      IF(LB.EQ.NL) GOTO 60
      IF(X.LT.RW(LB)) GOTO 55
      NL=LB
      GOTO 50
   55 NH=LB
      GOTO 50
   60 LB=LB-J
      GOTO 100
C
      ENTRY LLBN(NX,X)
      J=NX
      GOTO 5
  100 LBN=LB
      RETURN
      END

C   21/08/87 804271518  MEMBER NAME  EAMCDE   (S)           FORTRAN77
      SUBROUTINE EAMCDE( NP, IVECT, DEDX, SDEDX, NHDEDX )
C----------------------------------------------------------
C  VERSION OF 21/08/87       LAST MOD 27/04/88   MZ
C  Calculate dE/dx and sigma(dE/dx) for track specified in
C  Bank ZE4V at position NP (=absolute BOS pointer)
C
C  Input:
C           NP = Pointer to track in ZE4V
C           IVECT = Vect # and particle # in bank
C  Output:
C           DEDX  = dE/dx and
C           SDEDX =  error
C           NHDEDX =  Hits used in dE/dx calculation
C----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      DIMENSION HR(2)
      EQUIVALENCE (HW(1),IW(1),RW(1)), (HR(1),IR)
C                                           FIRST RUNS CORRESPONDING TO
C                                           K.AMBRUS PERIODS
      INTEGER IRUN(39) /
     *   400, 2600, 3730, 6000, 6850, 7170, 7592, 7840, 8120, 8375,
     *  8850, 9188, 9464,10000,10391,10578,10761,11021,11331,11634,
     * 12004,12341,13088,14605,15690,16803,17989,19068,21123,21705,
     * 22651,23443,23798,24201,25454,26217,27000,27938,28444/
C                                           CORRESPONDING TIMES
C                                           THE FIRST PERIODS HAVE NOT
C                                           BEEN CORRELATED YET
      INTEGER ITIM(39) /
     *  97816480,  97816480,  97816480,  97816480,  97816480,  97816480,
     *  97816480,  97816480,  97816480,  97816480,  97816480,  97816480,
     *  97816480,  97816480,  99482653, 100603789, 101329523, 105019795,
     * 106819543, 109577623, 111073856, 112319826, 135611935, 149456837,
     * 159725022, 171437703, 177893401, 194822761, 202803459, 206147941,
     * 210908637, 213476746, 214678727, 225055662, 230412916, 233447245,
     * 236008290, 239739240, 241204057/
      INTEGER NOW / 0 /, INITL / 0 /, ITIME(6)
      INTEGER NRUN / 25000 /
      LOGICAL FIRST / .TRUE. /
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IPZE4V = IBLN('ZE4V')
        NPHEAD = IW(IBLN('HEAD'))
        IF( NPHEAD .GT.0 ) THEN
          DO 1 I=1,6
            ITIME(I) = HW(NPHEAD*2+2+I)
    1     CONTINUE
          IEVTIM = KTMCON( ITIME, NOW, INITL )
          IPER = 1
          DO 2 WHILE( IPER.LT.39 .AND. ITIM(IPER).LT.IEVTIM )
            IPER = IPER + 1
    2     CONTINUE
          NRUN = IRUN(IPER)
          WRITE(6,9601) IPER, NRUN, IEVTIM
 9601     FORMAT(' +++ EAMCDE: Selecting K.Ambrus Period',I3,
     *           ' with first run',I6/
     *           '             recorded',I11,' secs after',
     *           ' beginning of 1/1/1979')
        ENDIF
      ENDIF
C
      DEDX = 0.
      SDEDX = 0.
C
      NPZE4V = IW(IPZE4V)
      IF( NPZE4V .GT. 0 ) THEN
        LT = HW(NPZE4V*2+5)
        NRPHZ = HW((NP+LT)*2+10)
C                                           HITS IN R-PHI FIT
        NRZ = NRPHZ/100
C                                           SET NHDEDX=NRZ
        NHDEDX = MAX( NRZ, 1 )
C                                           PARTICLE TYPE
        IPART = HW(NP*2+8)/100
        IR = IVECT
        NRVECT = HR(1)
        NR     = HR(2)
        CALL CLOC( NPVECT, 'VECT', NRVECT )
        IF( IPART .GT. 0 .AND. NPVECT.GT.0 .AND. NR.GT.0 ) THEN
C                                           TAKE ORIGINAL MOMENTUM FROM
C                                           VECT BANK
          J = NPVECT + IW(NPVECT+1) + (NR-1)*IW(NPVECT+2)
          PTOT = SQRT( RW(J+1)**2+RW(J+2)**2+RW(J+3)**2 )
C
        ELSE
          PTOT = RW(NP+6)
        ENDIF
        CALL DXMCGN( PTOT, NHDEDX, IPART, NRUN, DEDX, SDEDX, DEDXT )
      ENDIF
      END

C31938  MEMBER NAME  JEOSUM3  (GRAFIX.S)    SHELTRAN
Copyright Stanford  Mortran3.1   (FORTRAN 66 11JUN85)
      SUBROUTINE ELLIPS( MODE, INDEX, IDSHE, X, Y, DX, DY, PHIW )
      LOGICAL FLVCDO
      COMMON / CGVCDO / FLVCDO(20)
      IF  (MODE.NE.1) GO TO 20
      IF  (INDEX.NE.20) GO TO 40
      CALL DRAMOV( -X-8.0, Y , -X+8.0, Y , 0 )
      CALL DRAMOV( -X , Y-8.0, -X , Y+8.0, 0 )
      GO TO 30
40    IF(INDEX.NE.17)GO TO 50
      SNPHW = 0.0
      CSPHW = 1.0
      XDEV = DX
      YDEV = DY
      CALL DRAMOV( -X-XDEV, Y , -X+XDEV, Y , 0 )
      CALL DRAMOV( -X , Y-YDEV, -X , Y+YDEV, 0 )
30    CONTINUE
50    CONTINUE
      GO TO 10
20    CONTINUE
      XDEV = DX
      YDEV = DY
      IF  (PHIW.NE.0.0) GO TO 70
      SNPHW = 0.0
      CSPHW = 1.0
      CALL DRAMOV( -X-DX, Y , -X+DX, Y , 0 )
      CALL DRAMOV( -X , Y-YD, -X , Y+DY, 0 )
      GO TO 60
70    CONTINUE
      SNPHW = SIN(PHIW)
      CSPHW = COS(PHIW)
      XN1 = -DX*CSPHW + X
      XN2 = DX*CSPHW + X
      YN1 = DX*SNPHW + Y
      YN2 = -DX*SNPHW + Y
      XN3 = -DY*SNPHW + X
      XN4 = DY*SNPHW + X
      YN3 = -DY*CSPHW + Y
      YN4 = DY*CSPHW + Y
      CALL DRAMOV( -XN1, YN1, -XN2, YN2, 0 )
      CALL DRAMOV( -XN3, YN3, -XN4, YN4, 0 )
60    CONTINUE
10    CONTINUE
      IF  ((MODE.NE.1.OR.INDEX.NE.17).AND.(MODE.NE.0.OR..NOT.(FLVCDO(17)
     *))) GO TO 90
      NPRE = 25
      DTWI = 6.28318/FLOAT(NPRE)
      TWI = 0.0
      XNS = XDEV*CSPHW + X
      YNS = -XDEV*SNPHW + Y
      CALL MOVEA( -XNS, YNS )
      DO 101 I=1,NPRE
      TWI = TWI + DTWI
      XE = XDEV*COS(TWI)
      YE = YDEV*SIN(TWI)
C01 MAY 80)    ELLIPS    SYSTEM/370 FORTRAN H EXTENDED (ENHANCED)    DATE 97.082/19.36.47       PAGE   2
      XN = XE*CSPHW + YE*SNPHW + X
      YN = -XE*SNPHW + YE*CSPHW + Y
      IF  (IDSHE.NE.0) GO TO 120
      CALL DRAWA( -XN, YN )
      GO TO 110
120   CONTINUE
      CALL DASHA( -XN, YN, IDSHE )
110   CONTINUE
101   CONTINUE
102   CONTINUE
90    CONTINUE
      RETURN
      END

C   20/06/84 507190129  MEMBER NAME  HELPPROG (S)           FORTRAN
C
C-----------------------------------------------------------------------
C
C     INSTRUCTIONS:
C
C     1)  COPY MEMBER  HELPMOD  TO A SMALL SEQUENTIAL DATASET
C     2)  USE  ALLOC OLD TO GIVE THE SEQUENTIAL DS A DDNAME FT01F001
C     3)  USE  ALLOC OLD TO GIVE F22BOW.HELP.DATASET A DDNAME OF
C         FT10F001
C     4)  RUN  LOADGO  USING THIS PROGRAM (HELPPROG)
C     5)  THE DIRECT ACCESS DATASET IS NOW READY
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS(80)
C
      EQUIVALENCE  (CHARS(1),IN(1))
C
      DIMENSION  IAR(240), IN(20)
      DIMENSION  ISTAFL(20), IENDFL(20)
C
      DATA  IEND / '----' /
C
      DEFINE FILE 10 ( 200, 1024, E, I1 )
C
      CALL DEFCMD
C
C                            SKIP THE FIRST LINE
C
      READ(1,1,END=99) IN
C
      DO  2  I = 1,200
        N = 0
        READ(1,1,END=99) IN
  1     FORMAT(20A4)
C
        CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
        LEN = IENDFL(2) - ISTAFL(2) + 1
        CALL FINABR( CHARS(ISTAFL(2)), LEN, IREC, MAXARG, IS )
        N = 1
        DO  5  J = 1,20
          IAR(J) = IN(J)
  5     CONTINUE
C
        DO  20  LL = 1,15
          READ(1,1) IN
          IF( IN(1) .EQ. IEND ) GO TO 6
          DO  7  J = 1,20
            K = N*20 + J
            IAR(K) = IN(J)
  7       CONTINUE
          N = N + 1
  20   CONTINUE
C
  6     L = N * 20
        WRITE(10'IREC,3) L,(IAR(K),K=1,L)
  3     FORMAT(I4,240A4)
        WRITE(6,9) L,(IAR(K),K=1,L)
  9     FORMAT(X,I4/15(X,20A4/))
C
  2   CONTINUE
C
 99   STOP
      END

C   12/09/79 501101126  MEMBER NAME  TOFMA5   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFMA2
C
C  DETERMINES TOF FOR EACH TRACK AND ITS QUALITY
C  CREATES BANK TOFR
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       INTEGER *2 HADC,HTDC,HB
       REAL *8 DYC1,DYC2,C,D,FNORM
       COMMON/TFPRM/ NRNC1,NRNC2,DYC1,DYC2,IFLC(42),CM(42),CP(42),
     -DTAU(42),WM(42),WP(42),SV(42),DM(42),DP(42),PEDLM(42),PEDLP(42)
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IRELT(14,50)
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS,ZARUN,ZBRUN
       COMMON/TFPED/ HADC(2,42),HTDC(2,42),HB(42)
      COMMON/TMTP/TAUM(42),TAUP(42)
       DIMENSION IRAW(5,42),IW(704)
       EQUIVALENCE (IRAW(1,1),RAW(1,1)),(IW(1),INFM(1)),
     -             (IW(5),IRELT(1,1))
       DIMENSION IAGREE(3),ZT(2),TMNUS(2),TPLUS(2),DELT(2)
      DATA IENTRY/0/,IBUG/10/
      DATA CVEL/ 2.9979246E2/,DTAU1/1./
      IF(IENTRY.NE.0)  GOTO 66
      IENTRY = IENTRY + 1
      GOTO  66
   66 ZTOF = 0.
      ZTOF1 = 0.
       NNG= 0
       NOK= 0
       NTRR = 0
       CALL SETSL(IW,0,704*4,0)
       CALL SETSL(TAUM,0,84*4,0.)
C
       IBUG = IBUG + 1
      DO 1000 I=1,42
      TRANS= SV(I)
      MTPY= ICRT1(2,I)
      IF(MTPY.EQ.0) GO TO 1000
      IF(MTPY.GE.4) MTPY = 3
C
      DO   1001   M=1,MTPY
      NTR1= ICRT1(M+2,I)
C
      Z1= TRK(1,NTR1)
      PATH1= TRK(3,NTR1)
      PMEV1= TRK(4,NTR1)
      TAUM1= RAW(2,I)-Z1/TRANS
      TAUP1= RAW(3,I)+Z1/TRANS
      C = FNORM(0)
      D = FNORM(0)
      C = C*0.4
      D = D*0.4
      CALL HF1(555,C,1.)
      TAUM1 = TAUM1 + C
      TAUP1 = TAUP1 + D
      IF(IBUG.LE.10) PRINT 109,I,RAW(2,I),RAW(3,I),Z1,TRANS
  109 FORMAT(' TOFMA2',I5,10F10.3)

      TAUM(I) = TAUM1
      TAUP(I) = TAUP1
      NFLG= -1
            IF(HTDC(1,I).GT.10.AND.HTDC(1,I).LT.2048) GO TO 320
            TOF1= TAUP1
            GO TO 360
C
 320        IF(HTDC(2,I).LT.2048) GO TO 330
            TOF1= TAUM1
            GO TO 360
C
  330 IF(ABS(TAUM1-TAUP1).LE.3.*DTAU1) GO TO 350
                 IF(Z1.LT.0.) GO TO 340
                 TOF1= TAUP1
                 GO TO 360
 340  TOF1= TAUM1
      GO TO 360
C
 350  NFLG= 1
      TOF1= (TAUM1+TAUP1)/2.
      ZTOF1 = (RAW(2,I)-RAW(3,I))/2.*TRANS
 360  CONTINUE
      NTRR = NTRR + 1
      IF(NTRR.GT.50)  GOTO  1001
      IF(IBUG.LE.10) PRINT 170, NEV, NTRR,NTR1,I,ITOF1,ITRC(NTR1)
  170 FORMAT(' TOFMA2',10I8)
      TDCM = HTDC(1,I)
      TDCP = HTDC(2,I)
      ADCM = HADC(1,I)
      ADCP = HADC(2,I)
      BETA1 = PATH1/TOF1/CVEL
      IF(IBUG.LE.10) PRINT 171, TAUM1,TAUP1,TOF1,BETA1,Z1,PATH1
  171 FORMAT(' TOFMA2',10F10.3)
      CALL TFSTOR(NTRR,NTR1,NFLG,I,TOF1,PATH1,TDCM,TDCP,ADCM,ADCP,
     -            TAUM1,TAUP1,ITRC(NTR1),BETA1,ZTOF1)
      NOK= NOK+1
CXXXXXXXXXX
 1001 CONTINUE
 1000 CONTINUE
C
C=========   HEADER PART
C
                 NXX= 0
                 DO 2000 I=1,NTRK
                 IF(IRELT(1,I).NE.0) GO TO 2000
                 CALL TFSTOR(I,10,0,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
                 NXX= NXX+1
 2000            CONTINUE
            INFM(1)= NTRK
            INFM(2)= NOK
            INFM(3)= NNG
            INFM(4)= NXX
            LTFR= 14*NTRK+4
C
C=========   STORE RESULT INTO CURRENT BUFFER
C
       CALL BCRE(INTR,'TOFR',0,LTFR,&3000,IER)
       IF(INTR.EQ.0.AND.IER.EQ.2) GO TO 3000
       CALL BSTR(INTR,IW,LTFR)
       CALL BSAT(1,'TOFR')
       RETURN
3000   CONTINUE
C/////////
             WRITE(6,9300)
9300         FORMAT(1X,'BOS ERROR IN TOFMAS')
       RETURN
       END

C   06/03/82 705311925  MEMBER NAME  DEDXB1   (S)           FORTRAN
      SUBROUTINE DEDXB1(ITR)
C-----------------------  LAST CHANGE: 24.03.86   L.BECKER  ---C
C-----------------------  LAST CHANGE: 04.06.86  J.A.J.SKARD --C
C-----------------------  LAST CHANGE: 06.06.86  J.A.J.SKARD --C
C-----------------------  LAST CHANGE: 27.08.86  J.OLSSON    --C
C  SEVERAL CHANGES IN 1987, NOT COMMENTED,   L.SMOLEK...     --C
C  PMCUT IN COMMON/CDEDXU/ FOR VARIABLE P-CUT   J.O.  28.5.87 -C
C  UPDATED PERIODS ACC. TO DEDXBN               J.O.  31.5.87 -C
C                                                              C
C     DEDX FOR ONE TRACK ITR IN 'PATR' BANK                    C
C     SLIGHTLY MODIFIED VERSION OF DEDXBN                      C
C     PUTS ENERGY DEPOSITS FOR EACH WIRE INTO ARRAY EWIR(60),  C
C     CORRESPONDING X,Y,R, AND FITTED Z-VALUES INTO ARRAYS     C
C     XWIR(60),YWIR(60),RWIR(60), AND ZWIR(60), RESPECTIVELY   C
C                                                              C
C     CALCULATION OF DE/DX, SIGMA(DE/DX)      -   P.DITTMANN   C
C     COMPARISON WITH THE THEORETICAL VALUE   -   J.SKARD      C
C     RESULTS ARE WRITTEN INTO COMMON /CWORK1/                 C
C     THE ARRAY TRES(10,ITR) HOLDS THE FOLLOWING RESULTS       C
C                                                              C
C     ITRES(1,ITR)  =  NHIT, QUALITY OF DEDX                   C
C      TRES(2,ITR)  =  DEDX                                    C
C      TRES(3,ITR)  =  SIGMA(DEDX)                             C
C      TRES(4,ITR)  =  CHISQ(ELECTRON)                         C
C      TRES(5,ITR)  =  CHISQ(PION)                             C
C      TRES(6,ITR)  =  CHISQ(KAON)                             C
C      TRES(7,ITR)  =  CHISQ(PROTON)                           C
C     ITRES(8,ITR)  =  JMIN, NUMBER FOR MINIMUM CHISQUARE      C
C                      1 = P, 2 = K, 3 = PI, 4 = E, 0=NO DEDX  C
C      TRES(9,ITR)  =  MOMENTUM (GEV)                          C
C     TRES(10,ITR)  =  MOMENTUM ERROR                          C
C--------------------------------------------------------------C
C----------------DEDX RESULTS-----------------------
C      COMMON /CWORK1/ IER,NTRR,TRES(10,60)
       COMMON /CWORK1/ IER,NTRR,TRES(10,60),EWIR(60),XWIR(60),YWIR(60),
     *                 RWIR(60),ZWIR(60)
       DIMENSION ITRES(10,60)
       EQUIVALENCE (TRES(1,1),ITRES(1,1))
C----------------END--------------------------------
C
C HDATA IS DECLARED INTEGER*2 IN MACRO CDEDEDX
C
#include "cdata.for"
#include "cgraph.for"
#include "cjdrch.for"
C
#include "cdededx.for"
       COMMON/CDEJAS/DEBEST,PBEST
      DIMENSION ICEL(60),XYRZ(6)
C
      DATA IWARN / 0 /, JWARN/0/
C
      IPVERS=JPOINT(IPN+1)
      ICALL =ICALL+1
      IF(ICALL.GT.1)GO TO 9
      IPJETC = IBLN('JETC')
      IPJETV = IBLN('JETV')
      IPJHTL = IBLN('JHTL')
      IPPATR = IBLN('PATR')
      IPHEAD = IBLN('HEAD')
    9 CONTINUE
C
      IJETC = IDATA( IPJETC )
      IJETV = IDATA( IPJETV )
      IJHTL = IDATA( IPJHTL )
      IPATR = IDATA( IPPATR )
      IX    = 2*IDATA( IPHEAD )
      IRUN=HDATA(IX+10)
C        MONTE CARLO - RETURN
      IF(IRUN.EQ.0) RETURN
      IPN = JPOINT(8)
      IF(ICALL.EQ.1 .AND. NDDINN .EQ. 0 ) PRINT 901, IPVERS
  901 FORMAT(/'  ***********  DEDX - RECALIBRATION  VERSION',I8/)
      IF(NHFCUT.EQ.15) GO TO 903
      JWARN=JWARN+1
      IF(NDDINN .EQ. 0 .AND. JWARN .LE. 1) PRINT 902, NHFCUT
  902 FORMAT(/'  ***********  WARNING:         NHFCUT=     ',I8/)
C
  903 CONTINUE
      IF(IJETC.EQ.0 .OR.IJHTL.EQ.0 .OR.IPATR.EQ.0) GOTO 56
      IJETC2 = IJETC*2
      IJETV2 = IJETV*2 + 2
      NT = IDATA(IPATR+2)
C     IF(NT.LE.0 .OR. NT.GT.NTRTOT) GOTO 57
      IF(NT.LE.0 .OR. NT.GT.NTRTOT .OR. ITR.GT.NT) GOTO 57
      IER=0
      NTRR=NT
C        DATE FOR RUN-DEPENDENT CORRECTIONS
      IFLAG = 0
      IPERD = 1
      IF(IRUN.GE.1400)  IPERD=2
      IF(IRUN.GE.2600)  IPERD=3
      IF(IRUN.GE.3730)  IPERD=4
      IF(IRUN.GE.6000)  IPERD=5
      IF(IRUN.GE.7592)  IPERD=6
      IF(IRUN.GE.10000) IPERD=7
      IF(IRUN.GE.11021) IPERD=8
      IF(IRUN.GE.13088) IPERD=9
      IF(IRUN.GE.14605) IPERD=10
      IF(IRUN.GE.15690) IPERD=11
      IF(IRUN.GE.16803) IPERD=12
      IF(IRUN.GE.17988) IPERD=13
      IF(IRUN.GE.19068) IPERD=14
      IF(IRUN.GE.21123) IPERD=15
      IF(IRUN.GE.21705) IPERD=16
      IF(IRUN.GE.22651) IPERD=17
      IF(IRUN.GE.24201) IPERD=18
      IF(IRUN.GE.25454) IPERD=19
      IF(IRUN.GE.27938) IPERD=20
C        Z RECALIBRATION (IF NOT YET DONE)
      IHH=HDATA(IJETC2+2)
      MODE=1
      IF(IPERD.LT.9  .AND. IHH.NE.8305) CALL ZSFIT(MODE)
      IF(IPERD.EQ.9  .AND. IHH.NE.8404) CALL ZSFIT(MODE)
      IF(IPERD.EQ.10 .AND. IHH.NE.8404) CALL ZSFIT(MODE)
      IF(IPERD.EQ.11 .AND. IHH.NE.8412) CALL ZSFIT(MODE)
      IF(IPERD.EQ.12 .AND. IHH.NE.8412) CALL ZSFIT(MODE)
      IF(IPERD.EQ.13 .AND. IHH.NE.8412) CALL ZSFIT(MODE)
      IF(IPERD.EQ.14 .AND. IHH.NE.8511) CALL ZSFIT(MODE)
      IF(IPERD.EQ.15 .AND. IHH.NE.8511) CALL ZSFIT(MODE)
      IF(IPERD.EQ.16 .AND. IHH.NE.8611) CALL ZSFIT(MODE)
      IF(IPERD.EQ.17 .AND. IHH.NE.8611) CALL ZSFIT(MODE)
      IF(IPERD.EQ.18 .AND. IHH.NE.8610) CALL ZSFIT(MODE)
      IF(IPERD.EQ.19 .AND. IHH.NE.8610) CALL ZSFIT(MODE)
      IF(IPERD.EQ.20 .AND. IHH.NE.8610) CALL ZSFIT(MODE)
C
      FIELD = HDATA(IX+30)
      NDAY=HDATA(IX+7)*30+HDATA(IX+6)-30
      MDAY=NDAY
      IF (IFLAG.EQ.1) GOTO 60
   70 CONTINUE
C              --- SPECIAL CORRECTIONS:
      IF (IRUN.GT.12644) CA(8)=0.248
C
      NDAY = NDAY - ID0(IPERD)
      DAY = NDAY
C --------------------------------------- GAS PRESSURE
      PREFAC = 1. / (1.+CP(IPERD)*BP(IPERD)*DAY/AP(IPERD))
C --------------------------------------- SUBPERIODS
      DO 5 L=1,3
      IF(NDAY.LT.LSP(L,IPERD)) GOTO 6
    5 CONTINUE
      L = 1
    6 SUBFAC = SPF(L,IPERD)
C --------------------------------------- ELECTRON ATTACHMENT
      ICLBIN = DAY/10. + 1.5
      IF(ICLBIN.LE.0) ICLBIN=1
      IF(ICLBIN.GT.19) ICLBIN=19
      FRACT = DAY/10. - ICLBIN + 1
      TIMCOR = CA(IPERD) * (CL(ICLBIN)+FRACT*(CL(ICLBIN+1)-CL(ICLBIN)))
      TIMCOR = TIMCOR/1000.
C --------------------------------------- LOOP OVER ALL TRACKS
C ---------- LOOP TAKEN OUT ----------
      L0 = IDATA(IPATR+1)
      LT = IDATA(IPATR+3)
CCC   KT = IPATR + L0
CCC   DO 59 I=1,NT
C--------
      I=ITR
      KT = IPATR + L0 + (ITR-1)*LT
      DEBEST=0.
      PBEST=0.
C--------
      CALL MOMENP(KT,PX,PY,PZ,PTRANS,PMOM,PHI,THE)
C--------
      IF (PMOM.LT.PMCUT) GOTO 58
      NHIT = 0
      CALL VZERO(IZB,60)
      NSAME = 0
      CALL VZERO(EWIR,300)
      IF(ADATA(KT+25).EQ.0.) GOTO 58
      R = -1. / ADATA(KT+25)
      SR = SIGN(1.,R)
      CTH = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      STH = ADATA(KT+10)
      TTH = ABS(STH/CTH)
      IF (TTH.GT.6.) GOTO 58
C
      CPHI = ADATA(KT+8) / CTH
      SPHI = ADATA(KT+9) / CTH
      X0 = ADATA(KT+5)
      Y0 = ADATA(KT+6)
      XM = X0 - R*SPHI
      YM = Y0 + R*CPHI
      R0 = SQRT(X0**2+Y0**2)
      XE = ADATA(KT+12)
      YE = ADATA(KT+13)
      SE = R * ATAN2(SR*(CPHI*(XE-X0)+SPHI*(YE-Y0)),
     *               SR*(SPHI*(XE-X0)-CPHI*(YE-Y0)+R))
      IF(ABS(R).GT.1.E5) SE=SQRT((XE-X0)**2+(YE-Y0)**2)
C
C --------------------------------------- ORDER CELLS
      NC = 0
      DO 12 J=1,6
      KC = IDATA(KT+40-J)
      IF(KC.LE.0 .OR. KC.GT.96) GOTO 12
      IF(NC.EQ.0) GOTO 11
      IF(KC.GT.IC(NC)) GOTO 11
      DO 10 K=1,NC
      IF(KC.GT.IC(K)) GOTO 10
      IF(KC.EQ.IC(K)) GOTO 12
      JC = IC(K)
      IC(K) = KC
      KC = JC
   10 CONTINUE
   11 NC = NC + 1
      IC(NC) = KC
   12 CONTINUE
C --------------------------------------- LOOP OVER CELLS
      IM2 = I*2
      IM1 = IM2*65536
      DO 19 J=1,NC
      NCP = IJETC2 + IC(J) + 2
      NHCELL = (HDATA(NCP+1)-HDATA(NCP))/4
      KHCELL = (HDATA(NCP)-1)/4
      DO 14 L=1,16
   14 IHDT(L) = 0
C --------------------------------------- LOOP OVER HITS
      DO 18 K=1,NHCELL
      KA = IJHTL + KHCELL + K + 1
      IF(IDATA(KA).EQ.0) GOTO 18
      LRFLAG = 0
      ZFLAG = 0
      IMH=LAND(IDATA(KA),MTRNO1)
      IF(IMH.NE.IM1) GOTO 13
      IF(TBIT(IDATA(KA),15)) ZFLAG=1
      IF(TBIT(IDATA(KA), 7)) LRFLAG=1
      KABIT = 15
      GOTO 15
   13 IMH=LAND(IDATA(KA),MTRNO2)
      IF(IMH.NE.IM2) GOTO 18
      IF(TBIT(IDATA(KA),31)) ZFLAG=1
      IF(TBIT(IDATA(KA),23)) LRFLAG=1
      KABIT = 31
C ------------------------------------- HIT FOUND IN CELL IC(J), TRACK I
   15 IF (NHIT.EQ.60) GOTO 20
      NHIT = NHIT + 1
      NH1 = IJETC2 + (KHCELL+K-1)*4 + 101
      IJC(NHIT) = NH1
      ICEL(NHIT) = IC(J)
      IJH(NHIT) = KA
      IF(KABIT.EQ.15) IJH(NHIT)=-IJH(NHIT)
      LRFL(NHIT) = LRFLAG
      MHIT = HDATA(NH1)
      NW(NHIT) = MHIT / 8
      LH(NHIT) = LAND(MHIT,7) + 1
      ILAY = LAND(NW(NHIT),15) + 1
      IF (ILAY.LE.0 .OR. ILAY.GT.16) GOTO 18
      IHDT(ILAY) = NHIT
      IZB(NHIT) = 0
      IF(ZFLAG.EQ.0) GOTO 18
      IZB(NHIT) = LH(NHIT)
   18 CONTINUE
C
C --------------------------------------- X-TALK MATRIX
      DO 119 L=1,16
      K = IHDT(L)
      IF(K.LE.0 .OR. K.GT.60) GOTO 119
      DO 114 M=1,4
      IXL(K,M) = 0
      IXH(K,M) = 0
      IF(L.LE.M) GOTO 112
      IF(IHDT(L-M).EQ.0) GOTO 112
      IXL(K,M) = IHDT(L-M)
  112 IF(L.GE.17-M) GOTO 114
      IF(IHDT(L+M).EQ.0) GOTO 114
      IXH(K,M) = IHDT(L+M)
  114 CONTINUE
  119 CONTINUE
   19 CONTINUE
   20 CONTINUE
C --------------------------------------- LOOP OVER ALL HITS OF TRACK I
      NHF = 0
      NCL = -1
C
      DO 29 J=1,NHIT
      IF(IZB(J).EQ.0) GOTO 29
      NC = NW(J) / 16
      NR = NC / 24
      IF(NR.LT.3) NR=NR+1
      INR = (NR-1)*2
      NL = LAND(NW(J),15)
      NH1 = IJC(J)
C --------------------------------------- AMPLITUDES & DRIFT TIME
      AR = HDATA(NH1+1)
      AL = HDATA(NH1+2)
      T = HDATA(NH1+3) / 64.
C
      ILR = LRFL(J) + 1
      TM = VDREL(IPERD)*(TMAX(ILR,NR)+TSLP(ILR,NR)*NL)
      XT = T / TM
      AMP = AL + AR
      AMP = AMP / 8.
C --------------------------------------- REMOVE HITS IN CELL CORNERS
      IF(NL.GT.0 .AND. NL.LT.14) GOTO 21
      IF(T.LT.90.) GOTO 21
      IF(NL.EQ.15.AND.LRFL(J).EQ.1) GOTO 26
      IF(NL.EQ. 0.AND.LRFL(J).EQ.0) GOTO 26
      IF(NR.EQ.2.AND.NL.EQ.14.AND.LRFL(J).EQ.1.AND.T.GT.180.) GOTO 26
   21 IF(XT.GT.0.97) GOTO 26
      IF(T.LE.4.) GOTO 26
      IF(IPERD.EQ.1 .AND. NC.EQ.9) GOTO 26
C --------------------------------------- X - TALK
      DW(J) = 0
      DO 124 M=1,4
      JXT = 1
      K = IXL(J,M)
      IF(K.LE.0 .OR. K.GT.60) GOTO 122
  121 NHX = IJC(K)
      AMPX = (HDATA(NHX+1)+HDATA(NHX+2))/8.
      TX = HDATA(NHX+3)/64.
      GATE = T - TX - 1.0
      IF(GATE.LT.0.) GOTO 125
      IF(GATE.GT. 9.) GOTO 122
      BT = GATE
      GOTO 126
  125 BT = 10. + GATE
      IF(BT.LE.0.) GOTO 122
  126 FXT = 1.-BT/5.*(1.-BT/20.)
      IF(GATE.LT.0.) FXT=1.-FXT
      AMP = AMP + AMPX*CTALK(M)*FXT
      DW(J) = DW(J) + AMPX*CTALK(M)
  122 JXT = JXT + 1
      IF(JXT.GT.2) GOTO 124
      K = IXH(J,M)
      IF(K.NE.0) GOTO 121
  124 CONTINUE
      DL(J) = AMP
C --------------------------------------- GAIN
      GAIN=ACALIB(IPN+6+NW(J))
      AMP = AMP * GAIN
C --------------------------------------- WIRE STAGGERING
      IMH=LAND(NL,1)
      IF(IMH.NE.LRFL(J)) AMP=AMP*0.92
C -------------------- COMPUTE TRACK LENGTH IN DRIFTSPACE, ANODE CURRENT
C ----IF(ABS(R).GT.4000. .AND. NC.EQ. NCL) GOTO 24----
      IF(NC.EQ.NCL) GOTO 23
      NCL = NC
      CURR = 0.
      IF(IJETV.EQ.0) GOTO 22
      NS = NC - (NR-1)*24
      IF(NR.EQ.3) NS=NS/2
      KR = NR
      IMH=LAND(NC,1)
      IF(NR.EQ.3 .AND. IMH.EQ.1) KR=4
      ICURR = HDATA(IJETV2+NS*4+KR)
      CURR = LAND(ICURR,2047)
      IF (CURR.GT.80.) CURR=0.
   22 PHIW = 0.1309 + 0.2618*NC
      IF(NC.GE.48) PHIW=PHIW/2.
      CPHW = COS(PHIW)
      SPHW = SIN(PHIW)
C ----CPHD =  SPHW*CALF - CPHW*SALF----
C ----SPHD = -CPHW*CALF - SPHW*SALF----
      CPHD =  SPHW*DRICOS + CPHW*DRISIN
      SPHD = -CPHW*DRICOS + SPHW*DRISIN
   23 RW = 211.*NR + 10.*NL
      XW = RW * CPHW
      YW = RW * SPHW
      SGAM = ((XW-XM)*SPHD-(YW-YM)*CPHD)/R
      IF(ABS(SGAM).GT..87) GOTO 26
      CGAM = SQRT(1.-SGAM**2)
      TGAM = SGAM/CGAM
C --------------------------------------- TRACK LENGTH
   24 AMP = AMP * CGAM*CTH
      DT(J) = TGAM
C --------------------------------------- ANODE CURRENT
      AMP = AMP / (1.-0.00011*CURR**2)
C --------------------------------------- FINITE GATE LENGTH
      AMP = AMP / (1.-0.25*TGAM-0.60*TGAM**2)
C --------------------------------------- SATURATION
      AMP = AMP/(1.-SATTO(INR+1,IPERD)*EXP(-SATTO(INR+2,IPERD)*SQRT(T)))
      AMP = AMP/(1.-SATQUA(NR,IPERD)*T**2/1000.)
      AMP = AMP*9.67/SATFAC(NR,IPERD)
C
C --------------------------------------- GAS PRESSURE
      AMP = AMP * PREFAC
C --------------------------------------- SUBPERIODS
      AMP = AMP * SUBFAC
C --------------------------------------- DAY/4 CORRECTION
      IDAY4=MDAY/4 + (NR-1)*100 + 1
      ADAY4=ACALIB(IPN+1541+IDAY4)
      AMP = AMP * ADAY4
C --------------------------------------- ATTACHMENT
      AMP = AMP * EXP(TIMCOR*T)
C --------------------------------------- GAIN SATURATION
      AMP = AMP/(1.-SATSO(INR+1,IPERD)*EXP(-SATSO(INR+2,IPERD)*
     *                                   SQRT(TTH**2+SATSO(7,IPERD)*T)))
C --------------------------------------- EDGE FIELD DISTORTIONS
      IF(NL.GT.3 .AND. NL.LT.12) GOTO 25
      IL = NL
      IF(NL.GT.8) IL=15-NL
      ICORN = 0
      IF(NL.LT.8 .AND. LRFL(J).EQ.1) ICORN=1
      IF(NL.GT.8 .AND. LRFL(J).EQ.0) ICORN=1
      ICORN = ICORN*4 + IL + 1
      XTORT = XT - 0.5
      IF(XTORT.LT.0.) XTORT=0.
      AMP = AMP * FTORT(1,ICORN)*(1.+FTORT(2,ICORN)*XTORT)
   25 CONTINUE
      IF (NHF.EQ.60) GOTO 30
      NHF = NHF + 1
      G(NHF) = AMP
      S(J) = AMP
      CALL JFXYRZ(KT,NH1,LRFL(J),NSAME,ICEL(J),XYRZ)
      NSAME = 1
      EWIR(NHF) = AMP
      XWIR(NHF) = XYRZ(1)
      YWIR(NHF) = XYRZ(2)
      RWIR(NHF) = XYRZ(5)
      ZWIR(NHF) = XYRZ(6)
      GOTO 29
   26 IZB(J) = 0
   29 CONTINUE
   30 CONTINUE
C
      IF(NHF.LT.NHFCUT) GOTO 58
      CALL DSORT(NHF,G,TRCM,DTRCM)
      IF(TRCM.LT.0.1) GOTO 58
C
C-------------  RESULTS  ----------------------------------------------
C
      ITRES(1,I)=NHF
      TRES(2,I)=TRCM
      TRES(3,I)=2.6*DTRCM
      TRES(9,I)=PMOM
C
      PP2=TRCM
      SIGDE=TRES(3,I)
C
       CHMIN=1000000.
       SIGPP=1000000.
       JMIN=0
      CALL ERRMOM(KT,PMOM,ELMASS,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,ELMASS,PDEELC,DEDELC,CHIELC)
       IF(CHMIN .LT. CHIELC) GOTO 250
       CHMIN=CHIELC
       SIGPP=SIGMP
       DEBEST=DEDELC
       PBEST=PDEELC
       JMIN=4
250   CALL ERRMOM(KT,PMOM,PIOMAS,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,PIOMAS,PDEPIO,DEDPIO,CHIPIO)
       IF(CHMIN .LT. CHIPIO) GOTO 251
       CHMIN=CHIPIO
       SIGPP=SIGMP
       DEBEST=DEDPIO
       PBEST=PDEPIO
       JMIN=3
251   CALL ERRMOM(KT,PMOM,FKAMAS,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,FKAMAS,PDEKAO,DEDKAO,CHIKAO)
       IF(CHMIN .LT. CHIKAO) GOTO 252
       CHMIN=CHIKAO
       SIGPP=SIGMP
       DEBEST=DEDKAO
       PBEST=PDEKAO
       JMIN=2
252   CALL ERRMOM(KT,PMOM,PROTMA,SIGMP)
      CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,PROTMA,PDEPRO,DEDPRO,CHIPRO)
       IF(CHMIN .LT. CHIPRO) GOTO 253
       CHMIN=CHIPRO
       SIGPP=SIGMP
       DEBEST=DEDPRO
       PBEST=PDEPRO
       JMIN=1
253    TRES(4,I)=CHIELC
       TRES(5,I)=CHIPIO
       TRES(6,I)=CHIKAO
       TRES(7,I)=CHIPRO
       ITRES(8,I)=JMIN
       TRES(10,I)=SIGPP
       GOTO 59
C
   58 CONTINUE
      ITRES(1,I)=-1
      TRES(2,I)=0.
      TRES(3,I)=0.
      TRES(4,I)=-1.
      TRES(5,I)=-1.
      TRES(6,I)=-1.
      TRES(7,I)=-1.
      ITRES(8,I)=0
      TRES(9,I)=PMOM
      TRES(10,I)=1000000.
C
C-------------  END OF RESULTS  ---------------------------------------
C
CCC59 KT = KT + LT
C----
   59 CONTINUE
C----
C
      RETURN
C
   56 PRINT 561
  561 FORMAT ('  ***** ERROR IN DEDXB1: BANK POINTER = 0')
      IER=1000
      NTRR=0
      RETURN
C
   57 PRINT 571
  571 FORMAT ('  ***** ERROR IN DEDXB1: # OF TRACKS < 0 , > 60 , OR GIVE
     *N TRACK NO. > MAX.')
      IER=4000
      NTRR=0
      RETURN
C
   60 NDAY=75 + ID0(IPERD)
      IWARN=IWARN+1
      IF(IWARN.EQ.1) PRINT 601, IRUN
  601 FORMAT(/'  ***********  WARNING: DEDX CALIBRATION CONSTANTS NOT VA
     +LID FOR THESE DATA !!!'/'  ***********  RUN #  :',I10,'  AND LATER
     +'/)
      GOTO 70
C
      END

C   01/11/84 411011623  MEMBER NAME  TRIG2    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRIG2
C-----------------------------------------------------------------------
C
C   AUTHOR:     J. OLSSON       ?    :  DISPLAYS "TRIG(2)" RESULTS
C
C   LAST MOD:   J.H. C.B.    1/11/84 :  ROTNK CHANGE UPDATE
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            DISPLAYS "TRIG(2)" RESULTS.
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CJTRIG / PI, TWOPI
      COMMON / CJCELL / NCELL(3), NWIRES(3)
C
      DIMENSION  RAD(5),IPOINT(5),HCHAR(5),HWORD(2)
C
      EQUIVALENCE (IWORD,HWORD(1))
C
      DATA  IPOINT / 2,2,1,3,4 /
      DATA  HCHAR / 'O','O','O','A','F' /
      DATA  ICALL / 0 /
C
C------------------  C O D E  ------------------------------------------
C
      IF( ICALL .NE. 0 ) GO TO 10
      ICALL = 1
      RAD(1) = (FSENSW(2)+FSENSW(1)+(NWIRES(1)-1)*RINCR(1))/2.
      RAD(2) = (FSENSW(3)+FSENSW(2)+(NWIRES(2)-1)*RINCR(2))/2.
      GAP    = FSENSW(3)-FSENSW(2)-(NWIRES(2)-1)*RINCR(2)
      RAD(3) = FSENSW(3)+(NWIRES(3)-1)*RINCR(3)+GAP/2.
C
      SH1      = GAP - 35.0
      ROTNKP   = ROTNK + DROTNK
      RAD(4)   = ROTNKP +     (RTOF - ROTNKP)/4.0
      RAD(5)   = ROTNKP + 2.0*(RTOF - ROTNKP)/3.0
      HWORD(1) = 0
   10 CONTINUE
      IPJ=IDATA(IBLN('TRIG'))
      IF(IPJ.LT.1) RETURN
      IBN=IDATA(IPJ-2)
      IF(IBN.EQ.2) GO TO 1
      IPJ=IDATA(IPJ-1)
      IF(IPJ.LT.1) RETURN
      IBN=IDATA(IPJ-2)
      IF(IBN.NE.2) RETURN
    1 CONTINUE
      IWO=2*IPJ-2
      DO 2 IREG=1,6
      PHI0=(IREG-1)*TWOPI/6.
      IWO=IWO+4
      DO 3 IRAD=1,5
      IRING=IRAD
      IF(IRING.GT.3) IRING=3
      HWORD(2)=HDATA(IWO+IPOINT(IRAD))
      IF(IRAD.EQ.1) IWORD=ISHFTR(IWORD,8)
      R=RAD(IRAD)
      HWRIT=HCHAR(IRAD)
      NN=NCELL(IRING)/3
      DPHI=TWOPI/(6*NN)
      MASK=1
      DO 4 IPHI=1,NN
      PHI=PHI0+IPHI*DPHI
      ITEST=LAND(IWORD,MASK)
      MASK=2*MASK
      IF(ITEST.EQ.0) GO TO 4
      X=-R*COS(PHI)
      Y= R*SIN(PHI)
      PHWT=PI/2.-PHI
      IF(PHWT.LT.0.) PHWT=PHWT+TWOPI
      DX0=-SH1/3.
      DY0=-SH1/2.
      DX=COS(PHWT)*DX0-SIN(PHWT)*DY0
      DY=SIN(PHWT)*DY0+COS(PHWT)*DX0
      X=X+DX
      Y=Y+DY
      ICNT=1
      CALL HEMSYM(X,Y,SH1,HWRIT,ICNT,PHWT)
    4 CONTINUE
    3 CONTINUE
    2 CONTINUE
      RETURN
      END

C   07/06/96 606071905  MEMBER NAME  PVERT    (S4)          FORTRAN
      SUBROUTINE PVERT(X,N,NN)
C     PURPOSE
C        PRINT THE ARRAY X OF DIMENSION N (MAX 120) IN IABS(NN) LINES
C
C     USAGE
C        CALL PVERT(X,N,NN)
C        IABS(NN)    =NUMBER OF DIGITS (3 TO 6)
C        NN NEGATIVE = PRINT NO INDEXLINE BELOW ARRAY
      COMMON/CCONVT/JM,PX(32,9)
      REAL X(1)
      INTEGER PX,BLK/'    '/,PE/'  E '/,PM/'   .'/
      LOGICAL*1 LX(128,8),CHM/'-'/,CH(12)/'0','1','2',
     1     '3','4','5','6','7','8','9',' ','*'/
      EQUIVALENCE (PX(1,1),LX(1,1))
C
      JM=0
      DO 10 I=1,9
      DO 10 J=1,32
   10 PX(J,I)=BLK
      IF(N.LE.0) GOTO 100
      M=MIN0(120,N)
C
      JL=0
      XM=0.0
      DO 20 J=1,M
      IF(ABS(X(J)).LE.XM) GOTO 14
      XM=ABS(X(J))
      MX=J
   14 IF(X(J)) 16,20,18
   16 LX(8+J,1)=CHM
   18 JL=J
   20 CONTINUE
      IF(XM.EQ.0.0) GOTO 100
      IF(JL.LE.0) GOTO 100
      KN=IABS(NN)
      KN=MAX0(3,KN)
      KN=MIN0(6,KN)
      KE=DLOG10(DBLE(XM))
      IF(XM.LT.1.0) KE=KE-1
   22 FAC=1.D1**(KN-1-KE)
      IJ=FAC*XM+0.5
      IF(IJ.LT.10**KN) GOTO 24
      KE=KE+1
      GOTO 22
   24 IA=2+KN
C
      DO 40 J=1,JL
      IJ=FAC*ABS(X(J))+0.5
      IM=0
      IF(IJ.EQ.0) GOTO 40
      DO 30 I=1,KN
      IF(IJ.EQ.0) GOTO 40
      IH=IJ/10
      IN=IJ-10*IH
      IF(IN.NE.0.AND.IM.EQ.0) IM=IA-I+1
      LX(8+J,IA-I)=CH(IN+1)
   30 IJ=IH
   40 JM=MAX0(IM,JM)
      KL=KE
   50 IF(KE.LT.KN) GOTO 55
      KE=KE-3
      GOTO 50
   55 IF(KE.GE.0) GOTO 60
      KE=KE+3
      GOTO 55
   60 IN=KE+2
      IZ=KL-KE
      PX(2,IN)=PM
      PX(1,IN)=PE
      IF(IZ.GE.0) GOTO 70
      LX(4,IN)=CHM
      IZ=-IZ
   70 I1=IZ/10
      I2=MOD(IZ,10)
      LX(5,IN)=CH(I1+1)
      LX(6,IN)=CH(I2+1)
      JM=MIN0(2+KN,JM)
      JM=MAX0(IN+1,JM)
C
      DO 80 J=1,JL
      IF(X(J).NE.0.0.AND.LX(8+J,JM-1).EQ.CH(11)) LX(8+J,JM-1)=CH(1)
   80 CONTINUE
      DO 85 I=JM,8
      DO 85 J=1,27
   85 PX(J,I)=BLK
      DO 90 J=1,JL
      LX(8+J,JM)=CHM
      IF(MOD(J,2).EQ.1) GOTO 90
      I=MOD(J,10)+1
      LX(8+J,JM+1)=CH(I)
      IF(I.NE.1) GOTO 90
      I=MOD(J/10,10)+1
      LX(8+J,JM)=CH(I)
   90 CONTINUE
      LX(8+MX,JM)=CH(12)
      JM=JM+1
      IF(NN.LT.0) JM=JM-2
      DO 95 J=1,JM
   95 WRITE(6,101) (PX(I,J),I=1,32)
C
  100 RETURN
  101 FORMAT(3X,32A4)
      END

C   29/07/79 C9073001   MEMBER NAME  MDALGN   (S)           FORTRAN
      SUBROUTINE MDALGN
C-----------------------------------------------------------
C
C   VERSION OF 29/07/79      LAST MOD    30/07/79       E.ELSEN
C   ERASE NON EXISTING LG RINGS FOR MONTE CARLO DATA
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1)
      EQUIVALENCE ( HW(1), IW(1) )
C
      COMMON / CLGHIT / AMPL(3000)
C
C                                          GET ALGN BANK POINTER
      NPALGN = IW( IBLN('ALGN') )
      IF( NPALGN .EQ. 0 ) RETURN
      NP2 = NPALGN * 2
      IF( HW( NP2 + 3 ) .GE. HW( NP2 + 6 ) ) RETURN
C                                          INITIALISE AMPL
      CALL VZERO( AMPL, 3000 )
C                                          GET INTERNAL POINTERS
      IL = NP2 + HW(NP2+3) + 6
      IH = NP2 + HW(NP2+6) + 4
C                                          COPY FIRED BLOCKS TO HAMPL
C                                          INCREMENT BLOCK NUMBER FOR
C                                          PROPER USE IN STALGN
      DO 1000  I = IL, IH, 2
 1000 AMPL(HW(I)+1) = HW(I+1) + .5
C                                           ERASE EXTREME RINGS
      CALL ORDLG
C                                           CHECK IF BLOCKS SURVIVE
      CALL LHALGN( LNEW )
      IF( LNEW .EQ. 0 ) GO TO 2000
C                                           CHANGE LENGTH OF ALGN
      LD = LNEW - IW(NPALGN)
      IF( LD .GE. 0 ) RETURN
      CALL BCHM( NPALGN, LD, IER )
      CALL STALGN( LNEW, IW(NPALGN+1) )
      RETURN
C
C                                           DELETE BANK
 2000 CALL BDLS( 'ALGN', IW(NPALGN-2) )
      RETURN
      END

C   17/05/84 406142013  MEMBER NAME  DEFWRD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DEFWRD( HSTART, CSTRNG )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  17/05/84 :  ADD CSTRNG TO DICTIONARY
C
C
C     THIS ROUTINE ADDS THE COMMAND WORD IN CSTRNG (ENDS IN ^) TO THE
C     DICTIONARY ARRAY CDICTY IN / CGRAP3 /.  IDEFWP IS BLOCKDATA SET 0.
C     BE CAREFUL NOT TO OVERFLOW THE CDICTY ARRAY.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CDICTY, CSTRNG(20), CSTOP
C
      COMMON / CGRAP3 / IDEFWP, CDICTY(700)
C
      DATA  CSTOP / '^' /
C
C------------------  C O D E  ------------------------------------------
C
C
C                            COPY BYTE STRING IN CSTRNG TO DICTIONARY
C                            ARRAY CDICTY. STOP WHEN ^ IS FOUND.
C
      J = 0
      DO  1  I = 1,20
        CDICTY( I + IDEFWP ) = CSTRNG(I)
        J = J + 1
        IF( CSTRNG(I) .EQ. CSTOP ) GO TO 3
   1  CONTINUE
C
      WRITE(6,2) (CSTRNG(K),K=1,20)
   2  FORMAT(' ERROR DURING COMMAND DEFINITION PHASE'/
     +       ' CSTRNG WAS --> ',20A1/
     +       ' PROBABLY A ''^'' CHARACTER IS MISSING IN S/R COMWRD')
      STOP 999
C
C                            STORE THE STARTING POINT OF THIS WORD
C
   3  HSTART = IDEFWP + 1
      IDEFWP = IDEFWP + J
      RETURN
      END

C   11/09/81 807241304  MEMBER NAME  AXSHOW   (S)           FORTRAN
      SUBROUTINE AXSHOW
      IMPLICIT INTEGER*2 (H)
C---
C---     SUBROUTINE TO DISPLAY AXES AND RELATED RESULTS FROM SPHERICITY
C---     AND THRUST ROUTINES. 2,3 AND 4 JET ANALYSIS WITH THE PROGRAM
C---     MCGJET DUE TO M.C. (MONTE CARLO) GODDARD
C---           J.OLSSON 11.09.81      LAST CHANGE   23.06.82
C---       ERROR IN PROJECTIONS OF AXIS DISPLAY CORRECTED
C---       ACCORDING TO K.H. HELLENBRAND             5.11.85
C---    AN ERROR IN THE PRECEEDING CORRECTION CORRECTED
C---       ACCORDING TO K.H. HELLENBRAND            19.11.85
C---     DRAWING OF SPHERICITY AXIS ALSO IN VRX AND VC VIEWS
C---                    J. HAGEMANN                 06.03.86
C---     ALLOW ANALYSIS FOR DIFFERENT PATR-BANKS
C---                    J. HAGEMANN                 13.05.86
C---     DRAW SPHERICITY AXIS THROUGH RUN VERTEX
C---                    J. HAGEMANN                 16.05.86
C-
C-   INPUT FOR SPHERC IS STORED IN COMMON CWORK, ARRAY P
C-  OUTPUT FOR SPHERC IS STORED IN COMMON CWORK
C-
C-   INPUT FOR MCGJET IS STORED IN COMMON SENSE
C-   OUTPUT FOR MCGJET IS STORED IN COMMONS MARKET,COLD,CRUST
C-   NOW IN /CWORK/ FOR SPACE ECONOMY
C-
C-   MCGJET REQUIRES IN THE CASE OF 3-4 JET ANALYSIS ALSO THE INPUT
C-   OF A VECTOR DEFINING THE NORMAL TO THE EVENTPLANE. FOR THIS
C-   PURPOSE, SPHERC IS CALLED AND THE VECTOR CORRESPONDING TO SMALLEST
C-   EIGENVALUE IS USED.
C-
      DIMENSION HCOR(4,100),AXEL(3),AXD(3)
#include "cdata.for"
#include "cgeo1.for"
#include "cgraph.for"
      LOGICAL FL18,FL22,FL24
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      LOGICAL DSPDTM
      COMMON /CGRAP2/ BCMD,DSPDTM(30)
      COMMON /CHEADR/ HEAD(108)
C
      LOGICAL FLVCDO
      COMMON / CGVCDO / FLVCDO(20)
      COMMON /CJTRIG/ PI,TWOPI,PIHALF
      COMMON /CWORK1/ NMOM,P(4,100),T(6),R(9),AXIS(9),SPHITY(3)
      EQUIVALENCE(SPHITY(3),PTHR),(HEAD(18),HRUN)
      COMMON /CWORK/ PAR(3,4),PP(4,100),INUM,DUM(124),
     $ AXTS(3),THR,
     $ IJ(4),PTH(3,100,4),IPJ(100,4)
      COMMON / CVX    / NNPATR,NDUMM,NNJETC,NNVTXC
C     COMMON /SENSE/ PP(4,100),INUM
      DIMENSION IPP(4,100)
      EQUIVALENCE (PP(1,1),IPP(1,1))
C     COMMON /MARKET/ PAR(3,4)
C     COMMON /COLD/ IJ(4),PTH(3,100,4),IPJ(100,4)
C     COMMON /CRUST/ AXTS(3),THR
      DATA ZDEEP /5800./,ICALL/0/
C
      IF(ICALL.NE.0) GO TO 3510
      ZETMX = ZLGPL + ZDEEP
      ICALL = 1
3510  IF( LASTVW .LE. 11  .OR.  LASTVW .EQ. 14  .OR.
     &    LASTVW .EQ. 17  .OR.  LASTVW .EQ. 20 ) GO TO 3511
      CALL TRMOUT(80,' NOT AVAILABLE IN THIS VIEW ...^')
      GO TO 2235
3511  NJ=ACMD
      NJ1=BCMD
      IF(NJ.NE.0.OR.FL18) GO TO 100
      CALL TRMOUT(80,'CODE 1   : DISPLAY SPHERICITY AXIS^')
      CALL TRMOUT(80,'CODE 1 -1: DISPLAY SPHERICITY AXIS,PRINT Q VALUES^
     $')
      CALL TRMOUT(80,'CODE 2   : 2-JET ANALYSIS; AXIS DISPLAY^')
      CALL TRMOUT(80,'CODE 3   : 3-JET ANALYSIS; AXIS DISPLAY^')
      CALL TRMOUT(80,'CODE 4   : 4-JET ANALYSIS; AXIS DISPLAY^')
      CALL TRMOUT(80,'CODE K L : K-JET ANALYSIS; DISPLAY OF TRACKS BELON
     $GING TO JET L^')
      CALL TRMOUT(80,'CODE K -1: K-JET ANALYSIS; DISPLAY OF THRUST AXIS^
     $')
      CALL TRMOUT(80,'ENTER OPTION:^')
      CALL FYRINT(NJ,NJ1,IDM3,IDM4)
100   IF(NJ.GE.1.AND.NJ.LE.4) GO TO 200
      GO TO 2531
200   IF(NJ1.GE.-1.AND.NJ1.LE.NJ) GO TO 201
      GO TO 2531
201   CONTINUE
C
C                   ---------- ***   SET UP INPUT VECTORS *** --------
C
      EBM = EBEAM(HRUN)*.001
C
      IF( NNPATR .LT. 1 .OR. NNPATR .GT. 99 ) GO TO 2220
         CALL CLOC( IPO, 'PATR', NNPATR )
         IF( IPO .GT. 0 ) GO TO 2224
            WRITE(6,2219) NNPATR
2219        FORMAT(' PATR BANK NR',I3,' (GIVEN BY COMMAND PATR) NOT EXIS
     &TING')
2220  IPO=IDATA(IBLN('PATR'))
      IF(IPO.NE.0) GO TO 2224
      CALL TRMOUT(80,'PATR BANK DOES NOT EXIST^')
      GO TO 2235
2224  IPLGCL = IDATA(IBLN('LGCL'))
      IF(IPLGCL.NE.0) GO TO 2223
      CALL TRMOUT(80,'LGCL BANK DOES NOT EXIST^')
      GO TO 2235
2223  IPALGN=IDATA(IBLN('ALGN'))
      IF(IDATA(IPLGCL+21).NE.2) CALL LGCDIR(IPO,IPALGN,IPLGCL)
      NWPCL = IDATA(IPLGCL+25)
      IPOG = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      NCLST = IDATA(IPLGCL+7)
      LO = IDATA(IPO+1)
      NTR = IDATA(IPO+2)
      NMOM = 0
      INUM = 0
      IF(NTR.EQ.0) GO TO 523
      LTR = IDATA(IPO+3)
      IPZ = IPO + LO - LTR
      ITP = 1
      DO 1004  JTR = 1,NTR
      IPZ = IPZ + LTR
      CALL TRACK(IPZ,ITP,RMIN,NHT,FI,THETA,PTOT,PT,PL,PX,PY,PZ)
      IF(PTOT.LT.EBM) GO TO 3910
      WRITE(6,3911) JTR,PTOT,EBM
3911  FORMAT(' TRACK NR ',I2,' SCALED FROM ',E12.4,' TO ',E12.4)
      PTOTR = PTOT
      PTOT = EBM
      FACTOR = EBM/PTOTR
      PT = PT*FACTOR
      PL = PL*FACTOR
      PX = PX*FACTOR
      PY = PY*FACTOR
      PZ = PZ*FACTOR
3910  NMOM = NMOM + 1
      INUM = INUM + 1
      HCOR(1,NMOM) = ITP
      HCOR(2,NMOM) = IPZ
      HCOR(3,NMOM) = JTR
      HCOR(4,NMOM) = 0
      P(1,NMOM) = PX
      P(2,NMOM) = PY
      P(3,NMOM) = PZ
      P(4,NMOM) = PTOT
      PP(1,NMOM) = PX
      PP(2,NMOM) = PY
      PP(3,NMOM) = PZ
      IPP(4,NMOM) = NMOM
1004  CONTINUE
C  PHOTON PART
523   IF(NCLST.EQ.0) GO TO 1015
      IPZ = IPOG
      IGAM = 0
      ITP = 0
      DO 522  IGM = 1,NCLST
      IPZ = IPZ + NWPCL
      CALL TRACK(IPZ,ITP,RMIN,NHT,FI,THETA,PTOT,PT,PL,PX,PY,PZ)
      IF(IDATA(IPZ+8).EQ.0) GO TO 8800
      IF(PTOT.LT.1.0) GO TO 522
C SUBTRACK STANDARD 400 MEV FROM TRACK ASSOCIATED CLUSTERS ABOVE 1 GEV
      PTOT1 = PTOT - .400
      FACTOR = PTOT1/PTOT
      PX = PX*FACTOR
      PY = PY*FACTOR
      PZ = PZ*FACTOR
      PTOT = PTOT1
      IGAM = -1
      GO TO 8801
8800  IGAM = IGAM + 1
8801  CALL MOMGAM(IPZ,PX,PY,PZ,PT,PTOT,FI,THE)
      NMOM = NMOM + 1
      INUM = INUM + 1
      HCOR(1,NMOM) = ITP
      HCOR(2,NMOM) = IPZ
      HCOR(3,NMOM) = IGAM
      HCOR(4,NMOM) = 0
      P(1,NMOM) = PX
      P(2,NMOM) = PY
      P(3,NMOM) = PZ
      P(4,NMOM) = PTOT
      PP(1,NMOM) = PX
      PP(2,NMOM) = PY
      PP(3,NMOM) = PZ
      IPP(4,NMOM) = NMOM
522   CONTINUE
1015  IF(NMOM.GT.0) GO TO 1017
      CALL TRMOUT(80,'NO TRACKS, NO PHOTONS !!!^')
      GO TO 2235
1017  CALL SPHERC
      IF(NJ.GT.1) GO TO 2000
C
C--------------------------- *** SPHERICITY DISPLAY *** -------------
C
      SUM = SPHITY(1)+SPHITY(2)+SPHITY(3)
      Q1 = 1. - 2.*SPHITY(3)/SUM
      Q2 = 1. - 2.*SPHITY(2)/SUM
      Q3 = 1. - 2.*SPHITY(1)/SUM
      Q4 = (Q3-Q2)/SQRT(3.)
      Q5 = Q2 - Q1
C  WRITE OUTPUT OF SPHERC
      IF(.NOT.FL18) WRITE(6,7892) AXIS(1),AXIS(2),AXIS(3),SPHITY(1)
7892  FORMAT(' SPHERICITY:  AXES ',3F7.3,'   VALUE  ',F7.4)
      IF(NJ1.EQ.-1.AND..NOT.FL18) WRITE(6,7895) Q1,Q2,Q3
7895  FORMAT(' Q1-3 :  ',3E12.4)
      IF(NJ1.EQ.-1.AND..NOT.FL18) WRITE(6,7897) Q4,Q5
7897  FORMAT(' (Q3-Q2)/ROOT3 : ',E12.4,'    Q2-Q1 : ',E12.4)
C--
      DO 7575  I = 1,3
7575  AXD(I) = AXIS(I)
      IRETUR = 1
      GO TO 7000
C
C ------------ ***  JET AXIS ANALYSIS  WITH MCGJET *** ----------
C
2000  CONTINUE
      DO 2001  I = 1,3
2001  AXEL(I) = AXIS(6+I)
      CALL MCGJET(NJ,AXEL)
      IF(NJ1.NE.0) GO TO 3000
C
C ------------ ***  JET AXIS DISPLAY  *** ----------
C
      DO 2002  NJET = 1,NJ
      DO 7576  I = 1,3
7576  AXD(I) = PAR(I,NJET)
      IRETUR = 2
      GO TO 7000
2003  CONTINUE
2002  CONTINUE
      GO TO 2235
C
C ------------ ***  THRUST AXIS DISPLAY  *** ----------
C
3000  IF(NJ1.NE.-1) GO TO 4000
      DO 7577  I = 1,3
7577  AXD(I) = AXTS(I)
      IRETUR = 3
      GO TO 7000
3001  IF(.NOT.FL18) WRITE(6,3002) AXTS(1),AXTS(2),AXTS(3),THR
3002  FORMAT(' THRUST:  AXES ',3F7.3,'   VALUE  ',F7.4)
      GO TO 2235
C
C ------------ ***  DISPLAY TRACKS OF SINGLE JETS *** ---------
C
4000  RTS = RLG
      IF(LASTVW.EQ.1.OR.LASTVW.EQ.4.OR.LASTVW.EQ.8) RTS = RTOF
      VX = 0.
      VY = 0.
      VZ = 0.
      IJNRT = IJ(NJ1)
      DO 4001  IJK = 1,IJNRT
      IMOM = IPJ(IJK,NJ1)
      IF(HCOR(1,IMOM).EQ.0) GO TO 4010
C           CHARGED TRACKS
      IPO = HCOR(2,IMOM)
      ITR = HCOR(3,IMOM)
      ITYPLI = IDATA(IPO+29)
      INDEX = LASTVW
      IF(LASTVW.GT.3.AND.LASTVW.NE.14) GO TO 4002
C** DISPLAY TRACKS, RFI VIEWS
C                     PARABOLA FITS
      IF(IDATA(IPO+18).NE.1.AND.ITYPLI.EQ.1)
     $ CALL PARDIS(25,ADATA(IPO+19),ADATA(IPO+20),ADATA(IPO+21),
     $ ADATA(IPO+22),ADATA(IPO+5),ADATA(IPO+6),ADATA(IPO+12),
     $ ADATA(IPO+13),ADATA(IPO+31),ADATA(IPO+30),0.,0.)
C                     CIRCLE FITS
      IF(IDATA(IPO+18).EQ.1.AND.(ITYPLI.EQ.1.OR.ITYPLI.EQ.2))
     $ CALL CIRDIS(25,SIGN(ADATA(IPO+19),ADATA(IPO+25)),
     $ ADATA(IPO+20),ADATA(IPO+21),
     $ ADATA(IPO+5),ADATA(IPO+6),ADATA(IPO+12),ADATA(IPO+13),
     $ ADATA(IPO+31),ADATA(IPO+30),ITYPLI,0.,0.)
C** WRITE TRACK NUMBER
      CALL TRNUMB(ITR,0,ADATA(IPO+12),ADATA(IPO+13),ADATA(IPO+14))
      GO TO 4001
C** DISPLAY TRACKS, RZ VIEWS
4002  IF(ITYPLI.EQ.1) CALL LINDIS(IPO,INDEX,0.,0.,0.)
      GO TO 4001
4010  CONTINUE
C           NEUTRAL TRACKS
      IPO = HCOR(2,IMOM)
      IGAM = HCOR(3,IMOM)
C SKIP TRACK ASSOCIATED CLUSTERS
      IF(IGAM.EQ.-1) GO TO 4001
      JPART = IDATA(IPO+1)
      IF(JPART.NE.0) GO TO 4011
C****************************** BARREL PHOTONS *****
      PHI = ADATA(IPO+4)
      THE = ATAN2(ADATA(IPO+5)-VZ,RLG)
      THE = PIHALF - THE
      XP = RTS*COS(PHI)
      YP = RTS*SIN(PHI)
      IF(ABS(PIHALF-THE).LT..001) ZP = VZ
      IF(ABS(PIHALF-THE).GE..001) ZP = RTS/TAN(THE) + VZ
      VXP = VX
      VYP = VY
      VZP = VZ
      IF(LASTVW.NE.14) GO TO 4012
      FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
      FP1 = (ZDEEP - VZP)/(ZDEEP + ZLGPL)
      XP = FP*XP
      YP = FP*YP
      VXP = FP1*VXP
      VYP = FP1*VYP
      GO TO 4012
C****************************** ENDCAP PHOTONS *****
4011  XP = ADATA(IPO+4)
      YP = ADATA(IPO+5)
      RR = SQRT(XP*XP + YP*YP)
      ZZ = ZENDPL
      IF(JPART.LT.0) ZZ = ZENDMI
      ZZ = ZZ - VZ
      THE = ATAN2(RR,ZZ)
      PHI = ATAN2(YP,XP)
      IF(PHI.LT.0.) PHI = PHI + TWOPI
      ZP = ZENDPL
      IF(JPART.LT.0) ZP = ZENDMI
      VXP = VX
      VYP = VY
      VZP = VZ
      IF(LASTVW.NE.14) GO TO 4012
      FP = (ZDEEP - ZP)/(ZDEEP + ZLGPL)
      FP1 = (ZDEEP - VZP)/(ZDEEP + ZLGPL)
      XP = FP*XP
      YP = FP*YP
      VXP = FP1*VXP
      VYP = FP1*VYP
4012  CONTINUE
C * * * * * * * * *  DISPLAY PART
      IF(LASTVW.GT.3.AND.LASTVW.NE.14) GO TO 4013
      XX = XP
      YY = YP
      XX1 = VXP
      YY1 = VYP
      CALL TRNUMB(IGAM,0,XX,YY,DUM1)
      XX = - XX
      XX1 = - XX1
      GO TO 4014
4013  CONTINUE
      XX = ZP
      XX1 = VZP
      IF(DSPDTL(9)) GO TO 4015
      YY = XP
      YY1 = VXP
      IF(LASTVW.GT.7) YY = YP
      IF(LASTVW.GT.7) YY1 = VYP
      GO TO 4016
4015  YY = SQRT(XP*XP+YP*YP)
      YY1 = SQRT(VXP*VXP+VYP*VYP)
      IF(YP.LT.0..AND.LASTVW.GT.7) YY = - YY
      IF(XP.LT.0..AND.LASTVW.LT.8) YY = - YY
      IF(VYP.LT.0..AND.LASTVW.GT.7) YY1 = - YY1
      IF(VXP.LT.0..AND.LASTVW.LT.8) YY1 = - YY1
4016  CALL TRNUMB(IGAM,0,-XX,YY,DUM1)
4014  CALL MOVEA(XX1,YY1)
      CALL DASHA(XX,YY,14)
4001  CONTINUE
      GO TO 2235
C---------------------------------------------------------------------
C
C    PROCEDURE FOR AXIS DISPLAY
C
7000  CONTINUE
      SINTHE = SQRT(1.-AXD(3)*AXD(3))
      RTF1 = RTOF - 50.
      IF( LASTVW .EQ. 17 ) RTF1 = 5.5
      IF( LASTVW .EQ. 20 ) RTF1 = RITNK + 110.0
      XX1 = RTF1*AXD(1)
      YY1 = RTF1*AXD(2)
      ZZ1 = RTF1*AXD(3)
      RR1 = 0.
      IF(SINTHE.GT..00004) RR1 = SQRT(XX1**2 + YY1**2)
      IF( LASTVW .GT. 3   .AND.  LASTVW .NE. 14  .AND.
     &    LASTVW .NE. 17  .AND.  LASTVW .NE. 20 ) GO TO 7001
C RFI VIEWS
      XRV = 0.0
      YRV = 0.0
      IF( .NOT. FLVCDO(12) ) GO TO 6997
         CALL VTXCRV( XRV, YRV, DXR, DYR )
6997  CONTINUE
      DLX = XX1
      DLY = YY1
      XX1 = XRV + DLX
      YY1 = YRV + DLY
      XX2 = XRV - DLX
      YY2 = YRV - DLY
      IF( SINTHE .LE. 0.00004 ) GO TO 6998
         DLX = DLX/SINTHE
         DLY = DLY/SINTHE
         XX1 = XRV + DLX
         XX2 = XRV - DLX
         YY1 = YRV + DLY
         YY2 = YRV - DLY
6998  CONTINUE
      IF( LASTVW .NE. 14 ) GO TO 6999
C RFI CYLINDER VIEW
         XX1 = XX1*(ZDEEP - ZZ1)/ZETMX
         YY1 = YY1*(ZDEEP - ZZ1)/ZETMX
         XX2 = XX2*(ZDEEP - ZZ1)/ZETMX
         YY2 = YY2*(ZDEEP - ZZ1)/ZETMX
6999  CALL MOVEA( -XRV,  YRV )
      WARRO = 20.0
      IF( LASTVW .EQ. 17 ) WARRO = 0.2
      IF( LASTVW .EQ. 20 ) WARRO = 10.0
      CALL DASHA( -XX1, YY1, 78 )
      CALL MOVEA( -XRV,  YRV )
      CALL DASHA( -XX1, YY1, 18 )
      PHIAR = ATAN2(DLY,-DLX)
      CALL ARROW( WARRO, -XX1, YY1,  PHIAR )
      IF(IRETUR.NE.1.AND.IRETUR.NE.3) GO TO 2237
      CALL MOVEA( -XRV,  YRV )
      CALL DASHA( -XX2, YY2, 78 )
      CALL MOVEA( -XRV,  YRV )
      CALL DASHA( -XX2, YY2, 18 )
      PHIAR = ATAN2(-DLY,DLX)
      CALL ARROW( WARRO, -XX2, YY2,  PHIAR )
      GO TO 2237
C ZX AND ZY VIEWS
7001  IF(LASTVW.GT.11) GO TO 2235
      IF(DSPDTL(9)) GO TO 7002
C TRUE PROJECTIONS
      XXX1 = ZZ1
      YYY1 = XX1
      IF(LASTVW.GT.7) YYY1 = YY1
      GO TO 7003
C ROTATED PROJECTIONS
7002  XXX1 = ZZ1
      YYY1 = RR1
      IF(LASTVW.GT.7.AND.YY1.LT.0.) YYY1 = -RR1
      IF(LASTVW.LT.8.AND.XX1.LT.0.) YYY1 = -RR1
7003  CALL MOVEA(0.,0.)
      CALL DASHA(XXX1,YYY1,78)
      CALL MOVEA(0.,0.)
      CALL DASHA(XXX1,YYY1,18)
      CALL ARROW(20.,XXX1,YYY1,-1000.0)
      IF(IRETUR.NE.1.AND.IRETUR.NE.3) GO TO 2237
      CALL MOVEA(0.,0.)
      CALL DASHA(-XXX1,-YYY1,78)
      CALL MOVEA(0.,0.)
      CALL DASHA(-XXX1,-YYY1,18)
      CALL ARROW(20.,-XXX1,-YYY1,-1000.0)
2237  CONTINUE
      GO TO (2235,2003,3001),IRETUR
2531  CALL TRMOUT(80,' WRONG INPUT...^')
2235  RETURN
      END
      SUBROUTINE ARROW(R,ADX,ADY,PHIAR)
      COMMON /CJTRIG/ PI,TWOPI
C     DRAW TRIANGLE
      DEFI = TWOPI/3.
      OFFSET = PHIAR
      IF( PHIAR .EQ. -1000.0 ) OFFSET = ATAN2(ADY,ADX)
      IF(OFFSET.LT.0.) OFFSET = OFFSET + TWOPI
      FISX = OFFSET
      CALL MOVEA(ADX+R*COS(OFFSET),ADY+R*SIN(OFFSET))
      DO 27 IIK = 1,3
      FISX = FISX + DEFI
 27   CALL DRAWA(ADX+R*COS(FISX),ADY+R*SIN(FISX))
      RETURN
      END
      SUBROUTINE SPHERC
C *---------------------------------------------------------
C *  VERSION OF SPHRCY, MODIFIED FOR GRAPHICS USE 21.07.79
C *                                  LAST CHANGE  21.07.79  (J.OLSSON)
C *  VERSION OF 23/02/79
C *  COMPUTE SPHERICITY FOR A SET OF MOMENTA
C *  P IS ARRAY OF MOMENTA P(1..4,1..NMOM), WHERE P(1..3)=PX,PY,PZ
C *  AND P(4)=PTOT
C *  SPHITY IS ARRAY OF NORMALIZED SPHERICITIES
C *  AXIS CONTAINS THE THREE EIGENVECTORS
C *  AXIS(1..3)  EIGENVECTOR WITH SMALLEST EIGENVALUE
C *  AXIS(4..6)  EIGENVECTOR
C *  AXIS(7..9)  EIGENVECTOR WITH BIGGEST EIGENVALUE
C *---------------------------------------------------------
C
      COMMON /CWORK1/ NMOM,P(4,100),T(6),R(9),AXIS(9),SPHITY(3)
C
C  LOAD MOMENTUM TENSOR
C
       DO 10 I=1,6
   10  T(I)=0.
       DO 20 J=1,NMOM
       T(1) = T(1) + P(2,J)*P(2,J) + P(3,J)*P(3,J)
       T(2) = T(2) - P(1,J)*P(2,J)
       T(3) = T(3) + P(1,J)*P(1,J) + P(3,J)*P(3,J)
       T(4) = T(4) - P(1,J)*P(3,J)
       T(5) = T(5) - P(2,J)*P(3,J)
   20  T(6) = T(6) + P(1,J)*P(1,J) + P(2,J)*P(2,J)
CCCCCCCCC
C   DIAGONALIZE MOMENTUM TENSOR T
C
       CALL EIGEN( T, R, 3, 0 )
C
C      LOAD SPHERICITY AND JET AXIS
C
       SUM = T(1) + T(3) + T(6)
       SPHITY(1) = 3.* T(6) / SUM
       SPHITY(2) = 3.* T(3) / SUM
       SPHITY(3) = 3.* T(1) / SUM
       DO 30 I=1,3
   30  AXIS(I) = R(I+6)
       DO 40 I=4,6
   40  AXIS(I)= R(I)
       DO 50 I=7,9
   50  AXIS(I)= R(I-6)
      RETURN
      END

C   25/07/77 912210852  MEMBER NAME  SORT     (S)           FORTRAN
      SUBROUTINE SORT(VARMIN,VARBLE,ARRAY,BINSIZ,JMAX,K)
C---  SORT REAL VARIABLES INTO 1-DIM DISTRIBUTIONS
C     (FOR VARIABLE SORTING, I.E. ADDING, OR SUBTRACTING, OR VARIING OF
C      INCREMENT USE 'VSORT')
C
C     H.WRIEDT   02.02.79     18:00
C     LAST MODIFICATION    21.12.79     08:55
C
C     ORIGINALLY WRITTEN BY J.GAYLER NAMED 'VERTEI'
C
C     VARBLE: INPUT VARIABLE
C     ARRAY:  OUTPUT ARRAY
C     ARRAY(101): UNDERFLOWS
C     ARRAY(102): OVERFLOWS
C     JMAX = (VARMAX - VARMIN) / BINSIZ
C     K = NO. OF COLUMNS / BIN
C
      DIMENSION ARRAY(102)
      J = ((VARBLE - VARMIN) / BINSIZ) + 1.
      IF (J*K.GT.JMAX) J = JMAX+2
      IF (J.LT.1) J = JMAX+1
      IF (K.NE.1.AND.J.LE.JMAX) GOTO 2
      ARRAY(J) = ARRAY(J) + 1
      RETURN
 2    DO 1 L = 1,K
      M = J*K - L + 1
 1    ARRAY(M) = ARRAY(M) + 1
      RETURN
      END

C   07/06/96 606071859  MEMBER NAME  PALL     (S4)          FORTG1
      SUBROUTINE PALL
      CALL PCOND
      CALL PSTOR(0)
      CALL PTABL(0)
      CALL PHIST(0)
      CALL PCORR(0)
      RETURN
      END

      SUBROUTINE FITEVR( NTRVTX, MODE )
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "calibr.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(HPZR0 ,HPWRK(20)),(HPZR9 ,HPWRK(21)),(HLDZR ,HPWRK(22))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
        DATA LBINIT /0/
        DATA NPRMES /0/
      IF(
     - LBINIT .LE.0
     -)THEN
          LBINIT = 1
          IQHEAD = IBLN('HEAD')
          IQPATR = IBLN('PATR')
          IQJHTL = IBLN('JHTL')
          IQZVTX = IBLN('ZVTX')
      ENDIF
        NITER = 0
16000 CONTINUE
        NITER = NITER + 1
          NTRVTX = 0
          IF(IDATA(IQPATR).LE.0) RETURN
      IF(
     - LAND(MODE,1) .NE. 0
     -)THEN
            IPPAT0 = IDATA(IQPATR)
            NBNK1  = IDATA(IPPAT0-2) - 1
            NWRD   = IDATA(IPPAT0)
            NBYTE  = NWRD*4
            CALL CCRE(IPPATR,'PATR',NBNK1,NWRD,IERR)
      IF(
     - IERR.NE.0
     -)THEN
              PRINT 2900, IERR
 2900   FORMAT(' USFITO3(PS): CREATION OF NEW PATR-BANK RESULTED',
     ,         ' IN ERROR',I3)
              INDEX = 1
              RETURN
      ENDIF
            CALL MVCL(IDATA(IPPATR+1),0,IDATA(IPPAT0+1),0,NBYTE)
      ENDIF
          IPPATR = IDATA(IQPATR)
          IPTR1  = IDATA(IPPATR+1) + IPPATR
          LDTR   = IDATA(IPPATR+3)
          NTR    = IDATA(IPPATR+2)
          IF(NTR.LT.1) RETURN
          MTRV = 0
          IPV  = ICALIB(10)
          X0   = ACALIB(IPV+ 1)
          Y0   = ACALIB(IPV+ 3)
      DO 13000 ITR=1,NTR
      IF(
     - ABS(ADATA(IPTR1+25)).LT..00143 .AND.IDATA(IPTR1+24).GT.16
     -)THEN
              CALL DRTRCK(IPTR1,X0,Y0,DR0)
      IF(
     - ABS(DR0).LT.25. .OR. IDATA(IPTR1+4).EQ.1
     -)THEN
                MTRV = MTRV + 1
                IDATA(IPTR1+4) =-1
      ENDIF
      ENDIF
          IPTR1 = IPTR1 + LDTR
13000 CONTINUE
13001 CONTINUE
      IF(
     - MTRV.LE.0
     -)THEN
      GOTO 16001
      ENDIF
            Z0 = 0.
            IPZVTX = IDATA(IQZVTX)
            IF(IPZVTX.GT.0.AND.IDATA(IPZVTX+6).EQ.3) Z0=ADATA(IPZVTX+1)
            ERRFAC = 1.0
            IF(LAND(MODE,4)  .NE. 0) ERRFAC =  100.0
            IF(LAND(MODE,16) .NE. 0) ERRFAC = 1000.0
            MODEF = MODE
            CALL FZFITV(IPPATR,IDATA(IQJHTL),NTRVTX,Z0,ERRFAC,MODEF)
      IF(
     - MODEF .GE.0
     -)THEN
      GOTO 16001
      ENDIF
            IPHEAD = IDATA(IQHEAD) * 2
            NPRMES = NPRMES + 1
            IF(NPRMES.LE.10)
     ,      PRINT 2009, HDATA(IPHEAD+10),HDATA(IPHEAD+11),MODEF
 2009 FORMAT(' FITEVR(PST): ERROR IN JHTL-BANK FOR EVENT',3I6)
      IF(
     - LAND(MODE,8).EQ.0
     -)THEN
      GOTO 16001
      ENDIF
      IF(
     - NITER .GE.2
     -)THEN
      GOTO 16001
      ENDIF
      IF(
     - LAND(MODE,1).NE.0
     -)THEN
              IPPATR = IDATA(IQPATR)
              NBNK   = IDATA(IPPATR-2)
              CALL BDLS('PATR',NBNK)
      ENDIF
            IPPATR = IDATA(IQPATR)
            NBNK   = IDATA(IPPATR-2)
            CALL BDLS('PATR',NBNK)
            IPJHTL = IDATA(IQPATR)
            CALL BDLS('JHTL',NBNK)
            IND = 1
            CALL PATRCO(IND)
      IF(.NOT.(
     - NITER .GE.2
     -))GOTO 16000
16001 CONTINUE
      RETURN
      END

C   17/05/88 805171203  MEMBER NAME  SPHRCY   (S)           FORTRAN77
      SUBROUTINE zSPHRCY( P, NMOM, SPHITY , AXIS ) ! PMF 11/04/00 SPHRCY->zSPHRCY
C *---------------------------------------------------------
C *
C *  VERSION OF 23/02/79
C *  COMPUTE SPHERICITY FOR A SET OF MOMENTA
C *  P IS ARRAY OF MOMENTA P(1..4,1..NMOM), WHERE P(1..3)=PX,PY,PZ
C *  AND P(4)=PTOT
C *  SPHITY IS ARRAY OF NORMALIZED SPHERICITIES
C *  AXIS CONTAINS THE THREE EIGENVECTORS
C *  AXIS(1..3)  EIGENVECTOR WITH SMALLEST EIGENVALUE
C *  AXIS(4..6)  EIGENVECTOR
C *  AXIS(7..9)  EIGENVECTOR WITH BIGGEST EIGENVALUE
C *---------------------------------------------------------
C
      DIMENSION P(4,NMOM),T(6),R(9),AXIS(9), SPHITY(3)
C     DIMENSION A(6)
C
C  LOAD MOMENTUM TENSOR
C
       DO 10 I=1,6
   10  T(I)=0.
       DO 20 J=1,NMOM
       T(1) = T(1) + P(2,J)*P(2,J) + P(3,J)*P(3,J)
       T(2) = T(2) - P(1,J)*P(2,J)
       T(3) = T(3) + P(1,J)*P(1,J) + P(3,J)*P(3,J)
       T(4) = T(4) - P(1,J)*P(3,J)
       T(5) = T(5) - P(2,J)*P(3,J)
   20  T(6) = T(6) + P(1,J)*P(1,J) + P(2,J)*P(2,J)
CCCCCCCCC
C   DIAGONALIZE MOMENTUM TENSOR T
C
       CALL EIGEN( T, R, 3, 0 )
C
C      LOAD SPHERICTY AND JET AXIS
C
       SUM = T(1) + T(3) + T(6)
       SPHITY(1) = 3.* T(6) / SUM
       SPHITY(2) = 3.* T(3) / SUM
       SPHITY(3) = 3.* T(1) / SUM
       DO 30 I=1,3
   30  AXIS(I) = R(I+6)
       DO 40 I=4,6
   40  AXIS(I)= R(I)
       DO 50 I=7,9
   50  AXIS(I)= R(I-6)
      RETURN
      END

C   13/03/84 406221947  MEMBER NAME  FITAG    (S)           FORTRAN
C   11/03/84 403110517  MEMBER NAME  FI       (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C FIND THE VALUE OF FI (PHI ?) OF ADC WITH SOFTWARE ADDRESS I
C    TAN FI = Y/X
C
      FUNCTION FITAG(I)
C
C NEW VERSION 13/3/84
C A.J.FINCH
C
C RENAMED TO FITAG 20/3/84
C A.J.FINCH
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      DATA PIBY4 / 0.785398163 /
      DATA PIBY8 / 0.392699081 /
      ISAVE = I
C
C
      IF ( (I .GE.  1) .AND. (I .LE.  6) ) J = I + 2
      IF ( (I .GE.  7) .AND. (I .LE.  8) ) J = I - 6
      IF ( (I .GE.  9) .AND. (I .LE. 14) ) J = I + 2 -  8
      IF ( (I .GE. 15) .AND. (I .LE. 16) ) J = I - 6 -  8
      IF ( (I .GE. 17) .AND. (I .LE. 22) ) J = I + 2 - 16
      IF ( (I .GE. 23) .AND. (I .LE. 24) ) J = I - 6 - 16
      IF ( (I .GE. 25) .AND. (I .LE. 26) ) J = I + 6 - 24
      IF ( (I .GE. 27) .AND. (I .LE. 32) ) J = I - 2 - 24
      IF ( (I .GE. 33) .AND. (I .LE. 34) ) J = I + 6 -  8 - 24
      IF ( (I .GE. 35) .AND. (I .LE. 40) ) J = I - 2 -  8 - 24
      IF ( (I .GE. 41) .AND. (I .LE. 42) ) J = I + 6 - 16 - 24
      IF ( (I .GE. 43) .AND. (I .LE. 48) ) J = I - 2 - 16 - 24
C

      FITAG = (J * PIBY4) - PIBY8
      I = ISAVE
      RETURN
      END

C   19/02/84 409060934  MEMBER NAME  BANKPR5  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BANKPR
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL     ?     :  PRINT BOS BANK NAMES OR CONTENTS.
C
C        MOD: J. OLSSON   15/11/83 :
C        MOD: C. BOWDERY  14/02/84 :  RESOLVE PROBLEM WITH DELETED BANKS
C   LAST MOD: C. BOWDERY  14/02/84 :  NAMES PRINTED BY S/R EVBKPR
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8 DATE,TIME
C
#include "cgraph.for"
#include "cdata.for"
C
      COMMON / CWORK  / HDUM(8000),
     +                  HADC(2,42),HTDC(2,42),HTDC1(2,42),HADCF(2,16),
     +                  HTDCF(2,16),HTSPAR(16)
      COMMON / CWORK1 / HWORK(70),DATE,TIME
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION HDSPL(68),HSYM(10),HDATSV(22),HTX(6),HTM1(4),HTM2(4)
      DIMENSION NAMES(20),HSX(13,16),HELP(2)
      DIMENSION HSY(13,16)
C
      EQUIVALENCE (IZWORD,HELP(1))
      EQUIVALENCE (HWORK(1),NAME)
      EQUIVALENCE (HWORK(3),HDSPL(1))
      EQUIVALENCE (HDATSV(1),IDATSV(1)),(DATE,HTM1(1)),(TIME,HTM2(1))
C
      DATA NAMES/'JETC','PATR','TAGC','JHTL','ZETC','GVTX','DEDX',
     $ 'ZVTX','LGCL','TOFR','TPEV','TPTR','ATOF','TPVX','VECT','TRIG',
     $ 'N50S','MPRS','BK17','ZTRG'/
C
      DATA HSYM /'0 ','1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 '/
      DATA HBLANK/'  '/,HMINUS/'- '/, NNAMES /20/,MASKMH/Z001F/
      DATA HTX /'DS','N ','DA','TE','TI','ME'/
C
      DATA HSX/
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'*M','UL','TI','HA','DR','ON','IC',' E','VE','NT','**','  ','  ',
     $'*N','ON','-B','AR','RE','L ','BH','AB','HA',' E','VE','NT','**',
     $'*B','AR','RE','L ','BH','AB','HA',' E','VE','NT','**','  ','  ',
     $'*2','-P','HO','TO','N ','EV','EN','T*','* ','  ','  ','  ','  ',
     $'*M','UO','N-','PA','IR',' E','VE','NT','**','  ','  ','  ','  ',
     $'*B','EA','M-','BE','AM',' E','VE','NT','**','  ','  ','  ','  ',
     $'*C','OS','MI','C ','EV','EN','T*','* ','  ','  ','  ','  ','  ',
     $'*B','EA','M-','GA','S ','EV','EN','T*','* ','  ','  ','  ','  ',
     $'*H','AL','O ','EV','EN','T*','* ','  ','  ','  ','  ','  ','  ',
     $'*L','UM','I ','EV','EN','T*','* ','  ','  ','  ','  ','  ','  ',
     $'*U','NI','DE','NT','IF','IE','D ','EV','EN','T*','* ','  ','  ',
     $'*R','EJ','EC','TE','D ','EV','EN','T*','* ','  ','  ','  ','  '/
C
      DATA HSY/
     $'UN','EX','PE','CT','ED',' I','NT','ER','RU','PT',' N','-3','  ',
     $'UN','EX','PE','CT','ED',' I','NT','ER','RU','PT',' N','-2','  ',
     $'NO','N ','IN','CR','EA','SI','NG',' W','IR','E-','NU','MB','ER',
     $'IL','LE','GA','L ','HI','T ','CO','UN','TE','R ','  ','  ','  ',
     $'NE','GA','TI','VE',' D','AT','A ','FO','UN','D ','  ','  ','  ',
     $'JE','TC',' B','AN','K ','LO','NG','ER',' T','HA','N ','40','00',
     $'WI','RE',' N','UM','BE','R ','GR','EA','TE','R ','15','36','  ',
     $'NO',' H','IT','S ','IN',' R','IN','G2','  ','  ','  ','  ','  ',
     $'LA','ST',' C','EL','L ','IN',' R','IN','G ','IN','CO','MP','L.',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'T2','  ','RE','JE','CT','  ','  ','  ','  ','  ','  ','  ','  ',
     $'Z-','VE','RT','EX',' R','EJ','EC','T ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'AC','TU','AL','LY',' R','EJ','EC','TE','D ','BY',' N','10','  '/
C
C------------------  C O D E  ------------------------------------------
C
      NN = ACMD
      IF( NN .GE. 0 ) GO TO 1803
C
C                            NEGATIVE INDEX --> PRINT BOS BANK NAMES
C
      CALL EVBKPR(ICODE)
      IF( ICODE .EQ. 0 ) RETURN
      CALL TRMOUT(80,'ERROR IN BMRT (CURRENT LIST), CALLED IN BANKPR^')
      RETURN
C
1803  CALL TRMOUT(80,' * * PLEASE ENTER NAME OF DESIRED BANK.^')
      CALL TRMIN(4,NAMEB)
      IBANK=IBLN(NAMEB)
      IPBANK=IDATA(IBANK)
200   LIM1=IPBANK-2
210   IF(LIM1.GE.1) GO TO 3
35    CALL TRMOUT(80,'THE BANK IS EMPTY OR DOES NOT EXIST.^')
      RETURN
C** CHECK IF MORE THAN ONE BANK WITH SAME NAME; IF SO, REQUEST NUMBER.
3     IF(IDATA(LIM1+1).EQ.0) GO TO 300
      IF(NAMEB.EQ.NAMES(15)) GO TO 300
      CALL TRMOUT(80,'FOLLOWING BOS BANK NRS ARE PRESENT:^')
      LM1 = LIM1
3332  CALL DIAGIN('                    ',1,IDATA(LM1),N,N,N,N,N)
      IF(IDATA(LM1+1).EQ.0) GO TO 3333
      LM1 = IDATA(LM1+1)-2
      GO TO 3332
3333  CALL TRMOUT(80,'PLEASE ENTER DESIRED BOS BANK NUMBER.^')
      NBOS = TERNUM(DUMMY)
33    IF(NBOS.EQ.IDATA(LIM1)) GO TO 300
      IF(IDATA(LIM1+1).NE.0) GO TO 34
      GO TO 35
34    LIM1 = IDATA(LIM1+1) - 2
      GO TO 33
300   CALL ERASE
      IRETUR = 1
C********************** WRITE CAPTION
      CALL HOME
      CALL CHRSIZ(4)
      HWORK(1) = HTX(1)
      HWORK(2) = HTX(2)
      HWORK(3) = HBLANK
      DO 4988  I = 1,22
4988  HWORK(I+3) = HDATSV(I)
      CALL EOUTST(50,HWORK)
      KCNT=0
      IHEAD=IBLN('HEAD')
      IPHEAD=IDATA(IHEAD)
      IHHEAD=2*IPHEAD
      DO 5001 III=1,3
      IF(III.EQ.1) NUMCAP=HDATA(IHHEAD+10)
      IF(III.EQ.2) NUMCAP=HDATA(IHHEAD+11)
      IF(III.EQ.3) NUMCAP=ICREC
      IF(NUMCAP.LT.0) KCNT=KCNT+1
      IF(NUMCAP.LT.0) HWORK(KCNT)=HMINUS
      NUMCAP=IABS(NUMCAP)
      NDIG=1
      ACAP=NUMCAP
      IF(NUMCAP.GT.0) NDIG=1+ALOG10(ACAP+0.001)
      IF(NDIG.GT.8) NDIG=8
      DO 5002 JJJ=1,NDIG
      KKK=KCNT+NDIG-JJJ+1
      NTEN=NUMCAP/10
      IDIG=NUMCAP-10*NTEN
      HWORK(KKK)=HSYM(IDIG+1)
      NUMCAP=NTEN
 5002 CONTINUE
      KCNT=KCNT+NDIG
      IF(III.LT.3) KCNT=KCNT+1
      IF(III.LT.3) HWORK(KCNT)=HBLANK
 5001 CONTINUE
      KCNT = 2*KCNT
      CALL NEWLIN
      CALL EOUTST(KCNT,HWORK)
5118  CONTINUE
C WRITE DATE AND TIME
      CALL DAY(DATE,TIME)
      HWORK(1) = HTX(3)
      HWORK(2) = HTX(4)
      HWORK(3) = HBLANK
      DO 4987  I = 1,4
4987  HWORK(I+3) = HTM1(I)
      CALL NEWLIN
      CALL EOUTST(14,HWORK)
      HWORK(1) = HTX(5)
      HWORK(2) = HTX(6)
      HWORK(3) = HBLANK
      DO 4986  I = 1,4
4986  HWORK(I+3) = HTM2(I)
      CALL NEWLIN
      CALL EOUTST(14,HWORK)
      CALL NEWLIN
      CALL CHRSIZ(3)
      CALL NEWLIN
C****************************** WRITE BANK HEADER
      LIM2=LIM1+3
      LIMX = LIM2-1
      LIMHX = 2*LIMX
      NAME=IDATA(LIM1-1)
      CALL CORE(HDSPL,76)
      WRITE(10,9001) (IDATA(LHO),LHO=LIM1,LIMX),(HDATA(LIMHX+J),J=1,2)
 9001 FORMAT(3I10,2I10)
      CALL EOUTST(80,HWORK)
      CALL NEWLIN
C     CALL PROMPT
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
      CALL CHRSIZ(4)
      CALL CSIZE(IX,IXT)
      SIZE = IXT*.8
      DEL = 1.7*SIZE
C****************************** WRITE BANK CONTENT
      NWO = IDATA(LIM2-1) - 1
      LENGB=2*NWO
      NCYCLE=1+(LENGB-1)/20
      INNAM = 0
      DO 1473  INN = 1,NNAMES
      IF(NAMEB.NE.NAMES(INN)) GO TO 1473
      INNAM = INN
      GO TO 1474
1473  CONTINUE
      GO TO 1092
1474  GO TO (2001,877,1092,1092,5177,1277,1377,1577,1677,1977,2077,2177,
     $ 3177,4177,277,1092,3235,1940,2240,2550), INNAM
C-------------- NORMAL PRINT OF BANKS, INTEGER*2 OR Z4 FORMAT
1092  CONTINUE
      DO 9010 LHO=1,NCYCLE
9006  YS = YS - DEL
      IF(YS.GT.50.) GO TO 9012
      IRETUR = 4
      GO TO 9965
9012  LIML=2*LIM2+20*(LHO-1)+1
      LIMU = LIML + 19
      IF(LIMU.GT.(2*LIM2+LENGB)) LIMU=2*LIM2+LENGB
      ILIM = LIMU - LIML + 1
      IF(ILIM.LE.0) GO TO 9020
      DO 9025  I = 1,ILIM
      LLO = LIML + I - 1
9025  HWORK(I+100) = HDATA(LLO)
      IILIM = 6*ILIM + 1
      CALL CORE(HWORK,IILIM)
      IF(NAMEB.NE.NAMES(3).AND.NAMEB.NE.NAMES(4).AND.NAMEB.NE.NAMES(16))
     $ WRITE(JUSCRN,9011) (HWORK(LLO+100),LLO=1,ILIM)
      IF(NAMEB.EQ.NAMES(3).OR.NAMEB.EQ.NAMES(4).OR.NAMEB.EQ.NAMES(16))
     $ WRITE(JUSCRN,9111) (HWORK(LLO+100),LLO=1,ILIM)
 9011 FORMAT(' ',20I6)
 9111 FORMAT(' ',20(Z4,2X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 9010 CONTINUE
      GO TO 9020
C____________________________ SPECIAL FORMAT FOR JETC BANK
2001  LENGB = LENGB + 2
      NCYCLE=1+(LENGB-1)/20
      LENGB = LENGB - 2
      DO 8010 LHO=1,NCYCLE
8006  YS = YS - DEL
      IF(YS.GT.50.) GO TO 8012
      IRETUR = 5
      GO TO 9965
8012  LIML=2*LIM2+20*(LHO-1)+1
      IF(LHO.GT.5) LIML = LIML - 2
      LIMU = LIML + 19
      IF(LHO.EQ.5) LIMU = LIMU - 2
      IF(LIMU.GT.(2*LIM2+LENGB)) LIMU=2*LIM2+LENGB
      ILIM = LIMU - LIML + 1
      IF(ILIM.LE.0) GO TO 9020
      DO 8025  I = 1,ILIM
      LLO = LIML + I - 1
8025  HWORK(I+100) = HDATA(LLO)
      IF(LHO.LE.5) GO TO 8026
      DO 8027  I = 1,ILIM,4
      IX = HWORK(I+100)
      IX = SHFTR(IX,3)
8027  HWORK(I+100) = IX
8026  IILIM = 6*ILIM + 1
      CALL CORE(HWORK,IILIM)
      WRITE(JUSCRN,9011) (HWORK(LLO+100),LLO=1,ILIM)
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 8010 CONTINUE
      GO TO 9020
C--------------- SPECIAL FORMAT FOR ATOF BANK
3177  IPTOF = LIM2-1
      CALL AGRPR(IPTOF,&3173)
      GO TO 3174
3173  WRITE(6,3175)
3175  FORMAT(' ATFUGR ERROR, WRONG BANK DESCRIPTOR...' )
      RETURN
3174  CALL CORE(HWORK,107)
      WRITE(JUSCRN,3181)
3181  FORMAT(' NR   ADC(L)  ADC(R)   TDC(L)  TDC(R)   TDC1(L)  TDC1(R)
     $ ADCF(L)  ADCF(R)   TDCF(L)  TDCF(R)   TDC(SPARE)')
      CALL SYSSYM(XS,YS,SIZE,HWORK,107,0.)
      YS = YS - .9*DEL
      DO 3178  I = 1,42
      IF(I.GT.16) GO TO 3179
      CALL CORE(HWORK,106)
      WRITE(JUSCRN,3185) I,(HADC(J,I),J=1,2),(HTDC(J,I),J=1,2),
     $(HTDC1(J,I),J=1,2),(HADCF(J,I),J=1,2),(HTDCF(J,I),J=1,2),HTSPAR(I)
3185  FORMAT(' ',I2,2X,I6,2X,I6,3X,I6,2X,I6,3(3X,I7,2X,I7),3X,I10)
      CALL SYSSYM(XS,YS,SIZE,HWORK,106,0.)
      GO TO 3186
3179  CALL CORE(HWORK,55)
      WRITE(JUSCRN,3187) I,(HADC(J,I),J=1,2),(HTDC(J,I),J=1,2),
     $ (HTDC1(J,I),J=1,2)
3187  FORMAT(' ',I2,2X,I6,2X,I6,3X,I6,2X,I6,3X,I7,2X,I7)
      CALL SYSSYM(XS,YS,SIZE,HWORK,55,0.)
3186  YS = YS - .9*DEL
      IF(MOD(I,10).EQ.0) YS = YS -.2*DEL
3178  CONTINUE
      GO TO 9020
C--------------- SPECIAL FORMAT FOR VECT BANK
C-  FIRST VECT 0, THEN VECT 1 IF IT EXISTS
C-
277   IVPS = 0
      LIM2 = LIM2 - 1
2782  LO = IDATA(LIM2+1)
      LTR = IDATA(LIM2+2)
      NTR = IDATA(LIM2+4)
      IPO = LIM2 + LO
      CALL CORE(HWORK,106)
      WRITE(JUSCRN,278) (IDATA(LIM2+II),II=1,LO)
278   FORMAT('  ',6I8,2F8.4,5I8)
      LOO = LO*8+2
      CALL SYSSYM(XS,YS,SIZE,HWORK,LOO,0.)
      LO1 = MIN0(12,LO)
      IF(LO1.LT.7) GO TO 2791
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(JUSCRN,178) (ADATA(LIM2+II),II=7,LO1)
178   FORMAT(' HEADER WORDS 7-.. ',6E14.6)
      LOO = (LO1-6)*14+19
      CALL SYSSYM(XS,YS,SIZE,HWORK,LOO,0.)
2791  ICNT = 0
279   ICNT = ICNT + 1
      IF(ICNT.GT.NTR.AND.IVPS.EQ.1) GO TO 9020
      IF(ICNT.GT.NTR.AND.IVPS.EQ.0) GO TO 2781
275   YS = YS - DEL
      IF(YS.GT.50.) GO TO 276
      IRETUR = 3
      GO TO 9965
276   IPP = IPO + (ICNT-1)*LTR
      IF(LTR.EQ.10) CALL CORE(HWORK,95)
      IF(LTR.EQ.12) CALL CORE(HWORK,115)
      IF(LTR.EQ.10)
     1  WRITE(JUSCRN,274) (ADATA(IPP+I),I=1,5),(IDATA(IPP+I),I=6,7),
     2 (ADATA(IPP+I),I=8,10)
274   FORMAT(' ',4F10.4,2X,F10.6,2X,2I4,2X,3F10.3)
      IF(LTR.EQ.12)
     1  WRITE(JUSCRN,284) (ADATA(IPP+I),I=1,5),(IDATA(IPP+I),I=6,7),
     2 (ADATA(IPP+I),I=8,10),HDATA(2*IPP+21),HDATA(2*IPP+22),
     3  ADATA(IPP+12)
284   FORMAT(' ',4F10.4,2X,F10.6,2X,2I4,2X,3F10.3,2I5,F10.2)
      IF(LTR.EQ.10) CALL SYSSYM(XS,YS,SIZE,HWORK,95,0.)
      IF(LTR.EQ.12) CALL SYSSYM(XS,YS,SIZE,HWORK,115,0.)
      GO TO 279
2781  CONTINUE
      LIM2 = IDATA(LIM2-1)
      IF(LIM2.LT.1) GO TO 9020
      IVPS = 1
C* WRITE BANK HEADER FOR VECT 1
      CALL NEWLIN
      CALL NEWLIN
      LIM1=LIM2-2
      LIMX = LIM2
      LIMHX = 2*LIMX
      NAME=IDATA(LIM2-3)
      CALL CORE(HDSPL,76)
      WRITE(10,9001) (IDATA(LHO),LHO=LIM1,LIMX),(HDATA(LIMHX+J),J=1,2)
      CALL EOUTST(80,HWORK)
      CALL NEWLIN
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
      CALL CHRSIZ(4)
      CALL CSIZE(IX,IXT)
      GO TO 2782
C--------------- SPECIAL FORMAT FOR TPVX BANK
4177  LIM2 = LIM2 - 1
      LIMLIM = 2*LIM2
      CALL CORE(HWORK,13)
      WRITE(JUSCRN,4178) HDATA(LIMLIM+1),HDATA(LIMLIM+2)
4178  FORMAT(' ',I4,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,13,0.)
      YS = YS - DEL
      CALL CORE(HWORK,108)
      WRITE(JUSCRN,4179) (ADATA(LIM2+1+I),I=1,7),IDATA(LIM2+9),
     1 ADATA(LIM2+10)
4179  FORMAT(' ',3E12.4,2X,3E12.4,2X,E12.4,I4,3X,E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,108,0.)
      YS = YS - DEL
      CALL CORE(HWORK,51)
      WRITE(JUSCRN,4175) (HDATA(LIMLIM+20+I),I=1,10)
4175  FORMAT(' ',10I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,51,0.)
      MULSEC = HDATA(LIMLIM+22)
      IF(MULSEC.LE.0) GO TO 9020
      IVX = 30
4171  IVX1 = 20
      IF(MULSEC+30.LT.IVX+IVX1) IVX1 = MULSEC+30-IVX
      YS = YS - DEL
      CALL CORE(HWORK,101)
      WRITE(JUSCRN,4174) (HDATA(LIMLIM+IVX+I),I=1,IVX1)
4174  FORMAT(' ',20I5)
      LIMLO = IVX1*5 + 1
      CALL SYSSYM(XS,YS,SIZE,HWORK,LIMLO,0.)
      IVX = IVX + 20
      IF(IVX.GT.30+MULSEC) GO TO 9020
      GO TO 4171
C--------------- SPECIAL FORMAT FOR PATR BANKS
877   LIM2 = LIM2 - 1
      LO = IDATA(LIM2+1)
      NTR = IDATA(LIM2+2)
      LTR = IDATA(LIM2+3)
      IPO = LIM2 + LO
      CALL CORE(HWORK,72)
      WRITE(JUSCRN,878) (IDATA(LIM2+II),II=1,LO)
878   FORMAT('  ',3I5,2X,Z8,3I5,2X,Z8,4I5)
      LO = LO*5+12
      CALL SYSSYM(XS,YS,SIZE,HWORK,LO,0.)
      IF(NTR.GT.100) RETURN
      ICNT = 0
879   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 9020
875   YS = YS - DEL
      IF(YS.GT.50.) GO TO 876
      IRETUR = 2
      GO TO 9965
876   IPP = IPO + (ICNT-1)*LTR
      CALL CORE(HWORK,123)
      WRITE(JUSCRN,679) IDATA(IPP+1),(HDATA(IPP*2+I),I=3,4),
     $ (IDATA(IPP+I),I=3,4),(ADATA(IPP+I),I=5,10),
     1                  IDATA(IPP+11),(ADATA(IPP+I),I=12,17)
679   FORMAT(' ',I2,1X,2(Z2,2X),I5,I3,2X,2F8.3,F10.3,3F7.3,2X,I3,2X,
     1 2F8.3,F10.3,3F7.3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,123,0.)
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(JUSCRN,873) IDATA(IPP+18),(ADATA(IPP+I),I=19,23),
     1                  IDATA(IPP+24),(ADATA(IPP+I),I=25,28),
     2                  IDATA(IPP+29),(ADATA(IPP+I),I=30,32),
     3                  IDATA(IPP+33)
873   FORMAT(' ',I2,1X,F10.6,2F8.3,F10.6,F8.3,I3,1X,4F10.6,I2,1X,F10.2,
     1 2F8.2,I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(JUSCRN,872) (IDATA(IPP+I),I=34,48),HDATA(1+2*(IPP+1)),
     $ HDATA(2+2*(IPP+1))
872   FORMAT('  ',14I6,2X,Z8,2X,' VECTNR',I4,' PART.TYPE',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      GO TO 879
1277  CONTINUE
C--------------- SPECIAL FORMAT FOR GVTX BANKS
      NV = IDATA(LIM2)
      IPO = LIM2
      DO 1278  INV = 1,NV
      IPO = LIM2+(INV-1)*10
      CALL CORE(HWORK,72)
      WRITE(JUSCRN,1279) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO
     $ +8),ADATA(IPO+9),IDATA(IPO+10)
1279  FORMAT(' ',I3,3F8.2,3F8.2,I4,F8.2,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,72,0.)
1278  YS = YS - DEL
      NT = IDATA(IPO+11)
      CALL CORE(HWORK,4)
      WRITE(JUSCRN,1280) NT
1280  FORMAT(' ',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,4,0.)
      YS = YS - DEL
      IPO = IPO + 11 - 15
      DO 1281  INT = 1,NT
      IPO = IPO+15
      CALL CORE(HWORK,64)
      WRITE(JUSCRN,1282) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,8)
1282  FORMAT(' ',I3,F8.2,2F7.3,3F8.2,2F7.3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,64,0.)
      YS = YS - DEL
      CALL CORE(HWORK,42)
      WRITE(JUSCRN,1285) (ADATA(IPO+1+JJ),JJ=9,11),
     $ IDATA(IPO+13),IDATA(IPO+14),ADATA(IPO+15)
1285  FORMAT(' ',3F8.2,I4,I3,F10.2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,42,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1281
      IRETUR = 6
      GO TO 9965
1286  CONTINUE
1281  CONTINUE
      GO TO 9020
1377  CONTINUE
C--------------- SPECIAL FORMAT FOR DEDX BANKS
      NTR = IDATA(LIM2+1)
      CALL CORE(HWORK,4)
      WRITE(JUSCRN,1380) NTR
1380  FORMAT(' ',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,4,0.)
      NTR = MIN0(NTR,60)
      YS = YS - DEL
      DO 1378  ITR = 1,NTR
      IPO = LIM2+1+(ITR-1)*10
      CALL CORE(HWORK,82)
      WRITE(JUSCRN,1379) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO
     $ +8),ADATA(IPO+9)
1379  FORMAT(' ',I3,2F8.2,4E12.4,I4,F10.3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,82,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1378
      IRETUR = 7
      GO TO 9965
1376  CONTINUE
1378  CONTINUE
      GO TO 9020
1977  CONTINUE
C--------------- SPECIAL FORMAT FOR TOFR BANKS
      NTR = IDATA(LIM2)
      LIM2 = LIM2 - 1
      CALL CORE(HWORK,17)
      WRITE(JUSCRN,1980) (IDATA(LIM2+I),I=1,4)
1980  FORMAT(' ',4I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,17,0.)
      YS = YS - DEL
      NTRR = IDATA(LIM2+1)
      DO 1978  ITR = 1,NTRR
      IPO = LIM2+4+(ITR-1)*14
      CALL CORE(HWORK,118)
      WRITE(JUSCRN,1979) (IDATA(IPO+I),I=1,3),(ADATA(IPO+I),I=4,14)
1979  FORMAT(' ',3I3,F8.1,F8.0,4F8.0,2F8.1,I3,F8.2,F8.0)
      CALL SYSSYM(XS,YS,SIZE,HWORK,118,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1978
      IRETUR = 9
      GO TO 9965
1976  CONTINUE
1978  CONTINUE
      GO TO 9020
1677  CONTINUE
C--------------- SPECIAL FORMAT FOR LGCL BANKS
      LIM2 = LIM2 - 1
      CALL CORE(HWORK,29)
      WRITE(JUSCRN,1680) (IDATA(LIM2+LL),LL=1,4)
1680  FORMAT(' ',4I7)
      CALL SYSSYM(XS,YS,SIZE,HWORK,29,0.)
      LIM2 = LIM2 + 4
      YS = YS - DEL
      CALL CORE(HWORK,118)
      WRITE(JUSCRN,1681) (IDATA(LIM2+LL),LL=1,6),(ADATA(LIM2+LL),LL=7,1000052800
     $),IDATA(LIM2+11),(ADATA(LIM2+LL),LL=12,15),(IDATA(LIM2+L),L=16,21)
1681  FORMAT(' ',I3,I9,4I4,4F8.3,I4,4F8.3,2I3,I6,3I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,118,0.)
      NCLST = IDATA(LIM2+3)
      NWPCL = IDATA(LIM2+21)
      ILABEL = IDATA(LIM2+17)
      NCLS2 = NCLST*2+ 2
      LIM2 = LIM2 + 21
      LIM22 = 2*LIM2
      YS = YS - DEL
      CALL CORE(HWORK,101)
      WRITE(JUSCRN,1682) ((HDATA(LIM22+L),HDATA(LIM22+L+1)),L=1,NCLS2,2)
1682  FORMAT(' ',20I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,101,0.)
      IF(NCLST.LE.0) GO TO 9020
      LIM2 = LIM2 + NCLST + 1
      YS = YS - DEL
      DO 1678  ITR = 1,NCLST
      IPO = LIM2+(ITR-1)*NWPCL
      CALL CORE(HWORK,119)
C     IF(ILABEL.EQ.2)
      WRITE(JUSCRN,1679) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO
     $ +8),(ADATA(IPO+JJ),JJ=9,NWPCL)
1679  FORMAT(' ',I3,2F8.3,2F9.2,2F8.3,I4,4F8.3,F10.3,2F6.3,F7.3)
C     IF(ILABEL.EQ.1)
C    $WRITE(JUSCRN,1675) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO
C    $ +8),(ADATA(IPO+8+JJ),JJ=1,6),IDATA(IPO+15)
C1675  FORMAT(' ',I3,2F8.3,2F9.2,2F8.3,I4,6F9.3,I11)
      CALL SYSSYM(XS,YS,SIZE,HWORK,119,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1678
      IRETUR = 8
      GO TO 9965
1676  CONTINUE
1678  CONTINUE
      GO TO 9020
2240  CONTINUE
C--------------- SPECIAL FORMAT FOR FAMP BANKS (NOW TEMPORARILY BK17)
      LIM2 = LIM2 - 1
      LH2 = LIM2*2
      YS = YS - DEL
      CALL CORE(HWORK,28)
      WRITE(JUSCRN,2241) HDATA(LH2+3)
2241  FORMAT(' FAMP PROGRAM VERSION ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
C TRIGGERS
      NTRI = HDATA(LH2+4)
      IF(NTRI.GT.0) GO TO 2242
C      YS = YS - DEL
C      CALL CORE(HWORK,28)
C      WRITE(JUSCRN,2243)
C2243  FORMAT(' ---> NO TRIGGER INFORMATION')
C      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
       GO TO 2244
2242  YS = YS - DEL
      CALL CORE(HWORK,77)
      WRITE(JUSCRN,2245) (HDATA(LH2+NTRI+K),K=1,4)
2245  FORMAT(' #T2 TRACKS ',I3,' R3 TRACKS CELLS 33-48 ',Z4,'  CELLS 17-
     $32 ',Z4,'  CELLS 1-16 ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,77,0.)
C COUNTERS
2244  NCOU = HDATA(LH2+5)
      IF(NCOU.GT.0) GO TO 2246
C     YS = YS - DEL
C     CALL CORE(HWORK,28)
C     WRITE(JUSCRN,2247)
C2247  FORMAT(' ---> NO COUNTER INFORMATION')
C     CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
      GO TO 2248
2246  AA = HDATA(LH2+NCOU+2)*.1
      YS = YS - DEL
      CALL CORE(HWORK,53)
      WRITE(JUSCRN,2249) HDATA(LH2+NCOU+1),AA,HDATA(LH2+NCOU+3),
     $ HDATA(LH2+NCOU+4)
2249  FORMAT(' #TOFS ',I3,' TDIF(NS) ',F8.1,' ZVTOF ',I6,' ZVLG ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,53,0.)
C LEAD GLASS
2248  NL = HDATA(LH2+6)
      IF(NL.GT.0) GO TO 2250
C      YS = YS - DEL
C      CALL CORE(HWORK,31)
C      WRITE(JUSCRN,2251)
C2251  FORMAT(' ---> NO LEAD GLASS INFORMATION')
C      CALL SYSSYM(XS,YS,SIZE,HWORK,31,0.)
      GO TO 2252
2250  AA1 = HDATA(LH2+NL+5)*.001
      AA2 = HDATA(LH2+NL+6)*.001
      AA3 = HDATA(LH2+NL+7)*.001
      AA4 = HDATA(LH2+NL+8)*.001
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(JUSCRN,2253) (HDATA(LH2+NL+K),K=1,4),AA1,AA2,AA3,AA4,
     $ (HDATA(LH2+NL+KK),KK=9,10)
2253  FORMAT(' NR CLUSTERS TOTAL,BARREL,-EC,+EC : ',4I5,' ENERGIES: ',
     $4F8.3,' NHCLI ',I6,' ERES ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
C INNER DETECTOR ANALYSIS
2252  ND = HDATA(LH2+7)
      IF(ND.GT.0) GO TO 2254
      YS = YS - DEL
      CALL CORE(HWORK,35)
      WRITE(JUSCRN,2255)
2255  FORMAT(' ---> NO INNER DETECTOR INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,35,0.)
      GO TO 2256
2254  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(JUSCRN,2257) (HDATA(LH2+ND+K),K=1,3)
2257  FORMAT(' ID ZVTX FLAG ',I3,'  ZVTX IN MM ',I6,' INRGZV ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
      YS = YS - DEL
      INRGZV = HDATA(LH2+ND+3)
      NTR = HDATA(LH2+ND+4)
      NTRT = HDATA(LH2+ND+5)
      CALL CORE(HWORK,49)
      IF(NTR.LT.0) WRITE(JUSCRN,2258)
2258  FORMAT(' PATTERN RECOGNITION NOT PERFORMED              ')
      IF(NTR.EQ.0) WRITE(JUSCRN,2259)
2259  FORMAT(' PATTERN RECOGNITION PERFORMED, NO TRACKS FOUND ')
      IF(NTR.LE.0) CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      IF(NTR.LE.0) GO TO 2256
      WRITE(JUSCRN,2260) NTRT,NTR
2260  FORMAT(' PATREC PERFORMED,',I3,' TRACKS FOUND',I3,' TRACK BANKS')
      CALL SYSSYM(XS,YS,SIZE,HWORK,49,0.)
      LORT = HDATA(LH2+ND+6)
      LTRT = HDATA(LH2+ND+7)
      MWR1 = HDATA(LH2+ND+8)
      MWR2 = HDATA(LH2+ND+9)
      MWR3 = HDATA(LH2+ND+10)
      IEFA = HDATA(LH2+ND+11)
      IPLT = LH2+ND+LORT-LTRT
      YS = YS - DEL
      CALL CORE(HWORK,102)
      WRITE(JUSCRN,2261) NTRT,LORT,LTRT,MWR1,MWR2,MWR3,IEFA
2261  FORMAT(' TRACKS LISTED ',I4,'  LO AND LT FOR EACH ',2I4,
     $' NR WORDS MAP RING1-3: ',3I5,' ERROR FLAG ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,102,0.)
C
      DO 2262  ITR = 1,NTR
      IPLT = IPLT + LTRT
      IFTR = HDATA(IPLT)
      RR1 = HDATA(IPLT+1)*.1
      FI1 = HDATA(IPLT+2)
      Z1 = HDATA(IPLT+3)*.1
      RR2 = HDATA(IPLT+4)*.1
      FI2 = HDATA(IPLT+5)
      Z2 = HDATA(IPLT+6)*.1
      HELP(1) = HDATA(IPLT+8)
      HELP(2) = HDATA(IPLT+9)
      RR = FLOAT(IZWORD)*.1
      SIGXY = HDATA(IPLT+10)*.01
      NXY = HDATA(IPLT+11)
      TANTH = HDATA(IPLT+12)*001
      Z0 = HDATA(IPLT+13)*.1
      SIGZ = HDATA(IPLT+14)*.1
      NZ = HDATA(IPLT+15)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2199
      IRETUR = 11
      GO TO 9965
2199  CONTINUE
      CALL CORE(HWORK,120)
      WRITE(6,2263) ITR,IFTR,RR1,FI1,Z1,RR2,FI2,Z2,RR,SIGXY,NXY
2263  FORMAT(' ',I2,' SEC. ',I3,' R-FI-Z 1 ',F8.1,F5.0,F8.1,' R-FI-Z 2 '
     $,F8.1,F5.0,F8.1,' RCURV SIGXY NHITXY ',E14.6,F8.2,I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,115)
      WRITE(6,2264) TANTH,Z0,SIGZ,NZ
2264  FORMAT(' ',59X,' TANTHETA ',F10.5,' Z0 ',F8.2,' SIGZ(MM) ',F7.4,
     $ ' NZ ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,115,0.)
C
2262  CONTINUE
      IPLT = IPLT + LTRT
      IPLT1 = IPLT
      IPLT2 = IPLT1+MWR1
      IPLT3 = IPLT2+MWR2
      IPLT4 = IPLT3+MWR3
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2299
      IRETUR = 12
      GO TO 9965
2299  CONTINUE
      CALL CORE(HWORK,44)
      WRITE(6,2291) IPLT1,IPLT2,IPLT3,IPLT4
2291  FORMAT(' FAMP HIT MAP POINTERS: ',4I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,44,0.)
      IF(IPLT2.EQ.IPLT1) GO TO 2292
2295  IPLT22 = IPLT2-1
      IF(IPLT22.GT.IPLT1+19) IPLT22 = IPLT1+19
      IRESV = 22+5*(IPLT22-IPLT1+1)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2399
      IRETUR = 13
      GO TO 9965
2399  CONTINUE
      CALL CORE(HWORK,IRESV)
      WRITE(6,2293) (HDATA(II),II=IPLT1,IPLT22)
 2293  FORMAT(' ',14X,' RING1 ',20(Z4,1X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
      IF(IPLT22.GE.IPLT2-1) GO TO 2292
      IPLT1 = IPLT22+1
      GO TO 2295
2292  CONTINUE
      IF(IPLT3.EQ.IPLT2) GO TO 2296
2297  IPLT33 = IPLT3-1
      IF(IPLT33.GT.IPLT2+19) IPLT33 = IPLT2+19
      IRESV = 22+5*(IPLT33-IPLT2+1)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2499
      IRETUR = 14
      GO TO 9965
2499  CONTINUE
      CALL CORE(HWORK,IRESV)
      WRITE(6,2298) (HDATA(II),II=IPLT2,IPLT33)
2298  FORMAT(' ',14X,' RING2 ',20(Z4,1X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
      IF(IPLT33.GE.IPLT3-1) GO TO 2296
      IPLT2 = IPLT33+1
      GO TO 2297
2296  CONTINUE
      IF(IPLT4.EQ.IPLT3) GO TO 2301
      IF(INRGZV.NE.3) GO TO 2301
2302  IPLT44 = IPLT3-1
      IF(IPLT44.GT.IPLT3+19) IPLT44 = IPLT3+19
      IRESV = 22+5*(IPLT44-IPLT3+1)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2599
      IRETUR = 15
      GO TO 9965
2599  CONTINUE
      CALL CORE(HWORK,IRESV)
      WRITE(6,2303) (HDATA(II),II=IPLT3,IPLT44)
2303  FORMAT(' ',14X,' RING3 ',20(Z4,1X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
      IF(IPLT44.GE.IPLT4-1) GO TO 2301
      IPLT3 = IPLT44+1
      GO TO 2302
2301  CONTINUE
C
2256  NM = HDATA(LH2+8)
      IF(NM.GT.0) GO TO 2266
C      YS = YS - DEL
C      CALL CORE(HWORK,25)
C      WRITE(JUSCRN,2267)
C2267  FORMAT(' ---> NO MUON INFORMATION')
C      CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 2268
2266  CONTINUE
      YS = YS - DEL
      NMU = HDATA(LH2+NM)
      IF(NMU.GT.5) NMU =  5
      NCORE = 44 + NMU*4
      NMU = 2*NMU + 1
      CALL CORE(HWORK,64)
      WRITE(JUSCRN,2269) HDATA(LH2+NM),HDATA(LH2+NM+1),
     $ (HDATA(LH2+NM+K),K=2,NMU,2)
2269  FORMAT(' NR MUON TRACKS ',I2,'   IN BARREL ',I3,' POSITION ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
      YS = YS - DEL
      CALL CORE(HWORK,64)
      WRITE(JUSCRN,2270) (HDATA(LH2+NM+K+1),K = 2,NMU,2)
2270  FORMAT('                ',3X,'             ',3X,' QUALITY ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
C
2268  CONTINUE
      NTG = HDATA(LH2+9)
      IF(NTG.GT.0) GO TO 2271
C     YS = YS - DEL
C     CALL CORE(HWORK,25)
C     WRITE(JUSCRN,2272)
C2272  FORMAT(' ---> NO TAGG INFORMATION')
C     CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 2273
2271  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,50)
      WRITE(JUSCRN,2274) (HDATA(LH2+NTG+K),K=1,2)
2274  FORMAT(' TAGGING ENERGIES(MEV) IN -Z, +Z: ',2I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
C
2273  CONTINUE
C WRITE NOW FAMP ACTION WORD, FROM THE HEADBANK
C     IPHEA = IDATA(IBLN('HEAD'))
C     FAMACT = HDATA(2*IPHEA+26)
C     YS = YS - DEL
C     CALL CORE(HWORK,45)
C     WRITE(JUSCRN,2275) FAMACT
C2275  FORMAT('  FAMP ACTION WORD FROM HEAD BANK 26: ',Z4)
C      CALL SYSSYM(XS,YS,SIZE,HWORK,45,0.)
      GO TO 9020
C-------------------------
C----   SPECIAL FORMAT FOR ZTRG BANKS
C-------------------------
2550  CONTINUE
      LIM2 = LIM2 - 1
      LEZTRG = IDATA(LIM2)
      HPOINT = 2*( LIM2 + 1 )
      HZLENG = 2*( LEZTRG - 1 )
      YS = YS - DEL
C                    WRITE HEADER
      IILIM = 110
      CALL CORE(HWORK,IILIM)
      WRITE(JUSCRN,2551)
 2551 FORMAT(' DATA  B15 CHANNEL FIFOF HITCN UFLOW OFLOW Z-VALUE',10X,
     $' DATA  B15 CHANNEL FIFOF HITCN UFLOW OFLOW Z-VALUE')
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
C
      DO 2553 IHIT = 1,HZLENG,2
        HELP(2) = HDATA(HPOINT+IHIT)
        IZWRD1 = IZWORD
        KANAL1 = LAND( SHFTR(IZWORD,11),15)
        HITCN1 = LAND( SHFTR(IZWORD,8),3)
        IBT151 = 0
        IF(TBIT(IZWORD,16)) IBT151 = 1
        IZWRT1 = LAND( IZWORD,63 )
        IOVRF1 = 0
        IF(LAND(IZWORD,64).NE.0) IOVRF1 = 1
        IUNDF1 = 0
        IF(LAND(IZWORD,128).NE.0) IUNDF1 = 1
        IFIFF1 = 0
        IF(LAND(IZWORD,1024).NE.0) IFIFF1 = 1
C
        HELP(2) = HDATA(HPOINT+IHIT+1)
        IZWRD2 = IZWORD
        KANAL2 = LAND( SHFTR(IZWORD,11),15)
        HITCN2 = LAND( SHFTR(IZWORD,8),3)
        IBT152 = 0
        IF(TBIT(IZWORD,16)) IBT152 = 1
        IZWRT2 = LAND( IZWORD,63 )
        IOVRF2 = 0
        IF(LAND(IZWORD,64).NE.0) IOVRF2 = 1
        IUNDF2 = 0
        IF(LAND(IZWORD,128).NE.0) IUNDF2 = 1
        IFIFF2 = 0
        IF(LAND(IZWORD,1024).NE.0) IFIFF2 = 1
C
        YS = YS - DEL
        IF(YS.GT.50.) GO TO 2554
      IRETUR = 16
      GO TO 9965
2554    IILIM = 108
        CALL CORE(HWORK,IILIM)
        WRITE(JUSCRN,2552) IZWRD1,IBT151,KANAL1,IFIFF1,HITCN1,IUNDF1,
     $  IOVRF1,IZWRT1,
     $  IZWRD2,IBT152,KANAL2,IFIFF2,HITCN2,IUNDF2,
     $  IOVRF2,IZWRT2
 2552   FORMAT(' ',Z4,3X,I1,4X,I2,5X,I1,5X,I1,5X,I1,5X,I1,4X,I5,
     $ 13X,,Z4,3X,I1,4X,I2,5X,I1,5X,I1,5X,I1,5X,I1,4X,I5)
        CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 2553 CONTINUE
C
      GO TO 9020
3235  CONTINUE
C--------------- SPECIAL FORMAT FOR N50S BANKS
      LIM2 = LIM2 - 1
      LH2 = LIM2*2
      YS = YS - DEL
      CALL CORE(HWORK,86)
      WRITE(JUSCRN,3236) HDATA(LH2+3),HDATA(LH2+11),HDATA(LH2+12)
3236  FORMAT(' N50 PROGRAM VERSION ',I6,' ANALYSIS FLAG ',Z4,'  LOOSE MU
     $LTIHADRON SELECTION FLAG ',I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,86,0.)
C TRIGGERS
      NTRI = HDATA(LH2+4)
      IF(NTRI.GT.0) GO TO 3227
      YS = YS - DEL
      CALL CORE(HWORK,28)
      WRITE(JUSCRN,3228)
3228  FORMAT(' ---> NO TRIGGER INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
      GO TO 3229
3227  YS = YS - DEL
      CALL CORE(HWORK,77)
      WRITE(JUSCRN,3231) (HDATA(LH2+NTRI+K),K=1,4)
3231  FORMAT(' #T2 TRACKS ',I3,' R3 TRACKS CELLS 33-48 ',Z4,'  CELLS 17-
     $32 ',Z4,'  CELLS 1-16 ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,77,0.)
C COUNTERS
3229  NCOU = HDATA(LH2+5)
      IF(NCOU.GT.0) GO TO 3237
      YS = YS - DEL
      CALL CORE(HWORK,28)
      WRITE(JUSCRN,3238)
3238  FORMAT(' ---> NO COUNTER INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
      GO TO 3239
3237  AA = HDATA(LH2+NCOU+2)*.1
      YS = YS - DEL
      CALL CORE(HWORK,53)
      WRITE(JUSCRN,3241) HDATA(LH2+NCOU+1),AA,HDATA(LH2+NCOU+3),
     $ HDATA(LH2+NCOU+4)
3241  FORMAT(' #TOFS ',I3,' TDIF(NS) ',F8.1,' ZVTOF ',I6,' ZVLG ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,53,0.)
C LEAD GLASS
3239  NL = HDATA(LH2+6)
      IF(NL.GT.0) GO TO 3242
      YS = YS - DEL
      CALL CORE(HWORK,31)
      WRITE(JUSCRN,3243)
3243  FORMAT(' ---> NO LEAD GLASS INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,31,0.)
      GO TO 3244
3242  AA1 = HDATA(LH2+NL+5)*.001
      AA2 = HDATA(LH2+NL+6)*.001
      AA3 = HDATA(LH2+NL+7)*.001
      AA4 = HDATA(LH2+NL+8)*.001
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(JUSCRN,3245) (HDATA(LH2+NL+K),K=1,4),AA1,AA2,AA3,AA4,
     $ (HDATA(LH2+NL+KK),KK=9,10)
3245  FORMAT(' NR CLUSTERS TOTAL,BARREL,-EC,+EC : ',4I5,' ENERGIES: ',
     $4F8.3,' NHCLI ',I6,' ERES ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
C INNER DETECTOR ANALYSIS
3244  ND = HDATA(LH2+7)
      IF(ND.GT.0) GO TO 3246
      YS = YS - DEL
      CALL CORE(HWORK,35)
      WRITE(JUSCRN,3247)
3247  FORMAT(' ---> NO INNER DETECTOR INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,35,0.)
      GO TO 3248
3246  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(JUSCRN,3249) (HDATA(LH2+ND+K),K=1,3)
3249  FORMAT(' ID ZVTX FLAG ',I3,'  ZVTX IN MM ',I6,' INRGZV ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
      YS = YS - DEL
      NTR = HDATA(LH2+ND+4)
      NTRT = HDATA(LH2+ND+5)
      CALL CORE(HWORK,47)
      IF(NTR.LT.0) WRITE(JUSCRN,3250)
3250  FORMAT(' PATTERN RECOGNITION NOT PERFORMED             ')
      IF(NTR.EQ.0) WRITE(JUSCRN,3251)
3251  FORMAT(' PATTERN RECOGNITION PERFORMED, NO TRACKS FOUND')
      IF(NTR.LE.0) CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      IF(NTR.LE.0) GO TO 3248
      WRITE(JUSCRN,3252) NTR
3252  FORMAT(' PATTERN RECOGNITION PERFORMED,',I3,' TRACKS FOUND')
      CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      LORT = HDATA(LH2+ND+6)
      LTRT = HDATA(LH2+ND+7)
      IPLT = LH2+ND+LORT-LTRT
      YS = YS - DEL
      CALL CORE(HWORK,48)
      WRITE(JUSCRN,3212) NTRT,LORT,LTRT
3212  FORMAT(' TRACKS LISTED ',I4,'  LO AND LT FOR EACH ',2I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,48,0.)
C
      DO 4614  ITR = 1,NTRT
      IPLT = IPLT + LTRT
      X1 = HDATA(IPLT+1)*.1
      Y1 = HDATA(IPLT+2)*.1
      Z1 = HDATA(IPLT+3)*.1
      X2 = HDATA(IPLT+4)*.1
      Y2 = HDATA(IPLT+5)*.1
      Z2 = HDATA(IPLT+6)*.1
      HELP(1) = HDATA(IPLT+8)
      HELP(2) = HDATA(IPLT+9)
      RR = FLOAT(IZWORD)*.1
      SIGXY = HDATA(IPLT+10)*10.
      NXY = HDATA(IPLT+11)
      TANTH = HDATA(IPLT+12)
      Z0 = HDATA(IPLT+13)*.1
      SIGZ = HDATA(IPLT+14)*.1
      NZ = HDATA(IPLT+15)
      YS = YS - DEL
      CALL CORE(HWORK,114)
      WRITE(6,461) ITR,X1,Y1,Z1,X2,Y2,Z2,RR,SIGXY,NXY
461   FORMAT(' ',I2,' XYZ1 ',3F8.1,' XYZ2 ',3F8.1,' RADIUS ',E14.6,
     $'  SIGXY(MY) ',F10.0,' NXY ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,114)
      WRITE(6,462) TANTH,Z0,SIGZ,NZ
462   FORMAT(' ',59X,' TANTHETA ',F10.0,' Z0 ',F8.1,' SIGZ(MM) ',F6.1,
     $ ' NZ ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
C
4614  CONTINUE
C
3248  NM = HDATA(LH2+8)
      IF(NM.GT.0) GO TO 3253
      YS = YS - DEL
      CALL CORE(HWORK,25)
      WRITE(JUSCRN,3254)
3254  FORMAT(' ---> NO MUON INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 3255
3253  CONTINUE
      YS = YS - DEL
      NMU = HDATA(LH2+NM)
      IF(NMU.GT.5) NMU =  5
      NCORE = 44 + NMU*4
      NMU = 2*NMU + 1
      CALL CORE(HWORK,64)
      WRITE(JUSCRN,3256) HDATA(LH2+NM),HDATA(LH2+NM+1),
     $ (HDATA(LH2+NM+K),K=2,NMU,2)
3256  FORMAT(' NR MUON TRACKS ',I2,'   IN BARREL ',I3,' POSITION ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
      YS = YS - DEL
      CALL CORE(HWORK,64)
      WRITE(JUSCRN,3257) (HDATA(LH2+NM+K+1),K = 2,NMU,2)
3257  FORMAT('                ',3X,'             ',3X,' QUALITY ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
C
3255  CONTINUE
      NTG = HDATA(LH2+9)
      IF(NTG.GT.0) GO TO 3283
      YS = YS - DEL
      CALL CORE(HWORK,25)
      WRITE(JUSCRN,3284)
3284  FORMAT(' ---> NO TAGG INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 3285
3283  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,50)
      WRITE(JUSCRN,3286) (HDATA(LH2+NTG+K),K=1,2)
3286  FORMAT(' TAGGING ENERGIES(MEV) IN -Z, +Z: ',2I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
C
3285  CONTINUE
C WRITE NOW N50 ACTION WORD, FROM THE HEADBANK
      IPHEA = IDATA(IBLN('HEAD'))
      N50ACT = HDATA(2*IPHEA+26)
      YS = YS - DEL
      CALL CORE(HWORK,45)
      WRITE(JUSCRN,3258) N50ACT
3258  FORMAT('  NORD 50 ACTION WORD FROM HEAD BANK 26: ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,45,0.)
C
      IF(LAND(N50ACT,MASKMH).NE.0) GO TO 3263
      N50ACT = SHFTL(N50ACT,1)
      DO 3232 IBT = 1,16
      N50ACT = SHFTR(N50ACT,1)
      IF(IBT.LT.6) GO TO 3232
      IF(.NOT.TBIT(N50ACT,31)) GO TO 3232
C BIT IBT IS ON, WRITE CORRESPONDING INFORMATION
      DO 3287  I = 1,13
3287  HDUM(I) = HSX(I,IBT)
      YS = YS - 2*DEL
      CALL CORE(HWORK,43)
      WRITE(JUSCRN,3261) (HDUM(I),I=1,13)
3261  FORMAT('  CLASSIFICATION ',13A2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,43,0.)
3232  CONTINUE
      GO TO 3264
3263  MUH = LAND(N50ACT,MASKMH)
      DO 3289  I = 1,13
3289  HDUM(I) = HSX(I,5)
      YS = YS - 2*DEL
      CALL CORE(HWORK,61)
      WRITE(JUSCRN,3262) (HDUM(I),I=1,13),MUH
3262  FORMAT('  CLASSIFICATION ',13A2,' MULTIPLICITY ',I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,61,0.)
3264  CONTINUE
C
C MPRS BANK PART, INCLUDE SO THAT ALSO INDEPENDENT PRINT POSSIBLE
C
      IPLNAM = IDATA(IBLN('MPRS'))
      IF(IPLNAM.LE.0) GO TO 9020
      LIM2=IPLNAM+1
      YS = YS - DEL
      CALL CORE(HWORK,54)
      WRITE(JUSCRN,6231)
6231  FORMAT(' ------------->>>   MIPROC RESULTS   <<<--------------')
      CALL SYSSYM(XS,YS,SIZE,HWORK,54,0.)
C---------
1940  LIM2 = LIM2 - 1
      LH2 = LIM2*2
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(JUSCRN,6232) HDATA(LH2+10)
6232  FORMAT(' MIPROC EVENT COUNT (=TRIGGER NUMBER) ',I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,59)
      WRITE(JUSCRN,6233) HDATA(LH2+4),(HDATA(LH2+K),K=7,9)
6233  FORMAT(' MIPROC ZVTX',I6,' ZVX AND BACKG. PEAKS',2I6,' FLAG ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,59,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,27)
      WRITE(JUSCRN,6234) HDATA(LH2+5)
6234  FORMAT(' MIPROC FOUND ',I3,' R3 TRACKS')
      CALL SYSSYM(XS,YS,SIZE,HWORK,27,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,37)
      WRITE(JUSCRN,6235) HDATA(LH2+3)
6235  FORMAT(' MIPROC REJECTION AND ERROR FLAG ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,37,0.)
C
      MIPROC = HDATA(LH2+3)
      MIPROC = SHFTL(MIPROC,1)
      DO 8232 IBT = 1,16
      MIPROC = SHFTR(MIPROC,1)
      IF(.NOT.TBIT(MIPROC,31)) GO TO 8232
C BIT IBT IS ON, WRITE CORRESPONDING INFORMATION
      DO 8287  I = 1,13
8287  HDUM(I) = HSY(I,IBT)
      YS = YS - DEL
      CALL CORE(HWORK,41)
      WRITE(JUSCRN,8261) (HDUM(I),I=1,13)
8261  FORMAT('  ACTION/ERROR ',13A2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,41,0.)
8232  CONTINUE
C
      GO TO 9020
1577  CONTINUE
C--------------- SPECIAL FORMAT FOR ZVTX BANKS
      LIM2 = LIM2 - 1
      CALL CORE(HWORK,50)
      WRITE(JUSCRN,1579) (ADATA(LIM2+I),I=1,3),(IDATA(LIM2+I),I=4,6)
1579  FORMAT('  ',3F10.3,3I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
      GO TO 9020
C--------------- SPECIAL FORMAT FOR TPEV BANK
2077  LIM2 = LIM2 - 1
      LIMH2 = 2*LIM2
      CALL CORE(HWORK,62)
      WRITE(JUSCRN,2079) IDATA(LIM2+1),IDATA(LIM2+2),(HDATA(LIMH2+I),I=
     $5,14)
2079  FORMAT('  ',I8,2X,I8,2X,10I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,62,0.)
      YS = YS - DEL
      CALL CORE(HWORK,114)
      WRITE(JUSCRN,2080) (HDATA(LIMH2+I),I=15,34)
2080  FORMAT('  ',16I5,4I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(JUSCRN,2081) (ADATA(LIM2+I),I=18,27)
2081  FORMAT('  ',10E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,54)
      WRITE(JUSCRN,2082)(HDATA(LIMH2+I),I=55,56),(ADATA(LIM2+I),I=29,31)
2082  FORMAT('  ',2I5,3E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,54,0.)
      YS = YS - DEL
      CALL CORE(HWORK,110)
      WRITE(JUSCRN,2083) (ADATA(LIM2+I),I=32,40)
2083  FORMAT('  ',9E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,110,0.)
      YS = YS - DEL
      CALL CORE(HWORK,120)
      WRITE(JUSCRN,2084)(HDATA(LIMH2+I),I=81,82),(ADATA(LIM2+I),I=42,50)
2084  FORMAT('  ',2I5,9E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
      YS = YS - DEL
      CALL CORE(HWORK,72)
      WRITE(JUSCRN,2085) (ADATA(LIM2+I),I=51,55)
2085  FORMAT('  ',5E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,72,0.)
      YS = YS - DEL
      CALL CORE(HWORK,52)
      WRITE(JUSCRN,2086) (HDATA(LIMH2+I),I=111,120)
2086  FORMAT('  ',10I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,52,0.)
      GO TO 9020
C--------------- SPECIAL FORMAT FOR TPTR BANKS
2177  LIM2 = LIM2 - 1
      LIMH2 = 2*LIM2
      CALL CORE(HWORK,110)
      WRITE(JUSCRN,2179) (HDATA(LIMH2+I),I=1,18)
2179  FORMAT('  ',18I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,110,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(JUSCRN,2180) (ADATA(LIM2+I),I=10,19)
2180  FORMAT('  ',10E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,78)
      WRITE(JUSCRN,2181) IDATA(LIM2+20),ADATA(LIM2+21),IDATA(LIM2+22),
     $ (ADATA(LIM2+I),I=23,25),IDATA(LIM2+26)
2181  FORMAT('  ',I6,E14.6,I6,3E14.6,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,78,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(JUSCRN,2182)(ADATA(LIM2+I),I=27,33),(HDATA(LIMH2+I),I=67,68)
2182  FORMAT('  ',7E14.6,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(JUSCRN,2183)(ADATA(LIM2+I),I=35,38),(HDATA(LIMH2+I),I=77,78)
     $,(ADATA(LIM2+I),I=40,42)
2183  FORMAT('  ',4E14.6,2I6,3E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,74)
      WRITE(JUSCRN,2184) (HDATA(LIMH2+I),I=85,96)
2184  FORMAT('  ',12I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,74,0.)
      YS = YS - DEL
      CALL CORE(HWORK,120)
      WRITE(JUSCRN,2185) (ADATA(LIM2+I),I=49,57)
2185  FORMAT('   ',9E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
      YS = YS - DEL
      CALL CORE(HWORK,86)
      WRITE(JUSCRN,2186) IDATA(LIM2+58),(ADATA(LIM2+I),I=59,64)
2186  FORMAT('   ',I5,6E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,86,0.)
      YS = YS - DEL
      CALL CORE(HWORK,100)
      WRITE(JUSCRN,2187) (ADATA(LIM2+I),I=65,71)
2187  FORMAT('  ',7E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,100,0.)
      YS = YS - DEL
      CALL CORE(HWORK,98)
      WRITE(JUSCRN,2188) IDATA(LIM2+72),(ADATA(LIM2+I),I=73,78)
     $ ,(IDATA(LIM2+I),I=79,80)
2188  FORMAT('  ',I6,6E13.5,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,98,0.)
      GO TO 9020
C____________________________ SPECIAL FORMAT FOR ZETC BANK
5177  LENGB = LENGB + 2
      NCYCLE=1+(LENGB-1)/20
      LENGB = LENGB - 2
      DO 5010 LHO=1,NCYCLE
5006  YS = YS - DEL
      IF(YS.GT.50.) GO TO 5012
      IRETUR = 10
      GO TO 9965
5012  LIML=2*LIM2+20*(LHO-1)+1
      LIMU = LIML + 19
      IF(LIMU.GT.(2*LIM2+LENGB)) LIMU=2*LIM2+LENGB
      ILIM = LIMU - LIML + 1
      IF(ILIM.LE.0) GO TO 9020
      DO 5025  I = 1,ILIM
      LLO = LIML + I - 1
5025  HWORK(I+100) = HDATA(LLO)
      DO 5027  I = 1,ILIM,4
      IX = HWORK(I+100)
      IX = SHFTR(IX,3)
5027  HWORK(I+100) = IX
5026  IILIM = 6*ILIM + 1
      CALL CORE(HWORK,IILIM)
      WRITE(JUSCRN,9011) (HWORK(LLO+100),LLO=1,ILIM)
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 5010 CONTINUE
      GO TO 9020
C---------------    CONTINUATION SECTION
9965  CALL CORE(HWORK,14)
      WRITE(JUSCRN,9005)
9005  FORMAT(' CONTINUED ...')
      CALL SYSSYM(XS,YS,SIZE,HWORK,14,0.)
      GO TO 9029
9020  IRETUR = 1
9029  CALL TRMOUT(80,'HARDCOPY ?^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 5901
      CALL TRMOUT(80,'HARDCOPY ON EXTERNAL PLOTTER ?^')
      CALL DECIDE(JANSW)
      IF(JANSW.EQ.2) CALL HDCOPY
      IF(JANSW.EQ.1) CALL HDCEXT
5901  IF(IRETUR.EQ.1) GO TO 9566
      IF(IANSW.EQ.1) CALL PROMPT
      CALL ERASE
      YS = IYT
      CALL TRMOUT(80,'TERMINATE THIS LISTING?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 9566
      CALL ERASE
      GO TO (9566,875,275,9006,8006,1286,1376,1676,1976,5012,2199,
     $ 2299,2399,2499,2599,2554),IRETUR
9566  RETURN
      END

C   07/11/79 507081832  MEMBER NAME  FYRINT   (S)           FORTRAN
      SUBROUTINE FYRINT(I1,I2,I3,I4)
C
C     REVISED VERSION OF TONUM, TO GET FOUR INTEGERS FROM SCREEN, SEPA-
C     RATED BY BLANK OR KOMMA.
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL*1 BLANK,KOMMA,MINUS,TNN,ZW,SLASH
      COMMON /CWORK1/ TNN(40)
      DATA BLANK/' '/,SLASH/'/'/
      DATA KOMMA/','/
      DATA MINUS/'-'/
C
10    I1 = 0
      I2 = 0
      I3 = 0
      I4 = 0
      CALL TRMIN(40,TNN)
C                                       GET INTEGER NUMBER 1
      INT = 0
      NUM1 = 0
      ISGN = 1
      DO 20 I=1,40
        MKI = I
        ZW = TNN(I)
        IF(ZW.EQ.BLANK.OR.ZW.EQ.KOMMA.OR.ZW.EQ.SLASH) GOTO 30
        IF(ZW.NE.MINUS) GOTO 32
        ISGN = -1
        GOTO 20
 32     IF(ZW.LT.240 .OR. ZW.GT.249) GOTO 60
        NUM1 = NUM1 + 1
        INTD = ZW-240
        INT = 10*INT + INTD
   20 CONTINUE
C                                       CHECK IF MORE THAN 1 NUMBER
   30 I1 = ISGN*INT
      IF(MKI .GT.10) GOTO 60
      IF(NUM1.EQ.0) GOTO 70
C                                       GET INTEGER NUMBER 2
      NUM1 = 0.
      ISGN=1
      INT = 0.
      MKI = MKI + 1
      DO 41 I=MKI,40
        MKII = I
        ZW = TNN(I)
        IF(ZW.EQ.BLANK.OR.ZW.EQ.KOMMA.OR.ZW.EQ.SLASH) GOTO 50
        IF(ZW.NE.MINUS) GOTO 33
        ISGN = -1
        GOTO 41
   33   IF(ZW.LT.240 .OR. ZW.GT.249) GOTO 60
        NUM1 = NUM1 + 1
        INTD=ZW-240
        INT = 10*INT + INTD
   41 CONTINUE
C
 50   I2 = ISGN * INT
      IF(MKII.GT.20) GOTO 60
      IF(NUM1.EQ.0) GOTO 70
C                                       GET INTEGER NUMBER 3
      NUM1 = 0.
      ISGN=1
      INT = 0.
      MKI = MKII + 1
      DO 741 I=MKI,40
        MKII = I
        ZW = TNN(I)
        IF(ZW.EQ.BLANK.OR.ZW.EQ.KOMMA.OR.ZW.EQ.SLASH) GOTO 750
        IF(ZW.NE.MINUS) GOTO 733
        ISGN = -1
        GOTO 741
  733   IF(ZW.LT.240 .OR. ZW.GT.249) GOTO 60
        NUM1 = NUM1 + 1
        INTD=ZW-240
        INT = 10*INT + INTD
  741 CONTINUE
C
750   I3 = ISGN * INT
      IF(MKII.GT.30) GOTO 60
      IF(NUM1.EQ.0) GOTO 70
C                                       GET INTEGER NUMBER 4
      ISGN=1
      INT = 0.
      MKII = MKII + 1
      DO 40 I=MKII,40
        ZW = TNN(I)
        IF(ZW.EQ.BLANK.OR.ZW.EQ.KOMMA.OR.ZW.EQ.SLASH) GOTO 55
        IF(ZW.NE.MINUS) GOTO 34
        ISGN = -1
        GOTO 40
   34   IF(ZW.LT.240 .OR. ZW.GT.249) GOTO 60
        INTD=ZW-240
        INT = 10*INT + INTD
   40 CONTINUE
C
55    I4 = ISGN * INT
      GOTO 70
C
   60 CALL TRMOUT(80,'ILLEGAL CHARACTER. TRY AGAIN. STRING WAS:^')
      CALL TRMOUT(40,TNN)
      GOTO 10
   70 CONTINUE
      RETURN
      END

C   27/08/86 705201509  MEMBER NAME  J68KDS   (S)           FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE J68KDS
C-----------------------------------------------------------------------
C
C    AUTHOR:   G. ECKERLIN    5/08/86 :  JET CHAMBER RAW DATA DISPLAY
C       MOD:   G. ECKERLIN   18/08/86 :  NOW WITH USER KOORDINATES
C       MOD:   G. ECKERLIN   20/08/86 :  WIRE RANGE SELECTION ADDED
C       MOD:   G. ECKERLIN   27/08/86 :  DISPLAY OR NORMPULS ADDED
C       MOD:   G. ECKERLIN    3/09/86 :  DISPLAY DETAILS IMPLEMENTED
C  LAST MOD:   E. ELSEN      20/05/87 :  REDUCE SIZE OF BCS FROM 80K
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      LOGICAL LINEAR, LSEP, LDOS, LCELL(96), LWIFND, LWIRE(16),
     +        LAMP, DSPDTM
C
      INTEGER CL2PRC, PRC2CL
C
      COMMON / BCS / IW(1)
      COMMON /CWORK1/ IAMP(300,2), IWR, IPED(2,16), NWIRNG(2), IT0
     +                ,ISTWIR(16), IENWIR(16), NP0WIR(16)
     +                ,ISPRE2(8), TPREV(8), ISPRE1(8)
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CHEADR / HEAD(108)
      DIMENSION HW(1), RW(1)
      EQUIVALENCE (HW(1), IW(1), RW(1))
C
      DIMENSION NPCELL(96), NENDCL(96)
C
      DATA IPRINT / 0 /, IPRLIM / 0 /
      DATA AFAC / .7588 /, SCALE / 10. /
C
      RAW2LN(J) = SCALE * J * 64 / (64 - AFAC * J) + .5
C
      LN2RAW(R) = R/(SCALE + R*AFAC/64)+ .5
C
C-----------------  C O D E  -------------------------------------------

      INCELL = ACMD
CX    WRITE (6,9030) INCELL
 9030 FORMAT(' INCELL :',I5)
C                                   GET GLOBAL T0 FOR RUN
      IRUN = HEAD(18)
      IT0 = IT0GLB(IRUN)
CX    WRITE (6,9033) IT0
 9033 FORMAT(' T0 :',I7)
C                                   SET POINTER FOR J68K
      NPJ68K = IW(IBLN('J68K'))

C                                   IF J68K-BANK IS FILLED
      IF( NPJ68K.GT.0 ) THEN

        IF( IPRINT .LT. IPRLIM ) THEN
          CALL BPRS( 'J68K', 0 )
        ENDIF
        IPRINT = IPRINT + 1

C                                   PONITER FOR SCAN_SEC
        NPSCAN = HW(NPJ68K*2+7)
 9000   FORMAT(' NPSCAN :',I6)
CX      WRITE(6,9000) NPSCAN

        IF( NPSCAN.GT.0 ) THEN

C                                   RESET VARIABLES
          DO 200 I = 1, 96
            NPCELL(I) = 0
            NENDCL(I) = 0
            LCELL(I) = .FALSE.
  200     CONTINUE

          NPRCL = 0
          NPSCAN = NPSCAN + NPJ68K*2

C                                   NUMBER OF CRATES WITH SCAN_DATA
          NCRATE = HW(NPSCAN+1)
          NPSCAN = NPSCAN + 1
 9001     FORMAT(' NUMBER OF CRATES :',I6)
CX        WRITE(6,9001) NCRATE

C                                   FIND CRATE * CELL NUMBERS
          DO 2000 ICRATE=1,NCRATE
            L2 = HW(NPSCAN+1)
 9002       FORMAT(' WORDS FOR CRATE :',I6)
CX          WRITE(6,9002) L2
            IF( L2 .GT. 0 ) THEN

C                                   CRATE NUMBER
              IDL300 = HW(NPSCAN+2)
 9003         FORMAT(' CRATE NUMBER :',I6)
CX            WRITE(6,9003) IDL300
              NPSCAN = NPSCAN + 2
              LPT0 = 2
  700         IF( LPT0 .GE. L2 ) GO TO 900

C                                   NUMBER OF WORDS FOR PULS TRAIN
                L3 =  HW(NPSCAN+1)
                LPT0 = LPT0 + L3
                IF( L3.GT.5 ) THEN
                  IWIRE = HW(NPSCAN+2)/256

C                                   CELL NUMBER
                  ICELL = PRC2CL(IDL300)
                  ICELL = ICELL + IWIRE/16 + 1
 9004             FORMAT(' CELL NUMBER :',I6)
CX                WRITE(6,9004) ICELL
                  IF (.NOT.LCELL(ICELL)) THEN
                    LCELL(ICELL) = .TRUE.
                    NPCELL(ICELL) = NPSCAN
                    IF (NPRCL.GT.0) NENDCL(NPRCL) = NPSCAN
                    NPRCL = ICELL
                  ENDIF
                ENDIF
                NPSCAN =NPSCAN + L3
                GOTO 700
  900         CONTINUE

              IF (NPRCL.GT.0) NENDCL(NPRCL) = NPSCAN

            ENDIF
 2000     CONTINUE
C
C                                   REQUEST FOR CELL NUMBER
          IF (INCELL.LT.-96 .OR. INCELL.GT.96 ) INCELL = 0
          IF (INCELL.EQ.0 .OR. (.NOT.LCELL(ABS(INCELL)))) THEN
 2001       CONTINUE
            CALL TRMOUT(80,' CELLS AVAILABLE : (0 FOR EXIT)^')
            DO 500 I = 1, 96
              IF (LCELL(I)) THEN
 9005           FORMAT(1X,I6,' (',F4.1,')')
                WRITE(6,9005) I,CL2HEU(I)
              ENDIF
 500        CONTINUE
            CALL TRMOUT(80,'>>>>^')
            INCELL = TERNUM(DUMM)
CX          CALL TRMIN(4,INPUT)
CX          CALL GETINT(INPUT,INCELL)

C                                   IF INPUT EQ 0 EXIT
            IF (INCELL.EQ.0) THEN
              RETURN
            ENDIF

C                                   CHECK FOR LEGAL CELL NUMBER
            IF (INCELL.LT.-96 .OR. INCELL.GT.96 ) THEN
              CALL TRMOUT(80,' ILLEGAL CELL NUMBER^')
              GOTO 2001
            ENDIF

          ENDIF

C                                   REQUEST FOR WIRE RANGE
          IF ( INCELL.LT.0) THEN
 2002       CONTINUE
            WRITE(6,9020)
 9020       FORMAT(' GIVE WIRE RANGE 1...16 (MIN,MAX) :')
            READ (5,*) NWIRNG
CX          WRITE (6,9031) NWIRNG
 9031       FORMAT(' WIRE RANGE :',2I4)
            INCELL = -INCELL
            IF (NWIRNG(2).LT.NWIRNG(1)) THEN
              NSAVE = NWIRNG(1)
              NWIRNG(1) = NWIRNG(2)
              NWIRNG(2) = NSAVE
            ENDIF
            IF (NWIRNG(1).LT.1 .OR. NWIRNG(2).GT.16) GOTO 2002
          ELSE
            NWIRNG(1) = 1
            NWIRNG(2) = 16
          ENDIF

          ICELL = INCELL
          IF (NPCELL(ICELL).LE.0) THEN
            CALL TRMOUT(80,' NO DATA AVAILABLE FOR THIS CELL^')
            RETURN
          ENDIF
C                                   FIND POINTERS FOR JETC DATA
          DO 4004 NW = 1, 16
            LWIRE(NW) = .FALSE.
            NP0WIR(NW) = 0
            ISTWIR(NW) = 0
            IENWIR(NW) = 0
 4004     CONTINUE
          IPJETC = IW(IBLN('JETC'))
          IF (IPJETC.GT.0) THEN
            IPJET2 = IW(IPJETC - 1)
            IF (IPJET2.GT.0) THEN
              IPJETC = IPJET2
            ENDIF
            ICLPNT = ( IPJETC + 1 ) * 2
CXXX        NP0WIR = ICLPNT + 98
            NCELWD = HW(ICLPNT + ICELL + 1) - HW(ICLPNT + ICELL)
CX          WRITE (6,9100) ICLPNT, NCELWD
 9100       FORMAT(' ICLPNT,NCELWD :',2I8)
            IF (NCELWD.GT.0) THEN
              ISTCEL = HW(ICLPNT + ICELL) + ICLPNT + 98
              IENDCL = ISTCEL + NCELWD
              IPHIT = ISTCEL
 4000         IF (IPHIT.GE.IENDCL) GOTO 4001
                IWADDR = HW(IPHIT)
                IWJETC = IWADDR / 8
                IWREL = IWJETC - (ICELL - 1) * 16 + 1
                IF (IWREL.LT.1 .OR. IWREL.GT.16) THEN
                  CALL TRMOUT(80,' ERROR IN J68K FORMAT^')
                  RETURN
                ENDIF
                IF (.NOT.LWIRE(IWREL)) THEN
                  LWIRE(IWREL) = .TRUE.
                  NP0WIR(IWREL) = ICLPNT + 98
                  ISTWIR(IWREL) = IPHIT
                  IENWIR(IWREL) = IPHIT + 4
CX                WRITE (6,9103) IWREL, IPHIT
 9103             FORMAT(' IWREL,IPHIT :',2I8)
                ELSE
CX                WRITE (6,9102) IWREL, IPHIT
 9102             FORMAT(' END OF IWREL,IPHIT :',2I8)
                  IENWIR(IWREL) = IPHIT + 4
                ENDIF
                IPHIT = IPHIT + 4
                GOTO 4000
 4001         CONTINUE
            ELSE
              CALL TRMOUT(80,' NO HITS ACCEPTED^')
            ENDIF
          ELSE
            CALL TRMOUT(80,' NO JETC BANK') ! PMF 19/10/99: Add `80' to parameter list
          ENDIF
C
C                                   RESET GRAPHIC TERMINAL
C
          CALL ERASE
CXXX      CALL TWINDO(0,4095,0,4095)
          CALL DWINDO(0.,4095.,0.,4095.)
C
C                                   SET LEFT/RIGHT SEPARATION FLAG
          LSEP = DSPDTM(20)

C                                   SET DOS FLAG
          LDOS = DSPDTM(21)

C                                   SET LINEAR/NONLINEAR FLAG
          LINEAR = DSPDTM(22)
C                                   SET FLAG FOR NORMPULS DIPLAY
          LAMP = .TRUE.

C                                   FIND CRATE FROM CELL NUMBER
          IDL300 = CL2PRC(ICELL - 1)
CX        WRITE(6,9008) IDL300
 9008     FORMAT(' CRATE NUMBER FROM CELL :',I6)

          NPSCAN = NPCELL(ICELL)
C                                   END OF SECTION FOR CELL
          L2 = NENDCL(ICELL)
CX        WRITE(6,9009) L2
 9009     FORMAT(' END OF SECTION FOR CELL :',I6)

C                                   RESET PEDESTALS
          DO 3001 NW = 1, 16
             IPED(1,NW) = 0
             IPED(2,NW) = 0
 3001     CONTINUE
C                                   FIND PEDESTALS FOR CELL
          DO 3000 NW = NWIRNG(1), NWIRNG(2)
 2700       IF (NPSCAN.GE.L2) GOTO 2900
              L3 = HW(NPSCAN+1)
              IF (L3.GT.5) THEN
                IWIRE = HW(NPSCAN+2)/256
                ICWIR = IWIRE - (ICELL - PRC2CL(IDL300) - 1)*16 + 1
                IF (NW .EQ. ICWIR) THEN
                  IPED(1,NW) = HW(NPSCAN+3)
                  IPED(2,NW) = HW(NPSCAN+4)
                ENDIF
CX              WRITE (6,9032) NW,IPED(1,NW),IPED(2,NW)
 9032           FORMAT(' NW,IPED :',3I5)
              ENDIF
              NPSCAN = NPSCAN + L3
              IF (NW.GE.ICWIR) GOTO 2700
 2900       CONTINUE
            NPSCAN = NPSCAN - L3
 3000     CONTINUE

          NPSCAN = NPCELL(ICELL)
C                                   END OF SECTION FOR CELL
          L2 = NENDCL(ICELL)
C                                   DRAW KOORDINATE AXES
          CALL FADCAX(ICELL,LINEAR,LDOS,LSEP)
CX        CALL TRMOUT(80,' RETURN FROM FADCAX^')
          DO 1000  NW = NWIRNG(1), NWIRNG(2)

            DO 300 I = 1,2
              DO 400 J = 1, 300
                IF (.NOT.LINEAR) THEN
                  IAMP(J,I) = LN2RAW(REAL(IPED(I,NW)))
                ELSE
                  IAMP(J,I) = IPED(I,NW)
                ENDIF
  400         CONTINUE
  300       CONTINUE
CX          CALL TRMOUT(80,' RESET OF IAMP^')
            LWIFND = .FALSE.
CX          WRITE(6,9010) NPSCAN
 9010       FORMAT(' POINTER FOR DATA :',I6)
 1700       IF( NPSCAN .GE. L2 ) GO TO 1900

C                                   NUMBER OF WORDS FOR PULS TRAIN
              L3 =  HW(NPSCAN+1)
CX            WRITE(6,9011) L3
 9011         FORMAT(' NUMBER OF WORDS FOR PULS :',I6)
              IF( L3.GT.5 ) THEN
                IWIRE = HW(NPSCAN+2)/256
                ICWIR = IWIRE - (ICELL - PRC2CL(IDL300) - 1)*16 + 1
CX              WRITE (6,9014) ICWIR,IWIRE,NW
 9014           FORMAT(' ICWIR,IWIRE,NW :',I4,I4,I4)
                IF (NW .EQ. ICWIR) THEN
 9006             FORMAT(' WIRE FOUND :',I6)
CX                WRITE(6,9006) NW
                  ITOFF = HW(NPSCAN+2) - IWIRE*256
CX                WRITE (6,9012) ITOFF
 9012             FORMAT(' STARTBIN OF PULS :',I6)
                  IAFAC = HW(NPSCAN+5)
                  NPSCAN = NPSCAN + 5
                  L3 = L3 - 5
 9007             FORMAT(' NUMBER OF TIMEBINS :',I6)
CX                WRITE(6,9007) L3
                  IF( L3 .LE. 300 ) THEN
                    DO 800 IBIN=1,L3
                      IA = HW(NPSCAN+IBIN)

                      IF (.NOT. LINEAR ) THEN
C                                              GET LEFT AND RIGHT AMP.
                        IAMP(ITOFF+IBIN,1) = IA/256
                        IAMP(ITOFF+IBIN,2) = LAND(IA,255)

                      ELSE
C                                              GET LINEAR AMP
                        IAMP(ITOFF+IBIN,1) = RAW2LN(IA/256)
                        IA = LAND(IA,255)
                        IAMP(ITOFF+IBIN,2) = RAW2LN(IA)
                      ENDIF

  800               CONTINUE
CC                  IF( IPRINT .LT. IPRLIM ) THEN
CC                    CALL FABPLT( ITOFF, L3, HW(NPSCAN+1) )
CC                  ENDIF
CC                  IF( IPRINT .LT.   0 .AND. L3.LT.11 ) THEN
CC                    CALL FABPLT( ITOFF, L3, HW(NPSCAN+1) )
CCC                 ENDIF

                    LWIFND = .TRUE.
                  ENDIF
                ENDIF
              ENDIF
              NPSCAN = NPSCAN + L3
CX            CALL TRMOUT(80,' NEXT^')
CX            WRITE(6,9010) NPSCAN
              IF (NW.GE.ICWIR) GO TO 1700
 1900       CONTINUE
            NPSCAN = NPSCAN - L3
C                                   DRAW FADC DATA
C           IF (LWIFND) THEN
              IWR = NW
CX            CALL TRMOUT(80,' CALL FADDRW^')
              CALL FADDRW(LDOS,LSEP,LINEAR)
CX            CALL TRMOUT(80,' RETURN FROM FADDRW^')
C           ENDIF
C                                   DRAW NORMPULS
C           IF (LAMP) THEN
C             CALL FADNOR(LDOS,LSEP,LINEAR,AMP)
C           ENDIF
 1000     CONTINUE
        ELSE
          CALL TRMOUT(80,' NO SCAN_DATA AVAILABLE^')
        ENDIF
      ELSE
        CALL TRMOUT(80,' NO J68K_DATA AVAILABLE^')

      ENDIF
C                                   SET SCREEN WINDOW BACK TO LAST VIEW
      CALL SETSCL(JTVW)
      RETURN
      END

      SUBROUTINE FRFITV(IPTR,IPJHTL,ERRFAC)
      IMPLICIT INTEGER*2 (H)
      LOGICAL DEADCL
#include "cdata.for"
#include "cgeo1.for"
#include "calibr.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      INTEGER DATE(5), IDAY /0/
      DIMENSION  NHTRNG(3)
      DATA RESJ0 /.200/, RESV0 /.300/
      INTEGER MKLRT1 /Z1000000/, MKLRT2 /Z100/
      INTEGER MKBDCL(3) /Z10,Z20,Z40/
      INTEGER MKDDCL(3) /Z01,Z02,Z04/
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 1
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      NEV  = HDATA(IPHEAD+11)
      ITRK = IDATA(IPTR+1)
      HPFREE = 1
      HPFRE1 = HPFREE
      IPV    = ICALIB(10)
      XO     = ACALIB(IPV+ 1)
      YO     = ACALIB(IPV+ 3)
      PTRANS = ABS(0.0299792458*BKGAUS/ADATA(IPTR+25)) * .001
      RESV   = RESV0**2 + RESMS / PTRANS**2
      WGHT0  = RESJ0**2 / RESV
      F1     = ERRFAC
      IF(F1 .LT. .10) F1 = .10
      WGHT0  = WGHT0 / F1**2
      HPCO0  = HPFREE
      LHIT   = 14
      INDFET = 3
      CALL JFETCH(IPTR,IPJHTL,WRK(HPCO0),LHIT,IPRES,INDFET,XO,YO)
      HLDCO  = LHIT
      HPCO9  = IPRES - 1
      HPAR0  = IPRES
      HLDPA  = 20
      HPAR9  = HPAR0 + HLDPA - 1
      HPFREE = HPAR9 + 1
      XT     = WRK (IPRES   )
      YT     = WRK (IPRES+ 1)
      CSROT  = WRK (IPRES+ 2)
      SNROT  = WRK (IPRES+ 3)
      X0     = WRK (IPRES+ 9)
      Y0     = WRK (IPRES+10)
      XOR    =- XT*CSROT -  YT*SNROT
      YOR    =  XT*SNROT -  YT*CSROT
      WRK(HPAR0+ 4) = 0.
      WRK(HPAR0+ 5) = 0.
      WRK(HPAR0+ 6) = 0.
      WRK(HPAR0+ 7) = 1000.
      WRK(HPAR0+ 8) = 0.
      CSTH   = WRK (IPRES+11)
      SNTH   = WRK (IPRES+12)
      HPTR0 = HPFREE
      CALL MVC(IWRK(HPTR0),0,IDATA(IPTR+1),0,192)
      IWRK(HPTR0+ 1) = 0
      HPFREE = HPFREE + 48
      IWRK(HPTR0+1) = 0
      JRINGL = 3
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      ALBLM1 = 0.6
      ALBLM2 = 3.0
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
15000 CONTINUE
      IF(
     - NHGOOD.LT.8 .AND. NHFIT-NHGOOD.GT.8
     -)THEN
        ALBLM1 = ALBLM1 + 1.0
        ALBLM2 = ALBLM2 + 1.0
      ASSIGN 17006 TO IZZZ03
      GOTO 17004
17006 CONTINUE
      GOTO 15000
      ENDIF
15001 CONTINUE
      ALBLM1 = 0.6
      ALBLM2 = 3.0
16000 CONTINUE
      ASSIGN 17007 TO IZZZ02
      GOTO 17002
17007 CONTINUE
      ASSIGN 17008 TO IZZZ03
      GOTO 17004
17008 CONTINUE
      IF(.NOT.(
     - NHGOOD-NHFIT .LT.4
     -))GOTO 16000
16001 CONTINUE
      LBADFT = 0
      IF(IDATA(IPTR+24)-NHGOOD   .GT. 8) LBADFT = 1
      IF(IDATA(IPTR+24) .GT. 1.3*NHGOOD) LBADFT = 1
      IF(
     - SIG.LT.1. .AND. LBADFT .EQ.0
     -)THEN
      ASSIGN 17010 TO IZZZ04
      GOTO 17009
17010 CONTINUE
      ENDIF
      IF(
     - ABS(PAR1).GT..00030 .AND. NHTRNG(1)+NHTRNG(2).GT.16
     -)THEN
        ALBLM1 = 1.5
        ALBLM2 = 3.0
      ASSIGN 17011 TO IZZZ03
      GOTO 17004
17011 CONTINUE
        JRINGL = 2
      ASSIGN 17012 TO IZZZ02
      GOTO 17002
17012 CONTINUE
        ALBLM1 = 0.6
      ASSIGN 17013 TO IZZZ03
      GOTO 17004
17013 CONTINUE
      ASSIGN 17014 TO IZZZ02
      GOTO 17002
17014 CONTINUE
      ASSIGN 17015 TO IZZZ03
      GOTO 17004
17015 CONTINUE
        LBADFT = 0
        IF(IDATA(IPTR+24)-NHGOOD        .GT.   8) LBADFT = 1
        IF(IDATA(IPTR+24)/FLOAT(NHGOOD) .GT. 1.3) LBADFT = 1
      IF(
     - SIG.LT..10 .AND. LBADFT .EQ.0
     -)THEN
      ASSIGN 17017 TO IZZZ05
      GOTO 17016
17017 CONTINUE
          IWRK(IP+ 4) = 32
      ENDIF
      ENDIF
      IF(
     - ABS(PAR1).GT..00150 .AND. NHTRNG(1)+NHTRNG(2).GT.9
     -)THEN
        ALBLM1 = 1.5
        ALBLM2 = 3.0
      ASSIGN 17018 TO IZZZ03
      GOTO 17004
17018 CONTINUE
        JRINGL = 1
        NHTFIT = NHTRNG(1)
      IF(
     - NHTFIT.LE.5
     -)THEN
          NHTFIT = NHTFIT + NHTRNG(2)
          JRINGL = 2
      ENDIF
      IF(
     - NHTFIT.GT.9
     -)THEN
      ASSIGN 17019 TO IZZZ02
      GOTO 17002
17019 CONTINUE
          ALBLM1 = 0.6
      ASSIGN 17020 TO IZZZ03
      GOTO 17004
17020 CONTINUE
      ASSIGN 17021 TO IZZZ02
      GOTO 17002
17021 CONTINUE
      ASSIGN 17022 TO IZZZ03
      GOTO 17004
17022 CONTINUE
          LBADFT = 0
          IF(IDATA(IPTR+24)-NHGOOD        .GT.   8) LBADFT = 1
          IF(IDATA(IPTR+24)/FLOAT(NHGOOD) .GT. 1.3) LBADFT = 1
      IF(
     - SIG.LT..10 .AND. LBADFT .EQ.0
     -)THEN
      ASSIGN 17023 TO IZZZ05
      GOTO 17016
17023 CONTINUE
            IWRK(IP+ 4) = 48
      ENDIF
      ENDIF
      ENDIF
      HPFREE = HPFRE1
      RETURN
17002 CONTINUE
      S0 = WGHT0
      S1 = X0*WGHT0
      S2 = S1*X0
      S3 = S2*X0
      S4 = S3*X0
      S7 = Y0 * WGHT0
      S6 = S7*X0
      S5 = S6*X0
      IPCO = HPCO0
16002 CONTINUE
      IF(
     - IWRK(IPCO+ 10).EQ.0 .AND. IWRK(IPCO+12).LE.JRINGL
     -)THEN
          X = WRK(IPCO+3)
          Y = WRK(IPCO+4)
          X2 = X**2
          S1 = S1 + X
          S2 = S2 + X2
          S3 = S3 + X*X2
          S4 = S4 + X2**2
          S5 = S5 + Y*X2
          S6 = S6 + Y*X
          S7 = S7 + Y
          S0 = S0 + 1.
      ENDIF
      IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16002
16003 CONTINUE
      IF(
     - S0.LT.2.5
     -)THEN
        SIG = 1000.
      ELSE
        F1 = 1. / S4
        XX12 = S3*F1
        XX13 = S2*F1
        YY1  = S5*F1
        XX22 = S2 - S3*XX12
        XX23 = S1 - S3*XX13
        YY2  = S6 - S3*YY1
        XX32 = S1 - S2*XX12
        XX33 = S0 - S2*XX13
        YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
          XX23 = XX23 / XX22
          YY2  = YY2  / XX22
          PAR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
          PAR2 = YY2 - XX23*PAR3
      ELSE
          XX33 = XX33 / XX32
          YY3  = YY3  / XX32
          PAR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
          PAR2 = YY3 - XX33*PAR3
      ENDIF
        PAR1 = YY1 - XX12*PAR2 - XX13*PAR3
        DEG   = S0 - WGHT0 - 2.
        NHFIT = S0 - WGHT0 + .1
        CHISQ = 0.
        DCHIM1 = 0.
        IHITM1 = 0
        XST    = 999999.
        XEN    =-999999.
        IPCO = HPCO0
16004 CONTINUE
      IF(
     - IWRK(IPCO+ 10).EQ.0 .AND. IWRK(IPCO+12).LE.JRINGL
     -)THEN
            X = WRK(IPCO+3)
            IF(X.LT.XST) XST = X
            IF(X.GT.XEN) XEN = X
            Y = WRK(IPCO+4)
            F = (PAR1 *X + PAR2 )*X + PAR3
            DCHI = Y - F
            WRK(IPCO+13) = DCHI
            CHISQ = CHISQ + DCHI**2
      ENDIF
        IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16004
16005 CONTINUE
        SIG    =      CHISQ  / DEG
        SIGLM = TRELLM(16)**2
      ENDIF
      GOTO IZZZ02
17009 CONTINUE
      YST  = (PAR1 *XST + PAR2 )*XST + PAR3
      YEN  = (PAR1 *XEN + PAR2 )*XEN + PAR3
      TGST = PAR1*XST*2 + PAR2
      DXST = 1./SQRT(TGST**2+1.)
      DYST = DXST * TGST
      TGEN = PAR1*XEN*2 + PAR2
      DXEN = 1./SQRT(TGEN**2+1.)
      DYEN = DXEN * TGEN
      XMIN = -PAR2*.5 / PAR1
      YMIN = (PAR1*XMIN + PAR2)*XMIN + PAR3
      CVZW = TGST**2+1.
      CVST =-PAR1 * 2 / (SQRT(CVZW)*CVZW)
      DET = (S2*S0-S1*S1)*S4 + (S2*S1-S3*S0)*S3 + (S3*S1-S2*S2)*S2
      SIG11 = (S2*S0 - S1*S1)/DET
      SIG22 = (S4*S0 - S2*S2)/DET
      SIG33 = (S4*S2 - S3*S3)/DET
      SIG12 = (S3*S0 - S2*S1)/DET
      SIG13 = (S3*S1 - S2*S2)/DET
      SIG23 = (S4*S1 - S3*S2)/DET
      IP    = HPTR0 - 1
      IWRK(IP+ 1) = ITRK
      IWRK(IP+ 2) = LOR(IWRK(IP+ 2),32)
      IWRK(IP+ 3) = IDAY
      IWRK(IP+ 4) = 16
      WRK (IP+ 5) = XST *CSROT - YST *SNROT + XT
      WRK (IP+ 6) = XST *SNROT + YST *CSROT + YT
      WRK (IP+ 7) = XST - X0
      WRK (IP+ 8) = (DXST*CSROT - DYST*SNROT)
      WRK (IP+ 9) = (DXST*SNROT + DYST*CSROT)
      WRK (IP+10) = SNTH
      IWRK(IP+11) = 0
      WRK (IP+12) = XEN *CSROT - YEN *SNROT + XT
      WRK (IP+13) = XEN *SNROT + YEN *CSROT + YT
      WRK (IP+14) = XEN - X0
      WRK (IP+15) = (DXEN*CSROT - DYEN*SNROT)
      WRK (IP+16) = (DXEN*SNROT + DYEN*CSROT)
      WRK (IP+17) = SNTH
      IWRK(IP+18) = 2
      WRK (IP+19) = ATAN2(SNROT,CSROT)
      WRK (IP+20) = XMIN*CSROT - YMIN*SNROT + XT
      WRK (IP+21) = XMIN*SNROT + YMIN*CSROT + YT
      WRK (IP+22) = PAR1
      WRK (IP+23) = SQRT(SIG)
      IWRK(IP+24) = S0 + .001
      WRK (IP+25) = CVST
      WRK (IP+26) = SQRT(SIG*SIG11) * 2.
      WRK (IP+27) = CVST
      WRK (IP+28) = CVST
      WRK (IP+31) = XOR - X0
      GOTO IZZZ04
17016 CONTINUE
      YST  = (PAR1 *XST + PAR2 )*XST + PAR3
      TGST = PAR1*XST*2 + PAR2
      DXST = 1./SQRT(TGST**2+1.)
      DYST = DXST * TGST
      XMIN = -PAR2*.5 / PAR1
      YMIN = (PAR1*XMIN + PAR2)*XMIN + PAR3
      CVZW = TGST**2+1.
      CVST =-PAR1 * 2 / (SQRT(CVZW)*CVZW)
      DET = (S2*S0-S1*S1)*S4 + (S2*S1-S3*S0)*S3 + (S3*S1-S2*S2)*S2
      SIG11 = (S2*S0 - S1*S1)/DET
      SIG22 = (S4*S0 - S2*S2)/DET
      SIG33 = (S4*S2 - S3*S3)/DET
      SIG12 = (S3*S0 - S2*S1)/DET
      SIG13 = (S3*S1 - S2*S2)/DET
      SIG23 = (S4*S1 - S3*S2)/DET
      IP    = HPTR0 - 1
      WRK (IP+ 5) = XST *CSROT - YST *SNROT + XT
      WRK (IP+ 6) = XST *SNROT + YST *CSROT + YT
      WRK (IP+ 7) = XST - X0
      WRK (IP+ 8) = (DXST*CSROT - DYST*SNROT)
      WRK (IP+ 9) = (DXST*SNROT + DYST*CSROT)
      WRK (IP+10) = SNTH
      IWRK(IP+18) = 2
      WRK (IP+19) = ATAN2(SNROT,CSROT)
      WRK (IP+20) = XMIN*CSROT - YMIN*SNROT + XT
      WRK (IP+21) = XMIN*SNROT + YMIN*CSROT + YT
      WRK (IP+22) = PAR1
      WRK (IP+23) = SQRT(SIG)
      IWRK(IP+24) = S0 + .001
      WRK (IP+25) = CVST
      WRK (IP+26) = SQRT(SIG*SIG11) * 2.
      WRK (IP+27) = CVST
      GOTO IZZZ05
17004 CONTINUE
        IWL = -999
        NHTRNG(1) = 0
        NHTRNG(2) = 0
        NHTRNG(3) = 0
        IWL = -999
        NHGOOD = 0
      DO 13000 IP = HPCO0,HPCO9,HLDCO
          IW0 = IWRK(IP)
          X   = WRK(IP+3)
          Y   = WRK(IP+4)
          F   = (PAR1*X + PAR2)*X + PAR3
          DF  = F - Y
          LBGOOD = 4
          IF(ABS(DF).LT.ALBLM2) LBGOOD = 1
          IF(ABS(DF).LT.ALBLM1) LBGOOD = 0
          IWRK(IP+ 10) = LBGOOD
          IF(LBGOOD.EQ.0) NHGOOD = NHGOOD + 1
          WRK (IP+13) = DF
          IRNG = IWRK(IP+12)
          IF(LBGOOD.LE.1) NHTRNG(IRNG) = NHTRNG(IRNG) + 1
      IF(
     - IWL.EQ.IW0
     -)THEN
      IF(
     - ABS(DFL).LT.ABS(DF)
     -)THEN
              IF(IWRK(IP +10).EQ.0) NHGOOD = NHGOOD - 1
              IWRK(IP +10) = 16
      ELSE
              IF(IWRK(IPL+10).EQ.0) NHGOOD = NHGOOD - 1
              IWRK(IPL+10) = 16
      ENDIF
      ENDIF
          IWL = IW0
          IPL = IP
          DFL = DF
13000 CONTINUE
13001 CONTINUE
      GOTO IZZZ03
17000 CONTINUE
        IQJETC = IBLN('JETC')
        IQHEAD = IBLN('HEAD')
        CALL DAY2(DATE)
        IDAY = DATE(1)*1000 + DATE(2)
        RESMS = .020**2/2. * .16 * (1. + ALOG10(.16) / 9) * 155.45**2
      GOTO IZZZ01
      END

      SUBROUTINE BSIDE
      IMPLICIT INTEGER*2 (H)
#include "cworkpr.for"
#include "cjdrch.for"
#include "cdsmax.for"
#include "cpatlm.for"
#include "cworkmx.for"
      DIMENSION LSTCL(3),LFTCL(3),NCELL(3),TANDEL(3)
      EQUIVALENCE (IBCK(1),LSTCL(1)),(IBCK(4),LFTCL(1))
      EQUIVALENCE (IBCK(7),NCELL(1)),(DBCK(1),TANDEL(1))
      DATA MSKCR1 /Z100/
      LRCORN=0
      KT=K
      IRIFLG=0
      IWT=ILIM-1
      ICX=ICL
15000 CONTINUE
      IF(
     - IWT.LT.ILIM
     -)THEN
      DS=TRKAR(KT,10-IUDFLG)
      IW=ITRKAR(KT,9-IUDFLG)
      IKX=0
      A=TRKAR(KT,11-IUDFLG)
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ICT=ICX+1
      IF(ICT.GT.LSTCL(KRING)) ICT=ICT-NCELL(KRING)
      LR1=2
      IF(
     - IPER.GE.0
     -)THEN
      IF(
     - HNTCEL(ICT+1)-HNTCEL(ICT).GT.0
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - LR.EQ.1.OR.IMARK.EQ.0.OR.LR.EQ.0
     -)THEN
      CALL SIDE1
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      IF(
     - IKX.NE.0
     -)THEN
      IF(
     - LR.EQ.-1
     -)THEN
      CALL COREC
      ENDIF
      LR=-1
      IWT=HMCH(ITRKAR(IKX,9-IUDFLG)+1,KRING,2)
      IF(IUDFLG.EQ.6) IWT=-IWT
      CALL BSTORE
      IPST=0
      LR=1
      IJFLG=0
      ENDIF
      IF(
     - IKX.EQ.0
     -)THEN
      ICT=ICX-1
      IF(ICT.LT.LFTCL(KRING)) ICT=ICT+NCELL(KRING)
      LR1=1
      IF(
     - IPER.LE.0
     -)THEN
      IF(
     - HNTCEL(ICT+1)-HNTCEL(ICT).GT.0
     -)THEN
      ASSIGN 17004 TO IZZZ02
      GOTO 17002
17004 CONTINUE
      IF(
     - LR.EQ.-1.OR.IMARK.EQ.0.OR.LR.EQ.0
     -)THEN
      CALL SIDE1
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      IF(
     - IKX.NE.0
     -)THEN
      IF(
     - LR.EQ.0
     -)THEN
      HISTR(1,NTR)=-HISTR(1,NTR)
      ENDIF
      IF(
     - LR.EQ.1
     -)THEN
      CALL COREC
      ENDIF
      LR=1
      IWT=HMCH(ITRKAR(IKX,9-IUDFLG)+1,KRING,1)
      IF(IUDFLG.EQ.6) IWT=-IWT
      CALL BSTORE
      IPST=0
      IJFLG=0
      LR=-1
      ENDIF
      ELSE
      IWT=ILIM
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      RETURN
17002 CONTINUE
      IMARK=0
      KC1=HISTR(1,NTR)
      KC1=IPCL(IABS(KC1))
      KC2=HISTR(HNREL(NTR),NTR)
      KC2=IPCL(IABS(KC2))
      IF(
     - KC1.NE.KC2
     -)THEN
      IF(
     - KC1.LE.48
     -)THEN
      IF(KC1-KC2.NE.24) IMARK=1
      ELSE
      IMARK=1
      ENDIF
      ENDIF
      GOTO IZZZ02
17000 CONTINUE
      IPER=0
      IF(
     - IBKK(20).NE.0.AND.LR.NE.0.AND.NRHT(KT).GE.IBKK(19)
     -)THEN
      IPER=LR
      IF(LAND(MSKCR1,LBL(KT)).NE.0.AND.IUDFLG.EQ.3) IPER=-IPER
      ENDIF
      GOTO IZZZ01
      END

C   28/11/85 610021350  MEMBER NAME  DRPIPE   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      FUNCTION DRPIPE(DUMMY)
C-----------------------------------------------------------------------
C
C
C     RETURNS THE BEAMPIPE THICKNESS(MM), BASED ON DATE IN HEAD BANK
C     MC-DATA: NEW GEOMETRY IS FORCED IF FLAG LVTXC IS TRUE
C     ARGUMENT DUMMY IS IGNORED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL NEWDET,LVTXC,LNHARD
C
#include "cadmin.for"
#include "cdata.for"
#include "cgeo1.for"
#include "cgeov.for"
C
      COMMON / CVCEX  / LVTXC
C
C------------------  C O D E  ------------------------------------------
C
      IH2    = 2*IDATA( IBLN( 'HEAD' ) )
C
      IMONTH = HDATA(IH2+7)
      IYEAR  = HDATA(IH2+8)
C
C                            OLD GEOMETRY (PRIOR TO MAY 1984)
C
      DRPIPE = DRPIP
C                            NEW DETECTOR HARDWARE IN MONTE-CARLO DATA?
C                            THEN LVTXC IS TRUE (FLAG IS CHECKED AND
C                                                SET IN RDMTCO)
C
      LNHARD = (IMONTH .GE. 5  .AND.  IYEAR .EQ. 1984)
     +                          .OR.  IYEAR .GE. 1985
      NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
C
      IF( .NOT. NEWDET ) RETURN
C
C                            NEW GEOMETRY
C
      DRPIPE = DRPIPV
C
      RETURN
      END

C   27/04/79 C9050201   MEMBER NAME  RDREAD   (S)           FORTRAN
      SUBROUTINE RDREAD( NUNIT, HOPT, * )
C-----------------------------------------------------------

C      VERSION OF 27/04/79       LAST MOD 30/04/79
C      THIS ROUTINE READS MT CARLO DATA FROM UNIT NUNIT.
C      RETURN 1 IF END OF FILE ENCOUNTERED.
C      THE DATA HAVE TO BE IN BOS FORMAT. THE FIRST
C      RECORD WHICH IS READ HAS TO BE THE RECORD WITH THE MTC. CONST.
C      THE CONST ARE PUT INTO THE MT CARLO DATA COMMONS
C      EVENTS ARE READ INTO THE COMMON/ BCS /
C      DRIFT TIMES AND Z COORDINATES ARE PUT INTO PROPER BINNINGS
C      THERE ARE TWO OPTIONS IOPT:
C       1. HOPT='DE'      DEFAULT VALUES FOR DRIFT TIME BINS AND
C                         Z AMPLITUDES ARE INSERTED.
C                         THE DEFAULT VALUES ARE STORED IN FIDEF AND
C                         ZDEF
C       2. HOPT='SE'      THE USER HAS TO PROVIDE PHI AND Z BINNING
C                         THROUGH THE COMMON/CBIN/
C-----------------------------------------------------------
C
      IMPLICIT INTEGER * 2 (H)
C
#include "cmubcs.for"
C
      COMMON/CGEO1/IGEO(66)
C
      DIMENSION SAVTIM(6),IDOUBL(3)
      COMMON/CJDRCH/ DRCH(34)
C
      COMMON/C4VEC/I4VEC(424)
C
C      USER SUPPLIED COMMON/CBIN/
C
      COMMON/CBIN/TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3)
C
C      TIME     BIN WIDTH FOR DRIFT TIME IN MM
C               WIRES ARE PUT TOGETHER IN GROUPS OF 8
C               DEFAULT.. 6 * .35 MM
C      ZOF      OFFSET IN Z  DIRECTION IN MM FOR AMPLITUDE CALCULATION
C               DEFAULT -10. MM
C      ZRS      STANDARD DEV FOR Z RESOLUTION IN MM
C               DEFAULT  20 MM
C      ZL       EFFECTIVE WIRE LENGTH IN MM
C               DEFAULT  2687 MM
C      ZSC      SCALING FACTOR FOR Z AMPLITUDES
C               DEFAULT 1.
C      EPSI     EFFICIENCY IN EACH RING
C               DEFAULT 3 * 1.
C      DOUB     DOUBLE TRACK RESOLUTION IN MM IN EACH RING
C               DEFAULT 3 * 5.
C      IRN      NO OF RANDOM HITS INSERTED IN EACH RING
C               DEFAULT 3 * 0
C
C      SET DEFAULT VALUES
C
      DIMENSION TIMDEL(6)
      DIMENSION EPSOPT(3)
      DIMENSION DBOPT(3)
      DIMENSION IRNOPT(3)
      DATA TIMDEL  /6*0.35/
      REAL ZOFFS   /-10./
      REAL ZRESOL  /20./
      REAL ZAL     /2687./
      REAL ZSCAL   /1./
      DATA EPSOPT  /3*1./
      DATA DBOPT   /3*5./
      DATA IRNOPT  /3*0/
C
      DATA HOPT1/'DE'/
C
      LOGICAL CALIBS,CALIB1,CALIB2
      DATA CALIBS/.FALSE./,CALIB1/.FALSE./,CALIB2/.FALSE./
C CALIB1 IS .TRUE. IF 1ST CALIB. DATA RECORD ('MTCO') HAS BEEN READ,
C CALIB2 IS .TRUE. IF 2ND CALIB. DATA RECORD ('MUCO') HAS BEEN READ.
C CALIBS IS .TRUE. IF BOTH CALIB DATA RECORDS HAVE BEEN READ.
C
 1001 WRITE(6,9101)
 9101 FORMAT(' *********   READ ERROR IN RDREAD')
 1000 CONTINUE
C MAIN READ STATEMENT.
      CALL BSLT
      CALL BDLG
      CALL BREAD( NUNIT, &1001, &98 )
      IF(CALIBS)GO TO 20
      IPJ = IDATA( IBLN( 'HEAD' ) )
      IF( IPJ .NE. 0 ) GO TO 91
      IPJ = IDATA( IBLN( 'MUCO' ) )
      IF( IPJ .NE. 0 ) GO TO 21
      IPJ = IDATA( IBLN( 'MTCO' ) )
      IF( IPJ .EQ. 0 ) GO TO 93
C
 23   CONTINUE
C       POINTER TABLE FOR CONST
C       POINTER  1   POSITION 55 JETCH CONST /CJDRCH/
C       POINTER  2   POSITION 56 GEOM CONST /CGEO1/
      CALL BPRS( 'MTCO', 1 )
      CALL BPRS( 'MJET', 2 )
      CALL BPRS( 'MGEO', 3 )
      IP1 = IDATA( IBLN( 'MJET' ) )
      IP2 = IDATA( IBLN( 'MGEO' ) )
      LJET = IDATA(IP1)
      LGEO = IDATA(IP2)
      DO 1 I=1,LJET
    1 DRCH(I) = ADATA(IP1+I)
      DO 2 I=1,LGEO
    2 IGEO(I) = IDATA(IP2+I)
C
C      SAVE TIMING BIN WIDTH OF MTC GENERATION
C
      DO 8 I=1,6
    8 SAVTIM(I) = DRCH(I+19)
C
      IF( HOPT.EQ.HOPT1 ) GO TO 10
C
C      INSERT USER SUPPLIED VALUES FOR RESOLUTION INTO COMMONS
C      THE DEFAULT OPTIONS ARE OVERWRITTEN
C
      DO 6 I=1,6
    6 TIMDEL(I)= TIME(I)
      ZOFFS    = ZOF
      ZRESOL   = ZRS
      ZAL      = ZL
      ZSCAL    = ZSC
      DO 7 I=1,3
      EPSOPT(I) = EPSI(I)
      DBOPT(I)  = DOUB(I)
    7 IRNOPT(I) = IRN(I)
C
C      INSERT DEFAULT VALUES FOR RESOLUTION INTO COMMONS
C
   10 CONTINUE
      DO 11 I=1,6
      SAVTIM(I) = SAVTIM(I)/TIMDEL(I)
   11 DRCH(19+I) = TIMDEL(I)
      DRCH(27)  = ZOFFS
      DRCH(28)  = ZRESOL
      DRCH(30)  = ZAL
      DRCH(31)  = ZSCAL
C
C      PRINT ACTUAL CONST
C
      WRITE(6,100) (DRCH(I),I=20,32),DBOPT,IRNOPT,EPSOPT
  100 FORMAT(20X,'ACTUAL CONST FOR CENTRAL DETECTOR',/,
     * 5X,'TIMING BINS IN MM ',6(1X,F7.3),/,
     * 5X,'ZMAX               ',F9.3,/,
     * 5X,'ZOFFS              ',F9.3,/,
     * 5X,'ZRESOL             ',F9.3,/,
     * 5X,'ZNORM              ',F9.3,/,
     * 5X,'ZAL                ',F9.3,/,
     * 5X,'ZSCAL              ',F9.3,/,
     * 5X,'TILT ANGLE         ',F9.3,/,
     * 5X,'DOUB HIT RES IN MM',3(1X,F7.3),/,
     * 5X,'NR OF RDM HITS    ',3(1X,I3),/,
     * 5X,'EFFICIENCY        ',3(1X,F7.3))
C
      CALIB1 = .TRUE.
      CALIBS = CALIB1.AND.CALIB2
      GO TO 1000
C
 21   CONTINUE
C READ MU CHAMBER CALIBRATION DATA
C THERE ARE 3 ALTERNATIVE ROUTINES TO MOVE MUON CALIBRATION DATA OUT OF
C    THE INPUT DATA ARRAY INTO COMMON AREAS.
C 1)MUCON SIMPLY TRANSFERS ALL 4000 I*4 WORDS INTO THE FULL MUON
C    CALIBRATION DATA COMMONS, /CMFFIX/, ETC.
C 2)MUCONT TAKES CALIBRATION DATA STRAIGHT OUT OF THE INPUT DATA ARRAY
C    AND PRODUCES A CONDENSED VERSION OF CALIBRATION DATA IN /CMUTNY/.
C    IT AVOIDS USING THE FULL MUON CALIBRATION DATA COMMONS, /CMFFIX/,
C    ETC., THUS SAVING ABOUT 3500 I*4 WORDS (NET).
C 3)MUCONB DOES THE SAME, BUT USES BOS.
      CALL BPRS( 'MUCO', 1 )
      CALL MUCON( 0 )
C
      CALIB2 = .TRUE.
      CALIBS = CALIB1.AND.CALIB2
      GO TO 1000
C
 20   CONTINUE
C CALIBRATION DATA COMPLETE.  EVENTS NORMALLY FOLLOW.
C IF, HOWEVER, A CALIB. DATA RECORD IS READ, REFILL THE APPROPRIATE
C   COMMONS.  (ALTERNATIVELY SKIP THEM BY WRITING GO TO 1000 ON
C   NEXT 2 IF'S.)
      IPJ = IDATA( IBLN( 'MTCO' ) )
      IF( IPJ .NE. 0 ) GO TO  23
      IPJ = IDATA( IBLN( 'MUCO' ) )
      IF( IPJ .NE. 0 ) GO TO  21
      IPJ = IDATA( IBLN( 'VECT' ) )
      IF( IPJ .NE. 0 ) GO TO  300
      IPJ = IDATA( IBLN( 'HEAD' ) )
      IF( IPJ .EQ. 0 ) GO TO  93
      GO TO 400
C
C      FILL /C4VEC/ FROM ID
C      I4VEC(1) = EVENT NUMBER
C      I4VEC(5) TO I4VEC(8) = 4 VECTOR COMPONENTS (REAL'S)
C      I4VEC(9) = MASS (REAL)
C      I4VEC(10)= CHARGE (INTEGER)
C      I4VEC(11)= PARTICLE TYPE (INTEGER)
C
  300 CONTINUE
      LL0 = IDATA( IPJ )
      LL = IDATA( LL0 )
      DO 301 L=1,LL
  301 I4VEC(L)=IDATA( L + LL0 )
      GO TO 1000
C
C PUT DATA RECORD INTO / BCS /
C
C      POINTER TABLE
C      BANK  1  HEAD
C      BANK  2  TRIG     POINTER ON LOC 55 IN HEAD BANK
C      BANK  3  SCAL     POINTER ON LOC 56 IN HEAD BANK
C      BANK  4  LATC     POINTER ON LOC 57 IN HEAD BANK
C      BANK  5  ATST     POINTER ON LOC 58 IN HEAD BANK
C      BANK  6  ATOF     POINTER ON LOC 59 IN HEAD BANK
C      BANK  7  ALGL     POINTER ON LOC 60 IN HEAD BANK
C      BANK  8  JETC     POINTER ON LOC 61 IN HEAD BANK
C      BANK  9  CONC     POINTER ON LOC 62 IN HEAD BANK
C      BANK 10  MUEV     POINTER ON LOC 63 IN HEAD BANK
C
C
C      SET UP JET CHAMBER DATA
C
  400 CONTINUE
      IPJ = IDATA( IBLN( 'JETC' ) )
      IF( IPJ .EQ. 0 ) RETURN
C
      CALL RDRESO( SAVTIM )
C
CCC CONSIDER DOUBLE HIT RESOLUTION, INEFFICIENCIES AND RANDOM HITS
      DO 52 I3=1,3
   52 IDOUBL(I3) = DBOPT(I3) / DRCH(2*I3+18)
      CALL RDMODN( IRNOPT, EPSOPT, IDOUBL )
C
CCC SET CORRECT STANDARD DEVIATIONS IN PATR BANK
      CALL RDPATR
      RETURN
C
C      ERROR EXITS
C
   91 WRITE(6,191)
  191 FORMAT(5X,6('*'),3X,'READMC FOUND AN EVENT RECORD BEFORE ALL CALIB
     *RATION DATA RECORDS WERE READ')
      STOP 777
C
 98   CONTINUE
      IF(CALIBS)GO TO 99
      WRITE(6,198)
  198 FORMAT(5X,6('*'),3X,'EOF ENCOUNTERED BEFORE ALL CALIBRATION DATA H
     *AS BEEN READ')
      STOP 777
C
 93   WRITE(6,193)
 193  FORMAT(5X,'******  UNRECOGNISED RECORD READ IN READMC')
      STOP 777
C
   99 RETURN 1
      END

C   05/02/87            MEMBER NAME  TPTAGA   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTAGA
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery        5/02/87:  Analyse tagging system
C              A. Finch
C
C
C     Routine to analyse tagging system to search for clusters if
C     requested to.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  ANALYS

C------------------  C O D E  ------------------------------------------

C                            Get instruction about tagging analysis

      CALL TPTGI1( ANALYS )

C                            If analysis wanted, delete old banks first

      IF( ANALYS ) THEN

        CALL BMLT( 2,'ACLSTAGG' )
        CALL BDLM

C                            Perform tagging analysis
C                              IER > 1  if error has occurred
C                                    except IER = 10

        CALL TAGAN( IER, 0 )

        IF( IER. GT. 1  .AND.  IER .NE. 10 ) THEN
          CALL TPERRH
        ELSE
          CALL TPDIAG()
        ENDIF

      ENDIF

      RETURN
      END

C   08/11/78 102191158  MEMBER NAME  JDMAIN   (PATRECSR)    FORTRAN
C
C     MAIN PROGRAM FOR TESTS: P.STEFFEN(78/11/15)
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CDATA/ NWORD,IDATA(4000)
                     DIMENSION HJCA(10)
                     EQUIVALENCE (HJCA(1),IDATA(1))
                     EQUIVALENCE (IPJCA,IDATA(61))
C
      COMMON /CBIN/ TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IPN(3)
C
      COMMON /CCYCP/ HPTSEC(98)
C
      COMMON /CZVPAR/ LBZVDF,ZLOW,  BINZ,  NBINZ,
     ,                NWRDR1,LWRDC0,LWRDC1,LWRDC2,
     ,                IDZ1LM,IDZ2LM,NPKMIN,SBRAT,DFIMAX,
     ,                DZVPAR(5),
     ,                ZVTX,DZV1,DZV2,PEAK,BACK,IFLAG,
     ,                HUFLO(2),HOFLO(2),MAXZ ,HIST(100)
C
      COMMON /CWORK/ WORK(5000)
C
      COMMON /CLBPGM/ LBPGM(30)
C
      DATA NUNIT /1/
      DATA NREC /0/
C
 2001 FORMAT('0EOF REACHED ... STOP,',I6,' RECORDS READ')
 2002 FORMAT('0TIME LIMIT  ... STOP,',I6,' RECORDS READ')
C
C
 100   CONTINUE
C                                       CHECK TIME
        IF(IUHR(2).NE.1) GOTO 905
C                                                 READ MC-DATA
        NREC = NREC + 1
        CALL READMC(NUNIT,'DE',&900)
C                                         INITIALIZATION AFTER 1. RECORD
        IF(NREC.EQ.1) CALL INIT0
C                                                 FILL JCA-ARRAY
        NWORD2 = NWORD + NWORD
C                                                 INITIALIZE PGM-LABEL
        DO 120 I1=1,30
           LBPGM(I1) = 0
120     CONTINUE
C                                                 CHECK IF HITS IN JET C
      IF(IPJCA.LE.0) GOTO 100
C                                       PREPARE CYCLIC POINTER ARRAY
        CALL PRCYCP
C                                                 CALC. Z(VERTEX)
        CALL ZVERTF
C
        PRINT 2901, NREC, NWORD2
2901    FORMAT(1H1,'EVENT =',2I6,/,(1X,20I6))
C                                                 CHECK IF GOOD VERTEX
      IF(IFLAG.LT.0 .OR. ABS(ZVTX).GT.200.)  GOTO 100


C                                                 PATREC
      CALL PATREC
C                                                 CHECK IF END OF LOOP
      GOTO 100
C
 905  WRITE(6,2002) NREC
      GOTO 910
C                                                  EOF ... FINAL EVAL.
 900  CONTINUE
        WRITE(6,2001) NREC
 910    CONTINUE
        STOP
C
       END
C
      SUBROUTINE INIT0
C
C     CALL OF DIFFERENT INITIALIZATION ROUTINES
C
      CALL INITZV
      CALL INPATR
      CALL INPATC
      RETURN
      END

C   05/08/86 705201513  MEMBER NAME  FADDRW   (S)           FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE FADDRW(LDOS,LSEP,LINEAR)
C-----------------------------------------------------------------------
C
C    AUTHOR:   G. ECKERLIN    5/08/86 :  JET CHAMBER RAW DATA DISPLAY
C       MOD:   G. ECKERLIN   18/08/86 :  USER KOORDINATES USED NOW
C       MOD:   G. ECKERLIN   20/08/86 :  WIRE RANGE SELECTION SUPPORTED
C       MOD:   G. ECKERLIN    4/09/86 :  DESPLAY DETAILS IMPLEMENTED
C  LAST MOD:   E. ELSEN      20/05/87 :  REDUCE SIZE OF BCS FROM 80K
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LSEP, LDOS, LINEAR, LP, LTRACK, DSPDTM
C
      INTEGER MASK /Z FF0000/
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1), RW(1)
      EQUIVALENCE (HW(1), IW(1), RW(1))
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON /CWORK1/ IAMP(300,2), ICWIR, IPED(2,16), NWIRNG(2), IT0
     +                ,ISTWIR(16), IENWIR(16), NP0WIR(16)
     +                ,ISPRE2(8), TPREV(8), ISPRE1(8)
      COMMON / CORDER / KWR(17), KSIDE, KSTART, KEND, KTIMB, KEV
      COMMON / CKORD  / RX1, RX2,
     +                  RY1, RY2
C
      DIMENSION IWRADE(7), HAMP(2,256), BUFFER(3,8)
C
C
      DATA IWRADE / 87, 105, 114, 101, 96, 96, 96 /
      DATA ICALL  / 0 /
      DATA IPOINT / 18 /, SCALE / 10. /
C
C-----------------  C O D E  -------------------------------------------
C
C                                   SET DISPLAY FLAG FOR TRACK
      LTRACK = DSPDTM(23)
      IF (LSEP) LTRACK = .FALSE.

C                                   SET POINTER FOR JHTL
      NPJHTL = IW(IBLN('JHTL')) * 2
C                                                FETCH FADC-DATA
      IPREL =(ICWIR - 1)*250
      DO 60 JS = 1,2
          DO 50 JJ = 1,256
              HAMP(JS,JJ) = IAMP(JJ,JS)
  50      CONTINUE
  60  CONTINUE
C                                   DIFFERENCIATE IF CDTL 51
      IF( .NOT. LDOS ) GO TO 100
         DO 90 JS = 1, 2
C
            DO 80 JJ = 0, 254
               H1 = HAMP(JS,255-JJ)
               H2 = HAMP(JS,256-JJ)
               HAMP(JS,256-JJ) = H2 - H1
  80        CONTINUE
            HAMP(JS,1) = 0
  90  CONTINUE
C
 100  IF( .NOT. LSEP ) GOTO 120
         KSIDE = 1
         RX1 = 300.
         RX2 = 2100.
 120  IF(ICALL .GT. 0) GOTO 130
         KRANGE = KEND - KSTART
         RYMAX  = INT(RY2 - RY1)/KWR(17) - 50
         ISCRCH = RX2 - RX1
C
 130  RYO = INT(RY1) + INT(RYMAX + 50)*ICALL
      IF( LDOS ) THEN
        IF (.NOT.LINEAR) THEN
          RYO = INT(RYO) + INT(RYMAX)*24/64
        ELSE
          RYO = INT(RYO) + INT(RYMAX)*96/256
        ENDIF
      ENDIF
C
C
      IXO = RX1
      RX  = RX1
      RY  = RYO
C
C                                               DRAW FADC-DATA
      LSIDE = KSIDE
 150  IF(LSIDE .EQ. 3) LSIDE = 2
      CALL MOVEA(RX,RY)
      KSTR1 = KSTART + 1
      DO 200 IREP = KSTR1,KEND
         LP = .FALSE.
         IF (.NOT.LINEAR) THEN
           RDY = INT(RYMAX*HAMP(LSIDE, IREP))/64
         ELSE
           RDY = INT(RYMAX*HAMP(LSIDE, IREP))/256/SCALE
         ENDIF
         IF(RDY .GE. RYMAX) RDY = RYMAX
         RYY = RY + RDY
         IF(KSIDE .NE. 3 .OR. LSIDE .NE. 2) GOTO 180
            CALL DASHA(RX, RYY, 34)
            RX = IXO + ISCRCH*(IREP-KSTART)/KRANGE
            IF(RDY .LT. RYMAX) GOTO 170
               CALL DASHA(RX, RYY, 1)
               GOTO 200
 170        CALL DASHA(RX, RYY, 34)
            GOTO 200
 180     CONTINUE
         CALL DRAWA(RX, RYY)
         RX = IXO + ISCRCH*(IREP-KSTART)/KRANGE
         IF(RDY .LT. RYMAX) GOTO 190
            CALL DASHA(RX, RYY, 1)
            GOTO 200
 190     IF( LP ) CALL DASHA(RX,RYY,1)
         IF( .NOT. LP ) CALL DRAWA(RX, RYY)
 200  CONTINUE
C
C                                                REPEAT IF KSIDE = BOTH
      IF(KSIDE .NE. 3 .OR. LSIDE .NE. 2) GOTO 210
      LSIDE = 1
      RX = IXO
      GOTO 150
 210  CONTINUE
C                                                WRITE WIRE NUMBER
      IF (LSIDE.EQ.1) THEN
        RYWR = 100
        IF( LDOS ) RYWR = 190
        CALL MOVEA(RX1 - 250., RYO + RYMAX - RYWR)
        CALL CHRSIZ(4)
        IF (ICWIR.LT.10) THEN
          IWRADE(7) = ICWIR + 48
          IWRADE(6) = 48
        ELSE
          IWRADE(7) = ICWIR - (ICWIR/10)*10 + 48
          IWRADE(6) = ICWIR/10 + 48
        ENDIF
        CALL HLABEL(7,IWRADE)
      ENDIF
C                                   POINTER FOR JETC TIME
      IPHIT = ISTWIR(ICWIR)
      IF (LTRACK) THEN
        DO 4002 IHIT = 1, 8
          BUFFER(1,IHIT) = 0
          BUFFER(2,IHIT) = 0
          BUFFER(3,IHIT) = 0
 4002   CONTINUE
        NHIT = 1
      ENDIF
 4000 IF (IPHIT.GE.IENWIR(ICWIR)) GOTO 4001
C       IAL = HW(IPHIT + 1)
C       IAR = HW(IPHIT + 2)
        ITJETC = HW(IPHIT + 3)
CX      WRITE (6,9101) ICWIR, IAL, IAR, ITJETC
 9101   FORMAT(' WIRE , AL, AR, T :',4I5)
        ITIM = (ITJETC + IT0)/85
        XPNT = (RX2 - RX1) * ITIM /(KEND - KSTART) + RX1
        IPOINT = 18
        IF (NPJHTL.GT.0) THEN
          NPHIT = (IPHIT-NP0WIR(ICWIR))/2+ 3
          ITRK1 = SHFTR(LAND(HW(NPJHTL+NPHIT),255),1)
          ITRK2 = SHFTR(LAND(HW(NPJHTL+NPHIT+1),255),1)
CX        WRITE (6,9111) ITRK1, ITRK2, NPHIT
 9111     FORMAT(' TRACKS :',3I5)
          IF (ITRK1.GT.0 .OR. ITRK2.GT.0) THEN
C           IPOINT = 48 + ITRK1 - (ITRK1/10)*10
            IPOINT = 2
          ENDIF
C                                   FIND TRACKS
          IF (LTRACK) THEN
            DO 4003 IH = 1, 8
              IF (ITRK1.NE.0) THEN
                IF (ITRK1.EQ.ISPRE1(IH) .OR. ITRK1.EQ.ISPRE2(IH)) THEN
C                 CALL TRMOUT(80,' DRAWS LINE 1
                  CALL MOVEA(XPNT,RYO)
                  CALL DASHA(TPREV(IH),RYPREV,38)
                ENDIF
              ENDIF
              IF (ITRK2.NE.0) THEN
                IF (ITRK2.EQ.ISPRE1(IH) .OR. ITRK2.EQ.ISPRE2(IH)) THEN
                  CALL MOVEA(XPNT,RYO)
                  CALL DASHA(TPREV(IH),RYPREV,38)
                ENDIF
              ENDIF
 4003       CONTINUE
C
            BUFFER(1,NHIT) = XPNT
            IF (ITRK1.GT.0) BUFFER(2,NHIT) = ITRK1
            IF (ITRK2.GT.0) BUFFER(3,NHIT) = ITRK2
            NHIT = NHIT + 1
          ENDIF
        ENDIF
        CALL MOVEA(XPNT - 12,RYO - 25)
        CALL CHRSIZ(4)
        CALL CSIZE(IXWID,IYWID)
        CALL ANCHO(IPOINT)
CX      WRITE (6,9040) IXWID,IYWID
 9040   FORMAT(' IXWID, IYWID :',2I8)
        IPHIT = IPHIT + 4
        GOTO 4000
 4001 CONTINUE
      IF (LTRACK) THEN
        DO 4004 IHIT = 1, 8
          TPREV(IHIT) = BUFFER(1,IHIT)
          ISPRE1(IHIT) = BUFFER(2,IHIT)
          ISPRE2(IHIT) = BUFFER(3,IHIT)
 4004   CONTINUE
      ENDIF
C
      IF( (.NOT. LSEP) .OR. KSIDE .NE. 1) GOTO 220
         KSIDE = 2
         RX1 = 2200.
         RX2 = 4000.
         GOTO 120
C
 220  ICALL = ICALL + 1
      RYPREV = RYO
      IF(KWR(17) .NE. ICALL) RETURN
      ICALL = 0
      IF (LTRACK) THEN
        DO 4005 IHIT = 1, 8
          TPREV(IHIT) = 0
          ISPRE1(IHIT) = 0
          ISPRE2(IHIT) = 0
 4005   CONTINUE
      ENDIF
C
      RETURN
      END

      PROGRAM ZE4VJB
      IMPLICIT NONE
C   27/11/86 704161229  MEMBER NAME  ZE4VJBN  (S)           FORTRAN77
C
C   VERSION OF 04/02/85    E. ELSEN
C   MODIFIED   12/01/87    M. ZIMMER
C   MODIFIED   31/03/87    G. ECKERLIN
C   LAST MOD   16/04/87    G. ECKERLIN   EVENT SKIP AND SELECTION
C
C   Last mod   09/12/00    P. Movilla Fernandez
C                          Adapt for use on new platforms
C   Last mod   05/06/00    P. Movilla Fernandez
C                          Introduce IMPLICIT NONE, declare
C                          variables explicitly
C                          Reorganize I/O, use FFREAD cards
C                          Introduce readable print out of event BOS banks 
C                          Introduce handling of random number seeds
C
C-----------------------------------------------------------
C   COMPRESS EVENTBANKS INTO ZE4V FORMAT
C   WITH ZE4VTP FROM TPTR AS FAR AS POSSIBLE
C   WITH ZE4VPK FROM PATR AND LGCL BANK
C-----------------------------------------------------------
C
C BOS
      INTEGER IW
      INTEGER*2 HW
      REAL RW
      COMMON / BCS / IW(80000)
      DIMENSION HW(80000*2),RW(80000)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C Some counter limits
      INTEGER IEVLIM,IFILMX,IWRMAX,IWZMAX,ISCIP,ITPPK
      DATA IEVLIM / 10000/, IFILMX / 1 /, IWRMAX /  0  /
     >     IWZMAX / 10000 /, ISCIP / 0 /
C ZE4V DUMP FOR 'IDULIM' EVENTS
      INTEGER IDUMP,IDULIM
      DATA IDUMP/ 1 /, IDULIM / 10 /
C FLAG TO SELECT ZE4VTP=1/ZE4VPK=2
      DATA ITPPK/ 2 /
C Some old fashioned IBM stuff
      INTEGER*2 HDSN,HVOL
      DIMENSION HDSN(22), HVOL(3)
      DATA HVOL /3*'  '/
      REAL*8 DDIN/'FT02F001'/, DDOU/'FT03F001'/, DDZE/'FT51F001'/
      INTEGER IDDIN(2)
      EQUIVALENCE(IDDIN(1),DDIN)
C INPUT/OUTPUT FTXX..
C          INPUT   (2)   EVT-OUT (3)   ZE4V-OUT (51)
      INTEGER IRUNIT,IWUNIT,IUNZE4
      DATA IRUNIT/ 2 /, IWUNIT/ 3 /, IUNZE4/ 51 /
C
C --- PMF: new stuff:
C
C I/O parameters set in BLOCK DATA JADEBD
      INTEGER IUNIT,JUNIT,NCALI,KUNITA,LUNITA
      COMMON/CIOUNI/IUNIT,JUNIT,NCALI,KUNITA(10),LUNITA(10)
C Flags for reading the calibration constants in klread
      INTEGER LBMC
      COMMON /CMCCAL/ LBMC(17)
C FFREAD
      REAL SPACE
      INTEGER FFSPAC
      PARAMETER (FFSPAC=20000)
      COMMON / CFREAD / SPACE(FFSPAC)
C Additional I/O options
      INTEGER IOBANK
      LOGICAL LBANK
      DATA IOBANK/41/
C Misc
      INTEGER NAMLEN,NBYTEW,NWNAM
      PARAMETER( NAMLEN=120, NBYTEW=4, NWNAM=NAMLEN/NBYTEW )
      INTEGER  SVBOSF(NWNAM),ZBOSF(NWNAM),ZE4VF(NWNAM),BANKF(NWNAM)
     >     ,CALF(NWNAM,3)
      CHARACTER*(NAMLEN) CSVBOSF,CZBOSF,CZE4VF,CBANKF,CCALF(3),CCALFU
      LOGICAL LEXIST,LEX(3),LSTART
      CHARACTER CSEEDF*9
      DATA CSEEDF / 'ze4v.stat' /
      INTEGER INDEX,LENOCC,IERR
      DATA IERR/0/
      INTEGER HBANK(NWNAM)
      CHARACTER*(NAMLEN) CBANK
      INTEGER IHEAD,IEVT,MOD
C Some more explicit declarations 
      INTEGER*2 HERR
      INTEGER I,LT,LTCH,LTNE,LTRE,IACCLF,NPZE4V,MAXTR,IACCFL,NPTPEV
     >     ,IBLN,ITR,NPOINT,ISELFL,ISELEL,ISELMU,IEOF,IWZE4V,JUHR,IZE4V
     >     ,IWRITE,IEV,NPHEAD,IFIL
C
C------------- C o d e ------------------------------------
C

C READ IN DD* CARDS
***PMF      READ(5,5001) ITPPK,IEVLIM,IFILMX,IWRMAX,IWZMAX,IDULIM,ISCIP,
***PMF     &             ISELFL,ISELMU,ISELEL
***PMF 5001 FORMAT(20X,I10)

C ------- PMF 05/06/00 --------------

C Read FFREAD cards (PMF 05/06/00)
      WRITE (*,600)
 600  FORMAT( /,' *',3(7('*'),16('*'),7('*')),'*'/
     +       ' *',3(7X,16X,7X),'*'/
     +       ' *',3(7X,'Z E 4 V    J O B',7X),'*'/
     +       ' *',3(7X,16X,7X),'*'/
     +       ' *',3(7X,'VERSION 05/06/00',7X),'*'/
     +       ' *',3(7X,16X,7X),'*'/
     +       ' *',3(7('*'),16('*'),7('*')),'*'/  //       )
C... Initialise FFREAD cards
      CALL FFINIT(0)
      CALL FFSET('SIZE',8)
C... Read FFREAD cards  
      WRITE(*,'(A)') 'ZE4VJB: read FFREAD cards'
      ITPPK=2
      CALL FFKEY('TPPK',ITPPK,1,'INTE')
      LSTART=.FALSE.
      CALL FFKEY('ZSTART',LSTART,1,'LOGI')
      IEVLIM=999999
      CALL FFKEY('EVTREAD',IEVLIM,1,'INTE')
      IWRMAX=10
      CALL FFKEY('EVTOUT',IWRMAX,1,'INTE')
      IWZMAX=IEVLIM
      CALL FFKEY('ZE4VOUT',IWZMAX,1,'INTE')
      IDULIM=30
      CALL FFKEY('ZE4VPRT',IDULIM,1,'INTE')
      ISCIP=0
      CALL FFKEY('EVTSKP',ISCIP,1,'INTE')
      ISELFL=1
      CALL FFKEY('SELECT',ISELFL,1,'INTE')
      ISELMU=0
      CALL FFKEY('MSELCT',ISELMU,1,'INTE')
      ISELEL=0
      CALL FFKEY('ESELCT',ISELEL,1,'INTE')
      LBANK=.FALSE.
      CALL FFKEY('BANKS',LBANK,1,'LOGI')
      CALL VBLANK(HBANK,NWNAM)
      CALL FFKEY('CONT',HBANK,NWNAM,'MIXED')
C... File names
      CALL VBLANK(SVBOSF,NWNAM)
      CALL FFKEY('SVBOS',SVBOSF,NWNAM,'MIXED')
      CALL VBLANK(ZE4VF,NWNAM)
      CALL FFKEY('ZE4V',ZE4VF,NWNAM,'MIXED')
      CALL VBLANK(ZBOSF,NWNAM)
      CALL FFKEY('ZBOS',ZBOSF,NWNAM,'MIXED')
      CALL VBLANK(BANKF,NWNAM)
      CALL FFKEY('ZBANK',BANKF,NWNAM,'MIXED')
      CALL VBLANK(CALF(1,1),NWNAM)
      CALL FFKEY('AUPDAT0',CALF(1,1),NWNAM,'MIXED')
      CALL VBLANK(CALF(1,2),NWNAM)
      CALL FFKEY('BUPDAT0',CALF(1,2),NWNAM,'MIXED')
      CALL VBLANK(CALF(1,3),NWNAM)
      CALL FFKEY('BUPDAT1',CALF(1,3),NWNAM,'MIXED')
      CALL FFGO
C... Convert hollerith to character
      CALL UHTOC(CALF,NBYTEW,CCALF,NAMLEN*3)
      CALL UHTOC(HBANK,NBYTEW,CBANK,NAMLEN)
      CALL UHTOC(ZBOSF,NBYTEW,CZBOSF,NAMLEN)
      CALL UHTOC(ZE4VF,NBYTEW,CZE4VF,NAMLEN)
      CALL UHTOC(SVBOSF,NBYTEW,CSVBOSF,NAMLEN)
      CALL UHTOC(BANKF,NBYTEW,CBANKF,NAMLEN)
C... Check some parameters
      IEVLIM=MAX(0,IEVLIM)
      IWZMAX=MAX(0,IWZMAX)
      IWRMAX=MAX(0,IWRMAX)
      ISCIP=MAX(0,ISCIP)
      IF( IEVLIM.EQ.0 ) IEVLIM=999999
      IF( IWZMAX.EQ.0 ) IWZMAX=999999
      IF( IWRMAX.EQ.0 ) IWRMAX=999999
C                                           I/O UNIT SPECIFICATION (reorganized)
*PMF      CALL DDCHA( DDIN, HDSN, HERR, HVOL )
*PMF       WRITE(6,9111) HDSN, HVOL
*PMF  9111 FORMAT(/'      INPUT IS FROM DSN=',22A2,' VOL=',3A2)
*PMF       IF( IWUNIT.LE.0 ) GO TO 10
*PMF          CALL DDCHA( DDOU, HDSN, HERR, HVOL )
*PMF          WRITE(6,9112) HDSN, HVOL
*PMF  9112    FORMAT(/'      OUTPUT IS TO  DSN=',22A2,' VOL=',3A2)
*PMF    10 CONTINUE
C
*PMF       IF( IUNZE4.LE.0 ) GO TO 20
*PMF          CALL DDCHA( DDZE, HDSN, HERR, HVOL )
*PMF          WRITE(6,9122) HDSN, HVOL
*PMF  9122    FORMAT(/' ZE4V OUTPUT IS TO  DSN=',22A2,' VOL=',3A2/)
*PMF    20 CONTINUE

C... Input file with JADE events in BOS format
      INQUIRE(FILE=CSVBOSF,EXIST=LEXIST)
      IF( LEXIST ) THEN
         OPEN(IUNIT,FILE=CSVBOSF,STATUS='UNKNOWN',FORM='UNFORMATTED')
      ELSE
         WRITE(*,'(A)') 'ZE4VJB: Input BOS file does not exist!'
         WRITE(*,'(A)') '... will stop now!'
         GOTO 9999
      ENDIF
      OPEN(IUNIT,FILE=CSVBOSF,STATUS='OLD',FORM='UNFORMATTED')
C... Calibration files
      DO I=1,3
         CCALFU=CCALF(I)
         CALL CLTOU(CCALFU)
         IF( I.EQ.1 ) LEX(I)=(INDEX(CCALFU,'AUPDAT1').NE.0)
         IF( I.EQ.2 ) LEX(I)=(INDEX(CCALFU,'BUPDAT0').NE.0)
         IF( I.EQ.3 ) LEX(I)=(INDEX(CCALFU,'BUPDAT1').NE.0)
         IF( LEX(I) ) INQUIRE(FILE=CCALF(I),EXIST=LEX(I))
      ENDDO
C  - Get constants from AUPDAT1
      IF( LEX(1) ) THEN
      OPEN(LUNITA(2),FILE=CCALF(1),STATUS='UNKNOWN',FORM='UNFORMATTED')
      GOTO 5
      ENDIF
C  - Get constants from BUPDAT0 and/or BUPDAT1
      IF( LEX(2) )
     >     OPEN(LUNITA(1),FILE=CCALF(2),STATUS='OLD',FORM='UNFORMATTED')
      IF( LEX(3) )
     >     OPEN(LUNITA(2),FILE=CCALF(3),STATUS='OLD',FORM='UNFORMATTED')
      IF( .NOT.( LEX(2) .OR. LEX(3) ) ) THEN
         WRITE(*,'(A)') 'ZE4VJB: No calibration files specified!'
         WRITE(*,'(A)') '... will stop now!'
         GOTO 9999
      ENDIF
C... Output file with compressed events in ZE4V format
 5    OPEN(IUNZE4,FILE=CZE4VF,STATUS='UNKNOWN',FORM='UNFORMATTED')
C... Output file with complete BOS events
      OPEN(JUNIT,FILE=CZBOSF,STATUS='UNKNOWN',FORM='UNFORMATTED')
C... Output file with BOS bank contents in readable ASCII format
      IF(LBANK)
     >     OPEN(IOBANK,FILE=CBANKF,STATUS='UNKNOWN',FORM='FORMATTED')
C... Initialize random number generator
      WRITE(*,FMT='(/,120(''=''))')
      IF( .NOT. LSTART ) CALL MCRAND('R',CSEEDF,0,0,IERR)
      IF( IERR.LT.0 ) GOTO 9999

      WRITE(*,'(A40)') 'Calibration files used in this run: '
      DO I=1,3
         IF( LEX(I) ) WRITE(*,'(T42,A)') CCALF(I)(1:LENOCC(CCALF(I)))
      ENDDO
      WRITE(*,'(A40,A)') 'Input BOS file is: '
     >     ,CSVBOSF(1:LENOCC(CSVBOSF))
C
      LBMC(1)=1

C ------- PMF 05/06/00 END --------------

      WRITE(6,6001) IEVLIM,IFILMX,IWRMAX,IWZMAX,IDULIM,ISCIP,ITPPK,
     &             ISELFL,ISELMU,ISELEL
 6001 FORMAT(/' MAX # OF EVENTS TO READ   :',I8/
     &         ' MAX # OF INPUTFILES       :',I8/
     &         ' MAX # OF EVENTS ON UNIT 3 :',I8/
     &         ' MAX # OF EVENTS ON UNIT51 :',I8/
     &         ' MAX # OF ZE4V-BANK PRINTS :',I8/
     &         ' INITIAL EVENT SKIP        :',I8/
     &         ' TP/PK-FLAG (1=TP/2=PK)    :',I8/
     &         ' SELECTION (0:ENAB/1:DISAB):',I8/
     &         ' MUON QUALITY SELECTION    :',I8/
     &         ' ELEKTRON SELECTION        :',I8/)
      WRITE(*,FMT='(/,120(''=''))')
C
C                                           INIT BOS AND GEP
      CALL BINT( 80000, 40000, 10000, 0 )
      CALL GEPIC
C
      IFIL = 1
      IEOF = 0
      IWRITE = 0
      IEV = 0
      IZE4V = 0
      IWZE4V = 0
C 
C                                          INITIALISE FEHLER
      CALL FEHLIN
C
  100 IF( JUHR(2) .EQ. 2 ) GO TO 4000
      CALL BREAD( IRUNIT, *1000, *3000 )
CC    WRITE(6,*) '******* READ ENDED NORMALLY FOR EVENT ',IEV
      IEOF = 0
***PMF 06/06/00      IEV = IEV + 1
C                                          LOOK FOR HEAD BANK
      NPHEAD = IW(IBLN('HEAD'))
      IF( NPHEAD.LE.0 ) GO TO 200

      IEV = IEV + 1             ! PMF 06/06/00: increment event counter HERE
 
C                                          INITIAL EVENT SCIP
      IF (IEV.LE.ISCIP) GOTO 2000
C                                          FILL CALIBRATION CONSTANTS
      CALL KLREAD
C                                          FILL ZE4V OVER TP-BANK
C
      IF (ITPPK.EQ.1) THEN
        NPTPEV = IW(IBLN('TPEV'))
        IF( NPTPEV.LE.0 ) GO TO 200
        IF (IZE4V.LE.0) THEN
          CALL ZE4VIN( 1 )
          IZE4V = 1
        ELSE
          CALL ZE4VTP( 1 )
        ENDIF
C                                          FILL ZE4V FROM PATR-BANK
      ELSEIF (ITPPK.EQ.2) THEN
        IF (IZE4V.LE.0) THEN
          CALL ZE4VIN( 1 )
          IZE4V = 1
        ELSE
          CALL ZE4VPK( 1 )
        ENDIF
      ELSE
        WRITE(6,9001) ITPPK
 9001   FORMAT(1X,'FLAG NOT SUPPORTET : ',I4)
        GOTO 8100
      ENDIF
C
      IF (IDUMP.LE.IDULIM) THEN
        CALL ZE4VDP
        IDUMP = IDUMP + 1
      ENDIF
  200 CONTINUE
C
C                                          WRITE WHOLE EVENT
      IF( IWUNIT .GT. 0 .AND. IWRITE .LT. IWRMAX ) THEN
        IWRITE = IWRITE + 1
        CALL BSLW
        CALL BWRITE( IWUNIT )
C PMF 05/06/00: Write whole event out in readable format
        IF( LBANK ) THEN
           IHEAD=IW(IBLN('HEAD'))
           IEVT=HW(IHEAD*2+11)
           WRITE(IOBANK,'(2X,A,6I8)') 'Date',(HW(IHEAD*2+I),I=3,8)
           WRITE(IOBANK,'(3(2x,A,I8))') 'Run',HW(IHEAD*2+10)
     +          ,' Event',HW(IHEAD*2+11),' Type:',HW(IHEAD*2+12) 
           WRITE(IOBANK,'(2X,A,I8)') 'Ebeam',HW(IHEAD*2+29)
           CALL SHOWB(IOBANK,CBANK)
        ENDIF
      ENDIF
C
C                                          SCIP ZE4V WRITE IF MC RECORD
      IF( NPHEAD.LE.0 ) GO TO 2000
C                                          WRITE ZE4V BANK
      IF( IUNZE4 .GT. 0 .AND. IWZE4V .LT. IWZMAX ) THEN
        IWZE4V = IWZE4V + 1
C                                          EVENT SELECTION
        IACCFL=ISELFL
        NPZE4V=IW(IBLN('ZE4V'))
        IF (NPZE4V.GT.0) THEN
          MAXTR = HW(NPZE4V*2 + 6)
          LT = HW(NPZE4V*2 + 5)
          LTCH = HW(NPZE4V*2 + 7)
          LTNE = HW(NPZE4V*2 + 9)
          LTRE = HW(NPZE4V*2 + 11)
          NPOINT = NPZE4V + HW(NPZE4V*2 + 1)
CC      WRITE (6,*) 'EVENT :',IEV,'TRACKS :',MAXTR
          DO 111 ITR= 1, MAXTR
            IF (HW(NPOINT*2+18).EQ.1) THEN
              IF (IW(NPOINT+LT+12).GE.ISELMU.AND.ISELMU.GT.0) IACCFL=1
CC      WRITE (6,*) 'ITR,NPOINT,IACCFL,IW(NPOINT+LT+12) :',
CC   &               ITR,NPOINT,IACCFL,IW(NPOINT+LT+12)
              NPOINT = NPOINT + LTCH
            ELSEIF (HW(NPOINT*2+18).EQ.0) THEN
              NPOINT = NPOINT + LTNE
            ELSEIF (HW(NPOINT*2+18).EQ.2) THEN
              NPOINT = NPOINT + LTRE
            ENDIF
            NPOINT = NPOINT + LT
 111      CONTINUE
        ENDIF
C                                          FORCED ACCEPT OF FIRST EVENT
        IF (IW(IBLN('ZEHD')).GT.0) IACCFL=1
C                                          SCIP REJECTED EVENTS
        IF (IACCFL.LE.0) GOTO 2000
CC      WRITE (6,*) ' *******  EVENT ACCEPTED ***********',IEV
        CALL BMLT( 1, 'ZE4V' ) ! PMF 28/01/00:  CALL BMLT( 3, 'ZEHDZE4VPALL' )
CC      CALL BPRL(IDULIM)
        CALL BWRITE( IUNZE4 )
      ENDIF
      GO TO 2000
C
C
C                                           ERRORS
 1000 CONTINUE
      CALL JOBFIN( 3, IEV, *1100 )
 1100 IF( IEOF .NE. 0 ) GO TO 8000
C
C
 2000 CONTINUE
      CALL BSLT
      CALL BDLG

      IF( MOD(IEV,50).EQ.0 )
     >     WRITE(*,'(''ZE4VJB: event numbers: '
     >     //'read event / written ZE4V record / written BOS event: '''
     > //',I8,''  /'',I8,''  /'',I8)') IEV,IWZE4V,IWRITE

      IF( IEV .LT. IEVLIM ) GO TO 100
      CALL JOBFIN( 4, IEV, *8100 )
C
C                                           EOF ON IRUNIT
 3000 IF( IFIL .GE. IFILMX .OR. IEOF.NE.0 )  GO TO 8000
      IFIL = IFIL + 1
      IEOF = 1
      IDDIN(2) = IDDIN(2) + 1
      CALL DDCHA( DDIN, HDSN, HERR, HVOL )
      IF( HERR .NE. 0 ) GO TO 8000
      CALL BDLS( '+BUF', IRUNIT )
      WRITE(6,9104) IEV, IFIL
 9104 FORMAT(' +++++ AFTER',I6,' EVENTS FILE NUMBER CHANGED TO',I4,' +++
     *++')
      WRITE(6,9113) HDSN, HVOL
 9113 FORMAT(/' +++++ INPUT CONTINUES FROM DSN=',22A2,' VOL=',3A2)
      GO TO 100
C
C                                           TIME OUT
 4000 CALL JOBFIN( 2, IEV, *8100 )
C
C                                           END OF JOB
 8000 CONTINUE
      CALL JOBFIN( 1, IEV, *8100 )
 8100 CONTINUE
C                                           MCREDU STATISTICS
      CALL FEHLPR
      CALL EAFLDP               ! PMF 10/12/99: adopted from 'ze4vpkmn.for'
      CALL MCRDFL
      CALL BSTA
      CALL GEPW
C PMF: Save current random number sequence
      WRITE(*,FMT='(/,120(''=''))')
      CALL MCRAND('W',CSEEDF,ISCIP+1,IEV,IERR)
C PMF: Some output info
      WRITE(*,'(/,A,/,25(''-''))') 'ZE4VJB: I/O information:'
C      WRITE(*,'(A35,A)') 'Output BOS banks to: '
C     >     ,CZBOSF(1:LENOCC(CZBOSF))
      WRITE(*,'(A35,A)') 'Input BOS file was: '
     >     ,CSVBOSF(1:LENOCC(CSVBOSF))
      WRITE(*,'(A35,I8)') 'First processed event was: ',ISCIP+1
      WRITE(*,'(A35,I8)') 'Last processed event was: ',IEV
      WRITE(*,'(A35,I8)') 'Number of written ZE4V records: ',IWZE4V
      WRITE(*,'(A35,I8)') 'Number of written events: ',IWRITE
      WRITE(*,'(A35)') 'Calibration file used: '
      DO I=1,3
         IF( LEX(I) ) WRITE(*,'(T37,A)') CCALF(I)(1:LENOCC(CCALF(I)))
      ENDDO
      WRITE(*,'(A35,A)') 'Output BOS banks to: '
     >     ,CZBOSF(1:LENOCC(CZBOSF))
      WRITE(*,'(A35,A)') 'Output compressed ZE4V events to: '
     >     ,CZE4VF(1:LENOCC(CZE4VF))
      IF( LBANK ) THEN 
         WRITE(*,'(A35,A)') 
     >     'Output readable bank contents to: '
     >     ,CBANKF(1:LENOCC(CBANKF))
         WRITE(*,'(A35,A)') 'Printed BOS banks: ',CBANK(1:LENOCC(CBANK))
      ENDIF
C
      IF( ISCIP .GE. IEV ) WRITE(*,'(/,A)')
     >   'ZE4VJB: WARNING!!! Number of first event to be reconstructed'
     >   //' exceeds number of events contained in the input file!'
C
      WRITE(*,FMT='(/,120(''=''))')
C
 9999 STOP
      END

C   12/11/81            MEMBER NAME  MUCONR   (JADEMUS)     FORTRAN
C   13/08/81 108132002  MEMBER NAME  MUCONR   (JADEMUS1)    FORTRAN
C   25/03/81            TAKEN FROM:  MUCONR   (F22BOW.MUCAL.S)
C   26/11/79            TAKEN FROM:  MUCONR   (JADEMUS1)
C
C NEW VERSION 22.00 25/03/81 C. BOWDERY :GETS LUNIN FROM ARGUMENT RATHER
C                                       :THAN COMMON/CMULUN/. ADD HERR
C                                       :ERROR FLAG AND USE MUERRY.
C      CHANGE 09.48 10/09/80 J. ALLISON :TO REPLACE WRITE'S BY MUMESS
C
      SUBROUTINE MUCONR(LUNIN,HERR)
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C
C MUCONR READS CALIB. DATA INTO /BCS/ AND THEN CALLS MUCON AND MUREG TO
C MOVE IT INTO /CALIBR/ AND /CMUREG/.  IT TAKES CARE OF BOS LISTS.
C HERR = 0 NORMAL RETURN  ; = 1 BOS READ ERROR ; = 2 END-OF-DATA ERROR
C      =-1 WARNING: NO MUON CALIBRATION READ
C-----------------------------------------------------------------------
      HERR=0
      CALL MUMESS('MUCONR',LUNIN,'=LOGICAL UNIT OF MU CALIB DATASET.^')
      IF(LUNIN.GT.0)GO TO 1
        CALL MUMESS('MUCONR',-1,'NO MUON CALIBRATION READ^')
        HERR=-1
        RETURN
C
C-----------------------------------------------------------------------
C
C            ----> PRESERVE SPECIAL LIST.
 1    CALL BSLS(1)
C            ----> READ CALIBRATION DATA RECORD.
C
      CALL BREAD (LUNIN,&10,&20)
C
C            ----> MOVE FROM /BCS/ TO /CALIBR/ BY CALLING MUCON.
      CALL MUCON
C            ----> UPDATE COMMON/CMUREG/.
      CALL MUREG(0)
C            ----> MAKE CURRENT LIST EQUAL TO LIST OF BANKS JUST READ IN
      CALL BSLT
C            ----> DELETE BANKS IN CURRENT LIST.
      CALL BDLG
C            ----> CLEAR SPECIAL LIST.
      CALL BSLC
C            ----> RESTORE SPECIAL LIST.
      CALL BSLR(1)
C            ----> REWIND UNIT LUNIN SO THAT IT CAN BE RE-READ NEXT TIME
      REWIND LUNIN
      RETURN
C
C-----------------------------------------------------------------------
C
C                  ERROR CONDITIONS.
C
 10   CALL MUERRY('MUCONR',1,'ERROR READING MU  CALIBRATION DATA. DS HAS
     + NO OR INVALID BOS BANK(S)^')
      HERR=1
      RETURN
C
 20   CALL MUERRY('MUCONR',2,'END-OF-DATA ERROR ON READING MU CALIB. EMP
     +TY,TOO SHORT OR NON-BOS DS^')
      HERR=2
      RETURN
      END

C   01/05/96 605011927  MEMBER NAME  MANUAL   (BOSLIB.S) M  FVS
C
C               BBBBBB      OOOOO      SSSSS
C               B     B    O     O    S     S
C               B     B    O     O    S
C               BBBBBB     O     O     SSSSS
C               B     B    O     O          S
C               B     B    O     O    S     S
C               BBBBBB      OOOOO      SSSSS
C
C               ======== M A N U A L ========
C
C
C     -----------------------------------------------------
C     BANK ORGANISATION SYSTEM                      - BOS -
C     -----------------------------------------------------
C           DYNAMIC STORAGE ORGANISATION WITH FORTRAN
C                        1979 VERSION
C
C
C
C
C     AUTHOR  -  V.BLOBEL
C                II.INSTITUT FUER EXP.PHYSIK
C                UNIVERSITY OF HAMBURG   AND   DESY
C
C
C
C
C             ABSTRACT
C             ========
C             THE BOS SYSTEM AND ITS SUBSYSTEM SBOS
C             ALLOW THE EFFICIENT MANAGEMENT OF DATA
C             ARRAYS IN MEMORY AND ON MASS STORAGE
C             DEVICES. THE SYSTEMS ARE DEVELOPPED
C             ESPECIALLY FOR THE USE IN THE ANALYSIS
C             OF HIGH ENERGY PHYSICS EXPERIMENTS.
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C         TABLE OF CONTENT                             PAGE
C     -----------------------------------------------------
C
C
C
C     1.  INTRODUCTION                                    4
C
C     2.  CREATION OF BANKS                               9
C         2.1 CREATION OF A BANK
C         2.2 CHANGING THE LENGTH OF A BANK
C         2.3 STORAGE OF DATA IN A BANK
C         2.4 RENAMING A BANK
C         2.5 CALL OF THE PREVIOUS VERSION
C
C     3.  LOCATING OF BANKS                              12
C         3.1 LOCATING A BANK
C         3.2 LOCATING ALL BANKS OF THE SAME NAME
C         3.3 FASTER METHODS
C
C     4.  SETS OF BANKS                                  14
C         4.1 THE CURRENT LIST
C         4.2 THE SPECIAL LIST
C
C     5.  PRINTOUT OF BANKS                              18
C         5.1 SINGLE BANKS
C         5.2 SETS OF BANKS
C
C     6.  DELETING BANKS AND GARBAGE COLLECTION          18
C         6.1 SINGLE BANKS
C         6.2 SETS OF BANKS
C         6.3 GARBAGE COLLECTION
C
C     7.  INPUT FROM CARDS                               19
C         7.1 FREE FORMAT
C         7.2 FORMATED
C         7.3 SPECIAL CARDS
C         7.4 EXAMPLE
C
C     8.  UNFORMATED INPUT/OUTPUT OF BANKS               21
C         8.1 STANDARD OUTPUT AND INPUT
C         8.2 OUTPUT MODES AND RECORD TYPES
C         8.3 USER WRITE AND READ STATEMENTS
C         8.4 BUFFER BANKS
C         8.5 STANDARD EVENT READING/WRITING
C
C
C
C
C
C     9.  BANKS ON DIRECT ACCESS DATA SETS               27
C         9.1 INITIALIZATION OF A DADS
C         9.2 STORING AND RETRIEVING BANKS
C         9.3 UNLOADING AND LOADING THE DADS
C         9.4 PROTECTED DADS
C
C     10. PRINTING STATISTIC AND A DUMP                  30
C
C
C     APPENDIX A - THE SBOS SYSTEM                       34
C
C
C         A.1  INITIALIZATION
C         A.2  FUNCTION ILOC
C         A.3  FUNCTION IBLN
C         A.4  SUBROUTINE BMLT
C         A.5  SUBROUTINE BLST
C         A.6  SUBROUTINE BDLM
C         A.7  SUBROUTINE BGAR
C         A.8  SUBROUTINE BSIN
C         A.9  SUBROUTINE BSOUT
C
C
C     APPENDIX B - APPLICATION PROGRAMS                  40
C
C
C         B.1  PRINTOUT AND COMMENTS
C         B.2  COUNT IN A 32768 * 32768 ARRAY
C         B.3  COUNT IN A 256 * 16 ARRAY
C         B.4  HISTOGRAM
C         B.5  CORRELATION PLOT
C         B.6  STORE VECTORS
C         B.7  DETERMINE MEAN VALUES
C         B.8  DETERMINE PEAK VALUES
C         B.9  STORE SINGLE VALUES
C         B.10 BIN DEFINITION
C         B.11 INTERPOLATION OF TABULATED DATA
C         B.12 DETERMINATION OF A LINEAR DEPENDENCE
C         B.13 DETERMINATION OF AN EMPIRICAL FUNCTION
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C     -----------------------------------------------------------------1
C     1.  INTRODUCTION
C
C     LARGE AMOUNT OF DATA ARE TO BE ANALYSED IN HIGH-ENERGY
C     PHYSICS EXPERIMENTS. DATA ON ONE EVENT CONSIST OF DATA
C     FROM SEVERAL SOURCES, E.G. TRACK CHAMBERS, SHOWER COUNTERS
C     AND SCALERS. DURING THE ANALYSIS NEW DATA ARE ADDED
C     BY COMPUTATION, E.G. DATA ON SINGLE TRACKS. ALSO DATA
C     MAY BE COMPRESSED BY DATA REDUCTION PROGRAMS.
C     THE COMPLEXITY OF ANALYSIS DEPENDS VERY MUCH ON THE
C     ORGANISATION OF THE DATA IN STORAGE AND ON MASS STORAGE
C     DEVICES, E.G. TAPES. A FLEXIBLE DATA ORGANISATION
C     SIMPLIFIES THE ANALYSIS.
C     THE SYSTEM DESCRIBED HERE IS DESIGNED ACCORDING TO THE
C     NEEDS OF HIGH-ENERGY PHYSICS EXPERIMENTS. ALL DATA ARE
C     STRUCTURED IN SO CALLED BANKS OF VARIABLE LENGTH. DATA
C     IN ONE BANK REFER E.G. TO A SINGLE PARTICLE TRACK. A
C     BANK HAS TWO IDENTIFIERS NA AND NR, CALLED NAME AND
C     NUMBER. NORMALLY THE IDENTIFIER NA CONSISTS OF UP TO
C     FOUR CHARACTERS, WHILE IDENTIFIER NR IS AN INTEGER.
C
C     ALL BANKS ARE STORED IN A SINGLE COMMON/BCS/IW(NSPACE).
C     AN INDEX IND IS ASSIGNED TO EACH BANK, WHERE IW(IND)=NW
C     CONTAINS THE NUMBER OF DATA WORDS IN THAT BANK. DATA
C     ARE STORED IN IW(IND+1) TO IW(IND+NW). IN ADDITION
C     THERE ARE THREE WORDS CONTAINING NAME, NUMBER AND A
C     POINTER ACCORDING TO THE FOLLOWING SCHEMA.
C
C              I      IW(I)
C          --------   -------------------------------------
C          IND -  3   NA (NAME)
C          IND -  2   NR (NUMBER)
C          IND -  1   POINTER TO NEXT BANK OF SAME NAME
C                     -------------------------------------
C          IND        NW = NUMBER OF DATA WORDS IN THE BANK
C                     -------------------------------------
C          IND +  1   DATA WORD 1
C          IND +  2   DATA WORD 2
C          ...        ...
C          IND + NW   DATA WORD NW
C          --------   -------------------------------------
C
C     NO LIMITATIONS EXIST FOR THE LENGTH OF A SINGLE BANK OR
C     THE NUMBER OF BANKS, EXCEPT FOR THE TOTAL LENGTH OF
C     ALL BANKS.
C     OUTPUT OF SETS OF BANKS IS SIMPLY DONE BY SPECIFYING
C     ALL NAMES OF BANKS, BELONGING TO THE OUTPUT RECORD.
C     THE MAIN ADVANTAGES OF THE SYSTEM ARE -
C             - EFFICIENT USE OF STORAGE
C             - EASY ADDITION OF NEW BANKS
C             - FLEXIBLE INPUT/OUTPUT
C
C
C
C     THIS MANUAL DESCRIBES THE BOS VERSION RELEASED IN THE
C     BEGINNING OF 1979. THE MAIN CHANGES IN THIS VERSION TO
C     THE VERSION DESCRIBED IN THE INTERNAL REPORT DESY F14/76-01
C     ARE INTERNALLY, TO INCREASE THE SPEED ESPECIALLY FOR
C     INPUT AND OUTPUT. ALL CALLS OF THE PREVIOUS VERSION ARE ALSO
C     EXISTING IN THE CURRENT VERSION.
C     THE MAIN CHANGES ARE THE FOLLOWING
C     CHAPTER 2.   DIFFERENT ACTION IN CASE OF ERRORS IN BCRE
C     CHAPTER 4.   ADDITIONAL CALLS FOR LIST HANDLING
C     CHAPTER 6.   MODIFIED RULES FOR INPUT FROM DATA CARDS
C     CHAPTER 8.   NEW MODES FOR OUTPUT (AND INPUT)
C     CHAPTER 9.   NEW SUBROUTINES FOR DIRECT ACCESS DEVICES
C
C
C
C     LIBRARIES. THE SUBPROGRAMS OF THE BANK-SYSTEMS BOS AND
C     SBOS ARE ON THE DESY-NEWLIB LIBRARIES
C              DSN=F1EBLO.BOSLIB.L    (LOAD)
C         AND  DSN=F1EBLO.BOSLIB.S    (SOURCE)
C
C     THE FULL BOS SYSTEM IS DESCRIBED IN CHAPTER 2 - 10. IN
C     APPENDIX A A SMALL SUBSYTEM CALLED SBOS IS DESCRIBED, WHICH
C     HAS A TOTAL PROGRAM LENGTH OF BELOW 10 K BYTES. THIS SMALLER
C     SYSTEM IS FULLY COMPATIBLE WITH THE FULL SYSTEM, SUBROUTINES
C     FROM BOTH SYSTEMS MAY BE USED TOGETHER. THE SBOS SYSTEM IS
C     DEVELOPPED MAINLY FOR ONLINE APPLICATIONS. NEARLY ALL
C     FUNCTIONS DESCRIBED IN CHAPTER 2, 3, 4, 6 AND SOME OF THE
C     FUNCTIONS DESCRIBED IN CHAPTER 8 ARE POSSIBLE.
C     IN APPENDIX B APPLICATION PROGRAMS ARE DESCRIBED. THEY CAN
C     BE USED FOR COUNTING, MAKING HISTOGRAMS ETC AND MAY BE
C     USEFUL IN THE TESTING PHASE OF ANALYSIS PROGRAMS.
C
C     THE SBOS SYSTEM CONSISTS OF THE FOLLOWING SUBPROGRAMS.
C
C
C           SUBPROGRAM
C
C      0.1  BENT AND BDMPA
C      0.2  ILOC
C      0.3  IBLN                    (IDENTICAL IN BOS)
C      0.4  BMLT                    (IDENTICAL IN BOS)
C      0.5  BLST
C      0.6  BDLM                    (IDENTICAL IN BOS)
C      0.7  BGAR                    (IDENTICAL IN BOS)
C      0.8  BSIN
C      0.9  BOUT
C        +  ENTRIES VZERO, UCOPY AND UCOPY2
C
C     THE BOS SYSTEM (EXCLUDING THE APPLICATION PROGRAMS)
C     CONSISTS OF THE FOLLOWING SUBROUTINES.
C
C           SUBPROGRAM   ENTRIES
C
C      1.1  BINT         BINT1
C      1.2  BDMPA
C      1.3  IBLN         -
C      1.4  BRNM         BSPC
C      1.5  BCRE         -
C      1.6  CCRE         -
C      1.7  BLOC         -
C      1.8  CLOC         -
C      1.9  BCHM         BCHF   BSTR   BMRT
C      1.10 BDAR         -
C      1.11 BPOS         CPOS   BPRL
C      1.12 BNXT         -
C      1.13 CNXT         -
C      1.14 BMLT
C      1.15 BSAW         BDEF   BSAT   BSAD
C      1.15 BDLS         BPRS
C      1.17 BDLM
C      1.18 BDLG         BPRM   BSLW   BSLC   BSLT
C      1.19 BGAR         -
C      1.20 BDMP         BDMPF
C      1.21 BSTA         -
C      1.22 DUMP0C       -
C      1.23 BCHL         BMVE
C      1.24 CCHL         CMVE
C      1.25 BGAC         -
C      1.26 BSLS         BSLR
C      1.27 INDAR
C      + ENTRIES VZERO, UCOPY AND UCOPY2
C      + SUBR. UWP
C      + SUBR. DAY, ITRACE, NTIME FROM DESYLIB
C
C      2.1  BREADC       -
C      2.2  READHL       -
C
C      3.1  BREAD        -
C      3.2  CREAD        -
C      3.3  BWRITE       -
C      3.4  BRDS         -
C      3.5  BWRS         BWRO
C      3.6  BFRD         BFWR
C      3.7  BINP         BFRR
C      3.8  BOUTP        BORDP
C      3.9  BSEQ         BSEW   BSET   BSEL
C      3.10 RDVAR        WRVAR  WRFIX
C      3.11 MSGPR        MSGTXT MSGINT
C
C      4.1  BLOCDA       BDLSDA BCREDA BCHKDA
C      4.2  BINLDA       -
C      4.3  BLOADA       -
C      4.4  PODA         CHDIR
C      4.5  DADA         -
C      4.6  RDDA         WRDA   RDSQ   WRSQ
C      4.7  BPASDA       -
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C     INITIALIZATION IS DONE BY THE FOLLOWING STATEMENTS.
C
C     COMMON/BCS/IW(NSPACE)
C     REAL RW(NSPACE)
C     EQUIVALENCE (IW(1),RW(1))
C        WHERE NSPACE = INTEGER CONSTANT
C
C               ------ ---- ---- ----
C     CALL BINT(NSPACE,NREC,NDMP,NADD)
C
C
C        WHERE NREC  = MAX.NO OF WORDS IN A OUTPUT RECORD,
C                      IF BWRO IS NOT CALLED (SEE CH. 8.2)
C                      (DEFAULT 4000)
C              NDMP  = NR OF WORDS, PRINTED IN A DUMP
C                      (DEFAULT  500)
C              NADD  = NR OF WORDS FOR LOW PRIORITY BANKS
C                      (DEFAULT IS 10 PERCENT OF NSPACE)
C
C
C     HERE AND IN THE FOLLOWING INPUT ARGUMENTS HAVE
C     A LINE ABOVE, OUTPUT ARGUMENTS HAVE A LINE BELOW.
C     ARGUMENTS, WHICH ARE CHANGED BY THE PROGRAM, HAVE A LINE
C     ABOVE AND BELOW. THE ARGUMENT IER IN SOME CALLS IS AN
C     ERROR CODE WITH THE VALUE ZERO, IF NO ERROR WAS DETECTED.
C
C     THE DEFAULT VALUES ARE USED, IF THE ARGUMENTS ARE ZERO.
C     IF ERROR CONDITIONS E.G. ILLEGAL VALUES OF POINTERS ARE
C     DETECTED, THE DUMP PROGRAM BDMP IS CALLED AND THE PROGRAM
C     IS STOPPED WITH CALL ABEND. THE OUTPUT OF THE DUMP PROGRAM
C     IS EXPLAINED IN CH. 10.
C
C
C     BANKS WITH NAMES, WHERE THE FOURTH CHARACTER IS A '*',
C     E.G. 'HST*', ARE CONSIDERED AS BANKS OF LOW PRIORITY.
C     THEY CAN ONLY BE CREATED UP TO A TOTAL AMOUNT OF
C     NADD WORDS.
C
C     NAMES WITH CHARACTER '+' AS THE FIRST CHARACTER,
C     E.G. '+BUF', ARE NAMES OF SYSTEM BANKS. THE USER SHOULD
C     NOT USE NAMES STARTING WITH THE CHARACTER '+'.
C
C
C
C     OPTIONALLY THE USER CAN CALL BINT1 IMMEDIATELY AFTER
C     BINT, TO CHANGE SOME DEFAULT PARAMETERS OF THE SYSTEM.
C
C                --- --- --- ---
C     CALL BINT1(NNA,NNL,NNE,NNP)
C
C        WHERE NNA = MAX. NR OF DIFFERENT NAMES      (DEFAULT 200)
C              NNL = MAX. NR OF ENTRIES IN LISTS     (DEFAULT 100)
C              NNE = MAX. NR OF READ ERRORS ALLOWED  (DEFAULT  10)
C              NNP = MAX. NR OF LISTINGS FOR RECORDS
C                    WITH CERTAIN TYPES OF INPUT
C                    BANK ERRORS                     (DEFAULT   2)
C
C     THE DEFAULT VALUES ARE USED, IF BINT1 IS NOT CALLED. ABOUT
C     5*NNA + 3*NNL WORDS IN THE COMMON/BCS/ ARE USED FOR INTERNAL
C     TABLES (1312 WORDS FOR DEFAULT VALUES).
C
C     SOME INFORMATION ON THE FREE SPACE IN COMMON/BCS/ ETC
C     CAN BE OBTAINED BY
C
C     CALL BSPC(IND,NUS,NAS,NSL)
C               --- --- --- ---
C
C        WHERE IND = INDEX OF FIRST UNUSED WORD BEHIND THE BANKS
C              NUS = NR OF UNUSED WORDS BEHIND BANKS
C              NAS = NR OF ADDITIONAL FREE WORDS FROM DELETED BANKS
C              NSL = NR OF ENTRIES IN THE SPECIAL LIST
C
C     THE UNUSED SPACE  IW(IND) . . . IW(IND+NUS)  CAN BE USED
C     AS AN INTERMEDIATE STORAGE BETWEEN CALLS TO BOS SYSTEM
C     PROGRAMS.
C
C     -----------------------------------------------------------------2
C     2.  CREATION OF BANKS
C
C     2.1  CREATION OF A BANK
C
C                   -- -- --                               -- -- --
C     CALL BCRE(IND,NA,NR,NW,&S1,IER)        CALL CCRE(IND,NA,NR,NW,IER)
C               ---          --- ---                   ---          ---
C
C        WHERE NA = NAME OF THE BANK
C              NR = NUMBER OF THE BANK
C              NW = NUMBER OF WORDS OF THE BANK (NW.GE.0)
C             IND = INDEX OF BANK (IER=1, IF BANK ALREADY EXISTING)
C        ALL WORDS OF THE BANK ARE SET TO ZERO.
C
C
C     SPECIAL CONDITIONS
C                              BCRE              CCRE
C
C     BANK ALREADY PRESENT *)  IER=1             IER=1
C                              NORMAL RETURN
C
C     NOT ENOUGH SPACE         IND=0             IND=0
C                              IER=2             IER=2
C                              RETURN 1
C
C     *) IF THE ARGUMENT NW IS LARGER THAN THE LENGTH OF THE
C     EXISTING BANK, THE LENGTH OF THE BANK IS CHANGED TO THE
C     LENGTH GIVEN IN THE ARGUMENT, ALL ADDITIONAL WORDS ARE
C     SET TO ZERO (THE BANK IS MOVED TO THE END OF THE USED
C     BANK SPACE).
C     NOTE, THAT IN THE PREVIOUS BOS-VERSION THE LENGTH WAS
C     LEFT UNCHANGED.
C
C
C     IF THE NEW CREATED BANK BELONGS TO AN EVENT IN AN
C     EVENT-BY-EVENT PROCESSING PROGRAM, THE NAME OF THE
C     CREATED BANK SHOULD BE ADDED TO THE SPECIAL LIST (SEE
C     CH. 4).
C     THE BANK NAME IS ADDED TO THE SPECIAL LIST BY ONE OF
C     THE STATEMENTS
C         CALL BSAW(1,NA)     OR    BSAT(1,NA).
C     BSAT HAS TO BE USED, IF THE BANK SHOULD NOT BE ADDED
C     TO THE EVENT IN AN OUTPUT RECORD, BUT HAS TO BE DELETED
C     AFTER PROCESSING THE EVENT.
C
C
C
C
C
C
C
C     2.2  CHANGING THE LENGTH OF A BANK
C
C
C               --- --
C     CALL BCHM(IND,NW,IER)
C               ---    ---
C
C        WHERE NW = CHANGE IN LENGTH OF THE BANK (NW.LT.0 VALID)
C             IND = INDEX OF THE BANK TO BE CHANGED IN LENGTH
C
C     IF POSSIBLE, THE LENGTH OF THE BANK IS CHANGED WITHOUT MOVING
C     THE BANK. FOR NW=0, THE BANK IS MOVED TO THE END.
C
C
C     A BANK LENGTH OF AT LEAST NW WORDS IS OBTAINED BY THE FOLLOWING
C     CALL.
C               --- --
C     CALL BCHF(IND,NW,IER)
C               ---    ---
C
C        WHERE NW = MINIMUM LENGTH OF THE BANK
C             IND = INDEX OF THE BANK
C
C     THE BANK LENGTH IS CHANGED, IF THE ACTUAL LENGTH IS LESS
C     THAN NW.
C
C     ADDITIONAL WORDS OF THE BANK ARE NOT SET TO ZERO (SEE REMARK
C     IN CH. 2.1).
C
C
C     SPECIAL CONDITIONS
C                                               BCHM,BCHF
C
C     WRONG INDEX IND IN ARGUMENT, OR            IER = 1
C     BANK LENGTH WILL BECOME NEGATIVE
C
C     NOT ENOUGH SPACE                           IER = 2
C
C
C
C     2.3  STORAGE OF DATA IN A BANK
C
C               --- -- --
C     CALL BSTR(IND,JW,NW)
C
C
C     WHERE IND = INDEX
C           JW  = ARRAY TO BE STORED
C           NW  = LENGTH OF JW
C
C     JW(1) IS STORED IN IW(IND+1) ETC.
C
C
C
C
C
C
C     2.4  RENAMING A BANK
C
C     THE NAME AND NR OF A BANK CAN BE CHANGED (IN PLACE).
C
C               ------ ----- ------ -----
C     CALL BRNM(NAMOLD,NROLD,NAMNEW,NRNEW)
C
C        WHERE NAMOLD, NROLD = NAME AND NR OF AN EXISTING BANK
C              NAMNEW, NRNEW = NEW NAME AND NR OF THE BANK
C
C
C
C     2.5  CALLS OF THE PREVIOUS VERSION
C
C
C
C               --                                   --
C     CALL BCHL(NW,&S1)                    CALL CCHL(NW,IER)
C                  ---                                  ---
C
C        WHERE NW = CHANGE IN LENGTH OF THE BANK (NW.LT.0 VALID)
C
C
C
C     NOTE, THAT ONLY THE LENGTH OF THE LAST CREATED BANK CAN
C     BE CHANGED DIRECTLY. A SAFER WAY OF CHANGING THE LENGTH
C     OF A BANK IS BY USING BCHM OR BCHF (SEE CH. 2.2).
C
C               ---                                     ---
C     CALL BMVE(IND,&S1)                      CALL CMVE(IND,IER)
C               --- ---                                 --- ---
C        WHERE IND = INDEX OF BANK TO BE MOVED
C     THE BANK IS MOVED TO THE END OF THE USED STORAGE, IND
C     IS CHANGED. AFTER BMVE THE LENGTH OF THE BANK CAN BE CHANGED
C     BY BCHL.
C
C     SPECIAL CONDITIONS
C                                  BCHL,BMVE   CCHL,CMVE
C     NOT ENOUGH SPACE              RETURN 1     IER=2
C
C
C
C
C
C
C
C
C
C
C
C
C
C     -----------------------------------------------------------------3
C     3.  LOCATING OF BANKS
C
C     3.1  LOCATING A BANK
C
C
C                   -- --                                     -- --
C     CALL BLOC(IND,NA,NR,&S1)                  CALL CLOC(IND,NA,NR)
C               ---       ---                             ---
C
C        WHERE NA = NAME OF THE BANK
C              NR = NUMBER OF THE BANK
C              IND = INDEX OF THE BANK (NORMAL RETURN)
C
C     SPECIAL CONDITIONS
C                           BLOC             CLOC
C
C     BANK NOT EXISTING     IND=0            IND=0
C                           RETURN 1
C
C
C     3.2  LOCATING ALL BANKS WITH THE SAME NAME
C
C
C     LOCATING OF ALL BANKS OF A GIVEN NAME IN ASCENDING ORDER
C     OF NR IS DONE IN THE FOLLOWING WAY.
C
C               ----                               ----
C     CALL BPOS(NAME)                    CALL CPOS(NAME)
C
C        WHERE NAME = NAME OF THE BANKS
C
C               ---                                ---
C     CALL BNXT(IND,&S1)                 CALL CNXT(IND)
C               --- ---                            ---
C
C        WHERE IND = INDEX OF NEXT BANK OF THE SAME NAME
C
C     SPECIAL CONDITION
C                              BNXT             CNXT
C
C     NO FURTHER BANK          IND=0            IND=0
C                              RETURN 1
C
C     EXAMPLE FOR A LOOP ON ALL BANKS OF THE SAME NAME
C        CALL BPOS(NAME)
C     10 CALL BNXT(IND,&20)
C        . . .
C        GOTO 10
C     20 CONTINUE
C
C     BPOS/BNXT-LOOPS MAY BE NESTED. BNXT MAY ALSO BE USED
C     WITHOUT BPOS TO OBTAIN THE INDEX OF THE NEXT BANK OF
C     THE SAME NAME. THE INDEX IND IS A INPUT- AND OUTPUT-
C     ARGUMENT IN BNXT, EXCEPT FOR THE FIRST CALL AFTER THE
C     CALL OF BPOS, WHERE IT IS AN OUTPUT-ARGUMENT.
C
C
C
C     LOCATING ALL BANKS OF A GIVEN NAME CAN ALSO BE DONE USING
C     SUBROUTINE BDAR.
C
C                ----        ----
C     CALL  BDAR(NAME,N,INDA,NLIM)
C                     - ----
C
C        WHERE NAME = NAME OF THE BANKS
C              NLIM = NR.OF WORDS OF ARRAY INDA( )
C        INDA( ) = ARRAY CONTAING N INDICES (N.LE.NLIM)
C
C     EXAMPLE, EQUIVALENT TO THE ONE IN 3.2
C        INTEGER INDA(20)
C        CALL BDAR(NAME,N,INDA,20)
C        DO 20 I=1,N
C        IND=INDA(I)
C        . . .
C     20 CONTINUE
C
C
C
C
C     3.3  FASTER METHODS
C
C
C     TO LOCATE BANKS, FASTER METHODS CAN BE USED THAN THE METHODS
C     DESCRIBED ABOVE. THE DECREASE OF TIME IS OBTAINED BY AVOIDING
C     ANY SUBROUTINE CALLS.
C
C     THE INDEX IND OF THE FIRST BANK OF A GIVEN NAME (THE BANK WITH
C     THE SMALLEST VALUE OF NR) IS STORED IN ONE OF THE LOCATIONS
C     IW(1) TO IW(NAMAX), WHERE NAMAX IS THE MAXIMUM NR OF DIFFERENT
C     NAMES. THE INDEX I OF THIS LOCATION IS FIXED DURING THE JOB.
C     IT CAN BE OBTAINED BY THE FUNCTION IBLN, E.G.
C                  I = IBLN(NAME)
C     THUS IW(I) IS ZERO, IF NO BANK WITH THAT NAME EXISTS. IF
C                IND = IW(I)
C     IS NOT EQUAL TO ZERO, THEN IND IS THE INDEX OF THE
C     FIRST BANK FOR THAT NAME. THE POINTER TO THE NEXT BANK
C     OF THE SAME NAME (NEXT LARGER VALUE OF NR) IS STORED
C     IN THE LOCATION IW(IND-1), THUS CAN BE OBTAINED BY THE
C     STATEMENT
C                IND = IW(IND-1)
C
C
C
C
C
C
C
C
C
C
C
C
C     BELOW THE PROGRAMMING IS DESCRIBED FOR THE CASE, WHERE A LOOP
C     ON ALL BANKS OF THE SAME NAME IS EXECUTED. A LOCAL VARIABLE
C     INDF IS INITIALIZED TO ZERO BY A DATA STATEMENT, AND IS
C     DEFINED AS
C               INDF = IBLN(NAME)+1
C     AT THE FIRST EXECUTION OF THE LOOP.
C
C           DATA INDF/0/
C           IF(INDF.EQ.0) INDF=IBLN(NAME)+1
C           IND=INDF
C        10 IND=IW(IND-1)                         CALL BPOS(NAME)
C           IF(IND.EQ.0)    GOTO 30            10 CALL BNXT(IND,&30)
C      C    NEXT BANK FOUND                       . . .
C           . . .                                 . . .
C           . . .                                 . . .
C           GOTO 10                               GOTO 10
C      C    END OF LOOP                        30 . . .
C        30 . . .
C
C
C     BELOW THE PROGRAMMING IS DESCRIBED FOR THE CASE, WHERE A
C     CERTAIN BANK (NAME,NR) HAS TO BE LOCATED.
C
C
C           DATA INDF/0/
C           IF(INDF.EQ.0) INDF=IBLN(NAME)+1
C           IND=INDF
C        10 IND=IW(IND-1)
C           IF(IND.EQ.0)    GOTO 30
C           IF(IW(IND-2)-NR) 10,20,30         CALL BLOC(IND,NAME,NR,&30)
C      C    BANK (NAME,NR) FOUND              . . .
C        20 . . .
C
C      C    BANK NOT FOUND
C        30 . . .                          30 . . .
C
C     -----------------------------------------------------------------4
C     4.  SETS OF BANKS
C
C     SEVERAL SUBROUTINES WORK ON SET OF BANKS. THESE SETS ARE
C     DEFINED BY DEFINING A LIST OF NAMES, EVERY BANK WITH A NAME,
C     WHICH IS CONTAINED IN THE LIST, BELONGS TO THE SET OF BANKS.
C     THERE ARE TWO LISTS, ONE CALLED THE CURRENT LIST AND THE OTHER
C     THE SPECIAL LIST. THE CURRENT LIST IS USED IN THE SUBROUTINES
C            BDLM AND BDLG      TO DELETE A SET OF BANKS,
C            BPRM               TO PRINT A SET OF BANKS,
C            BWRITE ETC.        TO WRITE A SET OF BANKS (EVENT).
C
C     THE SPECIAL LIST IS DEFINED BY EACH INPUT ROUTINE, IT CONTAINS
C     AFTER THE INPUT OF ONE EVENT ALL NAMES (WITH MARKER EQUAL
C     TO 1) BELONGING TO THAT EVENT, AND IS LATER USED TO WRITE
C     THE BANKS AND TO DELETE THE BANKS. IF NEW BANKS ARE CREATED,
C     THEIR NAMES CAN BE ADDED TO THE SPECIAL LIST.
C
C
C     4.1  THE CURRENT LIST
C
C     THERE ARE THREE CALLS TO DEFINE THE CURRENT LIST.
C
C               - ----
C     CALL BMLT(N,LIST)
C
C        WHERE LIST( ) = ARRAY OF N NAMES
C
C
C
C     CALL BSLT
C
C     ALL NAMES OF THE SPECIAL LIST ARE DEFINED AS THE CURRENT LIST.
C
C
C
C     CALL BSLW
C
C     THE NAMES OF THE SPECIAL LIST WITH THE MARKER = 1 ARE DEFINED
C     AS THE CURRENT LIST.
C
C
C
C     THE LATTER TWO CALLS ARE USUALLY USED IN THE FOLLOWING
C     CONNECTION.
C
C     CALL BSLW
C     CALL BWRITE(IUN)      WRITE AN EVENT OF BANKS WITH NAMES OF
C                           THE SPECIAL LIST WITH MARKER +1.
C
C     CALL BSLT
C     CALL BDLG             DELETE ALL BANKS WITH NAMES OF THE
C                           SPECIAL LIST AND MAKE A GARBAGE
C                           COLLECTION.
C
C
C
C     THE CURRENT LIST OF NAMES CAN BE STORED IN AN USER DEFINED
C     ARRAY BY THE CALL
C
C                      -----
C     CALL BMRT(N,LIST,NLIST)
C
C        WHERE LIST( ) = ARRAY OF LENGTH NLIST
C                    N = NR OF NAMES STORED IN THE LIST
C
C     UP TO NLIST NAMES OF THE CURRENT LIST OF NAMES ARE STORED
C     INTO THE ARRAY LIST( ).
C
C
C
C     4.2  THE SPECIAL LIST
C
C
C                - ----                      - ----
C      CALL BSAT(N,LIST)           CALL BSAW(N,LIST)
C
C
C         WHERE LIST( ) = ARRAY OF N NAMES
C
C     IN BOTH CASES THE NAMES ARE ADDED TO THE SPECIAL LIST
C     (IF NOT ALREADY PRESENT), AND THE MARKER IS SET
C     =0 FOR BSAT AND =1 FOR BSAW.
C
C
C
C               - ----
C     CALL BSAD(N,LIST)
C
C     THE NAMES OF THE LIST ARE DELETED FROM THE SPECIAL LIST.
C
C
C
C
C
C     THERE ARE THREE ADDITIONAL CALLS, WHICH MAY BE USEFUL
C     UNDER SPECIAL CIRCUMSTANCES. THESE CALLS ALLOW TO CLEAR
C     THE SPECIAL LIST, TO SAVE THE SPECIAL LIST AND TO RESTORE
C     THE SAVED SPECIAL LIST.
C
C     CALL BSLC
C
C     THE SPECIAL LIST IS CLEARED (IT WILL CONTAIN NO NAMES).
C
C               --                     --
C     CALL BSLS(IS)          CALL BSLR(IS)
C
C     THE SPECIAL LIST IS SAVED BY BSLS UNDER AN ARBITARY
C     NUMBER IS. BY BSLR THE SAVED LIST IS RESTORED AS THE
C     SPECIAL LIST. THE ROUTINES USE A BANK TO STORE THE
C     SPECIAL LIST.
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C     THE CONNECTION BETWEEN THE TWO LISTS AND THE DIFFERENT
C     CALLS IS ILLUSTRATED IN THE FLOW DIAGRAM BELOW
C
C
C
C
C                        +---------------+
C                        I               I
C                        I SPECIAL LIST  I
C                        I     OF NAMES  I
C                ADDS    I               I
C        BSAW   ->->->->-I->->->-+-<-<-<-I-<-<-<-<-   INPUT ROUTINE
C                CHANGES I       |       I DEFINES
C                        I       V       I
C                        I       |       I
C                        I       V       I
C                ADDS    I       |       I
C        BSAT   ->->->->-I->-+-<-+->-+   I
C                CHANGES I   |       |   I
C                        I   V       V   I
C                        I   |       |   I
C                        +---------------+
C                            |       |
C                            V       V
C                            |       |
C
C          (USUALLY FOR    BSLT    BSLW   (USUALLY FOR
C       DELETING BANKS)                   WRITING BANKS)
C                            |       |
C                            V       V
C                            |DEFINES|
C                            V       V
C                            |       |
C                        +---------------+
C                        I               I
C                        I CURRENT LIST  I
C                        I     OF NAMES  I
C                DEFINES I               I
C        BMLT   ->->->->-I               I
C                        I               I
C                        I               I
C                        I               I
C                        +---------------+
C                                |
C                                V
C                                |
C                                V
C
C                        USED IN BPRM
C                                BDLM, BDLG
C                                OUTPUT ROUTINES
C
C
C
C
C     -----------------------------------------------------------------5
C     5.  PRINTOUT OF BANKS
C
C     5.1  SINGLE BANKS
C
C               -- --
C     CALL BPRS(NA,NR)
C
C
C        WHERE NA = NAME
C              NR = NUMBER OF BANK TO BE PRINTED
C
C
C     5.2  SETS OF BANKS
C
C                                      ---
C     CALL BPRM              CALL BPRL(LIM)
C
C     ALL BANKS OF THE CURRENT LIST OF NAMES ARE PRINTED. THE
C     CALL OF BPRL IS IGNORED AFTER LIM EXECUTIONS.
C
C     THE PRINTING FORMAT OF EACH WORD IS CHOSEN AUTOMATICALLY
C     (TEXT, INTEGER, REAL), NOT ALWAYS CORRECT.
C     -----------------------------------------------------------------6
C     6.  DELETING BANKS AND GARGAGE COLLECTION
C
C
C     6.1  SINGLE BANKS
C
C
C               -- --
C     CALL BDLS(NA,NR)
C
C
C        WHERE NA = NAME
C              NR = NUMBER OF BANK TO BE DELETED
C
C     IF THE DELETED BANK IS THE LAST IN STORAGE, ITS SPACE IS
C     IMMEDIATELY FREE FOR NEW BANKS, OTHERWISE BGAR HAS TO BE CALLED
C
C
C     6.2  SETS OF BANKS
C
C     CALL BDLM                   CALL BDLG
C
C     ALL BANKS OF THE CURRENT LIST OF NAMES ARE DELETED. IN BDLG
C     IN ADDITION A GARBAGE COLLECTION IS DONE.
C     A DELETED BANK IS NO LONGER ACCESSIBLE BY A CALL BLOC. IF THE
C     DELETED BANKS ARE THE LAST BANKS IN STORAGE, THEIR SPACE
C     IS IMMEDIATELY FREE FOR NEW BANKS ALSO FOR BDLM. OTHERWISE
C     THERE HAS TO BE AN EXTRA CALL OF BGAR.
C
C
C     6.3  GARBAGE COLLECTION
C
C     IN A GARBAGE COLLECTION THE ACTIVE (NOT DELETED) BANKS ARE
C     SHIFTED IN STORAGE, IF THERE ARE BANKS DELETED.
C
C
C
C     CALL BGAR(IGA)
C               ---
C
C        IGA = 0 NO GARBAGE COLLECTION DONE (IF NO BANKS WERE DELETED)
C        IGA = 1 GARBAGE COLLECTION DONE
C
C     WARNING. BECAUSE IN A GARBAGE COLLECTION, SOME BANKS (ALL BANKS
C     BEHIND DELETED BANKS) ARE SHIFTED, THE INDICES OF THE BANKS
C     CHANGE. AUTOMATIC GARBAGE COLLECTIONS ARE DONE IN THE INPUT-
C     OUTPUT ROUTINES (SEE 9.)
C
C
C     6.4   CALL OF THE PREVIOUS VERSION
C
C                   --
C     CALL BGAC(IGA,NW)
C               ---
C
C        WHERE NW = NR.OF WORDS OF A NEW BANK
C     NO GARBAGE COLLECTION IS DONE, IF THERE IS SPACE ENOUGH
C     FOR AN ADDITIONAL BANK WITH NW WORDS
C
C
C     -----------------------------------------------------------------7
C     7.  INPUT FROM CARDS
C
C     DATA CAN BE READ FROM CARDS IN FREE FORMAT OR IN A FORMAT GIVEN
C     ON THE CARDS ITSELF, AND STORED IN BANKS. THE LAST 8 COLS OF THE
C     CARDS ARE NOT USED IN FREE FORMAT MODE.
C
C     CALL BREADC
C
C     DATA ARE READ FROM CARDS (UNIT 5) UNTIL DATA END OR A CARD WITH
C     ENDQ IS READ.
C
C
C
C     7.1 FREE FORMAT
C
C     READING A CARD OF THE TYPE
C     NAME A B C . . .
C     CREATES A BANK (NAME,0) WITH DATA A, B ,C . . .
C     A SECOND CARD WITH THE SAME NAME CREATES A BANK (NAME,1) ETC.
C     IF THE FIRST CHARACTER OF NAME IS THE DOLLARSIGN $, THAN
C     THE INPUT IS ACCORDING TO THE MODE DESCRIBED BELOW.
C
C     NAME N / A B C . . .
C     CREATES A BANK (NAME,N) WITH DATA A, B, C . . .
C     A SECOND CARD WITH THE SAME (NAME,N) IS NOT STORED.
C
C     THE BANK NAME  CONSISTS OF THE FIRST FOUR CHARACTERS OF
C     NAME.
C     N, A, B, C, . . . ARE CONSTANTS.
C     INTEGER CONSTANTS ARE TO BE WRITTEN WITHOUT A DOT (.),
C     REAL CONSTANTS WITH DOT (.) AND OPTIONALLY WITH EXPONENT.
C     CONTINUATION CARDS STARTING IMMEDIATELY WITH CONSTANTS ARE
C     ALLOWED. NON-NUMERIC CHARACTERS BETWEEN CONSTANTS ARE
C     IGNORED.
C
C     7.2  FORMATED
C
C     AFTER READING A CARD
C
C     NAME N NW '(FORMAT)
C
C     NW WORDS ARE READ ACCORDING TO THE GIVEN FORMAT FROM CONSECUTIVE
C     CARDS AND STORED IN A BANK (NAME,N). THE FORMAT
C     SHOULD START WITH 1X (SEE EXAMPLE), TO ALLOW ECHO-PRINTOUT
C     WITHOUT LINE SKIPPING.
C
C
C     7.3  SPECIAL CARDS
C
C                                 ACTION
C
C     ENDQ                        BREADC RETURNS
C
C     POFF                        PRINTING OF CARDS IS SWITCHED OFF
C
C     PON                         PRINTING OF CARDS IS SWITCHED ON AGAIN
C
C     UNIT N     (N = INTEGER)    THE NEXT CARDS ARE READ FROM
C                                 UNIT N UNTIL DATA END, THEN AGAIN
C                                 FROM UNIT 5.
C
C
C
C     7.4  EXAMPLE
C
C
C     CONSTANTS 1.7 2.3 7 1.23E-4
C     RUN 2769 / 1.520 16.0
C     0.7 2.0
C     TITL 2000 5 '(1X,5A4)
C      PI+ PI+ PI- PI- PI0
C     ENDQ
C
C
C
C
C     BANKS STORED
C
C     NAME             CONS   RUN    TITL
C     NUMBER              0   2769   2000
C     NR.OF WORDS         4      4      5
C
C     1.DATA WORD       1.7  1.520   PI+
C     2.DATA WORD       2.3   16.0   PI+
C     3.DATA WORD         7    0.7   PI-
C     4.DATA WORD   1.23E-4    2.0   PI-
C     5.DATA WORD                    PI0
C
C     INDICES ARE OBTAINED BY
C     CALL BLOC(IND,'CONS',0,&S1)
C     CALL BLOC(IND,'RUN ',2769,&S1)
C     CALL BLOC(IND,'TITL',2000,&S1)   RESP.
C
C     -----------------------------------------------------------------8
C     8.  UNFORMATED INPUT/OUTPUT OF BANKS
C
C     BANK RECORDS ARE OF THE FORM
C        NTOT, BANK1, BANK2, . . . BANKN
C     WITH NTOT = NR OF WORDS OF ALL BANKS, THE TOTAL NR OF (USED)
C     WORDS IN A RECORD IS THEREFORE NRECL = NTOT +1.
C
C        FIRST WORD IN RECORD   = NTOT
C        NEXT WORD              = NAME
C        NEXT WORD              = NUMBER OF FIRST BANK
C        NEXT WORD              = POINTER (NO MEANING IN RECORD)
C        NEXT WORD              = NR.OF WORDS OF THE FIRST BANK
C        ETC.
C
C
C
C
C     8.1 STANDARD OUTPUT AND INPUT
C
C
C     OUTPUT IS DONE BY FIRST SELECTING THE NAMES OF ALL BANKS
C     TO BE WRITTEN AND THEN BY CALLING THE OUTPUT PROGRAM. THE
C     SET OF BANKS DEFINES ONE EVENT. IF THE EVENT IS WRITTEN,
C     THE ORDER OF THE BANKS IS ALWAYS THE SAME AS WITHIN THE LIST,
C     WITH BANKS OF THE SAME NAME IN THE ORDER OF INCREASING NUMBER.
C     ALL BANKS OF ONE EVENT ARE READ INTO THE COMMON/BCS/ BY
C     ONE CALL OF THE INPUT PROGRAM.
C
C
C
C
C
C
C
C     OUTPUT OF ONE EVENT
C
C        CALL BSLW               OR  CALL BMLT(N,LIST OF NAMES)
C
C
C        CALL BWRITE(IUN)
C
C     AFTER THE LAST EVENT, A ZERO LIST OF NAMES HAS TO BE DEFINED
C     AND BWRITE HAS TO BE CALLED AGAIN.
C
C        CALL BMLT(0,DUMMY)
C        CALL BWRITE(IUN)
C
C
C
C     INPUT OF ONE EVENT
C
C        CALL BREAD(IUN,&1,&2)         CALL CREAD(IUN,IER)
C
C     SPECIAL CONDITIONS
C
C                      BREAD                    CREAD
C
C     READ ERROR       RETURN1 (&1)             IER=1
C     END-OF-DATA      RETURN2 (&2)             IER=2
C
C
C
C     8.2 OUTPUT MODES AND RECORD TYPES
C
C
C     THERE ARE TWO TYPES OF RECORDS AND THREE MODES OF OUTPUT.
C
C     TYPES OF RECORDS
C
C     S-RECORDS     ONE RECORD CONTAINS ONE EVENT
C
C     M-RECORDS     ONE RECORD MAY CONTAIN SEVERAL EVENTS OR PARTS
C                   OF EVENTS. WITHIN THE RECORD, EVENTS OR PARTS
C                   OF EVENTS ARE WITHIN BANKS WITH THE NAME 'HIDD'.
C
C     FOR BOTH RECORD TYPES, THE INPUT PROGRAM ALWAYS PUTS THE
C     BANKS OF ONE EVENT INTO COMMON/BCS/.
C
C     THE OUTPUT MODE AND A MAXIMUM RECORD LENGTH IS DEFINED BY ONE
C     CALL (BEFORE THE FIRST CALL OF THE OUTPUT PROGRAM) FOR THE
C     OUTPUT UNIT IUNIT.
C
C                  ----- ----- ----
C        CALL BWRO(IUNIT,NRECL,MODE)
C
C     IF NOT CALLED, MODE = 0 IS ASSUMED WITH NRECL TAKEN FROM THE
C     CALL TO THE BOS INITIALIZATION PROGRAM BINT (SEE CH. 1).
C
C
C
C
C     MODES OF OUTPUT
C
C     MODE = 0     S-RECORDS ARE WRITTEN. THE EVENT IS NOT WRITTEN, IF
C                  THE LENGTH OF THE EVENT EXCEEDS NRECL WORDS.
C
C     MODE = 1     S-RECORDS OR M-RECORDS ARE WRITTEN. M-RECORDS ARE
C                  WRITTEN, IF THE LENGTH OF ONE EVENT EXCEEDS NRECL
C                  WORDS.
C
C     MODE = 2     M-RECORDS ARE WRITTEN.
C
C     THE RECORD LENGTH WILL NEVER EXCEED NRECL WORDS. IT IS POSSIBLE
C     (AND DONE IN BWRITE), TO WRITE RECORDS OF FIXED LENGTH NRECL
C     (ADDING UNUSED WORDS, IF NTOT IS LESS THAN NRECL - 1)
C
C
C     8.3 USER WRITE AND READ STATEMENTS
C
C     THE USER CAN USE HIS OWN WRITE AND READ STATEMENTS, TO ALLOW
C     E.G. USING THE IBM-FORTRAN DIRECT ACCESS STATEMENTS.
C     FOR OUTPUT THE STATEMENT CALL BWRITE(IUN) HAS TO BE REPLACED
C     (ALSO FOR THE CALL AFTER THE LAST EVENT) BY THE FOLLOWING
C     STATEMENTS.
C
C        1  CALL BWRS(IUN,NREC,INIW)
C           IF(INIW.EQ.0) GOTO 2
C           WRITE ONE RECORD ON UNIT IUN OF TOTAL NREC WORDS
C           IW(INIW),IW(INIW+1), . . . IW(INIW+NREC-1)
C           GOTO 1
C        2  CONTINUE
C
C     REMARK. IW(INIW) CONTAINS NTOT. FOR MODE = 0 OR = 1, NREC
C     IS EQUAL TO NTOT+1, FOR MODE = 2 NREC IS EQUAL TO NRECL
C     (FIXED NUMBER OF WORDS).
C
C
C     FOR INPUT THE STATEMENT CALL BREAD(IUN,&1,&2) HAS TO BE
C     REPLACED BY THE FOLLOWING STATEMENTS.
C
C
C        1  CALL BRDS(IUN,NREC,INIR)
C           IF(INIR.EQ.0) GOTO 2
C           READ ONE RECORD FROM UNIT IUN INTO WORDS
C           IW(INIR),IW(INIR+1), . . .
C           (SEE REMARKS BELOW)
C           GOTO 1
C        2  CONTINUE
C
C     REMARKS. THE ARGUMENT NREC IS (FOR INIR NOT EQUAL 0) EQUAL
C     TO THE LARGEST ALLOWED NUMBER OF WORDS, WHICH CAN BE READ.
C     SAFE INPUT IS POSSIBLE USING A SUITABLE ASSEMBLER READ ROUTINE.
C     THE END-OF-DATA CONDITION HAS TO BE HANDLED BY THE USER. IN
C     CASE OF READ ERRORS THIS CONDITION CAN BE SIGNALLED TO THE
C     BRDS PROGRAM BY DEFINING IW(INIR) = 0 AND GOTO 1. OTHERWISE
C     IW(INIR) CONTAINS NTOT = NR OF WORDS OF THE RECORD FOLLOWING.
C
C     FOR THE USE IN SPECIAL USER-WRITTEN INPUT-OUTPUT PROGRAMS
C     OR OTHER APPLICATIONS, THERE ARE TWO CALLS, WHICH ASSEMBLE
C     BANKS BELONGING TO THE CURRENT LIST IN CONTIGUOUS BANKSPACE
C     (BOUTP) AND STORE BANKS FROM AN ARBITRARY ARRAY INTO THE
C     COMMON /BCS/ (BINP).
C
C     CALL BOUTP(NRW,INIW)
C                --- ----
C     ALL BANKS BELONGING TO THE CURRENT LIST ARE ARRANGED IN
C     CONTIGUOUS BANK SPACE, STARTING AT LOCATION IW(INIW) WITH
C     A TOTAL OF NRW WORDS (INIW = 0 IN CASE OF ERRORS).
C
C               --- --
C     CALL BINP(NRW,AR)
C
C     ALL BANKS STORED IN THE ARRAY AR(1) . . . AR(NRW) ARE STORED
C     IN THE COMMON /BCS/, IF THERE IS ENOUGH SPACE AND IF THE ARRAY AR
C     CONTAINS CORRECT BANKS.
C
C
C
C     8.4   BUFFER BANKS
C
C     FOR EACH INPUT/OUTPUT UNIT IUN A BANK ('+BUF',IUN) IS USED
C     WITH BETWEEN 11 AND 10 +NRECL WORDS DEPENDING ON RECORD TYPE.
C     THESES BANKS ALSO CONTAIN STATISTIC ON INPUT/OUTPUT,
C     WHICH IS PRINTED BY CALLING THE STATUS-PRINT ROUTINE BSTA.
C     AFTER THE END OF INPUT/OUTPUT THESE BANKS CAN BE DELETED BY THE
C     USUAL CALL
C        CALL BDLS('+BUF',IUN)
C     THIS IS NECESSARY, IF THE SAME UNIT NUMBER IUN IS USED AFTERWARDS.
C     THE CONTENT OF THE BUFFER BANKS IS DESCRIBED IN CH. 10.
C
C
C
C     8.5    STANDARD EVENT READING/WRITING
C
C     PROGRAMMING EXAMPLE OF STANDARD EVENT PROCESSING WITH REPEATED
C     EXECUTION OF
C
C             INPUT OF ONE EVENT
C             PROCESS EVENT
C             OUTPUT OF EVENT
C             DELETE BANKS AND GARBAGE COLLECTION.
C
C     INPUT IS ASSUMED FROM UNIT 1, OUTPUT TO UNIT 2 WITH OUTPUT
C     MODE 0 AND A LIMIT OF 5000 WORDS PER RECORD.
C
C
C           CALL BINT(10000,0,0,0)
C           CALL BWRO(2,5000,0)
C     C
C     C     EVENT LOOP
C     C
C         1 CALL BREAD(1,&1,&2)
C     C     PROCESS EVENT
C           .....
C           .....
C           .....
C           CALL BSLW
C           CALL BWRITE(2)
C           CALL BSLT
C           CALL BDLG
C           GOTO 1
C     C
C     C     END OF EVENT LOOP
C     C
C         2 CALL BMLT(0,DUMMY)
C           CALL BWRITE(2)
C           STOP
C           END
C
C
C
C
C     THERE IS A STANDARD PROGRAM BSEQ, WHICH INCLUDES THE STANDARD
C     BOS PROGRAMS FOR INPUT, OUTPUT AND THE DELETING OF BANKS, AS
C     SHOWN IN THE EXAMPLE ABOVE.
C
C
C     CALL BSEQ(MARK)
C               ----
C
C        WHERE MARK = 0   ONE EVENT READ
C                   = 1   END, NO EVENT READ
C
C
C     BESQ, WHICH IS USED IN A LOOP, READS, EACH TIME CALLED, ONE
C     EVENT FROM UNIT 1. BSEQ RETURNS WITH MARK =1 IN THE END-OF-DATA
C     CONDITION, OR NSEC = 2 SECONDS BEFORE TIME OVERFLOW (TIME IS
C     CHECKED USING THE PROGRAM JUHR). THIS LIMIT CAN BE CHANGED
C     BY (BEFORE THE LOOP)
C
C     CALL BSET(NSEC)
C
C
C     IT IS ALSO POSSIBLE, TO DELIMIT THE NR OF EVENTS TO BE READ
C     BY (BEFORE THE LOOP)
C
C     CALL BSEL(LIMIT)
C
C     BSEQ WILL RETURN WITH MARK = 1 AFTER LIMIT EVENTS.
C
C     OUTPUT IS POSSIBLE WITH BSEQ ONTO THREE DIFFERENT OUTPUT UNITS.
C     IF AN EVENT SHOULD BE WRITTEN ONTO UNIT IUN, THIS HAS TO
C     SIGNALLED BY
C
C     CALL BSEW(IUN)
C
C     IF THE EVENT SHOULD NOT BE WRITTEN ONTO UNIT IUN, THIS IS
C     SIGNALLED BY (WITH A NEGATIVE UNIT)
C
C     CALL BSEW(-IUN)
C
C     DEFAULT IS NO OUTPUT FOR ALL EVENTS. THE OUTPUT ROUTINES ARE
C     CALLED WITHIN BSEQ AT THE NEXT ENTRY, USING THE SPECIAL LIST
C     OF NAMES (BSLW FOR OUTPUT, BSLT FOR DELETING BANKS).
C     THE OUTPUT MODES HAVE TO BE DEFINED BEFORE THE LOOP.
C
C
C
C     EXAMPLE FOR A COMPLETE MAIN PROGRAM.
C     1000 EVENTS ARE TO BE READ FROM UNIT 1, OUTPUT IS TO
C     UNIT 2 FOR ALL EVENTS, AND, FOR CERTAIN EVENTS, ALSO TO
C     THE UNITS 3 AND 4.
C
C
C           CALL BINT(10000,0,0,)
C           CALL BSET(5)
C           CALL BSEL(1000)
C           CALL BWRO(2,5000,0)
C           CALL BWRO(3,2000,1)
C           CALL BWRO(4,2000,1)
C     C
C     C     EVENT LOOP
C     C
C         1 CALL BSEQ(MARK)
C           IF(MARK.EQ.1) GOTO 2
C     C     PROCESS EVENT
C           .....
C           CALL BSEW(2)
C           CALL BSEW(3)
C           .....
C           .....
C           IF(.....) CALL BSEW(-3)
C           IF(.....) CALL BSEW(4)
C           GOTO 1
C     C
C     C     END OF EVENT LOOP
C     C
C         2 CALL BSTA
C           STOP
C           END
C
C
C     THERE IS ALSO THE POSSIBILITY IN BSEQ, TO READ WITH AN
C     ASSEMBLER PROGRAM (VBS RECORDS). IF THIS IS WANTED, ONE
C     HAS TO CALL
C
C     CALL ASVBS(IU)
C
C     BEFORE THE FIRST CALL OF BSEQ , TO DEFINE THE INPUT UNIT
C     NUMBER IU (DDNAME FTIUF001).
C
C
C
C
C     -----------------------------------------------------------------9
C     9.  BANKS ON DIRECT ACCESS DATA SETS
C
C     THE DIRECT ACCESS BOS ROUTINES ALLOW TO STORE BANKS ON A DIRECT
C     ACCESS DATA SET, CALLED DADS, AND, IN THE SAME JOB OR IN A LATER
C     JOB, TO GET THE BANKS BACK TO THE COMMON/BCS/ OR TO DELETE BANKS
C     ON THE DADS (SEE CH. 9.2). THE ROUTINES USE THE IBM-FORTRAN
C     DIRECT ACCESS FEATURES (E.G. DEFINE FILE), THEY WORK WITH
C     RECORDS OF FIXED LENGTH 1610 WORDS, HOWEVER THE BANKS MAY HAVE
C     ANY LENGTH BETWEEN 1 WORD AND 3200 WORDS.
C     THE DADS HAS TO BE INITIALIZED (SEE CH 9.1) BEFORE THE FIRST
C     BANK IS ADDED TO THE DADS.
C
C
C     9.1  INITIALIZATION OF A DADS
C
C     A DADS IS INITIALIZED BY THE FOLLOWING STATEMENTS, USING THE
C     DD-CARD SHOWN.
C
C          DEFINE FILE IU(NREC,1610,U,IVAR)
C          CALL BINLDA(IU,NREC,IPASS)
C
C     //FTIUF001 DD DSN=DSNAME,DISP=(NEW,CATLG),UNIT=FAST,
C     //   SPACE=(6440,(NREC))
C
C          WHERE    IU = (CONSTANT) FORTRAN=NR. OF THE DADS, EQUAL
C                        TO 17, 18 OR 19
C                 NREC = (CONSTANT) NR OF RECORDS, OF LENGTH 1610 WORDS.
C                        AT LEAST NREC = 10.
C                IPASS = PASSWORD (SEE CH.9.4) FOR PROTECTION
C                        OF THE DADS (NO PROTECTION FOR IPASS = 0)
C                 IVAR = DUMMY VARIABLE
C               DSNAME = DSNAME OF THE DADS
C
C     IN LATER JOBS, THE DD-CARD SHOULD CONTAIN DISP=SHR. THE
C     DEFINE FILE STATEMENT IS NOT NECCESSARY IN LATER JOBS,
C     UNLESS NREC IS GREATER THAN 200.
C
C     WITH NREC = 70, THERE IS SPACE ON THE DADS FOR ABOUT
C     100 000 WORDS.
C
C
C     9.2   STORING AND RETRIEVING BANKS
C
C     IF ANY OF THE CALLS DESCRIBED HERE IS USED, A STATEMENT
C     EXTERNAL BLOCDA
C     SHOULD BE INCLUDED IN THE USER-PROGRAM, TO MAKE SHURE
C     THAT THE SUBROUTINE BLOCDA, WHICH HAS THE ADDITIONAL
C     ENTRIES BCREDA, BDLSDA AND BCHKDA, IS INCLUDED BY THE
C     LINK EDITOR.
C     SEE CH. 9.4 FOR THE USE OF PROTECTED DADS.
C
C
C                 ----- ---
C     CALL BCREDA(IUNDA,IND)
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IND   = INDEX OF THE BANK TO BE STORED ON THE DADS
C
C     THE BANK AT THE INDEX IND IS STORED ON THE DADS, IF THE LENGTH
C     OF THE BANK IS BETWEEN 1 AND 3200 WORDS, AND IF THERE IS ENOUGH
C     SPACE ON THE DADS. IF THERE IS ALREADY A BANK WITH THE SAME
C     NAME AND NR ON THE DADS, THEN THE OLD ONE IS REPLACED BY THE
C     NEW ONE. IF THE LENGTH OF THE OLD BANK IS EQUAL TO THE LENGTH
C     OF THE NEW BANK, NO ADDITIONAL SPACE IS USED ON THE DADS.
C
C
C
C                 -----     ---- --
C     CALL BLOCDA(IUNDA,IND,NAME,NR,&1)
C                       ---         --
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IND   = INDEX OF THE BANK TO BE STORED ON THE DADS
C              NAME  = NAME OF THE BANK
C              NR    = NUMBER OF THE BANK
C              &1    = RETURN 1, IF BANK NOT FOUND (IND=0)
C
C     IF THE BANK IS ALREADY IN STORAGE, THE INDEX IND IS GIVEN
C     WITHOUT SEARCHING THE DADS. OTHERWISE THE DADS IS SEARCHED FOR
C     THE BANK (NAME,NR). IF FOUND, THE BANK IS STORED IN THE
C     COMMON/BCS/.
C
C
C
C
C                 ----- ---- --
C     CALL BDLSDA(IUNDA,NAME,NR)
C
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              NAME  = NAME OF THE BANK
C              NR    = NUMBER OF THE BANK
C
C     THE BANK IS DELETED FROM THE DADS. THE SPACE USED ON THE DADS
C     CANNOT BE USED FOR NEW BANKS.
C
C
C
C
C                 ----- ---- --
C     CALL BCHKDA(IUNDA,NAME,NR,NW)
C                               --
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              NAME  = NAME OF THE BANK
C              NR    = NUMBER OF THE BANK
C              NW    = NR OF WORDS OF THE BANK (NW = 0, IF NOT FOUND
C                      ON THE DADS)
C
C     THE DADS IS SEARCHED FOR THE BANK (NAME,NR). IF FOUND, THE
C     LENGTH OF THE BANK IS GIVEN IN NW (OTHERWISE NW = O).
C
C
C     9.3   UNLOADING AND LOADING THE DADS
C
C     THE SUBROUTINE DESCRIBED BOTH NEED ABOUT 6000 WORDS OF
C     BANK STORAGE, BOTH MAKE A GARBAGE COLLECTION BEFORE THEY
C     RETURN.
C
C                 ----- ----- ---- ----- -----
C     CALL BUNLDA(IUNDA,IUNTP,NREC,NPAGE,IPASS)
C
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IUNTP = FORTRAN UNIT OF THE SEQUENTIAL DA
C              NREC  = NR OF USED RECORDS OF THE DADS, TO BE UNLOADED,
C                      USUALLY THIS ARGUMENT CAN BE ZERO(SEE BELOW)
C              NPAGE = NR OF PAGES FOR PRINTOUT
C              IPASS = PASSWORD
C
C     ALL BANKS FROM THE DADS ARE WRITTEN (S-TYPE RECORDS) ONTO
C     THE SEQUENTIAL DATASET. THIS IS ALSO DONE, IF THE PASSWORD
C     IS NOT CORRECT. IF NREC = 0, THEN THE NR OF RECORDS
C     IS TAKEN FROM THE DADS (USUAL CASE). NREC SHOULD ONLY BE
C     GIVEN IN SPECIAL CASES.
C     DURING UNLOADING A TABLE (NAMES, NUMBERS, LENGTHS) IS
C     PRINTED (MAXIMUM NPAGE PAGES). IF IUNTP = 0, THEN ONLY
C     THE TABLE OF CONTENT IS PRINTED.
C
C
C
C
C                 ----- ----- -----
C     CALL BLOADA(IUNDA,IUNTP,IPASS)
C
C
C        WHERE IUNDA = FORTRAN UNIT OF DADS (17, 18 OR 19)
C              IUNTP = FORTRAN UNIT OF SEQUENTIAL DATA SET,
C                      OBTAINED BY THE USE OF BUNLDA.
C              IPASS = PASSWORD
C
C     THE PROGRAM STOPS, IF THE DADS IS PROTECTED AND AN
C     INCORRECT PASSWORD IS USED.
C     ALL BANKS OF THE SEQUENTIAL DATA SET ARE STORED ON THE
C     DADS, THE PREVIOUS CONTENT OF THE DADS IS OVERWRITTEN.
C
C
C
C     BUNLDA CAN BE USED TO WRITE BACKUP-COPIES OF THE DADS.
C     THE DADS CAN BE COMPRESSED BY THE USE OF BUNLDA, FOLLOWED
C     THE USE OF BLOADA.
C
C
C
C
C     9.4   PROTECTED DADS
C
C
C     IT IS POSSIBLE TO DEFINE A PASSWORD AT THE TIME OF INITIALIZATION
C     OF THE DADS. THEN, FOR ALL CALLS, WHICH MODIFY THE DADS, THE
C     CORRECT PASSWORD HAS TO BE GIVEN. IN ADDITION THERE IS A
C     SPECIAL PASSWORD, WHICH ALLOWS TO MODIFY PROTECTED DADS
C     WITHOUT KNOWING THE CORRECT PASSWORD.
C
C     THE PASSWORD IS GIVEN BY THE CALL
C
C                 ----- ----
C     CALL BPASDA(IUNDA,PASS)
C
C        WHERE  IUNDA = FORTRAN UNIT OF DADS
C               IPASS = PASSWORD
C
C
C
C     BPASDA HAS TO BE CALLED ONCE BEFORE ANY CALL OF
C     BCREDA OR BDLSDA, IF THE DATA SET IS PROTECTED AND
C     SHALL BE MODIFIED BY BCREDA OR BDLSDA. OTHERWISE THE
C     CALLS OF BCREDA AND BDLSDA ARE IGNORED.
C
C
C     ----------------------------------------------------------------10
C
C     10.  PRINTING STATISTIC AND A DUMP
C
C     THE STATUS OF THE BOS-SYSTEM, EXPECIALLY STATISTICS ON INPUT/
C     OUTPUT IS PRINTED BY
C
C     CALL BSTA
C
C
C
C     A DUMP CONTAINING RELEVANT STATUS INFORMATION AND NDMP
C     WORDS OF THE COMMON/BCS/IW(NSPACE) IS PRINTED BY
C
C     CALL BDMP
C
C     THE PROGRAM STOPS CALLING ABEND.
C     BDMP IS CALLED AUTOMATICALLY IN BOS-ROUTINES UNDER SEVERAL
C     ERROR CONDITIONS, DESCRIBED BELOW. IT IS ALSO CALLED IN
C     CASE OF A SYSTEM COMPLETION CODE 0CX, IF THE STATEMENT
C
C     CALL DUMP0C
C
C     IS USED AFTER BINT.
C
C
C
C     ICOND  SUBPGM   CONDITION                               REMARK
C     -----  ------   --------------------------------------  -------
C         1    IBLN   TOO MANY NAMES USED                     1,2
C        11  BREADC   NOT ENOUGH SPACE IN COMMON/BCS/         3
C        12    BRDS   NOT ENOUGH SPACE IN COMMON/BCS/         3
C        13    BWRS   NOT ENOUGH SPACE IN COMMON/BCS/         3
C        14  BLOADA   NOT ENOUGH SPACE IN COMMON/BCS/, OR     3,4
C                     ILLEGAL DADS
C        15    PODA   NOT ENOUGH SPACE IN COMMON/BCS/, OR     3,4
C                     ILLEGAL DADS
C        21    BRDS   TOO MANY READ ERRORS                    5,1
C        22    BRDS   RECORD READ TOO LONG                    5,3
C        23    BRDS   WRITE-UNIT USED FOR READING
C        24    BWRS   READ-UNIT USED FOR WRITING
C        31    ----   FORTRAN ERROR 240 (0CX)                 6,7
C        32    BGAR   WRONG INDEX FOUND                       6
C        41   BREADC  INCORRECT CARD FOR FORMATED INPUT
C
C
C     REMARKS
C     1   CHANGE PARAMETERS IN BINT1
C     2   PROBABLY USER ERROR, WRONG VARIABLE USED AS A NAME
C     3   INCREASE TOTAL SPACE IN COMMON/BCS/
C     4   PROBABLY USER ERROR, WRONG DATA SET USED
C     5   READ ERRORS
C     6   PROBABLY USER ERROR, BANK STRUCTURE OVERWRITTEN
C     7   PROBABLY USER ERROR, IN MOST CASES A WRONG INDEX IS USED
C
C
C
C
C     DESCRIPTION OF THE VARIABLES OF THE COMMON/ACS/, PRINTED
C     IN A DUMP.

C     INDEX    VARIABLE     MEANING
C
C       1      ICOND        ERROR CONDITION
C       2      NLAST        LENGTH OF COMMON/BCS/
C       3      NDUMP        NR OF WORDS PRINTED IN A DUMP
C       4      NSPL         NR OF WORDS FOR LOW PRIORITY BANKS
C       5      NAMAX        NR OF DIFFERENT NAMES ALLOWED
C       6      NAMAX1       NAMAX+1
C       7      NLIST        NR OF ENTRIES IN LISTS ALLOWED
C       8      NPRIME       PRIME NR USED IN IBLN
C       9      NFRS         FIRST LOCATION FOR BANKS
C      10      NLST         LAST LOCATION FOR BANKS
C
C      11      NEXT         NEXT LOCATION FOR BANKS
C      12      NCI          ACTUAL NR OF DIFFERENT NAMES
C      13      NFRE         NR OF FREE LOCATIONS
C      14      IN           ACTUAL NR OF NAMES IN LIST
C      15      KPOS         INDEX FROM BPOS/CPOS
C      16      LIND         INDEX OF LAST CREATED BANK
C      17      ILOW         LOWEST INDEX OF DELETED BANK
C      18      LFDI         LAST I-INDEX
C      19      LFDK         LAST K-INDEX
C      20      NCPL         ACTUAL NR OF WORDS OF LOW PRIORITY SPACE
C
C      21-30   NHISTH(10)   HISTOGRAM FOR TOTAL SPACE
C
C      31      NHISTH(11)   OVERFLOWS TOTAL SPACE
C      32      NCOL         NR OF GARBAGE COLLECTIONS
C      33      NZT          TIME OF BOS-START
C      34      IBFI         INDEX FOR BUFF-BANK
C      35      NLAST1       COPY OF NLAST
C      36      ISLST        INDEX FOR SPECIAL LIST OF NAMES
C      37      IMLST        INDEX FOR MARKERS OF SP. LIST O.N.
C      38      INAMV        INDEX FOR NAMES
C      39      IOLST        INDEX FOR IO-LIST
C      40      IPLST        INDEX FOR POINTERS TO NAMES
C
C      41-50   NER(10)      INPUT ERROR CODES FROM BINP/BRDS
C
C      51      NRECL        DEFAULT RECORD LENGTH FOR OUTPUT
C      52      NERRL        NR OF ERRORS ALLOWED
C      53      NRIN         NR OF INPUT EVENTS
C      54      NROUT        NR OF OUTPUT EVENTS
C      55      NS           ACTUAL NR OF NAMES IN SPECIAL LIST
C      56      NEXTI        NEXT INDEX FOR BANKS IN BRDS
C      57      NEXTA        INDEX OF BEGIN OF NEW EVENT
C      58      NEXTB        INDEX BEHIND NEW EVENT
C      59      ISAVB        INDEX OF SAVED LOCATION IN BWRS
C      60      NSAVB        CONTENT OF SAVED LOCATION IN BWRS
C
C      61-70   NHISTL(10)   HISTOGRAM FOR LOW PRIORITY SPACE
C
C      71      NHISTL(11)   OVERFLOWS OF LOW PRIORITY SPACE
C      72      MARKWR       MARKER FOR BSEQ
C      73-75   NOUT(3)      OUTPUT UNITS FOR BSEQ
C      76      IASW         SWITCH FOR FORTRAN/ASSEMBLER READ (BSEQ)
C      77      NPRE         NR OF BPRE PRINTOUTS
C      78      IDUMMY(1)    ONE DUMMY WORD (ZERO)
C      79      NEOTP        NR OF LISTINGS FOR INPUT-BANK ERRORS WITH
C                           ERROR CODE LESS THAN 6
C      80      NDUMP1       SAME AS NDUMP
C
C
C
C
C     DESCRIPTION OF BANKS ('+BUF',IUN) FOR INPUT AND OUTPUT
C
C
C
C     BUFFER FOR INPUT = BANK ('+BUF',IUN), LENGTH = 11,
C              LENGTH = 10 + NRECL FOR M-RECORDS
C
C     IBF+ 1   =1 (INPUT)
C          2   BUFFER SIZE USED
C          3   NR OF IO-ERRORS
C          4   NR OF RECORDS
C          5   NR OF EVENTS ACCEPTED
C          6   NR OF EVENTS, WHICH ARE TOO LARGE
C          7   SUM OF NR OF WORDS IN ALL EVENTS
C          8   MAX NR OF WORDS IN AN EVENT
C          9   LIMIT FOR NR OF ERRORS
C         10   POINTER WITHIN RECORD TO NEXT EVENT
C         ----------------
C         11   NTOT (= NR OF WORDS IN THE RECORD FOLLOWING)
C         12   RECORD
C          .   . . .
C          .   . . .
C
C     BUFFER FOR OUTPUT = BANK ('$BUF',IUN), LENGTH = 11
C              LENGTH = 10 + NRECL FOR M RECORDS
C
C     IBF+ 1   =2 (OUTPUT)
C          2   BUFFER SIZE
C          3   OUTPUT MODE
C          4   NR OF RECORDS
C          5   NR OF EVENTS ACCEPTED
C          6   NR OF EVENTS, WHICH ARE TOO LARGE
C          7   SUM OF NR OF WORDS IN ALL EVENTS
C          8   MAX NR OF WORDS IN AN EVENT
C          9   HIDD-NR
C         10   POINTER WITHIN RECORD TO NEXT EVENT
C         ----------------
C         11   NTOT (= NR OF WORDS IN THE RECORD FOLLOWING)
C         12   RECORD
C          .   . . .
C          .   . . .
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C     -----------------------------------------------------------------A
C
C     APPPENDIX A.   THE SBOS - SYSTEM
C
C
C     THE SBOS SYSTEM IS A SMALL SYSTEM FOR MEMORY MANAGEMENT.
C     IT CONSISTS OF TEN SUBROUTINES WITH A TOTAL LENGTH BELOW
C     10 K BYTES. NO MULTIPLE ENTRIES OR MULTIPLE RETURNS ARE
C     USED. ALL ENTRIES ARE FULLY COMPATIBLE WITH THE BOS SYSTEM.
C     THE SBOS SYSTEM CONTAINS ALL BASIC FUNCTIONS OF THE BOS
C     SYSTEM INCLUDING INPUT AND OUTPUT OF S-TYPE RECORDS.
C     SOME OF THE SUBPROGRAMS ARE IDENTICAL TO THE BOS SYSTEM.
C     THE ADDITIONAL SUBPROGRAMS MAY ALSO BE USED IN THE BOS
C     SYSTEM. ALL BOS SYSTEM SUBPROGRAMS MAY BE USED WITHIN THE
C     SBOS SYSTEM, HOWEVER, BECAUSE OF THE USE OF MULTIPLE ENTRIES
C     IN SOME BOS SUBPROGRAMS EVENTUALLY EXTERNAL STATEMENTS ARE
C     NECESSARY, IF THE MAIN ENTRY IS NOT USED OTHERWISE.
C
C     BASIC ELEMENTS FOR THE MEMORY MANAGEMENT IN THE SBOS AND
C     BOS SYSTEMS ARE SO CALLED BANKS. A BANK HAS TWO IDENTIFIERS
C     NA AND NR, CALLED NAME AND NUMBER, AND A DATA PART OF VARIABLE
C     LENGTH. NORMALLY THE IDENTIFIER NA CONSISTS OF FOUR
C     CHARACTERS, WHILE IDENTIFIER NR IS AN INTEGER.
C
C     ALL BANKS ARE STORED IN A SINGLE COMMON/BCS/IW(NSPACE).
C     AN INDEX IND IS ASSIGNED TO EACH BANK, WHERE IW(IND)=NW
C     CONTAINS THE NUMBER OF DATA WORDS IN THAT BANK. DATA
C     ARE STORED IN IW(IND+1) TO IW(IND+NW). IN ADDITION
C     THERE ARE THREE WORDS CONTAINING NAME, NUMBER AND A
C     POINTER ACCORDING TO THE FOLLOWING SCHEMA.
C
C              I      IW(I)
C          --------   -------------------------------------
C          IND -  3   NA (NAME)
C          IND -  2   NR (NUMBER)
C          IND -  1   POINTER TO NEXT BANK OF SAME NAME
C                     -------------------------------------
C          IND        NW = NUMBER OF DATA WORDS IN THE BANK
C                     -------------------------------------
C          IND +  1   DATA WORD 1
C          IND +  2   DATA WORD 2
C          ...        ...
C          IND + NW   DATA WORD NW
C          --------   -------------------------------------
C
C     NO LIMITATIONS EXIST FOR THE LENGTH OF A SINGLE BANK OR
C     THE NUMBER OF BANKS, EXCEPT FOR THE TOTAL LENGTH OF
C     ALL BANKS AND FOR THE NUMBER OF DIFFERENT NAMES.
C     FOR MORE DETAILS OF THE SYSTEM, CONSULT THE MANUAL OF
C     THE BOS SYSTEM.
C
C
C
C
C     THE SBOS SYSTEM CONSISTS OF THE FOLLOWING NINE SUBPROGRAMS
C
C      1.   SUBROUTINE   BENT   AND SUBROUTINE BDMPA
C      2.   FUNCTION     ILOC
C      3.   FUNCTION     IBLN
C      4.   SUBROUTINE   BMLT
C      5.   SUBROUTINE   BLST
C      6.   SUBROUTINE   BDLM
C      7.   SUBROUTINE   BGAR
C      8.   SUBROUTINE   BSIN
C      9.   SUBROUTINE   BOUT
C      +    ENTRIES      VZERO, UCOPY, UCOPY2
C
C
C
C
C     A.1   INITIALIZATION
C     ------------------
C
C     INITIALIZATION IS DONE BY THE FOLLOWING STATEMENTS.
C
C     COMMON/BCS/IW(NSPACE)
C     REAL RW(NSPACE)
C     EQUIVALENCE (IW(1),RW(1))
C        WHERE NSPACE = INTEGER CONSTANT
C
C     CALL BENT(NSPACE,NADD,NNA,NNL)
C
C
C        WHERE NADD  = NR OF WORDS FOR LOW PRIORITY BANKS
C                      (DEFAULT IS 10 PERCENT OF NSPACE)
C              NNA   = MAX. NR OF DIFFERENT NAMES      (DEFAULT 100)
C              NNL   = MAX. NR OF ENTRIES IN LISTS     (DEFAULT 100)
C
C
C
C     THE DEFAULT VALUES ARE USED, IF THE ARGUMENTS ARE ZERO.
C     IF SUBPROGRAMS OF THE SBOS AND OF THE BOS SYSTEM ARE USED,
C     EITHER BINT OR BENT HAS TO BE CALLED FOR INITIALIZATION.
C     IF ERROR CONDITIONS E.G. ILLEGAL VALUES OF POINTERS ARE
C     DETECTED, THE PROGRAM STOPS.
C         STOP 1   ILLEGAL POINTER DETECTED DURING GARBAGE COLLECTION
C         STOP 2   MORE THAN NNA NAMES USED
C         STOP 3   MORE THAN NNL NAMES USED IN LISTS
C         STOP 4   UNKNOWN CONDITION
C
C
C     BANKS WITH NAMES, WHERE THE FOURTH CHARACTER IS A '*',
C     E.G. 'HST*', ARE CONSIDERED AS BANKS OF LOW PRIORITY.
C     THEY CAN ONLY BE CREATED UP TO A TOTAL AMOUNT OF
C     NADD WORDS.
C
C
C
C     ABOUT 5*NNA + 3*NNL WORDS IN THE COMMON/BCS/ ARE USED FOR
C     INTERNAL TABLES ( 801 WORDS FOR DEFAULT VALUES). BANKS ARE
C     STORED INTO THE COMMON BEGINNING WITH WORD IW(NNA+1).
C
C     IN THE FOLLOWING ARGUMENTS OF SUBPROGRAMS, WHICH ARE CHANGED
C     BY THE CALLED PROGRAM, ARE INDICATED BY A LINE BELOW THE ARGUMENT.
C
C
C
C     A.2   FUNCTION ILOC
C     -----------------
C
C     THIS FUNCTION PERFORMS DIFFERENT OPERATIONS, DESCRIBED BELOW.
C
C
C     2.1    IND=ILOC(NA,NR,NW)    CREATION OF BANK (NA,NR) WITH
C                                  NW DATA WORDS. IF THE BANK IS
C                                  ALREADY EXISTING, THE LENGTH IS
C                                  CHANGED TO THE GIVEN VALUE,
C                                  ADDITIONAL VALUES ARE SET TO 0.
C                                  IND=0, IF INSUFFICIENT SPACE.
C
C     /SBOS/ IND=ILOC(NA,NR,NW)    /BOS/ CALL BCRE(IND,NA,NR,NW,&S1,IER)
C            IF(IND.EQ.0) GOTO S1
C
C
C     2.2    IND=ILOC(NA,NR,0)     LOCATING BANK (NA,NR). IND=0, IF
C                                  BANK NOT EXISTING.
C
C     /SBOS/ IND=ILOC(NA,NR,0)     /BOS/ CALL BLOC(IND,NA,NR,&S1)
C            IF(IND.EQ.0) GOTO S1
C
C
C     2.3    IND=ILOC(NA,NR,-1)    DELETE BANK (NA,NR). IND=0, IF BANK
C                                  NOT EXISTING, OTHERWISE IND = LAST
C                                  INDEX OF BANK, HOWEVER IW(IND) IS
C                                  CHANGED TO -(NW+4).
C
C     /SBOS/ IND=ILOC(NA,NR,-1)    /BOS/ CALL BDLS(NA,NR)
C
C
C     2.4    IND=ILOC(NA,NR,-2)    DELETE BANK (NA,NR) AND DO GARBAGE
C                                  COLLECTION, BUT NOT IN THE REGION
C                                  BEFORE THE DELETED BANK.
C
C
C     2.5    IND=ILOC(NA,NR,-3)    MOVE BANK (NA,NR) TO THE END. IND=0,
C                                  IF INSUFFICIENT SPACE.
C
C     /SBOS/ IND=ILOC(NA,NR,-3)    /BOS/ CALL BLOC(IND,NA,NR,&1)
C            IF(IND.EQ.0) GOTO S1        CALL BCHM(IND,0,IER)
C                                        IF(IER.NE.0) GOTO S1
C
C
C     2.6    IND=ILOC(NA,NR,-4)    CHANGE THE NAME AND NUMBER OF THE
C                                  BANK OF THE PREVIOUS CALL OF ILOC
C                                  TO NA AND NR, RESP. IND=0 IN CASE
C                                  OF AN ERROR (BANK NOT EXISTING OR
C                                  NEW NAME,NR ALREADY IN USE).
C
C     /SBOS/ IND=ILOC(NA1,NR1,0)   /BOS/ CALL BRNM(NA1,NR1,NA2,NR2)
C            IND=ILOC(NA2,NR2,-4)
C
C
C     2.7    IND=ILOC(0,0,0)       OBTAIN INDEX OF UNUSED SPACE BEHIND
C                                  BANKS. THE LENGTH OF THE UNUSED SPACE
C                                  IS STORED IN IW(IND)=NUS. (THERE IS
C                                  ENOUGH SPACE TO CREATE A BANK OF UP
C                                  TO NUS WORDS).
C
C
C
C
C     A.3   FUNCTION IBLN
C     -----------------
C
C     THE VALUE OF THE FUNCTION IBLN(NA) WITH NAME NA IS THE INDEX I
C     CORRESPONDING TO THIS NAME. IW(I) WILL CONTAIN THE INDEX OF THE
C     FIRST BANK OF THE GIVEN NAME.
C                                  /BOS/ IDENTICAL
C
C
C     3.1    IND=IW(IBLN(NA))      OBTAIN INDEX IND OF THE FIRST BANK
C                                  WITH THE NAME NA. IND=0, IF NO BANK
C                                  BANK OF THE NAME EXISTS.
C
C
C     3.2    IND=1+IBLN(NA)        INITIALIZATION OF A LOOP, SEE BELOW.
C
C     /SBOS/ IND=1+IBLN(NA)        /BOS/ CALL BPOS(NA)
C         S1 IND=IW(IND-1)            S1 CALL BNXT(IND,&S2)
C            IF(IND.EQ.0) GOTO S2        . . .
C            . . .                       . . .
C            GOTO S1                     GOTO S1
C         S2 . . .                    S2 . . .
C
C
C
C
C     A.4   SUBROUTINE BMLT
C     -------------------
C
C     4.1    CALL BMLT(NL,LIST)    DEFINE LIST(1) . . . LIST(NL) TO BE
C                                  THE CURRENT LIST.
C                                  /BOS/ IDENTICAL
C
C
C     4.2    CALL BMLT(-1,0)       ALL NAMES OF THE SPECIAL LIST ARE
C                                  DEFINED AS THE CURRENT LIST.
C
C     /SBOS/ CALL BMLT(-1,0)       /BOS/ CALL BSLT
C
C
C     4.3    CALL BMLT(-1,1)       ALL NAMES OF THE SPECIAL LIST WITH
C                                  MARKER=1 ARE DEFINED AS THE CURRENT
C                                  LIST.
C
C     /SBOS/ CALL BMLT(-1,1)       /BOS/ CALL BSLW
C
C
C
C
C     A.5   SUBROUTINE BLST
C     -------------------
C
C     5.1 CALL BLST(NL,LIST,0)     THE NAMES LIST(1) . . . LIST(NL) ARE
C                                  ADDED TO THE SPECIAL LIST WITH
C                                  MARKER=0.
C     /SBOS/ CALL BLST(NL,LIST,0)  /BOS/ CALL BSAT(NL,LIST)
C
C
C     5.2 CALL BLST(NL,LIST,1)     THE NAMES LIST(1) . . . LIST(NL) ARE
C                                  ADDED TO THE SPECIAL LIST WITH
C                                  MARKER=1.
C
C     /SBOS/ CALL BLST(NL,LIST,1)  /BOS/ CALL BSAW(NL,LIST)
C
C
C     5.3    CALL BLST(NL,LIST,-1) THE NAMES LIST(1) . . . LIST(NL) ARE
C                                  DELETED FROM THE SPECIAL LIST.
C
C     /SBOS/ CALL BLST(NL,LIST,-1) /BOS/ CALL BSAD(NL,LIST)
C
C
C     5.4    CALL BLST(0,0,-1)     THE SPECIAL LIST IS CLEARED.
C
C     /SBOS/ CALL BLST(0,0,-1)     /BOS/ CALL BSAC
C
C
C     5.5    CALL BLST(NL,LIST,ND) THE NAMES OF THE CURRENT LIST ARE
C                      --          STORED IN THE USER ARRAY LIST( ),
C                                  WHERE ND IS THE DIMENSION OF LIST( ).
C                                  ND GREATER THAN 1. UP TO ND NAMES
C                                  ARE STORED.
C
C     /SBOS/ CALL BLST(NL,LIST,ND) /BOS/ CALL BMRT(NL,LIST,ND)
C
C
C
C
C     A.6  SUBROUTINE BDLM
C     ------------------
C
C     6.1 CALL BDLM                ALL BANKS OF THE CURRENT LIST ARE
C                                  DELETED.
C                                  /BOS/ IDENTICAL
C
C
C
C
C     A.7  SUBROUTINE BGAR
C     ------------------
C
C     7.1 CALL BGAR(IGA)           THE ACTIVE (NOT DELETED) BANKS ARE
C                   ---            SHIFTED TO THE BEGIN OF THE BANK
C                                  SPACE. IGA=0, IF NO BANKS WERE
C                                  DELETED.
C                                  /BOS/ IDENTICAL
C
C
C
C     A.8  SUBROUTINE BSIN
C     ------------------
C
C     THIS SUBROUTINE IS TO BE USED, IF BANK RECORDS OF TYPE S ARE
C     TO BE READ. THE ACTUAL READ STATEMENT TO READ A RECORD HAS TO
C     BE GIVEN IN THE USER PROGRAM, THE RECORD HAS TO BE STORED
C     AT THE BEGIN OF THE FREE SPACE OF THE COMMON/BCS/. THEN SUBROU-
C     TINE BSIN HAS TO BE CALLED, TO ACCEPT THE BANKS OF THE RECORD,
C     I.E. TO DEFINE THE POINTERS.
C
C     8.1 CALL BSIN(NRW,ICD)       THE BANKS OF THE RECORD WITH NRW
C                       ---        WORDS, READ INTO THE UNUSED BANKSPACE
C                                  IS ACCEPTED. ICD IS AN ERROR CODE.
C                                  ICD=1  RECORD LENGTH LESS THAN 4
C                                  ICD=2  BANK LENGTH NEGATIVE
C                                  ICD=3  BANK LENGTH TOO LARGE
C                                  ICD=4  WRONG ORDER IN BANK NRS
C                                  ICD=5  WRONG RECORD END
C
C     EXAMPLE
C
C     IND=ILOC(0,0,0)              SUBROUTINE FREAD(IUN,NTOT,BIN,*,*)
C     CALL FREAD(IUN,NRW,          REAL BIN(NTOT)
C                IW(IND),&S1,&S2)  READ(IUN,ERR=1,END=2) NTOT,BIN
C     CALL BSIN(NRW,ICD)           RETURN
C     IF(ICD.NE.0) GOTO S1       1 RETURN 1
C                                2 RETURN 2
C                                  END
C
C
C
C
C     A.9   SUBROUTINE BOUT
C     -------------------
C
C     THIS SUBROUTINE IS TO BE USED, IF BANK RECORDS OF TYPE S ARE
C     TO BE WRITTEN. THE SUBROUTINE BGAR IS CALLED INTERNALLY.
C
C
C     9.1   CALL BOUT(NRW,INIW)    ALL BANKS BELONGING TO THE CURRENT
C                     --- ----     LIST ARE ARRANGED IN CONTIGUOUS
C                                  BANK SPACE. THE ACTUAL WRITESTATEMENT
C                                  SHOULD WRITE A RECORD, CONSISTING OF
C                                  THE WORD NRW (LENGTH), FOLLOWED BY
C                                  THE NRW WORDS IW(INIW), IW(INIW+1)
C                                  . . . IW(INIW+NRW-1).
C                                  NRW=0 IF NO BANKS.
C
C     EXAMPLE
C
C     DEFINE CURRENT LIST          SUBROUTINE FWRITE(IUN,NTOT,BIN)
C     CALL BOUT(NRW,INIW)          REAL BIN(NTOT)
C     IF(NRW.EQ.0) GOTO S1         WRITE(IUN) NTOT,BIN
C     CALL FWRITE(IUN,NRW,         RETURN
C                IW(INIW))         END
C
C
C
C
C     ------------------------------------------------------------------
C
C
C     APPENDIX B.    APPLICATION PROGRAMS
C
C
C
C     THE SUBROUTINE DESCRIBED HERE USE BANK STORAGE OF LOW
C     PRIORITY. THEY CAN BE USED FOR COUNTING, HISTOGRAMMING,
C     STORING OF VECTORS ETC. AND MAY BE USEFUL IN THE TESTING
C     PHASE OF LARGE PROGRAMS.
C     THE TOTAL NUMBER OF WORDS USED IN THE BANK COMMON /BCS/ CAN
C     NEVER EXCEED NADD WORDS (NADD IS AN ARGUMENT OF BINT).
C     THE SUBROUTINES START WITH A LETTER U FOR A NEW ENTRY, AND
C     WITH A LETTER P FOR PRINTOUT.
C
C     THE ARGUMENT N IN THE CALLS SHOULD ALWAYS BE A POSITIVE
C     INTEGER WITH LESS THAN 9 DIGITS.
C
C
C     B.1  PRINTOUT AND COMMENTS
C
C     FOR ALL APPLICATION PROGRAMS DESCRIBED IN APPENDIX A.2 TO A.6
C     PRINTOUT CAN BE DONE USING ONE CALL
C
C     CALL PALL
C
C
C
C     FOR SEVERAL APPLICATION PROGRAMS DESCRIBED IN THIS APPENDIX
C     COMMENT CAN BE DEFINED BY THE FOLLOWING CALLS. THIS COMMENT
C     IS PRINTED TOGETHER WITH THE RESULT
C
C                                         -NOT YET AVAILABLE-
C     CALL TCOND(N,'COMMENT    $')
C        COMMENT FOR UCOND
C
C     CALL TTABL(N,'COMMENT    $')
C        COMMENT FOR UTABL
C
C     CALL THIST(N,'COMMENT    $')
C        COMMENT FOR UHIST
C
C     CALL TCORR(N,'COMMENT    $')
C        COMMENT FOR UCORR
C
C     CALL TSTOR(N,'COMMENT    $')
C        COMMENT FOR USTOR/USTOS
C
C     CALL TMEAN(N,'COMMENT    $')
C        COMMENT FOR UMEAN
C
C     CALL TPEAK(N,'COMMENT    $')
C        COMMENT FOR UPEAK
C
C     CALL TLIND(N,'COMMENT    $')
C        COMMENT FOR ULIND
C
C     CALL TEMPF(N,'COMMENT    $')
C        COMMENT FOR UEMPF
C
C     THE COMMENT-TEXT IS DELIMITED BY A $ SIGN, MAXIMUM NUMBER
C     OF CHARACTERS IS 60.
C
C
C     A BANK WITH NAME 'TEX*' IS USED FOR EACH COMMENT.
C
C
C     B.2  COUNT IN A 32768 * 32768 ARRAY
C
C                - -
C     CALL UCOND(I,J)
C        INCREASE COUNT IN ELEMENT I,J BY ONE.
C        0 .LE. I .LE. 32767  AND 0 .LE. J .LE. 32767
C
C     CALL PCOND
C        PRINT ALL ELEMENTS .NE. 0. ALL BANKS USED ARE DELETED.
C
C                - -
C     CALL QCOND(I,J,NR)
C                    --
C        WHERE I,J = INDICES OF ELEMENT
C               NR = NUMBER OF COUNTS IN ELEMENT
C
C     BANKS (CON*,IJ) OF LENGTH 8(+4) ARE USED, WHERE IJ IS CALCULATED
C     FROM I AND J.
C
C
C     B.3  COUNT IN A 256 * 16 ARRAY
C
C                - - -
C     CALL UTABL(N,I,J)
C        INCREASE COUNT IN ELEMENT I,J BY ONE.
C        0 .LE. I .LE. 255  AND  0 .LE. J .LE. 15.
C        MAXIMUM COUNT IN ONE ELEMENT IS 65535.
C
C                -
C     CALL PTABL(N)
C        THE I/J ARRAY NUMBER N IS PRINTED. FOR N=0 ALL ARRAYS
C        ARE PRINTED.
C
C                - -
C     CALL QTABL(N,I,AR)
C                    --
C        WHERE AR( ) = ARRAY OF LENGTH 16 CONTAINING THE COUNTS
C                      IN THE I-ROW OF ARRAY NUMBER N.
C
C     A BANK (TAB*,N*16+I/16) OF LENGTH 128(+4) IS USED FOR EACH
C     FILLED 16 * 16 SUBARRAY.
C
C
C     B.4  HISTOGRAM
C
C                - -
C     CALL UHIST(N,X)
C        ADD NEW ENTRY X INTO HISTOGRAM N WITH 100 BINS. THE BIN SIZE
C        IS CHOOSEN AUTOMATICALLY, UNLESS DHIST IS USED.
C
C                - -- --
C     CALL DHIST(N,XL,XH)
C        FOR HISTOGRAM N THE VALUES XL AND XH ARE DEFINED AS LOWER
C        AND UPPER LIMITS, RESP.. (MUST BE CALLED BEFORE UHIST).
C
C                -
C     CALL PHIST(N)
C        THE HISTOGRAM N IS PRINTED, TOGETHER WITH MEAN VALUES ETC.
C        FOR N=0 ALL HISTOGRAMS ARE PRINTED.
C
C                -
C     CALL QHIST(N,Q)
C                  -
C
C        WHERE Q( ) = ARRAY OF LENGTH 115 FOR CONTENT OF
C        HISTOGRAM N (SEE BELOW).
C
C        I               Q(I)
C
C        1 . . . 100     CONTENT OF HISTOGRAM BINS
C        101             NR OF ENTRIES (TOTAL)
C        102             LOWEST BIN LEFT EDGE
C        103             BIN SIZE
C        104             NR OF ENTRIES OUTSIDE LOW
C        105             NR OF ENTRIES OUTSIDE HIGH
C        106             MIMIMUM VALUE OF X
C        107             MAXIMUM VALUE OF X
C        108             MEAN VALUE
C        109             MEDIAN (50 PC VALUE)
C        110             STANDARD DEVIATION
C        111                   . . .        FROM QUANTILES
C        112             QUANTILES   16 PC
C        113                . . .    84 PC
C        114                . . .   2.3 PC
C        115                . . .  97.7 PC
C
C     A BANK (HST*,N) OF LENGTH 120(+4) IS USED FOR EACH HISTOGRAM.
C
C
C     B.5  CORRELATION PLOT
C
C                - - -
C     CALL UCORR(N,Y,X)
C        ADD NEW ENTRY Y,X TO CORRELATION PLOT N WITH
C        50 * 100 BINS. BIN SIZE IS ALWAYS CHOOSEN AUTOMATICALLY.
C
C                -
C     CALL PCORR(N)
C        THE CORRELATION PLOT N IS PRINTED ON ONE PAGE TOGETHER
C        WITH PROJECTIONS AND MEAN VALUES.
C        BINS WITH CONTENT .NE. 0 ARE PRINTED AS A X. FOR N=0
C        ALL CORRELATION PLOTS ARE PRINTED.
C
C     A BANK (COR*,N) OF LENGTH 380(+4) IS USED FOR EACH
C     CORRELATION PLOT.
C
C
C
C     B.6  STORE VECTORS
C
C                - -- ----
C     CALL USTOR(N,AR,NDIM)
C        STORE VECTOR AR(1) . . . AR(NDIM) IN STORAGE N. THE
C        ARGUMENT NDIM SHOULD ALWAYS BE THE SAME FOR A GIVEN
C        STORAGE N.
C
C     NOTE. USTOR IS AN ENTRY OF USTOS. IF USTOS IS NOT CALLED,
C     USE A STATEMENT
C        EXTERNAL USTOS
C
C
C
C
C                - -- -- -- --
C     CALL USTOS(N,A1,A2,A3,A4)
C        STORE VECTOR A1, . . . IN STORAGE N. THE NUMBER OF ELEMENTS
C        IN A VECTOR MAY BE BETWEEN 1 AND 4 (VARIABLE NR OF ARGUMENTS
C        ALLOWED), BUT SHOULD ALWAYS BE THE SAME FOR A GIVEN
C        STORAGE N.
C
C     THE NUMBER OF VECTORS STORED IN A STORAGE IS LIMITED TO 100.
C     THIS LIMIT CAN BE CHANGED BY DSTOR.
C
C                ---
C     CALL DSTOR(LIM)
C        THE LIMIT ON THE NR OF VECTORS IS SET TO LIM.
C
C                -
C     CALL PSTOR(N)
C        THE VECTORS STORED IN STORAGE N ARE PRINTED. FOR N=0
C        THE VECTORS OF ALL STORAGES ARE PRINTED.
C
C     A BANK (STO*,N) IS USED FOR EACH STORAGE. THE STORAGE IS USED
C     AS FOLLOWS.
C
C     INDEX OF THE BANK       CONTENT
C            +1               NUMBER OF STORED VECTORS
C            +2               LENGTH OF ONE VECTOR
C            +3               (USED INTERNAL)
C            +4               1. ELEMENT OF 1. VECTOR
C            +5               2. ELEMENT OF 1. VECTOR
C            +6                    ETC
C
C
C     B.7  DETERMINE MEAN VALUES
C
C     THE MEAN VALUE IS DETERMINED FOR ENTRIES X. ENTRIES
C     HAVING A LARGE DEVIATION FROM THE AVERAGE X VALUE ARE
C     NOT USED. INTERNALLY A SMALL HISTOGRRAM IS MADE.
C     THREE DIFFERENT MEASURES FOR THE CENTER OF THE DISTRI-
C     BUTION ARE CALCULATED, THE USUAL MEAN FOR THE ENTRIES
C     INSIDE THE HISTOGRAM, THE TRIMMED MEAN, WHICH DETERMINES
C     THE MEAN FROM THE INNER 54 PERCENT OF THE HISTOGRAM,
C     AND THE MEDIAN (50 PERCENT VALUE OF HISTOGRAM). USUALLY
C     THE TRIMMED MEAN IS THE BEST MEASURE.
C
C                -- -- -
C     CALL UMEAN(N,KA,X)
C
C        ADD NEW ENTRY X TO MEAN VALUES N,KA.
C        THE KA-VALUE MAY BE BETWEEN 0 AND KAMAX,
C        IF SPACE IS RESERVED BY DMEAN(NA,KAMAX)
C
C                -- -----
C     CALL DMEAN(N,KAMAX)
C
C        FOR MEAN VALUES N,0 TO N,KAMAX SPACE IS RESERVED.
C        IF NOT CALLED, KAMAX=0 IS ASSUMED.
C
C
C                --
C     CALL PMEAN(N)
C        MEAN VALUES N,... ARE PRINTED. FOR N=0 ALL
C        MEAN VALUES ARE PRINTED.
C
C                -- --
C     CALL QMEAN(N,KA,Q)
C                      -
C        WHERE Q( ) = ARRAY OF LENGTH 10 FOR MEAN VALUE
C                     INFORMATION
C
C         I       Q(I)
C         1       NR OF ENTRIES TOTAL
C         2       MEAN
C         3       TRIMMED MEAN
C         4       MEDIAN
C         5       SIGMA (AVERAGE)
C         6       SIGMA (LEFT)
C         7       SIGMA (RIGHT)
C         8       NR OF ENTRIES OUTSIDE X-RANGE
C         9       LOWER LIMIT OF X-RANGE
C        10       UPPER LIMIT OF X-RANGE
C
C     A BANK (MEA*,N) IS USED WITH LENGTH 50*(KAMAX+1).
C
C
C
C     B.8  DETERMINE PEAK VALUES        -NOT YET AVAILABLE-
C
C     THE PEAK VALUE IS SEARCHED FOR IN THE DISTRIBUTION OF
C     ENTRIES X. INTERNALLY A HISTOGRRAM IS MADE, WHICH IS
C     ANALYSED USING STATISTICAL METHODS TO FIND THE LARGEST
C     PEAK CONSISTENT WITH A RAW DESCRIPTION.
C
C                -- -- -
C     CALL UPEAK(N,KA,X)
C
C        ADD NEW ENTRY X TO PEAK SEARCH N,KA.
C        THE KA-VALUE MAY BE BETWEEN 0 AND KAMAX,
C        AS GIVEN IN DPEAK.
C
C                - ----- -- -- ----
C     CALL DPEAK(N,KAMAX,XA,XZ,FWHM)
C
C        FOR PEAK SEARCHES N,0 TO N,KAMAX SPACE IS RESERVED.
C        IF NOT CALLED, FOLLOWING CALLS TO UPEAK ARE IGNORED.
C        THE ARGUMENTS GIVE A RAW DESCIPTION OF THE PEAK.
C        XA,XZ  = LOWER AND UPPER POSSIBLE VALUES OF PEAK POSITION
C        FWHM   = EXPECTED FULL WIDTH AT HALF MAXIMUM OF THE PEAK
C
C                -
C     CALL PPEAK(N)
C        RESULTS ON PEAK SEARCHES N,... ARE PRINTED, TOGETHER WITH
C        HISTOGRAMS. FOR N=0 ALL RESULTS ARE PRINTED, BUT WITHOUT
C        HISTOGRAMS.
C
C
C                - --
C     CALL QPEAK(N,KA,Q)
C                     -
C        WHERE Q( ) = ARRAY OF LENGTH 6 FOR PEAK SEARCH RESULTS
C
C         I       Q(I)
C         1       NR OF ENTRIES TOTAL
C         2       PEAK POSITION
C         3       SIGMA
C         4       FWHM
C         5       FRACTION OF ENTRIES WITHIN +- 1 STANDARD DEVIATIONS
C         6       FRACTION OF ENTRIES WITHIN +- 3 STANDARD DEVIATIONS
C
C     A BANK (PEA*,N) IS USED WITH LENGTH UP TO 10+100*(KAMAX+1).
C
C
C
C     B.9  STORE SINGLE VALUES
C
C                - -- -
C     CALL USSTO(N,KA,X)
C        STORE VALUE X IN STORAGE N,KA. KA VALUES ARE ALLOWED
C        BETWEEN 0 AND KAMAX, IF SPACE IS RESERVED BY
C        DSSTO(N,KAMAX).
C
C
C                - ----- ---
C     CALL DSSTO(N,KAMAX,IEN)
C        FOR STORAGE N,0 TO N,KAMAX SPACE IS RESERVED FOR UP TO
C        IEN ENTRIES EACH. IF NOT CALLED, KAMAX=0 AND IEN=100.
C
C                - --
C     CALL QSSTO(N,KA,Q,NQ,NENT)
C                     - -- ----
C
C        WHERE Q( ) = ARRAY OF LENGTH IEN, CONTAINING NQ SINGLE
C                     X-VALUES FROM A TOTAL OF NENT X-VALUES
C
C     A BANK (SST*,N) IS USED WITH LENGTH 1+(IEN+1)*KAMAX.
C
C
C
C
C     B.10  BIN DEFINITION
C
C     THE BIN NUMBER LB OF A VALUE X IN A BIN DEFINITION
C     DEFINED BY A BANK ('$BIN',NC) IS OBTAINED BY
C              -- -
C     LB = LBN(NX,X)
C
C     THE BANK ('$BIN',NX) MAY BE DEFINED BY DATA CARDS, READ BY
C     BREADC, AND MUST BE OF ONE OF THE FOLLOWING FORMS.
C
C     $BIN NX  XL XH                        ( NB=100 ASSUMED)
C     $BIN NX  XL XH NB                     ( NB LESS EQUAL 1000)
C     $BIN NX  X1 X2 X3 X4 . . . XL         ( NB = L-1, L AT LEAST 4)
C
C     XL AND XH ARE THE LOWER AND UPPER LIMITS OF ALL NB BINS.
C     X1, X2, X3 . . . ARE THE LOWER LEFT EDGES OF THE BINS,
C     SORTED IN ASCENDING ORDER.
C
C     FUNCTION LBN(N,X) RETURNS WITH 0, IF NO CORRESPONDING
C     BANK IS STORED. IT RETURNS 0 OR NB+1 FOR X VALUES OUTSIDE
C     THE BIN DEFINITION.
C
C     THE LIMITS XL AND XH OF A GIVEN BIN NR LB FOR BIN DEFINITION NX
C     IS OBTAINED BY
C               -- --
C     CALL VLBN(NX,LB,XL,XH,NB)
C                     -- -- --
C     NB IS THE TOTAL NR OF BINS.
C
C
C     B.11  INTERPOLATION OF TABULATED DATA
C
C     USING THE SPLINE INTERPOLATION PROGRAM CUBSPL THE FUNCTION
C     BFUN GIVES THE INTERPOLATED FUNCTION VALUE (BDER THE FIRST
C     DERIVATIVE) AT A GIVEN X VALUE FOR TABULATED DATA, WHICH ARE
C     STORED IN A BANK ('$FUN',N) AND E.G. READ IN FROM CARDS
C     BY BREADC.
C
C     $FUN N  Y1 X1  Y2 X2  Y3 X3  Y4 X4 . . .
C
C     (X VALUES IN ASCENDING ORDER, AT LEAST 3 Y,X PAIRS)
C
C                 - -
C     YI   = BFUN(N,X)        INTERPOLATED FUNCTION VALUE
C
C                 - -
C     YDER = BDER(N,X)        FIRST DERIVATIVE
C
C
C     AT THE FIRST ENTRY A BANK ('+FUN',N) IS CREATED, WHICH CONTAINS
C     THE SPLINE COEFFICIENTS. ITSLENGTH IS 5*NR OF Y,X PAIRS.
C
C     A PLOT OF THE FUNCTION N IS OBTAINED BY
C
C     CALL PFUN(N)
C
C
C     B.11  DETERMINATION OF A LINEAR DEPENDENCE Y(X)-NOT YET AVAILABLE-
C
C     A LINEAR DEPENDENCE OF Y ON X CAN BE DETERMINED BY THE FOLLOWING
C     CALL FROM PAIRS OF Y,X VALUES. INTERNALLY USSTO IS USED.
C
C                -- ----- --- -- -- -- --
C     CALL DLIND(NA,KAMAX,IEN,YL,YH,XL,XH)
C
C     FOR LINEAR DEPENDENCES N,0 TO N,KAMAX SPACE IS RESERVED FOR UP
C     TO IEN PAIRS. YL,YH AND XL,XH ARE THE LIMITS FOR THE Y AND
C     X VALUES.
C
C
C
C                - -- - -
C     CALL ULIND(N,KA,Y,X)
C
C     ADD NEW Y,X PAIR TO LINEAR DEPENDENCE N,KA, IF Y AND X ARE
C     WITHIN THE LIMITS DEFINED BY DLIND.
C
C                -
C     CALL PLIND(N)
C
C     THE RESULT INCLUDING INTERCEPT AND SLOPE OF THE LINEAR
C     DEPENDENCES NA,0 TO NA,KAMAX ARE PRINTED.
C
C                - --
C     CALL QLIND(N,KA,Q)
C                     -
C
C        WHERE Q( ) = ARRAY OF LENGTH 10 FOR INFORMATION ON
C                     LINEAR DEPENDENCE N,KA
C
C      I      Q(I)
C      1      NR OF ENTRIES STORED
C      2      INTERCEPT
C      3      SLOPE
C      4      ERROR OF SLOPE
C      5      MEAN X
C      6      MEAN Y
C      7      ERROR OF MEAN Y
C      8      MEAN SIGMA OF SINGLE POINT
C      9      NR OF DELETED POINTS
C     10      NR OF TOTAL ENTRIES
C
C     THE METHOD USED FOR THE DETERMINATION OF THE LINEAR
C     DEPENDENCE ALLOWS A BACKGROUND CONTRIBUTION OF ABOUT
C     20 PERCENT OF RANDOMLY DISTRIBUTED Y,X PAIRS. THE FRACTION
C     OF DELETED POINTS BEFORE THE ACTUAL LINEAR FIT IS GIVEN
C     IN Q(9).
C
C     A BANK (LIN*,N) IS USED OF LENGTH 6 WORDS PLUS THE
C     CORRESPONDING BANK (SST*,N)
C
C
C
C     B.13  DETERMINATION OF AN EMPIRICAL FUNCTION
C
C
C     A FUNCTIONAL DEPENDENCE OF Y ON X CAN BE DETREMINED BY THE
C     FOLLOWING CALLS FROM PAIRS OF Y,X VALUES. INTERNALLY UMEAN
C     IS USED, THE RESULT IS STORED A BANK $FUN,N.
C
C                - --
C     CALL DEMPF(N,NX)
C
C     FOR EMPIRICAL FUNCTION N, THE BIN DEFINITION NX IS TO BE
C     USED FOR THE X-VALUES. THE MEAN OF THE Y-VALUES WITHIN
C     EACH X-BIN WILL BE DETERMINED.
C
C
C                - - -
C     CALL UEMPF(N,Y,X)
C
C     ADD NEW Y VALUE INTO THE BIN DEFINED BY THE X VALUE AND THE
C     BIN DEFINITION NX.
C
C     CALL PEMPF(N)
C
C     THE RESULT IS PRINTED, A BANK $FUN,N IS CREATED WITH MEAN
C     Y VALUES AND THE CENTRAL X VALUE FOR EACH BIN.
C
C     THE METHOD ALLOWS A CERTAIN BACKGROUND IN THE DATA.
C
C     A BANK (EMP*,N) IS USED OF LENGTH 2+LENGTH OF $BIN BANK
C     PLUS THE CORRESPONDING BANK (MEA*,N).
C
C
C
C
C
C
C

C   01/11/84 507081529  MEMBER NAME  RZDRAW   (ZS)          FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RZDRAW(NWIR, XZ, YZ, XZ1, YZ1, XZ2, YZ2, ZZ1, ZZ2, LAB)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  DRAW HITS OF RZ CHAMBERS
C
C  LAST MOD:   J. HAGEMANN   09/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C        DRAW THE HITS IN RZ CHAMBERS; LAB GIVES THE MODE
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON /CZGEO/ RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,ZCHSS,
     +               ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      COMMON /CZKON/ ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
C
      COMMON /CJTRIG/ PI,TWOPI,PIHALF,PI3HAF
C
      DATA SCRUNI/8.0/, ICAL/0/
C
C-----------------  C O D E  -------------------------------------------
C
      ICAL = ICAL + 1
      IF(ICAL.NE.1) GO TO 4040
      ADDERZ = 24.*DLZPHI
      ADDRAD = ADDERZ/TWOPI
4040  IF(LAB.NE.1) GO TO 111
C                               RFI DISPLAYS
      IF(ZZ1.LT.0.) GO TO 1010
C  PLUS Z SIGN
      RAD=SQRT(XZ**2+YZ**2+1.)
      RAD=SCRUNI/RAD
      X00 = RAD*XZ
      Y00 = RAD*YZ
      XX=-XZ-X00
      YY=YZ-Y00
      CALL MOVEA(XX,YY)
      XX=-XZ+X00
      YY=YZ+Y00
      CALL DRAWA(XX,YY)
      XX=-XZ-Y00
      YY=YZ+X00
      CALL MOVEA(XX,YY)
      XX=-XZ+Y00
      YY=YZ-X00
      CALL DRAWA(XX,YY)
      CALL DRAMOV(-XZ1,YZ1,-XZ2,YZ2,0)
      RETURN
 1010 CONTINUE
C  MINUS Z SIGN
      RAD=SQRT(XZ**2+YZ**2+1.)
      RAD=1.41421356*RAD
      RAD=SCRUNI/RAD
      X00 = RAD*(-XZ+YZ)
      Y00 = RAD*(-XZ-YZ)
      XX=-XZ-X00
      YY=YZ-Y00
      CALL MOVEA(XX,YY)
      XX=-XZ+X00
      YY=YZ+Y00
      CALL DRAWA(XX,YY)
      XX=-XZ-Y00
      YY=YZ+X00
      CALL MOVEA(XX,YY)
      XX=-XZ+Y00
      YY=YZ-X00
      CALL DRAWA(XX,YY)
      CALL DRAMOV(-XZ1,YZ1,-XZ2,YZ2,0)
      RETURN
111   CONTINUE
      IF(LAB.NE.2) GO TO 222
C                        ZX AND ZY DISPLAYS
      IPAS = 1
      XP = ZZ1
      RP = SQRT(XZ**2+YZ**2)
      RP1 = SQRT(XZ1**2+YZ1**2)
      RP2 = SQRT(XZ2**2+YZ2**2)
      FLAGZ = 1.
      IF(LASTVW.LT.8.AND.XZ.LT.0.) FLAGZ = -1.
      IF(LASTVW.GT.7.AND.YZ.LT.0.) FLAGZ = -1.
      YP = RP*FLAGZ
      YP1 = RP1*FLAGZ
      YP2 = RP2*FLAGZ
8481  XX=XP-SCRUNI
      YY=YP
      CALL MOVEA(XX,YY)
      XX=XP+SCRUNI
      CALL DRAWA(XX,YY)
C     XX=XP
C     YY=YP-SCRUNI
C     CALL MOVEA(XX,YY)
C     YY=YP+SCRUNI
C     CALL DRAWA(XX,YY)
      CALL DRAMOV(XP,YP1,XP,YP2,0)
      IF(IPAS.EQ.2) RETURN
      IPAS = 2
      XP = ZZ2
      GO TO 8481
222   CONTINUE
      IF(LAB.NE.3) GO TO 333
C                        ROLLED OUT RZ DISPLAY
      ADY = 1500. + Z2ZCH
      IPAS = 1
      YP = ADY + ZZ1
      FIP = ATAN2(YZ,XZ)
      FIP1 = ATAN2(YZ1,XZ1)
      FIP2 = ATAN2(YZ2,XZ2)
      IF(FIP.LT.0.) FIP = FIP + TWOPI
      IF(FIP1.LT.0.) FIP1 = FIP1 + TWOPI
      IF(FIP2.LT.0.) FIP2 = FIP2 + TWOPI
      XP = ADDRAD*FIP
      XP1 = ADDRAD*FIP1
      XP2 = ADDRAD*FIP2
223   XX=XP-SCRUNI
      YY=YP
      IF(MOD(NWIR,2).EQ.1)  YY=YP-SCRUNI
      CALL MOVEA(XX,YY)
      XX=XP+SCRUNI
      IF(MOD(NWIR,2).EQ.1)  YY=YP+SCRUNI
      CALL DRAWA(XX,YY)
      XX=XP
      IF(MOD(NWIR,2).EQ.1)  XX=XP+SCRUNI
      YY=YP-SCRUNI
      CALL MOVEA(XX,YY)
      IF(MOD(NWIR,2).EQ.1)  XX=XP-SCRUNI
      YY=YP+SCRUNI
      CALL DRAWA(XX,YY)
      IF(XP2.GT..95*ADDERZ.AND.XP1.LT..05*ADDERZ) XP2=XP2-ADDERZ
      IF(XP1.GT..95*ADDERZ.AND.XP2.LT..05*ADDERZ) XP1=XP1-ADDERZ
      YY=YP
      CALL DRAMOV(XP1,YY,XP2,YY,0)
      IF(IPAS.EQ.2) RETURN
      IPAS = 2
      YP = ADY + ZZ2
      GO TO 223
333   CONTINUE
      RETURN
      END

C   07/02/89 903051738  MEMBER NAME  GUSTEP   (S)           FORTRAN77
      SUBROUTINE GUSTEP
C
C---USER SUPPLIED ROUTINE FOR DEALING WITH HITS AT END OF EACH
C   TRACKING STEP.
C                     GEANT COMMONS :

      COMMON /GCVOLU/ NLEVEL, NAMES(15), NUMBER(15),
     + LVOLUM(15),LINDEX(15),GTRAN(3,15),GRMAT(10,15),
     + NGPAR(15),GPAR(50,15),GONLY(15),GLX(3),
     + NJNEXT(2),JNEXT(15),INEXT(15),NNEXT(15)
C
      COMMON/GCONST/PI,TWOPI ,PIBY2,DEGRAD,RADDEG,CLIGHT ,BIG,EMASS
C
      COMMON/GCFLAG/IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN
     +        ,IEOTRI,IEVENT,ISWIT(10),IFINIT(20),NEVENT,NRNDM(2)
C
      COMMON/GCKINE/IKINE,PKINE(10),ITRA,ISTAK,IVERT,IPART,ITRTYP
     +      ,NAPART(5),AMASS,CHARGE,TLIFE,VERT(3),PVERT(4),IPAOLD
C
      COMMON/GCTRAK/VECT(7),GETOT,GEKIN,VOUT(7),NMEC,LMEC(30),NAMEC(30)
     + ,NSTEP ,MAXNST,DESTEP,SAFETY,SLENG ,STEP  ,SNEXT ,SFIELD,SNPHYS
     + ,TOFG  ,GEKRAT,IGNEXT,INWVOL,ISTOP ,IDECAD,IEKBIN
C
      COMMON/GCSETS/IUSET,IUDET,ISET,IDET,IDTYPE,NVNAME,NUMBV(20)
C
      COMMON/GCKING/KCASE,NGKINE,GKIN(5,100),TOFD(100)
C
      COMMON/GCTMED/NUMED,NATMED(5),ISVOL,IFIELD,FIELDM,TMAXFD,DMAXMS
     +      ,DEEMAX,EPSIL,STMIN,CFIELD,CMULS,IUPD,ISTPAR,NUMOLD
C
      COMMON / CEBLOK / EBLOCK(16,3)
      COMMON / CRVECT / PRVECT(3)
C
      LOGICAL  LDEBUG
C
      COMMON / CDEBUG / LDEBUG
C
      DATA ICALL / 0 /
      DATA IPRINT / 0 /
      ICALL = ICALL + 1
C
C------------------------------------------------------------------
C
      IF ( .NOT. LDEBUG ) GOTO 8011
      ZPOS = VECT (3)
      IF ( ABS (ZPOS) .LT. 293 ) GOTO 8011
      IF ( IPRINT .GT. 500 )      GOTO 8011

C           FOLLOW SHOWER-HISTORY
      IPRINT = IPRINT + 1
      PRINT 8000, ICALL, NUMED,(NATMED(I),I=1,5), NLEVEL,
     +            NUMBER(NLEVEL), NAMES(NLEVEL)
 8000 FORMAT (
     + /T2, I6, ' MEDIUM: ',I4,TR2,5A4,'  VOLUME LEVEL: ',I4,
     +  ' ,REGION ',I4,A5)

      PRINT 8006, NUMBER(2), NAMES(2)
 8006 FORMAT (1X,'2ND LEVEL VOL ',I2,3X,A5)

      PRINT 8002, ITRA, ISTAK, IPART, ITRTYP,
     +            AMASS * 1000., INT (CHARGE), IPAOLD, NUMOLD
 8002 FORMAT (
     + T2, 'ITRA=',I4, ' ,ISTAK=',I4, ' ,IPART=',I4,
     +     ' ,ITRTYP=',I4, ' ,MASS=',F6.1, ' ,Q=',I3, ' ,PARENT=',I4,
     +     ' ,OLD MED=',I3)

      PRINT 8004, (VECT(I),I=1,6), GETOT * 1000., GEKIN * 1000.,
     +            NSTEP, STEP, DESTEP * 1000.,
     +            INWVOL, ISTOP
 8004 FORMAT (
     + T2,'X,Y,Z=',3F7.1,' ,CX,CY,CZ=',3F7.3,' ,E,EK=',2F7.1,
     + /  'STEP# ',I4, ' ,STEPL=',F6.3, ' ,ELOSS=',F7.3,
     +    ' ,NEWVOL=',I3, ' ,ISTOP=',I3)

      NMEC1 = MIN ( NMEC, 8 )
      PRINT 8005, NMEC,
     +            ( I, LMEC(I), NAMEC(LMEC(I)), I=1,NMEC1)
 8005 FORMAT ( T2, ' # OF MECANISM IN THIS STEP = ' ,I2,
     +         8 ( /T2, I4, ' LMEC(I), NAMEC (LEMEC (I)) = ',
     +            I4, A10 ))
C
C-------------------------------------------------------------------
C
 8011 CONTINUE
C                  STORE PARTICLE POSITION FOR DRAWING TRACKS
CC    CALL GSXYZ
C
C-------------------------------------------------------------------
C
C
C              SECONDARIES GENERATED ?

      IF(NGKINE.GT.0) THEN
C       PRINT 9102, NGKINE, KCASE,
C    +             ( INT ( GKIN(5,I) ) , GKIN(4,I) * 1000. ,I=1,NGKINE)
C9102   FORMAT (
C    +   T2, I4, ' SECONDARIES BY ',A5, ' : TYP, E=',
C    +       20 ( 5 ( I5, F7.1 ) /) )
        DO 30 I=1,NGKINE
        ITYPA  = GKIN(5,I)
C                         PUT SECONDARIES ONTO STACK
CC      CALL GSKING(I)
   30   CONTINUE
      ENDIF
      IF(NGKINE.GT.0) CALL GSKING(0)
C
C---CHECK TO SEE THAT PARTICLE IS IN A SCINTILLATOR
      IF(NUMED.NE.26.OR.NUMBER(2).GT.16) GOTO 999
C
C---FIND MIDPOINT OF LAST TRACKING STEP
C
CC    WRITE(6,8007) PRVECT(1),PRVECT(2),PRVECT(3),VECT(1),VECT(2),
CC   &              VECT(3)
 8007 FORMAT(1X,'PRVECT : ',3F8.2,/T2,'VECT : ',3F8.2)
C
      X=(PRVECT(1)+VECT(1))/2
      Y=(PRVECT(2)+VECT(2))/2
      Z=(PRVECT(3)+VECT(3))/2
C
CC    WRITE(6,8008) X,Y,Z
 8008 FORMAT(1X,'MEAN COORDS : ',3F8.2)
C
C---DETERMINE WHICH OCTANT WAS HIT
C
      IF (NUMBER(2).GT.8) THEN
         NOCT=NUMBER(2)-8
      ELSE
         NOCT=NUMBER(2)
      ENDIF
C
CC    WRITE(6,8009) NUMBER(2),NOCT
 8009 FORMAT(1X,'HIT OCTANT ',2I4)
C
C---TRANSLATE AND ROTATE MIDPOINT ACCORDING TO SEGMENT
C
      CALL TRANS(X,Y,NOCT,XTRANS,YTRANS)
C
CC    WRITE(6,8010) XTRANS,YTRANS
 8010 FORMAT(1X,' XTRANS ',F8.2,' YTRANS ',F8.2)
C
C---MODIFY DEPOSITED ENERGY ACCORDING TO RADIAL PARAMETRISATION
C
      CALL EMOD(XTRANS,YTRANS,NOCT,DESTEP,ENMOD,IBLOCK)
C
CC    WRITE(6,8012) DESTEP,ENMOD
 8012 FORMAT(1X,' DESTEP ',F8.4,' ENMOD ',F8.4)
C
C
C---STORE POSITION COORDINATES
C
      PRVECT(1)=VECT(1)
      PRVECT(2)=VECT(2)
      PRVECT(3)=VECT(3)
C
CC    WRITE(6,8013) PRVECT(1),PRVECT(2),PRVECT(3)
 8013 FORMAT(1X,'PRVECT : ',3F8.2)
C
C---SUM THE BLOCK ENERGY
C
      EBLOCK(NUMBER(2),IBLOCK)=EBLOCK(NUMBER(2),IBLOCK)+ENMOD
C
CC    WRITE(6,8014) NUMBER(2),IBLOCK,EBLOCK(NUMBER(2),IBLOCK)
 8014 FORMAT(1X,' HIT OCTANT ',I4,' HIT BLOCK ',I4,' TOT ENERGY ',F8.4)
C
 999  RETURN
      END
C***********************************************************************
C ROUTINE TO MAP THE GLOBAL COORDINATES OF AN OCTANT ONTO A SINGLE
C REFERENCE OCTANT.
C
C   INPUT    X,Y,NOCT
C   OUTPUT   XTRANS,YTRANS
C
C  X,Y           = GLOBAL COORDINATES
C  NOCT          = OCTANT NUMBER
C  XTRANS,YTRANS = COORDINATES WITHIN REFERENCE OCTANT
C  P(I,J)        = PARAMETERS OF TRANSLATION
C                  J = OCTANT NUMBER
C                  I = 1 X TRANSLATION, 2 Y TRANSLATION,3 ROTATION ANGLE
C
      SUBROUTINE TRANS(X,Y,NOCT,XTRANS,YTRANS)
C
      COMMON / CTRANS / P(3,8)
      COMMON/GCONST/PI,TWOPI ,PIBY2,DEGRAD,RADDEG,CLIGHT ,BIG,EMASS
C
C---CONVERT ANGLE TO RADIANS
C
      PHI=TWOPI*P(3,NOCT)/360.0
C
      XTRANS=(X-P(1,NOCT))*COS(PHI) + (Y-P(2,NOCT))*SIN(PHI)
      YTRANS=(Y-P(2,NOCT))*COS(PHI) - (X-P(1,NOCT))*SIN(PHI) + 7.39
C
      RETURN
      END
C***********************************************************************
C MODIFICATION OF ENERGY ACCORDING TO RADIAL PARAMETRISATION
C
      SUBROUTINE EMOD(XTRANS,YTRANS,NOCT,DESTEP,ENMOD,IBLOCK)
C
C---DETERMINE WHICH YBIN OF REFERENCE FRAME ENERGY IS DEPOSITED
C
      DO 10 I1=1,2
         YCOORD=I1*0.5
         IF(YTRANS.LT.YCOORD) THEN
            IYVAL=I1
            IBLOCK=1
            GOTO 20
         ENDIF
 10   CONTINUE
      IF(YTRANS.LT.1.48) THEN
         IYVAL=3
         IBLOCK=1
         GOTO 20
      ENDIF
      DO 30 I1=4,8
         YCOORD=I1*0.5
         IF(YTRANS.LT.YCOORD) THEN
            IYVAL=I1
            IBLOCK=2
            GOTO 20
         ENDIF
 30   CONTINUE
      IF(YTRANS.LT.4.44) THEN
         IYVAL=9
         IBLOCK=2
         GOTO 20
      ENDIF
      DO 40 I1=10,30
         YCOORD=I1*0.5
         IF(YTRANS.LT.YCOORD) THEN
            IYVAL=I1
            IBLOCK=3
            GOTO 20
         ENDIF
 40   CONTINUE
C
C---NOW THE X BIN
C
 20   DO 50 I1=-19,20
         XCOORD=I1*0.5
         IF(XTRANS.LT.XCOORD) THEN
            IXVAL=I1+20
            GOTO 60
         ENDIF
 50   CONTINUE
 60   CONTINUE
C
CC    WRITE(6,8001) IXVAL,IYVAL
 8001 FORMAT(1X,'IXVAL ',I4,' IYVAL ',I4)
C
C---NOW ADD RADIAL CORRECTION
C
      CALL RADRES(NOCT,IXVAL,IYVAL,DESTEP,ENMOD)
C
      RETURN
      END
C***********************************************************************
C---Subroutine to increase the response of the outer block as seen in
C   the beam test data
C
      SUBROUTINE RADRES(NOCT,IXVAL,IYVAL,DESTEP,ENMOD)
C
      COMMON / RADPAR / RMIN(8),RADFIT(8)
C
C---CALCULATE THETA VALUE FROM IYVAL COORDINATE
C
      THETA=ATAN((RMIN(NOCT)+IYVAL*5.0)/(2950.+156.))
C---convert to mrads
      THETA=THETA*1000.
C
C     WRITE(6,8001) THETA
 8001 FORMAT(1X,' THETA (MRAD) ',F8.2)
C
C---Calculate response factor for this value of theta
C
      RESP=0.0
      IF(THETA.GT.55.AND.THETA.LT.63) THEN
         RESP=RADFIT(1)*THETA**2 + RADFIT(2)*THETA + RADFIT(3)
C
C---Correct the energy accordingly
C
         ENMOD=RESP*DESTEP
      ELSE
         ENMOD=DESTEP
C
C        WRITE(6,8002) DESTEP,RESP,ENMOD
 8002    FORMAT(1X,' DESTEP ',F8.4,'RESP ',F7.4,'ENMOD ',F8.4)
C
      ENDIF
C
      RETURN
      END

C   28/03/97 703282256  MEMBER NAME  JEOSUM4  (JADE56.S)    FORTRAN
C   03/03/89 903031529  MEMBER NAME  GEANTCOM (S)        M  FORTRAN
*
*   Modifications of JADE MC, version SF56, for use of GEANT in tagger
*                                                (acc. to C. Howarth)
*

MCJADE:   LFLAG(8) is set .TRUE. for the usage of GEANT in tagger. Note
=======   that LFLAG(7) invokes GEANT for the lead glass (D. Pitzl).
          Present version of MCJADE does not support this.

          IF(LFLAG(8)) CALL GEANTI

MCTAGM:   LFLAG(8) steers the inner acceptance:  19.4 mrad with Geant,
=======   32 mrad without. MCTAGE is not called, after CALL TGEANT the
          subroutine is left. The preceeding call to MCTAGC is of no
          consequence, XSH and YSH, which are calculated, are used as
          input to MCTAGE and thus dummy with GEANT. Note that XSH, YSH
          are calculated using the radiation length, which for a long
          time was wrong for the MarkIII tagger  (22.39 mm instead of
          25.3 mm).

STHEAD:   Word 15 (overflow word) is set to 1 if LFLAG(8)=.TRUE.
=======


It is possible to use MCJADEGE and MCTAGMGE, with and without GEANT,
by including the member GEANTDUM (holds subr. GEANTI and TGEANT).
Member #LINKMCG on F11OLS.JADE56.S

C   03/03/89 903031529  MEMBER NAME  JOBINFO  (S)        M  FORTRAN
***********************************************************************
   INFORMATION ON JOBS ON JADE56.S
***********************************************************************

#CERTST1:    GENERATE DATA FOR NPECER DETERMINATION, SF6 VERSION
   USES @CERTST1                             NTRY=100, N=1.76
#CERTST2:    GENERATE DATA FOR NPECER DETERMINATION, SF5 VERSION
   USES @CERTST3                             NTRY=100, N=1.6725,1.76
#CERTST3:    GENERATE DATA FOR NPECER DETERMINATION, SF5 VERSION
   USES @CERTST3                             NTRY=20, N=1.6725,1.76
#CERTST4:    GENERATE DATA FOR NPECER DETERMINATION, SF6 VERSION
   USES @CERTST1                            NTRY=100, N=1.805
#CERTST5:    GENERATE DATA FOR NPECER DETERMINATION, SF5 VERSION
   USES @CERTST3, CORRECTED                  NTRY=20, N=1.6725
   LATER UPDATED FOR GEP USES (FILES CERTST5.NR1...
   USES @CERTST4, WITH GEP PLOTS


#CERFIT1-D:  FIT PE/X0 DATA, SF6(N=1,76)
#CERSF51-5:  FIT PE/X0 DATA, SF5(N=1,76)   FROM #CERTST3
    #CERSF55 IS THE GEP VERSION
#CERSF56  :  FIT PE/X0 DATA, SF5(N=1,6725), FROM #CERTST5

#CERFJTA:  FIT PE/X0 DATA, SF6(N=1,805)

#FNPECER:  GRAPHICAL DISPLAY OF NPECER.
 USES @FNPECER AND VERSION FNPECER, WITH EXTRA ARGUMENT FOR PASSING A1-2


#CERSF6E:    FITTING SF6 DATA WITH 2-PARAMETER
#CERSF6G:    FITTING SF6 DATA WITH 3-PARAMETER

#UNIGAM:    CREATE 4V-DATASET OF MONOCHROMATIC PHOTONS
JBUNIGAM:   ANALYSE TRACKED UNIGAM EVENTS

C   23/05/87 705251722  MEMBER NAME  SUMCOR   (S)           FORTRAN

LGECORX: LGECOR, CORRECTED FOR SYSTEMATIC ERROR AT LOWEST ENERGIES

LGECORY: LGECORX, THICKER ABSORBER FOR 1984-1986

LGECORZ: LGECORY, BUT CALL ENLOSG INSTEAD OF ENGLOS

LGECORYT: LGECORY, BUT CALL THCORR IN ADDITION

LGECORZT: LGECORZ, BUT CALL THCORR IN ADDITION

LGECORWT: LGECORZT, BUT CALL LKCORR IN ADDITION

C   25/04/82 706031308  MEMBER NAME  SUMETPRF (S)           FORTRAN
C   25/04/82 706031308  MEMBER NAME  SUMUNIG  (S)           FORTRAN
C   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -  -
C                 SUMMARY OF MONTE CARLO GENERATION                    I
C   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -   -  -

            * * * * * * * * * * * * * * * * * * * * * * * * *
            *   REACTION  E+E-  --->  E+E- ETAPRIME(957)    *
            * * * * * * * * * * * * * * * * * * * * * * * * *

4-VECTOR INPUT
--------------
   LIM = 1       F11OLS.ETAPRIV4     19476    (ONLY PI+PI-GAM DECAY)
   LIM = 3       F11OLS.ETAPRIV5     20524    (ONLY PI+PI-GAM DECAY)
   LIM = 5       F11OLS.ETAPRIV6     20471    (ONLY PI+PI-GAM DECAY)
   LIM = 7       F11OLS.ETAPRIV4     19310    (ONLY PI+PI-GAM DECAY)
   LIM = 9       F11OLS.ETAPRIV5     19121    (ONLY PI+PI-GAM DECAY)
   LIM = 11      F11OLS.ETAPRIV4     19626    (ONLY PI+PI-GAM DECAY)

 (PSEUGG1.ETAPRIRF.B17P3)

TRACKING   JBMCJADT TWO CHARGED PARTICLES WITH
           COSLMC FROM 227,1180 AT LEAST 16 WIRES IN JET CHAMBER
           COSLMC /0.9820/,XMOLIM/.080/,XPTLIM/.050/
--------

ETAPRIV4 (LIM1)
--------
ETPRF.NR0           0 -   312 -->   169 EVENTS
ETPRF.S1          313 -  6500 -->  3204 EVENTS
ETPRF.S2         6501 - 13000 -->  3442 EVENTS
ETPRF.S3        13001 - 19476 -->  3425 EVENTS

 MERGE:                                   MSETPRF.SUM1  10240 EVENTS

ETAPRIV5 (LIM3)
--------
             0 - 17380-400 -->       EVENTS   ERROR IN FWDDET,COORD

 MERGE:                                   MSETPRF.SUM2  9151  EVENTS

ETAPRIV4 (LIM7)
--------
ETPRF.S1            0 -  6500 -->  3399 EVENTS
ETPRF.S2         6501 - 13000 -->  3407 EVENTS
ETPRF.S3        13001 - 19310 -->  3350 EVENTS

 MERGE:                                   MSETPRF.SUM3 10156 EVENTS


ETAPRIV5,6 (LIM9,5)
--------
             0 - 22160-180 -->       EVENTS   ERROR IN FWDDET,COORD

 MERGE:                                   MSETPRF.SUM4  11556 EVENTS


ETAPRIV4 (LIM11)
--------
ETPRF.S1            0 -  6500 -->  3330 EVENTS
ETPRF.S2         6501 - 13000 -->  3492 EVENTS
ETPRF.S3        13001 - 19626 -->  3551 EVENTS

 MERGE:                                   MSETPRF.SUM5 10373 EVENTS


ETAPRIV4 (LIM13)
--------
ETPRF.S1            0 -  6500 -->  3475 EVENTS
ETPRF.S2         6501 - 13000 -->  3418 EVENTS
ETPRF.S3        13001 - 19626 -->  3703 EVENTS

 MERGE:                                   MSETPRF.SUM6 10602 EVENTS

TG21,LGECORM,RDDATE81,STANDARD SELECTION
----------------------------------------
MSETPRF.SUM1      0 - 10240 -->  4839 EVENTS   MSETPRF.BSUM811
MSETPRF.SUM2      0 -  9151 -->  4256 EVENTS   MSETPRF.BSUM812
MSETPRF.SUM3      0 - 10156 -->  4674 EVENTS   MSETPRF.BSUM813
MSETPRF.SUM4      0 - 11556 -->  5381 EVENTS   MSETPRF.BSUM814
MSETPRF.SUM5      0 - 10373 -->  4860 EVENTS   MSETPRF.BSUM815
MSETPRF.SUM6      0 - 10596 -->  5006 EVENTS   MSETPRF.BSUM816


TG21,LGECORM,RDDATE82,STANDARD SELECTION
----------------------------------------
MSETPRF.SUM1      0 - 10240 -->  4839 EVENTS   MSETPRF.BSUM821
MSETPRF.SUM2      0 -  9151 -->  4256 EVENTS   MSETPRF.BSUM822
MSETPRF.SUM3      0 - 10156 -->  4674 EVENTS   MSETPRF.BSUM823
MSETPRF.SUM4      0 - 11556 -->  5381 EVENTS   MSETPRF.BSUM824
MSETPRF.SUM5      0 - 10373 -->  4860 EVENTS   MSETPRF.BSUM825
MSETPRF.SUM6      0 - 10596 -->  5006 EVENTS   MSETPRF.BSUM826

////////////////////////////////////////////////////////////////////////

4-VECTOR INPUT
--------------
   LIM = 1       F11OLS.ETAPRIV4     23509    (ONLY GAM-GAM DECAY)
   LIM = 3       F11OLS.ETAPRIV5     21978    (ONLY GAM-GAM DECAY)

 (PSEUGG1.ETAPRIRF.B17P3)


TRACKING (INCLUDE JBMCJADS STANDARD SETTING, DEMAND 2 PHOTONS WITH
--------     COSTHE < .870)

ETAPRIV5 (LIM3)
--------
ETPRFG.S1            0 -  6100 -->  3272 EVENTS
ETPRFG.S2         6101 - 12100 -->  3190 EVENTS
ETPRFG.S3        12101 - 18100 -->  3247 EVENTS
ETAPRIV5         18101 - 21978 -->  2081 EVENTS


ETAPRIV4 (LIM1)
--------
ETPRFG.S4            0 -  6000 -->  3174 EVENTS
ETPRFG.S5         6001 - 12000 -->  3192 EVENTS
ETPRFG.S6        12001 - 18000 -->  3238 EVENTS
ETAPRIV4         18001 - 23509 -->  2929 EVENTS

 MERGE S1-3,ETAPRIV5,S4-6,ETAPRIV4        MSETPRFG.SUM1  24629 EVENTS


TG02,ENGLOSM,STANDARD SELECTION (LIM 3)
-------------------------------

PI0RF.S1            0 -  3272 -->   1931 EVENTS
PI0RF.S2            0 -  3190 -->   1915 EVENTS
PI0RF.S3            0 -  3247 -->   1937 EVENTS
ETAPRIV5            0 -  2081 -->   1241 EVENTS
                                       BS1,BS2,BS3,BS4
TR02FS.ETPRF1    3846 EVENTS
TR02FS.ETPRF2    3178 EVENTS

TG02,ENGLOSM,STANDARD SELECTION (LIM 1)
-------------------------------

PI0RF.S4            0 -  3174 -->   1888 EVENTS
PI0RF.S5            0 -  3192 -->   1899 EVENTS
PI0RF.S6            0 -  3238 -->   1997 EVENTS
ETAPRIV4            0 -  2929 -->   1825 EVENTS
                                    B15-B30
TR02FS.ETPRF3    3787 EVENTS
TR02FS.ETPRF4    3822 EVENTS

 MERGE                                    MSETPRFG.BSUM1  14633 EVENTS

////////////////////////////////////////////////////////////////////////

4-VECTOR INPUT
--------------
   LIM = 1       F11OLS.ETAPRIV4      19123   (ONLY PI+PI-ETA(GG) DECAY)
   LIM = 3       F11OLS.ETAPRIV5      17928   (ONLY PI+PI-ETA(GG) DECAY)

 (PSEUGG1.ETAPRIRF.B17P3)


TRACKING   JBMCJADT TWO CHARGED PARTICLES WITH
           COSLMC FROM 227,1180 AT LEAST 16 WIRES IN JET CHAMBER
           COSLMC /0.9820/,XMOLIM/.040/,XPTLIM/.030/
           OR AT LEAST TWO PHOTONS WITH COSTHE < .87
--------

ETAPRIV4 (LIM1)  400 EV/3MIN
--------
ETPPGG.S1            0 -  9800 -->  5800 EVENTS  (1520 TRACKS)
ETPPGG.S2         9801 - 14600 -->  2907 EVENTS
PI0RF.BS4        14601 - 19123 -->  2666 EVENTS

ETAPRIV5 (LIM3)
--------
ETPPGG.S3            0 -  6000 -->  3704 EVENTS
ETPPGG.S4         6001 - 12000 -->  3615 EVENTS
ETPPGG.S5        12001 - 17928 -->  3593 EVENTS

    MERGE ETPPGG.S1,S2,PI0RF.BS4,ETPPGG.S3-5
                                 MSETPPGG.SUM3   22473  EVENTS


TG22, PTOT>.03,RMIN<40,ZMIN<200,NMBDMX 5,NTRMAX 15,STANDARD PHOTONS
   STANDARD ENGLOS WAS USED, BY MISTAKE

ETPPGG.S1            0 -  5800 -->  927  EVENTS
ETPPGG.S2            0 -  2907 -->  426  EVENTS
PI0RF.BS4            0 -  2666 -->  426  EVENTS
                                 ON PI0RF.BS3,BS2

ETPPGG.S3            0 -  3704 -->  574  EVENTS
ETPPGG.S4            0 -  3615 -->  527  EVENTS
ETPPGG.S5            0 -  3593 -->  576  EVENTS
                                 ON ETPPGG.BS1-3
  MERGE PI0RF.BS3,BS2,ETPPGG.BS1-3      MSETPPGG.B22SUM4   3456 EVENTS

TR22FS.B22SUM4A      1779 EVENTS
TR22FS.B22SUM4B      1677 EVENTS


TG22, PTOT>.03,RMIN<40,ZMIN<200,NMBDMX 5,NTRMAX 15,STANDARD PHOTONS
   LGECORM AND TLOOP24 WERE USED

MSETPPGG.SUM3          0 - 22285 --> 3497  EVENTS, MSETPPGG.B22SUM5

TR22FS.B22SUM5A      2000 EVENTS
TR22FS.B22SUM5B      1497 EVENTS


########################################################################


4-5 1987:  ETAPRIME --> PI+PI- ETA, ETA --> GG

4-VECTOR (#PSEU40,41):   PSEUGG1.ETAPRIRF.B18P62
(18.62 GEV IS MEAN BEAM ENERGY FOR 1982-86)

ETAPRIV4.NR1:   9382
ETAPRIV4.NR2:  11384
ETAPRIV4.NR3:  10924
ETAPRIV4.NR4:  10924
ETAPRIV4.NR5:  10923
ETAPRIV4.NR6:  11436
ETAPRIV4.NR7:  11436
ETAPRIV4.NR8:  11436
ETAPRIV4.NR9:  11436
ETAPRIV4.NR10: 11436

TRACKING WITH SF5/SF6 MC, IVER56 = 1
************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  4800  --->   4800 EVENTS   ETA86.SUMNR2
NR1:   4801 -  9382  --->   4582 EVENTS   ETA86.SUMNR3
NR2:      0 -  5600  --->   5600 EVENTS   ETA86.SUMNR4
NR2:   5601 -  9382  --->   5773 EVENTS   ETA86.SUMNR5
NR3:      0 -  5400  --->   5290 EVENTS   ETA86.SUMNR67
NR3:   5401 - 10720  --->   5227 EVENTS   ETA86.SUMNR8
NR4:      0 -  5400  --->   5267 EVENTS   ETA86.SUMNR9A,9B,9C
NR4:   5401 - 10798  --->   5297 EVENTS   ETA86.SUMNR1

SUM NR2-1               ETAPRI86.SUM1TO4   41836    EVENTS

NR5:      0 -  5600  --->   5600 EVENTS   ETA86.SUMNR1
NR5:   5601 - 10923  --->   5323 EVENTS   ETA86.SUMNR2
NR6:      0 -  5600  --->   5600 EVENTS   ETA86.SUMNR3
NR6:   5601 - 11429  --->   5817 EVENTS   ETA86.SUMNR4
NR7:      0 -  5600  --->   5600 EVENTS   ETA86.SUMNR5
NR7:   5601 - 11351  --->   5735 EVENTS   ETA86.SUMNR67
NR8:      0 -  5600  --->   5597 EVENTS   ETA86.SUMNR8
NR8:   5601 - 11436  --->   5836 EVENTS   ETA86.SUMNR9A,B,C

SUM NR1-9               ETAPRI86.SUM5TO8    45108   EVENTS

NR9:      0 -  5600  --->   5600 EVENTS   ETAPRI86.SUMNR2
NR9:   5601 - 10923  --->   5323 EVENTS   ETAPIR86.SUMNR3
NR10:     0 -  5600  --->   5600 EVENTS   ETAPRI86.SUMNR4
NR10:  5601 - 11405  --->   5786 EVENTS   ETAPRI86.SUMNR5

SUM NR1-9               ETAPRI86.SUM9TO10   22309   EVENTS



TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.SUM1TO4       41836 -->  4347 EVENTS, ETAP2286.ENGLOSX.BSUM1T9
ETAPRI86.SUM5TO8       45108 -->  4802 EVENTS, ETAP2286.ENGLOSX.CSUM1T9
ETAPRI86.SUM9TO10      42309 -->       EVENTS, ETAP2286.ENGLOSX.DSUM2T5

FAST FILES:   TR22FS.ENGLOSX.MCNR2T5, MCNR6T1
FAST FILES:   TR22FS.ENGLOSX.MCANR2T5, MCANR6T1
FAST FILES:   TR22FS.ENGLOSX.MCBNR2T5

                               ENGLOSM WITH LGECORX
                               ********************
                                                               (32 M)
ETAPRI86.SUM1TO4       41836 -->  4442 EVENTS, ETAP2286.ENGLOSMX.BSUM1T9

FAST FILES:   TR22FS.ENGLOSMX.BSUM1T4A,B    2200,2242



TG12, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.SUM1TO4       41836 -->  5396 EVENTS, ETAP1286.ENGLOSX.BSUM1T9
ETAPRI86.SUM5TO8       45108 -->  5780 EVENTS, ETAP1286.ENGLOSX.CSUM1T9

FAST FILES:   TR12FS.ENGLOSX.MCNR1T5, MCNR6T9
FAST FILES:   TR12FS.ENGLOSX.MCANR1T5, MCANR6T9

                               ENGLOSM WITH LGECORX
                               ********************

ETAPRI86.SUM1TO4       41836 -->  5405 EVENTS, ETAP1286.ENGLOSMX.BSUM1T9

FAST FILES:   TR12FS.ENGLOSMX.BSUM1T4A,B    2700,2705


TRACKING WITH MEIER/MAGNUSSEN TRLGSH/6
**************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  4800  --->   4800 EVENTS   ETA86.SUMNR1
NR1:   4801 -  9382  --->   4582 EVENTS   ETA86.SUMNR2
NR2:      0 -  5700  --->   5700 EVENTS   ETA86.SUMNR3
NR2:   5701 - 11400  --->   5700 EVENTS   ETA86.SUMNR4
NR3:      0 -  5400  --->   5400 EVENTS   ETA86.SUMNR5
NR3:   5401 - 10860  --->   5460 EVENTS   ETA86.SUMNR67
NR4:      0 -  5400  --->   5400 EVENTS   ETA86.SUMNR8
NR4:   5401 - 10830  --->   5430 EVENTS   ETA86.SUMNR9A,B,C

SUM NR1-9               ETAPMM86.SUM1TO4    42472   EVENTS

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPMM86.SUM1TO4       42472 -->  4396 EVENTS, ETAPMM86.NR1T4,NR5T9

FAST FILES:   TR22FS.ENGLOSX.MMNR1T4, MMNR5T9




TRACKING WITH OLD TOKYO SF5 PROGRAM
***********************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  4800  --->   4800 EVENTS   ETAPRI86.TUMNR1
NR1:   4801 -  9382  --->   4582 EVENTS   ETAPRI86.TUMNR2
NR2:      0 -  5600  --->   5600 EVENTS   ETAPRI86.TUMNR3
NR2:   6701 - 11406  --->   5806 EVENTS   ETAPRI86.TUMNR4
NR3:      0 -  5600  --->   5600 EVENTS   ETAPRI86.TUMNR5
NR3:   5601 - 10923  --->   5321 EVENTS   ETAPRI86.TUMNR6
NR4:      0 -  5600  --->   5599 EVENTS   ETAPRI86.TUMNR7
NR4:   5601 - 10923  --->   5328 EVENTS   ETAPRI86.TUMNR8

TUM NR1-8               ETAPRI86.TUM1TO4     42636  EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.TUM1TO4       42636 -->  4762 EVENTS, ETAP2286.TNR1T8

FAST FILES:   TR22FS.ENGLOSX.TNR1T3, TNR4T6,TNR7T8



TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, BUT WITH STANDARD NPECER
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  4800  --->   4800 EVENTS   ETAPRI86.TUMNR1
NR1:   4801 -  9382  --->   4582 EVENTS   ETAPRI86.TUMNR2
NR2:      0 -  5600  --->   5200 EVENTS   ETAPRI86.TUMNR3
NR2:   6701 - 11368  --->   5754 EVENTS   ETAPRI86.TUMNR4
NR3:      0 -  5600  --->   5588 EVENTS   ETAPRI86.TUMNR5
NR3:   5601 - 10923  --->   5242 EVENTS   ETAPRI86.TUMNR6
NR4:      0 -  5600  --->   5199 EVENTS   ETAPRI86.TUMNR7
NR4:   5601 - 10923  --->   5323 EVENTS   ETAPRI86.TUMNR8

TUM NR1-8               ETAPRI86.NPEC1TO4     41688  EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.NPEC1TO4       41688 -->  4395 EVENTS, ETAP2286.NPEC1TO8

FAST FILES:   TR22FS.ENGLOSX.NPEC1T3, NPEC4T6,NPEC7T8




TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, STANDARD NPECER, 57 VERSION
(REPLACING THICK AL COIL WITH THIN LG COIL, LIKE OLD SETUP)
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  4800  --->   4800 EVENTS   ETAPRI86.SUM1
NR1:   4801 -  9382  --->   4582 EVENTS   ETAPRI86.SUM2
NR2:      0 -  5600  --->   5600 EVENTS   ETAPRI86.SUM3
NR2:   5601 - 11368  --->   5720 EVENTS   ETAPRI86.SUM4
NR3:      0 -  5600  --->   5600 EVENTS   ETAPRI86.SUM5
NR3:   5601 - 10923  --->   5323 EVENTS   ETAPRI86.SUM6
NR4:      0 -  5600  --->   5600 EVENTS   ETAPRI86.SUM7
NR4:   5601 - 10923  --->   5323 EVENTS   ETAPRI86.SUM8

 SUM1-8               ETAPRI86.NP571TO4     42548  EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
**********************************************************

ETAPRI86.NP571TO4      42548  -->  4257 EVENTS, ETAP2286.NP571TO8

FAST FILES:   TR22FS.ENGLOSX.NP571T3, NP574T6,NP577T8

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
**********************************************************
OLD VERSION, NOT WITH LG-COIL BUT WITH STANDARD AL-COIL
ETAPRI86.NP571TO4      33073  -->  3572 EVENTS, ETAP2286.NP583TO8

FAST FILES:   TR22FS.ENGLOSX.NP583T5, NP585T8


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
REMAKE WITH LGCLWAR: UPDATE ALGN WITH BBLEAK, REDO LGCL,RESO
**********************************************************

ETAP2286.NP571TO8       4257  -->  4257 EVENTS, ETAP2286.NP611TO8

FAST FILES:   TR22FS.ENGLOSX.NP611T3, NP614T6, NP617T8





TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LGMC56TJ VERSION
(VARYING COIL THICKNESS ACC. TO SUBR. TJOCK)
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  4800  --->   4800 EVENTS   ETAPRI.SUM1
NR1:   4801 -  9382  --->   4582 EVENTS   ETAPRI.SUM2
NR2:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM3
NR2:   5601 - 11368  --->   5696 EVENTS   ETAPRI.SUM4
NR3:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM5
NR3:   5601 - 10923  --->   5322 EVENTS   ETAPRI.SUM6
NR4:      0 -  5600  --->   4752 EVENTS   ETAPRI.SUM7
NR4:   5601 - 10923  --->   5323 EVENTS   ETAPRI.SUM8
NR6:      0 -  4400  --->   4400 EVENTS   ETAPRI.SUM11

 SUM1-11              ETAPRI86.NPTJ1TO4    46075   EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.NPTJ1TO4      42548  -->  4995 EVENTS, ETAP2286.NPTJ1TO8

FAST FILES:   TR22FS.ENGLOSX.NPTJ1T3, NPTJ4T6,NPTJ7T11

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLWAR 1.05,0.95 AND BBLEAK CORR.
**********************************************************

ETAPRI86.NPTJ1TO4      42548  -->  4995 EVENTS,   NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.P5M51T3, P5M54T6,P5M57T11

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLVAR 1.10,1.00
**********************************************************

ETAPRI86.NPTJ1TO4      42548  -->  4995 EVENTS,   NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.P10M1T3, P10M4T6,P10M7T11





TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LGMC56TJ, LSCCTLNL
(VARYING COIL THICKNESS ACC. TO SUBR. TJOCK, BUT NO LOSS WHATSOEVER
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  4800  --->   4800 EVENTS   ETAPRI.SUM1
NR1:   4801 -  9382  --->   4582 EVENTS   ETAPRI.SUM2
NR2:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM3
NR2:   5601 - 11368  --->   5627 EVENTS   ETAPRI.SUM4
NR3:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM5
NR3:   5601 - 10923  --->   5323 EVENTS   ETAPRI.SUM6

 SUM1-6               ETAPRI86.NPTJ01T3    31532   EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.NPTJ01T3       31532 -->  3474 EVENTS, ETAP2286.NPTJ01T6

FAST FILES:   TR22FS.ENGLOSX.NPTJ01T3, NPTJ04T6




TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LGMC56TJ, LSCCTL40
(VARYING COIL THICKNESS ACC. TO SUBR. TJOCK, LOSS CONST SET TO 40.
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM7
NR1:   5601 - 11368  --->   5836 EVENTS   ETAPRI.SUM8
NR2:      0 -  4800  --->   4800 EVENTS   ETAPRI.SUM9
NR2:   4801 -  9382  --->   4582 EVENTS   ETAPRI.SUM10
NR3:      0 -  5600  --->   5598 EVENTS   ETAPRI.SUM11
NR3:   5601 - 10923  --->   5322 EVENTS   ETAPRI.SUM5

 SUM7-5               ETAPRI86.NTJ401T3    31738   EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.NTJ401T3       31738 -->  3490 EVENTS, ETAP2286.NTJ401T6

FAST FILES:   TR22FS.ENGLOSX.NTJ401T3, NTJ404T6


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLVAR 1.05,1.00
**********************************************************

ETAPRI86.NTJ401T3       31738 -->  3490 EVENTS, NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJ40P513, TJ40P546

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLVAR 1.10,1.00
**********************************************************

ETAPRI86.NTJ401T3       31738 -->  3490 EVENTS, NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJ40PA13, TJ40PA46

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLVAR 1.07,1.04
**********************************************************

ETAPRI86.NTJ401T3       31738 -->  3490 EVENTS, NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJ40.P7P413, TJ40.P7P446

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLVAR 1.07,0.96
**********************************************************

ETAPRI86.NTJ401T3       31738 -->  3490 EVENTS, NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJ40.P7M413, TJ40.P7M446



TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LGMC56EO, LSCCTLNL
(STANDARD AL COIL, NO LOSS, STANDARD ELGOBS LOSSES IMPOSED
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM1
NR1:   5601 - 11368  --->   5821 EVENTS   ETAPRI.SUM4
NR2:      0 -  4800  --->   5600 EVENTS   ETAPRI.SUM3
NR2:   4801 -  9382  --->   3782 EVENTS   ETAPRI.SUM2
NR3:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM5
NR3:   5601 - 10923  --->   5323 EVENTS   ETAPRI.SUM6

 SUM1-6               ETAPRI86.NPEO1TO3    31726   EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.NPEO1TO3       31726 -->  3230 EVENTS, ETAP2286.NPEO1T6

FAST FILES:   TR22FS.ENGLOSX.NPEO1T3, NPEO4T6


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLVAR 1.05,1.00
**********************************************************

ETAPRI86.NPTJ1TO4      31726  -->  3230 EVENTS,   NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJ40P513, TJ40P546

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
SCALE WITH LGCLVAR 1.10,1.00
**********************************************************

ETAPRI86.NPTJ1TO4      31726  -->  3230 EVENTS,   NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJ40PA13, TJ40PA46




TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LSCCTL20,LGMC56TJ
(STANDARD AL COIL WITH TJOCK, 51.7-->20
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR1:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM1
NR1:   5601 - 11368  --->   5640 EVENTS   ETAPRI.SUM4
NR2:      0 -  4800  --->   4800 EVENTS   ETAPRI.SUM3
NR2:   4801 -  9382  --->   4582 EVENTS   ETAPRI.SUM2
NR3:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM5
NR3:   5601 - 10923  --->   5323 EVENTS   ETAPRI.SUM6
NR4:        -  4792  --->   4792 EVENTS   ETAPRI.SUM7

 SUM1-6               ETAPRI86.TJ201TO4    36337   EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.TJ201TO4       36337 -->  3914 EVENTS, ETAP2286.TJ201T7

FAST FILES:   TR22FS.ENGLOSX.TJ201T3, TJ204T6, TJ207




UPDATE OF CONS: +7% SF5, +4% SF6

TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LSCCTL40,LGMC56TJ
(STANDARD AL COIL WITH TJOCK, 51.7-->40
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR5:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM1
NR5:   5601 - 11368  --->   5323 EVENTS   ETAPRI.SUM4
NR6:      0 -  4800  --->   5200 EVENTS   ETAPRI.SUM2
NR6:   4801 -  9382  --->   5726 EVENTS   ETAPRI.SUM3
NR7:      0 -  5600  --->   5600 EVENTS   ETAPRI.SUM5
NR7:   5601 - 10923  --->   5634 EVENTS   ETAPRI.SUM6
NR8:        -  4792  --->   5600 EVENTS   ETAPRI.SUM7
NR8:        -  4792  --->   5723 EVENTS   ETAPRI.SUM8

 SUM1-8               ETAPRI86.TJ401TO8    44406   EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORX,TLOOP24
**********************************************************

ETAPRI86.TJ401TO8       44406 -->  4880 EVENTS, ETAP2286.TJ40.P7P41TOE
                      (SUMMARY TAPE CONTAINS ALSO P7P4 FILES FROM
                       TRACKING OF 1-4)

FAST FILES:   TR22FS.ENGLOSX.TJ40.P7P479, TJ40.P7P4AC, TJ40.P7P4DE


TG22, NEUTRAL SEL. (.03,40.,5),ENLOSG WITH LGECORZ,TLOOP24
SCALE WITH LGCLVAR 1.00,1.00
**********************************************************

ETAPRI86.TJ401TO8       44406 -->  4880 EVENTS, NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJ40EG.P7P479, TJ40EG.P7P4AC, TJ40EG.P7P4DE



TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LSCCTL40,LGMC56TJ
(STANDARD AL COIL WITH TJOCK, 51.7-->40
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR11:     0 -  5600  --->   5595 EVENTS   ETAPRI.SUM1
NR11   5601 - 11200  --->   3258 EVENTS   ETAPRI.SUM3
NR11  11201 - 16800  --->   5600 EVENTS   ETAPRI.SUM4
NR11  16801 - 23800  --->   5600 EVENTS   ETAPRI.SUM5
NR12      0 -  3200  --->   3200 EVENTS   ETAPRI.SUM2
NR12   3201 -  7932  --->   4732 EVENTS   ETAPRI.SUM6
NR12   9601 - 15200  --->   5348 EVENTS   ETAPRI.SUM7
NR12  15200 -        --->   5600 EVENTS   ETAPRI.SUM8
NR11,12              --->   4000 EVENTS   ETAPRI.SUM9

 SUM1-9           ETAPRI86.TJ40PP1.SUM11T12    42933  EVENTS

NR9                  --->   4800 EVENTS   ETAPRI.SUM2
NR9                  --->   5353 EVENTS   ETAPRI.SUM6
NR10                 --->   5139 EVENTS   ETAPRI.SUM7
NR10                 --->   4800 EVENTS   ETAPRI.SUM9
NR12                 --->   2423 EVENTS   ETAPRI.SUM10
NR13                 --->   5600 EVENTS   ETAPRI.SUM12
NR13                 --->   5637 EVENTS   ETAPRI.SUM13
NR13                 --->   5600 EVENTS   ETAPRI.SUM14
NR13                 --->   5600 EVENTS   ETAPRI.SUM15
NR14                 --->   5600 EVENTS   ETAPRI.SUM16
NR14                 --->   5662 EVENTS   ETAPRI.SUM17
NR14                 --->   1600 EVENTS   ETAPRI86.NR29-32

 SUM2,6,7,9,10,12-17,86..   ETAPRI86.TJ40PP1.SUM9TO14    57814  EVENTS


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORY,TLOOP24
**********************************************************

ETAPRI86.TJ40PP1.SUM11T12  42933 --> 4897 EVENTS, ETAP2286.TJ40.P7P4FM

FAST FILES:   TR22FS.ENGLOSX.TJ40PP1.NR13,NR46,NR79

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORZT,TLOOP24
RESCALE WITH 1.0,1.0
**********************************************************

USE BSUM1,2,5,3,4,10,11,12 --> BSUM6,7,8, SUM1,8,3,4,5
  THESE ARE ALL TG22 DATA FROM TJ40 TRACKING
  BSUM6-8,SUM1,8  KEPT ON ETAP2286.ENGLOSX.TJ40PPZT.SUM1TOM

FAST FILES:   TR22FS.ENGLOSX.TJ40PPZT.NR13,NR46,NR79,NRAC,NRDE
              TR22FS.ENGLOSX.TJ40PPZT.NRFH,NRIK,NRLM

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24
RESCALE WITH 1.0,1.0
**********************************************************

USE BSUM1,2,5,3,4,10,11,12 --> BSUM6,7,8, SUM1,8,3,4,5
  THESE ARE ALL TG22 DATA FROM TJ40 TRACKING
  BSUM6-8,SUM1,8  KEPT ON ETAP2286.ENGLOSX.TJ40PPWT.SUM1TOM

FAST FILES:   TR22FS.ENGLOSX.TJ40PPWT.NR13,NR46,NR79,NRAC,NRDE
              TR22FS.ENGLOSX.TJ40PPWT.NRFH,NRIK,NRLM



TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
**********************************************************

TJ40PP1.SUM9TO14  57814 -->   6365 EVENTS, ETAP2286.TJ40PPWT.SUMNTOU

FAST FILES:   TR22FS.ENGLOSX.TJ40PPWT.NRNO,NRPQ,NRRS,NRTU




TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LSCCTLEL,LGMC56TJ
(STANDARD AL COIL WITH TJOCKI, AND 51.7 --> ELODIF
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR11                 --->   5600 EVENTS   ETAPRI.SUM1
NR11                 --->   5260 EVENTS   ETAPRI.SUM2
NR11                 --->   5200 EVENTS   ETAPRI.SUM3
NR11                 --->   5600 EVENTS   ETAPRI.SUM4
NR11,13              --->   5505 EVENTS   ETAPRI.SUM5
NR13                 --->   4800 EVENTS   ETAPRI.SUM10
NR13                 --->   5600 EVENTS   ETAPRI.SUM11
NR12                 --->   5600 EVENTS   ETAPRI.SUM6
NR12                 --->   5688 EVENTS   ETAPRI.SUM7
NR12                 --->   7185 EVENTS   ETAPRI.SUM8

 SUM1-8 (NOT 10,11)    ETAPRI86.TJEL.SUM1TO8   45638   EVENTS



TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
**********************************************************

TJEL.SUM1TO8, (10,11)   56038 --> 6072 EVENTS, ETAP2286.TJELPPWT.SUM1TO4

FAST FILES:   TR22FS.ENGLOSX.TJELPPWT.NR13,NR46,NR79   (NOT SUM8 PART)


TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
SCALE 0.95,0.95
**********************************************************

5333 EVENTS FROM SUM1-7, NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJELPPWT.M5M5NR13,M5M5NR46,M5M5NR79

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
SCALE 0.97,1.00
**********************************************************

5333 EVENTS FROM SUM1-7, NOT KEPT

FAST FILES:   TR22FS.ENGLOSX.TJELPPWT.M3M0NR13,M3M0NR46,M3M0NR79

FASTWRBB  (CORRECTED L7 WITH BBLEAK)
FAST FILES:   TR22FS.ENGLOSX.TJELBBWT.M3M0NR13,M3M0NR46,M3M0NR79





TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LSCCTLEL,LGMC56TJ
(STANDARD AL COIL WITH TJOCKI, AND 51.7 --> ELODIFENELMX
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR12                 --->   5200 EVENTS   ETAPRI.SUM1
NR12                 --->   5332 EVENTS   ETAPRI.SUM2
NR12                 --->   5600 EVENTS   ETAPRI.SUM3
NR11                 --->   7200 EVENTS   ETAPRI.SUM4
NR11                 --->   5300 EVENTS   ETAPRI.SUM5
NR11                 --->   5600 EVENTS   ETAPRI.SUM6
NR11                 --->   5600 EVENTS   ETAPRI.SUM7
NR13                 --->   7292 EVENTS   ETAPRI.SUM8
NR13                 --->   4800 EVENTS   ETAPRI.SUM10
NR13                 --->   4400 EVENTS   ETAPRI.SUM11

 SUM1-10               ETAPRI86.TJELMX.SUM1TO10  56324   EVENTS



TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
**********************************************************

TJEL.SUM1TO10       56324   --> 6683 EVENTS, ETAP2286.TJELMX.SUM1TO4

FASTWRBB
FAST FILES:   TR22FS.ENGLOSX.TJELPPWT.MR13,MR46,MR79

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
SCALE WITH 1.10,1.10
**********************************************************

SOME LOST DUE TO OVERFLOW, OUTPUT NOT KEPT

FASTWRBB                            1832,1845,1860
FAST FILES:   TR22FS.ENGLOSX.TJELPPWT.PAPAMR13,PAPAMR46,PAPAMR79

TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
SCALE WITH 1.13,1.07
**********************************************************

SOME LOST DUE TO OVERFLOW

FASTWRBB                            1832,1845,1859
FAST FILES:   TR22FS.ENGLOSX.TJELPPWT.PCP7MR13,PCP7MR46,PCP7MR79



TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LSCCTLEL,LGMC56TJ
(STANDARD AL COIL WITH TJOCKI, AND 51.7 --> ELODIF   ENELMX,MCIN56MX
****************************************************************
TRACKING WITHOUT CONDITIONS, ALL EVENTS
DATE IS 6/1986                      (EV.NR WITHOUT CONSTREC)

NR14                 --->  5600  EVENTS   ETAPRI.SUM1
NR14                 --->  5600  EVENTS   ETAPRI.SUM2
NR14                 --->  5600  EVENTS   ETAPRI.SUM3
NR14                 --->  7341  EVENTS   ETAPRI.SUM4
NR1                  --->  5600  EVENTS   ETAPRI.SUM5
NR1                  --->  5600  EVENTS   ETAPRI.SUM6
NR2                  --->  5600  EVENTS   ETAPRI.SUM7
NR2                  --->  5782  EVENTS   ETAPRI.SUM10,11
NR3                  --->  4800  EVENTS   ETAPRI.SUM9

 SUM1-9                ETAPRI86.TJELMXMX.SUM1TO9    51523  EVENTS



TG22, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
**********************************************************

SUM1TO9   51523 --> 5296 EVENTS, ETAP2286.ENGLOSX.TJELMXMX.SUM1TO3

FASTWRBB
FAST FILES:   TR22FS.ENGLOSX.TJELBBWT.PCP7MRAC,MRDF,MRGI


TG12, NEUTRAL SEL. (.03,40.,5),ENGLOS WITH LGECORWT,TLOOP24,RDALGNDB
**********************************************************

SUM1TO9   51523 --> 6745 EVENTS, ETAP1286.ENGLOSX.TJELMXMX.SUM1TO3

FASTWRBB
FAST FILES:   TR12FS.ENGLOSX.TJELPPWT.MRAB,MRCD,MREF,MRGI

************************************************************************
*                                                                      *
*          SUMMARY OF MONOCHROMATIC PHOTONS GENERATION                 *
*                                                                      *
************************************************************************

4-VECTOR DATA SETS, EACH 10000 EVENTS, PROGRAM #UNIGAM
              FROM D5 ON, 2000 EVENTS

E100 CORRESPONDS TO 100 MEV...
D1 CORRESPONDS TO Z = 40 MM, JITTER +- 20 MM, PHI ISOTROPIC TWOPI
D2 = 140 MM, D3 = 240 MM, D4 = 400 MM, D5 = 560 MM, D6 = 720 MM,
D7 = 880 MM, D8 = 1040 MM, D9 = 1200 MM, DA = 1360 MM, DB = 1520 MM,

UNIGAM4V.E100D1,D2,D3,D4,D5,D6,D7,D8,D9,DA,DB
UNIGAM4V.E200D1,E300D1,E400D1,E500D1,E600D1,E700D1,E800D1,E1000D1

TRACKING:
********

>>>>>>>>>>>>   SF5 (1982 DATE)

UNIGAM.E100D1.SF5       2000 EVENTS
UNIGAM.E200D1.SF5       1551 EVENTS
UNIGAM.E300D1.SF5       1104 EVENTS
UNIGAM.E400D1.SF5       1728 EVENTS
UNIGAM.E500D1.SF5       1393 EVENTS
UNIGAM.E600D1.SF5       1547 EVENTS
UNIGAM.E800D1.SF5       1321 EVENTS

UNIGAM.E100D2.SF5       2000 EVENTS
UNIGAM.E200D2.SF5       1565 EVENTS
UNIGAM.E300D2.SF5       1654 EVENTS
UNIGAM.E400D2.SF5       1561 EVENTS
UNIGAM.E500D2.SF5       1370 EVENTS
UNIGAM.E600D2.SF5       1344 EVENTS
UNIGAM.E800D2.SF5       1169 EVENTS

UNIGAM.E100D3.SF5       2000 EVENTS
UNIGAM.E200D3.SF5       1579 EVENTS
UNIGAM.E300D3.SF5       1657 EVENTS
UNIGAM.E400D3.SF5       1396 EVENTS
UNIGAM.E500D3.SF5       1353 EVENTS
UNIGAM.E600D3.SF5       1341 EVENTS
UNIGAM.E800D3.SF5       1012 EVENTS

>>>>>>>>>>       SF6 (1986 DATE), COS(2) = 0.86189  (SF5 VALUE)

UNIGAM.E100D1.SF6       2000 EVENTS
UNIGAM.E200D1.SF6       1436 EVENTS
UNIGAM.E300D1.SF6       1010 EVENTS
UNIGAM.E400D1.SF6       1569 EVENTS
UNIGAM.E500D1.SF6       1275 EVENTS
UNIGAM.E600D1.SF6       1411 EVENTS
UNIGAM.E800D1.SF6       1191 EVENTS

UNIGAM.E100D2.SF6       2000 EVENTS
UNIGAM.E200D2.SF6       1451 EVENTS
UNIGAM.E300D2.SF6       1548 EVENTS
UNIGAM.E400D2.SF6       1437 EVENTS
UNIGAM.E500D2.SF6       1258 EVENTS
UNIGAM.E600D2.SF6       1234 EVENTS
UNIGAM.E800D2.SF6       1055 EVENTS

UNIGAM.E100D3.SF6       2000 EVENTS
UNIGAM.E200D3.SF6       1480 EVENTS
UNIGAM.E300D3.SF6       1556 EVENTS
UNIGAM.E400D3.SF6       1304 EVENTS
UNIGAM.E500D3.SF6       1248 EVENTS
UNIGAM.E600D3.SF6       1226 EVENTS
UNIGAM.E800D3.SF6        920 EVENTS

>>  SF6 (1986 DATE), COS(2) = 1.724  (PRELIMINARY VALUE, FINAL IS 1.684)

UNIGAM.F100D1.SF6       2000 EVENTS
UNIGAM.F200D1.SF6       1428 EVENTS
UNIGAM.F400D1.SF6       1164 EVENTS
UNIGAM.F600D1.SF6       1055 EVENTS
UNIGAM.F800D1.SF6        926 EVENTS

UNIGAM.F100D2.SF6       2000 EVENTS
UNIGAM.F200D2.SF6       1443 EVENTS
UNIGAM.F400D2.SF6       1167 EVENTS
UNIGAM.F600D2.SF6       1062 EVENTS
UNIGAM.F800D2.SF6        933 EVENTS

UNIGAM.F100D3.SF6       2000 EVENTS
UNIGAM.F200D3.SF6       1464 EVENTS
UNIGAM.F400D3.SF6       1175 EVENTS
UNIGAM.F600D3.SF6       1065 EVENTS
UNIGAM.F800D3.SF6        930 EVENTS




NEW TRACKING
************
UPDATE OF CONS: +7% SF5, +4% SF6

TRACKING WITH NEW TOKYO SF5SF6 PROGRAM, NPECER8, LSCCTL40,LGMC56TJ
(STANDARD AL COIL WITH TJOCK, 51.7-->40)

UNIGAM4V.E100D1-B     22000 EVENTS      UNIGAM86.SUME100A,B
UNIGAM4V.E200D1-B     17871 EVENTS      UNIGAM86.SUME200A,B
UNIGAM4V.E300D1-B     12292 EVENTS      UNIGAM86.SUME300,A
UNIGAM4V.E400D1-B      9349 EVENTS      UNIGAM86.SUME400
UNIGAM4V.E500D1-B      6470 EVENTS      UNIGAM86.SUME500
UNIGAM4V.E600D1-B      6145 EVENTS      UNIGAM86.SUME600
UNIGAM4V.E700D1-B      5312 EVENTS      UNIGAM86.SUME700
UNIGAM4V.E800D1-B      4669 EVENTS      UNIGAM86.SUME800

C   16/03/84 807251613  MEMBER NAME  KOMMAN   (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE KOMMAN
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   5/06/84 :  COMMAND INTERPRETER FOR GRAPHICS
C
C       MOD:   C. BOWDERY  15/06/84 :  SMALL IMPROVEMENTS
C       MOD:   C. BOWDERY  18/06/84 :  SMALL IMPROVEMENTS
C       MOD:   C. BOWDERY  17/07/85 :  MULTIPLE COMMANDS
C       MOD:   C. BOWDERY  18/07/85 :  MACRO FEATURE ADDED
C       MOD:   C. BOWDERY  22/07/85 :  EXEMAC RENAMED EXPMAC
C       MOD:   C. BOWDERY   5/08/85 :  PROFIL CALLED
C       MOD:   C. BOWDERY   9/08/85 :  ERROR CONDITION IMPROVED
C       MOD:   C. BOWDERY  11/08/85 :  SLIGHT CHANGE IN STRUCTURE
C       MOD:   C. BOWDERY   8/06/86 :  INITIALISATION DONE IN MAIN
C  LAST MOD:   J. HAGEMANN 26/06/87 :  DO NOT REPEAT "WRIT" IF ONLY
C                                      "CR" WAS ENTERED
C
C
C     THIS IS THE COMMAND INTERPRETER FOR THE JADE GRAPHICS PROGRAM.
C
C     NOTE: THIS MEMBER CONTAINS SOME LOWER CASE LETTERS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  DSPDTM
      LOGICAL  LERROR
      LOGICAL  LCARET
C
      LOGICAL*1  CHARS, CHARSP, CDEF
C
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CGRAP5 / KOMCAL, LERROR
      COMMON / CGRBUF / CHARS(80),NFIELD,NEXFLD,ISTAFL(80),IENDFL(80),
     +                  CHARSP(80)
*PMF 19/11/99
      CHARACTER CHARS2*80
      EQUIVALENCE (CHARS2,CHARS(1))
*PMF(end)
C
#include "cgraph.for"
C
C-------------------  C O D E  -----------------------------------------
C
C
C                            IF THIS IS THE FIRST CALL,SETTING
C                            LERROR = TRUE INDICATES FIRST EVENT ONLY.
C
      IF( KOMCAL .EQ. 1 ) GO TO 1
        KOMCAL = 1
        LERROR = .TRUE.
        GO TO 10
C
C                            ANY COMMANDS LEFT IN THE BUFFER STILL?
C                            IF YES, GO CONTINUE WITH CURRENT BUFFER
C
   1  IF( NEXFLD .LE. NFIELD ) GO TO 20
C
C                            ANY MACROS OUTSTANDING? MACDEP > 1
C                            IF SO, RESTORE 1 LEVEL OF MACRO
C                            NOTE THAT LEVEL 1 IS THE 1ST CALLING LEVEL
C
      IF( MACDEP .LE. 1 ) GO TO 5
        CALL RESMAC( CHARS, NEXFLD )
        CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
        GO TO 1
C
C                            SAVE CURRENT BUFFER IF ALL COMMANDS DONE
C                            CLEAR ANY POSSIBLE ERROR CONDITION
C
   5  DO  8  K = 1,80
        CHARSP(K) = CHARS(K)
   8  CONTINUE
      LERROR = .FALSE.
C                            SEND PROMPTING CHARACTER TO THE SCREEN
C                            AND READ COMMAND CHARACTER STRING
C
  10  WRITE(*,'(''---> '',$)') ! PMF 19/11/99: CALL TRMOUT(4,'--->')
      LCARET = .FALSE.
      call iuwk(0,1)            ! PMF 24/11/99: update workstation
      READ(5,12) CHARS
  12  FORMAT(80A1)
      CALL CLTOU(CHARS2)      ! PMF 19/11/99: Conversion lower -> upper case letters
C
C                            DETERMINE HOW MANY FIELDS (NFIELD) IN THE
C                            COMMAND STRING (CHARS). STORE STARTING
C                            AND ENDING POSITIONS IN ISTAFL * IENDFL
C                            FOR EACH FIELD.
C
  15  NEXFLD = 1
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
C
      IF( NFIELD .GT. 0 ) GO TO 20
C
C                            ONLY C.R. --> RESTORE THE LAST BUFFER
C                                          EXCEPT IF LAST COMMAND
C                                          HAD ERROR OR IF 1ST COMMAND
        LCARET = .TRUE.
        IF( .NOT. LERROR ) GO TO 17
          WRITE(6,16)
  16      FORMAT(' Error: There is no valid command to repeat.')
          GO TO 10
C
  17    DO  18  K = 1,80
          CHARS(K)  = CHARSP(K)
  18    CONTINUE
        GO TO 15
C
C                            SEPARATE THE NEXT COMMAND IN THE BUFFER
C
  20  CALL SEPCMD( CHARS, NFIELD, ISTAFL, IENDFL, NEXFLD , NEWNEX )
C
C                            DETERMINE WHICH COMMAND
C
      NX  = NEXFLD
      NFL = NEWNEX - NX
C
      CALL JADCMD( CHARS, NFL, ISTAFL(NX), IENDFL(NX), LSTCMD,ACMD,BCMD)
      IF( LSTCMD .NE. 112 .OR. .NOT.LCARET ) GO TO 23
          WRITE(6,22)
  22      FORMAT(' Command WRIT will not be repeated if only CR was ente
     *red!')
          GO TO 10
  23  IF( LSTCMD .GT. 0 ) GO TO 30
C
C                            UNRECOGNISED COMMAND OR ERROR
C
        WRITE(6,25) CHARS
  25    FORMAT(' Input was --> ',80A1/
     +         ' Invalid command string. MENU and HELP give options.')
        MACDEP = 1
        LERROR = .TRUE.
        GO TO 10
C
C                            SET POSITION OF NEXT COMMAND IN BUFFER
C
  30  NEXFLD = NEWNEX + 1
C
C                            IS THIS COMMAND A MACRO?   LSTCMD > MACSTA?
C
      IF( LSTCMD .LE. MACSTA ) RETURN
C
C                            IF SO, EXPAND THIS MACRO INTO CHARS BUFFER
C
        CALL EXPMAC( LSTCMD, CHARS, NEXFLD, IERR )
        IF( IERR .EQ. 0 ) GO TO 15
          LERROR = .TRUE.
          GO TO 10
C
      END

C   02/11/81 312221239  MEMBER NAME  JELOSS   (S)           FORTRAN
      SUBROUTINE JELOSS( P, STRAC, POT, ZARO, XRAD, R, CA, SA )
C-----------------------------------------------------------
C
C  VERSION OF  3/12/77     LAST MOD 02/11/81   E.ELSEN
C  COMPONENTS OF P ARE CHANGED ACCORDING TO ENERGY LOSS.
C      P(1)...P(3) MOMENTUM THREE VECTOR
C      P(4)      ENERGY
C      P(5)      REST MASS
C      P(6)      TOTAL MOMENTUM
C
C      R(1..3)   COORDINATES OF POINT IN SYSTEM WHICH STILL HAS TO BE
C                ROTATED BY CA, SA!
C
C  FIND IONISATION ENERGY LOSS.
C      ZARO = Z / A * RO, WHERE RO IS DENSITY OF MATERIAL IN G/CM**3
C                    WITH CHARGE NUMBER Z AND MASS NUMBER A.
C      POT       IONISATION POTENTIAL IN EV ( ROUGHLY 10.*Z )
C   BETHE BLOCH FORMULA USED:
C   DE            Z          1.  (     (1.022E6 * BETA2   )         )
C   -- = 2. * D * - * RO * ----- ( ALOG(------------------) - BETA2 )
C   DX            A        BETA2 (     (POT * ( 1.- BETA2))         )
C
C   FIND BREMSSTRAHLUNG ENERGY LOSS
C   BETHE HEITLER XSECTION WITH COMPLETE SCREENING AND MULTIPLE
C   PHOTON EMISSION A LA EYGES
C   XI =(E0 - EPRIM)/E0,  B=4/3 , T=THICKNESS IN RADL
C   FI(XI) = XI**BT/BT -XI**(BT+1.)/(BT+1.) + 0.75/(BT+2.)*XI**(BT+2.)
C   LAST CHANGE                 20./11./83    W.BARTEL
C-----------------------------------------------------------
C
      DIMENSION P(6),R(3), RR(3)
      DIMENSION AK(10), IK(10)
      EQUIVALENCE (AK(1), IK(1))
      DIMENSION A2(3),A3(3)
C                                           MINIMUM OF RADIATED ENERGY
      DATA ARMIN / 0.001 /
C                                           MINIMUM PHOTON ENERGY
      DATA AKMIN / 0.01 /
      DATA D / .1535E-4 /
C                                           BREMSSTRAHLUNG LOSS
      COMMON /CFUNK/ BT,CONS,RHS
      DATA B /1.3333/
      EXTERNAL RADIAT
      FI(XI) = XI**BT/BT -XI**(BT+1.)/(BT+1.) + 0.75/(BT+2.)*XI**(BT+2.)
C
C  SCIP ELOSS IF STRAC < 1.E-06
C
      IF(STRAC.LT.1.E-06) RETURN
C
      BETA = P(6) / P(4)
      BETA2 = AMIN1( BETA * BETA, .9409 )
      DE = 2.*D*ZARO/BETA2* ( ALOG( 1.022E6/POT * BETA2/ (1.- BETA2 ) )
     *                                  - BETA2 ) * STRAC
C
C
C                                           DETERMINE TYPE OF LOSS
      IF( P(5) .GT. 1.E-3 ) GO TO 2000
C
C
C                                           BREMSSTRAHLUNG
C                                           TREATED STATISTICALLY
      T  = STRAC/XRAD
      BT = B*T
      CONS = BT*(1. + 0.577*BT)
      XLOW = 1.E-04
      FLOW = FI(XLOW)
      XNORM = (FI(1.) - FLOW) * CONS
      IF(RN(DUM).LT.FLOW*CONS) GO TO 2000
C
C      ELOSS ACCORDING TO EYGES FORMULA
C
      XIMIN = 1.E-04
      XIMAX = 1.
   11 RHS = XNORM*RN(DUM) + FLOW*CONS
      CALL RTMI(XIMSC,FF,RADIAT,XIMIN,XIMAX,1.E-3,20,IER)
      IF(XIMSC.GT.1.) GO TO 11
      XMSC = 1. - XIMSC
C                                           RADIATED PHOTON
      AK(4) = XIMSC*P(4)
      IF( AK(4) .LT. ARMIN ) GO TO 2000
      DE = DE + AK(4)
C
      IF( AK(4) .LT. AKMIN ) GO TO 2000
C                                           ASSUME ZERO
C                                           SCATTERING ANGLE
            FAC = AK(4) / P(6)
            AK(1) = P(1)*FAC
            AK(2) = P(2)*FAC
            AK(3) = P(3)*FAC
            AK(5) = 0.
            IK(6) = 0
            AK(7) = 0.
            AK(8) = 1.
            AK(9) = 0.
            AK(10) = 0.
            RR(1) = R(1)
            RR(2) = R(2)
            RR(3) = R(3)
C
      CALL JROTAT( RR, CA, -SA )
      CALL JROTAT( AK, CA, -SA )
      CALL SVECT1( AK, RR )
C
C
 2000 P(4) = AMAX1( P(5), P(4) - DE )
      PNEW = SQRT( P(4)*P(4) - P(5)*P(5) )
      P(1) = P(1) / P(6) * PNEW
      P(2) = P(2) / P(6) * PNEW
      P(3) = P(3) / P(6) * PNEW
      P(6) = PNEW
      RETURN
      END

C   20/12/85 512202036  MEMBER NAME  LGCLST   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE LGCLST
C-----------------------------------------------------------------------
C
C
C    DISPLAY TABLE OF RESULTS FOR CLUSTER ANALYSIS BANK  "LGCL"
C        IPO:          START ADRESS OF BANK CONTENT
C        NBK:          BOS NUMBER OF BANK
C        INDEX:        VIEW INDEX ACCORDING TO DISPLAY PROGRAM
C            J.OLSSON,  18.07.79           LAST CHANGE 01.12.79
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
      LOGICAL DSPDTM
C
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON/CWORK2/HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,NCLST,NWPCL
     $,PMOM,PZ,PTRANS,RMS,NHTF,RAD,RAD1,THE,PHI,XXX,YYY,SSS,IPP,IHO,IVE
     $,DUMM,NTRRES,IW52
      COMMON /CJTRIG/ PI,TWOPI
C
      DATA INAME /'LGCL'/
C
C------------------  C O D E  ------------------------------------------
C
      IPP = IPO
      ICNT = 0
      IFL = 0
C
C LSTCMD=111,112: NEXT EVENT, WRIT EVENT   SPECIAL FOR AUTO DISPLAY
C
      IF(DSPDTL(14).AND.ACMD.NE.0..AND.LSTCMD.NE.111.AND.LSTCMD.NE.112)
     $ IFL = 1
C---
      XXX = XMIN
      YYY = YMIN+.76*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,2)
C     IF(DSPDTL(14).AND.ACMD.NE.0..AND.LASTVW.EQ.13) GO TO 2277
      IF(IFL.NE.0.AND.LASTVW.EQ.13) GO TO 2277
C
C                            IF OPT 46 IS ON AND OPT 13 IS OFF
C                            FOR PUBLICATION PICTURES WITHOUT CAPTIONS,
C                            SUPPRESS THE RESULTS HEADER.
C
      IF( DSPDTM(16)  .AND.  .NOT. DSPDTL(13) ) GO TO 2277
C
      CALL CORE(HWORK,80)
      WRITE(10,220) INAME,NBK,NCLST
220   FORMAT('BANK ',A4,I2,' NR OF CLUSTERS',I3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
C
2277  IF( .NOT. DSPDTL(13) ) GO TO 21
      YYY = YYY - 3.*SSS
      IGMX = 0
200   ICNT = ICNT + 1
      IF(ICNT.GT.NCLST.OR.ICNT.GT.26) GO TO 21
      IPP = IPP + NWPCL
      IF(IDATA(IPP+8).EQ.0) IGMX = IGMX + 1
      CALL GMTEXT(IPP,NTRRES,ICNT,IGMX)
      GO TO 200
21    CONTINUE
      XXX = XMIN+.33*(XMAX-XMIN)
      YYY = YMIN+.01*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,1)
      IF(IFL.NE.0.AND.LASTVW.EQ.13) GO TO 2278
C     IF(DSPDTL(14).AND.ACMD.NE.0..AND.LASTVW.EQ.13) GO TO 2278
C
C                            IF OPT 46 IS ON AND OPT 13 IS OFF
C                            FOR PUBLICATION PICTURES WITHOUT CAPTIONS,
C                            SUPPRESS THE RESULTS HEADER.
C
      IF( DSPDTM(16)  .AND.  .NOT. DSPDTL(13) ) RETURN
C
      CALL CORE(HWORK,80)
      IPLGCL=IDATA(IBLN('LGCL'))
      WRITE(10,865) ADATA(IPLGCL+11),ADATA(IPLGCL+16),IDATA(IPLGCL+15)
865   FORMAT(' TOTAL CLUSTER ENERGY ',F7.3,'  PHOTON ENERGY ',F7.3,' NR
     $OF PHOTONS ',I3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,70,0.)
2278  CONTINUE
      RETURN
      END

C   29/09/86 801271428  MEMBER NAME  TPBOSI   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPBOSI
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      29/09/86:  Initialise BOS for TP
C
C     Last mod: C. Bowdery      27/01/88:  Add second output stream
C
C     Routine to initialise the BOS memory manager.
C
C------------------  D E F I N I T I O N S  ----------------------------
C
      IMPLICIT  INTEGER*2 (H)
C
C                            Include BOS COMMON macro
C
#include "bosdata.for"
C
C                            Include PARAMETER statement defining l.u.n
C
#include "units.for"
C
C------------------  C O D E  ------------------------------------------

C                            Do a page throw

      WRITE(6,1)
   1  FORMAT('1')

C                            Initialise BOS COMMON to length = LENBOS

      CALL BINT( LENBOS, 4000, 500, 0 )

C                            Initialise BOS output for both streams
C                            i.e. accepted and rejected events.

      CALL BWRO( JUNITA, 1558, 2 )
      CALL BWRO( JUNITR, 1558, 2 )

      RETURN
      END

C   12/03/80 003121518  MEMBER NAME  TRAPER   (JADEGS)      FORTRAN
      SUBROUTINE TRAPER(INDEX)
      IMPLICIT INTEGER*2 (H)
      WRITE(6,1) INDEX
    1 FORMAT(' TRAPER CALLED WITH INDEX = ',I6)
      RETURN
      END

C   23/08/85 511061940  MEMBER NAME  CMCTAG   (S)           FORTRAN
C
C   COMMON FOR NEW FORWARD TAGGER MC
C
      COMMON/CMCTAG/MARKMC,HGG(192),IHIT,INMARK,NCHANS,SIGMAS,CALIBS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C   12/02/82 202141706  MEMBER NAME  LGANAK   (S)           FORTRAN
C   11/07/79 101072247  MEMBER NAME  LGANAL   (SOURCE)      FORTRAN
      SUBROUTINE LGANAK
C
C     S.YAMADA  31-10-78  14:35
C     LAST MODIFICATION    01-08-79  24:00  IZ=0&31 KILLED
C     LAST MODIFICATION    07-01-79  24:00  NEG ENERGY TO 20000
C                                 Y.WATANABE
C     MODIFIED AT LICEPP  08-10-79 14:25  S.YAMADA  (GO TO 80>>GO TO 85)
C     MODIFIED AT LICEPP  19-11-79 09:30  S.KOMAMIYA
C---- MAIN SUBROUTINE FOR THE 1-ST STEP L-GLASS ANALYSIS.
C---- *******  MODIFIED FOR BOS *******
C
      IMPLICIT INTEGER *2 (H)
C
#include "cdata.for"
C
#include "clgwork1.for"
C------------------------------- ADDED BY S.K. --- 07-11-79 ------------
      COMMON /MAXCLS/EIG1,EIG2,EIGSUM,EIGDIV,MAXHIT,ECMAX,MAXCL
      COMMON /EIGAB/COSD(2),COSA(2),COSB(2),
     &          EIGA1,EIGA2,EIGB1,EIGB2,ENEA,ENEB,NHITA,NHITB,DNORM
C     COMMON /CLVEC/V11,V12,V21,V22
C-----------------------------------------------------------------------
C---- NCLST = NO.OF THE LOCATED CLUSTERS.
C---- MAPCL(J)=THE INDEX OF THE FIRST MEMBER OF THE J-TH CLUSTER
C               IN THE HLGADC. (THE FIRST 51 WORDS OF CLMPRP)
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3,ZVRTX,DZ
C
      COMMON /CLGMSB/ MSGVAL
C
      DATA NMLGCL/'LGCL'/,  LGANVR/1/,  MESS/0/
C
      IF(MESS) 1001,1000,1001
 1000 CALL LGMESG( 2, 0)
      MESS = 1
C
C
C---- FILL HEADER AND CONSTANTS IN THE GENERAL LG-INF. OF THE EVENT.
 1001 IDENT(1) = LGANVR
      IDENT(2) = IDATTM(DUM)
C
C---- CLEAR CLUSTER RESULTS ARRAY
      CALL SETSL(NCLST,0,5200,0)
C
C---- SET NO.OF WORDS/CLUSTER
      NWPCL = 15
C---- SET THE FLAG OF LG-ANALYSIS STEP-1.
      IFLAG(2) = 1
C
C*******************************************************************
C
C       LEAD GLASS CLUSTER FINDING
C
CC*   LG-ADC DATA IS MOVED FROM 'ALGN' TO /CWORK/.
CC*   CALL LGDCPY( NP, IFLAG(1))
C     LG-ADC DATA IS MOVED FROM 'ALGL' TO /CWORK/.CALIBRATED BY *5.
      CALL LGDCPK( NP, IFLAG(1))
C
C
C---- CHECK IF THERE IS ANY LG-DATA.
      IF(NP.LE.0) GO TO 100
C---- IF DATA FORMAT ERROR IS FOUND,SKIP ANALYSIS AND MAKE AN EMPTY RES.
C     IFLAG(1)=1,IF NOT CALIBRATED.
C     IFLAG(1)=2,IF NOT ALL DATA ARE COPIED DUE TO THE BUFFER SIZE.
C     IFLAG(1)=1024,IF FORMAT CONVRSION IS NOT DONE.
C
      IF(IFLAG(1).GE.1024) GO TO 100
C
C#####KILL IZ=0&31 RINGS BECAUSE THEY ARE NOT REAL.
      NHIT=LNG-3
      IF(NHIT.LE.0) GO TO 85
      DO 80 I=1,NHIT
C**********
      HPH=HLGADC(2,I)
      IF(HPH.LT.0) HLGADC(2,I)=20000
C**********
      IZ=HLGADC(1,I)
      IF(IZ.GT.2687) GO TO 80
      IZ=MOD(IZ,32)
      IF(IZ.EQ.0.OR.IZ.EQ.31) HLGADC(2,I)=0
C          PROTECTION HERE TO CORRECT NEGATIVE ENRGY DUE TO OVERFLOW.
80    CONTINUE
85    CONTINUE
C######
C---- CLUSTER FINDING    (NCLST,NCLBEC(1-3) ARE FILLED. MAP IS MADE.)
      CALL LGCCTK(IFLAG(1))
C
C---- CLUSTER POSITIONS AND ENERGIES ARE CALCULATED FOR THE BARREL AND
C     END CAPS.
      IF(NCLBEC(1)) 2,2,1
    1 CALL LGCLBK
    2 IF(NCLBEC(2)+NCLBEC(3)) 4,4,3
    3 CALL LGCLPC
C
C---- TOTAL ENERGY IS CALCULATED.
    4 ETOT(1) = ETOT(2)+ETOT(3)+ETOT(4)
C
  100 RETURN
      END

C   05/11/79 507111857  MEMBER NAME  EVCONV   (JADESR)      FORTRAN
      SUBROUTINE EVCONV(IREPLY)
C---
C---     COPIED FROM 'F11PST.JADESR(EVCONV7)' 13.30 21.05.79.
C---     NEW DRIFT TIME CHECK 6 NOV. 1979.
C---     INTRODUCE ZETCH  REFORMATING
C---     BK20  NOW BPCH                          31/07/84
C---     BK17  NOW FAMP                          08/10/84
C---     BK21  NOW VPAR                          11/07/85
C
C  PRINT WARNING, THIS VERSION IS HEAVILY OUTDATED !!
C
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C
      COMMON /CWORK/ NWORK,HWORK(20000)
C  %MACRO CDATA
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(33000)
      DIMENSION HDATA(10),IPNT(50),ADATA(1)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
#include "cgraph.for"
      COMMON/CLHOST/NREADE,NFORME,IENT,ISRAW,ISREF,IHRAW(500),IHREF(500)
     1,IHBANK(128),ISPINW(1540)
C
      DIMENSION NAME(128),HCAMWD(2),MARKTR(3),IPTRIG(3),HSAVE(1000)
      DIMENSION JN32(128)
      DIMENSION HPCELL(98)
      DIMENSION IPRNG(3)
      EQUIVALENCE(ICAMWD,HCAMWD(1))
C
      DATA NAME/'HEAD','LATC','TRIG','TRIG','TRIG','ATST','ATBP','ATOF',
     1          'ALGL','ATAG','TAGC','JETC','MUEV','SCAL','MPRS','N50S',
     1          'FAMP','ZTRG','ZETC','BPCH','VPAR','BK22','BK23','BK24',
     1          'BK25','BK26','BK27','BK28','BK29','BK30','BK31','BK32',
     1          'JETV','FADC','BK35','BK36','BK37','BK38','BK39','BK40',
     1          'BK41','BK42','BK43','BK44','BK45','BK46','BK47','BK48',
     1          'BK49','BK50','BK51','BK52','BK53','BK54','BK55','BK56',
     1          'BK57','BK58','BK59','BK60','BK61','BK62','BK63','BK64',
     1          'C065','C066','C067','C068','C069','C070','C071','C072',
     1          'C073','C074','C075','C076','C077','C078','C079','C080',
     1          'C081','C082','C083','C084','C085','C086','C087','C088',
     1          'C089','C090','C091','C092','C093','C094','C095','C096',
     1          'C097','C098','C099','C100','C101','C102','C103','C104',
     1          'C105','C106','C107','C108','C109','C110','C111','C112',
     1          'C113','C114','C115','C116','C117','C118','C119','C120',
     1          'C121','C122','C123','C124','C125','C126','C127','C128'/
      DATA JN32/'HEAD','LATC','TRG1','TRG2','TRG3','ATST','ATBP','ATOF',
     1          'ALGL','ATAG','TAGC','JETC','MUEV','SCAL','MPRS','N50S',
     1          'FAMP','ZTRG','ZETC','BPCH','VPAR','BK22','BK23','BK24',
     1          'BK25','BK26','BK27','BK28','BK29','BK30','BK31','BK32',
     1          'JETV','FADC','BK35','BK36','BK37','BK38','BK39','BK40',
     1          'BK41','BK42','BK43','BK44','BK45','BK46','BK47','BK48',
     1          'BK49','BK50','BK51','BK52','BK53','BK54','BK55','BK56',
     1          'BK57','BK58','BK59','BK60','BK61','BK62','BK63','BK64',
     1          'C065','C066','C067','C068','C069','C070','C071','C072',
     1          'C073','C074','C075','C076','C077','C078','C079','C080',
     1          'C081','C082','C083','C084','C085','C086','C087','C088',
     1          'C089','C090','C091','C092','C093','C094','C095','C096',
     1          'C097','C098','C099','C100','C101','C102','C103','C104',
     1          'C105','C106','C107','C108','C109','C110','C111','C112',
     1          'C113','C114','C115','C116','C117','C118','C119','C120',
     1          'C121','C122','C123','C124','C125','C126','C127','C128'/
      DATA ICALL/0/,I19/0/
C---
C---     CONVERTS CAMAC TO MONTE CARLO FORMAT AT NORD FOR THE DISPLAY.
C---     FRIDAY, FEBRUARY 23, 1979. L.H. O'NEILL.
C---
      ICALL=ICALL+1
      IF(ICALL.EQ.1) WRITE(6,581)
581   FORMAT(' *************   WARNING !!!!!!  **********')
      IF(ICALL.EQ.1) WRITE(6,582)
582   FORMAT('  HEAVILY OUTDATED VERSION OF EVCONV, CONTACT J.OLSSON')
      IF(ICALL.EQ.1) WRITE(6,581)
      IREPLY=0
      IERRCD = 0
C---
C---     CLEAR MARKERS TELLING WHICH OF THE THREE "TRIG" BANKS ARE
C---     PRESENT.
C---
      MARKTR(1)=0
      MARKTR(2)=0
      MARKTR(3)=0
C
   50 CONTINUE
      LOOK=0
      LEVB=0
      LENGH=0
      LENEVB=0
      IRING = 3
      MAXJET = 108
C
   21 CONTINUE
      IF(LENEVB.LT.8) GOTO 100
      LENEVH=LENEVB/2
      LENEVN=LENEVH*2
      IF(LENEVB.NE.LENEVN) LENEVB=LENEVB+1
C---
C---     SET BOS LENGTH PARAMETER.
C---
      HDATA(LEVB+7)=0
      HDATA(LEVB+8)=(LENEVB-8)/2
C---
C---     SET FIXED POINTER.
C---
      IF(IFPNT.NE.0) HDATA(IFPNT*2+108)=(LEVB+8)/2
      IF(IFPNT.NE.0) HDATA(IFPNT*2+108)=(LEVB+8)/2
      LEVB=LEVB+LENEVB
  100 CONTINUE
      LOOK=LOOK+LENGH
      IF(LOOK.EQ.NWORK*2) GOTO 500
      IF(LOOK.GE.NWORK*2) GOTO 5001
      HCAMWD(1)=HWORK(LOOK+1)
      HCAMWD(2)=HWORK(LOOK+2)
      ICHECK=ICAMWD
      DO 1776 INAME=1,128
      IBANK=INAME
      IF(ICHECK.EQ.JN32(INAME)) GOTO 22
 1776 CONTINUE
      GOTO 5002
   22 CONTINUE
C     IBANK=HWORK(LOOK+2)
C     IF(IBANK.GE.1 .AND. IBANK.LE.16) GOTO 23
C     WRITE(JUSCRN,9053) IBANK,LOOK
C9053 FORMAT(' OUT OF RANGE BANK NUMBER',I10,' AT LOOK=',I10)
C     GOTO 501
C  23 CONTINUE
      IHBANK(IBANK)=IHBANK(IBANK)+1
      LENGH=HWORK(LOOK+8)*2+8
      IF(LENGH.LT.11 .OR. LENGH.GT.20000) GOTO 5003
   24 CONTINUE
      IF(LOOK+LENGH.GT.20000 .OR. LEVB+LENGH.GT.20000) GOTO 5004
C---
C---     MAKE BOS HEADER.
C---
   25 CONTINUE
      ICAMWD=NAME(IBANK)
      HDATA(LEVB+1)=HCAMWD(1)
      HDATA(LEVB+2)=HCAMWD(2)
      HDATA(LEVB+3)=HWORK(LOOK+3)
      HDATA(LEVB+4)=HWORK(LOOK+4)
      HDATA(LEVB+5)=HWORK(LOOK+5)
      HDATA(LEVB+6)=HWORK(LOOK+6)
C---
C---     COPY BANK DESCRIPTOR WORD.
C---
      HDATA(LEVB+ 9)=HWORK(LOOK+ 9)
      HDATA(LEVB+10)=HWORK(LOOK+10)
C
      LENEVB=0
      IF(IBANK.GT.19) GO TO 17
      GOTO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,17,19),IBANK
C---
C---     HEAD
C---
    1 CONTINUE
      IF(LEVB.NE.0) GOTO 5010
      LNORHD=4*(HWORK(LOOK+8)-1)
      IYEAR=HWORK(LOOK+16)
      CALL MVC  (HDATA(11),0,HWORK(LOOK+11),0,LNORHD)
      ICLADD=8+2*HWORK(LOOK+8)+1
      LCLADD=2*(209-ICLADD)
      CALL SETSL(HDATA(ICLADD),0,LCLADD,0)
      LENEVB=208
      IFPNT=0
      GOTO 21
C---
C---     LATC
C---
    2 CONTINUE
      IFPNT=3
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     TRIG 1
C---
    3 CONTINUE
      IFPNT=1
      MARKTR(1)=1
      IPTRIG(1)=(LEVB+8)/2
      HDATA(LEVB+4)=1
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     TRIG 2
C---
    4 CONTINUE
      IFPNT=0
      IF(MARKTR(1).EQ.0) IFPNT=1
      MARKTR(2)=1
      IPTRIG(2)=(LEVB+8)/2
      HDATA(LEVB+4)=2
         LENEVB = LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     TRIG 3
C---
    5 CONTINUE
      IFPNT=0
      IF(MARKTR(1).EQ.0 .AND. MARKTR(2).EQ.0) IFPNT=1
      MARKTR(3)=1
      IPTRIG(3)=(LEVB+8)/2
      HDATA(LEVB+4)=3
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     ATST
C---
    6 CONTINUE
      IFPNT=4
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     ATBP
C---
    7 CONTINUE
      IFPNT=10
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     ATOF
C---
    8 CONTINUE
      IFPNT=5
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     ALGL
C---
    9 CONTINUE
      DATA MSKAD1,MSKAD2 /ZFFFF,Z7FFF/
      IFPNT = 6
      IADR1 = 2688
      IADR2 = 2784
C                                        FROM HERE ON SAME PROCEDURE
C                                        FOR ALGL + ATAG
   55 CONTINUE
      IF(LENGH.LE.11) GOTO 5061
C---
C---     HOW LONG CAN "ALGL" BECOME WHEN REFORMATTED IN THE WORST CASE?
C---     THE BOS HEADER, THE BANK DESCRIPTOR, THE FIRST ADDRESS AND
C---     THE FIRST PULSE HEIGHT ( 12 I*2 WORDS ) OCCUPY THE SAME SPACE
C---     IN THE ORIGINAL AND REFORMATTED EVENTS. THE REST OF THE INFOR-
C---     ATION DOUBLES IN LENGTH IN THE WORST CASE WHEN ONLY A STRING
C---     OF BLOCKS WITH CONSECUTIVE ADDRESSES IS PRESENT. IN ADDITION
C---     THE REFORMATTED BANK HAS 4 I*2 INTERNAL POINTERS.
C---
      MAXALG=LENGH*2-8
      IF(LEVB+MAXALG.GT.20000) GOTO 5062
C
C                                                 INITIALIZE POINTERS
      IPWRK  = LOOK + 10
      IPWRK9 = LOOK + LENGH
      IPHDT0 = LEVB + 14
      IPHDT  = IPHDT0
      IPLG0  = IPHDT0
      IPLG1  = IPHDT0
      IPLG2  = IPHDT0
      IADD  = -1
      HCAMWD(1)=0
C                                                 TEST 1.WORD=ADDRESS
      HZWNXT = HWORK(IPWRK+1)
      HCAMWD(2)=HZWNXT
      IF(SHFTR(ICAMWD,14).NE.2) GOTO 5063
C                                                 LOOP OVER ALL ADC'S
   30 CONTINUE
      IPWRK = IPWRK + 1
      IF(IPWRK.GT.IPWRK9) GOTO 33
C
      ICAMWD = LAND(HWORK(IPWRK),MSKAD1)
C                                                 CHECK IF ADDRESS
      IF(SHFTR(ICAMWD,14).NE.2) GOTO 32
C                                                 CALCULATE ADDRESS
      IADD1 = LAND(ICAMWD,MSKAD2)
      IF(SHFTR(IADD1,10) - 1) 34,35,36
   35 IADD1 = IADD1 - 64
      GOTO 34
   36 IADD1 = IADD1 - 128
      IF(IADD1.GT.2879) GOTO 5065
   34 CONTINUE
      IF(IADD1.LT.IADD) GOTO 5068
      IADD = IADD1
      GOTO 30
C                                                 STORE ADC
   32 CONTINUE
      IPHDT=IPHDT+2
      HDATA(IPHDT  ) = ICAMWD
      HDATA(IPHDT-1) = IADD
      IADD = IADD + 1
      IF(IADD.GT.IADR2) GOTO 30
      IF(IADD.GT.IADR1) GOTO 37
      IPLG1 = IPHDT
   37 IPLG2 = IPHDT
      GOTO 30
C
   33 CONTINUE
C
      IF(HCAMWD(2).EQ.0) IPHDT = IPHDT - 2
      IF(IPLG1.GT.IPHDT) IPLG1 = IPHDT
      IF(IPLG2.GT.IPHDT) IPLG2 = IPHDT
      HDATA(IPHDT0-3) = 1
      HDATA(IPHDT0-2) = IPLG1 - IPHDT0 + 1
      HDATA(IPHDT0-1) = IPLG2 - IPHDT0 + 1
      HDATA(IPHDT0  ) = IPHDT - IPHDT0 + 1
C
      LENEVB = IPHDT - LEVB
      GOTO 21
C---
C---     ATAG
C---
C---                                    SAME PROCEDURE AS FOR ALGL
C---
   10 CONTINUE
      IFPNT = 11
      IADR1 =  96
      IADR2 = 192
      IF(IYEAR.LE.1980) GO TO 55
      IADR1 =  32
      IADR2 =  64
      GOTO 55
C---
C---
C---     TAGC
C---
   11 CONTINUE
      IFPNT=12
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     JETC.
C---
   12 CONTINUE
C
C                                       KEEP POINTER TO RING-BANKS
      IF(LENGH.LT.15) GOTO 5071
      MAXHIT = ((LENGH-10)*16)/13+4
      MAXJET = MAXJET + MAXHIT
      IF(MAXJET.GT.20000) GOTO 5072
      IPRNG(IRING) = LOOK + 8
      IRING = IRING - 1
      LENEVB=0
      GOTO 21
C
C
C---
C---     MUEV
C---
   13 CONTINUE
      IFPNT=9
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     SCAL
C---
   14 CONTINUE
      IFPNT=2
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     MPRS
C---
   15 CONTINUE
      IFPNT=13
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     N50S
C---
   16 CONTINUE
      IFPNT=14
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     SPECIAL RUN STATUS BANKS
C---
   17 CONTINUE
      IFPNT=0
         LENEVB=LENGH
         LENCOP=LENGH*2 - 16
         CALL MVCL(HDATA(LEVB+9),0,HWORK(LOOK+9),0,LENCOP)
      GOTO 21
C---
C---     Z-CHAMBER BANK ZETC
C---
   19 CONTINUE
      I19    = I19 + 1
      LOOK2  = LOOK+LENGH
      IF(I19.LE.10)      WRITE(JUSCRN,4919) (HWORK(LLL),LLL=LOOK,LOOK2)
 4919 FORMAT(' UNREFORMATTED ZETC ',/(20I6))
      KEXTRA = 0
      IADR0  = -1
      IPHDT0 = LEVB + 10
      IPHDT  = IPHDT0
      IZAMIN = 0
      IZAMAX = 63
      IPWRK  = LOOK + 11
      IPWRK9 = LOOK + LENGH - 3
C                                           LOOP OVER ADCS
 4000 CONTINUE
      IF(IPWRK.GT.IPWRK9)                   GOTO 4100
      NHIT = HWORK(IPWRK)
      IF(NHIT.NE.16384)                     GOTO 4010
C                                           BENCH MARK
C ----------------------------------------- AT PRESENT NOT USED,
C                                           JUST SKIPPED.
         IPWRK  = IPWRK + 1
         NHIT   = HWORK(IPWRK)
C                                           CHECK HIT NUMBER
 4010 CONTINUE
      IF(NHIT.LE.0 .OR. NHIT.GT.127)        GOTO 4501
      IF(NHIT.LE.8)                         GOTO 4020
C ----------------------------------------- FOLLOWING CODE FOR LIST OF
C                                           OVERFLOW WIRES
C                                           -- NOT USED AT PRESENT --
C        IF(KEXTRA.GT.998)                  GOTO 4030
C           HSAVE(KEXTRA+1) = IADR
C           HSAVE(KEXTRA+2) = NHIT
C           KEXTRA          = KEXTRA+2
C -----------------------------------------
 4030    NHIT = 8
 4020 CONTINUE
C                                           CHECK WIRE ADDRESS
      IADR = HWORK(IPWRK+1)
      IF(IADR.LT.0 .OR. IADR.GT.IZAMAX)     GOTO 4502
      IF(IADR.LE.IADR0)                     GOTO 4503
         IADR0 = IADR
         IWIR  = IADR*8 + NHIT
         IPWRK = IPWRK+2
C                                           LOOP OVER HITS
 4040 CONTINUE
         IWIR = IWIR - 1
         HDATA(IPHDT+1) = IWIR
C                                           NOTE A1 AND A2 EXCHANGED
C                                           BETWEEN RAW & REFORMATTED
C                                           BANKS
         HDATA(IPHDT+3) = HWORK(IPWRK)
         HDATA(IPHDT+2) = HWORK(IPWRK+1)
         IF(HWORK(IPWRK+2) .GT. 255)        GOTO 4504
         HDATA(IPHDT+4) = HWORK(IPWRK+2)
         IPWRK = IPWRK + 3
         IPHDT = IPHDT + 4
         NHIT  = NHIT - 1
         IF(NHIT.NE.0)                      GOTO 4040
      GOTO 4000
 4100 CONTINUE
C ----------------------------------------- FOLLOWING CODE FOR LIST OF
C                                           OVERFLOW WIRES
C                                           -- NOT USED AT PRESENT --
C     IF(KEXTRA.LT.2)                       GOTO 4060
C     IF(IPHDT+KEXTRA .GT. 20000)           GOTO 4505
C     DO 4050 I=1,KEXTRA
C             IPHDT = IPHDT+1
C             HDATA(IPHDT) = HSAVE(I)
C4050 CONTINUE
C -----------------------------------------
C                                           UPDATE LENGTH
 4060 CONTINUE
      LENEVB = IPHDT - LEVB
      GOTO 21
C ---
C --- Z-CHAMBER --- ERRORS ---
C ---
C                                           ILLEGAL NHITS
 4501 WRITE(JUSCRN,4511) NHITS
 4511 FORMAT(/' ---- ZETC --- ILLEGAL NHITS = ',I6)
      GOTO 501
C                                           ILLEGAL WIRE ADDRESS
 4502 WRITE(JUSCRN,4512) IADR
 4512 FORMAT(/' ---- ZETC --- ILLEGAL WIRE ADDRESS = ',I6)
      GOTO 501
C                                           NON-INCREASING WIRE NO
 4503 WRITE(JUSCRN,4513) IADR,IADR0
 4513 FORMAT(/' ---- ZETC --- NON-INCREASING WIRE NO = ',I6,
     *        ' (LAST WAS ',I6,')')
      GOTO 501
C                                           ILLEGAL DRIFT TIME
 4504 WRITE(JUSCRN,4514) HWORK(IPWRK+2)
 4514 FORMAT(/' ---- ZETC --- ILLEGAL DRIFT TIME = ',I6)
      GOTO 501
C                                           BANK GETTING TOO LONG
C                                           -- NOT USED AT PRESENT --
C4505 WRITE(JUSCRN,4515)
C4515 FORMAT(/' ---- ZETC --- BANK TOO LONG W. LIST OF OVERFLOW WIRES')
C     GOTO 4060
C
  501 CONTINUE
      IREPLY=-1
      DATA NFAIL /0/
      NFAIL = NFAIL + 1
      IF(NFAIL.LE.1) WRITE(JUSCRN,9050)
 9050 FORMAT(' FAILED TO CONVERT')
C---
C---     SET TOTAL LENGTH.
C---
  500 CONTINUE
      HDATA(208)=LEVB/2
C---
C---     SET INTERNAL POINTERS FOR BANKS WITH THE SAME NAME.
C---
      DO 47 I=1,2
      IF(MARKTR(I).NE.1) GOTO 47
      IP1=IPTRIG(I)
      K=I+1
      DO 48 J=K,3
      IF(MARKTR(J).NE.1) GOTO 48
      IP2=IPTRIG(J)
      HDATA(IP1*2-2)=IP2
      GOTO 47
   48 CONTINUE
   47 CONTINUE
C
C                                       CHECK IF JETC DATA
      IF(IRING.EQ.3) GOTO 600
C---
C---     JETC.
C---
C---
C---     HOW LONG CAN THE REFORMATTED "JETC" BECOME IN THE WORST CASE,
C---     DISCOUNTING THE TRAILING LIST OF WIRES WITH MORE THAN EIGHT
C---     HITS? THE REFORMATTED BANK OCCUPIES 8 (BOS HEADER) + 2 (BANK
C---     DESCRIPTOR) + 98 (INTERNAL POINTERS) + 4*N INTEGER*2 WORDS,
C---     WHERE "N" IS THE TOTAL NUMBER OF HITS ON ALL WIRES, NOT COUNT-
C---     BEYOND THE 8TH HIT ON EACH WIRE. THIS IS 108 + 4*N I*2 WORDS.
C---     THE UNREFORMATTED BANK HAS 8 (BOS HEADER) + 2 (BANK DESCRIPTOR)
C---     I*2 WORDS PLUS THE HIT DATA. THE LARGEST POSSIBLE RATIO OF
C---     HITS TO UNREFORMATTED DATA LENGTH OCCURS IN THE CASE THAT THERE
C---     ARE EXACTLY 8 HITS PER WIRE, IN WHICH CASE THERE ARE 8 HITS
C---     PER 1 (NUMBER OF HITS) + 1 (WIRE NUMBER) + 3*8 = 26 DATA WORDS.
C---
C                                                 INITIALIZE POINTERS
      KEXTRA = 0
      ICELL0 = 0
      IADR0  =-1
      IPHDT0 = LEVB +  108
      IPHDT  = IPHDT0
C                                 GET RING POINTER
  120 CONTINUE
      IRING = IRING + 1
      IF(IRING.GT.3) GOTO 44
      LOOK = IPRNG(IRING)
      JRING=4-HWORK(LOOK-4)
      IRAMIN=384*(JRING-1)
      IRAMAX=IRAMIN+383
      IF(JRING.EQ.3) IRAMAX=1535
C---
C---     INITIALIZE LAST HIT COUNTER ADDRESS FOLLOWED BY REFORMATABLE
C---     DATA.
C---
      IPWR00=0
C
C                                                 INITIALIZE POINTERS
      IPWRK  = LOOK + 3
C---
C---     SUBTRACT 3 FROM IPWRK9 BELOW. WHEN IPWRK REACHES IPWRK9 NO
C---     FURTHER COMPLETE HIT IS POSSIBLE. THIS REDUCTION OF IPWRK9
C---     WILL AVOID SPURIOUS REFORMATTING ERRORS WHICH OCCUR WHEN
C---     "JETMRG" DELETES A -1 FROM THE MIDDLE OF A JETC BANK WHICH
C---     ALREADY HAS A TRAILING ZERO. THIS RESULTS IN TWO TRAILING
C---     ZEROES AT THE END OF THE UNREFORMATTED BANK AND A SPURIOUS
C---     ILLEGAL NHIT OF 0.
C---
C---                                   L.H. 0'NEILL
C---                                   05.08.79
C---
      IPWRK9 = HWORK(LOOK)*2 + LOOK - 3
      IPWBEN = IPWRK
   40 CONTINUE
      IF(IPWRK.GE.IPWRK9) GOTO 120
C                                                 LOOP OVER ALL ADC'S
  240 NHIT = HWORK(IPWRK)
C                                                 CHECK FOR BENCH MARK
      IF(NHIT.NE.16384) GOTO 140
         IPWBEN = IPWRK
C---
C---     SET LOWEST ADDRESS IN THE REFORMATTED DATA ARRAY TO WHICH
C---     ERROR RECOVERY MAY SEARCH BACKWARD LOOKING FOR THE PREVIOUS
C---     WIRE NUMBER. INITIALIZE DEAD LOOP PROTECTION COUNTER FOR
C---     THE REGION STARTING WITH THIS BENCH MARK.
C---
      IPHDTR=IPHDT
      KSPERC=0
         IPWRK = IPWRK + 1
         NHIT = HWORK(IPWRK)
C---
C---     COMPUTE MAXIMUM ALLOWED WIRE ADDRESS UNTIL THE NEXT BENCHMARK.
C---
         IABM1=HWORK(IPWRK+1)
         IADMAX=IRAMAX
         IF((IABM1.LE.IADR0).OR.(IABM1.GT.IRAMAX)) GO TO 140
         IRBMIN=IRAMIN
         IF(IABM1.GE.1152) IRBMIN=1152
         IBENCH=1+(IABM1-IRBMIN)/56
         IADMAX=56*IBENCH-1+IRBMIN
  140 IADR = HWORK(IPWRK+1)
      IF(NHIT.LE.0 .OR. NHIT.GT.127) GOTO 5073
      IF(NHIT.LE.8) GOTO 39
         IF(KEXTRA.GT.998) GOTO 38
         HSAVE(KEXTRA+1)=IADR
         HSAVE(KEXTRA+2)=NHIT
         KEXTRA=KEXTRA+2
   38    NHIT = 8
   39 CONTINUE
      IF(IADR.LT.0 .OR. IADR.GT.IADMAX) GOTO 5074
      IF(IADR.LE.IADR0) GOTO 5075
      IADR0 = IADR
      IWIR = IADR*8 + NHIT
      IPWRK = IPWRK + 2
      ICELL = SHFTR(IADR,4)+1
      IF(ICELL.EQ.ICELL0) GOTO 41
        ICELL0 = ICELL0 + 1
        IPDIF = IPHDT - IPHDT0 + 1
        DO 42 IC=ICELL0,ICELL
   42   HPCELL(IC) = IPDIF
        ICELL0 = ICELL
C
   41 CONTINUE
        IWIR = IWIR - 1
        HDATA(IPHDT+1) = IWIR
        HDATA(IPHDT+2) = HWORK(IPWRK  )
        HDATA(IPHDT+3) = HWORK(IPWRK+1)
        IF(HWORK(IPWRK+2).GT.255) GO TO 1946
        HDATA(IPHDT+4) = HWORK(IPWRK+2)
        IPWRK = IPWRK + 3
        IPHDT = IPHDT + 4
        NHIT = NHIT - 1
        IF(NHIT.NE.0) GOTO 41
        GOTO 40
C
   44   ICELL0 = ICELL0 + 1
        IPDIF = IPHDT - IPHDT0 + 1
        DO 43 IC=ICELL0,97
   43   HPCELL(IC) = IPDIF
C
      IF(KEXTRA.LT.2) GOTO 51
      IF(IPHDT+KEXTRA.GT.20000) GOTO 5076
      DO 49 I=1,KEXTRA
      IPHDT = IPHDT + 1
      HDATA(IPHDT) = HSAVE(I)
   49 CONTINUE
   51 HPCELL(98) = IPHDT - IPHDT0 + 1
C
      CALL MVCL(HDATA(IPHDT0-97),0,HPCELL(1),0,196)
C
      LENEVB = IPHDT - LEVB
      IF(LENEVB.LT.8) GOTO 600
C
C                                                SET BOS WORDS + POINTER
      IPNT( 7) = SHFTR(LEVB+8,1)
      NWORD = SHFTR(IPHDT+1,1)
      HDATA(LEVB+ 1) = HWORK(LOOK-7)
      HDATA(LEVB+ 2) = HWORK(LOOK-6)
      HDATA(LEVB+ 3) = 0
      HDATA(LEVB+ 4) = 0
      HDATA(LEVB+ 5) = 0
      HDATA(LEVB+ 6) = 0
      HDATA(LEVB+ 7) = 0
      HDATA(LEVB+ 8) = NWORD - IPNT(7)
      HDATA(LEVB+ 9) = HWORK(LOOK+1) + 100
      HDATA(LEVB+10) = IERRCD
C---
C---     ADD LIST OF WIRES WITH MORE THAN 8 HITS, AND NUMBERS OF HITS,
C---     TO THE END OF JETC BANK. INTERNAL POINTER 97 POINTS TO THE
C---     BEGINNING OF THIS LIST OF "HOT" WIRES AND INTERNAL POINTER
C---     98 POINTS TO THE LAST I*2 WORD OF THE BANK, PLUS ONE.
C---
  600 CONTINUE
C---  IF((IERRCD.NE.0).AND.(KERRCD.LT.20)) CALL LHODMP
      RETURN
C
C
C                                        *****************************
C                                        *       E R R O R S         *
C                                        *****************************
C
 5001 WRITE(JUSCRN,9051) NWORK,LOOK
 9051 FORMAT(' LENGTH ERROR:',2I10)
      GOTO 501
 5002 WRITE(JUSCRN,9052) ICHECK,LOOK
 9052 FORMAT(' BAD ICHECK',I10,' AT LOOK=',I10)
      GOTO 501
 5003 CONTINUE
      DATA NILLGH /0/
      NILLGH = NILLGH + 1
      IF(NILLGH.LE.1) WRITE(JUSCRN,9054) LENGH,LOOK
 9054 FORMAT(' ILLEGAL LENGTH',I10,' AT LOOK=',I10)
      GOTO 501
 5004 CONTINUE
      DATA NLONG /0/
      NLONG = NLONG + 1
      IF(NLONG.LE.1) WRITE(JUSCRN,9055) LENGH,LOOK,LEVB
 9055 FORMAT(' TOTAL EVENT GETTING TOO LONG. LENGH, LOOK, LEVB =',3I10)
      GOTO 501
C
 5010 WRITE(JUSCRN,9056) LOOK,LEVB,IBANK
 9056 FORMAT(' HEADER NOT FIRST BANK.',3I10)
      GOTO 501
C
 5061 WRITE(JUSCRN,9057) LOOK,LENGH
 9057 FORMAT(' ALGL/ATAG BANK HAS ILLEGAL LENGTH.',2I10)
      GOTO 501
 5062 CONTINUE
      DATA IEALG/0/
      IEALG=IEALG+1
      IF(IEALG.LE.1) WRITE(JUSCRN,9066) LOOK,LEVB,MAXALG
 9066 FORMAT(' REFORMATTED ALGL/ATAG MAY BECOME TOO LONG FOR IDATA:',
     ,         3I10)
      GOTO 501
 5063 WRITE(JUSCRN,9058) IPWRK,ICAMWD
 9058 FORMAT(' FIRST ADC WORD IS NOT AN ADDRESS.',2I10)
      GOTO 501
 5064 WRITE(JUSCRN,9001) IADD1,ICR
 9001 FORMAT(' ILLEGAL CRATE NUMBER',2I10)
      GOTO 501
 5065 ICR = SHFTR(IADD1,10)
      IF(ICR.GT.1) GOTO 5064
      WRITE(JUSCRN,9002) IADD1
 9002 FORMAT(' ILLEGAL CONVERTED ADC ADDRESS',I10)
      GOTO 501
 5067 WRITE(JUSCRN,9060) LOOK,I
 9060 FORMAT(' TWO ADC ADDRESSES IN A ROW.',2I10)
      GOTO 501
 5068 WRITE(JUSCRN,9061) IPWRK,IPHDT,IADD,IADD1
 9061 FORMAT(' NON-INCREASING ADC ADDRESS',4I10)
      GOTO 501
C
 5071 WRITE(JUSCRN,9062) IPWRK,LENGH
 9062 FORMAT(' ILLEGAL JETC LENGTH',2I10)
      IERRCD = LOR(IERRCD,2)
      GOTO 21
 5072 CONTINUE
      DATA IJETLN/0/
      IJETLN=IJETLN+1
      IF(IJETLN.LE.1) WRITE(JUSCRN,9067) IPWRK,LEVB,MAXJET
 9067 FORMAT(' JETC MAY BE TOO LARGE FOR IDATA.',3I10)
      IERRCD = LOR(IERRCD,2)
      MAXJET = MAXJET - MAXHIT
      GOTO 21
 5073 CONTINUE
      DATA KILGHT/0/
      KILGHT=KILGHT+1
      IF(KILGHT.LE.1) WRITE(JUSCRN,9063) IPWRK,IPHDT,NHIT
 9063 FORMAT(' ILLEGAL NHITS',3I10)
      GOTO 5078
 5074 CONTINUE
      DATA KILWRN/0/
      KILWRN=KILWRN+1
      IF(KILWRN.LE.1) WRITE(JUSCRN,9064) IPWRK,IPHDT,IADR
 9064 FORMAT(' ILLEGAL WIRE NUMBER',3I10)
      GOTO 5078
 5075 CONTINUE
      DATA KNONIW/0/
      KNONIW=KNONIW+1
      IF(KNONIW.LE.1) WRITE(JUSCRN,9065) IPWRK,IPHDT,IADR,IADR0
 9065 FORMAT(' NON-INCREASING WIRE NUMBER',4I10)
      GOTO 5078
 1946 CONTINUE
      DATA KILTIM/0/
      KILTIM=KILTIM+1
      IF(KILTIM.LE.1) WRITE(JUSCRN,1947) IPWRK,IPHDT,HWORK(IPWRK+2)
 1947 FORMAT(' ILLEGAL DRIFT TIME:',3I10)
      GOTO 5078
 5076 CONTINUE
      DATA KKEXT/0/
      KKEXT=KKEXT+1
      IF(KKEXT.LE.1) WRITE(JUSCRN,9068) IPWRK,LEVB,LENEVB,KOUNT,KEXTRA
 9068 FORMAT(' HOT WIRE LIST WILL MAKE JETC TOO LONG.',5I10)
      IERRCD = LOR(IERRCD,2)
      GOTO 51
C
C                                       ERROR RECOVERY USING BENCH MARKS

 5078 CONTINUE
      DATA KERRCD/0/
      KERRCD=KERRCD+1
      IF(KERRCD.LE.1) WRITE(6,9069) ICALL,HWORK(18),HWORK(19),KERRCD,
     1IERRCD
 9069 FORMAT(' ERROR RECOVERY: ICALL, RUN, EVENT, KERRCD, IERRCD = ',
     15I6)
      IERRCD = LOR(IERRCD,1)
C---
C---     SPECIAL "MORE SOPHISTICATED" ERROR RECOVERY INSTALLED 30-31
C---     OCTOBER, 1979 BY L.H. O'NEILL
C---     BEFORE JUMPING TO THE NEXT BENCH MARK, TRY TO SAVE THE
C---     INTERVENING DATA BY CHANGING THE LAST HIT COUNTER BEFORE
C---     THE ONE NOW POINTED TO BY IPWRK.
C---
C---     TRY ALL HIT NUMBERS FROM ONE TO EIGHT. IF THIS IS THE FIRST
C---     ERROR RECOVERY ATTEMPT SINCE "IADR0" WAS LAST INCREMENTED,
C---     I.E. SINCE THE LAST LEGAL HIT COUNTER - WIRE ADDRESS PAIR
C---     WAS FOUND, INITIALIZE THE TRIAL NUMBER OF HITS.
C---
      IF(IPWRK.GT.IPWR00) NHTRY=0
C---
C---     INCREMENT COUNTER FOR THE TOTAL NUMBER OF ERROR RECOVERY TRIES
C---     IN THIS RING. ( DEAD LOOP PROTECTION )
C---
      KSPERC=KSPERC+1
      IF(KSPERC.GT.100) GO TO 5080
      NHTRY=NHTRY+1
C---
C---     IF ALL POSSIBLE VALUES OF NHIT HAVE BEEN TRIED, GIVE UP.
C---
      IF(NHTRY.GT.8) GO TO 5090
      IF(NHTRY.GT.1) GO TO 5081
C---
C---     WE NOW HAVE THE FIRST TRIAL VALUE OF THE HIT COUNTER, NAMELY
C---     ONE. USE THE REFORMATTED DATA ARRAY TO DEDUCE HOW MUCH IPWRK
C---     MUST BE DECREMENTED IN ORDER TO GET IT TO POINT TO THE PREVIOUS
C---     HIT COUNTER IN THE UNREFORMATTED DATA ARRAY.
C---
C---     FIND THE NEXT BENCH MARK JUST TO BUILD IN SOME MORE SAFETY
C---     LIMITS.
C---
      IPWBNX=IPWBEN
 5091 IPWBNX=IPWBNX+1
      IF((HDATA(IPWBNX).NE.16384).AND.(IPWBNX.LE.(IPWRK9+3))) GO TO 509100084800
C---
C---     COUNT THE NUMBER OF HITS ON THE LAST WIRE WHOSE ADDRESS IS IN
C---     THE REFORMATTED ARRAY.
C---
      IPWR00=IPWRK
      NALSTR=0
      ILWADD=IPHDT-3
      ILWNUM=HDATA(ILWADD)/8
 5082 NALSTR=NALSTR+1
      ILWADD=ILWADD-4
C---
C---     DO NOT ALLOW SEARCH FOR A DIFFERENT WIRE NUMBER TO GO BELOW
C---     THE ADDRESS OF THE LAST BENCHMARK.
C---
      IF(ILWADD.LT.IPHDTR) GO TO 5083
      JLWNUM=HDATA(ILWADD)/8
      IF(JLWNUM.NE.ILWNUM) GO TO 5083
      GO TO 5082
C---
C---     COMPUTE WHERE THE POINTERS TO THE UNREFORMATTED AND REFOR-
C---     MATTED DATA ARRAYS, "IPWRK" AND "IPHDT" RESPECTIVELY, WERE
C---     WHEN THE HIT COUNTER WE ARE CHANGING WAS FIRST ENCOUNTERED.
C---
 5083 IPWSTR=IPWRK-2-3*NALSTR
      IPHDTS=IPHDT-4*NALSTR
      IF(IPWSTR.LT.(IPWBEN+1)) IPHDTS=IPHDTR
      IF(IPWSTR.LT.(IPWBEN+1)) IPWSTR=IPWBEN+1
      IPWSTQ=IPWSTR-1
      IF((IADR0.GE.0).AND.(IADR0.LE.1535)) ISPINW(IADR0+1)
     1=ISPINW(IADR0+1)+1
      IF((IADR0.GE.0).AND.(IADR0.LE.1535)) ISPINW(1540)=ISPINW(1540)+1
C---
C---     DECREMENT IADR0 SO THAT "NON-INCREASING WIRE NUMBER" ERROR
C---     DOES NOT OCCUR WHEN WE TRY A NEW NHIT.
C---
      IADR00=IADR0-1
C---
C---     FOR ALL TRIAL VALUES OF THE HIT COUNTER RESET THE POINTERS
C---     TO THE UNREFORMATTED AND REFORMATTED DATA TO THE VALUES THEY
C---     HAD WHEN THE HIT COUNTER BEING VARIED WAS FIRST ENCOUNTERED.
C---
 5081 IPWRK=IPWSTR
      IPHDT=IPHDTS
      IADR0=IADR00
      IF((IPWRK+2+3*NHTRY).GT.IPWBNX) GO TO 5090
      NHIT=NHTRY
      GO TO 140
 5090 CONTINUE
C---
C---     VARYING THE PREVIOUS HIT COUNTER HAS FAILED. NOW TRY THE
C---     HYPOTHESIS THAT THE HIT COUNTER IS MISSING. SIMPLY DECREMENT
C---     THE RESTARTING ADDRESS OF THE UNREFORMATTED DATA POINTER BY
C---     ONE, CHECK WHETHER THE CONTENTS OF THE ORIGINAL ADDRESS COULD
C---     POSSIBLY BE A WIRE NUMBER, AND IF SO REPEAT THE ABOVE PRO-
C---     CEDURE.
C---
      IF(IPWSTR.EQ.IPWSTQ) GO TO 5080
      DATA ISOPH/0/
      ISOPH=ISOPH+1
      IF(ISOPH.LE.1) WRITE(JUSCRN,6001) HWORK(18),HWORK(19)
 6001 FORMAT(' SOPHISTICATED ERROR RECOVERY FAILURE LEVEL ONE.',2I8)
      IF((HWORK(IPWSTR).LT.0).OR.(HWORK(IPWSTR).GT.1535)) GO TO 5080
      IPWSTR=IPWSTQ
      NHTRY=1
      GO TO 5081
C---
C---     "SOPHISTICATED" RECOVERY HAS FAILED. SKIP AHEAD TO THE NEXT
C---     BENCHMARK OR TO NEXT PROBABLE HIT COUNTER AS DETERMINED BY
C---     SIMPLE MINDED CRITERIA.
C---
 5080 IPWRK  = IPWBEN
      IPHDT=IPHDTS
      ISOPH=ISOPH+1
      IF(ISOPH.LE.1) WRITE(JUSCRN,6002) HWORK(18),HWORK(19)
 6002 FORMAT(' SOPHISTICATED ERROR RECOVERY FAILURE LEVEL TWO.',2I8)
C---
C---     GIVE IADR0 BACK THE 1 SUBTRACTED ABOVE.
C---
      IADR0=IADR00+1
 5079 CONTINUE
      IPWRK = IPWRK + 1
      IDSOPH=0
      IF((HWORK(IPWRK).EQ.16384).OR.(IPWRK.GE.IPWRK9)) IDSOPH=1
      ISOPH=ISOPH+IDSOPH
      IF((IDSOPH.EQ.1).AND.(ISOPH.LE.1)) WRITE(JUSCRN,6003)
     1HWORK(18),HWORK(19)
 6003 FORMAT(' SOPHISTICATED ERROR RECOVERY FAILURE LEVEL THREE.',2I8)
      IF(IPWRK.GE.IPWRK9) GOTO 120
      IF(HWORK(IPWRK).EQ.16384) GOTO 240
      IF(KSPERC.GT.100) GOTO 5079
      IF(IPWRK.LE.IPWSTR) GOTO 5079
C---
C---     SIMPLE MINDED SEARCH FOR PROBABLE HIT COUNTER.
C---
      NHYPHT=HWORK(IPWRK)
      IF((NHYPHT.LT.1).OR.(NHYPHT.GT.5)) GO TO 5079
      IF(HWORK(IPWRK+1).LE.IADR0) GO TO 5079
      IF(HWORK(IPWRK+1).GT.IADMAX) GO TO 5079
      IPWRL=IPWRK+2+3*NHYPHT
      IF(IPWRL.GE.IPWRK9) GO TO 5079
      NHYPHT=HWORK(IPWRL)
      IF((NHYPHT.LT.1).OR.(NHYPHT.GT.5)) GO TO 5079
      IF(HWORK(IPWRL+1).LE.(IADR0+1)) GO TO 5079
      IF(HWORK(IPWRL+1).GT.IADMAX) GO TO 5079
      GO TO 240
C
      END

C   23/08/85 711181952  MEMBER NAME  MCTAGB   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   11/03/84 403171903  MEMBER NAME  MCTAGB   (S)           FORTRAN
C
C SUBROUTINE TO RETURN BLOCK NUMBER OF HIT BLOCK GIVEN
C X,Y,Z
C
C HANDLES MARKMC 1 2 3 AND 4
C  = 1979/80, 1981/2 ,1983...
C
      SUBROUTINE MCTAGB(MARKMC,X,Y,Z,IBLNO,*)
C
C
C A.J.FINCH 11/3/84
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C    CONSTANTS:
C
C  ------------------------------------------------------------------
C
C 81/2 STUFF
C __________
C
      INTEGER*2 XYMAP(8,8)
C
      DATA XYMAP/2,31,15,18,50,47,63,34,1,32,16,17,49,48,64,33,
     15,28,12,21,53,44,60,37,8,25,9,24,56,41,57,40,
     14,29,13,20,52,45,61,36,3,30,14,19,51,46,62,35,
     17,26,10,23,55,42,58,39,6,27,11,22,54,43,59,38/
C
      DATA X1/83.0/,X2/95.0/,X3/164.0/,X4/176.0/,X5/245.0/,
     1X6/257.0/,Y1/81.0/,Y2/95.5/,Y3/162.0/,Y4/176.5/,Y5/243.0/,
     1Y6/258.0/
C
C ----------------------------------------------------------------------
C
C  79 80 STUFF-
C _____________
C
      DIMENSION NBLIST(11,6)
      DATA NBLIST /4*0,1,2,3,4*0,
     1             2*0,4,5,6,7,8,9,10,2*0,
     2             0,11,12,13,14,15,16,17,18,19,0,
     3             20,21,22,23,24,25,26,27,28,29,30,
     4             31,32,33,34,3*0,35,36,37,38,
     5             39,40,41,42,3*0,43,44,45,46/
C
C ---------------------------------------------------------------------
C
C  83 STUFF
C  ________
C
C     DATA R1/96.0/,R2/110.0/,R3/140.0/,R4/225.0/
C  CHANGE 18.11.87   INNER RADIUS SET TO 86 MM TO ALLOW FOR HITTING
C  FROM BENEATH. THE OUTER RADIUS, 225 MM, IS KEPT TO ALLOW FOR LEAVING
C  THE TAGGER ON THE OUTSIDE BEFORE THE END (CORRECT VALUE IS 214.4 MM).
C
      DATA R1/86.0/,R2/110.0/,R3/140.0/,R4/225.0/
      DATA PIBY4/0.785398163/
      DATA PIBY8/0.392699081/
      DATA TWOPI/6.283185307/
      DATA PI/3.141592654/
C     DATA HSHIFT/6.0/
C
C
C=============== CODE =======
C
C CHOOSE WHICH TAGGER,AND SAVE X,Y
C
C
      IBLOCK = -1
C
      IF(MARKMC.EQ.1)GOTO 1000
      IF(MARKMC.EQ.2)GOTO 1001
      IF(MARKMC.EQ.3)GOTO 1001
      IF(MARKMC.GE.4)GOTO 1002
C
C ----------------------------------------------------------------------
C
C HERE FOR 1983 ....TAGGER
C
C ----------------------------------------------------------------------
C
C
1002  CONTINUE
C
       FI = ATAN(ABS(Y)/ABS(X))
        IF(X.LT.0.AND.Y.GT.0)FI = PI - FI
        IF(X.LT.0.AND.Y.LT.0)FI = FI + PI
        IF(X.GT.0.AND.Y.LT.0)FI = TWOPI - FI
      R = SQRT(X**2+Y**2)
      AFI = FI
C
      DO 10 I = 1,8
       J = I
       AFI = AFI - PIBY4
       IF(AFI.LE.0)GOTO 20
10    CONTINUE
C
20    AFI = AFI + PIBY4
      IF(AFI.GE.PIBY8)BFI =  AFI - PIBY8
      IF(AFI.LT.PIBY8)BFI = PIBY8  - AFI
      RMID = R* COS(BFI)
      IF(RMID.LT.R1)GOTO 90
       IF(RMID.GE.R1.AND.RMID.LT.R2)SHIFT2=0
       IF(RMID.GE.R2.AND.RMID.LT.R3)SHIFT2=8
       IF(RMID.GE.R3.AND.RMID.LT.R4)SHIFT2=16
       IF(RMID.GE.R4)GOTO 90
C
       IF(Z.LT.0.AND.J.LT.3)IBLNO=J+6+SHIFT2
       IF(Z.LT.0.AND.J.GE.3)IBLNO=J-2+SHIFT2
       IF(Z.GT.0.AND.J.LT.7)IBLNO=J+2+SHIFT2+24
       IF(Z.GT.0.AND.J.GE.7)IBLNO=J-6+SHIFT2+24
      RETURN
 90   CONTINUE
      RETURN 1
C
C -----END OF SECTION FOR 1983 TAGGER
C
C---------------------------------------------------------------------
C
C HERE FOR 1981/2 TAGGER
C
C----------------------------------------------------------------------
C
1001  CONTINUE
C( USED TO BE:  SUBROUTINE BLNO81(X,Y,IBLOCK) )
C
      ISHIFT=0
      IF(Z.GT.0)ISIGNZ=1
      IF(Z.LT.0)ISIGNZ=-1
      IF(ISIGNZ.GT.0)ISHIFT=4
C
C   NOW CHOOSE QUADRANT USING X/Y SIGN
C
      IF((X.GT.0).AND.(Y.GT.0))I=1
      IF((X.GT.0).AND.(Y.LT.0))I=2
      IF((X.LT.0).AND.(Y.GT.0))I=3
      IF((X.LT.0).AND.(Y.LT.0))I=4
      I=I+ISHIFT
C
C NOW FIND WHICH BLOCK WITHIN THE QUADRANT USING THE
C  ABSOLUTE MAGNITUDE OF X/Y
C
      AX=ABS(X)
      AY=ABS(Y)
C
C( DO A  RETURN 1 FOR ILLEGAL VALUES OF X/Y OUTSIDE BLOCK EDGES )
C
C DEAL WITH THE TWO BLOCKS CLOSE TO THE X AXIS
C
      IF(AY.GT.Y1)GOTO 105
       IF(AX.LT.X2)RETURN 1
       IF(AX.GT.X6)RETURN 1
       J=1
       IF(AX.GT.X4)J=2
       GOTO 100
C
C DEAL WITH THE TWO BLOCKS ALONG THE Y AXIS
C
105   IF(AX.GT.X1)GOTO110
       IF(AY.LT.Y2)RETURN 1
       IF(AY.GT.Y6)RETURN 1
       J=3
       IF(AY.GT.Y4)J=4
C
       GOTO100
C
C THIS LEAVES THE OUTER BLOCK OF FOUR
C SPLIT FIRST ON Y
C
 110   IF(AY.GT.Y5)RETURN 1
       IF(AX.GT.X5)RETURN 1
       IF(AY.GT.Y3) GOTO 115
C
C THEN SPLIT ON SIZE OF X
C
        J=5
        IF(AX.GT.X3)J=6
        GOTO 100
C
C SPLIT LAST TWO BLOCKS ON X
C
 115   J=7
       IF(AX.GT.X3)J=8
C
C I AND J ARE NOW DETERMINED CAN USE THEM TO DETERMINE ACTUAL
C  HARDWARE ADDRESS /BLOCK NUMBER
C
 100      CONTINUE
          IBLNO=XYMAP(I,J)
C
C   NOW RETURN WITH THE KNOWLEDGE OF A JOB WELL DONE
C
          RETURN
C
C------------------------------------------------------------
C
C ------END OF SECTION FOR 1981/2 TAGGER
C
C----------------------------------------------------------
C
C HERE FOR 1979/80 TAGGER
C
C----------------------------------------------------------
C
 1000  CONTINUE
C
C---  OBTAIN PB-GLASS BLOCK NUMBER CORRESPONDING TO X-Y-POSITION
C---  INPUT:  X- AND Y-COORDINATES (IN MM)
C
C     H.WRIEDT      12.12.78      15:30
C     LAST MODIFICATION     18.01.79       15:00
C
      XSAVE = X
      YSAVE = Y
      IF(Z.GT.0)ISIGNZ=1
      IF(Z.LT.0)ISIGNZ=-1
      N= 0
C---  +Z-DIRECTION (TOWARDS MARKMC J)
      X0 = X
      Y0 = Y
      IF (ISIGNZ.GT.0) GOTO 205
C---  -Z-DIRECTION (TOWARDS PLUTO & CELLO)
      X0 = -X
      Y0 = -Y
C
205   X = X0
      Y = Y0
      IF (X0) 210,211,211
210   X = -X0
211   IF (ABS(Y0).LT.121.5) X = X+20.
      IF (Y0) 220,221,221
220   Y = -Y0
221   IF (X.LT.81.) Y = Y-30.
C
      NX = X/81.
      IF (NX.GE.6) GOTO 2100
      NX = 6-NX
      NY = (Y+40.5)/81.
      IF (NY.GE.6) GOTO 2100
      IF (X0) 240,230,230
C---  BLOCK ADDRESSES 1 TO 46
230   IF (Y0) 231,232,232
231   NY = 6-NY
      GOTO 235
232   NY = 6+NY
235   N = NBLIST(NY,NX)
      IF (N.EQ.0) GOTO 2100
C---  BLOCK ADDRESSES 97 TO 142
      IF (ISIGNZ.GT.0) N = N+96
      GOTO 2100
C---  BLOCK ADDRESSES 49 TO 94
240   IF (Y0) 241,242,242
241   NY = 6+NY
      GOTO 245
242   NY = 6-NY
245   N = NBLIST(NY,NX)
      IF (N.EQ.0) GOTO 2100
      N = 95-N
C---  BLOCK ADDRESSES 145 TO 190
      IF (ISIGNZ.GT.0) N = N+96
C
2100  CONTINUE
      X = XSAVE
      Y = YSAVE
      IBLNO = N
      IF(IBLNO.LE.0)RETURN 1
      RETURN
      END

C   10/02/86 604291041  MEMBER NAME  PRTPEVR  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRTPEV( IPTPEV, XS, YS , DEL, SIZE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 29/04/86 :  PRINT BOS BANK TPEV
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
C
      COMMON / CWORK1 / HWORK(70)
C
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*140
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      LIM2 = IPTPEV
      LIMH2 = 2*LIM2
      CALL CORE(HWORK,62)
      WRITE(cHWORK,1) IDATA(LIM2+1),IDATA(LIM2+2), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *               (HDATA(LIMH2+I),I=5,14)
    1 FORMAT('  ',I8,2X,I8,2X,10I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,62,0.)
      YS = YS - DEL
      CALL CORE(HWORK,114)
      WRITE(cHWORK,2) (HDATA(LIMH2+I),I=15,34) ! PMF 17/11/99: JUSCRN changed to cHWORK
    2 FORMAT('  ',16I5,4I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(cHWORK,3) (ADATA(LIM2+I),I=18,27) ! PMF 17/11/99: JUSCRN changed to cHWORK
    3 FORMAT('  ',10E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,54)
      WRITE(cHWORK,4)(HDATA(LIMH2+I),I=55,56),(ADATA(LIM2+I),I=29,31) ! PMF 17/11/99: JUSCRN changed to cHWORK
    4 FORMAT('  ',2I5,3E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,54,0.)
      YS = YS - DEL
      CALL CORE(HWORK,110)
      WRITE(cHWORK,5) (ADATA(LIM2+I),I=32,40) ! PMF 17/11/99: JUSCRN changed to cHWORK
    5 FORMAT('  ',9E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,110,0.)
      YS = YS - DEL
      CALL CORE(HWORK,120)
      WRITE(cHWORK,6)(HDATA(LIMH2+I),I=81,82),(ADATA(LIM2+I),I=42,50) ! PMF 17/11/99: JUSCRN changed to cHWORK
    6 FORMAT('  ',2I5,9E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
      YS = YS - DEL
      CALL CORE(HWORK,72)
      WRITE(cHWORK,7) (ADATA(LIM2+I),I=51,55) ! PMF 17/11/99: JUSCRN changed to cHWORK
    7 FORMAT('  ',5E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,72,0.)
      YS = YS - DEL
      CALL CORE(HWORK,52)
      WRITE(cHWORK,8) (HDATA(LIMH2+I),I=111,120) ! PMF 17/11/99: JUSCRN changed to cHWORK
    8 FORMAT('  ',10I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,52,0.)
      RETURN
      END

C   18/06/84 705211142  MEMBER NAME  FHTOS    (S)           FORTRAN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE FHTOS(ISAD,IHAD,*)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  THIS ROUTINE CONVERTS HARDWARE ADDRESSES TO SOFTWARE ADDRESSES
C
C  ISAD - OUTPUT - SOFTWARE ADDRESS
C  IHAD - INPUT  - HARDWARE ADDRESS
C
C  RETURN 1 IF IT CANT DO IT ( ILLEGAL ADDRESS SUPPLIED )
C
C
C  NEW VERSION 29/07/84     A.J.FINCH
C  LAST MOD :  18/067/84    J NYE  TIDIED UP
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
C
      INTEGER*2 HDATA
#include "cdata.for"
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   CONVERT HARWARE ADDRESSES TO SOFTWARE ADDRESSES
C
C    THE PATTERN FOR 1983 ONWARDS IS -
C
C    HARDWARE ADDRESS                              SOFTWARE ADDRESS
C
C         0 - 3             NOT USED
C         4 - 7           INNER RING - Z               1 - 4
C         8 - 11            "      "                   5 - 8
C        12 - 15            NOT USED
C        16 - 19             "   "
C        20 - 23           MIDDLE RING - Z             9- 12
C        24 - 27              "  "                     13-16
C        28 - 31            NOT USED
C        32 - 35             "   "
C        36 - 39            OUTER RING - Z         17-20
C        40 - 43              "   "                21-24
C        44 - 47            NOT USED
C
C        48 - 51            NOT USED
C        52 - 55          INNER RING + Z              25 - 28
C        56 - 59            "      "                  29 - 32
C        60 - 63            NOT USED
C        64 - 67             "   "
C        68 - 71           MIDDLE RING + Z            33- 36
C        72 - 75              "  "                    37 -40
C        76 - 79            NOT USED
C        80 - 83             "   "
C        84 - 87            OUTER RING + Z         41-44
C        88 - 91              "   "                45-48
C        92 - 95            NOT USED
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C---------------------------- C O D E ----------------------------------
C
C
C
       IF ( MARK .LT. 2 ) GOTO 100
C
C---                                     HERE FOR 1983 ONWARDS TAGGER
C
       K    =   0
       J    = -12
       ISAD =   0
       DO 10 K = 3,43,8
          J = J + 16
          IF ( (IHAD .GE. J) .AND. (IHAD .LE. (J+7)) ) ISAD = IHAD - K
          IF ( ISAD .NE. 0 ) GOTO 30
  10   CONTINUE
       RETURN 1
C
C---                                     CORRECT FOR BAD CABLING
C
C   FOR REAL DATA BETWEEN RUNS 14589
C   AND 15689 CABLES FROM COUNTERS
C   38 AND 40 TO ADCS WERE INTERCHANGED
C
  30    CONTINUE
        IF ( (ISAD .NE. 38) .AND. (ISAD .NE. 40) ) RETURN
        IF ( IMC .EQ. 1 ) RETURN
        IND   = IDATA(IBLN('HEAD'))
        IF ( IND .LE. 0 ) RETURN
        NRUN  = HDATA(IND+10)
        IF ( (NRUN .LT. 14589) .OR. (NRUN .GT. 15689) ) RETURN
        ISAVE = ISAD
        IF ( ISAVE .EQ. 38 ) ISAD = 40
        IF ( ISAVE .EQ. 40 ) ISAD = 38
        RETURN
C
C---                                     HERE FOR 1981/2 TAGGER
C
C  THE PATTERN IS MUCH SIMPLER !
C
  100  ISAD = IHAD + 1
       RETURN
       END

C   10/04/80 311291221  MEMBER NAME  ERRMSG   (S)           FORTRAN
      SUBROUTINE ERRMSG(MSG,*)
C
C     PRINTOUT OF RUN + EVENT # MASSAGE
C     A. SATO
C
      IMPLICIT INTEGER*2 (H)
      LOGICAL * 1 MSG(1) ,CH1,CH2,CH3
      DATA CH1/';'/,CH2/'$'/,CH3/'^'/
C
C-------------------------------
C  MACRO CHEADR .... HEADER BANK
C-------------------------------
      COMMON /CHEADR/ IHEADR(54)
      INTEGER*2 HHEADR(108)
      EQUIVALENCE (IHEADR(1),HHEADR(1))
C --
C --  HHEADR(17) = EXPERIMENT NUMBER
C --  HHEADR(18) = RUN NUMBER
C --  HHEADR(19) = EVENT NUMBER
C --  HHEADR(38) = MAGNETIC FIELD (GAUSS)
C --
C--------- END OF MACRO CHEADR ------------
      LOGICAL*1 LBREAD
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG
      EQUIVALENCE (HHEADR(18),HRUN) , (HHEADR(19),HEV)
      II=0
       DO 10 I=1,100
         IF(MSG(I).EQ.CH1) GOTO 11
         IF(MSG(I).EQ.CH2) GOTO 11
         IF(MSG(I).EQ.CH3) GOTO 11
10      CONTINUE
        I=100
11      CONTINUE
        I=I-1
C
      PRINT 2002
 2002 FORMAT(1X,' PRINT OUT FROM ERRMSG A POSSIBLE SOURCE IS TRLGL')
      PRINT 2001, NRREAD,HRUN,HEV ,(MSG(J),J=1,I)
 2001 FORMAT(1X,I6,' TH EVENT. NRUN,NRRC ',2I6,2X,100A1)
      RETURN 1
      END

C   14/01/83 307091722  MEMBER NAME  RTBIN    (S)           FORTRAN
      SUBROUTINE RESULT
      COMMON/TOFWRT/NWRIT,LPOINT,TOFREC(15002)
      COMMON/ACSUMS/ NACP(20),NACM(20),ZACP(20),ZACM(20)
      COMMON/SUMS/ ZTOT(20),NTOT(20),ZOTOT(20),NOTOT(20),
     1             NRTOT(20),ZRTOT(20),NROTOT(20),ZROTOT(20)
     2             ,JTOT,JOTOT,XTOT,XOTOT
      COMMON/SING/ZEV(20,20),ZOP(20,20),NEV(20,20),NOP(20,20)
      COMMON /COUNT/ NLOP,NBIN
      COMMON/ACFAC/INDAC,ACUT(5),ACTOT(5),DBIN(20)
      COMMON//BOOK(20000)
      DIMENSION CFAC(20),XAV(5),ZHELP(20)
      LOGICAL PRFL,POK

C  3*1979/80
C  5*SPRING 81
C  4*AUTUMN 81
C  3*SPRING 82
C  3*SUMMER 82
      DATA PI/3.1420/,LBUG/0/,IW/0/
      DATA CFAC/1.18889,1.5256,1.50898,
     2          1.113,1.196,1.145,1.145,1.307,
     3          2*1.119,2*1.0655,
     4          2*1.133,1.078,
     5          3*1.090     ,2*0./
C
      DFICUT = .017
      ALFCUT = .20
      CTOF = 3.142/21.
      ZA = 1000
      ZB = 13000
      CFIC = 3.142/12.
      CALL HLIMIT(20000)
      CALL HEXTEN
      CALL HBOOK1(7,'ASYMM/ACOLL $',20,0.,.2)
      CALL HTABLE( 54,'ITP ITPL$',5,9.,14.,5,9.,14.,1023.)
      CALL HBOOK1(105,'REDUC  $',400,0.,400.)
      CALL HBOOK1(333,'REJECT $',100,0.,100.)
      CALL HBOOK1(11,'COSTET $',100,-1.,1.)
      CALL HBOOK1(21,'COSTET $',100,-1.,1.)
      CALL HBOOK1(171,20H IDTOF             $,100,-50.,50.)
      CALL HBOOK1(12,'COSTET $',20,-.85,.85)
C     CALL HBOOK1(22,'COSTET $',20,-.85,.85)
C     CALL HBOOK1(13,'COSTET $',16,-.85,.85)
C     CALL HBOOK1(14,'COSTET $',12,-.85,.85)
C     CALL HBOOK1(15,'COSTET $',10,-.85,.85)
      CALL HBOOK1(16,'COSTET $',20,-.80,.80)
      CALL HBOOK1(17,'COSTET $',16,-.80,.80)
C     CALL HBOOK1(18,'COSTET $',12,-.80,.80)
      CALL HBOOK1(19,'COSTET $',10,-.80,.80)
      CALL HBOOK1(29,'COSTET $',10,-.80,.80)
      CALL HBARX(11)
      CALL HBARX(12)
C     CALL HBARX(13)
C     CALL HBARX(14)
C     CALL HBARX(15)
      CALL HBARX(16)
      CALL HBARX(17)
C     CALL HBARX(18)
      CALL HBARX(19)
      CALL HBOOK2( 31,' RADCOR   $',40,0.,20.,40,.8,1.2)
      CALL HBOOK2( 32,10HNRUN W1  $,100,ZA,ZB,40,0.,2.)
      CALL HBOOK2( 33,10HIB DTH   $,20,0.,20.,40,0.,1.)
      CALL HBOOK2(102,10HNRUN W   $,100,ZA,ZB,40,0.,2.)
C     CALL HBOOK2(104,' IT ITL   $',40,0.,20.,40,0.,20.,127.)
C     CALL HBPRO(104)
C     CALL HBOOK2(114,' ITP DIT  $',40,0.,20.,20,-10.,10.,511.)
C     CALL HTABLE(  6,' ITP ICP $',18,0.,18.,25,0.,25.,63.)
C     CALL HBPRO(6)
C     CALL HBOOK2(821,10HPIN1 DFI $,80,-.20,.20,40,-.04,.04)
C     CALL HBOOK2(822,10HPIN1 DFI $,80,-.20,.20,40,-.04,.04)
C     CALL HBPRO(821)
C     CALL HBOOK1(823,'1/PN  CUT DFI $',80,-.2,.2)
C     CALL HBOOK1(824,'PN  CUT DFI $',80,-40.,40.)
C     CALL HBOOK1(824,' FI         $',42,0.,6.28)
C     CALL HBOOK1(825,' FI         $',42,0.,6.28)
C     CALL HBOOK2(720,10HDFI1 DFI2$,50,-.25,.25,50,-.25,.25)
C     CALL HBPROX(720)
C     CALL HBOOK1(1,'COSTET $',20,-1.,1.)
      CALL HBOOK1(826,' FI         $',100,0.,10.)
C     CALL HBOOK1(2,'COSTET $',10,-1.,1.)
      CALL HBOOK2(103,10HNRUN IB  $,100,ZA,ZB,40,0.,20.)
      CALL HBOOK1(100,10HEV S     $,100,24.,39.)
      CALL HINTEG(100,3HYES)
      CALL HBOOK1(101,10HEV NRUN  $,100,ZA,ZB)
      CALL HINTEG(101,3HYES)
C
      INDAC = 3
C
      ACUT(1) = .70
      ACUT(2) = .76
      ACUT(3) = .80
      ACUT(4) = .85
      ACUT(5) = .90
      DO  55   J=1,5
      AC = ACUT(J)
      ACTOT(J) = (AC**3/3.+AC)*3./4.
   55 CONTINUE
      DO   56   J=1,20
      DBIN(J) = .1
   56 CONTINUE
      IF(INDAC.EQ.2) DBIN(2) = .06
      IF(INDAC.EQ.2) DBIN(19) = .06
      IF(INDAC.EQ.2) DBIN(1) = 0.
      IF(INDAC.EQ.2) DBIN(20) =0.
      PRINT 155,ACUT,ACTOT
  155 FORMAT(' ACUT,ACTOT',10F12.4)
      PRINT 156,DBIN
  156 FORMAT(' DBIN ',20F5.2)
C
      CALL SETSL(ZEV,0,1600*4,0)
      CALL SETSL(ZTOT,0,164*4,0)
      CALL SETSL(XAV,0,20,0)
      CALL SETSL(NACP,0,80*4,0)
      JTOT = 0
      JOTOT = 0
      XTOT = 0.
      XOTOT = 0.
      NLOP = 18
      NSUB = NLOP
      NBIN = 12
      LUN = 25
      NIN = 0
      NACC = 0
      L = 0
   60 LPOINT = 2
      READ(LUN,END=82) TOFREC
      PRINT 125,(TOFREC(I),I=1,60)
  125 FORMAT(1X,10F12.3)
      LMAX = IFIX(TOFREC(1))
      NWRDEV = IFIX(TOFREC(2))
   80 CONTINUE
      NIN = NIN + 1
      L = L + 1
      IREJ = 0
      PRFL = .FALSE.
      EB = TOFREC(LPOINT+1)
      ZR = TOFREC(LPOINT+6)
      IF(ZR.LT.5660.)  GOTO  74
      ZZEV= TOFREC(LPOINT+9)
      CALL ELIM(ZR,ZZEV,LOUT)
      IF(LOUT.NE.0)  GOTO  81
C
   74 PCUT = EB/3.
      INDAC = 3
      IF(ZR.GT.5660.)  GOTO  76
      INDAC = 2
      PCUT = 4.
      IB = 1
      IF(EB.GE.16.81) IB = 2
      IF(EB.GE.17.59) IB = 3
      GOTO  99
   76 IF(ZR.GT.7600.)  GOTO  97
C SPRING 81
      INDAC = 2
      IB = 1+3
      IF(EB.LE.15.)  GOTO  99
      IB = 3+3
      IF(ZR.LT.6630.) IB = 2+3
      IF(ZR.GT.6989.) IB = 4+3
      IF(ZR.GE.7326.) IB = 5+3
      GOTO  99
   97 CONTINUE
C AUTUMN 81
      IF(ZR.GT.10000.)  GOTO  98
      IB = 1+8
      IF(EB.GT.17.20) IB = 2+8
      IF(ZR.GT.9152.) IB = 3+8
      IF(ZR.GT.9452.) IB = 4+8
      GOTO  99
   98 IF(ZR.GT.11000.)  GOTO  121
C SPRING 82
      IB = 1+12
      IF(EB.LT.17.4) IB = 2+12
      IF(ZR.GT.10565.) IB = 3+12
      GOTO  99
  121 IF(ZR.GT.20000.)  GOTO  99
C SUMMER 82
      IB = 1+15
      IF(ZR.GT.11472.) IB = 2+15
      IF(ZR.GT.11916.) IB = 3+15
   99 CONTINUE
C
      CALL HF1(105,(IB-1)*20.,1.)
      S = 4.*EB*EB
      T1 = TOFREC(LPOINT+2)
      T1L= TOFREC(LPOINT+7)
      T2 = TOFREC(LPOINT+3)
      T2L= TOFREC(LPOINT+8)
C     IF(T1L.GT.1..OR.T2L.GT.1.) PRFL = .TRUE.
C     IF(ABS(T1-T1L).GT..2) PRFL = .TRUE.
C     IF(ABS(T2-T2L).GT..2) PRFL = .TRUE.
      T1T = T1
      T2T = T2
      P1 = TOFREC(LPOINT+4)
      P2 = TOFREC(LPOINT+5)
      PN1 = TOFREC(LPOINT+15)
      PN2 = TOFREC(LPOINT+16)
      DFI = TOFREC(LPOINT+17)
      POK = .TRUE.
      IF(P1*P2.LT.0.)  GOTO  88
C     GOTO  81
C     PRFL = .TRUE.
      POK = .FALSE.
      CALL HF1(105,(IB-1)*20.+2.,1.)
   83 IF(ABS(DFI).GT.DFICUT)  GOTO  88
      POK = .TRUE.
      CALL HF1(105,(IB-1)*20.+4.,1.)
C     GOTO  88
      P1 =-PN1
      P2 =-PN2
   88 CONTINUE
      ITRB = IFIX(TOFREC(LPOINT+14))
   54 CONTINUE
      FI1 = TOFREC(LPOINT+10)
      FI2 = TOFREC(LPOINT+11)
      ALF = TOFREC(LPOINT+12)
C
      IF(P1*P2.GT.0..AND.PRFL) PRINT 127
  127 FORMAT(1H+,79X,'***')
C
C   MAKE ADDITIONAL CUTS HERE AND GO TO 81
C
C   CHOOSE LEAD GLASS OR TRACKS
C     T1 = T1L
C     T2 = T2L
      CALL HF1(105,(IB-1)*20.+6.,1.)
      IF(IB.GT.3.AND.IB.LE.8.AND.
     &  (ABS(T1).GT..75.OR.ABS(T2).GT..75))  GOTO  81
      IREJ = 1
      IF(ABS(T1).GT.ACUT(INDAC))  GOTO  81
      IREJ = 2
      IF(ABS(T2).GT.ACUT(INDAC))  GOTO  81
      IREJ = 3
      CALL HF1(105,(IB-1)*20.+10.,1.)
      PAV = .5*(ABS(P1)+ABS(P2))
      IF(PAV.LT.PCUT)  GOTO  81
      IREJ = 4
      CALL HF1(105,(IB-1)*20.+14.,1.)
      IF(ALF.GT.ALFCUT)  GOTO  81
      IREJ = 5
      CALL HF1(105,(IB-1)*20.+15.,1.)
      ITR1 = IAND(ITRB,16)
      ITR2 = IAND(ITRB,32)
      IF(ITR1.NE.0) CALL HF1(105,(IB-1)*20.+16.,1.)
      IF(ITR2.NE.0) CALL HF1(105,(IB-1)*20.+17.,1.)
      IF(IB.GT.3.AND.IB.LE.8.AND.ITR1.LE.0)  GOTO  81
      IREJ = 6
      IF(IB.GT.8.AND.ITR2.LE.0)  GOTO  81
      IREJ = 7
C     IF(ITR1.LE.0.OR.ITR2.NE.0)  GOTO  81
C
C CALCULATE WHICH CELL LAST POINT IS IN
      AF = 0.
      IC1 = (FI1-AF*CFIC)/CFIC+1
      IC2 = (FI2-AF*CFIC)/CFIC+1
C
C CALCULATE WHICH TOFCOUNTER LAST POINT IS IN
            NCNT1 = IFIX((FI1+CTOF/2.)/CTOF)+1
            IF(NCNT1.GE.43) NCNT1=NCNT1-42
            IF(NCNT1.LT.1) NCNT1=1
            NCNT2 = IFIX((FI2+CTOF/2.)/CTOF)+1
            IF(NCNT2.GE.43) NCNT2=NCNT2-42
            IF(NCNT2.LT.1) NCNT2=1
      IDTOF = IABS(NCNT1-NCNT2)
      CALL HF1(171,FLOAT(IDTOF)-21.,1.)
C     IF(IABS(IDTOF-21).LE.1)  GOTO 81
C
      DFI1 = FI1-(FLOAT(IC1)-.5+AF)*CFIC
      DFI2 = FI2-(FLOAT(IC2)-.5+AF)*CFIC
      CALL HFILL(720,DFI1,DFI2,1.)
C     IF(ABS(DFI1).LT..01.OR.ABS(DFI1).GT..12)  GOTO  81
C     IF(ABS(DFI2).LT..01.OR.ABS(DFI2).GT..12)  GOTO  81
C
      NACC = NACC + 1
      T = .5*(ABS(T1)+ABS(T2))
C
      TP = 100.
      IF(P1.LT.0.) TP = T1
      IF(P2.LT.0.) TP = T2
      IF(P1.GT.0.) TN = T1
      IF(P2.GT.0.) TN = T2
      FIP= 100.
      IF(P1.LT.0.) FIP=FI1
      IF(P2.LT.0.) FIP=FI2
      IF(P1.GT.0.) FIN=FI1
      IF(P2.GT.0.) FIN=FI2
      IF(P1*P2.LT.0.) CALL HFILL(821,1./PN1,DFI,1.)
      IF(P1*P2.LT.0.) CALL HFILL(821,1./PN2,DFI,1.)
      IF(T1.GT.0..AND.ABS(DFI).LT.DFICUT) CALL HF1(823,1./PN1,1.)
      IF(T2.GT.0..AND.ABS(DFI).LT.DFICUT) CALL HF1(823,1./PN2,1.)
C     IF(T1.GT.0..AND.ABS(DFI).LT.DFICUT) CALL HF1(824,PN1,1.)
C     IF(T2.GT.0..AND.ABS(DFI).LT.DFICUT) CALL HF1(824,PN2,1.)
      IF(POK)  GOTO  70
C
C  IN CASE OF EQUAL SIGNS TAKE SIGN OF SMALLER MOM
      IF(ABS(P2).GT.ABS(P1))  GOTO  71
C  P2 SMALLER
      IF(P2.LT.0.) TP = T2
      IF(P2.GT.0.) TP = T1
      IF(P2.GT.0.) TN = T2
      IF(P2.LT.0.) TN = T1
      IF(P2.LT.0.)FIP =FI2
      IF(P2.GT.0.)FIP =FI1
      IF(P2.GT.0.)FIN =FI2
      IF(P2.LT.0.)FIN =FI1
      GOTO  87
C  P1 SMALLER
   71 IF(P1.LT.0.) TP = T1
      IF(P1.GT.0.) TP = T2
      IF(P1.GT.0.) TN = T1
      IF(P1.LT.0.) TN = T2
      IF(P1.LT.0.)FIP =FI1
      IF(P1.GT.0.)FIP =FI2
      IF(P1.GT.0.)FIN =FI1
      IF(P1.LT.0.)FIN =FI2
C
   87 CONTINUE
C     PRFL = .TRUE.
      CALL HFILL(822,1./PN1,DFI,1.)
      CALL HFILL(822,1./PN2,DFI,1.)
      IF(PRFL)PRINT 126, L,IB,EB,ZR,T1,T2,PN1,PN2,S,DFI,ITRB
  126 FORMAT(2I5,F8.2,F8.0,2F8.3,2F8.1,F8.2,F7.3,I5)
C     PRFL = .FALSE.
C CHANGE SIGN OF LARGER MOM
C     IF(ABS(P1).GT.ABS(P2))  GOTO  85
C     P2 = -P2
C     GOTO  89
C  85 P1 = -P1
C  89 IF(P1.LT.0.) TP = T1
C     IF(P2.LT.0.) TP = T2
C
   70 CONTINUE
C TP IS COS THET OF POSITIVE TRACK
      ITP = (TP+.96)/.16+1
      ITN = (TN+.96)/.16+1
C T  IS AVERAGE COS(THET) OF POSITIVE AND NEG TRACK
      T = T*TP/ABS(TP)
      IT = (T+.96)/.16+1
C     ITP = IT
C     ITP = ITN
      IT1 = (T1+1.)/.1+1
      IT2 = (T2+1.)/.1+1
      ICP = IC1
      IF(ITP.EQ.IT2) ICP = IC2
C TRACK-LG CORR PLOT
      ITPL = 20
      ITPT = IT1
      IF(ABS(TP-T2).LT..001) ITPT = IT2
      IF(T1L.GT.1..OR.T2L.GT.1.)  GOTO 84
      IT1T= (T1T+1.)/.1+1
      IT1L= (T1L+1.)/.1+1
      IT2T= (T2T+1.)/.1+1
      IT2L= (T2L+1.)/.1+1
      ITPL = IT1L
      IF(ABS(TP-T2).LT..001) ITPL = IT2L
C  CHECK SIGN AT VERTICAL INCIDENCE
C     IF(ITP.NE.10.AND.ITP.NE.11)  GOTO  94
C     CALL HFILL(54,FLOAT(ITP),FLOAT(ITPL),1.)
C     LBUG = LBUG + 1
C     IF(LBUG.LE.20) PRINT 283,T1,T2,T1L,T2L,TP
C 283 FORMAT(' VERTICAL',10F10.3)
CC    IF(LBUG.LE.20) PRINT 284,IT1,IT2,IT1L,IT2L,ITP,ITPL
C 284 FORMAT(' VERTICAL',6I5)
C     IF(ITP.EQ.10.AND.ITPL.EQ.11) ITP = 11
C     IF(ITP.EQ.11.AND.ITPL.EQ.10) ITP = 10
C     IF(LBUG.LE.20) PRINT 284,ITP
C
   94 CONTINUE
C     IF(IABS(ITPT-ITPL).GT.1) PRINT 117,ZR,T1T,T2T,T1L,T2L,
C    * IT1T,IT2T,IT1L,IT2L,ITPT,ITPL
C 117 FORMAT(' TRLG',5F10.2,6I5)
   84 CALL HFILL(104,FLOAT(ITPT),FLOAT(ITPL),1.)
      DIT = FLOAT(ITPL)-FLOAT(ITPT)
      CALL HFILL(114,FLOAT(ITPT),DIT,1.)
      CALL HFILL(6,FLOAT(ITP),FLOAT(ICP),1.)
      IF(PRFL) PRINT 128, T,TP,IT,ITP
  128 FORMAT('+',87X,2F8.3,2I5)
      IF(IT.LT.1) IT=1
      IF(ITP.LT.1) ITP=1
      IF(IT.GT.20) IT=20
      IF(ITP.GT.20) ITP=20
C
      W = 1.
      DTH = .1
      IF(IB.GT.8)  GOTO  75
      IF(ITP.NE.3.AND.ITP.NE.18)  GOTO  75
      IF(IB.GT.3)  GOTO  73
      DTH = .06
      GOTO 75
   73 DTH = .05
   75 W = CFAC(IB)*RADCOR(ITP,INDAC)
C  75 W = CFAC(IB)
      CALL HFILL(31,FLOAT(ITP),RADCOR(ITP,INDAC))
      CALL HFILL(33,FLOAT(IB),DTH)
      IF(IB.LE.8)  GOTO  77
C     IF(IB.LE.15.AND.(ABS(T1).GE..75.OR.ABS(T2).GE..75)) W = W*1.13
C     IF(IB.GT.15.AND.(ABS(T1).GE..75.OR.ABS(T2).GE..75)) W = W*1.13
   77 IF(W.LE.0.)  W = 1.
      W1 = W
      W = W*.1/DTH
C     IF(ZR.LE.10564.) CALL HF1(824,FIP,1.)
C     IF(ZR.GT.10564.) CALL HF1(825,FIP,1.)
      CALL HFILL(102,ZR,W,1.)
      CALL HFILL( 32,ZR,W1,1.)
      CALL HFILL( 33,FLOAT(IB),DTH,1.)
      CALL HFILL(103,ZR,FLOAT(IB),1.)
      IF(PRFL) PRINT 132,W
  132 FORMAT('+',117X,F8.3)
      CALL HF1(100,2.*EB,1.)
      CALL HF1(101,ZR,1.)
C
C  CALCULATE AVERAGE COS THETA
      XAV(3) = XAV(3) + TP*TP*TP*W
      XAV(1) = XAV(1) + TP*W
      XAV(2) = XAV(2) + W
      CALL HFILL(11,TP,0.,W)
      CALL HFILL(12,TP,0.,W)
      CALL HFILL(22,TP,0.,1.)
      CALL HFILL(13,TP,0.,W)
      CALL HFILL(14,TP,0.,W)
      CALL HFILL(15,TP,0.,W)
      CALL HFILL(16,TP,0.,W)
      CALL HFILL(17,TP,0.,W)
      CALL HFILL(18,TP,0.,W)
      CALL HFILL(19,TP,0.,W)
      CALL HFILL(29,TP,0.,1.)
      CALL HF1(826,FIP,W1)
C
C WRITE EVENT
C
C     WRITE(39)TP,W
      IW = IW + 1
C
      NEV(ITP,IB) = NEV(ITP,IB)+1
      NTOT(IB) = NTOT(IB) + 1
      NRTOT(ITP) = NRTOT(ITP)+1
      JTOT = JTOT + 1
C
      ZEV(ITP,IB) = ZEV(ITP,IB) + W1
      ZTOT(IB) = ZTOT(IB) + W1
      ZRTOT(ITP) = ZRTOT(ITP) + W1
      XTOT = XTOT + W1
C
      IF(.NOT.POK)  GOTO  81
      NOP(ITP,IB) = NOP(ITP,IB)+1
      NOTOT(IB) = NOTOT(IB)+1
      NROTOT(ITP) = NROTOT(ITP)+1
      JOTOT = JOTOT + 1
C  DIFFERENTIAL ACCUM IN ACOLLINEARITY
      IAC = ALF/.01+1
      IF(NACC.LE.20) PRINT 407,ALF,ITP,IAC
  407 FORMAT(' IAC',F10.4,2I5)
      IF(IAC.LT. 1) IAC = 1
      IF(IAC.GT.20) IAC = 20
      IF(ITP.GT.10) NACP(IAC) = NACP(IAC) + 1
      IF(ITP.LE.10) NACM(IAC) = NACM(IAC) + 1
C
      ZOP(ITP,IB) = ZOP(ITP,IB) + W1
      ZOTOT(IB) = ZOTOT(IB) + W1
      ZROTOT(ITP) = ZROTOT(ITP) + W1
      XOTOT = XOTOT + W1
      IF(ITP.GT.10) ZACP(IAC) = ZACP(IAC) + W1
      IF(ITP.LE.10) ZACM(IAC) = ZACM(IAC) + W1
      GOTO  79
C EVENT REJECTED
   81 CALL HFILL(21,TP,0.,1.)
   79 LPOINT = LPOINT + NWRDEV
      CALL HF1(333,FLOAT(IREJ),1.)
      IF(LPOINT.LT.LMAX)  GOTO  80
      GOTO  60
C
   82 IF(IB.LT.18)  GOTO 86
      PRINT 102
      PRINT 109
  109 FORMAT(' NEV')
      DO   40   N=1,NSUB
      PRINT 124,(NEV(L,N),L=1,20),NTOT(N)
  124 FORMAT(1X,20I5,5X,I5)
   40 CONTINUE
      PRINT 102
      PRINT 124,NRTOT,JTOT
      PRINT 102
C
      PRINT 108
  108 FORMAT(' NOP')
      DO   41   N=1,NSUB
      PRINT 124,(NOP(L,N),L=1,20),NOTOT(N)
   41 CONTINUE
      PRINT 102
      PRINT 124,NROTOT,JOTOT
      PRINT 102
C
      PRINT 110
  110 FORMAT(' ZEV')
      DO   42   N=1,NSUB
      PRINT 129,(ZEV(L,N),L=1,20),ZTOT(N)
   42 CONTINUE
      PRINT 102
      PRINT 129,ZRTOT,XTOT
      PRINT 102
C
      PRINT 111
  111 FORMAT(' ZOP')
      DO   43   N=1,NSUB
      PRINT 129,(ZOP(L,N),L=1,20),ZOTOT(N)
   43 CONTINUE
      PRINT 102
      PRINT 129,ZROTOT,XOTOT
      PRINT 102
C
  129 FORMAT(1X,20F5.1,5X,F7.2)
  102 FORMAT(//)
   86 PRINT 145,LUN,NIN,NACC,IB
  145 FORMAT(//' LUN,NIN,NACC,IB ',4I10//)
      NIN = 0
      NACC = 0
      LUN = LUN + 1
      IF(LUN.LE.29)  GOTO  60
C
C     CALL SHRWRT(2,NWRDEV,TOFREC(LPOINT+1),W,DTH)
C  WRITE LAST EVENT DUMMY
      TP = -20.
      WRITE(39)TP,W

C
      PRINT 231,IW,XAV(1),XAV(2),XAV(3)
 231  FORMAT(//' XAV',I10,3F12.5//)
      CALL CROSCL
      CALL HPRERR(11,3HYES)
      CALL HPRERR(12,3HYES)
      CALL HPRERR(13,3HYES)
      CALL HPRERR(14,3HYES)
      CALL HPRERR(15,3HYES)
      CALL HPRERR(16,3HYES)
      CALL HPRERR(17,3HYES)
      CALL HPRERR(18,3HYES)
      CALL HPRERR(19,3HYES)
      CALL HISTDO
      RETURN
      END

C   13/03/84 410282057  MEMBER NAME  FAMPDS   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FAMPDS
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON   20/07/83 :  DISPLAY FAMP RESULTS
C
C        MOD  J. OLSSON    9/12/83 :
C   LAST MOD  C. BOWDERY  14/03/84 :  RECOMMENTING. USES FAMPCO
C   LAST MOD  J. OLSSON   26/10/84 :  NAME 'FAMP' NOW ACCEPTED
C
C        DISPLAY ROUTINE FOR RESULTS OF ONLINE FAMP ANALYSIS
C        FAMP:  FAST AMSTERDAM MICRO PROCESSOR
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      COMMON / CWORK2 / HWORK(80)
      COMMON / CJTRIG / PI,TWOPI
C
      DATA VELH /.2998E-4/
      DATA INAME /'BK17'/
      DATA JNAME /'FAMP'/
      DATA HPLUS/'+ '/,HMINUS/'- '/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*160
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
C                            DISPLAY PATREC FITS FROM FAMP BANK 'BK17'
C
      IFAMP = IDATA( IBLN( 'FAMP' ) )
      IF( IFAMP .GT. 0 ) GO TO 2
      IFAMP = IDATA( IBLN( 'BK17' ) )
      IF( IFAMP .GT. 0 ) GO TO 2
        WRITE(6,1)
   1    FORMAT(' NO FAMP (''BK17'') BANK AVAILABLE')
        RETURN
C
   2  IF( LASTVW .LT. 4 ) GO TO 4
        WRITE(6,3)
   3    FORMAT(' FAMP RESULTS DISPLAY NOT POSSIBLE IN THIS VIEW')
        RETURN
C
   4  LH2 = IFAMP * 2
      ND  = HDATA(LH2+7)
      IF( ND .GT. 0 ) GO TO 6
        WRITE(6,5)
   5    FORMAT(' NO INNER DETECTOR INFORMATION IN FAMP BANK (''BK17'')')
        RETURN
C
   6  CONTINUE
      NTR  = HDATA( LH2 + ND + 4 )
      NTRT = HDATA( LH2 + ND + 5 )
      IF( NTR .GT. 0 ) GO TO 20
        IF( NTR .LT. 0 ) WRITE(6,10)
  10      FORMAT(' NO FAMP PATTERN RECOGNITION WAS PERFORMED')
        IF( NTR .EQ. 0 ) WRITE(6,14)
  14      FORMAT(' NO TRACKS WERE FOUND BY FAMP PATTERN RECOGNITION')
        RETURN
C
C                            THERE ARE FAMP PATREC DATA TO BE DISPLAYED
C
  20  LORT = HDATA( LH2 + ND + 6 )
      LTRT = HDATA( LH2 + ND + 7 )
C
      IPLT = LH2 + ND + LORT - LTRT
C
C                            LOOP OVER ALL THE TRACKS AND DRAW THEM
C
      VELHB = ABS( VELH * BKGAUS )
C
      DO  100  ITR = 1,NTR
        IPLT  = IPLT + LTRT
        IF( HDATA(IPLT) .LT. 0 ) GO TO 100
C
C                            FAMPCO EXTRACTS COORDINATES IN MM
C
        CALL FAMPCO( IPLT, X1, Y1, Z1, X2, Y2, Z2, RR )
C
        DIST2 = (X1 - X2)**2 + (Y1 - Y2)**2
C
        XM    = X1 + (X2 - X1) / 2.0
        YM    = Y1 + (Y2 - Y1) / 2.0
C
        SAGIT = DIST2 / (8.0 * RR)
        REST  = RR - SAGIT
        DIST  = SQRT( DIST2 )
        COSD  = (X2 - X1) / DIST
        SIND  = (Y2 - Y1) / DIST
        X0    = XM + (SIND * REST)
        Y0    = YM - (COSD * REST)
        PHI0  = ATAN2( Y0,X0 )
        RMIN  = SQRT( X0**2 + Y0**2 ) - ABS( RR )
C+++
C       WRITE(6,21) ITR,X1,Y1,X2,Y2,XM,YM
  21    FORMAT(' ITR ',I3,' XY1 XY2 XYM ',3(2E13.5,2X))
C       WRITE(6,22) SAGIT,DIST,REST,X0,Y0,PHI0,RMIN
  22    FORMAT(' SG D REST XY0 FI0 RM ',5E13.5,2X,F6.3,E13.5)
C+++
C
C                            FAMPFT IS A VERSION OF CIRDIS (CIRCLE DISP)
C
        CALL FAMPFT( 25, RR, RMIN, PHI0, X1, Y1, X2, Y2, 0.0, 0.0 )
C
C                            WRITE TRACK NUMBER AT (X2,Y2)
C
        CALL TRNUMB( ITR, 0, X2, Y2, 0.0 )
 100  CONTINUE
C
C                            PRINT OUT TRACK INFORMATION ON SCREEN
C
C                            HEADER OF TRACK INFO LISTING
C
      XXX = XMIN + 0.82 * (XMAX - XMIN)
      YYY = YMIN + 0.76 * (YMAX - YMIN)
      CALL XXXYYY( XXX, YYY, SSS, 0 )
      YYY = YYY - 12.0 * SSS
      IF( LASTVW .EQ. 2 ) YYY = YYY - 2.0 * SSS
C
      CALL CORE(HWORK,80)
      WRITE(cHWORK,200) INAME,NTR   ! PMF 17/11/99: UNIT=10 changed to cHWORK
 200  FORMAT(' BANK ',A4,' NR OF TRACKS ',I3)
      CALL SYSSYM( XXX, YYY, SSS, HWORK, 27, 0.0 )
C
      YYY = YYY - 2.0 * SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,205)             ! PMF 17/11/99: UNIT=10 changed to cHWORK
 205  FORMAT('NR +-  PTRANS NFI NZ')
      CALL SYSSYM( XXX, YYY, SSS, HWORK, 22, 0.0 )
C
      YYY = YYY - 1.5 * SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,210)             ! PMF 17/11/99: UNIT=10 changed to cHWORK
 210  FORMAT(' X1 Y1 Z1')
      CALL SYSSYM( XXX, YYY, SSS, HWORK, 9, 0.0 )
C
      YYY = YYY - 1.5 * SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,215)             ! PMF 17/11/99: UNIT=10 changed to cHWORK
 215  FORMAT(' X2 Y2 Z2')
      CALL SYSSYM( XXX, YYY, SSS, HWORK, 9, 0.0 )
      YYY = YYY - 4.5 * SSS
C
C                            LOOP OVER THE TRACK PARAMETERS AGAIN
C
      IPLT = LH2 + ND + LORT - LTRT
      DO  300  ITR = 1,NTR
        IPLT    = IPLT + LTRT
        IF( HDATA(IPLT) .LT. 0 ) GO TO 300
C
C                            FAMPCO EXTRACTS COORDINATES IN MM
C
        CALL FAMPCO( IPLT, X1, Y1, Z1, X2, Y2, Z2, RR )
C
        NFI     = HDATA(IPLT + 11)
        NZ      = HDATA(IPLT + 15)
        PTRANS  = VELHB * ABS( RR )
C
C                            DETERMINE SIGN
C
        HSIGN   = HPLUS
        IF( RR * BKGAUS .LT. 0.0 ) HSIGN = HMINUS
C
C                            WRITE TRACK PARAMETERS ON SCREEN
C
        YYY = YYY - 1.5 * SSS
        CALL CORE(HWORK,80)
        WRITE(cHWORK,310) ITR,HSIGN,PTRANS,NFI,NZ ! PMF 17/11/99: UNIT=10 changed to cHWORK
 310    FORMAT(I2,1X,A2,1X,F7.2,1X,I2,1X,I2)
        CALL SYSSYM( XXX, YYY, SSS, HWORK, 19, 0.0 )
C
        YYY = YYY - 1.5 * SSS
        CALL CORE(HWORK,80)
        WRITE(cHWORK,320) X1,Y1,Z1  ! PMF 17/11/99: UNIT=10 changed to cHWORK
 320    FORMAT(3(F7.1,1X))
        CALL SYSSYM( XXX, YYY, SSS, HWORK, 24, 0.0 )
C
        YYY = YYY - 1.5 * SSS
        CALL CORE(HWORK,80)
        WRITE(cHWORK,320) X2,Y2,Z2  ! PMF 17/11/99: UNIT=10 changed to cHWORK
        CALL SYSSYM( XXX, YYY, SSS, HWORK, 24, 0.0 )
 300  CONTINUE
C
      RETURN
      END

C   11/02/81 701191523  MEMBER NAME  ELGOBS0  (SOURCE)      FORTRAN
      FUNCTION ELGOBS(IBE,DC,EINC)
C
C  THIS PROGRAM CALCULATE THE OBSERVED ENERGY.
C  FROM THE TRUE ENERGY (FOR MONTE CARLO)     11/2/81  Y.WATANABE
C   LAST MOD    04-11-81   15:50   (DEBUGGED)
C
C  IBE; 0=BARREL, +-1=+,-END CAP
C  DC; THE DIRECTION COSINE
C
      DIMENSION DC(3)
      COMMON /CLGDMS/  X0,RADIUS(6),RADSX0(6),
     1  THX0(4),ZEND(2),ZENDX0(2),
     2  ZWID(2),ZGAP(2),PHWID(2),
     3  ZECAP(4),ZECAPX(4),THECPX(2),
     4  ECXLST(24),ECYLST(24)
C
C  THECPX(1)   THICKNESS OF END CAP COUNTER IN MM
C        (2)                                   X0
C  RADIUS(1,2) DISTANCE TO THE COIL SURFACE (INNER AND OUTER)
C        (3,4) DISTANCE TO THE LEAD GLASS SURFACE (TYPE A)
C  ZEND(1)     END POINT OF BARREL PART COUNTERS  (-)
C      (2)                                        (+)
C  ZGAP(1)     COUNTER GAP OF BARREL PART IN MM
C  THX0(1)     MAGNET COIL THICKNESS IN X0
C              X0 = 8.9 CM FOR ALUMINUM
C
      DATA PAI2/6.283185/
C
C  INITIAL SET UP
C
      ELGOBS=EINC
      IF(EINC.LT.0.001) RETURN
      DEP=SHMAX(EINC*1000,1)
      COSX=DC(1)
      COSY=DC(2)
      COSZ=DC(3)
C     WRITE(6,900) IBE,EINC,ELGOBS,COSX,COSY,COSZ,DEP
C900  FORMAT(I5,10F10.3)
C
      IF(IBE.EQ.0) GO TO 1
CCCCCCCCCCCCCCCCCCCCC
C
C  END CAP COUNTERS
C
CCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF THE LIGHT GUIDE
C
      III=1
      IF(COSZ.GT.0.) III=2
      XCO=ZEND(III)*COSX/COSZ
      YCO=ZEND(III)*COSY/COSZ
      R = THECPX(1)/COSZ-DEP
      R=ABS(R)
      IF( R.LT.0. ) R=0.
      XX=XCO+R*COSX
      YY=YCO+R*COSY
C
      THETA=ARCOS(COSZ)
      THETA=ABS(THETA)*57.2958
      IF(IBE.EQ.-1) THETA=180.0-THETA
C     WRITE(6,900) III,R,XX,YY,THETA
C
C   ITERATION FOR INCIDENT ENERGY
C
C
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
10    X=XX/X0
      Y=YY/X0
      CALL LGNMEC(X,Y,ID)
C
C   CHECK IF HIT IS INSIDE THE COUNTER
C
C
      IF(ID.GT.0) GO TO 60
      X=XCO/X0
      Y=YCO/X0
      CALL LGNMEC(X,Y,ID)
C
      IF(ID.GT.0) GO TO 60
      ELGOBS=0.
      RETURN
C
   60 MB=(ID-1)/24 +1
      ID=MOD(ID-1,24)+1
      U=ECXLST(ID)
      V=ECYLST(ID)
      GO TO (4,5,6,7),MB
    4 X=U
      Y=V
      GO TO 8
    5 X=-V
      Y=U
      GO TO 8
    6 X=-U
      Y=-V
      GO TO 8
    7 X=V
      Y=-U
    8 R=0.1*SQRT((X-XX)*(X-XX)+(Y-YY)*(Y-YY))
      DDR=SQRT(XX*XX+YY*YY)-SQRT(X*X+Y*Y)
      IF(ABS(R).GT.1.E-10) DDR=0.1*DDR/R
C
C     POS DEP
C
      CALL POSEND(EINC,R,DDR,FAC,&80)
C
      ELGOBS=EINC*FAC
      RETURN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  BARREL PART COUNTERS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF LIGHT GUIDE
C
    1 R=RADIUS(3)+DEP
      RPHI=SQRT(COSX*COSX+COSY*COSY)
      COSPHI=COSX/RPHI
      SINPHI=COSY/RPHI
C       X Y POSITION AT THE SHOWER MEDIAN.
      X=R*COSPHI
      Y=R*SINPHI
C
C     DISTANCE FROM THE SHOWER MAX POINT TO THE EXTRAPOLATED POINT
C           AT THE END FACE OF LEAD GLASS
      A=COSX*COSX+COSY*COSY
      B=X*COSX+Y*COSY
      C=X*X+Y*Y-RADIUS(4)*RADIUS(4)
      RDIF=(SQRT(B*B-A*C)-B)/A
C      X Y Z POSITION AT THE END FACE OF LG
      X=X+RDIF*COSX
      Y=Y+RDIF*COSY
C
      IF(ABS(X).LT.1.E-15) X=1.E-15
      THETA=ATAN2(Y,X)
      IF(THETA.LT.0.) THETA=THETA+PAI2
      STEP=PAI2/84.
      ITH=THETA/STEP
C
C       INCIDENT ANGLE
      ANGNOR=(ITH+0.5)*STEP
      COSNOR=COS(ANGNOR)
      SINNOR=SIN(ANGNOR)
      THETA=COSNOR*COSX+SINNOR*COSY
C     ABSORBER THICKNESS TRAVERSED BY THE PARTICLE.
      D=7.88/ABS(THETA)
      THETA=ARCOS(THETA)*57.2958
C     WRITE(6,910) ITH,ANGNOR,COSNOR,SINNOR,THETA,D
C910  FORMAT(I4,10F12.4)
C
C        ENERGY LOSS IN THE COIL
C
21    CALL ENGLOS(EINC,D,DELTAE,&80)
      ELGOBS=EINC-DELTAE
      IF(ELGOBS.GT.0.) GO TO 22
      GO TO 80
C
C       ANGLE DEPENDENCE
C
22    CALL ANGBAR(ELGOBS,THETA,AFAC,&80)
C
C     CALL POSBAR(ELGOBS,R,THETA,PFAC,&80)
C
CCC   FAC=PFAC*AFAC
      ELGOBS=ELGOBS*AFAC
C     WRITE(6,920) EINC,ELGOBS,AFAC,DELTAE
C920  FORMAT(' EINC,ELGOBS,AFAC,DELTAE',10F12.4)
      RETURN
C
C     ILLEGAL RETURN
C
   80 CONTINUE
      ELGOBS=0.
      RETURN
      END

C   19/11/79 806150900  MEMBER NAME  COMPR    (S)           FORTRAN
      SUBROUTINE COMPR(NRUN)
#include "tfprm.for"
#include "tfadc.for"
      DIMENSION CNEW(546),COLD(546),IDIF(546)
      DATA IENTRY/0/
      CALL UCOPY(CORNOR,CNEW,378)
      IF(NRUN.LE.1659) CALL COMPR2(NRUN)
      IF(NRUN.LE.1659) RETURN
      CALL UCOPY(CADCA,CNEW(379),168)
      IF(IENTRY.EQ.0)  GOTO  10
C
      NDIF = 0
      DO   2   I=1,546
      IDIF(I) = 0
      IF(ABS(CNEW(I)-COLD(I)).LE..001)  GOTO  2
      NDIF = NDIF + 1
      IDIF(NDIF) = I
    2 CONTINUE
      IF(NDIF.LE.0)  GOTO  10
      PRINT 103,NRUN,NDIF
  103 FORMAT(1X,100('=')/' CONST CHANGE AT RUN ',I5,I10,' CHANGES'/)
      PRINT 100,((IDIF(I),COLD(IDIF(I)),CNEW(IDIF(I))),I=1,NDIF)
  100 FORMAT(1X, 5(I5,2F8.4,2X))
      PRINT 104
  104 FORMAT(1X,100('='))
C
   10 CALL UCOPY(CNEW,COLD,546)
      IENTRY = IENTRY + 1
      IF(IENTRY.NE.1) RETURN
      PRINT 101,NRUN
      PRINT 111
  111 FORMAT(/' VELSC')
      PRINT 102,VELSC
      PRINT 111
  112 FORMAT(/' CORNOR')
      PRINT 102,CORNOR
      PRINT 113
  113 FORMAT(/' COROVF')
      PRINT 102,COROVF
      PRINT 114
  114 FORMAT(/' TPARM ')
      PRINT 102,TPARM
      PRINT 115
  115 FORMAT(/' TCALM ')
      PRINT 109,TCALM
      PRINT 116
  116 FORMAT(/' TCALP ')
      PRINT 109,TCALP
      PRINT 117
  117 FORMAT(/' PEDLM ')
      PRINT 102,PEDLM
      PRINT 118
  118 FORMAT(/' PEDLP ')
      PRINT 102,PEDLP
      PRINT 119
  119 FORMAT(/' CADCA ')
      PRINT 109,CADCA
      PRINT 120
  120 FORMAT(/' CADCB ')
      PRINT 102,CADCB
  102 FORMAT(/(1X,10F10.3))
  109 FORMAT(/(1X,10F10.5))
  101 FORMAT(' PRINTOUT COMPR CALIBRATION CONSTANTS FOR RUN ',I5)
C
      RETURN
      END

C   12/08/87 708131102  MEMBER NAME  TRKBL9   (S)           FORTRAN77
C   02/10/81 208051138  MEMBER NAME  TRKBLK   (SHOWS)       FORTRAN
      SUBROUTINE TRKBL9(IPN,IALGN,ITER1,ITER2,ILIPS)
C
C   COPIED FROM F11HEL.NEUFS(TRKBL9)
C
C
C   UEBERNOMMEN VON  F11MEI.SHOWS(TRKBLK)
C
C             CALCULATING PATHLENGTH IN LG-BLOCKS AFTER
C             OPTIMIZING THE BLOCK-TRACK CONNECTION
C
C             3 X 3 MATRIX
C             =====
C                                                 04/08/1982
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
      DIMENSION IRKL(2,50)
      EQUIVALENCE(IRKL(1,1),TRKL(1,1))
C  VALUES ARE BLOCK DATA SET AT THE END OF THIS ROUTINE
      COMMON/CSHD/ PSHD(2),XSHD(2),YSHD(2),ZSHD(2)
      DIMENSION ALIST(3,50),BLIST(3,50),TSURF(3,12)
      DIMENSION POS1(25),POS2(25)
      DIMENSION X(3),V(3)
      EQUIVALENCE (XI,X(1)),(YI,X(2)),(ZI,X(3))
      EQUIVALENCE (UI,V(1)),(VI,V(2)),(WI,V(3))
      DATA PI/3.14159/, TWOPI/6.283185/
      DATA SIGX,SIGY,SIGZ,SIGP / 40., 40., 40.,.02/
      DATA POS1,POS2 /3*0.,3*1.,3*-1.,16*0.,0.,-1.,1.,0.,-1.,1.,0.,-1.,
     * 1.,16*0./
C
C                                           MOD 13/08/87 E E
      EXTERNAL JADEBD
C                                           END MOD
      DATA ICALL/0/
      ICALL=ICALL+1
      II=ILIPS
      IF(ICALL.LE.3) WRITE(6,1001) PSHD(II),XSHD(II),YSHD(II),ZSHD(II)
 1001 FORMAT(/,1X,' PSHD,XSHD,YSHD,ZSHD FROM NEUFS(TRKBL9)',4F11.4,/)
      IF(ICALL.GT.1) GO TO 9999
      ZLGEFM=ZLGMI+BLZ
      ZLGEFP=ZLGPL-BLZ
      RBARSQ=RLG**2
      OUTRSQ=OUTR2**2
      RMAG=RCOIL+0.5*DRCOIL
      RMAGSQ=RMAG**2
      DEPENH=0.5*DEPEND
      TSURF( 1, 1)=0.
      TSURF( 1, 2)=   BLXY
      TSURF( 1, 3)=2.*BLXY
      TSURF( 1, 4)=TSURF( 1, 3)+50.
      TSURF( 1, 5)=3.*BLXY
      TSURF( 1, 6)=TSURF( 1, 5)+50.
      TSURF( 1, 7)=4.*BLXY
      TSURF( 1, 8)=TSURF( 1, 7)+50.
      TSURF( 1, 9)=5.*BLXY
      TSURF( 1,10)=TSURF( 1, 9)+50.
      TSURF( 1,11)=6.*BLXY
      TSURF( 1,12)=TSURF( 1,11)+50.
      TSURF( 2, 1)=2.*BLXY+50.
      TSURF( 2, 2)=2.*BLXY
      TSURF( 2, 3)=   BLXY
      TSURF( 2, 4)=0.
      TSURF( 2, 5)=0.
      TSURF( 2, 6)=0.
      TSURF( 2, 7)=0.
      TSURF( 2, 8)=0.
      TSURF( 2, 9)=0.
      TSURF( 2,10)=0.
      TSURF( 2,11)=0.
      TSURF( 2,12)=0.
      TSURF( 3, 1)=6.*BLXY+50.
      TSURF( 3, 2)=6.*BLXY+50.
      TSURF( 3, 3)=6.*BLXY
      TSURF( 3, 4)=   BLXY
      TSURF( 3, 5)=5.*BLXY
      TSURF( 3, 6)=   BLXY
      TSURF( 3, 7)=5.*BLXY
      TSURF( 3, 8)=   BLXY
      TSURF( 3, 9)=4.*BLXY
      TSURF( 3,10)=   BLXY
      TSURF( 3,11)=2.*BLXY
      TSURF( 3,12)=   BLXY
C
 9999 DO 40 ICLR=1,50
      IRKL(1,ICLR)=-1
      TRKL(2,ICLR)=0.
   40 CONTINUE
C
      IPNH0=2*IALGN+5
      NWO=IDATA(IALGN)
      MXH=2*(IALGN+NWO)
C
C     DON'T EXTRAPOLATE PATHOLOGICAL TRACKS
C
      IF(IDATA(IPN+24).LT.6.OR.IDATA(IPN+33).LT.6) GOTO 1
C
C     GET R-Z FIT PARAMETERS.
C
      Z0=ADATA(IPN+31)
      ZSL=ADATA(IPN+30)
      OODEM=1./SQRT(1.+ZSL**2)
      WI=    ZSL*OODEM
C
C     FIND RADIUS AND CENTER OF GYRATION IN X,Y PLANE.
C
      ITYPE=IDATA(IPN+18)
      IF(ITYPE.NE.1) GO TO 2
C
C     CIRCLE FIT.
C     GET INITIAL POINT AND DIRECTION IN CASE WE USE THE STRAIGHT
C     LINE APPROXIMATION.
C

      AC=ADATA(IPN+21)
      X0=ADATA(IPN+20)*COS(AC)
      Y0=ADATA(IPN+20)*SIN(AC)
      R0SQ=X0**2+Y0**2
      R0=SQRT(R0SQ)
      A0=AC-PI/2.
      DOT=ADATA(IPN+8)*COS(A0)+ADATA(IPN+9)*SIN(A0)
      IF(DOT.LT.0.) A0=A0+PI
      CROSS=0.
C
      CURV=ADATA(IPN+19)
      IF(CURV.LT.1.E-6) GO TO 3
      R=1./CURV
      D0=R+ADATA(IPN+20)
      ALPHA=ADATA(IPN+21)
      XC=D0*COS(ALPHA)
      YC=D0*SIN(ALPHA)
      AL0=ATAN2((Y0-YC),(X0-XC))
      GO TO 4
    2 CONTINUE
      IF(ITYPE.NE.2) GO TO 1
C
C     PARABOLA FIT.
C
      A0=ADATA(IPN+19)
      X0=ADATA(IPN+20)
      Y0=ADATA(IPN+21)
      CURV=2.*ADATA(IPN+22)
      IF(ABS(CURV).GT.1.E-6) GO TO 76
      ANG=A0+PI/2.
      PERP=X0*COS(ANG)+Y0*SIN(ANG)
      X0=PERP*COS(ANG)
      Y0=PERP*SIN(ANG)
      R0SQ=X0**2+Y0**2
      R0=SQRT(R0SQ)
      GO TO 3
   76 CONTINUE
      R=1./CURV
      ANG=A0+PI/2.
      XC=X0+R*COS(ANG)
      YC=Y0+R*SIN(ANG)
      R=ABS(R)
      AL0=ATAN2(-YC,-XC)
      X0=XC+R*COS(AL0)
      Y0=YC+R*SIN(AL0)
      A0=AL0-PI/2.
      DOT=ADATA(IPN+8)*COS(A0)+ADATA(IPN+9)*SIN(A0)
      IF(DOT.LT.0.) A0=A0+PI
      GO TO 4
    3 CONTINUE
C
C     STRAIGHT LINE CASE.
C
      UI=COS(A0)*OODEM
      VI=SIN(A0)*OODEM
      AR0=0.
      IF(R0.GT.0.1) AR0=ATAN2(Y0,X0)
      CSD=COS(A0-AR0)
      SDSQ=1.-CSD**2
      RADIA=RBARSQ-SDSQ*R0SQ
      IF(RADIA.LT.0.0) GOTO 351
      XYPATH=SQRT(RADIA)-R0*CSD
      PATH=XYPATH/OODEM
      ZBIMPC=Z0+WI*PATH
      IF(ZBIMPC.LT.ZLGEFM) GO TO 5
      IF(ZBIMPC.GT.ZLGEFP) GO TO 7
C
C     HITS BARREL.
C
      IREG=0
      XI=X0+UI*PATH
      YI=Y0+VI*PATH
      ZI=ZBIMPC
      GO TO 6
    5 CONTINUE
      IREG=-1
      ZPATH=ZENDMI-Z0
      ZI=ZENDMI
      GO TO 75
    7 CONTINUE
      IREG=1
      ZPATH=ZENDPL-Z0
      ZI=ZENDPL
   75 CONTINUE
      PATH=ZPATH/WI
      XI=X0+UI*PATH
      YI=Y0+VI*PATH
      GO TO 6
    4 CONTINUE
C
C     CIRCULAR ORBITS.
C
      CROSS=(X0-XC)*ADATA(IPN+9)-(Y0-YC)*ADATA(IPN+8)
      RCSQ=XC**2+YC**2
      RC=SQRT(RCSQ)
      RMAX=RC+R
      IF(RMAX.LT.(RMAG+100.)) GO TO 8
      DEL=R-RC
      IF(ABS(DEL).LT.1.E-1) DEL=0.
      COSL=(2.*RC*DEL+DEL**2-RMAGSQ)/(2.*RC*RMAG)
      AL=ARCOS(COSL)
      IF(CROSS.LT.0.) AL=-AL
      AIN=AL0+AL
      XI=RMAG*COS(AIN)
      YI=RMAG*SIN(AIN)
      XYPATH=SQRT((XI-X0)**2+(YI-Y0)**2)
      APATH=2.*ARSIN(0.5*XYPATH/R)
      IF(CROSS.LT.0.) APATH=-APATH
      ZPATH=ZSL*R*ABS(APATH)
      ZI=Z0+ZPATH
      IF((ZI.LT.ZLGEFM).OR.(ZI.GT.ZLGEFP)) GO TO 8
C
C     INTERSECTS COIL.
C
      IREG=0
      AI=A0+APATH
      UI=COS(AI)*OODEM
      VI=SIN(AI)*OODEM
C
C     TRANSPORT FROM COIL TO BARREL.
C
      BTERM=(UI*XI+VI*YI)/OODEM
      XYPATH=SQRT(RBARSQ-RMAGSQ+BTERM**2)-BTERM
      PATH=XYPATH/OODEM
      XI=XI+UI*PATH
      YI=YI+VI*PATH
      ZI=ZI+WI*PATH
      GO TO 6
    8 CONTINUE
      IF(ABS(WI).LT.0.1) GO TO 29
      IF(WI.GT.0.) GO TO 9
      IREG=-1
      ZI=ZENDMI
      GO TO 10
    9 CONTINUE
      IREG=1
      ZI=ZENDPL
   10 CONTINUE
      ZPATH=ZI-Z0
      APATH=ZPATH/(ZSL*R)
      IF(CROSS.LT.0.) APATH=-APATH
      AIN=AL0+APATH
      XI=XC+R*COS(AIN)
      YI=YC+R*SIN(AIN)
      AI=A0+APATH
      UI=COS(AI)*OODEM
      VI=SIN(AI)*OODEM
C
    6 CONTINUE
      PTRANS=ABS(0.0299792458*BKGAUS/CURV)
      PLONGI=PTRANS*ZSL
      ECHPRT=SQRT(PTRANS**2+PLONGI**2+139.57**2)
      IF(ECHPRT.GT.15000.) ECHPRT=6000.
      PMAG=SQRT(ECHPRT**2-139.57**2)
      PTRANS=PMAG/SQRT(1.+ZSL**2)
      PLONGI=PTRANS*ZSL
C
C
C     TRANSPORT PARTICLES THROUGH LEAD GLASS.
C
C
      XSHIFT = XSHD(ILIPS)
      YSHIFT = YSHD(ILIPS)
      ZSHIFT = ZSHD(ILIPS)
      PSHIFT = PSHD(ILIPS)
      XSTART = XI
      YSTART = YI
      ZSTART = ZI
      PSTART = ATAN2(XI,YI)
      IF(PSTART.LT.0) PSTART = PSTART + TWOPI
      IFINE = 0
      ITER1 = 0
      ITER2 = 0
C
   37 QUAMAX = 0.
      ITMAX = 1
      ITER = 1
      ITSEL = 0
      X1=XI
      Y1=YI
      Z1=ZI
      PH1 = ATAN2(XI,YI)
      IF(PH1.LT.0) PH1=PH1+TWOPI
   34 CONTINUE
      NSURF=0
      IF(IREG.NE.0) GO TO 11
C
C     HITS BARREL.
C
      XI=RLG*SIN(PH1 + POS2(ITER)*PSHIFT)
      YI=RLG*COS(PH1 + POS2(ITER)*PSHIFT)
      ZI=Z1 + POS1(ITER)*ZSHIFT
      PHI=ATAN2(XI,YI)
      IF(PHI.LT.0.) PHI=PHI+TWOPI
      WEIGHT = DGAUS2(ZI,PHI,ZSTART,PSTART,SIGZ,SIGP)
      BTERM=(UI*XI+VI*YI)/OODEM
      XYPATH=SQRT(OUTRSQ-RBARSQ+BTERM**2)-BTERM
      PATH=XYPATH/OODEM
      XF=XI+UI*PATH
      YF=YI+VI*PATH
      ZF=ZI+WI*PATH
      DPHI=ARSIN((XI*YF-XF*YI)/(RLG*OUTR2))
      IF(ABS(DPHI).LT.1.E-3) GO TO 20
      PHII=TWOPI+ATAN2(YI,XI)
      PHIF=PHII+DPHI
      IBI=84.*PHII/TWOPI
      IBF=84.*PHIF/TWOPI
      NSURF=0
      NBCR=IABS(IBF-IBI)
      IF(NBCR.LT.1) GO TO 20
      PHIMI=TWOPI*(IBI+0.5)/84.
      PHIMF=TWOPI*(IBF+0.5)/84.
      STEP=(PHIMF-PHIMI)/NBCR
      PHIN=PHIMI+0.5*STEP-PI/2.
   21 CONTINUE
      UN=COS(PHIN)
      VN=SIN(PHIN)
      DRIFTN=-(UN*XI+VN*YI)
      DOT=UN*UI+VN*VI
      DRIFT=DRIFTN/DOT
      IF(NSURF.GE.48) GOTO 20
      NSURF=NSURF+1
      ALIST(1,NSURF)=XI+UI*DRIFT
      ALIST(2,NSURF)=YI+VI*DRIFT
      ALIST(3,NSURF)=ZI+WI*DRIFT
      IF(NSURF.GE.NBCR) GO TO 20
      PHIN=PHIN+STEP
      GO TO 21
   20 CONTINUE
      IF(ABS(WI).LT.1.E-3) GO TO 22
      IBI=(ZI+50.*BLZ)/BLZ
      IBF=(ZF+50.*BLZ)/BLZ
      NBCR=IABS(IBF-IBI)
      IF(NBCR.LT.1) GO TO 22
      ZMI=(IBI+0.5)*BLZ-50.*BLZ
      ZMF=(IBF+0.5)*BLZ-50.*BLZ
      STEP=(ZMF-ZMI)/NBCR
      ZS=ZMI+0.5*STEP
      ISTEP=0
   23 CONTINUE
      DRIFTN=ZS-ZI
      DRIFT=DRIFTN/WI
      ISTEP=ISTEP+1
      IF(NSURF.GE.48) GOTO 22
      NSURF=NSURF+1
      ALIST(1,NSURF)=XI+UI*DRIFT
      ALIST(2,NSURF)=YI+VI*DRIFT
      ALIST(3,NSURF)=ZS
      IF(ISTEP.GE.NBCR) GO TO 22
      ZS=ZS+STEP
      GO TO 23
   22 CONTINUE
      IF(NSURF.GE.49) GOTO 18
      NSURF=NSURF+1
      ALIST(1,NSURF)=XI
      ALIST(2,NSURF)=YI
      ALIST(3,NSURF)=ZI
      IF(NSURF.GE.50) GOTO 18
      NSURF=NSURF+1
      ALIST(1,NSURF)=XF
      ALIST(2,NSURF)=YF
      ALIST(3,NSURF)=ZF
      GO TO 18
   11 CONTINUE
C
C     HITS ENDCAP.
C
      XI=X1+POS1(ITER)*XSHIFT
      YI=Y1+POS2(ITER)*YSHIFT
      ZI=Z1
      WEIGHT = DGAUS2(XI,YI,XSTART,YSTART,SIGX,SIGY)
      ZF=ZI+IREG*DEPEND
      ZM=0.5*(ZI+ZF)
      IDIM=0
      NSURF=0
   12 CONTINUE
      IDIM=IDIM+1
      JDIM=3-IDIM
      TRANS=V(IDIM)
      IF(ABS(TRANS).LT.1.0E-3) GO TO 13
      KTR=0
   14 CONTINUE
      KTR=KTR+1
      IF(KTR.GT.23) GO TO 13
      JTR=13-KTR
      IF(KTR.GE.12) JTR=KTR-11
      SIGN=-1.
      IF(KTR.GE.12) SIGN=1.
      TDRIFT=SIGN*TSURF(1,JTR)-X(IDIM)
      DRIFT=TDRIFT/TRANS
      ZS=ZI+WI*DRIFT
      IF(ABS(ZS-ZM).GT.DEPENH) GO TO 14
      YS=X(JDIM)+V(JDIM)*DRIFT
      AYS=ABS(YS)
      IF((AYS.LT.TSURF(2,JTR)).OR.(AYS.GT.TSURF(3,JTR))) GOTO 14
      NSURF=NSURF+1
      ALIST(IDIM,NSURF)=SIGN*TSURF(1,JTR)
      ALIST(JDIM,NSURF)=YS
      ALIST(   3,NSURF)=ZS
      GO TO 14
   13 CONTINUE
      IF(IDIM.LT.2) GO TO 12
      NSURF=NSURF+1
      ALIST(1,NSURF)=XI
      ALIST(2,NSURF)=YI
      ALIST(3,NSURF)=ZI
      DRIFT=(ZF-ZI)/WI
      XF=XI+UI*DRIFT
      YF=YI+VI*DRIFT
      NSURF=NSURF+1
      ALIST(1,NSURF)=XF
      ALIST(2,NSURF)=YF
      ALIST(3,NSURF)=ZF
C
C     BARREL AND END CAP TRACKS MERGE HERE.
C
   18 CONTINUE
C
C     ORDER.
C
      DO 15 I=1,NSURF
      AMINW=1.0E8
      DO 16 J=1,NSURF
      IF(IREG.EQ.0) CW=ALIST(1,J)**2+ALIST(2,J)**2
      IF(IREG.NE.0) CW=ABS(ALIST(3,J))
      IF(CW.GT.AMINW) GO TO 16
      AMINW=CW
      K=J
   16 CONTINUE
      DO 17 J=1,3
      BLIST(J,I)=ALIST(J,K)
      ALIST(J,K)=2.0E8
   17 CONTINUE
   15 CONTINUE
C
C     COUNT REAL BLOCKS HIT AND COMPUTE PATH LENGTHS.
C
      NBLK=0
      DO 19 I=2,NSURF
      XB=0.5*(BLIST(1,(I-1))+BLIST(1,I))
      YB=0.5*(BLIST(2,(I-1))+BLIST(2,I))
      ZB=0.5*(BLIST(3,(I-1))+BLIST(3,I))
      IBLK=NUMBLC(XB,YB,ZB,IREG)
      IF(IBLK.LT.0) GO TO 19
      NBLK=NBLK+1
      DX=BLIST(1,I)-BLIST(1,(I-1))
      DY=BLIST(2,I)-BLIST(2,(I-1))
      DZ=BLIST(3,I)-BLIST(3,(I-1))
      IF(ABS(DX).LT.1.0E-3) DX=1.0E-3
      IF(ABS(DY).LT.1.0E-3) DY=1.0E-3
      IF(ABS(DZ).LT.1.0E-3) DZ=1.0E-3
      DL=SQRT(DX**2+DY**2+DZ**2)
      IRKL(1,NBLK)=IBLK
      TRKL(2,NBLK)=DL
   19 CONTINUE
   29 CONTINUE
C
      QUANT = 0.
      TRITER = 0.
      EBITER = 0.
      NBLE = 0
      IF(NBLK.LT.1) GOTO 32
C
C     TOTAL TRACKLENGTH FOR THIS ITERATION
C
      DO 88 ILOP=1,NBLK
      TRITER = TRITER + TRKL(2,ILOP)
   88 CONTINUE
      IF(TRITER.LT..00001) GOTO 32
C
C     CALCULATE QUANT
C
      KBLK=0
   25 CONTINUE
      KBLK=KBLK+1
      IF(KBLK.GT.NBLK) GO TO 26
      IBLK=IRKL(1,KBLK)
      EBL=0.
      IPNH=IPNH0
   27 CONTINUE
      IPNH=IPNH+2
      IF(IPNH.GT.MXH) GO TO 28
      JBLK=HDATA(IPNH)
      IF(JBLK.NE.IBLK) GO TO 27
      NBLE = NBLE + 1
      EBL=HDATA(IPNH+1)
      EBITER = EBITER + EBL
      IF(ITER1.GT.1) GOTO 28
      ITER1=ITER1+2
      EBLO1=EBL
      NBL1=JBLK
   28 QUANT = QUANT + (EBL/ECHPRT)*(TRKL(2,KBLK)/TRITER)
      GOTO 25
   26 QUANT = WEIGHT*QUANT*FLOAT(NBLE)/FLOAT(NBLK)
      IF(ITSEL.EQ.1) GOTO 36
      IF(ITER2.GT.1) GOTO 31
      ITER2=ITER2+2
      EBIT1=EBITER
      NBN1=NBLE
C
   31 IF(QUANT.LE.QUAMAX) GOTO 32
      QUAMAX = QUANT
      ITMAX = ITER
   32 CONTINUE
      IF(ITSEL.EQ.1) GOTO 36
C
      ITER = ITER + 1
      IF(ITER.LE.9) GOTO 34
C
C     AGAIN FOR BEST ITERATION.
C
      ITSEL = 1
      ITER = ITMAX
      GOTO 34
C
C     NEW GRID
C
   36 CONTINUE
      IF(IFINE.EQ.1) GOTO 35
      XSHIFT = XSHIFT/3.
      YSHIFT = YSHIFT/3.
      ZSHIFT = ZSHIFT/3.
      PSHIFT = PSHIFT/3.
      IFINE = 1
      GOTO 37
C
   35 IBLCHK = 0
      IF(NBLK.LT.1) IBLCHK = 1
      IF(NBLK.GE.1.AND.EBITER.LT.1.) IBLCHK = 2
      RETURN
C                                           MOD 13/08/87 E E
C 351 IBLCSE=4
  351 IBLCHK=4
C                                           END MOD
      RETURN
    1 IBLCHK = 3
      RETURN
      END
C=======================================================================
      BLOCK DATA BLZ1           !PMF 09/12/99: add name
C
      COMMON/CSHD/ PSHD(2),XSHD(2),YSHD(2),ZSHD(2)
      DATA PSHD/0.0075,0.0225/, XSHD/15.0,45.0/
      DATA YSHD/15.0,45.0/, ZSHD/30.0,75.0/
      END

C   15/03/79 C9090901   MEMBER NAME  LGCLPC   (SOURCE)      FORTRAN
C   13/03/79 C9031501   MEMBER NAME  LGCLPCN  (S)           FORTRAN
      SUBROUTINE LGCLPC
C
C     MODIFIED TO CALCULATE THE CLUSTER SHAPE
C     BY R.EICHLER       15-03-78  12:00
C     LAST MODIFICATION    16-08-79  19:40      Y.WATANABE
C
C     ORGNL. S.YAMADA      13-01-78 VERSION 2 (LAST MOD.08-02-79,23:30)
C
C---- LEAD GLASS CLUSTERS IN THE ENDCAP PART ARE PROCESSED.
C---- TOTAL PULSE HEIGHT,AVERAGE POSITION AND SPATIAL SPREAD ARE
C     CALCULATED FOR EACH CLUSTER.
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     1                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     2                ZECAP(4),ZECAPX(4),THECPX(2),
     3                ECXLST(24), ECYLST(24)
      COMMON /CLGPRM/ ITHADC,MAXCLS
      COMMON/LGSHP/WW(50),YY(50),XX(50),EW(2),AVX,AVY,SIGX,SIGY,EV,KK
C
      COMMON /CLGMSB/ MSGVAL(5)
      DIMENSION AMSGVL(5)
      EQUIVALENCE (MSGVAL(1),AMSGVL(1))
C
#include "clgwork1.for"
C
C     ICLSPR(1,I)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     CLSPRP(2,I)=ENERGY IN GEV
C     CLSPRP(3,I)=SIG(ENERGY)
C     CLSPRP(4,I)=WEIGHTED AVERAGE X
C     CLSPRP(5,I)=WEIGHTED AVERAGE Y
C     CLSPRP(6,I)=SIGMA X (WEIGHTED)
C     CLSPRP(7,I)=SIGMA Y (WEIGHTED)
C     ICLSPR(8,I)=CHARGE,IF THERE IS A CHARGED NEIGHBOUR
C                  TRACK,ITS CHARGE IS COPIED.
C     CLSPRP(9--11,I)=DIRECTION COSIGNS OF THE CLUSTER
C     CLSPRP(12-14,I)=CLUSTER SHAPE: ELLIPS EIGENVALUES AND DIRECTION
C     CLSPRP(15,I)=FRACTION OF ENERGY IN EDGE COUNTERS IN THE CLUSTER
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/279071617/
      NVRSN(10) = NVCODE
C
      IF(NCLBEC(2)+NCLBEC(3).LE.0) RETURN
      N1 = NCLBEC(1)+1
      N2 = NCLST
      IF(N2 .GT. MAXCLS) N2=MAXCLS
        DO 1 N=N1,N2
        NS = HMAPCL(1,N)
        NL = HMAPCL(2,N)
        WSUM = 0.
        KK=NL-NS+1
        IF(KK.GT.50) KK = 50
          DO 2 NN=NS,NL
          ID = HLGADC(1,NN)
          ID = ID-2687
          IPART = -1
          IF(ID.LE.96) GO TO 3
          ID = ID-96
          IPART = 1
          IF(ID.LE.96) GO TO 3
C-----    ILLEGAL COMPONENT NO.
          MSGVAL(1) = NN
          MSGVAL(2) = ID
          MSGVAL(3) = HLGADC(1,NN)
          CALL LGMESG( 6, 1)
C-----    BAD DATA IS SKIPPED.
          GO TO 2
C
    3     MB = (ID-1)/24
          ID = ID-24*MB
          U = ECXLST(ID)
          V = ECYLST(ID)
          MB = MB+1
          GO TO (4,5,6,7),MB
    4     X = U
          Y = V
          GO TO 8
    5     X = -V
          Y = U
          GO TO 8
    6     X = -U
          Y = -V
          GO TO 8
    7     X = V
          Y = -U
C----     PULSE HEIGHT OF THE NN-TH HIT IS CALIBRATED TO GIVE MEV.
C         CHANGE IT TO GEV.
C
    8     W = HLGADC(2,NN)
          WSUM = WSUM+W
C
          IF(W) 90,9,9
C----     NEGATIVE ENERGY,   CLEARED TO PROTECT 'LGEIGN'.
   90     AMSGVL(1) = W
          CALL LGMESG( 6, 2)
          W = 0.
C
C----     FILL ARRAYS FOR CLUSTER SHAPE ANALYSIS
    9     NM=NN-NS+1
          IF(NM.GT.50) GO TO 14
          WW(NM)=W
          YY(NM)=Y
          XX(NM)=X
C
C----     CORNER CHECK
   14     CALL LGCRNR( IPART, ID, ID, ICLS)
          IF(ICLS.EQ.1) CLSPRP(15,N)=CLSPRP(15,N)+W
    2   CONTINUE
C
        CALL LGEIGN(1.)
C       CHANGE SIGZ AND SIGPH IN LINEAR DIMENSION.(Y.WATANABE 8/9/79)
        IF(SIGX.GT.0.) SIGX=SQRT(SIGX)
        IF(ABS(AVX-XX(1)).LT.0.1) SIGX=140./3.4641
C       WHEN ONLY ONE ROW OF THAT DIMENSION FIRE,
C       SIGMA=COUNTER WIDTH/2/SQRT(3).
        IF(SIGY.GT.0.) SIGY=SQRT(SIGY)
        IF(ABS(AVY-YY(1)).LT.0.1) SIGY=140./3.4641
C
C
C----   FILL RESULTS
        ICLSPR(1,N) = IPART
        WSUM = WSUM*0.001
        CLSPRP(2,N) = WSUM
        CALL LGEERR(IPART,WSUM,CLSPRP(3,N))
        CLSPRP(4,N) = AVX
        CLSPRP(5,N) = AVY
        CLSPRP(6,N) = SIGX
        CLSPRP(7,N) = SIGY
        CLSPRP(12,N)=EW(2)/EW(1)
        CLSPRP(13,N)=EW(1)+EW(2)
        CLSPRP(14,N)=EV
        CLSPRP(15,N)=0.001*CLSPRP(15,N)/WSUM
C
C----   ENERGY SUM
        IF(IPART) 10,1,20
   10   ETOT(3) = ETOT(3)+WSUM
        GO TO 1
   20   ETOT(4) = ETOT(4)+WSUM
C
    1   CONTINUE
  100 RETURN
      END

C   07/06/96 606071902  MEMBER NAME  PODA     (S4)          FORTG1
      SUBROUTINE PODA(IGOTO,LIST,IL)
C     BOS SUBPROGRAM   =4.4=
      COMMON/BCS/IW(1)
#include "ccs.for"
      INTEGER LIST(5,1),IBOS/'BOSS'/,DIRA/'DIRA'/
      JPAS=IPAS
      IPAS=0
      INDT=0
      CALL BLOC(INDA,'+DIR',IUND,*10)
      GOTO 12
   10 CALL BCRE(INDA,'+DIR',IUND,52,*60,IER)
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.LT.1610) GOTO 60
      CALL RDDA(1,IW(INDA+1),IW(INDA+2))
      IW(INDA+9)=0
      IW(INDA+10)=0
      IW(INDA+51)=0
      IW(INDA+52)=0
      WRITE(6,101) IUND,IW(INDA+6),IW(INDA+7),(IW(INDA+J),J=21,35)
      IF(IW(INDA+19).EQ.0) GOTO 11
      IF(IW(INDA+19).EQ.JPAS) GOTO 11
      IF(JPAS.EQ.IBOS) GOTO 11
      IW(INDA+19)=0
      IW(INDA+20)=1
      WRITE(6,102) IUND
      GOTO 12
   11 IW(INDA+20)=0
   12 IF(IW(INDA+2).EQ.DIRA) GOTO 13
      IF(IW(INDA+2).NE.IW(INDA-3)) GOTO 60
   13 GOTO (14,14,24),IGOTO
C     SEARCH/DELETE
   14 NHASH=2+MOD(IABS(LIST(1,1)+LIST(2,1)),IW(INDA+8))
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.LT.1610) GOTO 60
   16 CALL RDDA(NHASH,IW(IA),IW(IA+1))
      NHASHX=IW(IA+3)
      INDP=IA+4
      N=IW(INDP)/4
      IF(N.EQ.0) GOTO 20
      IF(N.LT.0.OR.N.GT.1610) GOTO 60
      K=INDP
      DO 18 I=1,N
      IF(LIST(1,1).NE.IW(K+1)) GOTO 18
      IF(LIST(2,1).NE.IW(K+2)) GOTO 18
      LIST(3,1)=IW(K+3)
      LIST(4,1)=IW(K+4)
      INDT=K
      GOTO (100,22),IGOTO
   18 K=K+4
   20 NHASH=NHASHX
      IF(NHASH.NE.0) GOTO 16
      GOTO 100
   22 NH=INDP+IW(INDP)-K-4
      IF(NH.NE.0) CALL UCOPY2(IW(K+5),IW(K+1),NH)
      IW(INDP)=IW(INDP)-4
      IW(IA)  =IW(IA)  -4
      CALL WRDA(NHASH,IW(IA),IW(IA+1))
      GOTO 100
C     INSERT
   24 NHASHF=0
      NHASHL=0
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.LT.1610) GOTO 60
      I=0
   26 I=I+1
      IF(I.GT.IL) GOTO 34
      NHASH=2+MOD(IABS(LIST(1,I)+LIST(2,I)),IW(INDA+8))
      IF(NHASH.EQ.NHASHF) GOTO 31
      NHASHF=NHASH
   28 IF(NHASHL.EQ.0) GOTO 30
      CALL WRDA(NHASHL,IW(IA),IW(IA+1))
      NHASHL=0
   30 CALL RDDA(NHASH,IW(IA),IW(IA+1))
   31 INDP=IA+4
      N=IW(INDP)/4
      IF(N.GE.400) GOTO 32
      CALL UCOPY(LIST(1,I),IW(INDP+IW(INDP)+1),4)
      IW(INDP)=IW(INDP)+4
      IW(IA)  =IW(IA)  +4
      NHASHL=NHASH
      GOTO 26
   32 IF(IW(IA+3).EQ.0) GOTO 33
      NHASH=IW(IA+3)
      GOTO 28
   33 NHASHL=NHASH
      IW(INDA+7)=IW(INDA+7)+1
      NHASH=IW(INDA+7)
      NTOT=IW(IA)
      NWDR=IW(IA+4)
      IW(IA)=4
      IW(IA+4)=0
      CALL WRDA(NHASH,IW(IA),IW(IA+1))
      IW(INDA+7)=IW(INDA+7)+1
      IW(IA)=0
      CALL WRDA(NHASH+1,IW(IA),IW(IA+1))
      IW(IA)  =NTOT
      IW(IA+3)=NHASH
      IW(IA+4)=NWDR
      GOTO 28
   34 IF(NHASHL.EQ.0) GOTO 100
      CALL WRDA(NHASHL,IW(IA),IW(IA+1))
      GOTO 100
C
      ENTRY CHDIR
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      IF(LB.LT.1610) GOTO 60
      DO 44 I=1,10
      CALL RDDA(1,IW(IA),IW(IA+1))
      IF(IW(IA+8).NE.0) GOTO 42
      IF(IW(IA+9).NE.0) GOTO 42
      IW(IA+8)=LISTE(1)
      IW(IA+9)=LISTE(2)
      CALL WRDA(1,IW(IA),IW(IA+1))
      CALL RDDA(2,IW(IA),IW(IA+1))
      CALL RDDA(1,IW(IA),IW(IA+1))
      IF(IW(IA+8).NE.LISTE(1)) GOTO 42
      IF(IW(IA+9).NE.LISTE(2)) GOTO 42
      GOTO 100
   42 CALL RDDA(2,IW(IA),IW(IA+1))
   44 CONTINUE
   50 WRITE(6,103) IUND
      STOP
   60 CALL BDMPA(15)
C
C
  100 RETURN
  101 FORMAT('0---- DA-UNIT',I3,10X,'TOTAL',I6,' RECORDS, USED',
     1   I6,' RECORDS'/'0',38X,'LAST LOAD',17X,'LAST UPDATE',17X,
     2   'LAST UNLOAD'/15X,' DATE',10X,3(2A4,2X,2A4,10X)/
     3   15X,' STORED BANKS',12X,3(I8,20X)/)
  102 FORMAT('0---- DA-UNIT',I3,10X,'PROTECTED DATA SET, NO BCREDA',
     1   ' OR BDLSDA POSSIBLE'/)
  103 FORMAT('0---- DA-UNIT',I3,' IN USE, NO CHANGE POSSIBLE - STOP'/)

      END

C   01/11/84            MEMBER NAME  HITDSP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE HITDSP(IKTRAR,LISTLB,MIRROR,LBSYM,TRHIT,TLHT,JNDEX,
     *                  REMEMB,REMB1,IQQ)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON     10/10/79 :  HIT DISPLAY IN EDITING PROGRAM
C
C       MOD:   J. OLSSON     12/10/79 :  CHANGED TO NEW FORMATS FORHIT
C                                        LABEL ARRAY AND MIDOUT
C                                        HRES ARRAY NOT NEEDED ANYMORE
C  LAST MOD:   J. HAGEMANN   09/10/84 :  NEW HITMRK USED
C
C      IKTRAR      :    NUMBER OF TRACKS IN ARRAY HKTRAR   (ALWAYS NE.0)
C      LISTLB = 0  :    DISPLAY ONLY TRACKS IN LIST
C      LISTLB = 1  :    DISPLAY ONLY ANTILIST HITS
C      MIRROR = 0  :    LEFT/RIGHT AMBIGUITY RESOLVED IN DISPLAY
C      MIRROR = 1  :    LEFT/RIGHT AMBIGUITY NOT RESOLVED IN DISPLAY
C      LBSYM  = 0  :    DEFAULT SYMBOL IN DISPLAY  (DSPDTL(6))
C      LBSYM  = 1  :    NON-DEFAULT SYMBOL IN DISPLAY(.NOT.DSPDTL(6))
C      IQQ         :    PRINT VARIABLE FOR DEBUGGING
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL REMEMB,REMB1,TRHIT,TLHT,TBIT
C
#include "cgraph.for"
#include "cdata.for"
#include "cworkpr.for"
#include "cworkeq.for"
C
      COMMON /CWORK1/ R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4
     +               ,KZAMP,HWORK(400),XLTR(200),YLTR(200),XLST(100)
     +               ,YLST(100),HKTRAR(100)
C
      COMMON /CJTRIG/ PI,TWOPI
C
      DIMENSION HELP1(2),HELP2(2)
      EQUIVALENCE (LABL1,HELP1(1)),(LABL2,HELP2(1))
C
C                            MASKS FOR TRACK NO. IN HIT LABEL
      DATA MSKTR1/ZFE/, HELP1/0,0/, HELP2/0,0/
C
C-----------------  C O D E  -------------------------------------------
C
      IPJCA=IDATA(IBLN('JETC'))
      IPJ = 2*IPJCA + 2
      NHITS = (HDATA(IPJ+97)-HDATA(IPJ+1))/4
      NWO = 4*NHITS + 98
      NTRCL1 = HNTCEL(25) - 1
      NTRCL2 = HNTCEL(49) - 1
      NRHIT1 = (HDATA(IPJ+25)-HDATA(IPJ+1))/4
      NRHIT2 = (HDATA(IPJ+49)-HDATA(IPJ+1))/4
      IAMB = 0
C---
      DO 8765  II = 1,200
      XLTR(II) = 0.
8765  YLTR(II) = 0.
      DO 8565  II = 1,100
      XLST(II) = 0.
8565  YLST(II) = 0.
C---
222   NI = IPJ + 95
      IHIT = 0
      HIHIT = -1
      MICKY = 0
      IAMB = IAMB + 1
      IF(IQQ.NE.0) WRITE(6,101) IKTRAR,(HKTRAR(IKT),IKT=1,IKTRAR)
101   FORMAT(' IKTRAR AND ARRAY ',10I5)
      IF(IQQ.NE.0) WRITE(6,102) LISTLB,MIRROR,LBSYM,TRHIT,TLHT,JNDEX
102   FORMAT(' LISTLB ETC ',10I5)
824   NI = NI + 4
8566  IHIT = IHIT + 1
      HIHIT = HIHIT + 2
      IHIT1 = HIHIT
      IHIT2 = IHIT1+1
      IF(IHIT.GT.NRHIT1) MICKY = NTRCL1
      IF(IHIT.GT.NRHIT2) MICKY = NTRCL2
      IF(IHIT.GT.NHITS) GO TO 2255
      HELP1(2) = HWRK(IHIT1+HPHL0-1)
      HELP2(2) = HWRK(IHIT2+HPHL0-1)
      IF(IHIT.LT.50.AND.IQQ.NE.0) WRITE(6,103) IHIT,MICKY,HELP1(2),HELP200008500
     $(2)
103   FORMAT(' IHIT MICKY LABL1 LABL2 ',2I5,Z16,1X,Z16)
      IKFLAG = 0
      ISGN = 0
      IDL = 0
      MTR = 0
      NZWIR = 30
CHECK NOW IF HIT BELONGS TO TRACK OR NOT
8823  IF(IAMB.EQ.2) GO TO 8822
      ITREL = LAND(LABL1,MSKTR1)
      ITREL = ISHFTR(ITREL,1)
      IF(IHIT.LT.50.AND.IQQ.NE.0) WRITE(6,104) IHIT,ITREL
104   FORMAT(' IHIT ITREL ',2I5)
      IF(ITREL.NE.0) GO TO 8564
      IF(LISTLB.EQ.0) GO TO 824
      GO TO 823
8822  ITREL = LAND(LABL2,MSKTR1)
      ITREL = ISHFTR(ITREL,1)
      IF(ITREL.EQ.0) GO TO 824
8564  ITREL = ITREL + MICKY
      LABZ = LBL(ITREL)
      IF(.NOT.TBIT(LABZ,23)) GO TO 8563
      NZWIR = ICRO(ITREL)
8563  CALL TRELTR(ITREL,MTR,MTR2)
      IF(MTR.LT.0) ISGN = -1
      IF(MTR.GT.0) ISGN = 1
      IF(IHIT.LT.50.AND.IQQ.NE.0) WRITE(6,105) IHIT,ITREL,MTR,NZWIR,ISGN
105   FORMAT(' IHIT ITREL MTR NZWIR SIGN ',5I5)
      MTR = IABS(MTR)
      DO 8255  IKT = 1,IKTRAR
8255  IF(HKTRAR(IKT).EQ.MTR) IKFLAG = 1
      IF(IHIT.LT.50.AND.IQQ.NE.0) WRITE(6,105) IHIT,IKFLAG
106   FORMAT(' IHIT IKFLAG ',2I5)
      IF(IKFLAG.EQ.0.AND.LISTLB.EQ.0) GO TO 824
      IF(IKFLAG.NE.0.AND.LISTLB.EQ.1) GO TO 824
      IF(IKFLAG.EQ.0) ISGN = 0
C823   IF(IKFLAG.EQ.0.AND.ISTANV.GT.3.AND.ISTANV.LT.14) GO TO 824
C  DISPLAY
823   IVVX = 0
      IF(ISTANV.GT.3.AND.ISTANV.LT.14) IVVX = 1
      IF(IVVX.EQ.1.AND.DSPDTL(9)) DSPDTL(10) = .TRUE.
      IF(ISTANV.EQ.14) IVVX = 2
      KZAMP = 0
      CALL FICOOR(IVVX,NI,NWE)
      IF(NWE.LT.-500) GO TO 225
      IF(NWE.GE.NZWIR.AND.NZWIR.GE.0) ISGN = - ISGN
      IF(LBSYM.EQ.1) DSPDTL(6)=.NOT.REMEMB
      IF(ISTANV.LT.4.OR.ISTANV.GT.12) GO TO 7539
C *****************************
C ZX AND ZY DISPLAYS ---------*
C *****************************
      IF(DSPDTL(9)) GO TO 3425
C-- TRUE PROJECTIONS -------
      IF(ISGN.LT.0.AND.MIRROR.EQ.0) GO TO 3421
      YPRO= X1
      IF(LASTVW.GT.7) YPRO = Y1
      IF(TRHIT.AND.MTR.NE.0) CALL TRNUMB(MTR,3,-ZET,YPRO,DM)
      IF(TLHT.AND.ITREL.NE.0) CALL TRNUMB(ITREL,3,-ZET,YPRO,DM)
      IF(.NOT.TRHIT.AND..NOT.TLHT)
     $ CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
      IF(MIRROR.EQ.0) GO TO 3422
3421  YPRO = X2
      IF(LASTVW.GT.7) YPRO = Y2
      IF(TRHIT.AND.MTR.NE.0) CALL TRNUMB(MTR,3,-ZET,YPRO,DM)
      IF(TLHT.AND.ITREL.NE.0) CALL TRNUMB(ITREL,3,-ZET,YPRO,DM)
      IF(.NOT.TRHIT.AND..NOT.TLHT)
     $ CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
3422  IF(MTR.EQ.0.OR.IKFLAG.EQ.0) GO TO 805
3427  XLST(MTR) = - ZET
      YLST(MTR) = YPRO
      GO TO 805
C-- WRAPPED PROJECTIONS ---------
3425  IF(ISGN.LT.0.AND.MIRROR.EQ.0) GO TO 3426
      YPRO = R1
      IF(TRHIT.AND.MTR.NE.0) CALL TRNUMB(MTR,3,-ZET,YPRO,DM)
      IF(TLHT.AND.ITREL.NE.0) CALL TRNUMB(ITREL,3,-ZET,YPRO,DM)
      IF(.NOT.TRHIT.AND..NOT.TLHT)
     $ CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
      IF(MTR.EQ.0) GO TO 3426
      IF(MIRROR.EQ.0) GO TO 3422
3426  YPRO = R2
      IF(TRHIT.AND.MTR.NE.0) CALL TRNUMB(MTR,3,-ZET,YPRO,DM)
      IF(TLHT.AND.ITREL.NE.0) CALL TRNUMB(ITREL,3,-ZET,YPRO,DM)
      IF(.NOT.TRHIT.AND..NOT.TLHT)
     $ CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
      GO TO 3422
C *****************************
C        RFI DISPLAYS  -------*
C *****************************
7539  IF(MTR.EQ.0.OR.IKFLAG.EQ.0) GO TO 1001
      IF(ISGN.LT.0.AND.MIRROR.EQ.0) GO TO 804
      IF(IKFLAG.EQ.0) GO TO 1001
      XLST(MTR) = X1
      YLST(MTR) = Y1
      XLTR(ITREL) = X1
      YLTR(ITREL) = Y1
      IF(TRHIT) CALL TRNUMB(MTR,3,X1,Y1,DM)
      IF(TLHT) CALL TRNUMB(ITREL,3,X1,Y1,DM)
1001  IF(.NOT.TRHIT.AND..NOT.TLHT)
     $ CALL HITMRK( ISTANV, -X1, Y1, 4.0, 0 )
      IF(ISGN.GT.0.AND.MIRROR.EQ.0) GO TO 805
804   IF(MTR.EQ.0.OR.IKFLAG.EQ.0) GO TO 1011
      XLST(MTR) = X2
      YLST(MTR) = Y2
      XLTR(ITREL) = X2
      YLTR(ITREL) = Y2
      IF(TRHIT) CALL TRNUMB(MTR,3,X2,Y2,DM)
      IF(TLHT) CALL TRNUMB(ITREL,3,X2,Y2,DM)
1011  IF(.NOT.TRHIT.AND..NOT.TLHT)
     $ CALL HITMRK( ISTANV, -X2, Y2, 4.0, 0 )
  805 DSPDTL(6) = REMEMB
      DSPDTL(10) = REMB1
      IF(NI.LE.(IPJ+NWO)) GO TO 8566
C-- WRITE TRACK NUMBER AT POSITION OF LAST HIT
2255  IF(LISTLB.EQ.1) GO TO 225
      IF(IAMB.EQ.1) GO TO 222
      IF(TRHIT) GO TO 8056
      DO 2344  II = 1,NTR
      IF(ABS(XLST(II)).LT..1.AND.ABS(YLST(II)).LT..1) GO TO 2344
      CALL TRNUMB(II,0,XLST(II),YLST(II),DM)
2344  CONTINUE
C** WRITE OUT TRACK ELEMENT NUMBERS ON SCREEN
8056  IF(TLHT) GO TO 225
      DO 5876  II = 1,HNTR
      IF(ABS(XLTR(II)).LT..1.AND.ABS(YLTR(II)).LT..1) GO TO 5876
      CALL TRNUMB(II,1,XLTR(II),YLTR(II),DM)
5876  CONTINUE
225   RETURN
      END

C   31/03/80 004142105  MEMBER NAME  RESHUF   (JADESR)      FORTRAN
      SUBROUTINE RESHUF
      IMPLICIT INTEGER*2 (H)
C---
C---     MOVES N50S BANK AROUND FROM END OF FIRST PIECE OF OVERFLOW
C---     EVENT TO END OF LAST PIECE.
C---                                   L.H. O'NEILL 31.03.80
C---
      COMMON/CWORK/NWORK,IWORK(10000)
      DIMENSION HWORK(20000)
      EQUIVALENCE(IWORK(1),HWORK(1))
      DIMENSION IN50(200)
      DATA N50N/'N50S'/
      DATA LN50/0/
C---
         DATA ICALL/0/
         ICALL=ICALL+1
C        WRITE(6,5000) ICALL,HWORK(18),HWORK(19),HWORK(23)
 5000    FORMAT(1H0,' RESHUF, ICALL, ETC. = ',4I6)
      IOVERF=HWORK(23)
      IF(IOVERF.EQ.16) GO TO 10
      IF(LN50.NE.0) RETURN
      LPNT=4
    1 CONTINUE
      NBN=IWORK(LPNT-3)
      LENGB=IWORK(LPNT)
      IF(LENGB.LT.1) RETURN
C        WRITE(6,5001) NBN,LPNT,LENGB,NWORK
 5001    FORMAT(1X,A4,3I6)
      IF(NBN.EQ.N50N) GO TO 2
      LPNT=LPNT+LENGB+4
      IF(LPNT.LT.NWORK) GO TO 1
      RETURN
    2 CONTINUE
      IF((LPNT+LENGB).NE.NWORK) RETURN
      LN50=4*(LENGB+4)
C        WRITE(6,5002) LN50
 5002    FORMAT(1X,' LOAD IN50. LN50 = ',I6)
      CALL MVCL(IN50(1),0,IWORK(LPNT-3),0,LN50)
      NWORK=NWORK-LENGB-4
      RETURN
   10 CONTINUE
      IF(LN50.LE.16) LN50=0
      IF(LN50.EQ.0) RETURN
C        WRITE(6,5003) LN50
 5003    FORMAT(1X,' LOAD IWORK. LN50 = ',I6)
      CALL MVCL(IWORK(NWORK+1),0,IN50(1),0,LN50)
      NWORK=NWORK+LN50/4
      LN50=0
      RETURN
      END

CDECK  ID>, MCJT74.
      PROGRAM MCJT74
      IMPLICIT NONE
*.********************************************************************
*.
*. Standalone example for Jetset74.
*. This example writes 4-vectors to disk for Gopal interface
*. via a card file, using the Opal production criteria for Jetset.
*.
*. AUTHOR    :  J.W.Gary
*. CREATED   :  23-Jun-91
*. LAST MOD  :  23-Jun-91
*. Modified for JETSET 74 8.2.95 Stefan Kluth
*. 03.07.96, STK: Very heavily modified for use with MC4VEC package
*. 20.09.96, STK: Mods for version 101
*. 27.07.00, PMF: Add initialisation of Peterson FF 
*. 28.05.01, PMF: Add initialization of Lund FF parameter a
*.                + Lambda_QCD for parton showers
*.
*.********************************************************************
      INTEGER  NLUPDM,NPLBUF
      PARAMETER  (NLUPDM=4000,NPLBUF=5)
      COMMON/GUJETS/N,K(NLUPDM,5),P(NLUPDM,NPLBUF),V(NLUPDM,5)
      INTEGER  N,K
      REAL  P,V
      SAVE /GUJETS/
      COMMON/GUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER  MSTU,MSTJ
      REAL  PARU,PARJ
      SAVE /GUDAT1/
      COMMON/GUDAT3/MDCY(500,3),MDME(2000,2),BRAT(2000),KFDP(2000,5)
      INTEGER  MDCY,MDME,KFDP
      REAL  BRAT
      SAVE /GUDAT3/
      COMMON/GUDAT4/CHAF(500)
      CHARACTER CHAF*8
      SAVE /GUDAT4/
      COMMON/GUDATR/MRLU(6),RRLU(100)
      INTEGER  MRLU
      REAL  RRLU
      SAVE /GUDATR/
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
      INTEGER IEVT,IFLAV,IERR
      CHARACTER*8 CH8
C
      EXTERNAL LUDATA
C
C  Error trapping sequences:
C
C  Read FFREAD cards:
      CALL MCINIT
C
C  User initialisation:
      CALL MCUSIN
      CHMCTYP= 'JETSET'
C
C  Check array dimensions for LUJETS:
      IF( NLUPDM.GT.MSTU(5) ) THEN
        WRITE (6,FMT='('' L74LON: Warning, NLUPDM='',I6,
     &     '' larger than MSTU(5)='',I6)') NLUPDM,MSTU (5)
        MSTU(5)= NLUPDM
      ENDIF
      MSTU(4)= NLUPDM
C
C  Update JETSET parameters, switches and decay table from OPAL default:
      PRINT*,' '
      PRINT*,'OPAL JETSET 7.4 default:'
      PRINT*,' '
      CALL JT74OP
      PRINT*,' '
      PRINT*,'Changes from OPAL JETSET 7.4 default:'
      PRINT*,' '
      WRITE(CH8,FMT='(F8.5)') JTB
      CALL LUGIVE('PARJ(42)='//CH8)
      WRITE(CH8,FMT='(F8.5)') JTSQ
      CALL LUGIVE('PARJ(21)='//CH8)
      WRITE(CH8,FMT='(F8.5)') JTQ0
      CALL LUGIVE('PARJ(82)='//CH8)

      WRITE(CH8,FMT='(F8.5)') JTEC
      CALL LUGIVE('PARJ(54)='//CH8)
      WRITE(CH8,FMT='(F8.5)') JTEB
      CALL LUGIVE('PARJ(55)='//CH8)

      WRITE(CH8,FMT='(F8.5)') JTA
      CALL LUGIVE('PARJ(41)='//CH8)
      WRITE(CH8,FMT='(F8.5)') JTLAMB
      CALL LUGIVE('PARJ(81)='//CH8)

      PRINT*,' '
C
C  Print JETSET welcome message:
      MSTU(12)= 1
C
C  Initial and final-state photon radiation, 107=0 no isr; 1 for isr,
C  41=2 for FSR on:
      PRINT*,'Switches for ISR and FSR:'
      IF( LISR ) THEN
        CALL LUGIVE('MSTJ(107)=1')
      ELSE
        CALL LUGIVE('MSTJ(107)=0')
      ENDIF
      IF( LFSR ) THEN
        CALL LUGIVE('MSTJ(41)=2')
      ELSE
        CALL LUGIVE('MSTJ(41)=1')
      ENDIF
C
C  Set long-lived hadrons stable if desired:
      PRINT*,' '
      IF( LSTBL ) CALL MCSTBL
C
C  Random numbers and 4-vector writing:
      IF( IMCRDM.GT.0 ) MRLU(1)= IMCRDM
      IF( L4VEC ) CALL MCWRIT('I',IERR)
C
C  Other initialization:
      IFLAV= 0
C
C  Event loop:
      PRINT*,' '
      PRINT*,'Start JETSET event generation now, NEVNT=',NEVNT
      DO IEVT=1,NEVNT
C
C       Generate 1 event:
   10   CALL LUEEVT(IFLAV,ECMASS)
C
C       Check for errors (mainly L=1 meson decays):
        IF( MSTU(24).EQ.4 .OR. MSTU(24).EQ.5 ) THEN
          PRINT*,'MCJT74: JETSET error: ',MSTU(24),' regenerate'
          GOTO 10
        ENDIF
C
C       Write 4-vectors if demanded:
        IF( L4VEC ) CALL MCWRIT('W',IERR)
C
C       User event analysis:
        CALL MCUSEV

      ENDDO
C
C  Now call MCUSFI to to finish things off:
      CALL MCUSFI
      IF( L4VEC ) CALL MCWRIT('F',IERR)
C
C  The End:
      STOP
      END
CDECK  ID>, MCEVBL.
      BLOCK DATA MCEVBL
C
C PMF 12/05/00: Introduce this BLOCK DATA subroutine to
C               initialize COMMON /MCEVSH/
C     25/07/00  Initialize with JADE-like binning
C     Stuff for event shape analysis:
C     nbmax: number of bins for the histograms
C     ndimm: dimension of the XBINS array
C
      INTEGER NVAR,NBMAX,NDIMM
      PARAMETER( NBMAX=100, NDIMM=50, NVAR=6 )
      INTEGER NBMAX2
      PARAMETER( NBMAX2=1000 )  ! PMF: needed for finer binning of LINEAR y23 (D) distribution
C EEC special stuff
      INTEGER NBEEC
      REAL PIEEC
      PARAMETER( NBEEC=100, PIEEC=3.1415927 )
      REAL EEC(NBEEC),EECER(NBEEC),EECA(NBEEC/2),EECAER(NBEEC/2)
C
      INTEGER NBIN(NVAR)
      REAL XBINS(NDIMM,NVAR)
      REAL TH,MH,BT,BW,CP,Y23
      REAL TMA, TMI, OBL, SP, AC
      CHARACTER*2 CHVAR(NVAR)
      COMMON /MCEVSH/ NBIN
     &               ,TH,MH,BT,BW,CP,Y23,XBINS
     &               ,CHVAR
      SAVE /MCEVSH/
**      DATA NBIN / 15, 14, 15, 14, 12, 13 / ! 14 GeV
      DATA NBIN / 15, 14, 15, 14, 14, 14 /
      DATA XBINS/
     >     0.00, 0.02, 0.04, 0.06, 0.08, 0.10, 0.12, 0.14, 0.16, 0.18,
     >     0.20, 0.23, 0.27, 0.32, 0.40, 0.50,         34*0.0, ! 1-T 
     >     0.00, 0.06, 0.10, 0.14, 0.18, 0.22, 0.26, 0.30, 0.34, 0.38,
     >     0.42, 0.46, 0.50, 0.55, 0.60,                     35*0.0, ! MH
     >     0.00, 0.03, 0.06, 0.08, 0.10, 0.12, 0.14, 0.16, 0.18, 0.20,
     >     0.22, 0.24, 0.27, 0.30, 0.34, 0.38,               34*0.0, ! BT
     >     0.00, 0.02, 0.04, 0.06, 0.08, 0.10, 0.12, 0.14, 0.16, 0.18,
     >     0.20, 0.23, 0.26, 0.30, 0.35,                     35*0.0, ! BW
**     >     0.00, 0.16, 0.28, 0.34, 0.40,
**     >     0.46, 0.52, 0.58, 0.64, 0.72, 0.80, 0.88, 1.00,    37*0.0, ! CP 14 GeV
     >     0.00, 0.10, 0.16, 0.22, 0.28, 0.34, 0.40,
     >     0.46, 0.52, 0.58, 0.64, 0.72, 0.80, 0.88, 1.00,    35*0.0, ! CP
**     >     0.00, .002, .004, .006, 0.01, 0.014, 0.02, 0.03, 0.04,
**     >     0.06, 0.10, 0.14, 0.2, 0.3,          36*0.0 /    ! D2 14 GeV
     >     0.00, .001, .002, .004, .006, 0.01, 0.014, 0.02, 0.03, 0.04,
     >     0.06, 0.10, 0.14, 0.2, 0.3,          35*0.0 /    ! D2
      DATA CHVAR / 'TH', 'MH', 'BT', 'BW', 'CP', 'D2' /
      END
CDECK  ID>, MCPOBL.
      BLOCK DATA MCPOBL
C
C PMF 12/05/00: Introduce this BLOCK DATA subroutine to
C               initialize COMMON /NPOWER/
      INTEGER NPOW
      PARAMETER (NPOW=12)
      CHARACTER*3 CHSHAP(NPOW)
      DOUBLE PRECISION DSHAP1(NPOW),DSHAP2(NPOW),DSHAP3(NPOW)
      INTEGER  NSHAP
C PMF 12.05.00: Change order of variables in order to avoid misalignement
C      COMMON / NPOWER / CHSHAP,DSHAP1,DSHAP2,DSHAP3,NSHAP
      COMMON / NPOWER / DSHAP1,DSHAP2,DSHAP3,NSHAP,CHSHAP
C
C..   KEEP RUNNING SUM OF THE EVENT-SHAPES Y, FOR Y, Y**2, Y**3
C..   WHERE Y IS DEFINED IN MCUSIN DATA STATEMENT
C
      DATA CHSHAP /'TH ','TMA','MH ','TMI','BT ','OBL'
     +     ,'BW ','SP ','CP ','AC ','Y23','1TH' /
      END
CDECK  ID>, MCUSFF.
      SUBROUTINE MCUSFF
      IMPLICIT NONE
C  Routine for user FFREAD cards:
C  Stefan Kluth, 16.07.96
C  Modifications:
C  17.07.96, STK: Replace VZERO by VBLANK for hollerith array
C  18.09.96, STK: Introduce switch for ISR removal, change default for FSRRM
C  13.02.97, SB : Introduce the 'JETRATE' card, calculation jet rates with cone
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
C  FFREAD user variables:
      LOGICAL LFSRRM,LISRRM,LBOOS,LCONE,LDURH,LJDE0,LCAMJ,LCKRN
      INTEGER HOUTFILE(NWONAM)
      INTEGER NJTEV
      COMMON /MCUFFR/ LFSRRM,LISRRM,LBOOS, LCONE,LDURH,LJDE0,LCAMJ
     &                ,LCKRN,NJTEV,HOUTFILE
      SAVE /MCUFFR/
      LFSRRM= .FALSE.
      CALL FFKEY('FSRRM',LFSRRM,1,'LOGI')
      LISRRM= .FALSE.
      CALL FFKEY('ISRRM',LISRRM,1,'LOGI')
      LBOOS= .FALSE.
      CALL FFKEY('MCBOOS',LBOOS,1,'LOGI') ! PMF 13/05/00: BOOST->MCBOOS
      LCONE= .FALSE.
      CALL FFKEY('MCCONE',LCONE,1,'LOGI')
      LDURH= .FALSE.
      CALL FFKEY('MCDURH',LDURH,1,'LOGI')
      LJDE0= .FALSE.
      CALL FFKEY('MCJDE0',LJDE0,1,'LOGI')
      NJTEV= -1
      CALL FFKEY('MCJTEV',NJTEV,1,'INTEGER')
      LCAMJ = .FALSE.
      CALL FFKEY('MCCAMJ',LCAMJ,1,'LOGI')
      LCKRN = .FALSE.
      CALL FFKEY('MCCKRN',LCKRN,1,'LOGI')
      CALL VBLANK(HOUTFILE,NWONAM)
      CALL FFKEY('OUTFILE',HOUTFILE,NWONAM,'MIXED')
C
      JADETUN=0
      CALL FFKEY('JADETUNE',JADETUN,1,'INTE')
C
C  The End:
      RETURN
      END
CDECK  ID>, MCUSIN.
      SUBROUTINE MCUSIN
      IMPLICIT NONE
C  Routine for user initialisation:
C  Stefan Kluth, 22.1.96
C  Modifications:
C  19.09.96, STK: Put bin edges into DATA statements
C  13.02.97, SB : Put in jetrates histograms
C  13.02.97, SB : Extend the jet-resolution to 10^-6
C  26.05.00. PMF: - Add energy-energy correlation
C                   in theta and cos(theta) bins
C                 - Add pTin, pTout, xp, yp, xi 
C                   for charged and neutral particles
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
C  FFREAD user variables:
      LOGICAL LFSRRM,LISRRM,LBOOS,LCONE,LDURH,LJDE0,LCAMJ,LCKRN
      INTEGER HOUTFILE(NWONAM)
      INTEGER NJTEV
      COMMON /MCUFFR/ LFSRRM,LISRRM,LBOOS, LCONE,LDURH,LJDE0,LCAMJ
     &                ,LCKRN,NJTEV,HOUTFILE
      SAVE /MCUFFR/
C  Stuff for HBOOK:
      INTEGER LIMIT
      PARAMETER( LIMIT=200000 )
      REAL HMEM
      COMMON /PAWC/ HMEM(LIMIT)
      SAVE /PAWC/
C     Stuff for event shape analysis:
C     nbmax: number of bins for the histograms
C     ndimm: dimension of the XBINS array
C
      INTEGER NVAR,NBMAX,NDIMM
      PARAMETER( NBMAX=100, NDIMM=50, NVAR=6 )
      INTEGER NBMAX2
      PARAMETER( NBMAX2=1000 )  ! PMF: needed for finer binning of LINEAR y23 (D) distribution
C EEC special stuff
      INTEGER NBEEC
      REAL PIEEC
      PARAMETER( NBEEC=100, PIEEC=3.1415927 )
      REAL EEC(NBEEC),EECER(NBEEC),EECA(NBEEC/2),EECAER(NBEEC/2)
C
      INTEGER NBIN(NVAR)
      REAL XBINS(NDIMM,NVAR)
      REAL TH,MH,BT,BW,CP,Y23
      REAL TMA, TMI, OBL, SP, AC
      CHARACTER*2 CHVAR(NVAR)
      COMMON /MCEVSH/ NBIN
     &               ,TH,MH,BT,BW,CP,Y23,XBINS
     &               ,CHVAR
      SAVE /MCEVSH/
      INTEGER NPOW
      PARAMETER (NPOW=12)
      CHARACTER*3 CHSHAP(NPOW)
      DOUBLE PRECISION DSHAP1(NPOW),DSHAP2(NPOW),DSHAP3(NPOW)
      INTEGER  NSHAP
C PMF 12.05.00: Change order of variables in order to avoid misalignement
C      COMMON / NPOWER / CHSHAP,DSHAP1,DSHAP2,DSHAP3,NSHAP
      COMMON / NPOWER / DSHAP1,DSHAP2,DSHAP3,NSHAP,CHSHAP
C
C..   KEEP RUNNING SUM OF THE EVENT-SHAPES Y, FOR Y, Y**2, Y**3
C..   WHERE Y IS DEFINED IN MCUSIN DATA STATEMENT
C
      INTEGER I,IVAR,NBE,IOFF,NBMM
      REAL XLO,XHI,XD2(NBMAX+1)
      CHARACTER*6 CNA(7)
      CHARACTER*14 PH(2)
C
C PMF 12/05/00: Initialization of /MCEVSH/ is now done
C               in the BLOCK DATA subroutine 'MCEVBL'
C      DATA NBIN / 13, 12, 14, 13, 12, 15 /
C      DATA XBINS / 0.00, 0.01, 0.02, 0.03, 0.04, 0.05, 0.07, 0.09, 0.12
C     &            ,0.15, 0.22, 0.30, 0.40, 0.50, 36*0.0
C     &            ,0.00, 0.06 ,0.075,0.09, 0.11, 0.14, 0.17, 0.20, 0.25
C     &            ,0.30, 0.35, 0.45, 0.60, 37*0.0
C     &            ,0.00, 0.03, 0.04, 0.05, 0.06, 0.075,0.09, 0.11, 0.13
C     &            ,0.16, 0.20, 0.25, 0.30, 0.35, 0.40, 35*0.0
C     &            ,0.00, 0.02, 0.03, 0.04, 0.05, 0.065,0.08, 0.10, 0.15
C     &            ,0.20, 0.25, 0.30, 0.35, 0.40, 36*0.0
C     &            ,0.00, 0.05, 0.08, 0.11, 0.14, 0.18, 0.22, 0.30, 0.4
C     &            ,0.50, 0.60, 0.75, 1.00, 37*0.0
C     &            ,0.00, 0.3E-03, 0.75E-03, 0.13E-02, 0.23E-02, 0.4E-02
C     &            ,0.7E-02, 0.012, 0.0225, 0.04, 0.07, 0.13, 0.235
C     &  ,0.40, 0.70, 1.00, 34*0.0 /
C
C      DATA CHVAR / 'TH', 'MH', 'BT', 'BW', 'CP', 'D2' /
C

      DATA CNA /' d',' u',' s',' c',' b','  ','(cum.)'/
      SAVE CNA

C PMF 12/05/00: Initialization of CHSHAP is now done 
C               in the BLOCK DATA subroutine 'MCPOBL'
C      DATA CHSHAP /'TH ','TMA','MH ','TMI','BT ','OBL'
C     +     ,'BW ','SP ','CP ','AC ','Y23','1TH' /

      NSHAP = 0
      DO I=1,NPOW
         DSHAP1(I) = 0D0
         DSHAP2(I) = 0D0
         DSHAP3(I) = 0D0
      ENDDO
C
C  Logarithmic bins for D2 distribution:
      XD2(1)= 0.0
      XD2(2)= LOG10(1.0E-6)
      XD2(NBMAX+1)= LOG10(1.0)
      DO I=1,NBMAX-1
        XD2(I+2)= XD2(2)+(XD2(NBMAX+1)-XD2(2))/REAL(NBMAX-1)*REAL(I)
      ENDDO
      DO I=2,NBMAX+1
        XD2(I)= 10.0**XD2(I)
      ENDDO
C
C  Initialise HBOOK and book histos:
      CALL HLIMIT(LIMIT)
      CALL HCDIR('//PAWC',' ')
      CALL HSTAF('YES')
      CALL HBOOK1(10,'Evis partons incl. FSR',195,5.,200.,0.)
      CALL HBOOK1(11,'Evis partons excl. FSR',195,5.,200.,0.)
      CALL HBOOK1(12,'Evis hadrons',195,5.,200.,0.)
      CALL HBOOK1(13,'Flavour',10,-0.5,9.5,0.)
      CALL HBOOK1(21,'log10(p) photons',100,-3.,2.,0.)
      CALL HBOOK1(22,'log10(p) neutrinos',100,-3.,2.,0.)
      CALL HBOOK1(23,'log10(p) electrons',100,-3.,2.,0.)
      CALL HBOOK1(24,'log10(p) muons',100,-3.,2.,0.)
      CALL HBOOK1(25,'log10(p) pi+-',100,-3.,2.,0.)
      CALL HBOOK1(26,'log10(p) pi0',100,-3.,2.,0.)
      CALL HBOOK1(27,'log10(p) K+-',100,-3.,2.,0.)
      CALL HBOOK1(28,'log10(p) K0L (130)',100,-3.,2.,0.)
      CALL HBOOK1(29,'log10(p) protons',100,-3.,2.,0.)
      CALL HBOOK1(30,'log10(p) neutrons',100,-3.,2.,0.)
      CALL HBOOK1(31,'log10(p) tau+-  ',100,-3.,2.,0.)
      CALL HBOOK1(32,'log10(p) K0S (310)',100,-3.,2.,0.)
      CALL HBOOK1(33,'log10(p) K0 (311)',100,-3.,2.,0.)
      CALL HBOOK1(34,'log10(p) Hyperon',100,-3.,2.,0.)
      CALL HBOOK1(35,'log10(p) Unknown',100,-3.,2.,0.)
      CALL HBOOK1(36,'KC particle codes',501,-0.5,500.5,0.0)
      CALL HBOOK1(37,'c*tau of stable hadrons',100,0.0,20.0,0.0)

      CALL HBOOK1(50,'PTin  partons (charged)',100,0.0,10.0,0.0)
      CALL HBOOK1(60,'PTin  hadrons (charged)',100,0.0,10.0,0.0)
      CALL HBOOK1(51,'PTout partons (charged)',100,0.0,5.0,0.0)
      CALL HBOOK1(61,'PTout hadrons (charged)',100,0.0,5.0,0.0)
      CALL HBOOK1(52,'xp    partons (charged)',100,0.0,1.0,0.0)
      CALL HBOOK1(62,'xp    hadrons (charged)',100,0.0,1.0,0.0)
      CALL HBOOK1(53,'yp    partons (charged)',100,0.0,8.0,0.0)
      CALL HBOOK1(63,'yp    hadrons (charged)',100,0.0,8.0,0.0)
      CALL HBOOK1(54,'xi    partons (charged)',100,0.0,10.0,0.0)
      CALL HBOOK1(64,'xi    hadrons (charged)',100,0.0,10.0,0.0)

      CALL HBOOK1(55,'PTin  partons (all)',100,0.0,10.0,0.0)
      CALL HBOOK1(65,'PTin  hadrons (all)',100,0.0,10.0,0.0)
      CALL HBOOK1(56,'PTout partons (all)',100,0.0,5.0,0.0)
      CALL HBOOK1(66,'PTout hadrons (all)',100,0.0,5.0,0.0)
      CALL HBOOK1(57,'xp    partons (all)',100,0.0,1.0,0.0)
      CALL HBOOK1(67,'xp    hadrons (all)',100,0.0,1.0,0.0)
      CALL HBOOK1(58,'yp    partons (all)',100,0.0,8.0,0.0)
      CALL HBOOK1(68,'yp    hadrons (all)',100,0.0,8.0,0.0)
      CALL HBOOK1(59,'xi    partons (all)',100,0.0,10.0,0.0)
      CALL HBOOK1(69,'xi    hadrons (all)',100,0.0,10.0,0.0)
      DO I=1,6
        CALL HBOOK1(100+I,'N partons'//CNA(I),41,-0.5,40.5,0.)
        CALL HBOOK1(200+I,'N hadrons'//CNA(I),151,-0.5,150.5,0.)
        CALL HBOOK1(210+I,'N ch. hadrons'//CNA(I),101,-0.5,100.5,0.)
      ENDDO
      CALL HBOOK1(218,'N CH HADRONS',50,1.0,101.,0.)

*     
*     book nbmax bins
*
      Do I=1,7
C Energy-energy correlation in theta bins
        CALL HBOOK1(I+220,'EEC (theta bins) parton level'//CNA(I)
     +       ,NBEEC,0.,PIEEC,0.)
        CALL HBOOK1(I+230,'EEC (theta bins) hadron level'//CNA(I)
     +       ,NBEEC,0.,PIEEC,0.)
        CALL HBOOK1(I+240,'AEEC (theta bins) parton level'//CNA(I)
     +       ,NBEEC/2,0.,PIEEC/2.,0.)
        CALL HBOOK1(I+250,'AEEC (theta bins) hadron level'//CNA(I)
     +       ,NBEEC/2,0.,PIEEC/2.,0.)
C Energy-energy correlation in cos(theta) bins
        CALL HBOOK1(I+260,'EEC (cos(theta) bins) parton level'//CNA(I)
     +       ,NBEEC,-1.0,1.0,0.)
        CALL HBOOK1(I+270,'EEC (cos(theta) bins) hadron level'//CNA(I)
     +       ,NBEEC,-1.0,1.0,0.)
        CALL HBOOK1(I+280,'AEEC (cos(theta) bins) parton level'//CNA(I)
     +       ,NBEEC/2,-1.,.0,0.)
        CALL HBOOK1(I+290,'AEEC (cos(theta) bins) hadron level'//CNA(I)
     +       ,NBEEC/2,-1.,.0,0.)
C
C                                                                   PMF: - some histogram ranges changed!
C                                                                        - NBMAX2 bins for linear y23 (D)
C                                                                           id = 900 ..
        CALL HBOOK1(I+300,'1-T parton level'//CNA(I),NBMAX,0.0,0.5,0.) ! 1-T:
        CALL HBOOK1(I+310,'1-T hadron level'//CNA(I),NBMAX,0.0,0.5,0.)
        CALL HBOOK1(I+320,'cosT parton level'//CNA(I),NBMAX,0.0,1.0,0.) ! PMF 01/11/00: added
        CALL HBOOK1(I+330,'cosT hadron level'//CNA(I),NBMAX,0.0,1.0,0.) ! PMF 01/11/00: added
        CALL HBOOK1(I+350,'TMA parton level'//CNA(I),NBMAX,0.0,1.0,0.) ! TMA: 0.0 ... 0.6
        CALL HBOOK1(I+360,'TMA hadron level'//CNA(I),NBMAX,0.0,1.0,0.) !      0.0 ... 0.6
        CALL HBOOK1(I+400,'MH  parton level'//CNA(I),NBMAX,0.0,1.0,0.) ! MHT: 0.0 ... 0.6
        CALL HBOOK1(I+410,'MH  hadron level'//CNA(I),NBMAX,0.0,1.0,0.) !      0.0 ... 0.6
        CALL HBOOK1(I+420,'MH2 parton level'//CNA(I),NBMAX,0.0,1.0,0.) ! PMF 10/03/01: added
        CALL HBOOK1(I+430,'MH2 hadron level'//CNA(I),NBMAX,0.0,1.0,0.)
        CALL HBOOK1(I+450,'TMI parton level'//CNA(I),NBMAX,0.0,1.0,0.)
        CALL HBOOK1(I+460,'TMI hadron level'//CNA(I),NBMAX,0.0,1.0,0.)
        CALL HBOOK1(I+500,'BT  parton level'//CNA(I),NBMAX,0.0,0.5,0.) ! BT: 0.0 ... 0.4
        CALL HBOOK1(I+510,'BT  hadron level'//CNA(I),NBMAX,0.0,0.5,0.) !     0.0 ... 0.4
        CALL HBOOK1(I+550,'OBL parton level'//CNA(I),NBMAX,0.0,1.0,0.)
        CALL HBOOK1(I+560,'OBL hadron level'//CNA(I),NBMAX,0.0,1.0,0.)
        CALL HBOOK1(I+600,'BW  parton level'//CNA(I),NBMAX,0.0,0.5,0.) ! BW: 0.0 ... 0.4
        CALL HBOOK1(I+610,'BW  hadron level'//CNA(I),NBMAX,0.0,0.5,0.) !     0.0 ... 0.4
        CALL HBOOK1(I+650,'SP  parton level'//CNA(I),NBMAX,0.0,1.0,0.)
        CALL HBOOK1(I+660,'SP  hadron level'//CNA(I),NBMAX,0.0,1.0,0.)
        CALL HBOOK1(I+700,'CP  parton level'//CNA(I),NBMAX,0.0,1.0,0.) ! CP: 
        CALL HBOOK1(I+710,'CP  hadron level'//CNA(I),NBMAX,0.0,1.0,0.) !
        CALL HBOOK1(I+750,'AC  parton level'//CNA(I),NBMAX,0.0,0.5,0.) ! AC: 0.0 ... 0.3
        CALL HBOOK1(I+760,'AC  hadron level'//CNA(I),NBMAX,0.0,0.5,0.) !     0.0 ... 0.3
        CALL HBOOK1(I+850,'T   parton level'//CNA(I),NBMAX,0.5,1.0,0.)
        CALL HBOOK1(I+860,'T   hadron level'//CNA(I),NBMAX,0.5,1.0,0.)
        CALL HBOOK1(I+900,'y23 (D) parton level'//CNA(I),NBMAX2,0.0,    ! D2:(lin.) ! PMF: NBMAX->NBMAX2
     +    1.0,0.)
        CALL HBOOK1(I+910,'y23 (D) hadron level'//CNA(I),NBMAX2,0.0,    ! ! PMF: NBMAX->NBMAX2
     +    1.0,0.)
        CALL HBOOK1(I+920,'mean jet rate (D) parton level'//CNA(I),     
     +       NBMAX2,0.0,1.0,0.) ! PMF: NBMAX->NBMAX2
        CALL HBOOK1(I+930,'mean jet rate (D) hadron level'//CNA(I),
     +       NBMAX2,0.0, 1.0,0.)! PMF: NBMAX->NBMAX2
        CALL HBOOKB(I+800,'y23 (D) parton level'//CNA(I),NBMAX,XD2,0.0)  ! D2:(log.)
        CALL HBOOKB(I+820,'mean jet rate (D) parton level'//CNA(I),
     +       NBMAX,XD2,0.0)
        CALL HIDOPT(I+800,'STAT')
        CALL HIDOPT(I+820,'STAT')
        CALL HBOOKB(I+810,'y23 (D) hadron level'//CNA(I),NBMAX,XD2,0.0) ! D2:(log.)
        CALL HBOOKB(I+830,'mean jet rate (D) hadron level'//CNA(I),
     +       NBMAX,XD2,0.0)
        CALL HIDOPT(I+810,'STAT')
        CALL HIDOPT(I+830,'STAT')
      ENDDO
      DO IVAR=1,NVAR
        CALL HBOOKB(1000+(IVAR-1)*10+1,CHVAR(IVAR)//' parton level'
     &             ,NBIN(IVAR),XBINS(1,IVAR),0.0)
        CALL HIDOPT(1000+(IVAR-1)*10+1,'STAT')
        CALL HBOOKB(1000+(IVAR-1)*10+2,CHVAR(IVAR)//' hadron level'
     &             ,NBIN(IVAR),XBINS(1,IVAR),0.0)
        CALL HIDOPT(1000+(IVAR-1)*10+2,'STAT')
        DO I=1,6                ! PMF 01/11/00: Introduce flavour dependent hadr. matrices
        CALL HBOOK2(1100+(IVAR-1)*10+I
     &             ,CHVAR(IVAR)//' hadronisation matrix'//CNA(I)
     &             ,NBIN(IVAR),0.5,REAL(NBIN(IVAR))+0.5
     &             ,NBIN(IVAR),0.5,REAL(NBIN(IVAR))+0.5,0.)
        ENDDO
      ENDDO
C
C..   JETRATES HISTOGRAMS
C
      PH(1) =' PARTON LEVEL'
      PH(2) =' HADRON LEVEL'
      DO IOFF=0,1
         IF(LJDE0) THEN
C
C     E0 FINDING, LINEAR SCALE
C 
          CALL HBOOK1(1201+10*IOFF,'R1 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
          CALL HBOOK1(1202+10*IOFF,'R2 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
          CALL HBOOK1(1203+10*IOFF,'R3 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
          CALL HBOOK1(1204+10*IOFF,'R4 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
          CALL HBOOK1(1205+10*IOFF,'R5 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
          CALL HBOOK1(1206+10*IOFF,'R6 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
          CALL HBOOK1(1208+10*IOFF,'MN E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)

         CALL HBOOK1(1221+10*IOFF,'Y12 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
         CALL HBOOK1(1222+10*IOFF,'Y23 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
         CALL HBOOK1(1223+10*IOFF,'Y34 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
         CALL HBOOK1(1224+10*IOFF,'Y45 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
         CALL HBOOK1(1225+10*IOFF,'Y56 E0'//PH(IOFF+1),NBMAX,0.,0.15,0.)
         ENDIF
         IF(LDURH) THEN
C
C     DURHAM FINDING, LOG SCALE
C 
           NBMM = 48
           CALL HBOOK1(1301+10*IOFF,'R1 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1302+10*IOFF,'R2 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1303+10*IOFF,'R3 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1304+10*IOFF,'R4 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1305+10*IOFF,'R5 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1306+10*IOFF,'R6 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1308+10*IOFF,'MN KT'//PH(IOFF+1),NBMM,-6.,0.,0.)

           CALL HBOOK1(1321+10*IOFF,'Y12 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1322+10*IOFF,'Y23 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1323+10*IOFF,'Y34 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1324+10*IOFF,'Y45 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1325+10*IOFF,'Y56 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
         ENDIF
	 IF(LCAMJ) THEN
C
C     CAMBRIDGE FINDING, LOG SCALE
C 
            NBMM = 24
            CALL HBOOK1(1401+10*IOFF,'R1 CM'//PH(IOFF+1),NBMM,-6.,0.,0.)
            CALL HBOOK1(1402+10*IOFF,'R2 CM'//PH(IOFF+1),NBMM,-6.,0.,0.)
            CALL HBOOK1(1403+10*IOFF,'R3 CM'//PH(IOFF+1),NBMM,-6.,0.,0.)
            CALL HBOOK1(1404+10*IOFF,'R4 CM'//PH(IOFF+1),NBMM,-6.,0.,0.)
            CALL HBOOK1(1405+10*IOFF,'R5 CM'//PH(IOFF+1),NBMM,-6.,0.,0.)
            CALL HBOOK1(1406+10*IOFF,'R6 CM'//PH(IOFF+1),NBMM,-6.,0.,0.)
            CALL HBOOK1(1408+10*IOFF,'MN CM'//PH(IOFF+1),NBMM,-6.,0.,0.)

           CALL HBOOK1(1421+10*IOFF,'Y12 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1422+10*IOFF,'Y23 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1423+10*IOFF,'Y34 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1424+10*IOFF,'Y45 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
           CALL HBOOK1(1425+10*IOFF,'Y56 KT'//PH(IOFF+1),NBMM,-6.,0.,0.)
         ENDIF

         IF(LCONE) THEN
           CALL HBOOK1(1501+10*IOFF,'R1 CR'//PH(IOFF+1),13,0.25,1.55,0.)
           CALL HBOOK1(1502+10*IOFF,'R2 CR'//PH(IOFF+1),13,0.25,1.55,0.)
           CALL HBOOK1(1503+10*IOFF,'R3 CR'//PH(IOFF+1),13,0.25,1.55,0.)
           CALL HBOOK1(1504+10*IOFF,'R4 CR'//PH(IOFF+1),13,0.25,1.55,0.)
           CALL HBOOK1(1505+10*IOFF,'R5 CR'//PH(IOFF+1),13,0.25,1.55,0.)
           CALL HBOOK1(1506+10*IOFF,'R6 CR'//PH(IOFF+1),13,0.25,1.55,0.)
            
            CALL HBOOK1(1521+10*IOFF,'R1 CE'//PH(IOFF+1),13,1.,27.,0.)
            CALL HBOOK1(1522+10*IOFF,'R2 CE'//PH(IOFF+1),13,1.,27.,0.)
            CALL HBOOK1(1523+10*IOFF,'R3 CE'//PH(IOFF+1),13,1.,27.,0.)
            CALL HBOOK1(1524+10*IOFF,'R4 CE'//PH(IOFF+1),13,1.,27.,0.)
            CALL HBOOK1(1525+10*IOFF,'R5 CE'//PH(IOFF+1),13,1.,27.,0.)
            CALL HBOOK1(1526+10*IOFF,'R6 CE'//PH(IOFF+1),13,1.,27.,0.)
         ENDIF
      ENDDO
C     
C..   POWERS OF EVENT SHAPES
C     
      CALL HBOOK1(191,'MEAN',12,0.5,12.5,0.)
      CALL HBOOK1(192,'WIDT',12,0.5,12.5,0.)
      CALL HBOOK1(193,'SKEW',12,0.5,12.5,0.)
      CALL HBOOK1(194,'Y   ',12,0.5,12.5,0.)
      CALL HBOOK1(195,'Y**2',12,0.5,12.5,0.)
      CALL HBOOK1(196,'Y**3',12,0.5,12.5,0.)
C
C   Tab file with event shapes
C
      IF( LTAB )
     >OPEN(UNIT=71,FILE='shapes.tab',STATUS='UNKNOWN',FORM='FORMATTED')

C
C  The End:
      RETURN
      END
CDECK  ID>, MCUSEV.
      SUBROUTINE MCUSEV
      IMPLICIT NONE
C  Routine gets stable partons and hadrons from JETSET event record,
C  packs momenta into arrays and calls analysis routine.
C  Created: 03.07.96
C  Author: Stefan Kluth (based on code from David Ward)
C  Modifications:
C  16.07.96, STK: New parton selection algorithm,
C                 mods for user FFREAD cards
C  25.07.96, STK: New (simpler) algorithms for ISR treatment
C  18.09.96, STK: Switch ISRRM for ISR removal from event record
C  30.10.96, STK: Fix flavour determination for JETSET
C  06.11.96, STK: Reorganise, pack selections into subroutines
C  25.07.00, PMF: Add calculation of particle statistics by LUTABU
C  01.08.00, PMF: Do not fill neither parton level nor hadron level
C                 distributions if LUDSC.EQ..TRUE.
C  01.06.01, PMF: Adapt code for use with Jetset6.3
      INTEGER  NLUPDM,NPLBUF
      PARAMETER  (NLUPDM=4000,NPLBUF=5)
      COMMON/GUJETS/N,K(NLUPDM,5),P(NLUPDM,NPLBUF),V(NLUPDM,5)
      INTEGER  N,K
      REAL  P,V
      SAVE /GUJETS/
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
C  FFREAD user variables:
      LOGICAL LFSRRM,LISRRM,LBOOS,LCONE,LDURH,LJDE0,LCAMJ,LCKRN
      INTEGER HOUTFILE(NWONAM)
      INTEGER NJTEV
      COMMON /MCUFFR/ LFSRRM,LISRRM,LBOOS, LCONE,LDURH,LJDE0,LCAMJ
     &                ,LCKRN,NJTEV,HOUTFILE
      SAVE /MCUFFR/
C  Stuff for HBOOK:
      INTEGER LIMIT
      PARAMETER( LIMIT=200000 )
      REAL HMEM
      COMMON /PAWC/ HMEM(LIMIT)
      SAVE /PAWC/
      LOGICAL LKEEP
      INTEGER I,J,L,II,III,NTRAKP,NTRAKH,JFLAV,LUCHGE,LUCOMP,IERR
      INTEGER IDIM,MAXTRK,ICALL,IRM,IPA,NSTBL
      PARAMETER( IDIM=6, MAXTRK=1000, NSTBL=7 )
      REAL PTRAKP(IDIM,MAXTRK),PTRAKH(IDIM,MAXTRK),PSUM(4),ESUM
      INTEGER IPAR(MAXTRK),IID(MAXTRK),ILIN(MAXTRK),IDSTBL(NSTBL)
      DATA ICALL /0/
      SAVE ICALL
C  sigma-, Lambda, sigma+, xi-, xi0, omega-, K0s:
      DATA IDSTBL / 3112,3122,3222,3312,3322,3334,310 /
      SAVE IDSTBL
C      DATA MASS / 1197.436, 1115.684, 1189.37, 1321.32, 1314.9, 1672.45
C     &           ,497.672
C      DATA CTAU / 4.434,    7.89,     2.396,   4.91,    8.71,   2.46
C     &           ,2.676 /
C
C  Print the occasional progress message:
      ICALL= ICALL+1
      IF( MOD(ICALL,500).EQ.0 ) THEN
        PRINT*,'MCUSEV: called this many times: ',ICALL
      ENDIF
C
C  Needed for MCFIMA
      KEVT=ICALL
C
C  Analyse parton/particle content of current event
      CALL LUTABU(21)
C
C  Print event record if requested:
      IF( ICALL.LE.NRTOPR  .OR. MOD(ICALL,5000).EQ.0 ) THEN
        PRINT*,' '
        WRITE(*,'(80(''*'')/,A,I7)') 'MCUSEV: Event record:',ICALL
        CALL LULIST(2)
        CALL LUEDIT(21)
      ENDIF
C
C  Get stable QCD partons and FSR photons after termination of parton shower:
      CALL MCGETP(1,IDIM,NTRAKP,PTRAKP,ILIN,IID,IPAR)
C
C  Get event flavour in Z0/gamma:
      CALL MCGETF(JFLAV)
C
C  Print selected partons for first few events:
      CALL VZERO(PSUM,4)
      DO I=1,NTRAKP
        DO J=1,4
          PSUM(J)= PSUM(J)+PTRAKP(J,I)
        ENDDO
      ENDDO
      CALL HFILL(10,PSUM(4),0.0,1.0)
      IF( ICALL.LE.NRTOPR .OR. MOD(ICALL,5000).EQ.0 ) THEN
        PRINT*,'MCUSEV: Event flavour: ',JFLAV
        PRINT*,'MCUSEV: Selected partons:'
        PRINT*,'#    ILIN  IID  IPAR   PX      PY      PZ      E'
        DO I=1,NTRAKP
          PRINT 30,I,ILIN(I),IID(I),IPAR(I)
     &            ,PTRAKP(1,I),PTRAKP(2,I),PTRAKP(3,I),PTRAKP(4,I)
        ENDDO
        WRITE(*,'(1X,''sums:'',16X,4(F8.3))')
     &    PSUM(1),PSUM(2),PSUM(3),PSUM(4)
      ENDIF
   30 FORMAT(1X,I3,1X,I4,1X,I5,1X,I4,2X,4(F8.3))
C
C  Get partons w/o FSR if demanded:
      IF( LFSRRM ) THEN
        CALL MCGETP(0,IDIM,NTRAKP,PTRAKP,ILIN,IID,IPAR)
        ESUM= 0.0
        DO I=1,NTRAKP
          ESUM= ESUM+PTRAKP(4,I)
        ENDDO
        IF( PSUM(4).GT.ESUM ) CALL HFILL(15,PSUM(4)-ESUM,0.0,1.0)
C       Print partons again:
        IF( ICALL.LE.NRTOPR  .OR. MOD(ICALL,5000).EQ.0 ) THEN
          PRINT*,'MCUSEV: partons after FSR removal:'
          PRINT*,'#    ILIN  IID  IPAR'
          DO I=1,NTRAKP
            PRINT 50, I,ILIN(I),IID(I),IPAR(I)
          ENDDO
        ENDIF
      ENDIF
   50 FORMAT(1X,I3,1X,I4,1X,I5,1X,I4)
C
C  Fill "decay length" of long-lived hadrons in histo:
      DO I=1,N
        DO J=1,NSTBL
          IF( ABS(K(I,2)).EQ.IDSTBL(J) ) THEN
            CALL HFILL(37,(V(I,4)+V(I,5))/1000.0,0.0,1.0)
          ENDIF
        ENDDO
      ENDDO
C
C  Mark photons with no parents for removal if demanded, they are ISR:
      IF( LISRRM ) THEN
        IF( ICALL.LE.NRTOPR  .OR. MOD(ICALL,5000).EQ.0 ) THEN
          CALL LUEDIT(5)
          PRINT*,' '
          PRINT*,'MCUSEV: Event record before ISR removal:'
          CALL LULIST(2)
          CALL LUEDIT(22)
        ENDIF
        DO I=1,N
          IF( K(I,2).EQ.22 .AND. K(I,3).EQ.0 ) THEN
            K(I,1)= 21
            CALL HFILL(14,P(I,4),0.0,1.0)
          ENDIF
        ENDDO
      ENDIF
C
C  Get "stable" hadrons after hadronisation and decays:
      CALL MCGETH(IDIM,NTRAKH,PTRAKH)
      IF( ICALL.LE.NRTOPR  .OR. MOD(ICALL,5000).EQ.0 ) THEN
        PRINT*,' '
        PRINT*,'MCUSEV: Stable particles in event record after MCGETH:'
        CALL LULIST(2)
      ENDIF
C
C  Call analysis routine:

      IF(NTRAKH.GE.2) THEN
         IF(ICALL.LE.15) THEN
            WRITE(*,'(A,I4)') 'MCUSEV: FLAVOUR:           ',JFLAV
            WRITE(*,'(A,I4)') 'MCUSEV: NUMBER OF PARTONS: ',NTRAKP
            WRITE(*,'(A,I4)') 'MCUSEV: NUMBER OF HADRONS: ',NTRAKH
            write(*,'(A,A)')  'MCUSEV: GENERATOR        : ',CHMCTYP
         ENDIF
         IF(LBQRK) THEN
            IF(JFLAV.EQ.5) THEN
               CALL MCANAL(JFLAV,NTRAKP,NTRAKH,IDIM,PTRAKP,PTRAKH)
            ENDIF
         ELSEIF(LUDSC) THEN
            IF(JFLAV.LT.5) THEN
               CALL MCANAL(JFLAV,NTRAKP,NTRAKH,IDIM,PTRAKP,PTRAKH)
            ENDIF
         ELSE
            IF(SFLAV.EQ.0) THEN
               CALL MCANAL(JFLAV,NTRAKP,NTRAKH,IDIM,PTRAKP,PTRAKH)
            ELSEIF(SFLAV.EQ.JFLAV) THEN
               CALL MCANAL(JFLAV,NTRAKP,NTRAKH,IDIM,PTRAKP,PTRAKH)
            ENDIF
         ENDIF
      ELSE
         WRITE(*,*) 'SELECTED HADRONS: ',NTRAKH
      ENDIF
C
C  The End:
      RETURN
      END
CDECK  ID>, MCUSFI.
      SUBROUTINE MCUSFI
      IMPLICIT NONE
C  User finish routine, writes histos filled with MC info to file:
C  Stefan Kluth, 03.07.96
C  Modifications:
C  11.07.96, STK: fix filename problem on unix systems, use
C                 external file definition now
C  16.07.96, STK: mods for user FFREAD cards
C  17.07.96, STK: back to FFREAD file defintion, works now on unix
C  25.05.00, PMF: add final calculations for energy-energy correlations
C  25.07.00, PMF: add printout of event statistics via LUTABU
C  02.08.00, PMF: perform flavour dependend final calculations only
C                 if permitted by LUDSC and LBQRK
C  01.06.01, PMF: adapt code for use with Jetset6.3
C  Stuff for HBOOK:
      INTEGER LIMIT
      PARAMETER( LIMIT=200000 )
      REAL HMEM
      COMMON /PAWC/ HMEM(LIMIT)
      SAVE /PAWC/
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
C  FFREAD user variables:
      LOGICAL LFSRRM,LISRRM,LBOOS,LCONE,LDURH,LJDE0,LCAMJ,LCKRN
      INTEGER HOUTFILE(NWONAM)
      INTEGER NJTEV
      COMMON /MCUFFR/ LFSRRM,LISRRM,LBOOS, LCONE,LDURH,LJDE0,LCAMJ
     &                ,LCKRN,NJTEV,HOUTFILE
      SAVE /MCUFFR/
      INTEGER NPOW
      PARAMETER (NPOW=12)
      CHARACTER*3 CHSHAP(NPOW)
      DOUBLE PRECISION DSHAP1(NPOW),DSHAP2(NPOW),DSHAP3(NPOW)
      INTEGER  NSHAP
C PMF 12.05.00: Change order of variables in order to avoid misalignement
C      COMMON / NPOWER / CHSHAP,DSHAP1,DSHAP2,DSHAP3,NSHAP
      COMMON / NPOWER / DSHAP1,DSHAP2,DSHAP3,NSHAP,CHSHAP
C
C..   KEEP RUNNING SUM OF THE EVENT-SHAPES Y, FOR Y, Y**2, Y**3
C..   WHERE Y IS DEFINED IN MCUSIN DATA STATEMENT
C
C     Stuff for event shape analysis:
C     nbmax: number of bins for the histograms
C     ndimm: dimension of the XBINS array
C
      INTEGER NVAR,NBMAX,NDIMM
      PARAMETER( NBMAX=100, NDIMM=50, NVAR=6 )
      INTEGER NBMAX2
      PARAMETER( NBMAX2=1000 )  ! PMF: needed for finer binning of LINEAR y23 (D) distribution
C EEC special stuff
      INTEGER NBEEC
      REAL PIEEC
      PARAMETER( NBEEC=100, PIEEC=3.1415927 )
      REAL EEC(NBEEC),EECER(NBEEC),EECA(NBEEC/2),EECAER(NBEEC/2)
C
      INTEGER NBIN(NVAR)
      REAL XBINS(NDIMM,NVAR)
      REAL TH,MH,BT,BW,CP,Y23
      REAL TMA, TMI, OBL, SP, AC
      CHARACTER*2 CHVAR(NVAR)
      COMMON /MCEVSH/ NBIN
     &               ,TH,MH,BT,BW,CP,Y23,XBINS
     &               ,CHVAR
      SAVE /MCEVSH/
      INTEGER I,LENOCC,IERR
      INTEGER NENT, IFLAV, IOFF
      REAL  RMEAN,RWIDTH,RSKEW
      CHARACTER*(NAMLEN) CHOUTFILE
C
C PMF 12/05/00: Initialization of /MCEVSH/ is now done
C               in the BLOCK DATA subroutine 'MCEVBL'
C      DATA NBIN / 13, 12, 14, 13, 12, 15 /
C      DATA XBINS / 0.00, 0.01, 0.02, 0.03, 0.04, 0.05, 0.07, 0.09, 0.12
C     &            ,0.15, 0.22, 0.30, 0.40, 0.50, 36*0.0
C     &            ,0.00, 0.06 ,0.075,0.09, 0.11, 0.14, 0.17, 0.20, 0.25
C     &            ,0.30, 0.35, 0.45, 0.60, 37*0.0
C     &            ,0.00, 0.03, 0.04, 0.05, 0.06, 0.075,0.09, 0.11, 0.13
C     &            ,0.16, 0.20, 0.25, 0.30, 0.35, 0.40, 35*0.0
C     &            ,0.00, 0.02, 0.03, 0.04, 0.05, 0.065,0.08, 0.10, 0.15
C     &            ,0.20, 0.25, 0.30, 0.35, 0.40, 36*0.0
C     &            ,0.00, 0.05, 0.08, 0.11, 0.14, 0.18, 0.22, 0.30, 0.4
C     &            ,0.50, 0.60, 0.75, 1.00, 37*0.0
C     &            ,0.00, 0.3E-03, 0.75E-03, 0.13E-02, 0.23E-02, 0.4E-02
C     &            ,0.7E-02, 0.012, 0.0225, 0.04, 0.07, 0.13, 0.235
C     &  ,0.40, 0.70, 1.00, 34*0.0 /
C
C      DATA CHVAR / 'TH', 'MH', 'BT', 'BW', 'CP', 'D2' /
C
C
      REAL EECSUM,EECASUM,EECCUM(NBEEC),EECACUM(NBEEC/2)
C
C..   PRINT THE POWERS
C
      DO I=1,12
         CALL FIN3OUT(DSHAP1(I),DSHAP2(I),DSHAP3(I),NSHAP,
     +        RMEAN,RWIDTH,RSKEW)
         WRITE(*,'(3A,3F8.4,3F12.1)') 'SHAPES ',CHSHAP(I),
     +        ' M W S X X2 X3: ',
     +        RMEAN,RWIDTH,RSKEW,DSHAP1(I),DSHAP2(I),DSHAP3(I)
         CALL HFILL(191,REAL(I),0.,RMEAN)
         CALL HFILL(192,REAL(I),0.,RWIDTH)
         CALL HFILL(193,REAL(I),0.,RSKEW)
         CALL HFILL(194,REAL(I),0.,REAL(DSHAP1(I)))
         CALL HFILL(195,REAL(I),0.,REAL(DSHAP2(I)))
         CALL HFILL(196,REAL(I),0.,REAL(DSHAP3(I)))
      ENDDO
      WRITE(*,*) 'DONE WITH EVENTS: ',NSHAP

      DO IFLAV=1,6
        IF( .NOT.(   (IFLAV.EQ.5.AND.LUDSC)
     +           .OR.(IFLAV.LT.5.AND.LBQRK) )) THEN
         DO IOFF=0,10,10
            CALL HNOENT(920+IFLAV+IOFF,NENT)
            CALL HOPERA(920+IFLAV+IOFF,'+',920+IFLAV+IOFF,
     +           920+IFLAV+IOFF,0.,REAL(NBMAX2)/REAL(NENT))! PMF: NBMAX->NBMAX2
            CALL HNOENT(820+IFLAV+IOFF,NENT)
            CALL HOPERA(820+IFLAV+IOFF,'+',820+IFLAV+IOFF,
     +           820+IFLAV+IOFF,0.,REAL(NBMAX)/REAL(NENT))
C
C     Final calculations for energy-energy correlation

C     --- 1. Normalize and calculate asymmetry in theta bins
            CALL PXEECB(0,0,0.,0.,NBEEC,EEC,EECER,EECA,EECAER
     +           ,'N',IERR,IOFF+IFLAV)
            CALL HPAK(220+IFLAV+IOFF,EEC)
            CALL HPAKE(220+IFLAV+IOFF,EECER)
            CALL HPAK(240+IFLAV+IOFF,EECA)
            CALL HPAKE(240+IFLAV+IOFF,EECAER)
ccc            PRINT *,'=============',IFLAV+IOFF
ccc            CALL PXPRRV ('EEC',NBEEC,EEC)
ccc            CALL PXPRRV ('EECER',NBEEC,EECER)
ccc            CALL PXPRRV ('EECA',(NBEEC/2),EECA)
ccc            CALL PXPRRV ('EECAER',(NBEEC/2),EECAER)

C     --- 2. Fill cumulative distributions in theta bins
            IF( IFLAV.EQ.6) THEN
               EECSUM=0.
               EECASUM=0.
               DO I=1,NBEEC
                  EECSUM=EECSUM+EEC(I)
                  EECCUM(I)=EECSUM
               ENDDO
               CALL HPAK(227+IOFF,EECCUM)
ccc               CALL PXPRRV ('EECCUM',NBEEC,EECCUM)
               DO I=1,NBEEC/2
                  EECASUM=EECASUM+EECA(I)
                  EECACUM(I)=EECASUM
               ENDDO
               CALL HPAK(247+IOFF,EECACUM)
ccc               CALL PXPRRV ('EECACUM',NBEEC/2,EECACUM)
            ENDIF

C     --- 3. Normalize and calculate asymmetry in cos(theta) bins
            CALL PXEECB(0,0,0.,0.,NBEEC,EEC,EECER,EECA,EECAER
     +           ,'N',IERR,-(IOFF+IFLAV+20) )
            CALL HPAK(260+IFLAV+IOFF,EEC)
            CALL HPAKE(260+IFLAV+IOFF,EECER)
            CALL HPAK(280+IFLAV+IOFF,EECA)
            CALL HPAKE(280+IFLAV+IOFF,EECAER)
ccc            PRINT *,'=============',-(IFLAV+IOFF+20)
ccc            CALL PXPRRV ('EEC',NBEEC,EEC)
ccc            CALL PXPRRV ('EECER',NBEEC,EECER)
ccc            CALL PXPRRV ('EECA',(NBEEC/2),EECA)
ccc            CALL PXPRRV ('EECAER',(NBEEC/2),EECAER)

C     --- 4. Fill cumulative distributions in cos(theta) bins
            IF( IFLAV.EQ.6) THEN
               EECSUM=0.
               EECASUM=0.
               DO I=1,NBEEC
                  EECSUM=EECSUM+EEC(I)
                  EECCUM(I)=EECSUM
               ENDDO
               CALL HPAK(267+IOFF,EECCUM)
ccc               CALL PXPRRV ('EECCUM',NBEEC,EECCUM)
               DO I=1,NBEEC/2
                  EECASUM=EECASUM+EECA(I)
                  EECACUM(I)=EECASUM
               ENDDO
               CALL HPAK(287+IOFF,EECACUM)
ccc               CALL PXPRRV ('EECACUM',NBEEC/2,EECACUM)
            ENDIF
         ENDDO
       ENDIF
      ENDDO
C
C     Print event statistics
      CALL LUTABU(22)
C
      CALL UHTOC(HOUTFILE,NBYTEW,CHOUTFILE,NAMLEN)
      PRINT*,' '
      PRINT*,'MCUSFI: Output histos to: ',
     +     CHOUTFILE(1:LENOCC(CHOUTFILE))
      CALL HCDIR('//PAWC',' ')
      CALL HRPUT(0,CHOUTFILE(1:LENOCC(CHOUTFILE)),'N')
C
C Close tab file
C
      IF( LTAB ) CLOSE(UNIT=71)
C Print MC Parameters
      CALL PRIPAR
C
      RETURN
      END
CDECK  ID>, PRIPAR.
      SUBROUTINE PRIPAR
      INTEGER  NLUPDM,NPLBUF
      PARAMETER  (NLUPDM=4000,NPLBUF=5)
      COMMON/GUJETS/N,K(NLUPDM,5),P(NLUPDM,NPLBUF),V(NLUPDM,5)
      INTEGER  N,K
      REAL  P,V
      SAVE /GUJETS/
      COMMON/GUDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER  MSTU,MSTJ
      REAL  PARU,PARJ
      SAVE /GUDAT1/
      COMMON/GUDAT2/KCHG(500,3),PMAS(500,4),PARF(2000),VCKM(4,4)
      INTEGER  KCHG
      REAL  PMAS,PARF,VCKM
      SAVE /GUDAT2/
**JWG  add psi'(3685) as KC code 80, needed for Eurodec interface
*      --- ---------- -- -- ---- --- ------ --- ------- ---------
      INTEGER  IDPSIP
      PARAMETER  (IDPSIP=80)
      COMMON/GUDAT3/MDCY(500,3),MDME(2000,2),BRAT(2000),KFDP(2000,5)
      INTEGER  MDCY,MDME,KFDP
      REAL  BRAT
      SAVE /GUDAT3/
      COMMON/GUDAT4/CHAF(500)
      CHARACTER CHAF*8
      SAVE /GUDAT4/
      COMMON/GUDATR/MRLU(6),RRLU(100)
      INTEGER  MRLU
      REAL  RRLU
      SAVE /GUDATR/
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
      INTEGER MSTA
      REAL PARA
      COMMON /ARDAT1/ PARA(40),MSTA(40)
C
      INTEGER INDEX
C
      IF( INDEX(CHMCTYP,'LUND63').NE.0 
     >     .OR. INDEX(CHMCTYP,'COJET').NE.0 
     >     .OR. INDEX(CHMCTYP,'HERWIG').NE.0 ) GOTO 999
      PRINT *,'MC parameters for ',CHMCTYP
      PRINT *,'MSTJ(11)=',MSTJ(11)
      PRINT *,'sigma_q  PARJ(21)=',PARJ(21)
      PRINT *,'      a  PARJ(41)=',PARJ(41)
      PRINT *,'      b  PARJ(42)=',PARJ(42)
      PRINT *,'  eps_c  PARJ(54)=',PARJ(54)
      PRINT *,'  eps_b  PARJ(55)=',PARJ(55)
      IF( INDEX(CHMCTYP,'ARIADNE').NE.0 ) THEN
         IF( MSTJ(11).GE.4 ) THEN
            PRINT *,'Modification of Lund symm. FF'
            PRINT *,'         PARJ(46)=', PARJ(46)
            PRINT *,'         PARJ(47)=', PARJ(47)
         ENDIF
         PRINT *,'  Lambda PARJ(81)=',PARJ(81)
         PRINT *,'  Lambda  PARA(1)=',PARA(1)
         PRINT *,'   p_T_0  PARA(3)=',PARA(3)
      ELSE
         PRINT *,'  Lambda PARJ(81)=',PARJ(81)
         PRINT *,'     Q_0 PARJ(82)=',PARJ(82)
      ENDIF
C
 999  RETURN
      END
CDECK  ID>, FIN3OUT.
      SUBROUTINE FIN3OUT(D1,D2,D3,N,RMEAN,RWIDTH,RSKEW)
      DOUBLE PRECISION DMOM(3),DMOMN(3)
      DOUBLE PRECISION D1,D2,D3
      INTEGER N,I
      REAL RMEAN,RWIDTH,RSKEW
* DMOM is sum(x_i),sum((x_i)^2),sum((x_i)^3) for i=1..N
* N is the number of events
* rmean, rwidth, rskew are real mean, width and skewness.
      RMEAN = 0.
      RSKEW = 0.
      RWIDTH = 0.
      IF(N.NE.0) THEN
         DMOMN(1) = D1/N
         DMOMN(2) = D2/N
         DMOMN(3) = D3/N
      ELSE
         RETURN
      ENDIF

      RMEAN=REAL(DMOMN(1))
      RWIDTH=REAL(SQRT(DMOMN(2)-DMOMN(1)**2))
      IF(DMOMN(2).NE.DMOMN(1)**2) THEN
      RSKEW=REAL((DMOMN(3)-3*DMOMN(1)*DMOMN(2)+2*DMOMN(1)**3)/
     +               ((SQRT(DMOMN(2)-DMOMN(1)**2))**3))
      ENDIF
      END

CDECK  ID>, MCFILL.
      SUBROUTINE MCFILL(NTRAK,IDIM,PTRAK,JFLAV,IOFF)
      IMPLICIT NONE
C  Routine to compute event shapes from PTRAK array and fill histos
C  Input:   NTRAK   Number of entries in PTRAK
C           PTRAK() Array with 5-momenta of particles
C           IDIM    1st dimension of PTRAK array
C           JFLAV   quark flavour identification, 1=u,...,5=b
C           IOFF    Offset for histo ids
C  Stefan Kluth, 19.1.96
C  Modifications:
C     22-10-96: include track based quantities SB
C     25-05-00, PMF: - include charged+neutral particles based quantities
C                    - include energy-energy correlations
C  Stuff for HBOOK:
      INTEGER LIMIT
      PARAMETER( LIMIT=200000 )
      REAL HMEM
      COMMON /PAWC/ HMEM(LIMIT)
      SAVE /PAWC/
C     Stuff for event shape analysis:
C     nbmax: number of bins for the histograms
C     ndimm: dimension of the XBINS array
C
      INTEGER NVAR,NBMAX,NDIMM
      PARAMETER( NBMAX=100, NDIMM=50, NVAR=6 )
      INTEGER NBMAX2
      PARAMETER( NBMAX2=1000 )  ! PMF: needed for finer binning of LINEAR y23 (D) distribution
C EEC special stuff
      INTEGER NBEEC
      REAL PIEEC
      PARAMETER( NBEEC=100, PIEEC=3.1415927 )
      REAL EEC(NBEEC),EECER(NBEEC),EECA(NBEEC/2),EECAER(NBEEC/2)
C
      INTEGER NBIN(NVAR)
      REAL XBINS(NDIMM,NVAR)
      REAL TH,MH,BT,BW,CP,Y23
      REAL TMA, TMI, OBL, SP, AC
      CHARACTER*2 CHVAR(NVAR)
      COMMON /MCEVSH/ NBIN
     &               ,TH,MH,BT,BW,CP,Y23,XBINS
     &               ,CHVAR
      SAVE /MCEVSH/
      INTEGER NPOW
      PARAMETER (NPOW=12)
      CHARACTER*3 CHSHAP(NPOW)
      DOUBLE PRECISION DSHAP1(NPOW),DSHAP2(NPOW),DSHAP3(NPOW)
      INTEGER  NSHAP
C PMF 12.05.00: Change order of variables in order to avoid misalignement
C      COMMON / NPOWER / CHSHAP,DSHAP1,DSHAP2,DSHAP3,NSHAP
      COMMON / NPOWER / DSHAP1,DSHAP2,DSHAP3,NSHAP,CHSHAP
C
C..   KEEP RUNNING SUM OF THE EVENT-SHAPES Y, FOR Y, Y**2, Y**3
C..   WHERE Y IS DEFINED IN MCUSIN DATA STATEMENT
C

      INTEGER NTRAK,JFLAV,IDIM,IOFF,IERR,ICALL,I,NFAIL
      REAL PTRAK(IDIM,*)
      REAL XP(1000),YP(1000),PTIN(1000),PTOUT(1000)
      REAL XI
      REAL THRUST,AMH,AML,Y34,Y12
     &    ,THRUS0(3),EVAL(3),EVEC(3,3)
      REAL TVEC0(3,3),TVEC(3)
      REAL CST
      REAL         YY
      INTEGER      NJET
      EQUIVALENCE (THRUST,THRUS0(3))
      EQUIVALENCE (TVEC(1),TVEC0(1,3))
      REAL VY(NBMAX),EX(NBMAX),EY(NBMAX)
      REAL VY2(NBMAX2),EX2(NBMAX2),EY2(NBMAX2) ! PMF: added array with dimension NBMAX2
      REAL XTH(NBMAX),XMH(NBMAX),XBT(NBMAX),XBW(NBMAX),XCP(NBMAX)
     &  ,XD2(NBMAX2),XD2LOG(NBMAX),XTMA(NBMAX),XTMI(NBMAX),XOBL(NBMAX)! PMF: NBMAX->NBMAX2
     &  ,XSP(NBMAX),XAC(NBMAX),XMH2(NBMAX)
      SAVE XTH,XMH,XBT,XBW,XCP,XD2,XD2LOG,XMH2
C  EEC stuff
      REAL EVISIB
      REAL EECVY(NBEEC),EECEX(NBEEC),EECEY(NBEEC)
      REAL AEECVY(NBEEC/2),AEECEX(NBEEC/2),AEECEY(NBEEC/2)
      REAL XEEC1(NBEEC),XAEEC1(NBEEC/2),XEEC2(NBEEC),XAEEC2(NBEEC/2)
      SAVE XEEC1,XAEEC1,XEEC2,XAEEC2
C
C
C PMF 12/05/00: Initialization of /MCEVSH/ is now done
C               in the BLOCK DATA subroutine 'MCEVBL'
C      DATA NBIN / 13, 12, 14, 13, 12, 15 /
C      DATA XBINS / 0.00, 0.01, 0.02, 0.03, 0.04, 0.05, 0.07, 0.09, 0.12
C     &            ,0.15, 0.22, 0.30, 0.40, 0.50, 36*0.0
C     &            ,0.00, 0.06 ,0.075,0.09, 0.11, 0.14, 0.17, 0.20, 0.25
C     &            ,0.30, 0.35, 0.45, 0.60, 37*0.0
C     &            ,0.00, 0.03, 0.04, 0.05, 0.06, 0.075,0.09, 0.11, 0.13
C     &            ,0.16, 0.20, 0.25, 0.30, 0.35, 0.40, 35*0.0
C     &            ,0.00, 0.02, 0.03, 0.04, 0.05, 0.065,0.08, 0.10, 0.15
C     &            ,0.20, 0.25, 0.30, 0.35, 0.40, 36*0.0
C     &            ,0.00, 0.05, 0.08, 0.11, 0.14, 0.18, 0.22, 0.30, 0.4
C     &            ,0.50, 0.60, 0.75, 1.00, 37*0.0
C     &            ,0.00, 0.3E-03, 0.75E-03, 0.13E-02, 0.23E-02, 0.4E-02
C     &            ,0.7E-02, 0.012, 0.0225, 0.04, 0.07, 0.13, 0.235
C     &  ,0.40, 0.70, 1.00, 34*0.0 /
C
C      DATA CHVAR / 'TH', 'MH', 'BT', 'BW', 'CP', 'D2' /
C
      DATA ICALL /0/, NFAIL /0/
      SAVE ICALL,NFAIL
C
C  Fix to fill cumulative distributions:
      ICALL= ICALL+1
      IF( ICALL.EQ.1 ) THEN

        CALL HREBIN(227+IOFF,XEEC1,EECVY,EECEX,EECEY,NBEEC,1,NBEEC)
        CALL HREBIN(247+IOFF,XAEEC1,EECVY,EECEX,EECEY,NBEEC/2,1,NBEEC/2)
        CALL HREBIN(267+IOFF,XEEC2,EECVY,EECEX,EECEY,NBEEC,1,NBEEC)
        CALL HREBIN(287+IOFF,XAEEC2,EECVY,EECEX,EECEY,NBEEC/2,1,NBEEC/2)

        CALL HREBIN(307+IOFF,XTH,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(357+IOFF,XTMA,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(407+IOFF,XMH,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(427+IOFF,XMH2,VY,EX,EY,NBMAX,1,NBMAX) ! PMF 10/03/01: added for MH**2
        CALL HREBIN(457+IOFF,XTMI,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(507+IOFF,XBT,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(557+IOFF,XOBL,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(607+IOFF,XBW,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(657+IOFF,XSP,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(707+IOFF,XCP,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(757+IOFF,XAC,VY,EX,EY,NBMAX,1,NBMAX)
        CALL HREBIN(907+IOFF,XD2,VY2,EX2,EY2,NBMAX2,1,NBMAX2)! PMF: NBMAX->NBMAX2
        CALL HREBIN(807+IOFF,XD2LOG,VY,EX,EY,NBMAX,1,NBMAX)
      ENDIF
C
C  Compute event shapes:
      CALL PXLTH4(NTRAK,IDIM,PTRAK,THRUS0,TVEC0,IERR)
      CALL PXMMBB(NTRAK,IDIM,PTRAK,TVEC,AMH,AML,BT,BW,IERR)
      CALL PXLSP3(NTRAK,IDIM,PTRAK,EVAL,EVEC,IERR)
      CP   = 3.0*( EVAL(1)*EVAL(2) + EVAL(2)*EVAL(3) +
     &          EVAL(3)*EVAL(1) )
      TH   = 1.-THRUST
      MH   = AMH
      TMA = THRUS0(2)
      TMI = THRUS0(1)
      OBL = TMA - TMI
      CST = TVEC0(3,3)          ! PMF 01/11/00: added
      CALL PXJSP3(NTRAK,IDIM,PTRAK,EVAL,EVEC,IERR)
      SP = (3./2.)*(EVAL(1)+EVAL(2))
      AC = (3./2.)*EVAL(1)
C  PMF: Force some negative quantities to be 0.
      IF( CP.LT.0. ) CP=0.
      IF( SP.LT.0. ) SP=0.
      IF( AC.LT.0. ) AC=0.
C
C  PMF: Compute energy-energy correlations.
C  Use modified version of PXEEC4 for simultaneous calculation
C  at hadron and parton level
      EVISIB=0.
      DO I=1,NTRAK
         EVISIB=EVISIB+PTRAK(4,I)
      ENDDO
C     --- in theta bins
      CALL PXEECB(NTRAK,IDIM,PTRAK,EVISIB,NBEEC,
     +     EEC,EECER,EECA,EECAER,'S',IERR,IOFF+JFLAV)
      CALL PXEECB(NTRAK,IDIM,PTRAK,EVISIB,NBEEC,
     +     EEC,EECER,EECA,EECAER,'S',IERR,IOFF+6)
C     --- in cos(theta) bins
      CALL PXEECB(NTRAK,IDIM,PTRAK,EVISIB,NBEEC,
     +     EEC,EECER,EECA,EECAER,'S',IERR, -(IOFF+JFLAV+20) )
      CALL PXEECB(NTRAK,IDIM,PTRAK,EVISIB,NBEEC,
     +     EEC,EECER,EECA,EECAER,'S',IERR, -(IOFF+6+20) )
C  Jet finding with Durham jet algorithm, IMODE=5. Set y23=0 when there
C  are only two partons in the MC event:
      CALL YKERN(5,NTRAK,IDIM,PTRAK,IERR)
      IF( NTRAK.GE.3 ) THEN
        CALL YYJET(2,Y23,Y12,IERR)
      ELSE
        Y23= 0.0
      ENDIF
C
C..   SAVE POWERS OF EVENT SHAPES FOR HADRON LEVEL
C
      IF(IOFF.EQ.10) THEN
         NSHAP     = NSHAP + 1
         DSHAP1(1) = DSHAP1(1) + DBLE(TH)
         DSHAP2(1) = DSHAP2(1) + DBLE(TH)**2
         DSHAP3(1) = DSHAP3(1) + DBLE(TH)**3
         
         DSHAP1(2) = DSHAP1(2) + DBLE(TMA)
         DSHAP2(2) = DSHAP2(2) + DBLE(TMA)**2
         DSHAP3(2) = DSHAP3(2) + DBLE(TMA)**3
         
         DSHAP1(3) = DSHAP1(3) + DBLE(MH)
         DSHAP2(3) = DSHAP2(3) + DBLE(MH)**2
         DSHAP3(3) = DSHAP3(3) + DBLE(MH)**3
         
         DSHAP1(4) = DSHAP1(4) + DBLE(TMI)
         DSHAP2(4) = DSHAP2(4) + DBLE(TMI)**2
         DSHAP3(4) = DSHAP3(4) + DBLE(TMI)**3
         
         DSHAP1(5) = DSHAP1(5) + DBLE(BT)
         DSHAP2(5) = DSHAP2(5) + DBLE(BT)**2
         DSHAP3(5) = DSHAP3(5) + DBLE(BT)**3
         
         DSHAP1(6) = DSHAP1(6) + DBLE(OBL)
         DSHAP2(6) = DSHAP2(6) + DBLE(OBL)**2
         DSHAP3(6) = DSHAP3(6) + DBLE(OBL)**3
         
         DSHAP1(7) = DSHAP1(7) + DBLE(BW)
         DSHAP2(7) = DSHAP2(7) + DBLE(BW)**2
         DSHAP3(7) = DSHAP3(7) + DBLE(BW)**3
         
         DSHAP1(8) = DSHAP1(8) + DBLE(SP)
         DSHAP2(8) = DSHAP2(8) + DBLE(SP)**2
         DSHAP3(8) = DSHAP3(8) + DBLE(SP)**3
         
         DSHAP1(9) = DSHAP1(9) + DBLE(CP)
         DSHAP2(9) = DSHAP2(9) + DBLE(CP)**2
         DSHAP3(9) = DSHAP3(9) + DBLE(CP)**3
         
         DSHAP1(10) = DSHAP1(10) + DBLE(AC)
         DSHAP2(10) = DSHAP2(10) + DBLE(AC)**2
         DSHAP3(10) = DSHAP3(10) + DBLE(AC)**3
         
         DSHAP1(11) = DSHAP1(11) + DBLE(Y23)
         DSHAP2(11) = DSHAP2(11) + DBLE(Y23)**2
         DSHAP3(11) = DSHAP3(11) + DBLE(Y23)**3
         
         DSHAP1(12) = DSHAP1(12) +  1D0-DBLE(TH)
         DSHAP2(12) = DSHAP2(12) + (1D0-DBLE(TH))**2
         DSHAP3(12) = DSHAP3(12) + (1D0-DBLE(TH))**3
      ENDIF
C
C  Fill histos:
      CALL HFILL(300+IOFF+JFLAV,TH,0.,1.)
      CALL HFILL(320+IOFF+JFLAV,CST,0.,1.)  ! PMF 01/11/00: added
      CALL HFILL(350+IOFF+JFLAV,TMA,0.,1.)
      CALL HFILL(400+IOFF+JFLAV,MH,0.,1.)
      CALL HFILL(420+IOFF+JFLAV,MH*MH,0.,1.) ! PMF 10/03/01: added MH**2
      CALL HFILL(450+IOFF+JFLAV,TMI,0.,1.)
      CALL HFILL(500+IOFF+JFLAV,BT,0.,1.)
      CALL HFILL(550+IOFF+JFLAV,OBL,0.,1.)
      CALL HFILL(600+IOFF+JFLAV,BW,0.,1.)
      CALL HFILL(650+IOFF+JFLAV,SP,0.,1.)
      CALL HFILL(700+IOFF+JFLAV,CP,0.,1.)
      CALL HFILL(750+IOFF+JFLAV,AC,0.,1.)
      CALL HFILL(800+IOFF+JFLAV,Y23,0.,1.)
      CALL HFILL(900+IOFF+JFLAV,Y23,0.,1.)
      CALL HFILL(306+IOFF,TH,0.,1.)
      CALL HFILL(326+IOFF,CST,0.,1.)  ! PMF 01/11/00: added
      CALL HFILL(356+IOFF,TMA,0.,1.)
      CALL HFILL(406+IOFF,MH,0.,1.)
      CALL HFILL(426+IOFF,MH*MH,0.,1.) ! PMF 10/03/01: added MH**2
      CALL HFILL(456+IOFF,TMI,0.,1.)
      CALL HFILL(506+IOFF,BT,0.,1.)
      CALL HFILL(556+IOFF,OBL,0.,1.)
      CALL HFILL(606+IOFF,BW,0.,1.)
      CALL HFILL(656+IOFF,SP,0.,1.)
      CALL HFILL(706+IOFF,CP,0.,1.)
      CALL HFILL(756+IOFF,AC,0.,1.)
      CALL HFILL(806+IOFF,Y23,0.,1.)
      CALL HFILL(856+IOFF,1.-TH,0.,1.)
      CALL HFILL(906+IOFF,Y23,0.,1.)
C
C     FILL THE MEAN JET RATE HISTOGRAMS
C
      DO I=1,NBMAX
         YY = XD2LOG(I)
         CALL YNJET(YY,NJET,IERR)
         CALL HFILL(820+IOFF+JFLAV,YY,0.,REAL(NJET))
         CALL HFILL(826+IOFF,YY,0.,REAL(NJET))
      ENDDO
      DO I=1,NBMAX2! PMF: NBMAX->NBMAX2
         YY = XD2(I)
         CALL YNJET(YY,NJET,IERR)
         CALL HFILL(920+IOFF+JFLAV,YY,0.,REAL(NJET))
         CALL HFILL(926+IOFF,YY,0.,REAL(NJET))
      ENDDO



C     Fill cumulative distributions:
c      write(*,'(2I4,7F10.3)') ntrak,jflav,th,tma,mh,tmi,bt,obl,bw
      DO I=1,NBMAX
        IF( TH.LE.XTH(I)   ) CALL HFILL(307+IOFF,XTH(I)  ,0.,1.)
        IF( TMA.LE.XTMA(I) ) CALL HFILL(357+IOFF,XTMA(I),0.,1.)
        IF( MH.LE.XMH(I)   ) CALL HFILL(407+IOFF,XMH(I)  ,0.,1.)
        IF( MH*MH.LE.XMH2(I) ) CALL HFILL(427+IOFF,XMH2(I)  ,0.,1.) ! 10/03/01: added for MH**2
        IF( TMI.LE.XTMI(I) ) CALL HFILL(457+IOFF,XTMI(I),0.,1.)
        IF( BT.LE.XBT(I)   ) CALL HFILL(507+IOFF,XBT(I)  ,0.,1.)
        IF( OBL.LE.XOBL(I) ) CALL HFILL(557+IOFF,XOBL(I),0.,1.)
        IF( BW.LE.XBW(I)   ) CALL HFILL(607+IOFF,XBW(I)  ,0.,1.)
        IF( SP.LE.XSP(I)   ) CALL HFILL(657+IOFF,XOBL(I),0.,1.)
        IF( CP.LE.XCP(I)   ) CALL HFILL(707+IOFF,XCP(I)  ,0.,1.)
        IF( AC.LE.XAC(I)   ) CALL HFILL(757+IOFF,XOBL(I),0.,1.)
        IF( Y23.LE.XD2LOG(I)) CALL HFILL(807+IOFF,XD2LOG(I),0.,1.)
      ENDDO
      DO I=1,NBMAX2
        IF( Y23.LE.XD2(I)  ) CALL HFILL(907+IOFF,XD2(I)  ,0.,1.)! PMF: NBMAX->NBMAX2
      ENDDO

C
C..   COMPUTE TRACK BASED QUANTITIES
C
      CALL QQCTRK(IDIM,NTRAK,PTRAK,XP,YP,PTIN,PTOUT)
      DO I=1,NTRAK
C     ...only charged particles
        IF(PTRAK(6,I).NE.0.) THEN
          CALL HFILL(50+IOFF,ABS(PTIN(I)) ,0.,1.)
          CALL HFILL(51+IOFF,ABS(PTOUT(I)),0.,1.)
          CALL HFILL(52+IOFF,ABS(XP(I))   ,0.,1.)
          CALL HFILL(53+IOFF,ABS(YP(I))   ,0.,1.)
          IF(XP(I).NE.0.) THEN
            XI = LOG(1/ABS(XP(I)))
          ELSE
            XI = 0.
          ENDIF
          CALL HFILL(54+IOFF,XI      ,0.,1.)
        ENDIF
C     ... all particles
        CALL HFILL(55+IOFF,ABS(PTIN(I)) ,0.,1.)
        CALL HFILL(56+IOFF,ABS(PTOUT(I)),0.,1.)
        CALL HFILL(57+IOFF,ABS(XP(I))   ,0.,1.)
        CALL HFILL(58+IOFF,ABS(YP(I))   ,0.,1.)
        IF(XP(I).NE.0.) THEN
           XI = LOG(1/ABS(XP(I)))
        ELSE
           XI = 0.
        ENDIF
        CALL HFILL(59+IOFF,XI      ,0.,1.)
      ENDDO
C
C  The End:
      RETURN
      END
CDECK  ID>, QQBOOS.
      SUBROUTINE QQBOOS(PVEC,IDIM,NTRAK,PTRAK)
      IMPLICIT NONE
C  Boost PTRAK array into restframe of 5-vector PVEC.
C  Input:  PVEC()   5-vector defining restframe, PVEC(5)= MASS
C          IDIM     1st dimension of PTRAK array
C          NTRAK    Number of entries in PTRAK array
C          PTRAK()  Array of 5-vectors to be boosted
C  Output: PTRAK()        "            after boost
C  Author: Stefan Kluth
C  Date: 28.11.95
C  Modifications:
C  13.3.96: Introduce variable first dimension for PTRAK array
      INTEGER I,J,IDIM,NTRAK
      REAL PTRAK(IDIM,*),PVEC(5),PTMP(5)
      DO I=1,NTRAK
        CALL PXLZF5(PVEC,PTRAK(1,I),PTMP)
        DO J=1,5
          PTRAK(J,I)= PTMP(J)
        ENDDO
      ENDDO
      RETURN
      END

CDECK  ID>, QQCTRK.
      SUBROUTINE QQCTRK(IDIM,NTRAK,PTRAK,XP,YP,PTIN,PTOUT)
      IMPLICIT NONE
C  Routine to compute particle based quantities.
C  Input:  IDIM    1st dimension of array PTRAK
C          NTRAK   number of entries in PTRAK
C          PTRAK() array of 5-momenta (px,py,pz,E,m)
C  Output: XP()    array with xp= p/E_beam
C          YP()    array with rapidity w.r.t. thrust axis
C          PTIN()  array with momentum components in event plane
C          PTOUT() array with momentum components out of event plane
C  Author: Stefan Kluth
C  Date: 28.3.96
C  Modifications:
C  Trap NTRAK.LE.1, 12.6.96, Stefan Kluth
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
      INTEGER IDIM, NTRAK
      REAL PTRAK(IDIM,*),XP(*),YP(*),PTIN(*),PTOUT(*)
      INTEGER I,IERR
      REAL XDUMMY(10),TVEC(3,3),SVEC(3,3)
      IF( NTRAK.GT.1 ) THEN
        CALL PXLTH4(NTRAK,IDIM,PTRAK,XDUMMY,TVEC,IERR)
        CALL PXJSP3(NTRAK,IDIM,PTRAK,XDUMMY,SVEC,IERR)
        DO I=1,NTRAK
          XP(I)= SQRT(PTRAK(1,I)**2+PTRAK(2,I)**2+PTRAK(3,I)**2)/
     +      (ECMASS/2)
          CALL PXRAP4(PTRAK(1,I),TVEC(1,3),YP(I),IERR)
          CALL PXPLT3(PTRAK(1,I),SVEC(1,2),PTIN(I),XDUMMY,IERR)
          CALL PXPLT3(PTRAK(1,I),SVEC(1,1),PTOUT(I),XDUMMY,IERR)
        ENDDO
      ELSE
        XP(1)= 0.0
        YP(1)= 0.0
        PTIN(1)= 0.0
        PTOUT(1)= 0.0
      ENDIF
C
C  The End:
      RETURN
      END

CDECK  ID>, MCFIMA.
      SUBROUTINE MCFIMA(VP,VH,KFLAV)
      IMPLICIT NONE
C  Routine to fill hadronisation matrices.
C  Input:   VP()    Array with observables at parton-level
C           VH()    Array with observables at hadron-level
C  Stefan Kluth, 19.1.96
C  Modifications:
C  P. Movilla Fernandez, 01.11.00: Write out arrays into a file 
C                                  Introduce flavour dependent histograming (KFLAV)
      INTEGER IP,IH,IVAR,I,KFLAV
      REAL VP(*),VH(*)
*- stuff needed for writing out into tab file
      CHARACTER CFMT*20
      LOGICAL FIRST /.TRUE./
      SAVE CFMT,FIRST
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
*-
C  Stuff for HBOOK:
      INTEGER LIMIT
      PARAMETER( LIMIT=200000 )
      REAL HMEM
      COMMON /PAWC/ HMEM(LIMIT)
      SAVE /PAWC/
C     Stuff for event shape analysis:
C     nbmax: number of bins for the histograms
C     ndimm: dimension of the XBINS array
C
      INTEGER NVAR,NBMAX,NDIMM
      PARAMETER( NBMAX=100, NDIMM=50, NVAR=6 )
      INTEGER NBMAX2
      PARAMETER( NBMAX2=1000 )  ! PMF: needed for finer binning of LINEAR y23 (D) distribution
C EEC special stuff
      INTEGER NBEEC
      REAL PIEEC
      PARAMETER( NBEEC=100, PIEEC=3.1415927 )
      REAL EEC(NBEEC),EECER(NBEEC),EECA(NBEEC/2),EECAER(NBEEC/2)
C
      INTEGER NBIN(NVAR)
      REAL XBINS(NDIMM,NVAR)
      REAL TH,MH,BT,BW,CP,Y23
      REAL TMA, TMI, OBL, SP, AC
      CHARACTER*2 CHVAR(NVAR)
      COMMON /MCEVSH/ NBIN
     &               ,TH,MH,BT,BW,CP,Y23,XBINS
     &               ,CHVAR
      SAVE /MCEVSH/
C
C PMF 12/05/00: Initialization of /MCEVSH/ is now done
C               in the BLOCK DATA subroutine 'MCEVBL'
C      DATA NBIN / 13, 12, 14, 13, 12, 15 /
C      DATA XBINS / 0.00, 0.01, 0.02, 0.03, 0.04, 0.05, 0.07, 0.09, 0.12
C     &            ,0.15, 0.22, 0.30, 0.40, 0.50, 36*0.0
C     &            ,0.00, 0.06 ,0.075,0.09, 0.11, 0.14, 0.17, 0.20, 0.25
C     &            ,0.30, 0.35, 0.45, 0.60, 37*0.0
C     &            ,0.00, 0.03, 0.04, 0.05, 0.06, 0.075,0.09, 0.11, 0.13
C     &            ,0.16, 0.20, 0.25, 0.30, 0.35, 0.40, 35*0.0
C     &            ,0.00, 0.02, 0.03, 0.04, 0.05, 0.065,0.08, 0.10, 0.15
C     &            ,0.20, 0.25, 0.30, 0.35, 0.40, 36*0.0
C     &            ,0.00, 0.05, 0.08, 0.11, 0.14, 0.18, 0.22, 0.30, 0.4
C     &            ,0.50, 0.60, 0.75, 1.00, 37*0.0
C     &            ,0.00, 0.3E-03, 0.75E-03, 0.13E-02, 0.23E-02, 0.4E-02
C     &            ,0.7E-02, 0.012, 0.0225, 0.04, 0.07, 0.13, 0.235
C     &  ,0.40, 0.70, 1.00, 34*0.0 /
C
C      DATA CHVAR / 'TH', 'MH', 'BT', 'BW', 'CP', 'D2' /
C
C
C  Fill hadronisation matrices:
      DO IVAR=1,NVAR
        IP= 0
        IH= 0
        DO I=1,NBIN(IVAR)
          IF( VP(IVAR).GE.XBINS(I,IVAR) .AND.
     &        VP(IVAR).LT.XBINS(I+1,IVAR) ) IP= I
          IF( VH(IVAR).GE.XBINS(I,IVAR) .AND.
     &        VH(IVAR).LT.XBINS(I+1,IVAR) ) IH= I
        ENDDO
        IF( IP.GT.0 .AND.          IH.GT.0 .AND.
     &      IP.LE.NBIN(IVAR) .AND. IH.LE.NBIN(IVAR)  ) THEN
          CALL HFILL(1000+(IVAR-1)*10+1,VP(IVAR),0.0,1.0)
          CALL HFILL(1000+(IVAR-1)*10+2,VH(IVAR),0.0,1.0)
* PMF 01/11/00: Introduce flavour dependent histograming for hadr. matrices
          CALL HFILL(1100+(IVAR-1)*10+6,REAL(IP),REAL(IH),1.0)
          CALL HFILL(1100+(IVAR-1)*10+KFLAV,REAL(IP),REAL(IH),1.0)
        ENDIF
      ENDDO
C
C Write out into tab file
      IF( LTAB ) THEN
        IF( FIRST ) THEN
            WRITE(CFMT,'(A,I2,A)') '(I6,1X,I1,1X,',2*NVAR,'F5.4)'
            FIRST=.FALSE.
        ENDIF
        WRITE(71,FMT=CFMT) KEVT,KFLAV,(VP(I),I=1,NVAR),(VH(I),I=1,NVAR)
      ENDIF
C
C  The End:
      RETURN
      END
CDECK  ID>, MCANAL.
      SUBROUTINE MCANAL(JFLAV,NTRAKP,NTRAKH,IDIM,PTRAKP,PTRAKH)
      IMPLICIT NONE
C  Routine to do analysis of MC 4-vectors:
C  Input: JFLAV    Quark flavour code
C         NTRAKP   Number of entries in array PTRAKP
C         NTRAKH   Number of entries in array PTRAKPH
C         IDIM     1st dimension of arrays PTRAKP,PTRAKH
C         PTRAKP() Array with parton 4-momenta
C         PTRAKH() Array with hadron 4-momenta
C  Stefan Kluth, 22.1.96
C  Modifications:
C     INTRODUCE BOOST OF THE HADRONIC SYSTEM 25.10.96  SB

C  Stuff for HBOOK:
      INTEGER LIMIT
      PARAMETER( LIMIT=200000 )
      REAL HMEM
      COMMON /PAWC/ HMEM(LIMIT)
      SAVE /PAWC/
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
C  FFREAD user variables:
      LOGICAL LFSRRM,LISRRM,LBOOS,LCONE,LDURH,LJDE0,LCAMJ,LCKRN
      INTEGER HOUTFILE(NWONAM)
      INTEGER NJTEV
      COMMON /MCUFFR/ LFSRRM,LISRRM,LBOOS, LCONE,LDURH,LJDE0,LCAMJ
     &                ,LCKRN,NJTEV,HOUTFILE
      SAVE /MCUFFR/
C     Stuff for event shape analysis:
C     nbmax: number of bins for the histograms
C     ndimm: dimension of the XBINS array
C
      INTEGER NVAR,NBMAX,NDIMM
      PARAMETER( NBMAX=100, NDIMM=50, NVAR=6 )
      INTEGER NBMAX2
      PARAMETER( NBMAX2=1000 )  ! PMF: needed for finer binning of LINEAR y23 (D) distribution
C EEC special stuff
      INTEGER NBEEC
      REAL PIEEC
      PARAMETER( NBEEC=100, PIEEC=3.1415927 )
      REAL EEC(NBEEC),EECER(NBEEC),EECA(NBEEC/2),EECAER(NBEEC/2)
C
      INTEGER NBIN(NVAR)
      REAL XBINS(NDIMM,NVAR)
      REAL TH,MH,BT,BW,CP,Y23
      REAL TMA, TMI, OBL, SP, AC
      CHARACTER*2 CHVAR(NVAR)
      COMMON /MCEVSH/ NBIN
     &               ,TH,MH,BT,BW,CP,Y23,XBINS
     &               ,CHVAR
      SAVE /MCEVSH/
      LOGICAL FIRST
      INTEGER JFLAV,NTRAKP,NTRAKH,IDIM
      REAL PTRAKP(IDIM,*),PTRAKH(IDIM,*)
      INTEGER I,IVAR,ITRAK,NTRKCH
      REAL EVIS,VP(NVAR),VH(NVAR)
      REAL PEV(5)
C
C PMF 12/05/00: Initialization of /MCEVSH/ is now done
C               in the BLOCK DATA subroutine 'MCEVBL'
C      DATA NBIN / 13, 12, 14, 13, 12, 15 /
C      DATA XBINS / 0.00, 0.01, 0.02, 0.03, 0.04, 0.05, 0.07, 0.09, 0.12
C     &            ,0.15, 0.22, 0.30, 0.40, 0.50, 36*0.0
C     &            ,0.00, 0.06 ,0.075,0.09, 0.11, 0.14, 0.17, 0.20, 0.25
C     &            ,0.30, 0.35, 0.45, 0.60, 37*0.0
C     &            ,0.00, 0.03, 0.04, 0.05, 0.06, 0.075,0.09, 0.11, 0.13
C     &            ,0.16, 0.20, 0.25, 0.30, 0.35, 0.40, 35*0.0
C     &            ,0.00, 0.02, 0.03, 0.04, 0.05, 0.065,0.08, 0.10, 0.15
C     &            ,0.20, 0.25, 0.30, 0.35, 0.40, 36*0.0
C     &            ,0.00, 0.05, 0.08, 0.11, 0.14, 0.18, 0.22, 0.30, 0.4
C     &            ,0.50, 0.60, 0.75, 1.00, 37*0.0
C     &            ,0.00, 0.3E-03, 0.75E-03, 0.13E-02, 0.23E-02, 0.4E-02
C     &            ,0.7E-02, 0.012, 0.0225, 0.04, 0.07, 0.13, 0.235
C     &  ,0.40, 0.70, 1.00, 34*0.0 /
C
C      DATA CHVAR / 'TH', 'MH', 'BT', 'BW', 'CP', 'D2' /
C
      DATA FIRST /.TRUE. /
C
C  Fill general histos:
      CALL HFILL(13,REAL(JFLAV),0.0,1.0)
      CALL HFILL(100+JFLAV,REAL(NTRAKP),0.0,1.0)
      CALL HFILL(200+JFLAV,REAL(NTRAKH),0.0,1.0)
      CALL HFILL(106,REAL(NTRAKP),0.0,1.0)
      CALL HFILL(206,REAL(NTRAKH),0.0,1.0)
C
C  Get number of charged hadrons if charge info supplied in PTRAK(6,):
      IF( IDIM.GE.6 ) THEN
        NTRKCH= 0
        DO I=1,NTRAKH
          IF( PTRAKH(6,I).NE.0.0 ) NTRKCH= NTRKCH+1
        ENDDO
        CALL HFILL(210+JFLAV,REAL(NTRKCH),0.0,1.0)
        CALL HFILL(216,REAL(NTRKCH),0.0,1.0)
        CALL HFILL(220,REAL(NTRKCH),0.0,1.0)
      ENDIF
C
C  Fill histos and store event shape results in array for partons,
C  optionally only for "light" partons:
      IF( LUDSC .AND. JFLAV.EQ.5 ) THEN
        CALL VZERO(VP,6)
      ELSE
        EVIS= 0.0
        DO ITRAK=1,NTRAKP
          EVIS= EVIS+PTRAKP(4,ITRAK)
        ENDDO
        CALL HFILL(11,EVIS,0.,1.)
        CALL MCFILL(NTRAKP,IDIM,PTRAKP,JFLAV,0)
        CALL JTFILL(0,NTRAKP,IDIM,PTRAKP)
c        CALL CTEST (0,NTRAKP,IDIM,PTRAKP)
c        CALL YTEST (0,NTRAKP,IDIM,PTRAKP)
        VP(1)= TH
        VP(2)= MH
        VP(3)= BT
        VP(4)= BW
        VP(5)= CP
        VP(6)= Y23
      ENDIF
C
C  Fill histos and store event shape results for hadrons:
      EVIS= 0.0
      DO ITRAK=1,NTRAKH
        EVIS= EVIS+PTRAKH(4,ITRAK)
      ENDDO
C     
C     BOOST TO THE CMS OF THE HADRONS
C
      IF(LBOOS) THEN
        IF(FIRST) THEN
          WRITE(*,*) '********************************'
          WRITE(*,*) '*** BOOST OF HADRONIC SYSTEM ***'
          WRITE(*,*) '********************************'
        ENDIF
        CALL VZERO(PEV,5)
        DO ITRAK=1,NTRAKH
          PEV(1)=PEV(1)+PTRAKH(1,ITRAK)
          PEV(2)=PEV(2)+PTRAKH(2,ITRAK)
          PEV(3)=PEV(3)+PTRAKH(3,ITRAK)
          PEV(4)=PEV(4)+PTRAKH(4,ITRAK)
        ENDDO
        PEV(5) = PEV(4)**2-(PEV(1)**2+PEV(2)**2+PEV(3)**2)
        IF(PEV(5).GT.0.) THEN
          PEV(5) = SQRT(PEV(5))
          CALL QQBOOS(PEV,IDIM,NTRAKH,PTRAKH)
        ELSE
          PEV(5) = 0.
          WRITE(*,*) 'NOT BOOSTED, MASS<= 0.'
        ENDIF
      ENDIF
      CALL HFILL(12,EVIS,0.0,1.0)
      CALL MCFILL(NTRAKH,IDIM,PTRAKH,JFLAV,10)
      CALL JTFILL(10,NTRAKH,IDIM,PTRAKH)
c      CALL CTEST(10,NTRAKH,IDIM,PTRAKH)
c      CALL YTEST(10,NTRAKH,IDIM,PTRAKH)
      VH(1)= TH
      VH(2)= MH
      VH(3)= BT
      VH(4)= BW
      VH(5)= CP
      VH(6)= Y23

C
C  Fill hadronisation matrices:
      CALL MCFIMA(VP,VH,JFLAV)
C
C     The End:
      FIRST = .FALSE.
      RETURN
      END
*-------------------------------------------------------------------
CDECK  ID>, JTFILL.
      SUBROUTINE JTFILL(IOFF,NTRAK,IDIM,PTRAK)
*
*     Routine to fill histograms with Jet information
*     Jet finding included for JADE E0, Durham, Cambridge
*     and Cone(R) and Cone(e)
*
*     S Bentvelsen, oct 1997
*
      IMPLICIT NONE
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
C  FFREAD user variables:
      LOGICAL LFSRRM,LISRRM,LBOOS,LCONE,LDURH,LJDE0,LCAMJ,LCKRN
      INTEGER HOUTFILE(NWONAM)
      INTEGER NJTEV
      COMMON /MCUFFR/ LFSRRM,LISRRM,LBOOS, LCONE,LDURH,LJDE0,LCAMJ
     &                ,LCKRN,NJTEV,HOUTFILE
      SAVE /MCUFFR/
      INTEGER MAXBIN
      PARAMETER (MAXBIN=200)

      INTEGER IOFF,NTRAK,IDIM,NWT,K,ID,LOC
      INTEGER NJTOT
      REAL PTRAK(IDIM,*)
      REAL HXMI,HXMA,HYMI,HYMA
      INTEGER NNY,NBIN,IERR,NJET
      INTEGER NPRINT
      CHARACTER*80 CHTOT
      REAL HX(MAXBIN),HY(MAXBIN),HEX(MAXBIN),
     &     HEY(MAXBIN)
C      REAL PJET(5,10)
      INTEGER IPASS(250),IJMUL(10)
      LOGICAL FIRST
      INTEGER IANAL

      REAL Y12,Y23,Y34,Y45,Y56
      INTEGER IJ(500)
      REAL    PJ(4,500)

      REAL PJET(10,10,10)
c      REAL YREC(10),
c	REAL YARR(20)
c      INTEGER HISTOR(2,250)
c      COMMON /YCL/YREC,PJET,HISTOR

      DATA IANAL  / 0 /
      DATA FIRST  / .TRUE. /
      DATA NPRINT / 0 /
      SAVE IANAL
      SAVE NPRINT
      SAVE FIRST

      IANAL = IANAL + 1
      IF(NJTEV.NE.-1.AND.IANAL.GT.NJTEV) RETURN

      IF(FIRST) THEN
         WRITE(*,*) '**********************************'
         WRITE(*,*) '*****    JTFILL              *****'
         WRITE(*,*) '**********************************'
         IF(NJTEV.EQ.-1) THEN
            WRITE(*,*) 'JETFINDING FOR ALL EVENTS'
         ELSE
            WRITE(*,*) 'JETFINDING FOR ',NJTEV,' EVENTS'
         ENDIF
         WRITE(*,*) 
      ENDIF



      IF(LJDE0) THEN
         ID = 1200
         CALL HGIVE(ID+1,CHTOT,NBIN,HXMI,HXMA,NNY,
     &        HYMI,HYMA,NWT,LOC)
         CALL HREBIN(ID+1,HX,HY,HEX,HEY,NBIN,1,NBIN)

         CALL YKERN(1,NTRAK,IDIM,PTRAK,IERR)
         IF(IERR.NE.0) THEN
            WRITE(*,*) 'ERROR IN JADE E0 FINDING: ',IERR
            RETURN
         ENDIF
         CALL MEANJET(IOFF,1)
         DO K=1,NBIN
            CALL YNJET(HX(K),NJET,IERR)
            IF(FIRST) WRITE(*,'(A,F10.6,I4)')
     &           'BINNING E0: ',hx(k),njet
            IF (NJET.EQ.1) NJET=2
            CALL HFILL(ID+8+IOFF,HX(K),0.,FLOAT(NJET))
            IF (NJET.GT.6) NJET=6
            IF (IERR.EQ.0) THEN
               CALL HFILL(ID+IOFF+NJET,HX(K),0.,1.)
            ELSE
               WRITE(6,*) 'ERROR IN HNJET!'
            ENDIF
            Y56 = 0.
            Y45 = 0.
            Y34 = 0.
            Y23 = 0.
            Y12 = 0.
            IF(NTRAK.GE.2) CALL YYJET(2,Y23,Y12,IERR)
            IF(NTRAK.GE.3) CALL YYJET(3,Y34,Y23,IERR)
            IF(NTRAK.GE.4) CALL YYJET(4,Y45,Y34,IERR)
            IF(NTRAK.GE.5) CALL YYJET(5,Y56,Y45,IERR)
            CALL HFILL(ID+IOFF+21,Y12,0.,1.)
            CALL HFILL(ID+IOFF+22,Y23,0.,1.)
            CALL HFILL(ID+IOFF+23,Y34,0.,1.)
            CALL HFILL(ID+IOFF+24,Y45,0.,1.)
            CALL HFILL(ID+IOFF+25,Y56,0.,1.)
         ENDDO
      ENDIF
      IF(LDURH) THEN
         ID = 1300
         CALL HGIVE(ID+1,CHTOT,NBIN,HXMI,HXMA,NNY,
     &        HYMI,HYMA,NWT,LOC)
         CALL HREBIN(ID+1,HX,HY,HEX,HEY,NBIN,1,NBIN)

         CALL YKERN(5,NTRAK,IDIM,PTRAK,IERR)
         IF(IERR.NE.0) THEN
            WRITE(*,*) 'ERROR IN JADE E0 FINDING: ',IERR
            RETURN
         ENDIF
         CALL MEANJET(IOFF,5)
         DO K=1,NBIN
            CALL YNJET(10**HX(K),NJET,IERR)
            IF(FIRST) WRITE(*,'(A,F10.6,I4)')
     &           'BINNING KT: ',hx(k),njet
            IF (NJET.EQ.1) NJET=2
            CALL HFILL(ID+8+IOFF,HX(K),0.,FLOAT(NJET))
            IF (NJET.GT.6) NJET=6
            IF (IERR.EQ.0) THEN
               CALL HFILL(ID+IOFF+NJET,HX(K),0.,1.)
            ELSE
               WRITE(6,*) 'ERROR IN HNJET!'
            ENDIF
            Y56 = 0.
            Y45 = 0.
            Y34 = 0.
            Y23 = 0.
            Y12 = 0.
            IF(NTRAK.GE.2) CALL YYJET(2,Y23,Y12,IERR)
            IF(NTRAK.GE.3) CALL YYJET(3,Y34,Y23,IERR)
            IF(NTRAK.GE.4) CALL YYJET(4,Y45,Y34,IERR)
            IF(NTRAK.GE.5) CALL YYJET(5,Y56,Y45,IERR)
            CALL HFILL(ID+IOFF+21,Y12,0.,1.)
            CALL HFILL(ID+IOFF+22,Y23,0.,1.)
            CALL HFILL(ID+IOFF+23,Y34,0.,1.)
            CALL HFILL(ID+IOFF+24,Y45,0.,1.)
            CALL HFILL(ID+IOFF+25,Y56,0.,1.)
         ENDDO
      ENDIF
      IF(LCAMJ) THEN
         ID = 1400
         CALL HGIVE(ID+1,CHTOT,NBIN,HXMI,HXMA,NNY,
     &        HYMI,HYMA,NWT,LOC)
         CALL HREBIN(ID+1,HX,HY,HEX,HEY,NBIN,1,NBIN)

         NJTOT = MIN(NTRAK,30)
         CALL CKERN(IDIM,NTRAK,PTRAK,NJTOT,IERR)
         IF(IERR.NE.0) THEN
            WRITE(*,*) 'ERROR IN CAMBRIDGE CLUSTERING: ',IERR
            RETURN
         ENDIF

         CALL MEANJET(IOFF,7)
         DO K=1,NBIN
            IF(10**HX(K).GT.1E-4) THEN
               
               CALL CNJET(10**HX(K),NJET,IERR)
C--   CALL PXCAMJ(IDIM,NTRAK,PTRAK,10**HX(K),NJET,IJ,PJ,IERR)
               IF(FIRST) WRITE(*,'(A,F10.6,I4)')
     &              'BINNING CAMJ: ',hx(k),njet
               IF(IERR.NE.0) THEN
                  IF(NPRINT.LE.50) THEN
                     WRITE(*,*) 'ERROR IN CAMBRIDGE CNJET: '
     &                    ,IERR,10**HX(K)
                     NPRINT = NPRINT + 1
                  ENDIF
                  RETURN
               ENDIF
               IF (NJET.EQ.1) NJET=2
               CALL HFILL(ID+8+IOFF,HX(K),0.,FLOAT(NJET))
               IF (NJET.GT.6) NJET=6
               IF (IERR.EQ.0) THEN
                  CALL HFILL(ID+IOFF+NJET,HX(K),0.,1.)
               ELSE
                  WRITE(6,*) 'ERROR IN HNJET!'
               ENDIF
               Y56 = 0.
               Y45 = 0.
               Y34 = 0.
               Y23 = 0.
               Y12 = 0.
               CALL HFILL(ID+IOFF+21,Y12,0.,1.)
               CALL HFILL(ID+IOFF+22,Y23,0.,1.)
               CALL HFILL(ID+IOFF+23,Y34,0.,1.)
               CALL HFILL(ID+IOFF+24,Y45,0.,1.)
               CALL HFILL(ID+IOFF+25,Y56,0.,1.)
            ENDIF
         ENDDO
      ENDIF
      IF(LCONE) THEN
         ID = 1500
         CALL HGIVE(ID+1,CHTOT,NBIN,HXMI,HXMA,NNY,
     &        HYMI,HYMA,NWT,LOC)
         CALL HREBIN(ID+1,HX,HY,HEX,HEY,NBIN,1,NBIN)

         DO K=1,NBIN
            CALL PXCONE(NTRAK,IDIM,PTRAK,HX(K),7.,10,
     &              NJET,PJET,IPASS,IJMUL,IERR)
            IF(FIRST) WRITE(*,'(A,F10.6,I4)')
     &           'BINNING CONE(R): ',hx(k),njet
            IF(IERR.NE.0) THEN
               WRITE(*,*) 'ERROR IN CONE FINDING: ',IERR
               RETURN
            ENDIF
            IF (NJET.EQ.1) NJET=2
            CALL HFILL(ID+8+IOFF,HX(K),0.,FLOAT(NJET))
            IF (NJET.GT.6) NJET=6
            IF (IERR.EQ.0) THEN
               CALL HFILL(ID+IOFF+NJET,HX(K),0.,1.)
            ELSE
               WRITE(6,*) 'ERROR IN HNJET!'
            ENDIF
         ENDDO

         ID = 1520
         CALL HGIVE(ID+1,CHTOT,NBIN,HXMI,HXMA,NNY,
     &        HYMI,HYMA,NWT,LOC)
         CALL HREBIN(ID+1,HX,HY,HEX,HEY,NBIN,1,NBIN)
         DO K=1,NBIN
            CALL PXCONE(NTRAK,IDIM,PTRAK,0.7,HX(K),10,
     &           NJET,PJET,IPASS,IJMUL,IERR)
            IF(FIRST) WRITE(*,'(A,F10.6,I4)') 
     &           'BINNING CONE(E): ',hx(k),njet
            IF(IERR.NE.0) THEN
               WRITE(*,*) 'ERROR IN CONE FINDING: ',IERR
               RETURN
            ENDIF
            IF (NJET.EQ.1) NJET=2
            CALL HFILL(ID+8+IOFF,HX(K),0.,FLOAT(NJET))
            IF (NJET.GT.6) NJET=6
            IF (IERR.EQ.0) THEN
               CALL HFILL(ID+IOFF+NJET,HX(K),0.,1.)
            ELSE
               WRITE(6,*) 'ERROR IN HNJET!'
            ENDIF
         ENDDO
      ENDIF


      FIRST = .FALSE.
      END

CDECK  ID>, YTEST.
      SUBROUTINE YTEST(IOFF,NTRAK,IDIM,PTRAK)
*
*     TESTING OF THE YKERN LIBRARY,
*	IN PARTICULAR THE PROBLEM OF NON-EXISTING JET MULTIPLICITIES IN THE
*	DURHAM FINDER
*
*     S Bentvelsen, apr 1998
*
      IMPLICIT NONE
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHMCTYP,CHEVFILE
      LOGICAL LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB
      INTEGER NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV,IDSTAB,KEVT,JADETUN
      REAL ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,JTA,JTLAMB
      COMMON /MCFFR/ 
     &     NEVNT,IMCRDM,NRTOPR,IRUN,SFLAV
     &     ,ECMASS,JTB,JTSQ,JTQ0,JTEC,JTEB,IDSTAB(50) ! PMF 27/07/00 JTEC,JTEB,IDSTAB added
     &     ,JTA,JTLAMB           ! PMF 28/05/01 JTA,JTLAMB added
     &     ,LSTBL,LUDSC,LBQRK,LISR,LFSR,LSTART,L4VEC,LTAB,KEVT ! PMF 01/11/00 LTAB,KEVT added
     &     ,JADETUN              ! PMF 10/02/01
     &     ,CHMCTYP,CHEVFILE
      SAVE /MCFFR/
C  FFREAD user variables:
      LOGICAL LFSRRM,LISRRM,LBOOS,LCONE,LDURH,LJDE0,LCAMJ,LCKRN
      INTEGER HOUTFILE(NWONAM)
      INTEGER NJTEV
      COMMON /MCUFFR/ LFSRRM,LISRRM,LBOOS, LCONE,LDURH,LJDE0,LCAMJ
     &                ,LCKRN,NJTEV,HOUTFILE
      SAVE /MCUFFR/
      INTEGER MAXBIN
      PARAMETER (MAXBIN=200)

      INTEGER IOFF,NTRAK,IDIM,IERR,NJET
      REAL PTRAK(IDIM,*)
      REAL YL, YH
      INTEGER K,KRET

      INTEGER   NCH

      DATA      NCH / 0 /
      SAVE      NCH

      IF(NCH.EQ.0) THEN
         CALL HBOOK1(3000,'kt ALL' ,50,0.,50.,0.)
         CALL HBOOK1(3001,'kt ER1' ,50,0.,50.,0.)
         CALL HBOOK1(3002,'kt ER2' ,50,0.,50.,0.)
         CALL HBOOK1(3003,'kt NE ' ,50,0.,50.,0.)

         CALL HBOOK1(4000,'jd ALL' ,50,0.,50.,0.)
         CALL HBOOK1(4001,'jd ER1' ,50,0.,50.,0.)
         CALL HBOOK1(4002,'jd ER2' ,50,0.,50.,0.)
         CALL HBOOK1(4003,'jd NE ' ,50,0.,50.,0.)
      ENDIF

      if(ioff.eq.10) then
c
c..   durham
c
         CALL YKERN(5,NTRAK,IDIM,PTRAK,IERR)
         DO K=2,MIN(NTRAK,10)
            CALL HFILL(3000,K*1.,0.,1.)
            IERR = 0
            CALL YYJET(K,YL,YH,IERR)
            IF(IERR.NE.0) CALL HFILL(3001,K*1.,0.,1.)
            IERR = 0
            CALL YNJET(YL,KRET,IERR)
            IF(IERR.NE.0) CALL HFILL(3002,KRET*1.,0.,1.)
            IF(K.NE.KRET) then
               WRITE(*,*) 'K AND KRET: ',K,KRET
               CALL HFILL(3003,K*1.,0.,1.)
            ENDIF
         ENDDO
c
c..   jade
c
         CALL YKERN(2,NTRAK,IDIM,PTRAK,IERR)
         DO K=2,MIN(NTRAK,10)
            CALL HFILL(4000,K*1.,0.,1.)
            IERR = 0
            CALL YYJET(K,YL,YH,IERR)
            IF(IERR.NE.0) CALL HFILL(4001,K*1.,0.,1.)
            IERR = 0
            CALL YNJET(YL,KRET,IERR)
            IF(IERR.NE.0) CALL HFILL(4002,KRET*1.,0.,1.)
            IF(K.NE.KRET) CALL HFILL(4003,K*1.,0.,1.)
         ENDDO
      endif
      NCH = NCH + 1
      RETURN
      END


C--------------------------------------------------------------------------
CDECK  ID>, MEANJET.
      SUBROUTINE MEANJET(IOFF,JETFINDER)
C--------------------------------------------------------------------------
C
C     MEANJET: STORE THE MEANJET VALUES FOR A LIMITED NUMBER OF EVENTS
C              IN ORDER TO DETERMINE THE STATISTICAL UNCERTAINTY ON ALPHA_S
C              FOR FITTING ALPHA_S OVER A RANGE IN MEANJET.
C              IN THIS WAY THE CORRELATIONS BETWEEN THE POINTS OF <NJET>
C              ARE TAKEN INTO ACCOUNT.
C
C     THE ROUTINE ASSUMES THAT THE JETFINDER HAS BEEN CALLED.
C
C     JETFINDER: VERSION OF THE JETFINDER
C     JETALG   : ARRAY WITH TOTAL NUMBER OF EVENTS FOR THE JETFINDER
C
C     AUGUST 10, 1998, STAN BENTVELSEN
C
C--------------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER  IOFF, JETFINDER

      CHARACTER  TIT*31
      INTEGER    NSAMPLE
      PARAMETER (NSAMPLE = 2000)
      INTEGER    JETALG(10)
      DATA       JETALG / 10*0 /
      INTEGER    HBID
      DATA       HBID   / 60000 /
      LOGICAL    FIRST
      DATA       FIRST / .TRUE. /

      INTEGER    NBIN
      INTEGER    LBIN(20)
      DATA       NBIN / 19 /
      INTEGER    I, J, ID, ID1, IERR, NJET

      REAL       XX(20),XM(19)

      INTEGER    ICURR
      DATA       ICURR / 0 /


      SAVE       HBID, ICURR, FIRST

      IF(FIRST) THEN
         FIRST = .FALSE.
         XX( 1) = .7000000E-05   
         XX( 2) = .1300000E-04   
         XX( 3) = .2256600E-04   
         XX( 4) = .4068000E-04   
         XX( 5) = .7178800E-04   
         XX( 6) = .1282120E-03   
         XX( 7) = .2274480E-03   
         XX( 8) = .4050120E-03   
         XX( 9) = .7196681E-03   
         XX(10) = .1280330E-02   
         XX(11) = .2276270E-02   
         XX(12) = .4048330E-02   
         XX(13) = .7198470E-02   
         XX(14) = .1280150E-01   
         XX(15) = .2276450E-01   
         XX(16) = .4048150E-01   
         XX(17) = .7198650E-01   
         XX(18) = .1280140       
         XX(19) = .2276460       
         XX(20) = .4048140       
         
         XM( 1) = .1000000E-04 
         XM( 2) = .1778300E-04 
         XM( 3) = .3162300E-04 
         XM( 4) = .5623400E-04 
         XM( 5) = .1000000E-03 
         XM( 6) = .1778300E-03 
         XM( 7) = .3162300E-03 
         XM( 8) = .5623400E-03 
         XM( 9) = .9999990E-03 
         XM(10) = .1778300E-02 
         XM(11) = .3162300E-02 
         XM(12) = .5623400E-02 
         XM(13) = .9999985E-02 
         XM(14) = .1778300E-01 
         XM(15) = .3162300E-01 
         XM(16) = .5623400E-01 
         XM(17) = .1000002     
         XM(18) = .1778300     
         XM(19) = .3162300     
      ENDIF

      IF(JETFINDER.LE.9.AND.JETFINDER.GT.0) THEN
C
C..   THIS ROUTINE IS CALLED FOR THE PARTON AND HADRON LEVEL
C..   CONSEQUETIVELY; ONLY COUNT THE 'PARTON LEVEL' EVENTS
C
         IF(IOFF.EQ.0) JETALG(JETFINDER) = JETALG(JETFINDER) + 1

         ID1 = HBID-10000+JETFINDER
         IF(JETALG(JETFINDER).EQ.1) THEN
C
C..   BOOK THE GLOBAL HISTOGRAMS
C
            TIT = 'TOTSAMPLE FOR JETFINDER XX'
            WRITE(TIT(25:26),'(I2)') JETFINDER+IOFF
            CALL HBOOKB(ID1   ,TIT//'PARTON NJET',NBIN,XX,0.)
            CALL HBOOKB(ID1+10,TIT//'PARTON NORM',NBIN,XX,0.)
            CALL HBOOKB(ID1+50,TIT//'HADRON NJET',NBIN,XX,0.)
            CALL HBOOKB(ID1+60,TIT//'HADRON NORM',NBIN,XX,0.)
C
C..   BOOK THE HISTOGRAMS TO CALCULATE THE CORRELATION
C
            CALL HBOOK2(ID1+100,'COV(I,J)  ',19,0.5,19.5,19,0.5,19.5,0.)
            CALL HBOOK2(ID1+101,'MEAN(I)   ',19,0.5,19.5,19,0.5,19.5,0.)
            CALL HBOOK2(ID1+102,'MEAN(J)   ',19,0.5,19.5,19,0.5,19.5,0.)
            CALL HBOOK2(ID1+111,'MEAN(I)**2',19,0.5,19.5,19,0.5,19.5,0.)
            CALL HBOOK2(ID1+112,'MEAN(J)**2',19,0.5,19.5,19,0.5,19.5,0.)
            CALL HBOOK2(ID1+110,'NTOT      ',19,0.5,19.5,19,0.5,19.5,0.)
            PRINT*,TIT
         ENDIF
         IF((JETALG(JETFINDER)/NSAMPLE).LE.100) THEN
C
C..   MAKE SUBSAMPLE HISTOGRAMS FOR THE FIRST 100 SUBSAMPLES.
C
            ID = HBID+100*(JETALG(JETFINDER)/NSAMPLE) +JETFINDER
            IF(MOD(JETALG(JETFINDER),NSAMPLE).EQ.1) THEN
C
C..   BOOK THE SUBSAMPLE HISTOGRAMS
C
               TIT = 'SUBSAMPLE XXX FOR JETFINDER XX'
               WRITE(TIT(11:13),'(I3)') JETALG(JETFINDER)/NSAMPLE
               WRITE(TIT(29:30),'(I2)') JETFINDER+IOFF
               CALL HBOOKB(ID   ,TIT//'PARTON NJET',NBIN,XX,0.)
               CALL HBOOKB(ID+10,TIT//'PARTON NORM',NBIN,XX,0.)
               CALL HBOOKB(ID+50,TIT//'HADRON NJET',NBIN,XX,0.)
               CALL HBOOKB(ID+60,TIT//'HADRON NORM',NBIN,XX,0.)
               PRINT*,TIT
            ENDIF
C
C..   FILL THE SUBSAMPLE HISTOGRAMS
C
            DO I=1,NBIN
               IF(JETFINDER.EQ.7) THEN
                  CALL CNJET(XM(I),NJET,IERR)
               ELSE
                  CALL YNJET(XM(I),NJET,IERR)
               ENDIF
               CALL HFILL(ID+5*IOFF,XM(I),0.,1.*NJET)
               IF(NJET.NE.0) THEN
                  CALL HFILL(ID+5*IOFF+10,XM(I),0.,1.)
               ENDIF
            ENDDO
         ENDIF
C
C..   FILL THE TOTSAMPLE HISTOGRAMS
C
         DO I=1,NBIN
            IF(JETFINDER.EQ.7) THEN
               CALL CNJET(XM(I),NJET,IERR)
            ELSE
               CALL YNJET(XM(I),NJET,IERR)
            ENDIF
            CALL HFILL(ID1+5*IOFF,XM(I),0.,1.*NJET)
            IF(NJET.NE.0) THEN
               CALL HFILL(ID1+5*IOFF+10,XM(I),0.,1.)
            ENDIF
            LBIN(I) = NJET
         ENDDO
C
C..   ATTEMPT TO CALCULATE THE CORRELATIONS BETWEEN THE NJET
C
         IF(IOFF.EQ.10) THEN
            DO I=1,NBIN
               DO J=1,NBIN
                  CALL HFILL(ID1+100,1.*I,1.*J,1.*LBIN(I)*LBIN(J))
                  CALL HFILL(ID1+101,1.*I,1.*J,1.*LBIN(I)        )
                  CALL HFILL(ID1+102,1.*I,1.*J,1.*        LBIN(J))
                  CALL HFILL(ID1+111,1.*I,1.*J,1.*LBIN(I)*LBIN(I))
                  CALL HFILL(ID1+112,1.*I,1.*J,1.*LBIN(J)*LBIN(J))
                  
                  CALL HFILL(ID1+110,1.*I,1.*J,1.)
               ENDDO
            ENDDO
         ENDIF
      ELSE
         PRINT*,'ERROR IN JETFINDER: ',JETFINDER
      ENDIF

      RETURN
      END

C   07/06/96 606071906  MEMBER NAME  RDDA     (S4)          FORTG1
      SUBROUTINE RDDA(NRC,NTOT,BUF)
C     BOS SUBPROGRAM  =4.6=
      COMMON/BCS/IW(1)
C   07/06/96 606071821  MEMBER NAME  CCS      (S4)          FORTG1
      COMMON/CCS/IUND,INDT,INDC,NPT,INDA,LISTE(5),IPAS
      INTEGER BUF(1610),BUFA(NTOT)
      IG=IUND-16
      GOTO (1,2,3),IG
    1 CONTINUE
*** PMF 11/10/1999
*     DEFINE FILE 17(200,1610,U,IVAR)
      OPEN(UNIT=17,ACCESS='DIRECT',RECL=1610
     +     ,FORM='UNFORMATTED',STATUS='UNKNOWN')
      NRC=1
*** PMF (END)
      GOTO 10
    2 CONTINUE
*** PMF 11/10/1999
*     DEFINE FILE 18(200,1610,U,IVAR)
      OPEN(UNIT=18,ACCESS='DIRECT',RECL=1610
     +     ,FORM='UNFORMATTED',STATUS='UNKNOWN')
      NRC=1
*** PMF (END)
      GOTO 10
    3 CONTINUE

*** PMF 11/10/1999 
*     DEFINE FILE 19(200,1610,U,IVAR)
*     10 READ(IUND'NRC) NTOT,BUF
      OPEN(UNIT=19,ACCESS='DIRECT',RECL=1610
     +     ,FORM='UNFORMATTED',STATUS='UNKNOWN')
      NRC=1
   10 READ(IUND,REC=NRC) NTOT,BUF
      NRC=NRC+1
***PMF (End)
      GOTO 100
C
      ENTRY WRDA(NRC,NTOT,BUFA)
***PMF  11/10/99
*     IF(NTOT.NE.0) WRITE(IUND'NRC) NTOT,BUFA
*     IF(NTOT.EQ.0) WRITE(IUND'NRC) NTOT,NTOT
      IF(NTOT.NE.0) THEN
         WRITE(IUND,REC=NRC) NTOT,BUFA
         NRC=NRC+1
      ENDIF
      IF(NTOT.EQ.0) THEN
         WRITE(IUND,REC=NRC) NTOT,NTOT
         NRC=NRC+1
      ENDIF
***PMF (End)
      GOTO 100
C
      ENTRY RDSQ(IUNTP,NTOT,BUFA,*)
      READ(IUNTP,END=101) NTOT,BUFA
      GOTO 100
C
      ENTRY WRSQ(IUNTP,NTOT,BUFA)
      WRITE(IUNTP) NTOT,BUFA
C
  100 RETURN
  101 RETURN 1
      END

C   24/10/79 910312212  MEMBER NAME  LGESHW   (SOURCE)      FORTRAN
      SUBROUTINE LGESHW
C
C     GET REALISTIC SHOWER ENERGY BY SUBTRACTING THE CONTRIBUTION OF
C     CHARGED PARTICLES, USING THE FOLLOWING FORMULA.
C     ESHOWER = (CLUSTER ENERGY - MIN(P,0.35))
C     AND STORE IT TO ADATA(NPCL+3) REPLACING SIG(E) AS A TEMPLALLY
C     MEASURE.
C     LAST MODIFICATION                24-10-79 Y.WATANABE
C
      IMPLICIT INTEGER *2 (H)
C
#include "cdata.for"
#include "clgwork2.for"
      COMMON /CLGMSB/ MSGVAL(5)
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
C---- CXDCHG  CONTAINS INNER TRACK INFORMATION
C     CXDCHG(9,N)     ABSOLUTE MOMENTUM IN GEV/C
C
      IF(NCLST2.LT.1) RETURN
C     SET POINTERS
      CALL BLOC(NPLG,'LGCL',1,&90)
      NPCLS=NPLG+IDATA(NPLG+3)-1
      NPCGI=NPLG+IDATA(NPLG+1)-1
      NWPCL=IDATA(NPCGI+21)
      NPCL=NPCLS-NWPCL
C
      DO 30 J=1,NCLST2
      NPCL=NPCL+NWPCL
      ESH=ADATA(NPCL+2)
      NCH=HCLLSO(1,J)
      IF(NCH.LT.1) GO TO 20
C     GO THROUGH ALL THE CHARGED PARTICLES.
C      TO TAKE CARE OF THE CASE NCH > 3.
C
      DO 10 N=1,NCHCL2
      IF(HCLIST(1,N).NE.1) GO TO 10
C      ASSUME THAT AT MOST ONE CLUSTER IS CONNECTED TO A PARTICLE.
      K=HCLIST(2,N)
      IF(K.NE.J) GO TO 10
C     SUBTRACT THE CONTRIBUTION.
      ESH=ESH-AMIN1(CXDCHG(9,N),0.35)
10    CONTINUE
C
      IF(ESH.LT.0.) ESH=0.
20    CONTINUE
      ADATA(NPCL+3)=ESH
30    CONTINUE
C
      RETURN
90    MSGVAL(3)=NPLG
      CALL LGMESG(1,2)
      RETURN
      END

C   25/06/78 601302202  MEMBER NAME  CURFIT5  (S)           FORTRAN
      SUBROUTINE CURFIT
     ,(X,Y,SIGMAY,NPTS,NTERMS,MODE,A,DELTAA,SIGMAA,FLAMDA,YFIT,CHISQR,
     , IPRO)
C      SUBROUTINE CURFIT
C
C    COPIED FROM F22YAM.UTILTYS(CURFIT). MODIFIED TO PRINT FOR DEBUGGING
C     NON CONVERGENCE SITUATION CHANGED  7.10.85  J.OLSSON
C     DSQRT ARGUMENT MADE ABSOLUTE...   30.01.86  J.OLSSON
C
C      ZWECK:
C      MAKE A LEAST-SQUAREA FIT TO A NON LINEAR FUNCTION
C      WITH A LINEARIZATION OF THE FITTING FUNCTION
C
C      USAGE:
C      CALL CURFIT(X,Y,SIGMAY,NPYS,NTERMS,MODE,A,DELTAA,
C
C        SIGMAA,FLAMDA,YFIT,CHISQR)
C      DESCRICPTION OF PARAMETERS
C
C      X           ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C      Y           ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C      SIGMAY      ARRAY OF STANDART DEVIATIONS FOR Y DATA POINTS
C      NPTS        NUMBER OF PAIRS OF DATA POINTE
C      NTERMS      NUMBER OF PARAMETERS
C      MODE        DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C                  +1 (INSTRUMENTAL) WEIGHT(I)=1./SIGMAY(I)**2
C                  0  (NO WEIGHTING) WEIGHT(I)=1.
C                  -1 (STATISTICAL) WEIGHT(I)=1./Y(I)
C      A           ARRAY OF PARAMETERS
C      DELTAA      ARRAY OF INCREMENTS FOR PARAMETER A (DERIVATION)
C      SIGMAA      ARRAY OF STANDART DEVIATIONS FOR PARAMETER A
C      FLAMDA      PROPORTION OF GRADIENT SEARCH INCLUDET
C      YFIT        ARRAY OF CALCULATED VALUES OF Y
C      CHISQR      REDUCED CHI SQUARE FOR FIT
C
C     IPRO:  PRINT STEERING. IF NONZERO, DEBUG PRINT IS PRODUCED
C
C
C      SUBROUTINES AND FUNCTIONS NEEDED
C      FUNCTN(X,I,A)
C         EVALUATES THE FITTING FUNCTION FOR THE I TH TERM
C      FCHISQ(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C         EVALUATES REDUCED CHI SQUARE FOR FIT DATA
C      FDERIV(X,I,A,DELTAA,NTERMS,DERIV)
C         EVALUATES THE DERIVATIVES OF THE FITTING FUNCTION
C         FOR THE I TH TERM WITH RESECT TO EACH PARAMETER
C         STEPWIDTHS IST DELTAA
C      MATINV(ARRAY,NTERMS,DET)
C         AND CALCULATES ITS DETERNINANT
C         INVERTS A SYMMETRIC 2 DIMENSIONAL MATRIX OF DEGREE NTERMS
C
C      COMMENTS
C      THE SUBROUTINE RETURNS AFTER EACH SUCSESSFUL STEP
C      THE MAIN PROGRAMM HAS TO CHECK CHISQR, WETHER CONVERGENZ IS REACH
C
C      NTERMS <= 10
C      SET FLAMDA = .001 AT THE BEGINNING OF SEARCH
C
C***********************************************************************
C
C
      REAL * 8 ARRAY(10,10),FLAMDA
      REAL X(1),Y(1),SIGMAY(1),A(1),DELTAA(1),SIGMAA(1),
     ,     YFIT(1), WEIGHT(300),ALPHA(15,15),BETA(15),DERIV(15),B(15)
      REAL YFITSA(300),ASAVE(10),ASISA(10)
C      NPTS <= 300
C
      IF(NTERMS.GT.10.OR.NTERMS.LT.1) GO TO 13
      IF(NPTS.GT.300) GO TO 13
      NFREE=NPTS-NTERMS
      IF(NFREE.GT.0) GO TO 20
13    CHISQR=0.
      GO TO 110
C
C         EVALUATE WEIGHTS
C
20    DO 30 I=1,NPTS
21     IF(MODE)22,27,29
22    IF(Y(I))25,27,23
23    WEIGHT(I)=1./Y(I)
      GO TO 30
25    WEIGHT(I)=1./(-Y(I))
      GO TO 30
27    WEIGHT(I)=1.
      GO TO 30
29    IF(SIGMAY(I)) 27,27,290
290   WEIGHT(I)=1./SIGMAY(I)/SIGMAY(I)
30    CONTINUE
C
C  PRINT INPUT AND CALCULATED WEIGHTS
      IF(IPRO.EQ.0) GO TO 7701
      WRITE(6,7702) NPTS,NTERMS,MODE
7702  FORMAT(' CURFIT INPUT:::  NPTS NTERMS MODE ',3I5)
      WRITE(6,7703) (A(K),K=1,NTERMS)
7703  FORMAT(' A: ',10(F10.4,1X))
      WRITE(6,7704) (DELTAA(K),K=1,NTERMS)
7704  FORMAT(' DELTAA: ',10(F10.4,1X))
      WRITE(6,7706) (X(K),K=1,NPTS)
7706  FORMAT(' X: ',10(F10.4,1X))
      WRITE(6,7707) (Y(K),K=1,NPTS)
7707  FORMAT(' Y: ',10(F10.4,1X))
      WRITE(6,7705) (SIGMAY(K),K=1,NPTS)
7705  FORMAT(' SIGMAY: ',10(F10.4,1X))
      WRITE(6,7709) (WEIGHT(K),K=1,NPTS)
7709  FORMAT(' WEIGHT: ',10(F10.4,1X))
7701  CONTINUE
C
C         EVALUATE ALPHA AND BETA MATRICES
C
31    DO 34 J=1,NTERMS
      BETA(J)=0.
      DO 34 K=1,J
34    ALPHA(J,K)=0.
41    DO 50 I=1,NPTS
      IF(IPRO.EQ.1) WRITE(6,1431) I
1431  FORMAT('   CALLING FDERIV,                  I = ',I10)
      CALL FDERIV(X,I,A,DELTAA,NTERMS,DERIV)
      FUNXIA = FUNCTN(X,I,A)
      IF(IPRO.EQ.1) WRITE(6,1461) I,X(I),FUNXIA,(A(II),II=1,NTERMS)
1461  FORMAT(' I X FUN  A.. ',I3,F8.2,E14.6,8F12.4)
      IF(IPRO.EQ.1) WRITE(6,1432) (DERIV(JK),JK=1,NTERMS)
1432  FORMAT('   DERIV: ',10(F10.4,1X))
      DO 46 J=1,NTERMS
      BETA(J)=BETA(J)+WEIGHT(I)*(Y(I)-FUNXIA)*DERIV(J)
      DO 46 K=1,J
46    ALPHA(J,K)=ALPHA(J,K)+WEIGHT(I)*DERIV(J)*DERIV(K)
50    CONTINUE
51    DO 53 J=1,NTERMS
      DO 53 K=1,J
53    ALPHA(K,J)=ALPHA(J,K)
      IF(IPRO.EQ.1) WRITE(6,7801) ((ALPHA(J,K),J=1,NTERMS),K=1,NTERMS)
7801  FORMAT(' ALPHA: ',10(F10.4,1X))
      IF(IPRO.EQ.1) WRITE(6,7802) (BETA(J),J=1,NTERMS)
7802  FORMAT(' BETA: ',10(F10.4,1X))
C
C         EVALUATE CHI SQUARE AT STARTING POINT
C
61    DO 62 I=1,NPTS
      IF(IPRO.EQ.1) WRITE(6,1311) I,X(I),(A(JJ),JJ=1,NTERMS)
1311  FORMAT(' LOOP62: I X A..',I3,F10.2,8E12.4)
62    YFIT(I)=FUNCTN(X,I,A)
63    CHISQ1=FCHISQ(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
C
C         INVERT MODIFIED CURVATURE MATRIX TO FIND NEW PARAMETERS
C
71    DO 74 J=1,NTERMS
      IF(ABS(ALPHA(J,J)).LE.1.E-30) ALPHA(J,J)=1.E-30
      DO 73 K=1,NTERMS
      IF(ABS(ALPHA(K,K)).LE.1.E-30) ALPHA(K,K)=1.E-30
73    ARRAY(J,K)=ALPHA(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
74    ARRAY(J,J)=1.D0+FLAMDA
80    CALL MATINV(ARRAY,NTERMS,DET)
81    DO 84 J=1,NTERMS
      B(J)=A(J)
      IF(IPRO.EQ.1) WRITE(6,1502) J,B(J)
1502  FORMAT(' LOOP84: J BJ ',I3,E12.4)
      DO 84 K=1,NTERMS
      IF(IPRO.EQ.1) WRITE(6,1501) J,K,BETA(K),ARRAY(J,K),ALPHA(J,J),
     $ ALPHA(K,K),B(J)
1501  FORMAT(' J K,'2I2,' BETAK ARRAYJK ALFAJJ,KK ',4E12.4,' BJ ',E12.4)
84    B(J)=B(J)+BETA(K)*ARRAY(J,K)/SQRT(ALPHA(J,J)*ALPHA(K,K))
C
C         IF CHI SQUARE INCREASED , INCREASE FLAMDA AND TRY AGAIN
C
91    DO 92 I=1,NPTS
      IF(IPRO.EQ.1) WRITE(6,1312) I,X(I),(B(JJ),JJ=1,NTERMS)
1312  FORMAT(' LOOP92: I X B..',I3,F10.2,8E12.4)
92    YFIT(I)=FUNCTN(X,I,B)
      IF(IPRO.EQ.1) WRITE(6,4803) (YFIT(I),I=1,NPTS)
4803  FORMAT(' YFIT: ',10F10.4)
93    CHISQR=FCHISQ(Y,SIGMAY,NPTS,NFREE,MODE,YFIT)
      IF(IPRO.EQ.1) WRITE(6,7803) CHISQ1,CHISQR,FLAMDA
7803  FORMAT(' CURFIT: CHISQ1,CHISQR,FLAMDA ',2E14.6,D12.4)
      IF(CHISQ1-CHISQR) 95,101,101
95    CONTINUE
C     FLAMDA=10.D0*FLAMDA
C     GO TO 71
C
C INCREASING FLAMDA DOES NOT WORK, RESTORE PREVIOUS RESULT INSTEAD.
C
      DO 1641  J1 = 1,NTERMS
      A(J1) = ASAVE(J1)
1641  SIGMAA(J1) = ASISA(J1)
      DO 1642  J2 = 1,NPTS
1642  YFIT(J2) = YFITSA(J2)
      GO TO 110
C
C         EVALUATE PARAMETERS AND UNCERTAINTIES
C
101   DO 103 J=1,NTERMS
      A(J)=B(J)
103   SIGMAA(J)=DSQRT(DABS(ARRAY(J,J))/ABS(ALPHA(J,J)))
      FLAMDA=FLAMDA/10.D0
      IF(IPRO.EQ.1) WRITE(6,7805) FLAMDA,(SIGMAA(JK),JK=1,8)
7805  FORMAT(' FLAMDA ',D12.4,' SIGAA ',8(F10.4,1X))
      IF(IPRO.EQ.1) WRITE(6,7807) (A(JK),JK=1,NTERMS)
7807  FORMAT(' NEW A: ',8(F10.4,1X))
C
C  SAVE FIT RESULT
C
      DO 1712  J1 = 1,NTERMS
      ASAVE(J1) = A(J1)
1712  ASISA(J1) = SIGMAA(J1)
      CHISQO = CHISQR
      DO 1713  J2 = 1,NPTS
1713  YFITSA(J2) = YFIT(J2)
110   CONTINUE
C
      IF(IPRO.EQ.1) WRITE(6,1714) (ASAVE(JJ),JJ=1,NTERMS)
1714  FORMAT(' ASAVE AT EXIT ',8E12.4)
      IF(IPRO.EQ.1) WRITE(6,1715) (ASISA(JJ),JJ=1,NTERMS)
1715  FORMAT(' ASISA AT EXIT ',8E12.4)
      IF(IPRO.EQ.1) WRITE(6,1716) (YFITSA(JJ),JJ=1,NPTS)
1716  FORMAT(' YFITSA EXIT ',10F10.2)
C
      RETURN
      END

C   12/03/84 508071656  MEMBER NAME  BLNUMB   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BLNUMB
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON PREHISTORY :  DRAW LG BLOCK NUMBERS
C
C        MOD: J. OLSSON    7/10/83 :
C        MOD: A. FINCH    12/03/84 :  CONFORM WITH TAGGING CHANGES
C        MOD: J. NYE      22/06/84 :  CALLS TAGMRK
C   LAST MOD: C. BOWDERY   7/08/85 :  NEW TAGG NAMES
C
C        WRITE BLOCK NUMBER OF LEAD GLASS CYLINDER AND ENDCAPS
C        ALSO HANDLES TAGGING LG / PB-SCINTILLATOR
C        ONLY BLOCKS WITH PULSE HEIGHT ARE CONSIDERED
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
#include "cgeo2.for"
#include "cgeo3.for"
#include "cwktag.for"
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CJTRIG / PI,TWOPI,PIHALF
C
C                        NPBPED REFERS TO 1979-80 TAGGING APPARATUS
C
      DIMENSION NPBPED(2),WFACT(4)
C
      DATA WFACT/-.25,-.75,.75,.25/
      DATA FACTFW/1.5/
      DATA NPBPED /500,50/
C
C------------------  C O D E  ------------------------------------------
C
C
      IF ( LASTVW .NE. 13 ) GOTO 4
C--------------ROLLED OUT VIEW ------------ TOKYO LEADGLASS NUMBERS
      IF ( ABS(XMAX-XMIN) .GT. 5000. ) GOTO 44
      IPJ = IDATA(IBLN('ALGN'))
      IF ( IPJ .LE. 0 ) GOTO 4
      NWO = IDATA(IPJ)
      IF ( NWO .LE. 3 ) GOTO 4
      IPJ = 2*IPJ
      NI = IPJ + 7
94    NO = HDATA(NI)
      NI = NI + 1
C  ENERGY TO BE REGISTERED
      IE = HDATA(NI)
      IF ( IE .LT. 1 ) GOTO 75
      CALL XYBLK(NO,X1,Y1,DXEB,DYEB)
      Y1=Y1-5. + DYEB - DYEB*.185
      CALL NUMBWR(-1,NO,X1,Y1,.185*DYEB)
75    NI = NI + 1
      IF ( NI .LE. (IPJ + 2 * NWO) ) GOTO 94
      GOTO 4
      ENTRY BLNMFW
C
C
C------------- FW VIEW -------------------- FORWARD DETECTOR LEAD GLASS
C
C
      IF ( ABS( XMAX - XMIN ) .GT. 5000.0 ) GOTO 44
      IPNTR = IDATA( IBLN( 'ATAG' ) )
      IF ( IPNTR .LT. 1 ) GOTO 4
      ADDX = 0.25 * ( XMAX - XMIN )
      SH3  = 0.20 * FENDC
C AJF WAS HERE - USE TAGINT FOR CONSISTENCY
C AND SO CAN USE MC DATA
C JMN WAS HERE - USE TAGMRK FOR CONSISTENCY
       CALL TAGINT(*4)
C      CALL TAGMRK(*4)
      IF ( MARK .EQ. 2 ) GOTO 2000
C
C
C----------------------------------------1979-82 DETECTORS ONLY---------
C
C
C
C TAGGING DETECTOR 1979-82, LEAD GLASS IN TWO CONFIGURATIONS
C
      IRUN = 1
C NO PROVISION FOR THIS FOR MC DATA
      IF ( HEAD(18) .GT. 2781 ) IRUN = 2
      IF ( IMC .EQ. 1 ) IRUN = 1
      NTAGK=96
      IF ( MARK .EQ. 1 ) NTAGK = 31
      IF ( MARK .EQ. 1 ) GOTO 1000
C
C
C----------------------------------------1979/80 DETECTOR  ONLY---------
C
C
C
C 1979-80 TAGGING SET-UP
C
      IADD=2*IPNTR+6
      IFLUMI = IADD + HDATA( IADD - 1 )
  200 CONTINUE
      IADD=IADD+1
      IF ( IADD .GE. IFLUMI ) GOTO 4
      NB=HDATA(IADD)
      IADD=IADD+1
      IF ( NB .EQ. 0 ) GOTO 200
      IF ( NB .GT.  46 .AND. NB .LT.  49 ) GOTO 200
      IF ( NB .GT.  94 .AND. NB .LT.  97 ) GOTO 200
      IF ( NB .GT. 142 .AND. NB .LT. 145 ) GOTO 200
      IF ( NB .GT. 190 ) GOTO 200
      HPH=HDATA(IADD)
      HPH = HPH - NPBPED(IRUN)
      IF ( HPH .LE. 0 ) GOTO 200
      IZ = -1
      IF ( NB .GT. IENDMZ ) IZ = 1
C GET CENTER COORDINATES OF BLOCK
      CALL XYTAG(NB,XTAG,YTAG,SLOPE)
      ADX = - ADDX
      ADY = 0.
      IF ( IZ .EQ. 1 ) ADX=ADDX
      SIGN = 1.
      IF ( LASTVW .EQ. 12 ) SIGN = -1.
      X1=SIGN*XTAG+ADX-0.40*FENDC
      Y1=YTAG+ADY-0.40*FENDC
      Y1=Y1-5. + FENDC*.660
      CALL NUMBWR(-1,NB,X1,Y1,.185*FENDC)
      GOTO 200
C
C
C----------------------------------------1981/82 DETECTOR  ONLY---------
C
C
C
C 1981-82 TAGGING SET-UP
C
 1000 CONTINUE
C              FILL CATAG ARRAY
C     CALL TAGINT(*4)
      CALL TAGMRK(*4)
      CALL TAGADC(0,*4)
      CALL TAGPED
      CALL TAGKAL(0)
C
      DO 334  NB = ISTMZ,IENDPZ
      IF ( CATAG(NB) .LT. 1. ) GOTO 334
      IZ = -1
      IF ( NB .GT. IENDMZ ) IZ = 1
C GET CORNER COORDINATES OF UNIT
      INB = NB-1
      CALL XYTAG(INB,XTAG,YTAG,SLOTAG)
      ADX = -ADDX
      ADY = 0.
      IF ( IZ .EQ. 1 ) ADX = ADDX
      SIGN = 1.
      IF ( LASTVW .EQ. 12 ) SIGN = -1.
      X1=XTAG*SIGN + ADX
      Y1=YTAG+ADY
      IPH = CATAG(NB)
      IF ( IPH .LE. 0 ) GOTO 334
      X1=SIGN*XTAG+ADX-0.40*FENDC
      Y1=YTAG+ADY-0.40*FENDC
      Y1=Y1-5. + FENDC*.660
      CALL NUMBWR(-1,INB,X1,Y1,.185*FENDC)
334   CONTINUE
C
      GOTO 4
C
C
C----------------------------------------1983    DETECTOR  ONLY---------
C
C
C
C 1983-.. TAGGING SET-UP
C
 2000 CONTINUE
C              FILL CATAG ARRAY
      CALL TAGMRK(*4)
C     CALL TAGINT(*4)
      CALL TAGADC(0,*4)
      CALL TAGPED
      CALL TAGKAL(0)
C     NTAGK = 24
      DFI = PI*.25
      DDFI = DFI*.75
C
      DO 551  NB = ISTMZ,IENDPZ
      IF ( CATAG(NB) .LT. 1. ) GOTO 551
      IZ = -1
      IF ( NB .GT. IENDMZ ) IZ = 1
C GET CORNER COORDINATES OF UNIT
C     CALL XYTAG(NB,XTAG,YTAG,SLOPE)
C   K GIVES LAYER NUMBER, L SERIAL 1 TO 8
      KNB = NB
      IF ( IZ .GT. 0 ) KNB = KNB - IENDMZ
      K = (KNB-1)/8 + 1
      L = KNB - (K-1)*8
      FISTRT = - FLOAT(IZ)*PIHALF
      IF ( IZ .GT. 0 ) GOTO 8021
C  MINUS Z  ENDCAP
      IF ( L .GT. 2 .AND. L .LT. 7 ) GOTO 8022
C UPPER HALF
      FI = FISTRT + (L-1)*DFI + DDFI
      RFI = PBSCR(K+1) - 1.4*SH3
      IF ( K .EQ. 3 ) RFI = RFI - SH3
      GOTO 8030
8022  CONTINUE
C LOWER HALF
      FI = FISTRT + L*DFI - DDFI
      RFI = PBSCR(K) + .5*SH3
      GOTO 8030
8021  CONTINUE
C  PLUS Z  ENDCAP
      IF ( L .GT. 2 .AND. L .LT. 7 ) GOTO 8024
C LOWER HALF
      FI = FISTRT + L*DFI - DDFI
      RFI = PBSCR(K) + .5*SH3
      GOTO 8030
8024  CONTINUE
C UPPER HALF
      FI = FISTRT + (L-1)*DFI + DDFI
      RFI = PBSCR(K+1) - 1.4*SH3
      IF ( K .EQ. 3 ) RFI = RFI - SH3
8030  CONTINUE
      LL = L - ((L-1)/4) * 4
      SLOPE = WFACT(LL)*PIHALF
      RFI = FACTFW*RFI
      XTAG = RFI*COS(FI)
      YTAG = RFI*SIN(FI)
      ADX = -ADDX
      ADY = 0.
      IF ( IZ .EQ. 1 ) ADX = ADDX
      SIGN = 1.
      IF ( LASTVW .EQ. 12 ) SIGN = -1.
      X1=XTAG*SIGN + ADX
      Y1=YTAG+ADY
C
C  FOLLOWING CODES RESTORES HARDWARE ADRESS FROM ARRAY NR 1-48
C
      IF ( NB .GE.  1 .AND. NB .LE.  8 ) INB = NB + 3
      IF ( NB .GE.  9 .AND. NB .LE. 16 ) INB = NB + 11
      IF ( NB .GE. 17 .AND. NB .LE. 24 ) INB = NB + 19
      IF ( NB .GE. 25 .AND. NB .LE. 32 ) INB = NB + 27
      IF ( NB .GE. 33 .AND. NB .LE. 40 ) INB = NB + 35
      IF ( NB .GE. 41 .AND. NB .LE. 48 ) INB = NB + 43
      CALL DNUM(INB,X1,Y1,SH3,SLOPE)
551   CONTINUE
C
      GOTO 4
44    WRITE(6,444)
444   FORMAT(' MAGNIFICATION NOT ENOUGH...')
4     RETURN
      END

C   16/11/82 606091755  MEMBER NAME  JVDTIM   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JVDTIM( X1, X2, FOUND, DIST, SLOPE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN  16/11/82 :  CALCULATES MINIMUM DRIFT DISTANCE
C             R. RAMCKE
C
C        CALCULATES MINIMUM DRIFT DISTANCE DIST OF A POINT BETWEEN X1
C        AND X2 FROM ORIGIN. IF FOUND IS TRUE POINT BELONGS TO THIS
C        DRIFT SPACE. SLOPE IS SLOPE OF TRACK IN THIS SPACE.
C-----------------------------------------------------------------------
C
      LOGICAL FOUND
C
      COMMON / CJVDAT / XSLOPV, YSLOPV, XLV, XHV,
     *                  SV, SV2, TANLOR
C
      DIMENSION X1(2),X2(2)
C
C------------------------  C O D E  ------------------------------------
C
      SLOPE = 1.E5
      FOUND = .FALSE.
C
C        ----- RETURN IF BOTH POINTS ARE NOT IN THIS CELL  -----
      IF(  ( -SV .GT. X1(1) .OR. X1(1) .GT. SV ) .AND.
     *     ( -SV .GT. X2(1) .OR. X2(1) .GT. SV ) ) RETURN
C
      FOUND = .TRUE.
      XLOW = AMAX1( AMIN1( X1(1), X2(1) ), -SV )
      XHIGH = AMIN1( AMAX1( X1(1), X2(1) ), SV )
      DELTAX = X2(1) - X1(1)
      DELTAY = X2(2) - X1(2)
      D12 = X1(1)*X1(1) + X1(2)*X1(2)
      D22 = X2(1)*X2(1) + X2(2)*X2(2)
C
      IF( D12 .LE. SV2 .OR. D22 .LE. SV2 ) GO TO 200
C             POINTS ARE NOT IN INNER CIRCLE WITH RADIUS SV.
C
          IF( ABS( DELTAX ) .LE. 1.0E-5 ) GO TO 100
C                 POINTS ARE NOT TOO CLOSE TOGETHER.
C
C               ----- PART FOR EXPLICIT MINIMIZATION
                  SLOPE = DELTAY / DELTAX
                  YITCPT = X1(2) - SLOPE*X1(1)
                  XMIN = -SV * SLOPE / SQRT( 1. + SLOPE*SLOPE )
                  DIST = ABS( SLOPE*XMIN+YITCPT )
C
C                   CHOOSE CORECT SIGN FOR XMIN
                            DIST1 = ABS( -SLOPE*XMIN+YITCPT )
                            IF( DIST1 .GT. DIST ) GO TO  20
                            XMIN = - XMIN
                            DIST = DIST1
   20            XMIN = AMAX1( AMIN1( XMIN, XHIGH ), XLOW )
                 DIST = ABS( SLOPE*XMIN+YITCPT )
     *                       - SQRT( SV2 - XMIN*XMIN ) + SV
                 RETURN
C
C
C              ----- TAKE ONE OF THE POINTS AS MINIMAL DISTANCE
  100 DIST = AMIN1( ABS(X1(2)) + SV - SQRT( AMAX1(SV2-X1(1)*X1(1),0.) ),
     *              ABS(X2(2)) + SV - SQRT( AMAX1(SV2-X2(1)*X2(1),0.) ))
           RETURN
C
C              ----- MINIMIZE EUCLIDEAN DISTANCE
  200 DIST = SQRT( AMIN1( D12, D22 ) )
      IF( ABS( DELTAX ) .LE. 1.0E-5 ) RETURN
C
C              ----- EXPLICIT MINIMIZATION
                SLOPE = DELTAY / DELTAX
                YITCPT = X1(2) - SLOPE*X1(1)
                XMIN = -SLOPE * YITCPT / (1.0 + SLOPE*SLOPE)
                IF( XLOW .GT. XMIN .OR. XMIN .GT. XHIGH ) RETURN
                DIST = AMIN1( DIST, ABS(YITCPT)/SQRT(1.+SLOPE*SLOPE) )
C
      RETURN
      END

C   03/09/79 001141517  MEMBER NAME  REPACK   (JADPRIVS)    FORTRAN
      SUBROUTINE REPACK(IER)
C---  FILL ANALYSIS RESULTS INTO BOS-BANKS
C---  OUTPUT BANKS: 'ACLS' AND 'TAGG'
C
C     H.WRIEDT        15.03.79      19:00
C     LAST MODIFICATION       14.01.80        15:20
C
      IMPLICIT INTEGER*4 (G), INTEGER*2 (H)
C
      EXTERNAL BDLM
C
      COMMON /BCS/ IDATA(30000)
      DIMENSION HDATA(60000), RDATA(30000)
      EQUIVALENCE (HDATA(1),IDATA(1),RDATA(1))
C
      DIMENSION HID(2)
      EQUIVALENCE (ID,HID(1))
C
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),HGGADC(2,192),IWORK2(263),
     &               HINF(54),RINF(7),IWORK3(16),GCLMAP(51),
     &               CLSPRP(13,51),IWORK4(16),GLUMON(10),IWORK5(10),
     &               TRACK(10,51)
C
      DIMENSION GGADC(195)
      EQUIVALENCE (GGADC(4),HGGADC(1,1))
C
      INTEGER MOUTI(34)
      EQUIVALENCE (MOUTI(1),HINF(1))
C
      INTEGER MOUTC(663)
      EQUIVALENCE (MOUTC(1),CLSPRP(1,1))
C
      INTEGER MOUTT(510)
      EQUIVALENCE (MOUTT(1),TRACK(1,1))
C
      COMMON /CDATUM/ HDATE
C
      COMMON /CMSGCT/ MSGDUM(21),NGGMSG(16)
C
      COMMON /CGGVRN/ NVRSN(20)
      DATA NVCODE/480011415/
C
      NVRSN(14) = NVCODE
C---  PROGRAM IDENTIFIER
C---  VERSION NO. (4 AT THE MOMENT)
      HID(1) = 4
C---  DATE
      HID(2) = HDATE
C
C---  CREATE ACLS
      NDATA = LNG + 1
      CALL BCRE(IND,'ACLS',0,NDATA,&100,IER)
      CALL BSAW(1,'ACLS')
C---  TRANSFER DATA INTO ACLS
      GGADC(1) = ID
      CALL BSTR(IND,GGADC,NDATA)
C
C---  CREATE TAGG/0
      CALL BCRE(IND,'TAGG',0,34,&110,IER)
      CALL BSAW(1,'TAGG')
C---  TRANSFER DATA INTO TAGG/0
      MOUTI(1) = ID
C---  HWORD(1): NUMBER OF WORDS USED PER CLUSTER FOR THE CLUSTER
C               INFORMATION (13, AT PRESENT)
      HINF(53) = 13
C---  HWORD(2): NUMBER OF WORDS USED PER TRACK FOR THE TRACK INFORMATION
C               (10, AT PRESENT)
      HINF(54) = 10
      CALL BSTR(IND,MOUTI,34)
      IF (HINF(6).EQ.0) GOTO 3
C---  CREATE TAGG/1
      NTAGG1 = HINF(6)
      CALL BCRE(IND,'TAGG',1,NTAGG1,&111,IER)
C---  TRANSFER DATA INTO TAGG/1
      CALL BSTR(IND,GCLMAP,NTAGG1)
C---  CREATE TAGG/2
      NTAGG2 = HINF(6)*HINF(53)
      CALL BCRE(IND,'TAGG',2,NTAGG2,&112,IER)
C---  TRANSFER DATA INTO TAGG/2
      CALL BSTR(IND,MOUTC,NTAGG2)
C---  CREATE TAGG/3
    3 CALL BCRE(IND,'TAGG',3,10,&113,IER)
C---  TRANSFER DATA INTO TAGG/3
      CALL BSTR(IND,GLUMON,10)
      IF (HINF(3).EQ.0) GOTO 5
C---  CREATE TAGG/4
      NTAGG4 = HINF(3)*HINF(54)
      CALL BCRE(IND,'TAGG',4,NTAGG4,&114,IER)
C---  TRANSFER DATA INTO TAGG/4
      CALL BSTR(IND,MOUTT,NTAGG4)
C
    5 RETURN
C
C---  NOT ENOUGH SPACE
  100 NGGMSG(11) = NGGMSG(11) + 1
      RETURN
C
  110 NGGMSG(12) = NGGMSG(12) + 1
      RETURN
  111 NGGMSG(13) = NGGMSG(13) + 1
      RETURN
  112 NGGMSG(14) = NGGMSG(14) + 1
      RETURN
  113 NGGMSG(15) = NGGMSG(15) + 1
      RETURN
  114 NGGMSG(16) = NGGMSG(16) + 1
      RETURN
      END

C   19/06/86 807251811  MEMBER NAME  EVTAX    (S)           FORTRAN
      SUBROUTINE EVTAX(EAXIS,EOUT,SPHITY,XMASS,IERR)
C-----------------------------------------------------------------
C     VERSION OF 19.06.86                   R.RAMCKE
C     FINDS THE EVT-AXIS IN MC-EVENTS
C     MOD 02.02.87                          R.RAMCKE
C     CALCULATES TRANSVERS MASS OF INITAL PARTONS
C
C-----------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      COMMON / CKOPP / HKOPP(100)
C
      DIMENSION EAXIS(3),EOUT(3),P(4,10),T(6),R(9)
      DIMENSION SPHITY(3)
      DATA IPR / -1 /
C
      IF(HKOPP(10) .LT. 100) GOTO 1
         IERR = -1
         RETURN
 1    CONTINUE
C
      IPALL = IDATA(IBLN('PALL'))
      IF(IPALL .GT. 0) GOTO 2
         IERR = -2
         RETURN
 2    CONTINUE
C
      NALL = IDATA(IPALL+4)
      IERR = -3
      IF(NALL .LE. 0) GOTO 100
      L1 = IDATA(IPALL+1)
      L2 = IDATA(IPALL+2)
      IPALL = IPALL + L1 + NALL*L2
      NINAT = 0
C
      IPR = IPR - 1
      IF(IPR .GT. 0) WRITE(6,744)
 744  FORMAT(/'  ---- LAST PARTICLES OF PALL -------')
C
      DO 30 I = 1,NALL
         IPALL = IPALL - L2
         IF(IDATA(IPALL+9) .NE. -2 .AND.
     *      IDATA(IPALL+9) .NE. -100) GOTO 35
C
            IF(IPR .GT. 0) WRITE(6,745) IDATA(IPALL+9),
     *                                  (ADATA(IPALL+II),II=1,5)
 745        FORMAT('  TYP: ',I4,'  PX,PY,PY,E,M: ',5F9.3)
C
         NINAT = NINAT + 1
         P(1,NINAT) = ADATA(IPALL+1)
         P(2,NINAT) = ADATA(IPALL+2)
         P(3,NINAT) = ADATA(IPALL+3)
         P(4,NINAT) = ADATA(IPALL+4)
C
 30   CONTINUE
 35   CONTINUE
      IERR = -4
      IF(NINAT .LE. 0) GOTO 100
C                                      CALC SPHERICITY
      DO 50 I = 1,6
 50      T(I) = 0.0
C
      DO 70 J=1,NINAT
         T(1) = T(1) + P(2,J)*P(2,J) + P(3,J)*P(3,J)
         T(2) = T(2) - P(1,J)*P(2,J)
         T(3) = T(3) + P(1,J)*P(1,J) + P(3,J)*P(3,J)
         T(4) = T(4) - P(1,J)*P(3,J)
         T(5) = T(5) - P(2,J)*P(3,J)
         T(6) = T(6) + P(1,J)*P(1,J) + P(2,J)*P(2,J)
   70 CONTINUE
C
      CALL EIGEN( T, R, 3, 0 )
C
      SUM = T(1) + T(3) + T(6)
      SPHITY(1) = 3.* T(6) / SUM
      SPHITY(2) = 3.* T(3) / SUM
      SPHITY(3) = 3.* T(1) / SUM
C
      EAXIS(1) = R(7)
      EAXIS(2) = R(8)
      EAXIS(3) = R(9)
      EOUT(1) = R(1)
      EOUT(2) = R(2)
      EOUT(3) = R(3)
C
      IECM = 2*HKOPP(29)
      ECM = FLOAT(IECM)/1000.
      IF(ECM .LE. 0) ECM = 44.4
      EVIS = 0.
C
      SUM = 0.0
      DO 200 I = 1,NINAT
         PABS = SQRT(P(1,I)**2+P(2,I)**2+P(3,I)**2)
         EX = P(1,I)/PABS
         EY = P(2,I)/PABS
         EZ = P(3,I)/PABS
         SUM  = SUM+P(4,I)*ABS(EX*R(1)+EY*R(2)+EZ*R(3))
         EVIS = EVIS + P(4,I)
         IF(IPR .GT. 0)WRITE(6,779) SUM,EVIS,EX,EY,EZ,(P(JJ,I),JJ=1,3)
 779     FORMAT(' SUM,EVIS,EX,Y,X,PX,Y,Z: ',8F9.2)
 200  CONTINUE
C                                   JETMASSE
      XMASS = SUM * ECM / EVIS
C
      IERR = 0
      IF(IPR .LE. 0) RETURN
         WRITE(6,788) HKOPP(11),NINAT,(EAXIS(II),II=1,3),XMASS,SPHITY(1)
 788     FORMAT('  EVT: ',I5,' #INPA: ',I3,'  ',
     *             3F9.3,' MT,SPH: ',2F9.3)
         WRITE(6,789) (EOUT(II),II=1,3),SPHITY(3)
 789     FORMAT('  EOUT: ',3F9.3,'  SPH: ',F9.3)
         RETURN
C
 100  CONTINUE
      RETURN
      END

C   06/12/79 002051550  MEMBER NAME  ANO162   (S)           FORTRAN
      SUBROUTINE ANO162(IRUN)
C---  ANOMALIES OF RUNS 2448 - 2520
C---  6.0 GEV      NOVEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     05.02.80     15:45
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (2448,2449,2450,2451,2452,2453,2454,2455,2456,2457,2458,
     &      2459,2460,2461,2462,2463,2464,2465,2466,2467,2468,2469,
     &      2470,2471,2472,2473,2474,2475,2476,2477,2478,2479,2480,
     &      2481,2482,13,2484,2485,2486,2487,2488,2489,2490,2491,2492,
     &      2493,2494,2495,2496,13,2498,2499,2500,2501,2502,2503,2504,
     &      2505,13,2507,2508,2509,2510,2511,2512,2513,2514,2515,2516,
     &      2517,2518,2519,2520),IRUN
   13 RETURN
C
 2448 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2449 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2450 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2451 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2452 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2453 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2454 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2455 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2456 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2457 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 2458 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2459 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2460 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2461 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2462 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2463 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2464 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2465 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(183) = -1
      LIMIT(183) = 135
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2466 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(138) = +1
      LIMIT(138) = 345
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
 2467 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(5) = +1
      LIMIT(5) = 360
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(183) = -1
      LIMIT(183) = 135
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2468 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2469 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2470 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(35) = +1
      LIMIT(35) = 375
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2471 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2472 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2473 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2474 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2475 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2476 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2477 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(146) = .TRUE.
C
      RETURN
C
 2478 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2479 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(33) = +1
      LIMIT(33) = 300
      KCONST(34) = +1
      LIMIT(34) = 390
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(118) = +1
      LIMIT(118) = 270
      KCONST(129) = +1
      LIMIT(129) = 225
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2480 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2481 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2482 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(146) = .TRUE.
C
      RETURN
C
 2484 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2485 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2486 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2487 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2488 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(42) = +1
      LIMIT(42) = 315
      KCONST(51) = +1
      LIMIT(51) = 360
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
 2489 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 135
C
      LTHRES(154) = .TRUE.
C
      RETURN
C
 2490 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2491 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2492 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2493 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
 2494 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
 2495 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2496 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2498 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(122) = +1
      LIMIT(122) = 225
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
 2499 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(36) = +1
      LIMIT(36) = 345
      KCONST(43) = +1
      LIMIT(43) = 315
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(139) = +1
      LIMIT(139) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2500 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2501 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(62) = +1
      LIMIT(62) = 375
      KCONST(72) = +1
      LIMIT(72) = 360
      KCONST(73) = +1
      LIMIT(73) = 405
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2502 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(101) = +1
      LIMIT(101) = 300
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2503 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2504 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2505 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2507 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(61) = +1
      LIMIT(61) = 375
      KCONST(122) = -1
      LIMIT(122) = 150
      KCONST(157) = +1
      LIMIT(157) = 240
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(122) = .TRUE.
C
      RETURN
C
 2508 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(52) = +1
      LIMIT(52) = 390
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2509 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2510 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2511 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(52) = +1
      LIMIT(52) = 390
      KCONST(67) = +1
      LIMIT(67) = 180
      KCONST(122) = +1
      LIMIT(122) = 225
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2512 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2513 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2514 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(24) = +1
      LIMIT(24) = 390
      KCONST(120) = +1
      LIMIT(120) = 330
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2515 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(130) = +1
      LIMIT(130) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2516 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2517 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2518 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2519 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2520 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
      END

C   06/02/87 807251153  MEMBER NAME  TPTGT1   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTGT1( IB, ITRACK, LAST, MODVTX, IER )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery        6/02/87:  Add 1 tagg track to new TPTR
C              A. Finch
C
C          mod: C. Bowdery      11/01/88:  SETSL--> VZERO
C     Last mod: C. Bowdery      25/07/88:  Add extra argument
C
C     Routine to copy information about one tagging cluster to a new
C     TPTR bank.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     IB       In        I*4      Pointer into TAGG/2 bank
C     ITRACK   In        I*4      Current cluster/track number
C     LAST     In / Out  I*4      Current last TPTR bank number
C     MODVTX   In        I*4      Vertex info from TPVX/1 bank
C     IER           Out  I*4      Error code from CCRE (0 = ok)
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      PARAMETER  ( NW = 40, NW2 = 2*NW )

      DIMENSION  IW( NW ), AW( NW ), HW( NW2 )

      EQUIVALENCE  ( IW(1), AW(1) ), ( IW(1), HW(1) )

C------------------  C O D E  ------------------------------------------

C                            Clear the work array IW

             CALL VZERO( IW, NW )

C                            Fill in the work array from TAGG/2

             CALL TPTGCY( ITRACK, IB, IW, AW, HW )

C                            Add in vertex info from TPVX/1

             HW(17) = MODVTX

C                            Create a new TPTR bank

             LAST   = LAST + 1

             CALL CCRE( NPTR, 'TPTR', LAST, NW, IER )

             IF( IER .NE. 0 ) RETURN

             CALL BSTR( NPTR, IW, NW )

             RETURN
             END

C   12/12/83 501241436  MEMBER NAME  LUDECYSP (S)           FORTRAN77
      SUBROUTINE LUDECY(IP)
C-----------------------------------------------------------
C   LAST MOD 24/01/85  E ELSEN
C   VERSION TO FORCE SEMILEPTONIC DECAYS OF ONE QUARK BRANCH
C-----------------------------------------------------------
C
C
C     ROUTINE CHANGED BY A. PETERSEN TO INCLUED DECAY VERTEX AND CODING
C     CH:310,12310,16120,16130,16140,16160,16170,16810
C     11710-11750
C
      COMMON /LUJETS/ N,K(250,2),P(250,5)
       COMMON /LUJET1/ JB(250),VERTX(250,4)
      COMMON /LUDAT1/ MST(20),PAR(20),FPAR(40)
      COMMON /LUDAT2/ KTYP(120),PMAS(120),PWID(60),KFR(80),CFR(40)
      COMMON /LUDAT3/ DPAR(20),IDB(120),CBR(300),KDP(1200)
      DIMENSION IFLO(4),IFL1(4),PV(10,5),RORD(10),U(3),BE(3)
C
      COMMON / CRDLUD / LDPRM(8)
      LOGICAL FIRST /.TRUE./

C...FUNCTIONS : MOMENTUM IN TWO-PARTICLE DECAYS AND FOUR-PRODUCT
      PAWT(A,B,C)=SQRT((A**2-(B+C)**2)*(A**2-(B-C)**2))/(2.*A)
      FOUR(I,J)=P(I,4)*P(J,4)-P(I,1)*P(J,1)-P(I,2)*P(J,2)-P(I,3)*P(J,3)

      IF( FIRST ) THEN
         FIRST = .FALSE.
         READ(5,9101) LDPRM
 9101    FORMAT(20X,8I3)
         DO 10 I=1,8
            IF( IABS(LDPRM(I)).GT.1 ) LDPRM(I)=LDPRM(I)/IABS(LDPRM(I))
   10    CONTINUE
         WRITE(6,9102) LDPRM
 9102    FORMAT(' -----------------------------------------------'/
     *          ' | LUDECY: SPECIAL VERSION                     |'/
     *          ' |         FORCING SEMIELECTRONIC DECAY OF     |'/
     *          ' |         PRIMARY QUARKS                      |'/
     *          ' |         LDPRM:',8I3,6X,'|'/
     *          ' -----------------------------------------------')
      ENDIF
      IDLOOP = 0
C
C
C...CHOOSE DECAY CHANNEL
      KFA=IABS(K(IP,2))
      KFS=ISIGN(1,K(IP,2))
  100 RBR=RANF(0)
      IF(KFA.LE.100) THEN
      IDC=IDB(KFA)-1
      ELSE
      CALL LUIFLV(KFA,IFLA,IFLB,IFLC,KSP)
      IDC=IDB(76+5*IFLA+KSP)-1
      ENDIF
  110 IDC=IDC+1
      IF(RBR.GT.CBR(IDC)) GOTO 110


C
C                                 Modification for semielectronic decays
      KFF = K(IP,2)*LDPRM(5)
      IF( LDPRM(5).EQ.0  .OR.
     *    ( (101 .GT. KFF .OR. KFF .GT. 104) .AND.
     *      (145 .GT. KFF .OR. KFF .GT. 158) .AND.
     *      (241 .GT. KFF .OR. KFF .GT. 246) .AND.
     *      (293 .GT. KFF .OR. KFF .GT. 307)
     *  ) )  GOTO 10021
         IDLOOP = IDLOOP + 1
         IF(IDLOOP .GT. 2) THEN
            WRITE(6,4774) IDLOOP, IP, KFA, IDB(KFA)
4774        FORMAT(' LOOP CONDITION IN LUDECY'/  ' IDLOOP=',I3,
     *             ' IP=',I4,'KFA=',I4,'IDB(KFA)=',I4)
         ELSE
            IDC=IDB(76+5*IFLA+KSP)
         ENDIF
      GOTO10011
C
10021 KFF = K(IP,2)*LDPRM(4)
      IF( LDPRM(4).EQ.0  .OR.
     *    ( ( 20 .GT. KFF .OR. KFF .GT.  22) .AND.
     *      ( 53 .GT. KFF .OR. KFF .GT.  56) .AND.
     *      ( 58 .GT. KFF .OR. KFF .GT.  60) .AND.
     *      ( 80 .NE. KFF)
     *  ) )    GOTO 10061
         IDLOOP = IDLOOP + 1
         IF(IDLOOP .GT. 2) THEN
            WRITE(6,4774) IDLOOP, IP, KFA, IDB(KFA)
         ELSE
            IDC = IDB(KFA)
         ENDIF
10061 CONTINUE
10011 CONTINUE

C...START READOUT OF DECAY CHANNEL: MATRIX ELEMENT, RESET COUNTERS
      MMAT=IABS(KDP(4*IDC-3))/1000
  120 I=N
      NP=0
      NQ=0
      PS=0.
      PSQ=0.

      DO 130 I1=4*IDC-3,4*IDC
C...READ OUT DECAY PRODUCT, CONVERT TO STANDARD FLAVOUR CODE
      KP=MOD(KDP(I1),1000)
      IF(KP.EQ.0) GOTO 130
      IF(IABS(KP).LE.100) THEN
      KFP=KFS*KP
      IF(KTYP(IABS(KP)).EQ.0) KFP=KP
      ELSEIF(IABS(KP).LT.590) THEN
      KFP=KFS*KP
      IF(KP.EQ.500) KFP=KP
      ELSEIF(IABS(KP).EQ.590) THEN
      IF(KSP.LE.1) KFP=KFS*(-500+IFLB)
      IF(KSP.EQ.3) KFP=KFS*(500+10*IFLC+IFLB)
      IF(KSP.EQ.2.OR.KSP.EQ.4) KFP=KFS*(500+10*IFLB+IFLC)
      ELSEIF(IABS(KP).EQ.591) THEN
      CALL LUIFLD(-KFS*INT(1.+(2.+PAR(2))*RANF(0)),0,0,KFP,KDUMP)
      IF(FPAR(2)+2.*ULMASS(2,KFP).GT.P(IP,5)) GOTO 120
      KFP=KFP+ISIGN(500,KFP)
      ELSEIF(IABS(KP).EQ.592) THEN
      KFP=-KFP
      ENDIF

C...ADD DECAY PRODUCT TO EVENT RECORD OR TO IFLO LIST
      IF(IABS(KFP).LT.500.OR.MMAT.EQ.0.OR.MMAT.EQ.4) THEN
      I=I+1
      NP=NP+1
      IF(IABS(KFP).GE.500) NQ=NQ+1
      K(I,1)=IP+1000*(NQ-2*(NQ/2))
      K(I,2)=KFP
      P(I,5)=ULMASS(1,KFP)
      PS=PS+P(I,5)
      ELSE
      NQ=NQ+1
      IFLO(NQ)=MOD(KFP,500)
      PSQ=PSQ+ULMASS(3,IFLO(NQ))
      ENDIF
  130 CONTINUE

      IF(NQ.NE.0.AND.(MMAT.EQ.2.OR.MMAT.EQ.3)) THEN
C...CHOOSE DECAY MULTIPLICITY IN PHASE SPACE MODEL
      PSP=PS
      CNDE=DPAR(11)*ALOG(MAX((P(IP,5)-PS-PSQ)/DPAR(12),1.03))
      IF(KFA.EQ.26.OR.KFA.EQ.36.OR.(KFA.GE.83.AND.KFA.LE.90))
     &CNDE=CNDE+DPAR(13)
  140 GAUSS=SQRT(-2.*CNDE*ALOG(RANF(0)))*SIN(2.*PAR(20)*RANF(0))
      ND=0.5+0.5*NP+0.25*NQ+CNDE+GAUSS
      IF(MMAT.EQ.3) ND=3
      IF(ND.LT.NP+NQ/2.OR.ND.LT.2.OR.ND.GT.10) GOTO 140

C...FORM HADRONS FROM FLAVOUR CONTENT
      DO 150 JT=1,4
  150 IFL1(JT)=IFLO(JT)
      IF(ND.EQ.NP+NQ/2) GOTO 170
      DO 160 I=N+NP+1,N+ND-NQ/2
      JT=1+INT((NQ-1)*RANF(0))
      CALL LUIFLD(IFL1(JT),0,0,IFL2,K(I,2))
  160 IFL1(JT)=-IFL2
  170 JT=2+2*(NQ/4)*INT(RANF(0)+0.5)
      IF(MIN(IABS(IFL1(1)),IABS(IFL1(JT))).GT.10.OR.(NQ.EQ.4.AND.
     &MIN(IABS(IFL1(3)),IABS(IFL1(6-JT))).GT.10)) GOTO 140
      CALL LUIFLD(IFL1(1),0,IFL1(JT),IFLDMP,K(N+ND-NQ/2+1,2))
      IF(NQ.EQ.4) CALL LUIFLD(IFL1(3),0,IFL1(6-JT),IFLDMP,K(N+ND,2))

C...CHECK THAT SUM OF DECAY PRODUCT MASSES NOT TOO LARGE
      PS=PSP
      DO 180 I=N+NP+1,N+ND
      K(I,1)=IP
      P(I,5)=ULMASS(1,K(I,2))
  180 PS=PS+P(I,5)
      IF(PS+DPAR(14).GT.P(IP,5)) GOTO 140

      ELSEIF(MMAT.EQ.4.AND.NP.EQ.4) THEN
C...RESCALE ENERGY TO SUBTRACT OFF SPECTATOR QUARK MASS
      ND=3
      PS=PS-P(N+4,5)
      PQT=(P(N+4,5)+DPAR(15))/P(IP,5)
      DO 190 J=1,5
      P(N+4,J)=PQT*P(IP,J)
  190 P(IP,J)=(1.-PQT)*P(IP,J)

      ELSE
C...FULLY SPECIFIED FINAL STATES, CHECK MASS BROADENING EFFECTS
      IF(NP.GE.2.AND.PS+DPAR(14).GT.P(IP,5)) GOTO 120
      ND=NP
C
C                       PI0 AND ETA DALITZ DECAY
C FINAL STATE PARTICLES ARE FILLED INTO P(I,J) AND JB(I) IN PI0DK
        IF(MMAT.EQ.7) CALL PI0DK(IP,&380)
C
      ENDIF

      IF(ND.EQ.1) THEN
C...KINEMATICS OF ONE-PARTICLE DECAYS
      DO 200 J=1,4
C                                           MOD 23/1/85 E ELSEN
         VERTX(N+1,J) = VERTX(IP,J)
C                                           END MOD
  200 P(N+1,J)=P(IP,J)
        JB(N+1)=JB(IP)
      GOTO 380
      ENDIF

C...CALCULATE MAXIMUM WEIGHT ND-PARTICLE DECAY
      DO 210 J=1,5
  210 PV(1,J)=P(IP,J)
      PV(ND,5)=P(N+ND,5)
      IF(ND.EQ.2) GOTO 270
      WTMAX=1./DPAR(ND-2)
      PMAX=PV(1,5)-PS+P(N+ND,5)
      PMIN=0.
      DO 220 IL=ND-1,1,-1
      PMAX=PMAX+P(N+IL,5)
      PMIN=PMIN+P(N+IL+1,5)
  220 WTMAX=WTMAX*PAWT(PMAX,PMIN,P(N+IL,5))

C...M-GENERATOR GIVES WEIGHT, IF REJECTED TRY AGAIN
  230 RORD(1)=1.
      DO 250 IL1=2,ND-1
      RSAV=RANF(0)
      DO 240 IL2=IL1-1,1,-1
      IF(RSAV.LE.RORD(IL2)) GOTO 250
  240 RORD(IL2+1)=RORD(IL2)
  250 RORD(IL2+1)=RSAV
      RORD(ND)=0.
      WT=1.
      DO 260 IL=ND-1,1,-1
      PV(IL,5)=PV(IL+1,5)+P(N+IL,5)+(RORD(IL)-RORD(IL+1))*(P(IP,5)-PS)
  260 WT=WT*PAWT(PV(IL,5),PV(IL+1,5),P(N+IL,5))
      IF(WT.LT.RANF(0)*WTMAX) GOTO 230

C...PERFORM TWO-PARTICLE DECAYS IN RESPECTIVE CM FRAME
  270 DO 290 IL=1,ND-1
      PA=PAWT(PV(IL,5),PV(IL+1,5),P(N+IL,5))
      U(3)=2.*RANF(0)-1.
      PHI=2.*PAR(20)*RANF(0)
      U(1)=SQRT(1.-U(3)**2)*COS(PHI)
      U(2)=SQRT(1.-U(3)**2)*SIN(PHI)
        JB(N+IL)=JB(IP)
        VERTX(N+IL,4)=VERTX(IP,4)
        VERTX(N+IL+1,4)=VERTX(IP,4)
      DO 280 J=1,3
        VERTX(N+IL,J)=VERTX(IP,J)
        VERTX(N+IL+1,J)=VERTX(IP,J)
      P(N+IL,J)=PA*U(J)
  280 PV(IL+1,J)=-PA*U(J)
      P(N+IL,4)=SQRT(PA**2+P(N+IL,5)**2)
  290 PV(IL+1,4)=SQRT(PA**2+PV(IL+1,5)**2)

C...LORENTZ TRANSFORM DECAY PRODUCTS TO LAB FRAME
        JB(N+ND)=JB(IP)
      DO 300 J=1,4
  300 P(N+ND,J)=PV(ND,J)
      DO 330 IL=ND-1,1,-1
      DO 310 J=1,3
  310 BE(J)=PV(IL,J)/PV(IL,4)
      GA=PV(IL,4)/PV(IL,5)
      DO 330 I=N+IL,N+ND
      BEP=BE(1)*P(I,1)+BE(2)*P(I,2)+BE(3)*P(I,3)
      DO 320 J=1,3
  320 P(I,J)=P(I,J)+GA*(GA*BEP/(1.+GA)+P(I,4))*BE(J)
  330 P(I,4)=GA*(P(I,4)+BEP)

      IF(MMAT.EQ.1) THEN
C...MATRIX ELEMENTS FOR OMEGA AND PHI DECAYS
      WT=(P(N+1,5)*P(N+2,5)*P(N+3,5))**2-(P(N+1,5)*FOUR(N+2,N+3))**2
     &-(P(N+2,5)*FOUR(N+1,N+3))**2-(P(N+3,5)*FOUR(N+1,N+2))**2
     &+2.*FOUR(N+1,N+2)*FOUR(N+1,N+3)*FOUR(N+2,N+3)
      IF(MAX(WT*DPAR(9)/P(IP,5)**6,0.001).LT.RANF(0)) GOTO 230

      ELSEIF(MMAT.EQ.3.OR.MMAT.EQ.4) THEN
C...MATRIX ELEMENTS FOR WEAK DECAYS (ONLY SEMILEPTONIC FOR C AND B)
      WT=FOUR(IP,N+1)*FOUR(N+2,N+3)
      IF(WT.LT.RANF(0)*P(IP,5)**4/DPAR(10)) GOTO 230
      ENDIF

      IF(MMAT.EQ.4.AND.NP.EQ.4) THEN
C...SCALE BACK ENERGY, COLOUR REARRANGEMENT POSSIBLE FOR FOUR JETS
      DO 340 J=1,5
  340 P(IP,J)=P(IP,J)/(1.-PQT)
      IF(NQ.EQ.4.AND.RANF(0).LT.DPAR(16)) THEN
      KSAV=K(N+2,2)
      K(N+2,2)=K(N+3,2)
      K(N+3,2)=KSAV
      DO 350 J=1,5
      PSAV=P(N+2,J)
      P(N+2,J)=P(N+3,J)
  350 P(N+3,J)=PSAV
      ENDIF

C...LOW INVARIANT MASS FOR SYSTEM WITH SPECTATOR QUARK GIVES PARTICLE,
C...NOT TWO JETS, READJUST MOMENTA ACCORDINGLY
      IF(P(N+3,5)**2+P(N+4,5)**2+2.*FOUR(N+3,N+4).LE.(FPAR(2)+P(N+3,5)+
     &P(N+4,5)-DPAR(15))**2) THEN
      CALL LUIFLD(MOD(K(N+3,2),500),0,MOD(K(N+4,2),500),IFLDMP,K(N+3,2))
      P(N+3,5)=ULMASS(1,K(N+3,2))
      DO 360 J=1,3
  360 P(N+3,J)=P(N+3,J)+P(N+4,J)
      P(N+3,4)=SQRT(P(N+3,1)**2+P(N+3,2)**2+P(N+3,3)**2+P(N+3,5)**2)
      HA=P(N+1,4)**2-P(N+2,4)**2
      HB=HA-(P(N+1,5)**2-P(N+2,5)**2)
      HC=(P(N+1,1)-P(N+2,1))**2+(P(N+1,2)-P(N+2,2))**2+
     &(P(N+1,3)-P(N+2,3))**2
      HD=(P(IP,4)-P(N+3,4))**2
      HE=HA**2-2.*HD*(P(N+1,4)**2+P(N+2,4)**2)+HD**2
      HF=HD*HC-HB**2
      HG=HD*HC-HA*HB
      HH=(SQRT(HG**2+HE*HF)-HG)/(2.*HF)
      DO 370 J=1,3
      PCOR=HH*(P(N+1,J)-P(N+2,J))
      P(N+1,J)=P(N+1,J)+PCOR
  370 P(N+2,J)=P(N+2,J)-PCOR
      P(N+1,4)=SQRT(P(N+1,1)**2+P(N+1,2)**2+P(N+1,3)**2+P(N+1,5)**2)
      P(N+2,4)=SQRT(P(N+2,1)**2+P(N+2,2)**2+P(N+2,3)**2+P(N+2,5)**2)
      ELSE
      ND=4
      ENDIF
      ENDIF

C...ALSO CHECK INVARIANT MASS OF OTHER TWO JETS, START OVER IF TOO SMALL
      IF(MMAT.EQ.4.AND.IABS(K(N+1,2)).GE.500.AND.P(N+1,5)**2+P(N+2,5)
     &**2+2.*FOUR(N+1,N+2).LE.(FPAR(2)+P(N+1,5)+P(N+2,5))**2) GOTO 120
  380 N=N+ND

      K(IP,1)=K(IP,1)+2000
      RETURN
      END

C   08/07/80 007081342  MEMBER NAME  PARCIR   (TPSOURCE)    FORTRAN
C
      SUBROUTINE PARCIR (IPATR,IND1,IND2)
C
C     M.NOZAKI   12-06-80  18:30   (COPIED FROM LCNOZ.PATR.FORT)
C     LAST MOD.
C
C         FINDS THE PATRENT CIRCLE
C
#include "cdata.for"
C
       IND2 = 0
       IND = IND1
       NLOOP = 0
 1001 CONTINUE
       CALL ADJCIR (IPATR,IND,INDP)
       IF(INDP.LE.0) RETURN
       NLOOP = NLOOP + 1
       IF(NLOOP.GT.10) GOTO 2000
       IND = INDP
       IND2 = INDP
      GOTO 1001
 2000 CONTINUE
      IPHD = IDATA(IBLN('HEAD'))
      NRUN = HDATA(IPHD*2+10)
      NREC = HDATA(IPHD*2+11)
      WRITE(6,6000) NRUN,NREC,IDATA(IND+1),IDATA(IND2+1),IPATR
 6000 FORMAT(' +++++ PARCIR  >10 PARENTS +++++',5X,
     &       'NRUN,NREC=',2I5,5X,'TRK#,PARENT#=',2I5,5X,
     &       'PATR POINTER=',I8)
      RETURN
C
      END

C   12/08/87 804271519  MEMBER NAME  EAUNIN   (S)           FORTRAN77
      SUBROUTINE EAUNIN( JTRK )
C-----------------------------------------------------------
C  VERSION OF 11/08/87     LAST MOD 19/08/87    E ELSEN
C  CHECK UNIQUENESS OF CLUSTER ASSIGNMENT FOR TRACK JTRK
C  ADAPTED FORM F11HEL.NEUFS(ELSE34, ENTRY UNINES IN EVENTO)
C
C  INPUT:
C     JTRK  TRACK NUMBER
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C---------------------------------------- COMMONS FOR LEAD GLASS ENERGY
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
      COMMON /LISE/   IBLCSE,NBSK,NBSE,XSI,YSI,ZSI,XSF,YSF,ZSF,XSTAST,
     *                YSTAST,ZSTAST,PSTAST,TRSE(3,50),TRISE
      DIMENSION IRSE(3,50)
      EQUIVALENCE(IRSE(1,1),TRSE(1,1))
      COMMON /CLDAT/ NUMBLO,NBLIST(40),ENLIST(40),IPACL,ECLCO,ECLUN,
     *               PIMP1,PIMP2
      COMMON / CONNEC / ICON,SUMPI,CONC(3,10)
      DIMENSION ICONC(3,10)
      EQUIVALENCE(ICONC(1,1),CONC(1,1))
      COMMON / CONNEP / ICOP,CONP(5,30),SUPH(5)
      DIMENSION ICONP(5,30)
      EQUIVALENCE(ICONP(1,1),CONP(1,1))
C-------------------------------------------- GENERAL COMMONS
C
      COMMON / CRELC / SIGP,SIG1EP,CH1EP,CHI1W,CHI2N,PCHI2,ESHM,RFIR,
     +                 CHIRP,CHIRZ,ZINT,RDIS,JKAND
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      DIMENSION LADD(-1:2)
      INTEGER RUN, EVENT
      LOGICAL FIRST / .TRUE. /
C
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IPHEAD = IBLN('HEAD')
        IPPATR = IBLN('PATR')
        IPZE4V = IBLN('ZE4V')
        IPALGN = IBLN('ALGN')
      ENDIF
      NPHEAD = IW(IPHEAD)
      IF( NPHEAD .GT. 0 ) THEN
        RUN = HW(NPHEAD*2+10)
        EVENT = HW(NPHEAD*2+11)
      ELSE
        RUN = 0
        EVENT = 0
      ENDIF
C
      ICON=0
      ICOP=0
      SUMPI=0.0
      DO 10 I=1,5
        SUPH(1)=0.
   10 CONTINUE
C
      CALL CLOC(NPALSA,'ALSA',JTRK )
      IF( NPALSA.GT.0 ) THEN
        DELZ=ABS(ZF-ZI)
        ZHIG=ZI+DELZ
        ZLOW=ZI-DELZ
C
        NPZE4V = IW(IPZE4V)
        NPPATR = IW(IPPATR)
        IF( NPZE4V .GT. 0 .AND. NPPATR.GT.0 ) THEN
          LT = HW( NPZE4V*2 + 5 )
          LADD(-1) = LT
          LADD(0)  = HW(NPZE4V*2 +  9) + LT
          LADD(1)  = HW(NPZE4V*2 +  7) + LT
          LADD(2)  = HW(NPZE4V*2 + 11) + LT
          NT = HW(NPZE4V*2 + 6)
          NP0 = NPZE4V + HW(NPZE4V*2 + 1)
          NP = NP0
          J = 0
          NPJ = 0
          DO 20 WHILE( J.LT.NT .AND. NPJ.LE.0 )
            J = J + 1
            ITPF =  HW(NP*2+18)
            IF( ITPF .EQ. 1 ) THEN
              IF( HW((NP+LT)*2+9) .EQ. JTRK ) NPJ = NP
            ENDIF
            ITPF =  HW(NP*2+18)
            NP = NP + LADD( ITPF )
   20     CONTINUE
C                                    TRACK IN ZE4V?
          IF( NPJ .GT. 0 ) THEN
            NP = NP0
            DO 1000 J=1,NT
              ITPF =  HW(NP*2+18)
              IPTRK = HW((NP+LT)*2+9)
              IF( ITPF .EQ. 1 .AND. IPTRK .NE. JTRK ) THEN
                COSOP = RW(NP+1)*RW(NPJ+1) + RW(NP+2)*RW(NPJ+2) +
     *                RW(NP+3)*RW(NPJ+3)
                PTOT = RW(NP+6)
                IF( COSOP .GT. 0.2 .AND. PTOT .GT. 0.02 ) THEN
                  EBISE = -1.
                  IP = NPPATR + (HW((NP+LT)*2+9)-1)*IW(NPPATR+3) +
     *                 IW(NPPATR+1)
                  CALL TRKBSE( IP, NPALSA, EBISE )
C                                           ENERGY LOSS OF MIN ION. TRK
C                                           IN COIL, 8.4 CM AL EQUIV,
C                                           AT 0.0044 GEV/CM
                  ELOS=0.0044*8.4/SQRT(1.-RW(NP+3)**2)
                  PTOT=AMAX1(0.0,PTOT-ELOS)
C
                  IF(EBISE.GT.0.) THEN
                    ICON=ICON+1
                    SUMPI=SUMPI+PTOT
C
                    IF(ICON.LE.10) THEN
                      ICONC(1,ICON)=IPTRK
                      CONC(2,ICON)=PTOT
                      CONC(3,ICON)=EBISE
                    ENDIF
                  ELSE
C                         EXAMINE TRACKS NEAR IN R-PHI
                    NPALGN=IW(IPALGN)
                    CALL TRKBSE(IP, NPALGN, EBISE )
                    IF( IBLCSE.LE.0 ) THEN
C                            IS IMPACT OF TRACK ISE WITHIN Z RANGE
C                            OF TRACK IPNR
                      IF(ZSTAST.GE.ZLOW.AND.ZSTAST.LE.ZHIG) THEN
                        DAPS=ABS(PSTART-PSTAST)
                        IF(DAPS.LE.0.5) THEN
                          ICOP=ICOP+1
                          IF(ICOP.LE.30) THEN
                            ICONP(1,ICOP)=IPTRK
                            CONP(2,ICOP)=PTOT
                            CONP(3,ICOP)=ZSTAST
                            CONP(4,ICOP)=PSTAST
                            CONP(5,ICOP)=EBISE
C                                      0.0748 = BLOCK WIDTH PHI
                            INSU=DAPS/0.0748 + 1
                            DO 575 JP=MIN(INSU+1,5),5
                              SUPH(JP)=SUPH(JP)+PTOT
  575                       CONTINUE
                          ENDIF
                        ENDIF
                      ENDIF
                    ENDIF
                  ENDIF
                ENDIF
C
              ENDIF
              NP = NP + LADD( ITPF )
 1000       CONTINUE
          ENDIF
        ENDIF




C
C
C
        IF(ICON.GT.10) THEN
          WRITE(6,9101) ICON, SUMPI, RUN, EVENT, JTRK
 9101     FORMAT(' +++ EAUNIN: ICON=',I3,'>10.  SUMPI=',F10.3,
     +            ' IN EVENT',2I8,' TRACK',I4)
          ICON = 10
        ENDIF
        IF(ICOP.GT.30) THEN
          WRITE(6,9102) ICOP, RUN, EVENT, JTRK
 9102     FORMAT(' +++ EAUNIN: ICOP=',I3,'>30 IN EVENT',2I8,
     *           ' TRACK',I4)
          ICOP = 30
         ENDIF
      ELSE
C
        WRITE(6,9104) JTRK, RUN, EVENT
 9104   FORMAT(' +++ EAUNIN: ALSA,',I3,' MISSING IN EVENT ',2I8 )
C
      ENDIF
      END

C   01/11/84            MEMBER NAME  PBGRZ    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PBGRZ( INDEX, SH1, SH2, SH3 )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  LG AMPLITUDES   (R-Z-VIEWS)
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON /CWORK1/ R,FI,XA,COSFI,X1,Y1,YA,SINFI,X2,Y2,ZET,X3,Y3,X4,Y400001900
     +               ,IMW(200)
C
      COMMON /CJTRIG/ PI,TWOPI
C
C-----------------  C O D E  -------------------------------------------
C
C     LEAD GLASS AMPLITUDES IN RZ VIEWS
C
      CALL PBGSUM(INDEX)
      call setcol('ECAL')     ! PMF 23/11/99: set colour
C DISPLAY ENDCAP SUMS
      DO 5020 IKJ=1,2
      X=ZENDMI-DEPEND+10.
      IF(IKJ.EQ.2) X=ZENDPL+10.
      Y0=-6*BLXY+10.
      DO 5020 KJI=1,12
      IRETRV=84+12*(IKJ-1)+KJI
      IESUM=IMW(IRETRV)
      IF(IESUM.LT.1) GO TO 5020
      Y=Y0+(KJI-1)*BLXY
      CALL DNUM(IESUM,X,Y,SH3,0.)
 5020 CONTINUE
C---
C---     NOW DO BARREL.
C---
      DO 34 ICC = 109,172
      IESUM = IMW(ICC)
      IF(IESUM.LT.0) GO TO 34
      ICCC = ICC - 108
      IF(ICCC.GT.32) ICCC = ICCC - 32
      X1 = ZLGMI + (ICCC-1)*BLZ
      Y1 = RLG
      X0 = X1 + 5.*SH2
      Y0 = Y1 + SH1
      FII = PI/2.
      IF(ICC.LT.141) GO TO 22
      Y1 = - RLG
      Y0 = Y1 - SH1
      X0 = X1 + SH2
      FII = 3.*PI/2.
   22 CALL DNUM(IESUM,X0,Y0,SH3,FII)
   34 CONTINUE
      call setcol(' ')     ! PMF 23/11/99: reset colour
      RETURN
      END

C   14/10/82            MEMBER NAME  MEMBERS3 (S)           FORTRAN77
      4.   DIRECT ACCESS PROGRAMS



      END
#include "blocda.for"
#include "binlda.for"
#include "bloada.for"
#include "poda.for"
#include "rdda.for"
#include "aajobdb1.for"
#include "aajobdb2.for"
#include "aajobdb3.for"

C   07/06/96 606071803  MEMBER NAME  BCHM     (S4)          FORTG1
      SUBROUTINE BCHM(IND,NZ,IER)
C     BOS SUBPROGRAM =1.7=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      INTEGER NZ(1)
C   30/04/96 604301841  MEMBER NAME  STAR     (BOSLIB.S)    FORTRAN
      REAL STAR/Z0000005C/,FF/Z000000FF/
      EQUIVALENCE (XNAME,INAME)
      LOGICAL NOTLOW
      REAL AND
      EXTERNAL AND
      NOTLOW(XNAME)=AND(XNAME,FF).NE.STAR
      IER=0
      NW=NZ(1)
      IF(NW) 20,10,30
C     ZERO MEANS MOVE TO END
   10 NN=IW(IND)+4
      IF(IND+IW(IND)+1.EQ.NEXT) GOTO 9
      IF(NEXT+NN.GT.NLST) GOTO 92
C     MOVE
      IW(INAMV)=IW(IND-3)
      LFDI=MOD(IABS(IW(INAMV)),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 3
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)               GOTO    91
      IF(IW(LFDI-2).LT.IW(IND-2)) GOTO 2
      IF(IW(LFDI-2).GT.IW(IND-2)) GOTO    91
      CALL UCOPY(IW(IND-3),IW(NEXT),NN)
      IW(IND)=-NN
      ILOW=MIN0(ILOW,IND)
      IND=NEXT+3
      NEXT=NEXT+NN
      IW(LFDK-1)=IND
      NFRE=NFRE+NN
    9 IF(NW) 40,100,40
C     NEGATIVE
   20 IF(IW(IND)+NW.LT.0) GOTO 91
      IF(IND+IW(IND)+1.EQ.NEXT) GOTO 40
      IF(NW.GT.(-4)) GOTO 10
      IW(IND)=IW(IND)+NW
      KND=IND+IW(IND)+4
      ILOW=MIN0(ILOW,KND)
      IW(KND)=NW
      NFRE=NFRE-NW
      GOTO 46
C     POSITIVE
   30 IF(IND+IW(IND)+1.NE.NEXT) GOTO 10
C     CHANGE LENGTH OF LAST BANK
   40 INAME=IW(IND-3)
      IF(NOTLOW(XNAME)) GOTO 45
      IF(NCPL+NW.GT.NSPL) GOTO 92
   45 IF(NEXT+NW.GT.NLST) GOTO 92
      IW(IND)=IW(IND)+NW
      NEXT=NEXT+NW
   46 INAME=IW(IND-3)
      IF(NOTLOW(XNAME)) GOTO 100
      NCPL=NCPL+NW
      GOTO 100
C
      ENTRY BCHF(IND,NZ,IER)
      IER=0
      NW=NZ(1)-IW(IND)
      IF(NW.GT.0) GOTO 30
      GOTO 100
C
      ENTRY BSTR(IND,NZ,IER)
      IF(IER.LE.0) GOTO 100
      CALL UCOPY2(NZ,IW(IND+1),IER)
      GOTO 100
C
      ENTRY BMRT(IND,NZ,IER)
      IND=0
      IF(IN.LE.0) GOTO 100
      DO 50 I=1,IN
      IF(I.GT.IER) GOTO 100
      IND=IND+1
      J=IW(NLST+I)
   50 NZ(IND)=IW(INAMV+J)
      GOTO 100
C     ERRORS
C     NOT ENOUGH SPACE
   92 IER=IER+1
C     BANK LENGTH WILL BECAME NEGATIVE OR
C     IND IS NOT A TRUE BANK INDEX
   91 IER=IER+1
C
  100 RETURN
      END

C   07/06/96 606071853  MEMBER NAME  JBN      (S4)          FORTG1
      FUNCTION JBN(X,A,B,C,D,E,F,G,H,P,Q)
C     PURPOSE
C        OBTAIN INDEX FROM X IN A NONEQUIDISTANT SCALE WITH
C        A = LOWEST CHANNEL LEFT ADGE
C        B = NEXT CHANNEL LEFT ADGE
C        C = NEXT CHANNEL LEFT ADGE
C        D = . . .
C
C     USAGE
C        INDEX=JBN(X,A,B,C,D, . . . )
C        WHERE A,B,C,D, . . .(VARIABLE NR OF ARGUMENTS) ARE NB+1
C        SORTED CHANNEL LEFT EDGES
C        (A MAXIMUN OF 10 ARE ALLOWED, I.E. NB=9)
C
C     REMARK
C        INDEX = 0    IF X LT A
C              = NB+1  IF X GE LAST ARGUMENT
C
C     EXAMPLE
C        INDEX=JBN(X,0.47,0.53)
C        INDEX = 0 FOR         X LT 0.47
C              = 1 FOR 0.47 LE X LT 0.53
C              = 2 FOR 0.53 LE X
C
      K=0
      CALL NOARG(N)
      GOTO (100,11,12,13,14,15,16,17,18,19,20),N
   20 IF(X.GE.Q) GOTO 10
   19 IF(X.GE.P) GOTO 9
   18 IF(X.GE.H) GOTO 8
   17 IF(X.GE.G) GOTO 7
   16 IF(X.GE.F) GOTO 6
   15 IF(X.GE.E) GOTO 5
   14 IF(X.GE.D) GOTO 4
   13 IF(X.GE.C) GOTO 3
   12 IF(X.GE.B) GOTO 2
   11 IF(X.GE.A) GOTO 1
      GOTO 100
    1 K=1
      GOTO 100
    2 K=2
      GOTO 100
    3 K=3
      GOTO 100
    4 K=4
      GOTO 100
    5 K=5
      GOTO 100
    6 K=6
      GOTO 100
    7 K=7
      GOTO 100
    8 K=8
      GOTO 100
    9 K=9
      GOTO 100
   10 K=10
  100 JBN=K
      RETURN
      END

C
C  COMMON FOR Z-RESOLUTION PARAMETERS,   USED IN SUBR. AMPS2Z
C
      COMMON / CZSPRM / NZSPRD,
C                                           PARMS FOR RESOLUTIONS
     * AZSRS0(3), AZSRSA(3),
C                                           PARMS FOR CUTS
     * AZSCT1(3), AZSCT2(3), AZSCT3(3), AZSCT4(3),
C                                           SECOND HIT
     * AZSSHT(5,3),
C                                           SECOND HIT DISTANCE
     * AZSSHD(3),
C                                           AVE RESOLUTIONS
     * AZSSAV(3),
C                                           ZSPD BANK FILL FLAG
     * LZSPDF
      LOGICAL LZSPDF

C   11/01/88 807231744  MEMBER NAME  BOSDATA  (S)           MACROFOR
C
      PARAMETER  ( LENBOS = 65000 )
C
      INTEGER    IDATA
      REAL       ADATA( LENBOS )
      INTEGER*2  HDATA( 2*LENBOS )
C
      COMMON  / BCS /  IDATA( LENBOS )
C
      EQUIVALENCE  ( IDATA(1), ADATA(1) ), ( HDATA(1), IDATA(1) )
C

C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1

C   21/03/79 C9091701   MEMBER NAME  CHANLI   (JADEGS)      FORTRAN
      SUBROUTINE CHANLI
      IMPLICIT INTEGER*2 (H)
C---
C---     PROGRAM TO CHANGE LIMITS OF PATTERN RECOGNITION CONSTANTS
C---     UNDER GRAPHICS FOR JADE EXPERIMENT
C---------------------- J.OLSSON 21.3.79,     LATEST CHANGE 02.8.79
C---
      COMMON /CWORK1/ HWORK(100)
#include "cgraph.for"
#include "cpatlm.for"
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
C     COMMON /CPATLM/ PATRLM( 5), FLINLM(10), TRELLM(20), ZFITLM(10),
C    *                BKK(20) , XYF(20) , IGFP(20) , XBKK(40) , IMCERT
C     INTEGER IXYF(20),LMPATR(2), LMFLIN(2),LMTREL(2),LMZFIT(2),IBKK(20)
C     DIMENSION GFP(20)
C     EQUIVALENCE     (PATRLM(1),LMPATR(1))
C    *               ,(FLINLM(1),LMFLIN(1)) , (TRELLM(1),LMTREL(1))
C    *               ,(ZFITLM(1),LMZFIT(1)) , (BKK(1),IBKK(1))
C    *               ,(XYF(1),IXYF(1))      , (GFP(1),IGFP(1))
C----------- END OF MACRO CPATLM --------------
      DIMENSION PLIM(146),KLIM(146)
      EQUIVALENCE(PLIM(1),PATRLM(1)),(PLIM(1),KLIM(1))
C
1     CALL TRMOUT(80,'ENTER 0 TO RETURN, 1 TO SHOW CURRENT VALUES, 2 TO
     $CHANGE A VALUE, 3 TO RESET^')
      NN = TERNUM(DUMM) + 1
      IF(NN.LT.1.OR.NN.GT.4) GO TO 1
      GO TO (100,200,300,400),NN
200   CONTINUE
      WRITE(JUSCRN,201) (LMPATR(I),I=1,5)
      WRITE(JUSCRN,202) (PATRLM(I),I=1,5)
201   FORMAT(' LMPATR ',5I8)
202   FORMAT(' PATRLM ',5E11.4)
      WRITE(JUSCRN,203) (LMFLIN(I),I=1,10)
      WRITE(JUSCRN,204) (FLINLM(I),I=1,10)
203   FORMAT(' LMFLIN ',5I8)
204   FORMAT(' FLINLM ',5E11.4)
      WRITE(JUSCRN,205) (LMTREL(I),I=1,20)
      WRITE(JUSCRN,206) (TRELLM(I),I=1,20)
205   FORMAT(' LMTREL ',5I8)
206   FORMAT(' TRELLM ',5E11.4)
      WRITE(JUSCRN,207) (LMZFIT(I),I=1,10)
      WRITE(JUSCRN,208) (ZFITLM(I),I=1,10)
207   FORMAT(' LMZFIT ',5I8)
208   FORMAT(' ZFITLM ',5E11.4)
      WRITE(JUSCRN,209) (IBKK(I),I=1,20)
      WRITE(JUSCRN,210) (BKK(I),I=1,20)
209   FORMAT(' IBKK ',5I8)
210   FORMAT(' BKK ',5E11.4)
      WRITE(JUSCRN,211) (IXYF(I),I=1,20)
      WRITE(JUSCRN,212) (XYF(I),I=1,20)
211   FORMAT(' IXYF ',5I8)
212   FORMAT(' XYF ',5E11.4)
      WRITE(JUSCRN,215) (IGFP(I),I=1,20)
      WRITE(JUSCRN,216) (GFP(I),I=1,20)
215   FORMAT(' IGFP ',5I8)
216   FORMAT(' GFP ',5E11.4)
      WRITE(JUSCRN,213) (XBKK(I),I=1,40)
213   FORMAT(' XBKK ',5E11.4)
      WRITE(JUSCRN,214) IMCERT
214   FORMAT(' IMCERT ',I4)
      GO TO 1
300   CALL TRMOUT(80,'COMMON CPATLM IS STRUCTURED AS FOLLOWS:^')
      CALL TRMOUT(80,'PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),^')
      CALL TRMOUT(80,'BKK(20),XYF(20),GFP(20),XBKK(40),IMCERT^')
      CALL TRMOUT(80,'ENTER RELATIV POSITION IN COMMON AND DESIRED VALUE
     $^')
      CALL TRMOUT(80,'FOR REALS, ENTER NEGATIV RELATIV POSITION AND DESI
     $RED VALUE^')
      CALL TONUM(NCO,ACO)
      IF(NCO.GT.0.AND.NCO.LT.147) GO TO 310
      IF(NCO.GE.0) GO TO 300
      NCO = IABS(NCO)
      IF(NCO.GT.146) GO TO 300
      OLDVAL = PLIM(NCO)
      PLIM(NCO) = ACO
      WRITE(JUSCRN,301) NCO,OLDVAL,PLIM(NCO)
301   FORMAT(' VAR.',I3,' CHANGED FROM ',E11.4,' TO NEW VALUE ',E11.4)
      GO TO 1
310   IOLVAL = KLIM(NCO)
      KLIM(NCO) = ACO
      WRITE(JUSCRN,311) NCO,IOLVAL,KLIM(NCO)
311   FORMAT(' VAR.',I3,' CHANGED FROM ',I10,' TO NEW VALUE ',I10)
      GO TO 1
400   CALL INPATR
      GO TO 1
100   RETURN
      END

      SUBROUTINE BAKFIT(IB,ITYP)
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
       DIMENSION CHITR(9),HITIN(10)
       EQUIVALENCE (ADWRK(91),CHITR(1)),(HITIN(1),ADWRK(86))
       IB=0
       IREM=IXYF(1)
       IXYF(1)=LOR(IXYF(1),9)
       HPOLD=HPFREE
       IBTRK=NTR
       CALL FXYZ(IBTRK)
       HPTR0=HPFREE
       HPTR9=HPTR0+49
       HLDTR=50
      HPFREE=HPTR9+1
      IF(
     - HPFREE.LE.HPLAST
     -)THEN
      CALL XYFIT
      RES=CHITR(HNREL(NTR))
      RMS=WRK(HPTR0+22)
      NTOT=IWRK(HPTR0+23)
      NHT=HITIN(HNREL(NTR))
      IF(NHT.GT.0) RES=RES/FLOAT(NHT)
      IF(ITYP.EQ.1.AND.(RMS.GT.YBKK(2).OR.RES.GT.YBKK(3))) IB=-1
      IF(ITYP.EQ.2.AND.(RMS.GT.YBKK(4).OR.RES.GT.YBKK(5))) IB=-1
      IF(ITYP.EQ.3.AND.(RMS.GT.YBKK(6).OR.RES.GT.YBKK(7))) IB=-1
      IF(ITYP.EQ.4.AND.RMS.GT.YBKK(8)) IB=-1
      ELSE
      PRINT 33
 33   FORMAT(' +++++++++  NOT ENOUGH SPACE IN CWORK  +++++++')
      ENDIF
      IXYF(1)=IREM
      HPFREE=HPOLD
      RETURN
      END

C   01/10/83 805261727  MEMBER NAME  MUFFLY   (JADEMUS)     FORTRAN
C
C LAST CHANGE  9.40 14/04/88 J. HAGEMANN - CORRECT CALC. OF EXTR. ERRORS
C      CHANGE 02.30 22/11/83 HUGH MCCANN  - PROTECT MHREG AND ARRAYS.
C      CHANGE 22.00 22/10/83 HUGH MCCANN  - FOR YOKE END PLATES.
C                                           AND INDENT SOME OF CODE.
C      CHANGE 03.00 14/07/83 HUGH MCCANN  - VARIOUS MODIFICATIONS.
C      CHANGE 18.31 21/03/83 CHRIS BOWDERY- NEW CHAMBER TWIST CORRECTION
C      CHANGE 12.00 12/01/83 HUGH MCCANN  - CHANGE NTHIS > 10 MESSAGES.
C      CHANGE 19.05 16/03/82 CHRIS BOWDERY- LET-OFF CHECK(LOCH)
C      CHANGE 14.30 04/02/82 HUGH MCCANN  - INCREASE KDEPTH LIMIT TO 4.
C      CHANGE 12.15 19/10/81 HUGH MCCANN  - MAKING ALLOWANCE FOR OVER-
C                                           WRITTEN HIT1'S + FIX HTC.
C      CHANGE 21.40 05/10/81 HUGH MCCANN  - OVERLAP HITS.
C      CHANGE 14.00 17/06/81 JOHN ALLISON - REFITTING, ETC.
C      CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE / 2 GLOBALS.
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLY(HC,NHITS,NWHIT,HLUN,HTC,HAMB,NTPH,*)
C-----------------------------------------------------------------------
C
C          THIS SUBROUTINE TRACKS THROUGH THE REGIONS FOUND BY MUREGY
C          TO ASSOCIATE HITS. DEVIATIONS ARE STORED FOR THE 'LET-OFF'
C          CHECK.
C
C IDTRK   IS INNER DETECTOR TRACK NUMBER.
C NCEPTS  IS THE NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS   IS NUMBER OF HITS ASSOCIATED WITH THIS TRACK.
C HC      CONTAINS MUON HIT COORDINATES.
C NHITS   IS THE NUMBER OF MUON HITS.
C NWHIT   IS NUMBER OF WORDS PER HIT IN HIT COORDINATE ARRAY.
C HLUN    IS HIT STATUS ARRAY.
C HTC     IS HIT-TRACK CORELLATION ARRAY - FILLED BY MUFFLE.
C HAMB    IS AMBIGUITY FLAG FOR EACH ENTRY IN HTC.
C NTPH    IS NUMBER OF TRACKS PER HIT ALLOCATED IN HTC.
C INEFF   IS NO. OF TIMES A HIT WAS NOT FOUND AND THERE WAS NO
C           DEAD CHAMBER TO EXPLAIN ITS ABSENCE.
C NHLAYR  IS RELATED TO THE NO. OF LAYERS WITH HITS WHICH ARE
C           ASSOCIATED WITH THIS TRACK.
C INFLAG  IS SET = 1 IF AN INEFFICIENCY IS FOUND, AND SET = 0 IF A HIT
C           IS FOUND WITHIN CUTS.  SO IF IT IS STILL 1 WHEN THIS ROUTINE
C           HAS FINISHED IT MEANS THERE WAS AN INEFFICIENCY IN THE LAST
C           LAYER INTERCEPTED.
C
C DEVDR(20,1/2) HOLDS THE DRIFT DEVIATIONS OF LEFT/RIGHT AMBIGUITIES
C                OF HITS IN THE CURRENT REGION WHICH ARE ASSOCIATED
C                WITH THIS TRACK ( ONLY IF L/R ASSOCIATED ). THIS IS
C                CLEARED FOR EACH INTERCEPT; INDEX=1-->NO. OF ASSOCIATED
C                HITS IN THIS REGION ( NHREG ).
C
C NCHAMR(20)     HOLDS CHAMBER NOS. CORRESPONDING TO DEVDR.
C NHITR(20)       "     HIT NOS. (MUR1)  "         "   "  .
C
C EEVDR(20,1/2)  AS DEVDR , BUT HOLDS THE DEVIATIONS FOR ALL HITSIN
C                THE CURRENT REGION, REGARDLESS OF WHETHER THEY ARE
C                ASSOCIATED.
C
C MCHAMR(20)     HOLDS CHAMBER NOS. CORRESPONDING TO EEVDR.
C MHITR(20)       "     HIT NOS. (MUR1)  "         "   "  .
C MBADR(20)       "     HIT  STATUS      "         "   "  .
C NDISQ(20)      IS A FLAG FOR TESTS ASSOCIATED WITH 'M...' ARRAYS.
C                THE INDEX GOES 1--> NHREG   (N.B. NHREG ) .
C
C RETURN 1 IF TRACK STOPS (I.E. RUNS OUT OF ENERGY).
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FOUND1,FOUND2,FOUNDL,NONE,BADT,BADL,BADH1,LCOVAR
*xxx 13.01.98
      LOGICAL TBIT
*xxx
C
C               COMMONS AND ARRAY DIMENSIONS
C
#include "cmuffl.for"
#include "cmufwork.for"
#include "cmureg.for"
#include "cmucalib.for"
      COMMON /CMUIEV/ IEV,NEV,IRD,KRUN,KREC,
     +                ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                REGZE(60),LOCHRS(60),ABLOCH(60)
      COMMON /CMUPTC/ XEXTRP,YEXTRP,ZEXTRP,VTZCV,LCOVAR
C
      DIMENSION DEVDR(20,2),NCHAMR(20),NHITR(20)
C
      DIMENSION EEVDR(20,2),MCHAMR(20),MHITR(20),MBADR(20),NDISQ(20)
      LOGICAL MBADR,NDISQ
      DIMENSION HC(1),HLUN(1),HTC(1),HAMB(1)
      DIMENSION KTYPE(4),KREGN(4)
C
C-----------------------------------------------------------------------
C
C        DATA INITIALISATION STATEMENTS, ETC.
C
C     FOR CHAMBER RESOLUTIONS, SEE BLOCK DATA FOR /CMUFFL/ AT THE END
C     SUBROUTINE MUFFLE.
C
C     ICONST IS THE CONSTANT SUBTRACTED FROM THE DRIFT TIME OF HIT2
C     TO ESTIMATE THE DRIFT TIME OF HIT1 IN THE EVENT THAT THE DRIFT
C     INFORMATION OF HIT1 HAS BEEN LOST---NECESSARY HERE TO CALCULATE
C     THE EXTRA ALLOWANCE FOR OVERWRITTEN HIT 1'S IN 'MEASURING ERROR'.
C
      DATA ICONST / 7 /
C
C-----------------------------------------------------------------------
C
C             START OF EXECUTABLE STATEMENTS.
C
      IF(NCEPTS.LE.0) RETURN
      VCT1 = REST1**2
      VCT2 = REST2**2
      VCL  = RESL **2
C
C             SET KDEPTH, WHICH RECORDS HOW MANY REGIONS ONE IS IN
C             AT ANY ONE TIME. NORMALLY THIS IS 0 OR 1 BUT CAN BE
C             UP TO 4 BECAUSE CHAMBER REGIONS ARE ARTIFICIALLY
C             EXTENDED IN MUREG AND CAN THEREFORE OVERLAP.
C
      KDEPTH=0
C
C             CLEAR THE 'OVER' VARIABLES WHICH, AFTER LEAVING
C             MUFFLY, WILL CONTAIN AMOUNTS FOR STEPS LEFT OVER
C             AFTER LEAVING THE LAST ABSORBER.
C
      DOVER  = 0.
      GMOVER = 0.
      ABOVER = 0.
      RDOVER = 0.
      DEOVER = 0.
C
C-----------------------------------------------------------------------
C START OF MAIN LOOP ---------------------------------------------------
C-----------------------------------------------------------------------
C
C             LOOK THROUGH INTERCEPTS.
C
      DO 1000   ICEPT = 1,NCEPTS
C
C             PROPAGATE TO INTERCEPT.
C
          JTYPE  = 0
          DSTEP  = RDOTD(ICEPT)
C
          IF(ICEPT.GT.1) DSTEP = DSTEP - RDOTD(ICEPT-1)
C
C            IF THIS STEP IS NOT THRO' DENSE MATTER, GOTO 1011
C            AFTER PUTTING THE MATTER VARIABLES TO ZERO.
          IF(KDEPTH.NE.0) GO TO 1010
             GMSTEP = 0.
             ABSTEP = 0.
             RDSTEP = 0.
             DESTEP = 0.
             GO TO 1011
 1010     CONTINUE
C           THIS STEP DOES GO THRO' DENSE MATTER.
C           FIND DENSEST TYPE - JTYPE.
          DO 1015  K = 1,KDEPTH
             IF(JTYPE.LT.KTYPE(K) ) JTYPE = KTYPE(K)
             IF(JTYPE.EQ.KTYPE(K) ) IRONRG= KREGN(K)
 1015     CONTINUE
C
C           OCTOBER 1983 :  FIX-UP FOR YOKE END PLATES .
C           THEY ARE COMPLETELY DEFINED BY HRFACE/IUNIT(IREGN)=5,6/3  ,
C           SINCE THEY ARE THE ONLY PARTS OF UNIT 3 (= MAGNET & PLINTH)
C           WHICH ARE IN FACES 5 AND 6.
C           IF MOST DENSE REGION IS NOT YOKE END PLATE, CARRY ON.
          IF( JTYPE.NE.3 )  GO TO 1016
C               THE REGION NO. OF THE IRON REGION WAS NOTED ABOVE.
C               NOTE : CAN'T BE IN 2 IRON REGIONS AT SAME TIME.
              IF(HRFACE(IRONRG).NE.5.AND.HRFACE(IRONRG).NE.6)GO TO 1016
                  IF(HUNIT(IRONRG).NE.3)GO TO 1016
                      JCEPT=ICEPT
                      CALL MUENDP(JCEPT,IRONRG,FACSTP)
C
C                        N.B.  DSTEP IS NOT CHANGED.
                      GMSTEP = (FACSTP*DSTEP)*GMG(JTYPE)
                      ABSTEP = (FACSTP*DSTEP)*ABG(JTYPE)
                      RDSTEP = (FACSTP*DSTEP)*RDG(JTYPE)
                      DESTEP = (FACSTP*DSTEP)*DEG(JTYPE)
                      GO TO 1011
 1016     CONTINUE
C
          GMSTEP = DSTEP*GMG(JTYPE)
          ABSTEP = DSTEP*ABG(JTYPE)
          RDSTEP = DSTEP*RDG(JTYPE)
          DESTEP = DSTEP*DEG(JTYPE)
 1011     CONTINUE
C+++
C     WRITE(6,8935)JTYPE
C8935 FORMAT(' JTYPE',I5)
C+++
C             ACCUMULATE THE 'OVER' VARIABLES WHICH, AFTER LEAVING
C             MUFFLY, WILL CONTAIN AMOUNTS FOR STEPS LEFT OVER AFTER
C             LEAVING THE LAST ABSORBER.
C
          IF(JTYPE.GT.1)GO TO 1017
              DOVER  = DOVER  + DSTEP
              GMOVER = GMOVER + GMSTEP
              ABOVER = ABOVER + ABSTEP
              RDOVER = RDOVER + RDSTEP
              DEOVER = DEOVER + DESTEP
              GO TO 1018
 1017     CONTINUE
              DOVER  = 0.
              GMOVER = 0.
              ABOVER = 0.
              RDOVER = 0.
              DEOVER = 0.
 1018     CONTINUE
C
          CALL MUFFLS(&3333)
C
C-----------------------------------------------------------------------
C
C             FIND OUT WHAT TYPE OF INTERCEPT.
C
          IREGN=IREG(ICEPT)
          ITYPE=HRTYPE(IREGN)
C             IS THIS A NEW REGION BOUNDARY?
          IF(KDEPTH.EQ.0) GO TO 1012
              DO 1013 K=1,KDEPTH
                 IF(IREGN.EQ.KREGN(K) ) GO TO 1014
 1013         CONTINUE
C
              GO TO 1012
C                IT MUST BE AN EXIT POINT - DELETE REFERENCE AND
C                DECREMENT KDEPTH. THIS MAY SEEM UNNECESSARILY
C                COMPLICATED BUT WITH OVERLAPPING REGIONS, AN EXIT
C                POINT DOES NOT NECESSARILY FOLLOW THE CORRESPONDING
C                ENTRY POINT.
C
 1014             JDEPTH=0
                  DO 1019  K = 1,KDEPTH
                     IF(IREGN.EQ.KREGN(K))GO TO 1019
                         JDEPTH = JDEPTH + 1
                         IF(JDEPTH.EQ.K)GO TO 1019
                             KREGN(JDEPTH) = KREGN(K)
                             KTYPE(JDEPTH) = KTYPE(K)
 1019             CONTINUE
                  KDEPTH=JDEPTH
C+++
C     WRITE(6,1657)            KDEPTH,KREGN,KTYPE
C1657 FORMAT('            KDEPTH,KREGN,KTYPE',I15,2(I15,3I5))
C+++
                  GO TO 1000
C
C            IT IS A NEW REGION - INCREMENT KDEPTH.
C
 1012     KDEPTH = KDEPTH + 1
          IF(KDEPTH.LE.4) GO TO 97
           CALL MUERRY('MUFFLY',KDEPTH,'REGIONS OVERLAPPING TOO MUCH.^')
           GO TO 1000
C
   97     KREGN(KDEPTH) = IREGN
          KTYPE(KDEPTH) = ITYPE
C+++
C     WRITE(6,1656)IREGN,ITYPE,KDEPTH,KREGN,KTYPE
C1656 FORMAT(' IREG,ITYPE,KDEPTH,KREGN,KTYPE',3I5,2(I15,3I5))
C+++
C             GO TO NEXT INTERCEPT IF NOT A CHAMBER REGION.
C
          IF(ITYPE.NE.1) GO TO 1000
C
C-----------------------------------------------------------------------
C
C             CHAMBER INTERCEPTED.
C
C CHECK AND RECORD HIT AND PRESERVE SPECIAL VARIABLES IF THERE IS A HIT.
C
      IFIRST = HRFIRS(IREGN)
      ILAST  = HRLAST(IREGN)
      IOR    = HRORI (IREGN)
      IOVALL = HOVALL(HUNIT(HFR(IFIRST)))
C
C-----------------------------------------------------------------------
C
C             WORK OUT PROJECTED VARIANCES FOR THIS REGION.
C
C ADD MULTIPLE SCATTERING AND TRACK FITTING ERRORS TO PRODUCE VARIANCES
C   ON DEVIATIONS AND COVARIANCES BETWEEN ANGLES AND DEVIATIONS
C   NORMAL TO TRACK IN THE 2 PLANES (THE A- & B-PLANES OF JADE NOTE 68.
C   NOTE THAT THE A-PLANE GETS THE LABEL 'Z' & THE B-PLANE 'XY' HERE.)
C
        IF( LCOVAR ) GOTO 995
           VZP = VTZD + VTZANG*(D-DTC)**2
           VZD = VMSD + VZP
           CZ  = CMS + VTZANG*(D-DTC)
           GOTO 996
 995    CONTINUE
           R0P = SQRT(X**2 + Y**2)
           VZP = VTZD + 2.0*R0P*VTZCV + R0P**2*VTZANG
           VZD = VMSD + VZP
           CZ  = CMS + (R0P*VTZANG+VTZCV)/COSEC
C
CCC     VXYD  = VMSD + VTXYD + VTXYAN*(D-DTC)**2
 996    DFXY2 = (X-XEXTRP)**2 + (Y-YEXTRP)**2
        VXYP  = VTXYD + VTXYAN*DFXY2
        VXYD  = VMSD + VXYP
CCC     CXY   = CMS + VTXYAN*(D-DTC)*COSEC
        CXY   = CMS + VTXYAN*SQRT(DFXY2)
C+++
C     WRITE(6,7491)VMSD,CMS,VZP,VZD,CZ,VXYP,CXY
C7491 FORMAT(' MUFFLY: VMSD,CMS,VZP,VZD,CZ,VXYP,CXY',/7G15.5)
C+++
C
C             PREPARE COEFFICIENTS FOR PROJECTING ONTO CHAMBER PLANES.
C
      IF(IOR.EQ.3) GO TO 1003
      AA = -COSEC
      CC = 0.
      IF(IOR.EQ.2)GO TO 1005
      BB = DCY * DCZ * COSEC/DCX
      DD = 1./(DCX * COSEC)
      GO TO 1002
 1005 CONTINUE
        BB = -DCX * DCZ * COSEC/DCY
        DD = -1./(DCY * COSEC)
        GO TO 1002
 1003 CONTINUE
        AA =  (DCY * COSEC)/DCZ
        BB =  (DCX * COSEC)
        CC =  (DCX * COSEC)/DCZ
        DD = -(DCY * COSEC)
 1002 CONTINUE
C+++
C     WRITE(6,2398)AA,BB,CC,DD
C2398 FORMAT(' AA,BB,CC,DD',4G15.5)
C+++
C
C               WORK OUT VARIANCES IN DRIFT (TRANSVERSE)
C               AND WIRE (LONGITUDINAL) DIRECTIONS.
C
      VL1  = AA**2 * VZD + BB**2 * VXYD
      VT1  = CC**2 * VZD + DD**2 * VXYD
      CTL1 = AA*CC * VZD + BB*DD * VXYD
C+++
C     WRITE(6,2399)VL1,VT1,CTL1
C2399 FORMAT(' VL1,VT1,CTL1',3G15.5)
C+++
C
C             STORE THESE VARIANCES AND COVARIANCES, WHICH GIVE
C             THE EFFECT OF MULTIPLE SCATTERING AND INNER DETECTOR
C             TRACK FITTING ERRORS,IN THE ARRAY ELIPSE FOR GRAPHICS USE.
C
      IF(NELIPS.GE.700) GO TO 1004
        ELIPSE(NELIPS+1) = X
        ELIPSE(NELIPS+2) = Y
        ELIPSE(NELIPS+3) = Z
        HLIPSE(2*NELIPS+7) = IDTRK
        HLIPSE(2*NELIPS+8) = IOR
        ELIPSE(NELIPS+5) = VT1
        ELIPSE(NELIPS+6) = VL1
        ELIPSE(NELIPS+7) = CTL1
C
        NELIPS = NELIPS + 7
 1004 CONTINUE
C
C-----------------------------------------------------------------------
C LOOP OVER HITS. ------------------------------------------------------
C-----------------------------------------------------------------------
C
      IF(NHITS.LE.0) GO TO 1000
      NONE=.TRUE.
C
C CLEAR DEVDR ETC. & SET COUNTER OF ASSOCIATED HITS WITHIN REGION.
C   "   EEVDR & MCHAMR    "     "    "  ALL HITS WITHIN REGION.
C
      CALL VZERO(DEVDR,40)
      CALL VZERO(NCHAMR,20)
      CALL VZERO(NHITR,20)
      NHREG = 0
      CALL VZERO(EEVDR,40)
      CALL VZERO(MCHAMR,20)
      CALL VZERO(MHITR,20)
      CALL VZERO(MBADR,20)
      CALL VZERO(NDISQ,20)
      MHREG = 0
C
      IP    = 0
      DO 2000  IHIT = 1,NHITS
      ICHAM=HC(IP+1)/4
C
C                  CHECK IF THIS CHAMBER IN THIS REGION.
C
      IF( ICHAM.LT.IFIRST .OR. ICHAM.GT.ILAST ) GO TO 2001
      ICHIT  = HC(IP+1) - 4*ICHAM + 1
      IFRAME = HFR(ICHAM)
      IFACE  = HFACE(IFRAME)
C
C                  FOR CALCULATION OF ANGLE CORRECTION WITH TRACK "Z" :
      IANG=HANG(IFRAME)
      ZMID=0.5*( HCLLO(IFRAME) + HCLHI(IFRAME) )
      ZHAF=0.5*( HCLHI(IFRAME) - HCLLO(IFRAME) )
C
      BADT   = .NOT.TBIT(HLUN(IHIT),14)
      BADL   = .NOT.TBIT(HLUN(IHIT),15)
      BADH1  = (ICHIT.EQ.1) .AND. (.NOT.TBIT(HLUN(IHIT),7))
      FOUND1 = .FALSE.
      FOUND2 = .FALSE.
      FOUNDL = .FALSE.
C                  NOW ADD CHAMBER MEASURING ERRORS TO COMPUTE CUTS.
      VL   = VL1 + VCL
      CUTL = FACTOR * SQRT(VL)
      IF(BADL) CUTL = FACTOR * SQRT(VL1) + RESLMX
      VCT  = VCT1
      IF(IREGN.GT.32) VCT=VCT2
      VT   = VT1 + VCT
      CUTT = FACTOR * SQRT(VT)
      IF(.NOT.BADH1) GO TO 1920
C WHAT IS THE DRIFT VELOCITY OF THIS CHAMBER AT THIS TIME ?
          IVDRCH = HVDRFT(ICHAM)
          ICRATE = HSECT (IFRAME)
          DELCDM = IVDRCH * ICONST/1000
C
C  CORRECT FOR CRATE 6 CLOCK PULSE .... BUT NOT FOR MONTE-CARLO EVENTS.
C  ( NOTE THAT THE CALIBRATION FILES ALWAYS HAVE CRATE 6 VDR & DTP)
C  ( EQUAL TO GLOBAL VALUES....THIS IS THE EFFECT OF THE VARIOUS)
C  ( UPDATES AS OF 16/03/83.                      )
          IF(ICRATE.EQ.6.AND.KRUN.LT.8256.AND.KRUN.GT.0)
     *    DELCDM=1.26*DELCDM
C
 1920 CONTINUE
C
C             EXCLUDE OVER-WRITTEN HIT1'S FROM THE CHI**2 CALCULATION.
C
      IF(BADH1) BADT = .TRUE.
C
C         CALCULATE THE WIRE COORDINATE (APART FROM OVALL).
C******  AS OF 16/03/83 , APPLY SOFTWARE SHIFT TO WIRE POSITION FOR ALL
C******  DATA AFTER BEGINNING OF 1980 :
      ISHIFT=0
      IF(IYEAR.GE.1980)ISHIFT=HLSF(4,ICHAM)
      IF(IABS(ISHIFT).GT.300)ISHIFT=0
C**** DON'T APPLY SOFTWARE SHIFTS TO MONTE-CARLO DATA.
      IF(KRUN.EQ.0)ISHIFT=0
      ICWIRE=HCTW(ICHAM)-ISHIFT
C
C
C++++
C     WRITE(6,9000)VXYD,VZD,VT1,VL1,CTL1,VT,VL,CUTT,CUTL
C9000 FORMAT(' VXYD,VZD,VT1,VL1,CTL1,VT,VL,CUTT,CUTL',9F10.4)
C++++
C
C-----------------------------------------------------------------------
C
C             PREPARE DEVIATIONS. PROJECT TO ACTUAL CHAMBER PLANE.
C
      GO TO (2101,2102,2103) , IOR
C
 2101 CONTINUE
        DDC = (HDIST(IFRAME) + HD1(ICHAM) + IOVALL -X) / DCX
        CT  = DCY * DDC + Y
        CL  = DCZ * DDC + Z
C
C                  CALCULATE ANGLE CORRECTION WITH TRACK "Z" :
C
        CHAMZ=CL-ZMID
        IF(ABS(CHAMZ).GT.ZHAF)CHAMZ=SIGN(ZHAF,CHAMZ)
        CANG =CHAMZ*FLOAT(IANG)/10000.
C
C                  APPLY ANGLE CORRECTION TO THE Y COORDINATE :
C
        DT1 = HC(IP+4)+CANG-CT
        DT2 = HC(IP+7)+CANG-CT
C
        DL  = HC(IP+5)  - CL
C
C              FOR BAD HITS AND OVER-WRITTEN HIT1'S , NOTE SOME
C              INFORMATION FOR HIT ASSOCIATION TESTS.
C                BADLY DIGITISED HIT ; NOTE CHAMBER EDGES.
C                   OVER-WRITTEN HIT1; NOTE POSITION OF HIT2.
        IF(.NOT.BADT)GO TO 2200
           IF(BADH1)GO TO 2111
              TEDGE1=ICWIRE+CANG-150.
              TEDGE2=ICWIRE+CANG+150.
              GO TO 2200
 2111            TEDGE1=HC(IP+4)+CANG-DELCDM
                 TEDGE2=HC(IP+7)+CANG+DELCDM
                 GO TO 2200
C
C
 2102 CONTINUE
        DDC = (HDIST(IFRAME) + HD1(ICHAM) - Y) / DCY
        CT  = DCX * DDC + X
        CL  = DCZ * DDC + Z
C
C                  CALCULATE ANGLE CORRECTION WITH TRACK "Z" :
C
        CHAMZ=CL-ZMID
        IF(ABS(CHAMZ).GT.ZHAF)CHAMZ=SIGN(ZHAF,CHAMZ)
        CANG =CHAMZ*FLOAT(IANG)/10000.
C
C                  APPLY ANGLE CORRECTION TO THE X COORDINATE :
C
        DT1 = HC(IP+3)+CANG-CT
        DT2 = HC(IP+6)+CANG-CT
C
        DL  = HC(IP+5)  - CL
C
        IF(.NOT.BADT)GO TO 2200
           IF(BADH1)GO TO 2112
              TEDGE1=ICWIRE+IOVALL+CANG-150.
              TEDGE2=ICWIRE+IOVALL+CANG+150.
              GO TO 2200
 2112            TEDGE1=HC(IP+3)+CANG-DELCDM
                 TEDGE2=HC(IP+6)+CANG+DELCDM
                 GO TO 2200
C
C
 2103 CONTINUE
        DDC = (HDIST(IFRAME) + HD1(ICHAM) - Z) / DCZ
        CT  = DCX * DDC + X
        CL  = DCY * DDC + Y
C
C                  CALCULATE ANGLE CORRECTION WITH TRACK "Z" :
C
        CHAMZ=CL-ZMID
        IF(ABS(CHAMZ).GT.ZHAF)CHAMZ=SIGN(ZHAF,CHAMZ)
        CANG =CHAMZ*FLOAT(IANG)/10000.
C
C                  APPLY ANGLE CORRECTION TO THE X COORDINATE :
C
        DT1 = HC(IP+3)+CANG-CT
        DT2 = HC(IP+6)+CANG-CT
C
        DL  = HC(IP+4)  - CL
C
        IF(.NOT.BADT)GO TO 2200
           IF(BADH1)GO TO 2113
              TEDGE1=ICWIRE+IOVALL+CANG-150.
              TEDGE2=ICWIRE+IOVALL+CANG+150.
              GO TO 2200
 2113            TEDGE1=HC(IP+3)+CANG-DELCDM
                 TEDGE2=HC(IP+6)+CANG+DELCDM
                 GO TO 2200
C
C
C-----------------------------------------------------------------------
C
C             CHECK IF COORDINATES ARE WITHIN CUTS.
C
 2200 IF( ABS(DT1).LE.CUTT ) FOUND1 = .TRUE.
      IF( ABS(DT2).LE.CUTT ) FOUND2 = .TRUE.
      IF( ABS(DL) .LE.CUTL ) FOUNDL = .TRUE.
C
      IF(FOUND1.OR.FOUND2)GO TO 2210
C
C         FURTHER CHECKS OF ASSOCIATION FOR BAD HITS :
C
C
          IF(.NOT.BADT)GO TO 2210
C
C CHECK IF THE TEST EDGE IS WITHIN FACTOR*SIGMA OF THE TRACK ; IF SO,
C THEN ASSOCIATE THE HIT WITH THE TRACK.
C   IF THE TRACK IS EXPECTED TO GO BEWEEN THE TEDGES, THEN THERE
C   IS NO NEED TO DO THE WEDGE TESTS.
              IF(TEDGE1.LT.CT  .AND.  TEDGE2.GT.CT)GO TO 2205
                WEDGE1=CT-CUTT
                WEDGE2=CT+CUTT
                IF(WEDGE1.LT.TEDGE1  .AND.  WEDGE2.GT.TEDGE1)GO TO 2205
                 IF(WEDGE1.LT.TEDGE2  .AND.  WEDGE2.GT.TEDGE2)GO TO 220500056000
                   GO TO 2210
 2205           FOUNDL=.TRUE.
                FOUND1=.TRUE.
                FOUND2=.FALSE.
                IF(ABS(DT1).LT.ABS(DT2))GO TO 2210
                   FOUND1=.FALSE.
                   FOUND2=.TRUE.
C
 2210    CONTINUE
C
C
C-----------------------------------------------------------------------
C
 2020 CONTINUE
C
C  PROTECT AGAINST OVERFLOWS IN THE ARRAYS FOR WHICH MHREG IS INDEX.
      IF(MHREG.LT.20) GO TO 2018
      CALL MUERRY('MUFFLY',IREGN,'(=REGION NO.) HAS >20 MUCOOR HITS -
     * MUFFLY CHECKS ON NON-ASSOCIATED HITS LIMITED.^')
        GO TO 2019
C           NOTE EEVDR, MCHAMR,MHITR.
 2018 MHREG=MHREG+1
      EEVDR(MHREG,1)  = DT1
      EEVDR(MHREG,2)  = DT2
      MCHAMR(MHREG)   = ICHAM
      MHITR(MHREG)    = IHIT
      MBADR(MHREG)    = BADT
 2019 CONTINUE
C+++
C                WRITE(6,2016)IDTRK,IREGN,MHREG,BADT
C2016            FORMAT('           TRACK NO./IREGN/MHREG/BADT:',3I6,L3)
C+++
C             DECIDE WHETHER TO KEEP HIT OR NOT.
C++++
C     WRITE(6,9001)DL,DT1,DT2,FOUND1,FOUND2,FOUNDL
C9001 FORMAT(' DL,DT1,DT2,FOUND,IAMB',3F10.4,3L5)
C++++
C
C   AT THE MOMENT THE HIT IS ASSOCIATED WITH THE EXTRAPOLATED INNER
C   DETECTOR TRACK USING THE DRIFT INFORMATION ALONE. THE LONGITUDINAL
C   INFORMATION IS INSPECTED (BUT NOT USED FOR SELECTION) ONLY IF
C   AT LEAST ONE OF THE DRIFT COORDINATES (LEFT OR RIGHT) IS IN THE CUT.
C
      IF( .NOT.(FOUND1.OR.FOUND2) ) GO TO 2001
C
C             ***  HIT HAS BEEN FOUND  ***
C             FLAG A HIT FOR THIS TRACK, THIS REGION.
C
      NONE=.FALSE.
C
C             INCREMENT HIT COUNTER AND SAVE THE REGION NUMBER IN
C             WHICH THE HIT WAS FOUND. SAVE THE DEVIATIONS (IN UNITS
C             OF SIGMA(TOT) ) FOR EACH AMBIGUITY IF ASSOCIATED.
C             SAVE THE AMOUNT OF ABSORBER TRAVERSED TO THIS REGION.
C
      NTHIS = NTHIS + 1
C
C             PROTECT AGAINST OVERFLOWS IN IHTREG :
C
      IF(NTHIS.LE.20) GO TO 96
      CALL MUERRY('MUFFLY',IDTRK,'(=TRACK NO.) HAS >20 ASSOCIATED HITS -
     * MUFFLY PROCESSING TERMINATED FOR THIS TRACK.^')
        GO TO 1000
C
 96   IHTREG(NTHIS) = IREGN
      ALLABS(NTHIS) = AB
C                         WHEN A TRACK CHANGES FACES THE DEVIATIONS
C                         MUST HAVE THE SAME LEFT/RIGHT SIGN CONV.
      IFAS = 1
      IF(IFACE.EQ.2 .OR. IFACE.EQ.3) IFAS = -1
      IF(FOUND1) ALLDEV(NTHIS,1) = IFAS * DT1/SQRT(VT)
      IF(FOUND2) ALLDEV(NTHIS,2) = IFAS * DT2/SQRT(VT)
C
C             MARK BAD DRIFT HITS WITH A 100 SIGMA DEVIATION
C
      IF(.NOT.(BADT .OR. BADH1) ) GO TO 3050
        ALLDEV(NTHIS,1) = 100.
        ALLDEV(NTHIS,2) = 100.
C
C                COUNT HITS ASSOCIATED WITH THIS TRACK IN THIS REGION.
 3050            NHREG = NHREG + 1
C+++
C                WRITE(6,3006)NTHIS,IREGN,NHREG,BADT
C3006            FORMAT(' NTHIS/IREGN/NHREG/BADT:',3I6,L3)
C+++
C                NOTE DEVDR, NCHAMR,NHITR
                 NCHAMR(NHREG) = ICHAM
                 NHITR(NHREG)  = IHIT
                 IF(FOUND1)DEVDR(NHREG,1)=DT1
                 IF(FOUND2)DEVDR(NHREG,2)=DT2
C
C             MAKE ENTRIES IN MUR2 BANKS 2 AND 3.
C             BANK 3 IS MODIFIED IN MUFFLX.
C
      J     = NTPH * (IHIT-1)
      JLAST = J + NTPH
 2021 CONTINUE
      J = J + 1
      IF(HTC(J).EQ.0) GO TO 2022
      IF(J.LT.JLAST)  GO TO 2021
      IF(HTC(J).GT.0) HTC(J) = - HTC(J)
      J = -1
      GO TO 2023
C
 2022 HTC(J) = IDTRK
      IF(FOUND1) HAMB(J) = -1
      IF(FOUND2) HAMB(J) =  1
      IF(FOUND1.AND.FOUND2) HAMB(J) = 0
C
C              FILL ENTRIES IN ERROR MATRIX, ETC.
C
 2023 IF(NTHIS.LE.10) GO TO 98
      CALL MUERRY('MUFFLY',IDTRK,'(=TRACK NO.) HAS >10 ASSOCIATED HITS -
     * NO FURTHER HITS USED IN CHI**2.^')
        GO TO 2001
C
   98 I3 = 3 * NTHIS
      I2 = I3 - 1
      I1 = I2 - 1
      IL = 2 * NTHIS
      IT = IL - 1
      IJA(NTHIS)    = J
      DALONG(NTHIS) = D
      DEV(I1) = DT1
      DEV(I2) = DT2
      DEV(I3) = DL
      EM(IT,IT) = VT
      EM(IL,IL) = VL
      EM(IT,IL) = CTL1
C             (FILL IN TRANSPOSED ELEMENT LATER - EM IS SYMMETRIC.)
      VXYDA(NTHIS) = VXYD
      VZDA(NTHIS)  = VZD
      CXYA(NTHIS)  = CXY
      CZA(NTHIS)   = CZ
      AAA(NTHIS)   = AA
      BBB(NTHIS)   = BB
      CCC(NTHIS)   = CC
      DDD(NTHIS)   = DD
      INCUT(I1)    = FOUND1
      INCUT(I2)    = FOUND2
      INCUT(I3)    = FOUNDL
      BADA(IT)     = BADT
      BADA(IL)     = BADL
      ITHISA(NTHIS)= IHIT
      CTDASH(NTHIS)= CT
      CLDASH(NTHIS)= CL
      VTDASH(NTHIS)= VT1
      VLDASH(NTHIS)= VL1
C
C        NOW FILL IN CORRELATIONS WITH PREVIOUS HITS (IF ANY).
C
      IF(NTHIS.LE.1) GO TO 2001
      NTHOSE = NTHIS - 1
      DO 2030  NTHAT = 1,NTHOSE
        J3    = 3 * NTHAT
        J2    = J3 - 1
        J1    = J2 - 1
        JL    = 2 * NTHAT
        JT    = JL - 1
        D12   = D - DALONG(NTHAT)
        CZ12  = VZDA(NTHAT)  + CZA(NTHAT)  * D12
        CXY12 = VXYDA(NTHAT) + CXYA(NTHAT) * D12
        CL12  = AAA(NTHAT) * AA * CZ12 + BBB(NTHAT) * BB * CXY12
        CT12  = CCC(NTHAT) * CC * CZ12 + DDD(NTHAT) * DD * CXY12
        CL1T2 = AAA(NTHAT) * CC * CZ12 + BBB(NTHAT) * DD * CXY12
        CT1L2 = CCC(NTHAT) * AA * CZ12 + DDD(NTHAT) * BB * CXY12
C+++
C     WRITE(6,4691)NTHAT,AAA(NTHAT),BBB(NTHAT),CCC(NTHAT),DDD(NTHAT)
C4691 FORMAT(' NTHAT,AAA(NTHAT),BBB-,CCC-,DDD-',I5,4G15.5)
C     WRITE(6,3429)D12,CZ12,CXY12,CL12,CT12,CL1T2,CT1L2
C3429 FORMAT(' D12,CZ12,CXY12,CL12,CT12,CL1T2,CT1L2',7G12.5)
C+++
        EM(JT,IT) = CT12
        EM(JL,IL) = CL12
        EM(JT,IL) = CT1L2
        EM(JL,IT) = CL1T2
C             (FILL IN TRANSPOSED ELEMENTS LATER.)
 2030 CONTINUE
C
C-----------------------------------------------------------------------
C
C END OF LOOP.
C
 2001 CONTINUE
      IP=IP+NWHIT
 2000 CONTINUE
C
C-----------------------------------------------------------------------
C END OF LOOP OVER HITS. -----------------------------------------------
C-----------------------------------------------------------------------
C
C             HAVE ANY HITS BEEN FOUND IN THIS REGION?
C
      IF(NONE)GO TO 1000
C
C AT LEAST ONE HIT HAS BEEN FOUND FOR THIS TRACK IN THIS REGION.
C UPDATE SPECIAL VARIABLES.
C
      CALL UCOPY(X,X0,NSPECI)
C
C             INCREMENT LAYRAB AND NOTE THE REGION NO. IN IEFFRG.
C
      LAYRAB         = LAYRAB+1
      IEFFRG(LAYRAB) = IREGN
C
C             FLAG  PAIRS OF ASSOCIATED OVERLAP HITS.
C               ( IT WAS ORIGINALLY INTENDED THAT THIS SHOULD BE
C                 DONE IN A SEPARATE ROUTINE , MUOLAP , BUT COMPILER
C                 BUG PREVENTED COMMUNICATION OF IOVLAP.  )
C
      NLOREG = NTHIS-NHREG+1
      IF(NHREG.LT.2)GO TO 4100
          NHLES1=NHREG-1
          DO 4050 NHIT=1,NHLES1
              NHAND1=NHIT+1
              DO 4050 NOVHIT=NHAND1,NHREG
C+++
C         WRITE(6,4006)
C    *   (DEVDR(NHIT  ,K),K=1,2),NCHAMR(NHIT),NHITR(NHIT),
C    *   (DEVDR(NOVHIT,K),K=1,2),NCHAMR(NOVHIT),NHITR(NOVHIT)
C4006    FORMAT('0 DEV/NCHAMR/NHITR(NHIT) :',2F8.1,' / ',I5,' / ',I5,
C    *        '  DEV/NCHAMR/NHITR(NOVHIT) :',2F8.1,' / ',I5,' / ',I5)
C+++
C
C                     ARE NHIT & NOVHIT IN ADJACENT CHAMBERS ?
C
                  IF(IABS(NCHAMR(NHIT)-NCHAMR(NOVHIT)).NE.1)GO TO 4050
C
C                         PICK UP INDICES IN RANGE 1-->NTHIS
                      NTHIS1 = 0
                      NTHIS2 = 0
                      DO 4010 ITH=NLOREG,NTHIS
                              IHIT=ITHISA(ITH)
                              IF(NHITR(NHIT  ).EQ.IHIT)NTHIS1=ITH
                              IF(NHITR(NOVHIT).EQ.IHIT)NTHIS2=ITH
 4010                 CONTINUE
C+++
C         WRITE(6,4016)NTHIS1,NTHIS2
C4016    FORMAT('0 NTHIS OF NHIT / NOVHIT =',2I3)
C+++
C
C                        SET OVERLAP TEST TOLERANCE ; OVLCUT FOR 2 GOOD
C                        HITS , (OVLCUT+15)MM IF ONE OR MORE OF THE HITS
C                        IS BAD.
C
                      OVTEST=OVLCUT
                      IF(BADA(2*NTHIS1-1).OR.BADA(2*NTHIS2-1))
     +                OVTEST=OVLCUT+15.
C+++
C         WRITE(6,4026)OVTEST
C4026    FORMAT('+',45X,' TOLERANCE ( OVTEST) =',F5.1)
C+++
C
                      I3=3*NTHIS1
                      I2=I3-1
                      I1=I2-1
                      J3=3*NTHIS2
                      J2=J3-1
                      J1=J2-1
C+++
C         WRITE(6,4036)INCUT(I1),INCUT(I2),INCUT(J1),INCUT(J2)
C4036    FORMAT('+',75X,' INCUTS NHIT/NOVHIT =',2L2,' / ',2L2)
C+++
                      IF(.NOT.INCUT(I1))GO TO 4020
C
C                           LEFT AMB OF NTHIS1 IS ASSOCIATED ;
C                           IS IT AN OVERLAP WITH RIGHT AMB OF NTHIS2 ?
C
                          IF(.NOT.INCUT(J2))GO TO 4020
                             DEVDIF=DEVDR(NHIT,1)-DEVDR(NOVHIT,2)
                             IF(ABS(DEVDIF).GT.OVTEST)GO TO 4020
C
C                              NHIT (LEFT) & NOVHIT (RIGHT) OVERLAP.
                               IOVLAP(NTHIS1,NTHIS2)=1
C
 4020                  IF(.NOT.INCUT(I2))GO TO 4050
C
C                            RIGHT AMB OF NTHIS1 IS ASSOCIATED ;
C                            IS IT AN OVERLAP WITH LEFT AMB OF NTHIS2 ?
C
                          IF(.NOT.INCUT(J1))GO TO 4050
                             DEVDIF=DEVDR(NHIT,2)-DEVDR(NOVHIT,1)
                             IF(ABS(DEVDIF).GT.OVTEST)GO TO 4050
C
C                               NHIT (RIGHT) & NOVHIT (LEFT) OVERLAP.
                                IOVLAP(NTHIS2,NTHIS1)=1
C
 4050      CONTINUE
C
 4100 CONTINUE
C
C+++
C                     WRITE(6,4106)
C4106                 FORMAT('0 NON-ZERO ELEMENTS OF OVERLAP MATRIX :')
C                     DO 4150 IOL=1,20
C                     DO 4150 JOL=1,20
C                     IF(IOVLAP(IOL,JOL).NE.0)WRITE(6,4156)IOL,JOL,
C    *                                        IOVLAP(IOL,JOL)
C4156                 FORMAT(' I / J / ELEMENT ',3I4)
C4150                 CONTINUE
C+++
C
C        CHECK IF ANY ASSOCIATED SINGLE AMBIGUITY OF ANY HIT IS ACTUALLY
C        THE 'OTHER' AMBIGUITY OF AN OVERLAP PAIR (NEITHER OF THE AMBS
C        IN THE PAIR NEED BE ASSOCIATED.)
C
      IF(MHREG.LT.2)GO TO 5100
          DO 5050 NHIT=1,NHREG
C+++
C         WRITE(6,5006)
C    *   (DEVDR(NHIT  ,K),K=1,2),NCHAMR(NHIT),NHITR(NHIT)
C5006    FORMAT('0 DEV/NCHAMR/NHITR(NHIT) :',2F8.1,' / ',I5,' / ',I5)
C+++
C
                  DO 5010 ITH=NLOREG,NTHIS
                          IHIT=ITHISA(ITH)
                          IF(NHITR(NHIT).EQ.IHIT)NTHIS1=ITH
 5010             CONTINUE
                  I3=3*NTHIS1
                  I2=I3-1
                  I1=I2-1
C+++
C         WRITE(6,5016)NTHIS1,INCUT(I1),INCUT(I2)
C5016    FORMAT('0 NTHIS OF NHIT =',I3,' INCUTS =',2L3)
C+++
C         ----------- IF BOTH AMBS ARE ASSOCD, THEN NO REJECTION.
                  IF(INCUT(I1).AND.INCUT(I2))GO TO 5050
C
C         ----------- NOTE INDEX IN 1--> MHREG OF THE CURRENT ASSOCIATED
C                     HIT. THIS IS NECESSARY SINCE DEVDR HOLDS
C                     DEVIATIONS OF ONLY THE ASSOCIATED AMB(S).
                     DO 5012 MHIT=1,MHREG
                             IF(NHITR(NHIT).EQ.MHITR(MHIT))MHITN=MHIT
 5012                CONTINUE
C+++
C          WRITE(6,5026)MHITN
C5026      FORMAT(' MHIT CORRESPONDING TO NHIT , I.E. MHITN =',I3)
C+++
C
C         ----------- LOOP OVER ALL HITS IN THE REGION AGAIN TO CARRY
C                     OUT THE CHECK.
                     DO 5020 MHIT=1,MHREG
C               ----------IS THIS HIT IN THE CHAMBER NEXT TO THE
C                         CURRENT ASSOCIATED HIT , AND IS IT ON THE
C                         OPPOSITE SIDE FROM THE ASSOCIATED AMBIGUITY ?
                        NEIGHB=MCHAMR(MHIT)-NCHAMR(NHIT)
                        IF(IABS(NEIGHB).NE.1)GO TO 5020
                        IF(NEIGHB.GT.0.AND.INCUT(I2))GO TO 5020
                        IF(NEIGHB.LT.0.AND.INCUT(I1))GO TO 5020
C                   ------- IF THE NEIGHBOURING HIT IS ALSO ASSOCIATED
C                           WITH THIS TRACK, NO REJECTION.
                        DO 5015 NHIT2=1,NHREG
                             IF(NHITR(NHIT2).EQ.MHITR(MHIT))GO TO 5020
 5015                   CONTINUE
C                   ------- HAVE FOUND A NON-ASSOCIATED HIT ON THE
C                           'CORRECT' SIDE OF THE CURRENT ASSOCD HIT.
C                           DOES IT MAKE AN OVERLAP  WITH THE NON-
C                           ASSOCD AMB OF THE CURRENT ASSOCD HIT?
C                           IF SO , SET THE DISQUALIFICATION FLAG FOR
C                           THIS ASSOCIATED HIT.
C+++
C         WRITE(6,5036)
C    *   (EEVDR(MHIT ,K),K=1,2),MCHAMR(MHIT),MHITR(MHIT),
C    *   (EEVDR(MHITN,K),K=1,2),MCHAMR(MHITN),MHITR(MHITN)
C5036    FORMAT('0 DEV/MCHAMR/MHITR(MHIT) :',2F8.1,' / ',I5,' / ',I5,
C    *        '  DEV/MCHAMR/MHITR(MHITN) :',2F8.1,' / ',I5,' / ',I5)
C+++
                            INHAMB=1
                            IMHAMB=2
                            IF(INCUT(2))GO TO 5017
                               INHAMB=2
                               IMHAMB=1
C                            ------- NOTE: COMPARE EEVDR ENTRIES OF
C                                          MHITN AND MHIT.
 5017                      DEVDIF=EEVDR(MHITN,INHAMB)-EEVDR(MHIT,IMHAMB)
                            OVTEST=OVLCUT
                            IF(MBADR(MHIT).OR.BADA(2*NTHIS1-1))
     *                         OVTEST=OVLCUT+15.
                            IF(ABS(DEVDIF).GT.OVTEST)GO TO 5020
                               NDISQ(NHIT)=.TRUE.
                               IHTREG(NTHIS1)=-IREGN
 5020                 CONTINUE
 5050      CONTINUE
C
C  LOOP OVER ALL ASSOCIATED HITS AGAIN TO CHECK IF ANY OF THEM SURVIVE
C  THE ABOVE DISQUALIFICATION PROCEDURE.
        IOK=0
        DO 5070 NHIT=1,NHREG
             IF(.NOT.NDISQ(NHIT))IOK=IOK+1
 5070   CONTINUE
        IF(IOK.GE.1)GO TO 5100
C     -----THIS REGION HAS ALL ASSOCIATED HITS DISQUALIFIED.
           IEFFRG(LAYRAB)=-IREGN
C+++
C        WRITE(6,5076)(NDISQ(K),K=1,20),(IHTREG(K),K=1,10),
C    *                (IEFFRG(K),K=1,10)
C5076    FORMAT('0 NDISQ/IHTREG/IEFFRG :',20L1,20I4)
C+++
C
 5100 CONTINUE
C
C-----------------------------------------------------------------------
C
 1000 CONTINUE
C
C-----------------------------------------------------------------------
C END OF MAIN LOOP OVER REGIONS. ---------------------------------------
C-----------------------------------------------------------------------
C
C+++
C     WRITE(6,1826)DOVER,GMOVER,ABOVER,RDOVER,DEOVER
C1826 FORMAT(' DOVER,GMOVER,ABOVER,RDOVER,DEOVER ',5G15.5)
C+++
C
C-----------------------------------------------------------------------
      RETURN
C-----------------------------------------------------------------------
C
C             TRACK STOPPED. JUMP HERE FROM RETURN OF MUFFLS
C
 3333 RETURN 1
      END

C   19/02/84 402192324  MEMBER NAME  RDPOIN   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDPOIN( H1, N2, H2 )
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    25/04/79 :  PURGE DELETED HITS
C
C        MOD  E. ELSEN    02/05/79 :
C        MOD  C. BOWDERY  29/09/83 :  POINTERS FROM OLD TO NEW HITS
C   LAST MOD  C. BOWDERY  17/10/83 :  NEGATIVE VALUES FOR ABSORBED HITS
C
C        ERASE WIRES IN ARRAY H2 (TOTAL N2) WITH ZERO WIRE NUMBER
C        AND COPY TO H1 STARTING IN POSITION 99.
C        CELL POINTERS ARE STORED IN H1(1..98).
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CWORK  / HWORK(20000)
      COMMON / CWORK1 / JHITS, H4VJH(4000), H4VMRG(5000)
C
      DIMENSION H1(2), H2(2)
C
      DATA ICLENG / 98 /
C
C---------------------------  C O D E  ---------------------------------
C
C                  CLEAR ARRAY OF POINTERS FROM INPUT SET OF HITS TO
C                  THE OUTPUT SET OF HITS
C
      DO  1  I = 1,N2
        H4VMRG(I) = 0
  1   CONTINUE
      JNEWP = 1
      JOLDP = 1
C
      IL  = ICLENG
      IL2 = 1
      IR2 = IL2
      IH2 = N2*4 + IL2
      H2(IH2) = 0
C
C                  COPY WIRES, OMIT ZEROS
C
  100 IF( IR2 .GT. IH2 ) GO TO 1000
C
C                  USE A BLOCK TRANSFER STRATEGY. IF WIRE NUMBER IS NOT
C                  ZERO THEN INCREASE POINTER. ONLY COPY A BLOCK WHEN
C                  A DELETED HIT IS FOUND.
C

      IF( H2(IR2) .NE. 0 ) GO TO 300
C
C                  COPY OLD INFORMATION, IF ANY, AND INCREMENT INDEX
C
         LD = IR2 - IL2
         IF( LD . LE. 0 ) GO TO 200
         CALL MVCL( H1, IL*2, H2, (IL2-1)*2, LD*2 )
         IL = IL + LD
  200    IL2 = IR2 + 4
         GO TO 400
C
C                  IF WIRE NOT ZERO (HIT NOT DELETED), STORE NEW
C                  POSITION FOR THIS HIT
C
  300    H4VMRG(JOLDP) = JNEWP
         JNEWP = JNEWP + 1
  400    JOLDP = JOLDP + 1
         IR2 = IR2 + 4
      GO TO 100
 1000 CONTINUE
C
C                  SET UP CELL POINTERS
C
      ICL = 0
      ILOW = 1
      IH = IL - 3
      IL = ICLENG + 1
 1100 IF( IL .GT. IH ) GO TO 1400
           ICELL = H1(IL) / 128 + 1
               IF( ICELL .EQ. ICL ) GO TO 1300
                      DO 1200 I = ILOW, ICELL
 1200                 H1(I) = IL - ICLENG
                      ILOW = ICELL + 1
                      ICL = ICELL
 1300          IL = IL + 4
      GO TO 1100
C
 1400 DO 1500 I=ILOW, ICLENG
 1500 H1(I) = IL - ICLENG
C
C                  USE THE H4VJH POINTER LIST WITH THE NEW H4VMRG LIST
C                  TO CREATE A FINAL ASSOCIATION ARRAY BETWEEN THE
C                  HIT INFORMATION IN THE ORIGINAL JETC BANK AND THE
C                  NEW SMEARED JETC BANK
C
      DO  2  I = 1,JHITS
        I4VJH    = H4VJH(I)
        H4VJH(I) = H4VMRG( IABS( I4VJH ) ) * ISIGN( 1,I4VJH)
 2    CONTINUE
C
      RETURN
      END

C   05/02/80 002161934  MEMBER NAME  DEDXBK0  (JADEGS)      FORTRAN
      SUBROUTINE DEDXBK(IPPATR)
C*800213*OLSSON*****************************************************
C*                                                                 *
C* C R E A T E  B A N K  DEDX  F R O M  D E D X A N  R E S U L T S *
C*                                                                 *
C*******************************************************************
C             IPPATR IS POINTER TO 'PATR' ;  SAME BOSBANK NR IS USED
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CWORK1/ IER,NTR,TRES(10,60)
      DIMENSION ITRES(10,60)
      EQUIVALENCE (TRES(1,1),ITRES(1,1))
C
      IF(NTR.EQ.0) GO TO 100
      NTRR = MIN0(NTR,60)
C****
C
      NBNK = IDATA(IPPATR-2)
      NWRES = 2 + NTRR*10
      CALL CCRE(IPHT,'DEDX',NBNK,NWRES,IERR)
      IF(IERR.NE.0) GO TO 100
      CALL BSAW(1,'DEDX')
      IDATA(IPHT+1) = IER
      IDATA(IPHT+2) = NTRR
      DO 1  ITR = 1,NTRR
      ITRX = IPHT+2+(ITR-1)*10
      DO 1  I = 1,10
1     IDATA(ITRX+I) = ITRES(I,ITR)
  100 RETURN
      END

C   14/12/83 401111710  MEMBER NAME  USER     (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE USER(INDEX)
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL   ?/??/78 :  USER ROUTINE CALLED BY SUPERV
C
C        MOD: C. BOWDERY  14/12/83 :  TO IMPROVE THE COMMENTING
C   LAST MOD: C. BOWDERY   9/01/84 :  TO REMOVE EXCESS CODE
C
C        USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C
C-----------------------------------------------------------------------
C
C        INDEX IS PASSED FROM SUPERV TO INDICATE WHICH LEVEL HAS BEEN
C        COMPLETED. THE MEANING OF THE VALUES IS EXPLAINED BELOW.
C
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   UNUSED
C              9   MUON ANALYSIS HAS BEEN DONE
C             10   UNUSED
C
C            100   END OF JOB CALL
C
C   ON RETURN, IF INDEX =  1 : THE SUPERVISOR WILL DROP CURRENT EVENT
C                              AND READ THE NEXT ONE.
C                         11 : EVENT WILL BE WRITTEN OUT AND NEW EVENT
C                              WILL BE READ
C                         12 : JOB WILL BE TERMINATED NORMALLY
C
C   OTHERWISE THE SUPERVISOR WILL GO TO THE LEVEL GIVEN BY "INDEX" ON
C   RETURN FROM "USER". THUS, TO CONTINUE WITH THE ANALYSIS, THIS
C   ROUTINE MUST INCREMENT "INDEX" BEFORE PASSING CONTROL BACK.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
#include "cdata.for"
C
C
C------------------  C O D E  ------------------------------------------
C
C        CHECK WHETHER CALL AT END OF JOB
C
      IF(INDEX.EQ.100) GOTO 1100
C
      GO TO (1001,1002,1003,1004,1005,1006,1007,1008,1009,1010),INDEX
C---
C---     INDEX=0 INITIALIZATION.
C---
C
      INDEX=INDEX+1
      RETURN
C
 1001 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1002 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1003 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1004 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1005 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1006 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1007 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1008 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1009 CONTINUE
      INDEX=INDEX+1
      RETURN
C
 1010 CONTINUE
      INDEX=INDEX+1
      RETURN
C---     END OF JOB: FINAL CALCULATIONS + PRINTOUT
 1100 CONTINUE
      CALL BSTA
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---
    1 CONTINUE
      INDEX=1
      RETURN
    2 CONTINUE
      INDEX=2
      RETURN
    3 CONTINUE
      INDEX=3
      RETURN
    4 CONTINUE
      INDEX=4
      RETURN
    5 CONTINUE
      INDEX=5
      RETURN
    6 CONTINUE
      INDEX=6
      RETURN
    7 CONTINUE
      INDEX=7
      RETURN
    8 CONTINUE
      INDEX=8
      RETURN
    9 CONTINUE
      INDEX=9
      RETURN
   10 CONTINUE
      INDEX=10
      RETURN
      END

C   09/11/81 705131621  MEMBER NAME  LSCCTL0  (S)           FORTRAN
      SUBROUTINE LSCCTL(XU,JBC)
C
C     S.YAMADA   09-03-78  17:50
C     LAST MODIFICATION  09-11-81  21:35
C
C MODIFIED TO WORK WITH SF5-SF6 MVERSION OF SHOWER MC   23.1.86  J.0.
C
C
C---- MAIN SUBROUTINE TO CONTROL LEAD-GLASS CERENKOV LIGHT GENRTN.
C
C
C  SHOWER MC COMMON
C
      COMMON /CLGD56/ RADIUS(6),ZEND(2),ZWID,ZGAP,PHWID,
     2                ECXLST(24), ECYLST(24),ZECAP(4),ZPV(4),TPV,
     3                TH(4),THECP
C     COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
C    1                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
C    2                ZECAP(4),ZECAPX(4),THECPX(2),
C    3                ECXLST(24), ECYLST(24),
C    4                ZPV(4),ZPVX0(4),TPV(2),TH(4)
C
      COMMON /CMATTR/ IMATTR,IMTLIS(10),XCM(10)
C
      COMMON / COLSON/ IPRO
      DIMENSION XO(3),PA0(9),XABS(3)
C
C
C---- XU(1--6) = POSITION AND DIRECTION OF THE PARTICLE INJECTED
C                INTO THE LEAD GLASS
C          THE UNIT OF XU(1--3) IS MM FOR INPUT
C            UNIT IS NOT CHANGED HERE, CONTRARY TO THE OLD VERSION
C
      DIMENSION XU(6)
C
C---- MEMORIZE THE INCIDENT DIRECTION AND ROTATE AROUND Z-AXIS
C    SO THAT IT HITS THE LEAD GLASS IN THE X-Z PLANE.
C
C  COSP AND SINP ARE PROJECTED ANGLES IN X-Y PLANE. ROTATION INTO THE
C   X-Z PLANE ACCORDING TO:
C
C       | COSP   SINP     0  |   |  XU(4)  |
C       |-SINP   COSP     0  | * |  XU(5)  |
C       |   0      0      1  |   |  XU(6)  |
C
C
      JBCI = JBC
      SJBC = JBC
      IF(JBC) 2,1,2
C
C        BARREL PART
C
    1 COSP = XU(1)/RADIUS(1)
      SINP = XU(2)/RADIUS(1)
C
C     XU(1) = RADSX0(1)
      XU(1) = RADIUS(1)
      XU(2) = 0.
C     XU(3) = XU(3)/X0
      W = XU(4)*COSP+XU(5)*SINP
      XU(5) = XU(5)*COSP-XU(4)*SINP
      XU(4) = W
      RETURN
C
C---- END CAP PART
C
C   2 W = XU(1)/X0
    2 W = XU(1)
C     XU(1) = XU(3)*SJBC/X0
      XU(1) = XU(3)*SJBC
C     XU(3) = XU(2)/X0
      XU(3) = XU(2)
      XU(2) = W
      W = XU(4)
      XU(4) = XU(6)*SJBC
      XU(6) = XU(5)
      XU(5) = W
      RETURN
C
C***********************************
C
      ENTRY LSCCTC(XO,PA0,T)
C
C   UPON ENTRY, UNIT IS RADIATION LENGTH. MULTIPLY BACK TO MM UNIT, BY
C        RAD.LENGTH FOR THE MATERIAL IN QUESTION (IMATTR AND XCM)
C     NOTE:  XCM IS GIVEN IN UNIT OF CM
C
C   PA0 IS THE 9-VECTOR OF THE PARTICLE, AT CURRENT POSITION
C   XO IS THE POSITION AT START
C
C
C---- CALCULATE BETA**2
C---- ENERGY UNIT OF PA0 IS ELECTRON MASS.
      BETA2 = 1.0-1.0/PA0(2)**2
C
      IF(IPRO.GT.0) WRITE(6,2001) (XO(IK),IK=1,3),BETA2,T
2001  FORMAT(' LSCCTC: XO ',3E12.4,' BETA2 ',E12.4,' T ',E12.4)
C
      IF(IPRO.GT.0) WRITE(6,2002) (PA0(IJ),IJ=1,9)
2002  FORMAT(' LSCCTC: PA0 ',9E12.4)
C
C---- SET THE AVERAGE POSITION
        DO 10 I=1,3
   10   XABS(I) = 0.5*(XO(I)+PA0(I+3))
      DEPTH = XABS(1)
      XJJ = XCM(IMATTR)*10.
      DEPTHM = DEPTH*XJJ
C
      IF(IPRO.GT.0) WRITE(6,2003) JBC,DEPTH,DEPTHM
2003  FORMAT(' LSCCTC: JBC ',I3,' DEPTH DEPTHM ',2E12.4)
C
      IF(JBC) 12,11,12
C
C#################
C-               --- BARREL
C#################
C
C---- CORRECT ENERGY LOSS IN THE AL-COIL.  CHANGED TO INCLUDE H2O,CH2..
C                                           ON 01-11-81 07:55
CC 11 IF(DEPTH.GE.RADSX0(1).AND.DEPTH.LE.RADSX0(2)) PA0(2)=PA0(2)-40.*T
C  11 IF(DEPTH.GE.RADSX0(1).AND.DEPTH.LE.RADSX0(2)) PA0(2)=PA0(2)-51.7*T
   11 IF(DEPTHM.GE.RADIUS(1).AND.DEPTHM.LE.RADIUS(2))
     $ PA0(2)=PA0(2)-51.7*T
C
      IF(IPRO.GT.0) WRITE(6,2004) PA0(2)
2004  FORMAT(' LSCCTC:  PA0(2) ',E12.4)
C
      IF(DEPTHM.LT.RADIUS(3).OR.DEPTHM.GT.RADIUS(4)) RETURN
      DEPTH = DEPTH-RADIUS(3)/XJJ
C
C---- ROTATE BACK W.R.T.Z-AXIS BY PHI.
      XABS1 = XABS(1)*COSP-XABS(2)*SINP
      XABS(2) = XABS(1)*SINP+XABS(2)*COSP
      XABS(1) = XABS1
C
      IF(IPRO.GT.0) WRITE(6,2005) DEPTH,(XABS(IK),IK=1,3)
2005  FORMAT(' LSCCTC: DEPTH XABS1-3 ',4E12.4)
C
      GO TO 30
C
C###########################
C                        ---- END CAP
C###########################
C
   12 W = XABS(1)
      XABS(1) = XABS(2)
      XABS(2) = XABS(3)
      XABS(3) = W*SJBC
C
      IF(IPRO.GT.0) WRITE(6,2006) (XABS(IK),IK=1,3)
2006  FORMAT(' LSCCTC: ECAP  XABS1-3 ',3E12.4)
C
      IF(DEPTHM.GE.ZPV(3).AND.DEPTHM.LE.ZPV(4)) PA0(2)=PA0(2)-51.7*T
      DEPTH = DEPTH -ZECAP(3)/XJJ
C
      IF(IPRO.GT.0) WRITE(6,2007) PA0(2),DEPTH,ZECAP(3),XJJ,THECP
2007  FORMAT(' LSCCTC: PA02 DEPTH,ZECAP3 XJJ THECP ',5E12.4)
C
      IF(DEPTH.LT.0. .OR. DEPTH.GT.THECP/XJJ) RETURN
C
   30 CONTINUE
C
      IF(IPRO.GT.0) WRITE(6,2008) T,DEPTH,PA0(7),JBCI
2008  FORMAT(' LSCCTC: CALL LGCR56 T DEPTH PA07 JBCI ',3E12.4,I5)
C
      CALL LGCR56( T,DEPTH,PA0(7),BETA2,XABS,JBCI )
      RETURN
      END

C   23/11/84 805201541  MEMBER NAME  ZCDATANW (S)           FORTRAN77
************************************************************************
      SUBROUTINE ZCDATA(NTPAT,NZHIT,NASS1,NASS2,IRET)
************************************************************************
*                                                                      *
*     ROUTINE TO DECODE Z-CHAMBER DATA                                 *
*                                                                      *
*     INPUT ARGUMENTS:           NONE                                  *
*     OUTPUT ARGUMENTS:          NTPAT = NUMBER OF PATR TRACKS         *
*                                NZHIT = NUMBER OF Z-CH HITS           *
*                                NASS1 = NO OF TRACKS WITH .GE.1       *
*                                           ASSOCIATED Z-CHAMBER HIT   *
*                                NASS2 = NO OF TRACKS WITH 2           *
*                                           ASSOCIATED Z-CHAMBER HITS  *
*                                IRET  = 0    EVERYTHING OK            *
*                                        1    NO PATR BANK             *
*                                        2    NO ZETC BANK             *
*                                        3    NO TRACKS                *
*                                        4    .GT.100 TRACKS           *
*                                        5    NO Z-CH HITS             *
*     COMMONBLOCKS FILLED:      /CZDATA/ Z-CHAMBER COORDINATES         *
*                               /CZTRK / TRACK ASSOCIATION DETAILS     *
*                                                                      *
*     S. CARTWRIGHT              23/11/84                              *
*                                                                      *
*  20/5/88     ADD RRTRK TO RECORD RADII OF INTERSECTIONS, EE          *
*                                                                      *
************************************************************************
*
******COMMONBLOCKS
      COMMON/CZDATA/JZDATA(64),IZDATA(3,8,64),RZDATA(3,8,64)
******              JZDATA(NW)        NUMBER OF HITS ON WIRE NW
*                   IZDATA(*,         ADC1,ADC2,TDC
*                            NH,      HIT NUMBER (1--8)
*                               NW)   WIRE NUMBER (1--64)
*                   RZDATA(*,         Z-DZ,Z+DZ,PHI
******                       NH,NW)   HIT NO, WIRE NO.
      COMMON/CZTRK /RZTRK(5,100),IZTRK(3,2,100), RRTRK(2,100)
******              RZTRK(*,NTR)      ZI1,PHI1,ZI2,PHI2,TANTH
*                                         FOR TRACK NUMBER NTR
*                   IZTRK(*,          IM(=1,-DZ,=2,+DZ),NH,NW
*                           IL,       LAYER(=1,INNER,=2,OUTER)
*                              NTR)   TRACKNO
******              RRTRK(*,   NTR)   RI1, RI2 FOR TRACK NTR
      COMMON/CZASS /IZASS(8,64)
******
*                   IZASS(I,NW)       NTR ASS. WITH I'TH HIT ON WIRE NW
******
*%MACRO CBCS
*%MACRO CZGEO
*%MACRO CZMKON
C ----------------------------------------------- BOS COMMON
      COMMON/BCS/IW(1)
      REAL RW(1)
      INTEGER*2 HW(1)
      EQUIVALENCE(IW(1),RW(1),HW(1))
C ----------------------------------------------- END BOS DECLARATIONS
C ----------------------------------------------- Z-CHAMBER CONSTANTS
C ----------------------------------------------- Z-CHAMBER CONSTANTS 3
      COMMON /CZMKON/ ZCVDR, ZCXCH, ZCTZER, ZCAPED, ZXLI, ZXLO
       COMMON /CZGEO/ RZCHI,RZCHA,NZRPHI,NZZ,Z1ZCH,Z2ZCH,
     *              ZCHA, ZCHB, ZCHSS, ZCHDL, ZCHDLL,
     *              DLZZ, DLZPMI, DLZW1, DLZW2
******END COMMONBLOCKS
******ARRAYS AND DECLARATIONS
      REAL WIRLEN(2)
      INTEGER NCALL/0/,KRUN0/-1/
      PARAMETER(PI=3.1415927,TWOPI=6.2831853,PHICUT=0.349,DWIR=10.)
******END ARRAYS AND DECLARATIONS
******INITIALISATION
      IF(NCALL.EQ.0)                   THEN
         KZETC     = IBLN('ZETC')
         KPATR     = IBLN('PATR')
         KHEAD     = IBLN('HEAD')
         WIRLEN(1) = NZRPHI/2 * DLZW1 - 200.
         WIRLEN(2) = NZRPHI/2 * DLZW2 - 200.
      ENDIF
*
      CALL VZERO(JZDATA,  64)
      CALL VZERO(IZDATA,1536)
      CALL VZERO(RZDATA,1536)
      CALL VZERO(RZTRK , 400)
      CALL VZERO(IZTRK , 600)
      CALL VZERO(RRTRK , 200)
      CALL VZERO(IZASS , 512)
*
      IHEAD = IW(KHEAD)
      KRUN  = HW(2*IHEAD+10)
      IF(KRUN.NE.KRUN0)                THEN
         CALL ZCHCAL(KRUN,ZCXCH,ZCVDR)
         KRUN0 = KRUN
      ENDIF
*
      IRET  = 0
      NASS1 = 0
      NASS2 = 0
      IPATR = IW(KPATR)
      IZETC = IW(KZETC)
      IF(IZETC.LE.0)                   IRET = 2
      IF(IRET .NE.0)                   RETURN
*
      JZETC = 2*IZETC
      J     = JZETC+2
      NZHIT = IW(IZETC)/2
      IF(NZHIT.LE.0)                   IRET = 5
      IF(IRET .NE.0)                   RETURN
******
*     LOOP OVER Z-CHAMBER HITS.
*     UNPACK DATA AND CONVERT TO COORDINATES.
*     FILL JZDATA,IZDATA,RZDATA
******
      CALL ZCOOR(JZETC,NZHIT,WIRLEN,ZCXCH,ZCVDR)
******
*     LOOP OVER PATR TRACKS
*     THIS IS THE ASSOCIATION SECTION OF THE ROUTINE
******
      IF(IPATR.LE.0)                   THEN
         IRET = 1
         RETURN
      ENDIF
*
      IPATS = IW(IPATR+1)
      NTPAT = IW(IPATR+2)
      NWPAT = IW(IPATR+3)
      IPATT = IPATR + IPATS
      IF(NTPAT.LE.  0)                 IRET = 3
      IF(NTPAT.GT.100)                 IRET = 4
      IF(IRET .NE.0)                   RETURN
*
      CALL ZCASS(IPATT,NTPAT,NWPAT,NASS1,NASS2)
*
******END OF SUBROUTINE*************************************************
      END

C------------START OF MACRO CMUREG--------------------------------------
C
      COMMON /CMUREG/NREGS,XRLO(100),XRHI(100),YRLO(100),YRHI(100),
     * ZRLO(100),ZRHI(100),HRMASK(100),HRFACE(100),HRTYPE(100),
     * HRORI(100),HRFIRS(100),HRLAST(100)
C
C NREGS IS NUMBER OF REGIONS.
C XRLO ETC. ARE REGION BOUNDARIES.
C HRMASK =1 (FACE 1), =2 (FACE 2), =4 (FACE 3), =8 (FACE 4), ETC.
C HRFACE = FACE NUMBER, =1-6 FOR -X,+X,-Y,+Y,-Z,+Z.
C HRTYPE =1, MU CHAMBER SENSITIVE REGION,
C        =2, CONCRETE REGION,
C        =3, IRON REGION,
C        =4, LEAD GLASS. (IRTYPE=4 USED ONLY IN MUFFLD.)
C HRORI  = ORIENTATION OF NORMAL, =1 (|| X), =2 (||Y), =3 (|| Z).
C HRFIRS = FIRST CHAMBER NUMBER.
C HRLAST = LAST CHAMBER NUMBER.
C
C------------END OF MACRO CMUREG----------------------------------------

      SUBROUTINE XYRFT1(IPTR,IPJHTL,ERRFAC,LDTR)
      IMPLICIT INTEGER*2 (H)
      REAL*8   S0D,S1D,S2D,S3D,S4D,S8D,DETD
      COMMON/XYFVT1/MODXYV
#include "cdata.for"
#include "cgeo1.for"
#include "calibr.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      INTEGER DATE(5), IDAY /0/
      INTEGER NCHECK(5)/5*8/
      REAL RCHECK(12,2,5)/
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1.,
     +   0.,  .004,  .01,  .045,  .06,  .1,  1.,  6., 4*0.,
     +   0.,  .65,   .79,  .86,   .89, .91, .94,  1., 4*1./
      REAL RESCUT/8./,CKAPP/.966/
      DIMENSION ISORT1(71),ISORT2(3,71),IRESHT(71),ISORT3(91)
     +,ISORT4(2,91)
      DATA KPRT1/0/,NPRT1/50/,IQJETC/0/,IQHEAD/0/
      DATA MASK1/Z2FFFFFF/,MASK2/ZFFFF02FF/,MASK3/ZFFFFF1FF/
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
         LBINIT = 1
         IQJETC = IBLN('JETC')
         IQHEAD = IBLN('HEAD')
         CALL DAY2(DATE)
         IDAY = DATE(1)*1000 + DATE(2)
         RESMS = .020**2/2. * .16 * (1. + ALOG10(.16) /9.) * 155.45**2
         WRITE(6,137)
 137     FORMAT(/,' *** XYRFT1 ***  A NEW R-PHI FITTING ROUTINE',/,
     +            '                 TEST VERSION 3. (J. SPITZER)',
     +                            ' LAST MOD 02/09/88           ',/
     +     ' BIT 512 OR 1024 IS SET IN THE PROGRAM IDENTIFIER WORD',/,
     +' IN CASE VERTEX CONSTRAINT WAS NOT OR WAS USED RESP.',/,
     +' CORRECT COV MATRIX IS PROVIDED WITH BIT 2048 SWITCHED ON',/,
     +' IF THE PATR BANK ALREADY HAS THE LARGER LENGTH, THE NUMBER',/,
     +' OF HITS USED IN THE FIT IS AT LEAST 10 AND THE FIT CONVERGED.',
     +/)
      ENDIF
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      NEV  = HDATA(IPHEAD+11)
      ITRK = IDATA(IPTR+1)
      HPFREE = 1
      IPV    = ICALIB(10)
      XO     = ACALIB(IPV+ 1)
      YO     = ACALIB(IPV+ 3)
      CURVXY=ADATA(IPTR+25)
      IF(ABS(CURVXY).LT.1.E-9) CURVXY = SIGN(1.E-9,CURVXY)
      DDR0=DISTXY(ADATA(IPTR+5),ADATA(IPTR+6),ADATA(IPTR+8),
     +ADATA(IPTR+9),1./CURVXY,XO,YO,XP,YP,FI)
      FV     = ERRFAC
      IF(FV .LT. .50) FV = .50
      IF(
     - LDATYP(DUMMY) .EQ. 1
     -)THEN
         SRESO=.160
      ELSE
         SRESO=.100
      ENDIF
      SIGMIN=(SRESO/1.6)**2
      PTRANS = ABS(0.0299792458*BKGAUS/CURVXY) * .001
      RESV=.0100+.25*SIN(FI)**2+RESMS/PTRANS**2
      WGHT0  = (SRESO/FV)**2 / RESV
      INDBIT=512
      XX    =  ADATA(IPTR+12) - ADATA(IPTR+5)
      YY    =  ADATA(IPTR+13) - ADATA(IPTR+6)
      RR    = 0.5*SQRT(XX**2+YY**2)
      IF(
     - RR.LT.10.
     -)THEN
      IF(
     - KPRT1.LT.NPRT1
     -)THEN
            KPRT1=KPRT1+1
            WRITE(6,848) NRUN,NEV,ITRK,RR
848         FORMAT(' ******** RUN,EV,TRACK',I8,I6,I3,/,
     +      ' HALF DISTANCE OF FIRST AND LAST POINTS',E14.3,
     +      ', XYRFT1 DOES NOT ATTEMPT R-PHI FIT')
      ENDIF
         RETURN
      ENDIF
      HPCO0  = HPFREE
      LHIT   = 14
      INDFET = 2
      CALL JFETCH(IPTR,IPJHTL,WRK(HPCO0),LHIT,IPRES,INDFET,XO,YO)
      HLDCO  = LHIT
      HPCO9  = IPRES - 1
      HPAR0  = IPRES
      HLDPA  = 20
      HPAR9  = HPAR0 + HLDPA - 1
      HPFREE = HPAR9 + 1
      XT     = WRK (IPRES   )
      YT     = WRK (IPRES+ 1)
      CSROT  = WRK (IPRES+ 2)
      SNROT  = WRK (IPRES+ 3)
      XOR    =- XT*CSROT -  YT*SNROT
      YOR    =  XT*SNROT -  YT*CSROT
      X0     = (XO-XT)*CSROT+(YO-YT)*SNROT
      Y0     =-(XO-XT)*SNROT+(YO-YT)*CSROT
      ZVERT = ADATA(IPTR+31)
      TGTH = ADATA(IPTR+30)
      CSTH   = WRK (IPRES+11)
      SNTH   = WRK (IPRES+12)
      IWRK(IPRES+10)=0
      SIG=ADATA(IPTR+23)**2
      IF(SIG.LT.1.E-5) SIG=1.E-5
      SIG11=(.5*ADATA(IPTR+26))**2/SIG
      XHCUT=RR+200.
      XREGA= 100000.
      XREGB=-100000.
      NHALL=0
      NHWIR=0
      NHPOT=0
      IPCO=HPCO0
16000 CONTINUE
         NHWIR=NHWIR+1
         IF(NHWIR.GT.70) RETURN
         ISORT1(NHWIR)=NHWIR
         ISORT2(1,NHWIR)=IPCO
         ISORT2(3,NHWIR)=0
         IW0=IWRK(IPCO)
         ICL0=IWRK(IPCO+9)
         LFL=0
15000 CONTINUE
      IF(
     - IPCO.LE.HPCO9
     -)THEN
            IW9=IWRK(IPCO)
            ICL9=IWRK(IPCO+9)
      IF(
     - IW9.EQ.IW0 .AND. ICL9.EQ.ICL0
     -)THEN
               NHALL=NHALL+1
               IF(NHALL.GT.90) RETURN
               IF(ISORT2(3,NHWIR).EQ.0) ISORT2(2,NHWIR)=NHALL
               ISORT2(3,NHWIR)=ISORT2(3,NHWIR)+1
               XA=WRK(IPCO+3)
               LBGOOD=IWRK(IPCO+10)
      IF(
     - LBGOOD.LE.2
     -)THEN
      IF(
     - ABS(XA).GT.XHCUT
     -)THEN
                     ISORT3(NHALL)=-1
      ELSE
                     ISORT3(NHALL)= 1
                     LFL=1
                     IF(XA.LT.XREGA) XREGA=XA
                     IF(XA.GT.XREGB) XREGB=XA
      ENDIF
                  IWRK(IPCO+10)=1
      ELSE
                  ISORT3(NHALL)=-1
      ENDIF
               IPCO=IPCO+HLDCO
      ELSE
      GOTO 15001
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      IF(
     - LFL.EQ.1
     -)THEN
            NHPOT=NHPOT+1
      ELSE
            ISORT3(ISORT2(2,NHWIR))=-2
      ENDIF
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16000
16001 CONTINUE
      IF(NHPOT.LT.4) RETURN
      XHF=.5*(XREGA+XREGB)
      RRPL=.5*(XREGB-XREGA)
      RRMI=RRPL
      IF(
     - ABS(XHF).GT.RR
     -)THEN
         RRPL=RRPL+XHF-SIGN(RR,XHF)
         RRMI=RRMI-XHF+SIGN(RR,XHF)
         XHF=SIGN(RR,XHF)
      ENDIF
      LCHC=0
      IF(
     - ABS(CURVXY*RR).GT.CKAPP
     -)THEN
         LCHC=1
         CURVXY=SIGN(CKAPP/RR,CURVXY)
      ENDIF
      IF(
     - ABS(CURVXY)*RR .GT. .04
     -)THEN
         LFTYP=1
         P1=CURVXY/SQRT(1.-(CURVXY*RR)**2)
         AAH=(RR-XHF)*(RR+XHF)
         PAR3=SAGCIR(1.,P1,AAH,SAGPR,1.E-4)
         PAR2=-P1/(1.+PAR3*P1)*XHF
         CSI2GM=1.+PAR2**2
         PAR1=CURVXY*SQRT(CSI2GM)
      ELSE
         LFTYP=2
         PAR3=.5*CURVXY*(RR-XHF)*(RR+XHF)
         PAR2=-CURVXY*XHF
         CSI2GM=1.+PAR2**2
         PAR1=-0.5*CURVXY*SQRT(CSI2GM)*CSI2GM
      ENDIF
      XMIN=PAR2/PAR1-CKAPP/ABS(CURVXY)
      XMAX=PAR2/PAR1+CKAPP/ABS(CURVXY)
      DISCUT=400.
      KFLIP=1
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      IF(NHFIT.LT.4) RETURN
      IF(
     - NHFIT.LT.6
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
         RETURN
      ENDIF
      IF(
     - ABS(DA).GT.1.5 .OR. ABS(DB).GT..1 .OR. LCHC.EQ.1
     -)THEN
      IF(
     - LFTYP.EQ.2
     -)THEN
            LFTYP=1
            PAR1=CUROUT*SQRT(CSI2GM)
            XMIN=PAR2/PAR1-CKAPP/ABS(CUROUT)
            XMAX=PAR2/PAR1+CKAPP/ABS(CUROUT)
      ENDIF
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ENDIF
      IF(NHFIT.LT.NHPOT/2) RETURN
      NHFTLS=NHFIT
      PAR1LS=PAR1
      PAR2LS=PAR2
      PAR3LS=PAR3
      CSI2LS=CSI2GM
      CURLST=CUROUT
      XMAXLS=XMAX
      XMINLS=XMIN
      SIG11L=SIG11
      SIGLST=SIG
      NHWIRV=NHWIR+1
      ISORT1(NHWIRV)=NHWIRV
      ISORT2(1,NHWIRV)=-200
      INDMAX=NHFIT/8+1
      IF(INDMAX.GT.8) INDMAX=8
      INDFIT=0
15002 CONTINUE
      IF(
     - INDFIT.LT.INDMAX
     -)THEN
         INDFIT=INDFIT+1
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      IF(
     - LNOCON.EQ.1
     -)THEN
            NHFIT=NHFTLS
            PAR1=PAR1LS
            PAR2=PAR2LS
            PAR3=PAR3LS
            CSI2GM=CSI2LS
            CUROUT=CURLST
            XMAX=XMAXLS
            XMIN=XMINLS
            SIG11=SIG11L
            SIG=SIGLST
      ASSIGN 17008 TO IZZZ02
      GOTO 17002
17008 CONTINUE
            RETURN
      ENDIF
      IF(
     - SIG.LT.SIGMIN
     -)THEN
      GOTO 15003
      ENDIF
      IF(
     - INDFIT.GE.2
     -)THEN
      ASSIGN 17010 TO IZZZ05
      GOTO 17009
17010 CONTINUE
      IF(
     - LSTOP.EQ.1
     -)THEN
               INDFIT=INDFIT-1
               NHFIT=NHFTLS
               PAR1=PAR1LS
               PAR2=PAR2LS
               PAR3=PAR3LS
               CSI2GM=CSI2LS
               CUROUT=CURLST
               XMAX=XMAXLS
               XMIN=XMINLS
               SIG11=SIG11L
               SIG=SIGLST
               KFLIP=3-KFLIP
      GOTO 15003
      ENDIF
      ENDIF
      IF(
     - INDFIT.EQ.INDMAX
     -)THEN
      GOTO 15003
      ENDIF
         NHFTLS=NHFIT
         PAR1LS=PAR1
         PAR2LS=PAR2
         PAR3LS=PAR3
         CSI2LS=CSI2GM
         CURLST=CUROUT
         XMAXLS=XMAX
         XMINLS=XMIN
         SIG11L=SIG11
         SIGLST=SIG
      ASSIGN 17012 TO IZZZ06
      GOTO 17011
17012 CONTINUE
      GOTO 15002
      ENDIF
15003 CONTINUE
      X0R=X0-XHF
      IF(
     - FV.LT.200. .AND. X0R.GT.XMIN .AND. X0R.LT.XMAX
     -)THEN
      IF(
     - LFTYP.EQ.2
     -)THEN
            DVCHI2=((PAR1*X0R+PAR2)*X0R+PAR3-Y0)**2*WGHT0
      ELSE
            AAH=-X0R**2*CSI2GM
            FDBPR=1./(1.+PAR1*X0R*PAR2)
            SAG=SAGCIR(FDBPR,PAR1,AAH,SAGPR,1.E-4)
            DVCHI2=(SAG+PAR2*X0R+PAR3-Y0)**2*WGHT0
      ENDIF
      IF(
     - DVCHI2 .LT.  9.*SIG
     -)THEN
            ISORT2(1,NHWIRV)=-100
      ASSIGN 17013 TO IZZZ04
      GOTO 17006
17013 CONTINUE
            IF(LNOCON.EQ.0) INDBIT=1024
      ENDIF
      ENDIF
      ASSIGN 17014 TO IZZZ02
      GOTO 17002
17014 CONTINUE
      RETURN
17006 CONTINUE
      LNOCON=0
      KFLIP=3-KFLIP
      KITER=0
15004 CONTINUE
      IF(
     - KITER .LT. 3-LFTYP
     -)THEN
         KITER=KITER+1
         X0R=X0-XHF
      IF(
     - ISORT2(1,NHWIRV).EQ.-100 .AND. X0R.GT.XMIN .AND. X0R.LT.XMAX
     -)THEN
      IF(
     - LFTYP.EQ.2
     -)THEN
               DYDP1=X0R**2
               DYDP2=X0R
               DYRES=Y0
      ELSE
               AAH=-X0R**2
               FDBPR=1./(1.+PAR1*X0R*PAR2)
               SAG=SAGCIR(FDBPR,PAR1,AAH*CSI2GM,SAGPR,1.E-4)
               CC1=FDBPR/(1.+SAG*PAR1*FDBPR)
               DYDP1=CC1*SAGPR
               DYDP2=X0R+PAR1*CC1*(AAH*PAR2-SAG*X0R)
               DYRES=Y0-SAG-PAR2*X0R-PAR3
      ENDIF
            S0 = WGHT0
            S1=DYDP2*WGHT0
            S2=DYDP1*WGHT0
            S3=S2*DYDP2
            S4=S2*DYDP1
            S8=S1*DYDP2
            S7=DYRES*WGHT0
            S6=S7*DYDP2
            S5=S7*DYDP1
      ELSE
            S0 = 0.
            S1 = 0.
            S2 = 0.
            S3 = 0.
            S4 = 0.
            S8 = 0.
            S7 = 0.
            S6 = 0.
            S5 = 0.
      ENDIF
         S00=S0
      DO 13000 IHWIR=1,NHWIR
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      DO 13002 JNH=1,NNH
               ISORT4(KFLIP,IH+JNH-1)=0
13002 CONTINUE
13003 CONTINUE
      IF(
     - ISORT3(IH).EQ.1 .OR. ISORT3(IH).EQ.-1.AND.NNH.GT.1
     -)THEN
               RESMIN=10000.
      DO 13004 JNH=1,NNH
                  JH=IH+JNH-1
      IF(
     - ISORT3(JH).EQ.1
     -)THEN
                     IPCO=ISORT2(1,IHWIR)+(JNH-1)*HLDCO
                     XA = WRK(IPCO+3)
                     XAR=XA-XHF
      IF(
     - XAR.GT.XMIN.AND.XAR.LT.XMAX
     -)THEN
                        YA = WRK(IPCO+4)
      IF(
     - LFTYP.EQ.2
     -)THEN
                           DYDP1A=XAR**2
                           DYDP2A=XAR
                           DYRESA=YA
                           DF0=ABS(YA-((PAR1*XAR+PAR2)*XAR+PAR3))
      ELSE
                           AAH=-XAR**2
                           FDBPR=1./(1.+PAR1*XAR*PAR2)
                           SAG=SAGCIR(FDBPR,PAR1,AAH*CSI2GM,SAGPR,1.E-4)
                           CC1=FDBPR/(1.+SAG*PAR1*FDBPR)
                           DYDP1A=CC1*SAGPR
                           DYDP2A=XAR+PAR1*CC1*(AAH*PAR2-SAG*XAR)
                           DYRESA=YA-SAG-PAR2*XAR-PAR3
                           DF0=ABS(DYRESA)
      ENDIF
      ELSE
                        DF0=15000.
      ENDIF
      IF(
     - DF0.LT.RESMIN
     -)THEN
                        RESMIN=DF0
                        DYDP1=DYDP1A
                        DYDP2=DYDP2A
                        DYRES=DYRESA
                        JHUSE=JH
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - RESMIN.LT.RESCUT
     -)THEN
                  S0=S0+1.
                  S1=S1+DYDP2
                  S2=S2+DYDP1
                  S3=S3+DYDP1*DYDP2
                  S4=S4+DYDP1**2
                  S8=S8+DYDP2**2
                  S7=S7+DYRES
                  S6=S6+DYRES*DYDP2
                  S5=S5+DYRES*DYDP1
                  ISORT4(KFLIP,JHUSE)=1
      ELSE
                  ISORT3(IH)=-2
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
         NHF1=S0-S00+.1
      IF(
     - NHF1.LT.6 .OR. NHF1.LT.NHPOT/2
     -)THEN
            LNOCON=1
      GOTO 15005
      ENDIF
         NHFIT=NHF1
         DEG   = S0 - S00 - 3.
         DET = (S8*S0-S1*S1)*S4 + (S2*S1-S3*S0)*S3 + (S3*S1-S2*S8)*S2
         SIG11 = (S8*S0 - S1*S1)/DET
         F1 = 1. / S4
         XX12 = S3*F1
         XX13 = S2*F1
         YY1  = S5*F1
         XX22 = S8 - S3*XX12
         XX23 = S1 - S3*XX13
         YY2  = S6 - S3*YY1
         XX32 = S1 - S2*XX12
         XX33 = S0 - S2*XX13
         YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
            XX23 = XX23 / XX22
            YY2  = YY2  / XX22
            PARR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
            PARR2 = YY2 - XX23*PARR3
      ELSE
            XX33 = XX33 / XX32
            YY3  = YY3  / XX32
            PARR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
            PARR2 = YY3 - XX33*PARR3
      ENDIF
         PARR1 = YY1 - XX12*PARR2 - XX13*PARR3
      IF(
     - LFTYP.EQ.2
     -)THEN
            PAR1=PARR1
            PAR2=PARR2
            PAR3=PARR3
            IF(ABS(PAR1).LT.1.E-10) PAR1 = SIGN(1.E-10,PAR1)
            CSI2GM=PAR2**2+1.
            CUROUT =-PAR1 * 2./ (SQRT(CSI2GM)*CSI2GM)
      ELSE
            PAR1=PAR1+PARR1
            PAR2=PAR2+PARR2
            PAR3=PAR3+PARR3
            IF(ABS(PAR1).LT.1.E-10) PAR1 = SIGN(1.E-10,PAR1)
            CSI2GM=PAR2**2+1.
            CUROUT=PAR1/SQRT(CSI2GM)
            XMIN=PAR2/PAR1-CKAPP/ABS(CUROUT)
            XMAX=PAR2/PAR1+CKAPP/ABS(CUROUT)
      ENDIF
      GOTO 15004
      ENDIF
15005 CONTINUE
      IF(
     - LNOCON.EQ.0
     -)THEN
         CHISQ = 0.
         NHF1=0
      DO 13006 IHWIR=1,NHWIR
            IRESHT(IHWIR)=-1
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      IF(
     - ISORT3(IH).GE.0 .OR. ISORT3(IH).EQ.-1.AND.NNH.GT.1
     -)THEN
               RESMIN=10000.
      DO 13008 JNH=1,NNH
                  JH=IH+JNH-1
      IF(
     - ISORT3(JH).GE.0
     -)THEN
                     IFLG=ISORT3(JH)
                     IPCO=ISORT2(1,IHWIR)+(JNH-1)*HLDCO
                     XR= WRK(IPCO+3)-XHF
      IF(
     - XR.GT.XMIN.AND.XR.LT.XMAX
     -)THEN
                        Y = WRK(IPCO+4)
      IF(
     - LFTYP.EQ.2
     -)THEN
                           DF0=ABS(Y-(PAR1*XR+PAR2)*XR-PAR3)
      ELSE
                           AAH=-XR**2*CSI2GM
                           FDBPR=1./(1.+PAR1*XR*PAR2)
                           SAG=SAGCIR(FDBPR,PAR1,AAH,SAGPR,1.E-4)
                           DF0=ABS(Y-SAG-PAR2*XR-PAR3)
      ENDIF
                        IF(DF0.LT.RESMIN) RESMIN=DF0
      ENDIF
      ENDIF
13008 CONTINUE
13009 CONTINUE
      IF(
     - RESMIN.LT.5000.
     -)THEN
                  IRESHT(IHWIR)=RESMIN*1.E6
      IF(
     - IFLG.EQ.1
     -)THEN
                     CHISQ=CHISQ+RESMIN**2
                     NHF1=NHF1+1
      ENDIF
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
         IF(NHF1.LT.NHFIT-3) LNOCON=1
         SIG    =      CHISQ  / DEG
      ENDIF
      GOTO IZZZ04
17011 CONTINUE
         CALL SHELL9(IRESHT,ISORT1,NHWIR)
         KOMIT=0
      DO 13010 J1=1,NHWIR
            IHWIR=ISORT1(NHWIR+1-J1)
            IPCO=ISORT2(1,IHWIR)
      IF(
     - IPCO.NE.-100 .AND. IPCO.NE.-200
     -)THEN
               NNH=ISORT2(3,IHWIR)
               IH=ISORT2(2,IHWIR)
               LFLG=0
      DO 13012 JNH=1,NNH
                  IHA=IH+JNH-1
                  IQA=ISORT3(IHA)
      IF(
     - IQA.GT.-1
     -)THEN
      IF(
     - LFLG.EQ.0
     -)THEN
                        LFLG=1
                        KOMIT=KOMIT+1
      ENDIF
      IF(
     - KOMIT.LE.INDFIT
     -)THEN
                        ISORT3(IHA)=0
      ELSE
                        ISORT3(IHA)=1
      ENDIF
      ENDIF
13012 CONTINUE
13013 CONTINUE
      ENDIF
13010 CONTINUE
13011 CONTINUE
      GOTO IZZZ06
17009 CONTINUE
      IF(
     - INDFIT.LE.6
     -)THEN
            INDCK=INDFIT-1
      ELSE
            INDCK=5
      ENDIF
         ICHCK=NCHECK(INDCK)
15006 CONTINUE
      IF(
     - SIGLST.LT.RCHECK(ICHCK,1,INDCK)
     -)THEN
            ICHCK=ICHCK-1
      GOTO 15006
      ENDIF
15007 CONTINUE
         IF(ICHCK.LT.1) ICHCK=1
      IF(
     - SIG/SIGLST.GT.RCHECK(ICHCK,2,INDCK)
     -)THEN
            LSTOP=1
      ELSE
            LSTOP=0
      ENDIF
      GOTO IZZZ05
17002 CONTINUE
         XST=XHF+XMIN
         IF(XST.LT.XREGA) XST=XREGA
         XSTR=XST-XHF
         XEN=XHF+XMAX
         IF(XEN.GT.XREGB) XEN=XREGB
         XENR=XEN-XHF
      IF(
     - LFTYP.EQ.2
     -)THEN
            YST  = (PAR1 *XSTR+ PAR2 )*XSTR+ PAR3
            YEN  = (PAR1 *XENR+ PAR2 )*XENR+ PAR3
            TGST = PAR1*XSTR*2.+ PAR2
            TGEN = PAR1*XENR*2.+ PAR2
      ELSE
            AAH=-XSTR**2
            FDBPR=1./(1.+PAR1*XSTR*PAR2)
            SAG=SAGCIR(FDBPR,PAR1,AAH*CSI2GM,SAGPR,1.E-4)
            YST=SAG+PAR2*XSTR+PAR3
         TGST=PAR2-PAR1*FDBPR/(1.+SAG*PAR1*FDBPR)*(SAG*PAR2+XSTR*CSI2GM)
            AAH=-XENR**2
            FDBPR=1./(1.+PAR1*XENR*PAR2)
            SAG=SAGCIR(FDBPR,PAR1,AAH*CSI2GM,SAGPR,1.E-4)
            YEN=SAG+PAR2*XENR+PAR3
         TGEN=PAR2-PAR1*FDBPR/(1.+SAG*PAR1*FDBPR)*(SAG*PAR2+XENR*CSI2GM)
      ENDIF
         DXST = 1./SQRT(TGST**2+1.)
         DYST = DXST * TGST
         DXEN = 1./SQRT(TGEN**2+1.)
         DYEN = DXEN * TGEN
         HPTR0 = HPFREE
         CALL MVCL(IWRK(HPTR0),0,IDATA(IPTR+1),0,4*LDTR)
         IP    = HPTR0 - 1
         IWRK(IP+2) = LAND(IWRK(IP+2),MASK3)
         IWRK(IP+2) = LOR(IWRK(IP+2),INDBIT)
         IWRK(IP+ 3) = IDAY
         WRK (IP+ 5) = XST *CSROT - YST *SNROT + XT
         WRK (IP+ 6) = XST *SNROT + YST *CSROT + YT
         WRK (IP+ 7) = SQRT(WRK(IP+ 5)**2 + WRK(IP+ 6)**2)*TGTH+ZVERT
         DXSTJ       =  DXST*CSROT - DYST*SNROT
         DYSTJ       =  DXST*SNROT + DYST*CSROT
         WRK (IP+ 8) =  DXSTJ*CSTH
         WRK (IP+ 9) =  DYSTJ*CSTH
         WRK (IP+12) = XEN *CSROT - YEN *SNROT + XT
         WRK (IP+13) = XEN *SNROT + YEN *CSROT + YT
         WRK (IP+14) = SQRT(WRK(IP+12)**2 + WRK(IP+13)**2)*TGTH+ZVERT
         WRK (IP+15) = (DXEN*CSROT - DYEN*SNROT)*CSTH
         WRK (IP+16) = (DXEN*SNROT + DYEN*CSROT)*CSTH
         IWRK(IP+24) = NHFIT
         WRK (IP+25) = CUROUT
         WRK (IP+27) = CUROUT
         WRK (IP+28) = CUROUT
         WRK (IP+23) = SQRT(SIG)
         WRK (IP+26) = SQRT(SIG*SIG11/CSI2GM)
         IF(LFTYP.EQ.2) WRK(IP+26)=WRK(IP+26)*2./CSI2GM
         IWRK(IP+18) = 1
         PAR1=CUROUT*SQRT(CSI2GM)
         SIGNC=SIGN(1.,CUROUT)
         ACURV=ABS(CUROUT)
         A=((XHF-XOR)*PAR2-PAR3+YOR)/SQRT(CSI2GM)
         B=(XHF-XOR+(PAR3-YOR)*PAR2)/SQRT(CSI2GM)
         FDBPR=1./ACURV+SIGNC*A
      IF(
     - FDBPR.LT.100.
     -)THEN
            DIMP=-1./ACURV+SQRT(FDBPR**2+B**2)
      ELSE
            DIMP=SIGNC*A+SAGCIR(1./(1.+CUROUT*A),ACURV,B**2,SP,1.E-4)
      ENDIF
         FDBPR=1.+DIMP*ACURV
      IF(
     - FDBPR.LT.ACURV*1.E-3
     -)THEN
            WRK(IP+19)=ACURV
            WRK(IP+20)=DIMP
            WRK(IP+21)=0.
      ELSE
            FDBPR=SIGNC/FDBPR
            SGPFI=(PAR2*CSROT+SNROT)/SQRT(CSI2GM)
            CGPFI=(CSROT-PAR2*SNROT)/SQRT(CSI2GM)
            COSALP=(CUROUT*(XHF*CSROT-PAR3*SNROT+XT)+SGPFI)*FDBPR
            SINALP=(CUROUT*(XHF*SNROT+PAR3*CSROT+YT)-CGPFI)*FDBPR
            WRK(IP+19)=ACURV
            WRK(IP+20)=DIMP
            WRK(IP+21)=ATAN2(SINALP,COSALP)
      IF(
     - LDTR.GE.55.AND.NHFIT.GE.10.AND.LNOCON.EQ.0
     -)THEN
               LCOVAR=1
      ELSE
               LCOVAR=0
      ENDIF
      IF(
     - LAND(MODXYV,32) .NE. 0
     -)THEN
               LJHTLU=1
      ELSE
               LJHTLU=0
      ENDIF
      ASSIGN 17016 TO IZZZ07
      GOTO 17015
17016 CONTINUE
            IWRK(IPRES+10)=1
      ENDIF
         CALL MVCL(IDATA(IPTR+1),0,IWRK(HPTR0),0,4*LDTR)
      GOTO IZZZ02
17000 CONTINUE
         S0 = 0.
         S1 = 0.
         S2 = 0.
         S3 = 0.
         S4 = 0.
      DO 13014 IHWIR=1,NHWIR
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      DO 13016 JNH=1,NNH
               ISORT4(KFLIP,IH+JNH-1)=0
13016 CONTINUE
13017 CONTINUE
      IF(
     - ISORT3(IH).EQ.1 .OR. ISORT3(IH).EQ.-1.AND.NNH.GT.1
     -)THEN
               RESMIN=10000.
      DO 13018 JNH=1,NNH
                  JH=IH+JNH-1
      IF(
     - ISORT3(JH).EQ.1
     -)THEN
                     IPCO=ISORT2(1,IHWIR)+(JNH-1)*HLDCO
                     XA = WRK(IPCO+3)
                     XAR=XA-XHF
      IF(
     - XAR.GT.XMIN .AND. XAR.LT.XMAX
     -)THEN
                        YA = WRK(IPCO+4)
      IF(
     - LFTYP.EQ.2
     -)THEN
                           DYRESA=YA-(PAR1*XAR+PAR2)*XAR-PAR3
      ELSE
                           AAH=-XAR**2*CSI2GM
                           FDBPR=1./(1.+PAR1*XAR*PAR2)
                           SAG=SAGCIR(FDBPR,PAR1,AAH,SAGPR,1.E-4)
                           DYRESA=YA-SAG-PAR2*XAR-PAR3
      ENDIF
                        DF0=ABS(DYRESA)
      ELSE
                        DF0=15000.
      ENDIF
      IF(
     - DF0.LT.RESMIN
     -)THEN
                        RESMIN=DF0
                        XR=XAR
                        DYRES=DYRESA
                        JHUSE=JH
      ENDIF
      ENDIF
13018 CONTINUE
13019 CONTINUE
      IF(
     - RESMIN.LT.DISCUT
     -)THEN
                  S0=S0+1.
                  S1=S1+XR
                  S2=S2+XR**2
                  S3=S3+DYRES
                  S4=S4+DYRES*XR
                  ISORT4(KFLIP,JHUSE)=1
      ENDIF
      ENDIF
13014 CONTINUE
13015 CONTINUE
         NHFIT=S0+.1
      IF(
     - NHFIT.GE.4
     -)THEN
            S12=S1/S2
            S42=S4/S2
            DA=(S3-S1*S42)/(S0-S1*S12)
            DB=S42-S12*DA
            PAR3=PAR3+DA
            PAR2=PAR2+DB
            CSI2GM=1.+PAR2**2
      IF(
     - LFTYP.EQ.2
     -)THEN
               CUROUT =-PAR1 * 2./ (SQRT(CSI2GM)*CSI2GM)
      ELSE
               CUROUT=PAR1/SQRT(CSI2GM)
               XMIN=PAR2/PAR1-CKAPP/ABS(CUROUT)
               XMAX=PAR2/PAR1+CKAPP/ABS(CUROUT)
      ENDIF
      ENDIF
      GOTO IZZZ01
17004 CONTINUE
      ISTV1=0
      DISCUT=400.
15008 CONTINUE
      IF(
     - ISTV1.LT.10
     -)THEN
         ISTV1=ISTV1+1
         S0 = 0.
         S1 = 0.
         S2 = 0.
         S3 = 0.
         S4 = 0.
         S8 = 0.
         S7 = 0.
         S6 = 0.
         S5 = 0.
         KFLIP=3-KFLIP
      DO 13020 IHWIR=1,NHWIR
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      DO 13022 JNH=1,NNH
               ISORT4(KFLIP,IH+JNH-1)=0
13022 CONTINUE
13023 CONTINUE
      IF(
     - ISORT3(IH).EQ.1 .OR. ISORT3(IH).EQ.-1.AND.NNH.GT.1
     -)THEN
               RESMIN=10000.
      DO 13024 JNH=1,NNH
                  JH=IH+JNH-1
      IF(
     - ISORT3(JH).EQ.1
     -)THEN
                     IPCO=ISORT2(1,IHWIR)+(JNH-1)*HLDCO
                     XA = WRK(IPCO+3)
                     XAR= WRK(IPCO+3)-XHF
      IF(
     - XAR.GT.XMIN.AND.XAR.LT.XMAX
     -)THEN
                        YA = WRK(IPCO+4)
                        AAH=-XAR**2
                        FDBPR=1./(1.+PAR1*XAR*PAR2)
                        SAG=SAGCIR(FDBPR,PAR1,AAH*CSI2GM,SAGPR,1.E-4)
                        DYRESA=YA-SAG-PAR2*XAR-PAR3
                        DF0=ABS(DYRESA)
      ELSE
                        DF0=15000.
      ENDIF
      IF(
     - DF0.LT.RESMIN
     -)THEN
                        RESMIN=DF0
                        X=XAR
                        DYRES=DYRESA
                        JHUSE=JH
      ENDIF
      ENDIF
13024 CONTINUE
13025 CONTINUE
      IF(
     - RESMIN.LT.DISCUT
     -)THEN
                  S0=S0+1.
                  S1=S1+X
                  S2=S2+X**2
                  S3=S3+X**3
                  S4=S4+X**4
                  S8=S8+X**2
                  S7=S7+DYRES
                  S6=S6+DYRES*X
                  S5=S5+DYRES*X**2
                  ISORT4(KFLIP,JHUSE)=1
      ENDIF
      ENDIF
13020 CONTINUE
13021 CONTINUE
         NHFIT=S0+.1
         IF(NHFIT.LT.5) RETURN
         F1 = 1. / S4
         XX12 = S3*F1
         XX13 = S2*F1
         YY1  = S5*F1
         XX22 = S8 - S3*XX12
         XX23 = S1 - S3*XX13
         YY2  = S6 - S3*YY1
         XX32 = S1 - S2*XX12
         XX33 = S0 - S2*XX13
         YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
            XX23 = XX23 / XX22
            YY2  = YY2  / XX22
            PARR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
            PARR2 = YY2 - XX23*PARR3
      ELSE
            XX33 = XX33 / XX32
            YY3  = YY3  / XX32
            PARR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
            PARR2 = YY3 - XX33*PARR3
      ENDIF
         PARR1 = YY1 - XX12*PARR2 - XX13*PARR3
         XAR=-.7*RRMI
         IF(XAR.LT..8*XMIN) XAR=.8*XMIN
         XBR= .7*RRPL
         IF(XBR.GT..8*XMAX) XBR=.8*XMAX
      IF(
     - -XAR.LT.XBR
     -)THEN
            XBR=-XAR
      ELSE
            XAR=-XBR
      ENDIF
         AAH=-XAR**2*CSI2GM
         FDBPR=1./(1.+PAR1*XAR*PAR2)
         SAG=SAGCIR(FDBPR,PAR1,AAH,SAGPR,1.E-4)
         YA=SAG+PAR2*XAR+PAR3 + (PARR1*XAR+PARR2)*XAR+PARR3
         AAH=-XBR**2*CSI2GM
         FDBPR=1./(1.+PAR1*XBR*PAR2)
         SAG=SAGCIR(FDBPR,PAR1,AAH,SAGPR,1.E-4)
         YB=SAG+PAR2*XBR+PAR3 + (PARR1*XBR+PARR2)*XBR+PARR3
         YC=PAR3+PARR3
         P2=(YB-YA)/(2.*XBR)
         C2=1.+P2**2
         SAG=YC-.5*(YA+YB)
      IF(
     - SAG**2.GT.(CKAPP*XBR)**2*C2
     -)THEN
            SAG=SIGN(CKAPP*XBR*SQRT(C2),SAG)
            YC=.5*(YA+YB)+SAG
      ENDIF
         PAR3=YC
         P1=2.*SAG/(C2*XBR**2-SAG**2)
         CUROUT=P1/SQRT(C2*(1.+(P1*XBR)**2))
         IF(ABS(CUROUT).LT.1.E-8) CUROUT= SIGN(1.E-8,CUROUT)
         PAR2=P2/(1.+SAG*P1)
         CSI2GM=1.+PAR2**2
         PAR1=CUROUT*SQRT(CSI2GM)
         XMIN=PAR2/PAR1-CKAPP/ABS(CUROUT)
         XMAX=PAR2/PAR1+CKAPP/ABS(CUROUT)
         DISCUT=.5*DISCUT
         IF(DISCUT.LT.10.) DISCUT=10.
      GOTO 15008
      ENDIF
15009 CONTINUE
      GOTO IZZZ03
17015 CONTINUE
         SAMFI=SINALP*CSROT-COSALP*SNROT
         CAMFI=COSALP*CSROT+SINALP*SNROT
         IP00=2*IDATA(IQJETC)+100
      DO 13026 IHWIR=1,NHWIR
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      DO 13028 JNH=1,NNH
               JH=IH+JNH-1
      IF(
     - ISORT4(KFLIP,JH).NE.1
     -)THEN
                  IPCO=ISORT2(1,IHWIR)+(JNH-1)*HLDCO
                  X=WRK(IPCO+3)
                  Y=WRK(IPCO+4)
                  A=(X-XOR)*CAMFI+(Y-YOR)*SAMFI
                  B=(X-XOR)*SAMFI-(Y-YOR)*CAMFI
                  FDBPR=1./ACURV+DIMP-A
      IF(
     - FDBPR.LT.100.
     -)THEN
                     SAG=SQRT(FDBPR**2+B**2)
                     RESA=SAG-1./ACURV
      ELSE
                     FDBPR=1./(1.+ACURV*(DIMP-A))
                     SAG=SAGCIR(FDBPR,ACURV,B**2,SP,1.E-4)
                     RESA=DIMP-A+SAG
      ENDIF
                  WRK(IPCO+13)=RESA
      IF(
     - LJHTLU.EQ.1
     -)THEN
                     IP1   =IWRK(IPCO+1)
                     LBSIDE=IWRK(IPCO+2)
                     IPHL=IPJHTL+2+(IP1-IP00)/4
                     LB=IDATA(IPHL)
                     IDST=ABS(RESA)*5.
                     IF(IDST.GT.31) IDST=31
                     IDST=ISHFTL(IDST,11)
                     IDST=LOR(IDST,1024)
                     IF(LBSIDE.EQ.1) IDST=LOR(IDST,256)
                     ITR1=LAND(ISHFTR(LB,17),127)
      IF(
     - ITR1.EQ.ITRK
     -)THEN
                        IDATA(IPHL)=LOR(LAND(LB,MASK1),ISHFTL(IDST,16))
      ELSE
                        IDATA(IPHL)=LOR(LAND(LB,MASK2),      IDST    )
      ENDIF
      ENDIF
      ENDIF
13028 CONTINUE
13029 CONTINUE
13026 CONTINUE
13027 CONTINUE
         CHISQ=0.
         NHF1=0
         S0D= 0.D0
         S1D= 0.D0
         S2D= 0.D0
         S3D= 0.D0
         S4D= 0.D0
         S8D= 0.D0
      DO 13030 IHWIR=1,NHWIR
            IH=ISORT2(2,IHWIR)
            NNH=ISORT2(3,IHWIR)
      DO 13032 JNH=1,NNH
               JH=IH+JNH-1
      IF(
     - ISORT4(KFLIP,JH).EQ.1
     -)THEN
                  IPCO=ISORT2(1,IHWIR)+(JNH-1)*HLDCO
                  X=WRK(IPCO+3)
                  Y=WRK(IPCO+4)
                  A=(X-XOR)*CAMFI+(Y-YOR)*SAMFI
                  B=(X-XOR)*SAMFI-(Y-YOR)*CAMFI
                  FDBPR=1./ACURV+DIMP-A
      IF(
     - FDBPR.LT.100.
     -)THEN
                     SAG=SQRT(FDBPR**2+B**2)
                     RESA=SAG-1./ACURV
                     DRDP2=FDBPR/SAG
                     DRDP1=B*(DRDP2+A/SAG)
                     DRDP3=1./ACURV**2*(1.-DRDP2)
      ELSE
                     FDBPR=1./(1.+ACURV*(DIMP-A))
                     SAG=SAGCIR(FDBPR,ACURV,B**2,SP,1.E-4)
                     DRDP2=1./(1.+SAG*FDBPR*ACURV)
                     DRDP1=DRDP2*B*(1.+A*FDBPR*ACURV)
                     DRDP3=DRDP2*FDBPR*SP
                     RESA=DIMP-A+SAG
      ENDIF
                  NHF1=NHF1+1
                  CHISQ=CHISQ+RESA**2
                  S0D=S0D+DRDP3**2
                  S1D=S1D+DRDP3*DRDP2
                  S2D=S2D+DRDP1*DRDP3
                  S3D=S3D+DRDP1*DRDP2
                  S4D=S4D+DRDP1**2
                  S8D=S8D+DRDP2**2
                  IWRK(IPCO+10)=0
                  WRK(IPCO+13)=RESA
      IF(
     - LJHTLU.EQ.1
     -)THEN
                     IP1   =IWRK(IPCO+1)
                     LBSIDE=IWRK(IPCO+2)
                     IPHL=IPJHTL+2+(IP1-IP00)/4
                     LB=IDATA(IPHL)
                     IDST=ABS(RESA)*5.
                     IF(IDST.GT.31) IDST=31
                     IDST=ISHFTL(IDST,11)
                     IF(LBSIDE.EQ.1) IDST=LOR(IDST,256)
                     ITR1=LAND(ISHFTR(LB,17),127)
      IF(
     - ITR1.EQ.ITRK
     -)THEN
                        IDATA(IPHL)=LOR(LAND(LB,MASK1),ISHFTL(IDST,16))
      ELSE
                        IDATA(IPHL)=LOR(LAND(LB,MASK2),      IDST    )
      ENDIF
      ENDIF
      ENDIF
13032 CONTINUE
13033 CONTINUE
13030 CONTINUE
13031 CONTINUE
      IF(
     - LCOVAR.EQ.1
     -)THEN
      IF(
     - NHF1.LT.10.OR.NHF1.NE.NHFIT
     -)THEN
               PRINT 6781,NRUN,NEV,ITRK,NHFIT,NHF1
6781           FORMAT(' RUN,EV,TRK,NHFIT,NHF1',I7,I6,I3,2I5)
      ELSE
               DETD=(S8D*S0D-S1D*S1D)*S4D+
     +        (S2D*S1D-S3D*S0D)*S3D+(S3D*S1D-S2D*S8D)*S2D
               FACT=CHISQ/(NHFIT-3)/DETD
               IWRK(IP+2) =LOR(IWRK(IP+2),2048)
               WRK(IP+49)=CHISQ/.115**2
               WRK(IP+50)=(S8D*S0D-S1D**2)*FACT
               WRK(IP+51)=(S1D*S2D-S0D*S3D)*FACT
               WRK(IP+52)=(S4D*S0D-S2D**2)*FACT
               WRK(IP+53)=(S3D*S1D-S8D*S2D)*FACT
               WRK(IP+54)=(S2D*S3D-S1D*S4D)*FACT
               WRK(IP+55)=(S8D*S4D-S3D**2)*FACT
      ENDIF
      ENDIF
      GOTO IZZZ07
      END

C   09/02/87 809301320  MEMBER NAME  TPTRTS   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE TPTRTS( IPATR, ITRK, BKG, NTPTR, HV, INPV, IER )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      22/07/87:  Create summary for one track
C
C          mod: C. Bowdery      26/07/87:  HNPV --> INPV
C          mod: C. Bowdery      11/01/88:  SETSL--> VZERO
C     Last mod: C. Bowdery      30/09/88:  New IER argument added
C
C     Routine to summarise one PATR track and handle vertex info
C     PATR track ITRK does not necessarily correspond to TPTR bank NTPTR
C
C     Based upon TPPATR by S. Yamada.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     IPATR     In       I*4      Pointer to required PATR bank
C     ITRK      In       I*4      PATR track number to be processed
C     BKG       In       R*4      Magnetic field in kilogauss
C     NTPTR     In / Out I*4      TPTR bank no. to be created and incr.
C     HV        In / Out I*2      Vertex working array
C     INPV      In / Out I*4      Pointer to HV for next track no. slot
C     IER            Out I*4      Error code from CCRE
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

C                            NW   = no. of words in a TPTR bank
C                            NVLM = no. of words in the TPVX/1 bank

      PARAMETER  ( NW     =     80 )
      PARAMETER  ( NVLM   =    100 )
      PARAMETER  ( INPVMX = 2*NVLM )

C                            IW: work space for each track
C                            HV: work space for the event vertex

      DIMENSION  IW( NW ), HV( INPVMX )

      DIMENSION  HW( 2*NW ), AW( NW )

      EQUIVALENCE ( HW(1),IW(1) ), ( AW(1),IW(1) )

C------------------  C O D E  ------------------------------------------

      IER   = 0

C                            Get the pointer to this track

      NWHD  = IDATA( IPATR + 1 )
      NWTRK = IDATA( IPATR + 3 )
      NB    = IPATR + NWHD + ( ITRK - 1 )*NWTRK

C                            Check if track is part of a curling one
C                            Skip processing if it is.

      CALL PARCIR( IPATR, NB, NBPAR )

      IF( NBPAR .EQ. 0 ) THEN

C                            Clear IW working space

        CALL VZERO( IW, NW )

C                            First assume this track from primary vertex
        HW( 1 ) = 1

C                            Track is seen in the Jet Chamber: code 1000
        HW( 3 ) = 1000

C                            Pointer to the copied track in 'PATR'.
        HW( 4 ) = ITRK

C                            Quality of the track
C                              chi**2 and no. of hits used: xy then rz

        AW( 19 ) = ADATA( NB + 23 )
        IW( 20 ) = IDATA( NB + 24 )
        AW( 21 ) = ADATA( NB + 32 )
        IW( 22 ) = IDATA( NB + 33 )

C                            CRV is the curvature in 1/mm
        CRV  = ADATA( NB + 25 )
        IF( BKG .LT. 0.0 ) CRV = -CRV
        ACRV = ABS( CRV )

C                            Charge of the track (from sign of CRV)
C                            If ambiguous charge, multiply by 100.

        AW(23) = SIGN( 1.0, CRV )

        IF( ADATA( NB + 26 ) .GE. ACRV ) AW(23) = 100.0 * AW(23)

C                            Calculate PT, momentum transverse to beam

        IF( ACRV .EQ. 0.0 ) ACRV = 1.E-10
        PT = ABS( 0.2998E-4 * BKG / ACRV )

C                            Calculate direction in xy plane

        DXY = SQRT( ADATA( NB+8 )**2 + ADATA( NB+9 )**2 )
        IF( DXY .EQ. 0.0 ) DXY = 1.E-10

C                            Calculate total momentum and error

        AW(24) = PT/DXY
        AW(25) = AW(24)*ADATA( NB+26 )/ACRV

C                            Store 'type' of the track direction
C                            1 = the line direction from the
C                                vertex to the first hit point
        IW(26) = 1

C                            Store direction cosines from PATR

        AW(27) = ADATA( NB+ 8 )
        AW(28) = ADATA( NB+ 9 )
        AW(29) = ADATA( NB+10 )

C                            VTXC/1 bank info
C                            HV(22)  # of the secondary tracks
C                            HV(23)  # of the positive secondary tracks
C                            HV(24)  # of the negative secondary tracks
C                            HV(26)  # of ambiguous secondary tracks

        HV(22) = HV(22) + 1

        IF( ABS(AW(23)) .LT. 10.0 ) THEN

          IF(AW(23) .GE. 0.0 ) THEN
            HV(23) = HV(23) + 1
          ELSE
            HV(24) = HV(24) + 1
          ENDIF

        ELSE
          HV(26) = HV(26) + 1
        ENDIF
        INPV = INPV + 1
        IF( INPV .LE. INPVMX )  HV( INPV ) = NTPTR

C                            Create a new track bank

        CALL CCRE( ITPTR, 'TPTR', NTPTR,  NW, IER )

        IF( IER .NE. 0 ) THEN
          CALL TPERRH
        ELSE
          CALL BSTR( ITPTR, IW, NW )
C + + + +                                       debug start
C         CALL BPRS( 'TPTR', NTPTR )
C + + + +                                       debug end
        ENDIF

C                           Increment TPTR bank number for next CALL

        NTPTR = NTPTR + 1

      ENDIF

      RETURN
      END

C   24/11/78 206041944  MEMBER NAME  USUNIGAM (JADEMC2)     FORTRAN
      SUBROUTINE USER(INDEX)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C---
      IMPLICIT INTEGER*2 (H)
C
      COMMON // BLCOMM(15000)
#include "cgraph.for"
C
#include "cdata.for"
      COMMON /CHEADR/ HEAD(108)
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR
      DIMENSION IGG(30),JIGG(10)
C---
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   MUON CHAMBER TRACKING HAS BEEN DONE.
C              9   MUON AND INNER DETECTOR TRACKS HAVE BEEN ASSOCIATED.
C             10   UNUSED
C---
C---     CHECK WHETHER CALL AT END OF JOB
      IF(INDEX.EQ.100) GOTO 9900
C
      GO TO (100,200,300,400,500,600,700,800,900,1000),INDEX
C---
C---     INDEX=0 INITIALIZATION.
C---
C
      DO 99 I = 1,10
99    JIGG(I) = 0
      DO 98 I = 1,30
98    IGG(I) = 0
      IPHMC = 25
      CALL HBOOK1( 1,' TOTAL ENERGY ALGN INT 1$',100,0.,2000.)
      CALL HBOOK1( 2,' TOTAL ENERGY ALGN INT 1$',100,0.,600.)
      CALL HBOOK1( 3,' TOTAL ENERGY ALGN INT 1$',100,0.,200.)
      CALL HBOOK1(11,' TOTAL ENERGY ALGN INT 2$',100,0.,2000.)
      CALL HBOOK1(12,' TOTAL ENERGY ALGN INT 2$',100,0.,600.)
      CALL HBOOK1(13,' TOTAL ENERGY ALGN INT 2$',100,0.,200.)
      CALL HBOOK1(21,' TOTAL ENERGY ALGN INT 3$',100,0.,2000.)
      CALL HBOOK1(22,' TOTAL ENERGY ALGN INT 3$',100,0.,600.)
      CALL HBOOK1(23,' TOTAL ENERGY ALGN INT 3$',100,0.,200.)
      CALL HBOOK1(31,' TOTAL ENERGY ALGN INT 4$',100,0.,2000.)
      CALL HBOOK1(32,' TOTAL ENERGY ALGN INT 4$',100,0.,600.)
      CALL HBOOK1(33,' TOTAL ENERGY ALGN INT 4$',100,0.,200.)
      CALL HBOOK1(41,' TOTAL ENERGY ALGN INT 5$',100,0.,2000.)
      CALL HBOOK1(42,' TOTAL ENERGY ALGN INT 5$',100,0.,600.)
      CALL HBOOK1(43,' TOTAL ENERGY ALGN INT 5$',100,0.,200.)
      CALL HBOOK1(51,' TOTAL ENERGY ALGN INT 6$',100,0.,2000.)
      CALL HBOOK1(52,' TOTAL ENERGY ALGN INT 6$',100,0.,600.)
      CALL HBOOK1(53,' TOTAL ENERGY ALGN INT 6$',100,0.,200.)
      CALL HBOOK1(61,' TOTAL ENERGY ALGN INT 7$',100,0.,2000.)
      CALL HBOOK1(62,' TOTAL ENERGY ALGN INT 7$',100,0.,600.)
      CALL HBOOK1(63,' TOTAL ENERGY ALGN INT 7$',100,0.,200.)
      CALL HBOOK1(71,' TOTAL ENERGY ALGN INT 8$',100,0.,2000.)
      CALL HBOOK1(72,' TOTAL ENERGY ALGN INT 8$',100,0.,600.)
      CALL HBOOK1(73,' TOTAL ENERGY ALGN INT 8$',100,0.,200.)
      CALL HBOOK1(81,' TOTAL ENERGY ALGN INT 9$',100,0.,2000.)
      CALL HBOOK1(82,' TOTAL ENERGY ALGN INT 9$',100,0.,600.)
      CALL HBOOK1(83,' TOTAL ENERGY ALGN INT 9$',100,0.,200.)
      CALL HBOOK1(91,' TOTAL ENERGY ALGN INT 0$',100,0.,2000.)
      CALL HBOOK1(92,' TOTAL ENERGY ALGN INT 0$',100,0.,600.)
      CALL HBOOK1(93,' TOTAL ENERGY ALGN INT 0$',100,0.,200.)
      CALL HBOOK1(101,' TOTAL ENERGY ALGN INT 10$',100,0.,2000.)
      CALL HBOOK1(102,' TOTAL ENERGY ALGN INT 10$',100,0.,600.)
      CALL HBOOK1(103,' TOTAL ENERGY ALGN INT 10$',100,0.,200.)
      CALL HBOOK1(111,' TOTAL ENERGY ALGN INT 11$',100,0.,2000.)
      CALL HBOOK1(112,' TOTAL ENERGY ALGN INT 11$',100,0.,600.)
      CALL HBOOK1(113,' TOTAL ENERGY ALGN INT 11$',100,0.,200.)
      CALL HBOOK1(121,' TOTAL ENERGY ALGN INT 12$',100,0.,2000.)
      CALL HBOOK1(122,' TOTAL ENERGY ALGN INT 12$',100,0.,600.)
      CALL HBOOK1(123,' TOTAL ENERGY ALGN INT 12$',100,0.,200.)
      KIBO = -1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
100   CONTINUE
      JIGG(1) = JIGG(1) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
200   CONTINUE
C                                    SELECT EVENT
      JIGG(2) = JIGG(2) + 1
C     IBO = (JIGG(2)-1)/1000
      IF((JIGG(2)/500)*500.EQ.JIGG(2)) WRITE(6,117) JIGG(2),HEAD(19)
117   FORMAT(' RECORD AND EVENT NR ',2I10)
      IBO = (HEAD(19) - 1)/1000
      IBO = 10*IBO
      IF(IBO.EQ.KIBO) GO TO 222
      KIBO = IBO
      LIGO = 0
      WRITE(6,911) IBO,JIGG(2),HEAD(19)
911   FORMAT(' IBO JIGG2 HEAD19 ',3I10)
222   LIGO = LIGO + 1
      IF(LIGO.GT.10) GO TO 333
      CALL ERGTOT(ECYL,ECAMI,ECAPL)
      ETOT1 = ECYL + ECAMI + ECAPL
333   CALL RMALGN(IPHMC)
      CALL ERGTOT(ECYL,ECAMI,ECAPL)
      ETOT = ECYL + ECAMI + ECAPL
      IF(LIGO.GT.10) GO TO 444
      WRITE(6,445) ETOT1,ETOT
445   FORMAT(' ETOT BEFORE AND AFTER RMALGN ',2E12.4)
444   CALL HFILL(IBO + 1,ETOT,0,1.)
      CALL HFILL(IBO + 2,ETOT,0,1.)
      CALL HFILL(IBO + 3,ETOT,0,1.)
      GO TO 11
C -------------------------------------------------------------------
300   CONTINUE
C                                    LEAD GLASS CALIBRATION DONE
      JIGG(3) = JIGG(3) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
400   CONTINUE
C                                    ZVERTEX CALCULATED
      JIGG(4) = JIGG(4) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
500   CONTINUE
C                                    PATREC PERFORMED
      JIGG(5) = JIGG(5) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
600   CONTINUE
C                                    CLUSTER ANALYSIS PERFORMED
      JIGG(6) = JIGG(6) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
700   CONTINUE
      JIGG(7) = JIGG(7) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
800   CONTINUE
      JIGG(8) = JIGG(8) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
900   CONTINUE
      JIGG(9) = JIGG(9) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
1000  CONTINUE
      JIGG(10) = JIGG(10) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C---     END OF JOB: FINAL CALCULATIONS + PRINTOUT
9900  CONTINUE
      WRITE(JUSCRN,9901) JIGG
      WRITE(JUSCRN,9902) IGG
9901  FORMAT(' JIGG ',12I10)
9902  FORMAT(' IGG ',10I10)
      CALL HISTDO
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---     'GO TO 11' MEANS ACCEPT EVENT, WRITE IT AND GO TO NEXT EVENT
C---     'GO TO 12' MEANS END THE JOB, WRITE FINAL RESULTS AND PLOTS
C---
1     INDEX = 1
      RETURN
2     INDEX = 2
      RETURN
3     INDEX = 3
      RETURN
4     INDEX = 4
      RETURN
5     INDEX = 5
      RETURN
6     INDEX = 6
      RETURN
7     INDEX = 7
      RETURN
8     INDEX = 8
      RETURN
9     INDEX = 9
      RETURN
10    INDEX = 10
      RETURN
11    INDEX = 11
      IGG(11) = IGG(11) + 1
      RETURN
12    INDEX = 12
      RETURN
      END

C   23/08/85 801311742  MEMBER NAME  MCTAGS9  (S)           FORTRAN
C-----------------------------------------------------------------------
C   15/03/84 403152035  MEMBER NAME  MCTAGS   (S)           FORTRAN
C
C ROUTINE TO SMEAR OUT CONTENTS OF ARRAY HGG
C IN ACCORDANCE WITH OBSERVED RESOLUTION
C AND CONVERT TO ADC CHANNEL NUMBER FROM ENERGY
C
C    HGG IS ON ENTRY EXPRESSED IN MEV. ON EXIT IN CHANNEL COUNTS
C
C
C
C A.J.FINCH 3/84
C
C CORRECTED 18.11.87   J.O.
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE MCTAGS
       IMPLICIT INTEGER*2 (H)
#include "cmctag.for"
C
       DATA CUTOFF/20.0/
C
C
C      TEST = CUTOFF * CALIBS     REMOVED   18.11.87
C
       DO 1 I = 1,NCHANS
C        IF(HGG(I).LE.TEST)HGG(I)=0   REMOVED 18.11.1987
         IF(HGG(I).LE.0)    GOTO 1
C
          ENERGY = HGG(I)/1000.0
          SMEAR=SQRT(ENERGY)*SIGMAS
          CALL NVERT(SMEAR,ENERGY,ENEW)
          HGG(I) = (ENEW*1000.0)/CALIBS
C   HGG NOW IN ADC COUNTS, SO TEST AGAINST THRESHOLD EXPRESSED IN COUNTS
         IF(HGG(I).LE.CUTOFF)HGG(I)=0
   1   CONTINUE
       RETURN
       END

C   02/11/81 312061526  MEMBER NAME  JGETVC   (S)           FORTRAN
      SUBROUTINE JGETVC( P, R, ICODE, IPRINT )
C-----------------------------------------------------------
C
C  VERSION OF 02/11/81   LAST MOD 05/11/81      E.ELSEN
C  GET NEXT REASONABLE 4-VECTOR FROM BANK VECT.
C  P = MOMENTUM ARRAY, R = STARTING POINT.
C  ICODE > 0 IF NO MORE PARTICLES IN VECT BANKS.
C  ( STEERED VIA COMMON /CJTCDC / )
C  PRINT OUT IF PRINT > 0.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON / CJTCDC / IBANK, IPART
      COMMON / CJTRLE / TOTLEN, STPLEN, TRCOFS
C
      COMMON / CJPATR / KPATR, IPATR(1448)
      DIMENSION HPATR(1)
      EQUIVALENCE (HPATR(1),IPATR(1))
C
      DIMENSION P(10),R(3)
C
      DATA IUNPH / 0 /
      DATA ICALL / 0 /
      IF( ICALL .GT. 0 ) GO TO 1
      ICALL = 1
      IPVECT = IBLN('VECT')
    1 CONTINUE
C
      NPVECT = IPVECT + 1
      ICODE = 2
    2 NPVECT = IW(NPVECT-1)
      IF( NPVECT .LE. 0 ) GO TO 8000
      IF( IW(NPVECT-2) .LT. IBANK ) GO TO 2
C
      L0 = IW(NPVECT+1)
      L1 = IW(NPVECT+2)
      NR  = IW(NPVECT+3)
      N  = IW(NPVECT+4)
C
      IF( IPART.EQ.0.AND.IPRINT.GT.0 ) WRITE(6,9101) NR, IBANK
 9101 FORMAT(//' === EVENT ',I5,
     *        '  === TRACKED PARTICLES FROM VECT',I3,' FOLLOWING ===' )
C
 1000 IF( IPART .GE. N ) GO TO 7000
      IP = NPVECT + L0 + IPART*L1
      IPART = IPART + 1
      ITYPE = IW(IP+7)
C                                           CHECK PARTICLE TYPE
      IF( ITYPE .LE. 0 ) GO TO 1000
C                                           UNPHYSICAL PARTICLES
      IF(RW(IP+5).EQ.0. .AND. IW(IP+6).NE.0 ) GO TO 6500
C
C                                           INITIALISE PARTICLE VECTOR
C                                           AND ORIGIN
      DO 200 J=1,5
  200 P(J)=RW(IP+J)
      P(6)=SQRT(P(1)**2+P(2)**2+P(3)**2)
      P(7)=IW(IP+6)
      P(8)=IW(IP+7)
      P(9)=0.
      P(10)=0.
C
      R(1)=RW(IP+ 8)
      R(2)=RW(IP+ 9)
      R(3)=RW(IP+10)
      R(4)=RW(IP+11)
C                                           OFFSET FOR TOF
      IF( IBANK .EQ. 1 ) TRCOFS = RW(IP+12)
      IF( IBANK .EQ. 0 ) TRCOFS = SQRT( R(1)**2+R(2)**2+R(3)**2 )
C                                           PATR INFORMATION
      IPATR( KPATR + 4 ) = IBANK + 1
      HPATR( (KPATR+2)*2-1) = IPART
C
      IF( IPRINT .GT. 0 ) WRITE(6,9102) (P(I),I=1,8),R
 9102 FORMAT(8F8.3,3F9.3)
C
C
      ICODE = 0
      GO TO 8000
C
C                                           MESSAGES
 6500 IF( IUNPH .GT. 5 ) GO TO 1000
      IUNPH = IUNPH + 1
      WRITE(6,9103) IPART
 9103 FORMAT(' === UNPHYSICAL PARTICLE AT PARTICLE #',I3,' ===')
      CALL BPRS( 'VECT', IBANK )
      GO TO 1000
C                                           NEXT BANK
 7000 IBANK = IBANK + 1
      IPART = 0
      GO TO 2
C
C
 8000 RETURN
      END

C   23/02/84 403091204  MEMBER NAME  MU2PUL   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      INTEGER FUNCTION  MU2PUL( IMONTH, IYEAR )
C-----------------------------------------------------------------------
C
C NEW FUNC    15.15  23/02/84   C. BOWDERY - DOUBLE PULSE CUT FOR MUCOOR
C
C     THIS FUNCTION RETURNS THE DOUBLE PULSE CUT (IN CLOCK PULSES)  THAT
C     IS NEEDED BY MUCOOR TO ELIMINATE "ECHO" PULSES CAUSED BY ELECTRON-
C     IC PROBLEMS IN THE DIGITISERS. USE TIME TO IMPLEMENT THESE BODGES,
C     RATHER THAN RUN NO. SO  THAT  MONTE-CARLO  WILL  HAVE THE CORRECT
C     VALUE TOO.
C
C     INPUT:   IMONTH   =  MONTH WHEN EVENT WAS RECORDED
C              IYEAR    =  YEAR  WHEN EVENT WAS RECORDED
C
C     OUTPUT:  MU2PUL   =  15       ( 1/1979 - 8/1983 )
C                       =  30       ( 9/1983 -   ?    )
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C------------------  C O D E  ------------------------------------------
C
      ITIME  = IYEAR * 100  +  IMONTH
C
      MU2PUL = 15
C
      IF( ITIME .GT. 198308 ) MU2PUL = 30
C
      RETURN
      END

C   12/03/84 412041854  MEMBER NAME  TAGSR2   (S)           FORTRAN
C
C
C
C
       SUBROUTINE TAGSR2(ICLUS)
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   THIS ROUTINE SORTS A SINGLE CLUSTER INTO ORDER OF ENERGY
C   SO THAT BY THE END CLUS(I,1) = ADDRESS,CLUS(I,2) = ENERGY
C   AND CLUS(I,2 ) >CLUS(I + 1,2)
C
C  ICLUS - INPUT - POINTER TO CLUSTER IN CLUSTER MAP CMAP(10,9)
C                  PRODUCED BY TAGPOS
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C

       DIMENSION STEMP(2)
C
       NNEI = NLIST(CMAP(ICLUS,1),1,MARK)
       IEND = NNEI + 1
       DO 5 I = 1,IEND
C
C                                   GET ADDRESS FROM CLUSTER MAP
C                                   AND ENERGY FROM CATAG
C
          CLUS(I,1) = CMAP(ICLUS,I)
          CLUS(I,2) = CATAG(CLUS(I,1))
    5  CONTINUE
C
C                                   RIPPLE SORT
C
       DO 10 J = 1 ,NNEI
          DO 11 K = 1,NNEI
             IF ( CLUS(K,2) .GT. CLUS(K+1,2) )  GOTO 11
             STEMP(1)    = CLUS(K,1)
             STEMP(2)    = CLUS(K,2)
             CLUS(K,1)   = CLUS(K+1,1)
             CLUS(K,2)   = CLUS(K+1,2)
             CLUS(K+1,1) = STEMP(1)
             CLUS(K+1,2) = STEMP(2)
   11     CONTINUE
   10  CONTINUE
  100  RETURN
       END

C   14/03/84 403191509  MEMBER NAME  INGAM1   (S)           FORTRAN
C   11/03/80 211191721  MEMBER NAME  INGAM1   (S)           FORTRAN
      SUBROUTINE INGAM1(IER,*,*)
C---  READ AND UNPACK DATA (REDUCED DATA !)
C---  GENERAL PURPOSE ROUTINE FOR ALL RUNS(MACRO- & MINI-BETA)
C---  (PEDESTAL SUBTRACTION IF NECESSARY, LATCHES REORDERED MAY 79,
C---   CALLED BY "@ANALYS1" (1979/80) OR "@ANALY81" (1981 F) )
C---  TREATS CHANNELS WITH & WITHOUT VARIING PEDESTALS
C
C
C     H.WRIEDT       12.03.79       11:15
C     LAST MODIFICATION       19.11.82      17:20
C     COPIED BY A.J.FINCH FROM SERVICE.S
C     BREAD TAKEN OUT
C
      IMPLICIT INTEGER*2 (H)
C
      EXTERNAL BDLM
C

      COMMON /BCS/ IDATA(30000)
      INTEGER*2 HDATA(60000)
      REAL RDATA(30000)
      EQUIVALENCE (IDATA(1),HDATA(1),RDATA(1))
C
      COMMON /CWORK/ HCOINC(16),HLUMON(16),HGGLAT(16),HSCALE(36),
     &               LNG,HPOINT(4),HGGADC(2,240),IWORK1(221),HCORR,
     &               HPBLAT,IWORK2,HSCAL(36),IWORK3(762),HACC,HIL,
     &               HLULAT,HWORK2,IWORK4(618),HRUNEX,HEVENT
      DIMENSION LAT(2),HLAT(4)
      INTEGER GGADC(242)
      EQUIVALENCE (GGADC(3),HGGADC(1,1)), (HLAT(1),LAT(1))
C
      COMMON /CRUNCO/ HRUN,HOLDRN,IUN
C
      COMMON /CPHASE/ LIMEVT
C
      DATA ICOUNT/0/
      DATA ILERR/0/
C
      IER = 0
C DELETED BY A.J.FINCH
C---  READ EVENT
C     CALL BREAD(IUN,&2,&3)
C     CALL BSLT
C     GOTO 4
C   2 RETURN 1
C   3 RETURN 2
C
C---  FETCH HEAD-POINTER
    4 IHEAD = IDATA(IBLN('HEAD'))
      IF (IHEAD.GT.0) GOTO 5
      WRITE(6,602)
  602 FORMAT(' ***** BANK HEAD MISSING *****')
C***  RESPONSE HAS TO BE DEVELOPPED
    5 INDEX = 2*IHEAD + 10
      HRUNEX = HDATA(INDEX)
      HEVENT = HDATA(INDEX+1)
C---  COMPARE RUN-NO. WITH RUN-NO. OF PREVIOUS EVENT
      IF (HRUNEX.EQ.HOLDRN) GOTO 6
C---  CALIBRATION FOR 1981 (OR LATER) - DATA  WILL BE CALLED
C        IN @ANALY81
      IF (HRUNEX.GT.6000) GOTO 11
C---  NEW LEAD-GLASS CALIBRATION AFTER RUN 1056
      IF (HOLDRN.LE.1056 .AND. HRUNEX.GT.1056) CALL GGFAC2
C---  NEW LEAD-GLASS CALIBRATION FROM RUN 2751 ONWARDS
C     (1980 DATA AFTER INSTALLATION OF FILTERS)
      IF (HOLDRN.LT.2751 .AND. HRUNEX.GE.2751) CALL GGFAC3
C---  CORRECTIONS FOR LEAD-GLASS-ADCS FROM RUN 2751 ONWARDS
C     (1980 DATA AFTER INSTALLATION OF FILTERS)
      IF (HOLDRN.LT.2751 .AND. HRUNEX.GE.2751) CALL GGFAC4
C---  NEW LEAD-GLASS CALIBRATION FROM RUN 4511 ONWARDS
C     (COPES WITH CHANGES OF EHTS BEGINNING OF AUGUST 1980)
      IF (HOLDRN.LT.4511 .AND. HRUNEX.GE.4511) CALL GGFAC5
C---  NEW LEAD-GLASS CALIBRATION FROM RUN 4993 ONWARDS
C     (COPES WITH CHANGES IN ELECTRONICS DURING 1980 SUMMER SHUT-DOWN)
      IF (HOLDRN.LT.4993 .AND. HRUNEX.GE.4993) CALL GGFAC6
C
   11 HOLDRN = HRUNEX
      HRUN = HRUNEX
C---  IF NEW RUN, NEW PEDESTAL CORRECTIONS NECESSARY
      INIT = 0
      IF (HRUN.LT.2700) CALL ANOMAL
C-OFF WRITE(6,605) HRUN
C 605 FORMAT(/' *** READY FOR RUN',I5,' ***')
C
C---  GET FLAG FOR LUMI- OR TAGG-EVENTS
C---      FOR 1979 - 1981 TRIGGER SCHEME
    6 IF (HRUN.LT.10000) CALL TAGFLG(IFLAG)
C---      FOR 1982 - .... TRIGGER SCHEME
      IF (HRUN.GT.10000) CALL TAGF82(IFLAG)
      IF (IFLAG.GT.0) HACC = 1
C---  TRANSFER DATA FROM 'LATC'
C---  FETCH LATC-POINTER
    9 IND = IDATA(IBLN('LATC'))
      IF (IND.GT.0) GOTO 1
C---  LATC IS MISSING
      WRITE(6,600)
  600 FORMAT(' ***** BANK LATC MISSING *****')
      IER = 4
      GOTO 50
C---  FETCH LATC-DATA
C---  FETCH TAGGING SYSTEM LATCHES
C***  STAND MAI 1979
    1 LAT(1) = IDATA(IND+13)
      LAT(2) = IDATA(IND+14)
      HLULAT = HLAT(3)
      HPBLAT = HLAT(4)
      HIL = HLULAT
C---  UNPACK LATCHES INFORMATION
        DO 10 I1 = 1,16
        I2 = I1 + 16
        HCOINC(I1) = JBIT(LAT(1),I1)
        HLUMON(I1) = JBIT(LAT(2),I2)
   10   HGGLAT(I1) = JBIT(LAT(2),I1)
C
C---  CORRECT INITIALIZATION OF LNG
   50 LNG = 2
C---  TRANSFER DATA FROM 'ATAG'
C---  FETCH ATAG-POINTER
      IND = IDATA(IBLN('ATAG'))
      IF (IND.GT.0) GOTO 51
C---  ATAG IS MISSING
C***  WRITE(6,601)
C*601 FORMAT(' ***** BANK ATAG MISSING *****')
      IER = IER + 2
C***  CALL BDLG
      RETURN
C---  FETCH ATAG-DATA
C---  LNG:  NUMBER OF ADC-DATA + 2
   51 NDATA = IDATA(IND)
      LNG = NDATA - 1
C---  CHECK WHETHER THERE IS ANY LG-INFORMATION AVAILABLE
      LADC = HDATA(2*IND+5) - HDATA(2*IND+3)
      IF (HACC.EQ.0 .AND. LADC.GE.1) HACC = 2
      IF (HACC.EQ.1 .AND. LADC.LT.1) HACC = -1
C
      IF (LNG.LE.242) GOTO 53
       ILERR=ILERR + 1
       IF(ILERR.GT.10)GOTO 522
      WRITE(6,6004)
6004  FORMAT('  ATAG BANK DUMPED BY INGAM1 BECAUSE ATAG LENGTH =',I10)
      CALL HPRS('ATAG',0)
522   CONTINUE
      RETURN 1
   53 CALL UCOPY(IDATA(IND+2),GGADC(1),LNG)
C
      IF (HRUN.GT.6000) GOTO 52
      ICOUNT = ICOUNT+1
      IF (LIMEVT.LT.ICOUNT) GOTO 52
      CALL BDLG
      RETURN
C
   52 INIT = INIT + 1
C---  SUBTRACT PEDESTALS
      IF (HRUN.LT.2700) CALL SUBNEW
      IF (HRUN.GT.2700 .AND. HRUN.LT.2872) CALL SUBOLD(INIT)
      IF (HRUN.GE.2872 .AND. HRUN.LT.6000) CALL CUTPED
      IF (HRUN.GE.6000) CALL CUTP81
C
C***  CALL BDLG
   54 RETURN
      END
      BLOCK DATA
      COMMON /CRUNCO/ I,IUN
      DATA IUN/3/
      END

C   14/08/80 008141209  MEMBER NAME  TOFBRA                 FORTRAN
      SUBROUTINE TOFBRA(NCN,LTRK,NFLG)
      INTEGER *2  HEADR(108)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      NRUN = HEADR(18)
      IF(NRUN.LT.1660) CALL TOFCL2(NCN,LTRK,NFLG)
      IF(NRUN.GE.1660) CALL TOFCLC(NCN,LTRK,NFLG)
      RETURN
      END

C   07/06/96 606071840  MEMBER NAME  CREAD    (S4)          FORTG1
      SUBROUTINE CREAD(IUN,IER)
C     BOS SUBPROGRAM =3.2=
      COMMON/BCS/IW(1)
      IER=0
   10 CALL BRDS(IUN,NBUFL,INIR)
      IF(INIR.EQ.0) GOTO 100
      CALL BFRD(IUN,IW(INIR),IW(INIR+1))
      IF(IW(INIR)) 20,30,10
   20 IER=IER+1
   30 IER=IER+1
  100 RETURN
      END

C   11/01/88 801172319  MEMBER NAME  TPUOPT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPUOPT( NAME, OPTION, ANSWER )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery       11/01/88:  Provide required option.
C
C
C
C     Routine to provide one option from the answers_table compiled
C     at the start of the program.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     NAME      In    Char*8      Name of option group
C     OPTION    In    Char*20     Name of option keyword
C     ANSWER    Out      L*4      TRUE if option keyword specified
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  ANSWER

      CHARACTER  NAME*8, OPTION*20

#include "tables.for"

C------------------  C O D E  ------------------------------------------

      DO  30  I = 1,NOG

        IF( NAME .EQ. NTABLE(I) ) THEN

          DO  10  J = 1,NOK

            IF( OPTION .EQ. OTABLE(J) ) THEN

              ANSWER = ATABLE(I,J)

C                            Record success in statistics area

              CALL TPSTAT

              RETURN

            ENDIF

  10      CONTINUE

          CALL TPERRH

        ENDIF

  30  CONTINUE

      CALL TPERRH

      RETURN

      END

      SUBROUTINE VTXINI 
C*800623*DITTMANN***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXINI)   18.9.86
C*                                                                 *
C* I N I T I A L I S A T I O N   O F   X Y Z   V E R T E X   F I T *
C*                                                                 *
C*       TO BE CALLED ONCE AND BEFORE FIRST CALL TO VTXPRE, VERTEX *
C*                                                                 *
C*    MODIFIED FOR VERTEX CHAMBER HARDWARE     860211 C.K.         *
C*       ADDITIONAL CONSTANTS ARE TAKEN FROM COMMON /CGEOV/        *
C*       JADEBD MUST BE DECLARED AS EXTERNAL                       *
C*                                                                 *
C*    MODES AND STATISTICS                        860527 C.K.      *
C*                                                                 *
C*******************************************************************
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV
     *               ,ITDLEN,IVDLEN       ! PMF 03/12/99
*** PMF 03/12/99: ITDLEN,IVDLEN needed for graphics ( commands VFIT, VX in JADEZ)
C
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
**** PMF 03/12/99: Tell graphics routines GVTXFT and VXDISP
*     the number of words for each track ( "ITDLEN" ) and for each
*     vertex ( "IVDLEN" ).
*     NB.: This communication via COMMON /CVTXC/ is NOT needed
*     for the functionality of the 'wertex' routines themselves
*     in which these parameters are fixed.
      ITDLEN = 40
      IVDLEN = 10
*** PMF(end)
C
C
C        RESET MODE AND CLEAR STATISTICS
      MODE = 0
      DO 10 I = 1, 120
         HVTXST(I) = 0
   10 CONTINUE
C
C        MEAN VERTEX COORDINATES
      XB = 0.
      YB = 0.
      ZB = 0.
C        OUTER RADIUS OF INNER TANK WALL
      RTANK = 174.
C        OUTER DISTANCE BEAM PIPE TO TANK WALL
      DTANK = 81.
C
C THE VARIABLES DTANK AND X0INN ARE UPDATED IN VTXPRE ACC. TO JADE
C STATUS, I.E. OLD OR NEW BEAMPIPE AND BP-COUNTERS OR VTX CHAMBER
C
C        RADIATION LENGTH BETWEEN BEAM AND FIRST WIRE
      X0INN = 0.1312
C        MEAN TRACK RESIDUAL IN XY AND ZR PLANE
      SIGX0 = 0.55
      SIGZ0 = 30.
C        ARTIFICIAL FACTOR TO ACCOUNT FOR SYSTEMATIC ERRORS
      SIGFAC = 1.0
      SIGX0 = SIGX0 * SIGFAC
      SIGZ0 = SIGZ0 * SIGFAC
C        MINIMUM NUMBER OF POINTS IN XY AND Z TRACK
      PNTMIN = 5.
C        MAXIMUM TRACK RESIDUAL IN XY AND Z (SIG<SIG1*SIGX0)
      SIG1 = 4.
C        MAXIMUM DISTANCE OF TRACKS TO AVERAGE BEAM
C        USED IN PRIMARY VERTEX SEARCH
      DISTB = 20.
C        MAXIMUM OPENING ANGLE OF COLLINEAR 2-PRONGS
      COLL2 = 0.99
C        MAXIMUM NUMBER OF ITERATIONS IN VERTEX FIT
      MITER = 12
C        CONVERGENCE PARAMETER
      DSCONV = 0.05
C        MINIMUM PROBABILITY FOR GOOD VERTEX
      PRCUT = 0.001
C        REJECT BAD TRACKS DURING VERTEX FIT (0=NO, 1=YES)
      IREJTR = 1
C        EE PAIRS: MINIMUM AND MAXIMUM MEASURED PHI DIFFERENCE (RADIAN)
      EEDPMN = -0.07
      EEDPMX =  0.8
C        EE PAIRS: MAXIMUM THETA DIFFERENCE (STD.DEV.)
      EEDTMX = 3.0
C        EE PAIRS: MAXIMUM DISTANCE WHERE TRACKS ARE PARALLEL (STD.DEV.)
      EEDRMX = 3.0
C        EE PAIRS: MAXIMUM POSITIVE XY DISTANCE, NO ST.DEV. CUT (MM)
      EEXYMN = 4.0
C        EE PAIRS: MAXIMUM XY DISTANCE WHERE TRACKS ARE PARALLEL (MM)
      EEXYMX = 20.
C        MAXIMUM TRACK EXTRAPOLATION AND INTRAPOLATION(ARC LENGTH)
      SEMAX = -300.
      SIMAX = 25.
C        MAXIMUM TRACK EXTRAPOLATION (PHI)
      PHEMAX = 1.0
C        MAXIMUM TRACK DISTANCE TO VERTEX DURING FIT (STD.DEV.)
      SIG2 = 2.
C        MAXIMUM TRACK DISTANCE TO VERTEX AFTER FIT (STD.DEV.)
      SIG3 = 4.
C        SEC. VERTICES: MINIMUM COS OF TRACK TO MAIN VERTEX (OR XB,YB)
      CSECV = -0.15
C
      RETURN
      END

C   08/08/85 508090428  MEMBER NAME  PROJVW   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PROJVW( JVIEW, LFLAG )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   8/08/85 :  DRAW ONE PROJECTION
C
C
C     PERFORMS EVENT, DETECTOR AND RESULTS DISPLAY FOR ONE PROJECTION
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  LFLAG
C
#include "cgraph.for"
C
C------------------  C O D E  ------------------------------------------
C
      NACMD = ACMD
      CALL SETSCL( JVIEW )
C
      IF( LFLAG ) CALL EVDISP(JVIEW)
      IF( NACMD .NE. 99  .AND.  LFLAG ) CALL JADISP(JVIEW)
C
C                            LAST COMMAND WAS VRES?
C                            IF SO, DO RESULTS DISPLAY WITH VERTICES
C
      IF( LSTCMD .NE. 52 ) GO TO 10
        CALL VXDISP(JVIEW)
        GO TO 13
C
C                            IF MUPT OR MUONS, DRAW MUON TRACKS,ETC
C                            S/R MULDSP CALLS XYMUD AND BOTH USE LASTVW
C
  10  IF( LSTCMD .NE. 105  .AND.  LSTCMD .NE. 106 ) GO TO 12
        LVIEW  = LASTVW
        LASTVW = JVIEW
        CALL MULDSP
        LASTVW = LVIEW
        GO TO 13
C
C                            IF CDTL 16 OR RES OR MUR2
C                            THEN CALL RESULTS DISPLAY
C
  12    IF( LSTCMD .EQ. 45  .OR.  LSTCMD .EQ. 55
     +                      .OR.  DSPDTL(16)     ) CALL RSDISP(JVIEW)
C
  13  RETURN
C
      END

      SUBROUTINE PATRC1(IDRENT)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C-------------------------------
C  MACRO CHEADR .... HEADER BANK
C-------------------------------
      COMMON /CHEADR/ IHEADR(54)
      INTEGER*2 HHEADR(108)
      EQUIVALENCE (IHEADR(1),HHEADR(1))
C --
C --  HHEADR(17) = EXPERIMENT NUMBER
C --  HHEADR(18) = RUN NUMBER
C --  HHEADR(19) = EVENT NUMBER
C --  HHEADR(38) = MAGNETIC FIELD (GAUSS)
C --
C--------- END OF MACRO CHEADR ------------
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C----------------------------------------------------------------------
C           MACRO CCYCP .... JET CHAMBER HIT POINTERS (PATREC)
C----------------------------------------------------------------------
      INTEGER*4 HPTSEC
      COMMON/CCYCP/HPTSEC(98)
C     HPTSEC(I) = CDATA POINTER TO 1ST I*2 WORD FOR 1ST HIT OF CELL I
C------------------------ END OF MACRO CCYCP --------------------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
     ,         , (ITR   ,IDWRK(7)),(ITRNG ,IDWRK(8))
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      COMMON /CLBPGM/ LBPGM(30)
      DIMENSION HEARR(30)
      DATA HPS /2HPS/
      DATA PATR /'PATR'/, LHEAD,LTRBK /8,48/
      DATA JHTL /'JHTL'/
      DATA JETC /'JETC'/
 2009 FORMAT('0CHANGE OF POINTERS:',10I8)
 2991 FORMAT('0/BCS/ TOO SHORT FOR TRACK BANK; EVENT:',3I6,
     ,       ', IRET=',I2,',NTR,LENGTH=',I3,1X,I4)
 2992 FORMAT('0/CWORK/ TOO SHORT FOR PATREC; EVENT:',3I6)
 2993 FORMAT('0/BCS/ TOO SHORT FOR PATREC; EVENT:',3I6,' ,IERR=',I2)
 2994 FORMAT('0WRONG POINTER IN JETC-BANK; EVENT:',3I6,' ,POINTER:',
     ,        (/,1X,24I5))
      NTR = 0
      IPJETC = IDATA(IBLN(JETC))
      IF(
     - IPJETC.LE.0
     -)THEN
        IPPATR = IDATA(IBLN(PATR))
      IF(
     - IPPATR.LE.0
     -)THEN
          NBNK = 10
          IZW = LHEAD
          CALL CCRE(IPPATR,PATR,NBNK,IZW,IERR)
          IF(IERR.NE.0) RETURN
          CALL BSAW(1,PATR)
          IDATA(IPPATR+1) = LHEAD
          IDATA(IPPATR+3) = LTRBK
      ENDIF
        RETURN
      ENDIF
      NHITJC = HDATA(IPJETC*2+99) / 4
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      HPFREE = 1
      HPLAST = LMPATR(5)
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      IF(
     - IERRFL.NE.0
     -)THEN
        I1 = IPJCA2 + 1
        I9 = I1 + 97
        WRITE(6,2994) HHEADR(17),HHEADR(18),HHEADR(19),
     ,                (HDATA(I),I=I1,I9)
        CALL BDLS(PATR,NBNK)
        CALL BDLS(JHTL,NBNK)
        RETURN
      ENDIF
      IF(
     - (HPFREE+NHITJC+96*12+10*17 - 1).LT.LMPATR(5)
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ELSE
        WRITE(6,2992) HHEADR(17),HHEADR(18),HHEADR(19)
        CALL BDLS(PATR,NBNK)
        CALL BDLS(JHTL,NBNK)
        RETURN
      ENDIF
      HPFRE0 = HPFREE
      HPRO = HPS
      ITR = 1
      IRINGO = 0
      JCELL=0
16000 CONTINUE
        JCELL = JCELL + 1
        HNTCEL(JCELL) = ITR
        MHIT = (HPTSEC(JCELL+1)-HPTSEC(JCELL)) / 4
      IF(
     - MHIT.GE.5
     -)THEN
          IRING = 3
          IF(JCELL.LE.48) IRING = 2
          IF(JCELL.LE.24) IRING = 1
      IF(
     - IRING.NE.IRINGO
     -)THEN
            IRINGO = IRING
            ITRNG = 1
      ENDIF
          ICELL = JCELL
          IERRCD = 0
          HPFREE = HPFRE0
          CALL SRTREL
      ENDIF
      IF(.NOT.(
     - JCELL.EQ.96
     -))GOTO 16000
16001 CONTINUE
      HNTCEL(97) = ITR
      HNTR = ITR - 1
      HPFREE = HPFRE0
      NTR = 0
      IF(HNTR.GT.0) CALL BACKTR(0,0)
      IF(
     - NTR.GT.0
     -)THEN
          LENGTR =(NTR+10)*LTRBK
          CALL BCHM(IPPATR,LENGTR,IRET)
      IF(
     - IRET.NE.0
     -)THEN
            WRITE(6,2991) HHEADR(17),HHEADR(18),HHEADR(19),
     ,                    IRET,NTR,LENGTR
            NTR = 0
            CALL BDLS(PATR,NBNK)
            CALL BDLS(JHTL,NBNK)
            RETURN
      ENDIF
          IPJETC = IDATA(IBLN(JETC))
          IP0 = IPJETC*2 + 101
      IF(
     - IP0.NE.HPTSEC(1)
     -)THEN
            PRINT 2009, IPJETC,IP0,HPTSEC(1)
      ASSIGN 17006 TO IZZZ02
      GOTO 17002
17006 CONTINUE
      ENDIF
      ENDIF
      RETURN
17000 CONTINUE
        IPJHTL = IDATA(IBLN(JHTL))
        IPPATR = IDATA(IBLN(PATR))
        NBKPAT = 10
        IF(IPPATR.GT.0) NBKPAT = IDATA(IPPATR-2) - 1
        NBKHTL = 10
        IF(IPJHTL.GT.0) NBKHTL = IDATA(IPJHTL-2) - 1
        NBNK = MIN0(10,NBKPAT,NBKHTL)
      IF(
     - IPJHTL.EQ.0 .OR. IDRENT.EQ.0
     -)THEN
          IZW = NHITJC + 1
          CALL CCRE(IPJHTL,JHTL,NBNK,IZW,IERR)
          LBRHTL = 0
          IF(IERR.NE.0) LBRHTL = 1
      ENDIF
      IF(
     - IPPATR.EQ.0 .OR. IDRENT.EQ.0
     -)THEN
          IZW = LHEAD
          CALL CCRE(IPPATR,PATR,NBNK,IZW,IERR)
      IF(
     - IERR.NE.0 .OR. LBRHTL.NE.0
     -)THEN
            WRITE(6,2993) HHEADR(17),HHEADR(18),HHEADR(19),IERR
            CALL BDLS(PATR,NBNK)
            CALL BDLS(JHTL,NBNK)
            RETURN
      ENDIF
          CALL BSAW(1,PATR)
          CALL BSAW(1,JHTL)
          IDATA(IPPATR+1) = LHEAD
          IDATA(IPPATR+2) = 0
          IDATA(IPPATR+3) = LTRBK
          IDATA(IPPATR+4) = IDATA(IPJHTL-2)
          IDATA(IPPATR+5) = NHITJC
          IDATA(IPPATR+6) = NHITJC
          IDATA(IPPATR+7) = NHITJC
          IDATA(IPPATR+8) = 0
      ELSE
          CALL CMVE(IPPATR,IERR)
      ENDIF
      GOTO IZZZ01
17002 CONTINUE
      IPJCA2 = IPJETC*2 + 2
      IP0 = IPJCA2 + 98
      IERRFL = 0
      IPCLL = IPJCA2
      DO 13000 ICLL=1,96
        IPCLL = IPCLL + 1
        HPTSEC(ICLL) = HDATA(IPCLL) + IP0
        IF(HDATA(IPCLL+1).LT.HDATA(IPCLL)) IERRFL = 1
13000 CONTINUE
13001 CONTINUE
      HPTSEC(97) = HDATA(IPCLL+1) + IP0
      HPTSEC(98) = 0
      GOTO IZZZ02
17004 CONTINUE
      HPHL0 = HPFREE*2 - 1
      HLDHL = NHITJC*2
      HPHL9 = HPHL0 + HLDHL - 1
      NBYTHT = HLDHL*2
      ZERO = 0
      CALL SETSL(HWRK(HPHL0),0,NBYTHT,ZERO)
      HPFREE = HPFREE + NHITJC
      GOTO IZZZ03
      END

C   08/12/80 211042028  MEMBER NAME  PATROL0  (PATRECSR)    FORTRAN
      SUBROUTINE PATROL(RMIN,RMAX)
      IMPLICIT INTEGER*2(H)
      LOGICAL TBIT
C
C
C----------------------------------------------------------------------
C       --------------  SUBROUTINE PATROL  -----------------
C       ---- G.F.PEARCE .. LAST UPDATE : 2020 ON  4/11/82 ----
C   SUBROUTINE TO SEARCH AND RECORD HITS MISSED BY THE PATTERN
C   RECOGNITION PROGRAMS. IF SUFFICIENT NEW HITS ARE FOUND A REFIT
C   OF THE TRACK IS MADE AND PATROL THEN RECALLS ITSELF.
C
C   TO SATISFY CERTAIN COMPLAINTS MANY VERBOSE COMMENTS HAVE BEEN
C   INTRODUCED. HOPEFULLY EVERYONE ELSE WILL DO THE SAME, BUT I DOUBT IT
C
C  CONTROLLING PATROL.
C  ===================
C                   CONTROL OF THE PARAMETERS AND LIMITS USED BY
C  THIS PROGRAM IS ACHIEVED THROUGH THE ARRAY GFP IN COMMON CPATLM.
C  FOR DETAILS SEE THE INITIALISING ROUTINE INPATR.
C
C  PATROL ERROR MESSAGES
C  =====================
C  PATROL ERROR 1 => PATROL CALLED FOR A TRACK WITH ILLEGAL FIT TYPE
C  PATROL ERROR 2 => NOT ENOUGH ROOM IN CWORK TO STORE ANY MORE HITS
C  PATROL ERROR 3 => ILLEGAL RETURN VALUE - THIS SHOULD NEVER HAPPEN
C  PATROL ERROR 4 => THERE WERE NO GOOD HITS ON THE TRACK WHEN PATROL
C                    WAS CALLED - PATROL IGNORES THIS TRACK.
C  PATROL ERROR 5 => A POINTER WAS -VE. PROBABLY HPTSEC OVERFLOWED
C  PATROL ERROR 6 => PATROL FOUND A HOLE BIGGER THAN THE TRACK. THIS
C                    IS ALMOST CERTAINLY A BACKTRACE ERROR RESULTING
C                    IN THE WRONG ORDERING OF TRACK ELEMENTS. (THEY
C                    SHOULD BE SUPPLIED BY BACKTR RADIALLY ORDERED)
C  PATROL ERROR 7 => OVERSIZE CORRECTION WHEN CONVERTING A PARABOLA TO
C                    A CIRCLE. THE PREVIOUS ITERATION IS USED AND
C                    PATROL CONTINUES.
C  PATROL ERROR 8 => TOO MANY REFITS CALLED BY PATROL. PATROL STOPS
C                    AND RETURNS THOSE HITS ALREADY FOUND.
C  PATROL ERROR 9 => FAILED TO CALCULATE DRIFT PATH DISPERSION
C                    CORRECTION. IT IS ASSUMED TO BE MAXIMUM.
C
C----------------------------------------------------------------------
C
      COMMON/CALIBR/JPOINT(100),
     1HMUCAL(8370),HLGMAI(5760),HTAGSY(384),HJPULS(9216),
     1DELTA0(96,2),DELTA1(96,2),DELTA2(96,2),DELTA5(96,2),DELTA6(96,2)
C
#include "cworkpr.for"
C
#include "cworkeq.for"
C
C=======EQUIVALENCES TO MACROS=======
      REAL*4 SL12(600,2)
      EQUIVALENCE (SL1(1),SL12(1,1))
      INTEGER*4 MINCL(3),MAXCL(3)
      EQUIVALENCE (MINCL(1),IBCK(4)) , (MAXCL(1),IBCK(1))
C====================================
C
#include "cdatamin.for"
C
#include "ccycp.for"
C
#include "cdsmax.for"
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     * RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,ZRESOL,ZNORM,ZAL,
     * ZSCAL,DRIDEV,DRICOS,DRISIN,PEDES,TZERO(3),
     * DRIROT(96,2),SINDRI(96,2),COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     * CAB(8)
C
#include "cpatlm.for"
C
      COMMON/CHEADR/HEAD(20)
C
C-------------------------------------------
C    EQUIVALENCE HIT BANK TO ADWRK
C-------------------------------------------
C
          EQUIVALENCE(ADWRK( 1),LAYERJ)
          EQUIVALENCE(ADWRK( 2),NH1)
          EQUIVALENCE(ADWRK( 3),NH)
          EQUIVALENCE(ADWRK( 4),XJETHT)
          EQUIVALENCE(ADWRK( 5),YJETHT)
          EQUIVALENCE(ADWRK( 6),ZJETHT)
          EQUIVALENCE(ADWRK( 7),RJETHT)
          EQUIVALENCE(ADWRK( 8),IERZRF)
          EQUIVALENCE(ADWRK( 9),LRTREL)
          EQUIVALENCE(ADWRK(10),INCELL)
          EQUIVALENCE(ADWRK(11),IERXYF)
          EQUIVALENCE(ADWRK(12),BETA)
          EQUIVALENCE(ADWRK(13),INRING)
          EQUIVALENCE(ADWRK(14),CHIXYF)
C
C-------------------------------------------
C         EQUIVALENCE TRACK BANK TO ADWRK
C-------------------------------------------
C
          EQUIVALENCE(ADWRK(21),XSTR)
          EQUIVALENCE(ADWRK(22),YSTR)
          EQUIVALENCE(ADWRK(23),RSTR)
          EQUIVALENCE(ADWRK(28),XEND)
          EQUIVALENCE(ADWRK(29),YEND)
          EQUIVALENCE(ADWRK(30),REND)
          EQUIVALENCE(ADWRK(34),IAMFIT)
          EQUIVALENCE(ADWRK(35),COEFF1,RAD)
          EQUIVALENCE(ADWRK(36),COEFF2,DMID)
          EQUIVALENCE(ADWRK(37),COEFF3,EPSILN)
          EQUIVALENCE(ADWRK(38),COEFF4)
          EQUIVALENCE(ADWRK(40),NPUSED)
          EQUIVALENCE(ADWRK(41),CURV)
C
C-------------------------------------------
C        EQUIVALENCES TO CWORK 'ZERO' ARRAY
C-------------------------------------------
C
          REAL*4 ZERO(100)
          EQUIVALENCE (ADWRK(41),ZERO(1))
          LOGICAL*1 CLFLAG(100)
          INTEGER*2 WIRMSK(96),RGFLAG(4)
          EQUIVALENCE (ZERO( 1),CLFLAG(1))
C         EQUIVALENCE (ZERO(25),CLFLAG(100))
          EQUIVALENCE (ZERO(26),WIRMSK(1))
C         EQUIVALENCE (ZERO(73),WIRMSK(96))
          EQUIVALENCE (ZERO(74),RGFLAG(1))
C         EQUIVALENCE (ZERO(75),RGFLAG(3))
          EQUIVALENCE (ZERO(76),JETCL)
          EQUIVALENCE (ZERO(77),NCELLS)
          EQUIVALENCE (ZERO(78),LAYTRY)
          EQUIVALENCE (ZERO(79),LAYINT)
          EQUIVALENCE (ZERO(80),LAYEXT)
C
C-------------------------------------------
C     EQUIVALENCES TO CWORK OF WORK ARRAY
C-------------------------------------------
C
          INTEGER*2 CELLPN(20,2),NWSET(20),WIRSET
C
C-------------------------------------------
C        DECLARATION OF 'MEMORY' VARIABLES
C-------------------------------------------
C
          REAL*4 PIE/3.14159/,TWOPIE/6.28318/
          INTEGER*4 BIT26/Z00000020/,BIT31N/ZFFFFFFFE/
          INTEGER*4 MSKLBL/Z000000FE/
          INTEGER*2 LAYBIT(16)/
     #    Z0001 , Z0002 , Z0004 , Z0008 ,
     #    Z0010 , Z0020 , Z0040 , Z0080 ,
     #    Z0100 , Z0200 , Z0400 , Z0800 ,
     #    Z1000 , Z2000 , Z4000 , Z8000 /
          INTEGER*2 LAYMSK(16,2) /
     #    ZFFFE , ZFFFC , ZFFF8 , ZFFF0 ,
     #    ZFFE0 , ZFFC0 , ZFF80 , ZFF00 ,
     #    ZFE00 , ZFC00 , ZF800 , ZF000 ,
     #    ZE000 , ZC000 , Z8000 , Z0000 ,
     #    Z0000 , Z0001 , Z0003 , Z0007 ,
     #    Z000F , Z001F , Z003F , Z007F ,
     #    Z00FF , Z01FF , Z03FF , Z07FF ,
     #    Z0FFF , Z1FFF , Z3FFF , Z7FFF /
          LOGICAL*1 PRINT
          NTRAK = HPWRK(30)
          NREFIT=0
C#######################################################################
      PRINT = .FALSE.
      IF(NTRAK.EQ.IGFP(20)) PRINT = .TRUE.
      IF(IGFP(20).LT.0.AND.NTRAK.GE.IABS(IGFP(20))) PRINT=.TRUE.
C#######################################################################
C==============================================
C==============================================
C         INITIALISATION
C==============================================
C==============================================
          KNTRL=IGFP(1)
 510      CONTINUE
C#######################################################################
          IF(PRINT)PRINT511,NTRAK,IGFP(1)
 511  FORMAT(1X,38('=')/' PATROL TRACK',I4,' GFP(1) = ',Z8/1X,38('='))
C#######################################################################
          ISTORY=IWRK(HPTR0+47)
          LNBYTE=HLDHT * 4
C==============================================
C==============================================
C         COMPUTE TRACK PARAMETERS
C==============================================
C==============================================
          IAMFIT=IWRK(HPTR0+17)
          IF(IAMFIT.EQ.1.OR.IAMFIT.EQ.2)GOTO520
C ----- ERROR 1 ILLEGAL FIT TYPE
          CALLERRORM('PATROL  ',1,NTRAK)
          GOTO7000
 520      CURV=WRK(HPTR0+24)
C#######################################################################
      IF(PRINT.AND.ABS(CURV).GE.GFP(14)) PRINT521,CURV
 521  FORMAT(' PATROL ABANDONED .. CURVATURE TOO HIGH ',E11.4)
C#######################################################################
          IF(ABS(CURV).GE.GFP(14))GOTO7000
          COEFF1=WRK(HPTR0+18)
          COEFF2=WRK(HPTR0+19)
          COEFF3=WRK(HPTR0+20)
          COEFF4=WRK(HPTR0+21)
          XSTR=WRK(HPTR0+4)
          YSTR=WRK(HPTR0+5)
          RSTR=WRK(HPTR0+6)-5.
          XEND=WRK(HPTR0+11)
          YEND=WRK(HPTR0+12)
          REND=WRK(HPTR0+13)+5.
          TRLEN2=(XSTR-XEND)**2+(YSTR-YEND)**2
          GOTO(910,920),IAMFIT
C
C         --------------------
C         TYPE 1 .. CIRCLE FIT
C         --------------------
C
 910      RAD=1./RAD
          DMID=DMID+RAD
          DMIDSQ=DMID**2
          XMID=DMID*COS(EPSILN)
          YMID=DMID*SIN(EPSILN)
          GOTO990
C
C         -----------------------
C         TYPE 2 .. PARABOLA FIT
C         -----------------------
C
 920      S1=SIN(COEFF1)
          S2=COS(COEFF1)
          RAD=1./(2*COEFF4)
          XMID=COEFF2-RAD*S1
          YMID=COEFF3+RAD*S2
C         CORRECT INSCRIBED CIRCLE
          IF(ABS(RAD).GE.30000)GOTO931
          IS3=0
 930      IS3=IS3+1
          S4=(XSTR-XMID)**2+(YSTR-YMID)**2-RAD**2
          S4=8*S4/TRLEN2
          S5=S4*RAD
          IF(ABS(S4).LE.0.4)GOTO933
C ----- ERROR 7 OVERSIZE CIRCLE CORRECTION
          IF(PRINT)CALLERRORM('PATROL  ',7,NTRAK)
          GOTO931
 933      RAD=RAD+S5
          XMID=XMID-S5*S1
          YMID=YMID+S5*S2
C#######################################################################
      IF(PRINT) PRINT981,RAD,XMID,YMID,S4
 981  FORMAT(' CIRCLE CORRECTION..RAD/X0/Y0 =',3E11.4,' CORRN =',F7.3)
C#######################################################################
          IF(S4.GT.GFP(15).AND.IS3.LT.5)GOTO930
 931      EPSILN=ATAN2(YMID,XMID)
          DMIDSQ=XMID**2 + YMID**2
          DMID=SQRT(DMIDSQ)
C
C         --------------------------
C         CLEAN UP CIRCLE PARAMETERS
C         --------------------------
C
 990      RAD=ABS(RAD)
          RADSQ=RAD**2
          RAD2=RAD*2
C
C==============================================
C==============================================
C         CALCULATE RESIDUAL CUTS
C==============================================
C==============================================
C
          NPUSED=IWRK(HPTR0+23)
          S1=10*NPUSED*ABS(CURV)
          IF(S1.GT.1.0)S1=1.0
          CODE0=GFP(4)+S1*GFP(5)
          CODE2=GFP(3)
C#######################################################################
      IF(PRINT) PRINT991,NPUSED,CODE0,CODE2,RSTR,REND
 991  FORMAT(' PATROL CUTS..NPUSED =',I4,' CODE0/CODE2 =',2F4.1/
     #       '           RSTR/REND =',2E11.4)
C#######################################################################
C
C==============================================
C==============================================
C         FLAG HITS ALREADY ATTACHED TO TRACK
C==============================================
C==============================================
C
          CALLSETSL(ZERO(1),0,320,0.)
          LAYSNT=0
          INCELL=0
          JETWR=-1
          IPHT=HPHT9-HLDHT+1
 1010     IF(IWRK(IPHT+10).EQ.0)GOTO1030
 1020     IPHT=IPHT-HLDHT
          IF(IPHT.LT.HPHT0)GOTO1060
          GOTO1010
 1030     JNCELL=IWRK(IPHT+9)
          IF(JNCELL.NE.INCELL)GOTO1050
C
C         ----------------------
C         NEW LAYER --- OLD CELL
C         ----------------------
C
 1040     IS1=IS1+1
          LAYSNT=LAYSNT+1
          LAYER=IWRK(IPHT)+1
          WIRSET=hLOR(WIRSET,LAYBIT(LAYER)) ! PMF 10/06/99: hlor (N.B.: WIRSET,LAYBIT= I*2)
          IPHST=IPHT
          GOTO1020
 1050     IF(INCELL.EQ.0)GOTO1070
C
C         --------------------------------
C         CELL COMPLETED -- LOAD END FLAGS
C         --------------------------------
C
 1060     CELLPN(NC,2)=IPHST
          WIRMSK(INCELL)=WIRSET
          NWSET(NC)=IS1
          IF(IPHT.LT.HPHT0)GOTO1110
C
C         ----------------------------
C         NEW CELL -- INITIALISE FLAGS
C         ----------------------------
C
 1070     INCELL=JNCELL
          INRING=IWRK(IPHT+12)
          RGFLAG(INRING)=INRING + 1
          WIRSET=WIRMSK(INCELL)
          IF(CLFLAG(INCELL))GOTO1080
          NCELLS=NCELLS+1
          NC=NCELLS
          IS1=0
          CLFLAG(INCELL)=.TRUE.
          CELLPN(NC,1)=IPHT
          GOTO1040
C
C         -----------------------------
C         OLD CELL AGAIN -- RESET FLAGS
C         -----------------------------
C
 1080     DO 1090 NC=1,NCELLS
          JNCELL=CELLPN(NC,1)
          JNCELL=IWRK(JNCELL+9)
          IF(JNCELL.EQ.INCELL)GOTO1100
 1090     CONTINUE
 1100     IS1=NWSET(NC)
          GOTO1040
 1110     IF(LAYSNT.GE.4)GOTO1120
C ----- ERROR 4 NO GOOD HITS FROM FIT !!!
          CALLERRORM('PATROL  ',4,NTRAK)
          GOTO7000
 1120     IF(TBIT(KNTRL,30))GOTO3000
C
C==============================================
C==============================================
C         LOOK FOR NEW HITS IN CELLS WITH HITS
C==============================================
C==============================================
C
          DO 2200 NC=1,NCELLS
          IRETRN=1
          IPHT=CELLPN(NC,1)
          INCELL=IWRK(IPHT+9)
          INRING=IWRK(IPHT+12)
C
C         -----------------------
C         CHECK FOR UNUSED LAYERS
C         -----------------------
C
          IS1=NWSET(NC)
C#######################################################################
          NH0 = HPTSEC(INCELL)
          NH9 = HPTSEC(INCELL+1) - 1
          IS2 = ISHFTR(NH9-NH0,2) + 1
      IF (PRINT) PRINT2011,INCELL,WIRMSK(INCELL),IS1,IS2
 2011 FORMAT(' SEARCH OLD CELL',I3,' MASK = Z',Z4,' WIRES GOT =',I3,
     #' HITS AVAILABLE =',I4)
C#######################################################################
          IF(IS1.EQ.16)GOTO2100
C         NH0=FIRST HIT, NH9 = LAST HIT
          NH0=HPTSEC(INCELL)
          NH9=HPTSEC(INCELL+1)-4
          IF(NH0.GT.0)GOTO2010
C ----- ERROR 5 POINTER -VE .. SUSPECT HPTSEC OVERFLOW
          CALLERRORM('PATROL  ',5,NTRAK)
          GOTO2100
 2010     IS2=ISHFTR(NH9-NH0,2)+1
          IF(IS2.LE.IS1)GOTO2100
C
C         -----------------------
C         CHECK ALL UNUSED LAYERS
C         -----------------------
C
C         SET IPHST TO LOWEST R HIT (HIGH IPHT)
CCCC      IPHST=IPHT
          IPHST=HPHT9 - HLDHT + 1
          WIRSET=WIRMSK(INCELL)
          DO 2020 NH1=NH0,NH9,4
          INWIRE=HDATA(NH1)
          INWIRE=ISHFTR(INWIRE,3)
          LAYER=LAND(INWIRE,15)+1
          MAND=hLAND(WIRSET,LAYBIT(LAYER)) ! PMF 28/06/99: hland (N.B.: WIRSET,LAYBIT= I*2)
          IF(MAND.NE.0)GOTO2020
          GOTO8000
 2020     CONTINUE
          WIRMSK(INCELL)=WIRSET
C
C==============================================
C==============================================
C  LOOK FOR NEW HITS IN CELLS ADJACENT TO CELLS
C  ALREADY CONTAINING HITS ON THE TRACK
C  IEND = 1 => LOW R.   IEND = 2 => HIGH R.
C==============================================
C==============================================
C
 2100     IRETRN=2
          JNCELL = INCELL
          DO 2195 IEND=1,2
C
C         --------------------------
C         REJECT WALL CROSSING IF NO
C         LAYERS IN THE ADJACENT CELL
C         COULD HAVE BEEN HIT.
C         --------------------------
C
          IPHT=CELLPN(NC,IEND)
          LAYER=IWRK(IPHT) + 1
          NLMIDO=IWRK(IPHT+8)
          LRINDX=1
          IF(NLMIDO.GT.0)LRINDX=2
          NWLIM=HMCH(LAYER,INRING,LRINDX)+1
C######################################################################
      INCELL = JNCELL + ISIGN(1,NLMIDO)
      IF(INCELL.GT.MAXCL(INRING)) INCELL=MINCL(INRING)
      IF(INCELL.LT.MINCL(INRING)) INCELL= MAXCL(INRING)
      IF (PRINT) PRINT2111,IEND,INCELL,LAYER,NLMIDO,NWLIM
 2111 FORMAT('        END',I2,' = CELL',I3,' LAYER',I3,' NLMIDO =',I5,
     #' NWLIM =',I3)
C######################################################################
          IF(NWLIM.LT.1.OR.NWLIM.GT.16)GOTO2195
C
C         ------------------------------------------
C         HAS THE ADJACENT CELL ALREADY BEEN CHECKED
C         ------------------------------------------
C
          INCELL=JNCELL+ISIGN(1,NLMIDO)
          IF(INCELL.GT.MAXCL(INRING))INCELL=MINCL(INRING)
          IF(INCELL.LT.MINCL(INRING))INCELL=MAXCL(INRING)
C######################################################################
      IF (PRINT.AND.CLFLAG(INCELL)) PRINT2121,INCELL
 2121 FORMAT('          CELL',I3,'  ALREADY CHECKED')
C######################################################################
          IF (CLFLAG(INCELL)) GOTO2195
C
C         -----------------------------------
C         ARE THERE ANY HITS IN THIS NEW CELL
C         -----------------------------------
C
          NH0 = HPTSEC(INCELL)
          NH9 = HPTSEC(INCELL+1) - 4
          IF (NH0.GT.0) GOTO2130
          CALLERRORM('PATROL  ',5,NTRAK)
          GOTO2195
 2130     CONTINUE
C######################################################################
      IF (PRINT.AND.(NH9.LT.NH0)) PRINT2122,INCELL,NH0,NH9
 2122 FORMAT('          CELL',I3,' HAS NO HITS',2I10)
C######################################################################
          IF(NH9.LT.NH0)GOTO2195
C
C         -------------------------------
C         REJECT CELL IF END HIT TOO FAR
C         FROM CELL BOUNDARY IN DRIFT SPACE
C         --------------------------------
C
          NLMIDO=IABS(NLMIDO)
          IF(NLMIDO.GT.199)GOTO2180
          DRIFT=HDATA(IWRK(IPHT+1)+3)
          IF(LAYER.GE.9)GOTO2140
          DRIFT=DRIFT*TIMDEL(1,INRING)
          GOTO2150
 2140     DRIFT=DRIFT*TIMDEL(2,INRING)
 2150     S2=SL12(NLMIDO,IEND)
          IS1=LAYER
          IF(IEND.EQ.2)GOTO2160
          S2=-S2
          IF (IS1.NE.1)IS1=IS1-1
          GOTO2170
 2160     IF(IS1.NE.16)IS1=IS1+1
 2170     DRIFT=ABS(DRIFT+S2)
          S2=DSMAX(IS1,INRING,LRINDX)*GFP(11)
C######################################################################
      IF (PRINT.AND.(DRIFT.LT.S2)) PRINT2171,INCELL,DRIFT,S2
 2171 FORMAT('          CELL',I3,' OUTSIDE DSMAX ',2F6.1)
C######################################################################
          IF(DRIFT.LT.S2)GOTO2195
C
C         ---------------------------------
C         MASK OUT DISALLOWED HITS AND
C         CHECK FIT RESIDUAL ON ALLOWED HITS
C         ---------------------------------
C
C         SET START POINTER TO LOWEST R HIT (HIGH IPHT)
 2180     IPHST=HPHT9-HLDHT+1
          WIRSET=WIRMSK(INCELL)
          WIRSET=hLOR(WIRSET,LAYMSK(NWLIM,IEND)) ! PMF 10/06/99: hlor (N.B.: WIRSET,LAYMSK= I*2)
C######################################################################
      IF (PRINT) PRINT2181,WIRMSK(INCELL),LAYMSK(NWLIM,IEND)
 2181 FORMAT('        SEARCH WITH WIRE MASK =Z',Z4,' AND Z',Z4)
C######################################################################
          NH1=NH0
 2185     INWIRE=HDATA(NH1)
          INWIRE=ISHFTR(INWIRE,3)
          LAYER=LAND(INWIRE,15)+1
          MAND=hLAND(WIRSET,LAYBIT(LAYER)) ! PMF 28/06/99: hland (N.B.: WIRSET,LAYBIT= I*2)
          IF(MAND.NE.0)GOTO2190
          GOTO8000
 2190     NH1=NH1+4
          IF(NH1.LE.NH9)GOTO2185
          WIRMSK(INCELL)=WIRSET
 2195     CONTINUE
 2200     CONTINUE
C
C==============================================
C==============================================
C         LOOK FOR NEW HITS IN MISSING RINGS
C==============================================
C==============================================
C
C
C--------------------------------
C  STEP 1. DETERMINE MISSING RING
C--------------------------------
C
 3000     NRMISS=RGFLAG(1)+RGFLAG(2)+RGFLAG(3)-1
C
C         -------------------------
C         IS THERE A MISSING RING ?
C         -------------------------
C
          IF(NRMISS.GE.7)GOTO4000
          IF (TBIT(KNTRL,28).AND.NRMISS.NE.5)GOTO4000
C         REQUIRED TO AVOID RUTHERFORD 0C4
          LAYLST=0
          IPHST=HPHT9-HLDHT+1
          GOTO(3110,3120,3130,3140,3150,3160),NRMISS
C         BOTH RINGS 2 AND 3 MISSING
 3110     INRING=2
          GOTO3200
C         BOTH RINGS 1 AND 3 MISSING
 3120     INRING=1
          GOTO3200
C         BOTH RINGS 1 AND 2 MISSING
 3130     INRING=2
          GOTO3200
C         ONLY RING 3 MISSING
 3140     INRING=3
          GOTO3200
C         ONLY RING 2 MISSING
 3150     INRING=2
          GOTO3200
C         ONLY RING 1 MISSING
 3160     INRING=1
C
C-----------------------------------------------
C  STEP 2.  DETERMINE CELLS INTERSECTED BY TRACK
C-----------------------------------------------
C
 3200     IRETRN=3
          S1=FSENSW(INRING)
          S2=S1+15*RINCR(INRING)
          IF(.NOT.TBIT(NRMISS,30))GOTO3240
          S1=S2
          S2=FSENSW(INRING)
C
C         ---------------------------------
C         COMPUTE RING INTERSECTION AZIMUTH
C         FOR ENTRY AND EXIT RADII
C         ---------------------------------
C
 3240     S1=(S1**2+DMIDSQ-RADSQ)/(2*S1*DMID)
          S2=(S2**2+DMIDSQ-RADSQ)/(2*S2*DMID)
C#######################################################################
      IF (ABS(S1).LE.1.0.OR.ABS(S2).LE.1.0) GOTO3245
      IF (PRINT) PRINT3241,INRING
 3241 FORMAT(' RING',I2,' NOT REACHED BY TRACK')
 3245  CONTINUE
C#######################################################################
          IF(ABS(S1).LE.1.0)GOTO3250
          IF(ABS(S2).GT.1.0)GOTO4000
          S1=SIGN(1.0,S1)
          GOTO3260
 3250     IF(ABS(S2).GT.1.0)S2=SIGN(1.0,S2)
 3260     S1=ARCOS(S1)
          S2=ARCOS(S2)
C
C         ------------------------
C         HAVE TWO SOLNS OF COURSE
C         DECIDE ON CORRECT ONE.
C         ------------------------
C
          S3=EPSILN-S1
          S1=EPSILN+S1
          S5=ATAN2(YSTR,XSTR)
          S4=ABS(S1-S5)
          IF(S4.GT.PIE)S4=TWOPIE-S4
          S5=ABS(S3-S5)
          IF(S5.GT.PIE)S5=TWOPIE-S5
          IF(S5.LT.S4)GOTO3270
          S2=EPSILN+S2
          GOTO3280
 3270     S1=S3
          S2=EPSILN-S2
 3280     IF(S1.LT.0.)S1=S1+TWOPIE
          IF(S2.LT.0.)S2=S2+TWOPIE
C
C         ---------------------------------
C         COMPUTE CELL RANGE TO BE SEARCHED
C         ---------------------------------
C
          S3=0.2618
          IF(INRING.EQ.3)S3=0.1309
          INCELL=S1/S3
          INCEL2=S2/S3
          INC=ISIGN(1,INCEL2-INCELL)
          IS1=MINCL(INRING)
          IS2=MAXCL(INRING)
          INCELL=IS1+INCELL
          INCEL2=IS1+INCEL2
          IF(INCELL.EQ.IS1.AND.INCEL2.EQ.IS2)INC=-1
          IF(INCELL.EQ.IS2.AND.INCEL2.EQ.IS1)INC=+1
C#######################################################################
      IF (PRINT) PRINT3296,INRING,INCELL,INCEL2,INC,NRMISS
 3296 FORMAT(' SEARCH RING',I2,' CELLS',I3,' TO',I3,' INC/NRMISS =',2I2)
C######################################################################
C
C-----------------------------------
C  STEP 3. LOOP OVER SELECTED CELLS
C-----------------------------------
C
          WIRSET=WIRMSK(INCELL)
C
C         ---------------------------------
C         GET POINTERS TO HITS IN THIS CELL
C         NH0 = FIRST HIT , NH9 = LAST HIT
C         ---------------------------------
C
 3410     NH0=HPTSEC(INCELL)
          NH9=HPTSEC(INCELL+1)-4
C######################################################################
      IF (PRINT.AND.(NH9.LT.NH0)) PRINT3411,INRING,INCELL,NH0,NH9
 3411 FORMAT(' RING',I2,' CELL',I3,' HAS NO HITS',2I10)
C######################################################################
          IF(NH0.GT.0)GOTO3420
          CALLERRORM('PATROL  ',5,NTRAK)
          GOTO3500
 3420     IF(NH9.LT.NH0)GOTO3500
          INCNH1=4
          IF(.NOT.TBIT(NRMISS,30))GOTO3430
          IS1=NH0
          NH0=NH9
          NH9=IS1
          INCNH1=-4
C
C         ---------------------------------
C         LOOP OVER ALL HITS IN CELL INCELL
C         ---------------------------------
C
 3430     NH1=NH0
          LAYLST=0
          LAYTRY=0
C######################################################################
      IF (PRINT) PRINT3431,INCELL,WIRSET
 3431 FORMAT('            CELL',I3,' SET MASK =Z',Z4)
C######################################################################
 3440     INWIRE=HDATA(NH1)
          INWIRE=ISHFTR(INWIRE,3)
          LAYER=LAND(INWIRE,15)+1
          MAND=hLAND(WIRSET,LAYBIT(LAYER)) ! PMF 28/06/99: hland (N.B.: WIRSET,LAYBIT= I*2)
          IF(MAND.NE.0)GOTO3480
          GOTO8000
C         GOOD HIT
 3450     LAYLST=LAYER
          GOTO3480
C         BAD HIT
 3470     IF(NRMISS.NE.5.AND.LAYTRY.GE.IGFP(6))GOTO3510
 3480     IF(NH1.EQ.NH9)GOTO3490
          NH1=NH1+INCNH1
          GOTO3440
C
C         --------------
C         GOTO NEXT CELL
C         --------------
C
 3490     WIRMSK(INCELL)=WIRSET
 3500     IF(INCELL.EQ.INCEL2)GOTO3520
          INCELL=INCELL+INC
          IF(INCELL.GT.MAXCL(INRING))INCELL=MINCL(INRING)
          IF(INCELL.LT.MINCL(INRING))INCELL=MAXCL(INRING)
C         SET MINIMUM LAYER FOR NEW CELL
          WIRSET=WIRMSK(INCELL)
          IF(LAYLST.EQ.0)GOTO3410
          IS1=1
          IF(INC.GT.0)IS1=2
          NWLIM=HMCH(LAYLST,INRING,IS1)+1
          IS2=2
          IF(NH9.LT.NH0)IS2=1
          WIRSET=hLOR(WIRSET,LAYMSK(NWLIM,IS2)) ! PMF 10/06/99: hlor (N.B.: WIRSET,LAYMSK= I*2)
C######################################################################
      IF(PRINT)PRINT3501,INCELL,LAYMSK(NWLIM,IS2),WIRSET
 3501 FORMAT('     "OR" NEXT CELL',I3,' MASK WITH Z',Z4,' GIVING Z',Z4)
C######################################################################
          GOTO3410
C
C         -------------------------
C         END OF LOOP OVER NEW RING
C         -------------------------
C
 3510     WIRMSK(INCELL)=WIRSET
 3520     CONTINUE
C
C==============================================
C==============================================
C         END OF PATROL HIT SEARCH
C==============================================
C==============================================
C
 4000     CONTINUE
C######################################################################
      IF (PRINT) PRINT4001,LAYINT,LAYEXT
 4001 FORMAT(' HIT SEARCH OVER. FOUND INTERP. =',I3,' EXTRAP. =',I3)
      IF(PRINT)CALLPCWORK(0,0,0,1,0)
C######################################################################
C
C         -----------------------------------------
C         LOOK FOR UNWANTED HITS FROM EXTRAPOLATION
C         -----------------------------------------
C
          IPHT=HPHT0
          S4=REND
 4010     S1=0.
          IS2=0
          IS3=IPHT
 4020     IF(IWRK(IPHT+10).NE.0)GOTO4040
          RJETHT=WRK(IPHT+6)
          IF(S1.EQ.0.)GOTO4030
          IF(ABS(RJETHT-S1).GT.GFP(8))GOTO4050
 4030     S1=RJETHT
          IS2=IS2+1
          IF(HLDHT*(RJETHT-S4).LT.0.)GOTO4060
 4040     IPHT=IPHT+HLDHT
          GOTO4020
C         DEMAND IGFP(9) CONSEC HITS
 4050     IF(IS2.LT.IGFP(9))GOTO4055
C         DONT ALLOW BIG HOLES
          IS5=IPHT
 4051     IS5=IS5-HLDHT
          IF(IS5.GE.HPHT0.AND.IS5.LT.HPHT9)GOTO4052
C ----- ERROR 6 PATROL FINDS HOLE BIGGER THAN TRACK. PROBABLE CAUSE
C ----- ERROR 6 IS A BACKTRACE ERROR IN TRACK ELEMENT ORDERING
          CALLERRORM('PATROL  ',6,NTRAK)
          IF(HLDHT.LT.0)HLDHT=-HLDHT
          CALLPCWORK(0,0,0,1,0)
          GOTO7000
 4052     IF(IWRK(IS5+10).NE.0)GOTO4051
          S2=(WRK(IPHT+3)-WRK(IS5+3))**2+(WRK(IPHT+4)-WRK(IS5+4))**2
          S2=SQRT(S2)-GFP(7)
          IF(IWRK(IS5+12).NE.IWRK(IPHT+12))S2=S2-GFP(12)
          IF(S2.LE.0.0)GOTO4056
 4055     IS3=IPHT
 4056     IS2=0
          GOTO4030
C         TRUE PATROL END POINT FOUND
C         MASK OUT UNWANTED HITS
 4060     IF(HLDHT.LT.0)GOTO4090
          IPHT=IS3
 4070     IPHT=IPHT-HLDHT
          IF(IPHT.LT.HPHT0)GOTO4080
C######################################################################
      IF (PRINT) PRINT4071,IPHT,IWRK(IPHT+9),IWRK(IPHT),IWRK(IPHT+8)
     # ,IWRK(IPHT+10)
 4071 FORMAT(' DELETE HIT..IPHT',I5,' CELL',I3,' LAYER',I3,' LRTREL',I5
     #,' IERXYF',I3)
C######################################################################
          IF(IWRK(IPHT+10).NE.0)GOTO4070
          IF(WRK(IPHT+6).GT.REND)LAYEXT=LAYEXT-1
          IWRK(IPHT+10)=2
          GOTO4070
 4080     IPHT=HPHT9-HLDHT+1
          HLDHT=-HLDHT
          S4=RSTR
          GOTO4010
 4090     CONTINUE
          IPHT=IS3
 4091     IPHT=IPHT-HLDHT
          IF(IPHT.GT.HPHT9)GOTO4100
          IF(IWRK(IPHT+10).NE.0)GOTO4091
          IF(WRK(IPHT+6).LT.RSTR)LAYEXT=LAYEXT-1
          IWRK(IPHT+10)=2
C######################################################################
      IF (PRINT) PRINT4071,IPHT,IWRK(IPHT+9),IWRK(IPHT),IWRK(IPHT+8)
     # ,IWRK(IPHT+10)
C######################################################################
          GOTO4091
 4100     HLDHT=-HLDHT
C######################################################################
      IF (PRINT) PRINT4101,LAYINT,LAYEXT
 4101 FORMAT(' END OF DELETE.   FOUND INTERP. =',I3,' EXTRAP. =',I3)
      IF (PRINT) CALLPCWORK(0,0,0,1,0)
C######################################################################
C
C         -------------------------------------
C         CALL REFIT WITH NEW HITS IF NECESSARY
C         -------------------------------------
C
 5000     IF(TBIT(KNTRL,31))GOTO7000
C         REFIT IF HAVE MANY MORE HITS
          IF(LAYINT.GE.IGFP(10))GOTO5010
          IF(LAYEXT.GT.0)GOTO5010
          GOTO7000
 5010     NREFIT=NREFIT+1
          IF(NREFIT.LE.IGFP(13))GOTO5015
C ----- ERROR 8 PATROL HAS CALLED TOO MANY REFITS .. END PATROL
                   CALLERRORM('PATROL  ',8,NTRAK)
          GOTO7000
 5015     IXYF1=IXYF(1)
          IXYF(1)=1
C######################################################################
      IF (PRINT) PRINT5011
 5011 FORMAT(' CALL XYFIT ')
C######################################################################
          RSTRSV=RSTR+5.
          RENDSV=REND-5.
          CALLXYFIT
          IXYF(1)=IXYF1
C         REPEAT PATROL IF FIT WAS GOOD
          IF(WRK(HPTR0+22).LE.GFP(2))GOTO510
C
C         ----------------------------------
C         REFIT WAS BAD. MASK OUT PATROLLED
C         HITS AND REINSTATE ORIGINAL FIT
C         ----------------------------------
C
          IWRK(HPTR0+47)=LOR (IWRK(HPTR0+47),BIT26)
          IWRK(HPTR0+47)=LAND(IWRK(HPTR0+47),BIT31N)
          IPHT=HPHT0+10
 5020     IF(IWRK(IPHT).EQ.1)IWRK(IPHT)=0
          IF(IABS(IWRK(IPHT-2)).LT.1000)GOTO5021
          RJETHT=WRK(IPHT-4)
          IF(RJETHT.GE.RSTRSV.AND.RJETHT.LE.RENDSV)GOTO5021
          IWRK(IPHT)=2
 5021     IPHT=IPHT+HLDHT
          IF(IPHT.LT.HPHT9)GOTO5020
C######################################################################
      IF (PRINT) PRINT4201
 4201 FORMAT(' PATROL RE-FIT WAS BAD. DELETE PATROLLED HITS AND REFIT')
C######################################################################
          IXYF1=IXYF(1)
          IXYF(1)=1
          CALLXYFIT
          IXYF(1)=IXYF1
C
C         ----------------------
C         FINAL EXIT FROM PATROL
C         ----------------------
C
 7000     IWRK(HPTR0+47)=ISTORY
C######################################################################
      IF (PRINT) PRINT4801,LAYINT
 4801 FORMAT(1X,10('#'),' EXIT PATROL. LAYINT =',I3)
C#######################################################################
          RETURN
C
C==============================================
C==============================================
C         CALCULATE RESIDUAL OF TEST HIT AND
C         LOAD INTO HIT ARRAY IF ACCEPTABLE
C==============================================
C==============================================
C
C         -------------------------
C         COMPUTE HIT LABEL POINTER
C         IS1=0 => HIT NOT ON TREL
C         -------------------------
C
 8000     IF(NH1.GT.0)GOTO8001
          CALLERRORM('PATROL  ',5,NTRAK)
          GOTO8750
 8001     NH=ISHFTR((NH1-HPTSEC(1)),1)+HPHL0
          IS1=HWRK(NH)
          IS1=LAND(IS1,MSKLBL)
          IF(IS1.EQ.0)GOTO8010
          IF(TBIT(KNTRL,29))GOTO8750
          GOTO8020
 8010     IF(TBIT(KNTRL,25))GOTO8750
 8020     CONTINUE
C
C         ----------------------------------
C         SET UP CELL AND LAYER CONSTANTS.
C         SKIP IF SAME WIRE ETC AS LAST TIME
C         ----------------------------------
C
          IF(INWIRE.EQ.JETWR)GOTO8120
          JETWR=INWIRE
C         NEW LAYER BEING TRIED .. INCREMENT LAYTRY
          LAYTRY=LAYTRY+1
          IF(INCELL.EQ.JETCL)GOTO8100
          JETCL=INCELL
          TRLORX=TRMATS(INCELL,1)
          TRLORY=TRMATC(INCELL,1)
          SINLOR=SINDRI(INCELL,1)
          COSLOR=COSDRI(INCELL,1)
          DRFVEL=DRIVEL(INCELL,1)
          DEL11=DELTA1(INCELL,1)
          DEL12=DELTA1(INCELL,2)
          DEL21=DELTA2(INCELL,1)
          DEL22=DELTA2(INCELL,2)
          RSENSW=FSENSW(INRING)
          DR0=RINCR(INRING)
          IS1=INCELL-24*(INRING-1)
          IF(INRING.EQ.3)GOTO8030
          DXWR=DIRWR1(IS1,1)
          DYWR=DIRWR1(IS1,2)
          GOTO8040
 8030     DXWR=DIRWR3(IS1,1)
          DYWR=DIRWR3(IS1,2)
 8040     SWDEPX=SWDEPL*DXWR
          SWDEPY=SWDEPL*DYWR
C
C         ------------------------------
C         COMPUTE (X,Y,R) OF SIGNAL WIRE
C         ------------------------------
C
 8100     LAYERJ=LAYER-1
          RWIRE=RSENSW+LAYERJ*DR0
          IF(TBIT(LAYERJ,31))GOTO8110
          XWIRE=RWIRE*DXWR-SWDEPY
          YWIRE=RWIRE*DYWR+SWDEPX
          GOTO8120
 8110     XWIRE=RWIRE*DXWR+SWDEPY
          YWIRE=RWIRE*DYWR-SWDEPX
 8120     CONTINUE
          IF(HPHT0.GT.HPHTLM)GOTO8200
C ----- ERROR 2 NOT ENOUGH ROOM IN CWORK
          CALLERRORM('PATROL  ',2,NTRAK)
          GOTO7000
C
C         --------------------------------
C         COMPUTE DRIFT DISTANCE FROM TIME
C         NOTE THAT DRIFT DISTANCE IS +VE
C         --------------------------------
C
 8200     IDRIFT=HDATA(NH1+3)
          DRIFT=IDRIFT*DRFVEL
          IF(HEAD(18).LE.0)DRIFT=DRIFT+0.5*DRFVEL
C
C         --------------------------------
C         DRIFT PATH DISPERSION CORRECTION
C         --------------------------------
C
          XJETHT=XWIRE-TRLORX*DRIFT-XMID
          YJETHT=YWIRE-TRLORY*DRIFT-YMID
          XJET2 =XWIRE+TRLORX*DRIFT-XMID
          YJET2 =YWIRE+TRLORY*DRIFT-YMID
          S3=SINLOR*DXWR-COSLOR*DYWR
          S4=COSLOR*DXWR+SINLOR*DYWR
          XX = ABS(S3*XJETHT+S4*YJETHT)
          IF(XX.NE.0.)GOTO1350
          CALLERRORM('PATROL  ',9,NTRAK)
C ----- ERROR 9  FAILED TO CALCULATE DRIFT PATH DISPERSION
C ----- ERROR 9  CORRECTION. ASSUME IT TO BE MAXIMUM
          BETA = 1.1
          GOTO1355
 1350     BETA = RAD/XX
          IF(BETA.LT.1.0)BETA=1.0
          IF(BETA.GT.1.2)BETA=1.1
 1355     XX=ABS(S3*XJET2+S4*YJET2)
          IF(XX.NE.0.) GOTO1360
          CALLERRORM('PATROL  ',9,NTRAK)
          BETA2 = 1.1
          GOTO1365
 1360     BETA2=RAD/XX
          IF(BETA2.LT.1.0)BETA2=1.0
          IF(BETA2.GT.1.1)BETA2=1.1
 1365     CONTINUE
C
          SCALE=DRIFT
          IF(DRIFT.GT.4.)SCALE=4.
          DRIFT1=DRIFT+(BETA-1.)*SCALE
          DRIFT2=DRIFT+(BETA2-1.)*SCALE
C
C         --------------------------
C         EDGE WIRE FIELD DISTORTION
C         --------------------------
C
          IF(LAYER.GE.3)GOTO1370
          DRIFT1=DRIFT1*(1.-DEL11*(LAYER-3)**2)
          DRIFT2=DRIFT2*(1.-DEL12*(LAYER-3)**2)
          GOTO1380
 1370     IF(LAYER.LE.12)GOTO1380
          DRIFT1=DRIFT1*(1.-DEL21*(LAYER-12)**2)
          DRIFT2=DRIFT2*(1.-DEL22*(LAYER-12)**2)
 1380     CONTINUE
C         ----------------------------------
C         DRIFT VELOCITY VARIATION NEAR WIRE
C         ----------------------------------
C
          IF(DRIFT1.LT.CAB(4))DRIFT1=DRIFT1+CAB(5)*(DRIFT1-CAB(4))**2
          IF(DRIFT2.LT.CAB(4))DRIFT2=DRIFT2+CAB(5)*(DRIFT2-CAB(4))**2
C         ---------------------
C         RESET -VE DRIFT TIMES
C         ---------------------
C
          IF(DRIFT1.LT.0.)DRIFT1=0.05
          IF(DRIFT2.LT.0.)DRIFT2=0.05
C
C         --------------------------------
C         COMPUTE X,Y COORDINATES FOR BOTH
C         LEFT (-VE) AND RIGHT (+VE) SOLNS
C         --------------------------------
C
          XJETHT=XWIRE-TRLORX*DRIFT1
          YJETHT=YWIRE-TRLORY*DRIFT1
          XJET2 =XWIRE+TRLORX*DRIFT2
          YJET2 =YWIRE+TRLORY*DRIFT2
C
C         --------------------------------
C         COMPUTE RESIDUALS FOR BOTH L/R
C         SOLUTIONS AND TAKE THE SMALLEST
C         --------------------------------
C
          CHIXYF=(XJETHT-XMID)**2+(YJETHT-YMID)**2
          CHIXYF=(CHIXYF-RADSQ)/RAD2
          S2=(XJET2-XMID)**2+(YJET2-YMID)**2
          S2=(S2-RADSQ)/RAD2
          LRTREL=-1
          DRIFT=DRIFT1
          IF(ABS(CHIXYF).LT.ABS(S2))GOTO8410
          LRTREL=1
          DRIFT=DRIFT2
          XJETHT=XJET2
          YJETHT=YJET2
          CHIXYF=S2
          BETA=BETA2
C
C         ----------------------
C         DETERMINE ACCEPT CODE
C         ----------------------
C
 8410     S2=ABS(CHIXYF)
          IERXYF=3
          IF(S2.GT.CODE2)GOTO8750
          IF(S2.GT.CODE0)GOTO8420
          IERXYF=0
          LAYTRY=0
          GOTO8430
 8420     IERXYF=2
 8430     CONTINUE
C
C         --------------------------------
C         COMPUTE RADIAL COORDINATE
C         TEST AGAINST USER DEFINED LIMITS
C         --------------------------------
C
          RJETHT=DRIFT/RWIRE
          RJETHT=RJETHT*(0.5*RJETHT-LRTREL*SINLOR)
          RJETHT=RWIRE*(1+RJETHT-.5*RJETHT**2)
          IF(RJETHT.LT.RMIN.OR.RJETHT.GT.RMAX)GOTO8750
C
C         -----------------------------
C         SET IERZRF = 16 IF THERE IS A
C         SECOND HIT WITHIN THE SOFTWARE
C         DOUBLE HIT RESOLUTION IXYF(18)
C         -----------------------------
C
          IERZRF=0
CC--CC    CLOSEST HIT WITH LOWER DRIFT TIME
CC--CC    IS2=NH1-4
CC--CC    IF(IS2.LT.NH0)GOTO8510
CC--CC    IS1=HDATA(IS2)
CC--CC    IS1=ISHFTR(IS1,3)
CC--CC    IF(IS1.NE.INWIRE)GOTO8510
CC--CC    IS2=IDRIFT-HDATA(IS2+3)
CC--CC    IF(IABS(IS2).LE.IXYF(18))IERZRF=16
CC--CC    CLOSEST HIT WITH HIGHER DRIFT TIME
C8510     IS2=NH1+4
CC--CC    IF(IS2.GT.NH9)GOTO8520
CC--CC    IS1=HDATA(IS2)
CC--CC    IS1=ISHFTR(IS1,3)
CC--CC    IF(IS1.NE.INWIRE)GOTO8520
CC--CC    IS2=IDRIFT-HDATA(IS2+3)
CC--CC    IF(IABS(IS2).LE.IXYF(18))IERZRF=16
C
C         ----------------------------------
C         COMPUTE Z-COORDINATE. IF EITHER Z-
C         AMPLITUDE IS <= 0 SET IERZRF = 16
C         ----------------------------------
C
 8520     IS1=HDATA(NH1+1)
          IS2=HDATA(NH1+2)
          IF(IS2.LE.0.OR.IS1.LE.0)GOTO8540
          ZJETHT=IS2+IS1
          ZJETHT=.5*ZAL*FLOAT(IS2-IS1)/ZJETHT
          GOTO8600
 8540     IERZRF=16
          ZJETHT=0
C
C         -----------------------------------
C         START SEARCH FOR INSERTION POINT AT
C         IPHT AND WORK DOWN (TO HIGHER R)
C         UNTIL A HIT OF GREATER R IS FOUND.
C         -----------------------------------
C
 8600     IF(IWRK(IPHST+1).EQ.NH1)GOTO8640
          IF(WRK(IPHST+6).GE.RJETHT)GOTO8610
          IPHST=IPHST-HLDHT
          IF(IPHST.GE.HPHT0)GOTO8600
C
C         -----------------------------------------
C         IPHST POINTS TO FIRST HIT WITH R > RJETHT
C         MAKE ROOM FOR NEW HIT IN HIT BANK
C         -----------------------------------------
C
 8610     LRTREL=1000*LRTREL
          IS1=4*(IPHST-HPHT0+HLDHT)
          HPHT0=HPHT0-HLDHT
          IF(IS1.NE.0)CALLMVCL(WRK(HPHT0),0,IWRK(HPHT0),LNBYTE,IS1)
          CALLMVCL(WRK(IPHST),0,ADWRK(1),0,LNBYTE)
C         IPHST NOW POINTS TO THE HIT JUST INSERTED
C
C         -----------------------------------
C         IF MEMORY OF CELL POINTERS IS STILL
C         REQUIRED THEY MUST NOW BE RESET TO
C         ALLOW FOR THE NEWLY INSERTED HIT
C         -----------------------------------
C
          IF(IRETRN.EQ.3)GOTO8700
          DO 8630 N=1,NCELLS
          IF(CELLPN(N,2).LE.IPHST)CELLPN(N,2)=CELLPN(N,2)-HLDHT
          IF(N.EQ.NC)GOTO8630
          IF(CELLPN(N,1).LE.IPHST)CELLPN(N,1)=CELLPN(N,1)-HLDHT
 8630     CONTINUE
          GOTO8700
 8640     IS1=IABS(IWRK(IPHST+8))
          IF(IS1.LT.1000)IS1=IS1+1000
          LRTREL=LRTREL*IS1
          CALLMVCL(WRK(IPHST),0,ADWRK(1),0,LNBYTE)
C
C         ---------------
C         GOOD HIT RETURN
C         ---------------
C
 8700     WIRSET=hLOR(WIRSET,LAYBIT(LAYER)) ! PMF 10/06/99: hlor (N.B.: WIRSET,LAYBIT= I*2)
C######################################################################
      LL = ISIGN(LAYERJ,LRTREL)
      IF (PRINT) PRINT8701,INCELL,LL,BETA,RJETHT,CHIXYF,IERXYF,IPHST
 8701 FORMAT(' CELL',I3,' LAYER',I3,' BETA',F5.2,' R=',F6.1,
     #' RES=',F7.2,I3,' ---ACCEPT---',I5)
C######################################################################
          IF(IERXYF.NE.0)GOTO8750
          IF(RJETHT.GT.REND.OR.RJETHT.LT.RSTR)GOTO8710
          LAYINT=LAYINT+1
          GOTO8720
 8710     LAYEXT=LAYEXT+1
 8720     GOTO(2020,2190,3450),IRETRN
C
C         ---------------
C         BAD  HIT RETURN
C         ---------------
C
 8750     CONTINUE
C######################################################################
      IF (IERXYF.LE.2) GOTO8755
      LL = ISIGN(LAYERJ,LRTREL)
      IF (PRINT) PRINT8751,INCELL,LL,BETA,RJETHT,CHIXYF,IERXYF
 8751 FORMAT(' CELL',I3,' LAYER',I3,' BETA',F5.2,' R=',F6.1,
     #' RES=',F7.2,I3,' ---REJECT---')
 8755  CONTINUE
C######################################################################
          GOTO(2020,2190,3470),IRETRN
C ----- ERROR 3 ILLEGAL RETURN VALUE
          CALLERRORM('PATROL  ',3,NTRAK)
          RETURN
      END

      COMMON/CWORK/MARK,SADC(32,2),CMAP(10,9),
     1CAND(3),SIGX,SIGY,SIGEN,
     1CLUS(9,2),NCLST,NNEI,ISTMZ,ISTPZ,IENDMZ,IENDPZ,IMC,
     1CATAG(192)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C
C MARK -> WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                - 2 = 1983 ONWARDS
C
C CATAG  -> CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC ->   COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1....9) -> ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) -> X,Y,AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN -> ERROR ON X,Y,ENERGY AFTER CLSPS
C
C FLIST(48) ->  NUMBER OF TIMES ADC(I) HAS BEEN FOUND IN A CLUSTER
C                   CLUSTER MAP FROM SORT23 WITH ENERGY IN CLUS(I,2)
C
C CLUS(9,2) -> ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C
C NCLST -> NUMBER OF CLUSTERS THIS END
C ISTMZ -> POINTER TO START OF -Z DATA IN CATAG (ALWAYS 1)
C ISTPZ -> POINTER TO START OF +Z DATA IN CATAG (EITHER 33 OR 25)
C IENDMZ -> POINTER TO END OF -Z DATA IN CATAG (EITHER 32 OR 24)
C IENDPZ -> POINTER TO END OF +Z DATA IN CATAG (EITHER 64 OR 48)
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C   12/03/84 406221906  MEMBER NAME  CLSPS    (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE CLSPS(SUM,ISHALL)
C
C
C ROUTINE TO FIND POSITION OF CENTRE OF CLUSTER
C
C SUM - INPUT - SUM OF ENERGY IN CLUSTER
C ISHALL - INPUT - FLAG TO SAY TURN ON THE DEBUGG INFO
C                  (1 = YES 0 = NO )
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
C
       OSUM = SUM
       IWRITE = ISHALL
       IF ( MARK .EQ. 1 ) CALL CLSPS1(OSUM,ISHALL)
       IF ( MARK .EQ. 2 ) CALL CLSPS2(SUM,ISHALL)
       RETURN
       END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE CLSPS1(SUM)
C
C WORK OUT CENTRE OF CLUSTER FOR 1981/2 TAGGER
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
#include "cwktag.for"
C
#include "comtag.for"
  11    TEST = SUM * 0.999
       TEST2 = SUM * 0.025
      XCORR = 0
      YCORR = 0
      SIGX = 20
      SIGY = 20
C
C  DEBUG INFO - WRITE OUT CLUS
C
      IF ( IWRITE .NE. 1 ) GOTO 701
      DO 1  I = 1,8
      WRITE (6,600 ) CLUS(I,1 ) ,CLUS(I,2)
 600  FORMAT(2X,F10.2,2X,F10.2)
C
C
 1    CONTINUE
 701    I = 1
        CAND(1) = CLUS(1,2)
        IF ( CAND(1) .LT. 0 ) ISHALL = 1
        IF ( CAND(1) .LT. 0 ) GOTO 11
        ADDRES = CLUS(1,1)
        CAND(2) = XMAP (ADDRES)
        CAND(3) = YMAP (ADDRES)
 5      IF ( CAND(1) .GT. TEST ) GOTO 10
CC
C
C FIT TO RATIO OF ENERGIES FOR HIT BLOCK
C AND NEXT LARGEST HIT BLOCK
C
      CALL FIT(2,XFIT,YFIT,ISHALL,&10)
C
 12   XCORR = XFIT
      YCORR = YFIT
C
C SOPHISTICATED CALCULATION OF ERROR ON X
C
      IF ( XCORR .GT. 5 ) SIGX = 5
      IF ( YCORR .GT. 5 ) SIGY = 5
C
C ALSO FIT TO 3RD BLOCK ,IF IT HAS SIGNIFICANT FRACTION OF ENERGY
C
      IF ( CLUS(3,2) .LT. TEST2 ) GOTO 10
      CALL FIT(3,XFIT,YFIT,ISHALL,&10)
C
C CHOOSE ONE OF THE TWO FIT RESULTS - WHICHEVER IS THE LARGEST
C
 13   IF ( ABS(XFIT) .GT. ABS(XCORR) ) XCORR = XFIT
      IF ( ABS(YFIT) .GT. ABS(YCORR) ) YCORR = YFIT
C SOPHISTICATED CALCULATION OF ERROR ON X
      IF ( XCORR .GT. 5 ) SIGX = 5
      IF ( YCORR .GT. 5 ) SIGY = 5
C
C NOW ADD XCORR (CORRECTION ON X) TO X
C AND SIMILARLY Y
C
   10  CAND(2) = CAND(2) + XCORR
      CAND(3) = CAND(3) + YCORR
C
C CAND(1) = ENERGY OF CLUSTER - ONLY FIRST 4 MEMBERS
C
      CAND(1) = CLUS(1,2) + CLUS(2,2) + CLUS(3,2) + CLUS(4,2 )
C
C DEBUG - WRITE OUT RESULT
C
      IF ( IWRITE .NE. 1 ) GOTO 702
      WRITE(6,601) CAND(1 ) ,CAND(2 ) ,CAND(3)
 702  SIGEN = 0.20 * SQRT(CAND(1) )
 601  FORMAT(' CLUSTER INFO ENERGY X Y ',3(2X,F12.2) )
      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE FIT(J,XFIT,YFIT, * )
C
C FIT PERFORMS THE FIT TO FIND THE DISTANCE OF THE CENTRE OF THE
CSHOWER FROM A BOUNDARY BETWEEN TWO BLOCK BY COMPARING THE RATIO
C OF THE ENERGY IN EACH
C
C J - INPUT - POINTER TO WHICH BLOCK IS TO BE COMPARED TO NUMBER 1
C                (IN CLUS)
C XFIT,YFIT - OUTPUT - X AND Y FIT RESULT
C
C RETURN 1 ERROR CONDITION DETECTED
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
#include "cwktag.for"
C
C
#include "comtag.for"
C
      XFIT = 0
      YFIT = 0
      SIGMA = 10
C
      E1 = CLUS(1,2)
      ADDRES = CLUS(1,1)
      X1 = XMAP(ADDRES)
      Y1 = YMAP(ADDRES)
      E2 = CLUS(J,2)
      IF ( (E2 + E1) .NE. 0) GOTO 10
C
      WRITE(6,60)
 60   FORMAT('  ERROR DETECTED IN FIT E2 + E1 IS ZERO ')
      RETURN  1
C
 10   ADDRES = CLUS(J,1)
      X2 = XMAP(ADDRES)
      Y2 = YMAP(ADDRES)
      IF ( IDEBUG .NE. 1 ) GOTO 703
      WRITE(6,601) E1,E2
 601  FORMAT('  E1 E2 ',2X,F10.2,2X,F10.2)
 703  RATIO = E2/(E2 + E1)
C
C THIS IS THE CRITICAL FORMULA
C
      A = RATIO/0.5
      R = LOG(A ) /( - 0.079)
C
C WORK OUT THE X AND Y CORRECTIONS REQUIRED
C
      YDIFF = Y2 - Y1
      XDIFF = X2 - X1
      YSIGN = MSIGN(YDIFF)
      XSIGN = MSIGN(XDIFF)
      THETA = 1.5708 * YSIGN
      IF ( (X2 - X1) .EQ. 0 ) GOTO 50
      THETA = ATAN((Y2 - Y1 ) /(X2 - X1) )
  50  CONTINUE
      XDIFF = X2 - X1
      YDIFF = Y2 - Y1
      ARG = YDIFF * * 2 + XDIFF * * 2
      AL = (SQRT(ARG) ) /2
      XFIT = ((AL - R) * COS(THETA) )
      YFIT = ((AL - R) * SIN(THETA) )
      XFIT = XSIGN * ABS(XFIT)
      YFIT = YSIGN * ABS(YFIT)
      IF ( IDEBUG .NE. 1 ) GOTO 704
      WRITE(6,603) XFIT,YFIT,XDIFF,YDIFF,THETA
      WRITE(6,604) AL,R,RATIO,E1,E2
  603    FORMAT(' XFIT,YFIT,YDIFF,XDIFF,THETA,AL,R,RATIO,E1,E2',5(2X,F1200018700
     1.2) )
 604  FORMAT('  ',5(2X,F12.2) )
 704  RETURN
C     DEBUG SUBCHK
      END
      FUNCTION MSIGN(X)
      MSIGN = - 1
      IF ( X .GE. 0 ) MSIGN = 1
      RETURN
      END
C   05/03/84            MEMBER NAME  NYECLS   (S)           FORTRAN
C   20/02/84            MEMBER NAME  CLSPS2   (TAGGS)       FORTRAN
C
C***HEADER*** MEMBER  CLSPS4         SAVED BY F22FIN  AT 16/10/83   23:400020100
C   10/10/83 310162342  MEMBER NAME  CLSPS4   (S)           FORTRAN
C   05/10/83 310091839  MEMBER NAME  CLSPS3   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C CLSPS2 - DOES THE WORK OF CLSPOS FOR 1983 TAGGER
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
         SUBROUTINE CLSPS2(SUM,IWRITE)
#include "cwktag.for"
      LOGICAL FIRST
      INTEGER ONE
      INTEGER OUTER
      INTEGER ONEONE
      INTEGER ADC
      COMMON/CRAT/RATDAT(100)
      COMMON/CRAT3/RA3DAT(100)
      DIMENSION FATDAT(100)
      DIMENSION USEDAT(100)
      DIMENSION FUDGE(3)
      DIMENSION FITYPE(9)
      DIMENSION RTYPE(9)
      DATA PIBY8/0.392699081/
      DATA FUDGE/0.68,0.80,0.95/
      DATA FATDAT/
     10.38,0.30,0.26,0.23,0.20,0.19,0.18,0.17,0.16,0.152,
     10.144,0.137,0.131,0.124,0.118,0.112,0.107,0.102,0.097,0.092,
     10.087,0.083,0.079,0.075,0.072,0.068,0.065,0.062,0.059,0.056,
     10.053,0.050,0.048,0.046,0.043,0.041,0.039,0.037,0.036,0.034,
     10.032,0.030,0.029,0.028,0.026,0.025,0.024,0.023,0.022,0.021,
     10.019,0.019,0.018,0.017,0.016,0.015,0.014,0.014,0.013,0.012,
     10.012,0.011,0.011,0.010,0.009,0.009,0.009,0.008,0.008,0.008,
     10.007,0.007,0.007,0.006,0.006,0.006,0.005,0.005,0.005,0.005,
     15 * 0.004                      ,5 * 0.003,
     10.003,0.003,8 * 0.003/
      DATA FIRST/.TRUE./

C
      DATA R1/96.0/,R2/110.0/,R23/125.0/,R3/140.0/,R4/225.0/
C ONE IS THE ADC SOFTWARE ADDRESS OF THE HIT BLOCK (TOP OF SORTED
C CLUSTER MAP)
      IF ( FIRST ) WRITE(6,60 ) FUDGE
  60  FORMAT('  FUDGE FACTORS ARE ',3(2X,F4.2) )

      ONE = CLUS(1,1)
      FLAG = FRTYPE(ONE)
C     IF ( FLAG .EQ. 2 ) IWRITE =  1
      INOFIL = 0
      ILOOP = 1
   1  ONESUM = 0.0
      TWOSUM = 0.0
      THRSUM = 0.0
      TEST2 = SUM * 0.000
      ILOOP = ILOOP + 1
C  WAS GOTO 2 - JMN
      IF ( IWRITE .NE. 1 ) GOTO 3
      DO 2  I = 1,9
      WRITE (6,600 ) CLUS(I,1 ) ,CLUS(I,2)
 600  FORMAT(2X,F10.2,2X,F10.2)
 2    CONTINUE
 3    CONTINUE
C
C
C FIRST FIND THE NUMBER OF 'BIG' BLOCKS,WITH LARGE AMMOUNTS
C OF ENERGY IN THEM,AND FOR THESE ,SET UP THE LIST R - TYPE
C  AND FI - TYPE
C R - TYPE = 1 FOR INNER BLOCKS
C          2     MIDDLE
C          3     OUTER
C
C FI - TYPE = 1 FOR BLOCKS IN THE - FI DIRECTION FROM THE BLOCK
C            WITH THE LARGEST AMMOUNT OF ENERGY( = 'ONE')
C         = 2 FOR BLOCKS WITH THE SAME FI AS  ONE
C         = 3 FOR BLOCKS IN THE + FI DIRN.
C
         DO 10 I = 1,9
           IF ( CLUS(I,2) .LT. TEST2 ) GOTO 11
            NBIG = I
            ADC = CLUS(I,1)
            RTYPE(I) = FRTYPE(ADC)
            FITYPE(I) = FFITYP(ADC,ONE)
C NOW IT IS NECCESSARY TO CORRECT THE ENERGIES IN THE CLUSTER
C SO THAT THEY REPRESENT THE ACTUAL ENERGY DEPOSITED,RATHER
C THAN THE ENERGY SUCH THAT ALL CLUSTERS (SUMMED OVER MANY
C BLOCKS ) HAVE THE CORRECT ENERGY.THESE ARE DIFFERENT
C FOR INNER AND MIDDLE BLOCKS DUE TO EDGE EFFECTS,I.E.
C ALL SHOWERS IN THESE BLOCKS LOSE SOME PORTION INTO
C INSIDE EDGE OF DETECTOR.
C ACKNOWLEDGMENTS TO JOHN NYE FOR POINTING THIS OUT!
C
             IF ( ILOOP .EQ. 1)CLUS(I,2) = CLUS(I,2) * FUDGE(FITYPE(I))
C
C WHILE WE ARE AT IT CALCULATE SUM OF ENERGIES IN RESPECTIVELY
C ALL BLOCKS OF FITYPE 1,DITTO 2,AND 3,USED IN RATIO
C CALCULATIONS LATER
C     IF ( IWRITE .EQ. 1 ) WRITE(6,601 ) I,ADC,RTYPE(I ) ,FITYPE(I)
C601  FORMAT(' I ADC RTYPE FITYPE ',2(2X,I4 ) ,2(2X,F2.0) )
             IF ( FITYPE(I) .EQ. 1 ) ONESUM = ONESUM + CLUS(I,2 )
             IF ( FITYPE(I) .EQ. 2 ) TWOSUM = TWOSUM + CLUS(I,2 )
             IF ( FITYPE(I) .EQ. 3 ) THRSUM = THRSUM + CLUS(I,2 )
C

C ALSO FIND THE POINTER TO THE BLOCK IN CLUS THAT IS
C THE OUTERMOST ONE IN THE HIT CAKE SLICE (SEGMENT) OR WHATEVER
C YOU WANT TO CALL IT.USED TO CHOOSE WHICH RATIO TO CALCULATE
C
             IF ( (FITYPE(I ) .NE.2) .OR. (RTYPE(I ) .NE.3) ) GOTO 10
             OUTER = I
  10     CONTINUE
C
CTEMP USE DIFFERENT = N FOR RTYPE 1 = 3
         IF ( RTYPE(1) .NE. 3 ) GOTO 125
            DO 12 I = 1,100
             USEDAT(I) = RA3DAT(I)
  12        CONTINUE
            GOTO 14
C   WAS GOTO 13 - JMN
  125       DO 13  I = 1,100
             USEDAT(I) = RATDAT(I)
  13     CONTINUE
  14     CONTINUE

C        DEPSUM IS THE  SUM OF ACTUAL DEPOSITED ENERGY,AS OPPOSED
C          TO SUM WHICH IS THE ESTIMATE OF THE ACTUAL PARTICLE ENERGY
C        SUM EFFECTIVELY IS CORRECTED FOR EDGE EFFECTS,DEPSUM IS NOT
C
         DEPSUM = ONESUM + TWOSUM + THRSUM
C USE DEPSUM TO ESTIMATE AMMOUNT OF THIS SHOWER LOST
C
          RATLOS = SUM/DEPSUM
C       WRITE(6,609 ) RATLOS
  609   FORMAT(' RATLOS IS ',F5.2)
C
C      IF ( IWRITE .EQ. 1 ) WRITE(6,610 ) OUTER,RATLOS
C610  FORMAT('   OUTER IS ',I2,' RATLOS IS ',F5.2)
  11  CONTINUE
C
C
C FOR INNER RING BLOCKS (RTYPE = 1) RATIO = ENERGY IN MIDDLE AND OUTER
C                   RINGS COMBINED DIVIDED BY TOTAL
C FOR OUTER RING BLOCKS (RTYPE = 3) RATIO = ENERGY IN MIDDLE AND INNER
C                   RINGS COMBINED DIVIDED BY TOTAL
C FOR MIDDLE RING BLOCKS (RTYPE = 3) RATIO = ENERGY IN OUTER
C                   RING DIVIDED BY TOTAL
C
C DEBUG
C       IF(IWRITE.EQ.1 ) WRITE(6,699 ) ONESUM,TWOSUM,THRSUM,CLUS(1,2 ) ,
C    1  CLUS(OUTER,2)
C699    FORMAT(' SUMS IN RATIO CALC 1,2,3. CLUS1, CLUS OUT',5(2X,F10.2))

C       RATHER THATN USE TWOSUM,USE TWOSUM CORRECTED FOR LOSSES
C       AT INSIDE EDGE
C
        CORTWO = TWOSUM * RATLOS
C
        IF ( RTYPE(1) .EQ. 1 ) RATIO = CLUS(OUTER,2 ) /CORTWO
        IF ( RTYPE(1) .EQ. 2 ) RATIO = CLUS(OUTER,2 ) /CORTWO
        IF(RTYPE(1 ) .EQ.3 ) RATIO = ((TWOSUM - CLUS(1,2) ) /TWOSUM )
C       IF(RTYPE(1 ) .EQ.3 ) RATIO = ((CORTWO - CLUS(1,2) ) /CORTWO )
C     IF ( RTYPE(1) .EQ. 3 ) CALL HFILL(999,RATIO,0.0,1.0)
C
       IF ( RATIO .GT. 0.0001 ) GOTO 25
C
         IF ( RTYPE(1) .EQ. 1 ) R = R1
         IF ( RTYPE(1) .EQ. 2 ) R = R23
         IF ( RTYPE(1) .EQ. 3 ) R = R4
C       WRITE(6,625 ) RTYPE(1 ) ,ONE,R
         INOFIL = 1
  625  FORMAT('  RATIO IS ZERO,RTYPE(1) IS ',F2.0,'  ONE IS  ',I3,' SO
     1  R IS ',F7.2)
        GOTO 40
   25  CONTINUE

C
C     IF ( IWRITE .EQ. 1 ) WRITE(6,631 ) RTYPE(1 ) ,RATIO
C 631 FORMAT('  RTYPE(1) RATIO ',2(2X,F6.3) )
        RCORR = 200.0
          DO 31 IX = 1,90
          IF ( RATIO .LT. USEDAT(IX) ) GOTO 31
C
              RCORR = IX - 0.5
              GOTO 32
C
  31      CONTINUE
C
 32     CONTINUE
C
C     IF ( R .GT. 140 ) CALL HFILL(1000,RCORR,0.0,1.0)
C      IF ( IWRITE .EQ. 1 ) WRITE(6,632 ) RCORR
C632   FORMAT('  RCORR ',F7.2)
C
C ADD RCORR TO THE RELEVANT VALUE OF R ,THAT IS THE BOUNDARY
C WHICH DIVIDED RATIO ( = ENERGY OUTSIDE BOUNDARY/TOTAL ENERGY)
C
 33     IF ( RTYPE(1) .EQ. 1 ) R = R3 - RCORR
        IF ( RTYPE(1) .EQ. 2 ) R = R3 - RCORR
        IF ( RTYPE(1) .EQ. 3 ) R = R3 + RCORR
C
C LIMIT CORRECTION TO NOT TAKING CENTRE OF CLUSTER OUT OF HIT BLOCK
C TO PROTECT AGAINST OVER ZEALOUS CORRECTION DUE TO POOR CALIBRATION
C DEAD CHANELS ETC.
C
      IF ( IWRITE .EQ. 1 ) WRITE(6,634 ) R
  634 FORMAT('   R IS ',F6.2)
      IF ( (RTYPE(1) .EQ. 1) .AND. (R .LT. R1) ) R = R1
C NOTE IN FACT THIS ONLY STOPS IT GOING OUT OF COUNTER
      R2LIM = R1
C     IF ( FIRST ) WRITE(6,62 ) R2LIM
C 62  FORMAT(/,' MIDDLE RING HITS R LIMITED TO ',F6.2)
      IF ( (RTYPE(1) .EQ. 2) .AND. (R .LT. R2LIM) ) R = R2LIM
      IF ( (RTYPE(1) .EQ. 3) .AND. (R .GT. R4) ) R = R4
C
  40  CONTINUE
C SECOND ITERATION FOR LARGE R BLOCKS HAVING FIRST CORRECTED FOR
C GEOMETRICAL OPTICS
C     GOTO 41
C     IF ( FIRST ) WRITE(6,61)
C61   FORMAT(' GEOMETRICAL OPTICS FUDGE IS ON ')
      IF ( ILOOP .GT. 2 ) GOTO 41
C     IF ( RTYPE(1) .NE. 3 ) GOTO 41
      IF ( R .LT. 128 ) GOTO 41
      IF ( R .LT. 160 ) CLUS(1,2) = CLUS(1,2) * 1.10
      IF ( R .LT. 155 ) CLUS(1,2) = CLUS(1,2) * 1.10
      IF ( R .LT. 150 ) CLUS(1,2) = CLUS(1,2) * 1.125
      IF ( R .LT. 145 ) CLUS(1,2) = CLUS(1,2) * 1.15
C     IF ( R .GT. 190 ) CLUS(1,2) = CLUS(1,2) * 0.90
      GOTO 1
   41 CONTINUE
       IF ( INOFIL .EQ. 1 ) GOTO 441
C       CALL HFILL(3,R,0.0,1.0)
C       IF ( RTYPE(1) .EQ. 1 ) CALL HFILL(801,R,0.0,1.0)
C       IF ( RTYPE(1) .EQ. 2 ) CALL HFILL(802,R,0.0,1.0)
C       IF ( RTYPE(1) .EQ. 3 ) CALL HFILL(803,R,0.0,1.0)
C     IF ( INOFIL .NE. 1 ) CALL HFILL(993,R,0.0,1.0)
C
C -------------------------------------------------------
C
C  HAVING DETERMINED R WORK OUT FI
C
C -------------------------------------------------------
C
C
 441  IF ( IWRITE .NE. 1 ) GOTO 773
           WRITE(6,605 ) R
 605       FORMAT('  R IS ',F10.2)
C
 773  FICORR = 0
C IF ONLY ONE  HIT BLOCK NO FI CORRECTION CALCULATED
C
      IF ( NBIG .EQ. 1 ) GOTO 43
C
C     FISIGN = 0 = > NO ENERGY IN NEIGHBOURING BLOCKS
C     FISIGN = -1/+1 = > MOST ENERGY IN NEIGHBOURS IN -FI/+FI DIRECTION
C
       FISIGN = 0
C
C
C
      IF ( IWRITE .NE. 1 ) GOTO 774
           WRITE(6,666 ) ONESUM,TWOSUM,THRSUM,SUM
 666       FORMAT('  ONESUM,TWOSUM,THRSUM,SUM ',4(F10.2,2X) )

 774  CONTINUE
         RATIO = ONESUM/SUM
         FISIGN = - 1
  34  IF ( ONESUM .GT. THRSUM) GOTO 36
         RATIO = THRSUM/SUM
         FISIGN = + 1
  36  CONTINUE
C
C DEBUG
C
C     IF ( RTYPE(1) .EQ. 3 ) CALL HFILL(999,RATIO,0.0,1.0)
C IF FISIGN IS STILL 0 ONESUM AND THRSUM ARE 0 SO NO RATIO
C CALCULATED (FICOR = 0)
      IF ( FISIGN .EQ. 0 ) GOTO 43
C RIC IS DISTANCE IN  MM FROM SHOWER TO BOUNDARY BETWEEN
C HIT OCTANT AND NEIGHBOURING OCTANT,DETERMINED FROM SHARING
C IF RATIO IS LARGE,MOST OF SHOWER IS IN HIT OCTANT,SO RIC IS
C LARGE,RIC IS DISTANCE OF CENTRE OF SHOWER FROM BOUNDARY
C
CTEMPTEMPTEMP  THIS FORCES R AND FI CALCULATION TO USE SAME
C FUNCTION TO ESTIMATE CORRECTIONS
C     DO 999 I = 1,100
C999  FATDAT(I) = RATDAT(I)
C  - OLD VERSION - 9/3/84 - - - - - - - -
C         DO 38 IX = 1,90
C         IF ( RATIO .LT. FATDAT(IX) ) GOTO 38
C
C             FICORR = FISIGN * (PIBY8 - ASIN((IX - 0.5 ) /R)  )
C             GOTO 37
C
C 38      CONTINUE
C - END OF OLD VERSION - 9/3/84 - - - -
C - NEW VERSION 9/3/84
C
      FICORR = 0
      IF ( RATIO .LT. 0.0001 ) GOTO 37
      SLOPE = 0.10
      IF ( RATIO .LT. 0.12 ) SLOPE = 0.06
      A = 2 * RATIO
       RCORR = (LOG(A) ) /( - 1.0 * SLOPE)
        FICORR = FISIGN * (PIBY8 - ASIN(RCORR/R) )
  37  CONTINUE
C     IF ( R .GT. 140 ) CALL HFILL(995,FICORR,0.0,1.0)
C     CORRECT R FOR FI POSITION
C
      R = R/(COS(FICORR) )
C
C     IF ( IWRITE .NE. 1 ) GOTO 776
C          WRITE(6,902) FICORR
C902       FORMAT(2X,' FICORR IS ',F10.2)
 776  CONTINUE
C
C ACTUAL VALUE OF FI (TFI) IS FI OF 'HIT' BLOCK ('ONE') + FI CORRECTION
C
 43   TFI = FITAG(ONE) + FICORR
C
      IF ( IWRITE .NE. 1 ) GOTO 777
C
C          FIONE = FITAG(ONE)
C          WRITE(6,624 ) FIONE
C624       FORMAT('  FI ONE IS ',F10.4)
C          WRITE(6,623) TFI
C623       FORMAT(' TFI IS ',F10.4)
C
C CAND(2) = X = R COS(FI)   CAND(3) = Y = R SIN(FI)
C
 777  CAND(2) = R * (COS(TFI) )
      CAND(3) = R * (SIN(TFI) )
C
C CAND(1) = ENERGY OF CLUSTER
C
       CAND(1) = SUM
C
C NOW A REALLY NAUGHTY THING
C ADJUST ENERGY OF CLUSTER FOR 'GEOMETRICAL OPTICS'
C
      IF ( R .GT. 176 ) CAND(1) = CAND(1) * 0.90
      IF ( (RTYPE(1) .EQ. 3) .AND. (R .GT. R4) ) R = R4
C
C AND FINALLY - ERROR ON ENERGY = SIGEN
      SIGEN = 0.10 * SQRT(CAND(1) )
C FILL DEBUG HISTS FOR TRUE LUMI ONLY
      FIRST = .FALSE.
       IF ( CAND(1) .LT. 15000 ) GOTO 1000
C         CALL HFILL(4,TFI,0.0,1.0)
C         CALL HFILL(994,TFI,0.0,1.0)
C         IF ( JPART .LT. 0 ) CALL HFILL(996,TFI,0.0,1.0)
C         IF ( JPART .GT. 0 ) CALL HFILL(997,TFI,0.0,1.0)
C     IWRITE = 0
1000   RETURN
C     DEBUG SUBCHK
      END

C   05/10/79 006211845  MEMBER NAME  CHANGE   (S)           FORTRAN
      SUBROUTINE CHANGE(KOMMON)
      IMPLICIT INTEGER*2(H),LOGICAL*1(Q)
#include "cpatlm.for"
#include "cjdrch.for"
      INTEGER*4 IDEC(1)
      EQUIVALENCE (IDEC(1),RDEC(1))
#include "cgraph.for"
#include "creply.for"
C
C
C-----------------------------------------------------------------------
C
C         --------------- SUBROUTINE CHANGE  -----------------
C         --------------- AUTHOR : G.F.PEARCE ----------------
C         ---------- LAST UPDATE : 1200HRS 22/06/80 ----------
C
C     ROUTINE TO ALLOW INTERACTIVE ALTERATION OF STANDARD COMMONS
C     PRESENTLY CATERS FOR 2 COMMON BLOCKS, CPATLM AND CJDRCH.
C
C     KOMMON = 1 => CHANGE COMMON CPATLM (PATREC LIMITS)
C     KOMMON = 2 => CHANGE COMMON CJDRCH (JET CHAMBER CONSTANTS)
C
C-----------------------------------------------------------------------
C
C
C-----------------------------------------------------------------------
C                          INITIALISATION
C-----------------------------------------------------------------------
C
C LIST OF VALID ARRAY NAMES WITHIN COMMON BLOCKS
C
      REAL*8 ARRAY8(34)/
CPATLM - PATREC LIMITS
     + 'PATRLM  ','FLINLM  ','TRELLM  ','ZFITLM  ','BKK     ','XYF     '
     +,'GFP     ','XBKK    ','IADMIN  ','YBKK    '
CJDRCH - INNER DETECTOR CONSTANTS
     +,'RDEC    ','PSIIN   ','RINCR   ','FIRSTW  ','FSENSW  ','RDEPTH  '
     +,'SWDEPL  ','YSUSPN  ','TIMDEL  ','ZMAX    ','ZOFFS   ','ZRESOL  '
     +,'ZNORM   ','ZAL     ','ZSCAL   ','DRIDEV  ','DRICOS  ','DRISIN  '
     +,'PEDES   ','TZERO   ','DRIROT  ','SINDRI  ','COSDRI  ','DRIVEL  '
     +/
      REAL*4 ALL/'ALL '/
      REAL*4ARRAY4(2,34)
      EQUIVALENCE (ARRAY8(1),ARRAY4(1,1))
      EQUIVALENCE (VALUE,IVALUE)
C
C LENGTHS OF VALID ARRAY NAMES WITHIN COMMON BLOCKS
C
      INTEGER*2  HLEN(34)/
CPATLM - PATREC LIMITS
     + 5,10,20,10,20,20,20,40,5,20,
CJDRCH - INNER DETECTOR CONSTANTS
     + 4,3,3,3,3,1,1,1,6,1,1,1,1,1,1,1,1,1,1,3,192,192,192,192/
C
C RELATIVE POSITION OF VALID ARRAY NAMES WITHIN COMMON BLOCKS
C
      INTEGER*2 HRELPN(34) /
CPATLM - PATREC LIMITS
     + 0, 5,15,35,45,65,85,105,145,150,
CJDRCH - INNER DETECTOR CONSTANTS
     + 0,4,7,10,13,16,17,18,19,25,26,27,28,29,30,31,32,33,34,35,38,
     + 230,422,614/
C
C SET FLAGS TO COMMON BLOCK REQUESTED THIS CALL
C
      INTEGER*2 HPOS(2,2)/1,10,11,34/
      IF (KOMMON.LT.1.OR.KOMMON.GT.2) RETURN
      IPOS1 = HPOS(1,KOMMON)
      IPOS2 = HPOS(2,KOMMON)
C-----------------------------------------------------------------------
C                      PROGRAM VERSION NUMBER
C-----------------------------------------------------------------------
      CALL TRMOUT(80,' SUBROUTINE CHANGE .. VERSION FROM 30/06/80 ^')
      CALL TRMOUT(80,' ------------------------------------------ ^')
      CALL TRMOUT(80,'    ^')
C-----------------------------------------------------------------------
C                      LIST, CHANGE OR RESET ?
C-----------------------------------------------------------------------
 20   CALL TRMOUT(80,'ENTER 1 TO LIST, 2 TO CHANGE, 3 TO RESET ^')
      CALL ALPHAN(100)
      IF (NREPLY.EQ.0.OR.IREPLY(1).LE.0.OR.IREPLY(1).GT.3) RETURN
      ICOMM = IREPLY(1)
      GOTO(100,300,900),ICOMM
C
C
C
C-----------------------------------------------------------------------
C                        LIST CURRENT VALUES
C-----------------------------------------------------------------------
 100  CONTINUE
C
C
C
C
C ARRAY NAME ?
C
      IF (NREPLY.EQ.1) GOTO101
      REPLY(1) = REPLY(2)
      GOTO104
 101  WRITE(JUSCRN,9000)(ARRAY8(I),I=IPOS1,IPOS2)
 9000 FORMAT(' ARRAYS AVAILABLE ARE :',1X,5A8/5(24X,5A8/))
      CALL TRMOUT(80,'ENTER ARRAY TO BE LISTED (OR ALL):^')
      CALL ALPHAN(100)
      IF (NREPLY.EQ.0) GOTO20
 104  IF (REPLY(1).EQ.ALL) GOTO106
      DO 105 NAME=IPOS1,IPOS2
      IF (REPLY(1).EQ.ARRAY4(1,NAME)) GOTO107
 105  CONTINUE
      WRITE(JUSCRN,9001)
 9001 FORMAT(' **** ILLEGAL ARRAY NAME ')
      GOTO101
 106  NAM1 = IPOS1
      NAM2 = IPOS2
      GOTO110
 107  NAM1 = NAME
      NAM2 = NAME
C
C LIST ALL ELEMENTS OF REQUESTED ARRAY
C
 110  DO 119 J=NAM1,NAM2
      IL = HRELPN(J)
      LN = HLEN(J)
      LN2= LN/2
      GOTO(111,112),KOMMON
 111  WRITE(JUSCRN,9002)(ARRAY8(J),I,PATRLM(I+IL),LMPATR(I+IL),I=1,LN)
      GOTO119
 112  IF(J.LT.31)WRITE(JUSCRN,9002)
     +                    (ARRAY8(J),I,RDEC(I+IL),IDEC(I+IL),I=1,LN)
      IF(J.GE.31)WRITE(JUSCRN,9003)
     +           (ARRAY8(J),I,RDEC(I+IL),RDEC(I+IL+96),I=1,LN2)
 119  CONTINUE
 9002 FORMAT(5X,A8,I3,')',1X,E13.6,' (REAL)',I8,' (INTEGER)'/
     +   200(5X,A8,I3,')',1X,E13.6,' (REAL)',I8,' (INTEGER)'/))
 9003 FORMAT(5X,A8,'CELL',I3,  4X,'LEFT)',E13.6,  4X,'RIGHT)',E13.6/
     +   200(5X,A8,'CELL',I3,  4X,'LEFT)',E13.6,  4X,'RIGHT)',E13.6/))
      GOTO20
C-----------------------------------------------------------------------
C                     CHANGE CURRENT VALUES
C-----------------------------------------------------------------------
 300  WRITE(JUSCRN,9000)(ARRAY8(I),I=IPOS1,IPOS2)
 305  CALL TRMOUT(80,'CHANGE : ENTER ARRAY, ELEMENT AND NEW VALUE :^')
      CALL ALPHAN(100)
      IF (NREPLY.EQ.0)GOTO390
      ARRNAM=REPLY(1)
      DO 310 NAME=IPOS1,IPOS2
      IF (ARRNAM.EQ.ARRAY4(1,NAME))GOTO320
 310  CONTINUE
      WRITE(JUSCRN,9001)
      GOTO300
 320  IF(NAME.NE.27.AND.NAME.NE.28.AND.NAME.NE.32.AND.NAME.NE.33)GOTO32100015100
      CALL TRMOUT(80,'*** CHANGE THE ANGLE, NOT THE SIN/COS !!!!!!^')
      GOTO300
 321  IF(NREPLY.EQ.1)GOTO330
      IF(NREPLY.EQ.2)GOTO340
      IF(NREPLY.EQ.3)GOTO350
      IF(NREPLY.GE.4)GOTO360
 330  IF(HLEN(NAME).NE.1)GOTO331
      IEL1=1
      IEL2=1
      GOTO332
 331  CALL TRMOUT(80,'ENTER ARRAY ELEMENT OR RANGE OF ELEMENTS :^')
      CALLALPHAN(100)
      IF(NREPLY.EQ.0)GOTO305
      IEL1=IREPLY(1)
      IEL2=IEL1
      IF(NREPLY.GE.2)IEL2=IREPLY(2)
 332  CALL TRMOUT(80,'ENTER NEW VALUE :^')
      CALLALPHAN(100)
      IF(NREPLY.EQ.0)GOTO305
      VALUE=REPLY(1)
      GOTO370
 340  IF(HLEN(NAME).NE.1)GOTO341
      IEL1=1
      VALUE=REPLY(2)
      GOTO370
 341  CALL TRMOUT(80,'***** ILLEGAL ARRAY ELEMENT^')
      GOTO300
 350  IEL1=IREPLY(2)
      IEL2=IREPLY(2)
      VALUE=REPLY(3)
      GOTO370
 360  IEL1=IREPLY(2)
      IEL2=IREPLY(3)
      VALUE=REPLY(4)
C
C CHECK FOR ILLEGAL ARRAY ELEMENTS
C
 370  IF(IEL1.GT.HLEN(NAME).OR.IEL1.LT.1.OR.IEL2.GT.HLEN(NAME).OR.
     +IEL2.LT.1)GOTO341
C
C     SET TO NEW VALUE
C
 380  IPOSN1=HRELPN(NAME)+IEL1
      IPOSN2=HRELPN(NAME)+IEL2
      IEL=IEL1
      DO388IPOSN=IPOSN1,IPOSN2
      IF (KOMMON.EQ.1) PATRLM(IPOSN) = VALUE
      IF (KOMMON.EQ.2) RDEC  (IPOSN) = VALUE
      IF(NAME.NE.31)GOTO386
      RDEC(IPOSN+192)=SIN(VALUE)
      RDEC(IPOSN+384)=COS(VALUE)
 386  WRITE(JUSCRN,9110)ARRAY8(NAME),IEL,VALUE,IVALUE
 9110 FORMAT(' ARRAY ',A8,' ELEMENT',I3,' RESET TO ',E13.6,' (REAL)',
     +I8,' (INTEGER)')
 388  IEL=IEL+1
      GOTO305
C
C RESET ANY OTHER CONSTANTS THAT MAY BE AFFECTED
C
 390  DRISIN = SIN(DRIDEV)
      DRICOS = COS(DRIDEV)
      CALL INPATC
      CALL TRMOUT(80,' END OF CHANGE LOOP^')
      GOTO20
C-----------------
C     RESET LIMITS
C-----------------
 900  IF (KOMMON.EQ.1) CALL INPATR
      IF (KOMMON.EQ.1) CALL TRMOUT(80,'LIMITS RESET^')
      IF (KOMMON.EQ.2) CALL TRMOUT(80,'RESET NOT POSSIBLE FOR CJDRCH^')
      GOTO20
      END

C   04/08/81 807241320  MEMBER NAME  DRAWER   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWER
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  ROUTINE FOR DIAGNOSTICS
C                                        DRAWS POINTS CIRCLES LINES ETC
C
C       MOD:   J. HAGEMANN   19/09/85 :  SMALL BUG CORRECTED FOR VIEW
C                                        VRX (INDEX=17)
C       MOD:   J. HAGEMANN   30/01/86 :  INCLUDING PARABOLA AND FIT-
C                                        POINTS
C  LAST MOD:   J. HAGEMANN   07/03/86 :  OPTION 7: LINE GIVEN BY A
C                                        POINT, SLOPE AND LENGTH
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CGAMOD / MODEGA, GAHEX
      COMMON / CJTRIG / PI,TWOPI
C
      DATA HYES / 'Y ' /
      DATA HBLK / '  ' /
C
C-----------------  C O D E  -------------------------------------------
C
      NN = ACMD
      NN = NN + 1
      IF( NN .NE. 1 ) GO TO 100
      GO TO 101
  102 CALL TRMOUT(80,'CODE 0:  RETURN^')
      CALL TRMOUT(80,'CODE 1:  LIST^')
      CALL TRMOUT(80,'CODE 2:  DRAW POINT X,Y ON SCREEN^')
      CALL TRMOUT(80,'CODE 3:  DRAW CIRCLE WITH RADIUS RAD AND CENTER X,
     $Y ^')
      CALL TRMOUT(80,'CODE 4:  DRAW LINE BETWEEN X1 Y1  AND  X2 Y2^')
      CALL TRMOUT(80,'CODE 5:  DRAW PARABOLA (X0,Y0,C,ALPHA) FROM XPB TO
     $ XPE^')
      CALL TRMOUT(80,'CODE 6:  DRAW HIT IN DETECTOR SYSTEM WITH COORDINA
     $TES GIVEN IN FIT SYSTEM^')
      CALL TRMOUT(80,'CODE 7:  DRAW LINE GIVEN BY A POINT, SLOPE AND LEN
     $GTH^')
  101 CALL TRMOUT(80,'ENTER OPTION.  1=LIST^')
      NN = TERNUM(DUM) + 1
  100 IF( NN .GE. 1 .AND. NN .LE. 8 ) GO TO 200
      GO TO 101
  200 GO TO (9999,102,300,400,500,600,700,800),NN
  300 BIG  = 40.0
      IF( LASTVW .EQ. 17 ) BIG = 0.4
      IF( LASTVW .EQ. 20 ) BIG = 16.0
      CALL TRMOUT(80,' ENTER X AND Y COOORDINATES OF POINT^')
      GO TO 9000
  400 CALL TRMOUT(80,' ENTER X,Y OF CENTER, AND CIRCLE RADIUS ^')
      GO TO 9000
  500 BIG  = 40.0
      IF( LASTVW .EQ. 17 ) BIG = 0.4
      IF( LASTVW .EQ. 20 ) BIG = 16.0
      CALL TRMOUT(80,' ENTER X1 Y1   X2 Y2  AS ENDPOINTS OF LINE^')
      GO TO 9000
  600 IF( MODEGA .EQ. 1 ) CALL CLEAR
      CALL TRMOUT(80,' ENTER X0,Y0 OF PARABOLA, C-PARAMETER, ANGLE (RADI
     $AN), XPB AND XPE^')
      READ(5,*) XS,YS,RAD,RD2,XPB,XPE
      GO TO 9001
  700 IF( MODEGA .EQ. 1 ) CALL CLEAR
      BIG  = 12.0
      IF( LASTVW .EQ. 17 ) BIG = 0.2
      IF( LASTVW .EQ. 20 ) BIG = 8.0
      CALL TRMOUT(80,' FIRST ENTER FIT SYSTEM PARAMETER (X0, Y0 , CSROT,
     $ SNROT) :^')
      CALL REALNM(X0,Y0,CSROT,SNROT)
      GO TO 9001
  800 CONTINUE
      CALL TRMOUT(80,' ENTER X,Y , SLOPE  AND LENGTH OF LINE TO
     $ BE DRAWN^')
      READ(5,*) X0,Y0,TAN,RLEN
      GO TO 9001
C
 9000 CALL REALNM(XS,YS,RAD,RD2)
      IF( LASTVW.LT.4 .OR. LASTVW.EQ.17 .OR. LASTVW.EQ.20 ) XS = -XS
 9001 GO TO (9999,102,301,401,501,601,701,801),NN
C
  301 CALL MOVEA( XS-BIG,     YS )
      CALL DRAWA( XS+BIG,     YS )
      CALL MOVEA(     XS, YS-BIG )
      CALL DRAWA(     XS, YS+BIG )
      GO TO 101
  401 CALL PLYGON(300,RAD,XS,YS,0)
      GO TO 101
  501 IF( LASTVW.LT.4 .OR. LASTVW.EQ.17 .OR. LASTVW.EQ.20 ) RAD = -RAD
      CALL DRAMOV(XS,YS,RAD,RD2,0)
      CALL MOVEA(  XS-BIG,      YS )
      CALL DRAWA(  XS+BIG,      YS )
      CALL MOVEA(      XS,  YS-BIG )
      CALL DRAWA(      XS,  YS+BIG )
      CALL MOVEA( RAD-BIG,     RD2 )
      CALL DRAWA( RAD+BIG,     RD2 )
      CALL MOVEA(     RAD, RD2-BIG )
      CALL DRAWA(     RAD, RD2+BIG )
      GO TO 101
  601 COSA = COS(RD2)
      SINA = SIN(RD2)
      YPB  = RAD*XPB*XPB
      DELX = (XPE - XPB)/100.0
      XP   = XPB*COSA - YPB*SINA + XS
      YP   = XPB*SINA + YPB*COSA + YS
      CALL MOVEA( -XP, YP )
      DO 650 I = 1, 100
         XPB  = XPB + DELX
         YPB  = RAD*XPB*XPB
         XP   = XPB*COSA - YPB*SINA + XS
         YP   = XPB*SINA + YPB*COSA + YS
         CALL DRAWA( -XP, YP )
  650 CONTINUE
      GO TO 101
C
  701 CALL TRMOUT(80,' ENTER HIT COORDINATES IN FIT SYSTEM :^')
      CALL REALNM(XH,YH,DUM1,DUM2)
      XDUM = XH
      XH   = XDUM*CSROT - YH*SNROT + X0
      YH   = XDUM*SNROT + YH*CSROT + Y0
      CALL MOVEA( -XH-BIG,     YH )
      CALL DRAWA( -XH+BIG,     YH )
      CALL MOVEA(     -XH, YH-BIG )
      CALL DRAWA(     -XH, YH+BIG )
      CALL TRMOUT(80,' OTHER HITS ?  <Y>, N^')
      CALL TRMIN( 2, HCD )
      IF( HCD .EQ. HBLK ) HCD = HYES
      IF( HCD .EQ. HYES ) GO TO 701
      GO TO 101
C
  801 ALF = ATAN(TAN)
      SN  = SIN(ALF)
      CS  = COS(ALF)
      XA  = X0 - RLEN*CS
      XE  = X0 + RLEN*CS
      YA  = Y0 - RLEN*SN
      YE  = Y0 + RLEN*SN
      IF( LASTVW .GT. 4 .AND. LASTVW .NE. 17 .AND. LASTVW .NE. 20 )
     *                                        GO TO 802
         XA = -XA
         XE = -XE
  802 CALL DRAMOV( XA, YA, XE, YE, 0 )
      GO TO 101
C
 9999 RETURN
      END

      SUBROUTINE FRFITV(IPTR,IPJHTL,ERRFAC)
      IMPLICIT INTEGER*2 (H)
      LOGICAL DEADCL
#include "cdata.for"
#include "cgeo1.for"
#include "calibr.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      INTEGER DATE(5), IDAY /0/
      DIMENSION ITRCLL(6), NCNCK(24), NHTRNG(3)
      DATA RESJ0 /.200/, RESV0 /.300/
      INTEGER MKLRT1 /Z1000000/, MKLRT2 /Z100/
      INTEGER MKBDCL(3) /Z10,Z20,Z40/
      INTEGER MKDDCL(3) /Z01,Z02,Z04/
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 1
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      HPFREE = 1
      HPFRE1 = HPFREE
      HPCO0  = HPFREE
      HLDCO  = 14
      HPFREE = HLDCO*100 + HPCO0
      HPCO9 = HPFREE - 1
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      HPTR0 = HPFREE
      CALL MVC(IWRK(HPTR0),0,IDATA(IPTR+1),0,192)
      IWRK(HPTR0+1) = 0
      ITRK = IDATA(IPTR+1)
      IF(
     - IDATA(IPTR+18).EQ.1
     -)THEN
        ALFA  = ADATA(IPTR+21)
        CRV   = ADATA(IPTR+19)
        IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
        RAD   =  1./CRV + ADATA(IPTR+20)
        XCIRC = COS(ALFA) * RAD
        YCIRC = SIN(ALFA) * RAD
        CHARGE = SIGN(1.,ADATA(IPTR+25))
      ELSE
        CRV   = ADATA(IPTR+22)*2.
        IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
        ALFA  = ADATA(IPTR+19)
        XCIRC =-SIN(ALFA)/CRV + ADATA(IPTR+20)
        YCIRC = COS(ALFA)/CRV + ADATA(IPTR+21)
        CHARGE =-SIGN(1.,ADATA(IPTR+22))
      ENDIF
      ZVERT = ADATA(IPTR+31)
      TGTH = ADATA(IPTR+30)
      CSTHI = SQRT(TGTH**2 + 1.)
      CSTH  = 1. / CSTHI
      SNTH  = CSTH * TGTH
      IPV    = ICALIB(10)
      XO     = ACALIB(IPV+ 1)
      YO     = ACALIB(IPV+ 3)
      PTRANS = ABS(0.0299792458*BKGAUS/ADATA(IPTR+25)) * .001
      RESV   = RESV0**2 + RESMS / PTRANS**2
      WGHT0  = RESJ0**2 / RESV
      F1     = ERRFAC
      IF(F1 .LT. .10) F1 = .10
      WGHT0  = WGHT0 / F1**2
      XT    = (ADATA(IPTR+12) + XO) * .5
      YT    = (ADATA(IPTR+13) + YO) * .5
      XX    =  ADATA(IPTR+12) - XO
      YY    =  ADATA(IPTR+13) - YO
      RR    = SQRT(XX**2+YY**2)
      CSROT = XX / RR
      SNROT = YY / RR
      XOT = XO - XT
      YOT = YO - YT
      X0   = XOT*CSROT + YOT*SNROT
      Y0   =-XOT*SNROT + YOT*CSROT
      XOR  =- XT*CSROT -  YT*SNROT
      YOR  =  XT*SNROT -  YT*CSROT
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      KCLL = 0
      NHIT = 0
      IPCO = HPCO0
      JRING = 0
      LBCELL = 0
16000 CONTINUE
      JRING = JRING + 1
        NHTRNG(JRING) = 0
        NHRNG = 0
        NCLL = 0
16002 CONTINUE
        NCLL = NCLL + 1
        KCLL = KCLL + 1
          JCELL = ITRCLL(KCLL)
      IF(
     - JCELL.NE.0
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
            NHRNG = NHRNG + JHIT
      ENDIF
      IF(.NOT.(
     - NCLL.EQ.2
     -))GOTO 16002
16003 CONTINUE
        IF(JCELL.NE.0) LBCELL = LOR(MKBDCL(JRING),LBCELL)
      IF(.NOT.(
     - KCLL.EQ.6
     -))GOTO 16000
16001 CONTINUE
      HPCO9 = IPCO - 1
      JRINGL = 3
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      ALBLM1 = 0.6
      ALBLM2 = 3.0
      ASSIGN 17009 TO IZZZ05
      GOTO 17008
17009 CONTINUE
      ASSIGN 17010 TO IZZZ04
      GOTO 17006
17010 CONTINUE
      ASSIGN 17011 TO IZZZ05
      GOTO 17008
17011 CONTINUE
      IF(
     - SIG.LT.1.
     -)THEN
      ASSIGN 17013 TO IZZZ06
      GOTO 17012
17013 CONTINUE
      ENDIF
      IF(
     - ABS(PAR1).GT..00030 .AND. NHTRNG(1)+NHTRNG(2).GT.16
     -)THEN
        ALBLM1 = 1.5
        ALBLM2 = 3.0
      ASSIGN 17014 TO IZZZ05
      GOTO 17008
17014 CONTINUE
        JRINGL = 2
      ASSIGN 17015 TO IZZZ04
      GOTO 17006
17015 CONTINUE
        ALBLM1 = 0.6
      ASSIGN 17016 TO IZZZ05
      GOTO 17008
17016 CONTINUE
      ASSIGN 17017 TO IZZZ04
      GOTO 17006
17017 CONTINUE
      ASSIGN 17018 TO IZZZ05
      GOTO 17008
17018 CONTINUE
      IF(
     - SIG.LT..10
     -)THEN
      ASSIGN 17020 TO IZZZ07
      GOTO 17019
17020 CONTINUE
          IWRK(IP+ 4) = 32
      ENDIF
      ENDIF
      IF(
     - ABS(PAR1).GT..00150 .AND. NHTRNG(1)+NHTRNG(2).GT.9
     -)THEN
        ALBLM1 = 1.5
        ALBLM2 = 3.0
      ASSIGN 17021 TO IZZZ05
      GOTO 17008
17021 CONTINUE
        JRINGL = 1
        NHTFIT = NHTRNG(1)
      IF(
     - NHTFIT.LE.5
     -)THEN
          NHTFIT = NHTFIT + NHTRNG(2)
          JRINGL = 2
      ENDIF
      IF(
     - NHTFIT.GT.9
     -)THEN
      ASSIGN 17022 TO IZZZ04
      GOTO 17006
17022 CONTINUE
          ALBLM1 = 0.6
      ASSIGN 17023 TO IZZZ05
      GOTO 17008
17023 CONTINUE
      ASSIGN 17024 TO IZZZ04
      GOTO 17006
17024 CONTINUE
      ASSIGN 17025 TO IZZZ05
      GOTO 17008
17025 CONTINUE
      IF(
     - SIG.LT..10
     -)THEN
      ASSIGN 17026 TO IZZZ07
      GOTO 17019
17026 CONTINUE
            IWRK(IP+ 4) = 48
      ENDIF
      ENDIF
      ENDIF
      HPFREE = HPFRE1
      RETURN
17006 CONTINUE
      S0 = WGHT0
      S1 = X0*WGHT0
      S2 = S1*X0
      S3 = S2*X0
      S4 = S3*X0
      S7 = Y0 * WGHT0
      S6 = S7*X0
      S5 = S6*X0
      IPCO = HPCO0
16004 CONTINUE
      IF(
     - IWRK(IPCO+ 10).EQ.0 .AND. IWRK(IPCO+12).LE.JRINGL
     -)THEN
          X = WRK(IPCO+3)
          Y = WRK(IPCO+4)
          X2 = X**2
          S1 = S1 + X
          S2 = S2 + X2
          S3 = S3 + X*X2
          S4 = S4 + X2**2
          S5 = S5 + Y*X2
          S6 = S6 + Y*X
          S7 = S7 + Y
          S0 = S0 + 1.
      ENDIF
      IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16004
16005 CONTINUE
      IF(
     - S0.LT.2.5
     -)THEN
        SIG = 1000.
      ELSE
        F1 = 1. / S4
        XX12 = S3*F1
        XX13 = S2*F1
        YY1  = S5*F1
        XX22 = S2 - S3*XX12
        XX23 = S1 - S3*XX13
        YY2  = S6 - S3*YY1
        XX32 = S1 - S2*XX12
        XX33 = S0 - S2*XX13
        YY3  = S7 - S2*YY1
      IF(
     - XX22.GT.XX32
     -)THEN
          XX23 = XX23 / XX22
          YY2  = YY2  / XX22
          PAR3 = (YY3 - XX32*YY2) / (XX33 - XX32*XX23)
          PAR2 = YY2 - XX23*PAR3
      ELSE
          XX33 = XX33 / XX32
          YY3  = YY3  / XX32
          PAR3 = (YY2 - XX22*YY3) / (XX23 - XX22*XX33)
          PAR2 = YY3 - XX33*PAR3
      ENDIF
        PAR1 = YY1 - XX12*PAR2 - XX13*PAR3
        DEG = S0 - WGHT0 - 2.
        CHISQ = 0.
        DCHIM1 = 0.
        IHITM1 = 0
        XST    = 999999.
        XEN    =-999999.
        IPCO = HPCO0
16006 CONTINUE
      IF(
     - IWRK(IPCO+ 10).EQ.0 .AND. IWRK(IPCO+12).LE.JRINGL
     -)THEN
            X = WRK(IPCO+3)
            IF(X.LT.XST) XST = X
            IF(X.GT.XEN) XEN = X
            Y = WRK(IPCO+4)
            F = (PAR1 *X + PAR2 )*X + PAR3
            DCHI = Y - F
            WRK(IPCO+13) = DCHI
            CHISQ = CHISQ + DCHI**2
      ENDIF
        IPCO = IPCO + HLDCO
      IF(.NOT.(
     - IPCO.GT.HPCO9
     -))GOTO 16006
16007 CONTINUE
        SIG    =      CHISQ  / DEG
        SIGLM = TRELLM(16)**2
      ENDIF
      GOTO IZZZ04
17002 CONTINUE
      DO 13000 I=1,6
          ITRCLL(I) = 0
13000 CONTINUE
13001 CONTINUE
        IPC0 = IPTR + 34
        IPC9 = IPC0 +  5
        ICELL = 0
      DO 13002 IPC = IPC0,IPC9
          JCELL = IDATA(IPC)
      IF(
     - JCELL.GT. 0 .AND. JCELL.LE.96
     -)THEN
            JRING = 1
            IF(JCELL.GT.24) JRING = 2
            IF(JCELL.GT.48) JRING = 3
            JPC = JRING*2 - 1
      IF(
     - ITRCLL(JPC).EQ.0
     -)THEN
              ITRCLL(JPC) = JCELL
      ELSE
              IF(ITRCLL(JPC).NE.JCELL) ITRCLL(JPC+1) = JCELL
      ENDIF
            ICELL = JCELL
            IRING = JRING
      ENDIF
13002 CONTINUE
13003 CONTINUE
      GOTO IZZZ02
17004 CONTINUE
      IF(
     - JRING.NE.3
     -)THEN
          IC1 = JCELL
          IF(IC1.GT.24) IC1 = IC1 - 24
          CSROT0 = DIRWR1(IC1,1)
          SNROT0 = DIRWR1(IC1,2)
      ELSE
          IC1 = JCELL - 48
          CSROT0 = DIRWR3(IC1,1)
          SNROT0 = DIRWR3(IC1,2)
      ENDIF
        DRICS  = TRMATC(JCELL,2)
        DRISN  = TRMATS(JCELL,2)
        DRITG  = DRISN/DRICS
        DRISNF = DRISN * .05
        R0 = FSENSW(JRING)
        DR = RINCR (JRING)
        R1   = DR*7.5 + R0
        DX   = R1 * CSROT0 - XCIRC
        DY   = R1 * SNROT0 - YCIRC
        RR   = SQRT(DX**2 + DY**2) * CHARGE
        CSB  = DX / RR
        SNB  = DY / RR
        TGB  = CSB/SNB
        DSBIN1 = DRIVEL(JCELL,1)
        IF(NRUN.GT.100) DS0 = T0FIX(JRING)*DSBIN1*64.
        IF(NRUN.LE.100) DS0 = DSBIN1*.5
        TANBET = ABS((TGB-DRITG)/(TGB*DRITG+1.))
        IPJCOR = ICALIB(5) + JCELL
        CCST01 = ACALIB(IPJCOR    ) * TANBET
        CCST02 = ACALIB(IPJCOR+ 96) * TANBET
        CCST11 = ACALIB(IPJCOR+192)
        CCST12 = ACALIB(IPJCOR+288)
        CCST21 = ACALIB(IPJCOR+384)
        CCST22 = ACALIB(IPJCOR+480)
        CCST51 = ACALIB(IPJCOR+576) * 10.
        CCST52 = ACALIB(IPJCOR+672) / 121.15
        CCST61 = ACALIB(IPJCOR+768) * 10.
        CCST62 = ACALIB(IPJCOR+864) / 121.15
        JHIT = 0
        NHIT   = 0
        NHGOOD = 0
        ILAYL =-99
        IPCO = IPCO - HLDCO
        IPJETC = IDATA(IQJETC)*2
        IP0    = IPJETC + 100
        IPCLL  = IPJETC + 2 + JCELL
        IP     = HDATA(IPCLL  ) + IP0
        IP9    = HDATA(IPCLL+1) + IP0
        IPHL   = IPJHTL + 2 + HDATA(IPCLL)/4
15000 CONTINUE
      IF(
     - IP.LT.IP9
     -)THEN
          LB   = IDATA(IPHL)
          ITR1 = LAND(ISHFTR(LB,17),127)
          ITR2 = LAND(ISHFTR(LB, 1),127)
      IF(
     - ITR1.EQ.ITRK .OR. ITR2.EQ.ITRK
     -)THEN
            LBLR = 0
            IF(ITR1.EQ.ITRK) LBLR = LAND(LB,MKLRT1)
            IF(ITR2.EQ.ITRK) LBLR = LAND(LB,MKLRT2)
            LBSIDE =-1
            IF(LBLR.NE.0) LBSIDE = 1
            LBLR = LBSIDE
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            ILAY = LAND(IWIR,15)
            IAMPL = HDATA(IP+1)
            IAMPR = HDATA(IP+2)
            DS =(HDATA(IP+3)) * DSBIN1
            X1   = ILAY * DR + R0
            Z1   = X1*TGTH + ZVERT
            DDS = (1222.9-ABS(Z1))*ABERR(1) + ABERR(6)*R1*CSTHI
            DSC = DS - DDS + DS0
            Y1   = SWDEPL
            IF(LAND(ILAY,1).NE.0) Y1 =-Y1
            Y1   = (7-ILAY)*(CCST52*Z1+CCST51) - CCST62*Z1-CCST61 + Y1
            X    = X1*CSROT0 - Y1*SNROT0
            Y    = X1*SNROT0 + Y1*CSROT0
      IF(
     - DS.LE.DRC
     -)THEN
      IF(
     - DS.LT.4.0
     -)THEN
      IF(
     - DS.GT.DSD1
     -)THEN
                  DSC = (DSD1-DSD0)*DRV0 + (DS-DSD1)*DRV1
      ELSE
                  DSC = (DS-DSD0)*DRV0
      ENDIF
                IF(DSC.LT.0.1) DSC = 0.1
      ENDIF
              DXR  = DSC * CSB
              DYR  = DSC * SNB
              DXL =-DXR
              DYL =-DYR
      ELSE
      IF(
     - ILAY.LT. 3
     -)THEN
                DILAY =-(ILAY- 3)**2
                DSCL  = (DILAY*CCST11 + 1.) * DSC
                DSCR  = (DILAY*CCST12 + 1.) * DSC
      ELSE
      IF(
     - ILAY.GT.12
     -)THEN
                DILAY =-(ILAY-12)**2
                DSCL  = (DILAY*CCST21 + 1.) * DSC
                DSCR  = (DILAY*CCST22 + 1.) * DSC
      ELSE
                DSCL = DSC
                DSCR = DSC
      ENDIF
      ENDIF
      IF(
     - DSC.GT.ABERR(7)
     -)THEN
                DWIR  = ILAY - 7.5
                DWIRC = DSC*DRISNF
                DWIRL = DWIR + DWIRC
                DWIRR = DWIR - DWIRC
                DSCL  = (DSCL-ABERR(7))*DWIRL*CCST01 + DSCL
                DSCR  =-(DSCR-ABERR(7))*DWIRR*CCST02 + DSCR
      ENDIF
              DXR  = (DSCR-DRC)*DRISN + DRC*CSB
              DYR  = (DSCR-DRC)*DRICS + DRC*SNB
              DXL  =-(DSCL-DRC)*DRISN - DRC*CSB
              DYL  =-(DSCL-DRC)*DRICS - DRC*SNB
      ENDIF
            XL   = DXL + X - XT
            YL   = DYL + Y - YT
            XXL  = XL*CSROT + YL*SNROT
            YYL  =-XL*SNROT + YL*CSROT
            XR   = DXR + X - XT
            YR   = DYR + Y - YT
            XXR  = XR*CSROT + YR*SNROT
            YYR  =-XR*SNROT + YR*CSROT
      IF(
     - IAMPR.LE.0.OR.IAMPL.LE.0
     -)THEN
              ZZ     = 0.
              LZGOOD = 16
      ELSE
              ZZ = IAMPR + IAMPL
              ZZ = FLOAT(IAMPR-IAMPL) * ZAL*.5 / ZZ
              LZGOOD = 0
              IF(ABS(ZZ).GT.1250.) LZGOOD = 16
      ENDIF
            NLRSOL = 1
            IF(DS.LT.2.0) NLRSOL = 2
            ILRSOL = 0
16008 CONTINUE
            ILRSOL = ILRSOL + 1
      IF(
     - NLRSOL.EQ.1 .AND. LBSIDE.LT.0  .OR.
     ?           NLRSOL.EQ.2 .AND. ILRSOL.EQ.1
     -)THEN
                LBSIDE =-1
                XX  = XXL
                YY  = YYL
      ELSE
                LBSIDE = 1
                XX  = XXR
                YY  = YYR
      ENDIF
              LBGOOD = 0
              IF(LBSIDE.NE.LBLR) LBGOOD = 1
      IF(
     - ILAY.NE.ILAYL .OR. LBGDL.LE.1.AND.LBGOOD.LE.1
     -)THEN
                LBREG = 1
                JHIT = JHIT + 1
                IPCO = IPCO + HLDCO
      ELSE
                LBREG = 0
                IF(LBGOOD.LT.IWRK(IPCO+10)) LBREG = 1
      ENDIF
      IF(
     - LBREG.NE.0
     -)THEN
                NHIT   = NHIT   + 1
                IF(LBGOOD.LE.1) NHGOOD = NHGOOD + 1
                IWRK(IPCO   ) = ILAY
                IWRK(IPCO+ 1) = IP
                IWRK(IPCO+ 2) = LBSIDE
                WRK (IPCO+ 3) = XX
                WRK (IPCO+ 4) = YY
                WRK (IPCO+ 5) = ZZ
                WRK (IPCO+ 6) = XX - X0
                IWRK(IPCO+ 7) = LZGOOD
                WRK (IPCO+ 8) = DS
                IWRK(IPCO+ 9) = JCELL
                IWRK(IPCO+10) = LBGOOD
                WRK (IPCO+11) = TGB
                IWRK(IPCO+12) = JRING
                WRK (IPCO+13) = 0.
                ILAYL = ILAY
                LBGDL = LBGOOD
                NHTRNG(JRING) = NHTRNG(JRING) + 1
      ENDIF
      IF(.NOT.(
     - ILRSOL.GE.NLRSOL
     -))GOTO 16008
16009 CONTINUE
      ENDIF
        IPHL = IPHL + 1
        IP   = IP   + 4
      GOTO 15000
      ENDIF
15001 CONTINUE
        IPCO = IPCO + HLDCO
      IF(
     - NHIT.LE.2
     -)THEN
      IF(
     - DEADCL(JCELL,NRUN)
     -)THEN
            LBCELL = LOR(LBCELL,MKDDCL(JRING))
            JHIT = 16
            NHIT = 16
      ENDIF
      ENDIF
      GOTO IZZZ03
17012 CONTINUE
      YST  = (PAR1 *XST + PAR2 )*XST + PAR3
      YEN  = (PAR1 *XEN + PAR2 )*XEN + PAR3
      TGST = PAR1*XST*2 + PAR2
      DXST = 1./SQRT(TGST**2+1.)
      DYST = DXST * TGST
      TGEN = PAR1*XEN*2 + PAR2
      DXEN = 1./SQRT(TGEN**2+1.)
      DYEN = DXEN * TGEN
      XMIN = -PAR2*.5 / PAR1
      YMIN = (PAR1*XMIN + PAR2)*XMIN + PAR3
      CURV =-PAR1 * 2.
      DET = (S2*S0-S1*S1)*S4 + (S2*S1-S3*S0)*S3 + (S3*S1-S2*S2)*S2
      SIG11 = (S2*S0 - S1*S1)/DET
      SIG22 = (S4*S0 - S2*S2)/DET
      SIG33 = (S4*S2 - S3*S3)/DET
      SIG12 = (S3*S0 - S2*S1)/DET
      SIG13 = (S3*S1 - S2*S2)/DET
      SIG23 = (S4*S1 - S3*S2)/DET
      IP    = HPTR0 - 1
      IWRK(IP+ 1) = ITRK
      IWRK(IP+ 2) = 32
      IWRK(IP+ 3) = IDAY
      IWRK(IP+ 4) = 16
      WRK (IP+ 5) = XST *CSROT - YST *SNROT + XT
      WRK (IP+ 6) = XST *SNROT + YST *CSROT + YT
      WRK (IP+ 7) = XST - X0
      WRK (IP+ 8) = (DXST*CSROT - DYST*SNROT)
      WRK (IP+ 9) = (DXST*SNROT + DYST*CSROT)
      WRK (IP+10) = SNTH
      IWRK(IP+11) = 0
      WRK (IP+12) = XEN *CSROT - YEN *SNROT + XT
      WRK (IP+13) = XEN *SNROT + YEN *CSROT + YT
      WRK (IP+14) = XEN - X0
      WRK (IP+15) = (DXEN*CSROT - DYEN*SNROT)
      WRK (IP+16) = (DXEN*SNROT + DYEN*CSROT)
      WRK (IP+17) = SNTH
      IWRK(IP+18) = 2
      WRK (IP+19) = ATAN2(SNROT,CSROT)
      WRK (IP+20) = XMIN*CSROT - YMIN*SNROT + XT
      WRK (IP+21) = XMIN*SNROT + YMIN*CSROT + YT
      WRK (IP+22) = PAR1
      WRK (IP+23) = SQRT(SIG)
      IWRK(IP+24) = S0 + .001
      WRK (IP+25) = CURV
      WRK (IP+26) = SQRT(SIG*SIG11) * 2.
      WRK (IP+27) = CURV
      WRK (IP+28) = CURV
      WRK (IP+31) = XOR - X0
      GOTO IZZZ06
17019 CONTINUE
      YST  = (PAR1 *XST + PAR2 )*XST + PAR3
      TGST = PAR1*XST*2 + PAR2
      DXST = 1./SQRT(TGST**2+1.)
      DYST = DXST * TGST
      XMIN = -PAR2*.5 / PAR1
      YMIN = (PAR1*XMIN + PAR2)*XMIN + PAR3
      CURV =-PAR1 * 2.
      DET = (S2*S0-S1*S1)*S4 + (S2*S1-S3*S0)*S3 + (S3*S1-S2*S2)*S2
      SIG11 = (S2*S0 - S1*S1)/DET
      SIG22 = (S4*S0 - S2*S2)/DET
      SIG33 = (S4*S2 - S3*S3)/DET
      SIG12 = (S3*S0 - S2*S1)/DET
      SIG13 = (S3*S1 - S2*S2)/DET
      SIG23 = (S4*S1 - S3*S2)/DET
      IP    = HPTR0 - 1
      WRK (IP+ 5) = XST *CSROT - YST *SNROT + XT
      WRK (IP+ 6) = XST *SNROT + YST *CSROT + YT
      WRK (IP+ 7) = XST - X0
      WRK (IP+ 8) = (DXST*CSROT - DYST*SNROT)
      WRK (IP+ 9) = (DXST*SNROT + DYST*CSROT)
      WRK (IP+10) = SNTH
      IWRK(IP+18) = 2
      WRK (IP+19) = ATAN2(SNROT,CSROT)
      WRK (IP+20) = XMIN*CSROT - YMIN*SNROT + XT
      WRK (IP+21) = XMIN*SNROT + YMIN*CSROT + YT
      WRK (IP+22) = PAR1
      WRK (IP+23) = SQRT(SIG)
      IWRK(IP+24) = S0 + .001
      WRK (IP+25) = CURV
      WRK (IP+26) = SQRT(SIG*SIG11) * 2.
      WRK (IP+27) = CURV
      GOTO IZZZ07
17008 CONTINUE
        IWL = -999
        IWL = -999
      DO 13004 IP = HPCO0,HPCO9,HLDCO
          IW0 = IWRK(IP)
          X   = WRK(IP+3)
          Y   = WRK(IP+4)
          F   = (PAR1*X + PAR2)*X + PAR3
          DF  = F - Y
          LBGOOD = 4
          IF(ABS(DF).LT.ALBLM2) LBGOOD = 1
          IF(ABS(DF).LT.ALBLM1) LBGOOD = 0
          IWRK(IP+ 10) = LBGOOD
          WRK (IP+13) = DF
      IF(
     - IWL.EQ.IW0
     -)THEN
      IF(
     - ABS(DFL).LT.ABS(DF)
     -)THEN
              IWRK(IP +10) = 16
      ELSE
              IWRK(IPL+10) = 16
      ENDIF
      ENDIF
          IWL = IW0
          IPL = IP
          DFL = DF
13004 CONTINUE
13005 CONTINUE
      GOTO IZZZ05
17000 CONTINUE
        IQJETC = IBLN('JETC')
        IQHEAD = IBLN('HEAD')
        CALL DAY2(DATE)
        IDAY = DATE(1)*1000 + DATE(2)
        RESMS = .020**2/2. * .16 * (1. + ALOG10(.16) / 9) * 155.45**2
        DRC = RINCR(1)*.5 * DRICOS
        IPHEAD = IDATA(IQHEAD)*2
        NRUN = HDATA(IPHEAD+10)
      IF(
     - NRUN.LE.100
     -)THEN
          DSD0   = .0
          DSD1   = 5.0
          DSD2   = 5.0
          DRV0   = 1.0
          DRV1   = 1.0
      ELSE
          DSD0   =-.63
          DSD1   = 1.8
          DSD2   = 4.0
          DRV0   = 0.8
          DRV1   = (DSD2 - (DSD1-DSD0)*DRV0) / (DSD2-DSD1)
      ENDIF
      GOTO IZZZ01
      END

C   08/07/80 708261442  MEMBER NAME  TRCROS   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRCROS( AR1, AR2, S1,S2, XYZC )
C-----------------------------------------------------------------------
C     ORIGINAL  06-03-80  09:55 S.YAMADA
C          MOD  08-05-80  14:45
C          MOD  13-10-81  18:35 E.ELSEN     AMAX1 INTRODUCED
C     LAST MOD  26-08-87  14:35 C.BOWDERY   RENAMED FROM TPTCRS
C
C     CROSSING POINT OF TWO LINES IS CALCULATED.
C
C     INPUT
C     -----
C     AR1=(X1,Y1,Z1,DX1,DY1,DZ1)   LINE PARAMETERS OF THE LINE #1
C     AR2=(X2,Y2,Z2,DX2,DY2,DZ2)   LINE PARAMETERS OF THE LINE #2
C     OUTPUT
C     ------
C     S1=DISTANCE FROM (X1,Y1,Z1) TO THE CROSSING POINT
C     S2=DISTANCE FROM (X2,Y2,Z2) TO THE CROSSING POINT
C
C     S1 AND S2 HAVE SIGNS W.R.T. THE INPUT DIRECTIONS.
C     S1 AND S2 HAVE SIGNS W.R.T. THE INPUT DIRECTIONS,
C     +  FOR THE SAME DIRECTION, - FOR THE OPPOSITE DIRECTION.
C     XYZC(I,J)   CROSSING POINT ON THE J-TH TRACK EXTRAPOLATION.
C                 I=1,2,3  FOR X,Y,Z
C
C-----------------------------------------------------------------------
C
      DIMENSION  AR1(6), AR2(6), XYZC(3,2)
C
C------------------  C O D E  ------------------------------------------
C
      X1 = AR1(1)
      Y1 = AR1(2)
      Z1 = AR1(3)
C
C                            NORMALIZED DIRECTION IN THE (X,Y) PLANE
C
      DS1 = AMAX1( SQRT(AR1(4)**2+AR1(5)**2), 1.E-6 )
      DX1 = AR1(4)/DS1
      DY1 = AR1(5)/DS1
      DZ1 = AR1(6)/DS1
C
      X2 = AR2(1)
      Y2 = AR2(2)
      Z2 = AR2(3)
C
C                            NORMALIZED DIRECTION IN THE (X,Y) PLANE
C
      DS2 = AMAX1( SQRT(AR2(4)**2+AR2(5)**2), 1.E-6 )
      DX2 = AR2(4)/DS1
      DY2 = AR2(5)/DS1
      DZ2 = AR2(6)/DS1
C
C                            THE EQUATION S FOR THE LINES
C                              X=DX1*S1+X1                  X=DX2*S2+X2
C                              Y=DY1*S1+Y1                  Y=DY2*S2+Y2
C                            THE EQUATIONS FOR THE DISTANCES
C                            TO THE CROSSING POINT
C                              DX1*S1 - DX2*S2 = X2 - X1 = DX
C                              DY1*S1 - DY2*S2 = Y2 - Y1 = DY
C
      DX    = X2-X1
      DY    = Y2-Y1
      COS12 = DX1*DX2+DY1*DY2
      IF( ABS(COS12).GT.0.99 ) GO TO 10
      DD    = DX1*DY2-DX2*DY1
      IF( DD.EQ.0. ) GO TO 10
C
      S1 = (DX*DY2-DY*DX2)/DD
      S2 = (DX*DY1-DY*DX1)/DD
      GO TO 100
C
C                            ALMOST PARALLEL CASE
C
   10 S1 =  0.5*(DX*DX1 + DY*DY1)
      S2 = -0.5*(DX*DX2 + DY*DY2)
C
  100 XYZC(1,1) = DX1*S1+X1
      XYZC(2,1) = DY1*S1+Y1
      XYZC(3,1) = DZ1*S1+Z1
      XYZC(1,2) = DX2*S2+X2
      XYZC(2,2) = DY2*S2+Y2
      XYZC(3,2) = DZ2*S2+Z2
C
      RETURN
      END

C   08/09/82 209092236  MEMBER NAME  LGBTDCA  (S)           FORTRAN
      SUBROUTINE LGBTDC( CBTDC, JFLLGT )
C
C     S.YAMADA   09-05-82   12:00      COPIED FROM F22YAM.PHANAL.S
C                                      ON 27-05-82
C     LAST MOD.  09-09-82  17:55       COPIED FROM F22YAM.LGCALIB.S
C
C---- LG-BARREL TOF
C
#include "cdata.for"
C
      INTEGER *4 NRUNBN(5)/2010241,2010263,2010361,2011440,2011803/
      DATA NMAX/5/
      REAL       TBASE(5)/   52.66,  92.69,  70.74,  91.80,  90.47/
C
      DATA ISTART/0/
      IF( ISTART ) 1001,1000,1001
 1000 WRITE(6,600)
  600 FORMAT('0 FOR LGB-TDC NEW VERSION (LGBTDCA) IS USED.',/)
      ISTART = 1
C
 1001 CBTDC = 0.
      JFLLGT = 0
C
C---- RUN NUMBER
      NPHD2 = 2*IDATA( IBLN('HEAD') )
      IF( NPHD2.LE.0 ) GO TO 90
      NRUN = HDATA(NPHD2+9)*100000 + HDATA(NPHD2+10)
      IF( NRUN.LT.2010055 ) GO TO 90
C---- TOTAL BARREL ENERGY
      NPCL = IDATA( IBLN('LGCL') )
      IF( NPCL.LE.0 )  GO TO 90
C     GET THE RUN-BIN NUMBER
        DO 1 N=1,NMAX
        IF( NRUN.LE.NRUNBN(N) ) GO TO 2
    1   CONTINUE
C
C---- CALIBRATION IS NOT READY YET.
      IFLLGT = 1
      N = NMAX
C
    2 TBASEN = TBASE(N)
C
C---- 'ATST' BANK
      NPATST = IDATA( IBLN('ATST') )*2
      IF( NPATST.EQ.0 ) GO TO 90
      BTDC = HDATA( NPATST+17 )
C---- CORECTION OF SLEWING
      ETOTB = ADATA( NPCL+12 )
      IF( ETOTB.LE.0. ) ETOTB = 0.045
CCC   CBTDC = 0.1*BTDC -33.25/SQRT(ETOTB) + 0.36*ETOTB -TBASEN
      CBTDC = 0.1*BTDC -33.25/SQRT(ETOTB) + 0.24*ETOTB -TBASEN
C
C---- CORECTION OF THETA.
      CALL CLOC( NPCL, 'LGCL', 1)
      NCLSB = IDATA(NPCL+8)
      IF( NCLSB.LE.0 ) GO TO 100
      IP3 = NPCL+IDATA(NPCL+3)-1
      NSTEP = IDATA(NPCL+25)
      ESHS = 0.
      ESTHS = 0
        DO 3 N=1,NCLST
        NB = IP3+(N-1)*NSTEP
        IF( IDATA(NB+1).NE.0 ) GO TO 4
        ESHS = ESHS + ADATA(NB+16)
        ESTHS = ESTHS + ADATA(NB+16)*ABS(ADATA(NB+11))
    3   CONTINUE
    4 IF(ESHS.LE.0 ) GO TO 90
      AVTH = ESTHS/ESHS
      DTTHET = 10.0/SQRT(1.0-AVTH**2)-10.0
      CBTDC = CBTDC-DTTHET
C
C---- TEST PLOT
CCC   CALL HFILL( 11, CBTDC, AVTH, 1.0)
C
  100 RETURN
C
   90 JFLLGT = 2
      RETURN
      END

C   20/12/85 807241307  MEMBER NAME  BANKLS   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BANKLS( INDEX, IPPATR )
C-----------------------------------------------------------------------
C
C    DISPLAY TABLE OF RESULTS FOR PATTERN RECOGNITION BANK "PATR"
C        IPO:          START ADRESS OF BANK CONTENT
C        NBK:          BOS NUMBER OF BANK
C        INDEX:        VIEW INDEX ACCORDING TO DISPLAY PROGRAM
C             J.OLSSON,   1.3.79                CHANGE 06.12.82
C             C.BOWDERY                         CHANGE 20.12.85
C             J.HAGEMANN                   LAST CHANGE 12.01.88
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
C
#include "cdata.for"
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CHEADR / HEAD(108)
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CWORK2 / HWORK(40),JNDEX,NTR,LTR,ITR,IPO,
     +                  ICNT,NBK,NCLST,NWPCL,
     +                  PMOM,PZ,PTRANS,RMS,NHTF,RAD,RAD1,THE,
     +                  PHI,XXX,YYY,SSS,IPP,IHO,IVE,
     +                  HSIGN,HDUM,NTRRES,IW52
C
      DATA  LNAME/'LGCL'/, HMINUS/'- '/
*** PMF 17/11/99: add variable needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*80
      EQUIVALENCE (cHWORK,HWORK(1))
      REAL SF/.75/
*** PMF(end)
CC
C------------------  C O D E  ------------------------------------------
C
      IFL = 0
      IF(DSPDTL(14).AND.ACMD.NE.0..AND.LSTCMD.NE.111.AND.LSTCMD.NE.112)
     $ IFL = 1
      IPP = IPO
      ICNT = 0
      JCNT = 0
      CALL CLOC(IMR20,'MUR2',0)
      CALL CLOC(IMR21,'MUR2',1)
C
      IMBOTH=IMR20*IMR21
C     IF(ACMD.NE.0.) IMBOTH=0
      IF(IMBOTH.EQ.0) GO TO 7704
      IPMUR2=IMR21
      IMSTEP=IDATA(IMR20+2)
7704  CONTINUE
      IF(DSPDTL(29)) ICNT = NTR
C
      XXX = XMIN
      YYY = YMIN+.76*(YMAX-YMIN) *1.05 ! PMF 20/11/99 add factor 1.05
      CALL XXXYYY(XXX,YYY,SSS,0)
      IF(DSPDTL(29)) GO TO 2117
C     IF(DSPDTL(14).AND.ACMD.NE.0.) GO TO 2277
      IF(IFL.NE.0) GO TO 2277
C
C                            IF OPT 46 IS ON AND OPT 13 IS OFF
C                            FOR PUBLICATION PICTURES WITHOUT CAPTIONS,
C                            SUPPRESS THE RESULTS HEADER.
C
      IF( DSPDTM(16)  .AND.  .NOT. DSPDTL(13) ) GO TO 221
C
        call setcol('TRCK')! PMF 24/11/99 set colour
        CALL CORE(HWORK,80)
        INAME = IDATA(IPPATR-3)
        WRITE(cHWORK,220) INAME,NBK,NTR ! PMF 17/11/99: UNIT=10 changed to cHWORK
220     FORMAT('BANK ',A4,I3,'  NR OF TRACKS ',I3)
        CALL SYSSYM(XXX,YYY,SSS,HWORK,31,0.)
C
221   IF( .NOT. DSPDTL(13) ) GO TO 2277
      YYY = YYY - 2.*SSS *sf ! PMF 20/11/99: add factor sf
      CALL CORE(HWORK,80)
      WRITE(cHWORK,219)         ! PMF 17/11/99: UNIT=10 changed to cHWORK
219   FORMAT('NR +-  RMSRFI RMSRZ/HIT  PHI')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,28,0.)
      YYY = YYY - 1.5*SSS *sf ! PMF 20/11/99: add factor sf
      CALL CORE(HWORK,80)
      WRITE(cHWORK,218)         ! PMF 17/11/99: UNIT=10 changed to cHWORK
218   FORMAT('PTOT  PLONG  PTRANS   COSTHE')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,28,0.)
      IF(IMBOTH.EQ.0) GO TO 2277
      YYY = YYY - 1.5*SSS *sf ! PMF 20/11/99: add factor sf
      CALL CORE(HWORK,80)
      WRITE(cHWORK,7706)        ! PMF 17/11/99: UNIT=10 changed to cHWORK
7706  FORMAT(' MUQUAL  CHIP  MUPR   PIPR')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,26,0.)
C
2277  IF(IFL.NE.0) YYY = YYY - 8.*SSS *sf ! PMF 20/11/99: add factor sf
C2277  IF(DSPDTL(14).AND.ACMD.NE.0.) YYY = YYY - 8.*SSS
C     IF(.NOT.DSPDTL(14).OR.ACMD.EQ.0.) YYY = YYY - 4.5*SSS
      IF(IFL.NE.0.AND.IMBOTH.NE.0) YYY = YYY - 1.5*SSS *sf ! PMF 20/11/99: add factor sf
      IF(IFL.EQ.0) YYY = YYY - 4.5*SSS *sf ! PMF 20/11/99: add factor sf
      SUMP = 0.
      SUMPT = 0.
      SUMPZ = 0.
      LADSUM = 0
200   ICNT = ICNT + 1
      JCNT = JCNT + 7
      IF(ICNT.GT.NTR) GO TO 21
      IF(JCNT.LT.187) GO TO 7702
      JCNT=-10000
      XXX = XMIN+.82*(XMAX-XMIN)*1.03 !PMF 20/1/99: add factor 1.03
      YYY = YMIN+.76*(YMAX-YMIN)*1.05 ! PMF 20/11/99 add factor 1.05
      CALL XXXYYY(XXX,YYY,SSS,0)
      YYY = YYY - 12.*SSS *sf ! PMF 20/11/99: add factor sf
      IF(LASTVW.EQ.2) YYY = YYY - 2.*SSS *sf ! PMF 20/11/99: add factor sf
7702  IPP = IPP + LTR
      CALL TRTEXT(IPPATR,IPP,XXX,YYY,SSS)
      IF( IMBOTH .EQ. 0  .OR.  .NOT. DSPDTL(13) ) GO TO 7703
      IQUALF=IDATA(IPMUR2+6)
      CHIP=ADATA(IPMUR2+11)
      AMUPR=ADATA(IPMUR2+25)
      PIPR=ADATA(IPMUR2+26)
      IPMUR2=IPMUR2+IMSTEP
C
C                             LSTCMD = 55 IS MUR2
C
      IF(IQUALF.LE.0.AND.LSTCMD.NE.55) GO TO 7703
      JCNT=JCNT+3
      IF(DSPDTL(14).AND.NTRRES.NE.IDATA(IPP+1).AND.NTRRES.NE.0) GO TO 7
      CALL CORE(HWORK,80)
      WRITE(cHWORK,7705) IQUALF,CHIP,AMUPR,PIPR ! PMF 17/11/99: UNIT=10 changed to cHWORK
7705  FORMAT(I5,F8.2,F6.2,F7.3)
      YYY=YYY+0.5*SSS *sf ! PMF 20/11/99: add factor sf
      CALL SYSSYM(XXX,YYY,SSS,HWORK,26,0.)
      YYY=YYY-2.0*SSS *sf ! PMF 20/11/99: add factor sf
      GO TO 7703
7     YYY = YYY - 1.5*SSS *sf ! PMF 20/11/99: add factor sf
7703  CONTINUE
C     IF(DSPDTL(14).AND.ACMD.NE.0.) GO TO 200
      IF(IFL.NE.0) GO TO 200
      SUMP = SUMP + PMOM
      SUMPT = SUMPT + PTRANS
      SUMPZ = SUMPZ + ABS(PZ)
      LADSUM = LADSUM + 1
      IF(HSIGN.EQ.HMINUS) LADSUM = LADSUM - 2
      GO TO 200
21    ICNT = ICNT - 1
      JCNT = JCNT - 7
2117  IF(.NOT.DSPDTL(28).AND..NOT.DSPDTL(29)) GO TO 2121
C                            LSTCMD = 52 IS VRES
      IF(LSTCMD.EQ.52.AND.IW52.EQ.0) GO TO 2121
      IF(NTRRES.NE.0) GO TO 2121
C
C                            WRITE RESULTS FOR LEAD GLASS CLUSTERS
C
      IPLGCL = IDATA(IBLN('LGCL'))
      IF(IPLGCL.EQ.0) GO TO 2121
      NBK = IDATA(IPLGCL-2)
      NWPCL = IDATA(IPLGCL+25)
      IPP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      NCLST = IDATA(IPLGCL+7)
      ISTEP = IDATA(IPLGCL+21)
      IPPATR=IDATA(IBLN('PATR'))
      IPALGN=IDATA(IBLN('ALGN'))
      IF(ISTEP.NE.2) CALL LGCDIR(IPPATR,IPALGN,IPLGCL)
      IF(JCNT.LT.172) GO TO 2118
      JCNT=-10000
      XXX = XMIN+.82*(XMAX-XMIN)*1.03 !PMF 20/1/99: add factor 1.03
      YYY = YMIN+.76*(YMAX-YMIN)*1.05 ! PMF 20/11/99 add factor 1.05
      CALL XXXYYY(XXX,YYY,SSS,0)
      YYY = YYY - 9.*SSS *sf ! PMF 20/11/99: add factor sf
      IF(LASTVW.EQ.2) YYY = YYY - 2.*SSS *sf ! PMF 20/11/99: add factor sf
2118  YYY = YYY - 3.*SSS *sf ! PMF 20/11/99: add factor sf
C
C                            IF OPT 46 IS ON AND OPT 13 IS OFF
C                            FOR PUBLICATION PICTURES WITHOUT CAPTIONS,
C                            SUPPRESS THE RESULTS HEADER.
C
      IF( DSPDTM(16)  .AND.  .NOT. DSPDTL(13) ) GO TO 2201
C
        call setcol('ECAL')! PMF 24/11/99 set colour
        CALL CORE(HWORK,80)
        WRITE(cHWORK,2200) LNAME,NBK,NCLST ! PMF 17/11/99: UNIT=10 changed to cHWORK
2200    FORMAT('BANK ',A4,I2,' NR OF CLUSTERS',I3)
        CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
C
2201  YYY = YYY - 2.*SSS *sf ! PMF 20/11/99: add factor sf
      IF( .NOT. DSPDTL(13) ) GO TO 2121
      IGMX = 0
      IICNT = 0
2000  ICNT = ICNT + 1
      JCNT = JCNT + 7
      IICNT = IICNT + 1
      IF(ICNT.GT.NCLST+NTR) GO TO 2121
      IF(JCNT.LT.182) GO TO 7712
      JCNT=-10000
      XXX = XMIN+.82*(XMAX-XMIN)*1.03 !PMF 20/1/99: add factor 1.03
      YYY = YMIN+.76*(YMAX-YMIN)*1.05 ! PMF 20/11/99 add factor 1.05
      CALL XXXYYY(XXX,YYY,SSS,0)
      YYY = YYY - 12.*SSS *sf ! PMF 20/11/99: add factor sf
      IF(LASTVW.EQ.2) YYY = YYY - 2.*SSS *sf ! PMF 20/11/99: add factor sf
7712  IPP = IPP + NWPCL
      IF(IDATA(IPP+8).EQ.0) IGMX = IGMX + 1
      CALL GMTEXT(IPP,NTRRES,IICNT,IGMX)
      GO TO 2000
2121  CONTINUE
C     IF(DSPDTL(14).AND.ACMD.NE.0.) RETURN
      IF(IFL.NE.0) RETURN
C
C                            WRITE OUT SUMS
C
      XXX = XMIN+.33*(XMAX-XMIN)
      YYY = YMIN+.01*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,1)
      IF(DSPDTL(29).AND.IPLGCL.NE.0) GO TO 2119
      IF(DSPDTL(29)) RETURN
C
C                            IF OPT 46 IS ON AND OPT 13 IS OFF
C                            FOR PUBLICATION PICTURES WITHOUT CAPTIONS,
C                            SUPPRESS THE SUMS PRINTOUT.
C
      IF( DSPDTM(16)  .AND.  .NOT. DSPDTL(13) ) RETURN
C
      CALL CORE(HWORK,80)
      call setcol('TEXT')! PMF 24/11/99: set colour
      WRITE(cHWORK,865) SUMP,SUMPT,SUMPZ,LADSUM ! PMF 17/11/99: UNIT=10 changed to cHWORK
865   FORMAT(' *** SUMS (GEV) ***    PTOT ',F7.3,'   PTRANS ',F7.3,
     $' PLONG ',F7.3,' CHARGE ',I3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,77,0.)
C
      IF(.NOT.DSPDTL(28).OR.IPLGCL.EQ.0) goto 999!RETURN
C
      YYY = YYY - 1.5*SSS *sf ! PMF 20/11/99: add factor sf
 2119 CALL CORE(HWORK,80)
      call setcol('TEXT')! PMF 24/11/99: set colour
      WRITE(cHWORK,866)
     +     ADATA(IPLGCL+11),ADATA(IPLGCL+16),IDATA(IPLGCL+15) ! PMF 17/11/99: UNIT=10 changed to cHWORK
866   FORMAT(' TOTAL CLUSTER ENERGY ',F7.3,'  PHOTON ENERGY ',F7.3,' NR
     $OF PHOTONS ',I3)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,70,0.)
C
 999  continue
      call setcol(' ')! PMF 24/11/99: reset colour
      RETURN
      END

C   10/10/84 807241745  MEMBER NAME  DSVAC    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DSVAC
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   19/10/84 :  MAIN PROGRAM FOR DRAWING
C                                        SIGNAL AMPLITUDES FOR A
C                                        SELECTED CELL IN VERTEX CHAMBER
C
C       MOD:   J. HAGEMANN   22/04/85 :  CHANGES DUE TO NEW MICRO-
C                                        PROCESSOR ONLINE PROGRAM
C       MOD:   J. HAGEMANN   12/07/85 :  CODE SPEEDED UP, SUBROUTINE
C                                        GETINT NOW IN OWN MEMBER,
C                                        CHANGES DUE TO NEW MICRO-
C                                        PROCESSOR ONLINE PROGRAM AND
C                                        FOR DIFFERENCIATED PULSES
C  LAST MOD:   J. HAGEMANN   13/02/86 :  FOR BANK VCVW
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LSEP, LDIF, LVIEW, FLVCDO
C
      INTEGER*4 CONVRT
C
#include "cgraph.for"
#include "cdata.for"
#include "cjvcel.for"
C
      COMMON / CGVCDO / FLVCDO(20)
      COMMON / CWORK1 / HAMP(2,60), HSTORE(2,420), ISCLOW, ISCHIG
      COMMON / CHEADR / HEAD(108)
      COMMON / CVX    / NNPATR,NDUMM,NNJETC,NNVTXC
C
      DIMENSION IHA(150), HBYTE(150)
C
C-----------------  C O D E  -------------------------------------------
C
C                            CHECK IF MONTE CARLO DATA
      IF( HEAD(18) .GT. 100 ) GO TO 5
         CALL TRMOUT(80,' VAC  not available for MONTE CARLO DATA^')
         RETURN
C                                      TEST IF RAW DATA BANK  B P C H
C                                      IS EXISTING
    5 IPBPCH = IDATA(IBLN('BPCH'))
      IF( IPBPCH .LE. 0 )  RETURN
C
      ISCLOW = 0
      ISCHIG = 64
      LVIEW  = .FALSE.
C
      IF( NNVTXC .LT. 0 .OR. NNVTXC .GT. 99 ) GO TO 50
         CALL CLOC( IPVCVW, 'VCVW', NNVTXC )
         LVIEW = .TRUE.
         IF( IPVCVW .GT. 0 ) GO TO 55
            LVIEW = .FALSE.
            IF( NNVTXC .NE. 10 )
     &      WRITE(6,40) NNVTXC
   40       FORMAT(' VCVW BANK NR',I3,' (GIVEN BY COMMAND VTXC) NOT EXIS
     &TING')
C
   50 ILBPCH = IDATA(IPBPCH)
C
      IF( ILBPCH .LE. 1 ) RETURN
C
   55 LDIF = .FALSE.
      NC   = ACMD
      IF( NC .GT. 0 ) GO TO 65
   60    CALL TRMOUT(80,' Enter Cell Number^')
         CALL TRMIN( 4, ICD )
         CALL GETINT( ICD, NC )
   65 IF( NC .LT. 100 ) GO TO 70
          NC = NC - 100
          LDIF = .TRUE.
   70 IF( NC .GT. 0 .AND. NC .LT. 25 ) GO TO 80
         CALL TRMOUT(80,' Illegal Cell Number^')
         GO TO 60
   80 CALL ERASE
      CALL TWINDO(0,4095,0,4095)
C
      DO 95 I = 1, 2
         DO 90 J = 1, 420
            HSTORE( I, J ) = 0
   90    CONTINUE
   95 CONTINUE
C
      NWLOW  = NC*MWIRE - 6
      NWHIG  = NC*MWIRE
C                                      FOR VCVW BANK DISPLAY
      IF( LVIEW ) GO TO 2000
C
      IPHVCR = IPBPCH*2
      ILHVCR = ILBPCH*2
      IAPOIN = IPHVCR + 2
      ILSUMP = 0
C
  100 ILMPST = HDATA(IAPOIN + 1)/2
      IVERS  = HDATA(IAPOIN + 6)/1024
C                            CHECK IF MP-STRING IS CORRECT
         IF( HDATA(IAPOIN + ILMPST) .NE. -2 ) GO TO 200
            GO TO 400
  200    IF( HDATA(IAPOIN + ILMPST) .NE. -1  .OR.
     &       HDATA(IAPOIN + ILMPST - 1) .NE. -2 ) GO TO 900
C
C                            PROCESS MICROPROCESSOR-STRING
C
  400       IPMPST = IAPOIN + 6
            ILSUMW = 0
C
C                  MAIN LOOP TO PROCESS WIRESIDE-STRING
C                            GET WIRESIDE-STRING LENGTH
  500       ILWSID = HDATA( IPMPST+1 )/2
C                  CHECK IF WIRESIDE STRING IS CORRECT
            IF( HDATA( IPMPST + ILWSID) .NE. -8 ) GO TO 750
C                            PROCESS WIRESIDE-STRING
            IPWSID = IPMPST + 2
C                            GET WIRESIDE NUMBER AND WIRE NUMBER
            NWSID = HDATA( IPWSID )
            NWIR  = (CONVRT(NWSID) + 1)/2
C                            CHECK IF WIRE IS IN SELECTED CELL
            IF( NWIR .LT. NWLOW .OR. NWIR .GT. NWHIG ) GO TO 730
C                            GET CELL NUMBER AND WIRE NUMBER WITHIN CELL
            NCEL  = (NWIR - 1)/MWIRE
            NWRC  = NWIR - NCEL*MWIRE
C
            ISIDE  = LAND(NWSID,1) + 1
C
            ILSUMH = 0
C
            IPDSTA = 1
C
           DO 505 I = 1, 150
              HBYTE(I) = 0
  505      CONTINUE
C
            IEND   = ILWSID - 3
C                            CONVERT BYTES IN WIRESIDE-STRING INTO I*2
            DO 510 I = 1, IEND
               IHB = I*2 - 1
               ILB = I*2
C
*** PMF 10/06/99
***            HBYTE(IHB) = LAND( HDATA( IPWSID + I ), 65280 )/256
***            HBYTE(ILB) = LAND( HDATA( IPWSID + I ), 255 )
               HBYTE(IHB) = hLAND( HDATA( IPWSID + I ), hint(65280))/256
               HBYTE(ILB) = hLAND( HDATA( IPWSID + I ), hint(255))
*** PMF (end)
C
  510       CONTINUE
C
C                  MAIN LOOP TO PROCESS HIT
C
            IPHELP = 0
C
  550       DO 570 I = 1, 75
               IHA(I) = HBYTE( IPHELP + I )
C
               IF( IHA(I) .LT. 248 ) GO TO 570
                  ILHIT = I
                  IENDO = I
                  GO TO 580
C
  570       CONTINUE
C
C
  580          IF( HEAD(18) .GT. 18778 ) GO TO 581
                  NCHA   = IHA(1)/2
                  IPEDAL = IHA( 2 ) - 2
                  GO TO 582
  581          NCHA   = IHA(2)/2
               IPEDAL = IHA( 3 ) - 2
               IF( HEAD(18) .GT. 19121 ) IPEDAL = (IHA(3) + 2)/4
C
  582          IPDEND = NCHA
CCCCC          IF( IVERS .GT. 4 ) IPDEND = IPDEND - 1
C
               DO 585 I = IPDSTA, IPDEND
                  IPFILL = (NWRC - 1)*60 + I
                  HSTORE( ISIDE, IPFILL ) = 300 + IPEDAL
  585          CONTINUE
C
               IPHS = 0
CCCCC          IF( IVERS .GT. 4 ) IPHS = -1
C
               IBEGO = 4
               IF( IVERS .GT. 4 ) IBEGO = 5
C
               DO 590 I = IBEGO, IENDO
                  IF( IHA(I) .GT. 247 ) GO TO 600
                     IF( IHA(I) .EQ. 240 ) GO TO 590
                        IPHS   = IPHS + 1
                        IPFILL = (NWRC - 1)*60 + NCHA + IPHS
                        HSTORE( ISIDE, IPFILL ) = IHA(I)
  590          CONTINUE
C
  600          IPDSTA = NCHA + IPHS + 1
C
C
               ILSUMH  = ILSUMH + ILHIT
C
               IF( ILSUMH .GT. (ILWSID*2 - 6) ) GO TO 700
C
                  IF( ILSUMH .EQ. (ILWSID*2 - 6) .OR.
     &                ILSUMH .EQ. (ILWSID*2 - 7) ) GO TO 700
                     IPHELP = IPHELP + ILHIT
                     GO TO 550
C                            LOAD PEDESTAL AFTER LAST HIT
  700       CONTINUE
            DO 720 I = IPDSTA, 60
               IPFILL = (NWRC - 1)*60 + I
               HSTORE( ISIDE, IPFILL ) = 300 + IPEDAL
  720       CONTINUE
C                            CHECK IF LAST WS-STRING
C
  730       ILSUMW = ILSUMW + ILWSID
C                            SAFETY CHECK IF END OF MP-STRING
            IF( ILSUMW .GT. (ILMPST-7) ) GO TO 800
C                            LAST WIRESIDE-STRING ?
               IF( ILSUMW .EQ. (ILMPST-7) .OR. ILSUMW .EQ. (ILMPST-8) )
     &                                         GO TO 800
                 IPMPST = IPMPST + ILWSID
                 GO TO 500
  750       CALL TRMOUT(80,' ERROR in Wireside-String^')
C
C                            CHECK IF LAST MP-STRING
C
  800       ILSUMP = ILSUMP + ILMPST
C                            SAFETY CHECK IF END OF BANK
            IF( ILSUMP .GT. ILHVCR-2 ) GO TO 8000
C                            LAST MP-STRING ?
            IF( ILSUMP .EQ. ILHVCR-2 .OR. ILSUMP .EQ. ILHVCR-3 )
     &                                               GO TO 8000
               IAPOIN = IAPOIN + ILMPST
               GO TO 100
  900    CALL TRMOUT(80,' ERROR in Microprocessor-String^')
         GO TO 8000
C
C                                      FOR VCVW BANK DISPLAY
 2000 IPVCV2 = IPVCVW*2
      ILVCV2 = IDATA(IPVCVW)*2
      ISCLOW = HDATA(IPVCV2+4)
      ISCHIG = HDATA(IPVCV2+5)
C
      IPARRY = IPVCV2 + HDATA(IPVCV2+1)
C
 2100 ILENWS = HDATA(IPARRY+1)
      INUMWS = HDATA(IPARRY+2)
      IWIRE  = (CONVRT(INUMWS) + 1)/2
C                                      CHECK IF WIRE IS IN SELECTED CELL
      IF( IWIRE .LT. NWLOW .OR. IWIRE .GT. NWHIG ) GO TO 2500
C                                      GET CELL NUMBER AND WIRE NUMBER
C                                      WITHIN CELL
         NCEL  = (IWIRE - 1)/MWIRE
         NWRC  = IWIRE - NCEL*MWIRE
C
         ISIDE = LAND(INUMWS,1) + 1
C
         ILINF = ILENWS - 2
C
         ICAN  = 1
C
         DO 2300 I = 1, ILINF
            IPWSI = IPARRY + 2 + I
            IWRD  = HDATA(IPWSI)
            IF( IWRD .LT. 200) GO TO 2200
               IWRD1 = IWRD/200
               IREP  = IWRD1
               DO 2150 INA = 1, IREP
                  IADD   = ICAN-1 + INA
                  IF( IADD .LE. 60 ) GO TO 2140
                     WRITE(6,9100) INUMWS
 9100                FORMAT(' DSVAC : ERROR IN WS',I4,'  IN VCVW BANK')
                     GO TO 2500
 2140             IPFILL = (NWRC - 1)*60 + IADD
                  HSTORE( ISIDE, IPFILL ) = IWRD - IWRD1*200
 2150          CONTINUE
               GO TO 2250
 2200       IF( ICAN .LE. 60 ) GO TO 2230
               WRITE(6,9100) INUMWS
               GO TO 2500
 2230       IPFILL = (NWRC - 1)*60 + ICAN
            HSTORE( ISIDE, IPFILL ) = IWRD
            IREP  = 1
 2250       ICAN = ICAN + IREP
 2300    CONTINUE
C
 2500 IPARRY = IPARRY + ILENWS
      IF( HDATA(IPARRY+1) .LE. 0 ) GO TO 8000
         IF( IPARRY .LT. IPVCV2+ILVCV2 ) GO TO 2100
C
 8000 LSEP = FLVCDO(6)
C
 8100 CONTINUE
C
      CALL KOORD( LSEP, NC, LDIF, LVIEW )
      DO 8200 I = 1, MWIRE
         CALL DRWHIT( I, LSEP, LDIF, NWLOW-1 + I )
 8200 CONTINUE
C
 8300 CALL SETSCL(LASTVW)
C
      RETURN
      END

C   26/01/88 801271425  MEMBER NAME  TPREDC   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPREDC( REJECT )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      26/01/88:  Do optional event reduction
C
C
C
C     Routine to handle event reduction if wanted.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     REJECT    Out      L*4      TRUE if event has been 'rejected'
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  REDUCE, REJECT

      REAL     EBEFIX

C------------------  C O D E  ------------------------------------------

C                            Get instruction about event reduction

      CALL TPEVI3( REDUCE )

      IF( REDUCE ) THEN

        EBEFIX = 0.0
        CALL MCREDU( EBEFIX, *10 )

      ENDIF

      REJECT = .FALSE.

      RETURN

C                            Alternate return means event rejected

 10   REJECT = .TRUE.

      RETURN
      END

      SUBROUTINE JFXYRZ(IPTR,NH1,LRFLAG,NSAME,ICJ,XYRZ)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "calibr.for"
#include "cjdrch.for"
#include "cdsmax.for"
      DIMENSION XYRZ(6)
      DATA NCOAR / 15/, DTGB / .15/
      REAL TGCOAR(15) /-99.,-.45, 12*0., 99./
      REAL T0COAR(60) / .000, .000, .000, .000, .000,
     ,     .000, .000,-.020,-.060,-.130,-.030, .100, .200, .200, .200,
     ,                  .000, .000, .010, .110, .100,
     ,     .075, .050, .025, .005, .015, .065, .060, .060, .060, .060,
     ,                  .190, .190, .180, .165, .140,
     ,     .120, .100, .075, .050, .010,-.050,-.075,-.035, .000, .000,
     ,                  .110, .110, .115, .140, .135,
     ,     .085, .045, .030, .040, .050, .055, .055, .055, .055, .055/
      REAL SLCOAR(60) / 60*0./
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 1
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      ITRK = IDATA(IPTR+1)
      IF(
     - NSAME.EQ.0
     -)THEN
      IF(
     - IDATA(IPTR+18).EQ.1
     -)THEN
          ALFA  = ADATA(IPTR+21)
          CRV   = ADATA(IPTR+19)
          IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
          RAD   =  1./CRV + ADATA(IPTR+20)
          XCIRC = COS(ALFA) * RAD
          YCIRC = SIN(ALFA) * RAD
          CHARGE = SIGN(1.,ADATA(IPTR+25))
      ELSE
          CRV   = ADATA(IPTR+22)*2.
          IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
          ALFA  = ADATA(IPTR+19)
          XCIRC =-SIN(ALFA)/CRV + ADATA(IPTR+20)
          YCIRC = COS(ALFA)/CRV + ADATA(IPTR+21)
          CHARGE =-SIGN(1.,ADATA(IPTR+22))
      ENDIF
        ZVERT = ADATA(IPTR+31)
        TGTH = ADATA(IPTR+30)
        CSTHI = SQRT(TGTH**2 + 1.)
        CSTH  = 1. / CSTHI
        SNTH  = CSTH * TGTH
      ENDIF
                 JCELL=ICJ
      IF(
     - JCELL.NE.JCOLD
     -)THEN
                    JCOLD=JCELL
                    JRING=1
                    IF(JCELL.GT.24) JRING=2
                    IF(JCELL.GT.48) JRING=3
      IF(
     - JRING.NE.3
     -)THEN
          IC1 = JCELL
          IF(IC1.GT.24) IC1 = IC1 - 24
          CSROT0 = DIRWR1(IC1,1)
          SNROT0 = DIRWR1(IC1,2)
      ELSE
          IC1 = JCELL - 48
          CSROT0 = DIRWR3(IC1,1)
          SNROT0 = DIRWR3(IC1,2)
      ENDIF
        DRICS  = TRMATC(JCELL,2)
        DRISN  = TRMATS(JCELL,2)
        DRITG  = DRISN/DRICS
        DRISNF = DRISN * .05
        R0 = FSENSW(JRING)
        DR = RINCR (JRING)
        R1   = DR*7.5 + R0
        DX   = R1 * CSROT0 - XCIRC
        DY   = R1 * SNROT0 - YCIRC
        RR   = SQRT(DX**2 + DY**2) * CHARGE
        CSB  = DX / RR
        SNB  = DY / RR
        TGB  = CSB/SNB
        DSBIN1 = DRIVEL(JCELL,1)
        TANBET = (DRITG - TGB) / (TGB*DRITG + 1.)
      IF(
     - NRUN.LE.100
     -)THEN
          DS0 = DSBIN1*.5
          T0CORR = 0.
      ELSE
          DS0 = T0FIX(JRING)*DSBIN1*64.
      DO 13000 I1=1,NCOAR
            IDX = I1
      IF(
     - TANBET.LT.TGCOAR(IDX)
     -)THEN
      GOTO 13001
      ENDIF
13000 CONTINUE
13001 CONTINUE
          KRNG = JRING
          IF(KRNG.EQ.3 .AND. lAND(JCELL,1).EQ.0) KRNG = 4 ! PMF 11/06/99: land
          IBIN = (KRNG-1)*NCOAR  + IDX
          T0CORR = (TANBET-TGCOAR(IDX)) * SLCOAR(IBIN) + T0COAR(IBIN)
      ENDIF
        IPJCOR = ICALIB(5) + JCELL
        CCST01 = ACALIB(IPJCOR     ) * ABS(TANBET)
        CCST02 = ACALIB(IPJCOR+  96) * ABS(TANBET)
        CCST11 = ACALIB(IPJCOR+ 192)
        CCST12 = ACALIB(IPJCOR+ 288)
        CCST21 = ACALIB(IPJCOR+ 384)
        CCST22 = ACALIB(IPJCOR+ 480)
        CCST51 = ACALIB(IPJCOR+ 576) * 10.
        CCST52 = ACALIB(IPJCOR+ 672) / 121.15
        CCST61 = ACALIB(IPJCOR+ 768) * 10.
        CCST62 = ACALIB(IPJCOR+ 864) / 121.15
        CCST81 = ACALIB(IPJCOR+1152)
      ENDIF
        IP=NH1
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            ILAY = IAND(IWIR,15)
            IAMPL = HDATA(IP+1)
            IAMPR = HDATA(IP+2)
            DS =(HDATA(IP+3)) * DSBIN1
            X1   = ILAY * DR + R0
            Z1   = X1*TGTH + ZVERT
            DDS = (1222.9-ABS(Z1))*ABERR(1) + ABERR(6)*R1*CSTHI
            DGR = ((Z1/1222.9)**2 - 1.) * .075
            DSC =  DS - DDS + DS0
            Y1   = SWDEPL
            IF(IAND(ILAY,1).NE.0) Y1 =-Y1
            Y1   = (7.5-ILAY)*(CCST52*Z1+CCST51) - CCST62*Z1-CCST61 + Y100039200
            X    = X1*CSROT0 - Y1*SNROT0
            Y    = X1*SNROT0 + Y1*CSROT0 - DGR
      IF(
     - DSC.LE.DRC
     -)THEN
      IF(
     - DSC.LT.DSD2
     -)THEN
      IF(
     - DSC.LT.DSD1
     -)THEN
                  DSC = DSC + DDS1 + (DSC-DSD1)*DRV1
      ELSE
                  DSC = DSC + DDS2 + (DSC-DSD2)*DRV2
      ENDIF
                IF(DSC.LT.0.1) DSC = 0.1
      ELSE
                DSC = (DSC-DSD2)/(DRC-DSD2) * T0CORR + DSC
      ENDIF
              DXR  = DSC * CSB
              DYR  = DSC * SNB
              DXL =-DXR
              DYL =-DYR
      ELSE
              DSC = DSC + T0CORR
      IF(
     - ILAY.LT. 3
     -)THEN
                DILAY =-(ILAY- 3)**2
                DSCL  = (DILAY*CCST11 + 1.) * DSC * (1. - CCST81)
                DSCR  = (DILAY*CCST12 + 1.) * DSC * (1. + CCST81)
      ELSE
      IF(
     - ILAY.GT.12
     -)THEN
                DILAY =-(ILAY-12)**2
                DSCL  = (DILAY*CCST21 + 1.) * DSC * (1. - CCST81)
                DSCR  = (DILAY*CCST22 + 1.) * DSC * (1. + CCST81)
      ELSE
                DSCL = DSC * (1. - CCST81)
                DSCR = DSC * (1. + CCST81)
      ENDIF
      ENDIF
      IF(
     - DSC.GT.ABERR(7)
     -)THEN
                DWIR  = ILAY - 7.5
                DWIRC = DSC*DRISNF
                DWIRL = DWIR + DWIRC
                DWIRR = DWIR - DWIRC
                DSCL  = (DSCL-ABERR(7))*DWIRL*CCST01 + DSCL
                DSCR  =-(DSCR-ABERR(7))*DWIRR*CCST02 + DSCR
      ENDIF
              DXR  = (DSCR-DRC)*DRISN + DRC*CSB
              DYR  = (DSCR-DRC)*DRICS + DRC*SNB
              DXL  =-(DSCL-DRC)*DRISN - DRC*CSB
              DYL  =-(DSCL-DRC)*DRICS - DRC*SNB
      ENDIF
            XXL  = DXL + X
            YYL  = DYL + Y
            XXR  = DXR + X
            YYR  = DYR + Y
      IF(
     - LRFLAG.EQ.1
     -)THEN
         XYRZ(1)=XXR
         XYRZ(2)=YYR
         XYRZ(3)=XXL
         XYRZ(4)=YYL
      ELSE
         XYRZ(1)=XXL
         XYRZ(2)=YYL
         XYRZ(3)=XXR
         XYRZ(4)=YYR
      ENDIF
      XYRZ(5)=SQRT(XYRZ(1)**2+XYRZ(2)**2)
      XYRZ(6)=ZVERT+TGTH*XYRZ(5)
      RETURN
17000 CONTINUE
        IQJETC = IBLN('JETC')
        IQHEAD = IBLN('HEAD')
        DRC = RINCR(1)*.5 * DRICOS
        IPHEAD = IDATA(IQHEAD)*2
        NRUN = HDATA(IPHEAD+10)
      IF(
     - NRUN.LE.100
     -)THEN
          DSD0   = .0
          DSD1   = .0
          DSD2   = .0
          DDS0   = .0
          DDS1   = .0
          DDS2   = .0
          DRV1   = .0
          DRV2   = .0
      ELSE
          DSD0   =-0.400
          DSD1   = 0.300
          DSD2   = 2.500
          DDS0   = 0.720
          DDS1   = 0.330
          DDS2   = 0.0
          DRV1   = (DDS0-DDS1) / (DSD0-DSD1)
          DRV2   = (DDS1-DDS2) / (DSD1-DSD2)
      ENDIF
        I9 = NCOAR - 1
      DO 13002 I1=2,I9
          IF(I1.GT.2) TGCOAR(I1   ) = TGCOAR(I1- 1) + DTGB
          SLCOAR(I1   ) = (T0COAR(I1   )-T0COAR(I1- 1)) / DTGB
          SLCOAR(I1+15) = (T0COAR(I1+15)-T0COAR(I1+14)) / DTGB
          SLCOAR(I1+30) = (T0COAR(I1+30)-T0COAR(I1+29)) / DTGB
          SLCOAR(I1+45) = (T0COAR(I1+45)-T0COAR(I1+44)) / DTGB
13002 CONTINUE
13003 CONTINUE
      GOTO IZZZ01
      END

      SUBROUTINE ZRFIT
      IMPLICIT INTEGER*2 (H)
C-------------------------------
C  MACRO CHEADR .... HEADER BANK
C-------------------------------
      COMMON /CHEADR/ IHEADR(54)
      INTEGER*2 HHEADR(108)
      EQUIVALENCE (IHEADR(1),HHEADR(1))
C --
C --  HHEADR(17) = EXPERIMENT NUMBER
C --  HHEADR(18) = RUN NUMBER
C --  HHEADR(19) = EVENT NUMBER
C --  HHEADR(38) = MAGNETIC FIELD (GAUSS)
C --
C--------- END OF MACRO CHEADR ------------
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      DIMENSION SUM(10),HIST(200)
      EQUIVALENCE
     ,           (ICELL ,ADWRK(1)),(NHIT  ,ADWRK(2)),(IRING ,ADWRK(3))
     ,         , (IERRCD,ADWRK(4)),(NTRKEL,ADWRK(5))
     ,         , (SUM(1),ADWRK(101))
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      DATA SBRAT/2./, NPKMIN /4/, NBINZ/200/
      IERRLB = 0
      IP0 = HPHT0
      IP9 = HPHT9
      IDP = HLDHT
      IP8 = IP9 - IDP + 1
      Z0 = .5*(WRK(IP0+5)+WRK(IP9-IDP+6))
      R0 = .5*(WRK(IP0+6)+WRK(IP9-IDP+7))
      ZMAXLM = ZMAX + 20.
      NHIT = 0
      NBAD = 0
      DO 13000 IP=HPHT0,HPHT9,HLDHT
        IF(IWRK(IP+ 7).GE.10) IWRK(IP+7) = 16
        IF(ABS(WRK(IP+ 5)).GE.ZMAXLM) IWRK(IP+7) = 16
        IF(IWRK(IP+10).NE. 0) IWRK(IP+7) = LOR(IWRK(IP+7),8)
        IF(IWRK(IP+ 7).EQ. 0) NHIT = NHIT + 1
        IF(IWRK(IP+ 7).LT.16) NBAD = NBAD + 1
13000 CONTINUE
13001 CONTINUE
      NBAD = NBAD - NHIT
      IF(
     - NHIT.LT.16 .AND. NBAD.GE.8
     -)THEN
      NHIT = 0
      DO 13002 IP=HPHT0,HPHT9,HLDHT
      IF(
     - IWRK(IP+ 7).LT.16 .AND. IWRK(IP+10).EQ.0
     -)THEN
            IWRK(IP+7) = 0
            NHIT = NHIT + 1
      ENDIF
13002 CONTINUE
13003 CONTINUE
      ENDIF
      IF(
     - NHIT.LT.3
     -)THEN
        IWRK(HPTR0+28) = 1
        WRK (HPTR0+29) = 0.
        WRK (HPTR0+30) = 0.
        WRK (HPTR0+31) = 1000000.
        IWRK(HPTR0+32) = 0.
        IWRK(HPTR0+47) = LOR(IWRK(HPTR0+47),384)
        RETURN
      ENDIF
      IF(
     - LAND(LMZFIT(10),1).NE.0
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      IF(
     - LAND(LMZFIT(10),2).NE.0
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      ENDIF
      NITER = 0
16000 CONTINUE
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
        A1SV   = A1
        B1SV   = B1
        RMSSV  = RMS
        NDEGSV = NDEG
      IF(
     - RMS.LE.ZFITLM(1) .OR. NDEG.LT.6
     -)THEN
      GOTO 16001
      ENDIF
      IF(
     - LAND(LMZFIT(10),1).EQ.0
     -)THEN
      ASSIGN 17006 TO IZZZ01
      GOTO 17000
17006 CONTINUE
      ELSE
      ASSIGN 17008 TO IZZZ04
      GOTO 17007
17008 CONTINUE
      ENDIF
      IF(
     - NBAD.EQ.0
     -)THEN
      GOTO 16001
      ENDIF
      ASSIGN 17009 TO IZZZ03
      GOTO 17004
17009 CONTINUE
      IF(
     - RMS.LE.ZFITLM(1)
     -)THEN
          A1SV   = A1
          B1SV   = B1
          RMSSV  = RMS
          NDEGSV = NDEG
          DZMAX = ZFITLM(2)*3
      ASSIGN 17011 TO IZZZ05
      GOTO 17010
17011 CONTINUE
      GOTO 16001
      ENDIF
      NITER = NITER + 1
      IF(.NOT.(
     - NITER.GE.1
     -))GOTO 16000
16001 CONTINUE
      IF(RMS.GT.ZFITLM(1) .OR. NDEG.LT.6) IERRLB = LOR(IERRLB,128)
      IWRK(HPTR0+28) = 1
      WRK (HPTR0+29) = B1SV
      WRK (HPTR0+30) = A1SV
      WRK (HPTR0+31) = RMSSV
      IWRK(HPTR0+32) = NDEGSV+2
      IWRK(HPTR0+47) = LOR(IWRK(HPTR0+47),IERRLB)
      RETURN
17010 CONTINUE
        NBAD = 0
        NGOOD = 0
      DO 13004 IPHIT = HPHT0,HPHT9,HLDHT
      IF(
     - IWRK(IPHIT+7).LE.8
     -)THEN
            R1 = WRK(IPHIT+6)
            Z1 = WRK(IPHIT+5)
            ZF = R1*B1 + A1
            DZ = Z1 - ZF
      IF(
     - ABS(DZ).GT.DZMAX
     -)THEN
              NBAD = NBAD + 1
              IWRK(IPHIT+7) = 1
      ELSE
              NGOOD = NGOOD + 1
              IWRK(IPHIT+7) = 0
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - NGOOD.LT.LMZFIT(3)
     -)THEN
      DO 13006 IP1 = IP0,IP9,IDP
          IWRK(IP1+7) = LAND(IWRK(IP1+7),14)
13006 CONTINUE
13007 CONTINUE
        NBAD = 0
      ENDIF
      GOTO IZZZ05
17007 CONTINUE
        NBAD = 0
        NGOOD = 0
      DO 13008 IPHIT = HPHT0,HPHT9,HLDHT
      IF(
     - IWRK(IPHIT+7).LT.4
     -)THEN
      IF(
     - IABS(IWRK(IPHIT+8)).GE.1000
     -)THEN
              NBAD = NBAD + 1
              IWRK(IPHIT+7) = LOR(IWRK(IPHIT+7),4)
      ELSE
              NGOOD = NGOOD + 1
              IWRK(IPHIT+7) = 0
      ENDIF
      ENDIF
13008 CONTINUE
13009 CONTINUE
      GOTO IZZZ04
17004 CONTINUE
        IHIT = 0
        SUM(1) = 0.
        SUM(2) = 0.
        SUM(3) = 0.
        SUM(4) = 0.
        SUM(5) = 0.
      DO 13010 IPHIT = IP0,IP9,IDP
      IF(
     - IWRK(IPHIT+7).EQ.0
     -)THEN
            IHIT =  IHIT + 1
            R1 = WRK(IPHIT+6) - R0
            Z1 = WRK(IPHIT+5) - Z0
            SUM( 1) = SUM( 1) + R1
            SUM( 2) = SUM( 2) + R1**2
            SUM( 3) = SUM( 3) + Z1
            SUM( 4) = SUM( 4) + Z1**2
            SUM( 5) = SUM( 5) + R1*Z1
      ENDIF
13010 CONTINUE
13011 CONTINUE
        ANHIT= IHIT
        NDEG = IHIT - 2
      IF(
     - NDEG.GT.0
     -)THEN
          ZW1  = (SUM(5)*ANHIT - SUM(1)*SUM(3))
          ZW2  = (SUM(2)*ANHIT - SUM(1)**2)
          B1   = ZW1 / ZW2
          A1   =(SUM(3) - B1*SUM(1)) / ANHIT + Z0 - B1*R0
          CHSQ = SUM(4)*ANHIT - SUM(3)**2 - ZW1**2/ZW2
          RMS  = CHSQ / (IHIT*NDEG)
          IF(RMS.GT.0) RMS = SQRT(RMS)
      ELSE
          B1   = 0.
          A1   = 0.
          RMS  = 1000000.
      ENDIF
      GOTO IZZZ03
17002 CONTINUE
      SIGL2 = ZFITLM(2)*2.
      SIGL4 = ZFITLM(2)*3.5
      NHIT  = 0
      IP10  = 0
      IP3   = IP0
16002 CONTINUE
      IF(
     - IWRK(IP3+ 7).EQ. 0
     -)THEN
          IF(IP10.LE.0) IP10 = IP3
          NHIT = NHIT + 1
      IF(
     - NHIT.EQ.1
     -)THEN
            R1 = WRK(IP3+6)
            Z1 = WRK(IP3+5)
            IP1 = IP3
      ELSE
      IF(
     - NHIT.EQ.2
     -)THEN
              R2 = WRK(IP3+6)
              Z2 = WRK(IP3+5)
              IP2 = IP3
      ELSE
              R3 = WRK(IP3+6)
              Z3 = WRK(IP3+5)
              DR31 = R3-R1
              DELT = 0.
              IF(ABS(DR31).GT.15.) DELT = Z2-Z1 - (R2-R1)*(Z3-Z1)/DR31
              IF(ABS(DELT).GT.SIGL4) IWRK(IP2+7) = 4
      IF(
     - ABS(DELT).GT.SIGL2
     -)THEN
                IF(IP1.EQ.IP0) IWRK(IP1+7) = 4
                IF(IP3.EQ.IP8) IWRK(IP3+7) = 4
      ENDIF
              R1 = R2
              R2 = R3
              Z1 = Z2
              Z2 = Z3
              IP1 = IP2
              IP2 = IP3
      ENDIF
      ENDIF
      ENDIF
      IP3 = IP3 + IDP
      IF(.NOT.(
     - IP3.GT.IP9
     -))GOTO 16002
16003 CONTINUE
      IP90 = IP2
      IP1 = IP10
      IP2 = 0
      IP3 = IP1
16004 CONTINUE
      IP3 = IP3 + IDP
      IF(
     - IWRK(IP3+ 7).LE.4
     -)THEN
          IP2 = IP3
      GOTO 16005
      ENDIF
      IF(.NOT.(
     - IP3.EQ.IP9
     -))GOTO 16004
16005 CONTINUE
      IF(
     - IP2.LE.0
     -)THEN
        NHIT = 0
      ELSE
16006 CONTINUE
        IP3 = IP3 + IDP
      IF(
     - IWRK(IP3+ 7).LE.4
     -)THEN
      IF(
     - IWRK(IP3+7).EQ.4 .OR. IWRK(IP1+7).EQ.4
     -)THEN
              R1 = WRK(IP1+6)
              Z1 = WRK(IP1+5)
              R2 = WRK(IP2+6)
              Z2 = WRK(IP2+5)
              R3 = WRK(IP3+6)
              Z3 = WRK(IP3+5)
              DR31 = R3-R1
              DELT = 1000000.
              IF(ABS(DR31).GT.15.) DELT = Z2-Z1 - (R2-R1)*(Z3-Z1)/DR31
      IF(
     - ABS(DELT).LT.SIGL2
     -)THEN
                IWRK(IP1+7) = 0
                IWRK(IP3+7) = 0
      ENDIF
      ENDIF
            IP1 = IP2
            IP2 = IP3
      ENDIF
      IF(.NOT.(
     - IP3.GE.IP90
     -))GOTO 16006
16007 CONTINUE
        NHIT = 0
      DO 13012 IP1=IP0,IP9,IDP
          IF(IWRK(IP1+7).EQ.0) NHIT = NHIT + 1
13012 CONTINUE
13013 CONTINUE
      ENDIF
      IF(
     - NHIT.LT.LMZFIT(3)
     -)THEN
      DO 13014 IP1 = IP0,IP9,IDP
          IWRK(IP1+7) = LAND(IWRK(IP1+7),11)
13014 CONTINUE
13015 CONTINUE
      ENDIF
      GOTO IZZZ02
17000 CONTINUE
      DO 13016 I = 1,NBINZ
        HIST(I) = 0
13016 CONTINUE
13017 CONTINUE
      AVRAD  = 0.
      NAVRAD = 0
      IP91 = IP9 - IDP
      Z0HIST = -7000.
      DZHIST = 70.
      DO 13018 IPHIT = IP0,IP91,IDP
      IF(
     - IWRK(IPHIT+7).EQ.0
     -)THEN
          R1 = WRK(IPHIT+6)
          AVRAD  = R1 + AVRAD
          NAVRAD =  1 + NAVRAD
          Z1 = WRK(IPHIT+5)
          IP1 = IPHIT + IDP
      DO 13020 IPHIT2 = IP1,IP9,IDP
      IF(
     - IWRK(IPHIT2+7).EQ.0
     -)THEN
              R2 = WRK(IPHIT2+6)
              Z2 = WRK(IPHIT2+5)
      IF(
     - ABS(R1-R2).GT.ZFITLM(6)
     -)THEN
                ZCON = (Z1*R2 - R1*Z2)/(R2-R1)
                IZV = (ZCON - Z0HIST) / DZHIST + 1
      IF(
     - IZV.GT.0 .AND. IZV.LE.NBINZ
     -)THEN
                  HIST(IZV) = HIST(IZV) + 1
      ENDIF
      ENDIF
      ENDIF
13020 CONTINUE
13021 CONTINUE
      ENDIF
13018 CONTINUE
13019 CONTINUE
      ASSIGN 17013 TO IZZZ06
      GOTO 17012
17013 CONTINUE
      ZVTX = ZPEAK
      IF(
     - INDLB.GT.0
     -)THEN
      DO 13022 I = 1,NBINZ
          HIST(I) = 0
13022 CONTINUE
13023 CONTINUE
        IF(NAVRAD.GT.0) AVRAD = AVRAD / NAVRAD
        Z0HIST = -3000.
        DZHIST = 30.
      DO 13024 IPHIT = IP0,IP9,IDP
      IF(
     - IWRK(IPHIT+7).LE.4
     -)THEN
            IWRK(IPHIT+7) = 0
            ZCON = (WRK(IPHIT+5) - ZVTX) * AVRAD/WRK(IPHIT+6)
            IZV  = (ZCON - Z0HIST) / DZHIST + 1
      IF(
     - IZV.GT.0 .AND. IZV.LE.NBINZ
     -)THEN
              HIST(IZV) = HIST(IZV) + 1
      ENDIF
      ENDIF
13024 CONTINUE
13025 CONTINUE
      ASSIGN 17014 TO IZZZ06
      GOTO 17012
17014 CONTINUE
      IF(
     - INDLB.GT.0
     -)THEN
          ZPRO = ZPEAK
          SLOPE = ZPRO / AVRAD
          SIG0 = ZFITLM(2)*4.
          NHIT = 0
          NBAD = 0
      DO 13026 IPHIT = IP0,IP9,IDP
      IF(
     - IWRK(IPHIT+7).LE.0
     -)THEN
              NHIT = NHIT + 1
              DZ = WRK(IPHIT+6)*SLOPE + ZVTX - WRK(IPHIT+5)
      IF(
     - ABS(DZ).GT.SIG0
     -)THEN
                NBAD = NBAD + 1
                IWRK(IPHIT+7) = LOR(IWRK(IPHIT+7),4)
      ENDIF
      ENDIF
13026 CONTINUE
13027 CONTINUE
          NHIT = NHIT - NBAD
      IF(
     - NHIT.LT.LMZFIT(3)
     -)THEN
      DO 13028 IPHIT = IP0,IP9,IDP
              IWRK(IPHIT+7) = LAND(IWRK(IPHIT+7),11)
13028 CONTINUE
13029 CONTINUE
      ENDIF
      ENDIF
      ENDIF
      GOTO IZZZ01
17012 CONTINUE
        NPEAK = 0
        IH9 = NBINZ-11
      DO 13030 IH=7,IH9
          IHSUM = HIST(IH  )+HIST(IH+1)+HIST(IH+2)+HIST(IH+3)+HIST(IH+4)
      IF(
     - IHSUM.GT.NPEAK
     -)THEN
            NPEAK = IHSUM
            HPEAK = IH
      ENDIF
13030 CONTINUE
13031 CONTINUE
        PEAK = NPEAK
        INDLB =-1
      IF(
     - NPEAK.GE.NPKMIN
     -)THEN
          INDLB = 1
          H1 = HPEAK - 7
          H2 = HPEAK + 7
          NBACK = HIST(H1  )+HIST(H1+1)+HIST(H1+2)+HIST(H1+3)+HIST(H1+4)
     +          + HIST(H2  )+HIST(H2+1)+HIST(H2+2)+HIST(H2+3)+HIST(H2+4)
          BACK = .5 * NBACK
          IF(BACK*SBRAT.GT.PEAK) INDLB = 0
          ZV = HIST(HPEAK+1)   + HIST(HPEAK+2)*2
     +        + HIST(HPEAK+3)*3 + HIST(HPEAK+4)*4
          ZV = ZV / PEAK
          DZ = HIST(HPEAK  )*(ZV   )**2 + HIST(HPEAK+1)*(ZV-1.)**2
     +       + HIST(HPEAK+2)*(ZV-2.)**2 + HIST(HPEAK+3)*(ZV-3.)**2
     +       + HIST(HPEAK+4)*(ZV-4.)**2
          DZ = DZ * DZHIST**2 / PEAK
          DZ = SQRT(DZ)
          ZPEAK     = Z0HIST + (HPEAK+ZV-.5)*DZHIST
      ENDIF
      GOTO IZZZ06
      END

C   26/04/84 703121401  MEMBER NAME  FWDISP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FWDISP( IVIEW )
C-----------------------------------------------------------------------
C
C
C   AUTHOR:    J. OLSSON    10.3.1987:  DISPLAY 4V IMPACTS IN FW VIEW
C                                       DISPLAY TAGAN RESULTS IN FW VIEW
C
C  LAST MODIFICATION    12.3.1987
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO2 .... JADE TAGGING GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO2 / FENDC,XYHOL1,XYHOL2,BLDPFW,ZMINBL,ZPLUBL,
     +                 XSC(2),YSC(2),RSC(2),ZMISC(2),ZPLSC(2),DZSC,
     +                 CHX(3,4),CHY(3,4),CHZ(3,4),WLEN,PITCH,WZDIS
C
C--------------------------- END OF MACRO CGEO2 ------------------------
C
C----------------------------------------------------------------------
C      MACRO CGEO3 .... JADE FORWARD DETECTOR GEOMETRY, 1981-3 VERSION
C----------------------------------------------------------------------
C
      COMMON / CGEO3 / ZPLUM2,ZMINM2,NRPBSC,PBSCR(4),PBSCZ(4)
C
C------------------------ END OF MACRO CGEO3 --------------------------
C
C
      COMMON /CHEADR/ HEAD(108)
      COMMON /CJTRIG/ PI,TWOPI
C
      DIMENSION HWORK(50)
      DIMENSION ZSC(2)
      EQUIVALENCE (ZSC(1),ZMINBL)
      LOGICAL*1 LCH,LPLUS,LMINU,LNULL
      DATA LPLUS/'+'/, LMINU/'-'/, LNULL/'0'/
      DATA INAME/'TAGG'/, NBK/2/, INAMV/'VECT'/, NBKV/0/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*100
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      IF(LASTVW.NE.12) GO TO 9999
      ADX = (XMAX-XMIN) * .25
      ADY = 0.
      RADI = FENDC*.5
C
      IPVECT = IDATA(IBLN('VECT'))
      IF(IPVECT.GT.0) GO TO 2633
      IF(HEAD(18).LT.100) WRITE(6,2526)
2526  FORMAT(' NO VECT BANK ....... ')
      GO TO 999
C
2633  IVPS = 0
15001 LO = IDATA(IPVECT+1)
      LTR = IDATA(IPVECT+2)
      NTRVEC = IDATA(IPVECT+4)
C
      IPO  = IPVECT + LO
      ICNT = 0
15005 ICNT = ICNT + 1
      IF( ICNT .GT. NTRVEC.AND.IVPS.EQ.1) GO TO 888
      IF( ICNT .GT. NTRVEC.AND.IVPS.EQ.0) GO TO 15010
15007 IPP = IPO + (ICNT-1)*LTR
C
C CODE FOR FI AND THETA
C
      PX = ADATA(IPP+1)
      PY = ADATA(IPP+2)
      PZ = ADATA(IPP+3)
C
      XFRO = 0.
      YFRO = 0.
      XBAC = 0.
      YBAC = 0.
C
      IF(ABS(PX).LT..001.AND.ABS(PY).LT..001) GO TO 7400
      RPP4 = SQRT(PX*PX + PY*PY)
      IF(ABS(PZ).LT.10.*RPP4) GO TO 15005
      TGTHE = RPP4/ABS(PZ)
      RFRO = PBSCZ(3)*TGTHE
      RBAC = PBSCZ(4)*TGTHE
      PHI = ATAN2(PY,PX)
      IF(PHI.GT.TWOPI) PHI = PHI - TWOPI
      IF(PHI.LT.0.) PHI = PHI + TWOPI
      XFRO = RFRO*COS(PHI)
      YFRO = RFRO*SIN(PHI)
      XBAC = RBAC*COS(PHI)
      YBAC = RBAC*SIN(PHI)
C
7400  XOFF = ADX
      IF(PZ.LT.0.) XOFF = -ADX
      YOFF = ADY
      XXX = XOFF - XFRO * 1.5
      YYY = YOFF + YFRO * 1.5
      XXX1 = XOFF - XBAC * 1.5
      YYY1 = YOFF + YBAC * 1.5
C
      CALL PLYGON(10,RADI*.6,XXX,YYY,0)
      CALL DRAMOV(XXX,YYY,XXX1,YYY1,0)
C
      CALL NUMBWR(30,ICNT,XXX-3.*RADI,YYY,RADI)
C
      GO TO 15005
15010 CONTINUE
C     IPVECT = IDATA(IPVECT-1)
C     IF(IPVECT.LT. 1 ) GO TO 888
      GO TO 888
C SECOND VECT BANK     SECONDARIES BLUR THE DISPLAY, DISCARD...
C     IVPS = 1
C     GO TO 15001
C
C   WRITE TRACK INFORMATION ON RIGHTHAND SIDE OF PICTURE
C
888   XXX = XMIN+.79*(XMAX-XMIN)
      YYY = YMIN+.76*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,0)
C
        CALL CORE(HWORK,80)
        WRITE(cHWORK,320) INAMV,NBKV,NTRVEC ! PMF 17/11/99: UNIT=10 changed to cHWORK
320     FORMAT(' BANK ',A4,I3,' NR OF 4-VECTORS',I3)
        CALL SYSSYM(XXX,YYY,SSS,HWORK,32,0.)
C
      YYY = YYY - 2.*SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,319)         ! PMF 17/11/99: UNIT=10 changed to cHWORK
319   FORMAT('NR  +-   X       Y       PHI(DEG)')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,33,0.)
      YYY = YYY - 1.5*SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,318)         ! PMF 17/11/99: UNIT=10 changed to cHWORK
318   FORMAT('ETOT     PT    PZ    MASS    COSTHE')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,35,0.)
C                    |     |       |      |
      YYY = YYY - 4.5*SSS
C
      IPO  = IPVECT + LO
      ICNT = 0
300   ICNT = ICNT + 1
      IF(ICNT.GT.NTRVEC) GO TO 31
      IPP = IPO + (ICNT-1)*LTR
C
C CODE FOR FI AND THETA
C
      PX = ADATA(IPP+1)
      PY = ADATA(IPP+2)
      PZ = ADATA(IPP+3)
      ET = ADATA(IPP+4)
      XM = ADATA(IPP+5)
      IC = IDATA(IPP+6)
C
      XFRO = 0.
      YFRO = 0.
      RPP4 = 0.
      TPHI = 0.
      COSTH = 1.0
      IF(PZ.LT.0.) COSTH = -1.0
      LCH = LNULL
      IF(IC.GT.0) LCH = LPLUS
      IF(IC.LT.0) LCH = LMINU
C
      IF(ABS(PX).LT..001.AND.ABS(PY).LT..001) GO TO 350
      RPP4 = SQRT(PX*PX + PY*PY)
      IF(ABS(PZ).LT.10.*RPP4) GO TO 300
      TGTHE = RPP4/ABS(PZ)
      RFRO = PBSCZ(3)*TGTHE
      RBAC = PBSCZ(4)*TGTHE
      PHI = ATAN2(PY,PX)
      IF(PHI.GT.TWOPI) PHI = PHI - TWOPI
      IF(PHI.LT.0.) PHI = PHI + TWOPI
      TPHI = PHI*180./PI
      THE = ATAN2(RPP4,PZ)
C     IF(PZ.LT.0.) THE = PI - THE
      COSTH = COS(THE)
      XFRO = RFRO*COS(PHI)
      YFRO = RFRO*SIN(PHI)
C
350   CALL CORE(HWORK,80)
      WRITE(cHWORK,321) ICNT,LCH,XFRO,YFRO,TPHI ! PMF 17/11/99: UNIT=10 changed to cHWORK
321   FORMAT(I2,1X,A1,1X,F7.2,2X,F7.2,4X,F5.1)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,30,0.)
      YYY = YYY - 1.5*SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,322) ET,RPP4,PZ,XM,COSTH ! PMF 17/11/99: UNIT=10 changed to cHWORK
322   FORMAT(F6.2,1X,F5.2,1X,F6.2,1X,F6.4,1X,F8.5)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,35,0.)
      YYY = YYY - 2.*SSS
C
      GO TO 300
31    CONTINUE
C//////// TAGAN DISPLAY /////////////////////////////////////
C
999   CONTINUE
C
C
       JRUN = 0
       CALL TAGAN(IERR,JRUN)
C
       IF (IERR.NE.0) WRITE(6,9800)IERR,JRUN
9800   FORMAT(' IERR=',I10,' JRUN=',I10)
       IF (IERR.NE.0) GO TO 9999
C
       ITAGG0 = IDATA(IBLN('TAGG'))
       ITAGG1 = IDATA(ITAGG0 - 1)
       ITAGG2 = IDATA(ITAGG1 - 1)
       ITAGG3 = IDATA(ITAGG2 - 1)
       ITAGG4 = IDATA(ITAGG3 - 1)
       NCLST = HDATA(2*ITAGG0 + 6)
       NCLZMI= HDATA(2*ITAGG0 + 7)
       NCLZPL= HDATA(2*ITAGG0 + 8)
       NWPCL = HDATA(2*ITAGG0 + 53)
C
       DO 9805 N = 1,NCLST
       IB = (N-1)*NWPCL
        XFN = ADATA(ITAGG2 + IB + 7)
        YFN = ADATA(ITAGG2 + IB + 8)
       JPARTN = HDATA(ITAGG2*2+2*IB+2)
C
      XOFF = ADX
      IF(JPARTN.LT.0) XOFF = -ADX
      YOFF = ADY
      XXX = XOFF - XFN * 1.5
      YYY = YOFF + YFN * 1.5
C
      CALL PLYGON(7,RADI,XXX,YYY,0)
C
      CALL NUMBWR(13,N,XXX+2.*RADI,YYY,RADI)
C
9805   CONTINUE
C********************************************************
C  WRITE TAGAN RESULTS IN LEFT HAND COLUMN
C
      XXX = XMIN
      YYY = YMIN+.76*(YMAX-YMIN)
      CALL XXXYYY(XXX,YYY,SSS,0)
C
        CALL CORE(HWORK,80)
        WRITE(cHWORK,220) INAME,NBK,NCLST   ! PMF 17/11/99: UNIT=10 changed to cHWORK
220     FORMAT(' BANK ',A4,I3,' NR OF CLUSTERS',I3)
        CALL SYSSYM(XXX,YYY,SSS,HWORK,31,0.)
C
      YYY = YYY - 2.*SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,219)         ! PMF 17/11/99: UNIT=10 changed to cHWORK
219   FORMAT('NR  Z     X       Y       PHI')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
      YYY = YYY - 1.5*SSS
      CALL CORE(HWORK,80)
      WRITE(cHWORK,218)             ! PMF 17/11/99: UNIT=10 changed to cHWORK
218   FORMAT('ETAG     +-  DETAG     COSTHE')
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
C
      YYY = YYY - 4.5*SSS
C
      ICNT = 0
200   ICNT = ICNT + 1
      IF(ICNT.GT.NCLST) GO TO 21
       IB = (ICNT-1)*NWPCL
        XFN = ADATA(ITAGG2 + IB + 7)
        YFN = ADATA(ITAGG2 + IB + 8)
        EFN = ADATA(ITAGG2 + IB + 5)
        DEFN = ADATA(ITAGG2 + IB + 6)
       JPARTN = HDATA(ITAGG2*2+2*IB+2)
C
C         CALCULATION OF FI AND THETA ANGLES FOR TAG.
C
       TAGFI = ATAN2(YFN,XFN)
       IF(TAGFI.LT.0.) TAGFI = TAGFI + TWOPI
      TAGFI = TAGFI*180./PI
      RFN = SQRT(XFN*XFN+YFN*YFN)
      THE = ATAN2(RFN,PBSCZ(3))
      IF(JPARTN.LT.0) THE = PI - THE
C
      CALL CORE(HWORK,80)
      WRITE(cHWORK,221) ICNT,JPARTN,XFN,YFN,TAGFI ! PMF 17/11/99: UNIT=10 changed to cHWORK
221   FORMAT(I2,1X,I2,1X,F7.2,2X,F7.2,2X,F5.1)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
      YYY = YYY - 1.5*SSS
      COSTH = COS(THE)
      CALL CORE(HWORK,80)
      WRITE(cHWORK,222) EFN,DEFN,COSTH ! PMF 17/11/99: UNIT=10 changed to cHWORK
222   FORMAT(F8.3,' +- ',F6.3,3X,F8.5)
      CALL SYSSYM(XXX,YYY,SSS,HWORK,29,0.)
      YYY = YYY - 2.*SSS
C
      GO TO 200
21    CONTINUE
C
9999  CONTINUE
      RETURN
      END

C   11/03/79 008260241  MEMBER NAME  INTOLG                 FORTRAN
      SUBROUTINE INTOLG(NPCL,HCLMAP,HLGADC,NPPREC)
C
C     S.YAMADA   11-12-78  14:10    COPIED FROM INTOLG(LGSOURCE)
C     LAST MODIFICATION   26-10-79 17:57 BY Y.WATANABE
C      (THE CONNECTED LG# IS WRITTEN INTO THE PATR BANK)
C
C---- CONNECT CALCULATED INNER TRACK CLUSTESTERS TO THE OBSERVED LG.CLUS
C     CHOOSE AT MOST ONE CLUSTER PAR ONE TRACK
C     THE CRITERION IS;MAX OVERLAPPING CLUSTER. IF OVERLAPPING IS EQUAL,
C     CHOOSE THE CLOSEST ONE AMONG THEM.
C
C     NPCL  =THE BOS POINTER TO THE LG-RESULT BANK ('LGCL')
C     NPPREC =THE BOS POINTER TO THE LATEST PATR BANK
C                                GIVEN AS AN ARGUMENT 26/8/80
      IMPLICIT INTEGER *2 (H)
C
C
#include "clgwork2.for"
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
      DIMENSION JBCCHG(9,100)
      EQUIVALENCE (CXDCHG(1,1),JBCCHG(1,1))
C---- CXDCHG  CONTAINS INNER TRACK INFORMATION
C     JBCCHG(1,N)     HITTING PART 0=BARREL, +/-1=+/-Z END CAP
C     CXDCHG(2,N)     CHARGE
C     CXDCHG(3-5,N)   HITTING POSITION ON THE COIL OR ON THE END CAP
C     CXDCHG(6-8,N)   DIRECTION COSIGNS
C     CXDCHG(9,N)     ABSOLUTE MOMENTUM IN GEV/C
C
#include "cdata.for"
C---- SEE  JADE COMPUTER-NOTE #14.
C     IDATA(NPCLS+1)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     ADATA(NPCLS+2)=CLUSTER ENERGY IN GEV
C     ADATA(NCLST+3)=SIGMA(ENERGY)
C     ADATA(NPCLS+4)=WEIGHTED AVERAGE PHI
C     ADATA(NPCLS+5)=WEIGHTED AVERAGE Z
C     ADATA(NPCLS+6)=SIGMA PHI (WEIGHTED)
C     ADATA(NPCLS+7)=SIGMA Z (WEIGHTED)
C     IDATA(NPCLS+8)=NUMBER OF CORRESPONDING INNER TRACKS
C     ADATA(NPCLS+9-11)=DIRECTION COSIGNS CORRECTED FOR SHOWER DEPTH.
C
      DIMENSION HCLMAP(2,2), HLGADC(2,2)
C
C
      DATA IFLAG/0/
      IF(IFLAG.GT.0) GO TO 5
      IFLAG=1
C     IPTR= IBLN('PATR')
5     CONTINUE
      IF(NCHCLS.LT.1) RETURN
      NPCGI = NPCL+IDATA(NPCL+1)-1
C---- GET NO.OF CLUSTERS
      NCLST = IDATA(NPCGI+3)
      IF(NCLST.LT.1) RETURN
C
      NCHCL2 = NCHCLS
      IF(NCHCL2.GT.100) NCHCL2 = 100
      NCLST2 = NCLST
      LSTEP = IDATA(NPCGI+21)
      NPCL0 = NPCL+IDATA(NPCL+3)-1-LSTEP
      RM=(RADIUS(3)+RADIUS(4))/2.
C     LOCATE PATR BANK AND SET POINTER TO THE WORD. 26-10-79
C     NPTR = IDATA(IPTR)
      NPTR = NPPREC
      LTR=IDATA(NPTR+3)
      NPTR=NPTR+IDATA(NPTR+1)+40 -LTR
C
        DO 100 N=1,NCHCL2
        NPTR=NPTR+LTR
        IDATA(NPTR)=0
        NS = MAPCCL(N)
        NE = MAPCCL(N+1)-1
        MARK=-2
        IF(NS.GT.NE) GO TO 99
        JCHB=JBCCHG(1,N)
        IF(IABS(JCHB).GT.1) GO TO 99
C
C----   GO THROUGH ALL THE OBSERVED CLUSTERS
          NPCLS=NPCL0
          COMAX=0.
          DR2MIN=1.E15
          DO 80 L=1,NCLST
          NPCLS=NPCLS+LSTEP
          LS = HCLMAP(1,L)
          LE = HCLMAP(2,L)
          IF(LE.LT.LS) GO TO 80
C----     COMPARE  ALL THE COMPONENTS OF THE N-TH SIMULATED CLUSTER
C         AND L-TH OBSERVED CLUSTER.
          IF(IDATA(NPCLS+1).NE.JCHB) GO TO 80
C         (CHECK IF IS THE SAME PART OF THE APPARATUS)
            COM=0.
            DO 30 NN=NS,NE
            HADR = HCLADR(NN)
C----       TRY TO FIND HADR AMONG THE OBSERVED CLUSTER COMPONENTS.
              DO 10 LL=LS,LE
              IF(HLGADC(1,LL).EQ.HADR) GO TO 20
10            CONTINUE
              GO TO 30
20          COM=COM+1.
30          CONTINUE
            IF(COM.LE.0.) GO TO 80
          COM=COM/(NE-NS+1)
          IF(HCLIST(1,N).LT.1) GO TO 40
          IF(COM-COMAX) 80,40,70
C
C         THE SAME DEGREE OF OVERLAPP. CHOOSE THE CLOSER ONE
40        IF(JCHB.NE.0) GO TO 50
C         BARREL PART
          PHI=ADATA(NPCLS+4)
          DX=RM*COS(PHI)-CXDCHG(3,N)
          DY=RM*SIN(PHI)-CXDCHG(4,N)
          DR2=DX*DX+DY*DY+(ADATA(NPCLS+5)-CXDCHG(5,N))**2
          GO TO 60
50        DX=ADATA(NPCLS+4)-CXDCHG(3,N)
          DY=ADATA(NPCLS+5)-CXDCHG(4,N)
          DR2=DX*DX+DY*DY
60        IF(DR2.GT.DR2MIN) GO TO 80
          DR2MIN=DR2
70        COMAX=COM
          HCLIST(1,N)=1
          HCLIST(2,N)=L
          IDATA(NPTR)=L
80        CONTINUE
C
C     FILL IN INVERSE LIST
        IF(HCLIST(1,N).LT.1) GO TO 90
        L=HCLIST(2,N)
        LCOM=HCLLSO(1,L)+1
        IF(LCOM.LE.3) HCLLSO(LCOM+1,L)=N
        HCLLSO(1,L)=LCOM
        GO TO 100
C----   IF THERE IS NO MATCHED LG-CLUSTER,MARK IT.
90      MARK = -2
        JSUMC = 0
C----   JSUMC IS THE COUNTER FOR THE EDGE BLOCKS.
          DO 95 NN= NS,NE
          CALL LGCRN2( HCLADR(NN), JSUMC )
95        CONTINUE
        DR2=FLOAT(JSUMC)/(NE-NS+1)
        IF(DR2.GT.0.5) MARK=-1
99      HCLIST( 1,N ) = MARK
100     CONTINUE
      RETURN
      END

C   12/03/84 406222013  MEMBER NAME  SORT1    (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE SORT1(ISTART,IEND,IWRITE)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE SORTS THE CONTENTS OF CATAG INTO ORDER OF ENERGY AND
C PUTS THE ESULTING LIST IN SADC(32,2) WHERE SADC(I,1) = ADDRESS OF BLOC
C AND SADC(I,2) = CONTENTS
C
C ISTART - INPUT - FIRST ADDRESS IN CATAG FROM WHICH DATA SHOULD BE TAKE
C IEND  - INPUT - LAST ADDRESS IN CATAG FROM WHICH DATA SHOULD BE TAKEN
C
C IWRITE - INPUT - FLAG TO TURN ON DEBUGGING INFO IF SET TO 1
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
C
       DIMENSION STEMP(2)
C
C                                   COPY THE CONTENTS OF PART OF
C                                   CATAG TO BE SORTED INTO SADC
C                                   PLUS ADC ADDRESSES
C
       L = 1
C
       DO 5 I = ISTART,IEND
          SADC(L,1) = I
          SADC(L,2) = CATAG(I)
          L = L + 1
    5  CONTINUE
C
C---DEBUG--------------------------------DEBUG  START-------------------
C
       IF ( IWRITE .EQ. 0) GOTO 101
       WRITE(6,601)
  601  FORMAT('  CONTENTS OF SADC BEFORE SORT ')
       DO 91 I = 1,IENDMZ,8
          WRITE(6,901) SADC(I,2),SADC(I+1,2),SADC(I+2,2),SADC(I+3,2),
     *                 SADC(I+4,2 ),SADC(I+5,2),SADC(I+6,2),SADC(I+7,2)
   91  CONTINUE
C
C---DEBUG--------------------------------DEBUG  END---------------------
C
  101  CONTINUE
C
C
C                                   NOW DO SORT ON SADC
C
       IELOO = IEND - ISTART
       DO 10 J = 1 ,IELOO
          DO 11 K = 1,IELOO
             IF ( SADC(K,2) .GT. SADC(K+1,2) )  GOTO 11
             STEMP(1)    = SADC(K,1)
             STEMP(2)    = SADC(K,2)
             SADC(K,1)   = SADC(K+1,1)
             SADC(K,2)   = SADC(K+1,2)
             SADC(K+1,1) = STEMP(1)
             SADC(K+1,2) = STEMP(2)
   11     CONTINUE
   10  CONTINUE
C
C
       IF ( IWRITE .EQ. 0) GOTO 100
C
C
C---DEBUG ONLY---------------------------DEBUG  ONLY--------------------
C
C
       WRITE(6,600)
  600  FORMAT('  CONTENTS OF SADC AFTER SORT ')
       DO 80 I = 1,IENDMZ,8
          WRITE(6,901) SADC(I,2),SADC(I+1,2),SADC(I+2,2),SADC(I+3,2),
     *                 SADC(I+4,2),SADC(I+5,2),SADC(I+6,2),SADC(I+7,2)
   80  CONTINUE
  901  FORMAT(8(3X,F10.2) )
C
C
  100  RETURN
       END

C ZREAD 06/07/01 P.A. Movilla Fernandez
      PROGRAM ZREAD
      IMPLICIT NONE
*.***************************************************************
*.
*.  Standalone example routine for reading ZE4V JADE data.
*.  This routine can process both ASCII and binary formatted files. 
*.
*.  06/07/01   P.A. Movilla Fernandez
*.
*.  Called routines:
*.        JADEV  ... reads ONE complete JADE record
*.        ENDIAN ... checks endian format of binary ZE4V files
*.
*.
*.***************************************************************
C

C General I/O steering parameters
C (should be read in via Fortran read or FFREAD or whatever) 
      INTEGER IUIN,NF,IFORM,MAXEVT,IPROUT
      CHARACTER FNAM0*80
C --- Basename of the data file
C     (The complete file name has the extension .1, .2, etc...)
      DATA FNAM0/ 'jade.demosample.bin_ze4v' /
C      DATA FNAM0/ 'jade.demosample.ascii_ze4v' /
C --- Format of the data file: 0=ASCII,  <>0=binary ZE4V
C     Must be set manually!
      DATA IFORM/ 1 /
C --- Number of input files with same basename (<=999)
      DATA NF / 100 /
C --- Max. number of events to read in
      DATA MAXEVT/ 1200 /
C --- Number of events to print out after connection with a new input file
      DATA IPROUT/ 20 /
C --- Fortran LUN / CFIO descriptor
      DATA IUIN / 20 /
C Further stuff
      INTEGER NEVENT,IEVTNW,IFL,IOS,IER
      LOGICAL ENDIAN,LEX,LPROUT
      CHARACTER CFORM*12,FNAM*80,CI*3
C
C------- C o d e ----------------------------------
C
C INITIALIZATION
C
      NEVENT=0
      IF( ABS( IFORM ).EQ.1 ) THEN
         CFORM='UNFORMATTED'
      ELSE
         CFORM='FORMATTED'
      ENDIF
C
C BEGIN OF FILE LOOP
C
C    -Perform user specific initialization
C     CALL JINI
C
      NF=MIN( NF,999 )
      DO 2000 IFL=1, NF
         IEVTNW=0
C      -Complete input file name
         IF( IFL.LT.10                   ) WRITE( CI,'(I1)') IFL
         IF( IFL.GE.10  .AND. IFL.LT.100  ) WRITE( CI,'(I2)') IFL
         IF( IFL.GE.100 .AND. IFL.LT.1000 ) WRITE( CI,'(I3)') IFL
         FNAM=FNAM0(1:INDEX(FNAM0,' ')-1)//'.'//CI
         INQUIRE( FILE=FNAM, EXIST=LEX )
         IF( .NOT.LEX ) THEN
            WRITE(*,9000) FNAM(1:INDEX( FNAM,' ' )-1)
 9000       FORMAT(' ZREAD: File ',A,' does not exist. Will stop now!' )
            GOTO 3000
         ENDIF
C
C    CONNECT WITH DATA FILE
C
C      -Check if endian format of current platform matches endian format of binary input data
         IF( IFL.EQ.1 .AND. IFORM.NE.0 ) THEN 
            IF( .NOT.ENDIAN( FNAM ) ) IFORM=-ABS( IFORM )
         ENDIF
C
C      -Use FORTRAN I/O to handle ASCII data and binary data with same endian format
         IF( IFORM.GE.0 ) THEN
            OPEN(IUIN,FILE=FNAM,STATUS='OLD',FORM=CFORM,IOSTAT=IOS)
         ELSE
C
C      -Use CERNLIB package CFIO to handle binary data with different endian format
            CALL CFOPEN(IUIN,0,1,'r   ',0,FNAM,IOS )
         ENDIF
C
C      -Print some info
         WRITE(*,9001) IFL,IUIN,CFORM,IOS,FNAM(1:INDEX( FNAM,' ' )-1)
 9001    FORMAT(//,' ZREAD: Processing data file:'
     >        ,' NR=',I2,' LUN=',I3,' F=',A,' IOSTAT=',I2,' FILE=',A,//)
         IF( IOS.NE.0 ) THEN
            WRITE( *,9002 )
 9002       FORMAT(' ZREAD: Error while opening file!'
     >           ,/,'...will stop now!')
            STOP
         ENDIF
C
C      -Read file header present in JADE files with ASCII format
         CALL JADEV( IUIN,IFORM,1,IER )
         IF( IER.LT.0 ) THEN
            WRITE( *, 9010 ) NEVENT+1,IER
 9010       FORMAT(' ZREAD: Read error in EVENT=',I7,' IOSTAT=',I2)
            STOP
         ENDIF
C
C    BEGIN OF EVENT LOOP
C
 1000    CONTINUE
C
         NEVENT=NEVENT+1
C
C    READ JADE EVENT RECORD
C
         CALL JADEV( IUIN,IFORM,0,IER )
C      -Check if read error
         IF( IER.LT.0 ) THEN
            WRITE( *, 9010 ) NEVENT,IER
            STOP
C      -Check if EOF reached
         ELSEIF( IER.EQ.1 ) THEN
            IF( IFORM.GE.0 ) THEN
               CLOSE( IUIN )
            ELSE
               CALL CFCLOS( IUIN,0 )
            ENDIF
            NEVENT=NEVENT-1
            WRITE( *, 9011 ) NEVENT,IER
 9011       FORMAT(' ZREAD: End of file reached.',
     >           ' Current event number =',I7,'  IOSTAT=',I2)
            IF( NEVENT.LT.MAXEVT ) THEN 
               GOTO 2000        ! <--- read next file
            ELSE
               GOTO 3000
            ENDIF
         ENDIF
C
C      -Dump JADE event record
         IEVTNW=IEVTNW+1
         LPROUT=( IEVTNW.LE.IPROUT
     >        .OR. MOD(NEVENT,500).EQ.0
     >        .OR. NEVENT.GE.MAXEVT )
         IF( LPROUT ) CALL JADEPR
C
C      -Perform analysis of current event
C      (Use information stored in common block /XDATA/)
C       CALL JANA
C
C    END OF EVENT LOOP
C
         IF( NEVENT.LT.MAXEVT ) THEN
            GOTO 1000
         ELSE
            IF( IFORM.GE.0 ) THEN
               CLOSE(IUIN)
            ELSE
               CALL CFCLOS(IUIN,0)
            ENDIF
            GOTO 3000
         ENDIF
C
C END OF FILE LOOP
C
 2000 CONTINUE
C
C The End
 3000 CONTINUE
      WRITE(*,9030) NEVENT
 9030 FORMAT(' ZREAD: Event limit or EOF reached.'
     >     ,' Number of read events;',I7)
C
C    -Perform final analysis steps
C     CALL JFIN
C
      STOP
      END
C
C
C
      SUBROUTINE JADEV(IUIN,IFORM,IOPT,IER)
      IMPLICIT NONE
*.********************************************************************
*.
*.  Reads one JADE event record and stores the data into common /XDATA/.
*.
*.  P.A. Movilla Fernandez
*.                    20/01/98 for ASCII data
*.                    28/01/00 now also working for binary ZE4V data
*.                    01/12/00 binary ZE4V data with both big endian
*.                             AND little endian format readable!
*.
*.  Input:
*.    IUIN        ... logical fortran unit number associated with the data file  
*.    IFORM= 0    ... event record is in ASCII format
*.         = 1    ... event record is in binary ZE4V format, endian format
*.                    of current platform equals endian format of data
*.         =-1    ... event record is in binary ZE4V format, endian format
*.                    of current platform differs from endian format of data
*.    IOPT = 0    ... read JADE event record
*.         = 1    ... read header of ASCII file
*.  Output:
*.     IER =  0,1 ... event record successfully read in
*.         =  1   ... end of file reached
*.         = -1   ... read error
*.
*.  The event record is stored in the following variables and arrays.
*.
*.  Header section of the event record:
*.  -----------------------------------
*.     IXREVN                      running event number
*.     IXRUN                       run number
*.     IXEVENT                     event number
*.     IXMCR                       MCREDU flag
*.     XEBEAM                      beam energy
*.     XEVCH                       visible energy (tracks)
*.     XEVTOT                      visible energy (clusters)
*.     XSPH1X XSPH1Y XSPH1Z XSPH1  1. sphericity + value
*.     XSPH2X XSPH2Y XSPH2Z XSPH2  2. sphericity + value
*.     XSPH3X XSPH3Y XSPH3Z XSPH3  3. sphericity + value
*.     XTHRX XTHRY XTHRZ XTHR      thrust axis and value
*.     XACOX XACOY XACOZ XACO      acoplanarity + value
*.     IXNVER                      # vertices
*.     XVERX(I) XVERY(I) XVERZ(I)  coordinate vertex I
*.     IXNPAR                      # partons
*.     IXQFL                       quark flavour
*.     XPPX(I) XPPY(I) XPPZ(I) XPP(I)  4-momentum of parton I  
*.     IXNP                        number of particles
*.
*.  Particle section (particle number: I)
*.  -------------------------------------
*.  - general
*.     IXRPN(I)              Running particle number
*.     IXPATR(I)             0 or PATR number of PHOT partners (conversion)
*.     IXPC(I)               Particle code (JADE-MC-convention)*100 + identified typ
*.     IXVN(I)               0 or vertex number of particle origin
*.     IXV2N(I)              0 or number of sec. vertec
*.     IXPALL(I)             0 or particle number in PALL bank (MC only)
*.     IXEO(I)               Traceback code [ electron origin ] (MC only)
*.     IXTPTR(I)             0 or number of TPTR bank
*.     IXPTF(I)              Particle typ flag: 0=cluster, 1=tracks
*.     XEX(I) XEY(I) XEZ(I)  Particle direction
*.     XP(I)                 Total momentum
*.     XCH(I)                Charge
*.  - tracks ( IXPTF(I)=1 )
*.     XECL(I) XECLE(I)      Energy of the associated cluster and its error
*.     XECLC(I)              0 oder corrected cluster energy (Meier)
*.     XDEDX(I) XDEDXS(I)    dEdx + sigma
*.     XRMIN(I)              Rmin
*.     XDX(I) XDY(I) XDZ(I)  Doca point(?)
*.     IXDFLG(I)             Detector flag (TP convention)
*.     IXCLN(I)              Number of the 1. associated cluster 
*.                           + 100*(number of the 2. associated cluster)
*.     IXCTRN(I)             Number of the track in PATR Bank
*.     IXHITS(I)             # hits in r/phi * 100 + # hits in r/z
*.     IXMUQ(I)              0 oder myon quality
*.  - clusters ( IXPTF(I)=0 )
*.     XECL(I) XECLE(I)      Energy of cluster and its error
*.     XECLC(I)              0 oder corrected cluster energy
*.     IXLGP(I)              LG section: 0 = barrel, +/-1 = +/-endcap
*.     IXCLN(I)              Number of the cluster in LGCL bank + 100* number of the 2. cluster
*.     IXNBL1(I)             # LG blocks 1. cluster minus # ass. tracks
*.     IXNBL2(I)             # LG blocks 2. cluster
*.
*.     
*.  === Format of the binary ZE4V data ===
*.
*.     See JADE Computer Note 99.
*.     N.B.: The binary data has BOS format. It can be read on both
*.           big endian and little endian machines.
*.           
*.  === Format of the JADE ASCII data ===
*.
*.  running evn#    (I6)
*.  run#     evn#    MCREDU    (3I8)
*.  Ebeam  Evis(ch)  Evis(ch+ne)    (3E16.9E2)
*.  1st sphericity axis(x,y,z) + value    (4E16.9E2)
*.  2nd sphericity axis(x,y,z) + value    (4E16.9E2)
*.  3rd sphericity axis(x,y,z) + value    (4E16.9E2)
*.      thrust     axis(x,y,z) + value    (4E16.9E2)
*.   acoplanarity  axis(x,y,z) + value    (4E16.9E2)
*.  #vertices    (I3)
*.   1st vertex (x,y,z)    (3E16.9E2)
*.   2nd vertex (x,y,z)    (3E16.9E2)
*.          :
*.  #jets/partons  quarkflavor    (2I3)
*.   1st parton px,py,pz,abs(p)    (4E16.9E2)
*.   2nd parton px,py,pz,abs(p)    (4E16.9E2)
*.          :
*.  #particles    (I4)
*.  (********** for each particle: *************************)
*.    running particle #    (I4)
*.    PATR# partcode vertex# secvertex# PALL# elecorigin TPTR# Ptf  (8I6)
*.    particle direction x,y,z + ptot + charge    (4E16.9E2,F4.1)
*.   (if Ptf=1:)
*.    Eclust Eclust-err corr.Eclust dE/dx sigma-dE/dx    (5E16.9E2)
*.    Rmin    (E16.9E2)
*.    doca  (x,y,z)    (3E16.9E2)
*.    detflag   cluster#   track#   nrphi*100+nrz  muquality    (5I6)
*.   (if Ptf=0:)
*.    Eclust  Eclust-err  corr.Eclust    (3E16.9E2)
*.    LG-part  cluster#   #blocks(1st LG)  #blocks(2nd LG)    (4I6)
*.  (********************************************************)
*.   (empty line)
*.
*.***************************************************************
C
C------  JADE event record variables -------------------------------
C 
      INTEGER IXREVN,IXRUN,IXEVENT,IXMCR
      REAL XEBEAM,XEVCH,XEVTOT
      REAL XSPH1X,XSPH1Y,XSPH1Z,XSPH1
     +     ,XSPH2X,XSPH2Y,XSPH2Z,XSPH2
     +     ,XSPH3X,XSPH3Y,XSPH3Z,XSPH3
     +     ,XACOX,XACOY,XACOZ,XACO
     +     ,XTHRX,XTHRY,XTHRZ,XTHR
      INTEGER IXNVER
      REAL XVERX,XVERY,XVERZ
      INTEGER IXNPAR,IXQFL
      REAL XPPX,XPPY,XPPZ,XPP
      INTEGER IXNP,IXRPN,IXPATR,IXPC,
     +     IXVN,IXV2N,IXPALL,IXEO,IXTPTR,IXPTF
      REAL XEX,XEY,XEZ,XP,XCH,XECL,XECLE,XECLC,
     +     XDEDX,XDEDXS,XRMIN,XDX,XDY,XDZ
      INTEGER IXDFLG,IXCLN,IXCTRN,IXHITS,
     +     IXMUQ,IXLGP,IXNBL1,IXNBL2
      INTEGER IX
      PARAMETER( IX=400 )
      COMMON /XDATA/ 
C         general section
     +     IXREVN,IXRUN,IXEVENT,IXMCR
     +     ,XEBEAM,XEVCH,XEVTOT
     +     ,XSPH1X,XSPH1Y,XSPH1Z,XSPH1
     +     ,XSPH2X,XSPH2Y,XSPH2Z,XSPH2
     +     ,XSPH3X,XSPH3Y,XSPH3Z,XSPH3
     +     ,XACOX,XACOY,XACOZ,XACO
     +     ,XTHRX,XTHRY,XTHRZ,XTHR
     +     ,IXNVER
     +     ,XVERX(20),XVERY(20),XVERZ(20)
     +     ,IXNPAR,IXQFL
     +     ,XPPX(20),XPPY(20),XPPZ(20),XPP(20),IXNP
C         particle section
     +     ,IXRPN(IX),IXPATR(IX),IXPC(IX)
     +     ,IXVN(IX),IXV2N(IX),IXPALL(IX),IXEO(IX)
     +     ,IXTPTR(IX),IXPTF(IX)
     +     ,XEX(IX),XEY(IX),XEZ(IX),XP(IX),XCH(IX)
     +     ,XECL(IX),XECLE(IX),XECLC(IX)
     +     ,XDEDX(IX),XDEDXS(IX),XRMIN(IX),XDX(IX),XDY(IX),XDZ(IX)
     +     ,IXDFLG(IX),IXCLN(IX),IXCTRN(IX),IXHITS(IX)
     +     ,IXMUQ(IX),IXLGP(IX),IXNBL1(IX),IXNBL2(IX)
      INTEGER IXDATA( 28+60+2+80+1+IX*31 )
      EQUIVALENCE( IXDATA(1),IXREVN )
C
C -------------------------------------------------------------------
C
      INTEGER IER,IOPT,IFORM,IUIN
C BOS
      REAL RW(40000)
      INTEGER IW(-4:40000),NWORDS
      INTEGER*2 HW0(80000)
      EQUIVALENCE (RW(1),IW(1),HW0(1))
      SAVE IW
C ZE4V pointer and counter
      INTEGER LH,LT,LCH,LPH,LPR,NPTR
      INTEGER*2 HW(80000),H1,H2
C
      INTEGER I,I1,I2,IXREVS,NDUM,NREAD,IOS
      CHARACTER TXT
      SAVE IXREVS
C
C----------------- C o d e ------------------------------------
C
      IER=0
      CALL VZERO(IXDATA,28+60+2+80+1+IX*31)
C
C**************************************
C     Read data from ASCII files
C**************************************
C
C General section
      IF( IFORM.EQ.0 ) THEN

C        Read header of the file 
         IF( IOPT.EQ.1 ) THEN
            READ(IUIN,ERR=9991,END=9992,FMT='(A1)') (TXT,I=1,34)
            GOTO 9999
         ENDIF
C
         READ(IUIN,'(I6)',ERR=9991,END=9992) IXREVN
         READ(IUIN,'(3I8)') IXRUN,IXEVENT,IXMCR
         READ(IUIN,'(3E16.9E2)') XEBEAM,XEVCH,XEVTOT
         READ(IUIN,'(4E16.9E2)') XSPH1X,XSPH1Y,XSPH1Z,XSPH1 
         READ(IUIN,'(4E16.9E2)') XSPH2X,XSPH2Y,XSPH2Z,XSPH2
         READ(IUIN,'(4E16.9E2)') XSPH3X,XSPH3Y,XSPH3Z,XSPH3
         READ(IUIN,'(4E16.9E2)') XTHRX,XTHRY,XTHRZ,XTHR
         READ(IUIN,'(4E16.9E2)') XACOX,XACOY,XACOZ,XACO
         READ(IUIN,'(I3)') IXNVER
         DO I=1,IXNVER
            READ(IUIN,'(3E16.9E2)') XVERX(I),XVERY(I),XVERZ(I) 
         ENDDO
         READ(IUIN,'(2I3)') IXNPAR,IXQFL
         IF( IXNPAR.GT.0 ) THEN
            DO I=1,IXNPAR
               READ(IUIN,'(4E16.9E2)') XPPX(I),XPPY(I),XPPZ(I),XPP(I) 
            ENDDO
         ENDIF
         READ(IUIN,'(I4)') IXNP

C Particle section
         IF( IXNP.GT.IX ) THEN
            WRITE(*,'(A,I8)') 'JADEV: Too many particles, IXNP=',IXNP
            WRITE(*,'(A)') ' ...will stop now!'
            STOP
         ENDIF
         DO I=1,IXNP
C ... general
            READ(IUIN,'(I4)') IXRPN(I)
            READ(IUIN,'(8I6)') IXPATR(I),IXPC(I),IXVN(I),IXV2N(I)
     >           ,IXPALL(I),IXEO(I),IXTPTR(I),IXPTF(I)
            READ(IUIN,'(4E16.9E2,F4.1)')
     >           XEX(I),XEY(I),XEZ(I),XP(I),XCH(I)
C ... tracks
            IF( IXPTF(I).EQ.1 ) THEN        
               READ(IUIN,'(5E16.9E2)')
     >              XECL(I),XECLE(I),XECLC(I),XDEDX(I),XDEDXS(I) 
               READ(IUIN,'(E16.9E2)') XRMIN(I)
               READ(IUIN,'(3E16.9E2)') XDX(I),XDY(I),XDZ(I)
               READ(IUIN,'(5I6)')
     >              IXDFLG(I),IXCLN(I),IXCTRN(I),IXHITS(I),IXMUQ(I)
C ... clusters
            ELSEIF( IXPTF(I).EQ.0 ) THEN
               READ(IUIN,'(3E16.9E2)') XECL(I),XECLE(I),XECLC(I)
               READ(IUIN,'(4I6)') IXLGP(I),IXCLN(I),IXNBL1(I),IXNBL2(I)
            ENDIF
         ENDDO
C Last line (blank) 
         READ(IUIN,'(A)') TXT
C
C*****************************************
C     Read data from binary ZE4V files
C*****************************************
C
      ELSEIF( ABS(IFORM).EQ.1 .AND. IOPT.EQ.0 ) THEN

C Perform FORTRAN read of binary data, if the data were produced on
C a platform similar to the current one (w.r.t. to endian format)
         IF( IFORM.EQ.1 ) THEN
            READ(IUIN,ERR=9991,END=9992) NWORDS,(IW(I),I=-3,NWORDS-4)
            NWORDS=NWORDS-4
            CALL UCOPY(HW0,HW,NWORDS)
         ELSE
C Read of binary data using subroutine CFGET, if the data were produced 
C on a platform different from the current one (w.r.t. to endian format)
C     - get record length
            NREAD=1
            CALL CFGET(IUIN,0,1,NREAD,NWORDS,IOS)
            IF( IOS.EQ.-1 ) THEN
               GOTO 9992
            ELSEIF( IOS.NE.0 ) THEN
               GOTO 9991
            ENDIF
            CALL VXINVB(NWORDS,1)
            NWORDS=NWORDS/4
C     - read record
            CALL CFGET(IUIN,0,NWORDS,NREAD,IW(-4),IOS)
            IF( IOS.NE.0 .OR. NREAD.NE.NWORDS ) GOTO 9991
C     - read last word of fortran record (=record length)
            NREAD=1
            CALL CFGET(IUIN,0,1,NREAD,NDUM,IOS)
            IF( IOS.NE.0 ) GOTO 9991
C     - ignore record length and BOS header IW(-4 ... 0)
            NWORDS=NWORDS-5
C     - perform byte-by-byte inversion of arrays IW,RW
            CALL VXINVB(IW(1),NWORDS)
C     - perform also halfword-by-halfword inversion of array HW0
C       (equivalenced with IW ) and put result into array HW
            DO I=1,NWORDS*2, 2
               H1=HW0(I)
               H2=HW0(I+1)
               HW(I)=H2
               HW(I+1)=H1
            ENDDO
         ENDIF

         LH   = HW(  1 )        ! Length of header
         LT   = HW(  5 )        ! Length general particle section
         LCH  = HW(  7 )        ! Length track section
         LPH  = HW(  9 )        ! Length cluster section
         LPR  = HW( 11 )        ! Length private section

         NPTR=0

         IXREVS  = IXREVS+1
         IXREVN  = IXREVS       ! no corresponding entry in ZE4V Bank
         IXRUN   = HW( 13 )
         IXEVENT = HW( 14 )
         IXMCR   = IW( 31 )
         XEBEAM  = RW(  8 )
         XEVCH   = 0.           ! no corresponding entry in ZE4V Bank
         XEVTOT  = 0.           ! no corresponding entry in ZE4V Bank
         XSPH1X  = RW(  9 )
         XSPH1Y  = RW( 10 )
         XSPH1Z  = RW( 11 )
         XSPH1   = RW( 12 )
         XSPH2X  = RW( 13 )
         XSPH2Y  = RW( 14 )
         XSPH2Z  = RW( 15 )
         XSPH2   = RW( 16 )
         XSPH3X  = RW( 17 )
         XSPH3Y  = RW( 18 )
         XSPH3Z  = RW( 19 )
         XSPH3   = RW( 20 )
         XTHRX   = RW( 21 )
         XTHRY   = RW( 22 )
         XTHRZ   = RW( 23 )
         XTHR    = RW( 24 )
         XACOX   = RW( 25 ) 
         XACOY   = RW( 26 )
         XACOZ   = RW( 27 )
         XACO    = RW( 28 )
         IXNVER  = HW(  3 )

         DO I=1,IXNVER
            XVERX(I) = RW( 31+HW(2)*(I-1) + 1 )
            XVERY(I) = RW( 31+HW(2)*(I-1) + 2 )
            XVERZ(I) = RW( 31+HW(2)*(I-1) + 3 )
         ENDDO

         IF( HW(4).GT.0 ) THEN
            IXNPAR   = HW( 62+2*HW(3)*HW(2) + 1 )
            IXQFL    = HW( 62+2*HW(3)*HW(2) + 2 )
            IF( IXNPAR.GT.0 ) THEN
               DO I=1,IXNPAR
                  XPPX(I) = RW( 32+HW(3)*HW(2)+4*(I-1) + 1 )
                  XPPY(I) = RW( 32+HW(3)*HW(2)+4*(I-1) + 2 )
                  XPPZ(I) = RW( 32+HW(3)*HW(2)+4*(I-1) + 3 )
                  XPP(I)  = RW( 32+HW(3)*HW(2)+4*(I-1) + 4 )
               ENDDO
            ENDIF
         ELSE
            IXNPAR  = 0
            IXQFL   = 0
            XPPX(1) = 0.
            XPPY(1) = 0.
            XPPZ(1) = 0.
            XPP(1)  = 0.
         ENDIF
         IXNP   = HW(6)

         NPTR  = LH             ! update ZE4V pointer

C Particle section
         IF( IXNP.GT.IX ) THEN
            WRITE(*,'(A,I8)') 'JADEV: Too many particles, IXNP=',IXNP
            WRITE(*,'(A)') ' ...will stop now!'
            STOP
         ENDIF
         DO I=1,IXNP
            IXRPN(I) = I        ! no corresponding entry in ZE4V Bank

C ... general
            IXPATR(I) = HW( NPTR*2 +  7 )
            IXPC(I)   = HW( NPTR*2 +  8 )
            IXVN(I)   = HW( NPTR*2 +  9 )
            IXV2N(I)  = HW( NPTR*2 + 10 )
            IXPALL(I) = HW( NPTR*2 + 15 )
            IXEO(I)   = HW( NPTR*2 + 16 ) ! I'am not sure
            IXTPTR(I) = HW( NPTR*2 + 17 )
            IXPTF(I)  = HW( NPTR*2 + 18 )
            XEX(I)    = RW( NPTR   +  1 )
            XEY(I)    = RW( NPTR   +  2 )
            XEZ(I)    = RW( NPTR   +  3 )
            XP(I)     = RW( NPTR   +  6 )
            XCH(I)    = RW( NPTR   +  7 )

            NPTR  = NPTR + LT   ! update ZE4V pointer

C ... tracks
            IF( IXPTF(I).EQ.1 ) THEN        
               XECL(I)    = RW( NPTR   +  1 )
               XECLE(I)   = RW( NPTR   +  2 )  
               XECLC(I)   = RW( NPTR   +  3 )  
               XDEDX(I)   = RW( NPTR   +  9 )  
               XDEDXS(I)  = RW( NPTR   + 10 )  
               XRMIN(I)   = RW( NPTR   + 11 )
               XDX(I)     = RW( NPTR   +  6 )
               XDY(I)     = RW( NPTR   +  7 )
               XDZ(I)     = RW( NPTR   +  8 )
               IXDFLG(I)  = HW( NPTR*2 +  7 ) 
               IXCLN(I)   = HW( NPTR*2 +  8 ) 
               IXCTRN(I)  = HW( NPTR*2 +  9 ) 
               IXHITS(I)  = HW( NPTR*2 + 10 ) 
               IXMUQ(I)   = IW( NPTR   + 12 ) 

               NPTR  = NPTR + LCH ! update ZE4V pointer
            
C ... clusters
            ELSEIF( IXPTF(I).EQ.0 ) THEN
               XECL(I)    = RW( NPTR   +  1 )
               XECLE(I)   = RW( NPTR   +  2 )
               XECLC(I)   = RW( NPTR   +  3 )
               IXLGP(I)   = HW( NPTR*2 +  7 ) 
               IXCLN(I)   = HW( NPTR*2 +  8 ) 
               IXNBL1(I)  = HW( NPTR*2 +  9 ) 
               IXNBL2(I)  = HW( NPTR*2 + 10 ) 

               NPTR  = NPTR + LPH ! update ZE4V pointer
               
            ENDIF
         ENDDO

      ENDIF
C
      GOTO 9999
 9991 IER=-1
      GOTO 9999
 9992 IER=1
 9999 RETURN
C
      ENTRY JADEPR
C
C Print out event in readable format
C

C General part
      WRITE(*,5900) IXREVN
     +     ,IXRUN,IXEVENT
     +     ,XEBEAM,IXMCR,XEVCH,XEVTOT
     +     ,IXNVER,IXNPAR,IXQFL
      WRITE(*,5910)
     +     'Thrust',XTHR,XTHRX,XTHRY,XTHRZ
     +     ,'Spher1',XSPH1,XSPH1X,XSPH1Y,XSPH1Z
     +     ,'Spher2',XSPH2,XSPH2X,XSPH2Y,XSPH2Z
     +     ,'Spher3',XSPH3,XSPH3X,XSPH3Y,XSPH3Z
     +     ,'Aco',XACO,XACOX,XACOY,XACOZ
      IF( IXNPAR.GT.0 ) THEN
         WRITE(*,5904)
         DO I=1,IXNPAR
            WRITE(*,5905) I,XPPX(I),XPPY(I),XPPZ(I),XPP(I) 
         ENDDO
      ENDIF
      WRITE(*,5902) IXNP
C Particle section
      I1=0
      I2=0
      DO I=1, IXNP
         
         IF( IXPTF(I) .EQ. 1 ) THEN
            I1=I1+1
            IF( I1.EQ.1 ) WRITE(*, 6001)
            WRITE(*,6010)
C    ... general
     +           IXRPN(I)
     +           ,IXPATR(I),IXPALL(I),IXTPTR(I)
     +           ,IXVN(I),IXV2N(I)
     +           ,IXEO(I),IXPC(I),IXPTF(I)
     +           ,XEX(I),XEY(I),XEZ(I),XP(I),XCH(I)
C    ... tracks
     +           ,XECL(I),XECLE(I),XECLC(I)
     +           ,IXDFLG(I),IXCLN(I),IXCTRN(I)
     +           ,INT(IXHITS(I)/100),MOD(IXHITS(I),100),IXMUQ(I)
     +           ,XRMIN(I),XDX(I),XDY(I),XDZ(I)
     +           ,XDEDX(I),XDEDXS(I)
         ELSE IF( IXPTF(I) .EQ. 0 ) THEN
            I2=I2+1
            IF( I2.EQ.1 ) WRITE(*, 6002)
            WRITE(*,6011)
C    ... general
     +           IXRPN(I)
     +           ,IXPATR(I),IXPALL(I),IXTPTR(I)
     +           ,IXVN(I),IXV2N(I)
     +           ,IXEO(I),IXPC(I),IXPTF(I)
     +           ,XEX(I),XEY(I),XEZ(I),XP(I),XCH(I)
C    ... clusters
     +           ,XECL(I),XECLE(I),XECLC(I)
     +           ,IXLGP(I),IXCLN(I),IXNBL1(I),IXNBL2(I)
         ENDIF
      ENDDO
C
 5900 FORMAT ('JADEPR:',/,T2
     +     ,58('#'),'   JADE EVENT RECORD ',I7,'    ',58('#')
     +     ,/,' Run=',I6,' Event=',I6,' Ebeam=',F6.2
     +     ,' MCREDU=',I3,' Evis(chrgd)= ',F5.2,' Evis(tot)= ',F5.2
     +     ,/,T4,'#Vertices=',I3,' #Partons=',I3,' Quarkflavour=',I3)
 5910 FORMAT (T4,A6,'= ',F6.4,4X,'x= ',F6.4,4X,'y= ',F6.4,4X,'z= ',F6.4)
 5904 FORMAT(T2,'Parton#      px      py      pz     |p|')
 5905 FORMAT(T2,I7,4F8.4)
 5902 FORMAT(T2,'#Particles=',I3)
 6001 FORMAT('  # PAT PAL TPT vt1 vt2 eor  pc  pt'
     +     ,'     ex     ey     ez    |p|  Q'
     +     ,'   E(cl)     +-    cor '  
     +     ,' det c# t# rf rz mu'
     +     ,'   Rmin   docx   docy   docz   dEdx     +-')
 6002 FORMAT(T91,' LG c# #b1 #b2')
 6010 FORMAT(T2,I2,8I4,4F7.3,F4.0,3F7.3,I5,4I3,I3,6F7.3)
 6011 FORMAT(T2,I2,8I4,4F7.3,F4.0,3F7.3,I5,3I3)

 6900 FORMAT(' - - - - - ',I2
     +     ,/T5,'General:',' PATR#',I2,' PALL#',I2,' TPTR#',I2
     +     ,' vtx#',I2,' vtx(2nd)#',I2
     +     ,' e-ori:',I3,' p-code:',I2,' p-type:',I2
     +     ,/T13,' ex=',F6.4,' ey=',F6.4,' ez=',F6.4
     +     ,' |p|=',F7.3,' Q=',F4.1)
 6901 FORMAT(T5,'Track:  '
     +     ,' det:',I4,' cl#:',I2,' tr#:',I2
     +     ,' #rphi:',I2,' #rz:',I2,' Mu:',I2
     +     ,' Rmin=',F7.3,' dx=',F7.3,' dy=',F7.3,' dz=',F7.3
     +     ,/T13,' E=',F7.3,' +-',F7.3,' cor=',F7.3
     +     ,' dEdx=',F7.4,' +-',F7.4)
 6902 FORMAT(T5,'Ecal:   '
     +     ,' LG:',I4,' Cl#',I2,' #Bl1:',I2,' #Bl2:',I2
     +     ,' E=',F7.3,' +-',F7.3,' cor=',F7.3)
C      
      RETURN
      END
C
C
C
      LOGICAL FUNCTION ENDIAN(CNAM)
      IMPLICIT NONE
*.***************************************************************
*.
*.  01/12/00   P.A. Movilla Fernandez
*.
*.  This routine checks if the endian format of current platform
*.  matches the endian format of the BINARY ZE4V input data.
*.
*.  Input:
*.        CNAM             ... name of the data file
*.  On return:
*.        ENDIAN = .TRUE.  ... format of current platform does match data format
*.        ENDIAN = .FALSE. ... format of current platform does NOT match data format
*.
*.  This is only an 'educated guess'. The routine checks the first
*.  integer words of the event record:
*.      1 = size of the fortran record length in bytes
*.      2 = size of the BOS record in full words
*.      4 = ZE4V BOS bank number (=1)
*.  The values should generally not exceed 65535 if the endian format
*.  of the data matches the endian format of the current platform.
*.
*.***************************************************************
      CHARACTER CNAM*(*)
C Check endian format of current platform
      INTEGER IBIG
      INTEGER*2 HBIG(2)
      EQUIVALENCE (IBIG,HBIG)
      DATA IBIG /1/
C
      INTEGER IUIN,IOS,N(5),LIM,NREAD
      DATA LIM/65535/
C Test input file
      CALL CFOPEN(IUIN,0,1,'r   ',0,CNAM,IOS )
      IF( IOS.NE.0 ) THEN
         WRITE(*,'(2A)') ' ENDIAN: Error while opening file ',CNAM
         WRITE(*,'(A)') ' ...will stop now!'
         STOP
      ENDIF
C Read first words of the record
      NREAD=5
      CALL CFGET(IUIN,0,NREAD,NREAD,N,IOS)
C Check words 1,2 and 4
      IF( ABS(N(1)).LE.LIM.AND.ABS(N(2)).LE.LIM.AND.ABS(N(4)).LE.LIM )
     >     THEN
         ENDIAN=.TRUE.
      ELSEIF(ABS(N(1)).GT.LIM.AND.ABS(N(2)).GT.LIM.AND.ABS(N(4)).GT.LIM)
     >        THEN
         ENDIAN=.FALSE.
         CALL VXINVB(N,2)
         CALL VXINVB(N(4),2)
      ELSE
         WRITE(*,'(3A)') ' ENDIAN: Cannot decide endian format'
     >        ,' of input data file ',CNAM
         WRITE(*,'(A,2I8,A5,I8)') ' Record starts with:',N
         WRITE(*,'(A)') ' ...will stop now!'
         STOP
      ENDIF
C I/O format info
      WRITE(*,'(/,A,/,A,2I8,A5,2I8)') 'ENDIAN:'
     >     ,' Data record starts with:',N
      WRITE(*,'(A,$)') ' JADE data I/O format: '
      IF( ENDIAN ) THEN
         WRITE(*,'(A,$)') 'binary ZE4V data and current platform with'
     >  //' EQUAL endian format.'
      ELSE
         WRITE(*,'(A,$)') 'binary ZE4V data and current platform with'
     >  //' DIFFERENT endian format.'
      ENDIF
      IF( HBIG(1).EQ.1 ) THEN
         WRITE(*,'(A)') ' Current platform is LITTLE ENDIAN.'
      ELSE
         WRITE(*,'(A)') ' Current platform is BIG ENDIAN.'
      ENDIF
C Close input file
      CALL CFCLOS(IUIN,0)
      RETURN
      END

      SUBROUTINE AMPS2Z( IP, NPJETC, Z, W, IFLAG )
      IMPLICIT INTEGER*2 (H)
      COMMON /CZSCAL/ IPVERS, ZALPDI, RESFAC, SECH(5)
C
C  COMMON FOR Z-RESOLUTION PARAMETERS,   USED IN SUBR. AMPS2Z
C
      COMMON / CZSPRM / NZSPRD,
C                                           PARMS FOR RESOLUTIONS
     * AZSRS0(3), AZSRSA(3),
C                                           PARMS FOR CUTS
     * AZSCT1(3), AZSCT2(3), AZSCT3(3), AZSCT4(3),
C                                           SECOND HIT
     * AZSSHT(5,3),
C                                           SECOND HIT DISTANCE
     * AZSSHD(3),
C                                           AVE RESOLUTIONS
     * AZSSAV(3),
C                                           ZSPD BANK FILL FLAG
     * LZSPDF
      LOGICAL LZSPDF
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
      COMMON / BCS / HW(1)
      REAL EXTRMZ / 1250. /, ZALDEF / 1400. /
      REAL DISMAX / 3.6 /
      LOGICAL FIRST / .TRUE. /
      IF(
     - FIRST
     -)THEN
         FIRST = .FALSE.
         WRITE(6,9101) NZSPRD, ZALPDI, ZALDEF
 9101    FORMAT(' +++ AMPS2Z    NZSPRD=',I3,' ZALPDI=',F10.3,
     *          ' ZALDEF=',F10.3)
      ENDIF
      Z = 0.
      W = 1.
      IFLAG = 16
      AL = HW(IP+2)/8.
      AR = HW(IP+1)/8.
      IF(
     -  AL.GT.0. .AND. AR.GT.0.
     -)THEN
      IF(
     -  ZALPDI .EQ. ZALDEF
     -)THEN
          Z = ZALPDI*(AL-AR)/(AL+AR)
      IF(
     - NZSPRD .LE. 2
     -)THEN
            W = ( AZSSAV(NZSPRD) /
     *              ( AZSRS0(NZSPRD)+
     *                AZSRSA(NZSPRD)*SQRT(AL**2+AR**2)/(AL+AR)**2
     *              )
     *          )**2
      ELSE
            W = (AZSSAV(NZSPRD)/
     *             (AZSRS0(NZSPRD)+AZSRSA(NZSPRD)/(AL+AR)))**2
      ENDIF
      ELSE
          Z = .5*ZAL*(AL-AR)/(AL+AR)
      ENDIF
      IF(
     -  ABS( Z ) .LT. EXTRMZ
     -)THEN
      IF(
     - NZSPRD.GT.2
     -)THEN
            ISEC = 0
            NP = IP - 4
      IF(
     -  NP.GT.NPJETC*2+100 .AND. HW(NP)/8 .EQ. HW(IP)/8
     -)THEN
               ICELL = HW(IP)/128 + 1
               DIS = (HW(NP+3)-HW(IP+3))*
     *               (DRIVEL(ICELL,1)+DRIVEL(ICELL,2))/2.
               IF( ABS(DIS).LT.DISMAX ) ISEC = ISEC + 1
      ENDIF
            NP = IP + 4
      IF(
     -  NP.LT.NPJETC*2+100+HW(NPJETC*2+99) .AND.
     *          HW(NP)/8 .EQ. HW(IP)/8
     -)THEN
               ICELL = HW(IP)/128 + 1
               DIS = (HW(NP+3)-HW(IP+3))*
     *               (DRIVEL(ICELL,1)+DRIVEL(ICELL,2))/2.
               IF( ABS(DIS).LT.DISMAX ) ISEC = ISEC + 1
      ENDIF
            IF( ISEC .EQ. 0 ) IFLAG = 0
      ELSE
             IFLAG = 0
      ENDIF
      ENDIF
        IF(IFLAG.EQ.0 .AND.
     *     ( HW(IP+1).EQ. 32760 .OR. HW(IP+2).EQ. 32760 ) ) IFLAG = 32
      ENDIF
      RETURN
      END

C   10/04/84 807251624  MEMBER NAME  PLYGON   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PLYGON( NN, R, ADX, ADY, L )
C-----------------------------------------------------------------------
C
C   AUTHOR: J. OLSSON      ?      : DRAW POLYGON
C
C LAST MOD: J. HAGEMANN   5/03/88 : 90 DEGREE ROTATION NOW POSSIBLE
C
C
C     DRAW POLYGON WITH NN CORNERS AND RADIUS R, AROUND ADX,ADY POINT
C     IF L NONZERO, A DASHED CODE WILL BE GENERATED
C     IF L < 0    , ROTATION BY 2*PI/(2*NN)
C
C-----------------------------------------------------------------------
C
      COMMON / CJTRIG / PI,TWOPI
C
C
C------------------  C O D E  ------------------------------------------
C
      LA = L
      FISX = 0.
      DEFI = TWOPI/FLOAT(NN)
      IF( LA .GE. 0) GOTO 2
         FISX = DEFI*0.5
         LA = 0
    2 CONTINUE
      CALL MOVEA(ADX+R*COS(FISX),ADY+R*SIN(FISX))
      DO 5 IIK = 1,NN
         FISX = FISX + DEFI
         IF(LA.GT.0) CALL DASHA(ADX+R*COS(FISX),ADY+R*SIN(FISX),LA)
         IF(LA.EQ.0) CALL DRAWA(ADX+R*COS(FISX),ADY+R*SIN(FISX))
    5 CONTINUE
      RETURN
      END

C   10/02/86 604291114  MEMBER NAME  PRTPVXR  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRTPVX( IPTPVX, XS, YS , DEL, SIZE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 29/04/86 :  PRINT BOS BANK TPVX
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CWORK1 / HWORK(70)
C
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*140
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      LIM2   = IPTPVX
      LIMLIM = 2*LIM2
      CALL CORE(HWORK,13)
      WRITE(cHWORK,1) HDATA(LIMLIM+1),HDATA(LIMLIM+2) ! PMF 17/11/99: JUSCRN changed to cHWORK
    1 FORMAT(' ',I4,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,13,0.)
      YS = YS - DEL
      CALL CORE(HWORK,108)
      WRITE(cHWORK,2) (ADATA(LIM2+1+I),I=1,7),IDATA(LIM2+9), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                 ADATA(LIM2+10)
    2 FORMAT(' ',3E12.4,2X,3E12.4,2X,E12.4,I4,3X,E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,108,0.)
      YS = YS - DEL
      CALL CORE(HWORK,51)
      WRITE(cHWORK,3) (HDATA(LIMLIM+20+I),I=1,10) ! PMF 17/11/99: JUSCRN changed to cHWORK
    3 FORMAT(' ',10I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,51,0.)
      MULSEC = HDATA(LIMLIM+22)
      IF( MULSEC .LE. 0 ) GO TO 100
         IVX = 30
    4    IVX1 = 20
         IF( MULSEC+30 .LT. IVX+IVX1 ) IVX1 = MULSEC + 30 - IVX
         YS = YS - DEL
         CALL CORE(HWORK,101)
         WRITE(cHWORK,5) (HDATA(LIMLIM+IVX+I),I=1,IVX1) ! PMF 17/11/99: JUSCRN changed to cHWORK
    5    FORMAT(' ',20I5)
         LIMLO = IVX1*5 + 1
         CALL SYSSYM(XS,YS,SIZE,HWORK,LIMLO,0.)
         IVX = IVX + 20
         IF( IVX .GT. 30+MULSEC ) GO TO 100
            GO TO 4
  100 CONTINUE
      RETURN
      END

C   24/06/85 506240947  MEMBER NAME  CALCOR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE xCALCOR( XWIRE, YWIRE, EEX, EEY, DRFWAY ) ! PMF 11/04/00 CALCOR->xCALCOR
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   17/10/84 :  CALCULATE COORDINATES IN
C                                        R-FI-PLANE FOR VERTEX CHAMBER
C                                        RAW-DATA FROM  B P C H - BANK
C
C-----------------------------------------------------------------------
C
      LOGICAL TBIT, FL18, FL22, FL24
C
#include "cgraph.for"
C
      COMMON/CWORK1/R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,EX,EY,COSPH,SINPH
     +             ,KZAMP
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
C-----------------  C O D E  -------------------------------------------
C
C                            CALCULATE COORDINATES OF DRIFT TIME IN
C                            R-FI-VIEW
      IPRJC = 0
C
      EX    = EEX
      EY    = EEY
C
      XDRF  = DRFWAY*EX
      YDRF  = DRFWAY*EY
C
      X1    = XWIRE + XDRF
      Y1    = YWIRE + YDRF
      R1    = SQRT( X1**2 + Y1**2 )
      FI1   = ATAN2( Y1, X1 )
C
      X2    = XWIRE - XDRF
      Y2    = YWIRE - YDRF
      R2    = SQRT( X2**2 + Y2**2 )
      FI2   = ATAN2( Y2, X2 )
C
      IF( FI1 .LT. 0.0 ) FI1 = FI1 + TWOPI
      IF( FI2 .LT. 0.0 ) FI2 = FI2 + TWOPI
      IF( DSPDTL(9) ) R1 = R1*WRAP(FI1)
      IF( DSPDTL(9) ) R2 = R2*WRAP(FI2)
      IF( .NOT. FL22 .OR. .NOT. FL18 ) GO TO 10
      IF( -X1 .LT. XMINR .OR. -X1 .GT. XMAXR ) IPRJC = 1
      IF( -X2 .LT. XMINR .OR. -X2 .GT. XMAXR ) IPRJC = 1
      IF(  Y1 .LT. YMINR .OR.  Y1 .GT. YMAXR ) IPRJC = 1
      IF(  Y2 .LT. YMINR .OR.  Y2 .GT. YMAXR ) IPRJC = 1
C
   10 CONTINUE
      RETURN
      END

C   23/08/85 702101935  MEMBER NAME  MCTAGF   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      REAL FUNCTION MCTAGF(X,MARKMC)
C
C WEIGHTING FUNCTION FOR INTEGRATION OF TAGGING MC ENERGY DEPOSTION
C      THE FUNCTION DESCRIBES THE LATERAL SPREAD OF THE SHOWER ENERGY.
C      DIFFERENT VALUES ARE USED FOR DIFFERENT VALUES OF MARKMC,
C      BASED ON COMPARISON OF RESULTING THETA/PHI DISTRIBUTIONS
C      WITH LUMI EVENTS IN DATA.
C
C        AUTHOR: A.J.FINCH 8/3/84
C
C   LAST CHANGE: A.J.FINCH 9/2/87
C
C                         - SLOPE FOR MARK 2 TAGGER CHANGED FROM
C                        0.025 TO 0.039, TO OPTIMISE THETA DISTRIBUTION
C                        BY COMPARISION WITH LUMI EVENTS.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C DATA SECTION
C
      DATA XMAX/190.0/
      DIMENSION SLOPE(10)
      DATA SLOPE  /0.025,2*0.039,7*0.0675/
      DATA SLOPE2/0.0325/
      DATA PERCEN/0.45/
      LOGICAL FIRST/.TRUE./
C
C INIIALISATION ON FIRST EVENT
C
      IF( FIRST ) CUTOFF = -(LOG(PERCEN)/SLOPE(4))
      FIRST = .FALSE.
C
C FOR MOST CASES USE SIMPLE SINGLE EXPONENTIAL, ...
C
      IF(MARKMC.GE.4.AND.X.GE.CUTOFF)GOTO 4
         MCTAGF=EXP(-1.0*X*SLOPE(MARKMC))
         RETURN
C
C HOWEVER FOR MARKMC = 4 (I.E.MARK III TAGGER) , AT LARGE X ...
C
 4    CONTINUE
         MCTAGF=PERCEN*EXP(-1.0*SLOPE2*(X-CUTOFF))
         IF(X.GT.XMAX)MCTAGF = 0.0
         RETURN
      END

C   20/03/80 003201329  MEMBER NAME  CUTPED   (S)           FORTRAN
      SUBROUTINE CUTPED
C---  CUT OFF ADC-PEDESTALS (MICROPROCESSOR SUBTRACTED) BELOW 50 CH.
C---  & CREATE NEW VALUES FOR LNG, HPOINT, AND HGGADC
C---  (DEALS WITH 240 ADC-CHANNELS)
C
C     H.WRIEDT     12.06.79       14:00
C     LAST MODIFICATION     20.03.80      13:25
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK(42),LNG,HPOINT(4),HGGADC(2,240)
C
      NDAT = LNG - 2
        DO 100 I = 1,NDAT
        HADR = HGGADC(1,I)
        IF (HGGADC(2,I).GE.50) GOTO 101
C---    CUTOFF OF ADCS WITH LOW CONTENT
C       (THRESHOLD: 49 CHANNELS)
        HGGADC(2,I) = 0
        GOTO 100
C---    SCRATCH UNPHYSICAL ADC-ADDRESSES (I.E. ADDRESSES 208 - 215,
C---    >229) AND CONTENTS
  101   IF ((HADR.GE.208.AND.HADR.LE.215).OR.(HADR.GE.230))
     &   HGGADC(2,I) = 0
  100   CONTINUE
C
      CALL GGSRTH(0,NDAT)
      LNG = 2
        DO 200 I = 1,NDAT
        IF (HGGADC(2,I).LE.0) GOTO 201
  200   LNG = I+2
  201 NDAT = LNG-2
      CALL GGSORT
C
C---  SET UP NEW POINTERS
      HPOINT(1) = 1
      HPOINT(2) = 1
      HPOINT(3) = 1
      IF (NDAT.LE.0) GOTO 211
        DO 210 I = 1,NDAT
        HADDR = HGGADC(1,I)
        IF (HADDR.LE.95) HPOINT(2) = 2*I+1
        IF (HADDR.LE.191) HPOINT(3) = 2*I+1
  210   CONTINUE
  211 HPOINT(4) = 2*NDAT+1
      RETURN
      END

**************************************************
* IPS
* ====
*
*   Emulation of some public IPS routines
*
*   06/10/98  P.A. Movilla Fernandez 
*
*   21/10/99  PMF last mod.
*   09/12/99  PMF last mod.
*
*     GETPDD
*     FREEDD
*     DDCHA
*
**************************************************
**************************************************
      SUBROUTINE GETPDD(NAME,VOLSR,DDN,LUN,HERR)
      IMPLICIT NONE
*
* GETPDD is a public IPS subroutine.
*
* GETPDD allocates a dataset 'NAME' and assigns it
* with a logical file number 'LUN'. If LUN=0 on entry,
* the value of LUN on exit will be decided here.
*
* Use simple OPEN and INQUIRE statement to emulate GETPDD.
*
* Still usefull error codes used here ( see also SUBROUTINE DSERR ) :
* HERR =    1 : all unit numbers have been used 
*      =    3 : dataset non-existent or name wrongly entered
*      =  528 : file for specified unit number already allocated
*               [REQUESTED DS NOT AVAILABLE]
*      =  863 : invalid logical file number 
*               [INVALID PARAMETER]
*      = 1040 : file already allocated
*
* Some 'inofficial' error codes are additionally introduced.
*
      INTEGER LUN
      INTEGER*2 HERR
      CHARACTER NAME*44
      REAL*8 VOLSR,DDN,DDN2
C
      CHARACTER CDDN2*8,CNAME*44,CFMT*11,CSTAT*7
      EQUIVALENCE (DDN2,CDDN2)
      LOGICAL LOCKED,EX,LWRIT
      INTEGER LUN0,LUN9,I,IERR,NUM
      PARAMETER(LUN0=2,LUN9=60)
C
      INTEGER IWFIL/0/
      CHARACTER WFIL*44(10)
      SAVE IWFIL
Code:
      HERR=0
C Check if logical file number and file name is valid
      IF(LUN.NE.0 .AND. (LUN.LT.LUN0 .OR. LUN.GT.LUN9)
     +     .OR. INDEX(NAME,' ').EQ.1 )! .OR. INDEX(NAME,'.').EQ.1 )
     +     THEN
         HERR=863               ! invalid parameter
         GOTO 15
      ENDIF

C Check if logical file number is already in use
      IF(LUN.EQ.0) THEN
         DO I=LUN0,LUN9
            INQUIRE(UNIT=I,OPENED=LOCKED)
            IF(.NOT.LOCKED) THEN
               LUN=I
               GOTO 5           ! found an unlocked unit number, continue
            ENDIF
         ENDDO
         HERR=1                 ! all unit numbers have been used
      ELSE
         INQUIRE(UNIT=LUN,OPENED=LOCKED)
         IF(LOCKED) HERR=528    ! file for specified unit number already allocated
      ENDIF
 5    CONTINUE

C Check if file is an output file ( indicated by a suffix '@' )
      IF( INDEX(NAME,'@').NE.0 ) THEN
         NAME(INDEX(NAME,'@'):INDEX(NAME,'@'))=' '
         LWRIT=.TRUE.
         IWFIL=IWFIL+1
         IF(IWFIL.GT.10) THEN
            HERR=531            ! Maximum number of OUTPUT files reached.
            GOTO 15
         ENDIF
         WFIL(IWFIL)=NAME
      ELSE
         LWRIT=.FALSE.
      ENDIF

C Check if file exists or if file is already allocated
      INQUIRE(FILE=NAME,EXIST=EX,OPENED=LOCKED,NUMBER=NUM)
      IF(.NOT.EX .AND. .NOT.LWRIT ) HERR=3
      IF(LOCKED) THEN 
         IF( .NOT. LWRIT ) THEN
            HERR=1040
            DO I=1,10
               IF( NAME.EQ.WFIL(I) ) THEN 
                  HERR=529 ! It is forbidden to read from an already allocated OUTPUT file.
                  GOTO 10
               ENDIF
            ENDDO
         ELSE
            HERR=530 ! It is forbidden to write into an already allocated INPUT file.
            WFIL(IWFIL)=' '
            IWFIL=IWFIL-1
         ENDIF
 10      LUN=NUM
      ENDIF

C Compose DDN
 15   CONTINUE
      IF(LUN.LT.10) THEN
         WRITE (CDDN2,'(''FT0'',I1,''F001'')') LUN
      ELSEIF(LUN.GE.10.AND.LUN.LT.100) THEN
         WRITE (CDDN2,'(''FT'',I2,''F001'')') LUN
      ELSE
         WRITE (CDDN2,'(''FT??F001'')')
      ENDIF
      DDN=DDN2
         
C Check for special DS names and open them as formatted files
C ( default is unformatted )
      IF( INDEX(NAME,'.HELP.').NE.0 .OR. INDEX(NAME,'.MACROS').NE.0 ) 
     + THEN
         CFMT='FORMATTED'
      ELSE
         CFMT='UNFORMATTED'
      ENDIF

C Output files do not need to exist
      IF( LWRIT ) THEN
         CSTAT='UNKNOWN'
      ELSE
         CSTAT='OLD'
      ENDIF

C Open file
      IF(HERR.EQ.0) THEN
         OPEN(FILE=NAME,UNIT=LUN,IOSTAT=IERR,STATUS=CSTAT,FORM=CFMT)
         IF(IERR.NE.0) HERR=ABS(IERR)+5888
      ENDIF
C
 999  CONTINUE
      WRITE(*,'(''GETPDD: FILE = '',A44)') NAME
      WRITE(*,'(T9,''DDN  ='',A9)') DDN
      WRITE(*,'(T9,''ERR  ='',I5)') HERR
      IF(HERR.EQ.0) THEN
         WRITE(*,'(T9,''ALLOCATION SUCCESFULL'')')
      ELSE
         IF( HERR.EQ.1040) THEN
            WRITE(*,'(T9,''FILE ALREADY ALLOCATED.'')')
         ENDIF
         IF( HERR.GE.528.AND.HERR.LE.531 ) THEN
            WRITE(*,'(T9,''REQUESTED DS NOT AVAILABLE.'')')
         ENDIF
         IF(HERR .EQ. 529) THEN
            WRITE(*,'(T9,''READING AN ALREADY ALLOCATED OUTPUT FILE'
     +           //' NOT ALLOWED.'')')
            HERR=528
         ELSEIF(HERR .EQ. 530) THEN
            WRITE(*,'(T9,''WRITING INTO AN ALREADY ALLOCATED INPUT FILE'
     +           //' NOT ALLOWED.'')')
          HERR=528
         ELSEIF(HERR .EQ. 531) THEN
            WRITE(*,'(T9,''MAXIMUM NUMBER OF OUTPUT FILES REACHED!'')')
            HERR=528
         ENDIF
         WRITE(*,'(T9,''LIST OF ALREADY ALLOCATED DATASETS:'')')
         DO I=LUN0,LUN9
            CNAME=' '
            INQUIRE(UNIT=I,OPENED=LOCKED,NAME=CNAME)
            IF(LOCKED) WRITE(*,'(T12,''LUN='',I2,'' NAME='',A)') 
     +           I,CNAME
         ENDDO
      ENDIF
C     
      RETURN
      END

**************************************************
      SUBROUTINE FREEDD(DDN,HERR)
      IMPLICIT NONE
*
* FREEDD is a public IPS subroutine.
*
* FREEDD releases allocated datasets.
* Use simple CLOSE and INQUIRE statement to emulate FREEDD.
* 
* Still usefull error code used here:
* HERR = 1080 : logical unit number is invalid
*               [DDNAME NOT FOUND]
*
      REAL*8 DDN,DDN2
      CHARACTER CDDN2*8,CNAME*44
      EQUIVALENCE(DDN2,CDDN2)
      INTEGER*2 HERR
      INTEGER LUN,IERR
      LOGICAL LOCKED
C
      INTEGER LUN0,LUN9,I
      PARAMETER(LUN0=11,LUN9=60)
Code:
      HERR=0
C Extract logical unit number from DDN
      DDN2=DDN
      READ(CDDN2,'(2X,I2)') LUN
C Check if logical unit number is valid
      IF( LUN.LT.LUN0 .OR. LUN.GT.LUN9 ) HERR=1080
C
C Verify that file is really allocated. If so, free this file.
      CNAME=' '
      IF(HERR.EQ.0) THEN
         INQUIRE(LUN,OPENED=LOCKED,NAME=CNAME)
         IF(LOCKED) THEN
            CLOSE(LUN,IOSTAT=IERR)
            HERR=IERR
         ELSE
            WRITE(*,FMT=20) DDN
 20         FORMAT('FREEDD: THERE IS NO ALLOCATED FILE'
     +           ,' CORRESPONDING TO DDN=',A8)
            HERR=1080
            CNAME='??'
         ENDIF
      ENDIF
C
 999  CONTINUE
      WRITE(*,'(''FREEDD: FILE = '',A)') CNAME
      WRITE(*,'(T9,''DDN  ='',A9)') DDN
      IF(HERR.EQ.0) THEN
         WRITE(*,'(T9,''RELEASE SUCCESFULL'')')
      ELSE
         WRITE(*,'(T9,''RELEASE SOMEHOW WRONG!!!'')')
         WRITE(*,'(T9,''LIST OF ALLOCATED DATASETS:'')')
         DO I=LUN0,LUN9
            CNAME=' '
            INQUIRE(UNIT=I,OPENED=LOCKED,NAME=CNAME)
            IF(LOCKED) WRITE(*,'(T12,''LUN='',I2,'' NAME='',A)') I,CNAME
         ENDDO
      ENDIF
C
      RETURN
      END

*****************************************************
      SUBROUTINE DDCHA( DDN, NAME, HERR, HVOL )
      IMPLICIT NONE
*
* Don't know where DDCHA comes from.
*
* Here, DCCHA asks for a dataset name and allocates
* the dataset. This emulation uses simply GETPDD.
* 
*
      REAL*8 DDN,DDN2,VOLSR
      CHARACTER CDDN2*8,NAME*44,C*44
      EQUIVALENCE(DDN2,CDDN2)
      INTEGER*2 HERR,HVOL(3)
      INTEGER LUN,INDEX
Code:
C Extract logical unit number from DDN
      DDN2=DDN
      READ(CDDN2,'(2X,I2)') LUN
C Read dataset name
      CALL VBLANK(C,11)
 10   WRITE(*,'(''ENTER DATASET NAME: '',$)')
      READ(*,'(A44)') C
      IF( INDEX(C,' ').EQ.1 ) GOTO 10 
C Allocate dataset
      NAME=C
      CALL GETPDD(NAME,VOLSR,DDN,LUN,HERR)
C
      RETURN
      END
**

C   09/08/85 508101747  MEMBER NAME  DISPZC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DISPZC( LVIEW )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   9/08/85 :  DISPLAY Z CHAMBER HITS
C
C     DISPLAYS THE HIT INFORMATION FOR THE Z CHAMBER
C
C     LVIEW :  1 = R-PHI VIEW
C              2 = ZX AND ZY VIEWS
C              3 = ROLLED OUT VIEW
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL DSPDTM
C
#include "cdata.for"
C
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
C
C------------------  C O D E  ------------------------------------------
C
      IF( .NOT. DSPDTM(11) ) RETURN
C
      IPZETC = IDATA(IBLN('ZETC'))
      IF( IPZETC .LE. 0 )    RETURN
      LENZC  = IDATA(IPZETC)
      IF( LENZC  .LT. 3 )    RETURN
C
      IZHITS = (LENZC-1)/2
      NWO    = IPZETC + LENZC -2
      IPZETC = IPZETC + 1
  10  IF( IPZETC .GT. NWO )  RETURN
C
      NWIR   = HDATA(2*IPZETC + 1)/8
C
C                            GET THE HIT COORDINATES
C
      CALL RZHITS( IPZETC, XZ,YZ, XZ1,YZ1, XZ2,YZ2, ZZ1,ZZ2, IERR )
C
C                            DRAW THE Z CHAMBER FOR VIEW = LVIEW
C
      CALL RZDRAW( NWIR, XZ,YZ, XZ1,YZ1, XZ2,YZ2, ZZ1,ZZ2, LVIEW )
C
      IPZETC = IPZETC + 2
      GO TO 10
C
      END

C   16/08/80 008210544  MEMBER NAME  LGSUBC                 FORTRAN
      SUBROUTINE LGSUBC(IC,HSUB)
C         CALUCULATES THE SUBTRACTION CONST WHEN TOO MANY HITS
C         OCCUR IN CRATE IC. IC=4 FOR ALL CRATES.
C         HSUB=AV+3*SIGMA OF 80% LOWEST PH.
C                       16/8/80       Y.WATANABE
      IMPLICIT INTEGER *2 (H)
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
     1               HTEMP(2880)
      DIMENSION HC(2,4)
      DATA HC/0,959,960,1919,1920,2879,0,2879/
C     ORDER THE PULSE HIGHT FROM THE LOWEST
      HIT=LNG-3
      HSUB=0
      IF(HIT.LT.1) RETURN
      ND=0
      DO 10 I=1,HIT
      IF(HLGADC(1,I).LT.HC(1,IC)) GO TO 10
      IF(HLGADC(1,I).GT.HC(2,IC)) GO TO 15
      ND=ND+1
      HTEMP(ND)=HLGADC(2,I)
10    CONTINUE
15    IF(ND.LT.1) RETURN
C     WRITE(6,900) IC,HIT,ND
C     WRITE(6,910) (HTEMP(J),J=1,ND)
C
      M = ND
   20 M = M/2
      IF(M.EQ.0) GO TO 50
      K = ND-M
        DO 40 J=1,K
        I = J
   30   IF(I.LE.0) GO TO 40
        IF( HTEMP(I+M).GE.HTEMP(I) ) GO TO 40
C----   REPLACING
        HW = HTEMP(I)
        HTEMP(I) = HTEMP(I+M)
        HTEMP(I+M) = HW
        I = I-M
        GO TO 30
   40   CONTINUE
      GO TO 20
C
50    CONTINUE
C     WRITE(6,900) IC,HIT,ND
C900  FORMAT('0 LGSUBC; IC,HIT,ND',10I6)
C     WRITE(6,910) (HTEMP(J),J=1,ND)
C910  FORMAT(20I6)
      ND=ND-30
      IF(IC.EQ.4) ND=ND-90
      IF(ND.LT.1) RETURN
      XM=0.
      S=0.
      DO 60 I=1,ND
      PH=HTEMP(I)
      XM=XM+PH
      S=S+PH*PH
60    CONTINUE
C
      XM=XM/ND
      S=S/ND-XM*XM
      IF(S.LT.0.) S=0.
      S=SQRT(S)
      HSUB=XM+3.*S
C     WRITE(6,920) IC,ND,HSUB,XM,S
C920  FORMAT(' LGSUBC; IC,ND,SUB,XM,S',3I6,6F10.3)
      RETURN
      END

C   21/11/78 C9012301   MEMBER NAME  ZBOS02   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------200000200
C     2.  CREATION OF BANKS
C
C     2.1  CREATION OF A BANK
C
C                   -- -- --                               -- -- --
C     CALL BCRE(IND,NA,NR,NW,&S1,IER)        CALL CCRE(IND,NA,NR,NW,IER)
C               ---          --- ---                   ---          ---
C
C        WHERE NA = NAME OF THE BANK
C              NR = NUMBER OF THE BANK
C              NW = NUMBER OF WORDS OF THE BANK (NW.GE.0)
C             IND = INDEX OF BANK (IER=1, IF BANK ALREADY EXISTING)
C        ALL WORDS OF THE BANK ARE SET TO ZERO.
C
C
C     SPECIAL CONDITIONS
C                              BCRE              CCRE
C
C     BANK ALREADY PRESENT *)  IER=1             IER=1
C                              NORMAL RETURN
C
C     NOT ENOUGH SPACE         IND=0             IND=0
C                              IER=2             IER=2
C                              RETURN 1
C
C     *) IF THE ARGUMENT NW IS LARGER THAN THE LENGTH OF THE
C     EXISTING BANK, THE LENGTH OF THE BANK IS CHANGED TO THE
C     LENGTH GIVEN IN THE ARGUMENT, ALL ADDITIONAL WORDS ARE
C     SET TO ZERO (THE BANK IS MOVED TO THE END OF THE USED
C     BANK SPACE).
C     NOTE, THAT IN THE PREVIOUS BOS-VERSION THE LENGTH WAS
C     LEFT UNCHANGED.
C
C
C     IF THE NEW CREATED BANK BELONGS TO AN EVENT IN AN
C     EVENT-BY-EVENT PROCESSING PROGRAM, THE NAME OF THE
C     CREATED BANK SHOULD BE ADDED TO THE SPECIAL LIST (SEE
C     CH. 4).
C     THE BANK NAME IS ADDED TO THE SPECIAL LIST BY ONE OF
C     THE STATEMENTS
C         CALL BSAW(1,NA)     OR    BSAT(1,NA).
C     BSAT HAS TO BE USED, IF THE BANK SHOULD NOT BE ADDED
C     TO THE EVENT IN AN OUTPUT RECORD, BUT HAS TO BE DELETED
C     AFTER PROCESSING THE EVENT.
C
C
C
C
C
C
C
C     2.2  CHANGING THE LENGTH OF A BANK
C
C
C               --- --
C     CALL BCHM(IND,NW,IER)
C               ---    ---
C
C        WHERE NW = CHANGE IN LENGTH OF THE BANK (NW.LT.0 VALID)
C             IND = INDEX OF THE BANK TO BE CHANGED IN LENGTH
C
C     IF POSSIBLE, THE LENGTH OF THE BANK IS CHANGED WITHOUT MOVING
C     THE BANK. FOR NW=0, THE BANK IS MOVED TO THE END.
C
C
C     A BANK LENGTH OF AT LEAST NW WORDS IS OBTAINED BY THE FOLLOWING
C     CALL.
C               --- --
C     CALL BCHF(IND,NW,IER)
C               ---    ---
C
C        WHERE NW = MINIMUM LENGTH OF THE BANK
C             IND = INDEX OF THE BANK
C
C     THE BANK LENGTH IS CHANGED, IF THE ACTUAL LENGTH IS LESS
C     THAN NW.
C
C     ADDITIONAL WORDS OF THE BANK ARE NOT SET TO ZERO (SEE REMARK
C     IN CH. 2.1).
C
C
C     SPECIAL CONDITIONS
C                                               BCHM,BCHF
C
C     WRONG INDEX IND IN ARGUMENT, OR            IER = 1
C     BANK LENGTH WILL BECOME NEGATIVE
C
C     NOT ENOUGH SPACE                           IER = 2
C
C
C
C     2.3  STORAGE OF DATA IN A BANK
C
C               --- -- --
C     CALL BSTR(IND,JW,NW)
C
C
C     WHERE IND = INDEX
C           JW  = ARRAY TO BE STORED
C           NW  = LENGTH OF JW
C
C     JW(1) IS STORED IN IW(IND+1) ETC.
C
C
C
C
C
C
C     2.4  RENAMING A BANK
C
C     THE NAME AND NR OF A BANK CAN BE CHANGED (IN PLACE).
C
C               ------ ----- ------ -----
C     CALL BRNM(NAMOLD,NROLD,NAMNEW,NRNEW)
C
C        WHERE NAMOLD, NROLD = NAME AND NR OF AN EXISTING BANK
C              NAMNEW, NRNEW = NEW NAME AND NR OF THE BANK
C
C
C
C     2.5  CALLS OF THE PREVIOUS VERSION
C
C
C
C               --                                   --
C     CALL BCHL(NW,&S1)                    CALL CCHL(NW,IER)
C                  ---                                  ---
C
C        WHERE NW = CHANGE IN LENGTH OF THE BANK (NW.LT.0 VALID)
C
C
C
C     NOTE, THAT ONLY THE LENGTH OF THE LAST CREATED BANK CAN
C     BE CHANGED DIRECTLY. A SAFER WAY OF CHANGING THE LENGTH
C     OF A BANK IS BY USING BCHM OR BCHF (SEE CH. 2.2).
C
C               ---                                     ---
C     CALL BMVE(IND,&S1)                      CALL CMVE(IND,IER)
C               --- ---                                 --- ---
C        WHERE IND = INDEX OF BANK TO BE MOVED
C     THE BANK IS MOVED TO THE END OF THE USED STORAGE, IND
C     IS CHANGED. AFTER BMVE THE LENGTH OF THE BANK CAN BE CHANGED
C     BY BCHL.
C
C     SPECIAL CONDITIONS
C                                  BCHL,BMVE   CCHL,CMVE
C     NOT ENOUGH SPACE              RETURN 1     IER=2
C
C
C
C
C
C
C
C
C
C
C
C
C
      RETURN
      END

C   12/03/84 412041858  MEMBER NAME  PEDFX2   (S)           FORTRAN
C
C
C
C
C
C
C
      SUBROUTINE TAGPD1
C
C ROUTINE TO SUBTRACT PEDESTALS - 1981/1982
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
       INTEGER*4 TEST(64)/  3,4,6,7 ,5,8,9,12 ,10,11,13,14 ,15,16,17,1
     *             ,19,20,22,23 ,21,24,25,28 ,26,27,29,30 ,31,32,1,2
     *             ,33,34,63,64 ,35,36,38,39 ,37,40,41,44 ,42,43,45,46
     *             ,47,48,49,50 ,51,52,54,55 ,53,56,57,59 ,58,59,61,62/
       VALUE  = 800.0
       APICKM = 0.0
       APICKP = 0.0
       NUMM   = 0
       NUMP   = 0
C
C
C
C
C 1/4 OF A TAGGING SYSTEM =
C
C                               ___________
C                               I    I    I
C                     __________I    I    I
C                     I    I    L____L____I
C                     I    I    I    I    I
C                     L____L____I    I    I
C                     I    I    L____L____I
C                     I    I    I
C                  ___L____L____I
C                  I    I    I
C                  I    I    I
C                  L____L____I
C                  I    I    I
C                  I    I    I
C                  L____L____I__
C                     I    I    L
C                     I    I    I__________
C                     L____L____I    I    I
C                     I    I    L    I    I
C                     I    I    I____L____I
C                     L____L____I    I    I
C                               I    I    I
C                               L____L____I
C
C   'SUPERBLOCK' =
C
C                  ___________
C                  I    I    I
C                  I    I    I
C                  L____L____I
C                  I    I    I
C                  I    I    I
C                  L____L____I
C
C

C
C LOOP OVER ALL 'SUPERBLOCKS' (SET OF FOUR BLOCKS) IN -Z TAGGER
C
       DO 10 I = 1,32,4
C
          K = I + 3
C
C LOOP OVER ALL MEMBERS OF SUPERBLOCK
C
          DO 20 J = I,K
             ITEST = TEST(J)
C
C      TEST FOR GREATER THAN 'VALUE'
C
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 10
   20     CONTINUE
C
C   NONE OF THE BLOCKS IN THE SUPERBLOCK UNDER TEST HAVE FAILED
C   TO BE LESS THAN 800,SO ANY HITS MUST BE PEDESTALS
C
          DO 30 L = I,K
             ITEST = TEST(L)
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 30
             APICKM = APICKM+CATAG(ITEST)
             NUMM = NUMM + 1
   30     CONTINUE
   10  CONTINUE
C
C NOW PLUS ZED
C
       DO 11 I = 33,64,4
C
          K = I+3
          DO 21 J = I,K
             ITEST = TEST(J)
             IF ( CATAG(ITEST) .GT. VALUE ) GOTO 11
   21     CONTINUE
C
C   NONE OF THE BLOCKS IN THE SUPERBLOCK UNDER TEST HAVE FAILED
C   TO BE LESS THAN 800
C
          DO 31 L = I,K
             ITEST = TEST(L)
             IF ( CATAG(ITEST) .EQ. 0 ) GOTO 31
             APICKP = APICKP+CATAG(ITEST)
             NUMP = NUMP + 1
   31     CONTINUE
   11  CONTINUE
C
C    CALCULATE THE MEAN NON ZERO PEDESTAL
C
       IF ( NUMM .EQ. 0 ) GOTO 50
       APICKM = APICKM/NUMM
C
C NOW WE HAVE THE VALUES APICKP AND APICKM TO BE SUBTRACTED
C  DO THE SUBTRACTION
C
       IF ( NUMM .LE. 4 ) GOTO 50
       DO 40 I = 1,32
          IF ( CATAG(I) .EQ. 0 ) GOTO 40
          CATAG(I) = CATAG(I) - APICKM
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   40  CONTINUE
C
C
*** PMF 15/10/99: new GOTO label introduced behind the 'END DO'-CONTINUE statement at label 41
*   50  IF ( NUMP .EQ. 0 ) GOTO 41
*       IF ( NUMP .LE. 4 ) GOTO 41
   50  IF ( NUMP .EQ. 0 ) GOTO 42
       IF ( NUMP .LE. 4 ) GOTO 42
*** PMF (end)
C
       APICKP = APICKP/NUMP
C
       DO 41 I = 33,64
          IF ( CATAG(I) .EQ. 0 ) GOTO 41
          CATAG(I) = CATAG(I) - APICKP
          IF ( CATAG(I) .LT. 0) CATAG(I) = 0
   41  CONTINUE
*** PMF 15/10/99: new label added for a former GOTO statement
   42  CONTINUE
*** PMF (end) 
C
C
        RETURN
        END

C   05/12/86 705202135  MEMBER NAME  LGST56   (S)           FORTRAN
      SUBROUTINE LGST56(JBC,PRTCLO,EMEV,AMASS2,LGMDMP)
C
C  COPIED FROM F22YAM.LG.S(LGSTRM) FOR MODIFICATION TO USE IN SF5-SF6
C
CC    S.YAMADA   18-12-78  20:30     COPIED FROM LGSTRC
CC    LAST MODIFICATION     14-06-82   14:25
C
C---- LG SHOWER TRACING BY M.C. TO GENERATE DATA FOR CLUSTER FINDING.
C     CALLED FROM LGMC56
C
C LAST CHANGE  J.OLSSON  5.12.1986   (REINSTALMENT OF LOST VERSION FROM
C                                     23.1.1986)
C
C     ON INPUT, POSITION COMPONENT OF PRTCLO (1-3,2,N) IN UNIT OF MM
C
C
      IMPLICIT INTEGER *2 (H)
C
      DIMENSION PRTCL(3,3,1000),SPTCL(3,3,1000),PRTCLO(9)
      DIMENSION PAQ(9,1000)
      EQUIVALENCE (PAQ(1,1),PRTCL(1,1,1))
      DATA MNP/1000/
C
C  SHOWER MC COMMON
C
      COMMON /CLGD56/ RADIUS(6),ZEND(2),ZWID,ZGAP,PHWID,
     2                ECXLST(24), ECYLST(24),ZECAP(4),ZPV(4),TPV,
     3                TH(4),THECP
C
      COMMON /CMATTR/ IMATTR,IMTLIS(10),XCM(10)
C
      COMMON /CCSF56/ NFINAL,NTR56
C
      COMMON /BCS/ IW(30000)
      DIMENSION HW(1),AW(1)
      EQUIVALENCE(IW(1),HW(1)),(IW(1),AW(1))
C
      COMMON / COLSON/ IPRO
      INTEGER*2 HDATE
      COMMON /TODAY/ HDATE(6)
C
C Z LIMIT OF THE SF6 PART OF THE BARREL  +- 3 ROWS
C    SET LIMIT SO THAT SF5 IS REACHED AFTER 1/3 OF BLOCK DEPTH
C    I.E. 3*106 = 318 AT 1100 + 100 DEPTH:   291.5 AT 1100
C
      DATA SF6LIM / 292./
C
C---- COPY INPUT TRACK
C
        DO 1 K=1,9
    1   PAQ(K,1) = PRTCLO(K)
C
      IF(LGMDMP.GE.3.OR.IPRO.NE.0) WRITE(6,6001) JBC,(PAQ(K,1),K=1,9)
 6001 FORMAT(' JBC,PAQ=',I3,2X,F6.1,F9.1,F6.1,3F8.1,2X,3F9.3)
C
C---- THE UNIT OF AMASS IS MEV/C**2.
C
      IF(IPRO.NE.0) WRITE(6,557) AMASS2
557   FORMAT(' LGST56: AMASS2 ',E12.4)
C
      IF(AMASS2.GT.1.0) GO TO 15
C
C-----ONLY FOR ELECTRONS AND/OR GAMMAS
C-----REMEMBER THE TRACK POSITION AND DIRECTION AND MODIFY THE
C     DIRECTION FOR SHOWER SIMULATION.
C
C
C  USE THE SPECIAL VERSION OF LSCCTL, THAT DOESNOT CHANGE TO X0 UNIT
C
      IF(IPRO.NE.0) WRITE(6,558) JBC
558   FORMAT(' LGST56: JBC AT CALL OF LSCCTL ',I4)
C
      CALL LSCCTL(PAQ(4,1),JBC)
C
      IF(LGMDMP.GT.0.OR.IPRO.NE.0) WRITE(6,6003) JBC,(PAQ(K,1),K=1,9)
 6003 FORMAT(' PAQ AFTER LSCCTL,JBC=',I3,/' ',F5.1,2F9.1,3F9.2,3F9.3)
C
C RADIATION LENGTH XCM IS GIVEN IN UNIT CM
C   START WITH AL-ABSORBER, BOTH FOR BARREL AND ENDCAPS
C
      IMATTR = 1
      XJJ = XCM(IMATTR) * 10.
C
      IF(JBC.NE.0) GO TO 11
C
C#########################################
C-                            --- BARREL PART  -----------------------
C#########################################
C
C
C  IF 1983-86, DETERMINE WHETHER IMPACT IN SF5 OR SF6 PART OF BARREL
C----
C----    PRTCLO  CHARGE      ENERGY(ELMASS)       LENGTH
C----            POS X         POS Y              POS Z      (MM)
C----           DIRCOS        DIRCOS             DIRCOS
C----
        ZTEST = PRTCLO(6)*RADIUS(3)/RADIUS(1)
C
      IMATTS = 2
      IF(HDATE(6).GT.1982.AND.ABS(ZTEST).LT.SF6LIM) IMATTS = 3
C
      IF(IPRO.NE.0) WRITE(6,559) PAQ(6,1),ZEND(1),ZEND(2)
559   FORMAT(' LGST56: PAQ(6,1) ZEND(1-2) ',3E14.6)
C
      IF(PAQ(6,1).GE.ZEND(1) .AND. PAQ(6,1).LE.ZEND(2)) GO TO 16
      JESC = 1
      GO TO 50
C                  IMATTR=1:  ALUMINIUM ABSORBER PART
   16 IMATTR = 1
C  FAR END OF MATERIAL IS GIVEN BY ARGBOU
      ARGBOU = RADIUS(2)/XJJ
C     DUM = BOUNDI(RADSX0(2))
      DUM = BOUNDI(ARGBOU)
      NP = 1
      JBACK = 0
C
C  CASSHW USES RAD. LENGTH FOR THE MATERIAL AS UNIT, CONVERT
C
      PRTCL(1,2,NP) = PRTCL(1,2,NP)/XJJ
      PRTCL(2,2,NP) = PRTCL(2,2,NP)/XJJ
      PRTCL(3,2,NP) = PRTCL(3,2,NP)/XJJ
C
      IF(IPRO.NE.0) WRITE(6,560)
560   FORMAT(' LGST56: CALL CASSHW  1 ')
C
C
      CALL CASSHW(PRTCL,SPTCL,MNP,NP,IER,JBACK)
C
C STORE INFORMATION ON RETURNING PARTICLES IN BOS-BANK SF56
C
      IF(NTR56.GT.NFINAL) GO TO 1200
      IPSF56 = IW(IBLN('SF56'))
      IF(IPSF56.GT.0) IW(IPSF56 + NTR56+1) = NP
C
C   CONVERT  BACK TO UNIT MM FOR ALL RETURNED PARTICLES  (NP)
C
1200  CONTINUE
      DO 5940 IP = 1,NP
      DO 5941 IJ = 1,3
5941  PRTCL(IJ,2,IP) = PRTCL(IJ,2,IP)*XJJ
5940  CONTINUE
C
C---- TRACE THE TRACK BEHIND THE COIL FOR THE BARREL PART.
C---- TH(2) IS THE THICKNESS OF AIRGAP   AL - LEADGLASS
C
C
      IF(IPRO.NE.0) WRITE(6,562) NP,PRTCL(1,2,NP)
562   FORMAT(' LGST56: NP BEHIND AL ',I4,' PRTCL12 ',E12.4)
C
C    TRANSPORT TO FRONT END OF LEADGLASS
C    NOTE BUG IN OLD CODE!      J.O.  24.4.87
C
      NEW =0
        DO 20 N=1,NP
C  SKIP BACKWARD DIRECTED PARTICLES
        IF(PRTCL(1,3,N).LE.0.) GO TO 20
        NEW = NEW+1
C       S = THX0(2)/PRTCL(1,3,N)
C       S = TH(2)/PRTCL(1,3,N)
        S = (RADIUS(3)-PRTCL(1,2,N))/PRTCL(1,3,N)
          DO 21 K=1,3
   21     PRTCL(K,2,NEW) = PRTCL(K,2,N)+PRTCL(K,3,N)*S
        IF(NEW.EQ.N) GO TO 23
          DO 22 K=1,3
          PRTCL(K,1,NEW) = PRTCL(K,1,N)
          PRTCL(K,3,NEW) = PRTCL(K,3,N)
   22     CONTINUE
C----   NEGLECT ESCAPING PARTICLES AT BARREL ENDS
   23   IF(ABS(PRTCL(3,2,NEW)).GT.ZEND(2)) NEW = NEW-1
   20   CONTINUE
      NP0 = NP
      NP = NEW
      IF(IPRO.NE.0) WRITE(6,5622) NP,PAQ(4,NP)
5622  FORMAT(' LGST56: NP BEHIND AL,TRANSPORTED ',I4,' PAQ4 ',E12.4)
      JESC = 0
      IF(NP.EQ.0) JESC = 1
      IF(JESC.NE.0) GO TO 50
C
      IF(LGMDMP.GT.1.OR.IPRO.NE.0)
     $ WRITE(6,6000) NP0,NP,((PAQ(I,K),I=1,9),K=1,NP)
 6000 FORMAT(' NP0,NP=',2I5,/(' ',F5.1,F9.1,F6.1,2X,3F8.1,3F8.3))
      IMATTR = IMATTS
      XJJ = XCM(IMATTR) * 10.
C
      ARGBOU = RADIUS(4)/XJJ
      DUM = BOUNDI(ARGBOU)
C     DUM = BOUNDI(RADSX0(4))
C
      IF(IPRO.NE.0) WRITE(6,561) IMATTR,XJJ,ZTEST,ARGBOU
561   FORMAT(' LGST56: IMATTR AND XJJ ZTEST ARGBOU',I3,3E12.4)
C
C
C   CONVERT  BACK TO UNIT RAD.LENGTH FOR ALL PARTICLES
C
      DO 5943 IP = 1,NP
      DO 5942 IJ = 1,3
5942  PRTCL(IJ,2,IP) = PRTCL(IJ,2,IP)/XJJ
5943  CONTINUE
C
C
      IF(IPRO.NE.0) WRITE(6,572) NP
572   FORMAT(' LGST56: NP CALLING CASSHW 2 ',I4)
C
      IF(IPRO.NE.0)
     $ WRITE(6,6500) ((PAQ(I,K),I=1,9),K=1,NP)
 6500 FORMAT(' ',F5.1,F9.1,F6.1,2X,3F8.1,3F8.3)
      CALL CASSHW( PRTCL,SPTCL, MNP,NP, IER,JBACK)
C
      IF(IPRO.NE.0) WRITE(6,573) IER
573   FORMAT(' LGST56: IER AFTER CALLING CASSHW 2:',I4)
C
      IF(IER) 90,100,90
C
C########################################
C-                           --- END CAP ----------------------------
C########################################
C
C  11 DUM = BOUNDI(ZECAPX(4))
C
   11 ARGBOU = ZPV(4) / XJJ
      DUM = BOUNDI(ARGBOU)
      NP = 1
      JBACK = 0
C
C  CASSHW USES RAD. LENGTH FOR THE MATERIAL AS UNIT, CONVERT
C
      PRTCL(1,2,NP) = PRTCL(1,2,NP)/XJJ
      PRTCL(2,2,NP) = PRTCL(2,2,NP)/XJJ
      PRTCL(3,2,NP) = PRTCL(3,2,NP)/XJJ
C
C
      IF(IPRO.GT.0) WRITE(6,574) NP
574   FORMAT(' LGST56: NP BEFORE CALLING CASSHW 3:',I4)
C
      CALL CASSHW( PRTCL,SPTCL, MNP,NP,IER,JBACK)
C
C   CONVERT  BACK TO UNIT MM FOR ALL RETURNED PARTICLES
C
      DO 5945 IP = 1,NP
      DO 5944 IJ = 1,3
5944  PRTCL(IJ,2,IP) = PRTCL(IJ,2,IP)*XJJ
5945  CONTINUE
C
C---- TRACE THE TRACK BEHIND THE I.C. ENDCAP TILL LG FRONT SURFACE
C      ZECAP(3) IS FRONT END OF +Z ENDCAP LG   ZPV(4) IS BACK END OF AL
C
      NEW =0
C
      IF(IPRO.GT.0) WRITE(6,575) NP
575   FORMAT(' LGST56: NP AFTER AL               :',I4)
C
C   TRANSPORT TO FRONT END OF LEAD GLASS, NOTE BUG IN PREVIOUS CODE
C     CORRECTED 24.4.87   J.O.
C
        DO 30 N=1,NP
        IF(PRTCL(1,3,N).LE.0.) GO TO 30
        NEW = NEW+1
C       S = (ZECAP(3)-ZPV(4))/PRTCL(1,3,N)
        S = (ZECAP(3)-ABS(PRTCL(1,2,N)))/PRTCL(1,3,N)
          DO 31 K=1,3
   31     PRTCL(K,2,NEW) = PRTCL(K,2,N)+PRTCL(K,3,N)*S
        IF(NEW.EQ.N) GO TO 33
          DO 32 K=1,3
          PRTCL(K,1,NEW) = PRTCL(K,1,N)
          PRTCL(K,3,NEW) = PRTCL(K,3,N)
   32     CONTINUE
C----   NEGLECT ESCAPING PARTICLES.
   33   IF(SQRT(PRTCL(2,2,NEW)**2+PRTCL(3,2,NEW)**2).GE.RADIUS(1) )
     $       NEW = NEW - 1
   30   CONTINUE
      NP0 = NP
      NP = NEW
      JESC = 0
      IF(NP.EQ.0) JESC = 1
      IF(JESC.NE.0) GO TO 50
C
      IF(LGMDMP.GT.1.OR.IPRO.GT.0)
     $ WRITE(6,6000) NP0,NP,((PAQ(I,K),I=1,9),K=1,NP)
C
C   SF5 TYPE LEAD GLASS
C
      IMATTR = 2
      XJJ = XCM(IMATTR)*10.
C
      ARGBOU = ZECAP(4)/XJJ
      DUM = BOUNDI(ARGBOU)
C
C   CONVERT  BACK TO UNIT RAD.LENGTH FOR ALL PARTICLES
C
      DO 5947 IP = 1,NP
      DO 5946 IJ = 1,3
5946  PRTCL(IJ,2,IP) = PRTCL(IJ,2,IP)/XJJ
5947  CONTINUE
C
C
      IF(IPRO.GT.0) WRITE(6,576) NP
576   FORMAT(' LGST56: NP BEFORE CALLING CASSHW 5:',I4)
C
      CALL CASSHW( PRTCL,SPTCL, MNP,NP, IER,JBACK)
C
      IF(IPRO.GT.0) WRITE(6,577) IER
577   FORMAT(' LGST56: IER AFTER CALLING CASSHW 5:',I4)
C
C
      IF(IER) 90,100,90
C
C---- CHARGED TRACK PENETRATION THROUGH THE LEAD GLASS
C
   15 CALL LGCHRG( EMEV,AMASS2,PAQ(4,1),JBC, JESC )
C
      IF(JESC) 50,100,50
   50 IF(LGMDMP.GE.3) WRITE(6,6004) JBC,JESC
 6004 FORMAT(' OUT OF DET. JBC=',I4,'   JESC=',I4)
  100 RETURN
C
C---- ERROR IN CASSHW
   90 WRITE(6,690) IER
  690 FORMAT(' *** ERROR IN CASSHW   PRINTED IN LGST56,IER=',I4)
      RETURN
      END

C   03/05/80 109091220  MEMBER NAME  TOFCHK   (JADEGS)      FORTRAN
      SUBROUTINE TOFCHK(TDIF,TSUM,NRUN)
      IMPLICIT INTEGER*2 (H)
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
      TDIF = 0.
      TSUM = 0.
      CALL TOFSMP(NRUN)
      IF(NTOF.LE.0) GO TO 5123
      NRS = 0
      DO 32 JK = 1,21
      IF(HTOF(JK).EQ.0.OR.ABS(TTOF(JK)).EQ.0.) GO TO 32
      IF(TTOF(JK).EQ.-20.) GO TO 32
      TOF1 = TTOF(JK)
      JK1 = JK + 18
      NRT = 0
      TOF2 = 0.
      DO 33 IBT = 1,5
      JK2 = JK1 + IBT
      IF(JK2.GT.42) JK2 = 42
      IF(HTOF(JK2).EQ.0.OR.ABS(TTOF(JK2)).EQ.0.) GO TO 33
      IF(TTOF(JK2).EQ.-20.) GO TO 33
      NRT = NRT + 1
      TOF2 = TOF2 + TTOF(JK2)
33    CONTINUE
      IF(NRT.EQ.0) GO TO 32
      TOF2 = TOF2/NRT
      NRS = NRS + 1
      TDIF = TDIF + TOF1 - TOF2
      TSUM = TSUM + TOF1 + TOF2
   32 CONTINUE
      IF(NRS.EQ.0) GO TO 5123
      TDIF = - TDIF / NRS
      TSUM = TSUM / NRS
5123  RETURN
      END

C   14/03/84            MEMBER NAME  TRACKS   (S)           FORTRAN
C   27/06/79 C9062701   MEMBER NAME  TRACKS   (S)           FORTRAN
      SUBROUTINE TRACKS
C---  COMBINE AVAILABLE INFORMATION OF LUMONITORS, LEAD-GLASS, AND
C---  DRIFT-CHAMBERS IN ORDER TO CREATE TRACK INFORMATION TO BE STORED
C---  IN OUTPUT BANK TAGG/4
C***  UP TO NOW NO DRIFT-CHAMBER INFORMATION AVAILABLE, THEREFORE THE
C***  FOLLOWING IS DONE:
C***   A) EACH 'TRACK' IS DEFINED BY A LEAD-GLASS CLUSTER; THE NUMBERS
C***      OF CLUSTERS AND TRACKS ARE IDENTICAL
C***   B) EACH 'TRACK' POINTS TO THE INTERSECTION REGION
C***   C) EACH 'TRACK' HAS EXACTLY ONE ASSOCIATED LEAD-GLASS CLUSTER
C***   D) THE COORDINATES OF THE 'TRACKS' IN THE DRIFT-CHAMBER PLANES
C***      ARE LEFT EMPTY
C
C     H.WRIEDT         27.6.79       02:15
C     LAST MODIFICATION      27.6.79       02:15
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK1(501),HITRAK(3),HCLST,HCLBEC(2),IWORK2(97),
     &               CLSPRP(13,51),IWORK3(25),HLULAT,HWORK1,IWORK4(10),
     &               TRACK(10,51)
      DIMENSION HCLSPR(26,51), HTRACK(20,51)
      EQUIVALENCE (HCLSPR(1,1),CLSPRP(1,1)), (HTRACK(1,1),TRACK(1,1))
C
      NTRACK = HCLST
      IF (NTRACK.LE.0) RETURN
        DO 10 I = 1,NTRACK
        HTRACK(1,I) = I
        HTRACK(2,I) = 1
        HTRACK(3,I) = HCLSPR(1,I)
        HCLSPR(3,I) = 1
        HCLSPR(4,I) = HTRACK(1,I)
        CALL LUMONS(ICOMB,I)
        HTRACK(4,I) = ICOMB
        ILATCH = HLULAT
        ITEST = JBYTET(ILATCH,ICOMB,1,16)
        HTRACK(5,I) = ITEST
        IF (HCLSPR(2,I).EQ.-1) HITRAK(2) = HITRAK(2) + 1
   10   IF (HCLSPR(2,I).EQ.+1) HITRAK(3) = HITRAK(3) + 1
      HITRAK(1) = NTRACK
      RETURN
      END

C   14/03/84 508301932  MEMBER NAME  GGCCTL   (S)           FORTRAN
C   28/09/78 001101647  MEMBER NAME  GGCCTL   (S)           FORTRAN
      SUBROUTINE GGCCTL(*)
C
C     H.WRIEDT      16-11-78  14:30
C     LAST MODIFICATION   10.01.80  16:50
C
C     ORIGINALLY WRITTEN AS 'LGCCTL' BY S.YAMADA
C     AS TO BE FOUND ON YAMLGSRC.S
C
C
C---  CONTROL SUBROUTINE FOR GGCLUS
C---  THIS IS CREATED TO FIND CLUSTERS IN THE TWO FORWARD LG-DETECTORS
C---  SEPARATELY
C
      IMPLICIT INTEGER*4 (G), INTEGER*2 (H)
      LOGICAL LCOLIN
C
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),HGGADC(2,192),IWORK2(263),
     &               ID,HTRACK(3),HCLST,HCLBEC(2),HNCLST,HCOL,HTYPE,HER,
     &               HCORR,HPBLAT,HDUMIN(2),HSCAL(36),HWORD(2),ACOLAN,
     &               ETOT(3),ENTOT(3),IWORK3(16),HCLMAP(2,51),
     &               CLSPRP(13,51),IWORK4(16),HLUADC(16),HACC,HWORK1,
     &               IWORK5(611),HSMADC(14),LCOLIN
C***  COMMON /CGGADC/ LNG,HPOINT(4),HGGADC(2,192)
C***  COMMON /CLUADC/ HLUADC(16)
C***  COMMON /CGGADD/ HSMADC(14)
      COMMON /CGGPRM/ ITH,MAXCLS
C***  COMMON /CGGCLS/ NCLST,NCLBEC(2),HCLMAP(2,51),CLSPRP(10,51),ACOLAN,
C*** &                LCOLIN
C
C---- HCLST = NO.OF THE LOCATED CLUSTERS.
C---- HCLMAP(J)=THE INDEX OF THE FIRST MEMBER OF THE J-TH CLUSTER
C               IN THE HGGADC.
C
      DIMENSION GGADC(192)
      EQUIVALENCE (GGADC(1),HGGADC(1,1))
      DIMENSION IHIT(2), HIT(2)
C
      DATA ICOUNT/0/
C
      COMMON/ CGGVRN/ NVRSN(20)
      DATA NVCODE/178120712/
      NVRSN(6) = NVCODE
C
C---  EVENTS WITH NO BLOCKS ARE REJECTED HERE
CCC*  MESSAGE FOR THE CALLING PROGRAM HAS TO BE FORESEEN YET
      IF(LNG.LE.2) RETURN
      IERT = 0
C
C---- SORT ADC-DATA IN ADDRESS ORDER  (RAW DATA SHOULD BE IN ORDER  BUT
C                           TO MAKE IT SURE)
CCC   CALL GGSORT
C
C---  POINTERS
C---  HPOINT(1): FIRST ADDRESS OF -Z-DETECTOR PART (ALWAYS 1)
C---  HPOINT(2): FIRST ADDRESS OF +Z-DETECTOR PART
C---  HPOINT(3): FIRST ADDRESS OF LUMINOSITY COUNTERS
C---  HPOINT(4): LAST ADDRESS + 1
C
C---  SEPARATE ADCS OF LUMINOSITY COUNTERS AND LEAD GLASS SUMS
      INDI = (HPOINT(3)+1)/2
      INDF = (HPOINT(4)-1)/2
      IF (INDF.LT.INDI) GOTO 69
        DO 60 I = INDI,INDF
        HADDR = HGGADC(1,I)
        IF (HADDR.LE.191) GOTO 68
        IF (HADDR.GE.208) GOTO 61
        HLUADC(HADDR-191) = HGGADC(2,I)
        GOTO 60
   61   IF (HADDR.LE.215.OR.HADDR.GE.230) GOTO 68
        HSMADC(HADDR-215) = HGGADC(2,I)
        GOTO 60
   68   ICOUNT = ICOUNT + 1
        IF (ICOUNT.GT.20) GOTO 60
        WRITE(6,601) HADDR,HGGADC(2,I),HPOINT
  601   FORMAT(' *** SEVERE ADDRESS ERROR DETECTED IN GGCCTL: ',6I10)
   60   CONTINUE
      LNG = INDI + 1
   69 CONTINUE
C
C---  CHECK WHETHER MIRROR-IMAGE BLOCK (ON OPPOSITE SIDE) IS HIT TOO,
C---  THEN: 'LCOLIN = .TRUE.'
C---  LOOP IS LEFT AFTER THE FIRST FOUND PAIR OF BLOCKS,
C---  EVEN IF THERE ARE MORE
        DO 30 JP = 1,2
        HIT(JP) = (HPOINT(JP+1)-HPOINT(JP))/2
 30     IHIT(JP) = (HPOINT(JP)+1)/2
C
C---  LOOKING FOR COLLINEAR BLOCKS ONLY DONE FOR EVENTS WITH NO TAGGING
C     TRIGGER
      IF (HACC.NE.0) GOTO 10
C
      NHIT1 = HIT(1)
      NHIT2 = HIT(2)
      IHIT1M = IHIT(1)-1
      IHIT2M = IHIT(2)-1
      LCOLIN = .FALSE.
      IF (NHIT1.LT.1) GOTO 10
      NHIT2L = IHIT2M+NHIT2
        DO 50 NN1 = 1,NHIT1
        IF (NN1.GT.NHIT2L) GOTO 10
          DO 50 NN2 = 1,NHIT2
          IF (HGGADC(1,IHIT1M+NN1).NE.(HGGADC(1,IHIT2M+NN2)-96)) GOTO 5000010300
          LCOLIN = .TRUE.
C         WRITE(6,600) HGGADC(1,IHIT1M+NN1)
 600      FORMAT(' ','AT LEAST ONE COLINEAR PAIR OF BLOCKS IS HIT',
     &           '(BLOCK NO.',I3,')')
          GOTO 10
 50     CONTINUE
C
C---- CLUSTER FINDING IS DONE FOR EACH DETECTOR SEPARATELY
   10   DO 20 JP=1,2
        NHIT = HIT(JP)
        INIT = IHIT(JP)
        CALL GGCLUS(JP,INIT,NHIT,IER)
        IERT = IERT+IER
   20   CONTINUE
C---  REWRITE POINTERS AFTER LUMINOSITY ADCS ARE TAKEN OUT
C***  BE CAREFUL, HPOINT(3) AND HPOINT(4) ARE INTERCHANGED ACCORDING
C***  TO THE ORIGINAL JADE-COMPUTER NOTE #16
      HPOINT(4) = 0
C
      HCLBEC(2) = HCLBEC(2)-HCLBEC(1)
      IF(IERT) 101,100,101
  100 RETURN
  101 RETURN 1
      END

C   26/04/84 405241539  MEMBER NAME  DRAWFD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWFD( IVIEW )
C-----------------------------------------------------------------------
C
C
C   AUTHOR:    J. OLSSON        ?    :  DRAW FORWARD DETECTOR
C
C        MOD:  C. BOWDERY   26/04/84 :  TAKEN FROM FORWRD. DOES FW NOW
C        MOD:  J. NYE       18/05/84 :  USE TAGMRK - WORKS FOR MC TOO
C   LAST MOD:  C. BOWDERY   24/05/84 :  IVIEW=1  NOW USED
C
C     DRAW THE FORWRD DETECTOR FOR THE VIEW IVIEW.
C       IVIEW = 1   : SUPERPOSITION OF TAGGING SYSTEM IN R-PHI VIEWS
C       IVIEW = 2   : ZXD AND ZYD VIEWS
C       IVIEW = 3   : FW VIEW
C
C     TAGMRK IS CALLED TO DETERMINE THE VERSION NUMBER OF THE APPARATUS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
#include "cgeo2.for"
#include "cgeo3.for"
#include "cwktag.for"
C
      COMMON /CHEADR/ HEAD(108)
C
      DIMENSION ZSC(2)
      EQUIVALENCE (ZSC(1),ZMINBL)
C
C------------------  C O D E  ------------------------------------------
C
      GO TO ( 10 , 20 , 30 ) , IVIEW
C
C                            R PHI VIEW  (FC COMMAND)
C
  10  CALL FWCAP(0.,0.,0,1.,0)
      RETURN
C
C                            Z VIEWS  (ZXD,ZYD)
C
C                            CALL TAGMRK TO DETERMINE APPARATUS
C                            MARK, FOR MC AND REAL DATA
C
  20  CALL TAGMRK(&21)
  21  IF( MARK .EQ. 0 ) GO TO 1
      IF( MARK .EQ. 1 ) GO TO 641
C
C                            1983 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
C
      CALL FW83
      GO TO 1000
641   CALL FWNEW
C
C                            1981-2 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
C
      GO TO 1000
    1 CONTINUE
C
C                            1979-80 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
C
      K = 1
      IF(LASTVW.EQ.11) K = 2
C
C++++                        CHAMBER DISPLAY COMMENTED OUT
C      DO 1602  I = 1,4
C        IF(K.EQ.1) CALL FWCHM2(I,CHZ(2,I),CHX(2,I),CHZ(3,I),CHX(3,I),
C     +                         CHZ(1,I),CHX(1,I))
C        IF(K.EQ.2) CALL FWCHM1(I,CHZ(1,I),CHY(1,I),CHZ(2,I),CHY(2,I))
C1602  CONTINUE
C++++
C
      DO 1603  I = 1,2
        CALL FWCAP1(ZSC(I),0.,I,K)
C
C++++                        COUNTER DISPLAY COMMENTED OUT
C       J = 2*I-1
C       CALL FWSCN1(ZMISC(I),0.,J)
C       J = J + 1
C       CALL FWSCN1(ZPLSC(I),0.,J)
C++++
C
 1603 CONTINUE
C
1000  CONTINUE
      RETURN
C
C                            FW VIEW  (TAGGING SYSTEM ONLY VIEW)
C
  30  FDX = 0.25 * (XMAX - XMIN)
      FDY = 0.0
      LL  = 0
      IF( DSPDTL(15) ) LL = 14
      DO  42  J = 1,2
        FDX = -FDX
        CALL FWCAP(FDX,FDY,LL,1.5,1)
  42  CONTINUE
      RETURN
      END

      SUBROUTINE TRCDCK
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cpatlm.for"
#include "cworkpr.for"
      COMMON /CWORK/ DWORK(1000)
#include "cworkeq.for"
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
      DIMENSION NTRC( 3), LHIT(3),MHIT(3)
      INTEGER*2 HZW(2)
      EQUIVALENCE (HZW(1),IZW)
      COMMON /CPTSLM/ BKTRLM(20),HXREF(200,3)
                      INTEGER LMBKTR(20)
                      EQUIVALENCE (BKTRLM(1),LMBKTR(1))
 2003 FORMAT(1H0,A4,I6,2(/,1X,24I4),/,1X,50I2)
 2004 FORMAT(1H0,'BACKTR:',5X,20I6)
 2005 FORMAT(1H ,12X,20I6)
 2006 FORMAT(1X,4I6,I3,2F10.3,I3,2F10.3,1X,Z5,2I3,2X,3I3)
      IF(HNTR.LE.0) RETURN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      MINHIT = 1
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      ASSIGN 17004 TO IZZZ01
      GOTO 17000
17004 CONTINUE
      MINHIT = 5
      ASSIGN 17005 TO IZZZ02
      GOTO 17002
17005 CONTINUE
      ASSIGN 17006 TO IZZZ01
      GOTO 17000
17006 CONTINUE
      RETURN
17002 CONTINUE
      DO 13000 ITRL=1,HNTR
      IF(
     - HXREF(ITRL,2).NE.0
     -)THEN
          NTRC(1) = HXREF(ITRL,1)
          NTRC(2) = HXREF(ITRL,2)
          NTRC(3) = HXREF(ITRL,3)
          LHIT(1) = 0
          LHIT(2) = 0
          LHIT(3) = 0
          MHIT(1) = 0
          MHIT(2) = 0
          MHIT(3) = 0
          ITRC = 1
16000 CONTINUE
            JTRC = NTRC(ITRC)
            NTRL = HNREL(JTRC)
            LHIT0 = 0
            MHIT0 = 0
      DO 13002 JTRL=1,NTRL
              KTRL = HISTR(JTRL,JTRC)
              KTRL = IABS(KTRL)
      IF(
     - HXREF(KTRL,2).EQ.0
     -)THEN
                MHIT0 = NRHT(KTRL) + MHIT0
      ELSE
                LHIT0 = NRHT(KTRL) + LHIT0
      ENDIF
13002 CONTINUE
13003 CONTINUE
            IF(MHIT0.LT.MINHIT) NTRC(ITRC) =-NTRC(ITRC)
            MHIT(ITRC) = MHIT0
            LHIT(ITRC) = LHIT0
          ITRC = ITRC + 1
      IF(.NOT.(
     - ITRC.GT.3 .OR. NTRC(ITRC).EQ.0
     -))GOTO 16000
16001 CONTINUE
      IF(
     - NTRC(1).LE.0 .AND. NTRC(2).LE.0 .AND. NTRC(3).LE.0
     -)THEN
            LHIT(1) = MHIT(1) + LHIT(1)
            LHIT(2) = MHIT(2) + LHIT(2)
            LHIT(3) = MHIT(3) + LHIT(3)
            IF(MAX0(LHIT(1),LHIT(2)).LT.LHIT(3)) NTRC(3) =-NTRC(3)
            IF(MAX0(LHIT(1),LHIT(3)).LT.LHIT(2)) NTRC(2) =-NTRC(2)
            IF(MAX0(LHIT(2),LHIT(3)).LT.LHIT(1)) NTRC(1) =-NTRC(1)
      IF(
     - NTRC(1).LE.0 .AND. NTRC(2).LE.0 .AND. NTRC(3).LE.0
     -)THEN
      IF(
     - LHIT(1).GE.LHIT(2)
     -)THEN
                NTRC(1) =-NTRC(1)
      ELSE
                NTRC(2) =-NTRC(2)
      ENDIF
      ENDIF
      ENDIF
          ITRC = 1
16002 CONTINUE
            JTRC = NTRC(ITRC)
      IF(
     - JTRC.LT.0
     -)THEN
              JTRC = IABS(JTRC)
              NTRL = HNREL(JTRC)
      DO 13004 JTRL=1,NTRL
                KTRL = HISTR(JTRL,JTRC)
                KTRL = IABS(KTRL)
      IF(
     - HXREF(KTRL,1).EQ.JTRC
     -)THEN
                  HXREF(KTRL,1) = HXREF(KTRL,2)
                  HXREF(KTRL,2) = HXREF(KTRL,3)
                  HXREF(KTRL,3) = 0
      ELSE
      IF(
     - HXREF(KTRL,2).EQ.JTRC
     -)THEN
                    HXREF(KTRL,2) = HXREF(KTRL,3)
                    HXREF(KTRL,3) = 0
      ELSE
                    IF(HXREF(KTRL,3).EQ.JTRC) HXREF(KTRL,3)=0
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
              NBYTE = (NTR-JTRC)*2
              IF(NBYTE.GT.0)
     ?        CALL MVC2(HNREL(JTRC),0,HNREL(JTRC+1),0,NBYTE) !PMF 28/06/99 MVC -> MVC2
              NBYTE = NBYTE*9
              IF(NBYTE.GT.0)
     ?        CALL MVCL2(HISTR(1,JTRC),0,HISTR(1,JTRC+1),0,NBYTE) !PMF 28/06/99 MVCL -> MVCL2
              HNREL(NTR) = 0
              CALL SETS(HISTR(1,NTR),0,18,0)
              NTR = NTR - 1
      DO 13006 I=1,HNTR
                IF(HXREF(I,1).GT.JTRC) HXREF(I,1) = HXREF(I,1) - 1
                IF(HXREF(I,2).GT.JTRC) HXREF(I,2) = HXREF(I,2) - 1
                IF(HXREF(I,3).GT.JTRC) HXREF(I,3) = HXREF(I,3) - 1
13006 CONTINUE
13007 CONTINUE
      ENDIF
          ITRC = ITRC + 1
      IF(.NOT.(
     - ITRC.GT.3 .OR. NTRC(ITRC).EQ.0
     -))GOTO 16002
16003 CONTINUE
      ENDIF
13000 CONTINUE
13001 CONTINUE
      GOTO IZZZ02
17000 CONTINUE
        PRINT 2003, HPRO,HNTR,HNTCEL
        IP0 = HPTE0
      DO 13008 I1=1,HNTR
        PRINT 2006, IP0,I1,(TRKAR(I1,I2),I2=1,11),
     ,              HXREF(I1,1),HXREF(I1,2),HXREF(I1,3)
           IP0 = IP0 + HLDTE
13008 CONTINUE
13009 CONTINUE
        PRINT 2004,NTR, (HNREL(I1),I1=1,NTR)
      DO 13010 ITR=1,NTR
          NELM = HNREL(ITR)
          PRINT 2005, (HISTR(I1,ITR),I1=1,NELM)
13010 CONTINUE
13011 CONTINUE
      GOTO IZZZ01
      END

C   18/01/81 106041820  MEMBER NAME  TOFCOR3  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFCOR
C
C         MATCHING BETWEEN THE TOF COUNTERS AND
C         THE PARTICLE TRAJECTORIES DEFINED
C         BY THE INNER DETECTORS.
C         CODED AT 07.11.78
C         CHANGED AT 3.3.1980 BEATE NAROSKA
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
       DIMENSION IRAW(5,42)
      COMMON/INOUT/WRITFL,EVWRIT
      LOGICAL WRITFL,EVWRIT,HISTFL,PRFL
       EQUIVALENCE (IRAW(1,1),RAW(1,1))
C
       DATA PAI/3.1415927/,RTOF/920./
       DATA XPAI/.14960/,SQRAD/.36742/,DSTAN/.01/
      DATA IBUG/10/,IENTRY/0/
C     IF(IENTRY.NE.0)  GOTO  10
C     IENTRY = 1
C     CALL HDELET(0)
C     CALL HBOOK1(406,5HDFI $,100,-.5,.5)
C  10 CONTINUE

C
C=========   ININTIALIZATION OF CORRESPONDENCE TABLE
C
      IBUG = IBUG + 1
      IF(IBUG.LE.10) PRINT 150,(IRAW(1,NCN),NCN=1,42)
  150 FORMAT(' CNTRS',42I3)
      IF(IBUG.LE.10) PRINT 151,NTRK,(ITRC(I),I=1,NTRK)
  151 FORMAT(' TRKS',I5,3X,10I3)
      EVWRIT = .FALSE.
       CALL SETSL(ICRT1,0,42*20,0)
       CALL SETSL(ICRT2,0,200,0)
            DO 2000 LTRK=1,NTRK
            IF(ICRT2(LTRK).GT.0) GO TO 2000
            NCN= ITRC(LTRK)
            IF(NCN.GE.1.AND.NCN.LE.42) GO TO 1050
            ICRT2(LTRK)= -1
            GO TO 2000
 1050       CONTINUE
C
C=========   LOOK FOR HIT IN CORRESPONDING COUNTER
  501 FORMAT(/' TOFCOR ', 3I5,54F10.3)
C
            IF(IRAW(1,NCN).LE.0) GO TO 1500
                 MTRK=ITRK(2,NCN)
                 IF(MTRK.GE.4) GO TO 1200
                 IF(MTRK.LT.1) GO TO 1500
                      MTRK1=MTRK+2
                      DO 1100 I=3,MTRK1
                      IF(LTRK.EQ.ITRK(I,NCN)) GO TO 1200
 1100                 CONTINUE
                      GO TO 1500
 1200            ICNT=ICRT1(2,NCN)+1
                 ICRT1(2,NCN)=ICNT
                 ICRT2(LTRK)= NCN
                 ICRT1(1,NCN)= NCN
                 IF(ICNT.GE.4) GO TO 2000
                 ICRT1(ICNT+2,NCN)=LTRK
                 GO TO 2000
 1500      CONTINUE
C
C=========   COUNTER WAS NOT HIT LOOK IN ADJACENT ONES
C    LOOK IN ADJACENT COUNTERS
C
                PH1=(FLOAT(NCN)-1.)*XPAI
                DPH=TRK(2,LTRK)-PH1
      IF(ABS(DPH).GT.6.284-XPAI/2.) DPH = ABS(DPH)-(6.284-XPAI/2.)
C     CALL HF1(406,DPH,1.)
      IF(ABS(DPH).GT..100) EVWRIT = .TRUE.
      I =1
      IF(DPH.LT.0.) I = -1
      NC1 = NCN + I
      IF(NC1.GT.42) NC1 = NC1-42
      IF(NC1.LT.1)  NC1 = NC1 + 42
      IF(IBUG.LE.20) PRINT 503,LTRK,NCN,NC1,DPH
  503 FORMAT(' TRACK',I5,' HITS ',I5,' TRY CNTR ',I5,F10.4)
      IF(IRAW(1,NC1).LE.0) GO TO 2000
C  40 IF(DPH.GT..03) GO TO 1700
C  CHECK QUALITY OF TOF DETERMINATION
C     CALL TOFBRA(NC1,LTRK,IFLG)
C     IF(IBUG.LE.20) PRINT 501,IFLG
           ICNT=ICRT1(2,NC1)+1
           ICRT1(2,NC1)=ICNT
           ICRT2(LTRK)= NC1
           ICRT1(1,NC1)= NC1
           IF(ICNT.GE.4) GO TO 2000
           ICRT1(ICNT+2,NC1)= LTRK
           ICRT2(LTRK)= NC1
           ICRT1(1,NC1)= NC1
C
 2000  CONTINUE

           RETURN
           END

C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
C   NOTE (JEO 23.3.97)  THAT HVTXST HAS DIM. 140 ON F22KLE.VERTEX.S LIB
      DIMENSION IVTXST(1)
C

C   12/03/84 412041852  MEMBER NAME  CLSPS1   (S)           FORTRAN
C
        SUBROUTINE TAGPS1(SUM,IWRITE)
C
C WORK OUT CENTRE OF CLUSTER FOR 1981/2 TAGGER
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
#include "cwktag.for"
C
#include "comtag.for"
C
C
C
C----------------------  C O D E  --------------------------------------
C
C
       TEST1 = SUM * 0.999
       TEST2 = SUM * 0.025
       XCORR = 0.0
       YCORR = 0.0
       SIGX  = 20.0
       SIGY  = 20.0
C
C
       CAND(1) = CLUS(1,2)
       IF ( CAND(1) .LT. 0.0 ) GOTO 9010
       ADDRES  = CLUS(1,1)
       CAND(2) = XMAP (ADDRES)
       CAND(3) = YMAP (ADDRES)
       IF ( CAND(1) .GT. TEST1 ) GOTO 10
C
C
C FIT TO RATIO OF ENERGIES FOR HIT BLOCK
C AND NEXT LARGEST HIT BLOCK
C
       CALL TAGFIT(2,XFIT,YFIT,IWRITE,*10)
C
       XCORR = XFIT
       YCORR = YFIT
C
C SOPHISTICATED CALCULATION OF ERROR ON X
C
       IF ( XCORR .GT. 5 ) SIGX = 5
       IF ( YCORR .GT. 5 ) SIGY = 5
C
C ALSO FIT TO 3RD BLOCK ,IF IT HAS SIGNIFICANT FRACTION OF ENERGY
C
       IF ( CLUS(3,2) .LT. TEST2 ) GOTO 10
       CALL TAGFIT(3,XFIT,YFIT,IWRITE,*10)
C
C CHOOSE ONE OF THE TWO FIT RESULTS - WHICHEVER IS THE LARGEST
C
       IF ( ABS(XFIT) .GT. ABS(XCORR) ) XCORR = XFIT
       IF ( ABS(YFIT) .GT. ABS(YCORR) ) YCORR = YFIT
C SOPHISTICATED CALCULATION OF ERROR ON X
       IF ( XCORR .GT. 5 ) SIGX = 5
       IF ( YCORR .GT. 5 ) SIGY = 5
C
C NOW ADD XCORR (CORRECTION ON X) TO X
C AND SIMILARLY Y
C
   10  CONTINUE
       CAND(2) = CAND(2) + XCORR
       CAND(3) = CAND(3) + YCORR
C
C CAND(1) = ENERGY OF CLUSTER - ONLY FIRST 4 MEMBERS
C
       CAND(1) = CLUS(1,2) + CLUS(2,2) + CLUS(3,2) + CLUS(4,2 )
       IF ( CAND(1) .LT. 0.0 ) GOTO 9010
       SIGEN = 0.20 * SQRT( CAND(1) )
C
C DEBUG - WRITE OUT RESULT
C
       IF ( IWRITE .EQ. 1 ) WRITE(6, 601) ((CLUS(I,J),I=1,9),J=1,2)
  601  FORMAT(' ++++ TAGPS1 : DEBUG  -  CLUS ARRAY ==>',/,
     *           2(9(1X,F8.2),/) )
       IF ( IWRITE .EQ. 1 ) WRITE(6,602) CAND(1 ) ,CAND(2 ) ,CAND(3)
  602  FORMAT(' CLUSTER INFO ENERGY X Y ',3(2X,F12.2) )
C
C---------------------------------------- R E T U R N ------------------
C
       RETURN
C
C
C---ERRORS :
C
C---                                      ENERGY < 0
C
 9010  WRITE(6,9011) ((CLUS(I,J),I=1,9),J=1,2)
       WRITE(6,602) CAND(1 ) ,CAND(2 ) ,CAND(3)
 9011  FORMAT(' ++++ TAGPS1 : NEGATIVE ENERGY  -  CLUS ARRAY ==>',/,
     *           2(9(1X,F8.2),/) )
       RETURN
       END

C   10/09/79 910212116  MEMBER NAME  ALPHAN   (JADEGS)      FORTRAN
      SUBROUTINE ALPHAN(LUN)
      IMPLICIT INTEGER*2(H),LOGICAL*1(Q)
#include "creply.for"
C-----------------------------------------------------------------------
C
C         ---------------- SUBROUTINE ALPHAN  ------------------
C         --------------- AUTHOR : G.F.PEARCE ----------------
C         ---------- LAST UPDATE : 1600HRS 10/09/79 ----------
C
C   SUBROUTINE TO READ A SINGLE LINE (72 CHARACTERS) FROM AN INPUT
C   FILE WRITTEN IN FREE FORMAT AND TO UNPACK THE CHARACTER STRINGS
C   INTO A SEQUENCE OF WORDS AND NUMBERS WHICH ARE THEN RETURNED
C   IN AN EASILY USEABLE FORM. THE ONLY REQUIREMENT IS THAT THE
C   CHARACTER STRINGS (WORDS AND NUMBERS) BE SEPERATED BY BLANKS OR
C   COMMAS. A WORD IS DEFINED HERE AS A SEQUENCE OF UP TO 4 UNINTERUPTED
C   ALPHABETIC CHARACTERS (DIGITS NOT ALLOWED). A NUMBER CAN BE EITHER
C   INTEGER OR DECIMAL (WITH + OR - SIGN). A MAXIMUM OF 20 REPLIES ARE
C   ALLOWED IN ANY ONE INPUT FIELD.
C   NOTE THAT TO AVOID PROBLEMS WHICH MAY ARISE WHEN NUMBERED TSO DATA
C   SETS ARE USED AS INPUT, CHARACTERS 73-80 IN THE INPUT FIELD ARE
C   ALWAYS IGNORED BY THIS ROUTINE.
C
C   LUN    = LOGICAL UNIT NUMBER FROM WHICH INPUT FIELD IS READ (EG 5)
C          = 100 TAKES AN IPS INPUT
C   NREPLY = NUMBER OF REPLIES (WORDS/NUMBERS) FOUND IN INPUT FIELD
C   REPLY  = REAL*4 ARRAY RETURNING ALPHABETIC WORDS AND/OR NUMBERS
C   QREPLY = LOGICAL ARRAY SHOWING TYPE OF RETURNED WORD
C            0 => ALPHABETIC   1 => REAL NUMBER   3 => INTEGER NUMBER
C
C-----------------------------------------------------------------------
C
C   CHARACTER CODES ASSUMED IN THIS ROUTINE ARE :
C                        A = 193
C                        B = 194
C                        " "  "
C                        " "  "
C                        Z = 233
C                        0 = 240
C                        1 = 241
C                        " "  "
C                        " "  "
C                        9 = 249
C                        ' = 107
C                        + = 78
C                        - = 96
C                        . = 75
C
C-----------------------------------------------------------------------
      REAL*4 BLANK4/4H    /
      LOGICAL*1 QZERO/Z00/,QONE/Z01/,QTHREE/Z03/
      LOGICAL*1 QWORD1(80),QB1(80),QTHIS(2)
      EQUIVALENCE (QWORD1(1),REPLY(1)) , (HCHAR,QTHIS(1))
C     ----------
C     INITIALISE
C     ----------
      NREPLY = 0
      DO 10 IPOSN=1,20
      QREPLY(IPOSN) = QZERO
  10  REPLY(IPOSN) = BLANK4
      IPOSN = 0
      HCHAR  = 0
      HSIGN  = 1
C     ----------
C     READ INPUT
C     ----------
      IF (LUN.EQ.100) CALL TRMIN(80,QB1)
      IF (LUN.NE.100) READ(LUN,20)QB1
  20  FORMAT(80A1)
C-------------------------
C     RESET LOCAL POINTERS
C-------------------------
  40  ILOCAL = 1
C-------------------------------------
C     PICK UP NEXT CHARACTER OF STRING
C-------------------------------------
  50  IPOSN = IPOSN + 1
C     DID WE HIT THE 72ND CHARACTER IN THE MIDDLE OF A WORD ?
      IF (IPOSN.LE.72) GOTO60
      IF (ILOCAL.GT.1) NREPLY = NREPLY + 1
      GOTO900
  60  QTHIS(2) = QB1(IPOSN)
C     IS IT AN ALPHABETIC CHARACTER ?
      IF (HCHAR.LT.193.OR.HCHAR.GT.233) GOTO80
C----------------------------------
C     LOAD NEW ALPHABETIC CHARACTER
C     INTO CURRENT WORD
C----------------------------------
      IF (NREPLY.GT.20.OR.ILOCAL.GT.4) GOTO50
      QWORD1(ILOCAL+NREPLY*4) = QTHIS(2)
      ILOCAL = ILOCAL + 1
      GOTO50
C----------------------------------
C     TEST FOR END OF CURRENT WORD
C----------------------------------
  80  IF (ILOCAL.EQ.1) GOTO90
      ILOCAL = 1
      NREPLY = NREPLY + 1
C-------------------------------
C     POSSIBLE START OF A NUMBER
C-------------------------------
  90  DIVIDE = 0.100
      IDEC = 1
      X = 0.0
      NDIGIT = 0
C     TEST FOR +/- SIGN , NUMERAL OR DECIMAL POINT
      IF (HCHAR.EQ.78) GOTO220
      IF (HCHAR.NE.96) GOTO300
C     FOUND MINUS SIGN
      HSIGN = 0
  220 IPOSN = IPOSN + 1
      IF (IPOSN.GT.72) GOTO900
      QTHIS(2) = QB1(IPOSN)
      GOTO300
C     NUMERAL .. START OF A NUMBER
  300 IF (HCHAR.NE.75) GOTO320
      IDEC = 2
      GOTO220
  320 IF (HCHAR.LT.240.OR.HCHAR.GT.249) GOTO380
  330 X1 = FLOAT(HCHAR-240)
      NDIGIT = NDIGIT + 1
      GOTO (340,350),IDEC
  340 X = X*10.0 + X1
      GOTO220
  350 X = X + X1*DIVIDE
      DIVIDE = DIVIDE/10.0
      GOTO220
C--------------------------
C     LOAD COMPLETED NUMBER
C--------------------------
  380 IF (NDIGIT.EQ.0) GOTO40
      NREPLY = NREPLY + 1
      IF (HSIGN.EQ.0) X = -X
      HSIGN = 1
      IF (NREPLY.GT.20) GOTO60
      IF (IDEC.EQ.1) GOTO385
      REPLY(NREPLY) = X
      QREPLY(NREPLY) = QONE
      GOTO60
 385  IREPLY(NREPLY) = X
      QREPLY(NREPLY) = QTHREE
      GOTO60
C----------------------
C     ALL OVER - RETURN
C----------------------
 900  CONTINUE
      RETURN
      END

C   16/12/81 112161851  MEMBER NAME  ENGLOSM  (SOURCE)      FORTRAN
C   19/02/80 111041559  MEMBER NAME  ENGLOS   (SOURCE)      FORTRAN
      SUBROUTINE ENGLOS(E,D,DE,*)
C     ENERGY LOSS IN AL. COIL AND OTHER MATERIAL.
C     INPUT   E   INPUT ENERGY IN GEV
C             D   THICKNESS OF ALUMINUM ABSORBER IN CENTI METER
C             DE  ENERGY LOSS IN GEV
C                        WRITTEN BY H.TAKEDA  16/12/81
C
C     ENERGY LOSS WAS CALCULATED BY MEAN VALUE
C                                OF THE OBSERVED ENERGY.
C     MONTE CARLO DATA WERE SUPPLIED BY MR. OLSSON.
C     MAX INCIDENT ENERGY IS 1 GEV.
      DIMENSION BENG(10),BTHK(11)
      INTEGER*2 HCOR(10,11)
      DATA BENG/0.0, 0.1, 0.2, 0.3, 0.5, 0.6, 0.7, 0.8, 1.0, 100.0/
      DATA BTHK/0., 8.68, 8.81, 9.05, 9.42, 9.97, 10.79, 12.09,
     & 13.05, 15.0, 100.0/
      DATA HCOR/10*0, 0,16,41,46,50,55,58,59,60,60,
     1 0,15,43,49,63,69,73,78,88,88,
     2 0,19,48,61,81,86,96,100,110,110,
     3 0,25,58,72,98,106,117,126,143,143,
     4 0,24,64,86,120,132,147,155,175,175,
     5 0,28,72,94,131,152,167,179,200,200,
     6 0,29,79,112,154,176,188,210,240,240,
     7 0,31,82,118,169,188,211,228,257,257,
     8 0,31,84,121,179,200,223,243,270,270,
     9 0,31,84,121,179,200,223,243,270,270/
      DATA IERR1,IERR2,IERCNT,IBTHK,IBENG/2*0,5,11,10/
      DE=0.
C
C       CHECK BAD INPUTS
2     IF(E.GE.0. .AND. E.LE.100.) GO TO 3
      IERR1=IERR1+1
      IF(IERR1.GT.IERCNT) RETURN1
      WRITE(6,600) E
600   FORMAT('0 **BAD  ENERGY INTO LGECOR(ENGLOSM) E=',F10.3)
      RETURN1
C
3     IF(D.GE.0. .AND. D.LE.100.) GO TO 4
      IERR2=IERR2+1
      IF(IERR2.GT.IERCNT) RETURN1
      WRITE(6,610) D
610   FORMAT('0 **BAD THICKNESS INTO LGECOR(ENGLOSM) D=',F10.3)
      RETURN1
C
4     DO 5 I=2,IBENG
      IF(E.LT.BENG(I)) GO TO 6
5     CONTINUE
6     DO 7 J=2,IBTHK
      IF(D.LT.BTHK(J)) GO TO 8
7     CONTINUE
C
8     EPORT=(E-BENG(I-1))/(BENG(I)-BENG(I-1))
      TPORT=(D-BTHK(J-1))/(BTHK(J)-BTHK(J-1))
C
      FACT1=HCOR(I-1,J-1)+EPORT*(HCOR(I,J-1)-HCOR(I-1,J-1))
      FACT2=HCOR(I-1,J  )+EPORT*(HCOR(I,J  )-HCOR(I-1,J  ))
C
      DE=FACT1+TPORT*(FACT2-FACT1)
      DE=DE/1000.
      IF(DE.GT.E) DE=E
      RETURN
      END

      PROGRAM CONV
C
C Program CONV converts line-by-line non-blank consecutive contents 
C of the formatted JADE calibration files ( present ASCII files 
C AUPTDAT1, BUPDAT0, BUPDAT1 ) 
C into INTEGER, REAL or CHARACTER-values, respectively, 
C according to their intended meaning in the character string.
C
C This routine uses the CERN-lib routine CKRACK from package M432
C
C For details of the structure of the calibration data
C see JADE computer note 68.
C
C Date:    16/11/98   Author:  P.M. Fernandez
C
      IMPLICIT NONE
C
      INTEGER IBUF(10000)
      REAL RBUF(10000)
      INTEGER*2 HBUF(20000)
      EQUIVALENCE(RBUF(1),IBUF(1)),(HBUF(1),IBUF(1))
C
      INTEGER NUNIT,MUNIT,NWORD,IRET,IOUT,NREC,MAXREC
      DATA NUNIT/10/,MUNIT/11/
      CHARACTER*100 CFILE/'aupdat1'/,CFILEC/'aupdat1.b'/
      DATA MAXREC /-1/
C
      INTEGER I,J,K,L,M,N
      LOGICAL FIRST /.TRUE./
C
C Open formatted calibration file
      OPEN(NUNIT,FILE=CFILE,FORM='FORMATTED',STATUS='UNKNOWN')
C
C Open unformatted conversion file
      OPEN(MUNIT,FILE=CFILEC,FORM='UNFORMATTED',STATUS='UNKNOWN')
C
      WRITE(*,'('' Input file  :'',A)') CFILE
      WRITE(*,'('' Output file :'',A)') CFILEC
      NREC=0
C     
C Read in record
 10   CALL RDATA(NUNIT,NWORD,IBUF,IRET)
      IF(IRET.EQ.1) GOTO 1000
      IF(IRET.EQ.2) GOTO 2000
C
      NREC=NREC+1
      IOUT=NWORD
      IF(IOUT.GT.10) IOUT=10
C
C Print out header
      IF(NWORD.GT.1) WRITE(6,900)  NREC,(IBUF(I),I=1,IOUT)
 900  FORMAT(1X,'--- Convert record number:',I5,4X,'Words:',I6
     +     ,2X,'Header:',' ',A4,' ',2I2,I2,2I10,I6,I10,I2)
C
C Write out Buffer
C      PRINT*, (IBUF(I),I=1,NWORD+1)
C      PRINT*
C      PRINT*, (HBUF(I),I=1,2*NWORD+2)
C      PRINT*
C      PRINT*, (RBUF(I),I=1,NWORD+1)
      IF (FIRST) THEN
         IF (     INDEX(CFILE,'aupdat1').NE.0
     +        .OR.INDEX(CFILE,'bupdat0').NE.0) THEN
            WRITE(MUNIT) 1,14688000
         ELSEIF (INDEX(CFILE,'bupdat1').NE.0) THEN
            WRITE(MUNIT) 1,169394661
         ELSE
            WRITE(*,'(''!!! Input file is wrong.'')')
            STOP
         ENDIF
         FIRST=.FALSE.
      ENDIF
      WRITE(MUNIT) (IBUF(I),I=1,NWORD+1)
C
      IF(NREC.LT.MAXREC.OR.MAXREC.EQ.-1) GOTO 10
      GOTO 9999
C
 1000 CONTINUE
      WRITE(6,101) NREC
 101  FORMAT(//' *** READ ERROR ENCOUNTERED AFTER ',I6,' RECORDS.')
      GOTO 9999
 2000 CONTINUE
      WRITE(6,102) NREC
 102  FORMAT(//' NORMAL END OF FILE AFTER',I6,' RECORDS.')
      GOTO 9999
C
 9999 CONTINUE
      CLOSE(NUNIT)
      CLOSE(MUNIT)
      STOP
      END

C----------------------------------------------
      SUBROUTINE RDATA(NUNIT,NWORD,IBUF,IRET)
C
C  This routine reads in one 'ASCII record'
C  Input:  
C     NUNIT: Logical file number 
C  Output:
C     IBUF: Array of data words (including length of bank)
C     NWORD: Number of data words (length of bank NOT included)
C     IRET:  Error flag
C
      IMPLICIT NONE
      INTEGER IBUF,NWORD,NDUM,IRET,NUNIT,ICON
      DIMENSION IBUF(10000)
C
      CHARACTER CLINE*200   
      INTEGER NLINE,NNUM,IBANK,IWORD,IND,ILINE,ILTOT/0/
      DIMENSION NLINE(100)
      LOGICAL FIRST
C
      INTEGER IOPT,IFORC
      CHARACTER*34 SBANK/'JTPL LGMA LGST MUCA SPTG TAGF TAGS'/
      CHARACTER BANK*4,OBANK*4
      INTEGER  NBANKS
      PARAMETER (NBANKS=17)
      CHARACTER*4 BANKS(NBANKS)
      DATA BANKS
     +     /'MUCA','LGMA','TAGS','JTPL','JTAB'
     +     ,'TOFC','LGST','DEDX','SPTG','RVTX'
     +     ,'ZCAL','TAGF','IDJS','VTXC','VTXR'
     +     ,'VTXB','VTXF'/
C
      INTEGER OILINE,OIND,ONWORD
      INTEGER I,J,K,L,M,N
C
      FIRST=.TRUE.
      IND=0
      ILINE=0
      IOPT=0
      IFORC=0
      BANK='XXXX'
C
C Read the line as character string
 10   CONTINUE
      READ(NUNIT,ERR=1,END=2,FMT='(A200)') CLINE
      ILINE=ILINE+1
      ILTOT=ILTOT+1
C
C Perform some error checks (part 1)
      IF(ILINE.EQ.1) THEN
         DO I=1,NBANKS
            IF(INDEX(CLINE,BANKS(I)).NE.0) GOTO 500 
         ENDDO
         WRITE(*,FMT=903) OBANK,OILINE,OIND,ONWORD,ILTOT,CLINE
         GOTO 1
      ELSE
         DO I=1,NBANKS
            IF(INDEX(CLINE,' '//BANKS(I)//' ').NE.0) THEN 
               WRITE(*,FMT=904) BANK,ILINE,IND,NWORD,ILTOT,CLINE
               GOTO 1
            ENDIF
         ENDDO
      ENDIF
 500  CONTINUE
C
C Check special conditions of some lines in the bank
      IF(ILINE.NE.1.AND.IOPT.EQ.0) THEN
         IF(INDEX(SBANK,BANK).NE.0) IOPT=1
         IF(BANK.EQ.'MUCA') IOPT=2
      ENDIF
      IF(ILINE.EQ.2) THEN
         IF(INDEX(CLINE,'/').NE.0) IFORC=1
         IF(INDEX(CLINE,'VERSN').NE.0) IFORC=10
         IF(INDEX(CLINE,'VSN').NE.0) IFORC=11
      ELSE
         IFORC=0
      ENDIF
C
C Convert consecutive non blank characters into
C INTEGER or REAL numbers, respectively
      CALL CONVRT(CLINE,NLINE,NNUM,IOPT,IFORC,ICON)
C
C Check if line is header line
      IF(FIRST) THEN
         WRITE(BANK,'(A4)') NLINE(2)
         NWORD=NLINE(1)
         FIRST=.FALSE.
      ENDIF
C
C Perform some error checks (part 2)
      IF (ICON.EQ.4) THEN
         WRITE(*,FMT=901) ILINE,BANK,ILTOT,CLINE
         GOTO 1
      ELSEIF (ICON.NE.0) THEN 
         WRITE(*,FMT=902) ILINE,ILTOT,CLINE
         GOTO 1
      ENDIF
C
C Put converted values in array IBUF
C until total number of words is reached
      DO I=1,NNUM
         IND=IND+1
         IBUF(IND)=NLINE(I)
         IF(I.EQ.NNUM.AND.IND.EQ.NWORD+1)
     +        WRITE(*,FMT=900) IND-1,NWORD,ILINE,BANK
 900     FORMAT(/'> Read',I5,' of',I5,' words after'
     +        ,I5,' lines of bank ',A4) 
         IF(IND.GE.NWORD+1) GOTO 20
      ENDDO
      OBANK=BANK
      OILINE=ILINE
      ONWORD=NWORD
      OIND=IND
      GOTO 10
C
 20   CONTINUE
C
C Check if last read line matches the current record
      IF (I.LT.NNUM) THEN
         WRITE(*,FMT=905) BANK,ILINE,IND,NWORD,ILTOT,CLINE
         GOTO 1
      ENDIF
C
      IRET=0
      RETURN
    1 CONTINUE
      IRET=1
      RETURN
    2 IRET=2
      RETURN
 901  FORMAT(/'!!! Error in length of line ',I6,' of bank ',A4
     +     ,/,I6,':',A)
 902  FORMAT(/'!!! Something is wrong with line ',I6,'of bank ',A4
     +     ,/,I6,':',/A)
 903  FORMAT(/'!!! Record length contradiction in bank ',A4
     +     , ' in line ',I6,' at word',I5,' of ',I5,/,I6,':',A/
     +     ,'Begin of an new bank without header!')
 904  FORMAT(/'!!! Record length contradiction in bank ',A4
     +     , ' in line ',I6,' at word',I5,' of ',I5,/,I6,':',A/
     +     ,'Begin of new bank indicated before end of old bank!')
 905  FORMAT(/'!!! Record length contradiction in bank ',A4
     +     , ' in line ',I6,' at word',I5,' of ',I5,/,I6,':',A/
     +     ,'End of bank indicated before end of current line!')
      END
C-------------------------------------------------
      SUBROUTINE CONVRT(CLINE,NLINE,NNUM,IOPT,IFORC,IRET)
C This routine converts non-blank consecutive contents of a 
C character string into INTEGER, REAL or CHARACTER-values, 
C respectively, according to their intended meaning in the 
C character string.
C
C Input:
C     CLINE: Character string (A200)
C Output:
C     NNUM:  Number of Words
C     NLINE: Array of NNUM Words
C     IRET:  Error flag
C
C COMMON /SLATE/ contains conversion information 
C (see CERN-lib package CHPACK, M432)
C     NUM(1),NUM(2): Converted number
C     ND: Number of numeric digits seen
C     NE: Position of terminating character
C     NF: Type of number read
C     NG: 0 for normal termination, otherwiese for special termination
C
      IMPLICIT NONE
C
      INTEGER MOD
      INTRINSIC MOD
C
      INTEGER ND,NE,NF,NG,NUM
      COMMON /SLATE/ ND,NE,NF,NG,NUM(2)
      REAL ANUM(2)
      EQUIVALENCE (ANUM(1),NUM(1))
C
      INTEGER IEND,IRET,IOPT,IFORC
      INTEGER ILS,IL,IR,ITYPE
C
      INTEGER NNUM,NLINE(100)
      INTEGER*2 NHNUM
      INTEGER KLINE(100)
      REAL RLINE(100)
      INTEGER*2 HLINE(200)
      CHARACTER*1 SLINE(400)
      EQUIVALENCE(RLINE(1),KLINE(1)),(HLINE(1),KLINE(1))
     +     ,(SLINE(1),KLINE(1))
C
      CHARACTER CLINE*200,CLINE0*201,CH*1,CHS*1
      CHARACTER*2 CLEN(-1:2)/'*4','*4','*2','*2'/
      CHARACTER*4 CTYPE(-1:4)
     +     /'char','blnk','bit ','int ','real','dble'/
C
      LOGICAL FLIP
C     
      INTEGER I,J,K,L,M,N
C
      DO I=1,100
         KLINE(I)=0
      ENDDO
      IRET=0
      FLIP=.FALSE.
C
**      WRITE (*,'(110(''-'')/A200)') CLINE
      CLINE0=' '//CLINE
C 
C Mark consecutive non blank characters (-> IL,IR)
      ILS=1
      NNUM=0
      NHNUM=0
 100  CONTINUE
      CALL CHBLNK(CLINE0,ILS,IL,IR,IEND)
      IF (IEND.EQ.1) GOTO 200
      ILS=IL+1
C
C Perform conversion
      CALL CKRACK(CLINE0,IL,IR,0)
C
C consider special handling of some lines
      IF(IOPT.EQ.2.AND.ITYPE.EQ.3) IOPT=-1
      IF(IFORC.EQ.10.OR.IFORC.EQ.11) IOPT=0
      IF(IFORC.EQ.1) THEN
         IL=3
         IR=10
         NF=-2
      ELSEIF(IFORC.EQ.10.AND.NF.EQ.-1) THEN
         IR=IL+59
         NF=-2
         IEND=1
      ELSEIF(IFORC.EQ.11.AND.NF.EQ.-1) THEN
         IL=9
         IR=IL+59
         NF=-2
         IEND=1
      ENDIF
C
      ITYPE=NF
      IF(ITYPE.LT.0) ITYPE=-1
C
C Put result in array NLINE
      IF(ITYPE.EQ.2) THEN
         IF(IOPT.GT.0) THEN
            NHNUM=NHNUM+1
            FLIP=.NOT.FLIP
            IF (FLIP) NNUM=NNUM+1
            HLINE(NHNUM)=NUM(1)
**            WRITE(*,FMT=90) FLIP,NHNUM,NNUM,IL,IR
**     +           ,CLINE0(IL:IR),CTYPE(ITYPE)
**     +           ,CLEN(IOPT)
**     +           ,NF,HLINE(NHNUM),HLINE(NHNUM)
**     +           ,KLINE(NNUM),KLINE(NNUM),ND,NE,NG
         ELSE
            NNUM=NNUM+1
            NHNUM=NHNUM+2
            KLINE(NNUM)=NUM(1)
**            WRITE(*,FMT=91) NNUM,IL,IR,CLINE0(IL:IR),CTYPE(ITYPE)
**     +           ,CLEN(IOPT)
**     +           ,NF,KLINE(NNUM),ND,NE,NG
         ENDIF
      ELSEIF(ITYPE.EQ.3) THEN
         NNUM=NNUM+1
         NHNUM=NHNUM+2
         RLINE(NNUM)=ANUM(1)
**         WRITE(*,FMT=92) NNUM,IL,IR,CLINE0(IL:IR),CTYPE(ITYPE),
**     +        NF,RLINE(NNUM),ND,NE,NG
      ELSEIF(ITYPE.EQ.-1) THEN
         DO K=0,IR-IL
            SLINE(4*NNUM+1+K)=CLINE0(IL+K:IL+K)
         ENDDO
         NNUM=NNUM+INT((IR-IL+1)/4)
         NHNUM=NHNUM+2*INT((IR-IL+1)/4)
**         WRITE(*,FMT=93) NNUM,IL,IR,CLINE0(IL:IR),CTYPE(ITYPE)
**     +        ,NF,CLINE0(IL:IR)
**     +        ,ND,NE,NG
      ELSE
         IRET=1
         RETURN
      ENDIF
      IF (IEND.EQ.1) GOTO 200
      GOTO 100
 90   FORMAT(T1,L4,2I3,I5,' -',I5,2X,'Char=',A,t45,'Type=',A4
     +     ,A2,T57,'(',I2,')',T66,' Value=',I9
     =     ,2X,'(',Z4.4,'|',Z8.8,')',I10
     +     ,t112,'| No=',I3,' Te=',I3,' St=',I3) 
 91   FORMAT(T6,I3,I5,' -',I5,2X,'Char=',A,t45,'Type=',A4
     +     ,A2,T57,'(',I2,')',T66,' Value=',I9
     +     ,t92,'| No=',I3,' Te=',I3,' St=',I3) 
 92   FORMAT(T6,I3,I5,' -',I5,2X,'Char=',A,t45,'Type=',A4
     +     ,T57,'(',I2,')',T66,' Value=',E12.6
     +     ,t92,'| No=',I3,' Te=',I3,' St=',I3) 
 93   FORMAT(T6,I3,I5,' -',I5,2X,'Char=',A,t45,'Type=',A4
     +     ,T57,'(',I2,')',T66,' Value=',A
     +     ,t92,'| No=',I3,' Te=',I3,' St=',I3) 
C     
 200  CONTINUE
      DO I=1,100
         NLINE(I)=KLINE(I)
      ENDDO
C
      IRET=MOD(INT(NHNUM),2)*4
C
      RETURN
      END
C-------------------------------------
      SUBROUTINE CHBLNK(C,ILS,IL,IR,IEND)
C
C This routine marks begin (IL) and end (IR) of
C the first consecutive non blank characters
C in the string C starting from the FIRST blank 
C at left from position ILS
C 
      IMPLICIT NONE
      CHARACTER C*200,CH*1,CHS*1
      INTEGER IL,IR,ILS,I,IEND
      LOGICAL LEFT,RIGHT
C
      IEND=0
      CHS='X'
      RIGHT=.FALSE.
      LEFT=.FALSE.
      DO I=ILS,200
         CH=C(I:I)
         IF (CH.NE.' '.AND.CHS.EQ.' ') THEN
            IL=I
            LEFT=.TRUE.
         ENDIF
         IF (CH.EQ.' '.AND.CHS.NE.' '.AND.LEFT.EQV..TRUE.) THEN
            IR=I-1
            RIGHT=.TRUE.
         ENDIF
         IF (LEFT.AND.RIGHT) GOTO 10
         CHS=CH
      ENDDO
 10   CONTINUE
      IF(.NOT.LEFT.AND..NOT.RIGHT) IEND=1
C
      RETURN
      END

C   06/03/82 709012222  MEMBER NAME  DEDXBN00 (JADEGS)      FORTRAN
      SUBROUTINE DEDXBN
C-----------------------  LAST CHANGE: 26.06.87   K.A. E.E. ---C
C-----------------------       CHANGE: 27.08.86   L.BECKER  ---C
C-----------------------       CHANGE: 28.08.86  J.A.J.SKARD --C
C-----------------------       CHANGE: 02.06.87   K.AMBRUS  ---C
C---   MADE STANDARD   1.9.1987                   J.OLSSON  ---C
C                                                              C
C     DETERMINE NUMBER OF OVERFLOW-HITS (BOTH WIRE ENDS)
C     DETERMINE MOMENTUM PROJECTIONS PX,PY,PZ
C     REBUILD MISSING LEFT OR RIGHT OVERFLOW-AMPLITUDES
C            AL,AR FROM Z-FIT
C     PERFORM NEW Z-CALIBRATION (BUT DO NOT STORE FIT RESULTS)
C     INTRODUCED JHTQ BANK TO GET HIT QUALITY
C     CORRECT FOR NEGATIVE OVERFLOW-AMPLITUDES-   K.AMBRUS
C
C     CALCULATION OF DE/DX, SIGMA(DE/DX)      -   P.DITTMANN   C
C     COMPARISON WITH THE THEORETICAL VALUE   -   J.SKARD      C
C                                                              C
C     RESULTS ARE WRITTEN INTO COMMON /CWORK1/                 C
C     THE ARRAY TRES(14,60) HOLDS THE FOLLOWING RESULTS        C
C                                                              C
C     ITRES(1,ITR)  =  NHIT, QUALITY OF DEDX                   C
C      TRES(2,ITR)  =  DEDX                                    C
C      TRES(3,ITR)  =  SIGMA(DEDX)                             C
C      TRES(4,ITR)  =  CHISQ(ELECTRON)                         C
C      TRES(5,ITR)  =  CHISQ(PION)                             C
C      TRES(6,ITR)  =  CHISQ(KAON)                             C
C      TRES(7,ITR)  =  CHISQ(PROTON)                           C
C     ITRES(8,ITR)  =  JMIN, NUMBER FOR MINIMUM CHISQUARE      C
C                      1 = P, 2 = K, 3 = PI, 4 = E, 0=NO DEDX  C
C      TRES(9,ITR)  =  MOMENTUM (GEV)                          C
C      TRES(10,ITR) =  MOMENTUM ERROR FOR MOST PROB. MASS -> JMIN
C ***  TRES(11,ITR) =  X-MOMENTUM (GEV)                        C
C ***  TRES(12,ITR) =  Y-MOMENTUM (GEV)                        C
C ***  TRES(13,ITR) =  Z-MOMENTUM (GEV)                        C
C *** ITRES(14,ITR) =  1 WIRE SIDE IN OVERFLOW: REBUILDED FROM TRACKFIT
C *** ITRES(15,ITR) =  BOTH WIRE SIDES IN OVERFLOW
C--------------------------------------------------------------C
C----------------DEDX RESULTS-----------------------
       COMMON /CWORK1/ IER,NTRR,TRES(10,60)
       DIMENSION ITRES(10,60)
       EQUIVALENCE (TRES(1,1),ITRES(1,1))
C----------------END--------------------------------
      DIMENSION IJCR(100)
      COMMON /CZSCAL/ IDUM,ZALC
C
#include "cdata.for"
#include "cgraph.for"
#include "cjdrch.for"
C
#include "cdededx.for"
C
      DATA IWARN / 0 /, JWARN / 0/
      INTEGER ONE / 1 /
C
      IPVERS=JPOINT(IPN+1)
      ICALL =ICALL+1
      IF(ICALL.GT.1)GO TO 9
      IPJETC = IBLN('JETC')
      IPJETV = IBLN('JETV')
      IPJHTL = IBLN('JHTL')
      IPJHTQ = IBLN('JHTQ')
      IPPATR = IBLN('PATR')
      IPHEAD = IBLN('HEAD')
    9 CONTINUE
C
      IJETC = IDATA( IPJETC )
      IJETV = IDATA( IPJETV )
      IJHTL = IDATA( IPJHTL )
      IPATR = IDATA( IPPATR )
      IX    = 2*IDATA( IPHEAD )
      IRUN=HDATA(IX+10)
C        MONTE CARLO - RETURN
      IF(IRUN.EQ.0) RETURN
      IPN = JPOINT(8)
      IPVERS=JPOINT(IPN+1)
C-
      IF(ICALL.EQ.1 .AND. NDDINN .EQ. 0 ) PRINT 901, IPVERS
  901 FORMAT(/'  ***********  DEDX - RECALIBRATION  VERSION',I8)
C########## CHANGED CUTS
      NHFCUT = 10
      PMCUT  = 0.01
C-
      IF(ICALL.EQ.1 .AND. NDDINN .EQ. 0 ) PRINT 911, NHFCUT,PMCUT
  911 FORMAT('  -----------       ( LAST CHANGE 12/06/87 )       '/
     *       '  -----------       NEW Z-CALIBRATION FOR OVERFLOW-HITS'/
     *       '  -----------       CORRECT DE/DX FOR OVERFLOW-HITS'/
     *       '  -----------       N(DE/DX)  >=',I8/
     *       '  -----------       PMOM / Q  >=',F12.4/)
C##########
CC    IF(NHFCUT.EQ.15) GO TO 903
CC    JWARN=JWARN+1
CC    IF(NDDINN .EQ. 0 .AND. JWARN .LE. 1) PRINT 902, NHFCUT
CC902 FORMAT(/'  ***********  WARNING:         NHFCUT=     ',I8/)
C
  903 CONTINUE
      IF(IJETC.EQ.0 .OR.IJHTL.EQ.0 .OR.IPATR.EQ.0) GOTO 56
C####### ADDED: 2 AND MOD
         IJETR = IDATA(IJETC-1)
         IF(IJETR.EQ.0) GOTO 56
         IJETR2 = IJETR*2
      IJETC2 = IJETC*2
      IJETV2 = IJETV*2 + 2
      NT = IDATA(IPATR+2)
      IF(NT.LE.0 .OR. NT.GT.NTRTOT) GOTO 57
      IER=0
      NTRR=NT
C        DATE FOR RUN-DEPENDENT CORRECTIONS
      IFLAG = 0
      IPERD = 1
      IF(IRUN.GE.1400) IPERD=2
      IF(IRUN.GE.2600) IPERD=3
      IF(IRUN.GE.3730) IPERD=4
      IF(IRUN.GE.6000) IPERD=5
      IF(IRUN.GE.7592) IPERD=6
      IF(IRUN.GE.10000) IPERD=7
      IF(IRUN.GE.11021) IPERD=8
      IF(IRUN.GE.13088) IPERD=9
      IF(IRUN.GE.14605) IPERD=10
      IF(IRUN.GE.15690) IPERD=11
      IF(IRUN.GE.16803) IPERD=12
      IF(IRUN.GE.17988) IPERD=13
      IF(IRUN.GE.19068) IPERD=14
CHANGED  05/05/87
      IF(IRUN.GE.21123) IPERD=15
      IF(IRUN.GE.21705) IPERD=16
      IF(IRUN.GE.22651) IPERD=17
      IF(IRUN.GE.24201) IPERD=18
      IF(IRUN.GE.25454) IPERD=19
      IF(IRUN.GE.27938) IPERD=20
C-       Z RECALIBRATION (IF NOT YET DONE)
      IHH=HDATA(IJETC2+2)
CHANGED 09/04/87 ; 05/05/87
C     MODE=1
C     IF(IPERD.LT.9  .AND. IHH.NE.8305) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.9  .AND. IHH.NE.8404) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.10 .AND. IHH.NE.8404) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.11 .AND. IHH.NE.8412) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.12 .AND. IHH.NE.8412) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.13 .AND. IHH.NE.8412) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.14 .AND. IHH.NE.8511) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.15 .AND. IHH.NE.8511) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.16 .AND. IHH.NE.8611) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.17 .AND. IHH.NE.8611) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.18 .AND. IHH.NE.8610) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.19 .AND. IHH.NE.8610) CALL ZSFIT(MODE)
C     IF(IPERD.EQ.20 .AND. IHH.NE.8610) CALL ZSFIT(MODE)
CHANGED 2: 05/05/87
CHANGED 2: 12/06/87
           MODE= 11
           CALL ZSFIT(MODE)
C                                           POINTERS MAY HAVE CHANGED
      IJETC = IDATA( IPJETC )
      IJETR = IDATA( IJETC-1 )
      IJETV = IDATA( IPJETV )
      IJHTL = IDATA( IPJHTL )
      IPATR = IDATA( IPPATR )
      IX    = 2*IDATA( IPHEAD )
      IJETR2 = IJETR*2
      IJETC2 = IJETC*2
      IJETV2 = IJETV*2 + 2
C
      FIELD = HDATA(IX+30)
      NDAY=HDATA(IX+7)*30+HDATA(IX+6)-30
      MDAY=NDAY
      IF (IFLAG.EQ.1) GOTO 60
   70 CONTINUE
C              --- SPECIAL CORRECTIONS:
      IF (IRUN.GT.12644) CA(8)=0.248
C
      NDAY = NDAY - ID0(IPERD)
      DAY = NDAY
C --------------------------------------- GAS PRESSURE
      PREFAC = 1. / (1.+CP(IPERD)*BP(IPERD)*DAY/AP(IPERD))
C --------------------------------------- SUBPERIODS
      DO 5 L=1,3
      IF(NDAY.LT.LSP(L,IPERD)) GOTO 6
    5 CONTINUE
      L = 1
    6 SUBFAC = SPF(L,IPERD)
C --------------------------------------- ELECTRON ATTACHMENT
      ICLBIN = DAY/10. + 1.5
      IF(ICLBIN.LE.0) ICLBIN=1
      IF(ICLBIN.GT.19) ICLBIN=19
      FRACT = DAY/10. - ICLBIN + 1
      TIMCOR = CA(IPERD) * (CL(ICLBIN)+FRACT*(CL(ICLBIN+1)-CL(ICLBIN)))
      TIMCOR = TIMCOR/1000.
C --------------------------------------- QUALITY OF HITS IN JHTQ
      IJHTQ = IDATA( IPJHTQ )
      IF( IJHTQ.LE.0 ) GO TO 111
        JHTQBT = IDATA(IJHTQ+1)
        NHPW = 32/JHTQBT
  111 CONTINUE
C --------------------------------------- LOOP OVER ALL TRACKS
      L0 = IDATA(IPATR+1)
      LT = IDATA(IPATR+3)
      KT = IPATR + L0
      DO 59 I=1,NT
C--------
      CALL MOMENP(KT,PX,PY,PZ,PTRANS,PMOM,PHI,THE)
C--------
C####### ADDED: 2
         PZ1 = ADATA(KT+30)
         PZ0 = ADATA(KT+31)
         NHRZ= IDATA(KT+33)
C####### CHANGED:
CCC      IF (PMOM.LT.0.06) GOTO 58
         IF (PMOM.LT.PMCUT) GOTO 58
      NHIT = 0
      CALL VZERO(IZB,60)
      IF(ADATA(KT+25).EQ.0.) GOTO 58
      R = -1. / ADATA(KT+25)
      SR = SIGN(1.,R)
      CTH = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      STH = ADATA(KT+10)
      TTH = ABS(STH/CTH)
      IF (TTH.GT.6.) GOTO 58
C
      CPHI = ADATA(KT+8) / CTH
      SPHI = ADATA(KT+9) / CTH
      X0 = ADATA(KT+5)
      Y0 = ADATA(KT+6)
      XM = X0 - R*SPHI
      YM = Y0 + R*CPHI
      R0 = SQRT(X0**2+Y0**2)
      XE = ADATA(KT+12)
      YE = ADATA(KT+13)
      SE = R * ATAN2(SR*(CPHI*(XE-X0)+SPHI*(YE-Y0)),
     *               SR*(SPHI*(XE-X0)-CPHI*(YE-Y0)+R))
      IF(ABS(R).GT.1.E5) SE=SQRT((XE-X0)**2+(YE-Y0)**2)
C
C --------------------------------------- ORDER CELLS
      NC = 0
      DO 12 J=1,6
      KC = IDATA(KT+40-J)
      IF(KC.LE.0 .OR. KC.GT.96) GOTO 12
      IF(NC.EQ.0) GOTO 11
      IF(KC.GT.IC(NC)) GOTO 11
      DO 10 K=1,NC
      IF(KC.GT.IC(K)) GOTO 10
      IF(KC.EQ.IC(K)) GOTO 12
      JC = IC(K)
      IC(K) = KC
      KC = JC
   10 CONTINUE
   11 NC = NC + 1
      IC(NC) = KC
   12 CONTINUE
C --------------------------------------- LOOP OVER CELLS
      IM2 = I*2
      IM1 = IM2*65536
      DO 19 J=1,NC
      NCP = IJETC2 + IC(J) + 2
      NHCELL = (HDATA(NCP+1)-HDATA(NCP))/4
      KHCELL = (HDATA(NCP)-1)/4
      DO 14 L=1,16
   14 IHDT(L) = 0
C --------------------------------------- LOOP OVER HITS
      DO 18 K=1,NHCELL
      KA = IJHTL + KHCELL + K + 1
      IF(IDATA(KA).EQ.0) GOTO 18
      LRFLAG = 0
      ZFLAG = 0
      IMH=LAND(IDATA(KA),MTRNO1)
      IF(IMH.NE.IM1) GOTO 13
      IF(TBIT(IDATA(KA),15)) ZFLAG=1
      IF(TBIT(IDATA(KA), 7)) LRFLAG=1
      KABIT = 15
      GOTO 15
   13 IMH=LAND(IDATA(KA),MTRNO2)
      IF(IMH.NE.IM2) GOTO 18
      IF(TBIT(IDATA(KA),31)) ZFLAG=1
      IF(TBIT(IDATA(KA),23)) LRFLAG=1
      KABIT = 31
C ------------------------------------- HIT FOUND IN CELL IC(J), TRACK I
   15 IF (NHIT.EQ.60) GOTO 20
C                                           TAKE HIT QUALITY FROM JHTQ
      IF( IJHTQ .LE. 0 ) GO TO 17
        KS = KHCELL + K
        NRW = (KS-1)/NHPW + 1
        NQW = IJHTQ + 1 + NRW
        NSHIFT = MOD(KS-1,NHPW)*JHTQBT
        IF( KABIT .EQ. 15 ) NSHIFT = NSHIFT + 1
        ZFLAG = 0
        IF( LAND(IDATA(NQW),SHFTL(ONE,NSHIFT)).NE.0 ) ZFLAG = 1
   17 CONTINUE
C
      NHIT = NHIT + 1
      NH1 = IJETC2 + (KHCELL+K-1)*4 + 101
      IJC(NHIT) = NH1
C####### ADDED: 2
         NH1R = IJETR2 + (KHCELL+K-1)*4 + 101
         IJCR(NHIT) = NH1R
      IJH(NHIT) = KA
      IF(KABIT.EQ.15) IJH(NHIT)=-IJH(NHIT)
      LRFL(NHIT) = LRFLAG
      MHIT = HDATA(NH1)
      NW(NHIT) = MHIT / 8
      LH(NHIT) = LAND(MHIT,7) + 1
      ILAY = LAND(NW(NHIT),15) + 1
      IF (ILAY.LE.0 .OR. ILAY.GT.16) GOTO 18
      IHDT(ILAY) = NHIT
      IZB(NHIT) = 0
      IF(ZFLAG.EQ.0) GOTO 18
      IZB(NHIT) = LH(NHIT)
   18 CONTINUE
C
C --------------------------------------- X-TALK MATRIX
      DO 119 L=1,16
      K = IHDT(L)
      IF(K.LE.0 .OR. K.GT.60) GOTO 119
      DO 114 M=1,4
      IXL(K,M) = 0
      IXH(K,M) = 0
      IF(L.LE.M) GOTO 112
      IF(IHDT(L-M).EQ.0) GOTO 112
      IXL(K,M) = IHDT(L-M)
  112 IF(L.GE.17-M) GOTO 114
      IF(IHDT(L+M).EQ.0) GOTO 114
      IXH(K,M) = IHDT(L+M)
  114 CONTINUE
  119 CONTINUE
   19 CONTINUE
   20 CONTINUE
C --------------------------------------- LOOP OVER ALL HITS OF TRACK I
      NHF = 0
C####### ADDED: 2
         NOV = 0
         NFT = 0
      NCL = -1
C
      DO 29 J=1,NHIT
      IF(IZB(J).EQ.0) GOTO 29
      NC = NW(J) / 16
      NR = NC / 24
      IF(NR.LT.3) NR=NR+1
      INR = (NR-1)*2
      NL = LAND(NW(J),15)
      NH1 = IJC(J)
      AR = HDATA(NH1+1)
      AL = HDATA(NH1+2)
C####### ADDED: 5
C------- FIND OVERFLOW-HITS
         NH1R = IJCR(J)
         ARR = HDATA(NH1R+1)
         ALR = HDATA(NH1R+2)
         IF(ALR.GE.4095.) AL = 32400.
         IF(ARR.GE.4095.) AR = 32400.
      AMP = AL + AR
      T = HDATA(NH1+3) / 64.
C
      ILR = LRFL(J) + 1
      TM = VDREL(IPERD)*(TMAX(ILR,NR)+TSLP(ILR,NR)*NL)
      XT = T / TM
C####### ADDED:
C------- RECONSTRUCT SINGLE SIDE OVERFLOW AMPLITUDES
C------- FROM FITTED ZR-TRACK-PARAMETERS
         IF(NHRZ.LT.10) GO TO 100
         IF(ALR.LT.4095. .AND. ARR.LT.4095.) GO TO 100
         IF(ARR.GE.4095. .AND. ALR.GE.4095.) GO TO 100
           LRFLAG = LRFL(J)
           CALL ZSXY(NH1,LRFLAG,XJET1,YJET1,XJET2,YJET2)
           ZTH = PZ0 + PZ1*SQRT(XJET1**2+YJET1**2)
           IF(ZALC.LE.0.) ZALC = 1400.
           FAK = (ZALC - ZTH)/(ZALC + ZTH)
           ARN = 0.
           ALN = 0.
           IF(ARR.GE.4095.) ARN= AL*FAK
           IF(ALR.GE.4095.) ALN= AR/FAK
           IF(ARN.GT.AR) AR = ARN
           IF(ALN.GT.AL) AL = ALN
           AMP= AR + AL
 100  CONTINUE
C##############
      AMP = AMP / 8.
C --------------------------------------- REMOVE HITS IN CELL CORNERS
      IF(NL.GT.0 .AND. NL.LT.14) GOTO 21
      IF(T.LT.90.) GOTO 21
      IF(NL.EQ.15.AND.LRFL(J).EQ.1) GOTO 26
      IF(NL.EQ. 0.AND.LRFL(J).EQ.0) GOTO 26
      IF(NR.EQ.2.AND.NL.EQ.14.AND.LRFL(J).EQ.1.AND.T.GT.180.) GOTO 26
   21 IF(XT.GT.0.97) GOTO 26
      IF(T.LE.4.) GOTO 26
      IF(IPERD.EQ.1 .AND. NC.EQ.9) GOTO 26
C --------------------------------------- X - TALK
      DW(J) = 0
      DO 124 M=1,4
      JXT = 1
      K = IXL(J,M)
      IF(K.LE.0 .OR. K.GT.60) GOTO 122
  121 NHX = IJC(K)
      AMPX = (HDATA(NHX+1)+HDATA(NHX+2))/8.
      TX = HDATA(NHX+3)/64.
      GATE = T - TX - 1.0
      IF(GATE.LT.0.) GOTO 125
      IF(GATE.GT. 9.) GOTO 122
      BT = GATE
      GOTO 126
  125 BT = 10. + GATE
      IF(BT.LE.0.) GOTO 122
  126 FXT = 1.-BT/5.*(1.-BT/20.)
      IF(GATE.LT.0.) FXT=1.-FXT
      AMP = AMP + AMPX*CTALK(M)*FXT
      DW(J) = DW(J) + AMPX*CTALK(M)
  122 JXT = JXT + 1
      IF(JXT.GT.2) GOTO 124
      K = IXH(J,M)
      IF(K.NE.0) GOTO 121
  124 CONTINUE
      DL(J) = AMP
C --------------------------------------- GAIN
      GAIN=ACALIB(IPN+6+NW(J))
      AMP = AMP * GAIN
C --------------------------------------- WIRE STAGGERING
      IMH=LAND(NL,1)
      IF(IMH.NE.LRFL(J)) AMP=AMP*0.92
C -------------------- COMPUTE TRACK LENGTH IN DRIFTSPACE, ANODE CURRENT
C ----IF(ABS(R).GT.4000. .AND. NC.EQ. NCL) GOTO 24----
      IF(NC.EQ.NCL) GOTO 23
      NCL = NC
      CURR = 0.
      IF(IJETV.EQ.0) GOTO 22
      NS = NC - (NR-1)*24
      IF(NR.EQ.3) NS=NS/2
      KR = NR
      IMH=LAND(NC,1)
      IF(NR.EQ.3 .AND. IMH.EQ.1) KR=4
      ICURR = HDATA(IJETV2+NS*4+KR)
      CURR = LAND(ICURR,2047)
      IF (CURR.GT.80.) CURR=0.
   22 PHIW = 0.1309 + 0.2618*NC
      IF(NC.GE.48) PHIW=PHIW/2.
      CPHW = COS(PHIW)
      SPHW = SIN(PHIW)
C ----CPHD =  SPHW*CALF - CPHW*SALF----
C ----SPHD = -CPHW*CALF - SPHW*SALF----
      CPHD =  SPHW*DRICOS + CPHW*DRISIN
      SPHD = -CPHW*DRICOS + SPHW*DRISIN
   23 RW = 211.*NR + 10.*NL
      XW = RW * CPHW
      YW = RW * SPHW
      SGAM = ((XW-XM)*SPHD-(YW-YM)*CPHD)/R
      IF(ABS(SGAM).GT..87) GOTO 26
      CGAM = SQRT(1.-SGAM**2)
      TGAM = SGAM/CGAM
C --------------------------------------- TRACK LENGTH
   24 AMP = AMP * CGAM*CTH
      DT(J) = TGAM
C --------------------------------------- ANODE CURRENT
      AMP = AMP / (1.-0.00011*CURR**2)
C --------------------------------------- FINITE GATE LENGTH
      AMP = AMP / (1.-0.25*TGAM-0.60*TGAM**2)
C --------------------------------------- SATURATION
      AMP = AMP/(1.-SATTO(INR+1,IPERD)*EXP(-SATTO(INR+2,IPERD)*SQRT(T)))
      AMP = AMP/(1.-SATQUA(NR,IPERD)*T**2/1000.)
      AMP = AMP*9.67/SATFAC(NR,IPERD)
C
C --------------------------------------- GAS PRESSURE
      AMP = AMP * PREFAC
C --------------------------------------- SUBPERIODS
      AMP = AMP * SUBFAC
C --------------------------------------- DAY/4 CORRECTION
      IDAY4=MDAY/4 + (NR-1)*100 + 1
      ADAY4=ACALIB(IPN+1541+IDAY4)
      AMP = AMP * ADAY4
C --------------------------------------- ATTACHMENT
      AMP = AMP * EXP(TIMCOR*T)
C --------------------------------------- GAIN SATURATION
      AMP = AMP/(1.-SATSO(INR+1,IPERD)*EXP(-SATSO(INR+2,IPERD)*
     *                                   SQRT(TTH**2+SATSO(7,IPERD)*T)))
C --------------------------------------- EDGE FIELD DISTORTIONS
      IF(NL.GT.3 .AND. NL.LT.12) GOTO 25
      IL = NL
      IF(NL.GT.8) IL=15-NL
      ICORN = 0
      IF(NL.LT.8 .AND. LRFL(J).EQ.1) ICORN=1
      IF(NL.GT.8 .AND. LRFL(J).EQ.0) ICORN=1
      ICORN = ICORN*4 + IL + 1
      XTORT = XT - 0.5
      IF(XTORT.LT.0.) XTORT=0.
      AMP = AMP * FTORT(1,ICORN)*(1.+FTORT(2,ICORN)*XTORT)
   25 CONTINUE
      IF (NHF.EQ.60) GOTO 30
      NHF = NHF + 1
C####### ADDED: 5
C------- MARK OVERFLOW-HITS
         IF(AMP.LT.0.) AMP = 0.
         IF(ARR.GE.4095. .AND. ALR.GE.4095.) AMP = 10000. + AMP
         IF(ARR.GE.4095. .AND. ALR.GE.4095.) NOV = NOV + 1
         IF(ARR.GE.4095. .AND. ALR.LT.4095.) NFT = NFT + 1
         IF(ARR.LT.4095. .AND. ALR.GE.4095.) NFT = NFT + 1
      G(NHF) = AMP
      S(J) = AMP
      GOTO 29
   26 IZB(J) = 0
   29 CONTINUE
   30 CONTINUE
      IF(NHF.LT.NHFCUT) GOTO 58
C####### CHANGED
CCC   CALL DSORT(NHF,G,TRCM,DTRCM)
         CALL DSORTO(NHF,G,TRCM,DTRCM)
      IF(TRCM.LT.0.1) GOTO 58
           COST = PZ/PMOM
          CAL = CALEX(IRUN,PMOM,COST,SR,TRCM)
         TRCM  = TRCM*CAL
         DTRCM = DTRCM*CAL
         DTRCM = ERDEDX(TRCM,DTRCM,IRUN,NHF)
C###############
C-------------  RESULTS  ----------------------------------------------
C
      ITRES(1,I)=NHF
      TRES(2,I)=TRCM
C####### CHANGED 1
CCC   TRES(3,I)=2.6*DTRCM
         TRES(3,I)=DTRCM
C###############
      TRES(9,I)=PMOM
C ***     TRES(11,I)=PX
C ***     TRES(12,I)=PY
C ***     TRES(13,I)=PZ
C ***     ITRES(14,I)=NFT
C ***     ITRES(15,I)=NOV
C
      PP2=TRCM
      SIGDE=TRES(3,I)
C
       CHMIN=1000000.
       SIGPP=1000000.
       JMIN=0
      CALL ERRMOM(KT,PMOM,ELMASS,SIGMP)
C####### CHANGED
CCC   CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,ELMASS,PDEELC,DEDELC,CHIELC)
         CALL DECHIL(PMOM,SIGMP,PP2,SIGDE,ELMASS,PDEELC,DEDELC,CHIELC)
C###############
       IF(CHMIN .LT. CHIELC) GOTO 250
       CHMIN=CHIELC
       SIGPP=SIGMP
       JMIN=4
250   CONTINUE
      CALL ERRMOM(KT,PMOM,PIOMAS,SIGMP)
C####### CHANGED 1
CCC   CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,PIOMAS,PDEPIO,DEDPIO,CHIPIO)
         CALL DECHIL(PMOM,SIGMP,PP2,SIGDE,PIOMAS,PDEPIO,DEDPIO,CHIPIO)
C###############
       IF(CHMIN .LT. CHIPIO) GOTO 251
       CHMIN=CHIPIO
       SIGPP=SIGMP
       JMIN=3
251   CONTINUE
      CALL ERRMOM(KT,PMOM,FKAMAS,SIGMP)
C####### CHANGED 1
CCC   CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,FKAMAS,PDEKAO,DEDKAO,CHIKAO)
         CALL DECHIL(PMOM,SIGMP,PP2,SIGDE,FKAMAS,PDEKAO,DEDKAO,CHIKAO)
C###############
       IF(CHMIN .LT. CHIKAO) GOTO 252
       CHMIN=CHIKAO
       SIGPP=SIGMP
       JMIN=2
252   CONTINUE
      CALL ERRMOM(KT,PMOM,PROTMA,SIGMP)
C####### CHANGED 2
CCC   CALL DECHIF(PMOM,SIGMP,PP2,SIGDE,PROTMA,PDEPRO,DEDPRO,CHIPRO)
         CALL DECHIL(PMOM,SIGMP,PP2,SIGDE,PROTMA,PDEPRO,DEDPRO,CHIPRO)
C###############
       IF(CHMIN .LT. CHIPRO) GOTO 253
       CHMIN=CHIPRO
       SIGPP=SIGMP
       JMIN=1
253    TRES(4,I)=CHIELC
       TRES(5,I)=CHIPIO
       TRES(6,I)=CHIKAO
       TRES(7,I)=CHIPRO
       ITRES(8,I)=JMIN
       TRES(10,I)=SIGPP
       GOTO 59
C
   58 CONTINUE
      ITRES(1,I)=-1
      TRES(2,I)=0.
      TRES(3,I)=0.
      TRES(4,I)=-1.
      TRES(5,I)=-1.
      TRES(6,I)=-1.
      TRES(7,I)=-1.
      ITRES(8,I)=0
      TRES(9,I)=PMOM
      TRES(10,I)=1000000.
C ***     TRES(11,I)=PX
C ***     TRES(12,I)=PY
C ***     TRES(13,I)=PZ
C ***     ITRES(14,I)=0
C ***     ITRES(15,I)=0
C
C-------------  END OF RESULTS  ---------------------------------------
C
   59 KT = KT + LT
C                                           DELETE JHTQ BANK
      CALL BMLT( 1, 'JHTQ' )
      CALL BDLM
C
      RETURN
C
   56 PRINT 561
  561 FORMAT ('  ***** ERROR IN DEDXBN: BANK POINTER = 0')
      IER=1000
      RETURN
C
   57 PRINT 571
  571 FORMAT ('  ***** ERROR IN DEDXBN: # OF TRACKS < 0 OR > 60')
      IER=4000
      RETURN
C
   60 NDAY=75 + ID0(IPERD)
      IWARN=IWARN+1
      IF(IWARN.EQ.1) PRINT 601, IRUN
  601 FORMAT(/'  ***********  WARNING: DEDX CALIBRATION CONSTANTS NOT VA
     +LID FOR THESE DATA !!!'/'  ***********  RUN #  :',I10,'  AND LATER
     +'/)
      GOTO 70
C
      END
C   02/09/86 609061900  MEMBER NAME  DSORTO   (S)           FORTRAN
C     **********************************
      SUBROUTINE DSORTO(N,PH,TRCM,DTRCM)
C     **********************************
C-------------------------------------- CHANGED: 29/08/86 K.AMBRUS
C
C   SUBROUTINE TO TAKE AVERAGE OF 5% - 70% LOWEST PULSE HEIGHTS
C     PUSE HEIGHTS IN PH(L) ,L=L'TH PULSE HEIGHT (INCL. OVERFLOWHITS)
C   OVERFLOW - HITS ARE USED
C   CORRECTION FOR FRACTIONAL HITS
C
C-----------------------------------------------------------------------
      DIMENSION PH(60)
C                            SET TRUNCATED MEAN FRACTION
      DATA TRMFLO /0.05/, TRMFHI /0.70/
      DATA NMIN   / 3  /
      IF (N.LT.NMIN) GOTO 99
C                            SORT PULSEHEIGHTS IN INCREASING ORDER
C=====
          XN = FLOAT(N)
        XNL = TRMFLO*XN
        XNH = TRMFHI*XN
      NTRMLO = XNL + 1
      NTRMHI = XNH + 1
      WL = XNL + 1. - NTRMLO
      WH = NTRMHI - XNH
C                            USE SHELL ALGORITHM
      M=N
   10 M=M/2
      IF (M.EQ.0) GO TO 40
      K=N-M
      DO 30 J=1,K
      I=J
   20 IF (I.LT.1) GO TO 30
      IF (PH(I+M).GE.PH(I)) GO TO 30
      W=PH(I)
      PH(I)=PH(I+M)
      PH(I+M)=W
      I=I-M
      GO TO 20
   30 CONTINUE
      GO TO 10
   40 CONTINUE
C                            SHELLS ARE SORTED NOW
        TRM = 0.
        SUM=0.
        SUM2=0.
          IO = 0
      DO 60 I=NTRMLO,NTRMHI
C                            ESTIMATION FOR OVERFLOW-HITS
          IF(PH(I).GE.10000.) IO = IO + 1
          IF(IO.EQ.1) PH(I) = PH(I) - 10000.
          IF(IO.EQ.1 .AND. I.GT.1 .AND. PH(I).LT.PH(I-1)) PH(I)=PH(I-1)
          IF(IO.GT.1) PH(I) = PH(I-1)*1.05
        IH = I
        TRM = TRM + 1.
        SUM=SUM+PH(I)
        SUM2=SUM2+PH(I)**2
  60  CONTINUE
C                                     CORRECT FOR FRACTIONAL HITS
        TRM = TRM  - WL - WH
        SUM = SUM  - WL*PH(NTRMLO) - WH*PH(IH)
        SUM2= SUM2 - WL*PH(NTRMLO)**2 - WH*PH(IH)**2
C                            CALCULATE MEAN AND SIGMA MEAN
      IF(TRM.LT.2) GO TO 99
      TRCM = SUM/TRM
        RMS = (SUM2 - TRM*TRCM**2)/(TRM-1.)
        RMS = RMS/TRM
        DTRC2 = ABS(RMS)
      DTRCM = SQRT(DTRC2)
      RETURN
C
   99 TRCM = 0.
      DTRCM = 0.
  100 CONTINUE
      RETURN
      END
C   20/05/87 702061751  MEMBER NAME  IPCALF   (S)           FORTRAN
C     *********************
      FUNCTION IPCALF(NRUN)
C     *********************
      DIMENSION JNA(39)
      DATA JNA/ 2600, 3730, 6000, 6850, 7170, 7592, 7840, 8120, 8375,
     #    8850, 9188, 9464,10000,10391,10578,10761,11021,11331,11634,
     #   12004,12341,13088,14605,15690,16803,17989,19068,21123,21705,
     #   22651,23443,23798,24201,25454,26217,27000,27938,28444,99999/
C     DATA IPRINT/1/
C***** FADC - DATEN FROM RUN 24201 (IP>33) *****
C---
      IPCALF = 1
      DO 1000 I=1,39
        IF(NRUN.GE.JNA(I)) IPCALF=I+1
1000  CONTINUE
C---
C     IPRINT = IPRINT + 1
C     IF(IPRINT.LE.1) PRINT 900
C     IF(IPCALF.GT.33 .AND. IPRINT.LE.1) PRINT 902,IPCALF
C900  FORMAT(1X,'########## IPCALF   05/05/1987   F11AMB.ANAL.L')
C902  FORMAT(1X,'********** IPCALF:  PER=',I2
C    #         ,': FADC - DATA')
C---
      RETURN
      END
C   26/09/83 704081242  MEMBER NAME  CHIFTL   (S)           FORTRAN
C     **********************************************************
      SUBROUTINE CHIFTL(X0,SIGX,Y0,SIGY,FITFCN,EPS,XB,YB,CHISQR)
C     **********************************************************
C  LAST CHANGE: 18.10.86   K.AMBRUS
C-----------------------------------------------------------------------
C
C        FINDS THE 'BEST' POINT (XB,YB) ON THE CURVE
C        Y=FITFCN(X), GIVEN THE INDEPENDENTLY MEASURED VALUES
C        X0 AND Y0, WITH STANDARD DEVIATIONS SIGX AND SIGY.
C
C        THE 'BEST' POINT IS THE POINT WHICH MINIMIZES CISQUARE,
C        GIVEN BY  CHISQ = ((X0-XB)/SIGX)**2 + ((Y0-YB)/SIGY)**2 .
C
C        THE ITERATION STOPS WHEN THE VALUES OF CHISQ FROM TWO CON-
C        SECUTIVE ITERATIONS DIFFER BY LESS THAN CHISQ*EPS,
C        OR WHEN THE NUMBER OF ITERATIONS REACHES ITRMAX (SET IN
C        DATA STATEMENT).
C
C        IF INPUT PARAMETERS ARE HOPELESS, NO FIT IS ATTEMPTED, AND
C        CHISQR IS SET TO 1.0E30.
C                                                  J.A.J.SKARD, 14/8/83
C-----------------------------------------------------------------------
C        COMMON FOR FITFCN
      COMMON /CODEDX/PAR(15),NPAR
      EXTERNAL FITFCN
C        MAX ITERATIONS
      DATA ITRMAX/10/
C        STEP SIZE IN X (FRACTION OF SIGX)
      DATA FACSTP/1.0/
C        STEP SIZE REDUCTION FACTOR FOR SUCCESSIVE ITERATIONS
      DATA FACRED/0.1/
C        LIMIT FOR PRINTOUT OF DIAGNOSTICS
      DATA IPRMAX/10/,IPR/0/
C        DEFINE CISQUARE AS AN INTERNAL STATEMENT FUNCTION
C****    NOTE: LOGARITHMIC X-SCALE IS USED
CH 18/10/86      CHISQ(X)=(X0-EXP(X))**2*HX+(Y0-FITFCN(EXP(X)))**2*HY
      CHISQ(X)=(X0-X)**2*HX+(Y0-FITFCN(X))**2*HY
C        GUARD AGAINST SOME OBVIOUS DISASTERS...
CH 18/10/86      IF(X0.LE.1.E-15)GO TO 10
      IF(Y0-FITFCN(X0).LT.SIGY*1.E15.AND.SIGX.GT.1.E-15)GO TO 1
   10 IPR=IPR+1
      IF(IPR-IPRMAX)2,3,4
    2 CONTINUE
CCC 2 WRITE(6,997)X0,SIGX,Y0,SIGY
  997 FORMAT(' *** CHIFTL: HOPELESS PARAMETERS. NO FIT ***',/,
     * 13X,'X0,SIGX,Y0,SIGY:',4E12.4)
      GO TO 4
    3 CONTINUE
CCC 3 WRITE(6,998)
    4 XB=X0
      YB=Y0
      CHISQR=1.E30
      GO TO 100
C        PARAMETERS ARE NOT UTTERLY HOPELESS - TRY FITTING
    1 HX=1./(SIGX*SIGX)
      HY=1./(SIGY*SIGY)
CH 18/10/86        CHANGE TO LOGARITHMIC X-SCALE
CH 18/10/86      X=ALOG(X0)
       X= X0
      DELX=AMIN1(FACSTP*SIGX/X0,10.)
      CHIM1=CHISQ(X)
      ITER=0
   11 CHI1=CHIM1
   41 ITER=ITER+1
      IF(ITER.LT.ITRMAX)GO TO 4141
      GO TO 8383
4141  X=X+DELX
      CHI2=CHISQ(X)
C        CHECK IF WE STARTED OUT IN THE RIGHT DIRECTION
      IF(CHI1-CHI2)51,41,61
C        WE DID NOT. REVERSE DIRECTION.
   51 DELX=-DELX
      X=X+DELX
      SAVE=CHI1
      CHI1=CHI2
      CHI2=SAVE
C        KEEP STEPPING ALONG...
   61 X=X+DELX
      CHI3=CHISQ(X)
C        CHECK NEW CHISQUARE
      IF(CHI3-CHI2)71,81,81
C        STILL DECREASING, ONE MORE STEP..
   71 CHI1=CHI2
      CHI2=CHI3
      GO TO 61
C        FIND MINIMUM OF PARABOLA DEFINED BY LAST THREE POINTS
   81 X=X-DELX*((CHI3-CHI2)/(CHI3-2.*CHI2+CHI1)+0.5)
      CHIM2=CHISQ(X)
C        ARE WE NEAR ENOUGH?
      IF(ABS(CHIM2-CHIM1).LT.CHIM1*EPS)GO TO 91
C        NOT YET - CHECK LIMIT OF ITERATIONS
      IF(ITER.LT.ITRMAX)GO TO 85
C        LIMIT OF ITERATIONS REACHED
 8383 IPR=IPR+1
      IF(IPR-IPRMAX)82,83,91
   82 CONTINUE
CCC82 WRITE(6,999)ITRMAX
  999 FORMAT(' *** CHIFTL: LIMIT OF',I4,' ITERATIONS REACHED, FIT STOPPE
     *D ***')
      GO TO 91
   83 CONTINUE
CCC83 WRITE(6,998)
  998 FORMAT(' *** CHIFTL: DIAGNOSTICS TURNED OFF, LIMIT REACHED ***')
      GO TO 91
C        RESET PARAMETERS AND DO IT AGAIN
   85 CHIM1=CHIM2
C        REDUCE STEP SIZE
      DELX=DELX*FACRED
      GO TO 11
C        GOOD ENOUGH - TIDY UP AND QUIT
   91 CHISQR=CHISQ(X)
CH 18/10/86      XB=EXP(X)
      XB=X
      YB=FITFCN(XB)
  100 RETURN
      END
C   05/11/82 501111759  MEMBER NAME  DECHIF   (S)           FORTRAN
C     ************************************************************
      SUBROUTINE DECHIL(P,SIGP,DE,SIGDE,FMASS,PBEST,DEBEST,CHISQR)
C     ************************************************************
C
C        CALCULATES CHI SQUARE AND BEST POINT (PBEST,DEBEST) ON
C        THEORETICAL DE/DX-CURVE, DEFINED BY THE FUNCTION DETHRL.
C        THUS DEBEST=DETHRL(PBEST). THE BEST POINT IS CHOSEN TO MINIMIZE
C        THE CHI SQUARE DEVIATION FOR THE POINT (LN(P),LN(DE)),
C        MEASURED WITH
C        ACCURACIES GIVEN BY THE STANDARD DEVIATIONS SIGP AND SIGDE.
C        THE THEORETICAL CURVE IS FOR PIONS, OTHER PARTICLES GET THEIR
C        MOMENTA SCALED TO THE SAME BETA BEFORE THE FIT
C
C                                                 J.A.J.SKARD, 14/8/83
C                                           COPIED:  K.AMBRUS, 24/1/84
C
       EXTERNAL DETHRL
C       REQUIRED ACCURACY OF MINIMUM CHI SQUARE IS AMAX1(CHISQR*EPS,EPS)
       DATA EPS/0.01/
C      DATA IPRINT/5/
       SCAFAC=0.1395669/FMASS
       PP=P*SCAFAC
       SIGPP=SIGP*SCAFAC
C-----
        PBEST = 0.
        DEBEST = 0.
        CHISQR = 1.E20
        IF(P.LE.0. .OR. DE.LE.0.) GO TO 9999
        IF(SIGP.LE.0. .AND. SIGDE.LE.0.)  GO TO 9999
C-----                     LOGARITHMIC SCALE
          PL  = ALOG(PP)
          SPL = SIGPP/PP
          EL  = ALOG(DE)
          SEL = SIGDE/DE
C-----
        CALL CHIFTL(PL,SPL,EL,SEL,DETHRL,EPS,PLB,ELB,CHISQR)
C-----                    LINEAR SCALE
            IF(PLB.GT.170.) PLB = 170.
            IF(ELB.GT.170.) ELB = 170.
          PBEST  =  EXP(PLB)/SCAFAC
          DEBEST =  EXP(ELB)
 9999  CONTINUE
C########## TEST
C      IF(IPRINT.LT.5) PRINT 910,P,SIGP,DE,SIGDE,FMASS
C      IF(IPRINT.LT.5) PRINT 920,PBEST,DEBEST,CHISQR
C      IPRINT = IPRINT + 1
C 910 FORMAT(1X,'###TEST### DECHIL:',2F10.4,2X,2F10.4,2X,2F10.4)
C 920 FORMAT(1X,'--RESULT-- DECHIL:',F10.4,12X,F10.4,12X,F10.4)
C###############
       RETURN
       END
C      *********************
       FUNCTION DETHRL(PL0)
C      *********************
C
C           RETURNS 'THEORETICAL' VALUE OF JADE DEDX FOR GIVEN
C        MOMENTUM BASED ON EMPIRICAL ADJUSTMENT TO THE DATA
C
      DATA  PIMAS,CHARGE / 0.1395669,1.000 /
          PL = PL0
          IF(PL.LT.-7.) PL =  -7.
          IF(PL.GT. 7.) PL =   7.
        P = EXP(PL)
      DETHRL=DEDXTP(P,PIMAS,CHARGE)
      DETHRL=ALOG(DETHRL)
      RETURN
       END
C   06/04/86 611231616  MEMBER NAME  DEDXTP   (S)           FORTRAN
C     ***********************************
      FUNCTION DEDXTP(PTOT,XMASS,CHARGE)
C     ***********************************
C ---------------------------------------------------------------------
C
C        CALCULATE THEORETICAL VALUE FOR DEDX
C
C        DEDXTP = DEDXTP( P , M , Q )
C
C        1/B**2- AND RERISE-REGION  ADJUSTED TO OBSERVATION
C        STERNHEIMER PARAMETERISATION OF DE/DX AS FUNCTION OF BETA
C
C        INPUT : PTOT  = P
C                XMASS  = M
C                CHARGE = Q
C
C        OUTPUT: DEDXTP = DE/DX  AT GIVEN VALUE OF P , M , Q
C
C        CHANGED: K. AMBRUS  07.04.1986
C ---------------------------------------------------------------------
C     BHABHAS ARE SET TO 10 KEV/CM
C     DEMIN  = EXPERIMENTAL VALUE FOR DE/DX IN MINIMUM
C     PARK   = ADJUST 1/B**2 - REGION
C     AA     = ADJUST RERISE - REGION
C
C ---------------------------------------------------------------------
      DATA IPRINT/0/
      DATA   DEMIN ,  PARK  ,   AA    , BGMIN
     #    / 6.9754 , 13.848 , 0.25981 , 3.96  /
      DATA ALFAT,X0,XA,X1,CC/5*0./
C---------------------------- CALCULATE PARAMETER
C                             INPUT: DEMIN,PARK,AA,BGMIN
      IF(IPRINT.LE.0) CALL PARSET(DEMIN,ALFAT,PARK,X0,XA,X1,AA,CC,BGMIN)
      IPRINT = IPRINT + 1
C     IF(IPRINT.EQ.0) PRINT 910
C910  FORMAT(' ########## DEDXTP:  04/05/1986  F11AMB.ANAL.L')
C---------------------------
      CHARG2 = CHARGE*CHARGE
         IF(CHARG2.LE.0.) CHARG2 = 1.
      IF(PTOT.LE.0.) GO TO 9999
       BETAG = 0.
       IF(XMASS.GT.0.) BETAG=PTOT/XMASS
       IF(BETAG.LE.0.01) GO TO 9999
       IF(BETAG.GT.1.E6) BETAG = 1.E6
      BG2 = BETAG*BETAG
      BB = BG2/(1.+BG2)
C-
        X=PARK+ALOG(CHARG2)+ALOG(BG2+1.)-BB-DENSC(BETAG,X0,XA,X1,AA,CC)
       DEDXTP=X*CHARG2*ALFAT/BB
      RETURN
C-
9999  CONTINUE
      DEDXTP = 1.E10
      RETURN
      END
C
C     *********************
      FUNCTION DENSC(BETAG,X0,XA,X1,AA,CC)
C     *********************
      COMMON /COMFIT/APCCO,PQCO,PPCO,P1CO,P2CO,P3CO,X1CO,XFCO
C
        X=ALOG10(BETAG)
        DENSC=0.
      IF(X.LE.X0) RETURN
        DENSC=CC*(X-XA)
      IF(X.GE.X1) RETURN
        DENSC=DENSC+AA*(X1-X)**3.
      RETURN
      END
C     ******************************************
      SUBROUTINE PARSET(EXMI,AL,AK,X0,XA,X1,AA,CC,BGMIN)
C     ******************************************
C     SET PARAMETER - VALUES: AL,X0,XA,X1,CC
C                      INPUT: EXMI,AK,AA,BGMIN
      DATA EXPL / 10. /
        CC  = 2.*ALOG(10.)
        BG2 = BGMIN*BGMIN
        BB = BG2/(BG2+1.)
C=====                                        CALCULATION OF AL
          FM = AK + ALOG(BG2+1.) - BB
      AL = EXMI*BB/FM
C-----                                         CALCULATION OF XA,X0,X1
      XA = (EXPL*FM/(BB*EXMI) - AK + 1.)/CC
          X10 = CC/(3.*AA)
          X10 = SQRT(X10)
      X0  = XA  -  X10**3 * AA/CC
      X1  = X10 +  X0
C=====
C     RE  = EXPL/EXMI
C     PRINT 900,EXMI,RE,AL,AK,BGMIN,AA,X0,XA,X1
  900 FORMAT(3X,'********* DEDXTP  - PARAMETER (04/05/86) **********'/
     #       3X,'        INPUT: EXMIN,AK,AA (BGM ADJUSTED)  '/
     #       3X,'  EXMI=',F10.5,'   RE=',F10.5,' ALFA=',F10.5/
     #       3X,'     K=',F10.5,'  BGM=',F10.5,'   AA=',F10.5/
     #       3X,'    X0=',F10.5,'   XA=',F10.5,'   X1=',F10.5/
     #       3X,'**************************************************'//)
C
      RETURN
      END
C   07/12/85 706032030  MEMBER NAME  ERDEDX   (S)           FORTRAN
C   07/12/85 609221253  MEMBER NAME  ERDEDX   (S)           FORTRAN
C     *****************************
      FUNCTION ERDEDX(E,SE,NRUN,NHITEX)
C     *****************************
C     CALCULATES SYSTEMATIC DE/DX-ERROR
C     KONSTANTS FOR DIFFERENT RUN-PERIODES AND EVENT-CLASSES ARE
C       ARE ADJUSTED TO MULTIHADRON DATA.
C
C     INPUT :  E      DEDX
C              SE     VARIANCE OF TRUNCATED MEAN E (5%-70%)
C              NRUN   RUN
C              NHITEX NUMBER OF DE/DX-HITS
C     OUTPUT:  ERDEDX DE/DX-ERROR
C-----
      DIMENSION ASYS(39)
      DATA ERRFAC/1.564/
CC-----
C     DATA ASMC / 0.320 /
C     DATA IPRINT/1/
      DATA ASYS/0.346,0.344,0.344,0.330,0.312,0.326,0.296,0.326,0.322,
     #    0.304,0.326,0.312,0.315,0.309,0.327,0.299,0.311,0.324,0.327,
     #    0.302,0.319,0.340,0.328,0.343,0.388,0.341,0.354,0.369,0.385,
     #    0.365,0.391,0.373,0.384,0.398,0.393,0.374,0.376,0.377,0.385/
C-----
C     IPRINT = IPRINT + 1
C     IF(IPRINT.EQ.1) PRINT 901
C901  FORMAT(' ########## ERDEDX:  03/06/1987  F11AMB.ANAL.L ')
CCC   IF(IPRINT.EQ.1) PRINT 900
C900  FORMAT(1X,'##### ERDEDX: FIXED DEDX-ERROR SE = E*0.32/SQRT(N)',
C    #    ' USED #####'/)
C-----
      ERDEDX = 0.
CHANGED:      IF(SE.LE.0. .OR. NHITEX.LE.0) GO TO 9999
      IF(NHITEX.LE.0) GO TO 9999
C-----                                                   GET RUN-PERIODE
      IPER = IPCALF(NRUN)
C-----
C     IF(IPRINT.EQ.1) PRINT 902,IPER,ASYS(IPER)
C902  FORMAT(' ########## ERDEDX: IPER =',I5,3X,' ASYS =',F7.3)
C-----
           XN = FLOAT(NHITEX)
         ERRSYS = ASYS(IPER)/SQRT(XN)
CHANGED:        STA  =  E * ASMC/SQRT(XN)
        STA  =  SE*ERRFAC
        SYS  =  E *ERRSYS
      ERDEDX = SQRT(STA*STA + SYS*SYS)
C
 9999 CONTINUE
      RETURN
      END
C   04/06/87 706040241  MEMBER NAME  CALEX    (S)           FORTRAN
C   04/06/87 706040235  MEMBER NAME  CADEDX   (S)           FORTRAN
C     *********************************
      FUNCTION CALEX(NR,PTOT0,C0,Q0,EX0)
C     *********************************
C ----------------------------------- LAST CHANGE: 21/02/86  K.AMBRUS
C     BHABHA - DE/DX - CALIBRATION - FUNCTION
C ---------------------------------------------------------------------
         DIMENSION AA(5,39)
         DIMENSION APPQ(39),APP1(39),APP2(39)
         DIMENSION AP2(39),AP4(39),AP5(39)
C     DATA IPRINT/ 1 /
C----- BHABHA - COS(THETA) - CORRECTION (03/06/87)
      DATA AA/ 1.0071,-0.052, 0.305,0.36,-0.84,
     2 0.9876,-0.063,0.437,1.59, 0.96,  0.9925,-0.050,0.451,1.27, 0.46,
     4 0.9896,-0.066,0.432,0.93, 0.07,  0.9810,-0.030,0.515,1.15, 0.31,
     6 0.9944,-0.059,0.257,0.42,-0.29,  0.9845, 0.008,0.420,0.66,-0.04,
     8 0.9856,-0.002,0.417,1.10, 0.70,  0.9878, 0.015,0.413,0.62,-0.12,
     * 0.9828, 0.021,0.391,0.61, 0.01,  0.9851, 0.036,0.416,0.99, 0.54,
     2 0.9845, 0.026,0.456,1.41, 1.03,  0.9855, 0.044,0.490,1.02, 0.21,
     4 0.9836, 0.020,0.474,0.87, 0.25,  0.9849, 0.008,0.492,1.07, 0.44,
     6 0.9837, 0.031,0.510,0.71,-0.25,  0.9823, 0.027,0.490,0.65,-0.31,
     8 0.9824,-0.040,0.262,0.68, 0.10,  0.9948,-0.025,0.347,0.44,-0.46,
     * 0.9974,-0.099,0.426,1.96, 1.71,  0.9934,-0.074,0.369,1.18, 0.56,
     2 0.9876,-0.072,0.477,0.97, 0.08,  0.9794,-0.031,0.539,0.99,-0.11,
     4 0.9722, 0.004,0.628,1.18, 0.39,  0.9767,-0.025,0.468,0.96, 0.25,
     6 0.9745,-0.061,0.580,1.50, 0.70,  0.9896,-0.044,0.283,0.34,-0.63,
     8 0.9465,-0.105,0.577,2.05, 1.26,  0.9527,-0.035,0.425,0.80, 0.07,
     * 0.9331,-0.003,0.565,1.71, 1.27,  0.9432,-0.081,0.756,2.36, 1.53,
     2 0.9537,-0.085,0.607,1.80, 1.02,  0.9543,-0.108,0.704,2.21, 1.24,
     3 0.9672,-0.079,0.463,1.64, 1.16,  0.9563,-0.015,0.533,1.18, 0.38,
     4 0.9589,-0.011,0.480,0.77,-0.15,  0.9589,-0.030,0.503,1.39, 0.75,
     8 0.9585,-0.051,0.537,1.41, 0.61,  0.9611,-0.038,0.385,0.97, 0.31/
C----- CHARGE- MOMENTUM - CORRECTION (03/06/87)
      DATA APPQ/ 0.00410,  0.00535,  0.00517,  0.00319,
     * 0.00561,  0.00393,  0.00364,  0.00327,  0.00369,
     1 0.00200,  0.00284,  0.00339,  0.00389,  0.00554,
     1 0.00387,  0.00291,  0.00407,  0.00638,  0.00599,
     2 0.00320,  0.00501,  0.00638,  0.00539,  0.00510,
     2 0.00597,  0.00937,  0.00134,  0.00836,  0.00781,
     3 0.00918,  0.00554,  0.00865,  0.00792,  0.01319,
     3 0.01216,  0.00773,  0.00787,  0.01058,  0.01143/
C-
      DATA APP1/-0.00082, -0.00509, -0.00552,  0.00127,
     * 0.00384,  0.00270,  0.00227,  0.00062,  0.00327,
     1 0.00020,  0.00267,  0.00267,  0.00316,  0.00317,
     1 0.00261,  0.00246,  0.00143,  0.00228,  0.00285,
     2 0.00426,  0.00534,  0.00645,  0.00515,  0.00366,
     2 0.00211,  0.00613, -0.00281,  0.00515,  0.00607,
     3 0.00387,  0.00319,  0.00425,  0.00579,  0.00706,
     3 0.00831,  0.00711,  0.00779,  0.00703,  0.00827/
C-
      DATA APP2/  0.000033, 0.000158, 0.000396,-0.000192,
     * -0.000240,-0.000201,-0.000115, 0.000075,-0.000133,
     1  0.000024,-0.000042,-0.000148,-0.000103,-0.000237,
     1 -0.000128,-0.000195,-0.000173,-0.000108,-0.000167,
     2 -0.000236,-0.000278,-0.000391,-0.000322,-0.000087,
     2 -0.000042,-0.000282, 0.000259,-0.000274,-0.000323,
     3 -0.000218,-0.000142,-0.000049,-0.000333,-0.000418,
     3 -0.000389,-0.000361,-0.000451,-0.000404,-0.000466/
C----- SATURATION (03/06/87)
      DATA AP1/ 8.11/
C-
      DATA AP2/ .138, .114, .118, .117, .115, .126, .114, .093, .104,
     1    .115, .110, .118, .134, .102, .103, .108, .099, .105, .095,
     2    .087, .074, .084, .092, .078, .061, .073, .056, .077, .071,
     3    .088, .089, .086, .055, .031, .058, .032, .034, .026, .052/
C-
      DATA AP3/ 55.0/
C-
      DATA AP4/4.765,5.691,6.139,1.802,1.146,1.450,1.947,2.581,2.212,
     1   2.336,2.935,3.665,3.303,1.730,2.045,1.482,1.972,2.742,2.220,
     2   2.493,2.185,1.481,1.149,1.000,1.134,1.140,1.116,0.914,1.080,
     3   1.048,0.711,1.146,1.251,4.816,3.591,3.754,4.758,4.865,3.696/
C-
      DATA AP5/ 33*0.961,6*0.890 /
C===== RUN - PERIODE
      IP = IPCALF(NR)
C     IPRINT = IPRINT + 1
C     IF(IPRINT.EQ.1) PRINT 900
C900  FORMAT(' ########## CALEX:  03/06/1987 ')
C ---------------------------------------------------------------------
      CALEX = 1.
      IF(NR.LE.0) GO TO 9999
       PTOT = PTOT0
       C = ABS(C0)
       C1= C
       IF(C.GT.1. .OR. PTOT.LE.1.E-10 .OR. EX0.LE.0.01)   GO TO 9999
       IF(C1.GT.0.99) C1 = 0.99
       IF(C.GT.0.83) C = 0.83
       IF(PTOT.LT.0.04) PTOT = 0.04
       CEX = 1.
C----- BHABHA - COS(THETA) - DEPENDANCE
         X = C - 0.6
        Z = 1.+AA(2,IP)*X+AA(3,IP)*X*X+AA(4,IP)*X**3+AA(5,IP)*X**4
        Z = Z*AA(1,IP)
      CEX =CEX / Z
C----- Q - DEPENDANCE (ONLY POS. PARTICLES)
         P = 0.
         IF(Q0.GT.0.) P = APPQ(IP)
      CEX = CEX / ( 1. + P/PTOT )
C----- P - CALIBRATION FOR LOW MOMENTA (ALL. PARTICLES)
      CEX = CEX * (1. + APP1(IP)/PTOT + APP2(IP)/PTOT**2)
C----- SATURATION
         EX = EX0*CEX
       CEX = CEX*(1. + AP2(IP)*(SQRT(EX)-SQRT(10.))*EXP(-AP1*C))
         EX = EX0*CEX
       CEX=CEX * (  1.
     #         + AP4(IP) * (EXP(0.01*AP5(IP)*EX)-1.)
     #         * EXP(-AP3/EX) )
       CEX=CEX / (  1.
     #         + AP4(IP) * (0.1*EXP(AP5(IP))-1.)
     #         * EXP(-AP3*0.1) )
C----- LN(D) - DEPENDANCE (ASSUMING BETA = Q = 1)
         EX = EX0*CEX
         D  = 1./SQRT(1.-C1*C1)
       CEX = CEX*(1. - 0.417*ALOG(D)/EX)
C-----
      CALEX = CEX
C-----
 9999 CONTINUE
C     IF(IPRINT.LE.1) PRINT 901,IP,(AA(K,IP),K=1,5)
C    #   ,APPQ(IP),APP1(IP),APP2(IP),AP1,AP2(IP),AP3,AP4(IP)
C    #   ,AP5(IP)
C 901 FORMAT(3X,'**********  CALEX  - PARAMETER (03/06/87) ********'/
C    #       3X,'                 PERIODE  ',I3/
C    #       3X,'  AA =',5F10.5/
C    #       3X,'  PQ =',F10.5,' PP1 =',F10.5,' PP2 =',F10.5/
C    #       3X,'  P1 =',F10.5,'  P2 =',F10.5/
C    #       3X,'  P3 =',F10.5,'  P4 =',F10.5/
C    #       3X,'  P5 =',F10.5,'  P6 =',F10.5/
C    #       3X,'**************************************************'//)
C     IF(IPRINT.LE.1) PRINT 902,EX,CEX
      RETURN
      END

C   01/11/84 411011623  MEMBER NAME  TRIG2    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRIG2
C-----------------------------------------------------------------------
C
C   AUTHOR:     J. OLSSON       ?    :  DISPLAYS "TRIG(2)" RESULTS
C
C   LAST MOD:   J.H. C.B.    1/11/84 :  ROTNK CHANGE UPDATE
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            DISPLAYS "TRIG(2)" RESULTS.
C
#include "cdata.for"
#include "cgeo1.for"
#include "cjdrch.for"
#include "cgraph.for"
C
      COMMON / CJTRIG / PI, TWOPI
      COMMON / CJCELL / NCELL(3), NWIRES(3)
C
      DIMENSION  RAD(5),IPOINT(5),HCHAR(5),HWORD(2)
C
      EQUIVALENCE (IWORD,HWORD(1))
C
      DATA  IPOINT / 2,2,1,3,4 /
      DATA  HCHAR / 'O','O','O','A','F' /
      DATA  ICALL / 0 /
C
C------------------  C O D E  ------------------------------------------
C
      IF( ICALL .NE. 0 ) GO TO 10
      ICALL = 1
      RAD(1) = (FSENSW(2)+FSENSW(1)+(NWIRES(1)-1)*RINCR(1))/2.
      RAD(2) = (FSENSW(3)+FSENSW(2)+(NWIRES(2)-1)*RINCR(2))/2.
      GAP    = FSENSW(3)-FSENSW(2)-(NWIRES(2)-1)*RINCR(2)
      RAD(3) = FSENSW(3)+(NWIRES(3)-1)*RINCR(3)+GAP/2.
C
      SH1      = GAP - 35.0
      ROTNKP   = ROTNK + DROTNK
      RAD(4)   = ROTNKP +     (RTOF - ROTNKP)/4.0
      RAD(5)   = ROTNKP + 2.0*(RTOF - ROTNKP)/3.0
      HWORD(1) = 0
   10 CONTINUE
      IPJ=IDATA(IBLN('TRIG'))
      IF(IPJ.LT.1) RETURN
      IBN=IDATA(IPJ-2)
      IF(IBN.EQ.2) GO TO 1
      IPJ=IDATA(IPJ-1)
      IF(IPJ.LT.1) RETURN
      IBN=IDATA(IPJ-2)
      IF(IBN.NE.2) RETURN
    1 CONTINUE
      IWO=2*IPJ-2
      DO 2 IREG=1,6
      PHI0=(IREG-1)*TWOPI/6.
      IWO=IWO+4
      DO 3 IRAD=1,5
      IRING=IRAD
      IF(IRING.GT.3) IRING=3
      HWORD(2)=HDATA(IWO+IPOINT(IRAD))
      IF(IRAD.EQ.1) IWORD=SHFTR(IWORD,8)
      R=RAD(IRAD)
      HWRIT=HCHAR(IRAD)
      NN=NCELL(IRING)/3
      DPHI=TWOPI/(6*NN)
      MASK=1
      DO 4 IPHI=1,NN
      PHI=PHI0+IPHI*DPHI
      ITEST=LAND(IWORD,MASK)
      MASK=2*MASK
      IF(ITEST.EQ.0) GO TO 4
      X=-R*COS(PHI)
      Y= R*SIN(PHI)
      PHWT=PI/2.-PHI
      IF(PHWT.LT.0.) PHWT=PHWT+TWOPI
      DX0=-SH1/3.
      DY0=-SH1/2.
      DX=COS(PHWT)*DX0-SIN(PHWT)*DY0
      DY=SIN(PHWT)*DY0+COS(PHWT)*DX0
      X=X+DX
      Y=Y+DY
      ICNT=1
      CALL HEMSYM(X,Y,SH1,HWRIT,ICNT,PHWT)
    4 CONTINUE
    3 CONTINUE
    2 CONTINUE
      RETURN
      END

C   17/07/85 807251717  MEMBER NAME  EFMASS   (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EFMASS
C-----------------------------------------------------------------------
C
C   AUTHOR:   R. EICHLER      ?    :  COMPUTES EFFECTIVE MASSES
C
C        MOD: J. OLSSON   22/02/83 :  HCONV PRINT,BRANCH
C        MOD: J. OLSSON    4/03/83 :  CONVERSION CORRECTION
C        MOD: J. OLSSON    4/05/83 :  INTERFACE /CVX/
C        MOD: C. BOWDERY  17/07/85 :  SMALL CHANGES
C        MOD: J. OLSSON   04/12/85 :  /CJJONI/ --> /CJIONI/  (IN JADEBD)
C        MOD: J. HAGEMANN 14/07/86 :  FOR NEW VERTEX ROUTINES
C   LAST MOD: J.OLSSON    20/05/87 :  IMPLICIT INTEGER*2 IN GETGAM
C
C        COMPUTES EFFECTIVE MASS OF CHARGED PARTICLES AND OR PHOTONS
C        INPUT GIVEN FROM SCREEN : TYPE AND TRACK NUMBER.
C        BOS NUMBER OF PATR BANK CAN BE ENTERED AS TRAILING NUMBER IN
C        COMMAND 'MASS'
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON / CJIONI / POTBEA, ZAROBE
     *                 ,POTTRI, ZAROTR
     *                 ,POTIVE, ZAROIV
     *                 ,POTRH0, ZAROR0
      COMMON / CVX    / NNPATR
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "mvertex0.for"
#include "mvertex1.for"
#include "mvertex2.for"
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      DIMENSION PP(6),IPOIN(20),HTEXT(5,7),RLIMS(2,6)
      DIMENSION HNNN(20),HNTP(20),PAR(20,4),PSAM(4),XMAS(20),ARMAS(6)
C
      DATA ARMAS /0.0,.000511,.105659,.139567,.49367,.93828/
      DATA HTEXT /'  ','  ','  ','  ','  ','BE','AM','-P','IP','E ',
     $            'BP','-Z','AE','HL','ER','ID','-T','AN','K ','  ',
     $            'RO','HA','CE','LL',' 1','RO','HA','CE','LL',' 2',
     $            'RO','HA','CE','LL',' 3'/
      DATA RLIMS /115.,127.,127.,167.,167.,174.,174.,195.,370.,410.,
     $            580.,625./
C
C-----------------------------------------------------------------------
C
      XVT=0.0
      YVT=0.0
      ZVT=0.0
      IH=IDATA(IBLN('HEAD'))
      IF(NNPATR.LE.0) GO TO 3801
      NBK = NNPATR
      GO TO 2225
3801  NBK = ACMD
      IF(NBK.LE.0) GO TO 2222
2225  CALL CLOC(IPO,'PATR',NBK)
      IF(IPO.NE.0) GO TO 2224
      CALL DIAGIN('NOT EXISTING,PATR BANK NR',1,NBK,IPO,IPO,IPO,IPO,IPO)
2222  IPO=IDATA(IBLN('PATR'))
      IF(IPO.NE.0) GO TO 2224
      CALL TRMOUT(80,'PATR bank does not exist^')
      RETURN
2224  IPLGCL = IDATA(IBLN('LGCL'))
      IF(IPLGCL.NE.0) GO TO 2223
      CALL TRMOUT(80,'LGCL bank does not exist^')
      RETURN
2223  IPALGN=IDATA(IBLN('ALGN'))
      IF(IDATA(IPLGCL+21).NE.2) CALL LGCDIR(IPO,IPALGN,IPLGCL)
      NWPCL = IDATA(IPLGCL+25)
      IPOG = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      NCLST = IDATA(IPLGCL+7)
      LO = IDATA(IPO+1)
      NTR = IDATA(IPO+2)
      LTR = IDATA(IPO+3)
      NN = 0
      JJ=0
      CALL TRMOUT(80,'  Part.Types:  -2 LG-clst,  -1 Gam,  1 Electron,
     $2 Mu,  3 Pi,  4 K,  5 P^')
1000  CALL TRMOUT(80,'               Enter Type & Track Number; Just RET
     $URN to finish input^')
      CALL FYRINT(ITYP,ITR,ID1,ID2)
      IF(ITYP.EQ.0) GO TO 1003
      IF(ITYP.GT.0) GO TO 1001
      IF(ITYP.LE.-3) GO TO 1011
C  PHOTON PART
      IF(ITR.GT.0.AND.ITR.LE.NCLST) GO TO 523
      GO TO 1006
523   IP = IPOG
      IGAM = 0
      DO 522  IGM = 1,NCLST
      IP = IP + NWPCL
      IF(ITYP .EQ. -2) GOTO 501
      IF(IDATA(IP+8).NE.0) GO TO 522
501   IGAM = IGAM + 1
      IF(IGAM.EQ.ITR) GO TO 524
522   CONTINUE
      GO TO 1006
524   IPOIN(NN+1)=IP
      JJ=JJ+1
      GO TO 1015
1011  CALL TRMOUT(80,'          Non-existing particle type. Try again^')
      GO TO 1000
1001  IF(ITYP.GT.5) GO TO 1011
      IF(ITR.GT.0.AND.ITR.LE.NTR) GO TO 1002
1006  CALL TRMOUT(80,'                 Non-existing track. Try again^')
      GO TO 1000
1002  IP = IPO + LO - LTR
      DO 1004  JTR = 1,NTR
      IP = IP + LTR
      IF(IDATA(IP+1).EQ.ITR) GO TO 1005
1004  CONTINUE
      GO TO 1006
1005  CALL MOMENT(IP,PX,PY,PZ,PT,PTOT,FI,THE)
1015  NN = NN + 1
      HNNN(NN) = ITR
      HNTP(NN) = ITYP
      ITYP = ITYP + 1
      IF(ITYP.LE.0) ITYP = 1
      XMAS(NN) = ARMAS(ITYP)
      PAR(NN,1) = PX
      PAR(NN,2) = PY
      PAR(NN,3) = PZ
      PAR(NN,4) = SQRT(PTOT*PTOT + XMAS(NN)*XMAS(NN))
      IF(ITYP.EQ.1) GO TO 4422
CORRECT HERE FOR ENERGY LOSS IN PIPE AND TANK
      PP(1) = PAR(NN,1)
      PP(2) = PAR(NN,2)
      PP(3) = PAR(NN,3)
      PP(4) = PAR(NN,4)
      PP(6) = SQRT(PP(1)**2+PP(2)**2+PP(3)**2)
      PP(5) = XMAS(NN)
      SINT = 1./SIN(THE)
C PASS THROUGH ROHACELL-0, INNER TANK, BEAMPIPECOUNTERS,BEAM PIPE
      STRAC = DR0ROH*SINT
      POT = POTRH0
      ZARO = ZAROR0
      ILV = 1
      CALL JEGAIN(PP,STRAC,POT,ZARO,&999)
      STRAC = DRITNK*SINT
      POT = POTIVE
      ZARO = ZAROIV
      ILV = 2
      CALL JEGAIN(PP,STRAC,POT,ZARO,&999)
      STRAC = DRBPC*SINT
      POT = POTTRI
      ZARO = ZAROTR
      ILV = 3
      CALL JEGAIN(PP,STRAC,POT,ZARO,&999)
      STRAC = DRPIP*SINT
      POT = POTBEA
      ZARO = ZAROBE
      ILV = 4
      CALL JEGAIN(PP,STRAC,POT,ZARO,&999)
      PAR(NN,1) = PP(1)
      PAR(NN,2) = PP(2)
      PAR(NN,3) = PP(3)
      PAR(NN,4) = PP(4)
      GO TO 4422
999   WRITE(6,867) ILV
867   FORMAT(' ERROR RETURN from JEGAIN at LEVEL ',I4)
C
4422  IF(NN.LT.20) GO TO 1000
1003  IF(NN.LE.1) RETURN
C IF LESS THEN 2 CHARGED PARTICLES DON'T DO VERTEX FIT
      IF(NN-JJ .GE. 2) GOTO 300
      CALL TRMOUT(80,'                              Enter vertex coordin
     1ates in mm (Integers!); ^')
      CALL TRMOUT(80,'                              Just RETURN for vert
     1ex = 0,0,0^')
      CALL FYRINT(IXVT,IYVT,IZVT,IDUM1)
      XVT=IXVT
      YVT=IYVT
      ZVT=IZVT
      CALL CLRCON
      GOTO 1510
C*************************
C   PERFORM VERTEX FIT   *
C*************************
 300  CALL CLRCON
      HCONV = 0
      CALL VTXINI
      CALL VTXPRE(IH,IPO)
      N=0
      J=0
      DO 320 M=1,NT
      DO 315 MM=1,NN
      IF(HNTP(MM) .LE. 0) GOTO 315
      IF(M .EQ. HNNN(MM)) GOTO 317
 315  CONTINUE
      IT(J+1)=0
      GOTO 320
 317  CONTINUE
      IF(IT(J+1) .EQ. 0) GOTO 321
      N=N+1
      IT(J+1)=2
      GO TO 320
321   WRITE(6,322) M
322   FORMAT(' Track ',I3,'  REJECTED for fit, by Vertex Program')
 320  J=J+ITDLEN
      NV=1
      IF(N+JJ .NE. NN) WRITE(JUSCRN,5000) N
5000  FORMAT(' Only',I4,' tracks accepted by Vertex Program')
      IF( N .NE. 2) GOTO 350
      IF(HNTP(1) .NE. 1 .OR. HNTP(2) .NE. 1) GOTO 350
      NV=0
      CALL VTXEE
      HCONV = 1
      IF(NV.NE.1) GO TO 361
      IF(IV(1).NE.4) GO TO 361
      GO TO 360
 361  HCONV = 2
      NV = 1
 350  CALL VERTEX
 360  CALL VTXAFT
C*****************************
C  GET RESULT OF VERTEX FIT  *
C*****************************
      R=V(2)**2+V(3)**2
      RL=SQRT(R+V(4)**2)
      R=SQRT(R)
      XVT=V(2)
      YVT=V(3)
      ZVT=V(4)
      IF(HCONV.EQ.2) WRITE(6,1379)
1379  FORMAT('  ***** Photon Conversion Fit FAILED, Standard Fit used **
     $*** ')
      IF(HCONV.NE.1) WRITE(6,1291)
1291  FORMAT('           ********* Vertex Fit Parameters ********* ')
      IF(HCONV.EQ.1) WRITE(6,1281)
1281  FORMAT(' ###   Photon Conversion:  Vertex Fit Parameters   ### ')
      NDF = 2*IV(8) - 3
      WRITE(6,1292) V(9),NDF
1292  FORMAT('  ChiSq / Ndf ',F6.2,' /',I2)
      WRITE(6,1293) IV(1),IV(8),NV
1293  FORMAT(' Quality Flag ',I3,'   Nr of used Tracks ',I3,'  Nr of Ver
     $tices found ',I3)
      WRITE(6,1294)
1294  FORMAT(' Vertex Coordinates         X                 Y
     $      Z')
      WRITE(6,1295) XVT,V(5),YVT,V(6),ZVT,V(7)
1295  FORMAT(20X,3(F6.1,' +- ',F4.1,4X))
      IRAD = 1
      DO 1296  KL = 1,6
      IF(R.GE.RLIMS(1,KL).AND.R.LT.RLIMS(2,KL)) IRAD = KL + 1
1296  CONTINUE
      DO 1297  KJ = 1,5
1297  HMW(KJ) = HTEXT(KJ,IRAD)
      WRITE(6,1298) R,(HMW(KL),KL=1,5)
1298  FORMAT('  Radius in RFI :',E12.4,10X,5A2)
      WRITE(6,1299) RL
1299  FORMAT('  Total Length :',E12.4)
      DO 1500 I=1,NN
      IF(HNTP(I) .LE. 0) GOTO 1500
      J=HNNN(I)
      INDEX=ITDLEN*(J-1)
      IF(IT(INDEX+1) .EQ. 0) GOTO 1500
      PH=T(3+INDEX)
      TH=1.5708-T(4+INDEX)
      XC=COS(PH)*SIN(TH)
      YC=SIN(PH)*SIN(TH)
      ZC=COS(TH)
      PTOT=PAR(I,1)**2+PAR(I,2)**2+PAR(I,3)**2
      PTOT=SQRT(PTOT)
      PAR(I,1)=XC*PTOT
      PAR(I,2)=YC*PTOT
      PAR(I,3)=ZC*PTOT
1500  CONTINUE
C -----FIND PHOTONS,RECALCULATE DIRECTION FROM NEW FOUND VERTEX
1510  DO 1600 I=1,NN
      IF(HNTP(I) .GE. 0) GOTO 1600
      IP=IPOIN(I)
      CALL GETGAM(IP,PX,PY,PZ,PTOT,XVT,YVT,ZVT)
      PAR(I,1)=PX
      PAR(I,2)=PY
      PAR(I,3)=PZ
      PAR(I,4)=PTOT
1600  CONTINUE
      PTOTSM = 0.
      PTOTM = 0.
      FACT = -1.
      DO 2000  J = 1,4
      IF(J.EQ.4) FACT = 1.
      PSAM(J) = 0.
      DO 2001  I = 1,NN
2001  PSAM(J) = PSAM(J) + PAR(I,J)
      IF(J.LT.4) PTOTM = PTOTM + PSAM(J)*PSAM(J)
2000  PTOTSM = PTOTSM + PSAM(J)*PSAM(J)*FACT
      PTOTSM = AMAX1(PTOTSM,1.E-08)
      PTOTM = AMAX1(PTOTM,1.E-08)
      XMASS = SQRT(PTOTSM)
      PTOTM = SQRT(PTOTM)
      IF(NN.NE.2) GO TO 2591
      COSOP = 0.
      PARB1 = 0.
      PARB2 = 0.
      DO 2592  IJN = 1,3
      PARB1 = PARB1+PAR(1,IJN)**2
      PARB2 = PARB2+PAR(2,IJN)**2
      COSOP = COSOP + PAR(1,IJN)*PAR(2,IJN)
2592  CONTINUE
      COSOP = COSOP/(SQRT(PARB1)*SQRT(PARB2))
2591  P1=0.
      P2=0.
      P3=0.
      DO 2005 I=1,NN
      P1=P1+PAR(I,1)
      P2=P2+PAR(I,2)
      P3=P3+PAR(I,3)
2005  CONTINUE
      AA=XVT*XVT+YVT*YVT+ZVT*ZVT
      PX=P1*P1+P2*P2+P3*P3
      AP=XVT*P1+YVT*P2+ZVT*P3
      XX=AA-AP*AP/PX
      IF(XX .GT. 0.)XX=SQRT(XX)
      WRITE(6,1391) XMASS
1391  FORMAT('                  Mass ------> ',E12.4)
      FI = ATAN2(PSAM(2),PSAM(1))
      COSTHE = PSAM(3)/PTOTM
      WRITE(6,1393) PTOTM,FI,COSTHE
1393  FORMAT(' Momentum ',E12.4,'    FI and COS(Theta)  ',2E12.4)
      WRITE(6,1392) PSAM
1392  FORMAT(' 4-Vector ',4E12.4)
      IF(NN.EQ.2) WRITE(6,1397) COSOP
1397  FORMAT(' COSINE Opening Angle ',F9.5)
      WRITE(JUSCRN,2002) XX
2002  FORMAT('     Dmin = ',E12.4)
      WRITE(JUSCRN,2003) ((HNNN(I),HNTP(I)),I=1,NN)
2003  FORMAT(' Particles and Types : ',8(I2,1X,I2,2X))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE GETGAM(IP,PX,PY,PZ,PTOT,XVT,YVT,ZVT)
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX, DZVRTX
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
      ZTEMP=ZVRTX
      ZVRTX=ZVT
      JEG=1
      JPART=IDATA(IP+1)
      EGAM=ADATA(IP+2)
      EMEV=EGAM*1000.
      IF(JPART) 10,20,10
C***-------BARREL PHOTONS-----------
  20  ZAV=ADATA(IP+5)
      CALL LGAVDP(ZAV,EMEV,JEG,DEP)
      ZZ=ZAV-ZVT
      X =(RADIUS(3)+DEP)*COS(ADATA(IP+4))-XVT
      Y =(RADIUS(3)+DEP)*SIN(ADATA(IP+4))-YVT
      TR=SQRT(X*X+Y*Y+ZZ*ZZ)
      PX=X/TR*EGAM
      PY=Y/TR*EGAM
      PZ=ZZ/TR*EGAM
      PTOT=EGAM
      GOTO 30
C****------ENDCAP PHOTONS--------
  10  ZAV=ZECAP(JPART+2)
      CALL LGAVDP(ZAV,EMEV,JEG,DEP)
      ZZ=ZAV-ZVT+DEP*FLOAT(JPART)
      X =ADATA(IP+4)-XVT
      Y =ADATA(IP+5)-YVT
      TR=SQRT(X*X+Y*Y+ZZ*ZZ)
      PX=X/TR*EGAM
      PY=Y/TR*EGAM
      PZ=ZZ/TR*EGAM
      PTOT=EGAM
  30  CONTINUE
      ZVRTX=ZTEMP
      RETURN
      END

C   18/12/87 807262019  MEMBER NAME  MUCON    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUCON
C-----------------------------------------------------------------------
C
C LAST CHANGE 20.03 26/07/88 CHRIS BOWDERY- PRINT MESSAGES ONLY ONCE
C      CHANGE 23.45 17/12/87 CHRIS BOWDERY- CHANGES IF NOT MUON MC DATA
C      CHANGE 20.30 19/02/84 CHRIS BOWDERY- REMOVE OLDSCR.NOW IN UCOPY
C      CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C      CHANGE 09.50 26/09/79 JOHN ALLISON.
C      CHANGE 20.16 21/09/79 HARRISON PROSPER.
C
C-----------------------------------------------------------------------
C
C      MUCON TRANSFERS ALL BOS BANKS INTO COMMON /CALIBR/
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  OLD, FIRST, FIRST1, FIRST2
C
C                            COMMONS.
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C
C                            DECLARATIONS, INITIALISATIONS, ETC.
C
      DIMENSION HUNI1(82)
C
      DATA HUNI1/3,1,1,1,1,1,1,1,1,1,
     *           1,1,1,3,2,2,2,2,2,2,
     *           2,2,2,2,2,2,3,3,3,3,
     *           3,3,3,3,3,3,3,3,4,4,
     *           5,5,4,4,5,5,4,4,5,5,
     *           4,4,5,5,4,4,5,5,4,4,
     *           5,5,4,4,5,5,4,5,4,5,
     *           4,5,4,5,4,5,4,5,4,5,
     *           4,5                  /
C
      DATA  FIRST, FIRST1, FIRST2 / .TRUE., .TRUE., .TRUE. /
C
C------------------  C O D E  ------------------------------------------
C
      IF( .NOT. FIRST ) GO TO 1
        CALL MUMESS('MUCON ',0,'CALLED TO COPY MUON CALIBRATION.^')
        CALL MUMESS('MUCON ',0,'WARNING: MESSAGE IS NOT REPEATED!^')
        FIRST = .FALSE.
C
C                            CHECK FOR 'MFFI' - SHOULD  BE  THERE  FOR
C                            OLD AND NEW.
C
 1    CALL CLOC(IP,'MFFI',2)
      IF( IP .LE. 0 ) GO TO 98
      CALL UCOPY(IDATA(IP+1),HMFFIX,IDATA(IP))
C
C                            CHECK FOR NEW BANKS.
C
      CALL CLOC(IP,'MUCD',0)
      IF( IP .GT. 0 ) GO TO 2
C                            OLD (PRE MAY 1979).
      OLD    = .TRUE.
      NVERSN = 1
      CALL UCOPY( 'OLD (PRE MAY 1979) MONTE CARLO CALIBRATION DATA.^
     +      ',DESCRP,15)
      CALL VZERO(HOVALL,3)
      GO TO 3
C                            NEW.
 2    OLD = .FALSE.
      CALL UCOPY(IDATA(IP+1),NVERSN,IDATA(IP))
      CALL CLOC(IP,'MUOV',0)
      CALL UCOPY(IDATA(IP+1),HOVALL,IDATA(IP))
C
C                            IF BANKS ARE EMPTY, TAKE NO FURTHER ACTION
C
      IF( NVERSN .LE. 0 ) GO TO 98
C
C                            FIND OTHER BANKS, ADDING NEW ARRAYS WHERE
C                            NECESSARY.
C
 3    CALL CLOC(IP,'MCFI',3)
      CALL UCOPY(IDATA(IP+1),HMCFIX,IDATA(IP))
      IF(OLD)CALL UCOPY(HUNI1,HUNIT,41)
C
      CALL CLOC(IP,'MFSU',4)
      CALL UCOPY(IDATA(IP+1),HMFSUR,IDATA(IP))
C
      CALL CLOC(IP,'MCSU',5)
      CALL UCOPY(IDATA(IP+1),HMCSUR,IDATA(IP))
C
      CALL CLOC(IP,'MCEL',6)
      CALL UCOPY(IDATA(IP+1),HMCELE,IDATA(IP))
      IF( .NOT. OLD ) GO TO 4
      DO  8  I = 1,NCHAMS
      HVDRFT(I) = HVDR
 8    CONTINUE
 4    CONTINUE
C
      CALL CLOC(IP,'MCST',7)
      CALL UCOPY(IDATA(IP+1),HMCSTA,IDATA(IP))
      IF(OLD)CALL VZERO(HMCSTA,IDATA(IP))
C
      CALL CLOC(IP,'MUFI',8)
      CALL UCOPY(IDATA(IP+1),HFILDA,IDATA(IP))
C
      CALL CLOC(IP,'MUYO',9)
      CALL UCOPY(IDATA(IP+1),HYKNMI,IDATA(IP))
C
      CALL CLOC(IP,'MUEN',10)
      CALL UCOPY(IDATA(IP+1),IZEII,IDATA(IP))
C
C                            PRINT OUT CALIBRATION DESCRIPTION ONCE
C
      IF( .NOT. FIRST2 ) RETURN
        CALL MUMESS('MUCON ',NVERSN,DESCRP)
        CALL MUMESS('MUCON ',0,'WARNING: MESSAGE IS NOT REPEATED!^')
        FIRST2 = .FALSE.
C
      RETURN
C
C                            NO MUON INFORMATION IN THE BANKS.
C
 98   IF( .NOT. FIRST1 ) RETURN
        CALL MUMESS('MUCON ',0,'MUON CALIB. DATA BANKS NOT PRESENT.^')
        CALL MUMESS('MUCON ',0,'WARNING: MESSAGE IS NOT REPEATED!^')
        FIRST1 = .FALSE.
C
      RETURN
      END

C   10/09/79 102191201  MEMBER NAME  PCCYCP   (PATRECSR)    FORTRAN
      SUBROUTINE PCCYCP
      IMPLICIT INTEGER*2(H)
C
C
C----------------------------------------------------------------------
C
C         --------------  SUBROUTINE PCCYCP  -----------------
C         --- G.F.PEARCE .. LAST UPDATE : 1200 ON 10/09/79 ---
C
C   SUBROUTINE TO DUMP THE PATTERN RECOGNITION COMMON /CCYCP/
C
C  CONTENTS OF /CCYCP/
C  -------------------
C
C  HPTSEC(I)   ..  POINTER TO FIRST I*2 WORD OF DATA FOR THE FIRST HIT
C              ..  OF CELL I IN THE /BCS/ COMMON.
C
C----------------------------------------------------------------------
C
C
#include "ccycp.for"
      PRINT11
 11   FORMAT(
     # 1X,47('-')/
     # ' DUMP OF PATTERN RECOGNITION POINTER ARRAY HPTSEC'/
     # 1X,47('-'))
      PRINT12,(HPTSEC(I),I=1,98)
 12   FORMAT( 4(1X,20I6/),1X,18I6 )
      RETURN
      END

C   06/03/80 205101418  MEMBER NAME  TFPAIR   (S)           FORTRAN
      SUBROUTINE TFPAIR(MCOSM)
C
      IMPLICIT INTEGER*2 (H)
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42),ZTOF(42)
      COMMON/TOFPAR/MPAIR,LTOF(2,10)
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      DIMENSION IHIT(42)
C
      DATA IBUG/0/
      IF(IENTRY.NE.0)  GOTO  19
      IENTRY = 1
      ZB = 10050
      ZA = 10150
      ZA = 10850
      ZB = 10950
      CALL HBOOK1(300,20HHITMAP             $,100,0.,100.)
      CALL HBOOK2(301,20HT1 T2              $, 40,-20.,20., 40,-20.,20.)
      CALL HBOOK1(302,20HTDT                $,100,-10.,15.)
      CALL HBOOK2(303,20HT VS TOFCOUNTER    $,100,-50.,50.,42,0.,42.)
      CALL HBOOK2(304,20HDTVS TOFCOUNTER    $,100,-25.,25.,22,0.,22.)
      CALL HBOOK2(305,20HNRUN TAUM          $,100,ZA,ZB,40,-20.,20.)
      CALL HBPROY(305)
      CALL HBOOK2(311,' Z1 Z2   $',100,-3000.,3000.,100,-3000.,3000.)
      CALL HBOOK1(312,20H DZ                $,100,-3000.,3000.)
   19 CONTINUE
C
      IBUG = IBUG + 1
      MPAIR = 0
      MCOSM = 0
      CALL SETSL(LTOF,0,20*4,0.)
      IF(NTOF.LT.2)  RETURN
C
C  FILL LATCH ARRAY IHIT
      NHIT = 0
      DO   30   I=1,42
      IF(HTOF(I).LE.0)  GOTO  30
      NHIT = NHIT + 1
      IHIT(NHIT) = I
      CALL HF1(300,FLOAT(I),1.)
   30 CONTINUE
      NH = NHIT
      IF(NHIT.GT.10) NH = 10
      CALL HF1(300,FLOAT(NH)+50.,1.)
C
      IBUG = IBUG + 1
      IF(IBUG.LE.10) PRINT 500,NHIT,NTOF,(IHIT(L),L=1,NHIT)
  500 FORMAT(' TFPAIT- NTOF ',11I5)
C
C FIND COPLANAR PAIRS OF TOF COUNTERS
C
      NA = NHIT-1
      DO   1   I=1,NA
      ITOF1 = IHIT(I)
      NB = I+1
      DO   2   J=NB,NHIT
      ITOF2 = IHIT(J)
      IDTOF = IABS(ITOF2-ITOF1)
      IF(IABS(IDTOF-21).GT.3)  GOTO  2
      IF(IBUG.LE.10) PRINT 500,I,J,ITOF1,ITOF2,IDTOF
      MPAIR = MPAIR + 1
      IF(MPAIR.GT.10)  GOTO  2
      LTOF(1,MPAIR) = ITOF1
      LTOF(2,MPAIR) = ITOF2
C
C   CHECK TOF DIFFERENCE
      T1 = TTOF(ITOF1)
      T2 = TTOF(ITOF2)
      IF(IBUG.LE.10) PRINT 501,ITOF1,ITOF2,T1,T2
  501 FORMAT(' TFPAIR- T1,T2',2I3,2F10.2)
C     IF(T1.LE.-20..OR.T2.LE.-20.)  GOTO  2
      DT = T2-T1
      IF(DT.GT.4.)  MCOSM = MCOSM + 1
      IF(IBUG.LE.10) PRINT 502,MCOSM,DT
  502 FORMAT(' TFPAIR- MCOSM,DT',I3,F10.2)
      CALL HFILL(301,T1,T2)
      CALL HF1(302,DT,1.)
      ZTOF1 = ZTOF(ITOF1)
      ZTOF2 = ZTOF(ITOF2)
      CALL HFILL(311,ZTOF1,ZTOF2)
      DZ = ZTOF1 + ZTOF2
      CALL HF1(312,DZ,1.)
    2 CONTINUE
    1 CONTINUE
C
      CALL HF1(300,FLOAT(MPAIR)+65.,1.)
      CALL HF1(300,FLOAT(MCOSM)+80.,1.)
      IF(MCOSM.GT.1) CALL HF1(300,FLOAT(NH)+95.,1.)
C/////////
      IF(MPAIR.NE.1) RETURN
      M = 1
      DO   50   I=1,2
      ITOF1 = LTOF(I,M)
      TOF1 = TTOF(ITOF1)
      CALL HFILL(303,TOF1,FLOAT(ITOF1))
      CALL HFILL(305,FLOAT(NRUN),TOF1)
   50 CONTINUE
      DT = TTOF(LTOF(2,1)) - TTOF(LTOF(1,1))
      CALL HFILL(304,DT,FLOAT(LTOF(1,1)))

       RETURN
       END

C   02/11/81 312061539  MEMBER NAME  SVECT1   (S)           FORTRAN
      SUBROUTINE SVECT1( P, R )
C-----------------------------------------------------------
C
C  VERSION OF 02/11/81   LAST MOD 04/11/81      E.ELSEN
C  STORE PARTICLE WITH P, R IN VECT,1 .
C  THE ORIGINATING PARTICLE GETS NEGATIVE TYPE.
C  ( STEERED VIA COMMON /CJTCDC / )
C ===> CHANGE: FILL RW(IP+7) FOR ELECTRONS    2/12/83 W.BARTEL
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON / CJTCDC / IBANK, IPART
      COMMON / CJTRLE / TOTLEN, STPLEN, TRCOFS
C
      DIMENSION P(10),R(3)
C
      DIMENSION NPVC(2)
      EQUIVALENCE (NPVC(1),NPVEC1), (NPVC(2),NPVEC2)
C
      DATA L0, L1 / 4, 12 /
C
      DATA ICALL, IER / 0, 0 /
      IF( ICALL .GT. 0 ) GO TO 1
      ICALL = 1
      IPVECT = IBLN('VECT')
    1 CONTINUE
C
      NPVEC1 = IW(IPVECT)
      IF( NPVEC1 .LE. 0 ) GO TO 8100
      NPVEC2 = IW(NPVEC1-1)
      IF( NPVEC2 .GT. 0 ) GO TO 100
C
      CALL CCRE( NPVEC2, 'VECT', 1, L0, IER )
      IF( IER .EQ. 2 ) GO TO 8200
      IW(NPVEC2+1) = L0
      IW(NPVEC2+2) = L1
      IW(NPVEC2+3) = IW(NPVEC1+3)
      IW(NPVEC2+4) = 0
C
  100 CALL BCHM( NPVEC2, L1, IER )
      IF( IER .NE. 0 ) GO TO 8200
      IP = NPVEC2 + L0 + IW(NPVEC2+4)*L1
      DO 200 J=1,5
  200 RW(IP+J) = P(J)
      IW(IP+6) = P(7)
      IW(IP+7) = P(8)
      RW(IP+8) = R(1)
      RW(IP+9) = R(2)
      RW(IP+10) = R(3)
      HW(IP*2+21) = IBANK
      HW(IP*2+22) = IPART
      RW(IP+12) = TRCOFS
      IF( P(7) .EQ. 0. ) RW(IP+12) = SQRT(R(1)**2+R(2)**2+R(3)**2)
C                                           ACCEPT PARTICLE
      IW(NPVEC2+4) = IW(NPVEC2+4) + 1
C
C                                           MARK DECAY FOR ORIGINATING
C                                           PARTICLE ( TYPE < 0 )
C                                           EXCEPT FOR ELECTRONS
      NPOLD = NPVC(IBANK+1)
      NPOLD = NPOLD + IW(NPOLD+1) + (IPART-1)*IW(NPOLD+2)
      IF( IW(NPOLD+7) .EQ. 2 ) GO TO 8000
      IW(NPOLD+7) = -IABS(IW(NPOLD+7))
C
      GO TO 8000
C
C
 8100 IF( IER .GT. 10 ) GO TO 8000
      IER = IER + 1
      WRITE(6,9101)
 9101 FORMAT(' +++++ SVECT1 +++++ BANK VECT 0 MISSING' )
      GO TO 8000
C
 8200 IF( IER .GT. 10 ) GO TO 8000
      IER = IER + 1
      WRITE(6,9102)
 9102 FORMAT(' +++++ SVECT1 +++++ NO SPACE FOR BANK VECT 1' )
C
 8000 RETURN
      END

C   12/03/84 503161539  MEMBER NAME  TAGFIT   (S)           FORTRAN
C
      SUBROUTINE TAGFIT(J,XFIT,YFIT,IDEBUG,*)
C
C TAGFIT PERFORMS THE FIT TO FIND THE DISTANCE OF THE CENTRE OF THE
C SHOWER FROM A BOUNDARY BETWEEN TWO BLOCKS BY COMPARING THE RATIO
C OF THE ENERGY IN EACH
C
C INPUT  : J       -  POINTER TO WHICH BLOCK IS TO BE COMPARED
C                     TO LARGEST BLOCK IN CLUSTER - CLUS(1)
C          IDEBUG  -  = 1  FOR DEBUG PRINT-OUT
C
C OUTPUT : XFIT    -  RESULT OF FIT IN  X - DIRECTION
C          YFIT    -  RESULT OF FIT IN  Y - DIRECTION
C
C RETURN 1 ERROR CONDITION DETECTED
C
C
#include "cwktag.for"
C
C
#include "comtag.for"
C
C
C
C
C---------------  C O D E  ---------------------------------------------
C
C
      XFIT = 0.0
      YFIT = 0.0
      SIGMA = 10.0
C
      E1 = CLUS(1,2)
      ADDRES = CLUS(1,1)
      X1 = XMAP(ADDRES)
      Y1 = YMAP(ADDRES)
      E2 = CLUS(J,2)
      IF ( (E2 + E1) .NE. 0 ) GOTO 10
C
      WRITE(6,60)
 60   FORMAT('  ERROR DETECTED IN TAGFIT E2 + E1 IS ZERO ')
      RETURN  1
C
 10   ADDRES = CLUS(J,1)
      X2 = XMAP(ADDRES)
      Y2 = YMAP(ADDRES)
      RATIO = E2/(E2 + E1)
C
C THIS IS THE CRITICAL FORMULA
C
      A = RATIO/0.5
      R = LOG(A ) /( - 0.079)
C
C WORK OUT THE X AND Y CORRECTIONS REQUIRED
C
      YDIFF = Y2 - Y1
      XDIFF = X2 - X1
CCC   YSIGN = MSIGN(YDIFF)
CCC   XSIGN = MSIGN(XDIFF)
      YSIGN =  SIGN(1.0,YDIFF)
      XSIGN =  SIGN(1.0,XDIFF)
      THETA = 1.5708 * YSIGN
      IF ( X2 .NE. X1 ) THETA = ATAN((Y2 - Y1 ) /(X2 - X1) )
      XDIFF = X2 - X1
      YDIFF = Y2 - Y1
      ARG = YDIFF ** 2 + XDIFF ** 2
      AL = (SQRT(ARG) ) /2
      XFIT = ((AL - R) * COS(THETA) )
      YFIT = ((AL - R) * SIN(THETA) )
      XFIT = XSIGN * ABS(XFIT)
      YFIT = YSIGN * ABS(YFIT)
C
C-------------------------------------------- R E T U R N --------------
C
      IF ( IDEBUG .NE. 1 ) RETURN
C
C
C
C-------------------------------------------- D E B U G ----------------
C
      WRITE(6,601) E1,E2
      WRITE(6,603) XFIT,YFIT,XDIFF,YDIFF,THETA
      WRITE(6,604) AL,R,RATIO,E1,E2
  601  FORMAT('  E1 E2 ',2X,F10.2,2X,F10.2)
  603  FORMAT(' XFIT,YFIT,YDIF,XDIF,THET,AL,R,RAT,E1,E2',5(2X,F12.2))
  604  FORMAT('  ',5(2X,F12.2) )
      RETURN
CCC   END
CCC   FUNCTION MSIGN(X)
CCC   MSIGN = - 1
CCC   IF ( X .GE. 0 ) MSIGN = 1
CCC   RETURN
      END

C   07/06/96 606071842  MEMBER NAME  DEFST    (S4)          FORTG1
      SUBROUTINE DEFST(IND)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (IW(1),RW(1))
      REAL H(100)
C     CALL BY UHIST
      IF(IW(IND+20).GE.1) GOTO 100
      CALL VALL(RW(IND+21),IW(IND+2),RW(IND+3),RW(IND+4),100)
      N=IW(IND+2)
      DO 10 I=1,N
      H(I)=RW(IND+20+I)
   10 RW(IND+20+I)=0
      DO 20 I=1,N
      K=(H(I)-RW(IND+3))/RW(IND+4)+21
      IF(K.LE.20) K=5
      IF(K.GT.120) K=6
   20 RW(IND+K)=RW(IND+K)+1.0
      IW(IND+20)=1
  100 RETURN
      END

C   29/09/86 809301244  MEMBER NAME  TPTAGT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTAGT
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       5/02/87:  Add tagging information to TP
C
C          mod: C. Bowdery       9/02/87:  Remove tidying-up routine
C     Last mod: C. Bowdery      30/09/88:  CALL TPSEFL now
C
C     Routine to add tagging information to the TP banks if wanted.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  SUMMRY

      INTEGER  TAGG

      PARAMETER ( TAGG = 7 )

C------------------  C O D E  ------------------------------------------

C                            Get instruction relating to tagging summary

      CALL TPTGI2( SUMMRY )

      IF( SUMMRY ) THEN

C                            Put summary information into new TPTR banks

        CALL TPTGTP
        CALL TPDIAG()

      ELSE

C                            Set flag to indicate summary not done

         CALL TPSEFL( TAGG, 4000 )

      ENDIF

      RETURN
      END

C   07/06/96 606071909  MEMBER NAME  SMOPMC   (S4)          FORTG1
      SUBROUTINE SMOPMC
      RETURN
      END
      SUBROUTINE SMOP(X,Y,DY,N,SY)
      COMMON/FDST/LLA,LLB,LLC,NKA,NKB
      REAL X(120),Y(120),DY(120),SY(120)
      REAL YI(120),W(120)
C
      IP=1
      DO 20 I=1,N
      YI(I)=Y(I)
      IF(DY(I).LE.0.0) GOTO 20
      IF(Y(I).LE.0.0)  GOTO 20
      SE=SQRT(Y(I))
      IF(ABS(SE-DY(I)).GT.1.E-3*SE) GOTO 30
   20 CONTINUE
      IP=0
C
C
   30 CALL SMHIST(YI,SY,DY,N,IP)
      CALL DEKB(NKB)
      SUM=0.0
      DO 40 I=1,N
      SUM=SUM+SY(I)
   40 CALL GEND(NKA,100,SY(I),X(I))
      IF(SUM.LE.0.0) GOTO 100
      SUM=1000.0/SUM
      DO 50 I=1,N
   50 CALL GEND(NKA+500,100,SY(I)*SUM,X(I))
      CALL PSAF(NKA)
      CALL PSAF(NKA+500)
  100 RETURN
      END

C   07/06/96 606071824  MEMBER NAME  BMLT     (S4)          FORTG1
      SUBROUTINE BMLT(NL,LIST)
C     BOS SUBPROGRAM =0.4=
#include "acs.for"
      COMMON/BCS/IW(1)
C
      INTEGER LIST(1)
C
      IF(NL.LT.0) GOTO 20
      IN=NL
      IF(NL.EQ.0) GOTO 100
      DO 10 I=1,IN
   10 IW(NLST+I)=IBLN(LIST(I))
      GOTO 100
C
   20 IN=0
      IF(NS.EQ.0) GOTO 100
      MARK=LIST(1)
      DO 30 I=1,NS
      IF(MARK.EQ.0) GOTO 25
      IF(IW(IMLST+I).EQ.0) GOTO 30
   25 IN=IN+1
      IW(NLST+IN)=IW(ISLST+I)
   30 CONTINUE
  100 RETURN
      END

C   09/01/80 006251729  MEMBER NAME  VTXEE    (JADEGS)      FORTRAN
      SUBROUTINE VTXEE
C*800604*DITTMANN********************************************
C*                                                          *
C*              X - Y - Z    E E   P A I R S                *
C*                                                          *
C*       A DESCRIPTION OF THE T AND V ARRAYS CAN BE FOUND   *
C*       IN SUBR. VERTEX                                    *
C************************************************************
      COMMON /CWORK1/ NT,T(1500),NV,V(200)
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX
C
      IF(NT.LE.1) GOTO 100
C****
C****    LOOP OVER ALL TRACK PAIRS
      J1 = 0
      NT1 = NT - 1
      DO 9 I=1,NT1
      IF(IT(J1+1).EQ.0) GOTO 9
      M = I + 1
      J2 = I*30
      DO 8 K=M,NT
      IF(IT(J2+1).EQ.0) GOTO 8
C        OPPOSITE CHARGE
      IF(T(J1+2)*T(J2+2).GT.0.) GOTO 8
C        MEASURED R-PHI OPENING
      DPHI = T(J1+3) - T(J2+3)
      IF(T(J1+2).LT.0.) DPHI=-DPHI
      IF(ABS(DPHI).GT.3.141593) DPHI=DPHI-SIGN(1.,DPHI)*6.283185
      IF(DPHI.LT.EEDPMN .OR. DPHI.GT.EEDPMX) GOTO 8
      ITANK = 0
      XM1 = T(J1+5) - T(J1+2)*T(J1+21)
      YM1 = T(J1+6) + T(J1+2)*T(J1+22)
      XM2 = T(J2+5) - T(J2+2)*T(J2+21)
      YM2 = T(J2+6) + T(J2+2)*T(J2+22)
C        EXTRAPOLATION LENGTH
      IF(T(J1+27).EQ.0. .OR. T(J2+27).EQ.0.) GOTO 6
      IF(T(J1+27).LT.SEMAX .OR. T(J2+27).LT.SEMAX) GOTO 6
C        PAIR ORIGIN IN TANK (ADD SQRT(2/3)*COULOMB ERROR)
      ST1 = T(J1+27)
      ST2 = T(J2+27)
      CALL VTXS(J1,ST1,XT1,YT1,ZT1,DXT12,DYT12,DZT12,PHIT1)
      CALL VTXS(J2,ST2,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT2)
C        DISTANCE IN TANK
      DPHI = PHIT1 - PHIT2
      IF(T(J1+2).LT.0.) DPHI=-DPHI
      IF(ABS(DPHI).GT.3.141593) DPHI=DPHI-SIGN(1.,DPHI)*6.283185
      PTANK2 = (T(J1+16)**2+T(J2+16)**2) / 1.5
      STANK2 = 49. * PTANK2
      DX2 = (XT1-XT2)**2
      DY2 = (YT1-YT2)**2
      DXY = SQRT(DX2+DY2)
      DIST = SQRT((XT2-XM1)**2+(YT2-YM1)**2)
      IF(DIST.LT.ABS(T(J1+2))) DXY=-DXY
      DZ = ABS(ZT1-ZT2)
      DTH = ABS(T(J1+4)-T(J2+4))
      SDTH = DTH / SQRT(T(J1+9)**2+T(J2+9)**2+PTANK2)
      IF(SDTH.GT.EEDTMX) GOTO 6
      CTH = COS((T(J1+4)+T(J2+4))/2.)**2
      SDZ = DZ / SQRT(DZT12+DZT22+STANK2/CTH**2)
      IF(SDZ.GT.EEDTMX) GOTO 6
      SDPHI = ABS(DPHI)/SQRT(T(J1+8)**2+T(J2+8)**2+PTANK2)
      IF(SDPHI.GT.EEDRMX) GOTO 5
      SDXY = ABS(DXY) / SQRT(1./(1./DXT12+1./DYT12)+
     *                       1./(1./DXT22+1./DYT22)+STANK2)
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 5
      ITANK = 1
      GOTO 6
C        DISTANCE AT BEAM PIPE
    5 DPHIT = DTANK/ABS(T(J1+2)) + DTANK/ABS(T(J2+2))
      DPHI = DPHI - DPHIT
      SDPHI = ABS(DPHI)/SQRT(T(J1+8)**2+T(J2+8)**2+PTANK2)
      IF(SDPHI.GT.EEDRMX) GOTO 6
      DXY = DXY - DPHIT*DTANK/2.
      SDXY = ABS(DXY) / SQRT(1./(1./DXT12+1./DYT12) +
     *             1./(1./DXT22+1./DYT22) + STANK2)
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 6
      ITANK = 1
C        VERTEX WHERE TRACKS ARE PARALLEL
    6 CALL VTXPNT(J1,XM2,YM2,XT1,YT1,ZT1,DXT12,DYT12,DZT12,PHIT1,ST1)
      CALL VTXPNT(J2,XM1,YM1,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT2,ST2)
      DX2 = (XT1-XT2)**2
      DY2 = (YT1-YT2)**2
      DXY = SQRT(DX2+DY2)
      IF(DXY.GT.EEXYMX) GOTO 8
      DIST = SQRT((XT2-XM1)**2+(YT2-YM1)**2)
      IF(DIST.LT.ABS(T(J1+2))) DXY=-DXY
      DZ = ABS(ZT1-ZT2)
      IF(ITANK.EQ.1) GOTO 7
C        PAIR ORIGIN IN CHAMBER
      IF(ST1.LT.SEMAX .OR. ST2.LT.SEMAX) GOTO 8
      IF(ST1.GT.SIMAX .OR. ST2.GT.SIMAX) GOTO 8
      IF(T(J1+27).NE.0. .AND. ST1-T(J1+27).LT.0.) GOTO 8
      IF(T(J2+27).NE.0. .AND. ST2-T(J2+27).LT.0.) GOTO 8
C        DISTANCE IN CHAMBER
      DTH = ABS(T(J1+4)-T(J2+4))
      SDTH = DTH / SQRT(T(J1+9)**2+T(J2+9)**2)
      IF(SDTH.GT.EEDTMX) GOTO 8
      SDZ = DZ / SQRT(DZT12+DZT22)
      IF(SDZ.GT.EEDTMX) GOTO 8
      SDXY = ABS(DXY)/SQRT(1./(1./DXT12+1./DYT12)+1./(1./DXT22+
     *       1./DYT22))
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 8
C
    7 IF(NV.EQ.20) GOTO 14
      NV = NV + 1
      LV = (NV-1)*10
      IV(LV+1) = 4
      DT1 = SQRT(DXT12)
      DT2 = SQRT(DXT22)
      V(LV+2) = (XT1/DT1+XT2/DT2) / (1./DT1+1./DT2)
      DT1 = SQRT(DYT12)
      DT2 = SQRT(DYT22)
      V(LV+3) = (YT1/DT1+YT2/DT2) / (1./DT1+1./DT2)
      DT1 = SQRT(DZT12)
      DT2 = SQRT(DZT22)
      V(LV+4) = (ZT1/DT1+ZT2/DT2) / (1./DT1+1./DT2)
      V(LV+5) = SQRT(DXT12+DXT22) / 2.
      V(LV+6) = SQRT(DYT12+DYT22) / 2.
      V(LV+7) = SQRT(DZT12+DZT22) / 2.
      V(LV+8) = SQRT(DX2+DY2)
      IV(LV+9) = I
      IV(LV+10) = K
    8 J2 = J2 + 30
    9 J1 = J1 + 30
C****
C****    CLEAN UP
      IF(NV.EQ.0) GOTO 100
   14 I = 1
   15 LV1 = (I-1)*10
      IF(I.EQ.NV) GOTO 19
      M = I + 1
      LV2 = I*10
      DO 16 K=M,NV
      IF(IV(LV1+9).EQ.IV(LV2+9) .OR. IV(LV1+10).EQ.IV(LV2+9) .OR.
     *   IV(LV1+10).EQ.IV(LV2+10)) GOTO 17
   16 LV2 = LV2 + 10
      GOTO 19
C        TWO PAIRS WITH SAME TRACK, TAKE PAIR WITH SMALLER DISTANCE
   17 M = I
      IF(V(LV1+8).LT.V(LV2+8)) M=K
      NV = NV - 1
      IF(M.GT.NV) GOTO 15
      DO 18 K=M,NV
      LV2 = K*10
      LV1 = LV2 - 10
      DO 18 J=1,10
   18 V(LV1+J) = V(LV2+J)
      GOTO 15
   19 J1 = (IV(LV1+9)-1)*30
      J2 = (IV(LV1+10)-1)*30
      IV(LV1+8) = 2
      V(LV1+9) = 0.
      IV(LV1+10) = 2
      IT(J1+1) = 3
      IT(J2+1) = 3
      IT(J1+14) = I
      IT(J2+14) = I
      I = I + 1
      IF(I.LE.NV) GOTO 15
C
  100 RETURN
      END

C   08/10/80 010131213  MEMBER NAME  GGFAC5   (S)           FORTRAN
      SUBROUTINE GGFAC5
C---  COPY CALIBRATION CONSTANTS OF LEAD-GLASS INTO COMMON /CALICO/
C---  RUN 4511 TO RUN 4864
C
C     H.WRIEDT    13.09.79     19:00
C     LAST MODIFICATION    13.10.80   12:15
C
      COMMON /CFACT5/ FACT5(191)
      COMMON /CALICO/ FAKTOR(191)
C
        DO 1 I = 1,191
    1   FAKTOR(I) = FACT5(I)
      WRITE(6,600)
  600 FORMAT(/' *** FOURTH SET OF LEAD-GLASS CALIBRATION CONSTANTS',
     &        ' INCLUDED ***')
      RETURN
      END
      BLOCK DATA
C
      COMMON /CFACT5/ FACT5
C     THIS DATA APPLICABLE FROM RUN 4511 TO RUN 4864
C     THE GAIN ASSUMES ENERGY(MEV)=CHANNEL*5.0
      REAL*4 FACT5(191)/191*1.65/
      END

C   14/09/81 202270914  MEMBER NAME  KALPRE   (JADEGS)      FORTRAN
      SUBROUTINE KALPRE
      IMPLICIT INTEGER*2 (H)
C---
C---    14.9.81 MODIFIED IN ORDER TO COPE WITH CHANGED CALIBR.FILES
C---            ONLY AUPDAT0 + AUPDAT1/KALWRK0 ARE NEEDED
C---            ASTART0 + ASTART1 ARE REDUNDANT   P. ST.
C---
C---     COPIES CALIBRATION DATA FROM THE BEGINNING OF THE RUTHERFORD
C---     REFORMATTED TAPES ONTO THE RUTHERFORD CALIBRATION DISK FILES.
C---                                   L.H. O'NEILL 14.03.81
C---
      DIMENSION JBUF(5000)
      DIMENSION LTIMES(10)
#include "ciouni.for"
      DATA LTIMES/
     1   14688000,
     1   66787200,
     1   14688000,
     1   66787200,
     1   6*0/
C---
      NUINI=NCALI
      DO 3 JUNITN=1,NUINI
      IUNITN=LUNITA(JUNITN)
      NREC=0
    1 CONTINUE
      CALL EVREA1(2,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
      IF(NREC.GT.1) GO TO 4
      IF(NWORD.NE.1) GO TO 1001
      IF(JBUF(1).NE.LTIMES(JUNITN)) GO TO 1001
    4 CONTINUE
      CALL KALBNK(IUNITN,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) JUNITN
  101 FORMAT(' *** KALPRE .. READ ERROR ON FILE',I2,' AFTER',I6,'RECS.')
      STOP
 1001 CONTINUE
      WRITE(6,102) JUNITN,NWORD,JBUF(1)
  102 FORMAT(' *** KALPRE .. INCORRECT 1ST RECORD IN',
     +           ' CALIBRATION DATA SET',I2,2I10)
      STOP
 2000 CONTINUE
      WRITE(6,103) NREC,IUNITN
  103 FORMAT(1X,10('-'),
     +             I6,' RECORDS COPIED BY KALPRE FROM FT02 TO UNIT',I3)
      END FILE IUNITN
      REWIND IUNITN
    3 CONTINUE
      RETURN
      END

C   23/08/85 508241143  MEMBER NAME  MCTAGC   (S)           FORTRAN
C--------------------------------------------------------------------
C   15/03/84 403152025  MEMBER NAME  MCTAGC   (S)           FORTRAN
C
C
C   GIVEN DX,DY,Z = DIRECTION COSINES OF TRACK
C     AND Z - WORK OUT X,Y OF TRACK
C
C USED IN JADE TAGG MC (A.J.FINCH'S VERSION)
C
C 15/3/84
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE MCTAGC(DX,DY,DZ,X,Y,Z)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       DATA ILIMIT/10/
       DATA IWRITE/0/
C
       IF(DZ.EQ.0)GOTO 1
       R = Z/DZ
       X = R*DX
       Y = R*DY
C GOSH THAT WAS HARD
       RETURN
  1    X= 0
       Y = 0
       IWRITE = IWRITE  + 1
       IF(IWRITE.GT.ILIMIT)WRITE(6,600)DX,DY,DZ,Z
 600   FORMAT(' PROBLEM IN MCTAGC DX,DY,DZ,Z ',4(2X,F8.3))
       RETURN
       END

C   24/04/85 807251550  MEMBER NAME  GRBLOCK  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      BLOCK DATA BLCKG2 !PMF 03/12/99: add name
C-----------------------------------------------------------------------
C
C                  THIS MACRO IS EXPANDED IN GPHMAIN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  FL18,FL22,FL24,DSPDTM
      LOGICAL  LERROR
      LOGICAL*1  CCMD,CDICTY
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,
     +                  IPRJC,FL18,FL22,FL24,KPROJ
      COMMON / CZKON  / ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
      COMMON / CVX    / NNPATR,ICRSTR,NNJETC,NNVTXC
C
      COMMON / CZGEO  / RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,
     +                  ZCHSS,ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CGRAP3 / IDEFWP, CDICTY(700)
C
      COMMON / CGRAP4 / IPOS4,CCMD(8,200),HCMD(5,200)
      COMMON / CGRAP5 / KOMCAL,LERROR
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
      COMMON / CSTANV / HDISPN, HCSTV2, HCSTV3
C
#include "chsym.for"
#include "cgrscl.for"
C
C------------------  D A T A  ------------------------------------------
C
      DATA HSYM /'0 ','1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 ','A ',
     + 'B ','C ','D ','E ','F ','G ','H ','I ','J ','K ','L ','M ','N ',
     + 'O ','P ','Q ','R ','S ','T ','U ','V ','W ','X ','Y ','Z '/
C
      DATA  FL18,FL22,FL24  / 3*.FALSE. /, KPROJ / 0 /
      DATA  DSPDTM / .TRUE. ,.TRUE. ,.FALSE.,.FALSE.,.FALSE.,
     +               .FALSE.,.FALSE.,.TRUE. ,.FALSE.,.FALSE.,
     +               .TRUE. ,.FALSE.,.TRUE. ,.FALSE.,.TRUE. ,
     +               .FALSE.,.FALSE.,.FALSE.,.TRUE. ,.TRUE. ,
     +               .TRUE. ,.FALSE.,.FALSE.,.FALSE.,.TRUE. ,
     +               .TRUE. ,.FALSE.,.FALSE.,.FALSE.,.FALSE. /
      DATA  ISTVW  / 0 /, JTVW   / 0 /
      DATA  NNPATR / 0 /, NNJETC / 0 /, NNVTXC / 9 /
C
      DATA  MACNR, MACSTA, MACDEP / 0, 169, 1 /
C
      DATA  RZCHI,RZCHA /864.5, 884.5/
      DATA  NZRPSI,NZZ /24,16/
      DATA  Z1ZCH,Z2ZCH /-1200.,1200./
      DATA  ZCHA,ZCHB,ZCHSS /5.,15.,1./
      DATA  ZCHDL,ZCHDLL /100.,20./, DLZZ,DLZPHI /150.,227.63/
      DATA  DLZW1,DLZW2 /228.94,231.58/
C
      DATA  ZCVDR/0.34/, ZCXCH/1.0/, ZCTZER/0.0/, ZCAPED/0.0/
      DATA  XL1,XL2 /2547.28, 2578.96/
      DATA  IDEFWP, IPOS4 / 0, 0 /
      DATA  KOMCAL / 0 /
C
      DATA  HDISPN/ 1 /, HCSTV2/ 1 /, HCSTV3/ -1 /
C
C                            VIEW RA
C
      DATA  XMAXST(1)  /  1400.0 /
      DATA  XMINST(1)  / -1400.0 /
      DATA  YMINST(1)  / -1100.0 /
C
C                            VIEW RB
C
      DATA  XMAXST(2)  /  1950.0 /
      DATA  XMINST(2)  / -2050.0 /
      DATA  YMINST(2)  / -1550.0 /
C
C                            VIEW RC
C
      DATA  XMAXST(3)  /  4900.0 /
      DATA  XMINST(3)  / -4900.0 /
      DATA  YMINST(3)  / -3350.0 /
C
C                            VIEW ZXA
C
      DATA  XMAXST(4)  /  1500.0 /
      DATA  XMINST(4)  / -1800.0 /
      DATA  YMINST(4)  / -1300.0 /
C
C                            VIEW ZXB
C
      DATA  XMAXST(5)  /  2000.0 /
      DATA  XMINST(5)  / -2400.0 /
      DATA  YMINST(5)  / -1700.0 /
C
C                            VIEW ZXC
C
      DATA  XMAXST(6)  /  4400.0 /
      DATA  XMINST(6)  / -5600.0 /
      DATA  YMINST(6)  / -3900.0 /
C
C                            VIEW ZXD
C
      DATA  XMAXST(7)  /  5500.0 /
      DATA  XMINST(7)  / -5500.0 /
      DATA  YMINST(7)  / -3900.0 /
C
C                            VIEW ZYA
C
      DATA  XMAXST(8)  /  1500.0 /
      DATA  XMINST(8)  / -1800.0 /
      DATA  YMINST(8)  / -1300.0 /
C
C                            VIEW ZYB
C
      DATA  XMAXST(9)  /  2000.0 /
      DATA  XMINST(9)  / -2400.0 /
      DATA  YMINST(9)  / -1700.0 /
C
C                            VIEW ZYC
C
      DATA  XMAXST(10) /  4400.0 /
      DATA  XMINST(10) / -5600.0 /
      DATA  YMINST(10) / -3900.0 /
C
C                            VIEW ZYD
C
      DATA  XMAXST(11) /  5500.0 /
      DATA  XMINST(11) / -5500.0 /
      DATA  YMINST(11) / -3900.0 /
C
C                            VIEW FW
C
      DATA  XMAXST(12) /  1200.0 /
      DATA  XMINST(12) / -1200.0 /
      DATA  YMINST(12) / - 800.0 /
C
C                            VIEW RU
C
      DATA  XMAXST(13) /  7890.0 /
      DATA  XMINST(13) / -1610.0 /
      DATA  YMINST(13) / -  25.0 /
C
C                            VIEW CYL
C
      DATA  XMAXST(14) /  1800.0 /
      DATA  XMINST(14) / -1800.0 /
      DATA  YMINST(14) / -1300.0 /
C
C                            VIEW FWMU
C
      DATA  XMAXST(15) /  7890.0 /
      DATA  XMINST(15) / -1610.0 /
      DATA  YMINST(15) / -  25.0 /
C
C                            VIEW Z-CHAMBER (ALIAS  RZ )
C
      DATA  XMAXST(16) /  5530.0 /
      DATA  XMINST(16) / -1250.0 /
      DATA  YMINST(16) /     0.0 /
C
C                            VIEW VRX  (RFI VERTEX REGION)
C
      DATA  XMAXST(17) /     7.0 /
      DATA  XMINST(17) /   - 8.5 /
      DATA  YMINST(17) /   - 6.0 /
C
C                            VIEW VRZX (ZX  VERTEX REGION)
C
      DATA  XMAXST(18) /     7.0 /
      DATA  XMINST(18) /   - 8.5 /
      DATA  YMINST(18) /   - 6.0 /
C
C                            VIEW VRZY (ZY  VERTEX REGION)
C
      DATA  XMAXST(19) /     7.0 /
      DATA  XMINST(19) /   - 8.5 /
      DATA  YMINST(19) /   - 6.0 /
C
C                            VIEW VC   (VERTEX CHAMBER)
C
      DATA  XMAXST(20) /   345.0 /
      DATA  XMINST(20) / - 345.0 /
      DATA  YMINST(20) / - 260.0 /
C
C                            SPARE VIEWS
C
      DATA  XMAXST(21) /   11.0 /
      DATA  XMINST(21) /    7.0 /
      DATA  YMINST(21) /    7.0 /
C
      DATA  XMAXST(22) /   11.0 /
      DATA  XMINST(22) /    7.0 /
      DATA  YMINST(22) /    7.0 /
C
      DATA  XMAXST(23) /   11.0 /
      DATA  XMINST(23) /    7.0 /
      DATA  YMINST(23) /    7.0 /
C
      DATA  XMAXST(24) /   11.0 /
      DATA  XMINST(24) /    7.0 /
      DATA  YMINST(24) /    7.0 /
C
      DATA  XMAXST(25) /   11.0 /
      DATA  XMINST(25) /    7.0 /
      DATA  YMINST(25) /    7.0 /
C
      DATA  XMAXST(26) /   11.0 /
      DATA  XMINST(26) /    7.0 /
      DATA  YMINST(26) /    7.0 /
C
      DATA  XMAXST(27) /   11.0 /
      DATA  XMINST(27) /    7.0 /
      DATA  YMINST(27) /    7.0 /
C
      DATA  XMAXST(28) /   11.0 /
      DATA  XMINST(28) /    7.0 /
      DATA  YMINST(28) /    7.0 /
C
      DATA  XMAXST(29) /   11.0 /
      DATA  XMINST(29) /    7.0 /
      DATA  YMINST(29) /    7.0 /
C
      DATA  XMAXST(30) /   11.0 /
      DATA  XMINST(30) /    7.0 /
      DATA  YMINST(30) /    7.0 /
C
      END

      SUBROUTINE VTXERR(IERR) 
C*860529*KLEINWORT***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXERR)   18.9.86
C*                                                                  *
C*   PRINT ERROR-TEXT FOR   V E R T E X -FIT                        *
C*                                                                  *
C********************************************************************
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C
      REAL*8 DTEXT(27)
      DIMENSION NSTART(10)
C
      DATA NSTART / 1, 4, 5, 6, 8, 14, 19, 24, 25, 28 /
      DATA DTEXT /
     *'NV < 1 O','R NV > 2','0       ',
     *'NT  <= 0',
     *'NTR <= 0',
     *'DET = 0.','0       ',
     *'NTR < 2 ','AFTER RE','JECTING ','TRACK WI','TH DS/R ','> 90 DEG',
     *'ERROR OF',' VERTEXC','OORDINAT','E(S) = 0','.0      ',
     *'NTR < 2 ','AFTER RE','JECTING ','BAD TRAC','K       ',
     *'NTR = 1 ',
     *'COLLINEA','R 2-PRON','G       ' /
C
      IF ((IERR.LT.1).OR.(IERR.GT.9)) GOTO 100
C        IF (HVTXST(4+IERR).GT.0)
      N1 = NSTART(IERR)
      N2 = NSTART(IERR+1)-1
      WRITE(6,9000) IERR,(DTEXT(K),K=N1,N2)
 9000 FORMAT(' ERROR ',I2,' : ',10A8)
      GOTO 200
C
  100 CONTINUE
C
      WRITE(6,9010) IERR
 9010 FORMAT(' ERROR ',I6,' IS UNKNOWN ')
C
  200 CONTINUE
C
      RETURN
      END

C   10/09/82 701161320  MEMBER NAME  STAT82   (JADESR)      FORTRAN
      SUBROUTINE STAT82
C   MODIFIED 16/01/87    TO INTRODUCE MBYTE COUNT
#include "ciouni.for"
      COMMON /CIGG/ IPRN,IGG(80)
C------------
C  PAGE TITLE
C------------
C
C KILL FULL STATISTICS FOR INDIVIDUAL RUNS AND JUST PRINT ONE LINE
      IF(IGG(1).NE.0)GOTO10000
CCCCC IF(IGG(1).NE.0)PRINT1000,IGG(1)
C1000 FORMAT(1H1/
C    + 1X,116('=')/
C    + 1X,45('='),' STATISTICS FOR RUN',I6,1X,45('=')/
C    + 1X,116('='))
C
C END OF JOB SUMMARY
      IF(IGG(1).EQ.0)PRINT1001
 1001 FORMAT(1H1/
     + 1X,113('=')/
     + 1X,40('='),' OVERALL STATISTICS FOR THIS JOB ',40('=')/
     + 1X,113('='))
C-------------------
C PRINT RAW COUNTERS
C-------------------
      PRINT1010,(IGG(I),I=1,80)
 1010 FORMAT(/' INTEGER CONTENTS',1X,10I8/
     +        ' ----------------',1X,10I8/6(18X,10I8/))
C-------------------
C USER LEVELS CALLED
C-------------------
      PRINT1015,(IGG(I),I=5,10)
 1015 FORMAT(' USER LEVELS 3 TO 8',7X,6I8/
     +       ' ------------------'/)
C-----------------
C EVENT STATISTICS
C-----------------
      PRINT1016
 1016 FORMAT(' EVENT STATISTICS'/
     +       ' ----------------')
C--------------------
C PULSERSCALER EVENTS
C--------------------
      N4RED=IGG(4)-IGG(11)
      FRACTN=0.0
      IF(IGG(4).GT.0)FRACTN=100./FLOAT(IGG(4))
      FIGG11=IGG(11)*FRACTN
      PRINT1020,IGG(4),IGG(11),FIGG11,IGG(9),N4RED
 1020 FORMAT(/
     + 10X,I10,1X,'(100.00%) ',
     +'EVENTS READ'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'PULSER/SCALER EVENTS (REJECTED)'/
     + 10X,I10,11X,
     +'LGCALB ERROR RETURNS'/
     + 10X,I10,11X,
     +'EVENTS CONTINUE FOR PROCESSING BY REDUC1 PACKAGE'/)
C-----------------------------------
C TRIGGER ACCEPT / REJECT & POSTPONE
C-----------------------------------
      NLB48=N4RED-IGG(14)-IGG(15)-IGG(21)
      NLB8=IGG(24) + IGG(25)+IGG(27)+IGG(28)+IGG(29)+IGG(30)
      NLB4=NLB48-NLB8
      FLB4 =NLB4 *FRACTN
      FLB8 =NLB8 *FRACTN
      FIGG14=IGG(14)*FRACTN
      FIGG15=IGG(15)*FRACTN
      FIGG21=IGG(21)*FRACTN
      PRINT1040,IGG(15),FIGG15,IGG(14),FIGG14,
     +          IGG(21),FIGG21,NLB4,FLB4,NLB8,FLB8
 1040 FORMAT(
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED WITH UNCONDITIONAL T1 REJECT (LABEL 0)'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS ACCEPTED WITH UNCONDITIONAL T1 ACCEPT (LABEL 1)'//
C
     + 31X,
     +'CREATE ZVTX BANK'/
C
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS ACCEPTED WITH UNCONDITIONAL T1 ACCEPT (LABEL 2)'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS CONTINUE DIRECTLY TO PATREC TESTS (LABEL 4 ONLY)'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS CONTINUE THROUGH Z-VERTEX TESTS   (LABEL 8 ONLY)'/)
C-----------
C ZVTX TESTS
C-----------
C ONLY LBACC = 8 SUBJECTED TO ZVTX CUTS
      FIGG24=IGG(24)*FRACTN
      FIGG22=IGG(22)*FRACTN
      FIGG23=IGG(23)*FRACTN
      NLB8=NLB8-IGG(22)-IGG(23)-IGG(24)
      FLB8=NLB8*FRACTN
      PRINT1060,IGG(24),FIGG24,
     +          IGG(25),IGG(27),IGG(28),IGG(29),IGG(30),
     +          IGG(22),FIGG22,IGG(23),FIGG23,NLB8,FLB8
 1060 FORMAT(
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED (LABEL 8) AFTER FAILING TO CREATE A ZVTX BANK'/
     + 10X,I10,11X,
     +'EVENTS RETURNED A ZVTX FLAG OF -2'/
     + 10X,I10,11X,
     +'EVENTS RETURNED A ZVTX FLAG OF  0'/
     + 10X,I10,11X,
     +'EVENTS RETURNED A ZVTX FLAG OF  1'/
     + 10X,I10,11X,
     +'EVENTS RETURNED A ZVTX FLAG OF  2'/
     + 10X,I10,11X,
     +'EVENTS RETURNED A ZVTX FLAG OF  3'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED WITH NO GOOD ZVTX FOUND'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED WITH ZVTX OUTSIDE 300 MMS'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'(LABEL 8) EVENTS CONTINUE TO PATREC TESTS'/)
C-----------
C PATR TESTS
C-----------
C ONLY LBACC = 4 , 8 LEFT
      N2TEST=NLB4+NLB8
      F2TEST=N2TEST *FRACTN
      FIGG31=IGG(31)*FRACTN
      FIGG32=IGG(32)*FRACTN
      FIGG33=IGG(33)*FRACTN
      FIGG34=IGG(34)*FRACTN
      FIGG35=IGG(35)*FRACTN
      FIGG36=IGG(36)*FRACTN
      FIGG40=IGG(40)*FRACTN
      PRINT1080,N2TEST,F2TEST,
     +          IGG(31),FIGG31,IGG(32),FIGG32,
     +          IGG(33),FIGG33,IGG(34),FIGG34,IGG(35),FIGG35,
     +          IGG(36),FIGG36,IGG(40),FIGG40
 1080 FORMAT(31X,'CREATE PATR BANK'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS ARRIVE FOR PATREC TESTS (LABEL 4 & 8)'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS ACCEPTED BECAUSE NO PATREC BANK COULD BE CREATED'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED BECAUSE NO ID TRACKS WERE FOUND'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED BECAUSE NO TRACKS WITH > 12 HITS WERE FOUND'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED BECAUSE NO LONG TRACKS HAD PT > 100MEV'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED BECAUSE NO LONG HI-PT TRACKS HAD ZINT < 300MMS'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS REJECTED BECAUSE NO GOOD TRACKS ALSO HAD RMIN < 50MMS'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS ACCEPTED WITH .GE. 1 GOOD TRACK FROM VERTEX'/)
C---------------
C EVENTS WRITTEN
C---------------
      FIGG10=IGG(10)*FRACTN
      NWR0=IGG(10)-IGG(51)-IGG(58)-IGG(66)
      FWR0=NWR0*FRACTN
      FIGG51=IGG(51)*FRACTN
      FIGG58=IGG(58)*FRACTN
      FIGG66=IGG(66)*FRACTN
      PRINT1100,IGG(10),FIGG10,
     +          NWR0,FWR0,IGG(51),FIGG51,IGG(58),FIGG58,IGG(66),FIGG66
 1100 FORMAT(
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS ACCEPTED IN TOTAL'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS WERE ACCEPTED WITH WRITE FLAG  0'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS WERE ACCEPTED WITH WRITE FLAG  1'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS WERE ACCEPTED WITH WRITE FLAG  8'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'EVENTS WERE ACCEPTED WITH WRITE FLAG 16'/)
C-------------
C MIPROC FLAGS
C-------------
      FIGG49=0.
      IF(IGG(10).GT.0) FIGG49=100.*IGG(49)/FLOAT(IGG(10))
      FIGG50=0.
      IF(IGG(10).GT.0) FIGG50=100.*IGG(50)/FLOAT(IGG(10))
      PRINT1120,IGG(49),FIGG49,IGG(50),FIGG50
 1120 FORMAT(
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'OF ACCEPTED EVENTS HAD THE MIPROC BIT 30 SET'/
     + 10X,I10,1X,'(',F6.2,'%) ',
     +'OF ACCEPTED EVENTS HAD THE MIPROC BIT 29 SET'/)
C-------------------------
C OVERALL REDUCTION FACTOR
C-------------------------
      PRINT9090,IGG(4),IGG(10),FIGG10
 9090 FORMAT(///
     +      5X,24('='), 11X,26('='), 11X,36('=')/
     +      1X,I10,' EVENTS WERE READ',6X,
     +      1X,I10,' EVENTS WERE WRITTEN',6X,
     +      1X, 5X,' ACCEPTED EVENT FRACTION = ',F7.2,'%'/
     +      5X,24('='), 11X,26('='), 11X,36('='))
      RETURN
C------------------------------------------
C SPECIAL BY-PASS FOR RUN-BY-RUN STATISTICS
C------------------------------------------
10000 CONTINUE
      FIGG10=0.
      IF(IGG(4).GT.0)FIGG10=100.*IGG(10)/FLOAT(IGG(4))
      XMB = XMBYTE( JUNIT )
      PRINT10001,IGG(1),IGG(4),IGG(11),IGG(10),FIGG10, XMB
10001 FORMAT(/
     + ' -----> RUN',I6,I10,' EVENTS READ',I4,' SCALER EVENTS',I6,
     + ' (',F6.2,'%) EVENTS WRITTEN (',F7.2,' MBYTE)')
      RETURN
      END
      FUNCTION XMBYTE( IWUNIT )
C----------------------------------------------------------
C  VERSION OF 14/01/87       LAST MOD 16/01/87   E ELSEN
C  COMPUTE MBYTES OUTPUT SINCE LAST CALL ON UNIT IWUNIT
C  ONLY ONE UNIT CAN BE HANDLED
C----------------------------------------------------------
      COMMON / BCS / IW(1)
      DATA IRLCOU / 0 /, LOGUNI / 0 /
      IF( IRLCOU .EQ. 0 ) LOGUNI = IWUNIT
      IF( IWUNIT.NE.LOGUNI ) GO TO 8101
        XMBYTE = 0.
        CALL BLOC( NPBUF, '+BUF', IWUNIT, &8101, IER )
          XMBYTE = 4.E-6*(IW(NPBUF+7) - IRLCOU )
          IRLCOU = IW(NPBUF+7)
 8101 CONTINUE
      RETURN
      END
C
      BLOCK DATA
#include "cutsr1.for"
      DATA NRUNST/0/,NEVTST/0/,NOTTOT/0/,NOTRUN/10*0/,NVRSN/1982/
C
C
C     REDUC1 THRESHOLDS FOR T1-ACCEPT TRIGGERS (1982-DATA)
C     ELGLM(1-4) : ETOT, BARREL THRESHOLDS
C     ELGLM(5-8) : END CAP THRESHOLDS
C
      DATA ELGLM  /6000.,2500.,2000.,1500.,
     ,             4000.,1000., 500., 300./
      END

C   01/08/80 109291144  MEMBER NAME  MEWT3    (JADESR)      FORTRAN
      SUBROUTINE MEWT3(ISTF)
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C FLAGS EVENTS CONTAINING POSSIBLE MUON TRACKS USING THE T3 TRIGGER
C STREET/GROUP INFORMATION IN THE TRIGGER BANK.
C MIN. REQUIREMENT FOR POSSIBLE TRACK IN A STREET IS THAT
C 3/5 GROUPS IN THAT STREET HAVE GIVEN SIGNALS
C THE N3ST SUCH STREETS ARE STORED IN ILIS3.
C THE N4ST STREETS WITH >/= 4/5 GROUPS FIRED ARE STORED IN ILIS4
C NOISY STREETS CAN BE TREATED DIFFERENTLY BY SETTING THE FLAG
C 'NOISY' FOR A NOISY STREET. IN THIS CASE MIN REQUIRENEMT FOR THIS
C STREET IS 4/5 GROUPS FIRED.
C IF A GROUP CONTAINS 1 OR MORE DEAD CHAMBERS,FLAG KAPUT(GROUP,STREET)
C CAN BE SET TO TREAT THIS GROUP AS HAVING FIRED.
C IN THIS VERSION,FOR USE IN REDUC1, KAPUT IS ONLY SET IN THE ENDWALLS.
C
C RETURN FLAG  ISTF :
C                       = -1         NO TRIGGER BANK.
C                       = N4ST = 0,1,2,.....9 NUMBER OF ENDWALL STREETS
C                              WITH >/= 4/5 GROUPS FIRED.
C                              FOR N4ST.GT.9, N4ST IS SET TO 9 &
C                              A WARNING MESSAGE IS PRINTED
C                       = 130 + N4ST, ENDWALL QUADRANTS 1 & 3 EACH
C                         HAVE ONE OR MORE STREETS WITH >/= 3/5
C                         GROUPS FIRED
C                       = 240 + N4ST, ENDWALL QUADRANTS 2 & 4 EACH
C                         HAVE ONE OR MORE STREETS WITH >/= 3/5
C                         GROUPS FIRED
C                       = 400 + N4ST, ALL 4 ENDWALL QUADRANTS CONTAIN
C                         A STREET WITH >/= 3/5 GROUPS FIRED.
C-----------------------------------------------------------------------
#include "cdata.for"
      COMMON /CHEADR/HEAD(17),HRUN,HEV
      LOGICAL*1 NOISY(36)
      LOGICAL*1 KAPUT(5,36)
      LOGICAL*1 IFIR3(36)
      LOGICAL*1 IFIR4(36)
      LOGICAL*1 IQUAD1,IQUAD2,IQUAD3,IQUAD4
      DIMENSION ILIS3(36),ILIS4(36)
      DATA NGR1/3/,NGM1/3/,NGR2/4/,NGM2/4/
      DATA NOISY/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     &           0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/
      DATA KAPUT/0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &           0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &           0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &           0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &           0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &           0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &           0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,
     &           0,0,0,0,0/
C
C..INITIALISE..
      DO 5 I=1,36
      IFIR3(I) = .FALSE.
      IFIR4(I) = .FALSE.
      ILIS3(I) = 0
      ILIS4(I) = 0
    5 CONTINUE
      ISTF = 0
      N3ST = 0
      N4ST = 0
      IQUAD1 = .FALSE.
      IQUAD2 = .FALSE.
      IQUAD3 = .FALSE.
      IQUAD4 = .FALSE.
C
C..FIND POINTER TO TRIGGER BANK..
      MTRIG1 = IDATA (IBLN('TRIG'))
      IF(MTRIG1.EQ.0) GOTO 999
      MTRIG2 = IDATA (MTRIG1 - 1)
      MTRIG3 = IDATA (MTRIG2 - 1)
C..HALF-WORD POINTERS..
      MHTRI1 = 2*MTRIG1
      MHTRI2 = 2*MTRIG2
      MHTRI3 = 2*MTRIG3
C
C..GET 1'ST I*2 T3 WORD..
      IT3 = MHTRI3 + 1
C
C..LOOP OVER T3 STREETS IN ENDWALLS..
      DO 100 IST = 21,36
      NG = 0
      NGG1 = 0
      NGG2 = 0
      ITEM = IT3 + IST
C
C..LOOP OVER GROUPS IN STREET IST..
      DO 40 IGR = 4,8
      IGROUP = 9 - IGR
      IF(KAPUT(IGR,IST)) GOTO 35
      IF(JBIT(HDATA(ITEM),IGR).NE.0) GOTO 40
   35 CONTINUE
      NG = NG + 1
      IF(IGROUP.GE.NGM1) NGG1 = NGG1 + 1
      IF(IGROUP.GE.NGM2) NGG2 = NGG2 + 1
   40 CONTINUE
      IF(NOISY(IST)) GOTO 45
      IF(NG.LT.NGR1.OR.NGG1.LE.0) GOTO 100
C..MIN REQUIREMENT SATISFIED FOR NORMAL STREET..
      N3ST = N3ST + 1
      IFIR3(IST) = .TRUE.
      ILIS3(N3ST) = IST
C
C..NOW SET UP FLAGS FOR ENDWALL QUADRANTS..
      IF(IST.GE.21.AND.IST.LE.24) IQUAD1 = .TRUE.
      IF(IST.GE.25.AND.IST.LE.28) IQUAD2 = .TRUE.
      IF(IST.GE.29.AND.IST.LE.32) IQUAD3 = .TRUE.
      IF(IST.GE.33.AND.IST.LE.36) IQUAD4 = .TRUE.
   45 CONTINUE
      IF(NG.LT.NGR2.OR.NGG2.LE.0) GOTO 100
      N4ST = N4ST + 1
      IFIR4(IST) = .TRUE.
      ILIS4(N4ST) = IST
  100 CONTINUE
      IF(N4ST.LT.10) GOTO 110
      WRITE(6,60) HRUN,HEV,N4ST
   60 FORMAT(1H ,/,' ***** MEWT3 : RUN ',I5,1X,'EVENT ',I5,
     &/,' !!!!! ',I3,' MUON STREETS WITH >/=4/5 GROUPS FIRED.SET TO 9')
      N4ST = 9
  110 CONTINUE
      ISTF = ISTF + N4ST
      IF(IQUAD1.AND.IQUAD4) ISTF = ISTF + 130
      IF(IQUAD2.AND.IQUAD3) ISTF = ISTF + 240
      IF(IQUAD1.AND.IQUAD2.AND.IQUAD3.AND.IQUAD4) ISTF = 400 + N4ST
      RETURN
  999 CONTINUE
      ISTF = -1
      RETURN
      END

C   01/11/84 411011500  MEMBER NAME  RDMRGV   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDMRGV( N1, H1, N2, H2 )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    25/04/79 :  MERGE DRIFT DATA
C
C   LAST MOD  J. HAGEMANN 17/05/83 :  MODIFIED FOR VERTEX CHAMBER DATA
C             R. RAMCKE
C
C      MERGE N1 DRIFT DATA FROM H1 WITH N2 DRIFT DATA FROM H2
C      IN ARRAY H2 IN INCREASING WIRE NUMBER. PROGRAM ASSUMES
C      DATA OF H2 TO START IN H2(N1*4+1).
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION H1(2), H2(2)
C
C------------------  C O D E  ------------------------------------------
C
      IL1 = 1
      IL2 = N1*4 + 1
      IH1 = IL2 - 4
      IH2 = IH1 + N2*4
      ILN = 0
C
C
  100 IF( ILN .GT. IH2 ) GO TO 1000
C
C                            CHECK IF DATA LEFT IN H2
      IF( IL2 .GT. IH2 ) GO TO 400
C
C                            CHECK IF DATA LEFT IN H1
      IF( IL1 .GT. IH1 ) GO TO 500
C
C                            COMPARE WIRE NUMBERS
C                            IF SAME NUMBER COMPARE DRIFT TIMES
      IF( H1(IL1) .LT. H2(IL2) ) GO TO 200
      IF( H1(IL1).EQ.H2(IL2) .AND. H1(IL1+3).LE.H2(IL2+3) ) GO TO 200
C
C                            MOVE DATA FROM END OF H2 TO ILN  POSITION
      CALL MVC( H2, ILN*2, H2, (IL2-1)*2, 8 )
      IL2 = IL2 + 4
      GO TO 300
C
C                            MOVE DATA FROM H1 TO H2 TO ILN POSITION
  200 CALL MVC( H2, ILN*2, H1, (IL1-1)*2, 8 )
      IL1 = IL1 + 4
C
  300 ILN = ILN + 4
      GO TO 100
C
C                          MOVE REST OF H1 DATA TO H2 AFTER ILN POSITION
  400 NL = IH1 - IL1 + 4
      IF( NL .GT. 0 ) CALL MVCL( H2, ILN*2, H1, (IL1-1)*2, NL*2 )
      GO TO 1000
C
C                          MOVE REST OF H1 DATA TO H2 AFTER ILN POSITION
  500 NL = IH2 - IL2 + 4
      IF( NL .GT. 0 ) CALL MVCL( H2, ILN*2, H2, (IL2-1)*2, NL*2 )
C
 1000 RETURN
      END

C   26/01/85 804281002  MEMBER NAME  QCPAPK   (S)           FORTRAN77
      SUBROUTINE QCPAPK( NST, N, IMODE )
C-----------------------------------------------------------
C  VERSION OF 01/06/87       LAST MOD 21/07/87    M ZIMMER
C  ROUTINE FROM E ELSEN
C  ADDITIONAL ENTRY INCLUDED
C  ADDITIONAL PARTICLES INCLUDED FOR B/C TRACEBACK
C  LOAD PALL DATA INTO VECSUB COMMON
C  IMODE=0    CHARGED AND GAMMA
C       =1    CHARGED ONLY
C       =2    CHARGED ONLY, ALL PI
C
C    VECSUB FILLING SCHEME
C   P( 1..7,*)   PX,PY,PZ,E,M,P,CHARGE
C  HP(15   ,*)   NOT USED
C  HP(16   ,*)   PARTICLE TYPE ( JADE MC-CONVENTION )
C  HP(17   ,*)   0 OR PALL NUMBER OF CORRESPONDING LEADING HADRON
C  HP(18   ,*)   QUARK ORIGIN (PARTON PARENT (QUARK OR ANTIQUARK)
C  HP(19   ,*)   PALL NUMBER
C  HP(20   ,*)   PARTICLE ORIGIN (> 0 MEANS ELECTRON )
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON  P(10,100)
      DIMENSION IP(10,100),HP(20,1)
      EQUIVALENCE (IP(1,1),P(1,1),HP(1,1))
C
C     CALL PRPALL( 5)
C
      N = 0
      L = 0
      NPPALL = IW(IBLN('PALL'))
      IF( NPPALL.GT.0 .AND. IW(NPPALL+4).GT.0 ) THEN
         NLUN = IW(NPPALL+4)
         IP0 = NPPALL + IW(NPPALL+1)
         IP9 = IP0 + IW(NPPALL+2)*(NLUN-1)
         DO 1000 LP = IP0, IP9, IW(NPPALL+2)
            L = L + 1
            LPA = 0
            DO 100 JP = IP0, IP9, IW(NPPALL+2)
               IF( IW(JP+8).EQ.L ) THEN
                  LPA = 1
                  GO TO 200
               ENDIF
  100       CONTINUE
  200       CONTINUE
            IF( LPA.EQ.0 ) THEN
               CHARGE = IW(LP+6)
               IF( CHARGE.NE.0. .OR.
     *             (IMODE.EQ.0.AND.IABS(IW(LP+7)).EQ.1) ) THEN
                  N = N + 1
                  P(1,NST+N) = RW(LP+1)
                  P(2,NST+N) = RW(LP+2)
                  P(3,NST+N) = RW(LP+3)
                  PTOT=SQRT(RW(LP+1)**2+RW(LP+2)**2+RW(LP+3)**2)
                  XM = RW(LP+5)
                  HP(16,NST+N) = IABS(IW(LP+7))
                  IF( IMODE.EQ.2.AND.CHARGE.NE.0. ) THEN
                     XM = .1396
                     HP(16,NST+N) = 0
                  ENDIF
                  P(4,NST+N) = SQRT( PTOT**2 + XM**2 )
                  P(5,NST+N) = XM
                  P(6,NST+N) = PTOT
                  P(7,NST+N) = CHARGE
                  HP(15,NST+N) = 0
                  HP(17,NST+N) = 0
                  JPP = IW(LP+9)
                  IF (JPP .GT. 1 ) JPP = -1
                  HP(18,NST+N) = JPP
                  HP(19,NST+N) = L
                  HP(20,NST+N) = 0
C                                           CATEGORIZE
                  IFC = MAX0( IABS(IW(NPPALL+9))-2, 1 )
                  ISC = 1
                  J = L
C                                      CURENT PARTICLE
                  IPCUR = LP
                  JCUR = L
  350             CONTINUE
C                                      NO PARTONS
                  IF( IABS(IW(IPCUR+7)) .LT. 1500 ) THEN
C                                      SELECT IN.STATE GAMMA (GETS -31)
                  IF( IW( IPCUR + 8 ) .EQ. 0 ) GOTO 404
C     PRINT *,'1  IPCUR= ',IPCUR,' IPPAR = ',IPPAR,' L= ',L,' N=',N
C                                      LOOK FOR PARENT,GRANDPARENT ...
C                                      POINTER TO PARENT IS JP
                     IPPAR = IP0 + (IW(IPCUR+8)-1)*IW(NPPALL+2)
C     PRINT *,'2  IPCUR= ',IPCUR,'IPPAR = ',IPPAR
C                                      STOP IF PARENT IS A PARTON
                     IF( IW(IPPAR+8) .EQ. 0 .OR. ISC .GT. 1)  GOTO 404
C
                     JCUR = IW( IPCUR+8 )
                     IPCUR = IPPAR
C                                      PART. TYPE OF PARENT PARTICLE
                     KF = MOD(IABS( IW(IPPAR+7) ), 1000 )
C
                     IF( KF.LT.100 ) GO TO 300
                     IF( (101 .GT. KF .OR. KF .GT. 104) .AND.
     *                   (123 .GT. KF .OR. KF .GT. 126) .AND.
     *                   (145 .GT. KF .OR. KF .GT. 158) .AND.
     *                   (241 .GT. KF .OR. KF .GT. 246) .AND.
     *                   (293 .GT. KF .OR. KF .GT. 307)
     *                   )   GOTO 300
C                                           THIS IS A B-HAD
                         ISC = 3
                         GO TO 400
  300                 IF( ( 20 .GT. KF .OR. KF .GT.  22) .AND.
     *                    ( 30 .GT. KF .OR. KF .GT.  32) .AND.
     *                    ( 51 .GT. KF .OR. KF .GT.  56) .AND.
     *                    ( 58 .GT. KF .OR. KF .GT.  60) .AND.
     *                    ( 71 .GT. KF .OR. KF .GT.  80)
     *                    )   GO TO 400
C                                           THIS IS A C-HAD
                         ISC = 2
  400                 GOTO 350
  404                 CONTINUE
                      HP(17,NST+N) = JCUR
                      HP(20,NST+N) =-(10*IFC+ISC)
                      IF( IFC.EQ.ISC ) HP(20,NST+N) = -ISC
                      IF( HP(16,NST+N).EQ.2)HP(20,NST+N)=-HP(20,NST+N)
                    ENDIF
                ENDIF
             ENDIF
 1000    CONTINUE
      ENDIF
      RETURN
C
C
      ENTRY QCJEPU( NSJET, NJET, IMD )
C------------------------------------------------------
C   UNPACK JETS AND STORE AS PARTICLES
C   FLAVOR CODE IS 1-5 FOR U,D,S,C, AND B
C------------------------------------------------------
C
C    VECSUB FILLING SCHEME
C   P( 1..7,*)   PX,PY,PZ,E,M,P,CHARGE
C  HP(15   ,*)   NOT USED
C  HP(16   ,*)   QUARK FLAVOUR( 0 = GLUON )
C  HP(17   ,*)   NOT USED
C  HP(18   ,*)   NOT USED
C  HP(19   ,*)   PALL NUMBER
C  HP(20   ,*)   ABS( QUARK FLAVOUR )
C-----------------------------------------------------------
C
      NJET = 0
      L = 0
      NPPALL = IW(IBLN('PALL'))
      IF( NPPALL.GT.0 .AND. IW(NPPALL+4).GT.0 ) THEN
         NLUN = IW(NPPALL+4)
         IP0 = NPPALL + IW(NPPALL+1)
         IP9 = IP0 + IW(NPPALL+2)*(NLUN-1)
         DO 2000 LP = IP0, IP9, IW(NPPALL+2)
            L = L + 1
            KF = MOD( IABS(IW(LP+7)), 1000 )
            IF( KF.GE.500 .AND.KF.LE.506 ) THEN
               IFL = KF - 500
               CHARGE = -1./3.
               IF( IFL.EQ.1 .OR.IFL.EQ.4 .OR. IFL .EQ.6 ) CHARGE = 2./3.
               IFL = IFL*ISIGN(1,IW(LP+7))
               IF( IFL.LT.0 ) CHARGE = -CHARGE
               NJET = NJET + 1
               PTOT = SQRT(RW(LP+1)**2+RW(LP+2)**2+RW(LP+3)**2)
               P(1,NSJET+NJET) = RW(LP+1)
               P(2,NSJET+NJET) = RW(LP+2)
               P(3,NSJET+NJET) = RW(LP+3)
               P(4,NSJET+NJET) = RW(LP+4)
               P(5,NSJET+NJET) = RW(LP+5)
               P(6,NSJET+NJET) = PTOT
               P(7,NSJET+NJET) = CHARGE
               HP(16,NSJET+NJET) = IFL
               HP(17,NSJET+NJET) = 0
               HP(18,NSJET+NJET) = 0
               HP(19,NSJET+NJET) = L
               HP(20,NSJET+NJET) = IP(8,NSJET+NJET)
            ENDIF
 2000    CONTINUE
      ENDIF

      RETURN
      ENTRY QCFRPU( NSFRG, NFRG, IMD )
C------------------------------------------------------
C   UNPACK PARTICLES PRODUCED BY FRAGMENTATION ( PARENTS ARE PARTONS )
C   FLAVOR CODE IS 3 FOR B-HADRONS, 2 FOR C-HADRONS AND 1 FOR OTHERS )
C------------------------------------------------------
C
C    VECSUB FILLING SCHEME
C   P( 1..7,*)   PX,PY,PZ,E,M,P,CHARGE
C  HP(15   ,*)   NOT USED
C  HP(16   ,*)   PARTICLE TYPE ( JADE MC-CONVENTION )
C  HP(17   ,*)   NOT USED
C  HP(18   ,*)   QUARK ORIGIN (PARTON PARENT )
C  HP(19   ,*)   PALL NUMBER
C  HP(20   ,*)   21,31=FRAGMENTATION 2=C 3=B LEADING HADRON
C-----------------------------------------------------------

      NFRG = 0
      L = 0
      NPPALL = IW(IBLN('PALL'))
      IF( NPPALL.GT.0 .AND. IW(NPPALL+4).GT.0 ) THEN
         NLUN = IW(NPPALL+4)
         IP0 = NPPALL + IW(NPPALL+1)
         IP9 = IP0 + IW(NPPALL+2)*(NLUN-1)
         DO 1400 LP = IP0, IP9, IW(NPPALL+2)
            L = L + 1
            IPPAR = IP0 + (IW(LP+8)-1) * IW(NPPALL+2)
            KFPAR = MOD( IABS(IW(IPPAR+7)), 1000 )
            IF( KFPAR.GE.500 .AND.KFPAR.LE.506 ) THEN
               KF = MOD( IABS( IW( LP+7 )), 1000 )
               ICODE = 1
               IF( KF.LT.100 ) GO TO 4300
               IF( (101 .GT. KF .OR. KF .GT. 104) .AND.
     *             (123 .GT. KF .OR. KF .GT. 126) .AND.
     *             (145 .GT. KF .OR. KF .GT. 158) .AND.
     *             (241 .GT. KF .OR. KF .GT. 246) .AND.
     *             (293 .GT. KF .OR. KF .GT. 307)
     *                  )   GOTO 4300
C                                           THIS IS A B-HAD
                 ICODE = 3
                 GO TO 4400
 4300          IF( ( 20 .GT. KF .OR. KF .GT.  22) .AND.
     *             ( 30 .GT. KF .OR. KF .GT.  32) .AND.
     *             ( 51 .GT. KF .OR. KF .GT.  56) .AND.
     *             ( 58 .GT. KF .OR. KF .GT.  60) .AND.
     *             ( 71 .GT. KF .OR. KF .GT.  80)
     *             )   GO TO 4400
C                                          THIS IS A C-HAD
                 ICODE = 2
 4400          CONTINUE
               NFRG = NFRG + 1
               PTOT = SQRT(RW(LP+1)**2+RW(LP+2)**2+RW(LP+3)**2)
               CHARGE = IW(LP+6)
               P(1,NSFRG+NFRG) = RW(LP+1)
               P(2,NSFRG+NFRG) = RW(LP+2)
               P(3,NSFRG+NFRG) = RW(LP+3)
               P(4,NSFRG+NFRG) = RW(LP+4)
               P(5,NSFRG+NFRG) = RW(LP+5)
               P(6,NSFRG+NFRG) = PTOT
               P(7,NSFRG+NFRG) = CHARGE
               HP(15,NSFRG+NFRG) = 0
               HP(16,NSFRG+NFRG) = KF
               HP(17,NSFRG+NFRG) = 0
               HP(18,NSFRG+NFRG) = IW(LP+9)
               HP(19,NSFRG+NFRG) = L
               HP(20,NSFRG+NFRG) = ICODE
            ENDIF
 1400    CONTINUE
      ENDIF

      RETURN
      END

C   07/04/82 311291534  MEMBER NAME  RNEXP0   (S)           FORTRAN
C
      FUNCTION RNEXP0(A)
C
C       GENERATES A RANDOM NUMBER WHICH DISTRIBUTES AS EXP(A*X)
C               A : A PARAMETER OF THE DISTRIBUTION
C               XMIN : THE MINIMUM VALUE OF THE RANDUM NUMBER
C               XMAX : THE MAXIMUM VALUE OF THE RANDUM NUMBER
C                              S. ODAKA    5-NOV-'79
C
      IF(A.GT.0.) A=-A
      RNEXP0=ALOG(1.-RN(DUM))/A
      RETURN
      END

C   09/12/87 712091733  MEMBER NAME  TPVISE   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPVISE( NP, ITRNA, EVISC, EVISN, SIGEC, SIGEN )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       9/12/87:  Do visible E calculations
C
C
C
C     Routine to calculate charged and neutral energy and errors.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     NP        In       I*4      No. of particles in ITRNA array
C     ITRNA     In       I*4      Array of particle (TPTR) numbers
C
C     EVISC     Out      R*4      Charged visible energy (GeV)
C     EVISN     Out      R*4      Neutral visible energy (GeV)
C     SIGEC     Out      R*4      Sigma(charged visible energy)
C     SIGEN     Out      R*4      Sigma(neutral visible energy)
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      INTEGER  NP
      INTEGER  ITRNA(200)

C------------------  C O D E  ------------------------------------------

C                            Clear running charged and neutral energies
C                            and corresponding variances.

      EVISC  = 0.0
      EVISN  = 0.0
      VEVISC = 0.0
      VEVISN = 0.0

C                            Loop over all primary tracks using ITRNA

      DO  10  I = 1,NP

        CALL CLOC( ITPTR, 'TPTR', ITRNA(I) )

        IF( ITPTR .GT. 0 ) THEN

          CHARGE = ADATA( ITPTR + 23 )
          PTOT   = ADATA( ITPTR + 24 )
          SIGP   = ADATA( ITPTR + 25 )
          ETOT   = ADATA( ITPTR + 36 )
          SIGESH = ADATA( ITPTR + 38 )

          IF( CHARGE .EQ. 0.0 ) THEN

            EVISN  = EVISN  + ETOT
            VEVISN = VEVISN + SIGESH**2

          ELSE

            EVISC  = EVISC  + ETOT
            VEVISC = VEVISC + ( PTOT * SIGP / ETOT )**2

          ENDIF

C                            Compute errors on visible energies

          SIGEC   = SQRT( VEVISC )
          SIGEN   = SQRT( VEVISN )

        ELSE

C                            TPTR bank is missing!

          CALL TPERRH

        ENDIF

  10  CONTINUE

      RETURN
      END

C   22/02/79 705211106  MEMBER NAME  PREVTX   (JADEGS)      FORTRAN
      SUBROUTINE PREVTX
C
      INTEGER*2 HDATA
#include "cdata.for"
      COMMON /CWORK1/ NT,T(500)
      DIMENSION IT(2)
      EQUIVALENCE (T(1),IT(1))
C        CONSTANTS
      DATA SIGX0/.14/, SIGZ0/20./, H03/.15/, X0INN/.153/
C
      NT = 0
      IP = IDATA(IBLN('PATR'))
      IF(IP.EQ.0) RETURN
      NT = IDATA(IP+2)
      IF(NT.LE.0) RETURN
      L0 = IDATA(IP+1)
      LT = IDATA(IP+3)
C
      KT = IP + L0
      JT = 0
      DO 19 I=1,NT
      IT(JT+1) = 0
C        MOST OF THE FOLLOWING TRACK REJECT CRITERIA ARE DUE
C        TO FAULTS IN PATTERN RECOGNITION
      IF(IDATA(KT+48).NE.0) GOTO 18
      IF(ADATA(KT+25).EQ.0.) GOTO 18
      PT = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      IF(PT.EQ.0.) GOTO 18
      IF(ADATA(KT+10).EQ.0.) GOTO 18
      T(JT+2) = -1. / ADATA(KT+25)
      T(JT+3) = ATAN2(ADATA(KT+9),ADATA(KT+8))
      TTH = ADATA(KT+10) / PT
      CTH = 1. / SQRT(1.+TTH**2)
      T(JT+4) = ATAN(TTH)
      T(JT+5) = ADATA(KT+5)
      T(JT+6) = ADATA(KT+6)
      T(JT+7) = ADATA(KT+7)
      SIGX = ADATA(KT+23)
      SIGZ = ADATA(KT+32)
      XNPT = IDATA(KT+24)
      ZNPT = IDATA(KT+33)
      IF(SIGX.EQ.0..OR.SIGZ.EQ.0..OR.XNPT.EQ.0..OR.ZPNT.EQ.0.) GOTO 18
      PROJL = ABS((ADATA(KT+14)-ADATA(KT+7))/TTH)
      IF(PROJL.LT.200.) GOTO 18
      T(JT+8) = SIGX * 14./(PROJL*SQRT(XNPT))
      T(JT+9) = SIGZ * 4.*CTH**2/(PROJL*SQRT(ZNPT))
      T(JT+10) = SIGX * 3./(SQRT(XNPT)*SIN(T(JT+3)))
      T(JT+11) = SIGX * 3./(SQRT(XNPT)*COS(T(JT+3)))
      T(JT+12) = SIGZ * SQRT(6./ZNPT)
      IT(JT+13) = IDATA(KT+24)
      T(JT+14) = 0.
      T(JT+15) = 0.
C     PRINT 118, I,(ADATA(KT+II),II=5,10),ADATA(KT+25),XNPT,ZNPT,SIGX,
C    *           SIGZ
C     PRINT 118, I,(T(JT+II),II=3,12)
C 118 FORMAT(I5,11E11.3)
C
      IF(SIGX.GT.10.*SIGX0) GOTO 18
      IF(SIGZ.GT.10.*SIGZ0) GOTO 18
      IT(JT+1) = 1
   18 JT = JT + 15
   19 KT = KT + LT
C
      JT = 0
      DO 29 I=1,NT
      IF(IT(JT+1).EQ.0) GOTO 29
      PT = H03*T(JT+2)
      BETA = 1.
      TH2 = (15./(PT*BETA))**2 * X0INN * COS(T(JT+4))
      T(JT+8) = SQRT(T(JT+8)**2+TH2)
      T(JT+9) = SQRT(T(JT+9)**2+TH2)
   29 JT = JT + 15
C
      RETURN
      END

C   12/03/84 406222023  MEMBER NAME  TAGSTO   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE TAGSTO(ICLST,IPOINT,IERTAG)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE STORES THE ACCUMLATED RESLUTS OF THE TAGGING ANALYSIS ROU
C IN THE RELEVANT BOS BANKS ('ACLS','TAGG')
C
C
C ICLST - INPUT - NUMBER OF CLUSTERS FOUND
C IPOINT - INPUT - FINAL VALUE OF APOINT ,AND THEREFORE REQUIRED FOR 'AC
C
C IERTAG - OUTPUT - SET TO ONE IF AT LEAST ONE BANK COULD NOT
C                     BE CREATED DUE TO SPACE PROBLEMS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C N.B. DO NOT REPLACE WITH CTAGGO - DIFFERENT NAMES !
C
       COMMON / CACLS  / ACLUS(70)
       COMMON / CTAGG0 / TAGG0(34)
       COMMON / CTAGG1 / TAGG1(20)
       COMMON / CTAGG2 / TAGG2(260)
C
C
C--------------------------- C O D E -----------------------------------
C
C
      IERTAG = 0
C
C SET UP THE LENGTHS OF THE VARIOUS BANKS
C
       NWAC = IPOINT - 1
       NWT0 = 34
       IF ( (ICLST .LT. 0) .OR. (ICLST .GT. 20) ) GOTO 999
       NWT1 = ICLST
       NWT2 = ICLST * 13
C
C    DELETE OLD BANKS
C
       CALL BDLS('ACLS',0)
       CALL BDLS('TAGG',1)
       CALL BDLS('TAGG',2)
       CALL BDLS('TAGG',0)
C
C CREATE THEN FILL NEW BANKS
C
   10  IF ( NWAC .EQ. 0 ) GOTO11
C
C 'ACLS'
C
       CALL BCRE(IND,'ACLS',0,NWAC,*1000,IER)
       CALL BSAW(1,'ACLS')
       CALL BSTR(IND,ACLUS,NWAC)
  11   IF ( NWT0 .EQ. 0 ) GOTO 12
C
C 'TAGG' 0
C
       CALL BCRE(IND,'TAGG',0,NWT0,*1001,IER)
       CALL BSAW(1,'TAGG')
       CALL BSTR(IND,TAGG0,NWT0)
  12   IF ( NWT1 .EQ. 0 ) GOTO13
C
C 'TAGG' 1
C
       CALL BCRE(IND,'TAGG',1,NWT1,*1002,IER)
       CALL BSTR(IND,TAGG1,NWT1)
  13   IF ( NWT2 .EQ. 0 ) GOTO14
C
C 'TAGG' 2
C
       CALL BCRE(IND,'TAGG',2,NWT2,*1003,IER)
       CALL BSTR(IND,TAGG2,NWT2)
   14  RETURN
C
C ERROR MESSAGES
C
 1000  WRITE(6,600)
  600  FORMAT('  NOT ENOUGH SPACE FOR ACLS ')
       IERTAG = 1
       GOTO 11
 1001  WRITE(6,601)
  601  FORMAT('  NOT ENOUGH SPACE FOR TAGG 0 ')
       IERTAG = 1
       GOTO 12
 1002  WRITE(6,602)
  602  FORMAT('  NOT ENOUGH SPACE FOR TAGG 1 ')
       IERTAG = 1
       GOTO 13
 1003  WRITE(6,603)
  603  FORMAT('  NOT ENOUGH SPACE FOR TAGG 2 ')
       IERTAG = 1
       GOTO 14
  999  WRITE(6,609)
  609  FORMAT(1X,'INVALID NUMBER OF CLUSTERS GIVEN AS ARGUMENT',
     1           ' TO TAGSTO - NOTHING STORED IN TAG TP BANKS  ')
       RETURN
       END

C   03/11/78 807251259  MEMBER NAME  IDATTM   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      FUNCTION IDATTM( NEW )
C-----------------------------------------------------------------------
C
C
C   AUTHOR:    S. YAMADA      3/11/78 : GIVES DATE AND HOUR
C
C LAST MOD:    C. BOWDERY    25/07/88 : CORRECT FOR LEAP YEARS AFTER 84
C
C
C     GIVES DATE AND TIME
C
C-----------------------------------------------------------------------
C
      INTEGER  IDTN(5), LENMON(12)
      DATA     LENMON  / 31,28,31,30,31,30,31,31,30,31,30,31 /
      DATA     IDTO / 0 /
C
C------------------  C O D E  ------------------------------------------
C
C
      IF( NEW .NE. 0  .AND.  IDTO .GT. 0 ) GO TO 100
C
C                            GET DATE AND TIME
C                            IDTN(1) =  YEAR (2 DIGITS)
C                            IDTN(2) =  DAY OF THE YEAR
C                            IDTN(3) =  HOURS
C                            IDTN(4) =  MINUTES
C                            IDTN(5) =  SECONDS
C
      CALL DAY2(IDTN)
C
      IYEAR = IDTN(1)
      IDAYY = IDTN(2)
      IHOUR = IDTN(3)
C
C                            FEBRUARY: SPECIAL TREATMENT FOR LEAP YEARS
C
      IF( MOD( IYEAR, 4 ) .EQ. 0 ) GO TO 1
        LENMON(2) = 28
        GO TO 2
C
    1   LENMON(2) = 29
C
C                            EVALUATE MONTH.
C
    2 IDAY = IDAYY
      DO  11  MONTH = 1,12
        IF( IDAY .LE. LENMON( MONTH ) ) GO TO 12
        IDAY = IDAY - LENMON( MONTH )
   11 CONTINUE
C
   12 IDTO = IYEAR*1000000 + MONTH*10000 + IDAY*100 + IHOUR
C
  100 IDATTM = IDTO
      RETURN
      END

C   08/08/79 C9090501   MEMBER NAME  ANOM31   (S)           FORTRAN
      SUBROUTINE ANOM31(IRUN)
C---  ANOMALIES OF RUNS 1084 - 1121
C---  13.86 GEV      JULY 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     05.09.79     13:00
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,13,1095,
     &      1096,1097,1098,1099,13,13,1102,1103,1104,1105,1106,1107,13,
     &      13,13,13,13,13,1114,1115,1116,1117,1118,1119,1120,1121),IRUN
   13 RETURN
C
 1084 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1085 PRELIMINARY
 1085 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1086 PRELIMINARY
 1086 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1087 PRELIMINARY
 1087 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
C
      RETURN
C
C1088 PRELIMINARY
 1088 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
 1089 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1090 PRELIMINARY
 1090 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1091 PRELIMINARY
 1091 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1092 PRELIMINARY
 1092 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1093 PRELIMINARY
 1093 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1095 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1096 PRELIMINARY
 1096 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1097 PRELIMINARY
 1097 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1098 PRELIMINARY
 1098 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1099 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1102 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 350
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(185) = .TRUE.
C
      RETURN
C
C1103 PRELIMINARY
 1103 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
C
      RETURN
C
C1104 PRELIMINARY
 1104 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
C
      RETURN
C
C1105 PRELIMINARY
 1105 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
C
      RETURN
C
 1106 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(7) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1107 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1114 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1115 PRELIMINARY
 1115 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1116 PRELIMINARY
 1116 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1117 PRELIMINARY
 1117 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1118 PRELIMINARY
 1118 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1119 PRELIMINARY
 1119 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1120 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1121 PRELIMINARY
 1121 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
      END

C   22/01/88 808021742  MEMBER NAME  CALCOR   (SOURCE)      FORTRAN


C        CORRECTION OF SYSTEMATIC EFFECTS IN THE LG-CALIBRATION
C        FOR THE BARREL PART

C        ROUTINE CALLED BY LGANAL

C          WRITTEN BY D.PITZL 22.1.88

C=======================================================================
      SUBROUTINE  CALCOR
C=======================================================================


      IMPLICIT INTEGER *2 (H)
C PMF 26/11/98  'jadelg.source.for' replaced by 'clgwork1.for'
C               (see lganal.F)
C include "'jadelg.source.for"
C     USED IN LGANAL PART OF PROGRAMS
C        NO CUTS ON MAX FIRIED #CHANNELS (I.E. DIMENSION=2880)
C        CHANGE SIZE OF THE CLUSTER BANK TO 16.. 13/6/80
C        CHANGED BY Y.WATANABE ON 23/09/79. 00:30
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,
     3               MAPCL(81),  CLPRP(1280)
      INTEGER *2 HMAPCL(2,81)
      DIMENSION ICLSPR(16,80),CLSPRP(16,80), CLMPRP(1361)
      EQUIVALENCE (HMAPCL(1,1),MAPCL(1)), (CLMPRP(1),MAPCL(1))
      EQUIVALENCE (ICLSPR(1,1),CLPRP(1)),  (CLSPRP(1,1),CLPRP(1))
C

C     COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
C    1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
C    2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,
C    3               MAPCL(81),  CLPRP(1280)
C     INTEGER *2 HMAPCL(2,81)
C     DIMENSION ICLSPR(16,80),CLSPRP(16,80), CLMPRP(1361)
C     EQUIVALENCE (HMAPCL(1,1),MAPCL(1)), (CLMPRP(1),MAPCL(1))
C     EQUIVALENCE (ICLSPR(1,1),CLPRP(1)),  (CLSPRP(1,1),CLPRP(1))
C
C---       IF ALGN - BANK IS PRESENT IT HAS 3 HEADER WORDS AND ONE
C          WORD FOR EACH BLOCK ( I.E. TWO HALFWORDS WITH BLOCK # AND
C          ENERGY IN MEV )

      DATA  NCALLS / 0 /

      IF ( NCALLS .EQ. 0 ) PRINT 3355
      NCALLS = 1

 3355 FORMAT ( T2,'JADELG.LOAD (CALCOR) IS CALLED FROM LGANAL',
     +   ', PERFORMS LG-CALIBRATION CORRECTION ON ALGN-BANK')


      NHIT = LNG - 3

CCC   PRINT 1144, NHIT
 1144 FORMAT ( /T2,' CALCOR: # OF BLOCKS IN ALGN-BANK = ',I6,
     +  /T2,' BLOCK#  RING       MEV     FCORR       MEV')

      IF ( NHIT .LT. 1 ) GOTO 90

      DO 80 I=1,NHIT
         IBLO  = HLGADC ( 1, I )
         IF ( IBLO .GT. 2687 ) GO TO 80
C---                                         BARREL PART HERE
         MEV   = HLGADC ( 2, I )
         RMEV  = FLOAT ( MEV )
         IRING = MOD ( IBLO , 32 )

         RMEV0 = RMEV
         CALL BBCORR ( IRING, FCORR )
         RMEV = RMEV * FCORR

         MEV  = INT ( RMEV )
         HLGADC ( 2, I ) = MEV

CCC      PRINT 1155, IBLO, IRING, RMEV0, FCORR, RMEV

  80  CONTINUE
  90  CONTINUE

 1155 FORMAT ( T2,2I6, F10.1, F10.3, F10.1 )

C---                           INCREASE HNORML TO INDICATE CALIBRATION
C                              CORRECTION WAS DONE
      HNORML = HNORML + 12000

      RETURN
      END

C   04/11/81 809081600  MEMBER NAME  $HIST    (SOURCE)      FORTRAN
C
C   04-11-81   16:00      CHANGED MEMBERS (DEBUGGED)
C        ELGOBS, ENGLOS
C
C   11-12-81   XX:00      CHANGED MEMBERS
C        POSENDN          NEW VERSION OF POSEND.(DEBUGGED BY TAKEDA)
C
C   14-12-81   09:00      CHANGED MEMBERS
C        LGMESG           MODIFIED FOR DETAIED MESSAGE.
C
C   14-12-81   16:25      CHANGED MEMBERS
C        POSEND           DEBUGGED.    ENERGY CORRECTION WAS NOT
C                         CORRECT FOR END-CAP CLUSTER < 600 MEV.
C                         THE OLD VERSION WAS RENAMED AS POSEND0.
C   14-12-81   16:25
C        LGECOR           ENERGY LOSS WAS INCORPOLATED FOR THE END-
C                         CAP CLUSTERS.  THE THICKNESS OF MATERIALS
C                         IN FRONT OF LEAD GLASS IS 1.17 X0.
C                         ALSO THE THICKNESS OF MATERIALS FOR
C                         BARREL PART WAS CHANGED.
C                            OLD THICKNESS   7.88 CM
C                            NEW THICKNESS   0.97*8.9 CM
C   13-06-81   21:45      CHANGED
C        LGECOR           CORRECTION FOR FINE POSITION DEPENDENCE IN
C                         BARREL PART WAS CHANGED TO USE A NEW ROUTINE
C                         'BRLGN' INSTEAD OF 'LGPOSC'.
C                         THE ITERATION METHOD OF ENERGY CORRECTION
C                         WAS ALSO CHANGED.
C                         THE OLD VERSION WAS RENAMED AS 'LGECOR1'.
C   14-06-82   14:40      CHANGED AND LOAD
C       LGADCD            IF THE LG-DATA IS EMPTY, RETURN AFTER
C                         THE LNGTH IS PRINTED.
C   06-09-82   13:40      NEW LGINIT IS LOADED. COMMON /CLGPRM/ IS
C                         MODIFIED TO INCLUDE JCALFL.
C   12-10-82   15:00      DEAD COUNTER INFORMATION UPDATED.
C     LGDEAD              TAKEDA
C   20-08-84    9:00      NEW LG...
C   24-01-86   11:00      CORRECTED VERSIONS FROM M.KUHLEN INSTALLED.
C     LGANAL,LGERSE       OLD VERSION NOW LGANAL0,LGERSE0    J.OLSSON
C   03-09-86   20:30      CORRECTED BUG IN LGCDIR (MC CLUSTERS).
C     LGCDIR              OLD VERSION NOW LGCDIR0            J.OLSSON
C   16-09-86   19:00      ADDED SEVERAL DEAD COUNTERS TO THE
C     LGDEAD              LGDEAD LIST. #753 IS DEAD SINCE 1984
C                         ALREADY !                        N.MAGNUSSEN
C   19-01-87   15:00      UPDATED ELGOBS TO CORRECT MATERIAL THICKNESS
C     ELGOBS              IN FRONT OF BARREL. ENDCAP LOSS ALSO INCLUDED
C                         OLD VERSION = ELGOBS0            J.OLSSON
C   21-12-87   21:00      UPDATED ENGLOS,LGECOR,LGCLPB, ADDED NEW SUB-
C     ENGLOS,ETC...       ROUTINES LKCORR,ENLOSG,THCORR,BBLEAK.
C                         AS PRESENTED IN JADE MEETING 14.12.87
C                         OLD VERSIONS LGECOR0,ENGLOS0,LGCLPB0
C                            J.O. D.P.
C   14-01-88   10:30      LGECOR WAS CHANGED 12.19 13.1.88 BY MISTAKE
C     LGECOR              THE VERSION EXISTED TILL 14.1.88, 1030 AND DID
C                         NOT PERFORM CORRECTIONS AS IT SHOULD. PRESENT
C                         VERSION IDENTICAL TO OLD ONE FROM 21.12.87
C                            J.O. D.P.
C   06-04-88   17:30      SECOND HALFWORD IN ALGN-BANK ( HNORML IN
C     LGCLPB              WORK-COMMON ) STEERS CALL TO BBLEAK. D.PITZL
C   22-06-88   16:30      NEW CORRECTION VALUES IN THCORR FROM GEANT-MC
C     THCORR              ESPECIALLY FOR YEARS 79-82.          D.PITZL
C   11-07-88   11:00      CHANGED LGECOR TO AGREE WITH NEW VERSION OF
C     LGECOR              THCORR                               D.PITZL
C   25-07-88   12:15      IDATTM SCRATCHED. IT HAS A BUG; AN IDENTICAL
C     IDATTM              VERSION ON F11LHO.JADEGS/GL IS UPDATED J.O.
C   02-08-88   17:00      NEW VERSIONS OF SEVERAL ROUTINES FOR BETTER
C                         PHOTON RECONSTRUCTION (D.PITZL)
C     LGANAL9             LGANAL9 CALLS CALCOR
C       CALCOR            CALCOR PERFORMS LG CALIBRATION CORRECTION
C         BBCORR          BBCORR HAS CALIBRATION CORRECTION CONSTANTS
C       LGCLPB9           LGCLPB9 RESET TO VERSION BEFORE 12/87.
C     LGCDIR9             LGCDIR9 PASSES # OF BLOCKS TO LGECOR9
C       LGECOR9           LGECOR9 HAS # OF BLOCKS AS ARGUMENT
C                         FOR CHARGED CLUSTERS: ENGLOS, ANGBAR, BRLGN
C                         FOR PHOTONS IN DATA AND SHOWER-MC: ENCORR,
C                                              THCOFA
C                         FOR PHOTONS IN MEI-MAG-MC: ENGLOS, THCORR,
C                                      THCOFA, ANGBAR
C         ENCORR          ENERGY CORRECTION FOR PHOTONS
C         THCOFA          THRESHOLD CORRECTION FOR 1- AND MORE BLOCK
C                         PHOTONS ( T.OEST)
C   12-08-88   10:20      REMOVED BUG FOR PHOTONS WITH |COS THETA|
C     ENCORR, THCOFA      > 0.80                   T.OEST, D.PITZL
C   08-09-88   16:00      LOADED LGDEAD, THIS WAS NOT DONE SINCE
C     LGDEAD              AUG 85                   T.OEST, D.PITZL

C   31/10/79 001151508  MEMBER NAME  ANO110   (S)           FORTRAN
      SUBROUTINE ANO110(IRUN)
C---  ANOMALIES OF RUNS 2033 - 2041
C---  15.71 GEV      OCTOBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     15.01.80     15:05
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (2033,13,13,2036,2037,13,13,2040,2041),IRUN
   13 RETURN
C
 2033 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 135
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
C2036 PRELIMINARY
 2036 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
C2037 PRELIMINARY
 2037 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2040 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(183) = -1
      LIMIT(183) = 120
      KCONST(190) = -1
      LIMIT(190) = 120
C
      RETURN
C
 2041 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(101) = -1
      LIMIT(101) = 135
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
      END

C   03/03/80 008141453  MEMBER NAME  TOFCL2                 FORTRAN
      SUBROUTINE TOFCL2(NCN,LTRK,NFLG)
      INTEGER *2 HADC,HTDC,HB
      REAL *8 DYC1,DYC2
      COMMON/TFPRM/ NRNC1,NRNC2,DYC1,DYC2,IFLC(42),CM(42),CP(42),
     -DTAU(42),WM(42),WP(42),SV(42),DM(42),DP(42),PEDLM(42),PEDLP(42)
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IRELT(14,50)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HB(42)
C
      TRANS= SV(NCN)
      DTAU1= DTAU(NCN)
      Z1= TRK(1,LTRK)
      TAUP1= RAW(3,NCN)+Z1/TRANS
      TAUM1= RAW(2,NCN)-Z1/TRANS
      NFLG= -1
          IF(HTDC(1,NCN).GT.10.AND.HTDC(1,NCN).LT.2048) GO TO 320
            GO TO 360
C
 320        IF(HTDC(2,NCN).GT.10.AND.HTDC(2,NCN).LT.2048) GO TO 330
            GO TO 360
C
  330 IF(ABS(TAUM1-TAUP1).LE.3.*DTAU1) GO TO 350
  350 NFLG= 1
  360 RETURN
      END

C   05/10/82 403081420  MEMBER NAME  KALIB    (JADESR)      FORTRAN
      SUBROUTINE KALCOP(INPU,IOUT)
      IMPLICIT INTEGER*2 (H)
C---
C---     SIMPLE COPY.
C---                                   L.H. O'NEILL 10.09.79
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 9)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
      DATA NAME/'MUCA','LGMA','TAGS','JTPL','JTAB','TOFC','LGST','DEDX',
     1          'SPTG'/
C---
      NREC=0
    1 CONTINUE
      CALL EVREA1(INPU,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
C
C
C     IF(NWORD.LE. 9) GOTO 10
C     IF(JBUF(8).GT. 0) GOTO 10
C        ITIM = JBUF(6)
C        CALL CVDTRN(IRUN,ITIM)
C        JBUF(8) = IRUN
   10 CONTINUE
      IF(JBUF(1).EQ.NAME(2) .AND. JBUF(8).EQ.   0) JBUF(8) = JBUF(6)
   50 CONTINUE
      CALL KALBNK(IOUT,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.',
     +'     (KALCOP F 101)')
      RETURN
 2000 CONTINUE
      WRITE(6,102) INPU,NREC
  102 FORMAT('0NORMAL EOF ON UNIT #',I2,' AFTER',I6,' RECORDS',
     +'  -  DSN=F11LHO.KALWRK0',10X,'(KALCOP F 102)')
      RETURN
      END
      SUBROUTINE KORDER
      IMPLICIT INTEGER*2 (H)
C---
C---     PUTS CALIBRATION UPDATE RECORDS INTO INCREASING TIME ORDER.
C---     INPUT/OUTPUT: UNIT #8/#9
C---                                   W.BARTEL  18.09.82
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      DIMENSION HTIME(6),HDAT(3),HCAT(1)
      COMMON/CORDER/NRECW,LIST(2,10000)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
      EQUIVALENCE(HDAT(1),IDAT(1))
      EQUIVALENCE(HCAT(1),HDAT(3))
      DATA NAME/'MUCA','LGMA','TAGS','JTPL','JTAB','TOFC','LGST'/
C---
C---
C---     READ NEW RECORD(S) FROM UNIT 8
C---
      IWFLAG=1
      ITIME(1)=0
      ITIME(2)=0
      ITIME(3)=0
      ITIME(4)=1
      ITIME(5)=1
      ITIME(6)=1979
      LASTIM=0
      IDMTIM=KTMCON(ITIME,KTWRIT,LASTIM)
C---
      JBUF(1)=NAME(7)
      JBUF(2)=1
      JBUF(3)=1
      JBUF(4)=0
      JBUF(5)=KTWRIT
      JBUF(6)=0
      JBUF(7)=1
      JBUF(8)=0
      JBUF(9)=0
      NREC=0
      NRECW=0
      REWIND 4
      REWIND 8
    4 CONTINUE
      CALL EVREAH(8,NWORDH,HCAT,IRET)
      IF(IRET.EQ.1) GO TO 1001
      IF(IRET.EQ.2) GO TO 2001
C     IF (NREC.LE.5)
C    +PRINT 2901, (HCAT(II),II=1,10)
 2901 FORMAT (1X,10I10,'     (KORDER F 2901)')
      NREC=NREC+1
      GO TO 5
 1001 CONTINUE
      WRITE(6,201) NREC
  201 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I8,' RECORDS. (8)',
     +'     (KORDER F 201)')
      STOP
C---
C---     SELECT RECORDS FROM INPUT UNIT(S).
C---
    5 IDAT(1)=NWORDH
C     IF (NREC.LE.5)
C    +PRINT 2905, (IDAT(II),II=1,8)
 2905 FORMAT (1X,8I10,'     (KORDER F 2905)')
         IF(IDAT(1).LE.10) GO TO 4
         IF(IDAT(2).LE.500) GO TO 4
C         IDAT(1)=LENG, IDAT(2)=#EV.  BETTER BE NO DATA THAN
C         HAVING SHORT DATA.
      NWORDH=NWORDH+2
      ITIME(1)=HCAT(5)
      ITIME(2)=HCAT(6)
      ITIME(3)=HCAT(7)
      ITIME(4)=HCAT(8)
      ITIME(5)=HCAT(9)
      ITIME(6)=HCAT(10)
      LASTIM=0
      JBUF(6)=KTMCON(ITIME,KTDUMM,LASTIM)
      IF(JBUF(6).EQ.0) GO TO 4
C---
C---     SUBTRACT 200 SECONDS FROM EFFECTIVE TIME TO MAKE SURE CHANGE
C---     GOES INTO EFFECT AT START OF RUN.
C---
      JBUF(6)=JBUF(6)-200
C---     SET RUN #
      JBUF(8)=HCAT(4)
      NWORD=NWORDH/2
      IF((2*NWORD).NE.NWORDH) NWORD=NWORD+1
      NWORD=NWORD+9
      NRECW=NRECW+1
C---     WRITE OUT RECORDS TO UNIT 4 (SCRATCH)
C---     FILL LIST ARRAY FOR ORDERING
      IF(NRECW.GT.10000) WRITE(6,203)
  203 FORMAT(' **** ERROR. MORE THEN 10000 RECORDS. PROGRAMMED STOP.',
     +'     (KORDER F 203)')
      IF(NRECW.GT.10000) STOP
      LIST(1,NRECW)=NRECW
      LIST(2,NRECW)=JBUF(6)
C     IF (NREC.LE.5)
C    +PRINT 2902, (JBUF(II),II=1,10)
 2902 FORMAT (1X,10I10,'     (KORDER F 2902)')
      CALL KALBNK(4,NWORD,JBUF)
      GO TO 4
 2001 CONTINUE
      WRITE(6,202) NREC, NRECW
  202 FORMAT('0NORMAL EOF ON UNIT # 8 AFTER',I6,' RECORDS  -  ',
     +'BAD CHANNEL SCRATCH FILE    (KORDER F 202)'/'0'28X,I6,
     +' RECORDS FROM UNIT # 8 ACCEPTED')
C---     ORDER ARRAY LIST ACCORDING TO TIME = LIST(2)
C---     USE SHELL ALGORITHM
C        WRITE(6,1991) ((LIST(KLM,LHO),KLM=1,2),LHO=1,50)
 1991    FORMAT(1X,2I10,
     +'        (KORDER F 1991)')
C
      IF(NRECW.NE.0) GOTO 9
      WRITE(6,306)
  306 FORMAT(' *** PROGRAMMED STOP *** NO BAD CHANNELS FOUND',
     +'     (KORDER F 306)')
C
    9 N=NRECW
      M=N
   12 M=M/2
      IF (M.EQ.0) GOTO 11
      K=N-M
      DO 14 J=1,K
      I=J
   13 IF (I.LT.1) GOTO 14
      IF (LIST(2,I+M).GE.LIST(2,I)) GOTO 14
      LW2=LIST(2,I)
      LW1=LIST(1,I)
      LIST(2,I)=LIST(2,I+M)
      LIST(1,I)=LIST(1,I+M)
      LIST(2,I+M)=LW2
      LIST(1,I+M)=LW1
      I=I-M
      GOTO 13
   14 CONTINUE
      GOTO 12
   11 CONTINUE
C -----------------------
C        WRITE(6,1998)
 1998    FORMAT(' ')
C        WRITE(6,1992) ((LIST(KLM,LHO),KLM=1,2),LHO=1,50)
 1992    FORMAT (1X,2I10,
     +'         (KORDER F 1992)')
    6 CONTINUE
C--     LIST ARRAY IS NOW TIME ORDERED
C--     READ UNIT # 4  PUT TIME ORDERED RECORDS ONTO UNIT # 9
C--
      REWIND 4
      REWIND 9
      NCURNT=0
      LASTIW=0
      DO 10 I=1,NRECW
C     IF (I.LE.10)
C    +    WRITE(6,1995) I,NCURNT,LIST(1,I),LIST(2,I)
 1995     FORMAT(' I,NCURNT,LIST(1,I),LIST(2,I)= ',4I10,
     +'         (KORDER F 1995)')
      NWISH=LIST(1,I)
      IF(NWISH.GT.NCURNT) GO TO 20
      REWIND 4
      DO 15 J=1,NWISH
      CALL EVREA1(4,NWORD,JBUF,IRET)
C     IF (J.LE.10.AND.I.LE.10)
C    +PRINT 2903, (JBUF(II),II=1,10)
 2903 FORMAT (1X,10I10,'     (KORDER F 2903)')
      IF(IRET.EQ.0) GO TO 15
      WRITE(6,205) IRET
  205 FORMAT(' *** ILLEGAL IRET = ',I2,' IN LOOP 15. STOP.',
     +'     (KORDER F 205)')
      STOP
   15 CONTINUE
      GO TO 16
   20 CONTINUE
      LOOP=NWISH-NCURNT
      DO 17 J=1,LOOP
      CALL EVREA1(4,NWORD,JBUF,IRET)
C     IF (J.LE.10.AND.I.LE.10)
C    +PRINT 2904, (JBUF(II),II=1,10)
 2904 FORMAT (1X,10I10,'     (KORDER F 2904)')
      IF(IRET.EQ.0) GO TO 17
      WRITE(6,207) IRET
  207 FORMAT(' *** ILLEGAL IRET = ',I2,' IN 7 LOOP. STOP.',
     +'     (KORDER F 207)')
      STOP
   17 CONTINUE
   16 CONTINUE
      NCURNT=NWISH
      IF(JBUF(6).EQ.LIST(2,I)) GO TO 18
      WRITE(6,204) I,JBUF(6),LIST(1,I),LIST(2,I)
  204 FORMAT(' JBUF(6) AND LIST(2,I) DISAGREE. DUMP = ',4I10,
     +'     (KORDER F 204)')
      WRITE(6,303)
  303 FORMAT(' *** PROGRAMMED STOP *** ',
     +'     (KORDER F 303)')
      STOP
   18 CONTINUE
      IF(JBUF(6).GE.LASTIW) GO TO 19
      WRITE(6,206) I,JBUF(6),LASTIW,LIST(1,I),LIST(2,I)
  206 FORMAT(' DECREASING TIME. DUMP = ',5I10,
     +'     (KORDER F 206)')
      WRITE(6,304)
  304 FORMAT(' *** PROGRAMMED STOP *** ',
     +'     (KORDER F 304)')
      STOP
   19 CONTINUE
      LASTIW=JBUF(6)
C     IF (I.LE.10)
C    +PRINT 2906, (JBUF(II),II=1,10)
 2906 FORMAT (1X,10I10,'     (KORDER F 2906)')
      IF(IWFLAG.EQ.1) CALL KALBNK(9,NWORD,JBUF)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE KALADD
      IMPLICIT INTEGER*2 (H)
C---
C---     FOR ADDING ON AND MODIFYING CALIBRATION RECORDS.
C---                                   W.BARTEL 22.09.82
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      DIMENSION HTIME(6),HDAT(3),HCAT(1),JBUF1(10000)
      EQUIVALENCE(JBUF1(1),HBUF(1))
      EQUIVALENCE(JBUF1(10),IDAT(1))
      EQUIVALENCE(HDAT(1),IDAT(1))
      EQUIVALENCE(HCAT(1),HDAT(3))
      COMMON/CORDER/INSRT,LIST(2,10000)
C---
      NREC=0
      NREC1=0
      NREC2=0
      IFILL=1
C---
C---     LOOP OVER THE RECORDS ON THE EXISTING CALIBRATION FILE (UNIT 3)
C---     ADD ON NEW CALIBRATION DATA FROM UNIT 9 WRITE TO UNIT 4
C---
      REWIND 3
      REWIND 9
      REWIND 4
      IEOF=0
      NPRI=0
    1 CONTINUE
      NPRI=NPRI+1
      IF (IEOF.EQ.1) GOTO 5
      CALL EVREA1(3,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
C     IF (NPRI.LE.5) PRINT 2901, (JBUF(II),II=1,10)
 2901 FORMAT (1X,10I10,'     (KALADD F 2901)')
C     IF (NPRI.LE.5) PRINT 2902, INSRT,IFILL,LIST(2,IFILL)
 2902 FORMAT (' INSRT,IFILL,LIST(2,IFILL)=',3I10,'     (KALADD F 2902)')
      NREC=NREC+1
C--      COPY DATA ONTO UNIT 4 UNLESS A UNIT 8 RECORD HAS TO BE
C--      INSERTED
      IF (IFILL.GT.INSRT) GOTO 4
    3 IF(JBUF(6).GE.LIST(2,IFILL)) GO TO 5
    4 CALL KALBNK(4,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I8,' RECORDS.',
     +'     (KALADD F 101)')
      STOP
 2000 CONTINUE
      IEOF=1
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL EOF ON UNIT # 3 AFTER',I6,' RECORDS',
     +'     (KALADD F 102)')
      NPRI=0
C---
C---     ADD ON NEW RECORD(S) MADE FROM DATA ON UNIT 9 ETC.
C---     AND WRITE THESE TO UNIT 4 SCRATCH FILE.
C---
    5 CONTINUE
      CALL EVREA1(9,NWORD1,JBUF1,IRET)
      IF(IRET.EQ.1) GO TO 1001
      IF(IRET.EQ.2) GO TO 2001
C     IF (NREC1.LE.5) PRINT 2903, (JBUF1(II),II=1,10)
 2903 FORMAT (1X,10I10,'     (KALADD F 2903)')
      NREC1=NREC1+1
      IFILL = IFILL + 1
      IF (JBUF1(6).EQ.LIST(2,NREC1)) GOTO 8
      PRINT 2905, NREC1,JBUF1(6),LIST(1,NREC1),LIST(2,NREC1)
 2905 FORMAT (' JBUF(6) AND LIST(2,..) DISAGREE. DUMP = ',4I10,
     +'      (KALADD F 2905)')
    8 CALL KALBNK(4,NWORD1,JBUF1)
      IF(IFILL.GT.INSRT) GO TO 4
      IF(JBUF(6).GE.LIST(2,IFILL)) GO TO 5
      GO TO 4
 1001 CONTINUE
      WRITE(6,201) NREC1
  201 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I8,' RECORDS. (TWO)',
     +'     (KALADD F 201)')
      STOP
 2001 CONTINUE
      WRITE(6,202) NREC1
  202 FORMAT('0NORMAL EOF ON UNIT # 9 AFTER',I6,' RECORDS',
     +'     (KALADD F 202)'/'0UNIT # 3 AND # 9 MERGED ONTO UNIT # 4')
      RETURN
      END
      SUBROUTINE KALREV
      IMPLICIT INTEGER*2 (H)
C---
C---     COPIES BACK FROM WORKING FILE TO AUPDAT...
C---     ELIMINATES DUPLICATE LGST BANKS.
C---                                   L.H. O'NEILL 20.02.80
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
      DATA NLGST/'LGST'/
C---
      ISECLF=10
      ITOK=1
      IF(IUHR(ISECLF).NE.1) ITOK=0
      IF(ITOK.EQ.1) WRITE(6,401)
      IF(ITOK.NE.1) WRITE(6,402)
  401 FORMAT('0TIME OK GOING INTO KALREV.')
  402 FORMAT(1X,' TIME ALMOST OUT GOING INTO KALREV.')
    3 CONTINUE
      IF(ITOK.GT.-20) WRITE(6,403)
  403 FORMAT(1X,' THREE LOOP.')
      ITOK=ITOK-1
      IF(ITOK.LT.0) GO TO 3
      REWIND 3
      REWIND 4
      NRECI=0
      NRECO=0
      LGTIME=-1
    1 CONTINUE
      CALL EVREA1(4,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NRECI=NRECI+1
C     IF (NRECI.LT.10) PRINT 2901, (JBUF(II),II=1,10)
 2901 FORMAT (1X,10I10,'     (KALREV F 2901)')
      IF(JBUF(1).NE.NLGST) GO TO 2
      IF(JBUF(6).EQ.LGTIME) GO TO 1
      LGTIME=JBUF(6)
    2 CONTINUE
      CALL KALBNK(3,NWORD,JBUF)
      NRECO=NRECO+1
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NRECI
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.',
     +'     (KALREV F 101)')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NRECI
  102 FORMAT('0NORMAL EOF ON UNIT # 4 AFTER',I6,' RECORDS',
     +'     (KALREV F 102)')
      WRITE(6,103) NRECO
  103 FORMAT ('0',I6,' RECORDS WRITTEN ON UNIT # 2       ',
     +'      (KALREV F 103)')
      PRINT 104
  104 FORMAT (///'0  -----  TESTRUN: ON UNIT # 3')
      RETURN
      END

C   17/11/75 008211859  MEMBER NAME  EIGEN                  FORTRAN
      SUBROUTINE EIGEN(A,R,N,MV)
      DIMENSION A(1),R(1)
C
C        ...............................................................
C
C        IF A DOUBLE PRECISION VERSION OF THIS ROUTINE IS DESIRED, THE
C        C IN COLUMN 1 SHOULD BE REMOVED FROM THE DOUBLE PRECISION
C        STATEMENT WHICH FOLLOWS.
C
C     DOUBLE PRECISION A,R,ANORM,ANRMX,THR,X,Y,SINX,SINX2,COSX,
C    1                 COSX2,SINCS,RANGE
C
C        THE C MUST ALSO BE REMOVED FROM DOUBLE PRECISION STATEMENTS
C        APPEARING IN OTHER ROUTINES USED IN CONJUNCTION WITH THIS
C        ROUTINE.
C
C        THE DOUBLE PRECISION VERSION OF THIS SUBROUTINE MUST ALSO
C        CONTAIN DOUBLE PRECISION FORTRAN FUNCTIONS.  SQRT IN STATEMENTS
C        40, 68, 75, AND 78 MUST BE CHANGED TO DSQRT.  ABS IN STATEMENT
C        62 MUST BE CHANGED TO DABS. THE CONSTANT IN STATEMENT 5 SHOULD
C        BE CHANGED TO 1.0D-12.
C
C        ...............................................................
C
C        GENERATE IDENTITY MATRIX
C
    5 RANGE=1.0E-6
      IF(MV-1) 10,25,10
   10 IQ=-N
      DO 20 J=1,N
      IQ=IQ+N
      DO 20 I=1,N
      IJ=IQ+I
      R(IJ)=0.0
      IF(I-J) 20,15,20
   15 R(IJ)=1.0
   20 CONTINUE
C
C        COMPUTE INITIAL AND FINAL NORMS (ANORM AND ANORMX)
C
   25 ANORM=0.0
      DO 35 I=1,N
      DO 35 J=I,N
      IF(I-J) 30,35,30
   30 IA=I+(J*J-J)/2
      ANORM=ANORM+A(IA)*A(IA)
   35 CONTINUE
      IF(ANORM) 165,165,40
   40 ANORM=1.414*SQRT(ANORM)
      ANRMX=ANORM*RANGE/FLOAT(N)
C
C        INITIALIZE INDICATORS AND COMPUTE THRESHOLD, THR
C
      IND=0
      THR=ANORM
   45 THR=THR/FLOAT(N)
   50 L=1
   55 M=L+1
C
C        COMPUTE SIN AND COS
C
   60 MQ=(M*M-M)/2
      LQ=(L*L-L)/2
      LM=L+MQ
   62 IF( ABS(A(LM))-THR) 130,65,65
   65 IND=1
      LL=L+LQ
      MM=M+MQ
      X=0.5*(A(LL)-A(MM))
   68 Y=-A(LM)/ SQRT(A(LM)*A(LM)+X*X)
      IF(X) 70,75,75
   70 Y=-Y
   75 SINX=Y/ SQRT(2.0*(1.0+( SQRT(1.0-Y*Y))))
      SINX2=SINX*SINX
   78 COSX= SQRT(1.0-SINX2)
      COSX2=COSX*COSX
      SINCS =SINX*COSX
C
C        ROTATE L AND M COLUMNS
C
      ILQ=N*(L-1)
      IMQ=N*(M-1)
      DO 125 I=1,N
      IQ=(I*I-I)/2
      IF(I-L) 80,115,80
   80 IF(I-M) 85,115,90
   85 IM=I+MQ
      GO TO 95
   90 IM=M+IQ
   95 IF(I-L) 100,105,105
  100 IL=I+LQ
      GO TO 110
  105 IL=L+IQ
  110 X=A(IL)*COSX-A(IM)*SINX
      A(IM)=A(IL)*SINX+A(IM)*COSX
      A(IL)=X
  115 IF(MV-1) 120,125,120
  120 ILR=ILQ+I
      IMR=IMQ+I
      X=R(ILR)*COSX-R(IMR)*SINX
      R(IMR)=R(ILR)*SINX+R(IMR)*COSX
      R(ILR)=X
  125 CONTINUE
      X=2.0*A(LM)*SINCS
      Y=A(LL)*COSX2+A(MM)*SINX2-X
      X=A(LL)*SINX2+A(MM)*COSX2+X
      A(LM)=(A(LL)-A(MM))*SINCS+A(LM)*(COSX2-SINX2)
      A(LL)=Y
      A(MM)=X
C
C        TESTS FOR COMPLETION
C
C        TEST FOR M = LAST COLUMN
C
  130 IF(M-N) 135,140,135
  135 M=M+1
      GO TO 60
C
C        TEST FOR L = SECOND FROM LAST COLUMN
C
  140 IF(L-(N-1)) 145,150,145
  145 L=L+1
      GO TO 55
  150 IF(IND-1) 160,155,160
  155 IND=0
      GO TO 50
C
C        COMPARE THRESHOLD WITH FINAL NORM
C
  160 IF(THR-ANRMX) 165,165,45
C
C        SORT EIGENVALUES AND EIGENVECTORS
C
  165 IQ=-N
      DO 185 I=1,N
      IQ=IQ+N
      LL=I+(I*I-I)/2
      JQ=N*(I-2)
      DO 185 J=I,N
      JQ=JQ+N
      MM=J+(J*J-J)/2
      IF(A(LL)-A(MM)) 170,185,185
  170 X=A(LL)
      A(LL)=A(MM)
      A(MM)=X
      IF(MV-1) 175,185,175
  175 DO 180 K=1,N
      ILR=IQ+K
      IMR=JQ+K
      X=R(ILR)
      R(ILR)=R(IMR)
  180 R(IMR)=X
  185 CONTINUE
      RETURN
      END

C   08/06/83 308081851  MEMBER NAME  MUFFLX   (JADEMUS)     FORTRAN
C
C LAST CHANGE 03.11 14/07/83 HUGH MCCANN - VARIOUS CHANGES.
C      CHANGE 12.17 05/05/83 CHRIS BOWDERY- GENERAL TIDY-UP. NEW HAMB=2200000400
C      CHANGE 22.04 27/04/83 CHRIS BOWDERY- FIX BUG WITH IAPPRO+BAD HIT
C      CHANGE 19.10 16/03/82 CHRIS BOWDERY- FOR 'LET-OFF' CHECK (LOCH)
C      CHANGE 14.30 04/02/82 HUGH MCCANN  - CORRECT TREATMENT OF CASE
C                                           WHERE ALL HITS ARE BAD.
C      CHANGE 11.30 18/10/81 HUGH MCCANN  - CORRECT MUR2/3 COCK-UP.
C      CHANGE 10.05 15/10/81 HUGH MCCANN  - PROTECT LAYRAB (<= 10).
C      CHANGE 08.30 12/10/81 HUGH MCCANN  - FOR OVERLAP HITS.
C
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLX(HAMB)
C-----------------------------------------------------------------------
C
C        THIS SUBROUTINE CALCULATES CHI-SQUARED AND SELECTS THE BEST
C        HIT COMBINATION.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C             COMMONS AND ARRAY DECLARATIONS
C
#include "cmufwork.for"
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                REGZE(60),LOCHRS(60),ABLOCH(60)
C
      DIMENSION HAMB(1)
      DIMENSION LHIT(10),LHC(10,10),LAMB(10),LPERM(10),LAYER(10)
      DIMENSION IHTMIN(10),ILRMIN(10),LOPERM(10),LOHPER(10)
C
C-----------------------------------------------------------------------
C             DEFINITIONS
C-----------------------------------------------------------------------
C
C   LHIT   = THE NO. OF ASSOCIATED HITS IN EACH OF THE 'LAYRAB'
C            LAYERS WHICH HAVE ASSOCIATED HITS.
C   LHC    = LAYER-HIT CORRELATION ARRAY :
C                  LHC(I,J) CONTAINS THE HIT NO. ( WITHIN 1 --> NTHISS )
C                           OF THE JTH. ASSOCIATED HIT IN THE ITH.
C                           LAYER WHICH HAS ASSOCIATED HITS.
C   NAMB   = THE NO. OF LAYERS WHICH HAVE > 1 ASSOCIATED HIT.
C   LAMB   = ARRAY CONTAINING THE INDEX ( WITHIN 1--> LAYRAB ) OF
C            THOSE LAYERS WHICH HAVE > 1 ASSOCIATED HIT.
C   LAYER  = FOR ASSD EACH HIT ( LABELLED 1 --> NTHISS ), ITS LAYER
C            NO. ( LABELLED 1 --> LAYRAB ) .
C
C   IHTPER = ARRAY (1 --> NTHISS ) WITH 1 OR 0 TO FLAG WHETHER A HIT IS
C            IN THE CURRENT HIT PERMUTATION
C   IHTEMP = ARRAY (1 --> NTHISS ) WITH 1 OR 0 TO FLAG WHETHER A HIT IS
C            AN ADDITIONAL, OVERLAP HIT IN THE CURRENT HIT PERMUTATION
C   LOHPER = IHTPER + IHTEMP OF CURRENT LOWEST CHI**2 /NDF FOR CURRENT
C            HIT PERMUTATION.
C   IPERM  = ARRAY (1 --> NTHISS ) WITH 1 OR -1 TO FLAG AMBIGUITY OF
C            HITS IN THE CURRENT PERMUTATION. 0 = HIT NOT IN THIS PERM.
C   IPTEMP = ARRAY (1 --> NTHISS ) WITH 1 OR -1 TO FLAG AMBIGUITY OF
C            ADDITIONAL OVERLAP HITS IN THE CURRENT PERMUTATION.
C   LOPERM = IPERM + IPTEMP OF CURRENT LOWEST CHI**2 /NDF FOR CURRENT
C            HIT PERMUTATION.
C   IHTMIN = ARRAY (1 --> NTHISS ) WITH IHTPER OF FINAL SOLUTION
C   ILRMIN = ARRAY (1 --> NTHISS ) WITH LOPERM OF FINAL SOLUTION
C
C            N.B. LOPERM * LOHPER ARE REQUIRED IN THIS VERSION, WHERE
C                 OVERLAP HITS ARE USED IN THE CHI**2 CALCULATION.
C                 SIMILARLY, FOR THE L/R AMBIGUITY PERMUTATION,
C                 CHI**2/NO. OF DEGREES OF FREEDOM IS NOW THE VARIABLE
C                 WHICH DEFINES THE BEST PERMUTATION.
C
C                 ALSO NOTE THAT NTHISS = NTHIS UNLESS NTHIS > 10
C
C--------- M E T H O D   O F   S O L U T I O N -------------------------
C
C  CHOVND = CHI**2 / NO. OF DEGREES OF FREEDOM (DRIFT COORDS ONLY)
C
C  THE SOLUTION IS THAT HIT * L/R PERMUTATION WITH LOWEST CHOVND.
C
C  DCHISQ / IDNDF = DRIFT CHI**2 / NDF OF SOLUTION
C  ZCHISQ / IZNDF = DRIFT + LONGL CHI**2 / NDF OF SOLUTION    (NOT DONE)
C
C-----------------------------------------------------------------------
C
C             INITIALISE THE ABOVE VARIABLES FOR THIS TRACK.
C
      CALL VZERO (REGDEV,30)
      CALL VZERO (IHTPER,10)
      CALL VZERO (IHTEMP,10)
      CALL VZERO (IPTEMP,10)
      CALL VZERO (LHIT  ,10)
      CALL VZERO (LHC  ,100)
      CALL VZERO (LAMB  ,10)
      CALL VZERO (LAYER ,10)
      CALL VZERO (IHTMIN,10)
      CALL VZERO (ILRMIN,10)
      CALL VZERO (LOPERM,10)
      CALL VZERO (LOHPER,10)
      NAMB   = 0
      CHOVND = 1.E19 ! 1.E50  PMF 06/11/98
      DCHISQ = 0.
      IDNDF  = 0
C
C++++
C     WRITE(6,2857)DALONG,DEV,VXYDA,VZDA,CXYA,CZA,INCUT,BADA,ITHISA,IJA,
C    *LAYRAB,IEFFRG,IHTREG
C
C2857 FORMAT('0DALONG',T20,10F10.1/
C    *' DEVIATIONS',T20,10F10.1/2(T20,10F10.1/)
C    *' VXYDA',T20,10F10.0/
C    *' VZDA',T20,10F10.0/
C    *' CXYA',T20,10F10.0/
C    *' CZA',T20,10F10.0/
C    *' INCUT',T20,30L2/
C    *' BADA',T20,30L2/
C    *' ITHISA',T20,10I5/
C    *' IJA',T20,10I5/
C    *' LAYRAB',I3,'  IEFFRG',10I5/
C    *' IHTREG',10I5)
C
C     DO  2849  I = 1,10
C       WRITE(6,2858) (IOVLAP(I,J),J=1,10)
C2858   FORMAT(10I2)
C2849 CONTINUE
C++++
C
C
      IF(LAYRAB.GT.10) LAYRAB = 10
      NTHISS = NTHIS
      IF(NTHIS.GT.10)  NTHISS = 10
      N2 = 2 * NTHISS
      N3 = 3 * NTHISS
C
C             FILL NAMB,LHIT * LHC.
C
      DO 10  I = 1,LAYRAB
C
        DO  5  J = 1,NTHISS
          IF(IHTREG(J).NE.IEFFRG(I)) GO TO 5
C+++
          IF(IHTREG(J).LT.0)GO TO 5
C+++
          LHIT(I) = LHIT(I) + 1
          LHC(I,LHIT(I)) = J
          LAYER(J) = I
    5   CONTINUE
C
CCCC    IF(LHIT(I).EQ.1) GO TO 8
C+++
        IF(LHIT(I).LE.1) GO TO 8
C+++
          NAMB       = NAMB + 1
          LAMB(NAMB) = I
          GO TO 10
    8   CONTINUE
C
C              FILL IHTPER FOR THOSE HITS IN
C              LAYERS WITH ONLY 1 ASSOCIATED HIT.
C
CCCC    IHTPER( LHC(I,1) ) = 1
C+++
        IF(LHIT(I).EQ.1)IHTPER( LHC(I,1) ) = 1
C+++
   10 CONTINUE
C
C
C     DO  2010  I = 1,10
C       WRITE(6,2009)(LHC(I,J),J=1,10),LHIT(I)
C2009   FORMAT('0 ',10I3,'  LHIT=',I3)
C2010 CONTINUE
C     WRITE(6,2015)NAMB,LAMB,IHTPER
C2015 FORMAT('0 NAMB=',I3,'  LAMB=',10I3/'0 IHTPER=',10I3)
C
C              FILL OUT REST OF ERROR MATRIX.
C
      N21 = N2 - 1
      DO  1  J = 1,N21
        J1  = J + 1
        DO  3  I = J1,N2
          EM(I,J) = EM(J,I)
 3      CONTINUE
 1    CONTINUE
C
C     WRITE(6,2856)((EM(I,J),I=1,12),J=1,12)
C2856 FORMAT('0FIRST 12 ENTRIES IN ERROR MATRIX'/(12F10.0))
C
C
C-----------------------------------------------------------------------
C
C             BEFORE GETTING FIRST PERMUTATION OF HITS IN AMBIGUOUS
C             LAYERS, INITIALISE LPERM TO ZERO.
C
      CALL VZERO(LPERM,10)
C
C             IF THERE ARE NO LAYERS WITH MORE THAN 1 ASSOCIATED HIT,
C             JUST PERMUTE THE LEFT/RIGHT AMBIGUITIES.
C
      IF(NAMB.EQ.0) GO TO 27
C
C-----------------------------------------------------------------------
C
C                  LOOP OVER PERMUTATIONS OF HITS
C                  ------------------------------
C
C             ALWAYS GO THRO 13 TO GET NEXT PERMUTATION OF HITS.
C
C LPERM(I) ( I=1,NAMB ) COUNTS HOW MANY TIME AMBIGUOUS LAYER 'I' HAS HAD
C             ITS HIT REPRESENTATIVE CHANGED IN THE PERMUTING ALGORITHM
C             SINCE THE (I-1)TH. LAYER LAST CHANGED ITS REPRESENTATIVE.
C             ALL PERMUTATIONS ARE EXHAUSTED WHEN :
C
C             LPERM(I)=LHIT( LAMB(I) )        FOR ALL I = 1,NAMB.
C
C-----------------------------------------------------------------------
C
  13  CONTINUE
C
C             GET NEXT PERMUTATION OF HITS.
C
      DO  25  I = 1,NAMB
        ILAYR = LAMB(I)
        NHL   = LHIT(ILAYR)
C
C             IF THIS IS THE LAST AMBIG. LAYER, CYCLE THRO' ALL ITS HITS
C             WITH THE CURRENT REPS OF AMBIG. LAYERS 1--> NAMB-1  FIXED.
C
        IF(I.EQ.NAMB) GO TO 17
C
C             THIS LAYER ONLY CHANGES ITS REP IF, FOR ITS CURRENT REP,
C             THE AMBIGUOUS LAYERS WITH HIGHER I HAVE ALL GONE THRO' ALL
C             POSSIBLE PERMUTATIONS I.E. LPERM(J)=LHIT(LAMB(J))
C                                                ALL J > I  ( COND A )
          I1 = I + 1
          DO  15  J = I1,NAMB
            IF(LPERM(I).NE.0.AND.LPERM(J).LT.LHIT(LAMB(J))) GO TO 25
 15       CONTINUE
C
C             CHANGE THE REP OF THIS AMBIG LAYER.
C
 17     DO  21  J = 1,NHL
          KHIT = LHC(ILAYR,J)
          IF(J.LT.LPERM(I)) GO TO 21
C******* THE STATEMENT BELOW MAY BE REDUNDANT ********
            IF(IHTPER(KHIT).EQ.1)GO TO 19
              IHTPER(KHIT)=1
              J1=J
   18         J1=J1+1
              IF(J1.GT.NHL)GO TO 23
                KHIT = LHC(ILAYR,J1)
                IHTPER(KHIT) = 0
              GO TO 18
   19       IHTPER(KHIT)=0
   21   CONTINUE
C
   23   LPERM(I)=LPERM(I)+1
        IF(I.EQ.NAMB)GO TO 25
C
C             COND A MUST HAVE BEEN SATISFIED FOR THIS LAYER. THEREFORE,
C             START ALL OVER AGAIN WITH THIS REP OF LAYER 'I'. SO , FOR
C             ALL J > I  ( UP TO NAMB ), MUST PUT LPERM(J)=0.
C
        DO  24  J = I1,NAMB
          LPERM(J) = 0
   24   CONTINUE
C
   25 CONTINUE
C
   27 CONTINUE
C
C++++
C     WRITE(6,2025)LPERM,IHTPER
C2025 FORMAT('0 LPERM=',10I3/'0 IHTPER=',10I3)
C++++
C
C-----------------------------------------------------------------------
C
C             CALCULATE CHI-SQUARED FOR DRIFT COORDINATES ALONE.
C
      CHINLO = 1.E19 ! 1.E50 PMF 06/11/98
      NDFTMI = 0
      NPERM  = 1
C
C             SET UP LEFT/RIGHT PERMUTATION VECTOR IPERM
C             IPERM = 0 IF NO AMBIGUITY.  INITIALLY SET TO -1 TO SELECT
C             LEFT AMBIGUITY IF AMBIGUITY EXISTS. THEN EACH NON-ZERO
C             VALUE OF IPERM IS SET TO +1 UNTIL ALL PERMUTATIONS HAVE
C             BEEN TRIED.
C
      DO  2  I = 1,NTHISS
        I1 = 3 * I - 2
        I2 = I1 + 1
        IT = 2 * I - 1
        IPERM(I) = 0
        IF(BADA(IT)) GO TO 2
C+++
        IF(IHTREG(I).LT.0)GO TO 2
C+++
        IF(IHTPER(I).NE.1) GO TO 2
        IF(INCUT(I1).AND.INCUT(I2)) IPERM(I) = -1
 2    CONTINUE
C
C             START OF LEFT/RIGHT AMBIGUITY PERMUTATION LOOP.
C
 30   CONTINUE
C
C             CLEAR IHTEMP , IPTEMP.
C
      CALL VZERO(IHTEMP,10)
      CALL VZERO(IPTEMP,10)
C
C             FOR THIS PERMUTATION OF HITS * AMBIGUITIES,
C             SELECT APPROPRIATE BITS OF DEVIATION VECTOR.
C
      CALL VZERO(IAPPRO,N3)
      DO  35  I = 1,NTHISS
        I1 = 3 * I - 2
        IT = 2 * I - 1
C
C             IS THIS HIT IN THE PRESENT HIT PERMUTATION ?
C
        IF(IHTPER(I).NE.1) GO TO 35
        IF(BADA(IT))       GO TO 35
        I2 = I1 + 1
        IF(IPERM(I)) 33,31,32
 31       IF(INCUT(I1))      GO TO 33
 32       II = I2
          JSIGN = 1
        GO TO 34
 33       II = I1
          JSIGN = -1
 34     IAPPRO(II) = 1
C
C             IS THERE AN OVERLAP HIT FOR THIS AMBIGUITY OF THIS HIT ?
C             IF THERE ARE NO AMBIGUOUS LAYERS , NO ;
C             IF THIS HIT IS NOT IN AN AMBIGUOUS LAYER, NO ;
C
        IF(NAMB.EQ.0) GO TO 35
        IF(LHIT(LAYER(I)).LT.2) GO TO 35
C
C             MAYBE, SO LOOK AT THE OVERLAP MATRIX :
C
        DO  345  K = 1,NTHISS
C
C             OF COURSE , ONLY CONSIDER OTHER HITS IN THE SAME LAYER.
C
          IF(LAYER(K).NE.LAYER(I)) GO TO 345
          IF(JSIGN.GT.0) GO TO 343
            IF(IOVLAP(I,K).EQ.0) GO TO 345
            GO TO 344
 343      IF(IOVLAP(K,I).EQ.0) GO TO 345
 344      IHTEMP(K) = 1
          IPTEMP(K) = -JSIGN
C
C                  DONT MAKE ENTRY IN IAPPRO IF BAD HIT
C
          IF(BADA(2*K-1)) GO TO 35
          KK = 3 * K - 1
          IF(JSIGN.EQ.1) KK = KK-1
          IAPPRO(KK) = 1
          GO TO 35
 345    CONTINUE
 35   CONTINUE
C
C             CALL MUFMAT TO GET ERROR MATRIX FOR THIS HIT PERMUTATION.
C             NOTE THAT THIS IS DONE FOR EVERY AMB PERM OF EVERY HIT
C             PERM. THIS IS NECESSARY DUE TO THE FACT THAT CHANGING THE
C             AMB PERM MAY ADD HITS TO THE HIT PERM DUE TO OVERLAPS. IN
C             PRINCIPLE , ONE COULD DO THIS ONLY WHEN AN OVERLAP DOES
C             EXIST. BUT THEN HAVE TO CALCULATE THE ERROR MATRIX AGAIN
C             FOR THE BASIC HIT PERM BEFORE NEXT AMB PERM, SO GAIN IS
C                                                               SMALL.
      CALL MUFMAT(NTHISS,MERR)
      IF(MERR.EQ.1)GO TO 53
C
C             FILL DEVA WITH APPROPRIATE BITS OF EM.
C
      K = 0
      DO  37  I = 1,N3
        IF(IAPPRO(I).EQ.0) GO TO 37
        K = K + 1
        DEVA(K) = DEV(I)
 37   CONTINUE
C
C++++
C     WRITE(6,2859)(DEVA(I),I=1,NDFT)
C2859 FORMAT(' DEVIATIONS'/(12F10.0))
C++++
C
C             K SHOULD EQUAL THE NUMBER OF DEGREES OF FREEDOM
C             IF THE PROGRAM IS WORKING CORRECTLY
C
      IF(K.EQ.NDFT) GO TO 38
        CALL MUERRY('MUFFLX',K,
     +  'SERIOUS--> NO. OF MARKED HITS .NE. NO. OF DEGREES OF FREEDOM^')
C
C             FORM CHI-SQUARED.
C
 38   CHISQT = 0.
      DO  50  I = 1,NDFT
        CH = 0.
C
        DO  51  J = 1,NDFT
          CH = CH + G(I,J)*DEVA(J)
 51     CONTINUE
C
        CHISQT = CHISQT + DEVA(I)*CH
 50   CONTINUE
C
      CHINDF = CHISQT / NDFT
      GO TO 55
 53   CHINDF = 1.1E19! 1.1E50 PMF 06/11/98
      NDFT=0
 55   CONTINUE
C
C++++
C     WRITE(6,2834)CHISQT,NDFT
C2834 FORMAT(' CHI-SQUARED',F10.4,'  NDFT',I4)
C++++
C
C             RECORD MINIMUM DRIFT CHI**2 PER DEGREE OF FREEDOM
C             FOR THIS HIT PERMUTATION.
C
      IF(CHINDF.GE.CHINLO) GO TO 60
      CHISMI = CHISQT
      NDFTMI = NDFT
      CHINLO = CHINDF
      MPERM  = NPERM
      DO  58  I = 1,NTHISS
        LOHPER(I) = IHTPER(I)
        IF(IHTEMP(I).NE.0) LOHPER(I) = IHTEMP(I)
        LOPERM(I) = IPERM(I)
        IF(IPTEMP(I).NE.0) LOPERM(I) = IPTEMP(I)
 58   CONTINUE
C
C             PERMUTE L/R AMBIGUITIES. GO BACK TO 30 IF ANOTHER
C             L/R AMBIGUITY IS STILL TO BE TRIED.
C
 60   NPERM=NPERM+1
      DO  63  I = 1,NTHISS
        IPERM(I) = - IPERM(I)
        IF(IPERM(I).EQ. 1) GO TO 30
 63   CONTINUE
C
      QUOT = 0.
      IF(NDFTMI.GT.0) QUOT = CHINLO
C
C++++
C     WRITE(6,1735)CHISMI,NDFTMI,QUOT
C1735 FORMAT(' CHISMI,NDFTMI',F10.4,I5,'  QUOT=',F10.3)
C++++
C
C-----------------------------------------------------------------------
C
C             CHECK HIT PERMUTATION.
C
      IF(NDFTMI.EQ.0) GO TO 170
C
C             IS THIS A NEW MINIMUM OF CHOVND ?  IF NO THEN JUMP.
C
      IF(QUOT.GT.CHOVND) GO TO 170
C
C             **  N.B. COULD HAVE MORE CONDITIONS ON THE ABOVE SELECTION
C             **       E.G. IF NDFTMI > IDNDF + 2 , ACCEPT PRESENT PERM
C             **          OVER CURRRENT MINIMUM IF QUOT < CHOVND + 0.05.
C
C             YES. SO RECORD CURRENT BEST HIT AND AMBIGUITY PERMUTATION
C                  AND NEW MIN CHOVND * CORRESPONDING QUANTITIES.
C
      DO  165  I = 1,NTHISS
        IHTMIN(I)=LOHPER(I)
        ILRMIN(I)=LOPERM(I)
  165 CONTINUE
C
      CHOVND = QUOT
      DCHISQ = CHISMI
      IDNDF  = NDFTMI
C
C             ARE THERE ANY FURTHER HIT PERMUTATIONS ? IF SO, GO TO 13.
C
 170  IF(NAMB.EQ.0) GO TO 180
      DO  175  I = 1,NAMB
        IF(LPERM(I) .LT. LHIT(LAMB(I)) ) GO TO 13
  175 CONTINUE
C
C             ALL PERMUTATIONS OF HITS ARE EXHAUSTED. CALCULATE THE
C             CHI**2 PROBABILITY.
C
 180  IF(IDNDF.GT.0) CHIPRT = PROB(DCHISQ,IDNDF)
C
C++++
C     WRITE(6,2185)IHTMIN,ILRMIN,CHOVND,DCHISQ,IDNDF,CHIPRT
C2185 FORMAT('0 IHTMIN=',10I3/'0 ILRMIN=',10I3/
C    *'0 CHOVND=',F10.3,' DCHISQ=',F10.3,' IDNDF=',I5,' CHIPRT=',G15.5)
C++++
C
C-----------------------------------------------------------------------
C
C ====>  AT PRESENT THE LONGITUDINAL CHI-SQUARED CALCULATION IS NOT DONE
C
      CHIPTL = 0.
C
C CALCULATE CHI-SQUARED FOR DRIFT AND LONGITUDINAL COORDINATES.
C
C SELECT APPROPRIATE BITS OF DEVIATION VECTOR.
C     CALL VZERO(IAPPRO,N3)
C     NDFTL=0
C     DO 136 I=1,NTHISS
C     I1=3*I-2
C     IT=2*I-1
C IS THIS HIT IN THE PRESENT HIT PERMUTATION ?
C     IF(IHTPER(I).NE.1)GO TO 136
C     IF(BADA(IT))GO TO 135
C     I2=I1+1
C     IF(IPERM(I))133,131,132
C131  IF(INCUT(I1))GO TO 133
C132  II=I2
C     GO TO 134
C133  II=I1
C134  IAPPRO(II)=1
C     NDFTL=NDFTL+1
C135  II=I1+2
C     IL=IT+1
C     IF(BADA(IL))GO TO 136
C     IAPPRO(II)=1
C     NDFTL=NDFTL+1
C136  CONTINUE
C     IF(NDFTL.LE.0)GO TO 152
C
C
C FILL G AND DEVA WITH APPROPRIATE INFORMATION.
C     K=1
C     DO 138 I=1,N3
C     IF(IAPPRO(I).EQ.0)GO TO 138
C     IE=2*((I-1)/3)+1
C     IF(MOD(I,3).EQ.0)IE=IE+1
C     L=1
C     DO 137 J=1,N3
C     IF(IAPPRO(J).EQ.0)GO TO 137
C     JE=2*((J-1)/3)+1
C     IF(MOD(J,3).EQ.0)JE=JE+1
C     G(K,L)=EM(IE,JE)
C     L=L+1
C137  CONTINUE
C     DEVA(K)=DEV(I)
C     K=K+1
C138  CONTINUE
C
C++++
C     WRITE(6,3848)NDFTL
C3848 FORMAT(I5,' COORDS IN DRIFT AND LONG. CALCULATION.',
C    *' SPECIFIC ERROR MATRIX IS')
C     DO 3849 I=1,NDFTL
C     WRITE(6,2858)(G(I,J),J=1,NDFTL)
C3849 CONTINUE
C     WRITE(6,2859)(DEVA(I),I=1,NDFTL)
C++++
C
C INVERT MATRIX.
C     CALL SYMIN4(G,20,NDFTL,MWORK,IER)
C     IF(IER.EQ.0)GO TO 98
C       CALL MUERRY('MUFFLX',IER,'ERROR RETURN FROM SYMIN4.^')
C       RETURN
C98   CONTINUE
C++++
C     WRITE(6,2861)IER
C     WRITE(6,2838)
C     DO 3839 I=1,NDFTL
C     WRITE(6,2840)(G(I,J),J=1,NDFTL)
C3839 CONTINUE
C++++
C
C
C FORM CHI-SQUARED.
C     CHISTL=0.
C     DO 150 I=1,NDFTL
C     CH=0.
C     DO 151 J=1,NDFTL
C151  CH=CH+G(I,J)*DEVA(J)
C150  CHISTL=CHISTL+DEVA(I)*CH
C     GO TO 153
C
C152  CONTINUE
C     CHISTL=0.
C
C153  CONTINUE
C     CHIPTL=PROB(CHISTL,NDFTL)
C++++
C     WRITE(6,3735)CHISTL,NDFTL,CHIPTL
C3735 FORMAT(' CHISTL,NDFTL,CHIPTL',F10.4,I5,G15.5)
C++++
C
C-----------------------------------------------------------------------
C
C             RECORD HIT AND L/R ASSIGNMENTS OF SOLUTION.
C             (IDEVP IS THE POINTER FOR REGDEV NEEDED BY MULOCH)
C
  155 IDEVP = 1
      DO  185  I = 1,NTHISS
        IF(IHTMIN(I).NE.1) GO TO 185
        I1 = 3*I-2
        I2 = I1+1
        IAMB = ILRMIN(I)
        IF(IAMB.NE.0) GO TO 186
C
C             PUT IAMB TO CORRECT VALUE FOR THOSE HITS  WHICH  HAD  ONLY
C             ONE AMB WITHIN  FACTOR*SIGMA ( * THEREFORE HAD IPERM = 0 *
C             ILRMIN = 0 ) .
C
        IAMB = -1
        IF(INCUT(I2)) IAMB =1
C
C             FOR LOCH ('LET-OFF' CHECK), COPY THE DEVIATION OF THE
C             SELECTED HIT AMBIGUITY INTO REGDEV AFTER SAVING THE
C             REGION NUMBER. (WE MAY HAVE 2 HITS PER REGION)
C
  186   REGDEV(IDEVP)   = IHTREG(I)
        REGDEV(IDEVP+1) = ALLABS(I)
        REGDEV(IDEVP+2) = ALLDEV(I,(IAMB+3)/2 )
        IDEVP           = IDEVP + 3
C
C             PRESENT SYSTEM :  IF ONLY LEFT/RIGHT AMB IS WITHIN 3 SIGMA
C             HAMB =  -2 / +2 . IF LEFT/RIGHT AMB IS IN THE BEST HIT/AMB
C                               PERM AND THE OTHER AMB IS WITHIN 3 SIGMA
C             HAMB = -12 / +12 .
C
        J = IJA(I)
        IF(J.LT.0) GO TO 185
        HAMB(J) = 2*IAMB
        IF( INCUT(I1).AND.INCUT(I2) ) HAMB(J) = HAMB(J) + IAMB*10
        IT = 2*I - 1
        IF(.NOT.BADA(IT)) GO TO 185
C
C             THIS IS A BAD HIT WHICH  FINDS  ITSELF  IN  THE  BEST  HIT
C             PERMUTATION. ARE BOTH AMBIGUITIES WITHIN 3 SIGMA OF  TRACK
C             OR WHICH ?   IF BOTH, MAKE HAMB = 22.
C
        IF(INCUT(I1)) HAMB(J) = -2
        IF(INCUT(I2)) HAMB(J) =  2
        IF( INCUT(I1).AND.INCUT(I2) ) HAMB(J) = 22
  185 CONTINUE
C
C++++
C     CALL BPRS('MUR2',2)
C     CALL BPRS('MUR2',3)
C++++
C
      RETURN
      END

      SUBROUTINE JFETCH(IPTR,IPJHTL,WRK,LHIT,IPRES,INDEX,XO,YO)
      IMPLICIT INTEGER*2 (H)
      DIMENSION WRK(200)
      EQUIVALENCE (ZWZ,IZW)
      COMMON/JSCALD/ JESCAL,JESKEY
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C----------------------------------------------------------------------
C            MACRO CALIBR .... JADE CALIBRATION DATA COMMON
C----------------------------------------------------------------------
      COMMON/CALIBR/ ACALIB(1000)
                     DIMENSION HCALIB(100),ICALIB(100)
                     EQUIVALENCE(ACALIB(1),HCALIB(1),ICALIB(1))
C------------------------ END OF MACRO CALIBR -------------------------
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C----------------------------------------------------------------------
C           MACRO CDSMAX .... PATTERN RECOGNITION CONSTANTS.
C----------------------------------------------------------------------
      COMMON/CDSMAX/DSMAX(16,3,2),DIRWR1(24,2),DIRWR3(48,2)
     *             ,DHALF(16,3,2),DTWICE(16,3,2),HMCH(16,3,2)
     *             ,IBCK(9),DBCK(30),TRMATS(96,2),TRMATC(96,2)
C------------------------ END OF MACRO CDSMAX -------------------------
      COMMON/CCMZCT/ DIMPCT, ZCUTV, ZCUTVV, IZVCST(5), ZCHWW
      DIMENSION IZCHMB(3,2),AZCHMB(3,2)
      COMMON/XYFVT1/MODXYV,NOVL
***PMF      DIMENSION IRESAR(13),RESAR(13),HRESAR(26)
      DIMENSION IRESAR(14),RESAR(14),HRESAR(28)
      EQUIVALENCE (IRESAR(1),RESAR(1),HRESAR(1))
      DATA NCOAR / 15/, DTGB / .15/
      REAL TGCOAR(15) /-99.,-.45, 12*0., 99./
      REAL T0COAR(60) / .000, .000, .000, .000, .000,
     ,     .000, .000,-.020,-.060,-.130,-.030, .100, .200, .200, .200,
     ,                  .000, .000, .010, .110, .100,
     ,     .075, .050, .025, .005, .015, .065, .060, .060, .060, .060,
     ,                  .190, .190, .180, .165, .140,
     ,     .120, .100, .075, .050, .010,-.050,-.075,-.035, .000, .000,
     ,                  .110, .110, .115, .140, .135,
     ,     .085, .045, .030, .040, .050, .055, .055, .055, .055, .055/
      REAL SLCOAR(60) / 60*0./
      INTEGER MKLRT1 /Z1000000/, MKLRT2 /Z100/
      IF(
     - JESCAL .GT. 0   .AND.   JESKEY .EQ. 54321
     -)THEN
         IP8=ICALIB(13)+6
         IP9=ICALIB(13)+2598
         CALL JFTNEW(IPTR,IPJHTL,WRK,LHIT,IPRES,INDEX,XO,YO,
     +   ACALIB(IP8),ACALIB(IP9))
         RETURN
      ENDIF
      INDX=INDEX
      IF(INDX.EQ.4) INDX=1
      DATA LBINIT /0/
      IF(
     - LBINIT .EQ. 0
     -)THEN
        LBINIT = 1
        NCALL = 0
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
        PRINT 7777
 7777   FORMAT(' JFETCH : VERSION FROM 13/01/88 CALLED!',/,
     *         ' +++++++++++++++++++++++++++++++++++++++++++++++++++++')
      ENDIF
      NCALL = NCALL + 1
      LHBIT  = LHIT*4
      IPCO = 1
      IPHEAD = IDATA(IQHEAD)*2
      NRUN = HDATA(IPHEAD+10)
      NEVT = HDATA(IPHEAD+11)
      ITRK = IDATA(IPTR+1)
      IF(
     - IDATA(IPTR+18).EQ.1
     -)THEN
        ALFA  = ADATA(IPTR+21)
        CRV   = ADATA(IPTR+19)
        IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
        RAD   =  1./ABS(CRV) + ADATA(IPTR+20)
        XCIRC = COS(ALFA) * RAD
        YCIRC = SIN(ALFA) * RAD
        CHARGE = SIGN(1.,ADATA(IPTR+25))
      ELSE
        CRV   = ADATA(IPTR+22)*2.
        IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
        ALFA  = ADATA(IPTR+19)
        XCIRC =-SIN(ALFA)/CRV + ADATA(IPTR+20)
        YCIRC = COS(ALFA)/CRV + ADATA(IPTR+21)
        CHARGE =-SIGN(1.,ADATA(IPTR+22))
      ENDIF
      ZVERT = ADATA(IPTR+31)
      TGTH = ADATA(IPTR+30)
      CSTHI = SQRT(TGTH**2 + 1.)
      CSTH  = 1. / CSTHI
      SNTH  = CSTH * TGTH
      IZZZSE=INDX
      GOTO 14002
14003 CONTINUE
        XT = 0.
        YT = 0.
        CSROT = 1.
        SNROT = 0.
        XOT   = 0.
        YOT   = 0.
      GOTO 14001
14004 CONTINUE
        XT    = (ADATA(IPTR+12) + ADATA(IPTR+5)) * .5
        YT    = (ADATA(IPTR+13) + ADATA(IPTR+6)) * .5
        XX    =  ADATA(IPTR+12) - ADATA(IPTR+5)
        YY    =  ADATA(IPTR+13) - ADATA(IPTR+6)
        RR    = SQRT(XX**2+YY**2)
      IF(
     - RR.LT.10.
     -)THEN
           IPRES=IPCO
           RETURN
      ENDIF
        CSROT = XX / RR
        SNROT = YY / RR
        XX    = XO - XT
        YY    = YO - YT
        XOT   = 0.
        YOT   = 0.
      GOTO 14001
14005 CONTINUE
        XT    = (ADATA(IPTR+12) + XO) * .5
        YT    = (ADATA(IPTR+13) + YO) * .5
        XX    =  ADATA(IPTR+12) - XO
        YY    =  ADATA(IPTR+13) - YO
        RR    = SQRT(XX**2+YY**2)
        CSROT = XX / RR
        SNROT = YY / RR
        XX    = XO - XT
        YY    = YO - YT
        XOT   = XX*CSROT + YY*SNROT
        YOT   =-XX*SNROT + YY*CSROT
      GOTO 14001
14002 CONTINUE
      GOTO(
     -14003,14004,14005
     -), IZZZSE
14000 CONTINUE
        RETURN
14001 CONTINUE
      NOVL = 0
      IPC0 = IPTR + 34
      IPC9 = IPC0 +  5
      DO 13000 IPC = IPC0,IPC9
         JCELL = IDATA(IPC)
      IF(
     - JCELL.GT. 0 .AND. JCELL.LE.96
     -)THEN
            JRING = 1
            IF(JCELL.GT.24) JRING = 2
            IF(JCELL.GT.48) JRING = 3
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      ENDIF
13000 CONTINUE
13001 CONTINUE
      IF(
     - INDEX.EQ.4 .AND. ZCHWW.GT..1 .AND. ZCHWW.LT.2000.
     -)THEN
         CALL ZCFTNW(NRUN,NEVT,ITRK,TGTH,ZVERT,NZHIT,IZCHMB,AZCHMB)
      IF(
     - NZHIT.GT.0
     -)THEN
      DO 13002 J=1,NZHIT
               HRESAR( 1) = 100+IZCHMB(1,J)
               HRESAR( 2) = IZCHMB(2,J)
               HRESAR( 3) = 0
               HRESAR( 4) = 0
               HRESAR( 5) = 1
               HRESAR( 6) = 101
               XX=AZCHMB(1,J)
               YY=AZCHMB(2,J)
               ZZ=AZCHMB(3,J)
               RESAR ( 4) = XX
               RESAR ( 5) = YY
               RESAR ( 6) = ZZ
               UX=XX-ADATA(IPTR+5)
               UY=YY-ADATA(IPTR+6)
               UU=SQRT(UX**2+UY**2)
            IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*SIN(.5*CURVXY*UU)/CURVXY
               IF(UX*ADATA(IPTR+8)+UY*ADATA(IPTR+9).LT.0.) UU=-UU
               RESAR ( 7) = UU
               RESAR ( 8) = ZCHWW
               IF(NRUN.LT.24200) RESAR(8)=RESAR(8)*.6
               CALL MVC(WRK(IPCO),0,RESAR(1),0,LHBIT)
               IPCO = IPCO + LHIT
13002 CONTINUE
13003 CONTINUE
      ENDIF
      ENDIF
      IPRES = IPCO
      IF(
     - INDEX.NE.4
     -)THEN
         WRK (IPRES   ) = XT
         WRK (IPRES+ 1) = YT
         WRK (IPRES+ 2) = CSROT
         WRK (IPRES+ 3) = SNROT
         WRK (IPRES+ 9) = XOT
         WRK (IPRES+10) = YOT
         WRK (IPRES+11) = CSTH
         WRK (IPRES+12) = SNTH
      ENDIF
      RETURN
17002 CONTINUE
      IF(
     - JRING.NE.3
     -)THEN
          IC1 = JCELL
          IF(IC1.GT.24) IC1 = IC1 - 24
          CSROT0 = DIRWR1(IC1,1)
          SNROT0 = DIRWR1(IC1,2)
      ELSE
          IC1 = JCELL - 48
          CSROT0 = DIRWR3(IC1,1)
          SNROT0 = DIRWR3(IC1,2)
      ENDIF
        DRICS  = TRMATC(JCELL,2)
        DRISN  = TRMATS(JCELL,2)
        DRITG  = DRISN/DRICS
        DRISNF = DRISN * .05
        R0 = FSENSW(JRING)
        DR = RINCR (JRING)
        R1   = DR*7.5 + R0
        DX   = R1 * CSROT0 - XCIRC
        DY   = R1 * SNROT0 - YCIRC
        RR   = SQRT(DX**2 + DY**2) * CHARGE
        CSB  = DX / RR
        SNB  = DY / RR
        TGB  = CSB/SNB
        DSBIN1 = DRIVEL(JCELL,1)
        TANBET = (DRITG - TGB) / (TGB*DRITG + 1.)
      IF(
     - NRUN.LE.100
     -)THEN
          DS0 = DSBIN1*.5
          T0CORR = 0.
      ELSE
          DS0 = T0FIX(JRING)*DSBIN1*64.
      DO 13004 I1=1,NCOAR
            IDX = I1
      IF(
     - TANBET.LT.TGCOAR(IDX)
     -)THEN
      GOTO 13005
      ENDIF
13004 CONTINUE
13005 CONTINUE
          KRNG = JRING
          IF(KRNG.EQ.3 .AND. lAND(JCELL,1).EQ.0) KRNG = 4 ! PMF 11/06/99: land
          IBIN = (KRNG-1)*NCOAR  + IDX
          T0CORR = (TANBET-TGCOAR(IDX)) * SLCOAR(IBIN) + T0COAR(IBIN)
      ENDIF
        IPJCOR = ICALIB(5) + JCELL
        CCST01 = ACALIB(IPJCOR     ) * ABS(TANBET)
        CCST02 = ACALIB(IPJCOR+  96) * ABS(TANBET)
        CCST11 = ACALIB(IPJCOR+ 192)
        CCST12 = ACALIB(IPJCOR+ 288)
        CCST21 = ACALIB(IPJCOR+ 384)
        CCST22 = ACALIB(IPJCOR+ 480)
        CCST51 = ACALIB(IPJCOR+ 576) * 10.
        CCST52 = ACALIB(IPJCOR+ 672) / 121.15
        CCST61 = ACALIB(IPJCOR+ 768) * 10.
        CCST62 = ACALIB(IPJCOR+ 864) / 121.15
        CCST81 = ACALIB(IPJCOR+1152)
        JHIT = 0
        NHIT   = 0
        NHGOOD = 0
        ILAYL =-99
        IPCO = IPCO - LHIT
        IPJET4 = IDATA(IQJETC)
        IPJETC = IDATA(IQJETC)*2
        IP0    = IPJETC + 100
        IPCLL  = IPJETC + 2 + JCELL
        IP     = HDATA(IPCLL  ) + IP0
        IP9    = HDATA(IPCLL+1) + IP0
        IPHL   = IPJHTL + 2 + HDATA(IPCLL)/4
15000 CONTINUE
      IF(
     - IP.LT.IP9
     -)THEN
          LB   = IDATA(IPHL)
          ITR1 = LAND(ISHFTR(LB,17),127)
          ITR2 = LAND(ISHFTR(LB, 1),127)
      IF(
     - ITR1.EQ.ITRK .OR. ITR2.EQ.ITRK
     -)THEN
            L0GOOD = 0
      IF(
     - ITR1.NE.0 .AND. ITR2.NE.0
     -)THEN
               NOVL   = NOVL + 1
               L0GOOD = 11
               ID1    = LAND(ISHFTR(LB,27), 31)
               ID2    = LAND(ISHFTR(LB,11), 31)
      IF(
     - ITR1 .EQ. ITRK
     -)THEN
                  IF( ID1 .LT. ID2 ) L0GOOD = 2
                  IF( ID1 .GT. ID2 ) L0GOOD = 12
      ELSE
                  IF( ID2 .LT. ID1 ) L0GOOD = 2
                  IF( ID2 .GT. ID1 ) L0GOOD = 12
      ENDIF
      ENDIF
            LBLR = 0
            IF(ITR1.EQ.ITRK) LBLR = LAND(LB,MKLRT1)
            IF(ITR2.EQ.ITRK) LBLR = LAND(LB,MKLRT2)
            LBSIDE =-1
            IF(LBLR.NE.0) LBSIDE = 1
            LBLR = LBSIDE
            IWIR = HDATA(IP)
            IWIR = ISHFTR(IWIR,3)
            ILAY = LAND(IWIR,15)
            IAMPL = HDATA(IP+1)
            IAMPR = HDATA(IP+2)
            DS =(HDATA(IP+3)) * DSBIN1
            X1   = ILAY * DR + R0
            Z1   = X1*TGTH + ZVERT
            DDS = (1222.9-ABS(Z1))*ABERR(1) + ABERR(6)*R1*CSTHI
      IF(
     - NRUN.LE.100
     -)THEN
              DGR = 0.0
      ELSE
              DGR = ((Z1/1222.9)**2 - 1.) * .075
      ENDIF
            DSC =  DS - DDS + DS0
            Y1   = SWDEPL
            IF(LAND(ILAY,1).NE.0) Y1 =-Y1
            Y1   = (7.5-ILAY)*(CCST52*Z1+CCST51) - CCST62*Z1-CCST61 + Y100046600
            X    = X1*CSROT0 - Y1*SNROT0
            Y    = X1*SNROT0 + Y1*CSROT0 - DGR
      IF(
     - DSC.LE.DRC
     -)THEN
      IF(
     - DSC.LT.DSD2
     -)THEN
      IF(
     - DSC.LT.DSD1
     -)THEN
                  DSC = DSC + DDS1 + (DSC-DSD1)*DRV1
      ELSE
                  DSC = DSC + DDS2 + (DSC-DSD2)*DRV2
      ENDIF
                IF(DSC.LT.0.1) DSC = 0.1
      ELSE
                DSC = (DSC-DSD2)/(DRC-DSD2) * T0CORR + DSC
      ENDIF
              DXR  = DSC * CSB
              DYR  = DSC * SNB
              DXL =-DXR
              DYL =-DYR
      ELSE
              DSC = DSC + T0CORR
      IF(
     - ILAY.LT. 3
     -)THEN
                DILAY =-(ILAY- 3)**2
                DSCL  = (DILAY*CCST11 + 1.) * DSC * (1. - CCST81)
                DSCR  = (DILAY*CCST12 + 1.) * DSC * (1. + CCST81)
      ELSE
      IF(
     - ILAY.GT.12
     -)THEN
                DILAY =-(ILAY-12)**2
                DSCL  = (DILAY*CCST21 + 1.) * DSC * (1. - CCST81)
                DSCR  = (DILAY*CCST22 + 1.) * DSC * (1. + CCST81)
      ELSE
                DSCL = DSC * (1. - CCST81)
                DSCR = DSC * (1. + CCST81)
      ENDIF
      ENDIF
      IF(
     - DSC.GT.ABERR(7)
     -)THEN
                DWIR  = ILAY - 7.5
                DWIRC = DSC*DRISNF
                DWIRL = DWIR + DWIRC
                DWIRR = DWIR - DWIRC
                DSCL  = (DSCL-ABERR(7))*DWIRL*CCST01 + DSCL
                DSCR  =-(DSCR-ABERR(7))*DWIRR*CCST02 + DSCR
      ENDIF
              DXR  = (DSCR-DRC)*DRISN + DRC*CSB
              DYR  = (DSCR-DRC)*DRICS + DRC*SNB
              DXL  =-(DSCL-DRC)*DRISN - DRC*CSB
              DYL  =-(DSCL-DRC)*DRICS - DRC*SNB
      ENDIF
            XL   = DXL + X - XT
            YL   = DYL + Y - YT
            XXL  = XL*CSROT + YL*SNROT
            YYL  =-XL*SNROT + YL*CSROT
            XR   = DXR + X - XT
            YR   = DYR + Y - YT
            XXR  = XR*CSROT + YR*SNROT
            YYR  =-XR*SNROT + YR*CSROT
            CALL AMPS2Z( IP,IPJET4,ZZ,WW,LZGOOD)
            NLRSOL = 1
            IF(DSC.LT.2.0) NLRSOL = 2
            ILRSOL = 0
16000 CONTINUE
            ILRSOL = ILRSOL + 1
            LBGOOD = L0GOOD
      IF(
     - NLRSOL.EQ.1 .AND. LBSIDE.LT.0  .OR.
     ?           NLRSOL.EQ.2 .AND. ILRSOL.EQ.1
     -)THEN
                LBSIDE =-1
                XX  = XXL
                YY  = YYL
      ELSE
                LBSIDE = 1
                XX  = XXR
                YY  = YYR
      ENDIF
              IF(LBSIDE.NE.LBLR) LBGOOD = LBGOOD + 1
      IF(
     - ILAY.NE.ILAYL .OR. LBGDL.LE.1.AND.LBGOOD.LE.2
     -)THEN
                LBREG = 1
                JHIT = JHIT + 1
                IPCO = IPCO + LHIT
      ELSE
                LBREG = 0
                ZWZ = WRK(IPCO+10)
                IF(LBGOOD.LT.IZW) LBREG = 1
      ENDIF
      IF(
     - LBREG.NE.0
     -)THEN
                NHIT   = NHIT   + 1
                IF(LBGOOD.LE.2) NHGOOD = NHGOOD + 1
      IF(
     - INDEX.NE.4
     -)THEN
                   IRESAR( 1) = ILAY
                   IRESAR( 2) = IP
                   IRESAR( 3) = LBSIDE
                   RESAR ( 4) = XX
                   RESAR ( 5) = YY
                   RESAR ( 6) = ZZ
                   RESAR ( 7) = XX - XOT
                   IF(INDX.EQ.1) RESAR ( 7) = SQRT(XX**2 + YY**2)
                   IRESAR( 8) = LZGOOD
                   RESAR ( 9) = DSC
                   IRESAR(10) = JCELL
                   IRESAR(11) = LBGOOD
                   RESAR (12) = TANBET
                   IRESAR(13) = JRING
                   RESAR (14) = 0.
      ELSE
                   HRESAR( 1) = JCELL
                   HRESAR( 2) = ILAY
                   HRESAR( 3) = LZGOOD
                   HRESAR( 4) = LBGOOD
                   HRESAR( 5) = 1
                   HRESAR( 6) = IP-IPJETC
                   RESAR ( 4) = XX
                   RESAR ( 5) = YY
                   RESAR ( 6) = ZZ
                   UX=XX-ADATA(IPTR+5)
                   UY=YY-ADATA(IPTR+6)
                   UU=SQRT(UX**2+UY**2)
                   CURVXY=ADATA(IPTR+25)
                   IF(ABS(CURVXY).LT.1.E-8) CURVXY = SIGN(1.E-8,CURVXY)
            IF(ABS(CURVXY*UU).GT.1.E-5) UU=2.*SIN(.5*CURVXY*UU)/CURVXY
                   IF(UX*ADATA(IPTR+8)+UY*ADATA(IPTR+9).LT.0.) UU=-UU
                   RESAR ( 7) = UU
                   RESAR ( 8) = WW
      ENDIF
                CALL MVC(WRK(IPCO),0,RESAR(1),0,LHBIT)
                ILAYL = ILAY
                LBGDL = LBGOOD
      ENDIF
      IF(.NOT.(
     - ILRSOL.GE.NLRSOL
     -))GOTO 16000
16001 CONTINUE
      ENDIF
        IPHL = IPHL + 1
        IP   = IP   + 4
      GOTO 15000
      ENDIF
15001 CONTINUE
        IPCO = IPCO + LHIT
      GOTO IZZZ02
17000 CONTINUE
        IQJETC = IBLN('JETC')
        IQHEAD = IBLN('HEAD')
        DRC = RINCR(1)*.5 * DRICOS
        IPHEAD = IDATA(IQHEAD)*2
        NRUN = HDATA(IPHEAD+10)
      IF(
     - NRUN.LE.100
     -)THEN
          DSD0   = .0
          DSD1   = .0
          DSD2   = .0
          DDS0   = .0
          DDS1   = .0
          DDS2   = .0
          DRV1   = .0
          DRV2   = .0
      ELSE
          DSD0   =-0.400
          DSD1   = 0.300
          DSD2   = 2.500
          DDS0   = 0.720
          DDS1   = 0.330
          DDS2   = 0.0
          DRV1   = (DDS0-DDS1) / (DSD0-DSD1)
          DRV2   = (DDS1-DDS2) / (DSD1-DSD2)
      ENDIF
        I9 = NCOAR - 1
      DO 13006 I1=2,I9
          IF(I1.GT.2) TGCOAR(I1   ) = TGCOAR(I1- 1) + DTGB
          SLCOAR(I1   ) = (T0COAR(I1   )-T0COAR(I1- 1)) / DTGB
          SLCOAR(I1+15) = (T0COAR(I1+15)-T0COAR(I1+14)) / DTGB
          SLCOAR(I1+30) = (T0COAR(I1+30)-T0COAR(I1+29)) / DTGB
          SLCOAR(I1+45) = (T0COAR(I1+45)-T0COAR(I1+44)) / DTGB
13006 CONTINUE
13007 CONTINUE
      GOTO IZZZ01
      END

C   16/08/85 508301807  MEMBER NAME  TAGINT   (S)           FORTRAN
C   12/03/84 412041843  MEMBER NAME  TAGINT   (S)           FORTRAN
C
C
C
C
C
C------  T A G I N T  ------  T A G I N T  ------  T A G I N T  ------
C
C------  T A G I N T  ------  T A G I N T  ------  T A G I N T  ------
C
C------  T A G I N T  ------  T A G I N T  ------  T A G I N T  ------
C
C
C
C
      SUBROUTINE TAGINT(*)
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C         THIS IS THE INITIALISATION ROUTINE THAT SHOULD BE CALLED
C      ONCE BEFORE ANALYZING ANY EVENTS USING THE TAGGING ROUTINES.
C      TO BE PRECISE IT MUST BE CALLED ONCE PER EVENT TO SET UP
C      THE CWORK COMMON AND TO CLEAR OTHER TAGG COMMONS ETC.
C
C      IT DOES A RETURN 1 IF TAGMRK DOES A RETURN 1 ,WHICH IT DOES
C      IF THE 'HEAD' BANK IS MISSING
C
C      MOD : 13/03/84  A.J.FINCH   NO MESSAGES WRITTEN IF  GRAPHICS
C                                     PACKAGE CALLED THIS ROUTINE
C      MOD : 18/06/84  J. NYE      USES IFLMRK --- SEE TAGMRK
C      MOD : 22/06/84  J. NYE      NO OUTPUT
C LAST MOD : A.J.FINCH 16/08/85 INCLUDED SETTING OF ISTMZ ETC., FOR
C                                     GRAPHICS PROGRAM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cgraph.for"
C
#include "comtag.for"
C
#include "cwktag.for"
C
C
C-----------------------------------------------------------------------
C
C
C
        DIMENSION IDUM(380)
        EQUIVALENCE (IDUM(1),MARK    )
C
        COMMON / CACLS  /  IACLS( 70)
C
        COMMON / CTAGG0 / ITAGG0( 34)
C
        COMMON / CTAGG1 / ITAGG1( 20)
C
        COMMON / CTAGG2 / ITAGG2(260)
C
C
C
C
C------------------------ C O D E --------------------------------------
C
C
C
C
C---                                     CLEAR ARRAYS
C
C
       CALL VZERO(   IDUM , 380)
       CALL VZERO(  IACLS ,  70)
       CALL VZERO( ITAGG0 ,  34)
       CALL VZERO( ITAGG1 ,  20)
       CALL VZERO( ITAGG2 , 260)
C
C
C---                                     INITIALIZE OTHER VARIABLES
C
C
       NCLST  = 0
       NNEI   = 0
       ISTMZ  = 0
       ISTPZ  = 0
       IENDMZ = 0
       IENDPZ = 0
C
C
C---                                     DECIDE ON DETECTOR MARK
C
C
C   CALL TAGMRK TO CHOOSE 'MARK'
C
C
      CALL TAGMRK(*100)
C
C
C---                                     CREATE NEIGHBOUR LIST IF
C---                                     FIRST EVENT
C
C
C   TAGNEB  GENERATES THE NEIGHBOUR LIST
C   IT NEED ONLY BE CALLED ONCE PER JOB
C   FLAG  LISTOK = 1 AFTERWARDS
C
       IF ( LISTOK .NE. 1 ) CALL TAGNEB
C
C
C---                                     SET UP 'MARK' DEPENDENT VALUES
C
C
C
       IF ( MARK .EQ. 0 ) GOTO 10
       IF ( MARK .EQ. 1 ) GOTO 1
       IF ( MARK .EQ. 2 ) GOTO 2
       WRITE(6,6999)MARK
6999   FORMAT('  TAGINT: ILLEGAL VALUE OF MARK: ',I10,/,
     1'                   SHOULD BE 0,1 OR 2 ')
      RETURN
C
C
C----------------------------------------MARK = 0  1979/80 DATA
C
C
   10  CONTINUE
       ISTMZ     =  1
       ISTPZ     = 97
       IENDMZ    = 96
       IENDPZ    = 192
C
       RETURN
C
C
C----------------------------------------MARK = 1  1981/82 DATA
C
C
    1  CONTINUE
       ISTMZ     =  1
       ISTPZ     = 33
       IENDMZ    = 32
       IENDPZ    = 64
C
       RETURN
C
C
C----------------------------------------MARK = 2  1983 -> DATA
C
C
    2  CONTINUE
       ISTMZ     =  1
       ISTPZ     = 25
       IENDMZ    = 24
       IENDPZ    = 48
C
       RETURN
C
C
C----------------------------------------R E T U R N   1----------------
C
C
C---                                     HERE IF TAGMRK DID RETURN 1
C
C
  100  RETURN 1
       END

      SUBROUTINE THRUNB( P, NP, NMAXP, PTHR, AXIS, ITMERR )
      DIMENSION P(1), AXIS(3)
      DIMENSION PIN(320), IPERM(80),IPS(320),PS(320)
      COMMON / CWORK / WORK(720)
      EQUIVALENCE (WORK(1),PIN(1)),(WORK(321),IPERM(1))
      EQUIVALENCE (WORK(401),PS(1)),(WORK(401),IPS(1))
      DATA IPINC / 4 /
      DATA NLIMIT / 15 /
      DATA NSEC / 2 /
      ITMERR = 0
      NMAXP1 = NMAXP
      IF(
     -  NP.GE.NLIMIT .AND. ( NMAXP.EQ.0 .OR. NMAXP.GT.NLIMIT )
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      NMAXP1 = NLIMIT
      ENDIF
      NTOT = NP
      NP1 = NTOT
      IF(
     - NTOT.GT.NMAXP1 .AND. NMAXP1.NE. 0
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      NTOT = NMAXP1 - 1
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ELSE
      CALL UCOPY( P, PIN, NTOT*4 )
      ENDIF
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      ASSIGN 17009 TO IZZZ05
      GOTO 17008
17009 CONTINUE
      RETURN
17000 CONTINUE
      WRITE(6,9101) NP,NLIMIT,NMAXP
 9101 FORMAT(' +++++  WARNING FROM THRUST ROUTINE  +++++'/
     *       2X,I4,' ARE TOO MANY INPUT VECTORS. NLIMIT=',I4,
     *' INPUT CUTOFF NMAXP=',I4,'.PTHR VAL. FOR NMAXP=NLIMIT WAS TAKEN')
      GOTO IZZZ01
17002 CONTINUE
      DO 13000 J=1,NTOT
      IPERM(J) = J*4
13000 CONTINUE
13001 CONTINUE
      M = NTOT / 2
15000 CONTINUE
      IF(
     -  M.GT.0
     -)THEN
      K = NTOT - M
      DO 13002 J=1,K
      I = J
15002 CONTINUE
      IF(
     -  I.GT.0
     -)THEN
      ILOW = IPERM(I)
      IHIGH = IPERM(I+M)
      IF(
     -  P(IHIGH) .GT. P(ILOW)
     -)THEN
      IPERM(I) = IHIGH
      IPERM(I+M) = ILOW
      I = I - M
      ELSE
      GOTO 15003
      ENDIF
      GOTO 15002
      ENDIF
15003 CONTINUE
13002 CONTINUE
13003 CONTINUE
      M = M/2
      GOTO 15000
      ENDIF
15001 CONTINUE
      GOTO IZZZ02
17004 CONTINUE
      DO 13004 J=1,NTOT
      IPJ = IPERM(J)
      J4 = J*4
      PIN(J4  ) = P(IPJ  )
      PIN(J4-1) = P(IPJ-1)
      PIN(J4-2) = P(IPJ-2)
      PIN(J4-3) = P(IPJ-3)
13004 CONTINUE
13005 CONTINUE
      GOTO IZZZ03
17006 CONTINUE
      NUP = NTOT*4 - 4
      K = 5
      IPS(1) = 1
      IPS(K) = 1
      PS(2) = 0.
      PS(3) = 0.
      PS(4) = 0.
      PM2 = 0.
16000 CONTINUE
      ASSIGN 17011 TO IZZZ06
      GOTO 17010
17011 CONTINUE
      IF(
     - IPS(K) .LT. NUP
     -)THEN
      ASSIGN 17013 TO IZZZ07
      GOTO 17012
17013 CONTINUE
      ELSE
      ASSIGN 17015 TO IZZZ08
      GOTO 17014
17015 CONTINUE
      ENDIF
      IF(.NOT.(
     - IPS(1) .NE. 1
     -))GOTO 16000
16001 CONTINUE
      AXISL = SQRT( PM2)
      DO 13006  J=1,3
      AXIS(J) = AXIS(J) / AXISL
13006 CONTINUE
13007 CONTINUE
      PSUM = 0.
      NIPINC = NTOT * 4
      DO 13008 J = 4,NIPINC,4
      PSUM = PSUM + PIN(J)
13008 CONTINUE
13009 CONTINUE
      PTHR = 2. * AXISL / PSUM
      GOTO IZZZ04
17008 CONTINUE
      NIPINC = NP1*IPINC
      SPCOS = 0.
      PSUM = 0.
      DO 13010 J=1,NIPINC,IPINC
      SPCOS = SPCOS + ABS( AXIS(1)*P(J)+AXIS(2)*P(J+1)+AXIS(3)*P(J+2) )
      PSUM = PSUM + P(J+3)
13010 CONTINUE
13011 CONTINUE
      PTHR = SPCOS / PSUM
      GOTO IZZZ05
17010 CONTINUE
      J = IPS(K)
      PS(K+1) = PS(K-3) + PIN(J  )
      PS(K+2) = PS(K-2) + PIN(J+1)
      PS(K+3) = PS(K-1) + PIN(J+2)
      PCL2 = PS(K+1)*PS(K+1) + PS(K+2)*PS(K+2) + PS(K+3)*PS(K+3)
      IF(
     -  PCL2 .GT. PM2
     -)THEN
      PM2 = PCL2
      AXIS(1) = PS(K+1)
      AXIS(2) = PS(K+2)
      AXIS(3) = PS(K+3)
      ENDIF
      GOTO IZZZ06
17012 CONTINUE
      K = K + 4
      IPS(K) = IPS(K-4) + 4
      GOTO IZZZ07
17014 CONTINUE
      K = K - 4
      IPS(K) = IPS(K) + 4
      IF(
     -  JUHR(NSEC) .EQ. 2
     -)THEN
      ASSIGN 17017 TO IZZZ09
      GOTO 17016
17017 CONTINUE
      RETURN
      ENDIF
      GOTO IZZZ08
17016 CONTINUE
      AXIS(1) = 0.
      AXIS(2) = 0.
      AXIS(3) = 1.
      PTHR = .5
      ITMERR = 1
      WRITE(6,9102) NSEC,NP,NMAXP,NLIMIT
 9102 FORMAT(' +++++++   TIME PROBLEMS IN THRUST - ROUTINE   ++++++++'/
     *       '        REMAINING TIME IS LESS THAN ',I4,' SECS.'/
     *       '        ',I4,' ARE TOO MANY INPUT VECTORS.  NMAXP =',I4,
     *       ' NLIMIT =',I4/
     *       '         AXIS WAS SET TO Z AXIS AND PTHR = .5')
      GOTO IZZZ09
      END

C   07/06/96 606071903  MEMBER NAME  PPEAK    (S4)          FORTG1
      SUBROUTINE PPEAK(NA)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL Q(10,3)
      IF(NA.EQ.0) GOTO 10
      CALL BLOC(IND,'PEA*',NA,&100)
      GOTO 30
   10 CALL BPOS('PEA*')
   20 CALL BNXT(IND,&100)
   30 KAMAX=IW(IND+8)+1
      IF(KAMAX.EQ.0) GOTO 60
      NNA=IW(IND-2)
      IP=0
      DO 50 K=1,KAMAX
      KM=K-1
      CALL QPEAK(NNA,KM,Q)
      IF(Q(1,1).EQ.0.0) GOTO 50
      IF(IP.EQ.0) WRITE(6,101) NNA
      IP=1
      JJ=Q(2,1)+0.5
      WRITE(6,102) KM,((Q(I,J),I=1,10),J=1,JJ)
      IF(NA.EQ.0) GOTO 50
      NB=IW(IND+7)
      INDK=IND+10+KM*(NB+2)
      CALL HISTPR(RW(INDK+1),NB,RW(IND+5),RW(IND+6))
   50 CONTINUE
   60 IF(NA.EQ.0) GOTO 20
  100 RETURN
  101 FORMAT('0-------------'/' UPEAK',I8,7X,'KA',5X,'ENTR.',
     1   5X,'POSITION',5X,'SIGMA',6X,'LEFT',5X,'RIGHT',4X,
     2   'FRACTION  SIGNIF CONTENT    +-')
  102 FORMAT(13X,I10,F10.0,F5.0,G12.5,3G10.3,4F8.2/
     1   (23X,F10.0,F5.0,G12.5,3G10.3,4F8.2))
      END

C   19/02/84 402192315  MEMBER NAME  RDDDCL   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDDDCL( NHITS, HITS, IDEAD )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN    27/07/79 :  DEAD CELL SIMULATION
C
C   LAST MOD: E. ELSEN     5/03/80 :
C
C   SET DEAD WIRES IN ARRAY HITS WITH NHITS HITS TO
C   ZERO . IDEAD COUNTS THE ERASED WIRES
C   NDEAD = NUMBER OF DEAD SINGLE WIRES  ( LIST IN HITD      0-1535 )
C   NCDEAD = NUMBER OF DEAD CELLS        ( LIST IN HCELLD    1-96 )
C   ALL CONSTANTS BLOCKDATA SET IN RDSTAT
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10)
C
      DIMENSION  HITS(1)
C
C------------------  C O D E  ------------------------------------------
C
      IDEAD = 0
      IF( NHITS .LE. 0 ) RETURN
C                                           LOOP OVER HITS
C                                           AND DEAD WIRES
      N4 = NHITS * 4
      IF( NDEAD .LE. 0 ) GO TO 1000
      I4 = 1
      J = 1
C
  100 IF( HITD(J) - HITS(I4)/8 ) 200, 300, 400
C                                           INCREMENT TO NEXT DEAD WIRE
  200 J = J + 1
      IF( J .GT. NDEAD ) GO TO 1000
      GO TO 100
C                                           DEAD WIRE
  300 HITS(I4) = 0
      IDEAD = IDEAD + 1
C                                           NEXT HIT
  400 I4 = I4 + 4
      IF( I4 .GT. N4 ) GO TO 1000
      GO TO 100
C                                           LOOP OVER HITS
C                                           AND DEAD CELLS
 1000 CONTINUE
      IF( NCDEAD .LE. 0 ) GO TO 8000
      I4 = 1
      J = 1
C
 1100 IF( HCELLD(J) - HITS(I4)/128-1 ) 1200, 1300, 1400
C                                           INCREMENT TO NEXT DEAD CELL
 1200 J = J + 1
      IF( J .GT. NCDEAD ) GO TO 8000
      GO TO 1100
C                                           DEAD WIRE
 1300 HITS(I4) = 0
      IDEAD = IDEAD + 1
C                                           NEXT HIT
 1400 I4 = I4 + 4
      IF( I4 .GT. N4 ) GO TO 8000
      GO TO 1100
C
 8000 RETURN
      END

C   07/06/96 606071839  MEMBER NAME  CNXT     (S4)          FORTG1
      SUBROUTINE CNXT(IND,IER)
C     BOS SUBPROGRAM =1.11=
#include "acs.for"
      COMMON/BCS/IW(1)
      EXTERNAL BPOS
      IF(KPOS.EQ.0) GOTO 10
      IND=IW(KPOS)
      KPOS=0
      GOTO 100
   10 IND=IW(IND-1)
  100 RETURN
      END

C   14/02/87 805191458  MEMBER NAME  ZE4VPKO1 (S)           FORTRAN77
      SUBROUTINE ZE4VPK( IGEN )
C-----------------------------------------------------------
C VERSION OF 21/11/86       M.ZIMMER
C MODIFIED   23/01/87       M.ZIMMER
C MODIFIED   14/02/87       G.ECKERLIN  (ZE4INI INCLUDED)
C MODIFIED   23/02/87       G.ECKERLIN / M.ZIMMER
C MODIFIED   02/04/87       G.ECKERLIN  (PARTONS INCLUDED FOR MC)
C LAST MOD   02/04/87       G.ECKERLIN  (NO CALL TO ZE4VEK FOR MC)
C LAST MOD   09/07/87       M ZIMMER    (NEW TRACEBACK IMPLEMENTED)
C LAST MOD   21/07/87       M ZIMMER    (EXTERNAL REFERENCES ADDED)
C LAST MOD   27/08/87       E ELSEN     (ITYP HANDLING, DEDX MC)
C LAST MOD   28/08/87       E ELSEN     (ZE4VMC CALL, EAMCDE CALL)
C LAST MOD   25/11/87       E ELSEN     (EAMCDE ONLY IF NDEDX GE 0
C LAST MOD   26/01/88       E ELSEN     (COPE WITH MISSING PATR
C LAST MOD   13/04/88       E ELSEN     (MUON CODE)
C LAST MOD   13/04/88       M ZIMMER    (BANK EXTENDED ( DATE , NDEDX )
C LAST MOD   27/04/88       E ELSEN     COMFIT RESULT STORED
C NEW VERSION FOR NEW ZE4V-BANK
C PACK INFORMATION INTO ZE4V-BANK FROM PATR AND LGCL BANKS
C IMODE = 0 UNCONNECTED LG-CLUSTERS AND PATR
C       = 1 UNCONNECTED LG-CLUSTERS
C       = 2 ALL CLUSTERS AND PATR
C       = 3 ALL CLUSTERS
C       = 4 CHARGED ONLY ( ALL MASSES PI )
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON P(10,400)
      DIMENSION IP(10,100),HP(20,1)
      EQUIVALENCE (P(1,1),IP(1,1),HP(1,1))
C
      DIMENSION VECTB(1000)
C
      DIMENSION PACT(3), R(3), RDOCA(3)
      INTEGER NWARN(2) / 2*0 /
      DATA IEV / 0 /, IEVLIM / 0 /
C                                            FORMAT OF ZEHD BANK
      DIMENSION HRUN(2)
      EQUIVALENCE (IRUN,HRUN(1))
C                                   MC INFO IN ZEHD NOT IMPLEMENTED
      DATA LMCH / 0 /
      DATA MCFLAG / 0 /
C
      EXTERNAL VECSUB
      EXTERNAL ZE4VMC
      EXTERNAL ZE4VUN
C
C                                           CUT PARAMETERS
C                                           RMIN CUT
      DATA RMINCT /  50. /
C                                           Z-CUT
      DATA ZCT    / 350. /
C                                           MIN R-PHI-HITS
      DATA NRPHCT / 20 /
C                                           MIN R-Z-HITS
      DATA NRZCT  / 12 /
C                                           MOMENTUM CUT
      DATA PCT   / .05 /
C                                           LG MIN ENERGY
      DATA ELGPHM / .150 /
C                                           LG SUBTRACTION ENERGY
      DATA ELGMIN /    .350 /
C
      DATA IMODE / 2 /
C                                           FORMAT OF ZE4V BANK
CHANGED :  LTCH (12 )  31.3.88 MZ
C
      DATA  LH / 31 /, LT / 9 /, LVX / 3 /, LMC / 18 /,
     & LTCH / 14 /, LTNE / 5 /, LTRE / 5 /
C                                            FORMAT OF ZEHD BANK
      DATA HVERS/ 1 /, LZHD / 3 /
      DATA LCUT / 12 /
C
      LVECS = 0
      GO TO 1

      ENTRY ZE4VIN( IGEN )
C--------------------------------------------------------
C  ENTRY FOR FIRST EVENT
C  CREATES ZEHD BANK FIRST
C  CHECKS IF MONTE CARLO OR DATA
C--------------------------------------------------------
      NPZEHD = IW(IBLN('ZEHD'))
C                                   DELETE OLD BANK
      IF (NPZEHD.GT.0) CALL BDLS('ZEHD',IGEN)
C                                      INIT ERROR MESSAGES
      CALL FEHLTX( 1,'ERROR CREATING ZEHD-BANK')
      CALL FEHLTX( 2,'NO PATR / LGCL BANK ')
      CALL FEHLTX( 3, 'NUMBER OF CHARGED TRACKS <= 0 IN PATR')
      CALL FEHLTX( 4, 'ERROR WHILE CREATING ZIM1-BANK')
      CALL FEHLTX( 5, 'NO TRACKS IN ZE4V-BANK')
      CALL FEHLTX( 11,'NUMBER OF HITS IN R-PHI LT CUT')
      CALL FEHLTX( 12,'NUMBER OF HITS IN R-Z LT CUT')
      CALL FEHLTX( 13,'Z- CUT NOT PASSED')
      CALL FEHLTX( 14,'RMIN CUT NOT PASSED')
      CALL FEHLTX( 15,'MOMENTUM CUT NOT PASSED')
      CALL FEHLTX( 17,'NO CONNECTED LG-CLUSTER')
      CALL FEHLTX( 18,'JCLUS > 0 BUT NO LGCL-BANK')
      CALL FEHLTX( 19,'CORR. ECL < 0 (NO CL. IN LGANAL)')
C                                   CHECK IF MONTE CARLO
      IRUN = IRNEVT(DUMMY)
      IF (HRUN(1).LT.100) MCFLAG = 1
C                                   CALC LENGTH OF BANK
      LZEHD = LZHD + LCUT + LMCH
C                                   CREATE NEW BANK
      CALL BCRE(NPZEHD,'ZEHD',IGEN,LZEHD,&30,IER)
      CALL BSAW(1,'ZEHD')
C                                   FILL HEADER PART
      HW(NPZEHD*2 + 1) = HVERS
C                                   FLAG MC>1/DATA=0
      HW(NPZEHD*2 + 2) = MCFLAG
C                                   # OF WORDS FOR HEADER PART
      HW(NPZEHD*2 + 3) = LZHD
C                                   # OF WORDS FOR CUT INFO
      HW(NPZEHD*2 + 4) = LCUT
C                                   # OF WORDS FOR MC INFO
      HW(NPZEHD*2 + 5) = LMCH
C                                   NOT USED
      HW(NPZEHD*2 + 6) = 0
C                                   CUT INFO PART
      NPZECT = NPZEHD + LZHD
      RW(NPZECT + 1) = 0.
C
      RW(NPZECT + 2) = 0.
C
      HW(NPZECT*2 + 5) = NRPHCT
C
      HW(NPZECT*2 + 6) = NRZCT
C
      RW(NPZECT + 4) = RMINCT
C
      RW(NPZECT + 5) = ZCT
C
      RW(NPZECT + 6) = PCT
C
      RW(NPZECT + 7) = 0.
C
      RW(NPZECT + 8) = 0.
C
      RW(NPZECT + 9) = 0.
C
      RW(NPZECT + 10) = ELGMIN
C
      RW(NPZECT + 11) = ELGPHM
C
      RW(NPZECT + 12) = .5
C                                   MC INFO PART
C     NPZEMC = NPZECT + LCUT
C     DO 20 IC = 1, LMCH
C       RW(NPZECT + IC) = 0.       NOT IMPLEMENTED !!!!!
C20   CONTINUE
      LVECS = 0
      GOTO 1
C                                  ERROR IN BCRE
 30   CONTINUE
      LVECS = 0
      CALL FEHLER( 1, &1 )

      ENTRY ZE4VUP( NST, N, IGEN )
C--------------------------------------------------------
C  ENTRY FOR VECSUB OPTION
C  LEAVES PARTICLES IN BLANK COMMON
C--------------------------------------------------------
      LVECS = 1
    1 CONTINUE
      IEV = IEV + 1
C
C
C                                      LOOK FOR BANKS
CC    NPZE4V = IW( IBLN('ZE4V'))
CC    IF( NPZE4V .GT. 0 ) CALL BDLS( 'ZE4V',IGEN)
      CALL BDLS( 'ZE4V',IGEN)
C                                      PATR - NBANK
      NPPATR = IW( IBLN('PATR'))
      IF( NPPATR .LE. 0 .AND. IMODE .EQ. 4 ) CALL FEHLER( 2, &8000 )
      NPLGCL = IW( IBLN('LGCL'))
      IF( NPPATR .LE. 0 .AND. NPLGCL .LE. 0 ) CALL FEHLER (2,&8000 )
      IF( NPLGCL .LE. 0 .AND. IMODE .EQ. 1
     &.OR.NPLGCL .LE. 0 .AND. IMODE .EQ. 3 ) CALL FEHLER( 2, &8000 )
C                                      IF NOT MC LMC = 0
      IF (MCFLAG.EQ.0) LMC = 0
C
      NVX = 1
      LHEAD = LH + NVX*LVX + LMC
C                                           CREATE ZE4V HEAD
      CALL BCRE( NPZE4V, 'ZE4V', IGEN, LHEAD, &8100, IER )
      CALL BSAW( 1, 'ZE4V' )
      HW(NPZE4V*2+ 1) = LHEAD
C                                      VERTEX PART
      HW(NPZE4V*2+ 2) = LVX
      HW(NPZE4V*2+ 3) = NVX
C                                      MONTE-CARLO PART
      HW(NPZE4V*2+ 4) = LMC
C                                      GENARAL TRACK PART
      HW(NPZE4V*2+ 5) = LT
C                                      TOTAL NUMBER OF PARTICLES
      HW(NPZE4V*2+ 6) = 0
C                                      CHARGED TRACK PART
      HW(NPZE4V*2+ 7) = LTCH
      HW(NPZE4V*2+ 8) = 0
C                                      NEUTRAL TRACK PART
      HW(NPZE4V*2+ 9) = LTNE
      HW(NPZE4V*2+10) = 0
C                                      RECONSTRUCTED TRACK PART
      HW(NPZE4V*2+11) = LTRE
      HW(NPZE4V*2+12) = 0
C                                      RUN/EVENT #
      IW(NPZE4V  + 7) = IRNEVT( DUMMY )
C                                           EBEAM IN GEV
      EBE = .001*EBEAM( HW(NPZE4V*2+13 ) )
      RW(NPZE4V  + 8) = EBE
C
CHANGED 31.3.88 MZ ( DATE ADDED )
C
      NPHEAD = IW( IBLN( 'HEAD' ))
      IF ( NPHEAD .GT. 0 ) THEN
        NPH2 = 2 * NPHEAD
        HW( 2*NPZE4V + 57 ) = HW( NPH2 + 6 )*100 + HW( NPH2 + 7 )
        HW( 2*NPZE4V + 58 ) = HW( NPH2 + 8 )
      ELSE
        IW( NPZE4V + 29 ) = 0
      ENDIF
C---END MOD
C                                      NOT USED
      RW(NPZE4V  +30) = 0.
C
C                                      ACCEPT EVENT BY MCREDU
      MRFLAG = -1
      CALL MCREDU( 0., &2040 )
C                                      EVENT ACCEPTED
      MRFLAG = 1
 2040 CONTINUE
      IW( NPZE4V + 31 ) = MRFLAG
      NTRVX = 0
      CALL ZE4VVX( R, NTRVX )
C                                           SET VERTEX HERE
      DO 20 I=1,3
         RW(NPZE4V  + LH + I) = R(I)
   20 CONTINUE
C
C$$$$$$---------------------------------    MC PART OF HEADER
C                                           FILLED FROM VECT BANK

      IF(MCFLAG.EQ.0) GOTO 4213
C
      NPVECT = IW(IBLN('VECT'))
      IF(NPVECT.GT.0) GO TO 4119
       WRITE(6,9212) HW(NPZE4V*2+14),HW(NPZE4V*2+13)
9212   FORMAT(' NO VECT BANK IN EVENT ',I8,'  RUN ',I8)
       GOTO 4213
4119  CONTINUE

C                                        START VECT-ANALYSIS
C
C                                        POINTER TO MC PART IN ZE4V
      NPMC = NPZE4V + LH + NVX*LVX
C
      HLENG = IW(NPVECT+1)
      IEVT = IW(NPVECT+3)
      NPARMC = IW(NPVECT+4)
      DO 4118 IMC=1,6
      VECTB(IMC) = FLOAT(IW(NPVECT+IMC))
4118  CONTINUE
      VECTB(7) = RW(NPVECT+7)
      VECTB(8) = RW(NPVECT+8)
      VECTB(9) = FLOAT(IW(NPVECT+9))
      NFLAV = IABS(IW(NPVECT+9))
      VECTB(10) = 0.
      DO 4320 IMC = 1,NPARMC
      JMC = 10 * IMC
      K = JMC + HLENG - 10
      VECTB(JMC+1) = RW(NPVECT+K+1)
      VECTB(JMC+2) = RW(NPVECT+K+2)
      VECTB(JMC+3) = RW(NPVECT+K+3)
      VECTB(JMC+4) = RW(NPVECT+K+4)
      VECTB(JMC+5) = RW(NPVECT+K+5)
      VECTB(JMC+8) = RW(NPVECT+K+8)
      VECTB(JMC+9) = RW(NPVECT+K+9)
      VECTB(JMC+10) = RW(NPVECT+K+10)
      VECTB(JMC+6) = FLOAT(IW(NPVECT+K+6))
      VECTB(JMC+7) = FLOAT(IW(NPVECT+K+7))
4320  CONTINUE
C
C                                        FIND NO OF JETS
C
      NJET = 0
      DO 4110 IMC=1,4
      IND = (NPARMC-IMC+1)*10
      IF(VECTB(IND+7).GE.-100.) GOTO 4313
      NJET = NJET + 1
      RW(NPMC + (IMC-1)*4 + 2) = VECTB(IND+1)
      RW(NPMC + (IMC-1)*4 + 3) = VECTB(IND+2)
      RW(NPMC + (IMC-1)*4 + 4) = VECTB(IND+3)
      RW(NPMC + (IMC-1)*4 + 5) = VECTB(IND+4)
      GOTO 4110
4313  CONTINUE
      RW(NPMC + (IMC-1)*4 + 2) = 0.
      RW(NPMC + (IMC-1)*4 + 3) = 0.
      RW(NPMC + (IMC-1)*4 + 4) = 0.
      RW(NPMC + (IMC-1)*4 + 5) = 0.
4110  CONTINUE
      HW(NPMC*2 + 1) = NJET
      HW(NPMC*2 + 2) = NFLAV
C
4213  CONTINUE
C
C                                           END OF MC PART
C
C$$$$$$---------------------
C
      IF( IMODE .EQ. 1 .OR. IMODE.EQ.3 ) GO TO 1000
C
C                                           PATR TRACKS
      IPPHOT = IBLN('PHOT')
      NPPHOT = IW( IPPHOT )

      IF( NPPATR .LE. 0 )      CALL FEHLER( 3, &1000 )
      NTR = IW( NPPATR + 2 )
      IF( NTR .LE. 0 )      CALL FEHLER( 3, &1000 )
C
      IP0 = IW( NPPATR + 1 ) + NPPATR
      LP = IW( NPPATR + 3 )
      IP9 = IP0 + ( NTR - 1) * LP
C                                      LOCATE HWDS
      CALL CLOC( NPHWDS, 'HWDS', IW(NPPATR-2) )
C                                           LOOP OVER TRACKS
      DO 300 J = IP0, IP9, LP
        NUMTRK = IW( J + 1 )
        NRPHI = IW(J+24)
        IF( NRPHI .LT. NRPHCT ) CALL FEHLER ( 11, &300 )
        NRZ = IW(J+33)
        IF( NRZ .LT. NRZCT )  CALL FEHLER ( 12, &300 )
        AZV = ABS( RW(J+31) )
        IF( AZV .GT. ZCT )         CALL FEHLER ( 13, &300 )
        CALL PRTOCI( J, CAP, RMIN, PHIM, SIG )
        IF( ABS( RMIN ) .GT. RMINCT )    CALL FEHLER ( 14, &300 )
C                                      SET REFERNCE POINT FOR CRDOCA
        CALL CRDOCA( J, R, PACT, RDOCA, CHARGE )
        PTOT = SQRT( PACT(1)**2 + PACT(2)**2 + PACT(3)**2 )
        IF( PTOT .LT. PCT )      CALL FEHLER ( 15, &300 )
C                                      ACCEPT THIS TRACK

C                                      FILL GLOBAL PART FOR EACH TRACK
C                                      EXTEND BANK
        CALL BCHM( NPZE4V, LT+LTCH, IER )
C                                      POINTER TO NEXT ZE4V-WORD
        NP = NPZE4V + LHEAD + HW( NPZE4V*2 + 6) * LT
     &                      + HW( NPZE4V*2 + 8) * LTCH
     &                      + HW( NPZE4V*2 +10) * LTNE
     &                      + HW( NPZE4V*2 +12) * LTRE
        NP2 = NP * 2
C                                      SUM UP # OF TOTAL AND CH. TRKS
        HW(NPZE4V*2+8 ) = HW(NPZE4V*2+8) + 1
        HW(NPZE4V*2+6 ) = HW(NPZE4V*2+6) + 1
C                                      EX,EY,EZ
        DO 1200 I = 1,3
          RW( NP + I ) = PACT(I)/PTOT
 1200   CONTINUE
C                                      # OF VERTEX OF PARTICLE ORIGIN
        HW( NP2 + 9) = 1
C                                      # OF SEC VERTEX
        HW( NP2 +10) = 0
C                                      MOMENTUM
        FAC = 1.
        IF( PTOT .GT. EBE ) FAC = .5*EBE /PTOT
        RW(NP + 6) = PTOT*FAC
        RW(NP + 7) =  CHARGE
C                                      LG-INFORMATION
        JCLUS1 = IW( J + 40 )
        NPLGCL = IW(IBLN('LGCL'))
        SIGECL = 0.
        ECL    = 0.
        JBAREC = -1000
        IF ( NPLGCL .GT. 0 .AND. JCLUS1 .GT. 0 ) THEN
          IPENDE = IW( NPLGCL + 4 )
          IP3 = IW( NPLGCL + 3 )
          NWPCL = IW( NPLGCL + 25 )
          NPOI = NPLGCL + IP3 + (JCLUS1-1) * NWPCL -1
          ECL    = RW( NPOI + 2 )
          SIGECL = RW( NPOI + 3 )
          JBAREC = IW( NPOI + 1 )
        ELSEIF( NPLGCL .GT. 0 .AND. JCLUS1 .LE. 0 ) THEN
          CALL FEHLER( 17, &3123)
        ELSEIF( NPLGCL .LE. 0 .AND. JCLUS1 .GT. 0 ) THEN
          CALL FEHLER( 18, &3123)
        ENDIF
 3123   CONTINUE
C
        NPART = 0
        NPHOT = IW(IPPHOT)
        DO 210 WHILE( NPHOT.GT.0 .AND. NPART.EQ.0 )
          IF(IW(NPHOT+24).EQ.IW(J+1)) NPART = IW(NPHOT+25)
          IF(IW(NPHOT+25).EQ.IW(J+1)) NPART = IW(NPHOT+24)
          NPHOT = IW(NPHOT-1)
  210   CONTINUE
C                                      PATR NUMBER OF PHOT PARTNER
  220   HW( NP2 + 7 ) = NPART
C                                           MC PART
C                                      0 OR PART# IN PALL BANK (HW(+15))
C                                      0 OR ELECTRON ORIGIN    (HW(+16))
        IW( NP + 8 ) = 0
C                                      CHECK FOR MONTE CARLO
        IF( MCFLAG.GT.0 ) THEN
C                                      NEW ENTRY IN ZE4VMC
          CALL ZE4VMC( IW(J+1), NPALL, IORI, ITYPMC, IVECT )
          HW( NP2 + 15) = NPALL
          HW( NP2 + 16) = IORI
          HW( NP2 +  8) = ITYPMC*100
        ELSE
          HW( NP2 +  8) = 0
        ENDIF
C                                      NUMBER OF CORR. TPTR BANK
        NPTPTR = IW(IBLN('TPTR'))
        DO 230 WHILE( NPTPTR.GT.0 .AND. HW(NPTPTR*2+4).NE.NUMTRK )
          NPTPTR = IW(NPTPTR-1)
  230   CONTINUE
        IF( NPTPTR .GT. 0 ) THEN
          HW(NP2 + 17 ) = IW(NPTPTR-2)
        ELSE
          HW(NP2 + 17 ) = 0
        ENDIF
C                                      ADDITIONAL CH. TRACK PART
        HW(NP2 + 18 ) = 1
C                                      CLUSTER-ENRGY IN GEV
        RW(NP + LT + 1 ) = ECL
C                                      ERROR IN CLUSTER-ENRGY
        RW(NP + LT + 2 ) = SIGECL
C                                      INIT MEIER ENERGY
        RW(NP + LT + 3 ) = 0.
C                                      DETECTOR FLAG
        JDETEC = 1000
        IF ( JBAREC .EQ. 0 ) JDETEC = JDETEC + 100
        IF ( IABS(JBAREC) .EQ. 1 ) JDETEC = JDETEC + 1
        HW( NP2 + LT*2 + 7) = JDETEC
C                                      #OF 1. AND 2. CONN. CLUSTER
        HW( NP2 + LT*2 + 8) = JCLUS1
C                                      # IN PATR-BANK
        HW( NP2 + LT*2 + 9) = NUMTRK
C                                      NRPHI + 100*NRZ
        HW( NP2 + LT*2 +10) = NRPHI + 100*NRZ
C                                      (X,Y,Z) TRACK AT DOCA
        RW( NP + LT + 6) = RDOCA( 1 )
        RW( NP + LT + 7) = RDOCA( 2 )
        RW( NP + LT + 8) = RDOCA( 3 )
C
        DEDX = 0.
        SIDEDX = 0.
        MUONQU = 0
        HBETA = 0.
        IF( NPTPTR .GT. 0 ) THEN
C                                      DEDX
          NDEDX = IW( NPTPTR + 72 )
          DEDX = RW( NPTPTR + 73 )
          SIDEDX = RW( NPTPTR + 74 )
C                                      MUON QUALITY FLAG OR 0
          MUONQU = HW( NPTPTR*2 + 96 )
CHANGED  13.4.88
          IF ( MUONQU .EQ. 9 )
     *      HW( NP2 + 8 ) = HW( NP2 + 8 )/100*100 + 3
C                                      TOF RESULTS (BETA)
          IF ( ABS( IW( NPTPTR + 58 )) .EQ. 1 ) THEN
            HBETA = INT( RW( NPTPTR+61 ) * 1000.) * IW( NPTPTR + 58 )
          ENDIF
        ENDIF
C                                      IF NOT FILLED, GENERATE
C                                      FOR MC
        IF( MCFLAG.GT.0 .AND.
     *      NDEDX.GE.0 .AND.  DEDX.EQ.0. .AND. SIDEDX.EQ.0. ) THEN
          CALL EAMCDE( NP, IVECT, DEDX, SIDEDX, NDEDX )
        ENDIF
C
        RW( NP + LT + 9 ) = DEDX
        RW( NP + LT +10 ) = SIDEDX
        RW( NP + LT +11 ) = RMIN
        IW( NP + LT +12 ) = MUONQU
CHANGED 31.3.88 MZ  ( 2HW ADDED )
        HW( NP2 + 2*LT + 25 ) = NDEDX
C
C                                      VTXC RESULTS IF AVAILABLE
        IF( NPHWDS.GT.0 ) THEN
          JHWDS = (J-IP0)/LP*IW(NPHWDS+3) + IW(NPHWDS+1) + NPHWDS
C                                      VTXC HITS
          HW( NP2 + 2*LT + 27 ) = IW( JHWDS + 59 )
          IF( IW(JHWDS+62) .GT. -2 ) THEN
            HW( NP2 + 2*LT + 26 ) = 2
          ELSE
            HW( NP2 + 2*LT + 26 ) = 1
          ENDIF
        ELSE
          HW( NP2 + 2*LT + 26 ) = 0
          HW( NP2 + 2*LT + 27 ) = 0
        ENDIF
        HW( NP2 + 2*LT + 28 ) = HBETA
C
  300 CONTINUE
C                                      SAVE PATR BANK SINCE LG ANALYSIS
C                                      OVERWRITES CLUSTER INFORMATION
      IPPATR = IBLN('PATR')
      NPPATR = IW(IPPATR)
      IF( NPPATR.GT.0 ) THEN
        LPATR = IW(NPPATR)
        CALL BCRE( NPBUF1, '--BU', 1 , LPATR, &8200, IER )
        IF( IER.EQ.0 ) THEN
          CALL UCOPY( RW(NPPATR+1), RW(NPBUF1+1), LPATR )
C                                      PERFORM ELECTRON ANALYSIS
C                                      ON WHOLE EVENT
C                                      WILL SET PATRICLE TYPE AND E-MEIEr
          CALL ZE4VEA
C                                      RESTORE PATR
          NPPATR = IW(IPPATR)
          CALL CLOC( NPBUF1, '--BU', 1 )
          CALL UCOPY( RW(NPBUF1+1), RW(NPPATR+1), LPATR )
          NPZE4V = IW(IBLN('ZE4V'))
        ENDIF
        CALL BDLS( '--BU', 1 )
      ENDIF
C
C
C------------------------------------- NEUTRAL PRIMARY
C
C                                           LGCL BANKS
 1000 IF( IMODE .EQ. 4 ) GO TO 2050
C
      NPLGCL = IW(IBLN('LGCL'))
      IF( NPLGCL .EQ. 0 ) GO TO 2050
C
      NCLST = IW( NPLGCL + 7 )
      IF( NCLST .LE. 0 ) GO TO 2050
C                                           LOOP OF CLUSTERS
C                                           ALL CLUSTERS GET
C                                           CHARGE 0
      IP2 = IW( NPLGCL + 2 )
      IP3 = IW( NPLGCL + 3 )
      NWPCL = IW( NPLGCL + 25 )
      IP0 = NPLGCL + IP3 - 1
      IP9 = IP0 + (NCLST-1) * NWPCL
      JCL = 0
      DO 2000 J=IP0,IP9,NWPCL
        JCL = JCL + 1
C                                           CHECK IF CONNNECTED
        ICONN = IW( J + 8 )
        IF( ICONN.NE.0 .AND. IMODE.LT.2 ) GO TO 2000
        ECL  = RW( J + 2 )
        ETOT = ECL
        SIGECL = RW( J + 3 )
        JBAREC = IW( J + 1 )
C                                      # OF LG-BLOCKS IN  CLUSTER
C                                      MINUS NUMBER OF TRACKS CONN.
        NPCLMP = NPLGCL + IP2 + JCL - 1
        NBLOCK = HW( NPCLMP*2 ) - HW(NPCLMP*2 - 1) + 1 -ICONN/100
        IF (JBAREC .EQ. 0 ) JBAREC = 100
C                                           PATH LENGTH CORREC
        DZDS = 1.
        IF( IW(J+1).EQ.0 ) DZDS = 1./SQRT(1-RW(J+11)**2)
        IF( ICONN .NE. 0 ) ETOT = ETOT - ELGMIN*(ICONN/100)*DZDS
        IF( ETOT .LT. ELGPHM ) GO TO 2000
C
C                                           ACCEPT THIS TRACK
        CALL BCHM( NPZE4V, LT+LTNE, IER )
C                                      POINTER TO NEXT ZE4V-WORD
        NP = NPZE4V + LHEAD + HW( NPZE4V*2 + 6) * LT
     &                      + HW( NPZE4V*2 + 8) * LTCH
     &                      + HW( NPZE4V*2 +10) * LTNE
     &                      + HW( NPZE4V*2 +12) * LTRE
        NP2 = NP * 2
C                                      SUM UP # OF TOTAL AND NE. TRKS
        HW(NPZE4V*2+10) = HW(NPZE4V*2+10) + 1
        HW(NPZE4V*2+6 ) = HW(NPZE4V*2+6 ) + 1
C                                      EX,EY,EZ
        DO 1211 I = 1,3
           RW(NP+I) = RW(J+8+I)
 1211   CONTINUE
C                                      0 OR PATR # OF PHOT PARTNER
        HW( NP2 + 7) = 0
C                                      PART TYPE
        ITYP = 1
        HW( NP2 + 8) = ITYP
C                                      1./2. VERTEX
        HW( NP2 + 9) = 1
        HW( NP2 +10) = 0
C                                      PTOT
        RW(NP  + 6) = ETOT
C                                      CHARGE
        RW(NP  + 7) = 0.
C                                      0 OR PART# IN PALL BANK
        HW( NP2 + 15) = 0
C                                      0 OR ELECTRON ORIGIN
        HW( NP2 + 16) = 0
C                                      TPTR NUMBER
        HW( NP2 + 17) = 0
C                                      0 FOR NEUTRAL PARTICLES
        HW( NP2 + 18) = 0
C                                      CLUSTER-ENERGY IN GEV
        RW( NP + LT + 1 ) = ECL
C                                      ERROR IN CLUSTER-ENERGY
        RW( NP + LT + 2 ) = SIGECL
C                                      CORRECTED CLUSTER ENERGY(NOT YET)
        RW( NP + LT + 3 ) = 0.
C                                      LG DETECTOR PART
        HW( NP2 + LT*2 + 7) = JBAREC
C                                      #OF 1. AND 2. CONN. CLUSTER
        HW( NP2 + LT*2 + 8) = ( J - IP0 ) / NWPCL + 1
C                                      # OF (BLOCKS - CH TRACKS) (1.CL)
        HW( NP2 + LT*2 + 9) = NBLOCK
C                                      # OF (BLOCKS - CH TRACKS) (2.CL)
        HW( NP2 + LT*2 +10) = 0
 2000 CONTINUE
C
C
 2050 CONTINUE
C
      IF( LVECS.NE.0 ) GO TO 2100
         N = HW( NPZE4V*2 + 6 )
         NST = 0
C                                           SAVE AWAY BLANK COMMON
         CALL BCRE( NPBUF, '--BU', 0 , 10*(N+5), &8200, IER )
         CALL UCOPY( P(1,NST+1), RW(NPBUF+1), 10*(N+5) )
 2100 CONTINUE
      IF( IEV.LT.IEVLIM) CALL BPRS( 'ZE4V', IGEN )
      CALL ZE4VUN( NST, N, 0 )
      IF( N.LE.0 ) GO TO 2150
         IF( IEV.LT.IEVLIM) CALL PWRT( NST+1, NST+N, 10000 )
         NPZE4V = IW(IBLN('ZE4V'))
         CALL SPTHAK( NST+1, NST+N, NST+N+4, THR,
     &                              NST+N+1, SPH,
     &                              NST+N+5, AKO, IER )
C                                      SPHERICITY
         CALL UCOPY( P(1,NST+N+1), RW(NPZE4V+ 9), 4 )
         CALL UCOPY( P(1,NST+N+2), RW(NPZE4V+13), 4 )
         CALL UCOPY( P(1,NST+N+3), RW(NPZE4V+17), 4 )
C                                      THRUST
         CALL UCOPY( P(1,NST+N+4), RW(NPZE4V+21), 4 )
C                                      AKOPLANARITY
         CALL UCOPY( P(1,NST+N+5), RW(NPZE4V+25), 4 )
         IF( IEV.LT.IEVLIM) CALL BPRS( 'ZE4V', IGEN )
         IF( IEV.LT.IEVLIM) CALL PWRT( NST+N+1, NST+N+5, 10000 )
C                                           RESTORE BLANK COMMON
 2150 CONTINUE
      IF( LVECS.NE.0 ) GO TO 2200
         CALL UCOPY( RW(NPBUF+1), P(1,NST+1), 10*(N+5) )
         CALL BDLS( '--BU', 0 )
 2200 CONTINUE
C
      GO TO 8000
C
C
C
C                                           BANK ZE4V
      ENTRY ZE4VST( NST, N, IGEN )
C-----------------------------------------------------------
C NEW VERSION  17-11-86    M.ZIMMER
C ONLY A VERY ELEMENTARY FORM OF ZE4V BANK IS FILLED
C ALL PARTICLES GET THE SAME NUMBER OF WORDS ( LT ) AND NO
C ADDITIONAL INFORMATION IS STORED
C STORE MOMENTA FROM VECSUB COMMON INTO ZE4V
C THE PARTICLES ARE STORED IN
C NST+1..NST+N, WHERE N IS SET ON EXIT
C-----------------------------------------------------------
C
      IF( N.LE.0 ) GO TO 5000
C
         CALL BCRE( NPZE4V, 'ZE4V', IGEN, LH+LT*N, &8100, IER )
         CALL BSAW( 1, 'ZE4V' )
         HW(NPZE4V*2+ 1) = LH
         HW(NPZE4V*2+ 2) = 0
         HW(NPZE4V*2+ 3) = 0
         HW(NPZE4V*2+ 4) = 0
         HW(NPZE4V*2+ 5) = LT
         HW(NPZE4V*2+ 6) = N
         HW(NPZE4V*2+ 7) = 0
         HW(NPZE4V*2+ 8) = 0
         HW(NPZE4V*2+ 9) = 0
         HW(NPZE4V*2+10) = 0
         HW(NPZE4V*2+11) = 0
         HW(NPZE4V*2+12) = 0
C                                      RUN/EVENT #
      IW(NPZE4V  + 7) = IRNEVT( DUMMY )
      RW(NPZE4V  + 8) = .001*EBEAM( HW(NPZE4V*2+13 ) )
C
      CALL SPTHAK( NST+1, NST+N, NST+N+4, THR,
     &                           NST+N+1, SPH,
     &                           NST+N+5, AKO, IER )
C                                      SPHERICITY
      CALL UCOPY( P(1,NST+N+1), RW(NPZE4V+ 9), 4 )
      CALL UCOPY( P(1,NST+N+2), RW(NPZE4V+13), 4 )
      CALL UCOPY( P(1,NST+N+3), RW(NPZE4V+17), 4 )
C                                      THRUST
      CALL UCOPY( P(1,NST+N+4), RW(NPZE4V+21), 4 )
C                                      AKOPLANARITY
      CALL UCOPY( P(1,NST+N+5), RW(NPZE4V+25), 4 )
C
         NP = NPZE4V + LH
         N1 = NST + 1
         NN = NST + N
         DO 3000 J=N1,NN
            RW(NP  + 1) = P(1,J)/P(6,J)
            RW(NP  + 2) = P(2,J)/P(6,J)
            RW(NP  + 3) = P(3,J)/P(6,J)
            HW(NP*2+ 7) = HP(18,J)
            HW(NP*2+ 8) = HP(16,J)
            HW(NP*2+ 9) = 0
            HW(NP*2+10) = 0
            RW(NP  + 6) = P(6,J)
            RW(NP  + 7) = P(7,J)
            HW(NP*2+15) = HP(19,J)
            HW(NP*2+16) = HP(20,J)
            HW(NP*2 + 17) = 0
            HW(NP*2 + 18) = -1
C
            NP = NP + LT
 3000    CONTINUE
C
 5000 CONTINUE
      GO TO 8000
C
C
 8000 CONTINUE
      NPZE4V = IW( IBLN('ZE4V'))
      IF ( HW(NPZE4V*2+6).LE.0) THEN
        CALL FEHLER( 5, &8001 )
 8001   CALL BDLS( 'ZE4V',IGEN)
      ENDIF
      RETURN
C
 8100 NWARN(1) = NWARN(1) + 1
      IF( NWARN(1).LT.10 ) WRITE(6,9101) IER
 9101 FORMAT(' IER=',I4,' WHEN CREATING ZE4V')
      RETURN
C
 8200 NWARN(2) = NWARN(2) + 1
      IF( NWARN(2).LT.10 ) WRITE(6,9102) IER
 9102 FORMAT(' IER=',I4,' WHEN CREATING --BU')
C
      RETURN
      END

C   17/01/84 401171711  MEMBER NAME  MCTR4V   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCTR4V( IOPT, IERROR)
C-----------------------------------------------------------------------
C
C   AUTHOR    C. BOWDERY   3/10/83 :  CREATE 'TR4V' BANK
C
C        MOD  C. BOWDERY   5/10/83 :  REMOVE BUG WRT 2ND HIGHEST TRACK
C        MOD  C. BOWDERY   6/10/83 :  ADD THE IOPT AND IERROR ARGUMENTS
C        MOD  C. BOWDERY  17/10/83 :  ABSORBED HITS HAVE -VE POINTERS
C        MOD  C. BOWDERY  17/10/83 :  3 HIT ORIGINS ==> 4
C        MOD  C. BOWDERY  19/10/83 :  PRINTING FLAGS ADDED (IEFL1/2)
C   LAST MOD  C. BOWDERY  16/01/84 :  SPEED IMPROVEMENTS
C
C   PROCESSES THE 'HITL' AND 'HTSL' BANKS FOR MC EVENTS ALONG WITH THE
C   'JHTL' BANK FROM PATREC IN ORDER TO DETERMINE  WHICH  PARTICLE  IN
C   'VECT' BANK 0 OR 1 WAS THE CAUSE  OF  EACH  TRACK  IN  THE  'PATR'
C   BANK.THE RESULTS ARE PLACED IN A NEW BANK CALLED 'TR4V'.
C
C-----------------------------------------------------------------------
C
C                  STRUCTURE OF THE 'TR4V' BANK   32 BIT WORDS
C                  ----------------------------
C
C     1ST WORD  =  NUMBER OF 'PATR' TRACKS
C
C     THIS IS FOLLOWED BY GROUPS OF 8 WORDS, ONE GROUP PER 'PATR' TRACK.
C
C  |  1ST GROUP WORD  =  NO. OF ASSOCIATED 4_VECTOR PARTICLES
C  |  2ND   "    "    =  NO. OF ASSOCIATED 'JETC' HITS WITH 'PATR' TRACK
C  |      THIS IS FOLLOWED BY 3 SUBGROUPS OF 2 WORDS
C  |      |   1ST SUBGROUP WORD =  CODED 4_VECTOR PARTICLE ORIGIN
C  |      |   2ND   "    "      =  NO. OF HITS FROM THE ABOVE ORIGIN
C
C       THE FIRST SUBGROUP CORRESPONDS TO THE MOST PROBABLE ORIGIN,
C       THE SECOND SUBGROUP CORRESPONDS TO THE 2ND MOST PROBABLE ORIGIN
C       (BUT MAY BE EMPTY) AND SO ON.
C
C       THE CODE USED IS:   2 * 4_VECTOR_PARTICLE + VECT_BANK_NUMBER
C
C       THE ARGUMENTS
C       -------------
C
C   INPUT:  IOPT:   0 = DO NOTHING IF THE 'TR4V' BANK CORRESPONDING TO
C                       THE LATEST 'PATR' BANK ALREADY EXISTS. OTHERWISE
C                       CREATE THAT 'TR4V' BANK.
C
C                   1 = DELETE EXISTING 'TR4V' BANK CORRESPONDING TO THE
C                       LATEST 'PATR' BANK, IF IT EXISTS, THEN CREATE
C                       A NEW 'TR4V' BANK.
C
C   OUTPUT: IERROR: 0 = NO ERROR OCCURRED.
C                   1 = B O S  BANK ERROR. NO 'TR4V' CREATED.
C                   2 = 'HITL' BANK NOT SAME LENGTH AS 'HTSL' BANK. THIS
C                       COULD BE A SERIOUS ERROR. NO 'TR4V' CREATED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CWORK  / H4VORG(5000,4), H4VTOT(5000)
      COMMON / CWORK1 / HHTTRK(5000,2)
C
#include "cmubcs.for"
C
      DIMENSION ITR4V(300), ITEMP(4)
C
      DATA MASK7F / Z7F / , IEFL1 / 0 / , IEFL2 / 0 /
C
C-----------------------  C O D E  -------------------------------------
C
      IERROR = 0
C
      IPP = IDATA( IBLN( 'PATR' ) )
      IPJ = IDATA( IBLN( 'JHTL' ) )
      IPH = IDATA( IBLN( 'HITL' ) )
      IPS = IDATA( IBLN( 'HTSL' ) )
C
      IF(IPH.LE.0  .OR. IPS.LE.0  .OR. IPP.LE.0 .OR. IPJ.LE.0 ) RETURN
C
C                            ALL 4 BANKS EXIST.
C
      IPH2   = IPH * 2
      IPS2   = IPS * 2
C
C                            NOHITS = NUMBER OF ORIGINAL HITS
C
      NOHITS = HDATA(IPH2+1)
      IF(NOHITS .EQ. HDATA(IPS2+1) ) GO TO 3
C
      IEFL2 = IEFL2 + 1
      IERROR = 2
      IF( IEFL2 .GT. 10 ) RETURN
        WRITE(6,1)
 1      FORMAT(' *** ERROR *** ''HITL'' BANK LENGTH .NE. ''HTSL'' ',
     +                                      'BANK LENGTH IN MCTR4V')
        RETURN
C
C                            PROVIDED THAT  THERE  WERE  SOME  ORIGINAL
C                            UNSMEARED  JETC  HITS,  FIND  THE  CURRENT
C                            'PATR'   BANK   AND   CHECK   WHETHER    A
C                            CORRESPONDING 'TR4V' BANK ALREADY  EXISTS.
C                            PROCEED ACCORDING TO INPUT OPTION IOPT.
C
 3    IF(NOHITS .LT. 1) RETURN
      NBANK  = IDATA(IPP-2)
      CALL CLOC(IPT,'TR4V',NBANK)
      IF(IPT .LE. 0) GO TO 12
        IF(IOPT .EQ. 0) RETURN
        CALL BDLS('TR4V',NBANK)
C
 12   CALL VZERO(H4VORG,12500)
      CALL VZERO(HHTTRK,5000)
C
C                            USE 'HITL' AND 'HTSL' TO
C                            CREATE A TABLE OF HIT ORIGINS.
C
      DO  2  I = 1,NOHITS
        NEWHIT = HDATA(IPS2 + 1 + I)
        IF(NEWHIT .EQ. 0 ) GO TO 2
C
C                            ABSORBED HITS HAVE -VE POINTERS
C
        NEWHIT = IABS( NEWHIT )
        H4VTOT(NEWHIT) = H4VTOT(NEWHIT) + 1
        IF(H4VTOT(NEWHIT) .GT. 4) H4VTOT(NEWHIT) = 4
        H4VORG(NEWHIT,H4VTOT(NEWHIT)) = HDATA(IPH2 + 1 + I)
 2    CONTINUE
C
C                            NOW CONSTRUCT AN  ARRAY  OF  'PATR'  TRACK
C                            ASSOCIATION FOR EVERY HIT IN 'JETC'  USING
C                            THE 'JHTL' BANK.
C
      NHITS = IDATA(IPP + 5)
      NTRKS = IDATA(IPP + 2)
C
      DO  4  I = 1,NHITS
        LABEL       = IDATA(IPJ + 1 + I)
        L1          = SHFTR(LABEL,17)
        HHTTRK(I,1) = LAND(L1,MASK7F)
C
        L2          = SHFTR(LABEL,1)
        HHTTRK(I,2) = LAND(L2,MASK7F)
 4    CONTINUE
C
C                            CREATE THE 'TR4V' BANK  WITH  BANK  NUMBER
C                            THE SAME AS THE 'PATR' BANK.
C
      LENGTH = NTRKS*8 + 1
      CALL BCRE(IPT,'TR4V',NBANK,LENGTH,&1000,IER)
      CALL BSAW(1,'TR4V')
      CALL UZERO(IDATA, IPT+1, IPT+LENGTH )
      IDATA(IPT+1) = NTRKS
C
C                            LOOP OVER EVERY 'PATR' TRACK AND PICK  OUT
C                            THE HITS FROM 'JETC'  THAT  BELONG  TO  IT
C                            USING THE HHTTRK ARRAY. FOR EACH TRACK  IN
C                            TURN, HISTOGRAM THE 4 VECTOR ORIGIN(S)  OF
C                            EACH HIT. ENSURE THAT  NO  HIT  ORIGINATES
C                            FROM THE SAME 4  VECTOR  MORE  THAN  ONCE.
C                            DECIDE THE 4 VECTOR ORIGIN OF  EACH  TRACK
C                            FROM THE ARRAY ELEMENT  WITH  THE  LARGEST
C                            NUMBER OF ENTRIES
C
      DO  5  I = 1,NTRKS
        NTOT = 0
        CALL VZERO(ITR4V,300)
C
C                            LOOP OVER ALL HITS
C
        DO  6  J = 1,NHITS
          IF(HHTTRK(J,1) .NE. I .AND. HHTTRK(J,2) .NE. I ) GO TO 6
            NTOT = NTOT + 1
            NUM = H4VTOT(J)
            IF(NUM .EQ. 0) GO TO 6
C
            DO  8  L = 1,NUM
              ITEMP(L) = H4VORG(J,L)
              LH = L - 1
              IF( LH .LE. 0 ) GO TO 88
                DO  7  LL = 1,LH
                  IF( ITEMP(L) .EQ. ITEMP(LL) ) GO TO 8
   7            CONTINUE
  88          ITR4V( ITEMP(L) ) = ITR4V( ITEMP(L) ) + 1
   8        CONTINUE
C
 6      CONTINUE
C
C        DETERMINE THE ORIGIN OF THIS TRACK
C
C              SEARCH THE ITR4V HISTOGRAM TO FIND THE CELLS
C              IE. 4 VECTOR PARTICLES, WITH THE 3 LARGEST NUMBER
C              OF ENTRIES, IE. CONTRIBUTING HITS.
C
C              LARGE1 > LARGE2 > LARGE3   ==> NO. OF HITS
C
C              I4V1  = 4 VECTOR WITH CURRENT HIGHEST NO. OF HITS
C              I4V2  = 4 VECTOR WITH CURRENT 2ND HIGHEST NO. OF HITS
C              I4V3  = 4 VECTOR WITH CURRENT 3RD HIGHEST NO. OF HITS
C
        LARGE1 = 0
        LARGE2 = 0
        LARGE3 = 0
        I4V1   = 0
        I4V2   = 0
C
        DO  9  M = 1,300
          IF(ITR4V(M) .EQ. 0 )     GO TO 9
          IF(ITR4V(M) .LE. LARGE1) GO TO 10
C                                                A NEW HIGHEST NO.
            LARGE3 = LARGE2
            LARGE2 = LARGE1
            I4V3   = I4V2
            I4V2   = I4V1
            LARGE1 = ITR4V(M)
            I4V1   = M
            GO TO 9
  10      IF(ITR4V(M) .LE. LARGE2) GO TO 11
C                                                A NEW 2ND HIGHEST NO.
            LARGE3 = LARGE2
            I4V3   = I4V2
            LARGE2 = ITR4V(M)
            I4V2   = M
            GO TO 9
  11      IF(ITR4V(M) .LE. LARGE3) GO TO 9
C                                                A NEW 3RD HIGHEST NO.
            LARGE3 = ITR4V(M)
            I4V3   = M
 9      CONTINUE
C
C                  NOW FILL IN THE 'TR4V' BANK FOR THIS 'PATR' TRACK.
C
        INDEX = IPT + (I-1)*8 + 1
        IDATA(INDEX + 2) = NTOT
        IF(LARGE1 .LE. 0 ) GO TO 5
          IDATA(INDEX + 3) = I4V1
          IDATA(INDEX + 4) = LARGE1
          IDATA(INDEX + 1) = 1
C                                               INCLUDE A 2ND ORIGIN ?
        IF(.NOT.(           LARGE2 .GE. 8
     +                          .OR.
     +           (LARGE2 .GE. 5 .AND. NTOT .LT. 20) ) ) GO TO 5
C
          IDATA(INDEX + 5) = I4V2
          IDATA(INDEX + 6) = LARGE2
          IDATA(INDEX + 1) = 2
C                                               INCLUDE A 3RD ORIGIN ?
        IF(.NOT.(           LARGE3 .GE. 8
     +                          .OR.
     +           (LARGE3 .GE. 5 .AND. NTOT .LT. 20) ) ) GO TO 5
C
          IDATA(INDEX + 7) = I4V3
          IDATA(INDEX + 8) = LARGE3
          IDATA(INDEX + 1) = 3
C
 5    CONTINUE
      RETURN
C                                      B O S    ERROR
 1000 IERROR = 1
      IEFL1 = IEFL1 + 1
      IF( IEFL1 .GT. 10 ) RETURN
        WRITE(6,1001) IER
 1001   FORMAT(' BCRE ERROR ',I3,' OCCURRED WHILE CREATING ''TR4V'' ')
        RETURN
      END

C   01/11/84 807251629  MEMBER NAME  TRUTH    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRUTH(INDEX)
C-----------------------------------------------------------------------
C
C    AUTHOR:   L. O'NEILL  29/11/78 :  DRAW TRUE MC TRACKS
C
C       MOD:   J. OLSSON   07/05/81 :
C       MOD:   J. OLSSON   13/11/81 :
C       MOD:   J. OLSSON   16/11/81 :
C       MOD:   J. OLSSON   26/01/83 :  DARCOS ERROR...
C       MOD:   J. OLSSON   16/05/83 :  QUARKS,NEUTRINOS NOT DRAWN
C       MOD:   J. OLSSON   19/02/84 :  VRX,VRZX,VRZY VIEWS
C       MOD:   C. BOWDERY  08/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 19/10/84 :  VC VIEW
C       MOD:   J. HAGEMANN 06/03/86 :  DRAWING OF JET AXIS IN R-FI VIEWS
C       MOD:   J. HAGEMANN 14/04/86 :  CORRECT DISPLAY OF TRUE TRACKS IN
C                                      MAGNIFIED VERTEX VIEWS
C       MOD:   J. HAGEMANN 14/05/86 :  DRAWS TRUE TRACKS DASHED IN R-FI
C       MOD:   J. HAGEMANN 25/06/86 :  NEGATIVE INDEX DISPLAYS PARTICLE
C                                      NUMBER=+INDEX OF VECT-BANK
C                                      BANK NUMBER (0/1) IS SWITCHED BY
C                                      FLVCDO(13)
C  LAST MOD:   J. HAGEMANN 23/06/87 :  DISPLAY PARTICLE TYPE TABLE
C                                      (INDEX = 5)
C        A SUBROUTINE FOR DISPLAYING THE EXACT PATHS OF TRACKS AND
C        GAMMA RAYS WHEN SCANNING MONTE CARLO DATA. MULTIPLE SCATTER-
C        ING AND DE/DX LOSSES ARE NEGLECTED. "INDEX" IN THE ARGUMENT
C        CONTROLS DISPLAY OF TRACKS AND GAMMA RAYS SEPARATELY. INDEX=0
C        CAUSES TRACKS ONLY TO BE DISPLAYED. INDEX=1 RESULTS IN ONLY
C        GAMMA RAYS APPEARING. INDEX=2 CAUSES BOTH TRACKS AND GAMMAS
C        TO APPEAR.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FLVCDO
      LOGICAL FL18,FL22,FL24,DSPDTM
      REAL*8 B,C,DORG2,DTOF2,DCENT2,DRAD2
C
#include "cdata.for"
#include "cgrscl.for"
#include "cgraph.for"
#include "cgeo1.for"
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CGVCDO / FLVCDO(20)
C
      DIMENSION EAXIS(3),EOUT(3),SPHITY(3)
      DIMENSION HDATSV(22)
      DIMENSION HWRITE(40)
      EQUIVALENCE(IDATSV(1),HDATSV(1))
C
C------------------   C O D E  -----------------------------------------
C
      ISEL = 0
      IBKSEL = 0
      IF( INDEX .GE. 0 ) GO TO 50
         IPAR   = -INDEX
         INDEX  = 0
         ISEL   = 1
         IF( FLVCDO(13) ) IBKSEL = 1
   50 CONTINUE
      Z1 = 0.
      ITRNUM = 0
      IPAGE = 0
      BCONST=2.99792458E-5*BKGAUS
      BCONST = ABS(BCONST)
      IF(LASTVW.LT.12) GO TO 351
      IF(LASTVW.EQ.20) GO TO 351
      IF(LASTVW.GE.17.AND.LASTVW.LE.19) GO TO 351
      CALL TRMOUT(80,'OPTION NOT IMPLEMENTED IN CURRENT VIEW.^')
      RETURN
351   I4VPNT=IDATA(IBLN('VECT'))
      IF(I4VPNT.LT.1) CALL TRMOUT(80,'NO FOUR VECTOR BANK.^')
      IF(I4VPNT.LT.1) RETURN
C--
2222  LHEAD=IDATA(I4VPNT+1)
      LNUMB = IDATA(I4VPNT-2)
      LNEXT = IDATA(I4VPNT-1)
      LTR = IDATA(I4VPNT+2)
      NPART=IDATA(I4VPNT+4)
C     NPART=IDATA(I4VPNT+12)
C     IF(NPART.EQ.0) NPART=IDATA(I4VPNT+4)
      IF(NPART.LT.1) CALL TRMOUT(80,'NO MONTE CARLO PARTICLES.^')
      IF(NPART.LT.1) RETURN
      IF(LNUMB.EQ.0 .AND. IBKSEL.EQ.1) GOTO 2766
C---
C---  CODE FOR OPTION 4         DRAW JET AXIS
C---
      IF( INDEX .NE. 4 ) GO TO 777
         IF( LASTVW .GT. 4 .AND. LASTVW .NE. 17 .AND. LASTVW .NE. 20 )
     &                                         GO TO 780
            CALL EVTAX(EAXIS,EOUT,SPHITY,XMASS,IERR)
            IF( IERR .NE. 0 ) RETURN
            PHIJET = ATAN2(EAXIS(2),EAXIS(1))
            RAB    = RTOF - 50.0
            IF( LASTVW .EQ. 17 ) RAB = 6.0
            IF( LASTVW .EQ. 20 ) RAB = RITNK + 110.0
            XX     = RAB*COS(PHIJET)
            YY     = RAB*SIN(PHIJET)
            CALL MOVEA( -XX,  YY )
            CALL DASHA(  XX, -YY, 4 )
            RETURN
C---
C---  CODE FOR OPTION 5         PARTICLE TYPE TABLE
C---
  777 CONTINUE
      IF( INDEX .NE. 5 ) GO TO 780
          CALL CLRCON
          WRITE(6,9771)
 9771 FORMAT(' JADE-TYPE :',/,
     &       ' 1 = PHOTON, 2 = ELECTRON, 3 = MUON, 4 = PION, 5 = KAON,'/
     &       ' 6 = NUCLEON, 7 = PHI, 8 = ETA, 9 = ETAP, 10 = OMEGA,'/
     &       ' 11 = K*(890), 12 = RHO, 22 = TAU, 50 = K0')
C
          RETURN
C---
C---  SET BOUNDARY PARAMETERS FOR THE DISPLAY
C---
 780  ZZPL = ZENDPL
      ZZMI = ZENDMI
      RFRF = RTOF
      DELL = 10.
      IF( LASTVW .LT. 17 .OR. LASTVW .GT. 19 ) GO TO 4933
         XYZLIM = 0.33*(XMAXST(17)-XMINST(17))
         ZZPL   = XYZLIM
         ZZMI   = -XYZLIM
         RFRF   = XYZLIM
         DELL   = XYZLIM*.01
4933  CONTINUE
C---
C---     LOOP OVER ALL PARTICLES IN FINAL STATE.
C---
      EPTOT=0.
      ECTOT=0.
      ENTOT=0.
      DO 1 IPART=1,NPART
C---
C---     SELECT VECT-0-BANK PARTICLE IF INDEX WAS NEGATIVE
C---
      IF( ISEL .EQ. 1  .AND.  LNUMB .NE. IBKSEL ) RETURN
      IF( ISEL .EQ. 1  .AND.  IPART .NE. IPAR ) GO TO 1
C---
C---     SET UP INITIAL MOMENTUM VECTOR AND POINT OF ORIGIN.
C---
      IOFF=I4VPNT+LHEAD+LTR*(IPART-1)
      AMASS=ADATA(IOFF+5)
      ICHRG=IDATA(IOFF+6)
      ITYPE=IDATA(IOFF+7)
      ICSIGN=1
      IBCHRG=1
      IF(ICHRG.LT.0) ICSIGN=-1
      IF(ICHRG.LT.0) IBCHRG=-1
      IF(BKGAUS.LT.0.) ICSIGN = - ICSIGN
      IF(BKGAUS.LT.0.) IBCHRG = - IBCHRG
      PX=ADATA(IOFF+1)
      PY=ADATA(IOFF+2)
      PZ=ADATA(IOFF+3)
      EPRT=ADATA(IOFF+4)
      EPTOT=EPTOT+EPRT
      IF(ICHRG.NE.0) ECTOT=ECTOT+EPRT
      IF(ICHRG.EQ.0) ENTOT=ENTOT+EPRT
      XORG=ADATA(IOFF+ 8)
      YORG=ADATA(IOFF+ 9)
      ZORG=ADATA(IOFF+10)
      ZVERT=ZORG
      IF(INDEX.NE.3) GO TO 25
C   ENTER HERE FOR WRITING RESULTS NUMERICALLY ON SCREEN
C
C---
C---     WRITE OUT PARTICLE DATA TO SCREEN, WITH HARDCOPY OPTION.
C---
      IPAGE=IPAGE + 1
      IF(IPAGE.NE.1) GO TO 26
      CALL ERASE
      CALL HOME
      CALL CORE(HWRITE,80)
      WRITE(JUSCRN,446) ICREC
  446 FORMAT(' RECORD NO.',I5)
      DO 27 I=1,8
      J=9-I
      HWRITE(J+22)=HWRITE(J)
   27 CONTINUE
      DO 28 I=1,22
      HWRITE(I)=HDATSV(I)
   28 CONTINUE
      CALL NEWLIN
      CALL EOUTST(60,HWRITE)
      CALL LINEF
   26 CONTINUE
      CALL CORE(HWRITE,80)
      WRITE(6,445) IPART,ITYPE,ICHRG,AMASS,XORG,YORG,ZORG,PX,PY,PZ,EPRT
  445 FORMAT(3I3,F9.4,F10.2,2F8.2,F10.4,2F8.4,F10.4)
      CALL NEWLIN
      CALL EOUTST(80,HWRITE)
      IF(IPART.NE.NPART.AND.IPAGE.NE.50) GO TO 1
      IF(IPART.NE.NPART) GO TO 29
      CALL CORE(HWRITE,80)
      WRITE(6,447) EPTOT,ECTOT,ENTOT
  447 FORMAT('   EPTOT, ECTOT, ENTOT = ',3F10.4)
      CALL NEWLIN
      CALL NEWLIN
      CALL EOUTST(55,HWRITE)
   29 CONTINUE
      CALL TRMOUT(80,'
     1                  HARDCOPY?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) CALL HDCOPY
      IPAGE = 0
      GO TO 1
   25 CONTINUE
C   ENTER HERE FOR DISPLAY OF TRACKS AND GAMMAS IN THE EVENT
C
C---
C---     IF WE ARE USING THE "WRAP AROUND" TRACK DISPLAY AND
C---     IF PARTICLE TRACK STARTS EXTREMELY CLOSE TO THE BEAM AXIS SET
C---     ITS ORIGINAL X,Y COORDINATES TO TRUE ZEROES. THIS SIMPLY AVOIDS
C---     NUMERICAL DIFFICULTIES LATER ON.
C---
      IF(LASTVW.LE.3.OR..NOT.DSPDTL(9).OR.LASTVW.EQ.20) GO TO 23
      IF(LASTVW.EQ.17) GO TO 23
      IF(ABS(XORG).GT.0.0001*(XMAX-XMIN)) GO TO 23
      IF(ABS(YORG).GT.0.0001*(XMAX-XMIN)) GO TO 23
      XORG=0.
      YORG=0.
   23 CONTINUE
      KINK1=0
      KINK2=0
C---
C---     REQUIRE THAT PARTICLES ORIGINATE WITHIN AND NOT CLOSER THAN
C---     ONE CENTIMETER TO THE BOUNDARY OF A CYLINDER DEFINED BY
C---     THE RADIUS OF THE TIME-OF-FLIGHT COUNTERS AND THE Z COORDINATES
C---     OF THE FACES OF THE LEAD GLASS END CAPS. PARTICLES WILL BE
C---     TRACKED AS FAR AS THE BOUNDARY OF THIS CYLINDER.
C---     THE RADIUS CUT IS MADE SEVERAL LINES LOWER.
C---
      IF(ZORG.LE.ZZMI+DELL) GO TO 1
      IF(ZORG.GE.ZZPL-DELL) GO TO 1
      PT2=PX**2+PY**2
      PT=SQRT(PT2)
      IF(PT.LT.0.01) GO TO 1
      PA=SQRT(PT2+PZ**2)
      DORG2=XORG**2+YORG**2
      RORG2=DORG2
      RORG=SQRT(RORG2)
      DTOF2=RFRF**2
      IF(RORG.GT.RFRF-DELL) GO TO 1
C---
C---     DEAL FIRST WITH THE GAMMA RAYS.
C---
      IF(ICHRG.NE.0) GO TO 2
      IF(ITYPE.NE.1.AND.ITYPE.NE.-1) GO TO 1
      IF(INDEX.EQ.0) GO TO 1
      RLEN=0.
      DRIFT=1000000.
      IF(PZ.LT.0.) DRIFT=(ZZMI-ZORG)*PA/PZ
      IF(PZ.GT.0.) DRIFT=(ZZPL-ZORG)*PA/PZ
      XIMPCT=XORG+PX/PA*DRIFT
      YIMPCT=YORG+PY/PA*DRIFT
      RIMPCT=SQRT(XIMPCT**2+YIMPCT**2)
      IF(RIMPCT.LE.RFRF) RLEN=DRIFT
      IF(RLEN.GT.0.) GO TO 3
C---
C---    THE GAMMA WILL HIT THE TOF COUNTERS RATHER THAN AN END CAP.
C---
      B=2.*(XORG*PX+YORG*PY)/PT
      C=DORG2-DTOF2
      RLEN=(-B+DSQRT(B**2-4.*C))/2.
      RLEN=RLEN*PA/PT
    3 CONTINUE
C---
C---     THE GAMMA RAYS HITTING THE END CAPS JOIN THE FLOW HERE.
C---
      XEND=XORG+RLEN*PX/PA
      YEND=YORG+RLEN*PY/PA
      ZEND=ZORG+RLEN*PZ/PA
    4 CONTINUE
C ENTER HERE ALSO WITH CHARGED TRACKS COMING FROM LOOP 12
      IF(LASTVW.EQ.20) GO TO 30
      IF(LASTVW.GT.3.AND.LASTVW.NE.17) GO TO 5
C RFI VIEWS HERE
   30 X0=-XORG
      Y0= YORG
      X1=-XEND
      Y1= YEND
      GO TO 7
    5 CONTINUE
C RZ VIEWS HERE
      X0=ZORG
      X1=ZEND
      IF(LASTVW.GT.7.AND.LASTVW.NE.18) GO TO 6
      Y0=XORG
      Y1=XEND
      Z0=YORG
      Z1=YEND
      GO TO 8
    6 CONTINUE
      Y0=YORG
      Y1=YEND
      Z0=XORG
      Z1=XEND
    8 CONTINUE
      IF(.NOT.DSPDTL(9)) GO TO 7
C---
C---     TAKE CARE OF THE ABSOLUTE RADIUS VERSUS Z PROJECTION CASE.
C---
      SIGN0=1.
      IF(Y0.LT.0.) SIGN0=-1.
      SIGN1=1.
      IF(Y1.LT.0.) SIGN1=-1.
      ICROSS=0
      IF(SIGN1.NE.SIGN0) ICROSS=1
      IF(ICROSS.EQ.0) GO TO 13
      Y2=0.
      FRAC=(Y2-Y0)/(Y1-Y0)
      X2=X0+FRAC*(X1-X0)
   13 CONTINUE
      Y0=SIGN0*SQRT(Y0**2+Z0**2)
      Y1=SIGN1*SQRT(Y1**2+Z1**2)
      IF(ICROSS.EQ.0) GO TO 7
      Y2=Y0+FRAC*(-Y1-Y0)
C THE DRAWING HERE IS ONLY IN RZ VIEWS
      IF(ICHRG.EQ.0) CALL SAEGE(X0,Y0,X2,Y2)
      IF(ICHRG.NE.0) CALL MOVEA(X0,Y0)
      IF(ICHRG.NE.0) CALL DRAWA(X2,Y2)
      Y3=-Y2
      IF(ICHRG.EQ.0) CALL SAEGE(X2,Y2,X2,Y3)
      IF(ICHRG.NE.0) CALL DRAWA(X2,Y3)
      X0=X2
      Y0=Y3
    7 CONTINUE
C---
C---     CHECK HERE ON THE CHARGE BECAUSE CHARGED PARTICLE TRACKING
C---            FROM LOOP 12
C---     WILL JUMP BACK TO STATEMENT 4 AND USE THE SAME CODING.
C---
      IF(ICHRG.NE.0) GO TO 9
C---
C---     FINISHED WITH THE GAMMA RAY. DRAW SAWTOOTH SYMBOL ON SCREEN.
C---
      CALL SAEGE(X0,Y0,X1,Y1)
C     CALL TRKNM(X0,Y0,X1,Y1,IPART)
      CALL TRNUMB(IPART,ITRNUM,-X1,Y1,Z1)
C GO TO 1  MEANS END OF LOOP, READY WITH THIS PARTICLE
      GO TO 1
    2 CONTINUE
C ENTER HERE WITH CHARGES,ICHARG = 0 SKIPPED IF ONLY CHARGES REQUESTED
      IF(ICHRG.NE.1.AND.ICHRG.NE.-1) GO TO 1
      IF(IABS(ITYPE).GT.99) GO TO 1
C---
C---     NOW DEAL WITH THE CHARGED CASE. WERE CHARGED TRACKS REQUESTED?
C---
      IF(INDEX.EQ.1) GO TO 1
C---
C---     LOCATE THE CENTER OF GYRATION IN THE X-Y PLANE. B FIELD
C---     ALONG THE +Z AXIS.
C---
C     XCENT=XORG+PY/BCONST/ICHRG
C     YCENT=YORG-PX/BCONST/ICHRG
      XCENT=XORG+PY/BCONST/IBCHRG
      YCENT=YORG-PX/BCONST/IBCHRG
      DCENT2=XCENT**2+YCENT**2
      RCENT2=DCENT2
      RCENT=SQRT(RCENT2)
      RAD=PT/BCONST/IABS(ICHRG)
      DRAD2=RAD**2
      RAD2=DRAD2
C---
C---     SET UP INITIAL AZIMUTH WITH RESPECT TO CENTER OF LARMOR ORBIT.
C---
      PHI0=ATAN2(PY,PX)+ICSIGN*PI/2.
      IF(PHI0.GE. PI) PHI0=PHI0-TWOPI
      IF(PHI0.LT.-PI) PHI0=PHI0+TWOPI
      ANG0=ATAN2(YCENT,XCENT)
      ANG1=ANG0-PI
      IF(ANG1.LT.(-PI)) ANG1=ANG1+TWOPI
C---
C---     CAN THE TRACK POSSIBLY REACH THE TOF COUNTERS? IF NOT, BRANCH
C---     TO THE CASE WHERE TRACKS STRIKE THE END CAPS. ADD ONE
C---     CENTIMETER TO THE RADIUS OF THE TOF COUNTERS TO AVOID NUMERICAL
C---     DIFFICULTIES. PARTICLES WHICH JUST BARELY PENETRATE THE TOF
C---     COUNTERS WILL BE TRANSPORTED TO THE END CAPS ANYWAY.
C---
      IF(2.*RAD+RORG.LE.RFRF+DELL) GO TO 10
C---
C---     THE TRACK MAY OR MAY NOT REACH THE TOF COUNTERS BEFORE
C---     STRIKING AN END CAP.
C---
      DELTAA=PI
      B=(DTOF2-DCENT2-DRAD2)/(2.*RAD*RCENT)
      IF(RCENT.LE.10.) GO TO 2821
      IF(DABS(B).LT.1.0) DELTAA = DARCOS(B)
2821  SOL1=ANG0-DELTAA
      SOL2=ANG0+DELTAA
      IF(SOL1.LT.-PI) SOL1=SOL1+TWOPI
      IF(SOL1.GE. PI) SOL1=SOL1-TWOPI
      IF(SOL2.LT.-PI) SOL2=SOL2+TWOPI
      IF(SOL2.GE. PI) SOL2=SOL2-TWOPI
C---
C---     "SOL1" AND "SOL2" ARE THE TWO AZIMUTHAL ANGLES ABOUT THE
C---     CENTER OF THE LARMOR ORBIT AT WHICH THE TRACK WOULD INTERSECT
C---     THE TOF COUNTERS IF IT MOVED COMPLETELY AROUND A CIRCLE.
C---     NOW WE WILL ATTEMPT TO SELECT THE CORRECT ONE FOR THE ACTUAL
C---     CASE.
C---
      DIST1=SOL1-PHI0
      IF(DIST1.LT.0.) DIST1=DIST1+TWOPI
      DIST2=SOL2-PHI0
      IF(DIST2.LT.0.) DIST2=DIST2+TWOPI
C---
C---     "DIST1" AND "DIST2" ARE THE ABSOLUTE ANGULAR DISTANCES, NOT
C---     RESTRICTED TO VALUES BETWEEN -PI AND +PI, WHICH A POINT MUST
C---     MOVE ALONG THE LARMOR ORBIT FROM THE POINT OF ORIGIN OF THE
C---     TRACK TO THE INTERSECTIONS WITH THE TOF COUNTERS, IF THIS POINT
C---     MOVES IN THE DIRECTION OF INCREASING AZIMUTHAL ANGLE ABOUT
C---     THE CENTER OF THE ORBIT. AN ACTUAL PARTICLE MOVING IN THE
C---     SAME SENSE (COUNTER CLOCKWISE IN THE CONVENTIONAL X-Y PLANE
C---     BUT CLOCKWISE ON OUR PICTURE WITH THE +X AXIS RUNNING TOWARD
C---     THE LEFT) WILL ENCOUNTER THE TOF COUNTERS AT AN AZIMUTH
C---     CORRESPONDING TO THE SMALLER OF DIST1 AND DIST2.
C---
      SCCW=SOL1
      SCW =SOL2
      IF(DIST2.LT.DIST1) SCCW=SOL2
      IF(DIST2.LT.DIST1) SCW =SOL1
C---
C---     POSITIVE PARTICLES MOVE CLOCKWISE IN THE CONVENTIONAL
C---     X-Y PLANE, COUNTERCLOCKWISE IN OUR PICTURE.
C---
C---        ONLY TRUE IF BKGAUS > 0  !!   (J.O.)
C---
      SOL=SCW
C     IF(ICHRG.LT.0) SOL=SCCW
      IF(IBCHRG.LT.0) SOL=SCCW
C THE ABOVE STATEMENT PUT IN BY J.O., TO ACCOUNT FOR NEGATIVE FIELD
      DIST=-ICSIGN*(SOL-PHI0)
      IF(DIST.LT.0.) DIST=DIST+TWOPI
C---
C---     "DIST" IS NOW SUPPOSED TO BE THE ABSOLUTE VALUE OF THE
C---     AZIMUTHAL ANGLE TRAVERSED BY THE PARTICLE IN GOING FROM
C---     THE POINT OF ORIGIN TO THE TOF RADIUS.
C---
C---     DOES THE PARTICLE ENCOUNTER AN END CAP BEFORE ACTUALLY REACHING
C---     THE RADIUS OF THE TOF COUNTERS?
C---
      ZIMPCT=ZORG+PZ/PT*RAD*DIST
      IF(ZIMPCT.LT.ZZMI) GO TO 10
      IF(ZIMPCT.GT.ZZPL) GO TO 10
      GO TO 11
   10 CONTINUE
C---
C---     ALL PARTICLES STRIKING THE END CAPS MERGE AT THIS POINT.
C---
      ZDRIFT=0.
      IF(PZ.LT.-0.001) ZDRIFT=ZZMI-ZORG
      IF(PZ.GT. 0.001) ZDRIFT=ZZPL-ZORG
      DIST=TWOPI
      IF(ZDRIFT.NE.0.) DIST=ZDRIFT*PT/PZ/RAD
   11 CONTINUE
C---
C---     NOW SET UP STEP SIZE FOR DRAWING THE ORBIT ONTO THE SCREEN
C---     AND TAKE CARE THAT ONE STEP ALWAYS OCCURS AT THE MINIMUM
C---     DISTANCE OF THE ORBIT FROM THE BEAM AXIS. THE LATTER IS
C---     DONE FOR THE BENEFIT OF THE Z-ABSOLUTE VALUE OF R VIEW.
C---
      PHI1=PHI0-ICSIGN*DIST
      IF(LASTVW.EQ.20) GO TO 34
      IF(LASTVW.GT.3.AND.LASTVW.NE.17) GO TO 14
   34 Q=RAD/8.
      GO TO 17
   14 CONTINUE
      Q=0.
      ZK=RAD*PZ/PT
      IF(ABS(ZK).LT.1E-3) GO TO 17
      MAX=0
      IF(DSPDTL(9)) GO TO 16
      IF(LASTVW.GT.7.AND.LASTVW.NE.18) GO TO 15
      PLIM1=-PI
      PLIM2=0.
      IF(PHI0.GE.0.) PLIM1=0.
      IF(PHI0.GE.0.) PLIM2=PI
      GO TO 18
   15 CONTINUE
      PLIM1=-PI
      PLIM2=-PI/2.
      IF(PHI0.GE.(-PI/2.)) PLIM1=-PI/2.
      IF(PHI0.GE.(-PI/2.)) PLIM2= PI/2.
      IF(PHI0.GE.( PI/2.)) PLIM1= PI/2.
      IF(PHI0.GE.( PI/2.)) PLIM2= PI
   18 CONTINUE
      IF(PHI1.LT.PLIM1) MAX=1
      IF(PHI1.GE.PLIM2) MAX=1
      IF(MAX.EQ.1) Q=RAD/8.
      IF(MAX.EQ.1) GO TO 17
      DOFF=0.
      IF(LASTVW.GT.7.AND.LASTVW.NE.18) DOFF=PI/2.
      DO 19 I=1,2
      S=PHI0-ICSIGN*DIST*(I-1)+DOFF
      Q1=ZK*RAD*COS(S)/(8.*SQRT(ZK**2+(RAD*SIN(S))**2))
      IF(ABS(Q1).GT.Q) Q=ABS(Q1)
   19 CONTINUE
      GO TO 17
   16 CONTINUE
      PLIM1=ANG1-TWOPI
      PLIM2=ANG1
      IF(PHI0.GT.ANG1) PLIM1=ANG1
      IF(PHI0.GT.ANG1) PLIM2=ANG1+TWOPI
      IF((PHI1.GT.PLIM1).AND.(PHI1.LT.PLIM2)) GO TO 20
      IF((XORG.EQ.0.).AND.(YORG.EQ.0.)) GO TO 20
      KINK1=1
      IF(DSQRT(DABS(DCENT2-DRAD2)).LT.100.) GO TO 20
      KINK1=0
      Q=ABS(RCENT*RAD/(8.*(RCENT-RAD)))
      GO TO 17
   20 CONTINUE
      PLIM1=ANG0-TWOPI
      PLIM2=ANG0
      IF(PHI0.GT.ANG0) PLIM1=ANG0
      IF(PHI0.GT.ANG0) PLIM1=ANG0+TWOPI
      IF((PHI1.GT.PLIM1).AND.(PHI1.LT.PLIM2)) GO TO 21
      Q=RCENT*RAD/(8.*(RCENT+RAD))
   21 CONTINUE
      DO 22 I=1,2
      S=PHI0-ICSIGN*DIST*(I-1)
      B=-XCENT*RAD*SIN(S)+YCENT*RAD*COS(S)
      C=-XCENT*RAD*COS(S)-YCENT*RAD*SIN(S)
      ARGM=DCENT2+DRAD2-2.*C
      IF(ARGM.LE.0.) GO TO 22
      Y=SQRT(ARGM)
      IF((XORG.EQ.0.).AND.(YORG.EQ.0.)) GO TO 22
      KINK2=1
      RADIPN=DSQRT(DABS(DCENT2-DRAD2))
      IF((RADIPN.LT.100.).AND.(Y.LT.RADIPN)) GO TO 22
      KINK2=0
      Q1=(-ZK*B*B+ZK*Y*Y*C)/(8.*DSQRT(ZK*ZK*(Y**6)+(Y**4)*B*B))
      IF(ABS(Q1).GT.Q) Q=ABS(Q1)
   22 CONTINUE
   17 CONTINUE
      STEP=PI
      IF(Q.NE.0.) STEP=0.01*SQRT((XMAX-XMIN)/Q)
C---
C---     IN CASE WE ARE IN THE "WRAP AROUND" VIEW AND IN CASE A REGION
C---     OF VERY HIGH CURVATURE NEAR THE BEAM AXIS HAS BEEN IGNORED IN
C---     SETTING "Q" MAKE SURE THAT THE STEP SIZE IS NO MORE THAN 100
C---     MILLIMETERS. THIS ASSURES THAT THERE IS AT LEAST ONE FULL STEP
C---     OUTSIDE THE REGION OF HIGH CURVATURE BUT STILL INSIDE THE BEAM
C---     PIPE AND THUS THAT THE TRACKS INSIDE THE JET CHAMBERS ARE STILL
C---     WELL FITTED.
C---
      IF((KINK1.EQ.0).AND.(KINK2.EQ.0)) GO TO 24
      STEPP=100./RAD
      IF(STEP.GT.STEPP) STEP=STEPP
   24 CONTINUE
      MODSTP=TWOPI/STEP+1
      IF(STEP.GT.PI) STEP=PI
      IF(STEP.LT.PI) STEP=TWOPI/MODSTP
      IF(LASTVW.GE.17.AND.LASTVW.LE.19) STEP = STEP*.005
      DIST1=-ICSIGN*(ANG1-PHI0)
      IF(DIST1.LT.0.) DIST1=DIST1+TWOPI
      NSTEP1=DIST1/STEP+1
      SHFTP=DIST1-NSTEP1*STEP
      NSTEP=(DIST-SHFTP)/STEP+2
      STEP=-ICSIGN*STEP
      SHFTP=-ICSIGN*SHFTP
C---
C---     NOW STEP ALONG THE TRACK AND DRAW THE CURVE ON THE SCREEN.
C---
      RRRF1 = 0.
      DO 12 ISTEP=2,NSTEP
      PHI=PHI0+SHFTP+STEP*(ISTEP-1)
      IF(ISTEP.EQ.NSTEP) PHI=PHI1
      XEND=XCENT+RAD*COS(PHI)
      YEND=YCENT+RAD*SIN(PHI)
      ZEND=ZVERT+PZ/PT*RAD*ABS(PHI-PHI0)
C---
C---     JUMP BACKWARDS INTO THE GAMMA CODING TO TAKE CARE OF THE
C---     SCREEN COORDINATES
C---
      GO TO 4
    9 CONTINUE
      IF(ISTEP.EQ.2) CALL MOVEA(X0,Y0)
CHECK TO SEE IF ALREADY OUTSIDE
      IF(LASTVW.LT.17.OR.LASTVW.GT.19) GO TO 5213
      RRRF = SQRT(X1*X1 + Y1*Y1)
      IF(RRRF.LE.RFRF) GO TO 5213
      RATF = (RFRF-RRRF1)/(RRRF-RRRF1)
      X1 = X0 + RATF*(X1-X0)
      Y1 = Y0 + RATF*(Y1-Y0)
5213  CALL DASHA(X1,Y1,1)
C      IF(DSPDTM(30)) WRITE(6,492) X1,Y1,ZEND,STEP,RRRF,RFRF
C492   FORMAT(' XY1 ZEND STEP RRRF RFRF',6E12.4)
      IF(RRRF.GT.RFRF) GO TO 1212
      XORG=XEND
      YORG=YEND
      ZORG=ZEND
      RRRF1=RRRF
   12 CONTINUE
 1212 CONTINUE
C     CALL TRKNM(X0,Y0,X1,Y1,IPART)
      CALL TRNUMB(IPART,ITRNUM,-X1,Y1,Z1)
    1 CONTINUE
 2766 IF(LNEXT.EQ.0) GO TO 1111
      I4VPNT = LNEXT
C CHANGE SIZE OF TRACK NUMBER FOR SECOND VECT BANK, VARIABLE ITRNUM
      ITRNUM = 1
      GO TO 2222
1111  RETURN
      END

C   15/02/88 802151516  MEMBER NAME  PRLIST   (S)        M  F77
      SUBROUTINE PRLIST( NNAMES, LIST )
C-----------------------------------------------------------
C  Version of 15/02/88         Last Mod 15/02/88 E Elsen
C  Print all NNAMES BOS banks specified in the list LIST.
C  All banks of a given name will be printed.
C-----------------------------------------------------------
      INTEGER LIST(NNAMES)
C
      DO 10 J=1,NNAMES
        CALL PRALLB( LIST(J) )
   10 CONTINUE
      END

C   17/01/79 205282127  MEMBER NAME  TOFDS    (JADEGS)      FORTRAN
      SUBROUTINE TOFDS
C--
C--     TOF DISPLAY FOR JADE, USING TOF PROGRAM FROM B.NAROSKA,KAWABATA
C--     TOF DISPLAY FOR JADE LEAD GLASS, USES YAMADA PROGRAM LGBTOF
C--     14.05.80       LAST CHANGE 28.05.82          J.OLSSON
C---
      IMPLICIT INTEGER*2 (H)
      LOGICAL FL18,FL22,FL24
      COMMON /CHEADR/ HEAD(108)
      COMMON /CWORK1/ HMW(112)
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      DIMENSION RE(14,50),HTYP(4,4)
      EQUIVALENCE (RE(1,1),IR(1,1))
#include "cgraph.for"
#include "cdata.for"
      DATA HTYP /'  ','PR','OT','ON','  ','  ','KA','ON',
     $           '  ','  ','PI','ON','EL','EC','TR','ON'/
      DATA HBLANK /'  '/
C----------------------------------------
      NN = ACMD
      IF(NN.EQ.-3) GO TO 2110
      IPPATR = IDATA(IBLN('PATR'))
      IF(IPPATR.GT.0) GO TO 98
      WRITE(6,97)
97    FORMAT(' ERROR ----->>   PATR BANK DOES NOT EXIST')
      RETURN
98    IPATOF = IDATA(IBLN('ATOF'))
      IF(IPATOF.GT.0) GO TO 96
      WRITE(6,95)
95    FORMAT(' ERROR ----->>   ATOF BANK DOES NOT EXIST')
96    CONTINUE
      DO 107  I = 1,50
      DO 107  J = 1,14
107   IR(J,I) = 0
C---   CALL TOF PROGRAM HERE
      NRUN = HEAD(18)
      CALL TOFINT(NRUN,IPATOF,IPPATR,&1000)
      IF(NN.GE.0) GO TO 99
      IF(NN.EQ.-1) GO TO 91
C SHOW DIAGRAM BETA VS MOMENTUM
      CALL TOFVW
      RETURN
91    CALL TOFBK
      RETURN
2110  IF(HEAD(18).GT.10000) GO TO 2111
      CALL TRMOUT(80,'LEAD GLASS TOF NOT AVAILABLE FOR RUNS < 10000^')
      RETURN
2111  CALL LGBTDC(BLGTOF,LGFLA)
      IF(LGFLA.LT.2) GO TO 2112
      WRITE(6,4415) BLGTOF
4415  FORMAT(' WARNING **** ERROR FLAG >= 2, LG TOF VALUE ',E12.4)
      RETURN
2112  IF(LGFLA.LT.1) GO TO 2113
      WRITE(6,4416) BLGTOF
4416  FORMAT(' WARNING * LAST CALIBRATION RUN EXCEEDED, LGTOF = ',F8.2)
      RETURN
2113  WRITE(6,4417) BLGTOF
4417  FORMAT(' ERROR CODE = 0,  LGTOF = ',F8.2)
      RETURN
C---
99    CONTINUE
C--   LOOP OVER TRACKS
      DO 111  ITR = 1,NTRK
      IF(NN.GT.0.AND.NN.NE.ITR) GO TO 111
C DECIDE WHICH CHISQUARE IS SMALLEST, TO DECIDE PARTICLE TYPE
      CHIQ = 1.E06
      IPARTY = 0
      IF(IR(2,ITR).NE.1.AND.IR(2,ITR).NE.2) GO TO 712
      DO 711  I = 1,4
      IF(RE(9+I,ITR).GT.CHIQ) GO TO 711
      IPARTY = I
      CHIQ = RE(9+I,ITR)
711   CONTINUE
 712  CONTINUE
      DO 112  I = 1,4
      IF(IPARTY.LT.1.OR.IPARTY.GT.4) HMW(I) = HBLANK
      IF(IPARTY.LT.1.OR.IPARTY.GT.4) GO TO 112
       HMW(I) = HTYP(I,IPARTY)
 112   CONTINUE
      WRITE(6,1379) ITR,(HMW(I),I=1,4),(IR(I,ITR),I=1,3),
     $ (RE(I,ITR),I=4,7),TRK(4,ITR)
1379  FORMAT(' ',I2,1X,4A2,3I3,
     $' TIME ',F6.3,' PATH ',F6.0,' BETA ',F6.3,' +-',F6.3,' MOM ',F8.3)
      WRITE(6,1381) (RE(I,ITR),I=8,13)
1381  FORMAT(' MASS ',F6.4,' +-',F6.4,' CHISQ P K P E ',4F10.3)
111   CONTINUE
      RETURN
1000  WRITE(6,1001)
1001  FORMAT(' ERROR RETURN 1 FORM TOFINT ****')
      RETURN
      END

C   14/12/83 401111710  MEMBER NAME  USER     (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE USER(INDX)
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL   ?/??/78 :  USER ROUTINE CALLED BY SUPERV
C
C        MOD: C. BOWDERY  14/12/83 :  TO IMPROVE THE COMMENTING
C   LAST MOD: C. BOWDERY   9/01/84 :  TO REMOVE EXCESS CODE
C
C   LAST MOD:
C   P. Movilla Fernandez  Oct./98 :  Adapted for use on new platforms
C                                    Reorganize I/O handling
C                                    Introduce calls to analysis routines
C   Last mod:        PMF 28/05/00 :  Use FFREAD for I/O steering
C                    PMF 31/05/00 :  Introduce INDX=13 on return
C                                    Introduce INDX=10, 20
C
C        USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C
C-----------------------------------------------------------------------
C
C        INDEX IS PASSED FROM SUPERV TO INDICATE WHICH LEVEL HAS BEEN
C        COMPLETED. THE MEANING OF THE VALUES IS EXPLAINED BELOW.
C
C         INDX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   UNUSED
C              9   MUON ANALYSIS HAS BEEN DONE
C    PMF:     10   If last event is processed, set INDEX=13 on return.
C    PMF:     20   Called immediately after event is read, but
C                  BEFORE inner detector smearing is done.
C
C            100   END OF JOB CALL
C
C   ON RETURN, IF INDX =   1 : THE SUPERVISOR WILL DROP CURRENT EVENT
C                              AND READ THE NEXT ONE.
C                         11 : EVENT WILL BE WRITTEN OUT AND NEW EVENT
C                              WILL BE READ
C                         12 : JOB WILL BE TERMINATED NORMALLY
C
C    PMF:                 13 : Current event will be written out
C                              and the job will be terminated normally.
C
C                              This additional index makes it easier for MC data
C                              to ensure a correct bookkeeping of the random number
C                              seed corresponding to the LAST EVENT WRITTEN OUT.
C                              This is in particular important if the job
C                              is terminated BEFORE the end of the MC input file.
C
C   OTHERWISE THE SUPERVISOR WILL GO TO THE LEVEL GIVEN BY "INDX" ON
C   RETURN FROM "USER". THUS, TO CONTINUE WITH THE ANALYSIS, THIS
C   ROUTINE MUST INCREMENT "INDX" BEFORE PASSING CONTROL BACK.
C
C-----------------------------------------------------------------------
C
      IMPLICIT NONE
C
C I/O default parameters set in JADEBD:
C     IUNIT:  Event input
C     JUNIT:  Event output
C     NCALI:  Max no. of calibration files
C     KUNITA: ASTART calibration files (dead)
C     LUNITA: AUPDAT/BUPDAT calibration files
C     ( IUNIT=2 JUNIT=3 LUNITA(1)=21 LUNITA(2)=22 )
      INTEGER IUNIT,JUNIT,NCALI,KUNITA,LUNITA
      COMMON/CIOUNI/IUNIT,JUNIT,NCALI,KUNITA(10),LUNITA(10)
C Flags to read the calibration constants in klread
      INTEGER LBMC
      COMMON /CMCCAL/ LBMC(17)
C MC smearing veto flag when reading MC events in subroutine EVREAD
C NOSMEAR = .TRUE. : suppress MC smearing
C NOSMEAR = .FALSE.: allow MC smearing
      LOGICAL NOSMEAR
      COMMON /CMCSMEAR/ NOSMEAR
C BOS
      INTEGER IW
      INTEGER*2 HW
      REAL AW
      COMMON /BCS/ IW(60000)
      DIMENSION HW(120000),AW(60000)
      EQUIVALENCE (HW(1),IW(1),AW(1))
C PAW
      INTEGER NWPAW,ICYCLE,HMEMOR
      PARAMETER (NWPAW=5000000)
      COMMON /PAWC/HMEMOR(NWPAW)
C FFREAD
      REAL SPACE
      INTEGER FFSPAC
      PARAMETER (FFSPAC=20000)
      COMMON / CFREAD / SPACE(FFSPAC)
C
C USER Parameters
C - I/O options
      INTEGER IOHIST,IOBANK
      LOGICAL LBANK,LHIST
      DATA IOBANK/41/, IOHIST/42/
C - Misc
      INTEGER NAMLEN,NBYTEW,NWNAM
      PARAMETER( NAMLEN=120, NBYTEW=4, NWNAM=NAMLEN/NBYTEW )
      INTEGER  HISTF(NWNAM),MCBOSF(NWNAM),SVBOSF(NWNAM),BANKF(NWNAM)
     >     ,CALF(NWNAM,3)
      CHARACTER*(NAMLEN) CHISTF,CMCBOSF,CSVBOSF,CBANKF,CCALF(3),CCALFU
      LOGICAL LEXIST,LEX(3),LLBMC(17),LZSR,LVTX,LSTART
      CHARACTER CSEEDF*11
      DATA CSEEDF / 'superv.stat' /
      INTEGER INDEX,LENOCC,IERR
      DATA IERR/0/
C - Specify bank contents to print for each supervisor level if LBANK .EQ. .TRUE.
C   (HEAD ALGN JETC ZVTX PATR JHTL LGCL LATC ATOF VECT PALL HITL VTXC HTSL TRIG)
      INTEGER HBANK(NWNAM,7)
      CHARACTER*(NAMLEN) CBANK(7)
C     DATA CBANK(1) /'HEAD LATC ATOF ALGN JETC PATR'/
C     DATA CBANK(2) /'HEAD'/
C     DATA CBANK(2) /'LATC ATOF ALGN JETC PATR HTSL JHTL'/
C     DATA CBANK(3) /'ALGN'/, CBANK(4) /'ZVTX'/, CBANK(5) /'PATR'/
C     DATA CBANK(6) /'LGCL'/, CBANK(7) /'PATR LGCL'/
C     DATA CBANK(7) /'HEAD ALGN JETC ZVTX PATR JHTL LGCL LATC ATOF VECT
C     +     PALL HITL VTXC HTSL TRIG TR4V'/
C - Pointer, counters etc.
      INTEGER IHEAD,IBLN
      INTEGER INDX
      INTEGER IEVT,IEVTF,IEVTL,NEVT,ICOUNT
      INTEGER I,J,K,L,M,N,ISGN
      INTEGER*2 H
      DATA ICOUNT /0/
      SAVE IEVT,IEVTF,IEVTL,NEVT,IOBANK,IOHIST,LEX,LZSR,LVTX,LSTART
      SAVE ICOUNT
      SAVE CBANK
C
C------------------  C O D E  ------------------------------------------
C
C        CHECK WHETHER CALL AT END OF JOB
C
      IF(INDX.EQ.100) GOTO 11000
C
      IF(INDX.LT.0) THEN 
         INDX=-INDX
         ISGN=1
      ELSE
         ISGN=0
      ENDIF
      IF(INDX.EQ.20) GOTO 20000
      GOTO (1000,2000,3000,4000,5000,6000,7000,8000,9000,10000),INDX
C
      IF( INDX.NE.0 ) THEN
         WRITE(*,'(A,I4,A)') 'USER: Illegal index, INDX='
     >        ,INDX,'. Will stop now!'
         INDX=12
         GOTO 999
      ENDIF
C
C--------------------------
C  INDEX=0: INITIALIZATION
C--------------------------
      PRINT *,' '
C... Initialise HBOOK and FFREAD
      CALL HLIMIT(NWPAW)
      CALL FFINIT(0)
      CALL FFSET('SIZE',8)
C... Read FFREAD cards  
      WRITE(*,'(A)') 'USER: read FFREAD cards'
C Random number generator
      LSTART=.TRUE.
      CALL FFKEY('SVSTART',LSTART,1,'INTE')
C First and last event to be processed
      IEVTF = 1
      CALL FFKEY('FIRST',IEVTF,1,'INTE')
      IEVTL = 999999
      CALL FFKEY('LAST',IEVTL,1,'INTE')
C Supervisor reconstruction options
C     - Perform zs refit
      LZSR=.FALSE.
      CALL FFKEY('ZSRFTV',LZSR,1,'LOGI')
C     - Perform vertex fit
      LVTX=.FALSE.
      CALL FFKEY('VTXFIT',LVTX,1,'LOGI')
C Calibrations constants reading options
      CALL FFKEY('MUCA',LLBMC(1),1,'LOGI')
      CALL FFKEY('LGMA',LLBMC(2),1,'LOGI')
      CALL FFKEY('TAGS',LLBMC(3),1,'LOGI')
      CALL FFKEY('TOFC',LLBMC(4),1,'LOGI')
      CALL FFKEY('LGST',LLBMC(5),1,'LOGI')
      CALL FFKEY('DEDX',LLBMC(6),1,'LOGI')
      CALL FFKEY('SPTG',LLBMC(7),1,'LOGI')
      CALL FFKEY('RVTX',LLBMC(8),1,'LOGI')
      CALL FFKEY('ZCAL',LLBMC(9),1,'LOGI')
      CALL FFKEY('TAGF',LLBMC(10),1,'LOGI')
      CALL FFKEY('IDJS',LLBMC(11),1,'LOGI')
      CALL FFKEY('VTXC',LLBMC(12),1,'LOGI')
      CALL FFKEY('VTXR',LLBMC(13),1,'LOGI')
      CALL FFKEY('VTXB',LLBMC(14),1,'LOGI')
      CALL FFKEY('VTXF',LLBMC(15),1,'LOGI')
C I/O options
      LBANK=.FALSE.
      CALL FFKEY('BANKS',LBANK,1,'LOGI')
      CALL VBLANK(HBANK(1,1),NWNAM*7)
      CALL FFKEY('LEVEL1',HBANK(1,1),NWNAM,'MIXED')
      CALL FFKEY('LEVEL2',HBANK(1,2),NWNAM,'MIXED')
      CALL FFKEY('LEVEL3',HBANK(1,3),NWNAM,'MIXED')
      CALL FFKEY('LEVEL4',HBANK(1,4),NWNAM,'MIXED')
      CALL FFKEY('LEVEL5',HBANK(1,5),NWNAM,'MIXED')
      CALL FFKEY('LEVEL6',HBANK(1,6),NWNAM,'MIXED')
      CALL FFKEY('LEVEL7',HBANK(1,7),NWNAM,'MIXED')
      LHIST=.TRUE.
      CALL FFKEY('HISTO',LHIST,1,'LOGI')
C File names
      CALL VBLANK(CALF(1,1),NWNAM)
      CALL FFKEY('AUPDAT0',CALF(1,1),NWNAM,'MIXED')
      CALL VBLANK(CALF(1,2),NWNAM)
      CALL FFKEY('BUPDAT0',CALF(1,2),NWNAM,'MIXED')
      CALL VBLANK(CALF(1,3),NWNAM)
      CALL FFKEY('BUPDAT1',CALF(1,3),NWNAM,'MIXED')
      CALL VBLANK(HISTF,NWNAM)
      CALL FFKEY('SVHIST',HISTF,NWNAM,'MIXED')
      CALL VBLANK(MCBOSF,NWNAM)
      CALL FFKEY('MCBOS',MCBOSF,NWNAM,'MIXED')
      CALL VBLANK(BANKF,NWNAM)
      CALL FFKEY('SVBANK',BANKF,NWNAM,'MIXED')
      CALL VBLANK(SVBOSF,NWNAM)
      CALL FFKEY('SVBOS',SVBOSF,NWNAM,'MIXED')
      CALl FFGO
C... Convert hollerith to character
      CALL UHTOC(CALF,NBYTEW,CCALF,NAMLEN*3)
      CALL UHTOC(HBANK,NBYTEW,CBANK,NAMLEN*7)
      CALL UHTOC(MCBOSF,NBYTEW,CMCBOSF,NAMLEN)
      CALL UHTOC(SVBOSF,NBYTEW,CSVBOSF,NAMLEN)
      CALL UHTOC(BANKF,NBYTEW,CBANKF,NAMLEN)
      CALL UHTOC(HISTF,NBYTEW,CHISTF,NAMLEN)
C... Check some parameters
      IEVTL=MAX(IEVTL,0)
      IEVTF=MAX(IEVTF,1)
      IF( IEVTL.NE.0 ) THEN 
         IEVTL=MAX(IEVTF,IEVTL)
      ELSE
         IEVTL=9999999
      ENDIF
C... Set calibration constants reading options
      DO I=1,16
         IF( LLBMC(I) ) THEN
            LBMC(I)=1
         ELSE
            LBMC(I)=0
         ENDIF
      ENDDO
C... Input file with events in BOS format
      INQUIRE(FILE=CMCBOSF,EXIST=LEXIST)
      IF( LEXIST ) THEN
         OPEN(IUNIT,FILE=CMCBOSF,STATUS='UNKNOWN',FORM='UNFORMATTED')
      ELSE
         WRITE(*,'(A)') 'USER: Input BOS file does not exist!'
         WRITE(*,'(A)') '... will stop now!'
         INDX=12
         GOTO 999
      ENDIF
      OPEN(IUNIT,FILE=CMCBOSF,STATUS='OLD',FORM='UNFORMATTED')
C... Calibration files
      DO I=1,3
         CCALFU=CCALF(I)
         CALL CLTOU(CCALFU)
         IF( I.EQ.1 ) LEX(I)=(INDEX(CCALFU,'AUPDAT1').NE.0)
         IF( I.EQ.2 ) LEX(I)=(INDEX(CCALFU,'BUPDAT0').NE.0)
         IF( I.EQ.3 ) LEX(I)=(INDEX(CCALFU,'BUPDAT1').NE.0)
         IF( LEX(I) ) INQUIRE(FILE=CCALF(I),EXIST=LEX(I))
      ENDDO
C  - Get constants from AUPDAT1
      IF( LEX(1) ) THEN
      OPEN(LUNITA(2),FILE=CCALF(1),STATUS='UNKNOWN',FORM='UNFORMATTED')
      GOTO 100
      ENDIF
C  - Get constants from BUPDAT0 and/or BUPDAT1
      IF( LEX(2) )
     >     OPEN(LUNITA(1),FILE=CCALF(2),STATUS='OLD',FORM='UNFORMATTED')
      IF( LEX(3) )
     >     OPEN(LUNITA(2),FILE=CCALF(3),STATUS='OLD',FORM='UNFORMATTED')
      IF( .NOT.( LEX(2) .OR. LEX(3) ) ) THEN
         WRITE(*,'(A)') 'USER: No calibration files specified!'
         WRITE(*,'(A)') '... will stop now!'
         INDX=12
         GOTO 999
      ENDIF
C... SUPERV result BOS banks
 100  OPEN(JUNIT,FILE=CSVBOSF,STATUS='UNKNOWN',FORM='UNFORMATTED')
C... Output file with BOS bank contents in readable ASCII format
      IF(LBANK)
     >     OPEN(IOBANK,FILE=CBANKF,STATUS='UNKNOWN',FORM='FORMATTED')
C... Initialize random number generator
      WRITE(*,FMT='(/,120(''=''))')
      IF( .NOT. LSTART ) CALL MCRAND('R',CSEEDF,0,0,IERR)
      IF( IERR.LT.0 ) THEN
         INDX=12 
         GOTO 999
      ENDIF
C... Book control histograms
      IF( LHIST ) THEN 
         CALL HCDIR('//PAWC',' ')
         CALL HSTAF('YES')
         CALL HSTDEF
      ENDIF
C... Print out some parameters:
      WRITE(*,'(/,A,/,32(''-''))') 'USER: reconstruction parameters:'
      WRITE(*,'(A40,A)') 'Input BOS file is: '
     >     ,CMCBOSF(1:LENOCC(CMCBOSF))
      WRITE(*,'(A40,I8)') 'First event: ',IEVTF
      WRITE(*,'(A40,I8)') 'Last event: ',IEVTL
      WRITE(*,'(A40,$)') 'Perform ZSRFTV fit: ' 
      IF( LZSR ) THEN
         WRITE(*,'(A8)') 'YES' 
      ELSE
         WRITE(*,'(A8)') 'NO' 
      ENDIF
      WRITE(*,'(A40,$)') 'Perform Vertex fit with VTX*: ' 
      IF( LVTX ) THEN
         WRITE(*,'(A8)') 'YES' 
      ELSE
         WRITE(*,'(A8)') 'NO' 
      ENDIF
      WRITE(*,'(A40)') 'Calibration files used in this run: '
      DO I=1,3
         IF( LEX(I) ) WRITE(*,'(T42,A)') CCALF(I)(1:LENOCC(CCALF(I)))
      ENDDO
      WRITE(*,'(A40,A,20I2)') 'Calibration flags: '
     >     ,'/CMCCAL/ LBMC(1..17) =',(LBMC(I),I=1,17)
C
      WRITE(*,FMT='(/,120(''=''))')
C
      NEVT=0
      INDX=INDX+1
 999  RETURN
C
C------------------------------------------------------
C INDEX=100: END OF JOB: FINAL CALCULATIONS + PRINTOUT
C------------------------------------------------------
C
11000 CONTINUE
      IF( LBANK ) WRITE(IOBANK,11900) ICOUNT
11900 FORMAT(/'***'/'*** USER: INDEX=100  END OF JOB AFTER '
     +     ,I8,' EVENTS'/'***'/)
C BOS statistics
      CALL BSTA
C Close files
      CLOSE(IUNIT)
      CLOSE(JUNIT)
      CLOSE(LUNITA(1))
      CLOSE(LUNITA(2))
      IF( LBANK ) CLOSE(IOBANK)
      IF( LHIST ) CLOSE(IOHIST)
C... Save current random number generator status
      WRITE(*,FMT='(/,120(''=''))')
      CALL MCRAND('W',CSEEDF,IEVTF,IEVTF+NEVT-1,IERR)
C Save histograms
      IF( LHIST) THEN 
         WRITE(*,'(/,A,/,25(''-''))') 'USER: Control histograms:'
         CALL HSTEND(0)
         CALL HCDIR('//PAWC',' ')
         CALL HRPUT(0,CHISTF(1:LENOCC(CHISTF)),'N')
      ENDIF
C... Some info
      WRITE(*,'(/,A,/,22(''-''))') 'USER: I/O information:'
      WRITE(*,'(A35,A)') 'Input BOS file was: '
     >     ,CMCBOSF(1:LENOCC(CMCBOSF))
      WRITE(*,'(A35,I8)') 'First processed event was: ',IEVTF
      WRITE(*,'(A35,I8)') 'Last processed event was: ',IEVTF+NEVT-1
      WRITE(*,'(A35,$)') 'ZSRFTV fit performed: ' 
      IF( LZSR ) THEN
         WRITE(*,'(A8)') 'YES' 
      ELSE
         WRITE(*,'(A8)') 'NO' 
      ENDIF
      WRITE(*,'(A35,$)') 'Vertex fit with VTX* performed: ' 
      IF( LVTX ) THEN
         WRITE(*,'(A8)') 'YES' 
      ELSE
         WRITE(*,'(A8)') 'NO' 
      ENDIF
      WRITE(*,'(A35)') 'Calibration file used: '
      DO I=1,3
         IF( LEX(I) ) WRITE(*,'(T37,A)') CCALF(I)(1:LENOCC(CCALF(I)))
      ENDDO
      WRITE(*,'(A35,A)') 'Output BOS banks to: '
     >     ,CSVBOSF(1:LENOCC(CSVBOSF))
      IF( LHIST ) WRITE(*,'(A35,A)') 'Output histos to: '
     >     ,CHISTF(1:LENOCC(CHISTF))
      IF( LBANK ) THEN 
         WRITE(*,'(A35,A)') 
     >     'Output readable bank contents to: '
     >     ,CBANKF(1:LENOCC(CBANKF))
         WRITE(*,'(A35)') 'Printed BOS banks: '
         DO I=1,7
            WRITE(*,'(A31,I2,A1,2X,A)')
     >           '-Level',I,':',CBANK(I)(1:LENOCC(CBANK(I)))
         ENDDO
      ENDIF
C
      IF( NEVT.EQ. 0 ) WRITE(*,'(/,A)')
     >     'USER: WARNING!!! Number of first event to be reconstructed'
     >     //' exceeds number of events contained in the input file!'
C
      WRITE(*,FMT='(/,120(''=''))')
C
      RETURN
C
C---------------------------
C  INDEX=1: START OF RUN 
C---------------------------
C
 1000 CONTINUE
      IF( NEVT.EQ.0 )  WRITE(*,1900)
      IF( LBANK ) WRITE(IOBANK,1900)
 1900 FORMAT(/100('-')
     +     /'***'/'*** USER: INDEX=1  START OF NEW RUN'/'***'/)
      INDX=INDX+1
      RETURN
C
C----------------------------------------------------------------
C  INDEX=2: EVENT JUST READ IN, INNER DETECTOR SMEARING PERFORMED
C----------------------------------------------------------------
C
 2000 CONTINUE
C BOS Pointers
      IHEAD=IW(IBLN('HEAD'))
      IEVT=HW(IHEAD*2+11)
      ICOUNT=ICOUNT+1
C Skip first IEVTF-1 events
      IF( ICOUNT.LT.IEVTF ) GOTO 1
      IF( ICOUNT.EQ.IEVTF )
     +    WRITE(*,'(//''USER: First processed event is: '',I8,//)')
     +     IEVT
      NEVT=NEVT+1
C Log file
      IF( NEVT.EQ.1 )  WRITE(*,2900)
      IF( LBANK ) THEN
         WRITE(IOBANK,2900)
         WRITE(IOBANK,'(2X,A,6I8)') 'Date',(HW(IHEAD*2+K),K=3,8)
         WRITE(IOBANK,'(3(2x,A,I8))') 'Run',HW(IHEAD*2+10)
     +        ,' Event',HW(IHEAD*2+11),' Type:',HW(IHEAD*2+12) 
         WRITE(IOBANK,'(2X,A,I8)') 'Ebeam',HW(IHEAD*2+29)
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
 2900 FORMAT(/'***'/'*** USER: INDEX=2  EVENT JUST READ IN'/'***'/)
C Histograming
      IF( LHIST ) CALL HSTFLL(INDX)
C
      IF( ISGN.EQ.0 ) INDX=INDX+1
      RETURN
C
C--------------------------------------------------
C  INDEX=3: LEAD GLASS ENERGIES HAVE BEEN COMPUTED
C--------------------------------------------------
C
 3000 CONTINUE
      IF( NEVT.EQ.1 )  WRITE(*,3900)
      IF( LBANK ) THEN
         WRITE(IOBANK,3900)
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
 3900 FORMAT(/'***'/'*** USER: INDEX=3  LEAD GLASS ENERGIES'
     +     ,' HAVE BEEN COMPUTED'/'***'/)
      IF( LHIST ) CALL HSTFLL(INDX)
      INDX=INDX+1
      RETURN
C
C-----------------------------------
C  INDEX=4: Z-VERTEX NOW CALCULATED
C----------------------------------
C
 4000 CONTINUE
      IF( NEVT.EQ.1 )  WRITE(*,4900)
      IF( LBANK ) THEN
         WRITE(IOBANK,4900)
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
 4900 FORMAT(/'***'/'*** USER: INDEX=4  Z-VERTEX NOW CALCULATED'
     +     /'***'/)
      IF( LHIST ) CALL HSTFLL(INDX)
      INDX=INDX+1
      RETURN
C
C-----------------------------------------------------------
C  INDEX=5: INNER DETECTOR PATTERN RECOGNITION NOW COMPLETE
C-----------------------------------------------------------
C
 5000 CONTINUE
      IF( NEVT.EQ.1 )  WRITE(*,5900)
      IF( LBANK ) THEN
         WRITE(IOBANK,5900)
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
 5900 FORMAT(/'***'/'*** USER: INDEX=5 INNER DETECTOR PATTERN'
     +     ,' RECOGNITION NOW COMPLETE '/'***'/)
      IF( LHIST ) CALL HSTFLL(INDX)
      INDX=INDX+1
      RETURN

C
C     IF( LZSRFTV ) CALL ZSRFTV(1,2)
C
C     IF( LVERTEX ) THEN
C       IH=IBLN('HEAD')
C       IP=IBLN('PATR')
C       CALL VTXPRE(IH,IP) 
C       CALL VTXSRC
C       CALL VTXAFT
C       CALL VTXBNK(IP)
C     ENDIF
C
C
C--------------------------------------------------------------
C  INDEX=6: ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND
C--------------------------------------------------------------
C
 6000 CONTINUE
      IF( NEVT.EQ.1 )  WRITE(*,6900)
      IF( LBANK ) THEN
         WRITE(IOBANK,6900)
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
 6900 FORMAT(/'***'/'*** USER: INDEX=6  ENERGIES CLUSTERS IN THE'
     +     ,' LEAD GLASS HAVE BEEN FOUND'/'***'/)
      IF( LHIST ) CALL HSTFLL(INDX)
      INDX=INDX+1
      RETURN

C
C----------------------------------------------------
C  INDEX=7: TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED
C----------------------------------------------------
C
 7000 CONTINUE
      IF( NEVT.EQ.1 )  WRITE(*,7900)
      IF( LBANK ) THEN
         WRITE(IOBANK,7900)
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
 7900 FORMAT(/'***'/'*** USER: INDEX=7  TRACKS AND CLUSTERS'
     +     ,' HAVE BEEN ASSOCIATED'/'***'/)
      IF( LHIST ) CALL HSTFLL(INDX)
      INDX=INDX+1
      RETURN
C
C------------------
C  INDEX=8: UNUSED
C------------------
C
 8000 CONTINUE
      IF( LHIST ) CALL HSTFLL(INDX) ! Histos combined from different levels
      GOTO 10                   ! Skip muon analysis
CCC   INDX=INDX+1
      RETURN
C
C---------------------------------------
C  INDEX=9: MUON ANALYSIS HAS BEEN DONE 
C---------------------------------------
C
 9000 CONTINUE
      IF( NEVT.EQ.1 )  WRITE(*,9900)
      IF( LBANK ) THEN
         WRITE(IOBANK,9900)
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
 9900 FORMAT(/'***'/'*** USER: INDEX=9  MUON ANALYSIS'
     +     ,' HAS BEEN DONE'/'***'/)
      IF( LHIST ) CALL HSTFLL(INDX)
      INDX=INDX+1
      RETURN
C
C----------------------------------------------
C  INDEX=10: UNUSED (PMF: not any longer)
C  If the event limit is reached, write out the
C  current event and terminate the job normally.
C  For this, set INDX=13 on return.
C----------------------------------------------
C
10000 CONTINUE
      INDX=INDX+1
C Event counter
      IF( MOD(ICOUNT,50).EQ.0 )
     + WRITE(*,'(''USER: number of currently read/processed events:'''
     >     //',I8,''  /'',I8)') ICOUNT,NEVT
C End of job if event limit reached
      IF(ICOUNT.GE.IEVTL) THEN
       WRITE(*,'(//''USER:  Event limit reached after'',I8'
     +        //','' events'',//)')
     +        NEVT
         INDX=13
      ENDIF
      RETURN
C
C---------------------------------------------------------------------
C  INDEX=20: EVENT JUST READ IN, INNER DETECTOR SMEARING NOT PERFORMED
C---------------------------------------------------------------------
C
20000 CONTINUE
C Suppress smearing of MC until first event to process is read
      IF( ICOUNT.LT.IEVTF-1 ) THEN
         NOSMEAR=.TRUE.
      ELSE
         NOSMEAR=.FALSE.
      ENDIF
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---
    1 CONTINUE
      INDX=1
      GO TO 99999
    2 CONTINUE
      INDX=2
      GO TO 99999
    3 CONTINUE
      INDX=3
      GO TO 99999
    4 CONTINUE
      INDX=4
      GO TO 99999
    5 CONTINUE
      INDX=5
      GO TO 99999
    6 CONTINUE
      INDX=6
      GO TO 99999
    7 CONTINUE
      INDX=7
      GO TO 99999
    8 CONTINUE
      INDX=8
      GO TO 99999
    9 CONTINUE
      INDX=9
      GO TO 99999
   10 CONTINUE
      INDX=10
99999 RETURN
C
      END
C

C   01/11/84 810171933  MEMBER NAME  TRKHIT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TRKHIT
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON     ?      :  DISPLAY PATREC RESULTS
C
C        MOD: J. OLSSON   17/10/81 :
C        MOD: K.-H.                :  CHANGES FOR NEW TR 6 - LIKE TR 3
C             HELLENBRAND 21/03/84 :  BUT BAD Z HITS MARKED DIFFERENTLY
C        MOD: J. HAGEMANN 10/10/84 :  NEW HITMRK USED
C        MOD: C. BOWDERY   9/08/85 :  CALL DISPZC
C        MOD: J. HAGEMANN 28/10/85 :  CALL DISPVC
C        MOD: J. HAGEMANN 10/01/86 :  EXTENDED COMMON CVX
C        MOD: J. HAGEMANN 16/12/86 :  DUE TO UPDATED DISPVC
C        MOD: J. HAGEMANN 27/02/87 :  FOR 1986 ID-DATA SMALLER CROSSES
C                                     IN R-FI-VIEWS
C        MOD: J. HAGEMANN 18/03/87 :  FOR TR3 INCREASE NUMBER OF SELEC-
C                                     TED TRACKS FROM 6 TO 50
C   LAST MOD: J. HAGEMANN 17/10/88 :  FOR VERTEX CHAMBER VIEW
C
C     DISPLAY PATTERN RECOGNITION RESULTS
C     VARIOUS OPTIONS FOR DISPLAYING HITS ACCORDING TO TRACK ASSOCIATION
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL TBIT,REMEMB,REMB1,MUONFL
      LOGICAL FL18,FL22,FL24
      LOGICAL DSPDTM
      LOGICAL FLVCDO
      LOGICAL FLVC01,FLVC02,FLVC03
C
#include "cgeo1.for"
#include "cgraph.for"
#include "cdata.for"
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  KZAMP,HWORK(400),XLST(100),YLST(100),HKTR(50)
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CGRAP2 / BCMD,DSPDTM(30)
      COMMON / CVX    / NNPATR,ICRSTR,NNJETC,NNVTXC
      COMMON / CGVCDO / FLVCDO(20)
C
      DIMENSION HELP1(2),HELP2(2)
      EQUIVALENCE (LABL1,HELP1(1)),(LABL2,HELP2(1))
C
      DATA HELP1/0,0/,HELP2/0,0/,HCALL/0/
      DATA MSKTR1 / ZFE/
C
C------------------  C O D E  ------------------------------------------
C
      CRLEN = 4.0
      IF( HEAD(16) .EQ. 1986 ) CRLEN = 2.75
      LSTREM = LASTVW
      IF(LASTVW.LE.11.OR.LASTVW.EQ.14.OR.LASTVW.EQ.20) GO TO 2410
      WRITE(6,2420)
2420  FORMAT(' LAST VIEW WAS NOT AN ID VIEW. THE DEFAULT VIEW RA IS CHOS
     $EN')
      CALL PROMPT
      LASTVW = 1
      CALL SETSCL(LASTVW)
2410  IF(NNPATR.LE.0) GO TO 2411
      CALL CLOC(IPJHTL,'JHTL',NNPATR)
      IF(IPJHTL.GT.0) GO TO 2702
      WRITE(6,2703) NNPATR
2703  FORMAT(' JHTL BANK NR',I3,' (GIVEN BY COMMAND PATR) NOT EXISTING')
      GO TO 2411
2702  CALL CLOC(IPJTR,'PATR',NNPATR)
      IF(IPJTR.GT.0) GO TO 2713
      WRITE(6,2704) NNPATR
2704  FORMAT(' PATR BANK NR',I3,' (GIVEN BY COMMAND PATR) NOT EXISTING')
      GO TO 2412
2411  IPJHTL = IDATA(IBLN('JHTL'))
2412  IPJTR = IDATA(IBLN('PATR'))
2713  IF(IPJHTL.GT.0.AND.IPJTR.GT.0) GO TO 1
C
C                            CANNOT CONTINUE IF PATR OR JHTL MISSING
C
 199  WRITE(JUSCRN,198)
 198  FORMAT(' ''PATR'' AND/OR ''JHTL'' BANK(S) MISSING'/
     +       ' MAYBE PATREC HAS NOT BEEN DONE?')
      GO TO 9999
C
 1    HALO = 0
      IF(ACMD.GT.100.) HALO = 1
      IF(ACMD.GT.100.) ACMD = ACMD - 100.
      NN2 = ACMD
      NCMD = BCMD
      IF(NN2.GT.6) NCMD = NN2
      IF(NN2.GT.6) NN2 = 0
      IF(NCMD.EQ.0.OR.NCMD.EQ.IDATA(IPJHTL-2)) GO TO 11
      CALL CLOC(IPJHTL,'JHTL',NCMD)
      CALL CLOC(IPJTR,'PATR',NCMD)
      IF(IPJHTL.NE.0.AND.IPJTR.NE.0) GO TO 11
      GO TO 199
11    IPJH = 2*IPJHTL+2
      IF(NNJETC.LE.0) GO TO 5100
      CALL CLOC(IPJETC,'JETC',NNJETC)
      IF(IPJETC.GT.0) GO TO 5101
      WRITE(6,5103) NNPATR
5103  FORMAT(' JETC BANK NR',I3,' (GIVEN BY COMMAND JETC) NOT EXISTING')
5100  IPJETC = IDATA(IBLN('JETC'))
5101  IPJ = 2*IPJETC + 2
      NHITS = (HDATA(IPJ+97)-HDATA(IPJ+1))/4
      NWO = 4*NHITS + 98
      NTR = IDATA(IPJTR+2)
      REMEMB = DSPDTL(6)
      REMB1 = DSPDTL(10)
      JNDEX = LASTVW
      IF(LASTVW.GT.7) JNDEX = JNDEX - 4
      MUONFL =((JNDEX.EQ.3.OR.JNDEX.EQ.6.OR.JNDEX.EQ.7).AND.DSPDTL(3))
      HCALL = HCALL + 1
      IF(HCALL.GT.1) GO TO 1601
      SH1 = BLDEP*.10
      SH2 = BLFI*.16667
      SH3 = 4.*SH2
      SH4 = 2.3*SH2
      DEFIX = TWOPI/84.
      GO TO 1601
122   CALL TRMOUT(80,'CODE 0 : DISPLAY CODE LIST^')
      CALL TRMOUT(80,'CODE 1 : DISPLAY ALL HITS ASSOCIATED WITH TRACKS^'
     +)
      CALL TRMOUT(80,'CODE 2 : DISPLAY ALL HITS NOT ASSOCIATED WITH TRAC
     +KS^')
      CALL TRMOUT(80,'CODE 3 : DISPLAY ALL HITS ASSOCIATED WITH TRACKS,
     +MARKING SELECTED ONES^')
      CALL TRMOUT(80,'CODE 4 : DISPLAY ALL HITS, MARKING TRACK-ASSOCIATE
     +D ONES^')
      CALL TRMOUT(80,'CODE 5 : DISPLAY RAW EVENT, MARKING SELECTED TRACK
     +S.^')
      CALL TRMOUT(80,'CODE 6 : SIMILAR TO CODE 3 BUT MARKING GOOD AND BA
     +D Z HITS DIFFERENTLY^')
1601  IQQ = 0
      IQQQ = 0
      IF(NN2.EQ.0) GO TO 1602
      NN = NN2 + 1
      NN2 = 0
      GO TO 2905
1602  CALL TRMOUT(80,'ENTER CODE: (0=LIST)^')
      NN = TERNUM(DUMM) + 1
2905  IF(NN.LT.1.OR.NN.GT.8) GO TO 1601
      GO TO (122,1800,1800,2000,1800,2100,2200,3000),NN
      GO TO 122
1800  KNDX = NN-1
      GO TO 222
2100  KNDX = 5
      KNDZ=0
      GO TO 2001
2200  KNDX = 3
      KNDZ=1
      GO TO 2001
2000  KNDX = 3
      KNDZ=0
2001  IKTR = 0
      DO 6101  II = 1,50
6101  HKTR(II) = 0
1019  CALL TRMOUT(80,'ENTER TRACK NR.^')
      KTR = TERNUM(DUMM)
      IF(KTR.LE.0.OR.KTR.GT.NTR) GO TO 1021
      IKTR = IKTR + 1
      IF(IKTR.LE.50) GO TO 1022
      IKTR = IKTR - 1
      GO TO 222
1022  HKTR(IKTR) = KTR
      GO TO 1019
1021  IF(IKTR.GT.0) GO TO 222
      CALL TRMOUT(80,'NO VALID TRACK NUMBER HAS BEEN ENTERED^')
      GO TO 1601
3000  IQQ = 1
      IF(NDDOUT.EQ.0) GO TO 3001
      CALL TRMOUT(80,'ENTER YES TO CONFIRM PRINT OPTION !^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 1601
3001  CALL TRMOUT(80,'DO YOU WANT SPECIAL DEBUG PRINT?^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 1602
      IQQ = 0
      IQQQ = 1
      GO TO 1602
C----------------------------------------------------------------------I
222   NI = IPJ + 99
      IHIT = 0
      IHITN = -1
      CALL ERASE
      IF(HALO.EQ.1) CALL JADISP(LASTVW)
C---     WRITE OUT EVENT CAPTION.
      CALL CAPMRK(LASTVW,HESUM)
C--  LOOP OVER NR OF WORDS IN EVENT
      DO 8565  II = 1,100
      XLST(II) = 0.
8565  YLST(II) = 0.
8566  IHIT = IHIT + 1
      IHITN = IHITN + 2
      IHIT1 = IHITN
      IHIT2 = IHITN + 1
      IF(IHIT.GT.NHITS) GO TO 2255
      HELP1(2) = HDATA(IHIT1+IPJH)
      HELP2(2) = HDATA(IHIT2+IPJH)
      IKFLAG = 0
      MTR = 0
      MTR2 = 0
      IF(IQQ.EQ.0) GO TO 7579
      WRITE(6,8500) IHIT,IHITN,IHIT1,IHIT2,NI,HELP1(2),HELP2(2)
8500  FORMAT(' IHIT,IHITN12,NI,HELP1,HELP2',5I5,4X,Z4,1X,Z4)
7579  IF(LABL1.NE.0.AND.KNDX.NE.2) GO TO 821
      IF(LABL1.EQ.0.AND.(KNDX.EQ.2.OR.KNDX.GT.3)) GO TO 821
824   NI = NI + 4
      GO TO 8566
821   ISGN = 0
      IF(LABL1.EQ.0) GO TO 823
      MTR = LAND(LABL1,MSKTR1)
      MTR = SHFTR(MTR,1)
      MTR2 = LAND(LABL2,MSKTR1)
      MTR2 = SHFTR(MTR2,1)
      IF(IQQ.NE.0)
     $ CALL DIAGIN('MTR IHIT NI KNDX MT2',5,MTR,IHIT,NI,KNDX,MTR2,NI)
      IF(MTR.EQ.0.AND.KNDX.NE.2.AND.KNDX.NE.5) GO TO 824
      IF(MTR.NE.0.AND.KNDX.EQ.2) GO TO 824
      ISGN = -1
      IF(TBIT(LABL1,23)) ISGN = 1
      IF(KNDX.NE.3.AND.KNDX.NE.5) GO TO 823
      DO 8255  IKT = 1,IKTR
      IF(HKTR(IKT).EQ.MTR) IKFLAG = 1
8255  IF(HKTR(IKT).EQ.MTR2) IKFLAG = 2
      IF(IKFLAG.EQ.0.AND.LASTVW.GT.3.AND.LASTVW.LT.14) GO TO 824
      IF(IKFLAG.EQ.2) ISGN = -1
      IF(IKFLAG.EQ.2.AND.TBIT(LABL2,23)) ISGN = 1
823   IVVX = 0
      IF(LASTVW.GT.3.AND.LASTVW.LT.14) IVVX = 1
      IF(IVVX.EQ.1.AND.DSPDTL(9)) DSPDTL(10) = .TRUE.
      IF(LASTVW.EQ.14) IVVX = 2
      KZAMP = 0
      CALL FICOOR(IVVX,NI,NWE)
      IF(NWE.LT.-500) GO TO 225
      IF(NWE.EQ.0) GO TO 7788
      IF(IQQ.NE.0)
     $ CALL DIAGIN('ISGN NWE IVVX IKFLAG',4,ISGN,NWE,IVVX,IKFLAG,I,I)
      IF(LABL1.NE.0.AND.KNDX.EQ.4) DSPDTL(6) = .NOT.REMEMB
      IF(LASTVW.LT.4.OR.LASTVW.GT.12) GO TO 7539
C*****************************
C**  ZX AND ZY DISPLAYS     **
C*****************************
      IF(IKFLAG.EQ.0.AND.(KNDX.EQ.3.OR.KNDX.EQ.5)) DSPDTL(6)=.NOT.REMEMB
      IF(KNDZ.EQ.0) GOTO 830
      IKSF=IKFLAG+1
      GOTO (830,827,828), IKSF
      GOTO 830
  827 IF(TBIT(LABL1,31)) GOTO 830
      GOTO 829
  828 IF(TBIT(LABL2,31)) GOTO 830
  829 DSPDTL(6)=.NOT.DSPDTL(6)
  830 IF(DSPDTL(9)) GO TO 3425
C-- TRUE PROJECTIONS -------
      IF(ISGN.LT.0.AND.KNDX.NE.5) GO TO 3421
      YPRO= X1
      IF(LASTVW.GT.7) YPRO = Y1
      CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
      IF(LABL1.NE.0.AND.KNDX.NE.5) GO TO 3427
3421  YPRO = X2
      IF(LASTVW.GT.7) YPRO = Y2
      CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
3422  IF(LABL1.EQ.0) GO TO 805
      IF(IKFLAG.EQ.0.AND.KNDX.EQ.5) GO TO 805
3427  IF(IKFLAG.EQ.2) GO TO 3438
      XLST(MTR) = - ZET
      YLST(MTR) = YPRO
      GO TO 805
3438  XLST(MTR2) = - ZET
      YLST(MTR2) = YPRO
      GO TO 805
3425  CONTINUE
C-- WRAPPED PROJECTIONS ---------
      IF(ISGN.LT.0.AND.KNDX.NE.5) GO TO 3426
      YPRO = R1
      CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
      IF(LABL1.NE.0.AND.KNDX.NE.5) GO TO 3427
3426  YPRO = R2
      CALL HITMRK( JNDEX, ZET, YPRO, 4.0, 0 )
      GO TO 3422
C********************
C**  RFI DISPLAYS  **
C********************
7539  IF(IKFLAG.NE.0.AND.(KNDX.EQ.3.OR.KNDX.EQ.5)) DSPDTL(6)=.NOT.REMEMB
      IF(KNDZ.EQ.0) GOTO 7543
      IKRF=IKFLAG+1
      GOTO (7543,7540,7541), IKRF
      GOTO 7543
 7540 IF(TBIT(LABL1,31)) GOTO 7543
      GOTO 7542
 7541 IF(TBIT(LABL2,31)) GOTO 7543
 7542 DSPDTL(6)=.NOT.DSPDTL(6)
 7543 IF(LABL1.EQ.0) GO TO 1001
      IF(ISGN.LT.0.AND.KNDX.NE.5) GO TO 804
      IF(IKFLAG.EQ.0.AND.KNDX.EQ.5) GO TO 1001
      NTRR = MTR
      IF(IKFLAG.EQ.2) NTRR = MTR2
      XLST(NTRR) = X1
      YLST(NTRR) = Y1
1001  CALL HITMRK( LASTVW, -X1, Y1, CRLEN, 0 )
      IF(ISGN.GT.0.AND.KNDX.NE.5) GO TO 805
804   IF(LABL1.EQ.0) GO TO 1011
      IF(IKFLAG.EQ.0.AND.KNDX.EQ.5) GO TO 1011
      NTRR = MTR
      IF(IKFLAG.EQ.2) NTRR = MTR2
      XLST(NTRR) = X2
      YLST(NTRR) = Y2
1011  CALL HITMRK( LASTVW, -X2, Y2, CRLEN, 0 )
  805 DSPDTL(6) = REMEMB
      DSPDTL(10) = REMB1
      IF(IQQQ.NE.0)
     $ CALL DIAGIN('NI IPJ KNX ISGN  MTR',5,NI,IPJ,KNDX,ISGN,MTR,NI)
7788  IF(NI.LE.(IPJ+NWO)) GO TO 8566
C-- WRITE TRACK NUMBER AT POSITION OF LAST HIT
2255  IF(KNDX.EQ.2) GO TO 225
      IF(IQQQ.NE.0)
     $ CALL DIAGIN('NIIPJKNX ISGN  MTR E',5,NI,IPJ,KNDX,ISGN,MTR,NI)
      FII = 0.
      DO 2344  II = 1,NTR
      IF(ABS(XLST(II)).LT..1.AND.ABS(YLST(II)).LT..1) GO TO 2344
      CALL TRNUMB(II,0,XLST(II),YLST(II),DM)
2344  CONTINUE
225   IF(LASTVW.GT.1.AND.LASTVW.LT.4) CALL PBGRFI(SH1,SH2,SH3,DEFIX)
      IF(LASTVW.GT.4.AND.LASTVW.LT.12.AND.LASTVW.NE.8)
     $ CALL PBGRZ(LASTVW,SH1,SH2,SH3)
      IF(LASTVW.EQ.14) CALL PBGCYL(DEFIX)
      IF(LASTVW.LT.4) CALL HODRFI
C
C                            DISPLAY VERTEX CHAMBER
C
      IF( LASTVW .GT. 3 .AND. LASTVW .NE. 20 ) GO TO 4400
         IF( NN .NE. 2 ) GO TO 4300
            FLVC01 = FLVCDO(1)
            FLVC02 = FLVCDO(2)
            FLVC03 = FLVCDO(3)
            FLVCDO(1) = .FALSE.
            FLVCDO(2) = .FALSE.
            FLVCDO(3) = .TRUE.
 4300    CONTINUE
         CALL DISPVC(LASTVW,1)
         IF( NN .NE. 2 ) GO TO 4400
            FLVCDO(1) = FLVC01
            FLVCDO(2) = FLVC02
            FLVCDO(3) = FLVC03
 4400 CONTINUE
      IF( LASTVW .GE. 4 .AND. LASTVW .LE. 11 ) CALL DISPVC(LASTVW,2)
C
C                            DISPLAY Z CHAMBER
C
      IF( LASTVW .LT. 4 ) CALL DISPZC( 1 )
      IF( LASTVW .GE. 4  .AND.  LASTVW .LE. 11 ) CALL DISPZC( 2 )
C
      IF(JNDEX.GT.5) CALL FWMUHT
      IF(MUONFL) CALL MUHDSP
      IF(MUONFL.AND.DSPDTL(18)) CALL TR3DSP
9999  IF(LSTREM.EQ.LASTVW) GO TO 9998
      LASTVW = LSTREM
      CALL SETSCL(LASTVW)
9998  RETURN
      END

C   25/02/80 206211807  MEMBER NAME  TOFSMP   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFSMP(NRUN)
C
C      COMPUTES TOF WITHOUT CHECKING AGREEMENT OF THE 2 PHOTOTUBES
C  OUTPUT TTOF(I) : TIME OF FLIGHT IN COUNTER I(ONLY COMPUTED IF LATCH
C                   HAS FIRED) OTHERWISE SET TO -100
C  HTOF(I) = 0 IF LATCH OF COUNTER I HAS NOT FIRED
C          = 1 IF IT HAS
C  NTOF = NUMBER OF TOF LATCHES THAT HAVE FIRED
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      IMPLICIT INTEGER*2 (H)
      COMMON/TFPRM/ CORNOR(84),COROVF(84),TPARM(41),VELSC,TCALM(42),
     1 TCALP(42),PEDLM(42),PEDLP(42),DUM(90)
      COMMON/TFADC/ CADCA(84),CADCB(84)
C   18/02/82 202180024  MEMBER NAME  CHEAD    (S)           FORTRAN
      INTEGER *2  HEADR(108)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
C
      COMMON/SMPTOF/MTOF,TTOF(42),NTOF,HTOF(42)
      COMMON/BCS/IDATA(1)
      DIMENSION HDATA(2)
      EQUIVALENCE  (HDATA(1),IDATA(1))
      DIMENSION MASK(7),LIST(19)
      DATA MASK/1,2,4,8,16,32,64/
      DATA ITOFST/93/
      DATA IRUN/0/
      DATA MBAD/19/
      DATA LIST/5,7,11,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42/
C
      HEADR(18) = NRUN
      NTOF = 0
      CALL SETSL(TTOF,0,42*4,0.)
      CALL SETSL(HTOF,0,42*2,0.)
      IF(NRUN.EQ.IRUN) GOTO  10
      IF(NRUN.LE.1659) CALL CORCST(NRUN)
      IF(NRUN.GE.1660) CALL RD0880(NRUN)
      IF(IRUN.NE.0)  GOTO  10
      PRINT 110,NRUN
  110 FORMAT(50X,'CALLED RD0880',I6)
   10 IRUN = NRUN
      IF(NRUN.LE.1660) CALL TOFSM2
      IF(NRUN.LE.1660) RETURN
      IF(NRUN.GE.8712) CALL TOFSM3(NRUN)
      IF(NRUN.GE.8712) RETURN
      IPLTC  = IDATA(IBLN('LATC'))
      IF(IPLTC.LE.0)  RETURN
      IPTOF  = IDATA(IBLN('ATOF'))
      IF(IPTOF.LE.0)  RETURN
      IF(IDATA(IPTOF).LT.94) RETURN
      JPTOF = IPTOF*2
      JPLTC = IPLTC*2
C
C  FILL ARRAY OF TOF-LATCHES
C
      IF(NRUN.LT.3728.OR.NRUN.GT.4426)  GOTO   8
C IN THESE RUNS TOF 25- AND 26- WERE INTERCHANGED
      IT25L = HDATA(JPTOF+150)
      IT26L = HDATA(JPTOF+149)
      IT25R = HDATA(JPTOF+148)
      IT26R = HDATA(JPTOF+151)
    8 CONTINUE
      DO   5   N=4,9
      ID = HDATA(JPLTC+N+2)
      IF(NRUN.LT.3728.OR.NRUN.GT.4426)  GOTO   9
      IF(N.NE.7)  GOTO  9
      IF(LAND(ID,8).NE.0) ID = ID-8
      IF(LAND(ID,16).NE.0) ID = ID-16
      IF(IT25L.LT.2048.AND.IT25R.LT.2048) ID = ID+8
      IF(IT26L.LT.2048.AND.IT26R.LT.2048) ID = ID+16
    9 IF(ID.EQ.0)  GOTO  5
      DO   6   M=1,7
      IF(LAND(ID,MASK(M)).LE.0)  GOTO  6
      KTOF = (N-4)*7 + M
      NTOF = NTOF + 1
      IF(NTOF.GT.42)  GOTO  6
      HTOF(KTOF) = 1
    6 CONTINUE
    5 CONTINUE
C
      IF(NTOF.LE.0) RETURN
      DO   1   I=1,42
      IF(HTOF(I).LE.0)  GOTO  1
      IF1 = 2*I-1
      IAD = ITOFST + IF1 + (IF1-1)/8
      ITDCL = HDATA(JPTOF+IAD)
      ITDCR = HDATA(JPTOF+IAD+1)
      IF(NRUN.LT.3728.OR.NRUN.GT.4426)  GOTO  7
      IF(I.NE.25.AND.I.NE.26)  GOTO 7
      IF(I.EQ.25) ITDCL = HDATA(JPTOF+IAD+2)
      IF(I.EQ.26) ITDCL = HDATA(JPTOF+IAD-2)
    7 CONTINUE
      IF(NRUN.LT.7588.OR.NRUN.GT.8712)  GOTO 12
      IF(NRUN.LT.7900)  GOTO  78
      IF(I.EQ.40) TTOF(I) = -20.
      IF(I.EQ.40) GOTO  1
   78 CONTINUE
      DO  19   ML=1,MBAD
      IF(I.NE.LIST(ML))  GOTO 19
      IF(NRUN.GE.8256.AND.ML.GT.4)  GOTO  19
      IF(NRUN.GE.7897.AND.ML.GT.7)  GOTO  19
      TTOF(I) = -20.
      GOTO  1
   19 CONTINUE
C
   12 IF(ITDCL.LT. 5.OR.ITDCL.GE.2048)  GOTO  1
      IF(ITDCR.LT. 5.OR.ITDCR.GE.2048)  GOTO  1
      CORADM = 0.
      CORADP = 0.
      ITIF = IABS(ITDCL-ITDCR)
      IF(NRUN.GT.6600.AND.ITIF.LE.1)  GOTO  20
      IADC =  IF1 + (IF1-1)/12
      ADCM = HDATA(JPTOF+2+IADC)
      ADCP = HDATA(JPTOF+3+IADC)
      IF(ADCM.LT.1024.) CMS = CORNOR(IF1)
      IF(ADCP.LT.1024.) CPS = CORNOR(IF1+1)
      IF(ADCM.GE.1024.) CMS = COROVF(IF1)
      IF(ADCP.GE.1024.) CPS = COROVF(IF1+1)
      ADCM = ADCM - PEDLM(I)
      ADCP = ADCP - PEDLP(I)
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
      ADCMIV = 1000./ADCM
      ADCPIV = 1000./ADCP
      CORADM =  TPARM(2) + TPARM(1)*ADCMIV
      CORADP =  TPARM(2) + TPARM(1)*ADCPIV
      IF(NRUN.LT.3728)  GOTO  20
      SQADM = SQRT(ADCMIV)
      SQADP = SQRT(ADCPIV)
      BADCM= CADCB(2*I-1)
      BADCP= CADCB(2*I)
      CORADM =  BADCM*SQADM
      CORADP =  BADCP*SQADP
  20  TDCL = ITDCL*TCALM(I)-CMS-CORADM
      TDCR = ITDCR*TCALP(I)-CPS-CORADP
      IF(NRUN.LT.4993) GOTO  321
      TDCL = TDCL -TPARM(25)
      TDCR = TDCR -TPARM(25)
 321  IF(NRUN.GT.6000.AND.NRUN.LT.7592) TDCL = TDCL +3.07
      IF(NRUN.GT.6000.AND.NRUN.LT.7592) TDCR = TDCR +3.07
      IF(NRUN.GT.10000) TDCL = TDCL +3.07
      IF(NRUN.GT.10000) TDCR = TDCR +3.07
      TTOF(I) = .5*(TDCL+TDCR)
    1 CONTINUE
C/////////
      RETURN
      END

C   07/06/96 606071822  MEMBER NAME  BIOLST   (S4)          FORTG1
      SUBROUTINE BIOLST(K)
C     BOS SUBPROGRAM =1.XX=
#include "acs.for"
      COMMON/BCS/IW(1)
C
      INTEGER LIST(200,2)/400*0/
C
      INS=0
      IF(K.EQ.1) INS=NS
      IF(K.EQ.2) INS=IN
      IF(INS.LE.0) GOTO 100
      IF(K.EQ.1) IST=ISLST
      IF(K.EQ.2) IST=NLST
      DO 10 I=1,INS
      J=IW(IST+I)
      IF(J.GT.200) GOTO 10
      LIST(J,K)=LIST(J,K)+1
   10 CONTINUE
      GOTO 100
C
      ENTRY BIOLSP
      WRITE(6,101)
      DO 20 J=1,200
      IF(LIST(J,1).EQ.0.AND.LIST(J,2).EQ.0) GOTO 20
      WRITE(6,102) J,IW(INAMV+J),LIST(J,1),LIST(J,2)
   20 CONTINUE
  100 RETURN
  101 FORMAT('0',10X,'STATISTIC ON BANK NAMES IN INPUT AND OUTPUT',
     1 ' RECORDS'//14X,'I',6X,'NAME',15X,'INPUT',14X,'OUTPUT'/)
  102 FORMAT(11X,I4,6X,A4,2I20)
      END

C   07/06/96 606071916  MEMBER NAME  UMEAN    (S4)          FORTG1
      SUBROUTINE UMEAN(NA,KA,X)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL Q(10)
      IF(KA.LT.0) GOTO 100
      CALL BLOC(IND,'MEA*',NA,&20)
   10 INDK=IND+KA*50
      IF(INDK.GE.IND+IW(IND)) GOTO 100
      IW(INDK+1)=IW(INDK+1)+1
      N=IW(INDK+1)
      IF(N.GT.46) GOTO 15
      RW(INDK+4+N)=X
      IF(N.EQ.46) CALL HMEAN(INDK,Q)
      GOTO 100
   15 J=46.0*(X-RW(INDK+2))/(RW(INDK+3)-RW(INDK+2))+1.0
      IF(J.LT.0.OR.J.GT.46) J=0
      IW(INDK+4+J)=IW(INDK+4+J)+1
      GOTO 100
   20 IF(KA.NE.0) GOTO 100
      CALL BCRE(IND,'MEA*',NA,50,&100,IER)
      GOTO 10
C
      ENTRY DMEAN(NA,KA)
      KAK=0
      IF(KA.GT.0) KAK=KA
      CALL BLOC(IND,'MEA*',NA,&30)
      GOTO 100
   30 NW=50*(KAK+1)
      CALL BCRE(IND,'MEA*',NA,NW,&100,IER)
C
  100 RETURN
      END

C   16/07/81 312172001  MEMBER NAME  LGCUT    (JADESR)      FORTRAN
      SUBROUTINE LGCUT(IACC,ECYL,ECAMI,ECAPL,ETOT)
C
C     DETERMINES IF EVENT SHOULD BE KEPT OR REJECTED, BASED ON LG ENERGY
C     IACC=0 MEANS REJECT
C     IACC=1 MEANS ACCEPT
C
C          MODIFIED TO EXCLUDE EDGEBLOCKS IN ENDCAPS IN THE SPINNER TEST
C                     J.OLSSON   11.02.80
C
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cutsr1.for"
      EQUIVALENCE (ETOTLM,ELGLM(1)),(EMIN,ELGLM(2)),(EMNCYL,ELGLM(3))
      COMMON /CHEADR/ HEAD(108)
      COMMON /CIGG/ IPRN,IGG(80)
      INTEGER*2 HELP(2)/0,0/
      EQUIVALENCE (HELP(1),LABL)
      DATA MSK200 /Z200/
      LOGICAL*1 FIRST/.FALSE./
C-----
C SET IACC=0 DIRECTLY; ONLY WAY FOR IACC=1 IS TO FULFILL LIMITS BELOW
C-----
      IACC = 0
C-----
C INITIALIZE BOS-POINTERS
C-----
      IF(FIRST)GOTO100
      FIRST=.TRUE.
      IQTRIG = IBLN('TRIG')
      IQALGN = IBLN('ALGN')
  100 CONTINUE
C-----
C FIND ENERGY IN CYLINDER AND ENDCAPS
C-----
      CALL ERGTOT(ECYL,ECAMI,ECAPL)
      ETOT=ECYL+ECAMI+ECAPL
      ETOT95 = ETOT * .95
      CALL HF1(4,ETOT,1.)
      IPO = IDATA(IQTRIG)
      IF(IPO.LE.0 .OR. IDATA(IPO-2).NE.1) GO TO 7432
      IPO = IPO*2
      HELP(2) = HDATA(IPO+10)
      IVAR = LAND(LABL,MSK200)
      ECAPS = ECAMI + ECAPL
      IF(IVAR.EQ.0) GO TO 7431
      GO TO 7432
7431  CONTINUE
C
C     ETOT.LT.ETOTLM MEANS NO CHANCE OF BAD BLOCKS
C     LT 95% OF ENERGY IN ENDCAPS MEANS NO BAD BLOCKS
C
7432  IF(ETOT.LT.ETOTLM) GO TO 1400
      IF(ECAMI.LT.ETOT95 .AND. ECAPL.LT.ETOT95) GOTO 1400
C-----
C CHECK FOR BAD BLOCKS HERE
C-----
      IPJ=IDATA(IQALGN)
      IF(IPJ.LE.0) GO TO 99
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 99
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
      DO 5004 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      IF(IAD.LE.2687) GO TO 5004
      ETEST = HDATA(IJK)
      IF(ETEST.LT.ETOT95) GOTO 5004
C TEST HERE TO EXCLUDE EDGE BLOCKS FROM THE CHECK
C     REDUCE TO NUMBERS 1 - 192
      NO = IAD - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (NO - 1)/96
C     REDUCE TO 1 - 96
      NO = NO - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (NO - 1)/24
C     REDUCE TO 1 - 24
      NO = NO - NQ*24
      IF(NO.LT.5) GO TO 5004
      IF(NO.GT.15.AND.NO.NE.20) GO TO 5004
      GO TO 5005
5004  CONTINUE
C     COME HERE IF NO BAD BLOCKS
1400  IF(ETOT.GT.EMIN.OR.ECYL.GT.EMNCYL) IACC = 1
      GO TO 1010
 99   CONTINUE
      DATA IPRN1 /0/
      IPRN1 = IPRN1 + 1
      IF(IPRN1.LT.10) WRITE(6,36) IPJ,NWO,HEAD(18),HEAD(19)
 36   FORMAT('  ERROR IN LG BANK  ',4I10)
      GO TO 1010
 5005 IF(IPRN.GT.0) WRITE(6,29) IAD,ETEST
 29   FORMAT(' ADDRESS AND ENERGY OF BAD BLOCK: ',I10,F10.2)
      IGG(71)=IGG(71)+1
      CALL HF1(5,ECAPS,1.)
1010  RETURN
      END
      SUBROUTINE STATUS
      COMMON /CIGG/ IPRN,IGG(80)
C---------------------
C  DUMP RUN STATISTICS
C---------------------
      RNIDS=0.
      NWRT=IGG(79)
      IF(IGG(1).NE.0)PRINT1000,IGG(1)
      IF(IGG(1).EQ.0)PRINT1001
 1000 FORMAT(1H1/
     + 1X,116('=')/
     + 1X,45('='),' STATISTICS FOR RUN',I6,1X,45('=')/
     + 1X,116('='))
 1001 FORMAT(1H1/
     + 1X,113('=')/
     + 1X,40('='),' OVERALL STATISTICS FOR THIS JOB ',40('=')/
     + 1X,113('='))
C
C DUMP RAW COUNTERS
C
      PRINT1010,(IGG(I),I=1,80)
 1010 FORMAT(/' INTEGER CONTENTS',1X,10I8/
     +        ' ----------------',1X,10I8/6(18X,10I8/))
C
C EVENTS READ
C
      NPASS=IGG(4)-IGG(11)
      PRINT1020,IGG(4),IGG(11),NPASS
 1020 FORMAT(
     +          I10,' EVENTS READ          ',
     +          I10,' PULSER EVENTS        ',
     +          I10,' NON-PULSER EVENTS    ')
      IF(IGG(11).NE.13.AND.IGG(1).NE.0)PRINT1030
 1030 FORMAT(20X,'********** WRONG NO. OF PULSER EVENTS **********')
C
C OVERFLOW EVENTS,LGCALB ERRORS & LUMI EVENTS
C
      PRINT1050,IGG(77),IGG(78),IGG(80)
 1050 FORMAT(
     +          I10,' OVERFLOW EVENTS      ',
     +          I10,' LGCALB ERROR RETURNS ',
     +          I10,' LUMI EVENTS          ')
C
C MIPROC REJECTION
C
      PRINT1060,IGG(19),IGG(20)
 1060 FORMAT(
     +          I10,' EVENTS REJECTED BY MIPROC ZVTX CUT',
     +     19X, I10,' EVENTS REJECTED BY MIPROC T2 CUT  ')
C
      IF(NPASS.EQ.0)GOTO10000
      EVS=IGG( 4)*.01
C
C TRIGGER CHECK
C
      NPASS=NPASS - IGG(12)
      GPASS = NPASS   / EVS
      GFAIL = IGG(12) / EVS
      PRINT2000,IGG(12),GFAIL,NPASS,GPASS
 2000 FORMAT(//I10,' EVENTS (',F6.2,'%) FAILED TRIGGER CHECK '/
     +         I10,' EVENTS (',F6.2,'%) PASSED TRIGGER CHECK ')
C
C FWD MUON CHECK
C
      GFMU=IGG(2)/EVS
      PRINT5010,IGG(2),GFMU
 5010 FORMAT(
     + I10,' EVENTS (',F6.2,'%) PASSED FORWARD MUON CHECK             ',
     + 20X,'----- ACCEPTED -----')
C
C BAD BLOCKS
C
      GBAD  = IGG(71) / EVS
      PRINT5020,IGG(71),GBAD
 5020 FORMAT(
     + I10,' EVENTS (',F6.2,'%) HAD BAD LEAD GLASS BLOCKS             ')
C
C T1 ACCEPT BUT IWRT=0
C
      RNIDF = IGG(13) / EVS
      PRINT5030,IGG(13),RNIDF
 5030 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH T1 ACCEPT BUT IWRT=0             ',
     + 20X,'===== REJECTED =====')
C
C EVENTS WITH WRITE FLAG
C
      NIWRT = 0
      DO 5 I=51,57
 5    NIWRT = IGG(I) + NIWRT
      GPASS = NIWRT   / EVS
      PRINT5040,NIWRT,GPASS,(IGG(I),I=51,57)
 5040 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH IWRT=1->7 ',7I6)
C
C NO ID HITS OR WRITE FLAG
C
      NPASS = NPASS -IGG(13)-IGG(14)-IGG(15)
      RNIDF = IGG(14) / EVS
      PRINT5050,IGG(14),RNIDF
 5050 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH NO ID HITS & WRITE FLAG OFF      ',
     + 20X,'===== REJECTED =====')
C
C NO ID HITS BUT WRITE FLAG ON
C
      RNIDS = 0.
      NIDS=IGG(15)
      RNIDS = NIDS / EVS
      PRINT5060,NIDS,RNIDS
 5060 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH NO ID HITS & WRITE FLAG ON       ',
     + 20X,'----- ACCEPTED -----')
C
C EVENTS PASSED
C
      RZVT  = NPASS   / EVS
      PRINT5070,NPASS,RZVT
 5070 FORMAT(
     + I10,' EVENTS (',F6.2,'%)                                       ',
     + 20X,'-----  PASSED  -----')
C
C ENTERED ZVERTEX ROUTINE
C
      RZVT  = IGG( 6) / EVS
      PRINT6000,IGG( 6),RZVT
 6000 FORMAT(/
     + I10,' EVENTS (',F6.2,'%) ENTERED ZVERTEX ROUTINE               ',
     + 20X,'----- ACCEPTED -----')
C
C EVENTS WITH WRITE FLAG ON
C
      RNIDS = IGG(21) / EVS
      PRINT6010,IGG(21),RNIDS
 6010 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH WRITE FLAG ON                    ',
     + 20X,'----- ACCEPTED -----')
C
C EVENTS WITH NO ZVTX BANK
C
      IZVT=IGG(24)
      RZVT  = IZVT    / EVS
      PRINT6020,IZVT,RZVT
 6020 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITHOUT "ZVTX" BANK                   ',
     + 20X,'===== REJECTED =====')
C
C ZVTX FLAGS
C
      RZ    = IGG(26) / EVS
      RZ1   = IGG(27) / EVS
      RZ2   = IGG(28) / EVS
      RZ3   = IGG(29) / EVS
      PRINT6030,RZ,RZ1,RZ2,RZ3,IGG(4)
 6030 FORMAT(28X,'ZVTX FLAGS',4(F6.2,'% '),' OF',I9)
C
C FAILED TO FIND ZVERTEX
C
      IZVT=IGG(22)
      RZVT  = IZVT    / EVS
      PRINT6040,IZVT,RZVT
 6040 FORMAT(
     + I10,' EVENTS (',F6.2,'%) FAILED TO FIND Z-VERTEX               ',
     + 20X,'===== REJECTED =====')
C
C Z-VERTEX > 300 MMS
C
      IZVT=IGG(23)
      RZVT  = IZVT    / EVS
      PRINT6050,IZVT,RZVT
 6050 FORMAT(
     + I10,' EVENTS (',F6.2,'%) HAD Z-VERTEX > 300 MMS                ',
     + 20X,'===== REJECTED =====')
C
C Z-VERTEX < 300 MMS
C
      NPASS = IGG( 6) - IGG(21)-IGG(22)-IGG(23)-IGG(24)
      RZVT  = NPASS   / EVS
      PRINT6060,NPASS,RZVT
 6060 FORMAT(
     + I10,' EVENTS (',F6.2,'%) HAD Z-VERTEX < 300 MMS                ',
     + 20X,'-----  PASSED  -----')
C
C EVENTS THROUGH PATREC
C
      NPASS = IGG( 7)
      RZVT  = NPASS   / EVS
      PRINT7000,NPASS,RZVT
 7000 FORMAT(/
     + I10,' EVENTS (',F6.2,'%) THROUGH PATTERN RECOGNITION           ')
C
C EVENTS WITHOUT PATREC BANK
C
      IZVT=IGG(31)
      RZVT  = IZVT    / EVS
      PRINT7010,IZVT,RZVT
 7010 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITHOUT "PATR" BANK                   ',
     + 20X,'----- ACCEPTED -----')
C
C EVENTS WITH NO TRACKS AND NO WRITE FLAG
C
      IZVT=IGG(32)
      RZVT  = IZVT    / EVS
      PRINT7020,IZVT,RZVT
 7020 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH NO TRACKS AND NO WRITE FLAG      ',
     + 20X,'===== REJECTED =====')
C
C EVENTS WITH TRACKS
C
      NPASS = NPASS - IGG(31) - IGG(32)
      RZVT  = NPASS / EVS
      PRINT7030,NPASS,RZVT
 7030 FORMAT(
     + I10,' EVENTS (',F6.2,'%) HAD AT LEAST ONE TRACK                ')
C
C EVENTS WITH TRACKS AND TAG FLAG
C
      NTAG = IGG(33) + IGG(34)
      RZVT  = NTAG / EVS
      PRINT8000,NTAG,RZVT
 8000 FORMAT(/
     + I10,' EVENTS (',F6.2,'%) HAD AT LEAST ONE TRACK AND TAG FLAG   ')
C
C TAG EVENTS WITH TRACKS BELOW MOMENTUM CUT
C
      RZVT  = IGG(33) / EVS
      PRINT8010,IGG(33),RZVT
 8010 FORMAT(
     + I10,' EVENTS (',F6.2,'%) TAG EVENTS WITH LOW MOMENTUM TRACKS   ',
     + 20X,'===== REJECTED =====')
C
C TAG EVENTS WITH TRACKS ABOVE MOMENTUM CUT
C
      RZVT = IGG(34) / EVS
      PRINT8020,IGG(34),RZVT
 8020 FORMAT(
     + I10,' EVENTS (',F6.2,'%) TAG EVENTS WITH HIGH MOMENTUM TRACKS  ',
     + 20X,'----- ACCEPTED -----')
C
C SHORT TRACK IN R-Z AND R-PHI
C
      RZVT  = IGG(35) / EVS
      PRINT8050,IGG(35),RZVT
 8050 FORMAT(/
     + I10,' EVENTS (',F6.2,'%) WITH SHORT TRACK IN R-Z AND R-PHI     ',
     + 20X,'===== REJECTED =====')
C
C SHORT TRACK IN R-Z BUT LONG TRACK IN R-PHI
C
      RZVT = IGG(36) / EVS
      PRINT8060,IGG(36),RZVT
 8060 FORMAT(
     + I10,' EVENTS (',F6.2,'%) SHORT TRACK IN R-Z,LONG TRACK IN R-PHI',
     + 20X,'----- ACCEPTED -----')
C
C ONLY LOW MOMENTUM LONG TRACKS
C
      NPASS = IGG(37) + IGG(38) + IGG(39) + IGG(40)
      IZVT=IGG(37)
      RZVT  = IZVT    / EVS
      PRINT9000,IZVT,RZVT
 9000 FORMAT(/
     + I10,' EVENTS (',F6.2,'%) WITH LONG TRACK OF LOW MOMENTUM ONLY  ',
     + 20X,'===== REJECTED =====')
C
C HIGH MOMENTUM LONG TRACKS
C
      NPASS = NPASS - IGG(37)
      RZVT  = NPASS   / EVS
      PRINT9010,NPASS,RZVT
 9010 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH LONG TRACK OF HIGH MOMENTUM      ')
C
C ZMIN > 300 MMS
C
      IZVT=IGG(38)
      RZVT  = IZVT    / EVS
      PRINT9020,IZVT,RZVT
 9020 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WITH ZMIN > 300 MMS                   ',
     + 20X,'===== REJECTED =====')
C
C EVENTS INTO RMIN CUT
C
      NPASS = NPASS - IGG(38)
      RZVT  = NPASS   / EVS
      PRINT9030,NPASS,RZVT
 9030 FORMAT(
     + I10,' EVENTS (',F6.2,'%) WENT INTO RMIN CUT                    ')
C
C EVENTS REJECTED BY RMIN CUT
C
      IZVT=IGG(39)
      RZVT  = IZVT    / EVS
      PRINT9040,IZVT,RZVT
 9040 FORMAT(
     + I10,' EVENTS (',F6.2,'%) REJECTED BY RMIN CUT                  ',
     + 20X,'===== REJECTED =====')
C
C EVENTS PASSED RMIN AND ZMIN CUTS
C
      RZVT = IGG(40) / EVS
      PRINT9050,IGG(40),RZVT
 9050 FORMAT(
     + I10,' EVENTS (',F6.2,'%) PASSED RMIN AND ZMIN CUTS             ',
     + 20X,'----- ACCEPTED -----')
C
C OVERALL REDUCTION FACTOR
C
      RZVT  = IGG(79)    / EVS
      PRINT9090,IGG(4),IGG(79),RZVT
 9090 FORMAT(///
     +      1X,I10,' EVENTS WERE READ',6X,
     +      1X,I10,' EVENTS WERE WRITTEN',6X,
     +      1X,10X,' ACCEPTED FRACTION = ',F6.2,'%'/
     +      1X, 5X,22('='),6X,
     +      1X, 6X,24('='),6X,
     +      1X,10X,' ===========================')
10000 IF(IPRN.GT.1) WRITE(7,10010) IGG
10010 FORMAT(10I8)
      RETURN
      END
      BLOCK DATA
#include "cutsr1.for"
      EQUIVALENCE (ETOTLM,ELGLM(1)),(EMIN,ELGLM(2)),(EMNCYL,ELGLM(3))
      DATA NRUNST/0/,NEVTST/0/,NOTTOT/0/,NOTRUN/10*0/,NVRSN/1981/
C
C SET FOR  7 ON  7 GEV RUNNING
C
CC-CC DATA ETOTLM /3000./,EMIN /3000./,EMNCYL/1500./
C
C SET FOR 15 ON 15 GEV RUNNING
C
      DATA ETOTLM /6000./,EMIN /7000./,EMNCYL/3500./
      END

C   01/11/84 807241744  MEMBER NAME  DRWHIT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRWHIT( IPW, LSEP, LDIF, IWR )
C-----------------------------------------------------------------------
C
C    AUTHOR:   R. RAMCKE     23/10/84 :  DRAWS AMPLITUDES FOR VERTEX
C                                        CHAMBER RAW DATA ON SCREEN
C       MOD:   J. HAGEMANN   24/07/85 :  FOR DIFFENCIATED PULSES
C  LAST MOD:   J. HAGEMANN   16/01/86 :  FOR VCVW BANK
C
C      ABSOLUTE SCREEN COORDINATES ARE USED
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LSEP, LP, LDIF
C
C   23/03/97 703231941  MEMBER NAME  MVCCAL   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVCCAL         SAVED BY F22KLE  ON 87/02/09  AT 17:52
C   27/06/85 702091751  MEMBER NAME  MVCCAL   (S)           FORTRAN
C
C         THIS MACRO CONTAINS THE DECLARATION FOR THE
C         VTXC-CALIBRATION-COMMON / CVCCAL / :
C
C------------------------------------------------- 03.03.86 J.H. -------
C
      REAL*8 VCDATE
      COMMON / CVCCAL / NVFREE, VFREE(50), VCDATE,
     &      T0, VD, CSLOR, SNLOR, VROT, VDX, VZX, VDY, VZY,
     &      S0R(2,168), CVD(2,168),
     &      VIHCRR(7,2,25)
C
C     NVFREE  : NUMBER OF FREE REAL WORDS IN VFREE
C     VFREE   : REAL ARRAY FOR CONSTANTS
C     T0      : GLOBAL T0                              (. 0.1 NS .)
C     VD      : GLOBAL DRIFTVELOCITY                   (. MM/(0.1 NS) .)
C     CSLOR   : COS( LORENTZ-ANGLE )
C     SNLOR   : SIN( LORENTZ-ANGLE )
C     VROT    : ROTATION VTXC - ID                     (. RADIAN .)
C     VDX     : DISPLACEMENT VTXC - ID IN X            (. MM .)
C     VZX     : SLOPE OF " IN Z
C     VDY     : DISPLACEMENT VTXC - ID IN Y            (. MM .)
C     VZY     : SLOPE OF " IN Z
C     S0R     : DISPLACEMENT FOR EACH WIRE (#)         (. MM .)
C     CVD     : DRIFTVEL.-CORRECTURE FOR EACH WIRE (#)
C
C     VIHCRR  : LAYER-DEPENDENT CORRECTIONS FOR INHOMOGENITIES
C                                                      (. MM . )
C
C     VFREE(50) : D(VROT)/D(Z)                         (. RADIAN/MM .)
C
C     VFREE(48,49) JOBNAME OF JOB GENERATING THIS CALIBRATION
C
C     (#)     : FOR EACH DRIFTSPACESIDE
C
C
      COMMON / CWORK1 / HAMP(2,60), HSTORE(2,420), ISCLOW, ISCHIG
      COMMON / CORDER / KWR(8), KSIDE, KSTART, KEND, KTIMB, KEV
      COMMON / CKORD  / IX1, IX2,
     +                  IY1, IY2
C
      DIMENSION IWRADE(6)
C
C
      DATA IWRADE / 87, 105, 114, 101, 96, 96 /
      DATA ICALL  / 0 /
C
C-----------------  C O D E  -------------------------------------------
C
C                                                FETCH FADC-DATA
      IPREL =(IPW - 1)*60
      DO 60 JS = 1,2
          DO 50 JJ = 1,60
              HAMP(JS,JJ) = HSTORE(JS, JJ + IPREL)
  50      CONTINUE
  60  CONTINUE
C
      IF( .NOT. LDIF ) GO TO 100
         DO 90 JS = 1, 2
            IPD2 = 0
            IF( HAMP(JS,60) .GE. 300 ) IPD2 = 300
            HAMP(JS,60) = IPD2
C
            DO 80 JJ = 1, 58
               H1 = HAMP(JS,59-JJ)
               H2 = HAMP(JS,60-JJ)
               IPD1 = 0
               IF( H1 .GE. 300 ) IPD1 = 300
               IPD2 = 0
               IF( H2 .GE. 300 ) IPD2 = 300
               H1 = H1 - IPD1
               H2 = H2 - IPD2
               HAMP(JS,60-JJ) = H2 - H1 + IPD2
  80        CONTINUE
C
            IPD2 = 0
            IF( HAMP(JS,1) .GE. 300 ) IPD2 = 300
            HAMP(JS,1) = IPD2
C
  90  CONTINUE
C
 100  IF( .NOT. LSEP ) GOTO 120
         KSIDE = 1
         IX1 = 300
         IX2 = 2100
 120  IF( ICALL .GT. 0 ) GOTO 130
         KRANGE = KEND - KSTART
         IYMAX  = (IY2 - IY1)/KWR(8) - 50
         ISCRCH = IX2 - IX1
C
 130  IYO = IY1  + (IYMAX + 50)*ICALL
      IF( LDIF ) IYO = IYO  + (IYMAX*3)/8
C
C
      IT0OFS = IFIX((0.5/VD*(S0R(1,IWR)+S0R(2,IWR))+T0)*.01
     *                                  *FLOAT(ISCRCH)/FLOAT(KRANGE))
      IXO    = IX1 - IT0OFS
      IX     = IXO
      IY     = IYO
C
C                                               DRAW FADC-DATA
      LSIDE = KSIDE
 150  IF( LSIDE .EQ. 3 ) LSIDE = 2
      CALL MOVABS(IX,IY)
      KSTR1 = KSTART + 1
      DO 200 IREP = KSTR1,KEND
         LP = .FALSE.
         IF( HAMP(LSIDE,IREP) .LT. 200 ) GOTO 155
            HAMP(LSIDE,IREP) = HAMP(LSIDE,IREP) - 300
            LP = .TRUE.
 155     IDY = IYMAX*HAMP(LSIDE, IREP)/(ISCHIG-ISCLOW)
         IF( IDY .GE. IYMAX ) IDY = IYMAX
         IYY = IY + IDY
         IF( KSIDE .NE. 3  .OR.  LSIDE .NE. 2 ) GOTO 180
            CALL DSHABS(IX, IYY, 34)
            IX = IXO + ISCRCH*(IREP-KSTART)/KRANGE
            IF( IDY .LT. IYMAX ) GOTO 170
               CALL DSHABS(IX, IYY, 1)
               GOTO 200
 170        CALL DSHABS(IX, IYY, 34)
            GOTO 200
 180     CONTINUE
         CALL DRWABS(IX, IYY)
         IX = IXO + ISCRCH*(IREP-KSTART)/KRANGE
         IF( IDY .LT. IYMAX ) GOTO 190
            CALL DSHABS(IX, IYY, 1)
            GOTO 200
 190     IF( LP ) CALL DSHABS(IX,IYY,1)
         IF( .NOT. LP ) CALL DRWABS(IX, IYY)
 200  CONTINUE
C
C                                                REPEAT IF KSIDE = BOTH
      IF( KSIDE .NE. 3  .OR.  LSIDE .NE. 2 ) GOTO 210
      LSIDE = 1
      IX = IXO
      GOTO 150
 210  CONTINUE
C                                                WRITE WIRE NUMBER
      IYWR = 100
      IF( LDIF ) IYWR = 190
      CALL MOVABS(IX1 + 50, IYO + IYMAX - IYWR)
      CALL CHRSIZ(4)
      IWRADE(6) = IPW + 48
      CALL HLABEL(6,IWRADE)
C
      IF( (.NOT. LSEP)  .OR.  KSIDE .NE. 1 ) GOTO 220
         KSIDE = 2
         IX1 = 2200
         IX2 = 4000
         GOTO 120
C
 220  ICALL = ICALL + 1
      IF( KWR(8) .NE. ICALL ) RETURN
      ICALL = 0
C
      RETURN
      END

C   25/06/78 C8080901   MEMBER NAME  RANAZI   (LGSOURCE)    FORTRAN
      SUBROUTINE RANAZI(C,S)
C
C     A.SATO, MODIFIED BY S.YAMADA
C     LAST MODIFICATION 09-08-78  10:20
C
C---- GET COS AND SIN OF RUNDOMLY DISTRIBUTED PHI.
C
    1 XR1=RN(DUM)
      XR2=RN(DUM)
      IF(XR1.EQ.0. .AND. XR2.EQ.0.) GO TO 90
      XR1=2.*(XR1-.5)
      X=XR1*XR1+XR2*XR2
      IF(X-1.) 2,2,1
    2 IF(X) 1,1,3
    3 C=(XR1*XR1-XR2*XR2)/X
      S=2.*XR1*XR2/X
      RETURN
C
   90 WRITE(6,690)
  690 FORMAT('0**** 2 SUCCESSIVE RANDOM NUMBERS ARE 0.IN NEWDR1.***',
     1        /'  EMERGENCY STOP')
      STOP
      END

C   18/03/88 803181307  MEMBER NAME  LDATYP   (JADEGS)      FORTRAN
      INTEGER FUNCTION LDATYP( DUMMY )
C-----------------------------------------------------------
C  Version of 18/03/88    last Mod 18/03/88   E Elsen
C  Determine event type form MC and data
C     LDATYP = 1   for DL8 Data
C            = 2   for DL300 Data
C-----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
      INTEGER IPHEAD / 0 /
C
      IF( IPHEAD.GT.0 ) GO TO 10
        IPHEAD = IBLN('HEAD')
        WRITE(6,9101)
 9101   FORMAT(' +++ LDATYP +++   Version of 18/03/88')
   10 CONTINUE
C
      NPHEAD = IW(IPHEAD)
      NRUN = HW(NPHEAD*2+10)
      IF( NRUN.LT.100 ) NRUN = IZT2RN( DUMMY )
C
      LDATYP = 1
      IF( NRUN.GE.24200 ) LDATYP = 2
      RETURN
      END

C   14/10/82            MEMBER NAME  MEMBERS0 (S)           FORTRAN77
#include "bint.for"
#include "ibln.for"
#include "bcre.for"
#include "ccre.for"
#include "bloc.for"
#include "cloc.for"
#include "bchm.for"
#include "bdar.for"
#include "bpos.for"
#include "bnxt.for"
#include "cnxt.for"
#include "bmlt.for"
#include "bdls.for"
#include "bdlm.for"
#include "bgar.for"
#include "bdmp.for"
#include "bsta.for"
#include "dump0c.for"
#include "bchl.for"
#include "cchl.for"
#include "bgac.for"
#include "bsls.for"
#include "indar.for"
#include "uwp.for"
#include "breadc.for"
#include "readhl.for"
#include "bread.for"
#include "cread.for"
#include "bwrite.for"
#include "brds.for"
#include "bwrs.for"
#include "bfrd.for"
#include "binp.for"
#include "boutp.for"
#include "bsep.for"
#include "msgpr.for"
#include "itoda.for"
#include "rdvar.for"
#include "blocda.for"
#include "binlda.for"
#include "bloada.for"
#include "poda.for"
#include "dada.for"
#include "rdda.for"
#include "bpasda.for"
#include "sortir.for"

C   03/10/83 310032055  MEMBER NAME  HDDUMP   (S)           FORTRAN
      SUBROUTINE HDDUMP
C
C COPIED FROM F22FIN.MAIN.S  ON 3.10.83       J.OLSSON
C    MACRO CDATA INTRODUCED
C
       IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
       CALL BLOC(IHEAD,'HEAD',0,&1000)
       IHHEAD=IHEAD *2
       HEBEAM = HDATA(IHHEAD +29)
       NEXP=HDATA(IHHEAD+9)
       NRUN=HDATA(IHHEAD+10)
       NEVEN = HDATA(IHHEAD + 11)
        WRITE(6,600) HEBEAM,NEXP,NRUN,NEVEN
 600    FORMAT(1X,'  ENERGY ,EXP. ,RUN NO.,EVENT NO. ',4(I7,2X)
     1)
 1000   RETURN
        END

C   14/09/79 911131438  MEMBER NAME  TRELTR   (JADEGS)      FORTRAN
      SUBROUTINE TRELTR(ITREL,MTR,MTR2)
      IMPLICIT INTEGER*2 (H)
C---
C---     FIND WHICH TRACKS MTR,MTR2 ARE ASSOCIATED TO TRACK ELEM. ITREL
C---
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
      DIMENSION MTRR(2)
C
      MTRR(1) = 0
      MTRR(2) = 0
      IF(ITREL.LT.0.OR.ITREL.GT.HNTR) GO TO 1001
      IAMB = 0
      IF(NTR.LE.0) GO TO 1002
      DO 2  ITR = 1,NTR
      KNREL = HNREL(ITR)
      IF(KNREL.LE.0.OR.KNREL.GT.9) GO TO 1003
      DO 2  INREL = 1,KNREL
      JNREL = HISTR(INREL,ITR)
      IF(ITREL.NE.IABS(JNREL)) GO TO 2
      IAMB = IAMB + 1
      IF(IAMB.GT.2) GO TO 1004
      MTRR(IAMB) = ITR*ISIGN(1,JNREL)
2     CONTINUE
2001  MTR = MTRR(1)
      MTR2 = MTRR(2)
      GO TO 2000
C * * *  ERROR MESSAGES
1001  WRITE(6,1101) ITREL
1101  FORMAT(' ERROR IN TRELTR:  ITREL = ',I10)
      GO TO 2001
1002  WRITE(6,1102) NTR
1102  FORMAT(' ERROR IN TRELTR:  NTR = ',I10)
      GO TO 2001
1003  WRITE(6,1103) KNREL
1103  FORMAT(' ERROR IN TRELTR:  KNREL = ',I10)
      GO TO 2001
C1004  WRITE(6,1104)
1104  FORMAT(' ERROR IN TRELTR:  MORE THAN TWO TRACKS ASSOCIATED WITH A
     $ TRACK ELEMENT')
1004  GO TO 2001
2000  RETURN
      END

C   07/09/79 C9090801   MEMBER NAME  KPRINT   (JADEGS)      FORTRAN
      SUBROUTINE KPRINT(NBANK,LIM0,NDMP,ITYPE)
      IMPLICIT INTEGER*2 (H)
C---
C---     DUMPS INDIVIDUAL BANKS FROM COMMON/CALIBR/.
C---
      COMMON/CALIBR/JPOINT(1)
      DIMENSION ICALIB(1)
      DIMENSION HCALIB(2)
      DIMENSION RCALIB(1)
      EQUIVALENCE(JPOINT(1),ICALIB(1))
      EQUIVALENCE(JPOINT(1),HCALIB(1))
      EQUIVALENCE(JPOINT(1),RCALIB(1))
C---
      WRITE(6,100) NBANK
  100 FORMAT('0    CALIBRATION BANK ',I4,/)
      IF(ITYPE.EQ.1) WRITE(6,201)
  201 FORMAT(' INTEGER*2',/)
      IF(ITYPE.EQ.2) WRITE(6,202)
  202 FORMAT(' INTEGER*4',/)
      IF(ITYPE.EQ.3) WRITE(6,203)
  203 FORMAT(' REAL*4',/)
      IPNTR=JPOINT(NBANK)
      INXT =JPOINT(NBANK+1)
      IF(ITYPE.EQ.1) IPNTR=IPNTR*2
      IF(ITYPE.EQ.1) INXT =INXT*2
      GO TO (1,2,3),ITYPE
    1 CONTINUE
      LINES=1+(NDMP-1)/20
      DO 11 LINE=1,LINES
      LIM1=20*(LINE-1)+1
      LIM2=20* LINE
      IWRT=LIM0+LIM1
      IF(LIM2.GT.NDMP) LIM2=NDMP
      IF((LIM2+LIM0+IPNTR).GT.INXT) LIM2=INXT-LIM0-IPNTR
      WRITE(6,101) IWRT,(HCALIB(IPNTR+LIM0+KLM),KLM=LIM1,LIM2)
  101 FORMAT(1X,I6,I12,19I6)
      IF(LIM2.GE.(INXT-LIM0-IPNTR)) GO TO 2000
   11 CONTINUE
      GO TO 2000
    2 CONTINUE
      LINES=1+(NDMP-1)/10
      DO 12 LINE=1,LINES
      LIM1=10*(LINE-1)+1
      LIM2=10* LINE
      IWRT=LIM0+LIM1
      IF(LIM2.GT.NDMP) LIM2=NDMP
      IF((LIM2+LIM0+IPNTR).GT.INXT) LIM2=INXT-LIM0-IPNTR
      WRITE(6,102) IWRT,(ICALIB(IPNTR+LIM0+KLM),KLM=LIM1,LIM2)
  102 FORMAT(1X,I6,10I12)
      IF(LIM2.GE.(INXT-LIM0-IPNTR)) GO TO 2000
   12 CONTINUE
      GO TO 2000
    3 CONTINUE
      LINES=1+(NDMP-1)/10
      DO 13 LINE=1,LINES
      LIM1=10*(LINE-1)+1
      LIM2=10* LINE
      IWRT=LIM0+LIM1
      IF(LIM2.GT.NDMP) LIM2=NDMP
      IF((LIM2+LIM0+IPNTR).GT.INXT) LIM2=INXT-LIM0-IPNTR
      WRITE(6,103) IWRT,(RCALIB(IPNTR+LIM0+KLM),KLM=LIM1,LIM2)
  103 FORMAT(1X,I6,10E12.4)
      IF(LIM2.GE.(INXT-LIM0-IPNTR)) GO TO 2000
   13 CONTINUE
 2000 CONTINUE
      RETURN
      END

C   01/11/84 705201518  MEMBER NAME  MENU     (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MENU
C-----------------------------------------------------------------------
C
C        SENDS LIST OF AVAILABLE COMMANDS TO SCANNER.
C
C-----------------------------------------------------------------------
C
      CONTINUE ! CALL CLRCON PMF 03/12/99
C
C
      CALL TRMOUT(80,'      --- G E N E R A L ---^')
C
      CALL TRMOUT(80,
     +'HELP    Detailed information on all commands.^')
      CALL TRMOUT(80,
     +'MENU    Lists available commands.^')
      CALL TRMOUT(80,
     +'NEWS    Lists recent news about graphics.^')
C
      CALL TRMOUT(80,'      --- V I E W S ---^')
C
      CALL TRMOUT(80,
     +'RA      Displays Central Detectors in R-PHI view.^')
      CALL TRMOUT(80,
     +'RB      Displays Central Detectors and LG in R-PHI view.^')
      CALL TRMOUT(80,
     +'RC      Displays Central Detectors, LG and Muon Filter in R-PHI.^
     +')
C
      CALL TRMOUT(80,
     +'ZXA     Displays Central Detectors in Z-X view.^')
      CALL TRMOUT(80,
     +'ZXB     Displays Central Detectors and LG in Z-X view.^')
      CALL TRMOUT(80,
     +'ZXC     Displays Central Detectors, LG and Muon Filter in Z-X.^')
      CALL TRMOUT(80,
     +'ZXD     Displays whole detector in Z-X view.^')
C
      CALL TRMOUT(80,
     +'ZYA     Displays Central Detectors in Z-Y view.^')
      CALL TRMOUT(80,
     +'ZYB     Displays Central Detectors and LG in Z-Y view.^')
      CALL TRMOUT(80,
     +'ZYC     Displays Central Detectors, LG and Muon Filter in Z-Y.^')
      CALL TRMOUT(80,
     +'ZYD     Displays whole detector in Z-Y view.^')
C
      CALL TRMOUT(80,
     +'FW      Displays overall view of Forward Detector.^')
      CALL TRMOUT(80,
     +'RU      Displays rolled-out view of Lead Glass and Forward Detect
     +or.^')
      CALL TRMOUT(80,
     +'RZ      Displays rolled-out view of the Z Chamber (ZC).^')
      CALL TRMOUT(80,
     +'VC      Displays magnified view of the Vertex Chamber.^')
C
      CALL TRMOUT(80,
     +'CYL     Displays perspective view of detector.^')
      CALL TRMOUT(80,
     +'FWMU    Displays Forward Muon Counters.^')
      CALL TRMOUT(80,
     +'VRX     Displays vertex region, R-FI view.^')
      CALL TRMOUT(80,
     +'VRZX    Displays vertex region, Z-X view.^')
      CALL TRMOUT(80,
     +'VRZY    Displays vertex region, Z-Y view.^')
      CALL TRMOUT(80,
     +'STVW    Displays current standard view. Especially if magnified
     + (S).^')
C
      CALL TRMOUT(80,'      --- R E S U L T S ---^')
C
      CALL TRMOUT(80,
     +'RES     Displays ID and LG analysis results.^')
      CALL TRMOUT(80,
     +'VRES    Like RES but with vertex extrapolation.^')
      CALL TRMOUT(80,
     +'MUPT    Displays muon analysis results and can re-analyse.^')
      CALL TRMOUT(80,
     +'MUONS   Displays good muons.^')
      CALL TRMOUT(80,
     +'TR      Displays ID hits with various options. TR1 removes mirror
     + hits.^')
      CALL TRMOUT(80,
     +'ZFIT    Displays results of z-s-fits for given tracks.^')
      CALL TRMOUT(80,
     +'TRUE    Displays original Monte Carlo 4-vectors.^')
      CALL TRMOUT(80,
     +'VX      Displays vertex results.^')
C
      CALL TRMOUT(80,
     +'DEDX    Displays dE/dx results, several options.^')
      CALL TRMOUT(80,
     +'TOF     Displays TOF results, several options.^')
      CALL TRMOUT(80,
     +'QP      Displays Q-plots with several options.^')
      CALL TRMOUT(80,
     +'AX      Displays the event jet-axes.^')
C
      CALL TRMOUT(80,
     +'ZV      Displays Z vertex histogram with your assistance.^')
      CALL TRMOUT(80,
     +'FAMP    Displays results of FAMP-found tracks.^')
      CALL TRMOUT(80,
     +'ND50    Displays results of NORD 50-found tracks.^')
      CALL TRMOUT(80,
     +'VAC     Displays amplitudes on signal wires in any cell of Vertex
     + Chamber^')
      CALL TRMOUT(80,
     +'J68K    Displays amplitudes on signal wires in any cell of Jet Ch
     +amber   ^')
      CALL TRMOUT(80,
     +'FADC    Displays Jet Chamber test wire Flash-ADC values.^')
      CALL TRMOUT(80,
     +'ZTRG    Displays Z-trigger Flash-ADC values (test data only).^')
      CALL TRMOUT(80,
     +'CLUS    Displays Lead Glass clusters. RES is often better.^')
      CALL TRMOUT(80,
     +'MUR2    Like RES but shows full muon info in track list.^')
C
      CALL TRMOUT(80,'      --- E X T R A S ---^')
C
      CALL TRMOUT(80,
     +'DET     Displays the detector in current view.^')
      CALL TRMOUT(80,
     +'PRO     Displays projections of the 2 orthogonal views.^')
      CALL TRMOUT(80,
     +'EC      Displays End Cap hits in R-FI views^')
      CALL TRMOUT(80,
     +'FC      Displays Tagging System hits in RFI views^')
      CALL TRMOUT(80,
     +'TRLG    Displays Lead Glass trigger conditions^')
      CALL TRMOUT(80,
     +'TRG2    Displays T2 trigger conditions.^')
      CALL TRMOUT(80,
     +'BL      Displays dead,killed and spinning LG blocks.^')
      CALL TRMOUT(80,
     +'COM     Add comment to the picture; appears on the hard copy.^')
C
      CALL TRMOUT(80,'      --- C O N T R O L ---^')
C
      CALL TRMOUT(80,
     +'N       Goes to next event WITHOUT writing (NN).^')
      CALL TRMOUT(80,
     +'CSTL    Changes the "stop flag" settings in USER  (LEVELS).^')
      CALL TRMOUT(80,
     +'CSTV    Changes the standard view and auto-display of event (CS).
     +^')
      CALL TRMOUT(80,
     +'CDTL    Changes any one of the many drawing flags  (OPT).^')
      CALL TRMOUT(80,
     +'CDST    Displays status of the drawing "CDTL" flags  (STAT).^')
C
      CALL TRMOUT(80,
     +'WRIT    Writes current event and goes to next.^')
      CALL TRMOUT(80,
     +'MORE    Switches to a new input dataset. The dsname is prompted f
     +or  (NEW).^')
      CALL TRMOUT(80,
     +'STOP    Stops the program  (EXIT, END, QUIT).^')
      CALL TRMOUT(80,
     +'FIND    Locates event by Run and Event number which are prompted
     +for.^')
C
      CALL TRMOUT(80,
     +'JOYS    Changes scale and/or origin of display. CNTRL-E ends inpu
     +t  (ZOOM)^')
      CALL TRMOUT(80,
     +'RS      Returns to standard scale and origin  (RESET).^')
      CALL TRMOUT(80,
     +'PATR    Selects number of PATR bank to be used.^')
      CALL TRMOUT(80,
     +'JETC    Selects number of JETC bank to be used.^')
      CALL TRMOUT(80,
     +'VTXC    Selects number of VTXC bank to be used.^')
      CALL TRMOUT(80,
     +'C       Continues to next USER level with "stop flag" set.^')
      CALL TRMOUT(80,
     +'JUMP    Causes a jump to specified SUPERVISOR level.^')
C
      CALL TRMOUT(80,'      --- M A C R O S ---^')
C
      CALL TRMOUT(80,
     +'MACRO   Creates a macro command sequence.^')
      CALL TRMOUT(80,
     +'EDITMAC Edits   a user-defined macro.^')
      CALL TRMOUT(80,
     +'DELMAC  Deletes a user-defined macro.^')
      CALL TRMOUT(80,
     +'RENAMAC Renames a user-defined macro.^')
C
      CALL TRMOUT(80,'      --- O T H E R S ---^')
C
      CALL TRMOUT(80,
     +'H       Generates a Hard Copy of the display  (Q).^')
      CALL TRMOUT(80,
     +'HX      Generates an External Hard Copy  (QX).^')
      CALL TRMOUT(80,
     +'HLP     Generates a Laser Printer Hard Copy  (LASER).^')
      CALL TRMOUT(80,
     +'MASS    Computes effective mass of a group of particles.^')
      CALL TRMOUT(80,
     +'SPVA    Users own command, no action in JADEZ.^')
C
      CALL TRMOUT(80,
     +'BW      Writes out BOS banks to screen  (PRINT).^')
      CALL TRMOUT(80,
     +'BDLS    Deletes BOS banks as requested  (DELETE).^')
      CALL TRMOUT(80,
     +'DRAW    Invokes drawing routine for circles, lines and points.^')
      CALL TRMOUT(80,
     +'PICK    Returns coordinates of point selected by joystick.^')
      CALL TRMOUT(80,
     +'GVTX    Performs vertex fit of chosen tracks  (VFIT).^')
      CALL TRMOUT(80,
     +'NWCL    Recalibrates Lead Glass and JETC data  (RECAL).^')
      CALL TRMOUT(80,
     +'EDIT    Invokes PATREC editor subsystem.^')
      CALL TRMOUT(80,
     +'RET     Return to PATREC editor subsystem.^')
      CALL TRMOUT(80,
     +'SAVE    Saves PATREC /CWORK/ onto a scratch file.^')
C
      RETURN
      END

C   07/06/96 606071907  MEMBER NAME  READFF   (S4)          FORTG1
      SUBROUTINE READFF(LABEL,NF,FR,NM,*)
C     BOS SUBPROGRAM =2.2=
      LOGICAL*1 TC(80),BLL/' '/
      COMMON/TEXTIF/ITC(10),NBT
      EQUIVALENCE (TC(1),ITC(1))
      REAL*4 FR(NM)
      LOGICAL*1 LC(80),LH(4),LL(4)
      LOGICAL*4 END/.FALSE./
      INTEGER*4 LABEL,BLANK/'    '/,ALABEL,NH/0/
      REAL *8 ITC,TCI(10)
      EQUIVALENCE (LC(1),TCI(1))
      INTEGER NS(4)/75,96,78,125/,NV/0/,NP/0/,NE/0/,NZ/0/,IB/0/
      REAL*8 ZZ/0.0/,TEN/10.0/
      EQUIVALENCE (NH,LH(1)),(ALABEL,LL(1))
      EQUIVALENCE (IZL,FZL),(IZH,FZH)
      INTEGER LON/'PON '/,LOFF/'POFF'/,UNIT/'UNIT'/
      INTEGER IUN/5/,IPR/1/
      INTEGER KC/2/
C
 1111 CONTINUE
      NC=0
      NF=0
      IF(END) GOTO 200
      IF(IB.EQ.1) GOTO 10
    1 READ(IUN,101,END=5) TCI
      GOTO 10
    5 IF(IUN.NE.5) GOTO 6
      END=.TRUE.
      IF(NC.EQ.0) GOTO 200
      GOTO 100
    6 IUN=5
      IF(NC.EQ.0) GOTO 1
      IB=0
      GOTO 100
   10 NC=NC+1
      NFF=NF
      ALABEL=BLANK
      LAB=0
      NP=0
      NV=0
      NI=256
      DO 85 I=1,73
      NO=I
      IF(I.EQ.73) GOTO 50
      LH(4)=LC(I)
      IF(NH.LT.240.OR.NH.GT.249) GOTO 20
      LAB=4
      ZZ=ZZ*TEN+DFLOAT(NH-240)
      NZ=NZ+1
      NE=NE+NP
      GOTO 85
   20 DO 30 J=1,4
      IF(NH.EQ.NS(J)) GOTO 40
   30 CONTINUE
      J=0
      JV=0
      IF(LAB.GE.4.OR.NH.EQ.64) GOTO 50
      LAB=LAB+1
      LL(LAB)=LC(I)
      GOTO 85
   40 JV=0
      LAB=4
      GOTO (42,44,50,50),J
   42 NP=1
      GOTO 85
   44 JV=-1
   50 IF(NZ.EQ.0) GOTO 80
   60 IF(NP.EQ.0) GOTO 61
      FZL=ZZ/TEN**NE
      NZL=0
      IF(NV.LT.0) FZL=-FZL
      GOTO 62
   61 IZL=ZZ+DBLE(0.5)
      NZL=1
      IF(NV.LT.0) IZL=-IZL
      IF(NI.NE.197.OR.LZL.EQ.1) GOTO 62
      FZH=0.0
      IF(NF.LE.NM) FZH=FR(NF)
      IF(LZL.EQ.1) FZH=IZH
      IF(NF.LE.NM) FR(NF)=FZH*TEN**IZL
      NI=256
      GOTO 70
   62 IF(NI.NE.92.OR.LZL.EQ.0) GOTO 65
      IZH=1
      IF(NF.LE.NM) FZH=FR(NF)
      NF=NF-1
      DO 64 N=1,IZH
      NF=NF+1
      IF(NF.LE.NM) FR(NF)=FZL
   64 CONTINUE
      NI=256
      GOTO 70
   65 NF=NF+1
      IF(NF.LE.NM) FR(NF)=FZL
      LZL=NZL
      NI=0
   70 ZZ=0.0
      NE=0
      NZ=0
      NV=0
   80 NP=0
      IF(NH.EQ.125) GOTO 86
      IF(NH.EQ.64) GOTO 85
      NV=JV
      IF(J.NE.0) GOTO 85
      NI=256*NI+NH
   85 CONTINUE
   86 CONTINUE
      IF(KC.EQ.2) GOTO 92
   90 LABEL=ALABEL
      IF(LABEL.EQ.LON) IPR=1
      IF(IPR.EQ.1.OR.LABEL.EQ.UNIT) WRITE(6,102) TCI
      IB=0
      DO 91 I=1,10
   91 ITC(I)=TCI(I)
      IF(LABEL.EQ.LON) GOTO 1111
      IF(LABEL.EQ.LOFF) GOTO 93
      IF(LABEL.EQ.UNIT) GOTO 95
      GOTO 100
   93 IPR=0
      GOTO 1111
   95 IUN=IZL
      GOTO 1111
   92 IF(NC.NE.1) GOTO 94
      LH(4)=LL(4)
      IF(NH.EQ.216) GOTO 90
      IF(ALABEL.EQ.LON) GOTO 90
      IF(ALABEL.EQ.LOFF) GOTO 90
      IF(ALABEL.EQ.UNIT) GOTO 90
      IF(NO.LE.72) GOTO 90
      LABEL=ALABEL
      GOTO 96
   94 IF(ALABEL.NE.BLANK) GOTO 98
   96 IF(IPR.EQ.1.AND.NC.EQ.1) WRITE(6,102) TCI
      IF(IPR.EQ.1.AND.NC.NE.1) WRITE(6,105) TCI
      DO 97 I=1,10
   97 ITC(I)=TCI(I)
      IF(NO.GE.73) GOTO 1
      IB=0
      GOTO 100
   98 NF=NFF
      IB=1
  100 N1=NF+1
      N2=MIN0(NM,10)
      IF(N1.GT.N2) GOTO 104
      DO 103 I=N1,N2
  103 FR(I)=0.0
  104 NF=MIN0(NF,NM)
      NBT=0
      NO=NO+1
      IF(NO.GT.72) GOTO 108
      KI=1
      DO 106 I=NO,72
      TC(KI)=TC(I)
  106 KI=KI+1
      DO 107 I=KI,80
  107 TC(I)=BLL
      NBT=KI-1
  108 ALABEL=LABEL
      LH(4)=LL(1)
      IF(NH.NE.92) RETURN
      FZL=FR(2)
      IF(IB.NE.0.OR.NF.NE.2) GOTO 109
      READ(IUN,ITC) (FR(I+1),I=1,IZL)
      IF(IPR.EQ.1) WRITE(6,ITC) (FR(I+1),I=1,IZL)
      NF=1+IZL
      RETURN
  109 WRITE(6,110)
      CALL BDMPA(34)
  200 RETURN 1
  101 FORMAT(10A8)
  102 FORMAT(' -------- ',10A8)
  105 FORMAT(10X,10A8)
  110 FORMAT(' -------- WRONG *CARD  -  STOP')
      END

C   07/06/96 606071903  MEMBER NAME  PSTOR    (S4)          FORTG1
      SUBROUTINE PSTOR(N)
      COMMON/BCS/IW(1)
      INTEGER H(10)
      IF(N.EQ.0)GOTO 10
      CALL BLOC(IND,'STO*',N,*100)
      GOTO 30
  10  CALL BPOS('STO*')
  20  CALL BNXT(IND,*100)
  30  NV=IW(IND+1)
       M=IW(IND+2)
      IF(NV.EQ.0) GOTO 60
      WRITE(6,101) IW(IND-2)
      DO 50 K=1,NV,10
      LA=K
      LB=MIN0(NV,LA+9)
      LL=LB+1-LA
      WRITE(6,102)
       DO 40 I=1,M
      J=0
      DO 35 L=LA,LB
      J=J+1
      H(J)=IW(3+I-M+L*M+IND)
  35  CONTINUE
  40  CALL UWP(H,1,LL)
  50  CONTINUE
  60  IF(N.EQ.0) GOTO 20
 100  RETURN
 101  FORMAT('0',5('----')/' USTOS/USTOR',I9)
 102  FORMAT(1X)
      END

C
      SUBROUTINE MCRAND(COPT,FNAM,IFIRST,ILAST,IERR)
      IMPLICIT NONE
**********************************************************
*
*     Initialise random number generator RANMAR and
*     read or write random seeds from or to disk.
*
*     28/05/00:   Pedro Movilla Fernandez
*
*     INPUT:  COPT='R': Read initial seed from file
*             COPT='W': Write current seed to file
*             FNAM    : Name of the file with initial seed
*        IFIRST,ILAST : First and last event number corresponding to
*                       the start and the end of the current random seed 
*                       (only for users book keeping purposes)
*
*     OUTPUT: IERR    : = 0    o.k.
*                       =-1    read or write error
*                       =-2    invalid option COPT
*
**********************************************************
      CHARACTER COPT*1,FNAM*(*)
      INTEGER IERR,IFIRST,ILAST
C
      INTEGER I,IOS,IOS2,NEVTOT,IFIRST0,ILAST0
      LOGICAL LEXIST
      DATA NEVTOT/0/,IFIRST0/0/,ILAST0/0/
      SAVE NEVTOT
C
      INTEGER IJKLIN,IJKLUT,NTOTIN,NTOTUT,NTO2IN,NTO2UT
      INTEGER J,IBUF(106),MTOT,MTOT2
      SAVE MTOT,MTOT2
C Use modified common /RANMA1/ to initialize with the private version of RANMAR.
      CHARACTER C1*1
      INTEGER IJKL,NTOT,NTOT2,I97,J97
      REAL C,U
      LOGICAL RANINI,RANPRV
      COMMON/RANMA1/IJKL,NTOT,NTOT2,I97,J97,C,U(97),RANINI,RANPRV
      SAVE /RANMA1/
Code:
      RANINI=.TRUE. ! If .true., then initialization via common /RANMA1/ is enabled
      IERR=0
      I=0
      CALL UZERO(IBUF,1,106)
C
      INQUIRE(FILE=FNAM,EXIST=LEXIST)
C --- Find last position in the random seed file
      IF( LEXIST ) THEN
         OPEN(UNIT=99,FILE=FNAM,STATUS='OLD',FORM='FORMATTED')
         PRINT *,'MCRAND: Random number seeds found in '//FNAM//':'
 100     READ(UNIT=99,IOSTAT=IOS,END=110,FMT=991) C1,(IBUF(J),J=1,106)
         IF( IOS.NE.0 ) THEN
            PRINT *,'MCRAND:  Something is wrong with file '//FNAM//'.'
            PRINT *,'... Will stop now!'
            IERR=-1
            GOTO 999
         ENDIF
         I=I+1
         WRITE(*,FMT=990) I,(IBUF(J),J=1,106)
         GOTO 100
C --- Create new random number seed file
      ELSE
         OPEN(UNIT=99,FILE=FNAM,STATUS='NEW',FORM='FORMATTED')
      ENDIF
 110  CONTINUE
      IF( COPT.EQ.'R' ) THEN
         IF( LEXIST ) THEN
C --- Initialise random number generator with last sequence found in the file
C     NB.: If using the private version of RANMAR, and if RANINI.EQ..TRUE., then
C          RMARIN will only set IJKL, NTOT, NTOT2 in common /RANMA1/, and RANPRV is
C          set to .TRUE.. In this case, initialization will be performed directly
C          via common /RANMA1/ (this is much faster than using RMARIN).
            IJKLIN=IBUF(1)
            NTOTIN=IBUF(2)
            NTO2IN=IBUF(3)
            IFIRST0=IBUF(4)
            ILAST0=IBUF(5)
            NEVTOT=IBUF(6)
            MTOT=NTOTIN
            MTOT2=NTO2IN
C        ... initialise via RMARIN (this call checks version of RANMAR used here)
            CALL RMARIN(IJKLIN,NTOTIN,NTO2IN)
C        ... or directly via /RANMA1/
            IF( RANPRV ) CALL UCOPY(IBUF(7),I97,100)
         ELSE
C --- No initialisation
            PRINT *,'MCRAND: Seed file '//FNAM//' does not exist.'
            PRINT *,'... Will use default seed!'
            GOTO 999
         ENDIF
         CLOSE(UNIT=99)
         PRINT *,'MCRAND: Initial seed for RANMAR used for this run:'
         WRITE(*,IOSTAT=IOS,FMT=990) I,IJKLIN,NTOTIN,NTO2IN
     >        ,IFIRST0,ILAST0,NEVTOT,I97,J97,C,(U(J),J=1,97)
      ELSE IF( COPT.EQ.'W' ) THEN 
C --- Write out current random number status to the file
C     NB.: The private version of RANMAR handles the counters NTOT and NTOT2 correctly.
         CALL RMARUT(IJKLUT,NTOTUT,NTO2UT)
         IF( .NOT.RANPRV ) THEN
            NTOTUT=NTOTUT+MTOT
            NTO2UT=NTO2UT+MTOT2
         ENDIF
         NEVTOT=NEVTOT+ILAST-IFIRST+1
         I=I+1
         PRINT *,'MCRAND: New random number seed added to '//FNAM//':'
         IBUF(1)=IJKLUT
         IBUF(2)=NTOTUT
         IBUF(3)=NTO2UT
         IBUF(4)=IFIRST
         IBUF(5)=ILAST
         IBUF(6)=NEVTOT
         CALL UCOPY(I97,IBUF(7),100)
         WRITE(*,FMT=990) I,(IBUF(J),J=1,106)
         WRITE(UNIT=99,IOSTAT=IOS,FMT=991) '#',(IBUF(J),J=1,106)
         CLOSE(UNIT=99,IOSTAT=IOS2)
         IF( IOS.NE.0 .OR. IOS2.NE.0 ) THEN
            PRINT *,'MCRAND: Error while writing out'
     >           //'current random number status to file '//FNAM//'!'
            IERR=-1
            GOTO 999
         END IF
      ELSE
         PRINT *,'MCRAND: Bad option COPT= '//COPT
         IERR=-2
      ENDIF
C
 999  RETURN
C 990  FORMAT(I2,':',3I12,'  (',3I8,'  )',/,2I12,8F12.8,9(/,10F12.8))
 990  FORMAT(I2,':',3I12,'  (',3I8,'  )',10(/,10I12))
 991  FORMAT(A1,3I12,3I8,10(/,10I12))
      END

C   29/04/80 011111125  MEMBER NAME  MCREDU   (CS11)        FORTRAN
      SUBROUTINE zMCREDU( EBEFIX, * ) !PMF 11/04/00 MCREDU->zMCREDU
C-----------------------------------------------------------
C  VERSION OF 29/04/80      LAST MOD 02/11/80     E.ELSEN
C  CUTS FOR MC REDUCTION.
C  EBEFIX IS VALUE OF BEAM ENERGY TO LIMIT MOMENTA . IF ZERO
C  EBEAM IS TAKEN FROM HEAD FOR RUN NUMBER.EQ.0, OTHERWISE
C  FUNCTION EBEAM IS USED.
C  IF( EBEAM < 10 GEV ) BARREL ENERGY CUT IS CHANGED
C  RETURN 1 IF NOT ACCEPTED.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1),HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      DIMENSION HBEAM(2)
      EQUIVALENCE (HBEAM(1),IBEAM)
      DATA EBEAMI / 10000. /, EBEAMA / 0. /
      DATA IEFIX / 0 /
C
      DIMENSION P1(3), P2(3), JLONG(2)
      REAL*4 R(3) / 3*0. /
C
      DIMENSION PCENTI(20)
      INTEGER NREJ(20) / 20*0 /
      DATA NCALL / 0 /, NACC / 0 /
      DATA IHIST / 0 /
C
      IF( NCALL .NE. 0 ) GO TO 2
      IBHEAD = IBLN('HEAD')
      IBTRIG = IBLN('TRIG')
      IBPATR = IBLN('PATR')
      IBALGN = IBLN('ALGN')
      IBLGCL = IBLN('LGCL')
      IF( EBEFIX .NE. 0. ) IEFIX = 1
      IF( IHIST .NE. 1 ) GO TO 2
      CALL THIST( 10001,'#OF LONG TRACKS$' )
      CALL DHIST( 10001, 0., 100. )
      CALL THIST( 10002,'#OF TRACKS$' )
      CALL DHIST( 10002, 0., 100. )
      CALL THIST( 10003,'RMIN2 BEFORE PATR CUT$' )
      CALL DHIST( 10003, 0., 200. )
      CALL THIST( 10004,'ACOPLANARITY--COS PHI$' )
      CALL DHIST( 10004, -1., .02  )
      CALL THIST( 10005,'SUMPL$' )
      CALL DHIST( 10005, 0., 60. )
      CALL THIST( 10006,'SHOWER TOTAL$' )
      CALL DHIST( 10006, 0., 60. )
      CALL THIST( 10007,'E-SHOWER BARREL$' )
      CALL DHIST( 10007, 0., 60. )
      CALL THIST( 10008,'SHOWER + P$' )
      CALL DHIST( 10008, 0., 60. )
      CALL THIST( 10009,'SHOWER + PL$' )
      CALL DHIST( 10009, 0., 60. )
      CALL THIST( 10015,'ETOTSL$' )
      CALL DHIST( 10015, 0., 60. )
      CALL THIST( 10020,'#OF LONG TRACKS AFTER CUT$' )
      CALL DHIST( 10020, 0., 100. )
      CALL THIST( 10021,'#OF TRACKS$ AFTER CUT' )
      CALL DHIST( 10021, 0., 100. )
      CALL THIST( 10022,'SHOWER TOTAL AFTER CUT$' )
      CALL DHIST( 10022, 0., 60. )
      CALL THIST( 10023,'E SHOWER BARREL AFTER CUT$' )
      CALL DHIST( 10023, 0., 60. )
      CALL THIST( 10024,'SUMPL AFTER CUT$' )
      CALL DHIST( 10024, 0., 60. )
    2 CONTINUE
C
C                                           CHECK TRIGGER
      NCALL = NCALL + 1
      NPHEAD = IW(IBHEAD)
      IF( NPHEAD .GT. 0 ) GO TO 100
      NREJ( 1) = NREJ( 1) + 1
      GO TO 8000
C
  100 ITR = HW(NPHEAD*2+22)
      IF( MOD(ITR,8) .NE. 0 ) GO TO 110
      NREJ(13) = NREJ(13) + 1
      GO TO 8000
C                                           MAG FIELD, ENERGY
  110 BKGAUS = ABS( HW(NPHEAD*2+30)/1000. )
      IBEAM= HW(NPHEAD*2+29)
      HBEAM(1) = 0
      EBEA = IBEAM / 1000.
      HRUN = HW(NPHEAD*2+10)
      IF( HRUN .NE. 0 ) EBEA = EBEAM( HRUN ) / 1000.
      IF( IEFIX .EQ. 1 ) EBEA = EBEFIX
      IF( EBEA .LT. EBEAMI ) EBEAMI = EBEA
      IF( EBEA .GT. EBEAMA ) EBEAMA = EBEA
C                                           BARREL ENERGY CUT
      EBARC = 3.
      ENDCC = .4
      IF( EBEA .GT. 12. ) GO TO 120
      EBARC = 2.
      ENDCC = .4
  120 CONTINUE
      IF( EBEA .GT. 8. ) GO TO 130
      EBARC = 1.2
      ENDCC = .2
  130 CONTINUE
C
C                                           CHARGED TRACKS
      NPPATR = IW(IBPATR)
      IF( NPPATR .GT. 0 ) GO TO 210
      NREJ( 3) = NREJ( 3) + 1
      GO TO 8000
C
  210 SUMPL = 0.
      SUMLZ = 0.
      SUMP = 0.
      SUMZ = 0.
      NTRKL = 0
      RMIN1 = 10000.
      RMIN2 = 10000.
      ZMIN = 1000000.
      AZMIN = 1000000.
      NTRK = IW(NPPATR+2)
      IF( NTRK .GT. 0 ) GO TO 220
      NREJ(11) = NREJ(11) + 1
      GO TO 8000
C
  220 LPATR = IW(NPPATR+3)
      IP0 = NPPATR + IW(NPPATR+1)
      IP9 = IP0 + (NTRK-1)*LPATR
      DO 300 J=IP0,IP9,LPATR
C                                           Z VALUES
      ZV = RW(J+31)
      AZV = ABS(ZV)
      IF( AZV .GT. AZMIN ) GO TO 240
      ZMIN = ZV
      AZMIN = AZV
  240 CONTINUE
C                                           RMIN
      CALL PRTOCI( J, CAP, RMIN, PHIM, SIG )
      ARMIN = ABS(RMIN)
      IF( ARMIN .GT. RMIN1 ) GO TO 245
      RMIN2 = RMIN1
      RMIN1 = ARMIN
      GO TO 247
  245 IF( ARMIN .GT. RMIN2 ) GOTO 247
      RMIN2 = ARMIN
  247 CONTINUE
C
      PRAD = .3E-4*BKGAUS/CAP
      DZDR = RW(J+30)
      P = PRAD*SQRT(1.+DZDR**2)
      A = 1.
      IF( P .GT. EBEA ) A = EBEA / P * .5
      P = P * A
      PZ = PRAD*DZDR*A
      SUMP = SUMP + P
      SUMZ = SUMZ + PZ
C                                           NO OF HITS
      IF( IW(J+24) .LT. 24 ) GO TO 300
      IF( AZV .GT. 350.    ) GO TO 300
      IF( ARMIN .GT. 100.  ) GO TO 300
      NTRKL = NTRKL + 1
      SUMPL = SUMPL + P
      SUMLZ = SUMLZ + PZ
C                                           INDICES FOR FIRST LONG
      IF( NTRKL .GT. 2 ) GO TO 300
      JLONG(NTRKL) = J
  300 CONTINUE
C
      IF( IHIST .EQ. 1 ) CALL UHIST( 10001, FLOAT(NTRKL) )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10002, FLOAT(NTRK) )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10005, SUMPL )
C
C                                           PATR CUTS
      IF( NTRKL .GE. 2 .AND. NTRK .GE. 5 ) GO TO 310
      NREJ( 5) = NREJ( 5) + 1
      GO TO 8000
C
  310 IF( IHIST .EQ. 1 ) CALL UHIST( 10003, RMIN2 )
      IF( RMIN2 .LE. 30. ) GO TO 320
      NREJ( 6) = NREJ( 6) + 1
      GO TO 8000
C
  320 IF( ABS(ZMIN) .LE. 400. ) GO TO 330
      NREJ( 7) = NREJ( 7) + 1
      GO TO 8000
C
  330 CONTINUE
C                                           ACOPLANARITY
      ACOP = 1.5
      IF( NTRKL .NE. 2 ) GO TO 400
      CALL MOFRCI( JLONG(1), R, P1, CH )
      CALL MOFRCI( JLONG(2), R, P2, CH )
      ACOP = ( P1(1)*P2(1) + P1(2)*P2(2) ) /
     *       SQRT( ( P1(1)*P1(1) + P1(2)*P1(2) ) *
     *             ( P2(1)*P2(1) + P2(2)*P2(2) ) )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10004, ACOP )
      IF( ACOP .GT. -.9848 ) GO TO 400
      NREJ( 8) = NREJ( 8) + 1
      GO TO 8000
C
C                                           TOTAL ENERGY
  400 NPLGCL = IW(IBLGCL)
      IF( NPLGCL .GT. 0 ) GO TO 410
      NREJ( 4 ) = NREJ( 4) + 1
      GO TO 8000
C
  410 J = NPLGCL + IW(NPLGCL+1)-1
      ETOT = RW(J+7)
      EBAR = RW(J+8)
      ENDM = RW(J+9)
      ENDP = RW(J+10)
      ESUM = SUMP + ETOT
      ESUML = SUMPL + ETOT
      IF( IHIST .EQ. 1 ) CALL UHIST( 10006, ETOT )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10007, EBAR )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10008, ESUM )
      IF( IHIST .EQ. 1 ) CALL UHIST( 10009, ESUML )
      IF( EBAR .GT. EBARC ) GO TO 420
      IF( ENDM.GT.ENDCC .AND. ENDP.GT.ENDCC ) GO TO 420
      NREJ( 9) = NREJ( 9) + 1
      GO TO 8000
C                                           CLUSTERS
  420 TOTSHW = 0.
      SHWZ = 0.
      NCLST = IW(NPLGCL+7)
      IF( NCLST .LE. 0 ) GO TO 450
      NWPCL = IW(NPLGCL+25)
      IB0 = NPLGCL + IW(NPLGCL+3) - 1
      IB9 = IB0 + (NCLST-1)*NWPCL
      DO 430 J=IB0,IB9,NWPCL
      ECL = RW(J+2)
      TOTSHW = TOTSHW + ECL
      SHWZ  = SHWZ + ECL*RW(J+11)
  430 CONTINUE
  450 CONTINUE
C
      ETOTSL = SUMPL + TOTSHW
      RSL = ( SUMLZ + SHWZ ) / ETOTSL
      IF( IHIST .EQ. 1 ) CALL UCORR( 10004, RSL, ETOTSL )
C                                           MOMENTUM BALANCE
      IF( ABS(RSL) .LT. .4 ) GO TO 510
      NREJ(10) = NREJ(10) + 1
      GO TO 8000
C                                           TOTAL ENERGY
  510 IF( IHIST .EQ. 1 ) CALL UHIST( 10015, ETOTSL )
      IF( ETOTSL .GT. EBEA ) GO TO 520
      NREJ(14) = NREJ(14) + 1
      GO TO 8000
C
  520 CONTINUE
      IF( IHIST .NE. 1 ) GO TO 530
      CALL UHIST( 10020, FLOAT(NTRKL) )
      CALL UHIST( 10021, FLOAT(NTRK) )
      CALL UHIST( 10022, ETOT )
      CALL UHIST( 10023, EBAR )
      CALL UHIST( 10024, SUMPL )
C
C
  530 NACC = NACC + 1
      RETURN
C
C                                           REJECTED
 8000 RETURN 1
C
C
      ENTRY MCRDFL
C----------------------------------------------------------
C ENTRY TO PRINT STATISTICS
C TO BE CALLED AT END OF JOB .
C----------------------------------------------------------
      IF( NCALL .LE. 0 ) RETURN
      PCBAS = MAX0( NCALL, 1 ) * .01
      PCENT = NACC / PCBAS
      PCENTE = SQRT( FLOAT(NCALL - NACC) ) / PCBAS
      DO 8101 I=1,14
      PCENTI(I) = NREJ(I) / PCBAS
 8101 CONTINUE
      IF( IEFIX .NE. 1 )
     *WRITE(6,9101) NCALL, NACC, PCENT, PCENTE, EBEAMI, EBEAMA
 9101 FORMAT(//10X,' SUMMARY FOR THIS FILE',
     *           '         PROGRAM VERSION OF 04/11/80'/
     *       10X,'   EVENTS ANALYSED ',I8/
     *       10X,'   EVENTS ACCEPTED ',I8,'=',F7.2,' % +-',F5.2,' %'
     *                                   ,20X,F7.3,'=< EBEAM =<',F7.3,
     *           '  TAKEN FROM ''HEAD'''/)
      IF( IEFIX .EQ. 1 )
     *WRITE(6,9103) NCALL, NACC, PCENT, PCENTE, EBEAMI, EBEAMA
 9103 FORMAT(//10X,' SUMMARY FOR THIS FILE',
     *           '         PROGRAM VERSION OF 04/11/80'/
     *       10X,'   EVENTS ANALYSED ',I8/
     *       10X,'   EVENTS ACCEPTED ',I8,'=',F7.2,' % +-',F5.2,' %'
     *                                   ,20X,F7.3,'=< EBEAM =<',F7.3,
     *           '  VALUE WAS FIXED'/)
      WRITE(6,9102) (NREJ(I),PCENTI(I),I=1,14)
 9102 FORMAT(10X,' REASONS FOR REJECTION'/
     */10X,'HEAD MISSING             ',I8,' =',F7.1,' %',
     */10X,'TRIG MISSING             ',I8,' =',F7.1,' %',
     */10X,'PATR MISSING             ',I8,' =',F7.1,' %',
     */10X,'LGCL MISSING             ',I8,' =',F7.1,' %',
     */10X,'NTRKL < 2                ',I8,' =',F7.1,' %',
     */10X,'RMIN2 > 30.MM            ',I8,' =',F7.1,' %',
     */10X,'ZMIN > 400.              ',I8,' =',F7.1,' %',
     */10X,'ACOPL > 10 DEG           ',I8,' =',F7.1,' %',
     */10X,'E - BARREL < 3(2,1.2)GEV ',
     */10X,'E+ OR E- < .4 (.4,.2)GEV ',I8,' =',F7.1,' %',
     */10X,'MOM BALANCE < .4         ',I8,' =',F7.1,' %',
     */10X,'NO TRACKS                ',I8,' =',F7.1,' %',
     */10X,'TOO MANY TRACKS          ',I8,' =',F7.1,' %',
     */10X,'REJECTED BY TRIGGER      ',I8,' =',F7.1,' %',
     */10X,'ETOTSL < EBEAM           ',I8,' =',F7.1,' %')
      IF( IHIST .NE. 1 ) GO TO 8900
      CALL PHIST( 10001 )
      CALL PHIST( 10002 )
      CALL PHIST( 10003 )
      CALL PHIST( 10004 )
      CALL PHIST( 10005 )
      CALL PHIST( 10006 )
      CALL PHIST( 10007 )
      CALL PHIST( 10008 )
      CALL PHIST( 10009 )
      CALL PHIST( 10015 )
      CALL PHIST( 10020 )
      CALL PHIST( 10021 )
      CALL PHIST( 10022 )
      CALL PHIST( 10023 )
      CALL PHIST( 10024 )
      CALL PCORR( 10004 )
 8900 RETURN
      END

C   03/08/85 508032008 MEMBER NAME  EDIMAC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EDIMAC
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   3/08/85 :  EDIT AN EXISTING MACRO
C
C
C     THIS ROUTINE PROMPTS FOR A MACRO NAME, DISPLAYS THE MACRO
C     DEFINITION AND ALLOWS THE USER TO REDEFINE THE MACRO.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS
      LOGICAL*1  CDEF
C
      COMMON / CWORK  / NFIELD, CHARS(80), ISTAFL(80), IENDFL(80)
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
C------------------  C O D E  ------------------------------------------
C
   5  WRITE(6,10)
  10  FORMAT(' Please enter the NAME of the macro to be edited')
      READ(5,40) CHARS
  40  FORMAT(80A1)
C
C                            FIND THE NAME
C
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .EQ. 0 ) RETURN
C
C                            CORRECT LENGTH AND ONLY ONE?
C
      LEN = IENDFL(1) - ISTAFL(1) + 1
      IF( NFIELD .EQ. 1  .AND.  LEN .LE. 8 ) GO TO 60
        WRITE(6,50)
  50    FORMAT(' Sorry. Only one name of 8 letters or less and no ";"',
     +         '. Please try again')
        GO TO 5
C
C                            IS THE NAME UNIQUE?
C
  60  CALL FINABR( CHARS(ISTAFL(1)), LEN, IREC, MAXARG, IS )
      IMAC = IREC - MACSTA
      IF( IMAC .GT. 0 ) GO TO 70
        WRITE(6,65)
  65    FORMAT(' No macro with that name exists.',
     +         ' Please try again or press ENTER to end EDITMAC')
        GO TO 5
C
C                            DISPLAY DEFINITION
C
  70  WRITE(6,80) (CDEF(K,IMAC),K=1,80)
  80  FORMAT(' The following definition currently exists for this',
     +       ' macro:'/
     +       1X,80A1/' Please enter new definition    or just press ',
     +               'ENTER to retain old definition')
C
      READ(5,90) CHARS
  90  FORMAT(80A1)
C
C                            NULL LINE?
C
      CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .GT. 0 ) GO TO 100
        WRITE(6,95)
  95    FORMAT(' Old definition retained.')
        RETURN
C
C
C
 100  DO  110  I = 1,80
        CDEF(I,IMAC) = CHARS(I)
 110  CONTINUE
C
      WRITE(6,120)
 120  FORMAT(' New definition accepted.')
C
      RETURN
      END

C   11/09/79 404162023  MEMBER NAME  MUMESS   (JADEMUS)     FORTRAN
C LAST CHANGE 10.30 11/09/79 JOHN ALLISON.
      SUBROUTINE MUMESS(NAME,INF,MESS)
C
      INTEGER*2 NAME(3)
      LOGICAL*1 MESS(1)
C
C PRINTS MU MESSAGES.
C
C PROVIDE SUBROUTINE NAME IN NAME.
C PROVIDE INFORMATION IN INTEGER*4 WORD INF.
C PROVIDE MESSAGE IN MESS TERMINATED BY '^'.
C
      COMMON /CMUPRN/MUPRIN
C
      LOGICAL*1 BAR/'^'/
C
C COUNT NUMBER OF CHARACTERS.
C
      IF(MUPRIN.LT.2)GO TO 99
C
      N=1
 1    CONTINUE
      IF(MESS(N).EQ.BAR)GO TO 2
      N=N+1
      IF(N.LE.200)GO TO 1
C
 2    CONTINUE
C
      N=N-1
C
      WRITE(6,100)NAME,INF,(MESS(I),I=1,N)
 100  FORMAT('0MU MESSAGE FROM ',3A2,4X,', INFORMATION --->',I10,',',
     *4X,70A1/(1X,132A1))
C
 99   CONTINUE
      RETURN
      END

C   07/10/83 310261819  MEMBER NAME  MCTRCB   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCTRCB( ITRACK, NPART, IPART, IVECT, FRACT )
C-----------------------------------------------------------------------
C
C   AUTHOR    C. BOWDERY   7/10/83 :  TRACEBACK FROM 'PATR' TO 'VECT'
C
C   LAST MOD  C. BOWDERY  21/10/83 :  CALL MCTR4V. CHECK -VE ITRACK.
C
C   GIVEN A 'PATR' TRACK NUMBER, DETERMINE THE 4_VECTOR PARTICLE IN
C   ONE OF THE 'VECT' BANKS THAT IS ASSOCIATED WITH IT. 'TR4V' IS USED.
C
C   INPUT:  ITRACK      =  'PATR' TRACK NUMBER
C   OUTPUT: NPART       =  NUMBER OF 4_VECTORS ASSOCIATED (USUALLY 1)
C           IPART(1..3) =  ARRAY OF ASSOCIATED 'VECT' PARTICLE NUMBERS
C           IVECT(1..3) =  ARRAY OF 'VECT' BANK NO. CORRESP. TO IPART
C           FRACT(1..3) =  ARRAY OF HIT FRACTIONS FOR EACH ASSOC. PART.
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL SELECT
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
      DIMENSION  IPART(3), IVECT(3), FRACT(3)
C
      DATA IEFL1, IEFL2 / 0 , 0 /
C
C-------------------  C O D E  -----------------------------------------
C
      DO  2  I = 1,3
        IPART(I) = 0
        IVECT(I) = 0
        FRACT(I) = 0.0
 2    CONTINUE
C
C                       CREATE THE 'TR4V' BANK IF IT DOES NOT EXIST
C
      CALL MCTR4V(0, IERROR)
C
C                       CHECK THAT THE 'TR4V' BANK EXISTS. ERROR CODE 1
C                                                        IF IT DOES NOT.
      IPT = IDATA( IBLN ('TR4V') )
      IF(IPT .GT. 0 ) GO TO 4
      NPART = -1
      IEFL1 = IEFL1 + 1
      IF( IEFL1 .GT. 10 ) RETURN
        WRITE(6,5)
  5     FORMAT(/' **** WARNING ****  MCTRCB FOUND NO ''TR4V'' BANK'/)
        RETURN
C
C                       CHECK THAT TRACK NUMBER DOES NOT EXCEED MAX.
C                       NUMBER OF PATR TRACKS. ERROR CODE 2 IF IT DOES.
C
  4   MAXTRK = IDATA ( IPT + 1 )
      IF( ITRACK .LE. MAXTRK .AND. ITRACK .GT. 0 ) GO TO 6
      NPART = -2
      IEFL2 = IEFL2 + 1
      IF( IEFL2 .GT. 50 ) RETURN
        WRITE(6,7) ITRACK, MAXTRK
  7     FORMAT(/' **** ERROR **** MCTRCB INPUT TRACK ',I4,' > NO. OF'
     +         ,' TRACKS ( = ',I4,') OR < 1'/)
        RETURN
C
C                       DETERMINE THE NUMBER OF ASSOCIATED 4 VECTORS
C                       AND THE TOTAL NUMBER OF HITS ALONG THE TRACK
C
  6   INDEX  = IPT + 1 + (ITRACK-1)*8
      NAPART = IDATA ( INDEX + 1 )
      NAHITS = IDATA ( INDEX + 2 )
      IF( NAPART .LE. 0 ) RETURN
C
C                       FIND THE ENCODED PARTICLE INFO AND EXTRACT
C                       THE PARTICLE AND VECT BANK NUMBER
C                       ICODE = 2 * 4_VECTOR_PARTICLE + VECT_BANK_NUMBER
C
C                       THEN CALCULATE HIT FRACTION
C
      NPART    = 1
      ICODE    = IDATA( INDEX + 3 )
      IPART(1) = ICODE / 2
      IVECT(1) = MOD( ICODE , 2 )
      FRACT(1) = FLOAT( IDATA( INDEX + 4 ) ) / FLOAT( NAHITS )
C
      IF( NAPART .EQ. 1 ) RETURN
C
C
      ICODE    = IDATA( INDEX + 5 )
      NHITS2   = IDATA( INDEX + 6 )
      FRACT2   = FLOAT( NHITS2 ) / FLOAT( NAHITS )
C
C                       DOES THE SECOND OPTION BELONG TO ANOTHER TRACK ?
C                       SCAN THE 'TR4V' BANK AND SET THE 'SELECT' FLAG.
C
      CALL SCTR4V(ICODE,NHITS2,FRACT2,IPT,SELECT)
      IF( .NOT. SELECT ) GO TO 1
      NPART    = 2
      IPART(2) = ICODE / 2
      IVECT(2) = MOD( ICODE, 2 )
      FRACT(2) = FRACT2
C
  1   IF( NAPART .EQ. 2 ) RETURN
C
      NHITS3       = IDATA( INDEX + 8 )
      FRACT3       = FLOAT( NHITS3 ) / FLOAT( NAHITS )
      ICODE        = IDATA( INDEX + 7 )
C
C                       DOES THE NEXT OPTION BELONG TO ANOTHER TRACK ?
C                       SCAN THE 'TR4V' BANK AND SET THE 'SELECT' FLAG.
C
      CALL SCTR4V(ICODE,NHITS3,FRACT3,IPT,SELECT)
      IF( .NOT. SELECT ) RETURN
C
C                       NPART COULD BE 2 OR 3 DEPENDING ON THE LAST STEP
C
      NPART        = NPART + 1
      IPART(NPART) = ICODE / 2
      IVECT(NPART) = MOD( ICODE, 2 )
      FRACT(NPART) = FRACT3
C
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE SCTR4V(ICODE,NHITS,FRACT,IPT,SELECT)
C-----------------------------------------------------------------------
C
C             THIS SUBROUTINE SCANS THE 'TR4V' BANK AND SEARCHES TO SEE
C             WHETHER THERE IS AN ENTRY IN THE BANK FOR 4_VECTOR
C             PARTICLE WITH CODE  ICODE WHICH HAS MORE HITS THAN NHITS,
C             IF THERE ARE LESS THAN 8 HITS OR WHICH HAS A GREATER HIT
C             FRACTION.
C             IF YES, SELECT IS 'FALSE', 'TRUE' OTHERWISE.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL SELECT
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C-------------------  C O D E  -----------------------------------------
C
      SELECT = .FALSE.
      NTRKS  = IDATA( IPT + 1 )
C
      DO  1  I = 1,NTRKS
        DO  2  J = 3,7,2
          JCODE = IDATA( IPT + 1 + (I-1)*8 + J )
          IF(JCODE .NE. ICODE ) GO TO 2
C                                              HITS FOR THIS PATR TRACK
            ITOT   = IDATA( IPT + 1 + (I-1)*8+ 2 )
C                                              HITS FOR THIS POSSIBILITY
            JHITS  = IDATA( IPT + 1 + (I-1)*8 + J + 1 )
            FRACTJ = FLOAT( JHITS ) / FLOAT( ITOT )
C
C                            ARE THERE 8 HITS OR MORE FOR BOTH PARTICLES
C
            IF( NHITS .GE. 8  .AND. JHITS .GE. 8 ) GO TO 3
C
C                            NO SO JUST COMPARE THE NUMBER OF HITS
C
              IF( JHITS .GT. NHITS ) RETURN
              GO TO 2
C
C                            YES SO COMPARE HIT FRACTIONS
C
   3        IF( FRACTJ .GT. FRACT ) RETURN
  2     CONTINUE
 1    CONTINUE
C
      SELECT = .TRUE.
C
      RETURN
      END

C   12/03/84 709172208  MEMBER NAME  TAGAN    (S)           FORTRAN
C
C
C
C------   T A G A N   ------   T A G A N   ------   T A G A N   ------
C
C------   T A G A N   ------   T A G A N   ------   T A G A N   ------
C
C------   T A G A N   ------   T A G A N   ------   T A G A N   ------
C
C
C
      SUBROUTINE TAGAN(IER,NRUN)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C TAGAN IS THE CONTROLLING ROUTINE FOR FORWARD DETECTOR ANALYSIS
C              ITS CHIEF PURPOSE IS TO DECIDE WHAT ROUTINE TO CALL
C              EITHER ANATAG OR TAGGTP
C
C     TAGGTP IS WRITTEN BY A.J.FINCH TO ANALYSE 1981 ONWARDS DATA
C     ANATAG IS WRITTEN BY H.WRIEDT  TO ANALYSE PRE 1981 DATA
C
C INPUT - NRUN -> THIS IS USED TO OVERIDE THE ATTEMPT BY
C                  TAGAN TO DECIDE WHAT SIMULATION HAS BEEN DONE
C                  WHEN MONTE CARLO DATA IS ANALYSED.
C
C                 IF NRUN = 0 TAGAN LOOKS AT THE FIRST WORD OF
C                  ATAG BANK DATA -
C                              - IF IT EQUALS ZERO THIS IS MARK 1
C                              - IF IT EQUALS ONE THIS IS MARK 2
C                              - IF IT EQUALS TWO THIS IS MARK 3
C
C                    (IN MCJADE THIS WORD IS SET IN STATAG/STAG81/..)
C
C OUTPUT - IER -> ERROR CODE:
C                     0 - ATAG EXISTS AND CLUSTERS WERE FOUND
C                     1 - ATAG EXISTS BUT CLUSTERS WERE NOT FOUND
C                     2 - ANALYSIS COMPLETED BUT NOT ENOUGH SPACE
C                         TO CREATE ONE OR MORE OUTPUT BANK
C                    10 - ATAG BANK NOT FOUND - NO ANALYSIS DONE
C                    11 - HEAD BANK NOT FOUND - NO ANALYSIS DONE
C
C 24/2/84 A.J.FINCH
C
C INSTALLED ON TAGG.S 12/3/84
C
C      MOD  J. NYE  24/05/84  CALLS TAGMRK
C      MOD  J. NYE  22/06/84  CHANGES MADE TO OUTPUT
C LAST MOD  J. NYE  13/09/84  CHANGES MADE TO OUTPUT
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       IMPLICIT INTEGER*2 (H)
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C
C FOLLOWING ARE ALL THE COMMONS USED BY TAGGTP ROUTINES
C
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C   12/03/84 412041226  MEMBER NAME  CTAGGO   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C HERE ARE THE COMMONS THAT EVENTUALLY BECOME THE TP BANKS ACCLS -
C TAGG/O ,1,2,3
C CONVENTION IN NAMING -
C
C FIRST LETTER -
C         C - NAME OF COMMON
C         H - NAME OF VARIABLES *2 TYPE      INTEGER
C         I -   "       "       *4 TYPE         "
C         A -   "       "                    REAL
C
C REST OF NAME AS FOR TAGG BANKS SEE JADE COMPUTER NOTE 16 FOR MORE DETA
C
C ACTUALLY ALL THIS COULD ALSO GO IN WORKSPACE BUT I CANT BE BOTHERED!
C
C**** IMPORTANT :  IF YOU CHANGE THE SIZE OF THESE COMMONS PLEASE
C                  REMEMBER TO CHANGE 'TAGINT' WHICH CLEARS THEM.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      COMMON / CACLS  / HID1,HID2,HIPM,HIPZ,HDUM,HIPL,HDUMM1(134)
      DIMENSION HACLS(140)
      EQUIVALENCE ( HACLS(1) , HID1 )
C
      COMMON / CTAGG0 / HID3,HID4,HTRACK,HTRZMI,HTRZPL,HCLST,
     *                  HCLZMI,HCLZPL,HNEUT,HCOL,HTYPE,HER,HCORR,
     *                  HPBLAT,HDUM1,HDUM2,HSCAL(36),HWPCL,HWPTR,
     *                  HDUMM2(14)
      DIMENSION     ATAGG0(34)
      EQUIVALENCE ( HID3 , ATAGG0(1) )
C
      COMMON / CTAGG1 / HMAP(2,20)
C
      COMMON / CTAGG2 / ATAGG2(260)
      DIMENSION         ITAGG2(260)
      INTEGER*2         HTAGG2(520)
      EQUIVALENCE ( HTAGG2(1) , ITAGG2(1) , ATAGG2(1) )
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       COMMON / CONTRL / JWRITE
       LOGICAL NFIRST
       DATA NFIRST  / .FALSE. /
       DATA NDEBUG  /      25 /
       DATA MARK0 / -1 /
C
C
C------------------------ C O D E --------------------------------------
C
C
C
C---                                    CHECK ATAG BANK EXISTS
C
C
CCC    JWRITE = 0
CCC    IF ( NDEBUG .GT. 0 ) JWRITE = 1
CCC    NDEBUG = NDEBUG - 1
       IWRITE = JWRITE
       IER = 0
       CALL BLOC(IND,'ATAG',0,*100)
       GOTO 200
  100  IER = 10
       RETURN
C
C
C---                                    CHECK HEAD BANK EXISTS
C
C
  200  IHEAD = IDATA(IBLN('HEAD'))
       IF ( IHEAD .GT. 0 ) GOTO 400
  300  IER = 11
       RETURN
  400  CONTINUE
C
C
C---                                    GET DATA FROM HEAD BANK
C
C
       IHHEAD = IHEAD + IHEAD
       NDATE  = HDATA(IHHEAD +  8)
       NEXP   = HDATA(IHHEAD +  9)
       NRUNTG = HDATA(IHHEAD + 10)
       NEVEN  = HDATA(IHHEAD + 11)
       NERGY  = HDATA(IHHEAD + 29)
       IF ( (NERGY .GT. 30000) .OR. (NERGY .LT. 5000) ) NERGY = 17500
       ERGY   = 0.001 * FLOAT( NERGY )
C
C
C---                                    DECIDE A) MC OR REAL DATA
C---                                           B) WHICH DETECTOR
C
C
C
C   CALL TAGMRK - RETURNS 1 IF NO HEAD BANK
C   SETS  IMC = 1 IF MC DATA
C   SETS MARK = 0,1,OR 2 FOR 79/80,81/82, AND 83
C                             DETECTORS
C
        CALL TAGMRK(*300)
C
C
C----------------------------------------MONTE CARLO DATA ONLY----------
C
C
C
C---                                    IF MC DATA AND NRUN GIVEN THEN
C---                                    FORCE MARK TO AGREE WITH NRUN
C
C
C
       IF ( (IMC .EQ. 0) .OR. (NRUN .EQ. 0) ) GOTO 5
C
       NRUNTG = NRUN
       IF (  NRUNTG .LT.  6000 )                            MARK = 0
       IF ( (NRUNTG .GE.  6000) .AND. (NRUNTG .LT. 12948) ) MARK = 1
       IF (  NRUNTG .GE. 12948 )                            MARK = 2
C
C-----------------------------------------------------------------------
C
    5  CONTINUE
C
C
C---                                    PRINT MARK USED ETC
C  NOTE  :  PRINTS REAL MARK (1-3)
C  RATHER THAN SOFTWARE MARK (0-2)
C
CCC    IF ( NFIRST ) GOTO 1
       IF ( MARK .EQ. MARK0 ) GOTO 1
       MARK0  = MARK
       NYMARK = MARK + 1
       WRITE(6,601)
       IF (  IMC .EQ. 0 ) WRITE(6,602) NYMARK
       IF (  IMC .EQ. 1 ) WRITE(6,603) NYMARK
       IF ( MARK .EQ. 0 ) WRITE(6,605)
       IF ( MARK .EQ. 1 ) WRITE(6,606)
       IF ( MARK .EQ. 2 ) WRITE(6,607)
       IF ( (IMC .EQ. 1) .AND. (NRUN.NE.0) ) WRITE(6,608) NRUN
       WRITE(6,604)
       NFIRST = .TRUE.
  601  FORMAT(/,/,
     * /,' ++++ T A G A N ++++++++ T A G A N ++++++++ T A G A N ++++',
     * /,' +                                                       +')
  602  FORMAT(
     *   ' +  REAL DATA ',9X,' MARK ',I3,'   TAGGER                +',
     * /,' +                                                       +')
  603  FORMAT(
     *   ' +  MC DATA   ',9X,' MARK ',I3,'   TAGGER SIMULATION     +',
     * /,' +                                                       +')
  605  FORMAT(
     *   ' +                      1979 - 1980                      +')
  606  FORMAT(
     *   ' +                      1981 - 1982                      +')
  607  FORMAT(
     *   ' +                      1983 - 1986                      +')
  608  FORMAT(
     *   ' +                                                       +',
     * /,' +  FORCED  BY  NRUN  =  ',I6,'                          +')
  604  FORMAT(
     *   ' +                                                       +',
     * /,' +++++++++++++++++++++++++++++++++++++++++++++++++++++++++',
     * /,/)
C
C
C
C---                                    CALL ANALYSIS ROUTINES
C
C
    1  CONTINUE
       IF ( MARK .GT. 0    ) GOTO 2
C
C
C----------------------------------------MARK = 0 ONLY------------------
C
C
C
C---                                    CALL ANATAG FOR PRE 1981 DATA
C
C
       IF ( IMC .EQ. 0 ) CALL ANATAG(IER1)
       IF ( IMC .EQ. 1 ) CALL AMCTAG(IER1)
       GOTO 1000
C
C
C----------------------------------------MARK = 1 OR 2 ONLY-------------
C
C
C---                                    CALL TAGGTP ROUTINE
C
C
C IWRITE CAN BE SET TO 1 TO TURN ON DEBUGGING INFO
C
C RETURN 1 FROM TAGGTP IS DONE IF ATAG NOT FOUND - SHOULD BE
C REDUNDANT WHEN CALLED FROM TAGAN
C RETURN 2 FROM TAGGTP IS DONE IF ERROR IN TAGSTO -
C  IE NO ROOM FOR TAGG BANKS IN COMMON/BCS/
C
    2  CALL TAGGTP(IWRITE,ERGY,*100,*100)
C
C
C-----------------------------------------------------------------------
C
C
C
C---                                    CHECK TAGG/0 BANK FOR CLUSTERS
C
C
 1000  CONTINUE
       CALL BLOC(INTAG0,'TAGG',0,*1001)
       NCLST = HDATA( INTAG0 + INTAG0 + 6 )
       IF ( NCLST .LE. 0 ) IER = 1
       RETURN
 1001  IER = 2
       RETURN
       END

C   07/06/96 606071904  MEMBER NAME  PTEXT1   (S4)          FORTRAN
      SUBROUTINE PTEXT
      COMMON/BCS/IW(1)
      LOGICAL*1 AR(1),LTEXT(60),DOLL/'$'/
      INTEGER TEXT(15),BLANK/'    '/
      EQUIVALENCE (TEXT(1),LTEXT(1))
      REAL*8 TEXTE(6)/'UCOND   ','UTABL   ','UHIST   ','UCORR   ',
     1   'USTOR/S ','TEXT    '/
      CALL BPOS('TEX*')
      LK=0
  10  CALL BNXT(IND,*100)
      K=IW(IND-2)/100000000
      M=IW(IND-2)-K*100000000
      IF(K.LE.0) K=0
      K=MOD(K,6)
      IF(K.LE.0) K=6
      IF(K.EQ.LK) GOTO 20
      LK=K
      WRITE(6,101) TEXTE(LK)
   20 CONTINUE
      NF=IW(IND)
      WRITE(6,102) M,(IW(IND+I),I=1,NF)
      GOTO 10
C
      ENTRY TCOND(N,AR)
      K=1
      GOTO 50
      ENTRY TTABL(N,AR)
      K=2
      GOTO 50
      ENTRY THIST(N,AR)
      K=3
      GOTO 50
      ENTRY TCORR(N,AR)
      K=4
      GOTO 50
      ENTRY TSTOR(N,AR)
      ENTRY TSTOS(N,AR)
      K=5
      GOTO 50
      ENTRY TTEXT(N,AR)
      K=6
   50 M=N
      IF(M.LT.0) GOTO 100
      M=M+K*100000000
      DO 60 I=1,61
      IF(AR(I).EQ.DOLL) GOTO 62
   60 CONTINUE
      I=61
   62 II=I-1
      IL=(II+3)/4
      DO 70 L=1,IL
   70 TEXT(L)=BLANK
      DO 80 I=1,II
   80 LTEXT(I)=AR(I)
      CALL BCRE(IND,'TEX*',M,IL,*100,IER)
      IF(IER.NE.0) GOTO 100
      CALL BSTR(IND,TEXT,IL)
  100 RETURN
  101 FORMAT(/,1X,A8/)
  102 FORMAT(1X,I16,4X,15A4)
      END

C   18/12/78 C9032101   MEMBER NAME  BFIELD   (JADEGS)      FORTRAN
      SUBROUTINE BFIELD
C---
C---     SETTING MAGNETIC FIELD EQUAL TO 0
C---
#include "cjdrch.for"
#include "cgeo1.for"
      DRIDEV = 0.
      DRICOS = 1.
      DRISIN = 0.
      BKGAUS = 0.
      RETURN
      END

C   03/03/82 203031541  MEMBER NAME  MUDUMP   (JADEMUS)     FORTRAN
C   17/02/82 202171616  MEMBER NAME  ERMUDUMP (S)           FORTRAN
C   03/02/81 104100736  MEMBER NAME  MUDUMP   (JADEMUS)     FORTRAN
      SUBROUTINE MUDUMP(IER,IP)
      IMPLICIT INTEGER*2 (H)
C LAST CHANGE 15.45  03/03/82   HUGH MCCANN  - BUG REMOVED.
C      CHANGE 13.30  22/02/82   HUGH MCCANN  - FOR IMPROVED ERROR OUTPUT
C      CHANGE 07.30  10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C      CHANGE 14.40  12/02/81 HUGH MCCANN.
C   THIS ROUTINE DUMPS THE MUEV BANK, ALONG WITH OTHER INFO ON EVENT.
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C  WRITE HEADER.
      WRITE(6,10)IER,IP
   10 FORMAT('0 ERROR',I3,' AT WORD',I4,
     *'   DUMP OF RAW DATA BANK (MUEV) :')
C
C WRITE OUT MUEV BANK.
C
      IPMU=IDATA(IBLN('MUEV'))
      IF(IPMU.LE.0)GO TO 97
      IP2=2*IPMU
      IPLAST=2*IDATA(IPMU)
      DO 100 I=1,IPLAST,20
      J=I+19
      IF(J.GT.IPLAST)J=IPLAST
  100 WRITE(6,20)I,(HDATA(IP2+K),K=I,J)
   20 FORMAT('0 ',I4,':',20I6)
      RETURN
   97 CONTINUE
      WRITE(6,970)
  970 FORMAT('0 ******** MUEV BANK NOT FOUND ********')
      RETURN
      END

C   13/02/80 711201806  MEMBER NAME  DEDXDS   (S)           FORTRAN
      SUBROUTINE DEDXDS
C--
C--     DEDX DISPLAY FOR JADE, USING DEDX PROGRAM FROM R.EICHLER
C--     13.02.80       LAST CHANGE 14.06.83          J.OLSSON
C--                    LAST CHANGE 17.05.85          J.A.J.SKARD
C--                    LAST CHANGE  9.06.86          J.OLSSON
C--                    LAST CHANGE 20.08.86          J.OLSSON
C--                    LAST CHANGE 13.11.87          E ELSEN
C---
C---   OPTIONS IN COMMAND DEDX
C---     DEDX I, I>0   SINGLE LINE PRINT FOR TRACK I
C---     DEDX 0        SINGLE LINE PRINT FOR EACH TRACK
C---     DEDX -1       CREATE BANK DEDX
C---     DEDX -2       LARGE DEDX VS. MOMENTUM DISPLAY
C---     DEDX -3       NOT USED
C---     DEDX -4       SMALL DEDX VS. MOMENTUM DISPLAY
C---     DEDX -5       LARGE DEDX VS. MOMENTUM DISPLAY, SCALE EXTRALARGE
C---     DEDX -6       CHANGE VARIABLE NHFCUT: MIN. NR OF HITS ON TRACK.
C---                     ALSO VARIABLE PMCUT: MIN. MOMENTUM OF TRACK.
C---
      IMPLICIT INTEGER*2 (H)
      LOGICAL FL18,FL22,FL24
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON/CWORK1/IER,NTR,TRES(10,60)
      DIMENSION ITRES(10,60),HTYP(3,8),HMW(4)
      EQUIVALENCE (TRES(1,1),ITRES(1,1))
      DIMENSION SAV(6)
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      COMMON / CDEDXU / NHFCUT,PMCUT
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      LOGICAL DSPDTM
C     DATA HTYP /'  ','PR','OT','ON','  ','K ','PL','US',
C    $           'PI',' P','LU','S ','PO','SI','TR','ON',
C    $           'A-','PR','OT','ON',' K',' M','IN','US',
C    $           'PI',' M','IN','US','EL','EC','TR','ON'/
      DATA HTYP /'PR','OT','ON','  ',' K',' +',
     $           '  ','PI',' +','  ',' E',' +',
     $           'AN','TI','-P','  ',' K',' -',
     $           '  ','PI',' -','  ',' E',' -'/
      DATA HBLANK /'  '/
C                                           FLAG TO REQUEST DATA FOR
C                                           SINGLE TRACK
      COMMON /CDXSIN/ ISNGTR
C----------------------------------------
      NN = ACMD
C---   CALL DEDX PROGRAM HERE
      IF( NN.GT.0 ) ISNGTR = NN
      NPDEDX = IDATA(IBLN('DEDX'))
C                                           PERFORM DEDX CALC IF
C                                           REQUESTED (NN=-1)
C                                           BANK NOT YET THERE
C                                           OR SINGLE TRACK
      IF( .NOT. ( NN.GT.0 .OR. NN.EQ.-1 .OR. NPDEDX.LE.0 ) )
     *                            GO TO 2213
        CALL DEDXBN
C                                           DO NOT RECREATE BANK
C                                           FOR SINGLE TRACK MODE
        IF( .NOT. ( NN.EQ.-1 .OR. NPDEDX.LE.0 ) ) GO TO 2213
          IPPATR = IDATA(IBLN('PATR'))
          IF(IPPATR.GT.0) GO TO 98
            WRITE(6,97)
97          FORMAT(' ERROR ----->>   PATR BANK DOES NOT EXIST')
            RETURN
98        CALL BDLS( 'DEDX', IDATA(IPPATR-2) )
          CALL DEDXBK(IPPATR)
2213  CONTINUE
C                                           REINSTALL DEDX BANK
      NPDEDX = IDATA(IBLN('DEDX'))
      IF( NPDEDX.GT.0 ) CALL UCOPY(IDATA(NPDEDX+1),IER,IDATA(NPDEDX) )
C
      IF(NN.GE.0) GO TO 99
      IF(NN.EQ.-1) GO TO 91
      IF(NN.EQ.-6) GO TO 121
C SHOW DIAGRAM DEDX VS MOMENTUM
      CALL DEDXVW
      RETURN
91    CONTINUE
      RETURN
C---       CHANGE NHFCUT AND PMCUT    OPTION DEDX -6
121   CONTINUE
      WRITE(6,1211) NHFCUT,PMCUT
1211  FORMAT(' PRESENT VALUES OF NHFCUT AND PMCUT ARE:',I3,F6.3,
     $  ',  ENTER NEW VALUES:')
      CALL TONUM(INT1,FLP1)
      NHFCUT = INT1
      IF(NHFCUT.LT.5.OR.NHFCUT.GT.45) NHFCUT = 15
      PMCUT = FLP1
      IF(PMCUT.LT..02) PMCUT = 0.05
      WRITE(6,995) NHFCUT,PMCUT
995   FORMAT(' NEW VALUES FOR NHFCUT AND PMCUT ARE:',I4,F7.3)
      CALL BMLT( 1, 'DEDX' )
      CALL BDLM
      RETURN
C---
99    CONTINUE
C--   LOOP OVER TRACKS
      IPO = IDATA(IBLN('PATR'))
      LO = IDATA(IPO+1)
C     NTR = IDATA(IPO+2)
      LTR = IDATA(IPO+3)
      IPO = IPO + LO - LTR
      NTRR = MIN0(NTR,60)
      DO 111  ITR = 1,NTRR
      IPO = IPO + LTR
      IF(NN.GT.0.AND.NN.NE.ITR) GO TO 111
      RAD = ADATA(IPO+25)
      HSIGN = 1
      IF(RAD*BKGAUS.LT.0.) HSIGN = -1
      JMIN = ITRES(8,ITR)
      DO 112  I = 1,3
      IF(JMIN.LT.1.OR.JMIN.GT.4) HMW(I) = HBLANK
      IF(JMIN.LT.1.OR.JMIN.GT.4) GO TO 112
      K = JMIN
      IF(HSIGN.LT.0) K = K + 4
      HMW(I) = HTYP(I,K)
112   CONTINUE
      NHT = ITRES(1,ITR)
      DEDX = TRES(2,ITR)
      SIDEDX = TRES(3,ITR)
      SAV(1)=TRES(4,ITR)
      SAV(2)=TRES(5,ITR)
      SAV(3)=TRES(6,ITR)
      SAV(4)=TRES(7,ITR)
      SAV(5)=TRES(9,ITR)
      SAV(6)=TRES(10,ITR)
C
C  IF SINGLE TRACK REQUIRED, DISPLAY DEDX VS RADIUS HISTOGRAM
C
      IF(DSPDTM(19).AND.NN.GT.0.AND.ITRES(1,NN).GT.0)   CALL DEDXV1
C
C---  WRITE DEDX INFORMATION FOR TRACK ITR
C     WRITE(6,1379) ITR,(HMW(I),I=1,3),DEDX,SIDEDX,(TRES(I,ITR),I=4,7)
C    ,, TRES(9,ITR), TRES(10,ITR)
      WRITE(6,1379) ITR,(HMW(I),I=1,3),DEDX,SIDEDX,(SAV(I),I=1,6)
1379  FORMAT(I2,1X,3A2,' DEDX=',F5.2,'+-',F5.2,' CHI(E P K P) ',
     $ 4F6.2,' P',F6.3,'+-',F5.3)
111   CONTINUE
      RETURN
      END

C   11/07/79 412041827  MEMBER NAME  LGANAL0  (SOURCE)      FORTRAN
      SUBROUTINE LGANAL
C
C     S.YAMADA  31-10-78  14:35
C     LAST MODIFICATION    01-08-79  24:00  IZ=0&31 KILLED
C     LAST MODIFICATION    07-01-79  24:00  NEG ENERGY TO 20000
C                                                 Y.WATANABE
C.....THE #WORDS/CLUSTER IS NOW 16..  13/6/80     Y.WATANABE
C     LAST MOD.     04-12-84   18:25    WORK SPACE CLEAR (5200->5520)
C                                                 S.YAMADA
C---- MAIN SUBROUTINE FOR THE 1-ST STEP L-GLASS ANALYSIS.
C---- *******  MODIFIED FOR BOS *******
C
      IMPLICIT INTEGER *2 (H)
C
#include "cdata.for"
C
#include "clgwork1.for"
C---- NCLST = NO.OF THE LOCATED CLUSTERS.
C---- MAPCL(J)=THE INDEX OF THE FIRST MEMBER OF THE J-TH CLUSTER
C               IN THE HLGADC. (THE FIRST 51 WORDS OF CLMPRP)
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX,DZ
C
      COMMON /CLGMSB/ MSGVAL
C
      DATA NMLGCL/'LGCL'/,  LGANVR/1/,  MESS/0/
C
C
C---- FOR THE FIRST CALL PRINT THE LG-CLUSTER FINDING PARAMETERS.
      DATA IINIT/0/
      IF(IINIT.GT.0) GO TO 14
      IINIT=1
      IPLGCL=IBLN(NMLGCL)
14    CONTINUE
C
      IF(MESS) 1001,1000,1001
 1000 CALL LGMESG( 2, 0)
      MESS = 1
C
C
C---- FILL HEADER AND CONSTANTS IN THE GENERAL LG-INF. OF THE EVENT.
 1001 IDENT(1) = LGANVR
      IDENT(2) = IDATTM(DUM)
C
C---- CLEAR CLUSTER RESULTS ARRAY
      CALL SETSL(NCLST,0,5520,0)
C
C---- SET NO.OF WORDS/CLUSTER
      NWPCL = 16
C---- SET THE FLAG OF LG-ANALYSIS STEP-1.
      IFLAG(2) = 1
C
C*******************************************************************
C
C       LEAD GLASS CLUSTER FINDING
C
C     LG-ADC DATA IS MOVED FROM 'ALGN' TO /CWORK/.
      CALL LGDCPY( NP, IFLAG(1))
C
C
C---- CHECK IF THERE IS ANY LG-DATA.
      IF(NP.LE.0) GO TO 5
C---- IF DATA FORMAT ERROR IS FOUND,SKIP ANALYSIS AND MAKE AN EMPTY RES.
C     IFLAG(1)=1,IF NOT CALIBRATED.
C     IFLAG(1)=2,IF NOT ALL DATA ARE COPIED DUE TO THE BUFFER SIZE.
C     IFLAG(1)=1024,IF FORMAT CONVRSION IS NOT DONE.
C
      IF(IFLAG(1).GE.1024) GO TO 5
C
C#####KILL IZ=0&31 RINGS BECAUSE THEY ARE NOT REAL.
      NHIT=LNG-3
      IF(NHIT.LE.0) GO TO 85
      IF(HLGADC(1,1).GE.2688) HPOINT(2)=1
      DO 80 I=1,NHIT
      HPH=HLGADC(2,I)
      IF(HPH.LT.0) HLGADC(2,I)=20000
      IZ=HLGADC(1,I)
      IF(IZ.GT.2687) GO TO 80
      IZ=MOD(IZ,32)
      IF(IZ.EQ.0.OR.IZ.EQ.31) HLGADC(2,I)=0
C          PROTECTION HERE TO CORRECT NEGATIVE ENRGY DUE TO OVERFLOW.
80    CONTINUE
85    CONTINUE
C######
C---- CLUSTER FINDING    (NCLST,NCLBEC(1-3) ARE FILLED. MAP IS MADE.)
      CALL LGCCTL(IFLAG(1))
C
C---- CLUSTER POSITIONS AND ENERGIES ARE CALCULATED FOR THE BARREL AND
C     END CAPS.
      IF(NCLBEC(1)) 2,2,1
    1 CALL LGCLPB
    2 IF(NCLBEC(2)+NCLBEC(3)) 4,4,3
    3 CALL LGCLPC
C
C---- TOTAL ENERGY IS CALCULATED.
    4 ETOT(1) = ETOT(2)+ETOT(3)+ETOT(4)
C
C
C****************************************************************
C---- COPY LG-RESULT INTO A NEW BANK/LGCL/.
C
C---- FIX POINTERS OF THREE PARTS.
    5 NPNT(1) = 5
      NPNT(2) = 26
      NPNT(3) = NCLST+27
      NPNT(4) = NPNT(3)+NWPCL*NCLST
C
      IF(NCLST.EQ.0 .OR. NCLST.EQ. MAXCLS ) GO TO 10
C---- SHIFT DATA TO FILL THE GAP BETWEEN MAPCL AND CLSPRP
      CALL MVCL(CLMPRP(NCLST+2),0,CLMPRP(MAXCLS+2),0, 4*NCLST*NWPCL)
C
   10 LNGCL = NPNT(4)-1
C
C---- CREATE THE LG-CLUST BANK.
      NPLGCL=IDATA(IPLGCL)
      IF(NPLGCL.LT.1) GO TO 12
      MSGVAL = 1
      CALL LGMESG( 2, 3)
      CALL BDLS(NMLGCL,1)
C
12    CALL BCRE(NPLGCL,NMLGCL,1,LNGCL,&91,IER)
      CALL BSAW( 1, NMLGCL)
      IF(IER.EQ.0) GO TO 20
C
C---- BCRE ENDS WITH AN ERROR.
C     THE 'LGCL' EXISTS ALREADY.
      MSGVAL = IER
      CALL LGMESG( 2, 3)
C
C---- COPY
   20 CALL BSTR( NPLGCL, NPNT, LNGCL)
      GO TO 30
C
C---- NOT ENOUGH SPACE IN /BCS/.
   91 IFLAG(1) = IFLAG(1)+100
      MSGVAL = IER
      CALL LGMESG( 2, 2)
C
C---- OVERWRITE 'ALGN'-BANK WITH THE SORTED LG-ADC'S.
   30 IF(NP.GT.0) CALL MVCL(IDATA,4*NP,HNORD,0,4*LNG)
C
  100 RETURN
      END

C   16/06/79 005061141  MEMBER NAME  GNUREC   (JADEGS)      FORTRAN
C   24/11/78 C9032101   MEMBER NAME  GNUREC   (JADEGS)      FORTRAN
         SUBROUTINE GNUREC (NFTN,NEVNT,NUREC)
C---
C---     COUNTS NORMAL EVENTS AND TOTAL RECORDS ON A DATA SET.
C---     MODIFIED BY W.YEN TO HANDLE BOSM FORMAT
C---     IMPLEMENTED 19.06.1979 BY J.OLSSON
C---
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      IPHEAD=IBLN('HEAD')
      NEVNT=0
      NUREC=0
    1 CALL BSLT
      CALL BDLG
      CALL BREAD(NFTN,&3,&2)
      NUREC=NUREC+1
      IF(IDATA(IPHEAD).LT.1) GO TO 1
      NEVNT=NEVNT+1
      GO TO 1
    2 CONTINUE
      REWIND NFTN
      CALL BDLS('+BUF',NFTN)
      RETURN
    3 CALL MESSAG(1)
      GO TO 1
      END

C   14/08/84 408271209  MEMBER NAME  MUPR20   (PWMUS)       FORTRAN
C   26/02/80 004231736  MEMBER NAME  MUPR20   (JADEMUS)     FORTRAN
C   16/02/80 002180915  MEMBER NAME  MUPR20   (JADEMUS1)    FORTRAN
C
C   LAST CHANGE 14/08/84 P.WARMING : OUTPUT COMMENTED
C-----------------------------------------------------------------------
C
      SUBROUTINE MUPR20
C
C
C  THIS ROUTINE PRINTS WORDS 1 AND 2 OF MUR2/0
C
      IMPLICIT INTEGER*2 (H)
#include "cmubcs.for"
C
C  FIND MUR2/0
C
      CALL CLOC(INDEX,'MUR2',0)
      IF(INDEX.LE.0)GO TO 1
      NUMTRK=IDATA(INDEX+1)
      NUMWTR=IDATA(INDEX+2)
      WRITE(6,10)NUMTRK,NUMWTR
   10 FORMAT('0 MUR2/0    NO. OF I.D. TRACKS =',I3,
     *4X,'NO. OF 4-BYTE WORDS PER TRACK IN MUR2/1 =',I3)
      RETURN
    1 CONTINUE
C------MUR2/0 DOES NOT EXIST
      WRITE(6,2)
    2 FORMAT('0',20X,'***** MUR2/0 DOES NOT EXIST. *****')
      RETURN
      END

C   24/11/83 712182117  MEMBER NAME  RDTRIG0  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDTRIG
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    10/05/82 :  TRIGGER SETTING
C
C        MOD  E. ELSEN    11/05/82 :
C        MOD  J. OLSSON   05/08/83 :  DIFFERENT VERSION CHOICE
C        MOD  J. OLSSON   10/08/83 :
C        MOD  C. BOWDERY  23/11/83 :  CADMIN MACRO USED - NFLAGS
C        MOD  C. BOWDERY  08/02/84 :  CADMIN MACRO FROM PATRECSR NOW
C        MOD  C. BOWDERY  17/09/84 :  S/R PRSTAT MOVED TO MEMBER PRSTAT
C        MOD  J. OLSSON 18/07 - 24/08 86:  NEW TRIGGER PERIODS 1983-198600001400
C                                NEW PARAMETERS FOR OLD/NEW TRIGGERS
C        MOD  J. OLSSON   26/07/87 :  Z-RESOLUTION FOR 1986 UPDATED
C        MOD  J. OLSSON   03/12/87 :  ZRS CHANGED WHERE IT IS USED!
C        MOD  E ELSEN     11/12/87 :  R-PHI RESOLUTION (2 GAUSS SCHEME)
C             J.HAGEMANN              FOR ID AND VTXC
C   LAST MOD  J.OLSSON    18/12/87 :  DTRSVV UPDATED (J.HAGEMANN)
C
C    THE TRIGGER PARAMETERS ARE KEPT IN COMMON /CTRIGG/
C    THE INNER DETECTOR STATUS IS KEPT IN COMMON /CRDSTA/
C    THE BLOCK DATA SETTING CORRESPONDS TO 1982 STATUS
C
C    THE CALL TO RDDATE WILL OVERWRITE EVENT DATE IN BANK HEAD
C    (WORDS 6-8) AND THE PROPER VERSION IS CHOSEN ACCORDINGLY.
C    THIS GIVES THE POSSIBILITY TO USE THE CALIBRATION CONSTANTS FOR
C    THE CORRESPONDING PERIOD, AS READ IN BY KALIBR/KLREAD.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1)
      EQUIVALENCE ( HW(1), IW(1) )
C
C                            IHIST GIVES DAY,MONTH,YEAR
C                            FROM THIS DATE, THE CORRESPONDING
C                            DETECTOR STATUS AND TRIGGER
C                            CONDITION IS SELECTED
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10), IPHALG
C
C                            CADMIN CONTAINS NFLAGS(10) AND ELEMENTS 2
C                            AND 3 ARE USED HERE AS FLAGS FOR CURRENT
C                            SMEARING DATE AND 4 AS A PRINTING FLAG.
C
      COMMON / CBIN / TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3),
     +                BINDL8(6),RJITT, DLRSLN(3)
      COMMON / CBINV /  DTRSVV, ZRSVV, EFFVV(2), DOUBVV(3), IRNHVV,
     +                  SMPRMV(3)
C
      COMMON / CJDRCH / DRCH(34),
     +                  PEDES, TZERO(3),
     +                  DRIROT(96,2), SINDRI(96,2), COSDRI(96,2),
     +                  DRIVEL(96,2)
C
C
#include "cadmin.for"
C
      DATA HT1A85 /Z7F07/, HT1A86 /Z7F17/
      DATA HT1P85 /Z7709/, HT1P86 /Z7F09/
C
C------------------  C O D E  ------------------------------------------
C
C                                           SET DATE OF JOB
      CALL RDDATE
C
      NPHEAD = IW(IBLN('HEAD'))
      IF( NPHEAD .GT. 0 ) GO TO 4771
      WRITE(6,4772)
4772  FORMAT(' * * * RDTRIG CALLED FOR HEADLESS EVENT, PROGRAMMED STOP')
      STOP
4771  IHIST(1) = HW(NPHEAD*2+6)
      IHIST(2) = HW(NPHEAD*2+7)
      IHIST(3) = HW(NPHEAD*2+8)
C
      IYEAR = IHIST(3)
      IYEAR = MOD(IYEAR,100)
      IF(NFLAGS(3).EQ.IYEAR) GO TO 8000
      NFLAGS(3) = IYEAR
      IMONTH = IHIST(2)
C
C                                           ****************************
C                                           *  1979 TRIGGER CONDITIONS *
C                                           ****************************
      IF( IYEAR .GT. 79 ) GO TO 1100
C                                           CHANGES
C  COPLANAR NARROW TOF, 2 FAST TRACKS
            HWCOLN = 0
C  TRACK LOGIC
            HITCLL(1) = 12
            HITCLL(2) = 11
            HITCLL(3) = 12
            HITWLL(1) = 1
            HITWLL(2) = 1
            HITWLL(3) = 1
            HITSUM(1) = 12
            HITSUM(2) = 12
            HITSUM(3) = 12
C  DEAD CELLS IN INNER DETECTOR
            HDEADC(1) = 17
            NCDEAD = 1
            HCELLD(1) = 17
C  MIN. TRACK NUMBER IN TOF + TOTAL LG ENERGY TRIGGER
            HACC1 = 1
C  TOTAL LG ENERGY THRESHOLDS
            HLGTOT(1,1) = 4000
            HLGTOT(2,1) = 2000
            HLGTOT(3,1) = 1000
            HLGTOT(4,1) = 500
C  TAGG THRESHOLDS AND ADC CONVERSION CONSTANT
            HLGTL = 4000
            HLGTH = 8000
            TAGADC = 5.5
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 20
            IRN(2) = 20
            IRN(3) = 20
C                                           VERSION FOR THIS PERIOD
      IF( NFLAGS(2) .EQ. 1 ) GO TO 8000
         NFLAGS(2) = 1
         GO TO 7900
C
C                                           ****************************
C                                           *  1980 TRIGGER CONDITIONS *
C                                           *     MONTH 1 - 3          *
C                                           ****************************
 1100 IF( IYEAR .GT. 80 ) GO TO 1300
      IF( IMONTH.GT. 3  ) GO TO 1200
C                                           CHANGES
C  COPLANAR NARROW TOF, 2 FAST TRACKS
            HWCOLN = 0
C  TRACK LOGIC
            HITCLL(1) = 12
            HITCLL(2) = 11
            HITCLL(3) = 12
            HITWLL(1) = 1
            HITWLL(2) = 1
            HITWLL(3) = 1
            HITSUM(1) = 12
            HITSUM(2) = 12
            HITSUM(3) = 12
C  DEAD CELLS IN INNER DETECTOR
            HDEADC(1) = 17
            HDEADC(2) = 37
            NCDEAD = 8
            HCELLD(1) = 17
            HCELLD(2) = 37
            HCELLD(3) = 65
            HCELLD(4) = 66
            HCELLD(5) = 73
            HCELLD(6) = 74
            HCELLD(7) = 81
            HCELLD(8) = 82
C  MIN. TRACK NUMBER IN TOF + TOTAL LG ENERGY TRIGGER
            HACC1 = 1
C  TOTAL LG ENERGY THRESHOLDS
            HLGTOT(1,1) = 4000
            HLGTOT(2,1) = 2000
            HLGTOT(3,1) = 1000
            HLGTOT(4,1) = 500
C  TAGG THRESHOLDS AND ADC CONVERSION CONSTANT
            HLGTL = 4000
            HLGTH = 8000
            TAGADC = 5.5
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 20
            IRN(2) = 20
            IRN(3) = 20
C                                           VERSION FOR THIS PERIOD
      IF( NFLAGS(2) .EQ. 2 ) GO TO 8000
         NFLAGS(2) = 2
         GO TO 7900
C
C                                           ****************************
C                                           *  1980 TRIGGER CONDITIONS *
C                                           *     MONTH 4 - 12         *
C                                           ****************************
 1200 CONTINUE
C                                           CHANGES
C  COPLANAR NARROW TOF, 2 FAST TRACKS
            HWCOLN = 0
C  TRACK LOGIC
            HITCLL(1) = 12
            HITCLL(2) = 11
            HITCLL(3) = 12
            HITWLL(1) = 1
            HITWLL(2) = 1
            HITWLL(3) = 1
            HITSUM(1) = 12
            HITSUM(2) = 12
            HITSUM(3) = 12
C  DEAD CELLS IN INNER DETECTOR
            HDEADC(1) = 17
            HDEADC(2) = 37
            NCDEAD = 6
            HCELLD(1) = 17
            HCELLD(2) = 37
            HCELLD(3) = 65
            HCELLD(4) = 66
            HCELLD(5) = 81
            HCELLD(6) = 82
C  MIN. TRACK NUMBER IN TOF + TOTAL LG ENERGY TRIGGER
            HACC1 = 1
C  TOTAL LG ENERGY THRESHOLDS
            HLGTOT(1,1) = 4000
            HLGTOT(2,1) = 2000
            HLGTOT(3,1) = 1000
            HLGTOT(4,1) = 500
C  TAGG THRESHOLDS AND ADC CONVERSION CONSTANT
            HLGTL = 4000
            HLGTH = 8000
            TAGADC = 5.5
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 20
            IRN(2) = 20
            IRN(3) = 20
C                                           VERSION FOR THIS PERIOD
      IF( NFLAGS(2) .EQ. 3 ) GO TO 8000
         NFLAGS(2) = 3
         GO TO 7900
C
C                                           ****************************
C                                           *  1981 TRIGGER CONDITIONS *
C                                           ****************************
 1300 IF( IYEAR .GT. 81 ) GO TO 1400
C
C  MIN. TRACK NUMBER IN TOF + TOTAL LG ENERGY TRIGGER
            HACC1 = 1
C  MIN. TRACK NR LIMIT FOR TAGG + TOTAL LG ENERGY TRIGGER
            HACC3 = 2
C  MIN. TRACK NR LIMIT FOR NARROW COPLANAR TOF TRIGGER
            HACC4 = 2
C  TOTAL LG ENERGY THRESHOLDS
            HLGTOT(1,1) = 4000
            HLGTOT(2,1) = 2000
            HLGTOT(3,1) = 1000
            HLGTOT(4,1) = 500
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 20
            IRN(2) = 20
            IRN(3) = 20
C
      IF( NFLAGS(2) .EQ. 4 ) GO TO 8000
         NFLAGS(2) = 4
         GO TO 7900
C
C
C                                           ****************************
C                                           *  1982 TRIGGER CONDITIONS *
C                                           ****************************
 1400 IF( IYEAR .GT. 82 ) GO TO 1500
      IF( NFLAGS(2) .EQ. 5 ) GO TO 8000
         NFLAGS(2) = 5
         GO TO 7900
C
C                                      *********************************
C                                      *  1983-84 TRIGGER CONDITIONS   *
C                                      *********************************
 1500 IF( IYEAR .GT. 84 ) GO TO 1600
C                                   CHANGES
C  UPPER LIMIT ON NR OF TOF IN TBG NS TRIGGER
            NTOFC2 = 6
C  UPPER LIMIT ON NR OF TOF IN NARROW COPLANAR TOF TRIGGER
            NTFCLN = 5
C  UPPER LIMIT ON NR OF TOF IN WIDE COPLANAR TOF TRIGGER
            NTFCOL = 4
C  TAGG THRESHOLDS AND ADC CONVERSION CONSTANT,INNER RING FLAG
            HLGTL = 6500
            HLGTH = 9000
            TAGADC = 6.666
            HTGTRG = 1
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 80
            IRN(2) = 80
            IRN(3) = 80
C
      IF( NFLAGS(2) .EQ. 6 ) GO TO 8000
         NFLAGS(2) = 6
         GO TO 7900
C
C                                      *********************************
C                                      *  1985    TRIGGER CONDITIONS   *
C                                      *********************************
 1600 IF( IYEAR .GT. 85) GO TO 1700
C                                   CHANGES
C  T1 ACCEPT AND POSTPONE ENABLE BITS IN HEAD BANK
            HT1ACC = HT1A85
            HT1PSP = HT1P85
            IF(IYEAR.EQ.86) HT1ACC = HT1A86
            IF(IYEAR.EQ.86) HT1PSP = HT1P86
C  UPPER LIMIT OF SEPTANTS IN COPLANAR SEPTANT TRIGGERS
            NRNBSH = 8
C  TAGG THRESHOLDS AND ADC CONVERSION CONSTANT, INNER RING FLAG
            HLGTL = 6500
            HLGTH = 9000
            TAGADC = 6.666
            HTGTRG = 1
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 40
            IRN(2) = 40
            IRN(3) = 40
      IF( NFLAGS(2) .EQ. 7 ) GO TO 8000
         NFLAGS(2) = 7
         GO TO 7900
C
C
C                                      *********************************
C                                      *  1986    TRIGGER CONDITIONS   *
C                                      *         MONTHS 1-6            *
C                                      *********************************
 1700 IF( IYEAR .EQ. 86.AND.IMONTH.GT.6) GO TO 1800
C                                   CHANGES
C  T1 ACCEPT AND POSTPONE ENABLE BITS IN HEAD BANK
            HT1ACC = HT1A86
            HT1PSP = HT1P86
C  UPPER LIMIT OF SEPTANTS IN COPLANAR SEPTANT TRIGGERS
            NRNBSH = 8
C  ECAP QUADRANTS THRESHOLD   (FOR KREHBIEL TRIGGER)
            HLGQT = 140
C  TAGG THRESHOLDS AND ADC CONVERSION CONSTANT, INNER RING FLAG
            HLGTL = 6500
            HLGTH = 9000
            TAGADC = 6.666
            HTGTRG = 1
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 8
            IRN(2) = 6
            IRN(3) = 6
C  DOUBLE HIT RESOLUTION IN THE INNER DETECTOR, FADC IN 1986
            DOUB(1) = 2.0
            DOUB(2) = 2.0
            DOUB(3) = 2.0
C  Z-RESOLUTION FACTOR 2 WORSE FOR 1986
            ZRS = 40.0
       DRCH(28) = 40.0
C  R-PHI RESOLUTION BETTER FOR 1986
            RJITT = .112
            DLRSLN(1) = .9514
            DLRSLN(2) = .0
            DLRSLN(3) = 14.087
C  NR OF RANDOM HITS IN THE VERTEX CHAMBER
            IRNHVV = 9
      IF( NFLAGS(2) .EQ. 8 ) GO TO 8000
         NFLAGS(2) = 8
         GO TO 7900
C                                           ****************************
C                                           *  1986 TRIGGER CONDITIONS *
C                                           *    MONTHS 7-12           *
C                                           ****************************
 1800 CONTINUE
C                                   CHANGES
C  T1 ACCEPT AND POSTPONE ENABLE BITS IN HEAD BANK
            HT1ACC = HT1A86
            HT1PSP = HT1P86
C  UPPER LIMIT OF SEPTANTS IN COPLANAR SEPTANT TRIGGERS
            NRNBSH = 8
C  ECAP QUADRANTS THRESHOLD   (FOR KREHBIEL TRIGGER)
            HLGQT = 140
C  TAGG THRESHOLDS AND ADC CONVERSION CONSTANT
            HLGTL = 4500
            HLGTH = 8750
            TAGADC = 6.666
C  NR OF RANDOM HITS IN THE RINGS OF THE INNER DETECTOR
            IRN(1) = 8
            IRN(2) = 6
            IRN(3) = 6
C  DOUBLE HIT RESOLUTION IN THE INNER DETECTOR, FADC IN 1986
            DOUB(1) = 2.0
            DOUB(2) = 2.0
            DOUB(3) = 2.0
C  Z-RESOLUTION FACTOR 2 WORSE FOR 1986
C  NOTE THAT DRCH(28) IS USED IN SMEARING!
            ZRS = 40.0
       DRCH(28) = 40.0
C  R-PHI RESOLUTION BETTER FOR 1986
            RJITT = .112
            DLRSLN(1) = .9514
            DLRSLN(2) = .0
            DLRSLN(3) = 14.087
C
      IF( NFLAGS(2) .EQ. 9 ) GO TO 8000
         NFLAGS(2) = 9
         GO TO 7900
C
C                                           PRINTOUT OF CONSTANTS
7900  IF(NFLAGS(4).NE.1) GO TO 8000
      WRITE(6,9105)
 9105 FORMAT(/' RDTRIG: VERSION OF DEC 87, COMPILED 10/12/1987'/)
C     CALL PRSTAT
 8000 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      BLOCK DATA
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C
C-----------------------------------------------------------------------
C
C  T1 ACC  1979-1981                      PARAMETERS USED IN SIMULATION
C  *****************                      *****************************
C
C  BIT  1:   LUMI                              HLGTH
C  BIT  2:   TOTAL LG ENERGY                   HLGTOT(1,1)
C  BIT  3:   TAGG * TOTAL LG ENERGY            HLGTL,HLGTOT(2,1)
C
C  T1 POSTPONE 1979-1981                  PARAMETERS USED IN SIMULATION
C  *****************                      *****************************
C
C  BIT  1:   TOF AND TOTAL LG ENERGY           NTOFC,HLGTOT(3,1),HACC1
C  BIT  2:   TAGG                              HLGTL,HACC3
C  BIT 3-4:  NOT USED
C  BIT  5:   COPLANAR TOF, WIDE                NTFCOL,IWCOLL,HACC2
C  BIT  6:   COPLANAR TOF, NARROW       HWCOLN,NTFCLN,IWCOLN,HACC4
C  BIT  7:   COPLANAR TOF, MULTIPRONG   HMPRON,IWMPRG,HFMPRL,HFMPRH
C                                                            HACCM
C
C  T1 ACC  1982-1986                      PARAMETERS USED IN SIMULATION
C  *****************                      *****************************
C
C  BIT  1:   LUMI                              HLGTH
C  BIT  2:   TOTAL LG ENERGY                   HLGTOT(1,1)
C  BIT  3:   TAGG * TOTAL LG ENERGY            HLGTL,HLGTOT(3,1),HTGTRG
C  BIT  4:   NOT SIMULATED (FWMU AND ECAPQ)
C  BIT  5:   SEPTANT AND ECAPQ, NO TOF         HLGBST,HLGQT,NTOFBS
C  BIT 6-8:  NOT USED
C  BIT  9:   ECAP1 * ECAP2                     HECAPT(2)
C  BIT 10:   ECAP1 + ECAP2, LG BARREL ENERGY   HECAPT(3),HLGTOT(4,2)
C  BIT 11:   TAGG ,LG BARREL ENERGY            HLGTL,HLGTOT(4,2),HTGTRG
C  BIT 12:   LG BARREL ENERGY                  HLGTOT(2,2)
C  BIT 13:   ECAP1 * ECAP2 * TOTAL LG ENERGY   HLGTOT(2,1),HECAPT(4)
C  BIT 14:   COLL. SEPTANT, NO TOF    HLGBST,NRNBSL,NRNBSH,NTOFBS,IWIDBS
C  BIT 15:   TAGG, SEPTANT, NO TOF            NTOFBS,HLGBST,HLGTL,HTGTRG
C  BIT 16:   NOT SIMULATED (RANDOM)
C
C
C  T1 POSTPONE 1982-1986                  PARAMETERS USED IN SIMULATION
C  *****************                      *****************************
C
C  BIT  1:   TOF AND TOTAL LG ENERGY           NTOFC,HLGTOT(3,1),HACC1
C  BIT  2:   NOT USED
C  BIT  3:   TOF, ECAP1 + ECAP2                NTOFC1,HECAPT(2),HACC1
C  BIT  4:   TBG NS                           HLGBRT,NTBGC2,NTOFC2,HACC200046800
C  BIT 5-8:  NOT USED   (BIT8 FOR T3 TRIGGER)
C  BIT  9:   TBG, LG BARREL ENERGY             HLGBRT,NTBGC1,HACC3
C  BIT 10:   TBG, TAGG                  HLGBRT,NTBGC1,HACC4,HLGTL,HTGTRG
C  BIT 11:   SEPTANT COLL.,TOF                 HLGBST,HACCB1,NTFBS2
C  BIT 12:   SEPTANT, TAGG, TOF                HLGBST,HACCB2,HTGTRG
C  BIT 13:   COPLANAR TOF, WIDE                IWCOLL,NTFCOL
C  BIT 14:   COPLANAR TOF, NARROW              IWCOLN,NTFCLN,HWCOLN
C  BIT 15:   COPLANAR TBG                      IWCTBG,HLGBRT,
C  BIT 16:   NOT USED
C
C-----------------------------------------------------------------------
C
C   T1ACCEPT AND T1POSTPONE ENABLE   (USED AFTER 1984 ONLY)
C
      DATA HT1ACC/0/, HT1PSP/0/
C
C DATE OF VERSION
C
      DATA IHIST /1,7,1982/
C
C NBPTFW = WIDTH OF BP-TOF MATRIX; OBSOLETE, NEVER USED IN TRIGGER
C
      DATA NBPTFW / 6 /
C
C DUMMY SPARE VARIABLES
C
      DATA IDUM1 /4*-1/, HDUM1/-1/, HDUM6/-1/
      DATA IDUM2 /10*-1/, HDUM2/9*-1/
      DATA IDUM3 /9*-1/, IDUM4/8*-1/
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     ****   THRESHOLDS FOR LATCHES ****
C
C     BARREL GROUPS,       BARREL SEPTANCES, ENDCAP QUADRANTS
      DATA HLGBRT/ 80/,       HLGBST/180/,       HLGQT/50/
C                   TOTAL ENERGY                    BARREL ENERGY
      DATA HLGTOT/ 6000,2500,2000,1500,       6000,2500,2000,1500/
C                   ENDCAP ENERGY
      DATA HECAPT/ 4000,1000, 500, 300/
C                   TAGGING ENERGIES
      DATA HLGTL/ 4000/,    HLGTH /8000/
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C                 ADC-MEV CONVERSION CONSTANT FOR TAGGING
      DATA TAGADC /10.00/
C                 FLAG FOR THE USE OF INNER RING OF TAGGING IN TRIGGER
      DATA HTGTRG /0/
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     ****   DATA FOR T1 ACCEPT  ****
C
C           NEUTRAL COPLANAR SEPTANT TRIGGER  (OLSSON 1)
C        NRNBSL, NRNBSH   IS LOWER AND UPPER LIMIT ON NR OF SEPTANTS
C        IWIDBS           WIDTH OF COPLANARITY IN SEPTANTS
C        NTOFBS           IS LIMIT ON NR OF TOF COUNTER VETO
      DATA NRNBSL/2/,  NRNBSH/3/, IWIDBS/3/, NTOFBS/1/
C--
C           NEUTRAL SEPTANT + ECAP QUADRANT (KREHBIEL)
C
C
C

C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     ****   DATA FOR T1 POSTPONE  ****
C
C                                WIDE COPLANAR TOF TRIGGER
C   IWCOLL      WIDTH OF TOF COPLANARITY
C   NTFCOL      NR OF TOF COUNTER LIMIT
      DATA IWCOLL/3/, NTFCOL/5/
C                                NARROW COPLANAR TOF TRIGGER
C   HWCOLN=1    TRIGGER IS ACTIVE
C   IWCOLN      WIDTH OF TOF COPLANARITY
C   NTFCLN      NR OF TOF COUNTER LIMIT
      DATA IWCOLN/1/, NTFCLN/7/, HWCOLN/1/
C           MULTIPRONG TRIGGER              HMPRON=1 --> TRIGGER ACTIV
      DATA IWMPRG/6/, HFMPRL/3/, HFMPRH/6/, HMPRON/0/
C           COPLANAR TBG TRIGGER
      DATA IWCTBG/2/
C           LIMITS FOR NR OF TOFS IN POSTPONE TRIGGERS
C           NTOFC  =  LIMIT FOR NTOF IN TOTAL ENERGY TRIGGER
C           NTOFC1 =  LIMIT FOR NTOF IN ENDCAP TOTAL ENERGY TRIGGER
C           NTOFC2 =  LIMIT FOR NTOF IN TBG-NS TRIGGER
C           NTFBS2 =  LIMIT FOR NTOF IN COLL.SEPTANT + TOF
      DATA NTOFC/2/,NTOFC1/2/, NTOFC2/7/, NTFBS2/6/
C           LIMITS FOR NR OF TBGS IN POSTPONE TRIGGERS
C           NTBGC  =  LIMIT FOR NTBG IN TAG TRIGGERS
C           NTBGC1 =  LIMIT FOR NTBG IN BARREL ENERGY TRIGGER
C           NTBGC2 =  LIMIT FOR NTBG IN NRTOFBG-NS TRIGGER
      DATA NTBGC/0/,NTBGC1/0/, NTBGC2/2/
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     ****    T2 DATA    ****
C
      DATA HITCLL/8,7,8/,  HITWLL/2,2,2/  ,HITSUM/10,9,10/
      DATA HCHAMB/24,24,48/,  HMASK/16*1,16*1,16*1/,HDEADC/10*0/
C
C  HACC1: TRACK NR LIMIT FOR TOF+TOTAL LG ENERGY
C         TRACK NR LIMIT FOR TOF+SUM ECAP
C  HACC2: TRACK NR LIMIT FOR WIDE COPLANAR TOF, 1979-1981
C  HACC2: TRACK NR LIMIT FOR TBGNS, 1982-...
C  HACC3: TRACK NR LIMIT FOR TAGG, 1979-1981
C  HACC3: TRACK NR LIMIT FOR TBG + BARREL ENERGY, 1982-...
C  HACC4: TRACK NR LIMIT FOR NARROW COPLANAR TOF, 1981..
C  HACC4: TRACK NR LIMIT FOR TAGG + TBG, 1982-...
C  HACCM: TRACK NR LIMIT FOR COPLANAR TOF MULTIPRONG
C  HACCB1:  TRACK NR LIMIT FOR COLL.SEPTANT + TOF
C  HACCB2:  TRACK NR LIMIT FOR TAGG+SEPTANT+TOF
      DATA HACC1/2/,  HACC2/2/,  HACC3/1/, HACC4/1/, HACCM/3/
      DATA HACCB1/1/,  HACCB2/1/
C   IWIDT2 GIVES WIDTH OF T2 COPLANARITY
      DATA IWIDT2 /4/
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10), IPHALG
C
C     WIRE DISABLE SECTION FOR JETC BANK
C     ==================================
C                                           DEAD WIRES
      DATA NDEAD / 0 /
      DATA HITD / 10*0 /
C                                           DEAD CELLS
      DATA NCDEAD / 0 /
      DATA HCELLD / 10*0 /
C
C                   LEAD GLASS BLOCK READOUT FLAG
      DATA IPHALG / 1 /
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
      COMMON /CFPLA/ HFT(12,4),HR1(12,4),HR2(12,4)
C
C  FPLA LOGIC FOR ONE STREET
C
      DATA HR2/3*5,4*6,5*7, 2*5,6,7*7,8,9, 3*9,4*8,5*7, 5*7,2*8,4*9,1/
      DATA HR1/10,11,12,10,11,12,13,11,12,13,14,15,
     *         11,12,11,10,11,12,13,14,15,16,15,15,
     *         16,15,14,16,15,14,13,15,14,13,12,11,
     *         11,12,13,14,15,13,15,13,14,15,16, 1/
      DATA HFT/0,1,1,0,7*1,0, 5*0,3*1,4*0, 0,1,1,0,7*1,0, 2*0,8*1,2*0/
C
      COMMON /CMASK/ MASK(16),MASK4,MASK3,MASK2,MASK1,HKRE(3,8)
      DATA MASK/Z1,Z2,Z4,Z8,Z10,Z20,Z40,Z80,Z100,Z200,Z400,Z800,
     *                 Z1000,Z2000,Z4000,Z8000/
      DATA MASK2/Z20000/, MASK1/Z10000/
      DATA MASK4/Z40000/, MASK3/Z30000/
C  CORRELATIONS FOR ECAP QUADRANT - SEPTANT  COLLINEARITY
      DATA HKRE /5,6,0,   1,6,7,   1,2,3,   3,4,5,
     $           5,6,0,   1,6,7,   1,2,3,   3,4,5/
C
C------ THIS PART WAS PREVIOUSLY CONTAINED IN RDMTCO -------------------
C
      COMMON / CBIN / TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3),
     +                BINDL8(6),RJITT, DLRSLN(3)
C
C      TIME     BIN WIDTH FOR DRIFT TIME IN MM
C               WIRES ARE PUT TOGETHER IN GROUPS OF 8
C      ZOF      OFFSET IN Z  DIRECTION IN MM FOR AMPLITUDE CALCULATION
C      ZRS      STANDARD DEV FOR Z RESOLUTION IN MM
C      ZL       EFFECTIVE WIRE LENGTH IN MM
C      ZSC      SCALING FACTOR FOR Z AMPLITUDES
C      EPSI     EFFICIENCY IN EACH RING
C      DOUB     DOUBLE TRACK RESOLUTION IN MM IN EACH RING
C      IRN      NO OF RANDOM HITS INSERTED IN EACH RING
C---------- BINDL8 AND RJITT ARE USED IN NEW RDRESO FOR SMEARING
C      BINDL8   BIN WIDTH FOR DRIFT TIME IN MM
C      RJITT +  NEW STANDARD SMEARING OF DRIFT COORDINATE
C      DLRSLN     (J S VALUES )
C
      DATA TIME / 6*0.380/
      DATA RJITT / .170 /
      DATA DLRSLN / .95683, 5.9568, 10.293 /
      DATA ZOF, ZRS, ZL, ZSC / -10., 20., 2687., 1. /
      DATA EPSI / 3*0.98/
      DATA DOUB / 3*7.5 /
C   RANDOM HITS ACCORDING TO GOOD BEAM CONDITIONS OF 1982
C   THIS IS UPDATED IN RDTRIG FOR OTHER PERIODS
      DATA IRN  / 15, 15, 15 /
C
      DATA BINDL8 / 6*0.380/
C
C     CBINV HAS TO BE USED TO CHANGE THE ACTUAL
C     CONSTANTS OF THE VERTEX CHAMBER
C
      COMMON / CBINV /  DTRSVV, ZRSVV, EFFVV(2), DOUBVV(3), IRNHVV,
     +                  SMPRMV(3)
C
C      DTRSVV      DRIFT TIME RESOLUTION OF VERTEX CHAMBER (MM)
C      ZRSVV       STANDARD DEVIATION FOR Z RESOLUTION (MM)
C      EFFVV(1)    EFFICIENCY PARAMETERS
C      EFFVV(2)       (SEE MEMBER RDIEFV)
C      DOUBVV(1)   SLOPE OF DOUBLE HIT RESOLUTION DISTRIBUTION
C      DOUBVV(2)   LOW CUT    (IN MICRONS)  (SEE MEMBER RDDOUV)
C      DOUBVV(3)   HIGH CUT   (IN MICRONS)
C      IRNHVV      NO OF RANDOM HITS INSERTED
C      SMPRMV(1)   FRACTION OF SMALLER NORMAL DISTRIBUTION
C      SMPRMV(2)   SHIFT OF WIDER NORMAL DISTRIBUTION
C      SMPRMV(3)   WIDTH OF WIDER NORMAL DISTRIBUTION
C                  DTRSVV CHANGED TO .130  18.12.1987   J.O.
C     DATA DTRSVV   / 0.150 /
      DATA DTRSVV   / 0.130 /
      DATA ZRSVV    / 20.0 /
      DATA EFFVV    / .995, .091 /
      DATA DOUBVV   / 0.583, 1.484, 4.2 /
C          RANDOM HITS ACCORDING TO BEAM CONDITIONS OF 1985 (44.2 GEV)
      DATA IRNHVV   / 33 /
      DATA SMPRMV   / 0.400, 0.0, 2.0 /
C
      END

C   15/02/84 402161942  MEMBER NAME  DRTHCV   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRTHCV( FRAC1 , LARGE , SMALL )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON    05/05/80 :  DRAW THEORETICAL DEDX CURVES
C
C   LAST MOD: C. BOWDERY   15/02/84 :  MOVE CODE TO THIS SUBROUTINE
C                                   :  ADD LABELS TO CURVES
C
C
C     DRAW "THEORETICAL" DE/DX CURVES FROM A. WAGNER
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  SMALL, LARGE, DSPDTM
C
      COMMON / CGRAP2 / BCMD, DSPDTM(30)
C
      DIMENSION  ARMAS(4) , HLABEL(4)
C
      DATA ARMAS / 0.000511, 0.139567, 0.49367, 0.93828 /
C
C                            LOWER CASE 'E', BLANK, K, LOWER CASE P
C
      DATA HLABEL / 'e ', '  ', 'K ', 'p ' /
C
C------------------  C O D E  ------------------------------------------
C
      DMINAW = 7.2
      IF( BCMD .GT. 4.0 ) DMINAW = BCMD
C
       DO  1  IMS = 1,4
         FMASS  = ARMAS(IMS)
         FMASS2 = FMASS**2
         PX     = 0.0
         IMMM   = 0
         PADD   = 0.002
         DO 2  IMM = 1,1500
          IF( IMM .EQ.  500 ) PADD = 0.02
          IF( IMM .EQ. 1000 ) PADD = 0.2
          PX = PX + PADD
          IF( PX .GT. 100 .OR. PX .LT. 0.05 ) GO TO 2
          PP = PX
          PP = ALOG10(PP)
          PP = FRAC1 + (1.0 + PP)*15.0
C
C                            CALCULATE BETA AND GAMMA FOR
C                            INPUT TO A. WAGNERS FUNCTION
C
          EAW    = SQRT(PX**2 + FMASS2)
          BETAW  = PX / EAW
          GAMMAW = EAW / FMASS
          DD     = THDEDX( BETAW, GAMMAW, DMINAW )
C
          IF(.NOT. LARGE .AND. (DD .GT. 25 .OR. DD .LT. 0.0 )) GO TO 2
          IF(LARGE .AND. (DD .GT. 200 .OR. DD .LT. 0.0 ))      GO TO 2
          IMMM = IMMM + 1
C
          DDSC = DD
          IF( LARGE ) DDSC = DD * 0.125
C
C                            FIRST TIME, MOVE TO STARTING POINT
C

          IF( IMMM .NE. 1) GO TO 3
            CALL MOVEA(PP,DDSC)
            XLABEL = PP
            YLABEL = DDSC
            GO TO 2
C
C                            DRAW DASHED LINE FOR ELECTRON CURVE
C                            DRAW NORMAL LINE FOR PI,K,P
C
  3       IF( IMS .EQ. 1 ) GO TO 4
            CALL DRAWA(PP,DDSC)
            GO TO 2
C
  4         CALL DASHA(PP,DDSC,14)
C
  2     CONTINUE
C
C                            DRAW LABEL FOR CURVE
C
        IF( SMALL ) GO TO 1
        XLABEL = XLABEL - 1.0
        YLABEL = YLABEL + 1.2
        IF( IMS .EQ. 1 ) YLABEL = YLABEL - 1.7
        IF( IMS .EQ. 3 .AND. LARGE ) YLABEL = YLABEL - 0.7
C
        IF( IMS .EQ. 2 ) GO TO 5
          CALL MOVEA( XLABEL, YLABEL )
          CALL EOUTST( 1, HLABEL(IMS) )
          GO TO 1
C
  5     IF( LARGE ) XLABEL = XLABEL - 0.5
        CALL DRAWPI( XLABEL , YLABEL + 0.3 )
C
  1   CONTINUE
C
      RETURN
      END

C   19/11/84 707261808  MEMBER NAME  PRTPTR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE  PRTPTR( IBANK, JUN1, JUN2, JUN3, JUN4, JUN5 )
C-----------------------------------------------------------------------
C
C   AUTHOR:    C. BOWDERY    20/11/84 : PRINTS OUT TPTR BANK 'IBANK'
C
C LAST MOD:    C. BOWDERY     2/10/86 : UNIT NUMBERS ARE PARAMETERS
C
C      INPUT:     IBANK  = BOS NUMBER OF TPTR BANK TO BE PRINTED
C                          IF IBANK = 0, IT PRINTS ALL TPTR BANKS
C                 JUN1   = LOGICAL UNIT NUMBER FOR OUTPUT STREAM 1
C                 JUN2   = LOGICAL UNIT NUMBER FOR OUTPUT STREAM 2
C                 JUN3   = LOGICAL UNIT NUMBER FOR OUTPUT STREAM 3
C                 JUN4   = LOGICAL UNIT NUMBER FOR OUTPUT STREAM 4
C                 JUN5   = LOGICAL UNIT NUMBER FOR OUTPUT STREAM 5
C
C     I M P O R T A N T :   ROUTINE USES  5  OUTPUT STREAMS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2  (H)
C
#include "cdata.for"
C
      INTEGER  IARR(100)
C
C------------------  C O D E  ------------------------------------------
C
      LUN1 = JUN1
      LUN2 = JUN2
      LUN3 = JUN3
      LUN4 = JUN4
      LUN5 = JUN5
C
      IF( JUN1 .LT. 1  .OR.  JUN1 .GT. 99 ) LUN1 = 6
      IF( JUN2 .LT. 1  .OR.  JUN2 .GT. 99 ) LUN2 = 6
      IF( JUN3 .LT. 1  .OR.  JUN3 .GT. 99 ) LUN3 = 6
      IF( JUN4 .LT. 1  .OR.  JUN4 .GT. 99 ) LUN4 = 6
      IF( JUN5 .LT. 1  .OR.  JUN5 .GT. 99 ) LUN5 = 6
C
C                            IBANK = 0  MEANS PRINT ALL BANKS
C
      IF( IBANK .GT. 0 ) GO TO 4
        CALL BDAR( 'TPTR', NBKS, IARR, 100 )
        IF( NBKS .GT. 0 ) GO TO 2
C
          WRITE(LUN1,1)
          WRITE(LUN2,1)
          WRITE(LUN3,1)
          WRITE(LUN4,1)
          WRITE(LUN5,1)
   1      FORMAT(/' ***  NO TPTR BANKS EXIST TO BE PRINTED '/)
          RETURN
C
   2    IBK = 1
        ITPTRN = IARR( IBK )
        WRITE(LUN1,3) NBKS
        WRITE(LUN2,3) NBKS
        WRITE(LUN3,3) NBKS
        WRITE(LUN4,3) NBKS
        WRITE(LUN5,3) NBKS
   3    FORMAT(//' ***  ',I3,' TPTR  BANKS FOLLOW:'//)
        GO TO 8
C
C                            IBANK > 0 MEANS PRINT TPTR/IBANK
C
   4  IBK = IBANK
      CALL CLOC( ITPTRN, 'TPTR', IBK )
C
      IF( ITPTRN .GT. 0 ) GO TO 6
        WRITE(LUN1,5) IBK
        WRITE(LUN2,5) IBK
        WRITE(LUN3,5) IBK
        WRITE(LUN4,5) IBK
        WRITE(LUN5,5) IBK
   5    FORMAT(/' ***  WARNING  ***  PRTPTR FOUND NO TPTR/',I2,' BANK'/)
        RETURN
C
   6  WRITE(LUN1,7) IBK
      WRITE(LUN2,7) IBK
      WRITE(LUN3,7) IBK
      WRITE(LUN4,7) IBK
      WRITE(LUN5,7) IBK
   7  FORMAT(//' ***  TPTR  BANK ',I3,' FOLLOWS:'//)
C
C                           PRINT A TPTR BANK
C
   8  ITPTR2 = ITPTRN * 2
C
      NUMBK  = IDATA( ITPTRN -  2 )
      LENGTH = IDATA( ITPTRN      )
C
      IVTX   = HDATA( ITPTR2 +  1 )
      IVTX2  = HDATA( ITPTR2 +  2 )
      IFLAG  = HDATA( ITPTR2 +  3 )
      ITRKN  = HDATA( ITPTR2 +  4 )
C
      NLGCL  = HDATA( ITPTR2 +  5 )
      LGCL1  = HDATA( ITPTR2 +  6 )
      LGCL2  = HDATA( ITPTR2 +  7 )
C
      NMUCL  = HDATA( ITPTR2 +  8 )
      MUCL1  = HDATA( ITPTR2 +  9 )
      MUCL2  = HDATA( ITPTR2 + 10 )
      MUCL3  = HDATA( ITPTR2 + 11 )
      MUCL4  = HDATA( ITPTR2 + 12 )
C
      IFWCL  = HDATA( ITPTR2 + 13 )
      ISPR1  = HDATA( ITPTR2 + 14 )
      ISPR2  = HDATA( ITPTR2 + 15 )
      ISPR3  = HDATA( ITPTR2 + 16 )
C
      ITSTO  = HDATA( ITPTR2 + 17 )
      IOTFL  = HDATA( ITPTR2 + 18 )
C
      X0     = ADATA( ITPTRN + 10 )
      Y0     = ADATA( ITPTRN + 11 )
      Z0     = ADATA( ITPTRN + 12 )
      SIGX0  = ADATA( ITPTRN + 13 )
      SIGY0  = ADATA( ITPTRN + 14 )
      SIGZ0  = ADATA( ITPTRN + 15 )
C
      DIS    = ADATA( ITPTRN + 16 )
      DRSR   = ADATA( ITPTRN + 17 )
      DZSZ   = ADATA( ITPTRN + 18 )
      CHISR  = ADATA( ITPTRN + 19 )
      IDOFR  = IDATA( ITPTRN + 20 )
      CHISZ  = ADATA( ITPTRN + 21 )
      IDOFZ  = IDATA( ITPTRN + 22 )
C
      CHARG  = ADATA( ITPTRN + 23 )
      P      = ADATA( ITPTRN + 24 )
      SIGP   = ADATA( ITPTRN + 25 )
      ITSTD  = IDATA( ITPTRN + 26 )
C
      DX     = ADATA( ITPTRN + 27 )
      DY     = ADATA( ITPTRN + 28 )
      DZ     = ADATA( ITPTRN + 29 )
      SIGDX  = ADATA( ITPTRN + 30 )
      SIGDY  = ADATA( ITPTRN + 31 )
      SIGDZ  = ADATA( ITPTRN + 32 )
      SPARE1 = ADATA( ITPTRN + 33 )
C
      INMAS  = HDATA( ITPTR2 + 67 )
      ITYPE  = HDATA( ITPTR2 + 68 )
C
      AMASS  = ADATA( ITPTRN + 35 )
      ETOT   = ADATA( ITPTRN + 36 )
      ESH    = ADATA( ITPTRN + 37 )
      SIGESH = ADATA( ITPTRN + 38 )
C
      IQSH   = HDATA( ITPTR2 + 77 )
      ICLAS  = HDATA( ITPTR2 + 78 )
C
      CHISD1 = ADATA( ITPTRN + 40 )
C                                               SHORT BANK, LENGTH = 40
      IF( LENGTH .EQ. 40 ) GO TO 10
C
      CHISD2 = ADATA( ITPTRN + 41 )
      SPARE2 = ADATA( ITPTRN + 42 )
      NMUHIT = HDATA( ITPTR2 + 85 )
      IACCFL = HDATA( ITPTR2 + 86 )
      MUQUAL = HDATA( ITPTR2 + 87 )
C
      MUSP1  = HDATA( ITPTR2 + 88 )
      MUSP2  = HDATA( ITPTR2 + 89 )
      MUSP3  = HDATA( ITPTR2 + 90 )
      MUSP4  = HDATA( ITPTR2 + 91 )
C
      MUSP5  = HDATA( ITPTR2 + 92 )
      MUSP6  = HDATA( ITPTR2 + 93 )
      MUSP7  = HDATA( ITPTR2 + 94 )
      MUSP8  = HDATA( ITPTR2 + 95 )
      MUCUTS = HDATA( ITPTR2 + 96 )
C
      AMULEN = ADATA( ITPTRN + 49 )
      ABSMM  = ADATA( ITPTRN + 50 )
C
      IF( LENGTH .EQ. 50 ) GO TO 10
C
      ABSG   = ADATA( ITPTRN + 51 )
      ELOSS  = ADATA( ITPTRN + 52 )
      ABSPI  = ADATA( ITPTRN + 53 )
C
      ELOSSP = ADATA( ITPTRN + 54 )
      PROBMU = ADATA( ITPTRN + 55 )
      PROBPI = ADATA( ITPTRN + 56 )
      SPARE3 = ADATA( ITPTRN + 57 )
C
      IQTOF  = IDATA( ITPTRN + 58 )
      TOF    = ADATA( ITPTRN + 59 )
      PLEN   = ADATA( ITPTRN + 60 )
      BETA   = ADATA( ITPTRN + 61 )
      SIGB   = ADATA( ITPTRN + 62 )
C
      TOFMAS = ADATA( ITPTRN + 63 )
      SIGMAS = ADATA( ITPTRN + 64 )
      CHISP1 = ADATA( ITPTRN + 65 )
      CHISK1 = ADATA( ITPTRN + 66 )
      CHISM1 = ADATA( ITPTRN + 67 )
      CHISE1 = ADATA( ITPTRN + 68 )
C
      DEDXTF = ADATA( ITPTRN + 69 )
      SPARE4 = ADATA( ITPTRN + 70 )
      SPARE5 = ADATA( ITPTRN + 71 )
C
      IQDEDX = IDATA( ITPTRN + 72 )
      DEDX   = ADATA( ITPTRN + 73 )
      SIGDE  = ADATA( ITPTRN + 74 )
      CHISP2 = ADATA( ITPTRN + 75 )
      CHISK2 = ADATA( ITPTRN + 76 )
      CHISM2 = ADATA( ITPTRN + 77 )
      CHISE2 = ADATA( ITPTRN + 78 )
C
      NTYPE2 = IDATA( ITPTRN + 79 )
      ISPR4  = IDATA( ITPTRN + 80 )
C
  10  WRITE(LUN1,17) NUMBK, LENGTH, IVTX, IVTX2, IFLAG,
     +               ITRKN, NLGCL, LGCL1, LGCL2, NMUCL,
     +               MUCL1, MUCL2, MUCL3, MUCL4, IFWCL,
     +               ISPR1, ISPR2, ISPR3, ITSTO, IOTFL,
     +               X0,    Y0,    Z0,    SIGX0, SIGY0,
     +               SIGZ0, DIS,   DRSR
C
      WRITE(LUN2,19) DZSZ , CHISR, IDOFR, CHISZ, IDOFZ,
     +               CHARG, P,     SIGP,  ITSTD, DX,
     +               DY,    DZ,    SIGDX, SIGDY, SIGDZ,
     +               SPARE1,INMAS, ITYPE, AMASS, ETOT
C
C                            PRINTOUT DEPENDS ON LENGTH OF BANK
C
      IF( LENGTH .GT. 40 ) GO TO 12
        WRITE(LUN3,21) ESH, SIGESH, IQSH, ICLAS, CHISD1
        WRITE(LUN4,23)
        WRITE(LUN5,25)
        GO TO 30
C
  12  IF( LENGTH .GT. 50 ) GO TO 14
        WRITE(LUN3,21) ESH,   SIGESH,IQSH,  ICLAS, CHISD1,
     +                 CHISD2,SPARE2,NMUHIT,IACCFL,MUQUAL,
     +                 MUSP1, MUSP2, MUSP3, MUSP4, MUSP5,
     +                 MUSP6, MUSP7, MUSP8, MUCUTS,AMULEN,
     +                 ABSMM
        WRITE(LUN4,23)
        WRITE(LUN5,25)
        GO TO 30
C
  14  WRITE(LUN3,21) ESH,   SIGESH, IQSH, ICLAS, CHISD1,
     +               CHISD2,SPARE2,NMUHIT,IACCFL,MUQUAL,
     +               MUSP1, MUSP2, MUSP3, MUSP4, MUSP5,
     +               MUSP6, MUSP7, MUSP8, MUCUTS,AMULEN,
     +               ABSMM, ABSG,  ELOSS, ABSPI, ELOSSP,
     +               PROBMU
C
      WRITE(LUN4,23) PROBPI,SPARE3,IQTOF, TOF,   PLEN,
     +               BETA,  SIGB,  TOFMAS,SIGMAS,CHISP1,
     +               CHISK1,CHISM1,CHISE1,DEDXTF,SPARE4,
     +               SPARE5
      WRITE(LUN5,25) IQDEDX,DEDX,  SIGDE, CHISP2,CHISK2,
     +               CHISM2,CHISE2,NTYPE2,ISPR4
C
  17  FORMAT(1X,I3,2X,I2,2X,2I3,I5,4I3,2X,5I2,2X,I3,3I2,2I3,8F8.2)
  19  FORMAT(1X,2F8.2,I3,F8.2,I3,F6.1,2F8.2,I3,6F8.2,F4.1,2I3,2F8.2)
  21  FORMAT(1X,2F8.2,2I3,2F8.2,F4.1,I4,I2,I4,2X,8I2,1X,I3,7F8.2)
  23  FORMAT(1X,F8.2,F4.1,I3,F6.1,F8.2,F7.3,8F8.2,2F4.1)
  25  FORMAT(1X,I4,6F8.2,2I3)
C
  30  IF( IBANK .GT.    0 ) RETURN
      IF( IBK   .GE. NBKS ) RETURN
      IBK = IBK + 1
      ITPTRN = IARR( IBK )
      GO TO 8
C
      END

C   06/03/79 507081844  MEMBER NAME  TOINT    (S)           FORTRAN
      SUBROUTINE TOINT(I1,I2)
C
C     REVISED VERSION OF TONUM, TO GET TWO INTEGERS FROM SCREEN, SEPA-
C     RATED BY BLANK OR KOMMA.
C
      LOGICAL*1 BLANK,KOMMA,MINUS,TNN,ZW
      COMMON /CWORK1/ TNN(20)
      DATA BLANK/' '/
      DATA KOMMA/','/
      DATA MINUS/'-'/
C
      I1 = 0
      I2 = 0
   10 CONTINUE
      CALL TRMIN(20,TNN)
C                                       GET INTEGER NUMBER 1
      INT = 0
      NUM1 = 0
      ISGN = 1
      DO 20 I=1,20
        MKI = I
        ZW = TNN(I)
        IF(ZW.EQ.BLANK.OR.ZW.EQ.KOMMA) GOTO 30
        IF(ZW.NE.MINUS) GOTO 32
        ISGN = -1
        GOTO 20
 32     IF(ZW.LT.240 .OR. ZW.GT.249) GOTO 60
        NUM1 = NUM1 + 1
        INTD = ZW-240
        INT = 10*INT + INTD
   20 CONTINUE
C                                       CHECK IF MORE THAN 1 NUMBER
   30 I1 = ISGN*INT
      IF(MKI .GT.10) GOTO 60
      IF(NUM1.EQ.0) GOTO 70
C                                       GET INTEGER NUMBER 2
      ISGN=1
      INT = 0.
      DO 40 I=MKI,20
        ZW = TNN(I)
        IF(ZW.EQ.BLANK.OR.ZW.EQ.KOMMA) GOTO 40
        IF(ZW.NE.MINUS) GOTO 34
        ISGN = -1
        GOTO 40
   34   IF(ZW.LT.240 .OR. ZW.GT.249) GOTO 60
        INTD=ZW-240
        INT = 10*INT + INTD
   40 CONTINUE
C
      I2 = ISGN * INT
      GOTO 70
C
   60 CALL TRMOUT(80,'ILLEGAL CHARACTER. TRY AGAIN. STRING WAS:^')
      CALL TRMOUT(20,TNN)
      GOTO 10
   70 CONTINUE
      RETURN
      END

C   12/03/84 412051642  MEMBER NAME  TAGADC   (S)           FORTRAN
C
C
C
C
C---   N O T E  :   THIS MEMBER INCLUDES  BLOCK DATA   T A G D A T
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C   THIS SUBROUTINE TAKES THE DATA FROM HDATA BLOCK
C   'ATAG' AND PUTS THE ADC CONTENTS IN THE ARRAY CATAG
C                        IN ORDER OF ADC ADDRESS
C
C   NOTE:- IT ALSO MULTIPLIES CHANNEL NUMBER TIMES A FACTOR TO MAKE IT
C   APPROXIMATELY EQUAL TO ENERGY IN MEV
C
C  A.J.FINCH 10/12/92
C       MOD. :  JOHN NYE 29/05/84   TEST FOR INVALID MARK * TIDY-UP
C  LAST MOD. :  JOHN NYE 20/07/84   CHANGED ERROR HANDLING
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TAGADC(IWRITE,*)
C
C    IWRITE IS A FLAG TO TELL WHETHER TO PRINT THE BANK 'CATAG' AFTER
C    IT HAS BEEN FILLED.
C
       IMPLICIT INTEGER*2 (H)
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
       LOGICAL NOMSG / .FALSE. /
       LOGICAL LERROR  / .FALSE. /
       DIMENSION CALIB(2)
       DATA CALIB / 10.0 , 6.66667 /
       DATA ICOUNT / 0 /
C
C
C------------------------- C O D E -------------------------------------
C
C
C---                                     INITIALISATION
C
C
       IF ( NDDINN .NE. 0 ) NOMSG = .TRUE.
C
       CALL BLOC(IND,'ATAG',0,*1000)
       NW    = IDATA(IND)
       IHIND = IND + IND
       IHSTA = IHIND + 7
       IHSTO = IHIND + NW + NW - 1
C
C---                                     CLEAR THE CATAG ARRAY
C
       DO 10 I =1,64
   10     CATAG(I)= 0.0
C
C---                                     TEST FOR ILLEGAL MARK
C---                                     OR TAGMRK NOT CALLED
C
       IF ( (MARK .LT. 0) .OR. (MARK .GT. 2) ) CALL TAGMRK(*1000)
       IF ( IFLMRK .NE. -1 ) CALL TAGMRK(*1000)
C
C---                                     CHECK FOR RAW DATA
C
       IHRAW = IHIND + 3
       ILOOK = HDATA(IHRAW)
       IF ( ILOOK .LT. 0 ) GOTO 1100
C
C---                                     LOOP OVER ALL DATA IN ATAG
C---                                     AND COPY TO CATAG ARRAY
C
        DO 20 J = IHSTA , IHSTO , 2
C
           IHAD = HDATA(J)
C
C---                                     CONVERT HARDWARE ADDRESSIHAD
C---                                     TO SOFTWARE ADDRESS ISAD
C
           CALL TAGH2S(ISAD,IHAD,*20)
C
           IF ( (ISAD .GT. IENDPZ) .OR. (ISAD .LT. 0) ) GOTO 19
C
C---                                     FILL CATAG ARRAY MEMBER
C---                                     ( SOFTARE ADDRESS ) WITH
C---                                     APPROX ENERGY IN MEV
C
           CATAG(ISAD) = HDATA(J+1) * CALIB(MARK)
C
C---                                     CHECK FOR CRAZY DATA
C
           IF ( (HDATA(J+1).LT.0) .OR. (HDATA(J+1) .GT. 4090) ) GOTO 18

C
           GOTO 20
C
C
C--------------------------------------- ERROR CONDITIONS --------------
C
C
C--------------------------------------- HERE FOR BAD ENERGY
C
   18      CONTINUE
C
           IF ( .NOT. NOMSG ) WRITE(6, 11)ISAD,CATAG(ISAD)
   11  FORMAT(//,' +++  WARNING FROM TAGGING ROUTINE - TAGADC -',
     *                '   CATAG(',I4,') HAS CRAZY VALUE -',F12.3,
     *                ' ---  IT HAS BEEN SET TO ZERO ')
C
C---                                     SET THE ARRAY TO ZERO
C
           CATAG(ISAD) = 0.0
           IF ( .NOT. NOMSG ) LERROR = .TRUE.
           GOTO 20
C
C--------------------------------------- HERE FOR ILLEGAL ADDRESS
C
   19      IF ( NOMSG ) GOTO 20
           LERROR = .TRUE.
           WRITE(6, 21)IHAD,ISAD
   21  FORMAT(' +++ ILLEGAL ADDRESS FOUND IN TAGADC IHAD,ISAD ',2I10)
C
C
C--------------------------------------- END OF LOOP -------------------
C
   20  CONTINUE

C
C
C---                                     O.K. THAT'S THE COMMON FILLED
C---                                     NOW TEST FOR ANY ERRORS
C
       IF ( NOMSG .OR. ( .NOT. LERROR ) )  GOTO 90
       LERROR = .FALSE.
C
C---                                     IF THERE WAS AN ERROR THEN
C---                                     DUMP OUT THE OFFENDING BANK
C
       CALL HPRS('ATAG',0)
C
C---                                     COUNT THE NUMBER OF ERRORS
C
       ICOUNT = ICOUNT + 1
       IF ( ICOUNT .NE. 10 ) GOTO 90
       NOMSG = .TRUE.
       WRITE(6, 31)
   31  FORMAT(///,'+++  MORE THAN TEN ERRORS DETECTED BY TAGADC',
     *            '  -- NO MORE MESSAGES  +++',///)
C
C---                                     RETURN  IF NO DEBUG
C
   90  CONTINUE
       IF ( IWRITE .NE. 1 ) RETURN
C
       WRITE(6,911)CALIB(MARK)
  911  FORMAT(' CATAG ARRAY =  ADC VALUES TIMES ',F6.3)
C
       DO 900 I = 1,IENDPZ,8
          WRITE(6,921) CATAG(I),CATAG(I+1),CATAG(I+2),CATAG(I+3),
     *                 CATAG(I+4),CATAG(I+5),CATAG(I+6),CATAG(I+7)
  900  CONTINUE
  921  FORMAT(8(3X,F10.2))
       RETURN
C
 1000  RETURN 1
C
C----------------------------------------RAW DATA-----------------------
C
 1100  CONTINUE
       CALL TAGRAW(IWRITE,*1000)
       RETURN
       END
C
C
C
C
C
C
C   12/03/84            MEMBER NAME  TAGDAT   (S)           FORTRAN
C      BLOCK DATA TAGDAT
       BLOCK DATA
C
       COMMON / COMTAG / LISTOK,NLIST(64,9,2),
     1                   XMAP(64),YMAP(64)
C
       DIMENSION NDUM(64,4)
       DIMENSION NDIM(64,4)
       EQUIVALENCE (NLIST(1,5,1),NDUM(1,1)),(NLIST(1,1,1),NDIM(1,1))
       DATA NDIM/5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           5,6,5,7,6,3,4*5,3,6,7,5,6,5,
     *           3,4,6,7,4,3,6,7,8,9,10,5,12,11,13,14,
     *           16,15,17,17,20,19,22,20,21,25,26,21,28,31,1,1,
     *           64,64,33,37,36,35,36,36,37,41,42,37,41,42,45,45,
     *           47,47,49,49,60,51,51,52,56,57,58,53,60,58,61,61,
     *           4,3,7,6,7,4,3,4,5,12,13,8,15,10,14,13,
     *           15,16,18,19,23,20,19,21,24,28,29,24,26,32,2,2,
     *           63,63,34,34,39,36,35,37,40,43,45,40,42,43,46,46,
     *           48,48,50,50,52,52,52,53,53,60,61,56,57,59,62,62,
     *           2,1,4,3,8,7,4,5,12,13,14,9,10,13,16,15,
     *           18,17,20,21,24,23,20,23,28,30,30,25,27,29,32,31,
     *           34,33,36,35,40,39,38,39,42,44,46,41,43,45,48,47,
     *           50,49,52,51,55,55,53,55,58,61,62,57,58,64,64,63/
       DATA NDUM/31,32,2,2,9,0,5,12,13,14,0,10,11,15,17,18,
     *           20,20,23,23,25,0,21,25,29,29,0,26,30,27,30,30,
     *           36,36,38,38,41,0,37,41,45,45,0,42,44,47,49,49,
     *           51,51,54,53,56,0,54,57,60,62,0,58,59,63,33,33,
     *           32,31,1,1,12,0,8,9,10,11,0,13,14,16,18,17,
     *           19,19,22,22,28,0,24,28,26,27,0,29,31,26,29,29,
     *           35,35,39,39,44,0,40,44,44,46,0,45,46,48,50,50,
     *           52,52,55,54,57,0,56,60,61,59,0,61,62,64,34,34,
     *           0,5,0,5,2,6*0,15,16,0,12,0,0,21,0,24,18,
     *           6*0,31,32,0,28,0,0,37,0,40,34,6*0,47,47,0,44,0,0,
     *           53,0,55,50,6*0,63,64,0,60,0,3*0,8,8*0,9,6*0,18,
     *           8*0,25,6*0,33,8*0,48,6*0,56,8*0,63,3*0/
      DATA XMAP/216.5,135.5,204.5,123.5,42.5,204.5,123.5,42.5,
     *          56*0.0/
      DATA YMAP/40.5,40.5,121.5,121.5,136.0,202.5,202.5,217.0,
     *          56*0.0/
      END

C   07/06/96 606071906  MEMBER NAME  RDVAR    (S4)          FORTG1
      SUBROUTINE RDVAR(IUN,NTOT,ARRAY,NDIM)
      INTEGER ARRAY(1),INI/0/,NRD/0/,NWR/0/
      COMMON/CIBCOM/IRFLG
***PMF      REAL*8 TEXTA(4)/' IBCOMR ',' IBWRD  ',' IBARR  '/
      REAL*8 TEXTA(4)/' IBCOMR ',' IBWRD  ',' IBARR  ','        '/
      REAL*8 TEXTB(3)/'        ',' IHN213 ',' IHN218 '/
C
      IF(INI.EQ.0) CALL IBCERR
C
      NRD=NRD+1
      IRFLG=1
      IRCDE=0
      CALL IBCOMR(IUN,*8,*4)
      CALL IBWORD(NTOT,*7,*3)
      IF(NTOT.LE.0.OR.NTOT.GT.NDIM) GOTO 1
      CALL IBARR(ARRAY,NTOT,*6,*2)
      CALL IBCOMF
      GOTO 100
C     RECORD TO LARGE OF FIRST WORD WRONG
    1 CALL IBCOMF
      WRITE(6,101) IUN,NRD,NDIM,NTOT,NTOT,NTOT
      NTOT=0
      GOTO 100
C     READ ERRORS
    2 IRCDE=IRCDE+1
    3 IRCDE=IRCDE+1
    4 IRCDE=IRCDE+1
      READ(IUN,ERR=5,END=9)
    5 WRITE(6,102) IUN,NRD,TEXTA(IRCDE),TEXTB(IRFLG)
      NTOT=0
      GOTO 100
C     END EXITS
    6 IRCDE=IRCDE+1
    7 IRCDE=IRCDE+1
    8 IRCDE=IRCDE+1
    9 WRITE(6,103) IUN,NRD,TEXTA(IRCDE)
      NTOT=-1
      GOTO 100
C
      ENTRY WRVAR(IUN,NTOT,ARRAY)
C
      IF(INI.EQ.0) CALL IBCERR
C
      NWR=NWR+1
      IRFLG=1
      CALL IBCOMW(IUN)
      IF(IRFLG.NE.1) GOTO 20
      CALL IBWORD(NTOT)
      IF(IRFLG.NE.1) GOTO 20
   10 CALL IBARR(ARRAY,NTOT)
      IF(IRFLG.NE.1) GOTO 20
      CALL IBCOMF
      GOTO 100
C
      ENTRY WRFIX(IUN,NTOT,ARRAY)
C
      IF(INI.EQ.0) CALL IBCERR
C
      NWR=NWR+1
      IRFLG=1
      CALL IBCOMW(IUN)
      IF(IRFLG.EQ.1) GOTO 10
   20 WRITE(6,104) IUN,NWR
      CALL ABEND
C
  100 INI=1
      RETURN
C
  101 FORMAT('0---- UNIT',I3,'   READ  ',I8,'.TH CALL',5X,'NDIM=',I6,
     1   ', FIRST WORD IN RECORD =',I12,' (I)   ',A4,' (A)',G15.5,
     2   ' (F)')
  102 FORMAT('0---- UNIT',I3,'   READ  ',I8,'.TH CALL',5X,'IO-ERROR IN',
     1   A8,4X,A8)
  103 FORMAT('0---- UNIT',I3,'   READ  ',I8,'.TH CALL',5X,'END EXIT IN',
     1   A8)
  104 FORMAT('0---- UNIT',I3,'   WRITE ',I8,'.TH CALL',5X,'IO-ERROR',
     1   ' ---- ABEND'/)
      END
      SUBROUTINE IBCERR
      INTEGER INI/0/
      EXTERNAL ERR213,ERR218
      IF(INI.NE.0) GOTO 100
      CALL ERRSET(213,256,0,0,ERR213)
      CALL ERRSET(218,256,0,0,ERR218)
      INI=1
  100 RETURN
      END
      SUBROUTINE ERR213(IRETCD,IERNO,A,B,D)
      COMMON/CIBCOM/IRFLG
      IRFLG=2
      RETURN
      END
      SUBROUTINE ERR218(IRETCD,IERNO,A,B,D,F)
      COMMON/CIBCOM/IRFLG
      IRFLG=3
      RETURN
      END

C   05/04/79 C9040501   MEMBER NAME  DUMMOT   (JADEGS)      FORTRAN
      SUBROUTINE PATREC(INDEX)
      RETURN
      END
      SUBROUTINE PTJADE(INDEX)
      RETURN
      END
      SUBROUTINE LGANAL
      RETURN
      END

      SUBROUTINE CKTRKO(LBTRCK,LBCELL)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      INTEGER MKLY(16) /1,2,4,8,16,32,64,128,256,512,1024,2048,
     ,                  Z1000,Z2000,Z4000,Z8000/
      INTEGER MKDDCL(3) /Z01,Z02,Z04/, LBDDCL /ZFFFF/
      INTEGER MKBDCL(3) /Z10,Z20,Z40/
      REAL RDLIM(5,2) / -2.0, -1.0, 1.0, 2.0, 8.5,
     ,                  -3.0, -2.0, 2.0, 3.0, 8.5/
      DATA INDLM /-1/
      DIMENSION  LBHT(15)
      LBTRCK = 0
      CALL SETS(LBHT(1),0,60,0)
      JRING0 = 0
      DO 13000 IP = HPCO0,HPCO9,HLDCO
        ILAY   = IWRK(IP   )
        JRING  = IWRK(IP+12)
        LBGOOD = IWRK(IP+ 7)
        DF     = WRK (IP+13)*IWRK(IP+2)
      IF(
     - JRING.NE.JRING0
     -)THEN
          JRING0 = JRING
          INDLM1 = 1
          IF(LAND(MKBDCL(JRING),LBCELL).NE.0) INDLM1 = 2
      IF(
     - INDLM1.NE.INDLM
     -)THEN
            INDLM = INDLM1
            RDLM1 = RDLIM(1,INDLM)
            RDLM2 = RDLIM(2,INDLM)
            RDLM3 = RDLIM(3,INDLM)
            RDLM4 = RDLIM(4,INDLM)
            RDLM5 = RDLIM(5,INDLM)
      ENDIF
      ENDIF
      IF(
     - LBGOOD .NE. 16
     -)THEN
          LBGOOD = 1
          IF(DF.LE. RDLM1 .OR.  DF.GE. RDLM5) LBGOOD = 5
          IF(DF.GE. RDLM1 .AND. DF.LT. RDLM2) LBGOOD = 2
          IF(DF.GE. RDLM3 .AND. DF.LT. RDLM4) LBGOOD = 3
          IF(DF.GE. RDLM4 .AND. DF.LT. RDLM5) LBGOOD = 4
          INDEX = JRING*5 - 5 + LBGOOD
          LBHT(INDEX) = LOR(LBHT(INDEX),MKLY(ILAY+1))
      ENDIF
13000 CONTINUE
13001 CONTINUE
      LMGAP = 3
      MGAP  = 0
      MGAP1 = 0
      MGAPM = 0
      MCON  = 0
      ILAYR = 0
      ILLST = 0
      NHGD  = 0
      LBOUND = 0
      JRING = 0
16000 CONTINUE
      JRING = JRING + 1
        INDEX = JRING*5 - 5
        NHGC  = 0
        NHTRC = 0
        LB1   = LBHT(INDEX + 1)
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
        LB2   = LBHT(INDEX + 2)
        LB3   = LBHT(INDEX + 3)
        LB4   = LBHT(INDEX + 4)
        IF(LAND(MKDDCL(JRING),LBCELL).NE.0) LB4 = LBDDCL
        LB5   = LBHT(INDEX + 5)
        LBCV  = LOR(  LB3,  LB4)
      IF(
     - LBCV.NE.0
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      ENDIF
        LBGC  = LOR( LBCV,  LB1)
        LBTRC = LOR( LBGC,  LB2)
        LBHIT = LOR(LBTRC,  LB4)
        IL = 0
15000 CONTINUE
      IF(
     - IL.LT.16
     -)THEN
        IL    = IL    + 1
        ILAYR = ILAYR + 1
          MKLY1 = MKLY(IL)
      IF(
     - LAND(LBGC,MKLY1).EQ.0
     -)THEN
      IF(
     - IL.GT.2 .AND. IL.LT.15
     -)THEN
              MGAP  = MGAP  + 1
              MGAP1 = MGAP1+ 1
              MCON  = 0
      ENDIF
      ELSE
            NHGC  = NHGC + 1
            MCON  = MCON + 1
      IF(
     - MCON.GE.2 .OR. MGAP1.EQ.1
     -)THEN
              MGAP  = 0
              MGAPM = 0
              ILLST = ILAYR
              IF(MCON.EQ.4) LBOUND = 0
      ENDIF
            MGAPM = MAX0(MGAPM,MGAP1)
            MGAP1 = 0
      ENDIF
          IF(LAND(LBTRC,MKLY1).NE.0) NHTRC = NHTRC + 1
          IF(LAND(LB1  ,MKLY1).NE.0) NHGD  = NHGD  + 1
      IF(
     - MGAPM.GE.4 .OR. MGAP.GE.6
     -)THEN
            LBACC = 0
            IF(LAND(MKBDCL(JRING),LBCELL).NE.0 .AND. MGAPM.LE.6
     ?         .AND. MGAP.LE.7) LBACC = 1
      IF(
     - LBACC.NE.0
     -)THEN
              LBOUND = 1
              ILLSTB = ILLST
      ELSE
              LBTRCK = ILLST
      GOTO 16001
      ENDIF
      ENDIF
      GOTO 15000
      ENDIF
15001 CONTINUE
      IF(.NOT.(
     - JRING.EQ.3
     -))GOTO 16000
16001 CONTINUE
      IF(LBTRCK.EQ. 0) LBTRCK = ILLST
      IF(LBOUND.NE. 0) LBTRCK = ILLSTB
      IF(NHGD  .LT. 8 .AND. LBTRCK.GT.0) LBTRCK =-LBTRCK
      RETURN
17000 CONTINUE
        LBGD2 = ISHFTL(LB1 ,1)
        MKGD1 = 7
        MKGD2 = 5
        MKGD3 = 2
      DO 13002 IL=1,16
          LBZW  = LAND(LBGD2,MKGD1)
      IF(
     - LBZW.EQ.MKGD2
     -)THEN
            LBGD2 = LOR(MKGD3,LBGD2)
      ENDIF
          MKGD1 = ISHFTL(MKGD1,1)
          MKGD2 = ISHFTL(MKGD2,1)
          MKGD3 = ISHFTL(MKGD3,1)
13002 CONTINUE
13003 CONTINUE
        LBPR = ISHFTR(LBGD2,1)
        LB1  = ISHFTR(LBGD2,1)
      GOTO IZZZ01
17002 CONTINUE
        LBCV2 = ISHFTL(LBCV,1)
        MKCV1 = 7
        MKCV2 = 2
      DO 13004 IL=1,16
          LBZW  = LAND(LBCV2,MKCV1)
      IF(
     - LBZW.EQ.MKCV2
     -)THEN
            LBCV2 = LAND(LCOMPL(MKCV2),LBCV2)
      ENDIF
          MKCV1 = ISHFTL(MKCV1,1)
          MKCV2 = ISHFTL(MKCV2,1)
13004 CONTINUE
13005 CONTINUE
        LBCV = ISHFTR(LBCV2,1)
      GOTO IZZZ02
      END

C   07/06/96 606071842  MEMBER NAME  DIDA     (S4)          FORTRAN
      SUBROUTINE DIDA(IGOTO,LIST,IL)
C
C     VERSION OF JULY 82
C
      COMMON/ACS/DUMMI(90),NUNTB
C
C     IGOTO =-1   RESERVE DATA SET FOR EXCLUSIVE USE
C     IGOTO = 0   CREATE MASTER DIRECTORY BANK
C     IGOTO = 1   SEARCH FOR NAME,NR IN DIRECTORY RECORDS
C     IGOTO = 2   DELETE NAME,NR IN DIRECTORY RECORD
C     IGOTO = 3   ADD NAME,NR TO DIRECTORY RECORD
C
C     LIST(1) = NAME
C     LIST(2) = NR
C     LIST(3) = NR OF DATA RECORD
C     LIST(4) = NR OF WORDS IN BANK

      COMMON/BCS/IW(1)
      COMMON/CCS/IUND,INDT,INDC,NPTR,INDA,LISTE(5),IPAS,NDAREC
      INTEGER LIST(5,1),IBOS/'BOSS'/,DIRA/'DIRA'/,BINTIM
      JPAS=IPAS
      IPAS=0
      IF(IGOTO.LT.0) GOTO 80
    1 INDA=ILINK(4H+DIR,IUND)
      IF(INDA.EQ.0)  GOTO 10
      IF(IGOTO.GE.0) GOTO 14
      IPRFLG=0
      IF(IW(INDA+20).EQ.0) JPAS=IW(INDA+19)
      GOTO 11
C
C     CREATE MASTER DIRECTORY BANK (FROM DATA SET), IF NOT YET EXISTING
C
   10 INDA=IBANK(4H+DIR,IUND,52)
      IPRFLG=1
      IF(INDA.EQ.0) GOTO 202
   11 CALL RDDA(1,50,IW(INDA+1))
      IW(INDA+ 9)=0
      IW(INDA+10)=0
      IF(IPRFLG.EQ.0) GOTO 15
      IF(NUNTB.NE.0)
     1  WRITE(NUNTB,101) IUND,IW(INDA+6),IW(INDA+7),(IW(INDA+J),J=21,35)
C     READ LAST RECORD, TO CHECK DEFINE FILE STATEMENT
      CALL ERRSET(232,1,1,0,0,232)
      CALL RDDA(IW(INDA+6),1,DUMMY)
C
C     CHECK PASSWORD (IW(INDA+20)=1 MEANS NO CHANGE POSSIBLE)
C
   15 IF(IW(INDA+19).EQ.0)    GOTO 12
      IF(IW(INDA+19).EQ.JPAS) GOTO 12
      IF(JPAS.EQ.IBOS)        GOTO 12
      IW(INDA+19)=0
      IW(INDA+20)=1
      IF(NUNTB.NE.0.AND.IPRFLG.EQ.1) WRITE(NUNTB,102) IUND
      GOTO 14
   12 IW(INDA+20)=0
C
C     CONSISTENCY CHECKS AND BRANCH
C
   14 IF(IW(INDA+2).EQ.DIRA)       GOTO 16
      IF(IW(INDA+2).NE.IW(INDA-3)) GOTO 203
   16 IF(IW(INDA+11).EQ.0) IW(INDA+11)=1610
      NDAREC=IW(INDA+11)
      IF(IGOTO.LE.0) GOTO 100
      IF(IGOTO.EQ.3) GOTO 40
C
C     SEARCH FOR ENTRY IN DIRECTORY RECORDS
C
   20 INDT=0
      NHASH=2+MOD(IABS(LIST(1,1)+LIST(2,1)),IW(INDA+8))
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 201
   22 CALL RDDA(NHASH,NDAREC,IW(IA))
      NHASHX=IW(IA+3)
      INDP=IA+4
      K=INDP
      N=IW(K)/4
      IF(N.EQ.0)              GOTO 26
      IF(N.LT.0.OR.N.GT.(NDAREC-10)/4)  GOTO 201
      DO 24 I=1,N
      IF(LIST(1,1).NE.IW(K+1)) GOTO 24
      IF(LIST(2,1).NE.IW(K+2)) GOTO 24
C
C     ENTRY IN DIRECTORY RECORDS FOUND
C
      LIST(3,1)=IW(K+3)
      LIST(4,1)=IW(K+4)
      INDT=K
      IF(IGOTO-1) 100,100,30
   24 K=K+4
   26 NHASH=NHASHX
      IF(NHASH.NE.0) GOTO 22
      GOTO 100
C
C     DELETE NAME,NR FROM DIRECTORY RECORD
C
   30 NWCP=INDP+IW(INDP)-K-4
      IF(NWCP.NE.0) CALL UCOPY2(IW(K+5),IW(K+1),NWCP)
      IW(INDP)=IW(INDP)-4
      IW(IA)  =IW(IA)  -4
      CALL WRDA(NHASH,IW(IA),IW(IA+1))
      GOTO 100
C
C     ADD NAME,NR TO DIRECTORY RECORD
C
   40 NHASHF=0
      NHASHL=0
      IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 202
      I=0
C
C     LOOP FOR IL DIRECTORY ENTRIES
C
   50 I=I+1
      IF(I.GT.IL)         GOTO 70
      NHASH=2+MOD(IABS(LIST(1,I)+LIST(2,I)),IW(INDA+8))
      IF(NHASH.EQ.NHASHF) GOTO 56
      NHASHF=NHASH
   52 IF(NHASHL.EQ.0)     GOTO 54
      CALL WRDA(NHASHL,IW(IA),IW(IA+1))
      NHASHL=0
   54 CALL RDDA(NHASH,NDAREC,IW(IA))
   56 INDP=IA+4
      N=IW(INDP)/4
      IF(N.GE.(NDAREC-10)/4)        GOTO 60
C
C     COPY 4 WORDS INTO DIRECTORY
C
      CALL UCOPY(LIST(1,I),IW(INDP+IW(INDP)+1),4)
      IW(INDP)=IW(INDP)+4
      IW(IA)  =IW(IA)  +4
      NHASHL=NHASH
      GOTO 50
C
C     TRY NEXT DIRECTORY RECORD
C
   60 IF(IW(IA+3).EQ.0) GOTO 62
      NHASH=IW(IA+3)
      GOTO 52
C
C     NEW DIRECTORY RECORD REQUIRED
C     WHAT HAPPENS, IF SPACE ON DATA SET NO SUFFICIENT FOR LOAD
   62 NHASHL=NHASH
      IW(INDA+7)=IW(INDA+7)+1
      NHASH=IW(INDA+7)
C
C     SAVE TWO WORDS FROM DIRECTORY RECORD
C
      NTOT=IW(IA)
      NWDR=IW(IA+4)
C
C     WRITE NEW DIRECTORY RECORD
C
      IW(IA)=4
      IW(IA+4)=0
      CALL WRDA(NHASH,IW(IA),IW(IA+1))
C
C     WRITE EMPTY DATA RECORD
C
      IW(INDA+7)=IW(INDA+7)+1
      IW(IA)=0
      CALL WRDA(NHASH+1,IW(IA),IW(IA+1))
C
C     RESTORE TWO WORDS AND ADD POINTER TO NEXT DIRECTORY RECORD
C
      IW(IA)  =NTOT
      IW(IA+3)=NHASH
      IW(IA+4)=NWDR
      GOTO 52
C
C     FINAL WRITE FOR LAST DIRECTORY RECORD
C
   70 IF(NHASHL.EQ.0) GOTO 100
      CALL WRDA(NHASHL,IW(IA),IW(IA+1))
      GOTO 100
C
C     RESERVE DATA SET FOR EXCLUSIVE USE
C
   80 IA=IBANK(0,0,0)
      IF(IW(IA).LT.NDAREC) GOTO 201
C
C     TRY TO RESERVE DATA SET FOR EXCLUSIVE USE
C
C     LOOP FOR THIS OFFLINE VERSION ONLY UP TO 12*13 SEC
C
      DO 84 I=1,12
      CALL RDDA(2,50,IW(IA))
      CALL RDDA(1,50,IW(IA))
      ITIME=BINTIM(I)
      IF(IW(IA+ 8).NE.0)        GOTO 82
      IF(IW(IA+ 9).NE.0)        GOTO 82
   81 IW(IA+ 8)=LISTE(1)
      IW(IA+ 9)=LISTE(2)
      IW(IA+11)=ITIME
      CALL WRDA(1,IW(IA),IW(IA+1))
      CALL RDDA(2,50,IW(IA))
      CALL RDDA(1,50,IW(IA))
      IF(IW(IA+ 8).NE.LISTE(1)) GOTO 82
      IF(IW(IA+ 9).NE.LISTE(2)) GOTO 82
      GOTO 1
C
C     DATA SET IN USE, TRY AGAIN
C
   82 JTIME=IW(IA+11)
      IDTIME=IABS(ITIME-JTIME)
      IF(NUNTB.NE.0) WRITE(NUNTB,104) IDTIME
  104 FORMAT(1X,'DATA SET RESERVED, TIME DIFFERENCE IS',I10,'/100 SEC')
C     ASSUME FREE, IF MORE THAN 3 MIN TIME DIFFERENCE
      IF(IABS(IDTIME).GT.18000) GOTO 81
C     WAIT  13 SEC (=500000*26 MIKROSEC)
      CALL DELAY(500000)
   84 CONTINUE
   90 IF(NUNTB.NE.0) WRITE(NUNTB,103) IUND
      GOTO 201
C
C
  100 RETURN
  101 FORMAT('0---- DIR-UNIT',I3,9X,'TOTAL',I6,' RECORDS, USED',
     1   I6,' RECORDS'/'0',38X,'LAST LOAD',17X,'LAST UPDATE',17X,
     2   'LAST UNLOAD'/15X,' DATE',10X,3(2A4,2X,2A4,10X)/
     3   15X,' STORED BANKS',12X,3(I8,20X)/)
  102 FORMAT('0---- DIR-UNIT',I3,9X,'PROTECTED DATA SET, NO BCREDA',
     1   ' OR BDLSDA POSSIBLE'/)
  103 FORMAT('0---- DIR-UNIT',I3,' IN USE, NO CHANGE POSSIBLE - STOP'/)
C
C     ERROR - DATA SET IN USE
C
  201 CALL BDMPA(15)
C
C     INSUFFICIENT SPACE FOR DIRAC OPERATION
C
  202 CALL BDMPA(16)
C
C     ILLEGAL DIRECTORY
C
  203 CALL BDMPA(17)
      GOTO 100
      END

C   16/05/80 205182255  MEMBER NAME  COMFIL   (S)           FORTRAN
      SUBROUTINE COMFIL(IENTRY,T,Z,PHIV,IPM)
C
      DIMENSION ZMAT(3,4,84),INDEX(3),YMAT(3,4),A(3,3)
      DIMENSION ZSOL(3,84)
      DATA RTOF/3.07/,IBUG/0/
C
      IF(IENTRY.LE.1)  GOTO  30
      IF(IENTRY.GT.2)  GOTO  20
      IF(IENTRY.NE.2) RETURN
      IBUG =IBUG + 1
      ZM = T
      IF(IBUG.LE.10) PRINT 113,IPM,T,Z,PHIV
  113 FORMAT(' COMFIL',I5,3F10.3)
C
      ZMAT(1,1,IPM) = ZMAT(1,1,IPM) + Z*Z
      ZMAT(2,1,IPM) = ZMAT(2,1,IPM) + Z
      ZMAT(3,1,IPM) = ZMAT(3,1,IPM) + Z*PHIV
C
      ZMAT(1,2,IPM) = ZMAT(1,2,IPM) + Z
      ZMAT(2,2,IPM) = ZMAT(2,2,IPM) + 1.
      ZMAT(3,2,IPM) = ZMAT(3,2,IPM) + PHIV
C
      ZMAT(1,3,IPM) = ZMAT(1,3,IPM) + Z*PHIV
      ZMAT(2,3,IPM) = ZMAT(2,3,IPM) + PHIV
      ZMAT(3,3,IPM) = ZMAT(3,3,IPM) + PHIV*PHIV
C
      ZMAT(1,4,IPM) = ZMAT(1,4,IPM) - Z*ZM
      ZMAT(2,4,IPM) = ZMAT(2,4,IPM) - ZM
      ZMAT(3,4,IPM) = ZMAT(3,4,IPM) -ZM*PHIV
C
      RETURN
   20 CONTINUE
      DO   1   I=1,84
      CALL UCOPY(ZMAT(1,1,I),YMAT(1,1),12)
      PRINT 103,I
  103 FORMAT(1X,I5,3E12.3)
      PRINT 1113,YMAT
 1113 FORMAT(6X,3E12.3)
      NDIM = 3
      MDIM = 1
      CALL MATIN1(YMAT,NDIM,NDIM,DUMMY,MDIM,INDEX,NERROR,DET)
      IF(NERROR.NE.0)  GOTO  2
      PRINT 104,I,DET
  104 FORMAT(' DET',I5,E12.5)
      PRINT 1113,YMAT
      DO   4   L=1,3
      DO   3   K=1,3
C     A(K,L) = ZMAT(K,1,I)*YMAT(1,L)+ZMAT(K,2,I)*YMAT(2,L)+ZMAT(K,3,I)
C    1 *YMAT(3,L)
      A(K,L) = YMAT(K,1)*ZMAT(1,L,I)+YMAT(K,2)*ZMAT(2,L,I)+
     1  YMAT(K,3)*ZMAT(3,L,I)
    3 CONTINUE
    4 CONTINUE
      PRINT 1113,A
      PRINT 101,(YMAT(L,4),L=1,3)
  101 FORMAT(' SOL',I5,12F 9.3)
      CALL UCOPY(YMAT(1,4),ZSOL(1,I),3)
      GOTO  1
    2 PRINT 102,I,NERROR
  102 FORMAT(' ERROR IN MAT INVERSION ',2I5)
    1 CONTINUE
C
      PRINT 105,ZSOL
  105 FORMAT(1X,3F12.5)
      WRITE(18) ZSOL
      RETURN
   30 CALL SETSL(ZMAT,0,84*12*4,0.)
      RETURN
      END

C   16/02/75 C7103101   MEMBER NAME  MULTSC   (SOURCE)      FORTRAN
      SUBROUTINE MULTSC(X1,P1,XRAD)
      DIMENSION X1(3),X2(3),X3(3)
      DATA PI/3.14159/
C
C      CALCULATE MULTIPLE SCATTERING
C      X1 = DIRECTIONAL COS FOR INCIDENT PARTICLE
C           THIS VECTOR IS OVERWRITTEN UPON RETURN WITH THE UNIT VECTOR
C           AFTER MULTIPLE SCATTERING
C      P1 = MOMENTUM OF INCIDENT PARTICLE IN GEV/C
C      XRAD = RADIATORTHICKNESS IN RADIATION LENGTHS
C
      IF(XRAD.LT.1.E-30) RETURN
      CTH=X1(3)
      IF(ABS(CTH).LT.1.E-30) GO TO 1
      STH=SQRT(1.-CTH*CTH)
      IF(STH.LT.1.E-30) GO TO 2
      SPHI=X1(2)/STH
      CPHI=X1(1)/STH
      X2(1)=SPHI
      X2(2)=-CPHI
      X2(3)=0.
      X3(1)=CPHI*CTH
      X3(2)=SPHI*CTH
      X3(3)=-STH
      GO TO 3
    1 X2(1)=X1(2)
      X2(2)=-X1(1)
      X2(3)=0.
      X3(1)=0.
      X3(2)=0.
      X3(3)=-1.
      GO TO 3
    2 X2(1)=0.
      X2(2)=-1.
      X2(3)=0.
      X3(1)=1.
      X3(2)=0.
      X3(3)=0.
    3 THSTR=15./P1*SQRT(XRAD)*1.E-03
      CALL NVERT(THSTR,0.,TH1)
      PHI=2.*PI*RN(D)
      PABS=0.
      DO 4 I=1,3
      X1(I)=X1(I)+TH1*COS(PHI)*X2(I)+TH1*SIN(PHI)*X3(I)
    4 PABS=PABS+X1(I)**2
      PABS=SQRT(PABS)
      DO 5 I=1,3
    5 X1(I)=X1(I)/PABS
      RETURN
      END

C   07/06/96 606071902  MEMBER NAME  PHIST    (S4)          FORTG1
      SUBROUTINE PHIST(NA)
      EXTERNAL UHIST
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL*8 RPR(11)
      REAL*4 SP(11)
      COMMON/CCONVT/JM,PX(32,10)
      INTEGER PX
      LOGICAL*1 LX(128,10),XCH/'X'/
      EQUIVALENCE (LX(1,1),PX(1,1))
      NAA=NA
      IF(NA.NE.0) GOTO 4
      CALL BPOS('HST*')
    2 CALL BNXT(IND,&100)
      NAA=IW(IND-2)
    4 CALL QHIST(NAA,PX)
      CALL BLOC(IND,'HST*',NAA,&100)
      IF(IND.EQ.0) RETURN
      IF(IW(IND+20).GE.3) GOTO 90
      CALL PTEXT(NAA,3)
      WRITE(6,101) (RW(IND+I),I=1,16,2)
      WRITE(6,102) (RW(IND+I),I=2,16,2)
      CALL HISTPR(RW(IND+21),100,RW(IND+3),RW(IND+4))
   90 IW(IND+20)=3
      IF(NA.EQ.0) GOTO 2
  100 RETURN
  101 FORMAT(
     1   '0UHIST',I10,    ' AW',G13.3,' OUTL',F8.0,' MIN',G13.6,' MEAN',
     2   G12.3,' SIGMA',G11.4,' 16PC',G11.4,' 02.3PC',G11.4)
  102 FORMAT(' ENTRIES',I8,' STEP',G11.3,' OUTH',F8.0,' MAX',G13.6,
     1   ' MEDIAN',G10.3,' MSIGM',G11.3,' 84PC',G11.4,' 97.7PC',G11.4)
      END

C   01/04/85 806291322  MEMBER NAME  SUPERV   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE SUPERV
C-----------------------------------------------------------------------
C
C
C        JADE SUPERVISOR ROUTINE FOR GENERAL PURPOSE ANALYSIS.
C        -----------------------------------------------------
C
C   AUTHOR:   L. O'NEILL PREHISTORY:  THE JADE SUPERVISOR
C
C        MOD  J. OLSSON   31/08/83 :  MOD. TO GRAPHICS PART OF EV. WRITE
C        MOD  J. OLSSON    9/11/83 :  CALL LGCDIR ADDED AT LEVEL 7
C        MOD  C. BOWDERY  13/12/83 :  MUON ANALYSIS ONLY IF NO MUON BNKS
C                                  :  GENERAL TIDY-UP PERFORMED.
C        MOD  C. BOWDERY  20/12/83 :  REMOVE BLOCKDATA. ADD EXTERNAL
C                                  :  JADEBD TO LOAD BLOCKDATA.
C                                  :  IUNIT = 2 REMOVED AS SET IN JADEBD
C        MOD  C. BOWDERY  16/01/84 :  PRINT BANNER HEADLINE. IDATA(40K)
C        MOD  C. BOWDERY  19/01/84 :  USE NEW CBCSMX MACRO
C        MOD  C. BOWDERY   8/02/84 :  MACRO CADMIN NOW ON PATRECSR
C        MOD  C. BOWDERY  14/02/84 :  CODE TO CHECK IF PATR/JHTL DELETED
C                                  :  NTIME CALLED AFTER CALL TO USER
C        MOD  C. BOWDERY  17/02/84 :  SERIOUS BUG CORRECTED IN LEVEL 5
C        MOD  C. BOWDERY   8/07/84 :  NOTICE IF NDDINN HAS CHANGED
C        MOD  C. BOWDERY   1/04/85 :  CALL KALIBR FOR EVERY EVENT NOW
C        MOD  C. BOWDERY  17/07/85 :  SMALL CHANGE FOR LEVEL 11
C   LAST MOD  C. BOWDERY  28/03/88 :  LOW PRIORITY BOS SPACE INCREASED
C
C   LAST MOD
C   P. Movilla Fernandez   Oct./98 :  Adapted for use on new platforms
C                                     Get rid of old IBM stuff
C                                     Reorganize I/O handling
C                    PMF  31/05/00 :  Introduce INDEX=13 on return from
C                                     USER subroutine
C
C------------------  M O D E   O F   U S E  ----------------------------
C
C
C   THE SUPERVISOR COORDINATES THE ANALYSIS OF JADE EVENTS. AT VARIOUS
C   POINTS IN THE PROGRAM, CONTROL IS PASSED TO S/R "USER" WHICH CAN
C   MAKE DECISIONS ABOUT WHAT TO DO NEXT. AT EACH CALL, AN "INDEX" VALUE
C   IS PASSED TO "USER" TO INDICATE AT WHICH POINT OR "LEVEL" THE
C   SUPERVISOR HAS JUST FINISHED. IT IS A SUPERVISOR CONVENTION THAT IF
C   THE ANALYSIS BANKS FOR AN ANALYSIS PACKAGE ALREADY EXIST, THEN A NEW
C   ANALYSIS IS -NOT- PERFORMED. THIS SHOULD BE REMEMBERED WHEN READING
C   THE COMMENTS BELOW. TO GET A RE-ANALYSIS, SIMPLY DELETE THE EXISTING
C   RESULTS BANKS IN THE "USER" ROUTINE BEFORE THE RELEVANT LEVEL.
C
C      INDEX                        COMMENT
C      -----                        -------
C
C        0             INITIAL CALL, BEFORE FIRST EVENT READ.
C        1             CALLED AT THE BEGINNING OF EACH NEW RUN.
C        2             CALLED IMMEDIATELY AFTER EVENT IS READ INTO /BCS/
C        3             LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C        4             FAST Z VERTEX HAS BEEN FOUND AND JETCAL CALLED
C        5             INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C        6             ENERGY CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND
C        7             I.D. TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C        8             UNUSED
C        9             MUON ANALYSIS HAS BEEN DONE
C       10             UNUSED
C      100             JUST BEFORE END OF JOB
C
C   ON RETURN, IF INDEX =  1 : THE SUPERVISOR WILL DROP CURRENT EVENT
C                              AND READ THE NEXT ONE.
C                         11 : EVENT WILL BE WRITTEN OUT AND NEW EVENT
C                              WILL BE READ
C                         12 : JOB WILL BE TERMINATED NORMALLY
C
C       PMF: NEW INDEX!   13 : Current event will be written out
C                              and the job will be terminated normally.
C
C                              This additional index makes it easier for MC data
C                              to ensure a correct bookkeeping of the random number
C                              seed corresponding to the LAST EVENT WRITTEN OUT.
C                              This is in particular important if the job
C                              is terminated BEFORE the end of the MC input file.
C                              
C
C   OTHERWISE THE SUPERVISOR WILL GO TO THE LEVEL GIVEN BY "INDEX" ON
C   RETURN FROM "USER". THUS, TO CONTINUE WITH THE ANALYSIS, THE "USER"
C   ROUTINE SHOULD INCREMENT "INDEX" BEFORE PASSING CONTROL BACK HERE.
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL SAFEOF,FLGWRT
C
C                            FORCE INCLUSION OF ERRPRT * JADE BLOCKDATA
C
      EXTERNAL ERRPRT , JADEBD
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C==MACRO CIOUNI=========================================
      COMMON/CIOUNI/IUNIT,JUNIT,NCALI,KUNITA(10),LUNITA(10)
C==ENDMACRO CIOUNI========================================
C
C                        --- MACRO CADMIN ---
C
      LOGICAL*1 LBREAD
C
      COMMON / CADMIN / IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG,IERCAL,
     +                  ISMEAR,IJETCI,NFLAGS(10)
C
C                                 NFLAGS IS AN ARRAY OF GENERAL FLAGS
C                                   (1) : USED BY RDDATE
C                                   (2) : USED BY RDTRIG
C                                   (3) : USED BY RDTRIG
C                                   (4) : USED BY RDTRIG / PRSTAT
C                                   (5) : USED BY EVREAD -COUNTS RECORDS
C                                   (6) : USED BY SUPERV -COUNTS ERRORS
C                                   (7) : USED BY EVWRIT -'HEAD'LESS EVS
C                                   (8) : USED BY EVREAD/RDMTCO (EVWRIT)
C                                   (9) : USED BY RDMTCO/EVWRIT
C                                  (10) : FREE
C
C                                  BLOCK DATA SET IN MEMBER JADEBD
C
C
C
C                            MACRO CBCSMX.... BOS COMMON + SIZE DEFINED
C
C-----------------------------------------------------------------------
C             MACRO CBCSMX.... BOS COMMON + SIZE DEFINITION
C
C             THIS MACRO DEFINES THE IDATA/HDATA/ADATA NAMES AND
C             FIXES THE ACTUAL SIZE OF /BCS/. IT IS THUS IDEAL FOR
C             MAIN PROGRAMS OR THE SUPERVISOR. LDATA CAN BE USED BY BINT
C
C-----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(60000)
      DIMENSION HDATA(120000),ADATA(60000)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1))
      DATA  LDATA / 60000 /
C
C------------------------ END OF MACRO CBCSMX --------------------------
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C
C------------------------------------------
C  MACRO CLBPGM ....
C------------------------------------------
      COMMON /CLBPGM/ LBPGM(30)
C--------- END OF MACRO CLBPGM ------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C
      COMMON / CTLIM / ISECLF
C
      COMMON / CVX   / NNPATR,ICRSTR
C
C                            ICRSTR STEERS RECORD FINDING  IN  COMMANDS
C                            WRIT N, WHERE SEVERAL EVENTS MAY  BE  READ
C                            BY SUPERV, BEFORE THE WANTED ONE  APPEARS.
C                            SPECIAL  CARE  BY   REWINDING   UPON   EOF
C                            ENCOUNTER.
C
      COMMON / CBSTR  / MODE,MAXRL,SAFEOF
      COMMON / CGCALB / NBADCR,NAVALL
C
      COMMON / CHEADR / IHEADR(54)
      COMMON / CALIBR / JPOINT(16)
C
      DIMENSION HCALIB(2) , HEAD(108) , IUSERC(10)
C
      EQUIVALENCE (HCALIB(1),JPOINT(1)) , (HEAD(1),IHEADR(1))
C
      DATA IUSERC / 10*0 /
      DATA IGG/ 0 / , NRUNW/ 0 / , NEVW/ 0 /
C
C------------------  C O D E  ------------------------------------------
C
C                            PRINT SUPERVISOR BANNER HEADLINE
C                            EXCEPT IN GRAPHICS PROGRAM
C
      IF( NDDINN .EQ. 0 ) WRITE(JUSCRN,600)
  600 FORMAT( /1X,33('****')/
     +       ' *',32('    '),'  *'/
     +       ' *',32('    '),'  *'/
     +       ' *',3(8X,'J A D E   S U P E R V I S O R',5X),4X,'*'/
     +       ' *',32('    '),'  *'/
     +       ' *',3(8X,'  V E R S I O N    28/03/88  ',5X),4X,'*'/
     +       ' *',3(8X,'          M O D    31/05/00  ',5X),4X,'*'/
     +       ' *',32('    '),'  *'/
     +       ' *',32('    '),'  *'/
     +         1X,33('****')  //       )
C
C                            CALL ERRSET TO TRANSFER CONTROL  TO  PST'S
C                            ROUTINE "ERRPRT" IN CASE OF IBCOM  ERRORS.
C
***PMF      CALL ERRSET(206,0,0,0,ERRPRT,214)
***PMF      CALL ERRSET(241,0,0,0,ERRPRT,301)
C
C
C                            INITIALISE  BOS.  (IN  GRAPHICS  BINT  HAS
C                            ALREADY BEEN CALLED.)
C
      IF( NDDINN .NE. 0 ) GO TO 80
C       CALL BINT(LDATA,10000,500,4000)
        CALL BINT(LDATA,LDATA,500,4000)
***PMF        CALL DUMP0C
        CALL BWRO(JUNIT,MAXRL,MODE)
C
C                            GET THE BOS POINTERS FOR SOME DATA BANKS
C
  80  IHEAD = IBLN('HEAD')
      IALGL = IBLN('ALGL')
      IALGN = IBLN('ALGN')
      IJETC = IBLN('JETC')
      IZVTX = IBLN('ZVTX')
      IPATR = IBLN('PATR')
      IJHTL = IBLN('JHTL')
      ILGCL = IBLN('LGCL')
C
C                            INITIALISE  PARAMETERS  FOR  LEAD   GLASS,
C                            Z-VERTEX AND PATREC.
C
      CALL LGINIT
      CALL INITZV
      CALL MUINI
      CALL VTXINI
C
      NBADCR = 500
      NAVALL = 20
      FLGWRT = .FALSE.
      ICREC  = 0
      IPFAST = 2
      INDUSR = 0
      CALL USER(INDUSR)
      LASTRN = -1
C
C                ---------------------------------------
C                ------->    MAIN EVENT LOOP    <-------
C                ---------------------------------------
C
C
C                            CHECK CLOCK IF THIS IS A BATCH JOB
C
    1 ITLIM  = 1
      IF( NDDINN .NE. 0 ) GO TO 12
      IF( IUHR(ISECLF) .EQ. 1 ) GO TO 12
      LBIUHR = IUHR(ISECLF)
      IF( LBIUHR .EQ. 1 ) GO TO 12
C
      WRITE(JUSCRN,7701) (ISECLF, ITMESS = 1,10)
7701  FORMAT(10(/'  NUMBER OF SECONDS LEFT AT TIME LIMIT = ',I10) )
      GO TO 100
   12 CONTINUE
      ITLIM = 0
C
C                            IUNIT IS BLOCKDATA SET TO 2. IF GRAPHICS,
C                            USE RUN TIME LUN STORED IN /CADMIN/.
C                            THIS VALUE MAY BE CHANGED DURING SESSION.
C
      IF( NDDINN .NE. 0 ) IUNIT = NDDINN
C
C                            READ  NEXT  EVENT,  HANDLING  MONTE  CARLO
C                            CALIBRATION IF RELEVANT. IRET = 2 ON EOF.
C                            READ ERRORS ARE NOT RETURNED.
C
      CALL EVREAD(IUNIT,IRET)
C
      IF(IRET.EQ.2) GO TO 100
      ICREC = ICREC + 1
C
      CALL EXJHTL(IERJHT)
      IF(IERJHT.NE.0) WRITE(6,7985)
7985  FORMAT(' ERROR IN SUBROUTINE EXJHTL, NO ROOM FOR NEW FORMAT JHTL')
C
      IPHEAD=IDATA(IHEAD)
      IF(IPHEAD.LT.1) GO TO 1002
      CALL MVCL(IHEADR(1),0,IDATA(IPHEAD-3),0,216)
      IPH2=IPHEAD*2
      NRUN=HDATA(IPH2+10)
      IACT=HDATA(IPH2+27)
      IF(NDDINN.NE.0) IACT=0
C
C                            ARE THERE PATR AND JHTL BANKS?
C
      NPBANK = -1
      IPPATR = IDATA(IPATR)
      IF( IPPATR .LE. 0 ) GO TO 102
        NPBANK = IDATA(IPPATR-2)
C
  102 NJBANK = -1
      IPJHTL = IDATA(IJHTL)
      IF( IPJHTL .LE. 0 ) GO TO 103
        NJBANK = IDATA(IPJHTL-2)
C
C                            RECORD IF THERE IS A MONTE CARLO PATR BANK
C
  103 CALL CLOC(MCPATR,'PATR',12)
      INDUSR = 2
C
C                            KALIBR AND INPATC CALLED FOR EVERY EVENT
C
      CALL KALIBR
      CALL INPATC
C
      IF( NRUN .EQ. LASTRN ) GO TO 2
C
C                            NEW OR FIRST RUN.
C
      IF( LASTRN .NE. -1 ) GO TO 110
C
C                            VERY  FIRST   EVENT.   INITIALISE   PATREC
C                            CONSTANTS BY CALL TO INPATR.
C
      CALL INPATR
C
  110 LASTRN = NRUN
      INDUSR = 1
      GO TO 200
C
C                - 2 -       EVENT HAS BEEN READ IN
C
   2  DO  301  KLR = 1,30
        LBPGM(KLR) = 0
  301 CONTINUE
      GO TO 200
C
C                - 3 -       CALL LEADGLASS ENERGY DECODING.
C
    3 IF(IDATA(IALGL) .LE. 0) GO TO 200
      IF(IDATA(IALGN) .EQ. 0) CALL LGCALB(*1225)
      GO TO 200
C
1225  IGG = IGG + 1
      IF(IGG.LT.20) WRITE(6,1222) HDATA(IPH2+10),HDATA(IPH2+11)
1222  FORMAT(' RUN AND EVENT ',2I6,' HAS RETURN1 IN LGCALB')
      GO TO 200
    4 CONTINUE
C
C                - 4 -       JET CHAMBER CALIBRATION AND FAST Z VERTEX
C
C                            CALL I.D. CALIBRATION ROUTINE ONLY IF:
C                            A)    THIS IS NOT MONTE CARLO DATA.
C                            B)    THERE IS NO SECOND "JETC" BANK, WHICH
C                                  WOULD MEAN THAT THE FIRST "JETC" BANK
C                                  IS ALREADY CALIBRATED  ON  THE  INPUT
C                                  DATA SET.
C
      IF( NRUN .LT. 100 ) GO TO 401
      IPNTJT = IDATA(IJETC)
      IF( IPNTJT .LT. 1 ) GO TO 401
      IPNTNX = IDATA(IPNTJT-1)
      IF( IPNTNX .NE. 0 ) GO TO 401
      CALL JETCAL
  401 CONTINUE
C
C                            CALL FAST Z VERTEX FINDING ROUTINE
C
      IF( IDATA(IZVTX) .EQ. 0 ) CALL ZVERTF
      GO TO 200
C
C                - 5 -       DO INNER DETECTOR PATTERN RECOGNITION.
C
    5 IPPATR = IDATA(IPATR)
      IPJHTL = IDATA(IJHTL)
      NRPATR = -1
      IF( IPPATR .EQ. 0 ) GO TO 52
      NRPATR = IDATA(IPPATR-2)
C
   52 NRJHTL = -2
      IF( IPJHTL .EQ. 0 ) GO TO 51
      NRJHTL = IDATA(IPJHTL-2)
C
C                            IF THE LATEST PATR AND JHTL HAVE BEEN
C                            DELETED THEN RE-DO PATTERN RECOGNITION.
C                            IGNORE TEST IF 'PATR' NEVER EXISTED BUT
C                            CONTINUE IF 'PATR' DID BUT 'JHTL' DIDN'T.
C
C                            NPBANK = 'PATR' BANK NO. ON INPUT
C                            NJBANK = 'JTHL' BANK NO. ON INPUT
C                                   = -1 IF NONE EXISTED THEN
C
   51 IF( NPBANK .EQ. -1 ) GO TO 55
      IF( NRPATR .NE. NPBANK  .AND. NRJHTL .NE. NJBANK ) GO TO 53
C
C                            IF THE EVENT  HAS  NOT  BEEN  PROCESSED  BY
C                            REDUC1 AND NO PATR BANK EXISTS (OTHER  THAN
C                            MC) THEN DO PATTERN RECOGNITION
C
   55 IF( NRPATR .LE. 10 .AND. NRPATR .GE. 0 ) GO TO 54
      IF(   IACT .NE.  0 ) GO TO 54
C
   53 CALL BGAR(IGARBA)
      IND = 0
      CALL PATREC(IND)
C
C                            THIRD STAGE IN MC TRACEBACK, SEE JCN 69
C
   54 IF(NRUN.LT.100) CALL MCTR4V(0,IERRMC)
      GO TO 200
C
C                - 6 -       CALL LEAD-GLASS DETECTOR CLUSTER ANALYSIS
C
    6 IF(IDATA(ILGCL).EQ.0) CALL LGANAL
      GO TO 200
C
C                - 7 -       ASSOCIATE INNER DETECTOR TRACKS WITH
C                            CLUSTERS.
C
    7 IPPATR = IDATA(IPATR)
      IF(IPPATR.EQ.0) GO TO 200
      IPALGN = IDATA(IALGN)
      IF(IPALGN.EQ.0) GO TO 200
C
      IPLGCL = IDATA(ILGCL)
      IF(IPLGCL.EQ.0) GO TO 200
      CALL LGCDIR(IPPATR,IPALGN,IPLGCL)
      GO TO 200
C
C                - 8 -       UNUSED
C
    8 CONTINUE
      GO TO 200
C
C                - 9 -       MUON DETECTOR ANALYSIS
C
    9 CALL CLOC(MUR1,'MUR1',0)
      CALL CLOC(MUR2,'MUR2',0)
C
C                            IF 'MUR1'/0 OR 'MUR2'/0 ARE MISSING
C                            DELETE ALL 'MUR1' * 'MUR2' BANKS.
C                            OTHERWISE SKIP THE ANALYSIS.
C
      IF( MUR1 .GT. 0  .AND. MUR2 .GT. 0 ) GO TO 200
      CALL BMLT(2,'MUR1MUR2')
      CALL BDLM
C
C                            CALL FOR MUON ANALYSIS. IF NO 'PATR' BANK,
C                            SET FLAG TO PREVENT PHILOSOPHY 2 ANALYSIS.
C
      IMUARG = 1
      IF(IDATA(IPATR).LT.1) IMUARG = 0
      CALL MUANA(IMUARG)
      GO TO 200
C
C               - 10 -       UNUSED
C
   10 CONTINUE
      GO TO 200
C
C               - 11 -       EVENT HAS BEEN ACCEPTED. WRITE IT OUT.
C
   11 CONTINUE
C
C                            SKIP THIS LEVEL IN GRAPHICS UNLESS WRIT
C                            COMMAND HAS ALREADY BEEN GIVEN
C
      IF(   NDDINN .NE. 0  .AND.  NDDOUT .EQ. 0 ) GO TO 1
2172  IF( SAFEOF  .AND.  NRWRIT .GT. 0 ) CALL OPUNIT(JUNIT)
      NRUNW = HEAD(18)
      NEVW  = HEAD(19)
C
C                            PRINT A WARNING IF THE MC PATR BANK THAT
C                            WAS READ IN IS NO LONGER PRESENT
C
      CALL CLOC(MCPAT2,'PATR',12)
      IF( MCPATR .EQ. 0 .OR. MCPAT2 .NE. 0 ) GO TO 111
        NFLAGS(6) = NFLAGS(6) + 1
        IF( NFLAGS(6) .LE. 10 ) WRITE(JUSCRN,112) ICREC
  112   FORMAT(/' ****  WARNING  ****  IN SUPERV FOR EVENT ',I6,
     +          '.   THE M.C. ''PATR''/12 BANK HAS',
     +          ' BEEN DELETED OR RENAMED OR RENUMBERED. IRREGULAR!'/)
C
C
C                            EVWRIT HANDLES MC CALIBRATION IF PRESENT
C                            AS WELL AS EVENTS.
C
  111 CALL EVWRIT(JUNIT)
C
      FLGWRT=.TRUE.
      IF( SAFEOF ) END FILE JUNIT
      IF( SAFEOF ) WRITE(JUSCRN,190) JUNIT
  190 FORMAT(' SUPERV HAS CALLED EVWRIT OF',I4,' AND EOFED THE FILE.')
C
      IF(SAFEOF) CALL SAFCHK(JUNIT)
      IF( INDUSR.EQ.13 ) GO TO 201 ! PMF 31/05/00: Introduce this branching according to INDUSR=13
      IF(NDDOUT.EQ.0) GO TO 1
      IF(ICREC.LT.ICRSTR) GO TO 1
C
      WRITE(6,2471)
2471  FORMAT(' NOW REWINDING INPUT FILE...')
      REWIND NDDINN
      ICREC = 0
      CALL BDLS('+BUF',NDDINN)
      IF( INDUSR.EQ.13 ) GO TO 201 ! PMF 31/05/00: Introduce this branching according to INDUSR=13
      GO TO 1
C
C                            PASS CONTROL TO THE USER-SUPPLIED  ROUTINE
C                            "USER" WITH THE CURRENT INDEX.
C
  200 IF((INDUSR.GE.1).AND.(INDUSR.LE.10))
     +                      IUSERC(INDUSR)=IUSERC(INDUSR)+1
C
      CALL USER(INDUSR)
C
C                            LOOPING OR RUNNING OUT OF TIME?
C
      IF( NDDINN .NE.  0 ) GO TO 203
      NTIMLF = NTIME(DUMMY)
      IF( NTIMLF .GT. 20 ) GO TO 203
        WRITE(JUSCRN,202) INDUSR,ICREC
  202   FORMAT(/' ****  INTERRUPT  ****  LESS THAN 0.2 SECONDS LEFT',
     +          ' IN SUPERV AT LEVEL ',I3,' FOR EVENT ',I6//
     +          ' MAYBE THE ''USER'' PROGRAM IS IN A LOOP ?  ',
     +          ' RECOVERY ACTION: SUPERV WILL JUMP TO LEVEL 100'//)
        GO TO 100
C
  203 GO TO (1,2,3,4,5,6,7,8,9,10,11,201,11),INDUSR !PMF 31/05/00: Introduce INDUSR=13
      CALL MESSAG(3)
      GO TO 201
C
C                            NO 'HEAD' BANK IN INPUT EVENT.
C
 1002 CALL MESSAG(4)
      GO TO 1
C
  100 CONTINUE
      IF(NDDINN.EQ.0) GO TO 201
      WRITE(6,2471)
      REWIND NDDINN
      ICREC = 0
      ICRSTR = 1
      CALL BDLS('+BUF',NDDINN)
      GO TO 1
  201 CONTINUE
      IF(.NOT.FLGWRT) GO TO 199
      IF(MODE.EQ.0) GO TO 199
C
C                            WRITE OUT LAST BLOCK(S) ONTO  OUTPUT  FILE
C                            IN BOSM CASE.
C
      CALL BMLT(0,DUMMY)
      CALL BWRITE(JUNIT)
C
  199 IF( ITLIM .EQ. 0 ) GO TO 294
        WRITE(JUSCRN,196)
  196   FORMAT(2(/'  ***** WARNING! TIME LIMIT REACHED. ***** ')//)
C
        WRITE(JUSCRN,197) HDATA(IPH2+10),HDATA(IPH2+11)
  197   FORMAT(' JOB STOPPED BY TIME LIMIT AFTER RUN',I8,' EVENT',I10)
C
        WRITE(JUSCRN,209) NRREAD,NRWRIT,NRERR
 209    FORMAT(//' TIMEOUT !!!',
     $   '   NR OF EVENTS READ: ',I6,'   NR OF EVENTS WRITTEN: ',I6,
     $   '   NR OF READ ERRORS ',I3,//)
        GO TO 295
C
 294    WRITE(JUSCRN,198) NRREAD,NRWRIT,NRERR
 198    FORMAT(//' ===  END OF DATA READING  ==='//
     $           ' NR OF EVENTS READ:',I6,'   NR OF EVENTS WRITTEN:',
     $      I6,'   NR OF READ ERRORS ',I2,//)
C
 295  IF(NEVW.GT.0) WRITE(JUSCRN,298) NRUNW,NEVW
 298  FORMAT(' LAST EVENT WRITTEN (RUN,EVENT): ',2I8)
C
      IF(IERCAL.NE.0) WRITE(6,2641) IERCAL
2641  FORMAT('  **** WARNING ------>>>',I6,' CALIBRATION ERRORS ENCOUNTE
     $RED. PLEASE CONTACT P.STEFFEN OR J.OLSSON !',//)
C
      WRITE(JUSCRN,194)
  194 FORMAT(' NUMBER OF CALLS TO USER FOR EACH INDEX VALUE:'/)
      DO  193  IU = 1,10
        WRITE(JUSCRN,195) IU,IUSERC(IU)
  195   FORMAT(1X,I6,I12)
  193 CONTINUE
C                            PRINT MUON STATISTICS
      CALL MUFINI
C                            FINAL CALL TO "USER"
      INDUSR = 100
      CALL USER(INDUSR)
C
      END

C   12/05/80 211031454  MEMBER NAME  WALLOK   (JADEGS)      FORTRAN
      SUBROUTINE WALLOK
      IMPLICIT INTEGER*2 (H)
C---
C---   ALLOCATE OUTPUT DATA SET IN GRAPHICS, JADE ROUTINE
C---
      COMMON/CBSTR/MODE,MAXRL
#include "cgraph.for"
#include "ciouni.for"
      REAL*8 DDN
      COMMON/CSVCW1/NDDSVE,NRWR
      COMMON/CWALLK/IOUTSV(11)
      DIMENSION IDATAL(11),HVOLSR(4)
      DATA ICONT /'CONT'/
      DATA HBLANK/'  '/
C---
C---     LAST CHANGE 3.11.82   J.OLSSON
C---
    1 CONTINUE
      CALL TRMOUT(80,'PLEASE ENTER FULL NAME OF CATALOGUED DATA SET FOR
     $OUTPUT EVENTS:^')
      CALL TRMIN(44,IDATAL)
C---
C---     TEST FOR THE STRING CONTINUE.
C---
      IF(IDATAL(1).NE.ICONT) GO TO 9
      NDDOUT = 0
      GO TO 200
C---
C---     ALLOCATE FORTRAN REFERENCE NUMBER TO OUTPUT DATA SET.
C---
9     CONTINUE
      DO 111  I = 1,11
111   IOUTSV(I) = IDATAL(I)
   16 CONTINUE
      DO 3 I=1,4
    3 HVOLSR(I)=HBLANK
      NDDOUT=0
      CALL TRMOUT(80,'THE DATA SET WILL NOW BE ALLOCATED, PLEASE WAIT A
     $LITTLE...^')
      CALL GETPDD(IDATAL,HVOLSR,DDN,NDDOUT,HERR)
      IF(HERR.EQ.0) GO TO 5
C---
C---     ERROR HAS OCCURRED ON ALLOCATION.
C---
      CALL TRMOUT(80,'THE NAME IS INCORRECT OR HMS/MSS IS JAMMED.^')
44    CALL TRMOUT(80,'PLEASE TRY AGAIN OR CONTINUE SESSION BY "CONTINUE"
     $.^')
      GO TO 1
C---
C---     SUCCESSFULLY ALLOCATED DATA SET. NOW COUNT THE RECORDS
C---     AND LOAD THE FORTRAN REFERENCE NUMBER AND NUMBER OF RECORDS
C---     INTO THE TRANSFER COMMON FOR THE USE OF OTHER ROUTINES.
C---
    5 JUNIT = NDDOUT
      CALL TRMOUT(80,' OUTPUT DATA SET ALLOCATED.^')
      CALL TRMOUT(80,
     $'DO YOU WANT TO OVERWRITE THE RECORDS ON THIS DS?^')
      CALL TRMOUT(80,'IF NOT YOU WILL ADD RECORDS TO THE EXISTING DS.^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 12
      CALL TRMOUT(80,' THIS OPTION IS PRESENTLY NOT WORKING, UNFORTUNATE
     $LY^')
      CALL TRMOUT(80,' DO YOU WISH ANOTHER OUTPUT FILE? IF NOT, YOU WILL
     $OVERWRITE THIS ONE.^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 1
C     CALL TRMOUT(80,
C    $'IF YOU CHOOSE TO ADD EVENTS TO THE EXISTING ONES,^')
C     CALL TRMOUT(80,
C    $'THEN THE CURRENT EVENT WILL NOT BE WRITTEN. IS THIS OK?^')
C     CALL DECIDE(IANSW)
C     IF(IANSW.EQ.2) GO TO 12
C     CALL GNUREC(NDDOUT,NUMEVN,NUMREC)
C     NRWR = NUMEVN
C     WRITE(JUSCRN,101) NUMEVN,NUMREC
C 101 FORMAT(' DATA SET HAS NUMBER OF EVENTS, NUMBER OF RECORDS = ',2I4)
C     CALL TRMOUT(80,'EVENTS WILL BE ADDED TO THE ALREADY EXISTING ONES.
C    $^')
C     CALL STWADD(NDDOUT,&4)
C     GO TO 100
C4     CALL TRMOUT(80,'THE DATA SET GIVES READ ERROR OR IS EMPTY.^')
C      GO TO 44
C100   CALL BWRO(JUNIT,MAXRL,MODE)
12    CALL TRMOUT(80,'EVENTS WILL BE OVERWRITTEN. BOS S FORMAT IS DEFAUL
     $T.^')
      MODE = 0
      MAXRL = 33000
      NRWR = 0
      CALL BWRO(JUNIT,MAXRL,MODE)
200   CONTINUE
      RETURN
      END

C   08/12/80 201131512  MEMBER NAME  INPATR8  (JADESR)      FORTRAN
      SUBROUTINE INPATR
C
C----------------------------------------------------------------------
C   INITIALISATION OF PATTERN RECOGNITION PROGRAM LIMITS AND TOLERANCES
C   AUTHORED BY A VARIETY OF PEOPLE.
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
#include "cpatlm.for"
#include "cgraph.for"
C
C--------------------------------------------------------------------
C
C       IPFAST = 2 MEANS SLOWEST, MOST EFFICIENT VERSION
C                    OF PATTERN RECOGNITION
C
C       IPFAST = 1 MEANS INTERMEDIATE VERSION OF PATTERN RECOGNITION
C
C       IPFAST = 0 MEANS FASTEST VERSION OF PATTERN RECOGNITION
C
C--------------------------------------------------------------------
C
        IF(IPFAST.NE.0.AND.IPFAST.NE.2.AND.IPFAST.NE.1)
     %  WRITE(6,256) IPFAST
  256  FORMAT('0 @@@@@@@ ERROR IN INPATR INITIALIZATION , IPFAST=',I10,
     *'  IPFAST SET TO 2')
        IF(IPFAST.NE.0.AND.IPFAST.NE.2.AND.IPFAST.NE.1) IPFAST=2
C
C
C
C---------------------------------------------------------------------
C INTERMEDIATE PATREC .. IPFAST=1
C ===================
C
C---------------------------------------------------------------------
C
C-----------------------------
C     INITIALISE PATREC LIMITS
C-----------------------------
C
C     MIN. NUMBER OF HITS IN A CELL
      LMPATR(1) = 8
C
C     WEIGHT OF ORIGIN IN FINAL R-FI-FIT
      PATRLM(2) = 0.00
C
C     LENGTH OF ARRAY WRK IN /CWORK/
      LMPATR(5) = 6000
      LMPATR(5) = 7000
C
C-----------------------------
C     INITIALISE FLINEL LIMITS
C-----------------------------
C
C     LIMIT FOR DEF. OF CLOSE HITS
      FLINLM(1) = 10.
C
C     LIMIT FOR SLOPE AGREEMENT
      FLINLM(2) = 3.0
C-----------------------------
C     INITIALISE FTRKEL LIMITS
C-----------------------------
C
C     STAGGERING (*4)
      TRELLM( 1) = 2.40
C
C     LIMIT ON DEV. FROM STAGGERING  (*4)
      TRELLM( 2) = 2.50
C
C     MAX (STAGG.DIST. * (-1)**ILAY)
      TRELLM( 3) = .20
C
C     MAX. RMS OF GOOD TREL: SIG0 = (4)+(5)*CURV
      TRELLM( 4) = 0.35
      TRELLM( 5) = 0.15
C
C     MAX.# OF REJECTED HITS BEFORE CUT OF TREL
      LMTREL( 6) =   2
C
C     MIN. |SIGL-SIGR| FOR L/R DET.
      TRELLM( 7) = 0.10
C
C     SPECIAL LIMIT FOR STRAIGHT TRACKS AT ZERO
      TRELLM( 8) = 4.0
C
C     LIMIT OF CURV/2 FOR FIT OF 4-5-HIT TREL
      TRELLM( 9) = .05
C
C     LIMITS FOR ZERO APPROACHING TREL
      TRELLM(10) = 1.0
      TRELLM(11) = .10
      TRELLM(12) = 1000000.
C
C     LIMITS FOR # OF HITS / TREL
      LMTREL(13) = 4
C
C     SIGMA OF GOOD FIT
      TRELLM(14) = .24
C
C     MIN. DISTANEC OF 'ZERO APPROACHING TREL'
      TRELLM(15) = 1.0
C
C     LIMIT OF SIGMA FOR TREL-FIT
      TRELLM(16) = 0.25
C
C     LIMIT OF SIGMA FOR TREL-FIT *(# OF END POINTS AT WALL)
      TRELLM(17) = 0.35
C
C     LIMIT OF SIGMA FOR TREL-FIT *(# OF ENDPOINTS AT WIREPLANE)
      TRELLM(18) = 0.15
C
C     L/R DETERMINED IF |SIGL**2-SIGR**2|<LIMIT
      TRELLM(19) = 0.10
C
C     NOT YET USED
      TRELLM(20) = 0.0
11111 CONTINUE
C-----------------------------
C     INITIALISE BACKTR LIMITS
C-----------------------------
C
C     OVERLAP OF HITS FOR JOIN OF TRACKELS IN CELL
      IBKK(1)=1
C
C     GAP IN HITS FOR JOIN OF TRACKELS IN ONE CELL
      IBKK(2)=2
C
C     IF THE LAST WIRE HIT IS LESS THAN IBKK(3) OR FIRST
      IBKK(4)=3
C
C     WIRE GREATER THAN IBKK(4) A CHECK IS MADE TO SEE WHETHER
C     THE TRACK PASSES THROUGH THE CELL SIDEWALL
      IBKK(3)=12
C
C     FOR JOINING OF TWO TRACKELS IN ONE CELL AND FOR THE TRACKELS
C     TO BE CONSIDERED ON OPPOSITE SIDES OF THE WIRE PLANE:
C     THE SLOPES MUST BE CORRECT,CROSSING FLAGS CORRECT AND
C     DS1 OR DS2  .LT.BKK(5)
      BKK(5)=15.
C
C     OVERLAP OR GAP IN HITS FOR CONNECTION THROUGH
C     CELL SIDEWALL
      IBKK(6)=2
C
C     MIN OF FIRST WIRE HIT TO TRY CONNECTION WITHIN CELL
      IBKK(8)=3
C
C     DRIFT TIME TOLERANCE FOR MATCHING
C     TRACKELS WITHIN A CELL
      BKK(9)=5.
C
C     DIFFERENCE IN THE ABS VALUES OF THE SLOPES FOR A
C     CONNECTION SKIPPING RING TWO
      BKK(10)=0.
C
C     UPPER LIMIT FOR THE VALUE OF THE SLOPE FOR EACH
C     TRACKEL TO TRY A CONNECTION SKIPPING RING TWO
      BKK(11)=0.0
C
C     BKK(12) MULTIPLIES SLOPE FOR SLOPE COMPARISON
C     IN CONNECTION THROUGH CELL SIDEWALL
      BKK(12)=1.
C
C     BKK(13) IS CONSTANT TERM FOR SLOPE COMPARISON
C     FOR CONNECTION THROUGH CELL SIDEWALL
      BKK(13)=.07
C
C     BKK(14) MULTIPLIES SLOPE FOR SLOPE COMPARISON
C     FOR CONNECTION OF TRACKELS IN ONE CELL
      BKK(14)=.02
C
C     BKK(15) IS CONSTANT TERM FOR SLOPE COMPARISON
C     FOR CONNECTION OF TRACKELS IN ONE CELL
      BKK(15)=.05
C
C     IBKK(16) NE 0 FORCES FIT BEFORE CONNECTION WITHIN CELL
      IBKK(16)=1
C
C     IBKK(17) NE 0 FORCES FIT BEFORE SIDE CONNECTION
      IBKK(17)=0
C
C     IBKK(18) NE 0 FORCES FIT BEFORE RING CONNECTION
      IBKK(18)=1
C
C     IBKK(19) IS MIN NO OF HITS FOR BACKTR
C     TO BE FORCED(BY IBKK(20) BEING NE 0) TO
C     USE L-R AMBIGUITY FROM WIRE STAGGERING
      IBKK(19)=7
C
C     IBKK(20) NE 0 FORCES BACKTR TO USE THE L-R
C     AMBIGUITY FROM WIRE STAGGERING
      IBKK(20)=1
C
C     THE XBKK ARRAY IS FOR MATCHING BETWEEN RINGS IN BACKTRACE
C     IT IS ARRANGED IN 4 GROUPS OF 8 NUMBERS
C     THE FOUR GROUPS ARE THE TOLERANCES FOR :
C         XBKK(1)-(8) : DRIFT TIME MATCHING BETWEEN RINGS
C         XBKK(9)-(16) : CONSTANT THAT MULTIPLIES SLOPE FOR
C                        SLOPE COMPARISON
C         XBKK(17)-(24) : ADDITIVE CONSTANT FOR SLOPE COMPARISON
C         XBKK(25)-(32) : CONSTANT FOR DETERMING WHETHER
C                         TRACK CROSSES WIRE PLANE AS IT
C                         GOES FROM RING TO RING
C
C       WHITHIN EACH GROUP OF 8 THE FIRST 4 NUMBERS
C       REFER TO RING TO RING CONNECTION (ALWAYS WITHIN ONE SECTOR)
C       AND THE SECOND 4 REFER TO 'CORNER' CONNECTIONS (CROSSING
C       FROM ONE SECTOR TO ANOTHER)
C
C       EACH OF THESE GROUP OF 4 NUMBERS IS FURTHER DIVIDED INTO
C       2 GROUPS OF 2
C       THE FIRST GROUP IS USED FOR THE FIRST BACKTRACE PASS
C       AND THE SECOND GROUP OF TOLERANCES FOR THE SECOND PASS
C       WITH INCREASED TOLERANCES
C
C       FINALLY, THE 2 TOLERANCES IN THE SMALLEST SUB-SECTION:
C       THE FIRST IS FOR 'NORMAL' TRACK CONNECTIONS
C       THE SECOND IS FOR CONNECTIONS WHERE AT LEAST ONE TRACKEL
C       IS SHORT (LT 8 HITS)
C
C
      XBKK(1)=1.
      XBKK(2)=1.
      XBKK(3)=3.
      XBKK(4)=4.
      XBKK(5)=1.
      XBKK(6)=1.
      XBKK(7)=3.
      XBKK(8)=4.
      XBKK(9)=.01
      XBKK(10)=.02
      XBKK(11)=.03
      XBKK(12)=.04
      XBKK(13)=.01
      XBKK(14)=.02
      XBKK(15)=.03
      XBKK(16)=.04
      XBKK(17)=.04
      XBKK(18)=.04
      XBKK(19)=.1
      XBKK(20)=.1
      XBKK(21)=.04
      XBKK(22)=.04
      XBKK(23)=.1
      XBKK(24)=.1
      XBKK(25)=1.
      XBKK(26)=2.
      XBKK(27)=5.
      XBKK(28)=10.
      XBKK(29)=3.
      XBKK(30)=6.
      XBKK(31)=6.
      XBKK(32)=10.
C
C  IYBKK(1) NE 0 FORCES FIT BEFORE SKIP-RING CONNECTION
      IYBKK(1)=0
C
C   LIMITS FOR FIT WITHIN BACKTRACE
C   YBKK(2) GIVES UPPER LIMIT FOR RMS FOR WHOLE TRACK
C    FOR CONNECTION WITHIN CELL
      YBKK(2)=.5
C
C   YBKK(3) GIVES UPPER LIMIT FOR RESIDUAL/PT FOR CANDIDATE TRACK
C    ELEMENT  FOR CONNECTION WITHIN CELL
      YBKK(3)=.5
C
C   YBKK(4) GIVES UPPER LIMIT FOR RMS FOR WHOLE TRACK
C    FOR RING CONNECTION
      YBKK(4)=.5
C
C   YBKK(5) GIVES UPPER LIMIT FOR RESIDUAL/PT FOR CANDIDATE TRACK
C    ELEMENT  FOR RING CONNECTION
      YBKK(5)=.5
C
C   YBKK(6) GIVES UPPER LIMIT FOR RMS FOR WHOLE TRACK
C    FOR SIDE CONNECTION
      YBKK(6)=5.
C
C   YBKK(7) GIVES UPPER LIMIT FOR RESIDUAL/PT FOR CANDIDATE TRACK
C    ELEMENT  FOR SIDE CONNECTION
      YBKK(7)=5.
C
C   YBKK(8) GIVES UPPER LIMIT FOR RMS FOR WHOLE TRACK
C    FOR SKIP-RING CONNECTION
      YBKK(8)=0.
22222 CONTINUE
C
C
C---------------------------------------
C     INITIALIZATION OF BAKPAK LIMITS
C---------------------------------------
C
C     IBKK(7) IS LAYER GAP FOR BAKPAK TO TRY CONNECTION
      IBKK(7) = 4
C
C     XBKK(33) IS RMS LIMIT FOR FIRST PASS IN BAKPAK
      XBKK(33)=.5
C
C
C     XBKK(34) IS RMS LIMIT FOR SECOND PASS IN BAKPAK
      XBKK(34)=1.
C
C   IYBKK(11) NE 0 CAUSES BAKPAK TO BE CALLED FOR FIRST PASS
       IYBKK(11)=0
C
C   IYBKK(15) NE 0 CAUSES BAKPAK TO BE CALLED FOR SECOND PASS
       IYBKK(15)=1
C
C    IYBKK(10) IS DIF BETWEEN EXPECTED CELL AND ACTUAL
C       CELL TO ATTEMPT CONNECTION IN BAKPAK
        IYBKK(10)=1
C
C     IXBKK(35).NE. 0 MEANS PATROL IS CALLED INSIDE BAKPAK
      IXBKK(35)=0
C
C     IYBKK(9) IS MIN NO OF HITS FOR PATROL TO FIND
C        TO MAKE SKIP RING CONNECTION IN BAKPAK
      IYBKK(9)=6
C
C     IYBKK(16) IS MIN NO OF HITS FOR PATROL TO FIND
C        TO MAKE SKIP RING CONNECTION IN BAKPAK
C       WITH WALL CROSSING IN RING 2
      IYBKK(16)=5
33333 CONTINUE
C
C
C---------------------------------------
C     INITIALIZATION OF XYFIT LIMITS
C---------------------------------------
C
C     XYFIT CONTROL WORD (VIA BIT STRUCTURE)
C     BIT ON MEANS :
C     BIT 31 .. MAKE A SINGLE FIT TO THE HITS AND STOP
C     BIT 30 .. NEVER PERFORM A CIRCLE FIT
C     BIT 29 .. RECALCULATE ABERRATIONS AND MAKE ONE MORE FIT
C     BIT 28 .. STORE TRACK ELEMENT CHI**2'S WHEN BIT 31 SET
C     BIT 27 .. STOP TRYING TO REJECT WORST TRACK ELEMENT
C     BIT 26 .. NEVER CHECK L/R SOLUTION WITH FIT
C     BIT 25 .. NOT USED
      IXYF(1) = 1
C
C     GOOD TRACK FIT CHI**2 CUT    CUT = (2) + (L/R) * (3)
      XYF(2) = 0.6
      XYF(3) = 0 0
C
C     HIT RESIDUAL CUTS            CUT = (4) + (L/R) * (5)
      XYF(4) = 3.0
      XYF(5) = 0.0
C
C     CIRCLE FIT NEVER MADE WHEN CURVATURE LESS THAN XYF(6)
C     MOM=0.03*H*RAD (MMS,KG,MEV/C)
      XYF(6) = 3.0E-4
C
C     MINIMUM SIGNIFICANT FRACTIONAL CHANGE IN CHI**2 REQUIRED TO
C     UNAMBIGUOUSLY DETERMINE LEFT/RIGHT SOLUTION
      XYF(7) = 0.2
C
C     CIRCLE FIT ITERATION LIMIT ON FRACTIONAL RADIUS ADJUSTMENT
      XYF(8) = 0.05
C
C     SPARE
      IXYF(9) = 0
C
C     CIRCLE FIT NEVER MADE WHEN PARABOLA FIT CHI**2 EXCEEDS XYF(10)
      XYF(10) = 10.0
C
C     LIMIT ON NUMBER OF LINES OF ERROR PRINT FROM FXYZ/XYFIT/PATROL
      IXYF(11) = 200
C
C     SPARE
      IXYF(15) = 0
C     SPARE
      IXYF(16) = 0
C     SPARE
      IXYF(17) = 0
C     Z-AMPLITUDE DOUBLE HIT RESOLUTION
      IXYF(18) = 0
C     PRINT FLAG (FXYZ)
      IXYF(19) = 0
C     PRINT FLAG (XYFIT)
      IXYF(20) = 0
44444 CONTINUE
C---------------------------------------
C     INITIALIZATION OF PATROL TOLERANCES
C---------------------------------------
C
C     PATROL CONTROL WORD
C     BIT 31 .. NEVER CALL A RE-FIT AFTER FINDING EXTRA HITS
C     BIT 30 .. ONLY SEARCH RINGS "WITHOUT" HITS ON THIS TRACK
C     BIT 29 .. IGNORE ALL HITS THAT "ARE" ON TRACK ELEMENTS
C     BIT 28 .. ONLY SEARCH RINGS "WITH" HITS ALREADY ON THIS TRACK
C     BIT 27 .. SPARE
C     BIT 26 .. SPARE
C     BIT 25 .. IGNORE ALL HITS THAT "ARE NOT" ON TRACK ELEMENTS
      IGFP(1) = 0
C
C     RMS OF FIT AT WHICH PATROL NOT RUN.
      GFP(2) = 3.
C
C     DOUBLE HIT RESOLUTION .. DONT LOOK FOR MORE HITS CLOSER THAN THIS
      GFP(3) = 4.5
C
C     HIT RESIDUAL CUTS            CUT = (4) + (L/R) * (5)
      GFP(4) = 2.9
      GFP(5) = 0.0
C
C     MAXIMUM # OF SUCCESSIVE FRUITLESS LAYERS ALLOWED IN NEW RING
      IGFP(6) = 3
C
C     MAXIMUM RADIAL GAP ON EXTRAPOLATION
       GFP(7) = 50.0
C
C     DELTA(R) TO DEFINE CONSECUTIVE HITS
       GFP(8) = 15.0
C
C     MINIMUM # OF CONSECUTIVE HITS REQUIRED ON EXTRAPOLATION
      IGFP(9) = 2
C
C     NO. NEW HITS FOUND BEFORE RE-FIT CALLED
      IGFP(10) = 3
C
C     WALL CROSSING LIMIT
      GFP(11) = 0.8
C
C     EXTRA HOLE SIZE ALLOWED ON GFP(7) WHEN CROSSING RING GAP
      GFP(12) = 50.0
C     MAXIMUM NUMBER OF RE-FITS
      IGFP(13) = 10
C
C     CURVATURE ABOVE WHICH PATROL NOT CALLED
      GFP(14) = 1.0E-2
C
C     ITERATION LIMIT ON CONVERTING PARABOLA TO CIRCLE
      GFP(15) = 0.05
C     SPARE
      IGFP(16) = 0
C     SPARE
      IGFP(17) = 0
C     SPARE
      IGFP(18) = 0
C     SPARE
      IGFP(19) = 0
C     PRINT FLAG
      IGFP(20) = 0
55555 CONTINUE
C----------------------------
C     INITIALISE ZRFIT LIMITS
C----------------------------
C
C     LIMIT FOR RMS OF FIT
      ZFITLM( 1) =   50.
C
C     SIGMA OF Z
      ZFITLM( 2) =   20.
C
C     LIMIT FOR HITS PER SEGMENT
      LMZFIT( 3) = 6
C
C     LIMIT FOR # OF SEGMENTS
      LMZFIT( 4) = 2
C
C     LIMIT FOR # OF SEGMENTS
      ZFITLM( 5) = .05
C
C     LIMIT FOR DELTA(R) FOR VERTEX DET.
      ZFITLM( 6) =   50.
C
C     LABEL FOR HIT SELECTION PREPROCESSOR
      LMZFIT(10) = 2
C
C--------------------------------------------
C     INITIALISATION OF ADMINISTRATION LIMITS
C--------------------------------------------
C
C     INITIALIZATION OF IMCERT
C     1 = NO DELETION OF COVERED + SHORT TRACKS
C     0 = DELETION OF COVERED + SHORT TRACKS
      IMCERT=0
C
C     IXBKK(40) NE 0 MEANS KNTREL ITERATES WITH
C     UPDATED BACKTR ARRAYS
      IXBKK(40)=0
C
C     IXBKK(39) GIVES MAX NO OF ALLOWED ITERATIONS
      IXBKK(39)=2
C
C     IXBKK(38) NE 0 CAUSES PRINT IN KNTREL
C     BIT 31 ON - MIN PRINT
C     BIT 30 ON - HIT LABEL IN CWORK
C     BIT 29 ON - HIT LABEL IN CDATA
C     BIT 28 ON - PCWORK PRINT
C     BIT 26 ON - BAKPAK PRINT
      IXBKK(38)=0
C
C     IXBKK(37) IS MIN NO OF UNUSED HITS LEFT ON A TRACKEL
C     FOR IT TO BE BROUGHT BACK AS A SEPARATE TRACK
      IXBKK(37)=5
C
C     IXBKK(36) IS MAX NO OF HITS LEFT UNCORRELATED
C     BEFORE TRACKEL IS ASSIGNED TO TRACK
      IXBKK(36)=1
C
C     IYBKK(14) .NE. 0  CAUSES BACKGROUND TRACKS TO BE DELETED
        IYBKK(14)=1
C
C     YBKK(12) IS LOWER LIMIT ON CURVATURE FOR DEFINITION
C      OF BACKGROUND TRACK
       YBKK(12)=.003
C
C      YBKK(13) IS UPPER LIMIT ON COS OF ANGLE THAT THE SARTPOINT
C      OF THE TRACK MAKES WITH WIRE PLANE TO DEFINE A BACKGROUND TRACK
      YBKK(13)=.9
C
C       YBKK(15) IS INTERSECT OF TRACK WITH BEAM LINE
C        ABOVE WHICH TRACK IS DELETED AS BACKGROUND
         YBKK(15)=100.
C
C    ******* SPECIAL FOR TEST OF ZCHECK **************
      IYBKK(20)=0
C--------------------------------------------------------------------
C
C           END OF  IPFAST = 1  SECTION OF INPATR
C
C--------------------------------------------------------------------
C
        IF(IPFAST.EQ.1) RETURN
        IF(IPFAST.EQ.2) GO TO 102
C
C
C
C
C
C#####################################################################
C FASTEST LEAST EFFICIENT PATREC .. IPFAST=0
C ==============================
C       OVERWRITE SOME LIMITS TO GET FAST VERSION OF PATREC
C#####################################################################
66666 CONTINUE
C
C
C-----------------------------
C     INITIALISE FTRKEL LIMITS
C-----------------------------
C
C     MAX.# OF REJECTED HITS BEFORE CUT OF TREL
      LMTREL( 6) =   1
C
C     LIMIT OF CURV/2 FOR FIT OF 4-5-HIT TREL
      TRELLM( 9) = .005
C
C     LIMITS FOR # OF HITS / TREL
      LMTREL(13) = 6
C
C     SIGMA OF GOOD FIT
      TRELLM(14) = .30
C
C     LIMIT OF SIGMA FOR TREL-FIT
      TRELLM(16) = 0.45
C
C-----------------------------
C     INITIALISE BACKTR LIMITS
C-----------------------------
C
C     IBKK(16) NE 0 FORCES FIT BEFORE CONNECTION WITHIN CELL
      IBKK(16)=0
C
C     IBKK(17) NE 0 FORCES FIT BEFORE SIDE CONNECTION
      IBKK(17)=0
C
C     IBKK(18) NE 0 FORCES FIT BEFORE RING CONNECTION
      IBKK(18)=0
C
C     THE XBKK ARRAY IS FOR MATCHING BETWEEN RINGS IN BACKTRACE
C     IT IS ARRANGED IN 4 GROUPS OF 8 NUMBERS
C     THE FOUR GROUPS ARE THE TOLERANCES FOR :
C         XBKK(1)-(8) : DRIFT TIME MATCHING BETWEEN RINGS
C         XBKK(9)-(16) : CONSTANT THAT MULTIPLIES SLOPE FOR
C                        SLOPE COMPARISON
C         XBKK(17)-(24) : ADDITIVE CONSTANT FOR SLOPE COMPARISON
C         XBKK(25)-(32) : CONSTANT FOR DETERMING WHETHER
C                         TRACK CROSSES WIRE PLANE AS IT
C                         GOES FROM RING TO RING
C
C       WHITHIN EACH GROUP OF 8 THE FIRST 4 NUMBERS
C       REFER TO RING TO RING CONNECTION (ALWAYS WITHIN ONE SECTOR)
C       AND THE SECOND 4 REFER TO 'CORNER' CONNECTIONS (CROSSING
C       FROM ONE SECTOR TO ANOTHER)
C
C       EACH OF THESE GROUP OF 4 NUMBERS IS FURTHER DIVIDED INTO
C       2 GROUPS OF 2
C       THE FIRST GROUP IS USED FOR THE FIRST BACKTRACE PASS
C       AND THE SECOND GROUP OF TOLERANCES FOR THE SECOND PASS
C       WITH INCREASED TOLERANCES
C
C       FINALLY, THE 2 TOLERANCES IN THE SMALLEST SUB-SECTION:
C       THE FIRST IS FOR 'NORMAL' TRACK CONNECTIONS
C       THE SECOND IS FOR CONNECTIONS WHERE AT LEAST ONE TRACKEL
C       IS SHORT (LT 8 HITS)
C
      XBKK(1)=8.
      XBKK(2)=8.
      XBKK(3)=20.
      XBKK(4)=45.
      XBKK(5)=8.
      XBKK(6)=8.
      XBKK(7)=20.
      XBKK(8)=45.
      XBKK(9)=.05
      XBKK(10)=.08
      XBKK(11)=.12
      XBKK(12)=.17
      XBKK(13)=.06
      XBKK(14)=.12
      XBKK(15)=.12
      XBKK(16)=.17
      XBKK(17)=.12
      XBKK(18)=.12
      XBKK(19)=.40
      XBKK(20)=.40
      XBKK(21)=.12
      XBKK(22)=.25
      XBKK(23)=.4
      XBKK(24)=.4
      XBKK(25)=1.
      XBKK(26)=2.
      XBKK(27)=5.
      XBKK(28)=10.
      XBKK(29)=3.
      XBKK(30)=6.
      XBKK(31)=6.
      XBKK(32)=10.
77777 CONTINUE
C
C
C---------------------------------------
C     INITIALIZATION OF BAKPAK LIMITS
C---------------------------------------
C
C   IYBKK(11) NE 0 CAUSES BAKPAK TO BE CALLED FOR FIRST PASS
       IYBKK(11)=0
C
C   IYBKK(15) NE 0 CAUSES BAKPAK TO BE CALLED FOR SECOND PASS
       IYBKK(15)=0
C
C
C
C---------------------------------------
C     INITIALIZATION OF XYFIT LIMITS
C---------------------------------------
C
C
C     1).NO CLEVER HIT DELETION BY FIT
C     2).KILL ALL CIRCLE FITS
      IXYF(1)=3
C---------------------------------------
C     INITIALIZATION OF PATROL LIMITS
C---------------------------------------
C
C     KILL PATROL COMPLETELY
      GFP(2) = 0.
C
C----------------------------
C     INITIALISE ZRFIT LIMITS
C----------------------------
C
C     LABEL FOR HIT SELECTION PREPROCESSOR
      LMZFIT(10) = 2
C
C--------------------------------------------
C     INITIALISATION OF ADMINISTRATION LIMITS
C--------------------------------------------
C
C     INITIALIZATION OF IMCERT
C     1 = NO DELETION OF COVERED + SHORT TRACKS
C     0 = DELETION OF COVERED + SHORT TRACKS
      IMCERT=0
C
C     IXBKK(40) NE 0 MEANS KNTREL ITERATES WITH
C     UPDATED BACKTR ARRAYS
      IXBKK(40)=0
C
C     IXBKK(39) GIVES MAX NO OF ALLOWED ITERATIONS
      IXBKK(39)=0
C
C     IYBKK(14) .NE. 0  CAUSES BACKGROUND TRACKS TO BE DELETED
        IYBKK(14)=0
C
      RETURN
C
C--------------------------------------------------------------------
C           END OF  IPFAST = 0  SECTION OF INPATR
C--------------------------------------------------------------------
C
C
 102   CONTINUE
C
C
C
C
C
C#####################################################################
C SLOWEST BUT BEST VERSION OF PATREC .. IPFAST=2
C ==================================
C       OVERWRITE SOME LIMITS TO GET EFFICIENT VERSION OF PATREC
C#####################################################################
C
C
C---------------------------------------
C     INITIALIZATION OF BAKPAK LIMITS
C---------------------------------------
C
C   IYBKK(11) NE 0 CAUSES BAKPAK TO BE CALLED FOR FIRST PASS
       IYBKK(11)=1
C
C     IXBKK(35).NE. 0 MEANS PATROL IS CALLED INSIDE BAKPAK
      IXBKK(35)=1
C
C
C
C--------------------------------------------
C     INITIALISATION OF ADMINISTRATION LIMITS
C--------------------------------------------
C
C     IXBKK(39) GIVES MAX NO OF ALLOWED ITERATIONS
      IXBKK(39)=5
C
      RETURN
C--------------------------------------------------------------------
C           END OF  IPFAST = 2  SECTION OF INPATR
C--------------------------------------------------------------------
C
      END
      BLOCK DATA
C
      IMPLICIT INTEGER*2 (H)
C
#include "cpatlm.for"
C
       DATA IPFAST/2/
       END

C   14/03/84 403210103  MEMBER NAME  N50SDS   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE N50SDS
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  20/03/84 :  DRAW RESULTS OF NORD 50 PATRCH
C
C
C        THIS ROUTINE IS BASED ON A ROUTINE BY HOWARD MILLS WHICH DRAWS
C        TRACKS FOUND BY THE NORD 50 PATTERN RECOGNITION PROGRAM PATRCH.
C        THE TRACK DATA IS 'PATR' BANK FORMAT IN THE 'IPJC' SUB-BANK OF
C        THE 'N50S' BANK. SEE JADE NOTE 78, TABLE 11.
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL RPVIEW, ZXVIEW
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      DATA BMAX      /   0.0175     /
      DATA GT,GT2    /  30.0,   7.5 /
      DATA XCUT,YLIM / 300.0, 110.0 /
C
C-------------------  C O D E  -----------------------------------------
C
C                            CHECK THAT THERE ARE TRACKS TO DRAW
C
      N50S = IDATA( IBLN( 'N50S' ) )
      N50S = N50S * 2
      IF( N50S .GT. 0 ) GO TO 2
        WRITE(JUSCRN,1)
   1    FORMAT(' NO ''N50S'' BANK AVAILABLE')
        RETURN
C
   2  IPJC = HDATA( N50S + 7 )
      IF( IPJC .GT. 0 ) GO TO 4
        WRITE(JUSCRN,3)
   3    FORMAT(' NO JET CHAMBER SUB-BANK IN ''N50S'' BANK'/
     +         ' MAYBE JET CHAMBER WAS NOT ANALYSED BY NORD 50')
        RETURN
C
   4  NTR  = HDATA( N50S + IPJC + 4 )
      IF( NTR .GE. 0 ) GO TO 6
        WRITE(JUSCRN,5)
   5    FORMAT(' NORD 50 PATTERN RECOGNITION NOT DONE')
        RETURN
C
   6  NT   = HDATA( N50S + IPJC + 5 )
      L0   = HDATA( N50S + IPJC + 6 )
      LT   = HDATA( N50S + IPJC + 7 )
C
      IF( NT .GT. 0 ) GO TO 8
        WRITE(JUSCRN,7)
   7    FORMAT(' NORD 50 PATTERN RECOGNITION FOUND NO TRACKS')
        RETURN
C
   8  JPTR   = N50S + IPJC +L0
      IF( LASTVW .LE. 11 ) GO TO 9
        WRITE(JUSCRN,88)
  88    FORMAT(' NORD 50 TRACK RESULTS DISPLAY NOT POSSIBLE HERE')
        RETURN
C
   9  IERROR = 0
      RPVIEW = LASTVW .LE. 3
      ZXVIEW = LASTVW .GE. 4  .AND.  LASTVW .LE. 7
C
      DO  100  I = 1,NT
C
C                            GET COORDINATES OF 1ST * LAST POINTS IN MM
C
        CALL N50SCO( JPTR, X1, Y1, Z1, X2, Y2, Z2, R )
C
        IF( HDATA(JPTR) .EQ. 0 ) GO TO 11
          IF( IERROR .LT. 3 ) WRITE(JUSCRN,10) HDATA(JPTR), I
   10     FORMAT(' BANK ERROR?  THE ZEROTH HALF-WORD IS ',I10/
     +           ' FOR TRACK ',I3,' IN ''N50S''. SHOULD BE ZERO.'/
     +           ' RECOVERY ACTION: CURRENT TRACK WILL BE SKIPPED')
          IERROR = IERROR + 1
          GO TO 100
C
C                            DRAW STRAIGHT LINES FOR Z VIEWS
C
   11   IF( RPVIEW ) GO TO 50
          X  = Z1
          XE = Z2
C
C                            IS Z-RADIUS TRACK DISPLAY WANTED?
C
          IF( .NOT. DSPDTL(9) ) GO TO 20
            R1 = SQRT( X1**2 + Y1**2 )
            R2 = SQRT( X2**2 + Y2**2 )
C
            IF( ZXVIEW ) GO TO 15
              Y  = SIGN(R1,Y1)
              YE = SIGN(R2,Y2)
              GO TO 18
C
  15          Y  = SIGN(R1,X1)
              YE = SIGN(R2,X2)
C
C                            ENSURE TRACK ENDS ARE NOT IN OPPOSITE
C                            OF THE JET CHAMBER DISPLAY
C
  18        IF( Y/YE .LT. 0.0 ) Y = - Y
            GO TO 30
C
C                            PROJECT MODE
C
  20      IF( ZXVIEW ) GO TO 25
            Y  = Y1
            YE = Y2
            GO TO 30
C
  25        Y  = X1
            YE = X2
C
  30      Z0 = HDATA( JPTR + 13 ) * 0.1
          CALL MOVEA( Z0, 0.0 )
          CALL DASHA( X, Y, 3 )
          CALL DRAWA( XE, YE  )
C
C                            FOR Z VIEWS, FLIP SIGN OF XE AS TRNUMB
C                            ALWAYS FLIPS IT SO THAT R VIEWS ARE RIGHT.
C
          XE = - XE
          GO TO 80
C
C                            R-PHI VIEWS   --> CURVED TRACKS UNLESS
C                                              CURVATURE IS VERY SMALL
C
  50      XE = X2
          YE = Y2
          IF( ABS(R) .LE. 2.0E4 ) GO TO 55
            CALL MOVEA( -X1, Y1 )
            CALL DRAWA( -X2, Y2 )
            GO TO 80
C
C                            CIRCULAR ARCS DRAWING SECTION
C
  55      AL     = SQRT( (X2 - X1)**2 + (Y2 - Y1)**2 ) * 0.5
          XM     = (X2 + X1) * 0.5
          YM     = (Y2 + Y1) * 0.5
          THETA  = ATAN2( Y2 - Y1, X2 - X1 )
          ALP    = SIGN( SQRT(R**2 - AL**2), R )
C
          XC     = XM + ALP * SIN(THETA)
          YC     = YM - ALP * COS(THETA)
          BETA   = 2.0 * ACOS(ALP/R)
          DELTA  = ATAN2( Y1 - YC, X1 - XC )
          NSTEPS = ABS(BETA) / BMAX
          IF( NSTEPS .GT. 1 ) GO TO 60
            CALL MOVEA( -X1, Y1 )
            CALL DRAWA( -X2, Y2 )
            GO TO 80
C
  60      BP     = SIGN( BETA / NSTEPS, R )
          CALL MOVEA( -X1, Y1 )
          DO  70  J = 1,NSTEPS
            DELTA = DELTA - BP
            X     = XC + ABS(R) * COS(DELTA)
            Y     = YC + ABS(R) * SIN(DELTA)
            CALL DRAWA( -X, Y )
  70      CONTINUE
C
C                            TRACK NUMBERS
C                            NOTE THAT TRNUMB ALWAYS FLIPS SIGN OF XE
C
  80    XE   = XE + SIGN( GT2, XE )
        YE   = YE + SIGN( GT2, YE )
        IF( XE .GT. 0.0 ) XE = XE + GT
        IF( YE .LT. 0.0 ) YE = YE - GT
C
        CALL TRNUMB( I, 0, XE, YE, 0.0 )
C
C                            POINT TO NEXT TRACK
C
        JPTR = JPTR + LT
 100  CONTINUE
C
      IF( RPVIEW ) RETURN
        CALL MOVEA(  XCUT,  YLIM )
        CALL DASHA(  XCUT, -YLIM, 3 )
        CALL MOVEA( -XCUT,  YLIM )
        CALL DASHA( -XCUT, -YLIM, 3 )
C
      RETURN
      END

C   07/06/96 606071916  MEMBER NAME  UHIST    (S4)          FORTG1
      SUBROUTINE UHIST(NA,X)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL FAC(5)/0.023,0.1587,0.50,0.8413,0.977/
      CALL BLOC(IND,'HST*',NA,&10)
    2 N=IW(IND+2)
      IF(IW(IND+20).GE.2) GOTO 100
      IF(N.NE.0) GOTO 4
      IW(IND+1)=NA
      RW(IND+7)=X
      RW(IND+8)=X
      RW(IND+19)=X
    4 N=N+1
      IW(IND+2)=N
      RW(IND+7)=AMIN1(RW(IND+7),X)
      RW(IND+8)=AMAX1(RW(IND+8),X)
      XD=X-RW(IND+19)
      RW(IND+17)=RW(IND+17)+XD
      RW(IND+18)=RW(IND+18)+XD*XD
      IF(IW(IND+20).EQ.0) GOTO 6
      K=(X-RW(IND+3))/RW(IND+4)+21
      IF(K.LE.20) K=5
      IF(K.GT.120) K=6
      RW(IND+K)=RW(IND+K)+1.0
      GOTO 100
    6 RW(IND+20+N)=X
      IF(N.LT.100) GOTO 100
      CALL DEFST(IND)
      GOTO 100
   10 CALL BCRE(IND,'HST*',NA,120,&100,IER)
      GOTO 2
C
      ENTRY DHIST(NA,XL,XH)
      CALL BLOC(IND,'HST*',NA,&12)
      GOTO 100
   12 CALL BCRE(IND,'HST*',NA,120,&100,IER)
      IW(IND+1)=NA
      RW(IND+3)=AMIN1(XL,XH)
      ST=ABS(XL-XH)*0.01
      IF(ST.EQ.0.0) ST=.01
      RW(IND+4)=ST
      IW(IND+20)=1
      GOTO 100
C
      ENTRY QHIST(NA,AR)
      REAL AR(115)
      DO 19 I=1,115
   19 AR(I)=0.0
      KND=0
      CALL BLOC(IND,'HST*',NA,&100)
      KND=IND
      CALL DEFST(IND)
      IF(IW(IND+20).GE.2) GOTO 40
C     MEAN AND SIGMA
   20 SN=IW(IND+2)
      IF(SN.EQ.0.0) GOTO 38
      IF(SN.LE.1.0) GOTO 21
      RW(IND+11)=(RW(IND+18)-RW(IND+17)**2/SN)/(SN-1.0)
      RW(IND+11)=SQRT(RW(IND+11))
   21 RW(IND+9)=RW(IND+19)+RW(IND+17)/SN
C     QUANTILES
      I=0
      J=0
      SUM=RW(IND+5)
   22 IF(J.EQ.5) GOTO 36
      J=J+1
      SJ=FAC(J)*SN
      IJ=0
   24 IF(SJ-SUM) 26,32,34
   26 IF(I.EQ.0) GOTO 22
      IF(IJ.EQ.0) GOTO 28
      R=0.5*FLOAT(IJ+I-1)
      GOTO 30
   28 R=FLOAT(I)+(SJ-SUM)/RW(IND+20+I)
   30 RW(IND+11+J)=RW(IND+3)+R*RW(IND+4)
      GOTO 22
   32 IF(IJ.EQ.0) IJ=I
   34 IF(I.EQ.100) GOTO 36
      I=I+1
      SUM=SUM+RW(IND+20+I)
      GOTO 24
   36 RW(IND+10)=RW(IND+14)
      RW(IND+14)=RW(IND+15)
      RW(IND+15)=RW(IND+12)
      RW(IND+12)=0.0
      IF(RW(IND+13)*RW(IND+14).NE.0.0) RW(IND+12)=0.5*(RW(IND+14)-
     1   RW(IND+13))
   38 CONTINUE
      IW(IND+20)=2
   40 DO 50 I=1,100
   50 AR(I)=RW(IND+20+I)
      DO 60 I=1,15
   60 AR(100+I)=RW(IND+1+I)
      AR(101)=IW(IND+2)
      AR(104)=IW(IND+5)
      AR(105)=IW(IND+6)
  100 RETURN
      END

C   27/04/79 C9042701   MEMBER NAME  MUREGS   (S)           FORTRAN
C ========================= M U R E G S ==============================
C
C  A)  N  IS THE NUMBER OF ELEMENTS TO BE ORDERED
C
C  B)  INTO UM(I) (I=1,N) SHOULD GO THE NUMBERS TO BE ORDERED
C
C  C)  THE ORDERED NUMBERS WILL BE OUTPUTTED IN UM(I)(SMALLEST FIRST)
C
C  D)  NFLAG(I) GIVES THE ORIGINAL POSITION OF THE ELEMENTS.
C
C      E.G. THE ELEMENT NOW IN POSITION  5 USED TO OCCUPY
C
C      POSITION NFLAG(5) IN THE INPUT LIST.
C
C HARRISON B. PROSPER   APRIL 1979   J A D E
C =====================================================================
C
      SUBROUTINE MUREGS(UM,N,NFLAG)
      DIMENSION UM(200),NFLAG(200)
C
      IF(N.LE.1) GOTO 50
      NM1=N-1
C
      DO 10 I=1,N
      NFLAG(I)=I
10    CONTINUE
C
      DO 1 I=1,NM1
      TEST=UM(I)
      K=I
      IP1=I+1
C
                   DO 2 J=IP1,N
                   IF(UM(J).GE.TEST) GOTO 2
                   K=J
                   TEST=UM(J)
2     CONTINUE
C
      TEMP = NFLAG(I)
      NFLAG(I) = NFLAG(K)
      NFLAG(K) = TEMP
C
      UM(K)=UM(I)
      UM(I)=TEST
1     CONTINUE
C =====================================================================
50    RETURN
      END

C   11/07/79 102121127  MEMBER NAME  STALGN   (S)           FORTRAN
      SUBROUTINE STALGN( LENGTH, ILGL )
C-----------------------------------------------------------
C
C   VERSION OF 10/05/79      LAST MOD    12/02/81       E.ELSEN
C   STORE LEAD GLASS DATA IN ARRAR ILGL.
C   BANK DESCRIPTOR AND BARREL/END CAP POINTERS ARE PUT IN.
C   LENGTH IS TOTAL I*4 LENGTH OF ARRAY.
C   EXTRA ENTRY RETURNS LENGTH ONLY.
C   RANGE OF BLOCK NUMBERS NOW FROM 0 - 2879
C   CHECK ON ENERGY SMEAR FLAG LFLAG INTRODUCED  11/06/80 18:30
C                         AND EXTENDED           12/02/81
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
*** PMF 15/10/99      DIMENSION ILGL(1), HP(4), IHP(2)
      DIMENSION ILGL(*), HP(4), IHP(2)
*** PMF (end)
      EQUIVALENCE ( HP(1), IHP(1) )
      COMMON / CLGAMP / LGLONG, HAMPL(3000)
      DIMENSION                 IAMPL(1500), HELP(2)
      EQUIVALENCE ( HAMPL(1), IAMPL(1) )
      EQUIVALENCE ( HELP(1), IHELP )
*** PMF 30.04.99 correct bug appearing on DEC's
*** when filling the first two I*2 words of ALGN
      DIMENSION HLGL(2),JLGL(1)
      EQUIVALENCE (HLGL(1),JLGL(1))
*** PMF(End)
C
      LOGICAL * 1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
CCC  CHECK NUMBER OF FIRED BLOCKS
      IF( LGLONG .EQ. 0 ) GO TO 1000
C
CCC  INITIALISE POINTERS
      HP(1) = 1
      HP(2) = 0
      HP(3) = 0
      HP(4) = LGLONG + 1
C
      NBLIM = 2688
      LGL2 = LGLONG / 2
      INX = 1
      DO 200 J = 1, LGL2
      IHELP = IAMPL(J)
   10 IF( HELP(1) .LE. NBLIM ) GO TO 100
      INX = INX + 1
      HP(INX) = J*2 - 1
      NBLIM = NBLIM + 96
      GO TO 10
  100 HELP(1) = HELP(1) - 1
C                                          STORE IN ILGL ARRAY
  200 ILGL(3+J) = IHELP
      IF( HP(3) .EQ. 0 ) HP(3) = HP(4)
      IF( HP(2) .EQ. 0 ) HP(2) = HP(3)
C
CCC SET DESCRIPTOR AND POINTERS
*PMF   ILGL(1) = 1
*PMF   IF( LFLAG(1) ) ILGL(1) = 2
*PMF   IF( LFLAG(3) ) ILGL(1) = ILGL(1)+16
*** PMF 30.04.99 correct bug appearing on DEC's
*** when filling the first two I*2 words of ALGN
      HLGL(1) = 0
      HLGL(2) = 1
      IF( LFLAG(1) ) HLGL(2) = 2
      IF( LFLAG(3) ) HLGL(2) = HLGL(2)+16
      ILGL(1)=JLGL(1)
*** PMF(End)
      ILGL(2) = IHP(1)
      ILGL(3) = IHP(2)
C
CCC  EXTRA ENTRY FOR LENGTH OF ARRAY
C-----------------------------------------------------------
      ENTRY LHALGN( LENGTH )
C-----------------------------------------------------------
C
 1000 LENGTH = 0
      IF( LGLONG .EQ. 0 ) RETURN
      LENGTH = LGLONG / 2 + 3
      RETURN
      END

C   05/12/79 001241837  MEMBER NAME  ANO161   (S)           FORTRAN
      SUBROUTINE ANO161(IRUN)
C---  ANOMALIES OF RUNS 2386 - 2447
C---  6.0 GEV      NOVEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     24.01.80     18:35
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (2386,2387,2388,2389,2390,2391,2392,2393,2394,2395,2396,13,
     &      2398,2399,2400,2401,2402,2403,2404,2405,2406,2407,2408,2409,
     &      2410,
     &      2411,2412,2413,2414,2415,2416,2417,2418,2419,13,2421,2422,
     &      2423,2424,2425,2426,2427,2428,2429,2430,2431,2432,2433,
     &      2434,2435,2436,2437,2438,2439,2440,2441,2442,2443,2444,
     &      2445,2446,2447),IRUN
   13 RETURN
C
 2386 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2387 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(52) = +1
      LIMIT(52) = 390
      KCONST(60) = +1
      LIMIT(60) = 330
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(156) = +1
      LIMIT(156) = 210
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2388 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2389 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(69) = +1
      LIMIT(69) = 255
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2390 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(183) = -1
      LIMIT(183) = 105
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2391 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2392 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2393 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(45) = +1
      LIMIT(45) = 405
      KCONST(55) = +1
      LIMIT(55) = 285
      KCONST(64) = +1
      LIMIT(64) = 450
      KCONST(67) = +1
      LIMIT(67) = 180
      KCONST(160) = +1
      LIMIT(160) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 90
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2394 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(53) = +1
      LIMIT(53) = 315
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2395 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2396 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2398 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2399 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2400 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2401 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(25) = +1
      LIMIT(25) = 315
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2402 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2403 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(110) = +1
      LIMIT(110) = 345
      KCONST(119) = +1
      LIMIT(119) = 360
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2404 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2405 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2406 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2407 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2408 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2409 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2410 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2411 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2412 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2413 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
 2414 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2415 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2416 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(77) = +1
      LIMIT(77) = 405
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2417 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2418 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2419 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2421 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2422 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2423 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(179) = +1
      LIMIT(179) = 315
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2424 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2425 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 90
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2426 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2427 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(43) = +1
      LIMIT(43) = 315
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2428 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = +1
      LIMIT(7) = 210
      KCONST(14) = +1
      LIMIT(14) = 390
      KCONST(111) = +1
      LIMIT(111) = 315
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2429 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2430 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(148) = +1
      LIMIT(148) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2431 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(40) = +1
      LIMIT(40) = 345
      KCONST(50) = +1
      LIMIT(50) = 390
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2432 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(41) = +1
      LIMIT(41) = 390
      KCONST(42) = +1
      LIMIT(42) = 345
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2433 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
C
      RETURN
C
 2434 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(13) = +1
      LIMIT(13) = 390
      KCONST(102) = +1
      LIMIT(102) = 300
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(183) = -1
      LIMIT(183) = 105
      KCONST(184) = -1
      LIMIT(184) = 135
      KCONST(190) = -1
      LIMIT(190) = 150
C
      RETURN
C
 2435 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2436 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(31) = +1
      LIMIT(31) = 330
      KCONST(41) = +1
      LIMIT(41) = 360
      KCONST(127) = +1
      LIMIT(127) = 360
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2437 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
 2438 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2439 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(57) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2440 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(73) = +1
      LIMIT(73) = 405
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = +1
      LIMIT(168) = 195
      KCONST(169) = +1
      LIMIT(169) = 210
C
      LTHRES(7) = .TRUE.
      LTHRES(25) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2441 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(69) = +1
      LIMIT(69) = 255
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(43) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2442 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2443 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2444 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2445 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(67) = .TRUE.
C
      RETURN
C
 2446 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(162) = -1
      LIMIT(162) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 105
      KCONST(178) = -1
      LIMIT(178) = 150
      KCONST(184) = -1
      LIMIT(184) = 105
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
 2447 LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(26) = +1
      LIMIT(26) = 345
      KCONST(112) = +1
      LIMIT(112) = 75
      KCONST(116) = -1
      LIMIT(116) = 120
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(168) = -1
      LIMIT(168) = 120
      KCONST(190) = -1
      LIMIT(190) = 135
C
      RETURN
C
      END

C   13/08/79 412031703  MEMBER NAME  LGTHCRN  (SOURCE)      FORTRAN
      SUBROUTINE LGTHCR( ECLS,EDG,JEG,COSTH, DCOSTH)
C
C     S.YAMADA  26-02-80   17:15
C     LAST MODIFICATION  28-02-80   15:35
C
C     CLUSTER POLAR ANGLE CORRECTION FOR THE BARREL PART.
C
C---- INPUT
C     ECLS=CLUSTER ENERGY
C     EDG =EDGE ENERGY FRACTION
C     JEG = 0(GAMMA),  NE.0(CHARGED)
C     COSTH = CLUSTER COS(TH)
C---- OUTPUT
C     DCOSTH = CORRECTION FOR COSTH
C
      DCOSTH = 0.
C---- CORRECTION DEPENDS ON THE CLUSTER ENERGY
      IF( ECLS.LE.0. ) GO TO 90
      IF( EDG.LT.0. .OR. EDG.GT. 1.0 )  GO TO 91
C
C---- ANGLE INDEPENDENT PART
      X = ALOG10( ECLS )
      IF( X.GT.-0.8239) GO TO 1
      DTHC = 0.0045*X-0.00245
      GO TO 10
    1 IF( X.GT.0.6532) GO TO 2
C     ENERGY  ( 0.15  --  4.5  ) GEV
      DTHC = -(0.001219*X+0.00725)
      GO TO 10
    2 DTHC = -0.008
C
C     ANGLE DEPENDENT PART
   10 DTHA = (0.0032*X+0.016)*EXP(-6.667*ABS(COSTH))
C
C---- COSTH CORRECTION AT THE BARREL EDGE
   30 DTHE = 0.
      IF( EDG.LE.0. ) GO TO 50
C---- CORRECTION IS DONE BY THE AMOUNT OF THE EDGE ENERGY FRACTION.
      IF(JEG) 40,31,40
C     GAMMA
   31 DTHE = (0.00913*X+0.0188)*EDG
      GO TO 50
C     CHARGED
   40 DTHE = ((0.12*EDG-0.18)*EDG+0.09)*EDG
C
   50 DCOSTH = DTHC+DTHA+DTHE
C////////// TEST
C     DATA MESS/0/
C      MESS = MESS+1
C      IF(MESS.LE.50)
C    $ WRITE(6,6000) ECLS,EDG,JEG,COSTH,X,DTHC,DTHA,DTHE,DCOSTH
C6000  FORMAT(' ECLS,EDG,JEG,COSTH=',2F7.3,I6,F8.4,
C    $        '   X,DTHC,DTHA,DTHE,DCOSTH=',5E10.3)
C//////////
      IF( COSTH.LT.0. ) DCOSTH = -DCOSTH
      RETURN
C
C---- ERRORS
   90 NER1 = NER1+1
      IF( NER1.LT.10 ) WRITE(6,690) ECLS,NER1
  690 FORMAT(/' ***** ERROR *****    WRONG INPUT FOR LGTHCR,  ECLS=',
     1      E12.4,'  NER=',I3)
      RETURN
C
   91 NER2 = NER2+1
      IF( NER2.LT.10 ) WRITE(6,691) EDG,NER2
  691 FORMAT(/' ***** ERROR *****    WRONG INPUT FOR LGTHCR,  EDG.FR =',
     1      E12.4,'  NER=',I3)
      RETURN
C
      END

C   26/08/86 608261112  MEMBER NAME  SHADO9   (S)           FORTRAN77
      SUBROUTINE SHADO9(WIDTH,ILIPS)
C
C     LOOK FOR LG ENERGY AROUND CALCULATED PARTICLE PATH
C     PROFILE IS DEFINED IN ARRAY WIDTH
C
C                                         06/07/82
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgeo1.for"
C
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
      DIMENSION IRKL(2,50)
      EQUIVALENCE(IRKL(1,1),TRKL(1,1))
      DIMENSION WIDTH(5)
CC    DATA WIDTH / 0.5 , 0.5 , 0.5 ,0.5 , 0.5 /
      DATA PI4 /.7854/, TWOPI/6.283185/
C
C     WRITE(6,123)
C 123 FORMAT(1X,'  ***  SHADOW  05  ***')
      ENEW = 0.
      NNEW = 0
      NENEW = 0
      DO 60 I=1,40
      NLIST(I) = -1
   60 CONTINUE
C
      IALGN = IDATA(IBLN('ALGN'))
      IF(IALGN.EQ.0) RETURN
      IPNH0=2*IALGN+5
      NWO=IDATA(IALGN)
      MXH=2*(IALGN+NWO)
C
C     SCAN ALONG PARTICLE PATH
C
      THLG = (ZF-ZI)/SQRT((XF-XI)**2+(YF-YI)**2+(ZF-ZI)**2)
      STHLG = SIN(THLG)
      CTHLG = COS(THLG)
C
C     WRITE(6,111) IREG,THLG
C 111 FORMAT(/,X,'PRINTOUT FROM SHADOW,LG-PART ',I2,' LG-THETA ',F6.3,
C    *       /,X,'  DIST   ','  XSCAN  ','  YSCAN  ','  ZSCAN  ',
C    *         X,'  PSCAN  ','  ELIPSP ','  ELIPS1 ','  ELIPS2 ',
C    *         X,'  ELIPS3 ','  ELIPS4 ','  XSCAN1 ','  YSCAN1 ',
C    *         X,'  XSCAN1 ','  PSCAN1 ')
C
      DO 10 ISCAN=1,5
      DIST = FLOAT(ISCAN-1)/4.
      XSCAN=(DIST*(XF-XI))+XI
      YSCAN=(DIST*(YF-YI))+YI
      ZSCAN=(DIST*(ZF-ZI))+ZI
      RSCAN=SQRT(XSCAN**2+YSCAN**2)
      PSCAN = ATAN2(XSCAN,YSCAN)
      IF(PSCAN.LT.0) PSCAN=PSCAN+TWOPI
C
      ELIPSP = 0.
      IF(IREG.NE.0) ELIPSP = ATAN2(XSCAN,YSCAN)
      DO 20 K=1,8
      ELIPSP = ELIPSP + PI4
C
      IF(IREG.NE.0) GOTO 1
CC    ELIPS1 = STHLG*COS(ELIPSP)
      ELIPS1 = COS(ELIPSP)
       ATHLG=1.4*ABS(THLG)
       IF(ATHLG.GT.1.) ATHLG=1.
       IF(ILIPS.EQ.2) GOTO 25
       IF((ELIPS1*ZSCAN).LT.0.) ELIPS1=ELIPS1*(1.-ATHLG)
   25 ELIPS2 = SIN(ELIPSP)
      ZSCAN1 = ZSCAN+ELIPS1*WIDTH(ISCAN)*BLZ
      PSCAN1 = PSCAN+ELIPS2*WIDTH(ISCAN)*DELFI
      XSCAN1 = RSCAN*SIN(PSCAN1)
      YSCAN1 = RSCAN*COS(PSCAN1)
      GOTO 2
C
    1 ELIPS3 = CTHLG*COS(ELIPSP)
      ELIPS4 = CTHLG*SIN(ELIPSP)
      XSCAN1 = XSCAN+ELIPS3*WIDTH(ISCAN)*BLXY
      YSCAN1 = YSCAN+ELIPS4*WIDTH(ISCAN)*BLXY
      ZSCAN1 = ZSCAN
C
    2 IBL = NUMBLC(XSCAN1,YSCAN1,ZSCAN1,IREG)
C
C     WRITE(6,222) DIST,XSCAN,YSCAN,ZSCAN,PSCAN,ELIPSP,ELIPS1,ELIPS2,
C    *             ELIPS3,ELIPS4,XSCAN1,YSCAN1,ZSCAN1,PSCAN1
C 222 FORMAT(X,14F9.3)
C
      IDEC = 1
      IF(IBL.EQ.-1) IDEC = 0
      DO 30 L=1,NBLK
      IF(IRKL(1,L).EQ.IBL) IDEC = 0
   30 CONTINUE
      IF(IDEC.EQ.0) GOTO 20
      IF(NNEW.EQ.0) GOTO 3
      IDEC = 1
      DO 40 M=1,NNEW
      IF(IBL.EQ.NLIST(M)) IDEC = 0
   40 CONTINUE
      IF(IDEC.EQ.0) GOTO 20
    3 NNEW = NNEW + 1
      NLIST(NNEW) = IBL
   20 CONTINUE
C
   10 CONTINUE
C
C     LOOK FOR ENERGY IN NEW BLOCKS
C
      IF(NNEW.EQ.0) RETURN
      DO 50 N=1,NNEW
      IPNH = IPNH0
    4 IPNH=IPNH+2
      IF(IPNH.GT.MXH) GOTO 50
      IF(HDATA(IPNH).NE.NLIST(N)) GOTO 4
      EBL = HDATA(IPNH+1)
      ENEW = ENEW + EBL
      NENEW = NENEW + 1
   50 CONTINUE
C
      RETURN
      END

C   09/02/87 711061719  MEMBER NAME  TPTRAK   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTRAK
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      25/03/87:  Process tracks
C
C          mod: C. Bowdery      26/07/87:  Include dE/dx call
C     Last mod: C. Bowdery      12/10/87:  Remove dE/dx and other calls
C
C     Routine to process tracks and create summary banks for them.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

C------------------  C O D E  ------------------------------------------

C                            Process tracks in the central detectors

      CALL TPCDET

C                            Create summary banks including vertex info

      CALL TPTRTP

C                            Delete unwanted track banks

      CALL TPTRDL

      RETURN
      END

C   17/03/79 003120036  MEMBER NAME  LGEIGNX  (SOURCE)      FORTRAN
      SUBROUTINE LGEIGN(PARA)
C
C     R.EICHLER   7-11-78 17:00
C     LAST MODIFICATION 15-02-80 13:35   BY S.YAMADA, AVZ CORR IS ADDED.
C
C   CALCULATE AVPH,SIGPH,AVZ,SIGZ,SIGZPH
C
      IMPLICIT INTEGER *2 (H)
C
#include "clgwork1.for"
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
      COMMON/LGSHP/WW(50),ZZ(50),XX(50),EW(2),AVPH,AVZ,SIGPH,SIGZ,EV,KK
C
      DATA EZ,EPH/0.33,0.33/, NVCODE/180021615/, MESS/0/
C
      IF(MESS) 1000,1000,1001
 1000 IDENT(1) = IDENT(1)+NVCODE/100000000*100
      MESS = 1
C
 1001   WTSUM=0.
        WTZSUM=0.
        ZSUM=0.
        ZPH=0.
        Z2SUM=0.
        PHSUM = 0.
        PH2SUM = 0.
        IMAX = KK
        IF(IMAX.GT.50) IMAX = 50
          DO 10 I=1,IMAX
          W=WW(I)**EPH
          ZW=W
C           USE THE SAME WEIGHT  15-02-80
          WZ=ZW*ZZ(I)
          ZSUM=ZSUM+WZ
          ZPH=ZPH+WZ*XX(I)
          Z2SUM=Z2SUM+WZ*ZZ(I)
          WTSUM=WTSUM+W
          WTZSUM=WTZSUM+ZW
          WPH=W*XX(I)
          PHSUM=PHSUM+WPH
          PH2SUM=PH2SUM+WPH*XX(I)
   10     CONTINUE
C      WRITE(6,900) WTSUM,WTZSUM,AVZ,PH2SUM
C900  FORMAT(' WTSUM,WTZSUM,AVZ,PH2SUM',5F12.3)
      AVPH=PHSUM/WTSUM
      SIGPH=(PH2SUM/WTSUM-AVPH*AVPH)
      AVZ=ZSUM/WTZSUM
      COSTH=1.
      IF(PARA .LE.0.1) COSTH=AVZ/SQRT(AVZ*AVZ+RADIUS(3)**2)
      SIGZ=(Z2SUM/WTZSUM-AVZ*AVZ)*COSTH*COSTH
      SIGZPH=(ZPH/WTZSUM-AVZ*AVPH)*COSTH
C
C---- CALCULATE EIGENVALUES OF MATRIX  ( SIGPH  SIGPHZ )
C                                      ( SIGPHZ SIGZ   )
      D=SIGPH+SIGZ
      F=D*D+4.*SIGZPH*SIGZPH-4.*SIGPH*SIGZ
      IF (F .LT. 0.) GO TO 60
      C=SQRT(F)*0.5
      EW(1)=D*0.5+C
      EW(2)=D*0.5-C
      F=SIGPH-EW(1)
      IF(ABS(F) .LT. 1.E-20) F=1.E-20
C---- EV=ANGLE OF EIGENVECTORS TO X-Y RESP. Z-PH COORD.SYSTEM
      EV=ATAN(-SIGZPH/F)
      IF(EW(1) .GT. EW(2)) GO TO 50
      C=EW(2)
      EW(2)=EW(1)
      EW(1)=C
   50 CONTINUE
      IF (EW(1))  60,60,70
C
C---- IF MATRIX IS SINGULAR OR DUE TO ROUNDING ERRORS BOTH EIGEN
C     VALUES ARE NEGATIV,SET EIGENVALUES SO THAT EW1/EW2 AND EW1+EW2
C---- ARE RIDICULOUS
   60 EW(1)=1.
      EW(2)=-10.
C
C---- AVZ IS CORRECTED FOR BARREL HITS,IF ABS(Z) .LE.500MM.
   70 IF(PARA.GT.0.1) GO TO 100
      IF( AVZ.LE.-50. .OR. AVZ.GE.50. ) GO TO 100
      AVZ =  AVZ*AVZ*AVZ/2500.
  100 RETURN
      END

C   10/04/84            MEMBER NAME  RECTAN   (JADEGS)      FORTRAN
      SUBROUTINE RECTAN(X0,Y0,X1,Y1,L)
C     DRAW RECTANGLE
      CALL MOVEA(X0,Y0)
      IF(L.GT.0) GO TO 101
      CALL DRAWA(X0,Y1)
      CALL DRAWA(X1,Y1)
      CALL DRAWA(X1,Y0)
      CALL DRAWA(X0,Y0)
      RETURN
101   CALL DASHA(X0,Y1,L)
      CALL DASHA(X1,Y1,L)
      CALL DASHA(X1,Y0,L)
      CALL DASHA(X0,Y0,L)
      RETURN
      END

C   07/06/96 606071812  MEMBER NAME  BFMT     (S4)          FORTRAN
      SUBROUTINE BFMT(X,N,XF,EF)
      LOGICAL*1CH(12)/'0','1','2','3','4','5','6','7','8','9','.','-'/
      REAL*8 XF(N),FXF,SXF,BLANK/'        '/,NULL/'00000000'/
      LOGICAL*1 FXL(8),SXL(8)
      EQUIVALENCE (FXL(1),FXF),(SXL(1),SXF)
      REAL*4 X(N)
      INTEGER BLK/'    '/
      INTEGER EF

      IP=0
      XM=0.0
      DO 10 I=1,N
   10 XM=AMAX1(XM,ABS(X(I)))
      JP=5
      FC=1.0
      IF(XM.EQ.0.0) GOTO 15
      JP=104-IFIX(ALOG10(ABS(XM))+100.04)
      FC=10.0**JP
   15 IM=6
      DO 30 I=1,N
      FXF=NULL
      IJ=FC*ABS(X(I))+0.5
      JM=6
      IF(IJ.EQ.0) GOTO 30
      DO 20 J=1,5
      JH=IJ/10
      JN=IJ-10*JH
      IF(JN.NE.0.AND.JM.EQ.6) JM=J
      FXL(J)=CH(JN+1)
   20 IJ=JH
      IM=MIN0(IM,JM)
   30 XF(I)=FXF
      JM=IM
   32 IF(6-JP.LE.5) GOTO 34
      JP=JP+3
      IP=IP+3
      GOTO 32
   34 IF(JP+1-JM.LE.5) GOTO 38
   36 JP=JP-3
      IP=IP-3
      GOTO 34
   38 IF(JP.GE.8) GOTO 36
      JA=MIN0(JM,JP)
      JB=MAX0(6,JP+1)
      DO 90 I=1,N
      FXF=XF(I)
      SXF=BLANK
      IB=7+(JB-JA)/2
      DO 80 J=JA,JB
      IF(FXL(J).NE.CH(1)) GOTO 70
      IF(J.GT.JP+1) GOTO 50
      IF(FXF.NE.NULL) GOTO 70
      IF(J.GE.JP) GOTO 70
      IB=IB-1
      GOTO 80
   50 DO 60 K=J,JB
      IF(FXL(K).NE.CH(1)) GOTO 70
   60 CONTINUE
      GOTO 80
   70 IB=IB-1
      SXL(IB)=FXL(J)
      IF(J.NE.JP) GOTO 80
      IB=IB-1
      SXL(IB)=CH(11)
   80 CONTINUE
      IF(X(I).LT.0.0) SXL(IB-1)=CH(12)
   90 XF(I)=SXF
      EF=BLK
      IF(IP.NE.0) EF=IAF(IP,'E   ')
  100 RETURN
      END

C   27/03/82 311291149  MEMBER NAME  HDECLS   (S)           FORTRAN
      SUBROUTINE HDECLS(ECLS,ICHG,IPAR,PE,IBE,PLLG,PLLI)
C
C     INPUT ARGUMENTS
C       IPAR  :  TYPE OF INCIDENT PARTICLE
C                  GAMMA = 1
C                  E     = 2
C                  MU    = 3
C                  PI    = 4
C                  K     = 5
C                  P     = 6
C       PE    :  INCIDENT 4-MOMENTUM
C       IFLG = 0 FOR NO IMPACT POINT (CURLING ELECTRON)
C            = 1 FOR IMPACT POINT IN ENDCAPS (INCLUDING GAP ENDCAP-CYL)
C            = 2 FOR IMPACT POINT IN CYLINDER
C       PLLG  :  TOTAL PATH LENGTH IN THE LEAD GLASS  IN MM
C       PLLI  :            ...            LIGHT GUIDE  ...
C
C      30/06/82
C
C     INCIDENT ANGLE DEPENDENCE IS INTRODUCED FOR MINIMUM IONIZING
C     PARTICLES
C                               06/01/83     J. KANZAKI
C
      DIMENSION PE(4),DC(3),XYZ1(3),XYZ2(3)
      DIMENSION A(3)
      DATA PLIM/ 0.5/
      DATA ASIG0/ 0.05/
      DATA PLLG0E,PLLG0B/ 226., 300./
      DATA PLLI0/ 60./
      DATA PLAL0E,PLAL0B/ 104.13, 86.33/
      DIMENSION XLLG1(6),XLAL1(6)
      DATA XLLG1/ 309., 309., 309., 309., 309., 309./
      DATA XLAL1/ 172., 172., 172., 172., 172., 172./
      DATA ABSA1,ABSA2/ 0.0595, 0.0787/
      DATA ABS0/ 0.372/
      DATA AEXALA/ 18.51/,AEXALB/ 26.68/
      DATA A2NOA,A2ALA,A2ALB/ 3., 2.2, 2.8/
      DATA A3A,A3B,A3C/ 5.132, 5.313, -0.782/
      DATA A4A,A4B,A4C/ -4.795, 44.26, -3.170/
      DIMENSION AMAS1(6)
      DATA AMAS1/ 0., 0.000511, 0.109, 0.1396, 0.4937, 0.9383/
      DATA AN1,AN2/ 1.67, 1.52/
      DATA ALNOA,AHNOA/ 0.3021, 0.2406/
      DATA ALALA,AHALA/ 0.2900, 0.2335/
      DATA ALALB,AHALB/ 0.2806, 0.2351/
      DATA PLIM1/ 5./
      DATA ALSIGA,ALSIGB/ 7.05, 3.99/
      DATA AHSIGA,AHSIGB/ 6.74, 0.67/
      DATA ANCLP/ 2.3/,ANCLN/ 1.15/
C
C     PARAMETERS FOR THE ANGULAR DEPENDENCE
C
      DATA ANOINT/ 0.7042/,BNOINT/ 14.753/
      DATA AINT/ 0.8/,BINT/ 14.753/
C     DATA AINT/ 0.9/,BINT/ 14.753/
C
C
      ECLS=0.
      IF(IBE.LE.-2 .OR. IBE.GE.2) RETURN
      IF(IPAR.LE.2) RETURN
C
      PT=SQRT(PE(1)**2+PE(2)**2)
      PP=SQRT(PE(3)**2+PT**2)
      IF(PP.LE.0.) CALL ERRMSG('MOMENTUM = 0. ??$',&999)
C
      IF(IBE.NE.0) PLLG1=PLLG/PLLG0E
      IF(IBE.EQ.0) PLLG1=PLLG/PLLG0B
      PLLI1=PLLI/PLLI0
      IF(IBE.NE.0) PLAL=PLAL0E*PLLG1
      IF(IBE.EQ.0) PLAL=PLAL0B*PLLG1
C
      IAL=1
CC********
CC    SUPRESS NOAL DATA
CC    IF(IFLG.NE.2) IAL=0
CC********
C
 1000 IF(IPAR.NE.3) GO TO 2000
C
C     MUON
C
      GO TO 2100
C
C     HADRON
C
 2000 CONTINUE
C
C     DETERMINE WHETHER THE PARTICLE INTERACTS OR NOT.
C
      XLLG0=XLLG1(IPAR)
      EXPLG=PLLG/XLLG0
      RINT=1.
      IF(EXPLG.LT.10.) RINT=1.-EXP(-EXPLG)
      IF(IAL.EQ.0) GO TO 2005
      XLAL0=XLAL1(IPAR)
      EXPAL=PLAL/XLAL0
      RINT=1.
      IF(EXPAL.LT.10. .AND. EXPLG.LT.10.)RINT=1.-EXP(-EXPAL)*EXP(-EXPLG)
 2005 IF(RN(DUM).GT.RINT) GO TO 2100
C
C     INTERACTING PARTICLE
C
      PMOM=PP
      IF(PP.LT.PLIM) PMOM=PLIM
      RINTAL=1./RINT
      IF(EXPAL.LT.10.) RINTAL=(1.-EXP(-EXPAL))/RINT
      IF(RN(DUM).GT.RINTAL) GO TO 2020
      RABS=(ABSA1+ABSA2/PMOM)/ABS0
      IF(RN(DUM).GT.RABS) GO TO 2020
      AEX=AEXALB+(AEXALA-AEXALB)*PLLI1
      EV=PP*RNEXP0(AEX)
      ECLS=EV
      RETURN
C
 2020 A(1)=0.
      IF(IAL.EQ.0) A(1)=A2NOA
      IF(IAL.EQ.1) A(1)=A2ALB+(A2ALA-A2ALB)*PLLI1
      A(2)=-(A3A+A3B*EXP(A3C*PMOM))
      A(3)=A4A+A4B*EXP(A4C*PMOM)
      PMOM=PP
C
      ELIM=PP+3.*ASIG0*SQRT(PP)
 2003 EV=PP*RNCONT(A)
      IF(EV.GT.ELIM) GO TO 2003
C
      ESIG=ASIG0*SQRT(EV)
 2010 ECLS=RNGAU(EV,ESIG)
      IF(ECLS.LT.0.) ECLS=0.
      IF(ECLS.GT.ELIM) GO TO 2010
C
C     SPECIAL CASE FOR ANTI-NUCLEON
C
      IF(IPAR.EQ.6 .AND. ICHG.EQ.0) ECLS=ANCLN*ECLS
      IF(IPAR.EQ.6 .AND. ICHG.EQ.-1) ECLS=ANCLP*ECLS
      IF(IBE.EQ.0) COSTH=PLLG0B/PLLG
      IF(IBE.NE.0) COSTH=PLLG0E/PLLG
      FCOR=FCRANG(COSTH,AINT,BINT)
      ECLS=FCOR*ECLS
      RETURN
C
C     NON-INTERACTING PARTICLE
C
 2100 IF(ICHG.EQ.0) RETURN
      PMOM=PP
      AMAS=AMAS1(IPAR)
      ALOW=0.
      AHIG=0.
      IF(IAL.EQ.0) ALOW=ALNOA
      IF(IAL.EQ.0) AHIG=AHNOA
      IF(IAL.NE.0) ALOW=ALALB+(ALALA-ALALB)*PLLI1
      IF(IAL.NE.0) AHIG=AHALB+(AHALA-AHALB)*PLLI1
C
      APKL=ALOW*(1.-AMAS**2/PMOM/(AN1**2-1))*PLLG1
      IF(APKL.LT.0.) APKL=0.
      APKH=AHIG*(1.-AMAS**2/PMOM/(AN2**2-1))*PLLI1
      IF(APKH.LT.0.) APKH=0.
      APK=APKL+APKH
C
      IF(APK.LE.0.) RETURN
C
      IF(IBE.EQ.0) COSTH=PLLG0B/PLLG
      IF(IBE.NE.0) COSTH=PLLG0E/PLLG
      FCOR=FCRANG(COSTH,ANOINT,BNOINT)
      APK=FCOR*APK
C
      PMOM1=PMOM
      IF(PMOM.GT.PLIM1) PMOM1=PLIM1
C
      ALSIG=ALSIGA+ALSIGB*PMOM1
      AHSIG=AHSIGA+AHSIGB*PMOM1
      ASIG=0.01*(ALSIG+(AHSIG-ALSIG)*PLLI1)*APK
C
      ECLS=RNGAU(APK,ASIG)
      IF(ECLS.LT.0.) ECLS=0.
C
      RETURN
C
  999 RETURN
      END

C   09/12/87 807261221  MEMBER NAME  TPTPUT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTPUT( NP, NMAXP, T, AXIS )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       9/12/87:  Store thrust info (TPEV)
C
C     Last mod: C. Bowdery      26/07/88:  Add extra arguments
C
C     Routine to store thrust and thrust axis in TPEV/1 bank
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     NP        In       I*4      Number of particles
C     NMAXP     In       I*4      Max number used in thrust calc.
C     T         In       R*4      Thrust of event
C     AXIS      In       R*4      Thrust axis (1..3)
C                                   AXIS(1) = x dir. cos. of thrust axis
C                                   AXIS(2) = y dir. cos. of thrust axis
C                                   AXIS(3) = z dir. cos. of thrust axis
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      REAL  T, AXIS(3)

C------------------  C O D E  ------------------------------------------

C                             Find TPEV/1 bank and copy thrust info

      CALL CLOC( ITPEV, 'TPEV', 1 )

      IF( ITPEV .GT. 0 ) THEN

        ADATA( ITPEV + 42 )   = T
        ADATA( ITPEV + 43 )   = AXIS(1)
        ADATA( ITPEV + 44 )   = AXIS(2)
        ADATA( ITPEV + 45 )   = AXIS(3)

C                             Copy number of tracks available and
C                             max number that were accepted.

        HDATA( 2*ITPEV + 81 ) = NP
        HDATA( 2*ITPEV + 82 ) = NMAXP

      ELSE

C                            TPEV bank is missing!

        CALL TPERRH

      ENDIF

      RETURN
      END

C   01/11/84 807251600  MEMBER NAME  HITPNT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE HITPNT( X01, Y01, X02, Y02, IPH )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. HAGEMANN   04/02/86 :  WRITE VTXC-BANK HIT POINTER
C                                        CLOSE TO HIT AND MIRROR HIT
C
C       ARGUMENTS :
C           X01,2  =  X - COORDINATES OF HIT, MIRROR HIT
C           Y01,2  =  Y - COORDINATES OF HIT, MIRROR HIT
C           IPH    =  VTXC-BANK HIT POINTER
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C---------  MACRO CHSYM    SYMBOLS USED IN GRAPHICS WRITING -----
      COMMON /CHSYM/ HSYM(36)
C------ END MACRO CHSYM
C
      DIMENSION HBUF(4)
C
      DATA HBLANK   /'  '/
      DATA HMINUS   /'- '/
C
C-----------------  C O D E  -------------------------------------------
C
      IF( IPH .GT. 9 ) GO TO 50
         HBUF(2) = HSYM(IPH + 1)
         HBUF(1) = HBLANK
         CALL HEMSYM( X02, Y02, 1.7, HBUF, 2, 0.0 )
         HBUF(1) = HMINUS
         CALL HEMSYM( X01, Y01, 1.7, HBUF, 2, 0.0 )
         GO TO 1000
   50 IF( IPH .GT. 99 ) GO TO 100
         ITEN    = IPH/10
         HBUF(2) = HSYM(ITEN + 1)
         IDIG    = IPH - ITEN*10
         HBUF(3) = HSYM(IDIG + 1)
         HBUF(1) = HBLANK
         CALL HEMSYM( X02, Y02, 1.7, HBUF, 3, 0.0 )
         HBUF(1) = HMINUS
         CALL HEMSYM( X01, Y01, 1.7, HBUF, 3, 0.0 )
         GO TO 1000
  100 CONTINUE
         IHUN    = IPH/100
         HBUF(2) = HSYM(IHUN + 1)
         ITEN    = (IPH-IHUN*100)/10
         HBUF(3) = HSYM(ITEN+1)
         IDIG    = IPH - IHUN*100 - ITEN*10
         HBUF(4) = HSYM(IDIG + 1)
         HBUF(1) = HBLANK
         CALL HEMSYM( X02, Y02, 1.7, HBUF, 4, 0.0 )
         HBUF(1) = HMINUS
         CALL HEMSYM( X01, Y01, 1.7, HBUF, 4, 0.0 )
C
 1000 CONTINUE
C
      RETURN
      END

C   07/02/87            MEMBER NAME  TPTOFS   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTOFS
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery        7/02/87:  Analyses TOF system
C
C
C
C     Routine to analyse TOF counters and determine particle types.
C     Unwanted banks are deleted at the end.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

C------------------  C O D E  ------------------------------------------

C                            Do TOF analysis  (may do nothing)

      CALL TPTOFA

C                            Add TOF information to banks (if wanted)

      CALL TPTOFT

C                            Delete TOF bank as requested

      CALL TPTOFD


      RETURN
      END

C   06/12/79 102191154  MEMBER NAME  ERRORM   (PATRECSR)    FORTRAN
      SUBROUTINE ERRORM(SUBR,NERROR,NT)
      IMPLICIT INTEGER*2(H)
      REAL*8 SUBR
      COMMON/CADMIN/IEVTP,NREC,NRWRIT,NRERR
      COMMON/CHEADR/HEAD(17),HRUN,HEV
#include "cpatlm.for"
C
C
C-----------------------------------------------------------------------
C
C         -------------- SUBROUTINE ERRORM  ------------------
C         --- G.F.PEARCE .. LAST UPDATE : 1200 ON  6/12/80 ---
C
C     THIS SUBROUTINE PRINTS OUT A SINGLE LINE ERROR MESSAGE
C     REQUIRED :
C     SUBR   = ALPHANUMERIC SUBROUTINE NAME (8 BYTES) IN WHICH ERROR
C              OCCURRED (E.G. 'XYFIT   ')
C     NERROR = ERROR IDENTIFICATION NUMBER
C     NT     = TRACK NUMBER ON WHICH ERROR OCCURED
C
C-----------------------------------------------------------------------
C
C
      IXYF(11) = IXYF(11) - 1
      IF(IXYF(11).LT.0)RETURN
      PRINT1,SUBR,NERROR,NREC,HRUN,HEV,NT
 1    FORMAT(1X,20('#'),A8,' ERROR MESSAGE ',I3
     #  ,'  RECORD/RUN/EVENT/TRACK =',4I6,1X,20('#'))
      IF(IXYF(11).EQ.0)PRINT2
 2    FORMAT(1X,20('$'),' ERRORM ERROR MESSAGES NOW SUSPENDED')
      RETURN
      END

C   12/11/84 411121739  MEMBER NAME  TAGALL   (S)           FORTRAN
#include "acol.for"
#include "aftp83.for"
#include "anatag.for"
#include "calad.for"
#include "clsps.for"
#include "clusfn.for"
#include "comfil.for"
#include "ffityp.for"
#include "fhtos.for"
#include "fitag.for"
#include "frtype.for"
#include "fstoh.for"
#include "ggblck.for"
#include "listgn.for"
#include "pedfix.for"
#include "sort.for"
#include "sort1.for"
#include "sort2.for"
#include "srsum.for"
#include "tagan.for"
#include "tagchk.for"
#include "tagdat.for"
#include "tagint.for"
#include "tagmrk.for"
#include "tagset.for"
#include "tagsto.for"
#include "tgdcos.for"

C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------

C   29/10/82 501081234  MEMBER NAME  XXTEST   (JADESR)      FORTRAN
      SUBROUTINE XXTEST
C
    1 READ (10,END=100) IRD, IED
      READ (20,END=100) IRR, IER
      PRINT 50, IRD, IED, IRR, IER
   50 FORMAT('  IRD, IED, IRR, IER =',4I10)
      GOTO 1
C
  100 CONTINUE
      RETURN
C
      END

C   07/06/96 606071857  MEMBER NAME  MSGPR    (S4)          FORTG1
      SUBROUTINE MSGPR
      REAL*8 WORD,LINE(16),BLANK/'        '/
      LOGICAL*1 ALIST(9),LWORD(8),BLK/' '/,LIST(9,10)/90*' '/
      EQUIVALENCE (WORD,LWORD(1))
      INTEGER NL/0/
      IF(NL.EQ.0) GOTO 100
      DO 30 N=1,NL
      WRITE(6,101)
      DO 20 LINENR=1,12
      DO 10 J=1,16
   10 LINE(J)=BLANK
      CALL BLKLET(LIST(1,N),LINENR,LINE,9)
      WRITE(6,101) LINE
   20 CONTINUE
      WRITE(6,101)
   30 CONTINUE
      DO 40 J=1,10
      DO 40 I=1,9
   40 LIST(I,J)=BLK
      NL=0
      GOTO 100
C
      ENTRY MSGTXT(ALIST)
      IF(NL.EQ.10) GOTO 100
      NL=NL+1
      DO 50 I=1,9
   50 LIST(I,NL)=ALIST(I)
      GOTO 100
C
      ENTRY MSGINT(NR,IA,IB)
      IF(NL.EQ.0) NL=1
      CALL ITODA(NR,WORD,-8)
      IL=IB
      IF(IL.GT.9) IL=9
      IF(IL.LT.1) IL=1
      NN=IB+1-IA
      NN=MIN0(NN,IL,8)
      NN=MAX0(NN,1)
      DO 60 I=1,NN
   60 LIST(IL+1-I,NL)=LWORD(9-I)
  100 RETURN
  101 FORMAT(3X,16A8)
      END

C   15/01/88 807222034  MEMBER NAME  TPVCI2   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPVCI2( COMFIT )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      22/07/88:  Get instr. about COMFIT
C
C
C     Routine to provide yes/no answer about need for COMFIT. This can
C     be done even when no vertex chamber information.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     ANALYS    Out      L*4      TRUE if COMFIT step is to be done
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  VTXC*8, CCOMFT*20

      LOGICAL  COMFIT, COMF, FIRST

      SAVE  FIRST, COMF

      DATA  FIRST  / .TRUE. /
      DATA  VTXC   / 'VTXC' /
      DATA  CCOMFT / 'COMFIT'   /

C------------------  C O D E  ------------------------------------------

C                            If not first call, COMF already SAVEd.

      IF( FIRST ) THEN

C                            Get user option relating to COMFIT

        CALL TPUOPT( VTXC, CCOMFT, COMF )

        FIRST = .FALSE.

      ENDIF

      IF( COMF ) THEN

        COMFIT = .TRUE.


      ELSE

        COMFIT = .FALSE.

      ENDIF

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   12/12/78 C9073001   MEMBER NAME  LGSRTH   (SOURCE)      FORTRAN
      SUBROUTINE LGSRTH( IB, ND )
C
C     S.YAMADA    12-12-78     16:40    COPIED FROM (LGSOURCE)
C     LAST MODIFICATION  09-03-79  15:45
C
C---- PULSE HEIGHT SORT OF LEAD GLASS DATA
C---- SORT ACCORDING TO THE ALGORITHM 201 OF CACM,SEE P.66 DESY R-INFO
C
C---- THIS IS A SUBPROGRAM TO SORT LG-DATA OF DIFFERENT DETECTOR PART
C     SEPARATELY.
C---- IB=BASE INDEX,  ND=NO. OF DATA TO BE SORTED.
C
      IMPLICIT INTEGER *2 (H)
C     USED IN LGANAL PART OF PROGRAMS
C        NO CUTS ON MAX FIRIED #CHANNELS (I.E. DIMENSION=2880)
C        CHANGE SIZE OF THE CLUSTER BANK TO 16.. 13/6/80
C        CHANGED BY Y.WATANABE ON 23/09/79. 00:30
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2880),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,
     3               MAPCL(81),  CLPRP(1280)
      INTEGER *2 HMAPCL(2,81)
      DIMENSION ICLSPR(16,80),CLSPRP(16,80), CLMPRP(1361)
      EQUIVALENCE (HMAPCL(1,1),MAPCL(1)), (CLMPRP(1),MAPCL(1))
      EQUIVALENCE (ICLSPR(1,1),CLPRP(1)),  (CLSPRP(1,1),CLPRP(1))
C
      DIMENSION LGADC(2000)
      EQUIVALENCE (LGADC(1),HLGADC(1,1))
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVCODE/178102015/
      NVRSN(17) = NVCODE
C
      IF( ND.LE.1) RETURN
      M = ND
   10 M = M/2
      IF(M.EQ.0) RETURN
      K = ND-M
        DO 50 J=1,K
        I = J+IB
   20   IF(I.LE.IB) GO TO 50
        IF( HLGADC(2,I+M).LE.HLGADC(2,I) ) GO TO 50
C----   REPLACING
    3   IW = LGADC(I)
        LGADC(I) = LGADC(I+M)
        LGADC(I+M) = IW
        I = I-M
        GO TO 20
   50   CONTINUE
      GO TO 10
      END

C   02/03/82 411121142  MEMBER NAME  TOFMAS   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFMAS
C
C  DETERMINES TOF FOR EACH TRACK AND ITS QUALITY
C  CREATES BANK TOFR
C  USES SINGLE TRACK ALGORITHM AND OLD BANKFORMAT
C  CREATES BANK TOFR
C  LAST MODIFIED 25.6.82
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "tcalcm1.for"
#include "tfprm.for"
#include "ddata.for"
#include "tfadc.for"
#include "chead.for"
      COMMON/PRPOS/PRPLS,CPOS
C
      DATA IENTRY/0/,IBUG/0/,NEXIST/0/
      DATA DTAU1/1./
C
      IF(IENTRY.NE.0)  GOTO 66
      IENTRY = IENTRY + 1
   66 ZTOF = 0.
C
      NRUN = HEADR(18)
C
C
      ZTOF1 = 0.
      NNG= 0
      NOK= 0
      CALL SETSL(IW,0,704*4,0)
      CALL SETSL(TAUM,0,84*4,0.)
      IBUG = IBUG + 1
      NTRR = 0
C
      DO 1000 I=1,42
      MTPY= ICRT1(2,I)
      IF(MTPY.EQ.0) GO TO 1000
      IF(MTPY.GE.4) MTPY = 3
C
      DO   1001   M=1,MTPY
      NTR1= ICRT1(M+2,I)
C
      ZTOF1 = -2000.
      ADCM = HADC(1,I) - PEDLM(I)
      ADCP = HADC(2,I) - PEDLP(I)
      CC2M = 0.
      IF(I.EQ.2.AND.ADCM.LT.25.) CC2M = 5.4
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
      IF(HADC(1,I).GT.1024) ADCM = 1024.
      IF(HADC(2,I).GT.1024) ADCP = 1024.
      Z1= TRK(1,NTR1)
      PATH1= TRK(3,NTR1)
      PMEV1= TRK(4,NTR1)
      TAUP1= RAW(3,I)+Z1/VELSC
      TAUM1= RAW(2,I)-Z1/VELSC
      TAUM1 = TAUM1 - (TPARM(7)*PATH1+TPARM(8))
      TAUP1 = TAUP1 - (TPARM(7)*PATH1+TPARM(8))
      IF(NRUN.GE.10000) TAUM1= RAW(2,I)-Z1*CADCA(2*I-1)
      IF(NRUN.GE.10000) TAUP1= RAW(3,I)-Z1*CADCA(2*I  )
C     PCOR = (PATH1-RADTOF)/CVEL
C     TAUM1 = TAUM1 - PCOR
C     TAUP1 = TAUP1 - PCOR
      IF(NRUN.LT.4993) GOTO  321
      IF(NRUN.GE.7592) GOTO  322
C  BEAM CURRENT CORR
      TAUM1 = TAUM1 - CPOS *TPARM(21)
      TAUP1 = TAUP1 - CPOS *TPARM(22)
C  AD HOC CORR FOR BEGIN 1981
  322 TAUM1 = TAUM1 - TPARM(25)
      TAUP1 = TAUP1 - TPARM(25)
      IF(NRUN.GT.6000.AND.NRUN.LT.7592) TAUM1 = TAUM1 +3.07
      IF(NRUN.GT.6000.AND.NRUN.LT.7592) TAUP1 = TAUP1 +3.07
      IF(NRUN.GE.10000) TAUM1= TAUM1+3.07
      IF(NRUN.GE.10000) TAUP1= TAUP1+3.07
      IF(NRUN.GE.10000.AND.I.EQ.2) TAUM1 = TAUM1  -CC2M
  321 CONTINUE
C
      NFLG= -1
      IF(HTDC(1,I).GT.10.AND.HTDC(1,I).LT.2048) GO TO 320
      TOF1= TAUP1
      TAUM1= -20.
      GO TO 360
C
  320 CONTINUE
      IF(HTDC(2,I).GT.10.AND.HTDC(2,I).LT.2048) GO TO 330
      TOF1= TAUM1
      TAUP1= -20.
      GO TO 360
C
  330 CONTINUE
      IF(ABS(TAUM1-TAUP1).LE.3.*DTAU1) GO TO 350
      IF(Z1.LT.0.) GO TO 340
      TOF1= TAUP1
      GO TO 360
 340  TOF1= TAUM1
      GO TO 360
C
 350  NFLG= 1
C
      VWM = TPARM(9)/ADCM+TPARM(10)
      VWP = TPARM(9)/ADCP+TPARM(10)
      VWM = 1./(VWM*VWM)
      VWP = 1./(VWP*VWP)
      TOF1 = (VWM*TAUM1+VWP*TAUP1)/(VWM+VWP)
      ZTOF1 =  (RAW(2,I)-RAW(3,I))/2.*VELSC
 360  CONTINUE
      NTRR = NTRR + 1
      IF(NTRR.GT.50)  GOTO  1001
      TAUM(I) = TAUM1
      TAUP(I) = TAUP1
      TDCM = HTDC(1,I)
      TDCP = HTDC(2,I)
      NFLG = NFLG * MTPY
      CALL CMASS( I,PMEV1,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -            PRO1,PKA1,PPI1,PEL1)
      CALL TFSTOR(NTR1,NFLG,I,TOF1,PATH1,BET1,DBET1,EMAS12,DMAS1,
     -            PRO1,PKA1,PPI1,PEL1,ZTOF1)
C           CALL TFSTOR(NTR1,NFLG,I,TOF1,PATH1,TDCM,TDCP,ADCM,ADCP,
C    -            TAUM1,TAUP1,ITRC(NTR1),0.,ZTOF1)
      NOK= NOK+1
C
 1001 CONTINUE
 1000 CONTINUE
C
C=========   HEADER PART
C
                 NXX= 0
                 DO 2000 I=1,NTRK
                 IF(IRELT(1,I).NE.0) GO TO 2000
                 CALL TFSTOR(I,10,0,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
                 NXX= NXX+1
 2000            CONTINUE
            INFM(1)= NTRK
            INFM(2)= NOK
            INFM(3)= NNG
            INFM(4)= NXX
            LTFR= 14*NTRK+4
C
C=========   STORE RESULT INTO CURRENT BUFFER
C
      CALL BCRE(INTR,'TOFR',0,LTFR,*3000,IER)
      IF(INTR.EQ.0.AND.IER.EQ.2) GO TO 3000
      IF(IER.NE.0) NEXIST = NEXIST + 1
      IF(IER.NE.0.AND. NEXIST.LE.5) PRINT 301,NEXIST
  301 FORMAT('  *********   TOFR BANK ALREADY EXISTS ,OVERWRITTEN',I5)
      CALL BSTR(INTR,IW,LTFR)
      CALL BSAT(1,'TOFR')
      RETURN
 3000 CONTINUE
C/////////
             WRITE(6,9300)
9300         FORMAT(1X,'BOS ERROR IN TOFMAS')
       RETURN
       END

C   01/11/84 411011903  MEMBER NAME  RDMODV   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDMODV( IRNV, EPV, DOUBV )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 27/06/83 :  SMEAR VERTEX CHAMBER DRIFT DATA
C             R. RAMCKE
C
C   LAST MOD  J. HAGEMANN 01/10/84 :  SOME VARIABLE NAMES CHANGED
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
      COMMON / CWORKV / HWORKV(2000)
C
      DIMENSION EPV(2), DOUBV(3)
C
C------------------  C O D E  ------------------------------------------
C
C                                      POINTER OF VTXC-BANK
      IPVTXC = IDATA( IBLN( 'VTXC' ) )
      IF( IPVTXC .EQ. 0 ) RETURN
C                                      HEADER LENGTHOF VTXC-BANK
      ILHDR = IDATA(IPVTXC+1)
C                                      NUMBER OF HITS
      NHITV = ( IDATA(IPVTXC) - ILHDR ) / 2
C
C                       SCALE DOWN NUMBER OF RANDOM HITS, IF TOO MANY
      IRANV = IRNV
      IF (NHITV .GT. 450) IRANV = 0
C
C                       GENERATE RANDOM HITS IN END SECTION OF HWORK
      CALL RDRNHV( IRANV, HWORKV(NHITV*4+1) )
C
C                       MERGE ALL HITS IN HWORK
      CALL RDMRGV( NHITV, HDATA(IPVTXC*2 + ILHDR*2 + 1), IRANV, HWORKV )
      NHNEWV = NHITV + IRANV
C
C                       INEFFICIENCIES
      CALL RDIEFV( EPV, NHNEWV, HWORKV, INEFLO )
      NHDV = NHNEWV - INEFLO
C
C                       DOUBLE PULSE RESOLUTION
      IDOULO = 0
      IF( NHDV .GT. 1 ) CALL RDDOUV( DOUBV, NHNEWV, HWORKV, IDOULO )
      NHDV = NHDV - IDOULO
C
C                       ADJUST LENGTH OF BANK
      IF( NHDV .LE. 0 ) GO TO 1000
      LDV = ( NHDV - NHITV ) * 2
      IF( LDV .NE. 0 ) CALL  BCHM( IPVTXC, LDV, IER )
      CALL RDPOIV( HDATA(IPVTXC*2 + ILHDR*2 + 1), NHNEWV, HWORKV )
      RETURN
C
C
 1000 CALL BDLS( 'VTXC', IDATA(IPVTXC - 2) )
      RETURN
      END

C   03/12/83 312030144  MEMBER NAME  BRVECT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BRVECT( IUNIT, *, * )
C-----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN             :  READ MC EVENT AND FILL VECT/0
C
C        MOD  C. BOWDERY  29/06/83 :  ALSO CREATE PALL/0 BANK
C        MOD  C. BOWDERY  20/10/83 :  FOR CPROD  MACRO
C        MOD  C. BOWDERY  17/11/83 :  CALL TO MCVALI TO CHECK INPUT
C        MOD  C. BOWDERY  22/11/83 :  IMPROVED ERROR MESSAGE CONTROL
C   LAST MOD  C. BOWDERY   2/12/83 :  CHANGED MESSAG (13/14) TO (18/19)
C
C
C  READ EVENT AND FILL 4 VECTOR BANK VECT/0 AND PALL/0. THE LATTER HAS
C  INFORMATION ABOUT ALL THE PARTICLES THE GENERATOR MADE.
C
C  RETURN 1    FOR READ ERROR, NOT ENOUGH SPACE IN BCS OR BAD INPUT DATA
C  RETURN 2    FOR EOF
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL VALID
C
      COMMON / BCS /  IW(1)
C
      COMMON / CVERR / MESSAG(20)
C
#include "cprod.for"
C
C-----------------------  C O D E  -------------------------------------
C
C                                           READ EVENTS
C
      READ(IUNIT,ERR=8000,END=8100)  NEV, BEAM, PT, PHI, THETA, IFLAVR,
     *     NP, NC, NN, ( (PP(I4,N), I4=1,4), XM(N), JCH(N), JTP(N),
     *     (JP(N,I2), I2=1,2), N=1,NP),
     *     NF, NCF, NNF, ( (PF(I4,N2),I4=1,4), XMF(N2), ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
C
C                                           CHECK INPUT
C
      CALL MCVALI( VALID )
      IF( .NOT. VALID ) RETURN 1
C
C                                           CREATE VECT BANK
C
      CALL LHVECT( LENGTH )
      CALL BCRE( NPVECT, 'VECT', 0 , LENGTH, &8200, IER )
      CALL STVECT( LENGTH, IW(NPVECT+1) )
      CALL BSAW( 1, 'VECT' )
C
C                                           CREATE PALL BANK
C
      CALL LHPALL( LENGTH)
      CALL BCRE( NPALL, 'PALL', 0, LENGTH, &8300, IER )
      CALL STPALL( LENGTH, IW(NPALL + 1) )
      CALL BSAW( 1, 'PALL' )
      RETURN
C                                           READ ERROR
 8000 MESSAG(18) = MESSAG(18) + 1
      IF( MESSAG(18) .GT. 20 ) RETURN 1
C
      WRITE(6,8005) IUNIT
 8005 FORMAT(/' *** READ ERROR ***  INPUT UNIT NUMBER = ',I4,'    ***'/)
      RETURN 1
C                                           BOS ERROR (VECT)
 8200 MESSAG(19) = MESSAG(19) + 1
      IF( MESSAG(19) .GT. 20 ) RETURN 1
C
      WRITE(6,8205) IER
 8205 FORMAT(/' *** BOS ERROR ***  BCRE RETURNED ERROR CODE ',I2,
     +        '   WHILE CREATING VECT/0 IN BRVECT    ***'/)
      RETURN 1
C                                           BOS ERROR (PALL)
 8300 MESSAG(19) = MESSAG(19) + 1
      IF( MESSAG(19) .GT. 20 ) RETURN 1
C
      WRITE(6,8305) IER
 8305 FORMAT(/' *** BOS ERROR ***  BCRE RETURNED ERROR CODE ',I2,
     +        '   WHILE CREATING PALL/0 IN BRVECT    ***'/)
      RETURN 1
C                                           EOF DETECTED
 8100 RETURN 2
      END

C   01/11/84            MEMBER NAME  PBGRFI   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PBGRFI( SH1, SH2, SH3, DEFIX )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  LG AMPLITUDES  (R-FI-VIEW)
C
C  LAST MOD:   J. HAGEMANN   10/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgeo1.for"
#include "cgraph.for"
C
      COMMON /CWORK1/ R,FI,XA,COSFI,X1,Y1,YA,SINFI,X2,Y2,ZET,X3,Y3,X4,Y400001900
     +               ,IMW(200)
C
      COMMON /CJTRIG/ PI,TWOPI
C
C-----------------  C O D E  -------------------------------------------
C
C  LEAD GLASS AMPLITUDES
      CALL PBGSUM(2)
      call setcol('ECAL')     ! PMF 23/11/99: set colour
      DO 4 NROW=1,84
      IESUM=IMW(NROW)
      IF(IESUM.LE.0) GO TO 4
C CORNER POINTS, START PNT FOR TEXT
      X1 = - RLG*COS((NROW-1)*DEFIX)
      Y1 = RLG*SIN((NROW-1)*DEFIX)
      X2 = - RLG*COS(NROW*DEFIX)
      Y2 = RLG*SIN(NROW*DEFIX)
      X3 = - OUTR2*COS(NROW*DEFIX)
      Y3 = OUTR2*SIN(NROW*DEFIX)
      X4 = - OUTR2*COS((NROW-1)*DEFIX)
      Y4 = OUTR2*SIN((NROW-1)*DEFIX)
      IF((NROW.GE.22).AND.(NROW.LE.63)) GO TO 19
      XA = X4
      YA = Y4
      FI = ATAN2((Y4-Y1),(X4-X1))
      IF(FI.GT.PI*.5) FI = FI + PI
      IF(FI.LE.-PI*.5 + .001) FI = FI + PI
      GO TO 20
   19 CONTINUE
      XA = X2
      YA = Y2
      FI = ATAN2((Y3-Y2),(X3-X2))
      IF(FI.LT.0.) FI = FI + TWOPI
   20 CONTINUE
      COSFI = COS(FI)
      SINFI = SIN(FI)
C START POINT FOR TEXT
      X0 = XA + SH1*COSFI - SH2*SINFI
      Y0 = YA + SH1*SINFI + SH2*COSFI
      CALL DNUM(IESUM,X0,Y0,SH3,FI)
    4 CONTINUE
      call setcol(' ')        ! PMF 23/11/99: reset colour
      RETURN
      END

C   18/05/79            MEMBER NAME  DUMMY0   (JADEGS)      FORTRAN
C   10/04/79 C9041001   MEMBER NAME  DUMMY0   (JADESR)      FORTRAN
      SUBROUTINE DUMMY
      CALL VZERO
      RETURN
      ENTRY PATREC
      RETURN
      ENTRY LGANAL
      RETURN
      ENTRY MUANAC
      RETURN
      ENTRY MUANAF
      RETURN
      ENTRY MUANAL
      RETURN
      ENTRY MUANAJ
      RETURN
      END

C   23/09/79 106101721  MEMBER NAME  TAGFLG   (JADESR)      FORTRAN
C   12/09/79 C9091401   MEMBER NAME  TAGFLG   (S)           FORTRAN
      SUBROUTINE TAGFLG(IFLAG)
C---  TAGFLG RETURNS THE FOLLOWING NUMBERS VIA IFLAG:
C       0  IF NO LEAD-GLASS OF THE FORWARD DETECTOR IS HIT
C       1  IF THE LEAD-GLASS ENERGY OF THE MINUS Z-SIDE IS ABOVE
C             THRESHOLD (SMZ)
C       2  IF THE LEAD-GLASS ENERGY OF THE PLUS Z-SIDE IS ABOVE
C             THRESHOLD (SPZ)
C      10  IF THE TAGG-TRIGGER (SMZ.OR.SPZ) IS SET
C     100  IF THE LUMI-TRIGGER (SMZ.AND.SPZ) IS SET
C
C     H.WRIEDT     12.09.79     15:05
C     LAST MODIFICATION    14.09.79    11:30
C
C     EXTERNAL BDLM
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
      DATA I2/2/,I7/7/,I13/13/,I15/15/
      DATA ICOUNT/0/
C
      IFLAG = 0
      ICOUNT = ICOUNT + 1
C---  FETCH TRIG-POINTER
      IND = IDATA(IBLN('TRIG'))
      IF (IND.EQ.0) GOTO 2
C---  FETCH TRIG-DATA
C---  TAGG-BIT
      LAT = IDATA(IND+5)
      LLAT = JBIT(LAT,I2)
      IF (LLAT.EQ.1) IFLAG = 10
C
C---  FETCH LATC-POINTER
    2 IND = IDATA(IBLN('LATC'))
      IF (IND.EQ.0) RETURN
C---  FETCH LATC-DATA
C---  LUMI-BIT
      LAT = IDATA(IND+10)
      LLAT = JBIT(LAT,I7)
      IF (LLAT.EQ.1) IFLAG = IFLAG+100
C---  SMZ- AND SPZ-BIT
      LAT = IDATA(IND+14)
      LLAT = JBIT(LAT,I13)
      IF (LLAT.EQ.1) IFLAG = IFLAG+1
      LLAT = JBIT(LAT,I15)
      IF (LLAT.EQ.1) IFLAG = IFLAG+2
      RETURN
      END

C   22/05/84 801182011  MEMBER NAME  LOCFLD   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  22/05/84 :  LOCATE THE FIELDS IN THE COMMAND
C
C LAST MOD:   C. BOWDERY  16/07/85 :  SEPARATOR = ' ' OR ';'
C
C
C     THIS ROUTINE FINDS THE STARTING AND ENDING POSITIONS OF FIELDS IN
C     THE COMMAND STRING CHARS. THE NO. OF FOUND FIELDS IS PUT IN NFIELD
C     ISTAFL IS AN ARRAY OF STARTING POINTS; IENDFL, ENDING POINT.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  GAP
C
      LOGICAL*1  CHARS(80), CBLANK, CSEMIC
C
      DIMENSION  ISTAFL(80), IENDFL(80)
C
      DATA  CBLANK /' '/, CSEMIC /';'/
C
C-------------------  C O D E  -----------------------------------------
C
      NFIELD = 0
      GAP    = .TRUE.
C
C                            THE FOLLOWING CASES EXIST
C                                  XXXX  YYYY              (1)
C                                  XXXX; YYYY              (2)
C                                  XXXX;YYYY               (3)
C                                  XXXX ; YYYY             (4)
C                                  XXXX ;YYYY              (5)
C
      DO  20  I = 1,80
C
C                            IS THIS A SEMI-COLON ';' ?
C
        IF( CHARS(I) .NE. CSEMIC ) GO TO 8
          IF( GAP ) GO TO 4
C                                                CASES (4) AND (5)
            IENDFL(NFIELD) = I - 1
            NFIELD         = NFIELD + 1
            ISTAFL(NFIELD) = I
            IENDFL(NFIELD) = I
            GAP            = .TRUE.
            GO TO 20
C                                                CASES (2) AND (3)
   4        NFIELD         = NFIELD + 1
            ISTAFL(NFIELD) = I
            IENDFL(NFIELD) = I
            GO TO 20
C                                                CASE  (1)
C
   8    IF( .NOT. GAP  .OR.  CHARS(I) .EQ. CBLANK ) GO TO 10
          GAP            = .FALSE.
          NFIELD         = NFIELD + 1
          ISTAFL(NFIELD) = I
          GO TO 20
C
  10    IF( GAP  .OR.  CHARS(I) .NE. CBLANK ) GO TO 20
          GAP            = .TRUE.
          IENDFL(NFIELD) = I - 1
C
  20  CONTINUE
C
C                                                LAST FIELD IS A CHAR
C
      IF( .NOT. GAP ) IENDFL(NFIELD) = 80
C
      RETURN
      END

C   18/09/79            MEMBER NAME  MUTIME   (S)           FORTRAN
C   04/09/79 C9090701   MEMBER NAME  MUTIME   (S)           FORTRAN
      SUBROUTINE MUTIME(WORD)
C WRITTEN BY IAN DUERDOTH,  SEPT 6 1979.
C PRINTS OUT THE TIME LEFT FOR THE JOB AND THE TIME SINCE THE LAST CALL
C AND AN IDENTIFIER WORD ( 8CHARACTERS )
C  USE   CALL MUTIME('WORDWORD')
C  NTIME(DUM) GETS THE TIME LEFT IN 1/100 SECS
C  MODELL(MACH) GETS THE MACHINE THE JOB IS RUNNING ON
C  SCALE CONVERTS TO SECONDS AND IF ON MACHINE C (FASTER) SCALES BY 1.7
      REAL*8 WORD, ZZZZ/'ZZZZZZZZ'/
      LOGICAL FIRST /.TRUE./
      LOGICAL*1 LA/'A'/, LB/'B'/, LC/'C'/, LM
      EQUIVALENCE(MACH,LM)
      NTIM = NTIME(DUM)
      IF(FIRST) GOTO 10
   5  IF(WORD.EQ.ZZZZ) GOTO 20
      TIME =  SCALE*NTIM
      ELAPST =  SCALE*(LTIM-NTIM)
      WRITE(6,1) WORD, TIME, ELAPST
   1  FORMAT(' MUTIME AT **', A8, '**  TIME LEFT=',F6.2,'  TIME DIFF=',
     *  F6.2, 'SECS' )
      LTIM = NTIM
      RETURN
C
C  ON FIRST CALL GET THE MODEL, PRINT IT, AND SET THE SCALE.
  10  LTIM=NTIM
      FIRST = .FALSE.
      CALL MODELL(MACH)
      SCALE=0.0
      IF(LM.EQ.LA.OR.LM.EQ.LB) SCALE=0.01
      IF(LM.EQ.LC)SCALE=0.017
      WRITE(6,9)LM
    9 FORMAT(' MUTIME  -THIS JOB IS RUNNING ON MACHINE ',A1)
      IF(LM.EQ.LC) WRITE(6,91)
   91 FORMAT(' MUTIME  -PRINTED TIMES SCALED BY FACTOR 1.7 ')
      IF(SCALE.EQ.0.0)STOP
      GOTO 5
C
C  IF 'ZZZZ' THEN PASS THE SCALE TO TIMLFT
   20 WORD = SCALE
      RETURN
      END
C
C
      FUNCTION TIMLFT(DUM)
C  RETURNS THE TIME LEFT IN SECS,  EG:   A = TIMLFT(DUM)
C    DUM IS A DUMMY(UNUSED) ARGUEMENT
C  IF ON MACHINE C THE TIME IS SCALED BY 1.7
      LOGICAL SET /.FALSE./
      REAL*8 ZZZZ /'ZZZZZZZZ'/
      IF(SET) GOTO 1
C ON FIRST CALL WE HAVE TO GO AND GET THE SCALE FROM MUTIME
      CALL MUTIME(ZZZZ)
      SCALE = ZZZZ
      SET = .TRUE.
C
    1 TIMLFT =  SCALE*NTIME(DUMM)
      RETURN
      END

C   14/12/83 401111710  MEMBER NAME  USER     (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCUSER(INDX0)
      IMPLICIT NONE
************************************************************************
*
*     User routine for the standard JADE tracking simulation
*     called by subroutine WRTMCB.
*
*     This version: Nov./99  Pedro Movilla Fernandez
*                   28/05/00 PMF last mod
*
************************************************************************
      INTEGER INDX0
C
C--- I/O Parameters
      INTEGER IUNIT,JUNIT,NCALI,KUNITA,LUNITA
      COMMON/CIOUNI/IUNIT,JUNIT,NCALI,KUNITA(10),LUNITA(10)
C
C--- BOS Parameters
      INTEGER IW
      INTEGER*2 HW
      REAL AW
      COMMON /BCS/ IW(40000)
      DIMENSION HW(80000),AW(40000)
      EQUIVALENCE (HW(1),IW(1),AW(1))
C
C--- USER Parameters
C Some special BOS pointers
      INTEGER IHEAD
      INTEGER IBLN
C
C Specify bank contents to be printed
      CHARACTER*100 CBANK(1)
      DATA CBANK(1) 
     +     /'HEAD VECT PALL LATC ATOF HITL ALGN JETC PATR VTXC'/
C
C User I/O
C     JADE convention: LUN=2: Event input  (cprod files)
C                         =3: Event output (bos files)
      INTEGER NEVT
      INTEGER IOVECT,IOBOS,IOBANK
      LOGICAL LBANK,LHIST,LSTART
      COMMON / MYIO / IOVECT,IOBOS,IOBANK,LBANK,LHIST,LSTART,NEVT
C
      INTEGER I,J,K,L,M,N,INDX,ICOUNT
      INTEGER*2 H
      DATA ICOUNT /0/
      SAVE ICOUNT
C
C------------------  C O D E  ------------------------------------------
C
      INDX=1
      ICOUNT=ICOUNT+1
      IF( MOD(ICOUNT,100).EQ.0 )
     >     WRITE(*,'(A,I7,A,I7,A)') 'MCUSER: tracked ',ICOUNT
     >     ,' out of ',NEVT,' events' 
C----------------------
C EVENT SIMULATED
C----------------------
C
 1000 CONTINUE
C
C... Print out JADE bank contents in readable ASCII format
      IF( LBANK ) THEN
         WRITE(IOBANK,1900)
 1900    FORMAT(/'***'/'*** MCUSER:  EVENT SIMULATED'/'***'/)
C Print run, event, ebeam
         IHEAD=IW(IBLN('HEAD'))
         WRITE(IOBANK,'(2X,A,6I8)') 'Date',(HW(IHEAD*2+K),K=3,8)
         WRITE(IOBANK,'(3(2x,A,I8))') 'Run',HW(IHEAD*2+10)
     +        ,' Event',HW(IHEAD*2+11),' Type:',HW(IHEAD*2+12) 
         WRITE(IOBANK,'(2X,A,I8)') 'Ebeam',HW(IHEAD*2+29)
C
C Print out selected banks   
         CALL SHOWB(IOBANK,CBANK(INDX))
      ENDIF
C
C... Do some histograming
      IF( LHIST ) CALL MCFILL
C
      RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE MCBOOK
      IMPLICIT NONE
C
C Book histograms
C
C PAW
      INTEGER IDNE,IDCH,IDTRK,IDHIT,IDLG
     +     ,IDCAP,IDBAR,IDPTOT,IDPT,IDTOT
      COMMON /USERBK/ IDNE,IDCH,IDTRK,IDHIT,IDLG
     +     ,IDCAP,IDBAR,IDPTOT,IDPT,IDTOT
Code:
      IDNE=101
      IDCH=102
      IDTRK=103
      IDHIT=104
      IDLG=105
      IDCAP=106
      IDBAR=107
      IDPTOT=108
      IDPT=109
      IDTOT=110
      CALL HCDIR('//PAWC',' ')
      CALL HSTAF('YES')
      CALL HBOOK1(IDNE,'N OF NEUTR PARTICLES (INPUT)',100,0.,100.,0.)
      CALL HBOOK1(IDCH,'NO OF CHRGD PARTICLES (INPUT)',100,0.,100.,0.)
      CALL HBOOK1(IDTRK,'NO OF CHRGD PARTICLES (PATR)',100,0.,100.,0.)
      CALL HBOOK1(IDHIT,'NO OF I.D. HITS',100,0.,1500.,0. )
      CALL HBOOK1(IDLG,'LG TOT ENERGY',50,0.,50.,0. )
      CALL HBOOK1(IDCAP,'LG END CAP ENERGY',50,0.,50.,0. )
      CALL HBOOK1(IDBAR,'LG BARREL ENERGY',50,0.,50.,0. )
      CALL HBOOK1(IDPTOT,'SUM PTOT',50,0.,50.,0. )
      CALL HBOOK1(IDPT,'SUM PT',50,0.,50.,0. )
      CALL HBOOK1(IDTOT,'SUM PTOT + LG',50,0.,50.,0. )
C
      RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE MCFILL
      IMPLICIT NONE
C
C Calculate histograms
C

C BOS
      INTEGER IW
      REAL RW
      INTEGER*2 HW
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1), RW(1), IW(1))
      INTEGER IBLN
C PAW
      INTEGER NWPAW,ICYCLE,HMEMOR
      PARAMETER (NWPAW=5000000)
      COMMON /PAWC/HMEMOR(NWPAW)
      INTEGER IDNE,IDCH,IDTRK,IDHIT,IDLG
     +     ,IDCAP,IDBAR,IDPTOT,IDPT,IDTOT
      COMMON /USERBK/ IDNE,IDCH,IDTRK,IDHIT,IDLG
     +     ,IDCAP,IDBAR,IDPTOT,IDPT,IDTOT
C
      INTEGER J,I,IND,IPH,LP,IP0,IP9,NHITS,IL,IH,IC,IEC
      REAL BKGAUS,PT,PTOT,PTRANS,ACURV,ETOT,ECAP
C
C Code:
C

C
C...  # OF INPUT PARTICLES
      IND = IW( IBLN('VECT') )
      IF( IND .EQ. 0 ) GOTO 1000
      CALL HF1( IDNE, REAL( IW( IND +  6 ) ), 1. )
      CALL HF1( IDCH, REAL( IW( IND +  5 ) ), 1. )

C
C...  # OF PATR TRACKS
 1000 IND = IW( IBLN('PATR') )
      IF( IND .EQ. 0 ) GO TO 2000
      CALL HF1(IDTRK,REAL( IW( IND +  2 ) ),1.)
C
C...  MOMENTA OF PATR TRACKS
      IPH = IW( IBLN( 'HEAD' ) )
      IF( IPH .EQ. 0 ) GO TO 2000
      BKGAUS = HW( IPH*2 + 30 ) * .001
      BKGAUS = ABS( BKGAUS )
      PT = 0.
      PTOT = 0.
      LP = IW( IND + 3 )
      IP0 = IND + IW( IND + 1 )
      IP9 = IP0 + ( IW(IND+2) - 1 ) * LP
      DO 1100 J = IP0, IP9, LP
      ACURV = ABS( RW(J+25) )
      PTRANS = .3E-4 * BKGAUS / AMAX1( ACURV, 1.E-6 )
      PT = PT + PTRANS
 1100 PTOT = PTOT + PTRANS * SQRT( 1. + RW(J+30)**2 )
      CALL HF1( IDPTOT, PTOT ,1. )
      CALL HF1( IDPT, PT ,1. )
C
C...  # OF JETC HITS
 2000 IND = IW( IBLN('JETC') )
      IF( IND .EQ. 0 ) GO TO 3000
      NHITS = ( HW(IND*2+99) - HW(IND*2+3) ) / 4
      CALL HF1( IDHIT, REAL(NHITS) ,1. )
C
C...  LG ENERGY
 3000 IND = IW( IBLN('ALGN') )
      IF( IND .EQ. 0 ) GO TO 4000
      ETOT = 0.
      ECAP = 0.
C
      IL = IND*2 + 6
      IH = IL + HW(IL) - 3
      IEC = IL + HW(IND*2+4) - 3
C
      DO 3010 I = IL,IH, 2
      IF( I .LE. IEC ) GO TO 3010
      ECAP = ECAP + HW(I+2)
 3010 ETOT = ETOT + HW(I+2)
      ECAP = ECAP * .001
      ETOT = ETOT * .001
C
      CALL HF1( IDLG, ETOT, 1. )
      CALL HF1( IDCAP, ECAP, 1. )
      CALL HF1( IDBAR, ETOT - ECAP, 1. )
C
C... TOTAL ENERGY
      CALL HF1( IDTOT, ETOT + PTOT, 1. )
C
 4000 RETURN
      END
C
C-----------------------------------------------------------------------
      SUBROUTINE MCEND
      IMPLICIT NONE
C
C Save histograms
C
C
      INTEGER NWPAW,ICYCLE,HMEMOR
      PARAMETER (NWPAW=5000000)
      COMMON /PAWC/HMEMOR(NWPAW)
Code:
      CALL HCDIR('//PAWC',' ')
      CALL HLDIR('//PAWC',' ')
C
      RETURN
      END

C   01/11/84 712141947  MEMBER NAME  RDRESV   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDRESV
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 07/12/82 :  SIMULATE SPACE RESOLUTION OF
C             R. RAMCKE               VERTEX CHAMBER
C
C        MOD  J. HAGEMANN 11/10/84 :  IMPROVED CODE
C        MOD  J. HAGEMANN 05/09/86 :  FOR FASTER SIMULATION OF GAUSSIAN
C                                     DISTRIBUTION, GENERAL UPDATE
C   LAST MOD  J. HAGEMANN 11/12/87 :  R-PHI RESOLUTION (2 GAUSS SCHEME)
C
C      SMEAR DRIFT TIMES AND Z-AMPLITUDES.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cmubcs.for"
#include "cjvtxc.for"
C
      COMMON / CBINV /  DTRSVV, ZRSVV, EFFVV(2), DOUBVV(3), IRNHVV,
     +                  SMPRMV(3)
C
C------------------  C O D E  ------------------------------------------
C
C
C
      IPVTXC = IDATA( IBLN('VTXC') )
      IF( IPVTXC .EQ. 0 ) RETURN
C
C                          FIRST AND LAST ADD. OF WIRE
      ILHD = IDATA(IPVTXC+1)
      ILV  = IPVTXC*2 + ILHD*2 + 1
      IHV  = ILV + (IDATA(IPVTXC) - ILHD)*2 - 4
C
C                          LOOP OVER ALL WIRES AND SET RESOLUTIONS
C
      DO  100  J = ILV, IHV, 4
C                          DRIFT TIME
         IDT = HDATA(J + 3)
         DT  = FLOAT(IDT)*TIMEV
C
         CALL NVERT( 1.0, 0.0, G1R )
C
         IF( RN(DUMMY) .GT. SMPRMV(1) ) GO TO 10
            DTSMR = G1R*DTRSVV
            GO TO 20
   10    CONTINUE
            DTSMR = (G1R*SMPRMV(3) - SMPRMV(2))*DTRSVV
   20    CONTINUE
C
         DTREL = ABS(DT + DTSMR)/TIMEV
         HDATA(J + 3) = HFIX(AMIN1( DTREL, 32767. ))
C                          LEFT AND RIGHT AMPLITUDES
         IAL  = HDATA(J + 1)
         ZLA = FLOAT(IAL)
         CALL NVERT ( ZRESV, ZLA, ZSLA )
         HDATA(J + 1) = HFIX(ZNAMP*(1.0 + ZSLA/ZMAXV))
         HDATA(J + 2) = HFIX(ZNAMP*(1.0 - ZSLA/ZMAXV))
  100 CONTINUE
C
      RETURN
      END

C   23/06/78 601062121  MEMBER NAME  AVABS5   (JADEMC2)     FORTRAN

      FUNCTION  AVABS(ALAMDA)
C---- S.YAMADA     14-11-77
C     LAST MODIFICATION  18-10-78  21:15
C     MEASURED ATTENUATION LENGTH OF THE JADE LG IS *2 BETTER.
C
C---- CALCULATE MEAN ABSORPTION LENGTH IN SF5 FOR WAVE LENGTH ALAMDA.
C     UNIT OF ALAMDA  IS NANOO-METER.
C     UNIT   OF AVABS IS CM.
C
      IF(ALAMDA.GE.450.) GO TO  3
      IF(ALAMDA-390.) 1,2,2
CCC 1 AVABS = 10.**(0.030303*ALAMDA-10.5155)
    1 AVABS = 10.**(0.030303*ALAMDA-10.2154)
      RETURN
CCC 2 AVABS = 10.**(0.013699*ALAMDA-4.027)
    2 AVABS = 10.**(0.013699*ALAMDA-3.726)
      RETURN
CCC 3 AVABS = 10.**(0.00284*ALAMDA+0.847)
    3 AVABS = 10.**(0.00284*ALAMDA+1.148)
      RETURN
      END

C   14/03/84            MEMBER NAME  GGCLPC   (S)           FORTRAN
C   29/09/78 006261425  MEMBER NAME  GGCLPC   (S)           FORTRAN
      SUBROUTINE GGCLPC
C
C     H.WRIEDT      29-11-78
C     LAST MODIFICATION 26-06-80  14:10
C
C     ORIGINALLY WRITTEN AS 'LGCLPC' BY S.YAMADA
C     AS TO BE FOUND ON YAMLGSRC.S
C
C
C---- LEAD GLASS CLUSTERS IN THE FORWARD DETECTORS ARE PROCESSED.
C---- TOTAL PULSE HEIGHT,AVERAGE POSITION AND SPATIAL SPREAD ARE
C     CALCULATED FOR EACH CLUSTER.
C
      IMPLICIT INTEGER*4 (G), INTEGER*2 (H)
      LOGICAL LSWTCH, LACOL
C
      COMMON /CGGDMS/ X0,ZECAP(4),ZECAPX(4),THECPX(2),
     1                ECXLST(46), ECYLST(46)
      COMMON /CGGPRM/ ITHADC,MAXCLS,CLBCNS
C
      COMMON /CALICO/ FAKTOR(191)
C
      COMMON /CMSGCT/ MSGDUM(20),GGMMAX,GGMSG1,GGMSG2
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),HGGADC(2,192),IWORK2(263),
     &               ID,HTRACK(3),HCLST,HCLBEC(2),HNCLST,HCOL,HTYPE,HER,
     &               HCORR,HPBLAT,HDUMIN(2),HSCAL(36),HWORD(2),ACOLAN,
     &               ETOT(3),ENTOT(3),IWORK3(16),HCLMAP(2,51),
     &               CLSPRP(13,51)
C
      COMMON /CPLADC/ HADCBL(128),HADCCL(128),HADCZM(128),HADCZP(128),
     &                HADCEV(128),ACOLPL(102)
C
      DIMENSION HCLSPR(26,51),COSZM(3),COSZP(3)
      EQUIVALENCE (HCLSPR(1,1),CLSPRP(1,1))
C
C     HCLSPR(1,I)=NO. OF THE CLUSTER
C     HCLSPR(2,I)=JBC, +1 FOR +Z-DIRECTION (TOWARDS MARK J)
C                      -1 FOR -Z-DIRECTION (TOWARDS PLUTO/CELLO)
C                       0 FOR ILLEGAL COMPONENT NO.
C     HCLSPR(3,I)=NUMBER OF TRACKS WHICH GO THROUGH THIS CLUSTER
C     HCLSPR(4,I)=NO. OF THE FIRST TRACK WHICH GOES THROUGH THIS
C                 CLUSTER
C     HCLSPR(5,I)=NO. OF THE COLLINEAR CLUSTER
C     CLSPRP(5,I)=CLUSTER SHOWER ENERGY IN GEV
C     CLSPRP(6,I)=EXPECTED ERROR OF THE ENERGY
C     CLSPRP(7,I)=WEIGHTED AVERAGE X
C     CLSPRP(8,I)=WEIGHTED AVERAGE Y
C     CLSPRP(9,I)=SIGMA X (WEIGHTED)
C     CLSPRP(10,I)=SIGMA Y (WEIGHTED)
C     CLSPRP(11-13,I)=DIRECTION COSINES OF THE CLUSTER
C
      COMMON/ CGGVRN/ NVRSN(20)
      DATA NVCODE/278113010/
      NVRSN(10) = NVCODE
C
   10 IF (HCLST.LE.0) RETURN
C---  INITIALIZE ADC-SUMS
      ISUMZM = 0
      ISUMZP = 0
C
        DO 1 N=1,HCLST
C
        NS = HCLMAP(1,N)
        NL = HCLMAP(2,N)
        WSUM = 0.
        WTSM = 0.
        XSUM = 0.
        YSUM = 0.
        X2SM = 0.
        Y2SUM = 0.
C---  INITIALIZE ADC-SUM
        ISUMCL = 0
C
          DO 2 NN=NS,NL
          ID = HGGADC(1,NN)
          CALIF = FAKTOR(ID)
          IPART = -1
          IF (ID.EQ.47.OR.ID.EQ.48.OR.ID.EQ.95.OR.ID.EQ.96) GOTO 89
          IF(ID.LE.96) GO TO 3
          ID = ID-96
          IPART = +1
          IF (ID.EQ.47.OR.ID.EQ.48.OR.ID.GE.95) GOTO 89
    3     MB = (ID-1)/48
          IF (MB.EQ.1) ID = 95 - ID
          U = ECXLST(ID)
          V = ECYLST(ID)
          MB = (1-2*MB)*IPART
          IF (MB) 5,89,4
    4     X = U
          Y = -V
          GO TO 8
    5     X = -U
          Y = V
    8     W = HGGADC(2,NN)*CLBCNS*CALIF
          HGGADC(2,NN) = W*1000
C
C---  FILL ADC-PLOT FOR BLOCK-SUM
C     ASSUMED: 12-BIT ADCS
          IDAT = (HGGADC(2,NN)+31)/32
          HADCBL(IDAT) = HADCBL(IDAT)+1
          ISUMCL = ISUMCL + IDAT
C
C---- WEIGHT IS CHANGED TO SQRT(W)
          WT = SQRT(W)
C----     ADD W,X,X2,Y,Z2
          WSUM = WSUM+W
          WTSM = WTSM+WT
          WX = WT*X
          XSUM = XSUM+WX
          X2SM = X2SM+WX*X
          YW = Y*WT
          YSUM = YSUM+YW
          Y2SUM = Y2SUM+YW*Y
          GOTO 2
C-----    ILLEGAL COMPONENT NO.
 89       CONTINUE
          IF(GGMSG2) 12,90,90
   90     GGMSG2 = GGMSG2+1
          IF(GGMSG2.LE.GGMMAX) WRITE(6,600) NN,ID,HGGADC(1,NN)
  600     FORMAT(' LG FORWARD DETECTOR FORMAT ERROR,  ID,HGGADC(1,',I4,
     &           ')=',2I5)
   12     IF (HGGADC(2,NN).GT.10) IPART = 0
          IF (HGGADC(2,NN).LE.10) CALL GGRESQ(NN,N,&10)
C-----    BAD DATA IS SKIPPED.
    2    CONTINUE
        IF (IPART.NE.0) GOTO 6
C---  FILL CLSPRP FOR CLUSTERS FROM ILLEGAL COMPONENTS
        HCLSPR(1,N) = N
        HCLSPR(2,N) = IPART
        CLSPRP(5,N) = 0.
        CLSPRP(7,N) = 0.
        CLSPRP(8,N) = 0.
        CLSPRP(9,N) = 0.
        CLSPRP(10,N) = 0.
        CLSPRP(11,N) = 0.
        CLSPRP(12,N) = 0.
        CLSPRP(13,N) = 0.
        GOTO 1
C---  FILL ADC-PLOT FOR CLUSTER-SUM
    6   IF (ISUMCL.GT.128) ISUMCL=128
        HADCCL(ISUMCL) = HADCCL(ISUMCL)+1
        IF (IPART.EQ.-1) ISUMZM = ISUMZM+ISUMCL
        IF (IPART.EQ.+1) ISUMZP = ISUMZP+ISUMCL
C
        IF (WTSM.GT.0.) GOTO 13
        WRITE(6,610) ((HGGADC(K,J),K=1,2),J=NS,NL)
        WRITE(6,611) WTSM,XSUM,YSUM
  610   FORMAT(/' *** ENERGY-SUM = 0 ***'/20(2X,I4))
  611   FORMAT(3(2X,I4))
        AVX = 0.
        SIGX = 0.
        AVY = 0.
        SIGY = 0.
        GOTO 14
   13   AVX = XSUM/WTSM
        SIGX = X2SM/WTSM-AVX*AVX
        AVY = YSUM/WTSM
        SIGY = Y2SUM/WTSM-AVY*AVY
C---  SUM OF TOTAL ENERGIES IN EACH DETECTOR HALF
   14   XIND = IPART/2. + 2.6
        INDEX = XIND
        ETOT(INDEX) = ETOT(INDEX) + WSUM
C---  FILL CLSPRP
        HCLSPR(1,N) = N
        HCLSPR(2,N) = IPART
        CLSPRP(5,N) = WSUM
        CLSPRP(7,N) = AVX
        CLSPRP(8,N) = AVY
        CLSPRP(9,N) = SIGX
        CLSPRP(10,N) = SIGY
C       CALCULATE THETA AND PHI
        ZVALUE = ZECAP(IPART+2)
        TR = SQRT(AVX*AVX+AVY*AVY+ZVALUE*ZVALUE)
        CLSPRP(11,N) = AVX/TR
        CLSPRP(12,N) = AVY/TR
        CLSPRP(13,N) = ZVALUE/TR
C---  SEARCH CLUSTER WITH MAXIMUM ENERGY IN EACH DETECTOR HALF
        IF (N.GE.2) GOTO 20
        LSWTCH = .FALSE.
        LACOL = .FALSE.
        IF (IPART.EQ.1) GOTO 1
C---  -Z-PART
        LACOL = .TRUE.
          DO 15 I = 1,3
   15     COSZM(I) = CLSPRP(I+10,1)
        ENMAX = CLSPRP(5,1)
        GOTO 1
C
   20   IF (.NOT.LACOL) GOTO 1
        IF (LSWTCH) GOTO 40
        IF (IPART.EQ.1) GOTO 30
        IF (CLSPRP(5,N).LE.ENMAX) GOTO 1
          DO 25 I = 1,3
   25     COSZM(I) = CLSPRP(I+10,N)
        ENMAX = CLSPRP(5,N)
        GOTO 1
C---  +Z-PART
   30   LSWTCH = .TRUE.
          DO 35 I = 1,3
   35     COSZP(I) = CLSPRP(I+10,N)
        INDEX = N
        CALL GGCOLS(INDEX)
        ENMAX = CLSPRP(5,N)
        GOTO 1
C
   40   IF (CLSPRP(5,N).LE.ENMAX) GOTO 46
          DO 45 I = 1,3
   45     COSZP(I) = CLSPRP(I+10,N)
        ENMAX = CLSPRP(5,N)
   46   INDEX = N
        CALL GGCOLS(INDEX)
    1   CONTINUE
C
C---  ADD TOTAL ENERGIES OF BOTH DETECTOR HALVES
      ETOT(1) = ETOT(2) + ETOT(3)
C---  ENERGY OF CLUSTERS WITHOUT TRACKS OR LUMONITORS
        DO 50 I = 1,3
   50   ENTOT(I) = ETOT(I)
C---  FILL ADC-PLOT FOR DETECTOR HALVES-SUM AND EVENT-SUM
      ISUMEV = ISUMZM + ISUMZP
      IF (ISUMZM.GT.128) ISUMZM=128
      IF (ISUMZM.GT.0) HADCZM(ISUMZM) = HADCZM(ISUMZM) + 1
      IF (ISUMZP.GT.128) ISUMZP=128
      IF (ISUMZP.GT.0) HADCZP(ISUMZP) = HADCZP(ISUMZP) + 1
      IF (ISUMEV.GT.128) ISUMEV=128
      HADCEV(ISUMEV) = HADCEV(ISUMEV) + 1
C
C---  CALCULATE ACOLLINEARITY ANGLE
      IF (LACOL.AND.LSWTCH) ACOLAN = ACOLL(COSZM,COSZP)
C     ACOLLINEARITY ANGLE DISTRIBUTION
      CALL SORT(0.,ACOLAN,ACOLPL,0.002,100,1)
  100 RETURN
      END
      FUNCTION ACOLL(COSZM,COSZP)
C---  CALCULATE ACOLLINEARITY ANGLE BETWEEN TWO ANGLES, GIVEN BY THEIR
C     DIRECTION COSINES, COSZM AND COSZP
C
C     H.WRIEDT      31.01.79         18:40
C     LAST MODIFICATION    01.02.79     19:05
C
      DIMENSION COSZM(3), COSZP(3)
C
      SUM = 0
        DO 10 I = 1,3
  10    SUM = SUM - COSZM(I)*COSZP(I)
C
C***  CHECK COSINE RANGE
      IF (SUM.GE.-1. .AND. SUM.LE.1.) GOTO 20
      IF (SUM.GE.-1.01 .OR. SUM.LE.1.01) GOTO 15
      WRITE(6,100) SUM
 100  FORMAT(' ***** ERROR IN ACOLAN, COSINE OUT OF RANGE: ',E16.8)
      ACOLL = 9.99
      RETURN
C---  CURE ROUNDING ERROR
  15  SUM = SIGN(1.,SUM)
C
  20  ACOLL = ARCOS(SUM)
      RETURN
      END
      SUBROUTINE GGCOLS(INDEX)
C---  FIND COLLINEAR PAIRS OF CLUSTERS
C---  A PAIR OF CLUSTERS IS DEFINED AS "COLLINEAR" IF THE ACOLLINEARITY
C---  ANGLE BETWEEN THE TWO CLUSTERS IS LESS THAN 17.5 MRAD (ABOUT
C---  1 DEGREE)
C
C     H.WRIEDT     22.03.79       20:50
C     LAST MODIFICATION     11.04.79     11:10
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK(503),HCLBEC(2),HNCLST,HCOL,IWORK2(96),
     &               CLSPRP(13,51)
      DIMENSION HCLSPR(26,51),COSZM(3),COSZP(3)
      EQUIVALENCE (HCLSPR(1,1),CLSPRP(1,1))
C
        DO 5 J = 1,3
    5   COSZP(J) = CLSPRP(J+10,INDEX)
C
      N = HCLBEC(1)
        DO 10 I = 1,N
          DO 1 J = 1,3
    1     COSZM(J) = CLSPRP(J+10,I)
        IF (ACOLL(COSZM,COSZP).GT.17.5E-3) GOTO 10
        HCOL = HCOL + 1
        HCLSPR(5,INDEX) = HCLSPR(1,I)
        HCLSPR(5,I) = HCLSPR(1,INDEX)
        RETURN
   10   CONTINUE
      RETURN
      END

C   13/02/79 005110616  MEMBER NAME  TPCNST   (SOURCE)      FORTRAN
      SUBROUTINE TPCNST( NPHD )
C
C     S.YAMADA   13-02-79  22:10
C---- LAST MODIFICATION   22-08-79  10:05  E.ELSEN
C
C---- FETCH EVENT CONSTANTS FOR ANALYSIS FROM THE 'HEAD'-BANK
C
#include "cdata.for"
C
      COMMON /CTPCNS/ EBMGEV, BKGAUS, NORDFG(15)
      DATA CONVF/0.001/
C
C
      NPHD2 = NPHD + NPHD
C
      EBMGEV = 0.001*HDATA( NPHD2+29 )
      IF(EBMGEV.LT.1.) EBMGEV=1.
      BKGAUS = CONVF*HDATA( NPHD2+30)
C
C---- UNPACK THE NORD READOUT PATTERN.
      NRP = HDATA(NPHD2+13)
        DO 1 I=1,15
        NRPW = NRP/2
        NORDFG(16-I) = NRP-2*NRPW
    1   NRP = NRPW
C//////////////////////////////
C       WRITE(6,6000) EBMGEV,BKGAUS, NORDFG
C6000   FORMAT(' EBMGEV,BKGAUS=',2E12.4,'  NORDFG=',8I2,2X,8I2)
C//////////////////////////////
      RETURN
      END

C   07/06/96 606071805  MEMBER NAME  BDLMY    (S4)          FORTG1
      SUBROUTINE BDLM
C     BOS SUBPROGRAM =1.14=
#include "acs.for"
      COMMON/BCS/IW(1)
#include "star.for"
C
      IDLM=0
    1 IF(IN.LE.0) GOTO 24
      ILS=0
      JLOW=NLST
      NDEL=0
      DO 20 J=1,IN
      K=IW(NLST+J)
      I=IW(K)
      IF(I.EQ.0) GOTO 20
      IW(K)=0
      NAMDEL=NDEL
      IF(ILS.EQ.0) ILS=I
      GOTO 15
   10 I=IW(I-1)
   15 IF(I.EQ.0) GOTO 18
      NN=4+IW(I)
      JLOW=MIN0(I,JLOW)
      NDEL=NDEL+NN
      IW(I)=-NN
      IF(ILS-IW(ILS).EQ.I) GOTO 16
      ILS=I
      GOTO 10
   16 IW(ILS)=IW(ILS)-NN
      GOTO 10
   18 INAME=IW(INAMV+K)
      IF(NOTLOW(XNAME)) GOTO 20
      NCPL=NCPL-NDEL+NAMDEL
   20 CONTINUE
      IF(JLOW+NDEL-3.NE.NEXT) GOTO 22
C     LAST BANKS
      NK=1+((10*(NEXT-2))/NLAST)
      NHISTH(NK)=NHISTH(NK)+1
      NK=1+((10*NCPL)/NLAST)
      NK=MIN0(10,NK)
      NHISTL(NK)=NHISTL(NK)+1
      NCOL=NCOL+1
      NEXT=NEXT-NDEL
      GOTO 24
C     NOT LAST BANKS
   22 NFRE=NFRE+NDEL
      ILOW=MIN0(ILOW,JLOW)
C
   24 IF(IDLM.EQ.1.AND.NFRE.NE.0) CALL BGAR(IGA)
      GOTO 100
C
C     BDLG = BDLM + BGAR, BUT FASTER IN MOST CASES
      ENTRY BDLG
      IDLM=1
      GOTO 1
C
      ENTRY BPRM
      IF(IN.LE.0) GOTO 100
      DO 40 J=1,IN
      K=IW(NLST+J)
      I=IW(K)
      GOTO 35
   30 I=IW(I-1)
   35 IF(I.EQ.0) GOTO 40
      CALL BPRS(IW(I-3),IW(I-2))
      GOTO 30
   40 CONTINUE
      GOTO 100
C
      ENTRY BSLW
      IN=0
      IF(NS.EQ.0) GOTO 100
      DO 80 I=1,NS
      IF(IW(IMLST+I).EQ.0) GOTO 80
      IN=IN+1
      IW(NLST+IN)=IW(ISLST+I)
   80 CONTINUE
      GOTO 100
C
      ENTRY BSLT
      IN=NS
      IF(NS.EQ.0) GOTO 100
      DO 90 I=1,NS
   90 IW(NLST+I)=IW(ISLST+I)
      GOTO 100
C
      ENTRY BSLC
      NS=0
  100 RETURN
      END

      SUBROUTINE IGWLCM
      IMPLICIT NONE
*******************************************************************
*
*  Print welcome message of the JADE interactive graphics
*  program on the HIGZ window.
*
*  20/06/2000 Pedro Movilla Fernandez
*
******************************************************************
******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************
      REAL XDOWN,XUP,YDOWN,YUP,XMID,YMID
C
      XDOWN = XTMIN+(XTMAX-XTMIN)/6.
      XUP   = XTMAX-(XTMAX-XTMIN)/6.
      YDOWN = YTMIN+(YTMAX-YTMIN)/2.
      YUP   = YTMAX-(YTMAX-YTMIN)/4.
      XMID  = (XDOWN+XUP)/2.
C - print title 
      CALL ISELNT(NTS)
      CALL IGPAVE(XDOWN,XUP,YDOWN,YUP,200.,1000,1011,'TRS')
      CALL ISTXFP(-6,2)
      CALL ISTXCI(4)
      CALL ISCHH(100.)
      CALL ISTXAL(2,3)
      CALL ITX(XMID,YUP*.92,' J A D E ')
      CALL ITX(XMID,YUP*.85,' Interactive  Graphics  Program ')
      CALL ISCHH(50.)
      CALL ISTXAL(1,3)
      CALL ITX(XDOWN*1.3,YUP*.76,' Original version: 17/10/88')
      CALL ITX(XDOWN*1.3,YUP*.72,' Modified for use on RS6000/AIX'
     + //' platforms: 18/11/99 (Pedro Movilla Fernandez)')
      CALL ISTXAL(3,0)
      CALL ISCHH(40.)

      CALL IUWK(0,1)
      CALL ISTXCI(1)
C - reset
      CALL SETCOL(' ')
      CALL IGDEF
C
      RETURN
      END

C   12/03/84 504221644  MEMBER NAME  TAGMRK   (S)           FORTRAN
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE TAGMRK(*)
C
C
C  AUTHOR   :  A. J. FINCH
C
C       MOD :  J. M. NYE  - DOESNT RETURN 1 IF ATAG BANK NOT THERE
C                           - ALSO USES SMEARING DATE FOR MC DATA IF
C                             NO ATAG BANK.                 24/05/84
C
C  LAST MOD :  18/06/84  J. NYE  - SETS IFLMRK = -1 WHEN CALLED
C
C
C
C THIS ROUTINE SETS THE VALUE OF 'MARK' IN CWORK TO INDICATE WHICH
C TAGGER THIS IS - VALUE OF MARK          TAGGER
C                  =============          ======
C                       1                 1981/2
C                       2                 1983...
C
C IT DOES A RETURN 1 IF 'HEAD'  BANK DOESNT EXIST
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       IMPLICIT INTEGER*2 (H)
#include "cdata.for"
C
#include "cwktag.for"
C
#include "cgraph.for"
C
       LOGICAL FIRST / .TRUE. /
C
C
C-------------------------- C O D E ------------------------------------
C
C
C
C---                                     GET HEAD AND ATAG POINTERS
C
C
       INHEAD = IDATA( IBLN('HEAD') )
       INATAG = IDATA( IBLN('ATAG') )
       IF ( INHEAD .LE. 0 ) GOTO   1
C
C---                                     GET HEAD BANK DATA
C
       IHHEAD = INHEAD + INHEAD
       NRUNTG = HDATA(IHHEAD + 10)
       NDATE  = HDATA(IHHEAD +  8)
C
       IMC = 0
       IF ( NRUNTG .GT. 0 ) GOTO 200
C
C
C--------------------------------------- MONTE CARLO DATA ONLY ---------
C
C---                                     NRUNTG = 0 => MONTE CARLO DATA
C---                                     SET FLAG FOR TAGKAL ETC.
C
       IF ( NRUNTG .EQ. 0 ) IMC = 1
C
C---                                     IF ATAG BANK EXISTS THEN USE
C---                                     WORD SET BY MC SIMULATION
C
C
       IF ( INATAG .LE. 0 ) GOTO   2
       MCMARK = HDATA( 2 * INATAG + 2 )
       IF ( MCMARK .EQ. 0 ) NRUNTG =  5000
       IF ( MCMARK .EQ. 1 ) NRUNTG = 10000
       IF ( MCMARK .EQ. 2 ) NRUNTG = 15000
       GOTO 200
C
C---                                     ELSE USE SMEARING DATE
C
    2  CONTINUE
       NRUNTG = 10000
       IF ( NDATE .LE. 1980 ) NRUNTG =  5000
       IF ( NDATE .GE. 1983 ) NRUNTG = 15000
C
C
C--------------------------------------- FOR BOTH REAL AND MC DATA -----
C
C
  200  CONTINUE
C
C
C---                                     SET VALUE OF 'MARK'
C
       IF   (NRUNTG.LT. 6000)                           MARK = 0
       IF ( (NRUNTG.GE. 6000) .AND. (NRUNTG.LT.12948) ) MARK = 1
       IF   (NRUNTG.GE.12948)                           MARK = 2
C
C
C---                                     SET IFLMRK = -1 TO FLAG THAT
C---                                     TAGMRK HAS BEEN CALLED
C
       IFLMRK = -1
       FIRST  = .FALSE.
       RETURN
C
C---------------------------------------- R E T U R N   1 --------------
C
C                                        RETURN 1 IF NO HEAD BANK
C
    1  RETURN 1
       END

C   05/11/82 503042126  MEMBER NAME  DECHIF   (JADEGS)      FORTRAN
      SUBROUTINE DECHIF(P,SIGP,DE,SIGDE,FMASS,PBEST,DEBEST,CHISQR)
C
C        CALCULATES CHI SQUARE AND BEST POINT (PBEST,DEBEST) ON
C        THEORETICAL DE/DX-CURVE, DEFINED BY THE FUNCTION DETHRY.
C        THUS DEBEST=DETHRY(PBEST). THE BEST POINT IS CHOSEN TO MINIMIZE
C        THE CHI SQUARE DEVIATION FOR THE POINT (P,DE), MEASURED WITH
C        ACCURACIES GIVEN BY THE STANDARD DEVIATIONS SIGP AND SIGDE.
C        THE THEORETICAL CURVE IS FOR PIONS, OTHER PARTICLES GET THEIR
C        MOMENTA SCALED TO THE SAME BETA BEFORE THE FIT
C
C                                                 J.A.J.SKARD, 14/8/83
C        PBEST RESCALED TO CORRECT VALUE FOR PARTICLE OF MASS FMASS,
C        BEFORE RETURN TO CALLING ROUTINE.
C                                                 J.A.J.SKARD,  4/3/85
C
       EXTERNAL DETHRY
C       REQUIRED ACCURACY OF MINIMUM CHI SQUARE IS AMAX1(CHISQR*EPS,EPS)
       DATA EPS/0.01/
       SCAFAC=0.139/FMASS
       PP=P*SCAFAC
       SIGPP=SIGP*SCAFAC
       CALL CHIFT1(PP,SIGPP,DE,SIGDE,DETHRY,EPS,PPBEST,DEBEST,CHISQR)
       PBEST=PPBEST/SCAFAC
       RETURN
       END

      SUBROUTINE VTXPNT(J,XP,YP,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,DPHIT,ST) 
C*800623*DITTMANN************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXPNT)   18.9.86
C*                                                              *
C*     S U P P O R T   F O R   X Y Z   V E R T E X   F I T      *
C*                                                              *
C*860611*KLEINWORT***********************************************
C*                                                              *
C*  REWRITTEN FOR PROPER ERRORS AND USE WITH 'COMFIT'ED TRACKS  *
C*                                                              *
C*  - AS NEW PARAMETER DPHIT THE ERROR OF PHI IS CALCULATED     *
C*    ( WITHOUT MULTIPLE SCATTERING ! )                         *
C*                                                              *
C*       COMMON CWORK1 MUST BE FILLED PROPERLY                  *
C*                                                              *
C*       ENTRY: VTXS                                            *
C****************************************************************
C PMF 03.11.98 
      LOGICAL TBIT
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C
      REAL*8 XM,YM,RR,PHI,SPHI,CPHI,SR
C        ENTRY VTXPNT
C****    CALCULATE POINT XT,YT,ZT ON HELIX J WHICH IS NEAREST
C****    TO POINT XP,YP IN X-Y PROJECTION
      RR = DBLE(T(J+2))
      XM = DBLE(T(J+5)) - RR*DBLE(T(J+21))
      YM = DBLE(T(J+6)) + RR*DBLE(T(J+22))
      SR = DBLE(SIGN(1.,T(J+2)))
      PHI = DATAN2(-SR*(XM-DBLE(XP)),SR*(YM-DBLE(YP)))
      SPHI = DSIN(PHI)
      CPHI = DCOS(PHI)
      PHIT = SNGL(PHI)
      PHI = PHI - DBLE(T(J+3))
      IF (DABS(PHI).GT.3.141593D0) PHI=PHI-DSIGN(1.D0,PHI)*6.283185D0
      ST = SNGL(RR*PHI)
      XT = SNGL(XM + RR*SPHI)
      YT = SNGL(YM - RR*CPHI)
      ZT = T(J+7) + ST*T(J+23)
      SSPACE = ST
      GOTO 100
C
C
         ENTRY VTXS(J,SJ,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,DPHIT)
C****    CALCULATE POINT XT,YT,ZT ON HELIX J FOR A GIVEN
C****    PROJECTED ARC LENGTH SJ
      RR = DBLE(T(J+2))
      PHI = DBLE(SJ) / RR + DBLE(T(J+3))
      PHIT = SNGL(PHI)
      SPHI = DSIN(PHI)
      CPHI = DCOS(PHI)
      XT = SNGL(DBLE(T(J+5)) + RR*(SPHI-DBLE(T(J+21))))
      YT = SNGL(DBLE(T(J+6)) - RR*(CPHI-DBLE(T(J+22))))
      ZT = T(J+7) + SJ*T(J+23)
      SSPACE = SJ
C
C *** CALCULATION OF RPHI-ERRORS
C
  100 CONTINUE
C
      SSCOUL = SSPACE - T(J+18)
      IF ((SSCOUL.GT.0.).OR.(T(J+18).GT.0.)) SSCOUL=0.
      SSCVXC = SSPACE - T(J+19)
      IF(SSCVXC.GT.0.) SSCVXC=0.
C
      X = SSPACE - 0.5*T(J+20)
C                                      ERROR IN XY (SQUARED)
C
C                                      MULTIPLE SCATTERRING ( TANKWALL )
      DXY = ( T(J+16) * SSCOUL )**2 +
C                                      MULTIPLE SCATTERRING ( BEAMPIPE )
     *      ( T(J+17) * SSCVXC )**2 +
C                                      PARABOLA FIT
     *      ((( T(J+32)   *X + T(J+33) ) *X +
     *          T(J+34) ) *X + T(J+35) ) *X + T(J+36)
C
C                                      ERROR IN PHI (NOT SQUARED)
C
C                                      NO MULTIPLE SCATTERRING
C                                      PARABOLA FIT
      XX = 2.0 * X
      DPHIT = ( T(J+32) *XX + T(J+33) ) *XX + T(J+40)
      IF (DPHIT.GE.0.) DPHIT = SQRT( DPHIT )
C
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(ABS(DXY)))
      DXT2 = SNGL(SPHI**2) / DXY
      DYT2 = SNGL(CPHI**2) / DXY
      IF(ABS(DXT2).LT.DXYLIM) DXT2=DXYLIM
      IF(ABS(DYT2).LT.DXYLIM) DYT2=DXYLIM
      DXT2 = 1. / DXT2
      DYT2 = 1. / DYT2
C
C *** CALCULATION OF ZS-ERRORS
C
      SSPACE = SSPACE + T(J+39)
C
      SSCOUL = SSPACE - T(J+18)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      SSCVXC = SSPACE - T(J+19)
      IF(SSCVXC.GT.0.) SSCVXC=0.
C
      X = SSPACE/T(J+38) - 0.5
C                                      MULTIPLE SCATTERRING
      DZT2 = ( T(J+16) * SSCOUL )**2 + ( T(J+17) * SSCVXC )**2 +
C                                      LINE FIT (WITH TRIPLETS)
     *         T(J+37) * ( 1.5 + 18.*X**2 )
C
      RETURN
C
      END

**************************************************
*     
*     SUPERV analyses routines called
*     by SUBROUTINE USER
*
*     07/12/1999  P.A. Movilla Fernandez
*
**************************************************
      SUBROUTINE HSTDEF
      IMPLICIT NONE
**************************************************
*
*     Book histograms
*
**************************************************
* PAW
#include "cana.for"
*
      INTEGER L,ID,I
Code:
      DO L=2,9
C VECT
      IF( L.EQ.2 ) THEN
      CALL HBOOK1(ID('NNEU, VECT',-L)
     +     ,'No of neutr particles, VECT',100,0.,100.,0.)
      CALL HBOOK1(ID('NCH, VECT',-L)
     +     ,'No of chrgd particles, VECT',100,0.,100.,0.)
      ENDIF
C ALGN
      IF( L.EQ.3 ) THEN
      CALL HBOOK1(ID('LG TOT, ALGN',-L)
     +     ,'LG total energy, ALGN',50,0.,50.,0. )
      CALL HBOOK1(ID('LG EC, ALGN',-L)
     +     ,'LG end cap energy, ALGN',50,0.,50.,0. )
      CALL HBOOK1(ID('LG BAR, ALGN',-L)
     +     ,'LG barrel energy, ALGN',50,0.,50.,0. )
      ENDIF
C JETC
      IF( L.EQ.2 ) THEN
      CALL HBOOK1(ID('ID HITS',-L)
     +     ,'Number of I.D. hits, JETC',100,0.,1500.,0.)
      ENDIF
C PATR
      IF( L.EQ.5 .OR. L.EQ.7) THEN
      CALL HBOOK1(ID('PTOT, PATR',-L)
     +     ,'Sum ptot, PATR',50,0.,50.,0.)
      CALL HBOOK1(ID('PT, PATR',-L)
     +     ,'Sum pt, PATR',50,0.,50.,0. )
      CALL HBOOK1(ID('NCH, PATR',-L)
     +     ,'Number of charged particles, PATR',100,0.,100.,0.)
      ENDIF
C ZVTX
      IF( L.EQ.4 ) THEN
      CALL HBOOK1(ID('FAST Z',-L)
     +     ,'Fast z vertex, ZVTX',100,-300.,300.,0.)
      CALL HBOOK1(ID('Z HITS',-L)
     +     ,'Number of hits in z peak, ZVTX',100,0.,800.,0.)
      ENDIF
C LGCL
      IF( L.EQ.6 .OR. L.EQ.7 ) THEN
      CALL HBOOK1(ID('# CLUS TOT',-L)
     +     ,'Number of clusters, total, LGCL',80,0.,80.,0. )
      CALL HBOOK1(ID('# CLUS BAR',-L)
     +     ,'Number of clusters, barrel, LGCL',80,0.,80.,0. )
      CALL HBOOK1(ID('# CLUS +EC',-L)
     +     ,'Number of clusters, +z end cap, LGCL',80,0.,80.,0. )
      CALL HBOOK1(ID('# CLUS -EC',-L)
     +     ,'Number of clusters, -z end cap, LGCL',80,0.,80.,0. )
      
      CALL HBOOK1(ID('LG E TOT',-L)
     +     ,'LG total energy, LGCL',50,0.,50.,0. )
      CALL HBOOK1(ID('LG E BAR',-L)
     +     ,'LG barrel energy, LGCL',50,0.,50.,0. )
      CALL HBOOK1(ID('LG E +EC',-L)
     +     ,'LG +z end cap energy, LGCL',50,0.,50.,0. )
      CALL HBOOK1(ID('LG E -EC',-L)
     +     ,'LG -z end cap energy, LGCL',50,0.,50.,0. )

      CALL HBOOK1(ID('# CLUS, U',-L)
     +     ,'Number of unassociated clusters, LGCL',40,0.,40.,0. )
      CALL HBOOK1(ID('LG E TOT, U',-L)
     +     ,'Energy of unassociated clusters, total, LGCL'
     +     ,50,0.,50.,0. )
      CALL HBOOK1(ID('LG E BAR, U',-L)
     +     ,'Energy of unassociated clusters, barrel, LGCL'
     +     ,50,0.,50.,0. )
      CALL HBOOK1(ID('LG E +EC, U',-L)
     +     ,'Energy of unassociated clusters, +z end cap, LGCL'
     +     ,50,0.,50.,0. )
      CALL HBOOK1(ID('LG E -EC, U',-L)
     +     ,'Energy of unassociated clusters, -z end cap, LGCL'
     +     ,50,0.,50.,0. )
      CALL HBOOK1(ID('LG E MIN',-L)
     +     ,'LG minimum energy',100,0.,.5,0. )
      ENDIF
C
      IF( L.EQ.8 ) THEN 
C LGCL + PATR
      CALL HBOOK1(ID('P+E, PATR LGCL',-L)
     +     ,'Sum Ptot + Etot, PATR LGCL',50,0.,50.,0. )
C ALGN + PATR
      CALL HBOOK1(ID('P+E, PATR ALGN',-L)
     +     ,'Sum Ptot + Etot, PATR ALGN',50,0.,50.,0. )
      ENDIF

      ENDDO
C
      RETURN
      END
C
C
C
      SUBROUTINE HSTFLL(INDX)
      IMPLICIT NONE
**************************************************
*
*     Calculate histograms
*
**************************************************
      INTEGER INDX
* PAW
#include "cana.for"
* BOS
      INTEGER IW
      REAL RW
      INTEGER*2 HW
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1), RW(1), IW(1))
      INTEGER IBLN
*
      INTEGER J,I,IND,IPH,LP,IP0,IP9,NHITS,IL,IH,IC,IEC
      INTEGER IP1,IP2,IP3,NCLST,NWPCL,IB
      REAL BKGAUS,PT,PTOT,PTRANS,ACURV,ETOT,ECAP,LGMIN
*
      INTEGER ID
      LOGICAL LDO,LPATR(9),LALGN(9),LLGCL(9)
      REAL EPATR(9),EALGN(9),ELGCL(9)
Code:
      IF( INDX.LE.2 ) THEN
         CALL VZERO(EPATR,9)
         CALL VZERO(EALGN,9)
         CALL VZERO(ELGCL,9)
         CALL VZERO(LPATR,9)
         CALL VZERO(LALGN,9)
         CALL VZERO(LLGCL,9)
      ENDIF
C VECT
C...  # of input particles
      LDO= INDX.EQ.2
      IND = IW( IBLN('VECT') )
      IF( IND.NE.0 .AND. LDO ) THEN
         CALL HHF1('NNEU, VECT',INDX, REAL( IW( IND +  6 ) ), 1. )
         CALL HHF1('NCH, VECT' ,INDX, REAL( IW( IND +  5 ) ), 1. )
      ENDIF
C PATR
C...  # of PATR tracks
      LDO = INDX.EQ.5 .OR. INDX.EQ.7
      IND = IW( IBLN('PATR') )
      IPH = IW( IBLN('HEAD') )
      IF( IND .NE. 0 .AND. IPH .NE. 0 .AND. LDO) THEN
         CALL HHF1('NCH, PATR',INDX, REAL( IW( IND +  2 ) ), 1. )
C...  Momenta of PATR tracks
         BKGAUS = HW( IPH*2 + 30 ) * .001
         BKGAUS = ABS( BKGAUS )
         PT = 0.
         PTOT = 0.
         LP = IW( IND + 3 )
         IP0 = IND + IW( IND + 1 )
         IP9 = IP0 + ( IW(IND+2) - 1 ) * LP
         DO 1100 J = IP0, IP9, LP
            ACURV = ABS( RW(J+25) )
            PTRANS = .3E-4 * BKGAUS / AMAX1( ACURV, 1.E-6 )
            PT = PT + PTRANS
 1100       PTOT = PTOT + PTRANS * SQRT( 1. + RW(J+30)**2 )
            CALL HHF1('PTOT, PATR',INDX, PTOT ,1. )
            CALL HHF1('PT, PATR',INDX, PT ,1. )
C... save results for later use
            LPATR(INDX)=.TRUE.
            EPATR(INDX)=PTOT
      ENDIF
C JETC
C...  # OF JETC HITS
      LDO=INDX.EQ.2
      IND = IW( IBLN('JETC') )
      IF( IND .NE. 0 .AND. LDO ) THEN
         NHITS = ( HW(IND*2+99) - HW(IND*2+3) ) / 4
 72      CALL HHF1('ID HITS',INDX, REAL(NHITS) ,1. )
      ENDIF
C ZVTX
      LDO=INDX.EQ.4
      IND =  IW( IBLN('ZVTX') )
      IF( IND.NE.0 ) THEN
c         write(*,'(A4,3I)') iw(ind-3),iw(ind-2),iw(ind-1),iw(ind)
c         print *,rw(ind+1),rw(ind+4)
         CALL HHF1('FAST Z',INDX, RW(IND+1), 1. )
         CALL HHF1('Z HITS',INDX, RW(IND+4), 1. )
      ENDIF
C ALGN
C...  LG energy
      LDO=INDX.EQ.3
      IND = IW( IBLN('ALGN') )
      IF( IND .NE. 0 .AND. LDO) THEN
         ETOT = 0.
         ECAP = 0.
         IL = IND*2 + 6
         IH = IL + HW(IL) - 3
         IEC = IL + HW(IND*2+4) - 3
         DO 3010 I = IL,IH, 2
            IF( I .LE. IEC ) GO TO 3010
            ECAP = ECAP + HW(I+2)
 3010       ETOT = ETOT + HW(I+2)
         ECAP = ECAP * .001
         ETOT = ETOT * .001
C
         CALL HHF1('LG TOT, ALGN',INDX, ETOT, 1. )
         CALL HHF1('LG EC, ALGN',INDX, ECAP, 1. )
         CALL HHF1('LG BAR, ALGN',INDX, ETOT - ECAP, 1. )
C ... save for later use
         LALGN(INDX)=.TRUE.
         EALGN(INDX)=ETOT
      ENDIF
C LGCL
      LDO = INDX.EQ.6 .OR. INDX.EQ.7
      IND = IW( IBLN('LGCL') )
      IF( IND .NE.0 .AND. LDO ) THEN
         IP1 = IW( IND+1 )
         IP2 = IW( IND+2 )
         IP3 = IW( IND+3 )
         NCLST= IW( IND + IP1 + 2 )
         NWPCL= IW( IND + IP1 + 20 )
C... No of Clusters
         CALL HHF1('# CLUS TOT',INDX, REAL(IW( IND+IP1+2 )), 1. )
         CALL HHF1('# CLUS BAR',INDX, REAL(IW( IND+IP1+3 )), 1. )
         CALL HHF1('# CLUS -EC',INDX, REAL(IW( IND+IP1+4 )), 1. )
         CALL HHF1('# CLUS +EC',INDX, REAL(IW( IND+IP1+5 )), 1. )
C... Shower Energies
         CALL HHF1('LG E TOT',INDX, RW( IND+IP1+6 ), 1. )
         CALL HHF1('LG E BAR',INDX, RW( IND+IP1+7 ), 1. )
         CALL HHF1('LG E -EC',INDX, RW( IND+IP1+8 ), 1. )
         CALL HHF1('LG E +EC',INDX, RW( IND+IP1+9 ), 1. )
C... No of "Photons" ( unassociated clusters )
         CALL HHF1('# CLUS, U',INDX, REAL(IW( IND+IP1+10 )), 1. )
C... "Photon" Energies
         CALL HHF1('LG E TOT, U',INDX, RW( IND+IP1+11 ), 1. )
         CALL HHF1('LG E BAR, U',INDX, RW( IND+IP1+12 ), 1. )
         CALL HHF1('LG E -EC, U',INDX, RW( IND+IP1+13 ), 1. )
         CALL HHF1('LG E +EC, U',INDX, RW( IND+IP1+14 ), 1. )
C... Loop over clusters
         LGMIN = 1.E9
         DO I=1, NCLST
            IB = IND+IP3+(I-1)*NWPCL-1
C... Minimal shower energy            
            IF( RW(IB+2) .LT. LGMIN ) LGMIN =  RW(IB+2) 
         ENDDO
         CALL HHF1('LG E MIN',INDX, LGMIN, 1. )
C... save for later user
         LLGCL(INDX)=.TRUE.
         ELGCL(INDX)= RW( IND+IP1+6 )
      ENDIF

C TOTAL ENERGY ( TRACKS + CLUSTERS )

      IF( INDX.EQ.8 ) THEN
      IF(LALGN(3).AND.LPATR(5))
     +     CALL HHF1('P+E, PATR ALGN',INDX, EPATR(5) + EALGN(3), 1. )
      IF(LLGCL(6).AND.LPATR(5))
     +     CALL HHF1('P+E, PATR LGCL',INDX, EPATR(5) + ELGCL(6), 1. )
      ENDIF
C
 4000 RETURN
      END
C
C
C
      SUBROUTINE HSTEND(INDX)
      IMPLICIT NONE
**************************************************
*
*     Final calculations
*
**************************************************
      INTEGER INDX
C PAW
#include "cana.for"
Code:
      CALL HCDIR('//PAWC',' ')
      CALL HLDIR('//PAWC',' ')
C
      RETURN
      END
C
C
C
      SUBROUTINE HHF1(CID,IND,X,W)
      IMPLICIT NONE
*******************************************************
*
*  Calls HBOOK histogram fill routine HF1. The 
*  histogram is specified by a mnemonic CID
*  which will be converted here into a unique histo id
*  before calling HF1. The histo id corresponds
*  the mnemonic CID and the supervisor level IND which 
*  is needed in ID to calculate an level specific
*  offset for the histo id.
*
*******************************************************
      INTEGER IND
      CHARACTER CID*(*)
      REAL X,W
      INTEGER IDEN,ID
C
      IDEN=ID(CID,IND)
      IF( IDEN.GT.0 ) CALL HF1(IDEN,X,W)
C
      RETURN
      END
C
C
C
      INTEGER FUNCTION ID(CD,IND)
      IMPLICIT NONE
*******************************************************************
*
*  Administration of histogramm id's and corresponding mnemonics
*
*     INPUT:  CD  ... Character string defining the mnemonic
*             IND ... Supervisor level index with sign
*     OUTPUT: ID  ... Histo id corresponding to CD and ABS(IND)
* 
*     If a mnemonic was not yet defined, then IND must have
*     a negative sign in order to force the definition
*     of the mnemonic, otherwise the programm will abort.
*
*     If the mnemonic CD is already defined, then ID will return
*     an histogram id corresponding to CD and ABS(IND).
*     If the corresponding histogramm does not exist,
*     ID will have the value 0. At least 1 histogram corresponding 
*     to CD and one supervisor level exists, but in general there
*     does not exist respective histograms in ALL supervisor levels.
*
*     If a mnemonic CD is already defined and a histogram
*     exists corresponding to CD and ABS(IND), then it is
*     forbidden to call ID with IND.LT.0 (program will abort).
*
*******************************************************************
      CHARACTER CD*(*)
      INTEGER IND
      CHARACTER CDLIST*20(200)
      INTEGER MAX,I,ICODE
      LOGICAL HEXIST
      CHARACTER CDLIS2*1(4000)
      EQUIVALENCE (CDLIS2,CDLIST(1))
      DATA CDLIS2 /4000*' '/, ICODE/1/
      SAVE CDLIST,ICODE
Code:
      IF( CD.EQ.' '.OR. IND.EQ.1 ) THEN
         WRITE(*,901) CD,ID
 901     FORMAT('*** ERROR IN ID: Illegal arguments: CD ='
     +        ,A,' ID = ',I8)
         ID=0
         GOTO 800
      ENDIF
      DO I=1,ICODE
         IF( CD.EQ.CDLIST(I) ) THEN
            ID=I+1000000*ABS(IND)
            IF( HEXIST(ID) ) THEN
               IF( IND.GT.0 ) GOTO 999
               WRITE(*,903) CD,ID
 903           FORMAT('*** ERROR IN ID: Histogram already exists:'
     +              ,/,' CD = ',A,' ID= ',I9)
               GOTO 800
            ELSE
               IF( IND.LT.0 ) GOTO 999 ! return only id value
               ID=0
               GOTO 999
            ENDIF
         ELSE
            IF( IND.GT.0 .AND. I.EQ.ICODE ) THEN
               WRITE(*,904) CD
 904           FORMAT('*** ERROR IN ID: Histogram corresponding to '
     +              ,'CD = ',A,' is not defined yet.')
               GOTO 800
            ENDIF
         ENDIF
      ENDDO
      IF(ICODE+1.GT.200) THEN
         WRITE(*,902) ICODE+1
 902     FORMAT('*** ERROR IN ID: Maximum number of histograms'
     +        ,' exceeded, ICODE=',I8)
         ID=0
         GOTO 800
      ENDIF
      CDLIST(ICODE)=CD
      ID=ICODE+1000000*ABS(IND)
      ICODE=ICODE+1
      GOTO 999
C      
 800  WRITE(*,'(''... Will stop now!'')')
      STOP
C
 999  RETURN
      END

C   01/11/84 807251739  MEMBER NAME  NEWS     (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE NEWS
C-----------------------------------------------------------------------
C
C      PRINT NEWS OF GRAPHICS ONTO THE SCREEN
C
C-----------------------------------------------------------------------
C
      CONTINUE !CALL CLRCON PMF 03/12/99
C
      CALL TRMOUT(80,'    ******  NEWS   *****  NEWS   ******
     $  from 20.05.87^')
C
      CALL TRMOUT(80,'Command  ZFIT available for comparison of differen
     $t z-s-fits^')
C
      CALL TRMOUT(80,'    ******  NEWS   *****  NEWS   ******
     $  from 16.04.87^')
C
      CALL TRMOUT(80,'Command  HLP now with trailing nr for steering out
     $put to dest L1,L2,..^')
C
      CALL TRMOUT(80,'    ******  NEWS   *****  NEWS   ******
     $  from 12.03.87^')
C
      CALL TRMOUT(80,'Command  RES available also in FW view: results of
     $ TAGAN analysis^')
C
      CALL TRMOUT(80,'    ******  NEWS   *****  NEWS   ******
     $  from 17.09.86^')
C
      CALL TRMOUT(80,'Command J68K gives a display of the fadc data in t
     $he Jetchamber.^')
      CALL TRMOUT(80,'works only for events with J68K bank included in t
     $he readout.^')
      CALL TRMOUT(80,'    ******  VERY  H O T   NEWS   *****
     $  from 18.11.99^')
C
      CALL TRMOUT(80,'JADE event display is working again ... yeah!^')
C
      RETURN
      END

      SUBROUTINE FEHLER(IFEHL,*)
      IMPLICIT NONE
      INTEGER IFEHL
      CHARACTER*40 CMESS(100),C
      SAVE CMESS
C
      WRITE(6,'(A)') CMESS(IFEHL)
      RETURN 1
C
      ENTRY FEHLTX(IFEHL,C)
C
      IF (IFEHL.LT.1 .OR. IFEHL .GT. 100) THEN
         WRITE(6,'(''ERROR IN FEHLER: IFEHL='',I3,''  MESG='',A)') 
     +        IFEHL,C
         STOP
      ENDIF
      CALL UBLANK(CMESS(IFEHL),1,10)
      CMESS(IFEHL)=C
      RETURN
      END

C   23/06/78 704172139  MEMBER NAME  CERFUNH  (S)           FORTRAN
      FUNCTION FUNCTN(X,I,A)
C
C---- S.YAMADA         06-12-77
C---- FIT FUNCTION FOR CERENKOV LIGHT DETECTION EFFICIENCY
C
C   CALCULATES EXPLICITLY PART1-3 IN MODE 1, FOR PLOTTING
C      PARAMETER 4 IN MODE 1 IS NOW      A(4) * EXP(...)
C      I.E. WITH 4 PARAMETERS NO DEPENDENCE ON CC1 ANY MORE..
C      AUTO CHANGE FOR NTERM=2,3,4
C
      DIMENSION X(1),A(1),DELTAA(1),DERIV(2)
      COMMON /COSTB/ COST, MODE, AESS, BASI,CC,CC1,AEXPA,A4,A5,A6,A7
     $ ,PART1,PART2,PART3
C     DATA AESS/1.00/
C
      GO TO (1,2,3,3),MODE
C
C---- MODE=1
    1 CONTINUE
C---- FUNCTN=A(1)+CC(COST)*EXP(0.55*X(I))+A(2)*X(I)
C---- FUNCTN=A(1)+CC(COST)*EXP(A(3)*X(I))+A(2)*X(I)
C
C     CC1 = ((0.8751*COST-0.8362)*COST+0.3924)*COST-2.0
      CC1 = ((A4*COST+A5)*COST+A6)*COST+A7
C     CC = 10.**CC1
      CC = BASI**CC1
      IF(NTERM.GT.3) CC = A(4)
C     IF(COST.LT.-.3) CC = 0.
C---- FOR ENDCAP CC=1.5*CC
C     CC = 1.5*CC
C     EXPARG = EXP(0.55*X(I))
      ARGEXP = AEXPA*(X(I)**AESS)
      IF(NTERM.GT.2) ARGEXP = A(3)*(X(I)**AESS)
      EXPARG = EXP(ARGEXP)
C     FUNCTN = A(1)+CC*EXPARG+A(2)*X(I)
      PART1 = A(1)
      PART2 = A(2)*X(I)
      PART3 = CC*EXPARG
      FUNCTN = PART1 + PART2 + PART3
      RETURN
C
C---- MODE=2
    2 Z = X(I)**2
      GO TO 4
C---- MODE=3,4
    3 Z = X(I)
    4 FF = ((A(8)*Z+A(7))*Z+A(6))*Z
      FUNCTN = ((((FF+A(5))*Z+A(4))*Z+A(3))*Z+A(2))*Z+A(1)
      RETURN
C
C
C **************************************
C
      ENTRY FDERIV(X,I,A,DELTAA,NTERMS,DERIV)
C
C    S.YAMADA     06-12-77
C     MODIFIED  07-12-77
C----CALCULATE DERIVATIVES OF THE FIT FUNCTION FOR CEERENKOV LIGHT
C    DETECTION EFFICIENCY SIMULATION DATA.
C----DEIFFERENCIATION IS DONE FOR EACH PARAMETER.
C--        BUG IN OVERWRITING INDEX I CORRECTED 7.10.85  J.OLSSON
C
      GO TO (10,20,30,30),MODE
   10 CONTINUE
C----- J=1
      DERIV(1) = 1.
C----- J=2
      DERIV(2) = X(I)
      IF(NTERMS.LT.3) RETURN
      EXCC = EXP(A(3)*(X(I)**AESS))
C----- J=3
      DERIV(3) = CC*(X(I)**AESS)*EXCC
C     DERIV(3) = EXP(0.55*X(I))
      IF(NTERMS.LT.4) RETURN
C----- J=4
      DERIV(4) = EXCC
      RETURN
C
C---- MODE=2
   20 Z = X(I)**2
      GO TO 40
C---- MODE=3
   30 Z = X(I)
   40 DERIV(1) = 1.0
C       DO 50 I=1,7
C  50   DERIV(I+1) = DERIV(I)*Z
C   BUG BUG BUG BUG BUG BUG  !! !! !! !! !!
        DO 50 JJ=1,7
   50   DERIV(JJ+1) = DERIV(JJ)*Z
      RETURN
      END

      SUBROUTINE USER(INDEX)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cpatlm.for"
#include "czvpar.for"
#include "cworkzv.for"
#include "cjdrch.for"
#include "cutsr1.for"
      COMMON /CTLIM/ ISECLF
      COMMON /CHEADR/ HEAD(108)
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT
      COMMON/CALIBR/JPOINT(100),
     +HMUCAL(8370),HLGMAI(5760),HTAGSY(384),HJPULS(9216),
     +DELTA0(96,2),DELTA1(96,2),DELTA2(96,2),DELTA5(96,2),DELTA6(96,2)
      COMMON /CIGG/ IPRN,IGG(80),JIGG(80)
      LOGICAL*1 CHOP
      DATA LBSTRT/0/,ETAGLM/300./,LIMHIT/12/,LIMHT1/20/,MKFWU1/Z800/
      DATA MKTAGE/Z400/,MKLGLE/Z200/,MKLUMI/Z100/,MKFWMU/Z80/,MKT3/Z80/
 2000 FORMAT('1')
 2001 FORMAT('0TOTAL REDUCTION FACTOR ',F7.2,' % ')
 2002 FORMAT(' COUNTERS ',10I8)
 2003 FORMAT(' TOTAL COUNTS ',10I8)
 2004 FORMAT('  RUN AND EVENT HAS NO ZVTX BANK ',2I5)
 2005 FORMAT('  RUN AND EVENT HAS NO PATR BANK ',2I5)
 2006 FORMAT(' RUN AND EVENT ',2I6,' HAS RETURN1 IN LGCALB')
 2007 FORMAT(1H1/
     +1X,10('='),20X,10('=')/
     +1X,10('='),' START OF RUN ',I5,1X,10('=')/
     +1X,10('='),20X,10('='))
 2018 FORMAT(
     +1X,10('=')/
     +1X,10('='),' THIS RUN HAS BEEN CHOPPED'/
     +1X,10('='))
      IF(
     - INDEX.EQ.0
     -)THEN
        CALL R1MODE
        ISECLF=20
        IPRN = 1
        IPFAST = 0
        IQHEAD = IBLN('HEAD')
        IQTRIG = IBLN('TRIG')
        IQALGN = IBLN('ALGN')
        IQZVTX = IBLN('ZVTX')
        IQJETC = IBLN('JETC')
        IQPATR = IBLN('PATR')
        IQJHTL = IBLN('JHTL')
        IQMPRS = IBLN('MPRS')
      DO 13000 I = 1,80
         IGG(I) = 0
        JIGG(I) = 0
13000 CONTINUE
13001 CONTINUE
        CALL HBOOK1(1,'ZVERTEX (ALL)$',100,-2000.,2000.)
        CALL HBOOK1(2,'NHITS IN RING1 (ZVERTEX < 300 MMS)$',100,0.,400.)
        CALL HBOOK1(3,'NUMBER OF TRACKS$',100,0.,50.)
        CALL HBOOK1(4,'LG ENERGY SUM (ALL)  $',100,0.02,40000.)
        CALL HBOOK1(5,'LG ENDCAP ENERGY (BAD BLOCKS) $',100,0.,40000.)
        CALL HBOOK1(6,'TRACK CURVATURE (LONG TRACKS) $',100,-.001,.001)
        CALL HBOOK1(7,'ZMIN (TRACKS)  $',100,-1000.,1000.)
        CALL HBOOK1(8,'RMIN $',100,0.,300.)
        CALL HBOOK1(9,'REJECT INDEX$',100,0.,  100.)
        INDEX=INDEX+1
        RETURN
      ENDIF
      IF(
     - INDEX.EQ.100
     -)THEN
      DO 13002 I = 2,80
        JIGG(I) = JIGG(I) + IGG(I)
13002 CONTINUE
13003 CONTINUE
        PERCEN = (FLOAT(NRWRIT)/FLOAT(JIGG(4)))*100.
        WRITE(6,2001) PERCEN
        CALL STATUS
      DO 13004 I = 1,80
        IGG(I) = JIGG(I)
13004 CONTINUE
13005 CONTINUE
        CALL STATUS
        CALL HISTDO
        RETURN
      ENDIF
      IF(INDEX.GT.2 .AND. INDEX.LE.8) IGG(INDEX+2) = IGG(INDEX+2) + 1
16000 CONTINUE
      INDREJ = 0
      IZZZSE=INDEX
      GOTO 14002
14003 CONTINUE
        IGG(3) = IGG(3) + 1
        INDEX=INDEX+1
        IF(IGG(4).NE.0) CALL STATUS
      DO 13006 I = 2,80
          JIGG(I) = JIGG(I) + IGG(I)
          IGG(I) = 0
13006 CONTINUE
13007 CONTINUE
        IGG(1) = HEAD(18)
      PRINT2007,HEAD(18)
      IF(
     - LBSTRT.EQ.0
     -)THEN
          LBSTRT = 1
          ZFITLM(1) = 70.
          ZFITLM(2) = 35.
      ENDIF
        CHOP=.FALSE.
      IF(
     - NOTTOT.NE.0
     -)THEN
      DO 13008 I=1,NOTTOT
          IF(HEAD(18).EQ.NOTRUN(I)) CHOP=.TRUE.
13008 CONTINUE
13009 CONTINUE
      ENDIF
        IF(HEAD(18).LT.NRUNST) CHOP=.TRUE.
        IF(CHOP) PRINT2018
        RETURN
14004 CONTINUE
        INDEX = 1
        IF(CHOP) RETURN
        IF(HEAD(18).EQ.NRUNST .AND. HEAD(19).LT.NEVTST) RETURN
        IGG(4) = IGG(4) + 1
        IWRT = 0
        ILUMI = 0
        INDREJ =  1
      IF(
     - HEAD(19).LT.13
     -)THEN
      GOTO 16001
      ENDIF
        IFLW= 0
      IF(
     - HEAD(23).NE.0
     -)THEN
          IFLW = 1
          IGG(77) = IGG(77) + 1
      ENDIF
        IF(HEAD(23).NE.0) IFLW = 1
        IERRLG = 0
        CALL LGCALB(&ERRLGC)
        LBTRBT = 0
        IPTRIG = IDATA(IQTRIG)
        IF(IPTRIG.GT.0 .AND. IDATA(IPTRIG-2).EQ.1)
     +  LBTRBT = HDATA(IPTRIG*2+10)
        IF(LAND(LBTRBT,MKLUMI).NE.0) ILUMI = 1
        IMUACC=0
        IMU=0
        IPHEAD = IDATA(IQHEAD)
        IF(IPHEAD.GT.0) IMU=HDATA(IPHEAD*2+22)
        IF((LAND(LBTRBT,MKFWMU).NE.0.AND.LAND(IMU,MKT3).NE.0).OR.
     +   LAND(LBTRBT,MKFWU1).NE.0) CALL MEWT3(IMUACC)
      IF(
     - IMUACC.LE.0
     -)THEN
        CALL TRGCHK(LBTRCK,LBTRBT)
        INDREJ =  2
      IF(
     - LBTRCK.EQ.0
     -)THEN
      GOTO 16001
      ENDIF
        IACC = 0
        IF(IERRLG.EQ.0) CALL LGCUT(IACC,ECYL,ECAMI,ECAPL,ETOT)
        IF(LAND(LBTRBT,MKLGLE).EQ.0) IACC = 0
        IFTG = 0
        IF(LAND(LBTRBT,2).NE.0) CALL TAGFLG(IFTG)
        ETAG = 0.
        IF(IFTG.NE.0. .AND. LAND(LBTRBT,MKTAGE).NE.0) ETAG = ETOT
        AFTG = IFTG
        IF(IACC.NE.     0) IWRT = 1
        IF(IFLW.NE.     0) IWRT = IWRT + 2
      IF(
     - ETAG.GT.ETAGLM .AND. IWRT.EQ.0
     -)THEN
          ECENTR = 0.
          IF(IFTG.EQ.11) ECENTR = ETOT - ECAMI
          IF(IFTG.EQ.12) ECENTR = ETOT - ECAPL
          IF(IFTG.GT.12) ECENTR = ETOT
      IF(
     - ECENTR.GT.100.
     -)THEN
              IWRT = IWRT + 4
      ELSE
      ENDIF
      ENDIF
        INDREJ =  3
      IF(
     - IWRT.EQ.0 .AND. LBTRCK.EQ.16
     -)THEN
      GOTO 16001
      ENDIF
      ELSE
        IWRT=1
        IGG(2)=IGG(2)+1
      ENDIF
        IPJCA  = IDATA(IQJETC)
      IF(
     - IPJCA.LE.0
     -)THEN
          INDEX = 1
          INDREJ =  4
      IF(
     - IWRT.EQ.0
     -)THEN
      GOTO 16001
      ENDIF
          INDREJ =  5
          INDEX = 11
      GOTO 16001
      ENDIF
        INDREJ =  6
        INDEX = 4
        RETURN
14005 CONTINUE
        INDEX = 1
        INDREJ = 11
      IF(
     - LAND(IWRT,5).NE.0
     -)THEN
      GOTO 16001
      ENDIF
        IPJCA  = IDATA(IQJETC)
        IPJCA2 = IPJCA*2
        NHITR1 = (HDATA(IPJCA2+27) - HDATA(IPJCA2+3)) / 4
        IPZV   = IDATA(IQZVTX)
        IF(IPZV.LE.0) WRITE(6,2004) HEAD(18),HEAD(19)
      IF(
     - IPZV.GT.0
     -)THEN
          IFLAG  = IDATA(IPZV+6)
          ZVTX   = ADATA(IPZV+1)
          PEAK   = ADATA(IPZV+4)
          IF(IFLAG.LT.3 .AND. LBTRCK.EQ.8) IFLAG = 0
          IGG(IFLAG+26) = IGG(IFLAG+26) + 1
      IF(
     - IFLAG.LE.0
     -)THEN
            INDREJ = 12
      GOTO 16001
      ELSE
            CALL HF1(1,ZVTX,1.)
      IF(
     - ABS(ZVTX).LE.300.
     -)THEN
              ANHTR1 = NHITR1
              CALL HF1(2,ANHTR1,1.)
      ELSE
              INDREJ = 13
      GOTO 16001
      ENDIF
      ENDIF
      ELSE
          INDREJ = 14
      GOTO 16001
      ENDIF
        INDEX = 5
        RETURN
14006 CONTINUE
        INDEX = 1
        IPPATR = IDATA(IQPATR)
        IF(IPPATR.LE.0) WRITE(6,2005) HEAD(18),HEAD(19)
        INDREJ = 21
        IPPATR = IDATA(IQPATR)
        IF(IPPATR.LE.0) IWRT=1
      IF(
     - IPPATR.LE.0
     -)THEN
      GOTO 16001
      ENDIF
        INDEX = 1
        NTR    = IDATA(IPPATR+2)
        LDTR   = IDATA(IPPATR+3)
        IPTR0  = IPPATR + IDATA(IPPATR+1)
        IPTR9  = IPTR0 + (NTR-1)*LDTR
        ANTR = NTR
        CALL HF1(3,ANTR,1.)
      IF(
     - NTR.LE.0
     -)THEN
          INDREJ = 22
      GOTO 16001
      ENDIF
      IF(
     - IFTG.NE.0
     -)THEN
          ACRV=1000.
          ZMIN = 1000.
          IFTAGC = 0
      DO 13010 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+24).GT.LIMHIT
     -)THEN
              CRV = ADATA(IPTR+25)
              IF(ABS(CRV).LT.ACRV) ACRV=ABS(CRV)
      IF(
     - ABS(CRV)      .LE..00150
     -)THEN
                AZV = ADATA(IPTR+31)
                IF(ABS(AZV).LT.ABS(ZMIN)) ZMIN = AZV
      ENDIF
      ENDIF
13010 CONTINUE
13011 CONTINUE
      IF(
     - ABS(ZMIN).GT.300.
     -)THEN
            INDREJ = 23
      GOTO 16001
      ENDIF
          INDEX = 11
          IWRT = IWRT + 16
          INDREJ = 24
      GOTO 16001
      ENDIF
        LBLONG = 0
        NE100  = 0
        ZSUM   = 0
        LBEHIG = 0
        ACRV=1000.
        ZAV=0.
        ZMIN = 1000.
        IKNT=0
      DO 13012 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+33).GT.LIMHIT
     -)THEN
            LBLONG = 1
            CRV = ADATA(IPTR+25)
            AZV = ADATA(IPTR+31)
            IF(ABS(CRV).LT.ACRV) ACRV=ABS(CRV)
            CALL HF1(6,CRV,1.)
      IF(
     - ABS(CRV)      .LE..00025
     -)THEN
              LBEHIG = 1
              ZAV=ZAV+AZV
              IKNT=IKNT+1
              IF(ABS(AZV).LT.ABS(ZMIN)) ZMIN = AZV
      ELSE
      IF(
     - ABS(CRV).LT..00150 .AND.
     +           ABS(AZV).LE.300.
     -)THEN
                RSQ = ADATA(IPTR+5)**2 + ADATA(IPTR+6)**2
      IF(
     - RSQ.LT.250000.
     -)THEN
                  NE100 = NE100 + 1
                  ZSUM = AZV + ZSUM
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13012 CONTINUE
13013 CONTINUE
        ISTAR = LBEHIG*2 + LBLONG
        IF(NE100.GE.2) ISTAR = ISTAR + 4
        ASTAR = ISTAR
        IF(IKNT.GT.0) ZAV=ZAV/FLOAT(IKNT)
        IF(NE100.GE.2 .AND. LBEHIG.EQ.0) ZMIN = ZSUM/FLOAT(NE100)
      IF(
     - LBLONG.EQ.0
     -)THEN
          ETOTX = ECAMI + ECAPL
          ACRV=1000.
          IKNT=0
      DO 13014 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+24).GT.LIMHT1
     -)THEN
              LBLONG = 1
              CRV = ADATA(IPTR+25)
              IF(ABS(CRV).LT.ACRV) ACRV=ABS(CRV)
              IKNT=IKNT+1
      ENDIF
13014 CONTINUE
13015 CONTINUE
      IF(
     - LBLONG.EQ.0
     -)THEN
            INDREJ = 25
      GOTO 16001
      ENDIF
          AKNT = IKNT
          INDREJ = 26
          INDEX = 11
          IWRT = IWRT + 32
      GOTO 16001
      ENDIF
      IF(
     - LBEHIG.EQ.0 .AND. NE100.LT.2
     -)THEN
          ETOTX = ECAMI + ECAPL
          INDREJ = 27
      GOTO 16001
      ENDIF
        CALL HF1(7,ZMIN,1.)
      IF(
     - ABS(ZMIN).GT.300.
     -)THEN
          INDREJ = 28
      GOTO 16001
      ENDIF
        RMIN=10000.
      DO 13016 IPTR=IPTR0,IPTR9,LDTR
      IF(
     - IDATA(IPTR+33).GT.LIMHIT
     -)THEN
            CRV = ADATA(IPTR+25)
            AZV = ADATA(IPTR+31)
      IF(
     - ABS(CRV)      .LE..00150 .AND. ABS(AZV).LE.300.
     -)THEN
              CALL PRTOCI(IPTR,DUM1,RM,DUM2,DUM3)
              IF(RM.LT.RMIN) RMIN=RM
      ENDIF
      ENDIF
13016 CONTINUE
13017 CONTINUE
        CALL HF1(8,RMIN,1.)
        INDREJ = 29
      IF(
     - RMIN.GT.60.
     -)THEN
      GOTO 16001
      ENDIF
        INDREJ = 30
        INDEX=11
        IWRT = IWRT + 64
      GOTO 16001
14002 CONTINUE
      GOTO(
     -14003,14004,14000,14005,14006
     -), IZZZSE
14000 CONTINUE
        INDEX = INDEX + 1
14001 CONTINUE
      INDREJ = 31
      IF(.NOT.(
     - .TRUE.
     -))GOTO 16000
16001 CONTINUE
      IF(
     - INDEX.EQ.11 .OR. LAND(IWRT,5).NE.0 .AND. INDEX.NE.4
     -)THEN
      IF(
     - IDATA(IQJETC).GT.0
     -)THEN
          IPFAST = 2
          CALL INPATR
          CALL PATREC(0)
          IPPATR = IDATA(IQPATR)
          IPJHTL = IDATA(IQJHTL)
      IF(
     - IPPATR.NE.0 .AND. IDATA(IPPATR-2).EQ.10
     -)THEN
            IDATA(IPPATR-2) = 9
            IF(IPJHTL.NE.0 .AND. IDATA(IPJHTL-2).EQ.10)IDATA(IPJHTL-2)=900000591
      ENDIF
          CALL BDLS('PATR',10)
          CALL BDLS('JHTL',10)
          IPFAST = 0
          CALL INPATR
          ZFITLM(1) = 70.
          ZFITLM(2) = 35.
      ENDIF
        INDEX = 11
      ENDIF
      IF(INDEX.EQ.1 .AND. IWRT.NE.0) INDEX = 11
      IF(
     - INDEX.EQ.11
     -)THEN
        IPHEAD = IDATA(IQHEAD)*2
        IF(IPHEAD.GT.0) HDATA(IPHEAD+27) = IWRT
      ENDIF
      IF(
     - INDEX.EQ.1 .AND. ILUMI.NE.0
     -)THEN
        DATA NEVLUM /4/
        NEVLUM = NEVLUM - 1
      IF(
     - NEVLUM.LE.0
     -)THEN
          INDEX = 11
          NEVLUM = 4
          IPHEAD = IDATA(IQHEAD)*2
          IF(IPHEAD.GT.0) HDATA(IPHEAD+27) = 0
          IGG(80) = IGG(80) + 1
      ENDIF
      ENDIF
      IF(
     - INDEX.EQ.11
     -)THEN
        IGG(     79) = IGG(     79) + 1
        AWRT  = IWRT
        ATRCK = LBTRCK
      ENDIF
      ANDREJ = INDREJ
      CALL HF1(9,ANDREJ,1.)
      IF(INDREJ.GT.0) IGG(INDREJ+10) = IGG(INDREJ+10) + 1
      IF(IWRT  .GE.16 .AND. IWRT.LT.32) IWRT = 16
      IF(IWRT  .GE.64) IWRT = 18
      IF(IWRT  .GE.32) IWRT = 17
      IF(IWRT  .GT.0) IGG(IWRT+50) = IGG(IWRT+50) + 1
      IMPRT=IDATA(IQMPRS)
      IF(
     - IMPRT.GT.0.AND.INDEX.EQ.11
     -)THEN
      IRFLAG=HDATA(2*IMPRT+3)
      IF(LAND(IRFLAG,4).NE.0) IGG(19)=IGG(19)+1
      IF(LAND(IRFLAG,8).NE.0) IGG(20)=IGG(20)+1
      ENDIF
      RETURN
17000 CONTINUE
        IGG(78) = IGG(78) + 1
        IF(IGG(78).LT.20.AND.IPRN.GT.0) WRITE(6,2006) HEAD(18),HEAD(19)
        IERRLG = 1
      END

C   09/06/83 306282232  MEMBER NAME  ADCPLT   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFMAS
C
C  THIS IS THE CALIBRATION VERSION      ********************
C  USING NEW TESTFILE CUPDAT1           ********************
C
C  DETERMINES TOF FOR EACH TRACK AND ITS QUALITY
C  CREATES BANK TOFR
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "tfadc.for"
#include "tcalcm1.for"
#include "tfprm.for"
#include "ddata.for"
#include "chead.for"
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/PRPOS/PRPLS,CPOS
      DIMENSION IAGREE(3),ZT(2),TMNUS(2),TPLUS(2),DELT(2)
      DIMENSION CORM(84),CM1(84)
C
      DATA IENTRY/0/,IBUG/0/,NEXIST/0/
      DATA CVEL/ 2.9979246E2/,DTAU1/1./
      DATA RADTOF/920./
      DATA IRUN/0/,CORM/84*0./
C
      IF(IENTRY.NE.0)  GOTO 66
      IENTRY = IENTRY + 1
C     READ(16) CM1
      GOTO  67
      READ(33) CORM
      DO   19   I=1,84
   19 CORM(I) = CORM(I) + CM1(I)
      PRINT 232,CORM
  232 FORMAT(' CM1  '/(1X,10F10.3))
      PRINT 232,CORM
C
   67 ZA = NRUN
      ZB = ZA + 500.
      ZA = 8700
      ZB = 9700
      ZA = 12500
      ZB = 13000
      ZA = 13000
      ZB = 13800
      CALL CNTFIT(1,I,TM,TP,T)
C
      CALL HDELET(0)
C
      ID = 2500
      IDL= 2600
C     CALL HBOOK2(701,' CORADM NCN $',50,-10.,10.,42,0.,42.)
C     CALL HBOOK2(702,' CORADP NCN $',50,-10.,10.,42,0.,42.)
      CALL HBOOK2(ID+57,' ADCM  ITOF $',100,0.,1000.,42,0.,42.)
      CALL HBOOK2(ID+58,' ADCP  ITOF $',100,0.,1000.,42,0.,42.)
      CALL HBPROX(ID+57)
      CALL HBPROX(ID+58)
      DO   64   I=1,42
      CALL HBOOK1(ID+I,' ADC  -/+      $',100,0.,1000.)
   64 CONTINUE
   66 ZTOF = 0.
C
      NRUN = HEADR(18)
   10 IRUN = NRUN
C
      ZTOF1 = 0.
      NNG= 0
      NOK= 0
      CALL SETSL(IW,0,704*4,0)
      CALL SETSL(TAUM,0,84*4,0.)
      IBUG = IBUG + 1
      NTRR = 0
      IRESET = 0
C
      DO 1000 I=1,42
      MTPY= ICRT1(2,I)
      IF(MTPY.EQ.0) GO TO 1000
      IF(MTPY.GE.4) MTPY = 3
C
      DO   1001   M=1,MTPY
      NTR1= ICRT1(M+2,I)
C
      ZTOF1 = -2000.
      ADCM = HADC(1,I) - PEDLM(I)
      ADCP = HADC(2,I) - PEDLP(I)
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
      IF(HADC(1,I).GT.1024) ADCM = 1024.
      IF(HADC(2,I).GT.1024) ADCP = 1024.
      Z1= TRK(1,NTR1)
      PATH1= TRK(3,NTR1)
      PMEV1= TRK(4,NTR1)
      TAUM1= RAW(2,I)-Z1/VELSC
      TAUP1= RAW(3,I)+Z1/VELSC
      TAUM1 = TAUM1 - (TPARM(7)*PATH1+TPARM(8))
      TAUP1 = TAUP1 - (TPARM(7)*PATH1+TPARM(8))
      IF(NRUN.GE.10000) TAUM1= RAW(2,I)-Z1*CADCA(2*I-1)
      IF(NRUN.GE.10000) TAUP1= RAW(3,I)-Z1*CADCA(2*I  )
      PCOR = (PATH1-RADTOF)/CVEL
      TAUM1 = TAUM1 - PCOR
      TAUP1 = TAUP1 - PCOR
      IF(NRUN.LT.4993) GOTO  321
      IF(NRUN.GE.7592) GOTO  322
C  BEAM CURRENT CORR
      TAUM1 = TAUM1 - CPOS *TPARM(21)
      TAUP1 = TAUP1 - CPOS *TPARM(22)
C  AD HOC CORR SINCE BEGIN 1981
  322 TAUM1 = TAUM1 - TPARM(25)
      TAUP1 = TAUP1 - TPARM(25)
      IF(NRUN.GT.6000.AND.NRUN.LT.7592) TAUM1 = TAUM1 +3.07
      IF(NRUN.GT.6000.AND.NRUN.LT.7592) TAUP1 = TAUP1 +3.07
      IF(NRUN.LT.10000) GOTO  321
      TAUM1 = TAUM1  + 3.07
      TAUP1 = TAUP1  + 3.07
      IF(NRUN.GT.12518) TAUM1 = TAUM1 - CORM(2*I-1)
      IF(NRUN.GT.12518) TAUP1 = TAUP1 - CORM(2*I)
      IF(NRUN.GT.12518) GOTO  321
  321 CONTINUE
      CALL HFILL(ID+57,ADCM,FLOAT(I))
      CALL HFILL(ID+58,ADCP,FLOAT(I))
      ADCML = ADCM
      IF(ADCML.GT.999.) ADCML = 999.
      ADCPL = ADCP
      IF(ADCPL.GT.999.) ADCPL = 999.
      CALL HFILL(ID+I,ADCML,1.)
      CALL HFILL(ID+I,ADCPL+1000.,1.)
      NOK= NOK+1
C
 1001 CONTINUE
 1000 CONTINUE
C
      RETURN
      END

C   20/10/81 404162044  MEMBER NAME  MUREG    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUREG(IPRINT)
C-----------------------------------------------------------------------
C
C LAST CHANGE 20.00 16/04/84 CHRIS BOWDERY-BETTER TEST  NOW MADE
C      CHANGE 13.00  9/03/84 CHRIS BOWDERY-TEST TO ENSURE CAL. READ
C      CHANGE 13.00 23/11/83 HUGH MCCANN - CORRECT YOKE PARAMETERS.
C                                          ...FURTHER ITERATION !!
C      CHANGE 22.00 22/10/83 HUGH MCCANN - CORRECT YOKE PARAMETERS.
C                                          AND INDENT ENTIRE CODE.
C      CHANGE 13.30 22/02/82 HUGH MCCANN - FOR IMPROVED ERROR OUTPUT.
C                                     MUMESS O/P FOR IPRINT >= 6 * < 10.
C      CHANGE 16.05 17/06/81 JOHN ALLISON - TO EXTEND REGIONS.
C
C ABSTRACTS FROM THE MU-FILTER CONSTANTS THE REGIONS FOR /CMUREG/.
C PRINTING SUPPRESSED IF IPRINT.LT.10.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL ERROR
C
C                            COMMONS.
C
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C------------START OF MACRO CMUREG--------------------------------------
C
      COMMON /CMUREG/NREGS,XRLO(100),XRHI(100),YRLO(100),YRHI(100),
     * ZRLO(100),ZRHI(100),HRMASK(100),HRFACE(100),HRTYPE(100),
     * HRORI(100),HRFIRS(100),HRLAST(100)
C
C NREGS IS NUMBER OF REGIONS.
C XRLO ETC. ARE REGION BOUNDARIES.
C HRMASK =1 (FACE 1), =2 (FACE 2), =4 (FACE 3), =8 (FACE 4), ETC.
C HRFACE = FACE NUMBER, =1-6 FOR -X,+X,-Y,+Y,-Z,+Z.
C HRTYPE =1, MU CHAMBER SENSITIVE REGION,
C        =2, CONCRETE REGION,
C        =3, IRON REGION,
C        =4, LEAD GLASS. (IRTYPE=4 USED ONLY IN MUFFLD.)
C HRORI  = ORIENTATION OF NORMAL, =1 (|| X), =2 (||Y), =3 (|| Z).
C HRFIRS = FIRST CHAMBER NUMBER.
C HRLAST = LAST CHAMBER NUMBER.
C
C------------END OF MACRO CMUREG----------------------------------------
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C                        --- MACRO CADMIN ---
C
      LOGICAL*1 LBREAD
C
      COMMON / CADMIN / IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG,IERCAL,
     +                  ISMEAR,IJETCI,NFLAGS(10)
C
C                                 NFLAGS IS AN ARRAY OF GENERAL FLAGS
C                                   (1) : USED BY RDDATE
C                                   (2) : USED BY RDTRIG
C                                   (3) : USED BY RDTRIG
C                                   (4) : USED BY RDTRIG / PRSTAT
C                                   (5) : USED BY EVREAD -COUNTS RECORDS
C                                   (6) : USED BY SUPERV -COUNTS ERRORS
C                                   (7) : USED BY EVWRIT -'HEAD'LESS EVS
C                                   (8) : USED BY EVREAD/RDMTCO (EVWRIT)
C                                   (9) : USED BY RDMTCO/EVWRIT
C                                  (10) : FREE
C
C                                  BLOCK DATA SET IN MEMBER JADEBD
C
C
      COMMON /CMUPRN/ MUPRIN,MUHPR,IANAC,ICOOR,IANAF,LANAC,LCOOR,LANAF,
     +                ITOTAL,LTOTAL,ICUTS,LCUTS
      COMMON /CWORK/  CNLO(500),CNHI(500),CLLO(500),CLHI(500),
     +                CTLO(500),CTHI(500),IUNIT(500)
C
C                            TEMPORARY STORE FOR REGION LIMITS.
C
C                            DATA INITIALISATIION STATEMENTS.
C
      DATA NPLMAX/48/
C
      DATA ERROR/.FALSE./
C
      DATA EXTRA/500./
C
C------------------  C O D E  ------------------------------------------
C
      IF( IPRINT .GE.6  .AND  .IPRINT .LT. 10 )
     +      CALL MUMESS('MUREG ',0,'CALLED TO COMPUTE MUON REGIONS.^')
C
C                            CHANGE HSECT FOR HANGING ROOF LAYER.
C
      HSECT(39)=9
      HSECT(40)=9
      HSECT(41)=10
      HSECT(42)=10
C
C                            CLEAR CMUREG - CURRENTLY 901 WORDS.
C
      CALL VZERO(NREGS,901)
C
C                            HAS THE CALIBRATION BEEN READ PROPERLY?
C                            CHECK SOME OF THE KNOWN NUMBERS
C
      IF( HFR(1) .EQ. 0  .AND.  HFR(200) .EQ. 0 ) GO TO 95
C
C                            DO CHAMBER PLANES.
C
      HRMASK(1)=256
      HRFACE(1)=1
      HRTYPE(1)=1
      HRORI(1)=HNORM(1)
      IUNIT(1)=3
      HRFIRS(1)=HAC(1)
      C1=HDIST(1)+HD1(HAC(1))
      C2=HDIST(1)+HD1(HAC(1)+1)
      IF(C1.GT.C2)GO TO 1
         CNLO(1)=C1
         CNHI(1)=C2
         GO TO 2
 1    CONTINUE
         CNLO(1)=C2
         CNHI(1)=C1
 2    CONTINUE
      CLLO(1)=HCLLO(1)
      CLHI(1)=HCLHI(1)
      CTLO(1)=HCTLO(1)
C
      J=1
C
      DO 3 I=2,NFRAMS
          K=HCTLO(I)-HCTHI(I-1)
          IF ( HDIST(I).EQ.HDIST(I-1) .AND.
     *         IABS(K).LT.50 ) GO TO 3
C
              J=J+1
              IF(J.GT.NPLMAX)GO TO 98
C
                  IFACE=HFACE(I)
                  HRMASK(J)=2**(IFACE-1)
                  IF(HLAYER(I).EQ.1)HRMASK(J)=256*HRMASK(J)
                  HRFACE(J)=IFACE
                  HRTYPE(J)=1
                  HRORI(J)=HNORM(I)
                  IUNIT(J)=HUNIT(I)
                  HRFIRS(J)=HAC(I)
                  C1=HDIST(I)+HD1(HAC(I))
                  C2=HDIST(I)+HD1(HAC(I)+1)
                  IF(C1.GT.C2)GO TO 4
                      CNLO(J)=C1
                      CNHI(J)=C2
                      GO TO 5
 4                CONTINUE
                      CNLO(J)=C2
                      CNHI(J)=C1
 5                CONTINUE
                  CLLO(J)=HCLLO(I)
                  CLHI(J)=HCLHI(I)
                  CTLO(J)=HCTLO(I)
C
                  HRLAST(J-1)=HAL(I-1)
                  CTHI(J-1)=HCTHI(I-1)
C
 3    CONTINUE
C
      I=NFRAMS
      HRLAST(J)=HAL(I)
      CTHI(J)=HCTHI(I)
      NPLANS=J
C
C-----------------------------------------------------------------------
C
C                            YOKE.
      DO 20 I=1,4
          J=J+1
          HRORI(J)=1
          IF(I.GE.3)HRORI(J)=2
          HRMASK(J)=2**(I+7)
          HRTYPE(J)=3
          HRFACE(J)=I
          IUNIT(J)=3
          C1=HYKNMI(I)
          C2=HYKNMO(I)
          IF(C1.GT.C2)GO TO 21
              CNLO(J)=C1
              CNHI(J)=C2
              GO TO 22
 21       CONTINUE
              CNLO(J)=C2
              CNHI(J)=C1
 22       CONTINUE
          CTLO(J)=-HYKTDM(I)
          CTHI(J)=HYKTDM(I)
          CLLO(J)=-HYKLDM(I)
          CLHI(J)=HYKLDM(I)
          IF(I.EQ.3)GO TO 20
              CLLO(J)=CLLO(J)+10
              CLHI(J)=CLHI(J)-10
 20   CONTINUE
C
C-----------------------------------------------------------------------
C
C                            END PLUG.
      DO 30 I=1,2
          J=J+1
          HRORI(J)=3
          HRMASK(J)=2**(I+11)
          HRTYPE(J)=3
          HRFACE(J)=I+4
          IUNIT(J)=3
C***       CORRECTION IMPLEMENTED ON 22/10/83 : YOKE END PLATE THICKNESS
C***       SET TO 340 MM .  SEE MUFFLY.
          CNLO(J)=-(IZEIO + 340 )
          CNHI(J)=-IZEIO
C***      CNLO(J)=-IZOEP5
C***      CNHI(J)=-IZOEP1
C
          IF(I.EQ.1)GO TO 31
C
              CNLO(J)=IZEIO
              CNHI(J)=IZEIO + 340
C***          CNLO(J)=IZOEP1
C***          CNHI(J)=IZOEP5
 31       CONTINUE
C
C              CORRECTION 23/11/83 , HMCC :
C              THE YOKE END-PLATES ARE COMPLETELY CONTAINED WITHIN
C              THE SIDE- , FLOOR- AND ROOF-PLATES IN X AND Y .
C              ( I DOUBT IF ANYONE WILL EVER NOTICE ANY EFFECT OF THIS!)
C              TO BE EVEN MORE PEDANTIC , THE Y.E.P.S ACTUALLY HAVE A
C              FLANGE AT +Y WHICH GOES A COUPLE OF CMS HIGHER THAN 1759
C              MM , BUT IGNORE THAT.
          CTLO(J)=-1759
          CTHI(J)= 1759
          CLLO(J)=-1759
          CLHI(J)= 1759
C***      CTLO(J)=HYKNMO(1)
C***      CTHI(J)=HYKNMO(2)
C***      CLLO(J)=HYKNMI(3)
C***      CLHI(J)=HYKNMO(4)
 30   CONTINUE
C
C-----------------------------------------------------------------------
C
C                            ABSORBER - FACES 1-3.
      DO 40 IFACE=1,3
          DO 40 IBLK=1,3
              J=J+1
              HRMASK(J)=2**(IFACE-1)
              HRFACE(J)=IFACE
              HRTYPE(J)=2
              IF(IFACE.EQ.3)HRTYPE(J)=3
              HRORI(J)=(IFACE+1)/2
              IUNIT(J)=IFACE
              K=6*(IFACE-1)+2*(IBLK-1)+1
              C1=HBNLIM(K)
              C2=HBNLIM(K+1)
              IF(C1.GT.C2)GO TO 41
                  CNLO(J)=C1
                  CNHI(J)=C2
                  GO TO 42
 41           CONTINUE
                  CNLO(J)=C2
                  CNHI(J)=C1
 42           CONTINUE
              CTLO(J)=HBTLO(IFACE)
              CTHI(J)=HBTHI(IFACE)
              CLLO(J)=HBLLO(IFACE)
              CLHI(J)=HBLHI(IFACE)
 40   CONTINUE
C
C                            ABSORBER - FACES 4-6.
      DO 50 IFACE=4,6
          DO 50 IBLK=1,3
              DO 50 ISIDE=1,2
                  J=J+1
                  HRMASK(J)=2**(IFACE-1)
                  HRFACE(J)=IFACE
                  HRTYPE(J)=2
                  HRORI(J)=(IFACE+1)/2
                  IUNIT(J)=ISIDE+3
                  K=6*(IFACE-1)+2*(IBLK-1)+1
                  C1=HBNLIM(K)
                  C2=HBNLIM(K+1)
                  IF(C1.GT.C2)GO TO 51
                      CNLO(J)=C1
                      CNHI(J)=C2
                      GO TO 52
 51               CONTINUE
                      CNLO(J)=C2
                      CNHI(J)=C1
 52               CONTINUE
                  IGAP=50.
                  IF(IFACE.GE.5)IGAP=350.
                  IF(ISIDE.EQ.2)GO TO 53
                      CTLO(J)=HBTLO(IFACE)
                      CTHI(J)=-IGAP
                      GO TO 54
 53               CONTINUE
                      CTLO(J)=IGAP
                      CTHI(J)=HBTHI(IFACE)
 54               CONTINUE
                  CLLO(J)=HBLLO(IFACE)
                  CLHI(J)=HBLHI(IFACE)
 50   CONTINUE
C
C-----------------------------------------------------------------------
C
C                            REMAINING PIECES - (OVERHANGING ARCH).
      DO 60 IFACE=5,6
          DO 60 IBLK=1,3
              DO 60 ISIDE=1,2
                  J=J+1
                  HRMASK(J)=2**(IFACE-1)
                  HRFACE(J)=IFACE
                  HRTYPE(J)=2
                  HRORI(J)=(IFACE+1)/2
                  IUNIT(J)=ISIDE+3
                  K=6*(IFACE-1)+2*(IBLK-1)+1
                  C1=HBNLIM(K)
                  C2=HBNLIM(K+1)
                  IF(C1.GT.C2)GO TO 61
                      CNLO(J)=C1
                      CNHI(J)=C2
                      GO TO 62
 61               CONTINUE
                      CNLO(J)=C2
                      CNHI(J)=C1
 62               CONTINUE
                  IF(ISIDE.EQ.2)GO TO 63
                      CTLO(J)=-350.
                      CTHI(J)=-50.
                      GO TO 64
 63               CONTINUE
                      CTLO(J)=50.
                      CTHI(J)=350.
 64               CONTINUE
                  CLLO(J)=350.
                  CLHI(J)=HBLHI(IFACE)
 60   CONTINUE
C
C-----------------------------------------------------------------------
C
      NREGS=J
C
C                            CHANGE FROM N,L,T TO X,Y,Z.
C                            (EXTEND CHAMBER REGIONS,I.E. I .LT. NPLANS)
      E=EXTRA
      DO 6 I=1,NREGS
          IF(I.GT.NPLANS)E=0.
          IOR=HRORI(I)
          GO TO (7,8,9),IOR
 7        CONTINUE
              XRLO(I)=CNLO(I)
              XRHI(I)=CNHI(I)
              YRLO(I)=CTLO(I)-E
              YRHI(I)=CTHI(I)+E
              ZRLO(I)=CLLO(I)-E
              ZRHI(I)=CLHI(I)+E
              GO TO 6
 8        CONTINUE
              XRLO(I)=CTLO(I)-E
              XRHI(I)=CTHI(I)+E
              YRLO(I)=CNLO(I)
              YRHI(I)=CNHI(I)
              ZRLO(I)=CLLO(I)-E
              ZRHI(I)=CLHI(I)+E
              GO TO 6
 9        CONTINUE
              XRLO(I)=CTLO(I)-E
              XRHI(I)=CTHI(I)+E
              YRLO(I)=CLLO(I)-E
              YRHI(I)=CLHI(I)+E
              ZRLO(I)=CNLO(I)
              ZRHI(I)=CNHI(I)
 6    CONTINUE
C
C-----------------------------------------------------------------------
C
C                            MAKE OVERALL UNIT TRANSLATIONS.
      DO 70 I=1,NREGS
          XRLO(I)=XRLO(I)+HOVALL(IUNIT(I))
          XRHI(I)=XRHI(I)+HOVALL(IUNIT(I))
 70   CONTINUE
C
C-----------------------------------------------------------------------
C
C                            PRINT OUT CONSTANTS.
 10   CONTINUE
      IF(IPRINT.LT.10)GO TO 99
      WRITE(6,100)NREGS,
     * (I,XRLO(I),XRHI(I),YRLO(I),YRHI(I),ZRLO(I),ZRHI(I),
     * HRMASK(I),HRFACE(I),HRTYPE(I),HRORI(I),HRFIRS(I),HRLAST(I),
     * I=1,NREGS)
 100  FORMAT('1MUREG - ABSTRACTS REGIONS AS FOLLOWS...'/
     *'0',I5,' REGIONS'/
     *'0     REGION  XRLO      XRHI      YRLO      YRHI      ZRLO',
     *'      ZRHI    HRMASK    HRFACE    HRTYPE      HRORI    HRFIRS',
     *'    HRLAST'/
     *(I10,6F10.2,Z10,5I10))
      GO TO 99
C
C-----------------------------------------------------------------------
C
C                            ERROR CONDITIONS.
C
 98   IF( MUPRIN .EQ. 0 ) MUPRIN = 2
      CALL MUERRY('MUREG ',NPLMAX,'TOO MANY MU PLANES. ++ STOP ++^')
      ERROR = .TRUE.
      GO TO 10
C
C                            NO MUON CALIBRATION IS ONLY AN ERROR FOR
C                            REAL DATA. CHECK EVENT TYPE BUT BE SURE
C
 95   IF( IEVTP .GT. 0 ) GO TO 99
      IPHEAD = IDATA(IBLN('HEAD'))
      IF( IPHEAD .LE. 0 ) GO TO 99
      KRUN   = HDATA( 2*IPHEAD + 10 )
      IF( KRUN .LT. 100 ) GO TO 99
      IF( MUPRIN .EQ. 0 ) MUPRIN = 2
      CALL MUERRY('MUREG ',0,' NO MUON CALIBRATION FOUND. ++ STOP ++^')
      ERROR = .TRUE.
C
C-----------------------------------------------------------------------
C
 99   IF( .NOT. ERROR ) RETURN
      CALL BSTA
      STOP 333
      END

C   18/07/85 508031418  MEMBER NAME  EXPMAC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EXPMAC( LSTCMD, CHARS, NEXFLD, IERR )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  18/07/85 :  EXPAND THE REQUESTED MACRO
C
C LAST MOD:   C. BOWDERY   3/08/85 :  ORIGINAL COMMAND MOVED TO POS 31
C
C
C     THIS ROUTINE EXPANDS A MACRO WHICH IS POINTED TO BY LSTCMD-MACSTA
C     SO THAT ON RETURN, ARRAY CHARS CONTAINS THE COMMAND LINE. THE
C     POINTER IS SAVED ON A STACK TO ALLOW MACRO NESTING TO DEPTH 10.
C     DEPTH = 1 CONTAINS THE POINTER TO THE INVOKING COMMAND LINE SO
C     USEFUL MACRO NESTING OF 9 LEVELS IS ALLOWED.
C     NEXFLD IS THE FIELD NUMBER WHERE THE NEXT COMMAND AFTER THIS MACRO
C     STARTS. IERR > 0 IF ERROR DETECTED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS(80)
      LOGICAL*1  CDEF
C
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
C------------------  C O D E  ------------------------------------------
C
C                            SAVE THE COMMAND LINE THAT INVOKED THE
C                            MACRO UNLESS WE ARE EXPANDING A NESTED
C                            MACRO, I.E.  IS DEPTH > 1
C
      IF( MACDEP .GT. 1 ) GO TO 5
C
C                            SAVE COMMAND LINE AS 'MACRO 31'
C
        DO  2  I = 1,80
          CDEF(I,31) = CHARS(I)
   2    CONTINUE
        MACPNT(1,1) = 31
C
   5  MACPNT(2,MACDEP) = NEXFLD
      MACDEP = MACDEP + 1
      IF( MACDEP .LE. 10 ) GO TO 10
        IERR   = 1
        MACDEP = 0
        WRITE(6,7)
   7    FORMAT(' Error: Macro nesting exceeded 9 levels. Aborted.')
        RETURN
C
  10  IPNT = LSTCMD - MACSTA
      MACPNT(1,MACDEP) = IPNT
C
      DO  20  I = 1,80
        CHARS(I) = CDEF(I,IPNT)
  20  CONTINUE
      IERR   = 0
      RETURN
      END

C   23/03/97 703231322  MEMBER NAME  JEOSUM1  (JADESR)      FORTRAN
$   13/09/84 509150240  MEMBER NAME  ˘COPYLB  (JADESR)      CLIST
$
$---------------------------------------------------
$
$        COPY RUTH TAPES TO DESY AND ARCHIVE
$             (FOR REDUC1 NUMBERS > 1000)
$
$---------------------------------------------------
$
FULL OFF
V OFF OFF
SET ESCAPE='˘'
ON ERROR GOTO END
ON ATTENTION GOTO END
$
SHOW ' '
SHOW ' '
SHOW ' '
SHOW '        C-LIST TO COPY RUTH TAPES TO DESY AND ARCHIVE'
SHOW '        ============================================='
SHOW ' '
SHOW ' '
READ INTO S23 PROMPT 'IS THE MEMBER COPYMEM UPDATED ? (Y OR N) '
SHOW ' '
SET S23=SUBSTR(S23,1,1)
IF S23^='Y' GOTO END
$
READ INTO S23 PROMPT 'START SUBMISSION OF JOBS ?????  (Y OR N) '
SHOW ' '
SET S23=SUBSTR(S23,1,1)
IF S23^='Y' GOTO END
$----------------------------------
$ CREATE/CLEAR DUMMY MEMBER FOR JCL
$----------------------------------
$
SC ###JUNK
IF DIR('###JUNK') = 'T'  GOTO SKIP1
./ ADD ###JUNK
./ LABEL NOMACRO
LABEL SKIP1
$
$RINT COPYMEM DEST LOCAL
$
$-------------------
$  NEXT TAPE NUMBERS
$-------------------
$
LABEL AGAIN
READ INTO S7 PROMPT ' ' MEMBER COPYMEM USING
READ INTO S7 PROMPT ' ' MEMBER COPYMEM POINT
READ INTO S7 PROMPT ' ' MEMBER COPYMEM POINT
SET S17=SUBSTR(S7,1,3)
IF S17='END' GOTO END
SET S2=SUBSTR(S7,7,6)
SET S1=SUBSTR(S7,15,4)
SET S40='JADE˘(S1)'
$
$--------------
$ CONSTRUCT JCL
$--------------
$
C ###JUNK
D 0 900000
$
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(01,00)
//*MAIN RELPRI=MED,LINES=(2),ORG=LOCAL
//*
//*---------------------------------------------------------------------
//*
//* JOB TO COPY REDUC1 MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
//*
//* SYSUT1 = (INPUT) RUTHERFORD TAPE CONTAINING REDUC1 MERGE DATA
//*        = EPR.REDUC1.G0˘(S1)    TAPE=˘(S2)    LABEL=1
//*
//* SYSUT2 = (OUTPUT) DESY MACHINE ROOM TAPE
//*        = JADEPR.REDUCONE.G˘(S1)V00
//*
//*---------------------------------------------------------------------
//*
//* STEP 1 - THE COPY
//* =================
//*
//RUTHCOPY EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=TAPE,DISP=(OLD,KEEP),
//       DSN=EPR.REDUC1.G0˘(S1),
//       VOL=SER=(˘(S2)),
//       LABEL=(1,SL,,IN)
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.REDUCONE.G˘(S1)V00
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.G˘(S1)V00
//*
//* STEP 3 - ARCHIVE
//* ========================
//*
//ARCHIVE EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*-----------------------------------------------------------
//*
//* JOB TO MAKE A BACKUP-ARCHIVE COPY OF A REDUC1 TAPE AT DESY
//*
//* SYSUT1 = INPUT REDUC1 TAPE TO BE COPIED
//*        = JADEPR.REDUCONE.G˘(S1)V00
//*
//* SYSUT2 = OUTPUT ARCHIVE COPY TAPE
//*        = JADEPR.ARCHIVE.REDU˘(S1)
//*
//*-----------------------------------------------------------
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.REDUCONE.G˘(S1)V00
//SYSUT2 DD UNIT=ARCHIV,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.ARCHIVE.REDU˘(S1)
//
./ LABEL NOMACRO
SUB ###JUNK
SHOW '         *****   JOB ˘(S40) SUBMITTED   *****'
C COPYMEM
RENUM
DEL 200
$EAD INTO S27 PROMPT 'PRESS ENTER TO CONT.'
GOTO AGAIN
$
LABEL END
C COPYMEM
SAVE COPYMEM
SET ESCAPE=''
V ON
FULL ON
SHOW ' '
SHOW '--- END OF CLIST'
RETURN
$
$   13/09/84 507131145  MEMBER NAME  ˘COPYL-1 (JADESR)      CLIST
$
$---------------------------------------------------
$
$        COPY RUTH TAPES TO DESY AND ARCHIVE
$
$---------------------------------------------------
$
FULL OFF
V OFF OFF
SET ESCAPE='˘'
ON ERROR GOTO END
ON ATTENTION GOTO END
$
SHOW ' '
SHOW ' '
SHOW ' '
SHOW '        C-LIST TO COPY RUTH TAPES TO DESY AND ARCHIVE'
SHOW '        ============================================='
SHOW ' '
SHOW ' '
READ INTO S23 PROMPT 'IS THE MEMBER COPYMEM UPDATED ? (Y OR N) '
SHOW ' '
SET S23=SUBSTR(S23,1,1)
IF S23^='Y' GOTO END
$
READ INTO S23 PROMPT 'START SUBMISSION OF JOBS ?????  (Y OR N) '
SHOW ' '
SET S23=SUBSTR(S23,1,1)
IF S23^='Y' GOTO END
$----------------------------------
$ CREATE/CLEAR DUMMY MEMBER FOR JCL
$----------------------------------
$
SC ###JUNK
IF DIR('###JUNK') = 'T'  GOTO SKIP1
./ ADD ###JUNK
./ LABEL NOMACRO
LABEL SKIP1
$
PRINT COPYMEM DEST LOCAL
$
$-------------------
$  NEXT TAPE NUMBERS
$-------------------
$
LABEL AGAIN
READ INTO S7 PROMPT ' ' MEMBER COPYMEM USING
READ INTO S7 PROMPT ' ' MEMBER COPYMEM POINT
READ INTO S7 PROMPT ' ' MEMBER COPYMEM POINT
SET S17=SUBSTR(S7,1,3)
IF S17='END' GOTO END
SET S2=SUBSTR(S7,7,6)
SET S1=SUBSTR(S7,16,3)
SET S40='JADEC˘(S1)'
$
$--------------
$ CONSTRUCT JCL
$--------------
$
C ###JUNK
D 0 900000
$
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(01,00)
//*MAIN RELPRI=MED,LINES=(2),ORG=LOCAL
//*
//*---------------------------------------------------------------------
//*
//* JOB TO COPY REDUC1 MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
//*
//* SYSUT1 = (INPUT) RUTHERFORD TAPE CONTAINING REDUC1 MERGE DATA
//*        = JADEPR.REDUC1.G0˘(S1)    TAPE=˘(S2)    LABEL=1
//*
//* SYSUT2 = (OUTPUT) DESY MACHINE ROOM TAPE
//*        = JADEPR.REDUCONE.G0˘(S1)V00
//*
//*---------------------------------------------------------------------
//*
//* STEP 1 - THE COPY
//* =================
//*
//RUTHCOPY EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=TAPE,DISP=(OLD,KEEP),
//       DSN=JADEPR.REDUC1.G0˘(S1),
//       VOL=SER=(˘(S2)),
//       LABEL=(1,SL,,IN)
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.REDUCONE.G0˘(S1)V00
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.G0˘(S1)V00
//*
//* STEP 3 - ARCHIVE
//* ========================
//*
//ARCHIVE EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*-----------------------------------------------------------
//*
//* JOB TO MAKE A BACKUP-ARCHIVE COPY OF A REDUC1 TAPE AT DESY
//*
//* SYSUT1 = INPUT REDUC1 TAPE TO BE COPIED
//*        = JADEPR.REDUCONE.G0˘(S1)V00
//*
//* SYSUT2 = OUTPUT ARCHIVE COPY TAPE
//*        = JADEPR.ARCHIVE.REDUC˘(S1)
//*
//*-----------------------------------------------------------
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.REDUCONE.G0˘(S1)V00
//SYSUT2 DD UNIT=ARCHIV,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.ARCHIVE.REDUC˘(S1)
//
./ LABEL NOMACRO
SUB ###JUNK
SHOW '         *****   JOB ˘(S40) SUBMITTED   *****'
C COPYMEM
RENUM
DEL 200
$EAD INTO S27 PROMPT 'PRESS ENTER TO CONT.'
GOTO AGAIN
$
LABEL END
SC ###JUNK
C COPYMEM
SAVE COPYMEM
SET ESCAPE=''
V ON
FULL ON
SHOW ' '
SHOW '--- END OF CLIST'
RETURN
$
$   28/05/84 508061722 MEMBER NAME  ˘SEARCH  (BIBLS)       NEWLIB
$
$    This CLIST searches for a string in the current PS
$
$    COMMAND=> (CLSEARCH)      ( copied from F22BOW and changed )
$
$    where 'string' can be anything acceptable to the FIND command
$
$    SEARCH in other libraries:
$
$    E.g.   N 'F22PET.LUND52.S'
$           GET BIBLS(˘SEARCH)
$           (˘SEARCH)
$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
  FULL OFF
  VERIFY OFF OFF
  SET ESCAPE='%'
  ON ERROR GOTO END
  ON ATTENTION GOTO END
  SHOW ' '
  SHOW '                        SEARCH C-LIST'
  SHOW '                        ============= '
  SHOW ' '
  SHOW '(Search for different strings:  string1 | string2 ... )'
  SHOW ' '
  READ INTO S0 PROMPT 'Enter string(s) to be searched for: '
  SHOW ' '
  SHOW 'Searching for string: ' || S0
  SHOW ' '
  READ INTO S5 PROMPT 'Scip members (blank: start at the beginning):'
  SHOW ' '
  SET N1=S5+1
  SET S2=MEMBER
  SET S13=0
$
  LABEL TOP
  SET S1=MEMBER(N1)
  IF S1 = '  ' GOTO END
  FULL ON
  CHANGE %S1
  FULL OFF
  SHOW '                         ---->  ' || S1
  FIND %S0
  IF SYSRC = 0
    THEN
     VERIFY ON
     SHOW '          *******   String found in member: ' || S1
     FIND %S0
     VERIFY OFF OFF
     SHOW ' '
  ENDIF
  SET N1=N1+1
  GOTO TOP
$
  LABEL END
  SET S0 = ''
  FULL ON
  VERIFY  ON
  CHANGE %S2
  SHOW ' '
  SHOW 'SEARCH clist ended normally'
$   28/05/84 508061722: MEMBER NAME  ####JUNK (BIBLS)       NEWLIB
//JADED001 JOB '10622622',REDUCONE,CLASS=D,MSGLEVEL=(1,0),TIME=25
//*MAIN RELPRI=MED,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*          = F11LHO.JDATA15.REFORM.G0001V00
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*          = JADEPR.RED1HH.ST001
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1LD,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),
//         SPACE=(CYL,(200,50))
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.BUPDAT1
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11LHO.JDATA15.REFORM.G0001V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00000000 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
//SPOOLING EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,CATLG),
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//       DSN=JADEPR.RED1HH.ST001
//
$   28/05/84 508061722: MEMBER NAME  ###JUNK  (BIBLS)       NEWLIB
//JADE1525 JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(01,00)
//*MAIN RELPRI=HIG,LINES=(2),ORG=LOCAL
//*
//*---------------------------------------------------------------------
//*
//* JOB TO COPY REDUC1 MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
//*
//* SYSUT1 = (INPUT) RUTHERFORD TAPE CONTAINING REDUC1 MERGE DATA
//*        = EPR.REDUC1.G01525    TAPE=939562    LABEL=1
//*
//* SYSUT2 = (OUTPUT) DESY MACHINE ROOM TAPE
//*        = JADEPR.REDUCONE.G1525V00
//*
//*---------------------------------------------------------------------
//*
//* STEP 1 - THE COPY
//* =================
//*
//RUTHCOPY EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=TAPE,DISP=(OLD,KEEP),
//       DSN=EPR.REDUC1.G01525,
//       VOL=SER=(939562),
//       LABEL=(1,SL,,IN)
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.REDUCONE.G1525V00
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.G1525V00
//*
$   28/05/84 508061722: MEMBER NAME  #ARCHLB  (BIBLS)       NEWLIB
//JADEARCH JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(00,30)
//*MAIN RELPRI=MED,LINES=(2),ORG=LOCAL
//*
//*---------------------------------------------------------------------
//*
//* JOB TO COPY REDUC1 MERGE DATA TO ARCHIVE
//*
//*
//*          ARCHIVE
//*          =======
//*
//ARCHIVE EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*-----------------------------------------------------------
//*
//* JOB TO MAKE A BACKUP-ARCHIVE COPY OF A REDUC1 TAPE AT DESY
//*
//* SYSUT1 = INPUT REDUC1 TAPE TO BE COPIED
//*        = JADEPR.REDUCONE.G1338V00
//*
//* SYSUT2 = OUTPUT ARCHIVE COPY TAPE
//*        = JADEPR.ARCHIVE.REDU1338
//*
//*-----------------------------------------------------------
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.REDUCONE.G1338V00
//SYSUT2 DD UNIT=ARCHIV,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.ARCHIVE.REDU1338
//
$   19/09/84 411090927  MEMBER NAME  #ARCH1   (JADESR)      CLIST
$
$---------------------------------------------------
$
$ #ARCH1 - TO ARCHIVE REDUCONE TAPE
$ ======                          ====
$
$
FULL OFF
V OFF OFF
SET ESCAPE='˘'
SET S7 ' '
SET S8 ' '
$
$----------------------------------
$ CREATE/CLEAR DUMMY MEMBER FOR JCL
$----------------------------------
$
SC ##JUNK
IF DIR('##JUNK') = 'T'  GOTO SKIP1
./ ADD ##JUNK
./ LABEL NOMACRO
LABEL SKIP1
C ##JUNK
D 0 900000
$
$-------------------------------
$ BRANCH TO REQUIRED REDUC1 TASK
$-------------------------------
$
IF N0^=0 GOTO NOTASK
CLEAR
SHOW '      COPY OF A REDUCONE TAPE TO AN ARCHIVE TAPE'
SHOW '      =========================================='
SHOW ' '
$
$----------------------------------------------------------------------
$    COPY A RUTHERFORD WRITTEN MERGE TAPE TO A DESY M/ROOM TAPE
$----------------------------------------------------------------------
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
IF S7 = ' ' GOTO OLD
SHOW ' '
SHOW '--- REDUC1 GENERATION NUMBER IS:˘(S7)'
SHOW '--- IF THIS IS THE GENERATION NUMBER, YOU WANT PRESS ENTER'
SHOW '--- ELSE GIVE A NEW NUMBER '
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NOCHANG
GOTO RUTH
LABEL NOCHANG
SET S1 = S7
GOTO RUTH
LABEL OLD
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE COPIED (EG 470)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
$
$---------------------------------
$ RUTHERFORD TAPE SERIAL NUMBER(S)
$---------------------------------
$
LABEL RUTH
$
$-----------
$ TIME LIMIT
$-----------
$
SET S11='(1,00)'
SET S12='A'
IF LENGTH(S2)<9 GOTO CLASSA
SET S11='(2,00)'
SET S12='K'
LABEL CLASSA
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S7=S1+1
SET S40='JADEA˘(S1)'
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=˘(S12),MSGLEVEL=(1,0),TIME=˘(S11)
//*MAIN RELPRI=MED,LINES=(2)
//ARCHIVE EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*-----------------------------------------------------------
//*
//* JOB TO MAKE A BACKUP-ARCHIVE COPY OF A REDUC1 TAPE AT DESY
//*
//* SYSUT1 = INPUT REDUC1 TAPE TO BE COPIED
//*        = JADEPR.REDUCONE.G0˘(S1)V00
//*
//* SYSUT2 = OUTPUT ARCHIVE COPY TAPE
//*        = JADEPR.ARCHIVE.REDUC˘(S1)
//*
//*-----------------------------------------------------------
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.REDUCONE.G0˘(S1)V00
//SYSUT2 DD UNIT=ARCHIV,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.ARCHIVE.REDUC˘(S1)
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$-------------
$ SUBMIT JOB ?
$-------------
$
LABEL SUBMIT
RENUM ##JUNK 1 1
SHOW ' '
SHOW '--- JCL CREATED'
SHOW '--- PRESS RETURN/ENTER TO SUBMIT, ANYTHING ELSE TO TERMINATE :'
READ INTO S1 PROMPT '--> '
IF S1=' ' GOTO RUN
SHOW '--- SUBMIT TERMINATED'
SHOW '--- JCL MAY BE INSPECTED IN MEMBER ##JUNK'
GOTO KEEPJCL
LABEL RUN
SUBH ##JUNK
SHOW '--- JOB ˘(S40) SUBMITTED '
READ INTO S1 PROMPT '--- ANOTHER ONE ? ( Y(ES) OR N(O) )'
IF SUBSTR(S1,1,1)^='N' GOTO SKIP1
GOTO STOP
$
$----------------
$ TERMINATE CLIST
$----------------
$
LABEL NODEFLT
SHOW ' '
SHOW '--- THERE IS NO DEFAULT FOR THIS PARAMETER'
LABEL STOP
SC ##JUNK
LABEL KEEPJCL
SHOW ' '
SHOW '--- END OF CLIST'
SET ESCAPE=''
V ON
FULL ON
RETURN
$   28/05/84 508061722: MEMBER NAME  #ATOMLB  (BIBLS)       NEWLIB
//JADEATOM JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(00,20)
//*MAIN RELPRI=HIG,LINES=(2),ORG=LOCAL
//*
//*---------------------------------------------------------------------
//*
//*          ARCHIVE  TO  REDUCONE
//*          =====================
//*
//*   ---->  VORHER:  RETRA   !!!!!!
//*
//COP EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.ARCHIVE.REDU1200
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//       DSN=JADEPR.REDUCONE.G1200V00
//
$   28/05/84 508061722: MEMBER NAME  #COPYBAR (BIBLS)       NEWLIB
//F11BAR   JOB '10622622',CLASS=K,TIME=(02,00),MSGLEVEL=(1,1)
//*MAIN RELPRI=HIG
// EXEC FCLG,REGION.GO=800K
C
C           COPY MULTIHADRON EVENTS
C             IN BOS FORMAT
C
#include "bdata.for"
C
      DATA   IUNIT   /11/
      DATA   IUNOUT  / 4/
      DATA   NFILE   / 4/
      DATA   NEVT    / 1000000 /
C
C
      CALL BINT(40000,20000,500,500)
      CALL BWRO(IUNOUT,1558,2)
C
    1 NEVT = NEVT - 1
      IF(NEVT.LT.0) GO TO 2
      CALL BSLT
      CALL BDLG
      CALL BREAD(IUNIT,&1001,&1002)
      CALL BSLW
      CALL BWRITE( IUNOUT )
C
      GOTO 1
C
 1001 WRITE(6,104)
  104 FORMAT(X,'****** EVENT READ ERROR ******')
      GOTO 1
C
 1002 WRITE(6,105) IUNIT
  105 FORMAT(X,'***  END OF FILE ON UNIT ',I3)
      NFILE = NFILE -1
      IF( NFILE.EQ.0) GO TO 2
      GOTO 1
C
    2 CONTINUE
      CALL BMLT(0,DUMMY)
      CALL BWRITE(IUNOUT)
      CALL BSTA
      CALL PALL
      STOP
      END
//LKED.SYSLIB DD
//            DD
//            DD DSN=F11MEI.DEVL,DISP=SHR,UNIT=FAST
//            DD DSN=F11LHO.JADEGL,DISP=SHR,UNIT=FAST
//            DD DSN=F11GOD.PATRECLD,DISP=SHR,UNIT=FAST
//            DD DSN=F1EBLO.BOSLIB.L,DISP=SHR,UNIT=FAST
//            DD DSN=R01UTL.CERN.GENLIB4,DISP=SHR
//            DD DSN=R01UTL.CERN.PACKLIB4,DISP=SHR
//LKED.SYSIN DD *
//*---------------- INPUT ----------------------------------------------
//GO.FT11F001 DD DSN=JADEPR.RED1HH.ST161,DISP=OLD,UNIT=TAPE
//GO.FT11F002 DD DSN=JADEPR.RED1HH.ST161A,
//    UNIT=AFF=FT11F001,DISP=SHR
//GO.FT11F003 DD DSN=JADEPR.RED1HH.ST162,
//    UNIT=AFF=FT11F001,DISP=SHR
//GO.FT11F004 DD DSN=JADEPR.RED1HH.ST163,
//    UNIT=AFF=FT11F001,DISP=SHR
//*
//*---------------- OUTPUT ---------------------------------------------
//GO.FT04F001 DD DSN=JADEPR.REDUC1HH.G0074V00,DISP=(NEW,CATLG,CATLG),
//    UNIT=TAPE
//*O.FT04F001 DD DUMMY
$   28/05/84 508061722: MEMBER NAME  #COPYLB  (BIBLS)       NEWLIB
//JADEPRCP JOB CLASS=A,MSGLEVEL=(2,0),TIME=(00,20)
//*MAIN RELPRI=HIG,LINES=2
//*MAIN ORG=EXT
// EXEC GEP,PARM.LKED='SIZE=(600K,60K)',REGION.LKED=800K,
//  REGION.GO=1100K
//COMP.SYSIN  DD *
#include "copylb.for"
//*
//*
//*       ***************   COPY  JOB    *********************
//*
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=F11BEK.USER.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11BEK.BIBLL
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*
//*         -------   INPUT   -------
//*
//GO.FT02F001 DD DISP=SHR,DSN=JADEPR.RED1HH.ST068
//*
//*         -------   OUTPUT  -------
//*
//*O.FT03F001 DD  DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*    MSVGP=VTMP,UNIT=3330V,
//*    DSN=JADEPR.TMP.RED1HELP.R124T
//*
//GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),
//    DCB=(R01DCB.VBS,LRECL=6236),SPACE=(TRK,(300,50),RLSE),
//    DSN=JADEPR.TMP.RED1HH.ST068
//*
//*O.FT03F001 DD DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,UNIT=TAPE,
//*   DSN=F11BEK.WAT.Z84B
//*
//*
//GO.FT03F001 DD DUMMY
//GO.FT04F001 DD DUMMY
//*            -------- GEP ---------
//GO.SYSIN DD *
PRINT
DST 10  '      RUN - NUMBER  OF  WRITTEN  EVENTS
ENDQ
$   13/09/84 411090926  MEMBER NAME  #COPYR   (JADESR)      CLIST
$
$---------------------------------------------------
$
$ #COPYR - TO COPY RUTH TAPES TO DESY AND ARCHIVE
$ ======                          ====
$
$
FULL OFF
V OFF OFF
SET ESCAPE='˘'
ON ERROR GOTO END
ON ATTENTION GOTO END
SET S7 ' '
SET S8 ' '
$
$----------------------------------
$ CREATE/CLEAR DUMMY MEMBER FOR JCL
$----------------------------------
$
SC ###JUNK
IF DIR('###JUNK') = 'T'  GOTO SKIP1
./ ADD ###JUNK
./ LABEL NOMACRO
LABEL SKIP1
C ###JUNK
D 0 900000
$
$-------------------------------
$ BRANCH TO REQUIRED REDUC1 TASK
$-------------------------------
$
IF N0^=0 GOTO NOTASK
CLEAR
SHOW '      COPY OF A RUTH TAPE TO A DESY TAPE AND ADDITIOAL ARCHIVE'
SHOW '      ============================================'
SHOW ' '
$
$----------------------------------------------------------------------
$    COPY A RUTHERFORD WRITTEN MERGE TAPE TO A DESY M/ROOM TAPE
$----------------------------------------------------------------------
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
IF S7 = ' ' GOTO OLD
SHOW ' '
SHOW '--- REDUC1 GENERATION NUMBER IS:˘(S7)'
SHOW '--- IF THIS IS THE GENERATION NUMBER, YOU WANT PRESS ENTER'
SHOW '--- ELSE GIVE A NEW NUMBER ("E" RETURNS)
READ INTO S1 PROMPT '-->'
SET S29=SUBSTR(S1,1,5)
IF S29='E' GOTO STOP
IF LENGTH(S1)=0 GOTO NOCHANG
GOTO RUTH
LABEL NOCHANG
SET S1 = S7
GOTO RUTH
LABEL OLD
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE COPIED (EG 470)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
$
$---------------------------------
$ RUTHERFORD TAPE SERIAL NUMBER(S)
$---------------------------------
$
LABEL RUTH
IF S8 =' ' GOTO OLDR
SHOW ' '
SHOW '--- RUTHERFORD TAPE NUMBER IS:˘(S8)'
SHOW '--- IF THIS IS THE TAPE NUMBER, YOU WANT PRESS ENTER'
SHOW '--- ELSE GIVE A NEW NUMBER '
READ INTO S2 PROMPT '-->'
IF LENGTH(S2)=0 GOTO NORUT
GOTO JOB
LABEL NORUT
SET S2 = S8
GOTO JOB
LABEL OLDR
SHOW ' '
SHOW '--- ENTER THE RUTHERFORD TAPE SERIAL NUMBER(S) (EG 939454,...)'
READ INTO S2 PROMPT '-->'
IF S2=' ' GOTO NODEFLT
IF LENGTH(S2)=0 GOTO NODEFLT
$
$--------------------------------------
$ RUTHERFORD TAPE LABEL SEQUENCE NUMBER
$--------------------------------------
$
LABEL JOB
SHOW ' '
SHOW '--- ENTER THE TAPE VOLUME LABEL NUMBER (DEFAULT = 1)'
READ INTO S3 PROMPT '-->'
IF S3=' ' SET S3='1'
IF LENGTH(S3)=0 SET S3='1'
$
$-----------
$ TIME LIMIT
$-----------
$
SET S11='(1,30)'
SET S12='K'
IF LENGTH(S2)<9 GOTO CLASSA
SET S11='(2,00)'
SET S12='K'
LABEL CLASSA
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S7=S1+1
SET S8=S2+1
SET S40='JADEC˘(S1)'
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=˘(S12),MSGLEVEL=(1,0),TIME=˘(S11)
//*MAIN RELPRI=MED,LINES=(2)
//*
//*---------------------------------------------------------------------
//*
//* JOB TO COPY REDUC1 MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
//*
//* SYSUT1 = (INPUT) RUTHERFORD TAPE CONTAINING REDUC1 MERGE DATA
//*        = JADEPR.REDUC1.G0˘(S1)    TAPE=˘(S2)    LABEL=˘(S3)
//*
//* SYSUT2 = (OUTPUT) DESY MACHINE ROOM TAPE
//*        = JADEPR.REDUCONE.G0˘(S1)V00
//*
//*---------------------------------------------------------------------
//*
//* STEP 1 - THE COPY
//* =================
//*
//RUTHCOPY EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=TAPE,DISP=(OLD,KEEP),
//       DSN=JADEPR.REDUC1.G0˘(S1),
//       VOL=SER=(˘(S2)),
//       LABEL=(˘(S3),SL,,IN)
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.REDUCONE.G0˘(S1)V00
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.G0˘(S1)V00
//*
//* STEP 3 - ARCHIVE
//* ========================
//*
//ARCHIVE EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*-----------------------------------------------------------
//*
//* JOB TO MAKE A BACKUP-ARCHIVE COPY OF A REDUC1 TAPE AT DESY
//*
//* SYSUT1 = INPUT REDUC1 TAPE TO BE COPIED
//*        = JADEPR.REDUCONE.G0˘(S1)V00
//*
//* SYSUT2 = OUTPUT ARCHIVE COPY TAPE
//*        = JADEPR.ARCHIVE.REDUC˘(S1)
//*
//*-----------------------------------------------------------
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.REDUCONE.G0˘(S1)V00
//SYSUT2 DD UNIT=ARCHIV,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.ARCHIVE.REDUC˘(S1)
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$-------------
$ SUBMIT JOB ?
$-------------
$
LABEL SUBMIT
RENUM ###JUNK 1 1
SHOW ' '
SHOW '--- JCL CREATED'
SHOW '--- PRESS RETURN/ENTER TO SUBMIT, ANYTHING ELSE TO TERMINATE :'
READ INTO S1 PROMPT '--> '
IF S1=' ' GOTO RUN
SHOW '--- SUBMIT TERMINATED'
SHOW '--- JCL MAY BE INSPECTED IN MEMBER ####JUNK'
GOTO KEEPJCL
LABEL RUN
SUBH ###JUNK
SHOW '--- JOB ˘(S40) SUBMITTED '
READ INTO S1 PROMPT '--- ANOTHER ONE ? ( Y(ES) OR N(O) )'
IF SUBSTR(S1,1,1)^='N' GOTO SKIP1
GOTO STOP
$
$----------------
$ TERMINATE CLIST
$----------------
$
LABEL NODEFLT
SHOW ' '
SHOW '--- THERE IS NO DEFAULT FOR THIS PARAMETER'
LABEL STOP
SC ###JUNK
LABEL KEEPJCL
SHOW ' '
SHOW '--- END OF CLIST'
SET ESCAPE=''
V ON
FULL ON
RETURN
$   28/05/84 508061722: MEMBER NAME  #COPY1   (BIBLS)       NEWLIB
//JADECO JOB 10622622,#COPY1,CLASS=A,TIME=(1,10),MSGLEVEL=(2,0)
//*MAIN ORG=EXT,RELPRI=HIG
//*     5000 PTRS=17S,     100 MC-EVENTS = 5SEC
// EXEC FCLG
C
C   VERSION OF 29/06/79    LAST MOD 20/11/79    E.ELSEN
C                          LAST MOD 19/11/81    P.WARMING
C   OUTPUT ONTO MANY DATASETS       07/04/82    P.WARMING
C   COPY ANY SET OF BOS BANKS
C   NO CHECK ON VALIDITY OF BANK NAMES
C-----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(35000)
      DIMENSION HW(1)
      EQUIVALENCE (HW(1),IW(1))
C IN -----
      DATA IEVLIM / 99999 /,    IEVANF /     0 /,    IFILMX / 1/
C OUT-----
      INTEGER JFILMX(20) /99999, 666,   1,  50,  50,  50,99999,13*0  /
      DIMENSION HDSN(22), HVOL(3)
      REAL*8 DDIN / 'FT02F001' /
      REAL*8 DDOU(20) /'FT21F001','FT22F001','FT23F001','FT24F001',
     *    'FT25F001','FT26F001','FT27F001','FT28F001','FT29F001',
     *  'FT30F001','FT31F001','FT32F001','FT33F001','FT34F001',
     *'FT35F001','FT36F001','FT37F001','FT38F001','FT39F001','FT40F001'/
      DATA IRUNIT / 2 /
      DATA IWUNIT / 21/, JOUT/0/
C
      CALL BINT( 35000, 35000, 10000, 0 )
      CALL DUMP0C
      CALL BWRO( IWUNIT, 1558, 2 )
C                                           I/O UNIT SPECIFICATION
      CALL DDCHA( DDIN, HDSN, HERR, HVOL )
      WRITE(6,9111) HDSN, HVOL
 9111 FORMAT(/' INPUT IS FROM DSN=',22A2,' VOL=',3A2)
      CALL DDCHA( DDOU(IWUNIT-20), HDSN, HERR, HVOL )
      WRITE(6,9112) HDSN, HVOL
 9112 FORMAT(/' OUTPUT IS TO  DSN=',22A2,' VOL=',3A2)
C
C
      IFIL = 1
      IEOF = 0
      IEV = 0
  100 IF( JUHR(2) .EQ. 2 ) GO TO 4000
      CALL BREAD( IRUNIT, &1000, &3000 )
      IEOF = 0
      IEV = IEV + 1
C     IF (MOD(IEV,5).EQ.0) WRITE (8,8008) IEV
C8008 FORMAT(I10)
C///////////////////////////////////////////////////
      IF (IEV.LE.IEVANF) GOTO 2000
C
      NPHEAD = IW(IBLN('HEAD'))
      IF( NPHEAD .LE. 0 ) GO TO 899
      HRUN = HW(NPHEAD*2+10)
      HEVT = HW(NPHEAD*2+12)
      IF(HRUN.EQ.14792.AND.HEVT.EQ.3793) WRITE(6,700) HRUN,HEVT
  700 FORMAT(3X,'FOLLOWING EVENT NOT COPIED RUN# EVT# ',2I9)
      IF(HRUN.EQ.14792.AND.HEVT.EQ.3793) GO TO 2000
  899 CONTINUE
  900 CONTINUE
C
C                                           WRITE RECORDS
      CALL BSLW
      CALL BWRITE( IWUNIT )
      JOUT = JOUT + 1
      IF (JOUT.LT.JFILMX(IWUNIT-20) ) GOTO 2000
C                                           INCREMENT OUTPUT UNIT
      CALL BMLT( 0, DUMMY )
      CALL BWRITE( IWUNIT )
      CALL BSTA
      IWUNIT = IWUNIT + 1
      JOUT = 0
      CALL DDCHA( DDOU(IWUNIT-20), HDSN, HERR, HVOL )
      WRITE(6,9112) HDSN, HVOL
      CALL BWRO( IWUNIT, 1558, 2 )
      GO TO 2000
C
C                                           ERRORS
 1000 WRITE(6,9101)
 9101 FORMAT(' +++++   READ ERROR FROM BREAD +++++' )
      CALL BSLT
      CALL BDLG
      GO TO 3000
C
C                                           END OF LOOP
 2000 CALL BSLT
      CALL BDLG
      IF( IEV .LT. IEVLIM ) GO TO 100
C
C                                           EOF ON IRUNIT
 3000 IF( IFIL .GE. IFILMX .OR. IEOF.NE.0 )  GO TO 8000
      IFIL = IFIL + 1
      IEOF = 1
      WRITE(6,9104) IEV, IFIL
 9104 FORMAT(' +++++ AFTER',I6,' EVENTS END OF FILE +++++')
      CALL BMLT( 0, DUMMY )
      CALL BWRITE( IWUNIT )
      CALL BSTA
      CALL BDLS( '+BUF', IRUNIT )
      GO TO 100
C
C
 4000 WRITE(6,9103)
 9103 FORMAT(/' +++++   TIME OUT +++++')
C
C                                           END OF JOB
 8000 CONTINUE
      CALL BMLT( 0, DUMMY )
      CALL BWRITE( IWUNIT )
      CALL BSTA
      STOP
      END
//LKED.SYSLIB DD
//            DD
//            DD DSN=F22ELS.CL11,DISP=SHR,UNIT=FAST
//            DD DSN=F1EBLO.BOSLIB.L,DISP=SHR,UNIT=FAST
//            DD DSN=F11LHO.JADEGL,DISP=SHR,UNIT=FAST
//*                INPUT
//GO.FT02F001 DD UNIT=TAPE,DISP=SHR,
//   DSN=F11LHO.JDATA10.REFORM.G0050V00
//*  --------      OUTPUT     --------       --------        -----------
//GO.FT08F001 DD DUMMY
//GO.FT21F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//   DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//   DSN=F11LHO.JDATA10.REFORM.G0050
/*
$   28/05/84 508061722: MEMBER NAME  #DIFFLB  (BIBLS)       NEWLIB
//JADETT   JOB BECKER,CLASS=E,TIME=(0,15),MSGLEVEL=(2,0)
//*MAIN ORG=EXT,LINES=2,RELPRI=HIG
// EXEC FCLG
C
C ------   BEGIN TEST   ------
C     7
      CALL DIFFLB
      STOP
      END
#include "difflb.for"
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=F11BEK.BIBLL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//*
//GO.FT10F001 DD DISP=SHR,DSN=JADEPR.DSK.DESY916
//GO.FT20F001 DD DISP=SHR,DSN=JADEPR.DSK.RUTH916
//*
//GO.FT30F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),
//    DCB=(R01DCB.VBS,LRECL=6236),SPACE=(TRK,(300,50),RLSE),
//    DSN=JADEPR.DSK.DIFF916
//*
//GO.FT30F001 DD DUMMY
//* 27/02/82            MEMBER NAME  #ENDF    (JADESR)      JCL
//JADEPREF JOB '10622622',PRODUC,CLASS=E,MSGLEVEL=(1,1),TIME=(0,05)
//*MAIN RELPRI=HIG
//CPRC EXEC FCLG,FORT='XL,OPT=2,LEVEL=4'
//FORT.SYSIN DD *
C--- COPY FIXED LENGTH RECORDS.
      END FILE 3
      STOP
      END
//GO.FT03F001 DD UNIT=FAST,DISP=OLD,DSN=F22WAT.LGBAD0
//* 31/07/84 504151221  MEMBER NAME  #EVT1    (JADESR)      JCL
//JADDUMP1 JOB '10622622',KAW,CLASS=A,MSGLEVEL=(1,1),TIME=(0,45)
//*MAIN LINES=(2),ORG=EXT,RELPRI=MED
//* #EVT1 IS FOR ONE NORD TAPE WITH ONE FILE TO ONE EXDATA TAPE
// EXEC NEWFAST
// EXEC FCLG
#include "evt.for"
//LKED.SYSLIB DD
// DD
// DD DSN=F22HIL.MTL,DISP=SHR,UNIT=FAST
// DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//LKED.JADE DD DSN=JADEPR.JADELD,DISP=SHR
 INCLUDE JADE(EVPK)
//*
//*                input
//*
//GO.FT09F001 DD DSN=F22YEN.NORD10,DISP=SHR,UNIT=TAPE,VOL=SER=JDAS04,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(1,NL)
//*
//*                output
//*
//GO.FT02F001 DD UNIT=DISK,DISP=(,PASS),SPACE=(CYL,(90,50)),
// DSN=&&OUTPUT,DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236)
F22RAM.TAPE04
//*-------------------------------------------------------------------
// EXEC PGM=IEBGENER
//*YSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&OUTPUT
//*YSUT2 DD DSN=F22YEN.JADE.EXTAPE01.G0088V00,UNIT=TAPE,
//*DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//SYSUT2 DD DSN=F22RAM.TAPE04,UNIT=TAPE,
// DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*-------------------------------------------------------------------
$   28/05/84 508061722: MEMBER NAME  #EVT2    (BIBLS)       NEWLIB
//JADDUMP2 JOB '10622622',KAW,CLASS=A,MSGLEVEL=(1,1),TIME=(1,0)
//*MAIN LINES=(2),ORG=EXT,RELPRI=HIGH
//* #EVT2 IS FOR ONE NORD TAPE WITH SEVERAL EOFS TO ONE EXDATA TAPE
//* AT THE END OF THIS PROGRAM YOU SHOULD SUPPLY THE BEGINNING AND THE
//* END OF RUN NUMBERS IN I5 FORMAT
// EXEC NEWFAST
// EXEC FCLG
#include "evt2.for"
//LKED.SYSLIB DD
// DD
// DD DSN=F22HIL.MTL,DISP=SHR,UNIT=FAST
// DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR,UNIT=FAST
//LKED.JADE DD DSN=JADEPR.JADELD,DISP=SHR
 INCLUDE JADE(EVPK)
//GO.FT02F001 DD UNIT=DISK,DISP=(,PASS),SPACE=(CYL,(90,50)),
// DSN=&&OUTPUT,DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236)
//GO.FT09F001 DD DSN=F22YEN.NORD10,UNIT=TAPE,VOL=SER=F11206,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(1,NL),DISP=(SHR,PASS)
//GO.FT10F001 DD DSN=F22YEN.NORD10,UNIT=AFF=FT09F001,VOL=SER=F11206,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(2,NL),DISP=(SHR,PASS)
//GO.FT11F001 DD DSN=F22YEN.NORD10,UNIT=AFF=FT09F001,VOL=SER=F11206,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(3,NL),DISP=(SHR,PASS)
//GO.FT12F001 DD DSN=F22YEN.NORD10,UNIT=AFF=FT09F001,VOL=SER=F11206,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(4,NL),DISP=(SHR,PASS)
//GO.FT13F001 DD DSN=F22YEN.NORD10,UNIT=AFF=FT09F001,VOL=SER=F11206,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(5,NL),DISP=(SHR,PASS)
F22RAM.TAPE3
1859918602
//*-------------------------------------------------------------------
// EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&OUTPUT
//*YSUT2 DD DSN=F22YEN.JADE.EXTAPE01.G0074V00,UNIT=TAPE,
//*DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//SYSUT2 DD DSN=F22RAM.TAPE3,UNIT=TAPE,
// DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*-------------------------------------------------------------------
$   28/05/84 508061722: MEMBER NAME  #EVT3    (BIBLS)       NEWLIB
//JADDUMP3 JOB '10622622',KAWBATA,CLASS=A,MSGLEVEL=(1,1),TIME=(1,00)
//*MAIN LINES=(2),ORG=EXT
//* THIS IS FOR SEVERAL NORD TAPES TO ONE EXTEST TAPE
// EXEC NEWFAST
// EXEC FCLG,REGION=600K
#include "evt.for"
//LKED.SYSLIB DD
// DD
// DD DSN=F22HIL.MTL,DISP=SHR,UNIT=FAST
// DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR,UNIT=FAST
//LKED.JADE DD DSN=JADEPR.JADELD,DISP=SHR
 INCLUDE JADE(EVPK)
//GO.FT09F001 DD DSN=F22YEN.NORD10,DISP=SHR,UNIT=TAPE,VOL=SER=F11180,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(1,NL)
//                      DD DSN=F22YEN.NORD10,DISP=SHR,VOL=SER=F11197,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(1,NL),UNIT=AFF=FT09F001
//GO.FT02F001 DD UNIT=DISK,DISP=(,PASS),SPACE=(CYL,(90,50)),
// DSN=&&OUTPUT,DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236)
JADE.EXTAPE01.G0074
//*-------------------------------------------------------------------
// EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&OUTPUT
//SYSUT2 DD DSN=F22YEN.JADE.EXTAPE01.G0074V00,UNIT=TAPE,
// DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//*SYSUT2 DD DSN=F11HEU.COSM.R6178U82,UNIT=TAPE,
//* DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*-------------------------------------------------------------------
//* 27/02/82 202271304  MEMBER NAME  #KALCOP  (JADESR)      JCL
//JADEPRC3 JOB 10622622,'KALCOP',TIME=(0,10),CLASS=E
//*MAIN RELPRI=HIG
// EXEC FCLG,LIB1='F11LHO.JADEGL'
//FORT.SYSIN DD *
      CALL KALCOP
      STOP
      END
      SUBROUTINE KALCOP
      IMPLICIT INTEGER*2 (H)
C---
C---     SIMPLE COPY.
C---                                   L.H. O'NEILL 10.09.79
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
C---
      NREC=0
    1 CONTINUE
      CALL EVREA1(2,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
C     IOUT=NWORD
C     IF(IOUT.GT.10) IOUT=10
C     WRITE(6,100) NREC,NWORD,(JBUF(I),I=1,IOUT)
  100 FORMAT(1X,I4,I12,10I10)
      CALL KALBNK(3,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
      RETURN
      END
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KALWRK0
//GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*  SPACE=(TRK,(50,20),RLSE),DSN=F11LHO.KB80023D
$   28/05/84 508061722: MEMBER NAME  #LKRED1  (BIBLS)       NEWLIB
//JADER1LK JOB '10622622',REDUCONE,CLASS=E,TIME=(0,15)
//*MAIN RELPRI=LOW,LINES=(2),ORG=EXT
//*
//*-------------------------------------------------------
//*
//* JOB TO LINK AN EXECUTABLE REDUC1 LOAD MODULE AT DESY
//* NEW MODULE NAME = JADEPR.JADELD(REDUC1LD)
//*
//*-------------------------------------------------------
//*
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
// EXEC FCL,FORT=XL,PARM.LKED='LIST,MAP'
//FORT.SYSIN DD *
#include "jdmain0.for"
//*
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//*           DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,DSN=R01UTL.CERN.KERNLIB4
//*           DD DISP=SHR,DSN=R01UTL.CERN.PACKLIB4
//*           DD DISP=SHR,DSN=R01UTL.CERN.GENLIB4
//LKED.SYSLMOD DD DISP=OLD,UNIT=FAST,DSN=JADEPR.JADELD(REDUC1LD)
//LKED.SYSIN DD *
 INCLUDE SYSLIB(USRED82,GBOOK,DBASEDUM)
//*
$   28/05/84 508061722: MEMBER NAME  #MELB+1  (BIBLS)       NEWLIB
//JADEMERG JOB '10622622',REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=HIG,LINES=(15),CARDS=(900)
//*
//*-----------------------------------------------------------
//*
//*    ******   F JADEPR.  !!!   *******
//*
//* JCL TO RUN THE JADE REDUC1 MERGE STEP
//*
//* SYSUT1   = CONCATENATED SEQUENCE OF INPUT FILES TO BE MERGED
//* SYSUT2   = OUTPUT FILE FOR MERGED SUM
//* FT01F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY MUONSTEP)
//* FT02F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY LISTRUNS)
//*
//*-----------------------------------------------------------
//*
//* STEP 1 - THE MERGE
//* ==================
//*
//DESYMRGE EXEC PGM=IEBGENER,REGION=120K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*  TAPE FOR MERGED OUTPUT
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG),DSN=JADEPR.REDUCONE.G0956V00,
// VOL=(,RETAIN)
//*
//*  LIST OF INPUT TAPES TO BE MERGED
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,DSN=JADEPR.ARCHIVE.REDUC956
// DD UNIT=AFF=SYSUT1,DISP=SHR,DSN=JADEPR.RED1HH.ST194
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,VOL=(,RETAIN),DSN=JADEPR.REDUCONE.G0956V00
//*
$   28/05/84 508061722: MEMBER NAME  #MERGELB (BIBLS)       NEWLIB
//JADEMERG JOB '10622622',REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=HIG,LINES=(15),CARDS=(900)
//*
//*-----------------------------------------------------------
//*
//*    ******   F JADEPR.  !!!   *******
//*
//* JCL TO RUN THE JADE REDUC1 MERGE STEP
//*
//* SYSUT1   = CONCATENATED SEQUENCE OF INPUT FILES TO BE MERGED
//* SYSUT2   = OUTPUT FILE FOR MERGED SUM
//* FT01F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY MUONSTEP)
//* FT02F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY LISTRUNS)
//*
//*-----------------------------------------------------------
//*
//* STEP 1 - THE MERGE
//* ==================
//*
//DESYMRGE EXEC PGM=IEBGENER,REGION=120K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*  TAPE FOR MERGED OUTPUT
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG),DSN=JADEPR.REDUCONE.G0968V00,
// VOL=(,RETAIN)
//*
//*  LIST OF INPUT TAPES TO BE MERGED
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,DSN=JADEPR.RED1HH.ST219
// DD UNIT=AFF=SYSUT1,DISP=SHR,DSN=JADEPR.RED1HH.ST220
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,VOL=(,RETAIN),DSN=JADEPR.REDUCONE.G0968V00
//*
//* 31/07/84 504151221  MEMBER NAME  #NORDLB  (JADESR)      JCL
//JADDUMP1 JOB '10622622',KAW,CLASS=A,MSGLEVEL=(1,1),TIME=(0,45)
//*MAIN LINES=(2),ORG=EXT,RELPRI=MED
//* #EVT1 IS FOR ONE NORD TAPE WITH ONE FILE TO ONE EXDATA TAPE
// EXEC NEWFAST
// EXEC FCLG
#include "evt.for"
//LKED.SYSLIB DD
// DD
// DD DSN=F22HIL.MTL,DISP=SHR,UNIT=FAST
// DD DSN=R01UTL.CERN.KERNLIB4,DISP=SHR
//LKED.JADE DD DSN=JADEPR.JADELD,DISP=SHR
 INCLUDE JADE(EVPK)
//*
//*                input
//*
//GO.FT09F001 DD DSN=F22YEN.NORD10,DISP=SHR,UNIT=TAPE,VOL=SER=JDAS04,
// DCB=(RECFM=F,BLKSIZE=4096,DEN=3),LABEL=(1,NL)
//*
//*                output
//*
//GO.FT02F001 DD UNIT=DISK,DISP=(,PASS),SPACE=(CYL,(90,50)),
// DSN=&&OUTPUT,DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236)
F22RAM.TAPE04
//*-------------------------------------------------------------------
// EXEC PGM=IEBGENER
//*YSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&OUTPUT
//*YSUT2 DD DSN=F22YEN.JADE.EXTAPE01.G0088V00,UNIT=TAPE,
//*DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//SYSUT2 DD DSN=F22RAM.TAPE04,UNIT=TAPE,
// DCB=(R01DCB.VBS,BLKSIZE=6240,LRECL=6236),DISP=(NEW,CATLG,CATLG)
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*-------------------------------------------------------------------
//* 13/07/84 407131521  MEMBER NAME  #REDUCTS (JADESR)      SHELTRAN
//JADED186 JOB '10622622',REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=1
//*MAIN RELPRI=HIG,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*          = F11LHO.JDATA11.REFORM.G0186V00
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*          = JADEPR.ST186
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1LT,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=FAST,DISP=(,CATLG,CATLG),
// DSN=JADEPR.ST186,SPACE=(TRK,(40,30),RLSE)
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11LHO.JDATA11.REFORM.G0186V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00017144 00003749
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
$   28/05/84 508061722: MEMBER NAME  #RED1_LB (BIBLS)       NEWLIB
//JADED097 JOB '10622622',REDUCONE,CLASS=D,MSGLEVEL=(1,0),TIME=25
//*MAIN RELPRI=MED,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*          = F11LHO.JDATA15.REFORM.G0097V00
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*          = JADEPR.RED1HH.ST097
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1L9,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),
//         SPACE=(CYL,(200,50))
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.BUPDAT1
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11LHO.JDATA15.REFORM.G0097V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00000000 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
//SPOOLING EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,CATLG),
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//       DSN=JADEPR.RED1HH.ST097
$   28/05/84 508061722: MEMBER NAME  #RED1LB  (BIBLS)       NEWLIB
//JADERED1 JOB '10622622',REDUCONE,CLASS=D,MSGLEVEL=(1,0),TIME=25
//*MAIN RELPRI=MED,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*===============================================================*
//*  IF BUPDAT1 IS UPDATED USE IT INSTEAD OF KALWRK0              *
//*  CHECK OF CAL.FILES :   F11BEK.BIBLS(#KALW)                   *
//*===============================================================*
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*          = F11LHO.JDATA12.REFORM.G0124V00
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*          = JADEPR.RED1HELP.R124
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1LD,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),
//         SPACE=(CYL,(200,50))
//*
//FT21F001 DD DISP=SHR,DSN=F11LHO.BUPDAT0
//*
//FT22F001 DD DISP=SHR,DSN=F11LHO.BUPDAT1
//*T22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11LHO.JDATA12.REFORM.G0124V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00000000 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
//SPOOLING EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,CATLG),
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//       DSN=JADEPR.RED1HELP.R124
//*
//* 18/01/82 312061840  MEMBER NAME  #RED1TST (JADESR)      JCL
//JADEGP99 JOB '10622622',REDUCONE,CLASS=L,MSGLEVEL=1,TIME=6
//*MAIN RELPRI=MED,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//* TAKES ABOUT 1.3 MNS FOR 1K INPUT EVENTS  (16/10/81)
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*
//*-----------------------------------------------------------
//*
//REDUC1 EXEC PGM=REDUC1LO,REGION=760K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),SPACE=(CYL,(200,50))
//FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.G0635V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *,DCB=(BUFNO=1)
STARTRUN 00014930 00014932
NOTRUNS  08871 00000 00000 00000 00000 00000 00000 00000 00000 00000
//COPY EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//SYSUT2 DD DISP=(NEW,CATLG,CATLG),DSN=JADEPR.TEST635,
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//       SPACE=(TRK,(20,100),RLSE),UNIT=FAST
//*
//* 18/01/82 404120911  MEMBER NAME  #RED2JCL (JADESR)      JCL
//JADEGP33 JOB '10622622',REDUCONE,CLASS=D,MSGLEVEL=1,TIME=28
//*MAIN RELPRI=MED,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//* TAKES ABOUT 1.3 MNS FOR 1K INPUT EVENTS  (16/10/81)
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*
//*-----------------------------------------------------------
//*
//REDUC1 EXEC PGM=REDUC1LD,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),SPACE=(CYL,(200,50))
//FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11LHO.JDATA11.REFORM.G0133V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *,DCB=(BUFNO=1)
STARTRUN 00009251 00000000
NOTRUNS  08871 00000 00000 00000 00000 00000 00000 00000 00000 00000
//COPY EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DSN=JADEPR.ST133,
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948)
//
$   18/10/82 403051410  MEMBER NAME  #REFORM  (JADESR)      CLIST
FULL OFF
V OFF OFF
SET ESCAPE='@'
$
$--------------------------
$ SET YEN AND REFORM SERIES
$--------------------------
$
SET S5='10'
SET S6='11'
$
$------
$ TITLE
$------
$
CLEAR
SHOW '        CREATE JCL FOR REFORM JOB'
SHOW '        ========================='
SHOW ' '
SHOW ' PRESENTLY HARDWIRED FOR EXDATA@(S5) AND JDATA@(S6)'
SHOW ' THE REFORM JCL WILL BE STORED IN MEMBER #REFMJCL'
SHOW ' '
$
$----------------------------------
$ CREATE/CLEAR DUMMY MEMBER FOR JCL
$----------------------------------
$
SC #REFMJCL
IF DIR('#REFMJCL') = 'T'  GOTO SKIP1
./ ADD #REFMJCL
./ LABEL NOMACRO
LABEL SKIP1
C #REFMJCL
D 0 900000
$
$---------------------
$ YEN GENERATION GROUP
$---------------------
$
SHOW ' '
READ INTO S1 PROMPT '-- ENTER YEN GENERATION GROUP NUMBER (EG 072)    :'
IF LENGTH(S1)=0 GOTO STOP
IF LENGTH(S1)=5 SET S1=SUBSTR(S1,3,3)
$
$-------------------------
$ REFORM GENERATION GROUP
$-------------------------
$
SHOW ' '
READ INTO S2 PROMPT '-- ENTER REFORM GENERATION GROUP NUMBER (EG 062) :'
IF LENGTH(S2)=0 GOTO STOP
IF LENGTH(S2)=5 SET S2=SUBSTR(S2,3,3)
$
$----------------------
$ RUTHERFORD TAPE NUMER
$----------------------
$
SHOW ' '
READ INTO S3 PROMPT '-- ENTER RUTHERFORD TAPE NUMBER (EG 939481)      :'
IF LENGTH(S3)=0 GOTO STOP
$
$-----------
$ CREATE JCL
$-----------
$
./ INSERT 10 10
//JADEREFO JOB '10622622',REFORM,CLASS=L,MSGLEVEL=1,TIME=(6,00)
//*MAIN RELPRI=MED
//*
//*
//* ======================================================
//*
//* JADE REFORMAT JOB
//* -----------------
//*
//* JCL CREATED BY @USER AT @SUBSTR(TIME,1,4) ON @DATE
//*
//* YEN TAPE = F22YEN.JADE.EXDATA@(S5).G0@(S1)V00
//*
//* REFORM TAPE = F11LHO.JDATA@(S6).REFORM.G0@(S2)V00
//*
//* RUTHERFORD TAPE = @(S3)
//*
//* ======================================================
//*
//*
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
// EXEC NEWFAST
//*
//* ===============
//*  REFORMAT STEP
//* ===============
//*
//REFORM EXEC PGM=REFRMLD,REGION=520K
//FT06F001 DD SYSOUT=*
//FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F22YEN.JADE.EXDATA@(S5).G0@(S1)V00
//FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),VOL=(,RETAIN),
//    DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//    DSN=F11LHO.JDATA@(S6).REFORM.G0@(S2)V00
//FT04F001 DD UNIT=FAST,DISP=MOD,DSN=F22WAT.LGBAD0
//FT08F001 DD UNIT=FAST,DISP=MOD,DSN=F11LHO.DSKTI001
//FT09F001 DD DUMMY
//*FT09F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.FASTSEL
//FT05F001 DD *
//*
//* =====================
//*  FIND BAD BLOCK STEP
//* =====================
//*
//BADCHL EXEC PGM=BADCHLD,REGION=340K
//FT06F001 DD SYSOUT=*
//FT02F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK0
//FT08F001 DD UNIT=FAST,DISP=OLD,DSN=F22WAT.LGBAD0
//FT04F001 DD UNIT=DISK,DISP=(,PASS),DSN=&&SCRTCH,
//         DCB=(R01DCB.VBS,LRECL=6236),SPACE=(CYL,(20,20))
//FT03F001 DD UNIT=DISK,DISP=(,PASS),DSN=&&SCRTCH1,
//         DCB=(R01DCB.VBS,LRECL=6236),SPACE=(CYL,(20,20))
//FT05F001 DD *
//*
//* =========================================================
//*  COPY THE CALIBRATION AND THE DATA ONTO A RUTHERFORD TAPE
//* =========================================================
//*
//RUTHCALB EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD DISP=SHR,DSN=F11LHO.KALWRK0
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,KEEP),DSN=JADEPR.KALWRK0,
//       VOL=(,RETAIN,,,SER=(@(S3))),LABEL=(1,SL,,OUT)
//*
//RUTHDATA EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD DISP=SHR,DSN=F11LHO.JDATA@(S6).REFORM.G0@(S2)V00
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//       DSN=JADEPR.REFORM.RD@(S5)G@(S1).RF@(S6)G@(S2),
//       VOL=(,RETAIN,,,SER=(@(S3))),LABEL=(2,SL,,OUT)
//*
./ LABEL NOMACRO
SHOW ' '
SHOW '-- JCL CREATED AND STORED IN MEMBER #REFMJCL'
SHOW '-- TO ENTER INTO CHANGE MODE ON #REFMJCL JUST PRESS ENTER'
SHOW ' '
RENUM #REFMJCL 0
SHOW ' '
$
$------------
$ SUBMIT JOB
$------------
$
$SUBMIT #REFMJCL HOLD
GOTO END
LABEL STOP
SC #REFMJCL
$
$----------------------------
$ TIDY UP AND EXIT FROM CLIST
$----------------------------
$
LABEL END
SET ESCAPE=''
V ON
FULL ON
SHOW '-- END OF #REFORM'
RETURN
//* 14/01/82 209101332  MEMBER NAME  #REFRUN  (JADESR)      JCL
//JADEPRFM JOB '10622622',PRODUC,CLASS=K,MSGLEVEL=(1,1),TIME=4
//*MAIN RELPRI=MED,LINES=(18)
//*NET ID=JADEPRN8,RL=(JADEPRD8)
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
//*EXEC CATPROGM
//*DELETE F11LHO.JDATA03.REFORM.G0XXXV00
// EXEC NEWFAST
//*
//*    REFORMAT EVENTS
//*
//REFM EXEC FCLG,FORT='XL,OPT=2,LEVEL=4',
//      LKED='MAP,LIST',REGION=750K
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      COMMON/CDFLAG/IDFLAG,LIMOUT,NRNMIN,NRNMAX
      IDFLAG=0
      LIMOUT=1000000
      NRNMIN=   9727
      NRNMAX=1000000
      CALL REFMAI
      STOP
      END
#include "evfoldkw.for"
#include "addon.for"
#include "evconv7.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
// DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
// DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(BREADKW,BWRITEKW)
//*O.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F22YEN.JADE.EXDUMP.G1237V00
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F22YEN.JADE.EXDATA05.G0181V00
//GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//   DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//   DSN=F11LHO.JDATA06.REFORM.G0199V00
//*
//GO.FT04F001 DD DSN=F22WAT.LGBAD0,DISP=MOD,UNIT=FAST
//GO.FT08F001 DD DSN=F11LHO.DSKTI001,DISP=MOD,UNIT=FAST
//GO.FT09F001 DD DUMMY
//*GO.FT09F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.FASTSEL
//*
//*
//*   FIND BAD BLOCKS
//*
//SPBL EXEC FCLG,FORT='XL,OPT=2,LEVEL=4'
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      REWIND 4
      REWIND 8
      CALL KALCOP
      CALL KALADD
      CALL KORDER
      CALL KALREV
      REWIND 4
      STOP
      END
#include "kalcop.for"
#include "kaladd.for"
#include "korder.for"
#include "kalrev.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
// DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//GO.FT02F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK0
//*GO.FT03F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK1
//GO.FT08F001 DD UNIT=FAST,DISP=OLD,DSN=F22WAT.LGBAD0
//GO.FT04F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//   SPACE=(CYL,(20,20)),DSN=&&SCRTCH
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//   SPACE=(CYL,(20,20)),DSN=&&SCRTCH1
//*
//* =========================================================
//*  COPY THE CALIBRATION AND THE DATA ONTO A RUTHERFORD TAPE
//* =========================================================
//*
//RUTHCALI EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD DISP=SHR,DSN=F11LHO.KALWRK0
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,KEEP),DSN=JADEPR.KALWRK0,
//       VOL=(,RETAIN,,,SER=939500),LABEL=(1,SL,,OUT)
//*
//RUTHDATA EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD DISP=SHR,DSN=F11LHO.JDATA03.REFORM.G0260V00
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DSN=JADEPR.RUTH@(S2),
//       VOL=SER=939500,LABEL=(2,SL,,OUT)
//*
$   28/05/84 508061722: MEMBER NAME  #REPAIR  (BIBLS)       NEWLIB
//JADEPR   JOB CLASS=A,MSGLEVEL=(1,0),TIME=(0,40)
//*MAIN RELPRI=HIG
//*    JOB TO REPAIR CROSSED ID CABLES
//*    USING SPITZERS ALGORITHM            2/8/84  W.BARTEL
// EXEC NEWLIB,PS='JADEPR.JADESR',PL='JADEPR.JADELD'
./ COMPILE USERSPI
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
// EXEC FLG,REGION.GO=950K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F22NAR.TOFLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USERSPI)
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//*GO.FT02F001 DD UNIT=TAPE,DISP=OLD,
//*         DSN=JADEPR.REDUC1HH.G0080V00
//GO.FT02F001 DD DISP=SHR,DSN=JADEPR.TEMPDL8
//*                        OUTPUT:
//*GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//   SPACE=(TRK,(70,10),),DSN=JADEPR.TEMPDL8C
//* 18/10/81 203301323  MEMBER NAME  #RUTHJCL (JADESR)      JCL
//*
//*
//*    A SIMPLE EXAMPLE OF A PROGRAM TO RUN AT RUTHERFORD
//*    (N.B. /* IS NOT A COMMENT !!)
//*                                                       GFP  NOV 1981
//*
//*
/*PRIORITY 8
//*
//* JOBCARD GIVES 5 MINUTES EXECUTION TIME AND 20K LINES LIMIT
//* =======
//*
//QLJOBNAM JOB (2191,QL,5-00,20,,,,,0),DESY,MSGLEVEL=1
//*
//* ROUTE CARDS SEND OUTPUT TO DESY (REMOTE79) TO PRINT UNDER ID F11RUT
//* ===========
//*
/*ROUTE  PRINT REMOTE79
/*ROUTE  POINT F11RUT
//*
//* SETUP CARDS
//* ===========
//*
//* THE FIRST TWO SETUP CARDS DEMAND THAT THE TAPE(S) ON WHICH THE TWO
//* NAMED REDUCTWO FILES RESIDE BE MOUNTED SUCCESSIVELY (UNIT=AFF) ON
//* THE SAME TAPE DRIVE. NO TAPE NUMBERS NEED BE SPECIFIED HERE SINCE
//* ALL REDUCTWO FILES AT RUTHERFORD ARE CATALOGUED.
//*
//* THE THIRD SETUP CARD DEMANDS THAT TAPE 333333 BE MOUNTED ONTO A
//* SECOND TAPE DRIVE WITH WRITE ENABLED. NOTE THAT WE HAVE ALSO HAD
//* TO SPECIFY THAT TH TAPE IS DEN6250 WITH A STANDARD LABEL (SL).
//* WE WOULD BE WRITING OUR OWN (PROCESSED) DATA ONTO THIS TAPE.
//*
/*SETUP  DSN=JADEPR.REDUCTWO.G0025V00
/*SETUPC DSN=JADEPR.REDUCTWO.G0026V00
/*SETUP 333333,DEN6250,SL,W
//*
//* COMPILE AND LINK STEPS
//* ======================
//*  THESE ARE VIRTUALLY THE SAME AS AT DESY. NOTE, HOWEVER, THAT THE
//*  STEP NAMES ARE DIFFERENT. COMPILE IS C , LINK IS L AND GO IS G.
//*  (RATHER THAN CO, LKED AND GO AT DESY).
//*  THE ONLY OTHER MAJOR DIFFERENCE IS IN THE NAMES OF THE JADE AND
//*  UTILITY LOAD LIBRARIES. MOST OF THE ONES THAT YOU WOULD NORMALLY
//*  REQUIRE ARE USED IN THIS EXAMPLE.
//*
//  EXEC FHCLG,CPRINT=YES,
//  PARM.C='OPT=3,LINECNT=60,NOXREF,NOMAP',REGION.C=400K,
//  PARM.L='LIST,MAP,SIZE=(208K,28K)',REGION.L=210K,
//  REGION.G=800K
//C.SYSIN DD *
      SUBROUTINE USER(INDEX)
      IMPLICIT INTEGER*2(H)
#include "cdata.for"
      IF(INDEX.EQ.1)PRINT100,INDEX
 100  FORMAT(' TEST USER CALLED WITH INDEX =',I6)
      RETURN
      END
/*
//L.SYSLIB DD
//         DD
//         DD
//         DD
//         DD DISP=SHR,DSN=ULIB.JADEGL
//         DD DISP=SHR,DSN=ULIB.TASSLIB
//         DD DISP=SHR,DSN=USER.DJLIB
//         DD DISP=SHR,DSN=SYS1.HBOOK
//         DD DISP=SHR,DSN=SYS1.CERNLIB
//L.SYSIN DD *
  INCLUDE SYSLIB(JDMAIN0)
/*
//*
//* GO STEP JCL
//* ===========
//*
//* STANDARD LINE PRINTER OUTPUT
//*
//G.FT06F001 DD SYSOUT=A
//*
//* INPUT DATA TAPES
//*
//G.FT02F001 DD      UNIT=DEN6250,DISP=SHR,DSN=JADEPR.REDUCTWO.G0025V00
//G.FT02F002 DD UNIT=AFF=FT02F001,DISP=SHR,DSN=JADEPR.REDUCTWO.G0026V00
//*
//* OUTPUT TAPE FOR WRITING MY DATA
//*
//G.FT03F001 DD UNIT=DEN6250,DISP=(NEW,KEEP),DSN=MYOUTPUT,
//           DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//           VOL=SER=333333,LABEL=(1,SL,,OUT)
//*
//* CALIBRATION FILES
//*
//G.FT21F001 DD DISP=SHR,DCB=(BUFNO=1),DSN=JADEPR.AUPDAT0
//G.FT22F001 DD DISP=SHR,DCB=(BUFNO=1),DSN=JADEPR.AUPDAT1
//
$   28/05/84 508061722: MEMBER NAME  #R1LB    (BIBLS)       NEWLIB
//JADERED1 JOB '10622622',REDUCONE,CLASS=L,MSGLEVEL=(1,0),TIME=3
//*MAIN RELPRI=HIG,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*===============================================================*
//*  IF BUPDAT1 IS UPDATED USE IT INSTEAD OF KALWRK0              *
//*  CHECK OF CAL.FILES :   F11BEK.BIBLS(#KALW)                   *
//*===============================================================*
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1LD,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),
//         SPACE=(CYL,(200,50))
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//*
//*T22F001 DD DISP=SHR,DSN=F11LHO.BUPDAT1
//FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=JADEOL.HH.G3138
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00000000 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
//SPOOLING EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//*YSUT2 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),
//*      DCB=(R01DCB.VBS,LRECL=6236),SPACE=(TRK,(300,50),RLSE),
//*      DSN=JADEPR.HH.G3138
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,CATLG),
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//       DSN=JADEPR.HH.G3138
//*
$   18/10/81 409121208  MEMBER NAME  #START0  (JADESR)      CLIST
FREE F(MACRO,CLIST)
ALLOC F(MACRO) DA('F11GOD.PATRECSR') SHR
ALLOC F(CLIST) DA('F11PEA.JDCLIST') SHR
CLEAR
$HOW ' ALL DESY REDUC1 TASKS ARE NOW CONTROLLED BY A CLIST. TO INVOKE  '
$HOW ' THIS SIMPLY TYPE IN '
$HOW '                    (REDUC1)'
$HOW ' AND ANSWER THE QUESTIONS. THE TASKS CURRENTLY PERFORMED BY THIS'
$HOW ' CLIST ARE TO :                '
$HOW ' (1) .. MAKE AN ARCHIVE COPY OF A REDUC1 MERGE TAPE'
$HOW ' (2) .. COPY MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE'
$HOW ' (3) .. LIST THE RUN CONTENTS OF A REDUC1 MERGE TAPE'
$HOW ' (4) .. SUBMIT A REDUC1 MERGE JOB'
$HOW ' (5) .. RE-LINK THE REDUC1 LOAD MODULE'
$HOW ' (6) .. SUBMIT A REDUC1 JOB'
$HOW ' (7) .. COPY A DESY REFORM TAPE ONTO A RUTHERFORD TAPE'
$HOW ' (8) .. LIST THE FILE CONTENTS OF A RUTHERFORD TAPE'
$HOW '                                                     GFP 27/02/82'
$HOW '-----------------------------------------------------------------'
SHOW '-----------------------------------------------------------------'
SHOW ' SEND A MESSAGE TO SOMEONE AT RUTHERFORD WITH THE COMMAND :      '
SHOW '                   (RUTHMAIL)                 OR (IN FULL)       '
SHOW '           "F11PEA.JDCLIST(RUTHMAIL)"                            '
SHOW '                                                    GFP          '
SHOW '-----------------------------------------------------------------'
$   06/07/82 403121153  MEMBER NAME  #START1  (JADESR)      CLIST
$   18/10/81 205181154  MEMBER NAME  #START   (JADESR)      CLIST
FREE F(MACRO,CLIST)
ALLOC F(MACRO) DA('F11GOD.PATRECSR') SHR
ALLOC F(CLIST) DA('F11PEA.JDCLIST') SHR
CLEAR
$HOW '1979 REDUC1 LIBRARY IS FOUND ON   JADEPR.ZZ.JADESR.B800222'
$HOW '                                                          '
$HOW ' JBUP4SET TO DELETE SCRATCH FILES 2-4 AFTER REFORMATTING (LHO)'
$HOW ' '
$HOW ' PLEASE SUBMIT NOT MORE THAN 6 RED-JOBS IN ADVANCE !!!!!!!!!!!!'
$HOW ' WE WILL GET OTHERWISE COMPLAINTS FROM R1 (PST)    !!!!!!!!!!!!'
$HOW '                  '
$HOW ' NEW RFM-JOB: JBNRFMT1,JBNRFMT2 '
$HOW '     JBNRFMT2(CLASS A)SEEMS TO BE FASTER THAN JBNRFMT1(CLASSK)
$HOW '     RED-JOB: JBNREDUC'
$HOW ' INTRODUCED NEW RING NUMBER "JRING" FROM JETC BANK HEADER INTO   '
$HOW ' EVCONV7. RELINKED REFRMLD. 11.51 31.03.80. L.H. O'NEILL         '
$HOW '                                                                 '
$HOW ' CHANGED JBSORDER TO WRITE ONTO F11LHO.FASTSEL1 INSTEAD OF 0     '
$HOW ' AND CUT THE SCRATCH DISK ALLOCATION DOWN TO 150 TRACKS.         '
$HOW '                                 L.H. ONEILL 17.50 03.05.80      '
$HOW '                                                                 '
$HOW '       A MULTI-STEP JOB NOW EXISTS TO                            '
$HOW '     MERGE, ARCHIVE , AND THEN TEST READ REDUC1 TAPES .          '
$HOW '       SEE MEMBER JBMRG                                          '
$HOW '                         MALCOLM                                 '
$HOW '                                                                 '
$HOW ' CHANGED JBNRFMT2 AND JBREFMT2 TO USER A SCRATCH FILE INSTEAD    '
$HOW ' OF F11LHO.KALWRK1. THIS SAVES A LITTLE SPACE ON STOR05.         '
$HOW '                                 L.H. ONEILL 17.10 15.05.80      '
$HOW ''
$HOW ' USREDUC1 CHANGED: LOWER PT LIMITS               '
$HOW ' OLD VERSIONS: USRED11 (ONLY SOURCE)                   '
$HOW ' BACKUPS ON ZZ.JADESR/LD.B800602                                 '
$HOW '                                 P. STEFFEN  11.51 09.06.80      '
$HOW ''
$HOW ' TRGCHK CHANGED(MISSING "ELSE"), PATROL CHANGED(UNDEFINED "S6")  '
$HOW ' MODUL RELINKED, BACKUP ON ZZ.JADELD.B800620           '
$HOW '                                 P. STEFFEN   9.00 20.06.80      '
$HOW '                                                                 '
$HOW ' SHORTENED FASTSEL AND GO REFORM JOBS WORKING ON IT AGAIN.       '
$HOW '
$HOW '     **************  REMEMBER TO SCRATCH EXISTING *********'
$HOW ' JADEPR.ST TAPES BEFORE SUBMITTING REDUC JOBS .                  '
$HOW '            '
$HOW ' CHANGE KALREV SO THAT IT GOES INTO A DELIBERATE DEAD LOOP'
$HOW ' IF LESS THAN 10 SECONDS CPU TIME LEFT AT CALL.
$HOW '                                 L.H. ONEILL 17.30 08.07.80'
$HOW ' CHANGED EVFOLDKW TO ELIMINATE BUG WHICH CAUSED ONLY ONE  '
$HOW ' EVENT PER RUN TO BE LISTED IN THE SUMMARY AT THE END.
$HOW '                                 L.H. ONEILL 08.25 10.07.80'
$HOW ' SCRATCHED TRGCHK AFTER SAVING THE SOURCE ONLY UNDER MEMBER'
$HOW ' TRGCHK8. RENAMED TRGCHKPS TO TRGCHK. RELINKED REDUC LOAD.'
$HOW '                                 L.H. ONEILL 12.24 25.07.80'
$HOW ' SCRATCHED TRGCHK AFTER SAVING THE SOURCE ONLY UNDER MEMBER'
$HOW ' TRGCHK8. RENAMED TRGCHKPS TO TRGCHK. RELINKED REDUC LOAD.'
$HOW '                                 L.H. ONEILL 12.24 25.07.80'
$HOW ' MADE NEW REFORMATTING MODULE WITH ADC ADDRESS ERROR       '
$HOW ' RECOVERY.                                                '
$HOW '                                 L.H. ONEILL 17.28 01.08.80'
$HOW ' CHANGED LGCUT AND USREDUC1 TO ACCOMODATE FWD MUON CNTRS   '
$HOW ' OLD VERSIONS ARE LGCUT0 AND USREDUC0                     '
$HOW '  RELINKED LOAD MODULE                                    '
$HOW '                                M. GODDARD AUG 3 80       '
$HOW ' REMOVED 512-ADDITION KLUGE OF 1 AUG. FROM EVCONV7 AND EVCONV9. '
$HOW ' COMPILED EVCONV9 TO THE LOAD. CHANGED JBLREFM SO THAT EVCONV9 '
$HOW ' IS STANDARDLY INCLUDED AND RELINKED REFORMATTING LOAD MODULE.'
$HOW ' THUS FOR THE TIME BEING WATANABES ERROR RECOVERY ROUTINE '
$HOW ' LGRFM1 IS ALWAYS CALLED FOR LEAD GLASS REFORMATTING.     '
$HOW ' THE ERROR CODE FROM THIS ROUTINE IS ADDED TO THE FIRST   '
$HOW ' HALF WORD OF THE ALGL BANK DESCRIPTOR.                   '
$HOW '                                 L.H. ONEILL 18.42 19.08.80'
$HOW ' CHANGED JBNRFMT2 TO WRITE ONTO JADEPR.FASTSEL6 INSTEAD OF      '
$HOW ' F11LHO.FASTSEL .                                              '
$HOW '                                MALCOLM,FRI AUG 29            '
$HOW ' REDUC179 RENAMED TO REDUCSUM                                   '
$HOW '                             MALCOLM , MON SEPT 1              '
$HOW '--------------------------------------------------------------'
$HOW ' EVFOLDKW CHANGED: CHECK ONLY IF INCREASING EVENT #             '
$HOW '                   REFMLD(LOAD MODUL) RELINKED PST, 19/9/80    '
$HOW '--------------------------------------------------------------'
$HOW ' STRAIGHTENED OUT FASTSEL MESS. CHANGED JBNRFMT2 TO WRITE ONTO  '
$HOW ' F11LHO.FASTSEL AGAIN.                                          '
$HOW '                   L.H. ONEILL 15.30 25 SEPT. 1980             '
$HOW '--------------------------------------------------------------'
$HOW ' TRGCHK   CHANGED: 3-TRACK TRIGGER BIT ALLOWED                  '
$HOW ' USREDUC1 CHANGED: PLOT VARIABLES SET REAL       PST, 26/9/80'
$HOW '--------------------------------------------------------------'
$HOW ' CHANGED EVCONV7 AND EVCONV9 TO ALLOW VARIABLE LENGTH NORD      '
$HOW ' HEADER BANK. RELINKED BADCHLD, REDUCLD AND REFRMLD, THE LATTER'
$HOW ' WITH INCLUSION OF EVCONV7, NOT 9, I.E. WITHOUT BAD ADC RECOVERY.'
$HOW '                       18.09 ON 26 SEPT. 1980. L.H. ONEILL       '
$HOW '--------------------------------------------------------------'
$HOW '--------------------------------------------------------------'
$HOW ' ADDED ALIAS VERSIONS OF KALREV AND KALADD, NAMED KALELM AND     '
$HOW ' KALM1S, AND A NEW DRIVER JOB NAMED JBREDOBL. THESE ARE FOR    '
$HOW ' REDOING THE BAD ADC DATA. THE KALADD VERSION UNDER ALIAS KALM1S'
$HOW ' SUBTRACTS 201 SECONDS INSTEAD OF THE USUAL 200 FROM THE TIME   '
$HOW ' GIVEN IN THE WATANABE SPINNING BLOCK RECORDS. THEN IN THE TIME-'
$HOW ' ORDERED SCRATCH CALIBRATION FILE THE OLD SPINNING BLOCK BANKS  '
$HOW ' WRITTEN BEFORE THE WATANABE CORRECTION ROUTINES BECAME AVAILABLE'
$HOW ' COME ONE SECOND AFTER THE NEW BANKS FOR THE SAME RUNS. THE OLD  '
$HOW ' BANKS ARE THEN ELIMINATED IN THE COPY FROM THE SCRATCH FILE TO  '
$HOW ' KALWRK0. THIS IS DONE BY THE KALREV ALIAS UNDER MEMBER KALELM.
$HOW '                       12.41 ON 29 SEPT. 1980. L.H. ONEILL       '
$HOW '--------------------------------------------------------------'
$HOW ' JADEPRLD RELINKED, ERROR(TRHTCK) CORRECTED ON PATRECSR/LD       '
$HOW '                       18.40 1/10/80 P.STEFFEN'
$HOW '--------------------------------------------------------------'
$HOW ' CHANGED USREDUC1 AND RELINKED REDUCLD TO SKIP RUN 5153, '
$HOW '  EVENT 26. ON JDATA04 #7. THIS CAUSES 0C4 IN BOS WRITE ROUTINE. '
$HOW '                       12.00 15/10/80 L.H. ONEILL.               '
$HOW '--------------------------------------------------------------'
$HOW ' TAPE JDATA04 #7 NOW THROUGH REDUC1. REMOVE THE CUT ON   '
$HOW '  RUN 5153, EVENT 26 IN USREDUC1 AND RELINK REDUCLD.             '
$HOW '                       09.00 16/10/80 L.H. ONEILL.               '
$HOW '--------------------------------------------------------------'
$HOW '  UPDATED REDUCTWO:  NEW TAPES 72 - 79     J.OLSSON  31.10.80'
$HOW '  REMOVED RUN 5153 PRINT STATEMENT USREDUC1. DONT BOTHER TO  '
$HOW '  RELINK REDUCLD. STATEMENT WILL DISAPPEAR NEXT TIME MODULE  '
$HOW '  IS RELINKED.         11.06 31/10/80 L.H. ONEILL            '
$HOW '  UPDATED REDUCTWO:REDUC2 TAPES AUTUMN 1980 REMADE J.O.26.11.80'
$HOW '--------------------------------------------------------------'
$HOW '  RELINKED REDUCLD FOLLOWING INSTALLATION OF NEW NOSAKI      '
$HOW '  CALIBRATION CONSTANTS ONTO THE STANDARD FILES. HAD TO SCRATCH'
$HOW '  KALELM IN ORDER TO COMPRESS JADELD - RECORDS GREATER THAN  '
$HOW '  BLOCK SIZE OR SOME SUCH NONSENSE. NO LONGER NEEDED ANYWAY. '
$HOW '                       21.58 08/12/80 L.H. ONEILL              '
$HOW '--------------------------------------------------------------'
$HOW '  RELINKED REDUCLD, REFRMLD AND BADCHLD TO BE SURE EVERYTHING  '
$HOW '  IS UP TO DATE FOR THE START OF 1981 RUNNING.                 '
$HOW '                       18.07 16/02/81 L.H. ONEILL              '
$HOW '--------------------------------------------------------------'
$HOW '  RE - RELINKED REDUCLD,            '
$HOW '                       1730  17/02/81 M.GODDARD                '
$HOW '--------------------------------------------------------------'
$HOW '  CHANGED EVCONV7 TO SET UP THE ATAG POINTERS PROPERLY FOR THE '
$HOW '  NEW TAGGING BLOCK SCHEME. RELINKED REFRMLD.                  '
$HOW '                       16.57 21/02/81 L.H. ONEILL              '
$HOW '--------------------------------------------------------------'
$HOW '  TAUGHT ADDON TO RECOGNIZE THE BANK MPRC. RELINKED REFRMLD.   '
$HOW '                       14.26 24/02/81 L.H. ONEILL              '
$HOW '--------------------------------------------------------------'
$HOW '  CHANGED THE STATEMENT:  IF IDATA(IQJETC).GT.0 TO             '
$HOW '  IF IDATA(IQJETC).LT.0 AT LINE 61700 IN USRECUC1. THIS WILL   '
$HOW '  BYPASS SLOW PATTERN RECOGNITION. RELINKED REDUCLD.           '
$HOW '                       11.59 12/03/81 L.H. ONEILL              '
$HOW '--------------------------------------------------------------'
$HOW '  ADDED AN END FILE NOUT AFTER THE BWTEND CALL END EVFOLDKW.   '
$HOW '                       15.59 15/03/81 L.H. ONEILL              '
$HOW '--------------------------------------------------------------'
$HOW '  CHANGED THE STATEMENT:  IF IDATA(IQJETC).LT.0 TO             '
$HOW '  IF IDATA(IQJETC).GT.0 AT LINE 61700 IN USRECUC1. THIS WILL   '
$HOW '  REVERSE THE CHANGE MADE ON 12/03/81 AND REACTIVATE SLOW      '
$HOW '  PATTERN RECOGNITION. RELINKED REDUCLD.                       '
$HOW '                       13.47 26/03/81 L.H. ONEILL              '
$HOW '--------------------------------------------------------------'
$HOW '  CHANGED TRGCHK TO RECOGNIZE NEW COLLINEAR TRIGGER            '
$HOW '                       APRIL 11 1981  M C G                    '
$HOW '--------------------------------------------------------------'
$HOW '  CHANGED USREDUC1 TO WRITE EVENTS WITH NO PATR BANK             '
$HOW '  AND TO PRINT SOME CALIBRATION NUMBERS.                         '
$HOW '  ALSO UPDATED FWMU ACCEPT                                       '
$HOW '                       APRIL 14 1981  M C G                    '
$HOW '--------------------------------------------------------------'
$HOW '  CHANGED USREDUC1 TO DROP PRINTOUT OF CONSTANTS                 '
$HOW '                       APRIL 24 1981  P S T                    '
$HOW '-----------------------------------------------------------------'
$HOW '  RELINKED REDUCLD TO MAKE SURE LATEST TRGCHK GET INTO MODULE.   '
$HOW '                       APRIL 29 1981 18.10 LHO                 '
$HOW '-----------------------------------------------------------------'
$HOW '  MOVED SUBROUTINE DUMDUM FROM MEMBER LGCUT TO MEMBER DUMDUM     '
$HOW '                         MAY 10 1981 14.50 GFP                   '
$HOW '-----------------------------------------------------------------'
$HOW '  TRGCHK CHANGED: ACCEPT UNKNOWN TRIGGER                        '
$HOW '                  REQUIRE 3 TRACKS FOR 3 TRACK TRIGGER          '
$HOW '                  TRGCHK0 = OLD VERSION                         '
$HOW '                  P. STEFFEN 81/05/13 10.00                     '
$HOW '-----------------------------------------------------------------'
$HOW '  MEMBERS USREPTIL AND JBREPTIL NOW DO THE JOB OF RECALIBRATION '
$HOW '  PROBLEM LIES IN THE FACT THAT DATA WITHOUT PATR AND JHTL      '
$HOW '  STILL HAS 2 JETC BANKS, SOMETIMES.THE CORRESPONDING NECESSARY '
$HOW '  BRANCHING HAS NOW BEEN INTRODUCED IN USREPTIL.                '
$HOW '            J.OLSSON ON EVENING OF 21.5.81                      '
$HOW '-----------------------------------------------------------------'
$HOW '  REDUCLD WAS RELINKED 30.5.81, 19.50    NO JOBS DIED. THIS WAS '
$HOW '  NECESSARY TO INCLUDE RECENT CHANGES IN KALIBR.'
$HOW '                 GREETINGS TO MALCOLM.... J.OLSSON '
$HOW '-----------------------------------------------------------------'
$HOW '  DELETED RUTHERFORD TAPE CATALOGUE ENTRIES  ... 13/6/81 G.F.P'
$HOW '-----------------------------------------------------------------'
$HOW '  SUBROUTINE DUMDUM REPLACED WITH RUTHERFORD    ...  6/7/81 G.F.P'
$HOW '  VERSION WHICH DUMMIES OUT ROUTINES NEVER      ...              '
$HOW '  CALLED BY THE REDUC1 PROGRAM.                 ...              '
$HOW '-----------------------------------------------------------------'
$HOW '  LOWERED LG THRESHOLDS IN LGCUT FOR 14 GEV DATA... 21/7/81 M.C.G'
$HOW '                                                ...              '
$HOW '-----------------------------------------------------------------'
$HOW '  USREDUC1, LGCUT AND JBNREDUC MADE COMPATIBLE  ... 10/8/81   GFP'
$HOW '  WITH THE RUTHERFORD VERSIONS - REDUC1 MODULE  ...              '
$HOW '  HAS NOT BEEN RE-LINKED. 0 => OLD VERSIONS     ...              '
$HOW '  NOTE...USELESS HISTOGRAMS ARE NOW GONE !!     ...              '
$HOW '-----------------------------------------------------------------'
$HOW '***  CHANGE OF CALIBRATION FILES:                       *********'
$HOW '     KALADD:  RUN # -> CALIBR.FILE ,   BADCHLD RELINKED   '
$HOW '     RUTHER:  READ ONLY UPDATE FILES , RUTHERLD RELINKED   '
$HOW '     #REFORM: ASTART0/1 FILES COMMENTED OUT                     '
$HOW '     15.09.81 9.45  P. ST.                                      '
$HOW '-----------------------------------------------------------------'
$HOW ' "GETMUONS" PROGRAM OF RJB NOW LOADED ONTO JADEPR.JADELD        '
$HOW '                                       GFP 5/10/81               '
$HOW '-----------------------------------------------------------------'
$HOW '     USREDUC1: |ZVTX| < 300                                      '
$HOW '     TRGCHK:   ERROR(LG-ROW #) CORRECTED                         '
$HOW '     REDUCLD RELINKED                           PST 6/10/81      '
$HOW '-----------------------------------------------------------------'
$HOW ' JCL EXAMPLES FOR VARIOUS REDUC1 TASKS CAN BE FOUND IN :         '
$HOW ' #COPYRUT  ..  JCL TO COPY A RUTHERFORD REDUC1 MERGE TAPE        '
$HOW ' #RED1ARK  ..  JCL TO PRODUCE AN ARCHIVE BACKUP OF A REDUC1 TAPE '
$HOW ' #RED1JCL  ..  JCL FOR A REDUC1 JOB (CLIST)                      '
$HOW ' #RED1LNK  ..  JCL TO RE-LINK THE REDUC1 MODULE                  '
$HOW ' #RED1LST  ..  JCL TO PRODUCE A RUN LISTING OF A REDUC1 TAPE     '
$HOW ' #RED1MRG  ..  JCL FOR THE REDUC1 MERGE JOB (CLIST !)         '
$HOW ' #RUTHTAP  ..  JCL TO CREATE A RUTHERFORD TAPE FROM REFORM TAPE  '
$HOW ' #TAPTEST  ..  JCL TO CHECK CONTENTS OF A RUTHERFORD TAPE        '
$HOW '                                       GFP 6/10/81               '
$HOW '-----------------------------------------------------------------'
$HOW ' IN ADDON + EVCONV7 THE BANCNAME FADC ADDED'
$HOW ' JBLREFM SUBMITTED TO PRODUCE A NEW LOAD MOULE                   '
$HOW '                                      PET 10/12/81               '
$HOW '-----------------------------------------------------------------'
SHOW ' ALL DESY REDUC1 TASKS ARE NOW CONTROLLED BY A CLIST. TO INVOKE  '
SHOW ' THIS SIMPLY TYPE IN '
SHOW '                    (REDUC1)'
SHOW ' AND ANSWER THE QUESTIONS. THE TASKS CURRENTLY PERFORMED BY THIS'
SHOW ' CLIST ARE TO :                '
SHOW ' (1) .. MAKE AN ARCHIVE COPY OF A REDUC1 MERGE TAPE'
SHOW ' (2) .. COPY MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE'
SHOW ' (3) .. LIST THE RUN CONTENTS OF A REDUC1 MERGE TAPE'
SHOW ' (4) .. SUBMIT A REDUC1 MERGE JOB'
SHOW ' (5) .. RE-LINK THE REDUC1 LOAD MODULE'
SHOW ' (6) .. SUBMIT A REDUC1 JOB'
SHOW ' (7) .. COPY A DESY REFORM TAPE ONTO A RUTHERFORD TAPE'
SHOW ' (8) .. LIST THE FILE CONTENTS OF A RUTHERFORD TAPE
SHOW '                                                     GFP 27/02/82'
SHOW '-----------------------------------------------------------------'
SHOW ' NEW REDUC1 MODULE (REDUC1LD) CREATED                GFP  4/03/82'
SHOW '-----------------------------------------------------------------'
SHOW ' NEW REDUC1 MODULE (REDUC1LD) CREATED                GFP 18/05/82'
$HOW '-----------------------------------------------------------------'
SHOW ' USRED82 AND TRCK82 CHANGED TO ALLOW FOR NEW MUT1 TRIGGER        '
SHOW ' COMPRESS AND BACKUP TAKEN FIRST. OLD VERSIONS COPIED TO         '
SHOW ' USRED820 AND TRCK820. REDUC1 MODULE RE-LINKED.      GFP 21/05/82'
SHOW '-----------------------------------------------------------------'
SHOW ' REFORMAT JOB JCL CHANGED TO ALLOW FOR THE CHANGEOVER TO A       '
SHOW ' SINGLE CALIBRATION FILE.                           GFP 10/09/82 '
SHOW '-----------------------------------------------------------------'
SHOW ' SEND A MESSAGE TO SOMEONE AT RUTHERFORD WITH THE COMMAND :      '
SHOW '                   (RUTHMAIL)                 OR (IN FULL)       '
SHOW '           "F11PEA.JDCLIST(RUTHMAIL)"                            '
SHOW '                                                    GFP          '
SHOW '-----------------------------------------------------------------'
SHOW ' USRED82: CHANGED TO COPE WITH ONLY 1 CALIBR. FILE (KALWRK0)     '
SHOW '          OLD VERSION = USRED820                                 '
SHOW ' EVCONV7 --> ECVONV, JBLREFM CHANGED ACCORDINGLY                 '
SHOW ' EVCONV9 + EVFOLDN5 DELETED                         PST 23/09/82 '
SHOW '-----------------------------------------------------------------'
SHOW ' USRED82: CHANGED TO ---REJECT--- RUN NUMBERS <= 63              '
SHOW '                                     BARRIE WHITAKER  06/06/83   '
SHOW '-----------------------------------------------------------------'
SHOW ' USREDUC1 AND LGCUT CHANGED TO CONFORM WITH PRTOCI ON TPSOURCE   '
SHOW '                                     J.OLSSON         17/12/83   '
$   28/05/84 508061722: MEMBER NAME  #SUPVLB  (BIBLS)       NEWLIB
//JADETEST JOB CLASS=A,MSGLEVEL=(2,0),TIME=(01,00)
//*MAIN RELPRI=HIG,LINES=2
//*MAIN ORG=EXT
// EXEC GEP,PARM.LKED='SIZE=(600K,60K)',REGION.LKED=800K,
//  REGION.GO=1100K
//COMP.SYSIN  DD *
#include "supvlb.for"
//*
//*
//*       ***************   COPY  JOB    *********************
//*
//*         --->    SET PARAMETERS IN COPYLB
//*
//LKED.SYSLIB DD
//            DD
//            DD
//            DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=F11BEK.USER.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11BEK.BIBLL
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*
//*         -------   INPUT   -------
//*
//*O.FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.G0916V00
//GO.FT02F001 DD DISP=SHR,DSN=JADEPR.RED1HELP.R124
//*
//GO.FT30F001 DD DISP=SHR,DSN=JADEPR.DSK.DIFF916
//*
//*         -------   OUTPUT  -------
//*
//*O.FT03F001 DD  DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*    MSVGP=VTMP,UNIT=3330V,
//*    DSN=JADEPR.TMP.RED1HELP.G0916
//*    DSN=JADEPR.TMP.REDUCONE.G0916
//*
//GO.FT03F001 DD DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,UNIT=TAPE,
//    DSN=JADEPR.RED1HELP.DIFF916
//*
//*O.FT30F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),
//*   DCB=(R01DCB.VBS,LRECL=6236),SPACE=(TRK,(300,50),RLSE),
//*   DSN=JADEPR.DSK.RUTH916
//*
//GO.FT03F001 DD DUMMY
//GO.FT04F001 DD DUMMY
//*            -------- GEP ---------
//GO.SYSIN DD *
PRINT
DST 10  '      RUN - NUMBER  OF  WRITTEN  EVENTS
ENDQ
$   28/05/84 508061722: MEMBER NAME  #TEMP    (BIBLS)       NEWLIB
//JADEPR   JOB 10622622,F11OLS,CLASS=A,MSGLEVEL=(1,0),TIME=(0,20)
//*MAIN ORG=EXT,RELPRI=HIG
// EXEC FLG
//LKED.SYSLIB DD
//            DD
//            DD DSN=F22ELS.CL11,DISP=SHR,UNIT=FAST
//            DD DSN=F1EBLO.BOSLIB.L,DISP=SHR,UNIT=FAST
//LKED.SYSIN DD *
  INCLUDE SYSLIB(ECOPY)
//*                INPUT
//*GO.FT02F001 DD DISP=SHR,DSN=F11OLS.MSNEUSUM.N237238
//*            DD DISP=SHR,DSN=F11OLS.MSNEUSUM.N201
//*GO.FT02F001 DD UNIT=TAPE,DISP=OLD,
//*         DSN=F11OLS.R2610
//*   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=F11OLS.R2611
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,
//         DSN=JADEPR.REDUC1HH.G0080V00
//*GO.FT02F001 DD UNIT=TAPE,DISP=OLD,
//*    VOL=SER=F11123,LABEL=(1,SL,,IN)
//*               OUTPUT
//*GO.FT03F001 DD DUMMY
//*GO.FT03F001 DD DISP=SHR,DSN=F11OLS.R283.RAWD19
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,KEEP),LABEL=(1,NL),
//*   DCB=(R01DCB.VBS,LRECL=6229,BLKSIZE=6233,DEN=4),
//*   DSN=YEN08150,VOL=SER=F11105
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*   DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.RED2NEU.TAPE84A
//GO.FT03F001 DD DISP=(NEW,CATLG,CATLG),DCB=R01DCB.VBS,
//    DSN=JADEPR.TEMPDL8,
//         MSVGP=VTMP,UNIT=3330V
//*GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//*   DCB=(R01DCB.VBS,LRECL=6236),
//*       SPACE=(CYL,(240,12)),DSN=&&SCRTCH
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//*COPY EXEC PGM=IEBGENER
//*SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//*SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*          DSN=F11OLS.TR2NGAM.TAPE82A
//*SYSPRINT DD SYSOUT=*
//*SYSIN DD DUMMY
$   28/05/84 508061722: MEMBER NAME  JBBLANK  (BIBLS)       NEWLIB
//JADEPRU0 JOB 10622622,'GENERAL',TIME=(0,02),CLASS=E
//*MAIN RELPRI=HIG
// EXEC FCLG,LIB1='F11LHO.JADEGL'
//FORT.SYSIN DD *
      CALL KALLST
      STOP
      END
      SUBROUTINE KALLST
      IMPLICIT INTEGER*2 (H)
C---
C---     JUST LISTS OFF CALIBRATION FILE RECORDS, OR PIECES THEREOF.
C---                                   L.H. O'NEILL 06.09.79
C---
      DIMENSION IBUF(10000)
      DIMENSION HBUF(20000)
      EQUIVALENCE(IBUF(1),HBUF(1))
C---
      LTOT=0
      NREC=0
    1 CONTINUE
      CALL EVREA1(2,NWORD,IBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NREC=NREC+1
      LTOT=LTOT+NWORD+1
      IOUT=NWORD
      IF(IOUT.GT.10) IOUT=10
      IF(NREC.EQ.1) WRITE(6, 99) NREC,NWORD,(IBUF(I),I=1,IOUT)
      IF(NREC.NE.1) WRITE(6,100) NREC,NWORD,(IBUF(I),I=1,IOUT)
   99 FORMAT(1X,I4,2I12)
  100 FORMAT(1X,I4,I12,' ',A4,' ',9I10)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
      LBTOT=4*LTOT
      WRITE(6,103) LTOT,LBTOT
  103 FORMAT('0TOTAL LENGTH IN I*4 WORDS AND BYTES:',2I10)
      RETURN
      END
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KALWRK0
//
$   28/05/84 508061722: MEMBER NAME  JBCAMFIX (BIBLS)       NEWLIB
//JADEPRFM JOB '10622622',PRODUC,CLASS=A,MSGLEVEL=(1,1),TIME=1
//*MAIN RELPRI=HIG
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
// EXEC NEWFAST
//*   FIX 29 FEB 1981 ON KALWRK0.
//*
//*   FIND BAD BLOCKS
//*
//SPBL EXEC FCLG,FORT='XL,OPT=2,LEVEL=4'
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      REWIND 4
      REWIND 8
      CALL KALCOP
      CALL KALADD
      CALL KORDER
      CALL KALREV
      REWIND 4
      STOP
      END
#include "kalcop.for"
#include "kaladdfx.for"
#include "korder.for"
#include "kalrev.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
// DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//GO.FT02F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK0
//*GO.FT03F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK1
//GO.FT08F001 DD UNIT=FAST,DISP=OLD,DSN=F22WAT.LGBAD0
//GO.FT04F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//   SPACE=(CYL,(20,20)),DSN=&&SCRTCH
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//   SPACE=(CYL,(20,20)),DSN=&&SCRTCH1
//*
$   28/05/84 508061722: MEMBER NAME  JBCOPY   (BIBLS)       NEWLIB
//F11PST   JOB CLASS=E,MSGLEVEL=(0,0),TIME=(0,15)
//*MAIN LINES=(3),ORG=EXT,RELPRI=HIG
// EXEC FCLG,PARM.LKED='MAP,LIST',REGION.GO=850K
#include "uscopy.for"
//LKED.SYSLIB DD
//            DD
//            DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//            DD DSN=F11GOD.PATRECLD,UNIT=FAST,DISP=SHR
//            DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//            DD DSN=F22ALL.JADEMUL,UNIT=FAST,DISP=SHR
//            DD DSN=F1EBLO.BOSLIB.L,UNIT=FAST,DISP=SHR
//            DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
//*
//GO.FT21F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT0,DISP=SHR
//GO.FT22F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT1,DISP=SHR
//*
//GO.FT02F001 DD DISP=SHR,
//    DSN=JADEPR.RED1OU2
//*
//*O.FT03F001 DD DUMMY
//GO.FT03F001 DD DISP=OLD,
//          DSN=JADEPR.RED1.T1ACC
$   28/05/84 508061722: MEMBER NAME  JBDSKREF (BIBLS)       NEWLIB
//JADEPRSQ JOB '10622622',PRODUC,CLASS=A,MSGLEVEL=(1,1),TIME=(0,15)
//*MAIN RELPRI=HIG
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
// EXEC NEWFAST
//*
//*    REFORMAT EVENTS
//*
//REFM EXEC FCLG,FORT='XL,OPT=2,LEVEL=4',
//      LKED='MAP,LIST',REGION=750K
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      COMMON/CDFLAG/IDFLAG,LIMOUT,NRNMIN,NRNMAX
      IDFLAG=0
      LIMOUT=1000000
      NRNMIN=      0
      NRNMAX=1000000
      CALL REFMAI
      STOP
      END
#include "reshuf.for"
#include "evfoldkw.for"
#include "addon.for"
#include "evconv7.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADEPR.YENLHO.L,UNIT=FAST,DISP=SHR
// DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
// DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(BREADKW,BWRITEKW)
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ORIC
//GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//  SPACE=(TRK,(50,20),RLSE),DSN=F11LHO.ORICREFM
//GO.FT04F001 DD DUMMY
//GO.FT08F001 DD DUMMY
//GO.FT09F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.FASTSEL
//*
$   28/05/84 508061722: MEMBER NAME  JBLBADC  (BIBLS)       NEWLIB
//JADEPRLK JOB '10622622',PRODUC,CLASS=E,MSGLEVEL=(1,1),TIME=(0,10)
//*MAIN RELPRI=HIG,LINES=(2),ORG=EXT
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
//*
//*   FIND BAD BLOCKS
//*
//LINK EXEC FCL,PARM.LKED='LIST,MAP'
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      REWIND 4
      REWIND 8
      CALL KALCOP
      CALL KALADD
      CALL KORDER
      CALL KALREV
      REWIND 4
      STOP
      END
//LKED.SYSLIB DD
//            DD
//            DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
//            DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
//            DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//LKED.SYSLMOD DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD(BADCHLD)
//*
$   28/05/84 508061722: MEMBER NAME  JBLBADC1 (BIBLS)       NEWLIB
//JADEPRLK JOB '10622622',PRODUC,CLASS=E,MSGLEVEL=(1,1),TIME=(0,10)
//*MAIN RELPRI=HIG,LINES=(2),ORG=EXT
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
//*
//*   FIND BAD BLOCKS
//*
//LINK EXEC FCL,PARM.LKED='LIST,MAP'
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      REWIND 2
      REWIND 3
      CALL KALCOP(2,3)
      CALL KORDER
      CALL KALADD
      CALL KALREV
      REWIND 4
      STOP
      END
//LKED.SYSLIB DD
//            DD
//            DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
//            DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
//            DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//LKED.SYSLMOD DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD(BADCHLD1)
//LKED.SYSIN DD *
  INCLUDE SYSLIB(KALIB)
//*
$   28/05/84 508061722: MEMBER NAME  JBLRED1  (BIBLS)       NEWLIB
//JADER1LK JOB '10622622',REDUCONE,CLASS=E,TIME=(0,15)
//*MAIN RELPRI=HIG,LINES=(2),ORG=EXT
//*
//*-------------------------------------------------------
//*
//* JOB TO LINK AN EXECUTABLE REDUC1 LOAD MODULE AT DESY
//* NEW MODULE NAME = JADEPR.JADELD(RED1LD)
//*
//*-------------------------------------------------------
//*
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
// EXEC FCL,FORT=XL,PARM.LKED='LIST,MAP'
//FORT.SYSIN DD *
#include "jdmain0.for"
//*
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//*           DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R02BUT.CERNLIB
//LKED.SYSLMOD DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD(RED1LD)
//LKED.SYSIN DD *
 INCLUDE SYSLIB(USRED82,GBOOK,DBASEDUM)
//*
$   28/05/84 508061722: MEMBER NAME  JBLRERM  (BIBLS)       NEWLIB
//JADEPRLK JOB '10622622',PRODUC,CLASS=E,MSGLEVEL=(1,1),TIME=(0,15)
//*MAIN RELPRI=HIG
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
//*
//*    REFORMAT EVENTS
//*
//LINK EXEC FCL,PARM.LKED='LIST,MAP'
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      COMMON/CDFLAG/IDFLAG,LIMOUT,NRNMIN,NRNMAX
      IDFLAG=0
      LIMOUT=1000000
      NRNMIN=      0
      NRNMAX=1000000
      CALL REFMAI
      STOP
      END
//LKED.SYSLIB DD
// DD
// DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
// DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
// DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSLMOD DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD(REFRMLD)
//LKED.SYSIN DD *
 INCLUDE SYSLIB(EVFOLDKW,ADDON,EVCONV,BREADKW,BWRITEKW)
//*
$   28/05/84 508061722: MEMBER NAME  JBMEMRD1 (BIBLS)       NEWLIB
//F11OLS   JOB 10622622,OLSSON,CLASS=E,MSGLEVEL=(0,0)
//*MAIN ORG=EXT
// EXEC FCLG
//FORT.SYSIN DD *
      DIMENSION A(80)
C********************** NCOPY IS NUMBER OF COPIES WANTED  *****
      NCOPY = 1
      DO 2 N=1,NCOPY
      WRITE(6,102)
      DO 1 I=1,100000
      READ(5,100,END=99) A
  100 FORMAT(80A1)
C     IF(MOD(I,33).EQ.0) WRITE(6,102)
  102 FORMAT(1H1,/)
      WRITE(6,101) A
  101 FORMAT(3X,72A1,30X,8A1)
C     WRITE(6,103)
  103 FORMAT(/)
    1 CONTINUE
   99 REWIND 5
    2 CONTINUE
      STOP
      END
//GO.SYSIN DD *

                       ****************************
                     I                              I
                    I   JADE COMPUTER NOTE NR. 27    I
                     I                              I
                       ****************************

   *********************************************************************
   *                   JADE DATA REDUCTION,  STEP 1                    *
   *********************************************************************
                                          M.GODDARD  J.OLSSON  P.STEFFEN
                                                              05.10.1979
   ---------------------------------------------------------------------

  GENERAL INFORMATION (BOOK-KEEPING):
  -----------------------------------

     THE START POINT FOR DATA REDUCTION ARE THE DATA TAPES FROM THE
  REFORMATING STEP. THESE ARE FOUND IN THE DATA GENERATION GROUP

                                         F11LHO.JDATA01.REFORM.G0NNNV00

  CURRENT STATUS OF THESE TAPES IS FOUND IN THE MEMBER

                             JADEPR.YENLHO.S(RUNLST)

     BEFORE STARTING THE REDUCTION STEP, AN UPDATING OF "BAD LEAD GLASS"
  INFORMATION HAS TO BE PERFORMED. BOOK-KEEPING OF THIS STEP IS FOUND IN

                             F22WAT.BADCHS(BADCH)

     DATA REDUCTION STEP 1 HAS TWO SERIES OF OUTPUT TAPES. DUE TO TIME
  REASONS, TEMPORARY TAPES WITH THE NAMES
                                         JADEPR.TNNNA
                                         JADEPR.TNNNB  ETC.,
  ARE FIRST CREATED, NORMALLY 3-4 PER REFORM-TAPE (WITH NUMBER NNN)
     THESE TEMPORARY TAPES ARE THEN GROUPED TOGETHER INTO PERMANENT
  TAPES IN THE GENERATION GROUP

                                         JADEPR.REDUC1.G00MMV00

     THE NUMBER MM HAS NO RELATION TO THE PREVIOUS NUMBER NNN OF THE
  REFORMATING STEP. THE BOOK-KEEPING OF THIS STEP IS FOUND IN

                             JADEPR.JADESR(REDUC)

     IF POSSIBLE, THE GROUPING TO REDUC1 TAPES FOLLOWS THE VARIOUS
  CM-ENERGIES.

  THE DATA REDUCTION CUTS:
  ------------------------

    LEAD GLASS PULSER EVENTS ARE REJECTED (NORMALLY 13 EVENTS / RUN)

    AFTER THE EVENT IS READ AND BEFORE IT GOES ON TO ZVERTEX CALCULATION
  AND PATTERN RECOGNITION, SEVERAL FLAGS ARE SET:

      1. OVERFLOW FLAG IFLW, 0 OR 1  (SHORTER OR LONGER THAN 3000 WORDS)
      2. TAGGING FLAG IFTG       BY CALLING SUBR. TAGFLG(IFTG), WHICH
              SETS FLAG FOR ENERGY IN FORWARD TAGGING BLOCKS
             IFTG = 0      NO ENERGY
             IFTG = 11     ENERGY ABOVE LIMIT IN NEG. FW ARM
             IFTG = 12     ENERGY ABOVE LIMIT IN POS. FW ARM
             IFTG = 113    ENERGY ABOVE LIMIT IN BOTH FW ARMS  (LUMI)
      3. TOKYO LEAD GLASS LABEL, IAC
             IAC = 0 IF ETOT < 7 GEV AND ECYL < 3.5 GEV
             IAC = 0 IF LGCALB GIVES ERROR RETURN
             IAC = 0 IF ETOT IS CONTAINED (>95%) IN ONE ENDCAP BLOCK
                     (THIS IS CHECKED ONLY IF ETOT > 6 GEV)
             IAC = 1 OTHERWISE

    THESE THREE FLAGS ARE COMBINED INTO ONE WRITE FLAG, IWRT :

      IWRT = 1
      IF(IAC.EQ.0.AND.IFLW.EQ.0.AND.(IFTG.EQ.0.OR.ETOT.LT.300.)) IWRT=0

    THE LAST ETOT LIMIT SERVES TO REJECT PURE LUMI TRIGGERS
  **********
  OBS OBS
    THE WRITE FLAG IS USED TO SAVE THE EVENT IF IT WOULD OTHERWISE BE
  REJECTED IN ONE OF THE FOLLOWING ZVERTEX OR PATREC STEPS.
  **********

    EVENTS WITH NO INNER DETECTOR HITS ARE NOW REJECTED IF IWRT = 0
    EVENTS WITH NO INNER DETECTOR HITS ARE NOW WRITTEN  IF IWRT = 1

  ----->  Z-VERTEX CALCULATION

    EVENTS WITH NO Z-VERTEX (ZVTX) FOUND   ARE REJECTED IF IWRT = 0
    EVENTS WITH ABS(ZVTX) > 450. MM        ARE REJECTED IF IWRT = 0
    ALL OTHER EVENTS PROCEED TO PATTERN RECOGNITION

  ----->  PATTERN RECOGNITION

    EVENTS WITH NO 'PATR' BANK        ARE REJECTED  (PATHOLOGIC)
    NOTE: A RESULT BANK 'PATR' WITH MINIMUM LENGTH OF 8 I*4 WORDS IS
          ALWAYS CREATED, EVEN IF NO TRACK IS FOUND. THE ONLY EXCEPTION
          TO THIS IS WHEN COMMON /BCS/ HAS NOT ENOUGH FREE SPACE EVEN
          FOR THIS SHORT BANK. PRESENT SIZE OF /BCS/ IS 20000 I*4 WORDS
          ( MINUS ADMINISTRATIVE SPACE FOR "BOS")
    EVENTS WITH NO TRACKS (NTR = 0)   ARE REJECTED IF IWRT = 0
    EVENTS WITH NO TRACKS (NTR = 0)   ARE WRITTEN  IF IWRT = 1

  THE REMAINING EVENTS WITH TRACKS (NTR > 0) ARE NOW SEPARATED INTO
  TAGGED AND NONTAGGED EVENTS (IFTG > 0  AND  IFTG = 0). THEY ARE
  TREATED DIFFERENTLY:

   TAGGED EVENTS:

    SEARCH FOR TRACKS WITH > 12 HITS AND PTRANS > 200 MEV
    EVENTS WITH AT LEAST ONE SUCH TRACK ARE WRITTEN
    EVENTS WITHOUT SUCH TRACKS          ARE REJECTED

   NOTAGGED EVENTS:

    THESE EVENTS ARE DIVIDED INTO THREE DIFFERENT CLASSES, ACCORDING TO
  QUALITY OF TRACKS:
      ISTAR=0 MEANS ALL TRACKS SHORT  ( < 12 HITS IN THE R-Z FIT)
      ISTAR=1 MEANS AT LEAST ONE LONG HIGH PTRANS TRACK   ( > 600 MEV)
      ISTAR=2 MEANS AT LEAST ONE LONG TRACK BUT NOT HIGH PTRANS

   ISTAR = 0 EVENTS:

    EVENTS ARE WRITTEN  IF IWRT = 1
    IF IWRT = 0  THE EVENTS UNDERGO A FURTHER CHECK:
       EVENTS ARE WRITTEN IF THEY HAVE AT LEAST ONE LONG ( > 20 HITS)
                                            TRACK IN THE R-FI FIT
       EVENTS ARE REJECTED IF THEY DO NOT HAVE SUCH A TRACK

   ISTAR = 2 EVENTS:
       EVENTS ARE REJECTED IF IWRT = 0
       EVENTS ARE WRITTEN  IF IWRT = 1

   ISTAR = 1 EVENTS:
       EVENTS ARE WRITTEN  IF IWRT = 1
       IF IWRT = 0 THEN THE QUANTITY ZMIN IS CALCULATED:
        ZMIN IS THE SMALLEST Z-AXIS INTERCEPT OF ALL THE LONG TRACKS
       EVENTS ARE REJECTED IF  ZMIN > 450 MM
       IF ZMIN IS < 450 MM  THEN THE QUANTITY RMIN IS CALCULATED
        RMIN IS THE SMALLEST DISTANCE TO THE Z-AXIS OF ALL LONG TRACKS
       EVENTS ARE REJECTED IF    RMIN > 60 MM
       EVENTS ARE WRITTEN  IF    RMIN < 60 MM

  REDUCTION STATISTICS
  --------------------

   BELOW IS GIVEN THE TYPICAL STATISTICS FOR A DATA REDUCTION STEP 1
  ACCORDING TO THE CUTS DESCRIBED ABOVE.  PERCENTAGES GIVEN REFER TO THE
  TOTAL NUMBER OF READ EVENTS (- PULSER EVENTS) IN CASE OF REJECTS AND
  TO THE TOTAL NUMBER OF WRITTEN EVENTS IN CASE OF WRITTEN EVENTS.

       ++++++++   STATISTICS FOR RUN      0    ++++++++++
  EVENTS READ       7000           PULSER EVENTS        13
  OVERFLOW EVENTS    9       LGCALB ERROR RETURNS       0
  6798 EVENTS FAILED LGLASS CUT     97.29%
   189 EVENTS PASSED LGLASS CUT      2.71%
    95 EVENTS HAD BAD LGLASS BLOCKS      1.36%    (E-CAP SPINNERS)
  5966 EVENTS HAVE NO TAG TRIGGER     85.39%
  1021 EVENTS HAVE TAG TRIGGER        14.61%
   149 EVENTS WITH TAG TRIGGER AND ETOT >  300. MEV      2.13%
  6650 EVENTS WITH COMBINED WRITE FLAG OFF   95.18%
   337 EVENTS WITH COMBINED WRITE FLAG ON     4.82%
   110 EVENTS HAD NO ID HITS AND WRITE FLAG OFF      1.57%         (REJ)
     0 EVENTS HAD NO ID HITS AND WRITE FLAG ON      0.0 %          (WRI)
  6877 EVENTS ENTERED ZVERTEX ROUTINE      98.43%
   821 EVENTS FAILED TO FIND Z VERTEX & HAD WRITE FLAG OFF  11.75% (REJ)
   122 EVENTS FAILED TO FIND Z VERTEX BUT HAD WRITE FLAG ON  1.75% (WRI)
  3045 EVENTS HAD ZVTX > 450 AND WRITE FLAG OFF     43.58%         (REJ)
  3011 EVENTS THROUGH PATREC      43.09%
    87 EVENTS WERE 0 PRONGS        1.25%
     6 EVENTS WERE 0 PRONGS AND HADE NO WRITE FLAG      0.09%      (REJ)
    81 EVENTS WERE 0 PRONGS AND HAD WRITE FLAG ON      6.61%       (WRI)
  2924 EVENTS HAD AT LEAST ONE TRACK       41.85%
   222 EVENTS WITH TRACKS AND TAG FLAG       3.18%
    40 EVENTS WITH TRACKS AND TAG FLAG, LOW MOMENTUM       0.57%   (REJ)
   182 EVENTS WITH TRACKS AND TAG FLAG, HIGH MOMENTUM      14.86%  (WRI)
   103 EVENTS WERE ISTAR=0       1.47%
    46 EVENTS WERE ISTAR=0 AND HAD WRITE FLAG ON      3.76%        (WRI)
    11 EVENTS WERE ISTAR=0 BUT HAD LONG TRACK IN RFI  0.90%        (WRI)
    46 EVENTS WERE ISTAR=0 AND HAD NO LONG TRACK IN RFI      0.66% (REJ)
   990 EVENTS WERE ISTAR=2      14.17%
    30 EVENTS WERE ISTAR=2 AND HAD WRITE FLAG ON      2.45%        (WRI)
   960 EVENTS WERE ISTAR=2 AND HAD WRITE FLAG OFF     13.74%       (REJ)
  1609 EVENTS WERE ISTAR=1      23.03%
   213 EVENTS HAD ZMIN > 450 AND HAD NO WRITE FLAG      3.05%      (REJ)
     5 EVENTS HAD ZMIN > 450 BUT HAD WRITE FLAG ON      0.41%      (WRI)
    36 EVENTS HAD ZMIN < 450 AND WRITE FLAG ON      2.94%          (WRI)
  1355 EVENTS WENT INTO RMIN CUT     19.39%
   521 EVENTS REJECTED BY RMIN CUT       7.46%                     (REJ)
   834 EVENTS PASSED RMIN CUT AND ZMIN       68.08%                (WRI)

  6987 EVENTS WERE READ AND A TOTAL OF  1225  EVENTS WERE WRITTEN
         REDUCTION FACTOR :     17.53%


  REDUCTION STEP 1 FOR DATA FROM SUMMER 1979
  ------------------------------------------

   THE STATISTICS GIVEN ABOVE IS TYPICAL FOR DATA TAKEN IN AUTUMN 79.
  DATA FROM THE PRECEDING RUN IN SUMMER 79 IS MUCH DIRTIER, DUE TO WORSE
  BEAM CONDITIONS. THUS THE PROPORTION OF COSMIC EVENTS IN THE AUTUMN
  DATA IS MUCH HIGHER; THIS IS MIRRORED IN THE VERY DIFFERENT FRACTIONS
  OF EVENTS THAT PROCEED TO PATTERN RECOGNITION, AS WELL AS IN THE VERY
  DIFFERENT OVERALL REDUCTION FACTORS.  BELOW IS GIVEN THE SAME SUMMARY
  AS ABOVE, BUT FOR A TYPICAL SUMMER RUN.

       ++++++++   STATISTICS FOR RUN      0    ++++++++++
  EVENTS READ       9011           PULSER EVENTS        12
  OVERFLOW EVENTS    6       LGCALB ERROR RETURNS       0
  8906 EVENTS FAILED LGLASS CUT     98.97%
    93 EVENTS PASSED LGLASS CUT      1.03%
    71 EVENTS HAD BAD LGLASS BLOCKS      0.79%    (E-CAP SPINNERS)
  5724 EVENTS HAVE NO TAG TRIGGER     63.61%
  3275 EVENTS HAVE TAG TRIGGER        36.39%
   115 EVENTS WITH TAG TRIGGER AND ETOT >  300. MEV      1.28%
  8787 EVENTS WITH COMBINED WRITE FLAG OFF   97.64%
   212 EVENTS WITH COMBINED WRITE FLAG ON     2.36%
   140 EVENTS HAD NO ID HITS AND WRITE FLAG OFF      1.56%         (REJ)
     0 EVENTS HAD NO ID HITS AND WRITE FLAG ON      0.0 %          (WRI)
  8859 EVENTS ENTERED ZVERTEX ROUTINE      98.44%
  4633 EVENTS FAILED TO FIND Z VERTEX & HAD WRITE FLAG OFF  51.48% (REJ)
    93 EVENTS FAILED TO FIND Z VERTEX BUT HAD WRITE FLAG ON  1.03% (WRI)
  2566 EVENTS HAD ZVTX > 450 AND WRITE FLAG OFF     28.51%         (REJ)
  1660 EVENTS THROUGH PATREC      18.45%
   129 EVENTS WERE 0 PRONGS        1.43%
    60 EVENTS WERE 0 PRONGS AND HADE NO WRITE FLAG      0.67%      (REJ)
    69 EVENTS WERE 0 PRONGS AND HAD WRITE FLAG ON     19.44%       (WRI)
  1531 EVENTS HAD AT LEAST ONE TRACK       17.01%
   158 EVENTS WITH TRACKS AND TAG FLAG       1.76%
   104 EVENTS WITH TRACKS AND TAG FLAG, LOW MOMENTUM        1.16%  (REJ)
    54 EVENTS WITH TRACKS AND TAG FLAG, HIGH MOMENTUM      15.21%  (WRI)
   227 EVENTS WERE ISTAR=0       2.52%
    33 EVENTS WERE ISTAR=0 AND HAD WRITE FLAG ON      9.30%        (WRI)
     0 EVENTS WERE ISTAR=0 BUT HAD LONG TRACK IN RFI   0.0%        (WRI)
   194 EVENTS WERE ISTAR=0 AND HAD NO LONG TRACK IN RFI      2.16% (REJ)
   708 EVENTS WERE ISTAR=2       7.87%
    15 EVENTS WERE ISTAR=2 AND HAD WRITE FLAG ON      4.23%        (WRI)
   693 EVENTS WERE ISTAR=2 AND HAD WRITE FLAG OFF      7.70%       (REJ)
   438 EVENTS WERE ISTAR=1       4.87%
   167 EVENTS HAD ZMIN > 450 AND HAD NO WRITE FLAG      1.86%      (REJ)
     3 EVENTS HAD ZMIN > 450 BUT HAD WRITE FLAG ON      0.85%      (WRI)
    19 EVENTS HAD ZMIN < 450 AND WRITE FLAG ON      5.35%          (WRI)
   249 EVENTS WENT INTO RMIN CUT      2.77%
    87 EVENTS REJECTED BY RMIN CUT       0.97%                     (REJ)
   162 EVENTS PASSED RMIN CUT AND ZMIN       45.63%                (WRI)

  8999 EVENTS WERE READ AND A TOTAL OF   355  EVENTS WERE WRITTEN
         REDUCTION FACTOR :      3.94%

   THE DIFFERENT BEAM CONDITIONS ARE ALSO MIRRORED IN THE DEMAND ON CPU-
  TIME FOR THE REDUCTION STEP. FOR AUTUMN DATA THE TOTAL TIME SPENT IN
  PATTERN RECOGNITION IS C:A  50 %  OF THE TOTAL JOBTIME AND AVERAGE
  CPU-TIME DEMAND IS  80 - 100 MSEC / EVENT.  THIS MEANS THAT WITH AN
  L-JOB (15 MIN.) 9 - 10000 EVENTS CAN BE PROCESSED. THIS SHOULD BE COM-
  PARED WITH 20 - 22000 EVENTS / L-JOB FOR THE SUMMER RUN.

  PROGRAM CHANGES
  ---------------

   THE DATA REDUCTION PROGRAM (SUBROUTINE USREDUC1 ON LIB JADEPR.JADESR)
  HAS CHANGED FROM THE VERSION USED IN THE SUMMER RUN, BOTH BECAUSE SOME
  OF THE CALLED PROGRAMS HAVE CHANGED (LEAD GLASS CALIBRATION, PATTERN
  RECOGNITION) AND BECAUSE OF THE INTRODUCTION OF NEW CONDITIONS. THESE
  NEW CONDITIONS ARE MAINLY THAT TAGGED EVENTS ARE NOW GIVEN SPECIAL
  ATTENTION AND THAT A RMIN-CUT IS PERFORMED. TEST RUNS OF THE OLD AND
  THE NEW PROGRAMS ON SUMMER DATA SHOW ONLY SMALL VARIATIONS, DUE TO THE
  FACT THAT THE INCLUSION OF TAGGED EVENTS IS BALANCED BY THE REJECTION
  BY THE RMIN CUT.

                       A COPY OF THIS INFORMATION CAN BE OBTAINED BY
                       SUBMITTING THE JOB   JBMEMRD1  ON THE LIBRARY
                       JADEPR.JADESR
$   28/05/84 508061722: MEMBER NAME  JBNBADC  (BIBLS)       NEWLIB
//JADEPRF1 JOB '10622622',PRODUC,CLASS=E,MSGLEVEL=(1,1),TIME=(0,15)
//*MAIN RELPRI=HIG,LINES=(2)
//*NET ID=JADEPRN7,RL=(JADEPRD7)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*   FIND BAD BLOCKS
//*
//BADCHL EXEC PGM=BADCHLD,REGION=600K
//*
//GO.FT02F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK0
//GO.FT03F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK1
//GO.FT08F001 DD UNIT=FAST,DISP=OLD,DSN=F22WAT.LGBAD0
//GO.FT04F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//   SPACE=(CYL,(20,20)),DSN=&&SCRTCH
//*
//GO.FT06F001 DD SYSOUT=*
//GO.FT05F001 DD *
//*
$   28/05/84 508061722: MEMBER NAME  JBPRMESS (BIBLS)       NEWLIB
//F11PST   JOB 10622622,MSGLEVEL=(0,0),CLASS=A,TIME=(0,10)
//*MAIN ORG=EXT,LINES=(4),RELPRI=HIG
// EXEC FCG,PARM.FORT='OPT=3,XL'
C
      DIMENSION A(200,18)
C
 1001 FORMAT(18A4)
 2000 FORMAT(1H1)
 2001 FORMAT(10X,18A4)
 2002 FORMAT(4X)
C
C                                       # OF PRINTED MESSAGES
C     NPR    =  70
      NPR    =  10
C
      IL = 1
  100 CONTINUE

         READ(5,1001,END=200) (A(IL,I1),I1=1,18)
         IL = IL + 1
         GOTO 100
C
  200 CONTINUE
      NL = IL - 1
C
      LINE   = 9999
      LINEMX = 32
      IF(NL.GT.LINEMX) LINEMX =-1
      DO 210 IPR=1,NPR
         IF(LINE.GT.LINEMX) GOTO 206
            L9 = LINEMX + 2
            L1 = LINE
            DO 204 IL=L1,L9
               PRINT 2002
               LINE = LINE + 1
  204       CONTINUE
         GOTO 207
  206       PRINT 2000
            LINE = 0
C
  207    CONTINUE
         DO 208 IL=1,NL
            IF(LINE.LE.68) GOTO 209
               PRINT 2000
               LINE = 0
  209       CONTINUE
            PRINT 2001, (A(IL,I1),I1=1,18)
            LINE = LINE + 1
  208    CONTINUE
  210 CONTINUE
C
      STOP
      END
//GO.SYSIN DD *
#include "rednote.for"
$   28/05/84 508061722: MEMBER NAME  JBREDOBL (BIBLS)       NEWLIB
//JADEPRFM JOB '10622622',PRODUC,CLASS=L,MSGLEVEL=(1,1),TIME=5
//*MAIN RELPRI=HIG,LINES=(18)
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
// EXEC CATPROGM
   DELETE F11LHO.JDATA03.REFORM.G0149V00
// EXEC NEWFAST
//*
//*    REFORMAT EVENTS
//*    SPECIAL VERSION FOR CORRECTING BAD ADC DATA AND REPLACING
//*    THE CORRESPONDING SPINNING BLOCK LISTS.
//*
//REFM EXEC FCLG,FORT='XL,OPT=2,LEVEL=4',
//      LKED='MAP,LIST',REGION=750K
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      COMMON/CDFLAG/IDFLAG,LIMOUT,NRNMIN,NRNMAX
      IDFLAG=0
      LIMOUT=1000000
      NRNMIN=      0
      NRNMAX=1000000
      CALL REFMAI
      STOP
      END
#include "evfoldkw.for"
#include "addon.for"
#include "evconv9.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
// DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
// DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(BREADKW,BWRITEKW)
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F22YEN.JADE.EXDATA02.G0173V00
//GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//   DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//   DSN=F11LHO.JDATA03.REFORM.G0149V00
//*
//GO.FT04F001 DD DSN=F22WAT.LGBAD0,DISP=MOD,UNIT=FAST
//GO.FT08F001 DD DUMMY
//GO.FT09F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.FASTSELR
//*
//*
//*   FIND BAD BLOCKS
//*
//SPBL EXEC FCLG,FORT='XL,OPT=2,LEVEL=4'
//FORT.SYSIN DD *
      IMPLICIT INTEGER*2 (H)
      REWIND 4
      REWIND 8
      CALL KALCOP
      CALL KALADD
      CALL KORDER
      CALL KALREV
      REWIND 4
      STOP
      END
#include "kalcop.for"
#include "kalm1s.for"
#include "korder.for"
#include "kalelm.for"
//LKED.SYSLIB DD
// DD
// DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
// DD DSN=F22WAT.BADCHL,UNIT=FAST,DISP=SHR
// DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//GO.FT02F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK0
//*GO.FT03F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.KALWRK1
//GO.FT08F001 DD UNIT=FAST,DISP=OLD,DSN=F22WAT.LGBAD0
//GO.FT04F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//   SPACE=(CYL,(20,20)),DSN=&&SCRTCH
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//   SPACE=(CYL,(20,20)),DSN=&&SCRTCH1
//*
$   28/05/84 508061722: MEMBER NAME  JBREDPS  (BIBLS)       NEWLIB
//F11PST   JOB '10622622',TEST,CLASS=E,MSGLEVEL=(0,0),TIME=(0,30)
//*MAIN RELPRI=HIG,LINES=(4),ORG=EXT
//*
// EXEC NEWLIB,PS='JADEPR.JADESR',
// LEVEL=0,OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ COMPILE USRED829
//*
//*   DATA REDUCTION 1
//*
//REDUC1 EXEC FLG,PARM.LKED='LIST',REGION.GO=850K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD
//            DD DISP=SHR,UNIT=FAST,DSN=F22YAM.LGKOSM.L
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R02BUT.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USRED829)
//*
//*O.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KALWRK0
//GO.FT07F001 DD SYSOUT=B
//*                        INPUT:
//*O.FT02F001 DD DISP=OLD,UNIT=TAPE,
//*  DSN=F11LHO.JDATA07.REFORM.G0090V00
//GO.FT02F001 DD DISP=SHR,
//   DSN=F22NAR.MSSJAD.MY408450
//*  DSN=JADEPR.RED1IN2
//* DSN=F22TAK.DSK.REF01
//*                        OUTPUT:
//GO.FT03F001 DD DUMMY
//*O.FT03F001 DD DISP=OLD,DSN=JADEPR.RED1OU2
//GO.SYSIN DD *
STARTRUN 00010286 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
$   28/05/84 508061722: MEMBER NAME  JBREDT1  (BIBLS)       NEWLIB
//JADEPR   JOB '10622622',TEST,CLASS=E,MSGLEVEL=(1,1),TIME=(0,15)
//*MAIN RELPRI=HIG,LINES=(5),ORG=EXT
//*
//*
//*   DATA REDUCTION 1
//*
//SHELTR EXEC SHELTRAN
#include "userx.for"
#include "trck82x.for"
//*
// EXEC FC,LEVEL=0,PARM.FORT='NOSOURCE,NOLIST,XL,OPT=3'
//FORT.SYSIN DD DSN=&&FORTIN,DISP=(OLD,DELETE)
// EXEC FCLG,LEVEL=0,PARM.FORT='NOLIST,XL,OPT=3',
//           PARM.LKED='LIST',REGION.GO=1000K
//*
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R02BUT.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(GBOOK,DBASEDUM)
//*
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.BUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KALWRK0
//GO.FT07F001 DD SYSOUT=B
//*                        INPUT:
//*O.FT02F001 DD DISP=OLD,UNIT=TAPE,
//*  DSN=F11LHO.JDATA05.REFORM.G0028V00
//GO.FT02F001 DD DISP=SHR,UNIT=FAST,
//   DSN=JADEPR.TEST635
//*O.FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.G0635V00
//*                        OUTPUT:
//GO.FT03F001 DD DUMMY
//*O.FT03F001 DD DISP=OLD,DSN=JADEPR.TEST635
EVNT               0         0
$   28/05/84 508061722: MEMBER NAME  JBRED1LT (BIBLS)       NEWLIB
//JADEPR JOB '10622622',REDUCONE,CLASS=E,MSGLEVEL=(1,0),TIME=(0,10)
//*MAIN RELPRI=HIG,LINES=(20),ORG=EXT
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*------------------  JCL FOR TEST OF LOAD MODULE  ----------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*          = F11LHO.˘(S2).REFORM.˘(S1)V00
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*          = JADEPR.ST˘(SUBSTR(S1,3,3))
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1LD,REGION=765K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD DUMMY
//*T03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//*        DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),
//*        SPACE=(CYL,(200,50))
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11PST.MSSJAD.MY408450
//*T02F001 DD DISP=SHR,DSN=F11LHO.˘(S2).REFORM.˘(S1)V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00000000 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
//*POOLING EXEC PGM=IEBGENER,REGION=220K
//*YSPRINT DD SYSOUT=*
//*YSIN DD DUMMY
//*YSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//*YSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*      DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//*      DSN=JADEPR.ST˘(SUBSTR(S1,3,3))
$   28/05/84 508061722: MEMBER NAME  JBREFORM (BIBLS)       NEWLIB
//F11JEO   JOB '10622622',REFORM,CLASS=K,MSGLEVEL=1,TIME=(4,00)
//*MAIN RELPRI=HIG
//*
//*
//* ======================================================
//*
//* JADE REFORMAT JOB
//* -----------------
//*
//* JCL CREATED BY JADEPR AT 1644 ON 19/09/82
//*
//* YEN TAPE = F22YEN.JADE.EXDATA07.G0072V00
//*
//* REFORM TAPE = F11LHO.JDATA08.REFORM.G0072V00
//*
//* RUTHERFORD TAPE = 939481
//*
//* ======================================================
//*
//*
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
// EXEC NEWFAST
//*
//* ===============
//*  REFORMAT STEP
//* ===============
//*
//REFORM EXEC PGM=REFRMLD,REGION=520K
//FT06F001 DD SYSOUT=*
//*FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F22YEN.JADE.EXDATA07.G0072V00
//FT02F001 DD DISP=SHR,DSN=F11BAR.YEN85
//FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),VOL=(,RETAIN),
//    DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//    DSN=F11OLS.REFORMOF.YEN85
//FT04F001 DD UNIT=FAST,DISP=MOD,DSN=F22WAT.LGBAD0
//FT08F001 DD UNIT=FAST,DISP=MOD,DSN=F11LHO.DSKTI001
//FT09F001 DD DUMMY
//*FT09F001 DD UNIT=FAST,DISP=OLD,DSN=F11LHO.FASTSEL
//FT05F001 DD *
$   28/05/84 508061722: MEMBER NAME  JBREFOVR (BIBLS)       NEWLIB
//F11LHO27 JOB '10622622',PRODUC,CLASS=A,MSGLEVEL=(1,1),TIME=5
//*MAIN RELPRI=LOW,LINES=(4)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
// EXEC NEWFAST
//*
//*    REFORMAT EVENTS
//*
//REFORM EXEC PGM=REFOVRF,REGION=600K
//*
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F22YEN.JADE.EXDATA01.G0209V00
//    DD UNIT=AFF=FT02F001,DISP=OLD,DSN=F22YEN.JADE.EXDATA01.G0210V00
//    DD UNIT=AFF=FT02F001,DISP=OLD,DSN=F22YEN.JADE.EXDATA01.G0211V00
//    DD UNIT=AFF=FT02F001,DISP=OLD,DSN=F22YEN.JADE.EXDATA01.G0212V00
//GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//   DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//   DSN=F11LHO.OVFIX27
//*
//GO.FT04F001 DD DUMMY
//GO.FT08F001 DD DUMMY
//GO.FT09F001 DD DUMMY
//*
//GO.FT06F001 DD SYSOUT=*
//GO.FT05F001 DD *
RNGE            3169      3184
//*
$   28/05/84 508061722: MEMBER NAME  JBREFPUL (BIBLS)       NEWLIB
//JADERFPU JOB '10622622',STEFFEN,CLASS=K,MSGLEVEL=(1,1),TIME=(6,00)
//*MAIN RELPRI=MED
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*    REFORMAT EVENTS
//*
//REFORM EXEC PGM=REFRMLD,REGION=600K
//*
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F11BET.TZEROU.R7963
//*
//*O.FT04F001 DD DSN=F22WAT.LGBAD0,DISP=MOD,UNIT=FAST
//*O.FT08F001 DD DSN=F11LHO.DSKTI001,DISP=MOD,UNIT=FAST
//GO.FT04F001 DD DUMMY
//GO.FT08F001 DD DUMMY
//GO.FT09F001 DD DUMMY
//*
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//       SPACE=(CYL,(200,50)),DSN=&&SCRTCH
//*
//GO.FT06F001 DD SYSOUT=*
//GO.FT05F001 DD *
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//COPY EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//          DSN=F11BET.TZEROR.R7963
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
$   28/05/84 508061722: MEMBER NAME  JBREPAT  (BIBLS)       NEWLIB
//JADEPRR8 JOB 10622622,CLASS=L,MSGLEVEL=(1,1),TIME=10
//*MAIN RELPRI=MED,ORG=EXT
// EXEC NEWLIB,PS='JADEPR.JADESR',
// OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USREPAT
./ I 5200
********************************************************************

   SEE MEMBER JBREPTIL AND USREPTIL   AS WELL AS #START

********************************************************************
// EXEC FLG,PARM.LKED='MAP,LIST',REGION=750K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USREPAT)
//GO.FT10F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
//GO.FT11F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART1
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*           INPUT
//*O.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.PATRPROB
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.RECLI142
//*   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=JADEPR.ST141A
//*   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=JADEPR.ST118B
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//       SPACE=(CYL,(200,50)),DSN=&&SCRTCH
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//COPY EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//          DSN=JADEPR.RECLA142
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
$   28/05/84 508061722: MEMBER NAME  JBREPTIL (BIBLS)       NEWLIB
//JADEPRR8 JOB 10622622,CLASS=D,MSGLEVEL=(1,1),TIME=(13,00)
//*MAIN RELPRI=MED
// EXEC NEWLIB,PS='JADEPR.JADESR',
// OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ COMPILE USREPTIL
// EXEC FLG,PARM.LKED='MAP,LIST',REGION=750K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USREPTIL)
//GO.FT10F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
//GO.FT11F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART1
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*           INPUT
//*O.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.PATRPRB1
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.RECLI141
//*   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=JADEPR.ST141A
//*   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=JADEPR.ST118B
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//    DCB=(R01DCB.VBS,LRECL=6236),
//        SPACE=(CYL,(200,50)),DSN=&&SCRTCH
//*O.FT03F001 DD DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   DSN=F11OLS.PATRPRB2,
//*        MSVGP=VTMP,UNIT=3330V
//*GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//COPY EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//          DSN=JADEPR.RECLA141
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
$   28/05/84 508061722: MEMBER NAME  JBR1ANA  (BIBLS)       NEWLIB
//F11PST   JOB CLASS=E,MSGLEVEL=(0,0),TIME=(0,25)
//*MAIN LINES=(3),ORG=EXT,RELPRI=HIG
//*
// EXEC FCLG,PARM.LKED='LIST',REGION.GO=850K
#include "usr1ana.for"
//LKED.SYSLIB DD
//            DD
//            DD DSN=JADEPR.JADELD,DISP=SHR
//            DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//            DD DSN=F11GOD.PATRECLD,UNIT=FAST,DISP=SHR
//            DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//            DD DSN=F22ALL.JADEMUL,UNIT=FAST,DISP=SHR
//            DD DSN=F1EBLO.BOSLIB.L,UNIT=FAST,DISP=SHR
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
//*
//GO.FT21F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT0,DISP=SHR
//GO.FT22F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT1,DISP=SHR
//*
//GO.FT02F001 DD DISP=SHR,
//    DSN=JADEPR.RED1OU2
//*
//GO.FT03F001 DD DUMMY
//*O.FT03F001 DD DISP=OLD,
//*         DSN=JADEPR.RED1.T1ACC
$   28/05/84 508061722: MEMBER NAME  JBSORDER (BIBLS)       NEWLIB
//F11JADSO JOB 10622622,'REORDER',TIME=(0,30),CLASS=A
// EXEC NEWFAST
// EXEC FCLG,LIB1='F11LHO.JADEGL'
//FORT.SYSIN DD *
      CALL SELCOP
      CALL SORDER
      STOP
      END
      SUBROUTINE SELCOP
      IMPLICIT INTEGER*2 (H)
C---
C---     SIMPLE COPY.
C---                                   L.H. O'NEILL 10.09.79
C---
      DIMENSION JBUF(10000),IDAT(9991),HBUF(20000),ITIME(6),NAME( 7)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(10),IDAT(1))
C---
      NREC=0
    1 CONTINUE
      CALL EVREA1(4,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
         IF(HBUF(18).LT.5342) WRITE(6,269) HBUF(18),HBUF(19)
         IF(HBUF(18).LT.5342) GO TO 1
         IF(HBUF(18).GT.9999) WRITE(6,269) HBUF(18),HBUF(19)
         IF(HBUF(18).GT.9999) GO TO 1
  269    FORMAT(1X,' ELIMINATE',2I6,'. RUN NUMBER CUT.')
      NREC=NREC+1
C     IOUT=NWORD
C     IF(IOUT.GT.10) IOUT=10
C     WRITE(6,100) NREC,NWORD,(JBUF(I),I=1,IOUT)
  100 FORMAT(1X,I4,I12,10I10)
      CALL KALBNK(2,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
      REWIND 2
      RETURN
      END
      SUBROUTINE SORDER
      IMPLICIT INTEGER*2 (H)
C---
C---     PUTS NORD 50 SELECTED EVENTS INTO ORDER OF INCREASING TIME.
C---                                   L.H. O'NEILL 25.02.80
C---
      DIMENSION JBUF(10000),IDAT(9996),HBUF(20000),HDAT(19992)
      DIMENSION LIST(2,10000),ITIME(6)
      EQUIVALENCE(JBUF(1),HBUF(1))
      EQUIVALENCE(JBUF(5),IDAT(1))
      EQUIVALENCE(IDAT(1),HDAT(1))
C---
      NREC=0
      NORG=0
    1 CONTINUE
      CALL EVREA1(2,NWORD,JBUF,IRET)
      IF(IRET.EQ.1) GO TO 1000
      IF(IRET.EQ.2) GO TO 2000
      NORG=NORG+1
         WRITE(6,737) NORG,HDAT(10),HDAT(11)
  737    FORMAT(1X,' SEQ. NUM. RUN, EVENT = ',I3,2I6)
      IF(HDAT(10).LT.2570) GO TO 1
      NREC=NREC+1
      IF(NREC.GT.10000) WRITE(6,201)
  201 FORMAT(' **** ERROR. MORE THEN 10000 RECORDS. PROGRAMMED STOP.')
      IF(NREC.GT.10000) STOP
      LIST(1,NREC)=NREC
      ITIME(1)=HDAT(3)
      ITIME(2)=HDAT(4)
      ITIME(3)=HDAT(5)
      ITIME(4)=HDAT(6)
      ITIME(5)=HDAT(7)
      ITIME(6)=HDAT(8)
      LASTIM=0
      NDUMMY=KTMCON(ITIME,KTWRIT,LASTIM)
      LIST(2,NREC)=NDUMMY
      CALL KALBNK(3,NWORD,JBUF)
      GO TO 1
 1000 CONTINUE
      WRITE(6,101) NREC
  101 FORMAT(' *** READ ERROR ENCOUNTERED AFTER ',I4,' RECORDS.')
      RETURN
 2000 CONTINUE
      WRITE(6,102) NREC
  102 FORMAT('0NORMAL END OF FILE AFTER',I4,' RECORDS.')
C---
C---     FIND TIME ORDER OF RECORDS.
C---
C        WRITE(6,1991) ((LIST(KLM,LHO),KLM=1,2),LHO=1,NREC)
 1991    FORMAT(1X,2I10)
      DO 2 I=1,NREC
      LOWEST=2000000001
      DO 3 J=I,NREC
      IF(LIST(2,J).GE.LOWEST) GO TO 3
      K=J
      LOWEST=LIST(2,J)
    3 CONTINUE
      IADDR=LIST(1,I)
      IVALU=LIST(2,I)
      LIST(1,I)=LIST(1,K)
      LIST(2,I)=LOWEST
      LIST(1,K)=IADDR
      LIST(2,K)=IVALU
C        WRITE(6,1998)
 1998    FORMAT(' ')
C        WRITE(6,1991) ((LIST(KLM,LHO),KLM=1,2),LHO=1,NREC)
    2 CONTINUE
C---
C---     NOW OVERWRITE FILE ON UNIT 2 WITH TIME ORDERED RECORDS.
C---
      REWIND 2
      REWIND 3
C---
      NCURNT=0
      LASTIW=0
      NOUT=0
      DO 10 I=1,NREC
C         WRITE(6,1995) I,NCURNT,LIST(1,I),LIST(2,I)
 1995     FORMAT(' I,NCURNT,LIST(1,I),LIST(2,I)= ',4I10)
      NWISH=LIST(1,I)
      IF(NWISH.GT.NCURNT) GO TO 4
      REWIND 3
      DO 5 J=1,NWISH
      CALL EVREA1(3,NWORD,JBUF,IRET)
      IF(IRET.EQ.0) GO TO 5
      WRITE(6,202) IRET
  202 FORMAT(' *** ILLEGAL IRET = ',I2,' IN 5 LOOP. STOP.')
      STOP
    5 CONTINUE
      GO TO 6
    4 CONTINUE
      LOOP=NWISH-NCURNT
      DO 7 J=1,LOOP
      CALL EVREA1(3,NWORD,JBUF,IRET)
      IF(IRET.EQ.0) GO TO 7
      WRITE(6,203) IRET
  203 FORMAT(' *** ILLEGAL IRET = ',I2,' IN 7 LOOP. STOP.')
      STOP
    7 CONTINUE
    6 CONTINUE
      NCURNT=NWISH
      ITIME(1)=HDAT(3)
      ITIME(2)=HDAT(4)
      ITIME(3)=HDAT(5)
      ITIME(4)=HDAT(6)
      ITIME(5)=HDAT(7)
      ITIME(6)=HDAT(8)
      LASTIM=0
      NDUMMY=KTMCON(ITIME,KTWRIT,LASTIM)
      IF(NDUMMY.EQ.LIST(2,I)) GO TO 8
      WRITE(6,204) I,NDUMMY,LIST(1,I),LIST(2,I)
  204 FORMAT(' NDUMMY AND LIST(2,I) DISAGREE. DUMP = ',4I10)
      WRITE(6,303)
  303 FORMAT(' *** PROGRAMMED STOP *** ')
      STOP
    8 CONTINUE
      IF(NDUMMY.GE.LASTIW) GO TO 9
      WRITE(6,205) I,NDUMMY,LASTIW,LIST(1,I),LIST(2,I)
  205 FORMAT(' DECREASING TIME. DUMP = ',5I10)
      WRITE(6,304)
  304 FORMAT(' *** PROGRAMMED STOP *** ')
      STOP
    9 CONTINUE
      IF(LASTIW.LT.NDUMMY) NOUT=NOUT+1
      IF(LASTIW.LT.NDUMMY) CALL KALBNK(2,NWORD,JBUF)
      IF(LASTIW.LT.NDUMMY)   WRITE(6,737) NOUT,HDAT(10),HDAT(11)
      IF(LASTIW.EQ.NDUMMY)   WRITE(6,738) HDAT(10),HDAT(11)
  738 FORMAT(1H0,' *** DUPLICATE',2I6,' ELIMINATED. ***',//)
      LASTIW=NDUMMY
   10 CONTINUE
      RETURN
      END
//GO.FT04F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.FASTSEL
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.FASTSEL7
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),DCB=R01DCB.VBS,
//  SPACE=(TRK,(180,10)),DSN=&&SEORD
$   28/05/84 508061722: MEMBER NAME  JBWRIT   (BIBLS)       NEWLIB
//JADEPR   JOB CLASS=L,MSGLEVEL=(0,0),TIME=(3,00)
//*MAIN RELPRI=HIG
//*EXEC NEWFAST
// EXEC NEWLIB,PS='F11OLS.JADESR',PL='F11OLS.JADELD',
//  UNIT=FAST,LEVEL=8,OPT=3,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USER0
./ I 10200
C END OF JOB, AFTER PRINT OF IGGS,JIGGS AND BEFORE PLOTS
./ I 7800
C LEVEL 7
./ I 7400
C LEVEL 6
./ I 6800
C LEVEL 5
./ I 6200
C LEVEL 4
./ I 5600
C LEVEL 3
./ I 5000
C LEVEL 2
C     IF(HEAD(18).LT.4337) GO TO 1
C     IF(HEAD(18).GT.4337) GO TO 12
C     IF(HEAD(18).LT.11417) GO TO 1
C     IF(HEAD(18).GT.11416) GO TO 12
      GO TO 11
./ I 4400
C LEVEL 1
C     WRITE(JUSCRN,201) JIGG(2),HEAD(18),HEAD(19),HEAD(37),HEAD(34)
201   FORMAT(' RECORD NUMBER ',I4,'  RUN AND EVENT ',2I10,'  EBEAM ',I7,
     $'  N50 LABEL ',Z4)
./ I 1300
C DECLARATIVE LEVEL
      DATA IEVCNT/0/
// EXEC FLG,REGION.GO=800K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R02BUT.CERNLIB
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USER0,EXJDUM)
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.R1492A
//   DD DISP=SHR,DSN=JADEPR.R11908
//   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=JADEPR.R1492B
//*GO.FT02F001 DISP=SHR,DSN=F11OLS.W12GEV.TR2GAM1
//*                        OUTPUT:
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//       SPACE=(CYL,(220,20)),DSN=&&SCRTCH
//*GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.RAETEST
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(3,1),RLSE),DSN=F11OLS.TR23GAM.RESO7
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*    DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11OLS.REDUCTWO.G0222V00
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//COPY EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//           DSN=JADEPR.REDUCONE.G0492V00
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
$   13/12/82 602191238  MEMBER NAME  REDUCHH  (JADESR)      CLIST
$
$---------------------------------------------------
$
$ REDUC1 - A CLIST TO PERFORM ALL DESY REDUC1 TASKS
$ ======                          ====
$
$ TASKS PERFORMED ARE :
$
$      (1) .. MAKE AN ARCHIVE COPY OF A REDUC1 MERGE TAPE'
$      (2) .. COPY REDUC1 DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
$      (3) .. LIST THE RUN CONTENTS OF A REDUC1 MERGE TAPE'
$      (4) .. SUBMIT A REDUC1 MERGE JOB'
$      (5) .. RE-LINK THE REDUC1 LOAD MODULE'
$      (6) .. SUBMIT A REDUC1 JOB'
$      (7) .. COPY A DESY REFORM TAPE ONTO A RUTHERFORD TAPE'
$      (8) .. LIST FILE CONTENTS OF A RUTHERFORD TAPE'
$
$ TO INVOKE TYPE (REDUC1) AND ANSWER THE QUESTIONS
$
$ THE JCL IS WRITTEN INTO THE DUMMY MEMBER ####JUNK
$ AND MAY THEN BE SUBMITTED OR EDITED
$---------------------------------------------------
$
FULL OFF
V OFF OFF
SET ESCAPE='˘'
$
$----------------------------------
$ CREATE/CLEAR DUMMY MEMBER FOR JCL
$----------------------------------
$
SC ####JUNK
IF DIR('####JUNK') = 'T'  GOTO SKIP1
./ ADD ####JUNK
./ LABEL NOMACRO
LABEL SKIP1
C ####JUNK
D 0 900000
$
$-------------------------------
$ BRANCH TO REQUIRED REDUC1 TASK
$-------------------------------
$
IF N0^=0 GOTO NOTASK
CLEAR
SHOW '      REDUC1 TASKS AVAILABLE FOR EXECUTION AT DESY'
SHOW '      ============================================'
SHOW ' '
SHOW ' ARCHIVE  (A) .. MAKE AN ARCHIVED COPY OF A REDUC1 MERGE TAPE'
SHOW ' COPYRUT  (C) .. COPY A RUTH WRITTEN REDUC1 TAPE ONTO A DESY TAPE'
SHOW ' LISTRUNS (L) .. LIST THE RUN CONTENTS OF A REDUC1 MERGE TAPE'
SHOW ' MERGE    (M) .. SUBMIT A REDUC1 MERGE JOB'
SHOW ' NEWLOAD  (N) .. RE-LINK THE REDUC1 LOAD MODULE'
SHOW ' REDUCE   (R) .. SUBMIT A REDUC1 JOB'
SHOW ' WRITERUT (W) .. COPY A DESY REFORM TAPE ONTO A RUTHERFORD TAPE'
SHOW ' XTAPE    (X) .. LIST FILE CONTENTS OF A RUTHERFORD TAPE'
SHOW ' '
SHOW ' TO OPERATE REDUC1 AT RUTHERFORD USE (RUTHJOBS)'
SHOW ' REDUC1 LOAD MODULE RELINKED 19/2/86  L.BECKER'
SHOW ' '
READ INTO S0 PROMPT ' ENTER TASK REQUIRED :'
IF S0=' ' GOTO STOP
IF LENGTH(S0)=0 GOTO STOP
LABEL NOTASK
IF SUBSTR(S0,1,1)='R' GOTO RED1JOB
IF SUBSTR(S0,1,1)='M' GOTO MERGEJOB
IF SUBSTR(S0,1,1)='A' GOTO ARCHIVE
IF SUBSTR(S0,1,1)='L' GOTO LISTRUNS
IF SUBSTR(S0,1,1)='W' GOTO WRITERUT
IF SUBSTR(S0,1,1)='C' GOTO COPYRUT
IF SUBSTR(S0,1,1)='N' GOTO NEWLOAD
IF SUBSTR(S0,1,1)='X' GOTO XTAPE
SHOW ' '
SHOW ' TASK ˘(S0) NOT RECOGNISED .. CLIST TERMINATING'
GOTO STOP
$
$----------------------------------------------------------------------
$              ARCHIVE A REDUC1 MERGE TAPE
$----------------------------------------------------------------------
$
LABEL ARCHIVE
CLEAR
SHOW '      CREATE AN ARCHIVED COPY OF A REDUC1 MERGE TAPE'
SHOW '      =============================================='
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE ARCHIVED (EG G0402)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEA'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=LOW,LINES=(2),ORG=EXT
//ARCHIVE EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*-----------------------------------------------------------
//*
//* JOB TO MAKE A BACKUP-ARCHIVE COPY OF A REDUC1 TAPE AT DESY
//*
//* SYSUT1 = INPUT REDUC1 TAPE TO BE COPIED
//*        = JADEPR.REDUCONE.˘(S1)V00
//*
//* SYSUT2 = OUTPUT ARCHIVE COPY TAPE
//*        = JADEPR.ARCHIVE.REDUC˘(SUBSTR(S1,3,3))
//*
//*-----------------------------------------------------------
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.REDUCONE.˘(S1)V00
//SYSUT2 DD UNIT=ARCHIV,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.ARCHIVE.REDUC˘(SUBSTR(S1,3,3))
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$    COPY A RUTHERFORD WRITTEN MERGE TAPE TO A DESY M/ROOM TAPE
$----------------------------------------------------------------------
$
LABEL COPYRUT
CLEAR
SHOW '    COPY A RUTHERFORD WRITTEN MERGE TAPE TO A DESY M/ROOM TAPE'
SHOW '    =========================================================='
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE COPIED (EG G0470)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
$---------------------------------
$ RUTHERFORD TAPE SERIAL NUMBER(S)
$---------------------------------
$
SHOW ' '
SHOW '--- ENTER THE RUTHERFORD TAPE SERIAL NUMBER(S) (EG 939454,...)'
READ INTO S2 PROMPT '-->'
IF S2=' ' GOTO NODEFLT
IF LENGTH(S2)=0 GOTO NODEFLT
$
$--------------------------------------
$ RUTHERFORD TAPE LABEL SEQUENCE NUMBER
$--------------------------------------
$
SHOW ' '
SHOW '--- ENTER THE TAPE VOLUME LABEL NUMBER (DEFAULT = 1)'
READ INTO S3 PROMPT '-->'
IF S3=' ' SET S3='1'
IF LENGTH(S3)=0 SET S3='1'
$
$-----------
$ TIME LIMIT
$-----------
$
SET S11='(1,00)'
SET S12='A'
IF LENGTH(S2)<9 GOTO CLASSA
SET S11='(2,00)'
SET S12='K'
LABEL CLASSA
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEC'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=˘(S12),MSGLEVEL=(1,0),TIME=˘(S11)
//*MAIN RELPRI=MED,LINES=(2),ORG=EXT
//*
//*---------------------------------------------------------------------
//*
//* JOB TO COPY REDUC1 MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
//*
//* SYSUT1 = (INPUT) RUTHERFORD TAPE CONTAINING REDUC1 MERGE DATA
//*        = JADEPR.REDUC1.˘(S1)    TAPE=˘(S2)    LABEL=˘(S3)
//*
//* SYSUT2 = (OUTPUT) DESY MACHINE ROOM TAPE
//*        = JADEPR.REDUCONE.˘(S1)V00
//*
//*---------------------------------------------------------------------
//*
//* STEP 1 - THE COPY
//* =================
//*
//RUTHCOPY EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=TAPE,DISP=(OLD,KEEP),
//       DSN=JADEPR.REDUC1.˘(S1),
//       VOL=SER=(˘(S2)),
//       LABEL=(˘(S3),SL,,IN)
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.REDUCONE.˘(S1)V00
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.˘(S1)V00
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$              LIST RUN CONTENTS OF A REDUC1 MERGE TAPE
$----------------------------------------------------------------------
$
LABEL LISTRUNS
CLEAR
SHOW '        LIST RUN CONTENTS OF A REDUC1 MERGE TAPE'
SHOW '        ========================================'
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE LISTED (EG ST402)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='ST'||S1
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEL'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=LOW,LINES=(2),ORG=EXT
//JOBLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//FT06F001 DD SYSOUT=*
//*
//*----------------------------------------------------------------
//*
//* JOB TO PRODUCE RUN/EVENT LISTING OF REDUC1 (OR ANY OTHER) TAPE
//* USED TO CHECK THAT CORRECT RUNS ETC ARE PRESENT ON TAPE
//*
//*----------------------------------------------------------------
//*
//FT02F001 DD DISP=SHR,DSN=JADEPR.HHMERGE.˘(S1)
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$                   SUBMIT A REDUC1 MERGE JOB
$----------------------------------------------------------------------
$
LABEL MERGEJOB
CLEAR
SHOW '        SUBMIT A REDUC1 MERGE JOB'
SHOW '        ========================='
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE USED (EG G0066)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='ST'||S1
$
$-------------------
$ TAPES TO BE MERGED
$-------------------
$
SHOW ' '
SHOW '--- ENTER A LIST OF THE DATA SETS TO BE MERGED USING THE FULL'
SHOW '--- DATA SET NAME WITH NO APOSTROPHES (EG ST123)'
SHOW '--- THE LIST IS TERMINATED WITH A NULL INPUT'
SHOW ' '
READ INTO S2 PROMPT '--- ENTER FIRST DATA SET NAME :'
IF LENGTH(S2)=0 GOTO NODEFLT
IF S2 = ' ' GOTO NODEFLT
$
$-----------
$ CREATE JCL
$-----------
$
SET S40='JADEM'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB '10622622',REDUCONE,CLASS=K,MSGLEVEL=(1,0),TIME=(2,00)
//*MAIN RELPRI=MED,LINES=(15),CARDS=(900)
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUC1 MERGE STEP
//*
//* SYSUT1   = CONCATENATED SEQUENCE OF INPUT FILES TO BE MERGED
//* SYSUT2   = OUTPUT FILE FOR MERGED SUM
//* FT01F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY MUONSTEP)
//* FT02F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY LISTRUNS)
//*
//*-----------------------------------------------------------
//*
//* STEP 1 - THE MERGE
//* ==================
//*
//DESYMRGE EXEC PGM=IEBGENER,REGION=120K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*  TAPE FOR MERGED OUTPUT
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG),DSN=JADEPR.REDUC1HH.˘(S1)V00,
// VOL=(,RETAIN)
//*
//*  LIST OF INPUT TAPES TO BE MERGED
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,DSN=JADEPR.RED1HH.˘(S2)
./ LABEL NOMACRO
$
$------------------------
$ MORE TAPES TO BE MERGED
$------------------------
$
LABEL MERGE1
READ INTO S2 PROMPT '--- ENTER NEXT  DATA SET NAME :'
IF LENGTH(S2)=0 GOTO MERGE2
IF S2 = ' ' GOTO MERGE2
./ INSERT 1000 1
// DD UNIT=AFF=SYSUT1,DISP=SHR,DSN=JADEPR.RED1HH.˘(S2)
./ LABEL NOMACRO
RENUM ####JUNK 1 1
GOTO MERGE1
LABEL MERGE2
$
$--------------------------------------
$ NOW FOR THE LISTRUN AND DI-MUON STEPS
$--------------------------------------
$
./ INSERT 1000 1
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,VOL=(,RETAIN),DSN=JADEPR.REDUC1HH.˘(S1)V00
//*
//* STEP 3 - THE RJB DI-MUON EXTRACTOR
//* =================================
//*
//* GETMUONS EXEC PGM=GETMUONS,REGION=550K
//* STEPLIB DD DSN=JADEPR.JADELD,DISP=SHR,UNIT=FAST
//* FT06F001 DD SYSOUT=*
//* FT08F001 DD SYSOUT=4,OUTLIM=90000
//* FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0,DCB=BUFNO=1
//* FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0,DCB=BUFNO=1
//* FT01F001 DD DISP=SHR,DSN=JADEPR.HHMERGE.˘(S1)
//* FT01F001 DD DISP=SHR,DSN=JADEPR.REDUC1HH.˘(S1)V00
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$                   RE-LINK THE REDUC1 MODULE
$----------------------------------------------------------------------
$
LABEL NEWLOAD
CLEAR
SHOW '           RE-LINK THE DESY REDUC1 MODULE'
SHOW '           =============================='
SHOW ' '
SHOW '--- ENTER THE NAME FOR THE NEW MODULE (DEFAULT = REDUC1LD) '
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 SET S1='REDUC1LD'
IF S1=' ' SET S1='REDUC1LD'
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADER1LK'
./ INSERT 1 1
//˘(S40) JOB '10622622',REDUCONE,CLASS=E,TIME=(0,15)
//*MAIN RELPRI=MED,LINES=(2),ORG=EXT
//*
//*-------------------------------------------------------
//*
//* JOB TO LINK AN EXECUTABLE REDUC1 LOAD MODULE AT DESY
//* NEW MODULE NAME = JADEPR.JADELD(˘(S1))
//*
//*-------------------------------------------------------
//*
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
// EXEC FCL,FORT=XL,PARM.LKED='LIST,MAP'
//FORT.SYSIN DD *
#include "jdmain0.for"
//*
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//*           DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DSN=R01UTL.CERN.GENLIB4,DISP=SHR
//            DD DSN=R01UTL.CERN.PACKLIB4,DISP=SHR
//LKED.SYSLMOD DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD(˘(S1))
//LKED.SYSIN DD *
 INCLUDE SYSLIB(USRED82,GBOOK,DBASEDUM)
//*
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$                       SUBMIT A REDUC1 JOB
$----------------------------------------------------------------------
$
LABEL RED1JOB
CLEAR
SHOW '        SUBMIT A REDUC1 JOB AT DESY'
SHOW '        ==========================='
SHOW ' '
$
$-------------------
$ TAPE TO BE REDUCED
$-------------------
$
SHOW ' '
SHOW '--- ENTER GENERATION NO. OF REFORM TAPE TO BE REDUCED (EG G0102)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF S1=' ' GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
SHOW ' '
SHOW '--- ENTER THE REFORMAT SERIES TO BE USED (DEFAULT = JDATA15)'
READ INTO S2 PROMPT '-->'
IF LENGTH(S2)=0 SET S2='JDATA15'
IF S2=' ' SET S2='JDATA15'
IF LENGTH(S2)=2 SET S2='JDATA'||S2
$
$--------
$ CPUTIME
$--------
$
SHOW ' '
SHOW '--- ENTER THE CPUTIME REQUIRED IN MINUTES (DEFAULT = 25)'
SHOW ' '
SHOW '    ESTIMATE OF CPUTIME: '
SHOW '    CPUTIME = (# OF REFORM EVENTS)/1300   '
SHOW '    BUT:  CPUTIME .LE. 35                      (L.B.)'
READ INTO S3 PROMPT '-->'
IF LENGTH(S3)=0 SET S3='25'
IF S3=' ' SET S3='25'
$
$-----------
$ CREATE JCL
$-----------
$
SET S40='JADED'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB '10622622',REDUCONE,CLASS=D,MSGLEVEL=(1,0),TIME=˘(S3)
//*MAIN RELPRI=MED,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*          = F11LHO.˘(S2).REFORM.˘(S1)V00
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*          = JADEPR.RED1HH.ST˘(SUBSTR(S1,3,3))
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1LD,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),
//         SPACE=(CYL,(200,50))
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11LHO.˘(S2).REFORM.˘(S1)V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00000000 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
//SPOOLING EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,CATLG),
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//       DSN=JADEPR.RED1HH.ST˘(SUBSTR(S1,3,3))
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$        COPY A DESY WRITTEN REFORM TAPE ONTO A RUTHERFORD TAPE
$----------------------------------------------------------------------
$
LABEL WRITERUT
CLEAR
SHOW '   COPY A DESY WRITTEN REFORM TAPE ONTO A RUTHERFORD TAPE'
SHOW '   ======================================================'
SHOW ' '
$
$-------------------------
$ REFORM GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REFORM GENERATION NUMBER TO BE COPIED (EG G0470)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF S1=' ' GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
SHOW ' '
SHOW '--- ENTER THE REFORMAT SERIES REQUIRED (DEFAULT = JDATA08)'
READ INTO S3 PROMPT '-->'
IF LENGTH(S3)=0 SET S3='JDATA08'
IF S3=' ' SET S3='JDATA08'
$
$---------------------------------
$ RUTHERFORD TAPE SERIAL NUMBER(S)
$---------------------------------
$
SHOW ' '
SHOW '--- ENTER THE SERIAL NUMBER OF THE RUTHERFORD TAPE (EG 939454)'
READ INTO S2 PROMPT '-->'
IF S2=' ' GOTO NODEFLT
IF LENGTH(S2)=0 GOTO NODEFLT
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEC'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=MED,LINES=(5)
//*
//*
//* ===================================================================
//*
//* JOB TO PRODUCE A RUTHERFORD REFORM TAPE
//*
//* DESY REFORM TAPE = F11LHO.˘(S3).REFORM.˘(S1)V00
//*
//* RUTHERFORD TAPE  = ˘(S2)
//*
//* ===================================================================
//*
//*
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//RUTH EXEC PGM=RUTHCOPY,REGION=190K
//FT06F001 DD SYSOUT=*
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//FT04F001 DD UNIT=TAPE,DISP=(OLD,KEEP),
//         DSN=F11LHO.˘(S3).REFORM.˘(S1)V00
//FT03F001 DD UNIT=TAPE,DISP=(NEW,KEEP,DELETE),
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//         VOL=SER=(˘(S2)),
//         LABEL=(1,SL,,OUT),
//         DSN=JADEPR.AU0R˘(SUBSTR(S1,3,3))
//FT03F002 DD UNIT=AFF=FT03F001,DISP=(NEW,KEEP,DELETE),
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//         VOL=SER=(˘(S2)),
//         LABEL=(2,SL,,OUT),
//         DSN=JADEPR.AU1R˘(SUBSTR(S1,3,3))
//FT03F003 DD UNIT=AFF=FT03F002,DISP=(NEW,CATLG,DELETE),
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//         VOL=SER=(˘(S2)),
//         LABEL=(3,SL,,OUT),
//         DSN=JADEPR.RUTH˘(SUBSTR(S1,3,3))
//FT05F001 DD *
//*
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$              LIST THE FILE CONTENTS OF A RUTHERFORD TAPE
$----------------------------------------------------------------------
$
LABEL XTAPE
CLEAR
SHOW '      LIST THE FILE CONTENTS OF A RUTHERFORD TAPE'
SHOW '      ==========================================='
SHOW ' '
$
$--------------------------
$ TAPE VOLUME SERIAL NUMBER
$--------------------------
$
SHOW ' '
SHOW '--- ENTER THE TAPE VOLUME SERIAL NUMBER (EG 939451)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADETAPE'
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,TIME=(,15),MSGLEVEL=(0,0)
//*MAIN RELPRI=MED,LINES=(5)
//*
//*-----------------------------------------------------------
//*
//* JOB TO LIST FILE CONTENTS OF A RUTHERFORD TAPE
//*
//*-----------------------------------------------------------
//*
// EXEC TAPETEST,VOLSER=˘(S1),ONLYSUM=Y
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$-------------
$ SUBMIT JOB ?
$-------------
$
LABEL SUBMIT
RENUM ####JUNK 1 1
SHOW ' '
SHOW '--- JCL CREATED'
SHOW '--- PRESS RETURN/ENTER TO SUBMIT, ANYTHING ELSE TO TERMINATE :'
READ INTO S1 PROMPT '--> '
IF S1=' ' GOTO RUN
SHOW '--- SUBMIT TERMINATED'
SHOW '--- JCL MAY BE INSPECTED IN MEMBER ####JUNK'
GOTO KEEPJCL
LABEL RUN
SUBH ####JUNK
SHOW '--- JOB ˘(S40) SUBMITTED '
READ INTO S1 PROMPT '--- ANOTHER ONE ? ( Y(ES) OR N(O) )'
IF SUBSTR(S1,1,1)^='Y' GOTO STOP
GOTO SKIP1
$
$----------------
$ TERMINATE CLIST
$----------------
$
LABEL NODEFLT
SHOW ' '
SHOW '--- THERE IS NO DEFAULT FOR THIS PARAMETER'
LABEL STOP
SC ####JUNK
LABEL KEEPJCL
SHOW ' '
SHOW '--- END OF CLIST'
SET ESCAPE=''
V ON
FULL ON
RETURN
$   13/12/82 407031412  MEMBER NAME  REDUC1   (JADESR)      CLIST
$
$---------------------------------------------------
$
$ REDUC1 - A CLIST TO PERFORM ALL DESY REDUC1 TASKS
$ ======                          ====
$
$ TASKS PERFORMED ARE :
$
$      (1) .. MAKE AN ARCHIVE COPY OF A REDUC1 MERGE TAPE'
$      (2) .. COPY REDUC1 DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
$      (3) .. LIST THE RUN CONTENTS OF A REDUC1 MERGE TAPE'
$      (4) .. SUBMIT A REDUC1 MERGE JOB'
$      (5) .. RE-LINK THE REDUC1 LOAD MODULE'
$      (6) .. SUBMIT A REDUC1 JOB'
$      (7) .. COPY A DESY REFORM TAPE ONTO A RUTHERFORD TAPE'
$      (8) .. LIST FILE CONTENTS OF A RUTHERFORD TAPE'
$
$ TO INVOKE TYPE (REDUC1) AND ANSWER THE QUESTIONS
$
$ THE JCL IS WRITTEN INTO THE DUMMY MEMBER ####JUNK
$ AND MAY THEN BE SUBMITTED OR EDITED
$---------------------------------------------------
$
FULL OFF
V OFF OFF
SET ESCAPE='˘'
$
$----------------------------------
$ CREATE/CLEAR DUMMY MEMBER FOR JCL
$----------------------------------
$
SC ####JUNK
IF DIR('####JUNK') = 'T'  GOTO SKIP1
./ ADD ####JUNK
./ LABEL NOMACRO
LABEL SKIP1
C ####JUNK
D 0 900000
$
$-------------------------------
$ BRANCH TO REQUIRED REDUC1 TASK
$-------------------------------
$
IF N0^=0 GOTO NOTASK
CLEAR
SHOW '      REDUC1 TASKS AVAILABLE FOR EXECUTION AT DESY'
SHOW '      ============================================'
SHOW ' '
SHOW ' ARCHIVE  (A) .. MAKE AN ARCHIVED COPY OF A REDUC1 MERGE TAPE'
SHOW ' COPYRUT  (C) .. COPY A RUTH WRITTEN REDUC1 TAPE ONTO A DESY TAPE'
SHOW ' LISTRUNS (L) .. LIST THE RUN CONTENTS OF A REDUC1 MERGE TAPE'
SHOW ' MERGE    (M) .. SUBMIT A REDUC1 MERGE JOB'
SHOW ' NEWLOAD  (N) .. RE-LINK THE REDUC1 LOAD MODULE'
SHOW ' REDUCE   (R) .. SUBMIT A REDUC1 JOB'
SHOW ' WRITERUT (W) .. COPY A DESY REFORM TAPE ONTO A RUTHERFORD TAPE'
SHOW ' XTAPE    (X) .. LIST FILE CONTENTS OF A RUTHERFORD TAPE'
SHOW ' '
SHOW ' TO OPERATE REDUC1 AT RUTHERFORD USE (RUTHJOBS)'
SHOW ' '
READ INTO S0 PROMPT ' ENTER TASK REQUIRED :'
IF S0=' ' GOTO STOP
IF LENGTH(S0)=0 GOTO STOP
LABEL NOTASK
IF SUBSTR(S0,1,1)='R' GOTO RED1JOB
IF SUBSTR(S0,1,1)='M' GOTO MERGEJOB
IF SUBSTR(S0,1,1)='A' GOTO ARCHIVE
IF SUBSTR(S0,1,1)='L' GOTO LISTRUNS
IF SUBSTR(S0,1,1)='W' GOTO WRITERUT
IF SUBSTR(S0,1,1)='C' GOTO COPYRUT
IF SUBSTR(S0,1,1)='N' GOTO NEWLOAD
IF SUBSTR(S0,1,1)='X' GOTO XTAPE
SHOW ' '
SHOW ' TASK ˘(S0) NOT RECOGNISED .. CLIST TERMINATING'
GOTO STOP
$
$----------------------------------------------------------------------
$              ARCHIVE A REDUC1 MERGE TAPE
$----------------------------------------------------------------------
$
LABEL ARCHIVE
CLEAR
SHOW '      CREATE AN ARCHIVED COPY OF A REDUC1 MERGE TAPE'
SHOW '      =============================================='
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE ARCHIVED (EG G0402)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEA'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=LOW,LINES=(2),ORG=EXT
//ARCHIVE EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*-----------------------------------------------------------
//*
//* JOB TO MAKE A BACKUP-ARCHIVE COPY OF A REDUC1 TAPE AT DESY
//*
//* SYSUT1 = INPUT REDUC1 TAPE TO BE COPIED
//*        = JADEPR.REDUCONE.˘(S1)V00
//*
//* SYSUT2 = OUTPUT ARCHIVE COPY TAPE
//*        = JADEPR.ARCHIVE.REDUC˘(SUBSTR(S1,3,3))
//*
//*-----------------------------------------------------------
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,
//       DSN=JADEPR.REDUCONE.˘(S1)V00
//SYSUT2 DD UNIT=ARCHIV,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.ARCHIVE.REDUC˘(SUBSTR(S1,3,3))
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$    COPY A RUTHERFORD WRITTEN MERGE TAPE TO A DESY M/ROOM TAPE
$----------------------------------------------------------------------
$
LABEL COPYRUT
CLEAR
SHOW '    COPY A RUTHERFORD WRITTEN MERGE TAPE TO A DESY M/ROOM TAPE'
SHOW '    =========================================================='
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE COPIED (EG G0470)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
$---------------------------------
$ RUTHERFORD TAPE SERIAL NUMBER(S)
$---------------------------------
$
SHOW ' '
SHOW '--- ENTER THE RUTHERFORD TAPE SERIAL NUMBER(S) (EG 939454,...)'
READ INTO S2 PROMPT '-->'
IF S2=' ' GOTO NODEFLT
IF LENGTH(S2)=0 GOTO NODEFLT
$
$--------------------------------------
$ RUTHERFORD TAPE LABEL SEQUENCE NUMBER
$--------------------------------------
$
SHOW ' '
SHOW '--- ENTER THE TAPE VOLUME LABEL NUMBER (DEFAULT = 1)'
READ INTO S3 PROMPT '-->'
IF S3=' ' SET S3='1'
IF LENGTH(S3)=0 SET S3='1'
$
$-----------
$ TIME LIMIT
$-----------
$
SET S11='(1,00)'
SET S12='A'
IF LENGTH(S2)<9 GOTO CLASSA
SET S11='(2,00)'
SET S12='K'
LABEL CLASSA
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEC'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=˘(S12),MSGLEVEL=(1,0),TIME=˘(S11)
//*MAIN RELPRI=MED,LINES=(2),ORG=EXT
//*
//*---------------------------------------------------------------------
//*
//* JOB TO COPY REDUC1 MERGE DATA FROM A RUTHERFORD TAPE TO A DESY TAPE
//*
//* SYSUT1 = (INPUT) RUTHERFORD TAPE CONTAINING REDUC1 MERGE DATA
//*        = JADEPR.REDUC1.˘(S1)    TAPE=˘(S2)    LABEL=˘(S3)
//*
//* SYSUT2 = (OUTPUT) DESY MACHINE ROOM TAPE
//*        = JADEPR.REDUCONE.˘(S1)V00
//*
//*---------------------------------------------------------------------
//*
//* STEP 1 - THE COPY
//* =================
//*
//RUTHCOPY EXEC PGM=IEBGENER,REGION=165K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=TAPE,DISP=(OLD,KEEP),
//       DSN=JADEPR.REDUC1.˘(S1),
//       VOL=SER=(˘(S2)),
//       LABEL=(˘(S3),SL,,IN)
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//      DSN=JADEPR.REDUCONE.˘(S1)V00
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.˘(S1)V00
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$              LIST RUN CONTENTS OF A REDUC1 MERGE TAPE
$----------------------------------------------------------------------
$
LABEL LISTRUNS
CLEAR
SHOW '        LIST RUN CONTENTS OF A REDUC1 MERGE TAPE'
SHOW '        ========================================'
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE LISTED (EG G0402)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEL'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=LOW,LINES=(2),ORG=EXT
//JOBLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//FT06F001 DD SYSOUT=*
//*
//*----------------------------------------------------------------
//*
//* JOB TO PRODUCE RUN/EVENT LISTING OF REDUC1 (OR ANY OTHER) TAPE
//* USED TO CHECK THAT CORRECT RUNS ETC ARE PRESENT ON TAPE
//*
//*----------------------------------------------------------------
//*
//FT02F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.˘(S1)V00
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$                   SUBMIT A REDUC1 MERGE JOB
$----------------------------------------------------------------------
$
LABEL MERGEJOB
CLEAR
SHOW '        SUBMIT A REDUC1 MERGE JOB'
SHOW '        ========================='
SHOW ' '
$
$-------------------------
$ REDUC1 GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REDUC1 GENERATION NUMBER TO BE USED (EG G0402)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
$-------------------
$ TAPES TO BE MERGED
$-------------------
$
SHOW ' '
SHOW '--- ENTER A LIST OF THE DATA SETS TO BE MERGED USING THE FULL'
SHOW '--- DATA SET NAME WITH NO APOSTROPHES (EG JADEPR.ST101)'
SHOW '--- THE LIST IS TERMINATED WITH A NULL INPUT'
SHOW ' '
READ INTO S2 PROMPT '--- ENTER FIRST DATA SET NAME :'
IF LENGTH(S2)=0 GOTO NODEFLT
IF S2 = ' ' GOTO NODEFLT
$
$-----------
$ CREATE JCL
$-----------
$
SET S40='JADEM'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB '10622622',REDUCONE,CLASS=K,MSGLEVEL=(1,0),TIME=(2,00)
//*MAIN RELPRI=MED,LINES=(15),CARDS=(900)
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUC1 MERGE STEP
//*
//* SYSUT1   = CONCATENATED SEQUENCE OF INPUT FILES TO BE MERGED
//* SYSUT2   = OUTPUT FILE FOR MERGED SUM
//* FT01F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY MUONSTEP)
//* FT02F001 = SAME AS SYSUT2 FILE (USED AS INPUT BY LISTRUNS)
//*
//*-----------------------------------------------------------
//*
//* STEP 1 - THE MERGE
//* ==================
//*
//DESYMRGE EXEC PGM=IEBGENER,REGION=120K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//*
//*  TAPE FOR MERGED OUTPUT
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG),DSN=JADEPR.REDUCONE.˘(S1)V00,
// VOL=(,RETAIN)
//*
//*  LIST OF INPUT TAPES TO BE MERGED
//*
//SYSUT1 DD UNIT=TAPE,DISP=SHR,DSN=˘(S2)
./ LABEL NOMACRO
$
$------------------------
$ MORE TAPES TO BE MERGED
$------------------------
$
LABEL MERGE1
READ INTO S2 PROMPT '--- ENTER NEXT  DATA SET NAME :'
IF LENGTH(S2)=0 GOTO MERGE2
IF S2 = ' ' GOTO MERGE2
./ INSERT 1000 1
// DD UNIT=AFF=SYSUT1,DISP=SHR,DSN=˘(S2)
./ LABEL NOMACRO
RENUM ####JUNK 1 1
GOTO MERGE1
LABEL MERGE2
$
$--------------------------------------
$ NOW FOR THE LISTRUN AND DI-MUON STEPS
$--------------------------------------
$
./ INSERT 1000 1
//*
//* STEP 2 - THE EVENT CHECK
//* ========================
//*
//LISTRUNS EXEC PGM=LISTRUNS,REGION=300K
//STEPLIB DD DSN=F11PEA.GENERAL.LOAD,DISP=SHR
//FT06F001 DD SYSOUT=*
//FT02F001 DD DISP=SHR,VOL=(,RETAIN),DSN=JADEPR.REDUCONE.˘(S1)V00
//*
//* STEP 3 - THE RJB DI-MUON EXTRACTOR
//* =================================
//*
//* GETMUONS EXEC PGM=GETMUONS,REGION=550K
//* STEPLIB DD DSN=JADEPR.JADELD,DISP=SHR,UNIT=FAST
//* FT06F001 DD SYSOUT=*
//* FT08F001 DD SYSOUT=4,OUTLIM=90000
//* FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0,DCB=BUFNO=1
//* FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0,DCB=BUFNO=1
//* FT01F001 DD DISP=SHR,DSN=JADEPR.REDUCONE.˘(S1)V00
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$                   RE-LINK THE REDUC1 MODULE
$----------------------------------------------------------------------
$
LABEL NEWLOAD
CLEAR
SHOW '           RE-LINK THE DESY REDUC1 MODULE'
SHOW '           =============================='
SHOW ' '
SHOW '--- ENTER THE NAME FOR THE NEW MODULE (DEFAULT = REDUC1LD) '
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 SET S1='REDUC1LD'
IF S1=' ' SET S1='REDUC1LD'
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADER1LK'
./ INSERT 1 1
//˘(S40) JOB '10622622',REDUCONE,CLASS=E,TIME=(0,15)
//*MAIN RELPRI=MED,LINES=(2),ORG=EXT
//*
//*-------------------------------------------------------
//*
//* JOB TO LINK AN EXECUTABLE REDUC1 LOAD MODULE AT DESY
//* NEW MODULE NAME = JADEPR.JADELD(˘(S1))
//*
//*-------------------------------------------------------
//*
//JOBLIB DD DSN=R02BUT.FORTRANH,DISP=SHR
// EXEC FCL,FORT=XL,PARM.LKED='LIST,MAP'
//FORT.SYSIN DD *
#include "jdmain0.for"
//*
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//*           DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DSN=R01UTL.CERN.GENLIB4,DISP=SHR
//            DD DSN=R01UTL.CERN.PACKLIB4,DISP=SHR
//LKED.SYSLMOD DD DISP=SHR,UNIT=FAST,DSN=JADEPR.JADELD(˘(S1))
//LKED.SYSIN DD *
 INCLUDE SYSLIB(USRED82,GBOOK,DBASEDUM)
//*
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$                       SUBMIT A REDUC1 JOB
$----------------------------------------------------------------------
$
LABEL RED1JOB
CLEAR
SHOW '        SUBMIT A REDUC1 JOB AT DESY'
SHOW '        ==========================='
SHOW ' '
$
$-------------------
$ TAPE TO BE REDUCED
$-------------------
$
SHOW ' '
SHOW '--- ENTER GENERATION NO. OF REFORM TAPE TO BE REDUCED (EG G0102)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF S1=' ' GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
SHOW ' '
SHOW '--- ENTER THE REFORMAT SERIES TO BE USED (DEFAULT = JDATA08)'
READ INTO S2 PROMPT '-->'
IF LENGTH(S2)=0 SET S2='JDATA08'
IF S2=' ' SET S2='JDATA08'
IF LENGTH(S2)=2 SET S2='JDATA'||S2
$
$--------
$ CPUTIME
$--------
$
SHOW ' '
SHOW '--- ENTER THE CPUTIME REQUIRED IN MINUTES (DEFAULT = 40)'
READ INTO S3 PROMPT '-->'
IF LENGTH(S3)=0 SET S3='40'
IF S3=' ' SET S3='40'
$
$-----------
$ CREATE JCL
$-----------
$
SET S40='JADED'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB '10622622',REDUCONE,CLASS=D,MSGLEVEL=(1,0),TIME=˘(S3)
//*MAIN RELPRI=MED,LINES=(20)
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//*
//*-----------------------------------------------------------
//*
//* JCL TO RUN THE JADE REDUCONE PROGRAM
//*
//* FT02F001 = INPUT REFORMAT TAPE (IE DATA TO BE REDUCED)
//*          = F11LHO.˘(S2).REFORM.˘(S1)V00
//*
//* SYSUT2   = OUTPUT FILE FOR REDUCED EVENTS
//*          = JADEPR.ST˘(SUBSTR(S1,3,3))
//*
//*-----------------------------------------------------------
//*
//REDUCING EXEC PGM=REDUC1LD,REGION=960K
//FT06F001 DD SYSOUT=*
//FT07F001 DD DUMMY
//FT03F001 DD UNIT=DISK,DISP=(NEW,PASS),DSN=&&DATAOUT,
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=6240),
//         SPACE=(CYL,(200,50))
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//*
//*        INPUT FILE OF EVENTS
//*
//FT02F001 DD DISP=SHR,DSN=F11LHO.˘(S2).REFORM.˘(S1)V00
//*
//*        USER CONTROL FILE
//*
//FT05F001 DD *
STARTRUN 00000000 00000000
NOTRUNS  00000 00000 00000 00000 00000 00000 00000 00000 00000 00000
/*
//SPOOLING EXEC PGM=IEBGENER,REGION=220K
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&DATAOUT
//*
//*        FINAL OUTPUT FILE
//*
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//       DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//       DSN=JADEPR.ST˘(SUBSTR(S1,3,3))
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$        COPY A DESY WRITTEN REFORM TAPE ONTO A RUTHERFORD TAPE
$----------------------------------------------------------------------
$
LABEL WRITERUT
CLEAR
SHOW '   COPY A DESY WRITTEN REFORM TAPE ONTO A RUTHERFORD TAPE'
SHOW '   ======================================================'
SHOW ' '
$
$-------------------------
$ REFORM GENERATION NUMBER
$-------------------------
$
SHOW ' '
SHOW '--- ENTER THE REFORM GENERATION NUMBER TO BE COPIED (EG G0470)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
IF S1=' ' GOTO NODEFLT
IF LENGTH(S1)=3 SET S1='G0'||S1
$
SHOW ' '
SHOW '--- ENTER THE REFORMAT SERIES REQUIRED (DEFAULT = JDATA08)'
READ INTO S3 PROMPT '-->'
IF LENGTH(S3)=0 SET S3='JDATA08'
IF S3=' ' SET S3='JDATA08'
$
$---------------------------------
$ RUTHERFORD TAPE SERIAL NUMBER(S)
$---------------------------------
$
SHOW ' '
SHOW '--- ENTER THE SERIAL NUMBER OF THE RUTHERFORD TAPE (EG 939454)'
READ INTO S2 PROMPT '-->'
IF S2=' ' GOTO NODEFLT
IF LENGTH(S2)=0 GOTO NODEFLT
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADEC'||SUBSTR(S1,3,3)
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,MSGLEVEL=(1,0),TIME=(1,00)
//*MAIN RELPRI=MED,LINES=(5)
//*
//*
//* ===================================================================
//*
//* JOB TO PRODUCE A RUTHERFORD REFORM TAPE
//*
//* DESY REFORM TAPE = F11LHO.˘(S3).REFORM.˘(S1)V00
//*
//* RUTHERFORD TAPE  = ˘(S2)
//*
//* ===================================================================
//*
//*
//JOBLIB DD DSN=JADEPR.JADELD,DISP=SHR
//RUTH EXEC PGM=RUTHCOPY,REGION=190K
//FT06F001 DD SYSOUT=*
//FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//FT22F001 DD DISP=SHR,DSN=F11LHO.KALWRK0
//FT04F001 DD UNIT=TAPE,DISP=(OLD,KEEP),
//         DSN=F11LHO.˘(S3).REFORM.˘(S1)V00
//FT03F001 DD UNIT=TAPE,DISP=(NEW,KEEP,DELETE),
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//         VOL=SER=(˘(S2)),
//         LABEL=(1,SL,,OUT),
//         DSN=JADEPR.AU0R˘(SUBSTR(S1,3,3))
//FT03F002 DD UNIT=AFF=FT03F001,DISP=(NEW,KEEP,DELETE),
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//         VOL=SER=(˘(S2)),
//         LABEL=(2,SL,,OUT),
//         DSN=JADEPR.AU1R˘(SUBSTR(S1,3,3))
//FT03F003 DD UNIT=AFF=FT03F002,DISP=(NEW,CATLG,DELETE),
//         DCB=(RECFM=VBS,LRECL=6236,BLKSIZE=24948),
//         VOL=SER=(˘(S2)),
//         LABEL=(3,SL,,OUT),
//         DSN=JADEPR.RUTH˘(SUBSTR(S1,3,3))
//FT05F001 DD *
//*
./ LABEL NOMACRO
GOTO SUBMIT
$
$----------------------------------------------------------------------
$              LIST THE FILE CONTENTS OF A RUTHERFORD TAPE
$----------------------------------------------------------------------
$
LABEL XTAPE
CLEAR
SHOW '      LIST THE FILE CONTENTS OF A RUTHERFORD TAPE'
SHOW '      ==========================================='
SHOW ' '
$
$--------------------------
$ TAPE VOLUME SERIAL NUMBER
$--------------------------
$
SHOW ' '
SHOW '--- ENTER THE TAPE VOLUME SERIAL NUMBER (EG 939451)'
READ INTO S1 PROMPT '-->'
IF LENGTH(S1)=0 GOTO NODEFLT
$
$--------------
$ CONSTRUCT JCL
$--------------
$
SET S40='JADETAPE'
./ INSERT 1 1
//˘(S40) JOB 10622622,REDUCONE,CLASS=A,TIME=(,15),MSGLEVEL=(0,0)
//*MAIN RELPRI=MED,LINES=(5)
//*
//*-----------------------------------------------------------
//*
//* JOB TO LIST FILE CONTENTS OF A RUTHERFORD TAPE
//*
//*-----------------------------------------------------------
//*
// EXEC TAPETEST,VOLSER=˘(S1),ONLYSUM=Y
//
./ LABEL NOMACRO
GOTO SUBMIT
$
$-------------
$ SUBMIT JOB ?
$-------------
$
LABEL SUBMIT
RENUM ####JUNK 1 1
SHOW ' '
SHOW '--- JCL CREATED'
SHOW '--- PRESS RETURN/ENTER TO SUBMIT, ANYTHING ELSE TO TERMINATE :'
READ INTO S1 PROMPT '--> '
IF S1=' ' GOTO RUN
SHOW '--- SUBMIT TERMINATED'
SHOW '--- JCL MAY BE INSPECTED IN MEMBER ####JUNK'
GOTO KEEPJCL
LABEL RUN
SUBH ####JUNK
SHOW '--- JOB ˘(S40) SUBMITTED '
READ INTO S1 PROMPT '--- ANOTHER ONE ? ( Y(ES) OR N(O) )'
IF SUBSTR(S1,1,1)^='Y' GOTO STOP
GOTO SKIP1
$
$----------------
$ TERMINATE CLIST
$----------------
$
LABEL NODEFLT
SHOW ' '
SHOW '--- THERE IS NO DEFAULT FOR THIS PARAMETER'
LABEL STOP
SC ####JUNK
LABEL KEEPJCL
SHOW ' '
SHOW '--- END OF CLIST'
SET ESCAPE=''
V ON
FULL ON
RETURN
$   28/05/84 508061722: MEMBER NAME  JBWRIT   (BIBLS)       NEWLIB

C   06/06/84 507222016  MEMBER NAME  FINABR   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FINABR( CCS, LEN, ICOMD, MAXARG, IS )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   6/06/84 :  FIND COMMAND ABBREVIATION MATCH
C
C
C   INPUT   CCS    STRING OF LENGTH LEN BYTES WITH COMMAND IN IT
C           LEN    LENGTH OF STRING
C
C   OUTPUT  ICOMD  FOUND COMMAND.  0 = COMMAND NOT FOUND.
C           MAXARG MAX. NO. OF ARGUMENTS ALLOWED FOR THIS COMMAND
C           IS     POINTER TO START OF NUMERICAL ARGUMENT IN CCS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CCMD,CBLANK,CCS(LEN)
C
      COMMON / CGRAP4 / IPOS4,CCMD(8,200),HCMD(5,200)
C
      DATA  CBLANK / ' ' /
C
C-------------------  C O D E  -----------------------------------------
C
C                            IS  POINTS TO START OF ARGUMENT IF IN FIELD
C
        IS = 0
C
C                            LOOP OVER THE ABBREVIATIONS LIST
C
        DO  8  J = 1,IPOS4
          ICOMD  = HCMD( 1, J )
          MAXARG = HCMD( 2, J )
          K      = 1
C
C                            LOOP OVER THE CHARS IN THE WORD FIELD
C                            AND CHECK FOR A MATCH
C
          DO  7  I = 1,LEN
            IF( K .GT. 8  .AND.  NUMFUN( CCS(I) ) .GE. 0 ) GO TO 15
            IF( CCS(I) .EQ. CCMD(K,J) ) GO TO 5
C
C                            THIS CHAR DOES NOT MATCH.
C                            IF THE INPUT CHAR IS A NUMBER AND THE
C                            COMMAND HAS NO MORE LETTERS  ==> SUCCESS
C
              IF( NUMFUN(CCS(I))  .GE. 0  .AND.
     +            CCMD(K,J) .EQ. CBLANK         ) GO TO 15
              GO TO 8
C
C                            THIS LETTER MATCHES
C
   5        K     = K + 1
   7      CONTINUE
C
          IF( K .GT. 8 ) RETURN
          IF( CCMD(K,J) .EQ. CBLANK ) RETURN
C
   8    CONTINUE
C
C                            NO MATCH
C
        ICOMD = 0
        RETURN
C
C                            THE END OF THIS FIELD FROM  I  ONWARDS
C                            CONTAINS A NUMERICAL ARGUMENT
C
  15    IS    = I
        RETURN
C
        END

C   07/06/96 606071903  MEMBER NAME  POTOEQ   (S4)          FORTG1
      SUBROUTINE POTOEQ(Y,N)
      REAL Y(N)
C
C     TRANSFORM POISSON DISTRIBUTED DATA TO DATA OF VARIANCE 1.0
C
      IA=0
      IB=0
      DO 10 I=1,N
      IF(Y(I).EQ.0.0) GOTO 10
      IF(IA.EQ.0) IA=I
      IB=I
   10 CONTINUE
      IF(IB.EQ.0) GOTO 100
      DO 30 I=IA,IB
      IF(Y(I).GT.0.0) GOTO 20
      Y(I)=1.0
      GOTO 30
   20 Y(I)=SQRT(Y(I))+SQRT(Y(I)+1.0)
   30 CONTINUE
      GOTO 100
C
      ENTRY EQTOPO(Y,N)
C
C     TRANSFORM BACK TO POISSON DISTRIBUTED DATA
C
      DO 50 I=1,N
      IF(Y(I).GT.1.0) GOTO 40
      Y(I)=0.0
      GOTO 50
   40 SY=(0.5*(Y(I)-1.0/Y(I)))**2
      NY=10.0*SY+0.5
      Y(I)=0.1*FLOAT(NY)
   50 CONTINUE
  100 RETURN
      END

C   13/02/80 711162035  MEMBER NAME  DEDXDS0  (S)           FORTRAN
      SUBROUTINE DEDXDS
C--
C--     DEDX DISPLAY FOR JADE, USING DEDX PROGRAM FROM R.EICHLER
C--     13.02.80       LAST CHANGE 14.06.83          J.OLSSON
C--                    LAST CHANGE 17.05.85          J.A.J.SKARD
C--                    LAST CHANGE  9.06.86          J.OLSSON
C--                    LAST CHANGE 20.08.86          J.OLSSON
C--                    LAST CHANGE 13.11.87          E ELSEN
C---
C---   OPTIONS IN COMMAND DEDX
C---     DEDX I, I>0   SINGLE LINE PRINT FOR TRACK I
C---     DEDX 0        SINGLE LINE PRINT FOR EACH TRACK
C---     DEDX -1       CREATE BANK DEDX
C---     DEDX -2       LARGE DEDX VS. MOMENTUM DISPLAY
C---     DEDX -3       NOT USED
C---     DEDX -4       SMALL DEDX VS. MOMENTUM DISPLAY
C---     DEDX -5       LARGE DEDX VS. MOMENTUM DISPLAY, SCALE EXTRALARGE
C---     DEDX -6       CHANGE VARIABLE NHFCUT: MIN. NR OF HITS ON TRACK.
C---                     ALSO VARIABLE PMCUT: MIN. MOMENTUM OF TRACK.
C---
      IMPLICIT INTEGER*2 (H)
      LOGICAL FL18,FL22,FL24
      COMMON/CPROJ/XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON/CWORK1/IER,NTR,TRES(10,60)
      DIMENSION ITRES(10,60),HTYP(3,8),HMW(4)
      EQUIVALENCE (TRES(1,1),ITRES(1,1))
      DIMENSION SAV(6)
#include "cgeo1.for"
#include "cgraph.for"
#include "cdata.for"
      COMMON / CDEDXU / NHFCUT,PMCUT
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      LOGICAL DSPDTM
C     DATA HTYP /'  ','PR','OT','ON','  ','K ','PL','US',
C    $           'PI',' P','LU','S ','PO','SI','TR','ON',
C    $           'A-','PR','OT','ON',' K',' M','IN','US',
C    $           'PI',' M','IN','US','EL','EC','TR','ON'/
      DATA HTYP /'PR','OT','ON','  ',' K',' +',
     $           '  ','PI',' +','  ',' E',' +',
     $           'AN','TI','-P','  ',' K',' -',
     $           '  ','PI',' -','  ',' E',' -'/
      DATA HBLANK /'  '/
C                                           FLAG TO REQUEST DATA FOR
C                                           SINGLE TRACK
      COMMON /CDXSIN/ ISNGTR
C----------------------------------------
      NN = ACMD
C---   CALL DEDX PROGRAM HERE
      IF( NN.GT.0 ) ISNGTR = NN
      CALL DEDXBN
2213  IF(NN.GE.0) GO TO 99
      IF(NN.EQ.-1) GO TO 91
      IF(NN.EQ.-6) GO TO 121
C SHOW DIAGRAM DEDX VS MOMENTUM
      CALL DEDXVW
      RETURN
91    IPPATR = IDATA(IBLN('PATR'))
      IF(IPPATR.GT.0) GO TO 98
      WRITE(6,97)
97    FORMAT(' ERROR ----->>   PATR BANK DOES NOT EXIST')
      RETURN
98    CALL DEDXBK(IPPATR)
      RETURN
C---       CHANGE NHFCUT AND PMCUT    OPTION DEDX -6
121   CONTINUE
      WRITE(6,1211) NHFCUT,PMCUT
1211  FORMAT(' PRESENT VALUES OF NHFCUT AND PMCUT ARE:',I3,F6.3,
     $  ',  ENTER NEW VALUES:')
      CALL TONUM(INT1,FLP1)
      NHFCUT = INT1
      IF(NHFCUT.LT.5.OR.NHFCUT.GT.45) NHFCUT = 15
      PMCUT = FLP1
      IF(PMCUT.LT..02) PMCUT = 0.05
      WRITE(6,995) NHFCUT,PMCUT
995   FORMAT(' NEW VALUES FOR NHFCUT AND PMCUT ARE:',I4,F7.3)
      RETURN
C---
99    CONTINUE
C--   LOOP OVER TRACKS
      IPO = IDATA(IBLN('PATR'))
      LO = IDATA(IPO+1)
C     NTR = IDATA(IPO+2)
      LTR = IDATA(IPO+3)
      IPO = IPO + LO - LTR
      NTRR = MIN0(NTR,60)
      DO 111  ITR = 1,NTRR
      IPO = IPO + LTR
      IF(NN.GT.0.AND.NN.NE.ITR) GO TO 111
      RAD = ADATA(IPO+25)
      HSIGN = 1
      IF(RAD*BKGAUS.LT.0.) HSIGN = -1
      JMIN = ITRES(8,ITR)
      DO 112  I = 1,3
      IF(JMIN.LT.1.OR.JMIN.GT.4) HMW(I) = HBLANK
      IF(JMIN.LT.1.OR.JMIN.GT.4) GO TO 112
      K = JMIN
      IF(HSIGN.LT.0) K = K + 4
      HMW(I) = HTYP(I,K)
112   CONTINUE
      NHT = ITRES(1,ITR)
      DEDX = TRES(2,ITR)
      SIDEDX = TRES(3,ITR)
      SAV(1)=TRES(4,ITR)
      SAV(2)=TRES(5,ITR)
      SAV(3)=TRES(6,ITR)
      SAV(4)=TRES(7,ITR)
      SAV(5)=TRES(9,ITR)
      SAV(6)=TRES(10,ITR)
C
C  IF SINGLE TRACK REQUIRED, DISPLAY DEDX VS RADIUS HISTOGRAM
C
      IF(DSPDTM(19).AND.NN.GT.0.AND.ITRES(1,NN).GT.0)   CALL DEDXV1
C
C---  WRITE DEDX INFORMATION FOR TRACK ITR
C     WRITE(6,1379) ITR,(HMW(I),I=1,3),DEDX,SIDEDX,(TRES(I,ITR),I=4,7)
C    ,, TRES(9,ITR), TRES(10,ITR)
      WRITE(6,1379) ITR,(HMW(I),I=1,3),DEDX,SIDEDX,(SAV(I),I=1,6)
1379  FORMAT(I2,1X,3A2,' DEDX=',F5.2,'+-',F5.2,' CHI(E P K P) ',
     $ 4F6.2,' P',F6.3,'+-',F5.3)
111   CONTINUE
      RETURN
      END

C   10/05/82 608291510  MEMBER NAME  RDTRG2   (JADEGS)      FORTRAN
      SUBROUTINE RDTRG2
C***********************************************************************
C     VERSION OF 5/3/79     AUTHOR M.HELM
C     LAST MOD 13/05/82     E.ELSEN
C     MODIFIED 8.8.83 TO CONFORM WITH RDTRG    J.OLSSON
C     COPLANARITY LOGIC FOR TRACKS CORRECTED   J.OLSSON
C        LAST CHANGE 24.8.86
C     THIS ROUTINE PERFORMS A SOFTWARE TRIGGER T2.
C     INPUT ARE THE LATCHES FOR JET CHAMBER WIRES AND TOF COUNTERS.
C     FILLS BANK 'TRIG' NO.2 AND TRIGGER ACTION WORD(22) IN BANK 'HEAD'
C******************************************************************
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CMASK/ MASK(16),MASK4,MASK3,MASK2,MASK1
      COMMON/BCS/IDATA(1)
      DIMENSION HDATA(2),IW22(8)
      EQUIVALENCE (IDATA(1),HDATA(1))
      COMMON/CWORK/HJHIT(96),HJCTRK(192),HJTRKA(96),HJTRKF(96),ITOF(42),
     *             HWORD(24),HFPLA(16),NJTRKA,NJTRKF,
     *             IDUMMY(96)
      DIMENSION IWORD(13)
      EQUIVALENCE(IWORD(2),HWORD(1))
      DIMENSION NZERO(400)
      EQUIVALENCE(NZERO(1),HJHIT(1))
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
      COMMON /CFPLA/ HFT(12,4),HR1(12,4),HR2(12,4)
C
C  RETURN, WHEN BANKS 'HEAD' OR 'TRIG' NO.1 NOT EXISTING
C                   OR BANK 'TRIG' NO.2 ALREADY EXISTING
      IYEAR = IHIST(3)
      IYEAR = MOD(IYEAR,100)
      IF(IYEAR.LT.82) GO TO 3231
C FOR 1982 AND LATER, CALL SUBR. RD82T2
      CALL RD82T2
      RETURN
3231  CONTINUE
      IND0=IDATA(IBLN('HEAD'))
      CALL CLOC(IND1,'TRIG',1)
      CALL CLOC(IND2,'TRIG',2)
      IF(IND2.NE.0.OR.IND0.EQ.0.OR.IND1.EQ.0) RETURN
C
      NJTRKA=0
      NJTRKF=0
C                         ZERO SET COMMON /CWORK/
      CALL VZERO(NZERO,400)
C
C  FILL JETC HIT CELL ARRAY     HJHIT:  HIT WIRES/CELL
C
             IPJ=IDATA(IBLN('JETC'))
             IF(IPJ.EQ.0) GOTO 1000
             IL4=IPJ*2+101
             IH4=IL4+HDATA(IPJ*2+99)-4
             NWSTOR=-1
             DO 300 KWIRE=IL4,IH4,4
             NWIRE=HDATA(KWIRE)/8
             IF(NWIRE.EQ.NWSTOR) GOTO 300
             NWSTOR=NWIRE
             NWCLL=NWIRE/16+1
             HJHIT(NWCLL)=HJHIT(NWCLL)+1
  300        CONTINUE
C
C  OVERWRITE HITS PER CELL WHEN IN DEAD CELLS WIRES ARE SWITCHED ON
C
             DO 310 K=1,10
             IF(HDEADC(K).NE.0) HJHIT(HDEADC(K))=16
  310        CONTINUE
C
C  FILL ARRAY HJCTRK: HIT CELLS (ODD INDEX) AND HIT WALLS (EVEN INDEX)
C
      DO 301  IRING=1,3
      IEND=HCHAMB(IRING)
      DO 301  ICELL=1,IEND
      I=ICELL+(IRING-1)*24
      IF(HJHIT(I).GT.HITCLL(IRING)) HJCTRK(2*I-1)=1
C  I IS CELL INDEX, I1 IS NEXT CELL
      I1=I+1
      IF(ICELL.EQ.HCHAMB(IRING)) I1=I1-HCHAMB(IRING)
      IF(HJHIT(I).GT.HITWLL(IRING).AND.HJHIT(I1).GT.HITWLL(IRING).AND.
     *  (HJHIT(I)+HJHIT(I1)).GT.HITSUM(IRING)) HJCTRK(2*I)=1
  301 CONTINUE
C
C  FILL ARRAY HWORD(1-24)   IT IS LATER STORED IN    TRIG:2
C
C      KWD = 2,6,10,14,18,22    KBIT = 9-16, 1-8   RING 1,2
C      KWD = 1,5,9,13,17,21     KBIT = 1-16        RING 3
C
C
             DO 302 I=1,192
             IF(HJCTRK(I).EQ.0) GOTO 302
             KWD=(I-1)/8*4+2
             KBIT=I-(I-1)/8*8+8
             IF(I.LE.48) GOTO 303
             KWD=(I-49)/8*4+2
             KBIT=I-(I-49)/8*8-48
             IF(I.LE.96) GOTO 303
             KWD=(I-97)/16*4+1
             KBIT=I-(I-97)/16*16-96
 303         CONTINUE
             HWORD(KWD)=hLOR(HWORD(KWD),hint(MASK(KBIT))) ! PMF 10/06/99: hlor,hint 
 302         CONTINUE
C
C  FILL TOF COUNTER LATCH ARRAY     ITOF(1-42)
C
                   IPL=IDATA(IBLN('LATC'))
                   IF(IPL.EQ.0) GOTO 201
                   DO 200 KWD=1,6
                   JBIT10=HDATA(IPL*2+5+KWD)
                   DO 200 KBIT=1,7
  200              ITOF((KWD-1)*7+KBIT)=JBIT(JBIT10,KBIT)
  201              CONTINUE
C
C                                           FOLLOWING ILLUSTRATION
C                                           BY ARTIST JAN OLSSON.
C                           N S E G
C                       --------------
C                       .     I     I
C                       .     I     I
C                       .  1  2  3  4
C                       .     I     I
C                       .     I     I
C           -------------------------------------
C           .           I           I           .
C           .           I           I           .
C           .     5     6     7     8     9     .
C           .           I           I           .
C           .           I           I           .
C           -------------------------------------
C           I           I           I           I
C           I           I           I           I
C          10    11     12    13    14    15    16
C           I           I           I           I
C           I           I           I           I
C           -------------------------------------
C     CELL AND WALL NUMBERING FOR TRACK DEFINITION
C
C  A SLOW TRACK IS DEFINED BY  1 - 5 - 10         (HFT = 0)
C  A FAST TRACK IS DEFINED BY  1 - 5 - 11, 1 - 5 - 12   ETC.   (HFT=1)
C
C   DEFINED BY ARRAY HFT(12,4)   1-4 GIVEN BY 1-4 IN RING 3
C   TRACKS DEFINED BY COINCIDENCE RING 1 - 3, GIVEN BY ARRAYS HR1,HR2
C
C
C  LOOP OVER INNER DETECTOR TRACK ELEMENTS FOR LINKING
C
      KA=1
      KF=1
      DO 400 NSEG=1,24
      NR3=96+(NSEG-1)*4
C  ARE THERE R3 TRACK ELEMENTS IN THIS SEGMENT
      IF((HJCTRK(NR3+1)+HJCTRK(NR3+2)+HJCTRK(NR3+3)+HJCTRK(NR3+4)).GT.0)
     *  GOTO 420
      KA=1
      KF=1
      GOTO 400
 420  CONTINUE
C
C  FILL 16 INPUTS OF FPLA FOR ONE STREET WITH TRACK ELEMENTS
C    HFPLA(1-4) :    RING3
C    HFPLA(5-9) :    RING2
C    HFPLA(10-16) :    RING1
C
C                           R3(1-4),R2(5-9),R1(10-16)
      NR2I=2*NSEG-4+48
      IF(NR2I.LE.48) NR2I=NR2I+48
        DO 403 N2=1,5
        NR2=NR2I+N2
        IF(NR2.GT.96) NR2=NR2-48
        IF(N2.NE.5) HFPLA(N2)=HJCTRK(NR3+N2)
  403   HFPLA(4+N2)=HJCTRK(NR2)
      NR1I=2*NSEG-5
      IF(NR1I.LE.0) NR1I=NR1I+48
        DO 404 N1=1,7
        NR1=NR1I+N1
        IF(NR1.GT.48) NR1=NR1-48
  404   HFPLA(9+N1)=HJCTRK(NR1)
C
C  PROOF FPLA CONDITIONS
        DO 401 ITYPE=1,4
        IF(HFPLA(ITYPE).EQ.0) GOTO 411
        H123A=0
        H123F=0
          DO 500 ICOND=1,12
          IF((ITYPE+ICOND).EQ.16) GOTO 500
          IF((HFPLA(HR2(ICOND,ITYPE))+HFPLA(HR1(ICOND,ITYPE))).EQ.2)
     *             H123A=1
          IF((HFPLA(HR2(ICOND,ITYPE))+HFPLA(HR1(ICOND,ITYPE)) +
     *             HFT(ICOND,ITYPE)).EQ.3) H123F=1
  500     CONTINUE
        IF((H123A+H123F).EQ.0) GOTO 411
C  TRACK FOUND THROUGH R1,R2,R3    KSEG DIVIDES DETECTOR IN 96 PARTS
        KSEG=(NSEG-1)*4+ITYPE
C
C  ADD TOF COUNTERS
C
             PHIJ=(360./96.)*KSEG
             DPHITO=360./42.
             ATOF=PHIJ/DPHITO+1.5001
             KTOF=ATOF
             KTOF=KTOF-KTOF/43*42
             KTP=KTOF+1-KTOF/42*42
             KTM=KTOF-1+(43-KTOF)/42*42
C            LOGIC OR OF 2 OR 3 TOF COUNTERS
             IF((ATOF-FLOAT(KTOF)).LT..001) KTP=KTM
             IF((ITOF(KTOF)+ITOF(KTP)+ITOF(KTM)).LT.1) GOTO 411
C  TRACKS GOES THROUGH FIRED TOF
  501 CONTINUE
C
C  COUNT TRACKS FOR ALL/HIGH MOMENTA AND CLASSIFY WITH SEGMENT IN R3
C    KA AND KF ARE 1 FIRST TIME, 0 FOLLING TIMES
C
      NJTRKA=NJTRKA+KA
      KA=1-KA
      HJTRKA(KSEG)=1
      IF(H123F.EQ.0) GOTO 412
      NJTRKF=NJTRKF+KF
      KF=1-KF
      HJTRKF(KSEG)=1
      GOTO 401
C  NO TRACKS FOUND, RESET KA,KF
  411 KA=1
  412 KF=1
  401 CONTINUE
  400 CONTINUE
C
C  FILL ARRAY HWORD WITH TRACK INFORMATION FOR LATER STORE IN TRIG:2
C    KWD = 3,7,11,15,19,23   KBIT = 1-16      ALL TRACKS
C    KWD = 4,8,12,16,20,24   KBIT = 1-16     FAST TRACKS
C
             DO 600 I=1,96
             KWD=(I-1)/16*4+3
             KBIT=I-(I-1)/16*16
      IF(HJTRKA(I).EQ.1) HWORD(KWD)=hLOR(HWORD(KWD),hint(MASK(KBIT))) ! PMF 10/06/99: hlor,hint 
      IF(HJTRKF(I).EQ.1)HWORD(KWD+1)=hLOR(HWORD(KWD+1),hint(MASK(KBIT))) ! PMF 10/06/99: hlor,hint 
  600        CONTINUE
C
C                                           CODE FOR NARROW COPLANARITY
C                                           CHECK LINKING TO FAST TRACKS
      ICOPLA = 0
      IF( NJTRKF .LE. 1 ) GO TO 790
        DO 700 I=1,72
        IF( HJTRKF(I) .EQ. 0 ) GO TO 700
        JLO = I + 48 - IWIDT2*2
        JHI = I + 48 + IWIDT2*2
          DO 700 J=JLO,JHI
          JOP = J
          IF(JOP.GT.96) JOP = JOP - 96
          IF( HJTRKF(JOP) .EQ. 0 ) GO TO 700
          ICOPLA = 1
          GO TO 790
  700   CONTINUE
  790 CONTINUE
C
 1000 CONTINUE
C
C  FILL BANK 'TRIG' NO.2  WITH CONTENT OF ARRAY HWORD
C
      CALL CCRE(IND2,'TRIG',2,13,IER)
      IF( IER .EQ. 2 ) GO TO 8000
      CALL MVCL( IDATA, IND2*4, IWORD, 0, 52 )
      IDATA(IND2+1) = 0
C
      CALL VZERO(IW22,8)
C
C  T2 LOGIC CONDITIONS ACCORDING TO T1 POSTPONE
C
      IT1=HDATA(IND1*2+10)
      ICO1 = 0
C
C--->>> 2-TRACK TRIGGERS
C
C         TOF AND TOTAL LG ENERGY
      IF(JBIT(IT1,1).EQ.1.AND.NJTRKA.GE.HACC1 ) ICO1= LOR(ICO1,MASK(10))
C
C         TAGG
C
      IF(JBIT(IT1,2).EQ.1.AND.NJTRKA.GE.HACC3 ) ICO1= LOR(ICO1,MASK(10))
C
C--->>> 2-COLL.TRACK TRIGGERS
C
C         COPLANARITY IN TOF, WIDE, CASE OF ANY TWO FAST TRACKS
C
C     IF(HWCOLN.NE.1 .AND.
      IF(IHIST(3).LT.1981.AND.
     *   JBIT(IT1,5).EQ.1.AND.NJTRKF.GE.HACC2 )
     *                                          ICO1= LOR(ICO1,MASK(11))
C
C         COPLANARITY IN TOF, WIDE, CASE OF COPLANAR FAST TRACKS
C
C     IF(HWCOLN.EQ.1 .AND.
      IF(IHIST(3).EQ.1981.AND.
     *   JBIT(IT1,5).EQ.1.AND.NJTRKF.GE.HACC2 .AND. ICOPLA .EQ. 1 )
     *                                          ICO1= LOR(ICO1,MASK(11))
C
C         COPLANARITY IN TOF, NARROW
C
C     IF(HWCOLN.EQ.1 .AND.
      IF(IHIST(3).EQ.1981.AND.
     *   JBIT(IT1,6).EQ.1.AND.NJTRKF.GE.HACC4 .AND. ICOPLA .EQ. 1 )
     *                                          ICO1= LOR(ICO1,MASK(11))
C
C--->>> 3-TRACK TRIGGERS
C
C         COPLANARITY IN TOF, WIDE MULTIPRONG CONDITION
C
      IF(JBIT(IT1,7).EQ.1.AND.NJTRKA.GE.HACCM ) ICO1= LOR(ICO1,MASK(12))
C -----------------------------------------------
      IF( ICO1 .GT. 0 ) IW22(6) = 1
C
      DO 1100 IBIT=1,8
      IW22(4)=IW22(4)+JBIT(IT1,IBIT+8)
 1100 IW22(5)=IW22(5)+JBIT(IT1,IBIT)
      IF(IW22(4).GE.1) IW22(1)=1
      IF(IW22(4).EQ.0.AND.IW22(6).EQ.1) IW22(2)=1
C
C  FILL WORD 22 IN 'HEAD': ACTUAL ACC T1,T2,T3; ACTION T1ACC,T1POST,
C                          T2ACC,T2POST,  T3ACC
      K=IND0*2+22
      HDATA(K) = 0
      DO 1101 IBIT=1,8
         IF(IW22(IBIT).GE.1) HDATA(K)=hLOR(HDATA(K),hint(MASK(IBIT))) ! PMF 10/06/99: hlor,hint 
 1101 CONTINUE
C                                           FILL BEATES SPECIAL WORD
C                                           IN TRIG,1 SHOWING ACTUAL
C                                           T2 ACCEPT SOURCE
      HDATA(IND1*2+9) = hLOR(HDATA(IND1*2+9),hint(ICO1)) ! PMF 10/06/99: hlor,hint 
C
      RETURN
C
C                                           NO SPACE IN BCS LEFT
 8000 WRITE(6,9101)
 9101 FORMAT(/' NOT ENOUGH SPACE IN BCS LEFT FOR CREATION OF TRIG, 2'/)
      RETURN
      END
      SUBROUTINE RD82T2
C***********************************************************************
C     VERSION OF 5/3/79     AUTHOR M.HELM
C     LAST MOD 27/07/86     J.OLSSON
C     COPLANARITY LOGIC FOR CHARGED TRACKS CORRECTED
C              --------------
C     THIS ROUTINE PERFORMS A SOFTWARE TRIGGER T2.
C     INPUT ARE THE LATCHES FOR JET CHAMBER WIRES AND TOF COUNTERS.
C******************************************************************
C
      IMPLICIT INTEGER*2 (H)
      COMMON /CMASK/ MASK(16),MASK4,MASK3,MASK2,MASK1
      COMMON/BCS/IDATA(1)
      DIMENSION HDATA(2),IW22(8)
      EQUIVALENCE (IDATA(1),HDATA(1))
      COMMON/CWORK/HJHIT(96),HJCTRK(192),HJTRKA(96),HJTRKF(96),ITOF(42),
     *             HWORD(24),HFPLA(16),NJTRKA,NJTRKF,IDUMMY(96)
      DIMENSION IWORD(13)
      EQUIVALENCE(IWORD(2),HWORD(1))
      DIMENSION NZERO(400)
      EQUIVALENCE(NZERO(1),HJHIT(1))
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C
      COMMON /CFPLA/ HFT(12,4),HR1(12,4),HR2(12,4)
C
C  RETURN, WHEN BANKS 'HEAD' OR 'TRIG' NO.1 NOT EXISTING
C                   OR BANK 'TRIG' NO.2 ALREADY EXISTING
      IND0=IDATA(IBLN('HEAD'))
      CALL CLOC(IND1,'TRIG',1)
      CALL CLOC(IND2,'TRIG',2)
      IF(IND2.NE.0.OR.IND0.EQ.0.OR.IND1.EQ.0) RETURN
C
      NJTRKA=0
      NJTRKF=0
C                         ZERO SET COMMON /CWORK/
      CALL VZERO(NZERO,400)
C
C  FILL JETC HIT CELL ARRAY     HJHIT:  HIT WIRES/CELL
C
             IPJ=IDATA(IBLN('JETC'))
             IF(IPJ.EQ.0) GOTO 1000
             IL4=IPJ*2+101
             IH4=IL4+HDATA(IPJ*2+99)-4
             NWSTOR=-1
             DO 300 KWIRE=IL4,IH4,4
             NWIRE=HDATA(KWIRE)/8
             IF(NWIRE.EQ.NWSTOR) GOTO 300
             NWSTOR=NWIRE
             NWCLL=NWIRE/16+1
             HJHIT(NWCLL)=HJHIT(NWCLL)+1
  300        CONTINUE
C
C  OVERWRITE HITS PER CELL WHEN IN DEAD CELLS WIRES ARE SWITCHED ON
C
             DO 310 K=1,10
             IF(HDEADC(K).NE.0) HJHIT(HDEADC(K))=16
  310        CONTINUE
C
C  FILL ARRAY HJCTRK: HIT CELLS (ODD INDEX) AND HIT WALLS (EVEN INDEX)
C
      DO 301  IRING=1,3
      IEND=HCHAMB(IRING)
      DO 301  ICELL=1,IEND
      I=ICELL+(IRING-1)*24
      IF(HJHIT(I).GT.HITCLL(IRING)) HJCTRK(2*I-1)=1
C  I IS CELL INDEX, I1 IS NEXT CELL
      I1=I+1
      IF(ICELL.EQ.HCHAMB(IRING)) I1=I1-HCHAMB(IRING)
      IF(HJHIT(I).GT.HITWLL(IRING).AND.HJHIT(I1).GT.HITWLL(IRING).AND.
     *  (HJHIT(I)+HJHIT(I1)).GT.HITSUM(IRING)) HJCTRK(2*I)=1
  301 CONTINUE
C
C  FILL ARRAY HWORD(1-24)   IT IS LATER STORED IN    TRIG:2
C
C      KWD = 2,6,10,14,18,22    KBIT = 9-16, 1-8   RING 1,2
C      KWD = 1,5,9,13,17,21     KBIT = 1-16        RING 3
C
             DO 302 I=1,192
             IF(HJCTRK(I).EQ.0) GOTO 302
             KWD=(I-1)/8*4+2
             KBIT=I-(I-1)/8*8+8
             IF(I.LE.48) GOTO 303
             KWD=(I-49)/8*4+2
             KBIT=I-(I-49)/8*8-48
             IF(I.LE.96) GOTO 303
             KWD=(I-97)/16*4+1
             KBIT=I-(I-97)/16*16-96
 303         CONTINUE
             HWORD(KWD)=hLOR(HWORD(KWD),hint(MASK(KBIT))) ! PMF 10/06/99: hlor,hint 
 302         CONTINUE
C
C  FILL TOF COUNTER LATCH ARRAY     ITOF(1-42)
C
                   IPL=IDATA(IBLN('LATC'))
                   IF(IPL.EQ.0) GOTO 201
                   DO 200 KWD=1,6
                   JBIT10=HDATA(IPL*2+5+KWD)
                   DO 200 KBIT=1,7
  200              ITOF((KWD-1)*7+KBIT)=JBIT(JBIT10,KBIT)
  201              CONTINUE
C
C                                           FOLLOWING ILLUSTRATION
C                                           BY ARTIST JAN OLSSON.
C                           N S E G
C                       --------------
C                       .     I     I
C                       .     I     I
C                       .  1  2  3  4
C                       .     I     I
C                       .     I     I
C           -------------------------------------
C           .           I           I           .
C           .           I           I           .
C           .     5     6     7     8     9     .
C           .           I           I           .
C           .           I           I           .
C           -------------------------------------
C           I           I           I           I
C           I           I           I           I
C          10    11     12    13    14    15    16
C           I           I           I           I
C           I           I           I           I
C           -------------------------------------
C     CELL AND WALL NUMBERING FOR TRACK DEFINITION
C
C  A SLOW TRACK IS DEFINED BY  1 - 5 - 10         (HFT = 0)
C  A FAST TRACK IS DEFINED BY  1 - 5 - 11, 1 - 5 - 12   ETC.   (HFT=1)
C
C   DEFINED BY ARRAY HFT(12,4)   1-4 GIVEN BY 1-4 IN RING 3
C   TRACKS DEFINED BY COINCIDENCE RING 1 - 3, GIVEN BY ARRAYS HR1,HR2
C
C
C  LOOP OVER INNER DETECTOR TRACK ELEMENTS FOR LINKING
C
      KA=1
      KF=1
      DO 400 NSEG=1,24
      NR3=96+(NSEG-1)*4
C  ARE THERE R3 TRACK ELEMENTS IN THIS SEGMENT
      IF((HJCTRK(NR3+1)+HJCTRK(NR3+2)+HJCTRK(NR3+3)+HJCTRK(NR3+4)).GT.0)
     *  GOTO 420
      KA=1
      KF=1
      GOTO 400
 420  CONTINUE
C
C  FILL 16 INPUTS OF FPLA FOR ONE STREET WITH TRACK ELEMENTS
C    HFPLA(1-4) :    RING3
C    HFPLA(5-9) :    RING2
C    HFPLA(10-16) :    RING1
C
C                           R3(1-4),R2(5-9),R1(10-16)
      NR2I=2*NSEG-4+48
      IF(NR2I.LE.48) NR2I=NR2I+48
        DO 403 N2=1,5
        NR2=NR2I+N2
        IF(NR2.GT.96) NR2=NR2-48
        IF(N2.NE.5) HFPLA(N2)=HJCTRK(NR3+N2)
  403   HFPLA(4+N2)=HJCTRK(NR2)
      NR1I=2*NSEG-5
      IF(NR1I.LE.0) NR1I=NR1I+48
        DO 404 N1=1,7
        NR1=NR1I+N1
        IF(NR1.GT.48) NR1=NR1-48
  404   HFPLA(9+N1)=HJCTRK(NR1)
C
C  PROOF FPLA CONDITIONS
        DO 401 ITYPE=1,4
        IF(HFPLA(ITYPE).EQ.0) GOTO 411
        H123A=0
        H123F=0
          DO 500 ICOND=1,12
          IF((ITYPE+ICOND).EQ.16) GOTO 500
          IF((HFPLA(HR2(ICOND,ITYPE))+HFPLA(HR1(ICOND,ITYPE))).EQ.2)
     *             H123A=1
          IF((HFPLA(HR2(ICOND,ITYPE))+HFPLA(HR1(ICOND,ITYPE)) +
     *             HFT(ICOND,ITYPE)).EQ.3) H123F=1
  500     CONTINUE
        IF((H123A+H123F).EQ.0) GOTO 411
C  TRACK FOUND THROUGH R1,R2,R3    KSEG DIVIDES DETECTOR IN 96 PARTS
        KSEG=(NSEG-1)*4+ITYPE
C
C  ADD TOF COUNTERS
C
             PHIJ=(360./96.)*KSEG
             DPHITO=360./42.
             ATOF=PHIJ/DPHITO+1.5001
             KTOF=ATOF
             KTOF=KTOF-KTOF/43*42
             KTP=KTOF+1-KTOF/42*42
             KTM=KTOF-1+(43-KTOF)/42*42
C            LOGIC OR OF 2 OR 3 TOF COUNTERS
             IF((ATOF-FLOAT(KTOF)).LT..001) KTP=KTM
             IF((ITOF(KTOF)+ITOF(KTP)+ITOF(KTM)).LT.1) GOTO 411
C  TRACKS GOES THROUGH FIRED TOF
  501 CONTINUE
C
C  COUNT TRACKS FOR ALL/HIGH MOMENTA AND CLASSIFY WITH SEGMENT IN R3
C    KA AND KF ARE 1 FIRST TIME, 0 FOLLING TIMES
C
      NJTRKA=NJTRKA+KA
      KA=1-KA
      HJTRKA(KSEG)=1
      IF(H123F.EQ.0) GOTO 412
      NJTRKF=NJTRKF+KF
      KF=1-KF
      HJTRKF(KSEG)=1
      GOTO 401
C  NO TRACKS FOUND, RESET KA,KF
  411 KA=1
  412 KF=1
  401 CONTINUE
  400 CONTINUE
C
C  FILL ARRAY HWORD WITH TRACK INFORMATION FOR LATER STORE IN TRIG:2
C    KWD = 3,7,11,15,19,23   KBIT = 1-16      ALL TRACKS
C    KWD = 4,8,12,16,20,24   KBIT = 1-16     FAST TRACKS
C
             DO 600 I=1,96
             KWD=(I-1)/16*4+3
             KBIT=I-(I-1)/16*16
         IF(HJTRKA(I).EQ.1) HWORD(KWD)=hLOR(HWORD(KWD),hint(MASK(KBIT))) ! PMF 10/06/99: hlor,hint 
      IF(HJTRKF(I).EQ.1)HWORD(KWD+1)=hLOR(HWORD(KWD+1),hint(MASK(KBIT))) ! PMF 10/06/99: hlor,hint 
  600        CONTINUE
C
C                                           CODE FOR NARROW COPLANARITY
C                                           CHECK LINKING TO FAST TRACKS
      ICOPLA = 0
      IF( NJTRKF .LE. 1 ) GO TO 790
        DO 700 I=1,72
        IF( HJTRKF(I) .EQ. 0 ) GO TO 700
        JLO = I + 48 - IWIDT2*2
        JHI = I + 48 + IWIDT2*2
          DO 700 J=JLO,JHI
          JOP = J
          IF(JOP.GT.96) JOP = JOP - 96
          IF( HJTRKF(JOP) .EQ. 0 ) GO TO 700
          ICOPLA = 1
          GO TO 790
  700   CONTINUE
  790 CONTINUE
C
 1000 CONTINUE
C
C  FILL BANK 'TRIG' NO.2      WITH CONTENT OF ARRAY HWORD
C
      CALL CCRE(IND2,'TRIG',2,13,IER)
      IF( IER .EQ. 2 ) GO TO 8000
      CALL MVCL( IDATA, IND2*4, IWORD, 0, 52 )
      IDATA(IND2+1) = LOR(IDATA(IND2+1),MASK2)
C
      CALL VZERO(IW22,8)
C
C  T2 LOGIC CONDITIONS ACCORDING TO T1 POSTPONE
C
      IT0=HDATA(IND1*2+8)
      IT1=HDATA(IND1*2+9)
      ICO1 = 0
      IW12 = 0
C
C--->>> 2-TRACK TRIGGERS
C
C              TOF AND TOTAL LG ENERGY
C
      IF(JBIT(IT1,1).EQ.1.AND.NJTRKA.GE.HACC1 ) ICO1= LOR(ICO1,MASK(1))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,1).EQ.1.AND.NJTRKA.GE.HACC1 ) IW12= LOR(IW12,MASK(1))
C
C                     TOF, ECAP1 + ECAP2
C
      IF(JBIT(IT1,3).EQ.1.AND.NJTRKA.GE.HACC1 ) ICO1= LOR(ICO1,MASK(1))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,3).EQ.1.AND.NJTRKA.GE.HACC1 ) IW12= LOR(IW12,MASK(2))
C
C              TBGNS
C
      IF(JBIT(IT1,4).EQ.1.AND.NJTRKA.GE.HACC2 ) ICO1= LOR(ICO1,MASK(1))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,4).EQ.1.AND.NJTRKA.GE.HACC2 ) IW12= LOR(IW12,MASK(3))
C
C--->>> 1-TRACK TRIGGERS
C
C              TBG AND BARREL LG ENERGY
C
      IF(JBIT(IT1,9).EQ.1.AND.NJTRKF.GE.HACC3)  ICO1=LOR(ICO1,MASK(3))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,9).EQ.1.AND.NJTRKF.GE.HACC3)  IW12=LOR(IW12,MASK(4))
C
C              TAGG AND TBG
C
      IF(JBIT(IT1,10).EQ.1.AND.NJTRKF.GE.HACC4) ICO1=LOR(ICO1,MASK(3))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,10).EQ.1.AND.NJTRKF.GE.HACC4) IW12=LOR(IW12,MASK(5))
C
C              COLL. SEPTANT + TOF
C
      IF(JBIT(IT1,11).EQ.1.AND.NJTRKA.GE.HACCB1) ICO1=LOR(ICO1,MASK(3))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,11).EQ.1.AND.NJTRKA.GE.HACCB1) IW12=LOR(IW12,MASK(9))
C
C              TAGG + SEPTANT + TOF
C
      IF(JBIT(IT1,12).EQ.1.AND.NJTRKA.GE.HACCB2) ICO1=LOR(ICO1,MASK(3))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,12).EQ.1.AND.NJTRKA.GE.HACCB2) IW12=LOR(IW12,MASK(10))
C
C--->>> 2-COLL.TRACK TRIGGERS
C
C              COPLANAR TOF, WIDE
C
      IF(JBIT(IT1,13).EQ.1.AND.ICOPLA.EQ.1)     ICO1=LOR(ICO1,MASK(4))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,13).EQ.1.AND.ICOPLA.EQ.1)     IW12=LOR(IW12,MASK(6))
C
C              COPLANAR TOF, NARROW
C
      IF(JBIT(IT1,14).EQ.1.AND.ICOPLA.EQ.1)     ICO1=LOR(ICO1,MASK(4))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,14).EQ.1.AND.ICOPLA.EQ.1)     IW12=LOR(IW12,MASK(7))
C
C              COPLANAR TBG
C
      IF(JBIT(IT1,15).EQ.1.AND.ICOPLA.EQ.1)     ICO1=LOR(ICO1,MASK(4))
      IF(IHIST(3).GT.1984.AND.
     $   JBIT(IT1,15).EQ.1.AND.ICOPLA.EQ.1)     IW12=LOR(IW12,MASK(8))
C -------------------------------------------
      IF( ICO1 .GT. 0 ) IW22(6) = 1
C
      DO 1100 IBIT=1,16
      IW22(4)=IW22(4)+JBIT(IT0,IBIT)
 1100 IW22(5)=IW22(5)+JBIT(IT1,IBIT)
      IF(IW22(4).GE.1) IW22(1)=1
      IF(IW22(4).EQ.0.AND.IW22(6).EQ.1) IW22(2)=1
C
C  FILL WORD 22 IN 'HEAD': ACTUAL ACC T1,T2,T3; ACTION T1ACC,T1POST,
C                          T2ACC,T2POST,  T3ACC
      K=IND0*2+22
      HDATA(K) = 0
      DO 1101 IBIT=1,8
      IF(IW22(IBIT).GE.1) HDATA(K)=hLOR(HDATA(K),hint(MASK(IBIT))) ! PMF 10/06/99: hlor,hint 
 1101 CONTINUE
C  FOR 1985-86 DATA, SET ALSO ENABLE BITS IN WORDS 37-38 OF HEAD
      IF(IHIST(3).LT.1985) GO TO 6670
      HDATA(IND0*2+37) = HT1ACC
      HDATA(IND0*2+38) = HT1PSP
      HDATA(IND0*2+1) = 3
6670  CONTINUE
C                                           FILL BEATES SPECIAL WORD
C                                           IN TRIG,1 SHOWING ACTUAL
C                                           T2 ACCEPT SOURCE
      HDATA(IND1*2+10) = hLOR(HDATA(IND1*2+10),hint(ICO1))        ! PMF 10/06/99: hlor,hint 
C                                           FILL T2 COINCIDENCES WORD
C                                           IN TRIG,1 SHOWING ACTUAL
C                                           T2 TRIGGER (ONLY 1985-86)
      IF(IHIST(3).GT.1984) HDATA(IND1*2+12) = IW12
C
      RETURN
C
C                                           NO SPACE IN BCS LEFT
 8000 WRITE(6,9101)
 9101 FORMAT(/' NOT ENOUGH SPACE IN BCS LEFT FOR CREATION OF TRIG, 2'/)
      RETURN
      END

CDECK  ID>, LEPAIR.
      PROGRAM LEPAIR
      IMPLICIT NONE
C
C  Simple lepton pair generator without any underlying physics.
C  Generates 4-vectors of back-to-back leptons in JADE MC /CPROD/ format.
C
C  08/11/2000 Pedro Movilla Fernandez
C
C  4-vector format for the JADE simulation program MCJADE
C  (see JADE Computer Note 69)
      REAL PP,PF,XM,XMF,BEAM,PT,THETA,PHI,PSTRT
      INTEGER NEV,NP,NC,NN,JCH,JTP,JP,NF,NCF,NNF,ICF,ITF,IFLAVR
      CHARACTER*16 CP,CF
      COMMON/CPROD/ NEV,BEAM,PT,PHI,THETA,IFLAVR,
     *        NP,NC,NN,PP(4,500),XM(500),JCH(500),JTP(500),JP(500,2),
     *        NF,NCF,NNF,PF(4,300),XMF(300),ICF(300),ITF(300),
     *        PSTRT(3,300)
      COMMON/CHCPRD/ CP(500),CF(300)
C  Stuff for FFREAD:
      INTEGER NAMLEN,NBYTEW,NWONAM
      PARAMETER( NAMLEN=80, NBYTEW=4, NWONAM=NAMLEN/NBYTEW )
      CHARACTER*(NAMLEN) CHEVFILE
      CHARACTER COPT*4
      INTEGER NEVENT,LTYP
      REAL CMS
C
      INTEGER HEVFILE(NWONAM),HOPT
      INTEGER I,IEVT,LUN,IERR,LENOCC,INDEX
      PARAMETER(  LUN=77 )
      REAL UMASS(3) / 0.0 , 0.511E-3 , 0.1057 /
      CHARACTER*16 LNAME(3) /'GAMMA','E','MU'/
      REAL RN,TWOPI,RPHI,RTH
      PARAMETER( TWOPI = 6.2831853 )
      CHARACTER C16*16,CFORM*12
Code:
C
C Initialize FFREAD
      CALL FFINIT(0)
      CALL FFSET('SIZE',8)
C
C Read FFREAD Cards
      NEVENT= 1000
      CALL FFKEY('NEVENT',NEVENT,1,'INTEGER')
      CMS= 35.0
      CALL FFKEY('CMS',CMS,1,'REAL')
      LTYP= 1
      CALL FFKEY('TYPE',LTYP,1,'INTEGER')
      CALL VBLANK(HEVFILE,NWONAM)
      CALL FFKEY('MCEVFILE',HEVFILE,NWONAM,'MIXED')
      CALL VBLANK(HOPT,1)
      CALL FFKEY('FORMAT',HOPT,1,'MIXED')
      CALL FFGO
C Check input
      IF (LTYP.LT.1.OR.LTYP.GT.2) THEN
         WRITE (*,'(A,I3,/A)') '...Wrong lepton flavour TYPE=,',LTYP
     >        ,'...Will stop now!'
         STOP
      ENDIF
      LTYP=LTYP+1
      WRITE(*,'(/,A,F7.3)') '> Center-of-mass energy:',CMS
      WRITE(*,'(A,I3)') '> Lepton flavour:',LTYP
C
C Output file
C     Format
      CALL UHTOC(HOPT,4,COPT,4)
      IF (INDEX(COPT,'A').NE.0) THEN
       WRITE (*,'(A)') '> Output of 4-vectors in readable ASCII format'
       CFORM='FORMATTED'
      ELSEIF (INDEX(COPT,'B').NE.0) THEN
       WRITE (*,'(A)') '> Output of 4-vectors in binary CPROD format'
       CFORM='UNFORMATTED'
      ELSE
         WRITE (*,FMT='('' COPT ='',A6,
     +        '' option unknown'')')  COPT
         STOP
      ENDIF
C     File name
      CALL UHTOC(HEVFILE,NBYTEW,CHEVFILE,NAMLEN)
      WRITE(*,'(A,A)') '> Output of 4-vectors to: '
     &     ,CHEVFILE(1:LENOCC(CHEVFILE))
      OPEN(UNIT=LUN,STATUS='NEW',FILE=CHEVFILE,FORM=CFORM)

C
C  Fill general stuff in common /CPROD/:
C
C     General info part
      PT=0.
      PHI=0.
      THETA=0.
      BEAM=CMS/2.0
C     Event flavour in Z0/gamma
      IFLAVR=0
C---  List of 'all' (final + intermediate)  particles
C     Total number of 'all' particles
      NP=2
      NN=0
      NC=2
      DO I=1,NP
C     Particle type (JADE convention)
         JTP(I)=LTYP
C     Parent and first daughter of the particle
         JP(I,1)=0
         JP(I,2)=0
C     Mass of the particle
         XM(I)=UMASS(LTYP)
      ENDDO
C Charges (e+e-, mu+mu-)
      JCH(1)=-1
      JCH(2)=1
C Flavour names
      CP(1)=LNAME(LTYP)(1:INDEX(LNAME(LTYP),' ')-1)//'-'
      CP(2)=LNAME(LTYP)(1:INDEX(LNAME(LTYP),' ')-1)//'+'
C---  List of 'final' (stable)  particles 
C     Number of charged/neutral particles
      NF=2
C     Number of charged/neutral particles in the 'final' list
      NNF=0
      NCF=2
C     Type/Mass/charge
      DO I=1,NF
         ITF(I)=JTP(I)
         XMF(I)=XM(I)
         ICF(I)=JCH(I)
         CALL UCOPY(PP(1,I),PF(1,I),4)
C     Origin of the particles in [mm]
         PSTRT(1,I)=0.
         PSTRT(2,I)=0.
         PSTRT(3,I)=0.
C     Flavour names
         CF(I)=CP(I)
      ENDDO
C
C     Dice the 4-vectors for NEVENT colinear lepton pairs
      DO IEVT= 1,NEVENT
C     /CPROD/ event counter
         NEV=IEVT
         CALL RANMAR(RN,1)
         RPHI=RN*TWOPI
         CALL RANMAR(RN,1)
         RTH=RN*TWOPI
C        -first particle
         PP(1,1)=BEAM*SIN(RTH)*SIN(RPHI)
         PP(2,1)=BEAM*SIN(RTH)*COS(RPHI)
         PP(3,1)=BEAM*COS(RTH)
         PP(4,1)=BEAM
         CALL UCOPY(PP(1,1),PF(1,1),4)
C        -second particle
         PP(1,2)=-PP(1,1)
         PP(2,2)=-PP(2,1)
         PP(3,2)=-PP(3,1)
         PP(4,2)=PP(4,1)
         CALL UCOPY(PP(1,2),PF(1,2),4)
C
C     Write out common /CPROD/
         IF (INDEX(COPT,'B').NE.0) THEN
C     - Binary format (JADE 'CPROD' format)
            CALL WRCPRD(LUN,IERR)
            IF( IERR.NE.0 ) GOTO 90
C     - Readable ASCII format 
         ELSE IF(INDEX(COPT,'A').NE.0) THEN
            CALL PRCPRD(LUN,IERR)
            IF( IERR.NE.0 ) GOTO 90
         ENDIF
      ENDDO
C
      WRITE (*,'(A,I8,1X,A,A)') '>',IEVT-1
     >     ,LNAME(LTYP)(1:INDEX(LNAME(LTYP),' ')-1),
     >     ' events generated succesfully!'
      CLOSE( LUN )
      STOP
 90   WRITE (*,'(A,I8,/A)') '...Error while writing out event!',IEVT
     >               ,'...Will stop now!'
      STOP
      END
CDECK  ID>, WRCPRD.
      SUBROUTINE WRCPRD(LUN,IERR)
      IMPLICIT NONE
*********************************************************************
*.
*.  Write out 4-vector information in a binary format 
*.  (JADE 'CPROD' format, see JADE Computer Note 69)
*.
*********************************************************************
C  4-vector format for the JADE simulation program MCJADE
C  (see JADE Computer Note 69)
      REAL PP,PF,XM,XMF,BEAM,PT,THETA,PHI,PSTRT
      INTEGER NEV,NP,NC,NN,JCH,JTP,JP,NF,NCF,NNF,ICF,ITF,IFLAVR
      CHARACTER*16 CP,CF
      COMMON/CPROD/ NEV,BEAM,PT,PHI,THETA,IFLAVR,
     *        NP,NC,NN,PP(4,500),XM(500),JCH(500),JTP(500),JP(500,2),
     *        NF,NCF,NNF,PF(4,300),XMF(300),ICF(300),ITF(300),
     *        PSTRT(3,300)
      COMMON/CHCPRD/ CP(500),CF(300)
      INTEGER I1,I2,I3,I4,I5,N,N2
      INTEGER LUN,IERR
Code:
      WRITE(UNIT=LUN,ERR=10,IOSTAT=IERR) 
     *     NEV, BEAM, PT, PHI, THETA, IFLAVR,
     *     NP, NC, NN, ( (PP(I4,N), I4=1,4), XM(N), JCH(N), JTP(N),
     *     (JP(N,I2), I2=1,2), N=1,NP),
     *     NF, NCF, NNF, ( (PF(I4,N2),I4=1,4), XMF(N2), ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
      RETURN
 10   WRITE(LUN,'(A,2I7)') ' WRCPRD: WRITE ERROR, NEV, IOSTAT=',NEV,IERR
      RETURN
      END
C
CDECK  ID>, PRCPRD.
      SUBROUTINE PRCPRD(LUN,IERR)
      IMPLICIT NONE
*********************************************************************
*.
*.  Print out 4-vector information in common /CPROD/ 
*.  in a readable format.
*.
*********************************************************************
C  4-vector format for the JADE simulation program MCJADE
C  (see JADE Computer Note 69)
      REAL PP,PF,XM,XMF,BEAM,PT,THETA,PHI,PSTRT
      INTEGER NEV,NP,NC,NN,JCH,JTP,JP,NF,NCF,NNF,ICF,ITF,IFLAVR
      CHARACTER*16 CP,CF
      COMMON/CPROD/ NEV,BEAM,PT,PHI,THETA,IFLAVR,
     *        NP,NC,NN,PP(4,500),XM(500),JCH(500),JTP(500),JP(500,2),
     *        NF,NCF,NNF,PF(4,300),XMF(300),ICF(300),ITF(300),
     *        PSTRT(3,300)
      COMMON/CHCPRD/ CP(500),CF(300)
      INTEGER I1,I2,I3,I4,I5,N,N2
      INTEGER LUN,IERR
Code:
      WRITE(LUN,'(/A,I8)') ' PRCPRD: Content of common /CPROD/ in event'
     *     ,NEV
      WRITE(LUN,'(/A6,I7,A6,F6.2,A8,I2)') 
     *     ' NEV=',NEV,' BEAM=',BEAM,' IFLAVR=',IFLAVR
      WRITE(LUN,'(A14,3F7.4)') ' PT/PHI/THETA=',PT, PHI, THETA
      WRITE(LUN,'(/A15,A10,3I4)') ' All particles:'
     *     ,' NP/NC/NN=',NP, NC, NN
      WRITE(LUN,'(T21,5A9,A5,A8,A6)') 
     *     'PP(1,I)','PP(2,I)','PP(3,I)','PP(4,I)','PP(5,I)'
     *     ,'JCH','JTP','JP'
      WRITE(LUN,'(I3,A17,5F9.3,I5,I8,2I4)')
     *     ( N,CP(N),(PP(I4,N), I4=1,4), XM(N), JCH(N), JTP(N),
     *     (JP(N,I2), I2=1,2), N=1,NP)
      WRITE(LUN,'(/A23,A13,3I4)') ' Final state particles:'
     *     ,' NF/NCF/NNF=',NF, NCF, NNF
      WRITE(LUN,'(T21,5A9,2A5,A21)') 
     *     'PF(1,I)','PF(2,I)','PF(3,I)','PF(4,I)','PF(5,I)'
     *     ,'ICF','ITF','PSTRT-X -Y -Z'
      WRITE(LUN,'(I3,A17,5F9.3,2I5,3F9.3)')
     *     (N2,CF(N2),(PF(I4,N2),I4=1,4), XMF(N2), ICF(N2),ITF(N2),
     *     (PSTRT(I3,N2),I3=1,3),N2=1,NF)
C     
      RETURN
      END
CDECK  ID>, INCPRD.
      SUBROUTINE INCPRD
      IMPLICIT NONE
*********************************************************************
*.
*.  Initialization of common /CPROD/ 
*.
*********************************************************************
C  4-vector format for the JADE simulation program MCJADE
C  (see JADE Computer Note 69)
      REAL PP,PF,XM,XMF,BEAM,PT,THETA,PHI,PSTRT
      INTEGER NEV,NP,NC,NN,JCH,JTP,JP,NF,NCF,NNF,ICF,ITF,IFLAVR
      CHARACTER*16 CP,CF
      COMMON/CPROD/ NEV,BEAM,PT,PHI,THETA,IFLAVR,
     *        NP,NC,NN,PP(4,500),XM(500),JCH(500),JTP(500),JP(500,2),
     *        NF,NCF,NNF,PF(4,300),XMF(300),ICF(300),ITF(300),
     *        PSTRT(3,300)
      COMMON/CHCPRD/ CP(500),CF(300)
Code:
      PT=0.
      PHI=0.
      THETA=0.
      NP=0
      NC=0
      NN=0
      NF=0
      NCF=0
      NNF=0
      CALL VZERO(PP,4*500)
      CALL VZERO(XM,500)
      CALL VZERO(JCH,500)
      CALL VZERO(JTP,500)
      CALL VZERO(JP,2*500)
      CALL VZERO(PF,4*300)
      CALL VZERO(XMF,300)
      CALL VZERO(ICF,300)
      CALL VZERO(ITF,300)
      CALL VZERO(PSTRT,3*300)
      CALL VBLANK(CP,4)
      CALL VBLANK(CF,4)
      RETURN
      END
C

C   07/06/96 606071833  MEMBER NAME  BSEP     (S4)          FORTG1
      SUBROUTINE BSEQ(MARK)
C     BOS SUBPROGRAM =3.9=
#include "acs.for"
      COMMON/BCS/IW(1)
      INTEGER LIMSEC/2/,LIMREC/0/,IUNIT/1/,NUNIT/0/,NUNITS(3)/3*0/
      IF(MARKWR.GE.0) GOTO 2
C     INITIALIZE
      I=JUHR(LIMSEC)
      NREC=0
      IUNIT=1
      KUNIT=1
      IF(NUNIT.NE.0) IUNIT=NUNITS(1)
      WRITE(6,101) IUNIT,LIMREC,LIMSEC
      MARKWR=0
    2 MARK=0
      IF(MARKWR.EQ.0) GOTO 20
C----- OUTPUT - WRITE LAST EVENT, IF MARKED
      CALL BSLW
      DO 14 I=1,MARKWR
      IUN=NOUT(I)
      IF(IUN.LE.0) GOTO 14
   10 CALL BWRS(IUN,NBUFL,INIW)
      IF(INIW.EQ.0) GOTO 12
      CALL WRFIX(IUN,NBUFL,IW(INIW))
      GOTO 10
   12 NOUT(I)=-IUN
   14 CONTINUE
C----- DELETE LAST EVENT AND MAKE GARBAGE COLLECTION
   20 CALL BSLT
      CALL BDLG
C----- CHECK TIME AND NR OF RECORDS
      IF(JUHR(LIMSEC).EQ.1) GOTO 22
      WRITE(6,102)
      CALL MSGTXT('TIMELIMIT')
      GOTO 40
   22 IF(LIMREC.EQ.0.OR.NREC.LT.LIMREC) GOTO 24
      WRITE(6,103)
      CALL MSGTXT('RECDLIMIT')
      GOTO 40
   24 NREC=NREC+1
C----- INPUT - READ NEXT EVENT
   30 MARKWR=0
   32 CALL BRDS(IUNIT,NBUFL,INIR)
      IF(INIR.EQ.0) GOTO 100
      CALL RDVAR(IUNIT,IW(INIR),IW(INIR+1),NBUFL)
      IF(IW(INIR).GE.0) GOTO 32
      WRITE(6,104) IUNIT
      IF(KUNIT.GE.NUNIT) GOTO 40
      REWIND IUNIT
      KUNIT=KUNIT+1
      IUNIT=NUNITS(KUNIT)
      WRITE(6,105) IUNIT
      GOTO 30
C----- END OF INPUT - WRITE LAST BUFFER
   40 CALL BMLT(0,DUMMY)
      IF(MARKWR.LE.0) GOTO 46
      DO 44 I=1,MARKWR
      IUN=IABS(NOUT(I))
      IF(IUN.EQ.0) GOTO 44
   42 CALL BWRS(IUN,NBUFL,INIW)
      IF(INIW.EQ.0) GOTO 44
      CALL WRFIX(IUN,NBUFL,IW(INIW))
   44 CONTINUE
C----- MARK END OF INPUT
   46 MARK=1
      MARKWR=-1
      NUNIT=0
      GOTO 100
C----- RETURN
      ENTRY BSEW(MARK)
C----- OUTPUT - DEFINE MARKER FOR OUTPUT
      IF(MARK.EQ.0) GOTO 100
      MARKA=IABS(MARK)
      IF(MARKWR.LE.0) GOTO 52
      DO 50 I=1,MARKWR
      IF(MARKA.EQ.IABS(NOUT(I))) GOTO 54
   50 CONTINUE
      IF(MARKWR.EQ.3) GOTO 100
   52 MARKWR=MARKWR+1
      IF(MARKWR.LE.0) MARKWR=1
      I=MARKWR
   54 NOUT(I)=MARK
      GOTO 100
C
      ENTRY BSET(MARK)
      LIMSEC=MARK
      GOTO 100
C
      ENTRY BSEL(MARK)
      LIMREC=MARK
      GOTO 100
C
      ENTRY ASVBS(MARK)
      ENTRY BSEU(MARK)
      IF(NUNIT.GE.3) GOTO 100
      NUNIT=NUNIT+1
      NUNITS(NUNIT)=MARK
  100 RETURN
  101 FORMAT('0++++ BSEQ START UNIT',I3,'   -  END WILL BE AFTER',I6,
     1   ' RECORDS OR',I3,' SECONDS BEFORE TIMEOVFL'/)
  102 FORMAT('0++++ BSEQ END OF READING  -  TIME LIMIT REACHED'/)
  103 FORMAT('0++++ BSEQ END OF READING  -  RECORD LIMIT REACHED'/)
  104 FORMAT('0++++ BSEQ                 -  END-OF-DATA ON UNIT',I3/)
  105 FORMAT('0++++ BSEQ START UNIT',I3/)
      END

C   18/02/81 203121800  MEMBER NAME  TFPLOT   (S)           FORTRAN
      SUBROUTINE TFUNPK(IPTOFR,LHIST)
C
C   LHIST=1 PRODUCES ALL HISTOGRAMS
C
#include "tcalcm.for"
      COMMON/POINT/IPHEAD,IPLTCH,IPT1,IPTOF,IPCLST,IPR,IPPATR,IPNT(12),
     1             IPBP
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/ENRGMG/BENGEV,BKGAUS,EGCOR
      COMMON/TOFHIT/XTOF(50),YTOF(50),ZTOF(50)
      COMMON/TRKINF/LTRK,DX1(10),DY1(10),DZ1(10),DXL(10),DYL(10),
     1            DZL(10),NXY(10),NRZ(10),CHIXY(10),ZPTOF(10),CHIRZ(10),
     2              X1(10),Y1(10),Z1(10),XL(10),YL(10),ZL(10),ZVER(10),
     3              NGOOD,IGOOD(10),PMOM(10),FI1(10),FIL(10),
     4              NFIN,ITRK1(10),ITRK2(10),RMIN(10)
      COMMON/TOFRES/TOFLGT(10),TDT(10),TDR(10),BETA(10),IQUAL(10)
     1          ,ITOFHT(10),PATH(10),MUCAND,IMUCND(10),NMU,IMUFIN(10)
     2          ,TAUMR(42),TAUPR(42)
      COMMON/TRACC/NACC,ALF(10),NMALF
      COMMON/DT4/NTGOOD(10),DDT1(10),DDT2(10),DDT3(10),DDT4(10)
      COMMON/BCS/IDATA(5000)
      COMMON/INOUT/WRITFL,EVWRIT
      COMMON/FLAGS/HISTFL,PRFL,NPRLIM
      LOGICAL WRITFL,EVWRIT,HISTFL,PRFL
      DIMENSION DATA(2000),KKREJ(10),JTRK(2)
      EQUIVALENCE(IDATA(1),DATA(1))
      DIMENSION RTOF(14,50),ITOF(14,50)
      EQUIVALENCE (RTOF(1,1),ITOF(1,1))
C
      DATA IBUG/30/,KBUG/ 0/,IENTRY/0/,JBUG/  0/,KERR/0/
      DATA LBUG/0/,NPRREJ/0/
      DATA CVEL/  2.997925E2 /,RADTOF/920./
C
      IF(IENTRY.NE.0)  GOTO  19
      IENTRY = 1
      CFIC = 3.142/12.
      CTOF = 6.284/42.
      CTOF2= CTOF/2.
      ZA = 1660.
      ZB = 5660.
C     CALL HDELET(0)
      CALL HBOOK1(3507,20HREJECT CODES       $,100,0.,100.)
      IF(LHIST.NE.1)  GOTO  19
      CALL HTABLE(1701,10HLAST CELL$,24,1.,25.,13,12.,25.,63.)
      CALL HTABLE(1702,20H  TOFCOUNTERS      $,22,0.,22.,22,20.,42.,63.)
      CALL HTABLE(1707,20H  TOFCOUNTERS      $,22,0.,22.,22,20.,42.,63.)
      CALL HBOOK1(1708,20H TOFCOUNTERS       $, 50,0.,50.)
      CALL HTABLE(1703,' TOF CNTR FLAG $',42,0.,42.,3,-1.,1.,511.)
      CALL HBOOK2(1704,20HT1 T2              $,40,-5.,15.,40,-5.,15.)
      CALL HBOOK1(1705,20HTDT                $,100,-10.,15.)
      CALL HBOOK2(1706,15HLTGOOD DT1800 $,100,-10.,15.,5,0.,5.)
      CALL HBOOK2(1710,15HDT1800 ITOF   $,100,-5.,15.,42,0.,42.)
      CALL HBOOK2(1711,15HTAUM   ITOF   $,100,-5.,15.,42,0.,42.)
      CALL HBOOK2(1712,15HTAUP   ITOF   $,100,-5.,15.,42,0.,42.)
      CALL HBOOK2(1720,' NRUN TM    $',100,ZA,ZB,40,0.,10.)
      CALL HBOOK2(1721,' NRUN TP    $',100,ZA,ZB,40,0.,10.)
C
   19 CONTINUE
      EVWRIT = .FALSE.
      CALL SETSL(KKREJ,0,40,0)
      MUCAND = 0
      NTR = IDATA(IPTOFR+1)
      CALL HF1(3507,20.,1.)
      KREJ = 70
      IF(NTR.LE.0) GOTO  60
      KREJ = 72
      CALL HF1(3507,22.,1.)
C
      IF(IBUG.LE.10) PRINT 106,NRUN,NEV,IEV,NTR,NOHIT
  106 FORMAT(' TOFKAW NTR',8I5)
C
      DO   1   N=1,50
      DO   1   I=1,14
      RTOF(I,N) = DATA(IPTOFR+4+(N-1)*14+I)
    1 CONTINUE
C
      KREJ = 74
      IF(NFIN.LT.1) GOTO  60
      CALL HF1(3507,23.,1.)
      IF(NTRK.GT.15) GOTO  60
      IF(NFIN.GT.10) NFIN = 10
      KREJ = 76
      CALL HF1(3507,24.,1.)
C

      CALL BHAREJ(IREJ,1)
      IF(IREJ.GT.0)  RETURN
      CALL HF1(3507,28.,1.)
C
      JBUG = JBUG + 1
      IMU = 0
      CALL ALPHA
      CALL SETSL(TOFLGT,0,4*92,0)
C
      DO   4   M=1,NFIN
      CALL HF1(3507,48.,1.)
      KKREJ(M) = 90
      I1 = ITRK1(M)
      I2 = ITRK2(M)
      P1 = ABS(PMOM(I1))
      P2 = ABS(PMOM(I2))
      IF(P1.LT.1..OR.P2.LT.1.)  GOTO  4
      CALL HFILL(1702,FLOAT(ITRC(I1)),FLOAT(ITRC(I2)))
      CALL HF1(3507,50.,1.)
C
      L1 = I1
      L2 = I2
C
      IF(L1.LE.0.OR.L2.LE.0)  GOTO  4
      CALL HF1(3507,54.,1.)
      KKREJ(M) = 91
      IF(ITOF(3,L1).LT.ITOF(3,L2))  GOTO  5
      J1 = I1
      I1 = I2
      I2 = J1
      J1 = L1
      L1 = L2
      L2 = J1
    5 CONTINUE
      ITRK1(M) = I1
      ITRK2(M) = I2
      IF(ITOF(1,L1).NE.I1.OR.ITOF(1,L2).NE.I2) GOTO  997
      CALL HF1(3507,56.,1.)
      KKREJ(M) = 92
C
      ITOF1 = ITOF(3,L1)
      ITOF2 = ITOF(3,L2)
      CALL HF1(3507,58.,1.)
      KKREJ(M) = 93
      KBUG = KBUG + 1
      IF(JBUG.LE.10) PRINT 108,NFIN,I1,I2,ITOF(2,I1),ITOF(2,I2)
  108 FORMAT(' NFIN,...',10I5)
      IF(ITOF1.GT.25)  PRINT 540
  540 FORMAT(' == TFUNPK == ITOF1 GT 25!!!'/)
      IF(ITOF1.GT.25)  CALL PRTOFR(IPTOFR)
      IF(ITOF1.GT.25)  GOTO  4
      KKREJ(M) = 94
C
C  CHECK QUALITY OF TOF DETERMINATION
C
       KKREJ(M) = 95
      CALL HFILL(1703,FLOAT(ITOF1),FLOAT(ITOF(2,L1)))
      CALL HFILL(1703,FLOAT(ITOF2),FLOAT(ITOF(2,L2)))
      IF(IABS(ITOF(2,L1)).NE.1)  GOTO  4
      IF(IABS(ITOF(2,L2)).NE.1)  GOTO  4
      CALL HF1(3507,60.,1.)
      IDTOF = IABS(ITOF1-ITOF2)
      KKREJ(M) = 96
      IF(IABS(IDTOF-21).GT.3)  GOTO  4
C
      PCOR1 = (RTOF(5,L1)-RADTOF)/CVEL
      PCOR2 = (RTOF(5,L2)-RADTOF)/CVEL
      T1 = RTOF(4,L1)-PCOR1
      T2 = RTOF(4,L2)-PCOR2
      TAUMR(ITOF1) = TAUM(ITOF1)-PCOR1
      TAUPR(ITOF1) = TAUP(ITOF1)-PCOR1
      TAUMR(ITOF2) = TAUM(ITOF2)-PCOR2
      TAUPR(ITOF2) = TAUP(ITOF2)-PCOR2
      DT1= ABS(TAUP(ITOF2)-TAUP(ITOF1))
      DT2= ABS(TAUM(ITOF2)-TAUM(ITOF1))
      DT3= ABS(TAUP(ITOF2)-TAUM(ITOF1))
      DT4= ABS(TAUM(ITOF2)-TAUP(ITOF1))
      LTGOOD = 0
      IF(DT1.LT.4.) LTGOOD = LTGOOD+1
      IF(DT2.LT.4.) LTGOOD = LTGOOD+1
      IF(DT3.LT.4.) LTGOOD = LTGOOD+1
      IF(DT4.LT.4.) LTGOOD = LTGOOD+1
      CALL HF1(3507,FLOAT(LTGOOD)+70.,1.)
      IF(ITOF(2,L1)*ITOF(2,L2).LT.0)
     *CALL HF1(3507,FLOAT(LTGOOD)+80.,1.)
      PATH1= RTOF(5,L1) + RTOF(5,L2)
      KKREJ(M) = 97
      IF(PATH1.LE.1.)  GOTO  4
      IF(JBUG.LE.10) PRINT 109,M,ITOF1,ITOF2,T1,T2,RTOF(5,L1),RTOF(5,L2)
  109 FORMAT('   ITOF1,2,...',3I5,8F10.2)
      DT1800 = T2-T1
      IF(LHIST.EQ.1) CALL HFILL(1706,DT1800,FLOAT(LTGOOD),1.)
      IF(LHIST.EQ.1) CALL HFILL(1710,DT1800,FLOAT(ITOF1),1.)
      IF(LHIST.EQ.1) CALL HFILL(1704,T1,T2,1.)
      IF(LHIST.EQ.1) CALL HF1(1705,DT1800,1.)
      IF(DT1800.LE.4.5) CALL HF1(3507,62.,1.)
      IF(LTGOOD.GE.2) CALL HF1(3507,64.,1.)
C
C   SPECIAL CUT FOR PLOCUT
C
      IF(ABS(T1-5.).GT.15.)  GOTO  4
      IF(ABS(T2-5.).GT.15.)  GOTO  4
      IF(DT1800.GT.4.5.AND.LTGOOD.LT.1)  GOTO  4
C
C CALCULATE WHICH CELL LAST POINT IS IN
      IC1 = FIL(I1)/CFIC+1
      IC2 = FIL(I2)/CFIC+1
      CALL HFILL(1701,FLOAT(IC1),FLOAT(IC2))
      CALL HF1(1708,FLOAT(ITOF1),1.)
      CALL HF1(1708,FLOAT(ITOF2),1.)
      CALL HFILL(1707,FLOAT(ITOF1),FLOAT(ITOF2))
      CALL HFILL(1711,TAUMR(ITOF1),FLOAT(ITOF1))
      CALL HFILL(1711,TAUMR(ITOF2),FLOAT(ITOF2))
      CALL HFILL(1712,TAUPR(ITOF1),FLOAT(ITOF1))
      CALL HFILL(1712,TAUPR(ITOF2),FLOAT(ITOF2))
      CALL HFILL(1720,FLOAT(NRUN),TAUMR(ITOF1))
      CALL HFILL(1720,FLOAT(NRUN),TAUMR(ITOF2))
      CALL HFILL(1721,FLOAT(NRUN),TAUPR(ITOF1))
      CALL HFILL(1721,FLOAT(NRUN),TAUPR(ITOF2))
C
    7 IMU = IMU + 1
      IF(IMU.GT.10)  GOTO  4
      KKREJ(M) = 98
      TDT(IMU) = DT1800
      IMUCND(IMU) = M
      NTGOOD(IMU) = LTGOOD
      DDT1(IMU) = DT1
      DDT2(IMU) = DT2
      DDT3(IMU) = DT3
      DDT4(IMU) = DT4
C
      TDR(I1) = T1
      TDR(I2) = T2
      ITOFHT(I1) = ITOF1
      ITOFHT(I2) = ITOF2
      TOFLGT(I1) = RTOF(4,L1)
      TOFLGT(I2) = RTOF(4,L2)
      PATH(I1) = RTOF(5,L1)
      PATH(I2) = RTOF(5,L2)
      BETA(I1) = RTOF(6,L1)
      BETA(I2) = RTOF(6,L2)
      IQUAL(I1) = ITOF(2,L1)
      IQUAL(I2) = ITOF(2,L2)
    4 CONTINUE
C
      MUCAND = IMU
      IF(IMU.GT.0) EVWRIT = .TRUE.
      IF(IMU .GT.0) KREJ = 80
      IF(EVWRIT) CALL HF1(3507,40.,1.)
      CALL HF1(200,FLOAT(IMU)+50.,1.)
C
   60 CONTINUE
      IF(MUCAND.LE.0) NPRREJ = NPRREJ + 1
      IF(MUCAND.LE.0.AND.NPRREJ.LE. 0)
     1  PRINT 701,NRUN,IEV,NEV,KREJ,KKREJ
  701 FORMAT(' REJECTED TFUNPK ',3I6,5X,I2,5X,10I3)
C
      RETURN
  997 CONTINUE
      KERR = KERR + 1
      IF(KERR.GT.20) RETURN
      PRINT 118
  118 FORMAT(' ERROR IN TOFR BANK')
      RETURN
      END

C   06/12/79 102191154  MEMBER NAME  ERRORM   (PATRECSR)    FORTRAN
      SUBROUTINE ERRORM(SUBR,NERROR,NT)
      IMPLICIT INTEGER*2(H)
      REAL*8 SUBR
      COMMON/CADMIN/IEVTP,NREC,NRWRIT,NRERR
      COMMON/CHEADR/HEAD(17),HRUN,HEV
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
C
C
C-----------------------------------------------------------------------
C
C         -------------- SUBROUTINE ERRORM  ------------------
C         --- G.F.PEARCE .. LAST UPDATE : 1200 ON  6/12/80 ---
C
C     THIS SUBROUTINE PRINTS OUT A SINGLE LINE ERROR MESSAGE
C     REQUIRED :
C     SUBR   = ALPHANUMERIC SUBROUTINE NAME (8 BYTES) IN WHICH ERROR
C              OCCURRED (E.G. 'XYFIT   ')
C     NERROR = ERROR IDENTIFICATION NUMBER
C     NT     = TRACK NUMBER ON WHICH ERROR OCCURED
C
C-----------------------------------------------------------------------
C
C
      IXYF(11) = IXYF(11) - 1
      IF(IXYF(11).LT.0)RETURN
      PRINT1,SUBR,NERROR,NREC,HRUN,HEV,NT
 1    FORMAT(1X,20('#'),A8,' ERROR MESSAGE ',I3
     +  ,'  RECORD/RUN/EVENT/TRACK =',4I6,1X,20('#'))
      IF(IXYF(11).EQ.0)PRINT2
 2    FORMAT(1X,20('$'),' ERRORM ERROR MESSAGES NOW SUSPENDED')
      RETURN
      END

C   14/10/82            MEMBER NAME  BSCOM11  (S)           FORTRAN77
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------900000200
C     10.  BANKS ON DIRACT ACCESS DATA SETS
C
C     THE DIRECT ACCESS BOS ROUTINES ALLOW TO STORE BANKS ON A DIRECT
C     ACCESS DATA SET, CALLED DADS, AND, IN THE SAME JOB OR IN A LATER
C     JOB, TO GET THE BANKS BACK TO THE COMMON/BCS/ OR TO DELETE BANKS
C     ON THE DADS (SEE CH. 11.2). THE ROUTINES USE THE IBM-FORTRAN
C     DIRECT ACCESS FEATURES (E.G. DEFINE FILE), THEY WORK WITH
C     RECORDS OF FIXED LENGTH 1610 WORDS, HOWEVER THE BANKS MAY HAVE
C     ANY LENGTH BETWEEN 1 WORD AND 3200 WORDS.
C     THE DADS HAS TO BE INITIALIZED (SEE CH 11.1) BEFORE THE FIRST
C     BANK IS ADDED TO THE DADS.
C
C
C     11.1  INITILIZATION OF A DADS
C
C     A DADS IS INITIALIZED BY THE FOLLOWING STATEMENTS, USING THE
C     DD-CARD SHOWN.
C
C          DEFINE FILE IU(NREC,1610,U,IVAR)
C          CALL BINLDA(IU,NREC)
C
C     //FTIUF001 DD DSN=DSNAME,DISP=(NEW,CATLG),UNIT=FAST,
C     //   SPACE=(6440,(NREC))
C
C          WHERE    IU = (CONSTANT) FORTRAN=NR. OF THE DADS, EQUAL
C                        TO 17, 18 OR 19
C                 NREC = (CONSTANT) NR OF RECORDS, OF LENGTH 1610 WORDS
C                 IVAR = DUMMY VARIABLE
C               DSNAME = DSNAME OF THE DADS
C

C   01/03/80 003061155  MEMBER NAME  PRBOSB   (JADEGS)      FORTRAN
      SUBROUTINE PRBOSB(IPOINT)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      WRITE(6,100) IDATA(IPOINT-3)
  100 FORMAT(1H0,'BANK ',A4,' INTEGER*2, INTEGER*4 AND REAL*4',//)
      LENG=IDATA(IPOINT)
      IPNH=2*IPOINT
      LENH=2*LENG
      WRITE(6,101) (HDATA(IPNH+LHO-8),LHO=1,8)
  101 FORMAT(1X,I12,7I6)
      LINES=1+(LENH-1)/20
      DO 1 LINE=1,LINES
      LIML=20*(LINE-1)+1
      LIMU=20*LINE
      IF(LIMU.GT.LENH) LIMU=LENH
      WRITE(6,102) LIML,(HDATA(IPNH+LHO),LHO=LIML,LIMU)
  102 FORMAT(1X,I6,I12,19I6)
    1 CONTINUE
      WRITE(6,103) (IDATA(IPOINT+LHO-4),LHO=1,4)
  103 FORMAT(1H0,4I12,/)
      LINES=1+(LENG-1)/10
      DO 2 LINE=1,LINES
      LIML=10*(LINE-1)+1
      LIMU=10*LINE
      IF(LIMU.GT.LENG) LIMU=LENG
      WRITE(6,104) LIML,(IDATA(IPOINT+LHO),LHO=LIML,LIMU)
  104 FORMAT(1X,I6,10I12)
    2 CONTINUE
      WRITE(6,103) (IDATA(IPOINT+LHO-4),LHO=1,4)
      LINES=1+(LENG-1)/10
      DO 3 LINE=1,LINES
      LIML=10*(LINE-1)+1
      LIMU=10*LINE
      IF(LIMU.GT.LENG) LIMU=LENG
      WRITE(6,105) LIML,(ADATA(IPOINT+LHO),LHO=LIML,LIMU)
  105 FORMAT(1X,I6,10E12.4)
    3 CONTINUE
      RETURN
      END

C   13/02/81 102141841  MEMBER NAME  COMPR2   (S)           FORTRAN
      SUBROUTINE COMPR2(NRUN)
      IMPLICIT INTEGER*2 (H)
      COMMON/TFPRM/ NRNC1,NRNC2,DYC(4),IFLC(42),CM(42),CP(42),
     -DTAU(42),WM(42),WP(42),SV(42),DM(42),DP(42),PEDLM(42),PEDLP(42)
      DIMENSION CNEW(378),COLD(378),IDIF(378)
      DATA IENTRY/0/
C
      DO   1   N=1,378
      IDUM = 0
      IF(N.GT.84) IDUM = 42
      CNEW(N) = CM(N+IDUM)
    1 CONTINUE
C
      IF(IENTRY.EQ.0)  GOTO  10
      NDIF = 0
      DO   2   I=1,378
      IDIF(I) = 0
      IF(ABS(CNEW(I)-COLD(I)).LE..001)  GOTO  2
      NDIF = NDIF + 1
      IDIF(NDIF) = I
    2 CONTINUE
      IF(NDIF.LE.0)  GOTO  10
      PRINT 103,NRUN,NDIF
  103 FORMAT(1X,100('=')/' CONST CHANGE AT RUN ',I5,I10,' CHANGES'/)
      PRINT 100,((IDIF(I),COLD(IDIF(I)),CNEW(IDIF(I))),I=1,NDIF)
  100 FORMAT(1X, 5(I5,2F7.1,2X))
      PRINT 104
  104 FORMAT(1X,100('='))
C
   10 CALL UCOPY(CNEW,COLD,378)
      IENTRY = IENTRY + 1
      IF(IENTRY.NE.1) RETURN
      PRINT 101,NRUN
      PRINT 102,CM
      PRINT 102,CP
      PRINT 102,WM
      PRINT 102,WP
      PRINT 102,SV
      PRINT 102,DM
      PRINT 102,DP
      PRINT 102,PEDLM
      PRINT 102,PEDLP
  102 FORMAT(/(1X,10F10.3))
  101 FORMAT(' CALIBRATION CONSTANTS FOR RUN (COMPR2) ',I5)
C
      RETURN
      END

C   18/07/85 507221511  MEMBER NAME  RESMAC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RESMAC( CHARS, NEXFLD )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY  18/07/85 :  RESTORE THE PREVIOUS MACRO
C
C
C     THIS ROUTINE RESTORES 1 LEVEL OF MACRO NESTING. LEVEL 1 IS THE
C     COMMAND LINE THAT CALLED THE MACRO. CHARS CONTAINS THE RESTORED
C     COMMAND LINE AND NEXFLD IS THE FIELD NUMBER OF THE NEXT COMMAND.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS(80)
      LOGICAL*1  CDEF
C
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
C------------------  C O D E  ------------------------------------------
C
      MACDEP = MACDEP - 1
C
      IPNT   = MACPNT(1,MACDEP)
      NEXFLD = MACPNT(2,MACDEP)
C
      DO  20  I = 1,80
        CHARS(I) = CDEF(I,IPNT)
  20  CONTINUE
      RETURN
      END

C   07/06/96 606071847  MEMBER NAME  HISTPS   (S4)          FORTG1
      SUBROUTINE HISTPS(F,N,AW,ST)
C
C     PRINT AN ARRAY OF UP TO 100 REAL VALUES AS A SMOOTHED HISTOGRAM
C                 - - -- --
C     CALL HISTPR(F,N,AW,ST)
C
C        WHERE F( ) = ARRAY OF N REAL VALUES
C              AW   = LOWEST CHANNEL LEFT EDGE
C              ST   = CHANNEL WIDTH
C
C
      REAL F(100),G(100)
      REAL*8 RPR(11)
      REAL*4 SP(11)
      COMMON/CCONVT/JM,PX(32,20)
      INTEGER PX,BLANK/'    '/
      LOGICAL*1 LX(128,20),XCH/'X'/
      EQUIVALENCE (LX(1,1),PX(1,1))
      XM=0.0
      NN=MIN0(100,N)
      CALL SMHIST(F,G,DY,NN,0)
      DO 10 I=1,NN
   10 XM=AMAX1(XM,G(I))
      IF(XM.LE.0.0) GOTO 23
      IF(XM.LE.20.0) GOTO 12
      FAC=20.0/XM
      JM=20
      GOTO 14
   12 FAC=1.0
      JM=XM+0.5
   14 DO 16 I=1,32
      DO 16 J=1,20
   16 PX(I,J)=BLANK
      DO 20 I=1,NN
      K=G(I)*FAC+0.5
      IF(K.EQ.0) GOTO 20
      JA=JM+1-K
      DO 18 J=JA,JM
   18 LX(I+8,J)=XCH
   20 CONTINUE
      WRITE(6,101)
      DO 22 J=1,JM
   22 WRITE(6,101) (PX(I,J),I=1,32)
      DO 123 I=1,NN
      NR=G(I)+0.5
  123 G(I)=NR
      CALL PVERT(G(1),NN,-5)
   23 CALL PVERT(F(1),NN,5)
      DO 24 I=1,11
   24 SP(I)=AW+ST*10.0*FLOAT(I-1)
      CALL BFMT(SP,11,RPR,TA)
      WRITE(6,102) TA,RPR
  100 RETURN
  101 FORMAT(3X,32A4)
  102 FORMAT(1X,A4,1X,11(A8,2X)/)
      END

C   07/06/96 606071826  MEMBER NAME  BOOKEE   (S4)          FORTRAN
      SUBROUTINE BOOKEE
C
C     ENTRY AT END OF EVENT
C
      COMMON/BCS/IW(1)
      INTEGER IBS(3)/3*0/,INB(3)
      INTEGER NRUNS(15),NR/0/,NLN/50/,IDAT/0/
      REAL*8 DATE(2)
      LOGICAL*1 LD(8),LN(4)
      EQUIVALENCE (DATE(1),LD(1)),(NN,LN(1))
      LOGICAL CURR/.FALSE./
      IF(CURR) GOTO 2
      CURR=.TRUE.
      IBS(1)=IBLN('BOOK')
      IBS(2)=IBLN('BKST')
      IBS(3)=IBLN('HEAD')
C
C     FIND INDICES FOR BANKS (NAME(I),0) AND DETERMINE RUN NUMBER
C
    2 DO 8 I=1,3
      INB(I)=0
      IND=IBS(I)+1
    4 IND=IW(IND-1)
      IF(IND.EQ.0) GOTO 8
      IF(IW(IND-2)) 4,6,8
    6 INB(I)=IND
    8 CONTINUE
      IF(INB(3).EQ.0) GOTO 100
      NRUN=IW(INB(3)+1)
C
C     COMPARE BANKS (BOOK,0) AND (BKST,0)
C
   10 IF(INB(1).EQ.0) GOTO 14
      IF(INB(2).EQ.0) GOTO 30
      N =IW(INB(1))
      IF(IW(INB(2)).NE.N) GOTO 20
      DO 12 I=1,N
      IF(IW(INB(1)+I).NE.IW(INB(2)+I)) GOTO 20
   12 CONTINUE
      GOTO 50
   14 IF(INB(2).EQ.0) GOTO 100
C
C     CONTENTS ARE NOT IDENTICAL / PRINT RUN NUMBERS
C
   20 IF(NR.EQ.0) GOTO 30
      IF(NLN.LE.0) GOTO 22
      WRITE(6,103) (NRUNS(I),I=1,NR)
      NLN=NLN-1
      IF(NLN.EQ.0) WRITE(6,105)
   22 NR=0
C
C     STORE NEW CONTENT
C
   30 IND=INB(2)
      IF(IND.EQ.0) GOTO 32
      IF(INB(1).EQ.0) GOTO 31
      IF(IW(IND).EQ.IW(INB(1))) GOTO 34
   31 CALL BDLS('BKST',0)
      IF(INB(1).EQ.0) GOTO 100
   32 CALL BCRE(IND,'BKST',0,IW(INB(1)),&100,IER)
   34 N=IW(IND)
      DO 36 I=1,N
   36 IW(IND+I)=IW(INB(1)+I)
C
C     PRINT NEW CONTENT
C
   40 IF(NLN.EQ.0) GOTO 48
      JND=IND
      N=N/4
      DO 42 I=1,N
      IF(IW(JND+1).EQ.0) GOTO 44
   42 JND=JND+4
   44 JA=IND+1
      WRITE(6,101)
   46 JB=MIN0(JA+11,JND)
      WRITE(6,102) (IW(J),J=JA,JB)
      NLN=NLN-1
      JA=JB+1
      IF(JA.LT.JND) GOTO 46
      WRITE(6,102)
      NLN=NLN-1
      IF(NLN.GT.0) GOTO 48
      NLN=0
      WRITE(6,105)
   48 NR=0
C
C     CHECK NEW RUN NR AND STORE, IF DIFFERENT
C
   50 IF(NR.EQ.0) GOTO 56
      IF(NRUNS(NR).EQ.NRUN) GOTO 100
   52 IF(NR.LT.15) GOTO 56
      IF(NLN.LE.0) GOTO 54
      WRITE(6,103) (NRUNS(I),I=1,NR)
      NLN=NLN-1
      IF(NLN.EQ.0) WRITE(6,105)
   54 NR=0
   56 NR=NR+1
      NRUNS(NR)=NRUN
      GOTO 100
C
C
C
      ENTRY BOOKEJ
C
C     ENTRY AT JOB END
C
   60 IF(NR.EQ.0) GOTO 100
      IF(NLN.LE.0) GOTO 62
      WRITE(6,103) (NRUNS(I),I=1,NR)
      NLN=NLN-1
      IF(NLN.EQ.0) WRITE(6,105)
   62 NR=0
      GOTO 100
C
C
C
      ENTRY BOOKPR(NLINES)
C
C     ENTRY TO ALLOW NLINES OF PRINTOUT
C
   70 NLN=MAX0(0,NLINES)
      IF(IDAT.NE.0) GOTO 74
      CALL DAY(DATE(1),DATE(2))
      IDAT=0
      DO 72 I=1,3
      II=9-3*I
      DO 72 J=1,2
      LN(4)=LD(II+J)
   72 IDAT=IDAT*10+NN-240
   74 WRITE(6,104) NLN,IDAT
C
C
C
  100 RETURN
  101 FORMAT('0EVENT STATUS    ',
     1   3('    PGMNAME VERSION     PROC.DATE  '))
  102 FORMAT(' ....',12X,3(4X,2A4,I7,I14,2X))
  103 FORMAT(' .... IN RUNS  ',15I7)
  104 FORMAT('0EVENT STATUS    ',I7,' LINES OF PRINTOUT ALLOWED',
     1    55X,'TODAY IS',I7/)
  105 FORMAT('0EVENT STATUS    ',7X,'   PRINTOUT SUPPRESSED'/)
      END

C   07/06/96 606071831  MEMBER NAME  BRDS     (S4)          FORTRAN
      SUBROUTINE BRDS(IUN,NBUFL,INIR)
C     BOS SUBPROGRAM =3.4=
      EXTERNAL BINP
#include "acs.for"
      COMMON/BCS/IW(1)
      INTEGER HIDD/'HIDD'/
C
C     BUFFER FOR INPUT = BANK ('+BUF',IUN), LENGTH = 10 + NRECL
C
C     IBF+ 1   =1 (INPUT)
C          2   BUFFER SIZE USED
C          3   NR OF IO-ERRORS
C          4   NR OF RECORDS
C          5   NR OF EVENTS ACCEPTED
C          6   NR OF EVENTS, WHICH ARE TOO LARGE
C          7   SUM OF NR OF WORDS IN ALL EVENTS
C          8   MAX NR OF WORDS IN AN EVENT
C          9   LIMIT FOR NR OF ERRORS
C         10   POINTER WITHIN RECORD TO NEXT EVENT
C         ----------------
C         11   NTOT (= NR OF WORDS IN THE RECORD FOLOWING)
C         12   RECORD
C          .   . . .
C          .   . . .
C
C     LOCATE BUFFER BANK
   10 IF(IBFI.EQ.0) IBFI=IBLN('+BUF')+1
      IBF=IBFI
    2 IBF=IW(IBF-1)
      IF(IBF.EQ.0)        GOTO    94
      IF(IW(IBF-2)-IUN) 2,4,94
    4 IF(IW(IBF+1).EQ.1) GOTO 12
      ICOND=23
      CALL BDMP
   12 IF(IW(IBF+10)) 20,14,30
C     CHECK FREE SPACE
   14 IF(NFRE.EQ.0) GOTO 90
      CALL BGAR(IGA)
      GOTO 10
C     NEW RECORD IN BUFFER
   20 IF(IW(IBF+11).GT.0) GOTO 22
C     READ ERROR
      IW(IBF+3)=IW(IBF+3)+1
      ITREC=1
      IF(IW(IBF+3).LE.IW(IBF+9)) GOTO 90
      ICOND=21
      CALL BDMP
C     NO READ ERROR
   22 IPREC=ITREC
      ITREC=0
      IW(IBF+4)=IW(IBF+4)+1
      IF(IW(IBF).EQ.11) GOTO 23
C     BUFFER USED, CHECK LENGTH
      IF(IW(IBF+11)+11.GT.IW(IBF)) GOTO 24
      GOTO 25
C     NO BUFFER USED
   23 IF(NEXT+IW(IBF+11).LT.NLST) GOTO 25
C     RECORD TOO LONG
   24 ICOND=22
      CALL BDMP
C     RESET POINTER
   25 IW(IBF+10)=12
      INDH=IBF+IW(IBF+10)
      IF(IW(INDH).EQ.HIDD) GOTO 29
C     FULL RECORD (NO LSB-RECORD)
      LENG=IW(IBF+11)
      IF(LENG.LT.4) GOTO 80
      IC=0
      IW(IBF+10)=0
      IF(LIC.EQ.0) GOTO 28
C     ERROR, HIDD WAS EXPECTED
      NER(7)=NER(7)+1
   26 IF(NEXT+IW(IBF+11).LT.NLST) GOTO 27
      IW(IBF+6)=IW(IBF+6)+1
      LIC=0
      GOTO 12
   27 CALL UCOPY2(IW(IBF+12),IW(NEXT),IW(IBF+11))
   28 NEXTA=NEXT
      CALL BFRR(LENG,AR)
      GOTO 71
C     LSB-RECORD
   29 IW(IBF+2)=MAX0(IW(IBF+2),IW(IBF+11)+1)
      IF(IW(IBF).NE.11) GOTO 32
      CALL BCHM(IBF,IW(IBF+2)+9,IER)
      IF(IER.EQ.0) GOTO 32
      GOTO 96
C     OLD RECORD OF LSB TYPE
   30 INDH=IBF+IW(IBF+10)
      IF(IW(INDH).NE.HIDD) GOTO 80
      LIC=0
C
   32 LENG=IW(INDH+3)-1
      IF(LENG.LT.4) GOTO 80
      IC=IW(INDH+4)
      IF(IC.LT.0.OR.IC.GT.3) GOTO 80
C     CHECK LENGTH OF RECORD
      IF(IW(IBF+10)+LENG-7.NE.IW(IBF+11)) GOTO 34
      IW(IBF+10)=0
      GOTO 40
   34 IW(IBF+10)=IW(IBF+10)+LENG+5
      IF(IW(IBF+10).GT.IW(IBF+11)+8) GOTO 80
C     CHECK NEW IC / LAST IC
   40 IF(IC-1) 42,44,46
   42 IF(LIC) 54,60,54
   44 IF(LIC) 50,52,50
   46 IF(LIC) 56,56,60
   50 NER(6)=NER(6)+1
   52 IF(IW(IBF+10).NE.0) GOTO 80
      GOTO 60
   54 NER(7)=NER(7)+1
      GOTO 60
   56 NER(8)=NER(8)+1
      GOTO 12
C
   60 IF(IC.EQ.0.OR.IC.EQ.1) NEXTI=NEXT
      IF(NEXTI+LENG.LT.NLST) GOTO 62
      IW(IBF+6)=IW(IBF+6)+1
      LIC=0
      GOTO 12
   62 CALL UCOPY2(IW(INDH+5),IW(NEXTI),LENG)
      NEXTI=NEXTI+LENG
      IF(IC.EQ.1.OR.IC.EQ.2) GOTO 92
C     NEW EVENT COMPLETE
   70 NEXTA=NEXT
      IF(IC.GE.2.AND.IPREC.NE.0) GOTO 56
      LEV=NEXTI-NEXT
      CALL BFRR(LEV,AR)
   71 NEXTB=NEXT
      LEV=NEXTB-NEXTA
      IF(LEV.GT.0) GOTO 72
      GOTO 12
   72 IW(IBF+5)=IW(IBF+5)+1
      IW(IBF+7)=IW(IBF+7)+LEV
      IW(IBF+8)=MAX0(IW(IBF+8),LEV)
      INIR=0
      GOTO 100
C     WRONG RECORD
   80 NER(9)=NER(9)+1
C     NEW INPUT REQUIRED
   90 IC=0
      IF(IW(IBF).EQ.11) GOTO 91
      CALL BCHM(IBF,11-IW(IBF),IER)
      IF(IER.NE.0) GOTO 96
      CALL BCHM(IBF,0,IER)
      IF(IER.NE.0) GOTO 96
      CALL BGAR(IGA)
      CALL BLOC(IBF,'+BUF',IUN,&96)
      GOTO 92
   91 CALL BCHM(IBF,0,IER)
      IF(IER.NE.0) GOTO 96
   92 IW(IBF+10)=-1
      LIC=IC
      INIR=IBF+11
      NBUFL=IW(IBF)-10
      IF(NBUFL.GT.1) GOTO 100
      NBUFL=NLST-NEXT
      GOTO 100
   94 CALL BCRE(IBF,'+BUF',IUN,11,&96,IER)
      IW(IBF+1)=1
      IW(IBF+2)=0
      IW(IBF+9)=10
      ITREC=0
      GOTO 12
   96 ICOND=12
      CALL BDMP
  100 RETURN
      END

C   07/06/96 606071853  MEMBER NAME  KBN      (S4)          FORTG1
      FUNCTION KBN(X,XAR,NB)
      REAL XAR(1)
      KBN=0
      NL=1
      NH=NB
      NF=NH
      IF(X.LT.XAR(NL)) GOTO 100
      IF(X.GE.XAR(NH)) GOTO 30
   10 NF=(NL+NH)/2
      IF(NL.EQ.NF) GOTO 30
      IF(X.LT.XAR(NF)) GOTO 20
      NL=NF
      GOTO 10
   20 NH=NF
      GOTO 10
   30 KBN=NF
  100 RETURN
      END

C   11/10/79 002232100  MEMBER NAME  HWORLD   (JADESR)      FORTRAN
      SUBROUTINE HWORLD(IPLG,JEMPTY,UNBAL)
C
C      SUM UP LEAD GLASS ENERGIES IN 12 DIFFERENT HALF-WORLDS AND SET
C      THE NUMBER JEMPTY = NR OF EMPTY HALFWORLDS
C      THE NUMBER UNBAL = SMALLEST RATIO BETWEEN OPPOSITE HALFWORLDS
C      IPLG = ADDRESS OF LEADGLASS BANK IN /BCS/
C                     J.OLSSON 11.10.79 (AFTER AN IDEA OF W.BARTEL)
C                     LAST CHANGE:       23.02.80
C
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CHEADR/ HEAD(108)
      COMMON /CWORK/ SUM12(12),SUMWRD(12)
C
C  THE FOLLOWING ARRAY GIVES HELP INDICES FOR THE ENDCAP BLOCKS
C  A ROUGH DIVISION INTO 12 SECTORS CAUSES A ENDCAP BLOCK TO BELONG TO
C  ONE OR AT MOST TWO (NEIGHBOURING) SECTORS
C
      DIMENSION HELP(2,96)
      DATA HELP /1,0,1,2,2,3,3,0,1,0,1,2,2,0,2,3,3,0,1,0,1,0,1,2,
     1           2,3,3,0,3,0,1,0,1,0,1,2,2,0,2,0,2,0,2,3,3,0,3,0,
     2           4,0,4,5,5,6,6,0,4,0,4,5,5,0,5,6,6,0,4,0,4,0,4,5,
     3           5,6,6,0,6,0,4,0,4,0,4,5,5,0,5,0,5,0,5,6,6,0,6,0,
     4           7,0,7,8,8,9,9,0,7,0,7,8,8,0,8,9,9,0,7,0,7,0,7,8,
     5           8,9,9,0,9,0,7,0,7,0,7,8,8,0,8,0,8,0,8,9,9,0,9,0,
     6 10,0,10,11,11,12,12,0,10,0,10,11,11,0,11,12,12,0,10,0,10,0,10,11,
     7 11,12,12,0,12,0,10,0,10,0,10,11,11,0,11,0,11,0,11,12,12,0,12,0/
      DATA EMIN /50./
C
      JEMPTY = 0
      UNBAL = 1.E+06
      DO 1 I=1,12
      SUMWRD(I)=0.
    1 SUM12(I)=0.
C
C      GET LEAD GLASS ADRESSES
C
      NWO=IDATA(IPLG)
      IF(NWO.GT.3) GO TO 2
      WRITE(6,101) HEAD(18),HEAD(19)
101   FORMAT(' NO LEAD GLASS HITS IN RUN AND EVENT ',2I10)
      GO TO 999
2     IPLG2=2*IPLG + 8
      NWO=IPLG2+2*NWO-8
C
C     CALCULATE ROW , RING , ENDCAP ENERGIES
C
      ETOT = 0.
      DO 10 IJK=IPLG2,NWO,2
      IADR=HDATA(IJK-1)
      ETOT = ETOT + HDATA(IJK)
      IF(IADR.GT.2687) GO TO 11
C ROW NUMBER   0 - 83
      IROW = IADR/32
C SECTOR NUMBER   1 - 12    ( EACH SECTOR HAS 7 ROWS )
      IND12 = IROW/7 + 1
      SUM12(IND12) = SUM12(IND12) + HDATA(IJK)
      GO TO 10
  11  IADR = IADR - 2687
      IF(IADR.GT.96) IADR = IADR - 96
      IF(IADR.GT.96) GO TO 10
      IADDE = HDATA(IJK)
      IF(HELP(1,IADR).NE.0.AND.HELP(2,IADR).NE.0) IADDE = IADDE/2
      DO 12  II = 1,2
      IND12 = HELP(II,IADR)
12    IF(IND12.NE.0) SUM12(IND12) = SUM12(IND12) + IADDE
  10  CONTINUE
C
C      CALCULATE ENERGY ASYMMETRY, MEASURED BY NUMBER OF EMPTY H-WORLDS
C      A HALF-WORLD CONSISTS OF ANY CONSECUTIVE 6 SECTORS
C      CALCULATE ALSO RATIO BETWEEN OPPOSITE HALFWORLDS
C
      DO 13  II = 1,12
      VAR = 0.
      DO 16 JJ = 1,6
      KK = II + JJ - 1
      IF(KK.GT.12) KK = KK - 12
16    VAR = VAR + SUM12(KK)
      SUMX = ETOT - VAR
      IF(SUMX.LT.VAR.AND.VAR.GT.0.) RATIO = SUMX/VAR
      IF(SUMX.GT.VAR.AND.SUMX.GT.0.) RATIO = VAR/SUMX
      IF(RATIO.LT.UNBAL) UNBAL = RATIO
13    SUMWRD(II) = VAR
      DO 14  II = 1,12
14    IF(SUMWRD(II).LT.EMIN) JEMPTY = JEMPTY + 1
999   RETURN
      END

C   08/06/86 810171936  MEMBER NAME  WELCME   (S)        M  FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE WELCME
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   8/06/86 :  BEGINS GRAPHICS PROGRAM DIALOGUE
C
C
C
C     HANDLES THE OPENING PLEASANTRIES OF THE GRAPHICS PROGRAM.
C     BASED ON CODE FROM GPHMAIN BY J. OLSSON AND L. O'NEILL.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8    DATE,TIME
      INTEGER*4 BINTIM
C
      COMMON / CGAMOD / MODEGA, GAHEX
      COMMON / CWORK  / DATE, TIME, DUMMY, ITIME, HWORK(40), HNAM(8)
C
      DIMENSION  HTM1(4), HTM2(4)
      DIMENSION  HNAME(4)
C
      EQUIVALENCE  ( DATE, HTM1(1) )
      EQUIVALENCE  ( TIME, HTM2(1) )
C
      EQUIVALENCE  ( HNAM(1), HNAME(1) )
C
      DATA  HBLANK /'  '/
C
C------------------  C O D E  -----------------------------------------
C
      CALL TRMOUT(80,'                J A D E  Interactive Graphics Prog
     +ram  Vs. 17. October   1988^')
      CALL TRMOUT(80,' ^')
C
C                            CLEAR NAME STRING
C
      DO  10  I = 1,8
        HNAM(I) = HBLANK
  10  CONTINUE
C
C                            FIND USERID
C
      CALL IDFUN(HNAME,NBOK)
C
C                            FIND TIME OF DAY
C
      ITIME = BINTIM(DUMMY)/360000
C
C                           GREET THE USER ACCORDING TO TIME OF DAY
C
      IF( ITIME .LT. 12 ) WRITE(6,20) (HNAM(IS),IS=1,5)
      IF( ITIME .GE. 12  .AND. ITIME .LT. 18 )
     +                    WRITE(6,30) (HNAM(I),I=1,5)
      IF( ITIME .GE. 18 ) WRITE(6,40) (HNAM(IS),IS=1,5)
C
  20  FORMAT('           Good Morning, ',4A2,'  Great to see you again '
     +,A2/)
  30  FORMAT('         Good Afternoon, ',4A2,'  Nice to see you again ',
     +A2/)
  40  FORMAT('           Good Evening, ',4A2,'   Working late again ? ',
     +A2/)
C
C                            WRITE OUT THE LATEST NEWS
C
      CALL NOTICE
C
C                            FIND DATE AND TIME STRINGS
C                            EQUIVALENCED TO HTM1 AND HTM2
C
      CALL DAY(DATE,TIME)
C
      DO  50  I = 1,4
        HWORK(I) = HTM1(I)
  50  CONTINUE
C
      HWORK(5) = HBLANK
      DO  60  I = 1,4
        HWORK(I+5) = HTM2(I)
  60  CONTINUE
C
      WRITE(6,70) (HWORK(I),I=1,9)
  70  FORMAT(' Scan Session Beginning at DATE and TIME: ',9A2)
C
      RETURN
      END

C   27/08/79 C9082901   MEMBER NAME  STWADD   (JADENS)      FORTRAN
      SUBROUTINE STWADD(IUNIT,*)
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
#include "cdata.for"
      COMMON/CBSTR/MODE
      CALL BREAD(IUNIT,&1000,&1000)
      CALL CLOC(IND,'+BUF',IUNIT)
      IF(IND.GT.0) GO TO 3
      WRITE(JUSCRN,100)
  100 FORMAT(' STWADD FAILS TO FIND +BUF BANK. PROGRAMMED STOP.')
      STOP
    3 MODE=2
      IF(IDATA(IND).EQ.11) MODE=0
      IF(MODE.EQ.0) WRITE(JUSCRN,101)
      IF(MODE.EQ.2) WRITE(JUSCRN,102)
  101 FORMAT(' *** OUTPUT MODE IS BOS S. ***')
  102 FORMAT(' *** OUTPUT MODE IS BOS M. ***')
      REWIND IUNIT
      CALL BDLS(+BUF,IUNIT)
      NREC=0
    1 CONTINUE
      READ(IUNIT,ERR=1000,END=2000) IDUMMY
      NREC=NREC+1
      GO TO 1
 1000 CONTINUE
      RETURN 1
 2000 CONTINUE
      REWIND IUNIT
      IF(NREC.LT.1) RETURN
      DO 2 IREC=1,NREC
      READ(IUNIT,ERR=1000,END=1000) IDUMMY
    2 CONTINUE
      RETURN
      END

C   13/10/83 310222221  MEMBER NAME  MUENDP   (JADEMUS)     FORTRAN
C
C LAST CHANGE 22.00 22/10/83 HUGH MCCANN .
C             10.00 14/10/83 HUGH MCCANN .
C
      SUBROUTINE MUENDP(JCEPT,IRONRG,FACSTP)
C
C        THIS ROUTINE ENSURES THAT TRACKS 'SEE' THE REAL THICKNESS
C        OF THE YOKE END PLATES. THEY ARE SET TO BE 340 MM THICK IN
C        MUREG, BUT IN FACT THE THICKNESS VARIES WITH THE DISTANCE
C        FROM THE BEAM LINE AS FOLLOWS :
C        (A)
C                   RADIUS < INNER RADIUS OF COIL , T = 340 MM
C                             ( RCOILI = 968 MM )
C            THIS COINCIDES WITH THE DEFINITION OF'END PLUG' IN MUFFLE
C            AND USES THE SAME FICTITIOUS THICKNESS AS IS USED THERE.
C            ( SEE BLOCK DATA FOR CMUFFL ).
C
C        (B)
C        RCOILI <   RADIUS <   END PLUG COLLAR OUTER RADIUS , T = 290 ;
C                               (  FLOAT(IREP4) = 1400. MM )
C           THIS IS ALSO A FICTITOUS THICKNESS, FOR THE SAME REASON AS
C           ABOVE. THE REAL THICKNESS IS 340 MM. THE POSSIBILITY THAT
C           THE TRACK MIGHT LEAVE THE IRON THRO' THE CYLINDER
C           X**2+Y**2=(COLLAR OUTER RADIUS) IS ALSO TAKEN INTO ACCOUNT.
C
C        (C)
C        1400.  <   RADIUS   , T = 210 MM  .  AT LAST , A REAL THICKNESS
C                                             VIZ. ACTUAL YOKE END PLATE
C
C
      IMPLICIT INTEGER*2 (H)
C
#include "cmuffl.for"
#include "cmufwork.for"
#include "cmureg.for"
#include "cmucalib.for"
      DATA THICK/290./
      COLLAR=FLOAT(IREP4)
      ZLIMEP=FLOAT(IZOEP5)
C
      FACSTP=1.
      ZENTER=ZRLO(IRONRG)
      IF(HRFACE(IRONRG).EQ.5)  ZENTER=ABS(ZRHI(IRONRG))
C
C       IF THE CURRENT STEP BRINGS THE TOTAL Z TRAVERSAL OF THE END
C       PLATE TO LESS THAN THE SMALLEST THICKNESS ( THE OUTER LIMIT OF
C       WHICH IS ZLIMEP ) , THEN NO MODIFICATION OF THE STEP
C       IS NEEDED.  I.E. GO TO 100 WITH FACSTP = 1.   .
C
      IF(  ABS(CINT(3,JCEPT)).LT.ZLIMEP  )   GO TO 100
C
C              CHECK THAT THE STARTING POINT OF THE STEP IS IN IRON.
           RSTART=SQRT( X**2 + Y**2 )
           IF( RSTART.LT.RCOILI )  GO TO 20
               IF( RSTART.GT.COLLAR )  GO TO 10
C                    IN THE COLLAR REGION.
                   IF( ABS(Z).LT.(ZENTER+THICK) )  GO TO 20
                       FACSTP=0.
                       GO TO 100
C                   BARE END PLATE REGION.
   10          IF( ABS(Z).LT.ZLIMEP )  GO TO 20
                   FACSTP=0.
                   GO TO 100
C
C               THE STARTING POINT IS IN IRON.  NOW CHECK END POINT.
   20      REND=SQRT(   CINT(1,JCEPT)**2  +  CINT(2,JCEPT)**2   )
           IF( REND.LT.RCOILI )  GO TO 100
C                 DISTANCE ALONG TRACK FROM CURRENT POSITION (X,Y,Z)
C                 TO EXIT FROM THE IRON IS ESTEP.
C                 IF DSTEP </= ESTEP , NO MODIFICATION NEEDED.
               IF( REND.GT.COLLAR )  GO TO 40
                  ESTEP= (ZENTER+THICK-ABS(Z))/ABS(DCZ)
                  GO TO 80
   40          ESTEP= (ZLIMEP-ABS(Z))/ABS(DCZ)
C                 IT IS POSSIBLE THAT THE TRACK WILL ACTUALLY LEAVE
C                 THE IRON THRO' THE CYLINDER X**2 + Y**2 = COLLAR.
               CSTEP=COLLAR/SQRT(1.00001-DCZ**2) - SQRT(X**2+Y**2+Z**2)
               IF(CSTEP.GT.ESTEP)  ESTEP=CSTEP
C
   80          IF( ESTEP.LT.DSTEP )  FACSTP=ESTEP/DSTEP
C
  100 RETURN
      END

C   07/06/96 606071858  MEMBER NAME  NEWOLD2  (S4)          FORTRAN
      SUBROUTINE BINT(NA,NB,NC,ND)
C     BOS SUBPROGRAM =1.1=
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1,
     9        NDUMMY(20)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      COMMON/CCS/IUND,INDT,INDC,NPT,INDA,LISTE(5),IPAS
      REAL*8 DATE(2)
      EXTERNAL UCOPY2,BRNM,BCHM,BPOS,BSAW,BDLS,BDLG,BDMP,BCHL,CCHL
      LOGICAL INIT/.FALSE./
C
C     LAYOUT OF BANK COMMON/BCS/
C
C     INDEX    IW( )             I   MEANING
C     ------------------------------------------------------
C         1    IW(1)             I+  POINTER TO FIRST BANKS
C         .    ...               I
C     NAMAX    IW(NAMAX)         I
C      NFRS    SPACE FOR BANKS   I+  BANK SPACE
C              ...               I
C      NLST    SPACE FOR BANKS   I
C              NALIST(1)         I+  LIST OF NAMES
C              ...               I
C     ISLST    NALIST(NLIST)     I
C              NSLIST(1)         I+  SPECIAL LIST OF NAMES
C              ...               I
C     IMLST    NSLIST(NLIST)     I
C              NMLIST(1)         I+  MARKER FOR SPECIAL LIST
C              ...               I
C              NMLIST(NLIST)     I
C     INAMV    NAME              I+  NAME
C              NAMES(1)          I+  NAMES
C              ...               I
C     IOLST    NAMES(NAMAX)      I
C              IOLIST(1)         I+  IO-MARKER
C              ...               I
C     IPLST    IOLIST(NAMAX)     I
C              IK(1)             I+  POINTER FOR NAMES
C              ...               I
C              IK(NAMAX)         I
C              IK(NAMAX+1)       I
C              ...               I
C     NLAST    IK(NAMAX+NPRIM)   I
C
C
      IF(INIT) GOTO 100
      INIT=.TRUE.
      CALL VZERO(ICOND,100)
      CALL VZERO(IUND,11)
      NDUMMY(11)=6
      NLAST=NA
      NLAST1=NLAST
      CALL VZERO(IW,NLAST)
      NRECL=4000
      IF(NB.GT.0) NRECL=NB
      NDUMP=500
      IF(NC.GT.0) NDUMP=NC
      NDUMP1=NDUMP
      NSPL=NLAST/10
      IF(ND.GT.0) NSPL=ND
      CALL DAY(DATE(1),DATE(2))
      NZT=NTIME(DUMMY)
      WRITE(6,101) DATE,NLAST,NRECL,NDUMP,NSPL
      NAMAX=200
      NLIST=100
      NERRL=10
      NEOTP=2
      MARKWR=-1
      GOTO 10
C
      ENTRY BINT1(NA,NB,NC,ND)
C
      NAMAX=MAX0(10,NA)
      NLIST=MAX0(10,NB)
      NERRL=MAX0( 0,NC)
      NEOTP=ND
      WRITE(6,102) NAMAX,NLIST,NERRL,NEOTP
C
   10 NPRIM=(NAMAX/2)*2-1
   12 NPRIM=NPRIM+2
      J    =SQRT(FLOAT(NPRIM))
      DO 14 K=3,J,2
      L    =NPRIM/K
      IF(L*K.EQ.NPRIM) GOTO 12
   14 CONTINUE
C
      NAMAX1=NAMAX+1
      IPLST=NLAST-NAMAX-NPRIM
      IOLST=IPLST-NAMAX
      INAMV=IOLST-NAMAX
      IMLST=INAMV-NLIST-1
      ISLST=IMLST-NLIST
      NFRS =NAMAX1
      NEXT =NFRS
      NLST =ISLST-NLIST
      ILOW=NLST
      GOTO 100
C
  100 RETURN
C
  101 FORMAT(/'0START/BANK ORGANISATION PROGRAM   -   JOB DATE ',A8,
     1   ' TIME ',A8/'0',6X,'CALL BINT(',I6,',',5X,'NR OF WORDS IN'
     2 ,' COMMON/BCS/'/17X,I6,',',5X,'MAX NR OF WORDS ALLOWED IN A ',
     3   'BANK-RECORD'/17X,I6,',',5X,'NR OF WORDS PRINTED IN A DUMP'/
     4   17X,I6,')',5X,'NR OF WORDS FOR LOW PRIORITY BANK SPACE'/)
  102 FORMAT('0',5X,'CALL BINT1(',I6,',',5X,'MAX NR OF NAMES'/
     1  17X,I6,',',5X,'MAX LENGTH OF LIST OF NAMES'/
     2  17X,I6,',',5X,'MAX NR OF READ ERRORS'/
     3  17X,I6,')',5X,'MAX NR OF LISTINGS FOR INPUT-BANK ERRORS'/)
      END
      SUBROUTINE BDMPA(IARG)
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1,
     9        NDUMMY(20)
      ICOND=IARG
      CALL BDMP
      RETURN
      END
      SUBROUTINE PRINTA(BIN,NA,NB)
C
C     BAS13     SUBROUTINE PRINTA
C
C
C     PRINTA PRINTS THE ARRAY BIN(NA) TO BIN(NB). LINES WITH ALL
C     ZEROS ARE SUPPRESSED, FORMAT IS CHOOSEN FOR EACH WORD ACCORDING
C     TO THE CONTENT (I.E. A, F(E) OR I FORMAT).
C     PRINTING IS TO UNIT NUNTB, DEFINED IN COMMON/ACS/
C     FOR NUNTB = 0 OR NEGATIVE PRINTOUT IS SUPPRESSED.
C
C                 --- -- --
C     CALL PRINTA(BIN,NA,NB)
C
C     --------------------------------------------------------------
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1,
     9   JNAM,NLK,NLM,ILKNA,ILKIN,ILKND,LKNAME,LKNR,ICUST,IREV,
     *   NUNTB,DUMMY(9)
C     --------------------------------------------------------------
      COMMON/BCS/IW(1)
C     --------------------------------------------------------------
      REAL*8 FMT(13),FMTF/'  F12.4,'/,FMTG/'  G12.4,'/,
     1     FMTI/'    I12,'/,FMTA/'  8X,A4,'/,FMT1/'        '/,
     2     FMT2/'(11X,   '/
      REAL*8 FMZ(11)
      REAL*4 BIN(2)
      INTEGER NEQ/0/,LIM(2,8),IUNITP/6/
      LOGICAL*1 LFMT(96),LL(8),LAST/')'/
      DATA FMT(1)/'(1X,I5, '/,FMT(2)/''' -'',I3,'/
      DATA LIM/75,80,91,97,107,111,123,136,
     1     193,201,209,217,226,233,240,249/
      EQUIVALENCE(FMT(1),LFMT(1)),(LL(1),REQ),(LL(5),NEQ)
      EQUIVALENCE (FMT(3),FMZ(1))
      IUNITP=NUNTB
      IF(IUNITP.LE.0.OR.IUNITP.GT.99) GOTO 100
      IF(NA.GT.NB) GOTO 100
C
C
C
      IZERO=0
      NTEN=10
      NF=((NA-1)/10)*10+1
      IF(NA.LE.0) NF=1
      IF(NA.LT.0.AND.NA.GT.(-10)) NTEN=-(-10/NA)*NA
      N=NB+1-NF
C
C     LOOP OVER ARRAY IN UNITS OF 10 WORDS
C
      DO 60 I=NF,NB,NTEN
      IA=I
      IB=MIN0(I+NTEN-1,NB)
      IF(IB.EQ.NB) GOTO 4
      DO 2 J=IA,IB
      IF(BIN(J).NE.0) GOTO 4
    2 CONTINUE
      IF(IZERO.EQ.0) IZERO=IA
      GOTO 60
    4 IF(IZERO.EQ.0) GOTO 8
      WRITE(IUNITP,101) IZERO
      IZERO=0
    8 M=3
      DO 50 J=IA,IB
      REQ=BIN(J)
      M=M+1
      LA=0
C
C     CHECK WETHER ALL 4 BYTES CONTAIN PRINTABLE CHARACTERS
C
      DO 20 K=1,4
      LL(8)=LL(K)
      IF(NEQ.EQ.64) GOTO 20
      DO 10 L=1,8
      IF(NEQ.LT.LIM(1,L)) GOTO 40
      IF(NEQ.GT.LIM(2,L)) GOTO 10
      IF(L.LE.4) LA=LA+1
      GOTO 20
   10 CONTINUE
      GOTO 40
   20 CONTINUE
C
C     ALLOW ONLY ONE SPECIAL CHARACTER
C
      IF(LA.GT.1) GOTO 40
      FMT(M)=FMTA
      GOTO 50
C
C     CHOOSE F(E) OR INTEGER FORMAT ACCORDING TO VALUE
C
   40 IF(ABS(REQ).GT.1.E20.OR.ABS(REQ).LT.1.E-20) GOTO 30
      IF(ABS(REQ).LT.10000.0.AND.ABS(REQ).GE.0.1) GOTO 45
      FMT(M)=FMTG
      GOTO 50
   45 FMT(M)=FMTF
      GOTO 50
   30 FMT(M)=FMTI
   50 CONTINUE
      LFMT(8*M)=LAST
      IF(N.LT.10) GOTO 55
      FMT(3)=FMT1
      JB=MOD(IB,1000)
      WRITE(IUNITP,FMT) IA,JB,(BIN(II),II=IA,IB)
      GOTO 60
   55 FMT(3)=FMT2
      WRITE(IUNITP,FMZ) (BIN(II),II=IA,IB)
   60 CONTINUE
C
C
C
  100 RETURN
  101 FORMAT(1X,I5,2X,'AND FOLLOWING ALL ZERO')
      END

C   07/06/96 606071805  MEMBER NAME  BDLS     (S4)          FORTG1
      SUBROUTINE BDLS(NAME,NR)
C     BOS SUBPROGRAM =1.13=
#include "acs.for"
      COMMON/BCS/IW(1)
*** PMF      INTEGER IHELP(2)/'BNK '/
*** PMF 07/05/99
      INTEGER IHELP(2)/'BNK ','    '/
*** PMF (end)
#include "star.for"
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAME),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 3
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)        GOTO    100
      IF(IW(LFDI-2).LT.NR) GOTO 2
      IF(IW(LFDI-2).GT.NR) GOTO    100
      NN=4+IW(LFDI)
      IW(LFDK-1)=IW(LFDI-1)
      IW(LFDI)=-NN
      IF(LFDI+NN-3.NE.NEXT) GOTO 4
C     LAST BANK
      NEXT=NEXT-NN
      GOTO 6
C     NOT LAST
    4 NFRE=NFRE+NN
      ILOW=MIN0(ILOW,LFDI)
C     LOW PRIORITY
    6 INAME=NAME
      IF(NOTLOW(XNAME)) GOTO 100
      NCPL=NCPL-NN
      GOTO 100
C
      ENTRY BPRS(NAME,NR)
      CALL BLOC(IND,NAME,NR,&100)
      ISAVE=IW(IND+1)
      IW(IND+1)=IND
      IHELP(2)=NA
      CALL UTP(IHELP,5,'NAME  NR PTR  NWINDX')
      CALL UWP(IW(IND-3),1,5)
      IW(IND+1)=ISAVE
      CALL UWP(IW(IND+1),1,IW(IND))
  100 RETURN
      END

C   18/05/79 006251731  MEMBER NAME  VERTEX   (JADEGS)      FORTRAN
      SUBROUTINE VERTEX
C*800623*DITTMANN****************************************************
C*                                                                  *
C*             X - Y - Z   V E R T E X   F I T                      *
C*                                                                  *
C*       INPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)            *
C*       ================                                           *
C*       NT    = TOTAL NR OF TRACKS OF EVENT                        *
C*       IT(1) =         FLAG (0 = TRACK INCOMPLETE OR BAD, NOT USED*
C*                             1 = GOOD, BUT DO NOT USE IN VERTEXFIT*
C*                             2 = GOOD)                            *
C*       T( 2) = +-R     RADIUS(+ MEANS ANTICLOCKWISE LOOKING TO -Z)*
C*          3  = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          4  = THETA   POLAR ANGLE TO XY-PLANE(0=VERTICAL TO BEAM)*
C*          5  = XT      .                                          *
C*          6  = YT      . FIRST MEASURED POINT ON TRACK            *
C*          7  = ZT      .                                          *
C*          8  = DPHI    ERROR OF PHI                               *
C*          9  = DTHETA  ERROR OF THETA                             *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         13  = NPT     NUMBER OF POINTS ON TRACK (INTEGER)        *
C*         14  = 0.      NOT USED ON INPUT                          *
C*         15  = 0.      NOT USED ON INPUT                          *
C*         16-30         FOR INTERNAL USE (SEE BELOW)               *
C*        (31-60)        2. TRACK                                   *
C*         .....         ........                                   *
C*                                                                  *
C*       OUTPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)           *
C*       =================                                          *
C*       FOR TRACKS WITH IT(1) GT 0                                 *
C*       IT(1) =         FLAG (3 = TRACK WAS USED IN VERTEXFIT)     *
C*       T( 3) = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          5  = XT      .                                          *
C*          6  = YT      . POINT ON TRACK NEAREST TO VERTEX         *
C*          7  = ZT      .                                          *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         14  = NV      NUMBER OF VERTEX TO WHICH TRACK BELONGS (I)*
C*         15  = S       EXTRAPOLATED ARC LENGTH (USUALLY NEGATIVE) *
C*       ALL OTHER T'S ARE UNCHANGED                                *
C*                                                                  *
C*       NV    = TOTAL NUMBER OF VERTICES                           *
C*       IV(1) =         FLAG (0 = NO VERTEX FIT                    *
C*                             1 = BAD VERTEX FIT                   *
C*                             2 = VERTEX OF 1- OR COLLINEAR 2-PRONG*
C*                             3 = GOOD VERTEX FIT                  *
C*                             4 = E+E- PAIR VERTEX                 *
C*                             5 = ISOLATED SINGLE TRACK VERTEX)    *
C*       V( 2) = X       .                                          *
C*          3  = Y       . VERTEX COORDINATES                       *
C*          4  = Z       .                                          *
C*          5  = DX      .                                          *
C*          6  = DY      . ERROR OF X,Y,Z                           *
C*          7  = DZ      .                                          *
C*       IV(8) = NTR     NUMBER OF TRACKS USED IN VERTEX FIT        *
C*       V( 9) = CHI2    CHISQARE OF FIT (N.D.F. = 2*NTR-3)         *
C*       IV(10)= NTRALL  NUMBER OF TRACKS BELONGING TO THIS VERTEX  *
C*        (11-20)        2. VERTEX                                  *
C*         .....         .........                                  *
C*                                                                  *
C*       INTERNAL PARAMETERS                                        *
C*       ===================                                        *
C*       IT(1) IS SET NEGATIV TEMPORARILY IF TRACK BELONGS TO VERTEX*
C*       T(16) = COULOMB SCATTERING ERROR                           *
C*       T(17) =                                                    *
C*       T(21) = SIN(PHI0)                                          *
C*       T(22) = COS(PHI0)                                          *
C*       T(23) = TAN(THETA)                                         *
C*       T(24) = COS(THETA)                                         *
C*       T(26) = S TO TANKWALL FAR                                  *
C*       T(27) = S TO TANKWALL NEAR                                 *
C*       T(28) = S.D. X                                             *
C*       T(29) = S.D. Y                                             *
C*       T(30) = S.D. Z                                             *
C*                                                                  *
C*       THIS ROUTINE CALLS SUBROUTINE SMINVD FOR SOLVING THE       *
C*       MATRIX EQUATION                                            *
C********************************************************************
      COMMON /CWORK1/ NT,T(1500),NV,V(200),A(55),B(10),NTIND(7),S(7),
     *                CHITR(7)
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
      REAL*8 A,B,DET
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR
C
      IF(NV.LE.0 .OR. NV.GT.20) RETURN
      LV = (NV-1)*10
      IV(LV+1) = 0
      IF(NT.LE.0) RETURN
    1 ITER = 0
      CHI2 = 0.
      ITFIN = 0
C****    CHECK TRACKS
C****    IF MORE THAN 7, REJECT THOSE WITH FEWEST MEASURED POINTS
      N = 0
      J = 0
      DO 5 I=1,NT
      IF(IT(J+1).LE.1) GOTO 5
      N = N + 1
      IF(N.GT.7) GOTO 2
      K = N
      GOTO 4
    2 MINPT = 48
      DO 3 K=1,7
      L = NTIND(K)
      IF(IT(L+13).GE.MINPT) GOTO 3
      IMIN = K
      MINPT = IT(L+13)
    3 CONTINUE
      IF(IT(J+13).LE.MINPT) GOTO 5
      K = IMIN
    4 NTIND(K) = J
      S(K) = 0.
    5 J = J + 30
      IF(N.GT.7) N=7
      NTR = N
      IF(NTR.EQ.0) RETURN
      IF(NTR.EQ.1) GOTO 50
      IF(NTR.NE.2) GOTO 10
C        CHECK IF COLLINEAR 2-PRONG
      J1 = NTIND(1)
      J2 = NTIND(2)
      COSW = T(J1+24)*T(J2+24) * (T(J1+21)*T(J2+21)+T(J1+22)*T(J2+22))
     *     + SIN(T(J1+4))*SIN(T(J2+4))
      COSW = ABS(COSW)
      IF(COSW.GT.COLL2) GOTO 50
C****
C****    VERTEX FIT
   10 CONTINUE
      N = NTR + 3
      L = (N*(N+1))/2
      DO 11 I=1,L
   11 A(I) = 0.D0
      IF(ITFIN.EQ.1) GOTO 13
      DO 12 I=1,N
   12 B(I) = 0.D0
   13 DO 19 I=1,NTR
      J = NTIND(I)
      N = I + 3
      L = (N*(N-1))/2
      PHI = T(J+3) + S(I)/T(J+2)
      SPHI = SIN(PHI)
      CPHI = COS(PHI)
      XT = T(J+5) + T(J+2)*(SPHI-T(J+21))
      YT = T(J+6) - T(J+2)*(CPHI-T(J+22))
      ZT = T(J+7) + S(I)*T(J+23)
      SSPACE = S(I)
      SSCOUL = S(I)-T(J+27)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      DXY = T(J+10)**2 + (T(J+8)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DZ = (T(J+9)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(DXY))
      DDX = 1. / DXY
      IF(DDX.LT.DXYLIM) DDX=DXYLIM
      DDY = 1. / DXY
      IF(DDY.LT.DXYLIM) DDY=DXYLIM
      DDZ = 1. / (T(J+12)**2 + DZ/(T(J+24)**2)**2)
      IF(ITFIN.EQ.0) GOTO 15
      IT(J+1) = 3
      DDX = DDX * SPHI**2
      DDY = DDY * CPHI**2
      CHITR(I) = DDX*(XT-B(1))**2 + DDY*(YT-B(2))**2+ DDZ*(ZT-B(3))**2
      CHI2 = CHI2 + CHITR(I)
      GOTO 16
   15 B(1) = B(1) + XT*DDX
      B(2) = B(2) + YT*DDY
      B(3) = B(3) + ZT*DDZ
      B(N) = - XT*CPHI*DDX - YT*SPHI*DDY - ZT*T(J+23)*DDZ
   16 A(1) = A(1) + DDX
      A(3) = A(3) + DDY
      A(6) = A(6) + DDZ
      A(L+1) = -CPHI*DDX
      A(L+2) = -SPHI*DDY
      A(L+3) = -T(J+23)*DDZ
      A(L+N) = CPHI**2*DDX + SPHI**2*DDY + T(J+23)**2*DDZ
   19 CONTINUE
      IF(ITFIN.EQ.1) GOTO 30
C        SOLVE MATRIX EQUATION
      CALL SMINVD(A,B,N,1,DET)
      IF(DET.EQ.0.0) GOTO 100
      DSUM = 0.
      DO 23 I=1,NTR
      J = NTIND(I)
      DS = B(I+3)
      IF(ABS(DS/T(J+2)).GT.1.5) GOTO 25
      DSUM = DSUM + ABS(DS)
   23 S(I) = S(I) + DS
      ITER = ITER + 1
      IF(ITER.LT.MITER .AND. DSUM.GT.DSCONV) GOTO 10
C        FIT FINISHED, REPEAT ONCE MORE WITH PROPER ERRORS
      ITFIN = 1
      GOTO 10
C        EXTRAPOLATION OF TRACK I EXCEEDS 90 DEG
C        REMOVE TRACK AND RESTART IF MORE THAN ONE LEFT
   25 IF(NTR.LE.2) GOTO 100
      IT(J+1) = 1
      GOTO 1
   30 CALL SMINVD(A,DUMMY,N,0,DET)
      IF(A(1).LT.0.0 .OR. A(3).LT.0.0 .OR. A(6).LT.0.0) GOTO 100
      NDF = 2*NTR - 3
      PR = PROB(CHI2,NDF)
      IV(LV+1) = 1
      IF(PR.GT.PRCUT) IV(LV+1)=3
      V(LV+2) = B(1)
      V(LV+3) = B(2)
      V(LV+4) = B(3)
      V(LV+5) = DSQRT(A(1))
      V(LV+6) = DSQRT(A(3))
      V(LV+7) = DSQRT(A(6))
      IV(LV+8) = NTR
      V(LV+9) = CHI2
      IF(IREJTR.EQ.0) GOTO 100
      IF(IV(LV+1).EQ.3) GOTO 100
      IF(NTR.LE.2) GOTO 100
C        BAD CHISQARE
C        CHECK IF THERE IS ONE TRACK WHICH CONTRIBUTES MOST TO CHI2
      CHIMAX = 0.
      DO 32 I=1,NTR
      IF(CHITR(I).LT.CHIMAX) GOTO 32
      CHIMAX = CHITR(I)
      NTMAX = I
   32 CONTINUE
      CHICUT = 3. / NTR
      IF(CHICUT.GT..9) CHICUT=.9
      CHICUT = CHICUT * CHI2
      IF(CHIMAX.LT.CHICUT) GOTO 100
      J = NTIND(NTMAX)
      IT(J+1) = 1
      GOTO 1
C****
C****    1-PRONG OR COLLINEAR 2-PRONG
   50 IV(LV+1) = 2
      J = NTIND(1)
      CALL VTXPNT(J,XB,YB,XT1,YT1,ZT1,DXT21,DYT21,DZT21,PHIT,ST)
      IT(J+1) = 3
      IF(NTR.EQ.2) GOTO 52
      V(LV+2) = XT1
      V(LV+3) = YT1
      V(LV+4) = ZT1
      V(LV+5) = SQRT(DXT21)
      V(LV+6) = SQRT(DYT21)
      V(LV+7) = SQRT(DZT21)
      IV(LV+8) = 1
      V(LV+9) = 0.
      IV(LV+10) = 1
      GOTO 100
   52 J = NTIND(2)
      CALL VTXPNT(J,XB,YB,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT,ST)
      IT(J+1) = 3
      V(LV+2) = (XT1+XT2)/2.
      V(LV+3) = (YT1+YT2)/2.
      V(LV+4) = (ZT1+ZT2)/2.
      V(LV+5) = SQRT((DXT21+DXT22)/2.)
      V(LV+6) = SQRT((DYT21+DYT22)/2.)
      V(LV+7) = SQRT((DZT21+DZT22)/2.)
      IV(LV+8) = 2
      V(LV+9) = 0.
      IV(LV+10) = 2
      SDXY1 = SQRT(((XT1-V(LV+2))**2/DXT21 + (YT1-V(LV+3))**2/DYT21)/2.)
      IF(SDXY1.GT.3.) IV(LV+1)=1
      SDXY2 = SQRT(((XT2-V(LV+2))**2/DXT22 + (YT2-V(LV+3))**2/DYT22)/2.)
      IF(SDXY2.GT.3.) IV(LV+1)=1
      SDZ1 = ABS(ZT1-V(LV+4))/SQRT(DZT21)
      IF(SDZ1.GT.3.) IV(LV+1)=1
      SDZ2 = ABS(ZT2-V(LV+4))/SQRT(DZT22)
      IF(SDZ2.GT.3.) IV(LV+1)=1
C
  100 RETURN
      END
C   05/08/79 002080919  MEMBER NAME  VTXAFT   (JADEGS)      FORTRAN
      SUBROUTINE VTXAFT
C*800124*DITTMANN***************************************************
C*                                                                 *
C*          F I N I S H   X Y Z   V E R T E X   F I T              *
C*                                                                 *
C*       CALCULATE TRACK PARAMETERS AT VERTEX-NEAREST POINT        *
C*       FOR DETAILS OF THE T,V-ARRAYS SEE COMMENT IN SUBR. VERTEX.*
C*                                                                 *
C*******************************************************************
C
      COMMON /CWORK1/ NT,T(1500),NV,V(200)
      DIMENSION IV(2),IT(2)
      EQUIVALENCE (V(1),IV(1)),(T(1),IT(1))
C
      IF(NV.EQ.0) RETURN
C****
C****    EXTRAPOLATE ALL TRACKS TO VERTEX
      J = 0
      DO 9 I=1,NT
      IF(IT(J+1).EQ.0) GOTO 9
      IF(IT(J+14).EQ.0) GOTO 9
      LV = (IT(J+14)-1)*10
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,SS)
      T(J+3) = PHI
      T(J+5) = XT
      T(J+6) = YT
      T(J+7) = ZT
      T(J+10) = SQRT(DXT2)
      T(J+11) = SQRT(DYT2)
      T(J+12) = SQRT(DZT2)
      T(J+15) = SS
    9 J = J + 30
C
  100 RETURN
      END
C   05/02/80 002080923  MEMBER NAME  VTXBNK   (JADEGS)      FORTRAN
      SUBROUTINE VTXBNK(IPPATR)
C*800205*OLSSON*****************************************************
C*                                                                 *
C* C R E A T E  B A N K  GVTX  F R O M  V E R T E X  R E S U L T S *
C*                                                                 *
C*******************************************************************
C             IPPATR IS POINTER TO 'PATR' ;  SAME BOSBANK NR IS USED
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CWORK1/ NT,T(1500),NV,V(200)
      DIMENSION IV(2),IT(2)
      EQUIVALENCE (V(1),IV(1)),(T(1),IT(1))
C
      IF(NV.EQ.0) GO TO 100
C****
C
      NBNK = IDATA(IPPATR-2)
      NWRES = 2 + NV*10 + NT*15
      CALL CCRE(IPHT,'GVTX',NBNK,NWRES,IERR)
      IF(IERR.NE.0) GO TO 100
      CALL BSAW(1,'GVTX')
      IDATA(IPHT+1) = NV
      DO 1  INV = 1,NV
      INVX = IPHT+1+(INV-1)*10
      ISS = (INV-1)*10
      DO 1  I = 1,10
1     IDATA(INVX+I) = IV(ISS+I)
      IDATA(IPHT+2+NV*10) = NT
C
      DO 2  INT = 1,NT
      INTX = IPHT+2+NV*10 + (INT-1)*15
      ISS = (INT-1)*30
      DO 2  I = 1,15
2     IDATA(INTX+I) = IT(ISS+I)
  100 RETURN
      END
C   09/01/80 006251729  MEMBER NAME  VTXEE    (JADEGS)      FORTRAN
      SUBROUTINE VTXEE
C*800604*DITTMANN********************************************
C*                                                          *
C*              X - Y - Z    E E   P A I R S                *
C*                                                          *
C*       A DESCRIPTION OF THE T AND V ARRAYS CAN BE FOUND   *
C*       IN SUBR. VERTEX                                    *
C************************************************************
      COMMON /CWORK1/ NT,T(1500),NV,V(200)
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX
C
      IF(NT.LE.1) GOTO 100
C****
C****    LOOP OVER ALL TRACK PAIRS
      J1 = 0
      NT1 = NT - 1
      DO 9 I=1,NT1
      IF(IT(J1+1).EQ.0) GOTO 9
      M = I + 1
      J2 = I*30
      DO 8 K=M,NT
      IF(IT(J2+1).EQ.0) GOTO 8
C        OPPOSITE CHARGE
      IF(T(J1+2)*T(J2+2).GT.0.) GOTO 8
C        MEASURED R-PHI OPENING
      DPHI = T(J1+3) - T(J2+3)
      IF(T(J1+2).LT.0.) DPHI=-DPHI
      IF(ABS(DPHI).GT.3.141593) DPHI=DPHI-SIGN(1.,DPHI)*6.283185
      IF(DPHI.LT.EEDPMN .OR. DPHI.GT.EEDPMX) GOTO 8
      ITANK = 0
      XM1 = T(J1+5) - T(J1+2)*T(J1+21)
      YM1 = T(J1+6) + T(J1+2)*T(J1+22)
      XM2 = T(J2+5) - T(J2+2)*T(J2+21)
      YM2 = T(J2+6) + T(J2+2)*T(J2+22)
C        EXTRAPOLATION LENGTH
      IF(T(J1+27).EQ.0. .OR. T(J2+27).EQ.0.) GOTO 6
      IF(T(J1+27).LT.SEMAX .OR. T(J2+27).LT.SEMAX) GOTO 6
C        PAIR ORIGIN IN TANK (ADD SQRT(2/3)*COULOMB ERROR)
      ST1 = T(J1+27)
      ST2 = T(J2+27)
      CALL VTXS(J1,ST1,XT1,YT1,ZT1,DXT12,DYT12,DZT12,PHIT1)
      CALL VTXS(J2,ST2,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT2)
C        DISTANCE IN TANK
      DPHI = PHIT1 - PHIT2
      IF(T(J1+2).LT.0.) DPHI=-DPHI
      IF(ABS(DPHI).GT.3.141593) DPHI=DPHI-SIGN(1.,DPHI)*6.283185
      PTANK2 = (T(J1+16)**2+T(J2+16)**2) / 1.5
      STANK2 = 49. * PTANK2
      DX2 = (XT1-XT2)**2
      DY2 = (YT1-YT2)**2
      DXY = SQRT(DX2+DY2)
      DIST = SQRT((XT2-XM1)**2+(YT2-YM1)**2)
      IF(DIST.LT.ABS(T(J1+2))) DXY=-DXY
      DZ = ABS(ZT1-ZT2)
      DTH = ABS(T(J1+4)-T(J2+4))
      SDTH = DTH / SQRT(T(J1+9)**2+T(J2+9)**2+PTANK2)
      IF(SDTH.GT.EEDTMX) GOTO 6
      CTH = COS((T(J1+4)+T(J2+4))/2.)**2
      SDZ = DZ / SQRT(DZT12+DZT22+STANK2/CTH**2)
      IF(SDZ.GT.EEDTMX) GOTO 6
      SDPHI = ABS(DPHI)/SQRT(T(J1+8)**2+T(J2+8)**2+PTANK2)
      IF(SDPHI.GT.EEDRMX) GOTO 5
      SDXY = ABS(DXY) / SQRT(1./(1./DXT12+1./DYT12)+
     *                       1./(1./DXT22+1./DYT22)+STANK2)
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 5
      ITANK = 1
      GOTO 6
C        DISTANCE AT BEAM PIPE
    5 DPHIT = DTANK/ABS(T(J1+2)) + DTANK/ABS(T(J2+2))
      DPHI = DPHI - DPHIT
      SDPHI = ABS(DPHI)/SQRT(T(J1+8)**2+T(J2+8)**2+PTANK2)
      IF(SDPHI.GT.EEDRMX) GOTO 6
      DXY = DXY - DPHIT*DTANK/2.
      SDXY = ABS(DXY) / SQRT(1./(1./DXT12+1./DYT12) +
     *             1./(1./DXT22+1./DYT22) + STANK2)
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 6
      ITANK = 1
C        VERTEX WHERE TRACKS ARE PARALLEL
    6 CALL VTXPNT(J1,XM2,YM2,XT1,YT1,ZT1,DXT12,DYT12,DZT12,PHIT1,ST1)
      CALL VTXPNT(J2,XM1,YM1,XT2,YT2,ZT2,DXT22,DYT22,DZT22,PHIT2,ST2)
      DX2 = (XT1-XT2)**2
      DY2 = (YT1-YT2)**2
      DXY = SQRT(DX2+DY2)
      IF(DXY.GT.EEXYMX) GOTO 8
      DIST = SQRT((XT2-XM1)**2+(YT2-YM1)**2)
      IF(DIST.LT.ABS(T(J1+2))) DXY=-DXY
      DZ = ABS(ZT1-ZT2)
      IF(ITANK.EQ.1) GOTO 7
C        PAIR ORIGIN IN CHAMBER
      IF(ST1.LT.SEMAX .OR. ST2.LT.SEMAX) GOTO 8
      IF(ST1.GT.SIMAX .OR. ST2.GT.SIMAX) GOTO 8
      IF(T(J1+27).NE.0. .AND. ST1-T(J1+27).LT.0.) GOTO 8
      IF(T(J2+27).NE.0. .AND. ST2-T(J2+27).LT.0.) GOTO 8
C        DISTANCE IN CHAMBER
      DTH = ABS(T(J1+4)-T(J2+4))
      SDTH = DTH / SQRT(T(J1+9)**2+T(J2+9)**2)
      IF(SDTH.GT.EEDTMX) GOTO 8
      SDZ = DZ / SQRT(DZT12+DZT22)
      IF(SDZ.GT.EEDTMX) GOTO 8
      SDXY = ABS(DXY)/SQRT(1./(1./DXT12+1./DYT12)+1./(1./DXT22+
     *       1./DYT22))
      IF(SDXY.GT.EEDRMX .AND. (DXY.LT.0..OR.DXY.GT.EEXYMN)) GOTO 8
C
    7 IF(NV.EQ.20) GOTO 14
      NV = NV + 1
      LV = (NV-1)*10
      IV(LV+1) = 4
      DT1 = SQRT(DXT12)
      DT2 = SQRT(DXT22)
      V(LV+2) = (XT1/DT1+XT2/DT2) / (1./DT1+1./DT2)
      DT1 = SQRT(DYT12)
      DT2 = SQRT(DYT22)
      V(LV+3) = (YT1/DT1+YT2/DT2) / (1./DT1+1./DT2)
      DT1 = SQRT(DZT12)
      DT2 = SQRT(DZT22)
      V(LV+4) = (ZT1/DT1+ZT2/DT2) / (1./DT1+1./DT2)
      V(LV+5) = SQRT(DXT12+DXT22) / 2.
      V(LV+6) = SQRT(DYT12+DYT22) / 2.
      V(LV+7) = SQRT(DZT12+DZT22) / 2.
      V(LV+8) = SQRT(DX2+DY2)
      IV(LV+9) = I
      IV(LV+10) = K
    8 J2 = J2 + 30
    9 J1 = J1 + 30
C****
C****    CLEAN UP
      IF(NV.EQ.0) GOTO 100
   14 I = 1
   15 LV1 = (I-1)*10
      IF(I.EQ.NV) GOTO 19
      M = I + 1
      LV2 = I*10
      DO 16 K=M,NV
      IF(IV(LV1+9).EQ.IV(LV2+9) .OR. IV(LV1+10).EQ.IV(LV2+9) .OR.
     *   IV(LV1+10).EQ.IV(LV2+10)) GOTO 17
   16 LV2 = LV2 + 10
      GOTO 19
C        TWO PAIRS WITH SAME TRACK, TAKE PAIR WITH SMALLER DISTANCE
   17 M = I
      IF(V(LV1+8).LT.V(LV2+8)) M=K
      NV = NV - 1
      IF(M.GT.NV) GOTO 15
      DO 18 K=M,NV
      LV2 = K*10
      LV1 = LV2 - 10
      DO 18 J=1,10
   18 V(LV1+J) = V(LV2+J)
      GOTO 15
   19 J1 = (IV(LV1+9)-1)*30
      J2 = (IV(LV1+10)-1)*30
      IV(LV1+8) = 2
      V(LV1+9) = 0.
      IV(LV1+10) = 2
      IT(J1+1) = 3
      IT(J2+1) = 3
      IT(J1+14) = I
      IT(J2+14) = I
      I = I + 1
      IF(I.LE.NV) GOTO 15
C
  100 RETURN
      END
C   04/07/79 006251728  MEMBER NAME  VTXINI   (JADEGS)      FORTRAN
      SUBROUTINE VTXINI
C*800623*DITTMANN***************************************************
C*                                                                 *
C* I N I T I A L I S A T I O N   O F   X Y Z   V E R T E X   F I T *
C*                                                                 *
C*       TO BE CALLED ONCE AND BEFORE FIRST CALL TO VTXPRE, VERTEX *
C*******************************************************************
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV
C
C        MEAN VERTEX COORDINATES
      XB = 0.
      YB = 0.
      ZB = 0.
C        OUTER RADIUS OF INNER TANK WALL
      RTANK = 174.
C        OUTER DISTANCE BEAM PIPE TO TANK WALL
      DTANK = 50.
C        RADIATION LENGTH BETWEEN BEAM AND FIRST WIRE
      X0INN = 0.16
C        MEAN TRACK RESIDUAL IN XY AND ZR PLANE
      SIGX0 = 0.55
      SIGZ0 = 30.
C        ARTIFICIAL FACTOR TO ACCOUNT FOR SYSTEMATIC ERRORS
      SIGFAC = 2.0
      SIGX0 = SIGX0 * SIGFAC
      SIGZ0 = SIGZ0 * SIGFAC
C        MINIMUM NUMBER OF POINTS IN XY AND Z TRACK
      PNTMIN = 5.
C        MAXIMUM TRACK RESIDUAL IN XY AND Z (SIG<SIG1*SIGX0)
      SIG1 = 4.
C        MAXIMUM DISTANCE OF TRACKS TO AVERAGE BEAM
C        USED IN PRIMARY VERTEX SEARCH
      DISTB = 20.
C        MAXIMUM OPENING ANGLE OF COLLINEAR 2-PRONGS
      COLL2 = 0.98
C        MAXIMUM NUMBER OF ITERATIONS IN VERTEX FIT
      MITER = 7
C        CONVERGENCE PARAMETER
      DSCONV = 0.1
C        MINIMUM PROBABILITY FOR GOOD VERTEX
      PRCUT = 0.001
C        REJECT BAD TRACKS DURING VERTEX FIT (0=NO, 1=YES)
      IREJTR = 1
C        EE PAIRS: MINIMUM AND MAXIMUM MEASURED PHI DIFFERENCE (RADIAN)
      EEDPMN = -0.07
      EEDPMX =  0.8
C        EE PAIRS: MAXIMUM THETA DIFFERENCE (STD.DEV.)
      EEDTMX = 3.0
C        EE PAIRS: MAXIMUM DISTANCE WHERE TRACKS ARE PARALLEL (STD.DEV.)
      EEDRMX = 3.0
C        EE PAIRS: MAXIMUM POSITIVE XY DISTANCE, NO ST.DEV. CUT (MM)
      EEXYMN = 4.0
C        EE PAIRS: MAXIMUM XY DISTANCE WHERE TRACKS ARE PARALLEL (MM)
      EEXYMX = 20.
C        MAXIMUM TRACK EXTRAPOLATION AND INTRAPOLATION(ARC LENGTH)
      SEMAX = -300.
      SIMAX = 25.
C        MAXIMUM TRACK EXTRAPOLATION (PHI)
      PHEMAX = 1.0
C        MAXIMUM TRACK DISTANCE TO VERTEX DURING FIT (STD.DEV.)
      SIG2 = 2.
C        MAXIMUM TRACK DISTANCE TO VERTEX AFTER FIT (STD.DEV.)
      SIG3 = 4.
C        SEC. VERTICES: MINIMUM COS OF TRACK TO MAIN VERTEX (OR XB,YB)
      CSECV = -0.15
C
      RETURN
      END
C   11/12/79 006251730  MEMBER NAME  VTXPNT   (JADEGS)      FORTRAN
      SUBROUTINE VTXPNT(J,XP,YP,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT,ST)
C*800623*DITTMANN************************************************
C*                                                              *
C*     S U P P O R T   F O R   X Y Z   V E R T E X   F I T      *
C*                                                              *
C*       COMMON CWORK1 MUST BE FILLED PROPERLY                  *
C*                                                              *
C*       ENTRY: VTXS                                            *
C****************************************************************
      COMMON /CWORK1/ NT,T(1500)
C
C        ENTRY VTXPNT
C****    CALCULATE POINT XT,YT,ZT ON HELIX J WHICH IS NEAREST
C****    TO POINT XP,YP IN X-Y PROJECTION
      XM = T(J+5) - T(J+2)*T(J+21)
      YM = T(J+6) + T(J+2)*T(J+22)
      SR = SIGN(1.,T(J+2))
      PHIT = ATAN2(-SR*(XM-XP),SR*(YM-YP))
      THETA = PHIT - T(J+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      ST = T(J+2)*THETA
      SPHI = SIN(PHIT)
      CPHI = COS(PHIT)
      XT = XM + T(J+2)*SPHI
      YT = YM - T(J+2)*CPHI
      ZT = T(J+7) + ST*T(J+23)
      SSPACE = ST
      SSCOUL = ST-T(J+27)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      DXY = T(J+10)**2 + (T(J+8)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DZ = (T(J+9)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(DXY))
      DXT2 = SPHI**2 / DXY
      DYT2 = CPHI**2 / DXY
      IF(DXT2.LT.DXYLIM) DXT2=DXYLIM
      IF(DYT2.LT.DXYLIM) DYT2=DXYLIM
      DXT2 = 1. / DXT2
      DYT2 = 1. / DYT2
      DZT2 = T(J+12)**2 + DZ/(T(J+24)**2)**2
      RETURN
C
         ENTRY VTXS(J,S,XT,YT,ZT,DXT2,DYT2,DZT2,PHIT)
C****    CALCULATE POINT XT,YT,ZT ON HELIX J FOR A GIVEN
C****    PROJECTED ARC LENGTH
      THETA = S / T(J+2)
      PHIT = T(J+3) + THETA
      SPHI = SIN(PHIT)
      CPHI = COS(PHIT)
      XT = T(J+5) + T(J+2)*(SPHI-T(J+21))
      YT = T(J+6) - T(J+2)*(CPHI-T(J+22))
      ZT = T(J+7) + S*T(J+23)
      SSPACE = S
      SSCOUL = S-T(J+27)
      IF(SSCOUL.GT.0.) SSCOUL=0.
      DXY = T(J+10)**2 + (T(J+8)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DZ = (T(J+9)*SSPACE)**2 + (T(J+16)*SSCOUL)**2
      DXYLIM = 1. / (2.*ABS(T(J+2))*SQRT(DXY))
      DXT2 = SPHI**2 / DXY
      DYT2 = CPHI**2 / DXY
      IF(DXT2.LT.DXYLIM) DXT2=DXYLIM
      IF(DYT2.LT.DXYLIM) DYT2=DXYLIM
      DXT2 = 1. / DXT2
      DYT2 = 1. / DYT2
      DZT2 = T(J+12)**2 + DZ/(T(J+24)**2)**2
      RETURN
C
      END
C   07/11/79 006251731  MEMBER NAME  VTXSRC   (JADEGS)      FORTRAN
      SUBROUTINE VTXSRC
C*800623*DITTMANN********************************************
C*                                                          *
C*        X - Y - Z    V E R T E X    S E A R C H           *
C*                                                          *
C*       1. SEARCH FOR E+E- PAIRS                           *
C*       2. SEARCH FOR MAIN VERTEX AROUND AVERAGE BEAM      *
C*       3. SEARCH FOR SECONDARY VERTICES                   *
C*                                                          *
C*       A DESCRIPTION OF THE T AND V ARRAYS CAN BE FOUND   *
C*       IN SUBR. VERTEX                                    *
C************************************************************
      COMMON /CWORK1/ NT,T(1500),NV,V(200),XXXXX(151),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,7)
      DIMENSION IT(2),IV(2),IV2(20,7)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1)),(V2(1,1),IV2(1,1))
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1,SIG2,SIG3,CSECV
C
      LOGICAL VREP,RESTOR
C
      NV = 0
      IF(NT.LE.0) RETURN
      IPRVTX = 0
C****
C****    SEARCH FOR GAMMA CONVERSIONS
      CALL VTXEE
      IF(NV.EQ.0) GOTO 5
      LV = 0
      DO 4 I=1,NV
      J = 0
      DO 3 K=1,NT
      IF(IT(J+14).EQ.I) IT(J+1)=-IT(J+1)
    3 J = J + 30
    4 LV = LV + 10
C****
C****    SEARCH FOR PRIMARY VERTEX AROUND AVERAGE BEAM
    5 NTGOD = 0
      NTBAD = 0
      J = 0
      DO 7 I=1,NT
      IF(IT(J+1).LE.0) GOTO 7
      CALL VTXPNT(J,XB,YB,XT,YT,ZT,DXT2,DYT2,DZT2,PHI,SS)
      DXY = SQRT((XT-XB)**2+(YT-YB)**2)
      IF(DXY.GT.DISTB) GOTO 6
      IF(SS.LT.SEMAX-RTANK) GOTO 6
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      GOTO 7
    6 IT(J+1) = 1
      NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
    7 J = J + 30
      IF(NTGOD.EQ.0) GOTO 39
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
      VREP = .FALSE.
      RESTOR = .FALSE.
C****
C****    VERTEX FIT
   10 CALL VERTEX
      IF(IV(LV+1).GE.1) GOTO 20
      IF(VREP) GOTO 60
      GOTO 40
C****
C****    CHECK VERTEX AND ITS TRACKS
   20 NTBAD = 0
      NTBAD3 = 0
      NTGOD = 0
      NTGOD3 = 0
      J = 0
      DO 25 I=1,NT
      IF(IT(J+1).LE.0) GOTO 25
C        SMALLEST DISTANCE TO VERTEX
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,SS)
      DXT2 = DXT2 + V(LV+5)**2
      DYT2 = DYT2 + V(LV+6)**2
      DZT2 = DZT2 + V(LV+7)**2
      SDX = ABS(XT-V(LV+2)) / SQRT(DXT2)
      SDY = ABS(YT-V(LV+3)) / SQRT(DYT2)
      SDZ = ABS(ZT-V(LV+4)) / SQRT(DZT2)
      T(J+15) = SS
      T(J+28) = SDX
      T(J+29) = SDY
      T(J+30) = SDZ
      IF(IT(J+1).EQ.1) GOTO 23
      IF(SDX.GT.SIG2 .OR. SDY.GT.SIG2 .OR. SDZ.GT.SIG2) GOTO 23
C        EXTRAPOLATION LENGTH
      IF(SS.GT.SIMAX) GOTO 23
      SSJC = SS
      IF(T(J+27).EQ.0.) GOTO 22
      IF(SS.LT.T(J+26)-SIMAX) GOTO 23
      IF(SS.LT.T(J+27)) SSJC=T(J+27)
   22 IF(SSJC.LT.SEMAX) GOTO 23
      IF(ABS(SS/T(J+2)).GT.PHEMAX) GOTO 23
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      IF(IT(J+1).EQ.3) NTGOD3=NTGOD3+1
      GOTO 25
   23 NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
      IF(IT(J+1).EQ.3) NTBAD3=NTBAD3+1
   25 J = J + 30
      IF(RESTOR) GOTO 30
      IF(NTGOD3.EQ.7) GOTO 30
      IF(NTBAD3.EQ.0 .AND. NTGOD.EQ.NTGOD3) GOTO 30
      IF(.NOT.VREP .AND. NTGOD.LT.3) GOTO 40
      IF(NTGOD.LE.2) GOTO 60
C        REPEAT VERTEX FIT
      DO 27 I=1,NTGOD
      J = JTGOD(I)
   27 IT(J+1) = 2
      IF(NTBAD.EQ.0) GOTO 10
      DO 28 I=1,NTBAD
      J = JTBAD(I)
   28 IT(J+1) = 1
      GOTO 10
C****
C****    GOOD VERTEX FOUND
   30 IF(NTBAD.EQ.0) GOTO 37
      IF(IV(LV+8).EQ.1) GOTO 37
C        COLLECT ALL TRACKS FITTING TO VERTEX
      NTB = 0
      DO 33 I=1,NTBAD
      J = JTBAD(I)
      IF(T(J+28).GT.SIG3.OR.T(J+29).GT.SIG3.OR.T(J+30).GT.SIG3) GOTO 32
      IF(T(J+15).GT.SIMAX) GOTO 32
      SSJC = T(J+15)
      IF(T(J+27).EQ.0.) GOTO 31
      IF(T(J+15).LT.T(J+26)-SIMAX) GOTO 32
      IF(T(J+15).LT.T(J+27)) SSJC=T(J+27)
   31 IF(SSJC.LT.SEMAX) GOTO 32
      IF(ABS(T(J+15)/T(J+2)).GT.PHEMAX) GOTO 32
      NTGOD = NTGOD + 1
      JTGOD(NTGOD) = J
      IT(J+1) = 1
      GOTO 33
   32 NTB = NTB + 1
      JTBAD(NTB) = J
   33 CONTINUE
      NTBAD = NTB
   37 IV(LV+10) = NTGOD
      DO 38 I=1,NTGOD
      J = JTGOD(I)
      IT(J+1) = -IT(J+1)
      IT(J+14) = NV
   38 CONTINUE
      IF(IPRVTX.NE.0) GOTO 39
      IF(ABS(V(LV+2)-XB).LT.3.*DISTB .AND. ABS(V(LV+3)-YB).LT.3.*DISTB)
     *   IPRVTX=NV
   39 IF(NTBAD.EQ.0) GOTO 90
      NTGOD = 0
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
C****
C****    VERTEX SEARCH
   40 IF(NTBAD.EQ.0) GOTO 241
      DO 41 I=1,NTBAD
      J = JTBAD(I)
   41 IT(J+1) = 1
  241 IF(NTGOD.EQ.0) GOTO 43
      DO 141 I=1,NTGOD
      J = JTGOD(I)
      NTBAD = NTBAD + 1
      JTBAD(NTBAD) = J
  141 IT(J+1) = 1
   43 NVL = NV
      NV2 = 0
      N1 = 1
      IF(NTBAD.LT.2) GOTO 50
C        TWO TRACK VERTEX
   42 J1 = JTBAD(N1)
      IT(J1+1) = 2
      N21 = N1 + 1
      IF(N21.GT.NTBAD) GOTO 45
      DO 44 N2=N21,NTBAD
      J2 = JTBAD(N2)
      IT(J2+1) = 2
      CALL VERTEX
      IF(IV(LV+1).LE.1) GOTO 44
C        CHECK THIS VERTEX
C        EXTRAPOLATION LENGTH TRACK 1
      CALL VTXPNT(J1,V(LV+2),V(LV+3),XT1,YT1,ZT1,DXT12,DYT12,DZT12,
     *            PHIT1,ST1)
      IF(ST1.GT.SIMAX) GOTO 44
      SSJC = ST1
      IF(T(J1+27).EQ.0.) GOTO 143
      IF(ST1.LT.T(J1+26)-SIMAX) GOTO 44
      IF(ST1.LT.T(J1+27)) SSJC=T(J1+27)
  143 IF(SSJC.LT.SEMAX) GOTO 44
      IF(ABS(ST1/T(J1+2)).GT.PHEMAX) GOTO 44
C        EXTRAPOLATION LENGTH TRACK 2
      CALL VTXPNT(J2,V(LV+2),V(LV+3),XT2,YT2,ZT2,DXT22,DYT22,DZT22,
     *            PHIT2,ST2)
      IF(ST2.GT.SIMAX) GOTO 44
      SSJC = ST2
      IF(T(J2+27).EQ.0.) GOTO 243
      IF(ST2.LT.T(J2+26)-SIMAX) GOTO 44
      IF(ST2.LT.T(J2+27)) SSJC=T(J2+27)
  243 IF(SSJC.LT.SEMAX) GOTO 44
      IF(ABS(ST2/T(J2+2)).GT.PHEMAX) GOTO 44
C        COMPARE TRACK DIRECTIONS WITH BEAM
      DZ = ABS(ZT1-ZT2)
      COSW12 = 0.
      IF(IPRVTX.EQ.0) GOTO 147
      LPV = (IPRVTX-1)*10
      DVX = V(LV+2) - V(LPV+2)
      DVY = V(LV+3) - V(LPV+3)
      DVZ = V(LV+4) - V(LPV+4)
      DV12 = SQRT(DVX**2+DVY**2+DVZ**2)
      COSW1 = (COS(PHIT1)*T(J1+24)*DVX + SIN(PHIT1)*T(J1+24)*DVY +
     *         SIN(T(J1+4))*DVZ) / DV12
      IF(COSW1.LT.CSECV) GOTO 44
      COSW2 = (COS(PHIT2)*T(J2+24)*DVX + SIN(PHIT2)*T(J2+24)*DVY +
     *        SIN(T(J2+4))*DVZ) / DV12
      IF(COSW2.LT.CSECV) GOTO 44
      COSW12 = COSW1 * COSW2
      GOTO 47
  147 DVX = V(LV+2) - XB
      DVY = V(LV+3) - YB
      DV12 = SQRT(DVX**2+DVY**2)
      IF(DV12.LT.DISTB) GOTO 47
      COSW1 = (COS(PHIT1)*DVX + SIN(PHIT1)*DVY) / DV12
      IF(COSW1.LT.CSECV) GOTO 44
      COSW2 = (COS(PHIT2)*DVX + SIN(PHIT2)*DVY) / DV12
      IF(COSW2.LT.CSECV) GOTO 44
      COSW12 = COSW1 * COSW2
C        CHECK IF MORE TRACKS FIT
   47 NT2 = 2
      DO 149 K=1,NTBAD
      J = JTBAD(K)
      IF(IT(J+1).EQ.3) GOTO 149
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,SS)
      SDX = ABS(XT-V(LV+2)) / SQRT(DXT2)
      SDY = ABS(YT-V(LV+3)) / SQRT(DYT2)
      SDZ = ABS(ZT-V(LV+4)) / SQRT(DZT2)
      IF(SDX.GT.SIG2 .OR. SDY.GT.SIG2 .OR. SDZ.GT.SIG2) GOTO 149
      IF(SS.GT.SIMAX) GOTO 149
      SSJC = SS
      IF(T(J+27).EQ.0.) GOTO 148
      IF(SS.LT.T(J+26)-SIMAX) GOTO 149
      IF(SS.LT.T(J+27)) SSJC=T(J+27)
  148 IF(SSJC.LT.SEMAX) GOTO 149
      IF(ABS(SS/T(J+2)).GT.PHEMAX) GOTO 149
      NT2 = NT2 + 1
  149 CONTINUE
C        TEMPORARY STORE OF ALL TWO TRACK VERTICES
      NV2 = NV2 + 1
      IV2(NV2,1) = NV
      IV2(NV2,2) = NT2
      IV2(NV2,3) = J1
      IV2(NV2,4) = J2
      V2(NV2,5) = COSW12
      V2(NV2,6) = DZ
      IV2(NV2,7) = IV(LV+1)
      IF(NV.EQ.20) GOTO 45
      NV = NV + 1
      LV = (NV-1)*10
C
   44 IT(J2+1) = 1
      IT(J1+1) = 1
      N1 = N1 + 1
      IF(N1.LE.NTBAD) GOTO 42
C        CHOOSE BEST TWO TRACK VERTEX
   45 IT(J1+1) = 1
      IT(J2+1) = 1
      IF(NV2.EQ.0) GOTO 50
      NT2MAX = 0
      DO 46 I=1,NV2
      IF(IV2(I,2).LT.NT2MAX) GOTO 46
      IF(IV2(I,2).EQ.NT2MAX) GOTO 144
      NT2MAX = IV2(I,2)
      LV2 = I
      GOTO 46
  144 IF(IV2(I,7).EQ.IV2(LV2,7)) GOTO 145
      IF(IV2(I,7).GT.IV2(LV2,7)) LV2=I
      GOTO 46
  145 IF(IPRVTX.EQ.0) GOTO 146
      IF(V2(I,5).GT.V2(LV2,5)) LV2=I
      GOTO 46
  146 IF(V2(I,6).LT.V2(LV2,6)) LV2=I
   46 CONTINUE
C        REPEAT VERTEX FIT
      J1 = IV2(LV2,3)
      J2 = IV2(LV2,4)
      NV = NVL
      LV = (NVL-1)*10
      LV2 = (IV2(LV2,1)-1)*10
      J1SAVE = J1
      J2SAVE = J2
      DO 48 K=1,10
      VSAVE(K) = V(LV2+K)
   48 V(LV+K) = V(LV2+K)
      DO 49 K=1,NTBAD
      J = JTBAD(K)
      IT(J+1)=2
   49 CONTINUE
      IT(J1+1) = 3
      IT(J2+1) = 3
      VREP = .TRUE.
      RESTOR = .FALSE.
      GOTO 20
C        SINGLE TRACK VERTEX
   50 DO 52 N1=1,NTBAD
      J1 = JTBAD(N1)
      IF(N1.EQ.1) GOTO 51
      IF(NV.EQ.20) GOTO 90
      NV = NV + 1
      LV = (NV-1)*10
   51 IV(LV+1) = 5
      V(LV+2) = T(J1+5)
      V(LV+3) = T(J1+6)
      V(LV+4) = T(J1+7)
      V(LV+5) = T(J1+10)
      V(LV+6) = T(J1+11)
      V(LV+7) = T(J1+12)
      IV(LV+8) = 1
      V(LV+9) = 0.
      IV(LV+10) = 1
      IT(J1+1) = -3
      IT(J1+14) = NV
   52 CONTINUE
      GOTO 90
C        SEARCH NOT CONVERGING
C        EMERGENCY ACTION: RESTORE 2-TRACK VERTEX (OTHERWISE DEAD LOOP)
   60 J1 = J1SAVE
      J2 = J2SAVE
      DO 62 I=1,10
   62 V(LV+I) = VSAVE(I)
      IF(NTBAD.EQ.0) GOTO 66
      DO 63 I=1,NTBAD
      J = JTBAD(I)
      IT(J+1)=2
   63 CONTINUE
   66 IF(NTGOD.EQ.0) GOTO 69
      DO 67 I=1,NTGOD
      J = JTGOD(I)
      IT(J+1)=2
   67 CONTINUE
   69 IT(J1+1) = 3
      IT(J2+1) = 3
      RESTOR = .TRUE.
      GOTO 20
C****
C****    CLEAN UP
   90 IF(NV.EQ.0) GOTO 100
      J = 0
      DO 91 I=1,NT
      IF(IT(J+1).LT.0) IT(J+1)=-IT(J+1)
   91 J = J + 30
      IF(NV.EQ.1) GOTO 100
      IF(IPRVTX.NE.0) GOTO 93
      IPRVTX = 1
      DXYP = 1.E20
      LV = 0
      DO 92 I=1,NV
      DXY = V(LV+2)**2+V(LV+3)**2
      IF(DXY.GT.DXYP) GOTO 92
      IPRVTX = I
      DXYP = DXY
   92 LV = LV + 10
   93 IF(IPRVTX.EQ.1) GOTO 100
C        MOVE PRIMARY VERTEX TO FIRST POSITION
      M = IPRVTX - 1
      LV = M*10
      DO 94 I=1,10
   94 VSAVE(I) = V(LV+I)
      DO 96 I=1,M
      DO 95 J=1,10
   95 V(LV+J) = V(LV+J-10)
   96 LV = LV - 10
      DO 97 I=1,10
   97 V(I) = VSAVE(I)
      J = 0
      DO 99 I=1,NT
      IF(IT(J+1).EQ.0) GOTO 99
      IF(IT(J+14).EQ.IPRVTX) GOTO 98
      IF(IT(J+14).LT.IPRVTX) IT(J+14)=IT(J+14)+1
      GOTO 99
   98 IT(J+14) = 1
   99 J = J + 30
C
  100 RETURN
      END

      SUBROUTINE PRXYTR
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cjdrch.for"
#include "cworkpr.for"
#include "cworkeq.for"
#include "cdsmax.for"
      IPTR  = HPFREE
      HPTE0 = HPFREE
      NBYTE = HLDTE*HNTR*4
      CALL SETSL(IWRK(IPTR),0,NBYTE,0)
      DO 13000 ITREL=1,HNTR
        JCELL = ITRKAR(ITREL,1)
        IWRK(IPTR   ) = JCELL
        IWRK(IPTR+ 1) = ITREL
        IWRK(IPTR+ 2) = ITRKAR(ITREL, 2)
        IWRK(IPTR+19) = ITRKAR(ITREL, 9)
      IF(
     - JCELL.LE.24
     -)THEN
          JRING = 1
          DXWR=DIRWR1(JCELL  ,1)
          DYWR=DIRWR1(JCELL  ,2)
          TRLOXL=TRMATS(JCELL  ,1)
          TRLOYL=TRMATC(JCELL  ,1)
          TRLOXR=TRMATS(JCELL  ,2)
          TRLOYR=TRMATC(JCELL  ,2)
      ELSE
      IF(
     - JCELL.LE.48
     -)THEN
          JRING = 2
          DXWR=DIRWR1(JCELL-24,1)
          DYWR=DIRWR1(JCELL-24,2)
          TRLOXL=TRMATS(JCELL  ,1)
          TRLOYL=TRMATC(JCELL  ,1)
          TRLOXR=TRMATS(JCELL  ,2)
          TRLOYR=TRMATC(JCELL  ,2)
      ELSE
          JRING = 3
          DXWR=DIRWR3(JCELL-48,1)
          DYWR=DIRWR3(JCELL-48,2)
          TRLOXL=TRMATS(JCELL  ,1)
          TRLOYL=TRMATC(JCELL  ,1)
          TRLOXR=TRMATS(JCELL  ,2)
          TRLOYR=TRMATC(JCELL  ,2)
      ENDIF
      ENDIF
        R0 = FSENSW(JRING)
        DR0= RINCR (JRING)
        DRC = DR0*.5
        ILAYR = ITRKAR(ITREL,3)
        DRSP1 = TRKAR(ITREL,4)
        DRSP2 = DRSP1 + TRKAR(ITREL,5)
      IF(
     - DRSP1.LT.DRC .AND. ABS(DRSP2-DRSP1).GE.DRC
     -)THEN
          DWIR = ITRKAR(ITREL,6)-ILAYR
          CRV  = 0.
          IF(DWIR.GT.0.) CRV = (TRKAR(ITREL,8)-TRKAR(ITREL,5))/DWIR
          SLOPE = CRV*.5 + DRSP2-DRSP1
          DRSP1 = DRSP1 + SLOPE
          DRSP2 = CRV*.5 + SLOPE + DRSP1
          ILAYR = ILAYR + 1
      ENDIF
        R1 = R0 + DR0*ILAYR
        R2 = R1 + DR0
        X1 = R1*DXWR
        X2 = R2*DXWR
        Y1 = R1*DYWR
        Y2 = R2*DYWR
      IF(
     - DRSP1.LT.DRC
     -)THEN
          SNFI = (DRSP2 - DRSP1) / DR0
          CSFI = SQRT(1.-SNFI**2)
          DRSPC = DRSP1/CSFI
          XL  = X1 + DYWR*DRSPC
          YL  = Y1 - DXWR*DRSPC
          DXL =-DXWR*CSFI - DYWR*SNFI
          DYL = DXWR*SNFI - DYWR*CSFI
          XR  = X1 - DYWR*DRSPC
          YR  = Y1 + DXWR*DRSPC
          DXR =-DXWR*CSFI + DYWR*SNFI
          DYR =-DXWR*SNFI - DYWR*CSFI
      ELSE
          YL  = Y1 - TRLOYL*DRSP1
          DYL = Y2 - TRLOYL*DRSP2 - YL
          XL  = X1 - TRLOXL*DRSP1
          DXL = X2 - TRLOXL*DRSP2 - XL
          DISTL = SQRT(DXL**2+DYL**2)
          DXL =-DXL / DISTL
          DYL =-DYL / DISTL
          COSGL = -DXL*TRLOYL + DYL*TRLOXL
          DDRSP = (1./COSGL - 1.) * DRC
          XL =-DDRSP*TRLOXL + XL
          YL =-DDRSP*TRLOYL + YL
          YR  = Y1 + TRLOYR*DRSP1
          DYR = Y2 + TRLOYR*DRSP2 - YR
          XR  = X1 + TRLOXR*DRSP1
          DXR = X2 + TRLOXR*DRSP2 - XR
          DISTR = SQRT(DXR**2+DYR**2)
          DXR =-DXR / DISTR
          DYR =-DYR / DISTR
          COSGR = -DXR*TRLOYR + DYR*TRLOXR
          DDRSP = (1./COSGR - 1.) * DRC
          XR = DDRSP*TRLOXR + XR
          YR = DDRSP*TRLOYR + YR
      ENDIF
        WRK(IPTR+ 3) = XL
        WRK(IPTR+ 4) = YL
        WRK(IPTR+ 5) = DXL
        WRK(IPTR+ 6) = DYL
        WRK(IPTR+ 7) = XR
        WRK(IPTR+ 8) = YR
        WRK(IPTR+ 9) = DXR
        WRK(IPTR+10) = DYR
        ILAYR = ITRKAR(ITREL,6)
        DRSP1 = TRKAR(ITREL,7)
        DRSP2 = DRSP1 - TRKAR(ITREL,8)
      IF(
     - DRSP1.LT.DRC .AND. ABS(DRSP2-DRSP1).GE.DRC
     -)THEN
          DWIR = ILAYR - ITRKAR(ITREL,3)
          CRV  = 0.
          IF(DWIR.GT.0.) CRV = (TRKAR(ITREL,8)-TRKAR(ITREL,5))/DWIR
          SLOPE =-CRV*.5 + DRSP1-DRSP2
          DRSP1 = DRSP1 - SLOPE
          DRSP2 = CRV*.5 - SLOPE + DRSP1
          ILAYR = ILAYR - 1
      ENDIF
        R1 = R0 + DR0*ILAYR
        R2 = R1 - DR0
          X1 = R1*DXWR
          X2 = R2*DXWR
          Y1 = R1*DYWR
          Y2 = R2*DYWR
      IF(
     - DRSP1.LT.DRC
     -)THEN
          SNFI = (DRSP2 - DRSP1) / DR0
          CSFI = SQRT(1.-SNFI**2)
          DRSPC = DRSP1/CSFI
          XL  = X1 + DYWR*DRSPC
          YL  = Y1 - DXWR*DRSPC
          DXL =-DXWR*CSFI + DYWR*SNFI
          DYL =-DXWR*SNFI - DYWR*CSFI
          XR  = X1 - DYWR*DRSPC
          YR  = Y1 + DXWR*DRSPC
          DXR =-DXWR*CSFI - DYWR*SNFI
          DYR = DXWR*SNFI - DYWR*CSFI
      ELSE
          YL  = Y1 - TRLOYL*DRSP1
          DYL = Y2 - TRLOYL*DRSP2 - YL
          XL  = X1 - TRLOXL*DRSP1
          DXL = X2 - TRLOXL*DRSP2 - XL
          DISTL = SQRT(DXL**2+DYL**2)
          DXL = DXL / DISTL
          DYL = DYL / DISTL
          COSGL = -DXL*TRLOYL + DYL*TRLOXL
          DDRSP = (1./COSGL - 1.) * DRC
          XL =-DDRSP*TRLOXL + XL
          YL =-DDRSP*TRLOYL + YL
          YR  = Y1 + TRLOYR*DRSP1
          DYR = Y2 + TRLOYR*DRSP2 - YR
          XR  = X1 + TRLOXR*DRSP1
          DXR = X2 + TRLOXR*DRSP2 - XR
          DISTR = SQRT(DXR**2+DYR**2)
          DXR = DXR / DISTR
          DYR = DYR / DISTR
          COSGR = -DXR*TRLOYR + DYR*TRLOXR
          DDRSP = (1./COSGR - 1.) * DRC
          XR = DDRSP*TRLOXR + XR
          YR = DDRSP*TRLOYR + YR
      ENDIF
      IF(
     - TBIT(ITRKAR(ITREL,9),23)
     -)THEN
          WRK(IPTR+15) = XL
          WRK(IPTR+16) = YL
          WRK(IPTR+17) = DXL
          WRK(IPTR+18) = DYL
          WRK(IPTR+11) = XR
          WRK(IPTR+12) = YR
          WRK(IPTR+13) = DXR
          WRK(IPTR+14) = DYR
      ELSE
          WRK(IPTR+11) = XL
          WRK(IPTR+12) = YL
          WRK(IPTR+13) = DXL
          WRK(IPTR+14) = DYL
          WRK(IPTR+15) = XR
          WRK(IPTR+16) = YR
          WRK(IPTR+17) = DXR
          WRK(IPTR+18) = DYR
      ENDIF
        IPTR = IPTR + HLDTE
13000 CONTINUE
13001 CONTINUE
      HPFREE = IPTR
      HPTE9  = IPTR - 1
      RETURN
      END

C   13/08/79 808021743  MEMBER NAME  LGCDIR9  (SOURCE)      FORTRAN
C
C=======================================================================
      SUBROUTINE LGCDIR( NPPREC, NPR, NPCL)
C=======================================================================
C
C     S.YAMADA      06-11-78  15:20
C          MOD. 01-11-79  18:30 BY Y.WATANABE(CALL TPCNST)
C          MOD. 29-02-80  14:20 BY S.YAMADA (COSTH CORRECTION)
C          MOD. 05-05-80  18:20 BY Y.WATANABE (HRUN=0. NOECOR)
C          MOD. 26-08-80  02:30 BY Y.WATANABE (INTOLG NPPREC )
C          MOD. 12-02-81  22:30 BY Y.WATANABE (ECOR FOR MC IF NEEDED)
C          MOD. 03-09-86  J.OLSSON  CORRECT BUG IN MC BANK DESCRIPTOR
C          MOD. 02-08-88  T.OEST/D.PITZL: PASS # OF BLOCKS TO LGECOR
C
C---- LEAD GLASS CLUSTER DIRECTION IS CALCULATED USING THE EVENT VERTEX.
C     ADATA(NPCLS+8--10) ARE FILLED. SEE BELOW.
C
C     THIS IS CALLED IN THE 2-ND STEP LG-ANALYSIS.
C    ******* BOS VERSION ********
C
C---- INPUT:
C         NPPREC=THE BOS POINTER TO THE PATTERN RECOGNITION RES.('PATR')
C                THE NEW FORMAT(VARIABLE LENGTH HEADER) IS ACCEPTED NOW.
C
C         NPR   =THE BOS POINTER TO THE RAW LG-ADC DATA ('ALGN')
C         NPCL  =THE BOS POINTER TO THE LG-RESULT BANK ('LGCL')
C
      IMPLICIT INTEGER *2 (H)
C
      DIMENSION HELP(2)
      EQUIVALENCE (IHELP,HELP(1))
C
#include "cdata.for"
#include "clgwork2.for"
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX, DZVRTX
      COMMON /CLGMSB/ MSGVAL(5)
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
      DIMENSION JBCCHG(9,100)
      EQUIVALENCE (CXDCHG(1,1),JBCCHG(1,1))
      COMMON /CLGSHP/ WWZZXX(150),EW(2),AVPH,AVZ
C
C---- SEE  JADE COMPUTER-NOTE #14.
C     IDATA(NPCLS+1)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     ADATA(NPCLS+2)=CLUSTER ENERGY IN GEV
C     ADATA(NCLST+3)=SIGMA(ENERGY)
C     ADATA(NPCLS+4)=WEIGHTED AVERAGE PHI
C     ADATA(NPCLS+5)=WEIGHTED AVERAGE Z
C     ADATA(NPCLS+6)=SIGMA PHI (WEIGHTED)
C     ADATA(NPCLS+7)=SIGMA Z (WEIGHTED)
C     IDATA(NPCLS+8)=NUMBER OF CORRESPONDING INNER TRACKS
C     ADATA(NPCLS+9-11)=DIRECTION COSINES CORRECTED FOR SHOWER DEPTH.
C
      INTEGER INDEX(3)/  9, 8,10/
C
      COMMON /CLGVRN/ NVRSN(20)
      DATA NVCODE,INITL/680082602,0/
      DATA HELP /0,0/
C
      IF(INITL.GT.0) GO TO 31
      INITL=1
      IPHD=IBLN('HEAD')
      IPVX=IBLN('TPVX')
C
      PRINT 6232
 6232 FORMAT( T2, 'JADELG.LOAD (LGCDIR9) CALLED, VERSION OF 02.08.88')
C
31    CONTINUE
C
C---- CHECK POINTERS
      IF(NPCL.LE.0) GO TO 90
C---- FIX POINTERS FOR CLUSTER DATA
      NPCGI = NPCL+IDATA(NPCL+1)-1
      NPCLS = NPCL+IDATA(NPCL+3)-1
C---- GET NO.OF CLUSTERS
      NCLST = IDATA(NPCGI+3)
C............ PUT IN BKGAUSS ETC...1-11-79
          NPHD = IDATA(IPHD)
         CALL TPCNST ( NPHD )
         HRUN=HDATA(NPHD+NPHD+10)
C        USED TO DECIDE DATA OR MONTE CARLO
C        IF HRUN=0 NO ENERGY CORRECTION IS DONE.
C
      NVRSN(9) = NVCODE
C
C     CHECK IF LGANAL IS CALLED FOR THIS JOB
      IF(IDATA(NPCGI+17).EQ.2) CALL LGREIN(NPCL,NPR)
C
C---- CLEAR THE MATCH TABLE
      CALL SETSL( NCHCL2, 0,1448, 0)
C
C---- SET THE FLAG TO SHOW THAT THE 2-ND STEP ANALYSIS IS DONE.
      IDATA(NPCGI+17) = 2
C
      IF( NPR.LE.0 ) GO TO 4
C
C---- INNER TRACK CONNECTION IS DONE IF 'PATR' IS THERE.
      IF(NPPREC.LE.0) GO TO 4
C
      NCHPRE = IDATA(NPPREC+2)
      NLPTRC = IDATA(NPPREC+3)
      NPTR = NPPREC+1+IDATA(NPPREC+1)
C
C---- SKIP CH.TRACING,IF LG-CLUSTER IS NOT THERE.(TO SAVE TIME)
      IF( NCLST.GT.0 ) GO TO 6
      NCHCLS = NCHPRE
      NPOINT = 0
      NCHCL2 = NCHPRE
      GO TO 7
C
    6 CALL ILCTRC(NCHPRE,NLPTRC,IDATA(NPTR),ADATA(NPTR))
      CALL LGCHC2
C
C---- CONNECT SIMULATED CHARGE CLUSTERS AND OBSERVED ONES.
      NPMAP = NPCL+IDATA(NPCL+2)
      NPALGN = NPR+NPR+7
C
C---- NOTICE THAT IN THE INTOLG LG-ADC MAP IS TREATED AS HDATA(2,2).
      CALL INTOLG(NPCL,IDATA(NPMAP),HDATA(NPALGN),NPPREC)
C
C---- SET THE FLAG OF INNER TRACK CONNECTION
    7 IDATA(NPCGI+19) = 1
C
    4 IF( NCLST ) 100,100,8
C
C---- GET NO.OF WORDS FOR EACH CLUSTER.
    8 LSTEP = IDATA(NPCGI+21)
C
C---- VERSION NO. FOR ENERGY CORRECTION SUBROUTINE IS SET.
      CALL LGECR0( NVECOR )
C---- SHOWER ENERGY CORRECTION IS MADE
      IDATA(NPCGI+18) = NVECOR
      IF(NVECOR)42,42,41
C---- CLEAR TOTAL ENERGY TO MAKE THE SUM OF CORRECTED ENERGIES
41    CALL SETSL(ADATA(NPCGI+7),0,36,0.)
42    NEND = NCLST
      IF(NEND.GT.MAXCLS) NEND = MAXCLS
C
C---- VERTEX OF THE EVENT IS COPIED INTO ZVRTX
      NPVX=IDATA(IPVX)
      ZVRTX = 0.
      DZVRTX = 0.
      IF(NPVX.LE.0) GO TO 5
C----   SET THE VERTEX FLAG
      IDATA(NPCGI+20) = HDATA(2*NPVX+2)
      ZVRTX = ADATA(NPVX+4)
C----   LIMIT THE VERTEX POSITION RANGE FOR SAFETY.
      IF( ZVRTX.LT.ZEND(1) ) ZVRTX = ZEND(1)
      IF( ZVRTX.GT.ZEND(2) ) ZVRTX = ZEND(2)
      DZVRTX = ADATA(NPVX+7)
    5 CONTINUE
C
C
        DO 1 N=1,NEND
C----   CHARGE( NO.OF CONNECTED CHARGED TRACK*100+ THE INDEX OF THE 1-ST
C               CANDIDATE)
        IDATA(NPCLS+8) = HCLLSO(1,N)*100+HCLLSO(2,N)
        JEG=0
        ELG=ADATA(NPCLS+2)
C....   SEPARATE GAMMA, ELCTRN/POSTRN * OTHER CHARGED.
        IF(HCLLSO(1,N)-1) 205,202,204
  202   IF(ELG.GT.0.6) GO TO 204
        NC=HCLLSO(2,N)
        PC=CXDCHG(9,NC)
        IF(PC.LT.0.5 .OR. ELG.GT.0.5*PC) GO TO 204
        JEG=2
C----   KINETIC ENERGY FOR PION IS USED.
        EMEV = 1000.*(SQRT(PC*PC+0.0196)-0.14)
        GO TO 206
C
  204   JEG=1
  205   EMEV = ELG*1000.0
C
  206   IPART = IDATA(NPCLS+1)
        IF(IPART) 10,2,10
C
C----   BARREL
    2   ZAV = ADATA(NPCLS+5)
C
C----   AVERAGE DEPTH OF THE SHOWER IS CALCULATED BY ITERATION.
        CALL LGAVDP(ZAV,EMEV,JEG,DEP)
C
C----   SET DIRECTION COSINES
    3   ZZ = ADATA(NPCLS+5)-ZVRTX
        TR = SQRT((RADIUS(3)+DEP)**2+ZZ**2)
        COSTH = ZZ/TR
C----   COSTH CORRECTION
        CALL LGTHCR( ADATA(NPCLS+2),ADATA(NPCLS+15),JEG,COSTH, DCOSTH)
        COSTH = COSTH+DCOSTH
   36   RXY = SQRT(1.0-COSTH*COSTH)
        ADATA(NPCLS+9) = RXY*COS(ADATA(NPCLS+4))
        ADATA(NPCLS+10) = RXY*SIN(ADATA(NPCLS+4))
        ADATA(NPCLS+11) = COSTH
        GO TO 20
C
C----   END CAP (JEG=1 FOR SAFETY REASON)
   10   IF(JEG.EQ.2) JEG=1
        ZAV=ZECAP(IPART+2)
C----     AVERAGE DEPTH OF THE SHOWER IS CALCULATEDBY BY ITERATION
        CALL LGAVDE(ZAV,NPCLS,JEG,DEP)
        ZZ = ZECAP(IPART+2)-ZVRTX+DEP*FLOAT(IPART)
        TR = SQRT(ADATA(NPCLS+4)**2+ADATA(NPCLS+5)**2+ZZ**2)
        ADATA(NPCLS+9) = ADATA(NPCLS+4)/TR
        ADATA(NPCLS+10) = ADATA(NPCLS+5)/TR
        ADATA(NPCLS+11) = ZZ/TR
C
C----   ENERGY CORRECTION FOR DATA, ENERGY SMEARING FOR MC.
   20   CONTINUE
        IF(LSTEP.GT.15) ADATA(NPCLS+16)=ADATA(NPCLS+2)
C           SAVE UNCORRECTED OR UNSMEARED ENERGY (IF MC) IN TO #16.
        IF(HRUN-500) 212,212,213
C          MONTE CARLO
212     CONTINUE
        NPGN=NPR+NPR+2
        HELP(2)=HDATA(NPGN)
C       MCWD=HDATA(NPGN)
C         MCWD BIT;1=UNSMEARED,2=SMEARED AT GENERATION STAGE.
***PMF 26/08/99        ISMR=LAND(IHELP,2)
        ISMR=hLAND(HELP(2),hint(2)) ! PMF 26/90/99 LAND(IHELP,...) replaced by hLAND(HELP(2),hint(...))
C       ISMR=MOD(MCWD,4)
C       IF(ISMR.EQ.2) GO TO 2121
        IF(ISMR.NE.0) GO TO 2121
***PMF 26/08/99        IHELP = LOR(IHELP,4)
        IHELP = hLOR(HELP(2),hint(4))  ! PMF 26/90/99 LOR(IHELP,...) replaced by hLOR(HELP(2),hint(...))
C       HDATA(NPGN)=MCWD+4
        HDATA(NPGN)=HELP(2)
        CALL LGESMR( ADATA(NPCLS+1))
C2121    ISMR=ISHFTR(MCWD,4)
***PMF 26/08/99 2121    ISMR=LAND(IHELP,16)
2121    ISMR=hLAND(HELP(2),hint(16)) ! PMF 26/90/99 LAND(IHELP,...) replaced by hLAND(HELP(2),hint(...))
C         MCWD BIT;16=IF ON, ENERGY LOSS IS IN THE GEN. STAGE.
C       ISMR=MOD(ISMR,2)
        IF(ISMR.EQ.0) GO TO 214
C       HDATA(NPGN)=MCWD+32
        IHELP = LOR(IHELP,32)
        HDATA(NPGN)=HELP(2)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
213   CONTINUE
      IP2  = IDATA(NPCL + 2)
      IPBL = HDATA(2*(NPCL+IP2+N-1)-1)
      IPBL2= HDATA(2*(NPCL+IP2+N-1))
      NRBLOC = IPBL2 - IPBL + 1
C      WRITE(6,1144) NRBLOC
C1144  FORMAT('   LGCDIRNE  NRBLOC =' ,I10)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C                 ENERGY CORRECTION IS TO BE DONE.
        CALL LGECOR( ADATA(NPCLS+1), DEP, NRBLOC, IFLAG )
214     CALL LGEERR( IPART, ADATA(NPCLS+2), ADATA(NPCLS+3))
C
C
        IF(NVECOR) 22,22,21
C----        SUM UP CORRECTED SHOWER ENERGY
   21   IP = INDEX( IPART+2 )
        ADATA(NPCGI+IP) = ADATA(NPCGI+IP)+ADATA(NPCLS+2)
C
C----        SUM UP GAMMA ENERGY
   22   IF(IDATA(NPCLS+8).NE.0) GO TO 50
C----        COUNT NO.OF GAMMAS
        IDATA(NPCGI+11) = IDATA(NPCGI+11)+1
        IP = INDEX( IPART+2 )+5
        ADATA(NPCGI+IP) = ADATA(NPCGI+IP)+ADATA(NPCLS+2)
C
   50   CONTINUE
C----        CHANGE THE POINTER FOR THE NEXT CLUSTER.
        NPCLS = NPCLS+LSTEP
    1   CONTINUE
C
C---- SUM UP ALL ENERGIES.
      ADATA(NPCGI+7) = ADATA(NPCGI+8)+ADATA(NPCGI+9)+ADATA(NPCGI+10)
      ADATA(NPCGI+12) = ADATA(NPCGI+13)+ADATA(NPCGI+14)+ADATA(NPCGI+15)
      GO TO 100
C
C---- WRONG POINTER
   90 MSGVAL(1) = NPPREC
      MSGVAL(2) = NPR
      MSGVAL(3) = NPCL
      CALL LGMESG( 7, 1)
C
  100 RETURN
      END

C   14/10/82            MEMBER NAME  UCOPY    (S)           FORTRAN77
         MACRO
&NAME    ANFANG
&NAME    B     *+12
         DC    AL1(6)
         DC    CL6'&NAME'
         DS    CL1
         STM   2,9,28(13)
         LA    3,SA
         ST    3,8(13)
         ST    13,4(3)
         LR    13,3
         MEND
*
* CALL UCOPY(AVM,XVM,N)
* KEINE UEBERLAPPUNGEN ERLAUBT
*
         START
         ENTRY UCOPY2,VZERO,VBLANK,UZERO,UBLANK
         ENTRY VFILL,VADD,VSUB,VMUL,VDOT,UCOPY
         USING *,15
UCOPY    ANFANG
         LM    2,4,0(1)
         L     5,0(4)        ANZAHL WORTE
         SLL   5,2           LAENGE ZIELFELD
         LR    4,3           ADR. ZIELFELD
         LR    3,5           LAENGE QUELLFELD
         MVCL  4,2           XVM=AVM
         B     REST
*
* CALL UCOPY2(AVM,XVM,N)
* ALLE UEBERLAPPUNGEN ERLAUBT
*
         USING *,15
UCOPY2   ANFANG
         LM    2,4,0(1)
         CLR   2,3           QUELLADR.=ZIELADR.?
         BC    8,REST        WENN Q = Z,DANN FERTIG
         L     5,0(4)        ANZAHL WORTE
         SLL   5,2           LAENGE ZIELFELD
         LR    6,2
         SR    6,3           DIFF. QUELLE-ZIELADR.
         BC    2,NORMAL      DIFF. > 0 , VERZWEIGEN
         LPR   6,6           DIFF.ABS.
         CLR   6,5
         BC    11,NORMAL     DIFF. >= LAENGE ZIEL UND QUELLE, VERZW.
         L     7,=F'-4'
         AR    5,7           LAENGE ZIELFELD MINUS VIER BYTES
SCH1     L     4,0(5,2)      AVM INS R4
         ST    4,0(5,3)      R4 NACH XVM
         BXH   5,7,SCH1      NACH SCH1,WENN R5 GROESSER ALS R7
         B     REST
NORMAL   LR    4,3           ZIELADR.
         LR    3,5           LAENGE QUELLE
         MVCL  4,2           N*4 BYTES SCHIEBEN
         B     REST
*
* CALL VZERO(XVM,N)
*
         USING *,15
VZERO    ANFANG
         LM    2,3,0(1)
         LA    5,0
         L     4,0(3)
         LA    15,SCH2       SPRUNGADR. INS BASISREGISTER
         BR    15            NACH UBLANK
*
* CALL VBLANK(XVM,N)
*
         USING *,15
VBLANK    ANFANG
         LM    2,3,0(1)
         IC    5,=C' '
         L     4,0(3)
         LA    15,SCH2       SPRUNGADR. INS BASISREGISTER
         BR    15            NACH UBLANK
*
* CALL UZERO(XVM,JL,JR)
*
         USING *,15
UZERO    ANFANG
         LM    2,4,0(1)
         LA    5,0
         LA    15,BZ         SPRUNGADR. INS BASISREGISTER
         BR    15            NACH UBLANK
*
* CALL UBLANK(XVM,JL,JR)
*
         USING *,15
UBLANK   ANFANG
         LM    2,4,0(1)
         IC    5,=C' '
         LA    15,BZ
*
         USING *,15
BZ       L     3,0(3)        JL
         L     4,0(4)        JR
         BCTR  3,0           JL-1
         SR    4,3           JR-(JL-1)
         SLL   3,2
         AR    2,3           ANFADR. ZIELFELD
         LA    15,SCH2
*
         USING *,15
SCH2     SLL   4,2           LAENGE ZIELFELD
         LR    3,4
         LA    4,1(2)        DUMMYADR. QUELLE
         SLL   5,24          PADDING CHAR.  COUNT=0
         MVCL  2,4           KEIN MOVEN, NUR PADDING
         B     REST
*
* CALL VFILL(XVM,N,CM)
*
         USING *,15
VFILL    ANFANG
         LM    2,4,0(1)
         L     4,0(4)        CM
         L     3,0(3)        N
         L     5,=F'-4'
         SLL   3,2           N*4
         AR    3,5           N*4-4
SCH7     ST    4,0(3,2)
         BXH   3,5,SCH7
         B     REST
*
* CALL VADD(AV,BV,XV,N)
*
         USING *,15
VADD     ANFANG
         LM    2,5,0(1)
         L     9,0(5)        N
         SLL   9,2           N*4
         LA    8,4
         SR    9,8           N*4-4
         SR    7,7
SCH3     LE    6,0(7,2)      AV
         AE    6,0(7,3)      AV+BV
         STE   6,0(7,4)      XV=AV+BV
         BXLE  7,8,SCH3      NACH SCH3,WENN R7 KLEINER GLEICH R9
         B     REST
*
* CALL VSUB(AV,BV,XV,N)
*
         USING *,15
VSUB     ANFANG
         LM    2,5,0(1)
         L     9,0(5)        N
         SLL   9,2           N*4
         LA    8,4
         SR    9,8           N*4-4
         SR    7,7
SCH4     LE    6,0(7,2)      AV
         SE    6,0(7,3)      AV-BV
         STE   6,0(7,4)      XV=AV-BV
         BXLE  7,8,SCH4      NACH SCH4,WENN R7 KLEINER GLEICH R9
         B     REST
*
* CALL VMUL(AV,BV,XV,N)
*
         USING *,15
VMUL      ANFANG
         LM    2,5,0(1)
         L     9,0(5)        N
         SLL   9,2           N*4
         LA    8,4
         SR    9,8           N*4-4
         SR    7,7
SCH5     LE    6,0(7,2)      AV
         ME    6,0(7,3)      AV*BV
         STE   6,0(7,4)      XV=AV*BV
         BXLE  7,8,SCH5      NACH SCH5,WENN R7 KLEINER GLEICH R9
         B     REST
*
* CALL X=VDOT(AV,BV,N)
* X=AV(1)*BV(1)+AV(2)*BV(2)+...+AV(N)*BV(N)
*
         USING *,15
VDOT     ANFANG
         LM    2,4,0(1)
         L     7,0(4)        N
         SLL   7,2           N*4
         LA    6,4
         SR    7,6           N*4-4
         SER   0,0
         SR    5,5
SCH6     LE    4,0(5,2)      AV
         ME    4,0(5,3)      AV*BV
         AER   0,4           REGISTER 0 PLUS AV*BV
         BXLE  5,6,SCH6      NACH SCH6,WENN R5 KLEINER GLEICH R7
*
REST     L     13,4(13)      RESTAURIEREN
         LM    2,9,28(13)
         MVI   12(13),X'FF'
         BR    14
*
*     DATEN
*
SA       DS    18F
         END

C   25/11/83 312082016  MEMBER NAME  NEWCAL   (JADEGS)      FORTRAN
      SUBROUTINE NEWCAL
C
C  JADE GRAPHICS ROUTINE:   DOES A COMPLETE RECALIBRATION OF LEADGLASS
C                           AND JET CHAMBER DATA, AND CALLS LEADGLASS
C                           ANALYSIS AND PATTERN RECOGNITION.
C     LAST CHANGE 08.12.83                    J.OLSSON  25.11.83
C
      IMPLICIT INTEGER*2 (H)
      COMMON /CLGPRM/ ITH
#include "cgraph.for"
#include "cdata.for"
      COMMON /CHEADR/ HEAD(108)
      COMMON /CNWCAL/ IFILE
C
C  IF TRAILING PARAMETER NONZERO, INTERPRET AS CLUSTER THRESHOLD
C
      ITH = 45
      NN = ACMD
      IF(NN.GT.0) ITH = NN
C
      IF(HEAD(18).LT.100) CALL TRMOUT(80,' NO RECALIBRATION IN MC..^')
      IF(HEAD(18).LT.100) RETURN
C
      IF(IFILE.NE.0) GO TO 2201
      CALL TRMOUT(80,'FOR LG RECALIBR., YOU NEED BUPDAT0 AND BUPDAT1. YO
     $U HAVE ALLOCATED AUPDAT1^')
      CALL TRMOUT(80,'THEREFORE ONLY JETC DATA WILL BE RECALIBRATED^')
      GO TO 2202
2201  CALL BDLS('ALGN',1)
      CALL BDLS('LGCL',1)
C  DELETE ALREADY CALIBRATED JETC BANK AND RENUMBER UNCALIBRATED JETC
2202  IPNJET=IDATA(IBLN('JETC'))
      IF(IPNJET.LE.0) GO TO 1
      NUMJET=IDATA(IPNJET-2)
      IPNNEX=IDATA(IPNJET-1)
      IF(IPNNEX.LE.0) GO TO 411
      NUMNEX=IDATA(IPNNEX-2)
      CALL BDLS('JETC',NUMJET)
      CALL BRNM('JETC',NUMNEX,'JETC',NUMJET)
411   CONTINUE
      IPGVTX = IDATA(IBLN('GVTX'))
      IF(IPGVTX.LE.0) GO TO 3012
      NRGVTX = IDATA(IPGVTX - 2)
      CALL BDLS('GVTX',NRGVTX)
3012  IPDEDX = IDATA(IBLN('DEDX'))
      IF(IPDEDX.LE.0) GO TO 3013
      NRDEDX = IDATA(IPDEDX - 2)
      CALL BDLS('DEDX',NRDEDX)
3013  IPTOFR = IDATA(IBLN('TOFR'))
      IF(IPTOFR.LE.0) GO TO 3014
      NRTOFR = IDATA(IPTOFR - 2)
      CALL BDLS('TOFR',NRTOFR)
3014  CALL BGAR(IGA)
      CALL TRMOUT(80,'OLD BANKS DELETED (ALGN,LGCL,JETC,DEDX,TOFR,GVTX)
     $...^')
C
C  AFTER DELETION OF OLD BANKS, NOW RECALIBRATE
C
      IF(IFILE.NE.0) CALL LGCALB(*1225)
      GO TO 731
1225  CALL TRMOUT(80,'LEAD GLASS CALIBRATION HAS ABENDED..')
731   CALL JETCAL
      CALL TRMOUT(80,'LEADGLASS / JETCHAMBER DATA WERE RECALIBRATED^')
C
C Z-RECALIBRATION
C
      MODE = 1
      CALL ZSFIT(MODE,0,0,0,0,1) ! PMF 03/12/99: four dummy arguments + 6th argument added
      CALL TRMOUT(80,' Z-RECALIBRATION HAS BEEN PERFORMED,MODE=1...^')
C
C NOW CALL ANALYSIS ROUTINES
C
      CALL PATREC(0)
C
      IF(IFILE.EQ.0) GO TO 6600
      IF(ITH.NE.45) WRITE(6,1301) ITH
1301  FORMAT(' NON STANDARD THRESHOLD IN CLUSTER SEARCH:',I4,' MEV')
      CALL LGANAL
6600  IPPATR = IDATA(IBLN('PATR'))
      IPALGN = IDATA(IBLN('ALGN'))
      IPLGCL = IDATA(IBLN('LGCL'))
      CALL LGCDIR(IPPATR,IPALGN,IPLGCL)
      CALL TRMOUT(80,'PATREC,LGANAL / LGCDIR HAVE BEEN CALLED..^')
      RETURN
1     CONTINUE
      WRITE(6,5201)
5201  FORMAT(' NO JETC BANK, RECALIBRATION WILL NOT BE DONE...')
      RETURN
      END

C   14/12/79 912140748  MEMBER NAME  @LGPROD  (SOURCE)      FORTRAN
C
C    S.YAMADA   09-03-79  10:25
C     LAST MODIFICATION   09-03-79  23:25
C
C---- SIMPLE TEST PROGRAM FOR LGANAL FOR REAL DATA.
C
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(24000)
      DIMENSION  ADATA(24000),HDATA(48000)
      EQUIVALENCE (IDATA(1),ADATA(1)), (HDATA(1),IDATA(1))
C
      COMMON /CLGMSB/ MSGVAL(5)
C
C---- INITIALIZATION
      DATA NUNITO,RPATR,RHEAD,RALGN,RLGCL/2,4HPATR,4HHEAD,4HALGN,4HLGCL/
      CALL BINT(24000,4000,500,0)
      CALL BINT1(200,100,10,0)
      CALL BWRO( NUNITO, 1558, 2)
C
      CALL LGINIT
C
        DO 1000 N=1,99999
        NTIM=JUHR(2)
        IF(NTIM.EQ.2) GO TO 300
C
        DATA NUNITI/1/
        CALL BREAD(NUNITI,&200,&200)
          IPNPHD = IBLN(RHEAD)
          NPHD = IDATA(IPNPHD)
          IF(NPHD.LE.0) GO TO 20
          NHPHD = NPHD+NPHD
C         HEXP=HDATA(NHPHD+ 9)
C         HRUN=HDATA(NHPHD+10)
C
          IPP = IBLN(RPATR)
          NPPR = IDATA(IPP)
        CALL LGANAL
C
C----   SECOND STEP ANALYSIS
C       POINTERS OF THE NECESSARY BANKS
        NPR = 0
        NPCL = 0
C----   SHIFT NPPATR BY 1 TO SKIP THE BANK-DESCRIPTER WORD IF IT'S THERE
        CALL CLOC( NPR,    RALGN,1)
        CALL CLOC( NPCL,   RLGCL,1)
        IF(NPCL) 90,90,10
C
C----   SOME BANK IS MISSING
   90   MSGVAL(1) =  NPPR
        MSGVAL(2) =  NPR
        MSGVAL(3) =  NPCL
        CALL LGMESG( 1, 2 )
        GO TO 20
C
   10   CALL LGCDIR( NPPR, NPR, NPCL )
20      CONTINUE
        CALL BSLW
        CALL BWRITE(NUNITO)
        CALL BSLT
        CALL BDLG
C
 1000   CONTINUE
      GO TO 100
  200 MSGVAL(1) = N
      CALL LGMESG( 1,1 )
      GO TO 100
300   WRITE(6,6200) N,(HDATA(HNPHD+J),J=9,11)
6200  FORMAT(' TIME OUT AT REC#,EXP#,RUN#,EV#',10I6)
100   CONTINUE
      CALL BMLT(0,DUMMY)
      CALL BWRITE(NUNITO)
      CALL BSLT
      CALL BDLG
      STOP
      END

C   31/08/79 C9083101   MEMBER NAME  EVDUMP   (JADENS)      FORTRAN
      SUBROUTINE EVDUMP
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cgraph.for"
      IHHEAD=2*IDATA(IBLN('HEAD'))
      NRUN=HDATA(IHHEAD+10)
      NEVT=HDATA(IHHEAD+11)
      WRITE(JUSCRN,100)
  100 FORMAT('1 EVENT DUMP ROUTINE CALLED.',/)
      WRITE(JUSCRN,101) NRUN, NEVT, ICREC
  101 FORMAT('  RUN',I6,' EVENT',I6,' SEQUENTIAL RECORD',I8,/)
      CALL BSLW
      CALL BPRL(1000)
      RETURN
      END

C     USED IN LGCDIR PART OF ANALYSIS
C     INCREASE UP TO 100 TRACKS ON 20/9/79
      COMMON /CWORK/ NCHCLS,NPOINT,MAPCCL(101),HCLADR(1600),
     $               NCHCL2,HCLIST(4,100),  NCLST2,HCLLSO(4,80)
      DATA NPMAX/1600/

C   24/07/79 C9082301   MEMBER NAME  ANOM02   (S)           FORTRAN
      SUBROUTINE ANOM02(IRUN)
C---  ANOMALIES OF RUNS 581 - 672
C---  13.86 GEV     JUNE 1979
C
C     H.WRIEDT    24.07.79     23:45
C     LAST MODIFICATION     23.08.79     15:15
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (581,582,11,584,11,586,587,588,589,590,591,592,593,594,595,
     &      596,597,598,599,600,601,602,603,604,605,606,607,608,609,
     &      610,611,612,613,614,11,616,617,618,619,620,621,622,623,624,
     &      11,11,11,11,11,630,631,632,633,634,635,636,637,638,639,640,
     &      641,642,643,644,645,646,647,648,649,650,651,11,11,654,655,
     &      656,657,658,659,660,661,662,663,664,665,666,667,668,669,
     &      670,671,672),IRUN
   11 RETURN
C
  581 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
C
      LTHRES(59) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  582 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  584 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 195
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 225
      KCONST(190) = -1
      LIMIT(190) = 195
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(86) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(97) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  586 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 300
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  587 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 330
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  588 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(33) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(60) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(129) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  589 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  590 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(173) = -1
      LIMIT(173) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  591 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(168) = -1
      LIMIT(168) = 255
      KCONST(190) = -1
      LIMIT(190) = 240
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  592 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(79) = +1
      LIMIT(79) = 390
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(166) = -1
      LIMIT(166) = 360
C
      LTHRES(11) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(27) = .TRUE.
      LTHRES(33) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(97) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  593 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(23) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  594 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  595 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  596 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  597 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  598 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(168) = -1
      LIMIT(168) = 270
      KCONST(190) = -1
      LIMIT(190) = 240
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  599 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  600 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  601 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(33) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  602 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  603 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 195
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 255
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(21) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  604 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  605 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(21) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  606 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  607 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  608 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  609 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  610 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(190) = -1
      LIMIT(190) = 240
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  611 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  612 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 375
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
C
      RETURN
C
  613 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(53) = -1
      LIMIT(53) = 180
      KCONST(54) = -1
      LIMIT(54) = 225
      KCONST(58) = -1
      LIMIT(58) = 225
      KCONST(59) = -1
      LIMIT(59) = 210
      KCONST(63) = -1
      LIMIT(63) = 150
      KCONST(69) = -1
      LIMIT(69) = 120
      KCONST(72) = -1
      LIMIT(72) = 210
      KCONST(84) = -1
      LIMIT(84) = 180
      KCONST(85) = -1
      LIMIT(85) = 225
      KCONST(87) = -1
      LIMIT(87) = 180
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(11) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(27) = .TRUE.
      LTHRES(33) = .TRUE.
      LTHRES(52) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(62) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(70) = .TRUE.
      LTHRES(71) = .TRUE.
      LTHRES(76) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(81) = .TRUE.
      LTHRES(83) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(88) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(90) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(92) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(105) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  614 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  616 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(168) = -1
      LIMIT(168) = 255
      KCONST(183) = -1
      LIMIT(183) = 255
      KCONST(190) = -1
      LIMIT(190) = 240
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  617 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  618 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  619 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  620 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  621 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  622 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  623 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(85) = -1
      LIMIT(85) = 240
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(148) = -1
      LIMIT(148) = 165
      KCONST(149) = -1
      LIMIT(149) = 240
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(164) = -1
      LIMIT(164) = 210
      KCONST(166) = -1
      LIMIT(166) = 300
      KCONST(167) = -1
      LIMIT(167) = 240
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(23) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(145) = .TRUE.
      LTHRES(148) = .TRUE.
      LTHRES(151) = .TRUE.
      LTHRES(156) = .TRUE.
      LTHRES(159) = .TRUE.
      LTHRES(165) = .TRUE.
      LTHRES(169) = .TRUE.
      LTHRES(170) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(174) = .TRUE.
      LTHRES(175) = .TRUE.
      LTHRES(176) = .TRUE.
      LTHRES(177) = .TRUE.
      LTHRES(180) = .TRUE.
      LTHRES(182) = .TRUE.
      LTHRES(186) = .TRUE.
      LTHRES(188) = .TRUE.
C
      RETURN
C
  624 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(145) = -1
      LIMIT(145) = 225
      KCONST(151) = -1
      LIMIT(151) = 255
      KCONST(159) = -1
      LIMIT(159) = 210
      KCONST(165) = -1
      LIMIT(165) = 195
      KCONST(170) = -1
      LIMIT(170) = 240
      KCONST(172) = -1
      LIMIT(172) = 135
      KCONST(174) = -1
      LIMIT(174) = 180
      KCONST(176) = -1
      LIMIT(176) = 150
      KCONST(177) = -1
      LIMIT(177) = 150
      KCONST(180) = -1
      LIMIT(180) = 120
      KCONST(182) = -1
      LIMIT(182) = 135
      KCONST(186) = -1
      LIMIT(186) = 165
      KCONST(188) = -1
      LIMIT(188) = 120
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(145) = .TRUE.
      LTHRES(151) = .TRUE.
      LTHRES(159) = .TRUE.
      LTHRES(165) = .TRUE.
      LTHRES(170) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(174) = .TRUE.
      LTHRES(176) = .TRUE.
      LTHRES(177) = .TRUE.
      LTHRES(180) = .TRUE.
      LTHRES(182) = .TRUE.
      LTHRES(186) = .TRUE.
      LTHRES(188) = .TRUE.
C
      RETURN
C
  630 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  631 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(190) = -1
      LIMIT(190) = 240
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  632 LCHANN(79) = .TRUE.
      LCHANN(105) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  633 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(131) = -1
      LIMIT(131) = 195
      KCONST(139) = -1
      LIMIT(139) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(145) = -1
      LIMIT(145) = 240
      KCONST(148) = -1
      LIMIT(148) = 195
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(151) = -1
      LIMIT(151) = 255
      KCONST(157) = -1
      LIMIT(157) = 255
      KCONST(158) = -1
      LIMIT(158) = 270
      KCONST(159) = -1
      LIMIT(159) = 210
      KCONST(165) = -1
      LIMIT(165) = 210
      KCONST(170) = -1
      LIMIT(170) = 255
      KCONST(172) = -1
      LIMIT(172) = 135
      KCONST(174) = -1
      LIMIT(174) = 180
      KCONST(176) = -1
      LIMIT(176) = 150
      KCONST(177) = -1
      LIMIT(177) = 150
      KCONST(180) = -1
      LIMIT(180) = 120
      KCONST(182) = -1
      LIMIT(182) = 150
      KCONST(186) = -1
      LIMIT(186) = 165
      KCONST(188) = -1
      LIMIT(188) = 135
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(131) = .TRUE.
      LTHRES(139) = .TRUE.
      LTHRES(145) = .TRUE.
      LTHRES(148) = .TRUE.
      LTHRES(149) = .TRUE.
      LTHRES(151) = .TRUE.
      LTHRES(157) = .TRUE.
      LTHRES(158) = .TRUE.
      LTHRES(159) = .TRUE.
      LTHRES(165) = .TRUE.
      LTHRES(170) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(174) = .TRUE.
      LTHRES(176) = .TRUE.
      LTHRES(177) = .TRUE.
      LTHRES(180) = .TRUE.
      LTHRES(182) = .TRUE.
      LTHRES(186) = .TRUE.
      LTHRES(188) = .TRUE.
C
      RETURN
C
  634 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  635 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 345
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  636 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  637 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  638 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  639 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  640 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  641 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  642 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  643 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  644 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  645 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  646 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  647 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
C
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  648 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  649 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  650 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  651 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  654 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(23) = .TRUE.
      LTHRES(27) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  655 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  656 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  657 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 375
      KCONST(149) = -1
      LIMIT(149) = 315
      KCONST(150) = -1
      LIMIT(150) = 300
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(164) = -1
      LIMIT(164) = 285
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(168) = -1
      LIMIT(168) = 255
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
      KCONST(190) = -1
      LIMIT(190) = 240
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
  658 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  659 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(164) = -1
      LIMIT(164) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  660 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  661 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(93) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  662 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 195
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  663 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  664 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  665 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  666 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 315
C
      LTHRES(1) = .TRUE.
      LTHRES(20) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  667 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(150) = -1
      LIMIT(150) = 270
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(1) = .TRUE.
      LTHRES(20) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  668 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 210
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(162) = -1
      LIMIT(162) = 210
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(168) = -1
      LIMIT(168) = 255
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(183) = -1
      LIMIT(183) = 255
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(1) = .TRUE.
      LTHRES(20) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(54) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(87) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
  669 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 345
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(1) = .TRUE.
      LTHRES(20) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  670 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(149) = -1
      LIMIT(149) = 285
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(1) = .TRUE.
      LTHRES(20) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  671 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 285
      KCONST(178) = -1
      LIMIT(178) = 300
      KCONST(185) = -1
      LIMIT(185) = 300
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(1) = .TRUE.
      LTHRES(20) = .TRUE.
      LTHRES(23) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(58) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
C
      RETURN
C
  672 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(140) = -1
      LIMIT(140) = 360
      KCONST(149) = -1
      LIMIT(149) = 300
      KCONST(166) = -1
      LIMIT(166) = 360
      KCONST(167) = -1
      LIMIT(167) = 300
      KCONST(178) = -1
      LIMIT(178) = 315
      KCONST(185) = -1
      LIMIT(185) = 315
      KCONST(187) = -1
      LIMIT(187) = 300
C
      LTHRES(1) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(112) = .TRUE.
C
      RETURN
C
      END

C   07/06/96 606071859  MEMBER NAME  PCOND    (S4)          FORTG1
      SUBROUTINE PCOND
      COMMON/BCS/IW(1)
      INTEGER*2 NH(2)
      EQUIVALENCE (NF,NH(1))
      INTEGER NLT(16)
      NN=0
      M=0
      CALL BPOS('CON*')
   80 CALL BNXT(K,&98)
      IF(M.EQ.0) WRITE(6,101)
      M=1
      N=IW(K)
      NF=IW(K-2)
C     WRITE(6,103) NF,NH
C 103 FORMAT(1X,10I12)
      NF=NF
      IF(NN.EQ.0) GOTO 81
      IF(NH(1).EQ.NLT(1)) GOTO 90
      WRITE(6,102)      (NLT(J),J=1,NN)
   81 NN=1
   90 NLT(1)=NH(1)
      DO 96 L=1,8
      IF(IW(K+L).EQ.0) GOTO 96
      IF(NN.LT.16) GOTO 94
      WRITE(6,102)      (NLT(J),J=1,NN)
      NN=1
   94 NLT(NN+1)=IW(K+L)
      NLT(NN+2)=NH(1)
      NLT(NN+3)=NH(2)-1+L
C     NLT(NN+3)=NLT(NN+3)+L-1
C     NLT(NN+3)=NH(2)
      NN=NN+3
   96 IW(K+L)=0
      CALL BDLS('CON*',NF)
      GOTO 80
   98 IF(NN.EQ.0) GOTO 99
      WRITE(6,102)      (NLT(J),J=1,NN)
   99 CONTINUE
      RETURN
  101 FORMAT('0---',7('----')/' UCOND',4X,'ENTRIES *(    I,'
     1   ,'    J)')
  102 FORMAT(' I=',I5,5(I 9,' *(',I5,',',I5,')'))
      END

C   09/10/79 911301222  MEMBER NAME  ANOM63   (S)           FORTRAN
      SUBROUTINE ANOM63(IRUN)
C---  ANOMALIES OF RUNS 1578 - 1604
C---  15.27 GEV      SEPTEMBER 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     30.11.79     12:00
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1578,1579,13,13,13,13,13,13,13,13,13,13,13,1591,1592,1593,
     &      1594,13,1596,1597,13,1599,1600,1601,1602,1603,1604),IRUN
   13 RETURN
C
 1578 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1579 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
C
      RETURN
C
 1591 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 240
      KCONST(117) = -1
      LIMIT(117) = 75
      KCONST(118) = -1
      LIMIT(118) = 150
      KCONST(145) = -1
      LIMIT(145) = 90
      KCONST(148) = -1
      LIMIT(148) = 105
      KCONST(150) = -1
      LIMIT(150) = 345
      KCONST(151) = -1
      LIMIT(151) = 180
      KCONST(153) = -1
      LIMIT(153) = 300
      KCONST(155) = -1
      LIMIT(155) = 240
      KCONST(166) = -1
      LIMIT(166) = 420
      KCONST(169) = -1
      LIMIT(169) = 75
      KCONST(171) = -1
      LIMIT(171) = 150
      KCONST(185) = -1
      LIMIT(185) = 360
C
      LTHRES(118) = .TRUE.
      LTHRES(177) = .TRUE.
C
      RETURN
C
 1592 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
        DO 15920 I = 97,142
15920   KCONST(I) = -10
      KCONST(97) = -1
      LIMIT(97) = 285
      KCONST(101) = -1
      LIMIT(101) = 150
      KCONST(166) = -1
      LIMIT(166) = 435
      KCONST(185) = -1
      LIMIT(185) = 360
C
      LTHRES(27) = .TRUE.
      LTHRES(97) = .TRUE.
      LTHRES(101) = .TRUE.
        DO 15921 I = 145,190
15921   LTHRES(I) = .TRUE.
C
      RETURN
C
 1593 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
        DO 15930 I = 97,142
15930   KCONST(I) = -10
      KCONST(166) = -1
      LIMIT(166) = 435
      KCONST(185) = -1
      LIMIT(185) = 375
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(51) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(68) = .TRUE.
      LTHRES(74) = .TRUE.
      LTHRES(79) = .TRUE.
      LTHRES(80) = .TRUE.
        DO 15931 I = 145,190
15931   LTHRES(I) = .TRUE.
C
      RETURN
C
 1594 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
        DO 15940 I = 97,142
15940   KCONST(I) = -10
      KCONST(146) = -1
      LIMIT(146) = 330
      KCONST(150) = -1
      LIMIT(150) = 330
      KCONST(158) = -1
      LIMIT(158) = 345
      KCONST(164) = -1
      LIMIT(164) = 345
      KCONST(166) = -1
      LIMIT(166) = 435
      KCONST(167) = -1
      LIMIT(167) = 330
      KCONST(185) = -1
      LIMIT(185) = 375
C
      RETURN
C
 1596 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(154) = -1
      LIMIT(154) = 45
      KCONST(166) = -1
      LIMIT(166) = 420
      KCONST(185) = -1
      LIMIT(185) = 360
C
      LTHRES(49) = .TRUE.
      LTHRES(154) = .TRUE.
C
      RETURN
C
 1597 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 420
C
      RETURN
C
 1599 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(97) = -1
      LIMIT(97) = 240
      KCONST(117) = -1
      LIMIT(117) = 60
      KCONST(166) = -1
      LIMIT(166) = 420
      KCONST(185) = -1
      LIMIT(185) = 360
C
      LTHRES(154) = .TRUE.
C
      RETURN
C
 1600 LCHANN(49) = .TRUE.
      LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
        DO 16000 I = 97,103
16000   KCONST(I) = -10
      KCONST(123) = -10
      KCONST(125) = -10
      KCONST(130) = -10
      KCONST(133) = -10
      KCONST(134) = -10
      KCONST(140) = -10
      KCONST(55) = -1
      LIMIT(55) = 45
      KCONST(67) = -1
      LIMIT(67) = 30
      KCONST(166) = -1
      LIMIT(166) = 435
      KCONST(185) = -1
      LIMIT(185) = 360
C
      LTHRES(7) = .TRUE.
      LTHRES(51) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(68) = .TRUE.
      LTHRES(74) = .TRUE.
      LTHRES(75) = .TRUE.
      LTHRES(80) = .TRUE.
C
      RETURN
C
 1601 LCHANN(49) = .TRUE.
      LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
        DO 16010 I = 97,142
16010   KCONST(I) = -10
      KCONST(55) = -1
      LIMIT(55) = 45
      KCONST(67) = -1
      LIMIT(67) = 30
      KCONST(166) = -1
      LIMIT(166) = 450
      KCONST(185) = -1
      LIMIT(185) = 375
C
      LTHRES(7) = .TRUE.
      LTHRES(51) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(68) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(146) = .TRUE.
      LTHRES(150) = .TRUE.
      LTHRES(158) = .TRUE.
      LTHRES(164) = .TRUE.
      LTHRES(167) = .TRUE.
C
      RETURN
C
 1602 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
        DO 16020 I = 97,142
16020   KCONST(I) = -10
      KCONST(151) = -1
      LIMIT(151) = 180
      KCONST(158) = -1
      LIMIT(158) = 345
      KCONST(164) = -1
      LIMIT(164) = 345
      KCONST(166) = -1
      LIMIT(166) = 435
      KCONST(185) = -1
      LIMIT(185) = 360
C
      LTHRES(51) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(68) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(80) = .TRUE.
        DO 16021 I = 145,190
16021   LTHRES(I) = .TRUE.
C
      RETURN
C
 1603 LCHANN(49) = .TRUE.
      LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
        DO 16030 I = 97,142
16030   KCONST(I) = -10
      KCONST(145) = -1
      LIMIT(145) = 90
      KCONST(151) = -1
      LIMIT(151) = 195
      KCONST(164) = -1
      LIMIT(164) = 330
      KCONST(166) = -1
      LIMIT(166) = 435
      KCONST(169) = -1
      LIMIT(169) = 90
      KCONST(185) = -1
      LIMIT(185) = 360
C
        DO 16031 I = 145,190
16031   LTHRES(I) = .TRUE.
C
      RETURN
C
 1604 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(7) = -1
      LIMIT(7) = 45
      KCONST(49) = -1
      LIMIT(49) = 90
      KCONST(51) = -1
      LIMIT(51) = 75
      KCONST(55) = -1
      LIMIT(55) = 90
      KCONST(61) = -1
      LIMIT(61) = 105
      KCONST(67) = -1
      LIMIT(67) = 90
      KCONST(68) = -1
      LIMIT(68) = 60
      KCONST(74) = -1
      LIMIT(74) = 135
      KCONST(97) = -1
      LIMIT(97) = 255
      KCONST(98) = -1
      LIMIT(98) = 390
      KCONST(99) = -1
      LIMIT(99) = 330
      KCONST(100) = -1
      LIMIT(100) = 360
      KCONST(103) = -1
      LIMIT(103) = 300
      KCONST(105) = -1
      LIMIT(105) = 270
      KCONST(110) = -1
      LIMIT(110) = 270
      KCONST(123) = -1
      LIMIT(123) = 390
      KCONST(125) = -1
      LIMIT(125) = 330
      KCONST(130) = -1
      LIMIT(130) = 330
      KCONST(133) = -1
      LIMIT(133) = 360
      KCONST(134) = -1
      LIMIT(134) = 480
      KCONST(140) = -1
      LIMIT(140) = 510
      KCONST(142) = -1
      LIMIT(142) = 270
      KCONST(146) = -1
      LIMIT(146) = 390
      KCONST(147) = -1
      LIMIT(147) = 360
      KCONST(150) = -1
      LIMIT(150) = 390
      KCONST(158) = -1
      LIMIT(158) = 390
      KCONST(161) = -1
      LIMIT(161) = 390
      KCONST(164) = -1
      LIMIT(164) = 390
      KCONST(166) = -1
      LIMIT(166) = 435
      KCONST(167) = -1
      LIMIT(167) = 390
      KCONST(185) = -1
      LIMIT(185) = 420
C
      LTHRES(7) = .TRUE.
      LTHRES(49) = .TRUE.
      LTHRES(51) = .TRUE.
      LTHRES(55) = .TRUE.
      LTHRES(61) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(68) = .TRUE.
      LTHRES(74) = .TRUE.
      LTHRES(80) = .TRUE.
      LTHRES(89) = .TRUE.
      LTHRES(90) = .TRUE.
C
      RETURN
C
      END

C   21/11/78 C9071601   MEMBER NAME  ZBOS08   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------800000200
C     8.  UNFORMATED INPUT/OUTPUT OF BANKS
C
C     BANK RECORDS ARE OF THE FORM
C        NTOT, BANK1, BANK2, . . . BANKN
C     WITH NTOT = NR OF WORDS OF ALL BANKS, THE TOTAL NR OF (USED)
C     WORDS IN A RECORD IS THEREFORE NRECL = NTOT +1.
C
C        FIRST WORD IN RECORD   = NTOT
C        NEXT WORD              = NAME
C        NEXT WORD              = NUMBER OF FIRST BANK
C        NEXT WORD              = POINTER (NO MEANING IN RECORD)
C        NEXT WORD              = NR.OF WORDS OF THE FIRST BANK
C        ETC.
C
C
C
C
C     8.1 STANDARD OUTPUT AND INPUT
C
C
C     OUTPUT IS DONE BY FIRST SELECTING THE NAMES OF ALL BANKS
C     TO BE WRITTEN AND THEN BY CALLING THE OUTPUT PROGRAM. THE
C     SET OF BANKS DEFINES ONE EVENT. IF THE EVENT IS WRITTEN,
C     THE ORDER OF THE BANKS IS ALWAYS THE SAME AS WITHIN THE LIST,
C     WITH BANKS OF THE SAME NAME IN THE ORDER OF INCREASING NUMBER.
C     ALL BANKS OF ONE EVENT ARE READ INTO THE COMMON/BCS/ BY
C     ONE CALL OF THE INPUT PROGRAM.
C
C
C
C
C
C
C
C     OUTPUT OF ONE EVENT
C
C        CALL BSLW               OR  CALL BMLT(N,LIST OF NAMES)
C
C
C        CALL BWRITE(IUN)
C
C     AFTER THE LAST EVENT, A ZERO LIST OF NAMES HAS TO BE DEFINED
C     AND BWRITE HAS TO BE CALLED AGAIN.
C
C        CALL BMLT(0,DUMMY)
C        CALL BWRITE(IUN)
C
C
C
C     INPUT OF ONE EVENT
C
C        CALL BREAD(IUN,&1,&2)         CALL CREAD(IUN,IER)
C
C     SPECIAL CONDITIONS
C
C                      BREAD                    CREAD
C
C     READ ERROR       RETURN1 (&1)             IER=1
C     END-OF-DATA      RETURN2 (&2)             IER=2
C
C
C
C     8.2 OUTPUT MODES AND RECORD TYPES
C
C
C     THERE ARE TWO TYPES OF RECORDS AND THREE MODES OF OUTPUT.
C
C     TYPES OF RECORDS
C
C     S-RECORDS     ONE RECORD CONTAINS ONE EVENT
C
C     M-RECORDS     ONE RECORD MAY CONTAIN SEVERAL EVENTS OR PARTS
C                   OF EVENTS. WITHIN THE RECORD, EVENTS OR PARTS
C                   OF EVENTS ARE WITHIN BANKS WITH THE NAME 'HIDD'.
C
C     FOR BOTH RECORD TYPES, THE INPUT PROGRAM ALWAYS PUTS THE
C     BANKS OF ONE EVENT INTO COMMON/BCS/.
C
C     THE OUTPUT MODE AND A MAXIMUM RECORD LENGTH IS DEFINED BY ONE
C     CALL (BEFORE THE FIRST CALL OF THE OUTPUT PROGRAM) FOR THE
C     OUTPUT UNIT IUNIT.
C
C                  ----- ----- ----
C        CALL BWRO(IUNIT,NRECL,MODE)
C
C     IF NOT CALLED, MODE = 0 IS ASSUMED WITH NRECL TAKEN FROM THE
C     CALL TO THE BOS INITIALIZATION PROGRAM BINT (SEE CH. 1).
C
C
C
C
C     MODES OF OUTPUT
C
C     MODE = 0     S-RECORDS ARE WRITTEN. THE EVENT IS NOT WRITTEN, IF
C                  THE LENGTH OF THE EVENT EXCEEDS NRECL WORDS.
C
C     MODE = 1     S-RECORDS OR M-RECORDS ARE WRITTEN. M-RECORDS ARE
C                  WRITTEN, IF THE LENGTH OF ONE EVENT EXCEEDS NRECL
C                  WORDS.
C
C     MODE = 2     M-RECORDS ARE WRITTEN.
C
C     THE RECORD LENGTH WILL NEVER EXCEED NRECL WORDS. IT IS POSSIBLE
C     (AND DONE IN BWRITE), TO WRITE RECORDS OF FIXED LENGTH NRECL
C     (ADDING UNUSED WORDS, IF NTOT IS LESS THAN NRECL - 1)
C
C
C     8.3 USER WRITE AND READ STATEMENTS
C
C     THE USER CAN USE HIS OWN WRITE AND READ STATEMENTS, TO ALLOW
C     E.G. USING THE IBM-FORTRAN DIRECT ACCESS STATEMENTS.
C     FOR OUTPUT THE STATEMENT CALL BWRITE(IUN) HAS TO BE REPLACED
C     (ALSO FOR THE CALL AFTER THE LAST EVENT) BY THE FOLLOWING
C     STATEMENTS.
C
C        1  CALL BWRS(IUN,NREC,INIW)
C           IF(INIW.EQ.0) GOTO 2
C           WRITE ONE RECORD ON UNIT IUN OF TOTAL NREC WORDS
C           IW(INIW),IW(INIW+1), . . . IW(INIW+NREC-1)
C           GOTO 1
C        2  CONTINUE
C
C     REMARK. IW(INIW) CONTAINS NTOT. FOR MODE = 0 OR = 1, NREC
C     IS EQUAL TO NTOT+1, FOR MODE = 2 NREC IS EQUAL TO NRECL
C     (FIXED NUMBER OF WORDS).
C
C
C     FOR INPUT THE STATEMENT CALL BREAD(IUN,&1,&2) HAS TO BE
C     REPLACED BY THE FOLLOWING STATEMENTS.
C
C
C        1  CALL BRDS(IUN,NREC,INIR)
C           IF(INIR.EQ.0) GOTO 2
C           READ ONE RECORD FROM UNIT IUN INTO WORDS
C           IW(INIR),IW(INIR+1), . . .
C           (SEE REMARKS BELOW)
C           GOTO 1
C        2  CONTINUE
C
C     REMARKS. THE ARGUMENT NREC IS (FOR INIR NOT EQUAL 0) EQUAL
C     TO THE LARGEST ALLOWED NUMBER OF WORDS, WHICH CAN BE READ.
C     SAFE INPUT IS POSSIBLE USING A SUITABLE ASSEMBLER READ ROUTINE.
C     THE END-OF-DATA CONDITION HAS TO BE HANDLED BY THE USER. IN
C     CASE OF READ ERRORS THIS CONDITION CAN BE SIGNALLED TO THE
C     BRDS PROGRAM BY DEFINING IW(INIR) = 0 AND GOTO 1. OTHERWISE
C     IW(INIR) CONTAINS NTOT = NR OF WORDS OF THE RECORD FOLLOWING.
C
C     FOR THE USE IN SPECIAL USER-WRITTEN INPUT-OUTPUT PROGRAMS
C     OR OTHER APPLICATIONS, THERE ARE TWO CALLS, WHICH ASSEMBLE
C     BANKS BELONGING TO THE CURRENT LIST IN CONTIGUOUS BANKSPACE
C     (BOUTP) AND STORE BANKS FROM AN ARBITRARY ARRAY INTO THE
C     COMMON /BCS/ (BINP).
C
C     CALL BOUTP(NRW,INIW)
C                --- ----
C     ALL BANKS BELONGING TO THE CURRENT LIST ARE ARRANGED IN
C     CONTIGUOUS BANK SPACE, STARTING AT LOCATION IW(INIW) WITH
C     A TOTAL OF NRW WORDS (INIW = 0 IN CASE OF ERRORS).
C
C               --- --
C     CALL BINP(NRW,AR)
C
C     ALL BANKS STORED IN THE ARRAY AR(1) . . . AR(NRW) ARE STORED
C     IN THE COMMON /BCS/, IF THERE IS ENOUGH SPACE AND IF THE ARRAY AR
C     CONTAINS CORRECT BANKS.
C
C
C
C     8.4   BUFFER BANKS
C
C     FOR EACH INPUT/OUTPUT UNIT IUN A BANK ('+BUF',IUN) IS USED
C     WITH BETWEEN 11 AND 10 +NRECL WORDS DEPENDING ON RECORD TYPE.
C     THESES BANKS ALSO CONTAIN STATISTIC ON INPUT/OUTPUT,
C     WHICH IS PRINTED BY CALLING THE STATUS-PRINT ROUTINE BSTA.
C     AFTER THE END OF INPUT/OUTPUT THESE BANKS CAN BE DELETED BY THE
C     USUAL CALL
C        CALL BDLS('+BUF',IUN)
C     THIS IS NECESSARY, IF THE SAME UNIT NUMBER IUN IS USED AFTERWARDS.
C     THE CONTENT OF THE BUFFER BANKS IS DESCRIBED IN CH. 10.
C
C
C
C     8.5    STANDARD EVENT READING/WRITING
C
C     PROGRAMMING EXAMPLE OF STANDARD EVENT PROCESSING WITH REPEATED
C     EXECUTION OF
C
C             INPUT OF ONE EVENT
C             PROCESS EVENT
C             OUTPUT OF EVENT
C             DELETE BANKS AND GARBAGE COLLECTION.
C
C     INPUT IS ASSUMED FROM UNIT 1, OUTPUT TO UNIT 2 WITH OUTPUT
C     MODE 0 AND A LIMIT OF 5000 WORDS PER RECORD.
C
C
C           CALL BINT(10000,0,0,0)
C           CALL BWRO(2,5000,0)
C     C
C     C     EVENT LOOP
C     C
C         1 CALL BREAD(1,&1,&2)
C     C     PROCESS EVENT
C           .....
C           .....
C           .....
C           CALL BSLW
C           CALL BWRITE(2)
C           CALL BSLT
C           CALL BDLG
C           GOTO 1
C     C
C     C     END OF EVENT LOOP
C     C
C         2 CALL BMLT(0,DUMMY)
C           CALL BWRITE(2)
C           STOP
C           END
C
C
C
C
C     THERE IS A STANDARD PROGRAM BSEQ, WHICH INCLUDES THE STANDARD
C     BOS PROGRAMS FOR INPUT, OUTPUT AND THE DELETING OF BANKS, AS
C     SHOWN IN THE EXAMPLE ABOVE.
C
C
C     CALL BSEQ(MARK)
C               ----
C
C        WHERE MARK = 0   ONE EVENT READ
C                   = 1   END, NO EVENT READ
C
C
C     BESQ, WHICH IS USED IN A LOOP, READS, EACH TIME CALLED, ONE
C     EVENT FROM UNIT 1. BSEQ RETURNS WITH MARK =1 IN THE END-OF-DATA
C     CONDITION, OR NSEC = 2 SECONDS BEFORE TIME OVERFLOW (TIME IS
C     CHECKED USING THE PROGRAM JUHR). THIS LIMIT CAN BE CHANGED
C     BY (BEFORE THE LOOP)
C
C     CALL BSET(NSEC)
C
C
C     IT IS ALSO POSSIBLE, TO DELIMIT THE NR OF EVENTS TO BE READ
C     BY (BEFORE THE LOOP)
C
C     CALL BSEL(LIMIT)
C
C     BSEQ WILL RETURN WITH MARK = 1 AFTER LIMIT EVENTS.
C
C     OUTPUT IS POSSIBLE WITH BSEQ ONTO THREE DIFFERENT OUTPUT UNITS.
C     IF AN EVENT SHOULD BE WRITTEN ONTO UNIT IUN, THIS HAS TO
C     SIGNALLED BY
C
C     CALL BSEW(IUN)
C
C     IF THE EVENT SHOULD NOT BE WRITTEN ONTO UNIT IUN, THIS IS
C     SIGNALLED BY (WITH A NEGATIVE UNIT)
C
C     CALL BSEW(-IUN)
C
C     DEFAULT IS NO OUTPUT FOR ALL EVENTS. THE OUTPUT ROUTINES ARE
C     CALLED WITHIN BSEQ AT THE NEXT ENTRY, USING THE SPECIAL LIST
C     OF NAMES (BSLW FOR OUTPUT, BSLT FOR DELETING BANKS).
C     THE OUTPUT MODES HAVE TO BE DEFINED BEFORE THE LOOP.
C
C
C
C     EXAMPLE FOR A COMPLETE MAIN PROGRAM.
C     1000 EVENTS ARE TO BE READ FROM UNIT 1, OUTPUT IS TO
C     UNIT 2 FOR ALL EVENTS, AND, FOR CERTAIN EVENTS, ALSO TO
C     THE UNITS 3 AND 4.
C
C
C           CALL BINT(10000,0,0,)
C           CALL BSET(5)
C           CALL BSEL(1000)
C           CALL BWRO(2,5000,0)
C           CALL BWRO(3,2000,1)
C           CALL BWRO(4,2000,1)
C     C
C     C     EVENT LOOP
C     C
C         1 CALL BSEQ(MARK)
C           IF(MARK.EQ.1) GOTO 2
C     C     PROCESS EVENT
C           .....
C           CALL BSEW(2)
C           CALL BSEW(3)
C           .....
C           .....
C           IF(.....) CALL BSEW(-3)
C           IF(.....) CALL BSEW(4)
C           GOTO 1
C     C
C     C     END OF EVENT LOOP
C     C
C         2 CALL BSTA
C           STOP
C           END
C
C
C     THERE IS ALSO THE POSSIBILITY IN BSEQ, TO READ WITH AN
C     ASSEMBLER PROGRAM (VBS RECORDS). IF THIS IS WANTED, ONE
C     HAS TO CALL
C
C     CALL ASVBS(IU)
C
C     BEFORE THE FIRST CALL OF BSEQ , TO DEFINE THE INPUT UNIT
C     NUMBER IU (DDNAME FTIUF001).
C
C
C
C
      RETURN
      END

C
C                        --- MACRO CADMIN ---
C
      LOGICAL*1 LBREAD
C
      COMMON / CADMIN / IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG,IERCAL,
     +                  ISMEAR,IJETCI,NFLAGS(10)
C
C                                 NFLAGS IS AN ARRAY OF GENERAL FLAGS
C                                   (1) : USED BY RDDATE
C                                   (2) : USED BY RDTRIG
C                                   (3) : USED BY RDTRIG
C                                   (4) : USED BY RDTRIG / PRSTAT
C                                   (5) : USED BY EVREAD -COUNTS RECORDS
C                                   (6) : USED BY SUPERV -COUNTS ERRORS
C                                   (7) : USED BY EVWRIT -'HEAD'LESS EVS
C                                   (8) : USED BY EVREAD/RDMTCO (EVWRIT)
C                                   (9) : USED BY RDMTCO/EVWRIT
C                                  (10) : FREE
C
C                                  BLOCK DATA SET IN MEMBER JADEBD
C

C   07/06/96 606071852  MEMBER NAME  INLINE   (S4)          FORTG1
C
C
C     ------------------------

C     FIRST PART (NAME)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAMEV),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
C     LFDI = INDEX TO FIRST BANK (NAME,...)
C     -------------------------
C
C     -------------------------
C     SECOND PART (NR)
      LFDK=LFDI+1
      LFDI=IW(LFDI)
      GOTO 3
    2 LFDK=LFDI
      LFDI=IW(LFDI-1)
    3 IF(LFDI.EQ.0)        GOTO    XXX
      IF(IW(LFDI-2).LT.NR) GOTO 2
      IF(IW(LFDI-2).GT.NR) GOTO    XXX
C     LFDI = INDEX TO BANK (...,NR)
C     LFDK = POINTER TO THIS BANK
C     ------------------------
      END

C   19/08/76 C9051801   MEMBER NAME  PIKMUF   (S)           FORTRAN
      SUBROUTINE PIKMUF(PV,PV2,XLDK)
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      REAL MPI/0.1396/,MK/0.4937/,MMU/0.1057/
      REAL CTPI/7804./,CTK/3709./
      REAL NCH
      DIMENSION PV(10),PV2(10)
C
C      PV(1) TO PV(4) FOUR VECTOR COMPONENTS
C      PV(5)  MASS IN GEV
C      PV(6)  3 MOMENTUM
C      PV(7)  CHARGE (REAL)
C      PV(8)  PARTICLE TYPE (INTEGER)
C             3 FOR MUON
C             4 FOR PION
C             5 FOR KAON
C
      DO 5 I=1,10
    5 PV2(I)=PV(I)
      XTYP=PV(8)
      XLDK = 1.E20
      IF(XTYP.NE.4. .AND. XTYP.NE.5.) RETURN
C
C      COMPUTE DECAY PATH UP TO THE LEAD GLASS SURFACES
C
      COSTH=ABS(PV(3))/PV(6)
      SINTH=SQRT( 1. - COSTH*COSTH )
C
      IF(ABS(COSTH).GT.CTLIMP) GO TO 1
      DKLTH=RLG/SINTH
      GO TO 3
    1 DKLTH=ZENDPL/COSTH
    3 CT=CTPI
      IF(XTYP.EQ.5.) CT=CTK
      AMAS=PV(5)
      GAM=PV(4)/PV(5)
      ETA=PV(6)/PV(5)
C
C      CHECK WHETHER PI OR K DECAYS AT ALL
C
      DK =DKLTH/ETA/CT
      IF(DK.GT.80.)DK=80.
      DK=1./EXP(DK)
      IF(RN(Q).GE.DK) GO TO 2
      RETURN
C
C      PI OR K DECAYS TO MU
C      CHOOSE DECAY POINT
C
    2 T=RN(QQ)*DKLTH
      XLDK=T
      DKAY=T/ETA/CT
      FACT=1./(ETA*CT)
      PROB=FACT*(1./EXP(DKAY))
      IF(FACT*RN(RR).GT.PROB)GO TO 2
      RETURN
C
C      DECAY PI OR K
C
      ENTRY PIKDEC(PV,PV2,XLDK)
C
      COSTH=PV(3)/PV(6)
      TH=ARCOS(COSTH)
      SINTH=SIN(TH)
      PHI=ATAN2(PV(2),PV(1))
      SINFI=SIN(PHI)
      COSFI=COS(PHI)
C
C      CHOSE DECAY ANGLES
C
      PCM=(AMAS**2-MMU*MMU)/(2.*AMAS)
      CTH=1.-2.*RN(DUM)
      PPCM=PCM*CTH
      PN=PCM*SIN(ARCOS(CTH))
      ECM=SQRT(PCM*PCM+MMU*MMU)
      XP=GAM*PPCM+ETA*ECM
      PHI=RN(Q)*6.283184
      YP=PN*COS(PHI)
      ZP=PN*SIN(PHI)
      P=SQRT(XP*XP+PN*PN)
C
C      ROTATE EVENT
C
      X=XP*SINTH*COSFI-YP*SINFI-ZP*COSTH*COSFI
      Y=XP*SINTH*SINFI+YP*COSFI-ZP*COSTH*SINFI
      Z=XP*COSTH+ZP*SINTH
      PXY=SQRT(X*X+Y*Y)
      SINTH=PXY/P
      COSTH=Z/P
      COSFI=X/PXY
      SINFI=Y/PXY
C
C      SET UP OUTPUT VECTOR PV2
C
      PV2(1)=P*SINTH*COSFI
      PV2(2)=P*SINTH*SINFI
      PV2(3)=P*COSTH
      PV2(4)=SQRT(P*P+MMU*MMU)
      PV2(5)=MMU
      PV2(6)=P
      PV2(8)=3
      RETURN
      END

C   14/03/84            MEMBER NAME  GGBLCK   (S)           FORTRAN
C   08/01/80 002141511  MEMBER NAME  GGBLCK   (S)           FORTRAN
      SUBROUTINE GGBLCK
C
C     H.WRIEDT  29-11-78  16:00
C---  LAST MODIFICATION  14.02.80  15:10
C
C     ORIGINALLY WRITTEN AS 'LGBLCK' BY S.YAMADA
C     AS TO BE FOUND ON YAMLGSRC.S
C
      IMPLICIT INTEGER*4 (G)
C---- ERROR MESSAGES
      COMMON /CMSGCT/ MSGDUM(20),GGMMAX,GGMSG1,GGMSG2
      GGMMAX = 10
      GGMSG1 = 0
      GGMSG2 = 0
      RETURN
      END
      BLOCK DATA
C
C---- BLOCK DATA FOR THE FORWARD SPECTROMETER GEOMETRICAL CONSTANTS
C
C***  ONLY FIRST GUESS, HAS TO BE DETERMINED MORE ACCURATELY!
C
      COMMON /CGGDMS/ X0,ZECAP(4),ZECAPX(4),THECPX(2),
     1                ECXLST(46), ECYLST(46),
     2                XANL(8),XANU(8),YANL(8),YANU(8),
     3                XBNL(8),XBNU(8),YBNL(8),YBNU(8)
C
      COMMON/ CGGVRN/ NVRSN(20)
      DATA NVRSN/4*0, 178120111, 15*0/
C
C---- THE UNIT IS EITHER MM OR X0.
C
      DATA X0/22.39/
C
C---  PB-GLASS DETECTORS
C---- END CAP WALL POSITIONS
      DATA ZECAP/ -4850.0, -5250.0, 4850.0, 5250.0/
      DATA ZECAPX/ -216.615, -234.480, 216.615, 234.480/
      DATA THECPX/ 400.0, 17.87/
C
C---- ECXLST,ECYLST   X AND Y POSITIONS OF THE ENDCAP COUNTERS
C----                 COORDINATES OF THE CENTRES OF THE BLOCKS
      DATA ECXLST/3*432.,2*371.,3*351.,2*371.,3*290.,3*270.,3*290.,
     1          4*209.,3*189.,4*209.,8*126.,8*45./
      DATA ECYLST/-81.,0.,81.,-243.,-162.,-81.,0.,81.,162.,243.,
     1          -324.,-243.,-162.,-81.,0.,81.,162.,243.,324.,
     2          -405.,-324.,-243.,-162.,-81.,0.,81.,162.,243.,324.,405.,
     3          -405.,-324.,-243.,-162.,162.,243.,324.,405.,
     4          -434.,-353.,-271.,-190.,190.,271.,353.,434./
C
C---  LUMONITOR COUNTERS
C---  FRAME B (-Z-DIRECTION): INDEX 1 TO 4;
C---  FRAME A (+Z-DIRECTION): INDEX 5 TO 8
C     XANL: LOWER X-BOUNDARY OF A-COUNTERS
C     XANU: UPPER X-BOUNDARY OF A-COUNTERS
C     YANL: LOWER Y-BOUNDARY OF A-COUNTERS
C     YANU: UPPER Y-BOUNDARY OF A-COUNTERS
C---  ALL THE VALUES IN MM, IN A COORDINATE-SYSTEM ROTATED BY 45 DEGREES
      DATA XANL/-75.,192.58,-75.,-262.58,-75.,-262.68,-75.,192.68/
      DATA XANU/75.,262.58,75.,-192.58,75.,-192.68,75.,262.68/
      DATA YANL/-262.64,-75.,192.64,-75.,192.75,-75.,-262.75,-75./
      DATA YANU/-192.64,75.,262.64,75.,262.75,75.,-192.75,75./
C---  SAME FOR B-COUNTERS
      DATA XBNL/-115.,152.58,-115.,-302.58,-115.,-302.68,-115.,152.68/
      DATA XBNU/115.,302.58,115.,-152.58,115.,-152.68,115.,302.68/
      DATA YBNL/-302.64,-115.,152.64,-115.,152.75,-115.,-302.75,-115./
      DATA YBNU/-152.64,115.,302.64,115.,302.75,115.,-152.75,115./
C
C---- GG ANALYSIS PARAMETERS
      COMMON /CGGPRM/ ITHADC,MAXCLS,CLBCNS
C
      DATA ITHADC/2/, MAXCLS/51/
      DATA CLBCNS/0.005/
C
C---  CALIBRATION FACTORS FOR PB-GLASS BLOCKS (PRELIMINARY)
      COMMON /CALICO/ FAKTOR(191)
      DATA FAKTOR/191*1./
C
      END

C-----------------------------------------------------------------------
C             MACRO CBCSMX.... BOS COMMON + SIZE DEFINITION
C
C             THIS MACRO DEFINES THE IDATA/HDATA/ADATA NAMES AND
C             FIXES THE ACTUAL SIZE OF /BCS/. IT IS THUS IDEAL FOR
C             MAIN PROGRAMS OR THE SUPERVISOR. LDATA CAN BE USED BY BINT
C
C-----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(60000)
      DIMENSION HDATA(120000),ADATA(60000)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1))
      DATA  LDATA / 60000 /
C
C------------------------ END OF MACRO CBCSMX --------------------------

      FUNCTION XFWVXC(IPHEAD) 
C-----------------------------------------------------------------------
C
C
C     RETURNS THE NUMBER OF RADIATION LENGTHS FROM THE INSIDE OF THE
C     BEAM PIPE TO THE FIRST GAS MOLECULE IN THE VERTEX CHAMBER.
C     BASED ON DATE IN HEAD BANK.
C     MC-DATA: NEW GEOMETRY IS FORCED IF FLAG LVTXC IS TRUE
C     ARGUMENT DUMMY IS IGNORED.
C
C   RADIATION LENGTH UPDATE, 9.6.1986    J.O.
C   RADIATION LENGTH UPDATE, 11.6.1986    J.O.
C
C       X0(BEAMPIPE)                0.03371
C       X0(1.KAPTON)                0.00011
C       X0(2.KAPTON+CU)             0.00148
C       X0(3.KAPTON+CU)             0.00262
C       X0(COOLING PIPES)           0.00107
C                                  =========
C                                   0.03899
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
C
      LOGICAL NEWDET,LVTXC,LNHARD
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C                        --- MACRO CADMIN ---
C
      LOGICAL*1 LBREAD
C
      COMMON / CADMIN / IEVTP,NRREAD,NRWRIT,NRERR,LBREAD(4),IFLG,IERCAL,
     +                  ISMEAR,IJETCI,NFLAGS(10)
C
C                                 NFLAGS IS AN ARRAY OF GENERAL FLAGS
C                                   (1) : USED BY RDDATE
C                                   (2) : USED BY RDTRIG
C                                   (3) : USED BY RDTRIG
C                                   (4) : USED BY RDTRIG / PRSTAT
C                                   (5) : USED BY EVREAD -COUNTS RECORDS
C                                   (6) : USED BY SUPERV -COUNTS ERRORS
C                                   (7) : USED BY EVWRIT -'HEAD'LESS EVS
C                                   (8) : USED BY EVREAD/RDMTCO (EVWRIT)
C                                   (9) : USED BY RDMTCO/EVWRIT
C                                  (10) : FREE
C
C                                  BLOCK DATA SET IN MEMBER JADEBD
C
C
      COMMON / CVCEX  / LVTXC
C
C------------------  C O D E  ------------------------------------------
C
      IH2    = 2*IPHEAD
C
      IMONTH = HDATA(IH2+7)
      IYEAR  = HDATA(IH2+8)
C
C                            OLD GEOMETRY (PRIOR TO MAY 1984)
C
C
C   FOR VALUE OF RADIATION LENGTH, SEE JCN 87
C
      XFWVXC = 0.00000
C                            NEW DETECTOR HARDWARE IN MONTE-CARLO DATA?
C                            THEN LVTXC IS TRUE (FLAG IS CHECKED AND
C                                                SET IN RDMTCO)
C
      LNHARD = (IMONTH .GE. 5  .AND.  IYEAR .EQ. 1984)
     +                          .OR.  IYEAR .GE. 1985
      NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
C
      IF( .NOT. NEWDET ) RETURN
C
C                            NEW GEOMETRY
C
      XFWVXC = 0.03899
C
      IF ((IEVTP.NE.0).AND.(IYEAR.LE.1985)) XFWVXC = 0.03371
C
      RETURN
      END

      SUBROUTINE RINCON
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C   30/10/79 910301050  MEMBER NAME  CWORKMX  (PATRECSR)    FORTRAN
C   16/09/79 C9092001   MEMBER NAME  CWORKMX  (UKSOR)       FORTRAN
C ==========MACRO CWORKMG =============================
      EQUIVALENCE (ADWRK(291),HUSE(1)),(ADWRK(391),K),
     * (ADWRK(392),ICL),(ADWRK(393),LRING),(ADWRK(394),KRING),
     * (ADWRK(395),LR),(ADWRK(396),IRIFLG),(ADWRK(397),IUDFLG),
     * (ADWRK(398),ILIM),(ADWRK(399),LR1),(ADWRK(400),IRL),
     * (ADWRK(401),ITK(1,1)),(ADWRK(441),DTEMP(1)),
     * (ADWRK(451),IPST),(ADWRK(452),IJFLG),(ADWRK(453),ICX),
     * (ADWRK(454),KT),(ADWRK(455),ISDL),(ADWRK(456),IBFIT),
     * (ADWRK(457),ISP),(ADWRK(458),ISKP(1)),(ADWRK(468),HSP1(1)),
     * (ADWRK(478),ITOL),(ADWRK(479),IW),(ADWRK(480),A),
     * (ADWRK(481),DS),(ADWRK(482),IWT),(ADWRK(483),ICT),
     * (ADWRK(484),IKX),(ADWRK(485),LRCORN)
      DIMENSION HUSE(200),DTEMP(10),ITK(10,4),ISKP(10),HSP1(20)
      EQUIVALENCE (ILOUT,IBKK(3)),(ILIN,IBKK(4)),
     * (ILBOT,IBKK(8)),(DCELL,BKK(9))
C ==========ENDMACRO CWORKMG==========================
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C----------------------------------------------------------------------
C           MACRO CDSMAX .... PATTERN RECOGNITION CONSTANTS.
C----------------------------------------------------------------------
      COMMON/CDSMAX/DSMAX(16,3,2),DIRWR1(24,2),DIRWR3(48,2)
     *             ,DHALF(16,3,2),DTWICE(16,3,2),HMCH(16,3,2)
     *             ,IBCK(9),DBCK(30),TRMATS(96,2),TRMATC(96,2)
C------------------------ END OF MACRO CDSMAX -------------------------
C----------------------------------------------
C  MACRO CPATLM .... PATTERN RECOGNITION LIMITS
C----------------------------------------------
      COMMON /CPATLM/ PATRLM(5),FLINLM(10),TRELLM(20),ZFITLM(10),BKK(20)
     *               ,XYF(20),IGFP(20),XBKK(40),IADMIN(5),YBKK(20)
      INTEGER IXYF(20),LMPATR(5),LMFLIN(10)
      INTEGER LMTREL(20),LMZFIT(10),IBKK(20)
      DIMENSION GFP(20),IXBKK(40),IYBKK(20)
      EQUIVALENCE (PATRLM(1),LMPATR(1)),(IXBKK(1),XBKK(1)),(IYBKK(1),
     *YBKK(1))   ,(FLINLM(1),LMFLIN(1)),(TRELLM(1),LMTREL(1))
     *           ,(ZFITLM(1),LMZFIT(1)),(BKK(1),IBKK(1))
     *           ,(XYF(1),IXYF(1)),(GFP(1),IGFP(1)),(IADMIN(1),IMCERT)
     *           ,(IYBKK(20),IPPASS),(IADMIN(2),IPFAST)
C----------- END OF MACRO CPATLM --------------
      DIMENSION LSTCL(3),LFTCL(3),NCELL(3),TANDEL(3)
      EQUIVALENCE (IBCK(1),LSTCL(1)),(IBCK(4),LFTCL(1))
      EQUIVALENCE (IBCK(7),NCELL(1)),(DBCK(1),TANDEL(1))
      DIMENSION HTEMP(9)
      DATA MSKCR1,MSKCR2,MSKERR,MSKLR0 /Z100,Z200,Z4000,Z1000/
      DATA MSKFIT,MSKAIT /Z20000,ZFFFDFFFF/
      DO 13000 II=1,2
      IRL=0
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      IF(
     - HNTCEL(ICX+1) - HNTCEL(ICX).GT.0
     -)THEN
      NTRLX1 = HNTCEL(ICX)
      NTRLX2 = HNTCEL(ICX+1)-1
      KRING = LRING - 1
      LRCORN=0
      DO 13002 KX = NTRLX1,NTRLX2
      IF(
     - HUSE(KX).EQ.0
     -)THEN
      IF(
     - KRING.EQ.2
     -)THEN
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      ELSE
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
      ENDIF
      ASSIGN 17006 TO IZZZ01
      GOTO 17000
17006 CONTINUE
      KRING=LRING-1
      ICX=ICX+1
      IF(ICX.GT.LSTCL(KRING)) ICX=ICX-NCELL(KRING)
      LRCORN=1
      ASSIGN 17008 TO IZZZ04
      GOTO 17007
17008 CONTINUE
      ASSIGN 17009 TO IZZZ01
      GOTO 17000
17009 CONTINUE
      KRING=LRING-1
      ICX=ICX-1
      IF(ICX.LT.LFTCL(KRING)) ICX=ICX+NCELL(KRING)
      LRCORN=-1
      ASSIGN 17010 TO IZZZ04
      GOTO 17007
17010 CONTINUE
      IF(
     - IRIFLG.EQ.1
     -)THEN
      ASSIGN 17012 TO IZZZ05
      GOTO 17011
17012 CONTINUE
      ENDIF
      KMP1=HISTR(1,NTR)
      KMP1=IABS(KMP1)
      KMP1=IPCL(KMP1)
      KMP2=HISTR(HNREL(NTR),NTR)
      KMP2=IABS(KMP2)
      KMP2=IPCL(KMP2)
      ASSIGN 17014 TO IZZZ06
      GOTO 17013
17014 CONTINUE
      IF(
     - IRIFLG.NE.0.OR.IPST.EQ.0.OR.LR.EQ.0.OR.IBKK(20).NE.0.AND.
     $IJFLG.EQ.0.AND.NRHT(K).GE.IBKK(19).OR.KMP1.NE.KMP2
     -)THEN
      GOTO 13001
      ELSE
      LR=-LR
      ENDIF
13000 CONTINUE
13001 CONTINUE
      RETURN
17011 CONTINUE
      IBFIT=-4
      IRT=IRL
      ITMP=LR
      ITMP1=K
      ITMP2=ICL
      DO 13004 JK=1,IRT
      LRCORN=0
      KX=ITK(JK,1)
      ICX=IPCL(KX)
      IC1=ICX+24
      IC2=IC1
      IF(
     - LRING.EQ.3
     -)THEN
      IC1=2*ICX-1
      IC2=IC1+1
      ENDIF
      ICZ=IC1
      IF(
     - HNTCEL(IC2+1)-HNTCEL(IC1).GT.0
     -)THEN
      NTRLX3=HNTCEL(IC1)
      NTRLX4=HNTCEL(IC2+1)-1
      DO 13006 IB=NTRLX3,NTRLX4
      IBFIT=-4
      IF(
     - HUSE(IB).EQ.0.OR.LAND(LBL(IB),MSKERR).NE.0
     -)THEN
      K=IB
      ICL=IPCL(IB)
      IF(
     - KRING.EQ.2
     -)THEN
      LR=0
      ASSIGN 17016 TO IZZZ07
      GOTO 17015
17016 CONTINUE
      ASSIGN 17017 TO IZZZ02
      GOTO 17002
17017 CONTINUE
      ELSE
      LR=ITK(JK,3)
      ASSIGN 17018 TO IZZZ07
      GOTO 17015
17018 CONTINUE
      ASSIGN 17019 TO IZZZ03
      GOTO 17004
17019 CONTINUE
      ENDIF
      ENDIF
13006 CONTINUE
13007 CONTINUE
      ENDIF
      IC1=ICZ+1
      IF(LRING.EQ.3) IC1=ICZ+2
      IF(IC1.GT.LSTCL(LRING)) IC1=IC1-NCELL(LRING)
      IC2=IC1
      IF(LRING.EQ.3) IC2=IC1+1
      IF(
     - HNTCEL(IC2+1)-HNTCEL(IC1).GT.0
     -)THEN
      NTRLX3=HNTCEL(IC1)
      NTRLX4=HNTCEL(IC2+1)-1
      DO 13008 IB=NTRLX3,NTRLX4
      IBFIT=-4
      IF(
     - HUSE(IB).EQ.0.OR.LAND(LBL(IB),MSKERR).NE.0
     -)THEN
      K=IB
      ICL=IPCL(IB)
      LRCORN=-1
      LR=0
      ASSIGN 17020 TO IZZZ07
      GOTO 17015
17020 CONTINUE
      ASSIGN 17022 TO IZZZ08
      GOTO 17021
17022 CONTINUE
      ENDIF
13008 CONTINUE
13009 CONTINUE
      ENDIF
      IC1=ICZ-1
      IF(LRING.EQ.3) IC1=ICZ-2
      IF(IC1.LT.LFTCL(LRING)) IC1=IC1+NCELL(LRING)
      IC2=IC1
      IF(LRING.EQ.3) IC2=IC1+1
      IF(
     - HNTCEL(IC2+1)-HNTCEL(IC1).GT.0
     -)THEN
      NTRLX3=HNTCEL(IC1)
      NTRLX4=HNTCEL(IC2+1)-1
      DO 13010 IB=NTRLX3,NTRLX4
      IBFIT=-4
      IF(
     - HUSE(IB).EQ.0.OR.LAND(LBL(IB),MSKERR).NE.0
     -)THEN
      K=IB
      ICL=IPCL(IB)
      LRCORN=1
      LR=0
      ASSIGN 17023 TO IZZZ07
      GOTO 17015
17023 CONTINUE
      ASSIGN 17024 TO IZZZ08
      GOTO 17021
17024 CONTINUE
      ENDIF
13010 CONTINUE
13011 CONTINUE
      ENDIF
13004 CONTINUE
13005 CONTINUE
      LR=ITMP
      ICL=ITMP2
      K=ITMP1
      IBFIT=0
      GOTO IZZZ05
17002 CONTINUE
      ASSIGN 17026 TO IZZZ09
      GOTO 17025
17026 CONTINUE
      IF(
     - LR.NE.0
     -)THEN
      LRT=LR
      ASSIGN 17028 TO IZZZ10
      GOTO 17027
17028 CONTINUE
      ELSE
      DSEX=DSEXR
      LRT=1
      SLEX=SLEXR
      ASSIGN 17029 TO IZZZ10
      GOTO 17027
17029 CONTINUE
      DSEX=DSEXL
      LRT=-1
      SLEX=SLEXL
      ASSIGN 17030 TO IZZZ10
      GOTO 17027
17030 CONTINUE
      ENDIF
      GOTO IZZZ02
17004 CONTINUE
      LR1=LR
      IF(LR.EQ.0) LR1=1
      IF(LR.EQ.0.AND.IBKK(20).NE.0.AND.NRHT(K).GE.IBKK(19)) IJFLG=1
      LRT=LR1
      LRS=LR1
      ASSIGN 17032 TO IZZZ11
      GOTO 17031
17032 CONTINUE
      ASSIGN 17034 TO IZZZ12
      GOTO 17033
17034 CONTINUE
      SL=SL1K-FCONT*.5*(W3-W2)
      DSEX=D-SL*(W3-W2)
      ASSIGN 17035 TO IZZZ10
      GOTO 17027
17035 CONTINUE
      GOTO IZZZ03
17000 CONTINUE
      ICX=ICL
      IF(LRING.EQ.3) ICX =(ICX+1)/2
      IF(LRING.EQ.2) ICX = ICX - 24
      GOTO IZZZ01
17013 CONTINUE
      IF(
     - IRIFLG.EQ.1
     -)THEN
      IF(
     - IRL.GT.1
     -)THEN
      CALL CHOOSE
      ENDIF
      IF(
     - IRIFLG.EQ.1
     -)THEN
      K=ITK(1,1)
      IKX=K
      IF(LR.EQ.0.AND.ITK(1,2).EQ.-1) HISTR(1,NTR)=-HISTR(1,NTR)
      ICL=IPCL(IKX)
      LRCORN=0
      IPAR=ITK(1,4)
      IPAR=IPCL(IPAR)+ICL
      IF(LAND(IPAR,1).EQ.1) LRCORN=1
      IF(LRCORN.EQ.1.OR.KRING.EQ.2) IJFLG=0
      LR=ITK(1,3)
      IF(II.EQ.2) CALL COREC
      IF(KMP1.EQ.KMP2.AND.KRING.EQ.1.AND.II.EQ.2.AND.LRCORN.EQ.0)
     * IJFLG=1
      LRING=KRING
      CALL BSTORE
      IPST=0
      ENDIF
      ENDIF
      GOTO IZZZ06
17007 CONTINUE
      IF(
     - HNTCEL(ICX+1)-HNTCEL(ICX).GT.0
     -)THEN
      NTRLX1=HNTCEL(ICX)
      NTRLX2=HNTCEL(ICX+1)-1
      DO 13012 KX=NTRLX1,NTRLX2
      IF(
     - HUSE(KX).EQ.0
     -)THEN
      ASSIGN 17036 TO IZZZ08
      GOTO 17021
17036 CONTINUE
      ENDIF
13012 CONTINUE
13013 CONTINUE
      ENDIF
      GOTO IZZZ04
17021 CONTINUE
      ASSIGN 17038 TO IZZZ13
      GOTO 17037
17038 CONTINUE
      LR1=-LRCORN
      IF(
     - LR.NE.0
     -)THEN
      LRT=LR
      ASSIGN 17039 TO IZZZ10
      GOTO 17027
17039 CONTINUE
      ELSE
      LRT=1
      DSEX=DSEXR
      SLEX=SLEXR
      ASSIGN 17040 TO IZZZ10
      GOTO 17027
17040 CONTINUE
      LRT=-1
      DSEX=DSEXL
      SLEX=SLEXL
      ASSIGN 17041 TO IZZZ10
      GOTO 17027
17041 CONTINUE
      ENDIF
      GOTO IZZZ08
17027 CONTINUE
      IOFF=0
      IF(NRHT(K).LE.6.OR.NRHT(KX).LE.6) IOFF=IOFF+1
      IF(ITOL.NE.1) IOFF=IOFF+2
      IF(LRCORN.NE.0) IOFF=IOFF+4
      DSM=XBKK(IOFF+1)
      SLCON=XBKK(IOFF+9)
      SLX=XBKK(IOFF+17)
      DX=XBKK(IOFF+25)
      ICROSS=0
      MAMB=0
      IF(NRHT(KX).GE.IBKK(19).AND.IBKK(20).NE.0) MAMB=1
      IF(
     - MAMB.NE.0
     -)THEN
      JT=IKX
      IKX=KX
      CALL LFRT(LRC)
      IF(
     - LRC.NE.0
     -)THEN
      IF(LAND(LBL(KX),MSKCR1).NE.0) LRC=-LRC
      IF(LRC.NE.LR1) ICROSS=1
      ENDIF
      IKX=JT
      ENDIF
      EPS=-.00001
      IF(
     - MAMB.EQ.0.OR.MAMB.NE.0.AND.LRC.EQ.0
     -)THEN
      IF(DSEX.LT.0..AND.SL2(KX).LT.EPS.OR.DSEX.LT.DX.AND.
     * DS2(KX).LT.DX.AND.SL2(KX).LT.EPS) ICROSS=1
      ENDIF
      DTMP=DSEX-DS2(KX)
      IF(ICROSS.EQ.1) DTMP=DSEX+DS2(KX)
      IF(
     - ABS(DTMP).LT.DSM
     -)THEN
      IF(ICROSS.EQ.1) LR1=-LR1
      INTFLG=0
      IKX=0
      ICFIT=IBFIT
      IBFIT=-1
      IF(
     - HNTCEL(ICX+1)-HNTCEL(ICX) .GT. 1
     -)THEN
      NTRLX1=HNTCEL(ICX)
      NTRLX2=HNTCEL(ICX+1)-1
      DO 13014 KK=NTRLX1,NTRLX2
      IF(
     - HUSE(KK).EQ.0
     -)THEN
      IW=NWR1(KK)
      IF(
     - IW.GE.ILBOT
     -)THEN
      CALL  INTJN1(KK,KX,INTFLG,DT)
      IF(
     - INTFLG.NE.0
     -)THEN
      GOTO 13015
      ENDIF
      ENDIF
      ENDIF
13014 CONTINUE
13015 CONTINUE
      ENDIF
      IF(
     - LRCORN.NE.0.AND.INTFLG.EQ.0
     -)THEN
      LRY=LR1
      IF(
     - LRCORN.EQ.1
     -)THEN
      LR1=1
      ICT=ICX-1
      IF(ICT.LT.LFTCL(KRING)) ICT=ICT+NCELL(KRING)
      ENDIF
      IF(
     - LRCORN.EQ.-1
     -)THEN
      LR1=2
      ICT=ICX+1
      IF(ICT.GT.LSTCL(KRING)) ICT=ICT-NCELL(KRING)
      ENDIF
      IF(
     - HNTCEL(ICT+1)-HNTCEL(ICT).GT.0
     -)THEN
      A=TRKAR(KX,8)
      DS=TRKAR(KX,7)
      IW=ITRKAR(KX,6)
      IUDFLG=3
      ILIM=ILOUT
      KT=KX
      CALL SIDE1
      ENDIF
      LR1=LRY
      ENDIF
      IBFIT=ICFIT
      IF(
     - INTFLG.EQ.0.AND.IKX.EQ.0
     -)THEN
      ASSIGN 17043 TO IZZZ14
      GOTO 17042
17043 CONTINUE
      ENDIF
      ENDIF
      GOTO IZZZ10
17037 CONTINUE
      ASSIGN 17044 TO IZZZ11
      GOTO 17031
17044 CONTINUE
      IF(
     - KRING.EQ.2
     -)THEN
      IF(
     - LAND(ICL,1).EQ.1
     -)THEN
      KR=3
      IN1=19
      IN2=21
      IN3=20
      JR=KRING
      IN4=10
      IN5=12
      IN6=13
      ASSIGN 17046 TO IZZZ15
      GOTO 17045
17046 CONTINUE
      ENDIF
      IF(
     - LAND(ICL,1).NE.1
     -)THEN
      KR=KRING
      IN1=11
      IN2=13
      IN3=12
      JR=3
      IN4=18
      IN5=20
      IN6=21
      ASSIGN 17047 TO IZZZ15
      GOTO 17045
17047 CONTINUE
      ENDIF
      ELSE
      KR=KRING
      IN1=15
      IN2=17
      IN3=16
      JR=KRING
      IN4=14
      IN5=16
      IN6=17
      ASSIGN 17048 TO IZZZ15
      GOTO 17045
17048 CONTINUE
      ENDIF
      GOTO IZZZ13
17045 CONTINUE
      IF(
     - LRCORN.EQ.1
     -)THEN
      DSMX=DTWICE(NWR2(KX)+1,KR,1)
      X1=DBCK(IN1)
      IF(
     - LR.EQ.0.OR.LR.EQ.1
     -)THEN
      X2=DBCK(IN2)
      LRS=1
      ASSIGN 17049 TO IZZZ12
      GOTO 17033
17049 CONTINUE
      ASSIGN 17051 TO IZZZ16
      GOTO 17050
17051 CONTINUE
      DSEX=DSMX-XQ
      ENDIF
      IF(LR.EQ.0) DSEXR=DSEX
      IF(LR.EQ.0) SLEXR=SLEX
      IF(
     - LR.EQ.0.OR.LR.EQ.-1
     -)THEN
      X2=DBCK(IN3)
      LRS=-1
      ASSIGN 17052 TO IZZZ12
      GOTO 17033
17052 CONTINUE
      ASSIGN 17053 TO IZZZ16
      GOTO 17050
17053 CONTINUE
      DSEX=DSMX+XQ
      ENDIF
      IF(LR.EQ.0) DSEXL=DSEX
      IF(LR.EQ.0) SLEXL=SLEX
      ELSE
      DSMX=DTWICE(NWR2(KX)+1,JR,2)
      X1=DBCK(IN4)
      IF(
     - LR.EQ.0.OR.LR.EQ.1
     -)THEN
      X2=DBCK(IN5)
      LRS=1
      ASSIGN 17054 TO IZZZ12
      GOTO 17033
17054 CONTINUE
      ASSIGN 17055 TO IZZZ16
      GOTO 17050
17055 CONTINUE
      DSEX=DSMX+XQ
      ENDIF
      IF(LR.EQ.0) DSEXR=DSEX
      IF(LR.EQ.0) SLEXR=SLEX
      IF(
     - LR.EQ.0.OR.LR.EQ.-1
     -)THEN
      X2=DBCK(IN6)
      LRS=-1
      ASSIGN 17056 TO IZZZ12
      GOTO 17033
17056 CONTINUE
      ASSIGN 17057 TO IZZZ16
      GOTO 17050
17057 CONTINUE
      DSEX=DSMX-XQ
      ENDIF
      IF(LR.EQ.0) DSEXL=DSEX
      IF(LR.EQ.0) SLEXL=SLEX
      ENDIF
      GOTO IZZZ15
17042 CONTINUE
      IF(
     - KRING.EQ.2.OR.LRCORN.NE.0
     -)THEN
      SL=SLEX
      IF(LRT*LR1.EQ.1) SL=-SL
      IF(ICROSS.EQ.1) SL=-SL
      T=DBCK(6)
      IF(KRING.EQ.2.AND.LRCORN.NE.0) T=DBCK(7)
      IF(KRING.EQ.1.AND.LRCORN.NE.0) T=TANDEL(2)
      IF(LAND(ICL,1).EQ.1.AND.LRCORN.EQ.1.OR.
     * LAND(ICL,1).NE.1.AND.LRCORN.EQ.-1) T=DBCK(22)
      SLEX=(T-SL)/(1.+SL*T)
      ENDIF
      IF(ICROSS.EQ.1) SLEX=-SLEX
      SL=SL2(KX)/RINCR(KRING)
      SLC=SLCOR(SL,LR1)
      SLTMP=SLC-SLEX
      SLOLIM=(ABS(SLEX)+ABS(SLC))/2.*SLX+SLCON
      IF(
     - ABS(SLC-SLEX) .LT. SLOLIM
     -)THEN
      IXXB=0
      IF(
     - IBKK(18).NE.0.AND.IBFIT.EQ.0
     -)THEN
      ASSIGN 17059 TO IZZZ17
      GOTO 17058
17059 CONTINUE
      ENDIF
      IF(
     - IXXB.EQ.0
     -)THEN
      ASSIGN 17061 TO IZZZ18
      GOTO 17060
17061 CONTINUE
      DTEMP(IRL)=ABS(DTMP*(SLC-SLEX))
      ENDIF
      ENDIF
      GOTO IZZZ14
17060 CONTINUE
      IRIFLG=1
      IF(
     - IRL.LT.10
     -)THEN
      IRL=IRL+1
      ITK(IRL,1)=KX
      ITK(IRL,3)=LR1
      ITK(IRL,2)=LRT
      ITK(IRL,4)=K
      ELSE
      ENDIF
      GOTO IZZZ18
17025 CONTINUE
      ASSIGN 17062 TO IZZZ11
      GOTO 17031
17062 CONTINUE
      IF(
     - LAND(ICL,1).EQ.1
     -)THEN
      LR1=-1
      DSMX=DHALF(NWR2(KX)+1,KRING,1)
      IF(
     - LR.EQ.-1.OR.LR.EQ.0
     -)THEN
      LRS=-1
      ASSIGN 17063 TO IZZZ12
      GOTO 17033
17063 CONTINUE
      X1=DBCK(5)
      X2=DBCK(8)
      ASSIGN 17064 TO IZZZ16
      GOTO 17050
17064 CONTINUE
      DSEX=DSMX+XQ
      ENDIF
      IF(LR.EQ.0) DSEXL=DSEX
      IF(LR.EQ.0) SLEXL=SLEX
      IF(
     - LR.EQ.1.OR.LR.EQ.0
     -)THEN
      LRS=1
      ASSIGN 17065 TO IZZZ12
      GOTO 17033
17065 CONTINUE
      X1=DBCK(5)
      X2=DBCK(9)
      ASSIGN 17066 TO IZZZ16
      GOTO 17050
17066 CONTINUE
      DSEX=DSMX-XQ
      ENDIF
      IF(LR.EQ.0) DSEXR=DSEX
      IF(LR.EQ.0) SLEXR=SLEX
      ENDIF
      IF(
     - LAND(ICL,1).NE.1
     -)THEN
      LR1=1
      DSMX=DHALF(NWR2(KX)+1,KRING,2)
      IF(
     - LR.EQ.-1.OR.LR.EQ.0
     -)THEN
      LRS=-1
      ASSIGN 17067 TO IZZZ12
      GOTO 17033
17067 CONTINUE
      X1=DBCK(4)
      X2=DBCK(9)
      ASSIGN 17068 TO IZZZ16
      GOTO 17050
17068 CONTINUE
      DSEX=DSMX-XQ
      ENDIF
      IF(LR.EQ.0) DSEXL=DSEX
      IF(LR.EQ.0) SLEXL=SLEX
      IF(
     - LR.EQ.1.OR.LR.EQ.0
     -)THEN
      LRS=1
      ASSIGN 17069 TO IZZZ12
      GOTO 17033
17069 CONTINUE
      X1=DBCK(4)
      X2=DBCK(8)
      ASSIGN 17070 TO IZZZ16
      GOTO 17050
17070 CONTINUE
      DSEX=DSMX+XQ
      ENDIF
      IF(LR.EQ.0) DSEXR=DSEX
      IF(LR.EQ.0) SLEXR=SLEX
      ENDIF
      GOTO IZZZ09
17033 CONTINUE
      SLC1=SLCOR(SL1K,LRS)
      IF(LAND(LBL(K),MSKCR1).NE.0.AND.LAND(LBL(K),MSKCR2).EQ.0)LRS=-LRS
      SLC2=SLCOR(SL2K,LRS)
      IF(
     - LAND(LBL(K),MSKCR1).NE.0.AND.LAND(LBL(K),MSKCR2).EQ.0
     -)THEN
      SLC2=ABS(SLC2)
      IF(SLC1.LT.0.) SLC2=-SLC2
      ENDIF
      FCONT=(SLC2-SLC1)/(NWR2(K)-NWR1(K))/RINCR(KRING+1)
      IF(ABS(FCONT).GT..001.AND.NRHT(K).LE.8) FCONT=FCONT/2.
      SLEX=SLC1-FCONT*(W3-W2)
      GOTO IZZZ12
17031 CONTINUE
      SL1K=SL1(K)/RINCR(KRING+1)
      SL2K=SL2(K)/RINCR(KRING+1)
      D=DS1(K)
      W3=FSENSW(KRING+1)+NWR1(K)*RINCR(KRING+1)
      W2=FSENSW(KRING)+NWR2(KX)*RINCR(KRING)
      GOTO IZZZ11
17050 CONTINUE
      SL=SL1K-FCONT*.5*(W3-W2)
      X=D*DRICOS/X1
      XQ=W3-(W2*DRICOS+D*X2)/X1
      XQ=X-SL*DRICOS*XQ/(X1-SL*X2)
      GOTO IZZZ16
17015 CONTINUE
      IF(
     - LAND(LBL(K),MSKERR).NE.0.AND.LAND(LBL(K),MSKLR0).EQ.0
     -)THEN
      DO 13016 KTR=1,100
      ITMM=HNREL(KTR)
      IF(
     - ITMM.GT.0
     -)THEN
      JA=HISTR(ITMM,KTR)
      IF(
     - IABS(JA).EQ.K
     -)THEN
      LR=ISIGN(1,JA)
      GOTO 13017
      ENDIF
      ELSE
      GOTO 13017
      ENDIF
13016 CONTINUE
13017 CONTINUE
      ENDIF
      GOTO IZZZ07
17058 CONTINUE
      IXXB=0
      IF(
     - HNREL(NTR).LT.9
     -)THEN
      CALL MVC2(HTEMP(1),0,HISTR(1,NTR),0,18) !PMF 28/06/99 MVC -> MVC2
      IKFLG=IJFLG
      IF(II.EQ.2) CALL COREC
      IJFLG=IKFLG
      HNREL(NTR)=HNREL(NTR)+1
      LRC=LR1
      IF(LAND(LBL(KX),MSKCR1).NE.0) LRC=-LRC
      HISTR(HNREL(NTR),NTR)=KX*LRC
      IF(LR.EQ.0.AND.LRT.EQ.-1) HISTR(1,NTR)=-HISTR(1,NTR)
      IAB=HNREL(NTR)
      CALL BAKFIT(IXXB,2)
      HNREL(NTR)=HNREL(NTR)-1
      CALL MVC2(HISTR(1,NTR),0,HTEMP(1),0,18) !PMF 28/06/99 MVC -> MVC2
      ENDIF
      GOTO IZZZ17
      END

C   08/06/86 606080831  MEMBER NAME  CALLOC   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE CALLOC( OK )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   8/06/86 :  ALLOCATES CALIBRATION DATASETS
C
C
C     ALLOCATES THE CALIBRATION DATASETS TO VARIABLE LUNS.
C     OK = .TRUE. IF THE ALLOCATION WAS SUCCESSFUL.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8   DDN
      LOGICAL  OK
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C==MACRO CIOUNI=========================================
      COMMON/CIOUNI/IUNIT,JUNIT,NCALI,KUNITA(10),LUNITA(10)
C==ENDMACRO CIOUNI========================================
C
      COMMON / CNWCAL / IFILE
C
      DIMENSION LUNC(11,4)
C
      DATA  HBLANK/'  '/, HCAL/'CC'/
      DATA  LUNC /'F11L','HO.B','UPDA','T0  ','    ','    ',5*'    ',
     +            'F11L','HO.B','UPDA','T1  ','    ','    ',5*'    ',
     +            'F11L','HO.A','UPDA','T1  ','    ','    ',5*'    ',
     +            'F11L','HO.K','ALWR','K0  ','    ','    ',5*'    '/
C
C
C------------------  C O D E  -----------------------------------------
C
      CALL TRMOUT(80,'The default calibration dataset  F11LHO.AUPDAT1 wi
     $ll now be allocated.^')
      CALL TRMOUT(80,'If you want the BUPDAT0/BUPDAT1 files for LG calib
     $ration (REFORM Data),^')
      CALL TRMOUT(80,'then press any CHARACTER+RETURN, else press RETURN
     $ for the first event^')
      CALL TRMOUT(80,'  --->     Please wait a moment...^')
C
C                            ALLOCATE THE CALIBRATION DATA SETS
C
      IFILE = 0
      NCALI = 1
      HDUM  = HBLANK
      OK    = .TRUE.
C
      LUNNNN = 0
      CALL LINKDS(LUNNNN,LUNC(1,3),HERR,DDN)
      IF( HERR .NE. 0 ) GO TO 100
      LUNITA(1) = LUNNNN
      GO TO 150
C
C                            ERROR WHILE ALLOCATING AUPDAT1 FILE
C
 100  CALL TRMOUT(80,'Error in allocating F11LHO.AUPDAT1.  The BUPDAT fi
     $les will be tried..^')
      IF( NCALI .EQ. 1 ) GO TO 130
 105  CALL TRMOUT(80,'Allocation Failure for both A and B files. Prematu
     $re End.^')
C
      OK = .FALSE.
      RETURN
C
C                            ERROR WHILE ALLOCATING BUPDAT0/1 FILE
C
 110  CALL TRMOUT(80,'Error in allocating BUPDAT0,1 files.  The AUPDAT1
     $file will be tried..^')
      IFILE = 0
      IF( NCALI .EQ. 2 ) GO TO 150
      GO TO 105
C
 120  NCALI = 2
C
 130  IFILE = 1
C
      DO  140  II = 1,2
        IPDS = II
        IF( II .EQ. 2  .AND.  HDUM .EQ. HCAL ) IPDS = 4
        LUNNNN = 0
        CALL LINKDS(LUNNNN,LUNC(1,IPDS),HERR,DDN)
        IF( HERR .NE. 0 ) GO TO 110
        LUNITA(II) = LUNNNN
 140  CONTINUE
C
      CALL TRMOUT(80,'  ---> Allocation Ready....^')
      RETURN
C
 150  CALL TRMOUT(80,'  ---> Allocation Ready.  Enter ?^')
      CALL TRMIN(2,HDUM)
      IF( HDUM .NE. HBLANK ) GO TO 120
C
      RETURN
      END

C   14/10/82            MEMBER NAME  BSCOM1   (S)           FORTRAN77
      SUBROUTINE BSCOM1
C
C     INDEX    VARIABLE     MEANING
C
C       1      ICOND        ERROR CONDITION
C       2      NLAST        LENGTH OF COMMON/BCS/
C       3      NDUMP        NR OF WORDS PRINTED IN A DUMP
C       4      NSPL         NR OF WORDS FOR LOW PRIORITY BANKS
C       5      NAMAX        NR OF DIFFERENT NAMES ALLOWED
C       6      NAMAX1       NAMAX+1
C       7      NLIST        NR OF ENTRIES IN LISTS ALLOWED
C       8      NPRIME       PRIME NR USED IN IBLN
C       9      NFRS         FIRST LOCATION FOR BANKS
C      10      NLST         LAST LOCATION FOR BANKS
C
C      11      NEXT         NEXT LOCATION FOR BANKS
C      12      NCI          ACTUAL NR OF DIFFERENT NAMES
C      13      NFRE         NR OF FREE LOCATIONS
C      14      IN           ACTUAL NR OF NAMES IN LIST
C      15      KPOS         INDEX FROM BPOS/CPOS
C      16      LIND         INDEX OF LAST CREATED BANK
C      17      ILOW         LOWEST INDEX OF DELETED BANK
C      18      LFDI         LAST I-INDEX
C      19      LFDK         LAST K-INDEX
C      20      NCPL         ACTUAL NR OF WORDS OF LOW PRIORITY SPACE
C
C      21-30   NHISTH(10)   HISTOGRAM FOR TOTAL SPACE
C
C      31      NHIST(11)    OVERFLOWS TOTAL SPACE
C      32      NCOL         NR OF GARBAGE COLLECTIONS
C      33      NZT          TIME OF BOS-START
C      34      IBFI         INDEX FOR BUFF-BANK
C      35      NLAST1       COPY OF NLAST
C      36      ISLST        INDEX FOR SPECIAL LIST OF NAMES
C      37      IMLST        INDEX FOR MARKERS OF SP. LIST O.N.
C      38      INAMV        INDEX FOR NAMES
C      39      IOLST        INDEX FOR IO-LIST
C      40      IPLST        INDEX FOR POINTERS TO NAMES
C
C      41-50   NER(10)      INPUT ERROR CODES FROM BINP/BRDS
C
C      51      NRECL        DEFAULT RECORD LENGTH FOR OUTPUT
C      52      NERRL        NR OF ERRORS ALLOWED
C      53      NRIN         NR OF INPUT EVENTS
C      54      NROUT        NR OF OUTPUT EVENTS
C      55      NS           ACTUAL NR OF NAMES IN SPECIAL LIST
C      56      NEXTI        NEXT INDEX FOR BANKS IN BRDS
C      57      NEXTA        INDEX OF BEGIN OF NEW EVENT
C      58      NEXTB        INDEX BEHIND NEW EVENT
C      59      ISAVB        INDEX OF SAVED LOCATION IN BWRS
C      60      NSAVB        CONTENT OF SAVED LOCATION IN BWRS
C
C      61-70   NHISTL(10)   HISTOGRAM FOR LOW PRIORITY SPACE
C
C      71      NHISTL(11)   OVERFLOWS OF LOW PRIORITY SPACE
C      72      MARKWR       MARKER FOR BSEQ
C      73-75   NOUT(3)      OUTPUT UNITS FOR BSEQ
C      76      IASW         SWITCH FOR FORTRAN/ASSEMBLER READ (BSEQ)
C      77      NPRE         NR OF BPRE PRINTOUTS
C      78-80   IDUMMY(2)    TWO DUMMY WORDS (ZERO)
C      80      NDUMP1       SAME AS NDUMP
C
      END

      SUBROUTINE VTXPRE(IH,IP) 
C*800623*DITTMANN***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXPRE)   18.9.86
C*                                                                 *
C*   P R E P A R A T I O N   F O R   X Y Z   V E R T E X   F I T   *
C*                                                                 *
C*       IH = POINTER TO 'HEAD' BANK                               *
C*       IP = POINTER TO 'PATR' BANK (AS IN JADE COMP NOTE 12).    *
C*                                                                 *
C*       VTXPRE COPIES ALL TRACKS INTO /CWORK1/, FLAGS TRACKS WHICH*
C*       SHOULD NOT BE USED IN VERTEX FIT, AND ADDS COULOMB        *
C*       SCATTERING ERRORS IN MATERIAL BEFORE FIRST WIRE.          *
C*       FOR DETAILS OF THE T-ARRAY SEE COMMENT IN SUBR. VERTEX.   *
C*                                                                 *
C*       SUBR. VTXINI MUST BE CALLED BEFORE FIRST CALL TO VTXPRE   *
C*                                                                 *
C*    MODIFIED FOR VERTEX CHAMBER HARDWARE     860211 C.K.         *
C*                                                                 *
C*    MODIFIED COMFIT-ERROR OF SCATTERING-ANGLE   860217 C.K.      *
C*                                                                 *
C*    +++ BIG MODIFICATION +++                    860611 C.K.      *
C*                                                                 *
C*    * FOR EACH TRACK NOW 40 INSTEAD OF 30 WORDS IN T()           *
C*                                                                 *
C*    * FITS IN RPHI AND ZS ARE TREATED INDEPENDENT                *
C*      ( DIFFERENT FIRST POINT, MULT. SCATTERING POSSIBLE,        *
C*        THIS IS NECCESSARY FOR 'COMFIT'TED TRACKS         )      *
C*                                                                 *
C*    +++ END MODIFICATION +++                                     *
C*                                                                 *
C*    - CURVATURE-CORRECTION                                       *
C*    - RECALCULATION OF FIRST MEASURED POINT FOR TYP 2 TRACKS     *
C*                                                                 *
C*    ... COVARIANCES FOR ERROR CALCULATION ...   860714 C.K.      *
C*                                                                 *
C*******************************************************************
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
#include "cdata.for"
C
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C%MACRO MVERTEX2
C     MACRO FOR VERTEX-FIT ROUTINES ( AXIS AND STATISTICS )
      COMMON /CVTX2/ MODE,TAXIS(12),SVR,HVTXST(120)
C
      DIMENSION IVTXST(1)
C
C        CONSTANTS
      COMMON /CVTXC/ XB,YB,ZB,RTANK,DTANK,X0INN,SIGX0,SIGZ0,PNTMIN,
     *               DISTB,COLL2,MITER,DSCONV,PRCUT,IREJTR,EEDPMN,
     *               EEDPMX,EEDTMX,EEDRMX,SEMAX,SIMAX,SIGFAC,EEXYMN,
     *               EEXYMX,PHEMAX,SIG1
      REAL*8 AA,BB,CC,DD,EE,RR,DR,DR1M
      REAL*8 PHI,SPHI,CPHI,XD,YD,PARKOR,DSR,DPHI
      REAL H03
C                  DEFAULT VALUES
      DATA LFIELD,LRUN/-4848,-1/
C
C
      NT = 0
C-------------------------------------------------------
C  UPDATE OF DTANK AND X0INN
C
      DTANK = RITNK - RBPIPE(DUM)
      X0INN = XBPIPE(DUM)
C-------------------------------------------------------
      IF(IH.EQ.0) RETURN
      IH2 = 2*IH
      NRUN = HDATA(IH2+10)
      NVAV = HDATA(IH2+18)
C
C---- LOCATE RUN-VERTEX IF NEEDED
C
      IF (TBIT(MODE,31)) CALL WTXCRV(NRUN,RVX,RVY,RVDX,RVDY)
C     NOTE THIS CODING FIXES UP ONLY VERY LOW FIELDS
         IFIELD = HDATA(IH2+30)
         IF(IABS(IFIELD).GE.100) GO TO 5408
      IF (NRUN .NE. LRUN)  WRITE(6,5407) NRUN,IFIELD,LFIELD
5407  FORMAT(' * WTXPRE #### *   WARNING: RUN ',I6,' HAS MAGNETIC FIELD
     $ = ',I6,' GAUSS - USING ',I6)
      HDATA(IH2+30)=LFIELD
      IFIELD = HDATA(IH2+30)
      LRUN=NRUN
5408  H03 = .00003 * ABS(FLOAT(IFIELD))
      IF(IP.EQ.0) RETURN
      NT = IDATA(IP+2)
      IF(NT.LE.0) RETURN
      IF(NT.GT.50) NT=50
      L0 = IDATA(IP+1)
      LT = IDATA(IP+3)
C
      KT = IP + L0
      JT = 0
      DO 19 I=1,NT
      DO 11 J=1,40
   11 IT(JT+J) = 0
      IPFLAG = IDATA(KT+44)
C        MOST OF THE FOLLOWING TRACK REJECT CRITERIA ARE DUE
C        TO FAULTS IN THE PATR BANK
      IF(ADATA(KT+25).EQ.0.) GOTO 18
      PT = SQRT(ADATA(KT+8)**2+ADATA(KT+9)**2)
      IF(PT.EQ.0.) GOTO 18
      IF(ADATA(KT+10).EQ.0.) GOTO 18
CCC   T(JT+2) = -1. / ADATA(KT+25)
      RR = -1.D0 / PARKOR(KT)
      T(JT+2) = SNGL(RR)
      T(JT+3) = ATAN2(ADATA(KT+9),ADATA(KT+8))
      TTH = ADATA(KT+10) / PT
      CTH = 1. / SQRT(1.+TTH**2)
      T(JT+4) = ATAN(TTH)
      T(JT+5) = ADATA(KT+5)
      T(JT+6) = ADATA(KT+6)
      T(JT+7) = ADATA(KT+7)
      SR = SIGN(1.,T(JT+2))
      DSR = DBLE(SR)
      ITYP = IDATA(KT+18)
      XP0  = ADATA(KT+20)
      YP0  = ADATA(KT+21)
C
C *** RECALCULATION OF FIRST MEASURED POINT WITH CORRECTED CURVATURE
C
      IF (ITYP.NE.2) GOTO 111
      XD = DBLE(XP0)
      YD = DBLE(YP0)
      SPHI = DSIN(DBLE(ADATA(KT+19)))
      CPHI = DCOS(DBLE(ADATA(KT+19)))
      AA = XD - RR*SPHI
      BB = YD + RR*CPHI
      DPHI = DATAN2( DSR*(DBLE(T(JT+5))-AA), DSR*(BB-DBLE(T(JT+6))) )
      XD = XD + RR*(DSIN(DPHI)-SPHI)
      YD = YD - RR*(DCOS(DPHI)-CPHI)
      T(JT+3) = SNGL(DPHI)
      T(JT+5) = SNGL(XD)
      T(JT+6) = SNGL(YD)
C
C     CHANGE TO TYP 1 ?
C
      IF (ABS(T(JT+2)).GT.20000.) GOTO 111
      IF (.NOT.TBIT(MODE,26)) GOTO 111
C
C     LIST OF CHANGED ITEMS IN PATR BANK
C
      ADATA(KT+5) = T(JT+5)
      ADATA(KT+6) = T(JT+6)
      ADATA(KT+8) = COS(T(JT+3)) * PT
      ADATA(KT+9) = SIN(T(JT+3)) * PT
      IDATA(KT+18) = 1
      ADATA(KT+19) = 1./ABS(T(JT+2))
      ADATA(KT+20) = SNGL( DSQRT(AA*AA+BB*BB) - DABS(RR) )
      ADATA(KT+21) = SNGL( DATAN2( BB, AA ) )
      ADATA(KT+22) = 0.
      ADATA(KT+25) = -1./T(JT+2)
C
  111 CONTINUE
C
      SIGX = ADATA(KT+23)
      SIGZ = ADATA(KT+32)
C----     THIS CLUDGE SHOULD SOMEHOW ACCOUNT FOR SYSTEMATIC ERRORS
      SIGX = SIGX * SIGFAC
      SIGZ = SIGZ * SIGFAC
C----
      XNPT = IDATA(KT+24)
      ZNPT = IDATA(KT+33)
C        CHECK RESIDUAL
      IF(SIGX.EQ.0..OR.SIGZ.EQ.0.) GOTO 18
      IF(SIGX.GT.SIG1*SIGX0) GOTO 18
      IF(SIGZ.GT.SIG1*SIGZ0) GOTO 18
C        CHECK NUMBER OF POINTS ON TRACK
      IF(XNPT.LT.PNTMIN .OR. ZNPT.LT.PNTMIN) GOTO 18
      PROJL = ABS((ADATA(KT+14)-ADATA(KT+7))/TTH)
      IF(PROJL.LT.1.) GOTO 18
      SXNPT = SQRT(XNPT)
      SZNPT = SQRT(ZNPT)
      T(JT+8) = SIGX * 14./(PROJL*SXNPT)
      T(JT+9) = SIGZ * 4.24*CTH**2/(PROJL*SZNPT)
      T(JT+10) = SIGX * 3. / SXNPT
      T(JT+11) = T(JT+10)
      T(JT+12) = SIGZ * 2.45 / SZNPT
C *** FOR NEW ERROR-CALCULATION
C     RPHI DEFAULT COVARIANCES ( FROM ID WITH 48 WIRES )
      SIG2N    = SIGX*SIGX/XNPT
      T(JT+20) = PROJL
      T(JT+32) = 154.0*SIG2N/PROJL**4
      T(JT+33) =   0.0
      T(JT+34) = -19.6*SIG2N/PROJL**2
      T(JT+35) =   0.0
      T(JT+36) =  2.45*SIG2N
      T(JT+40) =  10.7*SIG2N/PROJL**2
C     ZS PARAMETERS
      T(JT+37) = SIGZ*SIGZ/ZNPT
      T(JT+38) = PROJL
C     TRUE COVARIANCES FROM COMFIT
      IF ((LT.NE.64).OR.(IDATA(KT+2).NE.301).OR.(IDATA(KT+44).NE.3))
     *   GOTO 139
C     RAMCKE TEST
      IF (ADATA(KT+52).EQ.0.0) GOTO 139
      T(JT+32) = ADATA(KT+52)
      T(JT+33) = ADATA(KT+53)
      T(JT+34) = ADATA(KT+54)
      T(JT+35) = ADATA(KT+55)
      T(JT+36) = ADATA(KT+56)
      T(JT+40) = ADATA(KT+57)
  139 CONTINUE
C ***
      IT(JT+13) = IDATA(KT+24)
      T(JT+15) = 0.
      T(JT+21) = SIN(T(JT+3))
      T(JT+22) = COS(T(JT+3))
      T(JT+23) = TTH
      T(JT+24) = CTH
      IT(JT+1) = 2
      IF(IPFLAG.EQ.2) GOTO 14
C----   THIS CLUDGE CORRECTS AN ERROR IN THE PATR BANK
      AA = -DBLE(T(JT+5)) + RR*DBLE(T(JT+21))
      BB = -DBLE(T(JT+6)) - RR*DBLE(T(JT+22))
      IF(ITYP.EQ.2) AA=AA+DBLE(XP0)
      IF(ITYP.EQ.2) BB=BB+DBLE(YP0)
      DR1M = DSQRT(AA**2+BB**2)
      DR = DR1M - DABS(RR)
      IF(ITYP.NE.2) DR=DR-DBLE(ADATA(KT+20))
      T(JT+5) = T(JT+5) + DR*AA/DR1M
      T(JT+6) = T(JT+6) + DR*BB/DR1M
      T(JT+7) = ADATA(KT+31) + ADATA(KT+30)*SQRT(T(JT+5)**2+T(JT+6)**2)
C----
C
   14 XM = T(JT+5) - T(JT+2)*T(JT+21)
      YM = T(JT+6) + T(JT+2)*T(JT+22)
C
C---- START ITERATION AT RUNVERTEX ?
C
      IF (TBIT(MODE,31)) T(JT+15) =
     *      ( ATAN2( SR*(RVX - XM), SR*(YM - RVY) )
     *      - T(JT+3) ) * T(JT+2)
C
C---- MC WITHOUT MULTIPLE SCATTERING ?
C
      X0VX = XFWVXC(IH)
      X0ID = XFWID(IH) - X0VX
      IF (NRUN.GE.100) GOTO 149
      IF (NVAV.NE.-1)  GOTO 149
         X0ID = 0.
         X0VX = 0.
  149 CONTINUE
C
      PT = H03*T(JT+2)
C
C     INTERSECT WITH INNER TANKWALL
C
      AA = XM
      BB = YM
      AA = AA**2 + BB**2
      BB = T(JT+2)
      BB = BB**2
      CC = RTANK**2
      DD = (AA-BB+CC)/2.D0
      EE = AA*CC - DD**2
C        ANY INTERSECT ?
      IF(EE.LE.0.D0) GOTO 17
      EE = DSQRT(EE)
      XT1 = (XM*DD + YM*EE) / AA
      YT1 = (YM*DD - XM*EE) / AA
      XT2 = (XM*DD - YM*EE) / AA
      YT2 = (YM*DD + XM*EE) / AA
      D1 = SQRT((XT1-T(JT+5))**2+(YT1-T(JT+6))**2)
      D2 = SQRT((XT2-T(JT+5))**2+(YT2-T(JT+6))**2)
      IF(D1.LT.D2) GOTO 16
      XT = XT2
      YT = YT2
      XT2 = XT1
      YT2 = YT1
      XT1 = XT
      YT1 = YT
   16 PHI = ATAN2(-SR*(XM-XT1),SR*(YM-YT1))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+27) = T(JT+2)*THETA
      T(JT+18) = T(JT+27)
      PHI = ATAN2(-SR*(XM-XT2),SR*(YM-YT2))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+26) = T(JT+2)*THETA
C        MULT. SCATTERING IN INNER TANK WALL (AND VTXC)
      BETA = 1.
      TH2 = (14.1/(PT*BETA))**2 * X0ID * T(JT+24)
     *      * ( 1. + 1./9. * ALOG10( X0ID / T(JT+24) ) )**2
      T(JT+16) = SQRT(TH2)
   17 CONTINUE
C
C     INTERSECT WITH BEAMPIPE
C
      CC = (RBPIPE(DUM)+DRPIPE(DUM))**2
      DD = (AA-BB+CC)/2.D0
      EE = AA*CC - DD**2
C        ANY INTERSECT ?
      IF(EE.LE.0.D0) GOTO 172
      EE = DSQRT(EE)
      XT1 = (XM*DD + YM*EE) / AA
      YT1 = (YM*DD - XM*EE) / AA
      XT2 = (XM*DD - YM*EE) / AA
      YT2 = (YM*DD + XM*EE) / AA
      D1 = SQRT((XT1-T(JT+5))**2+(YT1-T(JT+6))**2)
      D2 = SQRT((XT2-T(JT+5))**2+(YT2-T(JT+6))**2)
      IF(D1.LT.D2) GOTO 171
      XT = XT2
      YT = YT2
      XT2 = XT1
      YT2 = YT1
      XT1 = XT
      YT1 = YT
  171 PHI = ATAN2(-SR*(XM-XT1),SR*(YM-YT1))
      THETA = PHI - T(JT+3)
      IF(ABS(THETA).GT.3.141593) THETA=THETA-SIGN(1.,THETA)*6.283185
      T(JT+19) = T(JT+2)*THETA
C        MULT. SCATTERING IN BEAMPIPE
      BETA = 1.
      TH2VX = 0.
      IF (X0VX.GT.0.) TH2VX = (14.1/(PT*BETA))**2 * X0VX * T(JT+24)
     *      * ( 1. + 1./9. * ALOG10( X0VX / T(JT+24) ) )**2
      T(JT+17) = SQRT(TH2VX)
  172 CONTINUE
C
C---- TRACK WITH VTXC ?
C
      R1 = SQRT(T(JT+5)**2+T(JT+6)**2)
      IT(JT+31) = 0
      T(JT+39) = 0.
      IF (R1.GE.RTANK) GOTO 18
      IT(JT+31) = 1
C     DISTANCE 1. WIRE VTXC TO 1. WIRE ID
      DS = 120.
      IF ((IDATA(KT+44).NE.1).AND.(IDATA(KT+44).NE.3)) GOTO 175
C     GET PROJ. TRACKLENGTH FROM ZS-FIT
      PROJLZ = ABS((ADATA(KT+45)-ADATA(KT+46))/TTH)
      DS = T(JT+38) - PROJLZ
C
  175 CONTINUE
      T(JT+38) = T(JT+38) - DS
      T(JT+39) = -DS
C
   18 JT = JT + 40
   19 KT = KT + LT
C
C
      RETURN
      END

C   03/10/77 310281222  MEMBER NAME  TRCOIL   (S)           FORTRAN
      SUBROUTINE TRCOIL(PV,R,*)
C
C      TRACK PARTICLES THROUGH  COIL
C      PV = USUAL PARTICLE VECTOR OF DIMENSION 10
C           FIRST FOUR ARE FOURVECTOR COMPONENTS SEE TRCDET
C     R  = THREE DIMENSIONAL RADIUS VECTOR
C     PV AND R ARE OVER WRITTEN UPON RETURN
C
C     TRACKING STOPS IN FRONT OF THE LEAD GLASS, EITHER IN THE
C     CENTRAL PART OR IN FRONT OF THE END CAP BLOCKS
C     RETURN 1 IS USED IF PARTICLES MISS THE LEAD GLASS ARRAYS
C
C   LAST CHANGE 26.10.1983    W. BARTEL
C
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2
      DIMENSION PV(10),R(3)
      DATA ITRCL /0/
C
C      DRIFT THROHGH FIELD FREE SPACE
C
      IF( PV(6) .LT. .01 ) RETURN 1
C
      PVX=PV(1)/PV(6)
      PVY=PV(2)/PV(6)
      PVZ=PV(3)/PV(6)
      PVXY=PVX**2+PVY**2
      IF(PVXY.LT.1.E-5) RETURN 1
      R1=R(1)**2+R(2)**2
      DR2=(RLG**2-R1)/PVXY
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      PRVBAR = PVR**2 + DR2
      IF(PRVBAR.GE.0.) GO TO 371
C
C ERROR THAT WILL POSSIBLY LEAD TO NEG. ARGUMENT IN SQRT.
C                                                 26.10.83 W.B.
      ITRCL = ITRCL + 1
      IF(ITRCL.LT.11) WRITE(6,374) R(1),R(2),R(3),(PV(K),K=1,6)
374   FORMAT(' TRCOIL ERROR, R(1),R(2),R(3),P1/6 ',3E12.4)
C
371   XL=-PVR+SQRT(PRVBAR)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
      IF( ZLGMI.GE.R(3).OR.R(3).GE.ZLGPL ) GO TO 1000
      RETURN
C
C      FOLLOW PARTICLE TO THE FACE OF THE END CAP COUNTERS
C
 1000 CONTINUE
      RABS=0.
      DO 1001 I3=1,3
 1001 RABS=RABS+R(I3)**2
      RABS=SQRT(RABS)
      DO 1002 I3=1,3
 1002 R(I3)=R(I3)/RABS
      ZLAM=ZENDPL/R(3)
      IF( R(3).LT.0. ) ZLAM=ZENDMI/R(3)
      DO 1003 I3=1,3
 1003 R(I3)=ZLAM*R(I3)
      CALL ENDCLG(R,NCL,&9000)
      RETURN
 9000 RETURN1
      END

C   14/03/84            MEMBER NAME  LUCHEK   (S)           FORTRAN
C   06/07/79 C9071001   MEMBER NAME  LUCHEK   (S)           FORTRAN
      SUBROUTINE LUCHEK
C---  CHECK FIRED LUMONITORS
C
C     H.WRIEDT       06.07.79      18:55
C     LAST MODIFICATION     10.07.79     01:20
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK1(501),HITRAK(3),HCLST,IWORK2(3),HWORK1,
     &               HPBLAT,IWORK3(793),HTRACK(20,51)
C
      LOGICAL LBSIS(8),LBSOT(8),LABSIS(8),LABSOT(8)
C
      COMMON /CLUMON/ LUMHIT(6,24),HLUPLT(102)
C
C---  EXPLANATION OF INDICES IN LUMHIT
C     2.ND INDEX:  1 FOR 1A,  2 FOR 1B,  3 FOR 1A*1B ETC.,
C                 22 FOR 8A, 23 FOR 8B, 24 FOR 8A*8B
C     1.ST INDEX (IN CASE OF A- OR B-COUNTERS):
C                1: SHOULD HAVE FIRED
C                2: HAS FIRED
C                3: HAS NOT FIRED
C                4: SHOULD NOT HAVE FIRED
C                (IN CASE OF A*B COINCIDENCES):
C                1: SHOULD HAVE FIRED
C                2: HAS FIRED
C                3: HAS NOT FIRED
C                4: NONE HAVE FIRED
C                5: ONLY A HAS FIRED
C                6: ONLY B HAS FIRED
C
      NTRACK = HITRAK(1)
      IF (NTRACK.LE.0) RETURN
        DO 10 I = 1,NTRACK
        LUMAOT = HTRACK(4,I)/256
        LUMBOT = HTRACK(4,I) - LUMAOT*256
        LUMAIS = HTRACK(5,I)/256
        LUMBIS = HTRACK(5,I) - LUMAIS*256
        LPBIS = HPBLAT
          DO 20 J = 1,8
          LBIT = 9 - J
          IAOT = JBIT(LUMAOT,LBIT)
          IBOT = JBIT(LUMBOT,LBIT)
          IAIS = JBIT(LUMAIS,LBIT)
          IBIS = JBIT(LUMBIS,LBIT)
          LSBIT = 17 - J - (J-1)/2
          ISIS = JBIT(LPBIS,LSBIT)
          LBSIS(J) = .FALSE.
          LBSOT(J) = .FALSE.
          LABSIS(J) = .FALSE.
          LABSOT(J) = .FALSE.
C
C---      A - COUNTERS
          INDA = 3*(J-1) + 1
          INDAOT = 4 - 3*IAOT
          INDAIS = 3 - IAIS
          LUMHIT(INDAOT,INDA) = LUMHIT(INDAOT,INDA) + 1
          IF (IAIS.EQ.1) HLUPLT(J) = HLUPLT(J) + 1
          IF (IAOT.NE.1) GOTO 2
          LUMHIT(INDAIS,INDA) = LUMHIT(INDAIS,INDA) + 1
          HLUPLT(J+50) = HLUPLT(J+50) + 1
C
C---      B - COUNTERS
    2     INDB = 3*(J-1) + 2
          INDBOT = 4 - 3*IBOT
          INDBIS = 3 - IBIS
          LUMHIT(INDBOT,INDB) = LUMHIT(INDBOT,INDB) + 1
          IF (IBIS.EQ.1) HLUPLT(J+10) = HLUPLT(J+10) + 1
          IF (IBOT.NE.1) GOTO 3
          LUMHIT(INDBIS,INDB) = LUMHIT(INDBIS,INDB) + 1
          HLUPLT(J+60) = HLUPLT(J+60) + 1
C
C---      B-S - COINCIDENCES
    3     IF (ISIS.NE.1) GOTO 4
          IF (IBIS.EQ.1) LBSIS(J) = .TRUE.
          IF (IBOT.EQ.1) LBSOT(J) = .TRUE.
C
C---      A-B - COINCIDENCES
    4     INDAB = 3*(J-1) + 3
          ICOIN = IAOT*IBOT
          IF (ICOIN.NE.1) GOTO 20
          LUMHIT(1,INDAB) = LUMHIT(1,INDAB) + 1
          HLUPLT(J+70) = HLUPLT(J+70) + 1
          IF (IAIS*IBIS.NE.1) GOTO 1
          LUMHIT(2,INDAB) = LUMHIT(2,INDAB) + 1
          HLUPLT(J+20) = HLUPLT(J+20) + 1
          GOTO 5
    1     LUMHIT(3,INDAB) = LUMHIT(3,INDAB) + 1
          INDABI = 4 + IAIS + 2*IBIS
          LUMHIT(INDABI,INDAB) = LUMHIT(INDABI,INDAB) + 1
          GOTO 6
C
C---      A-B-S - COINCIDENCES
    5     IF (ISIS.NE.1) GOTO 8
          HLUPLT(J+30) = HLUPLT(J+30) + 1
          LABSIS(J) = .TRUE.
          GOTO 7
    6     IF (ISIS.NE.1) GOTO 8
    7     HLUPLT(J+80) = HLUPLT(J+80) + 1
          LABSOT(J) = .TRUE.
C
C---      A-B-S - B-S - COINCIDENCES
    8     IF (J.LE.4) GOTO 20
          IF (LABSIS(J-4).AND.LBSIS(J)) HLUPLT(J+36) = HLUPLT(J+36) + 1
          IF (LABSIS(J).AND.LBSIS(J-4)) HLUPLT(J+40) = HLUPLT(J+40) + 1
          IF (LABSOT(J-4).AND.LBSOT(J)) HLUPLT(J+86) = HLUPLT(J+86) + 1
          IF (LABSOT(J).AND.LBSOT(J-4)) HLUPLT(J+90) = HLUPLT(J+90) + 1
   20     CONTINUE
   10   CONTINUE
      RETURN
      END

C   12/01/87 702231755  MEMBER NAME  ZE4VML   (S)           FORTRAN77
      SUBROUTINE ZE4VMI( NPZIM1 )
C-----------------------------------------------------------
C VERSION OF 23/02/87    LAST MOD. 23/02/87  M.ZIMMER
C
C INITS ADDITIONAL MEIER LG ANALYSIS
C
C CUTS APPLIED :
C       P >= 1GEV
C       E/P FROM LGCL >= 0.5 ( SINCE E-MEIER < E-LGCL )
C
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
      LOGICAL FIRST / .TRUE. /

C                                      CUTS USED FOR SELECTION          IDATES
C                                      MIN MOMENTUM
      DATA PMIN / 1. /
C                                      E/P MIN (FROM LGCL )
      DATA EPMIN / .5 /
C
C
      IF( .NOT. FIRST ) GO TO 10
         FIRST = .FALSE.
C
         CALL LGINIT
         CALL FEHLTX( 21,'P - CUT IN ZE4VML NOT PASSED')
         CALL FEHLTX( 22,'E/P - CUT IN ZE4VML NOT PASSED')
         CALL FEHLTX( 23,'TRACK NOT CHARGED IN ZE4VML')
         WRITE(6,9101) PMIN,  EPMIN
 9101    FORMAT(/' ZE4VMI HAS BEEN CALLED WITH FOLLOWING CUTS:'/,
     &           ' P - MIN                 :  ',F10.4,/,
     &           ' MIN E/P FROM LGCL       :  ',F10.4,/)
C
   10 CONTINUE
C
C                                      SAVE PATR-BANK
      NPPATR = IW(IBLN('PATR'))
      LPATR = IW( NPPATR )
      IPATR = IW( NPPATR - 2 )
      NPZIM1 = 0
      CALL BCRE(NPZIM1,'ZIM1',1,LPATR,&8100,IER)
      IF(IER.NE.0) GOTO 8100
      CALL BSAW(1,'ZIM1')
C                                      COPY PATR-BANK TO ZIM1 BANK
      CALL UCOPY( RW(NPPATR + 1), RW(NPZIM1+1), LPATR )
C                                      END OF INIT
      GOTO 8000
      ENTRY ZE4VML( NPSPUR, ESHM )
C----------------------------------------------------------------------
C LAST MOD 23/02/87 MZ/GE
C
C PERFORM MLG-ANALYSIS
C NPSPUR IS POINTER TO TRACK IN ZE4V-BANK
C----------------------------------------------------------------------
      ESHM = 0.
      NPZE4V = IW( IBLN('ZE4V'))
      IF ( NPZE4V .LE. 0 ) GOTO 8000
C                                      LENGTH OF GEN. TRACK PART
      LT = HW( NPZE4V*2 + 5 )
C                                      IS TRACK CHARGED?
      IPTF = HW( NPSPUR*2 + 18 )
      IF( IPTF .NE. 1 ) CALL FEHLER( 23, &8000 )
C                                      MOMENTUM CUT
      PTOT = RW( NPSPUR + 6 )
      IF ( PTOT .LT. PMIN )   CALL FEHLER( 21, &8000 )
C                                      E/P MINIMUM ( FROM LGCL )
      EPLGCL = RW( NPSPUR + LT + 1 ) / PTOT
      IF ( EPLGCL .LT. EPMIN ) CALL FEHLER( 22, &8000 )
C                                      GET TRACK NUMBER OF PATR BANK
      NUMTRK = HW( NPSPUR*2 + LT*2 + 9 )
C                                      ESHM ENERGY FROM BARREL ONLY
      CALL PBEN9( NUMTRK, NCLU, ESHE, ESHM, IPBC, IPBER )
      GOTO 8000
C                                      NORMAL EXIT
      ENTRY ZE4VME (IPPATR )
C----------------------------------------------------------------------
C LAST MOD 23/02/87  MZ/GE
C
C RESTORE ORIGINAL PATR- BANK ( COPIED TO ZIM1 ) IN OLD LOCATION
C----------------------------------------------------------------------
C                                      COPY ZIM1-BANK TO PATR-BANK
      CALL UCOPY( RW(NPZIM1 + 1), RW(NPPATR+1), LPATR )
      CALL BDLS('ZIM1',1)
      IPPATR = NPPATR
 8000 CONTINUE
      RETURN
C                                      ERRORS
C
 8100 WRITE(6,*)' ++++++ ZE4VLG :  ERROR WHILE CREATING ZIM1-BANK !!'
      RETURN
 8200 WRITE(6,*)' ++++++ ZE4VLG :  INVALID PTF-CODE !!!!!!'
      RETURN
      END

C   05/08/85 508061824 MEMBER NAME  PROFIL   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PROFIL
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   5/08/85 :  RENAME AN EXISTING MACRO
C
C
C     THIS ROUTINE READS A USERS PROFILE (DATASET CONTAINING MACROS)
C     AND DEFINES THE MACROS FOR THE CURRENT SESSION.
C
C     PROFILE NAME MUST BE:  USERID.GRAPHICS.PROFILE.MACROS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CHARS, CNAME(6), CID(16)
      LOGICAL*1  CDEF
      REAL*8  DDN, DNAME(6)
C
      COMMON / CGRMAC / MACNR, MACSTA, MACDEP, MACPNT(2,10), CDEF(80,31)
C
      COMMON / CWORK3 / CHARS(80), ISTAFL(80), IENDFL(80)
C
      EQUIVALENCE  ( CNAME(1), DNAME(1) )
C
      DATA  DNAME / 'F11LHO.G', 'RAPHICS.', 'PROFILE.',
     +              'MACROS  ', '        ', '        ' /
C
C------------------  C O D E  ------------------------------------------
C
      CALL JOBNAM(CID)
C
C                            COPY FIRST 6 LETTERS OF ID INTO DNAME(1)
C
      DO  1  I = 1,6
        CNAME(I) = CID(I)
   1  CONTINUE
C
      LUPROF = 0
      CALL LINKDS(LUPROF,DNAME,HERR,DDN)
C
C                            ERROR RETURN ==> PROBABLY NO PROFILE
C
      IF( HERR .NE. 0 ) RETURN
C
C                            READ IN THE PROFILE MACROS
C
   5  READ(LUPROF,10,END=999) CHARS
  10  FORMAT(80A1)
C
      IF( MACNR .LT. 30 ) GO TO 20
       WRITE(6,12)
  12   FORMAT(' 30 PROFILE macros already defined. Processing aborted.')
       RETURN
C                            FIND THE NAME
C
  20  CALL LOCFLD( CHARS, NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .EQ. 0 ) RETURN
C
C                            CORRECT LENGTH AND ONLY ONE?
C
      LEN = IENDFL(1) - ISTAFL(1) + 1
      IF( NFIELD .EQ. 1  .AND.  LEN .LE. 8 ) GO TO 60
        WRITE(6,50)
  50    FORMAT(' Bad MACRO NAME found while processing PROFILE.',
     +         ' Processing aborted.')
        RETURN
C
C                            IS THE NAME UNIQUE?
C
  60  CALL FINABR( CHARS(ISTAFL(1)), LEN, IREC, MAXARG, IS )
      IF( IREC .LE. 0 ) GO TO 70
        WRITE(6,65)
  65    FORMAT(' PROFILE MACRO NAME conflicts with a',
     +         ' COMMAND NAME. MACRO ignored.')
        READ(LUPROF,10,END=999)
        GO TO 5
C
C                            READ DEFINITION
C
  70  IMAC = MACNR + 1
C
      READ(LUPROF,10,END=999) (CDEF(K,IMAC),K=1,80)
C
C                            NULL LINE?
C
      CALL LOCFLD( CDEF(1,IMAC), NFIELD, ISTAFL, IENDFL )
      IF( NFIELD .GT. 0 ) GO TO 100
        WRITE(6,95)
  95    FORMAT(' PROFILE macro definition aborted. No macro defined.')
        GO TO  5
C
C
C                            ADD NAME TO COMMAND LIST
C                            COMMAND NUMBER IS MACRO NUMBER + BASE NO.
C
 100  MACNR  = MACNR + 1
      NUMCMD = MACNR + MACSTA
      CALL SETCMD( NUMCMD, CHARS(ISTAFL(1)), 0, 0,0,0 )
C
      GO TO 5
C
 999  RETURN
      END

C   25/03/81            MEMBER NAME  PRTRAK   (PATRECSR)    FORTRAN
      SUBROUTINE PRTRAK(IPPATR,NTRAK)
      IMPLICIT INTEGER*2(H)
C----------------------------------------------------------------------
C         --------------- SUBROUTINE PRTRAK ------------------
C         ---- G.F.PEARCE .. LAST UPDATE : 1400 ON 24/03/81 ----
C
C     PROGRAM TO PRINT OUT THE CONTENTS OF THE 'PATR' BANK FOR A GIVEN
C     TRACK.
C
C     IPPATR = BOS POINTER TO 'PATR' BANK  ( = IDATA(IBLN('PATR')) )
C     NTRAK  = REQUIRED TRACK NUMBER
C
C     PRINTOUT IS DIRECTED TO LINE PRINTER UNIT
C
C----------------------------------------------------------------------
#include "cdata.for"
      REAL*8 TYPE(2)/'REALDATA',' MCARLO '/
      INTEGER*2 HDENT(2)
      EQUIVALENCE (IDENTY,HDENT(1))
C------------------------
C CHECK FOR FALSE POINTER
C------------------------
      IF(IPPATR.GE.1)GOTO20
      PRINT10,IPPATR
 10   FORMAT(' ******* PRTRAK ERROR .. POINTER ERROR, IPPATR=',I6)
      RETURN
C------------
C PRINT TITLE
C------------
 20   NBANK=IDATA(IPPATR-2)
      NTRTOT=IDATA(IPPATR+2)
      LTR=IDATA(IPPATR+3)
      ITYPE=1
      IF(NBANK.EQ.12)ITYPE=2
      PRINT30,IDATA(IPPATR-3),NBANK,NTRAK,NTRTOT,TYPE(ITYPE)
 30   FORMAT(/1X,50('-')/
     - ' PRINTOUT OF BANK ',A4,' BANK NUMBER',I3,' FOR TRACK',I4,
     - ' .. TOTAL NUMBER OF TRACKS =',I4,3X,' ***** ',A8,' *****'/
     - 1X,50('-'))
C---------------
C TRACK EXISTS ?
C---------------
      IF(NTRAK.LE.NTRTOT.AND.NTRAK.GE.1)GOTO50
      PRINT40
 40   FORMAT(' ******* PRTRAK ERROR .. NON-EXISTENT TRACK')
      RETURN
C-------------
C TRACK HEADER
C-------------
 50   IP=IPPATR+IDATA(IPPATR+1)
      IP=IP+LTR*(NTRAK-1)
      IDENTY=IDATA(IP+2)
      IDATE=IDATA(IP+3)
      IF(NBANK.EQ.12)GOTO70
      PRINT60,IDATA(IP+1),IDATE,HDENT(2)
 60   FORMAT(/' TRACK',I3,'  DATE OF PATTERN RECOGNITION =',I6,
     -        '    PROGRAM IDENTIFIER =',Z2)
      GOTO90
 70   PRINT80,IDATA(IP+1),HDENT(1),HDENT(2),IDATE
 80   FORMAT(/' TRACK',I3,' NUMBER OF 4-VECTORS =',I4,
     - ' PARTICLE TYPE =',I3,' DATE OF PATTERN RECOGNITION =',I6)
C---------------------
C START AND END POINTS
C---------------------
 90   PRINT100,IDATA(IP+4),ADATA(IP+5),ADATA(IP+6),ADATA(IP+7)
     -                    ,ADATA(IP+8),ADATA(IP+8),ADATA(IP+10)
 100  FORMAT(/' START POINT .. TYPE =',I3,4X,
     -      ' POSITION  X = ',E11.4,'   Y = ',E11.4,'   Z = ',E11.4/24X,
     - '      DIRN COS DX = ',E11.4,'  DY = ',E11.4,'  DZ = ',E11.4)
      PRINT110,IDATA(IP+11),ADATA(IP+12),ADATA(IP+13),ADATA(IP+14)
     -                     ,ADATA(IP+15),ADATA(IP+16),ADATA(IP+17)
 110  FORMAT(/' END   POINT .. TYPE =',I3,4X,
     -      ' POSITION  X = ',E11.4,'   Y = ',E11.4,'   Z = ',E11.4/24X,
     - '      DIRN COS DX = ',E11.4,'  DY = ',E11.4,'  DZ = ',E11.4)
C-------------------
C X-Y FIT PARAMETERS
C-------------------
      PRINT120,IDATA(IP+18),ADATA(IP+19),ADATA(IP+20),ADATA(IP+21),
     -         ADATA(IP+22),ADATA(IP+23),IDATA(IP+24),
     -         ADATA(IP+25),ADATA(IP+26),ADATA(IP+27),ADATA(IP+28)
 120  FORMAT(/' X-Y FIT     .. TYPE =',I2,' FIT PARAMETERS = 1)',E11.4,
     - ' 2)',E11.4,' 3)',E11.4,' 4)',E11.4/
     - 16X,'RMS = ',E11.4,' NUMBER OF HITS USED IN FIT =',I4/
     - 16X,'TRACK CURVATURE = ',E11.4,' ERROR = ',E11.4,
     - ' START CURVATURE = ',E11.4,'  END CURVATURE = ',E11.4)
C-------------------
C Z-R FIT PARAMETERS
C-------------------
      PRINT140,IDATA(IP+29),ADATA(IP+30),ADATA(IP+31),ADATA(IP+32),
     -         IDATA(IP+33)
 140  FORMAT(/' Z-R FIT     .. TYPE =',I2,
     - '    FIT PARAMETERS = 1) ',E11.4, ' 2) ',E11.4,
     - '    RMS = ',E11.4,' NUMBER OF HITS USED =',I4)
C----------------------
C CELLS STRUCK BY TRACK
C----------------------
      PRINT150,IDATA(IP+34),IDATA(IP+35),IDATA(IP+36),IDATA(IP+37),
     -         IDATA(IP+38),IDATA(IP+39)
 150  FORMAT(/' CELLS HIT   ..  ',6I4)
C--------------------------------
C CONNECTIONS WITH OTHER ANALYSES
C--------------------------------
      PRINT160,IDATA(IP+40),IDATA(IP+41),IDATA(IP+42),IDATA(IP+43)
 160  FORMAT(/' POINTERS    ..  1) LEAD GLASS CLUSTER =',I6,
     -       '    2) MUON HITS =',I6,
     -       '    3) TP TRACK BANK =',I6,
     -       '    4) TOF BANK =',I6)
C-----------------------
C ADDITIONAL INFORMATION
C-----------------------
      PRINT170,IDATA(IP+44),ADATA(IP+45),ADATA(IP+46),IDATA(IP+47)
 170  FORMAT(/' ADDITIONAL INFORMATION FLAG =',I3,2X,
     -       ' FIRST VALID Z-COORDINATE =',E11.4,3X,
     -       ' LAST VALID Z-COORDINATE =',E11.4//
     -       ' NUMBER OF HITS ATTACHED TO TRACK =',I5)
C--------------
C TRACK HISTORY
C--------------
      IDENTY=IDATA(IP+48)
      PRINT180,IDENTY
 180  FORMAT(/' TRACK HISTORY WORD = ',Z4)
C---------
C TP FIT ?
C---------
      IF(LTR.GT.48)GOTO200
      PRINT190,LTR
 190  FORMAT(' ** THIS BANK CONTAINS A PATREC FIT AND NOT A TP FIT **')
      RETURN
C-------------
C R-PHI ERRORS
C-------------
 200  PRINT210,ADATA(IP+49),ADATA(IP+50),ADATA(IP+51),ADATA(IP+52),
     -         ADATA(IP+53),ADATA(IP+54),ADATA(IP+55)
 210  FORMAT(/' ERRORS FROM ..  R-PHI CHI**2 = ',E11.4,
     -                       '  COV(PHI**2) = ',E11.4,
     -                       '  COV(PHI*RMIN) = ',E11.4,
     -                       '  COV(RMIN**2)    = ',E11.4/
     -        '   TP FIT    ..',30X,'COV(PHI*K)  = ',E11.4,
     -                       '  COV(RMIN*K)   = ',E11.4,
     -                       '  COV(K**2)       = ',E11.4)
C-----------
C Z-R ERRORS
C-----------
      PRINT220,ADATA(IP+56),ADATA(IP+57),ADATA(IP+58),ADATA(IP+59)
 220  FORMAT( '             ..  Z-R CHI**2   = ',E11.4,
     -                       '  COV(Z0**2)  = ',E11.4,
     -                       '  COV(Z0*DZ/DR) = ',E11.4,
     -                       '  COV((DZ/DR)**2) = ',E11.4)
C---------------------
C DATE OF TP TRACK FIT
C---------------------
      PRINT230,IDATA(IP+60)
 230  FORMAT(/' TP FIT DATE ..  ',I5)
C------------
C END OF DUMP
C------------
 300  PRINT310
 310  FORMAT(/1X,16('-'),' END OF PATR DUMP ',16('-'))
      RETURN
      END

C   16/02/84 608291007  MEMBER NAME  DEDXV100 (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DEDXV1
C-----------------------------------------------------------------------
C
C   ADAPTED FROM J.OLSSON'S DEDXVW
C
C   LAST MOD: J.A.J.SKARD   28/08/86 :
C
C         SHOW DEDX FOR EACH WIRE VS SQRT(R**2+Z**2) FOR ONE TRACK
C
C         DEDX NN     NN>0 SHOWS DEDX PER WIRE FOR TRACK NN
C
C         THE TRAILING INTEGER FROM DEDX COMMAND IS IN ACMD IN /CGRAPH/
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C
#include "cgraph.for"
#include "cdata.for"
#include "chsym.for"
#include "cjdrch.for"
C
      COMMON / CALIBR / IPOINT(100)
      COMMON / CHEADR / HEAD(108)
       COMMON /CWORK1/ IER,NTR ,TRES(10,60),EWIR(60),XWIR(60),YWIR(60),
     *                 RWIR(60),ZWIR(60),HMW(132)
C
      DIMENSION XCAL(1000), ITRES(10,60)
      EQUIVALENCE (IPOINT(1),XCAL(1))
      EQUIVALENCE (TRES(1,1),ITRES(1,1))
      DIMENSION ARR(60)
C
C------------------  C O D E  ------------------------------------------
C
      HRUN = HEAD(18)
      IF(HRUN.LT.100)RETURN
      NN = ACMD
      NTRR = MIN0(NTR,60)
C     WRITE(6,3204)NTRR,NN
C3204 FORMAT(' *** DEDXV1: NTRR,NN=',2I6)
      IF(NTRR.GT.0.AND.NN.GT.0.AND.NN.LE.NTRR)GO TO 3201
      GO TO 998
C
C                            DEFINE WINDOW SIZE
C
3201  CALL ERASE
        CALL TWINDO(0,4095,0,4095)
      XMINRE = XMIN
      XMAXRE = XMAX
      YMINRE = YMIN
      YMAXRE = YMAX
C        FIND MAX AND MIN (NON-ZERO) ENERGY DEPOSIT VALUE, AND X-SCALE
      EMIN=1.E10
      EMAX=0.
      XHI=0.
      DO 2801 I=1,60
      IF(ABS(EWIR(I)).LT.1.E-10)GO TO 2801
      XTMP=RWIR(I)**2+ZWIR(I)**2
      IF(EWIR(I).LT.EMIN)EMIN=EWIR(I)
      IF(EWIR(I).GT.EMAX)EMAX=EWIR(I)
      IF(XTMP.GT.XHI)XHI=XTMP
 2801 CONTINUE
      EINTER=AMAX1(10.,EMAX-EMIN)
      XHI=(IFIX(SQRT(XHI)/100.)+2)*100
      XMIN=-80.
      XMAX=AMAX1(1100.,XHI)+120.
      XVMIN=100.0
      XVMAX=XMAX-220.
      YVMIN=IFIX(EMIN-1.-EINTER/8.)
      IF(EINTER/EMIN.GT.2.0)YVMIN=0.
      YVMAX=IFIX(EMAX+1.+EINTER/8.)
      YMIN=YVMIN-(YVMAX-YVMIN)/8.
      YMAX=YMIN+(YVMAX-YMIN)/0.60
C     WRITE(6,3205)XMIN,XMAX,YMIN,YMAX,EMAX,EINTER
C3205 FORMAT(' *** DEDXV1: XMIN,XMAX,YMIN,YMAX=',4F10.2,/,
C    *       '             EMAX,EINTER=',2F10.2)
C     WRITE(6,3206)XVMIN,XVMAX,YVMIN,YVMAX
C3206 FORMAT(' *** DEDXV1: XVMIN,XVMAX,YVMIN,YVMAX=',4F10.2)
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
C
C                            DRAW DIAGRAM FRAME
C
      CALL MOVEA(XVMIN,YVMIN)
      CALL DRAWA(XVMAX,YVMIN)
      CALL DRAWA(XVMAX,YVMAX)
      CALL DRAWA(XVMIN,YVMAX)
      CALL DRAWA(XVMIN,YVMIN)
C
C                            DRAW SCALE MARKERS
C
      CALL CHRSIZ(2)
      CALL CSIZE(IHOR,IVER)
      SSX = IHOR*(XMAX-XMIN)/4096.
      SSY = IVER*(YMAX-YMIN)/6240.
      XRANG=XVMAX-XVMIN
      YRANG=YVMAX-YVMIN
      XTICK=YRANG*0.015
      YTICK=XRANG*0.01
      XTDIS=200.
      IF(XRANG.LT.2000.)XTDIS=100.
      IF(XRANG.LT.1000.)XTDIS=50.
      IF(XRANG.LT.400.)XTDIS=10.
      YTDIS=50.
      IF(YRANG.LT.300.)YTDIS=10.
      IF(YRANG.LT.100.)YTDIS=5.
      IF(YRANG.LT.30.)YTDIS=2.
      IF(YRANG.LT.10.)YTDIS=0.5
      IF(YRANG.LT.3.)YTDIS=0.1
      IF(YRANG.LT.0.5)YTDIS=0.02
C
C                            WRITE TO INTERNAL ARRAY HMW
C                            THEN OUTPUT EBCDIC CHARACTERS ON SCREEN
C
      XCURR=XVMIN
      YCURR=YVMIN
 2802 CONTINUE
      IF(XCURR+XTDIS.GE.XVMAX)GO TO 503
      ITEST=(XCURR-XVMIN)*1.0001/XTDIS
      IF(MOD(ITEST,2).NE.0)GO TO 502
C        TICK LABELS
      CALL MOVEA(XCURR-3.0*SSX,YCURR-2.5*SSY)
      IXCURR=XCURR
      CALL CORE(HMW,5)
      WRITE(JUSCRN,245)IXCURR
245   FORMAT(' ',I4)
      CALL EOUTST(5,HMW)
C
C        TICK MARKS
C
502   XCURR=XCURR+XTDIS
C     WRITE(6,3207)XCURR,YCURR
C3207 FORMAT(' *** DEDXV1: X-TICK MARK AT X,Y=',2F10.2)
      CALL MOVEA(XCURR,YCURR)
      CALL DRAWA(XCURR,YCURR+XTICK)
      GO TO 2802
C
503   CONTINUE
      XCURR=XVMIN
      YCURR=YVMIN
2803  CONTINUE
      NYTICK=IFIX((YVMAX-YVMIN)/YTDIS)
      ITEST=(YCURR-YVMIN)*1.0001/YTDIS
      IF(NYTICK.LE.8)GO TO 601
      IF(MOD(ITEST,2).NE.0)GO TO 504
  601 IF(YCURR+2.*YTDIS.GE.YVMAX)GO TO 504
C        TICK LABELS
      IYCURR=YCURR+0.001
      IF(YCURR-FLOAT(IYCURR).GT.0.3)GO TO 504
      CALL MOVEA(XCURR-4.5*SSX,YCURR-0.5*SSY)
      CALL CORE(HMW,4)
      WRITE(JUSCRN,246)IYCURR
246   FORMAT(' ',I3)
      CALL EOUTST(4,HMW)
C        TICK MARKS
504   CONTINUE
C     WRITE(6,3208)XCURR,YCURR
C3208 FORMAT(' *** DEDXV1: Y-TICK MARK AT X,Y=',2F10.2)
      CALL MOVEA(XCURR,YCURR)
      CALL DRAWA(XCURR+YTICK,YCURR)
      YCURR=YCURR+YTDIS
      IF(YCURR.LT.YVMAX)GO TO 2803
C
C                            DEDX PLOT PER WIRE
C
        ITR=NN
        DEDX   = TRES(2,ITR)
        XBAR = XRANG*0.007
        YBAR = YRANG*0.007
C
C        LOOP OVER POINTS ON TRACK
C
      DO 505 NP=1,60
      IF(EWIR(NP).LT.0.01)GO TO 505
        SWIR = SQRT(RWIR(NP)**2+ZWIR(NP)**2)
        CALL MOVEA( SWIR-XBAR, EWIR(NP))
        CALL DRAWA( SWIR+XBAR, EWIR(NP))
C
C                            DRAW ERROR BAR
C
        CALL MOVEA(SWIR,EWIR(NP)+YBAR)
        CALL DRAWA(SWIR,EWIR(NP)-YBAR)
  505 CONTINUE
C
C        DRAW TRUNCATED MEAN DEDX
C
      CALL MOVEA(XVMIN,DEDX)
      CALL DRAWA(XVMAX,DEDX)
C
C        TRUNCATED MEAN DEDX FOR EACH RING SEPARATELY
C
      DO 515 IR=1,3
      NPC=0
      DO 514 I=1,60
      IF(RWIR(I).LE.RDEC(IR).OR.RWIR(I).GT.RDEC(IR+1))GO TO 514
      NPC=NPC+1
      ARR(NPC)=EWIR(I)
514   CONTINUE
      IF(NPC.EQ.0)GO TO 515
      CALL DSORT(NPC,ARR,TRCM,DTRCM)
      XCURR=XVMAX+30.*IR
      YCURR=TRCM
      CALL MOVEA(XCURR-XBAR,YCURR)
      CALL DRAWA(XCURR+XBAR,YCURR)
      CALL MOVEA(XCURR,YCURR-DTRCM)
      CALL DRAWA(XCURR,YCURR+DTRCM)
515   CONTINUE
C
C                            DRAW AXES CAPTIONS (LOWER CASE!)
C
      CALL CHRSIZ(2)
      CALL CSIZE(IHOR,IVER)
      SSX=IHOR*(XMAX-XMIN)/4096.
      SSY=IVER*(YMAX-YMIN)/6240.
      CALL MOVEA(XVMAX-XRANG*0.1,YVMIN-4.5*SSY)
      CALL CORE(HMW,3)
      WRITE(JUSCRN,3209)
3209  FORMAT(' mm')
      CALL EOUTST(3,HMW)
C
      CALL MOVEA(XVMAX,YVMIN)
      CALL DRAWA(XVMAX,YVMIN-4.5*SSY)
      CALL MOVEA(XVMAX+15.,YVMIN-2.5*SSY)
      CALL CORE(HMW,9)
      WRITE(JUSCRN,3214)
3214  FORMAT('Trc. mean')
      CALL EOUTST(9,HMW)
      CALL MOVEA(XVMAX+15.,YVMIN-4.5*SSY)
      CALL CORE(HMW,9)
      WRITE(JUSCRN,3215)
3215  FORMAT(' per ring')
      CALL EOUTST(9,HMW)
C
      CALL MOVEA(XVMAX-0.5*XRANG-8.*SSX,YVMIN-4.5*SSY)
      CALL CORE(HMW,16)
      WRITE(JUSCRN,3210)
3210  FORMAT(' SQRT(R**2+Z**2)')
      CALL EOUTST(16,HMW)
C
      CALL MOVEA(XVMIN-7.5*SSX,YVMAX-3.*SSY)
      CALL CORE(HMW,7)
      WRITE(JUSCRN,3211)
3211  FORMAT(' KeV/cm')
      CALL EOUTST(7,HMW)
C
      IF(NN.GE.10)GO TO 518
      CALL MOVEA(AMAX1(XVMIN-8.5*SSX,XMIN),YVMAX+0.5*SSY)
      CALL CORE(HMW,8)
      WRITE(JUSCRN,3212)NN
3212  FORMAT(' Track',I2)
      CALL EOUTST(8,HMW)
      GO TO 519
 518  CALL MOVEA(AMAX1(XVMIN-9.5*SSX,XMIN),YVMAX+0.5*SSY)
      CALL CORE(HMW,9)
      WRITE(JUSCRN,3213)NN
3213  FORMAT(' Track',I3)
      CALL EOUTST(9,HMW)
 519  CONTINUE
      CALL MOVEA(XVMIN+0.5*(XVMAX-XVMIN)-7.*SSX,YVMAX+0.5*SSY)
      CALL CORE(HMW,14)
      WRITE(JUSCRN,3216)
 3216 FORMAT('dE/dx per wire')
      CALL EOUTST(14,HMW)
C***
C***                    WRITE CAPTION
C***
      INDES = -1
      XMIN=-10.
      YMIN=-10.
      XMAX=50.
      YMAX=50
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
      CALL CAPMRK(INDES,IESUM)
998   CALL TWINDO(0,4095,0,4095)
      XMIN = XMINRE
      XMAX = XMAXRE
      YMIN = YMINRE
      YMAX = YMAXRE
      CALL SETSCL(LASTVW)
 999  RETURN
      END

C   11/06/79 C9100601   MEMBER NAME  LGECOR   (SOURCE)      FORTRAN
      SUBROUTINE LGECOR(ADATA,DEP,IFLAG)
C
C  THIS PROGRAM CALCULATE THE INCIDENT ENERGY
C  FROM THE MEASURED ENERGY.
C
C      05/3/1979     HIROSHI TAKEDA
C      LAST MODIFICATION   22/09/79
C      LAST MODIFICATION   04/10/79 Y.WATANABE
C       (END CAP CORRECTION IS RESTORED EXECPT FOR A FACTOR)
C  ADATA : DATA BUFFER OF THE FOLLOWING PARAMETERS.
C
C    IDATA(1)   0   BARREL
C                    -1   BOTTOM END CAP
C                    +1   TOP    END CAP
C    ADATA(2)   CLUSTER ENERGY IN GEV
C    ADATA(3)   SIGMA(ENERGY)
C    ADATA(4)   WEIGHTED AVERAGE PHI        BARREL
C                                       X        END CAP
C    ADATA(5)   WEIGHTED AVERAGE  Z         BARREL
C                                       Y        END CAP
C    ADATA(6)   SIGMA PHI (WEIGHTED)        BARREL
C                            X                   END CAP
C    ADATA(7)   SIGMA  Z (WEIGHTED)         BARREL
C                            Y                   END CAP
C    IDATA(8)   NUMBER OF CORRESPONDING INNER TRACKS
C    ADATA(9--11) DIRECTION COSIGNS CORRECTED FOR SHOWER DEPTH
C
C  DEP  :  SHOWER DEPTH IN MM
C  IFLAG   0    NORMAL RETURN
C          1    ITERATION OVERFLOW
C          2    HIT OUTSIDE END-CAP
C          3    TOO MUCH ENERGY LOSS
C
      DIMENSION ADATA(2)
      COMMON /CLGDMS/  X0,RADIUS(6),RADSX0(6),
     1  THX0(4),ZEND(2),ZENDX0(2),
     2  ZWID(2),ZGAP(2),PHWID(2),
     3  ZECAP(4),ZECAPX(4),THECPX(2),
     4  ECXLST(24),ECYLST(24)
C
C  THECPX(1)   THICKNESS OF END CAP COUNTER IN MM
C        (2)                                   X0
C  RADIUS(1,2) DISTANCE TO THE COIL SURFACE (INNER AND OUTER)
C        (3,4) DISTANCE TO THE LEAD GLASS SURFACE (TYPE A)
C  ZEND(1)     END POINT OF BARREL PART COUNTERS  (-)
C      (2)                                        (+)
C  ZGAP(1)     COUNTER GAP OF BARREL PART IN MM
C  THX0(1)     MAGNET COIL THICKNESS IN X0
C              X0 = 8.9 CM FOR ALUMINUM
C
      EQUIVALENCE (PHI,XCO),(ZCO,YCO),(IBE,BE)
      DATA ETHRE/0.01/ ,STEP/104.72/
C
C  INITIAL SET UP
C
      BE   =ADATA(1)
      ENERGY=ADATA(2)
      COSX  =ADATA(9)
      COSY  =ADATA(10)
      COSZ  =ADATA(11)
      PHI   =ADATA(4)
      ZCO   =ADATA(5)
      IFLAG=0
C
      IF(IBE.EQ.0) GO TO 1
CCCCCCCCCCCCCCCCCCCCC
C
C  END CAP COUNTERS
C
CCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF THE LIGHT GUIDE
C
      R=(THECPX(1)-DEP)/COSZ
      R=ABS(R)
      XXCO=XCO+R*COSX
      YYCO=YCO+R*COSY
C
      THETA=ARCOS(COSZ)
      THETA=ABS(THETA)*57.2958
      IF(IBE.EQ.-1) THETA=180.0-THETA
C
C   ITERATION FOR INCIDENT ENERGY
C
      ETEMP1=ENERGY
      ITERA=1
      JTERA=1
C
C  IMAGINARY DISPLACEMENT OF COORDINATES
C
   10 RDIS=0.0
      IF(THETA.LE.10.0) GO TO 30
      RDIS=24.0-6.3*ETEMP1
      IF(RDIS.LE.0.0) RDIS=0.0
      RDIS=RDIS/SQRT(1.0-COSZ*COSZ)
   30 XX=XXCO-RDIS*COSX
      YY=YYCO-RDIS*COSY
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
      X=XX/X0
      Y=YY/X0
      CALL LGNMEC(X,Y,ID)
C
C   CHECK IF HIT IS INSIDE THE COUNTER
C
      IF(ID.GT.0) GO TO 60
      X=XXCO/X0
      Y=YYCO/X0
      CALL LGNMEC(X,Y,ID)
C
      IF(ID.GT.0) GO TO 60
      X=XCO/X0
      Y=YCO/X0
      CALL LGNMEC(X,Y,ID)
C
      IF(ID.GT.0) GO TO 60
      IFLAG=2
      RETURN
C
   60 MB=(ID-1)/24 +1
      ID=MOD(ID-1,24)+1
      U=ECXLST(ID)
      V=ECYLST(ID)
      GO TO (4,5,6,7),MB
    4 X=U
      Y=V
      GO TO 8
    5 X=-V
      Y=U
      GO TO 8
    6 X=-U
      Y=-V
      GO TO 8
    7 X=V
      Y=-U
    8 R=SQRT((X-XX)*(X-XX)+(Y-YY)*(Y-YY))
C
C  CORRECTION FACTOR
C
      IF(ETEMP1.GE.1.5) GO TO 2
      FAC=0.1518*ETEMP1+0.8926
      FAC=FAC-R*(0.002067*ETEMP1+0.000236)
      GO TO 3
C
2     FAC=0.0861*ETEMP1+0.9949
      FAC=FAC-R*(0.00092*ETEMP1+0.00209)
      IF(ETEMP1.LE.5.0) GO TO 3
C
C -- ENERGY CORRECTION FOR E > 5 GEV
C    ROUGHLY ESTIMATED FROM BHABHA ENERGY DISTRIBUTION
C       AT 11 GEV AND 15 GEV.
C
      EXX=ETEMP1-5.0
      FAC=FAC*(1.0-EXX*(0.058426-0.002238*EXX))
C
    3 ETEMP2=ENERGY/FAC
      EDIF=ABS(ETEMP2-ETEMP1)
      IF(EDIF.LE.ETHRE) GO TO 9
      ITERA=ITERA+1
      IF(ITERA.GE.10) GO TO 40
      ETEMP1=ETEMP2
      GO TO 10
C
   40 ITERA=1
      ETEMP1=0.5*(ETEMP1+ETEMP2)
      JTERA=JTERA+1
      IF(JTERA.LT.5) GO TO 10
      IFLAG=1
      RETURN
C
    9 ADATA(2)=ETEMP2
      RETURN
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  BARREL PART COUNTERS
C
CCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  EXTRAPOLATION TO THE FACE OF LIGHT GUIDE
C
    1 R=RADIUS(3)+DEP
      COSPHI=COS(PHI)
      SINPHI=SIN(PHI)
      X=R*COSPHI
      Y=R*SINPHI
C
      A=COSX*COSX+COSY*COSY
      B=X*COSX+Y*COSY
      C=X*X+Y*Y-RADIUS(4)*RADIUS(4)
      RDIF=(-B+SQRT(B*B-A*C))/A
C
      X=X+RDIF*COSX
      Y=Y+RDIF*COSY
      Z=ZCO+RDIF*COSZ
C
C  DISTANCE FROM THE CENTER OF LIGHT GUIDE
C
      Z=Z-ZEND(1)+0.5*ZGAP(1)
      PERIOD=ZWID(1)+ZGAP(1)
      IZ=Z/PERIOD+1
      IF(IZ.LE.1) IZ=2
      IF(IZ.GE.32) IZ=31
      Z=Z-PERIOD*(IZ-0.5)
C
      THETA=ATAN(Y/X)
      THETA=ABS(THETA)*RADIUS(4)
      ITH=THETA/STEP
      THETA=THETA-(ITH+0.5)*STEP
C
      R=SQRT(Z*Z+THETA*THETA)
      R=0.1*R
C
      THETA=COSPHI*COSX+SINPHI*COSY
      D=7.88/THETA
      THETA=ARCOS(THETA)*57.2958
C
      ALMA=3.43*D-11.7
C
      IF(ALMA.LT.1000.0) GO TO 70
      IFLAG=3
      RETURN
C
   70 ALMB=8.14*D-5.75
C
C  ITERATION
C
      ETEMP1=ENERGY
      ITERA=1
      JTERA=1
C
C  ENERGY LOSS IN ALUMINUM COIL
C
   21 DELTAE=(ALMA*ETEMP1+ALMB)*0.001
      IF(DELTAE.LE.0.0) DELTAE=0.0
      ETEMP3=ETEMP1-DELTAE
      IF(ETEMP3.GT.0.0) GO TO 22
      ETEMP1=ETEMP1+ETHRE
      GO TO  21
C
   22 THCRI=3.75*ETEMP3+16.25
      THETA1=THETA
      IF(THETA.GE.THCRI) THETA1=THCRI
C
      ATH=-0.000404*ETEMP3+0.0023
      BTH=-0.0000015*ETEMP3+0.0000715
      FAC=(ATH+BTH*THETA1)*THETA1
      IF(FAC.LE.0.0) FAC=0.0
      FAC=1-FAC
C-----
C  WE HAVE NO DATA OF THE POSITION DEPENDENCE
C  AT THE ENERGIES MORE THAN 5 GEV.
C  THE DATA AT 5 GEV IS USED HERE.
C
      ETEMP4=ETEMP3
      IF(ETEMP4.GE.5.0) ETEMP4=5.0
C
      FAC=FAC*(1-0.0139/(THETA+1.95)*ETEMP4*R)
C
      ETEMP2=ENERGY/FAC+DELTAE
      EDIF=ABS(ETEMP2-ETEMP1)
      IF(EDIF.LE.ETHRE) GO TO 20
      ITERA=ITERA+1
      IF(ITERA.GE.10) GO TO 50
      ETEMP1=ETEMP2
      GO TO 21
C
   50 ITERA=1
      ETEMP1=0.5*(ETEMP1+ETEMP2)
      JTERA=JTERA+1
      IF(JTERA.LT.5) GO TO 21
      IFLAG=1
      RETURN
C
   20 ADATA(2)=ETEMP2
      RETURN
C************************************
      ENTRY LGECR0(NVR)
C
C  VERSION NUMBER (DATE)   79 09 22
C
      DATA IVR/791004/
      NVR=IVR
      RETURN
      END

C   13/02/80 504171555  MEMBER NAME  BLSHOW   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BLSHOW
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON       ?    :  DRAW LG BLOCK NUMBERS
C
C       MOD:   J. OLSSON   16/12/84 :
C  LAST MOD:   C. BOWDERY  17/04/85 :  COSMETIC CHANGES ONLY
C
C
C       DISPLAY ROUTINE FOR JADE, SHOWING LEAD GLASS BLOCK NUMBERS,
C       SPINNING BLOCKS AS KILLED IN LGERSE AND AS FAR AS KNOWN.
C       AND DEAD BLOCKS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL FL18,FL22,FL24
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CWORK1 / DMY1(4),X1,Y1,DMY2(2),X2,Y2,ZET,X3,Y3,X4,Y4
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CHEADR / HEAD(108)
C
#include "cgraph.for"
#include "cgeo1.for"
#include "cdata.for"
C
      DIMENSION HBLACK(40)
C
C------------------  C O D E  ------------------------------------------
C
      NN = ACMD + 1
      IF( NN .NE. 1 ) GO TO 100
      GO TO 101
102   CALL TRMOUT(80,'Code 0:   Return;  Code 1:  List;  Code 2:  Show b
     +lock numbers.^')
      CALL TRMOUT(80,'Code 3:   Show blocks killed in bank ALGN^')
      CALL TRMOUT(80,'Code 4:   Show spinning blocks as far as known^')
      CALL TRMOUT(80,'Code 5:   Show dead blocks^')
      CALL TRMOUT(80,'Code 345: Options 3,4 and 5 together^')
      CALL TRMOUT(80,'Code 6:   Explain pulse height code^')
      CALL TRMOUT(80,'Code 7:   Print cluster number for spinners ^')
101   CALL TRMOUT(80,'Enter option.  1=List^')
      NN = TERNUM(DUM) + 1
100   IF(NN.GE.1.AND.NN.LE.7.AND.LASTVW.EQ.13) GO TO 200
      IF(NN.EQ.346.AND.LASTVW.EQ.13) GO TO 400
      IF(NN.EQ.3.AND.LASTVW.EQ.12) GO TO 200
      IF(NN.EQ.8) GO TO 200
      CALL TRMOUT(80,' Not available in this view^')
      RETURN
200   GO TO (999,102,300,400,500,600,700,800),NN
C*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
C
C  DISPLAY SINGLE BLOCK NUMBERS
C
300   IF(LASTVW.EQ.13) CALL BLNUMB
      IF(LASTVW.EQ.12) CALL BLNMFW
      GO TO 999
C*** *** HARD SPINNERS (BAD BLOCKS)  *** *** *** *** *** *** *** *** ***
400   IPALGL = IDATA(IBLN('ALGL'))
      IPALGN = IDATA(IBLN('ALGN'))
      IF(IPALGL.GT.0.AND.IPALGN.GT.0) GO TO 1301
401   CALL TRMOUT(80,'ERROR: ALGL and/or ALGN do not exist^')
      GO TO 999
1302  CALL TRMOUT(80,'ERROR: ALGN is empty^')
      GO TO 999
1301  LNG = IDATA(IPALGL)
      IPL = 2*(IPALGL+3) + 1
      IPLEND =2*(IPALGL+LNG)
      NWO=IDATA(IPALGN)
      IF(NWO.LE.3) GO TO 1302
      IPN=2*IPALGN + 7
      IPNEND=IPN + 2*NWO - 7
      DO 1303  IPLL = IPL,IPLEND,2
      IADLGL = HDATA(IPLL)
      DO 1304 IPNN=IPN,IPNEND,2
      IADLGN = HDATA(IPNN)
      IF(IADLGN.EQ.IADLGL) GO TO 1303
1304  CONTINUE
C-- BLOCK FOUND THAT ONLY APPEARS IN LGCL:   DISPLAY IT
      CALL XYBLK(IADLGL,X1,Y1,DXEB,DYEB)
      X2 = X1
      Y2 = Y1 + DYEB
      Y3 = Y2
      X3 = X2 + DXEB
      X4 = X3
      Y4 = Y1
      CALL CRICRO(0.,0.)
1303  CONTINUE
      IF(NN.EQ.346.AND.LASTVW.EQ.13) GO TO 500
      GO TO 999
C*** *** SOFT SPINNERS * *** *** *** *** *** *** *** *** *** *** *** ***
500   CONTINUE
      HRUN = HEAD(18)
      IPALGN = IDATA(IBLN('ALGN'))
      IF(IPALGN.GT.0) GO TO 501
      GO TO 401
501   NWO=IDATA(IPALGN)
      IF(NWO.LE.3) GO TO 1302
      IPN=2*IPALGN + 7
      IPNEND=IPN + 2*NWO - 7
      DO 504 IPNN=IPN,IPNEND,2
      IADLGN = HDATA(IPNN)
      CALL SPINNR(IADLGN,IER,HRUN)
      IF(IER.EQ.0) GO TO 504
C-- SPINNING BLOCK FOUND:   DISPLAY IT
      CALL XYBLK(IADLGN,X1,Y1,DXEB,DYEB)
      EX = .05*DXEB
      EY = .05*DYEB
      DO 1305 I = 1,4
      XLO = X1 + (I-1)*EX
      YLO = Y1 + (I-1)*EY
      XHI = X1 - (I-1)*EX + DXEB
      YHI = Y1 - (I-1)*EY + DYEB
1305  CALL RECTAN(XLO,YLO,XHI,YHI,0)
504   CONTINUE
      IF(NN.EQ.346.AND.LASTVW.EQ.13) GO TO 600
      GO TO 999
C*** *** *** DEAD BLOCKS *** *** *** *** *** *** *** *** *** *** *** ***
600   CALL LGDEAD(HEAD(17),HBLACK)
      NBLACK = HBLACK(1)
      IF(NBLACK.LE.39) GO TO 113
      WRITE(6,114) NBLACK
114   FORMAT(' *** WARNING: LGDEAD error. No. of dead blocks = ',I5)
      GO TO 999
113   IF(NBLACK.LE.0) GO TO 999
      DO 601 I = 1,NBLACK
      IPNN = HBLACK(1+I)
      CALL XYBLK(IPNN,X1,Y1,DXEB,DYEB)
      XC = X1 + .5*DXEB
      YC = Y1 + .5*DYEB
      DO 602  K = 1,3
      BLRR = (0.6-K*.1)*DXEB
      CALL PLYGON(9,BLRR,XC,YC,0)
602   CONTINUE
601   CONTINUE
      GO TO 999
C*** *** *** PULSE HEIGHT CODE * *** *** *** *** *** *** *** *** *** ***
700   WRITE(6,701)
701   FORMAT(' 0: 0-10 MeV   1: 10-20 MeV  ...  9:  90-100 MeV')
      WRITE(6,702)
702   FORMAT(' A: 100-200 MeV  ... C: 300-400 MeV  ...  E: 500-600 MeV')
      WRITE(6,703)
703   FORMAT(' G: 700-800 MeV  ... I: 900-1000 MeV')
      WRITE(6,704)
704   FORMAT(' J: 1-2 GeV  ...  L: 3-4 GeV  ... N: 5-6 GeV')
      WRITE(6,705)
705   FORMAT(' P: 7-8 GeV  ...  R: 9-10 GeV')
      WRITE(6,706)
706   FORMAT(' S: 10-20 GeV   T: > 20 GeV')
      GO TO 999
C
C  WRITE PHOTON NUMBER FOR SPINNING BLOCK, IF ANY
C
800   CONTINUE
      HRUN = HEAD(18)
      IF(HRUN.GT.99) GO TO 805
      CALL TRMOUT(80,'  No spinners in Monte Carlo ...^')
      GO TO 999
805   IPALGN=IDATA(IBLN('ALGN'))
      IPLGCL=IDATA(IBLN('LGCL'))
      IF(IPALGN.GT.0.AND.IPLGCL.GT.0) GO TO 801
      CALL TRMOUT(80,' ALGN and/or LGCL do not exist ^')
      GO TO 999
801   NCLST = IDATA(IPLGCL+7)
      IF(NCLST.EQ.0) CALL TRMOUT(80,' No clusters...^')
      IF(NCLST.EQ.0) GO TO 999
      NWPCL = IDATA(IPLGCL+25)
      JUMPCL = IDATA(IPLGCL+2)
      IP = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      DO 802  IGM = 1,NCLST
      IP = IP + NWPCL
      IF(IDATA(IP+8).NE.0) GO TO 802
      IPBL = HDATA(2*(IPLGCL+JUMPCL+IGM-1)-1)
      IPBL2 = HDATA(2*(IPLGCL+JUMPCL+IGM-1))
      IF(IPBL.NE.IPBL2) GO TO 802
      NBL = HDATA(2*(IPALGN + 3 + IPBL)-1)
      IER = 0
      CALL SPINNR(NBL,IER,HRUN)
      IF(IER.NE.0) WRITE(6,803) IGM,NBL
803   FORMAT(' ',10X,'  Cluster no. ',I3,' is a spinner, block no. ',I5)
802   CONTINUE
999   CONTINUE
      RETURN
      END

C   17/03/79 407311224  MEMBER NAME  EVPK     (JADESR)      FORTRAN
C
C  LATEST CHANGE: 17/10/79 11.05 (BANK NAME TABLE WAS CHANGED.)
C  LATEST CHANGE: 31/07/84 12.28 (BANK NAME TABLE WAS CHANGED.)
C
      SUBROUTINE EVPK
      IMPLICIT INTEGER*2 (H)
      INTEGER*2 IARR(20004),IBUFF
      INTEGER*4 BUFFL,DALEN,LUN
      COMMON/MNF/IRUN,IREC,NEV,ISTAT,IFLAG,NWPR,BUFFL,DALEN,
     C   IND,ISPEC,LUN
      COMMON/BUFFER/IBUFF(2048)
      COMMON/CDATA/LENG,ID1(2),ID(10000)
      DIMENSION HX(3200),HD(20000),HB(20)
      DIMENSION IX(1557)
      DIMENSION JD(52),JD2(52)
      REAL*8 DATE(2)
      EQUIVALENCE (ID(1),HD(1),IARR(5)),(IX(1),HX(1))
      DATA IHD/'HIDD'/,JD2(1)/0/,HSTRC/0/
C
      DIMENSION MA(129),MB1(32),MB2(32),MB3(32),MB4(32)
      EQUIVALENCE (MA(1),MB1(1)),(MA(33),MB2(1))
      EQUIVALENCE (MA(65),MB3(1)),(MA(97),MB4(1))
      DATA MB1/'HEAD','LATC','TRG1','TRG2',
     D         'TRG3','ATST','ATBP','ATOF',
     D         'ALGL','ATAG','TAGC','JETC',
     D         'MUEV','SCAL','MPRS','N50S',
     D         'BK17','BK18','ZETC','BPCH','BK21','BK22',
     D         'BK23','BK24','BK25','BK26','BK27','BK28',
     D         'BK29','BK30','BK31','BK32'/
      DATA MB2/'JETV','FADC','BK35','BK36',
     D         'BK37','BK38','BK39','BK40','BK41','BK42',
     D         'BK43','BK44','BK45','BK46','BK47','BK48',
     D         'BK49','BK50','BK51','BK52','BK53','BK54',
     D         'BK55','BK56','BK57','BK58','BK59','BK60',
     D         'BK61','BK62','BK63','BK64'/
      DATA MB3/'C065','C066','C067','C068',
     D         'C069','C070','C071','C072','C073','C074',
     D         'C075','C076','C077','C078','C079','C080',
     D         'C081','C082','C083','C084','C085','C086',
     D         'C087','C088','C089','C090','C091','C092',
     D         'C093','C094','C095','C096'/
      DATA MB4/'C097','C098','C099','C100',
     D         'C101','C102','C103','C104','C105',
     D         'C106','C107','C108','C109','C110',
     D         'C111','C112','C113','C114','C115',
     D         'C116','C117','C118','C119','C120',
     D         'C121','C122','C123','C124','C125',
     D         'C126','C127','C128'/
      DATA MA(129)/'WRNG'/
C
      DATA IX/1557*0/
      DATA NTOT,NTOLD,NBLK,NV,NS/5*0/
   14 FORMAT(' ',I5,21I6)
   18 FORMAT('0',4X,20I6)
   19 FORMAT(' ',I11,20I6)
   21 FORMAT('0',I6,' BLOCKS,  ',I6,' EVENTS')
   30 FORMAT('0','ERROR IN COUNTING, TYPE 400 , ',16I6)
   40 FORMAT('0','WRONG EVENT STRUCTURE AT RUN # ',I6,', BLOCK #',
     F I6,', EVENT # ',I6,', WITH LENG, HB2, HSTRC = ',3I6)
      N=0
      JD2(1)=0
      IX(1)=IHD
      IX(3)=0
  200 CONTINUE
      CALL EVENT
      IF(ISTAT.EQ.4) GO TO 1000
      IF(ISTAT.NE.1) GO TO 200
      LENG=(IARR(2)-3)/2
      NEV=NEV+1
C
C    PUT IN BANK NAME AND JD2(I),WHERE THE LOCATIONS OF THE LAST WORD
C    OF EACH BANK IN I*4 WORDS ARE STORED
C
      HB1=1
      HB2=2
      DO 210 I=1,50
      IF(HD(HB2-1).NE.32767) GO TO 1400
      HDHB2=HD(HB2)
      IF(HDHB2.GE.129) HDHB2=129
      IF(HDHB2.LE.0) HDHB2=129
      ID(HB1)=MA(HDHB2)
      HB2=HB2+2*HD(HB2+6)+8
      J=I+1
      HB1=HB2/2
      JD2(J)=HB1-1
      IF(JD2(J).GE.LENG) GO TO 220
  210 CONTINUE
      J=51
  220 N2=J
C
      CALL LISTRN(2)
C
      NV=NV+1
      IX(NTOT+1)=IHD
      IX(NTOT+2)=NEV
      IX(NTOT+3)=0
      NTOLD=NTOT
      NTOT=NTOT+LENG+5
      IF(NTOT.GE.1538) GO TO 300
      NTOLD1=NTOLD+5
      IX(NTOLD+4)=LENG+1
      IX(NTOLD1)=0
      IF(NS.GE.1) IX(NTOLD1)=3
      CALL UCOPY2(ID(1),IX(NTOLD1+1),LENG)
      GO TO 200
  300 CONTINUE
      IF(NTOT.GE.1558) GO TO 400
      NTOLD1=NTOLD+5
      IX(NTOLD+4)=LENG+1
      IX(NTOLD1)=0
      IF(NS.GE.1) IX(NTOLD1)=3
      CALL UCOPY2(ID(1),IX(NTOLD1+1),LENG)
      WRITE(2) NTOT,IX
      NBLK=NBLK+1
      CALL UZERO(IX,1527,1557)
      NTOT=0
      NV=0
      GO TO 200
  400 CONTINUE
      NW=0
      K7=0
      K8=0
  410 CONTINUE
      K3=0
      K4=NTOT
      CALL UCOPIV(JD2,JD,N2)
C--- SUPPOSE XX IS THE LAST COMPLETE BANK OF THE BLOCK AND YY IS THE
C--- BANK NEXT TO XX, I.E.,YY IS AN INCOMPLETE BANK,THEN K1 IS THE
C--- LOCATION OF THE LAST WORD IN BANK XX WITH RESPECTIVE TO THE
C--- BEGINNING OF THE EVENT, THE HIDD HEADER IS NOT INCLUDED IN THE
C--- COUNTING.  K2 IS THE LOCATION OF THE SAME WORD WITH RESPECT TO
C--- THE BEGINNING OF THE BLOCK, WITH THE 5 WORDS HIDD HEADER COUNTED,
C--- SO, IF THE EVENT IS INSIDE A BLOCK,THEN K1 LT K2.IF THE EVENT
C--- START FROM THE LAST BLOCK, THEN K1 GT K2
      DO 430 J=1,N2
      K1=JD(J)
      K2=K1+NTOLD-NW+5
      K3=K3+8
      K5=J
      IF(K2.GE.1548.AND.K2.LE.1557) GO TO 500
      IF(K2.LE.1547.AND.K4.GE.1558) GO TO 440
      K4=K2
  430 CONTINUE
      WRITE(6,30) NEV,NV,LENG,NS,NTOT,NTOLD,K1,K2,K3,K4,K5
      GO TO 2000
  440 CONTINUE
      JJ=1552-NTOLD-K8
      NTOLD1=NTOLD+5
      IX(NTOLD+4)=1553-NTOLD
      IX(NTOLD1)=1
      IF(NS.GE.1) IX(NTOLD1)=2
      NTOLD2=NTOLD1+K8
      CALL UCOPY2(ID(K7+1),IX(NTOLD2+1),JJ)
      K6=K2
      IF(K2.LE.5) K6=5
      IX(K6+4)=1553-K6
      NTOT1=1557
      WRITE(2) NTOT1,IX
      NBLK=NBLK+1
      CALL UZERO(IX,1527,1557)
      NS=1
C**    AN EVENT WAS SPANNED, SO NS=1
      NTOT1=NTOT-1557
      NTOT=NTOT1+9
      IX(1)=IHD
      IX(2)=NEV
      IX(3)=0
      IX(6)=ID(K1+1)
      IX(7)=ID(K1+2)
      IX(8)=ID(K1+3)
      IX(9)=ID(K1+4)+K2-1553
      NV=1
      IF(NTOT.GE.1558) GO TO 490
      IF(NTOT.GE.1538) GO TO 480
      CALL UCOPY2(ID(JJ+K7+1),IX(10),NTOT1)
      IX(4)=NTOT-4
      IX(5)=3
      NS=0
C**    END OF SPANNING
C**    WE PUT IN ONE MORE BANK HEADER AT THE NEW BLOCK
C**    IN ADDITION TO THE HIDD HEADER
      GO TO 200
  480 CONTINUE
      IX(4)=NTOT-4
      IX(5)=3
      CALL UCOPY2(ID(JJ+K7+1),IX(10),NTOT1)
      WRITE(2) NTOT,IX
      NBLK=NBLK+1
      CALL UZERO(IX,1527,1557)
      NTOT=0
      NS=0
      GO TO 200
  490 CONTINUE
      NW=NW+1557-NTOLD-9
      K7=K7+JJ
      K8=4
      NTOLD=0
      GO TO 410
  500 CONTINUE
      NTOLD1=NTOLD+5
      NTOLD4=NTOLD+4
      IX(NTOLD4)=K1+1
      IX(NTOLD1)=1
      IF(NS.GE.1) IX(NTOLD1)=2
      NTOLD2=NTOLD1+K8
      K9=K1-K7
      IF(NS.GE.1) IX(NTOLD4)=K9+K8+1
      CALL UCOPY2(ID(K7+1),IX(NTOLD2+1),K9)
      WRITE(2) K2,IX
      NBLK=NBLK+1
      CALL UZERO(IX,1527,1557)
      NS=1
C**    AN EVENT WAS SPANNED, SO NS=1
      NTOT1=NTOT-K2
      NTOT=NTOT1+5
      NV=1
      IX(1)=IHD
      IX(2)=NEV
      IX(3)=0
      IF(NTOT.GE.1558) GO TO 580
      IF(NTOT.GE.1538) GO TO 560
      CALL UCOPY2(ID(K1+1),IX(6),NTOT1)
      IX(4)=NTOT-4
      IX(5)=3
      NS=0
      GO TO 200
  560 CONTINUE
      IX(4)=NTOT-4
      IX(5)=3
      CALL UCOPY2(ID(K1+1),IX(6),NTOT1)
      WRITE(2) NTOT,IX
      NS=0
      NTOT=0
      NBLK=NBLK+1
      CALL UZERO(IX,1527,1557)
      GO TO 200
  580 CONTINUE
      NW=NW+K2-NTOLD-5
      NTOLD=0
      K7=K7+K1
      K8=0
      GO TO 410
 1000 IF(NTOT.EQ.0) GO TO 1300
      NT1=NTOT+1
      IF(NT1.GE.1558) GO TO 1100
      CALL UZERO(IX,NT1,1557)
 1100 CONTINUE
      WRITE(2) NTOT,IX
      NBLK=NBLK+1
      WRITE(6,21) NBLK,NEV
C     WRITE(6,18) HB
C     WRITE(6,18)
C     IJK=NTOT/10+1
C     DO 1200 J=1,IJK
C     IJ=20*J
C     IK=IJ-19
C1200 WRITE(6,14) IK,(HX(K),K=IK,IJ),IJ
C     IF(NTOT.GE.1551) WRITE(6,19) (HX(K),K=3101,3114)
      NTOT=0
 1300 NS=0
      RETURN
C--- WRONG EVENT STRUCTURE
 1400 HSTRC=HSTRC+1
      WRITE(6,40) IBUFF(5),IBUFF(3),NEV,LENG,HB2,HSTRC
      GO TO 200
 2000 RETURN
      END

C---------------START OF MACRO CUNIT (LOGICAL UNIT NUMBERS)-------------
C
      COMMON /CUNIT/LUNMUC,LUNMUE
C
C LUNMUC  LOGICAL UNIT FOR MU CALIBRATION DATA.
C LUNMUE  LOGICAL UNIT FOR MU CALIBRATION DATA EDIT FILE.
C
C---------------END OF MACRO CUNIT--------------------------------------

C   20/11/84            MEMBER NAME  PRTPVX   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE  PRTPVX( IBANK, JUNIT )
C-----------------------------------------------------------------------
C
C   AUTHOR:    C. BOWDERY    20/11/84 : PRINTS OUT TPVX BANK 'IBANK'
C
C LAST MOD:    C. BOWDERY     2/10/86 : UNIT NUMBER IS A PARAMETER
C
C
C      INPUT:     JUNIT  = LOGICAL UNIT NUMBER FOR OUTPUT
C                 IBANK  = NUMBER OF TPVX BANK TO BE PRINTED.
C                          IF IBANK = 0, IT PRINTS ALL TPVX BANKS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2  (H)
C
#include "cdata.for"
C
      INTEGER  IARR(100)
C
C------------------  C O D E  ------------------------------------------
C
      IUNIT = JUNIT
      IF( JUNIT .LT. 1  .OR.  JUNIT .GT. 99 ) IUNIT = 6
C
C                            IBANK = 0  MEANS PRINT ALL BANKS
C
      IF( IBANK .GT. 0 ) GO TO 4
        CALL BDAR( 'TPVX', NBKS, IARR, 100 )
        IF( NBKS .GT. 0 ) GO TO 2
C
          WRITE(IUNIT,1)
   1      FORMAT(/' ***  NO TPVX BANKS EXIST TO BE PRINTED '/)
          RETURN
C
   2    IBK = 1
        ITPVXN = IARR( IBK )
        WRITE(IUNIT,3) NBKS
   3    FORMAT(//' ***  ',I3,' TPVX  BANKS FOLLOW:'//)
        GO TO 8
C
C                            IBANK > 0 MEANS PRINT TPVX/IBANK
C
   4  IBK = IBANK
      CALL CLOC( ITPVXN, 'TPVX', IBK )
C
      IF( ITPVXN .GT. 0 ) GO TO 6
        WRITE(IUNIT,5) IBK
   5    FORMAT(/' ***  WARNING  ***  PRTPVX FOUND NO TPVX/',I2,' BANK'/)
        RETURN
C
   6  WRITE(IUNIT,7) IBK
   7  FORMAT(//' ***  TPVX  BANK ',I3,' FOLLOWS:'//)
C
C                           PRINT A TPVX BANK
C
   8  ITPVX2 = ITPVXN * 2
C
      NUMBK  = IDATA( ITPVXN -  2 )
      LENGTH = IDATA( ITPVXN      )
C
      ITRKN  = HDATA( ITPVX2 +  1 )
      IFLAG  = HDATA( ITPVX2 +  2 )
C
      XVTX   = ADATA( ITPVXN +  2 )
      YVTX   = ADATA( ITPVXN +  3 )
      ZVTX   = ADATA( ITPVXN +  4 )
      SXVTX  = ADATA( ITPVXN +  5 )
      SYVTX  = ADATA( ITPVXN +  6 )
      SZVTX  = ADATA( ITPVXN +  7 )
      CHISQ  = ADATA( ITPVXN +  8 )
C                                           2 POSSIBLE INTERPRETATIONS
      IDOF   = IDATA( ITPVXN +  9 )
      ADOF   = ADATA( ITPVXN +  9 )
C
      COST   = ADATA( ITPVXN + 10 )
C
      ICHARG = HDATA( ITPVX2 + 21 )
      NSEC   = HDATA( ITPVX2 + 22 )
      NPTRK  = HDATA( ITPVX2 + 23 )
      NMTRK  = HDATA( ITPVX2 + 24 )
      NNTRK  = HDATA( ITPVX2 + 25 )
      NATRK  = HDATA( ITPVX2 + 26 )
      NGAMS  = HDATA( ITPVX2 + 27 )
      NEP    = HDATA( ITPVX2 + 28 )
      NMU    = HDATA( ITPVX2 + 29 )
      NHADRN = HDATA( ITPVX2 + 30 )
C
      K1 = ITPVX2 + 31
      K2 = ITPVX2 + 30 + NSEC
C
      MODE = MOD( IFLAG, 10 )
C
      IF( MODE .EQ. 2  .OR.  MODE .EQ. 3 ) GO TO 20
        WRITE(IUNIT,15) NUMBK, LENGTH, ITRKN, IFLAG,
     +                  XVTX,  YVTX,  ZVTX,
     +                  SXVTX, SYVTX, SZVTX, CHISQ, IDOF,
     +                  COST,  ICHARG,NSEC,  NPTRK, NMTRK,
     +                  NNTRK, NATRK, NGAMS, NEP,   NMU,
     +                  NHADRN, ( HDATA(K),K=K1,K2)
  15    FORMAT(1X,I2,2X,I2,2X,I2,I4,7F8.2,I8,F8.4,I3,9I3,10(4I3/117X))
        GO TO 30
C
C                           ADOF   INSTEAD OF IDOF
C
  20    WRITE(IUNIT,25) NUMBK, LENGTH, ITRKN, IFLAG,
     +                  XVTX,  YVTX,  ZVTX,
     +                  SXVTX, SYVTX, SZVTX, CHISQ, ADOF,
     +                  COST,  ICHARG,NSEC,  NPTRK, NMTRK,
     +                  NNTRK, NATRK, NGAMS, NEP,   NMU,
     +                  NHADRN, ( HDATA(K),K=K1,K2)
  25    FORMAT(1X,I2,2X,I2,2X,I2,I4,7F8.2,F8.2,F8.4,I3,9I3,10(4I3/117X))
C
  30  IF( IBANK .GT.    0 ) RETURN
      IF( IBK   .GE. NBKS ) RETURN
      IBK = IBK + 1
      ITPVXN = IARR( IBK )
      GO TO 8
C
      END

C   01/11/84 504171354  MEMBER NAME  RZHITS   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RZHITS(IPZETC,XZ,YZ,XZ1,YZ1,XZ2,YZ2,ZZ1,ZZ2,IERR)
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  CALCULATE COORDINATES OF
C                                        FOR RZ CHAMBERS
C
C       MOD:   J. HAGEMANN   09/10/84 :  NOW OWN MEMBER (FROM EVDISP)
C  LAST MOD:   C. BOWDERY    17/04/85 :  COMMENT OUT ERROR PRINTOUT
C
C        IPZETC POINTS TO WORD BEFORE THE  QUADRUPLE OF HALFWORDS IN BCS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL TBIT
C
#include "cdata.for"
#include "cgraph.for"
C
      COMMON /CZGEO/ RZCHI,RZCHA,NZRPSI,NZZ,Z1ZCH,Z2ZCH,ZCHA,ZCHB,ZCHSS,
     $               ZCHDL,ZCHDLL,DLZZ,DLZPHI,DLZW1,DLZW2
      COMMON /CZKON/ ZCVDR,ZCXCH,ZCTZER,ZCAPED,XL1,XL2
C
      COMMON /CJTRIG/ PI,TWOPI,PIHALF,PI3HAF
C
      DATA ICAL /0/,RESOL/40./
C
C-----------------  C O D E  -------------------------------------------
C
      IERR = 0
      ICAL = ICAL + 1
      IF(ICAL.NE.1) GO TO 2
      FI24 = PI/12.
      FI48 = FI24*.5
      COS48 = COS(FI48)
      SIN48 = SIN(FI48)
      RINRZ = RZCHI/COS48
      RUTRZ = RZCHA/COS48
2     HPZC = 2*IPZETC
      IWIR = HDATA(HPZC+1)
      IWIR = ISHFTR(IWIR,3)
      IF(IWIR.GE.0.AND.IWIR.LE.63) GO TO 1
      WRITE(6,6248) IWIR,(HDATA(HPZC+I),I=1,4)
6248  FORMAT(' WRONG WIRE NR RZ CHAMBERS: ',I10,3X,4I8)
333   XZ = 0.
      YZ = 0.
      ZZ1 = 0.
      ZZ2 = 0.
      IERR = 1
      RETURN
1     IA1 = HDATA(HPZC+2)
      IA2 = HDATA(HPZC+3)
      IT = HDATA(HPZC+4)
      KWIR = IWIR
      IF(IWIR.GT.31) KWIR = KWIR - 32
      ZW = Z1ZCH + DLZZ*.5 +(KWIR/2)*DLZZ
      DELZ = FLOAT(IT)*ZCVDR
      ZZ1 = ZW - DELZ
      ZZ2 = ZW + DELZ
      IASUM = IA1 + IA2
      IF(IASUM.GT.0) GO TO 6251
C     WRITE(6,6249) IWIR,(HDATA(HPZC+I),I=1,4)
6249  FORMAT(' SUM OF AMPLITUDES <=0: ',I10,3X,4I8)
      GO TO 333
6251  XLXL = XL1
      DLZWW = DLZW1
      RWIR = RINRZ+ZCHA
      IF(.NOT.TBIT(IWIR,31)) GO TO 222
      XLXL = XL2
      DLZWW = DLZW2
      RWIR = RINRZ+ZCHB
222   CONTINUE
      XL1ML2 = .5*XLXL*FLOAT(IA2-IA1)/(FLOAT(IASUM)*ZCXCH)
      IF(IWIR.GT.31) XL1ML2 = - XL1ML2
C      IF((ICAL/10)*10.EQ.ICAL) WRITE(6,6665) XLXL,DLZWW,ZZ1,ZZ2,XL1ML2
C      IF(ICAL.LT.2) WRITE(6,6665) XLXL,DLZWW,ZZ1,ZZ2,XL1ML2
C
C        L1           I                   L2
C A1------------------I------------------------------------------A2
C                     I
C
C    -X SIDE HAS OPPOSITE ARRANGEMENT
C
C   WIRES RUN FROM -Z TO +Z    0-31  ON +X SIDE     32-63 ON -X SIDE
C
C
C
      IRFI = ABS(XL1ML2/DLZWW)
      IF(XL1ML2.LT.0.) IRFI = - IRFI
      IF(IABS(IRFI).LT.6) GO TO 7611
      WRITE(6,7612) IRFI
7612  FORMAT(' ERROR RFI COORD OUTSIDE CHAMBER, IRFI:',I6)
      WRITE(6,6247) IWIR,(HDATA(HPZC+I),I=1,4)
6247  FORMAT(' WIRE NR, HIT DATA ',I5,2X,4I6)
      WRITE(6,6665) XLXL,DLZWW,ZZ1,ZZ2,XL1ML2
6665  FORMAT(' XLXL DLZWW ZZ1 2 L1-L2 ',5E12.4)
      GO TO 333
7611  XLLX = FLOAT(IRFI)*DLZWW
      REST = XL1ML2 - XLLX
      PHIZ = IRFI*FI24
      FACTW = 1.
      IF(REST.LT.0) FACTW = -1.
      IF(IWIR.GT.31) PHIZ = PI - PHIZ
      IF(IWIR.GT.31) FACTW = -FACTW
      COSPH = COS(PHIZ)
      SINPH = SIN(PHIZ)
      XWIR = RWIR*COSPH
      YWIR = RWIR*SINPH
      EX = - SINPH*SIN48 + FACTW*COSPH*COS48
      EY = - COSPH*SIN48 - FACTW*SINPH*COS48
      AREST = ABS(REST)
      AAA = AREST*EX
      BBB = AREST*EY
      XZ = XWIR+BBB
      YZ = YWIR+AAA
      AREST1 = AREST - RESOL
      AAA1 = AREST1*EX
      BBB1 = AREST1*EY
      XZ1 = XWIR+BBB1
      YZ1 = YWIR+AAA1
      AREST2 = AREST + RESOL
      AAA2 = AREST2*EX
      BBB2 = AREST2*EY
      XZ2 = XWIR+BBB2
      YZ2 = YWIR+AAA2
C     IF(LASTVW.LT.3) CALL DRAMOV(-XWIR,YWIR,-XZ,YZ,0)
C     IF(ICAL.LT.2) WRITE(6,6667) IRFI,FACTW,REST,XWIR,YWIR,AAA
C     IF((ICAL/10)*10.EQ.ICAL)
C    $ WRITE(6,6667) IRFI,FACTW,REST,XWIR,YWIR,AAA
C6667  FORMAT(' IRI FW REST XYWR AAA ',I3,F4.0,4E12.4)
C      IF(ICAL.LT.2) WRITE(6,6668) EX,EY,BBB,XZ,YZ
C6668  FORMAT(' EXY BBB XYZ ',5E12.4)
      RETURN
      END

C   28/07/87 708112125  MEMBER NAME  TPRPHI   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPRPHI
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      28/07/87:  Do inner det. R-Phi refit
C
C
C     Routine to do R-Phi refit of inner detector tracks  (optional)
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  REFITR

C                            Mode is refitting mode (See JCN 94)

      INTEGER  MODE

#include "bosdata.for"

C------------------  C O D E  ------------------------------------------

C                            Get instruction about refitting

      CALL TPRFI1( REFITR, MODE )

C                            If R-Phi refit wanted, do it.

      IF( REFITR ) THEN

        IPATR = IDATA( IBLN( 'PATR' ) )
        CALL EXPATR( IPATR, 64, IER )

        CALL XYRFTV( MODE )

        CALL TPDIAG(10)

      ENDIF

      RETURN

      END

C   27/08/87 708271321  MEMBER NAME  IRNEVT   (S)           FORTRAN77
      FUNCTION IRNEVT( DUMMY )
C-----------------------------------------------------------
C  Version of 27/08/87      Last mod 27/08/87  E Elsen
C  Provide run and event number in one I*4 word.
C  If no HEAD bank is there ZE4V is tried.
C-----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1), HELP(2)
      EQUIVALENCE (HW(1),IW(1)),(HELP(1), IHELP)
      LOGICAL FIRST / .TRUE. /
C
      IF( FIRST ) THEN
        FIRST = .FALSE.
        IPHEAD = IBLN('HEAD')
        IPZE4V = IBLN('ZE4V')
      ENDIF
C
      NPHEAD = IW(IPHEAD)
      IF( NPHEAD .GT. 0 ) THEN
        IRUN = HW( NPHEAD*2+10)
        IEVT = HW( NPHEAD*2+11)
        HELP(1) = IRUN
        HELP(2) = IEVT
        IRNEVT = IHELP
      ELSE
        NPZE4V = IW(IPZE4V)
        IF( NPZE4V.GT.0 ) THEN
          IRNEVT = IW(NPZE4V+7)
        ELSE
          IRNEVT = 0
        ENDIF
      ENDIF
      END

      SUBROUTINE AKOP( P, NP, NMAXP, A, AXIS, ITMERR )
      DIMENSION P(1), AXIS(3)
      DIMENSION PIN(320), IPERM(200),IPS(320),PS(320)
      COMMON / CWORK / WORK(840)
      EQUIVALENCE (WORK(1),PIN(1)),(WORK(321),IPERM(1))
      EQUIVALENCE (WORK(521),PS(1),IPS(1))
      DATA IPINC / 4 /
      DATA NLIMIT / 20 /
      DATA NSEC / 2 /
      DATA IER0 / 0/, IER1 /0/, IER2 /0/
      ITMERR = 0
      AXIS(1) = 1.
      AXIS(2) = 1.
      AXIS(3) = 1.
      A = 1000.
      IF(
     - NP .LE. 0
     -)THEN
      IF(
     - IER0 .LT. 10
     -)THEN
      WRITE(6,9103)
 9103 FORMAT(' +++ ERROR IN AKOP.  CALLED WITH ZERO PARTICLES +++')
      ENDIF
      IER0 = IER0 + 1
      RETURN
      ENDIF
      NMAXP1 = NMAXP
      IF(
     -  NP.GE.NLIMIT .AND. ( NMAXP.EQ.0 .OR. NMAXP.GT.NLIMIT )
     -)THEN
      IF(
     - IER1 .LT. 10
     -)THEN
      WRITE(6,9101) NP,NLIMIT,NMAXP
 9101 FORMAT(' +++++  WARNING FROM AKOP ROUTINE  +++++'/
     *       2X,I4,' ARE TOO MANY INPUT VECTORS. INTERNAL LIMIT=',I4,
     *' INPUT CUTOFF NMAXP=',I4,'. ONLY NLIMIT PARTICLES ARE PERMUTED')
      NMAXP1 = NLIMIT
      ENDIF
      IER1 = IER1 + 1
      ENDIF
      NTOT = NP
      CALL BALANC( P, NTOT, PSUM )
      IF(
     - PSUM .LT. 1.E-6
     -)THEN
      IF(
     - IER2 .LT. 10
     -)THEN
      WRITE(6,9104)
 9104 FORMAT(' +++ ERROR IN AKOP. MOMENTUM SUM AFTER BALANCE=0. +++')
      ENDIF
      IER2 = IER2 + 1
      RETURN
      ENDIF
      IF(
     - NTOT.GT.NMAXP1 .AND. NMAXP1.NE. 0
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      NP1 = NTOT
      NTOT = NMAXP1 - 1
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      CALL BALANC( PIN, NTOT, PSUM1 )
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      ELSE
      CALL UCOPY( P, PIN, NTOT*4 )
      ASSIGN 17008 TO IZZZ03
      GOTO 17004
17008 CONTINUE
      ENDIF
      RETURN
17000 CONTINUE
      DO 13000 J=1,NTOT
      IPERM(J) = J*4
13000 CONTINUE
13001 CONTINUE
      M = NTOT / 2
15000 CONTINUE
      IF(
     -  M.GT.0
     -)THEN
      K = NTOT - M
      DO 13002 J=1,K
      I = J
15002 CONTINUE
      IF(
     -  I.GT.0
     -)THEN
      ILOW = IPERM(I)
      IHIGH = IPERM(I+M)
      IF(
     -  P(IHIGH) .GT. P(ILOW)
     -)THEN
      IPERM(I) = IHIGH
      IPERM(I+M) = ILOW
      I = I - M
      ELSE
      GOTO 15003
      ENDIF
      GOTO 15002
      ENDIF
15003 CONTINUE
13002 CONTINUE
13003 CONTINUE
      M = M/2
      GOTO 15000
      ENDIF
15001 CONTINUE
      GOTO IZZZ01
17002 CONTINUE
      DO 13004 J=1,NTOT
      IPJ = IPERM(J)
      J4 = J*4
      PIN(J4  ) = P(IPJ  )
      PIN(J4-1) = P(IPJ-1)
      PIN(J4-2) = P(IPJ-2)
      PIN(J4-3) = P(IPJ-3)
13004 CONTINUE
13005 CONTINUE
      GOTO IZZZ02
17004 CONTINUE
      IF(
     - A .NE. 0.
     -)THEN
      K1 = NTOT-1
      DO 13006 INDI=1,K1
      K2 = INDI+1
      DO 13008 INDJ=K2,NTOT
      INDI4 = INDI * 4
      P11 = PIN(INDI4-3)
      P12 = PIN(INDI4-2)
      P13 = PIN(INDI4-1)
      INDJ4 = INDJ * 4
      P21 = PIN(INDJ4-3)
      P22 = PIN(INDJ4-2)
      P23 = PIN(INDJ4-1)
      PIJ1 = P12 * P23 - P13 * P22
      PIJ2 = P13 * P21 - P11 * P23
      PIJ3 = P11 * P22 - P12 * P21
      PIJ4 = SQRT(PIJ1*PIJ1 + PIJ2*PIJ2 + PIJ3*PIJ3)
      AIJ = 0.
      IF(
     - PIJ4 .GT. 1.E-5
     -)THEN
      DO 13010 INDK=1,NTOT
      INDK4 = INDK * 4
      AIJ = AIJ + ABS(PIJ1 * PIN(INDK4-3) + PIJ2 * PIN(INDK4-2)
     *              + PIJ3 * PIN(INDK4-1))
13010 CONTINUE
13011 CONTINUE
      AIJ = AIJ/PIJ4
      IF(
     - AIJ .LT. A
     -)THEN
      AXIS(1) = PIJ1/PIJ4
      AXIS(2) = PIJ2/PIJ4
      AXIS(3) = PIJ3/PIJ4
      A = AIJ
      ENDIF
      ELSE
      IF(
     - NTOT .LE. 4
     -)THEN
      AXIS(1) = 0.
      AXIS(2) = 0.
      AXIS(3) = 0.
      A = 0.
      ENDIF
      ENDIF
13008 CONTINUE
13009 CONTINUE
13006 CONTINUE
13007 CONTINUE
      A = 4. * ((A / PSUM)**2)
      ENDIF
      GOTO IZZZ03
17006 CONTINUE
      NIPINC = NP1*IPINC
      AA = 0.
      DO 13012 J=1,NIPINC,IPINC
      AA = AA + ABS( AXIS(1)*P(J)+AXIS(2)*P(J+1)+AXIS(3)*P(J+2) )
13012 CONTINUE
13013 CONTINUE
      A = 4. * ((AA / PSUM)**2)
      GOTO IZZZ04
      END
      SUBROUTINE BALANC( P, NTOT, PSUM )
      DIMENSION P(1)
      PSUM1 = 0.
      PSUM2 = 0.
      PSUM3 = 0.
      PSUM  = 0.
      N4 = NTOT*4
      DO 13000 J=1,N4,4
      PSUM1 = P(J  ) + PSUM1
      PSUM2 = P(J+1) + PSUM2
      PSUM3 = P(J+2) + PSUM3
      PSUM  = P(J+3) + PSUM
13000 CONTINUE
13001 CONTINUE
      PTOT = SQRT( PSUM1*PSUM1 + PSUM2*PSUM2 + PSUM3*PSUM3 )
      IF(
     -  PTOT .GT. .01
     -)THEN
      P(N4+1) = -PSUM1
      P(N4+2) = -PSUM2
      P(N4+3) = -PSUM3
      P(N4+4) = PTOT
      PSUM = PSUM + PTOT
      NTOT = NTOT + 1
      ENDIF
      RETURN
      END

C   12/03/84 403121301  MEMBER NAME  FHTOS    (S)           FORTRAN
C   24/07/83 403121234  MEMBER NAME  AFTP83   (S)           FORTRAN
C   03/05/83 307051220  MEMBER NAME  RALFUNC  (S)           FORTRAN
C   03/05/83            MEMBER NAME  RALFUNC  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE FHTOS(ISAD,IHAD,*)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE CONVERTS HARDWARE ADDRESSES TO SOFTWARE ADDRESSES
C
C ISAD - OUTPUT - SOFTWARE ADDRESS
C IHAD - INPUT  - HARDWARE ADDRESS
C
C RETURN 1 IF IT CANT DO IT ( ILLEGAL ADDRESS SUPPLIED )
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "cwktag.for"
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  CONVERT HARWARE ADDRESSES TO SOFTWARE ADDRESSES
C
C   THE PATTERN FOR 1983 ONWARDS IS -
C
C   HARDWARE ADDRESS                              SOFTWARE ADDRESS
C
C        0 - 3             NOT USED
C        4 - 7           INNER RING - Z               1 - 4
C        8 - 11            "      "                   5 - 8
C       12 - 15            NOT USED
C       16 - 19             "   "
C       20 - 23           MIDDLE RING - Z             9- 12
C       24 - 27              "  "                     13-16
C       28 - 31            NOT USED
C       32 - 35             "   '
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C == CODE ===
C
      IF(MARK.LT.2)GOTO 100
C
C HERE FOR 1983 ONWARDS TAGGER
C
      K=0
      DO 10 I = 1,6
       ISTART=(I*16)-12
       IEND=ISTART+7
        DO 20 J=ISTART,IEND
         K=K+1
        IF(IHAD.NE.J) GOTO20
        ISAD=K
        RETURN
 20    CONTINUE
 10   CONTINUE
      RETURN    1
C
C HERE FOR 1981/2 TAGGER
C
C THE PATTERN IS MUCH SIMPLER !
C
 100  ISAD=IHAD+1
      RETURN
      END

C   09/12/87 807261208  MEMBER NAME  TPTHRU   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTHRU( NP, P )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       9/12/87:  Do thrust calculation.
C
C          mod: C. Bowdery      31/01/88:  CALL TPEVI2 etc
C     Last mod: C. Bowdery      26/07/88:  Change to TPTPUT call
C
C     Routine to coordinate thrust calculation and storing of results
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     NP        In       I*4      No. of particles in P array
C     P         In       R*4      Momentum array
C                                   P(1,i) = px   of particle i
C                                   P(2,i) = py   of particle i
C                                   P(3,i) = pz   of particle i
C                                   P(4,i) = ptot of particle i
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      INTEGER  NP, NMAXP, ITMERR
      REAL     P(4,200)
      REAL     T, AXIS(3)

      LOGICAL  WANTED

C------------------  C O D E  ------------------------------------------

C                            Compute thrust and thrust axis if wanted

      CALL TPEVI2( WANTED )

      IF( WANTED  .AND.  NP .GT. 0 ) THEN

C                           Calc. limited to 15 most energetic particles

        NMAXP = 15
        CALL THRUST( P, NP, NMAXP, T, AXIS, ITMERR )

C                            Store thrust and thrust axis

        CALL TPTPUT( NP, NMAXP, T, AXIS )

      ENDIF

      RETURN
      END

C   26/07/87 901181602  MEMBER NAME  TPTPEV   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTPEV
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      26/07/87:  Create bank TPEV/1
C
C     Last mod: C. Bowdery      30/09/88:  Set error flags
C
C     Routine to create and initialise the event summary bank TPEV/1
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      INTEGER  LTPEV, ITPEV, IJETC, IATOF, IALGL, IALGN, IMUEV, IATAG

C                            Define length of the TPEV/1 bank

      PARAMETER  ( LTPEV = 60 )

C------------------  C O D E  ------------------------------------------

C                            Create the TPEV/1 bank

      CALL CCRE( ITPEV, 'TPEV', 1, LTPEV, IER)

      IF( IER .EQ. 0 ) THEN

C                            Version number = 916 = v9.1.6

        IDATA( ITPEV + 1 ) = 916

C                            Today's date and time

        IDATA( ITPEV + 2 ) = IDATTM( 0 )

C                            Set 'no raw data' error flags for
C                            inner detector, TOF counters, LG
C                            muon filter and tagging system.

        IJETC = IDATA( IBLN( 'JETC' ) )
        IF( IJETC .LE. 0 )               HDATA( 2*ITPEV + 111 ) = 10000

        CALL CLOC( IATOF, 'ATOF', 0 )
        IF( IATOF .LE. 0 )               HDATA( 2*ITPEV + 113 ) = 10000

        IALGL = IDATA( IBLN( 'ALGL' ) )
        CALL CLOC( IALGN, 'ALGN', 1 )
        IF( IALGL .LE. 0  .AND.
     +      IALGN .LE. 0        )        HDATA( 2*ITPEV + 115 ) = 10000

        IMUEV = IDATA( IBLN( 'MUEV' ) )
        IF( IMUEV .LE. 0 )               HDATA( 2*ITPEV + 116 ) = 10000

        CALL CLOC( IATAG, 'ATAG', 0 )
        IF( IATAG .LE. 0 )               HDATA( 2*ITPEV + 117 ) = 10000

      ELSE

        CALL TPERRH

      ENDIF

      RETURN
      END

C   05/11/82 401161419  MEMBER NAME  THDEDX   (S)           FORTRAN
      FUNCTION THDEDX (BETA,GAMMA,DEMIN)
C ---------------------------------------------------------------------
C
C        CALCULATE THEORETICAL VALUE FOR DEDX
C
C        STERNHEIMER PREDICTION FOR DEDX AS FUNCTION OF BETA, GAMMA
C        RERISE ADJUSTED TO OBSERVATION
C        HIGH DE/DX ADJUSTED TO OBSEVATION (CADEDX)
C        PARAMETERS IN DATA STATEMENT CALCULATED IN PROGRAM 'VAVRA'
C
C        INPUT : BETA, GAMMA
C                DEMIN = EXPERIMENTAL VALUE FOR DE/DX IN MINIMUM
C
C        OUTPUT: THDEDX = DE/DX  AT GIVEN VALUE OF BETA,GAMMA
C
C                 A. WAGNER  15.8.1983
C        CHANGED: K. AMBRUS  15.1.1984
C ---------------------------------------------------------------------
C
C     ALFAT  = ALFA*T
C     XMEANI = MEAN IONISATION POTENTIAL
C     RSTERN = STERNHEIMER FERMIPLATEAU
C     REXP   = EXPERIMENTAL FERMIPLATEAU
C     AI0    = VALUE OF DEDX(THEOR) IN MINIMUM
C
C                            CONSTANTS FOR ARGON - CH4 - I C4H10
C                                          .887   .085    .028
C                            JADE PARAMETERS
C
      DATA ALFAT /0.4798E-3/, XMEANI /0.1730E-3/
      DATA XA /2.2480/, X0 /1.6990/, X1 /3.6990/
      DATA RSTERN /1.540/, REXP / 1.425 /, AI0 /6.001E-3/
      DATA XMEL /0.5110034/
      DEMIN = 10. / REXP
      CREXP = REXP*0.995927
      RCORR =(CREXP-1.) / (RSTERN-1.)
C
      BETAG=BETA*GAMMA
      BB=BETA*BETA
      X=XMEL*ALFAT/(XMEANI*XMEANI)
      X=ALOG(X)+0.891+2.*ALOG(BETAG)-ALOG(BB)-BB
      X=X-DENS(XA,X0,X1,BETAG)
      RDEDX=(ALFAT*X/BB) / AI0
      IF (BETAG.GT.4.) RDEDX = (RDEDX-1.)*RCORR+1.
      THDEDX = DEMIN * RDEDX
      THDEDX = THDEDX*CADEDX(THDEDX,DEMIN)
      RETURN
      END
C ----------------------------------------------------------------------
      FUNCTION DENS (XA,X0,X1,BETAG)
      X=ALOG10(BETAG)
      DENS=0.
      IF (X.LT.X0) RETURN
      IF (X.GE.X0.AND.X.LE.X1) GO TO 1000
      DENS=4.606*(X-XA)
      RETURN
 1000 CONTINUE
      AA=4.606*(XA-X0)
      AA=AA/(X1-X0)**3.
      DENS=4.606*(X-XA)+AA*(X1-X)**3.
      RETURN
      END
C ----------------------------------------------------------------------
      FUNCTION CADEDX(DEDXTH,DEMIN)
      DATA P1/16.7581/, P2/1.20645/, P3/-0.301784/
      IF(DEDXTH.LE.DEMIN) GO TO 100
      ZZ = (DEDXTH-DEMIN)/P1
      IF(ZZ.GT.50.) ZZ = 50.
C
      CADEDX = EXP(-P2*ZZ) + ZZ
      CADEDX = CADEDX**P3
      RETURN
C
 100  CONTINUE
      CADEDX = 1.
      RETURN
      END

      SUBROUTINE TRHTCK(IPPATR,IPJHTL)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "ccycp.for"
#include "cjdrch.for"
#include "cworkpr.for"
#include "cworkeq.for"
      DIMENSION NCNT1(127),NCNT2(127)
      NTR1   = IDATA(IPPATR+ 2)
      IF(NTR1.LE.0) RETURN
      LPATR = IDATA(IPPATR)
      IPHL0 = IPJHTL*2 + 3
      ILDHL = IDATA(IPJHTL)*2 - 2
      IPHL9 = ILDHL + IPHL0 - 1
      I0 = IPHL0
      I9 = IPHL9
      I1 = IDATA(IBLN('PATR'))
      I2 = IDATA(IBLN('JHTL'))
      CALL SETSL(NCNT1(1),0,1016,0)
      DO 13000 I=IPHL0,IPHL9,2
        IZW1  = HDATA(I  )
        ITRK1 = LAND(ISHFTR(IZW1,1),127)
      IF(
     - ITRK1.GT.0
     -)THEN
          IZW2  = HDATA(I+1)
          ITRK2 = LAND(ISHFTR(IZW2,1),127)
      IF(
     - ITRK2.LE.0
     -)THEN
            NCNT1(ITRK1) = NCNT1(ITRK1) + 1
      ELSE
            NCNT2(ITRK1) = NCNT2(ITRK1) + 1
            NCNT2(ITRK2) = NCNT2(ITRK2) + 1
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      MTR = 0
      IPTR9 = IDATA(IPPATR) + IPPATR
      DO 13002 ITR=1,NTR1
      IF(
     - NCNT1(ITR).LT.5 .OR. NCNT1(ITR)+NCNT2(ITR).LT.8
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
          NCNT1(ITR) =-NCNT1(ITR)
      ELSE
          MTR = MTR + 1
      ENDIF
13002 CONTINUE
13003 CONTINUE
      IDATA(IPPATR+2) = MTR
      LENG  = IDATA(IPPATR+2)*IDATA(IPPATR+3) + IDATA(IPPATR+1)
      NDIFF = LENG - IDATA(IPPATR)
      IF(NDIFF.NE.0) CALL BCHM(IPPATR,NDIFF,IRET)
      RETURN
17000 CONTINUE
        JTR = MTR + 1
        ITRDIF = ITR - JTR
      IF(
     - NCNT1(ITR).NE.0 .OR. NCNT2(ITR).NE.0
     -)THEN
      DO 13004 I=IPHL0,IPHL9,2
            IZW1  = HDATA(I  )
            ITRK1 = LAND(ISHFTR(IZW1,1),127)
            IZW2  = HDATA(I+1)
            ITRK2 = LAND(ISHFTR(IZW2,1),127)
      IF(
     - ITRK2.EQ.JTR
     -)THEN
              HDATA(I+1) = 0
              ITRK2 = 0
              IND1  = ITRK1 + ITRDIF
              NCNT1(IND1) = NCNT1(IND1) + 1
              NCNT2(IND1) = NCNT2(IND1) - 1
      ENDIF
      IF(
     - ITRK1.EQ.JTR
     -)THEN
              HDATA(I ) = HDATA(I+1)
              HDATA(I+1) = 0
              ITRK1 = ITRK2
              ITRK2 = 0
      IF(
     - ITRK1.GT.0
     -)THEN
                IND1  = ITRK1 + ITRDIF
                NCNT1(IND1) = NCNT1(IND1) + 1
                NCNT2(IND1) = NCNT2(IND1) - 1
      ENDIF
      ENDIF
            IF(ITRK1.GT.JTR) HDATA(I  ) = HDATA(I  )-2
            IF(ITRK2.GT.JTR) HDATA(I+1) = HDATA(I+1)-2
13004 CONTINUE
13005 CONTINUE
      ENDIF
        LTRBK = IDATA(IPPATR+3)
        IPTR1 = IPPATR + IDATA(IPPATR+1) + MTR*LTRBK
        IPTR2 = IPTR1 + LTRBK
        NBYTE = (IPTR9 -IPTR2 + 1) * 4
      IF(
     - NBYTE.GT.0
     -)THEN
          CALL MVCL(IDATA(IPTR1+1),0,IDATA(IPTR2+1),0,NBYTE)
      DO 13006 IP=IPTR1,IPTR9,LTRBK
            IDATA(IP+1) = IDATA(IP+1) - 1
13006 CONTINUE
13007 CONTINUE
      ENDIF
        IPTR9 = IPTR9 - LTRBK
      GOTO IZZZ01
      END

C   22/03/97 703221647  MEMBER NAME  JEOSUM2  (JADEMUS)     FVS
C   22/03/97 703221635  MEMBER NAME  @COMMONS (JADEMUS)     FVS
------------------------------------------------------------------------
COMMON Descriptions. ---------------------------------------------------
------------------------------------------------------------------------

   Common block CALIBR can be easily incorporated using %MACRO CMUCALIB
   on F22ALL.JADEMUS(CMUCALIB) .

      COMMON /CALIBR/ LARRY(100),MUCAL(4185)




                NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
                                                     19 WORDS

      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
 ----------------------------------------------------19 WORDS SO FAR

      HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
 ---------------------------------------------------389 WORDS SO FAR


      HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
 ---------------------------------------------------707 WORDS SO FAR

      HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
 ---------------------------------------------------953 WORDS SO FAR


      HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
 --------------------------------------------------1587 WORDS SO FAR

@
      HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
C ********* N.B. HMCEDM IS JUST A 'FILLER' . **********
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
 --------------------------------------------------3807 WORDS SO FAR

      HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
 --------------------------------------------------4124 WORDS SO FAR

      HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
 --------------------------------------------------4160 WORDS SO FAR


      HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
      IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
 --------------------------------------------------4170 WORDS SO FAR


     IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
     IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
     IEPIND,IEPSCT

      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
 --------------------------------------------------4185 WORDS SO FAR
@  DEFINITION OF CALIBRATION TERMS

  NVERSN           Version number.
  DESCRP           Description.

  HOVALL(IUNIT)    Overall translation of each unit along rails.
                     IUNIT=1 - far  side (-x) wall,
                     IUNIT=2 - near side (+x, rucksack) wall,
                     IUNIT=3 - magnet  (All translations are relative to
                               this so HOVALL(3) should ALWAYS be zero.)
                     IUNIT=4 - far  side (-x) arch,
                     IUNIT=5 - near side (+x) arch.

  IFRAME           Frame number.
  ICHAM            Chamber number.
  NFRAMS           Number of frames.
  NCHAMS           Number of chambers.

  Fixed Data For Each Frame....

  HFACE(IFRAME)    1-6 for -x,+x,-y,+y,-z,+z respectively.
                   =0 if frame not present.
  HSECT(IFRAME)    Section number of section to which frame belongsh
  HLAYER(IFRAME)   1-5 numbering from the interaction point outwardsh
                     =1, inside return yoke
                     =2-5 for layers on concrete,
  HNORM(IFRAME)    =1,normal of plane parallel to x-axis
                   =2,normal of plane parallel to y-axis
                   =3,normal of plane parallel to z-axis
  HLONG(IFRAME)    =1,wire nominally parallel to x-axis
                   =2,wire nominally parallel to y-axis
                   =3,wire nominally parallel to z-axis
  HTRANS(IFRAME)   =1,drift field parallel to x-axis
                   =2,drift field parallel to y-axis
                   =3,drift field parallel to z-axis
  HAC(IFRAME)      Chamber number of first chamber in frame.
  HAL(IFRAME)      Chamber number of last chamber in frame.
  HUNIT(IFRAME)    Unit to which this frame belongs.

  Survey Data For Each Frame....

  HDIST(IFRAME)     The coordinate of the central plane where the axis
                     specified by HNORM(IFRAME) cuts the plane(units mm)
  HANG(IFRAME)      The angle between the wire and the axis specified by
                     HLONG(IFRAME)  (units 1/10 mr)
  HCLLO(IFRAME)     Lower logitudinal coordinate limit
  HCLHI(IFRAME)     Upper logitudinal coordinate limit
  HCTLO(IFRAME)     Lower transverse coordinate limit
  HCTHI(IFRAME)     Upper transverse coordinate limit
                    (The above 4 variables apply to total sensitive area
                       of plane.They are in mm )

  Fixed Data For Each Wire....

  HFR(ICHAM)        Frame number for this chamber.

  Survey Data For Each Wire....

  HD1(ICHAM)        Amount to be added to HDIST(IFRAME) to get to
                     coordinate of the chamber.   (units mm)
@ HCTW(ICHAM)       Tranverse coordinate of each wire.  (units mm)

  Electronic Data For Chambers...

  HDTP(ICHAM)      Drift time pedestal (trans. clock units, ca. 60 ns.)
  HLTP(ICHAM)      Longitudinal time pedestal (in long. clock units,
                     ca. 0.5 ns. or 50 mm.)
  HLSF(J,ICHAM)    Long. scale factor for j'th hit
                     (units (1/100mm)/long. clock unit)
  HVDRFT(ICHAM)    Drift velocity (microns per clock unit (50 ns)).

                   The above data are used to convert signals to coor-
                     -dinates relative to the chamber as follows..
                   ICT = ( HVDRFT * (ITD-HDTP) )/1000
                   ICL = ( HLSF   * (ITL-HLTP) )/100
                     where ICT,ICL are coordinates in mm,
                     ITD is drift time in trans. clock units, and
                     ITL is long. time diff. in long. clock units.


  Status Data For The Chambers

  HMCSTA(ICHAM)    =0    if chamber ok
                   .NE.0 if chamber u/s for any reason.

------------------------------------------------------------------------
#include "cmutny.for"
    /CMUTNY/


  Condensed mu-filter paarameters for use by approximate signal to
    coordinate conversion subroutine MUTINY as used at the NORD.

  HPLANS      No. of chamber planes.
  HVDRAV      Average drift velocity.
  HDTPAV      Average drift time pedestal.
  HLTPAV      Average longitudinal time difference pedestal.
  HLSFAV      Average longitudinal scaling factor.

  FOR EACH CHAMBER PLANE...

  HLY         Layer number.
  HOR         Orientation parameter:
              =1, wires parallel to beam, and normal parallel to
                    x-axis - faces 1(-x) and 2(+x).
              =2, wires parallel to beam, and normal parallel to
                    y-axis - faces 3(-y) and 4(+y).
              =3, wires vertical, and normal parallel to z-axis -
                    faces 5(-z) and 6(+z).
  HC1         First chamber number.
  HCN0        Normal       )
  HCL0        Longitudinal )  coordinate of 'origin' of chamber plane.
  HCT0        Transverse   )
  HSP         Average spacing of chambers.

    (The 'origin' is at one end of the wire of the first chamber in the
  plane.  The end is that with the lowest longitudinal coordinate.)

      COMMON /CMUTNY/HPLANS,HVDRAV,HDTPAV,HLTPAV,HLSFAV,
     * HLY(48),HOR(48),HC1(48),HCN0(48),HCL0(48),HCT0(48),HSP(48)

------------------------------------------------------------------------

 MACRO CMUANP.
 -------------
  Mu analysis parameters filled by block data after MUINI.

      COMMON/CMUANP/IMUANP(30)
      DIMENSION AMUANP(30),HMUANP(60)
      EQUIVALENCE (IMUANP(1),AMUANP(1),HMUANP(1))

------------------------------------------------------------------------

 COMMON /CMUPRN/.
 ---------------

      COMMON /CMUPRN/MUPRIN

      MUPRIN=0 to suppress all printing of mu messages,
            .GE.1 to get mu error messages,
            .GE.2 to get mu information messages,
            .GE.10 to get full mu calibration printout (about 10 pages).

------------------------------------------------------------------------
End of COMMON Descriptions. --------------------------------------------
------------------------------------------------------------------------
C   22/03/97 703221635  MEMBER NAME  @MISC    (JADEMUS)     FVS
**********************************************************************
*  The Philosophy 1 routines (MUANAL,MUANAJ) are currently commented *
*  out in the standard driving routine MUANA.                        *
**********************************************************************

      The calling sequence is now as follows:

 1) CALL MUINI                              - at start of operations.
 2) Fill muon calibration data areas        - before any processing.
     (This can be done with the STANDARD JADE SYSTEM or with MUCON.)
 3) CALL MUREG(IPRINT) (usually IPRINT=0)   -       ditto.
 4) CALL MUANA(0) if 'PATR' absent or
    CALL MUANA(1) if 'PATR' present         - in event loop.
     (MUANA is described in more detail below.)
 5) CALL MUFINI                             - at end.

      The above are incorporated into the standard supervisor.If you
 elect to use it, there exist the following to assist mu program
 development ( in source/load libraries F22ALL.MUSEFULS/MUSEFULL ) :
 1) A special version of USER in member MUSER.
 2) Subroutine MU0 which is called at start of operations. MU0 reads a
      parameter card which (among other things) specifies the print
      parameter IPRINT, which is used as follows...
        IPRINT .LE. 0 suppresses all printing. (This is the normal case
                        for graphics, standard analysis,etc.)
        IPRINT .GE. 1 to get error messages.
        IPRINT .GE. 2 to get normal muon messages.
        IPRINT .GE. 4 to get Philosophy 2 results printing.
        IPRINT .GE. 10 to get calibration data printing.
 3) Subroutine MU1 which is called just after new calibration data have
      been read in and which will read a private set of calibration data
      if requested, or alternatively a set of updates.
 4) Subroutine MU2 which is called just after the event has been read
      and which allows event selection.
*5) Subroutine MU8 which is called after mu processing is complete.
 6) Subroutine MU99 which is called at end.
*7) A specimen set of JCL in member #MUTEST which uses all of these
      facilities.
  =====
  NOTE: The following are also available on F22ALL.MUSEFULS/L :
  =====

  1) A somewhat simplified version of #MUTEST is to be found in member
     #USERA. It contains a data input file , a data output file , and
     JADE's calibration datasets. All the relevent load libraries are
     already linked in.
@
  2) Member USERA contains a special version of USER. This version of
     user contains the Time-Of-Flight programs which produce the 'TOFR'
     results bank , calls only those programs which are needed for
     Phil.2 and bypasses the call to MUANA at level 8 in the supervisor.
     ( see below )
  ======================================================================

C   22/03/97 703221635  MEMBER NAME  @MUCALIB (JADEMUS)     FVS
------------------------------------------------------------------------


Muon Calibration Data Banks :
-----------------------------

    These are kept on datasets
      (a)  F22ALL.MUCALIB.DATA0001 ( -0002, ..... ,-0018 )
           as BOS records which can be read by BREAD ;
      (b)  F22ALL.MUCALIB.NBOS0004 ( -0005, ..... ,-0016 only, see (c))
           as single logical records of length 4185 words.
*     (c)  F22ALL.MUCALIB.JADE0017 ( -0018, .....  )
*          which are in the new JADE format ( from no. 17 onwards ):
*         LENGTH,(IBUF(I),I=1,9),(MUCAL(I),I=1,4185)   ( ALL I*4 WORDS )
*           where LENGTH = 4194  ,
*                 IBUF(1)='MUCA' ,
*                 IBUF(6)= CAMAC TIME ( in seconds since 1/1/1979 )
*                          at which this data set comes into force ,
*                 IBUF(7)= 1 , signifying that a complete set of
*                             mufilter constants follows ,
*                 ALL OTHER IBUF(I)=0.
*     (d)  F22ALL.UPDATE0m.JADE00nn
*         the mTH. UPDATE to MUCALIB.JADE00nn , which are updates of
*         small nos. of constants provided in the format
*        LENGTH,(IBUF(I),I=1,9),CONST. #,NEW VALUE,CONST #,NEW VALUE,...
*        |--------------------| |------------------------------------...
*        |< I*4 WORDS        >| |<       I*2   WORDS   ....
*
*         where   LENGTH is VARIABLE and = the no. of words following,
*                 IBUF(7)= 0, signifying that UPDATES of individual
*                             constants follow ,
*                 ALL OTHER IBUF(I) are as in (c) above.
*          N.B.THE CONSTANT LOCATIONS ARE COUNTED IN I*2 WORDS IN MUCAL.
*

   The first one of type (a) is for MONTE-CARLO analysis.  Datasets  (a)
   are provided for the purpose of private muon calibration outside  the
   JADE system. Any changes or updates are put onto these BOS  datasets.
   The changes are then checked independently before providing a copy in
   format (c)/(d) for the JADE system.

*     Viewing and changing calibration datasets are now possible using a
*  fullscreen program called EXCALIBUR which is very easy to use. It  is
*  activated using the  command  'F22BOW.EXCALIBR.S(EXCALIBR)'.  Changes
*  and updates can be implemented by routine  MUCONE  which  is  usually
*  called  by  a  simple  main  program  running  outside  the  standard
*  supervisor. This program should call MUCONR (if desired) to  read  in
*  an existing BOS calibration dataset and also MUCONW to write out  the
*  new calibration.

   Only one common is used by MUCONE and MUCONW , namely CMUCALIB.
*
*  See further information on F22ALL.JADEMUS1
*

@ Bank Names, Numbers and Lengths
  -------------------------------

   Name/Number Length          Contents
   ---- ------ ------          --------

   MUCD   0      16    Version number and description.
   MUOV   0       3    Overall jade unit translations.
   MFFI   2     370    Fixed frame parameters.
   MCFI   3     318    Fixed chamber parameters.
   MFSU   4     246    'Survey' frame parameters.
   MCSU   5     634    'Survey' chamber parameters.
   MCEL   6    2220    'Electronic' chamber parameters.
   MCST   7     317    Chamber status words.
   MUFI   8      36    Filter (absorber block) parameters.
   MUYO   9      10    Side, top and bottom yoke parameters.
   MUEN  10      15    Yoke end-plug parameters.

  Total length 4185 words.

------------------------------------------------------------------------


    The following calibration data have been provided to the JADE
    calibration system:
*    ( N.B. The key parameter for implementation is the TIME stated.)

   Dataset     Run                    Comments
   Number     Numbers
   -------  -----------   ----------------------------------
    0004    0000 - 2047   Data unreliable ; all chambers 'off'
                           up to 13.00 26.10.79

    0005    2047 - 2185   336 chambers in the barrel faces 'on'
                           17.09 26.10.79  to 00.05 03.11.79

    0006    2186 - 2402   349 chambers in the barrel faces 'on'
                           00.18 03.11.79  to 23.19 18.11.79

    0007    2403 - 2746   477 chambers in the barrel faces and
                          the endwalls 'on'
                           23.31 18.11.79  to 23.59 31.12.79

    0008    2747 - 3015   592( out of 622 installed ) chambers 'on'
                           00:00 01.01.80  to  04.24 10.03.80

    0009    3016 - 3316   597/622 chambers 'on'
                           04.51 10.03.80 to  20.35 03.04.80

    0010    3317 - 3584   597/622 chambers 'on'
                           09.30 11.04.80 to  20.30 13.05.80

    0011    3585 - 3614   All chambers off!!! water leak
                           20.30 13.05.80 to  22.54 16.05.80

    0012    3615 - 3727   586/622 chambers 'on'
                           22.55 16.05.80 to  18.39 23.05.80

    0013    3730 - 4891   592/622 chambers 'on'
                           07.03 17.06.80 to  23:59 10.09.80

    0014    4865 - 5344   575/622 chambers 'on'
                           07:00 01.09.80 to  23:59 17.10.80

@   0015    5345 - 5566   578/622 chambers 'on'
                           00:00 18.10.80 to  23:59 31.10.80

    0016    5567 -   /    576/622 chambers 'on'
                           00:00 01.11.80 to  23:59 31/12/81

*   0017            -->    00:00 01.01.81 to  23:59 10/05/81
*                         N.B. All chambers 'OFF' up till 00:00 20.03.81

*   0018            -->    00:00 11.05.81 to  23.59 26/6/81
*

*   0019            -->    00:00 27/06/81 to  23:59 17/09/81
*

*   0020            -->    00:00 18/09/81 to  ........
*

*   0021            -->    00:00 ........ TO  ........
*

*   0022            -->    00:00 ........ TO  ........
*

*   0023            -->    00:00 ........ TO  ........
*

*   0024            -->    00:00 ........ TO  ........
*

*   0025            -->    00:00 ........ TO  NOW
*

       N.B.   'OFF' and 'ON' refer to the state of a software switch:
               for any given dataset,the set of chambers off in the
              NW Hall is a subset of those switched 'off', but generally
              corresponds fairly closely. Holes in run  number  sequence
              correspond to junk data, calibration runs etc.
*             From dataset 17 onwards, the chamber status is revised  on
*             a time scale of 1 day bins. Hence, exact  nos.  of  active
*             chambers are not given here.

C   22/03/97 703221635  MEMBER NAME  @MUSTAT  (JADEMUS)     FVS
------------------------------------------------------------------------

    THIS IS MEMBER @MUSTAT. IT CONTAINS THE INFORMATION CONCERNING
    THE MUON STATISTICS PRINTOUT PRODUCED BY SUBROUTINE MUFINI

------------------------------------------------------------------------

         RUNTIME PROGRAM STATISTICS

      1     CALLS TO MUCOOR
      2     SUM(OVER EVENTS) OF NUMBER OF HITS
      3     EVENTS WITH NO HITS
      4     (MUANAF) HITS IN MUR1/0 BUT NO MUR1/1(2) EXISTING
      5     (MUCUTS) MUR2/0 MISSING
      6     (MUCUTS) MUHITS AND PATR TRACKS EXIST BUT NO MUR2/1..3
      7     OVERFLOW OF OUTPUT ARRAY ( > 200 HITS )( 400 FROM 9/10/85 )
      8     LENGTH ERROR IN HMU
      9     LAST WORD OF HMU IS NOT 0 NOR 3840
     10     (MUANAF) MUR1/0 MISSING
     11     NUMBER OF EVENTS WITH MUCUTS MUONS
     12     NUMBER OF MUONS WITH MUCUTS FLAG = 1
     13     NUMBER OF MUONS WITH MUCUTS FLAG = 5  (NOT SUBSET OF 1 HERE)
     14     NUMBER OF MUONS WITH MUCUTS FLAG = 9  (NOT SUBSET OF 5 HERE)

         STATISTICS PERTAINING TO COORDINATES

     20     DRIFT COORDINATE FLAGGED AS BAD
     21     LONGITUDINAL COORDINATE FLAGGED AS BAD
     22     DRIFT COORDINATE PULLED IN
     23     LONGITUDINAL HIT PULLED IN TO END OF CHAMBER (7)
     24     HIT DELETED BY DOUBLE PULSE CUT(1016)
     25     RECOVER OVERWRITTEN HIT1 WITH (HIT2-ICONST)
     26     IITD.GE.JITD
     27     OUTPUT HITS FLAGGED DUE TO OUT OF SEQUENCE DRIFT TIMES
            N.B. #27 IS INCREMENTED ONLY ONCE PER CHAMBER IN ANY ONE
                 EVENT, WHEREAS #26 IS INCREMENTED FOR EVERY INSTANCE
                 WHERE WE HAVE  (SAMCHM).AND.IITD.GE.JITD  , WHICH
                 MORE THAN ONCE IN ANY ONE CHAMBER.
     28     HIT NUMBER NOT DECREASED BY ONE
     29     NEW CHAMBER, BUT LAST HIT WAS NOT HIT1
     30     SINGLES DATA, BUT NOT HIT1

         STATISTICS PERTAINING TO CHAMBERS

     40     HIT FROM CHAMBER WITH STATUS NOT GOOD(1017)
     41     INVALID CHAMBER NUMBER
     42     CHAMBER OUT OF SEQUENCE
     43     CHAMBER IN WRONG CRATE
     44     IN SINGLES DATA, COUNTS OR TIME IS NEGATIVE

         STATISTICS PERTAINING TO CRATES

     60     INVALID CRATE NUMBER (901)
     61     CRATE NUMBER OUT OF ORDER
     62     TIME REFERENCE WORD NOT PRESENT
     63     END-OF-CRATE FOUND IN RECOVER SEARCH (2203)
     64     CRATE MARKER FOUND IN RECOVER SEARCH (2204)
     65     END-OF-CRATE FOUND WHEN CRATE MARKER WAS EXPECTED.

     70 + NN   COUNT OF NUMBER OF EVENTS WHERE CRATE NN WAS MISSING
     84 + NN    "    "   "     "    "      "     "   "  HAD NO E.O.C.

    THE STATISTICS INFORMATION IS STORED IN

      COMMON / CMUSTT / MUTIT(100),NMU(100)

    MUTIT    ARE THE TITLES USED IN THE PRINTOUT. SEE BLOCKDATA IN MUINI
    NMU      ARE THE STATISTICS SCALARS.

C   22/03/97 703221635  MEMBER NAME  @PHIL1   (JADEMUS)     FVS
    THIS INFORMATION USED TO BE IN @MUINFOM. IT CONTAINS DETAILS ABOUT
    PHILOSOPHY 1

 -----------------------------------------------------------------------

  2)MUANAL.  This looks for 'linear clusters', i.e. tracks, in the muon
     filter.  It follows 'Philosophy 1', i.e. gathers as much
     information as possible by looking in the muon filter alone.  It
     uses 'MUR1' banks 0,1,& 2.  It updates 'MUR1' bank 0,1,& 2.  It
     creates 'MUR1' banks 3,4,5,6,and 7 (see below).

  3)MUANAJ.  This attempts to join muon clusters to inner detector and
     lead-glass clusters.  It uses the 'MUR1' banks and updates 'MUR1'
     banks 0 and 3 (see below).

 -----------------------------------------------------------------------

  'MUR1' Bank 0 - General information.
   -----------------------------------

   Word  Type  Contents
   ----  ----  --------
     1   I*4   No. of hits.
     2   I*4   No. of clusters (tracks).
     3   I*4   No. of 2-byte words per hit in coordinate bank.
     4   I*4   No. of 4-byte words per cluster in cluster bank.
     5   I*4   =1 if muline has been called, i.e. if an attempt to
                    create clusters has been made.   =0 otherwise.
     6   I*4   =1 if an attempt to join clusters to inner detector
                    tracks has been made.   =0 otherwise.
     7   I*4   =1 if an attempt to join clusters to lead-glass clusters
                    has been made.   =0 otherwise.
     8   I*4   Date of version of signal-coordinate conversion routine.
     9   I*4   Calibration data issue, i.e. identifier of calib. data
                    used to produce coordinates.


@ 'MUR1' Bank 3 - Muon cluster information.
   ----------------------------------------

              (Note. cluster number in word 30.)
                  For each cluster...

   Word  Type               Contents
   ----  ----               --------
     1   I*4   Date of production (e.g. 791010 for 10/10/79).
     2   R*4   Identifier of program which created cluster (a 4 char-
                 acter alphanumeric word).
     3   I*4   No. of hits in cluster.
     4   I*4   Cluster number of alternative cluster (=0 if none).
     5   I*4   =0, only one layer in cluster (if so words 9-14=0).
     6   R*4   xc )
     7   R*4   yc ) coords. of 'centre of gravity' (mm).
     8   R*4   zc )
     9   R*4   dx )
    10   R*4   dy ) direction cosines of fitted line.
    11   R*4   dz )
    12   R*4   d1, distance to 'first' point (mm).
    13   R*4   d2, distance to 'last' point (mm).
                 Note. algorithm to get cordinates of first hit is...
                   x1=xc+d1*dx
                   y1=yc+d1*dy
                   z1=zc+d1*dz
                 and similarly for last hit.
    14   R*4   rms deviation for 'good' cluster - see also words 25,26.
               =0. if mulina (ambiguity resolving routine) not called.
               =-1. if it fails acceptance criteria,
               =-2. if it has more than 2 acceptable ambigiuty
                             permutations.
               =-9999. if mulina has taken no action, e.g. if only 1
                  layer, or too many ambiguities, or only 2 layers and
                  too many ambiguities.
               Note that if this word.LE.0 then words 6-11 contain the
                 the results of fitting prior to call to MULINA, i.e.
                 l and r hits of unresolved hits used with equal weight
                 (although with lower weight than resolved hits).
    15   R*4   Integral dl (=distance, mm).                 )(from
    16   R*4   Integral density*dl (= material traversed,   )(inter-
                 gm cm**-2).                                )(action
    17   R*4   Integral (-dE/dX)*dl (energy loss, minimum   )(point to
                 ionising particle, GeV).                   )(last
    18   R*4   Integral dl/(absorption length) ('number' of )(point in
                 absorption lengths) assuming a pion.       )(cluster.
    19   R*4   Mu 'goodness' parameter (very crude at this stage).
    20   R*4   Hadron 'leak' probabilty, exp(-(no. of absn. lengths)).
    21   I*4   Associated inner detector track no., if any.
    22   I*4   Associated lead glass cluster no., if any.
    23   R*4   Distance between projections  of  the  mu-track  and  the
               inner detector track, if any, at the position of the flux
               return yoke.
    24   R*4   Ultimate range of a muon with momentum of inner  detector
               track, if any (gm cm**-2).
    25   R*4   rms drift direction deviation.              ) ignore if
    26   R*4   rms longitudinal (wire) direction deviation.) wd 14.LE.0.
    27   R*4   Total weight of x coordinates
    28   R*4   Total weight of y coordinates
    29   R*4   Total weight of z coordinates
    30   I*4   Cluster number.

@ 'MUR1' Bank 4 - The pointer list HCLP.
   -------------------------------------

     HCLP(ICL) points to start of information in HCLIST (bank 5) for
       cluster ICL.
     HCLP(no. of clusters +1) points to word after the last.

  'MUR1' Bank 5 - The hit list HCLIST.
   -----------------------------------

     This gives the hits belonging to each cluster.
     Banks 4 and 5 may be used in conjunction to find the hits belonging
       to each cluster as follows...
      NCLS = no. of clusters (word 2 of bank 0).
      NWHIT = no. of words per hit (word 3 of bank 0).
      NWCL = no. of words per cluster (word 4 of bank 0).
      IPCL = IP3, where IP3 is pointer to bank 3.
      IP11 = 2*IP1, where IP1 is pointer to bank 1.
      IP44 = 2*IP4, where IP4 is pointer to bank 4.
      IP55 = 2*IP5, where IP5 is pointer to bank 5.

  BEGIN LOOP 1 - LOOP OVER CLUSTERS                   **** START LOOP 1
      DO 1000 ICL=1,NCLS
  FIND HITS FOR THIS CLUSTER.  TO GET HITS OF SECONDARY CLUSTER USE
    THE POINTERS OF PRIMARY CLUSTER.
      JCL=ICL
      IALT=IDATA(IPCL+4)
      IF(IALT.NE.0.AND.IALT.LT.ICL)JCL=IALT
      LP=HDATA(IP44+JCL)
      LPNEXT=HDATA(IP44+JCL+1)
  START LOOP 2.                                 ***** START LOOP2.
 2000 CONTINUE
      IHIT=HDATA(IP55+LP)
      IP=NWHIT*(IHIT-1)
  NOW YOU CAN FIND HITS. ADD IP TO IP11 TO GET START OF COORDINATE DATA.
   (DON'T FORGET TO USE APPROPRIATE INFORMATION,E.G. AMBIGUITY FLAGS,
    FOR SECONDARY CLUSTERS, I.E. IF(JCL.LT.ICL) ).
      ....
      ....
  END LOOP 2.                                    ***** END LOOP 2.
 2001 CONTINUE
      LP=LP+1
      IF(LP.LT.LPNEXT)GO TO 2000
  END LOOP 1.                                    ***** END LOOP 1.
 1001 CONTINUE
      IPCL=IPCL+NWCL
 1000 CONTINUE


@ 'MUR1' Bank 6 - The l/r ambiguity of hits in primary clusters
   ------------------------------------------------------------

                  For each hit....
   Word  Type        Contents
   ----  ----        --------
     1   I*2   = -1, 'left' ambiguity selected,
     .    .      +1, 'right' ambiguity selected,
     .    .       0,  both ambiguities equally acceptable.
     .    .

  'MUR1' Bank 7 - The l/r ambiguity of hits in secondary clusters
   --------------------------------------------------------------

                  For each hit....
   Word  Type        Contents
   ----  ----        --------
     1   I*2   = -1, 'left' ambiguity selected,
     .    .      +1, 'right' ambiguity selected,
     .    .       0,  both ambiguities equally acceptable.
     .    .
C   22/03/97 703221635  MEMBER NAME  CMTEMP   (JADEMUS)     FVS
C
C
C
C___MACRO___MTEX1_______________________________________________________
C
C******* NOTE TO ALL MUON PROGRAMMERS : DO NOT ADD ANYMORE
C******* TO /CWORK/ IN THIS MACRO BECAUSE CMUFWORK USES
C******* FOLLOWING LOCATIONS.
C
C                MUREGY   COMMON     SPACE
      COMMON/CWORK/DUMMY(400),IREG(200),RDOTD(200),CINT(3,200),
     *NFLAG(200),ITEM(200)
C
C___MACRO___MTEX1_______________________________________________________
C
C
C
C   22/03/97 703221635  MEMBER NAME  CMUANP   (JADEMUS)     FVS
C--------START OF MACRO CMUANP------------------------------------------
C
C MU ANALYSIS PARAMETERS. FOR DESCRIPTION SEE BLOCK DATA IN MUINI.
C
      COMMON/CMUANP/IMUANP(30)
      EQUIVALENCE (CUTP,IMUANP(1))
      EQUIVALENCE (WRES,IMUANP(2))
      EQUIVALENCE (CUTT,IMUANP(3))
      EQUIVALENCE (CUTL,IMUANP(4))
      EQUIVALENCE (FT,IMUANP(5))
      EQUIVALENCE (FL,IMUANP(6))
      EQUIVALENCE (DRES,IMUANP(7))
      EQUIVALENCE (DLRES,IMUANP(8))
      EQUIVALENCE (FS,IMUANP(9))
      EQUIVALENCE (CUTC,IMUANP(10))
      EQUIVALENCE (FR,IMUANP(11))
      EQUIVALENCE (FAT,IMUANP(12))
      EQUIVALENCE (FAL,IMUANP(13))
      EQUIVALENCE (CUTDT,IMUANP(14))
      EQUIVALENCE (CUTDL,IMUANP(15))
C
C-----END OF MACRO CMUANP-----------------------------------------------
C   22/03/97 703221635  MEMBER NAME  CMUBCS   (JADEMUS)     FVS
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C   22/03/97 703221635  MEMBER NAME  CMUCALIB (JADEMUS)     FVS
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C   29/06/82 206291130  MEMBER NAME  CMUED    (JADEMUS)     FORTRAN
C             11.20 29/06/82 HUGH MCCANN
      COMMON /CMUED/NCHAN
C  NCHAN IS THE NO. OF I*2 WORDS WHICH ARE CHANGED BY THE CURRENT EDITS.
C    THIS APPROACH IS ADOPTED IN ORDER TO AVOID INITIALISING LOCATIONS
C  IN /CWORK/ .
C   28/05/82 206291132  MEMBER NAME  CMUEDWRK (JADEMUS)     FORTRAN
C   27/05/82 205271447  MEMBER NAME  CMUEDWRK (S)           FORTRAN
C   17/06/81 106170953  MEMBER NAME  CMUED    (JADEMUS1)    FORTRAN
C   12/06/81 106151117  MEMBER NAME  CMUED    (S)           FORTRAN
C
C LAST CHANGE 11.20 29/06/82 HUGH MCCANN  - FIX BUG..PUT NCHAN IN/CMUED/
C      CHANGE 10.00 28/05/82 HUGH MCCANN  - REDUCE CORE REQUIREMENTS FOR
C                                          PRODUCTION OF UPDATE DATASETS
C
      COMMON /CWORK/KTIME,HUPDAT(8370),HLOC(8370),IALPH,NHMUCA
C       N.B.  SEE  ALSO  CMUED.
C
C  THIS FITS IN WITHIN THE MAXIMUM SIZE OF CWORK....PATREC CWORK
C  IS APPROX 40 KBYTES.
C
      DIMENSION HMUCAL(8370)
      EQUIVALENCE (HMUCAL(1),MUCAL(1))
C  KTIME IS THE TIME AT WHICH THIS SET OF EDITS IS TO BE IMPLEMENTED
C         ( IN SECONDS FROM THE START OF 1979 VIA KTMCON)
C  HUPDAT IS AN ARRAY CONTAINING THESE NEW VALUES  (HUPDAT(I),I=1,NCHAN)
C  HLOC   IS AN ARRAY CONTAINING THEIR HALF-WORD ADDRESSES IN THE MUCAL
C         PART OF THE JADE CALIBRATION COMMON.
C  IALPH  IS THE NUMERICAL INDEX (1-20) OF THE ALPHABETIC IDENTIFIER OF
C         CURRENT MUCONE EDIT (ONLY USED DURING MUCONE OPERATIONS) .
C  NHMUCA IS THE HMUCAL LOCATION OF THE HMUCAL WORD WHICH IS CURRENTLY
C         BEING CHANGED ( ONLY USED DURING MUCONE OPERATIONS ).
C   20/10/81 408081453  MEMBER NAME  CMUFFL   (S)           FORTRAN
C
C LAST CHANGE 15.00 08/08/84 - CKB PWA     - ADD NALLWM,PMXFLG
C      CHANGE 15.00 03/12/83 - HUGH MCCANN - NEW LEAD GLASS PARAMETERS.
C      CHANGE 08.00 12/10/81 - HUGH MCCANN - TO ADD OVLCUT(FOR OVERLAPS)
C      CHANGE 09.33 17/06/81 - JOHN ALLISON - TO ADD RESOLUTIONS.
C
C-------------START OF MACRO CMUFFL-------------------------------------
C
      COMMON / CMUFFL / XYSTEP,RCOILI,RCOILO,PGMID,WMU,WMUSQ,DUMF1(4),
     +                  NSPECI,XPBAR,XPROT,XPION,XKAON,DUMF2(5),
     +                  TBP,GMBP,ABBP,RDBP,DEBP,
     +                  TJETI,GMJETI,ABJETI,RDJETI,DEJETI,
     +                  TJET1,GMJET1,ABJET1,RDJET1,DEJET1,
     +                  TJET2,GMJET2,ABJET2,RDJET2,DEJET2,
     +                  TJET4,GMJET4,ABJET4,RDJET4,DEJET4,
     +                  TJETO,GMJETO,ABJETO,RDJETO,DEJETO,
     +                  TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL,
     +                  ZJETE,TJETE,GMJETE,ABJETE,RDJETE,DEJETE,
     +                  ZEPLG,TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG,
     +                  RLG,ZLG,TLG,GMLG,ABLG,RDLG,DELG,
     +                  ZEP,TEP,GMEP,ABEP,RDEP,DEEP,
     +                  GMG(3),ABG(3),RDG(3),DEG(3),
     +                  VDRES,VLRES,
     +                  REST1,REST2,RESTMX,RESL,RESLMX,FACTOR,OVLCUT,
     +                  ZLGHAF,TLGHAF,ZLGC,GMLGC,ABLGC,RDLGC,DELGC,
     +                  NALLWM,PMXFLG
C
C FOR EXPLANATION SEE BLOCK DATA AFTER SUBROUTINE MUFFLE.
C
C--------------END OF MACRO CMUFFL--------------------------------------
C   20/10/81 202041521  MEMBER NAME  CMUFWORK (JADEMUS)     FORTRAN
C   12/10/81 110152138  MEMBER NAME  CMUFWORK (JADEMUS1)    FORTRAN
C-------------START OF MACRO CMUFWORK-----------------------------------
C LAST CHANGED 21.30 15/10/81 HUGH MCCANN  - EXTEND IOVLAP TO ALLOW
C                                            > 10 ASSOC HITS IN MUFFLY.
C LAST CHANGED 10.00 04/10/81 HUGH MCCANN  - FOR USE OF OVERLAP HITS.
C LAST CHANGED 14.46 17/06/81 JOHN ALLISON - TO ADD 'OVER' VARIABLES.
C LAST CHANGED 23.00 09/04/81 HUGH MCCANN - JADEMUS UPDATE.
C
      COMMON /CWORK/X,Y,Z,DCX,DCY,DCZ,P,PSQ,E,ESQ,D,GM,AB,RD,DE,PPIDK,
     *PKDK,PPBPEN,PPPEN,PPIPEN,PKPEN,DUMW1(29),X8,Y8,Z8,DCX8,DCY8,
     *DCZ8,P8,PSQ8,E8,ESQ8,D8,GM8,AB8,RD8,DE8,PPIDK8,PKDK8,PPBPE8,
     *PPPEN8,PPIPE8,PKPEN8,DUMW28(29),X0,Y0,Z0,DCX0,DCY0,DCZ0,P0,PSQ0,
     *E0,ESQ0,D0,GM0,AB0,RD0,DE0,PPIDK0,PKDK0,PPBPE0,PPPEN0,PPIPE0,
     *PKPEN0,DUMW2(29),X9,Y9,Z9,DCX9,DCY9,DCZ9,P9,PSQ9,E9,ESQ9,D9,GM9,
     *AB9,RD9,DE9,PPIDK9,PKDK9,PPBPE9,PPPEN9,PPIPE9,PKPEN9,DUMW29(29),
C-----200 WORDS UP TO HERE----------------------------------------------
     *X1,Y1,Z1,X2,Y2,Z2,XMID,YMID,ZMID,X3,Y3,Z3,D1,D2,D3,DTC,DUMW3(4),
     *DSTEP,GMSTEP,ABSTEP,RDSTEP,DESTEP,DUMW4(15),ADCZ,COSEC,STPINI,CURV
     *,DANG,DX,DY,DZ,R,RSQ,PT,DPINA,DKNA,DUMW5(7),VX,VY,VZ,RMSXY,RMSZ,
     *VTXYD,VTZD,VTXYAN,VTZANG,VMSANG,VMSD,CMS,DUMW6(8),SDS(10),DUMW7(10
C
C    *SDX,SDY,SDZ,SDTXYD,SDTZD,SDTXYA,SDTZAN,SDMSAN,SDMSD,SDCMS,DM7(10),
C
C NOTE ABOVE CARD SHORTENED TO SDS(10),DUMW7(10), SO THAT STATEMENT DOES
C   NOT EXCEED 19 CONTINUATION CARDS.  I THINK SD--'S ARE NOT USED.
     *),CHISQT,NDFT,CHIPRT,CHISTL,NDFTL,CHIPTL,NBADCH,DUMW8(13),IDTRK,
     *NCEPTS,NTHIS,INEFF,NHLAYR,INFLAG,NELIPS,NGLAYR,DUMW9(72),IREG(200)
C-----600 WORDS UP TO HERE----------------------------------------------
     *,RDOTD(200),CINT(3,200),NFLAG(200),ITEM(200),EM(30,30),DALONG(10),
C-----2710 WORDS UP TO HERE---------------------------------------------
     *DEV(30),VXYDA(10),VZDA(10),CXYA(10),CZA(10),INCUT(30),BADA(30),G(2
     *0,20),DEVA(20),IPERM(10),MWORK(20),ITHISA(10),IJA(10),EM1(20,20),E
     *MG(20,20),ELIPSE(700),INCHAM(10),INREG(10),IAPPRO(30),HBADCH(1000)
     *,CTDASH(10),CLDASH(10),VTDASH(10),VLDASH(10),IHTREG(20),LAYRAB,IEF
C-----5421 WORDS UP TO HERE---------------------------------------------
     *FRG(10),DUMW10(69),AAA(10),BBB(10),CCC(10),DDD(10),DOVER,GMOVER,AB
     *OVER,RDOVER,DEOVER,DUMW11(55),X7(50),IHTP(30),IOVLAP(20,20)
C-----6080 WORDS UP TO HERE---------------------------------------------
      DIMENSION ILIPSE(700)
      INTEGER*2 HLIPSE(1400)
      DIMENSION IHTPER(10),IHTEMP(10),IPTEMP(10)
      EQUIVALENCE (ILIPSE(1),HLIPSE(1),ELIPSE(1))
      EQUIVALENCE (IHTP(1) ,IHTPER(1)),
     *            (IHTP(11),IHTEMP(1)),
     *            (IHTP(21),IPTEMP(1))
      LOGICAL INCUT,BADA
C
C-----------------------------------------------------------------------
C
C THE FIRST 50 LOCATIONS ARE RESERVED FOR SPECIAL WORKING VARIABLES.
C THE NEXT 150 LOCATIONS ARE RESERVED FOR COPIES OF THESE SPECIAL
C    VARIABLES, IF, E.G., ONE WISHES TO PRESERVE THEIR VALUES AT
C    THE BEGINNING OF A STEP.
C THE COPIES HAVE A SUFFIX 0 FOR VALUES AT LAST ASSOCIATED HIT.
C THE COPIES HAVE A SUFFIX 7 FOR VALUES AFTER LEAD-GLASS BARREL OR
C    YOKE END-PLUG (X7 IS LATER IN COMMON - SEE BELOW).
C THE COPIES HAVE A SUFFIX 8 FOR VALUES AT LAST BUT ONE GOOD
C    CHAMBER LAYER.
C THE COPIES HAVE A SUFFIX 9 FOR VALUES AT LAST GOOD CHAMBER LAYER.
C NSPECI (SET IN BLOCK DATA BEHIND MUFFLE) IS THE NUMBER OF SUCH
C    VARIABLES ACTUALLY USED.
C
C SPECIAL VARIABLES....
C
C X,Y,Z       = CURRENT COORDINATES.
C DCX,DCY,DCZ = CURRENT DIRECTION COSINES OF TRACK.
C P,PSQ       = CURRENT MOMENTUM (AND ITS SQUARE).
C E,ESQ       = CURRENT ENERGY (AND ITS SQUARE).
C D           = CURRENT DISTANCE FROM VERTEX (MM).
C GM          = MATERIAL TRAVERSED TO CURRENT POSITION (GM CM**-2).
C AB          = ABSORPTION LENGTHS SO FAR.
C RD          = RADIATION LENGTHS SO FAR.
C DE          = ENERGY LOSS (GEV).
C PPIDK       = PROBABILITY OF PION DECAYING TO MUON BEFORE INTERACTING.
C PKDK        = PROBABILITY OF KAON DECAYING TO MUON BEFORE INTERACTING.
C PPBPEN      = ANTI-PROTON ) ( PENETRATION PROBABILITY, I.E. PROBAB-
C PPPEN       = PROTON      ) ( ILITY OF NOT BEING ABSORBED BY A NUCLEUS
C PPIPEN      = PI          ) ( AND NOT DECAYING.  SEE SUBROUTINE
C PKPEN       = K           ) ( MUFFLS FOR FURTHER DETAILS.
C
C-----------------------------------------------------------------------
C
C THE NEXT 200 LOCATIONS ARE RESERVED FOR VARIABLES THAT DO NOT NEED
C    SPECIAL PRESERVATION.
C
C OTHER VARIABLES...
C
C X1,Y1,Z1    = COORDS OF 1ST POINT ON TRACK.
C X2,Y2,Z2    = COORDS OF LAST POINT ON TRACK.
C XMID,YMID,ZMID = COORDS OF MID POINT ON TRACK.
C X3,Y3,Z3    = COORDS OF POINT WHERE TRACK LEAVES MAGNETIC FIELD.
C D1          = DISTANCE TRAVELLED TO (X1,Y1,Z1).
C D2          = DISTANCE TRAVELLED TO (X2,Y2,Z2).
C D3          = DISTANCE TRAVELLED TO (X3,Y3,Z3).
C DTC         = DISTANCE TRAVELLED TO MID-POINT OF TRACK.
C
C DSTEP       = STEP LENGTH THIS STEP (FOR MUFFLU) (MM).
C GMSTEP      = MATERIAL THIS STEP (GM CM**-2).
C ABSTEP      = ABSORPTION LENGTHS THIS STEP.
C RDSTEP      = RADIATION LENGTHS THIS STEP.
C DESTEP      = ENERGY LOSS OF MINIMUM IONISING PARTICLE THIS STEP,
C
C ADCZ        = ABS(DCZ)
C COSEC       = ABS(COSEC(THETA)), WHERE THETA IS ANGLE TO BEAM.
C STPINI      = STEP LENGTH IN INITIAL TRACKING TO COIL OR END PLUG.
C CURV        = CURVATURE FROM 'PATR' BANK.
C DANG        = ANGLE OF TURN FOR EACH STEP.
C DX,DY,DZ    = CHANGES OF X,Y,Z.
C R,RSQ       = DISTANCE FROM BEAM (RADIUS) AND ITS SQUARE.
C PT          = MOMENTUM COMPONENT PERPENDICULAR TO BEAM.
C DPINA       = INTEGRAL OF (DECAY LENGTH)*(PROBABILTY OF NOT INTER-
C                 ACTING) FOR PION. (NO LONGER USED. CAN BE RESURECTED
C DKNA        = SIMILARLY FOR KAON. (BY UN-COMMENTING IN MUFFLS.
C
C VX,VY,VZ    = CURRENT VARIANCES ON X,Y,Z.
C RMSXY       = RMS DEV. NORMAL TO CHORD IN XY FIT.     )
C RMSZ        = RMS Z DEV. IN RZ FIT.                   ) FROM
C VTXYD       = VARIANCE ON DEVIATION NORMAL TO         ) TRACK
C                 TRACK IN XY PLANE AT TRACK CENTRE.    ) RECON-
C VTZD        = VARIANCE ON DEVIATION NORMAL TO         ) STRUCTION
C                 TRACK IN RZ PLANE AT TRACK CENTRE.    ) ERRORS.
C VTXYAN      = VARIANCE ON ANGLE IN XY PLANE (PHI)     )
C VTZANG      = VARIANCE ON ANGLE IN RZ PLANE (THETA)   )
C VMSANG      = VARIANCE OF MULTIPLE SCATTERING ANGLE.
C VMSD        = VARIANCE OF MULTIPLE SCATTERING DEVIATION NORMAL TO
C                 TRACK.
C CMS         = COVARIANCE OF ABOVE TWO QUANTITIES.
C SD--        = CORRESPONDING STANDARD DEVIATIONS (SQUARE ROOTS).
C
C CHISQT      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFT        = NUMBER OF DEGREES OF FREEDOM.           ) (DRIFT)
C CHIPRT      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C CHISTL      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFTL       = NUMBER OF DEGREES OF FREEDOM.           ) & LONG'L
C CHIPTL      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C NBADCH      = NO. OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C
C IDTRK       = INNER DETECTOR TRACK NUMBER.
C NCEPTS      = NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS       = NUMBER OF MUON HITS ASSOCIATED WITH PROJECTED INNER
C                DETECTOR TRACK.
C INEFF       = NUMBER OF INEFFICIENCIES IN MUON SYSTEM FOUND THIS TRACK
C NHLAYR      = NUMBER WHICH REPRESENTS NUMBER OF MUON LAYERS WITH
C                ASSOCIATED MUON HITS. ADD 1 FOR THE INNER LAYER AND
C                2 FOR EACH SUBSEQUENT LAYER.
C INFLAG      = 1 IF LAST LAYER INTERCEPTED WAS INEFFICIENT.
C NELIPS      = NUMBER OF MULTIPLE SCATTERING ELIPSES ENTERED IN ELIPSE.
C NGLAYR      = AS NHLAYR, BUT FOR 'GOOD' LAYERS WHETHER THERE WAS AN
C                ASSOCIATED HIT OR NOT.
C
C-----------------------------------------------------------------------
C
C THE NEXT 1400 LOCATIONS USED BY MUREGY (CALCULATES REGION INTERCEPTS).
C
C IREG        = REGION NUMBER.                           )(IN PAIRS,I.E.
C RDOTD       = R.DOT.(DIR. COSINES) FOR EACH INTERCEPT. )( 2 INTERCEPTS
C CINT        = X,Y,Z COORDINATES OF EACH INTERCEPT.     )( PER REGION.
C NFLAG       = USED INTERNALLY BY MUREGY.
C ITEM        = USED INTERNALLY BY MUREGY.
C
C-----------------------------------------------------------------------
C
C THE NEXT 3600 LOCATIONS USED BY MUFFLE, ETC., TO ACCUMULATE
C   QUANTITIES NEEDED FOR CALCULATING CHI-SQUARED. IN THE DESCRIPTION
C   BELOW I,J GO AS FOLLOWS..
C     1   LEFT DRIFT COORDINATE    )  OF 1ST
C     2   RIGHT DRIFT COORDINATE   )  ASSOCIATED
C     3   LONGITUDINAL COORDINATE  )  HIT
C     4    ETC. FOR NEXT ASSOCIATED HIT.
C   K REFERS TO K'TH ASSOCIATED HIT.
C
C EM(I,J)     = 'ERROR MATRIX', I.E. VARIANCE (I=J) OR COVARIANCE (I.NE.
C                J) FOR COORDINATE I,J.
C DALONG(K)   = DISTANCE OF ASSOCIATED HIT K ALONG TRACK.
C DEV(I)      = DEVIATION OF COORDINATE I FROM EXTRAPOLATED INNER
C                DETECTOR TRACK.
C VXYDA(K)    = VARIANCE ON DEVIATION IN XY PLANE FOR HIT K.
C VZDA(K)     = VARIANCE ON DEVIATION IN RZ PLANE FOR HIT K.
C CXYA(K)     = COVARIANCE BETWEEN DEVIATION AND ANGLE IN XY PLANE.
C CZA(K)      = COVARIANCE BETWEEN DEVIATION AND ANGLE IN RZ PLANE.
C INCUT(I)    = .TRUE. IF COORDINATE I IS IN CUT (SEE MUFFLY).
C BADA(I)     = .TRUE. IF COORDINATE I IS BAD.
C G           = INVERSE ERROR MATRIX.
C DEVA        = CORRESPONDING DEVIATIONS.
C IPERM(K)    = USED TO PERMUTE LEFT/RIGHT AMBIGUITIES.
C MWORK       = USED BY MATRIX INVERTING ROUTINE AS WORKING SPACE.
C ITHISA(K)   = HIT NUMBER OF K'TH ASSOCIATED HIT.
C IJA(K)      = INDEX FOR K'TH ASSOCIATED HIT FOR ENTRY IN BANKS 2 & 3.
C EM1         = COPY OF RELEVANT PART OF ERROR MATRIX FOR TEST PURPOSES.
C EMG         = PRODUCT OF ERROR MATRIX AND ITS INVERSE. SHOULD BE UNIT
C                MATRIX. USED FOR TEST PURPOSES.
C ELIPSE      = TEMPORARY STORAGE FOR MULTIPLE SCATTERING ELIPSES.
C INCHAM      = LIST OF INEFFICIENT CHAMBERS ON THIS TRACK.
C INREG       = LIST OF INEFFICIENT REGIONS (PLANES) ON THIS TRACK.
C IAPPRO      = USED AS WORKING SPACE IN MUFFLX.
C HBADCH      = LIST OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C CTDASH(K)   = TRANSVERSE COORD. ESTIMATED FROM I.D. PROJECTION.
C CLDASH(K)   = LONGITUD'L COORD. ESTIMATED FROM I.D. PROJECTION.
C VTDASH(K)   = VARIANCE ON CTDASH.
C VLDASH(K)   = VARIANCE ON CLDASH (FOR K'TH ASSOCIATED HIT).
C
C-----------------------------------------------------------------------
C
C THE NEXT  380 LOCATIONS USED FOR VARIOUS IMPROVEMENTS TO MUFFLE, ETC.
C
C IHTREG      = FOR EACH ASSOCIATED HIT, THE REGION NO. IN WHICH
C               THE HIT OCCURS.
C LAYRAB      = ABSOLUTE NO. OF LAYERS WHICH HAVE ASSOCIATED HITS.
C IEFFRG      = LIST OF REGION NOS. OF THOSE REGIONS WHICH HAVE AN
C               ASSOCIATED HIT.
C   IHTPER = FLAG FOR EACH ASSOCIATED HIT TO TELL IF IT'S TO
C            GO FORWARD INTO THE CHI**2 CALCULATION . ONLY ONE
C            HIT PER LAYER IS TO BE USED ,APART FROM OVERLAP HITS.
C   IHTEMP = LIST OF HITS WHICH ARE TEMPORARILY IN THE HIT PERMUTATION
C            DUE TO OVERLAPS WITH THE CURRENT AMBIGUITYOF ONE OF THE
C            HITS IN IHTPER.
C   IPTEMP =  AS IHTEMP, BUT FOR L/R AMBIGUITIES.
C IOVLAP   =  MATRIX OF OVERLAP HITS. IOVLAP(I,J)=1 MEANS THAT THERE
C             IS AN OVERLAP BETWEEN ASSOCIATED HITS I & J ( I & J BOTH
C             IN THE RANGE 1 TO NTHIS ).
C AAA(K)      = TRANSFORMATION COEFF. A FOR K'TH ASSOCD. HIT.
C BBB(K)      = TRANSFORMATION COEFF. B FOR K'TH ASSOCD. HIT.
C CCC(K)      = TRANSFORMATION COEFF. C FOR K'TH ASSOCD. HIT.
C DDD(K)      = TRANSFORMATION COEFF. D FOR K'TH ASSOCD. HIT.
C
C DOVER, ETC. = STORES QUANTITIES LEFT OVER AFTER LEAVING LAST ABSORBER.
C
C X7          = VALUES OF SPECIAL VARIABLES AFTER LEAD-GLASS BARREL OR
C               YOKE END-PLUG - USED FOR RE-FITTING, ETC.
C
C-------------END OF MACRO CMUFWORK-------------------------------------
C   12/10/81 110152138  MEMBER NAME  CMUREG   (JADEMUS1)    FORTRAN
C------------START OF MACRO CMUREG--------------------------------------
C
      COMMON /CMUREG/NREGS,XRLO(100),XRHI(100),YRLO(100),YRHI(100),
     * ZRLO(100),ZRHI(100),HRMASK(100),HRFACE(100),HRTYPE(100),
     * HRORI(100),HRFIRS(100),HRLAST(100)
C
C NREGS IS NUMBER OF REGIONS.
C XRLO ETC. ARE REGION BOUNDARIES.
C HRMASK =1 (FACE 1), =2 (FACE 2), =4 (FACE 3), =8 (FACE 4), ETC.
C HRFACE = FACE NUMBER, =1-6 FOR -X,+X,-Y,+Y,-Z,+Z.
C HRTYPE =1, MU CHAMBER SENSITIVE REGION,
C        =2, CONCRETE REGION,
C        =3, IRON REGION,
C        =4, LEAD GLASS. (IRTYPE=4 USED ONLY IN MUFFLD.)
C HRORI  = ORIENTATION OF NORMAL, =1 (|| X), =2 (||Y), =3 (|| Z).
C HRFIRS = FIRST CHAMBER NUMBER.
C HRLAST = LAST CHAMBER NUMBER.
C
C------------END OF MACRO CMUREG----------------------------------------
C   12/10/81 110152138  MEMBER NAME  CMUSER   (JADEMUS1)    FORTRAN
C------START OF MACRO CMUSER--------------------------------------------
C
      COMMON /CMUSER/N1,N2,NPR,IPRINT,IPRINS,IREC,IHISTS,IJOIN,IRUN,
     * ITLFT,IOUT,LUNC,LUNE,LUNO
C
C------END OF MACRO MUSER-----------------------------------------------
C   12/10/81 110152138  MEMBER NAME  CMUSTAT  (JADEMUS1)    FORTRAN
C----------- START OF MACRO CMUSTAT ------------------------------------
C   LAST CHANGE 12.47 15/06/79 JOHN ALLISON.
C      /CMUSTT/
C
      COMMON / CMUSTT / MUTIT(100),NMU(100)
      REAL*8 MUTIT, MUT1(50), MUT2(50)
      EQUIVALENCE(MUTIT(1),MUT1(1)),(MUTIT(51),MUT2(1))
C
C  NMU ARE USED FOR STATISTICS COUNTING IN THE MUON ROUTINES
C
C------------ END OF MACRO CMUSTAT -------------------------------------
C   12/10/81 110152138  MEMBER NAME  CUNIT    (JADEMUS1)    FORTRAN
C---------------START OF MACRO CUNIT (LOGICAL UNIT NUMBERS)-------------
C
      COMMON /CUNIT/LUNMUC,LUNMUE
C
C LUNMUC  LOGICAL UNIT FOR MU CALIBRATION DATA.
C LUNMUE  LOGICAL UNIT FOR MU CALIBRATION DATA EDIT FILE.
C
C---------------END OF MACRO CUNIT--------------------------------------
C   12/10/81 110152138  MEMBER NAME  JCNCOM   (JADEMUS1)    FORTRAN
@-----------------------------------------------------------------------
COMMON Descriptions. ---------------------------------------------------
------------------------------------------------------------------------

   Common block CALIBR can be easily incorporated using %MACRO CMUCALIB
   on F22ALL.JADEMUS(CMUCALIB) .

      COMMON /CALIBR/ LARRY(100),MUCAL(4185)




                NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
                                                     19 WORDS

      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
 ----------------------------------------------------19 WORDS SO FAR

      HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
 ---------------------------------------------------389 WORDS SO FAR


      HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
 ---------------------------------------------------707 WORDS SO FAR

      HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
 ---------------------------------------------------953 WORDS SO FAR


      HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
 --------------------------------------------------1587 WORDS SO FAR

@
      HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
C ********* N.B. HMCEDM IS JUST A 'FILLER' . **********
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
 --------------------------------------------------3807 WORDS SO FAR

      HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
 --------------------------------------------------4124 WORDS SO FAR

      HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
 --------------------------------------------------4160 WORDS SO FAR


      HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
      IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
 --------------------------------------------------4170 WORDS SO FAR


     IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
     IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
     IEPIND,IEPSCT

      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
 --------------------------------------------------4185 WORDS SO FAR
@  DEFINITION OF CALIBRATION TERMS

  NVERSN           Version number.
  DESCRP           Description.

  HOVALL(IUNIT)    Overall translation of each unit along rails.
                     IUNIT=1 - far  side (-x) wall,
                     IUNIT=2 - near side (+x, rucksack) wall,
                     IUNIT=3 - magnet  (All translations are relative to
                               this so HOVALL(3) should ALWAYS be zero.)
                     IUNIT=4 - far  side (-x) arch,
                     IUNIT=5 - near side (+x) arch.

  IFRAME           Frame number.
  ICHAM            Chamber number.
  NFRAMS           Number of frames.
  NCHAMS           Number of chambers.

  Fixed Data For Each Frame....

  HFACE(IFRAME)    1-6 for -x,+x,-y,+y,-z,+z respectively.
                   =0 if frame not present.
  HSECT(IFRAME)    Section number of section to which frame belongsh
  HLAYER(IFRAME)   1-5 numbering from the interaction point outwardsh
                     =1, inside return yoke
                     =2-5 for layers on concrete,
  HNORM(IFRAME)    =1,normal of plane parallel to x-axis
                   =2,normal of plane parallel to y-axis
                   =3,normal of plane parallel to z-axis
  HLONG(IFRAME)    =1,wire nominally parallel to x-axis
                   =2,wire nominally parallel to y-axis
                   =3,wire nominally parallel to z-axis
  HTRANS(IFRAME)   =1,drift field parallel to x-axis
                   =2,drift field parallel to y-axis
                   =3,drift field parallel to z-axis
  HAC(IFRAME)      Chamber number of first chamber in frame.
  HAL(IFRAME)      Chamber number of last chamber in frame.
  HUNIT(IFRAME)    Unit to which this frame belongs.

  Survey Data For Each Frame....

  HDIST(IFRAME)     The coordinate of the central plane where the axis
                     specified by HNORM(IFRAME) cuts the plane(units mm)
  HANG(IFRAME)      The angle between the wire and the axis specified by
                     HLONG(IFRAME)  (units 1/10 mr)
  HCLLO(IFRAME)     Lower logitudinal coordinate limit
  HCLHI(IFRAME)     Upper logitudinal coordinate limit
  HCTLO(IFRAME)     Lower transverse coordinate limit
  HCTHI(IFRAME)     Upper transverse coordinate limit
                    (The above 4 variables apply to total sensitive area
                       of plane.They are in mm )

  Fixed Data For Each Wire....

  HFR(ICHAM)        Frame number for this chamber.

  Survey Data For Each Wire....

  HD1(ICHAM)        Amount to be added to HDIST(IFRAME) to get to
                     coordinate of the chamber.   (units mm)
@ HCTW(ICHAM)       Tranverse coordinate of each wire.  (units mm)

  Electronic Data For Chambers...

  HDTP(ICHAM)      Drift time pedestal (trans. clock units, ca. 60 ns.)
  HLTP(ICHAM)      Longitudinal time pedestal (in long. clock units,
                     ca. 0.5 ns. or 50 mm.)
  HLSF(J,ICHAM)    Long. scale factor for j'th hit
                     (units (1/100mm)/long. clock unit)
  HVDRFT(ICHAM)    Drift velocity (microns per clock unit (50 ns)).

                   The above data are used to convert signals to coor-
                     -dinates relative to the chamber as follows..
                   ICT = ( HVDRFT * (ITD-HDTP) )/1000
                   ICL = ( HLSF   * (ITL-HLTP) )/100
                     where ICT,ICL are coordinates in mm,
                     ITD is drift time in trans. clock units, and
                     ITL is long. time diff. in long. clock units.


  Status Data For The Chambers

  HMCSTA(ICHAM)    =0    if chamber ok
                   .NE.0 if chamber u/s for any reason.

------------------------------------------------------------------------
#include "cmutny.for"
    /CMUTNY/


  Condensed mu-filter paarameters for use by approximate signal to
    coordinate conversion subroutine MUTINY as used at the NORD.

  HPLANS      No. of chamber planes.
  HVDRAV      Average drift velocity.
  HDTPAV      Average drift time pedestal.
  HLTPAV      Average longitudinal time difference pedestal.
  HLSFAV      Average longitudinal scaling factor.

  FOR EACH CHAMBER PLANE...

  HLY         Layer number.
  HOR         Orientation parameter:
              =1, wires parallel to beam, and normal parallel to
                    x-axis - faces 1(-x) and 2(+x).
              =2, wires parallel to beam, and normal parallel to
                    y-axis - faces 3(-y) and 4(+y).
              =3, wires vertical, and normal parallel to z-axis -
                    faces 5(-z) and 6(+z).
  HC1         First chamber number.
  HCN0        Normal       )
  HCL0        Longitudinal )  coordinate of 'origin' of chamber plane.
  HCT0        Transverse   )
  HSP         Average spacing of chambers.

    (The 'origin' is at one end of the wire of the first chamber in the
  plane.  The end is that with the lowest longitudinal coordinate.)

      COMMON /CMUTNY/HPLANS,HVDRAV,HDTPAV,HLTPAV,HLSFAV,
     * HLY(48),HOR(48),HC1(48),HCN0(48),HCL0(48),HCT0(48),HSP(48)

------------------------------------------------------------------------

 MACRO CMUANP.
 -------------
  Mu analysis parameters filled by block data after MUINI.

      COMMON/CMUANP/IMUANP(30)
      DIMENSION AMUANP(30),HMUANP(60)
      EQUIVALENCE (IMUANP(1),AMUANP(1),HMUANP(1))

------------------------------------------------------------------------

 COMMON /CMUPRN/.
 ---------------

      COMMON /CMUPRN/MUPRIN

      MUPRIN=0 to suppress all printing of mu messages,
            .GE.1 to get mu error messages,
            .GE.2 to get mu information messages,
            .GE.10 to get full mu calibration printout (about 10 pages).

------------------------------------------------------------------------
End of COMMON Descriptions. --------------------------------------------
------------------------------------------------------------------------

C   20/03/84 711172327  MEMBER NAME  FWCHEV   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FWCHEV
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. OLSSON PREHISTORY :  DISPLAY FORWARD (TAGGING) SYSTEM
C
C        MOD: J. OLSSON   10/06/79 :  CHAMBER DISPLAY ADDED
C        MOD: J. OLSSON    4/10/83 :  CHAMBER DISPLAY REMOVED. (FWCHE0)
C        MOD: J. OLSSON    8/02/84 :
C        MOD: A. FINCH    12/03/84 :  UPDATED. SEE TAGG.S(TAGNOTE)
C        MOD: J. NYE      30/05/84 :  USES TAGMRK RATHER THAN TAGINT
C        MOD: C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS.
C   LAST MOD: C. BOWDERY   7/08/85 :  NEW TAGGING NAMES + TAGINT BACK
C   LAST MOD: J. OLSSON   23/10/85 :  PROPER HANDLING OF MC PEDESTALS
C
C
C        DISPLAY JADE FORWARD DETECTOR EVENT.
C        USED IN VIEWS NR 12(FW) 13(RU) AND COMMAND 58(FC)
C
C        1979-80 TAGGING APPARATUS
C        -------------------------
C
C        SUBTRACT A STANDARD PEDESTAL FROM LEAD GLASS, CONVERT TO MEV
C        WITH A STANDARD FACTOR 5.0      STANDARD PEDESTAL = 500 COUNTS
C        WITH A STANDARD FACTOR 7.5, PEDESTAL = 50 COUNTS AFTER RUN 278200002600
C
C        1981-82,83.. TAGGING APPARATUS
C        ------------------------------
C
C        CHANGED TO USE THE CALIBRATION OF A.FINCH, FOR 1981-82 AND 198300003100
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgraph.for"
#include "chsym.for"
#include "cgeo1.for"
#include "cgeo2.for"
#include "cgeo3.for"
#include "cwktag.for"
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CHEADR / HEAD(108)
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,X3,Y3,X4,Y4,
     +                  HMW(132)
C
      DIMENSION  NPBPED(3),PBGCAL(3)
C
      DATA NPBPED / 500, 50 ,0/, PBGCAL / 5.0, 7.5 ,5.5/
C
C------------------  C O D E  ------------------------------------------
C
C
      IPNTR = IDATA(IBLN('ATAG'))
      IF( IPNTR .LT. 1 ) GO TO 300
C
CCC                        USE TAGMRK SO THAT WE CAN ALSO HANDLE MC DATA
CCC
CCC   CALL TAGMRK(*300)
C
C                          USE TAGINT ONCE TO INITIALISE CWKTAG
C
      CALL TAGINT(*300)
C
      ADDEND = 84.0 * BLFI
      FDX    = 0.0
      ADY    = 0.0
      FACTFW = 1.0
      SH3    = 0.75 * FENDC
      IF( LASTVW .NE. 12 ) GO TO 2
C
C                           FW VIEW (12)
C
      FDX    = -(XMAX - XMIN) * 0.25
      FACTFW = 1.5
      SH3    = 0.70 * FENDC
   2  CONTINUE
      IF( LASTVW .NE. 13 ) GO TO 3
C
C                            RU VIEW (13)
C
      IF ( MARK .EQ. 2 ) SH3 = FENDC
      FACTFW = 2.0
      ADY    = 900.0
      FDX    = 0.5 * ADDEND
C
   3  IF( MARK .EQ. 1 ) GO TO 1111
      IF( MARK .NE. 0 ) GO TO 2222
C
C                            ENTER HERE FOR 1979-80 APPARATUS
C
      NBLIM = 190
      IRUN  = 1
C
C                            NO PROVISION FOR THIS IN TAGMRK SCHEME
C
      IF ( HEAD(18) .GT. 2781 ) IRUN = 2
      IF ( IMC .EQ. 1 ) IRUN = 3
C--
C  LOOP OVER BLOCK HITS, GET BLOCK NUMBER NB AND PULSEHEIGHT HPH
C     SUBTRACT PEDESTAL AND MULTIPLY WITH GAIN, STORE IN CATAG ARRAY
C--
      IADD   = 2 * IPNTR + 6
      IFLUMI = IADD + HDATA( IADD - 1 )
  200 CONTINUE
      IADD   = IADD + 1
      IF( IADD .GE. IFLUMI ) GO TO 210
C
      NB   = HDATA(IADD)
      IADD = IADD + 1
      IF( NB .EQ. 0 ) GO TO 200
      IF( NB .GT. 190 ) GO TO 200
      CATAG(NB) = 0.0
      IF( NB .GT.  46 .AND. NB .LT.  49 ) GO TO 200
      IF( NB .GT.  94 .AND. NB .LT.  97 ) GO TO 200
      IF( NB .GT. 142 .AND. NB .LT. 145 ) GO TO 200
      HPH = HDATA(IADD)
      HPH = HPH - NPBPED(IRUN)
      IF ( HPH .LT. 0 ) HPH = 0
      CATAG(NB) = HPH * PBGCAL(IRUN)
      GO TO 200
C
C
C
C
C----------------------------------------1981/82 APPARATUS ONLY---------
C
C
C                            ENTER HERE FOR 1981-82 APPARATUS
C
 1111 CONTINUE
C     IF( MARK .NE. 1 ) GO TO 2222
C
      NBLIM = 64
      CALL TAGADC(0,*300)
      CALL TAGPED
      CALL TAGKAL(0)
      GO TO 210
C
C
C
C----------------------------------------1983    APPARATUS ONLY---------
C
C
C                            ENTER HERE FOR 1983-.. APPARATUS
C
2222  CONTINUE
      IF( MARK .NE. 2 ) GO TO 999
C
      CALL TAGADC(0,*300)
      CALL TAGPED
      CALL TAGKAL(0)
      NBLIM = IENDPZ
C
C   DISPLAY LOOP FOR 1983-..  LEAD SCINTILLATOR ELEMENTS
C
      NTAGK=IENDMZ
C
C CHECK THE MAGNIFICATION, TO CHOOSE BETWEEN CRICRO AND PHNUMB
C
      IMAGOK = 0
      DELTX = ABS(XMAX-XMIN)
      IF ( DELTX .LT. 5000.0 .AND. LSTCMD .NE. 58 ) IMAGOK = 1
      IF ( DELTX .LT. 3000.0 .AND. LSTCMD .EQ. 58 ) IMAGOK = 1
C
      DO 400  NB = 1,NBLIM
      IF( CATAG(NB) .LT. 1.0 ) GO TO 400
C GET CORNER COORDINATES OF UNIT
      CALL XYTAG(NB,XTAG,YTAG,SLOTAG)
      ADX = FDX
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 12 ) ADX = -FDX
      IF ( LASTVW .EQ. 13 ) ADX = FDX - 750.0
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 13 ) ADX = FDX + 750.0
      IF( IMAGOK .EQ. 0 ) GO TO 399
      X1 = -XTAG * FACTFW + ADX
      Y1 =  YTAG * FACTFW + ADY
      IPH = CATAG(NB)
      CALL PHNUMB(IPH,SH3,SLOTAG)
      GO TO 400
399   X1 = -X1 * FACTFW
      X2 = -X2 * FACTFW
      X3 = -X3 * FACTFW
      X4 = -X4 * FACTFW
      Y1 =  Y1 * FACTFW
      Y2 =  Y2 * FACTFW
      Y3 =  Y3 * FACTFW
      Y4 =  Y4 * FACTFW
      CALL CRICRO(ADX,ADY)
400   CONTINUE
      GO TO 300
C
C
C
C----------------------------------------1979-82 DETECTORS ONLY---------
C
C
210   CONTINUE
C
C   DISPLAY LOOP FOR 1979-82  LEAD GLASS CAPS
C
      NTAGK=96
      IF ( MARK .EQ. 1 ) NTAGK = 32
C
      DO 333  NB = 1,NBLIM
      IF( CATAG(NB) .LT. 1.0 ) GO TO 333
      INB = NB
      IF ( MARK .EQ. 1 ) INB = NB - 1
C GET CENTER COORDINATES OF BLOCK
      CALL XYTAG(INB,XTAG,YTAG,SLOTAG)
      ADX = FDX
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 12 ) ADX = -FDX
      IF ( LASTVW .EQ. 13 ) ADX = FDX - 1100.0
      IF ( NB .GT. NTAGK .AND. LASTVW .EQ. 13 ) ADX = FDX + 1100.0
C  OBS THAT COORDINATES FOR X IN 1979-82 ALREADY HAVE REVERSED SIGN, FOR
C   DISPLAY IN POSITIVE SYSTEM
      X1 = -XTAG + ADX - 0.40 * FENDC
      Y1 =  YTAG + ADY - 0.40 * FENDC
      IPH = CATAG(NB)
      CALL PHNUMB(IPH,SH3,SLOTAG)
333   CONTINUE
C
  300 CONTINUE
      RETURN
 999  CONTINUE
      WRITE(6,6712)
6712  FORMAT('   ERROR RETURN FROM FWCHEV ')
      RETURN
      END

C   07/06/96 606071853  MEMBER NAME  ITODA    (S4)          FORTG1
      SUBROUTINE ITODA(I,R,M)
      REAL*8 R,S,B/'        '/
      LOGICAL*1 LS(8),LCH(10)/'0','1','2','3','4','5','6','7','8','9'/
      EQUIVALENCE (S,LS(1))
      N=IABS(M)
      J=IABS(I)
      S=B
      IF(J.EQ.0.AND.M.GT.0) GOTO 100
      DO 10 L=1,N
      K=J
      J=J/10
      K=K-J*10
      LS(N+1-L)=LCH(K+1)
      IF(J.EQ.0) GOTO 100
   10 CONTINUE
  100 R=S
      RETURN
      END

C   05/12/84 508151400  MEMBER NAME  TAGFTY   (S)           FORTRAN
C
C
C-----------------------------------------------------------------------
      FUNCTION TAGFTY(IN,ONIN)
C-----------------------------------------------------------------------
C
C
C   TAGFTY FINDS THE FI-TYPE  OF  ADC  I
C   RELATIVE TO  ADC  ONE(SOFTWARE ADDRESSES) :
C
C   FI-TYPE = 1   FOR BLOCKS IN THE  - FI  DIRECTION FROM BLOCK 'ONE'
C           = 2   FOR BLOCKS IN THE SAME FI  DIRECTION AS BLOCK 'ONE'
C           = 3   FOR BLOCKS IN THE  + FI  DIRECTION FROM BLOCK 'ONE'
C
C   VALID FOR 1983 --> DETECTOR ONLY
C
C
C---------------------------------------------------------------------
C
      INTEGER  ONE, ONIN
C
C-------------------------  C O D E  ---------------------------------
C
      ONE = ONIN
      I   = IN
C
C---                          SUBTRACT 8 UNTIL  1 <=  I  <= 8
C
       DO 10 J = 1 , 5
          IF ( I .LE. 8 ) GOTO 11
          I = I - 8
   10  CONTINUE
   11  CONTINUE
C
C---                          SUBTRACT 8 UNTIL  1 <= ONE <= 8
C
       DO 12 J = 1,5
          IF ( ONE .LE. 8 ) GOTO 13
          ONE = ONE - 8
   12  CONTINUE
   13  CONTINUE
C
C---                          SPECIAL CASE FOR END BLOCKS
C
      IF ( ( ONE .EQ. 1 ) .AND. ( I .EQ. 8 )  ) I = 0
      IF ( ( ONE .EQ. 8 ) .AND. ( I .EQ. 1 )  ) I = 9
C
      TAGFTY = (I - ONE ) + 2
C
C
      RETURN
      END

C   20/10/81 406182141  MEMBER NAME  MUPIC    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUPIC
C-----------------------------------------------------------------------
C
C LAST CHANGE 21.00 18/06/84 CHRIS BOWDERY - DRAW NOTHING IF NO CAL.
C      CHANGE 12.15  9/04/83 CHRIS BOWDERY - USE NEW MUFSTA FOR BODGE
C      CHANGE 12.30 31/03/82 HUGH MCCANN   - MODIFY BAD CHAMBER BODGE.
C      CHANGE 14.30 16/03/82 HUGH MCCANN   - TO BODGE GRAPHICS LIKE
C                                            MUCOOR RE DEAD CHAMS.
C      CHANGE 08.30 14/10/81 HUGH MCCANN   - TO DRAW (LONG) BASE OF YOKE
C      CHANGE 11.30 11/10/81 HUGH MCCANN   - TO DRAW Z-ENDS OF WIRES.
C      CHANGE 19.55 22/04/80 JOHN ALLISON  - TO DASH THE DEAD CHAMBERS.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C
C------------------  C O D E  ------------------------------------------
C
      IPHEAD = IDATA(IBLN('HEAD'))
      IMONTH = HDATA(2*IPHEAD+7)
      IYEAR  = HDATA(2*IPHEAD+8)
      KRUN   = HDATA(2*IPHEAD+10)
      KREC   = HDATA(2*IPHEAD+11)
C
C                           FIX UP GRAPHICS PICTURE. DEAD CHAMBER BODGE.
C
      CALL MUFSTA( IMONTH, IYEAR )
C
C
      IF((LASTVW.LT.1).OR.(LASTVW.GT.11)) RETURN
      IVWN=3
      IF(LASTVW.GT.3) IVWN=2
      IF(LASTVW.GT.7) IVWN=1
C
C                            NO CALIBRATION? THEN RETURN
C
      IF( IZOEP1 .EQ. 0  .AND.  IZOEP3 .EQ. 0 ) RETURN
C
C
C
C                       IVWN = 1,2,3 FOR ZY,ZX,XY VIEWS RESPECTIVELY.
C
      GO TO (1,2,3),IVWN
C
 1    CONTINUE
C ZY VIEW - NO WIRES.
C FACE 3 AND 4 BLOCKS.
      X1=0.
      X2=0.
      DO 11 IFACE=3,4
      Z1=HBLLO(IFACE)
      Z2=HBLHI(IFACE)
      J=6*IFACE-5
      DO 11 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 11   CONTINUE
C FACE 5 AND 6 BLOCKS.
      DO 12 IFACE=5,6
      Y1=HBLLO(IFACE)
      Y2=HBLHI(IFACE)
      J=6*IFACE-5
      DO 12 IBLOCK=1,3
      Z1=HBNLIM(J)
      Z2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 12   CONTINUE
C
C DRAW YOKE.
      DO 19 I=1,2
      S=-1.
      IF(I.EQ.2)S=1.
      CALL MOVEA(FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(FLOAT(IZOEP5),S*IREP4)
      IF(S)14,14,16
   14 IYKLDM=HYKLDM(3)
      CALL DRAWA(FLOAT(IZOEP5),S*IXYEP5)
      CALL DRAWA(FLOAT(IYKLDM),S*IXYEP5)
      CALL DRAWA(FLOAT(IYKLDM),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IYKLDM),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IYKLDM),S*IXYEP5)
      CALL DRAWA(-FLOAT(IZOEP5),S*IXYEP5)
      GO TO 18
   16 CALL DRAWA(FLOAT(IZOEP5),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IZOEP5),S*HYKNMO(2))
   18 CALL DRAWA(-FLOAT(IZOEP5),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(-FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP1),S*IREP1)
 19   CONTINUE
      IFLO=3
      IFHI=6
      GO TO 4
C
 2    CONTINUE
C ZX VIEW - END WALL WIRES DISPLAYED.
      DO 21 ICHAM=443,634
      CALL MUWIRE(ICHAM,X,Y,Z)
      IF(HMCSTA(ICHAM).EQ.0)GO TO 201
      CALL XYMUD(X-150.,Y,Z,XS,YS)
      CALL MOVEA(XS,YS)
      CALL XYMUD(X+150.,Y,Z,XS,YS)
      CALL DASHA(XS,YS,45)
      GO TO 21
 201  CONTINUE
      CALL XYMUD(X,Y,Z,XS,YS)
      CALL POINTA(XS,YS)
 21   CONTINUE
C FACE 1 AND 2 BLOCKS.
      Y1=0.
      Y2=0.
      DO 22 IFACE=1,2
      Z1=HBLLO(IFACE)
      Z2=HBLHI(IFACE)
      J=6*IFACE-5
      DO 22 IBLOCK=1,3
      X1=HBNLIM(J)+HOVALL(IFACE)
      X2=HBNLIM(J+1)+HOVALL(IFACE)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 22   CONTINUE
C FACE 5 AND 6 BLOCKS - LEFT.
      DO 23 IFACE=5,6
      X1=HBTLO(IFACE)+HOVALL(4)
      X2=-50+HOVALL(4)
      J=6*IFACE-5
      DO 23 IBLOCK=1,3
      Z1=HBNLIM(J)
      Z2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 23   CONTINUE
C FACE 5 AND 6 BLOCKS - RIGHT.
      DO 24 IFACE=5,6
      X1=50+HOVALL(5)
      X2=HBTHI(IFACE)+HOVALL(5)
      J=6*IFACE-5
      DO 24 IBLOCK=1,3
      Z1=HBNLIM(J)
      Z2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 24   CONTINUE
C
C DRAW YOKE .
      DO 41 I=1,2
      S=-1.
      IF(I.EQ.2)S=1.
      CALL MOVEA(FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(FLOAT(IZOEP5),S*IREP4)
      CALL DRAWA(FLOAT(IZOEP5),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IZOEP5),S*HYKNMO(2))
      CALL DRAWA(-FLOAT(IZOEP5),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP4)
      CALL DRAWA(-FLOAT(IZOEP3),S*IREP2)
      CALL DRAWA(-FLOAT(IZOEP1),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP1)
      CALL DRAWA(-FLOAT(IZEII),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(-FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IXYEP5)
      CALL DRAWA(FLOAT(IZEIO),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP3)
      CALL DRAWA(FLOAT(IZEII),S*IREP1)
      CALL DRAWA(FLOAT(IZOEP1),S*IREP1)
 41   CONTINUE
      IFLO=1
      IFHI=2
C
  4   CONTINUE
C  DRAW LONGITUDINAL SENSITIVE LIMITS (ZY * ZX VIEWS ONLY ).
C  XS--- * YS--- REFER TO HORIZL * VERTL COORDS ON SCREEN.
C
      DO 49 IFACE=IFLO,IFHI
          DO 49 ILAYER=1,5
              IF(IFACE.GT.4.AND.ILAYER.EQ.1)GO TO 49
              DO 47 IFRAME=1,82
                  IFR=IFRAME
                  IF(HFACE(IFR).NE.IFACE)GO TO 47
                  IF(HLAYER(IFR).NE.ILAYER)GO TO 47
                  IF(IFACE.GT.4)GO TO 45
  43              CONTINUE
                  XSLO=HCLLO(IFR)
                  XSHI=HCLHI(IFR)
                  YSFIXD=HDIST(IFR)
                  IF(IFACE.LE.2.AND.ILAYER.GT.1)
     *            YSFIXD=YSFIXD+HOVALL(IFACE)
                  CALL MOVEA(XSLO+20.,YSFIXD-20.)
                  CALL DRAWA(XSLO    ,YSFIXD-20.)
                  CALL DRAWA(XSLO    ,YSFIXD+20.)
                  CALL DRAWA(XSLO+20.,YSFIXD+20.)
                  CALL MOVEA(XSHI-20.,YSFIXD-20.)
                  CALL DRAWA(XSHI    ,YSFIXD-20.)
                  CALL DRAWA(XSHI    ,YSFIXD+20.)
                  CALL DRAWA(XSHI-20.,YSFIXD+20)
                  IF(IFACE.NE.4)GO TO 49
                  IF(ILAYER.EQ.1.OR.ILAYER.EQ.2)GO TO 49
                  IF(IFR.EQ.47.OR.IFR.EQ.55.OR.IFR.EQ.63)GO TO 49
                  IFR=IFR+4
                  GO TO 43
   45             XSFIXD=HDIST(IFR)
                  YSLO=HCLLO(IFR)
                  YSHI=HCLHI(IFR)
                  CALL MOVEA(XSFIXD-20.,YSLO+20.)
                  CALL DRAWA(XSFIXD-20.,YSLO    )
                  CALL DRAWA(XSFIXD+20.,YSLO    )
                  CALL DRAWA(XSFIXD+20.,YSLO+20.)
                  CALL MOVEA(XSFIXD-20.,YSHI-20.)
                  CALL DRAWA(XSFIXD-20.,YSHI    )
                  CALL DRAWA(XSFIXD+20.,YSHI    )
                  CALL DRAWA(XSFIXD+20.,YSHI-20.)
                  GO TO 49
   47         CONTINUE
   49 CONTINUE
      GO TO 99
C
 3    CONTINUE
C XY VIEW - WIRES IN 'BARREL'.
      DO 31 ICHAM=1,442
      CALL MUWIRE(ICHAM,X,Y,Z)
      IF((ICHAM.GE.323.AND.ICHAM.LE.346)
     * .OR. (ICHAM.GE.371.AND.ICHAM.LE.394)
     * .OR. (ICHAM.GE.419.AND.ICHAM.LE.442))Y=Y+10.
      IF(HMCSTA(ICHAM).EQ.0)GO TO 301
      IFRAME=HFR(ICHAM)
      IF(HTRANS(IFRAME).GT.1)GO TO 302
      CALL XYMUD(X-150.,Y,Z,XS,YS)
      CALL MOVEA(XS,YS)
      CALL XYMUD(X+150.,Y,Z,XS,YS)
      CALL DASHA(XS,YS,45)
      GO TO 31
 302  CONTINUE
      CALL XYMUD(X,Y-150.,Z,XS,YS)
      CALL MOVEA(XS,YS)
      CALL XYMUD(X,Y+150.,Z,XS,YS)
      CALL DASHA(XS,YS,45)
      GO TO 31
 301  CONTINUE
      CALL XYMUD(X,Y,Z,XS,YS)
      CALL POINTA(XS,YS)
 31   CONTINUE
C FACE 1 AND 2 BLOCKS.
      Z1=0.
      Z2=0.
      DO 32 IFACE=1,2
      Y1=HBTLO(IFACE)
      Y2=HBTHI(IFACE)
      J=6*IFACE-5
      DO 32 IBLOCK=1,3
      X1=HBNLIM(J)+HOVALL(IFACE)
      X2=HBNLIM(J+1)+HOVALL(IFACE)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 32   CONTINUE
C FACE 3 BLOCKS.
      X1=HBTLO(3)
      X2=HBTHI(3)
      J=13
      DO 33 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 33   CONTINUE
C FACE 4 BLOCKS.
      X1=HBTLO(4)+HOVALL(4)
      X2=-50+HOVALL(4)
      J=19
      DO 34 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 34   CONTINUE
      X1=50+HOVALL(5)
      X2=HBTHI(4)+HOVALL(5)
      J=19
      DO 35 IBLOCK=1,3
      Y1=HBNLIM(J)
      Y2=HBNLIM(J+1)
      CALL XYMUD(X1,Y1,Z1,XLO,YLO)
      CALL XYMUD(X2,Y2,Z2,XHI,YHI)
      CALL MUVIER(XLO,YLO,XHI,YHI)
      J=J+2
 35   CONTINUE
C
C DRAW YOKE.
      XLO=HYKNMI(1)
      CALL MUVIER(XLO,XLO,-XLO,-XLO)
      XLO=HYKNMO(1)
      CALL MUVIER(XLO,XLO,-XLO,-XLO)
C
      GO TO 99
C
 99   CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE MUVIER(XLO,YLO,XHI,YHI)
C DRAWS A RECTANGLE.
      CALL MOVEA(XLO,YLO)
      CALL DRAWA(XLO,YHI)
      CALL DRAWA(XHI,YHI)
      CALL DRAWA(XHI,YLO)
      CALL DRAWA(XLO,YLO)
      RETURN
      END

      SUBROUTINE SRTREL
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cdata.for"
#include "ccycp.for"
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
     ,         , (ITR   ,IDWRK(7)),(ITRNG ,IDWRK(8))
#include "cpatlm.for"
      DATA MKTREL / Z3000/
      DATA MKLBTC / ZFFF/
      DATA MKLFTR / Z 30000/, MKRGHT / Z20000/
      INTEGER  MKLRHT(3) / Z800, Z0, Z900/
      DATA LBZRCR / Z100/
      DATA NANF /0/
      IF(NANF.EQ.0) IQPATR= IBLN('PATR')
      NANF = 1
      IPPATR = IDATA(IQPATR)
          HPFRE0 = HPFREE
          CALL PRHTAR
      IF(
     - NHIT.GE.5
     -)THEN
            CALL FLINEL
            CALL FTRKEL
      IF(
     - NTRKEL.GT.0
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
            NLINUC = 0
      DO 13000 IP=HPHT0,HPHT9,HLDHT
              IF(IWRK(IP+9).EQ.0 .AND. LAND(IWRK(IP+4),7).NE.0)
     .        NLINUC = NLINUC + 1
13000 CONTINUE
13001 CONTINUE
            IDATA(IPPATR+7) = IDATA(IPPATR+7) + NLINUC
      ENDIF
          HPFREE = HPFRE0
      RETURN
17000 CONTINUE
        ICLL16 = (ICELL-1) * 16
        NTRCLL = 0
      DO 13002 IPTR = HPTR0,HPTR9,HLDTR
      IF(
     - ITR.LE.200 .AND. ITRNG.LT.128
     -)THEN
      IF(
     - LAND(IWRK(IPTR+15),MKTREL).NE.0
     -)THEN
            NTRCLL = NTRCLL + 1
            LB = LAND(IWRK(IPTR+15),MKLBTC)
            DRSP1 = WRK(IPTR+ 8)
            DRSP2 = WRK(IPTR+11)
            IF(DRSP1*DRSP2.LT.0) LB = LOR(LB,LBZRCR)
            LBLR = LAND(IWRK(IPTR+15),MKLFTR)
            IF(DRSP1.LT.0..AND.LBLR.NE.0.AND.LBLR.NE.MKLFTR)
     .         LBLR = LXOR(LBLR,MKLFTR)
            LB = LOR(LB,ISHFTR(LBLR,6))
            ITRKAR(ITR, 1) = ICELL
            ITRKAR(ITR, 2) = IWRK(IPTR+ 2)
            ITRKAR(ITR, 3) = IWRK(IPTR+ 7)
            TRKAR (ITR, 4) = ABS(DRSP1)
            DRSL1          = WRK(IPTR+ 9)
            IF(DRSP1.LT.0.)  DRSL1 =-DRSL1
            TRKAR (ITR, 5) = DRSL1
            ITRKAR(ITR, 6) = IWRK(IPTR+10)
            TRKAR (ITR, 7) = ABS(DRSP2)
            DRSL2          = WRK(IPTR+12)
            IF(DRSP2.LT.0.)  DRSL2 =-DRSL2
            TRKAR (ITR, 8) = DRSL2
            ITRKAR(ITR, 9) = LB
            ITRKAR(ITR,10) = ITRNG
            IDXLR =-1
            IF(LBLR.EQ.MKRGHT) IDXLR = 1
            IF(DRSP1.LT.0.) IDXLR =-IDXLR
            IDXLR1 = IDXLR
            ILAYZ =-1
      DO 13004 IP=HPHT0,HPHT9,HLDHT
      IF(
     - IWRK(IP+9).EQ.IPTR .OR.IWRK(IP+10).EQ.IPTR
     -)THEN
                DRSP = WRK(IP+2)
            IF(IWRK(IP+10).EQ.IPTR .AND. TBIT(IWRK(IP+4),20)) DRSP=-DRSP
                IF(DRSP.NE.0.) IDXLR1 = IDXLR
      IF(
     - DRSP*DRSP1.LT.0.
     -)THEN
                  IDXLR1 =-IDXLR
                  IF(ILAYZ.LT. 0) ILAYZ = IWRK(IP)
      ENDIF
                IPLBHT = (IWRK(IP+1) - HPTSEC(1))/2 + HPHL0
                LBHIT = ITRNG*2
                LBHIT = LOR(LBHIT,MKLRHT(IDXLR1+2))
      IF(
     - HWRK(IPLBHT).EQ.0
     -)THEN
                  HWRK(IPLBHT) = LBHIT
      ELSE
                  IF(HWRK(IPLBHT+1).EQ.0) HWRK(IPLBHT+1) = LBHIT
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
            IF(LAND(LB,LBZRCR).NE.0 .AND. ILAYZ.LT.0)
     .                                    ILAYZ = IWRK(IPTR+10) + 1
            IF(ILAYZ.LT.0) ILAYZ = 0
            ITRKAR(ITR,11) = ILAYZ
            ITR   = ITR   + 1
            ITRNG = ITRNG + 1
      ENDIF
      ENDIF
13002 CONTINUE
13003 CONTINUE
      GOTO IZZZ01
      END

C   07/06/96 606071851  MEMBER NAME  ILOC     (S4)          FORTG1
      FUNCTION   ILOC(NA,NB,NC)
C     BOS SUBPROGRAM =0.2=
#include "acs.for"
      COMMON/BCS/IW(1)
      EQUIVALENCE (XNAME,INAME)
      REAL FF/Z000000FF/
      INTEGER ISTAR/Z0000005C/
      REAL AND
      EXTERNAL AND
C
C
      IF(NA.EQ.0) GOTO 70
    1 IF(NC+4.EQ.0) GOTO 60
    2 IW(INAMV)=NA
      LFDI=MOD(IABS(NAMEV),NPRIM)+NAMAX1
    4 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 4
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      LFDK=LFDI+1
      LFDI=IW(LFDI)
    6 IF(LFDI.EQ.0)     GOTO 30
      IF(IW(LFDI-2)-NB) 8,10,30
    8 LFDK=LFDI
      LFDI=IW(LFDI-1)
      GOTO 6
C
C     BANK FOUND --------------
   10 ILOC=LFDI
      IF(NC) 12,100,20
   12 IF(NC+3.EQ.0) GOTO 40
      IF(NC+4.EQ.0) GOTO 90
C     DELETE BANK
      NN=4+IW(LFDI)
      IW(LFDI  )=-NN
      IW(LFDK-1)=IW(LFDI-1)
      INAME=NA
      XNAME=AND(XNAME,FF)
      IF(INAME.EQ.ISTAR) NCPL=NCPL-NN
      IF(LFDI+NN-3.NE.NEXT) GOTO 14
      NEXT=NEXT-NN
      GOTO 16
   14 NFRE=NFRE+NN
      ILOW=MIN0(ILOW,ILOC)
   16 IF(NC+2.NE.0) GOTO 100
C     RESTRICTED GARBAGE COLLECTION
      JLOW=ILOW
      II=LFDI
      ILOW=II
      CALL BGAR(IGA)
      ILOC=0
      IF(JLOW.LT.II) ILOW=JLOW
      GOTO 100
C     CHANGE LENGTH, IF DIFFERENT
   20 NW=NC-IW(LFDI)
      IF(NW.EQ.0) GOTO 100
      IF(LFDI+IW(LFDI)+1.EQ.NEXT) GOTO 50
      IF(NW) 22,100,40
   22 IF(NW+4.GT.0) GOTO 40
      IW(LFDI)=NC
      KND=LFDI+NC+4
      ILOW=MIN0(ILOW,KND)
      IW(KND)=NW
      NFRE=NFRE-NW
      GOTO 56
C
C     BANK NOT FOUND ----------
   30 LFDI=0
      IF(NC+4.EQ.0) GOTO 62
      IF(NC.LE.0) GOTO 90
      INAME=NA
      XNAME=AND(XNAME,FF)
C     CREATE BANK
      NN=4+NC
      IF(NEXT+NN.GE.NLST) GOTO 80
   32 IF(INAME.NE.ISTAR) GOTO 36
      IF(NCPL+NN.LT.NSPL) GOTO 34
      NHISTL(11)=NHISTL(11)+1
      GOTO 90
   34 NCPL=NCPL+NN
   36 ILOC=NEXT+3
      ISV =IW(LFDK-1)
      IW(LFDK-1)=ILOC
      IW(ILOC-3)=NA
      IW(ILOC-2)=NB
      IW(ILOC-1)=ISV
      IW(ILOC  )=NC
      NEXT=NEXT+NN
      LIND=ILOC
      CALL VZERO(IW(ILOC+1),NN)
      GOTO 100
C     MOVE BANK
   40 IF(NEXT+4+MAX0(IW(LFDI),NC).GE.NLST) GOTO 80
      NN=4+IW(LFDI)
      CALL UCOPY2(IW(LFDI-3),IW(NEXT),NN)
      ILOW=MIN0(ILOW,LFDI)
      ILOC=NEXT+3
      IW(LFDI  )=-NN
      IW(LFDK-1)=ILOC
      NEXT=NEXT+NN
      NFRE=NFRE+NN
      IF(NC+3.EQ.0) GOTO 100
C     CHANGE LAST BANK
   50 IF(INAME.NE.ISTAR) GOTO 54
      IF(NCPL+NW.LT.NSPL) GOTO 52
      NHISTL(11)=NHISTL(11)+1
      GOTO 90
   52 NCPL=NCPL+NW
   54 IW(ILOC)=IW(ILOC)+NW
      NEXT=NEXT+NW
      IF(NW.GT.0) CALL VZERO(IW(ILOC+NN-3),NW)
   56 IF(INAME.EQ.ISTAR) NCPL=NCPL+NW
      GOTO 100
C
C     RENAME
   60 KK=LFDK
      II=LFDI
      NL=0
      INAME=IW(II-3)
      XNAME=AND(XNAME,FF)
      IF(INAME.EQ.ISTAR) NL=-IW(II)-4
      GOTO 2
   62 IW(KK-1)=IW(LFDI-1)
      IW(II-1)=IW(LFDK-1)
      IW(LFDK-1)=II
      IW(II-3)=NA
      IW(II-2)=NB
      ILOC=II
      INAME=NA
      XNAME=AND(XNAME,FF)
      IF(INAME.EQ.ISTAR) NL=NL+IW(II)+4
      NCPL=NCPL+NL
      GOTO 100
C
C     LOCATE BUFFER SPACE
   70 IF(NB.NE.0.OR.NC.NE.0) GOTO 1
      ILOC=NEXT
      IW(ILOC)=NLST-NEXT-4
      GOTO 100
C
C
   80 NHISTH(11)=NHISTH(11)+1
   90 ILOC=0
  100 RETURN
      END

C   12/03/84 406222054  MEMBER NAME  CLUSFN   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
       SUBROUTINE CLUSFN(ISTART,IEND,THRESH,IWRITE)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE FINDS THE CLUSTERS IN THE TAGGING SYSTEM
C BY LOOKING FOR BLOCKS WITH LOTS OF ENERGY AND ASSUMING ALL
C ITS NEIGHBOURS ARE POTENTIAL MEMBERS OF THE CLUSTER AND THERFORE
C CAN'T BE PARENTS OF ANOTHER CLUSTER.
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "comtag.for"
C
#include "cwktag.for"
C
       DIMENSION FOUND(90)
       DIMENSION FLIST(64)
C
C CLEAR CMAP,FOUND,FLIST
C
       DO  9 I = 1,10
          DO  9 J = 1,9
             CMAP(I,J) = 0.0
    9  CONTINUE
       NUM = IEND - ISTART + 1
       DO 1 N = 1,NUM
          FOUND(N)     = 0.0
          FLIST(N)     = 0.0
          FLIST(N + NUM) = 0.0
    1  CONTINUE
       NCLST = 0
       K     = 1
C
C
C MAIN LOOP >>
C
C
    4  DO 10 I = ISTMZ    ,IENDMZ
C
C CHECK IF WE HAVE ALREADY USED THIS ADC
C A 'PARENT' CANT BE THE NEIGHBOUR OF ANOTHER CLUSTER
C
          DO 5 J = 1,K
             IF ( SADC(I,1) .EQ. FOUND(J) ) GOTO 10
    5     CONTINUE
C
C CHECK IF ENERGY IS BELOW THRESHOLD TO CALL IT A CLUSTER
C
          IF ( SADC(I,2) .LT. THRESH ) GOTO 11
C
C CLUSTER FOUND - STORE THE INFORMATION
C
          NCLST = NCLST + 1
          IF ( NCLST .GT. 10 ) GOTO 999
C
C PARENT ADC IS FIRST MEMBER OF CLUSTER MAP
C
          CMAP(NCLST,1) = SADC(I,1)
C
C NO OF NEIGHBOURS = NNEI  FOUND FROM NEIGHBOUR LIST
C
          NFADC = SADC(I,1)
C
C
          NNEI = NLIST(NFADC,1,MARK)
C
C
          IELOOP = NNEI + 1
C
C NLIST 2 TO NLIST (2 + NNEI) CONTAIN THE ADDRESSES ( IN CATAG)
C OF NEIGHBOURS OF THIS 'PARENT'
C
          DO 20 L = 2, IELOOP
C
C ADC NO. OF NEIGHBOUR = NADC
C
             NADC = NLIST(NFADC,L,MARK)
C
C FILL CLUSTER MAP
C
             CMAP(NCLST,L) = NADC
C
C SAVE ADC ADDRESSES USED,SO THEY CANT BECOME PARENTSOF LATER CLUSTERS
C
             FOUND(K) = NADC
C
             K = K + 1
             IF ( K .GT. 90 ) GOTO 999
C
C COUNT NUMBER OF CLUSTERS FOR WHICH THIS IS A NEIGHBOUR
C END OF LOOP OVER NEIGHBOURS OF PARENT
C
             FLIST(NADC) = FLIST(NADC) + 1
C
   20     CONTINUE
C
   10  CONTINUE
C
   11  CONTINUE
C
       IF ( NCLST .LE. 1 ) GOTO 40
C
C
C FOR ADC'S IN MORE THAN ONE CLUSTER,DIVIDE ENERGY BY NUMBER OF CLUSTERS
C FOR WHICH IT IS A MEMBER
C
 1000  DO 30 I = ISTART,IEND
          IF ( FLIST(I) .LE. 1 ) GOTO 30
          CATAG(I) = CATAG(I) / FLIST(I)
   30  CONTINUE
C
   40  CONTINUE
       IF ( IWRITE .NE. 1 ) RETURN
       DO 50 I = 1,NCLST
          WRITE(6,602) CMAP(I,1) ,CMAP(I,2) ,CMAP(I,3) ,CMAP(I,4) ,
     *                 CMAP(I,5) ,CMAP(I,6) ,CMAP(I,7) ,CMAP(I,9 )
   50  CONTINUE
  602  FORMAT(9(2X,F10.2))
       RETURN
C
C
  999  WRITE(6,600)
  600  FORMAT(' WARNING MORE THAN 10 CLUSTERS FOUND BY CLUSFN ')
       GOTO 1000
       END

C   10/02/86 604291051  MEMBER NAME  PRTPTRR  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRTPTR( IPTPTR, XS, YS , DEL, SIZE )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 29/04/86 :  PRINT BOS BANK TPTR
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CWORK1 / HWORK(70)
C
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*140
      EQUIVALENCE (cHWORK,HWORK(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      LIM2 = IPTPTR
      LIMH2 = 2*LIM2
      CALL CORE(HWORK,110)
      WRITE(cHWORK,1) (HDATA(LIMH2+I),I=1,18) ! PMF 17/11/99: JUSCRN changed to cHWORK
    1 FORMAT('  ',18I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,110,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(cHWORK,2) (ADATA(LIM2+I),I=10,19) ! PMF 17/11/99: JUSCRN changed to cHWORK
    2 FORMAT('  ',10E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,78)
      WRITE(cHWORK,3) IDATA(LIM2+20),ADATA(LIM2+21),IDATA(LIM2+22), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *               (ADATA(LIM2+I),I=23,25),IDATA(LIM2+26)
    3 FORMAT('  ',I6,E14.6,I6,3E14.6,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,78,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(cHWORK,4)(ADATA(LIM2+I),I=27,33),(HDATA(LIMH2+I),I=67,68) ! PMF 17/11/99: JUSCRN changed to cHWORK
    4 FORMAT('  ',7E14.6,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(cHWORK,5) (ADATA(LIM2+I),I=35,38),(HDATA(LIMH2+I),I=77,78), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                (ADATA(LIM2+I),I=40,42)
    5 FORMAT('  ',4E14.6,2I6,3E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,74)
      WRITE(cHWORK,6) (HDATA(LIMH2+I),I=85,96) ! PMF 17/11/99: JUSCRN changed to cHWORK
    6 FORMAT('  ',12I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,74,0.)
      YS = YS - DEL
      CALL CORE(HWORK,120)
      WRITE(cHWORK,7) (ADATA(LIM2+I),I=49,57) ! PMF 17/11/99: JUSCRN changed to cHWORK
    7 FORMAT('   ',9E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
      YS = YS - DEL
      CALL CORE(HWORK,86)
      WRITE(cHWORK,8) IDATA(LIM2+58),(ADATA(LIM2+I),I=59,64) ! PMF 17/11/99: JUSCRN changed to cHWORK
    8 FORMAT('   ',I5,6E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,86,0.)
      YS = YS - DEL
      CALL CORE(HWORK,100)
      WRITE(cHWORK,9) (ADATA(LIM2+I),I=65,71) ! PMF 17/11/99: JUSCRN changed to cHWORK
    9 FORMAT('  ',7E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,100,0.)
      YS = YS - DEL
      CALL CORE(HWORK,98)
      WRITE(cHWORK,10) IDATA(LIM2+72),(ADATA(LIM2+I),I=73,78), ! PMF 17/11/99: JUSCRN changed to cHWORK
     *                (IDATA(LIM2+I),I=79,80)
   10 FORMAT('  ',I6,6E13.5,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,98,0.)
      RETURN
      END

C   07/06/96 606071914  MEMBER NAME  UCOND    (S4)          FORTG1
      SUBROUTINE UCOND(NCOND,NC)
      COMMON/BCS/IW(1)
      INTEGER*2 NH(2)
      EQUIVALENCE (NF,NH(1))
C
C     PURPOSE
C        COUNT NUMBER OF CONDITIONS, CHARACTERIZED BY
C        TWO INTEGERS NCOND,NC  (BOTH LT 32768)
C
C     USAGE
C        CALL UCOND(NCOND,NC)
C      = INCREASE COUNT FOR CONDITION (NCOND,NC) BY 1
C
C        CALL PCOND
C      = PRINT COUNTS AND RESET COUNTERS
C
C        CALL QCOND(NCOND,NC,NUMBER)
C      = GET NUMBER OF COUNTS OF CONDITION (NCOND,NC)
C
      IF(NCOND.LT.0.OR.NCOND.GE.32768) GOTO 100
      IF(NC   .LT.0.OR.NC   .GE.32768) GOTO 100
      NH(1)=NCOND
      NH(2)=NC
      NS=(NF/8)*8
      NR=MOD(NF,8)
C     WRITE(6,101) NS,NR,NF,NH
C 101 FORMAT(1X,10I12)
      CALL BLOC(I,'CON*',NS,&20)
   10 IW(I+NR+1)=IW(I+NR+1)+1
  100 RETURN
   20 CALL BCRE(I,'CON*',NS,8,&100,IER)
      GOTO 10
C
      ENTRY QCOND(NCOND,NC,NUMBER)
      NUMBER=0
      IF(NCOND.LT.0.OR.NCOND.GE.32768) GOTO 100
      IF(NC   .LT.0.OR.NC   .GE.32768) GOTO 100
      NH(1)=NCOND
      NH(2)=NC
      NS=(NF/8)*8
      NR=MOD(NF,8)
      CALL BLOC(I,'CON*',NS,&100)
      NUMBER=IW(I+NR+1)
      GOTO 100
      END

      SUBROUTINE VTXBNK(IPPATR) 
C*800205*OLSSON*****************************************************
C*                                                                 *
C* C R E A T E  B A N K  GVTX  F R O M  V E R T E X  R E S U L T S *
C*                                                                 *
C*******************************************************************
C             IPPATR IS POINTER TO 'PATR' ;  SAME BOSBANK NR IS USED
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
#include "cdata.for"
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C
      IF(NV.EQ.0) GO TO 100
C****
C
      NBNK = IDATA(IPPATR-2)
      NWRES = 2 + NV*10 + NT*15
      CALL CCRE(IPHT,'GVTX',NBNK,NWRES,IERR)
      IF(IERR.NE.0) GO TO 100
      CALL BSAW(1,'GVTX')
      IDATA(IPHT+1) = NV
      DO 1  INV = 1,NV
      INVX = IPHT+1+(INV-1)*10
      ISS = (INV-1)*10
      DO 1  I = 1,10
1     IDATA(INVX+I) = IV(ISS+I)
      IDATA(IPHT+2+NV*10) = NT
C
      DO 2  INT = 1,NT
      INTX = IPHT+2+NV*10 + (INT-1)*15
      ISS = (INT-1)*40
      DO 2  I = 1,15
2     IDATA(INTX+I) = IT(ISS+I)
  100 RETURN
      END

* This is a private version of CERNLIB routine RANMAR.
*   13/07/2000 Pedro Movilla Fernandez
*
* Modifications:
*     - The counters NTOT, NTOT2 are not reset to zero at the end
*       of RMARIN, i.e.: These counters now refer to the very
*       beginning of the random numbers sequence and not only to
*       the number of random numbers generated since the first call
*       of RMARIN. Thus, a correct handling of NTOT2 is ensured.
*
*     - An initialization of the random generator is now also possible
*       externally by setting common /RANMA1/. This kind of initialization
*       is much faster than using RMARIN and must be indicated by the
*       user by the variable `RANINI' which is here appended at the end of
*       common /RANMA1/.
*
*       RANINI = .TRUE.: Initialization was done externally or by calling RMARIN.
*                .FALSE.: Perform default initialization by using RMARIN,
*                         if FIRST.EQ..TRUE.
*
*     - An additional flag `RANPRIV' was introduced and appended to
*       common  /RANMA1/ in order to let the user know that this version of
*       RANMAR is used. Use this information in order to handle the counters
*       NTOT and NTOT2 correctly!
*     
*
* $Id: ranmar.F,v 1.1.1.1 1996/02/15 17:49:53 mclareni Exp $
*
* $Log: ranmar.F,v $
* Revision 1.1.1.1  1996/02/15 17:49:53  mclareni
* Modified          2000/07/13           Pedro Movilla Fernandez
* Kernlib
*
*
      SUBROUTINE RANMAR(RVEC,LENV)
C
C CERN PROGLIB# V113    RANMAR          .VERSION KERNFOR  4.21  890323
C ORIG. 01/03/89 FCA + FJ
C
      DIMENSION RVEC(*)
C 
C PMF: - Introduce `RANPRIV' as privat-version-flag of RANMAR
C      - Append `RANINI' to common /RANMA1/ to inform RANMAR if
C        initialization has already been done externally via common /RANMA1/.
      LOGICAL RANPRIV,RANINI
C
      COMMON/RANMA1/IJKL,NTOT,NTOT2,I97,J97,C,U(97),RANINI,RANPRIV
      LOGICAL FIRST
      PARAMETER (TWOM24=2.**(-24),TWOM48=2.**(-48))
      PARAMETER (CD=7654321.*TWOM24,CM=16777213.*TWOM24)
      PARAMETER (CINT=362436.*TWOM24,MODCNS=1000000000)
      SAVE /RANMA1/, FIRST
      DATA FIRST/.TRUE./
      EXTERNAL RANDAT
C
C PMF: Report that this version of RANMAR is called
      IF( FIRST ) THEN
        WRITE(*,*) 
     >  'RANMAR: Private version of RANMAR (CERN PROGLIB# V113) called.'
        RANPRIV=.TRUE.
      ENDIF
C PMF: Check if initialization has already been done externally
      IF( RANINI.AND.FIRST ) THEN 
         WRITE(*,*)
     >  'RANMAR: Initialization done externally via /RANMA1/.' 
        FIRST=.FALSE.
      ELSEIF( FIRST ) THEN
         WRITE(*,*)
     >  'RANMAR: Will perform default initialization using RMARIN.' 
      ENDIF
C
      IF(FIRST) THEN
        IJKL = 54217137
        NTOT = 0
        NTOT2 = 0
        GO TO 70
      ENDIF
C
   80 CONTINUE
      DO 100 IVEC= 1, LENV
        UNI = U(I97)-U(J97)
        IF (UNI .LT. 0.) UNI=UNI+1.
        U(I97) = UNI
        I97 = I97-1
        IF (I97 .EQ. 0)  I97=97
        J97 = J97-1
        IF (J97 .EQ. 0)  J97=97
        C = C - CD
        IF (C .LT. 0.)   C=C+CM
        UNI = UNI-C
        IF (UNI .LT. 0.) UNI=UNI+1.
C
C   Replace exact zeroes by uniform distr. *2**-24
C
        IF (UNI .EQ. 0.)  THEN
          UNI = TWOM24*U(2)
C
C   An exact zero here is very unlikely, but let's be safe.
C
          IF (UNI .EQ. 0.) UNI= TWOM48
        ENDIF
        RVEC(IVEC) = UNI
  100 CONTINUE
C
      NTOT = NTOT + LENV
      IF (NTOT .GE. MODCNS)  THEN
        NTOT2 = NTOT2 + 1
        NTOT  = NTOT - MODCNS
      ENDIF
      RETURN
      ENTRY RMARIN(IJKLIN,NTOTIN,NTO2IN)
C
      IF( FIRST )
     >  WRITE(*,*) 
     >  'RANMAR: Private version of RANMAR (CERN PROGLIB# V113) called.'
C
      FIRST = .FALSE.
      IJKL  = IJKLIN
C PMF: Initialize with default seed if IJKLN.EQ.0
      IF( IJKL .EQ. 0 ) IJKL = 54217137
      NTOT  = NTOTIN
      NTOT2 = NTO2IN
C PMF: Prevent from initialisation by RMARIN if RANINI.EQ..TRUE.
      IF( RANINI ) THEN
         WRITE(*,*) 
     >   'RMARIN: Initialization is performed externally, so RMARIN'
     >  //' will let common /RANMA1/ unchanged.'
         RANPRIV=.TRUE.
         RETURN
      ELSE
         WRITE(*,*) 
     >   'RMARIN called for initialization.'
      ENDIF
C
   70 CONTINUE
      IJ = IJKL/30082
      KL = IJKL - 30082*IJ
      I = MOD(IJ/177, 177) + 2
      J = MOD(IJ, 177)     + 2
      K = MOD(KL/169, 178) + 1
      L = MOD(KL, 169)
      DO 30 II= 1, 97
        S = 0.
        T = .5
        DO 20 JJ= 1, 24
          M = MOD(MOD(I*J,179)*K, 179)
          I = J
          J = K
          K = M
          L = MOD(53*L+1, 169)
          IF (MOD(L*M,64) .GE. 32)  S = S+T
          T = 0.5*T
  20    CONTINUE
        U(II) = S
  30  CONTINUE
      C   = CINT
      I97 = 97
      J97 = 33
C       Complete initialization by skipping
C            (NTOT2*MODCNS + NTOT) random numbers
      NITER = MODCNS
      DO 50 LOOP2= 1, NTOT2+1
        IF(LOOP2.GT.NTOT2) NITER=NTOT
        DO 40 IDUM = 1, NITER
          UNI = U(I97)-U(J97)
          IF (UNI .LT. 0.) UNI=UNI+1.
          U(I97) = UNI
          I97 = I97-1
          IF (I97 .EQ. 0)  I97=97
          J97 = J97-1
          IF (J97 .EQ. 0)  J97=97
          C = C - CD
          IF (C .LT. 0.)   C=C+CM
   40   CONTINUE
   50 CONTINUE
C OB/PMF: The following two lines are wrong:
C     NTOT  = 0
C     NTOT2 = 0
      IF(FIRST) THEN
        FIRST = .FALSE.
        GO TO 80
      ENDIF
      RETURN
      ENTRY RMARUT(IJKLUT,NTOTUT,NTO2UT)
C
      NTOTUT = NTOT
      NTO2UT = NTOT2
      IJKLUT = IJKL
C
      END
C     Initialize RANINI and RANPRIV
      BLOCK DATA RANDAT
      LOGICAL RANPRIV,RANINI
      COMMON/RANMA1/IJKL,NTOT,NTOT2,I97,J97,C,U(97),RANINI,RANPRIV
      DATA RANPRIV/.FALSE./,RANINI/.FALSE./
      END

C   16/12/83 312161621  MEMBER NAME  MULOCH   (JADEMUS)     FORTRAN
C
C   LAST CHANGE  16/12/83 CHRIS BOWDERY  VARIABLES RENAMED IN PLACES
C        CHANGE  12/07/82 CHRIS BOWDERY  TO CORRECT 3 BUGS
C
C-----------------------------------------------------------------------
      SUBROUTINE MULOCH
C-----------------------------------------------------------------------
C
C             THIS SUBROUTINE PERFORMS THE 'LET-OFF' CHECK
C
C    INPUT:   REGDEV : A VECTOR CONTAINING A SEQUENCE OF:
C                      < REGION NUMBER , ABSORBER ENCOUNTERED , HIT
C                        DEVIATION IN UNITS OF SIGMA >
C             REGDCE : A VECTOR CONTAINING A SEQUENCE OF :
C                      < REGION NUMBER , ABSORBER ENCOUNTERED , LOWER
C                        LIMIT OF 'DCE' , UPPER LIMIT OF 'DCE' >
C                      WHERE 'DCE' IS A DEAD CHAMBER OR EDGE
C             REGZE  : A VECTOR LIKE REGDCE BUT FOR LONGITUDINAL EDGES
C
C    OUTPUT:  INEFF  : INCREMENTED FOR EVERY 'MISSING' REGION FOUND
C             INFLAG : SET TO 2 IF THE TRACK IS OUTER LAYER 'MISSING'
C             LOCHRS : A VECTOR CONTAINING A FLAG FOR EVERY REGION
C                       0 = NOT AFFECTED
C                       1 = MULOCH COULD NOT TEST THE REGION
C       FLAG CODE =     2 = REGION WAS NOT 'LET-OFF'
C                       3 = REGION WAS GIVEN THE BENEFIT OF THE DOUBT
C                       4 = REGION WAS 'LET-OFF'
C
C             THE ACTUAL FLAG IS  10*(DRIFT CODE) + LONGITUDINAL CODE
C             ---> A 'MISSING' REGION HAS CODE '02' OR '20' OR '22'
C
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
C             COMMONS AND ARRAY DECLARATIONS
C
C   20/10/81 202041521  MEMBER NAME  CMUFWORK (JADEMUS)     FORTRAN
C   12/10/81 110152138  MEMBER NAME  CMUFWORK (JADEMUS1)    FORTRAN
C-------------START OF MACRO CMUFWORK-----------------------------------
C LAST CHANGED 21.30 15/10/81 HUGH MCCANN  - EXTEND IOVLAP TO ALLOW
C                                            > 10 ASSOC HITS IN MUFFLY.
C LAST CHANGED 10.00 04/10/81 HUGH MCCANN  - FOR USE OF OVERLAP HITS.
C LAST CHANGED 14.46 17/06/81 JOHN ALLISON - TO ADD 'OVER' VARIABLES.
C LAST CHANGED 23.00 09/04/81 HUGH MCCANN - JADEMUS UPDATE.
C
      COMMON /CWORK/X,Y,Z,DCX,DCY,DCZ,P,PSQ,E,ESQ,D,GM,AB,RD,DE,PPIDK,
     *PKDK,PPBPEN,PPPEN,PPIPEN,PKPEN,DUMW1(29),X8,Y8,Z8,DCX8,DCY8,
     *DCZ8,P8,PSQ8,E8,ESQ8,D8,GM8,AB8,RD8,DE8,PPIDK8,PKDK8,PPBPE8,
     *PPPEN8,PPIPE8,PKPEN8,DUMW28(29),X0,Y0,Z0,DCX0,DCY0,DCZ0,P0,PSQ0,
     *E0,ESQ0,D0,GM0,AB0,RD0,DE0,PPIDK0,PKDK0,PPBPE0,PPPEN0,PPIPE0,
     *PKPEN0,DUMW2(29),X9,Y9,Z9,DCX9,DCY9,DCZ9,P9,PSQ9,E9,ESQ9,D9,GM9,
     *AB9,RD9,DE9,PPIDK9,PKDK9,PPBPE9,PPPEN9,PPIPE9,PKPEN9,DUMW29(29),
C-----200 WORDS UP TO HERE----------------------------------------------
     *X1,Y1,Z1,X2,Y2,Z2,XMID,YMID,ZMID,X3,Y3,Z3,D1,D2,D3,DTC,DUMW3(4),
     *DSTEP,GMSTEP,ABSTEP,RDSTEP,DESTEP,DUMW4(15),ADCZ,COSEC,STPINI,CURV
     *,DANG,DX,DY,DZ,R,RSQ,PT,DPINA,DKNA,DUMW5(7),VX,VY,VZ,RMSXY,RMSZ,
     *VTXYD,VTZD,VTXYAN,VTZANG,VMSANG,VMSD,CMS,DUMW6(8),SDS(10),DUMW7(1000002000
C
C    *SDX,SDY,SDZ,SDTXYD,SDTZD,SDTXYA,SDTZAN,SDMSAN,SDMSD,SDCMS,DM7(10),
C
C NOTE ABOVE CARD SHORTENED TO SDS(10),DUMW7(10), SO THAT STATEMENT DOES
C   NOT EXCEED 19 CONTINUATION CARDS.  I THINK SD--'S ARE NOT USED.
     *),CHISQT,NDFT,CHIPRT,CHISTL,NDFTL,CHIPTL,NBADCH,DUMW8(13),IDTRK,
     *NCEPTS,NTHIS,INEFF,NHLAYR,INFLAG,NELIPS,NGLAYR,DUMW9(72),IREG(200)
C-----600 WORDS UP TO HERE----------------------------------------------
     *,RDOTD(200),CINT(3,200),NFLAG(200),ITEM(200),EM(30,30),DALONG(10),
C-----2710 WORDS UP TO HERE---------------------------------------------
     *DEV(30),VXYDA(10),VZDA(10),CXYA(10),CZA(10),INCUT(30),BADA(30),G(200003100
     *0,20),DEVA(20),IPERM(10),MWORK(20),ITHISA(10),IJA(10),EM1(20,20),E
     *MG(20,20),ELIPSE(700),INCHAM(10),INREG(10),IAPPRO(30),HBADCH(1000)
     *,CTDASH(10),CLDASH(10),VTDASH(10),VLDASH(10),IHTREG(20),LAYRAB,IEF
C-----5421 WORDS UP TO HERE---------------------------------------------
     *FRG(10),DUMW10(69),AAA(10),BBB(10),CCC(10),DDD(10),DOVER,GMOVER,AB
     *OVER,RDOVER,DEOVER,DUMW11(55),X7(50),IHTP(30),IOVLAP(20,20)
C-----6080 WORDS UP TO HERE---------------------------------------------
      DIMENSION ILIPSE(700)
      INTEGER*2 HLIPSE(1400)
      DIMENSION IHTPER(10),IHTEMP(10),IPTEMP(10)
      EQUIVALENCE (ILIPSE(1),HLIPSE(1),ELIPSE(1))
      EQUIVALENCE (IHTP(1) ,IHTPER(1)),
     *            (IHTP(11),IHTEMP(1)),
     *            (IHTP(21),IPTEMP(1))
      LOGICAL INCUT,BADA
C
C-----------------------------------------------------------------------
C
C THE FIRST 50 LOCATIONS ARE RESERVED FOR SPECIAL WORKING VARIABLES.
C THE NEXT 150 LOCATIONS ARE RESERVED FOR COPIES OF THESE SPECIAL
C    VARIABLES, IF, E.G., ONE WISHES TO PRESERVE THEIR VALUES AT
C    THE BEGINNING OF A STEP.
C THE COPIES HAVE A SUFFIX 0 FOR VALUES AT LAST ASSOCIATED HIT.
C THE COPIES HAVE A SUFFIX 7 FOR VALUES AFTER LEAD-GLASS BARREL OR
C    YOKE END-PLUG (X7 IS LATER IN COMMON - SEE BELOW).
C THE COPIES HAVE A SUFFIX 8 FOR VALUES AT LAST BUT ONE GOOD
C    CHAMBER LAYER.
C THE COPIES HAVE A SUFFIX 9 FOR VALUES AT LAST GOOD CHAMBER LAYER.
C NSPECI (SET IN BLOCK DATA BEHIND MUFFLE) IS THE NUMBER OF SUCH
C    VARIABLES ACTUALLY USED.
C
C SPECIAL VARIABLES....
C
C X,Y,Z       = CURRENT COORDINATES.
C DCX,DCY,DCZ = CURRENT DIRECTION COSINES OF TRACK.
C P,PSQ       = CURRENT MOMENTUM (AND ITS SQUARE).
C E,ESQ       = CURRENT ENERGY (AND ITS SQUARE).
C D           = CURRENT DISTANCE FROM VERTEX (MM).
C GM          = MATERIAL TRAVERSED TO CURRENT POSITION (GM CM**-2).
C AB          = ABSORPTION LENGTHS SO FAR.
C RD          = RADIATION LENGTHS SO FAR.
C DE          = ENERGY LOSS (GEV).
C PPIDK       = PROBABILITY OF PION DECAYING TO MUON BEFORE INTERACTING.
C PKDK        = PROBABILITY OF KAON DECAYING TO MUON BEFORE INTERACTING.
C PPBPEN      = ANTI-PROTON ) ( PENETRATION PROBABILITY, I.E. PROBAB-
C PPPEN       = PROTON      ) ( ILITY OF NOT BEING ABSORBED BY A NUCLEUS
C PPIPEN      = PI          ) ( AND NOT DECAYING.  SEE SUBROUTINE
C PKPEN       = K           ) ( MUFFLS FOR FURTHER DETAILS.
C
C-----------------------------------------------------------------------
C
C THE NEXT 200 LOCATIONS ARE RESERVED FOR VARIABLES THAT DO NOT NEED
C    SPECIAL PRESERVATION.
C
C OTHER VARIABLES...
C
C X1,Y1,Z1    = COORDS OF 1ST POINT ON TRACK.
C X2,Y2,Z2    = COORDS OF LAST POINT ON TRACK.
C XMID,YMID,ZMID = COORDS OF MID POINT ON TRACK.
C X3,Y3,Z3    = COORDS OF POINT WHERE TRACK LEAVES MAGNETIC FIELD.
C D1          = DISTANCE TRAVELLED TO (X1,Y1,Z1).
C D2          = DISTANCE TRAVELLED TO (X2,Y2,Z2).
C D3          = DISTANCE TRAVELLED TO (X3,Y3,Z3).
C DTC         = DISTANCE TRAVELLED TO MID-POINT OF TRACK.
C
C DSTEP       = STEP LENGTH THIS STEP (FOR MUFFLU) (MM).
C GMSTEP      = MATERIAL THIS STEP (GM CM**-2).
C ABSTEP      = ABSORPTION LENGTHS THIS STEP.
C RDSTEP      = RADIATION LENGTHS THIS STEP.
C DESTEP      = ENERGY LOSS OF MINIMUM IONISING PARTICLE THIS STEP,
C
C ADCZ        = ABS(DCZ)
C COSEC       = ABS(COSEC(THETA)), WHERE THETA IS ANGLE TO BEAM.
C STPINI      = STEP LENGTH IN INITIAL TRACKING TO COIL OR END PLUG.
C CURV        = CURVATURE FROM 'PATR' BANK.
C DANG        = ANGLE OF TURN FOR EACH STEP.
C DX,DY,DZ    = CHANGES OF X,Y,Z.
C R,RSQ       = DISTANCE FROM BEAM (RADIUS) AND ITS SQUARE.
C PT          = MOMENTUM COMPONENT PERPENDICULAR TO BEAM.
C DPINA       = INTEGRAL OF (DECAY LENGTH)*(PROBABILTY OF NOT INTER-
C                 ACTING) FOR PION. (NO LONGER USED. CAN BE RESURECTED
C DKNA        = SIMILARLY FOR KAON. (BY UN-COMMENTING IN MUFFLS.
C
C VX,VY,VZ    = CURRENT VARIANCES ON X,Y,Z.
C RMSXY       = RMS DEV. NORMAL TO CHORD IN XY FIT.     )
C RMSZ        = RMS Z DEV. IN RZ FIT.                   ) FROM
C VTXYD       = VARIANCE ON DEVIATION NORMAL TO         ) TRACK
C                 TRACK IN XY PLANE AT TRACK CENTRE.    ) RECON-
C VTZD        = VARIANCE ON DEVIATION NORMAL TO         ) STRUCTION
C                 TRACK IN RZ PLANE AT TRACK CENTRE.    ) ERRORS.
C VTXYAN      = VARIANCE ON ANGLE IN XY PLANE (PHI)     )
C VTZANG      = VARIANCE ON ANGLE IN RZ PLANE (THETA)   )
C VMSANG      = VARIANCE OF MULTIPLE SCATTERING ANGLE.
C VMSD        = VARIANCE OF MULTIPLE SCATTERING DEVIATION NORMAL TO
C                 TRACK.
C CMS         = COVARIANCE OF ABOVE TWO QUANTITIES.
C SD--        = CORRESPONDING STANDARD DEVIATIONS (SQUARE ROOTS).
C
C CHISQT      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFT        = NUMBER OF DEGREES OF FREEDOM.           ) (DRIFT)
C CHIPRT      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C CHISTL      = CHI-SQUARED OF DEVIATION OF HITS FROM   ) FOR
C                 PROJECTED TRACK.                      ) TRANSVERSE
C NDFTL       = NUMBER OF DEGREES OF FREEDOM.           ) & LONG'L
C CHIPTL      = CHI-SQUARED PROBABILITY.                ) COORDS.
C
C NBADCH      = NO. OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C
C IDTRK       = INNER DETECTOR TRACK NUMBER.
C NCEPTS      = NUMBER OF INTERCEPTS FOUND BY MUREGY.
C NTHIS       = NUMBER OF MUON HITS ASSOCIATED WITH PROJECTED INNER
C                DETECTOR TRACK.
C INEFF       = NUMBER OF INEFFICIENCIES IN MUON SYSTEM FOUND THIS TRACK
C NHLAYR      = NUMBER WHICH REPRESENTS NUMBER OF MUON LAYERS WITH
C                ASSOCIATED MUON HITS. ADD 1 FOR THE INNER LAYER AND
C                2 FOR EACH SUBSEQUENT LAYER.
C INFLAG      = 1 IF LAST LAYER INTERCEPTED WAS INEFFICIENT.
C NELIPS      = NUMBER OF MULTIPLE SCATTERING ELIPSES ENTERED IN ELIPSE.
C NGLAYR      = AS NHLAYR, BUT FOR 'GOOD' LAYERS WHETHER THERE WAS AN
C                ASSOCIATED HIT OR NOT.
C
C-----------------------------------------------------------------------
C
C THE NEXT 1400 LOCATIONS USED BY MUREGY (CALCULATES REGION INTERCEPTS).
C
C IREG        = REGION NUMBER.                           )(IN PAIRS,I.E.
C RDOTD       = R.DOT.(DIR. COSINES) FOR EACH INTERCEPT. )( 2 INTERCEPTS
C CINT        = X,Y,Z COORDINATES OF EACH INTERCEPT.     )( PER REGION.
C NFLAG       = USED INTERNALLY BY MUREGY.
C ITEM        = USED INTERNALLY BY MUREGY.
C
C-----------------------------------------------------------------------
C
C THE NEXT 3600 LOCATIONS USED BY MUFFLE, ETC., TO ACCUMULATE
C   QUANTITIES NEEDED FOR CALCULATING CHI-SQUARED. IN THE DESCRIPTION
C   BELOW I,J GO AS FOLLOWS..
C     1   LEFT DRIFT COORDINATE    )  OF 1ST
C     2   RIGHT DRIFT COORDINATE   )  ASSOCIATED
C     3   LONGITUDINAL COORDINATE  )  HIT
C     4    ETC. FOR NEXT ASSOCIATED HIT.
C   K REFERS TO K'TH ASSOCIATED HIT.
C
C EM(I,J)     = 'ERROR MATRIX', I.E. VARIANCE (I=J) OR COVARIANCE (I.NE.
C                J) FOR COORDINATE I,J.
C DALONG(K)   = DISTANCE OF ASSOCIATED HIT K ALONG TRACK.
C DEV(I)      = DEVIATION OF COORDINATE I FROM EXTRAPOLATED INNER
C                DETECTOR TRACK.
C VXYDA(K)    = VARIANCE ON DEVIATION IN XY PLANE FOR HIT K.
C VZDA(K)     = VARIANCE ON DEVIATION IN RZ PLANE FOR HIT K.
C CXYA(K)     = COVARIANCE BETWEEN DEVIATION AND ANGLE IN XY PLANE.
C CZA(K)      = COVARIANCE BETWEEN DEVIATION AND ANGLE IN RZ PLANE.
C INCUT(I)    = .TRUE. IF COORDINATE I IS IN CUT (SEE MUFFLY).
C BADA(I)     = .TRUE. IF COORDINATE I IS BAD.
C G           = INVERSE ERROR MATRIX.
C DEVA        = CORRESPONDING DEVIATIONS.
C IPERM(K)    = USED TO PERMUTE LEFT/RIGHT AMBIGUITIES.
C MWORK       = USED BY MATRIX INVERTING ROUTINE AS WORKING SPACE.
C ITHISA(K)   = HIT NUMBER OF K'TH ASSOCIATED HIT.
C IJA(K)      = INDEX FOR K'TH ASSOCIATED HIT FOR ENTRY IN BANKS 2 & 3.
C EM1         = COPY OF RELEVANT PART OF ERROR MATRIX FOR TEST PURPOSES.
C EMG         = PRODUCT OF ERROR MATRIX AND ITS INVERSE. SHOULD BE UNIT
C                MATRIX. USED FOR TEST PURPOSES.
C ELIPSE      = TEMPORARY STORAGE FOR MULTIPLE SCATTERING ELIPSES.
C INCHAM      = LIST OF INEFFICIENT CHAMBERS ON THIS TRACK.
C INREG       = LIST OF INEFFICIENT REGIONS (PLANES) ON THIS TRACK.
C IAPPRO      = USED AS WORKING SPACE IN MUFFLX.
C HBADCH      = LIST OF BAD CHAMBERS (AS DEFINED BY HMCSTA).
C CTDASH(K)   = TRANSVERSE COORD. ESTIMATED FROM I.D. PROJECTION.
C CLDASH(K)   = LONGITUD'L COORD. ESTIMATED FROM I.D. PROJECTION.
C VTDASH(K)   = VARIANCE ON CTDASH.
C VLDASH(K)   = VARIANCE ON CLDASH (FOR K'TH ASSOCIATED HIT).
C
C-----------------------------------------------------------------------
C
C THE NEXT  380 LOCATIONS USED FOR VARIOUS IMPROVEMENTS TO MUFFLE, ETC.
C
C IHTREG      = FOR EACH ASSOCIATED HIT, THE REGION NO. IN WHICH
C               THE HIT OCCURS.
C LAYRAB      = ABSOLUTE NO. OF LAYERS WHICH HAVE ASSOCIATED HITS.
C IEFFRG      = LIST OF REGION NOS. OF THOSE REGIONS WHICH HAVE AN
C               ASSOCIATED HIT.
C   IHTPER = FLAG FOR EACH ASSOCIATED HIT TO TELL IF IT'S TO
C            GO FORWARD INTO THE CHI**2 CALCULATION . ONLY ONE
C            HIT PER LAYER IS TO BE USED ,APART FROM OVERLAP HITS.
C   IHTEMP = LIST OF HITS WHICH ARE TEMPORARILY IN THE HIT PERMUTATION
C            DUE TO OVERLAPS WITH THE CURRENT AMBIGUITYOF ONE OF THE
C            HITS IN IHTPER.
C   IPTEMP =  AS IHTEMP, BUT FOR L/R AMBIGUITIES.
C IOVLAP   =  MATRIX OF OVERLAP HITS. IOVLAP(I,J)=1 MEANS THAT THERE
C             IS AN OVERLAP BETWEEN ASSOCIATED HITS I & J ( I & J BOTH
C             IN THE RANGE 1 TO NTHIS ).
C AAA(K)      = TRANSFORMATION COEFF. A FOR K'TH ASSOCD. HIT.
C BBB(K)      = TRANSFORMATION COEFF. B FOR K'TH ASSOCD. HIT.
C CCC(K)      = TRANSFORMATION COEFF. C FOR K'TH ASSOCD. HIT.
C DDD(K)      = TRANSFORMATION COEFF. D FOR K'TH ASSOCD. HIT.
C
C DOVER, ETC. = STORES QUANTITIES LEFT OVER AFTER LEAVING LAST ABSORBER.
C
C X7          = VALUES OF SPECIAL VARIABLES AFTER LEAD-GLASS BARREL OR
C               YOKE END-PLUG - USED FOR RE-FITTING, ETC.
C
C-------------END OF MACRO CMUFWORK-------------------------------------
C------------START OF MACRO CMUREG--------------------------------------
C
      COMMON /CMUREG/NREGS,XRLO(100),XRHI(100),YRLO(100),YRHI(100),
     * ZRLO(100),ZRHI(100),HRMASK(100),HRFACE(100),HRTYPE(100),
     * HRORI(100),HRFIRS(100),HRLAST(100)
C
C NREGS IS NUMBER OF REGIONS.
C XRLO ETC. ARE REGION BOUNDARIES.
C HRMASK =1 (FACE 1), =2 (FACE 2), =4 (FACE 3), =8 (FACE 4), ETC.
C HRFACE = FACE NUMBER, =1-6 FOR -X,+X,-Y,+Y,-Z,+Z.
C HRTYPE =1, MU CHAMBER SENSITIVE REGION,
C        =2, CONCRETE REGION,
C        =3, IRON REGION,
C        =4, LEAD GLASS. (IRTYPE=4 USED ONLY IN MUFFLD.)
C HRORI  = ORIENTATION OF NORMAL, =1 (|| X), =2 (||Y), =3 (|| Z).
C HRFIRS = FIRST CHAMBER NUMBER.
C HRLAST = LAST CHAMBER NUMBER.
C
C------------END OF MACRO CMUREG----------------------------------------
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(60),
     +                REGZE(60),LOCHRS(60),ABLOCH(60)
C
      DIMENSION LVREGH(10),DEVIAT(10),ABSORB(10),SLOPE(9),AVEDEV(9)
      DIMENSION LVAL(10),LFLAG1(10)
C
C-------------------- CODE ---------------------------------------------
C
C             ARE THERE ANY 'LET-OFFS' TO BE CHECKED ?
C             ARE THERE ANY HITS ANYWAY ?
C             HAS THE TRACK ALREADY FAILED ?
C
      IF( (REGDCE(1).EQ.0 .AND. REGZE(1).EQ.0)
     +    .OR.   NTHIS.EQ.0
     +    .OR.   INEFF.GT.1                    ) RETURN
C
C             ARE THERE AT LEAST 2 ASSOCIATED HITS IN DIFFERENT
C             LAYERS OUTSIDE THE YOKE ?
C
      IF(NHLAYR.LT.4) RETURN
      CALL VZERO(LOCHRS,60)
      CALL VZERO(ABLOCH,60)
      CALL VZERO(LVREGH ,10)
C
C             UNPACK THE DEVIATIONS AND AVERAGE THE OVERLAP HITS
C             AND SEPARATE THE ABSORPTION VALUES.
C                LREGN   = PREVIOUS REGION NUMBER
C                NRGHIT  = NUMBER OF REGIONS WITH HITS
C                LVREGH  = VECTOR OF REGION NUMBERS WITH HITS
C
      LREGN  = 0
      NRGHIT = 0
C
      DO 1  I = 1,30,3
        IREGN  = REGDEV(I)
        IF(IREGN.EQ.0) GO TO 8
C
C                            BAD HITS HAVE DEVIATION=100 . IGNORE.
C
        IF(REGDEV(I + 2) .EQ.100.) GO TO 1
C
C                            LOOK FOR OVERLAP HITS AND AVERAGE
C
        IF(IREGN.NE.LREGN) GO TO 2
          DEVIAT(NRGHIT) = ( DEVIAT(NRGHIT) + REGDEV(I + 2) ) / 2.0
          LVAL(NRGHIT)   = 2
          GO TO 1
 2      LREGN  = IREGN
        NRGHIT = NRGHIT + 1
        LVREGH(NRGHIT)  = IREGN
        ABSORB(NRGHIT)  = REGDEV(I + 1)
        DEVIAT(NRGHIT)  = REGDEV(I + 2)
        LVAL(NRGHIT)    = 1
 1    CONTINUE
C
 8    KREGH = NRGHIT - 1
C+++
C     WRITE(6,97)(REGDCE(I),I=1,36)
C97   FORMAT(' REGDCE'/(12(X,F10.3) )   )
C     WRITE(6,96)(REGZE(I),I=1,24)
C96   FORMAT(' REGZE'/(12(X,F10.3) )   )
C     WRITE(6,98) NRGHIT,IDTRK,(DEVIAT(I),ABSORB(I),I=1,NRGHIT)
C98   FORMAT(' NRGHIT,IDTRK / DEVIAT,ABSORB ',2I3/2(X,F10.4) )
C+++
      IF(NRGHIT.GT.1) GO TO 3
C
C                  WE ONLY HAVE ONE HIT TO WORK ON. ASSUME THAT
C                  IT LIES ON A LINE WITH ZERO SLOPE IN UNITS OF
C                  SIGMA.
C
        KREGH    = 1
        SLOPE(1) = 0.0
        LFLAG1(1)= 1
        LFLAG2   = 0
        FCT      = 7.5
        IF(LVAL(1).EQ.2)     FCT = 6.0
        IF(DEVIAT(1).LT.0.5) FCT = 5.0
        GO TO 14
C
C                  TAKE EACH ADJACENT PAIR OF HITS AND CALCULATE
C                  THE SLOPE OF THE LINE JOINING THEM.
C
 3    DO 5  I = 1,KREGH
        DIFDEV =  DEVIAT(I + 1) - DEVIAT(I)
        SEPABS =  ABSORB(I + 1) - ABSORB(I)
        IF(SEPABS .LT. 0.1 ) SEPABS = 0.1
        SLOPE(I)  =  DIFDEV / SEPABS
        AVEDEV(I) =  ( DEVIAT(I + 1) + DEVIAT(I) ) / 2.0
C
C                  IS THE SLOPE REASONABLE ?
C
        LFLAG1(I) = 0
        IF(ABS(SLOPE(I) ) .GT. 1.5 ) LFLAG1(I) = 1
        IF(ABS(SLOPE(I) ) .GT. 5.0 ) SLOPE(I)  = 0.0
 5    CONTINUE
C
C                  ARE THE SLOPES CONSISTENT ?
C
 6    NPSLOP = KREGH - 1
      LFLAG2 = 0
      IF(NPSLOP.LT.1) GO TO 24
      DO 7  I = 1,NPSLOP
        IF(ABS(SLOPE(I)-SLOPE(I+1) ) .GT. 0.4 ) LFLAG2 = 1
        IF(ABS(SLOPE(I)-SLOPE(I+1) ) .GT. 1.0 ) LFLAG2 = 2
 7    CONTINUE
C
C             CALCULATE THE FACTORS USED FOR DETERMINING ALLOWANCES
C
 24   FCT = 4.5
      IF(LFLAG2.EQ.1) FCT =  7.0
      IF(LFLAG2.EQ.2) FCT = 10.0
      IF(LFLAG2.EQ.0 .AND. ABS(SLOPE(1))  .LT. 0.35) FCT = FCT - 1.0
      IF(LFLAG2.EQ.0 .AND. ABS(DEVIAT(1)) .LT. 0.35) FCT = FCT - 1.0
C
C             FIND THE LONGITUDINAL LET-OFFS AND CHECK THEIR
C             CONSISTENCY WITH THE HITS IN THE SAME UNIT.
C             THE PLINTH AND A SIDEWALL CAN BE TREATED TOGETHER HERE.
C             IF THERE IS A HIT AFTER A Z LET-OFF THEN THE LET-OFF
C             WAS WRONG PROVIDED THE CHAMBERS ARE THE SAME LENGTH.
C
 14   DO 17  I = 1,60,4
        IREGN = REGZE(I)
        IF(IREGN.EQ.0) GO TO 18
        ABSZE = REGZE(I+1)
        IFACE = HRFACE(IREGN)
C
C                       SELECT AS DEFAULT THE CODE FOR UNTESTABLE.
C
        IF(LOCHRS(IREGN).EQ.0) LOCHRS(IREGN) = 1
        ABLOCH(IREGN) = ABSZE
        DO 19  J = 1,NRGHIT
          JREGN = LVREGH(J)
C
C                            PLINTH AND SIDEWALLS ARE COMPATIBLE
C
          IF(HRFACE(JREGN).NE.IFACE .AND. .NOT.(IFACE.EQ.3 .AND.
     +        HRORI(JREGN).EQ.1)    ) GO TO 19
C
C                       SOME CHAMBERS ARE SHORTER THAN OTHERS
C                       SO THE CHECK CANNOT BE DONE. NOT FOR
C                       THE ENDWALLS.
C
          IF( HRORI(JREGN).EQ.3 ) GO TO 16
          IF( ABS(ZRLO(JREGN)-ZRLO(IREGN) ) .GT. 150. .OR.
     +        ABS(ZRHI(JREGN)-ZRHI(IREGN) ) .GT. 150.  ) GO TO 19
C
 16       IF(ABSZE.GE.ABSORB(J) ) GO TO 19
C
C                       IF THE TRACK IS ROUGHLY HEADING
C                       FOR THE Z GAP IN THE ROOF, WE
C                       CANNOT USE THE Z CONSISTENCY TEST.
C                       USE A COSEC THETA EXCLUSION CHECK.
C
C                       PASS TEST IF 120 < THETA < 60
C
          IF(IFACE.EQ.4 .AND. COSEC.LT.1.155 ) GO TO 19
C
          IF(LOCHRS(IREGN).LT.2) LOCHRS(IREGN) = 2
C
 19     CONTINUE
 17   CONTINUE
C
C             FIND THE DRIFT REGIONS THAT REQUEST TO BE 'LET-OFF'
C             AND DETERMINE WHETHER EXTRAPOLATION OR INTER-
C             POLATION CAN BE USED TO CHECK THEM.
C
 18   DO 10  I = 1,60,4
        IREGN = REGDCE(I)
        IF(IREGN.EQ.0) GO TO 28
C
C                       MARK THE REGION AS UNTESTABLE AS DEFAULT
C
        IF(LOCHRS(IREGN).LT.10 ) LOCHRS(IREGN) = LOCHRS(IREGN) + 10
        ABSDCE = REGDCE(I+1)
        ABLOCH(IREGN) = ABSDCE
C                            NEED EXTRAPOLATION BACKWARDS
        K = 1
        IF( ABSORB(K).LE.ABSDCE ) GO TO 12
C                            IS IT UNTESTABLE ? JUMP IF YES
          IF( HRORI(LVREGH(K)).EQ.3 .AND. HRORI(IREGN).EQ.1 ) GO TO 10
 38       IF(LVREGH(K+1).EQ.0) GO TO 41
          IF( HRORI(LVREGH(K)).NE.1 .OR. HRORI(LVREGH(K+1)).NE.3 )
     +                                           GO TO 39
 41         SLOPE(K) = 0.0
            ALW = (ABSORB(K)-ABSDCE) * 0.9
            IF(ALW.GT.2.0) ALW = 2.0
            IF(ALW.LT.0.3) ALW = 0.30
            GO TO 42
 39       IF(LFLAG1(K).EQ.1) FCT = FCT * 1.5
          ALW = FCT * (ABSORB(K)-ABSDCE) * 0.10
          IF(ALW.GT.2.0) ALW = 2.0
          IF(ALW.LT.0.3) ALW = 0.3
 42       CALL MULOC2 (LQ,I,ALW,SLOPE(K),ABSDCE,ABSORB(K),DEVIAT(K) )
          GO TO 15
C
C                            TAKE EACH ADJACENT HIT PAIR AND
C                            DETERMINE IF A 'LET-OFF' REGION LIES
C                            IN BETWEEN.
C
 12     DO 20  M = 1,KREGH
          IF( LVREGH(M+1).EQ.0) GO TO 20
          IF( ABSORB(M+1).LT.ABSDCE ) GO TO 20
C
C                            DON'T BOTHER IF THE 'LET-OFF' REGION IS
C                            IN A SIDEWALL AND THE HITS ARE IN THE
C                            PLINTH AND ENDWALL
C
            IF(HRORI(LVREGH(M)).EQ.2.AND.HRORI(IREGN).EQ.1 .AND.
     +         HRORI(LVREGH(M+1)).EQ.3) GO TO 10
C
C                            IF THE 2 HITS ARE IN THE PLINTH AND ENDWALL
C                            THEN INTERPOLATION BETWEEN THE HITS IS NOT
C                            POSSIBLE. USE EXTRAPOLATION.
C
          IF(HRORI(LVREGH(M)).EQ.1.AND.HRORI(LVREGH(M+1)).EQ.3) GO TO 3500025500
C
C                            --->   INTERPOLATE TO CHECK 'LET-OFF'  <---
C
              IF(LFLAG1(M).EQ.1) FCT = FCT * 1.5
              ALW = FCT * (ABSORB(M+1)-ABSORB(M) ) * 0.035
              IF(ALW .GT. 1.2 ) ALW = 1.2
              IF(ALW.LT.0.25) ALW = 0.25
              CALL MULOC2 (LQ,I,ALW,SLOPE(M),ABSDCE,ABSORB(M),DEVIAT(M))
              GO TO 15
C
 35           IF(HRORI(IREGN).EQ.3) GO TO 36
                K = M
                IF(K.EQ.1) GO TO 44
              GO TO 37
 36             K = M + 1
                IF(K.EQ.NRGHIT) GO TO 41
              GO TO 38
 20     CONTINUE
C                            --->  EXTRAPOLATION FORWARDS   <---
        K = KREGH
        IF(LVREGH(K+1).EQ.0) GO TO 44
C                            IS IT UNTESTABLE ? JUMP IF YES
        IF(HRORI(IREGN).EQ.3 .AND. HRORI(LVREGH(K+1)).EQ.1) GO TO 10
        IF(HRORI(IREGN).NE.3 .OR. HRORI(LVREGH(K)).NE.1) GO TO 37
          K = K +1
 44       SLOPE(K) = 0.0
          ALW = (ABSDCE-ABSORB(K) ) * 0.9
          IF(ALW.GT.2.0) ALW = 2.0
          IF(ALW.LT.0.3) ALW = 0.3
          GO TO 43
C
 37     IF(LFLAG1(K).EQ.1) FCT = FCT * 1.5
        ALW = FCT * (ABSDCE-ABSORB(K+1) ) * 0.10
        IF(ALW.GT.2.0)  ALW = 2.0
        IF(ALW.LT.0.3) ALW = 0.3
 43     CALL MULOC2 (LQ,I,ALW,SLOPE(K),ABSDCE,ABSORB(K),DEVIAT(K) )
 15     IF(LQ*10 .GT. LOCHRS(IREGN) )
     +        LOCHRS(IREGN) = LQ * 10 + MOD(LOCHRS(IREGN),10)
 10   CONTINUE
C
C             DETERMINE THE NUMBER OF TRUE INEFFICIENCIES FOR
C             THE TRACK.
C
 28   DO 30  IREGN = 1,60
        LCODE = LOCHRS(IREGN)
        IF(LCODE.NE.22 .AND. LCODE.NE.2 .AND. LCODE.NE.20 ) GO TO 30
          INEFF = INEFF + 1
C                       IF THIS IS THE LAST REGION, FLAG IT AS O.L.I.
          IF(ABLOCH(IREGN).GE.ABSORB(NRGHIT) ) INFLAG = 2
 30   CONTINUE
C
C+++
C     IF(INFLAG.EQ.2) WRITE(6,99)IDTRK
C99   FORMAT(' TRACK ',I2,' REJECTED BY MULOCH')
C     WRITE(6,99) INEFF,NHLAYR,INFLAG,LOCHRS
C99   FORMAT(' INEFF,NHLAYR,INFLAG / LOCHRS ',3I3/2(X,30I3/))
C+++
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE MULOC2 (LQUAL,IP,ALLOW,SLOPE,ABSDCE,ABSORB,DEVIAT)
C-----------------------------------------------------------------------
C
C             THIS SUBROUTINE CALCULATES THE EXPECTED DEVIATION
C             AT A REGION SITTING BEHIND 'ABSDCE' OF ABSORBER
C             USING A STRAIGHT LINE WITH SLOPE 'SLOPE' AND PASSING
C             THROUGH A POINT WITH DEVIATION 'DEVIAT' SITTING BEHIND
C             'ABSORB' OF ABSORBER.
C
C     IP     IS A POINTER TO THE 1ST WORD IN REGDCE FOR THIS REGION
C     LQUAL  IS THE RETURNED QUALITY FLAG
C               2 = TRACK WAS INSIDE ACTIVE REGION
C               3 = TRACK PROBABLY WAS OUTSIDE ACTIVE REGION
C               4 = TRACK WAS ALMOST CERTAINLY OUTSIDE ACTIVE REGION
C     ALLOW  IS THE QUANTITY USED TO DETERMINE WHETHER A TRACK WAS CLOSE
C            TO THE EDGE OF THE ACTIVE REGION
C
C-----------------------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CMULOC/ ALLDEV(12,2),ALLABS(12),REGDEV(30),REGDCE(50),
     +                REGZE(50),LOCHRS(60),ABLOCH(60)
C
      ESTDEV = SLOPE * (ABSDCE - ABSORB) + DEVIAT
C
      IF(ESTDEV.GE.REGDCE(IP+2) .AND. ESTDEV.LE.REGDCE(IP+3))GO TO 2
        IF(ESTDEV+ALLOW.GE.REGDCE(IP+2)  .AND.
     +     ESTDEV-ALLOW.LE.REGDCE(IP+3)      ) GO TO 1
             LQUAL = 2
             RETURN
 1         LQUAL = 3
           RETURN
C
 2      LQUAL = 4
        RETURN
        END

**************************************************
* DLIB
* ====
*
*   Emulation of some DESYLIB routines, IBM FORTRAN 
*   intrinsics and further missing obsolete routines 
*   used by the JADE library.
*
*   06/10/98  P.A. Movilla Fernandez 
*
*   21/10/99  PMF last mod.
*   09/12/99  PMF last mod.
*
*     DAY
*     DAY2
*     IUHR
*     JUHR
*     NTIME
*     BINTIM
*     JOBNAM (dummy)
*     CORE   (dummy)
*     PTRANS (dummy)
*     GEPIC  (dummy)
*     GEPW   (dummy)
*
*     FNORM
*     RN
*     ARCOS
*     DARCOS
*     ARSIN
*
**************************************************
**************************************************

      SUBROUTINE DAY(DATE,TIME)
      IMPLICIT NONE
*
*  DAY is a DESYLIB routine ported to Fortran
*  using the CERNLIB routine DATIMH (Z007)
*
*  DAY calling sequence is
*    CALL DAY (DATE,TIME)
*
*    Returns DATE= dd/mm/yy, TIME= hh.mm.00 
*
      DOUBLE PRECISION DATE,TIME
C
      CALL DATIMH(DATE,TIME)
C      
      RETURN
      END

**************************************************
      SUBROUTINE DAY2(DAT)
      IMPLICIT NONE
*
*  DAY2 is a DESYLIB routine ported to Fortran
*  using the CERNLIB routines DATIME(Z007), CALDAT(Z009)
*
*  DAY2 calling sequence is
*    CALL DAY2 (DAT)
*
*    Returns DAT(1) = yy
*            DAT(2) = dd (1 ... 365)
*            DAT(3) = hh
*            DAT(4) = mm
*            DAT(5) = ss
* 
      INTEGER DAT(5),IDUMMY,IERR
      CHARACTER*119 CHREP
      INTEGER*1 ICHREP(119)
      EQUIVALENCE (ICHREP,CHREP)
      INTEGER ISL
      COMMON /SLATE/ ISL(40)
C
      CALL DATIME(IDUMMY,IDUMMY)
      DAT(1)=ISL(1)
      DAT(2)=0
      DAT(3)=ISL(4)
      DAT(4)=ISL(5)
      DAT(5)=ISL(6)
C
C CALCULATE DAY IN THE YEAR
C
      CALL CALDAT(0,CHREP,IDUMMY,IERR)
      IF(IERR.EQ.0.) THEN
         DAT(2)=(ICHREP(111)-48)*100
     +        +(ICHREP(112)-48)*10
     +        +(ICHREP(113)-48)
      ELSE
         WRITE (*,'('' CALDAT: ERROR'')') 
         DAT(2)=0
      ENDIF
C
      RETURN
      END
C
C Usage of CALDAT:
C
C    CHARACTER   DMY14*14,DMY11*11,DMY9*9,DMY10*10
C    CHARACTER*8 DMY8A,DMY8B,YMD8,MDY8,YDM8
C    CHARACTER*6 DMY6,       YMD6,MDY6,YDM6
C    CHARACTER   YD5*5,W4*4,W2*2
C    EQUIVALENCE
C   *   (CHREP(  1: 14), DMY14), (CHREP( 15: 25), DMY11),
C   *   (CHREP( 26: 34), DMY9 ), (CHREP( 35: 44), DMY10),
C   *   (CHREP( 45: 52), DMY8A), (CHREP( 53: 60), DMY8B),
C   *   (CHREP( 61: 66), DMY6 ), (CHREP( 67: 74), YMD8 ),
C   *   (CHREP( 75: 80), YMD6 ), (CHREP( 81: 88), MDY8 ),
C   *   (CHREP( 89: 94), MDY6 ), (CHREP( 95:102), YDM8 ),
C   *   (CHREP(103:108), YDM6 ), (CHREP(109:113), YD5  ),
C   *   (CHREP(114:117), W4   ), (CHREP(118:119), W2   )
C
CDetails of the substrings in argument CHREP and the corresponding IINDEX values:
C
C            EXAMPLE       IINDEX            EXAMPLE  IINDEX
C 
C    DMY14   16. APRIL 1982     1      YMD6  820416        9
C    DMY11   16 APR 1982        2      MDY8  04/16/82     10
C    DMY9    16 APR 82          3      MDY6  041682       11
C    DMY10   16. 4.1982         4      YDM8  82/16/04     12
C    DMY8A   16. 4.82           5      YDM6  821604       13
C    DMY8B   16/04/82           6      YD5   82106        14
C    DMY6    160482             7      W4    FRI.
C    YMD8    82/04/16           8      W2    FR

**************************************************
      INTEGER FUNCTION IUHR(NSEC)
      IMPLICIT NONE
*
*  IUHR is a DESYLIB function ported to a Fortran routine 
*  using the CERNLIB routines TIMEL,TIMEST (Z007)
*
*  Usage:
*    N = IUHR(NSEC)
*        N,NSEC: INTEGER*4
*        N=1 if remaining time .GE. NSEC
*        N=2 if remaining time .LT. NSEC
*
      INTEGER NSEC,JUHR
      REAL T,TMAX
      DATA TMAX/9999999.0/
C
*
*  JUHR is another DESYLIB function
*  which is handled here like IUHR
*
C
      ENTRY JUHR(NSEC)
C
      CALL TIMEST(TMAX)
      CALL TIMEL(T)
C
      IF (REAL(NSEC).LE.T) THEN
         IUHR=1
      ELSE
         IUHR=2
         WRITE(*,9001) T
 9001    FORMAT ( '  IUHR: TIME LIMIT REACHED, T=',F8.2)
      ENDIF
C      
      RETURN
      END

**************************************************
      INTEGER FUNCTION NTIME(NDUMMY)
      IMPLICIT NONE
*
*  NTIME is a DESYLIB function ported to a Fortran routine 
*  using the CERNLIB routines TIMEL,TIMEST (Z007)
*
*  Usage:
*    N = NTIME(NDUMMY)
*        N: INTEGER*4
*        N = execution time ]in units of 10 ms] remaining
*            until time-limit
*
      INTEGER NDUMMY
      REAL RTIME,TMAX
      DATA TMAX/9999999.0/
C
      CALL TIMEST(TMAX)
      CALL TIMEL(RTIME)
      NTIME = INT(RTIME*100.)
C      
      RETURN
      END

**************************************************
      INTEGER FUNCTION BINTIM(DUMMY)
      IMPLICIT NONE
*
* BINTIM is a DESYLIB function ported to Fortran
* using the CERNLIB routine DATIMH (Z007)
*
*  Usage:
*     ITIME=BINTIM(DUMMY)
*           ITIME: INTEGER*4
*           ITIME = time of the day [in units of 10 ms].
*
      INTEGER DUMMY,HH,MM,SS
      REAL*8 DATE,TIME
      CHARACTER*8 CTIME
      EQUIVALENCE(CTIME,TIME)
C
      CALL DATIMH(DATE,TIME)
      READ(CTIME,'(I2,1X,I2,1X,I2)') HH,MM,SS
      BINTIM=( HH*60*60 + MM*60 + SS )*100
C
      RETURN
      END

**************************************************
      SUBROUTINE JOBNAM(RR)
      IMPLICIT NONE
*
* JOBNAM is ( presumably ) a DESYLIB routine
*
*   Usage:
*     CALL JOBNAM(RR(1),RR(2))
*         RR: REAL*8
*         RR = userid (use Jan Olssons one).
*
      DOUBLE PRECISION RR(2),RR2(2)
      CHARACTER*8 CRR2(2)
      EQUIVALENCE (RR2(1),CRR2(1))
C
      CRR2(1)='F11OLS  '
      CRR2(2)='        '
      RR(1)=RR2(1)
      RR(2)=RR2(2)
C
      RETURN
      END


**************************************************
      SUBROUTINE CORE(H,I)
      IMPLICIT NONE
*
* CORE is a DESYLIB routine.
*
* If CORE has been called, then the following 
* WRITE or READ statement will not be executed on the
* output or input unit, but to or from the indicated 
* memory area. Thus the unit number in WRITE and READ is 
* then a dummy, for this one use after CALL CORE.
*
* CORE is here a dummy routine, and the functionality
* described above must be implemented in the calling 
* procedure via a modified READ and WRITE statement.
*
* e.g.:
*         COMMON /CWORK1/ HWORK(40)
*         [...]
*         IILIM = 6*ILIM + 1
*         CALL CORE(HWORK,IILIM)
*         WRITE(JUSCRN,504) (HWORK(LLO+100),LLO=1,ILIM)
*  504    FORMAT(' ',20I6)
*         CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
*
* Possible replacement:
*
*        COMMON /CWORK1/ HWORK(40)
*        CHARACTER cHWORK*80                           <-- new
*        EQUIVALENCE (cHWORK,HWORK(1))                 <-- new
*        [...]
*        IILIM = 6*ILIM + 1
*        CALL CORE(HWORK,IILIM)                        <-- is now a dummy routine
*        WRITE(cHWORK,504) (HWORK(LLO+100),LLO=1,ILIM) <-- write into character string
*  504   FORMAT(' ',20I6)
*        CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
*        
* where cHWORK is a CHARACTER string equivalenced with the array
* argument of subroutine CORE.
*
      INTEGER*2 H(*)
      INTEGER I
C
      RETURN
      END

*****************************************************
      SUBROUTINE PTRANS(I,J)
      IMPLICIT NONE
*
* Needed for some translations of the internal graphics
* in order to be able to print on a laser printer.
*
* This is here a dummy routine.
*
      INTEGER I,J
Code:
      RETURN
      END

****************************************************
      SUBROUTINE GEPIC
      IMPLICIT NONE
*
      RETURN
      END

****************************************************
      SUBROUTINE GEPW
      IMPLICIT NONE
*
      RETURN
      END
**************************************************

**************************************************
      DOUBLE PRECISION FUNCTION FNORM(DUMMY)
      IMPLICIT NONE
*
*  FNORM is an old  DESYLIB function which is here 
*  emulated using the CERNLIB function RNORML (MATHLIB).
*  FNORM generates Gaussian distributed random numbers.
*
*  ---
*  N.B: RNORML uses RANMAR, so it may be initialized by calling RMARIN,
*       but note that this also initializes RANMAR ! 
*  ---
*
*  usage:
*   F = FNORM(DUMMY)
*         
*        F: REAL*8
*           Gaussian distributed random number
*
      REAL FN,DUMMY
C
      CALL RNORML(FN,1)
      FNORM=DBLE(FN)
C
      RETURN
      END
**************************************************
      REAL FUNCTION RN(DUMMY)
      IMPLICIT NONE
*
*  RN is an old DESYLIB function which is here 
*  emulated using the CERNLIB function RANMAR (MATHLIB) 
*  RN generates uniformly distributed random numbers
*  between 0. and 1.  (0. and 1. excluded)
*
* ---
*  N.B: Initialization is made by
*       CALL RMARIN(IA,IB,IC)
*       IA: Seed from wich to start a sequence 
*           Every INTEGER number from 1 to 900000000
*           originates an independent sequence of
*           random numbers. 
*       IB: Number of random number generated  mod 10^9
*       IC: Number of random number generated    * 10^9
*
*       Above arguments are returned by CALL RMARUT(IA,IB,IC)
* ---
*
*  usage:
*   R = RN(DUMMY)
*         
*        RN: REAL
*            uniformly distributed random number between 0. and 1.
*
      REAL DUMMY
C
      CALL RANMAR(RN,1)
C
      RETURN
      END
**************************************************

**************************************************
      REAL FUNCTION ARCOS(ARG)
      IMPLICIT NONE
*
      REAL ARG,ACOS
      ARCOS = ACOS(ARG)
      RETURN
      END
**************************************************
      DOUBLE PRECISION FUNCTION DARCOS(ARG)
      IMPLICIT NONE
*
      DOUBLE PRECISION ARG,DACOS
      DARCOS = DACOS(ARG)
      RETURN
      END
**************************************************
      REAL FUNCTION ARSIN(ARG)
      IMPLICIT NONE
*
      REAL ARG,ASIN
      ARSIN = ASIN(ARG)
      RETURN
      END
**

C   18/01/84 401181641  MEMBER NAME  USER     (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE USER( INDEX )
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL   ?/??/78 :  USER ROUTINE FOR JADEZ
C
C   LAST MOD: C. BOWDERY  13/12/83 :  SCRATCH MUON BANKS BEFORE LEVEL 9
C
C
C        USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C        THIS IS THE INTERACTIVE VERSION FOR THE GRAPHICS PROGRAM.
C
C-----------------------------------------------------------------------
C
C        INDEX IS PASSED FROM SUPERV TO INDICATE WHICH LEVEL HAS BEEN
C        COMPLETED. THE MEANING OF THE VALUES IS EXPLAINED BELOW.
C
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO /BCS/.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE + JETCAL
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGY CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   UNUSED LEVEL
C              9   MUON ANALYSIS HAS BEEN DONE
C             10   UNUSED LEVEL
C            100   END OF JOB CALL
C
C   ON RETURN, IF INDEX =  1 : THE SUPERVISOR WILL DROP CURRENT EVENT
C                              AND READ THE NEXT ONE.
C                         11 : EVENT WILL BE WRITTEN OUT AND NEW EVENT
C                              WILL BE READ
C                         12 : JOB WILL BE TERMINATED NORMALLY
C
C   OTHERWISE THE SUPERVISOR WILL GO TO THE LEVEL GIVEN BY "INDEX" ON
C   RETURN FROM "USER". THUS, TO CONTINUE WITH THE ANALYSIS, THIS
C   ROUTINE MUST INCREMENT "INDEX" BEFORE PASSING CONTROL BACK.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cgraph.for"
C
#include "cdata.for"
C
      DATA NREC / 0 /
C
C------------------  C O D E  ------------------------------------------
C
C                            CHECK WHETHER CALL AT END OF JOB
C
      IF( INDEX .EQ. 100 ) GO TO 1100
C
C                            CHECK FOR INDEX = 0
C
      IF( INDEX .GT. 0 ) GO TO 1
C
C                - 0 -       INITIALISATION.
C
C                            CLEAR FLAGS BY WHICH THE ANALYSIS  PROGRAM
C                            REQUESTS SCANNER HELP.
C
      DO   1000  I = 1,10
        PSTPS(I)=.FALSE.
 1000 CONTINUE
C
C                            DUMMY, TEMPORARY EVENT TYPE LABEL.
C
      LABEL = -1
C
      INDEX = INDEX + 1
      RETURN
C
C                            HANDLE POSITIVE INDEX VALUES.
C                            JUMP TO APPROPRIATE SECTION USING INDEX
C                            E.G. IF LEVEL 7 HAS JUST BEEN DONE --> 100700000810
C                            CARRY OUT TASKS FOR THE LEVEL THEN
C                            GO AND CALL SCANNR (IF A "STOP" REQUESTED)
C
  1   GO TO (1001,1002,1003,1004,1005,1006,1007,1008,1009,1010),INDEX
C
C                - 1 -       NEW RUN
C
 1001 ILSTOP = 0
      GO TO 3000
C
C                - 2 -       EVENT HAS BEEN READ IN
C
C                            CLEAR FLAGS BY WHICH THE ANALYSIS  PROGRAM
C                            REQUESTS SCANNER HELP.
C
 1002 DO   2000  I = 1,10
        PSTPS(I) = .FALSE.
 2000 CONTINUE
      ILSTOP = 1
C
      NREC = NREC + 1
      GO TO 3000
C
C                - 3 -       LG ENERGIES HAVE BEEN COMPUTED
C
 1003 CONTINUE
      GO TO 3000
C
C                - 4 -       JET CHAMBER CALIBRATED & FAST Z VERTEX DONE
C
 1004 CONTINUE
      GO TO 3000
C
C                - 5 -       PATREC HAS BEEN DONE
C
 1005 CONTINUE
      GO TO 3000
C
C                - 6 -       LG CLUSTERS FOUND
C
 1006 CONTINUE
      GO TO 3000
C
C                - 7 -       LG CLUSTERS JOINED TO ID TRACKS
C
 1007 CONTINUE
      GO TO 3000
C
C                - 8 -       NOTHING FURTHER HAS BEEN DONE
C
 1008 CONTINUE
      GO TO 3000
C
C                - 9 -       MUON ANALYSIS HAS BEEN DONE
C
 1009 CONTINUE
      GO TO 3000
C
C               - 10 -       NOTHING FURTHER HAS BEEN DONE
C
 1010 CONTINUE
      GO TO 3000
C
C                            END OF JOB: FINAL CALCULATIONS +  PRINTOUT
C
 1100 CONTINUE
      RETURN
C
C                            IF A "STOP" HAS BEEN REQUESTED, THEN CALL
C                            S/R SCANNR TO HANDLE THE INTERACTIVE
C                            DIALOGUE WITH THE "HUMAN USER" !
C
 3000 IF( SSTPS(INDEX) .OR. PSTPS(INDEX) ) CALL SCANNR( INDEX,IRFLG )
      IF( ILSTOP .EQ. 0 ) GO TO 3001
      KNTR = 0
C
 3002 KNTR = KNTR + 1
      NSET = LSTPS(KNTR)
      IF( NSET .EQ. 0 ) GO TO 3001
      IF( NSET .NE. LABEL ) GO TO 3003
C
      WRITE(JUSCRN,101) LABEL,INDEX
  101 FORMAT('PROGRAM HALTED BY LABEL=',I5,'   USER INDEX=',I5)
C
      CALL TRMOUT(80,'DO YOU WISH TO STOP AT SUBSEQUENT USER ENTRIES^')
      CALL TRMOUT(80,'IN THIS EVENT?^')
      CALL DECIDE(IANSWR)
      IF( IANSWR .EQ. 2 ) ILSTOP = 0
C
      CALL SCANNR( INDEX,IRFLG )
C
 3003 IF( KNTR .EQ. 10 ) GO TO 3001
      GO TO 3002
C
C                            INCREMENT INDEX TO GO TO NEXT LEVEL
C
 3001 IF( INDEX .NE. 8 ) GO TO 4000
C
C                            SCRATCH EXISTING MUON RESULTS BEFORE L9
C
      CALL BMLT(2,'MUR1MUR2')
      CALL BDLM
 4000 INDEX = INDEX + 1
      RETURN
      END

C   09/03/84 602121755  MEMBER NAME  PICK     (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PICK
C-----------------------------------------------------------------------
C
C   AUTHOR:  J. HAGEMANN   12/02/86 : PICKS COORDINATES FROM SCREEN
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CGAMOD / MODEGA, GAHEX
      COMMON / CWORK1 / HWORK(40),SIZEWN,RANGE,XCENT,YCENT
C
C------------------  C O D E  ------------------------------------------
C
C                            CLEAR TSO TERMINAL IF RUNNING IN GA-MODE
C
      IF( MODEGA .EQ. 1 ) CALL CLEAR
C
C                            CHECK IF PICK IS POSSIBLE FOR THIS VIEW
      IF( LASTVW .GT. 11 .AND. LASTVW .LT. 17 ) GO TO 4000
C
C                            FLASH CURSOR ON SCREEN AND AWAIT RESULT
C
      CALL VCURSR(HWORK(1),XGET,YGET)
C
      IF( LASTVW.LT.4 .OR. LASTVW.EQ.17 .OR. LASTVW.EQ.20 ) GO TO 900
C
         IF( (LASTVW .GT. 3 .AND. LASTVW .LT. 8) .OR. LASTVW .EQ. 18 )
     *      GO TO 800
C
            WRITE(6,9700) XGET, YGET
 9700       FORMAT(' Z : ',F10.3,'  Y : ',F10.3)
            GO TO 5000
C
  800 WRITE(6,9800) XGET, YGET
 9800 FORMAT(' Z : ',F10.3,'  X : ',F10.3)
      GO TO 5000
C
  900 XGET = -XGET
      WRITE(6,9900) XGET, YGET
 9900 FORMAT(' X : ',F10.3,'  Y : ',F10.3)
C
      GO TO 5000
C
 4000 CALL TRMOUT(80,' Sorry, PICK not available for this view!^')
C
 5000 CONTINUE
C
      RETURN
      END

C   10/05/82 706081430  MEMBER NAME  RDTRG10  (JADEGS)      FORTRAN
      SUBROUTINE RDTRG1
C-----------------------------------------------------------
C  VERSION OF 31/07/79  LAST MOD 15/11/81    E.ELSEN
C      MODIFIED TO CONFORM WITH RDTRIG  10.8.83   J.OLSSON
C
C  EXTENSION AND MODIFICATION 7/86
C
C   LAST CHANGE 08.6.87
C
C  NOTE!!  CHANGES IN RDTRG1 OR RDTRG2 NORMALLY SHOULD BE ACCOMPANIED
C          BY CHANGES IN PRSTAT !!
C
C  FILL TRIG 1 BANK ACCORDING TO JADE COMPUTER NOTE 23 A, JN32:SUPPL.5
C  FILL LATC 0 BANK ACCORDING TO JADE NOTE 32
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION HW(1)
      EQUIVALENCE ( HW(1), IW(1) )
C
      COMMON / CWORK / HBP(24), HTOF(42), IRES(8), NLGBR(42), NLGQ(8),
     *                 NTAG(2)
C
C MASK IS BLOCK DATA SET IN RDTRIG
      COMMON /CMASK/ MASK(16),MASK4,MASK3,MASK2,MASK1,HKRE(3,8)
C
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C                                           BIT PACKING FUNCTION
      IBPAT(NUM) = MAX0( MIN0(NUM,7)*2, 1 )
C
      IYEAR = IHIST(3)
      IYEAR = MOD(IYEAR,100)
      IF(IYEAR.LT.82) GO TO 3231
C FOR 1982 AND LATER, CALL SUBR. RD82T1
      CALL RD82T1
      RETURN
C
C     >>>>>>>>>>   TRIGGER SIMULATION FOR 1979-1981  <<<<<<<<<<
C
3231  CONTINUE
C                                           CREATE TRIG, 1
      CALL CCRE( NPTRIG, 'TRIG', 1, 5, IER )
      IF( IER .EQ. 2 ) GO TO 8000
      CALL BSAW( 1, 'TRIG' )
      NTRIG2 = NPTRIG * 2
      IW(NPTRIG+1) = LOR(IW(NPTRIG+1),MASK1)
C
C                                           CREATE LATC, 0
      CALL BDLS( 'LATC', 0 )
      CALL CCRE( NPLATC, 'LATC', 0, 14, IER )
      IF( IER .EQ. 2 ) GO TO 8100
      CALL BSAW( 1, 'LATC' )
      NLATC2 = NPLATC * 2
      IW(NPLATC+1) = LOR(IW(NPLATC+1),MASK1)
C                                           BP COUNTER MULTIPLICITY
      NBP = 0
      NPATBP = IW(IBLN('ATBP'))
      IF( NPATBP .EQ. 0 ) GO TO 200
      NATBP2 = NPATBP * 2
      DO 100 IBP = 1,24
      HBP(IBP) = 0
      J = IBP + (IBP-1)/8 + 54
      IF( HW(NATBP2+J) .GE. 2048 ) GO TO 100
      NBP = NBP + 1
      HBP(IBP) = 1
C                                           LATCHES
      NW = ( IBP - 1 ) / 8
      IBT = IBP - NW*8
      HW(NLATC2+NW+3) = LOR( HW(NLATC2+NW+3), MASK(IBT) )
  100 CONTINUE
C                                NTOF,      TOF COUNTER MULTIPLICITY
  200 NTOF = 0
      NPATOF = IW(IBLN('ATOF'))
      IF( NPATOF .EQ. 0 ) GO TO 400
      NATOF2 = NPATOF * 2
      DO 300 ITOF = 1,42
      HTOF(ITOF) = 0
      J = ITOF*2 + (ITOF-1)/4 + 92
      IF( (HW(NATOF2+J)+HW(NATOF2+J+1)) .GE. 4096 ) GO TO 300
      NTOF = NTOF + 1
      HTOF(ITOF) = 1
C                                           LATCHES
      NW = ( ITOF - 1 ) / 7
      IBT = ITOF - NW*7
      HW(NLATC2+NW+6) = LOR( HW(NLATC2+NW+6), MASK(IBT) )
  300 CONTINUE
C
C                                           TOF AND BP MATRIX
C                                           IRES BUFFERS RESULT
  400 NBPM = 0
      NTOFM = 0
      CALL VZERO( IRES, 8 )
      IF( NTOF .LE. 0 ) GO TO 600
      IF( NBP .LE. 0 ) GO TO 600
      DO 510 ITOF = 1,42
      IF( HTOF(ITOF) .EQ. 0 ) GO TO 510
      JC = 4*ITOF + 165
      JL = ( JC - NBPTFW -1 ) / 7 + 1
      JH = ( JC + NBPTFW ) / 7
      DO 500 J = JL, JH
      IBP = MOD( J - 1, 24 ) + 1
      IF( HBP(IBP) .EQ. 0 ) GO TO 500
C                                           BP IN IRES(7-8), 2 BYTES USE
      IWORD = ( IBP - 1 ) / 16 + 7
      IBIT = IBP - ( IWORD - 7 ) * 16
      IRES(IWORD) = LOR( IRES(IWORD), MASK(IBIT) )
C
      IF( HBP(IBP) .EQ. 1 ) NBPM = NBPM + 1
      HBP(IBP) = 10
C                                           TOF IN IRES(1-6), 1 BYTE USE
      IF( HTOF(ITOF) .NE. 1 ) GO TO 500
      IWORD = ( ITOF-1 ) / 7 + 1
      IBIT = ITOF - ( IWORD - 1 ) * 7
      IRES(IWORD) = LOR( IRES(IWORD), MASK(IBIT) )
      NTOFM = NTOFM + 1
      HTOF(ITOF) = 10
  500 CONTINUE
  510 CONTINUE
C
C                                           LOAD FIRST HALF OF TRIG, 1
  600 HW(NTRIG2+3) = IBPAT(NTOFM) * 16 + IBPAT(NBPM)
      HW(NTRIG2+3) = HW(NTRIG2+3)*256 + IBPAT(NTOF) * 16 + IBPAT(NBP)
      HW(NTRIG2+4) = IRES(2)*256 + IRES(1)
      HW(NTRIG2+5) = IRES(4)*256 + IRES(3)
      HW(NTRIG2+6) = IRES(6)*256 + IRES(5)
      HW(NTRIG2+7) = IRES(7)
      HW(NTRIG2+8) = IRES(8)
C
C                                           TRIGGER CONDITIONS
C                                           LEAD GLASS ENERGY
C                                           ASSUMING NUMBERING 0-31 ETC
C
C   LGNE IS TOTAL ENERGY
C
C
 1000 IETOT = 0
      CALL VZERO( NLGBR, 50 )
      NLGE = 0
      NPALGN = IW( IBLN('ALGN' ) )
      IF( NPALGN .EQ. 0 ) GO TO 1200
      NALGN2 = NPALGN*2
      IL = NALGN2 + 6 + HW(NALGN2+3)
      IH = NALGN2 + 4 + HW(NALGN2+6)
      IF( IH .LT. IL ) GO TO 1200
      DO 1100 J=IL,IH, 2
      NBLO = HW(J)
      NAMP = HW(J+1)
      NLGE = NLGE + NAMP
      IF( NBLO .GT. 2687 ) GO TO 1060
      NBLO = NBLO - 32
      IF( NBLO .LT. 0 ) NBLO = NBLO +2688
      KL1 = NBLO / 64 + 1
      KL2 = KL1 + 1
      KL3 = KL2 + 1
      IF( KL2 .GT. 42 ) KL2 = KL2 - 42
      IF( KL3 .GT. 42 ) KL3 = KL3 - 42
      NLGBR(KL1) = NLGBR(KL1) + NAMP
      NLGBR(KL2) = NLGBR(KL2) + NAMP
      NLGBR(KL3) = NLGBR(KL3) + NAMP
      GO TO 1100
C                                           END CAP
 1060 KL = ( NBLO-2688 ) / 24 + 1
      NLGQ(KL) = NLGQ(KL) + NAMP
C
 1100 IETOT = IETOT + NAMP
C
C                                           LG-ROW LATCHES
      DO 1110 J=1,42
      IF( NLGBR(J) .LE. HLGBRT ) GO TO 1110
      NW = (J-1)/7
      IBT = J-NW*7
      HW(NLATC2+NW+12) = LOR( HW(NLATC2+NW+12), MASK(IBT) )
 1110 CONTINUE
C                                           LG-END CAP LATCHES
      DO 1120 J=1,8
      IF( NLGQ(J) .LE. HLGQT  ) GO TO 1120
      HW(NLATC2+18) = LOR( HW(NLATC2+18), MASK(J) )
 1120 CONTINUE
C                                           TOTAL ENERGY LATCHES
C    4 LOWER BITS FOR THE VARIOUS THRESHOLDS, BIT 4 IS THE HIGHEST
C
      DO 1130 J=1,4
      IF( NLGE .LE. HLGTOT(J,1))  GO TO 1130
      HW(NLATC2+23) = LOR( HW(NLATC2+23), MASK(J) )
 1130 CONTINUE
C
C                                           COLLINEARITY TRIGGER
 1200 ICOLL = 0
      IF( NTOF .EQ. 0 ) GO TO 1270
      DO 1260 J = 1,42
      IF( HTOF(J) .EQ. 0 ) GO TO 1260
      JLO = J + 21 - IWCOLL
      JHI = J + 21 + IWCOLL
      DO 1250 JOP = JLO,JHI
      I = MOD( JOP - 1, 42 ) + 1
      IF( HTOF(I) .EQ. 0 ) GO TO 1250
      ICOLL = 1
      GO TO 1270
 1250 CONTINUE
 1260 CONTINUE
 1270 CONTINUE
C
C                                           NARROW COLLINEARITY
 1300 ICOLLN = 0
      IF( NTOF .EQ. 0 ) GO TO 1370
C     IF( HWCOLN .NE. 1 ) GO TO 1370
      IF(IHIST(3).LT.1981) GO TO 1370
      DO 1360 J = 1,42
      IF( HTOF(J) .EQ. 0 ) GO TO 1360
      JLO = J + 21 - IWCOLN
      JHI = J + 21 + IWCOLN
      DO 1350 JOP = JLO,JHI
      I = MOD( JOP - 1, 42 ) + 1
      IF( HTOF(I) .EQ. 0 ) GO TO 1350
      ICOLLN = 1
      GO TO 1370
 1350 CONTINUE
 1360 CONTINUE
 1370 CONTINUE
C
C                                           MULTIPRONG TRIGGER
      IMPRG = 0
      IF( NTOF .EQ. 0 ) GO TO 1800
      IF( HMPRON .NE. 1 ) GO TO 1800
      DO 1700 J = 1,42
      IF( HTOF(J) .EQ. 0 ) GO TO 1700
      JLO = J + 21 - IWMPRG
      JHI = J + 21 + IWMPRG
      DO 1600 JOP = JLO,JHI
      I = MOD( JOP - 1, 42 ) + 1
      IF( HTOF(I) .EQ. 0 ) GO TO 1600
      IMPRG = 1
      GO TO 1800
 1600 CONTINUE
 1700 CONTINUE
 1800 CONTINUE
C
C                                            TAGGING LATCHES
C   THE TAGG BANK CONTAINS ADC COUNTS, MATCH AGAINST THRESHOLDS BY
C   USE OF THE AVERAGE CONVERSION CONSTANT  TAGADC
C   IN 1979-1981, EITHER MARK 1 OR MARK 2 TAGGER, NO BLOCKS EXCLUDED
C    WHEN SETTING THE TRIGGER
C
      ITAG = 0
      NPATAG = IW(IBLN('ATAG'))
      NATAG2 = NPATAG * 2
      IF( NATAG2 .LE. 0 ) GO TO 3000
      NBAS = NATAG2 + 7
      DO 2400 J=1,2
      NH = HW(NATAG2+J+3) - 2
      NL = HW(NATAG2+J+2)
      NTAG(J) = 0
      IF( NL .GT. NH ) GO TO 2300
      DO 2200 I=NL, NH, 2
      NAMP = HW(NBAS+I)
      NTAG(J) = NTAG(J) + NAMP
 2200 CONTINUE
 2300 CONTINUE
      NTAG(J) = NTAG(J) * TAGADC
 2400 CONTINUE
C                                           THRESHOLDS
      IF( NTAG(1) .LT. HLGTL ) GO TO 2410
      ITAG = ITAG + 1
      HW(NLATC2+20) = LOR( HW(NLATC2+20), MASK(13) )
      IF( NTAG(1) .GT. HLGTH )
     *                 HW(NLATC2+20) = LOR( HW(NLATC2+20), MASK(14) )
 2410 IF( NTAG(2) .LT. HLGTL ) GO TO 3000
      ITAG = ITAG + 1
      HW(NLATC2+20) = LOR( HW(NLATC2+20), MASK(15) )
      IF( NTAG(2) .GT. HLGTH )
     *                 HW(NLATC2+20) = LOR( HW(NLATC2+20), MASK(16) )
C  LUMI BIT
      IF( NTAG(1) .GT. HLGTH.AND.NTAG(2).GT.HLGTH )
     *                        HW(NLATC2+20) = HW(NLATC2+20) + 64
 3000 CONTINUE
C
C ------------------------------------  T1- ACCEPT CONDITIONS
C
      IACC = 0
C
C                     LUMI-TRIGGER
C
      IF( NTAG(1) .GT. HLGTH.AND.NTAG(2).GT.HLGTH )
     $ IACC = LOR( IACC, MASK(1) )
C
C                     TOTAL ENERGY TRIGGER
C
      IF(IETOT .GT.HLGTOT(1,1)) IACC = LOR( IACC, MASK(2) )
C
C                     TAG+LG ENERGY TRIGGER
C
      IF(ITAG.GT.0.AND.IETOT.GT.HLGTOT(2,1)) IACC=LOR(IACC,MASK(3))
C
C ------------------------------------- T1- POSTPONE CONDITIONS
C
      IPOST = 0
C
C                 TOF + LG ENERGY
C
      IF(NTOF.GE.NTOFC.AND.IETOT.GE.HLGTOT(3,1))IPOST=LOR(IPOST,MASK(1))
C
C                 TAGG
C
      IF( ITAG .GT. 0 ) IPOST = LOR( IPOST, MASK(2) )
C
C                 COLLINEAR TOF, WIDE
C
      IF(ICOLL.EQ.1 .AND. NTOF.LT.NTFCOL) IPOST = LOR( IPOST, MASK(5) )
C
C                 COLLINEAR TOF, NARROW
C
      IF(ICOLLN.EQ.1 .AND. NTOF.LT.NTFCLN) IPOST = LOR(IPOST,MASK(6))
C
C                 COLLINEAR TOF, WIDE MULTIPRONG
C
      IF(IMPRG.EQ.1 .AND. NTOF.LE.HFMPRH .AND. NTOF.GE.HFMPRL )
     *                                    IPOST = LOR( IPOST, MASK(7) )
C -------------------------------------------------
C                                           FINAL TRIGGER WORDS
C
      HW(NTRIG2+10) = IACC*256 + IPOST
      HW(NTRIG2+ 1) = 0
      HW(NTRIG2+ 2) = 0
      RETURN
C
C                                           NO SPACE IN BCS LEFT
 8000 WRITE(6,9101)
 9101 FORMAT(/' NOT ENOUGH SPACE IN BCS LEFT FOR CREATION OF TRIG, 1'/)
      RETURN
 8100 WRITE(6,9102)
 9102 FORMAT(/' NOT ENOUGH SPACE IN BCS LEFT FOR CREATION OF LATC, 0'/)
      RETURN
      END
      SUBROUTINE RD82T1
C-----------------------------------------------------------
C  VERSION OF 31/07/79  LAST MOD 17/05/82    J.OLSSON
C        NTBG -- NTOFBG BUG CORRECTED 27.2.1984   J.OLSSON
C   SETTING OF KREHBIEL TRIGGER, BUG CORRECTED 8.6.1987  J.OLSSON
C  FILL TRIG 1 BANK ACCORDING TO JADE NOTE 82
C  FILL LATC 0 BANK ACCORDING TO JADE NOTE 82, JADE NOTE 32:4
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION HW(1),HELP(2)
      EQUIVALENCE ( HW(1), IW(1) ),(ICAMWD,HELP(1))
      COMMON /CMASK/ MASK(16),MASK4,MASK3,MASK2,MASK1,HKRE(3,8)
C
      COMMON / CWORK / HTOF(42),NLGBR(42),NLGQ(8),NTAG(2),HTBG(42),
     *                 NBG(42),NBS(7),HBG(42),NECA(2),NETOT(2),
     *                 NQARR(8),NBARR(7)
C
C  HTOF:  TOF COUNTER LATCHES
C  NLGBR: ENERGY OF BARREL SUB-GROUPS, IMMEDIATELY BEHIND TOF-COUNTER
C  NLGQ:  ENERGY OF END CAP QUADRANTS
C  NTAG:  ENERGY OF TAGGING END CAPS
C  HTBG:  LATCHES FOR TBG
C  NBG:   ENERGY OF BARREL GROUPS  (SUMS OF 3 NLGBR ELEMENTS)
C  NBS:   ENERGY OF LEAD GLASS SEPTANTS
C  HBG:   LATCHES FOR BARREL GROUPS
C  NECA:  ENERGY OF END CAPS
C  NETOT: TOTAL ENERGY AND BARREL ENERGY
C  NQARR: LATCHES FOR END CAP QUADRANTS
C  NBARR: LATCHES FOR SEPTANTS
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C
      DATA HELP/0,0/
C
      IBPAT(NUM) = MAX0( MIN0(NUM,7)*2, 1 )
C                                           BIT PACKING FUNCTION
C                        IBPAT OUTPUT:     NUM = 0 -->  IBPAT = 1
C                                          NUM = 1-7 --> IBPAT = 2*NUM
C                                          NUM > 7 --> IBPAT = 2*7
C
C                                           CREATE TRIG, 1
      LTRIGL = 5
      IF(IHIST(3).GT.1984) LTRIGL = 6
C
      CALL CCRE( NPTRIG, 'TRIG', 1, LTRIGL, IER )
      IF( IER .EQ. 2 ) GO TO 8000
      CALL BSAW( 1, 'TRIG' )
      NTRIG2 = NPTRIG * 2
      IF(IHIST(3).LT.1985) IW(NPTRIG+1) = LOR(IW(NPTRIG+1),MASK2)
      IF(IHIST(3).GT.1984) IW(NPTRIG+1) = LOR(IW(NPTRIG+1),MASK4)
C
C                                           CREATE LATC, 0
      CALL BDLS( 'LATC', 0 )
      CALL CCRE( NPLATC, 'LATC', 0, 14, IER )
      IF( IER .EQ. 2 ) GO TO 8100
      CALL BSAW( 1, 'LATC' )
      NLATC2 = NPLATC * 2
C BANK DESCRIPTOR 2
      IW(NPLATC+1) = LOR(IW(NPLATC+1),MASK2)
C                                           ****************************
C                                           *   SCINTILLATOR LATCHES   *
C                                           ****************************
      IF(IHIST(3).GT.1983) GO TO 200
C                                           BP COUNTER LATCHES
      NPATBP = IW(IBLN('ATBP'))
      IF( NPATBP .EQ. 0 ) GO TO 200
      NATBP2 = NPATBP * 2
      DO 100 IBP = 1,24
      J = IBP + (IBP-1)/8 + 54
      IF( HW(NATBP2+J) .GE. 2048 ) GO TO 100
      NW = ( IBP - 1 ) / 8
      IBT = IBP - NW*8
      HW(NLATC2+NW+3) = LOR( HW(NLATC2+NW+3), MASK(IBT) )
  100 CONTINUE
C                                NTOF,      TOF COUNTER MULTIPLICITY
C                                           LATCHES
  200 NTOF = 0
      NPATOF = IW(IBLN('ATOF'))
      IF( NPATOF .EQ. 0 ) GO TO 400
      NATOF2 = NPATOF * 2
      DO 300 ITOF = 1,42
      HTOF(ITOF) = 0
      J = ITOF*2 + (ITOF-1)/4 + 92
      IF( (HW(NATOF2+J)+HW(NATOF2+J+1)) .GE. 4096 ) GO TO 300
      NTOF = NTOF + 1
      HTOF(ITOF) = 1
      NW = ( ITOF - 1 ) / 7
      IBT = ITOF - NW*7
      HW(NLATC2+NW+6) = LOR( HW(NLATC2+NW+6), MASK(IBT) )
  300 CONTINUE
C
 400  CONTINUE
C                                           ****************************
C                                           *     LEAD GLASS ARRAYS    *
C                                           ****************************
C
C    FILL LEAD GLASS ARRAYS:  NLGBR FOR BARREL ROWS
C                             NBG FOR BARREL GROUPS
C                             NBS FOR BARREL SEPTANCES
C                             NLGQ FOR ENDCAP QUADRANTS
C                NUMBERING 0-31 ETC  FOR LEAD GLASS BLOCKS
C
C       I           I        I-----------I
C       I           I        I           I
C       I           IBRG NR 2I-----------I
C       I           I        I           I
C       I           I        I-----------I  I
C       I           I        I           I  I
C       I BG NR 1   IBRG NR 1I-----------I  I FI = 0   TOF NR 1
C       I           I        I           I  I
C       I           I        I-----------I  I
C       I           I        I           I
C       I           IBRG NR42I-----------I
C       I           I        I           I
C       I           I        I-----------I
C
 1000 CONTINUE
      CALL VZERO( NLGBR,147 )
      NPALGN = IW( IBLN('ALGN' ) )
      IF( NPALGN .EQ. 0 ) GO TO 1200
      NALGN2 = NPALGN*2
      IL = NALGN2 + 6 + HW(NALGN2+3)
      IH = NALGN2 + 4 + HW(NALGN2+6)
      IF( IH .LT. IL ) GO TO 1200
      DO 1100 J=IL,IH, 2
      NBLO = HW(J)
      NAMP = HW(J+1)
      NETOT(1) = NETOT(1) + NAMP
      IF( NBLO .GT. 2687 ) GO TO 1060
C                            BARREL ROWS
      NETOT(2) = NETOT(2) + NAMP
      NBLO = NBLO + 32
      IF( NBLO.GT.2687) NBLO = NBLO -2688
      KL1 = NBLO / 64 + 1
      NLGBR(KL1) = NLGBR(KL1) + NAMP
      GO TO 1100
C                                           END CAP QUADRANTS
 1060 KL = ( NBLO-2688 ) / 24 + 1
      NLGQ(KL) = NLGQ(KL) + NAMP
 1100 CONTINUE
C
 1200 CONTINUE
      DO 1101  I = 1,42
      HTBG(I) = 0
      HBG(I) = 0
      NBG(I) = 0
      J = I-1
      K = I+1
      IF(J.LE.0) J = 42
      IF(K.GT.42) K = 1
      NBG(I) = NLGBR(I) + NLGBR(J) + NLGBR(K)
      IF(NBG(I).GE.HLGBRT) HBG(I) = 1
      IF(HBG(I).GT.0.AND.HTOF(I).GT.0) HTBG(I) = 1
1101  CONTINUE
C                           SEPTANTS
      DO 7  J = 1,7
      NBS(J) = 0
      DO 7  I = 1,6
      K = (J-1)*6 + I - 3
      IF(K.LE.0) K = K + 42
      NBS(J) = NBS(J) + NLGBR(K)
7     CONTINUE
C                                           ****************************
C                                           *   LEAD GLASS LATCHES     *
C                                           ****************************
C
C             SET LATCHES FOR BARREL GROUPS, NBG
C
      J1 = NLATC2 + 14
      J2 = NLATC2 + 19
      DO 32 JK = J1,J2
      HELP(2) = 0
      IE = (JK-J1)*7
      DO 33 IBT = 1,7
      IF = IE + IBT
      IF(HBG(IF).NE.1) GO TO 33
      ICAMWD = LOR(ICAMWD,MASK(IBT))
33    CONTINUE
      HW(JK) = HELP(2)
32    CONTINUE
C
C             SET LATCHES FOR BARREL GROUPS WITH TOF, TBG
C
      NTOFBG = 0
      IF(NTOF.EQ.0) GO TO 1700
      J1 = NTRIG2 + 5
      J2 = NTRIG2 + 7
      DO 42 JK = J1,J2
      HELP(2) = 0
      IE = (JK-J1)*14
      DO 43 IBT = 1,14
      IF = IE + IBT
      IG = IBT
      IF(IBT.GT.7) IG = IG + 1
      IF(HTBG(IF).NE.1) GO TO 43
      NTOFBG = NTOFBG + 1
      ICAMWD = LOR(ICAMWD,MASK(IG))
43    CONTINUE
      HW(JK) = HELP(2)
42    CONTINUE
C
C             SET LATCHES FOR BARREL SEPTANTS, NBS
C    NRNBS IS TOTAL NR OF SEPTANTS SET
C
1700  J3 = NLATC2 + 20
      HELP(2) = 0
      NRNBS = 0
      DO 34 IBT = 1,7
      NBARR(IBT) = 0
      IF(NBS(IBT).LT.HLGBST) GO TO 34
      NRNBS = NRNBS + 1
      ICAMWD = LOR(ICAMWD,MASK(IBT))
      NBARR(IBT) = 1
34    CONTINUE
      HW(J3) = HELP(2)
C
C             SET LATCHES FOR ENDCAP QUADRANTS, NLGQ
C             SUM THE TWO ENDCAP TOTAL ENERGIES
C    NQLAT IS NUMBER OF QUADRANTS WITH LATCH SET
C
      NECA(1) = 0
      NECA(2) = 0
      NQLAT = 0
      J4 = NLATC2 + 21
      HELP(2) = 0
      DO 35 IBT = 1,8
      NQARR(IBT) = 0
      IC = 1
      IF(IBT.GT.4) IC = 2
      NECA(IC) = NECA(IC) + NLGQ(IBT)
      IF(NLGQ(IBT).LT.HLGQT) GO TO 35
      ICAMWD = LOR(ICAMWD,MASK(IBT))
      NQLAT = NQLAT + 1
      NQARR(IBT) = 1
35    CONTINUE
      HW(J4) = HELP(2)
C
C             SET LATCHES FOR ENDCAP ENERGIES, BARREL AND TOTAL ENERGIES
C
      J5 = NLATC2 + 22
      HELP(2) = 0
      DO 36 IBT = 1,8
      IC = 1
      IF(IBT.GT.4) IC = 2
      KC = IBT
      IF(KC.GT.4) KC = KC - 4
      IF(NECA(IC).GE.HECAPT(KC)) ICAMWD = LOR(ICAMWD,MASK(IBT))
36    CONTINUE
      HW(J5) = HELP(2)
      J6 = NLATC2 + 23
      HELP(2) = 0
      DO 37 IBT = 1,8
      IC = 1
      IF(IBT.GT.4) IC = 2
      KC = IBT
      IF(KC.GT.4) KC = KC - 4
      IF(NETOT(IC).GE.HLGTOT(KC,IC)) ICAMWD = LOR(ICAMWD,MASK(IBT))
37    CONTINUE
      HW(J6) = HELP(2)
C
C                         TAGGING LATCHES
C   THE TAGG BANK CONTAINS ADC COUNTS, MATCH AGAINST THRESHOLDS BY
C   USE OF THE AVERAGE CONVERSION CONSTANT  TAGADC
C   IN 1982-1986, EITHER MARK 2 OR MARK 3 TAGGER.
C   FOR 1983 TO MIDDLE 1986, INNER RING NOT INCLUDED IN TRIGGER
C
      ITAG = 0
      NPATAG = IW(IBLN('ATAG'))
      NATAG2 = NPATAG * 2
      IF( NATAG2 .LE. 0 ) GO TO 3000
      NBAS = NATAG2 + 7
      DO 2400 J=1,2
      NH = HW(NATAG2+J+3) - 2
      NL = HW(NATAG2+J+2)
      NTAG(J) = 0
      IF( NL .GT. NH ) GO TO 2300
C
      DO 2200 I=NL, NH, 2
      NBLOT = HW(NBAS+I-1)
C  INNER RING EXCLUDED IF FLAG ON
        IF(HTGTRG.EQ.1.AND.J.EQ.1.AND.NBLOT.LT.12) GO TO 2200
        IF(HTGTRG.EQ.1.AND.J.EQ.2.AND.NBLOT.LT.60) GO TO 2200
      NAMP = HW(NBAS+I)
      NTAG(J) = NTAG(J) + NAMP
 2200 CONTINUE
C
 2300 CONTINUE
      NTAG(J) = NTAG(J) * TAGADC
 2400 CONTINUE
C                                           THRESHOLDS
      IF( NTAG(1) .LT. HLGTL ) GO TO 2410
      ITAG = ITAG + 1
      HW(NLATC2+24) = LOR( HW(NLATC2+24), MASK(2) )
      HW(NLATC2+24) = LOR( HW(NLATC2+24), MASK(6) )
      HW(NLATC2+28) = LOR( HW(NLATC2+28), MASK(13) )
      IF( NTAG(1) .GT. HLGTH )
     *                 HW(NLATC2+28) = LOR( HW(NLATC2+28), MASK(14) )
 2410 IF( NTAG(2) .LT. HLGTL ) GO TO 3000
      ITAG = ITAG + 1
      HW(NLATC2+24) = LOR( HW(NLATC2+24), MASK(3) )
      HW(NLATC2+24) = LOR( HW(NLATC2+24), MASK(7) )
      HW(NLATC2+28) = LOR( HW(NLATC2+28), MASK(15) )
      IF( NTAG(2) .GT. HLGTH )
     *                 HW(NLATC2+28) = LOR( HW(NLATC2+28), MASK(16) )
C  LUMI BIT
      IF( NTAG(1) .GT. HLGTH.AND.NTAG(2).GT.HLGTH )
     *                        HW(NLATC2+24) = HW(NLATC2+24) + 16
 3000 CONTINUE
C
C  - - - - - - - - - - - - -   END OF LATCHES - - - - - -
C
C                                           ****************************
C                                           *   MULTIPLICITIES AND     *
C                                           *   COPLANAR TOPOLOGIES    *
C                                           ****************************
C
C   DETERMINE NEIGHBOR SUPRESSED MULTIPLICITIES OF TOF AND TBG
C
      NTFNS = 0
      INS = 0
      DO 500 ITF = 15,56
      IF(INS.EQ.0) GO TO 501
      IF(ITF.EQ.56) GO TO 501
      INS = INS - 1
      GO TO 500
501   ITOF = ITF
      IF(ITOF.GT.42) ITOF = ITOF - 42
      IF(HTOF(ITOF).EQ.0) GO TO 500
      NTFNS = NTFNS + 1
      INS = 3
500   CONTINUE
      NTBGNS = 0
      INS = 0
      DO 600 ITF = 15,56
      IF(INS.EQ.0) GO TO 601
      IF(ITF.EQ.56) GO TO 601
      INS = INS - 1
      GO TO 600
601   ITOF = ITF
      IF(ITOF.GT.42) ITOF = ITOF - 42
      IF(HTBG(ITOF).EQ.0) GO TO 600
      NTBGNS = NTBGNS + 1
      INS = 3
600   CONTINUE
C
C                                  SET MULTIPLICITIES
C
      IF(NTFNS.GT.15) NTFNS = 15
      IF(NTBGNS.GT.15) NTBGNS = 15
      K1 = NTRIG2+3
      HW(K1) = IBPAT(NTOF)
      HW(K1) = HW(K1) + 16*IBPAT(NTOFBG)
      HW(K1) = HW(K1) + 256 * NTFNS
      HW(K1) = HW(K1) + 4096* NTBGNS
C
C                                  TOF:     COLLINEARITY TRIGGER
C
      ICOLL = 0
      IF( NTOF .LT. 2 ) GO TO 1270
      DO 1260 J = 1,42
      IF( HTOF(J) .EQ. 0 ) GO TO 1260
      JLO = J + 21 - IWCOLL
      JHI = J + 21 + IWCOLL
      DO 1250 JOP = JLO,JHI
      I = MOD( JOP - 1, 42 ) + 1
      IF( HTOF(I) .EQ. 0 ) GO TO 1250
      ICOLL = 1
      GO TO 1270
 1250 CONTINUE
 1260 CONTINUE
 1270 CONTINUE
C
C                               TBG:        COLLINEARITY TRIGGER
C
      ICLTBG = 0
      IF( NTOFBG .LT. 2 ) GO TO 1370
      DO 1360 J = 1,42
      IF( HTBG(J) .EQ. 0 ) GO TO 1360
      JLO = J + 21 - IWCTBG
      JHI = J + 21 + IWCTBG
      DO 1350 JOP = JLO,JHI
      I = MOD( JOP - 1, 42 ) + 1
      IF( HTBG(I) .EQ. 0 ) GO TO 1350
      ICLTBG = 1
      GO TO 1370
 1350 CONTINUE
 1360 CONTINUE
 1370 CONTINUE
C
C                                 TOF:      NARROW COLLINEARITY
C
      ICOLLN = 0
      IF( NTOF .LT. 2 ) GO TO 1470
      DO 1460 J = 1,42
      IF( HTOF(J) .EQ. 0 ) GO TO 1460
      JLO = J + 21 - IWCOLN
      JHI = J + 21 + IWCOLN
      DO 1450 JOP = JLO,JHI
      I = MOD( JOP - 1, 42 ) + 1
      IF( HTOF(I) .EQ. 0 ) GO TO 1450
      ICOLLN = 1
      GO TO 1470
 1450 CONTINUE
 1460 CONTINUE
 1470 CONTINUE
C
C                       NEUTRAL TRIGGER:    SEPTANCE COLLINEARITY
C
      IOLS = 0
      IF( NRNBS.LT.NRNBSL) GO TO 1570
      DO 1560 J = 1,7
      IF(NBS(J).LT.HLGBST) GO TO 1560
      J3 = J + IWIDBS
      IF(J3.GT.7) J3 = J3 - 7
      IF(NBS(J3).LT.HLGBST) GO TO 1560
      IOLS = 1
      GO TO 1570
 1560 CONTINUE
 1570 CONTINUE
C
C                   SEPTANT-ENDCAP QUADRANT COPLANARITY LOGIC
C
      IKREH = 0
      IF(NQLAT.LT.1.OR.NQLAT.GT.2) GO TO 1380
      IF(NRNBS.LT.1) GO TO 1380
CHECK NEIGHBOR RELATION IF 2 QUADRANTS SET
      IF(NQLAT.NE.2) GO TO 1374
C
      DO 1373  IBTQ = 1,8
      IF(NQARR(IBTQ).EQ.0) GO TO 1373
      IF(NQARR(IBTQ+1).EQ.0.AND.(IBTQ.EQ.2.OR.IBTQ.EQ.3)) GO TO 1380
      IF(NQARR(IBTQ+1).EQ.0.AND.(IBTQ.EQ.6.OR.IBTQ.EQ.7)) GO TO 1380
      IF(NQARR(IBTQ+3).EQ.0.AND.NQARR(IBTQ+1).EQ.0.AND.
     $ (IBTQ.EQ.1.OR.IBTQ.EQ.5)) GO TO 1380
      GO TO 1374
1373  CONTINUE
C
1374  CONTINUE
C
      DO 1375  IBTQ = 1,8
      IF(NQARR(IBTQ).EQ.0) GO TO 1375
       DO 1376  IBTS = 1,7
       IF(NBARR(IBTS).EQ.0) GO TO 1376
       IF(IBTS.EQ.HKRE(1,IBTQ)) IKREH = 1
       IF(IBTS.EQ.HKRE(2,IBTQ)) IKREH = 1
       IF(IBTS.EQ.HKRE(3,IBTQ)) IKREH = 1
1376   CONTINUE
1375  CONTINUE
C
1380  CONTINUE
C                                           ****************************
C                                           *       TRIGGER WORDS      *
C                                           ****************************
C
C                   >>>>>>>>>>>>>>>>            T1:    ACCEPT CONDITIONS
C
      IACC = 0
C
C                         LUMI TRIGGER
C
      IF( NTAG(1) .GT. HLGTH.AND.NTAG(2).GT.HLGTH )
     $ IACC = LOR( IACC, MASK(1) )
C
C                         TOTAL ENERGY
C
      IF(NETOT(1).GE.HLGTOT(1,1)) IACC = LOR( IACC, MASK(2) )
C
C                         TAGG + TOTAL LG ENERGY
C
      IF(ITAG.GT.0.AND.NETOT(1).GE.HLGTOT(3,1)) IACC=LOR(IACC,MASK(3))
C
C           SEPTANT - ECAP QUADRANT COPLANARITY   (KREHBIEL TRIGGER)
C
      IF(IKREH.EQ.1.AND.NTOF.LT.1.AND.IHIST(3).GT.1985)
     $                                          IACC=LOR(IACC,MASK(5))
C
C                         ECAP1 * ECAP2
C
      IF(NECA(1).GE.HECAPT(2).AND.NECA(2).GE.HECAPT(2))
     $                                 IACC=LOR(IACC,MASK(9))
C
C                         ECAP1 + ECAP2, BARREL ENERGY
C
      IF(NECA(1)+NECA(2).GE.HECAPT(3).AND.NETOT(2).GE.HLGTOT(4,2))
     $                                 IACC=LOR(IACC,MASK(10))
C
C                         TAGG + BARREL LG ENERGY
C
      IF(ITAG.GT.0.AND.NETOT(2).GE.HLGTOT(4,2))
     $                                 IACC=LOR(IACC,MASK(11))
C
C                         BARREL LG ENERGY
C
      IF(NETOT(2).GE.HLGTOT(2,2))      IACC=LOR(IACC,MASK(12))
C
C                         ECAP1 * ECAP2 * TOTAL LG ENERGY
C
      IF(NECA(1).GE.HECAPT(4).AND.NECA(2).GE.HECAPT(4).AND.NETOT(1).
     $ GE.HLGTOT(2,1))                 IACC=LOR(IACC,MASK(13))
C
C                         SEPTANT COLLINEARITY  (OLSSON 1)
C
      IF(IOLS.EQ.1.AND.NRNBS.LE.NRNBSH.AND.NTOF.LT.NTOFBS)
     $                                      IACC=LOR(IACC,MASK(14))
C
C                         SEPTANT + TAGG  (ZORN 1)
C
      IF(IHIST(3).GT.1982.AND.
     $   NRNBS.GT.0.AND.ITAG.GT.0.AND.NTOF.LT.NTOFBS)
     $                                 IACC=LOR(IACC,MASK(15))
C
      ICAMWD = IACC
      HW(NTRIG2+8) = HELP(2)
C
C                     >>>>>>>>>>>>>>         T1:     POSTPONE CONDITIONS
C
      IPOST = 0
C
C                     TOF, TOTAL ENERGY
C
      IF(NTOF.GE.NTOFC.AND.NETOT(1).GE.HLGTOT(4,1))
     $                                     IPOST = LOR(IPOST,MASK(1))
C
C                     TOF, ECAP1 + ECAP2
C  OFF IN HARDWARE DUE TO MISTAKE FROM OKT 85 TILL JULY 86
C
      IF(IHIST(3).EQ.1986.AND.IHIST(2).LT.7) GO TO 8790
      IF(NECA(1)+NECA(2).GE.HECAPT(2).AND.NTOF.GE.NTOFC1)
     $                                     IPOST = LOR(IPOST,MASK(3))
C
C                     TBGNS
C
8790  CONTINUE
      IF(NTBGNS.GE.NTBGC2.AND.NTOF.LT.NTOFC2)
     $                                     IPOST = LOR(IPOST,MASK(4))
C
C                     TBG, BARREL LG ENERGY
C
      IF(NTOFBG.GT.NTBGC1.AND.NETOT(2).GE.HLGTOT(4,2))
     $                                     IPOST = LOR(IPOST,MASK(9))
C
C                     TAGG, TBG
C
      IF(NTOFBG.GT.NTBGC .AND.ITAG.GT.0)     IPOST = LOR(IPOST,MASK(10))
C
      IF(IHIST(3).LT.1985) GO TO 8010
C
C              COLL. SEPTANT + TOF
C
      IF(IOLS.EQ.1.AND.NTOF.GT.0.AND.NTOF.LT.NTFBS2)
     $                                      IPOST=LOR(IPOST,MASK(11))
C
      IF(IHIST(3).LT.1986) GO TO 8010
C
C              TAGG + SEPTANT + TOF
C
      IF(ITAG.GT.0.AND.NRNBS.GT.0.AND.NTOF.GT.0)
     $                                      IPOST=LOR(IPOST,MASK(12))
C
8010  CONTINUE
C
C                     COLLINEAR TOF, WIDE
C
      IF(NTOF.LT.NTFCOL.AND.ICOLL.NE.0)    IPOST = LOR(IPOST,MASK(13))
C
C                     COLLINEAR TOF, NARROW
C
      IF(NTOF.LT.NTFCLN.AND.ICOLLN.NE.0)   IPOST = LOR(IPOST,MASK(14))
C
C                     COLLINEAR TBG
C
      IF(ICLTBG.NE.0)                      IPOST = LOR(IPOST,MASK(15))
C
C
      ICAMWD = IPOST
      HW(NTRIG2+9) = HELP(2)
      RETURN
C
C                                           NO SPACE IN BCS LEFT
 8000 WRITE(6,9101)
 9101 FORMAT(/' NOT ENOUGH SPACE IN BCS LEFT FOR CREATION OF TRIG, 1'/)
      RETURN
 8100 WRITE(6,9102)
 9102 FORMAT(/' NOT ENOUGH SPACE IN BCS LEFT FOR CREATION OF LATC, 0'/)
      RETURN
      END

C   07/06/96 606071908  MEMBER NAME  SIMBOS   (S4)          FORTG1
      SUBROUTINE BLOC(INDA,NAMEA,NRA,*)
      COMMON/BCS/IW(3000)
      INTEGER IU(1),   NOFF/10/
      EQUIVALENCE (IU(1),IW( 11))
C     INTEGER IU(1),   NOFF/2000/
C     EQUIVALENCE (IU(1),IW(2001))
C
C     FOR THE PLUTO ONLINE PROGRAM, THIS IS A PROGRAM FOR THE
C     SIMULATION OF SEVERAL BOS-ENTRIES, USING THE MBOS PROGRAM.
C     THE FOLLOWING ENTRIES ARE SIMULATED.
C         BLOC
C         BPOS/BNXT
C         BCRE          SEE REMARKS BELOW
C         BDLS
C         BMVE          DUMMY
C         BCHL          SEE REMARKS BELOW
C         BGAR
C     THE MBOS PROGRAM USES AN ARRAY IU IN THE HIGH-PART OF
C     COMMON/BCS/IW(...)     (SEE STATEMENTS ABOVE)
C     THE MBOS-ARRAY HAS TO BE INITIALIZED BY E.G. (FOR 29 POINTERS)
C     CALL MBOS(IU,IU(30),1000)
C     ALL BANKS MUST HAVE ASSOCIATED POINTERS WITHIN IU( ) AND
C     A NAME AND A NUMBER. THE SIMULATED BCRE NEEDS A BANK OF
C     THE SAME NAME AND NUMBER. THIS CAN BE DONE BY CALLS
C        CALL MNNR(IU,NAME,NR)
C        CALL MCRE(IU,IU(L),0)
C     CREATING A BANK OF LENGTH ZERO. IF THE SIMULATED BCRE (OR
C     BCHL) IS CALLED, ALL BANKS BEHIND THE CREATED BANK ARE
C     SHIFTED.
C
C
C     ENTRY BLOC(INDA,NAMEA,NRA,*)
      IGO=1
      GOTO 88
C
C
      ENTRY BPOS(NAMEA)
      IGO=2
      GOTO 89
   10 IU(N-8)=IU(IND-1)
      GOTO 100
   12 IU(N-8)=-1
      GOTO 100
C
C
      ENTRY BCRE(INDA,NAMEA,NRA,NWA,*,IER)
      IGO=3
      IER=0
      GOTO 88
   20 K=IU(IND-1)
      CALL MCRE(IU,IU(K),NWA)
      IU(N-7)=K
      IF(IU(IND).NE.NWA) GOTO 22
      IF(NWA.EQ.0) GOTO 99
      CALL VZERO(IU(IND+1),NWA)
      GOTO 99
   22 IER=2
      GOTO 101
C
C
      ENTRY BDLS(NAMEA,NRA)
      IGO=4
      GOTO 88
   30 K=IU(IND-1)
      CALL MDRP(IU,IU(K),IU(K))
      GOTO 100
C
C
      ENTRY BNXT(INDA,*)
      N=IU(1)
      IF(IU(N-8)) 40,42,44
   40 IU(N-8)=0
      GOTO 101
   42 INDA=INDA-NOFF
      IND=INDA+4+IU(INDA)
      IF(IU(IND-3).EQ.IU(INDA-3)) GOTO 99
      GOTO 101
   44 K=IU(N-8)
      IU(N-8)=0
      IND=IU(K)
      GOTO 99
C
C
      ENTRY BMVE(INDA,*)
      GOTO 100
C
C
      ENTRY BCHL(NWA,*)
      IF(IU(N-7).EQ.0) GOTO 102
      K=IU(N-7)
      IF(IU(K).EQ.0) GOTO 102
      NW=IU(IU(K))+NWA
      CALL MCRE(IU,IU(K),NW)
      IF(IU(IU(K)).EQ.NW) GOTO 100
      GOTO 102
C
C
      ENTRY BGAR(IGA)
      CALL MBOS(IU,IU,NFRE)
      IGA=1
      GOTO 100
C
C
   88 NR  =NRA
   89 NAME=NAMEA
C     LOCATE NAME
      N=IU(1)
      L=IU(N)
      IND=L+4
   90 IF(IND.GE.IU(N-1)) GOTO 96
      IF(IU(IND-3).EQ.NAME) GOTO 91
      IND=IND+4+IU(IND)
      GOTO 90
C     NAME FOUND
   91 GOTO (93,10,93,93),IGO
C     LOCATE NR
   92 IF(IND.GE.IU(N-1)) GOTO 96
      IF(IU(IND-3).NE.NAME) GOTO 96
   93 IF(IU(IND-2)-NR) 94,95,96
   94 IND=IND+4+IU(IND)
      GOTO 92
C     NR FOUND
   95 GOTO (99,100,20,30),IGO
C     NOT FOUND
   96 GOTO (101,12,22,100),IGO
C
C
   99 INDA=IND+NOFF
  100 RETURN
  101 INDA=0
  102 RETURN 1
      END

C   26/04/84 405241539  MEMBER NAME  DRAWFD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWFD( IVIEW )
C-----------------------------------------------------------------------
C
C
C   AUTHOR:    J. OLSSON        ?    :  DRAW FORWARD DETECTOR
C
C        MOD:  C. BOWDERY   26/04/84 :  TAKEN FROM FORWRD. DOES FW NOW
C        MOD:  J. NYE       18/05/84 :  USE TAGMRK - WORKS FOR MC TOO
C   LAST MOD:  C. BOWDERY   24/05/84 :  IVIEW=1  NOW USED
C
C     DRAW THE FORWRD DETECTOR FOR THE VIEW IVIEW.
C       IVIEW = 1   : SUPERPOSITION OF TAGGING SYSTEM IN R-PHI VIEWS
C       IVIEW = 2   : ZXD AND ZYD VIEWS
C       IVIEW = 3   : FW VIEW
C
C     TAGMRK IS CALLED TO DETERMINE THE VERSION NUMBER OF THE APPARATUS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO2 .... JADE TAGGING GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO2 / FENDC,XYHOL1,XYHOL2,BLDPFW,ZMINBL,ZPLUBL,
     +                 XSC(2),YSC(2),RSC(2),ZMISC(2),ZPLSC(2),DZSC,
     +                 CHX(3,4),CHY(3,4),CHZ(3,4),WLEN,PITCH,WZDIS
C
C--------------------------- END OF MACRO CGEO2 ------------------------
C
C----------------------------------------------------------------------
C      MACRO CGEO3 .... JADE FORWARD DETECTOR GEOMETRY, 1981-3 VERSION
C----------------------------------------------------------------------
C
      COMMON / CGEO3 / ZPLUM2,ZMINM2,NRPBSC,PBSCR(4),PBSCZ(4)
C
C------------------------ END OF MACRO CGEO3 --------------------------
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
      COMMON /CHEADR/ HEAD(108)
C
      DIMENSION ZSC(2)
      EQUIVALENCE (ZSC(1),ZMINBL)
C
C------------------  C O D E  ------------------------------------------
C
      GO TO ( 10 , 20 , 30 ) , IVIEW
C
C                            R PHI VIEW  (FC COMMAND)
C
  10  CALL FWCAP(0.,0.,0,1.,0)
      RETURN
C
C                            Z VIEWS  (ZXD,ZYD)
C
C                            CALL TAGMRK TO DETERMINE APPARATUS
C                            MARK, FOR MC AND REAL DATA
C
  20  CALL TAGMRK(*21)
  21  IF( MARK .EQ. 0 ) GO TO 1
      IF( MARK .EQ. 1 ) GO TO 641
C
C                            1983 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
C
      CALL FW83
      GO TO 1000
641   CALL FWNEW
C
C                            1981-2 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
C
      GO TO 1000
    1 CONTINUE
C
C                            1979-80 CAPS, SIDE VIEWS IN ZXD,ZYD VIEWS
C
      K = 1
      IF(LASTVW.EQ.11) K = 2
C
C++++                        CHAMBER DISPLAY COMMENTED OUT
C      DO 1602  I = 1,4
C        IF(K.EQ.1) CALL FWCHM2(I,CHZ(2,I),CHX(2,I),CHZ(3,I),CHX(3,I),
C     +                         CHZ(1,I),CHX(1,I))
C        IF(K.EQ.2) CALL FWCHM1(I,CHZ(1,I),CHY(1,I),CHZ(2,I),CHY(2,I))
C1602  CONTINUE
C++++
C
      DO 1603  I = 1,2
        CALL FWCAP1(ZSC(I),0.,I,K)
C
C++++                        COUNTER DISPLAY COMMENTED OUT
C       J = 2*I-1
C       CALL FWSCN1(ZMISC(I),0.,J)
C       J = J + 1
C       CALL FWSCN1(ZPLSC(I),0.,J)
C++++
C
 1603 CONTINUE
C
1000  CONTINUE
      RETURN
C
C                            FW VIEW  (TAGGING SYSTEM ONLY VIEW)
C
  30  FDX = 0.25 * (XMAX - XMIN)
      FDY = 0.0
      LL  = 0
      IF( DSPDTL(15) ) LL = 14
      DO  42  J = 1,2
        FDX = -FDX
        CALL FWCAP(FDX,FDY,LL,1.5,1)
  42  CONTINUE
      RETURN
      END

      SUBROUTINE SHELL9(IVAL,IIND,N)
      DIMENSION IVAL(N),IIND(N)
      INTEGER*2 I,J,K,M
      M=N/2
15000 CONTINUE
      IF(
     - M.GT.0
     -)THEN
         K=N-M
      DO 13000 J=1,K
            I=J
15002 CONTINUE
      IF(
     - I.GE.1
     -)THEN
               IVI=IVAL(IIND(I))
               IVIPM=IVAL(IIND(I+M))
      IF(
     - IVIPM.GE.IVI
     -)THEN
      GOTO 15003
      ENDIF
               I1=IIND(I+M)
               IIND(I+M)=IIND(I)
               IIND(I)=I1
               I=I-M
      GOTO 15002
      ENDIF
15003 CONTINUE
13000 CONTINUE
13001 CONTINUE
         M=M/2
      GOTO 15000
      ENDIF
15001 CONTINUE
      RETURN
      END

C   07/06/96 606071908  MEMBER NAME  SMHIST1  (S4)          FORTG1
      SUBROUTINE SMHIST(YI,Y,DY,N,IDY)
      REAL YI(1),Y(1),DY(1)
      REAL A(64,5),YL(128),YS(128),X(128),C(128),W(128),DX(128)
      INTEGER NR/0/
      NR=NR+1
C
C     ------------------------------------------------------------------
C
C
C     PURPOSE - SMOOTH HISTOGRAM DATA
C
C     USAGE                 --   -- - ---
C               CALL SMHIST(YI,Y,DY,N,IDY)
C                              -
C               YI( ) = INPUT HISTOGRAM OF N BINS
C               Y ( ) = SMOOTHED HISTOGRAM
C               DY( ) = ERRORS OF INPUT HISTOGRAM DATA (FOR IDY=1 ONLY)
C               IDY   = 0   HISTOGRAM WITH ERROR OF BIN CONTENT EQUAL
C                           TO SQRT(CONTENT), POISSON DISTR., OR
C                     = 1   WEIGTHED HISTOGRAM WITH ERRORS GIVEN.
C
C               YI( ) AND Y( ) MAY BE THE SAME ARRAY. THERE IS NO
C               LIMITATION ON THE NUMBER OF BINS.
C
C     METHOD  - IT IS ASSUMED, THAT THE HISTOGRAM DATA CORRESPOND TO
C               BINS OF EQUAL SIZE. THE METHOD CONSISTS OF SEVERAL
C     PARTS. PEAKS AND VALLEYS OF ONLY ONE BIN WILL COMPLETELY VANISH,
C     THUS THE BIN SIZE SHOULD BE CHOOSEN SMALL ENOUGH, THAT EXPECTED
C     PEAKS WILL BE AT LEAST 3 BINS WIDE.
C
C     1. PART      IF THREE ADJACENT BINS CONTAIN LESS THAN 8 (EQUIV.)
C                  ENTRIES, THEY WILL BE AVERAGED.
C     2. PART *    TRANSFORMATION OF THE POISSON DISTRIBUTED DATA TO
C                  DATA OF VARIANCE 1.0
C     3. PART      353C ALGORITHM TO REDUCE LOCAL CHI SQUARE
C                  (SEE SUBROUTINE SMOPER)
C     4. PART      SPLINE FIT (SEE BELOW)
C     5. PART *    BACK TRANSFORMATION
C
C     *  FOR IDY = 0 ONLY.
C
C     SPLINE FIT - THE SUBROUTINE SPLESQ IS USED TO PERFORM A SPLINE
C     FIT, WHICH CONSISTS IN A LEAST SQUARE OF A CERTAIN NUMBER OF
C     REFERENCE POINTS, CONNECTED BY A SPLINE FUNCTION. THE BAND MATRIX
C     OCCURING IN THE FIT IS SOLVED BY A FAST RTR DECOMPOSITION METHOD
C     IN SUBROUTINE BANDSL. THE SPLINE FIT IS PERFORMED ITERATIVELY,
C     REFINING THE SETTING OF REFERENCE POINTS ACCORDING TO THE LOCAL
C     CHI SQUARE. IN THE FIRST ITERATION, THE REFERENCE POINTS ARE
C     CHOOSEN EQUIDISTANT WITH ABOUT 8 BINS BETWEEN 2 REFERENCE POINTS.
C     IN THE FOLLOWING ITERATIONS, USING THE LOCAL CHI SQUARE, THE
C     DISTANCE BETWEEN 2 REFERENCE POINTS IS REDUCED.
C
C     THE RESULTING SMOOTHED HISTOGRAM CONTENT WILL BE SMOOTH WITH
C     LITTLE SHORT LENGTH OSCILLATIONS, WHILE SIGNIFICANT STRUCTURES
C     WILL BE PRESENT.
C
C     SUBROUTINES CALLED - SMOPER
C                          SPLESQ (CALLS BANDSL)
C
C
C     ------------------------------------------------------------------
C
C
C     TRANSFER TO Y( ) AND GET FIRST AND LAST BIN WITH NONZERO CONTENT
C
      IA=0
      IB=0
      WL=0.0
      IL=0
      DO 2 I=1,N
      Y(I)=YI(I)
      IF(IDY.EQ.0.AND.Y(I).EQ.0.0) GOTO 2
      IF(IDY.NE.0.AND.DY(I).EQ.0.0) GOTO 2
      IF(IDY.NE.0.AND.IA.EQ.0) WL=DY(I)
      IF(IA.EQ.0) IA=I
      IB=I
      IF(IDY.EQ.0.OR.I.EQ.1.OR.I.EQ.N) GOTO 2
      IF(DY(I-1).NE.0.0.OR.DY(I+1).NE.0.0) GOTO 2
      WL=WL+DY(I)**2
      IL=IL+1
    2 CONTINUE
      IF(IDY.NE.0.AND.IL.NE.0.AND.WL.EQ.0.0) GOTO 100
      IF(IDY.NE.0) WL=FLOAT(IL)/WL


      NC=IB-IA+1
      IF(NC.LE.3) GOTO 100
C
C     FOLD BINS OF VERY LOW STATISTIC
C
      NM=IB-2
      ZL=Y(IA)
      DO 6 I=IA,NM
      ZN=Y(I+1)
      SUM=Y(I)+Y(I+1)+Y(I+2)
      IF(IDY.EQ.0) GOTO 3
      SUM2=DY(I)**2+DY(I+1)**2+DY(I+2)**2
      IF(SUM2.EQ.0.0) GOTO 4
      IF(SUM**2/SUM2.GT.8.0) GOTO 4
      ZN=0.25*(ZN+Y(I+1))
      GOTO 4
    3 IF(SUM.GT.8.0) GOTO 4
      ZN=ZN+(SUM-3.0*ZN)/(SUM+3.0)
    4 Y(I)=ZL
    6 ZL=ZN
      Y(IB-1)=ZL
C
C     TRANSFORM POISSON DISTRIBUTED DATA TO DATA OF VARIANCES 1.0
C
      IF(IDY.NE.0) GOTO 12
      DO 10 I=IA,IB
      IF(Y(I).GT.0.0) GOTO 8
      Y(I)=1.0
      GOTO 10
    8 Y(I)=SQRT(Y(I))+SQRT(Y(I)+1.0)
   10 CONTINUE
C
C     APPLY SIMPLE 353 ALGORITHM TO REDUCE CHI SQUARES
C
   12 CALL SMOPER(Y(IA),NC,5321)
C
C     SMOOTH BY REPEATED SPLINE FITS
C
      IF(IDY.EQ.0) IEQ=-1
      IF(IDY.NE.0) IEQ=+1
      KL=(NC+101)/112
      IF(KL.LE.0) KL=1
      LK=(NC+12*KL-11)/KL
      JA=IA
      DO 80 LL=1,KL
      JB=MIN0(IB,JA+LK-1)
      I=0
      DO 20 J=JA,JB
      I=I+1
      IF(LL.EQ.1) YL(I)=Y(J)
      YS(I)=YL(I)
      IF(IDY.EQ.0) GOTO 20
      W(I)=WL
      IF(DY(J).NE.0.0) W(I)=1.0/DY(J)**2
   20 X(I)=0.25
      X(1)=0.0
      M=I
      CLIM=0.20
      DO 22 I=1,M
      C(I)=YL(I)**2
      IF(IDY.NE.0) C(I)=C(I)*W(I)
   22 CONTINUE
      CALL SMOPER(C,M,7)
      SUM=0.0
      DO 24 I=1,M
   24 SUM=SUM+C(I)
      SUM=SUM/FLOAT(M)
      IF(IDY.EQ.0) SUM=0.25*SUM
      DXA=2.1/FLOAT(M)
      DXB=0.125*SQRT(0.02*SUM+0.1)
      DXB=AMIN1(0.125,DXB)
      DXB=AMAX1(DXA,DXB)
      DXQ=0.5*(DXA+DXB)
      DO 26 I=1,M
      X(I)=FLOAT(I-1)*DXQ*2.0
      FAC=SQRT(C(I)/SUM)
      FAC=AMAX1(0.3,FAC)
      FAC=AMIN1(2.0,FAC)
      DX(I)=FAC*DXQ
      DX(I)=AMAX1(DXA,DX(I))
   26 DX(I)=AMIN1(0.5,DX(I))
      DO 70 K=1,4
   30 NSP=3+X(M)*0.5
      CALL SPLESQ(DX,X,W,M,A,NSP,2*IEQ,CHDF)
      X(1)=0.0
      YS(1)=YL(1)
      DO 32 I=2,M
      YS(I)=YL(I)
   32 X(I)=X(I-1)+DX(I)+DX(I-1)
      NSP=3+X(M)*0.5
      CALL SPLESQ(YS,X,W,M,A,NSP,2*IEQ,CHDF)
      FACGEN=1.0
      IF(CHDF.LT.0.75*CLIM) FACGEN=0.8
      IF(CHDF.GT.1.50*CLIM) FACGEN=1.2
      DO 34 I=1,M
      C(I)=(YS(I)-YL(I))**2
      IF(IDY.NE.0) C(I)=C(I)*W(I)
   34 CONTINUE
      CALL SMOPER(C,M,7)
      SUM=0.0
      DO 40 I=1,M
      FAC=1.0
      SUM=SUM+C(I)
      IF(C(I).GT.1.1*CLIM) GOTO 36
      IF(C(I).GT.0.9*CLIM) GOTO 38
      FAC=0.8
      IF(C(I).LT.0.5*CLIM) FAC=FAC*FAC
      GOTO 38
   36 FAC=1.2
      IF(C(I).GT.2.0*CLIM) FAC=FAC*FAC
   38 DX(I)=DX(I)*FAC*FACGEN
   39 DX(I)=AMAX1(DXA,DX(I))
      DX(I)=AMIN1(0.5,DX(I))
   40 CONTINUE
      SUM=SUM/FLOAT(M)
   70 CONTINUE
   71 IF(LL.EQ.KL) GOTO 74
      KA=JB-10
      KB=MIN0(IB,KA+LK-1)
      I=0
      DO 72 K=KA,KB
      I=I+1
   72 YL(I)=Y(K)
   74 I=0
      DO 78 J=JA,JB
      I=I+1
      IF(I.GT.11.OR.JA.EQ.IA) GOTO 76
      Y(J)=0.1*(FLOAT(I-1)*YS(I)+FLOAT(11-I)*Y(J))
      GOTO 78
   76 Y(J)=YS(I)
   78 CONTINUE
   80 JA=JB-10
C
C     TRANSFORM BACK TO POISSON DISTRIBUTED DATA
C
      IF(IDY.NE.0) GOTO 100
      DO 90 I=1,N
      IF(Y(I).GT.1.0) GOTO 85
      Y(I)=0.0
      GOTO 90
   85 SY=(0.5*(Y(I)-1.0/Y(I)))**2
      NY=100.0*SY+0.5
      Y(I)=0.01*FLOAT(NY)
   90 CONTINUE
C
C
  100 RETURN
      END

C   07/12/86 708311919  MEMBER NAME  QCLPCK   (S)           FORTRAN77
      SUBROUTINE QCLPCK( NST, N, IMODE )
C-----------------------------------------------------------
C  VERSION OF 26/01/85       LAST MOD 31/08/87    M ZIMMER
C  ORIGIN OF ALL FINAL STATE PARTICLES IT CATEGORIZED
C  LOAD LUND DATA INTO VECSUB COMMON
C  IMODE=0    CHARGED AND GAMMA
C       =1    CHARGED ONLY
C       =2    CHARGED ONLY, ALL PI
C       =5    CHARGED AND NEUTRAL ALL MASSES PI AND 0
C
C    VECSUB FILLING SCHEME
C   P( 1..7,*)   PX,PY,PZ,E,M,P,CHARGE
C  HP(15   ,*)   NOT USED
C  HP(16   ,*)   PARTICLE TYPE ( JADE MC-CONVENTION )
C  HP(17   ,*)   0 OR PALL NUMBER OF CORRESPONDING LEADING HADRON
C  HP(18   ,*)   QUARK ORIGIN (PARTON PARENT (QUARK OR ANTIQUARK)
C  HP(19   ,*)   PALL NUMBER
C  HP(20   ,*)   PARTICLE ORIGIN (> 0 MEANS ELECTRON )
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / LUJETS / NLUN, KLUN(250,2),PLUN(250,5)
      COMMON  P(10,400)
      DIMENSION IP(10,1),HP(20,1)
      EQUIVALENCE (P(1,1),IP(1,1),HP(1,1))

      LOGICAL FIRST / .TRUE. /
      LOGICAL FIRSTP / .TRUE. /

      IF( FIRST ) THEN
         FIRST = .FALSE.
         WRITE(6,9201) NLUN, (KLUN(I,1),KLUN(I,2),(PLUN(I,J),J=1,5),
     *                 I=1,NLUN)
 9201    FORMAT(2X,' NLUN ',I5/(1X,2I8,5F12.3))
      ENDIF

      N = 0

      IF( NLUN.GT.0 ) THEN
         L=0
         IFL=0
C                                      GET FLAV. OF EVT
         DO 1000 UNTIL( (IFL .GT. 0 .AND. IFL .LT. 6) .OR. L .GT. NLUN)
            L = L+1
            IFL = IABS(KLUN(L,2))-500
 1000    CONTINUE
         IFC = MAX0( IFL-2,1 )
         DO 1001 L = 1, NLUN
            IF( KLUN(L,1).LT.2000 ) THEN
               CHARGE = FLOAT(LUCHGE(KLUN(L,2)))/3.
                IF( CHARGE.NE.0. .OR.
     *              ((IMODE.EQ.0 .OR. IMODE .EQ. 5)
     *                         .AND.IABS(KLUN(L,2)).EQ.1) ) THEN
                  N = N + 1
                  P(1,NST+N) = PLUN(L,1)
                  P(2,NST+N) = PLUN(L,2)
                  P(3,NST+N) = PLUN(L,3)
                  PTOT=SQRT(P(1,NST+N)**2+P(2,NST+N)**2+P(3,NST+N)**2)
                  P(6,NST+N) = PTOT
                  P(7,NST+N) = CHARGE
                  XM = PLUN(L,5)
                  HP(15,NST+N) = 0
                  HP(16,NST+N) = IABS(KLUN(L,2))
                  IF((IMODE.EQ.2 .OR. IMODE .EQ. 5)
     *                     .AND.CHARGE.NE.0.
     *                     .AND. IABS(KLUN(L,2)).NE.7 ) THEN
                     XM = .1396
                     HP(16,NST+N) = 0
                  ENDIF
                  IF(IMODE.EQ.5.AND.CHARGE.EQ.0. ) THEN
                     XM = 0.
                     HP(16,NST+N) = 0
                  ENDIF
                  P(5,NST+N) = XM
                  P(4,NST+N) = SQRT( PTOT**2 + XM**2 )
                  HP(17,NST+N) = 0
                  HP(19,NST+N) = L
C                                           CATEGORIZE
                  ISC = 1
                  J = L
                  DO 1002 WHILE ( MOD( KLUN(J,1), 1000 ).NE. 0)
                    JP = MOD( KLUN(J,1),1000)
                    IF(  ISC .LT. 2 ) THEN
                      KFP = IABS( KLUN(JP,2) )
                      IF( KFP .LT. 500 ) THEN
                        CALL LUIFLV( KFP, IFLA, IFLB, IFLC, KSP )
                        ISC = MAX0(IABS(IFLA)-2,1)
                      ENDIF
                    ENDIF
                    J = JP
 1002             CONTINUE
                  HP(18,NST+N) = ISIGN(1, KLUN(JP,2))
                  HP(20,NST+N) = -( 10*IFC+ISC )
                  IF( IFC.EQ.ISC ) HP(20,NST+N) = - ISC
                  IF( HP(16,NST+N).EQ.7 ) HP(20, NST+N) = - HP(20,NST+N)
               ENDIF
            ENDIF
 1001    CONTINUE
      ENDIF
      RETURN
C
C
      ENTRY QCJETU( NSJET, NJET, IMD )
C------------------------------------------------------
C   UNPACK JETS AND STORE AS PARTICLES
C   FLAVOR CODE IS 1-5 FOR U,D,S,C, AND B
C------------------------------------------------------
C
      IF( FIRSTP ) THEN
         FIRSTP = .FALSE.
C        WRITE(6,9202) NLUN, (KLUN(I,1),KLUN(I,2),(PLUN(I,J),J=1,5),
C    *                 I=1,NLUN)
C9202    FORMAT(2X,' NLUN ',I5/(1X,2I8,5F12.3))
      ENDIF


      NJET = 0

      IF( NLUN.GT.0 ) THEN
         DO 2000 L = 1, NLUN
            IFL = IABS(KLUN(L,2))-500
            IF( IFL.GE.0 .AND. IFL.LT.6 ) THEN
               ICODE = MAX0(1,IABS( IFL) - 2)
C                                      FOR GLUONS
               IF ( IFL .EQ. 0 ) ICODE = 0
               CHARGE = FLOAT(LUCHGE(KLUN(L,2)))/3.
               IF( CHARGE.EQ.0. ) GO TO 2000
                  NJET = NJET + 1
                  PTOT = SQRT(PLUN(L,1)**2+PLUN(L,2)**2+PLUN(L,3)**2)
                  P(1,NSJET+NJET) = PLUN(L,1)
                  P(2,NSJET+NJET) = PLUN(L,2)
                  P(3,NSJET+NJET) = PLUN(L,3)
                  P(4,NSJET+NJET) = PLUN(L,4)
                  P(5,NSJET+NJET) = PLUN(L,5)
                  P(6,NSJET+NJET) = PTOT
                  P(7,NSJET+NJET) = CHARGE
                  HP(15,NSJET+NJET) = 0
                  HP(16,NSJET+NJET) = KLUN(L,2)
                  HP(17,NSJET+NJET) = 0
                  HP(18,NSJET+NJET) = ISIGN(1,KLUN(L,2))
                  HP(19,NSJET+NJET) = L
                  HP(20,NSJET+NJET) = ICODE
               ENDIF
 2000    CONTINUE
      ENDIF

      RETURN
C
      ENTRY QCFRGU( NSFRG, NFRG, IMD )
C------------------------------------------------------
C   UNPACK PARTICLES PRODUCED BY FRAGMENTATION ( PARENTS ARE PARTONS )
C   FLAVOR CODE IS 3 FOR B-HADRONS, 2 FOR C-HADRONS AND 1 FOR OTHERS )
C------------------------------------------------------
C

      NFRG = 0

      IF( NLUN.GT.0 ) THEN
         DO 1400 L = 1, NLUN
            IPPAR =  MOD( KLUN( L,1) , 1000 )
            IFLPAR =  IABS(KLUN(IPPAR,2))-500
            IF( IFLPAR.GE.0 .AND. IFLPAR.LT.6 ) THEN
               IFL = KLUN(L,2)
               CALL LUIFLV( IFL, KFLVA, KFLVB, KFLVC, KSP )
               ICODE = MAX0( IABS(KFLVA) - 2, 1 )
               NFRG = NFRG + 1
               PTOT = SQRT(PLUN(L,1)**2+PLUN(L,2)**2+PLUN(L,3)**2)
               CHARGE = FLOAT(LUCHGE(KLUN(L,2)))/3.
               P(1,NSFRG+NFRG) = PLUN(L,1)
               P(2,NSFRG+NFRG) = PLUN(L,2)
               P(3,NSFRG+NFRG) = PLUN(L,3)
               P(4,NSFRG+NFRG) = PLUN(L,4)
               P(5,NSFRG+NFRG) = PLUN(L,5)
               P(6,NSFRG+NFRG) = PTOT
               P(7,NSFRG+NFRG) = CHARGE
               HP(15,NSFRG+NFRG) = 0
               HP(16,NSFRG+NFRG) = IFL
               HP(17,NSFRG+NFRG) = 0
               HP(18,NSFRG+NFRG) = ISIGN( 1, KLUN(IPPAR,2))
               HP(19,NSFRG+NFRG) = L
               HP(20,NSFRG+NFRG) = ICODE
            ENDIF
 1400    CONTINUE
      ENDIF

      RETURN
      END

C   07/06/96 606071828  MEMBER NAME  BREAD    (S4)          FORTG1
      SUBROUTINE BREAD(IUN,*,*)
C     BOS SUBPROGRAM =3.1=
      COMMON/BCS/IW(1)
   10 CALL BRDS(IUN,NBUFL,INIR)
      IF(INIR.EQ.0) GOTO 100
      CALL BFRD(IUN,IW(INIR),IW(INIR+1))
      IF(IW(INIR)) 102,101,10
  100 RETURN
  101 RETURN 1
  102 RETURN 2
      END

C   10/04/84            MEMBER NAME  FWNEW    (JADEGS)      FORTRAN
      SUBROUTINE FWNEW
      IMPLICIT INTEGER*2 (H)
#include "cgeo2.for"
#include "cgeo3.for"
C
C  DRAW SIDEVIEW OF THE TAGGING APPARATUS IN 1981-82 VERSION
C
      DO 1 JZ=1,2
      IZ=-3+2*JZ
      Z0=ZMINM2
      IF(JZ.EQ.2) Z0=ZPLUM2
      Z1=Z0+IZ*BLDPFW
      X0=-3.25*FENDC
      X1=-X0
      CALL RECTAN(Z0,X0,Z1,X1,0)
      X=-3.*FENDC
      DO 1 JX=1,7
      CALL MOVEA(Z0,X)
      CALL DRAWA(Z1,X)
      X=X+FENDC
    1 CONTINUE
      RETURN
      END

C   09/06/78 C8112701   MEMBER NAME  MESSAG   (JADELGS)     FORTRAN
      SUBROUTINE MESSAG(INDEX)
C
C     L.H.O'NEIL     XX-XX-XX   00:00
C     MODIFIED BY S.YAMADA  TO INCLUDE LEAD GLASS PART.  24-11-78
C
      COMMON /MESSGB/ MSGVAL(5)
      DIMENSION AMSGVL(5)
      EQUIVALENCE (MSGVAL(1),AMSGVL(1))
      DIMENSION KOUNT(20),LIMIT(20)
      DATA LIMIT/20*100/
      DATA KOUNT/20*0/
C
      IF((INDEX.LT.1).OR.(INDEX.GT.19)) GO TO 1001
      KOUNT(INDEX)=KOUNT(INDEX)+1
      IF(KOUNT(INDEX).GT.LIMIT(INDEX)) RETURN
C
      IF(INDEX.GT.10) GO TO 200
C
C---- SUPERVISER ERROR MSG.
      GO TO (1,2,3),INDEX
C
 1001 CONTINUE
      KOUNT(20)=KOUNT(20)+1
      IF(KOUNT(20).GT.LIMIT(20)) RETURN
      WRITE(6,100)
  100 FORMAT(' MESSAG CALLED WITH ILLEGAL INDEX.')
      RETURN
C
    1 CONTINUE
      WRITE(6,101)
  101 FORMAT(' INPUT READ ERROR. PROGRAMMED STOP.')
      STOP
C
    2 CONTINUE
      WRITE(6,102)
  102 FORMAT(' ILLEGAL EVENT NUMBER REQUESTED.')
      RETURN
    3 CONTINUE
      WRITE(6,103)
  103 FORMAT(' ILLEGAL USER INDEX. SKIP REST OF INPUT DS AND END.')
      RETURN
C
C---- LEAD GLASS ERROR MSG.
  200 LGINDX = INDEX-10
      GO TO (201,202,203,204,205,206,207),LGINDX
  201 WRITE(6,6201)
 6201 FORMAT('0***** BUFFER OVER FLOW IN LGADCN *****')
      RETURN
  202 WRITE(6,6202) MSGVAL
 6202 FORMAT(' ***** LG-DATA ILLEGAL ADDRESS:',I5)
      RETURN
  203 WRITE(6,6203)
 6203 FORMAT(' ******* TOO MANY LG-CLUSTERS *******')
  204 RETURN
  205 WRITE(6,6205) MSGVAL(1),AMSGVL(2),AMSGVL(3)
 6205 FORMAT(' NON-CONVERGENCE FOR DEPAV IN (LGAVRZ). NTRY,DEPO,DEP=',
     1       I3,2F10.2,'  **********')
      RETURN
  206 WRITE(6,6206) MSGVAL(1)
 6206 FORMAT(' ** ERROR IN /LGCL/ COPY.IER FROM JBCRA=',I5,' *****')
      RETURN
  207 WRITE(6,6207) MSGVAL(1)
 6207 FORMAT(' ** ERROR IN /ALGN/ COPY.IER FROM JBCRA=',I5,' *****')
      RETURN
      END

C   07/06/96 606071918  MEMBER NAME  VALL     (S4)          FORTG1
      SUBROUTINE VALL(X,L,AAW,ASCHR,NB)
      DIMENSION X(100),Y(100),XL(2),XF(2)
      DIMENSION DX(2)
      REAL    BINS(10)/0.1,0.15,0.2,0.25,0.4,0.5,0.6,0.8,1.0,1.5/
      REAL*8 XA,XZ,BN,BIN,FEX,SCHR,AW,TEN
      REAL*8 DN
      TEN=10
      N=MIN0(100,L)
      DO 10 I=1,N
   10 Y(I)=X(I)
      CALL SORT4(Y,N)
      XM=Y(N/2+1)
      XL(1)=XM-Y(1)
      XL(2)=Y(N)-XM
      NT=N/10
      IF(NT.LT.1) NT=1
      XF(1)=XM-Y(NT)
      XF(2)=Y(N+1-NT)-XM
      DO 20 I=1,2
      DX(I)=AMIN1(2.*XF(I),XL(I))
   20 CONTINUE
      IF(DX(1)+DX(2).GT.0.0) GOTO 30
      DO 22 I=1,2
   22 DX(I)=AMAX1(1.E-4,ABS(XM)*1.E-4)
   30 XA=XM-DX(1)
      XZ=XM+DX(2)
      BN=NB
      BIN=(XZ-XA)/BN
      IF(BIN.LE.0.0) BIN=1.E-4
      DN=DLOG10(BIN)
      ND=DN
      FEX=TEN**ND
   32 IF(BIN/FEX.LE.1.0) GOTO 34
      FEX=FEX*TEN
   34 BIN=BIN/FEX
      DO 40 I=1,9
      KI=I
      IF(BINS(I).GE.BIN) GOTO 50
   40 CONTINUE
      KI=9
   50 BIN=BINS(KI)
      SCHR=BIN*FEX
      AW=IDINT(XA/(TEN*SCHR))*SCHR*TEN
      IF(XA-AW.LT.0.0) AW=AW-SCHR*TEN
      IF(AW+BN*SCHR.GE.XZ) GOTO 100
      KI=KI+1
      IF(KI.LE.10) GOTO 50
  100 AAW=AW
      ASCHR=SCHR
      RETURN
      END

C   21/12/87 801171518  MEMBER NAME  IDFELD   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  IDFELD( STRING, LENGTH, ICODE, VALUE, VALFLG, IERROR )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery       21/12/87:  Identify string
C
C
C
C     Routine to match input string against dictionary using CMPDCT
C     and to return corresponding ICODE  or, if a number, return VALUE
C     along with VALFLG = .TRUE. .
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     STRING    In   CHAR*(*)     String of characters with no blanks
C     LENGTH    In       I*4      Length of STRING
C     ICODE     Out      I*4      Number code as in dictionary
C     VALUE     Out      R*4      Value of STRING if a number
C     VALFLG    Out      L*4      .TRUE. if string is a number
C     IERROR    Out      i*4      Error code
C                                  0 : no error
C                                  1 : string not in dictionary
C                                      or number was unrecognisable
C                                  2 : programming error; no operation
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER*(*)  STRING

      INTEGER  ICODE,  LENGTH,  IERROR

      REAL  VALUE

      LOGICAL  IER,  VALFLG

C------------------  C O D E  ------------------------------------------

C                            Is STRING a number?

      CALL STRNUM( STRING, LENGTH, VALUE, IER )

C                            Error return means STRING is not a number
C                            So, is STRING a known word?

      IF( IER ) THEN

        CALL CMPDCT( STRING, LENGTH, ICODE, IERROR )
        VALFLG = .FALSE.

      ELSE

        VALFLG = .TRUE.
        IERROR = 0

      ENDIF
      RETURN
      END

C   19/04/79 C9050901   MEMBER NAME  STATBP   (S)           FORTRAN
      SUBROUTINE STATBP( LENGTH, ATBP )
C-----------------------------------------------------------
C
C  VERSION OF 19/04/79  LAST MOD 09/05/79    E.ELSEN
C  PROVIDE DATA FOR BANK 'ATBP' AS DESCRIBED IN
C  JADE NOTE 32.
C  ARRAY ATBP CONTAINS DATA INCLUDING BANK DESCRIPTOR
C  EXTRA ENTRY LHALGL RETURNS LENGTH ONLY.
C----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CBPC   / HBPCAR(24)
C
      DIMENSION ATBP(40), HTBP(80), ITBP(40)
      EQUIVALENCE (HTBP(1),ITBP(1))
C
C
CCC  ZERO ARRAY AND SET BANK DESCRIPTOR
      CALL VZERO( ITBP, 40 )
C
CCC  LOOP OVER COUNTERS AND SET CORRESPONDING ADC AND TDC'S
      DO 1000 J =1,24
      ITOF = J + (J-1)/8 + 54
      IBP = J*2 + (J-1)/6 + 2
      IF( HBPCAR(J) .EQ. 0 ) GO TO 800
C
CCC  FIRED COUNTERS
      HTBP(IBP) = 160
      HTBP(IBP-1) = 160
      HTBP(ITOF) = 50
      GO TO 1000
C
CCC  NOT FIRED COUNTERS
  800 HTBP(ITOF) = 2048
 1000 CONTINUE
C
      CALL MVCL( ATBP, 0, ITBP, 0, 160 )
C
C-----------------------------------------------------------
      ENTRY LHATBP( LENGTH )
C-----------------------------------------------------------
      LENGTH = 40
      RETURN
      END

C   07/06/96 606071855  MEMBER NAME  MBPR     (S4)          FORTG1
      SUBROUTINE MBPR(IU,IY,IZ)
      INTEGER IU(1),IY(1),IZ(1)
      N=IU(1)
      LA=JDSTL(IY(1),IU(1))/4+1
      IF(LA.NE.1) GOTO 10
      IU(N-6)=IZ(1)
      GOTO 100
   10 IF(IU(N-6).LE.0) GOTO 100
      LB=JDSTL(IZ(1),IU(1))/4+1
      IF(LA.NE.2.OR.LB.NE.IU(N)) GOTO 20
C     PRINT TOTAL STRUCTURE
      WRITE(6,101)
      CALL UWP(IU,1,N)
      GOTO 90
C     PRINT SELECTED BANKS
   20 J=N-8
   30 IF(J.LE.IU(N-3)) GOTO 90
      J=J-1
      LJ=IU(J)
      IF(LJ.LT.LA.OR.LJ.GT.LB) GOTO 30
      K=IU(LJ)
      WRITE(6,102) (IU(K-4+I),I=1,4)
      CALL UWP(IU(K+1),1,IU(K))
      GOTO 30
   90 IU(N-6)=IU(N-6)-1
  100 RETURN
  101 FORMAT('0MBOS - TOTAL STRUCTURE'/)
  102 FORMAT('0MBOS - BANK ',9X,A4,',',I4,'   (PT.POS.=',I4,')',
     1   '  LENGTH',I5/)
      END

C   18/10/82 606101312  MEMBER NAME  MCMAIN9  (S)           FORTRAN
      COMMON / BCS / IW(33000)
      CALL BINT( 33000, 10000, 500, 0 )
      CALL MCJADE( 0, 50 )
      CALL BSTA
      CALL PALL
      STOP
      END

C   11/01/81 310281843  MEMBER NAME  TFSUB    (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE TFARNW(INLA,INTF,IFLG,*)
C==================================================
C  MODIFIED TO CHECK ON TDCS INSTEAD OF LATCHES
C==================================================
C          CONVERTS THE TOF DATA FROM CAMAC FORMAT
C       TO ANALYSIS FORMAT :
C                   IRAW(1,NCN)= NCN  ; COUNTER#
C      RAW(2,NCN)= TDC(-)-CM(NCN)
C      RAW(3,NCN)= TDC(+)-CP(NCN)
C       OR
C      RAW(2,NCN)= TDC(-) , IF IFLG= 1.
C      RAW(3,NCN)= TDC(+) , IF IFLG= 1.
C                   RAW(4,NCN) = ADC(-)
C                   RAW(5,NCN) = ADC(+)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
      IMPLICIT INTEGER*2 (H)
#include "tfprm.for"
#include "tfadc.for"
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HSTAT(42),HON(42)
      COMMON/PRPOS/PRPLS,CPOS
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      DIMENSION IRAW(5,42),HEADR(108),LIST1(2),LIST(19)
      EQUIVALENCE (IRAW(1,1),RAW(1,1))
      DIMENSION A(214),B(214)
C
      DATA MBAD/20/
      DATA LIST/5,7,8,32,34,35,36,42,40,11,27,28,29,30,31,33,37,38,39,
     1          41/
C
      DATA IENTRY/0/,IBUG/10/
      DATA ADCLIM/1./,IRUN/0/
C
      IF(IENTRY.NE.0)  GOTO 320
      IENTRY = IENTRY + 1
 320  CONTINUE
C
      NRUN = HEADR(18)
C
C========= ADDRESSING
C
C     CALL SETSL(RAW,0,20*42,0)
      CPOS = HEADR(31)/1000.
       INLA2= INLA*2
       INTF2= INTF*2
       IL0= INLA2+6
       IA0= INTF2+3
       IT0= INTF2+94
C//////////
      BADC = TPARM(1)
      AADC = TPARM(2)
      CALL ATOFUN(INTF)
      IF(IBUG.LE.10) CALL ATOFPR(INTF)
C
      DO 3000 NCN= 1,42
      IRAW(1,NCN) = 0
      ADCM = HADC(1,NCN)- PEDLM(NCN)
      ADCP = HADC(2,NCN)-PEDLP(NCN)
      IF(NRUN.LE.2306.OR.NCN.LE.38)  GOTO  75
      IF(NRUN.GE.3182)  GOTO  75
      ADCM = ADCM*2
      ADCP = ADCP*2
   75 CONTINUE
C
      IF(NCN.NE.25.AND.NCN.NE.26)  GOTO  76
      IF(NRUN.LT.3728.OR.NRUN.GT.4426)  GOTO  76
      ITDC25 = HTDC(1,25)
      ITDC26 = HTDC(1,26)
      IF(NCN.EQ.25) HTDC(1,25) = ITDC26
      IF(NCN.EQ.26) HTDC(1,25) = ITDC25
   76 CONTINUE
C
      MONE = 0
      IF(NRUN.LT.7588.OR.NRUN.GT.8711)  GOTO  77
      IF(NRUN.LT.7900)  GOTO  78
      IF(NCN.EQ.40) HTDC(1,NCN)=2050
      IF(NCN.EQ.40) MONE = 2
   78 CONTINUE
      DO   31   L=1,MBAD
      IF(NRUN.GE.8256.AND.L.GT.4)  GOTO  77
      IF(NRUN.GE.7900.AND.L.GT.8)  GOTO  77
C     IF(NRUN.GE.8256.AND.L.GT.3)  GOTO  77
C     IF(NRUN.GE.7897.AND.L.GT.7)  GOTO  77
      IF(NCN.NE.LIST(L))  GOTO  31
      HTDC(2,NCN) = 2050
      MONE = 1
   31 CONTINUE
   77 CONTINUE
C
      IF(NRUN.LT.8712.OR.NRUN.GT.10000)  GOTO  87
      IF(NCN.NE.8)  GOTO  88
      HTDC(1,NCN) = 2050
      MONE = 2
   88 CONTINUE
      IF(NCN.NE.11)  GOTO  87
      HTDC(2,NCN) = 2050
      MONE = 1
   87 CONTINUE
C
      IF(NRUN.GT.12518)  GOTO  89
      IF(NCN.NE.31)  GOTO  89
      HTDC(2,NCN) = 2050
      MONE = 1
   89 CONTINUE
C
      IF(NRUN.GT.14605)  GOTO  91
      IF(NRUN.LT.13900)  GOTO  91
      IF(NCN.NE.36)  GOTO  93
      HTDC(2,NCN) = 2050
      MONE = 1
      GOTO  91
   93 IF(NCN.NE.40)  GOTO  91
      HTDC(1,NCN) = 2050
      MONE = 2
   91 CONTINUE
C
      IF(NRUN.LT.14500.OR.NRUN.GT.14687)  GOTO  94
      IF(NCN.NE.36)  GOTO  94
      HTDC(1,NCN) = 2050
      MONE = 2
   94 CONTINUE
C
C========= CHECK THAT BOTH TDC'S HAVE FIRED
C          UNLESS ONE IS BROKEN
      HSTAT(NCN) = MONE
      IF(MONE.EQ.2)  GOTO  32
      IF(HTDC(1,NCN).LT. 5.OR.HTDC(1,NCN).GE.2048)  GOTO  3000
      IF(MONE.EQ.1)  GOTO  1500
   32 IF(HTDC(2,NCN).LT. 5.OR.HTDC(2,NCN).GE.2048)  GOTO  3000
C
C
C========= THEY HAVE
C
 1500 CONTINUE
      IBUG = IBUG + 1
      IF(IBUG.LE.10) PRINT 420,HSTAT
  420 FORMAT(' HSTAT',42I3)
      TDCM = HTDC(1,NCN)
      TDCP = HTDC(2,NCN)
C
C  COMPUTE PULSEHEIGHT CORRECTION FOR TOF
C
      CORADM = 0.
      CORADP = 0.
      IF(HADC(1,NCN).GE.1024) ADCM = 1024.
      IF(HADC(2,NCN).GE.1024) ADCP = 1024.
      IF(ADCM.LE.1.) ADCM = 1.
      IF(ADCP.LE.1.) ADCP = 1.
      ADCMIV = 1000./ADCM
      ADCPIV = 1000./ADCP
      CORADM =  AADC + BADC*ADCMIV
      CORADP =  AADC + BADC*ADCPIV
      IF(NRUN.LT.3728)  GOTO  20
      CORADM =   CADCB(2*NCN-1)*SQRT(ADCMIV)
      CORADP =   CADCB(2*NCN  )*SQRT(ADCPIV)
   20 IF(ADCM.LT.1024.) CMS = CORNOR(2*NCN-1)
      IF(ADCP.LT.1024.) CPS = CORNOR(2*NCN)
      IF(ADCM.GE.1024.) CMS = COROVF(2*NCN-1)
      IF(ADCP.GE.1024.) CPS = COROVF(2*NCN)
      IF(ADCM.LE.  25.) CORADM = 0.
      IF(ADCP.LE.  25.) CORADP = 0.
C     CORADM = 0.
C     CORADP = 0.
C
      IF(IBUG.LE.10) PRINT 106,NCN,CADCA(2*NCN-1),CADCB(2*NCN-1),
     1 CADCA(2*NCN),CADCB(2*NCN)
      IF(IBUG.LE.10) PRINT 106,NCN,ADCM,ADCP,CORADM,CORADP,CMS,CPS
  106 FORMAT(' TOFARD',I5,10F10.3)
      IF(TDCM.LT.10..OR.TDCM.GT.2048.)  GOTO  2000
      IF(ADCM.LT.ADCLIM)  GOTO  2000
      TDCM0= TDCM
      IF(IFLG.EQ.1) GO TO 1600
      TDCM0= TDCM0*TCALM(NCN)
      TDCM0= TDCM0-CMS-CORADM
C     CALL HFILL(701,CORADM,FLOAT(NCN))
      IF(IBUG.LE.10) PRINT 106,NCN,TDCM0
 1600 IRAW(1,NCN)= NCN
      RAW(2,NCN)= TDCM0
      RAW(4,NCN)= ADCM
C
 2000 CONTINUE
      IF(TDCP.LT.10..OR.TDCP.GT.2048.)  GOTO  2050
      IF(ADCP.LT.ADCLIM)  GOTO  2100
      TDCP0= TDCP
      IF(IFLG.EQ.1) GO TO 2050
2010  TDCP0= TDCP0*TCALP(NCN)
      TDCP0= TDCP0-CPS-CORADP
CC    CALL HFILL(702,CORADP,FLOAT(NCN))
      IF(IBUG.LE.10) PRINT 106,NCN,TDCP0
2050  IRAW(1,NCN)= NCN
      RAW(3,NCN)= TDCP0
      RAW(5,NCN)= ADCP
2100  CONTINUE
C
 3000 CONTINUE
C/////////
      RETURN
      END

C   25/06/78 708272232  MEMBER NAME  ENELPO   (S)           FORTRAN
      FUNCTION ENELPO(E)
C
C THIS FUNCTION GIVES THE AVERAGE IONIZATION LOSS, I.E. ENERGY LOSS
C FOR POSITRONS.
C THIS IS FORMULA (14) IN UEHLING, ANN.REV.NUCL.PHYS. 4 (1954)315
C
C  NOTE THAT THE INPUT ENERGY COMES IN UNITS OF ME, I.E. == GAMMA,
C  THEREFORE     BETA**2 = 1 - 1/E**2
C  LN2 = .69315
C
C  COMMON/ILPAR/ IS SET IN PARST2, CALLED BY INTSHW
C
      COMMON/ILPAR/AI,BI,ALCUTM
      DATA RME/0.511/
C
      BE2=1.-1./E**2
      IF(BE2.LE.0.)GOTO10
      EKIN = (E-1.)*RME
C
      CON=ALOG(E)+ALOG(BE2)/2.
C
      BIPRIM = BI + .69315
C
      ENELPO=AI*(BIPRIM + ALOG(BE2) - ALOG(1.-BE2) + ALOG(EKIN)
     @ - (BE2/12.) * ( 23. + 14./(E+1.) + 10./(E+1.)**2 + 4./(E+1.)**3 )
     @         -DENDEL(0.434294*CON))/BE2
C FUNCTION DENDEL CALCULATES DENSITY EFFECT CORRECTION.
      RETURN
 10   ENELPO=0.
      RETURN
      END

C   14/10/82            MEMBER NAME  MEMBERS1 (S)           FORTRAN77
      0.   COMMON ACS




      END
#include "acs.for"
#include "bscom1.for"
      1.   STANDARD PROGRAMS


           SUBPROGRAM   ENTRIES

      1.1  BINT         BINT1  BSPC  BRNM
      1.2  IBLN         -
      1.3  BCRE         -
      1.4  CCRE         -
      1.5  BLOC         -
      1.6  CLOC         -
      1.7  BCHM         BCHF  BSTR BMRT
      1.8  BDAR         -
      1.9  BPOS         CPOS  BPRL
      1.10 BNXT         -
      1.11 CNXT         -
      1.12 BMLT         BSAW  BDEF  BSAT  BSAD
      1.13 BDLS         BPRS
      1.14 BDLM         BDLG  BPRM  BSLW  BSLC   BSLT
      1.15 BGAR         -
      1.16 BDMP         BDMPF
      1.17 BSTA         -
      1.18 DUMP0C       -
      1.19 BCHL         BMVE
      1.20 CCHL         CMVE
      1.21 BGAC         -
      1.22 BSLS         BSLR
      1.23 INDAR
      END
#include "bint.for"
#include "ibln.for"
#include "bcre.for"
#include "ccre.for"
#include "bloc.for"
#include "cloc.for"
#include "bchm.for"
#include "bdar.for"
#include "bpos.for"
#include "bnxt.for"
#include "cnxt.for"
#include "bmlt.for"
#include "bdls.for"
#include "bdlm.for"
#include "bgar.for"
#include "bdmp.for"
#include "bsta.for"
#include "dump0c.for"
#include "bchl.for"
#include "cchl.for"
#include "bgac.for"
#include "bsls.for"
#include "indar.for"
      2.   CARD INPUT PROGRAM

           SUBPROGRAM   ENTRIES

      2.1  BREADC       -
      2.2  READHL       -
      END
#include "breadc.for"
#include "readhl.for"
      3.   INPUT-OUTPUT PROGRAMS

           SUBPROGRAM   ENTRIES

      3.1  BREAD        -
      3.2  CREAD        -
      3.3  BWRITE       -
      3.4  BRDS         -
      3.5  BWRS         BWRO
      3.6  BFRD         BFWR
      3.7  BINP         BFRR
      3.8  BOUTP        BORDP
      3.9  BSEQ         BSEW  BSET  BSEL
      3.10 RDVAR        WRVAR WRFIX
      END
#include "bread.for"
#include "cread.for"
#include "bwrite.for"
#include "brds.for"
#include "bwrs.for"
#include "bfrd.for"
#include "binp.for"
#include "boutp.for"
#include "bseq.for"
#include "rdvar.for"
      4.   DIRECT ACCESS PROGRAMS


           SUBPROGRAM   ENTRIES

      4.1  BLOCDA       BDLSDA BCREDA BCHKDA
      4.2  BINLDA       -
      4.3  BLOADA       -
      4.4  PODA         CHDIR
      4.5  DADA         -
      4.6  RDDA         WRDA   RDSQ   WRSQ
      4.7  BPASDA

      END
#include "blocda.for"
#include "binlda.for"
#include "bloada.for"
#include "poda.for"
#include "dada.for"
#include "rdda.for"
#include "bpasda.for"
      5.   APPLICATION PROGRAMS



      END
#include "ucond.for"
#include "pcond.for"
#include "utabl.for"
#include "qtabl.for"
#include "ptabl.for"
#include "uhist.for"
#include "defst.for"
#include "phist.for"
#include "ucorr.for"
#include "ccor.for"
#include "pcorr.for"
#include "ustos.for"
#include "pstor.for"
#include "tocont.for"
#include "ptext.for"
#include "dpeak.for"
#include "hmean.for"
#include "pmean.for"
#include "ppeak.for"
#include "umean.for"
#include "qmean.for"
#include "qpeak.for"
#include "ussto.for"
#include "utabi.for"
#include "uwp2.for"
      6.   NON-STANDRAD PROGRAMS


      3.10 ASRD         ASVB  ASVBS ASCL

      END
#include "testwr.for"
#include "lsbcom.for"
      7.  NON-BOS PROGRAMS



      END
#include "uwp.for"
#include "bfmt.for"
#include "iaf.for"
#include "itoda.for"
#include "pvert.for"
#include "sort4.for"
#include "sortir.for"
#include "vall.for"

C   18/01/88 807262227  MEMBER NAME  TPRFI2   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPRFI2( REFITZ, MODE, IOPT )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      18/01/88:  Get instr. about Z-S refit
C
C          mod: C. Bowdery       2/02/88:  COMMONZVTX not COMMONVTX now
C          mod: C. Bowdery      22/07/88:  New PATR only if rphi not new
C     Last mod: C. Bowdery      26/07/88:  Change to TPINQZ and response
C
C     Routine to provide yes/no answer about need for central detector
C     Z-S refit and if wanted, the refitting mode. See JCN 95.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     REFITZ    Out      L*4      TRUE if Z-S  refit step is to be done
C     MODE      Out      I*4      MODE value needed for s/r ZSRFTV
C     IOPT      Out      I*4      IOPT value needed for s/r ZSRFTV
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  REFIT*8, CIFNOZ*20, CZS*20
      CHARACTER  CRFI*20, COMVTX*20, COLDP*20

      LOGICAL  ZS, IFNOZ, FIRST, OLDPAT, COMVER, RFI
      LOGICAL  REFITZ, INDEP, WICOMV

      INTEGER  MODE, IOPT

      SAVE  FIRST, ZS, IFNOZ, OLDPAT, COMVER, RFI

      DATA  FIRST / .TRUE. /
      DATA  REFIT / 'REFIT' /,  CIFNOZ  / 'IFNOZS' /
      DATA  COLDP / 'OLDPATR' /, CZS    / 'ZS'   /
      DATA  CRFI  / 'RFI'   /
      DATA  COMVTX/ 'COMMONZVTX' /

C------------------  C O D E  ------------------------------------------

C                            If not first call, IFNOZ etc already SAVEd.

      IF( FIRST ) THEN

C                            Get user option relating to Z-S refitting
C                            that is, ZS, IFNOZS, OLDPATR, COMMONZVTX
C                            Also get RFI option.

        CALL TPUOPT( REFIT, CZS,    ZS     )
        CALL TPUOPT( REFIT, CIFNOZ, IFNOZ  )
        CALL TPUOPT( REFIT, COLDP,  OLDPAT )
        CALL TPUOPT( REFIT, COMVTX, COMVER )
        CALL TPUOPT( REFIT, CRFI,   RFI    )

        FIRST = .FALSE.

      ENDIF

      IF( ZS ) THEN

        REFITZ = .TRUE.

C                            Don't ask for a new PATR if OLDPATR
C                            selected or if a new one was made for RFI

        IF( OLDPAT  .OR.  RFI ) THEN
          MODE = 0
        ELSE
          MODE = 1
        ENDIF

C                            Set option pertaining to common_z_vertex

        IF( COMVER ) THEN
          IOPT = 2
        ELSE
          IOPT = 1
        ENDIF

C                            Handle conditional fit case

        IF( IFNOZ) THEN

C                            Has the latest PATR bank been z refitted
C                            with or without a common_z_vertex ?
C                            If no z refit, both flags are FALSE.

          CALL TPINQZ( INDEP, WICOMV )

C                            If desired fit already exists, cancel refit

          IF( ( WICOMV  .AND.        COMVER )  .OR.
     +        ( INDEP   .AND.  .NOT. COMVER )       ) THEN
            REFITZ = .FALSE.
            MODE   = 0
            IOPT   = 0
          ENDIF

        ENDIF

      ELSE

        REFITZ = .FALSE.
        MODE   = 0
        IOPT   = 0

      ENDIF

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   07/06/96 606071908  MEMBER NAME  SMMED    (S4)          FORTG1
      SUBROUTINE SMMED(Y,N,ISTE)
      REAL Y(N),EP(3,2),ZI(3)
      DIAN3(A,B,C)=AMAX1(AMIN1(A,B),AMIN1(B,C),AMIN1(C,A))
C
C
C
C
C
C
C
C
C
C
      JSTE=ISTE
   10 LSTE=JSTE/10
      KSTE=JSTE-10*LSTE
      JSTE=LSTE
      IF(KSTE.LE.0.OR.KSTE.GT.6) GOTO 100
      GOTO (20,30,40,50,60,70),KSTE
C
C
C     (1) = MED3
C     REPLACE EACH VALUE BY MEDIAN OF 3 VALUES
C
   20 NM=N-2
      IF(NM.LT.1) GOTO 10
      EP(1,1)=Y(1)
      EP(1,2)=Y(N)
      ZL=Y(1)
      DO 22 I=1,NM
      ZN=DIAN3(Y(I),Y(I+1),Y(I+2))
      Y(I)=ZL
   22 ZL=ZN
      Y(N-1)=ZL
      EP(2,1)=Y(2)
      EP(2,2)=Y(N-1)
      EP(3,1)=3.0*Y(2)-2.0*Y(3)
      EP(3,2)=3.0*Y(N-1)-2.0*Y(N-2)
      Y(1)=DIAN3(EP(1,1),EP(2,1),EP(3,1))
      Y(N)=DIAN3(EP(1,2),EP(2,2),EP(3,2))
      GOTO 10
C
C     (2) = MED5
C     REPLACE EACH VALUE BY MEDIAN OF 5 VALUES
C
   30 NM=N-4
      IF(NM.LT.1) GOTO 10
      ZL=Y(1)
      ZN=DIAN3(Y(1),Y(2),Y(3))
      ZE=DIAN3(Y(N-2),Y(N-1),Y(N))
      DO 36 I=1,NM
C
C     MEDIAN OF 5 VALUES
C
      IF(Y(I).GT.Y(I+4)) GOTO 31
      MIN=0
      MAX=4
      GOTO 32
   31 MIN=4
      MAX=0
   32 DO 35 N=1,3
      ZZ=Y(I+N)
      IF(ZZ.GT.Y(I+MIN)) GOTO 33
      ZI(N)=Y(I+MIN)
      MIN=N
      GOTO 35
   33 IF(ZZ.LT.Y(I+MAX)) GOTO 34
      ZI(N)=Y(I+MAX)
      MAX=N
      GOTO 35
   34 ZI(N)=ZZ
   35 CONTINUE
      ZM=DIAN3(ZI(1),ZI(2),ZI(3))
      Y(I)=ZL
      ZL=ZN
   36 ZN=ZM
      Y(N-3)=ZN
      Y(N-2)=ZM
      Y(N-1)=ZE
      GOTO 10
C
C     (3) = MED3C
C     REPLACE EACH VALUE BY MEDIAN OF 3 VALUES, COPYING FIRST AND LAST
C
   40 NM=N-2
      IF(NM.LT.1) GOTO 10
      ZL=Y(1)
      DO 42 I=1,NM
      ZN=DIAN3(Y(I),Y(I+1),Y(I+2))
      Y(I)=ZL
   42 ZL=ZN
      Y(N-1)=ZL
      GOTO 10
C
C     (4) = Q
C     CORRECT FLAT AREAS OF THREE EQUAL VALUES BY QUADRATIC INTERPOL.
C
   50 IA=3
      IB=N-2
      IF(IB.LT.IA) GOTO 10
      DO 52 I=IA,IB
      IF(Y(I).NE.Y(I-1).OR.Y(I).NE.Y(I+1)) GOTO 52
      A=Y(I)-Y(I-2)
      B=Y(I)-Y(I+2)
      IF(A*B.LE.0) GOTO 52
      J=1
      IF(ABS(A).GT.ABS(B)) J=-1
      Y(I-J)=Y(I+J)-0.5*(Y(I+J+J)-Y(I-J-J))
      Y(I)=(8.0*Y(I+J)-3.0*Y(I+J+J)+Y(I-J-J))/6.0
   52 CONTINUE
      GOTO 10
C
C     (5) = H
C     REPLACE EACH VALUE BY THE AVERAGE OVER 3 VALUES
C
   60 NM=N-2
      IF(NM.LT.1) GOTO 10
      ZL=Y(1)
      DO 62 I=1,NM
      ZN=0.25*Y(I)+0.5*Y(I+1)+0.25*Y(I+2)
      Y(I)=ZL
   62 ZL=ZN
      Y(N-1)=ZL
      GOTO 10
C
C     (6) = CH
C     REPLACE EACH VALUE BY THE AVERAGE OVER 5 VALUES,
C     IF QUADRATIC TERM NOT SIGNIFICANT
C
   70 NM=N-4
      IF(NM.LT.1) GOTO 10
      CUT=1.0
      ZL=Y(1)
      ZN=0.25*(Y(1)+2.0*Y(3)+Y(3))
      ZE=0.25*(Y(N)+2.0*Y(N-1)+Y(N-2))
      DO 74 I=1,NM
      ZM=Y(I+2)
      SUM=-2.0*Y(I)+Y(I+1)+2.0*Y(I+2)+Y(I+3)-2.0*Y(I+4)
      SUM=SUM*SUM/14.0
      IF(SUM.GT.CUT) GOTO 72
      SUM=Y(I)+2.0*Y(I+1)+3.0*Y(I+2)+2.0*Y(I+3)+Y(I+4)
      ZM=SUM/9.0
   72 Y(I)=ZL
      ZL=ZN
   74 ZN=ZM
      Y(N-3)=ZN
      Y(N-2)=ZM
      Y(N-1)=ZE
      GOTO 10
C
  100 RETURN
      END

C   10/04/84            MEMBER NAME  DRAMOV   (JADEGS)      FORTRAN
      SUBROUTINE DRAMOV(X1,Y1,X2,Y2,L)
C
C     DRAW LINE FROM X1,Y1 TO X2,Y2
C     IF L NONZERO, A DASHED CODE WILL BE GENERATED
C
      CALL MOVEA(X1,Y1)
      IF(L.LE.0) CALL DRAWA(X2,Y2)
      IF(L.GT.0) CALL DASHA(X2,Y2,L)
      RETURN
      END

C   08/08/79 C9091901   MEMBER NAME  ANOM41   (S)           FORTRAN
      SUBROUTINE ANOM41(IRUN)
C---  ANOMALIES OF RUNS 1122 - 1162
C---  11.0 GEV      JULY 1979
C
C     H.WRIEDT    27.07.79     02:20
C     LAST MODIFICATION     19.09.79     13:25
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      GOTO (1122,1123,1124,1125,1126,1127,1128,1129,1130,1131,1132,1133,
     &      1134,1135,1136,1137,13,1139,1140,13,1142,13,1144,1145,1146,
     &      1147,13,1149,1150,1151,1152,1153,1154,1155,1156,1157,13,
     &      1159,1160,1161,1162),IRUN
   13 RETURN
C
C1122 PRELIMINARY
 1122 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1123 PRELIMINARY
 1123 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1124 PRELIMINARY
 1124 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1125 PRELIMINARY
 1125 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1126 PRELIMINARY
 1126 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1127 PRELIMINARY
 1127 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1128 PRELIMINARY
 1128 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1129 PRELIMINARY
 1129 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1130 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(27) = -1
      LIMIT(27) = 165
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(165) = -1
      LIMIT(165) = 210
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1131 PRELIMINARY
 1131 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(27) = -1
      LIMIT(27) = 165
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(165) = -1
      LIMIT(165) = 210
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1132 PRELIMINARY
 1132 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(27) = -1
      LIMIT(27) = 165
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(165) = -1
      LIMIT(165) = 210
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1133 PRELIMINARY
 1133 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(27) = -1
      LIMIT(27) = 165
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(165) = -1
      LIMIT(165) = 210
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(49) = .TRUE.
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1134 PRELIMINARY
 1134 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(27) = -1
      LIMIT(27) = 165
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(165) = -1
      LIMIT(165) = 210
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1135 PRELIMINARY
 1135 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(27) = -1
      LIMIT(27) = 165
      KCONST(43) = -1
      LIMIT(43) = 225
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(165) = -1
      LIMIT(165) = 210
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 210
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(69) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(91) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1136 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1137 PRELIMINARY
 1137 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(67) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1139 PRELIMINARY
 1139 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 240
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(53) = .TRUE.
      LTHRES(59) = .TRUE.
      LTHRES(67) = .TRUE.
      LTHRES(72) = .TRUE.
      LTHRES(85) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1140 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1142 PRELIMINARY
 1142 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1144 PRELIMINARY
 1144 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1145 PRELIMINARY
 1145 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(49) = .TRUE.
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1146 PRELIMINARY
 1146 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1147 PRELIMINARY
 1147 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1149 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 210
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(59) = .TRUE.
      LTHRES(63) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(171) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1150 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1151 PRELIMINARY
 1151 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(6) = .TRUE.
      LTHRES(24) = .TRUE.
      LTHRES(30) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1152 PRELIMINARY
 1152 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1153 PRELIMINARY
 1153 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1154 PRELIMINARY
 1154 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 165
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(183) = -1
      LIMIT(183) = 240
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(183) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
C1155 PRELIMINARY
 1155 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
 1156 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1157 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(49) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1159 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1160 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(162) = -1
      LIMIT(162) = 165
      KCONST(166) = -1
      LIMIT(166) = 375
      KCONST(168) = -1
      LIMIT(168) = 225
      KCONST(190) = -1
      LIMIT(190) = 225
C
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(116) = .TRUE.
      LTHRES(162) = .TRUE.
      LTHRES(168) = .TRUE.
      LTHRES(172) = .TRUE.
      LTHRES(190) = .TRUE.
C
      RETURN
C
 1161 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
C1162 PRELIMINARY
 1162 LCHANN(79) = .TRUE.
      LCHANN(107) = .TRUE.
      LCHANN(156) = .TRUE.
      LCHANN(171) = .TRUE.
      LCHANN(173) = .TRUE.
      LCHANN(181) = .TRUE.
C
      KCONST(116) = -1
      LIMIT(116) = 180
      KCONST(166) = -1
      LIMIT(166) = 375
C
      LTHRES(78) = .TRUE.
      LTHRES(84) = .TRUE.
      LTHRES(106) = .TRUE.
      LTHRES(112) = .TRUE.
      LTHRES(172) = .TRUE.
C
      RETURN
C
      END

C   25/04/79 C9042501   MEMBER NAME  RODRAW   (JADEGS)      FORTRAN
      SUBROUTINE RODRAW(X0,Y0,X10,Y10,X20,Y20,COSN,SISN)
      IMPLICIT INTEGER*2 (H)
C---
C---     DRAWS LINE SEGMENT ROTATED ABOUT FIXED POINT.
C---                                   L.H. O'NEILL
C---                                   WEDNESDAY, APRIL 25,1979
C---
      X1 = COSN*X10 - SISN*Y10 + X0
      Y1 = SISN*X10 + COSN*Y10 + Y0
      X2 = COSN*X20 - SISN*Y20 + X0
      Y2 = SISN*X20 + COSN*Y20 + Y0
      CALL MOVEA(X1,Y1)
      CALL DRAWA(X2,Y2)
      RETURN
      END

C   09/11/78            MEMBER NAME  NPECERO  (WORKS)       FORTRAN
      SUBROUTINE NPECER(JBE,Z,COST,PENUM)
C     S.YAMADA    12-12-77
C---- CALCULATE NUMBER OF PHOTOELECTRONS BY CERECKOV LIGHT.
C
C INPUT
C     JBE=1 FOR BARREL PART,  =2 FOR END CAP
C     Z=DEPTH OF THE SOURCE TRACK IN THE LEAD GLASS( RAD.LENGTH )
C     COST=COS(THETA) OF THE SOURCE TRACK W.R.TO THE NORMAL OF
C          THE CATHODE SURFACE.
C
C OUTPUT
C     PENUM=NO.OF PHOTOELECTRONS/1RAD.LENGTH LONG TRACK.
C
C---- AN EMPIRICAL FORMULA IS USED.
C---- PHOTOMULTIPLIER AREA IS ASSUMED TO COVER THE WHOLE SURFACE.
C---- TO GET THE REAL PHOTOELECTRON NUMBER PENUM SHOULD BE MULTIPLIED
C     BY THE RATIO (CATHODE AREA/LEAD GLASS CROSS SECTION).
C
      DIMENSION A(2),B(8,2,2)
      DATA B/32.43, -9.609, -265.4, 1129., -1548., 689.6, 19.66, 0.,
     1  .2925, .5996, -0.1503, 7.148, -1.226, -17.22, 1.66, 11.21,
     2   22.57, -1.9, -285.2, 1459.0,-2780., 2306., -689.5, 0.,
     3   .1789, .8967, .0754, 3.593, -0.702, -10.41, .84, 7.068/
C
      PENUM = 0.
C---- CHECK POSITION
      IF(Z.LT.0. .OR. Z.GT.13.4 ) GO TO 90
      IF(ABS(COST).GT.1.0) GO TO 90
C---- DETERMINE A
      JBEW = JBE
C---- PROTECTION AGAINST FAULS JBE INPUT.
      IF(JBEW.LT.1) JBEW = 1
      IF(JBEW.GT.2) JBEW = 2
        DO 1 IA=1,2
        X = COST
        IF(IA.EQ.1) X = X*X
        F = B(8,IA,JBEW)
          DO 2 J=2,8
          JR = 9-J
          F = F*X+B(JR,IA,JBEW)
    2     CONTINUE
        A(IA) = F
    1   CONTINUE
C---- FUNCTN=A(1)+CC(COST)*EXP(0.55*Z)+A(2)*Z
C
      CC = ((0.8751*COST-0.8362)*COST+0.3924)*COST-2.0
      CC = 10.**CC
      IF(JBEW.EQ.2) CC = 1.5*CC
      EXPARG = EXP(0.55*Z)
      PENUM = A(1)+CC*EXPARG+A(2)*Z
      RETURN
C
      DATA MESS/0/
   90 IF(MESS.EQ.0) WRITE(6,600) JBE,Z,COST
  600 FORMAT(' ***** WRONG INPUT FOR NPECER *****',I6,2E12.3)
      MESS = 1
      RETURN
      END

C   02/02/82 504152032  MEMBER NAME  TBGDIS   (JADEGS)      FORTRAN
      SUBROUTINE TBGDIS
      IMPLICIT INTEGER*2 (H)
C---
C---     DISPLAYS BARREL GROUPS AND SEPTENCES, ECAP QUADRANTS ETC.,
C---     ACCORDING TO LATCHES SET, FOR 1982 -      DATA FORMAT
C---
C---  LAST CHANGE  15.4.1985                   J.OLSSON  23.1.1982
C---
      LOGICAL TBIT,DSPDTM
#include "cdata.for"
#include "cgeo1.for"
#include "cgraph.for"
      COMMON /CGRAP2/ BCMD,DSPDTM(30)
      COMMON/CJTRIG/PI,TWOPI,PIHALF
      DIMENSION HMW(20)
      DIMENSION HELP(2),RF(3),HRF(42)
      EQUIVALENCE (ICAMWD,HELP(1))
      DATA HELP /0,0/,MASK2/Z60000/
      DATA HRF/1,2,3,1,2,3,1,2,3,1,2,3,1,2,3,1,2,3,1,2,3,1,2,3,1,2,3,
     $ 1,2,3,1,2,3,1,2,3,1,2,3,1,2,3/
      DATA ICALL/0/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHMW*40
      EQUIVALENCE (cHMW,HMW(1))
*** PMF(end)

      IF(ICALL.NE.0) GO TO 10
      ICALL=1
      RF(1) = RLG - 60.
      RF(2) = RLG - 40.
      RF(3) = RLG - 20.
      R7 = OUTR2 + 50.
      R4 = 21.
      DEFI = TWOPI/42.
      DEFI7 = TWOPI/7.
      DEFIH = .5*DEFI
      EPS = .1*DEFIH
      L7 = 14
      NN4 = 40
   10 CONTINUE
      IF(LASTVW.NE.12.AND.LASTVW.NE.15) GO TO 3500
      WRITE (6,3501)
3501  FORMAT(' NOT AVAILABLE IN THIS VIEW...')
      RETURN
3500  IPJ=IDATA(IBLN('LATC'))
      IF(IPJ.GT.0) GO TO 2740
      WRITE(6,275)
275   FORMAT(' NO LATC BANK IN THIS EVENT..')
      RETURN
2740  IBN=IDATA(IPJ+1)
      IF(LAND(IBN,MASK2).NE.0) GO TO 1
      WRITE(6,276) IBN,IBN,MASK2
276   FORMAT(' BANK DESC = ',I6,1X,Z8,' MASK2 = ',Z8,' DISPLAY NOT POSSI
     $BLE')
      RETURN
1     IPJH = 2*IPJ
      IF(LASTVW.GT.3) GO TO 7774
      J1 = IPJH + 14
      J2 = IPJH + 19
C
C LOOP OVER THE BARREL GROUPS
C
      NBIT=7
      DO 32 JK = J1,J2
      HELP(2) = HDATA(JK)
      ICAMWD = ISHFTL(ICAMWD,1)
      DO 32 IBT = 1,NBIT
      ICAMWD = ISHFTR(ICAMWD,1)
      IE = (JK-J1)*NBIT
      IF(.NOT.TBIT(ICAMWD,31)) GO TO 32
      IE = IE + IBT
C---
C---   GROUP NR IE IS SET, DISPLAY IT
C---
      FI1=(IE-2)*DEFI-DEFIH + EPS
      FI2=IE*DEFI+DEFIH - EPS
      RR=RF(HRF(IE))
      CALL CIRSEG(8,RR,FI1,FI2,0.,0.,0)
   32 CONTINUE
C
C NOW SEPTANCES
C
      NBIT=7
      J3 = IPJH + 20
      HELP(2) = HDATA(J3)
      ICAMWD = ISHFTL(ICAMWD,1)
      DO 33 IBT = 1,NBIT
      ICAMWD = ISHFTR(ICAMWD,1)
      IF(.NOT.TBIT(ICAMWD,31)) GO TO 33
C---
C---   SEPTANCE NR IBT IS SET, DISPLAY IT
C---
      FI1=(IBT-1)*DEFI7-3.5*DEFI + EPS
      FI2=FI1+DEFI7 - 2.*EPS
      CALL CIRSEG(20,R7,FI1,FI2,0.,0.,0)
   33 CONTINUE
C
C OUTLINE LIMITS OF THE SEPTANCES
C
      FISX = -3.5*DEFI
      FISX = FISX - DEFI7
      R2 = OUTR2
      R1 = R7
      DO 28 IIK = 1,7
      FISX = FISX + DEFI7
      X2 = R2*COS(FISX)
      Y2 = R2*SIN(FISX)
      X1 = R1*COS(FISX)
      Y1 = R1*SIN(FISX)
      CALL DRAMOV(-X1,Y1,-X2,Y2,L7)
 28   CONTINUE
C
C DISPLAY ENDCAP QUADRANT BITS
C
7774  CONTINUE
      ISTX = 3695
      IADD = 400
      ISTY = 1250
      XMINRE = XMIN
      XMAXRE = XMAX
      YMINRE = YMIN
      YMAXRE = YMAX
      XXX = XMAX - .05*(XMAX-XMIN)
      YYY=YMIN + 0.42*(YMAX-YMIN)
      CALL MOVEA(XXX,YYY)
      CALL CORE(HMW,4)
      WRITE(cHMW,1125)          ! PMF 17/11/99: UNIT=10 changed to cHMW
1125  FORMAT(' +Z ')
      CALL EOUTST(4,HMW)
      YYY=YMIN + 0.28*(YMAX-YMIN)
      CALL MOVEA(XXX,YYY)
      CALL CORE(HMW,4)
      WRITE(cHMW,1126)          ! PMF 17/11/99: JUSCRN changed to cHMW
1126  FORMAT(' -Z ')
      CALL EOUTST(4,HMW)
      CALL TWINDO (ISTX,ISTX+IADD,ISTY,ISTY+IADD)
      CALL DWINDO(-50.,50.,-50.,50.)
C                             DRAW ECAP CIRCLES AND QUADRANTS
      XV = 0.
      YV = 25.
      CALL PLYGON(NN4,R4,XV,YV,0)
      CALL PLYGON(NN4,R4,XV,-YV,0)
      CALL DRAMOV(XV,YV+R4,XV,YV-R4,0)
      CALL DRAMOV(XV,-YV+R4,XV,-YV-R4,0)
      CALL DRAMOV(XV-R4,YV,XV+R4,YV,0)
      CALL DRAMOV(XV-R4,-YV,XV+R4,-YV,0)
C
      NBIT=8
      J4 = IPJH + 21
      HELP(2) = HDATA(J4)
      ICAMWD = ISHFTL(ICAMWD,1)
      DO 34 IBT = 1,NBIT
      ICAMWD = ISHFTR(ICAMWD,1)
      IF(.NOT.TBIT(ICAMWD,31)) GO TO 34
C---
C---   ECAP QUADRANT NR IBT IS SET, DISPLAY IT
C---
      IQ = IBT
      IF(IQ.GT.4) IQ = IQ - 4
      XV = 0.
      YV = -25.
      IF(IBT.GT.4) YV = 25.
      CALL ECAPQ(10,R4,IQ,XV,YV,0)
   34 CONTINUE
C                 RESET STANDARD VIEW
      CALL TWINDO (0,4095,0,4095)
      CALL SETSCL(LASTVW)
      XMIN = XMINRE
      XMAX = XMAXRE
      YMIN = YMINRE
      YMAX = YMAXRE
      CALL DWINDO (XMIN,XMAX,YMIN,YMAX)
C
C DISPLAY NOW TBG BITS
C
      IPJ=IDATA(IBLN('TRIG'))
      IF(IPJ.GT.0) GO TO 4740
      WRITE(6,475)
475   FORMAT(' NO TRIG BANK IN THIS EVENT..')
      RETURN
4740  IBN=IDATA(IPJ+1)
      IF(LAND(IBN,MASK2).NE.0) GO TO 4
      WRITE(6,476) IBN
476   FORMAT(' BANK DESCRIPTOR NOT EQUAL 2, BUT ',I6,' DISPLAY NOT POSSI
     $BLE')
      RETURN
 4    IPJH = 2*IPJ
      IF(LASTVW.GT.3) GO TO 7775
      J1 = IPJH + 5
      J2 = IPJH + 7
C
C LOOP OVER THE TBG BITS
C
      NBIT=15
      DO 62 JK = J1,J2
      HELP(2) = HDATA(JK)
      ICAMWD = ISHFTL(ICAMWD,1)
      IE = (JK-J1)*(NBIT-1)
      DO 62 IBT = 1,NBIT
      ICAMWD = ISHFTR(ICAMWD,1)
      IF(IBT.EQ.8) GO TO 62
      IF(.NOT.TBIT(ICAMWD,31)) GO TO 62
      JBT = IBT
      IF(JBT.GT.7) JBT = JBT - 1
      IF = IE + JBT
C---
C---   TBGBIT NR IF IS SET, DISPLAY IT
C---
      FI1=(IF-1)*DEFI
      RR=RF(HRF(IF))
      CALL TBGSTR(RR,FI1,0.,0.,0)
   62 CONTINUE
7775  RETURN
      END
      SUBROUTINE TBGSTR(R,FI1,XV,YV,L)
      COMMON /CJTRIG/ PI,TWOPI
C
C     DRAW SYMBOL AT RADIUS R, ANGLE FI1  CENTERED AT XV,YV
C     L GIVES CODE FOR SYMBOL
C
      X0 = R*COS(FI1)
      Y0 = R*SIN(FI1)
      CALL PLYGON(6,15.,-XV-X0,YV+Y0,0)
      RETURN
      END
      SUBROUTINE CIRSEG(NN,R,FI1,FI2,XV,YV,L)
      COMMON /CJTRIG/ PI,TWOPI
C
C     DRAW CIRCLE SEGMENT AT RADIUS R, BETWEEN FI1,2  CENTERED AT XV,YV
C     NN GIVES SEGMENTATION OF SEGMENT
C     L GIVES CODE FOR HASHED LINE, 0 GIVES FULL DRAW
C
      X0 = R*COS(FI1)
      Y0 = R*SIN(FI1)
      CALL MOVEA(-X0,Y0)
      DEFI = ABS(FI2-FI1)/FLOAT(NN)
      FISX = FI1
      DO 27 IIK = 1,NN
      FISX = FISX + DEFI
      X0 = R*COS(FISX)
      Y0 = R*SIN(FISX)
      IF(L.GT.0) CALL DASHA(XV-X0,YV+Y0,L)
 27   IF(L.LE.0) CALL DRAWA(XV-X0,YV+Y0)
      RETURN
      END
      SUBROUTINE ECAPQ(NN,R,IQ,XV,YV,L)
C
C     FILL QUADRANT IQ WITH LINE MESH, IN THE CIRCLE R AROUND XV,YV
C     NN GIVES SEGMENTATION OF LINE MESH
C     L GIVES CODE FOR HASHED LINE, 0 GIVES FULL DRAW
C
      DELRX = R/FLOAT(NN)
      IF(IQ.EQ.1.OR.IQ.EQ.4) DELRX = - DELRX
      X1 = XV
      NNL = NN-1
      DO 2  I = 1,NNL
      X1 = X1 + DELRX
      CALL MOVEA(X1,YV)
      DY = SQRT(R*R - (XV-X1)**2)
      Y1 = YV+DY
      IF(IQ.EQ.3.OR.IQ.EQ.4) Y1 = YV - DY
      CALL DRAWA(X1,Y1)
2     CONTINUE
      RETURN
      END

      SUBROUTINE XYRFTV(MODE)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON/XYFVT1/MODXYV
      DATA LBINIT /0/, IQPATR/0/, IQJHTL/0/
      IF(
     - LBINIT .LE.0
     -)THEN
         LBINIT = 1
         IQPATR = IBLN('PATR')
         IQJHTL = IBLN('JHTL')
      IF(
     - LAND(MODE,16).NE.0
     -)THEN
            WRITE(6,81)
 81         FORMAT(' *** XYRFTV WITHOUT VERTEX CONSTRAINT ***')
      ELSE
      IF(
     - LAND(MODE,4).EQ.0
     -)THEN
               WRITE(6,82)
 82            FORMAT(' *** XYRFTV WITH VERTEX CONSTRAINT ***')
               WRITE(6,84)
 84            FORMAT(' VC NOT APPLIED IF VERTEX INCOMPATIBLE',
     +         ' WITH TRACK FITTED W/O VC FIRST.')
      ELSE
               WRITE(6,83)
 83            FORMAT(' *** XYRFTV WITH WEAK VERTEX CONSTRAINT ***')
               WRITE(6,84)
      ENDIF
      ENDIF
      ENDIF
      IPPAT0 = IDATA(IQPATR)
      IF(IPPAT0.LE.0 .OR. IDATA(IQJHTL).LE.0 ) RETURN
      NTR    = IDATA(IPPAT0+2)
      IF(NTR.LT.1) RETURN
      IF(
     - LAND(MODE,1) .NE. 0
     -)THEN
         NBNK1  = IDATA(IPPAT0-2) - 1
         NWRD   = IDATA(IPPAT0)
         NBYTE  = NWRD*4
         CALL CCRE(IPPATR,'PATR',NBNK1,NWRD,IERR)
      IF(
     - IERR.NE.0
     -)THEN
            PRINT 2900, IERR
 2900       FORMAT(' CREATION OF NEW PATR-BANK RESULTED IN ERROR',I3)
            RETURN
      ENDIF
         CALL MVCL(IDATA(IPPATR+1),0,IDATA(IPPAT0+1),0,NBYTE)
      ENDIF
      IF(
     - LAND(MODE,32) .NE. 0
     -)THEN
         NBNK1 = IDATA(IDATA(IQPATR)-2)
         IPJHTL = IDATA(IQJHTL)
         NWRD = IDATA(IPJHTL)
         CALL CLOC( NPJHTL, 'JHTL', NBNK1, IER )
      IF(
     - NPJHTL.LE.0
     -)THEN
           CALL CCRE(NPJHTL,'JHTL',NBNK1,NWRD,IERR)
      IF(
     - IERR.NE.0
     -)THEN
              PRINT 2910, IERR
 2910         FORMAT(' CREATION OF NEW JHTL-BANK RESULTED IN ERROR',I3)
              RETURN
      ENDIF
           CALL MVCL(IDATA(NPJHTL+1),0,IDATA(IPJHTL+1),0,NWRD*4)
      ENDIF
      ENDIF
      IPPATR = IDATA(IQPATR)
      IPTR   = IDATA(IPPATR+1) + IPPATR
      LDTR   = IDATA(IPPATR+3)
      ERRFAC = 1.0
      IF(LAND(MODE,4)  .NE. 0) ERRFAC =  100.0
      IF(LAND(MODE,16) .NE. 0) ERRFAC = 1000.0
      MODXYV=MODE
      DO 13000 ITR=1,NTR
         CALL XYRFT1(IPTR,IDATA(IQJHTL),ERRFAC,LDTR)
         IPTR=IPTR+LDTR
13000 CONTINUE
13001 CONTINUE
      RETURN
      END

C   23/06/78 704180022  MEMBER NAME  FNPECR6  (S)           FORTRAN
      SUBROUTINE NPECR6(JBE,Z,COST,PENUM,A)
C
C    UPDATED WITH RESULTS FROM FITTING WITH #CERSF6E (NR21)
C    FOR BARREL SF6.   INTERPOLATION IS USED FOR THE COEFFICIENTS A1-2
C      J.OLSSON   17.4.87
C
C---- CALCULATE NUMBER OF PHOTOELECTRONS BY CERENKOV LIGHT.
C
C INPUT:
C     Z=DEPTH OF THE SOURCE TRACK IN THE LEAD GLASS( RAD.LENGTH )
C
C     COST=COS(THETA) OF THE SOURCE TRACK W.R.TO THE NORMAL OF
C          THE CATHODE SURFACE.
C
C OUTPUT:
C     PENUM=NO.OF PHOTOELECTRONS/1RAD.LENGTH LONG TRACK.
C
C---- PHOTOMULTIPLIER AREA IS ASSUMED TO COVER THE WHOLE SURFACE.
C---- TO GET THE REAL PHOTOELECTRON NUMBER PENUM SHOULD BE MULTIPLIED
C---  BY THE RATIO (CATHODE AREA/LEAD GLASS CROSS SECTION).
C
      DIMENSION A(2),AFIT(21,2)
      DATA MESS/0/
C
C FIT RESULTS FROM #CERSF6E, WITH BASI=10.,AESS=1.,AEXPA = 0.34
C                                 A4-7 = 0.6,-0.7,0.6,-2.
C                                 CC=0. FOR COST < -.3
C
C   21 STEPS IN COST FROM +1. TO -1., STEP WIDTH 0.1
C
      DATA AFIT/
     $ 32.059, 22.325, 21.580, 20.559, 19.738, 18.651, 17.730, 22.524,
     $ 24.521, 25.250, 25.229, 25.052, 24.215, 22.473, 17.757, 18.732,
     $ 19.544, 20.352, 21.093, 21.775, 31.930,
     $  0.668,  0.292,  0.323,  0.362,  0.360,  0.367,  0.359,  0.269,
     $  0.232,  0.196,  0.175,  0.143,  0.068, -0.002, -0.160, -0.177,
     $ -0.180, -0.189, -0.200, -0.222, -0.331/
C
C ///////////////////////////////////////////////////////////
C
      PENUM = 0.
C---- CHECK POSITION
      IF(Z.LT.0. .OR. Z.GT.19.6 ) GO TO 90
      IF(ABS(COST).GT.1.0) GO TO 90
C
C---- DETERMINE A1-2
C
        COSS = -1.
        DO 2  I = 1,20
        COSL = COSS
        COSS = COSS + .1
        IF(COST.GT.COSS) GO TO 2
C
        FRAC = (COST - COSL) / .10
        J = 22 - I - 1
        K = 22 - I
C
        A(1) = AFIT(K,1) + FRAC*( AFIT(J,1) - AFIT(K,1) )
        A(2) = AFIT(K,2) + FRAC*( AFIT(J,2) - AFIT(K,2) )
C
C       WRITE(6,1010) COST,COSL,COSS,FRAC, I,J,K,A(1),A(2)
C010  FORMAT('COST COSL COSS FRAC',4F10.3,' I J K ',3I4,' A1-2 ',2E12.4)
C
        GO TO 3
C
    2   CONTINUE
C
C---- FUNCTN=A(1)+CC(COST)*EXP(0.34*Z)+A(2)*Z
C
3     CONTINUE
      CC = ((0.6*COST-0.7)*COST+0.6)*COST-2.0
      CC = 10.**CC
      IF(COST.LT.-.35) CC = 0.
      EXPARG = EXP(0.34*Z)
      PENUM = A(1)+CC*EXPARG+A(2)*Z
      RETURN
C
   90 IF(MESS.EQ.0) WRITE(6,600) Z,COST
  600 FORMAT(' ***** WRONG INPUT FOR NPECR6 ***** Z COST ',2E12.3)
      MESS = 1
      RETURN
      END

C   11/12/78 C9032101   MEMBER NAME  MESSAG   (JADEGS)      FORTRAN
      SUBROUTINE MESSAG(INDEX)
C
C     L.H.O'NEILL    XX-XX-XX   00:00
C     MODIFIED BY S.YAMADA  TO INCLUDE LEAD GLASS PART.  24-11-78
C
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
      COMMON /MESSGB/ MSGVAL(5)
      DIMENSION AMSGVL(5)
      EQUIVALENCE (MSGVAL(1),AMSGVL(1))
      DIMENSION KOUNT(20),LIMIT(20)
      DATA LIMIT/20*100/
      DATA KOUNT/20*0/
C
      IF((INDEX.LT.1).OR.(INDEX.GT.19)) GO TO 1001
      KOUNT(INDEX)=KOUNT(INDEX)+1
      IF(KOUNT(INDEX).GT.LIMIT(INDEX)) RETURN
C
      IF(INDEX.GT.10) GO TO 200
C
C---- SUPERVISER ERROR MSG.
      GO TO (1,2,3,4),INDEX
C
 1001 CONTINUE
      KOUNT(20)=KOUNT(20)+1
      IF(KOUNT(20).GT.LIMIT(20)) RETURN
      WRITE(JUSCRN,100)
  100 FORMAT(' MESSAG CALLED WITH ILLEGAL INDEX.')
      RETURN
C
    1 CONTINUE
      DATA NRDERR /0/
      NRDERR = NRDERR + 1
      IF(NRDERR.LE.20) WRITE(JUSCRN,101)
  101 FORMAT(' INPUT READ ERROR: CONTINUE')
      RETURN
C
    2 CONTINUE
      WRITE(JUSCRN,102)
  102 FORMAT(' ILLEGAL EVENT NUMBER REQUESTED.')
      RETURN
    3 CONTINUE
      WRITE(JUSCRN,103)
  103 FORMAT(' ILLEGAL USER INDEX. SKIP REST OF INPUT DS AND END.')
      RETURN
    4 CONTINUE
      WRITE(JUSCRN,104)
  104 FORMAT(' HEADER BANK MISSING IN INPUT EVENT. SKIP EVENT.')
      RETURN
C
C---- LEAD GLASS ERROR MSG.
  200 LGINDX = INDEX-10
      GO TO (201,202,203,204,205,206,207),LGINDX
  201 WRITE(JUSCRN,6201)
 6201 FORMAT('0***** BUFFER OVER FLOW IN LGADCN *****')
      RETURN
  202 WRITE(JUSCRN,6202) MSGVAL
 6202 FORMAT(' ***** LG-DATA ILLEGAL ADDRESS:',I5)
      RETURN
  203 WRITE(JUSCRN,6203)
 6203 FORMAT(' ******* TOO MANY LG-CLUSTERS *******')
  204 RETURN
  205 WRITE(JUSCRN,6205) MSGVAL(1),AMSGVL(2),AMSGVL(3)
 6205 FORMAT(' NON-CONVERGENCE FOR DEPAV IN (LGAVRZ). NTRY,DEPO,DEP=',
     1       I3,2F10.2,'  **********')
      RETURN
  206 WRITE(JUSCRN,6206) MSGVAL(1)
 6206 FORMAT(' ** ERROR IN /LGCL/ COPY.IER FROM JBCRA=',I5,' *****')
      RETURN
  207 WRITE(JUSCRN,6207) MSGVAL(1)
 6207 FORMAT(' ** ERROR IN /ALGN/ COPY.IER FROM JBCRA=',I5,' *****')
      RETURN
      END

C   22/04/87 805100912  MEMBER NAME  ZE4VPKM2 (S)           FORTRAN77
C
C   VERSION OF 04/02/85    E. ELSEN
C   MODIFIED   12/01/87    M. ZIMMER
C   MODIFIED   31/03/87    G. ECKERLIN
C   MODIFIED   16/04/87    G. ECKERLIN   EVENT SCIP AND SELECTION
C   LAST MOD   22/04/87    G. ECKERLIN   PACK MURESULTS IN TP-BANK
C                                        FOR LUND MC FILES
C              19/08/87    M. ZIMMER    GUENTHERS PRIVATE STUFF REMOVED
C   LAST MOD   22/04/88    E E           DUMP ELECTRON STATISTICS
C
C   COMPRESS EVENTBANKS INTO ZE4V FORMAT
C   WITH ZE4VPK FROM PART AND LGCL BANK
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(80000)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C
C
      INTEGER ILIST(21)/68,  71, 100, 248, 254, 332, 360, 366, 449, 456,
     *                 548, 555, 569, 576, 615, 740, 744, 871, 906, 908,
     *                 946 /, ICUR / 1 /
C
C
      DIMENSION HDSN(22), HVOL(3),HRUNEV(2)
      REAL*8 DDIN / 'FT02F001' /
      REAL*8 DDOU / 'FT03F001' /
      REAL*8 DDZE / 'FT51F001' /
      INTEGER IDDIN(2) ,IRE
      EQUIVALENCE(HRUNEV(1),IRE)
      EQUIVALENCE(IDDIN(1),DDIN)
C                                      INPUT/OUTPUT FTXX..
C          INPUT   (2)   EVT-OUT (3)   ZE4V-OUT (51)
      DATA IRUNIT / 2 /, IWUNIT / 0 /, IUNZE4 /  51 /
C                                   READ IN DD* CARDS
      READ(5,9001) IEVLIM,IFILMX,IWRMAX,IWZMAX,IDULIM,ISCIP
 9001 FORMAT(20X,I10)
      WRITE(6,9002) IEVLIM,IFILMX,IWRMAX,IWZMAX,IDULIM,ISCIP
 9002 FORMAT(/' MAX # OF EVENTS TO READ   :',I8/
     &         ' MAX # OF INPUTFILES       :',I8/
     &         ' MAX # OF EVENTS ON UNIT 3 :',I8/
     &         ' MAX # OF EVENTS ON UNIT51 :',I8/
     &         ' MAX # OF ZE4V-BANK PRINTS :',I8/
     &         ' INITIAL EVENT SCIP        :',I8/)
C                                          INIT BOS
      CALL BINT( 80000, 40000, 10000, 0 )
C                                           I/O UNIT SPECIFICATION
      CALL DDCHA( DDIN, HDSN, HERR, HVOL )
      WRITE(6,9111) HDSN, HVOL
 9111 FORMAT(/'      INPUT IS FROM DSN=',22A2,' VOL=',3A2)
      IF( IWUNIT.LE.0 ) GO TO 10
         CALL DDCHA( DDOU, HDSN, HERR, HVOL )
         WRITE(6,9112) HDSN, HVOL
 9112    FORMAT(/'      OUTPUT IS TO  DSN=',22A2,' VOL=',3A2)
   10 CONTINUE
C
      IF( IUNZE4.LE.0 ) GO TO 20
         CALL DDCHA( DDZE, HDSN, HERR, HVOL )
         WRITE(6,9122) HDSN, HVOL
 9122    FORMAT(/' ZE4V OUTPUT IS TO  DSN=',22A2,' VOL=',3A2/)
   20 CONTINUE
C
      IFIL = 1
      IEOF = 0
      IWRITE = 0
      IEV = 0
      IZE4V = 0
      IWZE4V = 0
C                                      INITIALISE FEHLER
      CALL FEHLIN
C
  100 IF( JUHR(2) .EQ. 2 ) GO TO 4000
      CALL BREAD( IRUNIT, &1000, &3000 )
      IEOF = 0
      IEV = IEV + 1
      IRV = IRNEVT( DUMMY )
      WRITE(6,9301) HRUNEV(2), IEV
 9301 FORMAT(' +++++++++ NEXT EVENT # ',I5,' IEV = ',I6,' ++++++++++')
C                                      LOOK FOR HEAD BANK
      NPHEAD = IW(IBLN('HEAD'))
      IF( NPHEAD.LE.0 ) GO TO 200
C                                      INITIAL EVENT SCIP
      IF (IEV.LE.ISCIP) GOTO 2000
C                                      FILL CALIBRATION CONSTANTS
      CALL KLREAD
C
      IF (IZE4V.EQ.0) THEN
        CALL ZE4VIN( 1 )
        IZE4V = 1
      ELSE
        CALL ZE4VPK( 1 )
      ENDIF
C
      NPZE4V = IW( IBLN ( 'ZE4V' ))
      NUMEVT = HW(NPZE4V*2 + 14)
      IF ( NUMEVT .EQ. ILIST(ICUR) ) THEN
        CALL ZE4VDP
      ELSEIF( NUMEVT .GT. ILIST(ICUR)) THEN
        ICUR = ICUR + 1
        IF ( NUMEVT .EQ. ILIST(ICUR) ) CALL ZE4VDP
      ENDIF
      IF (IDUMP.LT.IDULIM) THEN
        CALL ZE4VDP
        IDUMP = IDUMP + 1
      ENDIF
  200 CONTINUE
C
C                                          WRITE WHOLE EVENT
      IF( IWUNIT .GT. 0 .AND. IWRITE .LT. IWRMAX ) THEN
        IF ( NPHEAD .GT. 0 ) IWRITE = IWRITE + 1
        CALL BSLW
        CALL BWRITE( IWUNIT )
      ENDIF
C
C                                          SCIP ZE4V WRITE IF MC RECORD
      IF( NPHEAD.LE.0 ) GO TO 2000
C                                          WRITE ZE4V BANK
      IF( IUNZE4 .GT. 0 .AND. IWZE4V .LT. IWZMAX ) THEN
        IWZE4V = IWZE4V + 1
        CALL BMLT( 3, 'ZEHDZE4VPALL' )
        CALL BWRITE( IUNZE4 )
      ENDIF
      GO TO 2000
C
C
C                                           ERRORS
 1000 CONTINUE
      CALL JOBFIN( 3, IEV, &1100 )
 1100 IF( IEOF .NE. 0 ) GO TO 8000
C
C
 2000 CONTINUE
      CALL BSLT
      CALL BDLG
      IF( IEV .LT. IEVLIM ) GO TO 100
      CALL JOBFIN( 4, IEV, &8100 )
C
C                                           EOF ON IRUNIT
 3000 IF( IFIL .GE. IFILMX .OR. IEOF.NE.0 )  GO TO 8000
      IFIL = IFIL + 1
      IEOF = 1
      IDDIN(2) = IDDIN(2) + 1
      CALL DDCHA( DDIN, HDSN, HERR, HVOL )
      IF( HERR .NE. 0 ) GO TO 8000
      CALL BDLS( '+BUF', IRUNIT )
      WRITE(6,9104) IEV, IFIL
 9104 FORMAT(' +++++ AFTER',I6,' EVENTS FILE NUMBER CHANGED TO',I4,' +++
     *++')
      WRITE(6,9113) HDSN, HVOL
 9113 FORMAT(/' +++++ INPUT CONTINUES FROM DSN=',22A2,' VOL=',3A2)
      GO TO 100
C
C                                        TIME OUT
 4000 CALL JOBFIN( 2, IEV, &8100 )
C
C                                           END OF JOB
 8000 CONTINUE
      CALL JOBFIN( 1, IEV, &8100 )
 8100 CONTINUE
C                                      MCREDU STATISTICS
      CALL FEHLPR
      CALL EAFLDP
      CALL MCRDFL
      CALL BSTA
C
      STOP
      END

C   09/07/79 002172012  MEMBER NAME  PARMIN   (JADEGS)      FORTRAN
      SUBROUTINE PARMIN(A,B,C,D,RP,ITYP)
C---
C---    FIND MINIMUM DISTANCE RP OF PARABOLA (A B C D) FROM ORIGIN
C---    THE PARAMETERS ARE: A = ANGLE BETWEEN LOCAL X-AXIS AND DETECTOR
C---                        B = X COORDINATE OF LOCAL MINIMUM POINT.
C---                        C = Y COORDINATE OF LOCAL MINIMUM POINT.
C---                        D = PARABOLA PARAMETER IN  Y = D * X*X
C---     J.OLSSON         09.07.79       LAST CHANGE 19.08.79
C---
      IMPLICIT INTEGER*2 (H)
C---
      IF(ITYP.NE.2) GO TO 1009
C--PARABOLA FIT
      COSA = COS(A)
      SINA = SIN(A)
C--
C-- FIND POINT OF CLOSEST APPROACH TO ORIGIN, BY SOLVING 3D DEGREE EQUA-
C-- TION ARISING FROM THE CONDITION D/DX (DIST)  =  0
C--
      RP = 10000.
      Q = -B*COSA - C*SINA
      P =  B*SINA - C*COSA
      P = (1. - 2.*D*P)/(6.*D*D)
      Q = - Q/(4.*D*D)
      DET = Q*Q + P*P*P
      IF(DET.LE.0.) GO TO 10
      DET = SQRT(DET)
      SIGN = 1.
      IF(-Q+DET.LT.0.) SIGN = -1.
      U = (((-Q+DET)*SIGN)**.3333333)*SIGN
      SIGN = 1.
      IF(-Q-DET.LT.0.) SIGN = -1.
      V = (((-Q-DET)*SIGN)**.3333333)*SIGN
      XPB = U+V
      YPB = D*XPB*XPB
      XP = (XPB)*COSA - (YPB)*SINA + B
      YP = (XPB)*SINA + (YPB)*COSA + C
      RP = SQRT(XP*XP + YP*YP)
10    RETURN
1009  CONTINUE
C  CIRCLE FIT
      RP = ABS(B)
      RETURN
      END

C   23/03/97 703231941  MEMBER NAME  MVCCAL   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVCCAL         SAVED BY F22KLE  ON 87/02/09  AT 17:52
C   27/06/85 702091751  MEMBER NAME  MVCCAL   (S)           FORTRAN
C
C         THIS MACRO CONTAINS THE DECLARATION FOR THE
C         VTXC-CALIBRATION-COMMON / CVCCAL / :
C
C------------------------------------------------- 03.03.86 J.H. -------
C
      REAL*8 VCDATE
      COMMON / CVCCAL / NVFREE, VFREE(50), VCDATE,
     &      T0, VD, CSLOR, SNLOR, VROT, VDX, VZX, VDY, VZY,
     &      S0R(2,168), CVD(2,168),
     &      VIHCRR(7,2,25)
C
C     NVFREE  : NUMBER OF FREE REAL WORDS IN VFREE
C     VFREE   : REAL ARRAY FOR CONSTANTS
C     T0      : GLOBAL T0                              (. 0.1 NS .)
C     VD      : GLOBAL DRIFTVELOCITY                   (. MM/(0.1 NS) .)
C     CSLOR   : COS( LORENTZ-ANGLE )
C     SNLOR   : SIN( LORENTZ-ANGLE )
C     VROT    : ROTATION VTXC - ID                     (. RADIAN .)
C     VDX     : DISPLACEMENT VTXC - ID IN X            (. MM .)
C     VZX     : SLOPE OF " IN Z
C     VDY     : DISPLACEMENT VTXC - ID IN Y            (. MM .)
C     VZY     : SLOPE OF " IN Z
C     S0R     : DISPLACEMENT FOR EACH WIRE (#)         (. MM .)
C     CVD     : DRIFTVEL.-CORRECTURE FOR EACH WIRE (#)
C
C     VIHCRR  : LAYER-DEPENDENT CORRECTIONS FOR INHOMOGENITIES
C                                                      (. MM . )
C
C     VFREE(50) : D(VROT)/D(Z)                         (. RADIAN/MM .)
C
C     VFREE(48,49) JOBNAME OF JOB GENERATING THIS CALIBRATION
C
C     (#)     : FOR EACH DRIFTSPACESIDE
C

      SUBROUTINE VTXAFT 
C*800124*DITTMANN***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXAFT)   18.9.86
C*                                                                 *
C*          F I N I S H   X Y Z   V E R T E X   F I T              *
C*                                                                 *
C*       CALCULATE TRACK PARAMETERS AT VERTEX-NEAREST POINT        *
C*       FOR DETAILS OF THE T,V-ARRAYS SEE COMMENT IN SUBR. VERTEX.*
C*                                                                 *
C*******************************************************************
C
C PMF 03.11.98 
      LOGICAL TBIT
C%MACRO MVERTEX1
C     MACRO FOR VERTEX-FIT ROUTINES
      COMMON /CWORK1/ NT,T(2000),NV,V(200),A(300),B(24),NTIND(20),S(20),
     *                CHITR(20),
     *                JTGOD(50),JTBAD(50),VSAVE(10),V2(20,20)
C
      DIMENSION IT(2),IV(2)
      EQUIVALENCE (T(1),IT(1)),(V(1),IV(1))
C
      IF(NV.EQ.0) RETURN
C****
C****    EXTRAPOLATE ALL TRACKS TO VERTEX
      J = 0
      DO 9 I=1,NT
      IF(IT(J+1).EQ.0) GOTO 9
      IF(IT(J+14).EQ.0) GOTO 9
      LV = (IT(J+14)-1)*10
      CALL VTXPNT(J,V(LV+2),V(LV+3),XT,YT,ZT,DXT2,DYT2,DZT2,PHI,DPHI,SS)
      T(J+3) = PHI
      T(J+5) = XT
      T(J+6) = YT
      T(J+7) = ZT
C *** CORRECT ERROR OF PHI,THETA FOR MULT. SCATTERING
      SSCOUL = SS - T(J+18)
      SSCVXC = SS - T(J+19)
      DPHMS2 = 0.
      IF ((SSCOUL.LT.0.).AND.(T(J+18).LT.0.)) DPHMS2 = T(J+16)**2
      IF (SSCVXC.LT.0.) DPHMS2 = DPHMS2 + T(J+17)**2
      T(J+8) = SQRT( DPHI**2 + DPHMS2 )
C
      SSCOUL = SS + T(J+39) - T(J+18)
      SSCOUL = SS + T(J+39) - T(J+19)
      DTHMS2 = 0.
      IF(SSCOUL.LT.0.) DTHMS2 = T(J+16)**2
      IF (SSCVXC.LT.0.) DTHMS2 = DTHMS2 + T(J+17)**2
      T(J+9) = SQRT( T(J+9)**2 + DTHMS2 )
C ***
      T(J+10) = SQRT(DXT2)
      T(J+11) = SQRT(DYT2)
      T(J+12) = SQRT(DZT2)
      T(J+15) = SS
    9 J = J + 40
C
  100 RETURN
      END

C   07/06/96 606071835  MEMBER NAME  BSLS     (S4)          FORTG1
      SUBROUTINE BSLS(ISA)
C     BOS SUBPROGRAM =1.21=
#include "acs.for"
      COMMON/BCS/IW(1)
      CALL BDLS('+SPL',ISA)
      IF(NS.EQ.0) GOTO 100
      CALL BCRE(IND,'+SPL',ISA,2*NS,*90,IER)
      CALL BSTR(IND,IW(ISLST+1),NS)
      CALL BSTR(IND+NS,IW(IMLST+1),NS)
      GOTO 100
C
      ENTRY BSLR(ISA)
      NS=0
      CALL BLOC(IND,'+SPL',ISA,*100)
      NS=IW(IND)/2
      CALL BSTR(ISLST,IW(IND+1),NS)
      CALL BSTR(IMLST,IW(IND+1+NS),NS)
      CALL BDLS('+SPL',ISA)
      GOTO 100
C
   90 CALL BDMPA(90)
  100 RETURN
      END

C   03/03/80 007281528  MEMBER NAME  TOFCLC   (S)           FORTRAN
      SUBROUTINE TOFCLC(NCN,LTRK,NFLG)
      INTEGER *2 HADC,HTDC
#include "tfprm.for"
      COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IRELT(14,50)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42)
      DATA DTAU1/1./
C
      Z1= TRK(1,LTRK)
      TAUP1= RAW(3,NCN)+Z1/VELSC
      TAUM1= RAW(2,NCN)-Z1/VELSC
      NFLG= -1
          IF(HTDC(1,NCN).GT.10.AND.HTDC(1,NCN).LT.2048) GO TO 320
            GO TO 360
C
 320        IF(HTDC(2,NCN).GT.10.AND.HTDC(2,NCN).LT.2048) GO TO 330
            GO TO 360
C
  330 IF(ABS(TAUM1-TAUP1).LE.3.*DTAU1) GO TO 350
  350 NFLG= 1
  360 RETURN
      END

C   07/02/87 809291216  MEMBER NAME  TPTOFT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTOFT
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       7/02/87:  Add TOF information to TP
C
C     Last mod: C. Bowdery      29/09/88:  CALL TPSEFL now
C
C     Routine to add TOF information to the TP banks if wanted.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      LOGICAL  SUMMRY

      INTEGER  TOF

      PARAMETER ( TOF = 3 )

C------------------  C O D E  ------------------------------------------

C                            Get instruction relating to TOF summary

      CALL TPTFI2( SUMMRY )

      IF( SUMMRY ) THEN

C                            Put summary information into TPTR banks

        CALL TPTFTP
        CALL TPDIAG()

      ELSE

C                            Set flag to indicate TOF summary not done

        CALL TPSEFL( TOF, 4000 )

      ENDIF

      RETURN
      END

C   10/04/84            MEMBER NAME  FW83     (JADEGS)      FORTRAN
      SUBROUTINE FW83
      IMPLICIT INTEGER*2 (H)
C
C DRAW TAGGING APPARATUS IN SIDEVIEW, 1983-.. VERSION
C
C----------------------------------------------------------------------
C      MACRO CGEO3 .... JADE FORWARD DETECTOR GEOMETRY, 1981-3 VERSION
C----------------------------------------------------------------------
C
      COMMON / CGEO3 / ZPLUM2,ZMINM2,NRPBSC,PBSCR(4),PBSCZ(4)
C
C------------------------ END OF MACRO CGEO3 --------------------------
C
C
      DO 1 JZ=1,3,2
      Z0=PBSCZ(JZ)
      Z1=PBSCZ(JZ+1)
      DO 2  IZ = 1,2
      IIZ = -3 + 2*IZ
      X0 = IIZ*PBSCR(1)
      X1 = IIZ*PBSCR(4)
      CALL RECTAN(Z0,X0,Z1,X1,0)
      DO 3 JX=2,3
      X = PBSCR(JX)*IIZ
      CALL MOVEA(Z0,X)
      CALL DRAWA(Z1,X)
3     CONTINUE
2     CONTINUE
1     CONTINUE
      RETURN
      END

C   21/11/81 305161658  MEMBER NAME  ZSREAD   (S)           FORTRAN
      SUBROUTINE ZSREAD(NRUN,LUN)
C*800817*DITTMANN******************************************************
C*                                                                    *
C*           R E A D   C A L I B R A T I O N   C O N S T A N T S      *
C*                                                                    *
C*       TO BE CALLED FOR EACH EVENT IF THE ZS-PACKAGE IS USED IN A   *
C*       SUPERVISOR CONTROLLED PROGRAM.                               *
C*       THE ROUTINE IS ACTIVE ONLY FOR THE FIRST EVENT AND IF        *
C*       THE RUN NUMBER CHANGES BEYOND THE FOLLOWING LIMITS:          *
C*                                                                    *
C*       79A:      0-1400     79B:    1400-2600                       *
C*       80A:   2600-3730     80B:    3730-4900   80C: 4900-6000      *
C*       81A:   6000-7600     81B:   7600-10000                       *
C*       82A: 10000-11800     82B:  11800-13000   (=NRUNE)            *
C*                                                                    *
C*       CALIBRATION CONSTANTS ARE READ FROM UNIT LUN.                *
C*                                                                    *
C*            ---    LAST UPDATE :  30.4.83  L. BECKER                *
C*                                                                    *
C**********************************************************************
      IMPLICIT INTEGER*2 (H)
      COMMON /CZSCAL/ IPVERS,ZALPDI,RESFAC,SECH(5),DUMMY(2),
     *                TCORR(4,96),XTALK(2,96),PAR(7,1536)
      REAL RESFX(2) / 4480., 7000. /
      REAL SECHX(5,2) /12.3, .183, .011 , .365, .106,
     *                  7.5, .045, .0015, .200, .055/
      DATA NRUNL /1/, NRUNH/0/, NRUNE /13000/
C
C        READ CALIBRATION CONSTANTS
      IF(NRUN.GE.NRUNL .AND. NRUN.LE.NRUNH) RETURN
      IF (NRUN.GT.NRUNE.AND.NRUNH.EQ.NRUNE) RETURN
      IF(NRUN.GT.NRUNH) GOTO 32
      REWIND LUN
   32 READ(LUN,END=33) IPVERS,NRUNL,NRUNH,TCORR,XTALK,PAR
C--   PRINT 10, NRUN, NRUNL,NRUNH
   10 FORMAT ('  NRUN, NRUNL, NRUNH= ',3I10,'         (ZSREAD 10)')
      IF(NRUN.GT.NRUNH) GOTO 32
C
      ZALPDI = 1400.
   33 J = 1
      IF(NRUN.GT.6000) J=2
      RESFAC = RESFX(J)
      DO 34 I=1,5
   34 SECH(I) = SECHX(I,J)
C
      RETURN
      END

C   13/08/79 001181430  MEMBER NAME  LGCDIR   (SOURCE)      FORTRAN
      SUBROUTINE LGCDIR( NPPREC, NPR, NPCL)
C
C     S.YAMADA      06-11-78  15:20
C     LAST MODIFICATION  12-08-79  22:25
C     LAST MODIFICATION  18-01-80  14:30 BY Y.WATANABE
C              CALL TPCNST......... DO NOT CALL LGECOR IF MONTE CARLO.
C
C---- LEAD GLASS CLUSTER DIRECTION IS CALCULATED USING THE EVENT VERTEX.
C     ADATA(NPCLS+8--10) ARE FILLED. SEE BELOW.
C
C     THIS IS CALLED IN THE 2-ND STEP LG-ANALYSIS.
C    ******* BOS VERSION ********
C
C---- INPUT:
C         NPPREC=THE BOS POINTER TO THE PATTERN RECOGNITION RES.('PATR')
C                THE NEW FORMAT(VARIABLE LENGTH HEADER) IS ACCEPTED NOW.
C
C         NPR   =THE BOS POINTER TO THE RAW LG-ADC DATA ('ALGN')
C         NPCL  =THE BOS POINTER TO THE LG-RESULT BANK ('LGCL')
C
      IMPLICIT INTEGER *2 (H)
C
#include "cdata.for"
#include "clgwork2.for"
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     $                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     $                ZECAP(4),ZECAPX(4),THECPX(2)
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX, DZVRTX
      COMMON /CLGMSB/ MSGVAL(5)
      COMMON /CLGCHG/ NCHIND,NSTEP,CXDCHG(9,100)
      DIMENSION JBCCHG(9,100)
      EQUIVALENCE (CXDCHG(1,1),JBCCHG(1,1))
C
C---- SEE  JADE COMPUTER-NOTE #14.
C     IDATA(NPCLS+1)=JBC, 0 FOR BARREL, -1 FOR BOTTOM, 1 FOR TOP
C     ADATA(NPCLS+2)=CLUSTER ENERGY IN GEV
C     ADATA(NCLST+3)=SIGMA(ENERGY)
C     ADATA(NPCLS+4)=WEIGHTED AVERAGE PHI
C     ADATA(NPCLS+5)=WEIGHTED AVERAGE Z
C     ADATA(NPCLS+6)=SIGMA PHI (WEIGHTED)
C     ADATA(NPCLS+7)=SIGMA Z (WEIGHTED)
C     IDATA(NPCLS+8)=NUMBER OF CORRESPONDING INNER TRACKS
C     ADATA(NPCLS+9-11)=DIRECTION COSINES CORRECTED FOR SHOWER DEPTH.
C
      INTEGER INDEX(3)/  9, 8,10/
C
      COMMON /CLGVRN/ NVRSN(20)
      DATA NVCODE/379090318/
C
C---- CHECK POINTERS
      IF(NPCL.LE.0) GO TO 90
C---- FIX POINTERS FOR CLUSTER DATA
      NPCGI = NPCL+IDATA(NPCL+1)-1
      NPCLS = NPCL+IDATA(NPCL+3)-1
C---- GET NO.OF CLUSTERS
      NCLST = IDATA(NPCGI+3)
C............ PUT IN BKGAUSS ETC...1-11-79
          NPHD = IBLN('HEAD')
          NPHD = IDATA(NPHD)
         CALL TPCNST ( NPHD )
         HRUN=HDATA(NPHD+NPHD+10)
C          USE IT TO DECIDE DATA OR MONTE CARLO.
C
      NVRSN(9) = NVCODE
C
C     CHECK IF LGANAL IS CALLED FOR THIS JOB
      IF(IDATA(NPCGI+17).EQ.2) CALL LGREIN(NPCL,NPR)
C
C---- CLEAR THE MATCH TABLE
      CALL SETSL( NCHCL2, 0,1448, 0)
C
C---- SET THE FLAG TO SHOW THAT THE 2-ND STEP ANALYSIS IS DONE.
      IDATA(NPCGI+17) = 2
C
C
      IF( NPR.LE.0 ) GO TO 4
C
C---- INNER TRACK CONNECTION IS DONE IF 'PATR' IS THERE.
      IF(NPPREC.LE.0) GO TO 4
C
      NCHPRE = IDATA(NPPREC+2)
      NLPTRC = IDATA(NPPREC+3)
      NPTR = NPPREC+1+IDATA(NPPREC+1)
C
C---- SKIP CH.TRACING,IF LG-CLUSTER IS NOT THERE.(TO SAVE TIME)
      IF( NCLST.GT.0 ) GO TO 6
      NCHCLS = NCHPRE
      NPOINT = 0
      NCHCL2 = NCHPRE
      GO TO 7
C
    6 CALL ILCTRC(NCHPRE,NLPTRC,IDATA(NPTR),ADATA(NPTR))
      CALL LGCHC2
C
C---- CONNECT SIMULATED CHARGE CLUSTERS AND OBSERVED ONES.
      NPMAP = NPCL+IDATA(NPCL+2)
      NPALGN = NPR*2+7
C
C---- NOTICE THAT IN THE INTOLG LG-ADC MAP IS TREATED AS HDATA(2,2).
      CALL INTOLG(NPCL,IDATA(NPMAP),HDATA(NPALGN))
C
C---- SET THE FLAG OF INNER TRACK CONNECTION
    7 IDATA(NPCGI+19) = 1
C
    4 IF( NCLST ) 100,100,8
C
C---- GET NO.OF WORDS FOR EACH CLUSTER.
    8 LSTEP = IDATA(NPCGI+21)
C
C---- VERSION NO. FOR ENERGY CORRECTION SUBROUTINE IS SET.
      CALL LGECR0( NVECOR )
C---- SHOWER ENERGY CORRECTION IS MADE
      IDATA(NPCGI+18) = NVECOR
      IF(NVECOR)42,42,41
C---- CLEAR TOTAL ENERGY TO MAKE THE SUM OF CORRECTED ENERGIES
41    CALL SETSL(ADATA(NPCGI+7),0,36,0.)
42    NEND = NCLST
      IF(NEND.GT.MAXCLS) NEND = MAXCLS
C
C---- VERTEX OF THE EVENT IS COPIED INTO ZVRTX
      CALL CLOC( NPVX, 'TPVX',1 )
      ZVRTX = 0.
      DZVRTX = 0.
      IF(NPVX.LE.0) GO TO 5
C----   SET THE VERTEX FLAG
      IDATA(NPCGI+20) = HDATA(2*NPVX+2)
      ZVRTX = ADATA(NPVX+4)
C----   LIMIT THE VERTEX POSITION RANGE FOR SAFETY.
      IF( ZVRTX.LT.ZEND(1) ) ZVRTX = ZEND(1)
      IF( ZVRTX.GT.ZEND(2) ) ZVRTX = ZEND(2)
      DZVRTX = ADATA(NPVX+7)
    5 CONTINUE
C
C
        DO 1 N=1,NEND
C----   CHARGE( NO.OF CONNECTED CHARGED TRACK*100+ THE INDEX OF THE 1-ST
C               CANDIDATE)
        IDATA(NPCLS+8) = HCLLSO(1,N)*100+HCLLSO(2,N)
      JEG=0
C....USE 1/2 OF COUNTER THICKNESS IF IT IS A NONSHOWERING PARTICLE
      IF(HCLLSO(1,N)-1) 206,202,204
202   ELG=ADATA(NPCLS+2)
      IF(ELG.GT.0.6) GO TO 204
      NC=HCLLSO(2,N)
      PC=CXDCHG(9,NC)
      IF(ELG.GT.0.75*PC) GO TO 204
      JEG=2
      GO TO 206
204   JEG=1
C
206     IPART = IDATA(NPCLS+1)
        IF(IPART) 10,2,10
C
C----   BARREL
    2   ZAV = ADATA(NPCLS+5)
C
C
C----   AVERAGE DEPTH OF THE SHOWER IS CALCULATED BY ITERATION.
        CALL LGAVDP(ZAV,ADATA(NPCLS+2)*1000.,JEG,DEP)
C
C----   SET DIRECTION COSINES
    3   ZZ = ADATA(NPCLS+5)-ZVRTX
        TR = SQRT((RADIUS(3)+DEP)**2+ZZ**2)
        RXY = (RADIUS(3)+DEP)/TR
        ADATA(NPCLS+9) = RXY*COS(ADATA(NPCLS+4))
        ADATA(NPCLS+10) = RXY*SIN(ADATA(NPCLS+4))
        ADATA(NPCLS+11) = ZZ/TR
        GO TO 20
C
C----   END CAP (JEG=1 FOR SAFTY REASON)
   10   JEG=1
        ZAV=ZECAP(IPART+2)
C----     AVERAGE DEPTH OF THE SHOWER IS CALCULATEDBY ITERATION
        CALL LGAVDE(ZAV,NPCLS,JEG,DEP)
        ZZ = ZECAP(IPART+2)-ZVRTX+DEP*FLOAT(IPART)
        TR = SQRT(ADATA(NPCLS+4)**2+ADATA(NPCLS+5)**2+ZZ**2)
        ADATA(NPCLS+9) = ADATA(NPCLS+4)/TR
        ADATA(NPCLS+10) = ADATA(NPCLS+5)/TR
        ADATA(NPCLS+11) = ZZ/TR
C
C----   ENERGY CORRECTION
   20   CONTINUE
        IF(HRUN.GT.0) CALL LGECOR( ADATA(NPCLS+1), DEP, IFLAG )
        CALL LGEERR( IPART, ADATA(NPCLS+2), ADATA(NPCLS+3))
C
C
        IF(NVECOR) 22,22,21
C----        SUM UP CORRECTED SHOWER ENERGY
   21   IP = INDEX( IPART+2 )
        ADATA(NPCGI+IP) = ADATA(NPCGI+IP)+ADATA(NPCLS+2)
C
C----        SUM UP GAMMA ENERGY
   22   IF(IDATA(NPCLS+8).NE.0) GO TO 30
C----        COUNT NO.OF GAMMAS
        IDATA(NPCGI+11) = IDATA(NPCGI+11)+1
        IP = INDEX( IPART+2 )+5
        ADATA(NPCGI+IP) = ADATA(NPCGI+IP)+ADATA(NPCLS+2)
C
   30   CONTINUE
C----        CHANGE THE POINTER FOR THE NEXT CLUSTER.
        NPCLS = NPCLS+LSTEP
    1   CONTINUE
C
C---- SUM UP ALL ENERGIES.
      ADATA(NPCGI+7) = ADATA(NPCGI+8)+ADATA(NPCGI+9)+ADATA(NPCGI+10)
      ADATA(NPCGI+12) = ADATA(NPCGI+13)+ADATA(NPCGI+14)+ADATA(NPCGI+15)
      GO TO 100
C
C---- WRONG POINTER
   90 MSGVAL(1) = NPPREC
      MSGVAL(2) = NPR
      MSGVAL(3) = NPCL
      CALL LGMESG( 7, 1)
C
  100 RETURN
      END

C   25/07/79 C9073101   MEMBER NAME  LGEHIT   (SOURCE)      FORTRAN
      SUBROUTINE LGEHIT(XY,IE,*)
C     CODED BY Y.WATANABE ON 29/7/79, 01:00
C     LAST CHANGE ON 31/7/79, 01:00
C     IE=+/-1, FOR +/-Z END CAP
      DIMENSION XY(2,4),IX(4),YCOR(2),SY(2)
      DATA DY/0.357143/
C     DY IS THE DISPLACEMENT CORRECTION
C*****THE FOLLOWING IS A STATEMENT FUNCTION
C*****BE CAREFUL TO CHECK IF EVERYTHING IS DEFIND BEFOREHAND!!!
      YF(J,I)=SY(J)*(I1-XY(1,I))+XY(2,I)
C
      DO 20 I=1,4
      DO 10 J=1,2
10    XY(J,I)=XY(J,I)+6.
      IX(I)=XY(1,I)
20    CONTINUE
C     WRITE(6,600) IX
C600  FORMAT(' LGEHIT;IX',10I10)
C     WRITE(6,605) XY
C605  FORMAT(' LGEHIT;XY',10F10.4)
C     THIS IS TO AVOID WORKING WITH NEGATIVE INTEGER
C     REMENBER THAT I=-ABS(X)-1 TO GET IT RIGHT
      IMIN=IX(1)
      IF(IMIN.GT.11) RETURN
      IMAX=IX(4)
      IF(IMAX.LT.0) RETURN
      IF(IMIN.GT.IMAX) RETURN
      IF(IMIN.LT.0) IMIN=0
      IF(IMAX.GT.11) IMAX=11
      IF(IX(1).EQ.IX(2).AND.IX(3).EQ.IX(4)) GO TO 100
      IF(IX(1).EQ.IX(3).AND.IX(2).EQ.IX(4)) GO TO 100
      SLP=(XY(2,3)-XY(2,1))/(XY(1,3)-XY(1,1))
      I1=IMIN
      J1O=XY(2,1)
      J2O=J1O
      SY(1)=SLP
      SY(2)=-1./SLP
      Y1=YF(1,1)
      Y2=YF(2,1)
      YCOR(1)=DY*SY(1)
      YCOR(2)=DY*SY(2)
      IF1=1
      IF2=2
      I1=IMIN-1
C
C     NOW SCAN OVER X FINDING THE BOUNDARY IN Y WITHIN THE
C     RECTANGLE
30    I1=I1+1
      IF(I1-IMAX) 34,32,200
32    Y1S=XY(2,4)
      Y2S=Y1S
C     THE END VALUES
      GO TO 51
34    IF(I1.NE.IX(3)) GO TO 40
      Y1=YF(2,3)
      IF1=2
40    Y1=Y1+SY(IF1)
      IF(I1.NE.IX(2)) GO TO 50
      Y2=YF(1,2)
      IF2=1
50    Y2=Y2+SY(IF2)
      Y1S=Y1
      Y2S=Y2
      COR1=0.
      COR2=0.
      IF(I1.EQ.IX(3)) Y1S=XY(2,3)
      IF(I1.EQ.IX(2)) Y2S=XY(2,2)
C     BY DOING THIS WE PICK UP THE CORNER BUT PICK UP UNWANTED
C     PART,TOO. IT IS NOT EASY PREVENT IT SIMPLY.
C.....THE FOLLOWING IS AN IMPERFECT CORRECTIONS FOR THE DISPLACEMENT OF
C     OF CERTAIN COUNTERS FROM THE GRID.
51    IF(I1.GE.5) GO TO 52
      IF(ABS(Y1S-YCOR(IF1)).LT.1.) COR1=-YCOR(IF1)
      IF(ABS(Y2S-YCOR(IF2)).LT.1.) COR2=-YCOR(IF2)
      GO TO 60
52    IF(I1.GE.7) GO TO 54
      IF(Y1S.GT.0.) COR1=-DY
      IF(Y1S.LT.0.) COR1=DY
      IF(Y2S.GT.0.) COR2=-DY
      IF(Y2S.LT.0.) COR2=DY
      GO TO 60
54    IF(ABS(Y1S+YCOR(IF1)).LT.1.) COR1=YCOR(IF1)
      IF(ABS(Y2S+YCOR(IF2)).LT.1.) COR2=YCOR(IF2)
60    CONTINUE
C.....UNCORRECTED REGION IS THE END POINTS THAT LIE IN ABS(Y)<1.
      Y1S=Y1S+COR1
      Y2S=Y2S+COR2
      J1N=MIN1(Y1+COR1,Y2+COR2)
      J2N=MAX1(Y1+COR1,Y2+COR2)
      J1=MIN1(Y1S,Y2S)
      J2=MAX1(Y1S,Y2S)
      IF(J1.GT.J1O) J1=J1O
      IF(J2.LT.J2O) J2=J2O
C     WRITE(6,610) I1,IF1,IF2,J1,J2,J1N,J2N,J1O,J2O
C610  FORMAT(' I1,IF1..',12I10)
C     WRITE(6,620) Y1,Y2,Y1S,Y2S,SY
C620  FORMAT(' Y1,Y2..',10F10.4)
      J1O=J1N
      J2O=J2N
      IF(J1.GT.11) GO TO 30
      IF(J2.LT.0) GO TO 30
      IF(J1.GT.J2) GO TO 30
      IF(J1.LT.0) J1=0
      IF(J2.GT.11) J2=11
      CALL LGEFIL(I1,J1,J2,IE,&300)
      GO TO 30
C
100   J2=XY(2,3)
      J1=XY(2,2)
      IF(J2.GT.J1) GO TO 140
      I=J1
      J1=J2
      J2=I
140   IF(J1.LT.0) J1=0
      IF(J2.GT.11) J2=11
C     WRITE(6,630) IMIN,IMAX,J1,J2
C630  FORMAT(' SIMPLE',10I10)
      DO 150 I=IMIN,IMAX
150   CALL LGEFIL(I,J1,J2,IE,&300)
200   RETURN
C
300   RETURN1
      END

C   25/06/78 C9060101   MEMBER NAME  GGSRTH   (S)           FORTRAN
      SUBROUTINE GGSRTH( IB, ND )
C
C     H.WRIEDT    17-11-78
C     LAST MODIFICATION  21.03.79  18:05
C
C---- PULSE HEIGHT SORT OF LEAD GLASS DATA
C---- SORT ACCORDING TO THE ALGORITHM 201 OF CACM,SEE P.66 DESY R-INFO
C
C---- THIS IS A SUBPROGRAM TO SORT LG-DATA IN THE TWO FORWARD DETECTORS
C     SEPARATELY.
C---- IB=BASE INDEX,  ND=NO. OF DATA TO BE SORTED.
C
      IMPLICIT INTEGER*4 (G), INTEGER*2 (H)
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),HGGADC(2,192)
C***  COMMON /CGGADC/ LNG,HPOINT(4),HGGADC(2,192)
      DIMENSION GGADC(192)
      EQUIVALENCE (GGADC(1),HGGADC(1,1))
C
      COMMON/ CGGVRN/ NVRSN(20)
      DATA NVCODE/178111717/
      NVRSN(17) = NVCODE
C
      IF( ND.LE.1) RETURN
      M = ND
   10 M = M/2
      IF(M.EQ.0) RETURN
      K = ND-M
        DO 50 J=1,K
        I = J+IB
   20   IF(I.LE.IB) GO TO 50
        IF( HGGADC(2,I+M).LE.HGGADC(2,I) ) GO TO 50
C----   REPLACING
    3   IW = GGADC(I)
        GGADC(I) = GGADC(I+M)
        GGADC(I+M) = IW
        I = I-M
        GO TO 20
   50   CONTINUE
      GO TO 10
      END

C   05/12/84 412051723  MEMBER NAME  TAGRTY   (S)           FORTRAN
C
C
C
C
      FUNCTION TAGRTY(I)
C
C
C   TAGRTY FINDS THE 'R TYPE' OF ADC SOFWARE ADDRESS I
C
C   R-TYPE = 1   FOR INNER   BLOCKS
C          = 2       MIDDLE BLOCKS
C          = 3       OUTERBLOCKS
C
C   VALID FOR 1983 --> DETECTOR ONLY
C
C------------------  C O D E  ------------------------------------------
C
      IF ( ( I .GE.  1 ) .AND. ( I .LE.  8 ) ) TAGRTY = 1
      IF ( ( I .GE.  9 ) .AND. ( I .LE. 16 ) ) TAGRTY = 2
      IF ( ( I .GE. 17 ) .AND. ( I .LE. 24 ) ) TAGRTY = 3
      IF ( ( I .GE. 25 ) .AND. ( I .LE. 32 ) ) TAGRTY = 1
      IF ( ( I .GE. 33 ) .AND. ( I .LE. 40 ) ) TAGRTY = 2
      IF ( ( I .GE. 41 ) .AND. ( I .LE. 48 ) ) TAGRTY = 3
C
      RETURN
      END

C   11/01/88 801172315  MEMBER NAME  TABLES   (S)        M  MACROFOR

C                            Common for TP options tables
C                            NTABLE contains the option names like MUON
C                            OTBALE conatins the option keywords like TP
C                            ATABLE conatins the TRUE/FALSE settings
C                            There are NOG entries in NTABLE
C                            and NOK entries in OTABLE when set up.

      PARAMETER  ( NOPTG = 10, NOPTS = 30 )

      CHARACTER  NTABLE( NOPTG )*8,  OTABLE( NOPTS )*20

      LOGICAL    ATABLE( NOPTG, NOPTS )

      INTEGER  NOG, NOK

      COMMON / CTPOP1 / NTABLE, OTABLE
      COMMON / CTPOP2 / ATABLE
      COMMON / CTPOP3 / NOG, NOK

C   25/08/83 311102220  MEMBER NAME  WRTMCB0  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE WRTMCB(NUNIT)
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     09/05/79 :  OUTPUTS MONTE CARLO BINARY EVENTS
C
C        MOD  E. ELSEN     19/08/80 :  TAGGING BANK 'ATAG' ADDED
C        MOD  E. ELSEN     21/07/82 :
C        MOD  C. BOWDERY   18/08/83 :  NEW 'HITL' BANK ADDED
C        MOD  C. BOWDERY   22/08/83 :  EXPANDED COMMON /CWSET/.
C                                   :  HITAR(16000) I.E. 4000 HITS
C   LAST MOD  C. BOWDERY   10/11/83 :  BSAW CALLED FOR 'MUCH' AND 'MUHC'
C
C   THIS ROUTINE OUTPUTS MT CARLO DATA ONTO UNIT NUNIT USING BOS.
C
C   SPECIAL LIST IS CLEARED AFTER EVERY GARBAGE COLLECTION TO
C   ENSURE THAT JETC BANK IS ALWAYS LAST IN OUTPUT RECORD
C
C   NOTE THAT THE VECT BANK NOW EXISTS ON INPUT
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER * 2 (H)
C
      COMMON / CGEO1  / GEO(65)
      COMMON / CJDRCH / DRCH(34)
      COMMON / CTOF   / IATDC(94)
      COMMON / C4VHIT / H4VHTR(400), H4VHIT(4000)
      COMMON / CWSET  / NHALL, ISTART, HPCELL(98), HITAR(16000)
      COMMON / CMUB   / LMUBMX,LMUB,HMUB(2000)
      COMMON / CJPATR / KPATR, APATR(1448)
      COMMON / BCS    / IW(1)
C
      DIMENSION NAM1(3), HW(1)
C
      EQUIVALENCE ( IW(1) , HW(1) )
C
      DATA NAM1/'MTCO','MJET','MGEO'/
      DATA LGEO,LJET/65,34/
      DATA ICALL/0/
C-----------------------------------------------------------------------
C
      ICALL=ICALL+1
      IF(ICALL.NE.1) GO TO 10
C
C                OUTPUT CONSTANTS ONLY ONCE AT THE FIRST CALL TO THE S/R
C
C                CLEAR SPECIAL-LIST
C
      CALL BSLC
      CALL BCRE( IPMTCO, NAM1(1), 1, 100, &1000, IER )
C
C                                           JET CHAMBER CONST
C
      CALL BCRE( IND, NAM1(2), 2, LJET, &1000, IER )
      CALL BSTR( IND, DRCH, LJET )
      IW(IPMTCO - 4 + 55 ) = IND - IPMTCO + 4
C
C                                           GEOMETRICAL CONST
C
      CALL BCRE( IND, NAM1(3), 3, LGEO, &1000, IER )
      CALL BSTR( IND, GEO, LGEO )
      IW(IPMTCO - 4 + 56 ) = IND - IPMTCO + 4
C
C                                           WRITE OUT
C
      CALL BSAW( 3, NAM1 )
      CALL BSLW
      CALL BWRITE( NUNIT )
      CALL BSLT
      CALL BDLG
      CALL BSLC
C
C                                           MU CHAMBER CONST
C
      CALL MUCONW( 1, NUNIT, 0, HERR )
      CALL BSLC
C
C                   ORGANIZE OUTPUT FOR MT CARLO DATA
C
C                                           SET UP FIRST BANK
C
   10 CALL BCRE( IPHEAD, 'HEAD', 1, 100, &1000, IER )
      CALL BSAW( 1, 'HEAD' )
      CALL STHEAD( LENGTH, IW(IPHEAD+1) )
C
C                                           FILL LATC BANK
C
      CALL LHLATC( LENGTH )
      CALL BCRE( IND, 'LATC', 0, LENGTH, &1000, IER )
      CALL BSAW( 1, 'LATC' )
      CALL STLATC( LENGTH, IW(IND+1) )
C
C                                           SET TOF ADC/TDC BANK
C
      CALL BCRE( IND, 'ATOF', 0, 94, &1000, IER )
      CALL BSAW( 1, 'ATOF' )
      CALL BSTR( IND, IATDC, 94 )
C
C                                           SET BP ADC/TDC BANK
C
      CALL LHATBP( LENGTH )
      CALL BCRE( IND, 'ATBP', 0, LENGTH, &1000, IER )
      CALL BSAW( 1, 'ATBP' )
      CALL STATBP( LENGTH, IW(IND+1) )
C
C                                           SET 4_VECTOR BANK 'VECT'
C
      CALL BLOC( IND, 'VECT', 0, &1000, IER )
      CALL BSAW( 1, 'VECT' )
C
C                                           SET 4_VECTOR BANK 'PALL'
C
      CALL BLOC( IND, 'PALL', 0, &1011, IER )
      CALL BSAW( 1, 'PALL' )
C
C                                           4_VECTOR/JETC HIT LABEL BANK
C
1011  LENGTH = ( NHALL + 2 ) / 2
      CALL BCRE( IND, 'HITL', 8, LENGTH, &1000, IER )
      CALL BSAW( 1, 'HITL' )
      HW(IND*2 + 1) = NHALL
      CALL MVCL( HW, 4*IND + 2, H4VHIT, 0, NHALL * 2 )
C
C                                           LEAD GLASS AMPLITUDES
C
      CALL LHALGN( LENGTH )
      IF( LENGTH.EQ.0 ) GO TO 30
      CALL BCRE( IND, 'ALGN', 1, LENGTH, &1000, IER )
      CALL BSAW( 1, 'ALGN' )
      CALL STALGN( LENGTH, IW(IND+1) )
C
C                                           MU CHAMBER DATA
C
   30 CALL BLOC( IND, 'MUEV', 0, &35, IER )
      CALL BSAW( 1, 'MUEV' )
   35 CALL BLOC( IND, 'MUCH', 0, &36, IER )
      CALL BSAW( 1, 'MUCH' )
   36 CALL BLOC( IND, 'MUHC', 0, &37, IER )
      CALL BSAW( 1, 'MUHC' )
C
C                                           TAGGING DATA
C
   37 CALL LHATAG( LENGTH )
      IF( LENGTH .LE. 0 ) GO TO 40
      CALL BCRE( IND, 'ATAG', 0, LENGTH, &1000, IER )
      CALL BSAW( 1, 'ATAG' )
      CALL STATAG( LENGTH, IW(IND+1) )
C
C                                           TRACK BANK
C
   40 CONTINUE
      IF( KPATR .LT. 10 ) GO TO 50
      CALL BCRE( IND, 'PATR', 12, KPATR, &1000, IER )
      CALL BSAW( 1, 'PATR' )
      CALL BSTR( IND, APATR, KPATR )
C
C                                           Z-CHAMBER
C
   50 CONTINUE
      CALL BSAW( 1, 'ZETC' )
C
C                                           JET CHAMBER DATA AND BANK
C                                           DESCRIPTOR.
C                                           HPCELL(97) IS A SPECIAL WORD
C                                           POINTING TO THE FIRST FREE
C                                           LOCATION IN HITAR.
C
  60  LENGTH = (HPCELL(97) - 1) / 2 + 50
      IF( LENGTH .LE. 50 ) GO TO 90
      CALL BCRE( IND, 'JETC', 8, LENGTH, &1000, IER )
      CALL BSAW( 1, 'JETC' )
      IW(IND+1) = 0
C                                           COPY INFO: HPCELL & HITAR
C
      CALL MVCL( IW, (IND+1)*4, HPCELL, 0, (LENGTH-1)*4 )
C
   90 CALL BSLW
      CALL MCHIST
      CALL BWRITE( NUNIT )
C
      CALL BSLT
      CALL BDLG
      CALL BSLC
      RETURN
C
C                                           ERROR IN RECORD WRITING
C
 1000 WRITE(6,9101) IER
 9101 FORMAT(' BCRE OR BLOC ENDED WITH ERROR IER=',I4,' IN WRTMCB')
      RETURN
      END

      SUBROUTINE ZCHECK(DHRLIM)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cgraph.for"
      COMMON / CJCELL / NCELL(3),NWIRES(3)
#include "cjdrch.for"
#include "cdata.for"
      COMMON /CHEADR/ HEAD(108)
#include "cdsmax.for"
      COMMON /CEE1/ EE1(96,2)
#include "cpatlm.for"
#include "cworkpr.for"
      EQUIVALENCE
     ,      (ADWRK(11),LAYER ),(ADWRK(12),NI    ),(ADWRK(13),NH    )
     ,     ,(ADWRK(14),XHIT  ),(ADWRK(15),YHIT  ),(ADWRK(16),ZHIT  )
     ,     ,(ADWRK(17),RHIT  ),(ADWRK(18),IERZRF),(ADWRK(19),LRFLAG)
     ,     ,(ADWRK(20),INCELL),(ADWRK(21),IERFLG),(ADWRK(22),BETA  )
      COMMON/CJTRIG/ PI,TWOPI
      DIMENSION LCL(4,100),MASKY(4)
      DIMENSION HELP1(2),HELP2(2),HCELLI(6),HELPX(2)
      EQUIVALENCE (LABL1,HELP1(1)),(HELP2(1),LABL2),(LABLX,HELPX(1))
      EQUIVALENCE (LCL(1,1),IWRK(1))
      DATA HELP1/0,0/ ,HELP2/0,0/, LNRHIT/100/, MK1/Z7F/,MKZLAB /Z1/
      DATA MKZ0LB /ZFFFE/
      DATA HELPX/0,0/,ICALL /0/
      IPATR=IBLN('PATR')
      IPPATR = IDATA(IPATR)
      IF(IPPATR.LE.0) RETURN
      NTR = IDATA(IPPATR+2)
      IF(NTR.LE.0) RETURN
      IJETC=IBLN('JETC')
      IJHTL=IBLN('JHTL')
      DELPHI = TWOPI/24.
      LO = IDATA(IPPATR+1)
      LTRBK = IDATA(IPPATR+3)
      IPJCA = IDATA(IJETC)
      IPJ = 2*IPJCA + 2
      NHT = (HDATA(IPJ+97)-HDATA(IPJ+1))/4
      HPFREE = 401
      LP1 = HPFREE - 1
      LP2 = LP1 + LNRHIT
      LP3 = LP2 + LNRHIT
      LP4 = LP3 + LNRHIT
      LP5 = LP4 + LNRHIT
      LP6 = LP5 + LNRHIT
      LP7 = LP6 + LNRHIT
      LP8 = LP7 + LNRHIT
      LP9 = LP8 + LNRHIT
      LPA = LP9 + LNRHIT
      LPB = LPA + LNRHIT
      HPFREE = LPB + LNRHIT + 1
      IPJ = IPJ + 95
      IPJHTL = IDATA(IJHTL)
      IPJH = 2*IPJHTL + 2
      IF(
     - ICALL.EQ.0
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
         ICALL = 1
      ENDIF
      ASSIGN 17003 TO IZZZ02
      GOTO 17002
17003 CONTINUE
      DO 13000 ITR = 1,NTR
         IPPO1 = IPPATR + (ITR-1)*LTRBK + LO
         IPPO = IPPO1
         ITYPTR = IDATA(IPPO + 18)
      IF(
     - ITYPTR.EQ.1
     -)THEN
      ASSIGN 17005 TO IZZZ03
      GOTO 17004
17005 CONTINUE
      IF(
     - IPRFL.EQ.0
     -)THEN
               RMIN1 = RMIN
               RMAX1 = RMAX
               XMIT1 = XMIT
               YMIT1 = YMIT
      ENDIF
      ENDIF
      IF(
     - ITYPTR.EQ.2
     -)THEN
      ASSIGN 17007 TO IZZZ04
      GOTO 17006
17007 CONTINUE
      IF(
     - IPRFL.EQ.0
     -)THEN
               C1R = C1
               C2R = C2
               C3R = C3
               C4R = C4
               C5R = C5
               C6R = C6
      ENDIF
      ENDIF
         IPRFL1 = IPRFL
      IF(
     - IPRFL1.EQ.0
     -)THEN
            NHIT = 0
            NI = IPJ
            IHITH = -1
      DO 13002 I = 1,6
               HCELLI(I) = IDATA(IPPO + 33 + I)
13002 CONTINUE
13003 CONTINUE
      DO 13004  IHT = 1,NHT
               NI = NI + 4
               IHITH = IHITH + 2
               IHITG = IHITH + 1
               HELP1(2) = HDATA(IPJH + IHITH)
               HELP2(2) = HDATA(IPJH + IHITG)
               MTR = LAND(ISHFTR(LABL1,1),MK1)
               MTR2 = LAND(ISHFTR(LABL2,1),MK1)
               IAMB = 0
               IF(MTR.EQ.ITR) IAMB = 1
               IF(MTR2.EQ.ITR) IAMB = 2
      IF(
     - IAMB.NE.0
     -)THEN
                  IF(IAMB.EQ.1) NH = IPJH + IHITH
                  IF(IAMB.EQ.2) NH = IPJH + IHITG
                  IF(IAMB.EQ.1) LABLX = LABL1
                  IF(IAMB.EQ.2) LABLX = LABL2
                  LRFLAG = -1
                  IF(TBIT(LABLX,23)) LRFLAG = 1
                  BETA = 1.
                  CALL JETXYZ
                  ITST = 1
      DO 13006 I = 1,6
                     IF(INCELL.EQ.HCELLI(I)) ITST = 0
13006 CONTINUE
13007 CONTINUE
      IF(
     - ITST.EQ.0
     -)THEN
                     NHIT = NHIT + 1
                     WRK(LP1+NHIT) = RHIT
                     FIHIT = ATAN2(YHIT,XHIT)
                     IF(FIHIT.LT.0.) FIHIT = FIHIT + TWOPI
                     WRK(LP2+NHIT) = FIHIT
                     WRK(LP3+NHIT) = XHIT
                     WRK(LP4+NHIT) = YHIT
                     IWRK(LP5+NHIT) = NI
                     IWRK(LP6+NHIT) = LAYER + (INCELL - 1)*16
                     IWRK(LP7+NHIT) = INCELL
                     IWRK(LP8+NHIT) = NH
                     IWRK(LP9+NHIT) = LRFLAG
                     WRK(LPA+NHIT) = ZHIT
                     IWRK(LPB+NHIT) = LAND(LABLX,MKZLAB)
      ENDIF
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - NHIT.GT.3
     -)THEN
      DO 13008 IHT = 1,NHIT
      ASSIGN 17009 TO IZZZ05
      GOTO 17008
17009 CONTINUE
      IF(
     - ITYPTR.EQ.1
     -)THEN
                     RMIN = RMIN1
                     RMAX = RMAX1
                     XMIT = XMIT1
                     YMIT = YMIT1
      ASSIGN 17011 TO IZZZ06
      GOTO 17010
17011 CONTINUE
      ENDIF
      IF(
     - ITYPTR.EQ.2
     -)THEN
                     C1 = C1R
                     C2 = C2R
                     C3 = C3R
                     C4 = C4R
                     C5 = C5R
                     C6 = C6R
      ASSIGN 17013 TO IZZZ07
      GOTO 17012
17013 CONTINUE
      ENDIF
                  ICRFL1 = ICRFL
      IF(
     - ICRFL1.EQ.0
     -)THEN
                     DISTA=(XTS-XW)**2+(YTS-YW)**2
                     DISTA = SQRT(DISTA)
                     XTS1 = XTS
                     YTS1 = YTS
                     RTS = SQRT(XTS**2 + YTS**2)
                     INCL1 = IWRK(LP7+IHT)
      ASSIGN 17015 TO IZZZ08
      GOTO 17014
17015 CONTINUE
      DO 13010 KTR = 1,NTR
      IF(
     - KTR.NE.ITR
     -)THEN
                           ICHKFL = LAND(MASKY(1),LCL(1,KTR))
     $                            + LAND(MASKY(2),LCL(2,KTR))
     $                            + LAND(MASKY(3),LCL(3,KTR))
     $                            + LAND(MASKY(4),LCL(4,KTR))
      IF(
     - ICHKFL.GT.0
     -)THEN
                              IPPO = IPPATR + (KTR-1)*LTRBK + LO
      ASSIGN 17017 TO IZZZ09
      GOTO 17016
17017 CONTINUE
      IF(
     - IOKZ.EQ.0
     -)THEN
                                 ITYPTS = IDATA(IPPO+18)
      IF(
     - ITYPTS.EQ.1
     -)THEN
      ASSIGN 17018 TO IZZZ03
      GOTO 17004
17018 CONTINUE
      IF(
     - IPRFL.EQ.0
     -)THEN
      ASSIGN 17019 TO IZZZ06
      GOTO 17010
17019 CONTINUE
      ENDIF
      ENDIF
      IF(
     - ITYPTS.EQ.2
     -)THEN
      ASSIGN 17020 TO IZZZ04
      GOTO 17006
17020 CONTINUE
      IF(
     - IPRFL.EQ.0
     -)THEN
      ASSIGN 17021 TO IZZZ07
      GOTO 17012
17021 CONTINUE
      ENDIF
      ENDIF
      IF(
     - IPRFL.EQ.0.AND.ICRFL.EQ.0
     -)THEN
      ASSIGN 17023 TO IZZZ10
      GOTO 17022
17023 CONTINUE
      IF(
     - ICLSAM.EQ.1
     -)THEN
                                       DISTB=(XTS-XW)**2+(YTS-YW)**2
                                       DISTB = SQRT(DISTB)
                                       DIST = ABS(DISTA-DISTB)
      IF(
     - DIST.LT.DHRLIM
     -)THEN
                                          NH = IWRK(LP8+IHT)
                                          HELPX(2) = HDATA(NH)
                                          LABLX = LAND(LABLX,MKZ0LB)
                                          HDATA(NH) = HELPX(2)
      GOTO 13011
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      ENDIF
13010 CONTINUE
13011 CONTINUE
      ENDIF
13008 CONTINUE
13009 CONTINUE
      ENDIF
      ENDIF
13000 CONTINUE
13001 CONTINUE
      RETURN
17002 CONTINUE
      IPPO = IPPATR - LTRBK + LO
      DO 13012 ITR = 1,NTR
         LCL(1,ITR) = 0
         LCL(2,ITR) = 0
         LCL(3,ITR) = 0
         LCL(4,ITR) = 0
         IPPO = IPPO + LTRBK
         IPP = IPPO + 33
      DO 13014 I = 1,6
            INCE = IDATA(IPP+I)
      IF(
     - INCE.GT.0
     -)THEN
               IRNG = (INCE-1)/24 + 1
               INCE = INCE - (IRNG-1)*24
               MASK = 2**(INCE-1)
               LCL(IRNG,ITR) = LOR(LCL(IRNG,ITR),MASK)
      ELSE
      GOTO 13015
      ENDIF
13014 CONTINUE
13015 CONTINUE
13012 CONTINUE
13013 CONTINUE
      GOTO IZZZ02
17000 CONTINUE
      DO 13016 INCELL = 1,96
      IF(
     - INCELL.LT.49
     -)THEN
               II = INCELL
               IF(II.GT.24) II = II - 24
               FINC = FLOAT(II-1)*DELPHI + DELPHI*.5
      ELSE
               II = INCELL - 48
               FINC = FLOAT(II-1)*DELPHI*.5 + DELPHI*.25
      ENDIF
            IF(FINC.LT.0.) FINC = FINC + TWOPI
            EE1(INCELL,1) = TAN(FINC + .5*PI + DRIROT(INCELL,1))
            EE1(INCELL,2) = TAN(FINC + .5*PI + DRIROT(INCELL,2))
13016 CONTINUE
13017 CONTINUE
      GOTO IZZZ01
17008 CONTINUE
         NI = IWRK(LP5 + IHT)
         LRFLG = IWRK(LP9 + IHT)
         IF(LRFLG.LT.0) LRFLG = 0
         XHIT = WRK(LP3+IHT)
         YHIT = WRK(LP4+IHT)
         INCELL = IWRK(LP7+IHT)
         E1 = EE1(INCELL,LRFLG+1)
         NRING = INCELL - 1
         NRING = NRING/24 + 1
         IF(NRING.GT.3) NRING = 3
         NCL = NCELL(NRING)
         RADD = RINCR(NRING)
         RW = FSENSW(NRING) - RADD
         NIW = IWRK(LP6+IHT) + 1
         NEW = NIW - (NRING-1)*384
         SHIFI = PSIIN(NRING)
         NCE = ISHFTR(NEW-1,4)
         NWE = NEW - NCE*16
         RW = RW + NWE*RADD
         NUMCLO = 2
         IF(NWE.LT.9) NUMCLO = 1
         FACT = -1.
         IF(TBIT(NWE,31)) FACT = 1.
         FIW = SHIFI + NCE*TWOPI/FLOAT(NCL)
         IF(FIW.LT.0.) FIW = FIW + TWOPI
         IF(FIW.GT.TWOPI) FIW = FIW - TWOPI
         COSPH = COS(FIW)
         SINPH = SIN(FIW)
         XW = RW*COSPH  - FACT*SINPH*SWDEPL
         YW = RW*SINPH  + FACT*COSPH*SWDEPL
         E2 = YW - E1*XW
      GOTO IZZZ05
17010 CONTINUE
         ICRFL = 0
         CONST1 = RMAX*RMIN + E2*E2 - 2.*E2*YMIT
         CONST1 = CONST1/(1.+E1*E1)
         CONST2 = E1*E2 - E1*YMIT - XMIT
         CONST2 = CONST2/(1.+E1*E1)
         RADD = CONST2*CONST2 - CONST1
         IF(RADD.LE.0.) ICRFL = -1
      IF(
     - ICRFL.EQ.0
     -)THEN
            RADD = AMAX1(RADD,.000001)
            RADD = SQRT(RADD)
            X1 = -CONST2 + RADD
            X2 = -CONST2 - RADD
            XTS = X1
            IF(ABS(XHIT-X2).LT.ABS(XHIT-X1)) XTS = X2
            YTS = E2 + E1*XTS
      ENDIF
      GOTO IZZZ06
17004 CONTINUE
         IPRFL = 0
         RAD = ADATA(IPPO+19)
         RMIN = ADATA(IPPO+20)
         PHIMIT = ADATA(IPPO+21)
      IF(
     - ABS(RAD).GT.1.E-08
     -)THEN
            RAD = ABS(1./RAD)
            RMIT= RAD + RMIN
            RMAX = RMIT + RAD
            XMIT = RMIT*COS(PHIMIT)
            YMIT = RMIT*SIN(PHIMIT)
      ELSE
            IPRFL = -1
      ENDIF
      GOTO IZZZ03
17006 CONTINUE
         IPRFL = 0
         A = ADATA(IPPO+19)
         B = ADATA(IPPO+20)
         C = ADATA(IPPO+21)
         D = ADATA(IPPO+22)
         COSA = COS(A)
         SINA = SIN(A)
         C1 = D*SINA*SINA
         C2 = - 2.*D*(B*COSA*SINA + C*SINA*SINA) - COSA
         C3 = D*COSA*COSA
         C4 = - 2.*D*(B*COSA*COSA + C*COSA*SINA) + SINA
         C5 = 2.*D*COSA*SINA
         C6 = (B*COSA+C*SINA)
         C6 = D*C6*C6 + C*COSA - B*SINA
      GOTO IZZZ04
17012 CONTINUE
         ICRFL = 0
         C7 = C1*E1*E1 + C3 + C5*E1
         C8 = 2.*C1*E1*E2 + C2*E1 + C4 + C5*E2
         C9 = C1*E2*E2 + C2*E2 + C6
      IF(
     - ABS(C7).GT..000001
     -)THEN
            DD = C8*C8 - 4.*C7*C9
      IF(
     - DD.GT..000001
     -)THEN
               X1 = (-C8 + SQRT(DD))/(2.*C7)
               X2 = (-C8 - SQRT(DD))/(2.*C7)
               XTS = X1
               IF(ABS(XHIT-X2).LT.ABS(XHIT-X1)) XTS = X2
               YTS = E2 + E1*XTS
      ELSE
               ICRFL = -1
      ENDIF
      ELSE
            ICRFL = -1
      ENDIF
      GOTO IZZZ07
17014 CONTINUE
      MASKY(1) = 0
      MASKY(2) = 0
      MASKY(3) = 0
      MASKY(4) = 0
      IF(
     - INCL1.LE.24
     -)THEN
      IF(
     - INCL1.EQ.1
     -)THEN
            MASKY(1) = 8388611
            MASKY(2) = MASKY(1)
            MASKY(3) = 7
            MASKY(4) = 8388608
      ELSE
      IF(
     - INCL1.LT.24
     -)THEN
               MASKY(1) = LOR(MASKY(1),2**(INCL1-2))
               MASKY(1) = LOR(MASKY(1),2**(INCL1-1))
               MASKY(1) = LOR(MASKY(1),2**INCL1)
               MASKY(2) = MASKY(1)
      IF(
     - INCL1.LT.12
     -)THEN
                  MASKY(3) = LOR(MASKY(3),2**(2*INCL1-3))
                  MASKY(3) = LOR(MASKY(3),2**(2*INCL1-2))
                  MASKY(3) = LOR(MASKY(3),2**(2*INCL1-1))
                  MASKY(3) = LOR(MASKY(3),2**(2*INCL1))
      ENDIF
      IF(
     - INCL1.GT.13
     -)THEN
                  INCK1 = INCL1 - 12
                  MASKY(4) = LOR(MASKY(4),2**(2*INCK1-3))
                  MASKY(4) = LOR(MASKY(4),2**(2*INCK1-2))
                  MASKY(4) = LOR(MASKY(4),2**(2*INCK1-1))
                  MASKY(4) = LOR(MASKY(4),2**(2*INCK1))
      ENDIF
      IF(
     - INCL1.EQ.12
     -)THEN
                  MASKY(3) = 14680064
                  MASKY(4) = 1
      ENDIF
      IF(
     - INCL1.EQ.13
     -)THEN
                  MASKY(4) = 7
                  MASKY(3) = 8388608
      ENDIF
      ELSE
               MASKY(1) = 12582913
               MASKY(2) = MASKY(1)
               MASKY(3) = 1
               MASKY(4) = 14680064
      ENDIF
      ENDIF
      ELSE
      IF(
     - INCL1.LE.48
     -)THEN
      IF(
     - INCL1.EQ.25
     -)THEN
               MASKY(1) = 8388611
               MASKY(2) = MASKY(1)
               MASKY(3) = 7
               MASKY(4) = 8388608
      ELSE
      IF(
     - INCL1.LT.48
     -)THEN
                  INCK1 = INCL1 - 24
                  MASKY(1) = LOR(MASKY(1),2**(INCK1-2))
                  MASKY(1) = LOR(MASKY(1),2**(INCK1-1))
                  MASKY(1) = LOR(MASKY(1),2**INCK1)
                  MASKY(2) = MASKY(1)
      IF(
     - INCK1.LT.12
     -)THEN
                     MASKY(3) = LOR(MASKY(3),2**(2*INCK1-3))
                     MASKY(3) = LOR(MASKY(3),2**(2*INCK1-2))
                     MASKY(3) = LOR(MASKY(3),2**(2*INCK1-1))
                     MASKY(3) = LOR(MASKY(3),2**(2*INCK1))
      ENDIF
      IF(
     - INCK1.GT.13
     -)THEN
                     INCK2 = INCK1 - 12
                     MASKY(4) = LOR(MASKY(4),2**(2*INCK2-3))
                     MASKY(4) = LOR(MASKY(4),2**(2*INCK2-2))
                     MASKY(4) = LOR(MASKY(4),2**(2*INCK2-1))
                     MASKY(4) = LOR(MASKY(4),2**(2*INCK2))
      ENDIF
      IF(
     - INCK1.EQ.12
     -)THEN
                     MASKY(3) = 14680064
                     MASKY(4) = 1
      ENDIF
      IF(
     - INCK1.EQ.13
     -)THEN
                     MASKY(4) = 7
                     MASKY(3) = 8388608
      ENDIF
      ELSE
                  MASKY(1) = 12582913
                  MASKY(2) = MASKY(1)
                  MASKY(3) = 1
                  MASKY(4) = 14680064
      ENDIF
      ENDIF
      ELSE
      IF(
     - INCL1.EQ.49
     -)THEN
               MASKY(1) = 8388609
               MASKY(2) = MASKY(1)
               MASKY(3) = 3
               MASKY(4) = 8388608
      ELSE
      IF(
     - INCL1.LT.96
     -)THEN
                  INCK1 = INCL1 - 48
                  INCK2 = INCK1/2
                  MASKY(1) = LOR(MASKY(1),2**(INCK2-1))
                  MASKY(1) = LOR(MASKY(1),2**INCK2)
                  MASKY(2) = MASKY(1)
      IF(
     - INCK2.LT.12
     -)THEN
                     MASKY(3) = LOR(MASKY(3),2**(INCK1-2))
                     MASKY(3) = LOR(MASKY(3),2**(INCK1-1))
                     MASKY(3) = LOR(MASKY(3),2**INCK1)
      ENDIF
      IF(
     - INCK2.EQ.12
     -)THEN
                     IF(INCK1.EQ.24) MASKY(3) = 12582912
                     IF(INCK1.EQ.25) MASKY(3) = 8388608
                     IF(INCK1.EQ.24) MASKY(4) = 1
                     IF(INCK1.EQ.25) MASKY(4) = 3
      ENDIF
      IF(
     - INCK2.GT.12
     -)THEN
                     INCK1 = INCK1 - 24
                     MASKY(4) = LOR(MASKY(4),2**(INCK1-2))
                     MASKY(4) = LOR(MASKY(4),2**(INCK1-1))
                     MASKY(4) = LOR(MASKY(4),2**INCK1)
      ENDIF
      ELSE
                  MASKY(1) = 8388609
                  MASKY(2) = MASKY(1)
                  MASKY(3) = 1
                  MASKY(4) = 12582912
      ENDIF
      ENDIF
      ENDIF
      ENDIF
      GOTO IZZZ08
17022 CONTINUE
      ICLSAM = 0
      FII = ATAN2(YTS,XTS)
      IF(FII.LT.0.) FII = FII + TWOPI
      NFII = FII/DELPHI
      IF(INCL1.GT.48) NFII = 2.*FII/DELPHI
      NFII = NFII + 1
      IF(INCL1.GT.24) NFII = NFII + 24
      IF(INCL1.GT.48) NFII = NFII + 24
      IF(INCL1.EQ.NFII) ICLSAM = 1
      GOTO IZZZ10
17016 CONTINUE
         IOKZ = 0
         ZTEST = ADATA(IPPO+30)*RTS + ADATA(IPPO+31)
         IF(ABS(ZTEST).GT.ZMAX) IOKZ = 1
      GOTO IZZZ09
      END

C   01/11/84            MEMBER NAME  HITMRK   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE HITMRK( INDEX, X0, Y0, SCRUNI, IDC )
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON        ?     :  DRAW HITS
C
C  LAST MOD:   J. HAGEMANN   09/10/84 :  NEW FEATURES INCLUDED
C
C
C     THE COORDINATES OF HITS ARE DRAWN AS CROSSES.
C
C       ARGUMENTS :
C           INDEX  =  VIEW NUMBER (SEE MEMBER CAPMRK)
C           X0     =  X - COORDINATE OF HIT
C           Y0     =  Y - COORDINATE OF HIT
C           SCRUNI =  SIZE OF HIT CROSSES
C           IDC    =  IBM DASH CODE ( IF .LE. 0 HITS NOT DASHED )
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C PMF 05/11/98     LOGICAL   DSPDTL, SSTPS, PSTPS, FREEZE, FL18, FL22, FL24
C The first four variables are already declared in macro cgraph
      LOGICAL  FL18, FL22, FL24
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON / CWORK1 / R,FI,R1,FI1,X1,Y1,R2,FI2,X2,Y2,ZET,XX,YY,RAD
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
C
C-----------------  C O D E  -------------------------------------------
C
      IF( IPRJC.NE.0 )  RETURN
      call setcol('HITS')       ! PMF 23/11/99: set colour
C                            ZET DEPENDENT POINT
      IF( ZET.LT.0. .AND. DSPDTL(6) ) GO TO 10
C                            PLUS Z SIGN
      IF( INDEX.GT.3 .AND. INDEX.NE.10 ) GO TO 20
         RAD = SQRT(X0**2 + Y0**2 +1.)
         RAD = SCRUNI/RAD
         X00 = RAD*X0
         Y00 = RAD*Y0
         XX  = X0 - X00
         YY  = Y0 - Y00
         CALL MOVEA(XX,YY)
C
         XX  = X0 + X00
         YY  = Y0 + Y00
         IF( IDC .LE. 0 )  CALL DRAWA(XX,YY)
         IF( IDC .GT. 0 )  CALL DASHA(XX,YY,IDC)
C
         IF( .NOT. DSPDTL(6) ) then
            call setcol(' ')
            RETURN
         endif
         XX  = X0 - Y00
         YY  = Y0 + X00
         CALL MOVEA(XX,YY)
C
         XX  = X0 + Y00
         YY  = Y0 - X00
         IF( IDC .LE. 0 )  CALL DRAWA(XX,YY)
         IF( IDC .GT. 0 )  CALL DASHA(XX,YY,IDC)
         call setcol(' ')    ! PMF 23/11/99: reset colour
         RETURN
   10 CONTINUE
C                            MINUS Z SIGN
      IF( INDEX.GT.3 .AND. INDEX.NE.10 ) GO TO 20
         RAD = SQRT(X0**2 + Y0**2 + 1.)
         RAD = 1.41421356*RAD
         RAD = SCRUNI/RAD
         X00 = RAD*(X0+Y0)
         Y00 = RAD*(X0-Y0)
         XX  = X0 - X00
         YY  = Y0 - Y00
         CALL MOVEA(XX,YY)
C
         XX  = X0 + X00
         YY  = Y0 + Y00
         IF( IDC .LE. 0 )  CALL DRAWA(XX,YY)
         IF( IDC .GT. 0 )  CALL DASHA(XX,YY,IDC)
C
         XX  = X0 - Y00
         YY  = Y0 + X00
         CALL MOVEA(XX,YY)
C
         XX  = X0 + Y00
         YY  = Y0 - X00
         IF( IDC .LE. 0 )  CALL DRAWA(XX,YY)
         IF( IDC .GT. 0 )  CALL DASHA(XX,YY,IDC)
         call setcol(' ')    ! PMF 23/11/99: reset colour
         RETURN
   20 CONTINUE
      XX  = X0 - SCRUNI
      YY  = Y0
      CALL MOVEA(XX,YY)
C
      XX  = X0 + SCRUNI
         IF( IDC .LE. 0 )  CALL DRAWA(XX,YY)
         IF( IDC .GT. 0 )  CALL DASHA(XX,YY,IDC)
C
      IF( .NOT. DSPDTL(6) ) then
         call setcol(' ')    ! PMF 23/11/99: reset colour
         RETURN
      endif
      XX  = X0
      YY  = Y0 - SCRUNI
      CALL MOVEA(XX,YY)
C
      YY  = Y0 + SCRUNI
         IF( IDC .LE. 0 )  CALL DRAWA(XX,YY)
         IF( IDC .GT. 0 )  CALL DASHA(XX,YY,IDC)
      call setcol(' ')    ! PMF 23/11/99: reset colour
      RETURN
      END

C   11/01/88 803161906  MEMBER NAME  TPTRI1   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPTRI1( SUMMRY )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      11/01/88:  Get instr. about TR summary
C
C     Last mod: C. Bowdery      16/03/88:  JETC --> TRACK option
C
C     Routine to provide yes/no answer about need for track
C     summary i.e. creating TPTR banks for central detector tracks.
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     SUMMRY    Out      L*4      TRUE if TP step wanted
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      CHARACTER  TRACK*8, TP*20

      LOGICAL  SUMMRY, SUM, FIRST

      SAVE  SUM, FIRST

      DATA  FIRST / .TRUE. /
      DATA  TRACK / 'TRACK' /,  TP / 'TP' /

C------------------  C O D E  ------------------------------------------

C                            If not first call, SUM already SAVEd.

      IF( FIRST ) THEN

C                            Get user request relating to track summary

        CALL TPUOPT( TRACK, TP, SUM )

        FIRST = .FALSE.

      ENDIF

C                            Set SUMMRY equal to SUM

      SUMMRY = SUM

C                            Record this in the statistics area

      CALL TPSTAT

      RETURN
      END

C   28/03/97 703282257  MEMBER NAME  JEOSUM2  (JADE56.S)    FORTRAN
C   26/06/78 704172134  MEMBER NAME  @CERFITH (S)           FORTRAN
C***** CERENKOV LIGHT DETECTION EFFICIENCY FIT *****
C     S.YAMADA   15-12-77
C     RE-CODED ON 15-12-77 TO RECOVER LOST VERSION
C     UPDATED  2-10-85 TO SF6, J.OLSSON
C     FORMATS MODIFIED, 5.1.1986    J.OLSSON
C  2 COMPONENT VERSION 30.1.1986    J.OLSSON
C  A4-A7 IN CC READ IN, VARIABLE
C
C         GEP VERSION
C
C     READ CONVERTED PHOTOELECTRON NUMBERS FROM THE TABLE
C     FOR DIFFERENT DIRECTION AND POSITIONS OF THE ORIGINS.
C---- FIT THE NUMBERS FOR FIXED DIRECTION FIRST AND THEN THE FIT
C     PARAMETERS ARE FITTED AS A FUNCTION OF THE DIRECTION.
C
C   SEE DESCRIPTION IN JADE NOTE 20, BY S.YAMADA
C
C
      REAL*8 FLAMDA
      DIMENSION AVN(20),ERR(20), TRY(20),RESLT(50,13)
      DIMENSION X(20),YFIT(21), A(8),DELTAA(8),SIGMAA(8)
      DATA AVN/20*0./,ERR/20*0./,TRY/19*100.,60./,DELTAA/8*1.0/
      DATA X/0.5,1.5,2.5,3.5,4.5,5.5,6.5,7.5,8.5,9.5,10.5,11.5,12.5,
     1  13.5,14.5,15.5,16.5,17.5,18.5,19.3/
      DATA MODE/1/, ND/0/
      DIMENSION SD(20,50), SER(20,50), BC(8,4)
      LOGICAL*1 TEXT
      DIMENSION TEXT(72)
C
      COMMON /COSTB/ COST,MODEFT,AESS,BASI,CC,CC1,AEXPA,A4,A5,A6,A7
     $ ,PART1,PART2,PART3
C
      DATA IENDCP/0/
C
C---- IENDCP=1  FOR THE ENDCAP, IENDCP=0  FOR THE BARREL PART.
C
      MODEFT = 1
      NTERMS = 4
      IPRO = 0
      NPTS = 20
      IF(IENDCP.EQ.1) NPTS = 12
      IF(IENDCP.EQ.1) X(12) = 11.1
C
C PLOT INITIALIZATION
C
      CALL ACORE(10000)
      DO 3705  I = 1,21
      CALL HBOOK1( I,' NR OF PHOTONS VS. RAD. LENGTH$',20,0.,20.)
      CALL HBOOK1(30+ I,' NR OF PHOTONS FITTED, SINGLE$',20,0.,20.)
      CALL HBOOK1(60+ I,' NR OF PHOTONS FITTED, COMBINED$',20,0.,20.)
3705  CONTINUE
      DO 3706  I = 1,4
      CALL HBOOK1(100+ I,' FIT PARAMETER VS. COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(110+ I,' FIT PARAMETER, GLOBAL FIT$',21,-1.05,1.05)
3706  CONTINUE
      CALL HBOOK1(121,'CHISQ VS. COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(151,' CC1(COST)VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(152,' CC=10**CC1 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(153,' PART1 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(154,' PART2 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(155,' PART3 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(161,' CC1(COST)VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(162,' CC=10**CC1 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(163,' PART1 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(164,' PART2 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(165,' PART3 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
C
C
7608  FORMAT(72A1)
7508  FORMAT(' ',72A1)
      READ 7608, TEXT
      WRITE(6,7508) TEXT
C
C---- READ THE MONTE CARLO RESULTS.
C---- AESS,BASI,AEXPA,A4-7 ARE PARAMETERS USED IN FUNCTN
C
      READ(5,501) AESS,BASI,AEXPA,A4,A5,A6,A7
  501 FORMAT(3F10.2,4F10.4)
      WRITE(6,6610) AESS,BASI,AEXPA,A4,A5,A6,A7
6610  FORMAT('  FUNCTN PAR.: AESS BASI AEXPA ',3F10.2,' A4-7 ',4F10.4)
C
C  LOOP OVER VARIOUS COST STARTING HERE   ###########################
C
 1    CONTINUE
      READ(5,500,END=100) COST
      READ(5,502,END=100) (AVN(K),K=1,10)
      READ(5,502,END=100) (AVN(K),K=11,NPTS)
  500 FORMAT(F6.3)
  502 FORMAT(10F7.2)
C  COMPENSATE FOR INCOMPLETE STEP AT END
C     AVN(NPTS) = AVN(NPTS)*1.7
C
C---- CALCULATE THE STATISTICAL ERRORS
C---- FORMULA ASSUMES AVN IS MEAN OF TRY ATTEMPTS, ERR IS THEN
C---- ERROR ON MEAN:  SIGMA**2/TRY, WITH SIGMA = ROOT(AVN)
C
        DO 2 K=1,NPTS
    2   ERR(K) = SQRT(AVN(K)/TRY(K))*0.5
C----   THE FACTOR 0.5 IS DUE TO THE CONVERSION EFFICIENCY MAX.(0.25).
C
C  SINCE AVN IS NOT A MEAN, BUT THE SUM OF TRY ATTEMPTS, THE CORRECTER
C  ERROR IS SIMPLY SQRT(SD)
C
C       DO 2 K=1,NPTS
C   2   ERR(K) = SQRT(AVN(K))
C
C---- STORE THE SOURCE DATA FOR FUTURE USE.
      ND = ND+1
      IF(ND.GT.50) GO TO 33
        DO 3 K=1,NPTS
        SD(K,ND) = AVN(K)
    3   SER(K,ND) = ERR(K)
33     CONTINUE
C
C
C PLOT INPUT
C
C     CALL HISTOG(20,SD(1,ND),X,0.,1.,0,4,DUMMY)
C     SUBROUTINE HISTOG (NBIN,CINCON,THEORY,BINLOW,BINSIZ,KND,NL,HISTIT)
C    NBIN = NO. OF BINS
C    CINCON = EXPERIMENTAL DISTRIBUTION
C    THEORY=THEORETICAL DISTRIBUTION (SUPERIMPOSED IF REQUIRED)
C    BINLOW = LOW EDGE OF FIRST BIN
C    BINSIZ = SIZE OF BIN
C    KND=0 IF YOU DON'T WISH TO SUPPLY A THEORETICAL CURVE
C    KND=1 THEORY WILL BE NORMALIZED AND RETURN IS MADE WITH IT STILL
C    NORMALIZED
C    KND=2 THEORY WILL BE NORMALIZED BUT RETURN IS MADE WITH IT RESTORED
C
C---- FIT AVN BY A1+A2*X+EXP(A3*X)*(A4*COST**3 - A5*COST**2 + A6*COST)
C
C---- SEARCH THE MIN OF THE AVN
      AVMIN = 100000.
        DO 4 K=1,NPTS
    4   IF(AVN(K).LT.AVMIN) AVMIN = AVN(K)
C
C---- PRESET PARAMETERS
      A(1) = AVMIN-1.0
      A(2) = 1.5*COST+0.5
      A(3) = AEXPA
      A(4) = (1. + COST) * .01
C
C     DO 980  J = 1,3
C     DELTAA(J) = .2 * A(J)
C80   IF(DELTAA(J).GT.5.) DELTAA(J) = 5.
C
      FLAMDA = 0.001D0
      CHISQO = 0.
      NPASS = 0
   20 CONTINUE
      CALL CURFIT(X,AVN,ERR,NPTS,NTERMS,MODE,
     1          A,DELTAA,SIGMAA,FLAMDA,YFIT,CHISQ,IPRO)
C    1          A,DELTAA,SIGMAA,FLAMDA,YFIT,CHISQ)
C---- CHECK CONVERGENCE
      DCHISQ = CHISQ-CHISQO
      DCHISQ = ABS(DCHISQ)/CHISQ
      CHISQO = CHISQ
C
C******** TEST DUMP
      IF(IPRO.EQ.1)  WRITE(6,6666) CHISQO,DCHISQ,(A(K),K=1,NTERMS)
 6666 FORMAT(' CHI,D: ',1P2E11.3,' A: ',8E11.3)
C
      NPASS = NPASS+1
      IF(NPASS.GT.100) GO TO 90
      IF(DCHISQ.GT.0.0005) GO TO 20
   90 CONTINUE
C
C     CALL HISTOG(20,SD(1,ND),YFIT,0.,1.,2,4,DUMMY)
C
      DO 1232  JJ = 1,NPTS
      WGT = SD(JJ,ND)
      CALL HFILL(ND,X(JJ),0,WGT)
      WGT = YFIT(JJ)
      CALL HFILL(30+ND,X(JJ),0,WGT)
1232  CONTINUE
      WGT = CC1
      CALL HFILL(151,COST,0,WGT)
      WGT = CC
      CALL HFILL(152,COST,0,WGT)
      WGT = PART1
      CALL HFILL(153,COST,0,WGT)
      WGT = PART2
      CALL HFILL(154,COST,0,WGT)
      WGT = PART3
      CALL HFILL(155,COST,0,WGT)
C
C---- PRINT INPUT
C
      WRITE(6,600) COST,AVN,ERR
  600 FORMAT('0 COST(ORIGINE)=',F8.2,/
     1' AVN ',3X,2(5F7.2,2X),/,' ',2(5F7.2,2X),
     2      /' +/-',2(5F7.2,2X),/,' ',2(5F7.2,2X))
C
      WRITE(6,602) NPASS
  602 FORMAT(' TRIAL NO.(MAX=100)=',I4)
C
   22 WRITE(6,601) (YFIT(L),L=1,NPTS),CHISQO,CHISQ,DCHISQ,
     1      (A(K),SIGMAA(K),K=1,NTERMS)
  601 FORMAT(' YFIT:',2(5F7.1,2X),/,' ',2(5F7.1,2X),/' CHISQO,...=',
     1 3E12.4,/,' A:',1P4(E11.3,'(',E11.3,')',2X))
   23 IF(ND.GT.50) GO TO 1
      RESLT(ND,1) = COST
      RESLT(ND,2) = A(1)
      RESLT(ND,3) = SIGMAA(1)
      RESLT(ND,4) = A(2)
      RESLT(ND,5) = SIGMAA(2)
      RESLT(ND,6) = A(3)
      RESLT(ND,7) = SIGMAA(3)
      RESLT(ND,8) = A(4)
      RESLT(ND,9) = SIGMAA(4)
      GO TO 1
  100 WRITE(6,603)
  603 FORMAT(' *************** FIT RESULTS **********')
        DO 30 N=1,ND
        WRITE(6,604) (RESLT(N,K),K=1,9)
  604   FORMAT(' FITRES ',F6.2,4(F11.3,' +/-',F6.3))
   30   CONTINUE
C
C******************************************************
C
C    FIT A(1) - A(3) AS FUNCTIONS OF COST
C
      IPRO = 0
C  STEP IN COST
      DCST = ABS(RESLT(1,1)-RESLT(2,1))
C
      DO 300 MODEFT=2,5
      NTERMS = 8
C
C   THERE ARE ND DIFFERENT COST POINTS
C
      NPTS = ND
C
        DO 400 K=1,8
  400   A(K) = 0.
      IF(MODEFT.NE.2) GO TO 403
      A(1) = 22.6
      A(2) = -1.9
      A(3) = -285.0
      A(4) = 1459.
      A(5) = -2780.0
      A(6) = 2306.0
      A(7) = -690.0
      GO TO 404
  403 CONTINUE
      IF(MODEFT.NE.3) GO TO 433
      A(1) = 19.95
      A(2) = 1.58
      A(3) = -0.3
      A(4) = -2.0
      A(6) = 1.45
      A(7) = 0.5
      GO TO 404
  433 CONTINUE
      IF(MODEFT.NE.4) GO TO 434
      A(1) = AEXPA
      GO TO 404
  434 CONTINUE
      A(1) = 0.01
      A(2) = 0.01
  404 CONTINUE
      FLAMDA = 0.001D0
      CHISQO = 0.
      NPASS = 0
      IPOS = (MODEFT-1)*2
      IPOS1 = IPOS+1
  200 CONTINUE
      IF(NPASS.EQ.1) WRITE(6,1471) MODEFT
1471  FORMAT(' FIT2:  MODEFT = ',I3)
      CALL CURFIT(RESLT(1,1),RESLT(1,IPOS),RESLT(1,IPOS1),
     1      NPTS,NTERMS,MODE,A,DELTAA,SIGMAA,FLAMDA,
     2      RESLT(1,MODEFT+8),CHISQ,IPRO)
C    2      RESLT(1,MODEFT+8),CHISQ)
C---- CHECK CONVERGENCE
C     IF(NPASS.EQ.1)
C    1CALL HISTOG(20,RESLT(1,IPOS),RESLT(1,MODEFT+8),1.,-DCST,2,4,DUMMY)
      WRITE(6,1781) NPASS,CHISQ
1781  FORMAT(' FIT2: NPASS CHISQ ',I4,E14.6)
      DCHISQ = CHISQ-CHISQO
      DCHISQ = ABS(DCHISQ)/CHISQ
C
      WRITE(6,6666) CHISQ,DCHISQ,(A(K),K=1,NTERMS)
      CHISQO = CHISQ
      NPASS = NPASS+1
      IF(NPASS.GT.100) GO TO 250
      IF(DCHISQ.GT.0.0005) GO TO 200
C---- PRINT FIT PARAMETERS
C
C GRAPHICAL DISPLAY OF INPUT AND FIT
C
C     CALL HISTOG(20,RESLT(1,IPOS),RESLT(1,MODEFT+8),1.,-DCST,2,4,DUMMY)
C
      COSS = 1.+DCST
      DO 2132  JJ = 1,ND
      COSS = COSS - DCST
      WGT = RESLT(JJ,IPOS)
      CALL HFILL(99+MODEFT,COSS,0,WGT)
      WGT = RESLT(JJ,MODEFT+8)
      CALL HFILL(109+MODEFT,COSS,0,WGT)
2132  CONTINUE
C
  250 WRITE(6,602) NPASS
      WRITE(6,605) A,SIGMAA
  605 FORMAT('0  **** A ***',1P8E12.4,/'       +/-   ',8E12.4)
C
        DO 260 K=1,8
  260   BC(K,MODEFT-1) = A(K)
  300 CONTINUE
C
        DO 220 N=1,ND
        WRITE(6,606) (RESLT(N,K),K=1,13)
  606   FORMAT(' RESLT:',F8.2,12F9.3)
  220   CONTINUE
C
C ************ ALL FITS ARE FINISHED *********
C
C    PRINT THE FINAL RESULT
C
       WRITE(6,2271)
2271   FORMAT(1H1)
C
        DO 1000 N = 1,ND
        CHISQ = 0.
C-----   SET PARAMETERS
          DO 1050 IP=1,4
          MODEFT = IP+1
          A(IP) = FUNCTN(RESLT(1,1),N,BC(1,IP))
 1050     CONTINUE
        MODEFT = 1
        COST = RESLT(N,1)
        IXE = 20
        IF(IENDCP.EQ.1) IXE = 12
          DO 1100 IX=1,IXE
          YFIT(IX) = FUNCTN(X,IX,A)
          CHISQ = CHISQ+((SD(IX,N)-YFIT(IX))/SER(IX,N))**2
 1100     CONTINUE
C
          DO 2491  IX = 1,IXE
          WGT = YFIT(IX)
          CALL HFILL(60+N,X(IX),0,WGT)
2491  CONTINUE
          CALL HFILL(121,COST,0,CHISQ)
          CALL HFILL(161,COST,0,CC1)
          CALL HFILL(162,COST,0,CC)
          CALL HFILL(163,COST,0,PART1)
          CALL HFILL(164,COST,0,PART2)
          CALL HFILL(165,COST,0,PART3)
C
        WRITE(6,607) COST,CHISQ,A(1),A(2),A(3),A(4),
     1           (SD(K,N),K=1,IXE),(YFIT(L),L=1,IXE)
  607   FORMAT('0COST=',F6.3,3X,'CHISQ=',E10.3,' A1-A4=',
     1        4F10.4,/' SD ',10F7.2,/,' ',10F7.2,
     2        /' YFIT ',10F7.2,/,' ',10F7.2)
 1000   CONTINUE
      CALL HISTDO
      STOP
      END
C***** CERENKOV LIGHT DETECTION EFFICIENCY FIT *****
C     S.YAMADA   15-12-77
C     RE-CODED ON 15-12-77 TO RECOVER LOST VERSION
C     UPDATED  2-10-85 TO SF6, J.OLSSON
C     FORMATS MODIFIED, 5.1.1986    J.OLSSON
C  2 COMPONENT VERSION 30.1.1986    J.OLSSON
C  A4-A7 IN CC READ IN, VARIABLE
C
C         GEP VERSION
C
C     READ CONVERTED PHOTOELECTRON NUMBERS FROM THE TABLE
C     FOR DIFFERENT DIRECTION AND POSITIONS OF THE ORIGINS.
C---- FIT THE NUMBERS FOR FIXED DIRECTION FIRST AND THEN THE FIT
C     PARAMETERS ARE FITTED AS A FUNCTION OF THE DIRECTION.
C
C   SEE DESCRIPTION IN JADE NOTE 20, BY S.YAMADA
C
C
      REAL*8 FLAMDA
      DIMENSION AVN(20),ERR(20), TRY(20),RESLT(50,13)
      DIMENSION X(20),YFIT(21), A(8),DELTAA(8),SIGMAA(8)
      DATA AVN/20*0./,ERR/20*0./,TRY/19*100.,60./,DELTAA/8*1.0/
      DATA X/0.5,1.5,2.5,3.5,4.5,5.5,6.5,7.5,8.5,9.5,10.5,11.5,12.5,
     1  13.5,14.5,15.5,16.5,17.5,18.5,19.3/
      DATA MODE/1/, ND/0/
      DIMENSION SD(20,50), SER(20,50), BC(8,4)
      LOGICAL*1 TEXT
      DIMENSION TEXT(72)
C
      COMMON /COSTB/ COST,MODEFT,AESS,BASI,CC,CC1,AEXPA,A4,A5,A6,A7
     $ ,PART1,PART2,PART3
C
      DATA IENDCP/0/
C
C---- IENDCP=1  FOR THE ENDCAP, IENDCP=0  FOR THE BARREL PART.
C
      MODEFT = 1
      NTERMS = 4
      IPRO = 0
      NPTS = 20
      IF(IENDCP.EQ.1) NPTS = 12
      IF(IENDCP.EQ.1) X(12) = 11.1
C
C PLOT INITIALIZATION
C
      CALL ACORE(10000)
      DO 3705  I = 1,21
      CALL HBOOK1( I,' NR OF PHOTONS VS. RAD. LENGTH$',20,0.,20.)
      CALL HBOOK1(30+ I,' NR OF PHOTONS FITTED, SINGLE$',20,0.,20.)
      CALL HBOOK1(60+ I,' NR OF PHOTONS FITTED, COMBINED$',20,0.,20.)
3705  CONTINUE
      DO 3706  I = 1,4
      CALL HBOOK1(100+ I,' FIT PARAMETER VS. COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(110+ I,' FIT PARAMETER, GLOBAL FIT$',21,-1.05,1.05)
3706  CONTINUE
      CALL HBOOK1(121,'CHISQ VS. COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(151,' CC1(COST)VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(152,' CC=10**CC1 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(153,' PART1 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(154,' PART2 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(155,' PART3 VS COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(161,' CC1(COST)VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(162,' CC=10**CC1 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(163,' PART1 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(164,' PART2 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
      CALL HBOOK1(165,' PART3 VS COSTHETA,GLOBAL$',21,-1.05,1.05)
C
C
7608  FORMAT(72A1)
7508  FORMAT(' ',72A1)
      READ 7608, TEXT
      WRITE(6,7508) TEXT
C
C---- READ THE MONTE CARLO RESULTS.
C---- AESS,BASI,AEXPA,A4-7 ARE PARAMETERS USED IN FUNCTN
C
      READ(5,501) AESS,BASI,AEXPA,A4,A5,A6,A7
  501 FORMAT(3F10.2,4F10.4)
      WRITE(6,6610) AESS,BASI,AEXPA,A4,A5,A6,A7
6610  FORMAT('  FUNCTN PAR.: AESS BASI AEXPA ',3F10.2,' A4-7 ',4F10.4)
C
C  LOOP OVER VARIOUS COST STARTING HERE   ###########################
C
 1    CONTINUE
      READ(5,500,END=100) COST
      READ(5,502,END=100) (AVN(K),K=1,10)
      READ(5,502,END=100) (AVN(K),K=11,NPTS)
  500 FORMAT(F6.3)
  502 FORMAT(10F7.2)
C  COMPENSATE FOR INCOMPLETE STEP AT END
C     AVN(NPTS) = AVN(NPTS)*1.7
C
C---- CALCULATE THE STATISTICAL ERRORS
C---- FORMULA ASSUMES AVN IS MEAN OF TRY ATTEMPTS, ERR IS THEN
C---- ERROR ON MEAN:  SIGMA**2/TRY, WITH SIGMA = ROOT(AVN)
C
        DO 2 K=1,NPTS
    2   ERR(K) = SQRT(AVN(K)/TRY(K))*0.5
C----   THE FACTOR 0.5 IS DUE TO THE CONVERSION EFFICIENCY MAX.(0.25).
C
C  SINCE AVN IS NOT A MEAN, BUT THE SUM OF TRY ATTEMPTS, THE CORRECTER
C  ERROR IS SIMPLY SQRT(SD)
C
C       DO 2 K=1,NPTS
C   2   ERR(K) = SQRT(AVN(K))
C
C---- STORE THE SOURCE DATA FOR FUTURE USE.
      ND = ND+1
      IF(ND.GT.50) GO TO 33
        DO 3 K=1,NPTS
        SD(K,ND) = AVN(K)
    3   SER(K,ND) = ERR(K)
33     CONTINUE
C
C
C PLOT INPUT
C
C     CALL HISTOG(20,SD(1,ND),X,0.,1.,0,4,DUMMY)
C     SUBROUTINE HISTOG (NBIN,CINCON,THEORY,BINLOW,BINSIZ,KND,NL,HISTIT)
C    NBIN = NO. OF BINS
C    CINCON = EXPERIMENTAL DISTRIBUTION
C    THEORY=THEORETICAL DISTRIBUTION (SUPERIMPOSED IF REQUIRED)
C    BINLOW = LOW EDGE OF FIRST BIN
C    BINSIZ = SIZE OF BIN
C    KND=0 IF YOU DON'T WISH TO SUPPLY A THEORETICAL CURVE
C    KND=1 THEORY WILL BE NORMALIZED AND RETURN IS MADE WITH IT STILL
C    NORMALIZED
C    KND=2 THEORY WILL BE NORMALIZED BUT RETURN IS MADE WITH IT RESTORED
C
C---- FIT AVN BY A1+A2*X+EXP(A3*X)*(A4*COST**3 - A5*COST**2 + A6*COST)
C
C---- SEARCH THE MIN OF THE AVN
      AVMIN = 100000.
        DO 4 K=1,NPTS
    4   IF(AVN(K).LT.AVMIN) AVMIN = AVN(K)
C
C---- PRESET PARAMETERS
      A(1) = AVMIN-1.0
      A(2) = 1.5*COST+0.5
      A(3) = AEXPA
      A(4) = (1. + COST) * .01
C
C     DO 980  J = 1,3
C     DELTAA(J) = .2 * A(J)
C80   IF(DELTAA(J).GT.5.) DELTAA(J) = 5.
C
      FLAMDA = 0.001D0
      CHISQO = 0.
      NPASS = 0
   20 CONTINUE
      CALL CURFIT(X,AVN,ERR,NPTS,NTERMS,MODE,
     1          A,DELTAA,SIGMAA,FLAMDA,YFIT,CHISQ,IPRO)
C    1          A,DELTAA,SIGMAA,FLAMDA,YFIT,CHISQ)
C---- CHECK CONVERGENCE
      DCHISQ = CHISQ-CHISQO
      DCHISQ = ABS(DCHISQ)/CHISQ
      CHISQO = CHISQ
C
C******** TEST DUMP
      IF(IPRO.EQ.1)  WRITE(6,6666) CHISQO,DCHISQ,(A(K),K=1,NTERMS)
 6666 FORMAT(' CHI,D: ',1P2E11.3,' A: ',8E11.3)
C
      NPASS = NPASS+1
      IF(NPASS.GT.100) GO TO 90
      IF(DCHISQ.GT.0.0005) GO TO 20
   90 CONTINUE
C
C     CALL HISTOG(20,SD(1,ND),YFIT,0.,1.,2,4,DUMMY)
C
      DO 1232  JJ = 1,NPTS
      WGT = SD(JJ,ND)
      CALL HFILL(ND,X(JJ),0,WGT)
      WGT = YFIT(JJ)
      CALL HFILL(30+ND,X(JJ),0,WGT)
1232  CONTINUE
      WGT = CC1
      CALL HFILL(151,COST,0,WGT)
      WGT = CC
      CALL HFILL(152,COST,0,WGT)
      WGT = PART1
      CALL HFILL(153,COST,0,WGT)
      WGT = PART2
      CALL HFILL(154,COST,0,WGT)
      WGT = PART3
      CALL HFILL(155,COST,0,WGT)
C
C---- PRINT INPUT
C
      WRITE(6,600) COST,AVN,ERR
  600 FORMAT('0 COST(ORIGINE)=',F8.2,/
     1' AVN ',3X,2(5F7.2,2X),/,' ',2(5F7.2,2X),
     2      /' +/-',2(5F7.2,2X),/,' ',2(5F7.2,2X))
C
      WRITE(6,602) NPASS
  602 FORMAT(' TRIAL NO.(MAX=100)=',I4)
C
   22 WRITE(6,601) (YFIT(L),L=1,NPTS),CHISQO,CHISQ,DCHISQ,
     1      (A(K),SIGMAA(K),K=1,NTERMS)
  601 FORMAT(' YFIT:',2(5F7.1,2X),/,' ',2(5F7.1,2X),/' CHISQO,...=',
     1 3E12.4,/,' A:',1P4(E11.3,'(',E11.3,')',2X))
   23 IF(ND.GT.50) GO TO 1
      RESLT(ND,1) = COST
      RESLT(ND,2) = A(1)
      RESLT(ND,3) = SIGMAA(1)
      RESLT(ND,4) = A(2)
      RESLT(ND,5) = SIGMAA(2)
      RESLT(ND,6) = A(3)
      RESLT(ND,7) = SIGMAA(3)
      RESLT(ND,8) = A(4)
      RESLT(ND,9) = SIGMAA(4)
      GO TO 1
  100 WRITE(6,603)
  603 FORMAT(' *************** FIT RESULTS **********')
        DO 30 N=1,ND
        WRITE(6,604) (RESLT(N,K),K=1,9)
  604   FORMAT(' FITRES ',F6.2,4(F11.3,' +/-',F6.3))
   30   CONTINUE
C
C******************************************************
C
C    FIT A(1) - A(3) AS FUNCTIONS OF COST
C
      IPRO = 0
C  STEP IN COST
      DCST = ABS(RESLT(1,1)-RESLT(2,1))
C
      DO 300 MODEFT=2,5
      NTERMS = 8
C
C   THERE ARE ND DIFFERENT COST POINTS
C
      NPTS = ND
C
        DO 400 K=1,8
  400   A(K) = 0.
      IF(MODEFT.NE.2) GO TO 403
      A(1) = 22.6
      A(2) = -1.9
      A(3) = -285.0
      A(4) = 1459.
      A(5) = -2780.0
      A(6) = 2306.0
      A(7) = -690.0
      GO TO 404
  403 CONTINUE
      IF(MODEFT.NE.3) GO TO 433
      A(1) = 19.95
      A(2) = 1.58
      A(3) = -0.3
      A(4) = -2.0
      A(6) = 1.45
      A(7) = 0.5
      GO TO 404
  433 CONTINUE
      IF(MODEFT.NE.4) GO TO 434
      A(1) = AEXPA
      GO TO 404
  434 CONTINUE
      A(1) = 0.01
      A(2) = 0.01
  404 CONTINUE
      FLAMDA = 0.001D0
      CHISQO = 0.
      NPASS = 0
      IPOS = (MODEFT-1)*2
      IPOS1 = IPOS+1
  200 CONTINUE
      IF(NPASS.EQ.1) WRITE(6,1471) MODEFT
1471  FORMAT(' FIT2:  MODEFT = ',I3)
      CALL CURFIT(RESLT(1,1),RESLT(1,IPOS),RESLT(1,IPOS1),
     1      NPTS,NTERMS,MODE,A,DELTAA,SIGMAA,FLAMDA,
     2      RESLT(1,MODEFT+8),CHISQ,IPRO)
C    2      RESLT(1,MODEFT+8),CHISQ)
C---- CHECK CONVERGENCE
C     IF(NPASS.EQ.1)
C    1CALL HISTOG(20,RESLT(1,IPOS),RESLT(1,MODEFT+8),1.,-DCST,2,4,DUMMY)
      WRITE(6,1781) NPASS,CHISQ
1781  FORMAT(' FIT2: NPASS CHISQ ',I4,E14.6)
      DCHISQ = CHISQ-CHISQO
      DCHISQ = ABS(DCHISQ)/CHISQ
C
      WRITE(6,6666) CHISQ,DCHISQ,(A(K),K=1,NTERMS)
      CHISQO = CHISQ
      NPASS = NPASS+1
      IF(NPASS.GT.100) GO TO 250
      IF(DCHISQ.GT.0.0005) GO TO 200
C---- PRINT FIT PARAMETERS
C
C GRAPHICAL DISPLAY OF INPUT AND FIT
C
C     CALL HISTOG(20,RESLT(1,IPOS),RESLT(1,MODEFT+8),1.,-DCST,2,4,DUMMY)
C
      COSS = 1.+DCST
      DO 2132  JJ = 1,ND
      COSS = COSS - DCST
      WGT = RESLT(JJ,IPOS)
      CALL HFILL(99+MODEFT,COSS,0,WGT)
      WGT = RESLT(JJ,MODEFT+8)
      CALL HFILL(109+MODEFT,COSS,0,WGT)
2132  CONTINUE
C
  250 WRITE(6,602) NPASS
      WRITE(6,605) A,SIGMAA
  605 FORMAT('0  **** A ***',1P8E12.4,/'       +/-   ',8E12.4)
C
        DO 260 K=1,8
  260   BC(K,MODEFT-1) = A(K)
  300 CONTINUE
C
        DO 220 N=1,ND
        WRITE(6,606) (RESLT(N,K),K=1,13)
  606   FORMAT(' RESLT:',F8.2,12F9.3)
  220   CONTINUE
C
C ************ ALL FITS ARE FINISHED *********
C
C    PRINT THE FINAL RESULT
C
       WRITE(6,2271)
2271   FORMAT(1H1)
C
        DO 1000 N = 1,ND
        CHISQ = 0.
C-----   SET PARAMETERS
          DO 1050 IP=1,4
          MODEFT = IP+1
          A(IP) = FUNCTN(RESLT(1,1),N,BC(1,IP))
 1050     CONTINUE
        MODEFT = 1
        COST = RESLT(N,1)
        IXE = 20
        IF(IENDCP.EQ.1) IXE = 12
          DO 1100 IX=1,IXE
          YFIT(IX) = FUNCTN(X,IX,A)
          CHISQ = CHISQ+((SD(IX,N)-YFIT(IX))/SER(IX,N))**2
 1100     CONTINUE
C
          DO 2491  IX = 1,IXE
          WGT = YFIT(IX)
          CALL HFILL(60+N,X(IX),0,WGT)
2491  CONTINUE
          CALL HFILL(121,COST,0,CHISQ)
          CALL HFILL(161,COST,0,CC1)
          CALL HFILL(162,COST,0,CC)
          CALL HFILL(163,COST,0,PART1)
          CALL HFILL(164,COST,0,PART2)
          CALL HFILL(165,COST,0,PART3)
C
        WRITE(6,607) COST,CHISQ,A(1),A(2),A(3),A(4),
     1           (SD(K,N),K=1,IXE),(YFIT(L),L=1,IXE)
  607   FORMAT('0COST=',F6.3,3X,'CHISQ=',E10.3,' A1-A4=',
     1        4F10.4,/' SD ',10F7.2,/,' ',10F7.2,
     2        /' YFIT ',10F7.2,/,' ',10F7.2)
 1000   CONTINUE
      CALL HISTDO
      STOP
      END
C   26/06/78 601301806  MEMBER NAME  @CERSF55 (S)           FORTRAN
C***** CERENKOV LIGHT DETECTION EFFICIENCY FIT *****
C     S.YAMADA   15-12-77
C     RE-CODED ON 15-12-77 TO RECOVER LOST VERSION
C     UPDATED  2-10-85 TO SF6, J.OLSSON
C     FORMATS MODIFIED, 5.1.1986    J.OLSSON
C   VERSION TO FIT SF5 AS TEST   7.1.86  J.OLSSON
C   MODIFIED BACK TO @CERFIT1 VERSION ON F22YAM.WORKS     29.1.1986
C
C     READ CONVERTED PHOTOELECTRON NUMBERS FROM THE TABLE
C     FOR DIFFERENT DIRECTION AND POSITIONS OF THE ORIGINS.
C---- FIT THE NUMBERS FOR FIXED DIRECTION FIRST AND THEN THE FIT
C     PARAMETERS ARE FITTED AS A FUNCTION OF THE DIRECTION.
C
C   SEE DESCRIPTION IN JADE NOTE 20, BY S.YAMADA
C
C
      REAL*8 FLAMDA
      DIMENSION AVN(14),ERR(14), TRY(14),RESLT(50,8)
      DIMENSION X(14),YFIT(14), A(8),DELTAA(8),SIGMAA(8)
      DATA AVN/14*0./,ERR/14*0./,TRY/13*20.,8./,DELTAA/8*1.0/
      DATA X/0.5,1.5,2.5,3.5,4.5,5.5,6.5,7.5,8.5,9.5,10.5,11.5,12.5,
     1  13.2/
      DATA MODE/1/, ND/0/
      DIMENSION SD(14,50), SER(14,50), BC(8,2)
      LOGICAL*1 TEXT
      DIMENSION TEXT(72)
C
      COMMON /COSTB/ COST,MODEFT
C
      DATA IENDCP/0/
C
C---- IENDCP=1  FOR THE ENDCAP, IENDCP=0  FOR THE BARREL PART.
C
      MODEFT = 1
      NTERMS = 2
      IPRO = 0
      NPTS = 14
      IF(IENDCP.EQ.1) NPTS = 12
      IF(IENDCP.EQ.1) X(12) = 11.1
C
C PLOT INITIALIZATION
C
      CALL ACORE(10000)
      DO 3705  I = 1,21
      CALL HBOOK1( I,' NR OF PHOTONS VS. RAD. LENGTH$',20,0.,20.)
      CALL HBOOK1(30+ I,' NR OF PHOTONS FITTED, SINGLE$',20,0.,20.)
      CALL HBOOK1(60+ I,' NR OF PHOTONS FITTED, COMBINED$',20,0.,20.)
3705  CONTINUE
      DO 3706  I = 1,2
      CALL HBOOK1(100+ I,' FIT PARAMETER VS. COSTHETA$',21,-1.05,1.05)
      CALL HBOOK1(110+ I,' FIT PARAMETER, GLOBAL FIT$',21,-1.05,1.05)
3706  CONTINUE
      CALL HBOOK1(121,'CHISQ VS. COSTHETA$',21,-1.05,1.05)
C
C
7608  FORMAT(72A1)
7508  FORMAT(' ',72A1)
      READ 7608, TEXT
      WRITE(6,7508) TEXT
C
C---- READ THE MONTE CARLO RESULTS.
C---- IPR:  RAW DATA DUMP
C---- IPRR:  DUMP OF FIT RESULTS
C
      READ(5,501) IPR,IPRR
  501 FORMAT(2I10)
C
C  LOOP OVER VARIOUS COST STARTING HERE   ###########################
C
 1    CONTINUE
      READ(5,500,END=100) COST
      READ(5,502,END=100) (AVN(K),K=1,10)
      READ(5,502,END=100) (AVN(K),K=11,NPTS)
  500 FORMAT(F6.3)
  502 FORMAT(10F7.2)
C  COMPENSATE FOR INCOMPLETE STEP AT END
C    13.2 IS CENTER, ==> 40 %  ==>  FACTOR 2.5 TO COMPENSATE
C     AVN(NPTS) = AVN(NPTS)*2.5
C
C---- CALCULATE THE STATISTICAL ERRORS
C---- FORMULA ASSUMES AVN IS MEAN OF TRY ATTEMPTS, ERR IS THEN
C---- ERROR ON MEAN:  SIGMA**2/TRY
C
        DO 2 K=1,NPTS
    2   ERR(K) = SQRT(AVN(K)/TRY(K))*0.5
C----   THE FACTOR 0.5 IS DUE TO THE CONVERSION EFFICIENCY MAX.(0.25).
C
C  SINCE AVN IS NOT A MEAN, BUT THE SUM OF TRY ATTEMPTS, THE CORRECTER
C  ERROR IS SIMPLY SQRT(SD)
C
C       DO 2 K=1,NPTS
C   2   ERR(K) = SQRT(AVN(K))
C
C---- STORE THE SOURCE DATA FOR FUTURE USE.
      ND = ND+1
      IF(ND.GT.50) GO TO 33
        DO 3 K=1,NPTS
        SD(K,ND) = AVN(K)
    3   SER(K,ND) = ERR(K)
33     CONTINUE
C
C
C PLOT INPUT
C
C     CALL HISTOG(20,SD(1,ND),X,0.,1.,0,4,DUMMY)
C     SUBROUTINE HISTOG (NBIN,CINCON,THEORY,BINLOW,BINSIZ,KND,NL,HISTIT)
C    NBIN = NO. OF BINS
C    CINCON = EXPERIMENTAL DISTRIBUTION
C    THEORY=THEORETICAL DISTRIBUTION (SUPERIMPOSED IF REQUIRED)
C    BINLOW = LOW EDGE OF FIRST BIN
C    BINSIZ = SIZE OF BIN
C    KND=0 IF YOU DON'T WISH TO SUPPLY A THEORETICAL CURVE
C    KND=1 THEORY WILL BE NORMALIZED AND RETURN IS MADE WITH IT STILL
C    NORMALIZED
C    KND=2 THEORY WILL BE NORMALIZED BUT RETURN IS MADE WITH IT RESTORED
C
C---- FIT AVN BY A1+A2*X+EXP(A3*X)*(A4*COST**3 - A5*COST**2 + A6*COST)
C
C---- SEARCH THE MIN OF THE AVN
      AVMIN = 1000.
        DO 4 K=1,NPTS
    4   IF(AVN(K).LT.AVMIN) AVMIN = AVN(K)
C
C---- PRESET PARAMETERS
      A(1) = AVMIN-1.0
      A(2) = 1.5*COST+0.5
      A(3) = 0.001
      A(4) = 0.55
C
C     DO 980  J = 1,2
C     DELTAA(J) = .2 * A(J)
C80   IF(DELTAA(J).GT.5.) DELTAA(J) = 5
C
      FLAMDA = 0.001D0
C     FLAMDA = 0.001
      CHISQO = 0.
      NPASS = 0
   20 CONTINUE
      CALL CURFIT(X,AVN,ERR,NPTS,NTERMS,MODE,
     1          A,DELTAA,SIGMAA,FLAMDA,YFIT,CHISQ,IPRO)
C    1          A,DELTAA,SIGMAA,FLAMDA,YFIT,CHISQ)
C---- CHECK CONVERGENCE
      DCHISQ = CHISQ-CHISQO
      DCHISQ = ABS(DCHISQ)/CHISQ
      CHISQO = CHISQ
C
C******** TEST DUMP
      IF(IPRO.EQ.1)  WRITE(6,6666) CHISQO,DCHISQ,(A(K),K=1,NTERMS)
 6666 FORMAT(' CHI,D: ',1P2E11.3,' A: ',8E11.3)
C
      NPASS = NPASS+1
      WRITE(6,602) NPASS
      IF(NPASS.GT.100) GO TO 90
      IF(DCHISQ.GT.0.0005) GO TO 20
   90 CONTINUE
C
C     CALL HISTOG(14,SD(1,ND),YFIT,0.,1.,2,4,DUMMY)
C
      DO 1232  JJ = 1,NPTS
      WGT = SD(JJ,ND)
      CALL HFILL(ND,X(JJ),0,WGT)
      WGT = YFIT(JJ)
      CALL HFILL(30+ND,X(JJ),0,WGT)
1232  CONTINUE
C---- PRINT INPUT
C
      IF(IPR.NE.0) WRITE(6,600) COST,AVN,ERR
  600 FORMAT('0 COST(ORIGINE)=',F8.2,/
     1' AVN ',3X,2(5F7.2,2X),/,' ',4F7.2,
     2      /' +/-',2(5F7.2,2X),/,' ',4F7.2)
C
      WRITE(6,602) NPASS
  602 FORMAT(' TRIAL NO.(MAX=100)=',I4)
C
   22 WRITE(6,601) YFIT,CHISQO,CHISQ,DCHISQ,
     1      (A(K),SIGMAA(K),K=1,NTERMS)
  601 FORMAT(' YFIT:',2(5F7.1,2X),/,' ',4F7.1,/' CHISQO,...=',
     1 3E12.4,/,' A:',1P4(E11.3,'(',E11.3,')',2X))
   23 IF(ND.GT.50) GO TO 1
      RESLT(ND,1) = COST
      RESLT(ND,2) = A(1)
      RESLT(ND,3) = SIGMAA(1)
      RESLT(ND,4) = A(2)
      RESLT(ND,5) = SIGMAA(2)
      RESLT(ND,6) = A(3)
      RESLT(ND,7) = SIGMAA(3)
      RESLT(ND,8) = A(4)
      GO TO 1
  100 WRITE(6,603)
  603 FORMAT(' *************** FIT RESULTS **********')
        DO 30 N=1,ND
        WRITE(6,604) (RESLT(N,K),K=1,8)
  604   FORMAT(' FITRES ',F6.2,3(F11.3,' +/-',F6.3),F7.3)
   30   CONTINUE
C
C******************************************************
C
C    FIT A(1) - A(2) AS FUNCTIONS OF COST
C
      IPRO = 0
C  STEP IN COST
      DCST = ABS(RESLT(1,1)-RESLT(2,1))
C
      DO 300 MODEFT=2,3
      NTERMS = 8
C
C   THERE ARE ND DIFFERENT COST POINTS
C
      NPTS = ND
C
        DO 400 K=1,8
  400   A(K) = 0.
      IF(MODEFT.EQ.3) GO TO 403
C     A(1) = 22.6
C     A(2) = -1.9
C     A(3) = -285.0
C     A(4) = 1459.
C     A(5) = -2780.0
C     A(6) = 2306.0
C     A(7) = -690.0
      A(1) = 58.22
      A(2) = 29.2
      A(3) = -1150.6
      A(4) = 4664.1
      A(5) = -6253.8
      A(6) = 685.51
      A(7) = 4351.7
      A(8) = -2296.5
      GO TO 404
 403  CONTINUE
C     A(1) = 19.95
C     A(2) = 1.58
C     A(3) = -0.3
C     A(4) = -2.0
C     A(6) = 1.45
C     A(7) = 0.5
      A(1) = 0.4225
      A(2) = 1.0556
      A(3) = -1.6712
      A(4) = 9.0240
      A(5) = 2.8498
      A(6) = -23.35
      A(7) = -0.9666
      A(8) = 15.58
  404 CONTINUE
      FLAMDA = 0.001D0
C     FLAMDA = 0.001
      CHISQO = 0.
      NPASS = 0
      IPOS = (MODEFT-1)*2
      IPOS1 = IPOS+1
  200 CONTINUE
      CALL CURFIT(RESLT(1,1),RESLT(1,IPOS),RESLT(1,IPOS1),
     1      NPTS,NTERMS,MODE,A,DELTAA,SIGMAA,FLAMDA,
     2      RESLT(1,MODEFT+4),CHISQ,IPRO)
C    2      RESLT(1,MODEFT+4),CHISQ)
C---- CHECK CONVERGENCE
C     IF(NPASS.EQ.1) CALL
C    1 HISTOG(ND,RESLT(1,IPOS),RESLT(1,MODEFT+6),1.05,-DCST,2,4,DUMMY)
      IF(NPASS.EQ.1) WRITE(6,1471) MODEFT
1471  FORMAT(' FIT2:  MODEFT = ',I3)
      WRITE(6,1781) NPASS,CHISQ
1781  FORMAT(' FIT2: NPASS CHISQ ',I4,E14.6)
      DCHISQ = CHISQ-CHISQO
      DCHISQ = ABS(DCHISQ)/CHISQ
C
      WRITE(6,6666) CHISQ,DCHISQ,(A(K),K=1,NTERMS)
      CHISQO = CHISQ
      NPASS = NPASS+1
      IF(NPASS.GT.100) GO TO 250
      IF(DCHISQ.GT.0.0005) GO TO 200
C---- PRINT FIT PARAMETERS
C
C GRAPHICAL DISPLAY OF INPUT AND FIT
C
C     CALL
C    $ HISTOG(ND,RESLT(1,IPOS),RESLT(1,MODEFT+4),1.05,-DCST,2,4,DUMMY)
C
      COSS = 1.+DCST
      DO 2132  JJ = 1,ND
      COSS = COSS - DCST
      WGT = RESLT(JJ,IPOS)
      CALL HFILL(99+MODEFT,COSS,0,WGT)
      WGT = RESLT(JJ,MODEFT+4)
      CALL HFILL(109+MODEFT,COSS,0,WGT)
2132  CONTINUE
C
  250 WRITE(6,602) NPASS
      WRITE(6,605) A,SIGMAA
  605 FORMAT('0  **** A ***',1P8E12.4,/'       +/-   ',8E12.4)
C
        DO 260 K=1,8
  260   BC(K,MODEFT-1) = A(K)
  300 CONTINUE
C
        DO 220 N=1,ND
        WRITE(6,606) (RESLT(N,K),K=1,7)
  606   FORMAT(' RESLT:',F8.2,6F10.3)
  220   CONTINUE
C
C ************ ALL FITS ARE FINISHED *********
C
C    PRINT THE FINAL RESULT
C
C      WRITE(6,2271)
2271   FORMAT(1H1)
C
        DO 1000 N = 1,ND
        CHISQ = 0.
C-----   SET PARAMETERS
          DO 1050 IP=1,2
          MODEFT = IP+1
          A(IP) = FUNCTN(RESLT(1,1),N,BC(1,IP))
 1050     CONTINUE
C       A(3) = 0.55
        MODEFT = 1
        COST = RESLT(N,1)
        IXE = 14
        IF(IENDCP.EQ.1) IXE = 12
          DO 1100 IX=1,IXE
          YFIT(IX) = FUNCTN(X,IX,A)
          CHISQ = CHISQ+((SD(IX,N)-YFIT(IX))/SER(IX,N))**2
 1100     CONTINUE
C
C GRAPHICAL DISPLAY OF INPUT AND FIT
C
C     CALL HISTOG(14,SD(1,N),YFIT,0.,1.,2,4,DUMMY)
C
          DO 2491  IX = 1,IXE
          WGT = YFIT(IX)
          CALL HFILL(60+N,X(IX),0,WGT)
2491  CONTINUE
          CALL HFILL(121,COST,0,CHISQ)
C
        WRITE(6,607) COST,CHISQ,A(1),A(2),
     1           (SD(K,N),K=1,IXE),YFIT
  607   FORMAT('0COST=',F6.3,3X,'CHISQ=',E10.3,' A1-A2=',
     1        2F10.4,/' SD ',10F7.2,/,' ',4F7.2,
     2        /' YFIT ',10F7.2,/,' ',4F7.2)
 1000   CONTINUE
      CALL HISTDO
      STOP
      END
C   26/06/78 704180112  MEMBER NAME  @CERTST4 (S)           FORTRAN
C     MAIN TO TEST CERENKOV LIGHT TRACE SUBROUTINE
C---- S.YAMADA   16-11-77
C
C  GEP VERSION   4.4.87
C
C
C    @CERTST1 ON F22YAM.WORKS
C      HERE MODIFED TO REASONABLE PRINTOUT
C
C---- A MUON PENETRATES THE LEAD GLASS BLOCK.
C
      COMMON /CONSTB/ CONVMX,BK7LNG, TOTL
      COMMON /CCERSR/ SOURCE(14,25),CRNKSC(14,25),ISPCT(14,40),
     1             NEP,NACP
      DIMENSION KARRAY(1262), DIR(3)
       EQUIVALENCE (KARRAY(1),SOURCE(1,1))
C
C
      XLAMLW = .3
      XLAMHG = .7
      DXLAM = (XLAMHG-XLAMLW)/40.
C
      CALL ACORE(20000)
      CALL HBOOK1( 1,'NR VS LAMBDA,DIR 1 DEPTH 1 X0$',40,.3,.7)
      CALL HBOOK1( 2,'NR VS LAMBDA,DIR 1 DEPTH 2 X0$',40,.3,.7)
      CALL HBOOK1( 3,'NR VS LAMBDA,DIR 1 DEPTH 3 X0$',40,.3,.7)
      CALL HBOOK1( 4,'NR VS LAMBDA,DIR 1 DEPTH 4 X0$',40,.3,.7)
      CALL HBOOK1( 5,'NR VS LAMBDA,DIR 1 DEPTH 5 X0$',40,.3,.7)
      CALL HBOOK1( 6,'NR VS LAMBDA,DIR 1 DEPTH 6 X0$',40,.3,.7)
      CALL HBOOK1( 7,'NR VS LAMBDA,DIR 1 DEPTH 7 X0$',40,.3,.7)
      CALL HBOOK1( 8,'NR VS LAMBDA,DIR 1 DEPTH 8 X0$',40,.3,.7)
      CALL HBOOK1( 9,'NR VS LAMBDA,DIR 1 DEPTH 9 X0$',40,.3,.7)
      CALL HBOOK1(10,'NR VS LAMBDA,DIR 1 DEPTH 10 X0$',40,.3,.7)
      CALL HBOOK1(11,'NR VS LAMBDA,DIR 1 DEPTH 11 X0$',40,.3,.7)
      CALL HBOOK1(12,'NR VS LAMBDA,DIR 1 DEPTH 12 X0$',40,.3,.7)
      CALL HBOOK1(13,'NR VS LAMBDA,DIR 1 DEPTH 13 X0$',40,.3,.7)
      CALL HBOOK1(14,'NR VS LAMBDA,DIR 1 DEPTH 14 X0$',40,.3,.7)
C
      CALL HBOOK1(21,'NR VS LAMBDA,DIR 5 DEPTH 1 X0$',40,.3,.7)
      CALL HBOOK1(22,'NR VS LAMBDA,DIR 5 DEPTH 2 X0$',40,.3,.7)
      CALL HBOOK1(23,'NR VS LAMBDA,DIR 5 DEPTH 3 X0$',40,.3,.7)
      CALL HBOOK1(24,'NR VS LAMBDA,DIR 5 DEPTH 4 X0$',40,.3,.7)
      CALL HBOOK1(25,'NR VS LAMBDA,DIR 5 DEPTH 5 X0$',40,.3,.7)
      CALL HBOOK1(26,'NR VS LAMBDA,DIR 5 DEPTH 6 X0$',40,.3,.7)
      CALL HBOOK1(27,'NR VS LAMBDA,DIR 5 DEPTH 7 X0$',40,.3,.7)
      CALL HBOOK1(28,'NR VS LAMBDA,DIR 5 DEPTH 8 X0$',40,.3,.7)
      CALL HBOOK1(29,'NR VS LAMBDA,DIR 5 DEPTH 9 X0$',40,.3,.7)
      CALL HBOOK1(30,'NR VS LAMBDA,DIR 5 DEPTH 10 X0$',40,.3,.7)
      CALL HBOOK1(31,'NR VS LAMBDA,DIR 5 DEPTH 11 X0$',40,.3,.7)
      CALL HBOOK1(32,'NR VS LAMBDA,DIR 5 DEPTH 12 X0$',40,.3,.7)
      CALL HBOOK1(33,'NR VS LAMBDA,DIR 5 DEPTH 13 X0$',40,.3,.7)
      CALL HBOOK1(34,'NR VS LAMBDA,DIR 5 DEPTH 14 X0$',40,.3,.7)
C
      CALL HBOOK1(41,'NR VS LAMBDA,DIR 10 DEPTH 1 X0$',40,.3,.7)
      CALL HBOOK1(42,'NR VS LAMBDA,DIR 10 DEPTH 2 X0$',40,.3,.7)
      CALL HBOOK1(43,'NR VS LAMBDA,DIR 10 DEPTH 3 X0$',40,.3,.7)
      CALL HBOOK1(44,'NR VS LAMBDA,DIR 10 DEPTH 4 X0$',40,.3,.7)
      CALL HBOOK1(45,'NR VS LAMBDA,DIR 10 DEPTH 5 X0$',40,.3,.7)
      CALL HBOOK1(46,'NR VS LAMBDA,DIR 10 DEPTH 6 X0$',40,.3,.7)
      CALL HBOOK1(47,'NR VS LAMBDA,DIR 10 DEPTH 7 X0$',40,.3,.7)
      CALL HBOOK1(48,'NR VS LAMBDA,DIR 10 DEPTH 8 X0$',40,.3,.7)
      CALL HBOOK1(49,'NR VS LAMBDA,DIR 10 DEPTH 9 X0$',40,.3,.7)
      CALL HBOOK1(50,'NR VS LAMBDA,DIR 10 DEPTH 10 X0$',40,.3,.7)
      CALL HBOOK1(51,'NR VS LAMBDA,DIR 10 DEPTH 11 X0$',40,.3,.7)
      CALL HBOOK1(52,'NR VS LAMBDA,DIR 10 DEPTH 12 X0$',40,.3,.7)
      CALL HBOOK1(53,'NR VS LAMBDA,DIR 10 DEPTH 13 X0$',40,.3,.7)
      CALL HBOOK1(54,'NR VS LAMBDA,DIR 10 DEPTH 14 X0$',40,.3,.7)
C
C---- SET CONSTANTS.
      IENDCP = 0
C---- MAXIMUM CONVERSION EFFICIENCY, GOOD FOR THE NEW CONVEF
      CONVMX = 0.28
C---- TOTAL LENGTH OF THE GLASS
      TOTL = 30.0
      IF(IENDCP.EQ.1) TOTL = 25.0
      TOTLRD = TOTL/2.23
C---- BK7LNG=LIGHT GUIDE LENGH IN CM.
      BK7LNG = 6.0
      IF(IENDCP.EQ.1) BK7LNG = 50.0
      WRITE(6,611) IENDCP,TOTL,BK7LNG
  611 FORMAT('0 IENDCP,TOTL,BK7LNG=',I6,2F10.2,/)
C
C---- SET MUON  PARAMETERS
      EE = 1000.0
      T = 0.05
      JEND = TOTLRD/T
C---- CHANGE TRACK DIRECTION
      DIR(1) = 0.
      DO 1000 IDIR=1,21
      DIR(3) = 1.1-0.1*IDIR
      IF(DIR(3).GT.1.) DIR(3) = 1.
      IF(DIR(3).LT.-1.) DIR(3) = -1.
      DIR(2) = SQRT(1.-DIR(3)**2)
      WRITE(6,610) DIR
  610 FORMAT('1********* INPUT DIRECTION COSIGNS *****   ',3F8.4)
C
      SHIFT = 0.5*T*(1.-DIR(3))
C
C---- CLEAR ARRAY
        DO 400 K=1,1262
  400   KARRAY(K) = 0
C
      NTRY = 20
      TRY = NTRY
C
        DO 1 N=1,NTRY
          DO 2 J=1,JEND
          DEPTH = T*(J-1)+SHIFT
          CALL CERNKV(DEPTH,DIR,EE,T)
    2     CONTINUE
    1   CONTINUE
C
C---- HISTOGRAM OUTPUT
C     WRITE(6,600) ((SOURCE(I,J),I=1,14),J=1,25)
      RNACP = NACP
      RNACP = RNACP/TRY
      WRITE(6,603) NEP,NACP,RNACP
  603 FORMAT(' TOTAL EMITTED PHOTON  NO.=',I8,
     1     /' TOTAL ACCEPTED PHO TOELECTRON=',I8,
     2     /' PHOTO-ELE./TRIAL=',F10.2)
      WRITE(6,600) (CRNKSC(I,18),I=1,14)
  600 FORMAT('0',(10F7.0))
C---- GET PHOTO-ELECTRON NUMBERS/1 RAD.LENGTH SOURCE TRACK.
        DO 10 I=1,14
          DO 20 J=1,25
          S = SOURCE(I,J)
          IF(S.EQ.0.) S = 1.
          CRNKSC(I,J) = CRNKSC(I,J)*CONVMX/S
   20     CONTINUE
   10   CONTINUE
      WRITE(6,604)
  604 FORMAT(' PHOTO-ELECTRON NUM.PER ONE RAD.LENGTH SOURCE TRACK')
      WRITE(6,605) (CRNKSC(I,18),I=1,14)
  605 FORMAT('0',(10F7.2))
      WRITE(6,601)
  601 FORMAT(' PHOTON WAVE LENGTH DISTRIBUTION')
      WRITE(6,602) ((ISPCT(I,J),I=1,14),J=1,40)
  602 FORMAT(' ',(10I7,2X,4I7))
C
      IF(IDIR.NE.1.AND.IDIR.NE.5.AND.IDIR.NE.10) GO TO 950
      IBO = 0
      IF(IDIR.EQ.5) IBO = 20
      IF(IDIR.EQ.10) IBO = 40
      DO 940 J = 1,14
      IBO = IBO + 1
      XLAM = XLAMLW - .5*DXLAM
      DO 941  I = 1,40
      XLAM = XLAM + DXLAM
      WEIG = FLOAT(ISPCT(J,I))
      CALL HFILL(IBO,XLAM,0,WEIG)
941   CONTINUE
940   CONTINUE
C
950   CONTINUE
C
 1000 CONTINUE
      CALL HISTDO
      STOP
      END
C   26/06/78 704051735  MEMBER NAME  @CERTST6 (S)           FORTRAN
C     MAIN TO TEST CERENKOV LIGHT TRACE SUBROUTINE
C---- S.YAMADA   16-11-77
C
C   LATEST CHANGE   23.1.1986   J.OLSSON
C
C     GEP VERSION 4.4.87
C
C---- A MUON PENETRATES THE LEAD GLASS BLOCK.
C
      COMMON /CONSTB/ CONVMX,BK7LNG, TOTL
      COMMON /CCERSR/ SOURCE(20,25),CRNKSC(20,25),ISPCT(20,40),
     1             NEP,NACP
      DIMENSION KARRAY(1802), DIR(3)
       EQUIVALENCE (KARRAY(1),SOURCE(1,1))
C
      XLAMLW = .3
      XLAMHG = .7
      DXLAM = (XLAMHG-XLAMLW)/40.
C
      CALL ACORE(20000)
      CALL HBOOK1( 1,'NR VS LAMBDA,DIR 1 DEPTH 1 X0$',40,.3,.7)
      CALL HBOOK1( 2,'NR VS LAMBDA,DIR 1 DEPTH 2 X0$',40,.3,.7)
      CALL HBOOK1( 3,'NR VS LAMBDA,DIR 1 DEPTH 3 X0$',40,.3,.7)
      CALL HBOOK1( 4,'NR VS LAMBDA,DIR 1 DEPTH 4 X0$',40,.3,.7)
      CALL HBOOK1( 5,'NR VS LAMBDA,DIR 1 DEPTH 5 X0$',40,.3,.7)
      CALL HBOOK1( 6,'NR VS LAMBDA,DIR 1 DEPTH 6 X0$',40,.3,.7)
      CALL HBOOK1( 7,'NR VS LAMBDA,DIR 1 DEPTH 7 X0$',40,.3,.7)
      CALL HBOOK1( 8,'NR VS LAMBDA,DIR 1 DEPTH 8 X0$',40,.3,.7)
      CALL HBOOK1( 9,'NR VS LAMBDA,DIR 1 DEPTH 9 X0$',40,.3,.7)
      CALL HBOOK1(10,'NR VS LAMBDA,DIR 1 DEPTH 10 X0$',40,.3,.7)
      CALL HBOOK1(11,'NR VS LAMBDA,DIR 1 DEPTH 11 X0$',40,.3,.7)
      CALL HBOOK1(12,'NR VS LAMBDA,DIR 1 DEPTH 12 X0$',40,.3,.7)
      CALL HBOOK1(13,'NR VS LAMBDA,DIR 1 DEPTH 13 X0$',40,.3,.7)
      CALL HBOOK1(14,'NR VS LAMBDA,DIR 1 DEPTH 14 X0$',40,.3,.7)
      CALL HBOOK1(15,'NR VS LAMBDA,DIR 1 DEPTH 15 X0$',40,.3,.7)
      CALL HBOOK1(16,'NR VS LAMBDA,DIR 1 DEPTH 16 X0$',40,.3,.7)
      CALL HBOOK1(17,'NR VS LAMBDA,DIR 1 DEPTH 17 X0$',40,.3,.7)
      CALL HBOOK1(18,'NR VS LAMBDA,DIR 1 DEPTH 18 X0$',40,.3,.7)
      CALL HBOOK1(19,'NR VS LAMBDA,DIR 1 DEPTH 19 X0$',40,.3,.7)
      CALL HBOOK1(20,'NR VS LAMBDA,DIR 1 DEPTH 20 X0$',40,.3,.7)
C
      CALL HBOOK1(21,'NR VS LAMBDA,DIR 5 DEPTH 1 X0$',40,.3,.7)
      CALL HBOOK1(22,'NR VS LAMBDA,DIR 5 DEPTH 2 X0$',40,.3,.7)
      CALL HBOOK1(23,'NR VS LAMBDA,DIR 5 DEPTH 3 X0$',40,.3,.7)
      CALL HBOOK1(24,'NR VS LAMBDA,DIR 5 DEPTH 4 X0$',40,.3,.7)
      CALL HBOOK1(25,'NR VS LAMBDA,DIR 5 DEPTH 5 X0$',40,.3,.7)
      CALL HBOOK1(26,'NR VS LAMBDA,DIR 5 DEPTH 6 X0$',40,.3,.7)
      CALL HBOOK1(27,'NR VS LAMBDA,DIR 5 DEPTH 7 X0$',40,.3,.7)
      CALL HBOOK1(28,'NR VS LAMBDA,DIR 5 DEPTH 8 X0$',40,.3,.7)
      CALL HBOOK1(29,'NR VS LAMBDA,DIR 5 DEPTH 9 X0$',40,.3,.7)
      CALL HBOOK1(30,'NR VS LAMBDA,DIR 5 DEPTH 10 X0$',40,.3,.7)
      CALL HBOOK1(31,'NR VS LAMBDA,DIR 5 DEPTH 11 X0$',40,.3,.7)
      CALL HBOOK1(32,'NR VS LAMBDA,DIR 5 DEPTH 12 X0$',40,.3,.7)
      CALL HBOOK1(33,'NR VS LAMBDA,DIR 5 DEPTH 13 X0$',40,.3,.7)
      CALL HBOOK1(34,'NR VS LAMBDA,DIR 5 DEPTH 14 X0$',40,.3,.7)
      CALL HBOOK1(35,'NR VS LAMBDA,DIR 5 DEPTH 15 X0$',40,.3,.7)
      CALL HBOOK1(36,'NR VS LAMBDA,DIR 5 DEPTH 16 X0$',40,.3,.7)
      CALL HBOOK1(37,'NR VS LAMBDA,DIR 5 DEPTH 17 X0$',40,.3,.7)
      CALL HBOOK1(38,'NR VS LAMBDA,DIR 5 DEPTH 18 X0$',40,.3,.7)
      CALL HBOOK1(39,'NR VS LAMBDA,DIR 5 DEPTH 19 X0$',40,.3,.7)
      CALL HBOOK1(40,'NR VS LAMBDA,DIR 5 DEPTH 20 X0$',40,.3,.7)
C
      CALL HBOOK1(41,'NR VS LAMBDA,DIR 10 DEPTH 1 X0$',40,.3,.7)
      CALL HBOOK1(42,'NR VS LAMBDA,DIR 10 DEPTH 2 X0$',40,.3,.7)
      CALL HBOOK1(43,'NR VS LAMBDA,DIR 10 DEPTH 3 X0$',40,.3,.7)
      CALL HBOOK1(44,'NR VS LAMBDA,DIR 10 DEPTH 4 X0$',40,.3,.7)
      CALL HBOOK1(45,'NR VS LAMBDA,DIR 10 DEPTH 5 X0$',40,.3,.7)
      CALL HBOOK1(46,'NR VS LAMBDA,DIR 10 DEPTH 6 X0$',40,.3,.7)
      CALL HBOOK1(47,'NR VS LAMBDA,DIR 10 DEPTH 7 X0$',40,.3,.7)
      CALL HBOOK1(48,'NR VS LAMBDA,DIR 10 DEPTH 8 X0$',40,.3,.7)
      CALL HBOOK1(49,'NR VS LAMBDA,DIR 10 DEPTH 9 X0$',40,.3,.7)
      CALL HBOOK1(50,'NR VS LAMBDA,DIR 10 DEPTH 10 X0$',40,.3,.7)
      CALL HBOOK1(51,'NR VS LAMBDA,DIR 10 DEPTH 11 X0$',40,.3,.7)
      CALL HBOOK1(52,'NR VS LAMBDA,DIR 10 DEPTH 12 X0$',40,.3,.7)
      CALL HBOOK1(53,'NR VS LAMBDA,DIR 10 DEPTH 13 X0$',40,.3,.7)
      CALL HBOOK1(54,'NR VS LAMBDA,DIR 10 DEPTH 14 X0$',40,.3,.7)
      CALL HBOOK1(55,'NR VS LAMBDA,DIR 10 DEPTH 15 X0$',40,.3,.7)
      CALL HBOOK1(56,'NR VS LAMBDA,DIR 10 DEPTH 16 X0$',40,.3,.7)
      CALL HBOOK1(57,'NR VS LAMBDA,DIR 10 DEPTH 17 X0$',40,.3,.7)
      CALL HBOOK1(58,'NR VS LAMBDA,DIR 10 DEPTH 18 X0$',40,.3,.7)
      CALL HBOOK1(59,'NR VS LAMBDA,DIR 10 DEPTH 19 X0$',40,.3,.7)
      CALL HBOOK1(60,'NR VS LAMBDA,DIR 10 DEPTH 20 X0$',40,.3,.7)
C
C---- SET CONSTANTS.
      IENDCP = 0
C---- MAXIMUM CONVERSION EFFICIENCY, GOOD FOR THE NEW CONVEF
      CONVMX = 0.28
C---- TOTAL LENGTH OF THE GLASS
      TOTL = 30.0
      IF(IENDCP.EQ.1) TOTL = 25.0
C     TOTLRD = TOTL/2.23
      TOTLRD = TOTL/1.53
C---- BK7LNG=LIGHT GUIDE LENGH IN CM.
C     BK7LNG = 6.0
      BK7LNG = 0.0
      IF(IENDCP.EQ.1) BK7LNG = 50.0
      WRITE(6,611) IENDCP,TOTL,BK7LNG
  611 FORMAT('  IENDCP,TOTL,BK7LNG=',I6,2F10.2,/)
C
C---- SET MUON  PARAMETERS
      EE = 1000.0
      T = 0.05
      JEND = TOTLRD/T
C---- CHANGE TRACK DIRECTION
      DIR(1) = 0.
C     DO 1000 IDIR=1,5
      DO 1000 IDIR=1,21
C     DIR(3) = 1.2-0.2*IDIR
C     DIR(3) = 1.05-0.05*IDIR
      DIR(3) = 1.10-0.10*IDIR
      IF(DIR(3).GT.1.) DIR(3) = 1.
      IF(DIR(3).LT.-1.) DIR(3) = -1.
      DIR(2) = SQRT(1.-DIR(3)**2)
      WRITE(6,610) DIR
  610 FORMAT('1********* INPUT DIRECTION COSIGNS *****   ',3F8.4)
C
      SHIFT = 0.5*T*(1.-DIR(3))
C
C---- CLEAR ARRAY
        DO 400 K=1,1802
  400   KARRAY(K) = 0
C
      NTRY = 100
C     NTRY = 20
      TRY = NTRY
C
        DO 1 N=1,NTRY
          DO 2 J=1,JEND
          DEPTH = T*(J-1)+SHIFT
          CALL CERNKV(DEPTH,DIR,EE,T)
    2     CONTINUE
    1   CONTINUE
C
C---- HISTOGRAM OUTPUT
C     WRITE(6,600) (SOURCE(I,18),I=1,20)
      RNACP = NACP
      RNACP = RNACP/TRY
      WRITE(6,603) NEP,NACP,RNACP
  603 FORMAT(' TOTAL EMITTED PHOTON  NO.=',I8,
     1     /' TOTAL ACCEPTED PHO TOELECTRON=',I8,
     2     /' PHOTO-ELE./TRIAL=',F10.2)
C//////   RESULTS TO BE USED IN FITTING PROGRAM   ///////////////
      WRITE(6,1603) DIR(3)
 1603 FORMAT(' ',F6.3)
      WRITE(6,600) (CRNKSC(I,18),I=1,20)
  600 FORMAT(' ',(10F7.0))
C///////////////////////////////////////////////////////////////
C---- GET PHOTO-ELECTRON NUMBERS/1 RAD.LENGTH SOURCE TRACK.
        DO 10 I=1,20
          DO 20 J=1,25
          S = SOURCE(I,J)
          IF(S.EQ.0.) S = 1.
          CRNKSC(I,J) = CRNKSC(I,J)*CONVMX/S
   20     CONTINUE
   10   CONTINUE
      WRITE(6,604)
  604 FORMAT(' PHOTO-ELECTRON NUM.PER ONE RAD.LENGTH SOURCE TRACK')
      WRITE(6,605) (CRNKSC(I,18),I=1,20)
  605 FORMAT(' ',(10F7.2))
      WRITE(6,601)
  601 FORMAT(' PHOTON WAVE LENGTH DISTRIBUTION')
      WRITE(6,602) ((ISPCT(I,J),I=1,20),J=1,40)
C 602 FORMAT(' ',(10I7,2X,4I7))
  602 FORMAT(' ',10I7)
C
      IF(IDIR.NE.1.AND.IDIR.NE.5.AND.IDIR.NE.10) GO TO 950
      IBO = 0
      IF(IDIR.EQ.5) IBO = 20
      IF(IDIR.EQ.10) IBO = 40
      DO 940 J = 1,20
      IBO = IBO + 1
      XLAM = XLAMLW - .5*DXLAM
      DO 941  I = 1,40
      XLAM = XLAM + DXLAM
      WEIG = FLOAT(ISPCT(J,I))
      CALL HFILL(IBO,XLAM,0,WEIG)
941   CONTINUE
940   CONTINUE
C
950   CONTINUE
C
 1000 CONTINUE
      CALL HISTDO
      STOP
      END
C   26/06/78 601232211  MEMBER NAME  @FNPECER (S)           FORTRAN
C
C    PLOT THE FUNCTION NPECER
C         GEP VERSION
C
C
      DIMENSION X(14),A(2)
      DATA X/0.5,1.5,2.5,3.5,4.5,5.5,6.5,7.5,8.5,9.5,10.5,11.5,12.5,
     1  13.4/
C
      LOGICAL*1 TEXT
      DIMENSION TEXT(72)
C
C
      IPRO = 0
      NPTS = 14
C
C PLOT INITIALIZATION
C
      CALL ACORE(10000)
      DO 3705  I = 1,21
      CALL HBOOK1( I,' NR OF PHOTONS VS. RAD. LENGTH$',20,0.,20.)
3705  CONTINUE
      DO 3706  I = 1,2
      CALL HBOOK1(110+ I,' FIT PARAMETER, GLOBAL FIT$',21,-1.05,1.05)
3706  CONTINUE
C
7608  FORMAT(72A1)
7508  FORMAT(' ',72A1)
C     READ 7608, TEXT
C     WRITE(6,7508) TEXT
C
C  LOOP OVER VARIOUS COST STARTING HERE   ###########################
C
      COST = 1.10
      DELCO = 0.10
      ND = 0
C
 1    CONTINUE
      COST = COST - DELCO
      IF(COST.LT.-1.) GO TO 1000
      ND = ND + 1
C
      DO 1232  JJ = 1,NPTS
      CALL NPECER(1,X(JJ),COST,PENUM,A(1))
      WGT = PENUM
      CALL HFILL(ND,X(JJ),0,WGT)
1232  CONTINUE
C
      WGT = A(1)
      CALL HFILL(111,COST,0,WGT)
      WGT = A(2)
      CALL HFILL(112,COST,0,WGT)
C
      GO TO 1
C
 1000   CONTINUE
      CALL HISTDO
      STOP
      END
C   26/06/78 705112054  MEMBER NAME  @NPECER  (S)           FORTRAN
C
C    PLOT THE FUNCTION NPECER
C         GEP VERSION
C
C
      DIMENSION X(14),A(2)
      DATA X/0.5,1.5,2.5,3.5,4.5,5.5,6.5,7.5,8.5,9.5,10.5,11.5,12.5,
     1  13.4/
C
      LOGICAL*1 TEXT
      DIMENSION TEXT(72)
C
C
      IPRO = 0
      NPTS = 14
C
C PLOT INITIALIZATION
C
      CALL ACORE(10000)
      DO 3705  I = 1,21
      CALL HBOOK1( I,' NR OF PHOTONS VS. RAD. LENGTH$',20,0.,20.)
3705  CONTINUE
C
7608  FORMAT(72A1)
7508  FORMAT(' ',72A1)
C     READ 7608, TEXT
C     WRITE(6,7508) TEXT
C
C  LOOP OVER VARIOUS COST STARTING HERE   ###########################
C
      COST = 1.10
      DELCO = 0.10
      ND = 0
C
 1    CONTINUE
      COST = COST - DELCO
      IF(COST.LT.-1.) GO TO 1000
      ND = ND + 1
C
      DO 1232  JJ = 1,NPTS
      CALL NPECER(1,X(JJ),COST,PENUM)
      WGT = PENUM
      CALL HFILL(ND,X(JJ),0,WGT)
1232  CONTINUE
C
      GO TO 1
C
 1000   CONTINUE
      CALL HISTDO
      STOP
      END

C   19/02/80 111041559  MEMBER NAME  ENGLOS0  (SOURCE)      FORTRAN
      SUBROUTINE ENGLOS(E,D,DE,*)
C     ENERGY LOSS IN AL. COIL AND OTHER MATERIAL.
C     INPUT   E   INPUT ENERGY IN GEV
C             D   THICKNESS OF ALUMINUM ABSORBER IN CENTI METER
C             DE  ENERGY LOSS IN GEV
C                        WRITTEN BY H.TAKEDA  15/02/80
C                        TYPED BY Y.WATANABE  19/02/80
      DIMENSION BENG(16),BTHK(7)
      INTEGER*2 HCOR(16,7)
      DATA BENG/0.0, 0.5, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0,
     1          9.0, 11.0, 13.0, 15.0, 17.0, 19.0, 100.0/
      DATA BTHK/0., 7.0, 9.0, 11.0, 13.0, 15.0, 100.0/
      DATA HCOR/16*0, 0,46,55,65,70,78,84,90,95,7*96,
     3 0,61,76,90,102,112,118,126,130,134,6*136,
     4 0,84,108,130,146,157,168,180,190,196,200,5*202,
     5 0,104,134,170,194,212,228,238,245,256,264,5*268,
     6 0,128,172,218,258,278,300,320,336,350,360,5*362,16*0/
      DATA IERR1,IERR2,IENTRY,IERCNT,IBTHK,IBENG/3*0,5,7,16/
C     EXTRAPOLATE THE THICKNESS OF ALUMINUM
      DE=0.
C---- INITIALIZE
      IF(IENTRY.GE.1) GO TO 2
      DO 1 I=1,IBENG
      F=(BTHK(IBTHK)-BTHK(IBTHK-2))/(BTHK(IBTHK-1)-BTHK(IBTHK-2))
      HCOR(I,IBTHK)=HCOR(I,IBTHK-2)+F*(HCOR(I,IBTHK-1)-HCOR(I,IBTHK-2))
1     CONTINUE
C     WRITE(6,900) HCOR
C900  FORMAT(16I6)
      IENTRY=1
C
C       CHECK BAD INPUTS
2     IF(E.GE.0. .AND. E.LE.100.) GO TO 3
      IERR1=IERR1+1
      IF(IERR1.GT.IERCNT) RETURN1
      WRITE(6,600) E
600   FORMAT('0 **BAD  ENERGY INTO LGECOR(ENGLOS) E=',F10.3)
      RETURN1
C
3     IF(D.GE.0. .AND. D.LE.100.) GO TO 4
      IERR2=IERR2+1
      IF(IERR2.GT.IERCNT) RETURN1
      WRITE(6,610) D
610   FORMAT('0 **BAD THICKNESS INTO LGECOR(ENGLOS) D=',F10.3)
      RETURN1
C
4     DO 5 I=2,IBENG
      IF(E.LT.BENG(I)) GO TO 6
5     CONTINUE
6     DO 7 J=2,IBTHK
      IF(D.LT.BTHK(J)) GO TO 8
7     CONTINUE
C
8     EPORT=(E-BENG(I-1))/(BENG(I)-BENG(I-1))
      TPORT=(D-BTHK(J-1))/(BTHK(J)-BTHK(J-1))
C
      FACT1=HCOR(I-1,J-1)+EPORT*(HCOR(I,J-1)-HCOR(I-1,J-1))
      FACT2=HCOR(I-1,J  )+EPORT*(HCOR(I,J  )-HCOR(I-1,J  ))
C
      DE=FACT1+TPORT*(FACT2-FACT1)
      DE=DE/1000.
      IF(DE.GT.E) DE=E
      RETURN
      END

C   21/11/81 311221842  MEMBER NAME  DSORT    (S)           FORTRAN
      SUBROUTINE DSORT (N,PH,TRCM,DTRCM)
C         SUBROUTINE TO TAKE AVERAGE OF 60% LOWEST PULSE HEIGHTS
C         PUSE HEIGHTS IN PH(L) ,L=L'TH PULSE HEIGHT
C         N = NUMBER OF HITS
      DIMENSION PH(2)
C                            SET TRUNCATED MEAN FRACTION
C---  DATA TRMFLO /0.  /, TRMFHI /1.00/
      DATA TRMFLO /0.05/, TRMFHI /0.70/
      IF (N.LT.2) GOTO 99
C                            SORT PULSEHEIGHTS IN INCREASING ORDER
C                            USE SHELL ALGORITHM
      M=N
   10 M=M/2
      IF (M.EQ.0) GO TO 40
      K=N-M
      DO 30 J=1,K
      I=J
   20 IF (I.LT.1) GO TO 30
      IF (PH(I+M).GE.PH(I)) GO TO 30
      W=PH(I)
      PH(I)=PH(I+M)
      PH(I+M)=W
      I=I-M
      GO TO 20
   30 CONTINUE
      GO TO 10
   40 CONTINUE
C                            SHELLS ARE SORTED NOW
      NTRMLO = N*TRMFLO + 0.5
      NTRMHI = N*TRMFHI + 0.5
      TRM = NTRMHI - NTRMLO
      SUM=0.
      SUM2=0.
      NTRMLO = NTRMLO + 1
      DO 60 I=NTRMLO,NTRMHI
      SUM=SUM+PH(I)
      SUM2=SUM2+PH(I)**2
   60 CONTINUE
C                            CALCULATE MEAN AND SIGMA MEAN
      TRCM = SUM/TRM
      RMS = SUM2/TRM - TRCM**2
      DTRCM = SQRT(RMS/TRM)
      GOTO 100
   99 TRCM = 0.
      DTRCM = 0.
  100 CONTINUE
      RETURN
      END

C   26/09/79 C9092601   MEMBER NAME  MUCONP   (S)           FORTRAN
C LAST CHANGE 10.00 26/09/79 JOHN ALLISON.
C LAST CHANGE 20.16 21/09/79 HARRISON PROSPER
      SUBROUTINE MUCONP
C
      IMPLICIT INTEGER*2 (H)
C
C-----------------------------------------------------------------------
C
C MUCONP PRINTS MUON CALIBRATION DATA.
C
C-----------------------------------------------------------------------
C
C COMMONS.
C
#include "cmucalib.for"
C
C-----------------------------------------------------------------------
C
C PRINT DATA.
      WRITE(6,1001)NVERSN,DESCRP
 1001 FORMAT('1MU CALIBRATION DATA, VERSION',I5,', ',15A4)
      WRITE(6,1002)(HOVALL(I),I=1,5)
 1002 FORMAT('0OVERALL TRANSLATION PARAMETERS...'/
     *'    UNIT 1, FAR SIDE (-X) WALL',T45,I6/
     *'    UNIT 2, NEAR SIDE (+X, RUCKSACK) WALL',T45,I6/
     *'    UNIT 3, MAGNET (-Y AND INNER)',T45,I6/
     *'    UNIT 4, FAR ARCH',T45,I6/
     *'    UNIT 5, NEAR ARCH',T45,I6)
      WRITE(6,1003)
      WRITE (6,1010)
      WRITE(6,1004)
      WRITE(6,1011)
      DO 5 IF=1,NFRAMS
    5 WRITE(6,1005) IF,HFACE(IF),HLAYER(IF),HSECT(IF),HUNIT(IF),
     * HNORM(IF),HLONG(IF),HTRANS(IF),HDIST(IF),HANG(IF),HCLLO(IF),
     * HCLHI(IF),HCTLO(IF),HCTHI(IF),HAC(IF),HAL(IF)
      WRITE(6,1006)
      WRITE(6,1007)
      IX=NCHAMS/4+1
      DO 6 IC=1,IX
      JC=IC
      JC1 = JC+IX
      JC2 = JC+2*IX
      JC3 = JC+3*IX
      IF(JC3.GT.NCHAMS)JC3=NCHAMS
      WRITE(6,1008)JC,HFR(JC),HCTW(JC),HD1(JC),JC1,HFR(JC1),HCTW(JC1),
     * HD1(JC1),JC2,HFR(JC2),HCTW(JC2),HD1(JC2),JC3,HFR(JC3),HCTW(JC3),
     * HD1(JC3)
    6 CONTINUE
C
      WRITE(6,1100)
 1100 FORMAT('1CHAMBER ''ELECTRONIC'' DATA.'/
     *'0  VDR    = DRIFT VELOCITY IN MICRONS PER CLOCK PULSE (50 NS),'/
     *'   DTP    = DRIFT TIME PEDESTAL,'/
     *'   LTP    = LONGITUDINAL TIME PEDESTAL,'/
     *'   LSF1-4 = LONGITUDINAL SCALING FACTORS, HITS 1-4, 1/100MM PER C
     *LOCK PULSE (0.5 NS),'/
     *'   STA    = STATUS, =0 OK, .NE.0 DOWN FOR SOME REASON.'/
     *'0 CH  VDR DTP LTP LSF1 LSF2 LSF3 LSF4 STA',
     *2('      CH  VDR DTP LTP LSF1 LSF2 LSF3 LSF4 STA'))
      IX=NCHAMS/3+1
      DO 7 IC=1,IX
      J1=IC
      J2=IC+IX
      J3=IC+2*IX
      IF(J3.GT.NCHAMS)J3=NCHAMS
      WRITE(6,1101)
     * J1,HVDRFT(J1),HDTP(J1),HLTP(J1),(HLSF(J,J1),J=1,4),HMCSTA(J1),
     * J2,HVDRFT(J2),HDTP(J2),HLTP(J2),(HLSF(J,J2),J=1,4),HMCSTA(J2),
     * J3,HVDRFT(J3),HDTP(J3),HLTP(J3),(HLSF(J,J3),J=1,4),HMCSTA(J3)
 1101 FORMAT(I4,I5,2I4,4I5,I4,2(I8,I5,2I4,4I5,I4))
 7    CONTINUE
C
      DO 150 IFA=1,6
      WRITE(6,1102) IFA
      WRITE(6,1103) HBLLO(IFA),HBLHI(IFA),HBTLO(IFA),HBTHI(IFA)
      IARG=6*(IFA-1) +1
      JARG=6*IFA
      WRITE(6,1104)(HBNLIM(J),J=IARG,JARG)
  150 CONTINUE
      WRITE(6,1114)IFCIND
 1114 FORMAT('0BLOCK PARAMETER IFCIND...',6I10)
C
      WRITE(6,2000)HYKNMI,HYKNMO,HYKLDM,HYKTDM,BYOKE,IYKIND
 2000 FORMAT('0YOKE PARAMETERS....'/
     *'   HYKNMI',4I10/
     *'   HYKNMO',4I10/
     *'   HYKLDM',4I10/
     *'   HYKTDM',4I10/
     *'   FLUX  ',F10.4/
     *'   IYKIND',I10)
C
      WRITE(6,2001)IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,
     *              IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
     *              IEPIND,IEPSCT
 2001 FORMAT('0END PLUG PARAMS....'/
     *'   IZEII ',I10/
     *'   IZEIO ',I10/
     *'   IREP1 ',I10/
     *'   IREP2 ',I10/
     *'   IREP3 ',I10/
     *'   IREP4 ',I10/
     *'   IXYEP5',I10/
     *'   IZOEP1',I10/
     *'   IZOEP2',I10/
     *'   IZOEP3',I10/
     *'   IZOEP4',I10/
     *'   IZOEP5',I10/
     *'   CAEP2 ',F10.4/
     *'   IEPIND',I10/
     *'   IEPSCT',I10)
C
C-----------------------------------------------------------------------
C
C OTHER FORMAT STATEMENTS.
C
C
 1003 FORMAT('0HERE IS THE DATA FOR THE MUON FILTER FRAMES')
 1004 FORMAT(' ',1X,'FRAME',3X,'FACE',3X,'LAYER',1X,'SECTION',2X,
     *'UNIT',3X,
     *' N L T',1X,'PERP DIST',1X,'   TWIST ',3X,'   CLLO ',2X,'   CLHI '
     *,2X,'   CTLO ',2X,'   CTHI ',1X,'1ST & LAST')
 1005 FORMAT(1X,I6,4I7,4X,3I2,6I10,2I5)
 1006 FORMAT('1HERE IS THE DATA FOR THE MU FILTER CHAMBERS')
 1007 FORMAT('     CH NO FRAME CTW(MM) D1(MM)',4X,'CH NO FRAME CTW(MM) D
     *1(MM)',4X,'CH NO FRAME CTW(MM) D1(MM)',4X,'CH NO FRAME CTW(MM) D1(
     *MM)')
 1008 FORMAT(4(2X,2I6,I8,I6,2X))
 1010 FORMAT(' ',T10,' FRAME INDICES ',T72,' SENSITIVE AREA LIMITS')
 1011 FORMAT(' ',T52,'(MM)',T60,'(1/10MR)',T73,'(MM)',T83,'(MM)',T93,
     * '(MM)',T103,'(MM)')
 1102 FORMAT(///,T5,'CONCRETE BLOCK LIMITS FOR FACE ',I4,5X,'(ALL IN MM)
     *')
 1103 FORMAT(/,T5,'LONGITUDINAL',I5,' TO ',I5,' TRANSVERSE ',I5,' TO ',
     * I5)
 1104 FORMAT(/,T5,'NORMAL LIMITS BLK#1',3X,I5,' TO ',I5,'   BLK#2',3X,
     *I5,' TO ',I5,'   BLK#3',3X,I5,' TO ',I5)
C
C-----------------------------------------------------------------------
C
      RETURN
      END

C   07/06/96 606071812  MEMBER NAME  BFRD     (S4)          FORTG1
      SUBROUTINE BFRD(IUN,NTOT,BUFF)
C     BOS SUBPROGRAM =3.6=
      INTEGER BUFF(NTOT)
      READ(IUN,ERR=101,END=102) NTOT,BUFF
  100 RETURN
  101 NTOT=0
      READ(IUN,ERR=101,END=102)
      GOTO 100
  102 NTOT=-1
      GOTO 100
C
      ENTRY BFWR(IUN,NTOT,BUFF)
      WRITE(IUN) BUFF
      GOTO 100
      END

C   24/10/81 206230903  MEMBER NAME  MCGJET   (GRAPHS)      FORTRAN
      SUBROUTINE MCGJET(NJET,Y)
C
C   GRAPHICS VERSION, ALL COMMONS PUT INTO /CWORK/
C                                           J.OLSSON   23.6.82
C
C
C  ********  SUBROUTINE FOR RECONSTRUCTION OF JET AXES IN   *******
C  ************    2-JET , 3-JET , 4-JET EVENTS        ***************
C
C                          ------------  M. C. GODDARD---------
C   VERSION NO. 478263900925
C
C --------------------------------------------------------------
C
C
C  INPUT :              ------------------
C
C       CALLING ARGUMENTS :
C
C           -- NJET --     NUMBER OF JETS TO BE RECONSTRUCTED
C           -- NJET --       (MUST BE GE 2 AND LE 4)
C
C           -- Y(3) --     NORMALIZED VECTOR IN THE DIRECTION OF THE
C           -- Y(3) --     EVENT PLANE NORMAL . CAN BE THE EIGENVECTOR
C           -- Y(3) --     OF THE SECOND LARGEST "Q" EIGENVALUE , OR
C           -- Y(3) --     THE ACCOPLANARITY DIRECTION .
C           -- Y(3) --     NOT NECESSARY FOR TWO-JET RECONSTRUCTION
C
C    *** N B ***  THIS VECTOR MUST HAVE UNIT NORM
C
C
C       COMMON BLOCKS :
C
C       -- /SENSE/ PP(4,100),INUM --  INPUT COMMON BLOCK CONTAINING
C       -- /SENSE/ PP(4,100),INUM --  THE THREE VECTORS OF THE
C       -- /SENSE/ PP(4,100),INUM --  TRACKS TO BE USED IN THE AXES
C       -- /SENSE/ PP(4,100),INUM --  DETERMINATION . INUM IS THE
C       -- /SENSE/ PP(4,100),INUM --  NUMBER OF TRACKS IN THE PP ARRAY .
C       -- /SENSE/ PP(4,100),INUM --  PP(1,J),PP(2,J),PP(3,J) ARE X,Y,Z
C       -- /SENSE/ PP(4,100),INUM --  MOMENTUM COMPONENTS FOR TRACK J .
C       -- /SENSE/ PP(4,100),INUM --  IPP(4,J) IS A TRACK INDEX WHICH
C       -- /SENSE/ PP(4,100),INUM --  IS JUST COPIED INTO THE OUTPUT
C       -- /SENSE/ PP(4,100),INUM --  COMMON BLOCK (SEE BELOW) AND CAN
C       -- /SENSE/ PP(4,100),INUM --  BE USED BY THE USER TO FURTHER
C       -- /SENSE/ PP(4,100),INUM --  ANALYZE A TRACK ASSIGNED TO ANY
C       -- /SENSE/ PP(4,100),INUM --  RECONSTRUCTED JET . THIS DOESNT
C       -- /SENSE/ PP(4,100),INUM --  HAVE TO BE FILLED .
C
C
C       -- /WT/ IWT --  IF IWT IS NON-ZERO , THE JET AXES FOR THREE
C       -- /WT/ IWT --  AND FOUR JET EVENTS WILL BE DETERMINED GIVING
C       -- /WT/ IWT --  A HIGHER WEIGHT TO THE FASTER PARTICLES . THE
C       -- /WT/ IWT --  DEFAULT IS IWT = 0 .
C
C
C  OUTPUT :                    ---------------------------
C
C          COMMON BLOCKS :
C
C         -- /MARKET/ PAR(3,4) --  NORMALIZED VECTORS IN THE DIRECTIONS
C         -- /MARKET/ PAR(3,4) --  OF THE RECONSTRUCTED JET AXES .
C         -- /MARKET/ PAR(3,4) --  PAR(1,J),PAR(2,J),PAR(3,J) ARE X,Y,Z
C         -- /MARKET/ PAR(3,4) --  COMPONENTS FOR JET J .
C
C
C         -- /COLD/ IJ(4),PTH(3,100,4),IPJ(100,4) --
C
C         --  IJ(J) CONTAINS THE NUMBER OF PARTICLES ASSOCIATED WITH
C         --        JET J .
C         --  PTH(3,K,J) CONTAINS THE MOMENTUM VECTOR FOR THE K'TH
C         --             TRACK OF JET J . K SHOULD RUN FROM 1 TO IJ(J) .
C         --  IPJ(K,J) IS THE TRACK INDEX FOR TRACK K OF JET J , JUST
C         --           COPIED FROM THE IPP(4,?) OF THE INPUT /SENSE/
C         --           COMMON BLOCK .
C
C
C         -- /CRUST/ AXIS(3),ATRST --  ANY CALL TO MCGJET CAUSES THE
C         -- /CRUST/ AXIS(3),ATRST --  THRUST AND THRUST AXIS TO BE
C         -- /CRUST/ AXIS(3),ATRST --  CALCULATED . AXIS(3) CONTAINS
C         -- /CRUST/ AXIS(3),ATRST --  THE NORMALIZED THRUST AXIS AND
C         -- /CRUST/ AXIS(3),ATRST --  ATRST THE THRUST VALUE. WHEN
C         -- /CRUST/ AXIS(3),ATRST --  THE CALL IS MADE WITH NJET=2
C         -- /CRUST/ AXIS(3),ATRST --  THE THRUST CALCULATION IS MADE
C         -- /CRUST/ AXIS(3),ATRST --  USING ONLY THE VECTORS IN THE
C         -- /CRUST/ AXIS(3),ATRST --  /SENSE/ COMMON. FOR ANY OTHER
C         -- /CRUST/ AXIS(3),ATRST --  VALUE OF NJET THE THRUST IS
C         -- /CRUST/ AXIS(3),ATRST --  CALCULATED USING A BALANCED SET
C         -- /CRUST/ AXIS(3),ATRST --  OF VECTORS .
C
C --------------------------------------------------------------
      COMMON /CWORK/ PAR(3,4),PP(4,100),INUM,JWT,ICONF
      COMMON /WT/ IWT
C     COMMON /MARKET/ PAR(3,4)
C     COMMON /SENSE/ PP(4,100),INUM
C     COMMON /CWT/ JWT
      DIMENSION Y(3),X(3),Z(3),PSUM(3)
C
C   FOR TWO JET RECON JWT = 0
C
      JWT=0
      IF(NJET.EQ.2) GO TO 222
C
C   BALANCE MOMENTUM BEFORE CALCULATING THRUST AXIS
C
      IREM=INUM
      IADD=INUM+1
      DO 56 IU=1,3
      PSUM(IU)=0.
      DO 57 IK=1,INUM
  57  PSUM(IU)=PSUM(IU)+PP(IU,IK)
  56  PP(IU,IADD)=-PSUM(IU)
      PPM=PP(1,IADD)**2+PP(2,IADD)**2+PP(3,IADD)**2
      IF(PPM.GT..0001) INUM=IADD
C
C   CALCULATE THRUST AXIS
C
      CALL JETREC(2,Y)
C
C   SET JWT TO INPUT VALUE
C
      JWT=IWT
C
C   RESET NUMBER OF TRACKS
C
      INUM=IREM
C
C   INITIALIZE X TO THRUST AXIS
C
      DO 44 IU=1,3
  44  X(IU)=PAR(IU,3)
C
C   Z = X CROSS Y
C
      Z(1)=X(2)*Y(3)-Y(2)*X(3)
      Z(2)=X(3)*Y(1)-Y(3)*X(1)
      Z(3)=X(1)*Y(2)-Y(1)*X(2)
      A=SQRT(Z(1)**2+Z(2)**2+Z(3)**2)
      IF(A.EQ.0.) A=1.
      A=1./A
      DO 28 IU=1,3
  28  Z(IU)=Z(IU)*A
C
C   DO JET AXIS RECONSTRUCTION
C
 222  CALL JETREC(NJET,X,Y,Z)
      RETURN
      END
C
C
C
C  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C
C
      SUBROUTINE JETREC(NJET,X,Y,Z)
C
C
C
C     MAIN SUBROUTINE FOR RECONSTRUCTION OF JET AXES
C
C
C
C --------------------------------------------------------------
C
C
C  INPUT :              ------------------
C
C       CALLING ARGUMENTS :
C
C           -- NJET --     NUMBER OF JETS TO BE RECONSTRUCTED
C           -- NJET --       (MUST BE GE 2 AND LE 4)
C
C           -- X(3) --     NORMALIZED VECTOR POINTING IN THE
C           -- X(3) --     ESTIMATED DIRECTION OF THE FASTEST JET.
C
C           -- Y(3) --     NORMALIZED VECTOR IN THE DIRECTION OF THE
C           -- Y(3) --     EVENT PLANE NORMAL .
C
C           -- Z(3) --     NORMALIZED VECTOR IN THE EVENT PLANE
C           -- Z(3) --     PERPENDICULAR TO THE X VECTOR .
C
C
C
C
C   INTERNAL COMMON BLOCKS :
C
C   THE /CONF/ COMMON BLOCK CONTAINS THE CONFIGURATION NUMBER
C
C     COMMON /CONF/ ICONF
C
C   THE /OLD/ COMMON BLOCK REMEMBERS THE VALUES OF THE PAR ARRAY
C               FOR EACH CONFIGURATION BEFORE THEY ARE CHANGED BY
C               SUBROUTINE RJXX . THEY ARE THEN USED BY SUBROUTINE
C               MINUS TO GENERATE A NEW CONFIGURATION .
C
C     COMMON /OLD/ POLD(3,4)
C
C   THE /TRIPL/ COMMON BLOCK CONTAINS THE BEST VALUE OF THE GENERALIZED
C                TRIPLICITY OBTAINED SO FAR FOR THIS EVENT .
C
C     COMMON /TRIPL/ TOLD,TR(4)
C
C   THE /LJET/ COMMON BLOCK CONTAINS : MJET -- NUMBER OF JETS TO
C                                           --  BE RECONSTRUCTED
C                                    IKONF -- NUMBER OF CONFIGURATIONS
C                                             (2 FOR 3-JETS ,
C                                                 10 FOR 4-JETS)
C
C     COMMON /LJET/ MJET,IKONF
C
C   THE /PMAG/ COMMON CONTAINS THE MODULUS OF THE VECTORS IN THE
C                 /SENSE/ COMMON
C
C     COMMON /PMAG/ PMOD(100)
C
C   THE /CYYY/ COMMON CONTAINS THE EVENT PLANE NORMAL AS SUPPLIED BY
C                THE USER
C
C     COMMON /CYYY/ YY(3)
      COMMON /CWORK/ PAR(3,4),PP(4,100),INUM,JWT,ICONF,POLD(3,4),TOLD,
     $ TR(4),MJET,IKONF,PMOD(100),YY(3),AXIS(3),ATRST,
     $ IJ(4),PTH(3,100,4),IPJ(100,4)
C
C
C ---------------------------------------------------------------------
C
C
C     COMMON /SENSE/ PP(4,100),INUM
C
C
C     COMMON /MARKET/ PAR(3,4)
C
C
C     COMMON /CRUST/ AXIS(3),ATRST
C
C
C     COMMON /COLD/ IJ(4),PTH(3,100,4),IPJ(100,4)
C
      DIMENSION Y(3),Z(3),X(3)
C
      DATA ROOT2/0.707107/
C
C
C
C
C
C
      MJET=NJET
      DO 87 IU=1,4
  87  IJ(IU)=0
C
C  IF IJ(L) IS STILL ZERO FOR L LE MJET THEN ONE JET HAS ZERO PARTICLES
C    ASSOCIATED WITH IT AND THIS EVENT SHOULD PROBABLY BE REJECTED
C    BY THE USER .
C
      DO 42 IU=1,3
  42  YY(IU)=Y(IU)
      IF(MJET.GE.2.AND.MJET.LE.4) GO TO 15
      WRITE(6,876) MJET
 876  FORMAT('0 **** RECONSTRUCTION OF',I5,'  JETS NOT POSSIBLE ******')
      RETURN
  15  CONTINUE
      ITRK=INUM
      IF(ITRK.LE.100) GO TO 16
      ITRK=100
      WRITE(6,908) INUM
  908 FORMAT('0 **** WARNING *****',I7,'   TRACKS INPUT AND THIS IS FAR
     #TOO MANY , SET TO 100')
  16  CONTINUE
      IF(ITRK.GE.MJET) GO TO 17
      WRITE(6,907) ITRK,MJET
 907  FORMAT('0 ***** ONLY',I4,'  TRACKS INPUT AND THIS IS FAR TOO FEW T
     #O RECONSTRUCT',I5,' JETS')
      RETURN
  17  CONTINUE
      IF(MJET.NE.2) GO TO 290
      DO 485 I=1,ITRK
 485  PMOD(I)=SQRT(PP(1,I)**2+PP(2,I)**2+PP(3,I)**2)
 290  CONTINUE
C  INITIALIZE CONFIGURATION NUMBER
      ICONF=0
C  INITIALIZE GENERALIZED TRIPLICITY
      TOLD=0.
      IF(MJET.EQ.3) GO TO 3
      IF(MJET.EQ.2) GO TO 2
C
C
C   -----------    FOUR JET RECONSTRUCTION  -------------------------
C
C  INITIALIZE THE PAR COMMON WITH EACH OF THE 10 CONFIGURATIONS
C      AND THEN CALL RJXX FOR EACH
C
C  SET NUMBER OF CONFIGURATIONS
      IKONF=10
C     CONFIGURATION 1
      DO 45 IU=1,3
      PAR(IU,1)=(X(IU)+Z(IU))*ROOT2
      PAR(IU,2)=(X(IU)-Z(IU))*ROOT2
      PAR(IU,3)=-PAR(IU,1)
      PAR(IU,4)=-PAR(IU,2)
 45   CONTINUE
      CALL RJXX
C   CONFIGURATION 2
      DO 645 IU=1,3
      PAR(IU,1)=POLD(IU,1)
      PAR(IU,2)=POLD(IU,2)
      PAR(IU,3)=(-X(IU)+Y(IU))*ROOT2
      PAR(IU,4)=(-X(IU)-Y(IU))*ROOT2
  645 CONTINUE
      CALL RJXX
C  CONFIGURATION 3
      CALL MINUS
      CALL RJXX
C  CONFIGURATION 4
      DO 675 IU=1,3
      PAR(IU,1)=POLD(IU,1)
      PAR(IU,2)=-POLD(IU,2)
      PAR(IU,3)=(-Z(IU)+Y(IU))*ROOT2
      PAR(IU,4)=(-Z(IU)-Y(IU))*ROOT2
  675 CONTINUE
      CALL RJXX
C  CONFIGURATION 5
      CALL MINUS
      CALL RJXX
C  CONFIGURATION 6
      DO 890 IU=1,3
      PAR(IU,1)=Z(IU)
      PAR(IU,2)=X(IU)
      PAR(IU,3)=-POLD(IU,1)
      PAR(IU,4)=-POLD(IU,2)
 890  CONTINUE
      CALL RJXX
C  CONFIGURATION 7
      DO 276 IU=1,3
      PAR(IU,1)=POLD(IU,1)
      PAR(IU,2)=POLD(IU,2)
      PAR(IU,3)=-(Z(IU)+X(IU))/2.+Y(IU)*ROOT2
      PAR(IU,4)=-(Z(IU)+X(IU))/2.-Y(IU)*ROOT2
 276  CONTINUE
      CALL RJXX
C  CONFIGURATION 8
      CALL MINUS
      CALL RJXX
C  CONFIGURATION 9
      DO 356 IU=1,3
      PAR(IU,1)=-POLD(IU,2)
      PAR(IU,2)=POLD(IU,1)
      PAR(IU,3)=(-Z(IU)+X(IU))/2.+Y(IU)*ROOT2
      PAR(IU,4)=(-Z(IU)+X(IU))/2.-Y(IU)*ROOT2
 356  CONTINUE
      CALL RJXX
C  CONFIGURATION 10
      CALL MINUS
      CALL RJXX
      RETURN
C
C
C    ----------------   THREE JET RECONSTRUCTION   ----------------
C
C  INITIALIZE THE PAR COMMON WITH EACH OF THE 2 CONFIGURATIONS
C      AND THEN CALL RJXX FOR EACH
C
  3   CONTINUE
C  SET NUMBER OF CONFIGURATIONS
      IKONF=2
C     CONFIGURATION 1
      DO 845 IU=1,3
      PAR(IU,1)=X(IU)
      PAR(IU,2)=(-X(IU)-Z(IU))*ROOT2
      PAR(IU,3)=(-X(IU)+Z(IU))*ROOT2
845   CONTINUE
      CALL RJXX
C   CONFIGURATION 2
      CALL MINUS
      CALL RJXX
      RETURN
C
C  ---------------------- TWO JET RECONSTRUCTION --------------------
C
C             SET PAR EQAL TO THE BIGGEST VECTOR IN /SENSE/
C                     AND CALL RJXX
C
  2   CONTINUE
      IMAX=1
      PMAX=PMOD(1)
      DO 621 ITR=2,ITRK
      IF(PMOD(ITR).LT.PMAX) GO TO 621
      IMAX=ITR
      PMAX=PMOD(ITR)
 621  CONTINUE
      DO 892 IU=1,3
      PAR(IU,1)=PP(IU,IMAX)
      PAR(IU,2)=-PP(IU,IMAX)
      PAR(IU,3)=0.
892   CONTINUE
      CALL RJXX
C  DETERMINE THRUST AXIS
      IL=IJ(1)
      DO 434 IK=1,IL
      DO 821 IU=1,3
821   PAR(IU,3)=PTH(IU,IK,1)+PAR(IU,3)
 434  CONTINUE
      IL=IJ(2)
      DO 534 IK=1,IL
      DO 521 IU=1,3
521   PAR(IU,3)=-PTH(IU,IK,2)+PAR(IU,3)
 534  CONTINUE
      PNORM=SQRT(PAR(1,3)**2+PAR(2,3)**2+PAR(3,3)**2)
      IF(PNORM.EQ.0.) GO TO 643
      PNORM=1./PNORM
      DO 759 IU=1,3
      PAR(IU,3)=PAR(IU,3)*PNORM
 759  AXIS(IU)=PAR(IU,3)
 644  CONTINUE
C  DETERMINE THRUST
      PSUM=0.
      PCOMP=0.
      DO 754 IU=1,ITRK
      PSUM=PSUM+PMOD(IU)
      PTEMP=PAR(1,3)*PP(1,IU)+PAR(2,3)*PP(2,IU)+PAR(3,3)*PP(3,IU)
      PCOMP=PCOMP+ABS(PTEMP)
754   CONTINUE
      PTH(1,1,3)=PCOMP/PSUM
      ATRST=PCOMP/PSUM
      RETURN
 643  CONTINUE
      DO 655 IU=1,3
      PAR(IU,3)=PAR(IU,1)
 655  AXIS(IU)=PAR(IU,1)
      GO TO 644
      END
C
C
C
C   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C
C
      SUBROUTINE RJXX
C
C  ---------------------------------------------------------------
C
C       THIS SUBROUTINE IS CALLED BY MCGJET FOR EACH CONFIGURATION.
C       THE INPUT CONFIGURATION IS USED AS A STARTING VALUE FOR
C       THE JET AXES . BETTER VALUES ARE THEN DETERMINED BY ITERATION .
C        THE INITIAL JET AXES FOR EACH CONFIGURATION ARE STORED
C        IN THE ARRAY POLD AND THE BEST JET AXES SO FAR
C        FOR THIS EVENT ARE IN THE ARRAYS TEMP,TPTH,ITPJ,ITJ .
C        THE VALUE FOR THE TRIPLICITY IS STORED IN THE COMMON /TRIPL/ .
C
C  ----------------------------------------------------------------
C
C     COMMON /SENSE/ PP(4,100),INUM
C     COMMON /MARKET/ PAR(3,4)
C     COMMON /COLD/ IJ(4),PTH(3,100,4),IPJ(100,4)
C
C     COMMON /CONF/ ICONF
C     COMMON /TRIPL/ TOLD,TR(4)
C     COMMON /OLD/ POLD(3,4)
C     COMMON /LJET/ MJET,IKONF
C
C
C  THE /IND/ COMMON IS AN INDEX SET UP JUST BEFORE THE CALL TO SUMTHR .
C    INDX(K,J) IS THE TRACK NUMBER IN THE /SENSE/ COMMON FOR
C    TRACK K IN JET J OF THE /COLD/ COMMON . THIS INDEX ALLOWS
C    THE MODULUS OF EACH TRACK IN THE /SENSE/ COMMON TO BE
C    COMPUTED ONLY ONCE (IN THE MAIN ROUTINE MCGJET) AND STORED
C    IN THE COMMON /PMAG/ FOR REPEATED USE IN THE SUBROUTINE SUMTHR .
C
C     COMMON /IND/ INDX(100,4)
C
C  THE /CJRUST/ COMMON CONTAINS THE NORMALIZED JET DIRECTION IN THE
C   ARRAY THRUJ AND THE VALUE OF THE GENERALIZED TRIPLICITY FOR
C   THIS ONE JET AS COMPUTED IN THE SUBROUTINE SUMTHR .
C
C     COMMON /CJRUST/ THJ,THRUJ(3)
      COMMON /CWORK/ PAR(3,4),PP(4,100),INUM,JWT,ICONF,POLD(3,4),TOLD,
     $ TR(4),MJET,IKONF,PMOD(100),YY(3),AXIS(3),ATRST,
     $ IJ(4),PTH(3,100,4),IPJ(100,4),INDX(100,4),THJ,THRUJ(3),
     $ TEMP(3,4),TPTH(3,100,4),ITPJ(100,4),ITJ(4),
     $ ANG(4),COMP(4),TREM(4)
C
      DIMENSION IPP(4,100)
      EQUIVALENCE(PP(1,1),IPP(1,1))
C
C  MAXIMUM NUMBER OF ITERATIONS IS ITMAX
C
      DATA ITMAX/9/
C
C
      ICONF=ICONF+1
C     WRITE(6,909) ICONF
C909  FORMAT('0CONFIGURATION NO ',I10)
C
C  REMEMBER THIS CONFIGURATION
C
      DO 643 IU=1,3
      DO 644 IY=1,4
      POLD(IU,IY)=PAR(IU,IY)
  644 CONTINUE
 643  CONTINUE
      IKOUNT=0
 777  CONTINUE
      IKOUNT=IKOUNT+1
      IIT=0
C
C -------  ITERATION LOOP --------------------------------------
C
 888  CONTINUE
C  IIT IS ITERATION COUNTER
      IIT=IIT+1
      DO 387 IU=1,4
      IJ(IU)=0
 387  CONTINUE
C
C  ---  LOOP OVER TRACKS -----------------------------------------
C
      DO 621 ITR=1,INUM
      PX=PP(1,ITR)
      PY=PP(2,ITR)
      PZ=PP(3,ITR)
C  DETERMINE TO WHICH CURRENT JET AXIS (AS GIVEN IN THE PAR ARRAY)
C   THIS TRACK IS CLOSEST
      DO 287 IU=1,MJET
 287  COMP(IU)=PX*PAR(1,IU)+PY*PAR(2,IU)+PZ*PAR(3,IU)
      JET=1
      AM=COMP(1)
      DO 288 IU=2,MJET
      AM=AMAX1(AM,COMP(IU))
 288  IF(AM.EQ.COMP(IU)) JET=IU
C
C  THIS TRACK IS CLOSEST TO JET NO 'JET'
C
      IF(IJ(JET).GE.100) GO TO 621
C  ASSOCIATE THIS TRACK WITH JET 'JET'
      IJ(JET)=IJ(JET)+1
      IPT=IJ(JET)
      IPJ(IPT,JET)=IPP(4,ITR)
      PTH(1,IPT,JET)=PX
      PTH(2,IPT,JET)=PY
      PTH(3,IPT,JET)=PZ
C  SET INDX ARRAY FOR FASTER COMPUTATION IN SUBROUTINE SUMTHR
      INDX(IPT,JET)=ITR
 621  CONTINUE
C
C  ------  DETERMINE NEW JET DIRECTIONS  ------------------------
C
      TTOT=0.
      DO 478 KU=1,MJET
      JCNT=KU
      CALL SUMTHR(JCNT)
C  ANGLE BETWEEN JET AXIS FROM THIS AND LAST ITERATION
      ANG(KU)=THRUJ(1)*PAR(1,KU)+THRUJ(2)*PAR(2,KU)+THRUJ(3)*PAR(3,KU)
C  STORE NEW JET DIRECTIONS
      DO 188 JL=1,3
      PAR(JL,KU)=THRUJ(JL)
 188   CONTINUE
C  TTOT IS GENERALIZED TRIPLICITY FOR THIS ITERATION
      TR(KU)=THJ
      TTOT=TTOT+THJ
 478  CONTINUE
C  IF CHANGE IN JET DIRECTIONS IS LESS THAN 1 DEGREE OR MAX NUMBER OF
C      OF ITERATIONS HAVE BEEN REACHED , WE WILL FINISH .
      DO 186 IU=1,MJET
 186  IF(ANG(IU).LT.0.99985) GO TO 388
      GO TO 1000
 388  CONTINUE
      IF(IIT.GE.ITMAX) GO TO 1000
C  ANOTHER ITERATION IS NECESSARY
      GO TO 888
C
C  ---------  END OF ITERATION  -------------------------------------
C
1000  CONTINUE
C
C
C     WRITE(6,984)((PAR(IK,IB),IK=1,3),IB=1,4)
C984   FORMAT('0 DIRS AFTER THIS CONF ',4(3F7.4,5X))
C     WRITE(6,898) IJ
C898  FORMAT('  IJ  ',4I10)
C     WRITE(6,245) TTOT
C245  FORMAT(' *****  TTOT = ',F10.5)
C
C  THIS CONF NOT AS GOOD AS ONE BEFORE , GO TO 911
      IF(TTOT.LE.TOLD) GO TO 911
C  THESE ARE THE BEST JET AXES SO FAR , REMEMBER THEM .
      TOLD=TTOT
C  IF TWO JET EVENT RETURN IMMEDIATELY SINCE
C   ONLY ONE CONFIGURATION TO BE TRIED . BEST AXES ARE
C   ALREADY STORED AWAY .
      IF(MJET.EQ.2) RETURN
      DO 87 IE=1,MJET
      IL=IJ(IE)
      IF(IL.EQ.0) GO TO 911
      TREM(IE)=TR(IE)
      DO 89 I=1,3
      TEMP(I,IE)=PAR(I,IE)
 89   CONTINUE
      ITJ(IE)=IJ(IE)
      DO 14 K=1,IL
      ITPJ(K,IE)=IPJ(K,IE)
      DO 14 I=1,3
      TPTH(I,K,IE)=PTH(I,K,IE)
  14  CONTINUE
 87   CONTINUE
  911 CONTINUE
      IF(MJET.EQ.4) GO TO 444
      IF(IKOUNT.GT.3) GO TO 444
      IF(IKOUNT.EQ.1) CALL RESTAR(1,2,3)
      IF(IKOUNT.EQ.2) CALL RESTAR(1,3,2)
      IF(IKOUNT.EQ.3) CALL RESTAR(2,3,1)
      GO TO 777
  444 CONTINUE
C
C  FINISH
C
C  IF MORE CONFIGURATIONS TO COME THEN JUST RETURN
C    BEST PARAMETERS SO FAR WILL BE STORED IN ITJ,ITPJ,TPTH,TEMP
      IF(ICONF.LT.IKONF) RETURN
C  WE HAVE THE LAST CONFIGURATION , SO FILL COMMONS WITH BEST VALUES
      DO 634 IE=1,MJET
      TR(IE)=TREM(IE)
      IL=ITJ(IE)
      IJ(IE)=ITJ(IE)
      DO 164 K=1,IL
      IPJ(K,IE)=ITPJ(K,IE)
      DO 164 I=1,3
      PTH(I,K,IE)=TPTH(I,K,IE)
 164  CONTINUE
      DO 321 I=1,3
      PAR(I,IE)=TEMP(I,IE)
 321  CONTINUE
 634  CONTINUE
C     WRITE(6,721)((PAR(IK,IB),IK=1,3),IB=1,4)
C721  FORMAT('0FINAL AXES ',4(3F7.4,5X))
C     WRITE(6,267) IJ
C267  FORMAT('   IJ    ',4I10)
C     WRITE(6,794) TOLD
C794  FORMAT(' FINAL TTOT  ',F10.5)
      RETURN
      END
C
C
C
C   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C
C
      SUBROUTINE MINUS
C
C  ---------------------------------------------------------------
C
C     THIS SUBROUTINE MAKES A NEW CONFIGURATION BY SIMPLY
C     REVERSING THE AXES OF THE PREVIOUS CONFIGURATION
C
C  ----------------------------------------------------------------
C
      COMMON /CWORK/ PAR(3,4),PP(4,100),INUM,JWT,ICONF,POLD(3,4),TOLD,
     $ TR(4),MJET,IKONF,PMOD(100),YY(3),AXIS(3),ATRST,
     $ IJ(4),PTH(3,100,4),IPJ(100,4),INDX(100,4),THJ,THRUJ(3),
     $ TEMP(3,4),TPTH(3,100,4),ITPJ(100,4),ITJ(4),
     $ ANG(4),COMP(4),TREM(4)
C     COMMON /OLD/ POLD(3,4)
C     COMMON /MARKET/ PAR(3,4)
C
      DO 187 IE=1,4
      DO 87 IU=1,3
      PAR(IU,IE)=-POLD(IU,IE)
 87   CONTINUE
 187  CONTINUE
      RETURN
      END
C
C
C
C   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C
C
      SUBROUTINE SUMTHR(JIN)
C
C
C
C  --------------------------------------------------------------
C
C    THIS SUBROUTINE CALCULATES NEW JET DIRECTIONS FOR JET "JIN" .
C           IT USES THE MOMENTA FOR JET JIN STORED IN THE COMMON
C          /COLD/ . ALSO CALCULATES VALUE FOR THE GENERALIZED
C          TRIPLICITY . THE NORMALIZED JET DIRECTION FOR JET JIN
C          AND THE CONTRIBUTION TO THE GENERALIZED TRIPLICITY
C          FROM THIS JET ARE STORED IN THE /CJRUST/ COMMON .
C
C ---------------------------------------------------------------
C
      COMMON /CWORK/ PAR(3,4),PP(4,100),INUM,JWT,ICONF,POLD(3,4),TOLD,
     $ TR(4),MJET,IKONF,PMOD(100),YY(3),AXIS(3),ATRST,
     $ IJ(4),PTH(3,100,4),IPJ(100,4),INDX(100,4),THJ,THRUJ(3),
     $ TEMP(3,4),TPTH(3,100,4),ITPJ(100,4),ITJ(4),
     $ ANG(4),COMP(4),TREM(4),T(3)
C     COMMON /CJRUST/ THJ,THRUJ(3)
C     COMMON /MARKET/ PAR(3,4)
C     COMMON /COLD/ IJ(4),PTH(3,100,4),IPJ(100,4)
C     COMMON /PMAG/ PMOD(100)
C     COMMON /IND/ INDX(100,4)
C     COMMON /CWT/ JWT
C
C     DIMENSION T(3)
C
      THJ=0.
      NTRK=IJ(JIN)
      IF(NTRK.LE.0) RETURN
C
C   BRANCH FOR WEIGHTING OF JET AXIS
C
      IF(JWT.NE.0) GO TO 543
C
      DO 101 K=1,3
      T(K)=0.
      DO 100 I=1,NTRK
      T(K)=T(K)+PTH(K,I,JIN)
 100  CONTINUE
 101  CONTINUE
 544  CONTINUE
      TMOD=SQRT(T(1)**2+T(2)**2+T(3)**2)
      RTMOD=1./TMOD
      DO 201 K=1,3
 201  THRUJ(K)=T(K)*RTMOD
C     PSUM=0.
C     DO 102 K=1,NTRK
C     I=INDX(K,JIN)
C     PSUM=PSUM+PMOD(I)
C102  CONTINUE
C     THJ=TMOD/PSUM
      THJ=TMOD
      RETURN
C
C   WEIGHTING
C
 543  CONTINUE
      DO 501 K=1,3
      T(K)=0.
      DO 500 I=1,NTRK
      J=INDX(I,JIN)
      T(K)=T(K)+PTH(K,I,JIN)*PMOD(J)
 500  CONTINUE
 501  CONTINUE
      GO TO 544
      END
C
C
C
C
C  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C
C
C
      SUBROUTINE RESTAR(I,J,K)
C
C
C
C ------------------------------------------------------------------
C
C     THIS SUBROUTINE GENERATES A NEW CONFIGURATION BY FIXING
C         RECONSTRUCTED AXIS K
C
C ------------------------------------------------------------------
C
      COMMON /CWORK/ PAR(3,4),PP(4,100),INUM,JWT,ICONF,POLD(3,4),TOLD,
     $ TR(4),MJET,IKONF,PMOD(100),YY(3)
C     COMMON /OLD/ POLD(3,4)
C     COMMON /MARKET/ PAR(3,4)
C     COMMON /CYYY/ YY(3)
C
      DIMENSION TEMP(3)
C
C   TEMP IS (REC JET AXIS K) CROSS (EVENT PLANE NORMAL)
C
      TEMP(1)=PAR(2,K)*YY(3)-PAR(3,K)*YY(2)
      TEMP(2)=PAR(3,K)*YY(1)-PAR(1,K)*YY(3)
      TEMP(3)=PAR(1,K)*YY(2)-PAR(2,K)*YY(1)
      A=SQRT(TEMP(1)**2+TEMP(2)**2+TEMP(3)**2)
      IF(A.EQ.0.) A=1.0
      A=1./A
      DO 26 IU=1,3
      TEMP(IU)=TEMP(IU)*A
C
C   GENERATE NEW CONFIGURATION
C
      PAR(IU,I)=(TEMP(IU)-PAR(IU,K))*0.707107
      PAR(IU,J)=(-TEMP(IU)-PAR(IU,K))*0.707107
  26  CONTINUE
      RETURN
      END
C
C
C   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
C
C
      BLOCK DATA
C
C   SET DEFAULT VALUE OF IWT
C
      COMMON /WT/ IWT
C
      DATA IWT /0/
C
      END

      FUNCTION SQTVAL(F,G,AL,EPS)
      S=(AL/F)*G
      U=-S*(AL/F)
      S=-.5*S*AL
      IF(
     - ABS(U).GT..3
     -)THEN
      IF(
     - U.LT..98
     -)THEN
            SQTVAL=F*(SQRT(1.-U)-1.)
      ELSE
            SQTVAL=0.
            PRINT 100,F,G,AL
100         FORMAT(1X,' SQTVAL',3E16.7)
      ENDIF
         RETURN
      ENDIF
      VAL=-S*(1.+.25*U+.125*U**2)
      Q=S*U**3/12.8
      N=5
15000 CONTINUE
      IF(
     - ABS(Q).GT.EPS .AND.N.LT.15
     -)THEN
         VAL=VAL-Q
         Q=Q*U*(1.-1.5/N)
         N=N+1
      GOTO 15000
      ENDIF
15001 CONTINUE
      SQTVAL=VAL
      RETURN
      END

C   20/10/81 408081453  MEMBER NAME  CMUFFL   (S)           FORTRAN
C
C LAST CHANGE 15.00 08/08/84 - CKB PWA     - ADD NALLWM,PMXFLG
C      CHANGE 15.00 03/12/83 - HUGH MCCANN - NEW LEAD GLASS PARAMETERS.
C      CHANGE 08.00 12/10/81 - HUGH MCCANN - TO ADD OVLCUT(FOR OVERLAPS)
C      CHANGE 09.33 17/06/81 - JOHN ALLISON - TO ADD RESOLUTIONS.
C
C-------------START OF MACRO CMUFFL-------------------------------------
C
      COMMON / CMUFFL / XYSTEP,RCOILI,RCOILO,PGMID,WMU,WMUSQ,DUMF1(4),
     +                  NSPECI,XPBAR,XPROT,XPION,XKAON,DUMF2(5),
     +                  TBP,GMBP,ABBP,RDBP,DEBP,
     +                  TJETI,GMJETI,ABJETI,RDJETI,DEJETI,
     +                  TJET1,GMJET1,ABJET1,RDJET1,DEJET1,
     +                  TJET2,GMJET2,ABJET2,RDJET2,DEJET2,
     +                  TJET4,GMJET4,ABJET4,RDJET4,DEJET4,
     +                  TJETO,GMJETO,ABJETO,RDJETO,DEJETO,
     +                  TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL,
     +                  ZJETE,TJETE,GMJETE,ABJETE,RDJETE,DEJETE,
     +                  ZEPLG,TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG,
     +                  RLG,ZLG,TLG,GMLG,ABLG,RDLG,DELG,
     +                  ZEP,TEP,GMEP,ABEP,RDEP,DEEP,
     +                  GMG(3),ABG(3),RDG(3),DEG(3),
     +                  VDRES,VLRES,
     +                  REST1,REST2,RESTMX,RESL,RESLMX,FACTOR,OVLCUT,
     +                  ZLGHAF,TLGHAF,ZLGC,GMLGC,ABLGC,RDLGC,DELGC,
     +                  NALLWM,PMXFLG
C
C FOR EXPLANATION SEE BLOCK DATA AFTER SUBROUTINE MUFFLE.
C
C--------------END OF MACRO CMUFFL--------------------------------------

C   15/11/83 311281210  MEMBER NAME  RADIAT   (S)           FORTRAN
      FUNCTION   RADIAT(XI)
      COMMON /CFUNK/ BT,CONS,RHS
C
C     ANALYTICAL FORM OF THE INTEGRAL OVER THE BREMSSTRAHLUNG
C     SPECTRUM, WHICH IS THE SOLUTION OF THE DIFFUSION EQUATION
C     TAKING INTO ACCOUNT MULTIPLE PHOTON EMISSION.
C     RADIAT HAS TO BE SOLVED FOR XI TO OBTAIN THE BREMS SPECTRUM.
C     THE INVERSION ROUTINE IS CALLED FROM JELOSS.
C                                    W.BARTEL     28./11./83
C
      F = XI**BT/BT - XI**(BT+1.)/(BT+1.) + 0.75/(BT+2.)*XI**(BT+2.)
      RADIAT = F * CONS - RHS
      RETURN
      END

C   07/06/96 606071822  MEMBER NAME  BINTX    (S4)          FORTG1
      SUBROUTINE BINT(NA,NB,NC,ND)
C     BOS SUBPROGRAM =1.1=
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
#include "ccs.for"
      REAL*8 DATE(2)
      EXTERNAL UCOPY2,BRNM,BCHM,BPOS,BSAW,BDLS,BDLG,BDMP,BCHL,CCHL
      LOGICAL INIT/.FALSE./
C
C     LAYOUT OF BANK COMMON/BCS/
C
C     INDEX    IW( )             I   MEANING
C     ------------------------------------------------------
C         1    IW(1)             I+  POINTER TO FIRST BANKS
C         .    ...               I
C     NAMAX    IW(NAMAX)         I
C      NFRS    SPACE FOR BANKS   I+  BANK SPACE
C              ...               I
C      NLST    SPACE FOR BANKS   I
C              NALIST(1)         I+  LIST OF NAMES
C              ...               I
C     ISLST    NALIST(NLIST)     I
C              NSLIST(1)         I+  SPECIAL LIST OF NAMES
C              ...               I
C     IMLST    NSLIST(NLIST)     I
C              NMLIST(1)         I+  MARKER FOR SPECIAL LIST
C              ...               I
C              NMLIST(NLIST)     I
C     INAMV    NAME              I+  NAME
C              NAMES(1)          I+  NAMES
C              ...               I
C     IOLST    NAMES(NAMAX)      I
C              IOLIST(1)         I+  IO-MARKER
C              ...               I
C     IPLST    IOLIST(NAMAX)     I
C              IK(1)             I+  POINTER FOR NAMES
C              ...               I
C              IK(NAMAX)         I
C              IK(NAMAX+1)       I
C              ...               I
C     NLAST    IK(NAMAX+NPRIM)   I
C
C
      IF(INIT) GOTO 100
      INIT=.TRUE.
      CALL VZERO(ICOND,80)
      CALL VZERO(IUND,11)
      NLAST=NA
      NLAST1=NLAST
      CALL VZERO(IW,NLAST)
      NRECL=4000
      IF(NB.GT.0) NRECL=NB
      NDUMP=500
      IF(NC.GT.0) NDUMP=NC
      NDUMP1=NDUMP
      NSPL=NLAST/10
      IF(ND.GT.0) NSPL=ND
      CALL DAY(DATE(1),DATE(2))
      NZT=NTIME(DUMMY)
      WRITE(6,101) DATE,NLAST,NRECL,NDUMP,NSPL
      NAMAX=200
      NLIST=100
      NERRL=10
      NEOTP=2
      MARKWR=-1
      GOTO 10
C
      ENTRY BINT1(NA,NB,NC,ND)
C
      NAMAX=MAX0(10,NA)
      NLIST=MAX0(10,NB)
      NERRL=MAX0( 0,NC)
      NEOTP=ND
      WRITE(6,102) NAMAX,NLIST,NERRL,NEOTP
C
   10 NPRIM=(NAMAX/2)*2-1
   12 NPRIM=NPRIM+2
      J    =SQRT(FLOAT(NPRIM))
      DO 14 K=3,J,2
      L    =NPRIM/K
      IF(L*K.EQ.NPRIM) GOTO 12
   14 CONTINUE
C
      NAMAX1=NAMAX+1
      IPLST=NLAST-NAMAX-NPRIM
      IOLST=IPLST-NAMAX
      INAMV=IOLST-NAMAX
      IMLST=INAMV-NLIST-1
      ISLST=IMLST-NLIST
      NFRS =NAMAX1
      NEXT =NFRS
      NLST =ISLST-NLIST
      ILOW=NLST
      GOTO 100
C
  100 RETURN
C
  101 FORMAT(/'0START/BANK ORGANISATION PROGRAM   -   JOB DATE ',A8,
     1   ' TIME ',A8/'0',6X,'CALL BINT(',I6,',',5X,'NR OF WORDS IN'
     2 ,' COMMON/BCS/'/17X,I6,',',5X,'MAX NR OF WORDS ALLOWED IN A ',
     3   'BANK-RECORD'/17X,I6,',',5X,'NR OF WORDS PRINTED IN A DUMP'/
     4   17X,I6,')',5X,'NR OF WORDS FOR LOW PRIORITY BANK SPACE'/)
  102 FORMAT('0',5X,'CALL BINT1(',I6,',',5X,'MAX NR OF NAMES'/
     1  17X,I6,',',5X,'MAX LENGTH OF LIST OF NAMES'/
     2  17X,I6,',',5X,'MAX NR OF READ ERRORS'/
     3  17X,I6,')',5X,'MAX NR OF LISTINGS FOR INPUT-BANK ERRORS'/)
      END
      SUBROUTINE BDMPA(IARG)
#include "acs.for"
      ICOND=IARG
      CALL BDMP
      RETURN
      END

C   19/02/84 409061158  MEMBER NAME  BANKPR2  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE BANKPR 
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL     ?     :  PRINT BOS BANK NAMES OR CONTENTS.
C
C        MOD: J. OLSSON   15/11/83 :
C        MOD: C. BOWDERY  14/02/84 :  RESOLVE PROBLEM WITH DELETED BANKS
C   LAST MOD: C. BOWDERY  14/02/84 :  NAMES PRINTED BY S/R EVBKPR
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C PMF 03.11.98 
      LOGICAL TBIT
C
      REAL*8 DATE,TIME
C
#include "cgraph.for"
#include "cdata.for"
C
      COMMON / CWORK  / HDUM(8000),
     +                  HADC(2,42),HTDC(2,42),HTDC1(2,42),HADCF(2,16),
     +                  HTDCF(2,16),HTSPAR(16)
      COMMON / CWORK1 / HWORK(70),DATE,TIME
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION HDSPL(68),HSYM(10),HDATSV(22),HTX(6),HTM1(4),HTM2(4)
      DIMENSION NAMES(20),HSX(13,16),HELP(2)
      DIMENSION HSY(13,16)
C
      EQUIVALENCE (IZWORD,HELP(1))
      EQUIVALENCE (HWORK(1),NAME)
      EQUIVALENCE (HWORK(3),HDSPL(1))
      EQUIVALENCE (HDATSV(1),IDATSV(1)),(DATE,HTM1(1)),(TIME,HTM2(1))
C
      DATA NAMES/'JETC','PATR','TAGC','JHTL','ZETC','GVTX','DEDX',
     $ 'ZVTX','LGCL','TOFR','TPEV','TPTR','ATOF','TPVX','VECT','TRIG',
     $ 'N50S','MPRS','BK17','ZTRG'/
C
      DATA HSYM /'0 ','1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 '/
      DATA HBLANK/'  '/,HMINUS/'- '/, NNAMES /20/,MASKMH/Z001F/
      DATA HTX /'DS','N ','DA','TE','TI','ME'/
C
      DATA HSX/
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'*M','UL','TI','HA','DR','ON','IC',' E','VE','NT','**','  ','  ',
     $'*N','ON','-B','AR','RE','L ','BH','AB','HA',' E','VE','NT','**',
     $'*B','AR','RE','L ','BH','AB','HA',' E','VE','NT','**','  ','  ',
     $'*2','-P','HO','TO','N ','EV','EN','T*','* ','  ','  ','  ','  ',
     $'*M','UO','N-','PA','IR',' E','VE','NT','**','  ','  ','  ','  ',
     $'*B','EA','M-','BE','AM',' E','VE','NT','**','  ','  ','  ','  ',
     $'*C','OS','MI','C ','EV','EN','T*','* ','  ','  ','  ','  ','  ',
     $'*B','EA','M-','GA','S ','EV','EN','T*','* ','  ','  ','  ','  ',
     $'*H','AL','O ','EV','EN','T*','* ','  ','  ','  ','  ','  ','  ',
     $'*L','UM','I ','EV','EN','T*','* ','  ','  ','  ','  ','  ','  ',
     $'*U','NI','DE','NT','IF','IE','D ','EV','EN','T*','* ','  ','  ',
     $'*R','EJ','EC','TE','D ','EV','EN','T*','* ','  ','  ','  ','  '/
C
      DATA HSY/
     $'UN','EX','PE','CT','ED',' I','NT','ER','RU','PT',' N','-3','  ',
     $'UN','EX','PE','CT','ED',' I','NT','ER','RU','PT',' N','-2','  ',
     $'NO','N ','IN','CR','EA','SI','NG',' W','IR','E-','NU','MB','ER',
     $'IL','LE','GA','L ','HI','T ','CO','UN','TE','R ','  ','  ','  ',
     $'NE','GA','TI','VE',' D','AT','A ','FO','UN','D ','  ','  ','  ',
     $'JE','TC',' B','AN','K ','LO','NG','ER',' T','HA','N ','40','00',
     $'WI','RE',' N','UM','BE','R ','GR','EA','TE','R ','15','36','  ',
     $'NO',' H','IT','S ','IN',' R','IN','G2','  ','  ','  ','  ','  ',
     $'LA','ST',' C','EL','L ','IN',' R','IN','G ','IN','CO','MP','L.',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'T2','  ','RE','JE','CT','  ','  ','  ','  ','  ','  ','  ','  ',
     $'Z-','VE','RT','EX',' R','EJ','EC','T ','  ','  ','  ','  ','  ',
     $'  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ','  ',
     $'AC','TU','AL','LY',' R','EJ','EC','TE','D ','BY',' N','10','  '/
*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHWORK*140,cHDSPL*136
      EQUIVALENCE (cHWORK,HWORK(1)),(cHDSPL,HDSPL(1))
*** PMF(end)
C
C------------------  C O D E  ------------------------------------------
C
      NN = ACMD
      IF( NN .GE. 0 ) GO TO 1803
C
C                            NEGATIVE INDEX --> PRINT BOS BANK NAMES
C
      CALL EVBKPR(ICODE)
      IF( ICODE .EQ. 0 ) RETURN
      CALL TRMOUT(80,'ERROR IN BMRT (CURRENT LIST), CALLED IN BANKPR^')
      RETURN
C
1803  CALL TRMOUT(80,' * * PLEASE ENTER NAME OF DESIRED BANK.^')
      CALL TRMIN(4,NAMEB)
      IBANK=IBLN(NAMEB)
      IPBANK=IDATA(IBANK)
200   LIM1=IPBANK-2
210   IF(LIM1.GE.1) GO TO 3
35    CALL TRMOUT(80,'THE BANK IS EMPTY OR DOES NOT EXIST.^')
      RETURN
C** CHECK IF MORE THAN ONE BANK WITH SAME NAME; IF SO, REQUEST NUMBER.
3     IF(IDATA(LIM1+1).EQ.0) GO TO 300
      IF(NAMEB.EQ.NAMES(15)) GO TO 300
      CALL TRMOUT(80,'FOLLOWING BOS BANK NRS ARE PRESENT:^')
      LM1 = LIM1
3332  CALL DIAGIN('                    ',1,IDATA(LM1),N,N,N,N,N)
      IF(IDATA(LM1+1).EQ.0) GO TO 3333
      LM1 = IDATA(LM1+1)-2
      GO TO 3332
3333  CALL TRMOUT(80,'PLEASE ENTER DESIRED BOS BANK NUMBER.^')
      NBOS = TERNUM(DUMMY)
33    IF(NBOS.EQ.IDATA(LIM1)) GO TO 300
      IF(IDATA(LIM1+1).NE.0) GO TO 34
      GO TO 35
34    LIM1 = IDATA(LIM1+1) - 2
      GO TO 33
300   CALL ERASE
      IRETUR = 1
C********************** WRITE CAPTION
      CALL HOME
      CALL CHRSIZ(4)
      HWORK(1) = HTX(1)
      HWORK(2) = HTX(2)
      HWORK(3) = HBLANK
      DO 4988  I = 1,22
4988  HWORK(I+3) = HDATSV(I)
      CALL EOUTST(50,HWORK)
      KCNT=0
      IHEAD=IBLN('HEAD')
      IPHEAD=IDATA(IHEAD)
      IHHEAD=2*IPHEAD
      DO 5001 III=1,3
      IF(III.EQ.1) NUMCAP=HDATA(IHHEAD+10)
      IF(III.EQ.2) NUMCAP=HDATA(IHHEAD+11)
      IF(III.EQ.3) NUMCAP=ICREC
      IF(NUMCAP.LT.0) KCNT=KCNT+1
      IF(NUMCAP.LT.0) HWORK(KCNT)=HMINUS
      NUMCAP=IABS(NUMCAP)
      NDIG=1
      ACAP=NUMCAP
      IF(NUMCAP.GT.0) NDIG=1+ALOG10(ACAP+0.001)
      IF(NDIG.GT.8) NDIG=8
      DO 5002 JJJ=1,NDIG
      KKK=KCNT+NDIG-JJJ+1
      NTEN=NUMCAP/10
      IDIG=NUMCAP-10*NTEN
      HWORK(KKK)=HSYM(IDIG+1)
      NUMCAP=NTEN
 5002 CONTINUE
      KCNT=KCNT+NDIG
      IF(III.LT.3) KCNT=KCNT+1
      IF(III.LT.3) HWORK(KCNT)=HBLANK
 5001 CONTINUE
      KCNT = 2*KCNT
      CALL NEWLIN
      CALL EOUTST(KCNT,HWORK)
5118  CONTINUE
C WRITE DATE AND TIME
      CALL DAY(DATE,TIME)
      HWORK(1) = HTX(3)
      HWORK(2) = HTX(4)
      HWORK(3) = HBLANK
      DO 4987  I = 1,4
4987  HWORK(I+3) = HTM1(I)
      CALL NEWLIN
      CALL EOUTST(14,HWORK)
      HWORK(1) = HTX(5)
      HWORK(2) = HTX(6)
      HWORK(3) = HBLANK
      DO 4986  I = 1,4
4986  HWORK(I+3) = HTM2(I)
      CALL NEWLIN
      CALL EOUTST(14,HWORK)
      CALL NEWLIN
      CALL CHRSIZ(3)
      CALL NEWLIN
C****************************** WRITE BANK HEADER
      LIM2=LIM1+3
      LIMX = LIM2-1
      LIMHX = 2*LIMX
      NAME=IDATA(LIM1-1)
      CALL CORE(HDSPL,76)
      WRITE(cHDSPL,9001)
     +     (IDATA(LHO),LHO=LIM1,LIMX),(HDATA(LIMHX+J),J=1,2)! PMF 17/11/99: UNIT=10 -> UNIT=cHDSPL
 9001 FORMAT(3I10,2I10)
      CALL EOUTST(80,HWORK)
      CALL NEWLIN
C     CALL PROMPT
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
      CALL CHRSIZ(4)
      CALL CSIZE(IX,IXT)
      SIZE = IXT*.8
      DEL = 1.7*SIZE
C****************************** WRITE BANK CONTENT
      NWO = IDATA(LIM2-1) - 1
      LENGB=2*NWO
      NCYCLE=1+(LENGB-1)/20
      INNAM = 0
      DO 1473  INN = 1,NNAMES
      IF(NAMEB.NE.NAMES(INN)) GO TO 1473
      INNAM = INN
      GO TO 1474
1473  CONTINUE
      GO TO 1092
1474  GO TO (2001,877,1092,1092,5177,1277,1377,1577,1677,1977,2077,2177,
     $ 3177,4177,277,1092,3235,1940,2240,2550), INNAM
C-------------- NORMAL PRINT OF BANKS, INTEGER*2 OR Z4 FORMAT
1092  CONTINUE
      DO 9010 LHO=1,NCYCLE
9006  YS = YS - DEL
      IF(YS.GT.50.) GO TO 9012
      IRETUR = 4
      GO TO 9965
9012  LIML=2*LIM2+20*(LHO-1)+1
      LIMU = LIML + 19
      IF(LIMU.GT.(2*LIM2+LENGB)) LIMU=2*LIM2+LENGB
      ILIM = LIMU - LIML + 1
      IF(ILIM.LE.0) GO TO 9020
      DO 9025  I = 1,ILIM
      LLO = LIML + I - 1
9025  HWORK(I+100) = HDATA(LLO)
      IILIM = 6*ILIM + 1
      CALL CORE(HWORK,IILIM)
      IF(NAMEB.NE.NAMES(3).AND.NAMEB.NE.NAMES(4).AND.NAMEB.NE.NAMES(16))
     $ WRITE(cHWORK,9011) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
      IF(NAMEB.EQ.NAMES(3).OR.NAMEB.EQ.NAMES(4).OR.NAMEB.EQ.NAMES(16))
     $ WRITE(cHWORK,9111) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
 9011 FORMAT(' ',20I6)
 9111 FORMAT(' ',20(Z4,2X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 9010 CONTINUE
      GO TO 9020
C____________________________ SPECIAL FORMAT FOR JETC BANK
2001  LENGB = LENGB + 2
      NCYCLE=1+(LENGB-1)/20
      LENGB = LENGB - 2
      DO 8010 LHO=1,NCYCLE
8006  YS = YS - DEL
      IF(YS.GT.50.) GO TO 8012
      IRETUR = 5
      GO TO 9965
8012  LIML=2*LIM2+20*(LHO-1)+1
      IF(LHO.GT.5) LIML = LIML - 2
      LIMU = LIML + 19
      IF(LHO.EQ.5) LIMU = LIMU - 2
      IF(LIMU.GT.(2*LIM2+LENGB)) LIMU=2*LIM2+LENGB
      ILIM = LIMU - LIML + 1
      IF(ILIM.LE.0) GO TO 9020
      DO 8025  I = 1,ILIM
      LLO = LIML + I - 1
8025  HWORK(I+100) = HDATA(LLO)
      IF(LHO.LE.5) GO TO 8026
      DO 8027  I = 1,ILIM,4
      IX = HWORK(I+100)
      IX = ISHFTR(IX,3)
8027  HWORK(I+100) = IX
8026  IILIM = 6*ILIM + 1
      CALL CORE(HWORK,IILIM)
      WRITE(cHWORK,9011) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 8010 CONTINUE
      GO TO 9020
C--------------- SPECIAL FORMAT FOR ATOF BANK
3177  IPTOF = LIM2-1
      CALL AGRPR(IPTOF,&3173)
      GO TO 3174
3173  WRITE(6,3175)
3175  FORMAT(' ATFUGR ERROR, WRONG BANK DESCRIPTOR...' )
      RETURN
3174  CALL CORE(HWORK,107)
      WRITE(cHWORK,3181) ! PMF 17/11/99: JUSCRN changed to cHWORK
3181  FORMAT(' NR   ADC(L)  ADC(R)   TDC(L)  TDC(R)   TDC1(L)  TDC1(R)
     $ ADCF(L)  ADCF(R)   TDCF(L)  TDCF(R)   TDC(SPARE)')
      CALL SYSSYM(XS,YS,SIZE,HWORK,107,0.)
      YS = YS - .9*DEL
      DO 3178  I = 1,42
      IF(I.GT.16) GO TO 3179
      CALL CORE(HWORK,106)
      WRITE(cHWORK,3185) I,(HADC(J,I),J=1,2),(HTDC(J,I),J=1,2), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $(HTDC1(J,I),J=1,2),(HADCF(J,I),J=1,2),(HTDCF(J,I),J=1,2),HTSPAR(I)
3185  FORMAT(' ',I2,2X,I6,2X,I6,3X,I6,2X,I6,3(3X,I7,2X,I7),3X,I10)
      CALL SYSSYM(XS,YS,SIZE,HWORK,106,0.)
      GO TO 3186
3179  CALL CORE(HWORK,55)
      WRITE(cHWORK,3187) I,(HADC(J,I),J=1,2),(HTDC(J,I),J=1,2), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ (HTDC1(J,I),J=1,2)
3187  FORMAT(' ',I2,2X,I6,2X,I6,3X,I6,2X,I6,3X,I7,2X,I7)
      CALL SYSSYM(XS,YS,SIZE,HWORK,55,0.)
3186  YS = YS - .9*DEL
      IF(MOD(I,10).EQ.0) YS = YS -.2*DEL
3178  CONTINUE
      GO TO 9020
C--------------- SPECIAL FORMAT FOR VECT BANK
C-  FIRST VECT 0, THEN VECT 1 IF IT EXISTS
C-
277   IVPS = 0
      LIM2 = LIM2 - 1
2782  LO = IDATA(LIM2+1)
      LTR = IDATA(LIM2+2)
      NTR = IDATA(LIM2+4)
      IPO = LIM2 + LO
      CALL CORE(HWORK,106)
      WRITE(cHWORK,278) (IDATA(LIM2+II),II=1,LO) ! PMF 17/11/99: JUSCRN changed to cHWORK
278   FORMAT('  ',6I8,2F8.4,5I8)
      LOO = LO*8+2
      CALL SYSSYM(XS,YS,SIZE,HWORK,LOO,0.)
      LO1 = MIN0(12,LO)
      IF(LO1.LT.7) GO TO 2791
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(cHWORK,178) (ADATA(LIM2+II),II=7,LO1) ! PMF 17/11/99: JUSCRN changed to cHWORK
178   FORMAT(' HEADER WORDS 7-.. ',6E14.6)
      LOO = (LO1-6)*14+19
      CALL SYSSYM(XS,YS,SIZE,HWORK,LOO,0.)
2791  ICNT = 0
279   ICNT = ICNT + 1
      IF(ICNT.GT.NTR.AND.IVPS.EQ.1) GO TO 9020
      IF(ICNT.GT.NTR.AND.IVPS.EQ.0) GO TO 2781
275   YS = YS - DEL
      IF(YS.GT.50.) GO TO 276
      IRETUR = 3
      GO TO 9965
276   IPP = IPO + (ICNT-1)*LTR
      IF(LTR.EQ.10) CALL CORE(HWORK,95)
      IF(LTR.EQ.12) CALL CORE(HWORK,115)
      IF(LTR.EQ.10)
     1  WRITE(cHWORK,274) (ADATA(IPP+I),I=1,5),(IDATA(IPP+I),I=6,7), ! PMF 17/11/99: JUSCRN changed to cHWORK
     2 (ADATA(IPP+I),I=8,10)
274   FORMAT(' ',4F10.4,2X,F10.6,2X,2I4,2X,3F10.3)
      IF(LTR.EQ.12)
     1  WRITE(cHWORK,284) (ADATA(IPP+I),I=1,5),(IDATA(IPP+I),I=6,7), ! PMF 17/11/99: JUSCRN changed to cHWORK
     2 (ADATA(IPP+I),I=8,10),HDATA(2*IPP+21),HDATA(2*IPP+22),
     3  ADATA(IPP+12)
284   FORMAT(' ',4F10.4,2X,F10.6,2X,2I4,2X,3F10.3,2I5,F10.2)
      IF(LTR.EQ.10) CALL SYSSYM(XS,YS,SIZE,HWORK,95,0.)
      IF(LTR.EQ.12) CALL SYSSYM(XS,YS,SIZE,HWORK,115,0.)
      GO TO 279
2781  CONTINUE
      LIM2 = IDATA(LIM2-1)
      IF(LIM2.LT.1) GO TO 9020
      IVPS = 1
C* WRITE BANK HEADER FOR VECT 1
      CALL NEWLIN
      CALL NEWLIN
      LIM1=LIM2-2
      LIMX = LIM2
      LIMHX = 2*LIMX
      NAME=IDATA(LIM2-3)
      CALL CORE(HDSPL,76)
      WRITE(cHDSPL,9001)
     +   (IDATA(LHO),LHO=LIM1,LIMX),(HDATA(LIMHX+J),J=1,2) ! PMF 17/11/99: UNIT=10 -> UNIT=cHDSPL
      CALL EOUTST(80,HWORK)
      CALL NEWLIN
      CALL SEELOC(IXT,IYT)
      XS = IXT
      YS = IYT
      CALL CHRSIZ(4)
      CALL CSIZE(IX,IXT)
      GO TO 2782
C--------------- SPECIAL FORMAT FOR TPVX BANK
4177  LIM2 = LIM2 - 1
      LIMLIM = 2*LIM2
      CALL CORE(HWORK,13)
      WRITE(cHWORK,4178) HDATA(LIMLIM+1),HDATA(LIMLIM+2) ! PMF 17/11/99: JUSCRN changed to cHWORK
4178  FORMAT(' ',I4,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,13,0.)
      YS = YS - DEL
      CALL CORE(HWORK,108)
      WRITE(cHWORK,4179) (ADATA(LIM2+1+I),I=1,7),IDATA(LIM2+9), ! PMF 17/11/99: JUSCRN changed to cHWORK
     1 ADATA(LIM2+10)
4179  FORMAT(' ',3E12.4,2X,3E12.4,2X,E12.4,I4,3X,E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,108,0.)
      YS = YS - DEL
      CALL CORE(HWORK,51)
      WRITE(cHWORK,4175) (HDATA(LIMLIM+20+I),I=1,10) ! PMF 17/11/99: JUSCRN changed to cHWORK
4175  FORMAT(' ',10I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,51,0.)
      MULSEC = HDATA(LIMLIM+22)
      IF(MULSEC.LE.0) GO TO 9020
      IVX = 30
4171  IVX1 = 20
      IF(MULSEC+30.LT.IVX+IVX1) IVX1 = MULSEC+30-IVX
      YS = YS - DEL
      CALL CORE(HWORK,101)
      WRITE(cHWORK,4174) (HDATA(LIMLIM+IVX+I),I=1,IVX1) ! PMF 17/11/99: JUSCRN changed to cHWORK
4174  FORMAT(' ',20I5)
      LIMLO = IVX1*5 + 1
      CALL SYSSYM(XS,YS,SIZE,HWORK,LIMLO,0.)
      IVX = IVX + 20
      IF(IVX.GT.30+MULSEC) GO TO 9020
      GO TO 4171
C--------------- SPECIAL FORMAT FOR PATR BANKS
877   LIM2 = LIM2 - 1
      LO = IDATA(LIM2+1)
      NTR = IDATA(LIM2+2)
      LTR = IDATA(LIM2+3)
      IPO = LIM2 + LO
      CALL CORE(HWORK,72)
      WRITE(cHWORK,878) (IDATA(LIM2+II),II=1,LO) ! PMF 17/11/99: JUSCRN changed to cHWORK
878   FORMAT('  ',3I5,2X,Z8,3I5,2X,Z8,4I5)
      LO = LO*5+12
      CALL SYSSYM(XS,YS,SIZE,HWORK,LO,0.)
      IF(NTR.GT.100) RETURN
      ICNT = 0
879   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 9020
875   YS = YS - DEL
      IF(YS.GT.50.) GO TO 876
      IRETUR = 2
      GO TO 9965
876   IPP = IPO + (ICNT-1)*LTR
      CALL CORE(HWORK,123)
      WRITE(cHWORK,679) IDATA(IPP+1),(HDATA(IPP*2+I),I=3,4), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ (IDATA(IPP+I),I=3,4),(ADATA(IPP+I),I=5,10),
     1                  IDATA(IPP+11),(ADATA(IPP+I),I=12,17)
679   FORMAT(' ',I2,1X,2(Z2,2X),I5,I3,2X,2F8.3,F10.3,3F7.3,2X,I3,2X,
     1 2F8.3,F10.3,3F7.3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,123,0.)
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(cHWORK,873) IDATA(IPP+18),(ADATA(IPP+I),I=19,23), ! PMF 17/11/99: JUSCRN changed to cHWORK
     1                  IDATA(IPP+24),(ADATA(IPP+I),I=25,28),
     2                  IDATA(IPP+29),(ADATA(IPP+I),I=30,32),
     3                  IDATA(IPP+33)
873   FORMAT(' ',I2,1X,F10.6,2F8.3,F10.6,F8.3,I3,1X,4F10.6,I2,1X,F10.2,
     1 2F8.2,I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(cHWORK,872) (IDATA(IPP+I),I=34,48),HDATA(1+2*(IPP+1)), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ HDATA(2+2*(IPP+1))
872   FORMAT('  ',14I6,2X,Z8,2X,' VECTNR',I4,' PART.TYPE',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      GO TO 879
1277  CONTINUE
C--------------- SPECIAL FORMAT FOR GVTX BANKS
      NV = IDATA(LIM2)
      IPO = LIM2
      DO 1278  INV = 1,NV
      IPO = LIM2+(INV-1)*10
      CALL CORE(HWORK,72)
      WRITE(cHWORK,1279) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ +8),ADATA(IPO+9),IDATA(IPO+10)
1279  FORMAT(' ',I3,3F8.2,3F8.2,I4,F8.2,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,72,0.)
1278  YS = YS - DEL
      NT = IDATA(IPO+11)
      CALL CORE(HWORK,4)
      WRITE(cHWORK,1280) NT ! PMF 17/11/99: JUSCRN changed to cHWORK
1280  FORMAT(' ',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,4,0.)
      YS = YS - DEL
      IPO = IPO + 11 - 15
      DO 1281  INT = 1,NT
      IPO = IPO+15
      CALL CORE(HWORK,64)
      WRITE(cHWORK,1282) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,8) ! PMF 17/11/99: JUSCRN changed to cHWORK
1282  FORMAT(' ',I3,F8.2,2F7.3,3F8.2,2F7.3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,64,0.)
      YS = YS - DEL
      CALL CORE(HWORK,42)
      WRITE(cHWORK,1285) (ADATA(IPO+1+JJ),JJ=9,11), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ IDATA(IPO+13),IDATA(IPO+14),ADATA(IPO+15)
1285  FORMAT(' ',3F8.2,I4,I3,F10.2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,42,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1281
      IRETUR = 6
      GO TO 9965
1286  CONTINUE
1281  CONTINUE
      GO TO 9020
1377  CONTINUE
C--------------- SPECIAL FORMAT FOR DEDX BANKS
      NTR = IDATA(LIM2+1)
      CALL CORE(HWORK,4)
      WRITE(cHWORK,1380) NTR ! PMF 17/11/99: JUSCRN changed to cHWORK
1380  FORMAT(' ',I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,4,0.)
      NTR = MIN0(NTR,60)
      YS = YS - DEL
      DO 1378  ITR = 1,NTR
      IPO = LIM2+1+(ITR-1)*10
      CALL CORE(HWORK,82)
      WRITE(cHWORK,1379) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ +8),ADATA(IPO+9)
1379  FORMAT(' ',I3,2F8.2,4E12.4,I4,F10.3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,82,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1378
      IRETUR = 7
      GO TO 9965
1376  CONTINUE
1378  CONTINUE
      GO TO 9020
1977  CONTINUE
C--------------- SPECIAL FORMAT FOR TOFR BANKS
      NTR = IDATA(LIM2)
      LIM2 = LIM2 - 1
      CALL CORE(HWORK,17)
      WRITE(cHWORK,1980) (IDATA(LIM2+I),I=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
1980  FORMAT(' ',4I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,17,0.)
      YS = YS - DEL
      DO 1978  ITR = 1,NTR
      IPO = LIM2+4+(ITR-1)*14
      CALL CORE(HWORK,118)
      WRITE(cHWORK,1979) (IDATA(IPO+I),I=1,3),(ADATA(IPO+I),I=4,14) ! PMF 17/11/99: JUSCRN changed to cHWORK
1979  FORMAT(' ',3I3,F8.2,F8.0,4F8.2,4F12.3,F12.0)
      CALL SYSSYM(XS,YS,SIZE,HWORK,118,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1978
      IRETUR = 9
      GO TO 9965
1976  CONTINUE
1978  CONTINUE
      GO TO 9020
1677  CONTINUE
C--------------- SPECIAL FORMAT FOR LGCL BANKS
      LIM2 = LIM2 - 1
      CALL CORE(HWORK,29)
      WRITE(cHWORK,1680) (IDATA(LIM2+LL),LL=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
1680  FORMAT(' ',4I7)
      CALL SYSSYM(XS,YS,SIZE,HWORK,29,0.)
      LIM2 = LIM2 + 4
      YS = YS - DEL
      CALL CORE(HWORK,118)
      WRITE(cHWORK,1681) (IDATA(LIM2+LL),LL=1,6),(ADATA(LIM2+LL),LL=7,1000052800 ! PMF 17/11/99: JUSCRN changed to cHWORK
     $),IDATA(LIM2+11),(ADATA(LIM2+LL),LL=12,15),(IDATA(LIM2+L),L=16,21)
1681  FORMAT(' ',I3,I9,4I4,4F8.3,I4,4F8.3,2I3,I6,3I3)
      CALL SYSSYM(XS,YS,SIZE,HWORK,118,0.)
      NCLST = IDATA(LIM2+3)
      NWPCL = IDATA(LIM2+21)
      ILABEL = IDATA(LIM2+17)
      NCLS2 = NCLST*2+ 2
      LIM2 = LIM2 + 21
      LIM22 = 2*LIM2
      YS = YS - DEL
      CALL CORE(HWORK,101)
      WRITE(cHWORK,1682) ((HDATA(LIM22+L),HDATA(LIM22+L+1)),L=1,NCLS2,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
1682  FORMAT(' ',20I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,101,0.)
      IF(NCLST.LE.0) GO TO 9020
      LIM2 = LIM2 + NCLST + 1
      YS = YS - DEL
      DO 1678  ITR = 1,NCLST
      IPO = LIM2+(ITR-1)*NWPCL
      CALL CORE(HWORK,119)
C     IF(ILABEL.EQ.2)
      WRITE(cHWORK,1679) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ +8),(ADATA(IPO+JJ),JJ=9,NWPCL)
1679  FORMAT(' ',I3,2F8.3,2F9.2,2F8.3,I4,4F8.3,F10.3,2F6.3,F7.3)
C     IF(ILABEL.EQ.1)
C    $WRITE(JUSCRN,1675) IDATA(IPO+1),(ADATA(IPO+1+JJ),JJ=1,6),IDATA(IPO
C    $ +8),(ADATA(IPO+8+JJ),JJ=1,6),IDATA(IPO+15)
C1675  FORMAT(' ',I3,2F8.3,2F9.2,2F8.3,I4,6F9.3,I11)
      CALL SYSSYM(XS,YS,SIZE,HWORK,119,0.)
      YS = YS - DEL
      IF(YS.GT.80.) GO TO 1678
      IRETUR = 8
      GO TO 9965
1676  CONTINUE
1678  CONTINUE
      GO TO 9020
2240  CONTINUE
C--------------- SPECIAL FORMAT FOR FAMP BANKS (NOW TEMPORARILY BK17)
      LIM2 = LIM2 - 1
      LH2 = LIM2*2
      YS = YS - DEL
      CALL CORE(HWORK,28)
      WRITE(cHWORK,2241) HDATA(LH2+3) ! PMF 17/11/99: JUSCRN changed to cHWORK
2241  FORMAT(' FAMP PROGRAM VERSION ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
C TRIGGERS
      NTRI = HDATA(LH2+4)
      IF(NTRI.GT.0) GO TO 2242
C      YS = YS - DEL
C      CALL CORE(HWORK,28)
C      WRITE(cHWORK,2243) ! PMF 17/11/99: JUSCRN changed to cHWORK
C2243  FORMAT(' ---> NO TRIGGER INFORMATION')
C      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
       GO TO 2244
2242  YS = YS - DEL
      CALL CORE(HWORK,77)
      WRITE(cHWORK,2245) (HDATA(LH2+NTRI+K),K=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
2245  FORMAT(' #T2 TRACKS ',I3,' R3 TRACKS CELLS 33-48 ',Z4,'  CELLS 17-
     $32 ',Z4,'  CELLS 1-16 ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,77,0.)
C COUNTERS
2244  NCOU = HDATA(LH2+5)
      IF(NCOU.GT.0) GO TO 2246
C     YS = YS - DEL
C     CALL CORE(HWORK,28)
C     WRITE(cHWORK,2247) ! PMF 17/11/99: JUSCRN changed to cHWORK
C2247  FORMAT(' ---> NO COUNTER INFORMATION')
C     CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
      GO TO 2248
2246  AA = HDATA(LH2+NCOU+2)*.1
      YS = YS - DEL
      CALL CORE(HWORK,53)
      WRITE(cHWORK,2249) HDATA(LH2+NCOU+1),AA,HDATA(LH2+NCOU+3), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ HDATA(LH2+NCOU+4)
2249  FORMAT(' #TOFS ',I3,' TDIF(NS) ',F8.1,' ZVTOF ',I6,' ZVLG ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,53,0.)
C LEAD GLASS
2248  NL = HDATA(LH2+6)
      IF(NL.GT.0) GO TO 2250
C      YS = YS - DEL
C      CALL CORE(HWORK,31)
C      WRITE(cHWORK,2251) ! PMF 17/11/99: JUSCRN changed to cHWORK
C2251  FORMAT(' ---> NO LEAD GLASS INFORMATION')
C      CALL SYSSYM(XS,YS,SIZE,HWORK,31,0.)
      GO TO 2252
2250  AA1 = HDATA(LH2+NL+5)*.001
      AA2 = HDATA(LH2+NL+6)*.001
      AA3 = HDATA(LH2+NL+7)*.001
      AA4 = HDATA(LH2+NL+8)*.001
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(cHWORK,2253) (HDATA(LH2+NL+K),K=1,4),AA1,AA2,AA3,AA4, ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ (HDATA(LH2+NL+KK),KK=9,10)
2253  FORMAT(' NR CLUSTERS TOTAL,BARREL,-EC,+EC : ',4I5,' ENERGIES: ',
     $4F8.3,' NHCLI ',I6,' ERES ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
C INNER DETECTOR ANALYSIS
2252  ND = HDATA(LH2+7)
      IF(ND.GT.0) GO TO 2254
      YS = YS - DEL
      CALL CORE(HWORK,35)
      WRITE(cHWORK,2255) ! PMF 17/11/99: JUSCRN changed to cHWORK
2255  FORMAT(' ---> NO INNER DETECTOR INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,35,0.)
      GO TO 2256
2254  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(cHWORK,2257) (HDATA(LH2+ND+K),K=1,3) ! PMF 17/11/99: JUSCRN changed to cHWORK
2257  FORMAT(' ID ZVTX FLAG ',I3,'  ZVTX IN MM ',I6,' INRGZV ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
      YS = YS - DEL
      INRGZV = HDATA(LH2+ND+3)
      NTR = HDATA(LH2+ND+4)
      NTRT = HDATA(LH2+ND+5)
      CALL CORE(HWORK,49)
      IF(NTR.LT.0) WRITE(cHWORK,2258) ! PMF 17/11/99: JUSCRN changed to cHWORK
2258  FORMAT(' PATTERN RECOGNITION NOT PERFORMED              ')
      IF(NTR.EQ.0) WRITE(cHWORK,2259) ! PMF 17/11/99: JUSCRN changed to cHWORK
2259  FORMAT(' PATTERN RECOGNITION PERFORMED, NO TRACKS FOUND ')
      IF(NTR.LE.0) CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      IF(NTR.LE.0) GO TO 2256
      WRITE(cHWORK,2260) NTRT,NTR ! PMF 17/11/99: JUSCRN changed to cHWORK
2260  FORMAT(' PATREC PERFORMED,',I3,' TRACKS FOUND',I3,' TRACK BANKS')
      CALL SYSSYM(XS,YS,SIZE,HWORK,49,0.)
      LORT = HDATA(LH2+ND+6)
      LTRT = HDATA(LH2+ND+7)
      MWR1 = HDATA(LH2+ND+8)
      MWR2 = HDATA(LH2+ND+9)
      MWR3 = HDATA(LH2+ND+10)
      IEFA = HDATA(LH2+ND+11)
      IPLT = LH2+ND+LORT-LTRT
      YS = YS - DEL
      CALL CORE(HWORK,102)
      WRITE(cHWORK,2261) NTRT,LORT,LTRT,MWR1,MWR2,MWR3,IEFA ! PMF 17/11/99: JUSCRN changed to cHWORK
2261  FORMAT(' TRACKS LISTED ',I4,'  LO AND LT FOR EACH ',2I4,
     $' NR WORDS MAP RING1-3: ',3I5,' ERROR FLAG ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,102,0.)
C
      DO 2262  ITR = 1,NTR
      IPLT = IPLT + LTRT
      IFTR = HDATA(IPLT)
      RR1 = HDATA(IPLT+1)*.1
      FI1 = HDATA(IPLT+2)
      Z1 = HDATA(IPLT+3)*.1
      RR2 = HDATA(IPLT+4)*.1
      FI2 = HDATA(IPLT+5)
      Z2 = HDATA(IPLT+6)*.1
      HELP(1) = HDATA(IPLT+8)
      HELP(2) = HDATA(IPLT+9)
      RR = FLOAT(IZWORD)*.1
      SIGXY = HDATA(IPLT+10)*.01
      NXY = HDATA(IPLT+11)
      TANTH = HDATA(IPLT+12)*001
      Z0 = HDATA(IPLT+13)*.1
      SIGZ = HDATA(IPLT+14)*.1
      NZ = HDATA(IPLT+15)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2199
      IRETUR = 11
      GO TO 9965
2199  CONTINUE
      CALL CORE(HWORK,120)
      WRITE(6,2263) ITR,IFTR,RR1,FI1,Z1,RR2,FI2,Z2,RR,SIGXY,NXY
2263  FORMAT(' ',I2,' SEC. ',I3,' R-FI-Z 1 ',F8.1,F5.0,F8.1,' R-FI-Z 2 '
     $,F8.1,F5.0,F8.1,' RCURV SIGXY NHITXY ',E14.6,F8.2,I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,115)
      WRITE(6,2264) TANTH,Z0,SIGZ,NZ
2264  FORMAT(' ',59X,' TANTHETA ',F10.5,' Z0 ',F8.2,' SIGZ(MM) ',F7.4,
     $ ' NZ ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,115,0.)
C
2262  CONTINUE
      IPLT = IPLT + LTRT
      IPLT1 = IPLT
      IPLT2 = IPLT1+MWR1
      IPLT3 = IPLT2+MWR2
      IPLT4 = IPLT3+MWR3
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2299
      IRETUR = 12
      GO TO 9965
2299  CONTINUE
      CALL CORE(HWORK,44)
      WRITE(6,2291) IPLT1,IPLT2,IPLT3,IPLT4
2291  FORMAT(' FAMP HIT MAP POINTERS: ',4I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,44,0.)
      IF(IPLT2.EQ.IPLT1) GO TO 2292
2295  IPLT22 = IPLT2-1
      IF(IPLT22.GT.IPLT1+19) IPLT22 = IPLT1+19
      IRESV = 22+5*(IPLT22-IPLT1+1)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2399
      IRETUR = 13
      GO TO 9965
2399  CONTINUE
      CALL CORE(HWORK,IRESV)
      WRITE(6,2293) (HDATA(II),II=IPLT1,IPLT22)
 2293  FORMAT(' ',14X,' RING1 ',20(Z4,1X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
      IF(IPLT22.GE.IPLT2-1) GO TO 2292
      IPLT1 = IPLT22+1
      GO TO 2295
2292  CONTINUE
      IF(IPLT3.EQ.IPLT2) GO TO 2296
2297  IPLT33 = IPLT3-1
      IF(IPLT33.GT.IPLT2+19) IPLT33 = IPLT2+19
      IRESV = 22+5*(IPLT33-IPLT2+1)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2499
      IRETUR = 14
      GO TO 9965
2499  CONTINUE
      CALL CORE(HWORK,IRESV)
      WRITE(6,2298) (HDATA(II),II=IPLT2,IPLT33)
2298  FORMAT(' ',14X,' RING2 ',20(Z4,1X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
      IF(IPLT33.GE.IPLT3-1) GO TO 2296
      IPLT2 = IPLT33+1
      GO TO 2297
2296  CONTINUE
      IF(IPLT4.EQ.IPLT3) GO TO 2301
      IF(INRGZV.NE.3) GO TO 2301
2302  IPLT44 = IPLT3-1
      IF(IPLT44.GT.IPLT3+19) IPLT44 = IPLT3+19
      IRESV = 22+5*(IPLT44-IPLT3+1)
      YS = YS - DEL
      IF(YS.GT.50.) GO TO 2599
      IRETUR = 15
      GO TO 9965
2599  CONTINUE
      CALL CORE(HWORK,IRESV)
      WRITE(6,2303) (HDATA(II),II=IPLT3,IPLT44)
2303  FORMAT(' ',14X,' RING3 ',20(Z4,1X))
      CALL SYSSYM(XS,YS,SIZE,HWORK,IRESV,0.)
      IF(IPLT44.GE.IPLT4-1) GO TO 2301
      IPLT3 = IPLT44+1
      GO TO 2302
2301  CONTINUE
C
2256  NM = HDATA(LH2+8)
      IF(NM.GT.0) GO TO 2266
C      YS = YS - DEL
C      CALL CORE(HWORK,25)
C      WRITE(cHWORK,2267) ! PMF 17/11/99: JUSCRN changed to cHWORK
C2267  FORMAT(' ---> NO MUON INFORMATION')
C      CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 2268
2266  CONTINUE
      YS = YS - DEL
      NMU = HDATA(LH2+NM)
      IF(NMU.GT.5) NMU =  5
      NCORE = 44 + NMU*4
      NMU = 2*NMU + 1
      CALL CORE(HWORK,64)
      WRITE(cHWORK,2269) HDATA(LH2+NM),HDATA(LH2+NM+1), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ (HDATA(LH2+NM+K),K=2,NMU,2)
2269  FORMAT(' NR MUON TRACKS ',I2,'   IN BARREL ',I3,' POSITION ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
      YS = YS - DEL
      CALL CORE(HWORK,64)
      WRITE(cHWORK,2270) (HDATA(LH2+NM+K+1),K = 2,NMU,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
2270  FORMAT('                ',3X,'             ',3X,' QUALITY ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
C
2268  CONTINUE
      NTG = HDATA(LH2+9)
      IF(NTG.GT.0) GO TO 2271
C     YS = YS - DEL
C     CALL CORE(HWORK,25)
C     WRITE(cHWORK,2272) ! PMF 17/11/99: JUSCRN changed to cHWORK
C2272  FORMAT(' ---> NO TAGG INFORMATION')
C     CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 2273
2271  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,50)
      WRITE(cHWORK,2274) (HDATA(LH2+NTG+K),K=1,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
2274  FORMAT(' TAGGING ENERGIES(MEV) IN -Z, +Z: ',2I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
C
2273  CONTINUE
C WRITE NOW FAMP ACTION WORD, FROM THE HEADBANK
C     IPHEA = IDATA(IBLN('HEAD'))
C     FAMACT = HDATA(2*IPHEA+26)
C     YS = YS - DEL
C     CALL CORE(HWORK,45)
C     WRITE(cHWORK,2275) FAMACT ! PMF 17/11/99: JUSCRN changed to cHWORK
C2275  FORMAT('  FAMP ACTION WORD FROM HEAD BANK 26: ',Z4)
C      CALL SYSSYM(XS,YS,SIZE,HWORK,45,0.)
      GO TO 9020
C-------------------------
C----   SPECIAL FORMAT FOR ZTRG BANKS
C-------------------------
2550  CONTINUE
      LIM2 = LIM2 - 1
      LEZTRG = IDATA(LIM2)
      HPOINT = 2*( LIM2 + 1 )
      HZLENG = 2*( LEZTRG - 1 )
      YS = YS - DEL
C                    WRITE HEADER
      IILIM = 110
      CALL CORE(HWORK,IILIM)
      WRITE(cHWORK,2551) ! PMF 17/11/99: JUSCRN changed to cHWORK
 2551 FORMAT(' DATA  B15 CHANNEL FIFOF HITCN UFLOW OFLOW Z-VALUE',10X,
     $' DATA  B15 CHANNEL FIFOF HITCN UFLOW OFLOW Z-VALUE')
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
C
      DO 2553 IHIT = 1,HZLENG,2
        HELP(2) = HDATA(HPOINT+IHIT)
        IZWRD1 = IZWORD
        KANAL1 = LAND( ISHFTR(IZWORD,11),15)
        HITCN1 = LAND( ISHFTR(IZWORD,8),3)
        IBT151 = 0
        IF(TBIT(IZWORD,16)) IBT151 = 1
        IZWRT1 = LAND( IZWORD,63 )
        IOVRF1 = 0
        IF(LAND(IZWORD,64).NE.0) IOVRF1 = 1
        IUNDF1 = 0
        IF(LAND(IZWORD,128).NE.0) IUNDF1 = 1
        IFIFF1 = 0
        IF(LAND(IZWORD,1024).NE.0) IFIFF1 = 1
C
        HELP(2) = HDATA(HPOINT+IHIT+1)
        IZWRD2 = IZWORD
        KANAL2 = LAND( ISHFTR(IZWORD,11),15)
        HITCN2 = LAND( ISHFTR(IZWORD,8),3)
        IBT152 = 0
        IF(TBIT(IZWORD,16)) IBT152 = 1
        IZWRT2 = LAND( IZWORD,63 )
        IOVRF2 = 0
        IF(LAND(IZWORD,64).NE.0) IOVRF2 = 1
        IUNDF2 = 0
        IF(LAND(IZWORD,128).NE.0) IUNDF2 = 1
        IFIFF2 = 0
        IF(LAND(IZWORD,1024).NE.0) IFIFF2 = 1
C
        YS = YS - DEL
        IF(YS.GT.50.) GO TO 2554
      IRETUR = 16
      GO TO 9965
2554    IILIM = 108
        CALL CORE(HWORK,IILIM)
        WRITE(cHWORK,2552) IZWRD1,IBT151,KANAL1,IFIFF1,HITCN1,IUNDF1, ! PMF 17/11/99: JUSCRN changed to cHWORK
     $  IOVRF1,IZWRT1,
     $  IZWRD2,IBT152,KANAL2,IFIFF2,HITCN2,IUNDF2,
     $  IOVRF2,IZWRT2
 2552   FORMAT(' ',Z4,3X,I1,4X,I2,5X,I1,5X,I1,5X,I1,5X,I1,4X,I5,
     $ 13X,Z4,3X,I1,4X,I2,5X,I1,5X,I1,5X,I1,5X,I1,4X,I5)
        CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 2553 CONTINUE
C
      GO TO 9020
3235  CONTINUE
C--------------- SPECIAL FORMAT FOR N50S BANKS
      LIM2 = LIM2 - 1
      LH2 = LIM2*2
      YS = YS - DEL
      CALL CORE(HWORK,86)
      WRITE(cHWORK,3236) HDATA(LH2+3),HDATA(LH2+11),HDATA(LH2+12) ! PMF 17/11/99: JUSCRN changed to cHWORK
3236  FORMAT(' N50 PROGRAM VERSION ',I6,' ANALYSIS FLAG ',Z4,'  LOOSE MU
     $LTIHADRON SELECTION FLAG ',I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,86,0.)
C TRIGGERS
      NTRI = HDATA(LH2+4)
      IF(NTRI.GT.0) GO TO 3227
      YS = YS - DEL
      CALL CORE(HWORK,28)
      WRITE(cHWORK,3228) ! PMF 17/11/99: JUSCRN changed to cHWORK
3228  FORMAT(' ---> NO TRIGGER INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
      GO TO 3229
3227  YS = YS - DEL
      CALL CORE(HWORK,77)
      WRITE(cHWORK,3231) (HDATA(LH2+NTRI+K),K=1,4) ! PMF 17/11/99: JUSCRN changed to cHWORK
3231  FORMAT(' #T2 TRACKS ',I3,' R3 TRACKS CELLS 33-48 ',Z4,'  CELLS 17-
     $32 ',Z4,'  CELLS 1-16 ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,77,0.)
C COUNTERS
3229  NCOU = HDATA(LH2+5)
      IF(NCOU.GT.0) GO TO 3237
      YS = YS - DEL
      CALL CORE(HWORK,28)
      WRITE(cHWORK,3238) ! PMF 17/11/99: JUSCRN changed to cHWORK
3238  FORMAT(' ---> NO COUNTER INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,28,0.)
      GO TO 3239
3237  AA = HDATA(LH2+NCOU+2)*.1
      YS = YS - DEL
      CALL CORE(HWORK,53)
      WRITE(cHWORK,3241) HDATA(LH2+NCOU+1),AA,HDATA(LH2+NCOU+3), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ HDATA(LH2+NCOU+4)
3241  FORMAT(' #TOFS ',I3,' TDIF(NS) ',F8.1,' ZVTOF ',I6,' ZVLG ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,53,0.)
C LEAD GLASS
3239  NL = HDATA(LH2+6)
      IF(NL.GT.0) GO TO 3242
      YS = YS - DEL
      CALL CORE(HWORK,31)
      WRITE(cHWORK,3243) ! PMF 17/11/99: JUSCRN changed to cHWORK
3243  FORMAT(' ---> NO LEAD GLASS INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,31,0.)
      GO TO 3244
3242  AA1 = HDATA(LH2+NL+5)*.001
      AA2 = HDATA(LH2+NL+6)*.001
      AA3 = HDATA(LH2+NL+7)*.001
      AA4 = HDATA(LH2+NL+8)*.001
      YS = YS - DEL
      CALL CORE(HWORK,124)
      WRITE(cHWORK,3245) (HDATA(LH2+NL+K),K=1,4),AA1,AA2,AA3,AA4, ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ (HDATA(LH2+NL+KK),KK=9,10)
3245  FORMAT(' NR CLUSTERS TOTAL,BARREL,-EC,+EC : ',4I5,' ENERGIES: ',
     $4F8.3,' NHCLI ',I6,' ERES ',I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,124,0.)
C INNER DETECTOR ANALYSIS
3244  ND = HDATA(LH2+7)
      IF(ND.GT.0) GO TO 3246
      YS = YS - DEL
      CALL CORE(HWORK,35)
      WRITE(cHWORK,3247) ! PMF 17/11/99: JUSCRN changed to cHWORK
3247  FORMAT(' ---> NO INNER DETECTOR INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,35,0.)
      GO TO 3248
3246  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(cHWORK,3249) (HDATA(LH2+ND+K),K=1,3) ! PMF 17/11/99: JUSCRN changed to cHWORK
3249  FORMAT(' ID ZVTX FLAG ',I3,'  ZVTX IN MM ',I6,' INRGZV ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
      YS = YS - DEL
      NTR = HDATA(LH2+ND+4)
      NTRT = HDATA(LH2+ND+5)
      CALL CORE(HWORK,47)
      IF(NTR.LT.0) WRITE(cHWORK,3250) ! PMF 17/11/99: JUSCRN changed to cHWORK
3250  FORMAT(' PATTERN RECOGNITION NOT PERFORMED             ')
      IF(NTR.EQ.0) WRITE(cHWORK,3251) ! PMF 17/11/99: JUSCRN changed to cHWORK
3251  FORMAT(' PATTERN RECOGNITION PERFORMED, NO TRACKS FOUND')
      IF(NTR.LE.0) CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      IF(NTR.LE.0) GO TO 3248
      WRITE(cHWORK,3252) NTR ! PMF 17/11/99: JUSCRN changed to cHWORK
3252  FORMAT(' PATTERN RECOGNITION PERFORMED,',I3,' TRACKS FOUND')
      CALL SYSSYM(XS,YS,SIZE,HWORK,47,0.)
      LORT = HDATA(LH2+ND+6)
      LTRT = HDATA(LH2+ND+7)
      IPLT = LH2+ND+LORT-LTRT
      YS = YS - DEL
      CALL CORE(HWORK,48)
      WRITE(cHWORK,3212) NTRT,LORT,LTRT ! PMF 17/11/99: JUSCRN changed to cHWORK
3212  FORMAT(' TRACKS LISTED ',I4,'  LO AND LT FOR EACH ',2I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,48,0.)
C
      DO 4614  ITR = 1,NTRT
      IPLT = IPLT + LTRT
      X1 = HDATA(IPLT+1)*.1
      Y1 = HDATA(IPLT+2)*.1
      Z1 = HDATA(IPLT+3)*.1
      X2 = HDATA(IPLT+4)*.1
      Y2 = HDATA(IPLT+5)*.1
      Z2 = HDATA(IPLT+6)*.1
      HELP(1) = HDATA(IPLT+8)
      HELP(2) = HDATA(IPLT+9)
      RR = FLOAT(IZWORD)*.1
      SIGXY = HDATA(IPLT+10)*10.
      NXY = HDATA(IPLT+11)
      TANTH = HDATA(IPLT+12)
      Z0 = HDATA(IPLT+13)*.1
      SIGZ = HDATA(IPLT+14)*.1
      NZ = HDATA(IPLT+15)
      YS = YS - DEL
      CALL CORE(HWORK,114)
      WRITE(6,461) ITR,X1,Y1,Z1,X2,Y2,Z2,RR,SIGXY,NXY
461   FORMAT(' ',I2,' XYZ1 ',3F8.1,' XYZ2 ',3F8.1,' RADIUS ',E14.6,
     $'  SIGXY(MY) ',F10.0,' NXY ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,114)
      WRITE(6,462) TANTH,Z0,SIGZ,NZ
462   FORMAT(' ',59X,' TANTHETA ',F10.0,' Z0 ',F8.1,' SIGZ(MM) ',F6.1,
     $ ' NZ ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
C
4614  CONTINUE
C
3248  NM = HDATA(LH2+8)
      IF(NM.GT.0) GO TO 3253
      YS = YS - DEL
      CALL CORE(HWORK,25)
      WRITE(cHWORK,3254) ! PMF 17/11/99: JUSCRN changed to cHWORK
3254  FORMAT(' ---> NO MUON INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 3255
3253  CONTINUE
      YS = YS - DEL
      NMU = HDATA(LH2+NM)
      IF(NMU.GT.5) NMU =  5
      NCORE = 44 + NMU*4
      NMU = 2*NMU + 1
      CALL CORE(HWORK,64)
      WRITE(cHWORK,3256) HDATA(LH2+NM),HDATA(LH2+NM+1), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ (HDATA(LH2+NM+K),K=2,NMU,2)
3256  FORMAT(' NR MUON TRACKS ',I2,'   IN BARREL ',I3,' POSITION ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
      YS = YS - DEL
      CALL CORE(HWORK,64)
      WRITE(cHWORK,3257) (HDATA(LH2+NM+K+1),K = 2,NMU,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
3257  FORMAT('                ',3X,'             ',3X,' QUALITY ',5I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,NCORE,0.)
C
3255  CONTINUE
      NTG = HDATA(LH2+9)
      IF(NTG.GT.0) GO TO 3283
      YS = YS - DEL
      CALL CORE(HWORK,25)
      WRITE(cHWORK,3284) ! PMF 17/11/99: JUSCRN changed to cHWORK
3284  FORMAT(' ---> NO TAGG INFORMATION')
      CALL SYSSYM(XS,YS,SIZE,HWORK,25,0.)
      GO TO 3285
3283  CONTINUE
      YS = YS - DEL
      CALL CORE(HWORK,50)
      WRITE(cHWORK,3286) (HDATA(LH2+NTG+K),K=1,2) ! PMF 17/11/99: JUSCRN changed to cHWORK
3286  FORMAT(' TAGGING ENERGIES(MEV) IN -Z, +Z: ',2I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
C
3285  CONTINUE
C WRITE NOW N50 ACTION WORD, FROM THE HEADBANK
      IPHEA = IDATA(IBLN('HEAD'))
      N50ACT = HDATA(2*IPHEA+26)
      YS = YS - DEL
      CALL CORE(HWORK,45)
      WRITE(cHWORK,3258) N50ACT ! PMF 17/11/99: JUSCRN changed to cHWORK
3258  FORMAT('  NORD 50 ACTION WORD FROM HEAD BANK 26: ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,45,0.)
C
      IF(LAND(N50ACT,MASKMH).NE.0) GO TO 3263
      N50ACT = ISHFTL(N50ACT,1)
      DO 3232 IBT = 1,16
      N50ACT = ISHFTR(N50ACT,1)
      IF(IBT.LT.6) GO TO 3232
      IF(.NOT.TBIT(N50ACT,31)) GO TO 3232
C BIT IBT IS ON, WRITE CORRESPONDING INFORMATION
      DO 3287  I = 1,13
3287  HDUM(I) = HSX(I,IBT)
      YS = YS - 2*DEL
      CALL CORE(HWORK,43)
      WRITE(cHWORK,3261) (HDUM(I),I=1,13) ! PMF 17/11/99: JUSCRN changed to cHWORK
3261  FORMAT('  CLASSIFICATION ',13A2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,43,0.)
3232  CONTINUE
      GO TO 3264
3263  MUH = LAND(N50ACT,MASKMH)
      DO 3289  I = 1,13
3289  HDUM(I) = HSX(I,5)
      YS = YS - 2*DEL
      CALL CORE(HWORK,61)
      WRITE(cHWORK,3262) (HDUM(I),I=1,13),MUH ! PMF 17/11/99: JUSCRN changed to cHWORK
3262  FORMAT('  CLASSIFICATION ',13A2,' MULTIPLICITY ',I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,61,0.)
3264  CONTINUE
C
C MPRS BANK PART, INCLUDE SO THAT ALSO INDEPENDENT PRINT POSSIBLE
C
      IPLNAM = IDATA(IBLN('MPRS'))
      IF(IPLNAM.LE.0) GO TO 9020
      LIM2=IPLNAM+1
      YS = YS - DEL
      CALL CORE(HWORK,54)
      WRITE(cHWORK,6231) ! PMF 17/11/99: JUSCRN changed to cHWORK
6231  FORMAT(' ------------->>>   MIPROC RESULTS   <<<--------------')
      CALL SYSSYM(XS,YS,SIZE,HWORK,54,0.)
C---------
1940  LIM2 = LIM2 - 1
      LH2 = LIM2*2
      YS = YS - DEL
      CALL CORE(HWORK,46)
      WRITE(cHWORK,6232) HDATA(LH2+10) ! PMF 17/11/99: JUSCRN changed to cHWORK
6232  FORMAT(' MIPROC EVENT COUNT (=TRIGGER NUMBER) ',I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,46,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,59)
      WRITE(cHWORK,6233) HDATA(LH2+4),(HDATA(LH2+K),K=7,9) ! PMF 17/11/99: JUSCRN changed to cHWORK
6233  FORMAT(' MIPROC ZVTX',I6,' ZVX AND BACKG. PEAKS',2I6,' FLAG ',I2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,59,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,27)
      WRITE(cHWORK,6234) HDATA(LH2+5) ! PMF 17/11/99: JUSCRN changed to cHWORK
6234  FORMAT(' MIPROC FOUND ',I3,' R3 TRACKS')
      CALL SYSSYM(XS,YS,SIZE,HWORK,27,0.)
C
      YS = YS - DEL
      CALL CORE(HWORK,37)
      WRITE(cHWORK,6235) HDATA(LH2+3) ! PMF 17/11/99: JUSCRN changed to cHWORK
6235  FORMAT(' MIPROC REJECTION AND ERROR FLAG ',Z4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,37,0.)
C
      MIPROC = HDATA(LH2+3)
      MIPROC = ISHFTL(MIPROC,1)
      DO 8232 IBT = 1,16
      MIPROC = ISHFTR(MIPROC,1)
      IF(.NOT.TBIT(MIPROC,31)) GO TO 8232
C BIT IBT IS ON, WRITE CORRESPONDING INFORMATION
      DO 8287  I = 1,13
8287  HDUM(I) = HSY(I,IBT)
      YS = YS - DEL
      CALL CORE(HWORK,41)
      WRITE(cHWORK,8261) (HDUM(I),I=1,13) ! PMF 17/11/99: JUSCRN changed to cHWORK
8261  FORMAT('  ACTION/ERROR ',13A2)
      CALL SYSSYM(XS,YS,SIZE,HWORK,41,0.)
8232  CONTINUE
C
      GO TO 9020
1577  CONTINUE
C--------------- SPECIAL FORMAT FOR ZVTX BANKS
      LIM2 = LIM2 - 1
      CALL CORE(HWORK,50)
      WRITE(cHWORK,1579) (ADATA(LIM2+I),I=1,3),(IDATA(LIM2+I),I=4,6) ! PMF 17/11/99: JUSCRN changed to cHWORK
1579  FORMAT('  ',3F10.3,3I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,50,0.)
      GO TO 9020
C--------------- SPECIAL FORMAT FOR TPEV BANK
2077  LIM2 = LIM2 - 1
      LIMH2 = 2*LIM2
      CALL CORE(HWORK,62)
      WRITE(cHWORK,2079) IDATA(LIM2+1),IDATA(LIM2+2),(HDATA(LIMH2+I),I= ! PMF 17/11/99: JUSCRN changed to cHWORK
     $5,14)
2079  FORMAT('  ',I8,2X,I8,2X,10I4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,62,0.)
      YS = YS - DEL
      CALL CORE(HWORK,114)
      WRITE(cHWORK,2080) (HDATA(LIMH2+I),I=15,34) ! PMF 17/11/99: JUSCRN changed to cHWORK
2080  FORMAT('  ',16I5,4I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,114,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(cHWORK,2081) (ADATA(LIM2+I),I=18,27) ! PMF 17/11/99: JUSCRN changed to cHWORK
2081  FORMAT('  ',10E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,54)
      WRITE(cHWORK,2082)(HDATA(LIMH2+I),I=55,56),(ADATA(LIM2+I),I=29,31) ! PMF 17/11/99: JUSCRN changed to cHWORK
2082  FORMAT('  ',2I5,3E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,54,0.)
      YS = YS - DEL
      CALL CORE(HWORK,110)
      WRITE(cHWORK,2083) (ADATA(LIM2+I),I=32,40) ! PMF 17/11/99: JUSCRN changed to cHWORK
2083  FORMAT('  ',9E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,110,0.)
      YS = YS - DEL
      CALL CORE(HWORK,120)
      WRITE(cHWORK,2084)(HDATA(LIMH2+I),I=81,82),(ADATA(LIM2+I),I=42,50) ! PMF 17/11/99: JUSCRN changed to cHWORK
2084  FORMAT('  ',2I5,9E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
      YS = YS - DEL
      CALL CORE(HWORK,72)
      WRITE(cHWORK,2085) (ADATA(LIM2+I),I=51,55) ! PMF 17/11/99: JUSCRN changed to cHWORK
2085  FORMAT('  ',5E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,72,0.)
      YS = YS - DEL
      CALL CORE(HWORK,52)
      WRITE(cHWORK,2086) (HDATA(LIMH2+I),I=111,120) ! PMF 17/11/99: JUSCRN changed to cHWORK
2086  FORMAT('  ',10I5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,52,0.)
      GO TO 9020
C--------------- SPECIAL FORMAT FOR TPTR BANKS
2177  LIM2 = LIM2 - 1
      LIMH2 = 2*LIM2
      CALL CORE(HWORK,110)
      WRITE(cHWORK,2179) (HDATA(LIMH2+I),I=1,18) ! PMF 17/11/99: JUSCRN changed to cHWORK
2179  FORMAT('  ',18I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,110,0.)
      YS = YS - DEL
      CALL CORE(HWORK,122)
      WRITE(cHWORK,2180) (ADATA(LIM2+I),I=10,19) ! PMF 17/11/99: JUSCRN changed to cHWORK
2180  FORMAT('  ',10E12.4)
      CALL SYSSYM(XS,YS,SIZE,HWORK,122,0.)
      YS = YS - DEL
      CALL CORE(HWORK,78)
      WRITE(cHWORK,2181) IDATA(LIM2+20),ADATA(LIM2+21),IDATA(LIM2+22), ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ (ADATA(LIM2+I),I=23,25),IDATA(LIM2+26)
2181  FORMAT('  ',I6,E14.6,I6,3E14.6,I8)
      CALL SYSSYM(XS,YS,SIZE,HWORK,78,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(cHWORK,2182)(ADATA(LIM2+I),I=27,33),(HDATA(LIMH2+I),I=67,68) ! PMF 17/11/99: JUSCRN changed to cHWORK
2182  FORMAT('  ',7E14.6,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,112)
      WRITE(cHWORK,2183)(ADATA(LIM2+I),I=35,38),(HDATA(LIMH2+I),I=77,78) ! PMF 17/11/99: JUSCRN changed to cHWORK
     $,(ADATA(LIM2+I),I=40,42)
2183  FORMAT('  ',4E14.6,2I6,3E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,112,0.)
      YS = YS - DEL
      CALL CORE(HWORK,74)
      WRITE(cHWORK,2184) (HDATA(LIMH2+I),I=85,96) ! PMF 17/11/99: JUSCRN changed to cHWORK
2184  FORMAT('  ',12I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,74,0.)
      YS = YS - DEL
      CALL CORE(HWORK,120)
      WRITE(cHWORK,2185) (ADATA(LIM2+I),I=49,57) ! PMF 17/11/99: JUSCRN changed to cHWORK
2185  FORMAT('   ',9E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,120,0.)
      YS = YS - DEL
      CALL CORE(HWORK,86)
      WRITE(cHWORK,2186) IDATA(LIM2+58),(ADATA(LIM2+I),I=59,64) ! PMF 17/11/99: JUSCRN changed to cHWORK
2186  FORMAT('   ',I5,6E13.5)
      CALL SYSSYM(XS,YS,SIZE,HWORK,86,0.)
      YS = YS - DEL
      CALL CORE(HWORK,100)
      WRITE(cHWORK,2187) (ADATA(LIM2+I),I=65,71) ! PMF 17/11/99: JUSCRN changed to cHWORK
2187  FORMAT('  ',7E14.6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,100,0.)
      YS = YS - DEL
      CALL CORE(HWORK,98)
      WRITE(cHWORK,2188) IDATA(LIM2+72),(ADATA(LIM2+I),I=73,78) ! PMF 17/11/99: JUSCRN changed to cHWORK
     $ ,(IDATA(LIM2+I),I=79,80)
2188  FORMAT('  ',I6,6E13.5,2I6)
      CALL SYSSYM(XS,YS,SIZE,HWORK,98,0.)
      GO TO 9020
C____________________________ SPECIAL FORMAT FOR ZETC BANK
5177  LENGB = LENGB + 2
      NCYCLE=1+(LENGB-1)/20
      LENGB = LENGB - 2
      DO 5010 LHO=1,NCYCLE
5006  YS = YS - DEL
      IF(YS.GT.50.) GO TO 5012
      IRETUR = 10
      GO TO 9965
5012  LIML=2*LIM2+20*(LHO-1)+1
      LIMU = LIML + 19
      IF(LIMU.GT.(2*LIM2+LENGB)) LIMU=2*LIM2+LENGB
      ILIM = LIMU - LIML + 1
      IF(ILIM.LE.0) GO TO 9020
      DO 5025  I = 1,ILIM
      LLO = LIML + I - 1
5025  HWORK(I+100) = HDATA(LLO)
      DO 5027  I = 1,ILIM,4
      IX = HWORK(I+100)
      IX = ISHFTR(IX,3)
5027  HWORK(I+100) = IX
5026  IILIM = 6*ILIM + 1
      CALL CORE(HWORK,IILIM)
      WRITE(cHWORK,9011) (HWORK(LLO+100),LLO=1,ILIM) ! PMF 17/11/99: JUSCRN changed to cHWORK
      CALL SYSSYM(XS,YS,SIZE,HWORK,IILIM,0.)
 5010 CONTINUE
      GO TO 9020
C---------------    CONTINUATION SECTION
9965  CALL CORE(HWORK,14)
      WRITE(cHWORK,9005) ! PMF 17/11/99: JUSCRN changed to cHWORK
9005  FORMAT(' CONTINUED ...')
      CALL SYSSYM(XS,YS,SIZE,HWORK,14,0.)
      GO TO 9029
9020  IRETUR = 1
9029  CALL TRMOUT(80,'HARDCOPY ?^')
      CALL DECIDE(IANSW)
      IF(IANSW.NE.1) GO TO 5901
      CALL TRMOUT(80,'HARDCOPY ON EXTERNAL PLOTTER ?^')
      CALL DECIDE(JANSW)
      IF(JANSW.EQ.2) CALL HDCOPY
      IF(JANSW.EQ.1) CALL HDCEXT
5901  IF(IRETUR.EQ.1) GO TO 9566
      IF(IANSW.EQ.1) CALL PROMPT
      CALL ERASE
      YS = IYT
      CALL TRMOUT(80,'TERMINATE THIS LISTING?^')
      CALL DECIDE(IANSW)
      IF(IANSW.EQ.1) GO TO 9566
      CALL ERASE
      GO TO (9566,875,275,9006,8006,1286,1376,1676,1976,5012,2199,
     $ 2299,2399,2499,2599,2554),IRETUR
9566  RETURN
      END

C   01/11/84 807251624  MEMBER NAME  RSDISP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RSDISP(INDEX)
C-----------------------------------------------------------------------
C
C   AUTHOR: J. OLSSON        ?    : RESULTS DISPLAY
C
C      MOD: J. OLSSON    19/12/83 :
C      MOD: C. BOWDERY   13/03/84 : CDTL 13 REVERSED MEANING
C      MOD: C. BOWDERY   28/04/84 : VERTEX CHAMBER CODE FROM HAGEMANN
C      MOD: J. HAGEMANN  10/10/84 : FOR VERTEX CHAMBER VIEW (INDEX=20)
C      MOD: C. BOWDERY   20/12/85 : BANKLS ET AL, NOW IN OWN MEMBERS
C      MOD: J. HAGEMANN  07/01/86 : FOR OPTIONS 54,56
C      MOD: J. HAGEMANN  12/02/86 : EXTENDED COMMON CVX
C      MOD: J. HAGEMANN  04/07/86 : DISPLAY PHOTONS BEGINNING AT RUN
C                                   VERTEX IF REQUESTED
C      MOD: J. OLSSON    12/03/87 : FWDISP: RESULT DISPLAY IN FW VIEW
C      MOD: J. SPITZER   21/04/87 : HELDIS: HELIX DISPLAY IN Z-VIEWS
C      MOD: J. HAGEMANN  05/06/87 : DUE TO UPDATE OF STANDARD RSDISP
C LAST MOD: J. HAGEMANN  20/01/88 : FOR HWDS-BANK AND VCDO 9
C
C       RESULTS DISPLAY FOR JADE GRAPHICS PROGRAM
C       THIRD INDEPENDENT LINK IN THE CHAIN JADISP - EVDISP - RSDISP
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL REMEMB,REMEMC
      LOGICAL FL18,FL22,FL24
      LOGICAL FLVCDO
      LOGICAL TBIT
C
      COMMON / CPROJ  / XMINR,XMAXR,YMINR,YMAXR,IPRJC,FL18,FL22,FL24
      COMMON / CWORK2 / HWORK(40),JNDEX,NTR,LTR,ITR,IPO,ICNT,NBK,
     +                  NCLST,NWPCL,DUMMM(16),NTRRES,IW52
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CVX    / NNPATR,ICRSTR,NNJETC,NNVTXC
      COMMON / CHEADR / HEAD(108)
      COMMON / CVCPV  / ICD, DFX, DFY, IRC, PTOTCT
      COMMON / CGVCDO / FLVCDO(20)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C-----------------------------------------------------------------------        
C                                                                               
C   COMMON-DEFINITION FOR                 14.04.86  R.RAMCKE                    
C   COMFIT PARAMETER COMMON               09.02.87  C.KLEINWORT                 
C                                                                               
      COMMON / CCOMF / SCF1, SCF2, SCF3, SCF4,                                  
     &                 DCF1, DCF2, ITMX, IVHMN, IPRBN, CFPMIN, MODECF,          
     &                 CFSFAC             , VCWGHT  !!!   VCWGHT added 02.02.98  
C                                                                               
C----------------------------------------------------------------------- 

C
      DATA INAME  / 'PATR' /
C
C-----------------------------------------------------------------------
C
      IALGN = IBLN('ALGN')
      ILGCL = IBLN('LGCL')
      IZVTX = IBLN('ZVTX')
      JNDEX = INDEX
      IF( INDEX .GT. 7 ) JNDEX = INDEX - 4
C
      IF( INDEX .GT. 0  .AND.  INDEX .LT. 21 ) GO TO 4900
      RETURN
C
4900  LASTVW = INDEX
      IF(INDEX.EQ.12) GO TO 5
C                            SEARCH BANK PATR
      NBK    = 0
      NTRRES = 0
C
C                  LSTCMD = 45,118  MEANS  COMMANDS  RES,EDIT
C
      IF(LSTCMD.NE.118.AND.LSTCMD.NE.45) GO TO 2222
      NBK = ACMD
      IF(NBK.NE.0.AND.NBK.NE.99) GO TO 2225
      GO TO 2222
2225  IF(DSPDTL(14)) GO TO 2222
      CALL CLOC(IPO,INAME,NBK)
      IF(IPO.NE.0) GO TO 2223
2224  CALL DIAGIN('NOT EXISTING,BANK NR',1,NBK,IPO,IPO,IPO,IPO,IPO)
      RETURN
2222  IF(NNPATR.LE.0) GO TO 2701
      CALL CLOC(IPPATR,'PATR',NNPATR)
      IPO = IPPATR
      IF(IPPATR.GT.0) GO TO 2702
      WRITE(6,2703) NNPATR
2703  FORMAT(' PATR BANK NR',I3,' (GIVEN BY COMMAND PATR) NOT EXISTING')
2701  IPO = IDATA(IBLN('PATR'))
      IPPATR = IPO
2702  IF(DSPDTL(14)) NTRRES = NBK
      IF(IPO.EQ.0) GO TO 2224
2223  CALL CLOC(IPHWDS,'HWDS',IPRBN)
      IF(IPHWDS .GT. 0) GO TO 2221
         IPHWDS = IDATA(IBLN('HWDS'))
2221  IF(.NOT.FLVCDO(15) .OR. IPHWDS.LE.0) GOTO 2704
         IPO = IPHWDS
         IPPATR = IPO
2704  LO = IDATA(IPO+1)
      NBK = IDATA(IPO-2)
      IPPTR1 = IPO
      NTR = IDATA(IPO+2)
      LTR = IDATA(IPO+3)
      IPO = IPO + LO - LTR
      IFIELD  = HEAD(38)
      AH03 = 3.000E-8*FLOAT(IABS(IFIELD))
C                INDEX=16    Z CHAMBER ROLLED OUT VIEW
      IF( INDEX .EQ. 16 ) GO TO 61
      IF(JNDEX.GT.3.AND.JNDEX.LT.10) GO TO 2
      IF( INDEX .EQ. 18  .OR.  INDEX .EQ. 19 ) GO TO 2
C
C                           RFI-VIEW OF INNER DETECTOR
C                           **************************
      IF(IPO.EQ.0) RETURN
      IF(.NOT.FL18) CALL BANKLS(INDEX,IPPTR1)
      ICNT = 0
      XRV  = 0.0
      YRV  = 0.0
      IF(DSPDTL(29)) GO TO 21
      IF( .NOT. FLVCDO(11) ) GO TO 200
         CALL VTXCRV( INT(HEAD(18)), XRV, YRV, DXR, DYR ) !PMF 09/11/99: add run argument HEAD(18)
200   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 21
      IPO = IPO+LTR
      IF(ICNT.NE.NTRRES.AND.DSPDTL(14).AND.NTRRES.NE.0) GO TO 200
      ITR  = IDATA(IPO + 1)
      ICD  = IDATA(IPO + 2)
      DFX  = ADATA(IPO + 8)
      DFY  = ADATA(IPO + 9)
      IRC  = -100
      IF( ICD .EQ. 301 ) ICD = 65536
      VERVAL = -100.0
      IF( LTR .GT. 62 ) VERVAL = ABS(ADATA(IPO+51))
      IF(TBIT(ICD,19) .AND. LTR.EQ.64 .AND. VERVAL.GT.0.01)
     *                  ICD = IBITON(ICD,15)
      IF( TBIT(ICD,15) .AND. LTR .GE. 64 ) IRC = IDATA(IPO + 62)
      PARAM1 = ADATA(IPO+20)
      PARAM2 = ADATA(IPO+21)
      IF( .NOT.FLVCDO(14) .OR. IRC.NE.0) GOTO 202
         PARAM1 = ADATA(IPO+49)
         PARAM2 = ADATA(IPO+50)
 202  CRV  = ADATA(IPO + 25)
      CST  = 1./SQRT(1.+ADATA(IPO+30)**2)
      PTOT = ABS(AH03/(CRV*CST))
      IF( FLVCDO(9) .AND. PTOT.LT.PTOTCT ) GOTO 200
      IF( FLVCDO(9) .AND. PTOTCT.LT.0.0 .AND.
     *    ((TBIT(ICD,15) .AND. IRC.NE.0 ).OR.
     *     .NOT.TBIT(ICD,15)) ) GOTO 200
C** DISPLAY TRACKS
      call setcol('TRCK') ! PMF 23/11/99: set colour
      ITYPLI = IDATA(IPO+29)
C                     PARABOLA FITS
      IF(ICNT.NE.NTRRES.AND.DSPDTL(14).AND.NTRRES.NE.0) GO TO 200
      IF(IDATA(IPO+18).EQ.2.AND.(ITYPLI.EQ.1.OR.ITYPLI.EQ.2))
     $ CALL PARDIS(25,ADATA(IPO+19),PARAM1,PARAM2,
     $ ADATA(IPO+22),ADATA(IPO+5),ADATA(IPO+6),ADATA(IPO+12),
     $ ADATA(IPO+13),ADATA(IPO+31),ADATA(IPO+30),XRV,YRV)
C                     CIRCLE FITS
      IF(IDATA(IPO+18).EQ.1.AND.(ITYPLI.EQ.1.OR.ITYPLI.EQ.2))
     $ CALL CIRDIS(25,SIGN(ADATA(IPO+19),ADATA(IPO+25)),
     $ PARAM1,PARAM2,
     $ ADATA(IPO+5),ADATA(IPO+6),ADATA(IPO+12),ADATA(IPO+13),
     $ ADATA(IPO+31),ADATA(IPO+30),ITYPLI,XRV,YRV)
      GO TO 200
C
C
C
  21  IF((DSPDTL(28).OR.DSPDTL(29)).AND.NTRRES.EQ.0)
     $ CALL GAMDIS(INDEX,XRV,YRV,0.)
      IF(.NOT.DSPDTL(27)) GO TO 211
      ACMDR = ACMD
      ACMD = 0.
      CALL VXDISP(INDEX)
      ACMD = ACMDR
211   continue
      call setcol(' ')
      IF(JNDEX.EQ.3) GO TO 3
      RETURN
2     IF( JNDEX .GT. 7  .AND.  INDEX .NE. 18  .AND. INDEX.NE.19) GO TO 5
C--                         XZ OR YZ-VIEW OF INNER DETECTOR
C--                         *******************************
      IF(IPO.EQ.0) GO TO 321
      IF(.NOT.FL18) CALL BANKLS(INDEX,IPPTR1)
      IF(DSPDTL(29)) GO TO 321
      ICNT = 0
300   ICNT = ICNT + 1
      IF(ICNT.GT.NTR) GO TO 321
      IPO = IPO + LTR
      IF(ICNT.NE.NTRRES.AND.DSPDTL(14).AND.NTRRES.NE.0) GO TO 300
      ITR = IDATA(IPO + 1)
C** DISPLAY TRACKS
C                     LINE FITS
      ITYPLI = IDATA(IPO+29)
C **MODIFY TO DRAW HELIX FIT RESULT    J.S. 16/4/87
      ACURXY=ABS(ADATA(IPO+25))
      LLLL=0
      IF(ACURXY.GT.1.E-4) LLLL=1
      call setcol('TRCK') ! PMF 23/11/99: set colour
      IF(ITYPLI.EQ.2.AND.LLLL.EQ.1)
     +CALL HELDIS(ITR,INDEX,ADATA(IPO+5),ADATA(IPO+6),ADATA(IPO+7),
     +ADATA(IPO+12),ADATA(IPO+13),ADATA(IPO+14),ADATA(IPO+25))
      IF(ITYPLI.EQ.1.OR.ITYPLI.EQ.2.AND.LLLL.EQ.0)
     +CALL LINDIS(IPO,INDEX,0.,0.,0.)
C ** END MODIFICATION
      GO TO 300
321   IF((DSPDTL(28).OR.DSPDTL(29)).AND.NTRRES.EQ.0)
     $ CALL GAMDIS(INDEX,0.,0.,0.)
      call setcol(' ') ! PMF 23/11/99: reset colour
      IF(.NOT.DSPDTL(27)) GO TO 322
      ACMDR = ACMD
      ACMD = 0.
      CALL VXDISP(INDEX)
      ACMD = ACMDR
322   IPO = IDATA(IZVTX)
      IF(IPO.EQ.0) GO TO 399
      IFLG = IDATA(IPO+6)
C     WRITE(JUSCRN,946) IFLG
C946   FORMAT(' FLAG IN ZV BANK ',I6)
      IF(IFLG.LT.0) GO TO 399
      ZVTX = ADATA(IPO+1)
      DZV1 = ADATA(IPO+2)
      DZV2 = ADATA(IPO+3)
C                                       DRAW ZVERTEX WITH ERRORS
      X1  = ZVTX - DZV1
      X11 = ZVTX - DZV2
      X2  = ZVTX + DZV1
      X22 = ZVTX + DZV2
      Y0  = - 70.
      Y1  = - 90.
      Y2  = - 50.
      CALL MOVEA(X1  , Y1)
      CALL DRAWA(X1  , Y2)
      CALL MOVEA(X1  , Y0)
      CALL DRAWA(X2  , Y0)
      CALL MOVEA(X2  , Y1)
      CALL DRAWA(X2  , Y2)
      CALL MOVEA(X22 , Y2)
      CALL DRAWA(X22 , Y1)
      CALL MOVEA(ZVTX, Y1)
      CALL DRAWA(ZVTX, Y2)
      CALL MOVEA(X11 , Y2)
      CALL DRAWA(X11 , Y1)
399   IF(JNDEX.GT.5) GO TO 3
      RETURN
    3 CONTINUE
      IF( JNDEX .LT. 7  .OR.  INDEX .EQ. 18
     +                  .OR.  INDEX .EQ. 19 ) RETURN
C--
C                            FORWARD DETECTOR
C--
      RETURN
5     IF(JNDEX.EQ.9) GO TO 6
      IF(JNDEX.EQ.12) GO TO 61
C                           FORWARD DETECTOR DISPLAY
C                           ************************
C                           (RESULTS OF TAGAN, CONTENTS OF VECT:0)
      CALL FWDISP
      RETURN
6     IPLGCL=IDATA(ILGCL)
      IF(IPLGCL.EQ.0) RETURN
C                           ROLLED OUT VIEW OF LEADGLASS SYSTEMS
C                           ************************************
      NBK = IDATA(IPLGCL-2)
      NWPCL = IDATA(IPLGCL+25)
      IPO = IDATA(IPLGCL+3) + IPLGCL - 1 - NWPCL
      NCLST = IDATA(IPLGCL+7)
      ISTEP = IDATA(IPLGCL+21)
      IPALGN=IDATA(IALGN)
      call setcol('ECAL') ! PMF 29/11/99: set color
      IF(ISTEP.NE.2) CALL LGCDIR(IPPATR,IPALGN,IPLGCL)
      CALL LGCLST
      IPO = IPPATR + LO - LTR
      call setcol('TRCK') ! PMF 29/11/99: set color
      CALL TRKROL
      call setcol('ECAL') ! PMF 29/11/99: set color
      CALL YAMADA(0)
      call setcol(' ') ! PMF 29/11/99: reset color
      RETURN
61    CONTINUE
C
C  RESULT DISPLAY FOR RZ CHAMBER ROLLED OUT VIEW
C
      IF(IPO.EQ.0) RETURN
      CALL RZROLL
      CALL BANKLS(INDEX,IPPTR1)
      RETURN
      END

C   12/03/84 412051637  MEMBER NAME  TAGSUM   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C    THIS SUBROUTINES SUMS ALLL ADC DATA IN ARRAY CATAG ONE END OR THE
C    OTHER TO GIVE THE VALUE OF SUM.
C
C JPART - INPUT - SIGN DETERMINES WHICH END TAGGER IS ANALYSED
C                  JPART > 0 = > +Z
C                  JPART < 0 = > -Z
C
C  SUM - OUTPUT - SUM OF ENERGY
C
C RETURN 1 IF SUM IS A CRAZY VALUE
C
C   A.J.FINCH  10/12/92
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TAGSUM(JPART,SUM,*)
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
       DATA ICOUNT / 0 /
C
C = == CODE ===
C
C GET THE RELEVANT POINTERS
C
       ISTART = ISTMZ
       IEND   = IENDMZ
       IF ( JPART .GT. 0 ) ISTART = ISTPZ
       IF ( JPART .GT. 0 ) IEND   = IENDPZ
C
C CALCULATE SUM
C
       SUM = 0.0
       DO 10 I = ISTART,IEND
          SUM = SUM + CATAG(I)
 10    CONTINUE
       IF ( (SUM .LT. 50000.0) .AND. (SUM .GE. 0.0) ) RETURN
C
C
C----------------------------------- ERROR MESSAGES -------------------
C
C
       IF ( NDDINN .NE.  0 ) RETURN 1
       IF ( ICOUNT .GE. 10 ) RETURN 1
       WRITE(6,600) SUM
 600   FORMAT(/,' *** WARNING MESSAGE FROM TAGGING ROUTINE - TAGSUM -',
     *        /,'  SUM HAS A CRAZY VALUE  ',E10.2)
       WRITE(6,603)
 603   FORMAT(1X,' LARGE VALUES MAY BE CAUSED BY DIRTY',
     *           ' BEAM CONDITIONS OR EXTREME PEDESTAL FLUCTUATION')
       WRITE(6,602)
 602   FORMAT(1X,' RAW TAGGING ADC BANK -ATAG- WILL BE PRINTED ',/,/)
       CALL HPRS('ATAG',0)
       ICOUNT = ICOUNT + 1
       IF ( ICOUNT .EQ. 10 ) WRITE(6,601)
 601   FORMAT(' * NO MORE ERROR MESSAGES FROM TAGSUM WILL BE PRINTED')
       RETURN 1
       END

C---------  MACRO CGEO2COM       GEOMETRY OF FORWARD DETECTOR   -------
C
C---  LEAD GLASS BLOCKS
C     FENDC:  WIDTH (AND HEIGHT) OF BLOCKS
C     XYHOL1: DISTANCE FROM BEAM CENTRE TO EDGE OF FIRST
C             HORIZONTAL BLOCK
C     XYHOL2: DISTANCE FROM BEAM CENTRE TO EDGE OF FIRST
C             VERTICAL BLOCK
C     BLDPFW: DEPTH OF BLOCKS
C     ZMINBL: DISTANCE FROM INTERACTION POINT TO FRONT SURFACE
C             OF LEAD GLASS BLOCKS (-Z-DIRECTION, PLUTO/CELLO)
C     ZPLUBL: DISTANCE FROM INTERACTION POINT TO FRONT SURFACE
C             OF LEAD GLASS BLOCKS (+Z-DIRECTION, MARK J)
C---  LUMONITORS
C     XSC:    LENGTH OF LONG EDGE (1: A-COUNTER, 2: B-COUNTER)
C     YSC:    LENGTH OF SHORT EDGE
C     RSC:    DISTANCE FROM BEAM CENTRE TO CENTRE OF INNERMOST LONG
C             EDGE ON A-COUNTER
C     ZMISC:  DISTANCE FROM INTERACTION POINT TO FRONT SURFACE OF
C             LUMONITOR (-Z-DIRECTION, TOWARDS PLUTO/CELLO)
C     ZPLSC:  DISTANCE FROM INTERACTION POINT TO FRONT SURFACE OF
C             LUMONITOR (+Z-DIRECTION, TOWARDS MARK J)
C     DZSC:   THICKNESS OF LUMONITORS
C
C---  DRIFT CHAMBERS
C
C  CHX(I,J): XPOSITION OF WIRE 0 IN CHAMBER I (1-3) IN PLANE J (1-4)
C  CHY AND CHZ ANALOGOUS.     WLEN IS SENSITIVE LENGTH OF WIRES
C  PITCH IS WIRE DISTANCE IN XY-PLANE, WZDIS DISTANCE IN Z BETWEEN
C  THE ODD AND EVEN WIRE PLANES
C  WIRE 0 IS CLOSEST TO THE BEAM LINE
C  PRESENT DATA SETTING OF WIRES BASED ON "EDUCATED GUESSES"
C
C     ALL VALUES IN MM      BLOCK DATA SETTING IN SUBR. JADISP
C
C     DATA FENDC/81./,XYHOL1,XYHOL2/141.,151.5/,BLDPFW/400./,
C    1 ZMINBL,ZPLUBL /-5250.,5250./,
C    2 XSC /230.,150./, YSC /150.,70./, RSC /152.48,192.48/,
C    3 ZMISC/-4235.,-4135./, ZPLSC/4235.,4135./, DZSC/6./,
C    4 CHX/140.,-400.,-140.,140.,-400.,-140.,
C    5 140.,-400.,-140.,140.,-400.,-140./,
C    6 CHY /-400.,140.,-400.,-400.,140.,-400.,
C    7 -400.,140.,-400.,-400.,140.,-400./,
C    8 CHZ /-4770.,-4720.,-4770.,-4020.,-3970.,-4020.,
C    9 4020.,3970.,4020.,4770.,4720.,4770./,
C    A WLEN/800./, PITCH /25./, WZDIS/10./
C
C------ END MACRO CGEO2COM

C   16/11/82 606091753  MEMBER NAME  JFTEST   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JFTEST ( X, P, IRETRN, *, CA, SA )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN  16/11/82 :  CKECKS FRAME CONDITION
C             R. RAMCKE
C
C        THIS SUBROUTINE CALCULATES NEXT POINT R OF
C        CHECKS FRAME CONDITIONS FOR DRIFT SPACE IN VERTEX CHAMBER.
C        IRETRN IS RETURN CODE:
C
C           IRETRN = 0 : NEXT ELEMENT, INCREASING X
C                  = 1 : NEXT ELEMENT, DECREASING X
C                  = 2 : NEXT ELEMENT, INCREASING Z
C                  = 3 : NEXT ELEMENT, DECREASING Z
C                  = 4 : PARTICLE STOPPED IN SYSTEM OR DECAY CONDITION
C                        REACHED.
C                  = 5 : NEXT ELEMENT, CHANGING PHI
C
C        IF PARTICLE IS IN FRAME RETURN ELSE RETURN 1.
C-----------------------------------------------------------------------
C
      COMMON / CGEOV  / RPIPV, DRPIPV, XRLPIV, RVXC, DRVXC, XRLVXC,
     +                  ZVXCM, DZVCM, XRZVCM, ZVXCP, DZVCP, XRZVCP,
     +                  XRVTXC
      COMMON / CJVDAT / XSLOPV, YSLOPV, XLV, XHV,
     *                  SV, SV2, TANLOR
C
      DIMENSION X(3), P(7)
C
      DATA EPSIL0, EPSIL1 / 1.E-3, 5.E-3 /
C
C------------------------  C O D E  ------------------------------------
C
      X4 = SQRT ( X(1) * X(1) + X(2) * X(2) )
C
      IF ( X4 .LE. XHV + EPSIL0 )   GOTO 20
                     IRETRN = 0
                     RETURN 1
   20 IF ( X4 .GE. XLV - EPSIL0 )   GOTO 30
                     IRETRN = 1
                     RETURN 1
   30 IF ( ABS(X(2)) .LE. YSLOPV * X(1) + EPSIL1 ) GOTO 40
                     IRETRN = 5
                     RETURN 1
   40 IF ( X(3) .LE. ZVXCP )  GOTO 50
                     IRETRN = 2
                     RETURN 1
   50 IF ( X(3) .GE. ZVXCM )  RETURN
                     IRETRN = 3
                     RETURN 1
      END

C   26/08/86 707081025  MEMBER NAME  PBEN9    (S)           FORTRAN77
      SUBROUTINE PBEN9(INR,NCLU,ESHE,ESHM,IPBC,IPBER)
C
C  CHANGE  05/06/84    ELIPS1=ELIPS1*(1.-1.4*ABS(THLG))
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
      COMMON /LINK/   IBLCHK,IREG,NBLK,NBLE,XI,YI,ZI,XF,YF,ZF,XSTART,
     *                YSTART,ZSTART,PSTART,TRKL(2,50),TRITER,EBITER,
     *                PMAG,NNEW,NENEW,NLIST(40),ENEW,ICHARG(40,20),
     +                NBLO,MEICL(50),NEICL(50),EBIT1,NBN1,EBLO1,NBL1
      COMMON / CGENL / IRUN,IEVE,JIGG2,IPAC,LCO,LTC
      DIMENSION IRKL(2,50)
      DIMENSION WIDTH(5)
      DATA WIDTH / 0.5 , 0.5 , 0.5 ,0.5 , 0.5 /
      EQUIVALENCE(IRKL(1,1),TRKL(1,1))
      DATA ILGA/0/
C
      IPATR=IDATA(IBLN('PATR'))
      IALGN=IDATA(IBLN('ALGN'))
      IPLG=IDATA(IBLN('LGCL'))
      LO  = IDATA(IPATR+1)
      NTR = IDATA(IPATR+2)
      LTR = IDATA(IPATR+3)
C
      ESHM=-1.
      IPBER=0
      DO 600 IN=1,50
      MEICL(IN)=0
      NEICL(IN)=0
  600 CONTINUE
C
      IF(NTR.EQ.0) RETURN
      IPN=IPATR+LO+(INR-1)*LTR
C
       ILIPS=1
      CALL TRKBL9(IPN,IALGN,ITER1,ITER2,ILIPS)
      IF(IBLCHK.EQ.1) RETURN
C
       CALL SHADO9(WIDTH,ILIPS)
C
C
      EBITER=EBITER+ENEW
      ESHE=EBITER
C                               -----------------------------
C                               --   PB-ENERGIE-KORREKTUR  --
C                               -----------------------------
C    BLOECKE, DIE ZUM CLUSTER GEHOEREN IN MEICL(I) FUELLEN
      NBLO=0
      DO 100 I=1,NBLK
      NBLO=NBLO+1
      MEICL(NBLO)=IRKL(1,I)
  100 CONTINUE
      DO 200 I=1,NNEW
      NBLO=NBLO+1
      MEICL(NBLO)=NLIST(I)
  200 CONTINUE
C
      IER=0
C                              'ALGN',1  -->  'ALZW',2
      NWO=IDATA(IALGN)
      CALL BCRE(IALG2,'ALZW',2,NWO,&1100,IER)
      IF(IER.NE.0) GOTO 1120
      CALL BSAW(1,'ALZW')
      DO 300 I=1,NWO
  300 IDATA(IALG2+I)=IDATA(IALGN+I)
C                              'LGCL',1  -->  'LGZW',2
      NWOL=IDATA(IPLG)
      CALL BCRE(IPLG2,'LGZW',2,NWOL,&1100,IER)
      IF(IER.NE.0) GOTO 1125
      CALL BSAW(1,'LGZW')
      DO 302 I=1,NWOL
  302 IDATA(IPLG2+I)=IDATA(IPLG+I)
C
C                            IN 'ALGN',1 ALLE BLOECKE = -1
C                                    UND BLOCKNUMMERN = -1 SETZEN,
C                            DIE NICHT ZUM MEIER-CLUSTER GEHOEREN
      IPNH=2*IALGN+5
      MXH=2*(IALGN+NWO)
      NWA=3
CCCC
      IJK = 0
C
  400 IPNH=IPNH+2
      IF(IPNH.GT.MXH) GOTO 500
      IBLK=HDATA(IPNH)
      DO 410 IMEI=1,NBLO
      IF(IBLK.EQ.MEICL(IMEI)) THEN
                              IJK = IJK + 1
                              GOTO 490
      ENDIF
  410 CONTINUE
      HDATA(IPNH)=-1
      HDATA(IPNH+1)=-1
      GOTO 400
  490 NEICL(IMEI)=HDATA(IPNH+1)
      IF(HDATA(IPNH+1).GT.0) NWA=NWA+1
      GOTO 400
  500 CONTINUE
C                                     ALLE HALBWORTE > 0 AUS 'ALGN',1
C                                     NACH 'ALCO',1 KOPIEREN
      CALL BCRE(IALC,'ALCO',1,NWA,&1100,IER)
      IF(IER.NE.0) GOTO 1128
      CALL BSAW(1,'ALCO')
      IPNH=2*IALGN
      IAC2=2*IALC
      MXHC=2*(IALC+NWA)
  550 IPNH=IPNH+1
      IF(IPNH.GT.MXH) GOTO 560
      IF(HDATA(IPNH).LE.0.AND.IPNH.GT.(2*IALGN+3)) GOTO 550
      IAC2=IAC2+1
      IF(IAC2.GT.MXHC) GOTO 555
      HDATA(IAC2)=HDATA(IPNH)
      GOTO 550
  555 WRITE(6,5556)
 5556 FORMAT(/,1X,' LAENGE DER BANK ALCO UEBERSCHRITTEN +++++++++',/)
  560 NWP1=NWA*2-5
      HDATA(2*IALC+4)=NWP1
      HDATA(2*IALC+5)=NWP1
      HDATA(2*IALC+6)=NWP1
CCC
CCC   CALL BMLT(1,'ALCO')
CCC   CALL BPRM
CCC
      CALL BDLS('ALGN',1)
      CALL BRNM('ALCO',1,'ALGN',1)
C
C     WRITE(6,501) NBLO,(MEICL(I),I=1,NBLO)
C 501 FORMAT(1X,I4,' BLOECKE',18I6)
C     WRITE(6,502) (NEICL(L),L=1,NBLO)
C 502 FORMAT(1X,'     ENERGIE',18I6)
C
C                   CLUSTER-ANALYSE WIEDERHOLEN MIT NEUER 'ALGN',1-BANK
      NPLG=IDATA(IBLN('LGCL'))
      NCLU=IDATA(NPLG+7)
      CALL BDLS('LGCL',1)
      CALL LGANAL
      NPLG=IDATA(IBLN('LGCL'))
      NCLU=IDATA(NPLG+7)
C     NCLULG=NCLU
CCCCCCCC
      IF(NCLU.LE.0) GOTO 1140
CCCCCCCC
C                                    LGCDIR MACHT JETZT ENERGIEKORREKTUR
      CALL LGCDIR(IPATR,IALGN,NPLG)
C
C                      KORRIGIERTE CLUSTER-ENERGIE AUS 'LGCL',1-BANK
      NPLG=IDATA(IBLN('LGCL'))
      ESHM=ADATA(NPLG+11)
      NCLU=IDATA(NPLG+8)
C
      CALL CLOC(ITEL,'LGSA',INR)
      IF(ITEL.NE.0) CALL BDLS('LGSA',INR)
      CALL CLOC(ITEA,'ALSA',INR)
      IF(ITEA.NE.0) CALL BDLS('ALSA',INR)
C            UMBENENNUNG VON 'ALGN',1  IN  'ALSA',INR
C            UMBENENNUNG VON 'LGCL',1  IN  'LGSA',INR
C            SAVE 'ALSA',INR  UND 'LGSA',INR
      CALL BRNM('ALGN',1,'ALSA',INR)
      CALL BRNM('LGCL',1,'LGSA',INR)
      CALL BSAW(1,'ALSA')
      CALL BSAW(1,'LGSA')
CCCCC
CCC   CALL BPRS('ALSA',INR)
CCC   CALL BPRS('LGSA',INR)
C
C            'ALZW',2 NACH 'ALGN',1 ZURUECKKOPIEREN
C            'LGZW',2 NACH 'LGCL',1 ZURUECKKOPIEREN
C            FALS MEHR ALS EINE SPUR IN EINEM EVENT EIN E-KANDIDAT IST
      CALL BRNM('ALZW',2,'ALGN',1)
      CALL BRNM('LGZW',2,'LGCL',1)
C
C
      RETURN
 1100 WRITE(6,1110) IER,IPBC
 1110 FORMAT(1X,' 1100 FEHLER BEIM KOPIEREN VON ALGN, FEHLER',I4,
     +       1X,'   ICALL',I4)
      IPBER=4
      GOTO 1200
 1120 WRITE(6,1121) IER,IPBC
 1121 FORMAT(1X,' 1120 FEHLER BEIM KOPIEREN VON ALGN, FEHLER',I4,
     +       1X,'   ICALL',I4)
CCC   CALL BPRS('ALZW',2)
      IPBER=4
      GOTO 1200
 1125 WRITE(6,1126) IER,IPBC
 1126 FORMAT(1X,' 1125 FEHLER BEIM KOPIEREN VON LGCL, FEHLER',I4,
     +       1X,'   ICALL',I4)
CCC   CALL BPRS('LGZW',2)
      IPBER=4
      GOTO 1200
 1128 WRITE(6,1129) IER,IPBC
 1129 FORMAT(1X,' 1128 FEHLER BEIM KOPIEREN VON ALCO, FEHLER',I4,
     +       1X,'   ICALL',I4)
      IPBER=4
      GOTO 1200
 1140 ILGA=ILGA+1
      IF(ILGA.GT.20) GOTO 1200
      WRITE(6,1150) IRUN,IEVE,JIGG2,INR,NBLO,(MEICL(IM),IM=1,NBLO)
      WRITE(6,1151) (NEICL(MI),MI=1,NBLO)
 1150 FORMAT(1X,' LGANAL FINDET KEINE CLUSTER, EVENT',3I8,'  SPUR',I3,
     +     /,1X,' NBLOCK',I4,'  NUMMER ',16I6)
 1151 FORMAT(1X,'            ENERGIE ',16I6)
      IPBER=2
      IF(ILGA.GT.5) GOTO 1200
CCC   CALL BPRS('ALZW',2)
CCC   CALL BPRS('LGCL',1)
      GOTO 1200
C1160 WRITE(6,1165)
C1165 FORMAT(1X,' CLUSTER IN ZWEI VERSCHIEDENEN DETEKTORTEILEN')
C     RETURN
C1170 WRITE(6,1175) NCLO
C1175 FORMAT(1X,'     >>>>> IFIND = 0 <<<<<,   NCLO =',I4)
C     RETURN
C
 1200 CONTINUE
      CALL BDLS('ALGN',1)
      CALL BDLS('LGCL',1)
      CALL BRNM('ALZW',2,'ALGN',1)
      CALL BRNM('LGZW',2,'LGCL',1)
      RETURN
      END
      REAL FUNCTION DGAUS2(X1,X2,A1,A2,SIG1,SIG2)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     2 - DIM. GAUSS - DISTRIBUTION                                    C
C     CORRELATION = 0                                                  C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      DGAUS2 = 0.
C
      B1 = ((X1 - A1)/SIG1)**2
      B2 = ((X2 - A2)/SIG2)**2
      ARGUM = -.5*(B1 + B2)
C
      IF(ARGUM.LE.-180.) RETURN
C
      DGAUS2 = (1./(6.283185*SIG1*SIG2))*EXP(ARGUM)
C     DGAUS2 = EXP(ARGUM)
C
      RETURN
      END
C   04/12/81 207051513  MEMBER NAME  NUMBLC   (SHOWS)       FORTRAN
      FUNCTION NUMBLC(XA,YA,ZA,IREG)
C
C     RETURNS BLOCK NUMBER FOR GIVEN COORDINATES AND LG-PART
C
C                                           05/07/82
C
#include "cgeo1.for"
C
      COMMON /CJTRIG/ PI,TWOPI
      DIMENSION MAP(6,6)
C
      DATA ICALL/0/
      IF(ICALL.NE.0) GO TO 9999
      ICALL=1
      MAP(1,1)=   -1
      MAP(2,1)=   -1
      MAP(3,1)= 2688
      MAP(4,1)= 2692
      MAP(5,1)= 2697
      MAP(6,1)= 2703
      MAP(1,2)=   -1
      MAP(2,2)=   -1
      MAP(3,2)= 2689
      MAP(4,2)= 2693
      MAP(5,2)= 2698
      MAP(6,2)= 2704
      MAP(1,3)= 2691
      MAP(2,3)= 2690
      MAP(3,3)= 2694
      MAP(4,3)= 2699
      MAP(5,3)= 2705
      MAP(6,3)=   -1
      MAP(1,4)= 2696
      MAP(2,4)= 2695
      MAP(3,4)= 2700
      MAP(4,4)= 2707
      MAP(5,4)= 2706
      MAP(6,4)=   -1
      MAP(1,5)= 2702
      MAP(2,5)= 2701
      MAP(3,5)= 2709
      MAP(4,5)= 2708
      MAP(5,5)=   -1
      MAP(6,5)=   -1
      MAP(1,6)= 2711
      MAP(2,6)= 2710
      MAP(3,6)=   -1
      MAP(4,6)=   -1
      MAP(5,6)=   -1
      MAP(6,6)=   -1
C
 9999 IBLK=-1
      X=XA
      Y=YA
      Z=ZA
      IF(IREG.EQ.0) GO TO 1
      IF((ABS(X).LT.(2.*BLXY)).AND.(ABS(Y).LT.(2.*BLXY))) GO TO 100
      IF((X.GT.0.).AND.(Y.GE.0.)) IQUAD=1
      IF((X.LE.0.).AND.(Y.GT.0.)) IQUAD=2
      IF((X.LT.0.).AND.(Y.LE.0.)) IQUAD=3
      IF((X.GE.0.).AND.(Y.LT.0.)) IQUAD=4
C
C     ROTATE (X,Y) INTO THE FIRST QUADRANT.
C
      JQUAD=0
    2 CONTINUE
      JQUAD=JQUAD+1
      IF(JQUAD.GE.IQUAD) GO TO 3
      XS = Y
      YS =-X
      X  =XS
      Y  =YS
      GO TO 2
    3 CONTINUE
      IF(Y.LT.BLXY) X=X-50.
      IF(X.LT.BLXY) Y=Y-50.
      IX=1.+X/BLXY
      IY=1.+Y/BLXY
      IF((IX.GT.6).OR.(IY.GT.6)) GO TO 100
      IBLK=MAP(IX,IY)
      IF(IBLK.LT.0) GO TO 100
      IBLK=IBLK+24*(IQUAD-1)+48*(IREG+1)
      GO TO 100
    1 CONTINUE
      PHI=ATAN2(Y,X)
      IF(PHI.LT.0.) PHI=PHI+TWOPI
      IPHI=84.*PHI/TWOPI
      IF(IPHI.GT.83) IPHI=83
      IZ=(Z-ZLGMI)/BLZ
      IF((IZ.LT.1).OR.(IZ.GT.30)) GO TO 100
      IBLK=IZ+32*IPHI
  100 CONTINUE
      NUMBLC=IBLK
      RETURN
      END

C   12/08/79 103151554  MEMBER NAME  EVFOLDKW (JADESR)      FORTRAN
      SUBROUTINE REFMAI
C
      IMPLICIT INTEGER*2 (H)
C---
C---     ALIASED FROM EVFOLDLH AND CHANGED TO CALL KAWABATA'S NEW
C---     BREAD RATHER THAN YEN'S UNPACK. 14.06. 12.08.79
C---

      COMMON/CMNF/IRUN,IREC,ISTAT,IFLAG,NWPR
      COMMON/CLHOST/NREADE,NFORME,IENT,ISRAW,ISREF,IHRAW(500),IHREF(500)
     1,IHBANK(128),ISPINW(1540)
      COMMON /CUNPK/ ND,NTOLD,NW1,NEV,LENG,N5001,INIT,NDR
      COMMON/CADDMS/IAERKT(10)
      COMMON/CANOM/NORDE,NCOMBN,NBADAD,NASKIP,IANRUN,IANEVN,JUNKRJ
      COMMON/CDFLAG/IDFLAG,LIMOUT,NRNMIN,NRNMAX
C
#include "cdata.for"
#include "cgraph.for"
      COMMON/CWORK/NWORK,IWORK(10000)
C
      DIMENSION LHON(16),LISTRN(9,50),NEVPRN(50),ITIME(6),H50ACT(2)
      EQUIVALENCE(N50ACT,H50ACT(1))
      DATA LHON/ 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16/
      DATA LSTRN/0/
      DATA NEVPRN/50*0/
      DATA NRUNS/0/
      DATA NINT /2/, NOUT /3/
      DATA NEVIN /0/, NEVOUT /0/
      DATA ITROK /0/
C
C     CALL TMLOG(10,8HEVCONV  )
C
      JUSCRN=6
      NORDE=0
      NCOMBN=0
      NASKIP=0
      NBADAD=0
      NCOMWT=0
      NEVIN=0
      NEVOUT=0
      NREADE=0
      NFORME=0
      IENT=0
      ISRAW=0
      ISREF=0
      IDL8E=0
      IANRUN=0
      IANEVN=0
      JUNKRJ=0
C
      N5001 = 5001
      INIT = 0
C
      DO 900 ICLR=1,500
      IHRAW(ICLR)=0
      IHREF(ICLR)=0
  900 CONTINUE
      DO 899 ICLR=1,128
      IHBANK(ICLR)=0
  899 CONTINUE
      DO 896 ICLR=1,1540
      ISPINW(ICLR)=0
  896 CONTINUE
      CALL BADSPR(1)
C---     COUNT EVENTS ON FAST MULTIHADRON SELECTION FILE.
      MULTI0=0
      MULTI1=0
      MULLNG=0
      H50ACT(1)=0
      ITHRU=1
      KTHRU2=0
C---
C---  THE FOLLOWING STATEMENT TURNS OFF THE FASTSEL FEATURE.
C---                                   13.46 17 FEB 1981 L.O'NEILL
C---
      IF(ITHRU.EQ.1) GO TO 100
  902 CONTINUE
      CALL EVREA1(9,NWORK,IWORK,IRET)
      IF(IRET.EQ.2) GO TO 99
      IF(IRET.EQ.0) GO TO 904
      WRITE(6,903) MULTI0,ITHRU
  903 FORMAT(' **** ERROR ON FASTSEL AFTER',I4,' RECORDS, PASS',I2)
      MULTI0=-100
      GO TO 100
  904 CONTINUE
      MULTI0=MULTI0+2-ITHRU
      KTHRU2=KTHRU2+ITHRU-1
      MULLNG=MULLNG+4*(NWORK+1)*(2-ITHRU)
      IF(KTHRU2.GE.MULTI0) GO TO 100
      GO TO 902
   99 CONTINUE
      IF(ITHRU.EQ.2) GO TO 100
      ITHRU=2
      REWIND 9
      GO TO 902
 100  CONTINUE
      CALL EVREAD(NINT,IRET)
      IF(IRET.NE.2) NEVIN=NEVIN+1
      NWRD2 = NWORD*2
      IF(NWRD2.LT.220) NWRD2 = 220
C     PRINT 2001, NWRD2,IRET,(HDATA(I1),I1=1,NWRD2)
 2001 FORMAT(1H1,2I6,/,(1X,20I6))
      IF(NEVOUT.GE.LIMOUT) GOTO 300
      IF(IRET.EQ.2) GO TO 300
      IF(IRET.NE.0) GO TO 100
C---
C---     WRITE NORD 50 MULTIHADRONS TO FASTSEL DISK FILE.
C---
      IF(MULTI0.LT.0) GO TO 905
      H50ACT(2)=HDATA(34)
      IMN50=LAND(N50ACT,31)
      IF(IMN50.EQ.0) GO TO 905
      IF(MULLNG.GT.5000000) GO TO 905
         IF(MULTI0.GT.2000) REWIND 9
         IF(MULTI0.GT.2000) MULTI0=0
      CALL KALBNK(9,NWORD,IDATA)
      MULTI1=MULTI1+1
      MULLNG=MULLNG+4*(NWORD+1)
  905 CONTINUE
C---
C---     UPDATE RUN LIST.
C---
         IF(HDATA(18).EQ.LSTRN) GO TO 1948
         NRUNS=NRUNS+1
         ITIME(1)=HDATA(11)
         ITIME(2)=HDATA(12)
         ITIME(3)=HDATA(13)
         ITIME(4)=HDATA(14)
         ITIME(5)=HDATA(15)
         ITIME(6)=HDATA(16)
         LASTIM=0
         IDMTIM=KTMCON(ITIME,KTWRIT,LASTIM)
         NCRUN=HDATA(18)
         WRITE(8) NCRUN,IDMTIM,ITIME,KTWRIT
         IF(NRUNS.GT.50) GO TO 1947
         LISTRN(1,NRUNS)=HDATA(18)
         LISTRN(2,NRUNS)=IDMTIM
         LISTRN(3,NRUNS)=HDATA(11)
         LISTRN(4,NRUNS)=HDATA(12)
         LISTRN(5,NRUNS)=HDATA(13)
         LISTRN(6,NRUNS)=HDATA(14)
         LISTRN(7,NRUNS)=HDATA(15)
         LISTRN(8,NRUNS)=HDATA(16)
         LISTRN(9,NRUNS)=KTWRIT
 1947    LSTRN=HDATA(18)
 1948    CONTINUE
C---
         IF(NRUNS.LE.50) NEVPRN(NRUNS)=NEVPRN(NRUNS)+1
      IF(HDATA(20).GE.64) GO TO 1900
      IPNTR1=IDATA(55)
      IPNTR2=0
      IF(IPNTR1.GE.108) IPNTR2=IDATA(IPNTR1-1)
      IF((IPNTR1.GE.108).AND.(IPNTR2.GE.108)) GO TO 1900
      IF(ITROK.LT.100) WRITE(6,1901) HDATA(18),HDATA(19)
 1901 FORMAT(' *** NO TRIGGER BANK. RUN, EVENT = ',2I6,' *********',//)
      ITROK=ITROK+1
      CALL LHODMP
 1900 CONTINUE
         IPNJET=IDATA(61)
         IF(IPNJET.LT.1) GO TO 1950
         IPNERR=2*IPNJET+2
         IERRCD=HDATA(IPNERR)
         IF(IERRCD.EQ.0) GO TO 1950
         IDL8E=IDL8E+1
 1950 CONTINUE
C   THE EVENT IS STORED IN ARRAY ID, THE LENGTH OF THE EVENT
C   IS EQUAL TO (IARR(2)-3)/2 IN I*4 WORDS
C
      NEVOUT=NEVOUT+1
      IF(HDATA(23).GE.2) NCOMWT=NCOMWT+1
      CALL BADSPR(2)
      CALL BWRITE(NOUT,NWORD,IDATA)
C        KLOK=IUHR(1)
C        IF(KLOK.EQ.1) GO TO 898
C        WRITE(6,897)
C 897    FORMAT('0****** WARNING, TIMEOUT ******',//)
C        GO TO 300
C 898    CONTINUE
      GOTO 100
C
  300 CONTINUE
      CALL BADSPR(3)
      CALL BWTEND(NOUT)
      END FILE NOUT
      WRITE(6,894)
  894 FORMAT('1DL8 ERROR FREQUENCY VERSUS ADDRESS. LAST LOCATION HOLDS')
      WRITE(6,893)
  893 FORMAT(' TOTAL NUMBER OF ENTRIES.',/)
      DO 892 LINE=1,77
      IWIRF=20*(LINE-1)
      WRITE(6,891) IWIRF,(ISPINW(IWIRF+KLM),KLM=1,20)
  891 FORMAT(1X,I4,I8,19I6)
  892 CONTINUE
      SRAW=FLOAT(ISRAW)/FLOAT(IENT)
      SREF=FLOAT(ISREF)/FLOAT(IENT)
      WRITE(6,101) IENT,ISRAW,ISREF,SRAW,SREF
  101 FORMAT('0LENGTH HISTOGRAM ENTRIES, ETC. = ',3I10,2F10.2)
      WRITE(6,1779) (LHON(IJK),IJK=1,16)
 1779 FORMAT('0 BANKS',16I6,/)
      WRITE(6,1780) IHBANK
 1780 FORMAT(1X,I12,15I6)
      DO 901 IPAGE=1,2
      IF(IPAGE.EQ.1) WRITE(6,102)
  102 FORMAT(' DISTRIBUTIONS OF LENGTHS OF RAW RECORDS:',/)
      IF(IPAGE.EQ.2) WRITE(6,103)
  103 FORMAT('1DISTRIBUTIONS OF LENGTHS OF REFORMATTED RECORDS:',/)
      DO 901 LINE=1,50
      IWRT=100*(LINE-1)
      LIM1=10*(LINE-1)+1
      LIM2=LIM1+9
      IF(IPAGE.EQ.1) WRITE(6,104) IWRT,(IHRAW(LHO),LHO=LIM1,LIM2)
  104 FORMAT(' ',I5,I15,9I10)
      IF(IPAGE.EQ.2) WRITE(6,104) IWRT,(IHREF(LHO),LHO=LIM1,LIM2)
  901 CONTINUE
      WRITE(6,910) NRUNS
  910 FORMAT(1H0,I4,
     1' RUNS PROCESSED. THE RUN NUMBERS AND EVENTS PER RUN ARE:',//)
      IF(NRUNS.GT.50) NRUNS=50
      DO 912 JRUN=1,NRUNS
      WRITE(6,911) JRUN,LISTRN(1,JRUN),NEVPRN(JRUN),
     1(LISTRN(K,JRUN),K=2,9)
  911 FORMAT(1X,I4,I8,2I12,6I6,I12)
  912 CONTINUE
      WRITE(6,2008) NORDE
 2008 FORMAT(1H0,I10,' NORD PSEUDO EVENTS READ.')
      WRITE(6,2009) NEVIN
 2009 FORMAT(1X,I10,' TOTAL NORMAL AND EXTENDED EVENTS FROM EVREAD.')
      WRITE(6,2010) NEVOUT
 2010 FORMAT(1X,I10,' EVENTS WRITTEN.')
      WRITE(6,2011) NREADE
 2011 FORMAT(1X,I10,' INPUT TAPE READ ERRORS.')
      WRITE(6,2012) NFORME
 2012 FORMAT(1X,I10,' FAILURES TO REFORMAT.')
      WRITE(6,2013) NBADAD
 2013 FORMAT(1X,I10,' ERROR RETURNS FROM EVREAD DUE TO ADDON FAILURE.')
      WRITE(6,2014) NASKIP
 2014 FORMAT(1H0,I10,' EXTENDED EVENTS SKIPPED INTERNALLY BY EVREAD.')
      WRITE(6,2114) JUNKRJ
 2114 FORMAT(1H0,I10,' GARBAGE ENENTS WITH TYPE 128 REJECTED.')
      WRITE(6,2015) NCOMBN
 2015 FORMAT(1H0,I10,' EXTENDED EVENTS SUCCESSFULLY ASSEMBLED.')
      WRITE(6,2016) NCOMWT
 2016 FORMAT(1H0,I10,' EXTENDED EVENTS ACTUALLY WRITTEN.')
      WRITE(6,2017) MULLNG
 2017 FORMAT(1H0,' FASTSEL FILE IS NOW',I8,' BYTES LONG.')
      WRITE(6,2018) MULTI0,MULTI1
 2018 FORMAT(1H0,I4,' EVENTS WERE ON FASTSEL.',I4,' WERE ADDED.')
      WRITE(6,1915) IDL8E
 1915 FORMAT(1H0,' EVENTS WITH DL8 ERROR RECOVERIES:',I6)
      WRITE(6,1913) IANRUN,IANEVN
 1913 FORMAT(1H0,' RUN NUMBER AND EVENT NUMBER ANOMALIES:',2I6)
      WRITE(6,1912)
 1912 FORMAT(1H0,' NUMBERS OF THE VARIOUS ADDON ERRORS:')
      WRITE(6,1914) IAERKT
 1914 FORMAT(1X,10I6,/)
      IF(ITROK.EQ.0) WRITE(6,1910)
 1910 FORMAT(1H0,' TRIGGER BANKS WERE PRESENT FOR EVERY EVENT.')
      IF(ITROK.NE.0) WRITE(6,1911) ITROK
 1911 FORMAT(1H0,' WARNING. THERE WERE',I6,' MISSING TRIGGER BANKS.')
C
C     CALL TMLOG(0)
C
      RETURN
      END
      SUBROUTINE EVWRIT(NUNIT,NWORD,ARRAY)
      DIMENSION ARRAY(NWORD)
      WRITE(NUNIT) NWORD,ARRAY
      RETURN
      END
      SUBROUTINE EVREAD(NUNIT,IRET)
      IMPLICIT INTEGER *2 (H)
#include "cgraph.for"
#include "cdata.for"
      COMMON/CWORK1/NWORK1,IWORK1(10000)
      COMMON/CWORK/NWORK,IWORK(10000)
      COMMON/CANOM/NORDE,ICOMBN,NBADAD,NASKIP,IANRUN,IANEVN,JUNKRJ
      COMMON/CDFLAG/IDFLAG,LIMOUT,NRNMIN,NRNMAX
      DIMENSION HWORK(20000)
      EQUIVALENCE(IWORK(1),HWORK(1))
      COMMON/CLHOST/NREADE,NFORME,IENT,ISRAW,ISREF,IHRAW(500),IHREF(500)
     1,IHBANK(128)
      DATA NADMS/0/
      DATA ICALL/0/
      DATA LSTCDE/16/
      DATA LASTRN/-1/
      ICALL=ICALL+1
      NWORK1=0
      NADDON=0
      IADDFL=0
 1776 CONTINUE
      IRET=0
      CALL BREAD(NUNIT,NWORK,IWORK,&1000,&2000)
 3000 CONTINUE
      IF(IRET.NE.0) GO TO 1778
C---
C---     CHECKING THAT EVENT NUMBER INCREASES PROPERLY. INSTALLED
C---     11.20 22.10.79 BY L.H. O'NEILL.
C---
      NRUN=HWORK(18)
C---     FIXUP YEAR SCREWUP
         IF((NRUN.GE.2570).AND.(NRUN.LE.2802)) HWORK(16)=1980
      IF((NRUN.LT.NRNMIN).OR.(NRUN.GT.NRNMAX)) GO TO 1776
      NEVENT=HWORK(19)
 1900 CONTINUE
      IF(NRUN.NE.LASTRN) GO TO 1901
      IF(NEVENT.LE.LASTEV) GO TO 1902
      IF(NEVENT.GT.(LASTEV+100)) GO TO 1902
      GO TO 1910
 1901 CONTINUE
      LASTEV=-1
      IF((NRUN.NE.(LASTRN+1)).AND.(LASTRN.NE.-1)) GO TO 1903
      LASTRN=NRUN
      GO TO 1900
 1903 CONTINUE
      WRITE(6,1990) NRUN,LASTRN
 1990 FORMAT
     1(' *** ANOMALOUS RUN NUMBER SEQUENCE. NEW RUN, LAST RUN = ',2I8)
      IANRUN=IANRUN+1
      LASTRN=NRUN
      GO TO 1900
 1902 CONTINUE
      WRITE(6,1991) NRUN,NEVENT,LASTEV
 1991 FORMAT
     1(' *** ANOMALOUS EVENT NUMBER SEQUENCE. RUN, EVN, LAST EVN:',3I8)
      IANEVN=IANEVN+1
 1910 CONTINUE
      LASTEV=NEVENT
      NORDE=NORDE+1
      IF(HWORK(20).EQ.128) JUNKRJ=JUNKRJ+1
      IF(HWORK(20).EQ.128) GO TO 1776
      IOVERF=HWORK(23)
      IF(IOVERF.GE.2) IADDFL=1
      IF((IOVERF.LT.2).AND.(LSTCDE.EQ.16)) GO TO 1778
      LSTCDE=IOVERF
C---
C---     THE CURRENT EVENT MUST BE COLLECTED FROM SEVERAL NORD PSEUDO
C---     EVENTS.
C---
      CALL ADDON
C---
C---     IN CASE TERMINATOR VALUE "IOVERF=16" NEVER COMES AND "IOVERF"
C---     .LT.2 OCCURS FIRST, LET ADDON GENERATE ITS ERROR MESSAGE BUT
C---     SAVE THE CURRENT, NON-OVERFLOW EVENT.   17.32 11.08.79
C---
      IF(IOVERF.LT.2) NWORK1=0
      IF(IOVERF.LT.2) GO TO 1778
      NADDON=NADDON+1
      IF(IOVERF.EQ.16) GO TO 1777
C---
C---     SEND MESSAGE IF THERE ARE MORE THAN 10 CONTINUATIONS. THEN
C---     JUST SKIP FORWARD UNTIL NEXT NORMAL EVENT WITH OVERFLOW
C---     FLAG 0 OR 1.
C---
      IF(NADDON.LT.10) GO TO 1776
      NWORK1=-1
      NADMS=NADMS+1
      IF(NADMS.GT.10) GO TO 1776
      WRITE(6,1781) ICALL,HWORK(18),HWORK(19)
 1781 FORMAT('0ERROR: MORE THAN 10 CONTINUATIONS. ICALL, RUN, EVENT = ',
     13I8,//)
      CALL LHODMP
      GO TO 1776
 1777 CONTINUE
C---
C---     ADDON HAS BUILT UP THE TRUE EVENT IN CWORK1. MOVE IT BACK
C---     INTO CWORK.
C---
      IF(NWORK1.LT.1) GO TO 1778
      IADDFL=0
      ICOMBN=ICOMBN+1
      LMOVE=4*NWORK1
      CALL MVCL(IWORK(1),0,IWORK1(1),0,LMOVE)
      NWORK=NWORK1
      IF(NADDON.GT.2) HWORK(23)=NADDON
      IF(ICOMBN.GT.100) GO TO 1778
C---  WRITE(6,1790)
 1790 FORMAT('0EVENT EXTENDED OVER MULTIPLE NORD "EVENTS".')
C---  WRITE(6,1791) HWORK(18),HWORK(19),NADDON,NWORK
 1791 FORMAT
     1(' RUN NO., EVNT. NO., NUMB OF NORD "EVENTS", UNREFORM. I*4 LENGTH
     1',4I8,//)
 1778 CONTINUE
      LSTCDE=16
      IF(IRET.EQ.1) NREADE=NREADE+1
      IF((IRET.EQ.1).AND.(NREADE.LE.10)) WRITE(6,100) ICALL
  100 FORMAT(' ERROR FROM EVREA2. EVCONV NOT CALLED. ICALL=',I10)
      IF((IRET.EQ.1).AND.(NREADE.LE.20)) CALL LHODMP
      IREPLY=0
      IF(NWORK1.LT.0) IRET=1
      IF(NWORK1.LT.0) NBADAD=NBADAD+1
      IF(IRET.EQ.0) CALL EVCONV(IREPLY)
         IF(IDFLAG.EQ.0) GO TO 1946
         IPNJET=IDATA(61)
         IF(IPNJET.LT.1) GO TO 1946
         IPNERR=2*IPNJET+2
         IERRCD=HDATA(IPNERR)
         IF(IERRCD.EQ.0) GO TO 1946
         DATA KERREC/0/
         KERREC=KERREC+1
         IF(KERREC.GT.20) GO TO 1946
         CALL LHODMP
 1946    CONTINUE
      IF(IREPLY.NE.0) IRET=1
      IF(IREPLY.NE.0) NFORME=NFORME+1
      IF((IREPLY.NE.0).AND.(NFORME.LE.10)) WRITE(6,101) ICALL
  101 FORMAT(' REFORMATTING ERROR. ICALL=',I10)
      IF((IREPLY.NE.0).AND.(NFORME.LE.20)) CALL LHODMP
      NASKIP=NASKIP+IADDFL
      IF(IRET.NE.0) RETURN
      INRAW=(NWORK-1)/10+1
      IF(INRAW.LT.1) INRAW=1
      IF(INRAW.GT.500) INRAW=500
      INREF=(NWORD-1)/10+1
      IF(INREF.LT.1) INREF=1
      IF(INREF.GT.500) INREF=500
      IHRAW(INRAW)=IHRAW(INRAW)+1
      IHREF(INREF)=IHREF(INREF)+1
      IENT=IENT+1
      ISRAW=ISRAW+NWORK
      ISREF=ISREF+NWORD
      RETURN
 1000 IRET=2
      GO TO 3000
 2000 IRET=1
      GO TO 3000
      END
C
      SUBROUTINE LHODMP
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON/CWORK/NWORK,HWORK(20000)
#include "cdata.for"
#include "cgraph.for"
C
      DATA ICALL /0/
      ICALL = ICALL + 1
      IF(ICALL.GT.0) RETURN
C
      DO 1 I=1,2
      IF(I.EQ.2) WRITE(6,103)
      IF(I.EQ.2) WRITE(6,103)
      IF(I.EQ.1) WRITE(6,101)
      IF(I.EQ.2) WRITE(6,102)
  101 FORMAT(' CAMAC EVENT:')
  102 FORMAT(' REFORMATTED EVENT:')
      WRITE(6,103)
  103 FORMAT('  ')
      IF(I.EQ.1) LENG=2*NWORK
      IF(I.EQ.2) LENG=2*HDATA(208)
      IF((LENG.GE.1).AND.(LENG.LE.20000)) GO TO 3
      WRITE(6,104) I,LENG
  104 FORMAT(' ILLEGAL LENGTH IN LHODMP. I, LENG=',2I10)
      GO TO 1
    3 CONTINUE
      LINES=1+(LENG-1)/20
      DO 2 LINE=1,LINES
      LIM1=20*(LINE-1)+1
      LIM2=LIM1+19
      IF(LIM2.GT.LENG) LIM2=LENG
      IF(I.EQ.1) WRITE(6,105) LIM1,(HWORK(LHO),LHO=LIM1,LIM2)
      IF(I.EQ.2) WRITE(6,105) LIM1,(HDATA(LHO),LHO=LIM1,LIM2)
  105 FORMAT(1X,I6,6X,20I6)
    2 CONTINUE
    1 CONTINUE
      RETURN
C
      END

C   16/07/79 011140211  MEMBER NAME  LGBADC   (SOURCE)      FORTRAN
      SUBROUTINE LGBADC(HEXP,HRUN,*)
C
C  THIS SUBROUTINE GIVES THE LIST OF BAD ADC-CHANNELS, AND #CHANNELS
C  TO BE SUBTRACTED (KILL THAT ADC IF IT IS A BIG NO.)
C  CALLED FROM LGERSE  LAST MOD. 09:40  09-11-79
C     HEXP  :  INPUT EXPERIMENTAL #   IGNORE FROM NOW ON
C     HRUN  :  INPUT RUN#
C     HCAL  :  BUFFER FOR BAD CHANNELS.
C              ALSO USED AS THE OUTPUT OF THIS ROUTINEIN THE FORM OF
C              HCRT(4),HBADC,HBCHN,HADC(J,I)..
C              HCRT(I);SUB CONST FOR CRATE 1-3 AND FOR ALL CRATES(I=4)
C              HBADC=#BAD ADC MODULES, HBCHN=#BAD CHANNELS
C              HADC(J,I),J;1=CHN#,2=#CHANNELS TO BE SUBTRACTED.
C     CODED BY H.TAKEDA  7/5/79  09:05
C        LAST MODIFICATION  29/04/80  23:00 BY Y.WATANABE
C
      IMPLICIT INTEGER *2 (H)
#include "clgwork1.for"
#include "clgkalb.for"
      COMMON /CLGBCH/ HABAD(2,3),HBBAD(2,2,2)
      COMMON /CTEMPB/ HCHB(500)
C     HABAD(J,I); I; 1=ALL CRATES, 2=EACH CRATE, 3=EACH ADC
C                 J; 1=MIN.#CHANNELS FOR THE ACTION TO TAKE PLACE.
C                    2=MIN. FREQ. OF FIRING*10000...
C     HBBAD(K,J,I);I;1=BARREL 2=END CAP, J;1=SUB,2=KILL
C                   K=1;MIN. FREQ. OF FIRING*10000
C                   K=2;MIN. AV. PULSE HEIGHT.
C
C         THE DEFINITION OF BADCH WAS CHANGED BTW SUMMER AND FALL 79
C         SO REDEFINE HBBAD FOR THE SUMMER RUNS
      IF(HRUN.LE.0) RETURN1
      IF(HRUN.GT.1486) GO TO 1
C        DIFFERENT DEF. OF BADCH FILE.
      HBBAD(1,1,1)=500
      HBBAD(2,1,1)=10
      HBBAD(1,1,2)=1000
      HBBAD(2,1,2)=200
1     CONTINUE
      HBBAD(1,1,1)=100
      HBBAD(2,1,1)=3
      HBBAD(1,1,2)=100
      HBBAD(2,1,2)=3
C
      NP=NCAL(7)
      NLENG=NCAL(NP+1)
      NEV=NCAL(NP+2)
      IF(NEV.GT.500) GO TO 5
C       USE PREVIOUS RUN IF NO EVENTS FOR THIS RUN.
      WRITE(6,590) HEXP,HRUN
590   FORMAT(1X,'**EXP#, RUN # ',2I5,' TOO SHORT ***USE PREVIOUS RUN')
      RETURN
C
5     HBADC=0
      HBCHN=0
      HCHB(1)=0
      HCHB(2)=0
      HCHB(3)=0
      HCHB(4)=0
C       (INITIALIZATION)
      NPH=NP+NP+2
      HHEXP=HCAL(NPH+3)
      HHRUN=HCAL(NPH+4)
      KPH=2
C     IF(HHEXP.NE.HEXP) GO TO 90    NOT TEST ON EXP# 27/9/79
      IF(HHRUN.EQ.HRUN) GO TO 10
      WRITE(6,600) HEXP,HRUN,HHRUN
  600 FORMAT(1X,'**EXP#, RUN # ',2I5,' NOT FOUND ***USE RUN#',I5)
C
10    IFG=0
      NBAD=NLENG-10
      NBAD=NBAD/4
      KP=6
      IF(NBAD.LE.0)GO TO 80
      J2=NPH+10
C     WRITE(6,900) HEXP,HRUN
C900   FORMAT('0 BADCH FOR EXP AND RUN',2I5)
      J1=NPH+11
      J2=NPH+NLENG
C     WRITE(6,910) (HCAL(JP),JP=J1,J2)
C910   FORMAT(8(3I5,1X))
      IBE=1
      JP=NPH+7
      IF(HCAL(JP+4).LT.10000) GO TO 100
C
      DO 70 I=1,NBAD
      JP=JP+4
      HCH=HCAL(JP)
      HFR=HCAL(JP+1)
      HAV=HCAL(JP+2)
      HSG=HCAL(JP+3)
      HSG=HSG+HSG
      IF(HSG.LT.6) HSG=6
      IF(HSG.GT.60) HSG=60
C      (SAFETY FACTOR)
      IF(HCH.LT.20000) GO TO 20
C
C     CRATE INFORMATION;  0-3 FOR CRATE 1-3 AND ALL CRATES
      HCH=HCH-20000
      M=2
      IF(HCH.EQ.3) M=1
      HSUB=0
      IF(HFR.GE.HABAD(2,M)) HSUB=HAV+HSG
      HCHB(HCH+1)=HSUB
      GO TO 70
20    IF(HCH.LT.10000) GO TO 30
C
C     ADC INFORMATION
      IF(HFR.LT.HABAD(2,3)) GO TO 70
      HCH=HCH-10000
      HSUB=HAV+HSG
      HBADC=HBADC+1
      GO TO 60
C
C     CAHNNEL INFORMATION
30    IF(HCH.GE.2688) IBE=2
C
      IF(HFR.GT.HBBAD(1,2,IBE)) GO TO 50
      IF(HFR.LT.HBBAD(1,1,IBE)) GO TO 70
C     CATEGORY 1.  CHECK THE PULSE HEIGHT.
      IF(HAV.LT.HBBAD(2,1,IBE)) GO TO 70
      HSUB=HAV+HSG
      HBCHN=HBCHN+1
      GO TO 60
50    CONTINUE
C     CATEGORY 2;KILL IF HAV>1000
      HSUB=HAV+HSG
      IF(HAV.GT.HBBAD(2,2,IBE)) HSUB=9999
C     (KILL THAT CHANNEL)
      HBCHN=HBCHN+1
C     (PROBABLY THIS IS OK. I.E. HAV+HSG TAKES CARE MOST OF THEM.)
60    KP=KP+1
      HCHB(KP)=HCH
      KP=KP+1
      HCHB(KP)=HSUB
70    CONTINUE
C
80    IFG=1
90    CONTINUE
      HCHB(5)=HBADC
      HCHB(6)=HBCHN
C
C     WRITE(6,920) (HCHB(JP),JP=1,KP)
C920   FORMAT(10(2I6,1X))
      RETURN
C
C  ...THE OLD FORMAT IS STILL IN THE /CALIBR/. NO LIST IS DONE.
      DATA IERP/0/
100   IERP=IERP+1
      IF(IERP.LT.6) WRITE(6,670) HEXP,HRUN
670   FORMAT('0 ***** LGBADCH CONSTS STILL OLD. NO KILLING WILL BE '
     1 'DONE IN LGERSE( MESSAGE FROM LGBADC):EXP,RUN=',2I5)
      RETURN1
      END

C   01/02/84 510091210  MEMBER NAME  MUINI    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUINI
C-----------------------------------------------------------------------
C
C ANY CHANGE HERE SHOULD ALSO BE MADE TO MUINIG
C
C LAST CHANGE 20.00 12/03/84 CHRIS BOWDERY- BLOCK DATA STRINGS CHANGED
C      CHANGE 23.30  8/03/84 CHRIS BOWDERY- BLOCK DATA STRINGS CHANGED
C      CHANGE 15.30 18/01/84 TIM GREENSHAW- BLOCK DATA STRINGS CHANGED
C      CHANGE 10.40 13/01/84 CHRIS BOWDERY- BLOCK DATA STRINGS CHANGED
C      CHANGE 15.00 02/12/83 HUGH MCCANN  - STANDARD LEVEL IS NOW 2.
C      CHANGE 12.00 29/06/82 HUGH MCCANN  - FOR FEWER MUCOOR ERROR MESS.
C      CHANGE 10.30 23/02/82 HUGH MCCANN  - TO ADD MUCUTS TREATMENT.
C      CHANGE 13.30 22/02/82 HUGH MCCANN  - FOR IMPROVED ERROR OUTPUT.
C
C-----------------------------------------------------------------------
C
C MUON INITIALISATION ROUTINE.
C
C SETS UP MUON STATISTICS ARRAYS.
C
C ALSO SETS MU ANALYSIS PARAMETERS - SEE BLOCK DATA STATEMENT.
C
C
C-----------------------------------------------------------------------
C
C                            COMMONS
C
      COMMON /CMUPRN/ MUPRIN,MUHPR,IANAC,ICOOR,IANAF,LANAC,LCOOR,LANAF,
     +                ITOTAL,LTOTAL,ICUTS,LCUTS
      COMMON /CMUIEV/ IEV,NEV,IRD,KRUN,KREC,
     +                ISECS,IMINS,IHOURS,IDAY,IMONTH,IYEAR
C
C------------------  C O D E  ------------------------------------------
C
C INITIALISE EVENT COUNTER FOR MU MESSAGES.
C
      IEV=0
C
C SET MUPRIN=2 TO ALLOW STANDARD MESSAGES FOR STANDARD USER.
C
      MUPRIN=2
C
C INITIALISE TOTAL MESSAGE COUNT FOR THIS JOB AND SET ITS LIMIT.
C
      ITOTAL=0
      LTOTAL=500
C
C INITIALISE ERROR COUNT FOR MUANAC,MUCOOR,MUANAF FOR THIS JOB.
C                            + MUCUTS.
      IANAC=0
      ICOOR=0
      IANAF=0
      ICUTS=0
C
C SET LIMITS ON ERROR MESSAGES FROM MUANAC,MUCOOR,MUANAF FOR THIS JOB.
C                            + MUCUTS.
      LANAC=20
      LCOOR=50
      LANAF=20
      LCUTS=20
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
      RETURN
C
      END
C
C-----------------------------------------------------------------------
      BLOCK DATA
C-----------------------------------------------------------------------
C
C                           COMMONS
C
#include "cmustat.for"
#include "cmuanp.for"
C
C-----------------------------------------------------------------------
C
C DATA INITIALISATION STATEMENTS.
C
      DATA MUT1    /
     1 'MUCOOR  ','ALL HITS','NO HITS ','NO MUR1I','NO MUR20',
     2 'NO MUR2I','HITS>400','HMU LEN.','HMU BAD ','NO MUR10',
     3 'MU EVENT','MU TYP 1','MU TYP 5','MU TYP 9','    ..  ',
     4 '    ..  ','    ..  ','    ..  ','    ..  ','BAD DRFT',
     5 'BAD LONG','X PULLED','Z PULLED','MULT-PUL','HIT REC.',
     6 'HIT SEQ1','HIT SEQ2','HIT# ERR','NEW CH? ','SING ERR',
     7 '    ..  ','    ..  ','    ..  ','    ..  ','    ..  ',
     8 '    ..  ','    ..  ','    ..  ','    ..  ','DC-->HIT',
     9 'BAD CH# ','CH ORDER','CH-/->CR','SING BAD','    ..  ',
     A '    ..  ','    ..  ','    ..  ','    ..  ','    ..  '  /
      DATA MUT2    /
     1 '    ..  ','    ..  ','    ..  ','    ..  ','    ..  ',
     2 '    ..  ','    ..  ','    ..  ','    ..  ','BAD CR# ',
     3 'CR ORDER','NO T.REF','EOC REC.','CR. MARK','EOC ERR.',
     4 '    ..  ','    ..  ','    ..  ','    ..  ','    ..  ',
     5 'MCRATE 1','MCRATE 2','MCRATE 3','MCRATE 4','MCRATE 5',
     6 'MCRATE 6','MCRATE 7','MCRATE 8','MCRATE 9','MCRATE10',
     7 'MCRATE11','MCRATE12','MCRATE13','MCRATE14','NO EOC 1',
     8 'NO EOC 2','NO EOC 3','NO EOC 4','NO EOC 5','NO EOC 6',
     9 'NO EOC 7','NO EOC 8','NO EOC 9','NO EOC10','NO EOC11',
     A 'NO EOC12','NO EOC13','NO EOC14','    ..  ','    ..  '  /
C
C-----------------------------------------------------------------------
C
      DATA NMU/100*0/
C
C-----------------------------------------------------------------------
C
C CUTS ETC. USED IN MULINE.......
C CUTP: CUT ON PERPENDICULAR DISTANCE FROM HIT TO LINE IN CLUSTER
C   SEARCH IN MULINE.
      DATA CUTP/400./
C WRES: WEIGHT PER AMBIGUITY RESOLVED HIT. (REMEMBER UNRESOLVED HITS
C   GET A WEIGHT OF 2. SO MAKE WRES BIGGER THAN THIS.)
      DATA WRES/4./
C
C CUTS ETC. USED IN MULINA.......
C A) IN STEP 2, THROWING OUT WILD POINTS......
C     WILD=(D1.GT.FT*DMIN1.AND.D1.GT.FT*DRES).OR.D1.GT.FT*CUTT
C    *     .OR.(DL1.GT.FL*DLMIN1.AND.DL1.GT.FL*DLRES).OR.DL1.GT.FL*CUTL
      DATA CUTT/100./
      DATA CUTL/9999./
      DATA FT/3./
      DATA FL/3./
C DRES AND DLRES: ESTIMATED RESOLUTIONS, DRIFT AND LONG. RESPECTIVELY.
      DATA DRES/15./
      DATA DLRES/999./
C B) IN STEP 3, LOOKING FOR SMALL DRIFT DISTANCES....
C FS: IF DISTANCE BETWEEN LEFT AND RIGHT POINTS IS FS*BEST RMS DRIFT
C   DEVIATION, FIX AMBIGUITY AND REPEAT FROM STEP 1.
      DATA FS/2./
C C) IN STEP 4, CLASSIFYING CLUSTERS.......
C CUTC: CLUSTERS NOT ACCEPTED IF MINIMUM RMS DRIFT DEVIATION .GT. CUT1.
C    THE TOTAL RMS DEVIATION IS SET TO -1 (NO ACCEPTABLE PERMUTATIONS).
      DATA CUTC/35./
C FR: CLUSTERS NOT ACCEPTED IF 3RD BEST FIT .LT. FR*BEST FIT. THE TOTAL
C    RMS DEVIATION IS SET TO -2 (TOO MANY ACCEPTABLE PERMUTATIONS).
      DATA FR/2./
C D) IN STEP 5, ADDING LEFT OVER SINGLE HITS TO EXISTING CLUSTERS...
C FAT: ADD IF HIT .LT. FAT*RMS DEVIATION AWAY IN DRIFT DIRECTION .OR.
C FAL: ADD IF HIT .LT. FAL*RMS DEVIATION AWAY IN LONG. DIRECTION.
      DATA FAT/4./
      DATA FAL/4./
C CUTDT IS THE CUT (IN MM) APPLIED TO THE DISTANCE OF A HIT FROM A
C GIVEN LINE IN THE DRIFT DIRECTION
      DATA CUTDT/300.0/
C THE FOLLOWING CUTS ARE USED IN MULINE
C CUTDL IS THE CUT (IN MM) APPLIED TO THE DISTANCE OF A HIT FROM A
C GIVEN LINE IN THE LONGITUDINAL DIRECTION
      DATA CUTDL/9999.0/
C
      END

      SUBROUTINE CRTREL(IPHT,IERRFL)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C----------------------------------------------------------------------
C           MACRO CCYCP .... JET CHAMBER HIT POINTERS (PATREC)
C----------------------------------------------------------------------
      INTEGER*4 HPTSEC
      COMMON/CCYCP/HPTSEC(98)
C     HPTSEC(I) = CDATA POINTER TO 1ST I*2 WORD FOR 1ST HIT OF CELL I
C------------------------ END OF MACRO CCYCP --------------------------
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      EQUIVALENCE
     ,           (ICELL ,IDWRK(1)),(NHIT  ,IDWRK(2)),(IRING ,IDWRK(3))
     ,         , (IERRCD,IDWRK(4)),(NTRKEL,IDWRK(5))
     ,         , (ITR   ,IDWRK(7)),(ITRNG ,IDWRK(8))
      DATA MKATR / ZFF01/
      INTEGER  MKLRHT(3) / Z800, Z0, Z900/
      IF(
     - HNTR.GE.200
     -)THEN
        IERRFL = -1
        RETURN
      ENDIF
      LBLR = 1
      IF(IPHT.LT.0) LBLR =-1
      IPHT = IABS(IPHT)
      IWIR = HDATA(IPHT)
      IWIR = ISHFTR(IWIR,3)
      ICLL = ISHFTR(IWIR,4)
      ILAY = LAND(IWIR,15)
      IPTR = HNTCEL(ICLL+2)
      IRNG = ICLL / 24 + 1
      IF(IRNG.GT.3) IRNG = 3
      IC1 =  1
      IC9 = 24
      IF(ICLL.GE.24) IC1 = 25
      IF(ICLL.GE.24) IC9 = 48
      IF(ICLL.GE.48) IC1 = 49
      IF(ICLL.GE.48) IC9 = 96
      IP1  = HNTCEL(IC1  )
      IP9  = HNTCEL(IC9+1) - 1
      JTRELM = 1
      IF(IP1.LE.IP9) JTRELM = NTREL(IP9) + 1
      IF(
     - JTRELM.GE.128
     -)THEN
        IERRFL = -1
        RETURN
      ENDIF
      NTRL = 1
      IF(
     - IPTR.GT.1
     -)THEN
        NTRL = NTREL(IPTR-1) + 1
        IRNG1 = (IPCL(IPTR-1)-1)/24 + 1
        IF(IRNG1.GT.3) IRNG1 = 3
        IF(IRNG1.NE.IRNG) NTRL = 1
      ENDIF
      IF(
     - IPTR.LE.IP9
     -)THEN
      DO 13000 IP=IPTR,IP9
          NTREL(IP) = NTREL(IP) + 1
13000 CONTINUE
13001 CONTINUE
        IPHT0 = (HPTSEC(ICLL+1)-HPTSEC(1))/2 + HPHL0
        IPHT9 = (HPTSEC(IC9 +1)-HPTSEC(1))/2 + HPHL0 - 1
      DO 13002 IP=IPHT0,IPHT9
          LBHIT = HWRK(IP  )
          NTR1 = ISHFTR(LBHIT,1)
          NTR1 = LAND(NTR1,127)
          IF(NTR1.GE.NTRL) NTR1 = NTR1 + 1
          LBHIT = LAND(MKATR,LBHIT)
          LBHIT = LOR(LBHIT,ISHFTL(NTR1,1))
          HWRK(IP  ) = LBHIT
13002 CONTINUE
13003 CONTINUE
      ENDIF
      IC0 = ICLL + 1
      DO 13004 IC=IC0,96
        HNTCEL(IC+1) = HNTCEL(IC+1) + 1
13004 CONTINUE
13005 CONTINUE
      HNTR = HNTR + 1
      IF(
     - IPTR.NE.HNTR
     -)THEN
        IP = HNTR - 1
16000 CONTINUE
          TRKAR(IP+1, 1) = TRKAR(IP, 1)
          TRKAR(IP+1, 2) = TRKAR(IP, 2)
          TRKAR(IP+1, 3) = TRKAR(IP, 3)
          TRKAR(IP+1, 4) = TRKAR(IP, 4)
          TRKAR(IP+1, 5) = TRKAR(IP, 5)
          TRKAR(IP+1, 6) = TRKAR(IP, 6)
          TRKAR(IP+1, 7) = TRKAR(IP, 7)
          TRKAR(IP+1, 8) = TRKAR(IP, 8)
          TRKAR(IP+1, 9) = TRKAR(IP, 9)
          TRKAR(IP+1,10) = TRKAR(IP,10)
          TRKAR(IP+1,11) = TRKAR(IP,11)
          HRES(IP+1) = HRES(IP)
          IP = IP - 1
      IF(.NOT.(
     - IP.LT.IPTR
     -))GOTO 16000
16001 CONTINUE
      IF(
     - NTR.GT.0
     -)THEN
      DO 13006 ITR=1,NTR
            NELM = HNREL(ITR)
      DO 13008 I=1,NELM
              IELM = HISTR(I,ITR)
              INCR = ISIGN(1,IELM)
              IF(IABS(IELM).GE.IPTR) HISTR(I,ITR) = IELM + INCR
13008 CONTINUE
13009 CONTINUE
13006 CONTINUE
13007 CONTINUE
      ENDIF
      ENDIF
      ITRKAR(IPTR, 1) = IC0
      ITRKAR(IPTR, 2) = 1
      ITRKAR(IPTR, 3) = ILAY
      ITRKAR(IPTR, 4) = 0
      ITRKAR(IPTR, 5) = 0
      ITRKAR(IPTR, 6) = ILAY
      ITRKAR(IPTR, 7) = 0
      ITRKAR(IPTR, 8) = 0
      ITRKAR(IPTR, 9) = 0
      ITRKAR(IPTR,10) = NTRL
      ITRKAR(IPTR,11) = 0
      HRES(IPTR) = 0
      IPLBHT = (IPHT - HPTSEC(1))/2 + HPHL0
      LBHIT = NTRL*2
      LBHIT = LOR(LBHIT,MKLRHT(LBLR+2))
      HWRK(IPLBHT+1) = HWRK(IPLBHT)
      HWRK(IPLBHT  ) = LBHIT
      IERRFL = 0
      IPHT = IPTR
      RETURN
      END

C   10/03/79 209031402  MEMBER NAME  @LGHIST  (SOURCE)      FORTRAN
C
C    S.YAMADA   09-03-79  10:25
C     LAST MODIFICATION   09-03-79  23:25
C
C---- SIMPLE TEST PROGRAM FOR LGANAL FOR REAL DATA.
C
C
      IMPLICIT INTEGER *2 (H)
C
      COMMON /BCS/ IDATA(6000)
      DIMENSION  RDATA(6000),HDATA(12000)
      EQUIVALENCE (IDATA(1),RDATA(1)), (HDATA(1),IDATA(1))
C
      COMMON /CWORK/ LNG,HNORD,HNORML,HPOINT(4),HLGADC(2,2000),
     1               LGCL(3),LNGCL,NPNT(4),IDENT(2),NCLST,NCLBEC(3),
     2               ETOT(4),NNEUT,EGAM(4),IFLAG(5),NWPCL,CLMPRP(801)
      DIMENSION  MAPCL(51), HLGAD1(1000)
      EQUIVALENCE (MAPCL(1),CLMPRP(1)), (HLGADC(1,1),HLGAD1(1))
C
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3
      COMMON /CLGMSB/ AMSGVL(5)
      DIMENSION MSGVAL(5)
      EQUIVALENCE (AMSGVL(1),MSGVAL(1))
      COMMON /CTPCNS/ EBMGEV, BKGAUS
C
C---- INITIALIZATION
      CALL BINT(6000,4000,500,0)
C
      CALL LGINIT
      BKGAUS = 0.01
      ITH = 45
C
      NEV = 0
C
        DO 1000 N=1,300
C
C----   CHECK TIME
        IF( NTIME(DUM).LT.200 ) GO TO 100
C
        DATA NUNITI/1/
        CALL BREAD(NUNITI,&1000,&200)
C
        CALL KALIBR
        CALL CLOC( NPR,    'ALGN',1 )
        IF( NPR.GT. 0 ) GO TO 1
C
        CALL LGCALB(&1000)
C       LG-HIT MAP
    1   CALL LGHITM(JDMP)
        IF(JDMP.EQ.0) GO TO 30
        DATA JDCNT/0/
        JDCNT = JDCNT+1
        IF(JDCNT.GT.3) GO TO 30
                    WRITE(6,6666) N
 6666               FORMAT('0======== N=',I3,' ========')
                    CALL HPRS( 'HEAD',0)
                    CALL LGADCD(2,8)
                    CALL HPRS( 'ALGL',0)
C                   CALL BPRS( 'ALGN',1)
C                   CALL BPRS( 'ALGN',1)
C
   30   CALL LGANAL
C
C----   DUMP THE RESULTS
C       CALL LGSHOW
C       CALL LGADCD(2,5)
C----   SECOND STEP ANALYSIS
C       POINTERS OF THE NECESSARY BANKS
        NPPATR = 0
        NPR = 0
        NPCL = 0
        IPP = IBLN('PATR')
        NPPATR = IDATA(IPP)
C----   SHIFT NPPATR BY 1 TO SKIP THE BANK-DESCRIPTER WORD.
C----   TAKE ONLY 2-TRACK EVENTS
        IF( IDATA(NPPATR+2).NE.2) GO TO 20
        NEV = NEV+1
C
        CALL CLOC( NPR,    'ALGN',1 )
        CALL BLOC( NPCL,   'LGCL',1, &90)
        GO TO 10
C
C----   SOME BANK IS MISSING
   90   MSGVAL(1) =  NPPATR
        MSGVAL(2) =  NPR
        MSGVAL(3) =  NPCL
        CALL LGMESG( 1, 2 )
        GO TO 20
C
   10   CONTINUE
C***    CALL LGCDIR( NPPATR, NPR, NPCL )
        CALL LGHIST( NPCL )
C
C
   20   CALL BSLT
        CALL BDLG
C
 1000   CONTINUE
      GO TO 100
  200 MSGVAL(1) = N
      CALL LGMESG( 1,1 )
  100 WRITE(6,6100) N,NEV
 6100 FORMAT('0 NO.OF READ AND PLOTTED EVENTS=',2I6)
      CALL LGHITL
      CALL HISTDO
      STOP
      END
C
C/////////////////////////////////////////////////////
C
C
C---- DUMMY ENERGY CORRECTION
      SUBROUTINE LGECOR(ADATA,DEP,IFLAG)
C
C  THIS PROGRAM CALCULATE THE INCIDENT ENERGY
      IFLAG=0
      RETURN
C************************************
      ENTRY LGECR0(NVR)
C
C  VERSION NUMBER (DATE)   79 03 12    DUMMY SUB.
C
      DATA IVR/790312/
      NVR=IVR
      RETURN
      END

C   05/08/86 609171231  MEMBER NAME  FADCAX   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE FADCAX(NCELL,LINEAR,LDOS,LSEP)
C-----------------------------------------------------------------------
C
C    AUTHOR:   R. RAMCKE     23/10/84 :  DRAWS COORDINATES FOR FADC
C                                        DATA ON SCREEN
C       MOD:   J. HAGEMANN   23/07/85 :  FOR DIFFENCIATED PULSES
C       MOD:   G. ECKERLIN   05/08/86 :  NEW MEMBER FOR JETC DATA
C       MOD:   G. ECKERLIN   18/08/86 :  USER KOORDINATES USED NOW
C       MOD:   G. ECKERLIN   20/08/86 :  WIRE RANGE SELECTION SUPPORTED
C  LAST MOD:   G. ECKERLIN    4/09/86 :  DESPLAY DETAILS IMPLEMENTED
C
C------------------------------------------------------------
C
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LINEAR, LSEP, LDOS
C
      COMMON /CWORK1/ IAMP(300,2), ICWIR, IPED(2,16), NWIRNG(2), IT0
     +                ,ISTWIR(16), IENWIR(16), NP0WIR(16)
     +                ,ISPRE2(8), TPREV(8), ISPRE1(8)
C
C
#include "cgraph.for"
C
      COMMON / CORDER / KWR(17), KSIDE, KSTART, KEND, KTIMB, KEV
      COMMON / CKORD  / RX1, RX2,
     +                  RY1, RY2
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION KANAL(10), KAN(3), IAD(5)
      DIMENSION HDATSV(22), HMW(24), HTX(2), HCELL(2), HDIFF(11)
      DIMENSION HZETM(2), HZETP(2), HLIN(5)
C
      EQUIVALENCE ( HDATSV(1), IDATSV(1) )
C
      DATA KANAL / 48, 49, 50, 51, 52, 53, 54, 55, 56, 57 /
      DATA HTX   / 'DS', 'N ' /
      DATA HCELL / 'Ce', 'll' /
      DATA HDIFF / 'di','ff','er','en','ci','at','ed',' p','ul',
     *             'se','s ' /
      DATA HLIN  / 'no','n ','li','ne','ar' /
      DATA HZETM / ' -',' Z' /
      DATA HZETP / ' +',' Z' /
C
C-----------------  C O D E  -------------------------------------------
C
CX    CALL TRMOUT(80,' SUBROUTINE FADCAX^')
C
      KEV    = 1
      DO 2 I = 1,16
         KWR(I) = 1
    2 CONTINUE
      KWR(17) = NWIRNG(2) - NWIRNG(1) + 1
      KSIDE  = 3
      KSTART = 0
      KEND   = 256
      KTIMB  = 50
C
      NTIMB = KTIMB
      IF(KTIMB .EQ. 0) NTIMB = 10
C
      RY1 =  100.
      RY2 = 2950.
      IF( LSEP ) GOTO 10
         RX1 =  600.
         RX2 = 4000.
         GOTO 13
   10 CONTINUE
      LS = 1
      RX1 = 300.
      RX2 = 2100.
      GOTO 13
   12 LS  = 2
      RX1 = 2200.
      RX2 = 4000.
C
   13 IF( LSEP .AND. LS .EQ. 2 ) GOTO 50
C                                      WRITE DSN ON PICTURE
      CALL CHRSIZ(4)
      HMW(1) = HTX(1)
      HMW(2) = HTX(2)
C
      DO 14 I = 1, 22
         HMW(I+2) = HDATSV(I)
   14 CONTINUE
C
      CALL MOVEA(RX1 - 50., RY2 + 200.)
      CALL EOUTST(48, HMW)
C                                      WRITE RUN NUMBER ON PICTURE
      IRUN = HEAD(18)
      CALL INTADE(IRUN, IAD, 5)
      CALL MOVEA(RX1 - 50., RY2 + 50.)
      CALL HLABEL(5,IAD)
C                                      WRITE EVENT NUMBER ON PICTURE
      IEVT = HEAD(19)
      CALL INTADE(IEVT, IAD, 5)
      CALL SEELOC(IXAC, IYAC)
      RXAC = IXAC
      RYAC = IYAC
      CALL MOVEA(RXAC + 30., RYAC)
      CALL HLABEL(5, IAD)
C                                      WRITE CURRENT EVENT NUMBER
      CALL INTADE(ICREC, IAD, 5)
      CALL SEELOC(IXAC, IYAC)
      RXAC = IXAC
      RYAC = IYAC
      CALL MOVEA(RXAC + 30., RYAC)
      CALL HLABEL(5, IAD)
C                                      WRITE CELL NUMBER ON PICTURE
      CALL INTADE(NCELL, IAD, 2)
      CALL MOVEA(RX1 + 1800., RY2 + 200.)
      CALL EOUTST(4, HCELL)
      CALL SEELOC(IXAC, IYAC)
      RXAC = IXAC
      RYAC = IYAC
      CALL MOVEA(RXAC + 50., RYAC)
      CALL HLABEL(2, IAD)
C                                   WRITE 'NON LINEAR PULSES'IF
C                                   CDTL 52 IS NOT SET
      IF ( LINEAR ) GOTO 70
        CALL MOVEA( RX1 + 2150., RY2 + 200. )
        CALL EOUTST( 10,HLIN )
   70 CONTINUE
C                                      WRITE 'DIFFERENTIATED PULSES' ON
C                                      PICTURE IF CDTL51 IS SET
      IF( .NOT. LDOS ) GO TO 50
         CALL MOVEA( RX1 + 2500., RY2 + 200.)
         CALL EOUTST( 22, HDIFF )
C
   50 CALL NLINE(RX1, RY1, RX1, RY2, 0)
C
      IYREL = INT(RY2 - RY1)/KWR(17)
      NLIM  = KWR(17)
C
      DO 60 IW = 1, NLIM
          RYK = INT(RY1) + IYREL*(IW - 1)
C         WRITE (6,9000) IW
 9000     FORMAT(' CALL LINE :',I4)
          CALL NLINE(RX1, RYK, RX2, RYK, 0)
   60 CONTINUE
C
      IF( .NOT. LSEP ) GO TO 75
         CALL CHRSIZ(4)
         CALL MOVEA( RX1 + 800., RY2 + 40.)
         IF( LS .EQ. 1 ) CALL EOUTST( 4, HZETM )
         IF( LS .EQ. 2 ) CALL EOUTST( 4, HZETP )
C
   75 IF( .NOT. LDOS ) GO TO 100
         DO 80 IW = 1, NLIM
            RYK = INT(RY1) + IYREL*(IW - 1) + (IYREL - 50)*24/64
            CALL NLINE( RX1, RYK, RX2, RYK, 12 )
   80    CONTINUE
C
  100 ISCRCH = RX2 - RX1
      KRANGE = KEND- KSTART
      RYUP = RY2
      IF(KTIMB .EQ. 0) RYUP = RY1
      NB = KRANGE/NTIMB
      T0 = RX1 + ISCRCH*IT0/(85 * KRANGE)
      CALL NLINE(T0, RYUP, T0, RY1 - 20.,47)
      DO 200 JB = 1, NB
          RXWID = INT(RX1) + ISCRCH*NTIMB*JB/KRANGE
C         WRITE (6,9002) JB,RXWID,RYUP,RY1
 9002     FORMAT(' CALL LINE :',I5,3F10.3)
          CALL NLINE(RXWID, RYUP, RXWID, RY1 - 20., 38)
          ICHNR = KSTART + NTIMB*JB
          CALL MOVEA(RXWID - 40., RY1 - 50.)
          CALL CHRSIZ(4)
          IF(NTIMB .EQ. 1 .AND. ((ICHNR/2)*2 - ICHNR) .NE. 0) GOTO 200
          IF(ICHNR .GE. 10) GOTO 150
             KAN(1) = KANAL(1)
             KAN(2) = KANAL(1)
             KAN(3) = KANAL(ICHNR + 1)
             GOTO 170
  150     CONTINUE
          IF (ICHNR.GE.100) GOTO 160
            KAN(1) = KANAL(1)
            KAN(2) = KANAL(ICHNR/10 + 1)
            KAN(3) = KANAL(ICHNR -(ICHNR/10)*10 + 1)
            GOTO 170
  160     CONTINUE
          KAN(1) = KANAL(ICHNR/100 + 1)
          IDUM = (ICHNR - (ICHNR/100)*100)/10
          KAN(2) = KANAL(IDUM + 1)
          KAN(3) = KANAL(ICHNR -IDUM*10 -(ICHNR/100)*100 + 1)
  170     CALL HLABEL(3, KAN)
  200 CONTINUE
C
      IF( LSEP .AND. LS .EQ. 1 ) GOTO 12
C
      RETURN
      END
C
      SUBROUTINE INTADE( IN, IA, N )
C------------------------------------------------------------
C     VERSION 30/10/84
C     CONVERTS INTEGER INTO ADE-CODE
C------------------------------------------------------------
      DIMENSION IA(N)
      IZ = 10**(N-1)
      K = IN
      DO 10 J = 1, N
         IA(J) = K/IZ + 48
         K     = K - (K/IZ)*IZ
         IZ    = IZ/10
   10 CONTINUE
C
      IF( N .EQ. 1) GO TO 30
C                           MERGE ZEROES AT BEGIN
      NEND = N - 1
      DO 20 J = 1, NEND
         IF( IA(J) .GT. 48 ) GO TO 30
             IA(J) = 96
   20 CONTINUE
   30 CONTINUE
      RETURN
      END
C
      SUBROUTINE NLINE(RX1, RY1, RX2, RY2, NDRW)
C--------------------------------------------------------------
C     VERSION 7/3/83
C     DRAWS LINE (DASHES) FROM (RX1, RY1)  TO
C     (RX2, RY2)
C--------------------------------------------------------------
C
C     WRITE (6,9001) RX1,RY1,RX2,RY2
 9001 FORMAT(' RX1,RY1,RX2,RY2 :',4F10.3)
      CALL MOVEA(RX1, RY1)
      IF(NDRW .EQ. 0) CALL DRAWA(RX2, RY2)
      IF(NDRW .GT. 0) CALL DASHA(RX2, RY2, NDRW)
      RETURN
      END

C   23/06/78 509272145  MEMBER NAME  CONVEF   (WORKS)       FORTRAN
      FUNCTION CONVEF(ALAMDA)
C---- S.YAMADA   14-11-77
C     LAST MODIFICATION  20-10-78  16:45
C
C---- NEW DATA FROM HTV IS USED.
C---- CONVERSION  EFFICIENCY OF R594 PHOTOTUBE.
C---- ALAMDA = WAVE LENGTH IN NANO-METER.
C
      CONVEF = 0.0
      IF(ALAMDA.LE.280.1 .OR. ALAMDA.GT.700.0) RETURN
C---- CHANGE UNIT OF WAVE LENGTH TO MICRON-METER.
      A = 0.001*ALAMDA
      CONVEF = ((14.25*A-22.66)*A+10.77)*A-1.32-0.001/(A-0.28)
      IF(CONVEF.LT.0.) CONVEF = 0.
      RETURN
      END

      SUBROUTINE IGWLCM
      IMPLICIT NONE
*******************************************************************
*
*  Print welcome message of the JADE interactive graphics
*  program on the HIGZ window.
*
*  20/06/2000 Pedro Movilla Fernandez
*
******************************************************************
#include "cplot10.for"
      REAL XDOWN,XUP,YDOWN,YUP,XMID,YMID
C
      XDOWN = XTMIN+(XTMAX-XTMIN)/6.
      XUP   = XTMAX-(XTMAX-XTMIN)/6.
      YDOWN = YTMIN+(YTMAX-YTMIN)/2.
      YUP   = YTMAX-(YTMAX-YTMIN)/4.
      XMID  = (XDOWN+XUP)/2.
C - print title 
      CALL ISELNT(NTS)
      CALL IGPAVE(XDOWN,XUP,YDOWN,YUP,200.,1000,1011,'TRS')
      CALL ISTXFP(-6,2)
      CALL ISTXCI(4)
      CALL ISCHH(100.)
      CALL ISTXAL(2,3)
      CALL ITX(XMID,YUP*.92,' J A D E ')
      CALL ITX(XMID,YUP*.85,' Interactive  Graphics  Program ')
      CALL ISCHH(50.)
      CALL ISTXAL(1,3)
      CALL ITX(XDOWN*1.3,YUP*.76,' Original version: 17/10/88')
      CALL ITX(XDOWN*1.3,YUP*.72,' Modified for use on RS6000/AIX'
     + //' platforms: 18/11/99 (Pedro Movilla Fernandez)')
      CALL ISTXAL(3,0)
      CALL ISCHH(40.)

      CALL IUWK(0,1)
      CALL ISTXCI(1)
C - reset
      CALL SETCOL(' ')
      CALL IGDEF
C
      RETURN
      END

C   01/11/84 411011909  MEMBER NAME  RDRNHV   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDRNHV( IRNV, HITV )
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 25/04/79 :  CREATE RANDOM HIT IN
C             R. RAMCKE               VERTEX CHAMBER
C   LAST MOD  J. HAGEMANN 17/05/83 :  IMPROVED CODE
C
C      CREATE IRNV RANDOM HITS IN VERTEX CHAMBER AND STORE HITS
C      IN ARRAY HITV WITH INCREASING WIRE NUMBER.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cjvtxc.for"
#include "cgeov.for"
C
      DIMENSION HWBUFV(8), HITV(2)
C
C                          MAXIMUM DRIFTSPACE FOR EACH WIRE
      DIMENSION TWREL(7)
C
      DATA TWREL / 12.6, 13.8, 15.0, 16.2, 17.4, 18.7, 19.9 /
C
C------------------  C O D E  ------------------------------------------
C
      IHVTOT = IRNV
      IF( IHVTOT .EQ. 0 ) RETURN
      IL = 1
      IH = 1
C
C                            COMPUTE NEW HITS
      DO  100  J = 1, IHVTOT
         IWIRV = IFIX(AMIN1(168.*RN(DUM)+1,168.))
         HITV(IH) = IWIRV
C                            Z - AMPLITUDES
         ZET = ZVXCP*(1. - 2.*RN(DUM))
         HITV(IH+1) = HFIX(ZNAMP*(1 - ZET/ZMAXV))
         HITV(IH+2) = HFIX(ZNAMP*(1 + ZET/ZMAXV))
C                            DRIFT TIME
         NCEV =( IWIRV - 1 ) / 7
         IRV = IWIRV - NCEV * 7
         IF( IRV .LT. 1 .OR. IRV .GT. 7 ) GO TO 103
            HITV(IH + 3) = HFIX(TWREL(IRV)*RN(DUM)/TIMEV + .5)
  100       IH = IH + 4
C
            GO TO 105
  103    WRITE(6,104) IRV
  104    FORMAT('  --WARNING FROM RDRDMV-- WRONG WIRE NUMBER:', I4 )
         IH = IH + 4
  105    CONTINUE
C
C                            SORT HITS
         IWV4 = IHVTOT * 4
         M = IHVTOT
  200    M = M / 2
         IF( M .LE. 0 ) GO TO 500
            M4 = M*4
            K = IH - M4 - 4
            DO 400 J = IL, K, 4
               I = J
  300          IF( I .LT. IL ) GO TO 400
                  IM = I + M4
                  IF( HITV(I) .LT. HITV(IM) ) GO TO 400
                  IF( HITV(I) .EQ. HITV(IM) .AND.
     *                HITV(I+3) .GE. HITV(IM+3)) GO TO 400
                     IM2 = ( IM - 1 ) * 2
                     I2 = ( I - 1 ) * 2
                     CALL MVC( HWBUFV, 0, HITV, IM2, 8 )
                     CALL MVC( HITV, IM2, HITV, I2, 8 )
                     CALL MVC( HITV, I2, HWBUFV, 0, 8 )
                     I = I - M4
                     GO TO 300
  400       CONTINUE
            GO TO 200
  500    CONTINUE
      RETURN
      END

C   07/06/96 606071906  MEMBER NAME  RDDA     (S4)          FORTG1
      SUBROUTINE RDDA(NRC,NTOT,BUF)
C     BOS SUBPROGRAM  =4.6=
      COMMON/BCS/IW(1)
#include "ccs.for"
      INTEGER BUF(1610),BUFA(NTOT)
      IG=IUND-16
      GOTO (1,2,3),IG
    1 CONTINUE
      DEFINE FILE 17(200,1610,U,IVAR)
      GOTO 10
    2 CONTINUE
      DEFINE FILE 18(200,1610,U,IVAR)
      GOTO 10
    3 CONTINUE
      DEFINE FILE 19(200,1610,U,IVAR)
   10 READ(IUND'NRC) NTOT,BUF
      GOTO 100
C
      ENTRY WRDA(NRC,NTOT,BUFA)
      IF(NTOT.NE.0) WRITE(IUND'NRC) NTOT,BUFA
      IF(NTOT.EQ.0) WRITE(IUND'NRC) NTOT,NTOT
      GOTO 100
C
      ENTRY RDSQ(IUNTP,NTOT,BUFA,*)
      READ(IUNTP,END=101) NTOT,BUFA
      GOTO 100
C
      ENTRY WRSQ(IUNTP,NTOT,BUFA)
      WRITE(IUNTP) NTOT,BUFA
C
  100 RETURN
  101 RETURN 1
      END

C   16/02/81            MEMBER NAME  INCOSM   (PATRECSR)    FORTRAN
      SUBROUTINE INCOSM
C
C     THIS SUBROTINE OVERWRITES SOME LIMITS IN CPATLM
C     FOR COSMIC DATA
C
C
      IMPLICIT INTEGER*2 (H)
C
#include "cpatlm.for"
C
       XYF(2)=20.
       XYF(4)=20.
       GFP(2)=20.
       GFP(4)=20.
       IGFP(9)=1
       IGFP(10)=1
       RETURN
       END

      SUBROUTINE EXJHTL(IERR)
      IMPLICIT INTEGER*2 (H)
      LOGICAL TBIT
#include "cdata.for"
      IERR = 0
      IPJHTL = IDATA(IBLN('JHTL'))
      IPJETC = IDATA(IBLN('JETC'))
      IF(IPJETC.LE.0) RETURN
      IF(IPJHTL.LE.0) RETURN
      NHIT  = (HDATA(IPJETC*2+99)) / 4
16000 CONTINUE
        NWHTL = IDATA(IPJHTL)
        I0 = IPJHTL*2 + 1
        I9 = IDATA(IPJHTL)*2 + I0 - 1
        IF(NWHTL.GE.NHIT) RETURN
        NWDIFF = NHIT+1 - NWHTL
        CALL BCHM(IPJHTL,NWDIFF,IERR)
        IF(IERR.NE.0) RETURN
        IP0 =  IPJHTL*2+2
        IP1 =  IP0 + NHIT
        IP2 =  IP0 + NHIT*2
16002 CONTINUE
          LBHIT = HDATA(IP1)
      IF(
     - LBHIT.EQ.0
     -)THEN
            HDATA(IP2-1) = 0
            HDATA(IP2  ) = 0
      ELSE
            LBZ   = LAND (LBHIT, 1)
            LBB12 = ISHFTR(LBHIT,13)
            LBB12 = ISHFTL(LBB12, 9)
            LBHT1 = LAND (LBHIT,63)
            LBHT1 = LOR  (LBHT1,LBB12)
            IF(TBIT(LBHIT,25)) LBHT1 = IBITON(LBHT1,23)
            LBHT2 = ISHFTR(LBHIT, 6)
            LBHT2 = LAND (LBHT2,62)
      IF(
     - LBHT2.NE.0
     -)THEN
              LBHT2 = LOR  (LBHT2,LBZ)
              LBHT2 = LOR  (LBHT2,LBB12)
              IF(TBIT(LBHIT,19)) LBHT2 = IBITON(LBHT2,23)
      ENDIF
            HDATA(IP2-1) = LBHT1
            HDATA(IP2  ) = LBHT2
      ENDIF
        DATA NPR /0/
        NPR = NPR + 1
        IP2 = IP2 - 2
        IP1 = IP1 - 1
      IF(.NOT.(
     - IP1.LE.IP0
     -))GOTO 16002
16003 CONTINUE
        I0 = IPJHTL*2 + 1
        I9 = IDATA(IPJHTL)*2 + I0 - 1
      IPJHTL = IDATA(IPJHTL-1)
      IF(.NOT.(
     - IPJHTL.LE.0
     -))GOTO 16000
16001 CONTINUE
      RETURN
      END

C   07/06/96 606071851  MEMBER NAME  INDAR    (S4)          FORTG1
      SUBROUTINE INDAR(NAME,N,INDA,NLIM)
#include "acs.for"
      COMMON/BCS/IW(1)
      INTEGER INDA(1)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAMEV),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      K=LFDI+1
      DO 10 I=1,NLIM
      K=IW(K-1)
      IF(K.EQ.0) GOTO 100
   10 INDA(I)=K
      I=NLIM+1
  100 N=I-1
      RETURN
      END

C   14/09/79 911131438  MEMBER NAME  TRELTR   (JADEGS)      FORTRAN
      SUBROUTINE TRELTR(ITREL,MTR,MTR2)
      IMPLICIT INTEGER*2 (H)
C---
C---     FIND WHICH TRACKS MTR,MTR2 ARE ASSOCIATED TO TRACK ELEM. ITREL
C---
#include "cworkpr.for"
      DIMENSION MTRR(2)
C
      MTRR(1) = 0
      MTRR(2) = 0
      IF(ITREL.LT.0.OR.ITREL.GT.HNTR) GO TO 1001
      IAMB = 0
      IF(NTR.LE.0) GO TO 1002
      DO 2  ITR = 1,NTR
      KNREL = HNREL(ITR)
      IF(KNREL.LE.0.OR.KNREL.GT.9) GO TO 1003
      DO 2  INREL = 1,KNREL
      JNREL = HISTR(INREL,ITR)
      IF(ITREL.NE.IABS(JNREL)) GO TO 2
      IAMB = IAMB + 1
      IF(IAMB.GT.2) GO TO 1004
      MTRR(IAMB) = ITR*ISIGN(1,JNREL)
2     CONTINUE
2001  MTR = MTRR(1)
      MTR2 = MTRR(2)
      GO TO 2000
C * * *  ERROR MESSAGES
1001  WRITE(6,1101) ITREL
1101  FORMAT(' ERROR IN TRELTR:  ITREL = ',I10)
      GO TO 2001
1002  WRITE(6,1102) NTR
1102  FORMAT(' ERROR IN TRELTR:  NTR = ',I10)
      GO TO 2001
1003  WRITE(6,1103) KNREL
1103  FORMAT(' ERROR IN TRELTR:  KNREL = ',I10)
      GO TO 2001
C1004  WRITE(6,1104)
1104  FORMAT(' ERROR IN TRELTR:  MORE THAN TWO TRACKS ASSOCIATED WITH A
     $ TRACK ELEMENT')
1004  GO TO 2001
2000  RETURN
      END

C   07/06/96 606071919  MEMBER NAME  YLOW     (S4)          FORTG1
      SUBROUTINE YLOW(Y,Z,N,R)
      REAL Y(N),Z(N),R(4)
      DO 1 J=1,4
    1 R(J)=0.0
      Z(1)=Y(1)
      DO 2 I=2,N
    2 Z(I)=Z(I-1)+Y(I)
      IF(Z(N).EQ.0.0) GOTO 100
      ZL=0.46*Z(N)
      IL=1
      IH=1
      NMIN=M+1
    4 ZA=Z(IL)-Y(IL)
    6 IF(Z(IH)-ZA.GT.ZL) GOTO 8
      IF(IH.EQ.N) GOTO 16
      IH=IH+1
      GOTO 6
    8 NM=IH-IL+1
      IF(NM-NMIN) 10,12,14
   10 ILM=IL
   12 IHM=IH
      NMIN=NM
   14 IL=IL+1
      GOTO 4
   16 SUM1=0.0
      SUM2=0.0
      DO 18 I=ILM,IHM
      SUM1=SUM1+Y(I)
   18 SUM2=SUM2+Y(I)*FLOAT(I)
      R(1)=SUM1
      R(2)=SUM2/SUM1
      R(3)=0.82*FLOAT(IHM-ILM+1)
      R(4)=SUM1/FLOAT(IHM-ILM+1)
  100 RETURN
      END

C   14/06/82 206142136  MEMBER NAME  TMUC822  (S)           FORTRAN
      SUBROUTINE TMUCUT(IPCLST,LHIST)
      INTEGER *2 HADC,HTDC
      COMMON/RJECT/IREJ,KREJ
      COMMON/MOMSTF/DM1,DM2,SAG,SNDFI,ACOP,PN1,PN2
      COMMON/TFPRM/ NRNC1,NRNC2,DYC1,DYC2,IFLC(42),CM(42),CP(42),
     -DTAU(42),WM(42),WP(42),SV(42),DM(42),DP(42),PEDLM(42),PEDLP(42)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HB(42)
***PMF#include "ddatas.for"
#include "ddata.for"
      COMMON/TRKCLS/IBH,LCL(2,10),DXLG(2,10),DYLG(2,10),DZLG(2,10),
     1              ENCL(2,10),PHILG(2,10),ZLG(2,10)
      COMMON/TRGWRD/IANDOR
      COMMON/CLUST/NCLST,ETOTB,ALFLG(10),ACOPL(10)
      COMMON/TRACC/NNACC,ALF(10),NMALF
      COMMON/PU/ NTOF,NBEAM,IHIT(150),ILG(50),DPHI
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/LGCUT/ELGCUT,ETCUT,ALFCUT,ACUT,TDTCUT,PCUT
      COMMON/TRKVTX/XCLOS(10),YCLOS(10),ZCLOS(10),XVTX(10),YVTX(10),
     1              ZVTX(10)
      COMMON/TRKINF/NTRK,DX1(10),DY1(10),DZ1(10),DXL(10),DYL(10),
     1              DZL(10),NXY(10),NRZ(10),CHIXY(10),DRZ(10),CHIRZ(10),
     2              X1(10),Y1(10),Z1(10),XL(10),YL(10),ZL(10),ZVER(10),
     3              NGOOD,IGOOD(10),PMOM(10),FI1(10),FIL(10),
     4              NFIN,ITRK1(10),ITRK2(10),RMIN(10)
      COMMON/ENRGMG/BENGEV,BKGAUS,EGCOR
      COMMON/INCLI/RTHET(10)
      COMMON/TOFRES/TOFLGT(10),TDT(10),TDR(10),BETA(10),IQUAL(10)
     1          ,ITOFHT(10),PATH(10),MUCAND,IMUCND(10),NMU,IMUFIN(10)
     2          ,TAUR(42,2)
      COMMON/DT4/NTGOOD(10),DDT1(10),DDT2(10),DDT3(10),DDT4(10)
      COMMON/TMTP/TAUM(42),TAUP(42)
      COMMON/MUTRK/NTRMU,IMUIN(10),IQUMU(10),ILAYR(10),NTHITS(10),
     1             CHIMU(10),ILASTL(10),IMUEF(10)
      COMMON/FLAGS/HISTFL,PRFL,NPRLIM
      COMMON/INOUT/WRITFL,EVWRIT,EVSEL,EVFL(10)
      LOGICAL WRITFL,EVWRIT,HISTFL,PRFL,PRSPC,EVSEL,EVFL
      DIMENSION JTRK(2),ECLUST(2),PLIM(2)
C
      DATA IBUG/0/,IENTRY/0/,KBUG/20/,LBUG/0/
C  TIME AND ENERGY DEPENDENT CUTS
      ELGCUT = EGCOR/3.
      ETCUT = 2.*ELGCUT
      ACUT = 1.
      IF(NRUN.LT.6060) ACUT = .76
      PCUT = EGCOR/3.
C
      IF(IENTRY.NE.0)  GOTO  10
      IENTRY = 1
      CFIC = 3.142/12.
      CTOF = 3.142/21.
C CONSTANT CUTS
      TDTCUT = 3.00
      ALFCUT = .200
      PRINT 924,ACUT,TDTCUT,PCUT,ELGCUT,ETCUT,ALFCUT
  924 FORMAT(' THETA ACC CUT',T20,F10.3/' TDTCUT',T20,F10.2/' PCUT',T20,
     1 F10.1/' ELGCUT',T20,F10.1/' ETCUT ',F10.2/
     2 ' ALFCUT',T20,F10.3//)
      ID = 2000
      CALL HBOOK1(3508,20HLTGOOD             $,100,0.,100.)
C
      CALL HBOOK1(ID+12,20H  ALFATR           $,100,0.,1.)
      CALL HINTEG(ID+12,3HYES)
      IF(LHIST.NE.1)  GOTO  11
      CALL HBOOK1(ID+29,20H P AVERAGE         $,100,0.,50.)
      CALL HBOOK2(ID+13,' ELG1 ELG2$', 40,0.,8.,40,0.,8.)
      CALL HBOOK2(ID+8,' DZ1 QUMU $',100,-1.,1.,5,0.,5.)
      CALL HTABLE(ID+22,20HQUAL1 QUAL2        $,4,-2.,2.,4,-2.,2.,8191.)
C
      CALL HBOOK2(ID+3,15HLTGOOD DT1800 $,100,-10.,15.,5,0.,5.)
      CALL HBOOK2(ID+4,20HT1 T2              $,40,-5.,15.,40,-5.,15.)
      CALL HBOOK1(ID+5,20HTDT                $,100,-10.,15.)
      CALL HBOOK2(ID+6,15HZ1 Z2         $,25,-150.,150.,25,-150.,150.)
      CALL HBOOK1(ID+7,20H ZZVV              $,100,-200.,200.)
      CALL HBOOK1(ID+9,10HCOS THETA$,100,-1.,1.)
      CALL HBOOK1(ID+10,20HTHETA              $,100,-1.,1.)
      CALL HBOOK1(ID+11,20HFI                 $,100,0.,6.)
   11 IF(LHIST.NE.2)  GOTO  10
   10 CONTINUE
C
      NMU = 0
      EVWRIT = .FALSE.
      EVSEL  = .FALSE.
      EVFL(2)  = .FALSE.
      IREJ = 1
      CALL HF1(3508,39.,1.)
      IF(MUCAND.LE.0) GOTO  60
      CALL HF1(3508,40.,1.)
      IREJ = 3
      NCLST = IDATA(IPCLST+7)
      NCLSTB = IDATA(IPCLST+8)
      ETOTB = DATA(IPCLST+12)
C
      IF(NCLST.LE.0) GOTO  24
      CALL HF1(3508,41.,1.)
      CALL CONBHA(IPCLST,0)
C
   24 CONTINUE
      IF(MUCAND.GT.10) MUCAND = 10
      CALL ALPHA
      DO   2000   N = 1,MUCAND
      IMUFIN(N) = 0
      NF = IMUCND(N)
      I1= ITRK1(NF)
      I2= ITRK2(NF)
      JTRK(1) = I1
      JTRK(2) = I2
C  ASSIGN CLUSTER TO TRACK
      ECLUST(1) = 0.
      ECLUST(2) = 0.
      ALFLG(NF) = 1000.
      ACOPL(NF) = 1000.
      IF(LCL(1,NF).GT.0) ECLUST(1) = ENCL(1,NF)
      IF(LCL(2,NF).GT.0) ECLUST(2) = ENCL(2,NF)
      CALL HFILL(ID+13,ECLUST(1),ECLUST(2))
C
C COMPUTE ACOLLINEARITY LEADGLASS
C
      IF(LCL(1,NF).LE.0.OR.LCL(2,NF).LE.0)  GOTO 25
      CALL HF1(3508,42.,1.)
      DXLG1 = DXLG(1,NF)
      DXLG2 = DXLG(2,NF)
      DYLG1 = DYLG(1,NF)
      DYLG2 = DYLG(2,NF)
      DZLG1 = DZLG(1,NF)
      DZLG2 = DZLG(2,NF)
      COS = DXLG1*DXLG2 + DYLG1*DYLG2 + DZLG1*DZLG2
      IF(ABS(COS).GE.1.)  GOTO  91
      ALFLG(NF) = 3.142-ABS(ACOS(COS))
   91 COPLN1 = SQRT(DXLG1*DXLG1+DYLG1*DYLG1)
      COPLN2 = SQRT(DXLG2*DXLG2+DYLG2*DYLG2)
      IF(ABS(COPLN1*COPLN2).LE..00000001)  GOTO  25
      COP = (DXLG1*DXLG2+DYLG1*DYLG2)/COPLN1/COPLN2
      IF(ABS(COP).GE.1.)  GOTO  25
      ACOPL(NF) = 3.142-ABS(ACOS(COP))
   25 CONTINUE
C
      T1 = TDR(JTRK(1))
      T2 = TDR(JTRK(2))
      ITOF1 = ITOFHT(JTRK(1))
      T1M = TAUR(ITOF1,1)
      T1P = TAUR(ITOF1,2)
      ITOF2 = ITOFHT(JTRK(2))
      T2M = TAUR(ITOF2,1)
      T2P = TAUR(ITOF2,2)
C
      ZZVV = .5*(ZVER(I1)+ZVER(I2))
      IQU1 = IQUAL(I1)
      IQU2 = IQUAL(I2)
      IF(ITOF1.EQ.8.OR.ITOF1.EQ.11)  GOTO  150
      IF(IQU1.LT.0.OR.IQU2.LT.0) EVFL(2) = .TRUE.
      GOTO  151
  150 IF(IQU2.LT.0) EVFL(2) = .TRUE.
  151 P1 = ABS(PMOM(I1))
      P2 = ABS(PMOM(I2))
      PB1 = PMOM(I1)
      PB2 = PMOM(I2)
      PAV = .5*(P1+P2)
      DDX1 = 3.142-ACOS(DX1(I1))-ACOS(DX1(I2))
      DDY1 = 3.142-ACOS(DY1(I1))-ACOS(DY1(I2))
      DDZ1 = 3.142-ACOS(DZ1(I1))-ACOS(DZ1(I2))
C
C  ACCEPTANCE CUT
C
      IREJ = 5
      IF(ABS(DZ1(I1)).GT.ACUT)  GOTO  2000
      IF(ABS(DZ1(I2)).GT.ACUT)  GOTO  2000
      CALL HF1(3508,43.,1.)
C
C  PLOTS BEFORE CUTS
C
      ID = 2000
      IF(LHIST.LE.0)  GOTO  71
      CALL HFILL(ID+4,TDR(JTRK(1)),TDR(JTRK(2)),1.)
      CALL HF1(ID+5,TDT(N),1.)
      CALL HFILL(ID+6,ZVER(JTRK(1)),ZVER(JTRK(2)),1.)
      CALL HFILL(ID+3,TDT(N),NTGOOD(N))
      CALL HF1(ID+7,ZZVV,1.)
      DO   70   L=1,2
      CALL HF1(ID+10,DZ1(JTRK(L)),1.)
      CALL HF1(ID+11,ABS(FI1(JTRK(L))),1.)
   70 CONTINUE
C
      PLIM(1) = PB1
      PLIM(2) = PB2
      IF(P1.GE.30.) PLIM(1) = 29.*PMOM(I1)/ABS(PMOM(I1))
      IF(P2.GE.30.) PLIM(2) = 29.*PMOM(I2)/ABS(PMOM(I2))
      CALL HF1(ID+29,PAV,1.)
      CALL HFILL(ID+22,FLOAT(IQUMU(I1)),FLOAT(IQUMU(I2)))
   71 CONTINUE
C
C  CUTS
C
      DO   7   I=1,2
      IF(LCL(I,NF).LE.0)  GOTO  7
      IREJ = 6+I
      IF(ECLUST(I).GT.ELGCUT)  GOTO  2000
    7 CONTINUE
      CALL HF1(3508,45.,1.)
      IREJ = 9
      IF(ABS(ZVER(I1)).GT.150.)  GOTO  2000
      IF(ABS(ZVER(I2)).GT.150.)  GOTO  2000
      CALL HF1(3508,47.,1.)
      IREJ = 10
      IF(ABS(ZZVV).GT.100.)  GOTO  2000
      CALL HF1(3508,49.,1.)
      IREJ = 12
      IF(TDT(N).GT.TDTCUT)  GOTO  2000
      CALL HF1(3508,51.,1.)
      IREJ = 13
C     IF(NTGOOD(N).LT.4)  GOTO  2000
      CALL HF1(3508,52.,1.)
      IREJ = 14
      IF(RMIN(I1).GT.20..AND.RMIN(I2).GT.20.)  GOTO  2000
      IF(RMIN(I1).GT.5.OR.RMIN(I2).GT.5.)  EVFL(2) = .TRUE.
      IREJ = 15
      CALL HF1(3508,53.,1.)
      IF(T1.LT.-1..OR.T1.GT.7.) GOTO  2000
      IF(T2.LT.-1..OR.T2.GT.7.) GOTO  2000
      IREJ = 17
      CALL HF1(3508,55.,1.)
      IF(ABS(PB1).LT.1. OR.ABS(PB2).LT.1.) GOTO  2000
      IREJ = 19
      CALL HF1(3508,57.,1.)
      CALL HF1(ID+12,ALF(NF),1.)
      IF(ALF(NF).GT.ALFCUT)  GOTO  2000
      CALL HF1(3508,61.,1.)
      IF(PAV.LT.PCUT)  GOTO  2000
      CALL HF1(3508,63.,1.)
      IREJ = 23
      IF(ABS(DDX1).GT..2)  GOTO  2000
      IF(ABS(DDY1).GT..2)  GOTO  2000
      IF(ABS(DDZ1).GT..3)  GOTO  2000
      CALL HF1(3508,65.,1.)
      IREJ = 25
      IF(ETOTB.GT.ETCUT)  CALL HF1(3508,67.,1.)
      CALL TRLTCH
      ITRB = IAND(IANDOR,48)
      ITR1 = IAND(ITRB,16)
      ITR2 = IAND(ITRB,32)
      IF(ITR1.GT.0)  CALL HF1(3508,80.,1.)
      IF(ITR2.GT.0)  CALL HF1(3508,81.,1.)
      IF(ITR1.GT.0.AND.ITR2.LE.0)  CALL HF1(3508,82.,1.)
      IF(ITR2.GT.0.AND.ITR1.LE.0)  CALL HF1(3508,83.,1.)
C     IF(ITR1.LE.0)  GOTO  2000
C     IF(ETOTB.GT.ETCUT)  EVWRIT = .TRUE.
C
C CALCULATE WHICH CELL LAST POINT IS IN
      AF = 0.
      IC1 = (FIL(I1)-AF*CFIC)/CFIC+1
      IC2 = (FIL(I2)-AF*CFIC)/CFIC+1
      DFI1 = FIL(I1)-(FLOAT(IC1)-.5+AF)*CFIC
      DFI2 = FIL(I2)-(FLOAT(IC2)-.5+AF)*CFIC
C
      CALL NEWMOM(I1,I2,0)
      IF(ABS(DZ1(I1)).LT..75.AND.ABS(DZ1(I2)).LT..75) GOTO  65
      EVWRIT = .FALSE.
      CALL HF1(3508,90.,1.)
      NQUMU = 0
      IF(IQUMU(I1).GT.0)  NQUMU = NQUMU + 1
      IF(IQUMU(I2).GT.0)  NQUMU = NQUMU + 1
      IF(LHIST.NE.0) CALL HFILL(ID+8,DZ1(I1),FLOAT(NQUMU))
      IF(NQUMU.GT.0)  EVWRIT = .TRUE.
      IF(EVWRIT) CALL HF1(3508,92.,1.)
      IREJ = 27
C     IF(.NOT.EVWRIT) PRINT 165,NTRK,NTRMU,(IQUMU(LK),LK=1,NTRMU)
C     IF(.NOT.EVWRIT) PRINT 165,I1,I2,NQUMU,(IQUMU(LK),LK=1,NTRK)
C 165 FORMAT(' I1,I2,NQUMU,IQUMU',10I5)
C     IF(.NOT.EVWRIT) CALL MUR2PR
      IF(.NOT.EVWRIT) GOTO  2000
   65 IREJ = 30
      NMU = NMU + 1
      IMUFIN(N) = 1
      EVWRIT = .TRUE.
      IF(EVWRIT) CALL HF1(3508,94.,1.)
      IF(LHIST.NE.0) CALL HF1(ID+9,DZ1(I1),1.)
C
 2000 CONTINUE
C
   60 CALL HF1(3508,FLOAT(IREJ),1.)
      CALL HF1(3508,FLOAT(NMU)+70.,1.)
      IF(NMU.GT.0)  RETURN
C REJECTED
      LBUG = LBUG + 1
C     IF(LBUG.LE.20) PRINT 255,NRUN,IEV,NEV,IREJ,KREJ
  255 FORMAT(' REJECT CODE',5I5)

      RETURN
      END

C   07/06/96 606071836  MEMBER NAME  BWRS     (S4)          FORTRAN
      SUBROUTINE BWRS(IUN,NBUFL,INIW)
C     BOS SUBPROGRAM =3.5=
      EXTERNAL BOUTP
#include "acs.for"
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      INTEGER ITWO/2/
      EQUIVALENCE (TWO,ITWO)
      INTEGER HIDD/'HIDD'/
      REAL OR
      EXTERNAL OR
C
C     ISAVB=0 INTO ACS
C
C
C     BUFFER FOR OUTPUT = BANK ('+BUF',IUN), LENGTH = 10 + NRECL
C
C     IBF+ 1   =2 (OUTPUT)
C          2   BUFFER SIZE
C          3   OUTPUT MODE (0 = SINGLE RECORDS, NO RECORD, IF TOO LARGE
C                           1 = SINGLE RECORD OR SEVEREAL RECORDS
C                           2 = LSB-RECORDS)
C          4   NR OF RECORDS
C          5   NR OF EVENTS ACCEPTED
C          6   NR OF EVENTS, WHICH ARE TOO LARGE
C          7   SUM OF NR OF WORDS IN ALL EVENTS
C          8   MAX NR OF WORDS IN AN EVENT
C          9   HIDD-NR
C         10   POINTER WITHIN RECORD TO NEXT EVENT
C         ----------------
C         11   NTOT (= NR OF WORDS IN THE RECORD FOLLOWING)
C         12   RECORD
C          .   . . .
C          .   . . .
C
C     LOCATE BUFFER BANK
   10 IF(IBFI.EQ.0) IBFI=IBLN('+BUF')+1
      IBF=IBFI
    2 IBF=IW(IBF-1)
      IF(IBF.EQ.0)        GOTO    90
      IF(IW(IBF-2).LT.IUN) GOTO 2
      IF(IW(IBF-2).GT.IUN) GOTO    90
      IF(IW(IBF+1).EQ.2) GOTO 11
C     UNIT IS INCORRECT
      ICOND=24
      CALL BDMP
   11 IF(IW(IBF+10)+3.NE.0) GOTO 12
      IF(ISAVB.NE.0) IW(ISAVB)=NSAVB
      ISAVB=0
  111 IW(IBF+10)=0
      INIW=0
      GOTO 100
   12 IF(IW(IBF).NE.16) GOTO 13
      IER=0
      IF(IN.GT.0.AND.IW(IBF+3).NE.0) CALL BCHF(IBF,IW(IBF+2)+10,IER)
      IF(IER.NE.0) GOTO 92
   13 ISTAT=1
      IF(IW(IBF+10)+1) 14,16,18
   14 ISTAT=ISTAT+1
   16 ISTAT=ISTAT+1
      IW(IBF+10)=0
   18 IF(IW(IBF+10).NE.0) GOTO 20
      IW(IBF+ 9)=0
      IW(IBF+10)=12
C
   20 INDH=IBF+IW(IBF+10)
      NL  =IBF+IW(IBF)-INDH+1
      IF(IN.LE.0) GOTO 71
      IF(IW(IBF+3).EQ.0) GOTO 21
      IF(NL.LT.9) GOTO 71
C     NEW HIDD-BANK
   21 IW(IBF+9)=IW(IBF+9)+1
      IW(INDH  )=HIDD
      IW(INDH+1)=IW(IBF+9)
      IW(INDH+2)=0
      IW(INDH+3)=1
      IW(INDH+4)=0
      IBIC=INDH+4
      INDH=INDH+5
      NL  =NL  -5
      GOTO (30,50,60),ISTAT
C     NEW EVENT
   30 IC=0
      IW(IBF+5)=IW(IBF+5)+1
      NTOTE=0
      IF(IW(IBF+3).EQ.2) GOTO 31
C     CHECK ORDER AND LENGTH EXCEPT FOR MODE=2
      NTOT=IW(IBF+3)
      INIA=IW(IBF+2)
      CALL BORDP(NTOT,INIA)
      IBF=IBFI
   33 IBF=IW(IBF-1)
      IF(IBF.EQ.0) GOTO 92
      IF(IW(IBF-2)-IUN) 33,35,92
   35 IF(NTOT.EQ.0) GOTO 111
      IF(IW(IBF+3).EQ.1) GOTO 37
C     MODE=0
      IF(INIA.NE.0) GOTO 36
C     TOO LARGE
      IW(IBF+5)=IW(IBF+5)-1
      IW(IBF+6)=IW(IBF+6)+1
      IW(IBF+8)=MAX0(IW(IBF+8),NTOT)
      GOTO 111
C     DIRECT WRITE
   36 INIW=INIA-1
      NBUFL=NTOT+1
      IW(IBF+7)=IW(IBF+7)+NTOT
      IW(IBF+8)=MAX0(IW(IBF+8),NTOT)
      IW(IBF+4)=IW(IBF+4)+1
      IW(IBF+10)=-3
      ISAVB=INIW
      NSAVB=IW(ISAVB)
      IW(ISAVB)=NTOT
      GOTO 100
C     MODE=1
   37 IF(INIA.GT.0) GOTO 36
      GOTO 39
C     EVENT LOOP FOR MODE=1 AND 2
   31 NROUT=NROUT+1
   39 J=0
   32 J=J+1
      IF(J.LE.IN) GOTO 40
C     ALL BANKS DONE
      IF(IC.NE.0) IC=3
      IW(IBIC  )=IC
      IW(IBIC-1)=INDH-IBIC
      IF(IW(IBIC-1).LE.1) INDH=INDH-5
      IW(IBF+10)=INDH-IBF
   34 INIW=0
      IW(IBF+7)=IW(IBF+7)+NTOTE
      IW(IBF+8)=MAX0(IW(IBF+8),NTOTE)
      IF(IW(IBF+3).EQ.2) GOTO 100
      IW(IBF+4)=IW(IBF+4)+1
      INIW=IBF+11
      IF(IC.NE.3) INIW=IBF+16
      IW(INIW)=INDH-IBF-12
      IF(IC.NE.3) IW(INIW)=INDH-IBF-17
      NBUFL=IW(INIW)+1
      IW(IBF+10)=-3
      GOTO 100
C     NEXT NAME
   40 IND=IW(NLST+J)
      NIND=IW(IND)
      IF(NIND.NE.0) RW(IOLST+IND)=OR(RW(IOLST+IND),TWO)
   42 IND=NIND
      IF(IND.LE.0) GOTO 32
      NIND=IW(IND-1)
C     NEXT BANK
   50 LENG=IW(IND)+4
      IF(NL.LT.4) GOTO 64
      NTOTE=NTOTE+LENG
      NC=MIN0(LENG,NL)
      CALL UCOPY(IW(IND-3),IW(INDH),NC)
      IW(INDH+3)=NC-4
      INDH=INDH+NC
      NL  =NL  -NC
      LENG=LENG-NC
      IF(LENG.LE.0) GOTO 42
      NLC=NC
      GOTO 62
C     COPY INTERRUPTED BANK
   60 CALL UCOPY(IW(IND-3),IW(INDH),4)
      NC=MIN0(LENG,NL-4)
      IW(INDH+3)=NC
      CALL UCOPY(IW(IND-3+NLC),IW(INDH+4),NC)
      INDH=INDH+4+NC
      NL  =NL  -4-NC
      LENG=LENG-NC
      IF(LENG.LE.0) GOTO 42
      NLC=NLC+NC
C     BANK DIVIDED BETWEEN RECORDS
   62 IW(IBF+10)=-2
      GOTO 70
C     LAST BANK COMPLETED IN LAST RECORD
   64 IW(IBF+10)=-1
C
   70 IF(IC.LT.2) IC=IC+1
      IW(IBIC  )=IC
      IW(IBIC-1)=INDH-IBIC
      GOTO 72
   71 IW(IBF+10)=0
   72 IW(IBF+11)=INDH-IBF-12
      INIW=IBF+11
      IF(IW(INIW).EQ.0) INIW=0
      IF(INIW.EQ.0) IW(IBF+10)=0
      IF(INIW.NE.0.AND.IW(IBF+3).GE.1) IW(IBF+4)=IW(IBF+4)+1
      NBUFL=IW(IBF)-10
      IF(IW(IBF+3).EQ.2) GOTO 100
      IF(INIW.NE.0) NBUFL=IW(INIW)+1
      GOTO 100
C
   90 CALL BCRE(IBF,'+BUF',IUN,16,&92,IER)
      IW(IBF+1)=2
      IW(IBF+2)=NRECL
      GOTO 12
C
   92 ICOND=13
      CALL BDMP
C     OPEN OUTPUT BUFFER
      ENTRY BWRO(IUN,NBUFL,INIW)
C     ARGUMENTS UNIT BUFFERSIZE MODE
      CALL BDLS('+BUF',IUN)
      CALL BCRE(IBF,'+BUF',IUN,16,&92,IER)
      IW(IBF+1)=2
      IW(IBF+2)=NBUFL
      IW(IBF+3)=INIW
      IF(IW(IBF+3).LT.0.OR.IW(IBF+3).GT.2) IW(IBF+3)=0
  100 RETURN
      END

C   07/06/96 606071818  MEMBER NAME  BINLDA   (S4)          FORTG1
      SUBROUTINE BINLDA(IUNDA,NREC,IPASS)
C     BOS SUBPROGRAM   =4.2=
      COMMON/BCS/IW(1)
#include "ccs.for"
      INTEGER DIRA/'+DIR'/
      REAL*8 DATE(2)
      EXTERNAL RDDA
      WRITE(6,101) IUNDA,NREC
      CALL BDLS('+DIR',IUNDA)
      CALL BCRE(INDA,'+DIR',IUNDA,52,&100,IER)
      IUND=IUNDA
      NPRIME=NREC/20
      IF(NPRIME.LE.3) NPRIME=3
      NPRIME=NPRIME-2
   10 NPRIME=NPRIME+2
      A=NPRIME
      J=SQRT(A)
      DO 20 K=3,J,2
      NDIV=NPRIME/K
      IF(NDIV*K.EQ.NPRIME) GOTO 10
   20 CONTINUE
      IW(INDA+1)=49
      IW(INDA+2)=DIRA
      IW(INDA+3)=0
      IW(INDA+4)=0
      IW(INDA+5)=45
      IW(INDA+6)=NREC
      IW(INDA+7)=NPRIME+2
      IW(INDA+8)=NPRIME
      IW(INDA+19)=IPASS
      CALL DAY(DATE(1),DATE(2))
      CALL UCOPY(DATE,IW(INDA+21),4)
      CALL UCOPY(DATE,IW(INDA+25),4)
      CALL UCOPY(DATE,IW(INDA+29),4)
      CALL WRDA(1,IW(INDA+1),IW(INDA+2))
      CALL BDLS('+DIR',IUNDA)
      CALL BLOADA(IUNDA,0,IPASS)
      WRITE(6,102)
  100 RETURN
  101 FORMAT('0---- BINLDA    START FOR DA-DATASET',I3,
     1   ' WITH SPACE FOR',I6,' RECORDS')
  102 FORMAT('0---- BINLDA    END')
      END

C   22/03/97 703221634  MEMBER NAME  JEOSUM1  (JADEMUS)     FVS
C   22/03/97 703221633  MEMBER NAME  #MUPR    (JADEMUS)     FVS
//F22MCCP3 JOB 10622622,CLASS=L,TIME=(01,00),MSGLEVEL=(1,1)
//*MAIN LINES=(9),RELPRI=HIG,ORG=EXT
// EXEC FCLG,REGION.GO=896K
      IMPLICIT INTEGER*2 (H)
      DATA IVERSN/20/
C-------------------------------------
#include "cdata.for"
#include "ciouni.for"
#include "cmucalib.for"
#include "cmuffl.for"
C
      INTEGER*4 UN,UN1,SECT
      COMMON/CWORK/IDUMMY
      COMMON /TRAX/ PHIT(40),THETAT(40),NHRPHI(40)
C
C----------------------------------------------------------------------
      COMMON /CDEV/ ITRAK,ND,NDHIT(20),NDCHAM(20),XDEV(20),SDEV(20)
C
C  CDEV IS THE 'DEVIATIONS COMMON'.
C
C  I  ITRAK        IS THE CURRENT TRACK NO. IN CALLING PROGRAM;
C  O  ND           IS THE NO. OF HITS FOR WHICH DEVIATIONS ARE OUTPUT
C                  FOR THIS TRACK. THIS IS DEPENDENT ON MUFFLD   ;
C  O  NDHIT(1->ND) ARE THE HIT NOS OF THESE HITS ;
C  O  NDCHAM( "  ) ARE THE CHAMBER NOS OF THESE HITS ;
C  O  XDEV  ( "  ) ARE THE ABSOLUTE DEVIATIONS OF THESE HITS FROM THE
C                  EXTRAPOLATED JET CHAMBER TRACK ;
C  O  SDEV  ( "  ) ARE THE STANDARD DEVIATIONS OF THESE HITS FROM THE
C                  EXTRAPOLATED JET CHAMBER TRACK .
C
C---------------------------------------------------------------------
C
C  ASSIGN A UNIT NO. TO EACH OF THE 634 CHAMBERS . THE SCHEME IS
C  AS FOLLOWS :
C              UNICH=1N -X SIDE WALL CHAMBERS , EXCLUDING INNER LAYER ,
C                        LAYER N ;
C              UNICH=2N +X SIDE WALL CHAMBERS , EXCLUDING INNER LAYER ;
C              UNICH=3MN      PLINTH CHAMBERS , EXCLUDING INNER LAYER ;
C                             N=LAYER NO. , M= 1 FOR -X ,  2 FOR +X ;
C              UNICH=4MN  -X    ROOF CHAMBERS , EXCLUDING INNER LAYER ;
C              UNICH=5MN  +X    ROOF CHAMBERS , EXCLUDING INNER LAYER ;
C                               M=QUADRANT NO. , N=LAYER NO.
C                               ROOF L2 HAS  QUADRANT NOS. 1 & 2 ;
C                               ROOF L3,4,5 HAVE  QUAD NOS. 3,4,5,6 .
C              UNICH=6     ALL INNER LAYER CHAMBERS ;
C              UNICH=7N  -Z -X END WALL CHAMBERS ; N INDICATES LAYER NO.
C              UNICH=8N  -Z +X END WALL CHAMBERS ;
C              UNICH=9N  +Z -X END WALL CHAMBERS ;
C              UNICH=10N +Z +X END WALL CHAMBERS ;
C
C   CONVENTIONS FOR UNICH  :
C   (1)  UNICH/10  =  UNIT NO. IN RANGE 1 --> 10  ;
C   (2)  MOD(UNICH,10) =  LAYER NO. WITHIN QUADRANT ;
C   (3)  MOD(UNICH,100) - LAYER NO. = QUADRANT NO.  (ROOF CHAMBERS ONLY)
C                                                 (HALF NO. FOR PLINTH
      INTEGER*4 UNICH(634)/21*6,18*12,18*13,18*14,18*15,
     *21*6,18*22,18*23,18*24,18*25,
     *16*6,  7*312,7*322,  7*313,7*323,  7*314,7*324,  7*315,7*325,
     *16*6, 12*412,12*522, 12*433,12*543,12*453,12*563,
     *12*434,12*544,12*454,12*564,   12*435,12*545,12*455,12*565,
     * 12*72,12*82 , 12*73,12*83 , 12*74,12*84 , 12*75,12*85,
     * 12*92,12*102, 12*93,12*103, 12*94,12*104, 12*95,12*105/
C
      COMMON /  / IMEMOR(80000)
C                 INITIALISE CALIBRATION EDITS UNIT.
      DATA SECS /2./
      CALL HBOOK1(2 ,'NO. OF HITS IN THE R-PHI PATR FIT$',60,0.,60.,0.)
      CALL HBOOK1(10,'CHI**2 PROBABILITY ALL MUONS $',
     *100,0.,1.,0.)
      CALL HBOOK1(15,'CHI**2 PROBABILITY ALL MUONS, 2% BINS $',
     *50,0.,1.,0.)
      CALL HBOOK1(20,'CHI**2 PROBABILITY BARREL MUONS ONLY $',
     *100,0.,1.,0.)
      CALL HBOOK1(25,'CHI**2 PROBABILITY BARREL MUONS ONLY , 2 % BINS$',
     *50,0.,1.,0.)
      CALL HBOOK1(30,'CHI**2 PROBABILITY ENDWALL MUONS ONLY $',
     *100,0.,1.,0.)
      CALL HBOOK1(31,'CHI**2 PROB. -X -Z ENDWALL MUONS ONLY$',
     *100,0.,1.,0.)
      CALL HBOOK1(32,'CHI**2 PROB. +X -Z ENDWALL MUONS ONLY$',
     *100,0.,1.,0.)
      CALL HBOOK1(33,'CHI**2 PROB. -X +Z ENDWALL MUONS ONLY$',
     *100,0.,1.,0.)
      CALL HBOOK1(34,'CHI**2 PROB. +X +Z ENDWALL MUONS ONLY$',
     *100,0.,1.,0.)
      CALL HBOOK1(35,'CHI**2 PROBABILITY ENDWALL MUONS ONLY, 4 % BINS$',
     *25,0.,1.,0.)
      CALL HBOOK1(36,'CHI**2 PROB. -X -Z ENDWALL MUONS ONLY, 4 % BINS$',
     *25,0.,1.,0.)
      CALL HBOOK1(37,'CHI**2 PROB. +X -Z ENDWALL MUONS ONLY, 4 % BINS$',
     *25,0.,1.,0.)
      CALL HBOOK1(38,'CHI**2 PROB. -X +Z ENDWALL MUONS ONLY, 4 % BINS$',
     *25,0.,1.,0.)
      CALL HBOOK1(39,'CHI**2 PROB. +X +Z ENDWALL MUONS ONLY, 4 % BINS$',
     *25,0.,1.,0.)
      CALL HBOOK2(100,'PHI  VS  CHI**2 PROBABILITY BARREL MUONS ONLY $',
     *50,0.,1.,72,0.,360.,0.)
      CALL HBSLIX(100,8)
CCC   CALL HBOOK1(140,'THETA DIST FOR ALL MUONS WITH  90 < PHI < 100$',
CCC  *100,0.,200.,0.)
CCC   CALL HBOOK1(141,'THETA DIST MUONS  PROB < 4 % , 90 < PHI < 100$',
CCC  *100,0.,200.,0.)
CCC   CALL HBOOK1(142,'THETA DIST FOR ALL MUONS WITH 100 < PHI < 120$',
CCC  *100,0.,200.,0.)
CCC   CALL HBOOK1(143,'THETA DIST MUONS  PROB < 4 % ,100 < PHI < 120$',
CCC  *100,0.,200.,0.)
CCC   CALL HBOOK1(144,'THETA DIST FOR ALL MUONS WITH 120 < PHI < 145$',
CCC  *100,0.,200.,0.)
CCC   CALL HBOOK1(145,'THETA DIST MUONS  PROB < 4 % ,120 < PHI < 145$',
CCC  *100,0.,200.,0.)
CCC   CALL HBOOK1(150,'HITMAP FOR MUONS  90 < PHI < 100$',
CCC  *200,250.,450.,0.)
CCC   CALL HBOOK1(155,'HITMAP FOR MUONS  90 < PHI < 100 , PROB < 4%$',
CCC  *200,250.,450.,0.)
CCC   CALL HBOOK1(160,'HITMAP FOR MUONS 100 < PHI < 120$',
CCC  *200,250.,450.,0.)
CCC   CALL HBOOK1(165,'HITMAP FOR MUONS 100 < PHI < 120 , PROB < 4%$',
CCC  *200,250.,450.,0.)
CCC   CALL HBOOK1(170,'HITMAP FOR MUONS 120 < PHI < 145$',
CCC  *200,250.,450.,0.)
CCC   CALL HBOOK1(175,'HITMAP FOR MUONS 120 < PHI < 145 , PROB < 4%$',
CCC  *200,250.,450.,0.)
C
      CALL H1EVLI(0)
      CALL HBLACK(0)
      CALL HMINIM(0,0.)
CCC   CALL HSQUEZ(3HYES)
C---
C---     INITIALIZE BOS.
C---
      CALL BINT(25000,25000,25000,1)
C
      CALL MUINI
C  INITIALISE EVENT COUNTER.
C
      NEV=0
      IEV=0
C
C---
C---     MAIN EVENT LOOP
C---
C---CALL SUBROUTINE MUTIM(SECS,*) TO FORCE EXIT
C---    FIRST , SUPPLY LOGICAL UNIT NO. OF INPUT DATA SET.
      NUNIN=2
    1 CONTINUE
      CALL MUTIM(SECS,&30)
      CALL BSLT
      CALL BDLG
C---
       CALL BREAD(NUNIN,&10,&20)
C PICK UP HEADER POINTER.
      IPHEAD=IDATA(IBLN('HEAD'))
C PICK UP RUN NUMBER ,RECORD NUMBER ETC
      ISECS = HDATA(2*IPHEAD+3)
      IMINS = HDATA(2*IPHEAD+4)
      IHOURS= HDATA(2*IPHEAD+5)
      IDAY  = HDATA(2*IPHEAD+6)
      IMONTH= HDATA(2*IPHEAD+7)
      IYEAR = HDATA(2*IPHEAD+8)
      KRUN  = HDATA(2*IPHEAD+10)
      KREC  = HDATA(2*IPHEAD+11)
      BGAUSS= HDATA(2*IPHEAD+30)
C
C  ONLY TAKE EVENTS WITH C.M. ENERGY .GT. 26 GEV  .
C FIND BEAM ENERGY - IN GEV!!!!!!
      EBGEV=EBEAM(KRUN)/1000.
CCCC  IF(EBGEV.LT.13.)GO TO 1
CMACRO HEADWRIT
C
      CALL KALIBR
C  TO SELECT DATA FROM PERIOD UNDER INVESTIGATION ONLY.
CCCCC IF(NVERSN.NE.IVERSN)GO TO 1
      NEV=NEV+1
      IEV=NEV
C
C  GENERALISATION :
CCCC  IEDIT=20+NVERSN
C
C FOR 1980 DATA :
CCC   IEDIT=28
CCC   IF(IEDIT.LT.28)GO TO 999
CCC   IF(HCTW(115).EQ.-2767)CALL MUCONE(IEDIT,3,1)
C                                    (LUN,IPRINT,IFLAG)
      IF(IEV.GT.1)GO TO 2
      CALL MUCONP
C  FOR LATER CHECK OF MODIFIED CALIBRATION AGAINST PRIVATE FILES :
CCC   IOUT=50+IVERSN
CCC   CALL MUCONW(1,0,IOUT,HERR)
C           (IFLAG,LUNBOS,LUNJAD,HERR)
C
   2  CONTINUE
C
C
C-----------------------------------------------------------------------
C
C MUCONE EDITS MUON CALIBRATION DATA.
C READS EDITS FROM LOGICAL UNIT LUNMUE.
C PRINTING SUPRESSED IF IPRINT.LT.2.
C FULL PRINTING IF IPRINT.GE.10.
C THE MODIFIED HMUCAL VALUES & THEIR ADDRESSES ARE SAVED IN /MUED/
C IF IFLAG=0 .IF A COMPLETE NEW SET OF CALIBRATION IS WANTED,
C PUT IFLAG=1 .
C
C-----------------------------------------------------------------------
      IPPATR=IDATA(IBLN('PATR'))
      CALL FTRAX(IPPATR)
C
C FORCE MUON RE-ANALYSIS.
C
      CALL BMLT(2,'MUR1MUR2')
      CALL BDLM
C
C---  CALL MU CHAMBER TRACKING.
      IMUARG=1
      CALL MUANA(IMUARG)
C--- PRINT MUEV BANK.
CC    CALL MUDUMP(0,0)
C--- PRINT RESULTS OF SIGNAL-COORDINATE CONVERSION.
CC    CALL MURES1(1,1,1,0,0,0)
C--- PRINT RESULTS OF PHILOSOPHY 2 ANALYSIS.
CC    CALL MURES2(1,1,1,1,1)
C
C  NOW ANALYSE RESULTS.
C
C
C  FIND MUR2/0.
      IBANK=0
      CALL CLOC(IND20,'MUR2',IBANK)
      IF(IND20.LE.0)GO TO 11
      NUMTRK=IDATA(IND20+1)
      NMUW  =IDATA(IND20+2)
      NTPH=IDATA(IND20+3)
C
C  FIND MUR2/1.
      IBANK=1
      CALL CLOC(IND21,'MUR2',IBANK)
      IF(IND21.LE.0)GO TO 11
C
C   LOOP ROUND TRACKS.
C
      J=IND21
      J2=J+J
      DO 99 I=1,NUMTRK
C
C  ONLY CONSIDER MUONS WITH QUALITY >= 1 AND < 100:
            IQUAL=IDATA(J+6)
            IF(IQUAL.LE.0.OR.IQUAL.GE.100)GO TO 9
                CHIP=ADATA(J+11)
C
C
                CALL HFILL(10,CHIP)
                CALL HFILL(15,CHIP)
                ITRAK=I
                PHI=PHIT(I)
                THETA=THETAT(I)
                NHXY =NHRPHI(I)
                CALL DEVPIK
C
C  SPECIAL PRINTING FOR TROUBLE AREAS :
CCC             IFLAG=0
CCC             IF(PHI.GT. 90..AND.PHI.LT.145..AND.CHIP.LT.0.1)IFLAG=1
CCC             IF(PHI.GT.180..AND.PHI.LT.225..AND.CHIP.LT.0.1)IFLAG=1
CCC             IF(IFLAG.EQ.0)GO TO 7
C--- PRINT MUEV BANK.
CCC                 CALL MUDUMP(0,0)
C--- PRINT RESULTS OF SIGNAL-COORDINATE CONVERSION.
CCC                 CALL MURES1(1,1,1,0,0,0)
C--- PRINT RESULTS OF PHILOSOPHY 2 ANALYSIS.
CCC                 CALL MURES2(1,1,1,0,0)
C
C++
CCC                 WRITE(6,156)I,PHI,THETA,ND,CHIP
CC156               FORMAT('0 **** ITRAK/ PHI/ THETA/ ND/ CHIP :',
CCC  *              I3,2F7.2,I3,F10.5)
C++
CCC                 IF(ND.LE.0)GO TO 7
C++
CCC                    DO 170 JPIK=1,ND
CCC      WRITE(6,166)NDHIT(JPIK),NDCHAM(JPIK),XDEV(JPIK),SDEV(JPIK)
CC166    FORMAT('0  HIT NO./  CHAMBER NO./ XDEV/ SDEV : ', 2I5,2F10.2)
CC170                  CONTINUE
C++
    7              NEW=0
                   IF(PHI.GT.80..AND.PHI.LT.100.)GO TO 9
                   IF(ND.LE.0)GO TO 9
                   CALL HFILL(2,NHRPHI(I))
                   IF(NHRPHI(I).LT.20)GO TO 9
                      DO 90 JASS=1,ND
                         UN1=UNICH(NDCHAM(JASS))
                         UN = UN1
C
C  REMOVE DIGITS FROM RIGHT OF UN IF NECESSARY :
                         IF(UN .GT.10)UN=UN /10
                         IF(UN .GT.10)UN=UN /10
                         IF(UN.GT.6)NEW=NEW+1
                         IF(NEW.NE.1)GO TO 90
                            IHIST=35+UN-6
                            CALL HFILL(IHIST,CHIP)
                            IHIST2=30+UN-6
                            CALL HFILL(IHIST2,CHIP)
   90                 CONTINUE
C
C  SEPARATE TRACKS WITH >= 1 END WALL HIT IN THE CHI**2 CALCULATION :
                   IF(NEW.GT.0)GO TO 8
                       CALL HFILL(20,CHIP)
                       CALL HFILL(25,CHIP)
                       CALL HFILL(100,CHIP,PHI)
CCC                    IF(PHI.LT.90.  .OR.  PHI.GT.145.  )GO TO 9
CCC                        IF(PHI.LT.100.)MAPALL=150
CCC                        IF(PHI.GT.100..AND.PHI.LT.120.)MAPALL=160
CCC                        IF(PHI.GT.120.)MAPALL=170
CCC                        MAPLOW=MAPALL+5
CCC                        ITHALL=140
CCC                        IF(MAPALL.EQ.150)ITHALL=142
CCC                        IF(MAPALL.EQ.170)ITHALL=144
CCC                        ITHLOW=ITHALL+1
CCC                        CALL HFILL(ITHALL,THETA)
CCC                        IF(CHIP.LT.0.04)CALL HFILL(ITHLOW,THETA)
CCC                        DO 95 JASS=1,ND
CCC                            ICH=NDCHAM(JASS)
CCC                                            CALL HFILL(MAPALL,ICH)
CCC                            IF(CHIP.LT.0.04)CALL HFILL(MAPLOW,ICH)
CCC95                      CONTINUE
                       GO TO 9
C
    8               CALL HFILL(30,CHIP)
                    CALL HFILL(35,CHIP)
    9 CONTINUE
      J=J+NMUW
   99 CONTINUE
C
C  GO TO NEXT EVENT.
      GO TO 1
C
C PROBLEMS , PROBLEMS , .......
   11 CONTINUE
      WRITE(6,116)IBANK
  116 FORMAT('0 BANK MUR2 / ',I1,' NOT FOUND')
      GO TO 1
C***  IF(NEV.GT.99)GO TO 20
      GO TO 1
C---
C
C---     READ ERROR ON INPUT DATA SET
C---
   10 CONTINUE
      WRITE(6,110)NEV
  110 FORMAT('0READ ERROR',I5,2X,
     *'EVENTS WERE READ BEFORE ERROR OCCURED.')
       GOTO 140
C---
C---     END OF DATA.
C---
   20 CONTINUE
      WRITE(6,120)NEV
  120 FORMAT('0END OF DATA.',I5,2X,'EVENTS HAVE BEEN PROCESSED.')
C
      GOTO 140
   30 CONTINUE
      WRITE(6,130)SECS,NEV
  130 FORMAT('0TIMEOUT AT ',F4.1,' SECS.',
     *I5,2X,'EVENTS HAVE BEEN PROCESSED.')
C
  140 CONTINUE
C
CC    CALL HINDEX
CC    CALL HPHS(0)
      CALL HPRINT(0)
C
      GO TO 200
C
C  EMERGENCY STOP :
  999 WRITE(6,9996)IEDIT
 9996 FORMAT('0  ******* EMERGENCY STOP , IEDIT = ',I4)
C
C PRINT BOS STATISTICS.
  200 CALL BSTA
C
      STOP
      END
C
C-----------------------------------------------------------------------
C BLOCK DATA.
C-----------------------------------------------------------------------
C
      BLOCK DATA
C
#include "cmuffl.for"
C
      DATA XYSTEP/20./
C XYSTEP IS STEP LENGTH OF INITIAL EXTRAPOLATION UP TO COIL OR END-PLUG
C   WITH MORE OR LESS FIXED LENGTH IN X-Y PLANE (MM).
C   (STPINI IS THE ACTUAL INITIAL STEP LENGTH).
C
      DATA RCOILI/968./,RCOILO/1045./
C RCOILI/O ARE INNER/OUTER RADII OF COIL (MM).
C
      DATA PGMID/'MUFF'/
C PGMID IS PROGRAM IDENTIFIER.
C
      DATA WMU/.10566/,WMUSQ/.011164/
C WMU,WMUSQ ARE MUON MASS (GEV) AND MASS-SQARED (GEV**2).
C
      DATA NSPECI/21/
C NSPECI IS THE NUMBER OF SPECIAL VARIBLES ACTUALLY USED (SEE CMUFWORK).
C
      DATA XPBAR,XPROT,XPION,XKAON/100.,40.,25.,20./
C THESE ARE NOMINAL CROSS-SECTIONS OF PARTICLES ON HYDROGEN AT 1 GEV
C   USED FOR SCALING INTERACTION LENGTH.
C (NOT USED, ACTUALLY - SEE MUFFLS).
C
C THE FOLLOWING ARE R--  = RADIUS (MM),
C                   Z--  = Z COORDINATE,
C                   T--  = THICKNESS (MM),
C                   GM-- = THICKNESS (GM CM**-2),
C                   AB-- = THICKNESS (ABSORPTION LENGTHS, USING DATA
C                            BOOKLET, I.E. FOR PROTONS. SCALE FOR OTHER
C                            PARTICLES.)
C                   RD-- = THICKNESS (RADIATION LENGTHS),
C                   DE-- = ENERGY LOSS FOR MIN. IONISING PARTICLE (GEV).
C
C BEAM PIPE AND BEAM PIPE COUNTERS (4 MM ALUMINIUM).
C   (ALUMINIUM HAS A DENSITY = 2.7 GM CM**-3,
C          ABSORPTION LENGTH = 37.2 CM,
C           RADIATION LENGTH = 8.9 CM,
C               (-DE/DX) MIN = 4.37 MEV CM**-1).
      DATA TBP,GMBP,ABBP,RDBP,DEBP/4.,1.08,.011,.045,1.7E-3/
C
C JET CHAMBER INNER PIPE (SEE JADE NOTE 17).
      DATA TJETI,GMJETI,ABJETI,RDJETI,DEJETI/0.,1.89,.019,.079,3.02E-3/
C
C JET CHAMBER SUPPORT 1 (SEE JADE NOTE 17).
C   (SUPPORTS ASSUMED TO HAVE AN ABSORPTION LENGTH = 100 GM CM**-2,
C                  (-DE/DX)MIN = 1.6 MEV GM**-1 CM**2).
      DATA TJET1,GMJET1,ABJET1,RDJET1,DEJET1/0.,.208,.002,.006,.33E-3/
C
C JET CHAMBER SUPPORTS 2 AND 3 (SEE JADE NOTE 17).
      DATA TJET2,GMJET2,ABJET2,RDJET2,DEJET2/0.,.33,.003,.01,.53E-3/
C
C JET CHAMBER SUPPORT 4 (SEE JADE NOTE 17).
      DATA TJET4,GMJET4,ABJET4,RDJET4,DEJET4/0.,.258,.003,.008,.41E-3/
C
C JET CHAMBER OUTER WALL (SEE JADE NOTE 17).
      DATA TJETO,GMJETO,ABJETO,RDJETO,DEJETO/12.,3.42,.032,.135,5.24E-3/
C
C COIL. ASSUMED TO BE...
C   3 MM EPOXY (MYLAR?),
C  20 MM WATER (THIS IS 2 20 MM DIAM. PIPES AVERAGED OUT),
C  57 MM ALUMINIUM.
      DATA TCOIL,GMCOIL,ABCOIL,RDCOIL,DECOIL/80.,17.8,.185,.7,30.E-3/
C
C JET CHAMBER END WALLS (JADE NOTE 17 SAYS 'SIMILAR TO COIL', I.E.
C    AS ABOVE, BUT I QUERIE THIS).
      DATA ZJETE/1250./
      DATA TJETE,GMJETE,ABJETE,RDJETE,DEJETE/80.,17.8,.185,.7,30.E-3/
C
C END-PLUG LEAD-GLASS.
C TOKYO LEAD-GLASS HAS DENSITY = 4.08 GM CM**-3,  ) ( BASED ON TOKYO
C            ABSORPTION LENGTH = 318.4 MM,        ) ( DATA INTERPRETED
C             RADIATION LENGTH = 22.39 MM,        ) ( BY J. ALLISON.
C                  (-DE/DX)MIN = 5.708 MEV/CM.    ) (
      DATA ZEPLG/1510./
      DATA TEPLG,GMEPLG,ABEPLG,RDEPLG,DEEPLG/226.,92.21,.71,10.09,.129/
C
C (BARREL) LEAD-GLASS.
C RLG IS INNER RADIUS OF BARREL LG.
C ZLG IS Z COORDINATE OF END OF BARREL.
      DATA RLG,ZLG/1100.,1602.25/
      DATA TLG,GMLG,ABLG,RDLG,DELG/300.,122.4,.942,13.4,.171/
C
C MAGNET END-PLUG.
      DATA ZEP/1755./
      DATA TEP,GMEP,ABEP,RDEP,DEEP/340.,267.,1.99,19.32,.394/
C TEP,ETC., ARE (AVERAGE) FOR END-PLUG (MM).  (I ASSUME IT HAS
C   UNIFORM THICKNESS, AVERAGED TO SOMETHING LESS THAN REAL THICKNESS
C   TO TAKE INTO ACCOUNT LEAD-GLASS LIGHT-GUIDE HOLES.  FURTHER I
C   ASSUME DENSITY, ETC. OF IRON.)
C
C GMG(3),ABG(3),RDG(3),DEG(3) ARE 'GENERAL' QUANTITIES PER MILLIMETRE
C   FOR 1)CHAMBERS, 2)CONCRETE, 3)IRON.
      DATA GMG/0.05,0.536,0.787/
      DATA ABG/0.0005,0.00438,0.0058/
      DATA RDG/0.001,0.0368,0.0568/
      DATA DEG/0.07E-3,0.91E-3,1.16E-3/
C
C SPECIFY NOMINAL CHAMBER RESOLUTION (IN STANDARD DEVIATIONS)....
C REST   IS RESOLUTION IN TRANSVERSE (DRIFT) DIRECTION.
C REST1 IS FOR BARREL FACES , REST2 IS FOR ENDWALLS.
C RESTMX IS RESOLUTION IN TRANSVERSE DIRECTION FOR THE CASE WHEN THE
C          TRANSVERSE (DRIFT) COORDINATE IS BAD. THIS IS SET TO
C          DRIFT DISTANCE = 150 MM, RATHER THAN (CHAMBER WIDTH),
C          SINCE BOTH AMBIGUITIES ARE TRIED.
C          FOR ASSOCIATION OF HITS , IT IS ADDED LINEARLY TO THE SQUARE
C          ROOT OF THE SUM OF THE SQUARES OF THE VARIANCES DUE TO
C          MULT SCAT & PATREC FIT ERRORS.
C          HOWEVER , FOR CALCULATION OF CHI**2 , IT SHOULD BE  ADDED
C          QUADRATICALLY WITH THE OTHERS -- BUT , FOR PRESENT, BAD
C          HITS ARE NOT USED FOR CHI**2 CALCULATION.
C RESL   IS RESOLUTION IN LONGITUDINAL (WIRE) DIRECTION.
C RESLMX IS SIMILAR TO RESTMX, I.E. FOR CASE WHEN LONGITUDINAL COORD.
C          IS BAD.  SET TO CHAMBER LENGTH.
      DATA REST1,REST2,RESTMX,RESL,RESLMX/ 5.,10.,150.,150.,5000./
C
C FACTOR IS THE NUMBER OF STANDARD DEVIATIONS USED FOR HIT CUT.
      DATA FACTOR/3./
C
C OVLCUT IS THE DIFFERENCE IN DRIFT DEVIATIONS WHICH IS TOLERATED(MM)
C FOR HITS TO BE CONSIDERED AS OVERLAP HITS.
      DATA OVLCUT/15./
C
      END
      BLOCK DATA
C==MACRO CIOUNI=========================================
      COMMON/CIOUNI/IUNIT,JUNIT,NCALI,KUNITA(10),LUNITA(10)
C==ENDMACRO CIOUNI========================================
      DATA NCALI/2/
      DATA KUNITA/10,11,8*0/
      DATA LUNITA/21,22,8*0/
      END
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F22NAR.TOFLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L (NEW HBOOK)
//            DD DSN=R01UTL.CERNLIB,DISP=SHR,UNIT=FAST  (CERN LIB)
//LKED.MYLIB  DD DSN=F22MCC.MUCALIB.L,DISP=SHR,UNIT=FAST
  INCLUDE MYLIB(FTRAX,MUANAFD,MUFFL2MD,MUFFLD,DEVPIK,MUCONE1)
//LKED.SYSIN DD *
//*NCLUDE SYSLIB(SUCOOR,TANTHM,NUFFLY)
//*NCLUDE MYLIB(FTRAX,MUANAFD,MUFFL2MD,MUFFLD,DEVPIK,MUFFLS,MUCONE1)
//*NCLUDE MYLIB(NUCOORSH,TANTHM,NUFFLY)
//*NCLUDE MYLIB(NUCOOR,TANTHM)
//*KED.SYSIN DD *
//*O.FT02F001 DD DSN=F22HAS.COSMIC.MANY,DISP=SHR,UNIT=TAPE
//*O.FT02F001 DD DSN=F22NAR.MSSJAD.MC1.R408450,DISP=SHR
//*O.FT02F001 DD DSN=F22NAR.DSK.MY064190,DISP=SHR
//*O.FT02F001 DD DSN=F22NAR.MSSJAD.MY191269,DISP=SHR
//GO.FT02F001 DD DSN=F22NAR.MSSJAD.MY191269,DISP=SHR
//*O.FT02F001 DD DSN=F22NAR.ZZ.DSK.M271290A.B821123,DISP=SHR,UNIT=TAPE
//*           DD DSN=F22NAR.DSK.MY291335,DISP=SHR
//*O.FT02F001 DD DSN=F22NAR.MSSJAD.MY336407,DISP=SHR
//*O.FT02F001 DD DSN=F22NAR.MSSJAD.MY408450,DISP=SHR
//*O.FT02F001 DD DSN=F22NAR.MSSJAD.MY451509,DISP=SHR
//*O.FT02F001 DD DSN=F22MCC.MSS.MUPAIRS,DISP=SHR,UNIT=FAST
//*---CALIBRATION DATA INPUT----------------------------------
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*O.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//*O.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ZZ.AUPDAT1.B821209
//*O.FT28F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.FIXED.DS1980
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NISURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHED0816
//*O.FT33F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED13
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NFSURVEY
//*O.FT34F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED14
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NGSURVEY
//*O.FT35F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED15
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NHSURVEY
//*O.FT36F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED16
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NISURVEY
//*O.FT37F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED17
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NJSURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHEDIT17
//*O.FT38F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED18
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NKSURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHEDIT18
//*O.FT39F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED19
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NLSURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHEDIT19
//*O.FT40F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED20
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NMSURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHEDIT20
//*O.FT41F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED21
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NNSURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHEDIT21
//*O.FT42F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.MEANVDTP.CARDS.FIXED22
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NOSURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHEDIT22
//*O.FT43F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.MEANVDTP.CARDS.RIXED23
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NUSURVEY
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.SHEDIT23
//*O.FT32F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.MEANVDTP.CARDS.FIXED22
//*O.FT33F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.MEANVDTP.CARDS.FIXED23
//*           DD UNIT=FAST,DISP=SHR,DSN=F22MCC.CARDS.NUSURVEY
//*O.FT48F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED08
//*O.FT49F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED09
//*O.FT50F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED10
//*O.FT51F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED11
//*O.FT52F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED12
//*O.FT53F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED13
//*O.FT54F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED14
//*O.FT55F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED15
//*O.FT56F001 DD UNIT=FAST,DISP=SHR,DSN=F22MCC.OLDXT.CARDS.FIXED16
//GO.SYSIN DD *
C   22/03/97 703221633  MEMBER NAME  #MUTEST  (JADEMUS)     FVS
//F22HAS13 JOB 10622622,CLASS=E,MSGLEVEL=(0,0),TIME=(0,10),MSGCLASS=T
//*MAIN ORG=EXT,RELPRI=HIGH
//*EXEC NEWFAST
// EXEC FLG,PARM.LKED='MAP,LIST',REGION=800K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DSN=R01UTL.HBOOK3.L,DISP=SHR,UNIT=FAST (NEW HBOOK)
//            DD DSN=R02BUT.CERNLIB,DISP=SHR,UNIT=FAST  (CERN LIB)
 INCLUDE SYSLIB(JDMAIN0,MUSER)
//*
//*
//*___EXPT_DATA_________________________________________________________
//*
//GO.FT02F001 DD DSN=F22HAS.MUSTBE,DISP=SHR,UNIT=FAST
//*O.FT02F001 DD DSN=F22MIN.RESULT.TPMH412,DISP=SHR,UNIT=FAST
//*
//*
//*___REDUCED DATA______________________________________________________
//*
//*
//*--FT03F001-DATA OUTPUT FILE----------------------------------------
//GO.FT03F001 DD DUMMY  (ANALYSIS OUTPUT)
//*O.FT03F001 DD DSN=F22ALL.ARCHIE,DISP=OLD,UNIT=FAST
//*
//*
//*--FT38F001-CALIBRATION DATA INPUT----------------------------------
//*UNIT=FAST                   (MU CALIB. DATA - JUL 1979)
//GO.FT38F001 DD DSN=F22ALL.NUCALIB.DATA0013,DISP=SHR,UNIT=FAST
//*
//*
//*--FT39F001-CALIBRATION UPDATES-------------------------------------
//GO.FT39F001 DD DSN=F22HAS.@UPDAT43,DISP=SHR,UNIT=FAST
//*O.FT39F001 DD DSN=NULLFILE
//*O.FT39F001 DD DSN=F22HAS.DATA0014,DISP=SHR,
//*UNIT=FAST
//*
//*
//*--FT37F001-UPDATED-CALIBRATION DATASET.----------------------------
//*O.FT37F001 DD DUMMY
//GO.FT41F001 DD DSN=F22ALL.MUCALIB.DATA0013,DISP=(NEW,CATLG,DELETE),
// VOL=SER=STOR05,DCB=R01DCB.VBS,SPACE=(TRK,2),
// UNIT=FAST                      (CALIBRATION DATA FROM JAN 1980)
//*O.FT37F001 DD DSN=F22HAS.RECAL.DATA007,DISP=(NEW,CATLG),
//*VOL=SER=FASTOV,DCB=R01DCB.VBS,SPACE=(TRK,2),
//*UNIT=FAST                      (OLD MUCALIB DS.)
//*
//*
//*LARRY'S CALIBRATION DATA SETS...
//*
//GO.FT42F001 DD DSN=F22ALL.MUCALIB.NBOS0013,DISP=(NEW,CATLG,DELETE),
// VOL=SER=STOR05,DCB=R01DCB.VBS,SPACE=(TRK,2),
// UNIT=FAST                      (CALIBRATION DATA FROM JAN 1980)
//GO.FT10F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
//GO.FT11F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART1
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*
//*
//*--TITLES---------------------------------------------------------
//GO.FT35F001 DD *
OLD MUCALIB NONSENSE  UPDATED JH 29.11.80
INNER LAYERS ARE INCLUDED BUT POSITIONAL PARAMETERS ARE DESIGN VALUES.
THESE MAY BE 1 CM OUT OF POSITION- THEY AWAIT OFFLINE ANALYSIS.
//*S DS HAS OFFLINE TPS AND LSFS, PLUS THE EXTRA ROOF CHAMBERS
//*IMISED OFFLINE MEASUREMENTS. DATA11,12,13 ROOF MISTAKES CORRECTED
//*WALL EXTRA CHAMBERS TAKEN OUT AS APPROPRIATE.
//*
//*--SYSIN------------------------------------------------------------
//* FIRST CARD ON SYSIN IS IN FORMAT(14I5)...
//* IEV1,IEV2,NPR,IPRINT,IPRINS,IANAL,ISTATS,IJOIN
//* EVENTS IEV1 TO IEV2 ARE PROCESSED. (IF IEV2=0, ALL EVENTS FROM IEV1
//*   ARE PROCESSED.  IF IEV1=0, ALL EVENTS ARE PROCESSED.)
//* THE EVENT COUNTER STARTS FROM IRUN,IREC IF IRUN,IREC.NE.0.
//* NPR IS NUMBER OF EVENTS PRINTED, =0 FOR 10 EVENTS, =-1 FOR NONE.
//* IPRINT=2 NORMALLY TO GET MESSAGES, BUT NOT FULL CALIB. DATA PRINT.
//* IPRINS=0 SUPPRESSES SPECIAL RAW DATA PRINTING.
//* IREC SELECTS RECORD NUMBER IN ASSOCIATION WITH IRUN.
//* IHISTS=0 SUPPRESSES HISTOGRAMS.
//* LUNT = LOG. UNIT NUMBER OF TITLES, =0 IF NONE.
//* IRUN SELECTS SINGLE RUN (=0 FOR ANY RUN).
//* ITLFT IS NUMBER OF SECONDS REQUIRED AT END. (=2 IF ITLFT=0)
//* IOUT.NE.0 PRINTS OUTPUT BANKS EVEN IF NPR DOES NOT SELECT.
//* LUNC =(38)= LOG. UNIT OF OWN CALIBRATION DATA FILE, =0 IF NONE.
//* LUNE =(39)= LOG. UNIT OF CALIBRATION DATA UPDATES, =0 IF NONE.
//* LUNO =(37,41)= LOG. UNIT OF CALIB. DATA OUTPUT FILE, =0 IF NONE.
//*   40<LUNO<45      ==>  MUCONW WRITES BOTH A BOS DATA SET AND A
//*                         SINGLE LOGICAL RECORD OF LENGTH 4185 WORDS
//*                         ON LOGICAL UNIT NUMBERS LUNO AND LUNO+1
//*                         RESPECTIVELY ;
//*V1-IEV2--NPR-RINT-RINS-IREC-ISTS-LUNT-IRUN-TLFT-IOUT-LUNC-LUNE-LUNO
    0    1   -1    0    0             35         1        38   39   41

C   14/10/82 606071855  MEMBER NAME  MBCOMT   (S4)          FORTRAN77
      SUBROUTINE MBCOMT
C
C              THE MINI-BOS PROGRAM MBOS
C              -------------------------
C
C     THE PURPOSE OF THE MBOS PROGRAM IS TO CREATE DYNAMICALLY
C     A STRUCTURE OF DATA BANKS WITHIN COMMON BLOCKS OR ARRAYS.
C
C     THE MINI-BOS PROGRAM MBOS ALLOWS CREATION OF BANKS AND OTHER
C     FUNCTIONS IN A WAY SIMILAR TO AND COMPATIBLE WITH THE BOS-
C     SYSTEM. IT IS HOWEVER ONE SMALL PROGRAM OF ABOUT
C     1000 WORDS. THE MBOS PROGRAM OFFERS THE POSSIBILITY OF
C     USING SEVERAL DYNAMIC STRUCTURES WITHIN COMMON BLOCKS
C     OR DIMENSIONED ARRAYS. WITHIN EACH STRUCTURE DATA BANKS CAN
C     BE CREATED, WITH BANKS OF THE SAME FORM AS IN THE BOS-SYSTEM,
C     ACCORDING TO THE FOLLOWING SCHEMA.
C
C     IW(IND-3)      NAME
C     IW(IND-2)      NUMBER
C     IW(IND-1)      INTERNALLY USED
C     IW(IND  )      NW = NUMBER OF WORDS IN THE BANK
C     IW(IND+1)      1. DATA WORD
C     IW(IND+2)      2. DATA WORD
C     . . .
C     IW(IND+NW)     LAST DATA WORD
C
C     IN CONTRAST TO BOS, IN THE MBOS PROGRAM EACH BANK HAS AN
C     ASSOCIATED POINTER WITHIN THE ARRAY. THE EXECUTION TIME
C     OF THE FUNCTIONS IS THEREFORE SHORTER, ON THE COST OF
C     FLEXIBILITY, ESPECIALLY IF BANKS ARE WRITTEN ON A DATA SET
C     AND LATER READ IN AGAIN. THERE IS HOWEVER THE POSSIBILITY
C     TO TRANSFER MBOS BANKS TO THE BOS SYSTEM.
C
C
C
C     IN EACH SUBPROGRAM REFERENCING BANKS OF THE STRUCTURE THE
C     USER HAS TO INSERT STATEMENTS INCLUDING A LIST OF POINTERS
C     IND1 . . . INDN OF THE FOLLOWING FORM
C
C     COMMON/ANYNAM/IW(1),IND1,IND2,. . .,INDN,IWRD(1)
C     REAL RW(NSPACE)
C     EQUIVALENCE (IW(1),RW(1))
C
C     WHERE NSPACE IS A INTEGER CONSTANT, DEFINING THE TOTAL
C     LENGTH OF THE STRUCTURE.
C
C
C     ALL ENTRIES HAVE A NAME OF FOUR CHARACTERS, STARTING WITH
C     THE CHARACTER M, AND HAVE THREE ARGUMENTS, THE FIRST ONE
C     BEING THE NAME OF THE ARRAY. IF ARGUMENTS ARE POINTERS,
C     THERE NAMES HAVE TO APPEAR IN THE LIST OF THE DECLARATION
C     STATEMENT (THEIR VALUES AND ADDRESSES ARE USED). OTHERWISE
C     THE PROGRAM STOPS IMMEDIATELY. THE USE OF E.G. IW(17) AS
C     A POINTER-ARGUMENT IS VALID.
C
C     THE MBOS SYSTEM CONSISTS OF THE SUBROUTINES MBOS AND MBPR (+UWP),
C     WHICH ARE ON THE DESY-NEWLIB-LIBRARIES
C        F1EBLO.BOSLIB.S (SOURCE)
C        F1EBLO.BOSLIB.L (LOAD)
C     THE FUNCTION JDSTL FROM DESYLIB IS USED IN ADDITION.
C
C
C     THE STORAGE LAYOUT IS ACCORDING TO THE FOLLOWING SCHEMA.
C
C     IW(1)           NSPACE = LENGHT OF THE ARRAY
C     -------------------------------------------------------------
C     IW(2) = IND1    POINTER TO (INDEX OF) BANK IDENTIFIED BY IND1
C     IW(3) = IND2    POINTER TO (INDEX OF) BANK IDENTIFIED BY IND2
C     ...
C     IW(I) = INDX    POINTER TO (INDEX OF) BANK IDENTIFIED BY INDX
C     ...
C     IW(K) = INDN    POINTER TO (INDEX OF) BANK IDENTIFIED BY INDN
C     -------------------------------------------------------------
C     IW( )           NAME                       FIRST BANK
C     IW( )           NUMBER
C     IW( )           (INDEX I OF POINTER)
C     IW( )           NW = NUMBER OF DATA WORDS IN THE BANK
C     IW( )           1. DATA WORD
C     IW( )           2. DATA WORD
C     ...
C     IW( )           LAST DATA WORD
C     -------------------------------------------------------------
C     IW( )           NAME                      SECOND BANK
C     IW( )           NUMBER
C     IW( )           (INDEX I OF POINTER)
C     IW( )           NW = NUMBER OF DATA WORDS IN THE BANK
C     IW( )           1. DATA WORD
C     IW( )           2. DATA WORD
C     ...
C     IW( )           LAST DATA WORD
C     -------------------------------------------------------------
C     ...
C     FREE SPACE
C     -------------------------------------------------------------
C     IW(IW(N-3))     INDEX OF POINTER TO LAST STORED BANK
C     ...             ...
C     IW(N-10)        INDEX OF POINTER TO SECOND STORED BANK
C     IW(N- 9)        INDEX OF POINTER TO FIRST STORED BANK
C     -------------------------------------------------------------
C     IW(N- 8)        (INTERNAL USE)
C     IW(N- 7)        (INTERNAL USE)
C     IW(N- 6)        NR OF PRINTOUTS ALLOWED
C     IW(N- 5)        (NAME OR INDEX LA)
C     IW(N- 4)        (NR   OR INDEX LB)
C     IW(N- 3)        POINTER TO POINTER LIST
C     IW(N- 2)        =1 IF BANKS DROPPED
C     IW(N- 1)        INDEX OF NEXT BANK IN UNUSED SPACE
C     IW(N   )        NR OF POINTERS ETC
C     -------------------------------------------------------------
C
C
C
C     1. INITIALISATION
C
C               -- ---- ------
C     CALL MBOS(IW,INDN,NSPACE)
C
C        WHERE  IW( )  = NAME OF THE ARRAY
C               INDN   = NAME OF LAST POINTER
C               NSPACE = LENGTH OF ARRAY IW( )
C
C
C     THIS PROGRAM HAS TO BE CALLED BEFORE ANY OTHER CALLS USING
C     THE ARRAY. ALL POINTERS ARE SET TO ZERO.
C     IF MBOS IS CALLED WITH NSPACE=0, ALL EXISTING BANKS ARE
C     DELETED.
C
C
C
C     2. CREATION OF BANKS
C
C               -- ---- --
C     CALL MCRE(IW,INDI,NW)
C                  ----
C
C        WHERE  IW( )  = NAME OF THE ARRAY
C               INDI   = INDEX OF THE BANK (ITS NAME MUST APPEAR
C                        IN THE LIST OF POINTERS)
C               NW     = NR OF WORDS OF THE BANK
C
C     THE DEFAULT NAME AND NR OF THE BANK ARE ('    ',0). THE USER
C     CAN DEFINE A NAME AND A NUMBER OF THE BANK BY A CALL
C
C               -- ---- --
C     CALL MNNR(IW,NAME,NR)
C
C     BEFORE CALLING MCRE.
C     THIS IS NECESSARY, IF BANKS ARE WRITTEN TO A DATA SET AND LATER
C     READ BY THE BOS-SYSTEM. IT IS RECOMMENDED IN ALL CASES TO
C     ALLOW EASY IDENTIFICATION OF PRINTOUT (SEE 5.).
C     THE BANK IS CREATED WITH ZEROS IN THE DATA PART OF THE BANK,
C     IF IT WAS NOT EXISTING AND IF THERE IS SUFFICIENT SPACE.
C     IF NECESSARY, A GARBAGE COLLECTION IS DONE AUTOMATICALLY.
C     IF THE BANK IS ALREADY EXISTING, THE LENGTH IS CHANGED TO
C     THE GIVEN VALUE NW, SHIFTING ALL OTHER BANKS BEHIND THE
C     BANK. ADDITIONAL WORDS ARE NOT FILLED WITH ZEROS.
C     THE BANKS ARE ALWAYS IN THE ORDER OF THE POINTERS.

C     THE NUMBER NFRE OF FREE WORDS FOR ONE NEW BANK CAN BE
C     OBTAINED BY THE CALL
C
C               -- --
C     CALL MCRE(IW,IW,NFRE)
C                     ----
C
C
C
C
C     3.   GARBAGE COLLECTION AND DROPPING OF BANKS
C
C     IF ALL THE BANKS ARE TO BE DELETED, THE SIMPLEST WAY IS
C     TO CALL THE INITIALIZATION PROGRAM MBOS (SEE UNDER 1.).
C     SPECIFIC BANKS CAN BE MARKED FOR DELETION (DROPPED) BY THE CALL
C               -- ---- ----
C     CALL MDRP(IW,INDI,INDJ)
C
C        WHERE  IW( )   = NAME OF THE ARRAY
C               INDI    = INDEX OF FIRST BANK TO BE DELETED
C               INDJ    = INDEX OF LAST BANK TO BE DELETED
C
C     THE DROPPED BANKS ARE STILL PRESENT, THEY ARE DELETED
C     DURING THE NEXT GARBAGE COLLECTION, WHICH IS EITHER DONE
C     AUTOMATICALLY, IF NECCESSARY DURING A CALL OF BCRE, OR BY
C     THE CALL
C               -- --
C     CALL MBOS(IW,IW,NFRE)
C                     ----
C        WHERE IW( )   = NAME OF THE ARRAY
C              NFRE    = NUMBER OF FREE WORDS
C
C
C
C     4.   INPUT/OUTPUT OF BANKS
C
C     BANKS CAN BE WRITTEN IN STANDARD BOS-FORMAT ON A DATASET AND
C     LATER READ INTO THE ARRAY AGAIN OR READ BY THE BOS-INPUT
C     ROUTINES. WRITING OF BANK-RECORDS IS PREPARED BY THE
C     FOLLOWING CALLS
C               -- ---- ----
C     CALL MMLT(IW,INDI,INDJ)
C
C               --
C     CALL MBWR(IW,NTOT,INDW)
C                  ---- ----
C     THE FIRST CALL DEFINES THE SET OF BANKS TO BE WRITTEN, IT IS
C     NOT NECCESARY, IF ALL BANKS ARE TO BE WRITTEN. BY THE SECOND
C     CALL THE TOTAL NUMBER OF WORDS NTOT AND THE INDEX OF THE FIRST
C     WORD OF THE FIRST BANK IS OBTAINED. A WRITE STATEMENT
C     WRITE( ) NTOT,(IW(INDW+I-1),I=1,NTOT)
C     CAN BE USED TO WRITE ONE RECORD.
C     THIS STANDARD BOS RECORD CAN BE READ BY THE BOS-INPUT ROUTINE,
C     IF EACH WRITTEN BANK HAS ASSOCIATED A NAME AND A NUMBER.
C     IT CAN ALSO BE READ FOR USE WITH THE MBOS PROGRAM IN AN ARRAY,
C     HOWEVER IF THERE ARE OTHER BANKS IN THE ARRAY, THEY ARE
C     OVERWRITTEN. THE ARRAY MUST HAVE AT LEAST AS MUCH POINTERS
C     AS WERE DURING THE WRITING. A READ STATEMENT
C     READ( ) NTOT,(IWRD(I),I=1,NTOT)
C     CAN BE USED TO READ ONE RECORD. THE POINTERS TO ALL BANKS
C     OF THE RECORD ARE DEFINED BY A CALL
C               -- ----
C     CALL MBRD(IW,NTOT,IER)
C                       ---
C        WHERE IW( )   = NAME OF THE ARRAY
C              NTOT    = NUMBER OF WORDS OF THE RECORD
C              IER     = ERROR MARKER ( =1, IF ERROR DETECTED)
C
C     IT IS NOT POSSIBLE TO READ STANDARD RECORDS WRITTEN BY THE
C     BOS-SYSTEM.
C
C
C     5.   PRINTOUT
C
C     THERE IS AN ADDITIONAL SUBROUTINE MBPR (+UWP), TO PRINT
C     THE TOTAL ARRAY OR SELECTED BANKS, WITH FORMAT SELECTION
C     FOR EACH WORD ACCORDING TO ITS CONTENT (INTEGER, REAL, CHARACTER).
C
C               -- ---- ----
C     CALL MBPR(IW,INDI,INDJ)
C        WHERE IW( )   = NAME OF THE ARRAY
C              INDI    = INDEX OF THE FIRST BANK
C              INDJ    = INDEX OF THE LAST BANK
C
C     THE BANKS TO POINTERS INDI TO INDJ ARE PRINTED. THE TOTAL ARRAY
C     IS PRINTED, IF THE FIRST AND LAST POINTER ARE GIVEN. THERE IS A
C     LIMIT (DEFAULT VALUE 10) OF THE TOTAL NUMBER OF PRINTOUTS.
C     THIS LIMIT CAN BE SET TO THE VALUE LIM BY THE CALL
C
C               -- -- ---
C     CALL MBPR(IW,IW,LIM)
C
C
      RETURN
      END

C   24/11/78 408031344  MEMBER NAME  USERSPI  (JADESR)      FORTRAN
      SUBROUTINE USER(INDEX)
C---
C---     USER ROUTINE FOR CUTS AND INTERACTIVE DECISION MAKING.
C---
      IMPLICIT INTEGER*2 (H)
C
      COMMON // BLCOMM(15000)
#include "cgraph.for"
C
#include "cdata.for"
      COMMON /CHEADR/ HEAD(108)
      COMMON /CADMIN/ IEVTP,NRREAD,NRWRIT,NRERR
      DIMENSION IGG(30),JIGG(10)
C---
C        INDEX=0   INITIAL CALL, BEFORE FIRST EVENT READ.
C              1   CALLED AT THE BEGINNING OF EACH NEW RUN.
C              2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO CDATA.
C              3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
C              4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
C              5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
C              6   ENERGIES CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
C              7   TRACKS AND CLUSTERS HAVE BEEN ASSOCIATED.
C              8   MUON CHAMBER TRACKING HAS BEEN DONE.
C              9   MUON AND INNER DETECTOR TRACKS HAVE BEEN ASSOCIATED.
C             10   UNUSED
C---
C---     CHECK WHETHER CALL AT END OF JOB
      IF(INDEX.EQ.100) GOTO 9900
C
      GO TO (100,200,300,400,500,600,700,800,900,1000),INDEX
C---
C---     INDEX=0 INITIALIZATION.
C---
C
      DO 99 I = 1,12
99    JIGG(I) = 0
      DO 98 I = 1,30
98    IGG(I) = 0
      WRITE(6,112)
112   FORMAT(' REPAIR ROUTINE FOR DL8 ERROR; ',/,
     $ '   ALL JETC BANKS ARE CORRECTED; ',/,
     $ '   ALL ZVTX,PATR AND JHTL BANKS ARE DELETED',/,
     $ '   Z-VERTEX AND PATREC (SLOW VERSION)  ARE BOTH REDONE')
C
C     INITIALIZE INPUT OUTPUT UNITE
C
      CALL JBWDL8(2,3)
C
C    UNIT 2 = INPUT,    UNIT 3 = OUTPUT
C
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
100   CONTINUE
      JIGG(1) = JIGG(1) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
200   CONTINUE
C                                    SELECT EVENT
      JIGG(2) = JIGG(2) + 1
      CALL SPITZ(&11)
C
C RETURN1 = GO TO 11, WRITE EVENT
C   IF OUTSIDE RUN LIMITS 16803,17326   OR IF NO HEAD OR JETC BANK.
C
3010  CONTINUE
      IPPATR = IDATA(IBLN('PATR'))
      IF(IPPATR.LE.0) GO TO 3011
      NRPATR = IDATA(IPPATR - 2)
      CALL BDLS('PATR',NRPATR)
      GO TO 3010
3011  IPJHTL = IDATA(IBLN('JHTL'))
      IF(IPJHTL.LE.0) GO TO 3012
      NRJHTL = IDATA(IPJHTL - 2)
      CALL BDLS('JHTL',NRJHTL)
      GO TO 3011
3012  IPZVTX = IDATA(IBLN('ZVTX'))
      IF(IPZVTX.LE.0) GO TO 210
      NRZVTX = IDATA(IPZVTX - 2)
      CALL BDLS('ZVTX',NRZVTX)
      GO TO 3012
C
210   INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
300   CONTINUE
C                                    LEAD GLASS CALIBRATION DONE
      JIGG(3) = JIGG(3) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
400   CONTINUE
C                                    JETC CALIBRATED
C                                    ZVERTEX CALCULATED
      JIGG(4) = JIGG(4) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
500   CONTINUE
C                                    PATREC PERFORMED
      JIGG(5) = JIGG(5) + 1
      GO TO 11
C                                     WRITE EVENT
C -------------------------------------------------------------------
600   CONTINUE
C                                    CLUSTER ANALYSIS PERFORMED
      JIGG(6) = JIGG(6) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
700   CONTINUE
      JIGG(7) = JIGG(7) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
800   CONTINUE
      JIGG(8) = JIGG(8) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
900   CONTINUE
      JIGG(9) = JIGG(9) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
1000  CONTINUE
      JIGG(10) = JIGG(10) + 1
      INDEX=INDEX+1
      RETURN
C -------------------------------------------------------------------
C---     END OF JOB: FINAL CALCULATIONS + PRINTOUT
9900  CONTINUE
      WRITE(JUSCRN,9901) JIGG
      WRITE(JUSCRN,9902) IGG
9901  FORMAT(' JIGG ',12I10)
9902  FORMAT(' IGG ',10I10)
      RETURN
C---
C---     RETURNS FOR STEERING ANALYSIS TO DESIRED NEXT STEP.
C---     'GO TO 1' MEANS REJECT EVENT AND GO TO NEXT EVENT.
C---     'GO TO 11' MEANS ACCEPT EVENT, WRITE IT AND GO TO NEXT EVENT
C---     'GO TO 12' MEANS END THE JOB, WRITE FINAL RESULTS AND PLOTS
C---
1     INDEX = 1
      RETURN
2     INDEX = 2
      RETURN
3     INDEX = 3
      RETURN
4     INDEX = 4
      RETURN
5     INDEX = 5
      RETURN
6     INDEX = 6
      RETURN
7     INDEX = 7
      RETURN
8     INDEX = 8
      RETURN
9     INDEX = 9
      RETURN
10    INDEX = 10
      RETURN
11    INDEX = 11
      RETURN
12    INDEX = 12
      RETURN
      END
      SUBROUTINE JBWDL8(IDUM1,IDUM2)
C
      WRITE (6,111)
111   FORMAT(' DUMMY JBWDL8 WAS CALLED ')
      RETURN
      END

C   27/06/79 C9073101   MEMBER NAME  RCOORD   (JADEGAMS)    FORTRAN
      SUBROUTINE RCOORD(X,PHI,STHETA)
C---  COMPUTE X- AND Y-COORDINATES WHEN Z, PHI, AND THETA OF TRACK ARE
C---  GIVEN (ALL DISTANCES IN MM, STARTING POINT IS ASSUMED TO BE 0)
C---  ROTATE X- AND Y- COORDINATES BY 45 DEGREES
C
C     H.WRIEDT      27.06.79         04:45
C     LAST MODIFICATION      30.07.79     20:10
C
      DIMENSION X(3)
C
      DATA FAKTOR/0.7071068/
C
      COMMON /CGGVRN/ NVRSN(20)
      DATA NVCODE/279073020/
C
      NVRSN(17) = NVCODE
      THESIN = X(3)*STHETA
      X(1) = THESIN*COS(PHI)
      X(2) = THESIN*SIN(PHI)
C
C---  ROTATE COORDINATES BY 45 DEGREES
      XR = (X(2)+X(1))*FAKTOR
      YR = (X(2)-X(1))*FAKTOR
      X(1) = XR
      X(2) = YR
C
      RETURN
      END

C   08/08/85 508090428  MEMBER NAME  PROJVW   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PROJVW( JVIEW, LFLAG )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY   8/08/85 :  DRAW ONE PROJECTION
C
C
C     PERFORMS EVENT, DETECTOR AND RESULTS DISPLAY FOR ONE PROJECTION
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  LFLAG
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
C------------------  C O D E  ------------------------------------------
C
      NACMD = ACMD
      CALL SETSCL( JVIEW )
C
      IF( LFLAG ) CALL EVDISP(JVIEW)
      IF( NACMD .NE. 99  .AND.  LFLAG ) then
         call setcol('JADE')    ! PMF 23/11/99: set colour
         CALL JADISP(JVIEW)
         call setcol(' ')    ! PMF 23/11/99: reset colour
      endif
C
C                            LAST COMMAND WAS VRES?
C                            IF SO, DO RESULTS DISPLAY WITH VERTICES
C
      IF( LSTCMD .NE. 52 ) GO TO 10
        CALL VXDISP(JVIEW)
        GO TO 13
C
C                            IF MUPT OR MUONS, DRAW MUON TRACKS,ETC
C                            S/R MULDSP CALLS XYMUD AND BOTH USE LASTVW
C
  10  IF( LSTCMD .NE. 105  .AND.  LSTCMD .NE. 106 ) GO TO 12
        LVIEW  = LASTVW
        LASTVW = JVIEW
        CALL MULDSP
        LASTVW = LVIEW
        GO TO 13
C
C                            IF CDTL 16 OR RES OR MUR2
C                            THEN CALL RESULTS DISPLAY
C
  12    IF( LSTCMD .EQ. 45  .OR.  LSTCMD .EQ. 55
     +                      .OR.  DSPDTL(16)     ) CALL RSDISP(JVIEW)
C
  13  RETURN
C
      END

C   18/12/87 807262019  MEMBER NAME  MUCON    (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUCON
C-----------------------------------------------------------------------
C
C LAST CHANGE 20.03 26/07/88 CHRIS BOWDERY- PRINT MESSAGES ONLY ONCE
C      CHANGE 23.45 17/12/87 CHRIS BOWDERY- CHANGES IF NOT MUON MC DATA
C      CHANGE 20.30 19/02/84 CHRIS BOWDERY- REMOVE OLDSCR.NOW IN UCOPY
C      CHANGE 07.30 10/04/81 HUGH MCCANN  - JADEMUS UPDATE.
C      CHANGE 09.50 26/09/79 JOHN ALLISON.
C      CHANGE 20.16 21/09/79 HARRISON PROSPER.
C
C-----------------------------------------------------------------------
C
C      MUCON TRANSFERS ALL BOS BANKS INTO COMMON /CALIBR/
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  OLD, FIRST, FIRST1, FIRST2
C
C                            COMMONS.
C
#include "cmubcs.for"
#include "cmucalib.for"
C
C                            DECLARATIONS, INITIALISATIONS, ETC.
C
      DIMENSION HUNI1(82)
C
      DATA HUNI1/3,1,1,1,1,1,1,1,1,1,
     *           1,1,1,3,2,2,2,2,2,2,
     *           2,2,2,2,2,2,3,3,3,3,
     *           3,3,3,3,3,3,3,3,4,4,
     *           5,5,4,4,5,5,4,4,5,5,
     *           4,4,5,5,4,4,5,5,4,4,
     *           5,5,4,4,5,5,4,5,4,5,
     *           4,5,4,5,4,5,4,5,4,5,
     *           4,5                  /
C
      DATA  FIRST, FIRST1, FIRST2 / .TRUE., .TRUE., .TRUE. /
C
C------------------  C O D E  ------------------------------------------
C
      IF( .NOT. FIRST ) GO TO 1
        CALL MUMESS('MUCON ',0,'CALLED TO COPY MUON CALIBRATION.^')
        CALL MUMESS('MUCON ',0,'WARNING: MESSAGE IS NOT REPEATED!^')
        FIRST = .FALSE.
C
C                            CHECK FOR 'MFFI' - SHOULD  BE  THERE  FOR
C                            OLD AND NEW.
C
 1    CALL CLOC(IP,'MFFI',2)
      IF( IP .LE. 0 ) GO TO 98
      CALL UCOPY(IDATA(IP+1),HMFFIX,IDATA(IP))
C
C                            CHECK FOR NEW BANKS.
C
      CALL CLOC(IP,'MUCD',0)
      IF( IP .GT. 0 ) GO TO 2
C                            OLD (PRE MAY 1979).
      OLD    = .TRUE.
      NVERSN = 1
      CALL UCOPY( 'OLD (PRE MAY 1979) MONTE CARLO CALIBRATION DATA.^
     +      ',DESCRP,15)
      CALL VZERO(HOVALL,3)
      GO TO 3
C                            NEW.
 2    OLD = .FALSE.
      CALL UCOPY(IDATA(IP+1),NVERSN,IDATA(IP))
      CALL CLOC(IP,'MUOV',0)
      CALL UCOPY(IDATA(IP+1),HOVALL,IDATA(IP))
C
C                            IF BANKS ARE EMPTY, TAKE NO FURTHER ACTION
C
      IF( NVERSN .LE. 0 ) GO TO 98
C
C                            FIND OTHER BANKS, ADDING NEW ARRAYS WHERE
C                            NECESSARY.
C
 3    CALL CLOC(IP,'MCFI',3)
      CALL UCOPY(IDATA(IP+1),HMCFIX,IDATA(IP))
      IF(OLD)CALL UCOPY(HUNI1,HUNIT,41)
C
      CALL CLOC(IP,'MFSU',4)
      CALL UCOPY(IDATA(IP+1),HMFSUR,IDATA(IP))
C
      CALL CLOC(IP,'MCSU',5)
      CALL UCOPY(IDATA(IP+1),HMCSUR,IDATA(IP))
C
      CALL CLOC(IP,'MCEL',6)
      CALL UCOPY(IDATA(IP+1),HMCELE,IDATA(IP))
      IF( .NOT. OLD ) GO TO 4
      DO  8  I = 1,NCHAMS
      HVDRFT(I) = HVDR
 8    CONTINUE
 4    CONTINUE
C
      CALL CLOC(IP,'MCST',7)
      CALL UCOPY(IDATA(IP+1),HMCSTA,IDATA(IP))
      IF(OLD)CALL VZERO(HMCSTA,IDATA(IP))
C
      CALL CLOC(IP,'MUFI',8)
      CALL UCOPY(IDATA(IP+1),HFILDA,IDATA(IP))
C
      CALL CLOC(IP,'MUYO',9)
      CALL UCOPY(IDATA(IP+1),HYKNMI,IDATA(IP))
C
      CALL CLOC(IP,'MUEN',10)
      CALL UCOPY(IDATA(IP+1),IZEII,IDATA(IP))
C
C                            PRINT OUT CALIBRATION DESCRIPTION ONCE
C
      IF( .NOT. FIRST2 ) RETURN
        CALL MUMESS('MUCON ',NVERSN,DESCRP)
        CALL MUMESS('MUCON ',0,'WARNING: MESSAGE IS NOT REPEATED!^')
        FIRST2 = .FALSE.
C
      RETURN
C
C                            NO MUON INFORMATION IN THE BANKS.
C
 98   IF( .NOT. FIRST1 ) RETURN
        CALL MUMESS('MUCON ',0,'MUON CALIB. DATA BANKS NOT PRESENT.^')
        CALL MUMESS('MUCON ',0,'WARNING: MESSAGE IS NOT REPEATED!^')
        FIRST1 = .FALSE.
C
      RETURN
      END

C   27/07/79 C9081301   MEMBER NAME  TPVTX    (JADEGS)      FORTRAN
      SUBROUTINE TPVTX( NPPR )
C
C     S.YAMADA   18-07-79  09:00
C     LAST MODIFICATION   27-07-79  15:00
C                        MODIFIED FOR GRAPHICS USE, WITH /CWORK1/
C                                       J.OLSSON  29.07.79
C
C---- FIND THE VERTEX IN THE (X,Y) PROJECTION.
C
      COMMON /BCS/ IDATA(12000)
      DIMENSION ADATA(12000)
      EQUIVALENCE (IDATA(1),ADATA(1))
C
      COMMON /CWORK1/ MARK(40), CS(40),SN(40),X0(40),Y0(40), C(40),
     $               XV,YV, XX(40),YY(40),  XQ(40),
     $               A(40),B(40), A2B2(40), DIS2(40),
     $               NL, AL(40),BL(40), XYFIT(5), DIS2FT(40), IER, MODE
C
      COMMON /CTPVTX/ JCIRCL, RADMIN, DIS2MX,  NPCUT1,NPCUT2, COSCUT
      DATA  DMIN/1.E-20/, CNVVTX/4.E-4/, NTRYLM/10/
      DATA  RING2S/1.444E5/
C
      CMAX = 0.5/RADMIN
C
      XV = 0.
      YV = 0.
      IER = 0
      MODE = 0
      NTRY = 0
      DIS2LM = DIS2MX
        DO 400 K=1,5
  400   XYFIT(K) = 0.
C
C---- CHECK THE NUMBER OF INNER TRACKS.
      NTRK = IDATA(NPPR+2)
      IF(NTRK.LE.0) GO TO 100
C
C---- SET THE POINTER TO THE 1-ST TRACK
      NB = NPPR+IDATA(NPPR+1)
      NB0 = NB
      NSTEP = IDATA(NPPR+3)
C
C
        DO 1 I=1,NTRK
C----   COPY TRACK PARAMETERS
        CALL TPVTRC( I, NB)
C
C----   REMOVE LOW MOMENTUM TRACKS
        IF( 1.0-CS(I) ) 10,11,11
   10   IF( ABS(C(I))-RADMIN )  9,12,12
   11   IF( ABS(C(I))-CMAX ) 12,12,9
C
C----   CKECK NO.OF FITTED POINTS
C----   REMOVE TOO SHORT TRACKS IN THE FUTURE FITTING.
   12   IF(ADATA(NB+5)**2+ADATA(NB+6)**2-RING2S) 6,7,7
    6   IF(IDATA(NB+24)-NPCUT1) 9,8,8
    7   IF(IDATA(NB+24)-NPCUT2) 9,8,8
    8   MARK(I) = 0
        GO TO 1
    9   MARK(I) = -1
    1   NB = NSTEP+NB
C
C---- CALCULATE THE TANGENT LINE EQ.
    2 CALL TPVTNG(NTRK)
C
C---- FIT THE COMMON VERTEX
C     MOVE THE LINE PARAMETERS(A,B) TO AL AND BL ARRAYS.
      NL = 0
        DO 3 I=1,NTRK
        IF(MARK(I).LT.0) GO TO 3
C----   REMOVE TOO APART TRACKS.
   31   IF( DIS2(I)-DIS2LM ) 32,33,33
   32   NL = NL+1
        AL(NL) = A(I)
        BL(NL) = B(I)
        MARK(I) = 1
C///////////////////////////////
C       WRITE(6,6004) I,NL,AL(NL),BL(NL)
C6004   FORMAT(' I,NL,AL,BL=',2I4,2E10.3)
C///////////////////////////////
        GO TO 3
   33   MARK(I) = 0
C//////////////////////
C       WRITE(6,6005) I,DIS2(I), DIS2LM
C6005   FORMAT(' I,DIS2 =',I4,E12.3,'  DIS2LM=',E10.3)
C//////////////////////
    3   CONTINUE
C
C---- VERTEX FINDING PROGRAM
      IF( NL ) 100,100,40
   40 CALL TPVSLC( COSCUT )
      IF( MODE-2 ) 1000,61,62
C
C----  NEARLY PARARELL TWO TRACKS
   61 CALL TPVPRL
      GO TO 1000
C
      DATA SIGMA/1.0/
   62 CALL TPXYVX( NL, AL, BL, SIGMA, XYFIT, DIS2FT, IER)
C
C---- CHECK CONVERSION
      IF(NTRY.LT.1) GO TO 4
      RELDIF = (XV-XYFIT(1))**2+(YV-XYFIT(2))**2
C---- CHECK THE ABSOLUTE DIFFERENCE
      IF(RELDIF.LT.CNVVTX) GO TO 1000
      AVV = 0.25*((XV+XYFIT(1))**2+(YV+XYFIT(2))**2)
      IF(AVV.LE.0.) AVV = DMIN
      RELDIF = RELDIF/AVV
C---- CHECK THE RELATIVE DIFFERENCE
      IF( RELDIF.LT.CNVVTX) GO TO 1000
C
C---- REPEAT VERTEX FIT
    4 XV = XYFIT(1)
      YV = XYFIT(2)
      IF(XYFIT(5).GT.0.)   DIS2LM = 16.0*XYFIT(5)
      IF(DIS2LM.GT.DIS2MX) DIS2LM = DIS2MX
      IF(DIS2LM.LT.100.)   DIS2LM = 100.
      NTRY = NTRY+1
      IF(NTRY.GT.NTRYLM) GO TO 91
C---- RECALCULATE THE TANGENT LINES AT THE SHORTEST POINT FROM THE FIT
C     VERTEX.
C     GET THE CLOSEST POINT FROM THE VERTEX ON EACH TRACK.
        DO 5 I=1,NTRK
        IF( 1.0-CS(I) ) 50,55,55
   50   DX = XV-X0(I)
        DY = YV-Y0(I)
        DS = SQRT(DX**2+DY**2)
        IF(DS) 52,52,51
   51   RATIO = C(I)/DS
        XX(I) = X0(I)+RATIO*DX
        YY(I) = Y0(I)+RATIO*DY
        GO TO 5
C----   VERTEX IS ON THE CENTER. TRY  (0,0).
   52   XX(I) = 0.
        YY(I) = 0.
        GO TO 5
C
   55   AXBY = A(I)*XV-B(I)*YV
        XX(I) = A(I)*(AXBY+B(I)**2)/A2B2(I)
        YY(I) = B(I)*(-AXBY+A(I)**2)/A2B2(I)
    5   CONTINUE
      IF(IER) 1000,2,1000
C
C---- NO CONVERSION
   91 WRITE(6,691)
  691 FORMAT(' NO VERTEX CONV.')
C
C---- VERTEX POINT IS DEFINED IN THE (X,Y) PLANE.
 1000 NB = NB0
        DO 1001 I=1,NTRK
        X1 = ADATA(NB+5)
        Y1 = ADATA(NB+6)
        IF(A(I)*(X1-XYFIT(1))-B(I)*(Y1-XYFIT(2))) 1002,1003,1003
 1002   S = -1.
        GO TO 1004
 1003   S = 1.
 1004   A2B2(I) = SQRT(A2B2(I))
        A(I) = S*A(I)/A2B2(I)
        B(I) = -S*B(I)/A2B2(I)
        NB = NB+NSTEP
 1001   CONTINUE
  100 RETURN
      END
C
C
C*******************************************************************
C
      BLOCK DATA
C
      COMMON /CTPVTX/ JCIRCL, RADMIN, DIS2MX,  NPCUT1,NPCUT2, COSCUT
C
C---- INITIALIZATION OF PARAMETERS FOR THE VERTEX FITTING
C
C**** JCIRCL = FLAG TO FORCE CIRCLE PARAMETERS ALSO FOR PARABOLA FITTED
C              TRACKS.
      DATA JCIRCL/1/
C**** RADMIN = MIN.RADIUS OF THE TRACK TO BE USED FOR THE VERTEX
C                   FIT IN MM.
      DATA RADMIN/ 740./
C
C**** DIS2MX = SQUARED MAX.DIST.OF A TRACK IN MM**2
      DATA DIS2MX/1.0E4/
C**** NPCUT1 = MIN.NO. OF HITS IF THE TRACK STARTS IN THE R1-CHAMBER
      DATA NPCUT1/11/
C**** NPCUT2 = MIN.NO OF HITS ON THE TRACK IF IT STARTS AFTER THE R1.
      DATA NPCUT2/16/
C**** COSCUT = THE MAX.<ABS(COS(AL))> OF ALL SELECTED TRACK PAIRSIN
C              (X,Y) PROJECTION TO START A FIT.
C              IF <ABS(COS(AL))>.GT.COSCUT,THE AVERAGE FOOT-POINTS ARE
C              TAKEN.
      DATA COSCUT/0.90/
      END
      SUBROUTINE TPVTRC( I, NB )
C
C     S.YAMADA  18-07-79  18:55
C     LAST MODIFICATION  25-07-79   00:25
C
C---- COPY THE TRACK FIT PARAMETERS OF THE I-TH TRACK FROM 'PATR' TO
C     THE /CWORK1/.
C
      COMMON /BCS/ IDATA(12000)
      DIMENSION ADATA(12000)
      EQUIVALENCE (IDATA(1),ADATA(1))
C
C
      COMMON /CWORK1/ MARK(40), CS(40),SN(40),X0(40),Y0(40), C(40),
     $               XV,YV, XX(40),YY(40),  XQ(40),
     $               A(40),B(40), A2B2(40), DIS2(40),
     $               NL, AL(40),BL(40), XYFIT(5), DIS2FT(40), IER, MODE
C
      COMMON /CTPVTX/ JCIRCL, RADMIN, DIS2MX,  NPCUT1,NPCUT2, COSCUT
C
C---- BOTH PARABOLA AND CIRCLE FIT MAY BE USED.
C     IF(JCIRCL>0) PARABOLA PARAMETERS ARE CONVERTED INTO CIRCLE ONES.
      IF(IDATA(NB+18)-1) 20,20,21
C
C----   CIRCLE FIT CASE
   20 CS(I) = 10.
      SN(I) = 0.
      RAD = ADATA(NB+19)
      IF(ABS(RAD).LT.DMIN ) RAD = SIGN(DMIN,RAD)
      C(I) = 1.0/RAD
      DIS = C(I)+ADATA(NB+20)
      X0(I) = DIS*COS(ADATA(NB+21))
      Y0(I) = DIS*SIN(ADATA(NB+21))
      GO TO 22
C
C----   PARABOLA CASE
   21 IF(JCIRCL) 30,30,31
   30 CS(I) = COS(ADATA(NB+19))
      SN(I) = SIN(ADATA(NB+19))
      X0(I) = ADATA(NB+20)
      Y0(I) = ADATA(NB+21)
      C(I) = ADATA(NB+22)
      GO TO 22
C
C---- PARABOLA TO CIRCLE CONV.
   31 CS(I) = 10.0
      SN(I) = 0.
      IF(ADATA(NB+22)) 32,33,32
   32 C(I) = 0.5/ADATA(NB+22)
      GO TO 34
   33 C(I) = 1.E6
   34 X0(I) = ADATA(NB+20) - C(I)*SIN(ADATA(NB+19))
      Y0(I) = ADATA(NB+21) + C(I)*COS(ADATA(NB+19))
      C(I)  = ABS( C(I) )
C
C
   22 XX(I) = XV
      YY(I) = YV
C
      RETURN
      END
      SUBROUTINE TPVTNG(NTRK)
C
C     S.YAMADA  21-03-79  14:25
C     LAST MODIFICATION    15-05-79  20:50
C
C---- OBTAIN THE TANGENT LINE EQUATIONS OF THE FITTED CURVES.
C
C---- INPUT:  NTRK=NO.OF TRACKS FILLED INTO THE COMMON.
C             CS,SN,X0,Y0,C,XX,YY  MUST BE FILLED
      COMMON /CWORK1/ MARK(40), CS(40),SN(40),X0(40),Y0(40), C(40),
     $               XV,YV, XX(40),YY(40),  XQ(40),
     $               A(40),B(40),A2B2(40), DIS2(40),
     $               NL, AL(40),BL(40), XYFIT(5), DIS2FT(40)
C
C---- IN CASE OF CIRCLE FIT
C     CS > 1.00, SHOWS THAT THE FIT PARAMETERS ARE FOR CIRCLE FIT
C     SN         NOT USED
C     X0,Y0      CENTER COORDINATE.
C     C          RADIUS
C     --- EQUATION ----    (X-X0)**2+(Y-Y0)**2=C**2
C     XV,YV: VERTEX POINT
C     XX,YY      POINT TO CALULATE THE TANGENT
C
C---- IN CASE OF PARABOLA FIT
C     CS,SN:SIN AND COS OF THETA(PARABOLA INCLINATION ANGLE)
C     X0,Y0:XQ=0,YQ=0 POINT IN THE (X,Y) COORDINATE.
C     C:    PARABOLA PARAMETER  YP=C*XP**2
C     XV,YV: VERTEX POINT
C     XX,YY: POINT TO CALULATE XQ,WHERE THE PARABOLA TANGENT IS OBTAINED
C     XQ:    AT (XQ,XQ**2) THE TANGENT IS CALCULATED.
C
C---- OUTPUTS
C
C     A,B:   THE TANGENT LINE EQUATION IN THE (X,Y) COORDINATE.
C     DIS2:  DISTANCE FROM THE VERTEX TO THE TANGENT LINE.
C
      DATA DMIN/1.E-20/
C
      IF(NTRK.LE.0) RETURN
        DO 1 I=1,NTRK
        IF(CS(I).LE. 1.0) GO TO 2
C----   CASE OF CIRCLE FIT
        DX = XX(I)-X0(I)
        IF(ABS(DX).LT.DMIN ) DX = SIGN(DMIN,DX)
        DY = YY(I)-Y0(I)
        IF(ABS(DY).LT.DMIN ) DY = SIGN(DMIN,DY)
        DS = SQRT(DX**2+DY**2)
        DD = DS*C(I)+DX*X0(I)+DY*Y0(I)
        GO TO 3
C
C----   PARABOLA CASE
    2   XQ(I) = (XX(I)-X0(I))*CS(I)+(YY(I)-Y0(I))*SN(I)
C
C----   TANGENT AT XP=XQ,   YP = C*XQ*(2.*XP - XQ)
C
C----   THE SAME LINE IN THE (X,Y) COORDINATE, X/A+Y/B=1.0
C
        DX = 2.0*C(I)*XQ(I)*CS(I)+SN(I)
        IF( ABS(DX).LT.DMIN ) DX = SIGN(DMIN,DX)
        DY = 2.0*C(I)*XQ(I)*SN(I)-CS(I)
        IF( ABS(DY).LT.DMIN ) DY = SIGN(DMIN,DY)
        DD = DX*X0(I) + DY*Y0(I) + C(I)*XQ(I)**2
    3   A(I) = DD/DX
        B(I) = DD/DY
        B2 = B(I)**2
        A2 = A(I)**2
        A2B2(I) = A2+B2
        IF( A2B2(I).LT.DMIN ) A2B2(I) = DMIN
        DIS2(I) = (A(I)*B(I)-B(I)*XV-A(I)*YV)**2/A2B2(I)
C////////////////////
C
C       WRITE(6,6002) XX(I),YY(I),X0(I),Y0(I),CS(I),SN(I),XQ(I),
C    $              A(I),B(I),DIS2(I)
C6002   FORMAT(' XX,YY,X0,Y0,CS,SN,XQ,A,B,DIS2=',10E10.3)
C////////////////////////
C
    1   CONTINUE
      RETURN
      END
      SUBROUTINE TPVSLC( COSCUT )
C
C     S.YAMADA  01-04-79  18:05
C     LAST MODIFICATION   12-07-79  10:30
C
C---- SELECT THE MODE OF VERTEX FITTING.
C
      COMMON /CWORK1/ MARK(40), CS(40),SN(40),X0(40),Y0(40), C(40),
     $               XV,YV, XX(40),YY(40),  XQ(40),
     $               A(40),B(40), A2B2(40), DIS2(40),
     $               NL, AL(40),BL(40), XYFIT(5), DIS2FT(40), IER, MODE
      DIMENSION SQA2B2(40)
C
      MODE = NL
C
      IF(NL-2) 100,1,10
C
C---- CHECK PARAREL OR NOT.
    1 COST = ABS(AL(1)*AL(2)+BL(1)*BL(2))
      COST = COST/SQRT((AL(1)**2+BL(1)**2)*(AL(2)**2+BL(2)**2))
      IF(COST-COSCUT) 40,40,100
C
   10 MODE = 1
C---- CALCULATE THE AVERAGE COST
      NL1 = NL-1
      SCOST = 0.
      CONT = 0.
        DO 20 I=1,NL
        SQA2B2(I) = SQRT(AL(I)**2+BL(I)**2)
        IF(SQA2B2(I).EQ.0.) SQA2B2(I) = 1.E-20
   20   CONTINUE
        DO 11 I=1,NL1
        J1 = I+1
          DO 12 J=J1,NL
          COST = ABS(AL(I)*AL(J)+BL(I)*BL(J))/(SQA2B2(I)*SQA2B2(J))
          SCOST = SCOST+COST
   12     CONT = CONT+1.
   11   CONTINUE
      IF(CONT) 100,100,30
   30 COST = SCOST/CONT
      IF(COST-COSCUT) 40,40,50
   40 MODE = 3
      GO TO 100
   50 MODE = 2
  100 RETURN
      END
      SUBROUTINE TPVPRL
C
C     S.YAMADA  01-04-79  18:25
C     LAST MODIFICATION  02-04-79   11:05
C
C---- CALCULATE THE AVERAGE CLOSEST POINT FROM THE BEAM TO 2-TRACKS.
C     CALLED IN TPVTX1
C
C
      COMMON /CWORK1/ MARK(40), CS(40),SN(40),X0(40),Y0(40), C(40),
     $               XV,YV, XX(40),YY(40),  XQ(40),
     $               A(40),B(40), A2B2(40), DIS2(40),
     $               NL, AL(40),BL(40), XYFIT(5), DIS2FT(40), IER
C
        DO 4 K=1,4
    4   XYFIT(K) = 0.
      CNT = 0.
C
      IF(NL.LE.1) GO TO 90
C
        DO 5 I=1,NL
        B2 = BL(I)**2
        A2 = AL(I)**2
        ASBS = A2+B2
        IF(ASBS.LE.0.) ASBS = 1.E-20
        AB = AL(I)*BL(I)
        XS = AB*BL(I)/ASBS
        YS = AB*AL(I)/ASBS
        XYFIT(1) = XYFIT(1)+XS
        XYFIT(2) = XYFIT(2)+YS
        XYFIT(3) = XYFIT(3)+XS**2
        XYFIT(4) = XYFIT(4)+YS**2
        CNT = CNT+1.
    5   CONTINUE
C
C---- TAKE THE AVERAGE
      IF(CNT.LE.0.) CNT=1.
      XYFIT(1) = XYFIT(1)/CNT
      XYFIT(2) = XYFIT(2)/CNT
      XYFIT(3) = XYFIT(3)/CNT-XYFIT(1)**2
      XYFIT(4) = XYFIT(4)/CNT-XYFIT(2)**2
      IF(XYFIT(3).LT.0.) XYFIT(3) = 0.
      XYFIT(3) = SQRT(XYFIT(3))
      IF(XYFIT(4).LT.0.) XYFIT(4) = 0.
      XYFIT(4) = SQRT(XYFIT(4))
      IER = 0
      RETURN
C
   90 IER = 1
      RETURN
      END
      SUBROUTINE TPXYVX( NL, A, B, SIGMA, XYVTX, DIS2, IER)
C
C      S.YAMADA    07-01-78  21:05
C     LAST MODIFICATION  10-01-79   09:15
C
C---- CALCULATE THE COMMON VERTEX FOR NL-LINES IN THE X-Y PLANE
C
C---- INPUTS
C     NL;        NO.OF INPUT LINES(>1)
C     A(I),B(I); X,Y INTERCEPTS OF THE I-TH LINE.
C     SIGMA;     EXPECTED DEVIATION FOR A LINE.
C
C---- OUTPUTS
C     XYVTX(1);   X COORDINATE OF THE LEAST SQUARE FITTEDVERTEX POINT.
C     XYVTX(2);   Y    "
C     XYVTX(3);   ERROR FOR X
C     XYVTX(4);   ERROR FOR Y
C     XYVTX(5);   SUM(DIS2)/SIGMA2       A KIND OF CHI-SQUARE

C                          VERTEX POINT
C     DIS2;    SQUARED DISTANCES FROM THE (XYVTX) TO THE INPUT LINES.
C     IER;     ERROR FLAG, =0 IF NOERROR.
C
      DIMENSION A(1),B(1),  XYVTX(2),DIS2(1)
C
      IF(NL.LE.1) GO TO 90
        DO 400 K=1,5
  400   XYVTX(K) = 0.
C
      SB2 = 0.
      SA2 = 0.
      SAB = 0.
      SA2B = 0.
      SAB2 = 0.
        DO 1 N=1,NL
        B2 = B(N)**2
        A2 = A(N)**2
        C = A2+B2
        IF(C.LE.1.E-30) C=1.E-30
        RC = 1./C
        DIS2(N) = RC
        AB = A(N)*B(N)
        SB2 = SB2+B2*RC
        SA2 = SA2+A2*RC
        SAB = SAB+AB*RC
        SA2B = SA2B+A2*B(N)*RC
        SAB2 = SAB2+AB*B(N)*RC
    1   CONTINUE
C
C---- THE EQUATION FOR X,Y
C     SB2*X + SAB*Y = SAB2
C     SAB*X + SA2*Y = SA2B
C
      C = SA2*SB2-SAB**2
      IF(C.EQ.0.0) GO TO 91
      XYVTX(1) = (SAB2*SA2-SA2B*SAB)/C
      XYVTX(2) = (SA2B*SB2-SAB2*SAB)/C
      IER = 0
C
C---- ERRORS OF (X,Y) ARE SET
      IF(SB2.GT.0.) XYVTX(3) = SIGMA/SQRT(SB2)
      IF(SA2.GT.0.) XYVTX(4) = SIGMA/SQRT(SA2)
C
C
C---- DISTANCE**2 FROM THE XY-VERTEX TO EACH INPUT LINE IS CALCULATED.
      SDIS2 = 0.
        DO 2 N=1,NL
        DIS2(N) = DIS2(N)*(A(N)*B(N)-B(N)*XYVTX(1)-A(N)*XYVTX(2))**2
        SDIS2 = SDIS2+DIS2(N)
    2   CONTINUE
      XYVTX(5) = SDIS2/SIGMA**2/(NL-1)
      RETURN
C
   90 WRITE(6,690) NL
  690 FORMAT(' TOO FEW LINES FOR TPXYVX-INPUTS,  NL=',I2)
      IER = 1
      RETURN
   91 IER = 2
      RETURN
      END

C   20/10/82 409271500  MEMBER NAME  KALIBR   (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE KALIBR
C-----------------------------------------------------------------------
C
C        HANDLES STANDARD JADE CALIBRATION DATA
C
C
C        TEMPORARY KLUGE TO PUT IN SOMEWHAT BETTER CALIBRATION DATA
C        IN THE CASE OF REAL DATA THAN THE MONTE CARLO VALUES. THE
C        "TWISTING ANGLE" IS LEFT AT 20 DEGREES FOR THE TIME BEING
C        BUT ITS SIGN IS REVERSED COMPARED TO THE MONTE CARLO CONVEN-
C        TION IN ORDER TO CONFORM TO THE DATA TAKEN SO FAR, FOR WHICH
C        THE MAGNETIC FIELD POINTS ALONG THE MINUS Z AXIS. THE TIMING-
C        BINS-TO-MILLIMETERS CONVERSION FACTORS ARE ALL SET TO 0.382
C        AND THE EFFECTIVE LENGTH OF THE WIRES TO 2792.9, BOTH VALUES
C        OBTAINED FROM MR. NOZAKI TODAY.
C                                      TUESDAY, MARCH 27, 1979
C                                      L.H. O'NEILL
C        ADDED: BKGAUS = -4.9          J.OLSSON 2.4.79
C        DIVIDED TIMDELS BY 64.        L.H. O'NEILL 11 JUNE, 1979.
C        UPDATED SETTING OF BKGAUS, CALL TO INPATR OUT
C                                      J.OLSSON 23.6.79
C
C        NEW VERSION SETS WIRE STAGGERING TO 200 MICRONS INSTEAD OF
C        150 AND INCREASES WIRE RADII BY 0.5 MM.
C
C                                      L.O'NEILL 02.08.79 14.50
C        BKGAUS IS TESTED UPON TO INSURE THAT IT IS NEGATIVE
C                                      J OLSSON 18.08.79
C        MANY CHANGES IN ALFA AND TZERO VALUES , NOZAKIS NEW CONSTANTS
C        INTRODUCED 14.9.80                 J.OLSSON
C        LORENTZ ANGLE VARIES WITH MAGNETC FIELD VALUE IF VARIATION
C        IF VARIATION > 1%                  P.STEFFEN 81/05/12
C        YEAR UPDATE FOR RUNS 7417-28       J.OLSSON 81/05/29
C        29 FEBRUARY UPDATE                 J.OLSSON 81/06/05
C     NEW 81 RUNS WITH YEAR 0 DISCOVERED, CORRECTED  J.OLSSON 81.06.22
C
C        T0 + LORENZ ANGLES FOR 1981              P. STEFFEN 81/10/09
C
C     NOZAKI POINTED OUT THAT THE STATEMENT GO TO 8 IS MISSING BETWEEN
C     1981 AUTUMN AND 1982  T0 SETTING    THIS LEADS TO 1982 CONSTANTS
C     BEING USED FOR 1981 AUTUMN DATA !!!!
C     CHANGED THIS EVENING,  12.3.1982     J.OLSSON
C
C     E-BEAM SET TO 17300 MEV FOR RUN 11790       P. STEFFEN 82/09/21
C
C
C     NEW TWANG, DRIVELS AND T0 ADDED FOR RUNS > 11036
C     OLD VERSION RETAINED AS KALIBR0 !!!!
C                                                G.F.PEARCE 18/05/82
C
C     RUNS > 10000 : YEAR FORCED TO 1982
C                                                P. STEFFEN 82/06/15
C
C
C        T0 FOR 1982 (CORRECTED)                 P. STEFFEN 82/06/21
C        EBEAM FOR 12804-12805                   J.OLSSON   82/12/08
C        BFIELD FOR RUNS 13651-13653          J.OLSSON   83/06/13
C        BEAM E FOR RUNS 13707-13714          J.OLSSON   83/06/14
C        BEAM E FOR RUNS 10666,11038-11052    J.OLSSON   83/08/08
C        BEAM E FOR RUNS 11104,11791          J.OLSSON   83/08/01
C        BEAM E FOR RUN  13826                J.OLSSON   83/08/05
C        BEAM E FOR RUN  16342                J.OLSSON   84/09/27
C
C        ADDED EXTERNAL JADEBD                C.BOWDERY  84/01/09
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C                                       FORCE LOADING OF JADE BLOCK DATA
      EXTERNAL JADEBD
C
#include "cdata.for"
C                                       INITIALIZE POINTER
      DATA LBINIT /0/
C
C------------------  C O D E  ------------------------------------------
C
      IF(LBINIT.NE.0) GOTO 10
         IQHEAD=IBLN('HEAD')
   10 CONTINUE
C
C
      IHHEAD=IDATA(IQHEAD)*2
      NRUN=HDATA(IHHEAD+10)
C
C                            FIX YEAR SCREW UP.
C
         IYEAR = HDATA(IHHEAD+8)
         IF(NRUN.GE. 2570.AND.NRUN.LE.2802) HDATA(IHHEAD+8)=1980
         IF(NRUN.GT. 6000.AND. IYEAR.LT.1981) HDATA(IHHEAD+8)=1981
         IF(NRUN.GT.10000.AND. IYEAR.LT.1982) HDATA(IHHEAD+8)=1982
C
C                            FIX 29 FEBRUARY 1981 SCREW UP
C
         IF(HDATA(IHHEAD+8).EQ.1984) GO TO 5410
         IF(HDATA(IHHEAD+7).NE.2) GO TO 5410
         IF(HDATA(IHHEAD+6).EQ.29) HDATA(IHHEAD+7) = 3
         IF(HDATA(IHHEAD+6).EQ.29) HDATA(IHHEAD+6) = 1
C
C                            RESET MAGNETIC FIELD FOR PERIOD WHEN  READ
C                            OUT SET IT TO 0
C
5410     CONTINUE
         IF(NRUN.EQ.11908) HDATA(IHHEAD+30) = -4848
         IF(NRUN.GE.13651.AND.NRUN.LE.13653) HDATA(IHHEAD+30) = -4844
         IF(NRUN.LT.12255.OR.NRUN.GT.12270) GO TO 5411
         HDATA(IHHEAD+30) = -4847
C
C                            CORRECT BEAM ENERGIES FOR SELECTED RUNS
C
5411     CONTINUE
         IF(NRUN.LT.10000) GO TO 5408
         IF(NRUN.GT.11037.AND.NRUN.LT.11053) HDATA(IHHEAD+29) = 17243
         IF(NRUN.EQ.11104.OR.NRUN.EQ.10666) HDATA(IHHEAD+29) = 17300
         IF(NRUN.EQ.11790.OR.NRUN.EQ.11791) HDATA(IHHEAD+29) = 17300
         IF(NRUN.EQ.12804.OR.NRUN.EQ.12805) HDATA(IHHEAD+29) = 19120
         IF(NRUN.GE.13707.AND.NRUN.LE.13713) HDATA(IHHEAD+29) = 20725
         IF(NRUN.EQ.13714) HDATA(IHHEAD+29) = 20740
         IF(NRUN.EQ.13826) HDATA(IHHEAD+29) = 20795
         IF(NRUN.EQ.16342) HDATA(IHHEAD+29) = 23240
C
C                            PRINTOUT(WARNING) LOW MAG.FIELD
C
5408     IFIELD = HDATA(IHHEAD+30)
         IF(IABS(IFIELD).LT.100) WRITE(6,5407) NRUN,IFIELD
5407  FORMAT(' * KALIBR #### *   WARNING: RUN ',I6,' HAS MAGNETIC FIELD
     $ = ',I6,' GAUSS ')
C
C                            PRINTOUT(WARNING) LOW BEAM ENERGY
C
         IF(NRUN.LT.6000) GO TO 1201
         IBEAM = HDATA(IHHEAD+29)
         IF(IBEAM.LT.5000) WRITE(6,5404) NRUN,IBEAM
5404  FORMAT(' * KALIBR #### *   WARNING: RUN ',I6,' HAS BEAM ENERGY = '
     $,I6,' MEV ')
C
1201  CONTINUE
      CALL KLREAD
C
      CALL MUREG(0)
C
      RETURN
      END

C   25/10/83 705102120  MEMBER NAME  TRKGMV   (S)           FORTRAN
C-----------------------------------------------------------------------
      SUBROUTINE TRKGMV(PV,R0,R,P1,P2,*,*)
C-----------------------------------------------------------------------
C
C   AUTHOR:   J. HAGEMANN 22/11/82 :  TRACKING OF PHOTONS THROUGH NEW
C             R. RAMCKE               DETECTOR CONFIGURATION (VTX CHAM)
C
C   LAST MOD  J. HAGEMANN 11/12/83 :  BETTER LG SIMULATION NOW POSSIBLE
C
C  ******************************************************************
C           ERRORS IN RADIATOR THICKNESSES CORRECTED   15.03.1986
C                                                       J. OLSSON
C           CORRECTED RADIATION LENGTH FOR VTXC MATTER 11.06.1986
C                                                       J. HAGEMANN
C  ******************************************************************
C
C      THIS ROUTINE TRACKS PHOTONS THROUGH THE DETECTOR
C      UP TO THE LEAD GLASS SURFACES OF BARREL COUNTERS AND END CAPS
C      HODOSCOPES ARE SET BY CONVERTING GAMMAS
C
C      PV = USUAL PARTICLE VECTOR OF DIMENSION 10
C           FIRST FOUR ARE FOURVECTOR COMPONENTS SEE TRCDET
C      R  = THREE DIMENSIONAL RADIUS VECTOR
C      PV AND R ARE OVER WRITTEN UPON RETURN
C      P1 AND P2 CONTAIN THE E+/E- VECTORS IF A CONVERSION HAS
C      TAKEN PLACE BEFORE THE END OF THE CENTRAL DETECTOR
C
C     RETURN 1 IS USED IF THERE IS NO CONVERSION OR A CONVERSION
C              IN THE COIL. IN THIS CASE PV IS CONVERTED INTO AN
C              ELECTRON VECTOR.
C     RETURN 2 IS USED IF THE PHOTON LEAVES THE DETECTOR WITHOUT
C              ANY INTERACTION I.E. THROUGH THE BEAM PIPE OR THROUGH
C              GAPS,
C              OR IF PHOTON HAS LESS THAN PMIN ENERGY.
C
C-----------------------------------------------------------------------
C
      LOGICAL * 1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
      COMMON / CGEO1  / BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *                  RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *                  R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *                  R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *                  RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *                  ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *                  ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *                  ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *                  XRJETC,
     *                  RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *                  BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *                  XHOL1,XHOL2,YHOL1,YHOL2
C
      COMMON / CGEOV  / RPIPV, DRPIPV, XRLPIV, RVXC, DRVXC, XRLVXC,
     *                  ZVXCM, DZVCM, XRZVCM, ZVXCP, DZVCP, XRZVCP,
     *                  XRVTXC
C
      DIMENSION PV(10),R0(3),R(3),P1(10),P2(10)
C
      REAL ME/0.5E-03/
      REAL PMIN / .005 /
C
C  XRL10 GIVES THICKNESS OF CONVERTER UP TO PASSING BEAM PIPE
C       BEAMPIPE   0.0337  X0   (INCLUDES WATER COOLING PIPES..)
C      0.2776*BEAMPIPECHAMBER      0.00674 X0
C  XRL20 GIVES THICKNESS OF REMAINING CONVERTER UP TO INNER DETECTOR
C      0.7224*BEAMPIPECHAMBER      0.01754 X0
C       INNER TANKWALL             0.0787 X0
C       ZEROTH ROHACELL LAYER      0.0076 X0
C       1/3 OF I.D. GAS            0.0069 X0
C  XRL30 GIVES THICKNESS OF FIRST MIDDLE ROHACELL + I.D. GAS
C       FIRST MIDDLE ROHACELL    0.0109 X0
C       1/3 OF I.D. GAS          0.0069 X0
C  XRL40 GIVES THICKNESS OF FIRST MIDDLE ROHACELL + I.D. GAS
C       SECOND MIDDLE ROHACELL   0.0109 X0
C       1/6 OF I.D. GAS          0.0035 X0
C  XRL50 GIVES THICKNESS OF CONVERTER UP TO SETTING OF TOF COUNTERS
C       1/6 OF I.D. GAS          0.0035 X0
C       LAST ROHACELL LAYER      0.0147 X0
C       OUTER TANKWALL           0.1348 X0
C       INNER DET. CABLING       0.0252 X0  (ALSO G10 STRIPS)
C       Z-CHAMBER                0.0625 X0
C       1/2 TOF-COUNTERS         0.0238 X0
C  XRL60 GIVES THICKNESS OF CONVERTER AFTER MIDDLE OF TOF COUNTERS
C       1/2 TOF-COUNTERS         0.0238 X0
C       COIL AND HEATSHIELDS     0.7562 X0
C
      DATA XRL10 /0.04045/, XRL20 /0.11074/, XRL30 /0.0178/
      DATA XRL40 /0.0144/, XRL50 /0.2645/, XRL60 /0.7800/
      DATA ICLTRG /0/
C
C--------------------  C O D E  ----------------------------------------
C
C
      ICLTRG = ICLTRG + 1
      IF(ICLTRG.EQ.1) WRITE(6,3855)
3855  FORMAT('   * * *   NEW, CORRECTED TRKGMV VERSION, FROM 15.3.1986')
C
C
C      FOLLOW PHOTON FROM THE IA POINT TO THE BEAM PIPE (+VESSEL)
C
      DO 2 I10=1,10
      P1(I10)=0.
    2 P2(I10)=0.
      R(1)=R0(1)
      R(2)=R0(2)
      R(3)=R0(3)
C *** TEST PHOTON ENERGY
      IF( PV(6) .LT. PMIN ) RETURN2
      PVX=PV(1)/PV(6)
      PVY=PV(2)/PV(6)
      PVZ=PV(3)/PV(6)
C *** TEST ON GAMMA ANGLE
      IF(ABS(PVZ).GT.0.968) RETURN 2
      PVXY=PVX**2+PVY**2
      IF(PVXY.LT.1.E-5) RETURN 2
C
C      CALCULATE GEOMETRICAL CONST., TRACK TO THE BEAM PIPE
C
      STH=SQRT(1.-PVZ**2)
C
C     XRL1=XRLPIV/STH
C     XRL2=XRLTKI/STH
C     XRL3=XR1ROH/STH
C     XRL4=XR2ROH/STH
C     XRL5=XRLTKO/STH
C     XRL6=XRCOIL/STH
C
      XRL1=XRL10/STH
      XRL2=XRL20/STH
      XRL3=XRL30/STH
      XRL4=XRL40/STH
      XRL5=XRL50/STH
      XRL6=XRL60/STH
C
      R1=R(1)**2+R(2)**2
      DR2=(RPIPV**2-R1)/PVXY
      IF( DR2 .LE. 0. ) GO TO 10
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
      IF(R(3).GT.ZTKP) GO TO 1000
      IF(R(3).LT.ZTKM) GO TO 1000
C
C     IF THERE IS A CONVERSION RETURN TO THE CALLING PROGRAM
C     WITH THE ELECTRON MOMENTA IN P1 AND P2
C
C     TEST FOR CONVERSION IN THE BEAM PIPE
C
      CALL EEPAIR(PV,P1,P2,XRL1,*10)
C
C ******                 CALCULATE ACTUAL CONVERSION POINT
      DCONV = DRPIPV * RN(DUM) / STH
      R(1)  = R(1) + DCONV*PVX
      R(2)  = R(2) + DCONV*PVY
      R(3)  = R(3) + DCONV*PVZ
      RETURN
C
C      FOLLOW GAMMA FROM PIPE TO INNER RADIUS OF THE TANK
C
   10 CONTINUE
C
C      CHECK IF PHOTON PASSES VERTEX CHAMBER END PLATE
C
      IF(ABS(PVZ).GE.0.973 .OR. ABS(PVZ).LE.0.922)  GO TO 334
      XDRIN = XRZVCP / ABS(PVZ)
      RIN = ZVXCP*SQRT(1. - PVZ*PVZ)/ABS(PVZ)
      R1=R(1)*R(1)+R(2)*R(2)
      DR2=(RIN*RIN-R1)/PVXY
      IF(DR2 .LE. 0.) GO TO 334
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR*PVR+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
      IF(R(3) .GE. ZVXCP+DZVCP) GO TO 1000
      IF(R(3) .LE. ZVXCM+DZVCM) GO TO 1000
C
C !!!!!  TEST FOR CONVERSION IN THE END PLATE OF VERTEX CHAMBER
C
      CALL EEPAIR(PV, P1, P2, XDRIN, *334)
C ******                 CALCULATE ACTUAL CONVERSION POINT
      DCONV = DZVCP * RN(DUM) / ABS(PVZ)
      R(1)  = R(1) + DCONV*PVX
      R(2)  = R(2) + DCONV*PVY
      R(3)  = R(3) + DCONV*PVZ
C     WRITE(6,2222) DCONV,R(1),R(2),R(3)
C2222 FORMAT('  DCONV R1 R2 R3 ',4F12.3)
      RETURN
C
  334 CONTINUE
C                      INNER TANK WALL
      R1=R(1)**2+R(2)**2
      DR2=(RITNK**2-R1)/PVXY
      IF( DR2 .LE. 0. ) GO TO 11
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
      IF(R(3).GT.ZTKP) GO TO 1000
      IF(R(3).LT.ZTKM) GO TO 1000
C
C      TEST FOR CONVERSION IN THE TANK WALL
C
      CALL EEPAIR(PV,P1,P2,XRL2,*11)
C ******                 CALCULATE ACTUAL CONVERSION POINT
      DCONV = DRITNK * RN(DUM) / STH
      R(1)  = R(1) + DCONV*PVX
      R(2)  = R(2) + DCONV*PVY
      R(3)  = R(3) + DCONV*PVZ
      RETURN
C
C      FOLLOW GAMMA FROM INNER TANK TO FIRST ROHACELL
C
   11 CONTINUE
      R1=R(1)**2+R(2)**2
      DR2=(R1ROH**2-R1)/PVXY
      IF( DR2 .LE. 0. ) GO TO 12
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
      IF(R(3).GT.ZTKP) GO TO 1000
      IF(R(3).LT.ZTKM) GO TO 1000
C
C      TEST FOR CONVERSION IN THE ROHACELL
C
      CALL EEPAIR(PV,P1,P2,XRL3,*12)
C ******                 CALCULATE ACTUAL CONVERSION POINT
      DCONV = DR1ROH * RN(DUM) / STH
      R(1)  = R(1) + DCONV*PVX
      R(2)  = R(2) + DCONV*PVY
      R(3)  = R(3) + DCONV*PVZ
      RETURN
C
C      FOLLOW GAMMA FROM FIRST ROHACELL TO SECOND ROHACELL
C
   12 CONTINUE
      R1=R(1)**2+R(2)**2
      DR2=(R2ROH**2-R1)/PVXY
      IF( DR2 .LE. 0. ) GO TO 13
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
      IF(R(3).GT.ZTKP) GO TO 1000
      IF(R(3).LT.ZTKM) GO TO 1000
C
C      TEST FOR CONVERSION IN THE ROHACELL LAYER
C
      CALL EEPAIR(PV,P1,P2,XRL4,*13)
C ******                 CALCULATE ACTUAL CONVERSION POINT
      DCONV = DR2ROH * RN(DUM) / STH
      R(1)  = R(1) + DCONV*PVX
      R(2)  = R(2) + DCONV*PVY
      R(3)  = R(3) + DCONV*PVZ
      RETURN
C
C      FOLLOW GAMMA FROM SECOND ROHACELL TO TANK
C
   13 CONTINUE
      R1=R(1)**2+R(2)**2
      DR2=(ROTNK**2-R1)/PVXY
      IF( DR2 .LE. 0. ) GO TO 15
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
      IF(R(3).GT.ZTKP) GO TO 1000
      IF(R(3).LT.ZTKM) GO TO 1000
C
C      TEST FOR CONVERSION IN THE TANK WALL
C
      PPROB=EXP(-XRL5*7./9.)
      IF(PV(4).LT.0.5) PPROB=EXP(-XRL5*7./9.*(1.-6.2E-02/SQRT(PV(4))))
      IF(PPROB.GT.RN(DUM)) GO TO 15
      POLD = PV(6)
      PNEW = POLD
      IF(LFLAG(2)) PNEW=PV(6)-0.02*(1.+0.3*RN(DUM))*(0.5*XRL5+XRL6)
      IF(PNEW.LT.0.) PNEW=0.001
      PV(1) = PNEW/POLD*PV(1)
      PV(2) = PNEW/POLD*PV(2)
      PV(3) = PNEW/POLD*PV(3)
      PV(6) = SQRT( PV(1)**2+PV(2)**2+PV(3)**2 )
      PV(4)=SQRT(PV(6)**2+ME**2)
      PV(5)=ME
      PV(7)=1.
C
C      FOLLOW ELECTRON FROM TANK TO TOF COUNTERS. IT IS ASSUMED THAT
C      THE PHOTON CONVERTS INTO ONE ELECTRON WHICH CONTINUES WITH
C      DIRECTION AS THE PHOTON AS ENERGY LOSS ONLY SHOWER LOSSES ARE
C      CONSIDERED
C
      R1=R(1)**2+R(2)**2
      DR2=(RTOF**2-R1)/PVXY
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
      IF(R(3).GT.ZTOFPL) GO TO 1000
      IF(R(3).LT.ZTOFMI) GO TO 1000
C
C      SET TOF COUNTER
C
      CALL SETTOF(R)
C                                           MOD E.ELSEN 22/08/80
      TRL=RTOF/ABS(PVZ)
      CALL ACTOF(PV,R,TRL)
C
C      FOLLOW GAMMA FROM TANK TO COIL
C
   15 R1=R(1)**2+R(2)**2
      DR2=(RCOIL**2-R1)/PVXY
      IF( DR2 .LE. 0. ) GO TO 20
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
      IF(R(3).GT.ZLGPL) GO TO 1000
      IF(R(3).LT.ZLGMI) GO TO 1000
C
C      TEST FOR CONVERSION IN THE COIL
C
      IF(PV(5).GT.1.E-5) GO TO 20
      PPROB=EXP(-XRL6*7./9.)
      IF(PV(4).LT.0.5) PPROB=EXP(-XRL6*7./9.*(1.-6.2E-02/SQRT(PV(4))))
      IF(PPROB.LT.RN(DUM)) GO TO 20
      POLD = PV(6)
      PNEW = POLD
      IF(LFLAG(2)) PNEW=PV(6)-0.02*(1.+0.3*RN(DUM))*0.5*XRL6
      IF(PNEW.LT.0.) PNEW=0.001
      PV(1) = PNEW/POLD*PV(1)
      PV(2) = PNEW/POLD*PV(2)
      PV(3) = PNEW/POLD*PV(3)
      PV(6) = SQRT( PV(1)**2+PV(2)**2+PV(3)**2 )
      PV(4)=SQRT(PV(6)**2+ME**2)
      PV(5)=ME
      PV(7)=1.
C
C      FOLLOW ELECTRON OR GAMMA FROM TOF TO LEAD GLASS
C
   20 R1=R(1)**2+R(2)**2
      DR2=(RLG**2-R1)/PVXY
      IF( DR2 .LE. 0. ) GO TO 9000
      PVR=R(1)*PVX+R(2)*PVY
      PVR=PVR/PVXY
      XL=-PVR+SQRT(PVR**2+DR2)
C
      R(1)=R(1)+XL*PVX
      R(2)=R(2)+XL*PVY
      R(3)=R(3)+XL*PVZ
C
      IF(R(3).GT.ZLGPL) GO TO 1000
      IF(R(3).LT.ZLGMI) GO TO 1000
   21 RETURN 1
C
C      FOLLOW PHOTON TO THE FACE OF THE END CAP COUNTERS
C
 1000 CONTINUE
      RABS=0.
      DO 1001 I3=1,3
 1001 RABS=RABS+R(I3)**2
      RABS=SQRT(RABS)
      DO 1002 I3=1,3
 1002 R(I3)=R(I3)/RABS
      ZLAM=ZENDPL/R(3)
      IF( R(3) .LT. 0. ) ZLAM=ZENDMI/R(3)
      DO 1003 I3=1,3
 1003 R(I3)=ZLAM*R(I3)
      CALL ENDCLG(R,NCL,*9000)
      RETURN 1
 9000 RETURN 2
      END

C   07/06/96 606071917  MEMBER NAME  USSTO    (S4)          FORTG1
      SUBROUTINE USSTO(NA,KA,X)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      IF(KA.LT.0) GOTO 100
      CALL BLOC(IND,'SST*',NA,&20)
   10 NEN=IW(IND+1)
      INDK=IND+2+KA*(NEN+1)
      IF(IW(INDK).GT.IND+IW(IND)) GOTO 100
      IW(INDK)=IW(INDK)+1
      N=IW(INDK)
      IF(N.GT.NEN) GOTO 100
      RW(INDK+N)=X
      GOTO 100
   20 IF(KA.NE.0) GOTO 100
      CALL BCRE(IND,'SST*',NA,102,&100,IER)
      IW(IND+1)=100
      GOTO 10
C
      ENTRY DSSTO(NA,KA,IEN)
      CALL BLOC(IND,'SST*',NA,&30)
      GOTO 100
   30 KAK=0
      IF(KA.GT.0) KAK=KA
      NW=IEN
      IF(NW.LE.0) NW=0
      NWW=NW
      NW=(KAK+1)*(NW+1)+1
      CALL BCRE(IND,'SST*',NA,NW,&100,IER)
      IW(IND+1)=NWW
      GOTO 100
C
      ENTRY QSSTO(NA,KA,Q,NQ,NTOT)
      REAL Q(1)
      NQ=0
      NTOT=0
      IF(KA.LT.0) GOTO 100
      CALL BLOC(IND,'SST*',NA,&100)
      NEN=IW(IND+1)
      INDK=IND+KA*(NEN+1)+2
      IF(INDK.GT.IND+IW(IND)) GOTO 100
      NTOT=IW(INDK)
      NQ=MIN0(NTOT,NEN)
      IF(NQ.EQ.0) GOTO 100
      DO 40 I=1,NQ
   40 Q(I)=RW(INDK+I)
C
  100 RETURN
      END

C   23/06/78 708241856  MEMBER NAME  NPECER   (S)           FORTRAN
      SUBROUTINE NPECER(JBE,Z,COST,PENUM)
C
CCC   S.YAMADA    12-12-77
CCC   LAST MODIFICATION  13-11-78  10:50
CCC   ----- NEW PARAMETERS CALCULATED BY A.SATO ARE USED NOW -----
CCC   ----- SEE THE TELEX 13.NOV.78 BY A.SATO. -----
C
C   UPDATED WITH RESULT FROM CERSF56.NR2,3  18.4.87    J.O.
C
C   DATA FROM CERTST5.NR1     DONE WITH N=1.6725
C    (NEW BARREL DATA ONLY, B-ARRAY LATER PART FOR ENDCAP STAYS SAME)
C   THE OLD EMPIRICAL FORMULA IS ONLY USED IN ENDCAPS
C   FOR THE BARREL AN INTERPOLATION IS USED, IS MORE ACCURATE
C      (PREVIOUSLY CALLED NPECER8)
C
C---- CALCULATE NUMBER OF PHOTOELECTRONS BY CERECKOV LIGHT.
C
C INPUT
C     JBE=1 FOR BARREL PART,  =2 FOR END CAP
C     Z=DEPTH OF THE SOURCE TRACK IN THE LEAD GLASS( RAD.LENGTH )
C     COST=COS(THETA) OF THE SOURCE TRACK W.R.TO THE NORMAL OF
C          THE CATHODE SURFACE.
C
C OUTPUT
C     PENUM=NO.OF PHOTOELECTRONS/1RAD.LENGTH LONG TRACK.
C
C---- AN EMPIRICAL FORMULA IS USED.
C---- PHOTOMULTIPLIER AREA IS ASSUMED TO COVER THE WHOLE SURFACE.
C---- TO GET THE REAL PHOTOELECTRON NUMBER PENUM SHOULD BE MULTIPLIED
C     BY THE RATIO (CATHODE AREA/LEAD GLASS CROSS SECTION).
C
      DIMENSION A(2),B(8,2,2)
      DATA B/54.90,48.55,-1180.1, 4484.0, -5803.2,657.17,3772.8,-1950.8,
     1 0.3566,0.624,-1.1146, 9.2361, 2.1321, -22.445,-1.0606, 14.955,
     2   57.43, 18.43, -967.99, 3892.1,-5084.3, 367.12, 3683.6,-1880.3,
     3  0.7039,2.9466,-5.5495,-6.5502, 19.755, 19.114,-17.413,-16.228/
C
      DIMENSION AFIT(21,2)
      DATA AFIT/
     $ 83.344, 53.083, 48.599, 45.092, 42.589, 40.442, 48.708, 52.659,
     $ 53.865, 55.566, 55.503, 55.939, 54.140, 52.271, 46.991, 40.710,
     $ 42.327, 45.090, 48.847, 53.213, 83.832,
     $  2.685,  1.480,  1.260,  1.253,  1.186,  1.158,  0.826,  0.607,
     $  0.544,  0.436,  0.369,  0.197,  0.136, -0.054,  0.002, -0.662,
     $ -0.627, -0.728, -0.811, -0.869, -1.529/
C
      DATA ICALNP/0/
C
C  ////////////////////////////////////////
C
      IF(ICALNP.NE.0) GO TO 111
      ICALNP = 1
      WRITE(6,1111)
1111  FORMAT(' NPECER FOR SF5, WITH INTERPOLATION...')
111   CONTINUE
C
      PENUM = 0.
C---- CHECK POSITION
      IF(Z.LT.0. .OR. Z.GT.13.4 ) GO TO 90
      IF(ABS(COST).GT.1.0) GO TO 90
C---- DETERMINE A
      JBEW = JBE
C---- PROTECTION AGAINST FAULS JBE INPUT.
      IF(JBEW.LT.1) JBEW = 1
      IF(JBEW.GT.2) JBEW = 2
C
      IF(JBEW.EQ.2) GO TO 55
C
        COSS = -1.
        DO 22  I = 1,20
        COSL = COSS
        COSS = COSS + .1
        IF(COST.GT.COSS) GO TO 22
C
        FRAC = (COST - COSL) / .10
        J = 22 - I - 1
        K = 22 - I
C
        A(1) = AFIT(K,1) + FRAC*( AFIT(J,1) - AFIT(K,1) )
        A(2) = AFIT(K,2) + FRAC*( AFIT(J,2) - AFIT(K,2) )
C
       GO TO 33
C
   22   CONTINUE
       GO TO 33
C
55     CONTINUE
        DO 1 IA=1,2
        X = COST
        IF(IA.EQ.1) X = X*X
        F = B(8,IA,JBEW)
          DO 2 J=2,8
          JR = 9-J
          F = F*X+B(JR,IA,JBEW)
    2     CONTINUE
        A(IA) = F
    1   CONTINUE
C---- FUNCTN=A(1)+CC(COST)*EXP(0.55*Z)+A(2)*Z
C
33    CC = ((0.8751*COST-0.8362)*COST+0.3924)*COST-2.0
      CC = 10.**CC
      IF(JBEW.EQ.2) CC = 1.5*CC
      IF(JBEW.EQ.1.AND.COST.LT.-.35) CC = 0.
      EXPARG = EXP(0.55*Z)
      PENUM = A(1)+CC*EXPARG+A(2)*Z
      RETURN
C
      DATA MESS/0/
   90 IF(MESS.EQ.0) WRITE(6,600) JBE,Z,COST
  600 FORMAT(' ***** WRONG INPUT FOR NPECER *****',I6,2E12.3)
      MESS = 1
      RETURN
      END

C   09/10/85            MEMBER NAME  MUANAC   (JADEMUS)     FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MUANAC
C-----------------------------------------------------------------------
C
C LAST CHANGE 15.40  8/10/85 CHRIS BOWDERY - EXPAND HC AND HLUN ARRAYS
C      CHANGE 23.30 29/09/84 CHRIS BOWDERY - CALIBRATION CHECKING CODE
C      CHANGE 12.00  9/03/84 CHRIS BOWDERY - NEW MUCOOR DATE.
C      CHANGE 10.00 13/01/84 CHRIS BOWDERY - NEW MUCOOR DATE.
C      CHANGE 12.00 25/10/83 HUGH MCCANN   - NEW MUCOOR DATE.
C      CHANGE 11.00 16/03/83 HUGH MCCANN   - NEW MUCOOR DATE.
C
C-----------------------------------------------------------------------
C
C        THIS IS THE  FIRST  ROUTINE  OF  THE  MUON  ANALYSIS  CHAIN.IT
C        CONVERTS THE THE MUON RAW DATA (IBM FORMAT) TO COORDINATES AND
C        STORES THEM, AND OTHER INFORMATION, IN 'MUR1' BANKS 0,1,AND 2.
C        (FOR DESCRIPTION OF BANKS SEE @MUINFOM).
C
C        NOTE BANK 0 IS CREATED EVEN IF THERE ARE NO MUON HITS.
C
C        THERE ARE 2 SIGNAL TO COORDINATE CONVERSION ROUTINES...
C
C    1)  MUTINY, WHICH USES  A  CONDENSED  SET  OF  CALIBRATION  DATA
C        PREPARED BY MUCONT (FOR MONTE  CARLO  OUTPUT  -  SEE  MCJADE),
C        WHICH CALLS A VERSION OF MUDOWN.
C
C    2)  MUCOOR, WHICH USES THE FULL MUON CALIBRATION DATA PREPARED BY
C        MUCON (FOR MONTE CARLO OUTPUT - SEE MCJADE).
C
C HMU IS THE RAW MU DATA.
C LMU IS THE LENGTH OF THE RAW DATA BANK MEASURED IN I*4 WORDS.
C
C HC IS THE MU COORDINATE OUTPUT ARRAY IN 9'S.....
C               WORD  1     -  4*CHAMBER NUMBER + (HIT NUMBER -1).
C               WORD  2     -  10*LAYER NUMBER + ORIENTATION PARAMETER.
C               WORDS 3 - 8 -  X,Y,Z(LEFT),X,Y,Z(RIGHT) (MM).
C               WORD  9     -  POINTER TO RAW DATA
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C                            COMMONS.
C
C----------START OF MACRO CMUBCS----------------------------------------
      COMMON /BCS/IDATA(1)
      DIMENSION HDATA(1),ADATA(1)
      EQUIVALENCE (HDATA(1),ADATA(1),IDATA(1))
C----------END OF MACRO CMUBCS------------------------------------------
C
C
C
C
C
C=======================<< MACRO CMUCALIB >>============================
C
C LAST CHANGE  25/09/79  13.20 UHR   HARRISON PROSPER
C
C BANK NAMES, NUMBERS AND LENGTHS
C
C  NAME/NUMBER LENGTH  CONTENTS
C  MUCD   0      16    VERSION NUMBER AND DESCRIPTION.
C  MUOV   0       3    OVERALL JADE UNIT TRANSLATIONS.
C  MFFI   2     370    FIXED FRAME PARAMETERS.
C  MCFI   3     318    FIXED CHAMBER PARAMETERS.
C  MFSU   4     246    'SURVEY' FRAME PARAMETERS.
C  MCSU   5     634    'SURVEY' CHAMBER PARAMETERS.
C  MCEL   6    2220    'ELECTRONIC' CHAMBER PARAMETERS.
C  MCST   7     317    CHAMBER STATUS WORDS.
C  MUFI   8      36    FILTER (ABSORBER BLOCK) PARAMETERS.
C  MUYO   9      10    SIDE, TOP AND BOTTOM YOKE PARAMETERS.
C  MUEN  10      15    YOKE END-PLUG PARAMETERS.
C
C TOTAL LENGTH 4185 WORDS.
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
      COMMON /CALIBR/ LARRY(100),MUCAL(4185)
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C
C               NVERSN
      DIMENSION DESCRP(15),HOVALL(6)
C                                                    19 WORDS
C
      EQUIVALENCE ( NVERSN,MUCAL(1) ),( DESCRP(1),MUCAL(2) ),
     *            ( HOVALL(1),MUCAL(17) )
C----------------------------------------------------19 WORDS SO FAR
C
C     HMFFIX(740)                                   370 WORDS
      DIMENSION HMFFIX(740)
      EQUIVALENCE ( HMFFIX(1),MUCAL(20) )
      DIMENSION HFACE(82),HSECT(82),HLAYER(82),HNORM(82),HLONG(82),
     *          HTRANS(82),HAC(82),HAL(82),HUNIT(82)
      EQUIVALENCE (HMFFIX(1),NFRAMS),(HMFFIX(3),HFACE(1)),
     *            (HMFFIX(85),HSECT(1)),(HMFFIX(167),HLAYER(1)),
     *            (HMFFIX(249),HNORM(1)),(HMFFIX(331),HLONG(1)),
     *            (HMFFIX(413),HTRANS(1)),(HMFFIX(495),HAC(1)),
     *            (HMFFIX(577),HAL(1)),(HMFFIX(659),HUNIT(1))
C---------------------------------------------------389 WORDS SO FAR
C
C
C     HMCFIX(636)                                   318 WORDS
      DIMENSION HMCFIX(636)
      EQUIVALENCE ( HMCFIX(1),MUCAL(390) )
      DIMENSION HFR(634)
      EQUIVALENCE (HMCFIX(1),NCHAMS),(HMCFIX(3),HFR(1))
C---------------------------------------------------707 WORDS SO FAR
C
C     HMFSUR(492)                                   246 WORDS
      DIMENSION HMFSUR(492)
      EQUIVALENCE ( HMFSUR(1),MUCAL(708) )
      DIMENSION HDIST(82),HANG(82),HCLLO(82),HCLHI(82),HCTLO(82),
     *          HCTHI(82)
      EQUIVALENCE (HMFSUR(1),HDIST(1)),(HMFSUR(83),HANG(1)),
     *            (HMFSUR(165),HCLLO(1)),(HMFSUR(247),HCLHI(1)),
     *            (HMFSUR(329),HCTLO(1)),(HMFSUR(411),HCTHI(1))
C---------------------------------------------------953 WORDS SO FAR
C
C
C     HMCSUR(1268)                                  634 WORDS
      DIMENSION HMCSUR(1268)
      EQUIVALENCE ( HMCSUR(1),MUCAL(954) )
      DIMENSION HD1(634),HCTW(634)
      EQUIVALENCE (HMCSUR(1),HCTW(1)),(HMCSUR(635),HD1(1))
C--------------------------------------------------1587 WORDS SO FAR
C
C
C     HMCELE(4440)                                 2220 WORDS
      DIMENSION HMCELE(4440)
      EQUIVALENCE ( HMCELE(1),MUCAL(1588) )
      DIMENSION HDTP(634),HLTP(634),HLSF(4,634),HVDRFT(634)
      EQUIVALENCE (HMCELE(1),HVDR),(HMCELE(2),HDTP(1)),
     *            (HMCELE(636),HLTP(1)),(HMCELE(1270),HLSF(1,1)),
     *            (HMCELE(3806),HMCEDM),(HMCELE(3807),HVDRFT(1))
C--------------------------------------------------3807 WORDS SO FAR
C
C
C     HMCSTA(634)                                   317 WORDS
      DIMENSION HMCSTA(634)
      EQUIVALENCE ( HMCSTA(1),MUCAL(3808) )
C--------------------------------------------------4124 WORDS SO FAR
C
C
C     HFILDA(72)                                     36 WORDS
      DIMENSION HFILDA(72)
      EQUIVALENCE ( HFILDA(1),MUCAL(4125) )
      INTEGER*2 HBLLO(6),HBLHI(6),HBTLO(6),HBTHI(6),HBNLIM(36)
      INTEGER*4 IFCIND(6)
      INTEGER*2 HFILDA
      EQUIVALENCE (HBLLO(1),HFILDA(1)),(HBLHI(1),HFILDA(7)),
     *            (HBTLO(1),HFILDA(13)),(HBTHI(1),HFILDA(19)),
     *            (HBNLIM(1),HFILDA(25)),(IFCIND(1),HFILDA(61))
C--------------------------------------------------4160 WORDS SO FAR
C
C
C     HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4),BYOKE, 10 WORDS
C     IYKIND
      DIMENSION HYKNMI(4),HYKNMO(4),HYKLDM(4),HYKTDM(4)
      INTEGER*2 HYKTDM,HYKLDM,HYKNMI,HYKNMO
      EQUIVALENCE ( HYKNMI(1),MUCAL(4161) ),
     *            ( HYKNMO(1),MUCAL(4163) ),
     *            ( HYKLDM(1),MUCAL(4165) ),
     *            ( HYKTDM(1),MUCAL(4167) ),
     *            ( BYOKE,MUCAL(4169) ),( IYKIND,MUCAL(4170) )
C--------------------------------------------------4170 WORDS SO FAR
C
C
C    IZEII,IZEIO,IREP1,IREP2,IREP3,IREP4,IXYEP5,     15 WORDS
C    IZOEP1,IZOEP2,IZOEP3,IZOEP4,IZOEP5,CAEP2,
C    IEPIND,IEPSCT
C
      EQUIVALENCE ( IZEII,MUCAL(4171) ),( IZEIO,MUCAL(4172) ),
     *            ( IREP1,MUCAL(4173) ),( IREP2,MUCAL(4174) ),
     *            ( IREP3,MUCAL(4175) ),( IREP4,MUCAL(4176) ),
     *            ( IXYEP5,MUCAL(4177) ),( IZOEP1,MUCAL(4178) ),
     *            ( IZOEP2,MUCAL(4179) ),( IZOEP3,MUCAL(4180) ),
     *            ( IZOEP4,MUCAL(4181) ),( IZOEP5,MUCAL(4182) ),
     *            ( CAEP2,MUCAL(4183) ),( IEPIND,MUCAL(4184) ),
     *            ( IEPSCT,MUCAL(4185) )
C--------------------------------------------------4185 WORDS SO FAR
C
C=======================<< MACRO CMUCALIB >>============================
C
C
C
C
C
C
      COMMON /CWORK/ HC(3600),HLUN(400)
C
C                            DATA INITIALISATION STATEMENTS.
C
C                            NWHIT IS NO. OF WORDS PER HIT
      DATA NWHIT/9/
C
C                            NHITMX  IS  THE  MAXIMUM   NO.   OF   HITS
C                            CONVERTED.
      DATA NHITMX/400/
C
C------------------  C O D E  ------------------------------------------
C
C                            FIND MUON DATA BANK POINTER.
C
      IPMU = IDATA(IBLN('MUEV'))
      IF( IPMU .NE. 0 ) GO TO 1
C
C                            NO MUON BANK PRESENT.
      NHITS = 0
      GO TO 2
C
C                            CHECK THE CALIBRATION TO SEE IF MISSING
C                            IF 2 CONSTANTS ARE ZERO, THEN NO CALIB.
C
  1   IF( IZOEP1 .EQ. 0  .AND.  IZOEP3 .EQ. 0 ) GO TO 95
C
C
C                            CALL MUCOOR TO GET COORDINATES, ETC.
C
      CALL MUCOOR(IDATA(IPMU+1),NHITS,HC(1),NHITMX,IDATA(IPMU),HLUN(1),
     +            NWHIT)
C-----------------------------------------------------------------------
C
C                            CREATE 'MUR1' BANK 0 - MUON GENERAL INFO
C
 2    CONTINUE
C                            ADD  'MUR1'  TO  SPECIAL  LIST  READY  FOR
C                            WRITING.
      CALL BSAW(1,'MUR1')
      IBANK=0
      CALL CCRE(IP0,'MUR1',IBANK,9,IER)
      IF(IER.NE.0)GO TO 96
C                            NO. OF HITS.
      IDATA(IP0+1) = NHITS
C                            NO. OF I*2 WORDS  PER  HIT  IN  COORDINATE
C                            BANK.
      IDATA(IP0+3) = NWHIT
C                            DATE OF VERSION OF MUCOOR  WHICH  PRODUCES
C                            COORDINATES.
      IDATA(IP0+8) = 840929
C                            CALIBRATION DATA ISSUE.
      IDATA(IP0+9) = NVERSN
C
C-----------------------------------------------------------------------
C
C                            CREATE 'MUR1' BANK  1  -  MUON  COORDINATES
C
      IF(NHITS.LE.0)GO TO 98
      LB1=(NWHIT*NHITS+1)/2
      IBANK=1
      CALL CCRE(IP1,'MUR1',IBANK,LB1,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(HC(1),IDATA(IP1+1),LB1)
C
C
C-----------------------------------------------------------------------
C
C                            CREATE 'MUR1' BANK 2 - HIT STATUS BANK.
C
      IF(NHITS.LE.0) RETURN
      LB2=(NHITS+1)/2
      IBANK=2
      CALL CCRE(IP2,'MUR1',IBANK,LB2,IER)
      IF(IER.NE.0)GO TO 96
      CALL UCOPY(HLUN(1),IDATA(IP2+1),LB2)
C
      RETURN
C
C-----------------------------------------------------------------------
C
C                            ERROR CONDITIONS.
C
 95   CALL MUERRY('MUANAC',0,'WARNING: NO CALIBRATION FOUND. IF MC DATA,
     + WAS EVREAD USED TO PROCESS CALIB. RECORDS? MUCOOR NOT CALLED.^')
      RETURN
C
 96   IF( IER .GT. 1 ) GO TO 97
      CALL MUERRY('MUANAC',IBANK,'''MUR1'' ALREADY PRESENT.^')
      RETURN
C
 97   CALL MUERRY('MUANAC',IBANK,'NOT ENOUGH SPACE FOR ''MUR1''.^')
      RETURN
C
 98   IF( IPMU .NE. 0 ) RETURN
      CALL MUERRY('MUANAC',0,' WARNING: MUEV BANK NOT LOCATED.^')
      RETURN
C
      END

C   21/11/78 C9071801   MEMBER NAME  ZBOS00   (S)           FORTRAN
      SUBROUTINE BSCOM
C
C               BBBBBB      OOOOO      SSSSS
C               B     B    O     O    S     S
C               B     B    O     O    S
C               BBBBBB     O     O     SSSSS
C               B     B    O     O          S
C               B     B    O     O    S     S
C               BBBBBB      OOOOO      SSSSS
C
C               ======== M A N U A L ========
C
C
C     -----------------------------------------------------
C     BANK ORGANISATION SYSTEM                      - BOS -
C     -----------------------------------------------------
C           DYNAMIC STORAGE ORGANISATION WITH FORTRAN
C                        1979 VERSION
C
C
C
C
C     AUTHOR  -  V.BLOBEL
C                II.INSTITUT FUER EXP.PHYSIK
C                UNIVERSITY OF HAMBURG   AND   DESY
C
C
C
C
C             ABSTRACT
C             ========
C             THE BOS SYSTEM AND ITS SUBSYSTEM SBOS
C             ALLOW THE EFFICIENT MANAGEMENT OF DATA
C             ARRAYS IN MEMORY AND ON MASS STORAGE
C             DEVICES. THE SYSTEMS ARE DEVELOPPED
C             ESPECIALLY FOR THE USE IN THE ANALYSIS
C             OF HIGH ENERGY PHYSICS EXPERIMENTS.
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C         TABLE OF CONTENT                             PAGE
C     -----------------------------------------------------
C
C
C
C     1.  INTRODUCTION                                    4
C
C     2.  CREATION OF BANKS                               9
C         2.1 CREATION OF A BANK
C         2.2 CHANGING THE LENGTH OF A BANK
C         2.3 STORAGE OF DATA IN A BANK
C         2.4 RENAMING A BANK
C         2.5 CALL OF THE PREVIOUS VERSION
C
C     3.  LOCATING OF BANKS                              12
C         3.1 LOCATING A BANK
C         3.2 LOCATING ALL BANKS OF THE SAME NAME
C         3.3 FASTER METHODS
C
C     4.  SETS OF BANKS                                  14
C         4.1 THE CURRENT LIST
C         4.2 THE SPECIAL LIST
C
C     5.  PRINTOUT OF BANKS                              18
C         5.1 SINGLE BANKS
C         5.2 SETS OF BANKS
C
C     6.  DELETING BANKS AND GARBAGE COLLECTION          18
C         6.1 SINGLE BANKS
C         6.2 SETS OF BANKS
C         6.3 GARBAGE COLLECTION
C
C     7.  INPUT FROM CARDS                               19
C         7.1 FREE FORMAT
C         7.2 FORMATED
C         7.3 SPECIAL CARDS
C         7.4 EXAMPLE
C
C     8.  UNFORMATED INPUT/OUTPUT OF BANKS               21
C         8.1 STANDARD OUTPUT AND INPUT
C         8.2 OUTPUT MODES AND RECORD TYPES
C         8.3 USER WRITE AND READ STATEMENTS
C         8.4 BUFFER BANKS
C         8.5 STANDARD EVENT READING/WRITING
C
C
C
C
C
C     9.  BANKS ON DIRECT ACCESS DATA SETS               27
C         9.1 INITIALIZATION OF A DADS
C         9.2 STORING AND RETRIEVING BANKS
C         9.3 UNLOADING AND LOADING THE DADS
C         9.4 PROTECTED DADS
C
C     10. PRINTING STATISTIC AND A DUMP                  30
C
C
C     APPENDIX A - THE SBOS SYSTEM                       34
C
C
C         A.1  INITIALIZATION
C         A.2  FUNCTION ILOC
C         A.3  FUNCTION IBLN
C         A.4  SUBROUTINE BMLT
C         A.5  SUBROUTINE BLST
C         A.6  SUBROUTINE BDLM
C         A.7  SUBROUTINE BGAR
C         A.8  SUBROUTINE BSIN
C         A.9  SUBROUTINE BSOUT
C
C
C     APPENDIX B - APPLICATION PROGRAMS                  40
C
C
C         B.1  PRINTOUT AND COMMENTS
C         B.2  COUNT IN A 32768 * 32768 ARRAY
C         B.3  COUNT IN A 256 * 16 ARRAY
C         B.4  HISTOGRAM
C         B.5  CORRELATION PLOT
C         B.6  STORE VECTORS
C         B.7  DETERMINE MEAN VALUES
C         B.8  DETERMINE PEAK VALUES
C         B.9  STORE SINGLE VALUES
C         B.10 BIN DEFINITION
C         B.11 INTERPOLATION OF TABULATED DATA
C         B.12 DETERMINATION OF A LINEAR DEPENDENCE
C         B.13 DETERMINATION OF AN EMPIRICAL FUNCTION
C
C
C
C
C
C
C
C
C
C
C
C
C
C
      RETURN
      END

C   03/03/89 903031439  MEMBER NAME  GEANTDUM (S)        M  FORTRAN
      SUBROUTINE GEANTI
C
C  dummy routine to be used with JADE MC program, linking without geant
C
      WRITE(6,200)
200   FORMAT(' Warning:  dummy geant used')
      RETURN
      END
      SUBROUTINE TGEANT(P1,X1)
C
C  dummy routine to be used with JADE MC program, linking without geant
C
      RETURN
      END

C   07/06/96 606071823  MEMBER NAME  BLST     (S4)          FORTG1
      SUBROUTINE BLST(NL,LIST,MK)
C     BOS SUBPROGRAM =0.5=
#include "acs.for"
      COMMON/BCS/IW(1)
C
      INTEGER LIST(1)
C
      IF(MK.LT.0) GOTO 40
      IF(MK.GE.1) GOTO 20
C     STORE NAMES OF CURRENT LIST IN ARGUMENT LIST
      NL=0
      IF(IN.LE.0) GOTO 100
      DO 10 I=1,IN
      IF(NL.GE.MK) GOTO 100
      NL=NL+1
      J=IW(NLST+I)
   10 LIST(NL)=IW(INAMV+J)
      GOTO 100
C     ADD NAMES OF ARGUMENT LIST INTO SPECIAL LIST
   20 IF(NL.LE.0) GOTO 100
      MARK=0
      IF(MK.EQ.1) MARK=1
      DO 30 LN=1,NL
      IB=IBLN(LIST(LN))
      IF(NS.EQ.0) GOTO 26
      DO 24 I=1,NS
      IF(IB.EQ.IW(ISLST+I)) GOTO 28
   24 CONTINUE
      IF(NS.GE.NLIST) CALL BDMPA(30)
   26 NS=NS+1
      I =NS
      IW(ISLST+I)=IB
   28 IW(IMLST+I)=MARK
   30 CONTINUE
      GOTO 100
C
C
   40 IF(NL.GT.0) GOTO 50
C     CLEAR SPECIAL LIST
      NS=0
      GOTO 100
C     DELETE NAMES FROM THE SPECIAL LIST
   50 DO 60 LN=1,NL
      IB=IBLN(LIST(LN))
      IF(NS.EQ.0) GOTO 100
      DO 52 I=1,NS
      IF(IB.EQ.IW(ISLST+I)) GOTO 54
   52 CONTINUE
      GOTO 60
   54 IS=I+1
      IF(IS.GT.NS) GOTO 58
      DO 56 I=IS,NS
      IW(ISLST+I-1)=IW(ISLST+I)
   56 IW(IMLST+I-1)=IW(IMLST+I)
   58 NS=NS-1
   60 CONTINUE
C
  100 RETURN
      END

C   12/03/79 007281422  MEMBER NAME  DDATA    (S)           FORTRAN
C
      COMMON /BCS/ IDATA(10000)
      DIMENSION DATA(10000)
      INTEGER *2 HDATA(20000)
      EQUIVALENCE (IDATA(1),DATA(1)), (HDATA(1),IDATA(1))
C

C   05/03/80 003210625  MEMBER NAME  MOCARD   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE MOCARD(INLA,INTF,IFLG,*)
C  SPECIAL VERSION OF TOFARD TO READ MONTE CARLO DATA
C          CONVERTS THE TOF DATA FROM CAMAC FORMAT
C       TO ANALYSIS FORMAT :
C                   IRAW(1,NCN)= NCN  ; COUNTER#
C      RAW(2,NCN)= TDC(-)-CM(NCN)-WM(NCN)*(1./SQRT(A0M)-1./SQRT(ADC(-)))
C      RAW(3,NCN)= TDC(+)-CP(NCN)-WP(NCN)*(1./SQRT(A0M)-1./SQRT(ADC(+)))
C       OR
C      RAW(2,NCN)= TDC(-) , IF IFLG= 1.
C      RAW(3,NCN)= TDC(+) , IF IFLG= 1.
C                   RAW(4,NCN) = ADC(-)
C                   RAW(5,NCN) = ADC(+)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
#include "ddata.for"
      INTEGER *2  HADC,HTDC,HB,HBLK,HSTAR,HPEK,HNG
       REAL *8 DYC1,DYC2
       COMMON/TFPRM/ NRNC1,NRNC2,DYC1,DYC2,IFLC(42),CM(42),CP(42),
     -DTAU(42),WM(42),WP(42),SV(42),DM(42),DP(42),PEDLM(42),PEDLP(42)
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
      COMMON/TFPED/ HADC(2,42),HTDC(2,42),HB(42)
      DIMENSION MASK(16)
      DATA MASK/1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,
     1          16384,32768/
      DIMENSION CORADC(20)
      DIMENSION IX(7),IRAW(5,42),RX(210)
      EQUIVALENCE (IRAW(1,1),RAW(1,1)),(RX(1),RAW(1,1))
      DATA HBLK,HSTAR,HPEK,HNG/ '  ','**','XX','NG'/
      DATA A0M/ 200./,A0P/200./
      DATA CORADC/1.9,2.45,2.8,3.0,3.15,3.3,3.35,3.45,3.5,3.55,3.55,
     1            3.6,8*3.6/
      DATA IENTRY/0/,LERR/0/,IBUG/70/,JBUG/10/
      IF(IENTRY.NE.0)  GOTO 320
      IENTRY = IENTRY + 1
  101 FORMAT(/4(1X,10F12.3/),1X,2F12.3)
C
 320  DO 10 I=1,210
10    RX(I)= 0.
C
C========= ADDRESSING
C
      IBUG = IBUG + 1
      JBUG = JBUG + 1
       IER= 0
       INLA2= INLA*2
       INTF2= INTF*2
       IL0= INLA2+6
       IA0= INTF2+3
       IT0= INTF2+94
C//////////
C
        NUM= 0
        DO 3000 NCN= 1,42
C
C========= ADDRESS OF ADC AND TDC FOR COUNTER# NCN
C
        NCN2= NCN*2
        IAA= (NCN-1)/6+NCN2+IA0-2
        IAT= (NCN-1)/4+NCN2+IT0-2
        IAA1= IAA+1
        IAT1= IAT+1
        HADC(1,NCN)= HDATA(IAA)
        HADC(2,NCN)= HDATA(IAA1)
      IF(NRUN.LE.2306.OR.NCN.LE.38)  GOTO  75
      ADCM = HADC(1,NCN) - PEDLM(NCN)
      ADCP = HADC(2,NCN) - PEDLP(NCN)
      HADC(1,NCN) = ADCM*2+PEDLM(NCN)
      HADC(2,NCN) = ADCP*2+PEDLP(NCN)
   75 HTDC(1,NCN)= HDATA(IAT)
      HTDC(2,NCN)= HDATA(IAT1)
      HB(NCN)= HBLK
C
C========= CHECK OF LATCHED BIT
C
        NW= (NCN-1)/7+IL0
        MDATA= HDATA(NW)
        IF(MDATA) 100,3000, 100
 100    NORD= MOD(NCN,7)
      IF(NORD.EQ.0) NORD = 7
        IF(LAND(MDATA,MASK(NORD)).GT.0)  GOTO  1500
      GOTO  3000
C
C========= BIT HAD BEEN SET
C
 1500 CONTINUE
C-------- PULSE HEIGHT CORRECTION
      ADCM = HADC(1,NCN)
      ADCP = HADC(2,NCN)
      IF(ADCM.LE.0.) ADCM = 1.
      IF(ADCP.LE.0.) ADCP = 1.
        TCM= WM(NCN)*(1./SQRT(A0M)-1./SQRT(ADCM))
        TCP= WP(NCN)*(1./SQRT(A0P)-1./SQRT(ADCP))
        ADCM= HDATA(IAA)
        TDCM= HDATA(IAT)
      IF(TDCM.LT.10..OR.TDCM.GT.2048.)  GOTO  2000
        TDCM0= TDCM
        IF(IFLG.EQ.1) GO TO 1600
 1510   TDCM0= TDCM0*DM(NCN)
        TDCM0= TDCM0-CM(NCN)-TCM
 1600   IRAW(1,NCN)= NCN
        RAW(2,NCN)= TDCM0
        RAW(4,NCN)= ADCM
 2000   IAA1= IAA+1
        IAT1= IAT+1
        ADCP= HDATA(IAA1)
        TDCP= HDATA(IAT1)
      IF(TDCP.LT.10.OR.TDCP.GT.2048.)  GOTO  2100
        TDCP0= TDCP
        IF(IFLG.EQ.1) GO TO 2050
2010    TDCP0= TDCP0*DP(NCN)
        TDCP0= TDCP0-CP(NCN)-TCP
2050    IRAW(1,NCN)= NCN
        RAW(3,NCN)= TDCP0
        RAW(5,NCN)= ADCP
2100    CONTINUE
C/////////
 3000    CONTINUE
C/////////
       RETURN
 4000  CONTINUE
C/////////
  994 LERR = LERR + 1
      IF(LERR.GT.20) RETURN
 9440 FORMAT(' ERROR IN COMPUTING INDEX FOR ADC CORRECTION '/
     1       1X,2I5,4F10.4)
      RETURN
       END

      SUBROUTINE INPATC
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cdsmax.for"
#include "cjdrch.for"
      DATA HHHRUN /-1/
      IPHE = IDATA(IBLN('HEAD'))
      HHRUN = HDATA(2*IPHE+10)
      IF(HHRUN.EQ.HHHRUN) RETURN
      HHHRUN = HHRUN
      DFI0 = 3.1415927 / 12.
      DFI1 = 3.1415927 / 24.
      DFI3 = 3.1415927 / 48.
      FI = DFI1
      DO 13000 I=1,6
        DX = COS(FI)
        DY = SIN(FI)
        DIRWR1(I   ,1) = DX
        DIRWR1(I   ,2) = DY
        DIRWR1(I+ 6,1) =-DY
        DIRWR1(I+ 6,2) = DX
        DIRWR1(I+12,1) =-DX
        DIRWR1(I+12,2) =-DY
        DIRWR1(I+18,1) = DY
        DIRWR1(I+18,2) =-DX
        FI = FI + DFI0
13000 CONTINUE
13001 CONTINUE
      FI = DFI3
      DO 13002 I=1,12
        DX = COS(FI)
        DY = SIN(FI)
        DIRWR3(I   ,1) = DX
        DIRWR3(I   ,2) = DY
        DIRWR3(I+12,1) =-DY
        DIRWR3(I+12,2) = DX
        DIRWR3(I+24,1) =-DX
        DIRWR3(I+24,2) =-DY
        DIRWR3(I+36,1) = DY
        DIRWR3(I+36,2) =-DX
        FI = FI + DFI1
13002 CONTINUE
13003 CONTINUE
      DO 13004 I=1,96
      K = I
      IF(K.GT.24) K=K-24
      IF(
     - I.LE.48
     -)THEN
      DX=DIRWR1(K,1)
      DY=DIRWR1(K,2)
      ELSE
      DX=DIRWR3(K-24,1)
      DY=DIRWR3(K-24,2)
      ENDIF
        TRMATS(I,1) = -( DY * COSDRI(I,1) + DX * SINDRI(I,1) )
        TRMATS(I,2) = -( DY * COSDRI(I,2) + DX * SINDRI(I,2) )
        TRMATC(I,1) =  ( DX * COSDRI(I,1) - DY * SINDRI(I,1) )
        TRMATC(I,2) =  ( DX * COSDRI(I,2) - DY * SINDRI(I,2) )
13004 CONTINUE
13005 CONTINUE
      FACTL1 = SIN(DFI1) / COS(DFI1+DRIDEV)
      FACTR1 = SIN(DFI1) / COS(DFI1-DRIDEV)
      FACTL3 = SIN(DFI3) / COS(DFI3+DRIDEV)
      FACTR3 = SIN(DFI3) / COS(DFI3-DRIDEV)
      R1 = FSENSW(1)
      R2 = FSENSW(2)
      R3 = FSENSW(3)
      DO 13006 ILAY=1,16
        DSMAX(ILAY,1,1) = R1 * FACTL1
        DSMAX(ILAY,2,1) = R2 * FACTL1
        DSMAX(ILAY,3,1) = R3 * FACTL3
        DSMAX(ILAY,1,2) = R1 * FACTR1
        DSMAX(ILAY,2,2) = R2 * FACTR1
        DSMAX(ILAY,3,2) = R3 * FACTR3
        R1 = R1 + RINCR(1)
        R2 = R2 + RINCR(2)
        R3 = R3 + RINCR(3)
13006 CONTINUE
13007 CONTINUE
      CALL INBACK
      RETURN
      END
      SUBROUTINE INBACK
      IMPLICIT INTEGER*2 (H)
#include "cdsmax.for"
#include "cjdrch.for"
       DIMENSION LFTCL(3),LSTCL(3),NCELL(3),TANDEL(3)
       EQUIVALENCE (IBCK(1),LSTCL(1)),(IBCK(4),LFTCL(1))
       EQUIVALENCE (IBCK(7),NCELL(1)),(DBCK(1),TANDEL(1))
      DIMENSION GB(3)
      DATA GB/376.,586.,797./
      NCELL(1)=24
      NCELL(2)=24
      NCELL(3)=48
      LSTCL(1)=24
      LSTCL(2)=48
      LSTCL(3)=96
      LFTCL(1)=1
      LFTCL(2)=25
      LFTCL(3)=49
      DEL=3.141593/48.
      DBCK(4)=COS(DEL-DRIDEV)
      DBCK(5)=COS(DEL+DRIDEV)
      DBCK(6)=TAN(DEL)
      DBCK(7)=TAN(DEL+3.141593/24.)
      DBCK(8)=SIN(DEL)
      DBCK(9)=-DBCK(8)
      DEL=DEL+3.141593/24.
      DBCK(10)=COS(DEL-DRIDEV)
      DBCK(11)=COS(DEL+DRIDEV)
      DBCK(12)=SIN(DEL)
      DBCK(13)=-DBCK(12)
      DEL=6.283185/24.
      DBCK(14)=COS(DEL-DRIDEV)
      DBCK(15)=COS(DEL+DRIDEV)
      DBCK(16)=SIN(DEL)
      DBCK(17)=-DBCK(16)
      DEL=DEL+3.141593/48.
      DBCK(18)=COS(DEL-DRIDEV)
      DBCK(19)=COS(DEL+DRIDEV)
      DBCK(20)=SIN(DEL)
      DBCK(21)=-DBCK(20)
      DBCK(22)=TAN(3.141593/12.+3.141593/48.)
      DO 13000 KRING=1,3
      DEL=3.141593/NCELL(KRING)
      TANDEL(KRING)=TAN(DEL*2.)
      DO 13002 IW=1,16
      DSMX=DSMAX(IW,KRING,1)
      IF(KRING.EQ.3) DSMSP=DSMAX(IW,2,1)
      ALSIN=-DRISIN
      AL=-DRIDEV
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      HMCH(IW,KRING,1)=IK
      DHALF(IW,KRING,1)=DT
      DTWICE(IW,KRING,1)=DTW
      DSMX=DSMAX(IW,KRING,2)
      IF(KRING.EQ.3) DSMSP=DSMAX(IW,2,2)
      ALSIN=DRISIN
      AL=DRIDEV
      ASSIGN 17002 TO IZZZ01
      GOTO 17000
17002 CONTINUE
      HMCH(IW,KRING,2)=IK
      DHALF(IW,KRING,2)=DT
      DTWICE(IW,KRING,2)=DTW
13002 CONTINUE
13003 CONTINUE
13000 CONTINUE
13001 CONTINUE
      RETURN
17000 CONTINUE
      W=FSENSW(KRING)+FLOAT(IW-1)*RINCR(KRING)
      X=SQRT(W**2+DSMX**2-2.*W*DSMX*ALSIN)
      DTW=1.-TAN(DEL)*TAN(DEL-AL)
      DTW=2.*DSMX/DTW
      IF(
     - KRING.EQ.2
     -)THEN
      DTW=1.-TAN(DEL*.5)*TAN(DEL-AL)
      DTW=DSMX*(1.+TAN(DEL*.5)/TAN(DEL))/DTW
      ENDIF
      IF(
     - KRING.EQ.3
     -)THEN
      DTW=1.-TAN(DEL*1.5)*TAN(DEL-AL)
      DTW=DSMSP*(1.+TAN(DEL*1.5)/TAN(DEL))/DTW
      ENDIF
      DT=TAN(DEL*0.5)*TAN(DEL*0.5-AL)
      DT=DSMX*0.5*(1.-DT)
      IF(
     - X.LT.GB(KRING)
     -)THEN
      IK=-5
      E=X*COS(AL+DEL)/DRICOS
      E=E-FSENSW(KRING)
      IF(E.GE.-5.) IK=(E+5.)/RINCR(KRING)
      IF(IK.GT.15) IK=20
      ELSE
      IK=20
      ENDIF
      GOTO IZZZ01
      END

C   25/07/79 C9073101   MEMBER NAME  LGBFIL   (SOURCE)      FORTRAN
      SUBROUTINE LGBFIL(II,J1,J2,*)
C     CODED BY Y.WATANABE ON 29/7/79, 02:00
      IMPLICIT INTEGER *2 (H)
#include "clgwork2.for"
      IX=II
      IF(IX.LT.0) IX=IX+84
      IF(IX.LT.0) RETURN
      IX=MOD(IX,84)
      IX=IX*32
      JX=J1-1
10    JX=JX+1
      IF(JX.GT.J2) GO TO 20
      NPOINT=NPOINT+1
      IF(NPOINT.GE.NPMAX) RETURN1
      HCLADR(NPOINT)=JX+IX
C     WRITE(6,600) II,IX,JX,NPOINT
C600  FORMAT(' LGBFIL;',10I10)
      GO TO 10
20    RETURN
      END

C   12/07/79 005292257  MEMBER NAME  MCHIST   (S)           FORTRAN
      SUBROUTINE MCHIST
C-----------------------------------------------------------
C
C   VERSION OF 09/05/79  LAST MOD    29/05/80    E.ELSEN
C   COMPUTE SOME HISTOGRAMS FOR EVERY EVENT.
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1), RW(1), IW(1))
C
      DATA ICALL / 0 /
C
      IF( ICALL .NE. 0 ) GO TO 100
      ICALL = 1
      CALL THIST(  1,'# OF NEUTRAL PARTICLES (INPUT)$' )
      CALL DHIST(  1, 0., 100. )
      CALL THIST(  2,'# OF CHARGED PARTICLES (INPUT)$' )
      CALL DHIST(  2, 0., 100. )
      CALL THIST(  3,'# OF CHARGED PARTICLES (PATR)$' )
      CALL DHIST(  3, 0., 100. )
      CALL THIST(  4,'# OF I.D. HITS$' )
      CALL DHIST(  4, 0., 1500. )
      CALL THIST(  5,'LG TOT ENERGY$' )
      CALL DHIST(  5, 0., 50. )
      CALL THIST(  6,'LG END CAP ENERGY$' )
      CALL DHIST(  6, 0., 50. )
      CALL THIST(  7,'LG BARREL ENERGY$' )
      CALL DHIST(  7, 0., 50. )
      CALL THIST(  8,'SUM PTOT$' )
      CALL DHIST(  8, 0., 50. )
      CALL THIST(  9,'SUM PT$' )
      CALL DHIST(  9, 0., 50. )
C
C                                           # OF INPUT PARTICLES
  100 IND = IW( IBLN('VECT') )
      IF( IND .EQ. 0 ) GO TO 1000
      CALL UHIST( 1, FLOAT( IW( IND +  6  ) ) )
      CALL UHIST( 2, FLOAT( IW( IND +  5  ) ) )
C
C                                           # OF PATR TRACKS
 1000 IND = IW( IBLN('PATR') )
      IF( IND .EQ. 0 ) GO TO 2000
      CALL UHIST( 3, FLOAT( IW( IND + 2   ) ) )
C
      IPH = IW( IBLN( 'HEAD' ) )
      IF( IPH .EQ. 0 ) GO TO 2000
      BKGAUS = HW( IPH*2 + 30 ) * .001
      BKGAUS = ABS( BKGAUS )
      PT = 0.
      PTOT = 0.
      LP = IW( IND + 3 )
      IP0 = IND + IW( IND + 1 )
      IP9 = IP0 + ( IW(IND+2) - 1 ) * LP
      DO 1100 J = IP0, IP9, LP
      ACURV = ABS( RW(J+25) )
      PTRANS = .3E-4 * BKGAUS / AMAX1( ACURV, 1.E-6 )
      PT = PT + PTRANS
 1100 PTOT = PTOT + PTRANS * SQRT( 1. + RW(J+30)**2 )
      CALL UHIST( 8, PTOT )
      CALL UHIST( 9, PT )

C
C                                           # OF JETC HITS
 2000 IND = IW( IBLN('JETC') )
      IF( IND .EQ. 0 ) GO TO 3000
      NHITS = ( HW(IND*2+99) - HW(IND*2+3) ) / 4
      CALL UHIST( 4, FLOAT( NHITS ) )
C
C                                           # LG ENERGY
 3000 IND = IW( IBLN('ALGN') )
      IF( IND .EQ. 0 ) GO TO 4000
      ETOT = 0.
      ECAP = 0.
C
      IL = IND*2 + 6
      IH = IL + HW(IL) - 3
      IEC = IL + HW(IND*2+4) - 3
C
      DO 3010 I = IL,IH, 2
      IF( I .LE. IEC ) GO TO 3010
      ECAP = ECAP + HW(I+2)
 3010 ETOT = ETOT + HW(I+2)
      ECAP = ECAP * .001
      ETOT = ETOT * .001
C
      CALL UHIST(   5, ETOT )
      CALL UHIST(   6, ECAP )
      CALL UHIST(   7, ETOT - ECAP )
C
 4000 RETURN
      END

C   17/03/79 310171346  MEMBER NAME  EVT      (MTLINKS)     FORTRAN
C=======================================================================
C  #EVT1 IS FOR ONE NORD TAPE TO ONE EXTEST(+1) TAPE
C  #EVT2 IS FOR ONE NORD TAPE WITH SEVERAL EOFS
C  #EVT3 IS FOR SEVERAL NORD TAPES TO ONE M TAPE
C  #EVT4 IS FOR ONE NORD TAPE TO ONE SPECIFIC EXDATA TAPE
C  #EVT5 IS FOR ONE NORD TAPE TO ONE M TAPE
C=======================================================================
      IMPLICIT INTEGER*2 (H)
      COMMON/CDATA/LENG,ID1(2),ID(10000)
      INTEGER*2 IARR,IBUFF
      INTEGER*2 J,HB(20)
      INTEGER*4 BUFFL,DALEN,LUN
      COMMON/MNF/IRUN,IREC,NEV,ISTAT,IFLAG,NWPR,BUFFL,DALEN,
     C   IND,ISPEC,LUN
      COMMON/BUFFER/IBUFF(2048)
      DIMENSION IARR(20004)
      EQUIVALENCE(IARR(5),ID(1))
      REAL*8 DATE(2)
      DATA HB/1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20/
    1 FORMAT(' ',I5,21I6)
    2 FORMAT('0',I10,19I6)
    3 FORMAT(' RUN=',I5,3X,'NEV=',I5,3X,'ISTAT=',I5,3X,'IARR(1-6)=',7I8)
    4 FORMAT('0',' JOB DATE ',A8,' TIME ',A8)
      CALL DAY(DATE(1),DATE(2))
      WRITE(6,4) DATE
C
      CALL LISTRN(1)
C
      CALL RTA
      LUN=9
      BUFFL=4096
      IFLAG=1
      IARR(1)=20000
      IRUN=0
  100 CONTINUE
      IREC=0
      CALL EVTIN
      NEV=0
  200 CALL EVPK
  300 CONTINUE
      CALL RTE
      WRITE(6,2)
      WRITE(6,2)
      PRINT 3,IRUN,NEV,ISTAT,(IARR(I),I=1,6),IBUFF(5)
      WRITE(6,2)
      WRITE(6,2) HB
      WRITE(6,2)
      IJK=IARR(2)/20+1
      DO 400 I=1,IJK
      IJ=20*I
      IK=IJ-19
  400 WRITE(6,1) IK,(IARR(K),K=IK,IJ),IJ
C
      CALL LISTRN(3)
C
      STOP
      END

C   05/02/80 801211400  MEMBER NAME  DEDXBK   (JADEGS)      FORTRAN
      SUBROUTINE DEDXBK(NPPATR)
C*800213*OLSSON*****************************************************
C* LAST MOD 21/01/88   E ELSEN                                     *
C* C R E A T E  B A N K  DEDX  F R O M  D E D X A N  R E S U L T S *
C* STRAIGHT COPY OF COMMON CWORK1                                  *
C*******************************************************************
C             NPPATR IS POINTER TO 'PATR' ;  SAME BOSBANK NR IS USED
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CWORK1/ IER,NTR,TRES(10,60)
      DIMENSION ITRES(10,60)
      EQUIVALENCE (TRES(1,1),ITRES(1,1))
C
C
      IF(IER.NE.0 .OR.NTR.EQ.0) GO TO 100
        NTRR = MIN0(NTR,60)
C
        NRPATR = IDATA(NPPATR-2)
        NWRES = 2 + NTRR*10
        CALL CCRE(NPDEDX,'DEDX',NRPATR,NWRES,IERR)
        CALL BSAW(1,'DEDX')
        IF(IERR.NE.2) CALL UCOPY( IER, IDATA(NPDEDX+1), IDATA(NPDEDX) )
  100 RETURN
      END

C   08/12/80 304211227  MEMBER NAME  JETCAL   (JADEGS)      FORTRAN
C   19/08/80 009041235  MEMBER NAME  JETCAL9  (JADESR)      FORTRAN
      SUBROUTINE JETCAL
C---
C--- **************************************************************
C--- ******************* VERSION FOR NOZAKIS NEW JET CONSTANTS ****
C--- **************************************************************
C---     CREATES CALIBRATED JET CHAMBER BANK.
C---
C---                                    WEDNESDAY, MAY 23, 1979
C---                                    L.H. O'NEILL
C---
C---
C---     SET AMPLITUDES = 0 IF OVERFLOW  P. STEFFEN 12.30 83/04/21
C---
C---     NEW VERSION WITH A TZERO FOR EACH OF THE THREE RINGS.
C---                                   L.H. O'NEILL 19.30 13.08.79
C---   CHANGED 14.9.80 TO ACCOUNT FOR NOZAKIS NEW CONSTANTS
C---                                                  J.OLSSON
C---
C---
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
#include "cgraph.for"
C------------------------------------------
C  MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C------------------------------------------
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     * RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,ZRESOL,ZNORM,ZAL,
     * ZSCAL,DRIDEV,DRICOS,DRISIN,PEDES,TZERO(3),
     * DRIROT(96,2),SINDRI(96,2),COSDRI(96,2),DRIVEL(96,2),T0FIX(3)
C    PREVIOUS MACRO REPLACED WITH EXPLICIT COMMON STATEMENT, TO ACCOUNT
C    FOR INTRODUCTION OF ARRAY T0FIX.  WILL LATER BE INCLUDED IN MACRO
C CORRESPONDING CHANGE MADE IN SUPERV BLOCK DATA     J.OLSSON 14.9.80
C
C--------- END OF MACRO CJDRCH ------------
      COMMON/CALIBR/JPOINT(16)
      DIMENSION HCALIB(2)
      EQUIVALENCE (HCALIB(1),JPOINT(1))
      DATA ZPHS/2440./
      DATA RAMPS/100./
      DATA ICALL/0/
C---
      IF(ICALL.NE.0) GO TO 3
      ICALL=1
      IHEAD=IBLN('HEAD')
      IJETC=IBLN('JETC')
      AC0=0.5*(ZPHS-ZAL)/ZAL
      AC1=0.5*RAMPS*ZPHS/ZAL
    3 CONTINUE
      IPHALF=2*JPOINT(4)
      IPHEA2=2*IDATA(IHEAD)
      NRUN=HDATA(IPHEA2+10)
      IPJET1=IDATA(IJETC)
C---
C---     RENUMBER "JETC 0" TO "JETC 1" AND CREATE "JETC 0".
C---
      NW=IDATA(IPJET1)
      NUMB=IDATA(IPJET1-2)
      CALL BRNM('JETC',NUMB,'JETC',1)
      CALL CCRE(IPJET0,'JETC',0,NW,IERR)
      IF(IERR.NE.0) GO TO 10
      CALL CLOC(IPJET1,'JETC',1)
C---
C---     NOW CALIBRATE "JETC 0".
C---
      IP0=4*IPJET0
      IP1=4*IPJET1
      CALL MVCL(IDATA,IP0,IDATA,IP1,200)
C---
C---     COPY BANK DESCRIPTOR, CELL POINTERS AND LIST OF WIRES WITH
C---     MORE THAN 8 HITS. THE LATTER LIST IS AT THE END OF THE BANK
C---
      NEND=2*(HDATA(2*IPJET0+100)-HDATA(2*IPJET0+99))
      IP2=IP0+4*NW-NEND
      IP3=IP1+4*NW-NEND
      IF(NEND.GT.0) CALL MVCL(IDATA,IP2,IDATA,IP3,NEND)
C---
C---     ADD 100 TO FIRST I*2 BANK DESCRIPTOR WORD FOR CALIBRATED BANK.
C---
      HDATA(2*IPJET0+1)=HDATA(2*IPJET0+1)+200
      NHITS=(HDATA(2*IPJET0+99)-HDATA(2*IPJET0+3))/4
      IF(NHITS.LT.1) RETURN
      J=2*IPJET1+100
      K=2*IPJET0+100
      KMAX=K+HDATA(K-1)
    2 CONTINUE
      J=J+1
      K=K+1
      IF(K.GE.KMAX) GO TO 1
      HDATA(K)=HDATA(J)
      IWIRE=HDATA(J)
      J=J+1
      K=K+1
      IA1=HDATA(J)
      IF(IA1.LT.0) IA1=0
      IF(IA1.GE.4095) IA1=0
      IA1=ISHFTL(IA1,3)
      IA2=HDATA(J+1)
      IF(IA2.LT.0) IA2=0
      IF(IA2.GE.4095) IA2=0
      IA2=ISHFTL(IA2,3)
C     IHITN=LAND(IWIRE,7)
      IWIRE=ISHFTR(IWIRE,3)
C     IHITN=ISHFTL(IHITN,2)
C     IPLOC=IPHALF+34*IWIRE
      IPLOC=IPHALF+6*IWIRE
      ITZERO=HCALIB(IPLOC+1)
      SF=AC0+AC1/HCALIB(IPLOC+2)
C     IPLOC=IPLOC+IHITN
      IPEDL1=HCALIB(IPLOC+3)
      IGAIN1=HCALIB(IPLOC+4)
      IPEDL2=HCALIB(IPLOC+5)
      IGAIN2=HCALIB(IPLOC+6)
C---
C---     THE 512 (2**9) ADDED BELOW CAUSES THE SUBSEQUENT SHIFT RIGHT
C---     BY 10 BITS TO DO A ROUND OFF RATHER THAN A TRUNCATION.
C---
      IF(IA1.GT.0) IA1=IGAIN1*(IA1-IPEDL1)+512
      IF(IA1.LT.0) IA1=0
      IA1=ISHFTR(IA1,10)
      IF(IA2.GT.0) IA2=IGAIN2*(IA2-IPEDL2)+512
      IF(IA2.LT.0) IA2=0
      IA2=ISHFTR(IA2,10)
C---
C---     COMPUTE AMPLITUDE SLEWING CORRECTION AT THIS POINT.
C---
C---    NEW SLEWING CORRECTION INTRODUCED WITH NEW CONSTANTS,
C---    PARABOLIC CORRECTION, DIFFERENT FOR SMALL AND BIG AMPLITUDES;
C---                                              J.OLSSON  14.9.80
C---
      IAMCOR=0
      IAM=IA1
      IF(IA2.GT.IA1) IAM=IA2
C     IF(IAM.GT.2400) GO TO 200
C     TAMCOR=-66.2784+0.027616*IAM
C     IAMCOR=TAMCOR-0.5
C 200 CONTINUE
      IF(NRUN.GE.6185) GO TO 203
C -------- NEW   14.9.80
      IF(IAM.GT.2000) GO TO 200
      TAMCOR = -64.*1.494 + 7.872E-03*IAM*8. - 1.157E-05*IAM*IAM
      GO TO 201
200   IF(IAM.GT.4000) GO TO 202
      TAMCOR = -64.*0.8207 + 2.926E-03*IAM*8. - 2.561E-06*IAM*IAM
201   IAMCOR = TAMCOR - 0.5
202   CONTINUE
      GO TO 204
C -------- END NEW   14.9.80
C -------- NEW   25.3.81
203   CONTINUE
      IF(IAM.GT.1800) GO TO 205
      TAMCOR = -64.*1.811 + 1.112E-02*IAM*8. - 2.155E-05*IAM*IAM
      GO TO 206
205   IF(IAM.GT.5600) GO TO 204
      TAMCOR = -64.*0.8430 + 2.340E-03*IAM*8. - 1.623E-06*IAM*IAM
206   IAMCOR = TAMCOR - 0.5
C -------- END NEW   25.3.81
204   CONTINUE
      AX=SF*(IA2-IA1)
      IF(AX.GT.0.) AX=AX+0.5
      IF(AX.LT.0.) AX=AX-0.5
      IS=AX
      IF(IA1.GT.0) IA1=IA1-IS
      IF(IA1.LT.    0) IA1=0
      IF(IA1.GT.32767) IA1=32767
      IF(IA2.GT.0) IA2=IA2+IS
      IF(IA2.LT.    0) IA2=0
      IF(IA2.GT.32767) IA2=32767
      HDATA(K  )=IA1
      HDATA(K+1)=IA2
      J=J+2
      K=K+2
      IDTIME=HDATA(J)
      IF(IDTIME.LT.0) IDTIME=0
      IF(IDTIME.GT.255) IDTIME=255
      IDTIME=ISHFTL(IDTIME,6)-ITZERO+IAMCOR
      KLOK=1
      IF(IWIRE.GE.384) KLOK=2
      IF(IWIRE.GE.768) KLOK=3
C -------- NEW   14.9.80
      TPED=64.*(TZERO(KLOK) + T0FIX(KLOK)) + 10000.5
C -------- END NEW   14.9.80
C     TPED=64.*TZERO(KLOK)+10000.5
      IPED=TPED
      IPED=IPED-10000
C---  IF(IDTIME.LT.IPED) IDTIME=IPED
      HDATA(K)=IDTIME-IPED
      GO TO 2
    1 CONTINUE
      RETURN
   10 CONTINUE
      WRITE(JUSCRN,101) IERR
  101 FORMAT(' ERROR RETURN',I4,' FROM CCRE.')
      RETURN
      END

C   01/11/84 809101248  MEMBER NAME  RDMTCO9  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE RDMTCO( HOPT )
C-----------------------------------------------------------------------
C
C   AUTHOR:     E. ELSEN     4/05/79 :  PROCESSES THE MC CONSTANTS BANKS
C
C        MOD:   E. ELSEN    16/11/81 :
C        MOD:   C. BOWDERY   6/10/83 :  CREATE 'JETC'/9 BANK
C        MOD:   J. OLSSON   15/12/83 :  CORR. OF CTR123 ERROR
C        MOD:   J. HAGEMANN 11/10/83 :  VERTEX CHAMBER CODE
C               R. RAMCKE
C        MOD:   J.H.  C.B.  12/10/84 :  FIX-UP OF ROTNK & OTHER CHANGES
C        MOD:   J. HAGEMANN 08/11/84 :  COMMON /CVCEX/ IMPLEMENTED
C        MOD:   J. HAGEMANN 22/05/86 :  UPDATED CODE FOR CHANGING THE
C                                       INPUT FILE (SMEARED DATA <-->
C                                       UNSMEARED DATA) LIKE IN GRAPHICS
C                                       PROGRAM
C        MOD:   J. HAGEMANN 16/06/86 :  UPDATED VTXC BANK NUMBER
C        MOD:   J. OLSSON 7-8/86 :  GENERAL UPDATE TOGETHER WITH
C               OTHER TRIGGER ROUTINES. CALL PRAGAI, TO PREVENT
C               UNNECESSARY AND REPEATED PRINT
C               MOVE BLOCK DATA TO RDTRIG
C        MOD:   E. ELSEN    11/12/87 :  FOR NEW SMEARING SCHEMES IN
C               J. HAGEMANN             ID AND VTXC
C   LAST MOD:   J. OLSSON   25/07/88 :  NFLAGS(3) RESET FOR UNSMEARED
C                                       CALLS
C
C    THIS ROUTINE PROCESSES THE JET CHAMBER/VERTEX CHAMBER MC CONSTANTS
C    FOUND IN THE FIRST RECORD OF A MC EVENT DATASET. IT ACCOMMODATES
C    THE NEW INNER DETECTOR SMEARING SCHEME, SAVES THE CONSTANTS OF THIS
C    SCHEME IN THE START RECORD (MTCO EVENT) AND KEEPS COMPATIBILITY
C    WITH EARLIER MC DATA, WHICH ARE SMEARED IN A DIFFERENT WAY.
C
C    FURTHER CHANGES WERE INTRODUCED BY J.OLSSON, TO KEEP INFORMATION
C    ABOUT DOUBLE HIT RESOLUTION, RANDOM HITS AND EFFICIENCIES. THIS
C    WAS MADE BY STORING VALUES INTO MTCO IN SUBR. EVWRIT AND MARKING
C    MTCO, WORD 2.
C
C     IDATA(IPMTCO + 2) = FLAG FOR MTCO STORAGE OF SMEARING INFO.
C                A)   = 0  THIS INFORMATION WAS NOT KEPT
C                B)   = 1  INFORMATION IS KEPT, STORED IN MTCO
C
C
C    RDMTCO IS CALLED BY THE EVENT READING ROUTINE WHENEVER A
C    CALIBRATION EVENT WITH THE BANK MTCO IS ENCOUNTERED. SUCH AN
C    EVENT NORMALLY SHOULD CONTAIN THE BANKS MTCO,MJET AND MGEO. IT
C    MAY ALSO CONTAIN AN MVCC AND AN MGEV BANK WITH VERTEX CHAMBER
C    CONSTANTS.
C
C    RDMTCO COPIES THE CONSTANTS IN THESE BANKS INTO THE RELEVANT
C    COMMONS. RDMTCO ALSO INITIALISES THE SMEARING OF THE INNER DETECTOR
C
C      THERE ARE TWO OPTIONS FOR SMEARING THE DRIFT DATA
C       1. HOPT='DE'      DEFAULT VALUES FOR DRIFT TIME BINS AND
C                         Z AMPLITUDES ARE INSERTED.
C                         /CBIN/ IS OVERWRITTEN
C       2. HOPT='SE'      THE USER HAS TO PROVIDE PHI AND Z BINNING
C                         THROUGH THE COMMON/CBIN/
C      CBIN WILL HOWEVER BE OVERWRITTEN IN EITHER CASE IF THE
C      LAST MTCO BANK HAD THE SMEAR FLAG
C             IDATA(IDATA(IBLN('MTCO'))+1) .EQ. 1.
C
C  NOTE:
C  THESE DISTINCTIONS ARE HISTORICAL AND MEAN NOTHING. ALL PROGRAMS
C  CALL RDMTCO WITH 'DE' OPTION.
C
C
C     THE DETECTOR STATUS IS COPIED FROM MTCO INTO /CRDSTA/ AND /CTRIGG/
C     IF WORD2 IN MTCO IS NONZERO.
C
C     THE NEW SUBROUTINE RDRESO SETS FLAG ISMEAR IN /CADMIN/
C     FOR SMEARED DATA, ISMEAR IS SET = THIRD WORD IN MTCO
C     IF THIS FLAG IS SET, EVWRIT WILL STORE INFORMATION IN MTCO
C                  ***********
C     IPMTCO IS POINTER OF 'MTCO' - BANK
C
C     IDATA(IPMTCO + 3) = FLAG FOR SMEARING SCHEME
C                A)   = 0  O L D  SUBROUTINE RDRESO WAS USED
C                B)   = 1  N E W  SUBROUTINE RDRESO WAS USED
C
C     (IDATA(IPMTCO + 3 + I), I=1,6) = ACTUAL BINNING USED FOR SMEARING
C                                      OF INNER DETECTOR DRIFT DATA
C                                      (BINDL8(I), I=1,6)
C     IDATA(IPMTCO + 10)  =  STANDARD SMEARING OF DRIFT COORDINATE
C                            (RJITT)
C
C
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER * 2 (H)
C
      LOGICAL  LVTXC
C
#include "cmubcs.for"
C
      COMMON / CGEO1  / IGEO(66)
C
      EQUIVALENCE  ( IGEO(23), ROTNK )
C
      COMMON / CPRINT / NPRINT
      COMMON / CJDRCH / DRCH(34),
     +                  PEDES, TZERO(3),
     +                  DRIROT(96,2), SINDRI(96,2), COSDRI(96,2),
     +                  DRIVEL(96,2)
C
C                                          VERTEX CHAMBER
C
      COMMON / CVCEX  / LVTXC
      COMMON / CGEOV  / GEOV(13)
      COMMON / CJVTXC / VXCC(15),
     +                  DRILOR(24), SNLORA(24), CSLORA(24),
     +                  DRVELO(24)
      COMMON / CBINV /  DTRSVV, ZRSVV, EFFVV(2), DOUBVV(3), IRNHVV,
     +                  SMPRMV(3)
      DIMENSION ABINV(11)
      EQUIVALENCE ( ABINV(1), DTRSVV )
C
      COMMON / CADMIN / IEVTP,DUMM(6),ISMEAR,IJETCI,NFLAGS(10)
C
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10), IPHALG
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C
      DIMENSION TSTAT1(110), TSTAT2(13)
      EQUIVALENCE (TSTAT1(1),IHIST(1)), (TSTAT2(1), NDEAD)
C     COMMON / CTR123 / NPRINT,
C    +                  NBPTFW, NTOFC, IWCOLL, NTOFCA, ETOT1, ETOT2,
C    +                  ETOT3, HLGBRT, HLGQT, HLGET(4), HLGTL, HLGTH,
C    +              HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),
C    +              HDEADC(10),HJTOF,HACC1,HACC2,HACC3,
C    +              HACC4,HFMPRL,HFMPRH,HMPRON,IWMPRG,
C    +              HACC5,HWCOLN,HFSCLL,HFSCLH,IWCOLN,IWIDT2
      DIMENSION TSTAT3(56),HSTAT3(112),ISTAT3(56)
      DIMENSION TSTAT4(13),HSTAT4(26),ISTAT4(13)
      EQUIVALENCE (TSTAT3(1),ISTAT3(1)),(ISTAT3(1),HSTAT3(1))
      EQUIVALENCE (TSTAT4(1),ISTAT4(1)),(ISTAT4(1),HSTAT4(1))
C
CCC USER SUPPLIED COMMON/CBIN/
C
      COMMON / CBIN   / TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3),
     +                BINDL8(6),RJITT, DLRSLN(3), DLZSLN(3)
      DIMENSION ABIN(29)
      EQUIVALENCE ( ABIN(1), TIME(1) )
C
CCC /CBINMC/ IS USED FOR PASSING THE BINMC ARRAY TO SUBR. RDRDMH
C             THIS HAS HISTORICAL REASONS ONLY...
C
      COMMON / CBINMC / BINMC(6)
      DIMENSION SDRCH(34), SBIN(29), SBINV(11)
      DIMENSION IDOUBL(3)
C
C
      DATA SDRCH   / 34*0. /
      DATA SBIN    / 29*0. /
      DATA SBINV   / 11*0. /
      DATA IDOUBL  /  3*0  /
C
CCC   DATA HOPT1   / 'DE'  /
      DATA ICALL   /   0   /
      DATA IFLAG1  /   0   /
      DATA LBIN    /  29   /
      DATA LBINV   /  11   /
C
C-------------------  C O D E  -----------------------------------------
C
      ICALL = ICALL + 1
      IF( ICALL .EQ. 1) WRITE(6,6110)
6110  FORMAT(' ---> RDMTCO: VERSION FROM  JULY 1988')
C
CCC  CHECK IF CONSTANTS BANK IN BCS COMMON
C
      IPMTCO = IDATA( IBLN( 'MTCO' ) )
      IF( IPMTCO .NE. 0 .OR. ICALL .GT. 1 ) GO TO 500
         WRITE(6,9100)
 9100    FORMAT(//' +++++ WARNING FROM RDMTCO ++++++',/
     *            '   NO M T C O BANK IS FOUND !',/
     *            '    PROGRAMMED STOP FOLLOWS')
         STOP
  500 CONTINUE
C
C               COPY DRIFT CHAMBER INFORMATION IN MJET TO /CJDRCH/
C               ALSO SAVE THIS INFORMATION IN ARRAY SDRCH
C
      IPMJET = IDATA( IBLN( 'MJET' ) )
      LJET = IDATA(IPMJET)
      CALL MVCL( DRCH, 0, ADATA, IPMJET*4, LJET*4 )
      CALL MVCL( SDRCH, 0, DRCH, 0, LJET*4 )
C
C               COPY GENERAL GEOMETRY DATA FROM MGEO INTO /CGEO1/
C
      IPMGEO = IDATA( IBLN( 'MGEO' ) )
      LGEO = IDATA(IPMGEO)
      CALL MVCL( IGEO, 0, IDATA, IPMGEO*4, LGEO*4 )
C
C               FIX-UP THE VALUE OF ROTNK IF OLD DEFINITION
C
      IF( ROTNK .EQ. 847.0 ) ROTNK = 835.0
C

C
C               COPY VERTEX CHAMBER INFORMATION IN MVCC TO /CJVTXC/
C                   (IF MONTE CARLO DATA WITH VERTEX CHAMBER TRACKING)
      LVTXC = .FALSE.
      IPMVCC = IDATA( IBLN( 'MVCC' ) )
      IF( IPMVCC .LE. 0 ) GO TO 1000
         LVTXC = .TRUE.
         LVCC = IDATA(IPMVCC)
         CALL MVCL( VXCC, 0, ADATA, IPMVCC*4, LVCC*4 )
C
C               COPY GENERAL VERTEX CHAMBER GEOMETRY INFORMATION IN
C               BANK MGEV TO /CGEOV/
C
         IPMGEV = IDATA( IBLN( 'MGEV' ) )
         LGEV = IDATA(IPMGEV)
         CALL MVCL( GEOV, 0, ADATA, IPMGEV*4, LGEV*4 )
C
1000  CONTINUE
C
C    AT FIRST CALL, SAVE CONTENT OF /CBIN/ IN ARRAY SBIN
C                   SAVE CONTENT OF /CBINV/ IN ARRAY SBINV
C
      IF( ICALL .GT. 1 ) GO TO 1001
         CALL MVCL( SBIN, 0, ABIN, 0, LBIN*4 )
         CALL MVCL( SBINV, 0, ABINV, 0, LBINV*4 )
C
1001  CONTINUE
C                     CHECK MODE FLAG
C                                      IFLAG1: SMEARING FLAG
C                                             0:  UNSMEARED
C                                             1:    SMEARED
      IFLAG1 = IDATA(IPMTCO+1)
      IFLAG2 = IDATA(IPMTCO+2)
      IF( IFLAG1 .EQ. 1 ) GO TO 2000
C
C                                         **************************
C                                         *     UNSMEARED DATA     *
C                                         **************************
C
C
C       HOPT = HOPT1   MEANS DEFAULT SMEARING. HISTORICAL !!
C
CCC   IF( HOPT .EQ. HOPT1 ) CALL MVCL( ABIN, 0, SBIN, 0, LBIN*4 )
      CALL MVCL( ABIN, 0, SBIN, 0, LBIN*4 )
      CALL MVCL( ABINV, 0, SBINV, 0, LBINV*4 )
C
C     HERE BINDL8 WILL HOLD REALISTIC TIME BIN VALUES, NORMALLY 0.380
C     BINMC HOLDS THE TIMING BINS COMING WITH THE UNSMEARED DATA: 0.005
C
      DO 1010 I=1,6
         BINDL8(I)  = TIME(I)
         BINMC(I)   = DRCH(19+I)
 1010 CONTINUE
C
C INITIALIZE IFLADB AND NFLAGS(3), TO ENABLE RDTRIG AND CODE AFTERWARDS
C THIS IS NECESSARY IF A SECOND FILE WITH CONSTANTS BANKS IS READ
C
      IFLADB = 0
      NFLAGS(3) = -1
C
C  ARRAY IDOUB IS A HELP ARRAY, TO KEEP DOUBLE HIT RESOLUTION IN UNITS
C  OF DRIFT TIME BINS
C   OBS!! ALL SMEARED DATA ARE KEPT IN UNITS OF FINE ORIGINAL RESOLUTION
C         THEREFORE BINMC IS USED AS UNIT. THE SAME IS TRUE IN RDRESO.
C
      DO 1020 I=1,3
         IDOUBL(I) = IFIX(DOUB(I) / BINMC(2*I-1))
 1020 CONTINUE
      DRCH(27) = ZOF
      DRCH(28) = ZRS
      DRCH(30) = ZL
      DRCH(31) = ZSC
C                              FILL CELL DEPENDENT DRIFT VELOCITY ARRAY
      DO 121 IR = 1,3
         ICLL = IR*24 - 23
         ICLH = IR*24
         IF( IR .EQ. 3 ) ICLH = 96
         DO 120 I = ICLL,ICLH
            DRIVEL(I,1) = BINMC(2*IR-1)
            DRIVEL(I,2) = BINMC(2*IR)
  120       CONTINUE
  121    CONTINUE
C
      GO TO 3000
C
C                                         **************************
C                                         *  ALREADY SMEARED DATA  *
C                                         **************************
C
C      OVERWRITE /CBIN/ WITH THE VALUES IN /CJDRCH/. THESE HAVE JUST
C      JUST BEEN COPIED FROM BANK MJET. THEN SAVE THESE VALUES IN SBIN
C
 2000 CONTINUE
      DO 2010 I=1,6
         TIME(I) = DRCH(I+19)
 2010 CONTINUE
      ZOF = DRCH(27)
      ZRS = DRCH(28)
      ZL  = DRCH(30)
      ZSC = DRCH(31)
C
C  SET ARRAY DRIVEL IN /CJDRCH/,FROM THE GLOBAL VALUES
C
      DO 141 IR = 1, 3
         TIM = DRCH(IR*2+18)
         ICLL = IR*24 - 23
         ICLH = IR*24
         IF( IR .EQ. 3 ) ICLH = 96
         DO 140 I = ICLL, ICLH
            DRIVEL(I,1) = TIM
            DRIVEL(I,2) = TIM
  140    CONTINUE
  141 CONTINUE
C
C NOW CHECK IF DOUBLE HIT RESO, RANDOM HITS ETC. ARE KEPT IN MTCO
C
      DO 2020 I=1,3
         DOUB(I) = -5.
         EPSI(I) = -1.
         IRN(I)  = -100
         IF( IFLAG2 .NE. 0) DOUB(I) = ADATA(IPMTCO+133+I)
         IF( IFLAG2 .NE. 0) EPSI(I) = ADATA(IPMTCO+136+I)
         IF( IFLAG2 .NE. 0) IRN(I)  = IDATA(IPMTCO+139+I)
         IDOUBL(I) = DOUB(I) / DRCH(2*I+18)
 2020 CONTINUE
C
C    CHECK IF MONTE - CARLO - DATA ARE SMEARED WITH NEW SUBROUTINE
C    RDRESO, THEN IDATA(IPMTCO+3) EQUAL 1
C
      IFLAG3 = IDATA(IPMTCO+3)
      ISMEAR = IFLAG3
C
      DO 600 I = 1,6
         BINDL8(I)   = DRCH(I+19)
         BINMC(I)   = DRCH(I+19)
         IF( IFLAG3 .EQ. 1 ) BINDL8(I) = ADATA(IPMTCO+3+I)
  600 CONTINUE
      RJITT = -1.
      DLRSLN(1) = -1.
      DLRSLN(2) = -1.
      DLRSLN(3) = -1.
      DLZSLN(1) = -1.
      DLZSLN(2) = -1.
      DLZSLN(3) = -1.
      IF( IFLAG3 .NE. 1 ) GO TO 620
        RJITT = ADATA(IPMTCO+10)
        IF( IDATA(IPMTCO).GE.156) CALL UCOPY(ADATA(IPMTCO+151),DLRSLN,3)
        IF( IDATA(IPMTCO).GE.159) CALL UCOPY(ADATA(IPMTCO+157),DLZSLN,3)
  620 CONTINUE
C
C                   GET THE SMEARING PARAMETERS FOR VERTEX CHAMBER
C                   FROM BANK MTCO
C
      IF( .NOT. LVTXC )  GO TO 2026
        SMPRMV(1) = -1.
        SMPRMV(2) = -1.
        SMPRMV(3) = -1.
        DTRSVV    = ADATA(IPMTCO + 143)
        ZRSVV     = ADATA(IPMTCO + 144)
        EFFVV(1)  = ADATA(IPMTCO + 145)
        EFFVV(2)  = ADATA(IPMTCO + 146)
        DOUBVV(1) = ADATA(IPMTCO + 147)
        DOUBVV(2) = ADATA(IPMTCO + 148)
        DOUBVV(3) = ADATA(IPMTCO + 149)
        IRNHVV    = IDATA(IPMTCO + 150)
        IF( IDATA(IPMTCO).GE.156) CALL UCOPY(ADATA(IPMTCO+154),SMPRMV,3)
C
 2026 CONTINUE
C                            NOW COPY NOT ALLOWED, CONTENTS OF SBIN (THE
C                            ORIGINAL CONTENTS OF CBIN) WILL BE
C                            OVERWRITTEN
CCC   CALL MVCL( SBIN, 0, ABIN, 0, LBIN*4 )
C
C   GET THE DETECTOR STATUS AT THE TIME OF SMEARING
C     THIS INFORMATION IS ONLY AVAILABLE IF IFLAG2.NE.0
C
      IF( IFLAG2 .EQ. 0 )  GO TO 2040
         CALL MVCL( TSTAT1, 0, IDATA, (IPMTCO+10)*4, 110*4 )
         CALL MVCL( TSTAT2, 0, IDATA, (IPMTCO+120)*4, 13*4 )
 2040 CONTINUE
C
C   EARLIER VERSIONS OF CTRIGG (CTR123) MAY HAVE BEEN STORED IN MTCO
C   THIS COULD HAVE HAPPENED IN EARLIER VERSIONS OF TP PROGRAM
C   IF SO, COPY THE INFORMATION INTO PRESENT /CTRIGG/
C
      CALL MVCL( TSTAT3, 0, IDATA, (IPMTCO+10)*4, 52*4 )
      CALL MVCL( TSTAT4, 0, IDATA, (IPMTCO+62)*4, 13*4 )
      CALL MVCL( TSTAT3, 52*4, IDATA, (IPMTCO+75)*4, 4*4 )
C
C  CHECK IF OLD IWCOLL IS SET IN ISTAT3(4)
C
      IF( ISTAT3(4) .NE. 3) GO TO 2050
C
      IFLAG2 = 2
      WRITE(6,2041)
2041  FORMAT(' *** THESE DATA HAVE OLD VERSION OF COMMON /CTR123/ AND /C
     $RDSTA/ STORED IN MTCO ****')
      WRITE(6,2042)
2042  FORMAT(' *** THE CONSTANTS ARE COPIED INTO CURRENT COMMONS. THE CO
     $RRESPONDING DATE IS GIVEN IN THE LATER HEAD BANKS ***')
C
      IHIST(1) = 0
      IHIST(2) = 0
      IHIST(3) = 0
      NBPTFW = ISTAT3(2)
      NTOFC  = ISTAT3(3)
      IWCOLL = ISTAT3(4)
      NTFCOL = ISTAT3(5)
      HLGTOT(1,1) = HSTAT3(22)
      HLGTOT(2,1) = HSTAT3(21)
      HLGTOT(3,1) = HSTAT3(20)
      HLGTOT(4,1) = HSTAT3(19)
      HLGTL = HSTAT3(23)
      HLGTH = HSTAT3(24)
      HITCLL(1) = HSTAT3(25)
      HITCLL(2) = HSTAT3(26)
      HITCLL(3) = HSTAT3(27)
      HITWLL(1) = HSTAT3(28)
      HITWLL(2) = HSTAT3(29)
      HITWLL(3) = HSTAT3(30)
      HITSUM(1) = HSTAT3(31)
      HITSUM(2) = HSTAT3(32)
      HITSUM(3) = HSTAT3(33)
      HCHAMB(1) = HSTAT3(34)
      HCHAMB(2) = HSTAT3(35)
      HCHAMB(3) = HSTAT3(36)
      DO 2044  I = 1,16
         HMASK(I,1) = HSTAT3(36+I)
         HMASK(I,2) = HSTAT3(52+I)
         HMASK(I,3) = HSTAT3(68+I)
2044  CONTINUE
      DO 2045  I = 1,10
         HDEADC(I) = HSTAT3(84+I)
2045  CONTINUE
      HACC1  = HSTAT3(96)
      HACC2  = HSTAT3(97)
      HACC3  = HSTAT3(98)
      HACCM  = HSTAT3(99)
      HFMPRL = HSTAT3(100)
      HFMPRH = HSTAT3(101)
      HMPRON = HSTAT3(102)
      IWMPRG = ISTAT3(52)
      HACC4  = HSTAT3(105)
      HWCOLN = HSTAT3(106)
      NTFCLN = HSTAT3(108) + 1
      IWCOLN = ISTAT3(55)
      IWIDT2 = ISTAT3(56)
C
      NDEAD  = ISTAT4(1)
      NCDEAD = ISTAT4(2)
      DO 2048  I = 1,10
         HITD(I)   = HSTAT4(4+I)
         HCELLD(I) = HSTAT4(14+I)
2048  CONTINUE
      IPHALG = ISTAT4(13)
C
2050  CONTINUE
C                             FOR ALREADY SMEARED DATA, PRINT STATUS
C                      COMPARE CURRENT STATUS TO BACKUP
C                      IN ORDER TO AVOID UNNECESSARY PRINT
      IF(NFLAGS(8).NE.0) CALL PRAGAI(IPRIT)
      NFLAGS(8) = 0
      IF(IPRIT.NE.0) NFLAGS(9) = 1
      IF(NFLAGS(9).NE.0)  WRITE(6,8010)
8010  FORMAT('  RDMTCO: FLAG9 SET TO WRITE CONSTANTS RECORDS ON OUTPUT')
      IF(IPRIT.NE.0) CALL PRSTAT(IFLAG1,IFLAG2,IFLAG3)
C
C                                         **************************
C                                         *  ENTER HERE FOR BOTH   *
C                                         * SMEARED AND UNSMEARED  *
C                                         *    MONTE CARLO DATA    *
C                                         **************************
C
3000  CONTINUE
      DRIDEV = DRCH( 32 )
      DRISIN = SIN( DRIDEV )
      DRICOS = COS( DRIDEV )
C
C  SET CELL DEPENDENT CONSTANTS IN /CJDRCH/ FROM THE GLOBAL VALUES
C
      DO 111 J=1,2
         DO 110 I=1,96
            DRIROT(I,J) = DRIDEV
            SINDRI(I,J) = DRISIN
            COSDRI(I,J) = DRICOS
  110    CONTINUE
  111 CONTINUE
C
C                   SET CELL DEPENDENT CONSTANTS FOR THE VERTEX CHAMBER
C                   IN /CJVTXC/ FROM THE GLOBAL VALUES
C
      IF( .NOT. LVTXC )  GO TO 150
         DO 145  I = 1, 24
            DRILOR(I) = VXCC(7)
            CSLORA(I) = VXCC(8)
            SNLORA(I) = VXCC(9)
            DRVELO(I) = VXCC(15)
  145    CONTINUE
C
C THE FOLLOWING FUDGE IS INTRODUCED TO KEEP COMPATIBILITY WITH
C THE OLD TP PROGRAMS. IN THOSE PROGRAMS THE MTCO EVENT WILL BE WRITTEN
C OUT IMMEDIATELY, BEFORE READING THE MUCO EVENT. NOTE THAT THIS IMPLIES
C A LOGICAL ERROR, SINCE /CTR123/ OR /CTRIGG/ IS NOT UPDATED BEFORE
C THE FIRST EVENT HAS BEEN READ AND RDDATE BEEN CALLED (IN RDJETC).
C
  150 CALL BDLS( 'MTCO', 1)
      CALL BCRE( IPMTCO, 'MTCO', 1, 159, &9090, IER )
C
C       COPY DETECTOR STATUS INTO MTCO BANK
C
      CALL MVCL( IDATA, (IPMTCO+10)*4, TSTAT1, 0, 110*4 )
      CALL MVCL( IDATA, (IPMTCO+120)*4, TSTAT2, 0, 13*4 )
C
C COPY DOUB, EPSI AND IRN INTO MTCO
C
      DO 1011 I=1,3
         ADATA(IPMTCO+133+I) = DOUB(I)
         ADATA(IPMTCO+136+I) = EPSI(I)
         IDATA(IPMTCO+139+I) = IRN(I)
1011  CONTINUE
      IF( .NOT. LVTXC )  GO TO 1012
         ADATA(IPMTCO + 143) = DTRSVV
         ADATA(IPMTCO + 144) = ZRSVV
         ADATA(IPMTCO + 145) = EFFVV(1)
         ADATA(IPMTCO + 146) = EFFVV(2)
         ADATA(IPMTCO + 147) = DOUBVV(1)
         ADATA(IPMTCO + 148) = DOUBVV(2)
         ADATA(IPMTCO + 149) = DOUBVV(3)
         IDATA(IPMTCO + 150) = IRNHVV
         ADATA(IPMTCO+154) = SMPRMV(1)
         ADATA(IPMTCO+155) = SMPRMV(2)
         ADATA(IPMTCO+156) = SMPRMV(3)
C
C  WORD2 :   DETECTOR STATUS AND SOME CBIN VARIABLES ARE STORED
 1012 IDATA(IPMTCO+2) = 1
C
C  WORD3 :   BINDL8 AND RJITT SMEARING VARIABLES ARE STORED, IF ISMEAR=100005670
C
      IDATA(IPMTCO+3) = ISMEAR
      IF( ISMEAR .EQ. 0) GO TO 1111
C
C             COPY BINDL8 AND RJITT INTO MTCO
C
         DO 1013 I=1,6
            ADATA(IPMTCO+3+I) = BINDL8(I)
1013     CONTINUE
         ADATA(IPMTCO+10) = RJITT
         ADATA(IPMTCO+151) = DLRSLN(1)
         ADATA(IPMTCO+152) = DLRSLN(2)
         ADATA(IPMTCO+153) = DLRSLN(3)
         ADATA(IPMTCO+157) = DLZSLN(1)
         ADATA(IPMTCO+158) = DLZSLN(2)
         ADATA(IPMTCO+159) = DLZSLN(3)
1111  CONTINUE
C
C  WORD1 :   THIS IS SMEARED MONTE CARLO DATA
C     IDATA(IPMTCO+1) = 1
C          THIS FLAG IS SET BY THE CALLING PROGRAM, I.E. TPMAIN
C
C
C FOR USERS WHICH HAVE NOT INITIALIZED /CADMIN/, PRINT A WARNING
C
      IF( IEVTP .EQ. 1 .OR. IEVTP .EQ. 2) GO TO 9090
      WRITE(6,9089)
9089  FORMAT(' '/)
      WRITE(6,9091)
9091  FORMAT(' ',30('*'))
      WRITE(6,9092)
9092  FORMAT(' *****     WARNING    ********')
      WRITE(6,9091)
      WRITE(6,9093)
9093  FORMAT(' RDMTCO HAS COPIED TRIGGER AND DETECTOR STATUS INFORMATION
     $ INTO BANK MTCO.')
      WRITE(6,9094)
9094  FORMAT(' THIS VERSION OF THE TP PROGRAM WILL WRITE IT OUT ON THE O
     $UTPUT FILE IMMEDIATELY,')
      WRITE(6,9095)
9095  FORMAT(' BUT THE PROPER VERSION OF THE STATUS HAS NOT YET BEEN SET
     $, SINCE THE FIRST EVENT HAS NOT BEEN READ YET.')
      WRITE(6,9096)
9096  FORMAT(' BE AWARE THAT ERRORS MAY BE PRODUCED WITH THIS ILLOGICAL
     $PROCEDURE !!!')
      WRITE(6,9091)
      WRITE(6,9089)
C
9090  CONTINUE
      RETURN
C-----------------------------------------------------------------------
      ENTRY RDJETC
C-----------------------------------------------------------------------
C
C      SMEAR JETC BANK DATA, PUT IN INEFFICIENCIES, RANDOM HITS1
C      AND FINITE DOUBLE PULSE RESOLUTION.
C      PARAMETERS FOR SMEARING ARE IETHER DEFAULT OR HAVE BEEN SET BY A
C      PREVIOUS CALL TO RDMTCO.
C      PARAMETERS FOR TRIGGER AND INNER DETECTOR STATUS ARE SET BY THE
C      CALL TO RDTRIG
C-----------------------------------------------------------------------
C  FIRST SAVE HEAD DATE (WORDS 6-8) INTO HEAD WORDS 96-98.
C    THE EVENT DATE WILL BE OVERWRITTEN BY RDDATE, FOR TRIGGER VERSION
C-
       CALL RDHEAD
C-  NOW SET COMMONS /CTRIGG/ AND /CRDSTA/, AS WELL AS /CBIN/
       CALL RDTRIG
C                      COMPARE CURRENT STATUS TO BACKUP
C                      IN ORDER TO AVOID UNNECESSARY PRINT
      IPRIT = 0
      IF(NFLAGS(8).NE.0) CALL PRAGAI(IPRIT)
      NFLAGS(8) = 0
      IF(IPRIT.NE.0) NFLAGS(9) = 1
C     IF(NFLAGS(9).NE.0)  WRITE(6,8011)
C011  FORMAT('  RDJETC: FLAG SET TO WRITE CONSTANTS RECORDS ON OUTPUT')
      IF(IPRIT.NE.0) CALL PRSTAT(IFLAG1,IFLAG2,IFLAG3)
C
C  SINCE SOME OF THE INNER DETECTOR VARIABLES IN /CBIN/ ARE UPDATED
C  IN RDTRIG, REPEAT SOME OF THE RDMTCO ACTIONS HERE
C
C
C  ARRAY IDOUB IS A HELP ARRAY, TO KEEP DOUBLE HIT RESOLUTION IN UNITS
C  OF DRIFT TIME BINS
C   OBS!! ALL SMEARED DATA ARE KEPT IN UNITS OF FINE ORIGINAL RESOLUTION
C         THEREFORE BINMC IS USED AS UNIT. THE SAME IS TRUE IN RDRESO.
C
      IF(IFLADB.NE.0) GO TO 7021
      DO 7020 I=1,3
         IDOUBL(I) = IFIX(DOUB(I) / BINMC(2*I-1))
 7020 CONTINUE
C
      IFLADB = 1
7021  CONTINUE
C
C                                          VERTEX CHAMBER
C
      IF( .NOT. LVTXC )  GO TO 5304
C
         CALL RDRESV
C
         IPVTXC = IDATA (IBLN('VTXC'))
         IF( IPVTXC .LE. 0 )
     *      CALL BCRE ( IPVTXC, 'VTXC',10, 5, &5304, IEVT )
         CALL BSAW(1, 'VTXC')
         IDATA(IPVTXC + 1 ) = 5
C                                          DOUB. HIT RESO., INEFF.,
C                                          RANDOM HITS
         CALL RDMODV( IRNHVV, EFFVV, DOUBVV )
 5304 CONTINUE
C
C
C                       COPY UNSMEARED 'JETC' BANK 8 TO BANK 9
C
      IPJ = IDATA( IBLN( 'JETC' ) )
      IF( IPJ .LE. 0 ) GO TO 401
         IF( IJETCI .EQ. 0) GO TO 401
C
            LENGTH = IDATA(IPJ)
            CALL BCRE( IPJ9, 'JETC', 9, LENGTH, &401, IER )
            CALL MVCL( IDATA, IPJ9*4, IDATA, IPJ*4, LENGTH*4 )
C
C                       NOW SMEAR TIME AND Z-COORD VALUES
C
 401  CALL RDRESO( BINMC )
C
      IF( IPJ .LE. 0 ) CALL BCRE( IPJ, 'JETC', 8, 50, &7788, IE )
      CALL BSAW( 1, 'JETC' )
C
C                       CONSIDER DOUBLE HIT RESOLUTION,
C                       INEFFICIENCIES AND RANDOM HITS
C
      CALL RDMODN( IRN, EPSI, IDOUBL )
C
C                       SET CORRECT STANDARD DEVIATIONS IN PATR BANK
C
      CALL RDPATR
C                       CREATE TRIGGER BANKS
7788  CALL RDTRG1
      CALL RDTRG2
C                       DELETE LG-BLOCKS BELOW READOUT THRESHOLD IPHALG
      CALL RDALGN
      RETURN
      END

C   14/05/81 203291919  MEMBER NAME  GBOOK    (JADESR)      FORTRAN
C
C-----------------------------------------------------------------------
C
C  GFP 14/5/81
C
C  SIMPLISTIC HISTOGRAM PACKAGE PATCHED UP TO LOOK LIKE HBOOK
C  INTENDED FOR USE IN JADE REDUC1 PACKAGE AT RUTHERFORD TO SAVE CORE
C  ONLY 1-D HISTOGRAMS ARE PROCESSED -- 2-D PLOTS ARE IGNORED
C
C
C
C
C
C
C     ALL DATA IS STORED IN COMMON/CGBOOK/. THIS VERSION STORES
C     1 HISTOGRAM, BUT THIS CAN BE INCREASED BY CHANGING THE
C     SIZE OF THE ARRAY PLOT(116,10) IN YOUR OWN PROGRAM
C
C
C
C     THE HISTOGRAM BINNING FORMULA IS
C
C          IBIN=(XHIST-START)/BINSIZE+1
C
C     EVALUATED TO THE RULES OF OS/370 FORTRAN G1.
C     THIS IMPLIES THAT IF YOU EQUATE AN INTEGER TO A FLOATING
C     POINT NUMBER AND THEN HISTOGRAM THE FLOATING POINT,IT WILL
C     OCCUR AT THE LEFT-HAND EDGE OF A BIN.
C
C     NOTE -- WEIGHTS ARE IGNORED; YOU ALWAYS GET 100 BINS.
C     ----
C
C STORAGE SPACE IN ARRAY PLOT USED AS FOLLOWS :
C
C    PLOT(1->100) = HISTOGRAM
C    PLOT(101) = XMIN
C    PLOT(102) = XMAX
C    PLOT(103) = BINSIZE
C    PLOT(104) = UNDERFLOWS
C    PLOT(105) = OVERFLOWS
C    PLOT(106) = PLOT XREF IDENTIFIER  (INTEGER)
C    PLOT(107->116) = TITLE
C
C-----------------------------------------------------------------------
      SUBROUTINE HBOOK1(IDREF,ITIT,NBINS,XMIN,XMAX)
      COMMON/CGBOOK/PLOT(116,1)
      COMMON/CGB947/MAXLIN,MAXPLO
      INTEGER ITIT(1)
      LOGICAL*1 TIT(40)
      LOGICAL*1 BLANK/' '/,LOGTIT(2)/' ',' '/,TITEND
      INTEGER*4    IPLOT(116,1)
      INTEGER*2 COMTIT,DOLLAR/' $'/
      EQUIVALENCE (PLOT(1,1),IPLOT(1,1)),(COMTIT,LOGTIT(1))
C
C -- CHECK FOR DOUBLE DEFINITION
C
      CALL UCOPY(ITIT(1),TIT(1),10)
      IF(MAXPLO.EQ.0)GOTO30
      DO 20 I=1,MAXPLO
      IF(IPLOT(106,I).NE.IDREF)GOTO20
      PRINT10,IDREF
 10   FORMAT(' *** GBOOK1 PLOT ',I5,' DOUBLY DEFINED')
      GOTO60
 20   CONTINUE
C
C -- INITIALISE NEW PLOT
C
 30   ID=MAXPLO+1
      CALL UZERO(PLOT(1,ID),1,105)
       PLOT(101,ID)=XMIN
       PLOT(102,ID)=XMAX
       PLOT(103,ID)=(XMAX-XMIN)/100.
      IPLOT(106,ID)=IDREF
C -- TITLE
      TITEND=.FALSE.
      DO 40 I=1,40
      LOGTIT(2)=TIT(I)
      IF(COMTIT.EQ.DOLLAR)TITEND=.TRUE.
 40   IF(TITEND)TIT(I)=BLANK
      CALL UCOPY(TIT(1),PLOT(107,ID),10)
      MAXPLO=ID
      PRINT50,ID,IDREF,PLOT(101,ID),PLOT(102,ID),(PLOT(I,ID),I=107,116)
  50  FORMAT(' GBOOK1 PLOT ',I3,' .. ID',I4,3X,
     + 'XMIN =',E11.4,2X,'XMAX =',E11.4,3X,10A4)
  60  RETURN
      END
      SUBROUTINE HBOOK2(IDREF,TIT,NBINX,XMIN,XMAX,NBINY,YMIN,YMAX)
      INTEGER TIT(1)
      RETURN
      END
      SUBROUTINE HF2(IDREF,X,Y,WEIGHT)
      RETURN
      END
      SUBROUTINE HFILL(IDREF,X,Y,WEIGHT)
      CALL HF1(IDREF,X)
      RETURN
      END
      SUBROUTINE HF1(IDREF,X,WEIGHT)
      COMMON/CGBOOK/PLOT(116,10)
      INTEGER*4    IPLOT(116,1)
      COMMON/CGB947/MAXLIN,MAXPLO
      EQUIVALENCE (PLOT(1,1),IPLOT(1,1))
C
C -- FIND PLOT NUMBER
C
      DO 10 ID=1,MAXPLO
      IF(IPLOT(106,ID).EQ.IDREF)GOTO20
 10   CONTINUE
      RETURN
C
C -- LOAD ENTRY
C
 20   IF(PLOT(103,ID).EQ.0.0)RETURN
      IF(X.LT.PLOT(101,ID))GOTO30
      IF(X.GE.PLOT(102,ID))GOTO40
      B=X-PLOT(101,ID)
      IBIN = (X-PLOT(101,ID)) / PLOT(103,ID) + 1
      PLOT(IBIN,ID)= PLOT(IBIN,ID)+1.
      RETURN
 30   PLOT(104,ID) = PLOT(104 ,ID)+1.
      RETURN
 40   PLOT(105,ID) = PLOT(105 ,ID)+1.
      RETURN
      END
      SUBROUTINE HISTDO
      COMMON/CGBOOK/PLOT(116,10)
      INTEGER*4    IPLOT(116,1)
      COMMON/CGB947/MAXLIN,MAXPLO
      DIMENSION PLOT1(100),LINE(100),POINT(10)
      LOGICAL*1 ALINE(4,100)
      INTEGER SPACE/'    '/,STAR/'XXXX'/
      EQUIVALENCE (PLOT(1,1),IPLOT(1,1)),(LINE(1),ALINE(1,1))
C
C -- LOOP OVER THE PLOTS
C
      DO 200 ID=1,MAXPLO
C -- ZERO BINSIZE ?
      IF(PLOT(103,ID).EQ.0.0)GO TO 200
C
C LARGEST BIN, WEIGHTED TOTAL AND SUM TOTAL
C
      TOT=0.
      TAV=0.0
      TMAX=0.
      DO 30 J=1,100
      IF(PLOT(J,ID).GT.TMAX)TMAX=PLOT(J,ID)
      FI=FLOAT(J)-0.5
      TAV=TAV+(PLOT(101,ID)+FI*PLOT(103,ID))*PLOT(J,ID)
 30   TOT=TOT+PLOT(J,ID)
C -- EMPTY ?
      IF( (TOT+PLOT(104,ID)+PLOT(105,ID)) .LT. 1.0)GOTO200
C
C -- PRINT TITLE
C
      PRINT40,IPLOT(106,ID),(PLOT(J,ID),J=107,116)
 40   FORMAT(1H1,10X,'PLOT NUMBER',I5,5X,10A4)
      PRINT50
 50   FORMAT(1H0,10X,10('I',9X),/11X,100('-'))
C
C -- PRINT HISTOGRAM
C
      FULL=MAXLIN-20
      TMAX2=TMAX
      IF(TMAX2.LT.FULL)TMAX2=FULL
      DO 60 J=1,100
 60   PLOT1(J)=(PLOT(J,ID)*FULL)/TMAX2+0.0001
      ILINE=FULL
      DO 90 J=1,ILINE
      KBACK=ILINE-J
C SINGLE HORIZONTAL LINE
      DO 70 K=1,100
      LINE(K)=SPACE
      ISTAR=PLOT1(K)
 70   IF(ISTAR.GT.KBACK)LINE(K)=STAR
      PRINT80,LINE
 80   FORMAT(1H ,9X,'I',100A1,'I')
 90   CONTINUE
      PRINT100
 100  FORMAT(1H ,10X,100('-'),/11X,10('L',9X))
C
C -- PRINT X-COORDINATES
C
      DO 110 KK=1,10
 110  POINT(KK)=PLOT(101,ID)+(KK-1)*PLOT(103,ID)*10.0
      PRINT120,POINT
 120  FORMAT(6X,10(E9.3,1X),/1X)
C
C -- PRINT HISTOGRAM BIN CONTENTS
C
      LSUM=0
      DO 140 KK=1,5
      K=6-KK
      DO 130 JJ=1,100
      FIB=(PLOT(JJ,ID)+0.0001) / (10**K)
      IB1 = FIB * 10
      IB2 = FIB
      LIN = 0.0001 + IB1 - 10.0*IB2
      LSUM=LSUM+LIN
      LIN=LIN+240
      IF( (LIN.EQ.240) .AND. (LINE(JJ).EQ.SPACE.OR.KK.EQ.1) ) LIN=SPACE
      LINE(JJ) = LIN
 130  CONTINUE
      IF(LSUM.GT.0)PRINT150,(ALINE(4,JJ),JJ=1,100)
 140  CONTINUE
 150  FORMAT(1H ,10X,100A1)
C
C -- PRINT PLOT STATISTICS
C
      PRINT160,TOT,TMAX,PLOT(104,ID),PLOT(105,ID)
 160  FORMAT(1H0,'NUMBER OF EVENTS IN PLOT =',F10.0,10X,
     1 'MAXIMUM BIN CONTENTS =',F10.0,//1X,'UNDERFLOWS =',F10.0,
     2 10X,'OVERFLOWS =',F10.0)
C
C -- CALCULATE MEAN AND SIGMA
C
      IF(TOT.LT.2.)GO TO 200
      TAV=TAV/TOT
      STDDEV=0.0
      DO 170 J=1,100
      FJ=FLOAT(J)-0.5
 170  STDDEV=STDDEV+(((PLOT(101,ID)+FJ*PLOT(103,ID))-TAV)**2)*PLOT(J,ID)
      STDDEV=SQRT(STDDEV/(TOT-1.0))
      PRINT180,TAV,STDDEV
  180 FORMAT(1H0,'MEAN=',E11.4,'   STD DEVIATION=',E11.4)
  200 CONTINUE
      RETURN
      END
      SUBROUTINE HBLACK(I)
      RETURN
      END
      SUBROUTINE HLIMIT(I)
      RETURN
      END
      SUBROUTINE H1EVLI(I)
      RETURN
      END
      BLOCK DATA
      COMMON/CGB947/MAXLIN,MAXPLO
      INTEGER*4 MAXLIN/60/,MAXPLO/0/
      END

C   14/03/83 303151151  MEMBER NAME  TOFCORT  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFCOR
C
C         MATCHING BETWEEN THE TOF COUNTERS AND
C         THE PARTICLE TRAJECTORIES DEFINED
C         BY THE INNER DETECTORS.
C         CODED AT 07.11.78
C         CHANGED AT 3.3.1980 BEATE NAROSKA
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       COMMON/CWORK/NR,RAW(5,42),NC,ICRT1(5,42),NTRK,ICRT2(50),TRK(5,50)
     - ,ITRC(50),NTC,ITRK(5,42),INFM(4),IR(14,50)
       DIMENSION IRAW(5,42)
       EQUIVALENCE (IRAW(1,1),RAW(1,1))
      COMMON/POINT/IPHEAD,IPLTCH,IPT1,IPTOF,IPCLST,IPR,IPPATR,IPNT(13)
C
       DATA PAI/3.1415927/,RTOF/920./
       DATA XPAI/.14960/,SQRAD/.36742/,DSTAN/.01/
      DATA IBUG/50/
C
C=========   ININTIALIZATION OF CORRESPONDENCE TABLE
C
      IBUG = IBUG + 1
       CALL SETSL(ICRT1,0,42*20,0)
       CALL SETSL(ICRT2,0,200,0)
C
C---------------------------------------------------------------------
C   SEARCH TRACKS HITTING A PARTICULAR COUNTER,THAT HAD EITHER EXACTLY
C   ONE TRACK EXTRAPOLATING TO IT OR NONE
C---------------------------------------------------------------------
C
      DO   20   N=1,NTRK
      IF(ITRC(N).NE.41.AND.ITRC(N).NE.42)  GOTO  20
      GOTO  30
   20 CONTINUE
      RETURN
   30 PRINT 220,NTRK,(ITRC(N),N=1,NTRK)
  220 FORMAT(' TRACK INFO' I6,5X,10I8)
      CALL ATOFPR(IPTOF)
C
           RETURN
           END

C   01/10/83 310011924  MEMBER NAME  JHITIN   (S1)          FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JHITIN ( * )
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     25/09/78 :  ORDERS JET CHAMBER HITS
C
C        MOD  C. BOWDERY   19/08/83 :  EXPANDED COMMON /CWSET/.
C                                   :  HITAR(16000) I.E. 4000 HITS
C   LAST MOD  C. BOWDERY   23/08/83 :  4V/HIT ASSOCIATION INFO SORTED
C
C        ORDERS HITS ACCORDING TO WIRE NUMBERS (AND DRIFT TIMES WHEN A
C        WIRE HAS MULTIPLE HITS). THE HIT INFO FOR THE CURRENT TRACK IS
C        HELD IN HLIST AND H4VHTR. ON EXIT THE HITAR AND H4VHIT ARRAYS
C        CONTAIN ALL THE HITS INCLUDING THOSE OF THE CURRENT TRACK.
C
C           NHITS  = NO. OF HITS FOR CURRENT TRACK
C           INEXT  = POINTER TO FIRST FREE WORD IN HLIST (4 * NHITS + 1)
C           NHALL  = TOTAL NUMBER OF HITS IN HITAR
C           ISTART = POINTER TO FIRST FREE WORD IN HITAR (4 * NHALL + 1)
C
C        RETURN 1  IF ON ADDING THE CURRENT TRACK'S HITS, NHALL WOULD
C                                                         EXCEED 4000
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / C4VHIT / H4VHTR(400), H4VHIT(4000)
      COMMON / CWORK  / NHITS, INEXT, HLIST(1600)
      COMMON / CWSET  / NHALL, ISTART, HPCELL(98), HITAR(16000)
C
      DIMENSION HW(4)
C
C------------------------  C O D E  ------------------------------------
C
C             FIRST ORDER HITS OF THE CURRENT TRACK USING THE SHELLSORT
C             ALGORITHM. THE SORTING IS DONE 'IN SITU'.
C
      IF( NHITS.EQ. 0 ) RETURN
      IF( NHALL + NHITS .GT. 4000) RETURN 1
C
      IL = 1
      M  = MIN0( NHITS, 30 )
C
   10 M = M/2
      IF( M .EQ. 0 ) GO TO 900
        K = ( NHITS - M )*4
        DO 50 J = IL, K, 4
           I = J
   20      IM = I + M*4
           IF( HLIST(IM)   .GT. HLIST(I)   .OR.
     *        (HLIST(IM)   .EQ. HLIST(I)   .AND.
     *         HLIST(IM+3) .LE. HLIST(I+3)) ) GO TO 50
C
C                            INDICES FOR HLIST
C
              ISH  = ( I  - 1 ) * 2
              IMSH = ( IM - 1 ) * 2
              CALL MVC( HW,    0,    HLIST, ISH,  8 )
              CALL MVC( HLIST, ISH,  HLIST, IMSH, 8 )
              CALL MVC( HLIST, IMSH, HW,    0,    8 )
C
C                            INDICES FOR H4VHTR
C
              I4V = ( I  + 3 ) / 4
              M4V = ( IM + 3 ) / 4
              HTEMP         = H4VHTR( I4V )
              H4VHTR( I4V ) = H4VHTR( M4V )
              H4VHTR( M4V ) = HTEMP
C
              I = I - 4*M
              IF( I .LT. 1 ) GO TO 50
              GO TO 20
   50   CONTINUE
        GO TO 10
  900 CONTINUE
C
C-----------------------------------------------------------------------
C
C     COPY FROM HLIST --> HITAR   AND   H4VHTR --> H4VHIT
C
C            IR = POINTS IN HITAR WHERE NEXT 4 HIT WORDS WILL GO
C            IT = POINTS IN HLIST TO GET NEXT 4 NEW HIT WORDS
C            IL = POINTS IN HITAR TO GET NEXT 4 OLD HIT WORDS
C
C     THE HITAR ARRAY IS ORDERED BY SELECTING THE HIT INFORMATION
C     (8 BYTES) IN DESCENDING ORDER FROM HLIST (NEW HITS) AND HITAR
C     (EXISTING HITS), FROM WHICHEVER HAS THE LARGER WIRE NUMBER OR
C     SMALLER DRIFT TIME, AND PLACING IT INTO HITAR POINTED AT BY 'IR'.
C     'IR' INITIALLY POINTS TO THE TOP POSITION IN HITAR FOR STORING
C     ALL THE EXISTING AND NEW HITS. IT IS DECREMENTED EACH TIME A HIT
C     IS STORED. WHEN A HIT IS TAKEN FROM HLIST, THE 'IT' POINTER IS
C     THEN DECREMENTED. SIMILARLY WHEN AN EXISTING HIT IS REPOSITIONED
C     IN HITAR, THE 'IL' POINTER IS DECREMENTED TO POINT AT THE NEXT
C     EXISTING HIT AT THE TOP OF THE OLD LIST.
C     THE SORTING OF THE 4_VECTOR_TRACK/HIT ASSOCIATION INFO IS
C     SIMILAR BUT THE POINTERS ARE SIMPLER (ONLY 1 HALF-WORD MOVES).
C
C-----------------------------------------------------------------------
C
      IR = ISTART + NHITS * 4 - 1
      IT = INEXT - 5
      IL = ISTART - 5
C                                       H4VHTR & H4VHIT POINTERS
      JR = NHALL + NHITS + 1
      JT = NHITS
      JL = NHALL
C
 1000 IR = IR - 4
      JR = JR - 1
      IF( IL .LT. 0 ) GO TO 1100
C
      IF( HLIST(IT+1) .GT. HITAR(IL+1)  .OR.
     *   (HLIST(IT+1) .EQ. HITAR(IL+1)  .AND.
     *    HLIST(IT+4) .LE. HITAR(IL+4)) ) GO TO 1100
C                                                     REPOSITION OLD HIT
         CALL MVC( HITAR, IR*2, HITAR, IL*2, 8 )
         H4VHIT( JR ) = H4VHIT( JL )
         IL = IL - 4
         JL = JL - 1
         GO TO 1000
C                                                     STORE NEW HIT
 1100 CALL MVC( HITAR, IR*2, HLIST, IT*2, 8 )
      H4VHIT( JR ) = H4VHTR( JT )
      JT = JT - 1
      IT = IT - 4
      IF( IT .GE. 0 ) GO TO 1000
C
C
      ISTART = ISTART + NHITS * 4
      NHALL  = NHALL  + NHITS
      RETURN
      END

C   01/11/84 807241257  MEMBER NAME  DRAWID   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWID( IVIEW )
C-----------------------------------------------------------------------
C
C   AUTHOR:    C. BOWDERY    26/04/84 :  DRAW INNER DETECTOR
C
C       MOD:   J. HAGEMANN   09/10/84 :  HATCH TANK WALL ON SCREEN
C  LAST MOD:   J. HAGEMANN   11/04/88 :  BIG DOTS FOR SIGNAL WIRES
C                                        WHEN REQUESTED
C
C     DRAW THE INNER DETECTOR FOR THE VIEW IVIEW.
C       IVIEW = 1   : R PHI VIEW
C       IVIEW = 2   : RZ VIEWS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  DSPDTM, FLVCDO
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CJCELL / NCELL(3),NWIRES(3)
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CGVCDO / FLVCDO(20)
C
#include "cjdrch.for"
#include "cgeo1.for"
#include "cgeo2.for"
#include "cgraph.for"
#include "cgrscl.for"
C
C------------------  C O D E  ------------------------------------------
C
C                            CDTL 4   DRAW JET CHAMBER WALLS
C                            CDTL 5   DRAW JET CHAMBER WIRES
C                            CDTL 6   DRAW CROSSES FOR JET CHAMBER HITS
C
      GO TO ( 10 , 20 ) , IVIEW
C
C                            R PHI VIEW
C
  10  IF( ( .NOT. DSPDTL(4) )  .AND.  ( .NOT. DSPDTL(5) ) ) GO TO 9
C
      RDT = 0.5/ABS(XMAX-XMIN)*ABS(XMAXST(20)-XMINST(20))
      NRING = 3
      IF( LASTVW .EQ. 20 ) NRING = 1
      DO  2  J = 1,NRING
        RADD   = RINCR(J)
        RR1    = FSENSW(J)
        NN     = NCELL(J)
        NWE    = NWIRES(J)
        RR2    = RR1 + RADD*(NWE - 1)
        DELPHI = TWOPI/NN
C
        DO  4  K = 1,NN
          DO  6  L = 4,5
            IF( .NOT. DSPDTL(L) ) GO TO 6
            RR11 = RR1
            IF( L .EQ. 4 ) RR11 = RR11 - 15.
            RR22 = RR2
            IF( L .EQ. 4 ) RR22 = RR22 + 15.
C
            PHI  = DELPHI * (K - 1) + 0.5 * DELPHI * (L - 4)
            CSN  = COS(PHI)
            SSN  = SIN(PHI)
            XL1  = RR11 * CSN
            YL1  = RR11 * SSN
            IF( L .EQ. 5 ) GO TO 7
C
            CALL DRAMOV(XL1,YL1,RR22*CSN,RR22*SSN,0)
            GO TO 6
    7       CONTINUE
            STEPX = RADD * CSN
            STEPY = RADD * SSN
            DO  8  M = 1,NWE
              CALL POINTA(XL1,YL1)
              IF( LASTVW .NE. 20 .OR. .NOT. FLVCDO(19) )  GO TO 1008
                 CALL PLYGON( 11, RDT, XL1, YL1, 0 )
1008          XL1 = XL1 + STEPX
              YL1 = YL1 + STEPY
   8        CONTINUE
   6      CONTINUE
   4    CONTINUE
   2  CONTINUE
C
   9  DDD   = 10.24 * 25.4 / ( XMAX - XMIN )
      NN = 525.0 * DDD
      IF( NN .LT. 40 ) NN = 40
      CALL PLYGON(NN,RITNK,0.,0.,0)
      CALL PLYGON(NN,RITNK+DRITNK,0.,0.,0)
      IF( DSPDTM(15) )
     +              CALL DRHATC(IVIEW, 200, RITNK, RITNK+DRITNK, 0., 0.)
C
      NN = 750.0 * DDD
      IF( NN .LT. 40 ) NN = 40
      CALL PLYGON(NN,ROTNK,0.,0.,0)
      CALL PLYGON(NN,ROTNK+DROTNK,0.,0.,0)
      IF( DSPDTM(15) )
     +              CALL DRHATC(IVIEW, 500, ROTNK, ROTNK+DROTNK, 0., 0.)
C
      RETURN
C
C                            Z VIEWS
C
C                            FIRST DRAW BOX
C
  20  CALL DRAMOV(ZTKM, RITNK,ZTKM, ROTNK,0)
      CALL DRAWA( ZTKP, ROTNK)
      CALL DRAWA( ZTKP, RITNK)
      CALL DRAWA( ZTKM, RITNK)
      CALL DRAMOV(ZTKM,-RITNK,ZTKM,-ROTNK,0)
      CALL DRAWA( ZTKP,-ROTNK)
      CALL DRAWA( ZTKP,-RITNK)
      CALL DRAWA( ZTKM,-RITNK)
      X1 = -ZMAX + ZOFFS
      X2 =  ZMAX + ZOFFS
C
C                            DRAW WIRES OF INNER DETECTOR
C
      IF( .NOT. DSPDTL(5) ) RETURN
C
      DO  21  J = 1,3
        RADD = RINCR(J)
        R    = FSENSW(J)
        NWE  = NWIRES(J) - 1
        DO  22  K = 1,2
          R = R + (K-1)*NWE*RADD
          CALL DRAMOV(X1, R,X2, R,0)
          CALL DRAMOV(X1,-R,X2,-R,0)
  22    CONTINUE
  21  CONTINUE
C
      RETURN
      END

C   21/11/78 C9012401   MEMBER NAME  ZBOS03   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------300000200
C     3.  LOCATING OF BANKS
C
C     3.1  LOCATING A BANK
C
C
C                   -- --                                     -- --
C     CALL BLOC(IND,NA,NR,&S1)                  CALL CLOC(IND,NA,NR)
C               ---       ---                             ---
C
C        WHERE NA = NAME OF THE BANK
C              NR = NUMBER OF THE BANK
C              IND = INDEX OF THE BANK (NORMAL RETURN)
C
C     SPECIAL CONDITIONS
C                           BLOC             CLOC
C
C     BANK NOT EXISTING     IND=0            IND=0
C                           RETURN 1
C
C
C     3.2  LOCATING ALL BANKS WITH THE SAME NAME
C
C
C     LOCATING OF ALL BANKS OF A GIVEN NAME IN ASCENDING ORDER
C     OF NR IS DONE IN THE FOLLOWING WAY.
C
C               ----                               ----
C     CALL BPOS(NAME)                    CALL CPOS(NAME)
C
C        WHERE NAME = NAME OF THE BANKS
C
C               ---                                ---
C     CALL BNXT(IND,&S1)                 CALL CNXT(IND)
C               --- ---                            ---
C
C        WHERE IND = INDEX OF NEXT BANK OF THE SAME NAME
C
C     SPECIAL CONDITION
C                              BNXT             CNXT
C
C     NO FURTHER BANK          IND=0            IND=0
C                              RETURN 1
C
C     EXAMPLE FOR A LOOP ON ALL BANKS OF THE SAME NAME
C        CALL BPOS(NAME)
C     10 CALL BNXT(IND,&20)
C        . . .
C        GOTO 10
C     20 CONTINUE
C
C     BPOS/BNXT-LOOPS MAY BE NESTED. BNXT MAY ALSO BE USED
C     WITHOUT BPOS TO OBTAIN THE INDEX OF THE NEXT BANK OF
C     THE SAME NAME. THE INDEX IND IS A INPUT- AND OUTPUT-
C     ARGUMENT IN BNXT, EXCEPT FOR THE FIRST CALL AFTER THE
C     CALL OF BPOS, WHERE IT IS AN OUTPUT-ARGUMENT.
C
C
C
C     LOCATING ALL BANKS OF A GIVEN NAME CAN ALSO BE DONE USING
C     SUBROUTINE BDAR.
C
C                ----        ----
C     CALL  BDAR(NAME,N,INDA,NLIM)
C                     - ----
C
C        WHERE NAME = NAME OF THE BANKS
C              NLIM = NR.OF WORDS OF ARRAY INDA( )
C        INDA( ) = ARRAY CONTAING N INDICES (N.LE.NLIM)
C
C     EXAMPLE, EQUIVALENT TO THE ONE IN 3.2
C        INTEGER INDA(20)
C        CALL BDAR(NAME,N,INDA,20)
C        DO 20 I=1,N
C        IND=INDA(I)
C        . . .
C     20 CONTINUE
C
C
C
C
C     3.3  FASTER METHODS
C
C
C     TO LOCATE BANKS, FASTER METHODS CAN BE USED THAN THE METHODS
C     DESCRIBED ABOVE. THE DECREASE OF TIME IS OBTAINED BY AVOIDING
C     ANY SUBROUTINE CALLS.
C
C     THE INDEX IND OF THE FIRST BANK OF A GIVEN NAME (THE BANK WITH
C     THE SMALLEST VALUE OF NR) IS STORED IN ONE OF THE LOCATIONS
C     IW(1) TO IW(NAMAX), WHERE NAMAX IS THE MAXIMUM NR OF DIFFERENT
C     NAMES. THE INDEX I OF THIS LOCATION IS FIXED DURING THE JOB.
C     IT CAN BE OBTAINED BY THE FUNCTION IBLN, E.G.
C                  I = IBLN(NAME)
C     THUS IW(I) IS ZERO, IF NO BANK WITH THAT NAME EXISTS. IF
C                IND = IW(I)
C     IS NOT EQUAL TO ZERO, THEN IND IS THE INDEX OF THE
C     FIRST BANK FOR THAT NAME. THE POINTER TO THE NEXT BANK
C     OF THE SAME NAME (NEXT LARGER VALUE OF NR) IS STORED
C     IN THE LOCATION IW(IND-1), THUS CAN BE OBTAINED BY THE
C     STATEMENT
C                IND = IW(IND-1)
C
C
C
C
C
C
C
C
C
C
C
C
C     BELOW THE PROGRAMMING IS DESCRIBED FOR THE CASE, WHERE A LOOP
C     ON ALL BANKS OF THE SAME NAME IS EXECUTED. A LOCAL VARIABLE
C     INDF IS INITIALIZED TO ZERO BY A DATA STATEMENT, AND IS
C     DEFINED AS
C               INDF = IBLN(NAME)+1
C     AT THE FIRST EXECUTION OF THE LOOP.
C
C           DATA INDF/0/
C           IF(INDF.EQ.0) INDF=IBLN(NAME)+1
C           IND=INDF
C        10 IND=IW(IND-1)                         CALL BPOS(NAME)
C           IF(IND.EQ.0)    GOTO 30            10 CALL BNXT(IND,&30)
C      C    NEXT BANK FOUND                       . . .
C           . . .                                 . . .
C           . . .                                 . . .
C           GOTO 10                               GOTO 10
C      C    END OF LOOP                        30 . . .
C        30 . . .
C
C
C     BELOW THE PROGRAMMING IS DESCRIBED FOR THE CASE, WHERE A
C     CERTAIN BANK (NAME,NR) HAS TO BE LOCATED.
C
C
C           DATA INDF/0/
C           IF(INDF.EQ.0) INDF=IBLN(NAME)+1
C           IND=INDF
C        10 IND=IW(IND-1)
C           IF(IND.EQ.0)    GOTO 30
C           IF(IW(IND-2)-NR) 10,20,30         CALL BLOC(IND,NAME,NR,&30)
C      C    BANK (NAME,NR) FOUND              . . .
C        20 . . .
C
C      C    BANK NOT FOUND
C        30 . . .                          30 . . .
C
      RETURN
      END

C   20/08/80 008221358  MEMBER NAME  FTDLHO                 FORTRAN
      SUBROUTINE FTDLHO(IPNTH,ICNT,MPROJ,X0,Y0,DX,DY)
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      DIMENSION ADJ(8)
      DATA ADJ/3*0.5,0.0,0.5,3*0.0/
      SIZE=75.
      IRAD=2*ICNT-1
      IADR=IPNTH+240+IRAD/8+IRAD
      ITOF0=HDATA(IADR)
      ITOF1=HDATA(IADR+1)
      IF(ITOF0.GE.2048) ITOF0=0
      IF(ITOF1.GE.2048) ITOF1=0
      GO TO (1,2,3),MPROJ
    1 CONTINUE
      IS=1
      IF(X0.GT.0.) IS=-1
      X=X0+6*IS*DX+1.5*(IS-1)*SIZE
      ICYL=ICNT/8
      IHT=ICNT-8*ICYL-4
      Y=SIZE*(2*IHT-0.5)
      GO TO 200
    2 CONTINUE
      IS=1
      IF(X0.GT.0.) IS=-1
      X=X0+6*IS*DX+2*(IS-1)*SIZE
      Y=Y0-0.5*SIZE
      GO TO 200
    3 CONTINUE
      ICY=ICNT/8+1
      X=X0-2*SIZE+ADJ(ICY)*SIZE
      Y=Y0-DY-4*SIZE
      CALL DNUM(ITOF0,X,Y,SIZE,0.)
      Y=Y0+DY+2*SIZE
      CALL DNUM(ITOF1,X,Y,SIZE,0.)
      GO TO 300
  200 CONTINUE
      ITHR=ITOF0+ITOF1
      IF(ITHR.LT.1) GO TO 300
      ITHB=ITOF0*ITOF1
      IF(ITOF0.GT.0) ITOFA=ITOF0
      IF(ITOF1.GT.0) ITOFA=ITOF1
      IF(ITHB.GT.0) ITOFA=(ITOF0+ITOF1)/2
      CALL DNUM(ITOFA,X,Y,SIZE,0.)
  300 CONTINUE
      RETURN
      END

C   17/12/87 712172317  MEMBER NAME  RDDATE00 (JADEGS)      FORTRAN
C
C----------------------------------------------------------------------
      SUBROUTINE RDDATE
C----------------------------------------------------------------------
C
C   AUTHOR    E. ELSEN    13/05/82 :  SET SMEARING DATE
C
C        MOD  J. OLSSON   23/08/83 :  CHANGED THE DATE
C        MOD  C. BOWDERY  19/10/83 :  CHANGED THE DATE AGAIN
C        MOD  C. BOWDERY  22/11/83 :  FORCE SMEARING DATE FOR MU EVENTS
C        MOD  C. BOWDERY   8/02/84 :  CADMIN MACRO NOW ON PATRECSR
C        MOD  J. OLSSON   17/08/86 :
C        MOD  J. OLSSON   29/10/86 :  RESTRICT MISMATCH PRINT
C   LAST MOD  C. BOWDERY  17/12/87 :  CHOOSE TRACKING DATE UNLESS THE
C                                     COMMON /TODAY/ DATE IS NOT DEFAULT
C
C   ROUTINE CALLED IN RDTRIG.
C   THIS ROUTINE OVERWRITES THE DATE
C   IN THE BANK 'HEAD' WITH THE SMEARING DATE TO BE USED.
C
C   THE DATE TO BE USED FOR SMEARING IS COPIED FROM THE TRACKING
C   CONFIGURATION DATE SET BY MCJADE  U N L E S S  THE DATE FOUND IN
C   COMMON /TODAY/ HAS BEEN CHANGED (BY OVERWRITING) FROM THE DEFAULT
C   DATE OF 17/5/85.
C
C   THE /TODAY/ DATE IS ALSO CHECKED FOR VALIDITY WITH RESPECT TO THE
C   STATUS OF THE VERTEX CHAMBER;  IF THE FLAG LVTXC IN
C   COMMON /CVCEX/ IS TRUE AND A SMEARING DATE BEFORE 1984 IS REQUESTED,
C   OR VICE VERSA, A WARNING IS PRINTED OUT.
C
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cadmin.for"
C
      COMMON /TODAY/ HDATE(6)
C
      LOGICAL  LVTXC
      COMMON / CVCEX  / LVTXC
C
      COMMON / BCS / IW(1)
C
      DIMENSION  HW(1)
      DIMENSION  IDATE(6)
      EQUIVALENCE ( HW(1), IW(1) )
C
      DATA IERPRI /0/
C
C------------------  C O D E  -----------------------------------------
C
      NPHEAD = IW( IBLN('HEAD') )
      IF( NPHEAD .LE. 0 ) RETURN
      NFLAGS(1) = NFLAGS(1) + 1
C
C                            HAS THE DATE IN COMMON /TODAY/ CHANGED
C                            FROM THE DEFAULT DATE OF 17TH MAY 1985?
C                            IF SO, CHOOSE THIS DATE AS THE SMEARING
C                            DATE.
C
      IF( HDATE(4) .NE.   17    .OR.
     +    HDATE(5) .NE.    5    .OR.
     +    HDATE(6) .NE. 1985           ) GO TO 30
C
C
C                            OTHERWISE SET THE JETC SMEARING DATE TO BE
C                            THE SAME AS THE TRACKING DATE
C                            AS RECORDED IN THE 'HEAD' BANK.
C
        IDAY   = HW(NPHEAD*2+96)
        IMONTH = HW(NPHEAD*2+97)
        IYEAR  = HW(NPHEAD*2+98)
C
        IF( NFLAGS(1) .LE. 1 ) WRITE(6,10)
C
  10    FORMAT(/' ****  N E W   F E A T U R E    17/12/87  '/
     +          ' ****  RDDATE HAS SET THE JETC SMEARING DATE TO '/
     +          ' ****  AGREE WITH THE TRACKING CONFIGURATION DATE'/
     +          ' ****  SINCE COMMON /TODAY/ HAS NOT BEEN ALTERED')
C
        GO TO 50
C
C                            SET SMEARING DATE ACCORDING TO /TODAY/
C
  30    IDAY   = HDATE(4)
        IMONTH = HDATE(5)
        IYEAR  = HDATE(6)
C
        IF( NFLAGS(1) .LE. 1 ) WRITE(6,40) (HW(NPHEAD*2+I),I=96,98)
C
  40    FORMAT(/' ++++  N E W   F E A T U R E    17/12/87  '/
     +          ' ++++  RDDATE HAS SET THE JETC SMEARING DATE'/
     +          ' ++++  ACCORDING TO THE REQUESTED DATE IN'/
     +          ' ++++  COMMON /TODAY/ SINCE IT HAS BEEN ALTERED.'/
     +          ' ++++  N.B. THE TRACKING CONFIGURATION DATE IS ',3I8)
C
C                            COPY SMEARING DATE INTO HEAD BANK
C                            AFTER CHECKING THAT IT IS REASONABLE!
C
  50  IF( IYEAR .GT.  100 ) GO TO 52
        IYEAR0 = IYEAR
        IYEAR  = 1900 + IYEAR0
        IF( NFLAGS(1) .LE. 1 ) WRITE(6,51) IYEAR0, IYEAR
  51    FORMAT(/' --->  THE YEAR FOR SMEARING WAS ',I5,' !',
     +          '  THIS HAS BEEN CHANGED TO ',I5/)
C
  52  IDATE(1) = 0
      IDATE(2) = 0
      IDATE(3) = 0
      IDATE(4) = IDAY
      IDATE(5) = IMONTH
      IDATE(6) = IYEAR
C
      ISECS = KTMCON( IDATE, NOW, -1 )
      IF( ISECS .NE. -1 ) GO TO 55
        IDAY   =   17
        IMONTH =    5
        IYEAR  = 1985
        IF( NFLAGS(1) .LE. 1 ) WRITE(6,54)
  54    FORMAT(/' --->  ILLEGAL SMEARING DATE!  SUBSTITUTE DATE USED!'/)
C
C
  55  HW(NPHEAD*2+6) = IDAY
      HW(NPHEAD*2+7) = IMONTH
      HW(NPHEAD*2+8) = IYEAR
C
      IF( NFLAGS(1) .LE. 1 ) WRITE(6,56) (HW(NPHEAD*2+I),I=6,8)
  56  FORMAT(/' --->  SMEARING DATE (DAY, MONTH, YEAR) IS :',3I8/)
C
C
C                            CHECK VALIDITY OF THIS DATE AND THE VTXC
C                            STATUS. VTXC ADDED IN MAY 1984.
C
      IF(IERPRI.GT.10) RETURN
C
      IF( .NOT. ( LVTXC  .AND.  (
     +              ( IYEAR .LT. 1984  )  .OR.
     +              ( IYEAR .EQ. 1984  .AND.  IMONTH .LT. 5 ) ) )
     +                                                    ) GO TO 60
        IERPRI = IERPRI + 1
        WRITE(6,58)
  58    FORMAT(/' # # #  MISMATCH:  EVENT HAS VERTEX CHAMBER',
     +          ' GEOMETRY AND SMEARING DATE < MAY 1984   # # # #')
C
C
  60  IF( .NOT. ( .NOT. LVTXC  .AND.  (
     +              ( IYEAR .GT. 1984  )  .OR.
     +              ( IYEAR .EQ. 1984  .AND.  IMONTH .GT. 4 ) ) )
     +                                                    ) RETURN
        IERPRI = IERPRI + 1
        WRITE(6,65)
  65    FORMAT(/' # # #  MISMATCH:  EVENT HAS NO VERTEX CHAMBER',
     +          ' GEOMETRY BUT SMEARING DATE > APRIL 1984   # # # #')
C
      RETURN
      END

C   15/03/80 003281450  MEMBER NAME  MUREGY   (JADEMUS)     FORTRAN
C=======================<< MUREGY >>====================================
C THIS ROUTINE FINDS WHICH REGIONS OF THE MUON FILTER LIE ALONG
C A GIVEN STRAIGHT LINE AND CALCULATES THE INTERCEPTS OF THE LINE
C WITH THE PLANES BOUNDING THE REGIONS.
C=======================================================================
C  HARRISON B. PROSPER   APRIL 1979    J A D E
C=======================================================================
C
C
C
C
C
C====================<< I N T E R C E P T S >>==========================
C
C  THE EQUATION OF A PLANE CAN BE WRITTEN AS   L1.X = P  WHERE P IS THE
C  PERPENDICULAR DISTANCE OF THE PLANE FROM THE ORIGIN,AND X = (X,Y,Z)
C  IS ANY POINT IN THE PLANE. L1 = (L1,M1,N1) IS THE DIRECTION COSINE
C  VECTOR OF THE NORMAL TO THE GIVEN PLANE.
C
C  THE EQUATION OF A LINE CAN BE WRITTEN AS  R = R2 + A*L2
C
C  WHERE  L2=(L2,M2,N2) , R2=(X2,Y2,Z2) (A GIVEN POINT ON THE LINE),AND
C
C  R=(X,Y,Z) IS ANY POINT ON THE LINE.
C
C  LET T = ( P - L1.R2 )/( L1.L2)    ( HERE SCALAR PRODUCT IS IMPLIED)
C
C  LET W = (X3,Y3,Z3)  BE THE RADIUS VECTOR OF THE INTERSECTION OF THE
C
C  LINE WITH THE PLANE. W IS GIVEN BY:
C                    -----------------
C
C                      W = T*L2 + R2
C
C                    -----------------
C
C T IS THE DISTANCE OF A POINT (ALONG THE LINE) FROM THE GIVEN POINT
C
C=======================================================================
C
C
C
C
C
C===================<< I N F O R M A T I O N >>=========================
C
C        BELOW (1,2,3)=(X,Y,Z)
C
C        DCS(1) = X2
C        DCS(2) = Y2    POINT ON LINE ( E.G. 'FIRST' POINT )
C        DCS(3) = Z2
C
C        DCS(4) = L2
C        DCS(5) = M2    DIRECTION COSINES OF LINE
C        DCS(6) = N2
C
C        A REGION 'I' IS DEFINED BY THE BOUNDARIES OF A RECTANGULAR
C        PRISM. XRLO(I),XRHI(I),...ETC. ARE THE LOWER AND UPPER
C        LIMITS RESPECTIVELY.
C
C   B)   HRTYPE(I) INDICATES THE NATURE OF THE REGION.I.E:
C
C        1...MUON CHAMBERS
C
C        2...CONCRETE REGION
C
C        3...IRON REGION
C
C
C   C)   HRORI(I) (=1,2,OR,3) GIVES THE DIRECTION OF THE PRINCIPAL
C        NORMAL TO THE REGION (I.E. THE NORMAL TO THE LARGEST FACE)
C   D)   NFLAG(J) (J=1,N) GIVES THE ORIGINAL POSITION OF THE  J TH
C        ELEMENT IN THE ORDERED LIST
C   E)   N IS THE TOTAL NUMBER OF INTERCEPTS
C
C NOTE:  MUREGS OUTPUTS THE SMALLEST ELEMENT FIRST
C
C
C   F)   IF N1 = 0  MUREGY WILL CONSIDER   A L L   REGIONS
C         ( N1 = 1  FOR CHAMBER REGIONS   O N L Y  )
C         ( N1 = 2  FOR CONCRETE REGIONS  O N L Y  )
C         ( N1 = 3  FOR IRON   REGIONS    O N L Y  )
C
C   G)   IF N2 = 0  MUREGY WILL FIND REGIONS IN BOTH DIRECTIONS
C        IF N2 = 1  MUREGY WILL FIND REGIONS WHOSE ENTRY FACES LIE
C                   AHEAD OF THE GIVEN POINT
C        IF N2 = 2  MUREGY WILL FIND REGIONS WHOSE EXIT FACES LIE
C                   AHEAD OF THE GIVEN POINT
C
C
C=====<< ERROR  CODES >>================================================
C
C   H) 1) NER = -1 IF ALL OK
C      2) NER =  0 IF DIRECTION COSINES ARE INVALID
C      3) NER =  1 IF TRACK IS OUTSIDE DETECTOR
C      4) NER =  2 IF NO REGIONS INTERCEPTED ( BUT TRACK NONTHELESS
C                  PASSES THROUGH THE DETECTOR )
C      5) NER =  3 IF THE INPUTTED MASK IS INVALID
C=======================================================================
C     FOR A DESCRIPTION OF HMASK PLEASE SEE MUREGM( ON CALIB.S)
C=======================================================================
      SUBROUTINE MUREGY(N1,N2,NER,DCS,HMASK,N)
      IMPLICIT INTEGER*2 (H)
      DIMENSION DCS(6),TH(3),TL(3),T(100,2,3)
#include "cmtemp.for"
#include "cmureg.for"
      EQUIVALENCE(T(1,1,1),XRLO(1))
C=======================================================================
              MER = 0
                N = 0
              NER = 0
C=======================================================================
C==STEP 1 =========== CHECK DIRECTION COSINES ==========================
C=======================================================================
      IF(ABS(DCS(4)).GT.1.01)                    GOTO 97
      IF(ABS(DCS(5)).GT.1.01)                    GOTO 97
      IF(ABS(DCS(6)).GT.1.01)                    GOTO 97
      SUM = ABS(DCS(4)) + ABS(DCS(5)) + ABS(DCS(6))
      IF(SUM.LT.0.99.OR.SUM.GT.1.75)             GOTO 97
C=======================================================================
C
C
C=======================================================================
C==STEP 2 ==== CHECK IF TRACK PASSES THROUGH THE DETECTOR ==============
C=======================================================================
      DO 81 K = 1,3
      GOTO(76,77,78),K
  76  CONTINUE
      L1 = 5
      L2 = 10
      GOTO 79
  77  CONTINUE
      L1 = 16
      L2 = 32
      GOTO 79
  78  CONTINUE
      L1 = 40
      L2 = 48
  79  CONTINUE
      IF(ABS(DCS(K+3)).LT.1.E-07)      GOTO 80
           T1 = ( T(L1,1,K) - DCS(K) )/DCS(K+3)
           T2 = ( T(L2,2,K) - DCS(K) )/DCS(K+3)
        TH(K) = AMAX1( T1,T2 )
        TL(K) = AMIN1( T1,T2 )
                                       GOTO 81
  80  CONTINUE
      IF(DCS(K).LT.T(L1,1,K).OR.DCS(K).GT.T(L2,2,K)) GOTO 84
        TH(K) = 1.E07
        TL(K) =-1.E07
  81  CONTINUE
C
                   KH = 1
                   KL = 1
                   SL = TL(1)
                   SH = TH(1)
      DO 83 J=2,3
                   IF(TL(J).LE.SL)     GOTO 82
                   KL = J
                   SL = TL(J)
  82  CONTINUE
                   IF(TH(J).GE.SH)     GOTO 83
                   KH = J
                   SH = TH(J)
  83  CONTINUE
                   IF(TL(KL).LT.TH(KH))GOTO 85
  84  CONTINUE
                   NER = 1
                                       GOTO 97
C=======================================================================
C.....STEP 3
C           LOOP OVER ALL REGIONS
C           AND WHERE APPROPRIATE CALCULATE INTERCEPTS
  85  CONTINUE
       DO 93 I = 1,NREGS
C
C PERFORM A BIT BY BIT .AND. OF THE CORRESPONDING BITS OF HRMASK(I) &
C HMASK,AND THEN .OR. THE RESULT. IF THE 'TRUTH' VALUE IS 0 THEN IGNORE
C THIS REGION (SINCE IT DOES NOT BELONG TO A FACE SPECIFIED BY THE MASK)
C
      IF(LAND(HRMASK(I),HMASK).NE.0)  GOTO 86
C**** HARRY , WAS THIS INTENDED ?---> GOTO 86   **********
C.... ERROR CODE (3)
      MER = MER + 1
                                      GOTO 93
C IF N1.EQ.0 THEN  REGIONS OF ALL TYPES ARE TO BE LOOPED OVER
C
  86  CONTINUE
      IF(N1.EQ.0)                     GOTO 87
C
C IF N1.NE.0 IT MAY BE EQUAL TO (1,2,3,OR 4) IN WHICH CASE CONSIDER
C ONLY THE APPROPRIATE REGION
C
      JTYPE = HRTYPE(I)
      IF(JTYPE.NE.N1)                 GOTO 93
  87  CONTINUE
C
C
C=======================================================================
C=========== C A L C U L A T E       I N T E R C E P T S===============
C=======================================================================
C CALCULATE THE DISTANCES FROM THE GIVEN POINT ON THE LINE TO THE POINTS
C OF INTERSECTION OF THE LINE WITH THE 6 PLANES BOUNDING THE REGION.
C FOR EACH PAIR OF PLANES DETERMINE WHICH INTERCEPT IS THE GREATER AND
C WHICH THE SMALLER.CALL THE GREATER ONE TH(K) I.E. AN EXIT POINT,
C AND THE SMALLER TL(K) I.E. AN ENTRY POINT.
C
      DO 89 K = 1,3
      IF(ABS(DCS(K+3)).LT.1.E-07)      GOTO 88
           T1 = ( T(I,1,K) - DCS(K) )/DCS(K+3)
           T2 = ( T(I,2,K) - DCS(K) )/DCS(K+3)
        TH(K) = AMAX1( T1,T2 )
        TL(K) = AMIN1( T1,T2 )
                                       GOTO 89
  88  CONTINUE
      IF(DCS(K).LT.T(I,1,K).OR.DCS(K).GT.T(I,2,K)) GOTO 93
        TH(K) = 1.E07
        TL(K) =-1.E07
  89  CONTINUE
C=======================================================================
C====== DETERMINE   'E N T R Y'   AND   'E X I T'    P O I N T S =======
C=======================================================================
C FIND THE MINIMUM OF THE THREE TH(K)'S AND THE MAXIMUM OF THE THREE
C TL(K)'S.THE ENTRY POINT FURTHEST AWAY FROM THE GIVEN POINT ON THE LINE
C IS POTENTIALLY THE ENTRY POINT INTO THE REGION.THE EXIT POINT NEAREST
C THE GIVEN POINT ON THE LINE IS POTENTIALLY THE EXIT POINT OUT OF THE
C REGION.
                   KH = 1
                   KL = 1
                   SL = TL(1)
                   SH = TH(1)
      DO 91 J=2,3
                   IF(TL(J).LE.SL) GOTO 90
                   KL = J
                   SL = TL(J)
  90  CONTINUE
                   IF(TH(J).GE.SH) GOTO 91
                   KH = J
                   SH = TH(J)
  91  CONTINUE
C=======================================================================
C============== TEST IF LINE PASSES THRU' REGION =======================
C=======================================================================
C  IF THE DISTANCE FROM THE GIVEN POINT ON THE LINE TO THE POTENTIAL
C  ENTRY POINT IS GREATER THAN THAT OF THE POTENTIAL EXIT POINT THEN THE
C  LINE FAILS TO INTERCEPT THE CURRENT REGION.(THIS IS NOTHING MORE THAN
C  THE TOPOLOGICAL REQUIREMENT THAT TO GET OUT OF A REGION WITH AN
C  INTERIOR DISCONECTED FROM THE EXTERIOR ONE MUST HAVE AT SOME STAGE
C  ENTERED THROUGH THE BOUNDARY.NOTE ALSO THAT A CONVEX REGION (ROUGHLY
C  SPEAKING ONE WITHOUT DIMPLES) HAS ONLY ONE ENTRY POINT AND ALSO ONLY
C  ONE EXIT POINT.
      IF(TL(KL).GT.TH(KH)) GOTO 93
C.....IF N2.EQ.0 FIND REGIONS IN BOTH DIRECTIONS
      IF(N2.EQ.0)          GOTO 92
C.....IF N2.EQ.2 FIND REGIONS WHOSE EXIT FACES LIE AHEAD
C.....OF THE GIVEN POINT ON THE LINE
      IF(TH(KH).LT.0.0.AND.N2.EQ.2)    GOTO 93
C
C.....IF N2.EQ.1 FIND REGIONS WHOSE ENTRY FACES LIE AHEAD
C.....OF THE GIVEN POINT ON THE LINE
      IF(TL(KL).LT.0.0.AND.N2.EQ.1)    GOTO 93
C=======================================================================
C     ACCUMULATE  RESULTS IN OUTPUT ARRAYS
  92  CONTINUE
             N = N + 1
      RDOTD(N) = TL(KL)
       ITEM(N) = I
             N = N + 1
      RDOTD(N) = TH(KH)
       ITEM(N) = I
  93  CONTINUE
C=======================================================================
      IF(N.LT.1) GOTO 96
C=======================================================================
C==STEP 4 ============== ORDER THE INTERCEPTS ==========================
C=======================================================================
      CALL MUREGS(RDOTD,N,NFLAG)
      DO 95 K=1,N
      DO 94 L=1,3
      CINT(L,K) = RDOTD(K)*DCS(L+3) + DCS(L)
  94  CONTINUE
      IREG(K) = ITEM(NFLAG(K))
  95  CONTINUE
C=======================================================================
C     SET ERROR   CODES
      NER =-1
      GOTO 97
  96  CONTINUE
      NER = 2
      IF(MER.EQ.NREGS)    NER = 3
C=======================================================================
  97  CONTINUE
      RETURN
      END

C   18/01/82            MEMBER NAME  MCTRCO   (JADEGS)      FORTRAN
C   15/12/81 112161224  MEMBER NAME  MCTRCO   (JADESR)      FORTRAN
      SUBROUTINE MCTRCO(IPTR1,IPPATR,JPTR2,CHSQTR)
C
C     FIND TRACK IN PATR(10) CORRESP. TO MC-TRACK (IPTR1) IN PATR(12)
C     IPTR1  : POINTER TO TRACK IN PATR(12)-BANK
C     IPPATR : POINTER TO PATR(10)-BANK
C     JPTR2  : POINTER TO FOUND TRACK IN PATR(10)-BANK
C              = 0 : NO TRACK FOUND
C     CHSQTR : ARRAY WITH RESULTS
C
C     TRACK IS SEARCHED FOR BY COMPARING POSITION + DIRECTION OF
C     FIRST + LAST POINT OF TRACKS
C     CHI**2 = 1/4 * ( (DXY/.40)**2 + (DFI/.010)**2    : FIRST POINT
C                    + (DXY/.40)**2 + (DFI/.010)**2 )  : LAST  POINT
C     CHSQTR(1)  : CHI**2
C     CHSQTR(2)  : DXY(FIRST POINT ON TRACK)
C     CHSQTR(3)  : DXY(LAST  POINT ON TRACK)
C     CHSQTR(4)  : DFI(FIRST POINT ON TRACK)
C     CHSQTR(5)  : DFI(LAST  POINT ON TRACK)
C     P. STEFFEN  16.12.81
C
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION CHSQTR(5)
C
#include "cdata.for"
C
      DATA LBPRFT /1/
C
C2001 FORMAT(' MCTRCO     :',I6,2F8.1,2F8.3,F10.6,3F10.1)
C2002 FORMAT(' MCTRCO     :',2I3,I6,6F6.1,3F8.5,2F8.1)
C2000 FORMAT(1H0,'EVENT =',3I6,,F8.1)
C
C                                       INITIALIZATION
      DATA LBINIT /0/
      IF(LBINIT.NE.0) GOTO 100
        LBINIT = 1
        NPR = 0
        IQHEAD = IBLN('HEAD')
C
  100 CONTINUE
      NPR = NPR + 1
C
      CHSQTR(1) = 9999999.
      JPTR2  = 0
C
C                                       CURVATURE + RADIUS OF TRACK
C                                       INNER POINT + DIRECTION
C     CALL CHECK( 1)
      X1    = ADATA(IPTR1+ 5)
      Y1    = ADATA(IPTR1+ 6)
      DX1   = ADATA(IPTR1+ 8)
      DY1   = ADATA(IPTR1+ 9)
      ANR1  = SQRT(DX1**2 + DY1**2)
      DX1   = DX1 / ANR1
      DY1   = DY1 / ANR1
C     CALL CHECK( 2)
      CRV1  = ADATA(IPTR1+27)
      IF(ABS(CRV1).LT.1.E-6) CRV1 = SIGN(1.E-6,CRV1)
C                                       CIRCLE EXTRAPOLATION
      RCI   = 1. / CRV1
C     CALL CHECK( 3)
      XCI   = DY1*RCI + X1
      YCI   =-DX1*RCI + Y1
      RCI   = ABS(RCI)
C     IF(NPR.LE.5) PRINT 2001, IPTR1,X1,Y1,DX1,DY1,CRV1,RCI,XCI,YCI
C
C                                       CURVATURE + RADIUS OF TRACK
C                                       OUTER POINT + DIRECTION
      X1    = ADATA(IPTR1+12)
      Y1    = ADATA(IPTR1+13)
      DX1   = ADATA(IPTR1+15)
      DY1   = ADATA(IPTR1+16)
      ANR1  = SQRT(DX1**2 + DY1**2)
C
C
C                                       CHECK IF DIR. AT OUTER POINT
      IF(ANR1.LE..01) RETURN
C
      DX1   = DX1 / ANR1
      DY1   = DY1 / ANR1
C     CALL CHECK( 4)
      CRV1  = ADATA(IPTR1+28)
      IF(ABS(CRV1).LT.1.E-6) CRV1 = SIGN(1.E-6,CRV1)
C                                       CIRCLE EXTRAPOLATION
C     CALL CHECK( 5)
      RCO   = 1. / CRV1
      XCO   = DY1*RCO + X1
      YCO   =-DX1*RCO + Y1
      RCO   = ABS(RCO)
C     IF(NPR.LE.5) PRINT 2001, IPTR1,X1,Y1,DX1,DY1,CRV1,RCO,XCO,YCO
C
C                                       POINTER TO TRACKS IN PATR(10)
      IPTR0  = IDATA(IPPATR+1) + IPPATR
      LDTR   = IDATA(IPPATR+3)
      NTR    = IDATA(IPPATR+2)
C
      IF(NTR.LE.0) RETURN
C
C                                       LOOP OVER ALL TRACKS
C     IF(RC1.LT.1. .OR. RCO.LT.1.) CALL PRPATR
      CHISQ     = 9999999.
      IPTR2 = IPTR0
      DO 200 ITR2=1,NTR
C                                       DIST. OF 1. + LAST POINTCS CSTH200010600
        X2I   = ADATA(IPTR2+ 5)
        Y2I   = ADATA(IPTR2+ 6)
C     CALL CHECK( 6)
        DRI   = ( ( (X2I-XCI)**2+(Y2I-YCI)**2 ) / RCI - RCI) *.5
C     CALL CHECK( 7)
        X2O   = ADATA(IPTR2+12)
        Y2O   = ADATA(IPTR2+13)
        DRO   = ( ( (X2O-XCO)**2+(Y2O-YCO)**2 ) / RCO - RCO) *.5
C     CALL CHECK( 8)
C                                      CHECK IF SAME HEMISPHERE
        DX2I  = ADATA(IPTR2+ 8)
        DY2I  = ADATA(IPTR2+ 9)
        DALF1 = DX1*DX2I + DY1*DY2I
        IF(DALF1 .LT. 0.) GOTO 198
C                                      ANGLE AT INNER POINT
        DX    = X2I - XCI
        DY    = Y2I - YCI
        RRI   = SQRT((DX**2+DY**2) * (DX2I**2+DY2I**2))
        DALFI = ABS(DX*DX2I + DY*DY2I) / RRI
C       IF(RRI.LT.1.) CALL PRPATR
C     CALL CHECK( 9)
C                                      ANGLE AT OUTER POINT
        DX2O  = ADATA(IPTR2+15)
        DY2O  = ADATA(IPTR2+16)
        DX    = X2O - XCO
        DY    = Y2O - YCO
        RRO   = SQRT((DX**2+DY**2) * (DX2O**2+DY2O**2))
        DALFO = ABS(DX*DX2O + DY*DY2O) / RRO
C       IF(RRO.LT.1.) CALL PRPATR
C     CALL CHECK(10)
C                                      CALCULATE CHI**2
        CH    =(DRI/.40)**2+(DRO/.40)**2+(DALFI/.010)**2+(DALFO/.010)**200013800
C     IF(NPR.LE.5) PRINT 2002, ITR2,NAGR,IPTR2,
C    ,     X2I,Y2I,X2O,Y2O,DRI,DRO,DALFI,DALFO,DALF1,CH,CHISQ
        IF(CH.GT.CHISQ) GOTO 198
C                                      SAVE VALUES + TRACK
           CHISQ  = CH
           DRIS   = DRI
           DALFIS = DALFI
           DROS   = DRO
           DALFOS = DALFO
           IPTR2S = IPTR2
C
  198   CONTINUE
C     CALL CHECK(11)
        IPTR2 = IPTR2 + LDTR
  200 CONTINUE
C
      CHISQ  = CHISQ / 4.
      CHSQTR(1) = CHISQ
      CHSQTR(2) = DRIS
      CHSQTR(3) = DROS
      CHSQTR(4) = DALFIS
      CHSQTR(5) = DALFOS
      IF(CHISQ.LT.9999.) JPTR2 = IPTR2S
C
  300 CONTINUE
        IPHEAD = IDATA(IQHEAD)*2
        HRUN   = HDATA(IPHEAD+10)
        HEV    = HDATA(IPHEAD+11)
C       IF(CHISQ.GT.9.) PRINT 2000, HRUN,HEV,JPTR2S,CHISQ
C
      RETURN
C
      END

C   27/07/87 710121527  MEMBER NAME  TPRFTR   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPRFTR
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      27/07/87:  Refit central detector tracks
C
C
C
C     Routine to refit central detector tracks (if wanted) and to
C     perform the last stage of traceback for MC events if relevant.
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

C------------------  C O D E  ------------------------------------------

C                            Do R-Phi refitting as required

      CALL TPRPHI

C                            Do R-Z refitting as required

      CALL TPZSFT

C                            Perform traceback if Monte Carlo events

      CALL TPTRCB

      RETURN
      END

C   16/08/85 508301807  MEMBER NAME  TAGINT   (S)           FORTRAN
C   12/03/84 412041843  MEMBER NAME  TAGINT   (S)           FORTRAN
C
C
C
C
C
C------  T A G I N T  ------  T A G I N T  ------  T A G I N T  ------
C
C------  T A G I N T  ------  T A G I N T  ------  T A G I N T  ------
C
C------  T A G I N T  ------  T A G I N T  ------  T A G I N T  ------
C
C
C
C
      SUBROUTINE TAGINT(*)
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C         THIS IS THE INITIALISATION ROUTINE THAT SHOULD BE CALLED
C      ONCE BEFORE ANALYZING ANY EVENTS USING THE TAGGING ROUTINES.
C      TO BE PRECISE IT MUST BE CALLED ONCE PER EVENT TO SET UP
C      THE CWORK COMMON AND TO CLEAR OTHER TAGG COMMONS ETC.
C
C      IT DOES A RETURN 1 IF TAGMRK DOES A RETURN 1 ,WHICH IT DOES
C      IF THE 'HEAD' BANK IS MISSING
C
C      MOD : 13/03/84  A.J.FINCH   NO MESSAGES WRITTEN IF  GRAPHICS
C                                     PACKAGE CALLED THIS ROUTINE
C      MOD : 18/06/84  J. NYE      USES IFLMRK --- SEE TAGMRK
C      MOD : 22/06/84  J. NYE      NO OUTPUT
C LAST MOD : A.J.FINCH 16/08/85 INCLUDED SETTING OF ISTMZ ETC., FOR
C                                     GRAPHICS PROGRAM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
C
C-----------------------------------------------------------------------
C
C
C
        DIMENSION IDUM(380)
        EQUIVALENCE (IDUM(1),MARK    )
C
        COMMON / CACLS  /  IACLS( 70)
C
        COMMON / CTAGG0 / ITAGG0( 34)
C
        COMMON / CTAGG1 / ITAGG1( 20)
C
        COMMON / CTAGG2 / ITAGG2(260)
C
C
C
C
C------------------------ C O D E --------------------------------------
C
C
C
C
C---                                     CLEAR ARRAYS
C
C
       CALL VZERO(   IDUM , 380)
       CALL VZERO(  IACLS ,  70)
       CALL VZERO( ITAGG0 ,  34)
       CALL VZERO( ITAGG1 ,  20)
       CALL VZERO( ITAGG2 , 260)
C
C
C---                                     INITIALIZE OTHER VARIABLES
C
C
       NCLST  = 0
       NNEI   = 0
       ISTMZ  = 0
       ISTPZ  = 0
       IENDMZ = 0
       IENDPZ = 0
C
C
C---                                     DECIDE ON DETECTOR MARK
C
C
C   CALL TAGMRK TO CHOOSE 'MARK'
C
C
      CALL TAGMRK(*100)
C
C
C---                                     CREATE NEIGHBOUR LIST IF
C---                                     FIRST EVENT
C
C
C   TAGNEB  GENERATES THE NEIGHBOUR LIST
C   IT NEED ONLY BE CALLED ONCE PER JOB
C   FLAG  LISTOK = 1 AFTERWARDS
C
       IF ( LISTOK .NE. 1 ) CALL TAGNEB
C
C
C---                                     SET UP 'MARK' DEPENDENT VALUES
C
C
C
       IF ( MARK .EQ. 0 ) GOTO 10
       IF ( MARK .EQ. 1 ) GOTO 1
       IF ( MARK .EQ. 2 ) GOTO 2
       WRITE(6,6999)MARK
6999   FORMAT('  TAGINT: ILLEGAL VALUE OF MARK: ',I10,/,
     1'                   SHOULD BE 0,1 OR 2 ')
      RETURN
C
C
C----------------------------------------MARK = 0  1979/80 DATA
C
C
   10  CONTINUE
       ISTMZ     =  1
       ISTPZ     = 97
       IENDMZ    = 96
       IENDPZ    = 192
C
       RETURN
C
C
C----------------------------------------MARK = 1  1981/82 DATA
C
C
    1  CONTINUE
       ISTMZ     =  1
       ISTPZ     = 33
       IENDMZ    = 32
       IENDPZ    = 64
C
       RETURN
C
C
C----------------------------------------MARK = 2  1983 -> DATA
C
C
    2  CONTINUE
       ISTMZ     =  1
       ISTPZ     = 25
       IENDMZ    = 24
       IENDPZ    = 48
C
       RETURN
C
C
C----------------------------------------R E T U R N   1----------------
C
C
C---                                     HERE IF TAGMRK DID RETURN 1
C
C
  100  RETURN 1
       END

C   19/10/79 411291542  MEMBER NAME  TOFRPR5  (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFRPR
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "tcalcm.for"
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      INTEGER *2 HDATA
      COMMON/BCS/IDATA(1)
      DIMENSION DATA(1),HDATA(2)
      EQUIVALENCE(IDATA(1),DATA(1)),(HDATA(1),IDATA(1))
      DIMENSION RTOF(14,50),ITOF(14,50)
      EQUIVALENCE (RTOF(1,1),ITOF(1,1))
C
      DATA CVEL/ 2.9979246E2/ ,RADTOF/920./
      DATA IBUG/ 0/
      DATA IENTRY/0/
      IF(IENTRY.NE.0)  GOTO  800
      IENTRY = 1
  800 CONTINUE
C
C
   34 IBUG = IBUG + 1
      IF(IBUG.LE.50) PRINT 300,IBUG,NRUN,NEV,IEV
  300 FORMAT(//'  NEW EVENT ',I8,' RUN...',3I10)

      IPTOFR = IDATA(IBLN('TOFR'))
C
   32 NTR = IDATA(IPTOFR+1)
C     IF(NTR.LE.0) GOTO  60
      PRINT 400 ,NTR
  400 FORMAT(' TOFR BANK        ',I10,'  TRACKS'/)
C
      DO   40  N=1,NTR
      DO   41  I=1,14
      RTOF(I,N) = DATA(IPTOFR+4+(N-1)*14+I)
   41 CONTINUE
      PRINT 401,N,ITOF(1,N),ITOF(2,N),ITOF(3,N),
     1                        (RTOF(KK,N),KK=4,11),RTOF(13,N)
  401 FORMAT(1X,4I3,F6.2,5F6.0,2F6.2,F8.4)
   40 CONTINUE
C
      RETURN
       END

C   14/05/80 309241511  MEMBER NAME  DSFADC   (JADEGS)      FORTRAN
      SUBROUTINE DSFADC
      IMPLICIT INTEGER*2 (H)
C
C         SHOW FLASH ADC HISTOGRAMS FROM BANK FADC.   TEST FEATURE
C                              J.OLSSON 25.11.81
C                          LAST CHANGE 25.11.81
C
#include "cgraph.for"
#include "cdata.for"
      COMMON /CWORK1/ HMW(112)

*** PMF 17/11/99: add variables needed for emulation of DESYLIB routine 'CORE'  
      CHARACTER cHMW*224
      EQUIVALENCE (cHMW,HMW(1))
*** PMF(end)
C--
      CALL ERASE
      CALL TWINDO(0,4095,0,4095)
      XMINRE = XMIN
      XMAXRE = XMAX
      YMINRE = YMIN
      YMAXRE = YMAX
      XMIN = -40.
      YMIN = -10.
      XMAX = 80.
      YMAX = 110.
      CALL DWINDO(XMIN,XMAX,YMIN,YMAX)
C  DRAW DIAGRAM FRAME
      CALL MOVEA(0.,0.)
      CALL DRAWA(64.,0.)
      CALL DRAWA(64.,64.)
      CALL DRAWA(0.,64.)
      CALL DRAWA(0.,0.)
      CALL MOVEA(0.,48.)
      CALL DRAWA(64.,48.)
      CALL MOVEA(0.,32.)
      CALL DRAWA(64.,32.)
      CALL MOVEA(0.,16.)
      CALL DRAWA(64.,16.)
C  WRITE HORIZONTAL SCALE     0  32  64  96  128
      DX = 16.
      XLX = -3. - DX
      XLY = -3.
      LIT = 32
      ITX = -LIT
      CALL CHRSIZ(3)
      DO 242  I = 1,5
      XLX = XLX + DX
      ITX = ITX + LIT
      CALL MOVEA(XLX,XLY)
      CALL CORE(HMW,4)
      WRITE(cHMW,241) ITX ! PMF 17/11/99: JUSCRN changed to cHMW
241   FORMAT(' ',I3)
      CALL EOUTST(4,HMW)
242   CONTINUE
      CALL MOVEA(50.,-5.)
      CALL CORE(HMW,5)
      WRITE(cHMW,271) ! PMF 17/11/99: JUSCRN changed to cHMW
271   FORMAT(' TIME')
      CALL EOUTST(5,HMW)
C--
C  WRITE VERTICAL SCALE     0  32  0  32   0  32    0  32  64
      DY = 8.
      XLX = -4.
      XLY = -DY - .5
      LIT = 32
      ITX = - LIT
      DO 244  I = 1,9
      XLY = XLY + DY
      ITX = ITX + LIT
      IF(ITX.EQ.2*LIT.AND.I.LT.9) ITX = 0
      CALL MOVEA(XLX,XLY)
      CALL CORE(HMW,3)
      WRITE(cHMW,243) ITX ! PMF 17/11/99: JUSCRN changed to cHMW
243   FORMAT(' ',I2)
      CALL EOUTST(3,HMW)
244   CONTINUE
      CALL MOVEA(-11.,53.)
      CALL CORE(HMW,6)
      WRITE(cHMW,272) ! PMF 17/11/99: JUSCRN changed to cHMW
272   FORMAT(' PULSE')
      CALL EOUTST(6,HMW)
      CALL MOVEA(-11.,50.5)
      CALL CORE(HMW,7)
      WRITE(cHMW,273) ! PMF 17/11/99: JUSCRN changed to cHMW
273   FORMAT(' HEIGHT')
      CALL EOUTST(7,HMW)
C--
C  WRITE HORIZONTAL TIC MARKS
      DX = 1.
      DY = .25
      DYB = .55
      DO 253  KK = 1,4
      XLX = 0.
      YYY = 0. + (KK-1)*16.
      DO 252  I = 1,64
      DDYY = DY
      IF((I/8)*8.EQ.I) DDYY = DYB
      XLX = XLX + DX
      XLY = YYY-DDYY
      IF(KK.EQ.1) XLY = YYY
      YUPP = XLY+DDYY
      IF(KK.NE.1) YUPP = YUPP + DDYY
      CALL MOVEA(XLX,XLY)
      CALL DRAWA(XLX,YUPP)
252   CONTINUE
253   CONTINUE
C--
C  WRITE VERTICAL TIC MARKS
      DY = 1.
      DX = .25
      DXB = .55
      XLX = 0.
      DO 263  KK = 1,4
      XLX = 0.
      XLY = 0. + (KK-1)*16.
      DO 262  I = 1,16
      DDXX = DX
      IF((I/4)*4.EQ.I) DDXX = DXB
      XLY = XLY + DY
      CALL MOVEA(XLX,XLY)
      CALL DRAWA(XLX+DDXX,XLY)
262   CONTINUE
263   CONTINUE
C--
C--
      CALL MOVEA(0.,-10.)
      CALL CHRSIZ(2)
      CALL CORE(HMW,34)
      WRITE(cHMW,3209) ! PMF 17/11/99: JUSCRN changed to cHMW
3209  FORMAT(' F L A S H   A D C   D I S P L A Y')
      CALL EOUTST(34,HMW)
      CALL CHRSIZ(4)
C
C     DISPLAY HISTOGRAMS
C
      IPFADC = IDATA(IBLN('FADC'))
      IF(IPFADC.GT.0) GO TO 1606
      WRITE(6,1607)
1607  FORMAT('   NO FADC BANK IN THIS EVENT ..')
      GO TO 3200
1606  IPF = 2*IPFADC + 2
      DX = .5
      DY = .25
      DO 300  I = 1,4
      IPFF = IPF + (I-1)*256
      XLX = -DX
      XLY = 0. + (I-1)*16.
      CALL MOVEA(0.,XLY)
      DO 301  J = 1,128
      KPH = IPFF + J
      IPH = HDATA(KPH)
      XIPH = FLOAT(IPH)
      XLYY = XLY + XIPH*DY
      XLX = XLX + DX
      CALL DRAWA(XLX,XLYY)
      CALL DRAWA(XLX+DX,XLYY)
301   CONTINUE
300   CONTINUE
C***
C***                    WRITE CAPTION
C***
3200  INDES = -3
      CALL CAPMRK(INDES,IESUM)
      CALL TWINDO(0,4095,0,4095)
      XMIN = XMINRE
      XMAX = XMAXRE
      YMIN = YMINRE
      YMAX = YMAXRE
C     CALL SETSCL(LASTVW)
      RETURN
      END

C   24/11/78 C9101501   MEMBER NAME  DNUM     (JADEGS)      FORTRAN
      SUBROUTINE DNUM(NUMBER,XPOS,YPOS,AGT,THETA)
C
C     ******************************************************************
C     *   THIS SUBROUTINE WILL DRAW A 16-BIT INTEGER STARTING AT       *
C     *   POSITION (XPOS,YPOS).  THE HEIGHT IS GIVEN BY AGT AND THETA  *
C     *   SPECIFIES THE ANGLE IN RADIANS.  HEMSYM IS USED TO O/P CHARS *
C     *   WRITTEN BY H.E.MILLS  LAST UPDATED ON 09-AUG-78 AT 10.35.    *
C     ******************************************************************
C     MODIFIED 6.12.78 BY OLSSON, PURPOSE TRANSFER OF DECODED NUMBER
C     MODIFIED 14.10.79 BY OLSSON, PURPOSE WRITING NUMBERS > 32000
C
      IMPLICIT INTEGER*2 (H)
      DIMENSION HBUF(6)
C
      CALL NUMCOD(NUMBER,HBUF,K)
C
C     **** OUTPUT THE ARRAY ****
C
      CALL HEMSYM(XPOS,YPOS,AGT,HBUF,K,THETA)
      RETURN
      END
C------------------------
      SUBROUTINE NUMCOD(NUMBER,HBUF,K)
      IMPLICIT INTEGER*2 (H)
      DIMENSION ITENS(6),HBUF(6),HCH(10)
C
      DATA ITENS/100000,10000,1000,100,10,1/, HBL/' '/
      DATA HCH/'0','1','2','3','4','5','6','7','8','9'/
C
      K=0
      IND=0
      NUMB=NUMBER
C
C     **** LOOP 6 TIMES - PUT DIGIT IN J ****
C
      DO 50 I=1,6
      HBUF(I) = HBL
      IF(I.EQ.6) IND=1
      J=NUMB/ITENS(I)
      NUMB=NUMB-J*ITENS(I)
      IF(J.EQ.0 .AND. IND.EQ.0) GOTO 50
      IND=1
C
C     **** STORE CHARACTER IN HBUF ****
C
      K=K+1
      HBUF(K)=HCH(J+1)
   50 CONTINUE
      RETURN
      END

C   07/06/96 606071905  MEMBER NAME  QMEAN    (S4)          FORTG1
      SUBROUTINE QMEAN(NA,KA,Q)
      COMMON/BCS/IW(1)
      REAL RW(1)
      EQUIVALENCE (RW(1),IW(1))
      REAL Q(10),XL(5),YL(5)
      REAL*8 S(4)
      LOGICAL NADD
      DO 10 I=1,10
   10 Q(I)=0.0
      IF(KA.LT.0) GOTO 100
      CALL BLOC(IND,'MEA*',NA,&100)
      INDK=IND+50*KA
      IF(INDK.GE.IND+IW(IND)) GOTO 100
      N=IW(INDK+1)
      IF(N.EQ.0) GOTO 100
      IF(N.GE.46) GOTO 20
      CALL HMEAN(INDK,Q)
      GOTO 100
   20 SUM=IW(INDK+1)-IW(INDK+4)
      BIN=(RW(INDK+3)-RW(INDK+2))/46.0
      XA=RW(INDK+2)
      XL(1)=SUM*0.1585
      XL(2)=SUM*0.23
      XL(3)=SUM*0.5
      XL(4)=SUM*0.77
      XL(5)=SUM*0.8415
      DO 25 I=1,4
   25 S(I)=0.0
      XB=XA
      SUM=0.0
      NADD=.TRUE.
      DO 40 I=1,46
      DC=IW(INDK+4+I)
      XZ=XB+BIN
      IF(DC.EQ.0.0) GOTO 35
      S(1)=S(1)+DC*(XB+XZ)*0.5
      S(2)=S(2)+DC
      IF(NADD) GOTO 26
      S(3)=S(3)+DC*(XB+XZ)*0.5
      S(4)=S(4)+DC
   26 DO 30 J=1,5
      IF(SUM.GE.XL(J)) GOTO 30
      IF(SUM+DC.LT.XL(J)) GOTO 30
      FR=(XL(J)-SUM)/DC
      YL(J)=XB+FR*BIN
      IF(MOD(J,2).NE.0) GOTO 30
      IF(J.EQ.4) FR=-1.0+FR
      S(3)=S(3)+FR*DC*(XB+XZ)*0.5
      S(4)=S(4)+FR*DC
      IF(J.EQ.2) NADD=.FALSE.
      IF(J.EQ.4) NADD=.TRUE.
   30 CONTINUE
   35 SUM=SUM+DC
   40 XB=XZ
      Q(1)=N
      Q(2)=S(1)/S(2)
      Q(3)=S(3)/S(4)
      Q(4)=YL(3)
      Q(6)=YL(3)-YL(1)
      Q(7)=YL(5)-YL(3)
      Q(5)=0.5*(Q(6)+Q(7))
      Q(8)=IW(INDK+4)
      Q(9)=RW(INDK+2)
      Q(10)=RW(INDK+3)
  100 RETURN
      END

C   11/05/82 206081552  MEMBER NAME  TFAR82   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        SUBROUTINE TFARNW(INLA,INTF,IFLG,*)
C==================================================
C  MODIFIED TO CHECK ON TDCS INSTEAD OF LATCHES
C==================================================
C          CONVERTS THE TOF DATA FROM CAMAC FORMAT
C       TO ANALYSIS FORMAT :
C                   IRAW(1,NCN)= NCN  ; COUNTER#
C      RAW(2,NCN)= TDC(-)-CM(NCN)
C      RAW(3,NCN)= TDC(+)-CP(NCN)
C       OR
C      RAW(2,NCN)= TDC(-) , IF IFLG= 1.
C      RAW(3,NCN)= TDC(+) , IF IFLG= 1.
C                   RAW(4,NCN) = ADC(-)
C                   RAW(5,NCN) = ADC(+)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC
      IMPLICIT INTEGER*2 (H)
#include "tfadc.for"
#include "tfprm1.for"
#include "tcalcm1.for"
      COMMON/PRPOS/PRPLS,CPOS
      COMMON /CHEADR/ IHEADR(54)
      EQUIVALENCE (IHEADR(1),HEADR(1))
      DIMENSION HEADR(108),LIST1(2),LIST(19)
C
C
      DATA IENTRY/ 0/,IBUG/10/
      DATA ADCLIM/1./
      NRUN = HEADR(18)
      IF(IENTRY.NE.0)  GOTO 320
      IENTRY = IENTRY + 1
      PRINT 101,NRUN
      PRINT 102,TCALM2
      PRINT 102,TCALP2
      PRINT 102,TCPDM
      PRINT 102,TCPDP
      PRINT 102,TCPDM2
      PRINT 102,TCPDP2
  102 FORMAT(/(1X,10F10.3))
  101 FORMAT(' ADDITIONAL CALIBRATION CONSTANTS FOR RUN ',I5)
C
 320  CONTINUE
C
C========= ADDRESSING
C
C     CALL SETSL(RAW,0,20*42,0)
      CPOS = HEADR(31)/1000.
       INLA2= INLA*2
       INTF2= INTF*2
       IL0= INLA2+6
       IA0= INTF2+3
       IT0= INTF2+94
C//////////
      IBUG = IBUG + 1
      BADC = TPARM(1)
      AADC = TPARM(2)
      CALL ATOFUN(INTF)
C     IF(IBUG.LE.10) CALL ATOFPR(INTF)
C
      DO 3000 NCN= 1,42
      IRAW(1,NCN) = 0
      MONE = 0
      ADCM = HADC(1,NCN)- PEDLM(NCN)
      ADCP = HADC(2,NCN)-PEDLP(NCN)
C
C========= CHECK THAT BOTH TDC'S HAVE FIRED
C          UNLESS ONE IS BROKEN
      HSTAT(NCN) = MONE
      IF(MONE.EQ.2)  GOTO  32
      IF(HTDC(1,NCN).LT. 5.OR.HTDC(1,NCN).GE.2048)  GOTO  3000
      IF(MONE.EQ.1)  GOTO  1500
   32 IF(HTDC(2,NCN).LT. 5.OR.HTDC(2,NCN).GE.2048)  GOTO  3000
C
C
C========= THEY HAVE
C
 1500 CONTINUE
      TDCM = HTDC(1,NCN)
      TDCP = HTDC(2,NCN)
      TDCM2 = HTDC1(1,NCN)
      TDCP2 = HTDC1(2,NCN)
C
C  COMPUTE PULSEHEIGHT CORRECTION FOR TOF
C
      CORADM = 0.
      CORADP = 0.
      IF(HADC(1,NCN).GE.1024) ADCM = 1024.
      IF(HADC(2,NCN).GE.1024) ADCP = 1024.
      IF(ADCM.LE.1.) ADCM = 1.
      IF(ADCP.LE.1.) ADCP = 1.
      ADCMIV = 1000./ADCM
      ADCPIV = 1000./ADCP
      CORADM =   CADCB(2*NCN-1)*SQRT(ADCMIV)
      CORADP =   CADCB(2*NCN  )*SQRT(ADCPIV)
      IF(CORADM.GT.5.) CORADM = 5.
      IF(CORADP.GT.5.) CORADP = 5.
   20 CONTINUE
      CMS = CORNOR(2*NCN-1)+TCPDM(NCN)
      CPS = CORNOR(2*NCN)  +TCPDP(NCN)
C
      IF(IBUG.LE.10)PRINT106,NCN,TDCM,TDCP,CMS,CPS,TCPDM(NCN),TCPDP(NCN)
     1,PEDLM(NCN),PEDLP(NCN),TCALM(NCN),TCALP(NCN)
      IF(IBUG.LE.10) PRINT 106,NCN,ADCM,ADCP,CORADM,CORADP
  106 FORMAT(' TOFARD',I5,10F10.3)
      IF(TDCM.LT.5..OR.TDCM.GE.2048.)  GOTO  2000
      TDCM0= TDCM
      TDCM20= TDCM2
      IF(IFLG.EQ.1) GO TO 1600
      TDCM0= TDCM0*TCALM(NCN)
      TDCM0= TDCM0-CMS-CORADM
      IF(TDCM2.GE.5.AND.TDCM2.LT.2048.)
     *TDCM20= TDCM2*TCALM2(NCN)-TCPDM2(NCN)-42.5
      IF(IBUG.LE.10) PRINT 106,NCN,TDCM,TDCM0,TDCM2,TDCM20
 1600 IRAW(1,NCN)= NCN
      RAW(2,NCN)= TDCM0
      RAW(4,NCN)= ADCM
      IF(TDCM2.GE.5.AND.TDCM2.LT.2048.)RAW2(1,NCN) = TDCM20
C
 2000 CONTINUE
      IF(TDCP.LT.5..OR.TDCP.GE.2048.)  GOTO  2050
C     IF(ADCP.LT.ADCLIM)  GOTO  2100
      TDCP0= TDCP
      TDCP20= TDCP2
      IF(IFLG.EQ.1) GO TO 2050
2010  TDCP0= TDCP0*TCALP(NCN)
      TDCP0= TDCP0-CPS-CORADP
      IF(TDCP2.GE.5.AND.TDCP2.LT.2048.)
     *TDCP20= TDCP2*TCALP2(NCN)-TCPDP2(NCN)-42.5
      IF(IBUG.LE.10) PRINT 106,NCN,TDCP,TDCP0,TDCP2,TDCP20
2050  IRAW(1,NCN)= NCN
      RAW(3,NCN)= TDCP0
      RAW(5,NCN)= ADCP
      IF(TDCP2.GE.5.AND.TDCP2.LT.2048.) RAW2(2,NCN) = TDCP20
2100  CONTINUE
C
 3000 CONTINUE
C/////////
      RETURN
      END

C   16/02/84 609151603  MEMBER NAME  MCVALI   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE MCVALI( VALID )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   15/11/83 :  CHECKS VALIDITY OF INPUT VECTORS
C
C        MOD: C. BOWDERY   22/11/83 :  FOR TEST DISABLING
C        MOD: C. BOWDERY    2/12/83 :  TEST EVENT NO. * MASS
C        MOD: C. BOWDERY    1/02/84 :  E/P/M IMBALANCE: EVENT KEPT
C                                   :  IF LOW E PHOTON
C        MOD: C. BOWDERY   16/02/84 :  PTOT = EBEAM NOW LEGAL
C        MOD: C. BOWDERY   27/02/84 :  NO TESTS FOR PARTONS AT ALL NOW
C        MOD: C. BOWDERY   12/10/84 :  EBEAM  M U S T  BE < 32.767 GEV
C   LAST MOD: J.OLSSOM     52/09/86 :  EL.MASS IS NOW 0.000511 GEV/C**2
C
C   THIS ROUTINE VALIDATES THE 4-VECTOR INFORMATION IN /CPROD/ BEFORE
C   TRACKING COMMENCES.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL VALID , GOODTR , VALSP
C
      DOUBLE PRECISION DPTSQ , DMSQ , DESQ , DEPM , DPX , DPY, DPZ
      DOUBLE PRECISION DE , DM
C
#include "cprod.for"
C
      COMMON / CVERR / MESSAG(20)
C
      DIMENSION STMASS(6)
C
C                       PARTICLE MASSES (GAMMA,E,MU,PI,K,N)
C
      DATA STMASS / 0.0 , 0.511E-3 , 0.1057 , 0.1396 , 0.4937 , 0.938 /
C
C-------------------  C O D E  -----------------------------------------
C
C                  EVEN IF AN ERROR IS FOUND HERE, THE TEST MAY BE
C                  DISABLED SO THE RETURN FLAG 'VALSP' MUST BE CHECKED
C                  AFTER CALLS TO MCVERR.
C
C
C                            FIRST CHECK EVENT NUMBER
C
C
      VALID = .TRUE.
      IF( NEV .GE. 0  .AND.  NEV .LE. 9999999 ) GO TO 111
      CALL MCVERR(13 ,'INVALID EVENT NUMBER^',0.,NEV,'    ',NEV,1,VALID)
C
C
C                            CHECK NF , NCF AND NNF
C
C
 111  IF( NF  .GT. 0   .AND.  NF  .LE. 300 ) GO TO 112
      CALL MCVERR(14 ,'INVALID NO. OF PARTICLES (NF)^',0.,NF,
     +                                               '    ',NEV,1,VALSP)
      IF( NF .LE. 0 ) VALSP = .FALSE.
      VALID = VALID .AND. VALSP
      IF( .NOT. VALSP ) RETURN
C
C
 112  IF( NCF .GE. 0   .AND.  NCF .LE. 300 ) GO TO 113
      CALL MCVERR(15 ,'INVALID NO. OF CHARGED PARTICLES^',0.,NCF,
     +                                               '    ',NEV,1,VALSP)
      VALID = VALID .AND. VALSP
C
C
 113  IF( NNF .GE. 0   .AND.  NNF .LE. 300 ) GO TO 114
      CALL MCVERR(16 ,'INVALID NO. OF NEUTRAL PARTICLES^',0.,NNF,
     +                                               '    ',NEV,1,VALSP)
      VALID = VALID .AND. VALSP
C
C
 114  IF( NF .EQ. NCF + NNF ) GO TO 115
      CALL MCVERR(17 ,'NF .NE. NCF + NNF . DIFFERENCE =^',0.,NF-NCF-NNF,
     +                                               '    ',NEV,1,VALSP)
      VALID = VALID .AND. VALSP
C
C
C                            CHECK VALIDITY OF THE BEAM ENERGY 'BEAM'.
C                            UPPER LIMIT IS DUE TO HEAD BANK ALLOCATING
C                            ONLY AN SIGNED I*2 WORD TO BEAM ENERGY.
C
C
 115  IF( BEAM .GT. 0.0  .AND. BEAM .LE. 32.767 ) GO TO 1
      CALL MCVERR( 1 ,'INVALID BEAM ENERGY^',BEAM,0,' GEV',NEV,1,VALSP )
      VALID = VALID .AND. VALSP
      IF( .NOT. VALID ) RETURN
C
C
C                            LOOP OVER THE FINAL LIST
C
C
   1  DO  2  I = 1,NF
        GOODTR = .TRUE.
C
C                            IGNORE ANY PARTONS IN THE FINAL LIST.
C
        IF( ITF(I) .LE. -100 .AND. ITF(I) .GT. -120 ) GO TO 2
C
C
C                            CHECK EACH 3-MOMENTUM COMPONENT
C
        DO  3  J = 1,3
C
          IF( ABS( PF(J,I) ) .GT. 1.0E-20          .AND.
     +        ABS( PF(J,I) ) .LE. BEAM  .OR. PF(J,I) .EQ. 0.0  ) GO TO 300001070
C
          CALL MCVERR( 2,'INVALID MOMENTUM COMPONENT^',PF(J,I),0,' GEV',
     +                                                NEV,I,VALSP)
          VALID  = VALID  .AND. VALSP
          GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(2) .GT. 20 )
C
          IF( ABS( PF(J,I) ) .LE. 1.0E-20 ) GO TO 20
          IF( ABS( PF(J,I) ) .GE. 1.0E+20 ) GO TO 20
   3    CONTINUE
C
C
C                            CHECK THE PARTICLE ENERGY
C
C
   4    IF( PF(4,I) .GT. 1.0E-20 .AND. PF(4,I) .LE. 2 * BEAM ) GO TO 5
        CALL MCVERR( 3,'INVALID ENERGY COMPONENT^',PF(4,I),0,' GEV',
     +                                             NEV,I,VALSP )
        VALID  = VALID  .AND. VALSP
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(3) .GT. 20 )
C
        IF( ABS( PF(4,I) ) .LE. 1.0E-20 ) GO TO 20
        IF( ABS( PF(4,I) ) .GE. 1.0E+20 ) GO TO 20
C
C
C                            CHECK THE TYPE. ONLY 1..6 IS LEGAL
C
C
   5    IF( ITF(I) .GT. 0  .AND. ITF(I) .LE. 6 ) GO TO 6
C
        CALL MCVERR( 11,'INVALID PARTICLE TYPE^',0.0,ITF(I),'    ',
     +                                             NEV,I,VALSP )
        VALID  = VALID  .AND. VALSP
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(11) .GT. 20 )
        GO TO 7
C
C
C                            CHECK THAT THE MASS AND TYPE AGREE ROUGHLY
C
C
   6    PMASS = STMASS( ITF(I) )
        IF( ABS( PMASS - XMF(I) ) .LT. 0.01 ) GO TO 7
        CALL MCVERR( 4,'MASS DISAGREES WITH TYPE^',XMF(I),0,' GEV',
     +                                              NEV,I,VALSP )
        VALID  = VALID  .AND. VALSP
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(4) .GT. 20 )
C
C
C                            PRINT ADDITIONAL INFORMATION
C
C
        IF( MESSAG(4) .LE. 20 .AND. .NOT. VALSP )
     +                        WRITE(6,102) ITF(I),PMASS
 102    FORMAT(34X,'PARTICLE TYPE ',I3,' SHOULD HAVE MASS = ',G10.4,
     +                                                       ' GEV')
C
C
C                            CHECK THE ELECTRIC CHARGE. ONLY -1,0,1  OK
C
C
   7    IF( IABS( ICF(I) ) .LE. 1 ) GO TO 8
        CALL MCVERR( 12,'INVALID ELECTRIC CHARGE^',0.0,ICF(I),'    ',
     +                                               NEV,I,VALSP )
        VALID  = VALID  .AND. VALSP
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(12) .GT. 20 )
C
C
C                            CHECK THE TOTAL MOMENTUM
C
C
   8    DPX   = PF(1,I)
        DPY   = PF(2,I)
        DPZ   = PF(3,I)
        DE    = PF(4,I)
        DM    = XMF(I)
        DPTSQ = DPX*DPX + DPY*DPY + DPZ*DPZ
        PTOT  = DSQRT( DPTSQ )
C
        IF( PTOT .LE. BEAM * 1.001 ) GO TO 81
        CALL MCVERR( 8,'INVALID TOTAL MOMENTUM : PTOT  =^',PTOT,0,
     +                                      ' GEV',NEV,I,VALSP)
        VALID  = VALID  .AND. VALSP
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(8) .GT. 20 )
C
C
C                            CHECK THAT THE MASS IS WITHIN BOUNDS
C
C
  81    IF( XMF(I) .GT. 1.0E-20 .AND. XMF(I) .LE. 2 * BEAM
     +          .OR.  XMF(I) .EQ. 0.0 ) GO TO 85
C
        CALL MCVERR( 9,'INVALID PARTICLE MASS^',XMF(I),0,
     +                                      ' GEV',NEV,I,VALSP)
        VALID  = VALID  .AND. VALSP
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(9) .GT. 20 )
C
        IF( ABS( XMF(I) ) .LE. 1.0E-20 ) GO TO 20
        IF( ABS( XMF(I) ) .GE. 1.0E+20 ) GO TO 20
C
  85    DMSQ = DM * DM
C
C
C                            DETERMINE THE ENERGY/MOMENTUM MISMATCH
C
C                               | ( P**2 + M**2 - E**2 ) |
C                               --------------------------
C                                          E**2
C
C
C                            THIS ERROR IS NOT SO SERIOUS FOR LOW E
C                            PHOTONS. - DON'T ALWAYS SET VALID=.FALSE.
C
        DESQ  = DE * DE
        DEPM  = DABS( DPTSQ + DMSQ - DESQ ) / DESQ
        IF( DEPM .LT. 2.5D-3 ) GO TO 9
        XMISM = DSQRT( DEPM ) * 1.0D2
        CALL MCVERR( 5,'E*E  .NE. M*M  + PTOT*PTOT :  ERR =^',
     +                            XMISM,0,' %  ', NEV,I,VALSP )
C
C
C                            DONT REJECT EVENT FOR BAD LOW ENERGY PHOTON
C
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(5) .GT. 20 )
        IF( PF(4,I) .GT. 0.2  .OR. ITF(I) .NE. 1 )
     +                                         VALID = VALID .AND. VALSP
C
C
C                            CHECK THE VERTEX COMPONENTS
C
C
   9    DO  10  K = 1,3
          APSTRT = ABS( PSTRT(K,I) )
          IF( APSTRT .GT. 1.0E-20 .AND. APSTRT .LT. 5000.0
     +               .OR. APSTRT .EQ. 0.0 )       GO TO 10
          CALL MCVERR( 6,'INVALID VERTEX COMPONENT^',PSTRT(K,I),0,' MM '
     +                                            ,NEV,I,VALSP )
          VALID  = VALID  .AND. VALSP
          GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(6) .GT. 20 )
C
          IF( ABS( PSTRT(K,I) ) .LT. 1.0E-20 ) GO TO 20
  10    CONTINUE
C
C
C                            CHECK THE VERTEX SCALAR VALUE
C
C
        VERTEX = SQRT( PSTRT(1,I)**2 + PSTRT(2,I)**2 + PSTRT(3,I)**2 )
        IF( VERTEX .LT. 8000.0 ) GO TO 20
        CALL MCVERR( 7,'INVALID VERTEX POINT^',VERTEX,0,
     +                                  ' MM ',NEV,I,VALSP )
        VALID  = VALID  .AND. VALSP
        GOODTR = GOODTR .AND. ( VALSP .OR. MESSAG(7) .GT. 20 )
C
C
C                            IF NOT GOOD TRACK, THEN PRINT INFORMATION
C                            NOTE THAT NO PRINTOUT IS OBTAINED IF THE
C                            MAX. NO. OF MESSAGES HAS BEEN EXCEEDED.
C
C
  20  IF( GOODTR ) GO TO 2
        WRITE(6,101) (PF(K,I),K=1,4) , XMF(I), ICF(I) , ITF(I)
 101    FORMAT(34X,'PX = ',G12.6,' GEV    PY = ',G12.6,' GEV    PZ = ',
     +         G12.6,' GEV    E = ',G12.6,' GEV'/
     +         34X,'M  = ',G12.6,' GEV     CHARGE =',I4,'     TYPE = ',
     +         I5 )
C
        WRITE(6,103) (PSTRT(L,I),L=1,3)
 103    FORMAT(34X,'X = ',G10.4,' MM       Y = ',G10.4,' MM       Z = ',
     +         G10.4,' MM')
C
   2  CONTINUE
C
C
C                            AT THE END, IF VALID = .TRUE. THEN ALL OK
C
C
      RETURN
      END

      SUBROUTINE VTXEER(IT1,IT2,IPOINT,ITEST) 
C*860529*KLEINWORT***************************************************
C*  COPIED FROM F22KLE.VERTEX.S(VTXEER)   18.9.86
C*                                                                  *
C*   PRINT ERROR-TEXT FOR   V T X E E                               *
C*                                                                  *
C********************************************************************
C
      IMPLICIT INTEGER*2(H)
C PMF 03.11.98 
      LOGICAL TBIT
C
#include "cdata.for"
C
      REAL*8 DTEXT(14)
C
      DATA DTEXT / 'PRETEST ', 'TANKWALL', 'BEAMPIPE', 'PAR.TEST',

     * 'CHAMBER ', 'CHARGE  ', 'D(PHI)  ', 'D(THETA)', 'D(XY)   ',
     * 'D(Z)    ', 'INTRSECT', 'EXTRAP.S', 'INTERP.S', 'RADIUS  ' /
C
      IF (ITEST.EQ.0) GOTO 600
C
      IF ((IPOINT.LT.1).OR.(IPOINT.GT.5)) GOTO 500
      IF ((ITEST.LT.0).OR.(ITEST.GT.9)) GOTO 500
C
      WRITE(6,9000) DTEXT(IPOINT),DTEXT(ITEST+5),IT1,IT2
 9000 FORMAT(' VTXEE FAILED IN ',A8,' DUE TO INVALID ',A8,
     *' WITH TRACKS :',2I3)
C
      IH = IDATA(IBLN('HEAD'))
      IF (IH.LE.0) GOTO 600
C
      NRUN  = HDATA( 2*IH+ 10 )
      NREC  = HDATA( 2*IH+ 11 )
      WRITE(6,9010) NRUN,NREC
 9010 FORMAT(' RUN,REC : ',2I6)
C
      GOTO 600
C
  500 CONTINUE
      WRITE(6,9020) IPOINT,ITEST
 9020 FORMAT(' ??? STRANGE ENTRY TO VTXEER : ',2I5)
C
  600 CONTINUE
      RETURN
      END

******************************************************************
*
*     PLOT10/HIGZ TERMINAL PARAMETERS
*
*     This file is included when compiling plot10.F
*
*     (XTMIN,YTMIN),(XTMAX,YTMAX) : Edges of the screen
*     (XMIN0,YMIN0),(XMAX0,YMAX0) : Edges of user window in screen coordinates
*     (XMIN,YMIN),(XMAX,YMAX)     : Edges of user window in virtual coordinates
*     XPOS0,YPOS0                 : Beam position in screen coordinates 
*     XPOS,YPOS                   : Beam position in virtual coordinates 
*
*     TTEST .EQ. .TRUE. : SUBROUTINE TWINDO was executed
*     DTEST .EQ. .TRUE. : SUBROUTINE DWINDO was executed
*     INIT .EQ. .TRUE.  : SUBROUTINE INITT was executed
*
*     NTS  : HIGZ normalization transformation index of screen window
*     NTV  : HIGZ normalization transformation index of virtual window
*
      LOGICAL TTEST,DTEST,INIT,TRACE,LROTAT,LSCALE,LTSO
      INTEGER NTV,NTS,KWTYPE,KLIN,KCHR,TLINE,IFNT,IPRC,ISYNC,ICHRSZ
      REAL XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,ANGLE,SCALE,XSIZE,YSIZE
     +     ,XCHAR,YCHAR
      CHARACTER FNAME*256
      COMMON /PLOT10/ TTEST,DTEST,INIT,TRACE,NTV,NTS,KWTYPE,LTSO
     +     ,XTMIN,XTMAX,YTMIN,YTMAX,XTMG,YTMG
     +     ,XMIN0,XMAX0,YMIN0,YMAX0,XPOS0,YPOS0
     +     ,XMIN,XMAX,YMIN,YMAX,XPOS,YPOS
     +     ,LROTAT,ANGLE,LSCALE,SCALE
     +     ,XCHAR,YCHAR,KLIN,KCHR,TLINE,ICHRSZ
     +     ,XSIZE,YSIZE,IFNT,IPRC,ISYNC
      COMMON /PLT10C/ FNAME
*******************************************************************

C   19/10/79 206141952  MEMBER NAME  TOFRPR   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
       SUBROUTINE TOFRPR
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
#include "tcalcm.for"
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      INTEGER *2 HDATA
      COMMON/BCS/IDATA(1)
      DIMENSION DATA(1),HDATA(2)
      EQUIVALENCE(IDATA(1),DATA(1)),(HDATA(1),IDATA(1))
      DIMENSION RTOF(14,50),ITOF(14,50)
      EQUIVALENCE (RTOF(1,1),ITOF(1,1))
C
      DATA CVEL/ 2.9979246E2/ ,RADTOF/920./
      DATA IBUG/ 0/
      DATA IENTRY/0/
      IF(IENTRY.NE.0)  GOTO  800
      IENTRY = 1
  800 CONTINUE
C
C
   34 IBUG = IBUG + 1
      IF(IBUG.LE.50) PRINT 300,IBUG,NRUN,NEV,IEV
  300 FORMAT(//'  NEW EVENT ',I8,' RUN...',3I10)

      IPTOFR = IDATA(IBLN('TOFR'))
C
   32 NTR = IDATA(IPTOFR+1)
C     IF(NTR.LE.0) GOTO  60
      PRINT 400 ,NTR
  400 FORMAT(' TOFR BANK        ',I10,'  TRACKS'/)
C
      DO   40  N=1,NTR
      DO   41  I=1,14
      RTOF(I,N) = DATA(IPTOFR+4+(N-1)*14+I)
   41 CONTINUE
      LTR = ITOF(1,N)
      IQUAL = ITOF(2,N)
      NC = ITOF(3,N)
      PATH1 = RTOF(5,N)
      T1 = RTOF(4,N)
      BETA = RTOF(6,N)
      DBETA = RTOF(7,N)
      ZMASS = RTOF(8,N)
      PRINT401,N,LTR,IQUAL,NC,T1,PATH1,BETA,DBETA,ZMASS
  401 FORMAT(1X,4I3,F6.2,F6.0,F6.2,4F6.2)
      PRINT 402,HTDC(1,NC),HTDC(2,NC),HADC(1,NC),HADC(2,NC),HSTAT(NC)
  402 FORMAT(1H+,60X,5I8)
   40 CONTINUE
C
      RETURN
       END

C   23/02/79 C9062501   MEMBER NAME  DIAGRE   (JADEGS)      FORTRAN
      SUBROUTINE DIAGRE(HTEXT,N,R1,R2,R3,R4,R5)
C---
C---     PRINT HTEXT AND UP TO 5 REAL NUMBERS, FOR DIAGNOSTICS
C---
      IMPLICIT INTEGER*2 (H)
      DIMENSION R(5),HTEXT(10),HWORK(41)
C---
      IF(N.LT.1.OR.N.GT.5) RETURN
      DO 1  I = 1,5
1     R(I) = 0.
      IF(N.GT.0) R(1) = R1
      IF(N.GT.1) R(2) = R2
      IF(N.GT.2) R(3) = R3
      IF(N.GT.3) R(4) = R4
      IF(N.GT.4) R(5) = R5
      ILIM = 20 + N*11
      CALL CORE(HWORK,ILIM)
      WRITE(10,100) (HTEXT(I),I=1,10),(R(I),I=1,N)
100   FORMAT(10A2,5E11.4)
      CALL TRMOUT(ILIM,HWORK)
      RETURN
      END

C   17/09/84 807231820  MEMBER NAME  PRAGAI0  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE PRAGAI(IPRIT)
C-----------------------------------------------------------------------
C
C   AUTHOR    J.OLSSON    28/07/86 :  CHECK "PRINT AGAIN" CONDITION
C        LAST CHANGE      07/11/86 :  TYPE ERRORS CORRECTED
C
C   THE VARIOUS COMMONS FOR DETECTOR SMEARING AND TRIGGER CONDITIONS
C   ARE CHECKED FOR DIFFERENCES, AS COMPARED TO BACKUPS FROM PREVIOUS
C   CALLS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C /////////////////////////////////////////////////////////////////
C
      COMMON /CTRIGG/ IHIST(3),NBPTFW,TAGADC,IDUM1(4),HDUM1,
     *  HLGBRT,HLGBST,HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,HTGTRG,
     *                HDUM2(9),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     *                NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     *                IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,HMPRON,
     *                IWCTBG,NTFCOL,NTFCLN,NTFBS2,IDUM3(9),
     *  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),HMASK(16,3),HDEADC(10),
     *  HACC1,HACC2,HACC3,HACC4,HACCM,HDUM6,IWIDT2,HACCB1,HACCB2,
     *  HT1ACC,HT1PSP,IDUM4(8)
C
      COMMON /XTRIGG/ JPRAGA(110)
      DIMENSION KPRAGA(110),XPRAGA(110),YPRAGA(110)
      EQUIVALENCE (KPRAGA(1),IHIST(1),XPRAGA(1))
      EQUIVALENCE (JPRAGA(1),YPRAGA(1))
C
C /////////////////////////////////////////////////////////////////
C
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10), IPHALG
C
      COMMON /XRDSTA/ JPRAGB(13)
      DIMENSION KPRAGB(13),XPRAGB(13),YPRAGB(13)
      EQUIVALENCE (KPRAGB(1),NDEAD,XPRAGB(1))
      EQUIVALENCE (JPRAGB(1),YPRAGB(1))
C
C /////////////////////////////////////////////////////////////////
C
      COMMON / CJDRCH / DRCH(34),
     +                  PEDES, TZERO(3),
     +                  DRIROT(96,2), SINDRI(96,2), COSDRI(96,2),
     +                  DRIVEL(96,2)
C
      COMMON /XJDRCH/ JPRAGC(38)
      DIMENSION KPRAGC(38),XPRAGC(38),YPRAGC(38)
      EQUIVALENCE (KPRAGC(1),DRCH(1),XPRAGC(1))
      EQUIVALENCE (JPRAGC(1),YPRAGC(1))
C
C /////////////////////////////////////////////////////////////////
C
      COMMON / CJVTXC / VXCC(15),
     +                  DRILOR(24), SNLORA(24), CSLORA(24),
     +                  DRVELO(24)
C
      COMMON /XJVTXC/ JPRAGD(111)
      DIMENSION KPRAGD(111),XPRAGD(111),YPRAGD(111)
      EQUIVALENCE (KPRAGD(1),VXCC(1),XPRAGD(1))
      EQUIVALENCE (JPRAGD(1),YPRAGD(1))
C
C /////////////////////////////////////////////////////////////////
C
      COMMON / CBINV /  DTRSVV, ZRSVV, EFFVV(2), DOUBVV(3), IRNHVV
C
      COMMON /XBINV/ JPRAGE(8)
      DIMENSION KPRAGE(8),XPRAGE(8),YPRAGE(8)
      EQUIVALENCE (KPRAGE(1),DTRSVV,XPRAGE(1))
      EQUIVALENCE (JPRAGE(1),YPRAGE(1))
C
C /////////////////////////////////////////////////////////////////
C
      COMMON / CBIN   / TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3),
     +                BINDL8(6),RJITT, DLRSLN(3), DLZSLN(3)
C
      COMMON /XBIN/ JPRAGF(32)
      DIMENSION KPRAGF(32),XPRAGF(32),YPRAGF(32)
      EQUIVALENCE (KPRAGF(1),TIME(1),XPRAGF(1))
      EQUIVALENCE (JPRAGF(1),YPRAGF(1))
C
C /////////////////////////////////////////////////////////////////
C
      COMMON / CBINMC / BINMC(6)
C
      COMMON /XBINMC/ JPRAGG(6)
      DIMENSION KPRAGG(6),XPRAGG(6),YPRAGG(6)
      EQUIVALENCE (KPRAGG(1),BINMC(1),XPRAGG(1))
      EQUIVALENCE (JPRAGG(1),YPRAGG(1))
C
C-/////////////////  C O D E  //////////////////////////////////////////
C
      IPRIT = 0
C
      DO 1  I = 1,110
      IF(JPRAGA(I).EQ.KPRAGA(I)) GO TO 1
C     WRITE(6,3801) I,JPRAGA(I),KPRAGA(I),XPRAGA(I),YPRAGA(I)
C801  FORMAT('  PRAGAI FOUND DIFFERENCE IN /CTRIGG/, ELEMENT ',I3,' VALU
C    $ES OLD-NEW, INT',2I5,' REAL ',2E12.4)
      GO TO 8000
1     CONTINUE
C
      DO 2  I = 1,13
      IF(JPRAGB(I).EQ.KPRAGB(I)) GO TO 2
      WRITE(6,3802) I,JPRAGB(I),KPRAGB(I),XPRAGB(I),YPRAGB(I)
3802  FORMAT('  PRAGAI FOUND DIFFERENCE IN /CRDSTA/, ELEMENT ',I3,' VALU
     $ES OLD-NEW, INT',2I5,' REAL ',2E12.4)
      GO TO 8000
2     CONTINUE
C
      DO 3  I = 1,38
      IF(JPRAGC(I).EQ.KPRAGC(I)) GO TO 3
      WRITE(6,3803) I,JPRAGC(I),KPRAGC(I),XPRAGC(I),YPRAGC(I)
3803  FORMAT('  PRAGAI FOUND DIFFERENCE IN /CJDRCH/, ELEMENT ',I3,' VALU
     $ES OLD-NEW, INT',2I5,' REAL ',2E12.4)
      GO TO 8000
3     CONTINUE
C
      DO 4  I = 1,111
      IF(JPRAGD(I).EQ.KPRAGD(I)) GO TO 4
      WRITE(6,3804) I,JPRAGD(I),KPRAGD(I),XPRAGD(I),YPRAGD(I)
3804  FORMAT('  PRAGAI FOUND DIFFERENCE IN /CJVTXC/, ELEMENT ',I3,' VALU
     $ES OLD-NEW, INT',2I5,' REAL ',2E12.4)
      GO TO 8000
4     CONTINUE
C
      DO 5  I = 1,8
      IF(JPRAGE(I).EQ.KPRAGE(I)) GO TO 5
      WRITE(6,3805) I,JPRAGE(I),KPRAGE(I),XPRAGE(I),YPRAGE(I)
3805  FORMAT('  PRAGAI FOUND DIFFERENCE IN /CBINV/, ELEMENT ',I3,' VALU
     $ES OLD-NEW, INT',2I5,' REAL ',2E12.4)
      GO TO 8000
5     CONTINUE
C
      DO 6  I = 1,32
      IF(JPRAGF(I).EQ.KPRAGF(I)) GO TO 6
      WRITE(6,3806) I,JPRAGF(I),KPRAGF(I),XPRAGF(I),YPRAGF(I)
3806  FORMAT('  PRAGAI FOUND DIFFERENCE IN /CBIN/, ELEMENT ',I3,'  VALU
     $ES OLD-NEW, INT',2I5,' REAL ',2E12.4)
      GO TO 8000
6     CONTINUE
C
      DO 7  I = 1,6
      IF(JPRAGG(I).EQ.KPRAGG(I)) GO TO 7
      WRITE(6,3807) I,JPRAGG(I),KPRAGG(I),XPRAGG(I),YPRAGG(I)
3807  FORMAT('  PRAGAI FOUND DIFFERENCE IN /CBINMC/, ELEMENT ',I3,' VALU
     $ES OLD-NEW, INT',2I5,' REAL ',2E12.4)
      GO TO 8000
7     CONTINUE
C
      GO TO 9000
C
 8000 IPRIT = 1
C
C     NEW BACKUP, AFTER DIFFERENCE WAS FOUND
C
      DO 11  I = 1,110
      JPRAGA(I) = KPRAGA(I)
11    CONTINUE
C
      DO 12  I = 1,13
      JPRAGB(I) = KPRAGB(I)
12    CONTINUE
C
      DO 13  I = 1,38
      JPRAGC(I) = KPRAGC(I)
13    CONTINUE
C
      DO 14  I = 1,111
      JPRAGD(I) = KPRAGD(I)
14    CONTINUE
C
      DO 15  I = 1,8
      JPRAGE(I) = KPRAGE(I)
15    CONTINUE
C
      DO 16  I = 1,32
      JPRAGF(I) = KPRAGF(I)
16    CONTINUE
C
      DO 17  I = 1,6
      JPRAGG(I) = KPRAGG(I)
17    CONTINUE
C
 9000 CONTINUE
      RETURN
      END
      BLOCK DATA BL4            ! PMF 01/07/99 add name
C
C  DATA SETTING OF BACKUP COMMONS FOR PRAGAI CHECKS
C
      COMMON /XTRIGG/ JPRAGA(110)
      DATA JPRAGA /110 * -1/
C
C /////////////////////////////////////////////////////////////////
C
      COMMON /XRDSTA/ JPRAGB(13)
      DATA JPRAGB /13 * -1/
C
C /////////////////////////////////////////////////////////////////
C
      COMMON /XJDRCH/ JPRAGC(38)
      DATA JPRAGC /38 * -1/
C
C /////////////////////////////////////////////////////////////////
C
      COMMON /XJVTXC/ JPRAGD(111)
      DATA JPRAGD /111 * -1/
C
C /////////////////////////////////////////////////////////////////
C
      COMMON /XBINV/ JPRAGE(8)
      DATA JPRAGE /8 * -1/
C
C /////////////////////////////////////////////////////////////////
C
      COMMON /XBIN/ JPRAGF(32)
      DATA JPRAGF /32 * -1/
C
C /////////////////////////////////////////////////////////////////
C
      COMMON /XBINMC/ JPRAGG(6)
      DATA JPRAGG /6 * -1/
C
      END

C   22/05/84 807251604  MEMBER NAME  JADCMD   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE JADCMD( CICS, NFLDS, IST, IEND, ICOMD , A, B )
C-----------------------------------------------------------------------
C
C   AUTHOR:   C. BOWDERY   5/06/84 :  DETERMINE WHICH JADE COMMAND
C
C      MOD:   C. BOWDERY  17/07/85 :  INCREASE DIMENSIONS OF IST,IEND
C LAST MOD:   J. HAGEMANN 03/09/86 :  ALLOW ARGUMENT TO BE A STRING
C                                  :  CHARACTER BEFORE STRING HAS TO
C                                  :  BE A '/'
C
C
C IN    CICS      = INPUT COMMAND STRING
C       NFLDS     = NUMBER OF FIELDS LOCATED IN CICS
C       IST       = ARRAY OF STARTING POSITIONS OF THE FIELDS IN CICS
C       IEND      = ARRAY OF ENDING POSITIONS OF THE FIELDS IN CICS
C
C OUT   ICOMD     = COMMAND NUMBER; 0 = NOT FOUND; -1 = NO COMMAND WORDS
C       A         = FIRST ARGUMENT (MAY BE ZERO)
C       B         = SECOND ARGUMENT (MAY BE ZERO)
C
C     INITIALLY THE FIELDS ARE EXAMINED TO DETERMINE HOW MANY COMMAND
C     WORDS ARE PRESENT (OR A SINGLE ABBREVIATION) AND HOW MANY
C     ARGUMENTS (IF ANY) FOLLOW. IF ONLY 1 COMMAND FIELD IS FOUND, THE
C     ABBREVIATIONS ARE SEARCHED FOR A MATCH. IF SUCCESSFUL THE
C     ARGUMENTS ARE EXTRACTED. IF NOT OR IF SEVERAL COMMAND FIELDS ARE
C     PRESENT, THE FIELDS ARE COMPARED WITH THE COMMAND WORD DICTIONARY
C     AND THE BEST MATCH WITH THE COMMAND LIST IS MADE.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL*1  CICS(80), CSLASH, CHLP(4)
C
      EQUIVALENCE( A1,CHLP(1))
C
      DIMENSION  IST(80), IEND(80), HWRD(10)
C
      DATA CSLASH / '/' /
C
C-------------------  C O D E  -----------------------------------------
C
C
      A  = 0.0
      B  = 0.0
      A1 = 0.0
C
C                            DETERMINE HOW MANY COMMAND WORDS PRESENT.
C                            NUMFUN RETURNS VALUE OF DIGIT (0-9) OR
C                            10-13 FOR '+','-','.','/'. OTHERWISE -1
C
      NCOMW = 0
      DO  1  I = 1,NFLDS
        IF( NUMFUN( CICS(IST(I)) ) .GE. 0 ) GO TO 2
        NCOMW = NCOMW + 1
   1  CONTINUE
C
C                            THERE IS NO COMMAND HERE
C
   2  IF( NCOMW .NE. 0 ) GO TO 3
        ICOMD = -1
        RETURN
C
C                            THERE IS A COMMAND HERE
C                            IF ONLY 1 WORD, TRY THE ABBREVIATIONS
C
   3  IF( NCOMW .GT. 1 ) GO TO 10
        LEN = IEND(1) - IST(1) + 1
        CALL FINABR( CICS( IST(1) ), LEN, ICOMD, MAXARG, IS )
        IF( ICOMD .EQ. 0 ) GO TO 10
        IF( IS .EQ. 0 ) GO TO 20
          IS = IS + IST(1) - 1
          GO TO 15
C
C                            DECODE THE COMMAND WORDS
C                            USING THE DICTIONARY DEFINED BY DEFWRD
C
  10  DO  11  N = 1,NCOMW
        LEN = IEND(N) - IST(N) + 1
        CALL FINWRD( CICS(IST(N)), LEN, N, NCOMW, HWRD(N), IS )
  11  CONTINUE
C
C                            PROCESS THESE WORDS TO DETERMINE COMMAND
C
      CALL FINCMD( HWRD, NCOMW, ICOMD, MAXARG )
      IF( ICOMD .LT. 1 ) RETURN
C
C                            IF  IS = 0  THEN THE LAST COMMAND
C                            FIELD DID NOT CONTAIN THE FIRST ARGUMENT
C
      IF( IS .EQ. 0 ) GO TO 20
C
C                            COMMAND RECOGNISED BUT FIRST ARGUMENT IS
C                            PART OF THE COMMAND FIELD SO SET START
C                            POSITION AND LENGTH OF ARGUMENT.
C
  15    LEN   = IEND(NCOMW) - IS + 1
        IARGP = NCOMW
        GO TO 23
C
C                            ARE THERE ANY ARGS?
C
  20    IF( NCOMW .EQ. NFLDS ) RETURN
C
C                            SET START POSITION AND LENGTH OF ARGUMENT
C
        IARGP = NCOMW + 1
        IS    = IST( IARGP )
        LEN   = IEND( IARGP ) - IS + 1
C
C                            ARE ANY ARGUMENTS ALLOWED?
C
  23  IF( MAXARG .LT. 1 ) GO TO 30
C
C                            TEST IF ARGUMENT IS A BANK NAME
C
      IF( CICS(IS) .NE. CSLASH ) GO TO 25
         DO 24 IC = 1, 4
            CHLP(IC) = CICS(IS+IC)
  24     CONTINUE
         A = A1
         GO TO 27
C
C                            EXTRACT FIRST ARGUMENT
C
  25  CALL JADARG( CICS(IS), LEN, 1, A )
C
C                            IS THERE A 2ND ARGUMENT? IS IT ALLOWED?
C
  27  IF( IARGP .EQ. NFLDS ) RETURN
      IF( MAXARG .LT. 2 ) GO TO 30
      IARGP = IARGP + 1
C
C                            EXTRACT SECOND ARGUMENT
C
      CALL JADARG( CICS(IST(IARGP)), IEND(IARGP)-IST(IARGP)+1, 2, B )
      IF( IARGP .EQ. NFLDS ) RETURN
C
C                            TOO MANY ARGUMENTS
C
  30  WRITE(6,31) MAXARG
  31  FORMAT(' Warning: Too many arguments.'/' Limit is ',I1,
     +       ' for this command. Excess values ignored.')
      RETURN
C
      END

C   08/12/80 602051412  MEMBER NAME  JRECAL9  (JADEGS)      FORTRAN
      SUBROUTINE JRECAL(IERR)
C---
C---     RECALIBRATES JETC BANK
C---
C---
C---     NEW VERSION FOR FADC-READOUT    P. STEFFEN 12.30 86/02/05
C---
C---     SET AMPLITUDES = 0 IF OVERFLOW  P. STEFFEN 12.30 83/04/21
C---
C---     NEW VERSION WITH A TZERO FOR EACH OF THE THREE RINGS.
C---     AND NEW SLEWING CORRECTIONS
C---                                   P. STEFFEN   16.00 17.09.79
C---      PROTECTION AGAINST MONTE CARLO   J.OLSSON,C.BOWDERY  07.03.84
C---
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
#include "cgraph.for"
C
#include "cjdrch.for"
C
      COMMON/CALIBR/JPOINT(16)
      DIMENSION HCALIB(2)
      EQUIVALENCE (HCALIB(1),JPOINT(1))
C
      DIMENSION TOFSET(3)
C
      DATA ZPHS/2440./
      DATA RAMPS/100./
      DATA ICALL/0/
C---
      IERR = 1
C     NHIT = 0
C---                                     INITIALIZATION
      IF(ICALL.NE.0) GO TO 3
        ICALL=1
C---    FACTORS FOR AMPLITUDE CALCULATION
        AC0 =(ZPHS-ZAL)*.5 / ZAL
        AC1 =RAMPS*ZPHS*.5 / ZAL
        IQHEAD=IBLN('HEAD')
        IJETC=IBLN('JETC')
    3 CONTINUE
        IPHEA2=IDATA(IQHEAD)*2
        NRUN=HDATA(IPHEA2+10)
C
C FOR MONTE CARLO, JUST RETURN    CHANGE 7.3.1984   (J.O., C.B.)
C
        IF(NRUN.LT.100) GO TO 200
C
C---    DRIFT TIME OFFSET
        TOFSET(1) = (TZERO(1) + T0FIX(1))*64. + 10000.5
        TOFSET(2) = (TZERO(2) + T0FIX(2))*64. + 10000.5
        TOFSET(3) = (TZERO(3) + T0FIX(3))*64. + 10000.5
C
C---    AMPLITUDE CORRECTION FACTORS FOR TIME SLEWING
        IF(NRUN.GE.6185) GO TO 20
          AMCF1 = -64.*1.494 - .5
          AMCF2 =  7.872E-03*8.
          AMCF3 = -1.157E-05
          AMCF4 = -64.*0.8207 - .5
          AMCF5 =  2.926E-03*8.
          AMCF6 = -2.561E-06
          AMLM1 = 2000.
          AMLM2 = 4000.
          GOTO 30
   20   CONTINUE
          AMCF1 = -64.*1.811 - .5
          AMCF2 =  1.112E-02*8.
          AMCF3 = -2.155E-05
          AMCF4 = -64.*0.8430 - .5
          AMCF5 =  2.340E-03*8.
          AMCF6 = -1.623E-06
          AMLM1 = 1800.
          AMLM2 = 5600.
   30   CONTINUE
C                                        POINTER
      IPHALF = JPOINT(4)*2
      IPJETC = IDATA(IJETC)
      JPJETC = IDATA(IPJETC-1)
      IF(IPJETC.LE.0 .OR. JPJETC.LE.0) GOTO 900
      NWI = IDATA(IPJETC)
      NWJ = IDATA(JPJETC)
      IERR = 2
      IF(NWI.NE.NWJ .OR. NWI.LE.50) GOTO 900
C---
C---                                   COPY UNCALIBRATED BANK
C---
      IPJ2  = IPJETC*2
      IP0   = IPJ2 + 100
      IP9   = HDATA(IP0-1) + IP0 - 2
      NBYTE = HDATA(IP0-1)*2 - 2
      CALL MVCL(IDATA(IPJETC+51),0,IDATA(JPJETC+51),0,NBYTE)
      IDATA(IPJETC+1) = IDATA(JPJETC+1)
      HDATA(IPJ2  +1) = HDATA(IPJ2  +1) + 200
C---                                   LOOP OVER HITS
      DO 200 IP = IP0,IP9,4
        IWIRE  = HDATA(IP+1)
        IA1    = HDATA(IP+2)
        IA2    = HDATA(IP+3)
        IDTIME = HDATA(IP+4)
C
        IF(IA1.LT.0) IA1=0
        IF(IA1.GE.4095) IA1=0
        IA1=SHFTL(IA1,3)
        IF(IA2.LT.0) IA2=0
        IF(IA2.GE.4095) IA2=0
        IA2=SHFTL(IA2,3)
C
        IWIRE  = SHFTR(IWIRE,3)
        IPLOC  = IWIRE* 6 + IPHALF
        ITZERO = HCALIB(IPLOC+1)
        SF     = AC1/HCALIB(IPLOC+2) + AC0
        IPEDL1 = HCALIB(IPLOC+3)
        IGAIN1 = HCALIB(IPLOC+4)
        IPEDL2 = HCALIB(IPLOC+5)
        IGAIN2 = HCALIB(IPLOC+6)
C---
C---       THE 512 (2*9) ADDED BELOW CAUSES THE SUBSEQUENT SHIFT RIGHT
C---       BY 10 BITS TO DO A ROUND OFF RATHER THAN A TRUNCATION.
C---
        IF(IA1.GT.0) IA1 = (IA1-IPEDL1)*IGAIN1+512
        IF(IA1.LT.0) IA1 = 0
        IA1              = SHFTR(IA1,10)
        IF(IA2.GT.0) IA2 = (IA2-IPEDL2)*IGAIN2+512
        IF(IA2.LT.0) IA2 = 0
        IA2              = SHFTR(IA2,10)
C---
C---       COMPUTE AMPLITUDE SLEWING CORRECTION AT THIS POINT.
C---
        IAMCOR=0
        IF(NRUN .GE. 24200) GOTO 290
C
          AMX = MAX0(IA1,IA2)
          IF(AMX.GT.AMLM2) GO TO 202
          IF(AMX.GT.AMLM1) GO TO 201
            IAMCOR = (AMCF3*AMX + AMCF2)*AMX + AMCF1
            GO TO 202
201         IAMCOR = (AMCF6*AMX + AMCF5)*AMX + AMCF4
202       CONTINUE
C
C
  290   CONTINUE
C
        AX = (IA2-IA1)*SF
        IS = SIGN(.5,AX) + AX
        IF(IA1.GT.    0) IA1 = IA1-IS
        IF(IA1.LT.    0) IA1 = 0
        IF(IA1.GT.32767) IA1 = 32767
        IF(IA2.GT.    0) IA2 = IA2+IS
        IF(IA2.LT.    0) IA2 = 0
        IF(IA2.GT.32767) IA2 = 32767
C
C                                         DRIFTTIME
        IF(NRUN .GE. 24200) GOTO 310
          IF(IDTIME.LT.0) IDTIME=0
          IF(IDTIME.GT.255) IDTIME=255
          IDTIME = SHFTL(IDTIME,6)
  310   CONTINUE
        IDTIME = IDTIME - ITZERO + IAMCOR
C
        TZ0 = TOFSET(1)
        IF(IWIRE.GE.384) TZ0 = TOFSET(2)
        IF(IWIRE.GE.768) TZ0 = TOFSET(3)
        IPED = INT(TZ0) - 10000
C
C
        HDATA(IP+2) = IA1
        HDATA(IP+3) = IA2
        HDATA(IP+4) = IDTIME - IPED
C
C
C     NHIT = NHIT + 1
C     IF(NHIT.GT. 8) GOTO 200
C     PRINT 2001, IWIRE,KLOK,IDTIME,IPED,ITZERO,IAMCOR,IA1,IA2
C2001 FORMAT(' JRECAL',8I6)
  200 CONTINUE
      IERR = 0
      RETURN
C
  900 CONTINUE
      WRITE(JUSCRN,2901) IERR
 2901 FORMAT(' JRECAL(PST): ERROR',I4)
      RETURN
      END

C   04/05/81 807262012  MEMBER NAME  MUNEWS   (JADEMUS)     FORTRAN

            THIS MEMBER CONTAINS INFORMATION ABOUT DEVELOPMENT OF
            MUON CALIBRATION/SOFTWARE

THE LAST ISSUE OF JCN 22 WAS NO. 4 AND WAS ISSUED ON 01/02/84.


26/07/88 :CB    MUCON ONLY PRINTS ITS MESSAGES ONCE AND A WARNING OF
--------        THIS IS ALSO PRINTED.

07/06/88 :PW    MUCUTS CHANGED. RMSZUP INCREASED FOR 1986 DATA
--------  (JH)  BY A FACTOR OF 2.

26/05/88 :PW    MUANAF,MUFFLE,MUFFLT,MUFFLY UPDATED.
--------  (JH)  USE CORRECT ERROR CALCULATION.

 8/02/88 :CB    MUFFLE NO LONGER CALLS MUFFLM.
--------        MUFFLM IS NOW OBSOLETE AND COULD BE DELETED.

18/12/87 :CB    MUCON CHANGED TO SHORT CIRCUIT ROUTINE IF NON-MUON MC
--------        DATASET IS BEING PROCESSED. MUMESS MESSAGE PRINTED.

20/03/86 :CB    MUANAF CHANGED TO ENSURE MUR2/0 CREATED BEFORE
--------        TERMINATING ANALYSIS IF NREGS = 0.

 9/10/85 :CB    MUANAC CHANGED TO MAKE HLUN AND HC ARRAYS BIGGER.
--------        CAN NOW HANDLE 400 HITS. MUINI,MUINIG CHANGED TO
                PRINT CORRECT STATISTICS (HITS>400). MUSTAT
                DESCRIPTION ALSO UPDATED.

23/04/85 :PW    MUCONE & MUCHAN GAVE WRONG RESULTS IN UPDATE MODE.
--------        (CORRECT ELSEWHERE)                ---------------
                IF CTW'S WERE CHANGED  CTLO, CTHI WERE WRONG.
                ACTW, AANG WERE POSSIBLE ALTHOUGH ILLEGAL IN THIS MODE.
                THE ABOVE ERRORS CORRECTED,
                INITIALISATION OF VARIABLES COMPLETED,
                ALGORITHM FOR CTLO/CTHI HANDLING GREATLY IMPROVED.
                ALSO SOME SMALLER BUGS (WRONG CONSTANTS) FIXED.


29/03/85 :CB    NEW VERSION OF MUANA NOW CALLS MUANAB, A NEW ROUTINE
--------        WHICH EXTRACTS HEADER INFO AND CORRECTS IT IF NEEDED.


13/02/85 :CB    SMALL BUG IN S/R MUONS REMOVED. THIS WILL HAVE HAD
--------        NO EFFECT ON USERS PROGRAMS.


11/10/84 :CB    MUFFLE CHANGED TO ELIMINATE TEMPORARY ALTERATION LEFT
--------        IN MEMBER SINCE CHANGE OF 10/8/84. NO EFFECT ON USAGE.
                NEW STAND-ALONE ROUTINE  CALLED MUONS ADDED. THIS
                EXAMINES THE MUON RESULTS BANKS AND RETURNS INFORMATION
                ABOUT MUONS IN THE EVENT. SEE MEMBER LISTING.

29/09/84 :CB    CHECK FOR CALIBRATION IN MUANAC NOW.
--------

27/08/84 :PW    MUPR10-MUPR23: OUTPUT OF THESE ROUTINES MADE MORE
--------        TRANSPARENT BY A FEW COMMENTS ADDED TO THE PRINTOUT

10/08/84 :CB    NEW VERSION OF MUFFLE AND CMUFFL TO ALLOW CHANGES TO
--------        BE MADE TO NUMBER OF ALLOWED MISSING HITS AND
                MAX VALUE OF MOMENTUM USED FOR TRACK EXTRAPOLATION.
                IF THIS VALUE IS EXCEEDED, P IS SET TO MAX VALUE.
                NALLWM, PMXFLG ARE PRESET IN CMUFFL BY BLOCK DATA.

18/06/84 :CB    MUPIC NOW DRAWS NOTHING IF THERE IS NO CALIBRATION.
--------

16/04/84 :CB    MUREG NOW HAS CORRECT TEST FOR MONTE CARLO EVENTS.
--------        MUMESS ALTERED TO MATCH MUERRY.

30/03/84 :CB    MUCUTS NOW PROTECTED AGAINST EVENTS WITH MORE THAN 60
--------        TRACKS. PREVIOUSLY ARRAYS WERE SIZE 40 AND UNPROTECTED.

23/03/84 :CB    MUFFLE NOW STORES NGLAYR IN MUR2/1 I*4 WORD 7 / TRACK
--------        MUTIM UPDATED.


15/03/84 :PH/CB MULDSP NOW HANDLES MUPT 9000
--------

12/03/84 :CB    MUCUTS TAKEN FROM HUGH'S LIBRARY AND TIDIED-UP.
--------        NOW FLAGS TYPE 9 GOOD MUONS. MUINI/MUINIG CHANGED FOR
                NEW STATISTICS INFO. MUERRY TIDIED-UP.@MUSTAT UPDATED.

 9/03/84 :CB    MUCOOR NOW CALLS MU2PUL TO GET MULTI-PULSING CUT  AND
--------        MUFSTA TO FIX UP BAD STATUS INFO. OTHER SMALL IMPROVE-
                MENTS INCLUDE BETTER ERROR CHECKING. MUINI CHANGED TO
                PRINT TITLE FOR SCALAR 65 (MUINIG TOO). MUANAC UPDATED.
                MUREG NOW CHECK THAT CALIBRATION READ. IF NOT, IT STOPS.
                (BUT ONLY FOR REAL DATA)
                MUPIC NOW ALSO CALLS MUFSTA.
                MUFFLE NOW CALLS MUSAFE FOR ALL TRACKS, NOT ONLY MUONS
                MUANAF NOW CHECKS THAT NREGS IS GREATER THAN ZERO.

21/02/84 :CB    IMPROVED VERSION OF MUCONW  RELEASED. MUINIG UPDATED.
--------

19/02/84 :CB    IMPROVED VERSION OF MUCON RELEASED.
--------

 1/02/84 :PH/CB NEW VERSION OF MULDSP FOR MUPT 5000
 -------

 1/02/84 :TG/CB NEW VERSIONS OF MUCOOR,MUINI,MUCUTS & MUANAF
 -------        WITH IMPROVED STATISTICS LAYOUT, BETTER ERROR HANDLING
                AND PRINTOUT IF BANKS MISSING AND NEW STATISTICS DATA.
                MEMBER @MUSTAT GIVES DETAILS OF STATISTICS

13/01/84 :CB    MUCOOR CHANGED TO RECORD MULTI-PULSED HITS IN BIT 9
--------        OF EVERY WORD IN MUR1/2. MUCOOR ERROR MESSAGES IMPROVED
                AND MUANAC CHANGED TO REFLECT NEW MUCOOR VERSION.
                MUFINI CHANGED. NO STATISTICS ARE PRINTED IF ALL VALUES
                ARE ZERO. TITLES UPDATED IN MUINI WRT STATISTICS.

16/12/83 :CB    NEW VERSION OF MULOCH NOW INSTALLED. THIS VERSION
--------        DIFFERS ONLY IN BEING EASIER TO READ AND UNDERSTAND.
                THUS CERTAIN VARIABLES HAVE BEEN RENAMED.

13/12/83 :HMCC
--------                MODIFIED MUON CALIBRATION
                        -------------------------

                THE MUON CHAMBER CALIBRATION DEPENDS ON THE JET-CHAMBER
                CALIBRATION AND FITTING PROCEDURE IN THAT SMALL CORRECT-
                IONS ARE MADE TO THE MU HIT COORDINATES TO CORRECT FOR
                MISALIGNMENTS BETWEEN THE MU HITS AND THE EXTRAPOLATED
                'PATR' TRACKS. THE RECENT RE-CALIBRATION OF THE JET-
                CHAMBER HAS NECESSITATED RE-CALCULATION OF THESE SHIFTS.
                THEY HAVE BEEN CALCULATED USING THE MU-PAIR EVENTS SELE-
                CTED BY BEATE NAROSKA AND RE-FITTED BY PETER STEFFEN
                IN EXACTLY THE SAME WAY AS THE MULTI-HADRON DATA HAS
                BEEN RE-FITTED  I.E. NEW R-PHI CALIBN , NEW R-Z CALIBN,
                R-Z FIT DONE WITH Z-VERTEX CONSTRAINT  ( FOR DATA TAKEN
                IN 1980 AND THE LOW ENERGY DATA TAKEN IN 1981, ONLY THE
                LAST TWO IMPROVEMENTS APPLY ). THE Z RE-CALIBRATION WAS
                DONE WITHOUT HIT-CLEANING.  THE RESULTING CORRECTIONS
                ARE NOW INSTALLED IN THE STANDARD MU CALIBRATION FILES.
                USERS SHOULD NOTE THAT THE SHIFTS FOR THE END-WALLS ARE
                LARGE ( TYPICALLY 20 MM ) AND ARE VERY SENSITIVE TO THE
                JET-CHAMBER Z CALIBRATION AND R-Z FITTING PROCEDURE.
                ( THESE CORRECTIONS ARE IGNORED FOR MONTE-CARLO TRACKING
                  AND ANALYSIS. )

08/12/83 :CB    MULDSP HAS BEEN CHANGED SO THAT IN GRAPHICS, MUPT 1000
--------        NOW DRAWS ALL MUON TRACKS WITH THE MUCUTS FLAG (1/2 WORD
                53 FOR A GIEVN TRACK IN MUR2/1) GREATER THAN 0.

07/12/83 :HMCC  THE FOLLOWING ROUTINES WERE CHANGED :
--------
                MUCUTS    A SUBSET OF THOSE TRACKS WHICH GET A
                          NON-ZERO FLAG NOW GET FLAG '5' IN
                          HALF-WORD 53 IF THEY HAVE NO MISSING HITS
                          AND PENETRATE MORE THAN 5.8 ABS LENGTHS.

02/12/83 :HMCC  THE FOLLOWING ROUTINES WERE CHANGED :
--------

                MUFFLE ( AND MACRO CMUFFL )   FOR NEW LEAD GLASS ;
                MUINI     STANDARD USER NOW HAS LEVEL 2 ;
                MUANAF    FOR EBEAM = ZERO , SET EBEAM = 50.

23/11/83 :HMCC  THE FOLLOWING ROUTINES WERE CHANGED :
--------
                MUFFLY    PROTECT CERTAIN ARRAYS FROM OVERFLOW ;
                MUREG     FURTHER ITERATION OF YOKE PARAMETERS.

25/10/83 :HMCC  THE FOLLOWING ROUTINES WERE CHANGED :
--------        MUCOOR    BUGS CONCERNING MISSING-CRATE EVENTS
                          AND CRATES WITH NON-ZERO TIME REFERENCE
                          REMOVED ;
                MUANAC    DATE OF THIS CHANGE ENTERED FOR MUR1/0 .

22/10/83 :HMCC  THE FOLLOWING ROUTINES WERE CHANGED :
--------        MUFFLE    SOME BUGS REMOVED AND MUFFLE/MUREGY "ERROR"
                          SOLVED ;
                MUREG     THE YOKE END PLATE THICKNESS SET TO 340 MM ;
                MUFFLY    CHANGES TO TAKE ACCOUNT OF VARYING YOKE
                          END PLATE THICKNESS  ( CALLS MUENDP ) ;
                MUFFLT        D I T T O     ;

                THE FOLLOWING NEW ROUTINE WAS ADDED :
                MUENDP    DECIDES HOW MUCH IRON A TRACK REALLY GOES
                          THROUGH IN THE YOKE END PLATES ( IN THE
                          CURRENT MUFFLY/MUFFLT STEP FOR WHICH IT
                          HAS BEEN CALLED ) .

 8/08/83 :CB    UPDATE OF JADEMUS/L TODAY
 -------

30/05/83 :HMCC  MUHITS WAS CHANGED AGAIN TO CALL MUANAC DIRECTLY, WITH
--------        COMMON /CMUIEV/ FILLED. THIS WAS REQUIRED IN ORDER THAT
                THE GRAPHICS OVERLAY STRUCTURE COULD BE RETAINED.
                NOTE:
                -----    THIS ROUTINE IS PROVIDED PURELY TO TELL THE
                GRAPHICS PROGRAMME THE NO. OF MUHITS IN AN EVENT.THE
                GENERAL MORAL OF THE COMMENT BELOW STILL APPLIES FOR
                BATCH USAGE.

25/05/83 :HMCC  MUHITS WAS CHANGED TO CALL MUANA(0) INSTEAD OF MUANAC.
--------        CALLS DIRECT TO MUANAC , I.E. WITHOUT GOING THRO' MUANA,
                ARE STRICTLY FORBIDDEN, SINCE SOME HEADER INFORMATION
                FROM THE EVENT IS REQUIRED IN MUCOOR ( AND IN OTHER
                ROUTINES TOO ).  THE EFFECT OF THE PREVIOUS VERSION
                OF MUHITS WAS TO MARK 4 CHAMBERS 'DEAD' INCORRECTLY
                IN THE GRAPHICS MODULE IN THE CASE WHERE THE EVENTS
                BEING EXAMINED HAD NO MUR1 BANK BEFORE INPUT.

30/03/83 :HMCC  MUCOOR CHANGED TO TREAT MONTE-CARLO DATA DIFFERENTLY
--------        FROM REAL DATA. ALSO, I CHANGED THE LOWER LIMIT ON
                KKTD FROM 5 TO 0 FOR SETTING THE RECONSTRUCTED DRIFT
                TIME TO KKTD FOR OVERWRITTEN HIT1'S.

16/03/83 :HMCC  NEW CALIBRATION INSTALLED & THE FOLLOWING ROUTINES
--------        CHANGED :
                MUCOOR    SIGNAL-TO-COORDINATE CONVERSION PROCEDURE
                          RADICALLY CHANGED;
                MUFFLY    CHAMBER TWIST CORRECTIONS TO HIT POSITIONS
                          NOW DONE USING TRACK "Z" COORDINATE ;
                MUANAC    NEW DATE;
                MUFFLE    BLOCK DATA NOW HAS RESOLUTIONS 5MM (BARREL)
                          AND 10MM(ENDWALLS) AND OVLCUT=15MM;
                MUFFLS    MULTIPLE SCATTERING CONSTANT = 15 MEV/C .
                TANTHM IS A NEW ROUTINE.

12/01/83 :HMCC  MUFFLY PROTECTED AGAINST > 20 HITS ASSOCIATED WITH
---------       ONE TRACK ; MESSAGES CHANGED ; MUERRY BUG IN THE
                COUNTING OF MUANAC ERRORS CORRECTED.

11/10/82 :HMCC  A BUG WAS CORRECTED IN THE ROUTINE   MUCUTS  .
---------       THE CORRECTION WAS TO ENSURE THAT HALF-WORD 53 IN
                MUR2/1 IS ALWAYS SET TO ZERO FOR EACH TRACK BEFORE
                CONSIDERING WHETHER THE TRACK SHOULD HAVE IT SET TO 1 .

30/09/82 :HMCC  THE FOLLOWING NOTE WAS ISSUED TO ALL JADE MEMBERS :
---------
                AN ERROR HAS BEEN FOUND IN THE CALIBRATION FILES
                REGARDING THE  ON/OFF  STATUS OF ABOUT 120 MU CHAMBERS
                DURING THE PERIOD  00:00  10/02/82  -  17:00  11/02/82.
                THE ERROR WAS CORRECTED AT 14:00 ON 21/09/82.

                ANYONE WHO IS ANALYSING DATA FROM THIS PERIOD IS
                ADVISED TO RE-ANALYSE IT IN LIGHT OF THE ABOVE CHANGE.
                THE INTEGRATED LUMINOSITY DURING THIS PERIOD WAS AROUND
                OR LESS THAN 200 NB**(-1) .

29/06/82 :HMCC  CMUEDWRK WAS CHANGED.... NCHAN WAS PUT IN /CMUED/
---------       IN ORDER THAT WE DIDN'T HAVE TO INITIALISE
                LOCATIONS IN /CWORK/.   /CMUED/ IS IN A NEW MEMBER
                CALLED CMUED. THE NECESSARY CHANGES WERE MADE TO
                MUCHAN , MUCONE & MUCONW.
          +
                MUINI WAS CHANGED TO REDUCE THE LIMIT ON THE NO.
                OF ERROR MESSAGES FROM MUCOOR ( NOW 50 ).

22/06/82 :HMCC  THE BLOCK DATA BELOW MUCHAN WAS STILL TAKING UP
---------       MORE CORE THAN NECCESSARY DUE TO ABSENCE OF
                THE STATEMENT   '  IMPLICIT INTEGER*2 (H) '   !!
                ------- NOW FIXED.

28/05/82 :HMCC  THE MUCONE-MUCHAN SYSTEM FOR PRODUCING UPDATES IS
---------       NOW INSTALLED ON JADEMUS. A LOT OF CORE WHICH WAS
                BEING NEEDLESSLY TAKEN UP BY /CMUED/ AND LOCAL ARRAY
                IN MUCONW IS NOW SAVED.  IN SUMMARY :
                CMUED        SCRATCHED
                CMUEDWRK     ADDED = NEW VERSION OF CMUED, USES /CWORK/
                MUCONE       NEW VERSION
                            (PREVIOUSLY ON JADEMUS1. MODIFIED AS ABOVE.)
                MUCHAN       NEW ROUTINE.
                            (PREVIOUSLY ON JADEMUS1. MODIFIED AS ABOVE.)
                MUCONW       NEW VERSION. (MODIFIED AS ABOVE.)

24/05/82 :HMCC  MUANAF BUG NOW FIXED. BEAM ENERGY IS NOW CHECKED TO
---------       BE BETWEEN 1 - 50 GEV.

16/03/82 :HMCC  BODGED DEAD CHAMBERS IN MUCOOR ARE NOW CORRECTLY
---------       DISPLAYED IN GRAPHICS REGARDLESS OF RE-ANALYSIS ETC.
                THIS HAS BEEN DONE BY APPLYING THE SAME BODGE TO MUPIC.

23/02/82 :HMCC  SEE (+) ADDITIONAL COMMENT ON 04/02/82 NOTE.
---------

22/02/82 :HMCC  MUCH IMPROVED ERROR OUTPUT INSTALLED.
-----------
            (A) STANDARD USER GETS LEVEL 1 (=MUPRIN IN /CMUPRN/) O/P.
                THIS INCLUDES MISSING BANK ERRORS ETC. FROM
                MUANAC (DEFAULT=20 MUANAC MESSAGES ONLY+OVERFLOW O/P)
                MUANAF   "       " MUANAF   "       ""
                MUCOOR   "      200 MUCOOR  "      ""(SEE (C)  )
                MUCUTS   "       20 MUCUTS  "       "            "
                ALL MUFFLE,M,S,T,R,X,Y,Z ERRORS ARE PRINTED AT LEVEL1.
                MUMESS CALLS ARE PRINTED AT LEVEL 1.
            (B) MUFINI O/P OCCURS AT LEVEL 2.
            (C) MUEV DUMP IS CALLED FOR MUCOOR ERRORS AT LEVEL 3.
            (D) MUDCHK O/P OCCURS AT LEVEL 5.
            (E) MUREG CALLS MUMESS AT LEVELS >5 & <10  .
            (F) IN ORDER TO SUPPRESS ERROR O/P ON GRAPHICS, A VERSION
                OF MUINI CALLED MUINIG HAS BEEN CREATED FOR THE GRAPHICS
                MODULE.


08/02/82 :HMCC THE CHANGE IN KDEPTH LIMIT IN MUFFLY ( BELOW) REQUIRES
-----------   ALSO THAT THE KDEPTH LIMIT IN MUFFLT SHOULD BE INCREASED
              TO 4.   THIS WAS DONE TODAY AT 14.55 .

04/02/82 :HMCC THE FOLLOWING ROUTINES HAVE BEEN ADDED / CHANGED TODAY :
-----------
             MUANA      NOW CALLS MUCUTS  ;
             MUANAF     NOW HAS NTPH=4    ;
             MUCOOR     HAS A BODGE TO SWITCH OFF SEVERAL CHAMBERS
                        ---- THIS IS TEMPORARY UNTIL THE CALIBRATION
                        FILES ARE MODIFIED. NOTE THAT THE GRAPHICS
                        PICTURE SHOWS CHAMBERS AS ACTIVE IF THE
                        CALIBRATION FILES SAY SO(+). THE EFFECT OF THIS
                        MUCOOR BODGE IS TO ENSURE THAT THE MU ANALYSIS
                        IS CORRECT ( WHETHER IN GRAPHICS OR BATCH ) SO
                        NO HITS WILL APPEAR IN THESE CHAMBERS AT THE
                        GRAPHICS TERMINAL FOR THE SPECIFIED PERIODS.
                (+)     IF RE-ANALYSIS IS DONE , EITHER BY MUPT -1
                        OR BY WORKING AT LEVEL 9, THESE CHAMBERS WILL
                        BE SHOWN AS 'OFF' ON THE GRAPHICS SCREEN.
             MUCUTS     NEW ROUTINE. CALLED FROM MUANA AFTER PHIL2
                        ANALYSIS TO EXAMINE THE MUR2 RESULTS BANKS.
                        TRACKS SATISFYING CERTAIN CUTS GET FLAGGED
                        WITH A '1' IN 1/2 WORD 53 OF THE MUR2/1 INFO
                        FOR THIS TRACK.
             MUFFLE     NOW HAS ASSOCIATION 'WINDOW' = 2 STANDARD
                        DEVIATIONS + BUG REMOVED.
             MUFFLX     BUG REMOVED.
             MUFFLY     BUG REMOVED ( KDEPTH LIMIT INCREASED TO 4 ).

02/12/81 :          CALIBRATION UPDATES       HMCC
----------          -------------------
            THE NAMES OF THE CALIBRATION UPDATES HAVE BEEN CHANGED
            FROM E.G.
                      F22ALL.UPDATE01.JADE0017
              TO
                      F22ALL.JADE0017.UPDATE01 .

            THIS MAKES F22ALL'S CATALOGUE LOOK PRETTIER !

12/11/81 :  NEW VERSIONS OF MUCONR AND MUCONW HAVE BEEN PLACED ON
----------  JADEMUS/L . THE PRINCIPAL DIFFERENCES BETWEEN THE NEW
  (C.B.)    VERSIONS AND THE OLD ONES ARE:
            A)  CHANGES ARGUMENTS :
                  -->  CALL MUCONR(LUNIN,HERR)
                                      LUNIN = LOGICAL UNIT NUMBER
                                              OF INPUT CALIBRATION
                                      HERR  = 0 IF NO ERROR
                                              (SEE LISTING FOR DETAILS)
                  -->   CALL MUCONW(IFLG,BOSOUT,JADOUT,HERR)
                                      ILFG  = 1 FOR FULL DS OUTPUT
                                              0 FOR UPDATES ONLY
                                      BOSOUT = LOGICAL UNIT NUMBER OF
                                               THE BOS CALIBRATION O/P
                                      JADOUT = LOGICAL UNIT NUMBER OF
                                               THE JADE FORMAT O/P
                                               (STANDARD JADE CAL. SYS)
                                      HERR   = 0 IF NO ERRORS
            B) COMMON /CMULUN/ IS NO LONGER USED BY MUCONR.
               THIS COMMON IS NOW OBSOLETE.
            C) MUCONW DOES NOT REQUIRE THAT THE OUTPUT LUNS HAVE ANY
               SPECIAL VALUES OR SEQUENCE.
            D) MUCONW OUTPUTS CALIBRATION DATASETS IN BOS (AS BEFORE)
               AND IN THE NEW JADE FORMAT (INSTEAD OF THE OLD NBOS
               FORMAT. THE DIFFERENCE IS THAT JADE FORMAT INCLUDES
               A HEADER.
            E) THE JADE FORMAT OUTPUT CAN BE A FULL DS IF IFLG = 1 ON
               INPUT OR ONLY UPDATES IF IFLG = 0.
            F) MUCONW USES A NEW COMMON MACRO CMUED NOW ON THE JADEMUS/L
               LIBRARY. TO GET UPDATES ONE ALSO NEEDS THE NEW MUCONE AND
               MUCHAN WHICH ARE ON JADEMUS1/L1 AT PRESENT.
            ************************************************************
            *                                                          *
            *   A NEW CALIBRATION PROGRAM WILL SOON REPLACE THE USE    *
            *   OF MUCONE/MUCHAN IN THE NEAR FUTURE.                   *
            *                                                          *
            *   THIS NEW PROGRAM CALLED  E X C A L I B U R  WORKS      *
            *   INTERACTIVELY IN FULL SCREEN MODE.                     *
            *                                                          *
            ************************************************************

05/11/81 :  A TRIVIAL ERROR IN MUANA WAS FIXED. ALTHOUGH TRIVIAL,
----------  THIS CODING ERROR HAD THE EFFECT OF (A) NOT INCREASING
(HMCC)    ITMCUT IN MUCOOR FOR THE BAD GAS PERIOD( RUNS 4220 -
            - 4480 (APPROX)) ;  (B) NOT BODGING THE CRATE 6 VDR
            FOR BAD GAS PERIOD & ALL RUNS JANUARY TILL SUMMER 1981.
              THE ERROR WAS INITIATED ON 20/10/81.

******************************************************************
***   ON 20/10/81 , A NEW VERSION OF THE MUON SOFTWARE WAS     ***
***   IMPLEMENTED .  SEE 'F22ALL.JADEMUS(@MUINFOM)' & JADE     ***
***   COMPUTER NOTE 52 .                                       ***
***     THE MAIN CHANGES ARE AS FOLLOWS :                      ***
***   (A) THE MUON CHAMBER REGIONS ARE ARTIFICIALLY 'EXTENDED' ***
***       SO THAT, EVEN IF AN EXTRAPOLATED TRACK IS SUPPOSED   ***
***       TO (NARROWLY) MISS A CHAMBER REGION , THAT REGION IS ***
***       STILL SEARCHED FOR HITS WITHIN 3 SIGMA.              ***
***   (B) MANY CHANGES HAVE BEEN MADE TO THE GRAPHICS ROUTINES.***
***       THESE ARE EXPLAINED FULLY IN JADE COMPUTER NOTE 52.  ***
***    A COMPLETE RE-ISSUE OF JADE COMPUTER NOTE 22 IS NOT     ***
***    BEING DONE NOW DUE TO THE POSSIBILITY OF FURTHER IMPRO- ***
***    VEMENTS IN THE NEAR FUTURE.                             ***
******************************************************************

C   07/06/96 606071824  MEMBER NAME  BMLTY    (S4)          FORTG1
      SUBROUTINE BMLT(NL,LIST)
C     BOS SUBPROGRAM =1.12=
#include "acs.for"
      COMMON/BCS/IW(1)
C
      INTEGER LIST(1)
C
      IN=MAX0(0,NL)
      IF(IN.EQ.0) GOTO 100
      DO 10 I=1,IN
   10 IW(NLST+I)=IBLN(LIST(I))
      GOTO 100
C
      ENTRY BSAW(NL,LIST)
      MARK=1
      GOTO 30
      ENTRY BSAT(NL,LIST)
      MARK=0
C
   30 IF(NL.LE.0) GOTO 100
      DO 70 LN=1,NL
      IB=IBLN(LIST(LN))
      IF(NS.EQ.0) GOTO 50
      DO 40 I=1,NS
      IF(IB.EQ.IW(ISLST+I)) GOTO 60
   40 CONTINUE
      IF(NS.GE.NLIST) CALL BDMPA(30)
   50 NS=NS+1
      I =NS
      IW(ISLST+I)=IB
   60 IW(IMLST+I)=MARK
   70 CONTINUE
      GOTO 100
C
      ENTRY BDEF(NL,LIST)
      IF(NL.LE.0) GOTO 100
      DO 75 I=1,NL
   75 IDUM=IBLN(LIST(I))
      GOTO 100
C
      ENTRY BSAD(NL,LIST)
      IF(NL.LE.0) GOTO 100
      DO 90 LN=1,NL
      IB=IBLN(LIST(LN))
      IF(NS.EQ.0) GOTO 100
      DO 82 I=1,NS
      IF(IB.EQ.IW(ISLST+I)) GOTO 84
   82 CONTINUE
      GOTO 90
   84 IS=I+1
      IF(IS.GT.NS) GOTO 88
      DO 86 I=IS,NS
      IW(ISLST+I-1)=IW(ISLST+I)
   86 IW(IMLST+I-1)=IW(IMLST+I)
   88 NS=NS-1
   90 CONTINUE
C
  100 RETURN
      END

C   07/11/78 C9060101   MEMBER NAME  GGCLUS   (S)           FORTRAN
      SUBROUTINE GGCLUS(JP,INIT,LNGJP,IER)
C
C     H.WRIEDT      16-11-78  16:40
C     LAST MODIFICATION   09-04-79  14:00
C
C     ORIGINALLY WRITTEN AS 'LGCLUS' BY S.YAMADA
C     AS TO BE FOUND ON YAMLGSRC.S
C
C
C---  LOCATE HIT CLUSTERS IN THE FORWARD DETECTOR  LEAD-GLASS COUNTERS
C---  ADC-S BELONGING TO A CLUSTER ARE GROUPED TOGETHER AND THE MAP OF
C---  THE STARTING MEMBER FOR EACH CLUSTER IS MADE.
C---  (SOME MODIFICATIONS ARE MADE FOR SPEED UP)
C
      IMPLICIT INTEGER*4 (G), INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),HGGADC(2,192),IWORK2(263),
     &               ID,HTRACK(3),HCLST,HCLBEC(2),HNCLST,HCOL,HTYPE,HER,
     &               HCORR,HPBLAT,HDUMIN(2),HSCAL(36),HWORD(2),ACOLAN,
     &               ETOT(3),ENTOT(3),IWORK3(16),HCLMAP(2,51)
C***  COMMON /CGGADC/ LNG,HPOINT(4),HGGADC(2,192)
      COMMON /CGGPRM/ ITH,MAXCLS
C***  COMMON /CGGCLS/ NCLST,NCLBEC(2),HCLMAP(2,51),CLSPRP(10,51),ACOLAN,
C*** &                LCOLIN
C---- HCLST = NO.OF THE LOCATED CLUSTERS.
C---- HCLMAP(J)=THE INDEX OF THE FIRST MEMBER OF THE J-TH CLUSTER
C               IN THE HGGADC.
C
      COMMON /CMSGCT/ MSGDUM(20),GGMMAX,GGMSG1,GGMSG2
      COMMON /CNEIGH/ HLIST(6,96)
C     'HLIST' STORES NEIGHBOUR POSITIONS.
      DIMENSION GGADC(192)
      EQUIVALENCE (GGADC(1),HGGADC(1,1))
C
C---- INPUT
C     JP      PART OF THE LG-COUNTER TO BE ANALYSED, 1 FOR -Z-DIRECTION
C                                          (TOWARDS PLUTO/CELLO)
C                                                    2 FOR +Z-DIRECTION
C                                          (TOWARDS MARK J)
C     INIT    INITIAL DATA IN THE HGGADC FOR THE JP-TH PART
C     LNGJP     NO. OF ADC DATA FOR THE JP-TH PART
C
C---- RELATIVE THERESHOLD TO CONTINUE CLUSTER FINDING.
CCC*  HAS TO BE CHECKED WITH REAL DATA
      DATA IRLTHD/5/, IRLTH2/4/, IRLTH3/2/
C
      COMMON/ CGGVRN/ NVRSN(20)
      DATA NVCODE/178120812/,  MESS/0/
C
C---- INITIAL MESSAGE AND VERSION NO.SET.
      IF(MESS) 1001,1000,1001
 1000 WRITE(6,6000) ITH,MAXCLS,IRLTHD,IRLTH2
 6000 FORMAT('0 THRESHOLD OF CLUSTER SEARCH START=',I3,/' MAX.CLUSTER#='
     $,      I3,/' IRLTHD,IRLTH2=',2I5)
      NVRSN(8) = NVCODE
      MESS = 1
C
 1001 IER = 0
      IF(LNGJP) 80,80,2000
C
C---- ADC DATA SORTING ACCORDING TO THE PULSE HEIGHT
 2000 CALL GGSRTH(INIT-1,LNGJP)
      KEND = INIT+LNGJP-1
C
C---- INITIALIZATION
      HCLST = HCLST+1
      IF(HCLST.GT.MAXCLS) GO TO 90
      HCLMAP(1,HCLST) = INIT
      IPRNT = INIT
C
C---- SET THRESHOLDS
   30 IF(HGGADC(2,IPRNT).LT.ITH) GO TO 70
      IABTHD = HGGADC(2,IPRNT)/IRLTHD
      IABTH2 = HGGADC(2,IPRNT)/IRLTH2
C
C---- NEXT IS THE INDEX OF THE 1-ST NONREPLACED MEMBER.
      NEXT = IPRNT+1
   20 IF(NEXT.GT.KEND) GO TO 4
C---- SET UP THE NEIGHBOUR LIST FOR THE IPRNT-TH ADC.
      JPPRN = HGGADC(1,IPRNT)
      IF (JPPRN.GT.96) JPPRN = JPPRN-96
      NNBR = HLIST(1,JPPRN)+1
C
      GGAPRN = HGGADC(2,IPRNT)
      IABTH3 = GGAPRN*IRLTH3
C---- LOOK FOR DAUGHTERS
      NCAND = NEXT
   10   JPCND = HGGADC(1,NCAND)
        IF (JPCND.GT.96) JPCND = JPCND-96
C----   GLOBAL POSITION CHECK
        JDF = JPCND-JPPRN
        IF(JDF.LT.0) JDF = -JDF
        IF(JDF.GT.11) GO TO 1
C
C----   CAND IS CLOSE TO PRNT.SURVEY THE NEIGHBOUR TABLE.
          DO 2 NN=2,NNBR
          IF(JPCND.EQ.HLIST(NN,JPPRN)) GO TO 40
    2     CONTINUE
        GO TO 1
C
C----   A NEIGHBOUR IS FOUND. CHECK PULSE HEIGHT.
   40   IF(GGAPRN.GE.IABTHD) GO TO 3
C----   TAIL OF THE CLUSTER
        IF(HGGADC(2,NCAND).GT.IABTH2) GO TO 1
        IF(HGGADC(2,NCAND).GT.IABTH3) GO TO 1
C
C----   THE FOUND NEIGHBOUR IS MOVED TO FOLLOW THE PARENT.
    3   IF(NEXT-NCAND) 6,5,5
    6   LWORK = GGADC(NCAND)
C       SHIFT THE DATA BETWEEN NEXT AND NCAND.
        NSHIFT = NCAND-NEXT
          DO 60 NN=1,NSHIFT
          LL = NCAND-NN
          GGADC(LL+1) = GGADC(LL)
   60     CONTINUE
        GGADC(NEXT) = LWORK
C       PROCEED TO THE NEXT PLACE.
    5   NEXT = NEXT+1
    1   NCAND = NCAND+1
      IF(NCAND.LE.KEND) GO TO 10
C
C---- A SURVEY IS OVER FOR A PARENT.
C---- IF A NEW NEIGHBOUR WAS FOUND,TREAT IT AS A PARENT.
      IPRNT = IPRNT+1
      IF(IPRNT.LT.NEXT) GO TO 20
C
C---- ALL NEIGHBOURS ARE ALREADY FOUND.
C     STORE THE LAST INDEX OF THE ACTUAL CLUSTER & THE FIRST INDEX
C     OF THE FOLLOWING CLUSTER INTO HCLMAP
    4 HCLMAP(2,HCLST) = NEXT-1
      HCLST = HCLST+1
      IF(HCLST.GT.MAXCLS) GO TO 90
      HCLMAP(1,HCLST) = NEXT
C---- CHECK IF ANY MORE DATA IS LEFT
      IF(NEXT.LE.KEND) GO TO 30
C
C---- CLUSTER SEARCH IS FINISHED.
C
C---- SET THE LAST CLUSTER NO. FOR EACH PART INTO NCLBEC
   70 HCLST = HCLST-1
      HNCLST = HCLST
   80 HCLBEC(JP) = HCLST
      GO TO 100
C
C---- TOO MANY CLUSTER
   90 HCLBEC(JP) = HCLST-1
      IF(GGMSG1) 100,91,91
   91 GGMSG1 = GGMSG1+1
      IF(GGMSG1.LE.GGMMAX) WRITE(6,690)
  690 FORMAT(' ******* TOO MANY LG-CLUSTERS *******')
      IER = 1
  100 RETURN
      END
      BLOCK DATA
      COMMON /CNEIGH/ HLIST(6,96)
C
C---  THE COMMON 'CNEIGH' IS USED BY 'GGCLUS',
C---  'HLIST' CONTAINS THE NEIGHBOURING BLOCKS OF EACH BLOCK
C---  (FROM BLOCK-NO. 1 TO NO. 96)
C---  THE BLOCKS 47, 48, 95, AND 96 ARE ONLY FICTICIOUS ONES!
      INTEGER*2 HLIST, HLIST1(6,19), HLIST2(6,19), HLIST3(6,10)
      INTEGER*2 HLIST4(6,8), HLIST5(6,19), HLIST6(6,21)
      EQUIVALENCE (HLIST(1,1),HLIST1(1,1)), (HLIST(1,20),HLIST2(1,1))
      EQUIVALENCE (HLIST(1,39),HLIST3(1,1)), (HLIST(1,49),HLIST4(1,1))
      EQUIVALENCE (HLIST(1,57),HLIST5(1,1)), (HLIST(1,76),HLIST6(1,1))
      DATA HLIST1/ 3, 2,5,6, 2*0,
     2 3, 1,3,7, 2*0,
     3 3, 2,8,9, 2*0,
     4 2, 5,12, 3*0,
     5 4, 1,4,6,13, 0,
     6 5, 1,5,7,13,14,
     7 4, 2,6,8,15, 0,
     8 5, 3,7,9,16,17,
     9 4, 3,8,10,17, 0,
     & 2, 9,18, 3*0,
     1 2, 12,21, 3*0,
     2 4, 4,11,13,22, 0,
     3 5, 5,6,12,14,23,
     4 5, 6,13,15,23,24,
     5 4, 7,14,16,25, 0,
     6 5, 8,15,17,26,27,
     7 5, 8,9,16,18,27,
     8 4, 10,17,19,28, 0,
     9 2, 18,29, 3*0/
      DATA HLIST2/ 2, 21,31, 3*0,
     1 4, 11,20,22,32, 0,
     2 4, 12,21,23,33, 0,
     3 5, 13,14,22,24,34,
     4 4, 14,23,25,34, 0,
     5 3, 15,24,26, 2*0,
     6 4, 16,25,27,35, 0,
     7 5, 16,17,26,28,35,
     8 4, 18,27,29,36, 0,
     9 4, 19,28,30,37, 0,
     & 2, 29,38, 3*0,
     1 4, 20,32,39,40, 0,
     2 5, 21,31,33,40,41,
     3 5, 22,32,34,41,42,
     4 4, 23,24,33,42, 0,
     5 4, 26,27,36,43, 0,
     6 5, 28,35,37,43,44,
     7 5, 29,36,38,44,45,
     8 4, 30,37,45,46, 0/
      DATA HLIST3/ 3, 31,40,49, 2*0,
     & 5, 31,32,39,41,50,
     1 5, 32,33,40,42,51,
     2 4, 33,34,41,52, 0,
     3 4, 35,36,44,53, 0,
     4 5, 36,37,43,45,54,
     5 5, 37,38,44,46,55,
     6 3, 38,45,56, 2*0,
     7 0, 5*0,
     8 0, 5*0/
      DATA HLIST4/ 3, 39,50,57, 2*0,
     & 5, 40,49,51,57,58,
     1 5, 41,50,52,58,59,
     2 4, 42,51,59,60, 0,
     3 4, 43,54,61,62, 0,
     4 5, 44,53,55,62,63,
     5 5, 45,54,56,63,64,
     6 3, 46,55,64, 2*0/
      DATA HLIST5/ 4, 49,50,58,65, 0,
     8 5, 50,51,57,59,66,
     9 5, 51,52,58,60,67,
     & 4, 52,59,68,69, 0,
     1 4, 53,62,71,72, 0,
     2 5, 53,54,61,63,73,
     3 5, 54,55,62,64,74,
     4 4, 55,56,63,75, 0,
     5 2, 57,66, 3*0,
     6 4, 58,65,67,76, 0,
     7 4, 59,66,68,77, 0,
     8 5, 60,67,69,78,79,
     9 4, 60,68,70,79, 0,
     & 3, 69,71,80, 2*0,
     1 4, 61,70,72,81, 0,
     2 5, 61,71,73,81,82,
     3 4, 62,72,74,83, 0,
     4 4, 63,73,75,84, 0,
     5 2, 64,74, 3*0/
      DATA HLIST6/ 2, 66,77, 3*0,
     7 4, 67,76,78,85, 0,
     8 5, 68,77,79,86,87,
     9 5, 68,69,78,80,87,
     & 4, 70,79,81,88, 0,
     1 5, 71,72,80,82,89,
     2 5, 72,81,83,89,90,
     3 4, 73,82,84,91, 0,
     4 2, 74,83, 3*0,
     5 2, 77,86, 3*0,
     6 4, 78,85,87,92, 0,
     7 5, 78,79,86,88,92,
     8 4, 80,87,89,93, 0,
     9 5, 81,82,88,90,94,
     & 4, 82,89,91,94, 0,
     1 2, 83,90, 3*0,
     2 3, 86,87,93, 2*0,
     3 3, 88,92,94, 2*0,
     4 3, 89,90,93, 2*0,   0, 5*0,   0, 5*0/
      END

      COMMON/TFPRM/ CORNOR(84),COROVF(84),TPARM(41),VELSC,TCALM(42),
     1 TCALP(42),PEDLM(42),PEDLP(42),TCPDM(42),TCPDP(42),DUM(6)
      COMMON/TFPRM1/ TCALM2(42),TCALP2(42),TCPDM2(42),TCPDP2(42)
     1 ,VSC(84)

C   20/03/85 503291845  MEMBER NAME  MUANA    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE  MUANA( IJOIN )
C-----------------------------------------------------------------------
C
C        THIS ROUTINES COORDINATES MUON ANALYSIS IN JADE
C
C LAST CHANGE 13.30 20/03/85 CHRIS BOWDERY- CORRECT RUN YEAR IF NEEDED.
C      CHANGE 13.30 22/02/82 HUGH MCCANN - FOR IMPROVED ERROR OUTPUT.
C      CHANGE 15.30 04/02/82 HUGH MCCANN - NOW CALLS MUCUTS.
C      CHANGE 15.15 05/11/81 HUGH MCCANN - CORRECT BUG , IMP INT*2!!
C      CHANGE 17.46 19/10/81 CHRIS BOWDERY- INSERT MACRO CMUBCS
C      CHANGE 12.30 19/10/81 HUGH MCCANN  - INSERT COMMON CMUIEV.
C      CHANGE 09.12 13/05/80 JOHN ALLISON --COMMENT OUT CALL MUANAJ.
C      CHANGE 16.00 02/05/80 HUGH MCCANN ---COMMENT OUT CALL MUANAL.
C      CHANGE 10.56 18/05/79 JOHN ALLISON.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
C------------------  C O D E  ------------------------------------------
C
C
C                            STANDARD MUON ANALYSIS PROCEDURE
C
C                            IJOIN = 0   SUPPRESSES CALLS TO ROUTINES
C                            WHICH USE BANKS OTHER THAN MUON BANKS
C
C
C                            BEGIN BY EXTRACTING DATA FROM HEAD BANK
C
      CALL MUANAB
C
C                            CONVERT MUON SIGNALS TO COORDINATES
C
      CALL MUANAC
C
C                            FOLLOW EACH INNER DETECTOR TRACK OUT
C                            (PHILOSOPHY 2).  AT THE MOMENT, MUANAF
C                            AND MUANAL ARE COMPLETELY INDEPENDENT
C
      IF( IJOIN .NE. 0 ) CALL MUANAF
      IF( IJOIN .NE. 0 ) CALL MUCUTS
C
C                            ****** FROM 18/03/80 , ONLY WANT PHIL2
C                            RUN IN STANDARD MU ANALYSIS. THIS WILL BE
C                            DONE IF 'IJOIN' IS GREATER THAN ZERO .
C
C
C                            FIND MUON LINES - PHILOSOPHY 1 MUON
C                            PATTERN RECOGNITION.
C
C     CALL MUANAL
C
C                            ATTEMPT TO JOIN MUON CLUSTERS WITH INNER
C                            DETECTOR TRACKS AND WITH LG CLUSTERS. ALSO
C                            CORRELATE RESULTS OF PHILOSPHY 1 AND 2.
C
C     IF( IJOIN .NE. 0 ) CALL MUANAJ
C
C
      RETURN
      END

C   20/10/81 508071748  MEMBER NAME  MUFMAT   (JADEMUS)     FORTRAN
C
C LAST CHANGE 18.00  7/08/85 ROGER BARLOW - SYMIN4 BUG AVOIDED
C      CHANGE 17.20 06/05/83 CHRIS BOWDERY-CORRECTED ERROR MESSAGE
C      CHANGE 14.30 21/10/81 HUGH MCCANN - RENAMED TO MUFMAT.
C      CHANGE 11.30 18/10/81 HUGH MCCANN - SYMIN4 SUBSTITUTED FOR MATIN100000400
C
C-----------------------------------------------------------------------
      SUBROUTINE MUFMAT(NTHISS,MERR)
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION HAMB(1)
C
C ASSEMBLES THE ERROR MATRIX FOR A GIVEN HIT/ AMBIGUITY PERMUTATION
C AND INVERTS IT.
C MERR =1 IF NDFT .LE. 0 OR THERE IS A SYMIN4 ERROR, OTHERWISE , =0.
C
C-----------------------------------------------------------------------
C
C             COMMONS.
C
#include "cmufwork.for"
C             INITIALISE ERROR FLAG.
      MERR=1
C
C             SELECT ERROR MATRIX AND INVERT IT.
      NDFT=0
      K=1
      DO 40 I=1,NTHISS
      IT=2*I-1
C             IS  THIS  HIT  IN  THE  PRESENT  HIT  PERMUTATION  ?
C             EVEN TEMPORARILY ?
      IF(IHTPER(I).NE.1.AND.IHTEMP(I).NE.1)GO TO 40
      IF(BADA(IT))GO TO 40
      L=1
      DO 41 J=1,NTHISS
      JT=2*J-1
      IF(IHTPER(J).NE.1.AND.IHTEMP(J).NE.1)GO TO 41
      IF(BADA(JT))GO TO 41
      G(K,L)=EM(IT,JT)
      L=L+1
 41   CONTINUE
      K=K+1
 40   CONTINUE
      NDFT=K-1
      IF(NDFT.LE.0)RETURN
      MERR=0
C
C++++
C     WRITE(6,2848)NDFT
C2848 FORMAT(I5,' COORDS IN DRIFT CALCULATION.',
C    *' SPECIFIC ERROR MATRIX IS')
C     CALL UCOPY(G,EM1,400)
C     DO 2849 I=1,NDFT
C     WRITE(6,2858)(EM1(I,J),J=1,NDFT)
C2858 FORMAT(12F10.0)
C2849 CONTINUE
C     WRITE(6,2859)(DEVA(I),I=1,NDFTL)
C2859 FORMAT(' CORRESPONDING DEVIATIONS'/(12F10.0))
C++++
C
C             INVERT MATRIX.
       IF (NDFT.NE.2) GOTO 664
       DETER=G(1,1)*G(2,2)-G(1,2)**2
       IER=1
       IF(DETER.EQ.0.0) GOTO 98
       IER=0
       G(1,2)=-G(1,2)/DETER
       G(2,1)=-G(2,1)/DETER
       SSAVE=G(1,1)
       G(1,1)=G(2,2)/DETER
       G(2,2)=SSAVE/DETER
       GOTO 665
664   CALL SYMIN4(G,20,NDFT,MWORK,IER)
665   IF(IER.NE.0)GO TO 98
C++++
C     WRITE(6,2861)IER
C2861 FORMAT(' IER',I5)
C     WRITE(6,2838)
C2838 FORMAT(' INVERSE ERROR MATRIX IS')
C     DO 2839 I=1,NDFT
C     WRITE(6,2840)(G(I,J),J=1,NDFT)
C2840 FORMAT(10E12.4)
C2839 CONTINUE
C     DO 3951 I=1,NDFT
C     DO 3951 J=1,NDFT
C     EMG(I,J)=0.
C     DO 3951 K=1,NDFT
C3951 EMG(I,J)=EMG(I,J)+EM1(I,K)*G(K,J)
C     WRITE(6,2138)
C2138 FORMAT(' PRODUCT MATRIX IS')
C     DO 2139 I=1,NDFT
C     WRITE(6,2140)(EMG(I,J),J=1,NDFT)
C2140 FORMAT(10E12.4)
C2139 CONTINUE
C++++
C
      GO TO 99
C
C-----------------------------------------------------------------------
C
 98   CONTINUE
      CALL MUERRY('MUFMAT',IER,'ERROR RETURN FROM SYMIN4.^')
      MERR=1
      GO TO 99
C
C-----------------------------------------------------------------------
C
 99   CONTINUE
      RETURN
      END

C   07/06/96 606071832  MEMBER NAME  BRUTH    (S4)          FORTG1
      SUBROUTINE BRUTH(IA,IB,IC)
C             FOR RUTHERFORD LAB ONLY
C     BOS SUBPROGRAM =1.XX=
#include "acs.for"
      IA=NLST
      IB=NCI
      IC=NAMAX
  100 RETURN
      END

C   07/11/86 702121551  MEMBER NAME  ZE4VTP   (S)           FORTRAN77
      SUBROUTINE ZE4VTP( IGEN )
C-----------------------------------------------------------
C VERSION OF 11/11/86       M.ZIMMER
C LAST MOD   27/11/86       M.ZIMMER
C LAST MOD   29/01/87       G.ECKERLIN
C NEW VERSION FOR NEW ZE4V-BANK
C PACK INFORMATION AS FAR AS POSSIBLE FROM TP-BANK
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON P(10,400)
      DIMENSION IP(10,100),HP(20,1)
      EQUIVALENCE (P(1,1),IP(1,1),HP(1,1))
C
      DIMENSION R(3), VECTB(1000)
      INTEGER NWARN(2) / 2*0 /
      DATA IEV / 0 /, IEVLIM / 0 /
C
      EXTERNAL VECSUB
C
C                                           CUT PARAMETERS
C                                           RMIN CUT
      DATA RMINCT /  50. /
C                                           Z-CUT
      DATA ZCT    / 350. /
C                                           MIN R-PHI-HITS
      DATA NRPHCT / 20 /
C                                           MIN R-Z-HITS
      DATA NRZCT  / 12 /
C                                           MOMENTUM CUT
      DATA PCT   / .05 /
C                                           LG MIN ENERGY
      DATA ELGPHM / .150 /
C                                           LG SUBTRACTION ENERGY
      DATA ELGMIN /    .350 /
C                                           FORMAT OF ZE4V BANK
      DATA  LH / 31 /, LT / 9 /, LVX / 3 /, LMC / 0 /,
     & LTCH / 12 /, LTNE / 5 /, LTRE / 0 /
C                                      MIN/MAX OF PART. FOR THR-SPH-AKO
C                                      FOR TEST DATA ONLY
      DATA NPAMIN / 1 / , NPAMAX / 7 /

      LVECS = 0
      GO TO 1
      ENTRY ZE4VUP( NST, N, IGEN )
C--------------------------------------------------------
C  ENTRY FOR VECSUB OPTION
C  LEAVES PARTICLES IN BLANK COMMON
C--------------------------------------------------------
      LVECS = 1
    1 CONTINUE
      IEV = IEV + 1
C
C                                      LOOK FOR BANKS
      NPZE4V = IW( IBLN('ZE4V'))
      IF( NPZE4V .GT. 0 ) CALL BDLS( 'ZE4V',IGEN)
      NPTPEV = IW(IBLN('TPEV'))
      IF( NPTPEV .LE. 0 )   CALL FEHLER( 1, &8000 )
      NTR = HW( NPTPEV*2 + 5 )
      IF( NTR .LE. 0 )   CALL FEHLER( 3, &8000 )
      NVX = HW( NPTPEV*2 + 12 )
      IF ( NVX .LT. 1 )     CALL FEHLER( 5, &8000 )
      NPPATR = IW( IBLN('PATR'))
      IF( NPPATR .LE. 0)    CALL FEHLER( 7, &8000 )
      LTPATR = IW( NPPATR + 3 )
      LHPATR = IW( NPPATR + 1 )
C
C                                      LENGTH OF HEADER
      LHEAD = LH + NVX*LVX
C                                      IF MC : LHEAD + LMC
      IF (MCFLAG.NE.0) LHEAD = LHEAD + LMC

C                                           CREATE ZE4V HEAD
      CALL BCRE( NPZE4V, 'ZE4V', IGEN, LHEAD, &8100, IER )
      CALL BSAW( 1, 'ZE4V' )
C
      HW(NPZE4V*2+ 1) = LHEAD
      HW(NPZE4V*2+ 2) = LVX
      HW(NPZE4V*2+ 3) = NVX
C                                      MONTE-CARLO PART
      HW(NPZE4V*2+ 4) = LMC
C                                      GENARAL TRACK PART
      HW(NPZE4V*2+ 5) = LT
C                                      TOTAL NUMBER OF PARTICLES
      HW(NPZE4V*2+ 6) = 0
C                                      CHARGED TRACK PART
      HW(NPZE4V*2+ 7) = LTCH
      HW(NPZE4V*2+ 8) = 0
C                                      NEUTRAL TRACK PART
      HW(NPZE4V*2+ 9) = LTNE
      HW(NPZE4V*2+10) = 0
C                                      RECONSTRUCTED TRACK PART
      HW(NPZE4V*2+11) = LTRE
      HW(NPZE4V*2+12) = 0
C                                      RUN/EVENT #
      IW(NPZE4V  + 7) = IRNEVT( DUMMY )
C                                           EBEAM
      EBE = EBGENL( DUMMY )
      RW(NPZE4V  + 8) = EBE
C                                      E-VIS FROM TP (CH + NEUTR)
      RW(NPZE4V  + 29) = RW( NPTPEV + 18) + RW( NPTPEV + 20 )
C                                      E-VIS FROM TP (NEUTRAL)
      RW(NPZE4V  + 30) = RW( NPTPEV + 20)
C                                      ACCEPT EVENT BY MCREDU
      MRFLAG = -1
      CALL MCREDU( 0., &2040 )
C                                      EVENT ACCEPTED
      MRFLAG = 1
 2040 CONTINUE
      IW( NPZE4V + 31 ) = MRFLAG
C
C                                           SET VERTEX HERE
      KPTPVX = IW( IBLN( 'TPVX'))
      IF( KPTPVX .LE. 0 ) CALL FEHLER( 34, &3546 )
 3546 CONTINUE
      CALL BPOS( 'TPVX' )
C                                      FILL VERTEX
      DO 1020 I0 = 1,NVX
        CALL BNXT( NPTPVX, &8020 )
        DO 1020 I=1,3
          IF( NPTPVX .LE. 0 ) THEN
            R(I) = 0.
          ELSE
            R(I) = RW( NPTPVX + 1 + I )
          ENDIF
          RW(NPZE4V + LH + LVX*(I0-1) + I) = R(I)
 1020 CONTINUE
C                                           MC PART OF HEADER
C                                           FILLED FROM VECT BANK
C
      IF(MCFLAG.EQ.0.) GOTO 4213
C
      NPVECT = IW(IBLN('VECT'))
      IF(NPVECT.GT.0) GO TO 4119
       WRITE(6,9212) HW(NPZE4V*2+14),HW(NPZE4V*2+13)
9212   FORMAT(' NO VECT BANK IN EVENT ',I8,'  RUN ',I8)
       GOTO 4213
4119  CONTINUE
C
C                                        START VECT-ANALYSIS
C
C                                        POINTER TO MC PART IN ZE4V
      NPMC = LH + NVX*LVX

      HLENG = IW(NPVECT+1)
      IEVT = IW(NPVECT+3)
      NPARMC = IW(NPVECT+4)
      DO 4118 IMC=1,6
      VECTB(IMC) = FLOAT(IW(NPVECT+IMC))
4118  CONTINUE
      VECTB(7) = RW(NPVECT+7)
      VECTB(8) = RW(NPVECT+8)
      VECTB(9) = FLOAT(IW(NPVECT+9))
      NFLAV = IABS(IW(NPVECT+9))
      VECTB(10) = 0.
      DO 4320 IMC = 1,NPARMC
      JMC = 10 * IMC
      K = JMC + HLENG - 10
      VECTB(JMC+1) = RW(NPVECT+K+1)
      VECTB(JMC+2) = RW(NPVECT+K+2)
      VECTB(JMC+3) = RW(NPVECT+K+3)
      VECTB(JMC+4) = RW(NPVECT+K+4)
      VECTB(JMC+5) = RW(NPVECT+K+5)
      VECTB(JMC+8) = RW(NPVECT+K+8)
      VECTB(JMC+9) = RW(NPVECT+K+9)
      VECTB(JMC+10) = RW(NPVECT+K+10)
      VECTB(JMC+6) = FLOAT(IW(NPVECT+K+6))
      VECTB(JMC+7) = FLOAT(IW(NPVECT+K+7))
4320  CONTINUE
C
C                                        FIND NO OF JETS
C
      NJET = 0
      DO 4110 IMC=1,4
      IND = (NPARMC-IMC+1)*10
      IF(VECTB(IND+7).GE.-100.) GOTO 4313
      NJET = NJET + 1
      RW(NPMC + (IMC-1)*4 + 2) = VECTB(IND+1)
      RW(NPMC + (IMC-1)*4 + 3) = VECTB(IND+1)
      RW(NPMC + (IMC-1)*4 + 4) = VECTB(IND+1)
      RW(NPMC + (IMC-1)*4 + 5) = VECTB(IND+1)
      GOTO 4110
4313  CONTINUE
      RW(NPMC + (IMC-1)*4 + 2) = 0.
      RW(NPMC + (IMC-1)*4 + 3) = 0.
      RW(NPMC + (IMC-1)*4 + 4) = 0.
      RW(NPMC + (IMC-1)*4 + 5) = 0.
4110  CONTINUE
      HW(NPMC*2 + 1) = NJET
      HW(NPMC*2 + 2) = NFLAV
C
4213  CONTINUE
C
C                                           END OF MC PART
C
      NPPHOT = IW( IBLN('PHOT'))
C                                           LOOP OVER TPTR BANKS
      CALL BPOS( 'TPTR' )
C                                           LOOP OVER TRACKS
      DO 300 J = 1, NTR
        NRPHI = 0
        NRZ = 0
        CALL BNXT( NPTPTR, &300 )
        INFOVX = HW( NPTPTR*2 + 2 )
        IF( INFOVX .LT. 0 .OR. INFOVX .GT. 10 )
     &                                CALL FEHLER( 15, &300 )
        CHARGE = RW( NPTPTR + 23 )
C
        IF ( ABS( CHARGE ) .GT. .5 .AND. NPPATR .GT. 0 )     THEN
           NRPATR = HW( NPTPTR*2 + 4)
           NPTRAK = NPPATR + LHPATR + (NRPATR-1)*LTPATR
           CALL PRTOCI( NPTRAK, CAP, RMIN, PHIM, SIG )
           NRPHI = IW (NPTRAK + 24)
           NRZ   = IW (NPTRAK + 33)
           IF( NRPHI .LT. NRPHCT )   CALL FEHLER( 17, &300 )
           IF( NRZ .LT. NRZCT )         CALL FEHLER( 19, &300 )
C          RMIN = RW( NPTPTR + 16 )
           IF( ABS( RMIN ) .GT. RMINCT ) CALL FEHLER ( 11, &300 )
           AZV = ABS( RW( NPTRAK + 31) )
           IF( AZV .GT. ZCT )           CALL FEHLER( 21, &300 )
        ENDIF
        PTOT = RW( NPTPTR + 24 )
        IF( PTOT .LT. PCT )  THEN
                                      CALL FEHLER ( 13, &300 )
               WRITE(6,*) '!!!!  PTOT NOT PASSED !!!!!!!!!!!!!!!!!'
           ENDIF
C                                      ACCEPT THIS TRACK
C                                      FILL GLOBAL PART FOR EACH TRACK
C                                      EXTEND BANK
        CALL BCHM( NPZE4V, LT, IER )
C                                      POINTER TO NEXT ZE4V-WORD
        NP = NPZE4V + LHEAD + HW( NPZE4V*2 + 6) * LT
     &                      + HW( NPZE4V*2 + 8) * LTCH
     &                      + HW( NPZE4V*2 +10) * LTNE
     &                      + HW( NPZE4V*2 +12) * LTRE
        NP2 = NP * 2
C                                      EX,EY,EZ
        DO 1200 I = 1,3
          RW( NP + I ) = RW( NPTPTR + 26 + I )
 1200   CONTINUE
C                                      PARTICLE CODE (MC-CONV)
        HW(NP2 + 8) = HW(NPTPTR*2 + 68 )
C                                      # OF VERTEX OF PARTICLE ORIGIN
        HW(NP2 + 9) = HW( NPTPTR*2 + 1)
C                                      # OF SEC VERTEX
        HW(NP2 +10) = HW( NPTPTR*2 + 2)
C                                      MOMENTUM
        FAC = 1.
        IF( PTOT .GT. EBE ) FAC = .5*EBE /PTOT
        RW(NP + 6) = PTOT*FAC
        RW(NP + 7) =  CHARGE
C
        NPART = 0
        IF( NPPATR .GT. 0 .AND. NPPHOT  .GT. 0 ) THEN
          NPHOT = NPPHOT
  210     CONTINUE
          IF( NPHOT.LE.0 .OR. NPART.GT.0 ) GO TO 215
          IF(IW(NPHOT+24).EQ.IW(NPTRAK+1)) NPART = IW(NPHOT+25)
          IF(IW(NPHOT+25).EQ.IW(NPTRAK+1)) NPART = IW(NPHOT+24)
          NPHOT = IW( NPHOT - 1 )
          GO TO 210
  215   ENDIF
C                                      PATR NUMBER OF PHOT PARTNER
  220   HW( NP2 + 7 ) = NPART
C                                           MC PART
C                                      0 OR PART# IN PALL BANK (HW(+15))
C                                      0 OR ELECTRON ORIGIN    (HW(+16))
        IW( NP + 8 ) = 0
CCC     IF( HW(NPZE4V*2+5).LT.100 .AND. NPPATR .GT. 0)
        IF( MCFLAG.NE.0 .AND. NPPATR .GT. 0)
     *      CALL ZE4VMC( IW(NPTRAK+1), IW( NP+8 ) )
C                                        # OF TPTR BANK
        HW( NP2 + 17 ) = IW( NPTPTR - 2 )
C
C                                      LG-INFORMATION
        JCLUS1 = HW(NPTPTR*2 + 6)
        JCLUS2 = HW(NPTPTR*2 + 7)
        SIGECL =  0.
        ECL    =  0.
        JBAREC =  0
        NBLOCK = 0
        IF (JCLUS1.LE.0) GOTO 3123
        NPLGCL = IW(IBLN('LGCL'))
        IF ( NPLGCL .GT. 0 ) THEN
          IPENDE = IW( NPLGCL + 4 )
          IP3 = IW( NPLGCL + 3 )
          NWPCL = IW( NPLGCL + 25 )
          NPOINT = NPLGCL + IP3 + (JCLUS1-1) * NWPCL -1
          IF ( NPOINT .GT. ( NPLGCL + IPENDE )) CALL FEHLER( 23,&3123)
          ECL    = RW( NPOINT + 2 )
          SIGECL = RW( NPOINT + 3 )
          JBAREC = IW( NPOINT + 1 )
          ICON = IW(NPOINT + 8)
          ICL =    ( NPLGCL + 25 + JCLUS1 ) * 2
          NBLOCK = HW(ICL) - HW(ICL-1) + 1 - ICON/100
C                               CORRECT ENERGY FOR CONNECTED CLUSTER
          DZDS = 1.
          IF( JBAREC.EQ.0 ) DZDS = 1./SQRT(1-RW(NPOINT+11)**2)
          IF( ICON .NE. 0 .AND. FAC .EQ. 1.)
     &    RW(NP + 6) = RW(NP + 6) - (ICON/100) * ELGMIN * DZDS
        ELSE
          CALL FEHLER( 25, &3123)
        ENDIF
 3123   CONTINUE
C
C                                      FILL SPECIAL TRACK PART
C
C------------------------------------- CHARGED PRIMARY -----------
C
        IF( ABS(CHARGE) .GT. .5 .AND. INFOVX .EQ. 0 ) THEN
C
          HW(NPZE4V*2 + 8 ) = HW(NPZE4V*2 + 8) + 1
          HW(NPZE4V*2 + 6 ) = HW(NPZE4V*2 + 6) + 1
          HW(NP2 + 18 ) = 1
          CALL BCHM( NPZE4V, LTCH, IER )
C                                      CLUSTER-ENRGY IN GEV
          RW( NP  + LT + 1 ) = ECL
C                                      ERROR IN CLUSTER-ENRGY
          RW( NP  + LT + 2 ) = SIGECL
C                                      CORRECTED CLUSTER ENERGY(NOT YET)
          RW( NP  + LT + 3 ) = 0.
C                                      DETECTOR FLAG
          HW( NP2 + LT*2 + 7) = HW( NPTPTR*2 + 3 )
C                                      #OF 1. AND 2. CONN. CLUSTER
          HW( NP2 + LT*2 + 8) = JCLUS1 + 100*JCLUS2
C                                      # IN PATR-BANK
          HW( NP2 + LT*2 + 9) = HW( NPTPTR*2 + 4 )
C                                      NRPHI + 100*NRZ
          HW( NP2 + LT*2 +10) = NRPHI + 100*NRZ
C                                      (X,Y,Z) TRACK AT DOCA
          RW( NP + LT + 6 ) = RW( NPTPTR + 10 )
          RW( NP + LT + 7 ) = RW( NPTPTR + 11 )
          RW( NP + LT + 8 ) = RW( NPTPTR + 12 )
C                                      DEDX
          RW( NP + LT + 9 ) = RW( NPTPTR + 73 )
          RW( NP + LT +10 ) = RW( NPTPTR + 74 )
          RW( NP + LT +11 ) = RMIN
C                                      MUON QUALITY NUMBER
          RW( NP + LT +12 ) = HW( NPTPTR*2 + 96 )
C
C------------------------------------- NEUTRAL PRIMARY
C
        ELSEIF ( ABS(CHARGE) .LT. .5 .AND. INFOVX .EQ. 0 ) THEN
C
          HW(NPZE4V*2 + 10) = HW(NPZE4V*2 + 10) + 1
          HW(NPZE4V*2 + 6)  = HW(NPZE4V*2 + 6 ) + 1
          HW(NP2 + 18 ) = 0
          CALL BCHM( NPZE4V, LTNE, IER )
C                                      CLUSTER-ENRGY IN GEV
          RW( NP + LT + 1 ) = ECL
C                                      ERROR IN CLUSTER-ENRGY
          RW( NP + LT + 2 ) = SIGECL
C                                      CORRECTED CLUSTER ENERGY(NOT YET)
          RW( NP + LT + 3 ) = 0.
C                                      LG DETECTOR PART
          HW( NP2 + LT*2 + 7) = JBAREC
C                                      #OF 1. AND 2. CONN. CLUSTER
          HW( NP2 + LT*2 + 8) = JCLUS1 + 100*JCLUS2
C                                      NUMBER OF LG-BL. - CONN. TRACKS
          HW( NP2 + LT*2 + 9) = NBLOCK
          HW( NP2 + LT*2 +10) = 0
C
C------------------------------------- RECONSTRUCTED SECONDARY
C
        ELSEIF( INFOVX. GT. 0 ) THEN
C
          HW( NPZE4V*2 + 12) = HW( NPZE4V*2 + 12) + 1
          HW( NPZE4V*2 + 6 ) = HW( NPZE4V*2 + 6 ) + 1
          HW(NP2 + 18 ) = 2
          CALL BCHM( NPZE4V, LTRE, IER )
C
        ELSE
          CALL BCHM( NPZE4V, (-1)*LT, IER)
          CALL FEHLER( 27, &300 )
        ENDIF
  300 CONTINUE
C
 2050 CONTINUE
C
      IF( LVECS.NE.0 ) GO TO 2100
         N = HW( NPZE4V*2 + 6 )
         IF( N .LT. NPAMIN ) THEN
            CALL BDLS( 'ZE4V', IGEN )
                             CALL FEHLER( 31, &8000)
         ELSEIF ( N .GT. NPAMAX ) THEN
            CALL BDLS( 'ZE4V',IGEN )
                             CALL FEHLER( 33, &8000)
         ENDIF
C
         NST = 0
C                                           SAVE AWAY BLANK COMMON
         CALL BCRE( NPBUF, '--BU', 0 , 10*(N+5), &8200, IER )
         CALL UCOPY( P(1,NST+1), RW(NPBUF+1), 10*(N+5) )
 2100 CONTINUE
      IF( IEV.LT.IEVLIM) CALL BPRS( 'ZE4V', IGEN )
      CALL ZE4VUN( NST, N, 0 )
      IF( N.LE.0 ) GO TO 2150
         IF( IEV.LT.IEVLIM) CALL PWRT( NST+1, NST+N, 10000 )
         NPZE4V = IW(IBLN('ZE4V'))
         CALL SPTHAK( NST+1, NST+N, NST+N+4, THR,
     &                              NST+N+1, SPH,
     &                              NST+N+5, AKO, IER )
C                                      SPHERICITY
         CALL UCOPY( P(1,NST+N+1), RW(NPZE4V+ 9), 4 )
         CALL UCOPY( P(1,NST+N+2), RW(NPZE4V+13), 4 )
         CALL UCOPY( P(1,NST+N+3), RW(NPZE4V+17), 4 )
C                                      THRUST
         CALL UCOPY( P(1,NST+N+4), RW(NPZE4V+21), 4 )
C                                      AKOPLANARITY
         CALL UCOPY( P(1,NST+N+5), RW(NPZE4V+25), 4 )
         IF( IEV.LT.IEVLIM) CALL BPRS( 'ZE4V', IGEN )
         IF( IEV.LT.IEVLIM) CALL PWRT( NST+N+1, NST+N+5, 10000 )
C                                           RESTORE BLANK COMMON
 2150 CONTINUE
      IF( LVECS.NE.0 ) GO TO 2200
         CALL UCOPY( RW(NPBUF+1), P(1,NST+1), 10*(N+5) )
         CALL BDLS( '--BU', 0 )
 2200 CONTINUE
C
      GO TO 8000
C
C
C
C                                           BANK ZE4V
      ENTRY ZE4VST( NST, N, IGEN )
C-----------------------------------------------------------
C NEW VERSION  17-11-86    M.ZIMMER
C ONLY A VERY ELEMENTARY FORM OF ZE4V BANK IS FILLED
C ALL PARTICLES GET THE SAME NUMBER OF WORDS ( LT ) AND NO
C ADDITIONAL INFORMATION IS STORED
C STORE MOMENTA FROM VECSUB COMMON INTO ZE4V
C THE PARTICLES ARE STORED IN
C NST+1..NST+N, WHERE N IS INPUT
C-----------------------------------------------------------
C
      IF( N.LE.0 ) GO TO 5000
C                                           EBEAM
         EBE = EBGENL( DUMMY )
C
         CALL BCRE( NPZE4V, 'ZE4V', IGEN, LH+LT*N, &8100, IER )
         CALL BSAW( 1, 'ZE4V' )
         HW(NPZE4V*2+ 1) = LH
         HW(NPZE4V*2+ 2) = 0
         HW(NPZE4V*2+ 3) = 0
         HW(NPZE4V*2+ 4) = 0
         HW(NPZE4V*2+ 5) = LT
         HW(NPZE4V*2+ 6) = N
         HW(NPZE4V*2+ 7) = 0
         HW(NPZE4V*2+ 8) = 0
         HW(NPZE4V*2+ 9) = 0
         HW(NPZE4V*2+10) = 0
         HW(NPZE4V*2+11) = 0
         HW(NPZE4V*2+12) = 0
C                                      RUN/EVENT #
      IW(NPZE4V  + 7) = IRNEVT( DUMMY )
      RW(NPZE4V  + 8) = EBE
C
      CALL SPTHAK( NST+1, NST+N, NST+N+4, THR,
     &                           NST+N+1, SPH,
     &                           NST+N+5, AKO, IER )
C                                      SPHERICITY
      CALL UCOPY( P(1,NST+N+1), RW(NPZE4V+ 9), 4 )
      CALL UCOPY( P(1,NST+N+2), RW(NPZE4V+13), 4 )
      CALL UCOPY( P(1,NST+N+3), RW(NPZE4V+17), 4 )
C                                      THRUST
      CALL UCOPY( P(1,NST+N+4), RW(NPZE4V+21), 4 )
C                                      AKOPLANARITY
      CALL UCOPY( P(1,NST+N+5), RW(NPZE4V+25), 4 )
C
         NP = NPZE4V + LH
         N1 = NST + 1
         NN = NST + N
         DO 3000 J=N1,NN
            RW(NP  + 1) = P(1,J)/P(6,J)
            RW(NP  + 2) = P(2,J)/P(6,J)
            RW(NP  + 3) = P(3,J)/P(6,J)
            HW(NP*2+ 7) = HP(17,J)
            HW(NP*2+ 8) = 0
            HW(NP*2+ 9) = 0
            HW(NP*2+10) = 0
            RW(NP  + 6) = P(6,J)
            RW(NP  + 7) = P(7,J)
            HW(NP*2+15) = HP(19,J)
            HW(NP*2+16) = HP(20,J)
            HW(NP*2+17) = 0
            HW(NP*2+18) = -1
C
            NP = NP + LT
 3000    CONTINUE
C
 5000 CONTINUE
      GO TO 8000
C
C
      ENTRY ZE4VDP
C-----------------------------------------------------------
C  DUMP BANK IN READABLE FORMAT
C-----------------------------------------------------------
      NPZE4V = IW(IBLN('ZE4V'))
      IF( NPZE4V.LE.0 ) GO TO 6000
C
      NZ2 = NPZE4V*2
      LLH = HW( NZ2 + 1 ) - HW( NZ2 + 3 )*HW( NZ2 + 2 )
     &                       - HW( NZ2 + 4)
      WRITE(6,9103) IW(NPZE4V-2), IW(NPZE4V),(HW(NZ2+I),I=1,14),
     *              RW(NPZE4V+8),(RW( NPZE4V+ LLH + I ),I=1,3)
 9103 FORMAT(//' DUMP OF ZE4V  ',I4,' LENGTH=',I5,5X,/,
     *1X,' LHD  LVX  NVX  LMC   LT   NP  LCH  NCH  LNE  NNE  LRE  NRE',
     *'   # RUN   # EVT   E-BEAM   X-VX1   Y-VX1   Z-VX1',/,
     * 1X,12(I4,1X),1X,I6,2X,I6,2X,F7.3,3(1X,F7.2)/)
      J = NPZE4V+9
      K = NPZE4V+28
      WRITE(6,9104) (RW(I),I=J,K)
 9104 FORMAT( 5X,3F10.3,2X,F10.3/
     *        5X,3F10.3,2X,F10.3,'  SPHERICITY'/
     *        5X,3F10.3,2X,F10.3/
     *        5X,3F10.3,2X,F10.3,'  THRUST'/
     *        5X,3F10.3,2X,F10.3,'  AKOPLANARITY')
C
      N = HW( NZ2 + 6 )
      LTR = HW( NZ2 + 5 )
      LTRCH = HW( NZ2 + 7 )
      LTRNE = HW( NZ2 + 9 )
      LTRRE = HW( NZ2 + 11)
      J = 0
      NP = NPZE4V + HW(NZ2+1)
      IF( N.LE.0 ) GO TO 5100
      WRITE(6,9105)
 9105 FORMAT(1X,'NR    EX    EY    EZ   PTOT  Q',
     *       ' PH TY VO VS PL OR PT',
     *       '   ECL S_ECL M_ECL  DET CL12 PA RZRF',
     *       ' X-TRK Y-TRK Z-TRK  DEDX SDEDX  R-MIN')
 5100 IF( J.GE.N ) GO TO 6000
      J = J + 1
      NP2 = NP*2
         IF( HW(NP*2 +18 ) .EQ. 1 )  THEN
      WRITE(6,9108)J,RW(NP+1),RW(NP+2),RW(NP+3),RW(NP+6),INT(RW(NP+7)),
     *                    HW(NP2+7),HW(NP2+8),HW(NP2+9),HW(NP2+10),
     *                    HW(NP2+15),HW(NP2+16),HW(NP2+18),
     &                    (RW(NP+LTR+I),I=1,3),(HW(NP2+LTR*2+I),I=7,10),
     &                    (RW(NP+LTR+I),I=6,11)
 9108       FORMAT(1X,I2,1X,3(F5.2,1X),F6.3,1X,I2,1X,6(I2,1X),I2,
     &            3(1X,F5.2),2(1X,I4),1X,I2,1X,I4,3(1X,F5.1),
     &            2(1X,F5.2),1X,F6.2)
            NP = NP + LTR + LTRCH
C
          ELSEIF ( HW(NP*2 + 18) .EQ. 0 ) THEN
C
      WRITE(6,9109)J,RW(NP+1),RW(NP+2),RW(NP+3),RW(NP+6),INT(RW(NP+7)),
     *                    HW(NP2+7),HW(NP2+8),HW(NP2+9),HW(NP2+10),
     *                    HW(NP2+15),HW(NP2+16),HW(NP2+18),
     &                    (RW(NP+LTR+I),I=1,3),(HW(NP2+LTR*2+I),I=7,8)
 9109       FORMAT(1X,I2,1X,3(F5.2,1X),F6.3,1X,I2,1X,6(I2,1X),I2,
     &                 3(1X,F5.2),2(1X,I4))
            NP = NP + LTR + LTRNE
C
          ELSEIF( HW(NP*2 + 18) .EQ. 2 )  THEN
C
            NP = NP + LTR + LTRRE
C
          ELSEIF( HW(NP*2 + 18) .EQ.-1 )  THEN
C
            NP = NP + LTR
C
         ENDIF
C
         GO TO 5100
 6000 CONTINUE
C
 8000 CONTINUE
      RETURN
C
 8020 CALL FEHLER (35, &8000)
      RETURN
C
 8100 NWARN(1) = NWARN(1) + 1
      IF( NWARN(1).LT.10 ) WRITE(6,9101) IER
 9101 FORMAT(' IER=',I4,' WHEN CREATING ZE4V')
      RETURN
C
 8200 NWARN(2) = NWARN(2) + 1
      IF( NWARN(2).LT.10 ) WRITE(6,9102) IER
 9102 FORMAT(' IER=',I4,' WHEN CREATING --BU')
C
      RETURN
      END
      SUBROUTINE EA3RUN( NST, N, IMODE )
C-----------------------------------------------------------
C UNPACK DOCA POINTS FROM ZE4V INTO VECSUB COMMON
C IMODE = 0 ALL PARTICLES
C       = 3 ALL NEUTRALS
C       = 4 ALL CHARGED
C THE PARTICLES ARE STORED IN
C NST+1..NST+N, WHERE N IS SET ON EXIT
C    THE INDIVIDUAL POSITIONS ARE:
C  P(  1..3,*)   RX,RY,RZ
C-----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
C
      COMMON P(10,400)
      DIMENSION IP(10,100),HP(20,1)
      EQUIVALENCE (P(1,1),IP(1,1),HP(1,1))
C
C
      N = 0
      NPZE4V = IW(IBLN('ZE4V'))
      IF( NPZE4V.LE.0 ) GO TO 7000
         NT = HW(NPZE4V*2 + 3 )
         NP = NPZE4V + HW(NPZE4V*2+1)
         DO 6200 J=1,NT
            CHARGE = RW(NP+7)
            IF( CHARGE.EQ.0. .AND. IMODE.EQ.4 ) GO TO 6100
            IF( CHARGE.NE.0. .AND. IMODE.EQ.3 ) GO TO 6100
               N = N + 1
               CALL UCOPY( RW(NP+8), P(1,NST+N), 3 )
 6100       CONTINUE
            NP = NP + HW(NPZE4V*2+2)
 6200    CONTINUE
 7000 CONTINUE
      RETURN
      ENTRY EA3RVX( NAST )
C-----------------------------------------------------------
C UNPACK EVENT VERTEX FROM ZE4V INTO VECSUB COMMON
C STORED IN NAST
C-----------------------------------------------------------
C
C
      NA = 0
      NPZE4V = IW(IBLN('ZE4V'))
      IF( NPZE4V.LE.0 ) GO TO 8000
         CALL UCOPY( RW(NPZE4V+ 5), P(1,NAST), 3 )
 8000 CONTINUE
      RETURN
      END

C   25/06/79 301061236  MEMBER NAME  HELDIS   (JADEGS)      FORTRAN
      SUBROUTINE HELDIS(ITR,INDEX,A,B,XB,YB,ZB,XE,YE,ZE,CURV,RMIN,PHIM)
C---
C---     DRAWS A CURVE BETWEEN ZB,XB (YB) AND ZE,XE (YE)
C---     THE CURVE IS A PROJECTION OF Z-FI(HELIX) FIT, TYPE 2 IN PATR
C---                                         Z = B*FI + A
C---     ITR IS CURRENT TRACK NUMBER
C---
C---     J.OLSSON 25.6.79          LAST CHANGE 01.07.79
C---
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
#include "cgeo1.for"
      COMMON /CJTRIG/ PI,TWOPI
      DATA DUM1 /0./
C---
      RAD = 1./ABS(CURV)
      RMIT = RAD + RMIN
      XMIT = RMIT*COS(PHIM)
      YMIT = RMIT*SIN(PHIM)
      SGN = SIGN(1.,CURV)
C                    START POINT
      XX = XB
      YY = YB
      RR = SQRT(XX*XX + YY*YY +.0000001)
      RCON1 = RMIT*RMIT + RAD*RAD
      RCON2 = 2.*RMIT*RAD
      FIFRST = (RCON1 - RR*RR)/RCON2
      FIFRST = ARCOS(FIFRST)
      IF(FIFRST.LT.0.) FIFRST = FIFRST + TWOPI
      IF(.NOT.DSPDTL(19)) GO TO 11
      FII = PHIM - PI
      XX = XMIT + RAD*COS(FII)
      YY = YMIT + RAD*SIN(FII)
      RR = SQRT(XX*XX + YY*YY + .00000001)
11    ZETP = XX
      IF(INDEX.GT.7) ZETP = YY
      IF(.NOT.DSPDTL(9)) GO TO 2
      ZETP = RR
      IF(YY.LT.0..AND.INDEX.GT.7) ZETP = - ZETP
      IF(XX.LT.0..AND.INDEX.LT.8) ZETP = - ZETP
2     IF(.NOT.DSPDTL(19)) ZETR = ZETP
      ZET = ZB
      IF(DSPDTL(19)) ZET = -B*FIFRST + A
      CALL MOVEA(ZET,ZETP)
C      IF(DSPDTL(30)) WRITE(JUSCRN,333) XB,YB,ZB,XX,YY,RR,ZETP,ZET,A
C333   FORMAT(' XYZB XYR*2 ZET-P ',9E11.3)
C                    END POINT
      XX = XE
      YY = YE
      RR = SQRT(XX*XX + YY*YY +.0000001)
      FIEND = (RCON1 - RR*RR)/RCON2
      FIEND = ARCOS(FIEND)
      IF(FIEND.LT.0.) FIEND = FIEND + TWOPI
      FIDIFF = ABS(FIEND-FIFRST)
      IF(DSPDTL(19)) FIDIFF = FIEND
      FIDEL = - SGN*FIDIFF/25.
      FII = PI + PHIM - SGN*FIFRST
      IF(DSPDTL(19)) FII = PI + PHIM
      FIB = FII
      ZDEL = B*ABS(FIDEL)
C      IF(DSPDTL(30)) WRITE(JUSCRN,334) XE,YE,ZE,XX,YY,RR,ZDEL,B,ZLGPL
C334   FORMAT(' XYZE XYR*2 ZDEL  ',9E11.3)
C      IF(DSPDTL(30)) WRITE(JUSCRN,123)
C     $ ITR,PHIM,FIFRST,FIEND,FIDIFF,FIDEL,FII,FIB
C123   FORMAT(' 123 PHIM FIRST ETC ',I4,7E11.4)
C      IF(DSPDTL(30)) WRITE(JUSCRN,124)
C     $ ITR,CURV,RAD,RMIN,RMIT,XMIT,YMIT,SGN
C124   FORMAT(' 124 CURV RAD ETC ',I4,6E11.4,F5.1)
      DO 34 IF = 1,25
        FII = FII + FIDEL
        XX = XMIT + RAD*COS(FII)
        YY = YMIT + RAD*SIN(FII)
        RR = SQRT(XX*XX + YY*YY)
        ZET = ZET + ZDEL
        ZETP = XX
        IF(INDEX.GT.7) ZETP = YY
        IF(.NOT.DSPDTL(9)) GO TO 32
        ZETP = RR
        IF(YY.LT.0..AND.INDEX.GT.7) ZETP = - ZETP
        IF(XX.LT.0..AND.INDEX.LT.8) ZETP = - ZETP
32    IF(DSPDTL(19).AND.IF.EQ.1) ZETR = ZETP
C     IF(ZETR*ZETP.LT.0.) ZETP = - ZETP
C      IF(DSPDTL(30)) WRITE(JUSCRN,2345) IF,FII,XX,YY,RR,ZET,ZETP
C2345  FORMAT(' LOOP ',I2,F8.4,5E12.4)
C     IF(DSPDTL(30)) CALL PROMPT
34    CALL DRAWA(ZET,ZETP)
      CALL TRNUMB(ITR,0,-ZET,ZETP,DUM1)
      IF(.NOT.DSPDTL(23)) RETURN
C PROLONGATION TO TOF OR LEAD GLASS LIMIT
      CALL MOVEA(ZET,ZETP)
      RTS = RLG
      IF(LASTVW.EQ.4.OR.LASTVW.EQ.8) RTS = RTOF
      Z2 = ZET
      R2 = RR
      NNN = 0
      IFLGX = 0
      FAT = 1.
551   FII = FII + FAT*FIDEL
      NNN = NNN + 1
      IF(NNN.GT.200) RETURN
        XX = XMIT + RAD*COS(FII)
        YY = YMIT + RAD*SIN(FII)
        RR = SQRT(XX*XX + YY*YY)
        IF(RR.LT.RITNK) RETURN
        ZET = ZET + ZDEL*FAT
        ZETP = XX
        IF(INDEX.GT.7) ZETP = YY
        IF(.NOT.DSPDTL(9)) GO TO 549
        ZETP = RR
        IF(YY.LT.0..AND.INDEX.GT.7) ZETP = - ZETP
        IF(XX.LT.0..AND.INDEX.LT.8) ZETP = - ZETP
C     IF(ZETR*ZETP.LT.0.) ZETP = - ZETP
549   IF(IFLGX.NE.0) GO TO 553
CHECK LIMITS
      IF(ABS(ZET).LT.ZENDPL) GO TO 554
      IFLGX = 1
      FAT = - ABS((ABS(ZET) - ZENDPL)/(ZET - Z2))
      GO TO 551
554   IF(RR.LT.RTS) GO TO 553
      IFLGX = 2
      FAT = - (RR-RTS)/(RR-R2)
      GO TO 551
553   R2 = RR
      Z2 = ZET
C      IF(DSPDTL(30)) WRITE(JUSCRN,2346) NNN,FII,XX,YY,RR,ZET,ZETP
C2346  FORMAT(' NNN ',I3,F8.4,5E12.4)
C      IF(DSPDTL(30)) CALL PROMPT
      CALL DRAWA(ZET,ZETP)
      IF(IFLGX.EQ.0) GO TO 551
      RETURN
      END

C   22/04/80 004221939  MEMBER NAME  MUTIMA   (JADEMUS)     FORTRAN
C=======================================================================
C THIS ROUTINE CAN BE USED TO TIME PROGRAMS
C=======================================================================
C  APRIL 1980  HARRISON B. PROSPER     J A D E
C=======================================================================
      SUBROUTINE MUTIMA (TIMDIF)
      LOGICAL FIRST /.TRUE./
      LOGICAL*1 C/'C'/,TYPE
C=======================================================================
C-----NTIME(DUM) GIVES THE TIME LEFT IN 1/100 SECS
C-----MODELL(TYPE) GIVES THE MACHINE THE JOB IS RUNNING ON.
C-----IF THE JOB IS RUNNING ON MACHINE C,SCALE UP THE TIME LEFT
C-----BY 1.7,SINCE MACHINE C IS FASTER.
      BIGBEN = NTIME(DUM)
      BIGBEN = BIGBEN/100
C-----ON FIRST CALL TO TIMER GET FIND OUT WHICH MACHINE
C-----THE JOB IS RUNNING ON
      IF(.NOT.FIRST) GOTO 2
      CALL MODELL(TYPE)
      FIRST = .FALSE.
                   SCALE = 1.0
      IF(TYPE.EQ.C)SCALE = 1.7
      TIME0  = BIGBEN
 2    CONTINUE
      TIMDIF = SCALE*( TIME0 - BIGBEN )
      RETURN
      END

C   07/06/96 606071803  MEMBER NAME  BCHL     (S4)          FORTG1
      SUBROUTINE BCHL(NW,*)
C     BOS SUBPROGRAM =1.19=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
      CALL BCHM(LIND,NW,IER)
      GOTO 100
C
      ENTRY BMVE(NW,*)
      CALL BCHM(NW,0,IER)
      LIND=NW
C
  100 IF(IER.EQ.2) GOTO 101
      RETURN
  101 RETURN 1
      END

C   19/02/79 C9021901   MEMBER NAME  LGCRN2   (JADELGS)     FORTRAN
      SUBROUTINE LGCRN2( HADR, ISUMC )
C
C     S.YAMADA   19-02-79  16:45
C     LAST MODIFICATION    19-02-79  21:25
C
C---- COUNT THE EDGE COUNTERS
C
C---- INPUT:
C           HADR=ADC ADDRESS
C        ISUMC=COUNTER FOR THE EDGE BLOCKS
C---- OUTPUT:
C           ISUMC IS INCREMENTED IF THE HADR IS AN EDGE ONE.
C
      INTEGER *2 HADR
C
C
      IF(HADR.GE.2688) GO TO 10
C
C----       BARREL
C
      IPH = HADR/32
      IZ = HADR-32*IPH
C---- CHECK CORNER HIT
      CALL LGCRNR( 0, IZ, IPHI, ISUMC)
      RETURN
C
C            END CAP
C
   10 ID = HADR-2687
      IPART = -1
      IF(ID.LE.96) GO TO 3
      ID = ID-96
      IPART = 1
C---- ILLEGAL COMPONENT NO.IS  NEGLECTED.
      IF(ID.GT.96) RETURN
C
    3 MB = (ID-1)/24
      ID = ID-24*MB
C
      CALL LGCRNR( IPART, ID,MB, ISUMC )
C
      RETURN
      END

C   07/03/79 C9101501   MEMBER NAME  TRKNM    (JADEGS)      FORTRAN
      SUBROUTINE TRKNM(X0,Y0,X1,Y1,IPART)
      IMPLICIT INTEGER*2 (H)
      COMMON /CJTRIG/ PI,TWOPI
      DATA SIZE/20./
      THETA=ATAN2((Y1-Y0),(X1-X0))
      IFLIP=0
      IF(ABS(THETA).GT.(PI/2.)) IFLIP=1
      IF(THETA.GT.( PI/2.)) THETA=THETA-PI
      IF(THETA.LT.(-PI/2.)) THETA=THETA+PI
      NDIG=1
      IF(IPART.GE.10) NDIG=2
      IF(IPART.GE.100) NDIG=3
      X=X1+SIZE*(3-(NDIG+6)*IFLIP)*COS(THETA)
      Y=Y1+SIZE*(3-(NDIG+6)*IFLIP)*SIN(THETA)
      CALL DNUM(IPART,X,Y,SIZE,THETA)
      RETURN
      END

C   21/07/80 312171956  MEMBER NAME  LGCUTX   (JADEGS)      FORTRAN
      SUBROUTINE LGCUTX(IACC,ECYL,ECAMI,ECAPL,ETOT)
C
C     DETERMINES IF EVENT SHOULD BE KEPT OR REJECTED, BASED ON LG ENERGY
C     IACC=0 MEANS REJECT
C     IACC=1 MEANS ACCEPT
C
C          MODIFIED TO EXCLUDE EDGEBLOCKS IN ENDCAPS IN THE SPINNER TEST
C                     J.OLSSON   11.02.80
C
C OBS!!! THIS IS THE JADEGS VERSION, WITH NO CALLS TO HFILL.
C        IT IS CALLED FROM REDONE, AND INDIRECTLY FROM USREDUC2.
C
      IMPLICIT INTEGER*2 (H)
#include "cdata.for"
      COMMON /CHEADR/ HEAD(108)
      EQUIVALENCE (HRUN,HEAD(18)),(HEVENT,HEAD(19))
      COMMON /CIGG/ IPRN,IGG(80)
      DIMENSION HELP(2)
      EQUIVALENCE (HELP(1),LABL)
      DATA ETOTLM /6000./,EMIN /7000./,EMNCYL/3500./,HELP/0,0/
C     DATA ETOTLM /3000./,EMIN /3000./,EMNCYL/1500./,HELP/0,0/
      DATA MSK200 /Z200/
C
C     INITIALIZE BOS-POINTERS
      DATA MKSTRT /0/
      IF(MKSTRT.NE.0) GOTO 100
        MKSTRT = 1
        IQALGN = IBLN('ALGN')
  100 CONTINUE
C
C SET IACC=0 DIRECTLY; ONLY WAY FOR IACC=1 IS TO FULFILL LIMITS BELOW
      IACC = 0
C
C     FIND ENERGY IN CYLINDER AND ENDCAPS
      CALL ERGTOT(ECYL,ECAMI,ECAPL)
      ETOT=ECYL+ECAMI+ECAPL
      ETOT95 = ETOT * .95
      IF(ETOT.LT.ETOTLM) GO TO 1400
C     LT 95% OF ENERGY IN ENDCAPS MEANS NO BAD BLOCKS
      IF(ECAMI.LT.ETOT95 .AND. ECAPL.LT.ETOT95) GOTO 1400
C     CHECK FOR BAD BLOCKS HERE
      IPJ=IDATA(IQALGN)
      IF(IPJ.LE.0) GO TO 99
      NWO=IDATA(IPJ)
      IF(NWO.LE.3) GO TO 99
      IPJ=2*IPJ + 8
      NWO=IPJ+2*NWO-8
      DO 5004 IJK=IPJ,NWO,2
      IAD=HDATA(IJK-1)
      IF(IAD.LE.2687) GO TO 5004
      ETEST = HDATA(IJK)
      IF(ETEST.LT.ETOT95) GOTO 5004
C TEST HERE TO EXCLUDE EDGE BLOCKS FROM THE CHECK
C     REDUCE TO NUMBERS 1 - 192
      NO = IAD - 2687
C     0 FOR -Z, 1 FOR +Z
      NE = (NO - 1)/96
C     REDUCE TO 1 - 96
      NO = NO - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (NO - 1)/24
C     REDUCE TO 1 - 24
      NO = NO - NQ*24
      IF(NO.LT.5) GO TO 5004
      IF(NO.GT.15.AND.NO.NE.20) GO TO 5004
      GO TO 5005
5004  CONTINUE
C     COME HERE IF NO BAD BLOCKS
1400  IF(ETOT.GT.EMIN.OR.ECYL.GT.EMNCYL) IACC = 1
      GO TO 1010
 99   CONTINUE
      DATA IPRN1 /0/
      IPRN1 = IPRN1 + 1
      IF(IPRN1.LT.10) WRITE(6,36) IPJ,NWO,HEAD(18),HEAD(19)
 36   FORMAT('  ERROR IN LG BANK  ',4I10)
      GO TO 1010
 5005 IF(IPRN.GT.0) WRITE(6,29) IAD,ETEST
 29   FORMAT(' ADDRESS AND ENERGY OF BAD BLOCK: ',I10,F10.2)
      IGG(71)=IGG(71)+1
1010  RETURN
      END

C   25/06/78            MEMBER NAME  BREMS1   (LGSOURCE)    FORTRAN
      SUBROUTINE BREMS1(ENE,EPSI)
C
C SUBROUTINE BREMS1,2,M0LLRE
C     A.SATO
C     LATEST MODIFICATION 05-04-78 21:55
C
      COMMON /FB1PAR/ BGAM,PROSWD
      COMMON /BRPAR/ BRA,BRB,BDEL
      COMMON/SFCPA/SFP,SFE
      BH(X)=4.184*ALOG(X+0.952)-0.280
      XR=RN(DAM)
      IF (XR-0.5) 10,11,11
 10    EPSI=EXP(-BGAM*XR)
      GO TO 1
 11    EPSI=SQRT(EXP(-2.*BGAM*XR)-PROSWD)
1     XR=RN(DAM)
      DEL=BDEL*EPSI/(ENE*(1.-EPSI))
      IF(DEL-1.)20,20,21
 20    G1=(1.-EPSI)*(1.-BRA*DEL*(3.898-0.9805*DEL))
      GOTO 2
 21    G1=(1.-EPSI)*(1.-BRA*BH(DEL))
 2    IF(XR*SFE-G1)30,30,31
 30    IF(EPSI.LE. 1.-1./ENE) RETURN
 31    EPSI=0.
      RETURN
      END

******************************************************************
*
*     HIGZ colour settings for graphics action with PLOT10.
*
*     12/11/1999  P.A. Movilla Fernandez
*
      SUBROUTINE SETCOL(C)
      IMPLICIT NONE
      CHARACTER C*(*)
      INTEGER ICI,ITCI,ICI2,ITCI2,I
      REAL WI
*
#include "cplot10.for"
#include "cpltcol.for"
Code:
      IF (.NOT.LCOL ) RETURN
      CALL CLTOU(C)
      IF( .NOT.LINIT .AND. C.NE.'*INI' ) RETURN
      IF( C.EQ.'*INI' ) THEN
         LINIT=.TRUE.
         DO I=1,NCOL
            CALL ISCR(1,10+I,RED(I),GREEN(I),BLUE(I))
            CALL IXSETCO(10+I,RED(I),GREEN(I),BLUE(I))
         ENDDO
         CALL IXSETCO(100,1.,1.,1.)
         CALL IXSETCO(101,0.,0.,0.)
C default settings for PostScript output
C                            foreground
         CALL ISELNT(NTS)
         CALL ISLWSC(1.)
         CALL ISPLCI(IFORE)
         CALL ISPMCI(IFORE)
         CALL ISTXCI(IFORE)
C                            background
         IF( IBACK.EQ.1 ) THEN
            CALL ISFAIS(1)
            CALL ISFACI(IBACK)
            CALL IGBOX(XTMIN,XTMAX,YTMIN,YTMAX)
         ENDIF
C additional settings for X11
         IF( IBACK2.EQ.1 .OR. IBACK.EQ.1  ) THEN
            CALL IXSETTC(IFORE2)
            CALL IXSETLC(IFORE2)
            CALL IXSETMC(IFORE2)
            CALL IXSETFC(IBACK2)
            CALL IXBOX(XTMIN,XTMAX,YTMIN,YTMAX,1)
         ENDIF
C
         CALL IUWK(0,1)
         RETURN
      ENDIF
C Set colour
      DO I=1,NCOL
         IF( C.EQ.TCOL(I) ) THEN
            IF( C.NE.'TEXT' ) THEN
               WI=WID(I)
               ICI=10+I
               ITCI=10+I
               ICI2=ICI
               ITCI2=ITCI
            ELSE
               WI=1.
               ICI=10+I
               ITCI=10+I
               ICI2=ICI
               ITCI2=ITCI
               IF( IBACK.EQ.0 ) THEN
                  ICI=ICI+1
                  ITCI=ITCI+1
               ENDIF
               IF( IBACK2.EQ.0 ) THEN
                  ICI2=ICI2+1
                  ITCI2=ITCI2+1
               ENDIF
            ENDIF
            GOTO 10
         ENDIF
      ENDDO
      WI=1.
      ITCI=IFORE
      ICI=IFORE
      ITCI2=IFORE2
      ICI2=IFORE2
 10   CONTINUE
C Force special attributes required exceptionally in certain contexts
      IF( PLTFLG.EQ. 1 ) THEN
         IF( C.EQ.'HITS' ) WI = 1.
      ENDIF

C Set attributes for graphics in PS file
      CALL ISLWSC(WI)
      CALL ISPLCI(ICI)
      CALL ISPMCI(ICI)
      CALL ISTXCI(ITCI)

C Set attributes for graphics apearing on the screen
      CALL IXSETLC(ICI2)
      CALL IXSETMC(ICI2)
      CALL IXSETTC(ITCI2)
      CALL IXSETLN(1)
C
      RETURN
      END

C /PLTCOL/
      BLOCKDATA CPLTCOL
# include "cpltcol.for"
      DATA LCOL/.TRUE./
      DATA LINIT/.FALSE./
      DATA IFORE /1/, IBACK /0/   ! <--- for PostScript
      DATA IFORE2/0/, IBACK2/1/   ! <--- for screen
      DATA TCOL/'JADE','TRCK','ECAL','TOFH','TRUE','HITS'
     +        ,'VTX ','TEXT','TXT2','TITL'/
      DATA RED  /  .4,  .0,  1. ,   0.,  .0  ,   1.,   
     +            8.,   1.,   0.,   0./
      DATA GREEN/  .4,   .7,  .6 ,  .9 ,  1.  ,   .0,
     +            1.,   1.,   0.,   1./
      DATA BLUE /  .4,   1.,  .0 ,  .0 ,  .5  ,   .0,
     +            0.,   .0,   .5,   0./
      DATA WID  /   1.,   2.,  4.,   2.,   4. ,   4.,
     +             6.,   1.,    1.,  1./
      DATA PLTFLG/0/
      END
C JADE .64 .4 .0
      SUBROUTINE SETCOL0(C)
      IMPLICIT NONE
      CHARACTER*4 C
      RETURN
      END

C   24/09/81 111210224  MEMBER NAME  ZSXY     (HELIX)       FORTRAN
      SUBROUTINE ZSXY(NH1,LRFLAG,XJET1,YJET1,XJET2,YJET2)
C*811119*DITTMANN*************************************************
C*                                                               *
C*       X - Y   C O O R D I N A T E   O F   O N E   H I T       *
C*                                                               *
C*       THIS ROUTINE CONTAINS THE ESSENTIALS OF G. PEARCE'S OLD *
C*       JETXYZ. THE ACCURACY NEEDED FOR X-Y IS ONLY 5 MM,       *
C*       THEREFORE SMALL CORRECTIONS ARE OMITTED.                *
C*       COMMONS /CJDRCH/ AND /CDSMAX/ ARE NEEDED PARTLY.        *
C*       IF THIS SUBROUTINE SHOULD RUN IN AN SUPERVISOR INDEPEN- *
C*       DENT PROGRAM AND THOSE COMMONS ARE NOT FILLED, THE      *
C*       ROUTINE ZSSPEC HAS TO BE CALLED, WHICH FILLS THE        *
C*       NEEDED PARTS OF THE COMMONS.                            *
C*****************************************************************
          IMPLICITINTEGER*2(H)
          LOGICAL TBIT
#include "cdata.for"
#include "cjdrch.for"
#include "cdsmax.for"
C         ------------------
C         DATA AND CONSTANTS
C         ------------------
          INWIRE=HDATA(NH1)
          INWIRE=SHFTR(INWIRE,3)
          LAYER=LAND(INWIRE,15)
          INCELL=LAND(SHFTR(INWIRE,4),127)+ 1
          INRING=1
          IF(INCELL.GT.24)INRING=2
          IF(INCELL.GT.48)INRING=3
          DR0=RINCR(INRING)
          IW1=INCELL-24*(INRING-1)
          IF(INRING.EQ.3)GOTO 10
          DXWR=DIRWR1(IW1,1)
          DYWR=DIRWR1(IW1,2)
          GOTO20
 10       DXWR=DIRWR3(IW1,1)
          DYWR=DIRWR3(IW1,2)
C         -------------------------
C         COMPUTE (X,Y,R) OF LAYER
C         INCLUDING WIRE STAGGERING
C         -------------------------
 20       R1=FSENSW(INRING)+LAYER*DR0
          IW1=-1
          IF(TBIT(LAYER,31))IW1=+1
          X1=R1*DXWR+IW1*SWDEPL*DYWR
          Y1=R1*DYWR-IW1*SWDEPL*DXWR
C         -----------------------
C         SET LEFT/RIGHT SOLUTION
C         -----------------------
          NEXTLR=0
          LR1M1=ISIGN(1,LRFLAG)
 30       LR12=1
          IF(LR1M1.GT.0)LR12=2
C         --------------------------------
C         CONVERT DRIFT TIME INTO DISTANCE
C         --------------------------------
          DRIFT=HDATA(NH1+3)*DRIVEL(INCELL,LR12)
C         -------------------------
C         ADD DRIFT TIME TO (X,Y,R)
C         -------------------------
          TRLORX=TRMATS(INCELL,LR12)
          TRLORY=TRMATC(INCELL,LR12)
          XDRFT=LR1M1*TRLORX*DRIFT
          YDRFT=LR1M1*TRLORY*DRIFT
          IF(NEXTLR.EQ.1)GOTO70
          XJET1=X1+XDRFT
          YJET1=Y1+YDRFT
          NEXTLR=1
          LR1M1=-LR1M1
          GOTO30
 70       XJET2=X1+XDRFT
          YJET2=Y1+YDRFT
          RETURN
          END

C   07/06/96 606071922  MEMBER NAME  ASRD     (S4)          FORTG1
      SUBROUTINE ASRD(BUF,NBT,NBL)
      LOGICAL*1 BUF(1)
      INTEGER IPAR(8)/1,3,6*0/
      INTEGER*2 NCC,NS
      INTEGER TEXT,TEXTL(3)/' VB ',' VBS',' VBS'/
C
C    USAGE
C    =====
C
C    INITIALIZATION
C                        ---
C             CALL ASVB (IUN)        VB-RECORDS
C                        ---
C             CALL ASVBS(IUN)       VBS-RECORDS
C
C             WHERE IUN    =  UNIT NUMBER
C             (DEFAULT IS IUN = 1 AND VBS)
C
C     READ ONE RECORD
C                               ---
C             CALL ASRD(BUF,NBT,NBL)
C                       --- ---
C             WHERE   BUFF( ) =  ARRAY FOR RECORD
C                     NBT     =  RECORD LENGTH (BYTES) *)
C                     NBL     =  LENGTH OF ARRAY (BYTES)
C
C     IF THE TRUE RECORD LENGTH IS LARGER THAN THE ARRAY LENGTH NBL,
C     THIS IS CONSIDERED AS AN ERRROR AND NBT IS SET ZERO. IN ANY
C     CASE NO MORE THAN NBL BYTES ARE FILLED INTO THE ARRAY BUF( ).
C     RESTRICTION. RECORDS IN VB-MODE OR SEGMENTS IN VBS-MODE MUST HAVE
C     A LENGTH LESS THAN 8192 WORDS OR 32768 BYTES.
C
C     *)   NBT =  0   IO-ERROR OR SEGMENT ERROR OR RECORD LENGTH ERROR
C          NBT = -1   END-OF-DATA
C
C          RECORDS WITH IO-ERRORS ARE IGNORED, IF THE DCB=EROPT=SKIP
C          IS SPECIFIED, OTHERWISE THE PROGRAM ABENDS.
C
C
C     CLOSE DATA SET
C                    CALL ASCL
C     NECESSARY ONLY, IF A FURTHER DATA SET SHOULD BE READ. NOT
C     NECESSARY, IF END EXIT OF VREAD IS TAKEN.
C
C
C
      ILOOP=0
   10 ILOOP=ILOOP+1
      IF(ILOOP.GT.10) GOTO 70
      IER=0
      NBT=0
      NB =NBL
      IF(IPAR(7).NE.0) GOTO 20
C     OPEN DATA SET
      TEXT=TEXTL(IPAR(2))
      WRITE(6,101) IPAR(1),TEXT
*xxx 10.01.98     CALL RVOPEN(IPAR(1),*74)
      PRINT *,'CALL RVOPEN: STOP'
      STOP
*xxx
      DO 15 I=3,8
   15 IPAR(I)=0
      IPAR(7)=1
C
   20 IF(IPAR(2).NE.1) GOTO 40
C     VB=RECORDS
   30 NCC=NB
      IF(NB.GE.32768) NCC=32767
*xxx 10.01.98     CALL RV(NCC,BUF(1),*80,*71,*74)
      PRINT *,'CALL RV: STOP'
      STOP
*xxx  
      IF(NCC.GT.NB) GOTO 73
      NBT=NCC
      GOTO 60
C     VBS-RECORDS
   40 NCC=NB
      IF(NB.GE.32768) NCC=32767
*xxx 10.01.98      CALL RVS(NCC,BUF(1),NS,*80,*71,*74)
      PRINT *,'CALL RVS: STOP'
      STOP
*xxx
      IF(NCC.GT.NB) GOTO 73
      NBT=NCC
      MJ=NS+1
      GOTO (60,50,72,72),MJ
   50 NB =NB-NCC
      NCC=NB
      IF(NB.GE.32768) NCC=32767
*xxx 10.01.98      CALL RVS(NCC,BUF(1+NBT),NS,*80,*71,*74)
      PRINT *,'CALL RVS: STOP'
      STOP
*xxx
      IF(NCC.GT.NB) GOTO 73
      NBT=NCC+NBT
      MJ=NS+1
      GOTO (72,72,60,50),MJ
C
   60 IPAR(3)=IPAR(3)+1
      IPAR(8)=0
      GOTO 100
C     ERRORS
   73 IER=IER+1
   72 IER=IER+1
   71 IER=IER+1
      IF(IER.NE.2) GOTO 70
      IF(IPAR(8).NE.0) GOTO 10
   70 NBT=0
      IPAR(2+IER)=IPAR(2+IER)+1
      IPAR(8)=IER
      GOTO 100
C     OPEN ERROR
   74 WRITE(6,102)
      NBT=-1
      GOTO 84
C
      ENTRY ASCL
      IF(IPAR(7).EQ.0) GOTO 100
      GOTO 82
C     END-OF-DATA
   80 NBT=-1
      WRITE(6,104)
*xxx   82 CALL RVCLOS
 82   PRINT *,'CALL RVCLOS: STOP'  
      STOP
*xxx
   84 WRITE(6,103) (IPAR(I),I=3,6)
      DO 86 I=3,8
   86 IPAR(I)=0
      IPAR(1)=1
      IPAR(2)=3
      GOTO 100
C
      ENTRY ASVB(IUN)
      MARK=1
      GOTO 90
      ENTRY ASVBS(IUN)
      MARK=2
   90 IF(IPAR(7).NE.0) GOTO 100
      IPAR(1)=IUN
      IPAR(2)=MARK
      GOTO 100
C
      ENTRY ASMD(IUN)
      IUN=0
      IF(IPAR(2).NE.3) IUN=IPAR(1)
  100 RETURN
  101 FORMAT('0++++ ASRD OPEN',12X,'-  UNIT',I3,',',A4/)
  102 FORMAT('0++++ ASRD OPEN ERROR'/)
  103 FORMAT('0++++ ASRD CLOSE',11X,'-',I12,'  RECORDS ACCEPTED'/
     1   I40,'  IO-ERRORS'/
     2   I40,'  SEGMENT-ERRORS'/
     3   I40,'  INPUT-ARRAY TOO SMALL'/)
  104 FORMAT('0++++ ASRD END-OF-DATA')
      END

C   09/08/82 303101253  MEMBER NAME  TANTHM   (JADEMUS)     FORTRAN
      FUNCTION TANTHM( ICH )
C GETS COORDS OF THE WIRE OF THE GIVEN CHAMBER
C X IS THE NORMAL DIRECTION
C Y IS THE DRIFT  DIRECTION
C BOTH X AND Y ARE MADE POSITIVE
C RETURNS THE TANGENT OF THE ANGLE OF THE "MUON" TRACK
C (ASSUMED FROM THE ORIGIN) TO THE NORMAL TO THE CHAMBER
      IMPLICIT INTEGER*2 (H)
#include "cmucalib.for"
      IFRAME = HFR(ICH)
      IOR = HNORM(IFRAME)
      IARCH = HOVALL(HUNIT(IFRAME))
      ICNORM = HDIST(IFRAME) + HD1(ICH)
      GOTO( 11, 12, 13 ),IOR
   11 X = ICNORM + IARCH
      Y = HCTW(ICH)
      GOTO 20
   12 Y = HCTW(ICH) + IARCH
      X = ICNORM
      GOTO 20
   13 Y = HCTW(ICH) + IARCH
      X = ICNORM
      GOTO 20
   20 IF(X.LT.0.0) X = -X
      IF(Y.LT.0.0) Y = -Y
      TANTHM =  Y/X
      RETURN
      END

C   22/01/79 C9032101   MEMBER NAME  COMENT   (JADEGS)      FORTRAN
      SUBROUTINE COMENT
C---
C---     ENABLES THE GRAPHICS USER TO PUT A COMMENT ANY DELIBERATE
C---     PLACE ONTO HIS PICTURE;  THE COMMENT WILL APPEAR ON THE
C---     HARDCOPY.                           J.OLSSON 18.12.78
C---
      IMPLICIT INTEGER*2 (H)
      COMMON /CWORK1/ HMW(80),XST,YST
C
      CALL TRMOUT(80,'PLEASE ENTER START POSITION OF YOUR COMMENT^')
      CALL VCURSR(HMW(1),XST,YST)
      CALL MOVEA(XST,YST)
      DO 1  I = 1,3
1     CALL TRMOUT(80,' ^')
      CALL TRMOUT(80,'PLEASE ENTER YOUR COMMENT^')
      CALL TRMIN(80,HMW)
      CALL CHRSIZ(4)
      CALL EOUTST(80,HMW)
      RETURN
      END

C   10/04/84            MEMBER NAME  NEWCAP   (JADEGS)      FORTRAN
      SUBROUTINE NEWCAP(ADX,ADY,LLL,ITXT)
      IMPLICIT INTEGER*2 (H)
#include "cgeo2.for"
#include "cgraph.for"
C
C DRAW FRONT VIEW OF TAGGING SYSTEM IN 1981-82 VERSION
C
      DO 1 I=1,32
      NO=I-1
      CALL XYTAG(NO,X,Y,slope)  ! PMF 01/12/99: dummy argument slope added
      X0=ADX-X-0.5*FENDC
      X1=X0+FENDC
      Y0=ADY+Y-0.5*FENDC
      Y1=Y0+FENDC
      CALL RECTAN(X0,Y0,X1,Y1,LLL)
    1 CONTINUE
      IF(ITXT.EQ.0) RETURN
C     WRITE TEXT
C  WRITE +- Z  BELOW CAPS
      SH3 = 0.6*FENDC
      Y1 = ADY - 5.*FENDC
      I = 1
      IF(ADX.GT.0.) I = 2
      LABT = 101 + (I-1)*2
      X1 = ADX-0.5*FENDC
      CALL RUTEXT(LABT,X1,Y1,SH3)
C  DRAW BEAM CROSS INSIDE CAP
      CALL MOVEA(ADX,ADY-20.)
      CALL DRAWA(ADX,ADY+20.)
      CALL MOVEA(ADX+20.,ADY)
      CALL DRAWA(ADX-30.,ADY)
      CALL DRAWA(ADX-30.,ADY+15.)
      CALL DRAWA(ADX-45.,ADY)
      CALL DRAWA(ADX-30.,ADY-15.)
      CALL DRAWA(ADX-30.,ADY)
      RETURN
      END

C   18/05/79 002210634  MEMBER NAME  LGESUM   (SOURCE)      FORTRAN
      SUBROUTINE LGESUM(ETOTLG)
C
C     S.YAMADA   18-05-79  12:50
C     LAST MODIFICATI0N  18-05-79  13:25
C
C---- LG ENERGY IS SUMMED FOR EACH PART.
C
      IMPLICIT INTEGER *2 (H)
C
#include "cdata.for"
C
      DIMENSION ETOTLG(3)
C
      DATA INITP/0/
      IF(INITP.GT.0) GO TO 5
      INITP=1
      IP= IBLN('ALGN')
5     CONTINUE
      ETOTLG(1) = -1.0
C     CALL CLOC( NP, 'ALGN',1 )
      NP=IDATA(IP)
      IF(NP.LE.0) GO TO 100
C
      NNP = NP+NP
      NNPADC = NNP+7
C
        DO 1 K=1,3
        ISUM = 0
        NS = HDATA(NNP+2+K)
        NE = HDATA(NNP+3+K)-2
        IF( NE-NS ) 3,2,2
    2     DO 20 NH=NS,NE,2
   20     ISUM = ISUM+HDATA(NNPADC+NH)
    3   ETOTLG(K) = 0.001*ISUM
    1   CONTINUE
C
  100 RETURN
      END

C   12/03/84 412041842  MEMBER NAME  TAGNEB   (S)           FORTRAN
C
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
       SUBROUTINE TAGNEB
C
C THIS SUBROUTINE GENERATES THE NEIGHBOUR LIST FOR THE 1983 TAGGER
C SOFTWARE NUMBERING SCHEME - MAINLY BECAUSE I CANT BE BOTHERED TO
C TYPE THEM ALL IN TO BLOCK DATA.
C
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C NLIST - LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = TOTAL NUMBER
C         OF NEIGHBOURS
C
#include "comtag.for"
C
C
       LISTOK = 0
       DO 10 I = 1,48,24
          ISTART = I
          IEND   = I + 7
          DO 20 J = ISTART,IEND
             NLIST(J,1,2) = 8
             NLIST(J,2,2) = J - 1
             NLIST(J,3,2) = J + 1
             NLIST(J,4,2) = J + 7
             NLIST(J,5,2) = J + 8
             NLIST(J,6,2) = J + 9
             NLIST(J,7,2) = J + 15
             NLIST(J,8,2) = J + 16
             NLIST(J,9,2) = J + 17
       IF ( NLIST(J,2,2) .LT. ISTART ) NLIST(J,2,2) = IEND
       IF ( NLIST(J,4,2) .LT. (ISTART + 8) )  NLIST(J,4,2) = IEND + 8
       IF ( NLIST(J,7,2) .LT. (ISTART + 16) ) NLIST(J,7,2) = IEND + 16
       IF ( NLIST(J,9,2) .GT. (IEND + 16) )   NLIST(J,9,2) = ISTART + 1600004200
       IF ( NLIST(J,6,2) .GT. (IEND + 8) )    NLIST(J,6,2) = ISTART + 8
       IF ( NLIST(J,3,2) .GT. IEND ) NLIST(J,3,2) = ISTART
  20      CONTINUE
          ISTART = I + 8
          IEND = ISTART + 7
          DO 30 J = ISTART,IEND
             NLIST(J,1,2) = 8
             NLIST(J,2,2) = J - 1
             NLIST(J,3,2) = J + 1
             NLIST(J,4,2) = J + 7
             NLIST(J,5,2) = J + 8
             NLIST(J,6,2) = J + 9
             NLIST(J,7,2) = J - 9
             NLIST(J,8,2) = J - 8
             NLIST(J,9,2) = J - 7
      IF ( NLIST(J,2,2) .LT. ISTART )       NLIST(J,2,2) = IEND
      IF ( NLIST(J,4,2) .LT. (ISTART + 8) ) NLIST(J,4,2) = IEND + 8
      IF ( NLIST(J,7,2) .LT. (ISTART - 8) ) NLIST(J,7,2) = IEND - 8
      IF ( NLIST(J,9,2) .GT. (IEND - 8) )   NLIST(J,9,2) = ISTART - 8
      IF ( NLIST(J,6,2) .GT. (IEND + 8) )   NLIST(J,6,2) = ISTART + 8
      IF ( NLIST(J,3,2) .GT. IEND )         NLIST(J,3,2) = ISTART
  30      CONTINUE
          ISTART = I + 16
          IEND = ISTART + 7
          DO 10 J = ISTART,IEND
             NLIST(J,1,2) = 8
             NLIST(J,2,2) = J - 1
             NLIST(J,3,2) = J + 1
             NLIST(J,4,2) = J - 15
             NLIST(J,5,2) = J - 16
             NLIST(J,6,2) = J - 17
             NLIST(J,7,2) = J - 9
             NLIST(J,8,2) = J - 8
             NLIST(J,9,2) = J - 7
       IF ( NLIST(J,2,2) .LT. ISTART )        NLIST(J,2,2) = IEND
       IF ( NLIST(J,4,2) .GT. (IEND - 16) )   NLIST(J,4,2) = ISTART - 1600007800
       IF ( NLIST(J,7,2) .LT. (ISTART - 8) )  NLIST(J,7,2) = IEND - 8
       IF ( NLIST(J,9,2) .GT. (IEND - 8) )    NLIST(J,9,2) = ISTART - 8
       IF ( NLIST(J,6,2) .LT. (ISTART - 16) ) NLIST(J,6,2) = IEND - 16
       IF ( NLIST(J,3,2) .GT. IEND )          NLIST(J,3,2) = ISTART
  10   CONTINUE
       DO 70 I = 9,16
          XMAP(I) = -1.0 * XMAP(17 - I)
  70      YMAP(I) = YMAP(17 - I)
       DO 80 I = 17,32
          XMAP(I) = XMAP(33 - I)
   80     YMAP(I) = -1.0 * YMAP(33 - I)
       DO 90 I = 1,32
          XMAP(I + 32) = -1.0 * XMAP( I)
 90       YMAP(I + 32) = -1.0 * YMAP( I)
C
C LISTOK = 1 FLAGS THAT LIST HAS BEEN GENERATED TO STOP TAGNEB BEING
C             CALLED AGAIN
C
       LISTOK = 1
       RETURN
       END

C   01/11/84 807251614  MEMBER NAME  KOORD    (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE KOORD( LSEP, NC, LDIF, LVIEW )
C-----------------------------------------------------------------------
C
C    AUTHOR:   R. RAMCKE     23/10/84 :  DRAWS COORDINATES FOR FADC
C                                        DATA ON SCREEN IN ABSOLUTE
C                                        COORDINATES
C       MOD:   J. HAGEMANN   09/07/85 :  DRAW DRIFTTIME INFORMATION AS
C                                        TRIANGLE
C       MOD:   J. HAGEMANN   23/07/85 :  FOR DIFFENCIATED PULSES
C       MOD:   J. HAGEMANN   15/10/85 :  FOR CALIBRATED PULSES
C  LAST MOD:   J. HAGEMANN   16/01/86 :  FOR VCVW BANK
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LSEP, LDIF, LVIEW
C
#include "cgraph.for"
#include "cdata.for"
#include "cjvcel.for"
#include "mvccal.for"
C
      COMMON / CORDER / KWR(8), KSIDE, KSTART, KEND, KTIMB, KEV
      COMMON / CKORD  / IX1, IX2,
     +                  IY1, IY2
      COMMON / CWORK1 / HAMP(2,60), HSTORE(2,420), ISCLOW, ISCHIG
      COMMON / CHEADR / HEAD(108)
      COMMON / CVX    / NNPATR,NDUMM,NNJETC,NNVTXC
C
      DIMENSION KANAL(10), KAN(2), IAD(5)
      DIMENSION HDATSV(22), HMW(24), HTX(2), HCELL(2), HDIFF(11)
      DIMENSION HZETM(2), HZETP(2), HBPCH(2), HVCVW(2), HBANK(2)
C
      EQUIVALENCE ( HDATSV(1), IDATSV(1) )
C
      DATA KANAL / 48, 49, 50, 51, 52, 53, 54, 55, 56, 57 /
      DATA HTX   / 'DS', 'N ' /
      DATA HCELL / 'Ce', 'll' /
      DATA HBPCH / 'BP', 'CH' /
      DATA HVCVW / 'VC', 'VW' /
      DATA HDIFF / 'di','ff','er','en','ci','at','ed',' p','ul',
     *             'se','s ' /
      DATA HZETM / ' -',' Z' /
      DATA HZETP / ' +',' Z' /
C
C-----------------  C O D E  -------------------------------------------
C
      NWLOW  = NC*MWIRE - 6
      NWHIG  = NC*MWIRE
C
      KEV    = 1
      DO 2 I = 1,7
         KWR(I) = 1
    2 CONTINUE
      KWR(8) = 7
      KSIDE  = 3
      KSTART = 0
      KEND   = 60
      KTIMB  = 10
C
      NTIMB = KTIMB
      IF(KTIMB .EQ. 0) NTIMB = 10
C
      IY1 =  100
      IY2 = 2950
      IF( LSEP ) GOTO 10
         IX1 =  600
         IX2 = 4000
         GOTO 13
   10 CONTINUE
      LS = 1
      IX1 = 300
      IX2 = 2100
      GOTO 13
   12 LS  = 2
      IX1 = 2200
      IX2 = 4000
C
   13 IF( LSEP .AND. LS .EQ. 2 ) GOTO 50
C                                      WRITE DSN ON PICTURE
      CALL CHRSIZ(4)
      HMW(1) = HTX(1)
      HMW(2) = HTX(2)
C
      DO 14 I = 1, 22
         HMW(I+2) = HDATSV(I)
   14 CONTINUE
C
      CALL MOVABS(IX1 - 50, IY2 + 200)
      CALL EOUTST(48, HMW)
C                                      WRITE RUN NUMBER ON PICTURE
      IRUN = HEAD(18)
      CALL INTADE(IRUN, IAD, 5)
      CALL MOVABS(IX1 - 50, IY2 + 50)
      CALL HLABEL(5,IAD)
C                                      WRITE EVENT NUMBER ON PICTURE
      IEVT = HEAD(19)
      CALL INTADE(IEVT, IAD, 5)
      CALL SEELOC(IXAC, IYAC)
      CALL MOVABS(IXAC + 30, IYAC)
      CALL HLABEL(5, IAD)
C                                      WRITE CURRENT EVENT NUMBER
      CALL INTADE(ICREC, IAD, 5)
      CALL SEELOC(IXAC, IYAC)
      CALL MOVABS(IXAC + 30, IYAC)
      CALL HLABEL(5, IAD)
C                                      WRITE CELL NUMBER ON PICTURE
      CALL INTADE(NC, IAD, 2)
      CALL MOVABS(IX1 + 1800, IY2 + 200)
      CALL EOUTST(4, HCELL)
      CALL SEELOC(IXAC, IYAC)
      CALL MOVABS(IXAC + 50, IYAC)
      CALL HLABEL(2, IAD)
C                                      WRITE 'DIFFERENTIATED PULSES' ON
C                                      PICTURE
      IF( .NOT. LDIF ) GO TO 40
         CALL MOVABS( IX1 + 2500, IY2 + 200 )
         CALL EOUTST( 22, HDIFF )
C                                      WRITE NAME OF DISPLAYED BANK ON
C                                      PICTURE
   40 HBANK(1) = HBPCH(1)
      HBANK(2) = HBPCH(2)
      IF( .NOT. LVIEW ) GO TO 45
         HBANK(1) = HVCVW(1)
         HBANK(2) = HVCVW(2)
   45 CALL MOVABS( IX1 + 1400, IY2 + 160 )
      CALL EOUTST( 4, HBANK )
C
   50 IYREL = (IY2 - IY1)/KWR(8)
      NLIM  = KWR(8)
C
      DO 60 IW = 1, NLIM
          IYK = IY1 + IYREL*(IW - 1)
          CALL LINE(IX1, IYK, IX2, IYK, 0)
   60 CONTINUE
      ISCRCH = IX2 - IX1
      KRANGE = KEND - KSTART
C
      IF( .NOT. LSEP ) GO TO 75
         CALL CHRSIZ(4)
         CALL MOVABS( IX1 + 800, IY2 + 40 )
         IF( LS .EQ. 1 ) CALL EOUTST( 4, HZETM )
         IF( LS .EQ. 2 ) CALL EOUTST( 4, HZETP )
C
   75 IF( .NOT. LDIF ) GO TO 100
         DO 80 IW = 1, NLIM
            IYK = IY1 + IYREL*(IW - 1) + ((IYREL - 50)*3)/8
            CALL LINE( IX1, IYK, IX2, IYK, 12 )
   80    CONTINUE
C
C                                      DRAW DRIFTTIME AS TRIANGLE
C                                      ONLY IN COMPRESSED MODE
  100 IF( LSEP ) GOTO 140
      IF( NNVTXC .LT. 0 .OR. NNVTXC .GT. 99 ) GO TO 102
         CALL CLOC( IPVTXC, 'VTXC', NNVTXC )
         NBANK = NNVTXC
         IF( IPVTXC .GT. 0 ) GO TO 103
            WRITE(6,101) NNVTXC
  101       FORMAT(' VTXC BANK NR',I3,' (GIVEN BY COMMAND VTXC) NOT EXIS
     *TING')
  102 NBANK = 10
      CALL CLOC( IPVTXC, 'VTXC', NBANK )
      IF( IPVTXC .LE. 0 )  GO TO 140
  103    NHDLV = IDATA(IPVTXC+1)
         NWORD = IDATA(IPVTXC) - NHDLV
         IF( NWORD .LE. 0 ) GO TO 140
C
C
            NHITS  = NWORD/2
            IPVTX2 = IPVTXC*2
            IPOFFS = IPVTX2 + NHDLV*2
            NCEL = NC - 1
            DO 120 IBK = 1, NHITS
               IPACTU = IPOFFS + (IBK-1)*4
               NWIR   = HDATA(IPACTU + 1)
C
               IF( NWIR .LT. NWLOW .OR. NWIR .GT. NWHIG ) GO TO 120
                  NWRC = NWIR - NCEL*MWIRE
                  IDRI = HDATA(IPACTU + 4)
                  DRIF = FLOAT(IDRI) - T0
                  DRI1 = DRIF*0.1
                  DRI2 = (DRIF*0.5*(CVD(1,NWIR)+CVD(2,NWIR))
     *                    - 0.5*(S0R(1,NWIR)+S0R(2,NWIR))/VD)*0.1
                  XT1  = FLOAT(ISCRCH)/FLOAT(KRANGE)*DRI1*0.1
                  XT2  = FLOAT(ISCRCH)/FLOAT(KRANGE)*DRI2*0.1
                  IXT1 = IX1 + IFIX(XT1)
                  IXT2 = IX1 + IFIX(XT2)
                  IYT  = IY1 + IYREL*(NWRC-1)
C
                  IA1  = HDATA(IPACTU + 2)
                  IA2  = HDATA(IPACTU + 3)
C
                  IF( IA1 .GT. 0 .AND. IA2 .GT. 0 ) GO TO 115
                     IF( IA1 .GT. 0 .AND. IA2 .LE. 0 ) GO TO 113
                        CALL PFEIL( IXT1, IYT, 2)
                        CALL LINE( IXT2, IYT-50, IXT2, IYT, 0 )
                        GO TO 120
  113                CALL PFEIL( IXT1, IYT, 1)
                     CALL LINE( IXT2, IYT-50, IXT2, IYT, 0 )
                     GO TO 120
  115             CALL DELTA( IXT1, IYT )
                  CALL LINE( IXT2, IYT-50, IXT2, IYT, 0 )
C
  120       CONTINUE
C
C
  140 IYUP = IY2
      IF(KTIMB .EQ. 0) IYUP = IY1
      CALL LINE(IX1, IYUP, IX1, IY1 - 20, 38)
      NB = KRANGE/NTIMB
      DO 200 JB = 1, NB
          IXWID = IX1 + ISCRCH*NTIMB*JB/KRANGE
          CALL LINE(IXWID, IYUP, IXWID, IY1 - 20, 38)
          ICHNR = KSTART + NTIMB*JB
          CALL MOVABS(IXWID - 40, IY1 - 50)
          CALL CHRSIZ(4)
          IF(NTIMB .EQ. 1 .AND. ((ICHNR/2)*2 - ICHNR) .NE. 0) GOTO 200
          IF(ICHNR .GE. 10) GOTO 150
             KAN(1) = KANAL(1)
             KAN(2) = KANAL(ICHNR + 1)
             GOTO 160
  150     CONTINUE
          KAN(1) = KANAL(ICHNR/10 + 1)
          KAN(2) = KANAL(ICHNR -(ICHNR/10)*10 + 1)
  160     CALL HLABEL(2, KAN)
  200 CONTINUE
C
      IF( LSEP .AND. LS .EQ. 1 ) GOTO 12
C
      RETURN
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C-----------------------------------------------------------------------
      SUBROUTINE INTADE( IN, IA, N )
C-----------------------------------------------------------------------
C
C    AUTHOR:   R. RAMCKE     30/10/84 :  CONVERTS INTEGER INTO ADE CODE
C
C-----------------------------------------------------------------------
C
      DIMENSION IA(N)
C
C-----------------  C O D E  -------------------------------------------
C
      IZ = 10**(N-1)
      K  = IN
      DO 10 J = 1, N
         IA(J) = K/IZ + 48
         K     = K - (K/IZ)*IZ
         IZ    = IZ/10
   10 CONTINUE
C
      IF( N .EQ. 1) GO TO 30
C                           MERGE ZEROES AT BEGIN
      NEND = N - 1
      DO 20 J = 1, NEND
         IF( IA(J) .GT. 48 ) GO TO 30
             IA(J) = 96
   20 CONTINUE
   30 CONTINUE
      RETURN
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C-----------------------------------------------------------------------
      SUBROUTINE LINE( IX1, IY1, IX2, IY2, NDRW )
C-----------------------------------------------------------------------
C
C    AUTHOR:   R. RAMCKE     07/03/83 :  DRAWS (DASHES) LINE FROM
C                                        (IX1,IY1) TO (IX2,IY2)
C
C
C-----------------  C O D E  -------------------------------------------
C
      CALL MOVABS(IX1, IY1)
      IF(NDRW .EQ. 0) CALL DRWABS(IX2, IY2)
      IF(NDRW .GT. 0) CALL DSHABS(IX2, IY2, NDRW)
      RETURN
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C-----------------------------------------------------------------------
      SUBROUTINE DELTA( IX, IY )
C-----------------------------------------------------------------------
C
C    AUTHOR:   R. RAMCKE     07/03/83 :  DRAWS TRIANGLE AT POSITION
C                                        (IX,IY)
C
C-----------------------------------------------------------------------
C
      DATA IA  / 20 /
C
C-----------------  C O D E  -------------------------------------------
C
      IB = 2*IA
      CALL MOVABS( IX - IA, IY - IB )
      CALL DRWABS( IX, IY )
      CALL DRWABS( IX + IA, IY - IB )
      CALL DRWABS( IX - IA, IY - IB )
      RETURN
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C-----------------------------------------------------------------------
      SUBROUTINE PFEIL( IX, IY, IS )
C-----------------------------------------------------------------------
C
C    AUTHOR:   R. RAMCKE     07/03/83 :  DRAWS ARROW AT POSITION
C                                        (IX,IY) WITH DIRECTION
C                                        UP (IS=1) OR DOWN (IS^=1)
C
C-----------------------------------------------------------------------
C
      DATA IA  / 20 /
C
C-----------------  C O D E  -------------------------------------------
C
      IB = -2*IA
      IF( IS .EQ. 1 ) IB = -IB
      CALL MOVABS( IX - IA, IY - IB )
      CALL DRWABS( IX, IY )
      CALL DRWABS( IX + IA, IY - IB )
      CALL MOVABS( IX, IY )
      CALL DRWABS( IX, IY - 2*IB )
      RETURN
      END

C   19/02/84 712141930  MEMBER NAME  EVWRIT0  (JADEGS)      FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EVWRIT(NUNIT)
C-----------------------------------------------------------------------
C
C   AUTHOR:   L. O'NEILL  30/08/79 :  WRITE JADE EVENTS
C
C        MOD: J. OLSSON   10/09/79 :  CORRECTED
C        MOD: L. O'NEILL  14/11/79 :  USE MUCONW
C        MOD: J. OLSSON   12/11/81 :  NEW MUCONW
C        MOD: J. OLSSON    4/08/83 :  CHANGES REGARDING MC CONSTANTS
C        MOD: C. BOWDERY  19/02/84 :  CHECK HEAD BANK EXISTS
C        MOD: C. BOWDERY  20/02/84 :  WRITE CONSTANTS WHEN NFLAGS(8)=1
C        MOD: J. HAGEMANN 08/11/84 :  ADD VERTEX CHAMBER CONSTANTS
C        MOD: E ELSEN     10/12/87 :  ADD DLRSLN
C   LAST MOD: J. HAGEMANN 11/12/87 :  ADD SMPRMV TO /CBINV/
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL LVTXC
C
C                            NFLAGS(7) IS USED TO COUNT HEADLESS EVENTS
C                            NFLAGS(8) = 1 MEANS WRITE NEW CONSTANTS
C
#include "cadmin.for"
#include "cdata.for"
#include "cgraph.for"
C
      COMMON / CGEO1  / GEO(66)
      COMMON / CJDRCH / DRCH(34)
C
C                                          VERTEX CHAMBER
      COMMON / CVCEX  / LVTXC
      COMMON / CGEOV  / GEOV(13)
      COMMON / CJVTXC / VXCC(15)
      COMMON / CBINV /  DTRSVV, ZRSVV, EFFVV(2), DOUBVV(3), IRNHVV,
     +                  SMPRMV(3)
C
      COMMON / CRDSTA / NDEAD, NCDEAD, HITD(10), HCELLD(10), IPHALG
      COMMON / CBIN   / TIME(6),ZOF,ZRS,ZL,ZSC,EPSI(3),DOUB(3),IRN(3),
     +                  BINDL8(6),RJITT, DLRSLN(3)
C
      COMMON / CTRIGG / IHIST(3),NBPTFW,IDUM1(5),HDUM1,HLGBRT,HLGBST,
     +                  HLGQT,HLGTOT(4,2),HECAPT(4),HLGTL,HLGTH,
     +                  HDUM2(10),IWIDBS,NRNBSL,NRNBSH,NTOFBS,IDUM2(10),
     +                  NTOFC,NTOFC1,NTOFC2,NTBGC,NTBGC1,NTBGC2,
     +                  IWCOLL,IWCOLN,IWMPRG,HFMPRL,HFMPRH,HWCOLN,
     +                  HMPRON,IWCTBG,NTFCOL,NTFCLN,IDUM3(10),
     +                  HITCLL(3),HITWLL(3),HITSUM(3),HCHAMB(3),
     +                  HMASK(16,3),HDEADC(10),HACC1,HACC2,HACC3,
     +                  HACC4,HACCM,HDUM6,IWIDT2,IDUM4(10)
C
      DIMENSION NAM1(3), NAMV(2)
C
C
      DIMENSION TSTAT1(110), TSTAT2(13), ABIN(20)
      EQUIVALENCE (TSTAT1(1),IHIST(1)), (TSTAT2(1), NDEAD)
      EQUIVALENCE ( ABIN(1), TIME(1) )
C
      DATA NAM1  / 'MTCO', 'MJET', 'MGEO' /
      DATA NAMV  / 'MVCC', 'MGEV' /
      DATA LMTCO,LGEO,LJET / 156, 66, 34 /
      DATA LVCC, LGEV  / 15, 13 /
C
C------------------  C O D E  ------------------------------------------
C
      IF( JUSCRN .LE. 0  .OR. JUSCRN .GT. 99 ) JUSCRN = 6
C
      IF( NFLAGS(8) .EQ. 0  .OR. IEVTP .EQ. 0 ) GO TO 10
C                                                    *****************
C                                                    *  MONTE CARLO  *
C                                                    *****************
C                                   ***************
C                                   *  BANK MTCO  *
C                                   ***************
C
C                  WRITE OUT CONSTANTS RECORDS FIRST ON FILE
C
      CALL CLOC( IPMTCO, NAM1(1), 1 )
      IF( IPMTCO .GT. 0 .AND. IDATA(IPMTCO).GE.LMTCO ) GO TO 1
C
      IF( IPMTCO .LE. 0 )
     *              CALL BCRE( IPMTCO, NAM1(1), 1,LMTCO, &1000, IER )
      IF( IDATA(IPMTCO).LT.LMTCO )
     *              CALL BCHM( IPMTCO, LMTCO - IDATA(IPMTCO), IER )
C
C                  COPY DETECTOR STATUS INTO MTCO BANK
C
    1 CALL MVCL( IDATA, (IPMTCO+10)*4, TSTAT1, 0, 110*4 )
      CALL MVCL( IDATA, (IPMTCO+120)*4, TSTAT2, 0, 13*4 )
C
C                  COPY DOUB, EPSI AND IRN INTO MTCO
C
      DO  1001  I = 1,3
          ADATA(IPMTCO+133+I) = DOUB(I)
          ADATA(IPMTCO+136+I) = EPSI(I)
          IDATA(IPMTCO+139+I) = IRN(I)
 1001 CONTINUE
      IF( .NOT. LVTXC )  GO TO 1003
         ADATA(IPMTCO+143) = DTRSVV
         ADATA(IPMTCO+144) = ZRSVV
         ADATA(IPMTCO+145) = EFFVV(1)
         ADATA(IPMTCO+146) = EFFVV(2)
         ADATA(IPMTCO+147) = DOUBVV(1)
         ADATA(IPMTCO+148) = DOUBVV(2)
         ADATA(IPMTCO+149) = DOUBVV(3)
         IDATA(IPMTCO+150) = IRNHVV
         ADATA(IPMTCO+154) = SMPRMV(1)
         ADATA(IPMTCO+155) = SMPRMV(2)
         ADATA(IPMTCO+156) = SMPRMV(3)
C
C  WORD2 :   DETECTOR STATUS AND SOME CBIN VARIABLES ARE STORED
C
 1003 IDATA(IPMTCO+2) = 1
C
C  WORD3 :   BINDL8 AND RJITT SMEARING VARIABLES ARE STORED, IF ISMEAR=100011900
C
      IDATA(IPMTCO+3) = ISMEAR
      IF(ISMEAR.EQ.0) GO TO 1111
C
C                  COPY BINDL8 AND RJITT INTO MTCO
C
      DO 1011 I=1,6
 1011 ADATA(IPMTCO+3+I) = BINDL8(I)
      ADATA(IPMTCO+10) = RJITT
      ADATA(IPMTCO+151) = DLRSLN(1)
      ADATA(IPMTCO+152) = DLRSLN(2)
      ADATA(IPMTCO+153) = DLRSLN(3)
 1111 CONTINUE
C
C  WORD1 :   THIS IS SMEARED MONTE CARLO DATA
C
      IDATA(IPMTCO+1) = 1
C                                   ***************
C                                   *  BANK MJET  *
C                                   ***************
C
C                  JET CHAMBER CONST
C
      CALL CLOC( IND, NAM1(2), 2 )
      IF( IND .GT. 0 ) GO TO 2
C
      CALL BCRE( IND, NAM1(2), 2, LJET, &1000, IER )
    2 CALL BSTR( IND, DRCH, LJET )
C
C                                   ***************
C                                   *  BANK MGEO  *
C                                   ***************
C
C                  GEOMETRICAL CONST
C
C
      CALL CLOC( IND, NAM1(3), 3 )
      IF( IND .GT. 0 ) GO TO 3
C
      CALL BCRE( IND, NAM1(3), 3, LGEO, &1000, IER )
    3 CALL BSTR( IND, GEO, LGEO )
C
      IF( .NOT. LVTXC ) GO TO 6
C
C                                   ***************
C                                   *  BANK MVCC  *
C                                   ***************
C
C                  CONSTANTS FOR VERTEX CHAMBER
C
C
      CALL CLOC( IND, NAMV(1), 4 )
      IF( IND .GT. 0 ) GO TO 4
C
      CALL BCRE( IND, NAMV(1), 4, LVCC, &1000, IER )
    4 CALL BSTR( IND, VXCC, LVCC )
C
C                                   ***************
C                                   *  BANK MGEV  *
C                                   ***************
C
C                  GEOMETRICAL CONSTANTS OF VERTEX CHAMBER
C
C
      CALL CLOC( IND, NAMV(2), 5 )
      IF( IND .GT. 0 ) GO TO 5
C
      CALL BCRE( IND, NAMV(2), 5, LGEV, &1000, IER )
    5 CALL BSTR( IND, GEOV, LGEV )
C
C                  WRITE OUT
C
    6 CALL BSLS(1)
      CALL BSLC
      CALL BSAW( 3, NAM1 )
      IF( LVTXC ) CALL BSAW( 2, NAMV)
      CALL BSLW
      CALL BWRITE( NUNIT )
      CALL BSLT
      CALL BDLG
C
C
C                  MU CHAMBER CONSTANTS
C
      CALL MUCONW(1,NUNIT,0,HERR)
      CALL BSLR(1)
C
C                            CLEAR FLAG TO INDICATE CONSTANTS WRITTEN
C
      NFLAGS(8) = 0
C
C                                                    *****************
C                                                    * REAL DATA AND *
C                                                    *  MONTE CARLO  *
C                                                    *    EVENTS     *
C                                                    *****************
10    NRWRIT = NRWRIT + 1
      IPHEAD = IDATA(IBLN('HEAD'))
      IF( IPHEAD .GT. 0 ) GO TO 12
        NFLAGS(7) = NFLAGS(7) + 1
        IF( NFLAGS(7) .GT. 50 ) GO TO 12
          WRITE(JUSCRN,11) NRWRIT
11        FORMAT(/' ****  WARNING  ****  EVWRIT DETECTED ''HEAD'' BANK',
     +            ' MISSING WHILE WRITING OUTPUT EVENT ',I6/)
C
12    CALL BSLW
      CALL BWRITE(NUNIT)
      RETURN
C
C                  ERROR IN RECORD WRITING
C
 1000 WRITE(JUSCRN,9101) IER
 9101 FORMAT(' BCRE ENDED WITH ERROR IER=',I4,' IN EVWRIT')
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FWRITE(NUNIT,NN,DATA)
C-----------------------------------------------------------------------
C
C      WRITE THE ARRAY DATA(NN) ONTO UNIT NUNIT
C
      DIMENSION DATA(NN)
      WRITE(NUNIT) NN,DATA
      RETURN
      END

C   28/11/85 512182247  MEMBER NAME  RBPIPE0  (S)           FORTRAN
C
C-----------------------------------------------------------------------
      FUNCTION RBPIPE(DUMMY)
C-----------------------------------------------------------------------
C
C
C     RETURNS THE BEAMPIPE RADIUS, BASED ON DATE IN HEAD BANK
C     IF A VTXC BANK IS PRESENT, NEW GEOMETRY IS FORCED.
C     ARGUMENT DUMMY IS IGNORED.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
#include "cgeo1.for"
#include "cgeov.for"
C
C------------------  C O D E  ------------------------------------------
C
      IH2    = 2*IDATA( IBLN( 'HEAD' ) )
      IVTXC  =   IDATA( IBLN( 'VTXC' ) )
      IF( IVTXC .GT. 0 ) GO TO 10
C
      IMONTH = HDATA(IH2+7)
      IYEAR  = HDATA(IH2+8)
C
C                            OLD GEOMETRY (PRIOR TO MAY 1984)
C
      RBPIPE = RPIP
C
      IF( IYEAR .LT. 1984  .OR.
     +    IYEAR .EQ. 1984  .AND.  IMONTH .LT. 5 ) RETURN
C
C                            NEW GEOMETRY
C
  10  RBPIPE = RPIPV
C
      RETURN
      END

C   25/06/78 705271434  MEMBER NAME  DENDEL   (S)           FORTRAN
      FUNCTION DENDEL(X)
C FUNCTION DENDEL CALCULATES DENSITY EFFECT CORRECTION.
C
      COMMON/DFPAR/CI,AI,RMI,X0,X1
      XT=X1-X
      IF(XT)2,1,1
 2    DENDEL=4.606*X+CI
      RETURN
 1    IF(X-X0) 3,3,4
 4    DENDEL=4.606*X+CI+AI*XT**RMI
      RETURN
 3    DENDEL=0.
      RETURN
      END

C   07/06/96 606071827  MEMBER NAME  BPLU     (S4)          FORTG1
      SUBROUTINE BPLU(IRB,IEV)
C     SPECIAL PLUTO PROGRAM
C
C     FOR NEW RUN   IRB = RUN NR       = 0 OTHERWISE
C                   IEV = IW(IHD+4)
C
      COMMON/BCS/IW(1)
      COMMON/IPAR64/IPAR(32)
      INTEGER LRN/0/,IJ/0/
      IF(LRN.EQ.0) CALL VZERO(IPAR,32)
      IRB=0
      IEV=0
      CALL BLOC(IHD,'HEAD',0,&100)
      IRN=IW(IHD+1)
      IEV=IW(IHD+4)
      IF(IRN.EQ.LRN) GOTO 100
      LRN=IRN
      CALL BSPC(IA,LB,IDUM1,IDUM2)
      CALL GETRUN(LRN,IPAR,IW(IA),&10,&10)
      IRB=IRN
      J=MOD(IJ,16)
      I=IJ/16
      IJ=IJ+1
      CALL ITABL(0,I,J,IRB)
      GOTO 100
C
   10 CALL VZERO(IPAR,32)
  100 RETURN
      END

C   20/08/82 209061341  MEMBER NAME  LGINIT   (SOURCE)      FORTRAN
      SUBROUTINE LGINIT
C
C     S.YAMADA   17-01-79   14:40
C     MODIFICATION   20-02-82   8:25 BY Y.WATANABE
C        DUE TO THE INSTALLATION OF THE NEW LG TRIGGER, THE THRESHOLD
C        OF BAD CHANNEL FOR ENDCAP IS INCREASED.
C     LAST MODIFICATION   20-08-82  13:25 BY S.YAMADA, JCALFL IS ADDED.
C                         06-09-82  13:40  THE MODIFIED VERSION LOADED.
C
C---- INITIALIZATION ROUTINE FOR THE LG-ANALYSIS PROGRAM
C---- LOAD IN BLOCK DATA WHEN CALLED.
      IMPLICIT INTEGER *2 (H)
      COMMON /CMSGCT/ LGMMAX,LGMSG(20)
C
C---- ERROR MESSAGE PRINTING PARAMETERS.
      LGMMAX = 5
        DO 400 K=1,20
  400   LGMSG(K) = 0
C
      RETURN
      END
C
C****************************************************************
C
C   17/12/78 C9030801   MEMBER NAME  LGBLCK   (JADELGS)     FORTRAN
      BLOCK DATA
C
C    S.YAMADA  01-09-78  12:15
C---- LAST MODIFICATION  08-03-79  22:30
C
C---- BLOCK DATA FOR THE LG-COUNTER GEOMETRICAL CONSTANTS
C
      IMPLICIT INTEGER *2 (H)
      COMMON /CLGDMS/ X0,RADIUS(6),RADSX0(6),THX0(4),
     1                ZEND(2),ZENDX0(2),ZWID(2),ZGAP(2),PHWID(2),
     2                ZECAP(4),ZECAPX(4),THECPX(2),
     3                ECXLST(24), ECYLST(24)
C
      COMMON/ CLGVRN/ NVRSN(20)
      DATA NVRSN/4*0, 178090112, 15*0/
C
C---- THE UNIT IS EITHER MM OR X0.
C
      DATA X0/22.39/
C
C---- RADIUS IN MM
C     RADIUS(1,2) = DISTANCE TO THE COIL SURFACES(INNER AND OUTER)
C     RADIUS(3,4) = DISTANCE TO THE LEAD GLASS SURFACES(TYPE A)
C     RADIUS(5,6) = DISTANCE TO THE LEAD GLASS SURFACES(TYPE A-PR)
C
      DATA RADIUS/ 950.0, 967.45, 1100.0, 1400.0, 1150.0, 1400.0/
C---- RADIUS IN X0
      DATA RADSX0/ 42.430, 43.209, 49.129, 62.528, 51.362, 62.528/
C
C---- THICKNESS OF EACH PART IN X0
C     THX0(1)=COIL EQUIV.,THX0(2)=GAP BETWEEN THE COIL AND THE L.G.
C     THX0(3)=TYPE A LEAD-GLASS,  THX0(4)=TYPE A-PR LEAD-GLASS
C
      DATA THX0/ 0.779, 5.920, 13.399, 11.166/
C
C---- THE BARREL ENDS
      DATA ZEND/ -1705.45, 1705.45/, ZENDX0/ -76.172, 76.172/
C
C---- COUNTER SIZE IN MM AND IN X0
      DATA ZWID/ 103.2, 4.609/,  PHWID/80.8, 3.609/
C
C---- COUNTER GAP
      DATA ZGAP/3.5, 0.156/
C
C---- END CAP WALL POSITIONS
      DATA ZECAP/ -1522.0, -1748.0, 1522.0, 1748.0/
      DATA ZECAPX/ -67.977, -78.071, 67.977, 78.071/
C        MORE ACCURATE VALUES 2-11-79
      DATA THECPX/ 226.0, 10.09/
C
C---- ECXLST,ECYLST   X AND Y POSITIONS OF THE ENDCAP COUNTERS
      DATA ECXLST/400., 350., 210., 70., 540., 490., 350., 210.,
     1          70., 680., 630., 490., 350., 210., 70., 820.,
     2          770., 2*630., 2*490., 350., 210., 70./
      DATA ECYLST/70., 210., 350., 400., 70., 210., 350., 490.,
     1          540., 70., 210., 350., 490., 630., 680., 70.,
     2          210., 350., 2*490., 2*630., 770., 820./
C
C
C---- LG ANALYSIS PARAMETERS
      COMMON /CLGPRM/ ITH,MAXCLS,IRLTHD,IRLTH2,IRLTH3, ZVRTX,DZVRTX
     $               ,IDUMM(2), JCALFL
C     IDUMM(2) IS TO KEEP SOME OLD PROG. HAPPY.
      DATA IDUMM/2*200/
C     JCALFL;  FLAG TO CHECK THE LG-CALIBRATION CONST.
      DATA JCALFL/0/
C                    IT IS SET TO 1 IN THE KLREAD IF THE RIGHT CONSTS
C                    ARE SET.
C
C---- THRESHOLD TO START CLUSTER SEARCH.  NOW ADC-DATA IS CALIBRATED
C     TO GIVE ENERGY IN MEV BEFORE ANALYSIS STARTS.
C---- THE MAXIMUM NUMBER OF CLUSTERS TO BE STORED.
      DATA ITH/45/, MAXCLS/80/
C
      DATA IRLTHD/5/, IRLTH2/2/, IRLTH3/3/
C---- (THRESHOLD TO SEPARATE NEARBY CLUSTERS.)
C
C----  DEFAULT Z-VERTEX
      DATA  ZVRTX/ 0.0/, DZVRTX/0.0/
C
      COMMON /CUNIT/ LUNMVC,LUNMUE,LUBADC
      DATA  LUNMVC/8/, LUNMUE/9/, LUBADC/13/
C
      COMMON /CLGBCH/ HABAD(2,3),HBBAD(2,2,2)
C     THE CUTS TO LIST UP BAD CHANNELS BASED ON F22WAT.LGBADCH
C     HABAD(J,I);  J=1 MIN. #CHANNELS
C                  J=2 MIN. (FRAQ. OF FIRING)*10**4
C                  I; 1=ALL CRATES, 2=EACH CRATE, 3=EACH ADC
C     HBBAD(K,J,I);K=1 MIN. (FRAQ. OF FIRING)*10**4
C                  K=2 AVERAGE PULSE HEIGHTS
C                  J;1=SUB, 2=KILL
C                  I=1 BARREL,I=2 END CAP
C
      DATA HABAD/600,20,60,20,18,20/
CCCCC DATA HBBAD/100,3,500,1000,500,3,1000,1000/
      DATA HBBAD/500,3,1000,1000,1500,3,1000,1000/
C                               ...14-11-80... NOT TO KILL...
      END

C********************************************************************
C*                                                                  *
C*             X - Y - Z   V E R T E X   F I T                      *
C*                                                                  *
C*       INPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)            *
C*       ================                                           *
C*       NT    = TOTAL NR OF TRACKS OF EVENT                        *
C*       IT(1) =         FLAG (0 = TRACK INCOMPLETE OR BAD, NOT USED*
C*                             1 = GOOD, BUT DO NOT USE IN VERTEXFIT*
C*                             2 = GOOD)                            *
C*       T( 2) = +-R     RADIUS(+ MEANS ANTICLOCKWISE LOOKING TO -Z)*
C*          3  = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          4  = THETA   POLAR ANGLE TO XY-PLANE(0=VERTICAL TO BEAM)*
C*          5  = XT      .                                          *
C*          6  = YT      . FIRST MEASURED POINT ON TRACK            *
C*          7  = ZT      .                                          *
C*          8  = DPHI    ERROR OF PHI                               *
C*          9  = DTHETA  ERROR OF THETA                             *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         13  = NPT     NUMBER OF POINTS ON TRACK (INTEGER)        *
C*         14  = 0       NOT USED ON INPUT                          *
C*         15  = S0      INITIAL ARCLENGTH ( = 0. OR CLOSEST        *
C*                          APPROACH TO RUNVERTEX )                 *
C*         16-40         FOR INTERNAL USE (SEE BELOW)               *
C*        (41-80)        2. TRACK                                   *
C*         .....         ........                                   *
C*                                                                  *
C*       OUTPUT PARAMETERS IN /CWORK1/ (MM, MEV, RADIANS)           *
C*       =================                                          *
C*       FOR TRACKS WITH IT(1) GT 0                                 *
C*       IT(1) =         FLAG (3 = TRACK WAS USED IN VERTEXFIT)     *
C*       T( 3) = PHI     AZIMUTH AT POINT XT,YT,ZT                  *
C*          5  = XT      .                                          *
C*          6  = YT      . POINT ON TRACK NEAREST TO VERTEX         *
C*          7  = ZT      .                                          *
C*         10  = DXT     .                                          *
C*         11  = DYT     . ERROR OF XT,YT,ZT                        *
C*         12  = DZT     .                                          *
C*         14  = NV      NUMBER OF VERTEX TO WHICH TRACK BELONGS (I)*
C*         15  = S       EXTRAPOLATED ARC LENGTH (USUALLY NEGATIVE) *
C*       ALL OTHER T'S ARE UNCHANGED                                *
C*                                                                  *
C*       NV    = TOTAL NUMBER OF VERTICES                           *
C*       IV(1) =         FLAG (0 = NO VERTEX FIT                    *
C*                             1 = BAD VERTEX FIT                   *
C*                             2 = VERTEX OF 1- OR COLLINEAR 2-PRONG*
C*                             3 = GOOD VERTEX FIT                  *
C*                             4 = E+E- PAIR VERTEX                 *
C*                             5 = ISOLATED SINGLE TRACK VERTEX)    *
C*       V( 2) = X       .                                          *
C*          3  = Y       . VERTEX COORDINATES                       *
C*          4  = Z       .                                          *
C*          5  = DX      .                                          *
C*          6  = DY      . ERROR OF X,Y,Z                           *
C*          7  = DZ      .                                          *
C*       IV(8) = NTR     NUMBER OF TRACKS USED IN VERTEX FIT        *
C*       V( 9) = CHI2    CHISQARE OF FIT (N.D.F. = 2*NTR-3)         *
C*       IV(10)= NTRALL  NUMBER OF TRACKS BELONGING TO THIS VERTEX  *
C*        (11-20)        2. VERTEX                                  *
C*         .....         .........                                  *
C*                                                                  *
C*       INTERNAL PARAMETERS                                        *
C*       ===================                                        *
C*       IT(1) IS SET NEGATIV TEMPORARILY IF TRACK BELONGS TO VERTEX*
C*       T(16) = COULOMB SCATTERING ERROR ( TANKWALL )              *
C*       T(17) = COULOMB SCATTERING ERROR ( NEW BEAMPIPE ONLY )     *
C*       T(18) = S TO TANKWALL NEAR                                 *
C*       T(19) = S TO BEAMPIPE NEAR                                 *
C*       T(20) = PROJ. TRACKLENGTH IN RPHI                          *
C*       T(21) = SIN(PHI0)                                          *
C*       T(22) = COS(PHI0)                                          *
C*       T(23) = TAN(THETA)                                         *
C*       T(24) = COS(THETA)                                         *
C*       T(25)   UNUSED                                             *
C*       T(26) = S TO TANKWALL FAR                                  *
C*       T(27) = S TO TANKWALL NEAR                                 *
C*       T(28) = S.D. X                                             *
C*       T(29) = S.D. Y                                             *
C*       T(30) = S.D. Z                                             *
C*                                                                  *
C*       NEW INTERNAL PARAMETERS ( 31 - 40 )               BY KLE   *
C*       -----------------------                                    *
C*       IT(31)= 1 FOR 'COMFIT'TED TRACKS, 0 ELSE                   *
C*                                      ( COVAR. DEFAULTS :   )     *
C*       T(32) = RPHI COVARIANCE : X**4 ( 180 SIG**2/N / L**4 )     *
C*       T(33) = RPHI COVARIANCE : X**3 ( 0.0 )                     *
C*       T(34) = RPHI COVARIANCE : X**2 ( -18 SIG**2/N / L**2 )     *
C*       T(35) = RPHI COVARIANCE : X**1 ( 0.0 )                     *
C*       T(36) = RPHI COVARIANCE : X**0 ( 9/4 SIG**2/N )            *
C*       T(37) = SIG**2/NPT IN ZS                                   *
C*       T(38) = PROJ. TRACKLENGTH IN ZS                            *
C*       T(39) = S0(ZS) - S0(RPHI)                                  *
C*       T(40) = COVARIANCE TERM FOR ANGULAR ERROR                  *
C*                                                                  *
C********************************************************************
C*                                                                  *
C*   MODES :                                                        *
C*  =========                                                       *
C*   BIT 31 ON --> STARTPOINT IS RUNVERTEX ( NOT FIRST MEASURED )   *
C*   BIT 30 ON --> RUNVERTEX CONSTRAIN                              *
C*   BIT 29 ON --> AXIS CONSTRAIN                                   *
C*   BIT 28 ON --> FITS IN RPHI AND Z ARE INDEPENDENT               *
C*   BIT 27 ON --> LOCAL STATISTICS FROM VERTEX                     *
C*   BIT 26 ON --> OVERWRITE PATR-BANK FOR TYP 2 WITH HELIX-        *
C*                 PARAMETERS                                       *
C*   BIT 25 ON --> MESSAGE FROM VTXEE IF FAILED                     *
C*                                                                  *
C********************************************************************

C   02/02/79 C9032101   MEMBER NAME  EVREA1   (JADEGS)      FORTRAN
      SUBROUTINE EVREA1(NUNIT,NWORD,IDATA,IRET)
      IMPLICIT INTEGER*2 (H)
      DIMENSION IDATA(NWORD)
      READ(NUNIT,ERR=1,END=2) NWORD,IDATA
      IRET=0
      RETURN
    1 CONTINUE
      IRET=1
      RETURN
    2 IRET=2
      RETURN
      END

C   25/06/78 C8062601   MEMBER NAME  SETECT   (LGSOURCE)    FORTRAN
      SUBROUTINE SETECT(ECUTIN)
C
C     S.YAMADA    04-03-78
C
C     LAST MODIFICATION  14-03-77 14:35  BY A.SATO
C
C---- RESULT TABLE
C
C    2.0<=ECUTIN
C       ECUTEL=ECUTIN, ECUTPS=ECUTIN, ECUTPH=ECUTIN-1.0, ECUT=ECUTIN
C
C    1.05<ECUTIN<2.0
C       ECUTEL=ECUTIN, ECUTPS=0.9999, ECUTPH=0.05, ECUT=1.0
C
C    1.0<ECUTIN<1.05
C       ECUTEL=ECUTIN, ECUTPS=0.9999, ECUTPH=0.05, ECUT=1.0
C
C    ECUTIN<=1.0
C       ECUTEL=1.0, ECUTPS=0.9999, ECUTPH=0.05, ECUT=1.0
C
      COMMON/ENECUT/ECUT,ECUTEL,ECUTPH,ECUTPS
       DATA RM/.511/
      DIMENSION ECUTLS(3)
      EQUIVALENCE (ECUTLS(1),ECUTEL)
C
C     IF(ECUTIN .GT.0.) GOTO 2
C     CALL MSG('ECUT IN MEV =? (F8.2);;')
C     READ(5,500) ECUTIN
C 500 FORMAT(F8.2)
C   2 CONTINUE
      ECUTIN=ECUTIN/RM
C
      ECUTEL=ECUTIN
      IF(ECUTEL.LT.1.0) ECUTEL=1.0
      ECUTPH = ECUTEL-1.0
      IF(ECUTPH.LT.0.05) ECUTPH=0.05
      ECUTPS = ECUTEL
      IF(ECUTPH.LT.1.0) ECUTPS= 0.9999
C
      ECUT = ECUTPS
      IF(ECUT .LT. 1.0) ECUT=1.0
C     GOTO 1
C
C     ENTRY SETEC0
C
C     CALL MSG('ECUT IN MEV =? (F8.2);;')
C     READ(5,500) ECUTIN
C     ECUTIN=ECUTIN/.511
C     IF(ECUTIN.LT.1.)ECUTIN=1.
C     ECUT=ECUTIN;ECUTEL=ECUTIN;ECUTPH=ECUTIN;ECUTPS=ECUTIN
C
    1 FCUT=ECUT*RM
      FCUTEL = ECUTEL*RM
      FCUTPH = ECUTPH*RM
      FCUTPS = ECUTPS*RM
      PRINT 600,FCUT,FCUTEL,FCUTPH,FCUTPS
600   FORMAT(' ECUT,ECUTEL,ECUTPH,ECUTPS IN MEV=',4G12.4)
      RETURN
      END

C   16/06/87 901131422  MEMBER NAME  ZSPDBK   (JADEGS)      FORTRAN77
      SUBROUTINE ZSPDBK( ITRK )
C----------------------------------------------------------
C  Version of 22/04/87      Last mod 13/01/89   C Bowdery
C  Copy information of z fit into Bank ZSPD, itrk
C  all existing banks of this name are deleted.
C  The words are stored as:
C     (..+1) = IJC(I),       REL POINTER IN JETC
C     (..+2) = S(I),         TRACK LENGTH
C     (..+3) = Z(I),         Z
C     (..+4) = FLAG(I),      0 IF OK
C     (..+5) = 1/SIGMA(I)**2
C----------------------------------------------------------
      IMPLICIT INTEGER*2 (H)
      PARAMETER (NWTR=5)
      COMMON / BCS / IW(1)
      DIMENSION HW(1),RW(1)
      EQUIVALENCE (HW(1),IW(1),RW(1))
C
      COMMON /CWORK/ NHIT,IZB(60),IJC(60),IJH(60),NW(60),LH(60),
     *                LRFL(60),ALU(60),ARU(60),X(60),Y(60),Z(60),S(60),
     *                G(60),DT(60),DL(60),DW(60),FCORR(60)
C
      NPJETC = IW(IBLN('JETC'))

      IF( NHIT .GT.0 .AND. NPJETC.GT.0 .AND.
     *    ( IW(NPJETC-2).EQ.0 .OR. IW(NPJETC-1).LE.0 ) ) THEN
        CALL BCRE( NPZSPD, 'ZSPD', ITRK, NWTR*NHIT+1, *8000, IER )
        CALL BSAW( 1, 'ZSPD' )
        IW(NPZSPD+1) = NWTR
        NPZSP1 = NPZSPD + 1
        DO 100 I=1,NHIT
          IW(NPZSP1+(I-1)*NWTR+1) = IJC(I) - NPJETC*2
          RW(NPZSP1+(I-1)*NWTR+2) = S(I)
          RW(NPZSP1+(I-1)*NWTR+3) = Z(I)
          IF( IZB(I) .EQ. 0 ) THEN
            IW(NPZSP1+(I-1)*NWTR+4) = 16
          ELSE
            IW(NPZSP1+(I-1)*NWTR+4) = 0
          ENDIF
          RW(NPZSP1+(I-1)*NWTR+5) = G(I)
  100   CONTINUE
      ENDIF
 8000 CONTINUE
      END

C   12/03/84 412041848  MEMBER NAME  TAGCLS   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
       SUBROUTINE TAGCLS(ISTART,IEND,THRESH,IWRITE)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C THIS ROUTINE FINDS THE CLUSTERS IN THE TAGGING SYSTEM
C BY LOOKING FOR BLOCKS WITH LOTS OF ENERGY AND ASSUMING ALL
C ITS NEIGHBOURS ARE POTENTIAL MEMBERS OF THE CLUSTER AND THERFORE
C CAN'T BE PARENTS OF ANOTHER CLUSTER.
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      COMMON/COMTAG/LISTOK,NLIST(64,9,2),
     1XMAP(64),YMAP(64)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C COMTAG - THESE NUMBERS ARE NEEDED THROUGHOUT THE JOB BY ANALYSIS
C           ROUTINES
C ================================================================
C
C
C LISTOK->  FLAGS THAT NEIGHBOUR LIST HAS BEEN GENERATED
C
C NLIST ->  LIST OF CLOSEST NEIGHBOURS TO A BLOCK   (I,1) = NUMBER
C           OF CLOSEST NEIGHBOURS (I,2-9)ADC ADDRESSES OF NEIGHBOURING
C           BLOCKS  (CLUSFN).THE THIRD ARGUMENT REFERS TO THE MARK
C           OF TAGGING SYSTEM - EITHER MARK 2 OR MARK 3.
C
C XMAP(64) -> XMAP AND YMAP CONTAIN THE X,Y ADDRESSES OF THE BLOCKS IN
C YMAP(64) -> THE 1982 TAGGING SYSTEM
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
C
       DIMENSION FOUND(90)
       DIMENSION FLIST(64)
C
C CLEAR CMAP,FOUND,FLIST
C
       DO  9 I = 1,10
          DO  9 J = 1,9
             CMAP(I,J) = 0.0
    9  CONTINUE
       NUM = IEND - ISTART + 1
       DO 1 N = 1,NUM
          FOUND(N)     = 0.0
          FLIST(N)     = 0.0
          FLIST(N + NUM) = 0.0
    1  CONTINUE
       NCLST = 0
       K     = 1
C
C
C MAIN LOOP >>
C
C
    4  DO 10 I = ISTMZ    ,IENDMZ
C
C CHECK IF WE HAVE ALREADY USED THIS ADC
C A 'PARENT' CANT BE THE NEIGHBOUR OF ANOTHER CLUSTER
C
          DO 5 J = 1,K
             IF ( SADC(I,1) .EQ. FOUND(J) ) GOTO 10
    5     CONTINUE
C
C CHECK IF ENERGY IS BELOW THRESHOLD TO CALL IT A CLUSTER
C
          IF ( SADC(I,2) .LT. THRESH ) GOTO 11
C
C CLUSTER FOUND - STORE THE INFORMATION
C
          NCLST = NCLST + 1
          IF ( NCLST .GT. 10 ) GOTO 999
C
C PARENT ADC IS FIRST MEMBER OF CLUSTER MAP
C
          CMAP(NCLST,1) = SADC(I,1)
C
C NO OF NEIGHBOURS = NNEI  FOUND FROM NEIGHBOUR LIST
C
          NFADC = SADC(I,1)
C
C
          NNEI = NLIST(NFADC,1,MARK)
C
C
          IELOOP = NNEI + 1
C
C NLIST 2 TO NLIST (2 + NNEI) CONTAIN THE ADDRESSES ( IN CATAG)
C OF NEIGHBOURS OF THIS 'PARENT'
C
          DO 20 L = 2, IELOOP
C
C ADC NO. OF NEIGHBOUR = NADC
C
             NADC = NLIST(NFADC,L,MARK)
C
C FILL CLUSTER MAP
C
             CMAP(NCLST,L) = NADC
C
C SAVE ADC ADDRESSES USED,SO THEY CANT BECOME PARENTSOF LATER CLUSTERS
C
             FOUND(K) = NADC
C
             K = K + 1
             IF ( K .GT. 90 ) GOTO 999
C
C COUNT NUMBER OF CLUSTERS FOR WHICH THIS IS A NEIGHBOUR
C END OF LOOP OVER NEIGHBOURS OF PARENT
C
             FLIST(NADC) = FLIST(NADC) + 1
C
   20     CONTINUE
C
   10  CONTINUE
C
   11  CONTINUE
C
       IF ( NCLST .LE. 1 ) GOTO 40
C
C
C FOR ADC'S IN MORE THAN ONE CLUSTER,DIVIDE ENERGY BY NUMBER OF CLUSTERS
C FOR WHICH IT IS A MEMBER
C
 1000  DO 30 I = ISTART,IEND
          IF ( FLIST(I) .LE. 1 ) GOTO 30
          CATAG(I) = CATAG(I) / FLIST(I)
   30  CONTINUE
C
   40  CONTINUE
       IF ( IWRITE .NE. 1 ) RETURN
       DO 50 I = 1,NCLST
          WRITE(6,602) CMAP(I,1) ,CMAP(I,2) ,CMAP(I,3) ,CMAP(I,4) ,
     *                 CMAP(I,5) ,CMAP(I,6) ,CMAP(I,7) ,CMAP(I,9 )
   50  CONTINUE
  602  FORMAT(9(2X,F10.2))
       RETURN
C
C
  999  WRITE(6,600)
  600  FORMAT(' WARNING MORE THAN 10 CLUSTERS FOUND BY TAGCLS ')
       GOTO 1000
       END

C   12/03/84 412041226  MEMBER NAME  CTAGGO   (S)           FORTRAN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C HERE ARE THE COMMONS THAT EVENTUALLY BECOME THE TP BANKS ACCLS -
C TAGG/O ,1,2,3
C CONVENTION IN NAMING -
C
C FIRST LETTER -
C         C - NAME OF COMMON
C         H - NAME OF VARIABLES *2 TYPE      INTEGER
C         I -   "       "       *4 TYPE         "
C         A -   "       "                    REAL
C
C REST OF NAME AS FOR TAGG BANKS SEE JADE COMPUTER NOTE 16 FOR MORE DETA
C
C ACTUALLY ALL THIS COULD ALSO GO IN WORKSPACE BUT I CANT BE BOTHERED!
C
C**** IMPORTANT :  IF YOU CHANGE THE SIZE OF THESE COMMONS PLEASE
C                  REMEMBER TO CHANGE 'TAGINT' WHICH CLEARS THEM.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      COMMON / CACLS  / HID1,HID2,HIPM,HIPZ,HDUM,HIPL,HDUMM1(134)
      DIMENSION HACLS(140)
      EQUIVALENCE ( HACLS(1) , HID1 )
C
      COMMON / CTAGG0 / HID3,HID4,HTRACK,HTRZMI,HTRZPL,HCLST,
     *                  HCLZMI,HCLZPL,HNEUT,HCOL,HTYPE,HER,HCORR,
     *                  HPBLAT,HDUM1,HDUM2,HSCAL(36),HWPCL,HWPTR,
     *                  HDUMM2(14)
      DIMENSION     ATAGG0(34)
      EQUIVALENCE ( HID3 , ATAGG0(1) )
C
      COMMON / CTAGG1 / HMAP(2,20)
C
      COMMON / CTAGG2 / ATAGG2(260)
      DIMENSION         ITAGG2(260)
      INTEGER*2         HTAGG2(520)
      EQUIVALENCE ( HTAGG2(1) , ITAGG2(1) , ATAGG2(1) )
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C   27/06/79 C9073101   MEMBER NAME  LUMONS   (JADEGAMS)    FORTRAN
      SUBROUTINE LUMONS(ICOMB,ITRK)
C---  DETERMINE WHETHER TRACK HITS LUMONITORS
C
C     H.WRIEDT     27.6.79      04:10
C     LAST MODIFICATION       30.7.79       20:10
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CWORK/ IWORK1(601),CLSPRP(13,51)
      DIMENSION HCLSPR(26,51)
      EQUIVALENCE (HCLSPR(1,1),CLSPRP(1,1))
C
      COMMON /CGGDMS/ X0,ZECAP(4),ZECAPX(4),THECPX(2),
     &                ECXLST(46),ECYLST(46),
     &                XANL(8),XANU(8),YANL(8),YANU(8),
     &                XBNL(8),XBNU(8),YBNL(8),YBNU(8)
C
      DIMENSION XA(3),XB(3)
C
      DATA PIHALF/1.57079632/, PI/3.14159264/
C
      COMMON /CGGVRN/ NVRSN(20)
      DATA NVCODE/279073020/
C
      NVRSN(16) = NVCODE
      ICOMB = 0
      IF (HCLSPR(2,ITRK).EQ.+1) GOTO 5
C---  Z-COORDINATES OF A- AND B-COUNTERS ON -Z-SIDE (PRELIMINARY!)
      XA(3) = -4135.
      XB(3) = -4235.
      IDIR = 0
      GOTO 10
C---  Z-COORDINATES OF A- AND B-COUNTERS ON +Z-SIDE (PRELIMINARY!)
    5 XA(3) = 4135.
      XB(3) = 4235.
      IDIR = 4
C
C---  CALCULATE PHI- AND SIN(THETA)-VALUE OF TRACKS
   10 DX = CLSPRP(11,ITRK)
      DY = CLSPRP(12,ITRK)
      DZ = CLSPRP(13,ITRK)
C
      IF (DY.NE.0.) GOTO 15
      PHI = SIGN(PIHALF,DX)
      GOTO 16
   15 PHI = ATAN(DX/DY)
      IF (DY.LT.0.) PHI = PI - PHI
C
   16 STHETA = SIN(ARCOS(DZ))
C---  COMPUTE X- AND Y-COORDINATES IN A-COUNTER PLANE (EACH IN MM)
C     AND ROTATE THEM BY 45 DEGREES
      CALL RCOORD(XA,PHI,STHETA)
      XR = XA(1)
      YR = XA(2)
C
C---  WHICH COUNTER HAS BEEN HIT?
      K = 0
        DO 20 II = 1,4
        I = II + IDIR
        IF (XR.GT.XANL(I).AND.XR.LT.XANU(I).AND.YR.GT.YANL(I).AND.YR
     &      .LT.YANU(I)) K = I
        IF (K.GT.0) GOTO 21
   20   CONTINUE
      GOTO 25
   21 ICOMB = 2**(16-K)
C---  COMPUTE X- AND Y-COORDINATES IN B-COUNTER PLANE (EACH IN MM)
C     AND ROTATE THEM BY 45 DEGREES
   25 CALL RCOORD(XB,PHI,STHETA)
      XR = XB(1)
      YR = XB(2)
C---  WHICH COUNTER HAS BEEN HIT?
      K = 0
        DO 30 II = 1,4
        I = II + IDIR
        IF (XR.GT.XBNL(I).AND.XR.LT.XBNU(I).AND.YR.GT.YBNL(I).AND.YR
     &      .LT.YBNU(I)) K = I
        IF (K.GT.0) GOTO 31
   30   CONTINUE
      RETURN
   31 ICOMB = ICOMB + 2**(8-K)
      RETURN
      END

      SUBROUTINE LBHTRO(ITRK,PAR1,PAR2,PAR3,INDPAR)
      IMPLICIT INTEGER*2 (H)
#include "cworkpr.for"
#include "cworkeq.for"
      EQUIVALENCE
     ,          (HPCO0 ,HPWRK(17)),(HPCO9 ,HPWRK(18)),(HLDCO ,HPWRK(19))
     ,         ,(ICELL ,IDWRK( 1)),(MHIT  ,IDWRK( 2)),(IRING ,IDWRK( 3))
     ,         ,(IERRCD,IDWRK( 4)),(NTRKEL,IDWRK( 5))
#include "cpatlm.for"
#include "cjdrch.for"
#include "cdsmax.for"
      DIMENSION HST( 80)
      DATA XCV /152.7/
      CALL SETS(HST(1),0,160,0)
      DCRV =  .000010
      CRV1 = -DCRV*20.
      X0   = FSENSW(IRING) + RINCR(IRING)*7.5
      Y0   = (PAR1*X0 + PAR2)*X0 + PAR3
      S0   = PAR1*X0*2. + PAR2
      CRV0 = (S0*X0 - Y0) / X0**2
      CRV0 = CRV0 + CRV1
      CVP0 = (S0*X0 - Y0) / (X0**2 - XCV**2)
      CVP0 = CVP0 + CRV1
      ZW1  = X0
      ZW2  = Y0 / X0
      ZW3  = XCV**2
      DO 13000 IP = HPCO0,HPCO9,HLDCO
          X   = WRK(IP+3)
          Y   = WRK(IP+4)
      IF(
     - ABS(X-X0) .GT. 25.
     -)THEN
            CV1 = ZW2*X - Y
            CV2 = (ZW1-X)*X
            CRV = CV1 / CV2
            IBN = (CRV-CRV0) / DCRV + 1
            IF(IBN.GT.0 .AND. IBN.LE.40) HST(IBN   ) = HST(IBN   ) + 1
            CVP = CV1 / ((X/ZW1-1.)*ZW3 + CV2)
            IBM = (CVP-CVP0) / DCRV + 1
            IF(IBM.GT.0 .AND. IBM.LE.40) HST(IBM+40) = HST(IBM+40) + 1
      ENDIF
13000 CONTINUE
13001 CONTINUE
      MHST = 0
      IMAX = 0
      DO 13002 I=19,22
        NHST = HST(I-1) + HST(I  ) + HST(I+1)
      IF(
     - NHST.GE.MHST
     -)THEN
          MHST = NHST
          IMAX = I
      ENDIF
13002 CONTINUE
13003 CONTINUE
      MHSTP = 0
      IMAXP = 0
      DO 13004 I=59,62
        NHST = HST(I-1) + HST(I  ) + HST(I+1)
      IF(
     - NHST.GE.MHSTP
     -)THEN
          MHSTP = NHST
          IMAXP = I
      ENDIF
13004 CONTINUE
13005 CONTINUE
      IF(
     - MHSTP.LT.IRING*8 .OR. MHSTP-5.LT.MHST
     -)THEN
        INDPAR = 0
      ELSE
        INDPAR = 1
        MHST = MHSTP
        IMAX = IMAXP - 40
        CALL MVC2(HST(1),0,HST(2),0,80) !PMF 28/06/99 MVC -> MVC2
        CRV0 = CVP0
        PAR1 = CVP0 - CRV1
        PAR3 = PAR1 * ZW3
      ENDIF
      NH0 = HST(IMAX-2)
      NH1 = HST(IMAX-1)
      NH2 = HST(IMAX  )
      NH3 = HST(IMAX+1)
      NH4 = HST(IMAX+2)
      IF(
     - IMAX.EQ.19 .AND.
     ?   NH0.GT.0 .AND. NH0.GT.NH1 .AND. NH4.NE.0
     -)THEN
        IMAX = IMAX + 1
      ENDIF
      IF(
     - IMAX.EQ.22 .AND.
     ?   NH4.GT.0 .AND. NH4.GT.NH3 .AND. NH0.NE.0
     -)THEN
        IMAX = IMAX - 1
      ENDIF
      IM1 = IMAX - 1
      IM3 = IMAX + 1
      IF(NH1.LE.2 .AND. NH3-NH1.GT.2) IM1 = IM1 + 1
      IF(NH3.LE.2 .AND. NH1-NH3.GT.2) IM3 = IM3 - 1
      NHST  = NH1 + NH2 + NH3
      NHTTR = 0
      IF(
     - NHST.GE.3
     -)THEN
        IHIT = 0
        IPHT = HPHT0
      DO 13006 IP = HPCO0,HPCO9,HLDCO
          X   = WRK(IP+3)
          Y   = WRK(IP+4)
      IF(
     - ABS(X-X0) .GT. 25.
     -)THEN
            CV1 = ZW2*X - Y
            CV2 = (ZW1-X)*X
      IF(
     - INDPAR.EQ.0
     -)THEN
              CRV = CV1 / CV2
      ELSE
              CRV = CV1 / ((X/ZW1-1.)*ZW3 + CV2)
      ENDIF
            IBN = (CRV-CRV0) / DCRV + 1
      IF(
     - IBN.GE.IM1 .AND. IBN.LE.IM3
     -)THEN
      IF(
     - IWRK(IP+ 9).EQ.ICELL
     -)THEN
                LBGOOD = 4
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ELSE
                LBGOOD = 0
      ENDIF
      ELSE
              LBGOOD = 8
      ASSIGN 17002 TO IZZZ01
      GOTO 17000
17002 CONTINUE
      ENDIF
      ELSE
            LBGOOD = 1
      ASSIGN 17003 TO IZZZ01
      GOTO 17000
17003 CONTINUE
      ENDIF
          IWRK(IP+7) = LBGOOD
          IF(LBGOOD.EQ.0) IHIT = IHIT + 1
13006 CONTINUE
13007 CONTINUE
        NHTTR = IHIT
      ENDIF
      RETURN
17000 CONTINUE
      IF(
     - ITRK.GT.0
     -)THEN
        JCELL = IWRK(IP+ 9)
      IF(
     - JCELL.EQ.ICELL
     -)THEN
          IPBACK = IWRK(IP+ 1)
15000 CONTINUE
      IF(
     - IPHT.LT.HPHT9
     -)THEN
      IF(
     - IWRK(IPHT+1).EQ.IPBACK
     -)THEN
              IF(IWRK(IPHT+9).EQ.ITRK .OR. IWRK(IPHT+10).EQ.ITRK)
     ?          LBGOOD = 0
      GOTO 15001
      ENDIF
      IF(
     - IWRK(IPHT+1).GT.IPBACK
     -)THEN
      GOTO 15001
      ENDIF
          IPHT = IPHT + HLDHT
      GOTO 15000
      ENDIF
15001 CONTINUE
      ENDIF
      ENDIF
      GOTO IZZZ01
      END

C   30/04/81 311061022  MEMBER NAME  CNTFIT   (S)           FORTRAN
      SUBROUTINE CNTFIT(IENTRY,I,TM,TP,T)
C
      COMMON/EVRUN/NRUN,IEV,ITYP,NEV,IMISS
      COMMON/MNVAL/STDC(130),STDC2(130),SNTDC(130)
C
      DATA IBUG/ 0/
      DATA TAUR/3.07/,TCUT/50./
C
      GOTO  (10,20,30), IENTRY
   20 CONTINUE
      IBUG = IBUG + 1
      IF(IBUG.LE.10) PRINT 305,I,TM,TP,T
  305 FORMAT(' CNTFIT ',I5,3F12.0)
      IF(ABS(TM).GT.TCUT)  GOTO  61
      STDC(2*I-1) = STDC(2*I-1) + TM
      STDC2(2*I-1) = STDC2(2*I-1) + TM*TM
      SNTDC(2*I-1) = SNTDC(2*I-1) + 1.
   61 IF(ABS(TP).GT.TCUT)  GOTO  62
      STDC(2*I) = STDC(2*I) + TP
      STDC2(2*I) = STDC2(2*I) + TP*TP
      SNTDC(2*I) = SNTDC(2*I) + 1.
      M = 84+I
   62 IF(ABS(T).GT.TCUT)  GOTO  63
      STDC(M) = STDC(M) + T
      STDC2(M) = STDC2(M) + T*T
      SNTDC(M) = SNTDC(M) + 1.
   63 IF(ABS(TM).GT.TCUT)  GOTO  64
      STDC(127) = STDC(127) + TM
      STDC2(127) = STDC2(127) + TM*TM
      SNTDC(127) = SNTDC(127) + 1.
   64 IF(ABS(TP).GT.TCUT)  GOTO  65
      STDC(128) = STDC(128) + TP
      STDC2(128) = STDC2(128) + TP*TP
      SNTDC(128) = SNTDC(128) + 1.
      M = 129
   65 IF(ABS(T).GT.TCUT)  RETURN
      STDC(M) = STDC(M) + T
      STDC2(M) = STDC2(M) + T*T
      SNTDC(M) = SNTDC(M) + 1.
      RETURN
C
   30 CONTINUE
      CALL HBOOK2(60,15HDTM TP        $,100,0.,100.,40,-1.,1.)
      CALL HBOOK2(70,15HDT            $, 50,0.,100.,40,-1.,1.)
      CALL HBOOK2(61,15HDTM TP RMS    $,100,0.,100.,40,0.,2.)
      CALL HBOOK2(71,15HDT     RMS    $, 50,0.,100.,40,0.,2.)
C
      DO   1   I=1,130
      IF(SNTDC(I).LT.1.) GOTO  4
      STDC(I) = STDC(I)/SNTDC(I)
      STDC2(I) = SQRT(ABS(STDC(I)*STDC(I)-STDC2(I)/SNTDC(I)))
      M = I
      ID = 0
      IF(I.GT.42) M = I+7
      IF(I.GT.84) M = I-84
      IF(I.GT.84) ID = 10
      CALL HFILL(60+ID,FLOAT(M),STDC(I),1.)
      CALL HFILL(61+ID,FLOAT(M),STDC2(I),1.)
      GOTO  1
    4 STDC(I) = 0.
      STDC2(I) = 0.
    1 CONTINUE
      PRINT 102
      PRINT 120
  120 FORMAT('  STDC  '/)
  101 FORMAT(1X,12F10.2)
  102 FORMAT(//)
      PRINT 102
      PRINT 101,SNTDC
      PRINT 102
      PRINT 101,STDC
      PRINT 102
      PRINT 101,STDC2
      PRINT 102
      PRINT 122
  122 FORMAT(' NOW WRITING ON 18')
      WRITE(18) STDC,STDC2
      RETURN
   10 CONTINUE
      CALL SETSL(STDC,0,130*12,0)
      RETURN
      END

      SUBROUTINE RSTBTR(IPJHTL)
      IMPLICIT INTEGER*2 (H)
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C----------------------------------------------------------------------
C           MACRO CCYCP .... JET CHAMBER HIT POINTERS (PATREC)
C----------------------------------------------------------------------
      INTEGER*4 HPTSEC
      COMMON/CCYCP/HPTSEC(98)
C     HPTSEC(I) = CDATA POINTER TO 1ST I*2 WORD FOR 1ST HIT OF CELL I
C------------------------ END OF MACRO CCYCP --------------------------
C-----------------------------------------------------------------------
C                            MACRO CJDRCH .... JET CHAMBER CONSTANTS.
C-----------------------------------------------------------------------
C
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     +                  RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,
     +                  ZRESOL,ZNORM,ZAL,ZSCAL,DRIDEV,DRICOS,DRISIN,
     +                  PEDES,TZERO(3),DRIROT(96,2),SINDRI(96,2),
     +                  COSDRI(96,2),DRIVEL(96,2),T0FIX(3),
     +                  ABERR(8), DUMJDC(20)
C
C      BLOCK DATA SET TO MC VALUES, KALIBR WILL SET REAL DATA VALUES
C--->  A CHANGE OF THIS COMMON MUST BE DONE SIMULTANEOUSLY WITH  <----
C--->  A CHANGE OF THE BLOCK DATA                                <----
C
C--------------------------- END OF MACRO CJDRCH -----------------------
C
C----------------------------------------------
C  MACRO CWORKPR .... PATTERN RECOGNITION CWORK
C----------------------------------------------
      COMMON /CWORK/ HPLAST,HPFREE,HPWRK(30),ADWRK(600),
     ,               HPRO,HNTR,HNTCEL(98),IPCL(200),NRHT(200),
     ,               NWR1(200),DS1(200),SL1(200),
     ,               NWR2(200),DS2(200),SL2(200),
     ,               LBL(200),NTREL(200),ICRO(200),
     ,               NTR,HNREL(100),HISTR(9,100),HRES(168),
     ,               NTRLM,RLMTR(3,5),
     ,               WRK(7000)
                     DIMENSION TRKAR(200,11),ITRKAR(200,11),
     ,                         LMRTR(3,5)
                     EQUIVALENCE (IPCL(1),TRKAR(1,1),ITRKAR(1,1))
                     EQUIVALENCE (LMRTR(1,1),RLMTR(1,1))
         DIMENSION IWRK(7000),HWRK(14000),IDWRK(600),HDWRK(1200)
                     EQUIVALENCE (IWRK(1),WRK(1),HWRK(1))
                     EQUIVALENCE (IDWRK(1),ADWRK(1),HDWRK(1))
C---------- END OF MACRO CWORKPR --------------
C-------------------------------------------------------
C  MACRO CWORKEQ .... PATTERN RECOGNITION CWORK POINTERS
C-------------------------------------------------------
      EQUIVALENCE
C                POINTERS FOR FXYZ HIT ARRAY .. PRIMARY L/R SOLUTION
     +          (HPHT0,HPWRK( 1)),(HPHT9,HPWRK( 2)),(HLDHT,HPWRK( 3))
C                POINTERS FOR CWORK SINGLE TRACK PATR BANK
     +         ,(HPTR0,HPWRK( 4)),(HPTR9,HPWRK( 5)),(HLDTR,HPWRK( 6))
C                POINTERS FOR TRACK ELEMENT HIT LABEL ARRAY
     +         ,(HPHL0,HPWRK( 7)),(HPHL9,HPWRK( 8)),(HLDHL,HPWRK( 9))
C                POINTERS FOR FXYZ HIT ARRAY .. OPPOSITE L/R SOLUTION
     +         ,(HPHT0A,HPWRK(10)),(HPHT9A,HPWRK(11)),(HLDHTA,HPWRK(12))
C               POINTER LIMIT ON FXYZ HIT ARRAY
     +         ,(HPHTLM,HPWRK(13))
C               POINTERS FOR
     +         ,(HPTE0,HPWRK(14)),(HPTE9,HPWRK(15)),(HLDTE,HPWRK(16))
C-------------- END OF MACRO CWORKEQ ------------------
      DATA MKHTL1 /Z8400/, MKATR /Z100/, MKHTL2 /Z7FFF/
      DATA  MKLRSV / Z800/
      DATA  MKBDHT / Z600/
      DATA MKLFTR,MKRTTR / Z400, Z800/
      DATA LBZRCR / Z100/
      NBYTE = IDATA(IPJHTL)*4 - 4
      CALL MVCL2(HWRK(HPHL0),0,IDATA(IPJHTL+2),0,NBYTE)!PMF 28/06/99 MVCL -> MVCL2
      HLDHL = IDATA(IPJHTL)*2 - 2
      HPHL9 = HLDHL + HPHL0 - 1
      HPFREE = (HPHL9+1)/2 + 1
      HPHT0  = HPFREE
      DO 13000 I=HPHL0,HPHL9,2
        IZW = HWRK(I  )
      IF(
     - LAND(IZW,MKBDHT).NE.0
     -)THEN
          HWRK(I) = HWRK(I+1)
          IZW     = HWRK(I+1)
          HWRK(I+1) = 0
          IF(LAND(IZW,MKBDHT).NE.0) HWRK(I  ) = 0
      ELSE
          IZW = HWRK(I+1)
          IF(LAND(IZW,MKBDHT).NE.0) HWRK(I+1) = 0
      ENDIF
13000 CONTINUE
13001 CONTINUE
      NBYTE = 200
      CALL SETSL(HNREL(1),0,NBYTE,0)
      NTR   = 0
      HNTR  = 0
      ICELL = 1
      ITREL = 0
      ITRBK = 0
16000 CONTINUE
        IPHIT0 = HPTSEC(ICELL  )
        IPHIT9 = HPTSEC(ICELL+1) - 4
        IF(ICELL.EQ.25) ITREL = 0
        IF(ICELL.EQ.49) ITREL = 0
        IRING = 1
        IF(ICELL.GE.25) IRING = 2
        IF(ICELL.GE.49) IRING = 3
        DSBIN1 = TIMDEL(1,IRING)
        DSBIN2 = TIMDEL(2,IRING)
      IF(
     - IPHIT9.GE.IPHIT0
     -)THEN
          IPHTL0 = (IPHIT0-HPTSEC(1))/2 + HPHL0
16002 CONTINUE
            IPHIT = IPHIT0
            IPHTL = IPHTL0
            ITR   = 0
            DSBIN = DSBIN1
            NHT   = 0
            IPHTW = HPHT0
            ZCRLB1 = 0.
            ZCRLB2 = 0.
15000 CONTINUE
      IF(
     - IPHIT.LE.IPHIT9
     -)THEN
              LHTL1 = HWRK(IPHTL  )
              LHTL2 = HWRK(IPHTL+1)
              NTR1  = 0
              NTR2  = 0
             IF(LAND(LHTL1,MKHTL1).EQ.0) NTR1=LAND(ISHFTR(LHTL1,1),127)
             IF(LAND(LHTL2,MKHTL1).EQ.0) NTR2=LAND(ISHFTR(LHTL2,1),127)
      IF(
     - ITR.EQ.0
     -)THEN
      IF(
     - NTR1.NE.0
     -)THEN
                  ITR = NTR1
      ELSE
                  IF(NTR2.NE.0) ITR = NTR2
      ENDIF
                IF(ITR.NE.0) ITREL = ITREL + 1
      ENDIF
      IF(
     - ITR.NE.0 .AND. (NTR1.EQ.ITR .OR. NTR2.EQ.ITR)
     -)THEN
      IF(
     - ITR.EQ.NTR1
     -)THEN
                  LBHIT = LAND(MKATR,LHTL1)
                  SGNLR =-1.
                  IF(LBHIT.NE.0) SGNLR = 1.
                  LBHIT = LOR (ITREL*2,LBHIT)
                  LBHIT = LOR (MKHTL1 ,LBHIT)
                  LBHIT = LOR (MKLRSV ,LBHIT)
                  HWRK(IPHTL  ) = LBHIT
      ENDIF
      IF(
     - ITR.EQ.NTR2
     -)THEN
                  LBHIT = LAND(MKATR,LHTL2)
                  SGNLR =-1.
                  IF(LBHIT.NE.0) SGNLR = 1.
                  LBHIT = LOR (ITREL*2,LBHIT)
                  LBHIT = LOR (MKHTL1 ,LBHIT)
                  LBHIT = LOR (MKLRSV ,LBHIT)
                  HWRK(IPHTL+1) = LBHIT
      ENDIF
                IWIR = HDATA(IPHIT  )
                ILAY = LAND(ISHFTR(IWIR,3),15)
                IF(ILAY.GE.8) DSBIN = DSBIN2
                ITAU = HDATA(IPHIT+3)
                DRSP          = ITAU*DSBIN*SGNLR
                IF(ZCRLB1.EQ.0. .AND. DRSP.NE.0.) ZCRLB1 = SIGN(1.,DRSP)
                IF(ZCRLB1*DRSP.LT.0.) ZCRLB2 =-ZCRLB1
      IF(
     - ZCRLB2*DRSP.LT.0.
     -)THEN
                  HWRK(IPHTL  ) = LHTL1
                  HWRK(IPHTL+1) = LHTL2
      GOTO 15001
      ENDIF
                NHT = NHT + 1
                IWRK(IPHTW  ) = ILAY
                WRK (IPHTW+1) = DRSP
                IPHTW = IPHTW + 2
      ENDIF
            IPHTL = IPHTL + 2
            IPHIT = IPHIT + 4
      GOTO 15000
      ENDIF
15001 CONTINUE
      IF(
     - ITR.GT.0
     -)THEN
      ASSIGN 17001 TO IZZZ01
      GOTO 17000
17001 CONTINUE
      ENDIF
      IF(.NOT.(
     - ITR.EQ.0
     -))GOTO 16002
16003 CONTINUE
      ENDIF
      ICELL = ICELL + 1
      IF(.NOT.(
     - ICELL.GT.96
     -))GOTO 16000
16001 CONTINUE
      HNTR = ITRBK
      ICELL0 = 0
      DO 13002 ITRBK=1,HNTR
        ICELL = IPCL(ITRBK)
      IF(
     - ICELL.NE.ICELL0
     -)THEN
          ICELL0 = ICELL0 + 1
      DO 13004 IC=ICELL0,ICELL
            HNTCEL(IC) = ITRBK
13004 CONTINUE
13005 CONTINUE
          ICELL0 = ICELL
      ENDIF
13002 CONTINUE
13003 CONTINUE
      ICELL0 = ICELL0 + 1
      ITRBK = HNTR + 1
      DO 13006 IC=ICELL0,97
        HNTCEL(IC) = ITRBK
13006 CONTINUE
13007 CONTINUE
      HNTCEL(98) = 0
      CALL TRLORD
      DO 13008 I=HPHL0,HPHL9
        IZW = HWRK(I)
        IZW = LAND(IZW,MKHTL2)
        HWRK(I) = IZW
13008 CONTINUE
13009 CONTINUE
      RETURN
17000 CONTINUE
        HPHT9 = IPHTW - 1
        ITRBK = ITRBK + 1
        DS10  =  WRK(HPHT0+1)
        DS20  =  WRK(HPHT9  )
      IF(
     - NHT.LT.4
     -)THEN
      IF(
     - NHT.EQ.1
     -)THEN
            SL10 = 0.
            SL20 = 0.
      ELSE
            IDWIR =  IWRK(HPHT9-1)-IWRK(HPHT0)
            SL10  =  0.
            IF(IDWIR.NE.0) SL10  =  (DS20-DS10)/IDWIR
            SL20  =  SL10
      ENDIF
      ELSE
          SL10  =  (WRK(HPHT0+7)-DS10)/(IWRK(HPHT0+6)-IWRK(HPHT0  ))
          SL20  =  (WRK(HPHT9-6)-DS20)/(IWRK(HPHT9-7)-IWRK(HPHT9-1))
          WR10  =  (IWRK(HPHT0+6)+IWRK(HPHT0  ))*.5
          WR20  =  (IWRK(HPHT9-7)+IWRK(HPHT9-1))*.5
          DSL   =  0.
          DWR   =  WR20 - WR10
          IF(DWR.GT.0) DSL   =  (SL20-SL10) / DWR
      IF(
     - DSL.NE.0.
     -)THEN
            SL10 = SL10 + (IWRK(HPHT0  )-WR10)*DSL
            SL20 = SL20 + (IWRK(HPHT9-1)-WR20)*DSL
      ENDIF
      ENDIF
        LBTREL       = MKRTTR
        IF(DS10.LT.0.) LBTREL = MKLFTR
        IF(DS10.EQ.0 .AND. DS20.LT.0) LBTREL = MKLFTR
        ITRBKS = ITRBK
        ITRS   = ITR
      IF(
     - LBTREL.EQ.MKLFTR
     -)THEN
          ITRBKS =-ITRBK
          ITRS   =-ITR
          DS10   =-DS10
          SL10   =-SL10
          DS20   =-DS20
          SL20   =-SL20
      ENDIF
        IZRCR = 0
      IF(
     - DS10*DS20 .LT.0.
     -)THEN
          DS20 =-DS20
          SL20 =-SL20
          LBTREL = LOR(LBTREL,LBZRCR)
          DS0 = WRK(HPHT0+1)
      DO 13010 IP=HPHT0,HPHT9,2
      IF(
     - DS0*WRK(IP+1).LT.0
     -)THEN
      GOTO 13011
      ENDIF
            IZRCR = IWRK(IP)
13010 CONTINUE
13011 CONTINUE
          IZRCR = IZRCR + 1
      ENDIF
        IPCL (ITRBK) =  ICELL
        NRHT (ITRBK) =  NHT
        NWR1 (ITRBK) =  IWRK(HPHT0  )
        DS1  (ITRBK) =  DS10
        SL1  (ITRBK) =  SL10
        NWR2 (ITRBK) =  IWRK(HPHT9-1)
        DS2  (ITRBK) =  DS20
        SL2  (ITRBK) =  SL20
        LBL  (ITRBK) =  LBTREL
        NTREL(ITRBK) =  ITREL
        ICRO (ITRBK) =  IZRCR
        MTREL = HNREL(ITR)
        IF(MTREL.LT.9) MTREL = MTREL + 1
        HISTR(MTREL,ITR) = ITRBKS
        HNREL(ITR) = MTREL
        HRES(ITRBK) = ITRS
        NTR = MAX0(NTR,ITR)
      GOTO IZZZ01
      END

C   01/11/84 807241300  MEMBER NAME  DRAWBP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWBP( IVIEW , VTXCHR )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY    26/04/84 :  DRAW BEAM PIPE    (FROM JADISP)
C
C       MOD:   C. BOWDERY    27/06/84 :  VTXCHR IS AN ARGUMENT NOW
C       MOD:   J. HAGEMANN   09/10/84 :  HATCH BEAM PIPE ON SCREEN
C LAST  MOD:   J. HAGEMANN   14/02/86 :  DRAW CHAMBER IN TRUE POSITION
C                                        RELATIVE TO THE ORIGIN
C
C
C     THE BEAM PIPE DRAWN DEPENDS ON THE EVENT DATE. VTXCHR IS .TRUE.
C     IF THE NEW, SMALLER PIPE IS TO BE DRAWN.
C       IVIEW = 1  :  R PHI VIEW
C       IVIEW = 2  :  RZ VIEWS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  VTXCHR, DSPDTM
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEOV      VERTEX CHAMBER GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEOV  / RPIPV,DRPIPV,XRLPIV,RVXC,DRVXC,XRLVXC,
     +                  ZVXCM,DZVCM,XRZVCM, ZVXCP,DZVCP,XRZVCP,
     +                  XRVTXC
C
C--------------------------- END OF MACRO CGEOV ------------------------
C
C   23/03/97 703231941  MEMBER NAME  MVCCAL   (PATRECSR)    SHELTRAN
C**HEADER*** MEMBER  MVCCAL         SAVED BY F22KLE  ON 87/02/09  AT 17:52
C   27/06/85 702091751  MEMBER NAME  MVCCAL   (S)           FORTRAN
C
C         THIS MACRO CONTAINS THE DECLARATION FOR THE
C         VTXC-CALIBRATION-COMMON / CVCCAL / :
C
C------------------------------------------------- 03.03.86 J.H. -------
C
      REAL*8 VCDATE
      COMMON / CVCCAL / NVFREE, VFREE(50), VCDATE,
     &      T0, VD, CSLOR, SNLOR, VROT, VDX, VZX, VDY, VZY,
     &      S0R(2,168), CVD(2,168),
     &      VIHCRR(7,2,25)
C
C     NVFREE  : NUMBER OF FREE REAL WORDS IN VFREE
C     VFREE   : REAL ARRAY FOR CONSTANTS
C     T0      : GLOBAL T0                              (. 0.1 NS .)
C     VD      : GLOBAL DRIFTVELOCITY                   (. MM/(0.1 NS) .)
C     CSLOR   : COS( LORENTZ-ANGLE )
C     SNLOR   : SIN( LORENTZ-ANGLE )
C     VROT    : ROTATION VTXC - ID                     (. RADIAN .)
C     VDX     : DISPLACEMENT VTXC - ID IN X            (. MM .)
C     VZX     : SLOPE OF " IN Z
C     VDY     : DISPLACEMENT VTXC - ID IN Y            (. MM .)
C     VZY     : SLOPE OF " IN Z
C     S0R     : DISPLACEMENT FOR EACH WIRE (#)         (. MM .)
C     CVD     : DRIFTVEL.-CORRECTURE FOR EACH WIRE (#)
C
C     VIHCRR  : LAYER-DEPENDENT CORRECTIONS FOR INHOMOGENITIES
C                                                      (. MM . )
C
C     VFREE(50) : D(VROT)/D(Z)                         (. RADIAN/MM .)
C
C     VFREE(48,49) JOBNAME OF JOB GENERATING THIS CALIBRATION
C
C     (#)     : FOR EACH DRIFTSPACESIDE
C
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CHATCH / IHAT
C
C-----------------  C O D E  -------------------------------------------
C
C                            DETERMINE INNER AND OUTER RADII
C
C                                RPIP(V)  = INNER RADIUS
C                                DRPIP(V) = THICKNESS OF PIPE
C
      XDEV = 0.0
      YDEV = 0.0
      IHAT = 0
      RADIN  = RPIP
      RADOUT = RPIP + DRPIP
      IF( .NOT. VTXCHR ) GO TO 111
C                            LOAD CONSTANTS FOR RELATIVE POSITION
         RADIN  = RPIPV
         RADOUT = RPIPV + DRPIPV
         IF( HEAD(18) .LE. 100 ) GO TO 111
         XDEV = VDX
         YDEV = VDY
         IHAT = 1
C
  111 GO TO ( 1 , 2 ) , IVIEW
C
C                            R PHI VIEW
C
C                            CALCULATE NUMBER OF LINES TO DRAW A CIRCLE
C
   1  DDD   = 10.24 * 25.4 / ( XMAX - XMIN )
      NN     = 25.0 * 15.0 * DDD
      IF( NN .LT. 40 ) NN = 40
C
C                            DRAW INNER AND OUTER SURFACES OF BEAM PIPE
C
      CALL PLYGON( NN, RADIN , -XDEV, YDEV, 0 )
      CALL PLYGON( NN, RADOUT, -XDEV, YDEV, 0 )
C
C                            HATCH BEAM PIPE IF CDTL 45 ON
C
      IF( DSPDTM(15) )
     +       CALL DRHATC( IVIEW, 144, RADIN, RADOUT, 0., 0. )
      IHAT = 0
      RETURN
C
C                            RZ VIEWS
C
   2  CALL DRAMOV(ZENDMI, RADIN, ZENDPL, RADIN, 0)
      CALL DRAMOV(ZENDMI,-RADIN, ZENDPL,-RADIN, 0)
      CALL DRAMOV(ZENDMI, RADOUT,ZENDPL, RADOUT,0)
      CALL DRAMOV(ZENDMI,-RADOUT,ZENDPL,-RADOUT,0)
C
C                            HATCH BEAM PIPE IF CDTL 45 ON
C
      IF( .NOT. DSPDTM(15) ) RETURN
      CALL DRHATC(IVIEW, 250, RADIN, RADOUT, ZENDMI, ZENDPL)
      CALL DRHATC(IVIEW, 250,-RADIN,-RADOUT, ZENDMI, ZENDPL)
      RETURN
      END

C   12/07/79 C9090201   MEMBER NAME  USERTM   (SOURCE)      FORTRAN
C
      SUBROUTINE USERTM
C
C
C    Y. TOTSUKA  12. 7. 1979
C
C---- CHECK TIME OUT
C
      WRITE(6, 6000)
 6000 FORMAT(' ', 10('='), ' PRINT FROM USERTM', 10('='))
C////////DUMP LAST EVENT//////////
      DATA IUN/2/
        CALL BMLT(0, DUMMY)
        CALL BFIXP
C       CALL BWRITE(IUN)
      CALL BPRS('PATR', 10)
      CALL HPRS('HEAD', 0)
      WRITE(6, 6000)
      RETURN
      END

C   07/06/96 606071904  MEMBER NAME  PTEXT    (S4)          FORTRAN
      SUBROUTINE PTEXT(N,KK)
      COMMON/BCS/IW(1)
      LOGICAL*1 AR(1),LTEXT(60),DOLL/'$'/
      INTEGER TEXT(15),BLANK/'    '/
      EQUIVALENCE (TEXT(1),LTEXT(1))
      IF(N.LT.0) GOTO 10
      M=KK+10*N
      CALL BLOC(IND,'TEX*',M,&10)
      NF=IW(IND)
      IF(NF.LE.0) GOTO 10
      WRITE(6,101) (IW(IND+I),I=1,NF)
      GOTO 100
   10 WRITE(6,101)
      GOTO 100
C
      ENTRY TCOND(N,AR)
      K=1
      GOTO 50
      ENTRY TTABL(N,AR)
      K=2
      GOTO 50
      ENTRY THIST(N,AR)
      K=3
      GOTO 50
      ENTRY TCORR(N,AR)
      K=4
      GOTO 50
      ENTRY TSTOR(N,AR)
      ENTRY TSTOS(N,AR)
      K=5
      GOTO 50
      ENTRY TMEAN(N,AR)
      K=6
      GOTO 50
      ENTRY TPEAK(N,AR)
      K=7
   50 M=N
      IF(M.LT.0) GOTO 100
      M=K+10*M
      DO 60 I=1,61
      IF(AR(I).EQ.DOLL) GOTO 62
   60 CONTINUE
      I=61
   62 II=I-1
      IL=(II+3)/4
      DO 70 L=1,IL
   70 TEXT(L)=BLANK
      DO 80 I=1,II
   80 LTEXT(I)=AR(I)
      CALL BCRE(IND,'TEX*',M,IL,&100,IER)
      IF(IER.NE.0) GOTO 100
      CALL BSTR(IND,TEXT,IL)
  100 RETURN
  101 FORMAT('0',5('----'),1X,15A4)
      END

C   29/06/79 807251746  MEMBER NAME  GVTXFT   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE GVTXFT 
C-----------------------------------------------------------------------
C
C    AUTHOR:   J. OLSSON   28/05/82 :  VERTEX FIT FOR TRACKS
C
C       MOD:   J. OLSSON   27/02/84 :
C       MOD:   C. BOWDERY   8/06/84 :  NEW COMMAND NUMBERS
C       MOD:   J. HAGEMANN 26/06/86 :  ALLOW AXIS CONSTAINT AND DRAW
C                                      VERTEX WITH ITS ERRORS IN
C                                      VRX-VIEW
C       MOD:   J. HAGEMANN 26/07/86 :  BIT INFORMATION UPDATED
C       MOD:   J. HAGEMANN 09/01/87 :  FOR DAVIDON-ALGORITHM AND ERROR
C                                      ELLIPSE
C       MOD:   J. HAGEMANN 25/03/87 :  BIT 24 INTRODUCED FOR MODE-FLAG
C       MOD:   J. HAGEMANN 21/10/87 :  FOR CONVERSION SEARCH
C       MOD:   J. HAGEMANN 30/11/87 :  FOR PROBABILITY CALCULATION
C  LAST MOD:   J. HAGEMANN 21/01/88 :  FOR HWDS-BANK
C
C        PERFORMS THE DITTMANN FIT FOR GIVEN INPUT TRACKS
C        INPUT GIVEN FROM SCREEN : TRACK NUMBER.
C        ADAPTED FROM SUBROUTINE EFMASS
C        COMMAND GVTX WITH TRAILING NUMBER 1    : WITH AXIS CONTRAINT
C        COMMAND GVTX WITH TRAILING NUMBER 1024 : PHOTON CONVERSION FIT
C
C        T(1500) --> T(2000) KLE
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL TBIT
      LOGICAL LVTXC, LNHARD, NEWDET
      LOGICAL FLVCDO
C
#include "cdata.for"
#include "cgraph.for"
#include "cgeo1.for"
#include "cadmin.for"
C
      COMMON / CJTRIG / PI,TWOPI
      COMMON / CVCEX  / LVTXC
      COMMON / CGVCDO / FLVCDO(20)
      COMMON / CHEADR / HEAD(108)
      COMMON / CVX    / NNPATR
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "mvertex0.for"
#include "mvertex1.for"
#include "mvertex2.for"
C
      DIMENSION HTEXT(5,7),RLIMS(2,6),HNNN(50),ITR(4)
C
      DIMENSION HMW(5) ! PMF 26/10/99 DIMENSION statement added
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      DATA ZDEEP /5800./,DER/20./
      DATA HTEXT /'  ','  ','  ','  ','  ','BE','AM','-P','IP','E ',
     +            'BP','-C','OU','NT','ER','ID','-T','AN','K ','  ',
     +            'RO','HA','CE','LL',' 1','RO','HA','CE','LL',' 2',
     +            'RO','HA','CE','LL',' 3'/
      DATA RLIMS /115.,127.,127.,167.,167.,174.,174.,195.,370.,410.,
     +            580.,625./
C
C-----------------------------------------------------------------------
C
      NACMD = ACMD
      IF( NACMD .NE. -1 ) GO TO 100
         CONTINUE !CALL CLRCON 03/12/99
         WRITE(6,9001)
 9001    FORMAT(' VERTEX FIT MODES:',/,
     &  ' BIT31(=  1) : START AT RUN VERTEX',/,
     &  ' BIT30(=  2) : RUN VERTEX CONSTRAINT',/,
     &  ' BIT29(=  4) : AXIS CONSTRAINT',/,
     &  ' BIT28(=  8) : FITS IN R-PHI AND Z INDEPENDENT',/,
     &  ' BIT27(= 16) : LOCAL STATISTICS FOR EACH TRACK',/,
     &  ' BIT26(= 32) : OVERWRITE PATR-BANK FOR TYPE-2-TRACKS WITH HELIX
     &-PARAMETERS',/,
     &  ' BIT25(= 64) : MESSAGE FROM VTXEE IF CONVERSION SEARCH FAILED',
     &/,' BIT24(=128) : SWITCH ON PENALTY FUNCTION FOR DAVIDON-ALGORITHM
     &')
 101     CALL TRMOUT(80,'ENTER MODE: ( > -1)^')
         CALL FYRINT(NACMD,ID2,ID3,ID4)
         IF( NACMD .LT. 0 ) GO TO 101
  100 CONTINUE
C
      LNHARD = (HEAD(15) .GE. 5  .AND.  HEAD(16) .EQ. 1984)
     &         .OR.   HEAD(16) .GE. 1985
      NEWDET = LVTXC .OR. (IEVTP.EQ.0 .AND. LNHARD)
      IF( .NOT. NEWDET ) GO TO 600
         RLIMS(1,1) = 99.0
         RLIMS(2,1) = 133.0
         RLIMS(1,2) = 50000.0
         RLIMS(2,2) = 60000.0
         RLIMS(1,3) = 133.0
         RLIMS(2,3) = 174.0
 600  CONTINUE
      IH = IDATA(IBLN('HEAD'))
      IF( NNPATR .LE. 0 ) GO TO 2701
      CALL CLOC(IPO,'PATR',NNPATR)
      IF( IPO .GT. 0 ) GO TO 2702
      WRITE(6,2703) NNPATR
2703  FORMAT(' PATR BANK NR',I3,' (GIVEN BY COMMAND PATR) NOT EXISTING')
2701  IPO = IDATA(IBLN('PATR'))
2702  IH  = IDATA(IBLN('HEAD'))
      IF( IPO .NE. 0 ) GO TO 2224
         CALL TRMOUT(80,'PATR BANK DOES NOT EXIST^')
         RETURN
2224  CONTINUE
      IPHWDS = IDATA(IBLN('HWDS'))
      IF(.NOT.FLVCDO(15) .OR. IPHWDS.LE.0) GOTO 2704
         IPO = IPHWDS
2704  LO  = IDATA(IPO+1)
      NTR = IDATA(IPO+2)
      LTR = IDATA(IPO+3)
      NN  = 0
      JJ  = 0
1000  CALL TRMOUT(80,' ENTER TRACK NUMBERS, UP TO 4 AT A TIME;  A BLANK
     $OR 0 WILL FINISH INPUT^')
      CALL FYRINT(ITR(1),ITR(2),ITR(3),ITR(4))
      DO 1  I = 1,4
      IF(ITR(I).EQ.0) GO TO 2
      IF(ITR(I).LE.NTR.AND.ITR(I).GT.0) GO TO 1002
      CALL TRMOUT(80,' ILLEGAL TRACKNUMBER ENCOUNTERED, IS IGNORED.')
      GO TO 1
1002  NN = NN + 1
      HNNN(NN) = ITR(I)
      IF(NN.LT.50) GO TO 1
      CALL TRMOUT(80,'MAXIMUM NR OF TRACKS (50) REACHED, GO TO FIT.^')
      GO TO 2
1     CONTINUE
      GO TO 1000
2     CONTINUE
      IF(NN.GT.1) GO TO 3
      CALL TRMOUT(80,'LESS THAN TWO TRACKS ENTERED...^')
      RETURN
C*************************
C   PERFORM VERTEX FIT   *
C*************************
C     CALL ERASE
3     CALL VTXINI
      IF( NACMD .GT. 0 .AND. NACMD .LT. 1024 ) MODE = NACMD
      CALL VTXPRE(IH,IPO)
      N = 0
      J = 0
      DO 320 M = 1, NT
         IF( IT(J+1) .EQ. 0 ) GOTO 320
            IT(J+1) = 1
            IF( NACMD .GE. 1024 ) IT(J+1) = 0
            DO 315 MM = 1, NN
               IF( M .EQ. HNNN(MM) ) GOTO 317
 315        CONTINUE
            GOTO 320
 317           N = N+1
               IT(J+1) = 2
 320  J  = J + ITDLEN
      NV = 1
      IF( N .NE. NN ) WRITE(JUSCRN,5000) N
5000  FORMAT(' ONLY',I4,' TRACKS ACCEPTED')
      IF( NACMD .GE. 1024 .AND. N .NE. 2 )
     &CALL TRMOUT(80,'CONVERSION FIT IGNORED, NOT TWO TRACKS.^')
      IF( N .NE. 2) GOTO 350
      IF( NACMD .LT. 1024 ) GO TO 350
         NV=0
         MODE = NACMD - 1024
         CALL VTXEE
         GOTO 360
 350  IF( .NOT.FLVCDO(16) ) CALL VERTEX
      IF( FLVCDO(16) ) CALL VTXDAV(IRET)
      IF( FLVCDO(16) .AND. IRET .LT. 0 ) GO TO 111
 360  CALL VTXAFT
C*****************************
C  GET RESULT OF VERTEX FIT  *
C*****************************
      IF( NV .GT. 0 ) GO TO 112
 111     CALL TRMOUT(80,' GVTXFT: NO VERTEX FOUND !^')
         RETURN
 112  R   = V(2)**2 + V(3)**2
      RL  = SQRT(R + V(4)**2)
      R   = SQRT(R)
      XVT = V(2)
      YVT = V(3)
      ZVT = V(4)
C
C DISPLAY VERTEX POSITION WITH CROSS
C
      VX = -XVT
      VY =  YVT
      IF( (LASTVW.GT.3 .AND. LASTVW.LT.8) .OR. LASTVW.EQ.18) VY = XVT
      IF( LASTVW .GT.3  .AND. LASTVW .LT. 14 ) VX = ZVT
      IF( LASTVW .EQ.18 .OR.  LASTVW .EQ. 19 ) VX = ZVT
      IF( LASTVW.LT.4 .OR.  LASTVW.EQ.17 .OR. LASTVW.EQ.20) GO TO 114
         RV  = SQRT(XVT*XVT + YVT*YVT)
         FIV = 0.
         IF( RV .GT. 0.001 ) FIV = ATAN2(YVT,XVT)
         IF( RV .GT. 0.001 .AND. FIV .LT. 0.0 ) FIV = FIV + TWOPI
         IF( .NOT.DSPDTL(9) .OR. DSPDTL(10) ) GO TO 113
         IF( LASTVW .EQ. 14 ) GO TO 113
            IF( RV .GT. 0.001 ) RV = RV*WRAP(FIV)
            VY = RV
113      IF( LASTVW .NE. 14 ) GO TO 114
CYLINDER VIEW, Z CORRECTION FOR PERSPECTIVE FACTOR
            ZETMX = ZLGPL + ZDEEP
            RV    =  RV*(ZDEEP - ZVT)/ZETMX
            VX    = -RV*COS(FIV)
            VY    =  RV*SIN(FIV)
114   CONTINUE
C  ADJUST THE DEVIATION DER
      DERV = DER
      IF( LASTVW.EQ.18 .OR. LASTVW.EQ.19 ) DERV = .01*DER
      IF( LASTVW .NE. 17 ) GO TO 115
         IF( FLVCDO(17) ) GO TO 214
            DRVX = V(5)
            DRVY = V(6)
            CALL MOVEA( -XVT-DRVX,     YVT )
            CALL DRAWA( -XVT+DRVX,     YVT )
            CALL MOVEA(      -XVT, YVT-DRVY )
            CALL DRAWA(      -XVT, YVT+DRVY )
            GO TO 116
 214     AV   = V(5)**2
         BV   = V(6)**2
         ROOT = SQRT(0.25*(AV-BV)**2 + V(11)**2)
         EIG1 = 0.5*(AV+BV) + ROOT
         EIG2 = 0.5*(AV+BV) - ROOT
         PHIW = ATAN2(EIG1-AV,V(11))
         CALL ELLIPS( 0, LASTVW, 1, XVT, YVT, EIG1, EIG2, -PHIW )
         GO TO 116
 115  CONTINUE
      CALL MOVEA(VX-DERV,VY-DERV)
      CALL DRAWA(VX+DERV,VY+DERV)
      CALL MOVEA(VX+DERV,VY-DERV)
      CALL DRAWA(VX-DERV,VY+DERV)
 116  CONTINUE
      IDIM = 3
      IF( TBIT(MODE,28) ) IDIM = 2
      NDF = 2*IV(8) - IDIM
      IF( FLVCDO(16) ) NDF = IV(8)*(IDIM-1) - IDIM
      CORXY = V(11)/(V(5)*V(6))
      PRFIT = PROB(V(9),NDF)
      WRITE(6,1292) V(9),NDF,PRFIT,IV(1),IV(8),CORXY
1292  FORMAT(' CHISQ/NDF ',F9.3,'/',I2,' PROB',F6.3,
     $' QUALITY FLAG',I3,' NR OF USED TRACKS ',I2,' CORXY ',F7.3)
      WRITE(6,1294) XVT,V(5),YVT,V(6),ZVT,V(7)
1294  FORMAT(' --->  X Y Z   OF VERTEX: ',/,1X,2(F9.3,' +-',F6.3,3X),
     &3X,F6.1,' +-',F5.1)
      IRAD = 1
      DO 1296  KL = 1,6
      IF(R.GE.RLIMS(1,KL).AND.R.LT.RLIMS(2,KL)) IRAD = KL + 1
1296  CONTINUE
      DO 1297  KJ = 1,5
1297  HMW(KJ) = HTEXT(KJ,IRAD)
      WRITE(6,1298) R,(HMW(KL),KL=1,5),RL
1298  FORMAT(' RADIUS IN RFI :',E12.4,3X,5A2,'   TOTAL LENGTH: ',E12.4)
      RETURN
      END

C   05/11/82 705211100  MEMBER NAME  ERRMOM   (JADEGS)      FORTRAN
      SUBROUTINE ERRMOM(IP,P,FMASS,DP)
      IMPLICIT INTEGER*2 (H)
C
C        RETURNS THE (THEORETICALLY EXPECTED) MOMENTUM ERROR DP IN GEV
C        FOR A TRACK WITH A GIVEN MASS HYPOTHESIS.
C           THE SPACE RESOLUTION CONTRIBUTION IS GIVEN BY A GLUCKSTERN
C        TYPE FORMULA, CORRECT TO FIRST ORDER IN 1/N, WHERE N=NRFI, THE
C        NUMBER OF RFI POINTS USED IN THE FIT.
C           XYRES AND ZRES ARE THE JADE XY AND Z RESOLUTIONS IN MM.
C           FACMSC=(0.015 GEV)**2*CN, WHERE CN=1.43 FOR NRFI >> 3.
C           FACTAN=12., REF. E.G. R.G.GLASSER: 'ANALYSIS OF ERRORS....',
C        N.R.L. REPORT 6150 (1964)
C           RADLEN IS THE MEAN RADIATION LENGTH OF THE JADE JET CHAMBER
C        IN MM, FOUND AS FOLLOWS:
C              TRLEN=FSENSW(3)-FSENSW(1)
C        IS THE MAXIMUM RADIAL DISTANCE ALONG THE TRACK, WHERE TWO
C        LAYERS OF ROHACELL, AND, OF COURSE, THE JADE GAS CONTRIBUTE
C        TO THE RADIATION LENGTH. THUS:
C              RADLEN=TRLEN/(XR1ROH+XR2ROH+TRLEN/XRJETC)=11666 MM
C        (THE VARIABLES ARE ALL IN COMMON /CGEO1/ )
C
C        INPUTS:
C                IP    = POINTER TO TRACK IN 'PATR'
C                P     = MOMENTUM (GEV), FOUND E. G. BY ROUTINES
C                        'FNDMOM' OR 'TRACK'
C                FMASS = PARTICLE MASS (NEEDED FOR MULTIPLE SCATTERING)
C
#include "cdata.for"
#include "cgeo1.for"
      DATA XYRES/0.180/,FACMSC/3.22E-4/,RADLEN/11666./,ZRES/42./
      DATA FACTAN/12./
      DATA VELH/0.2998E-4/
      DATA IPRMAX/10/,IPR/0/
C        GET PARAMETERS
      VELHB=VELH*ABS(BKGAUS)
      NRFI=IDATA(IP+24)
      NRZ=IDATA(IP+33)
      TAN=ADATA(IP+30)
      COSTSQ=1./(TAN*TAN+1.)
      COST=SQRT(COSTSQ)
      PSQ=P*P
C        PROJECTED TRACK LENGTH
      XF = ADATA(IP+5)
      YF = ADATA(IP+6)
      XL = ADATA(IP+12)
      YL = ADATA(IP+13)
      PROLSQ = (XF-XL)**2+(YF-YL)**2
      PROLEN=SQRT(PROLSQ)
      IF(P.GT..001.AND.PROLEN.GT.10..AND.NRZ.GT.1)GO TO 10
      IPR=IPR+1
      IF(IPR-IPRMAX)82,83,91
   82 WRITE(6,999)P,PROLEN
  999 FORMAT(/' *** ERRMOM TROUBLE *** P,PROLEN=',2E12.4/)
      GO TO 91
   83 WRITE(6,998)
  998 FORMAT(' *** ERRMOM: DIAGNOSTICS TURNED OFF, LIMIT REACHED ***')
      GO TO 91
C        POSITION RESOLUTION
   10 DPRESQ=720./(NRFI+5.)*PSQ*COSTSQ*(XYRES/(VELHB*PROLSQ))**2
C        MULTIPLE SCATTERING
      DPMSCQ=FACMSC*(1.+FMASS*FMASS/PSQ)/(VELHB**2*RADLEN*PROLEN*COST)
C        COS THETA (R-Z) RESOLUTION
      DPCOSQ=TAN*ZRES/((TAN*TAN+1.)*PROLEN)
      DPCOSQ=FACTAN*DPCOSQ*DPCOSQ/FLOAT(NRZ)
C        PUT IT ALL TOGETHER
      DP=SQRT(DPRESQ+DPMSCQ+DPCOSQ)*P
   90 RETURN
   91 DP=1.E15
      GO TO 90
      END

C   14/09/88 809141902  MEMBER NAME  #TAKLUMI (JADESR)      FORTRAN
      PROGRAM TAKLUMI           ! PMF give main program a name
*//F11JOL   JOB 00010622,OLSSON,CLASS=A,MSGLEVEL=(1,0),TIME=(0,08)
*//*MAIN RELPRI=HIG
*//*
*//*      ************************************************
*//*      *  MODIFIED VERSON OF BBGGSELS(RDLUMI) F22WAT  *
*//*      *   USES NEW BARREL LUMI FILE FROM TAKEDA      *
*//*      ************************************************
*//*                                              J.OLSSON 15.1.82
*//*                    LAST CHANGE      03.1.83
*
*                                        20.09.00 P. Movilla Fernandez
*                                                 Some small mods (HBOOK, I/O ...)
*                                                 
C
* PMF: Add run number range 24214 - 30000
      IMPLICIT INTEGER*2 (H)
      DIMENSION NNRL(58),NNRU(58),EAVAR(58),SLUM(58),DSLUM(58)
      DATA NNRL/10599, 6000, 2600,  699, 1491,  699, 1282, 1491, 1660,
     $  2306, 3320, 3504, 3561, 4429, 4993, 6000, 6606, 7181, 7295,
     $  7589, 8712,  699, 6000,6638,6948,10001,10599,11001,11473,7968,
     $ 10001,10493,10974,10001,10493,10493,10818,11288,12519,13000,
     $ 15189,15693,17595,20000,10974,13000,13700,14432,14606,14924,
     $ 15693,16734,18003,20000,21705,22441,23352,24214/
      DATA NNRU/20000,10598, 6000, 1490, 2600, 1281, 1490, 1659, 2226,
     $  3319, 3503, 3560, 4428, 4992, 6000, 6605, 7180, 7294, 7588,
     $  7967,10000, 2600, 6637,6947,7180,10598,11000,11472,12518,8711,
     $ 10492,10973,12518,12518,12518,10817,11287,12518,12950,15188,
     $ 15689,16856,19025,24187,11472,13699,14431,14605,14923,15689,
     $ 16733,18002,19025,21704,22440,23351,24187,30397/
      DATA NLINE/50/,NNRLU/58/
* PMF: Introduce lumi per cms-range statistics
      DIMENSION ECML(6),ECMU(6),EAVAR2(6),SLUM2(6),DSLUM2(6)
      DATA ECML/12. , 21.5, 34.5, 37.5, 43.,11.0/
      DATA ECMU/14.5, 22.5, 35.5, 38.5, 45.,48.0/
      DATA NECM/6/
C
*- PMF Initialize HBOOK
      INTEGER IMEMO
      COMMON /PAWC/IMEMO(100000)
      CALL HLIMIT(100000)
* PMF      CALL ACORE(10000)
      CALL HBOOK1( 1,'INTEGRATED BARREL LUMI FOR JADE',100,0.,50.,0) ! PMF
      CALL HBOOK1( 2,'INTEGRATED BARREL LUMI FOR JADE',100,20.,50.,0) ! PMF
*- PMF Read only NRUN1, NRUN2; fix IUNIT
*      READ(5,100) IUNIT, NRUN1, NRUN2
*  100 FORMAT(3I10)
      READ(5,*) NRUN1, NRUN2 !PMF FMT=100->FMT=*
      IUNIT=20
      OPEN(IUNIT,FILE='lumi.dat',FORM='FORMATTED',STATUS='OLD')
C
      WRITE(6,200) NRUN1, NRUN2
  200 FORMAT(1H1//////////20X,52('*')/20X,'*',50X,'*'/
     &  20X,'*  LUMINOSITY LIST FROM RUN',I6,' UP TO RUN',I6,'  *'/
     &  20X,'*',50X,'*'/20X,52('*')//)
C
C -------  INITIALIZATION  -------------
      CALL LUMINT( IUNIT, NRUN1, NRUN2 )
C    IUNIT: LOGICAL UNIT NUMBER OF A RESULT FILE
C    ( NRUN1, NRUN2 ): RANGE OF RUNS
C   NOTE: NRUN2 - NRUN1 HAS TO BE POSITIVE AND LESS THAN 30000 (MAXL)
C       YOU CAN CALL 'LUMINT' AT ANY TIME WHEN YOU WANT TO INITIALIZE
C     THE INTERNAL TABLE.  THE INPUT RESULT FILE IS AUTOMATICALLY
C     REWOUND.
C --------------------------------------
C
      ILINE= NLINE
      EAVEBR = 0.
      BRLS= 0.
      DBRL2S= 0.
      ISKIP = 0
      EBMOLD = -1.
      DO 4710  I = 1,NNRLU
      SLUM(I) = 0.
4710  DSLUM(I) = 0.
* PMF: INITIALIZE LUMI PER ECMS-RANGE STATISTICS
      DO 4711  I = 1,NECM
      SLUM2(I) = 0.
4711  DSLUM2(I) = 0.

      DO 10 NRUN=NRUN1,NRUN2
       IF( ILINE.LT.NLINE ) GOTO 1
      WRITE(6,300)
 300  FORMAT(1H1///6X,'RUNS',6X,' BEAM ',10X,'BARREL LUMINOSITY ')
       ILINE= 0
    1  CONTINUE
C
       CALL RDLUMI( NRUN, EBM, BRL, DBRL )
C    INPUT   NRUN: RUN NUMBER
C    OUTPUT  EBM: BEAM ENERGY (GEV)
C            BRL, DBRL: BARREL LUMINOSITY AND ITS ERROR
C --------------------------------------
C
       IF(EBM.LT.1.) GO TO 11
      HRUN = NRUN
C.........RUNS TO BE EXCLUDED
      CALL RDATA(IER,HRUN)
C         RDATA IN F11LHO.JADEGL; IER=0; GOOD DATA RUNS
      IF(IER.EQ.0) GO TO 1501
      WRITE(6,1510) HRUN
1510  FORMAT(' FOLLOWING RUN EXCLUDED BY RDATA ',I8)
      GO TO 11
1501  CONTINUE
C ----------------------------------------------------------------
C     EXCLUSION BY RUN NUMBER HERE
C ----------------------------------------------------------------
C RUN PERIOD 5064 TO 5141  HAS TOF INTERCHANGES, COLANAR TRIGGER USELESS
      IF(HRUN.GE.5064 .AND.HRUN.LE.5141) GO TO 11
C RUN PERIOD 12417 TO 12445 HAS NO LUMINOSITY, SEPARATED BEAMS
      IF(HRUN.GE.12417.AND.HRUN.LE.12445) GO TO 11
C SKIP R 13106-13145
      IF(HRUN.GE.13106.AND.HRUN.LE.13145) GO TO 11
C NO COPLANAR TRIGGER BEFORE RUN 699
      IF(HRUN.LT. 699) GO TO 11
C     IF(HRUN.LT.10493) GO TO 11
C     IF(HRUN.GT.2294) GO TO 11
C ----------------------------------------------------------------
C     EXCLUSION BY BEAM ENERGY HERE
C ----------------------------------------------------------------
C     IF(EBM.LT.13.00) GO TO 11
C     IF(EBM.GT.20.00) GO TO 11
C
       IF(ABS(EBM-EBMOLD).LT..003) GO TO 15
C      IF(EBM.EQ.EBMOLD) GO TO 15
       IF(EBMOLD.LT.1.) GO TO 16
450    CONTINUE
       DBRLSE = SQRT( DBRLS2 )
C PRINT SEPARATE ENERGY PERIOD SUMS
      WRITE(6,400) NRUNL,NRUNU,EBMOLD,BRLSE,DBRLSE
400   FORMAT(' ',I5,' ',I5,'  ',F7.3,'   ',E14.6,' +- ',E14.6)
C
16     ILINE= ILINE +1
       BRLSE = 0.
       DBRLS2 = 0.
       EBMOLD = EBM
       NRUNL = NRUN
       IF(ISKIP.EQ.1) GO TO 10
15     CONTINUE
C  TOTAL PERIOD SUM AND ERROR
       BRLS= BRLS +BRL
       DBRL2S= DBRL2S +DBRL**2
       EAVEBR = EAVEBR + BRL*EBM
C
       DO 1060  JL = 1,NNRLU
       IF(NRUN.LT.NNRL(JL).OR.NRUN.GT.NNRU(JL)) GO TO 1060
       SLUM(JL) = SLUM(JL) + BRL
       DSLUM(JL) = DSLUM(JL) + DBRL**2
       EAVAR(JL) = EAVAR(JL) + BRL*EBM

* PMF: LUMI PER ENERGY RANGE
       ECME = 2.*EBM
       DO 1061 JE = 1,NECM
          IF(ECME.LT.ECML(JE).OR.ECME.GT.ECMU(JE)) GO TO 1061
          SLUM2(JE) = SLUM2(JE) + BRL
          DSLUM2(JE) = DSLUM2(JE) + DBRL**2
          EAVAR2(JE) = EAVAR2(JE) + BRL*EBM
 1061  CONTINUE

1060  CONTINUE
C
       ECME = 2.*EBM
       CALL HFILL( 1,ECME,0,BRL)
       CALL HFILL( 2,ECME,0,BRL)
C  SEPARATE ENERGY SUMS AND ERRORS
       BRLSE = BRLSE + BRL
       DBRLS2= DBRLS2 +DBRL**2
C
       NRUNU = NRUN
11     IF(NRUN.EQ.NRUN2) ISKIP = 1
       IF(NRUN.EQ.NRUN2) GO TO 450
   10 CONTINUE
C
C  END OF LOOP OVER RUN NUMBERS, FINAL RESULTS
C
       DBRLS= SQRT( DBRL2S )
       EAVEBR = EAVEBR/BRLS
       WRITE(6,421)
421   FORMAT(///,100(1H*),//)
       WRITE(6,411) EAVEBR,BRLS,DBRLS
411    FORMAT(' AVERAGE BEAM ENERGY ',E12.4,' BARREL LUMI : ',E14.6,' +-
     $ ',E14.6)
       WRITE(6,422)
422   FORMAT(//,100(1H*))
C     PRINT LOOP SUMS
      WRITE(6,307)
 307  FORMAT(' RUN PERIOD         AVER. BE',10X,'BARREL LUMINOSITY ')

      DO 1300  JL = 1,NNRLU
      IF(SLUM(JL).LE.0.) GO TO 1301
      DBRLS= SQRT( SLUM(JL))
      EAVEBR = EAVAR(JL)/SLUM(JL)
      GO TO 1302
1301  DBRLS= 0.
      EAVEBR = 0.
1302  WRITE(6,1303) NNRL(JL),NNRU(JL),EAVEBR,SLUM(JL),DBRLS
1303  FORMAT(' ',I6,' - ',I6,10X,F10.3,10X,E14.6,' +- ',E14.6)
1300  CONTINUE
* PMF: LUMI PER ENERGY RANGE
      WRITE(6,407)
 407  FORMAT(' CMS RANGE          AVER. BE',10X,'BARREL LUMINOSITY ')
      DO 1400  JE = 1,NECM
      IF(SLUM2(JE).LE.0.) GO TO 1401
      DBRLS= SQRT( SLUM2(JE))
      EAVEBR = EAVAR2(JE)/SLUM2(JE)
      GO TO 1402
1401  DBRLS= 0.
      EAVEBR = 0.
1402  WRITE(6,1403) ECML(JE),ECMU(JE),EAVEBR,SLUM2(JE),DBRLS
1403  FORMAT(' ',F6.3,' - ',F6.3,10X,F10.3,10X,E14.6,' +- ',E14.6)
1400  CONTINUE
* PMF (end)
*PMF      CALL HISTDO
* PMF: HISTOGRAMFILE
      CALL HRPUT(0,'lumi.hist','N')
C
      STOP
      END
      SUBROUTINE RDLUMI( NRUNX, EBM, BRL, DBRL ) ! PMF name changed: NRUN-> NRUNX
C
C  READ A LUMINOSITY RESULT FILE    24-SEP-81  S.ODAKA
C    MODIFIED TO READ TAKEDAS NEW BARREL LUMI FILES      OLSSON 3.1.83
C
C
C    INPUT   NRUN: RUN NUMBER
C    OUTPUT  EBM: BEAM ENERGY (GEV)
C            BRL, DBRL: BARREL LUMINOSITY AND ITS ERROR
C
C    NOTE: 'LUMINT', WHICH IS A ENTRY OF THIS ROUTINE, HAS TO
C         BE CALLED BEFORE 'RDLUMI' IS USED.
C
      IMPLICIT INTEGER*2 (H)
      DIMENSION ADATA(4,30397),IDATA(4,30397)
      DATA MAXL/30397/
      EQUIVALENCE (ADATA(1,1),IDATA(1,1))
      DIMENSION ADATA1(4),IDATA1(4)
      EQUIVALENCE (ADATA1(1),IDATA1(1))
C
      NRUN=NRUNX                               ! PMF
      IF( NRUN.LT.NRUN1 .OR. NRUN.GT.NRUN2 ) GOTO 9
      IA= NRUN -NRUN1 +1
      EBM= ADATA(2,IA)
      BRL= ADATA(3,IA)
      DBRL= ADATA(4,IA)
C      WRITE(6,100) IA,IDATA(1,IA),ADATA(2,IA),(ADATA(I,IA),I=3,4)
C  100 FORMAT(5X,2I10,3F10.2)
      RETURN
C
    9 CONTINUE
      WRITE(6,900) NRUN
  900 FORMAT(5X,'***** "RDLUMI" INVALID RUN# =',I6)
      EBM= 0.
      BRL= 0.
      DBRL= 0.
      RETURN
C
C
      ENTRY LUMINT( IUNIT, NRUN1X, NRUN2X ) ! PMF names changed: NRUN1->NRUN1X, NRUN2->NRUN2X
      NRUN1=NRUN1X                         ! PMF 
      NRUN2=NRUN2X                         ! PMF
C
C   READ A RESULT FILE ( LUN = IUNIT ) AND FILL A TABLE.
C        IUNIT: LOGICAL UNIT NUMBER
C        (NRUN1, NRUN2): RANGE OF RUNS, RESULTS OF WHICH YOU WANT
C                        TO KNOW. ( NRUN2 - NRUN1 < MAXL )
C
      ITEST = 0
      WRITE(6,1100) IUNIT, NRUN1, NRUN2
 1100 FORMAT(/5X,'*****  INITIALIZATION TO READ LUMINOSITY RESULT FILE'/
     &  5X,'IUNIT =',I3,', NRUN1 =',I6,', NRUN2 =',I6)
      NRUNL= NRUN2 -NRUN1 +1
      IF( NRUNL.LT.1 .OR. NRUNL.GT.MAXL ) GOTO 1009
      WRITE(6,2331)
2331  FORMAT(' LUMINT ACCEPTED RUN NUMBERS ')
C
      REWIND IUNIT
C
      DO 1020 IA=1,NRUNL
      IDATA(1,IA)= 0
      DO 1020 I=2,4
 1020 ADATA(I,IA)= 0.
C
      NREAD= 0
*PMF 1001 READ(IUNIT,END=1002,FMT='(2(I5,3X),F6.3,2E14.6)') ADATA1
* Changed to read Olssons output files (fax), sorted by consecutive 
* run number ranges with same cms energy, instead of the original
* lumi per run files!
 1001 READ(IUNIT,END=1002,FMT='(2(I5,3X),F6.3,2E14.6)')
     >     ADATA1(1),IDUM,ADATA1(2),ADATA1(3),ADATA1(4)
      ITEST = ITEST + 1
      IF(ITEST.LT.21) WRITE(6,1300) IDATA1(1),(ADATA1(I),I=2,4)
 1300 FORMAT(' LUMINT READ: ',I10,3F10.2)
      NRUN= IDATA1(1)
      IF(ITEST.LT.21) WRITE(6,2471) ITEST,NREAD,NRUN,NRUN1,NRUN2
2471  FORMAT(' ITEST NREAD NRUN NRUN1-2 ',5I8)
      IF( NRUN.LT.NRUN1 ) GOTO 1001
      IF( NRUN.GT.NRUN2 ) GOTO 1001
      IA= NRUN -NRUN1 +1
      DO 1010 I=2,4
 1010 ADATA(I,IA)= ADATA1(I)
      NREAD= NREAD +1
      GOTO 1001
C
 1002 WRITE(6,1200) NREAD
 1200 FORMAT(10X,'INITIALIZATION FINISHED. ',I6,' RUNS WERE READ.'/)
      WRITE(6,1201) NRUN
 1201 FORMAT(10X,'LAST RUN ',I6)
      RETURN
C
 1009 WRITE(6,1900) NRUNL,MAXL
 1900 FORMAT(10X,'GIVEN RUN LENGTH(',I6,' ) IS > MAXIMUM =',I5)
      STOP
      END

C   30/05/80 803301135  MEMBER NAME  RDATA    (JADEGS)      FORTRAN
      SUBROUTINE RDATA(IER,HRUN)
C---
C---     TABLE FOR REAL DATA TAKING RUNS, RETURNS FLAG IER
C---     IER = 0 IF REAL DATA,  OTHERWISE IER = 1
C---     IER = 0 IF MONTE CARLO, I.E. HRUN < 100
C---          LAST CHANGE  30.03.88           J.OLSSON  30.05.80
C---
      IMPLICIT INTEGER*2 (H)
C
      IER = 1
      IF(HRUN.LT.100) GO TO 100
      IF(HRUN.GT. 539.AND.HRUN.LT. 673) GO TO 100
      IF(HRUN.GT. 698.AND.HRUN.LT. 710) GO TO 100
      IF(HRUN.GT. 763.AND.HRUN.LT. 799) GO TO 100
      IF(HRUN.GT. 803.AND.HRUN.LT.1055) GO TO 100
      IF(HRUN.GT.1055.AND.HRUN.LT.1180) GO TO 100
      IF(HRUN.GT.1209.AND.HRUN.LT.1374) GO TO 100
      IF(HRUN.GT.1375.AND.HRUN.LT.1398) GO TO 100
      IF(HRUN.GT.1496.AND.HRUN.LT.1548) GO TO 100
      IF(HRUN.GT.1557.AND.HRUN.LT.1687) GO TO 100
      IF(HRUN.GT.1710.AND.HRUN.LT.1814) GO TO 100
      IF(HRUN.GT.1845.AND.HRUN.LT.2227) GO TO 100
      IF(HRUN.GT.2294.AND.HRUN.LT.2309) GO TO 100
      IF(HRUN.GT.2310.AND.HRUN.LT.2521) GO TO 100
      IF(HRUN.GT.2744.AND.HRUN.LT.3019) GO TO 100
      IF(HRUN.GT.3036.AND.HRUN.LT.3183) GO TO 100
      IF(HRUN.GT.3184.AND.HRUN.LT.3297) GO TO 100
      IF(HRUN.GT.3324.AND.HRUN.LT.3541) GO TO 100
      IF(HRUN.GT.3560.AND.HRUN.LT.4708) GO TO 100
      IF(HRUN.GT.4709.AND.HRUN.LT.4842) GO TO 100
      IF(HRUN.GT.4852.AND.HRUN.LT.4865) GO TO 100
      IF(HRUN.GT.4993.AND.HRUN.LT.5057) GO TO 100
      IF(HRUN.GT.5057.AND.HRUN.LT.5404) GO TO 100
      IF(HRUN.GT.6310.AND.HRUN.LT.6329) GO TO 100
C KNOWN COSMIC RUNS, TEST RUNS
      IF(HRUN.EQ. 6185) GO TO 200
      IF(HRUN.EQ.15870) GO TO 200
      IF(HRUN.GE.17691.AND.HRUN.LE.17695) GO TO 200
      IF(HRUN.GE.11796.AND.HRUN.LE.11798) GO TO 200
      IF(HRUN.GE. 8630.AND.HRUN.LE. 8631) GO TO 200
      IF(HRUN.EQ.18283) GO TO 200
      IF(HRUN.EQ.18284) GO TO 200
      IF(HRUN.EQ.18287) GO TO 200
      IF(HRUN.EQ.25688) GO TO 200
C
      IF(HRUN.GT.5404                 ) GO TO 100
      GO TO 200
100   IER = 0
200   RETURN
      END
*//LKED.SYSLIB DD
*//            DD
*//            DD
*//            DD
*//            DD
*//            DD UNIT=FAST,DISP=SHR,DSN=F11LHO.JADEGL
*//*           DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
*//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
*//*  <<  RESULT FILE  >>
*//GO.FT01F001 DD DISP=SHR,DSN=F22TAK.DISK.BRLLUMI.G001519
*//            DD DISP=SHR,DSN=F22TAK.DISK.BRLLUMI.G520733
*//            DD DISP=SHR,DSN=F22TAK.DISK.BRLLUMI.G734956
*//            DD DISP=SHR,DSN=F22TAK.DISK.BRLLUMI.G0957.G1091
*//            DD DISP=SHR,DSN=F22TAK.DISK.BRLLUMI.G1092.G1243
*//            DD DISP=SHR,DSN=F22TAK.DISK.BRLLUMI.G1244.G1642
*//*O.FT01F001 DD DISP=SHR,DSN=F22TAK.DISK.ENDLUMI.G001519
*//*           DD DISP=SHR,DSN=F22TAK.DISK.ENDLUMI.G520733
*//*           DD DISP=SHR,DSN=F22TAK.DISK.ENDLUMI.G734956
*//*           DD DISP=SHR,DSN=F22TAK.DISK.ENDLUMI.G0957.G1091
*//*           DD DISP=SHR,DSN=F22TAK.DISK.ENDLUMI.G1092.G1243
*//*           DD DISP=SHR,DSN=F22TAK.DISK.ENDLUMI.G1244.G1642
*//*      +--------------------------------+
*//*   COLLINEAR TWOPRONG TRIGGER START AT RUN 699
*//*   NEUTRAL TRIGGER:    HIGH THRESHOLD 1982:  RUNS 10493-11287
*//*                       LOW  THRESHOLD 1982:  RUNS 11288-12518
*//*     AUTUMN 1982       LOW  THRESHOLD 1982:  RUNS 12557-12950
*//*                       LOW  THRESHOLD 1983:  RUNS 13000-15689
*//*                              SPRING  1984:  RUNS 15690-16738
*//*      +--------------------------------+
*//GO.SYSIN DD *
*         1     23739     30397
*//*  IUNIT     NRUN1     NRUN2
*
*

C   11/10/79 203030844  MEMBER NAME  LGCT828  (JADESR)      FORTRAN
      SUBROUTINE LGCT82(IPLG)
C
C      SUM UP LEAD GLASS ENERGIES IN 12 DIFFERENT HALF-WORLDS AND SET
C      THE NUMBER JEMPTY = NR OF EMPTY HALFWORLDS
C      THE NUMBER UNBAL = SMALLEST RATIO BETWEEN OPPOSITE HALFWORLDS
C      IPLG = ADDRESS OF LEADGLASS BANK IN /BCS/
C                     J.OLSSON 11.10.79 (AFTER AN IDEA OF W.BARTEL)
C                     LAST CHANGE:       23.02.80
C
      IMPLICIT INTEGER*2 (H)
C
#include "cdata.for"
C
#include "cheadr.for"
C
      COMMON /CWORK/ SUM12(12),SUMWRD(12)
C
      COMMON /CRESR1/ ETOT,EBAR,EC1,EC2,E7MIN,
     ,               JEMPTY,UNBAL,IACCLG
C
C
C  THE FOLLOWING ARRAY GIVES HELP INDICES FOR THE ENDCAP BLOCKS
C  A ROUGH DIVISION INTO 12 SECTORS CAUSES A ENDCAP BLOCK TO BELONG TO
C  ONE OR AT MOST TWO (NEIGHBOURING) SECTORS
C
      DIMENSION HELP(2,96)
      DATA HELP /1,0,1,2,2,3,3,0,1,0,1,2,2,0,2,3,3,0,1,0,1,0,1,2,
     1           2,3,3,0,3,0,1,0,1,0,1,2,2,0,2,0,2,0,2,3,3,0,3,0,
     2           4,0,4,5,5,6,6,0,4,0,4,5,5,0,5,6,6,0,4,0,4,0,4,5,
     3           5,6,6,0,6,0,4,0,4,0,4,5,5,0,5,0,5,0,5,6,6,0,6,0,
     4           7,0,7,8,8,9,9,0,7,0,7,8,8,0,8,9,9,0,7,0,7,0,7,8,
     5           8,9,9,0,9,0,7,0,7,0,7,8,8,0,8,0,8,0,8,9,9,0,9,0,
     6 10,0,10,11,11,12,12,0,10,0,10,11,11,0,11,12,12,0,10,0,10,0,10,11,
     7 11,12,12,0,12,0,10,0,10,0,10,11,11,0,11,0,11,0,11,12,12,0,12,0/
C
      DATA EMINK /50./
C
      DATA IPRN /0/
C
C                                       INITIALIZE RESULTS
      JEMPTY = 0
      UNBAL  = 1.E+06
      E7MIN  = 0.
      ETOT   = 0.
      EBAR   = 0.
      EC1    = 0.
      EC2    = 0.
      IACCLG = 0
      DO 1 I=1,12
      SUMWRD(I)=0.
    1 SUM12(I)=0.
C
C      GET LEAD GLASS ADRESSES
C
      NWO=IDATA(IPLG)
      IF(NWO.GT.3) GO TO 2
      PRINT 2001, HHEADR(18),HHEADR(19)
 2001 FORMAT(' NO LEAD GLASS HITS IN RUN AND EVENT ',2I10)
      GO TO 999
2     IPLG2=2*IPLG + 8
      NWO=IPLG2+2*NWO-8
C
C     CALCULATE ROW , RING , ENDCAP ENERGIES
C
      IADMX = 0
      EBLMX = 0.
      DO 20 IJK=IPLG2,NWO,2
        IADR=HDATA(IJK-1)
        EBL  = HDATA(IJK)
        ETOT = ETOT + EBL
        IF(IADR.GT.2687) GO TO 11
C
C                                       CYLINDER
          EBAR = EBAR + EBL
C                                       ROW NUMBER   0 - 83
          IROW = IADR/32
C                                 SECTOR NUMBER 1 - 12 (7 ROWS / SECTOR)
          IND12 = IROW/7 + 1
          SUM12(IND12) = SUM12(IND12) + EBL
          GO TO 20
   11   CONTINUE
C
C                                       END CAPS
          IADR = IADR - 2687
C                                       KEEP HIGHEST BLOCK IN END CAP
          IF(EBL.LE.EBLMX) GOTO 16
            EBLMX = EBL
            IADMX = IADR
   16     CONTINUE
          IF(IADR.GT.96) GOTO 18
             EC1  = EC1 + EBL
             GOTO 19
   18     CONTINUE
             IADR = IADR - 96
             IF(IADR.GT.96) GOTO 20
             EC2  = EC2 + EBL
   19     CONTINUE
          IND1 = HELP(1,IADR)
          IND2 = HELP(2,IADR)
          IF(IND1*IND2 .NE. 0) EBL = EBL * .5
          IF(IND1.NE.0) SUM12(IND1) = SUM12(IND1) + EBL
          IF(IND2.NE.0) SUM12(IND2) = SUM12(IND2) + EBL
   20 CONTINUE
C
C     CHECK IF 'SPINNING' BLOCK
      IF(EBLMX.LT.ETOT*.95) GOTO 22
C     0 FOR -Z, 1 FOR +Z
      NE = 0
      IF(IADMX.GT.96) NE = 1
C     REDUCE TO 1 - 96
      IADMX = IADMX - NE*96
C     GET QUADRANT NUMBER 0 - 3
      NQ = (IADMX - 1)/24
C     REDUCE TO 1 - 24
      IADMX = IADMX - NQ*24
      IF(IADMX.LT.5) GO TO 22
      IF(IADMX.GT.15.AND.IADMX.NE.20) GO TO 22
      IPRN = IPRN + 1
      IF(IPRN.LE.20) PRINT 2002, HHEADR(18),HHEADR(19),IADMX,EBLMX
 2002 FORMAT(' EVENT',2I6,': ADDRESS AND ENERGY OF BAD BLOCK:',I6,F10.2)
      RETURN
C
C
   22 CONTINUE
C
C     CALCULATE ENERGY ASYMMETRY, MEASURED BY NUMBER OF EMPTY H-WORLDS
C     A HALF-WORLD CONSISTS OF ANY CONSECUTIVE 6 SECTORS
C     CALCULATE ALSO RATIO BETWEEN OPPOSITE HALFWORLDS
C
      E7MIN = 1.E10
      DO 40  I6 = 1,6
        IF(I6.NE.1) GOTO 32
          E6SM1 = SUM12(1)+SUM12(2)+SUM12(3)
     ,          + SUM12(4)+SUM12(5)+SUM12(6)
          E7SM1 = E6SM1 + SUM12(12)
          E7SM2 = ETOT  - E6SM1 + SUM12( 1)
          GOTO 33
   32   CONTINUE
          E7SM1 = E6SM1 + SUM12(I6+5)
          E6SM1 = E7SM1 - SUM12(I6-1)
          E7SM2 = ETOT  - E6SM1 + SUM12(I6)
   33   CONTINUE
        E6SM2 = ETOT - E6SM1
C
        E1    = AMIN1(E6SM1,E6SM2)
        E2    = ETOT - E1
        RAT   = 0.
        IF(E1.GT.0.) RAT = E1 / E2
        IF(RAT.LT.UNBAL) UNBAL = RAT
C
        IF(E6SM1.LT.EMINK) JEMPTY = JEMPTY + 1
        IF(E6SM2.LT.EMINK) JEMPTY = JEMPTY + 1
        E7MIN = AMIN1(E7SM1,E7SM2,E7MIN)
        SUMWRD(I6  ) = E6SM1
        SUMWRD(I6+6) = E6SM2
   40 CONTINUE
C
C
C
  999 CONTINUE
      IACCLG = 1
      RETURN
      END

C   17/02/82 311291152  MEMBER NAME  PLLIGD   (S)           FORTRAN
      SUBROUTINE PLLIGD(PL,X1,Y1,Z1,X2,Y2,Z2,IFLG)
C
C     PROGRAM WRITTEN BY KANZAKI
C     OUTPUT ;
C       PL = PATH LENGTH IN THE LIGHT GUIDE
C     INPUT  ;
C       X1,Y1,Z1 = COORDINATES OF THE HIT POINT AT THE FRONT SURFACE OF
C                    THE LEAD GLASS
C       X2,Y2,Z2 = COORDINATES OF THE HIT POINT AT THE BACK SURFACE OF
C                    THE LEAD GLASS
C       IFLG = 1 FOR IMPACT POINT IN ENDCAPS (INCLUDING GAP ENDCAP-CYL)
C       IFLG = 2 FOR IMPACT POINT IN CYLINDER
C
C       --->  YOU CAN GET ABOVE PARAMETERS BY RUTRCK IN JADEGS
C       --->  COPIED FROM F22MIN.LGMC.S   BY W.BARTEL ON 29/11/83
C
      DATA ZWID1/ 103.2/,PHWID1,PHWID2/ 80.0, 102.8/
      DATA PHWID0/ 0.0748/
      DATA RADI1,RADI2/ 1100.0, 1400.0/
      DATA ZEND1/ 1705.45/,ZGAP1/ 3.5/
      DATA PI/ 3.1415927/
C
      DATA ALLIGD,RLIGD/ 60., 37.5/
C
C
      PL=0.
C
      IF(IFLG.NE.1 .AND. IFLG.NE.2) RETURN
      IF(IFLG.NE.2) RETURN
C
      PHI=ATAN2(Y2,X2)
      IF(PHI.LT.0.) PHI=PHI+2.*PI
C     RL2=RADI2*PHI
      IC2=INT(PHI/PHWID0)+1
      ZWIDG=ZWID1+ZGAP1
      IR2=INT((Z2+ZEND1)/ZWIDG)+1
C
CCC   WRITE(6,630) IR2,IC2
  630 FORMAT(1H ,'RING,COUTER # = ',2I5)
C
      PHI0=(FLOAT(IC2-1)+0.5)*PHWID0-0.5*PI
      IF(PHI0.LT.0.) PHI0=PHI0+2.*PI
      Z0=(FLOAT(IR2-1)+0.5)*ZWIDG-ZEND1
CCC   WRITE(6,640) PHI0,Z0
  640 FORMAT(1H ,'PHI0,Z0 = ',2E15.7)
C
      R1=SQRT(X1**2+Y1**2)
      R2=SQRT(X2**2+Y2**2)
CCC   WRITE(6,650) R1,R2
  650 FORMAT(1H ,'R1,R2 = ',2E15.7)
C
      X0=-RADI2*SIN(PHI0)
      Y0=RADI2*COS(PHI0)
CCC   WRITE(6,660) X0,Y0
  660 FORMAT(1H ,'X0,Y0 = ',2E15.7)
C
C***
      XR0=X0*COS(PHI0)+Y0*SIN(PHI0)
      YR0=-X0*SIN(PHI0)+Y0*COS(PHI0)-RADI2
CCC   WRITE(6,670) XR0,YR0
  670 FORMAT(1H ,'XR0,YR0 = ',2E15.7)
C***
C
      XR1=X1*COS(PHI0)+Y1*SIN(PHI0)
      YR1=-X1*SIN(PHI0)+Y1*COS(PHI0)-RADI2
      ZR1=Z1-Z0
C
      XR2=X2*COS(PHI0)+Y2*SIN(PHI0)
      YR2=-X2*SIN(PHI0)+Y2*COS(PHI0)-RADI2
      ZR2=Z2-Z0
C
CCC   WRITE(6,600) XR1,YR1,ZR1,XR2,YR2,ZR2
  600 FORMAT(1H ,'**** AFTER COORDINATE TRANSFORMATION ****'/
     *       1H ,'XR1,YR1,ZR1 = ',3E15.7/
     *       1H ,'XR2,YR2,ZR2 = ',3E15.7)
C
      A=ZR2-ZR1
      B=XR1-XR2
      C=XR1*ZR2-XR2*ZR1
C
      D=RLIGD**2*(A**2+B**2)-C**2
C
CCC   WRITE(6,680) A,B,C,D
  680 FORMAT(1H ,'A,B,C = ',3E15.7/
     *       1H ,'D     = ',E15.7)
C
      IF(D.LE.0.) RETURN
C
      XCRS1=(A*C+ABS(B)*SQRT(D))/(A**2+B**2)
      ZCRS1=(B*C+ABS(A)*SQRT(D))/(A**2+B**2)
      YCRS1=(YR2-YR1)*(XCRS1-XR1)/(XR2-XR1)+YR1
C
      XCRS2=(A*C-ABS(B)*SQRT(D))/(A**2+B**2)
      ZCRS2=(B*C-ABS(A)*SQRT(D))/(A**2+B**2)
      YCRS2=(YR2-YR1)*(XCRS2-XR1)/(XR2-XR1)+YR1
C
CCC   WRITE(6,620) XCRS1,YCRS1,ZCRS1,XCRS2,YCRS2,ZCRS2
  620 FORMAT(1H ,'**** SOLUTION !!! ****'/
     *       1H ,'XCRS1,YCRS1,ZCRS1 = ',3E15.7/
     *       1H ,'XCRS2,YCRS2,ZCRS2 = ',3E15.7)
C
      IF((YCRS1.LT.0. .AND. YCRS2.LT.0.) .OR.
     *   (YCRS1.GT.ALLIGD .AND. YCRS2.GT.ALLIGD)) RETURN
C
      IF(YCRS1.LE.YCRS2) GO TO 100
      XTMP=XCRS1
      YTMP=YCRS1
      ZTMP=ZCRS1
      XCRS1=XCRS2
      YCRS1=YCRS2
      ZCRS1=ZCRS2
      XCRS2=XTMP
      YCRS2=YTMP
      ZCRS2=ZTMP
C
  100 IF(YCRS1.GE.0.) GO TO 110
      XCRS1=-YR1*(XR2-XR1)/(YR2-YR1)+XR1
      YCRS1=0.
      ZCRS1=-YR1*(ZR2-ZR1)/(YR2-YR1)+ZR1
C
  110 IF(YCRS2.LT.ALLIGD) GO TO 120
      XCRS2=(ALLIGD-YR1)*(XR2-XR1)/(YR2-YR1)+XR1
      YCRS2=ALLIGD
      ZCRS2=(ALLIGD-YR1)*(ZR2-ZR1)/(YR2-YR1)+ZR1
C
  120 PL=SQRT((XCRS2-XCRS1)**2+(YCRS2-YCRS1)**2+(ZCRS2-ZCRS1)**2)
C
      RETURN
      END

C   10/10/79 C9101501   MEMBER NAME  YAMADA   (JADEGS)      FORTRAN
      SUBROUTINE YAMADA(INDEX)
C----
C---     DRIVER ROUTINE FOR YAMADA'S CLUSTER FINDING ROUTINES WHEN THEY
C---     RUN UNDER GRAPHICS.      AUTHOR L.H. O'NEILL
C---                             ( CHANGED 15.7.79   J.OLSSON)
C---                             ( CHANGED 14.10.79   J.OLSSON)
      IMPLICIT INTEGER*2 (H)
C-----------------------------------------------------------------------
C                            MACRO CGRAPH .... GRAPHICS COMMON
C-----------------------------------------------------------------------
C
      LOGICAL DSPDTL,SSTPS,PSTPS,FREEZE
C
      COMMON / CGRAPH / JUSCRN,NDDINN,NDDOUT,IDATSV(11),ICREC,MAXREC,
     +                  LSTCMD,ACMD,LASTVW,ISTANV,
     +                  SXIN,SXAX,SYIN,SYAX,XMIN,XMAX,YMIN,YMAX,
     +                  DSPDTL(30),SSTPS(10),PSTPS(10),FREEZE(30),
     +                  IREADM,LABEL,LSTPS(10),IPSVAR
C
C------- END OF MACRO CGRAPH -------------------------------------------
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
      COMMON /CMSGCT/ MSGDUM(10),LGMMAX,LGMSG(9)
      COMMON/CWORK/HWORK(40),XLINE(3,200,2),X,Y,X0,Y0,DX,DY,
     1NBLK,NBLK1,XCLMIN,XCLMAX,YCLMIN,YCLMAX,XCLDRW,YCLDRW,SIZE
      DATA ICALL/0/
      IF(ICALL.EQ.1) GO TO 300
      ICALL=1
      LGMMAX=10
      DO 400 I=1,6
      LGMSG(I)=0
  400 CONTINUE
      XMBARL=    0.00
      XRBARL= 6911.52
      YABARL= 4496.00
      XE01  =  898.50
      YE01  =  900.00
      XE02  = 6013.02
      YE02  =  900.00
  300 CONTINUE
      IF((INDEX.NE.2).AND.(INDEX.NE.3).AND.(LASTVW.NE.13))
     1CALL TRMOUT(80,'CLUSTER DISPLAY NOT AVAILABLE IN THIS VIEW.^')
      IF((INDEX.NE.3).AND.(LASTVW.NE.13)) RETURN
      IF(IDATA(IBLN('ALGN')).LT.1) RETURN
      IF(INDEX.NE.3) GO TO 3
      IERR=0
      IF(IDATA(IBLN('LGCL')).EQ.0) GO TO 8
      CALL BMLT(1,'LGCL')
      CALL BDLM
    8 CONTINUE
      IF(IERR.NE.0) CALL TRMOUT(80,'ERROR ATTEMPTING TO ERASE LGCL^')
      IF(IERR.NE.0) RETURN
      CALL LGANAL
      RETURN
    3 CONTINUE
      IPLGCL=IDATA(IBLN('LGCL'))
      IF(IPLGCL.LT.1) RETURN
      IRET=IDATA(IPLGCL+20)
      IF(IRET.NE.0) GO TO 1
      GO TO 2
    1 CONTINUE
      CALL TRMOUT(80,'CLUSTER ANALYSIS ERROR EXIT.^')
      RETURN
    2 CONTINUE
      IPSHUF=IDATA(IBLN('ALGN'))
      NCLST=IDATA(IPLGCL+7)
      IP3=IDATA(IPLGCL+3)
      NWPCL=IDATA(IPLGCL+25)
      IF(INDEX.NE.2) GO TO 301
      WRITE(JUSCRN,101) NCLST
  101 FORMAT(' NCLST=',I10)
  301 CONTINUE
      IF(NCLST.LT.1) GO TO 5
      IF(NCLST.GT.50) GO TO 5
      IPMAP=IDATA(IPLGCL+2)+IPLGCL-1
      DO 6 ICLST=1,NCLST
      LIM1=2*HDATA(2*IPMAP+2*ICLST-1)-1
      LIM2=2*HDATA(2*IPMAP+2*ICLST  )
      IB=IP3+(ICLST-1)*NWPCL-1+IPLGCL
      IF(INDEX.NE.2) GO TO 303
      CALL TRMOUT(80,' ^')
      NBLOKS=(LIM2-LIM1+1)/2
      WRITE(JUSCRN,102) ICLST,LIM1,LIM2,NBLOKS
  102 FORMAT(' CLUSTER, ADDRESS RANGE AND NUMBER OF BLOCKS = ',4I6)
      IF(NBLOKS.LT.1) GO TO 6
      NCYCLE=1+(NBLOKS-1)/5
      DO 302 LINE=1,NCYCLE
      LIML=LIM1+10*(LINE-1)
      LIMU=LIML+9
      IF(LIMU.GT.LIM2) LIMU=LIM2
      WRITE(JUSCRN,104) (HDATA(2*IPSHUF+6+KLM),KLM=LIML,LIMU)
  104 FORMAT(' ',10I6)
  302 CONTINUE
      CALL TRMOUT(80,
     1'JPART,          E,         DE,        PHI,          Z,       DPHI
     1          DZ^')
      WRITE(JUSCRN,105) IDATA(IB+1),(ADATA(IB+KLM),KLM=2,7)
  105 FORMAT(' ',I5,6F12.4)
      GO TO 6
  303 CONTINUE
      IF(LIM2.LT.LIM1) GO TO 5
      IF((LIM2-LIM1).GT.100) GO TO 5
      KOUNT=0
      XCLMIN= 100000.
      XCLMAX=-100000.
      YCLMIN= 100000.
      YCLMAX=-100000.
      DO 7 IADD=LIM1,LIM2,2
      NBLK=HDATA(2*IPSHUF+6+IADD)
      CALL XYBLK(NBLK,X0,Y0,DX,DY)
      IF( X0    .LT.XCLMIN) XCLMIN=X0
      IF((X0+DX).GT.XCLMAX) XCLMAX=X0+DX
      IF( Y0    .LT.YCLMIN) YCLMIN=Y0
      IF((Y0+DY).GT.YCLMAX) YCLMAX=Y0+DY
      IF(KOUNT.GT.198) GO TO 7
      KOUNT=KOUNT+1
      XLINE(1,KOUNT,1)=Y0
      XLINE(2,KOUNT,1)=X0
      XLINE(3,KOUNT,1)=X0+DX
      XLINE(1,KOUNT,2)=X0
      XLINE(2,KOUNT,2)=Y0
      XLINE(3,KOUNT,2)=Y0+DY
      KOUNT=KOUNT+1
      XLINE(1,KOUNT,1)=Y0+DY
      XLINE(2,KOUNT,1)=X0
      XLINE(3,KOUNT,1)=X0+DX
      XLINE(1,KOUNT,2)=X0+DX
      XLINE(2,KOUNT,2)=Y0
      XLINE(3,KOUNT,2)=Y0+DY
    7 CONTINUE
      SIZE=65.
      XCLDRW= XCLMIN - 3.*SIZE
      IF(ICLST.GE.10)  XCLDRW = XCLDRW - SIZE
      YCLDRW=(YCLMIN+YCLMAX)/2.-SIZE/2.
      CALL NUMBWR(13,ICLST,XCLDRW,YCLDRW,SIZE)
      DO 201 IDIR=1,2
      IF(KOUNT.LT.2) GO TO 201
      KOUNTM=KOUNT-1
      DO 202 J1=1,KOUNTM
      Y=XLINE(1,J1,IDIR)
      XMIN2=XLINE(2,J1,IDIR)
      XMAX2=XLINE(3,J1,IDIR)
      LIM1=J1+1
      DO 203 K1=LIM1,KOUNT
      Y1=XLINE(1,K1,IDIR)
      IF(ABS(Y1-Y).GT.1) GO TO 203
      XMIN1=XLINE(2,K1,IDIR)
      XMAX1=XLINE(3,K1,IDIR)
      IF(ABS(XMIN1-XMIN2).GT.1.) GO TO 304
      IF(ABS(XMAX1-XMAX2).GT.1.) GO TO 304
C--      IDENTICAL LINES
      XLINE(1,J1,IDIR)=100000.
      XLINE(1,K1,IDIR)=100000.
      GO TO 202
  304 CONTINUE
C--      CHECK FOR NON-OVERLAPPING LINES.
      IF((XMAX1-XMIN2).LT.1.) GO TO 203
      IF((XMIN1-XMAX2).GT.1.) GO TO 203
C--      THE LINES OVERLAP.
      IF(XMAX1.GT.XMAX2) GO TO 305
      XLINE(2,J1,IDIR)=XMAX1
      XLINE(3,K1,IDIR)=XMIN2
      GO TO 203
  305 CONTINUE
      XLINE(2,K1,IDIR)=XMAX2
      XLINE(3,J1,IDIR)=XMIN1
  203 CONTINUE
  202 CONTINUE
  201 CONTINUE
      IF(KOUNT.LT.2) GO TO 205
      DO 206 LINE=1,KOUNT
      Y0=XLINE(1,LINE,1)
      IF(Y0.GT.10000.) GO TO 207
      X0=XLINE(2,LINE,1)
      CALL MOVEA(X0,Y0)
      X1=XLINE(3,LINE,1)
      Y1=Y0
      CALL DRAWA(X1,Y1)
  207 CONTINUE
      X0=XLINE(1,LINE,2)
      IF(X0.GT.10000.) GO TO 206
      Y0=XLINE(2,LINE,2)
      CALL MOVEA(X0,Y0)
      Y1=XLINE(3,LINE,2)
      X1=X0
      CALL DRAWA(X1,Y1)
  206 CONTINUE
  205 CONTINUE
      IF(INDEX.NE.1) GO TO 6
      IF(IDATA(IB+1).NE.0) GO TO 306
C---     BARREL SECTION.
      X0=XMBARL+ADATA(IB+4)*XRBARL/6.283185308
      IF(X0.LT.0.) X0=X0+XRBARL
      X1=X0
      Y0=YABARL
      Y1=ADATA(IB+5)+Y0
      CALL SAEGE(X0,Y0,X1,Y1)
      GO TO 6
  306 CONTINUE
C---     END CAP CASE
      X0=XE01
      Y0=YE01
      IF(IDATA(IB+1).NE.1) GO TO 307
      X0=XE02
      Y0=YE02
  307 CONTINUE
      X1=-ADATA(IB+4)+X0
      Y1= ADATA(IB+5)+Y0
      CALL SAEGE(X0,Y0,X1,Y1)
    6 CONTINUE
    5 CONTINUE
      RETURN
      END

C   14/03/84 403202337  MEMBER NAME  ANAL79   (S)           FORTRAN
C   13/01/82 201271037  MEMBER NAME  @ANALYS1 (S)           FORTRAN
C---  ANALYSIS PROGRAM (DATA WITH TAGGING TRIGGER)
C---  (PEDESTAL SUBTRACTION, LATCHES REORDERED MAY 79)
C---  (TREATS CHANNELS WITH OR WITHOUT VARIING PEDESTALS)
C---  DEALS WITH REDUCED DATA
C---  WRITES OUTPUT ONTO TAPE (SINGLE TAGG EVENTS)
C
C     H.WRIEDT      09.03.79     18:50
C     LAST MODIFICATION      13.01.82       16:30
C
C     COPIED BY A.J.FINCH14/3/84 AND ADAPTED
C       TO BE CALLED FROM TP JOB
C
C
C****************************************************************
C     STRUCTURE OF THE ANALYSIS PROGRAMS CHAIN
C     @ANALYSE   CALLS THE FOLLOWING SUBROUTINES:
C               GGBLCK
C               GCLEAR
C               INGAMW
C               GGSORT
C               PICTUR     (OPTION)
C               GGADCD     (OPTION)
C               GGCCTL
C               GGCLPC
C               GGCLSD     (OPTION)
C               LUMOUT     (OPTION)
C               OUTGAM
C*************************************************************
C
      SUBROUTINE ANAL79(IER)
      IMPLICIT INTEGER*2 (H)
C
      COMMON /BCS/ IDATA(30000)
      REAL RDATA(30000)
      EQUIVALENCE (IDATA(1),RDATA(1))
C
      COMMON /CWORK/ IWORK1(42),LNG,HPOINT(4),HGGADC(2,192),HWORK(532),
     &               HCLSTM,HCLSTP,
     &               IWORK5(23),ACOLAN,ETOT,ETOTM,ETOTP,IWORK4(757),
     &               HACC,HWORK1,IWORK3(619),HRUNEX,HEVENT
C
      COMMON /CRUNCO/ HRUN,HOLDRN,IUN
C
      COMMON /CSUMEA/ HEVENA
C
      LOGICAL*1 LDUMP/.TRUE./
      DATA LIMIT/100/, MASK/1/, IMISS/0/, NIER1/0/
      DATA HEVEN1/0/
      LOGICAL FIRST/.TRUE./
C
      DATA ICOUNT/0/
      DATA IEVLIM/3/
C
C
C
       IF(.NOT.FIRST)GOTO 1
       FIRST=.FALSE.
C---  INITIALIZE FORWARD DETECTORS DATA
      CALL GGBLCK
C---  READ FIRST SET OF CALIBRATION FACTORS OF PB-GLASS
      CALL GGFAC1
C
C---  PREPARE NEW RUN
      NREDUC = 22
      HOLDRN = 0
C
C---  GET DATE
      HDATE = DATE(DUMMY)
C
C
    1 CONTINUE
      ICOUNT = ICOUNT + 1
C
C---  CLEAR COMMON BLOCKS FOR NEW EVENT
C RENAMED TO GSCRUB FROM GCLEAR - A.J.FINCH 20/3/84 TO PREVENT
C CONFLICT WITH IPS COMMAND OF SAME NAME
      CALL GSCRUB
COLDOLDALL GCLEAROLD
C
C---   UNPACK DATA OF NEW EVENT
      CALL INGAM1(IER)
C
      HEVENA = HEVENA + 1
C---  1981 (OR LATER) - DATA ARE NOT ANALYSED BY @ANALYS1:
      IF (HRUNEX.GT.6000) GOTO 104
C---  ONLY EVENTS WITH TAGGING TRIGGER OR ENERGY IN TAGGING LEAD-GLASS
C---  ARE PROCESSED FURTHER
      IF (HACC.NE.0) GOTO 2
      GOTO 103
    2 HEVEN1 = HEVEN1 + 1
      IF (IER.EQ.0) GOTO 10
      IF (IER.EQ.7) GOTO 103
      IMASK = IAND(IER,MASK)
      IF (IMASK.EQ.1) GOTO 100
   10 CONTINUE
C
C---  LEAD GLASS
  100 IER = IER/2
      IMASK = IAND(IER,MASK)
      IF (IMASK.EQ.1) GOTO 103
C
C---  CLUSTER SEARCH
      CALL GGCCTL(&103)
      CALL GGCLPC(&103)
C
C---  LEAD GLASS RESULT DUMP
C AJF - ONLY FIRST FEW EVENTS
C
      IF(ICOUNT.GT.IEVLIM)GOTO 103
      IF (HCLSTM.LT.1 .AND. HCLSTP.LT.1) GOTO 103
      IF (HACC.EQ.1) WRITE(6,501)
  501 FORMAT(' EVENT HAS GOT TAG-TRIGGER & ENERGY IN TAGGING-LG')
      IF (HACC.EQ.2) WRITE(6,502)
  502 FORMAT(' EVENT HAS GOT NO TAG-TRIGGER BUT ENERGY IN TAGGING-LG')
      IF (.NOT.LDUMP) GOTO 103
      WRITE(6,603) HEVENA
  603 FORMAT(///1X,'EVENT NO.',I5,' DISPLAYED')
      WRITE(6,608) HEVENT,HRUNEX
  608 FORMAT(' THIS IS EVENT NO.',I5,' OF RUN NO.',I4)
C
      CALL GGCLSD
C
C---  WRITE RESULT INTO NEW BANKS
  103 CALL OUTGAW(IER1)
      IER = IER1
104   RETURN
      END

C   29/04/87 705071933  MEMBER NAME  ZSLINE9  (JADEGS)      FORTRAN
      SUBROUTINE ZSLINE(N,Z0,TANL,SIGMAZ,ZMIN,ZMAX)
C*811215*DITTMANN****************************************************
C*                                                                  *
C*             Z - S   S T R A I G H T   L I N E   F I T            *
C*                                                                  *
C*       SELECT HIT TRIPLES ON ADJACENT WIRES,                      *
C*       IF NOT SUFFICIENT HIT TRIPLES FOUND, SELECT HIT DOUBLES    *
C*       IF NOT SUFFICIENT HIT DOUBLES, USE SINGLE HITS.            *
C*       FIT FIRST APPROXIMATION LINE THROUGH HIT MULTIPLES,        *
C*       REMOVE ITERATIVELY BAD FITTING MULTIPLES.                  *
C*       USE THIS LINE AS ROAD CENTER WITH WIDTH 2 SIGMA            *
C*       TO SELECT HITS FOR FINAL FIT.                              *
C*       MODIFIED 29/04/87    E ELSEN                               *
C*       INTRODUCED COMMON CZSPRM                                   *
C********************************************************************
      COMMON /CWORK/ NHIT,IZB(60),IJC(60),IJH(60),NW(60),LH(60),
     *                LRFL(60),ALU(60),ARU(60),X(60),Y(60),Z(60),S(60),
     *                G(60),DT(60),DL(60),DW(60),FCORR(60)
      DIMENSION JW(60),JTRIP(60),ZTRIP(60),STRIP(60)
      REAL*8 SN,SS,SZ,SS2,SZ2,SSZ,D,ZZ,TT,SSJ,SZJ,SGJ
C     DIMENSION ITR(60),ITRW(60),DZ1TR(60),DZ2TR(60)
#include "czsprm.for"
C
      N = 0
      SMIN = 1000.
      SMAX = 0.
      DO 11 J=1,NHIT
      JW(J) = 0
      IF(IZB(J).EQ.0) GOTO 11
      N = N + 1
      JW(J) = LAND(NW(J),15)
      IF(S(J).LT.SMIN) SMIN=S(J)
      IF(S(J).GT.SMAX) SMAX=S(J)
   11 CONTINUE
      IF(N.LT.3) GOTO 100
      DS1 = SMAX - SMIN
C        SELECT HIT TRIPLES
      NMULT = 3
      NTRIP = 0
      SIGMAT = 0.
      SMIN = 1000.
      SMAX = 0.
      NH2 = NHIT - 2
      DO 15 J=1,NH2
      IF(IZB(J).EQ.0) GOTO 15
      IF(JW(J+1).NE.JW(J)+1 .OR. JW(J+2).NE.JW(J)+2) GOTO 15
      DZ1 = Z(J) + Z(J+2) - 2.*Z(J+1)
      DZ2 = Z(J) - Z(J+2)
      IF(ABS(DZ1).GT.AZSCT1(NZSPRD)) GOTO 15
      IF(ABS(DZ2).GT.AZSCT2(NZSPRD)) GOTO 15
      NTRIP = NTRIP + 1
      JTRIP(NTRIP) = J
      ZTRIP(NTRIP) = (Z(J) + Z(J+1) + Z(J+2)) / 3.
      STRIP(NTRIP) = S(J+1)
      DZ = (Z(J)**2+Z(J+1)**2+Z(J+2)**2 -3.*ZTRIP(NTRIP)**2)/2.
      IF(DZ.LT.0.) DZ=0.
      SIGMAT = SIGMAT + SQRT(DZ)
      IF(S(J).LT.SMIN) SMIN=S(J)
      IF(S(J+2).GT.SMAX) SMAX=S(J+2)
C     ITR(NTRIP) = J
C     ITRW(NTRIP) = NW(J)
C     DZ1TR(NTRIP) = DZ1
C     DZ2TR(NTRIP) = DZ2
   15 CONTINUE
C     PRINT 101,(ITR(I),ITRW(I),DZ1TR(I),DZ2TR(I),I=1,NTRIP)
C 101 FORMAT( 7(I4,X Z3,2F5.0))
      IF(NTRIP.LT.3) GOTO 16
      SIGMAT=SIGMAT/NTRIP
      DS3 = SMAX - SMIN
      IF(2.*DS3.GT.DS1) GOTO 20
C        < 3 HIT TRIPLES, TRY WITH HIT DOUBLES
   16 NMULT = 2
      NTRIP = 0
      SIGMAT = 0.
      NH2 = NHIT - 1
      DO 17 J=1,NH2
      IF(IZB(J).EQ.0) GOTO 17
      IF(JW(J+1).NE.JW(J)+1) GOTO 17
      DZ1 = Z(J) - Z(J+1)
      IF(ABS(DZ1).GT.AZSCT3(NZSPRD)) GOTO 17
      NTRIP = NTRIP + 1
      JTRIP(NTRIP) = J
      ZTRIP(NTRIP) = (Z(J) + Z(J+1)) / 2.
      STRIP(NTRIP) = (S(J) + S(J+1)) / 2.
      DZ = Z(J)**2+Z(J+1)**2 - 2.*ZTRIP(NTRIP)**2
      IF(DZ.LT.0.) DZ=0.
      SIGMAT = SIGMAT + SQRT(DZ)
C     ITR(NTRIP) = J
C     ITRW(NTRIP) = NW(J)
C     DZ1TR(NTRIP) = DZ1
C     DZ2TR(NTRIP) = 0.
   17 CONTINUE
C     PRINT 101,(ITR(I),ITRW(I),DZ1TR(I),DZ2TR(I),I=1,NTRIP)
      IF(NTRIP.LT.3) GOTO 18
      SIGMAT=SIGMAT/NTRIP
      GOTO 20
C        < 3 HIT DOUBLES, TRY WITH SINGLE HITS
   18 NMULT = 1
      NTRIP = 0
      DO 19 J=1,NHIT
      IF(IZB(J).EQ.0) GOTO 19
      NTRIP = NTRIP + 1
      JTRIP(NTRIP) = J
      ZTRIP(NTRIP) = Z(J)
      STRIP(NTRIP) = S(J)
   19 CONTINUE
      IF(NTRIP.LT.3) GOTO 100
C        FIRST APPROXIMATION BY FIT THRU TRIPLE COORDINATES
   20 N = 0
      SN = 0.
      SS = 0.
      SZ = 0.
      SS2 = 0.
      SZ2 = 0.
      SSZ = 0.
      DO 21 J=1,NTRIP
      IF(JTRIP(J).EQ.0) GOTO 21
      N = N + 1
      SSJ = STRIP(J)
      SZJ = ZTRIP(J)
      SN = SN + 1.D0
      SS = SS + SSJ
      SZ = SZ + SZJ
      SS2 = SS2 + SSJ**2
      SZ2 = SZ2 + SZJ**2
      SSZ = SSZ + SSJ*SZJ
   21 CONTINUE
      D = SN*SS2 - SS**2
      ZZ = (SZ*SS2-SS*SSZ) / D
      TT = (SN*SSZ-SS*SZ) / D
      SIGMAZ = (SZ2-ZZ*SZ-TT*SSZ) / (SN-2.)
      IF(SIGMAZ.LT.0.) SIGMAZ=0.
      SIGMAZ = SQRT(SIGMAZ)
      Z0 = ZZ
      TANL = TT
C     PRINT 102, NMULT,Z0,TANL,SIGMAZ,SIGMAT
C     PRINT 103, (JTRIP(I),I=1,NTRIP)
      IF(NMULT.EQ.3 .AND. SIGMAZ.LT.1.2*SIGMAT) GOTO 23
      IF(NMULT.EQ.2 .AND. SIGMAZ.LT.1.4*SIGMAT) GOTO 23
      IF(N.LE.3 .AND. NMULT.EQ.3) GOTO 16
      IF(N.LE.3 .AND. NMULT.EQ.2) GOTO 18
      IF(N.LE.3) GOTO 23
C        BAD FIT, REMOVE WORST TRIPLE
      SIGMAX = 0.
      DO 22 J=1,NTRIP
      IF(JTRIP(J).EQ.0) GOTO 22
      DZ = ABS(ZTRIP(J)-Z0-STRIP(J)*TANL)
      IF(DZ.LT.SIGMAX) GOTO 22
      SIGMAX = DZ
      JMAX = J
   22 CONTINUE
      IF(NMULT.EQ.1 .AND. SIGMAX.LT.AZSCT4(NZSPRD)) GOTO 23
      JTRIP(JMAX) = 0
      GOTO 20
C        SELECT HITS USING FIRST APPROXIMATION ROAD
   23 N = 0
      SIGMAZ = 0.
      I = 0
      DO 26 J=1,NTRIP
      IF(JTRIP(J).EQ.0) GOTO 26
      IF(JTRIP(J).LE.I) GOTO 24
      I = JTRIP(J)
      N = N + 1
      DZ = Z(I) - Z0 - S(I)*TANL
      SIGMAZ = SIGMAZ + DZ**2
      IF(NMULT.EQ.1) GOTO 26
   24 IF(JTRIP(J)+1.LE.I) GOTO 25
      I = JTRIP(J) + 1
      N = N + 1
      DZ = Z(I) - Z0 - S(I)*TANL
      SIGMAZ = SIGMAZ + DZ**2
      IF(NMULT.EQ.2) GOTO 26
   25 I = JTRIP(J) + 2
      N = N + 1
      DZ = Z(I) - Z0 - S(I)*TANL
      SIGMAZ = SIGMAZ + DZ**2
   26 CONTINUE
      SIGMAZ = SQRT(SIGMAZ/(N-2))
      DO 27 J=1,NHIT
      IF(IZB(J).EQ.0) GOTO 27
      DZ = ABS(Z(J)-Z0-S(J)*TANL)
      IF(DZ.GT.2.*SIGMAZ) IZB(J)=0
   27 CONTINUE
C        FINAL PARAMETERS FOR Z = Z0 + S*TANL
C        WEIGHTED WITH PULSEHEIGHT
   40 N = 0
      SN = 0.
      SS = 0.
      SZ = 0.
      SS2 = 0.
      SZ2 = 0.
      SSZ = 0.
      SMIN = 1000.
      SMAX = 0.
      DO 41 J=1,NHIT
      IF(IZB(J).EQ.0) GOTO 41
      IZB(J) = IABS(IZB(J))
      N = N + 1
      SSJ = S(J)
      SZJ = Z(J)
      SGJ = G(J)
      SN = SN + SGJ
      SS = SS + SSJ*SGJ
      SZ = SZ + SZJ*SGJ
      SS2 = SS2 + SSJ**2*SGJ
      SZ2 = SZ2 + SZJ**2*SGJ
      SSZ = SSZ + SSJ*SZJ*SGJ
      IF(S(J).LT.SMIN) SMIN=S(J)
      IF(S(J).GT.SMAX) SMAX=S(J)
C     ITR(N) = J
   41 CONTINUE
      IF(N.LT.3) GOTO 100
      D = SN*SS2 - SS**2
      ZZ = (SZ*SS2-SS*SSZ) / D
      TT = (SN*SSZ-SS*SZ) / D
      SIGMAZ = (SZ2-ZZ*SZ-TT*SSZ) / SN
      IF(SIGMAZ.LT.0.) SIGMAZ=0.
      SIGMAZ = SQRT(SIGMAZ)
      Z0 = ZZ
      TANL = TT
      ZMIN = Z0 + SMIN*TANL
      ZMAX = Z0 + SMAX*TANL
C     PRINT 102, N,Z0,TANL,SIGMAZ
C 102 FORMAT(I5,4F10.1)
C     PRINT 103, (ITR(I),I=1,N)
C 103 FORMAT(40I3)
C
  100 RETURN
      END

C   01/11/84 807241300  MEMBER NAME  DRAWBP   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE DRAWBP( IVIEW , VTXCHR )
C-----------------------------------------------------------------------
C
C    AUTHOR:   C. BOWDERY    26/04/84 :  DRAW BEAM PIPE    (FROM JADISP)
C
C       MOD:   C. BOWDERY    27/06/84 :  VTXCHR IS AN ARGUMENT NOW
C       MOD:   J. HAGEMANN   09/10/84 :  HATCH BEAM PIPE ON SCREEN
C LAST  MOD:   J. HAGEMANN   14/02/86 :  DRAW CHAMBER IN TRUE POSITION
C                                        RELATIVE TO THE ORIGIN
C
C
C     THE BEAM PIPE DRAWN DEPENDS ON THE EVENT DATE. VTXCHR IS .TRUE.
C     IF THE NEW, SMALLER PIPE IS TO BE DRAWN.
C       IVIEW = 1  :  R PHI VIEW
C       IVIEW = 2  :  RZ VIEWS
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      LOGICAL  VTXCHR, DSPDTM
C
#include "cgeo1.for"
#include "cgraph.for"
#include "cgeov.for"
#include "mvccal.for"
C
      COMMON / CHEADR / HEAD(108)
      COMMON / CGRAP2 / BCMD,DSPDTM(30),ISTVW,JTVW
      COMMON / CHATCH / IHAT
C
C-----------------  C O D E  -------------------------------------------
C
C                            DETERMINE INNER AND OUTER RADII
C
C                                RPIP(V)  = INNER RADIUS
C                                DRPIP(V) = THICKNESS OF PIPE
C
      XDEV = 0.0
      YDEV = 0.0
      IHAT = 0
      RADIN  = RPIP
      RADOUT = RPIP + DRPIP
      IF( .NOT. VTXCHR ) GO TO 111
C                            LOAD CONSTANTS FOR RELATIVE POSITION
         RADIN  = RPIPV
         RADOUT = RPIPV + DRPIPV
         IF( HEAD(18) .LE. 100 ) GO TO 111
         XDEV = VDX
         YDEV = VDY
         IHAT = 1
C
  111 GO TO ( 1 , 2 ) , IVIEW
C
C                            R PHI VIEW
C
C                            CALCULATE NUMBER OF LINES TO DRAW A CIRCLE
C
   1  DDD   = 10.24 * 25.4 / ( XMAX - XMIN )
      NN     = 25.0 * 15.0 * DDD
      IF( NN .LT. 40 ) NN = 40
C
C                            DRAW INNER AND OUTER SURFACES OF BEAM PIPE
C
      CALL PLYGON( NN, RADIN , -XDEV, YDEV, 0 )
      CALL PLYGON( NN, RADOUT, -XDEV, YDEV, 0 )
C
C                            HATCH BEAM PIPE IF CDTL 45 ON
C
      IF( DSPDTM(15) )
     +       CALL DRHATC( IVIEW, 144, RADIN, RADOUT, 0., 0. )
      IHAT = 0
      RETURN
C
C                            RZ VIEWS
C
   2  CALL DRAMOV(ZENDMI, RADIN, ZENDPL, RADIN, 0)
      CALL DRAMOV(ZENDMI,-RADIN, ZENDPL,-RADIN, 0)
      CALL DRAMOV(ZENDMI, RADOUT,ZENDPL, RADOUT,0)
      CALL DRAMOV(ZENDMI,-RADOUT,ZENDPL,-RADOUT,0)
C
C                            HATCH BEAM PIPE IF CDTL 45 ON
C
      IF( .NOT. DSPDTM(15) ) RETURN
      CALL DRHATC(IVIEW, 250, RADIN, RADOUT, ZENDMI, ZENDPL)
      CALL DRHATC(IVIEW, 250,-RADIN,-RADOUT, ZENDMI, ZENDPL)
      RETURN
      END

C   14/05/84 510232119  MEMBER NAME  TAGCHK   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE TAGCHK(IPHTGM,IPHTGP)
C-----------------------------------------------------------------------
C
C   AUTHOR:      ?      PREHISTORY :  TAGGING SYSTEM COMPUTATIONS
C
C        MOD: J. OLSSON    6/10/83 :
C        MOD: A. FINCH    12/03/84 :  TO CONFORM WITH TAGGING CHANGES
C   LAST MOD: J. NYE      14/05/84 :  INITIALIZE CAPSUMS  TO ZERO
C   LAST MOD: J. OLSSON   23/10/85 :  MONTE CARLO PEDESTALS PROPER
C
C
C
C        COMPUTE ENERGY SUMS FOR FORWARD TAGGING LEADGLASS
C        IPHTGM,IPHTGP ARE MINUS AND PLUS Z CAPSUMS
C        SUBTRACT STANDARD PEDESTAL OF 500 COUNTS, APPLY STANDARD
C        CALIBRATION FACTOR OF 5 MEV / COUNT
C        AFTER RUN 2782, PEDESTAL IS 50 COUNTS, CALIBR. FACTOR 7.5
C
C        FOR 1981 - 82 LEADGLASS, USE CALIBRATION FROM A.FINCH
C        FOR 1983 - ..            USE CALIBRATION FROM FINCH....
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER * 2 (H)
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C
C------------ C O M M O N    C W O R K   F O R   T A G A N -------------
C
C
       COMMON/CWORK/MARK,IFLMRK,IMC,NCLST,NNEI,
     *              ISTMZ,ISTPZ,IENDMZ,IENDPZ,
     *              SIGX,SIGY,SIGEN,
     *              CAND(3),CLUS(9,2),CMAP(10,9),
     *              SADC(32,2),CATAG(192)
C
C
C CWORK - WORKSPACE USED ONLY ONCE PER EVENT FOR INTERNAL PROCESSING
C ==================================================================
C
C MARK   ->  WHICH 'MARK' OF TAGGER - 1 = 1981,2
C                                   - 2 = 1983 ONWARDS
C
C IFLMRK ->  SET TO '1' BY TAGMRK
C
C IMC    ->  SET TO '1' BY TAGMRK IF MC DATA
C
C CATAG  ->  CONTAINS THE ADC CONTENTS UNPACKED FROM ATAG
C
C SADC   ->  COMMON FOR ADC'S AFTER SORTING  (SORT 1)
C
C CMAP(I,1...9) ->  ADDRESS OF ADC'S IN CLUSTER I,SORT23 PUTS THESE IN
C                   ORDER OF ENERGY.
C
C CAND(3) ->  X, Y, AND ENERGY OF A FOUND CLUSTER IN AFTER CLSPS
C
C SIGX,SIGY,SIGEN ->  ERROR ON X, Y, AND ENERGY AFTER CLSPS
C
C CLUS(9,2) ->  ADC ADDRESS AND CONTENTS OF CLUSTERS - SORTED BY ENERGY
C
C NCLST   ->  NUMBER OF CLUSTERS THIS END
C ISTMZ   ->  POINTER TO START OF -Z DATA IN CATAG ( ALWAYS  1       )
C ISTPZ   ->  POINTER TO START OF +Z DATA IN CATAG ( EITHER 33 OR 25 )
C IENDMZ  ->  POINTER TO   END OF -Z DATA IN CATAG ( EITHER 32 OR 24 )
C IENDPZ  ->  POINTER TO   END OF +Z DATA IN CATAG ( EITHER 64 OR 48 )
C
C A.J.FINCH 24/2/84
C MODIFIED 12/3/84 CATAG PUT TO END AND INCREASED TO 192
C  TO ALLOW IT TO BE USED FOR 1979,80 TAGGER IN GRAPHICS
C LAST MOD : J. NYE  30/05/84  RE-ORGANIZED INCLUDING IFLMRK
C
C
C-----------------------------------------------------------------------
C
      COMMON / CHEADR / HEAD(108)
C
      DIMENSION NPBPED(3 ) ,CALTAG(3)
C
      DATA NPBPED /500,50,0/, CALTAG /5.,7.5,5.5/
C
C------------------ C O D E ------------------------------------------
C
C
C---                                     INITIALIZATION
C
C
      PPHM = 0.0
      PPHP = 0.0
      CALL TAGINT(*300)
      IPNTR = IDATA( IBLN( 'ATAG' ) )
      IF ( IPNTR .LT. 1 ) GOTO 300
      IF ( MARK .GT. 0 ) GOTO 1919
C
C
C----------------------------------------1979/80 APPARATUS ONLY---------
C
C
C ENTER HERE FOR 1979 - 80 VERSION OF THE TAGGING APPARATUS
C
      IRUN = 1
      IF ( HEAD(18) .GT. 2781 ) IRUN = 2
      IF ( IMC.EQ.1 ) IRUN = 3
      IADD = 2 * IPNTR + 6
      IFLUMI = IADD + HDATA(IADD - 1)
C
200   IADD = IADD + 1
      IF ( IADD .GE. IFLUMI ) GOTO 300
      NB = HDATA(IADD)
      IADD = IADD + 1
      IF ( NB .EQ. 0 ) GOTO 200
      IF ( NB .GT.  46 .AND. NB .LT.  49 ) GOTO 200
      IF ( NB .GT.  94 .AND. NB .LT.  97 ) GOTO 200
      IF ( NB .GT. 142 .AND. NB .LT. 145 ) GOTO 200
      IF ( NB .GT. 190 ) GOTO 300
      HPH = HDATA(IADD)
      HPH = HPH - NPBPED(IRUN)
      IF ( HPH .LT. 0 ) GOTO 200
      PPH = CALTAG(IRUN) * HPH
      IF ( NB .LE. 96 ) PPHM = PPHM + PPH
      IF ( NB .GT. 96 ) PPHP = PPHP + PPH
      GOTO 200
C
C
C----------------------------------------1981--> APPARATUS ONLY---------
C
C
C
C
C  ENTER HERE FOR 1981 - .. APPARATUS
C
1919  CONTINUE
      CALL TAGADC(0,*300)
      CALL TAGPED
      CALL TAGKAL(0)
      CALL TAGSUM(-1,PPHM,*299)
299   CALL TAGSUM(+1,PPHP,*300)
300   IPHTGM = PPHM
      IPHTGP = PPHP
      RETURN
      END

C   11/07/79 C9071601   MEMBER NAME  ZBOS11   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------A
C
C     APPPENDIX A.   THE SBOS - SYSTEM
C
C
C     THE SBOS SYSTEM IS A SMALL SYSTEM FOR MEMORY MANAGEMENT.
C     IT CONSISTS OF TEN SUBROUTINES WITH A TOTAL LENGTH BELOW
C     10 K BYTES. NO MULTIPLE ENTRIES OR MULTIPLE RETURNS ARE
C     USED. ALL ENTRIES ARE FULLY COMPATIBLE WITH THE BOS SYSTEM.
C     THE SBOS SYSTEM CONTAINS ALL BASIC FUNCTIONS OF THE BOS
C     SYSTEM INCLUDING INPUT AND OUTPUT OF S-TYPE RECORDS.
C     SOME OF THE SUBPROGRAMS ARE IDENTICAL TO THE BOS SYSTEM.
C     THE ADDITIONAL SUBPROGRAMS MAY ALSO BE USED IN THE BOS
C     SYSTEM. ALL BOS SYSTEM SUBPROGRAMS MAY BE USED WITHIN THE
C     SBOS SYSTEM, HOWEVER, BECAUSE OF THE USE OF MULTIPLE ENTRIES
C     IN SOME BOS SUBPROGRAMS EVENTUALLY EXTERNAL STATEMENTS ARE
C     NECESSARY, IF THE MAIN ENTRY IS NOT USED OTHERWISE.
C
C     BASIC ELEMENTS FOR THE MEMORY MANAGEMENT IN THE SBOS AND
C     BOS SYSTEMS ARE SO CALLED BANKS. A BANK HAS TWO IDENTIFIERS
C     NA AND NR, CALLED NAME AND NUMBER, AND A DATA PART OF VARIABLE
C     LENGTH. NORMALLY THE IDENTIFIER NA CONSISTS OF FOUR
C     CHARACTERS, WHILE IDENTIFIER NR IS AN INTEGER.
C
C     ALL BANKS ARE STORED IN A SINGLE COMMON/BCS/IW(NSPACE).
C     AN INDEX IND IS ASSIGNED TO EACH BANK, WHERE IW(IND)=NW
C     CONTAINS THE NUMBER OF DATA WORDS IN THAT BANK. DATA
C     ARE STORED IN IW(IND+1) TO IW(IND+NW). IN ADDITION
C     THERE ARE THREE WORDS CONTAINING NAME, NUMBER AND A
C     POINTER ACCORDING TO THE FOLLOWING SCHEMA.
C
C              I      IW(I)
C          --------   -------------------------------------
C          IND -  3   NA (NAME)
C          IND -  2   NR (NUMBER)
C          IND -  1   POINTER TO NEXT BANK OF SAME NAME
C                     -------------------------------------
C          IND        NW = NUMBER OF DATA WORDS IN THE BANK
C                     -------------------------------------
C          IND +  1   DATA WORD 1
C          IND +  2   DATA WORD 2
C          ...        ...
C          IND + NW   DATA WORD NW
C          --------   -------------------------------------
C
C     NO LIMITATIONS EXIST FOR THE LENGTH OF A SINGLE BANK OR
C     THE NUMBER OF BANKS, EXCEPT FOR THE TOTAL LENGTH OF
C     ALL BANKS AND FOR THE NUMBER OF DIFFERENT NAMES.
C     FOR MORE DETAILS OF THE SYSTEM, CONSULT THE MANUAL OF
C     THE BOS SYSTEM.
C
C
C
C
C     THE SBOS SYSTEM CONSISTS OF THE FOLLOWING NINE SUBPROGRAMS
C
C      1.   SUBROUTINE   BENT   AND SUBROUTINE BDMPA
C      2.   FUNCTION     ILOC
C      3.   FUNCTION     IBLN
C      4.   SUBROUTINE   BMLT
C      5.   SUBROUTINE   BLST
C      6.   SUBROUTINE   BDLM
C      7.   SUBROUTINE   BGAR
C      8.   SUBROUTINE   BSIN
C      9.   SUBROUTINE   BOUT
C      +    ENTRIES      VZERO, UCOPY, UCOPY2
C
C
C
C
C     A.1   INITIALIZATION
C     ------------------
C
C     INITIALIZATION IS DONE BY THE FOLLOWING STATEMENTS.
C
C     COMMON/BCS/IW(NSPACE)
C     REAL RW(NSPACE)
C     EQUIVALENCE (IW(1),RW(1))
C        WHERE NSPACE = INTEGER CONSTANT
C
C     CALL BENT(NSPACE,NADD,NNA,NNL)
C
C
C        WHERE NADD  = NR OF WORDS FOR LOW PRIORITY BANKS
C                      (DEFAULT IS 10 PERCENT OF NSPACE)
C              NNA   = MAX. NR OF DIFFERENT NAMES      (DEFAULT 100)
C              NNL   = MAX. NR OF ENTRIES IN LISTS     (DEFAULT 100)
C
C
C
C     THE DEFAULT VALUES ARE USED, IF THE ARGUMENTS ARE ZERO.
C     IF SUBPROGRAMS OF THE SBOS AND OF THE BOS SYSTEM ARE USED,
C     EITHER BINT OR BENT HAS TO BE CALLED FOR INITIALIZATION.
C     IF ERROR CONDITIONS E.G. ILLEGAL VALUES OF POINTERS ARE
C     DETECTED, THE PROGRAM STOPS.
C         STOP 1   ILLEGAL POINTER DETECTED DURING GARBAGE COLLECTION
C         STOP 2   MORE THAN NNA NAMES USED
C         STOP 3   MORE THAN NNL NAMES USED IN LISTS
C         STOP 4   UNKNOWN CONDITION
C
C
C     BANKS WITH NAMES, WHERE THE FOURTH CHARACTER IS A '*',
C     E.G. 'HST*', ARE CONSIDERED AS BANKS OF LOW PRIORITY.
C     THEY CAN ONLY BE CREATED UP TO A TOTAL AMOUNT OF
C     NADD WORDS.
C
C
C
C     ABOUT 5*NNA + 3*NNL WORDS IN THE COMMON/BCS/ ARE USED FOR
C     INTERNAL TABLES ( 801 WORDS FOR DEFAULT VALUES). BANKS ARE
C     STORED INTO THE COMMON BEGINNING WITH WORD IW(NNA+1).
C
C     IN THE FOLLOWING ARGUMENTS OF SUBPROGRAMS, WHICH ARE CHANGED
C     BY THE CALLED PROGRAM, ARE INDICATED BY A LINE BELOW THE ARGUMENT.
C
C
C
C     A.2   FUNCTION ILOC
C     -----------------
C
C     THIS FUNCTION PERFORMS DIFFERENT OPERATIONS, DESCRIBED BELOW.
C
C
C     2.1    IND=ILOC(NA,NR,NW)    CREATION OF BANK (NA,NR) WITH
C                                  NW DATA WORDS. IF THE BANK IS
C                                  ALREADY EXISTING, THE LENGTH IS
C                                  CHANGED TO THE GIVEN VALUE,
C                                  ADDITIONAL VALUES ARE SET TO 0.
C                                  IND=0, IF INSUFFICIENT SPACE.
C
C     /SBOS/ IND=ILOC(NA,NR,NW)    /BOS/ CALL BCRE(IND,NA,NR,NW,&S1,IER)
C            IF(IND.EQ.0) GOTO S1
C
C
C     2.2    IND=ILOC(NA,NR,0)     LOCATING BANK (NA,NR). IND=0, IF
C                                  BANK NOT EXISTING.
C
C     /SBOS/ IND=ILOC(NA,NR,0)     /BOS/ CALL BLOC(IND,NA,NR,&S1)
C            IF(IND.EQ.0) GOTO S1
C
C
C     2.3    IND=ILOC(NA,NR,-1)    DELETE BANK (NA,NR). IND=0, IF BANK
C                                  NOT EXISTING, OTHERWISE IND = LAST
C                                  INDEX OF BANK, HOWEVER IW(IND) IS
C                                  CHANGED TO -(NW+4).
C
C     /SBOS/ IND=ILOC(NA,NR,-1)    /BOS/ CALL BDLS(NA,NR)
C
C
C     2.4    IND=ILOC(NA,NR,-2)    DELETE BANK (NA,NR) AND DO GARBAGE
C                                  COLLECTION, BUT NOT IN THE REGION
C                                  BEFORE THE DELETED BANK.
C
C
C     2.5    IND=ILOC(NA,NR,-3)    MOVE BANK (NA,NR) TO THE END. IND=0,
C                                  IF INSUFFICIENT SPACE.
C
C     /SBOS/ IND=ILOC(NA,NR,-3)    /BOS/ CALL BLOC(IND,NA,NR,&1)
C            IF(IND.EQ.0) GOTO S1        CALL BCHM(IND,0,IER)
C                                        IF(IER.NE.0) GOTO S1
C
C
C     2.6    IND=ILOC(NA,NR,-4)    CHANGE THE NAME AND NUMBER OF THE
C                                  BANK OF THE PREVIOUS CALL OF ILOC
C                                  TO NA AND NR, RESP. IND=0 IN CASE
C                                  OF AN ERROR (BANK NOT EXISTING OR
C                                  NEW NAME,NR ALREADY IN USE).
C
C     /SBOS/ IND=ILOC(NA1,NR1,0)   /BOS/ CALL BRNM(NA1,NR1,NA2,NR2)
C            IND=ILOC(NA2,NR2,-4)
C
C
C     2.7    IND=ILOC(0,0,0)       OBTAIN INDEX OF UNUSED SPACE BEHIND
C                                  BANKS. THE LENGTH OF THE UNUSED SPACE
C                                  IS STORED IN IW(IND)=NUS. (THERE IS
C                                  ENOUGH SPACE TO CREATE A BANK OF UP
C                                  TO NUS WORDS).
C
C
C
C
C     A.3   FUNCTION IBLN
C     -----------------
C
C     THE VALUE OF THE FUNCTION IBLN(NA) WITH NAME NA IS THE INDEX I
C     CORRESPONDING TO THIS NAME. IW(I) WILL CONTAIN THE INDEX OF THE
C     FIRST BANK OF THE GIVEN NAME.
C                                  /BOS/ IDENTICAL
C
C
C     3.1    IND=IW(IBLN(NA))      OBTAIN INDEX IND OF THE FIRST BANK
C                                  WITH THE NAME NA. IND=0, IF NO BANK
C                                  BANK OF THE NAME EXISTS.
C
C
C     3.2    IND=1+IBLN(NA)        INITIALIZATION OF A LOOP, SEE BELOW.
C
C     /SBOS/ IND=1+IBLN(NA)        /BOS/ CALL BPOS(NA)
C         S1 IND=IW(IND-1)            S1 CALL BNXT(IND,&S2)
C            IF(IND.EQ.0) GOTO S2        . . .
C            . . .                       . . .
C            GOTO S1                     GOTO S1
C         S2 . . .                    S2 . . .
C
C
C
C
C     A.4   SUBROUTINE BMLT
C     -------------------
C
C     4.1    CALL BMLT(NL,LIST)    DEFINE LIST(1) . . . LIST(NL) TO BE
C                                  THE CURRENT LIST.
C                                  /BOS/ IDENTICAL
C
C
C     4.2    CALL BMLT(-1,0)       ALL NAMES OF THE SPECIAL LIST ARE
C                                  DEFINED AS THE CURRENT LIST.
C
C     /SBOS/ CALL BMLT(-1,0)       /BOS/ CALL BSLT
C
C
C     4.3    CALL BMLT(-1,1)       ALL NAMES OF THE SPECIAL LIST WITH
C                                  MARKER=1 ARE DEFINED AS THE CURRENT
C                                  LIST.
C
C     /SBOS/ CALL BMLT(-1,1)       /BOS/ CALL BSLW
C
C
C
C
C     A.5   SUBROUTINE BLST
C     -------------------
C
C     5.1 CALL BLST(NL,LIST,0)     THE NAMES LIST(1) . . . LIST(NL) ARE
C                                  ADDED TO THE SPECIAL LIST WITH
C                                  MARKER=0.
C     /SBOS/ CALL BLST(NL,LIST,0)  /BOS/ CALL BSAT(NL,LIST)
C
C
C     5.2 CALL BLST(NL,LIST,1)     THE NAMES LIST(1) . . . LIST(NL) ARE
C                                  ADDED TO THE SPECIAL LIST WITH
C                                  MARKER=1.
C
C     /SBOS/ CALL BLST(NL,LIST,1)  /BOS/ CALL BSAW(NL,LIST)
C
C
C     5.3    CALL BLST(NL,LIST,-1) THE NAMES LIST(1) . . . LIST(NL) ARE
C                                  DELETED FROM THE SPECIAL LIST.
C
C     /SBOS/ CALL BLST(NL,LIST,-1) /BOS/ CALL BSAD(NL,LIST)
C
C
C     5.4    CALL BLST(0,0,-1)     THE SPECIAL LIST IS CLEARED.
C
C     /SBOS/ CALL BLST(0,0,-1)     /BOS/ CALL BSAC
C
C
C     5.5    CALL BLST(NL,LIST,ND) THE NAMES OF THE CURRENT LIST ARE
C                      --          STORED IN THE USER ARRAY LIST( ),
C                                  WHERE ND IS THE DIMENSION OF LIST( ).
C                                  ND GREATER THAN 1. UP TO ND NAMES
C                                  ARE STORED.
C
C     /SBOS/ CALL BLST(NL,LIST,ND) /BOS/ CALL BMRT(NL,LIST,ND)
C
C
C
C
C     A.6  SUBROUTINE BDLM
C     ------------------
C
C     6.1 CALL BDLM                ALL BANKS OF THE CURRENT LIST ARE
C                                  DELETED.
C                                  /BOS/ IDENTICAL
C
C
C
C
C     A.7  SUBROUTINE BGAR
C     ------------------
C
C     7.1 CALL BGAR(IGA)           THE ACTIVE (NOT DELETED) BANKS ARE
C                   ---            SHIFTED TO THE BEGIN OF THE BANK
C                                  SPACE. IGA=0, IF NO BANKS WERE
C                                  DELETED.
C                                  /BOS/ IDENTICAL
C
C
C
C     A.8  SUBROUTINE BSIN
C     ------------------
C
C     THIS SUBROUTINE IS TO BE USED, IF BANK RECORDS OF TYPE S ARE
C     TO BE READ. THE ACTUAL READ STATEMENT TO READ A RECORD HAS TO
C     BE GIVEN IN THE USER PROGRAM, THE RECORD HAS TO BE STORED
C     AT THE BEGIN OF THE FREE SPACE OF THE COMMON/BCS/. THEN SUBROU-
C     TINE BSIN HAS TO BE CALLED, TO ACCEPT THE BANKS OF THE RECORD,
C     I.E. TO DEFINE THE POINTERS.
C
C     8.1 CALL BSIN(NRW,ICD)       THE BANKS OF THE RECORD WITH NRW
C                       ---        WORDS, READ INTO THE UNUSED BANKSPACE
C                                  IS ACCEPTED. ICD IS AN ERROR CODE.
C                                  ICD=1  RECORD LENGTH LESS THAN 4
C                                  ICD=2  BANK LENGTH NEGATIVE
C                                  ICD=3  BANK LENGTH TOO LARGE
C                                  ICD=4  WRONG ORDER IN BANK NRS
C                                  ICD=5  WRONG RECORD END
C
C     EXAMPLE
C
C     IND=ILOC(0,0,0)              SUBROUTINE FREAD(IUN,NTOT,BIN,*,*)
C     CALL FREAD(IUN,NRW,          REAL BIN(NTOT)
C                IW(IND),&S1,&S2)  READ(IUN,ERR=1,END=2) NTOT,BIN
C     CALL BSIN(NRW,ICD)           RETURN
C     IF(ICD.NE.0) GOTO S1       1 RETURN 1
C                                2 RETURN 2
C                                  END
C
C
C
C
C     A.9   SUBROUTINE BOUT
C     -------------------
C
C     THIS SUBROUTINE IS TO BE USED, IF BANK RECORDS OF TYPE S ARE
C     TO BE WRITTEN. THE SUBROUTINE BGAR IS CALLED INTERNALLY.
C
C
C     9.1   CALL BOUT(NRW,INIW)    ALL BANKS BELONGING TO THE CURRENT
C                     --- ----     LIST ARE ARRANGED IN CONTIGUOUS
C                                  BANK SPACE. THE ACTUAL WRITESTATEMENT
C                                  SHOULD WRITE A RECORD, CONSISTING OF
C                                  THE WORD NRW (LENGTH), FOLLOWED BY
C                                  THE NRW WORDS IW(INIW), IW(INIW+1)
C                                  . . . IW(INIW+NRW-1).
C                                  NRW=0 IF NO BANKS.
C
C     EXAMPLE
C
C     DEFINE CURRENT LIST          SUBROUTINE FWRITE(IUN,NTOT,BIN)
C     CALL BOUT(NRW,INIW)          REAL BIN(NTOT)
C     IF(NRW.EQ.0) GOTO S1         WRITE(IUN) NTOT,BIN
C     CALL FWRITE(IUN,NRW,         RETURN
C                IW(INIW))         END
C
C
C
C
      RETURN
      END

C   08/02/84 711301817  MEMBER NAME  IDFUN    (S)           FORTRAN
C
C----------------------------------------------------------------------
      SUBROUTINE IDFUN(HNAME,NBOK)
C----------------------------------------------------------------------
C
C   AUTHOR:   J  OLSSON      ?     :  NAME MATCH TO DESY ID
C
C        MOD: J. OLSSON   01/08/83 :  NEW NAME ADDED
C        MOD: C. BOWDERY  08/02/84 :  NEW NAME ADDED. TIDIED UP.
C        MOD: J. OLSSON   31/07/85 :  F22JMC,F22KWG,F11LUD ADDED
C        MOD: C. BOWDERY   5/08/85 :  BUG WITH JOBNAM CALL REMOVED
C        MOD: J. OLSSON    4/03/87 :  SEVERAL NEW USERS ADDED
C        MOD: J. OLSSON    5/05/87 :  SEVERAL NEW USERS ADDED
C   LAST MOD: J. OLSSON   30/11/87 :  SEVERAL NEW USERS ADDED
C
C        RETURNS A NAME CORRESPONDING TO THE TSO IDENTIFIER.
C
C   ---> ADDING A NAME REQUIRES INCREASE OF SUBARRAY AS WELL AS MAIN
C        ARRAY. ALSO CHANGE THE DO LOOP UPPER LIMIT.
C
C----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      REAL*8  RIDENT,RR(2),ARRAY(2,127),BLANK
      REAL*8  AR1(2,22),AR2(2,22),AR3(2,22)
      REAL*8  AR4(2,13),AR5(2,13),AR6(2,35)
C
      DIMENSION HNAME(4),HNAM(4)
C
      EQUIVALENCE (ARRAY(1,1),AR1(1,1)),(ARRAY(1,23),AR2(1,1))
      EQUIVALENCE (ARRAY(1,45),AR3(1,1)),(HNAM(1),RIDENT)
      EQUIVALENCE (ARRAY(1,67),AR4(1,1))
      EQUIVALENCE (ARRAY(1,80),AR5(1,1))
      EQUIVALENCE (ARRAY(1,93),AR6(1,1))
C
      DATA AR1 /'F11BAR  ','WULFRIN ','F11OLS  ','MASTER  ',
     $'F11PST  ','PETER   ','F11GOD  ','MALCOLM ','F11DIT  ','PETER   ',
     $'F11DRU  ','HERBIE  ','F11HEI  ','GOETZ   ','F11DIE  ','GERHARD ',
     $'F11PEA  ','GEOFF   ','F11LHO  ','MASTER  ','F11HEU  ','ROLF    ',
     $'F11HUG  ','GARETH  ','F11MEI  ','K-HEINZ ','F11RIE  ','HANS    ',
     $'F11WAG  ','ALBRECHT','F11NOZ  ','TADAO   ','F11BEK  ','LUTZ    ',
     $'F11JVK  ','JUERGEN ','F22FEL  ','ROLF    ','F11HEL  ','KARL-H. ',
     $'F22ORI  ','SHUJI   ','F22KIN  ','BARRY   '/
C
      DATA AR2 /'F22ELS  ','ECKHARDT','F22RAE  ','RALPH   ',
     $'F22HAI  ','DIETER  ','F22HAS  ','JOHN    ','F22KOB  ','TOMIO   ',
     $'F22MCC  ','HUGH    ','F22MAR  ','ROBIN   ','F22MIN  ','MAKOTO  ',
     $'F22NAR  ','BEATE   ','F22MIL  ','HOWARD  ','F22PET  ','ALFRED  ',
     $'F22HAY  ','HARRY   ','F22SUD  ','TEROHIRO','F22TAK  ','HIROSHI ',
     $'F22TOT  ','YOJI    ','F22VAL  ','KLAUS   ','F22PWA  ','PETER   ',
     $'F22WAT  ','YASUSHI ','F22WEB  ','GUSTAV  ','F22HOW  ','HENNING ',
     $'F22COD  ','DIETER  ','F22YAM  ','SAKUE   '/
C
      DATA AR3 /'F22MUR  ','PAUL    ','F22YNG  ','CHIAKI  ',
     $'F22NOZ  ','MITSUAKI','F22BEL  ','SANDY   ','F22RJB  ','ROGER   ',
     $'F22SAT  ','ASAO    ','F22KOM  ','SACHIO  ','F22BAL  ','AUSTIN  ',
     $'F11BET  ','SIEGFRID','F22DUE  ','IAN     ','F22DWH  ','DIETER  ',
     $'F22HAG  ','JOERG   ','F22KAW  ','SETSUYA ','F22HIL  ','CORNELIA',
     $'F22WEN  ','HORST   ','F22FKL  ','FREDERIC','F22FOS  ','FRANK   ',
     $'F22ROW  ','PHILIP  ','F22GLE  ','IAN     ','F22KAN  ','JUNICHI ',
     $'F22RAM  ','RAINER  ','F22ODA  ','SHIGERU '/
C
      DATA AR4 /'F22BOW  ','MASTER  ','F22BAM  ','GARY    ',
     $'F11DIK  ','ANDREAS ','F11KUH  ','MICHAEL ','F22CHR  ','JOHN    ',
     $'F22SMN  ','HOLGER  ','F22SNE  ','UWE     ','F11WIE  ','WALTER  ',
     $'F22TKE  ','TOHRU   ','F22RIP  ','MICHAEL ','F22KMT  ','TATSUO  ',
     $'F22KAD  ','HENNING ','F11HAG  ','THOMAS  '/
C
      DATA AR5 /'F22FIN  ','ALEXANDR','F32KNI  ','GERHARD ',
     $'F32GTZ  ','GUS     ','F22HEM  ','HOWARD  ','F22JTB  ','JOHN    ',
     $'F22KLE  ','CLAUS   ','F11LAU  ','PETRI   ','F11AMB  ','KARL    ',
     $'F11SPI  ','JOSZEF  ','F32JAS  ','ARTHUR  ','F32SKA  ','JOHN    ',
     $'F32BOB  ','ROBERT  ','F32RGG  ','ROBERT  '/
C
      DATA AR6 /'F32GLA  ','ROBERT  ','F32KNA  ','GERHARD ',
     $'F32GUS  ','GUS     ','F32KNE  ','GERHARD ','F32DSD  ','DIETHARD',
     $'F32BSZ  ','GUS     ','F32HJU  ','HEINRICH','F32SKM  ','J-ARTHUR',
     $'F32WAG  ','STEVE   ','F22PAU  ','PAUL    ','F22GRE  ','TIM     ',
     $'F22COR  ','DIETER  ','F22SAU  ','CORNELIA','F11BOC  ','        ',
     $'F22NYE  ','JOHN    ','F22CAR  ','SUSAN   ','F22MID  ','ROBIN   ',
     $'F22DAV  ','PETE    ','F11MAG  ','NORBERT ','F22JMC  ','JANE    ',
     $'F22KWG  ','KIYOTOMO','F11LUD  ','LUDEK   ','F11ZIM  ','MANFRED ',
     $'F22CHG  ','CHRIS   ','F11ECK  ','GUNTER  ','F11HOL  ','YVONNE  ',
     $'F22VIC  ','RAINER  ','F22WAL  ','IAN     ','F11PFE  ','MATHIAS ',
     $'F22HAU  ','VOLKE   ','F22PEP  ','PETER   ','F11OES  ','THORSTEN',
     $'F11PIT  ','DANIEL  ','F22WEG  ','ARMIN   ','F22SCH  ','FLORIAN '/
C
      DATA BLANK /'        '/,HBLANK/'  '/
C
C------------------  C O D E  -----------------------------------------
C
      RIDENT = BLANK
      NBOK   = 4
C
C                            JOBNAM RETURNS USERID   IN RR(1)
C                            JOBNAM RETURNS SETPNAME IN RR(2)
C
      CALL JOBNAM(RR)
C
      DO  1  I = 1,127
        IF( RR(1) .EQ. ARRAY(1,I) ) RIDENT = ARRAY(2,I)
   1  CONTINUE
C
      DO  2  I = 1,4
        HNAME(I) = HNAM(I)
        IF( HNAM(I) .NE. HBLANK ) NBOK = I
   2  CONTINUE
C
      RETURN
      END

C   28/10/81 807251829  MEMBER NAME  TRPVTX   (S)           FORTRAN
      SUBROUTINE TRPVTX(IPTR,XV,YV,RES)
C
C     EXTRAPOLATION OF TRACK TO VERTEX(XV,YV) +
C     CALCULATION OF POSITION + DIRECTION AT CLOSEST POINT
C     P. STEFFEN                                     82/08/26
C
C
C     INPUT:
C     IPTR = POINTER TO TRACK IN PATR-BANK
C     XV   = X-POSITION OF VERTEX
C     YV   = Y-POSITION OF VERTEX
C
C     OUTPUT:
C     RES(1)   : DR = DISTANCE (XV,YV)-TRACK(IPTR)
C                           +VE IF OUTSIDE CIRCLE
C                           -VE IF INSIDE CIRCLE
C     RES(2)   : X-POSITION OF CLOSEST POINT
C     RES(3)   : Y-POSITION OF CLOSEST POINT
C     RES(4)   : X-DIRECTION AT CLOSEST POINT (ONLY IN R-FI)
C     RES(5)   : Y-DIRECTION AT CLOSEST POINT (ONLY IN R-FI)
C     RES(6)   : )
C     RES(7)   : )  DIRECTION COSINES IN SPACE
C     RES(8)   : )
C     RES(9)   : PT, TRANSVERSE MOMENTUM
C     RES(10)  : P , MOMENTUM
C
C
      IMPLICIT INTEGER*2 (H)
C
      DIMENSION RES(10)
C
      DATA VLIGHT /.0299792458E-3/
C
C----------------------------------------------------------------------
C             MACRO CDATA .... BOS COMMON.
C
C             THIS MACRO ONLY DEFINES THE IDATA/HDATA/ADATA NAMES.
C             THE ACTUAL SIZE OF /BCS/ IS FIXED ON MACRO CBCSMX
C             OR BY OTHER MEANS. A DEFAULT SIZE OF 40000 IS GIVEN HERE.
C
C----------------------------------------------------------------------
C
      COMMON /BCS/ IDATA(40000)
      DIMENSION HDATA(80000),ADATA(40000),IPNT(50)
      EQUIVALENCE (HDATA(1),IDATA(1),ADATA(1)),(IPNT(1),IDATA(55))
      EQUIVALENCE (NWORD,IPNT(50))
C
C------------------------ END OF MACRO CDATA --------------------------
C
C-----------------------------------------------------------------------
C                            MACRO CGEO1 .... JADE GEOMETRY
C-----------------------------------------------------------------------
C
      COMMON / CGEO1 / BKGAUS,
     +                 RPIP,DRPIP,XRLPIP,   RBPC,DRBPC,XRLBPC,
     +                 RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     +                 R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     +                 R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     +                 RTOF,DRTOF,XRTOF,    RCOIL,DRCOIL,XRCOIL,
     +                 ZJM,DZJM,XRZJM,ZJP,DZJP,XRZJP,ZTKM,DZTKM,XRZTKM,
     +                 ZTKP,DZTKP,XRZTKP,ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     +                 XRJETC,RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,
     +                 CTLIMM,DELFI,BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     +                 XHOL1,XHOL2,YHOL1,YHOL2,BLFI
C
C------------------------- END OF MACRO CGEO1 --------------------------
C
C
      REAL*8 XC,YC,RC
C
C2001 FORMAT(' DRTRCK     :',10F10.5)
C2002 FORMAT(' DRTRCK(PAR):',11F10.5)
C2003 FORMAT(' DRTRCK(CIR):',10E13.5)
C
C                                       CURVATURE + RADIUS OF TRACK
C                                       1. POINT + DIRECTION
      X1    = ADATA(IPTR+ 5)
      Y1    = ADATA(IPTR+ 6)
      DRI   = SQRT(ADATA(IPTR+8)**2 + ADATA(IPTR+9)**2)
      DX1   = ADATA(IPTR+8) / DRI
      DY1   = ADATA(IPTR+9) / DRI
      CRV   = ADATA(IPTR+25)
      TGTH = ADATA(IPTR+30)
      CSTH  = 1. / SQRT(TGTH**2 + 1.)
      SNTH  = CSTH * TGTH
C     PRINT 2001, X1,Y1,DX1,DY1,CRV,XV,YV
C
C                                       MOMENTUM > 1.7 GEV ?
      IF(ABS(CRV).LT..00010) GOTO 200
C
C                                       CIRCLE EXTRAPOLATION
         RC    = 1. / CRV
         XC    = DY1*RC + X1
         YC    =-DX1*RC + Y1
         RC    = DABS(RC)
         RES(1)= ( ( (XV-XC)**2+(YV-YC)**2 ) / RC - RC) *.5
C     PRINT 2003, CRV,XC,YC,RC,DR

         DX      = XV - XC
         DY      = YV - YC
         ANORM   = SQRT(DX**2 + DY**2)
         DX      = DX / ANORM
         DY      = DY / ANORM
         RES( 2) =-DX * RES(1) + XV
         RES( 3) =-DY * RES(1) + YV
         RES( 4) = DY * SIGN(1.,CRV)
         RES( 5) =-DX * SIGN(1.,CRV)
C     PRINT 2003, DX,DY,(RES(I1),I1=1,5)
         GOTO 300
C
C                                       PARABOLA EXTRAPOLATION
  200 CONTINUE
         DXX     = (XV-X1)*DX1 + (YV-Y1)*DY1
         DRP     =-DXX**2 * CRV * .5
         DRO     = (YV-Y1)*DX1 - (XV-X1)*DY1
         RES( 1) = (DRO - DRP) * SIGN(1.,CRV)
C     PRINT 2002, CRV,DRP,DRO,DR,DXX
C
         RES( 2) = DXX * DX1 - DRP*DY1 + X1
         RES( 3) = DXX * DY1 + DRP*DX1 + Y1
         TG1     =-DXX*CRV
         CS1     = 1. / SQRT(1. + TG1**2)
         SN1     = TG1 * CS1
         RES( 4) = DX1*CS1 - DY1*SN1
         RES( 5) = DX1*SN1 + DY1*CS1
C     PRINT 2002, TG1,SN1,CS1,(RES(I1),I1=1,5)
C
C
  300 CONTINUE
         RES( 6) = RES(4) * CSTH
         RES( 7) = RES(5) * CSTH
         RES( 8) = SNTH
C
C                                     MOMENTUM CALCULATION
         IF(ABS(CRV).LT.1.E-8) CRV = SIGN(1.E-8,CRV)
         RES( 9) = ABS(VLIGHT*BKGAUS/CRV)
         RES(10) = RES(9) / CSTH
C     PRINT 2002, (RES(I1),I1=1,10)
C
         RETURN
C
      END

C   01/06/83 306011450  MEMBER NAME  MUFFLB   (JADEMUS1)    FORTRAN
C
C  NEW S/R   13.45  06/05/83  CHRIS BOWDERY
C
C-----------------------------------------------------------------------
      SUBROUTINE MUFFLB
C-----------------------------------------------------------------------
C
C             PROCEDURE FOR BACK-TRACKING AND SETTING-UP 1ST PART
C             FOR MUFFLE STEPS 2 AND 3.
C
C-----------------------------------------------------------------------
C
C             COMMONS
C
#include "cmufwork.for"
#include "cmuffl.for"
C
C-----------------------------------------------------------------------
C
C             PRESERVE COORDS.
C
      CALL UCOPY(X,X0,NSPECI)
      X3 = X
      Y3 = Y
      Z3 = Z
C
C             CALCULATE DISTANCE  TRAVELLED  FROM  VERTEX  (INTERACTION
C             POINT), INCLUDING CORRECTION FOR CURVATURE.
C
      D3 = SQRT(X3**2 + Y3**2 + Z3**2)
      XYCHOR = SQRT(X3**2 + Y3**2)
      D3 = D3 + (CURV**2 * XYCHOR**3 / 24.) * COSEC
C
C             BACK-TRACK.
C
      X = X3 - DCX * D3
      Y = Y3 - DCY * D3
      Z = Z3 - DCZ * D3
C
C             MAKE A STEP TO MID-POINT OF TRACK. FOR  THIS  FIRST  STEP
C             THE QUANTITIES WHICH DETERMINE  MULTIPLE  SCATTERING  AND
C             ENERGY LOSS ARE SET TO  ZERO  BECAUSE  (A)  THE  MULTIPLE
C             SCATTERING IS DETERMINED BY THE TRACK FITTING  PARAMETERS
C             AT THE MID-POINT, AND (B) THE ENERGY IS DETERMINED BY THE
C             MOMENTUM EFFECTIVELY DETERMINED AT THE MID-POINT.
C
      DSTEP  = D3 / 2.0
      GMSTEP = (GMBP + GMJETI + GMJET1 + GMJET2) * COSEC
      ABSTEP = (ABBP + ABJETI + ABJET1 + ABJET2) * COSEC
      RDSTEP = 0.0
      DESTEP = 0.0
C
      RETURN
      END

C   12/08/87 708121048  MEMBER NAME  SHWCPR   (S)           FORTRAN77
      SUBROUTINE SHWCPR(VERT,CHI22)
C
C   COPIED FROM F11HEL.ES(SHWCPR)
C
C
C     THIS SUBROUTINE COMPARES A SINGLE SHOWER PROFILE WITH
C     A CLUSTER IN THE 'LGCL' BANK
C     CLUSTER DATA HAVE TO BE STORED IN /CLDAT/ FOR THIS VERSION
C
C     INPUT  -->  VERT   =  VERTEX COORDINATES (3-DIM)
C
C     OUTPUT -->  CHI22  =  CHI**2 (RESULT OF COMPARISON)
C
C                                                    09/08/82
C     IBLIST-ERROR CORRECTED 9/8/82   16.00
C
      DIMENSION PSSF(2),IBLIST(40),BLCFRC(40),VERT(3)
      COMMON /CLDAT/ NUMBLO,NBLIST(40),ENLIST(40),IPACL,ECLCO,ECLUN,
     *               PIMP1,PIMP2
C
      DO 11 IL = 1,NUMBLO
   11 IBLIST(IL)=NBLIST(IL)
C
      PSSF(1) = PIMP1
      PSSF(2) = PIMP2
C
      CALL EXPECT(IPACL,ECLCO,PSSF,VERT,NUMBLO,IBLIST,BLCFRC,AVGSUM)
      CHI22 = 0.
      DO 12 I=1,NUMBLO
      ENEXPT = BLCFRC(I)*ECLCO
      SIGSQU = 21.6*ENLIST(I)
      STHEO2 = .25*ENEXPT**2
      CHI22 = CHI22+(ENEXPT-ENLIST(I))**2/(SIGSQU+STHEO2)
   12 CONTINUE
      RETURN
C
      END

C   24/08/85 511061959  MEMBER NAME  EVTINI0  (S)           FORTRAN
C   23/08/85            MEMBER NAME  EVTINI   (S)           FORTRAN
C   19/08/83 308251801  MEMBER NAME  EVTINI   (S)           FORTRAN
C
C-----------------------------------------------------------------------
      SUBROUTINE EVTINI
C-----------------------------------------------------------------------
C
C   AUTHOR:   E. ELSEN     05/03/79 :  INITIALISES A MONTE CARLO EVENT
C
C        MOD  E. ELSEN     05/11/81 :  FORWARD DETECTOR INITIALISED
C        MOD  J. HAGEMANN  17/01/83 :  S/R DAY2 NOW CALLED HERE ONCE PER
C             R  RAMCKE             :  EVENT, NOT FOR EVERY PARTICLE IN
C                                   :  S/R JIPATR. NEW COMMON /CDAY/
C        MOD  C. BOWDERY   19/08/83 :  EXPANDED COMMON /CWSET/.
C                                   :  HITAR(16000) I.E. 4000 HITS
C  LAST  MOD  A.FINCH      24/08/85 :  CALL TO MCTAGI INSERTED TO
C                                      INITIALISE NEW MCTAG SCHEME
C
C
C   THIS ROUTINE INITIALIZES AN EVENT BEFORE MONTE CARLO TRACKING.
C
C   IT HAS TO BE CALLED ONCE FOR EVERY EVENT BEFORE ITS PARTICLES ARE
C   TRACKED THROUGH THE DETECTOR.
C
C-----------------------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON / CLGHIT / AMPLG(3000)
      COMMON / CWSET  / NHALL, ISTART, HPCELL(98), HITAR(16000)
      COMMON / CJPATR / KPATR, IPATR(1243)
C
      COMMON / CTOFF  / ITOFAR(21)
      COMMON / CBPC   / IBPC(12)
C
      COMMON / CJTCDC / IBANK, IPART
      COMMON / CDAY   / IDAY(5)
C
C
C------------------------  C O D E  ------------------------------------
C
C                  INITIALIZE TO VECT BANK 0 AND PARTICLE 0
C
      IBANK = 0
      IPART = 0
C
C                  INITIALIZE TRACKING THROUGH LEAD GLASS
C
      DO 1 I=1,3000
    1 AMPLG(I)=0.
C
C                  INITIALIZE TRACKING THROUGH CENTRAL DETECTOR
C                            ZERO NUMBER OF HITS; 1ST FREE WORD IS #1
      NHALL  = 0
      ISTART = 1
C
C                  INITIALIZE TRACK ARRAY
C
      KPATR = 8
      CALL DAY2(IDAY)
      DO 10 I=1,8
   10 IPATR(I) = 0
      IPATR(1) = 8
      IPATR(3) = 48
C
C                  INITIALIZE HODOSCOPE COUNTER ARRAYS
C
      DO 20 I=1,21
   20 ITOFAR(I)=0
      DO 21 I=1,12
   21 IBPC(I)=0
      CALL INTTOF
C
C                  INITIALIZE FWD LG BLOCKS
C
      CALL MCTAGI
C
      RETURN
      END

C   21/11/78 C9012401   MEMBER NAME  ZBOS04   (S)           FORTRAN
      SUBROUTINE BSCOM
C     -----------------------------------------------------------------400000200
C     4.  SETS OF BANKS
C
C     SEVERAL SUBROUTINES WORK ON SET OF BANKS. THESE SETS ARE
C     DEFINED BY DEFINING A LIST OF NAMES, EVERY BANK WITH A NAME,
C     WHICH IS CONTAINED IN THE LIST, BELONGS TO THE SET OF BANKS.
C     THERE ARE TWO LISTS, ONE CALLED THE CURRENT LIST AND THE OTHER
C     THE SPECIAL LIST. THE CURRENT LIST IS USED IN THE SUBROUTINES
C            BDLM AND BDLG      TO DELETE A SET OF BANKS,
C            BPRM               TO PRINT A SET OF BANKS,
C            BWRITE ETC.        TO WRITE A SET OF BANKS (EVENT).
C
C     THE SPECIAL LIST IS DEFINED BY EACH INPUT ROUTINE, IT CONTAINS
C     AFTER THE INPUT OF ONE EVENT ALL NAMES (WITH MARKER EQUAL
C     TO 1) BELONGING TO THAT EVENT, AND IS LATER USED TO WRITE
C     THE BANKS AND TO DELETE THE BANKS. IF NEW BANKS ARE CREATED,
C     THEIR NAMES CAN BE ADDED TO THE SPECIAL LIST.
C
C
C     4.1  THE CURRENT LIST
C
C     THERE ARE THREE CALLS TO DEFINE THE CURRENT LIST.
C
C               - ----
C     CALL BMLT(N,LIST)
C
C        WHERE LIST( ) = ARRAY OF N NAMES
C
C
C
C     CALL BSLT
C
C     ALL NAMES OF THE SPECIAL LIST ARE DEFINED AS THE CURRENT LIST.
C
C
C
C     CALL BSLW
C
C     THE NAMES OF THE SPECIAL LIST WITH THE MARKER = 1 ARE DEFINED
C     AS THE CURRENT LIST.
C
C
C
C     THE LATTER TWO CALLS ARE USUALLY USED IN THE FOLLOWING
C     CONNECTION.
C
C     CALL BSLW
C     CALL BWRITE(IUN)      WRITE AN EVENT OF BANKS WITH NAMES OF
C                           THE SPECIAL LIST WITH MARKER +1.
C
C     CALL BSLT
C     CALL BDLG             DELETE ALL BANKS WITH NAMES OF THE
C                           SPECIAL LIST AND MAKE A GARBAGE
C                           COLLECTION.
C
C
C
C     THE CURRENT LIST OF NAMES CAN BE STORED IN AN USER DEFINED
C     ARRAY BY THE CALL
C
C                      -----
C     CALL BMRT(N,LIST,NLIST)
C
C        WHERE LIST( ) = ARRAY OF LENGTH NLIST
C                    N = NR OF NAMES STORED IN THE LIST
C
C     UP TO NLIST NAMES OF THE CURRENT LIST OF NAMES ARE STORED
C     INTO THE ARRAY LIST( ).
C
C
C
C     4.2  THE SPECIAL LIST
C
C
C                - ----                      - ----
C      CALL BSAT(N,LIST)           CALL BSAW(N,LIST)
C
C
C         WHERE LIST( ) = ARRAY OF N NAMES
C
C     IN BOTH CASES THE NAMES ARE ADDED TO THE SPECIAL LIST
C     (IF NOT ALREADY PRESENT), AND THE MARKER IS SET
C     =0 FOR BSAT AND =1 FOR BSAW.
C
C
C
C               - ----
C     CALL BSAD(N,LIST)
C
C     THE NAMES OF THE LIST ARE DELETED FROM THE SPECIAL LIST.
C
C
C
C
C
C     THERE ARE THREE ADDITIONAL CALLS, WHICH MAY BE USEFUL
C     UNDER SPECIAL CIRCUMSTANCES. THESE CALLS ALLOW TO CLEAR
C     THE SPECIAL LIST, TO SAVE THE SPECIAL LIST AND TO RESTORE
C     THE SAVED SPECIAL LIST.
C
C     CALL BSLC
C
C     THE SPECIAL LIST IS CLEARED (IT WILL CONTAIN NO NAMES).
C
C               --                     --
C     CALL BSLS(IS)          CALL BSLR(IS)
C
C     THE SPECIAL LIST IS SAVED BY BSLS UNDER AN ARBITARY
C     NUMBER IS. BY BSLR THE SAVED LIST IS RESTORED AS THE
C     SPECIAL LIST. THE ROUTINES USE A BANK TO STORE THE
C     SPECIAL LIST.
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C     THE CONNECTION BETWEEN THE TWO LISTS AND THE DIFFERENT
C     CALLS IS ILLUSTRATED IN THE FLOW DIAGRAM BELOW
C
C
C
C
C                        +---------------+
C                        I               I
C                        I SPECIAL LIST  I
C                        I     OF NAMES  I
C                ADDS    I               I
C        BSAW   ->->->->-I->->->-+-<-<-<-I-<-<-<-<-   INPUT ROUTINE
C                CHANGES I       |       I DEFINES
C                        I       V       I
C                        I       |       I
C                        I       V       I
C                ADDS    I       |       I
C        BSAT   ->->->->-I->-+-<-+->-+   I
C                CHANGES I   |       |   I
C                        I   V       V   I
C                        I   |       |   I
C                        +---------------+
C                            |       |
C                            V       V
C                            |       |
C
C          (USUALLY FOR    BSLT    BSLW   (USUALLY FOR
C       DELETING BANKS)                   WRITING BANKS)
C                            |       |
C                            V       V
C                            |DEFINES|
C                            V       V
C                            |       |
C                        +---------------+
C                        I               I
C                        I CURRENT LIST  I
C                        I     OF NAMES  I
C                DEFINES I               I
C        BMLT   ->->->->-I               I
C                        I               I
C                        I               I
C                        I               I
C                        +---------------+
C                                |
C                                V
C                                |
C                                V
C
C                        USED IN BPRM
C                                BDLM, BDLG
C                                OUTPUT ROUTINES
C
C
C
C
     RETURN
     END

C-------------------------------------------
C  MACRO CJTCAL .... JET CHAMBER CALIBRATION
C               ....  P. STEFFEN : 78/01/17
C-------------------------------------------
      COMMON /CJTCAL/ HJTCAL(50688)
                      INTEGER*2 HTMPED(1536), HAMCAL(8,1536,4)
                      EQUIVALENCE (HTMPED(  1),HJTCAL(   1))
     ,               ,            (HAMCAL(1,1),HJTCAL(1537))
C
C     HTMPED(IWIR)        : DRIFT TIME PEDESTAL IN UNITS OF .01
C     HAMCAL(IHIT,IWIR,J) : AMPLITUDE CALLIBRATION
C     J = 1 : AMP(-Z), IN UNITS OF 4096
C     J = 2 : PED(-Z), IN UNITS OF    1
C     J = 3 : AMP(+Z), IN UNITS OF 4096
C     J = 4 : PED(+Z), IN UNITS OF    1
C----------- END OF MACRO CJTCAL -----------

C   04/08/79 410081805  MEMBER NAME  ADDON    (JADESR)      FORTRAN
      SUBROUTINE ADDON
      IMPLICIT INTEGER*2 (H)
C---
C---  BUILDS UP LONG EVENT IN CWORK1 FROM PIECES OF SAME IN CWORK.
C---  LAST CHANGE  INTRODUCE ZETC AND BPCH
C---                                      31/07/84   W.BARTEL
C---  LAST CHANGE  INTRODUCE FAMP         08/10/84   W.BARTEL
C---
C---
#include "cdata.for"
      COMMON/CADDMS/IAERKT(10)
      COMMON/CMOADD/JETPNT(3),NMOADD(3),IMOADD(3,10)
      COMMON/CWORK /NWORK ,IWORK (10000)
      COMMON/CWORK1/NWORK1,IWORK1(10000)
      DIMENSION HWORK(20000),HWORK1(20000)
      EQUIVALENCE(IWORK (1),HWORK (1))
      EQUIVALENCE(IWORK1(1),HWORK1(1))
      DIMENSION NAME(128)
      DATA NAME/'HEAD','LATC','TRG1','TRG2','TRG3','ATST','ATBP','ATOF',
     1          'ALGL','ATAG','TAGC','JETC','MUEV','SCAL','MPRS','N50S',
     1          'FAMP','ZTRG','ZETC','BPCH','BK21','BK22','BK23','BK24',
     1          'BK25','BK26','BK27','BK28','BK29','BK30','BK31','BK32',
     1          'JETV','FADC','BK35','BK36','BK37','BK38','BK39','BK40',
     1          'BK41','BK42','BK43','BK44','BK45','BK46','BK47','BK48',
     1          'BK49','BK50','BK51','BK52','BK53','BK54','BK55','BK56',
     1          'BK57','BK58','BK59','BK60','BK61','BK62','BK63','BK64',
     1          'C065','C066','C067','C068','C069','C070','C071','C072',
     1          'C073','C074','C075','C076','C077','C078','C079','C080',
     1          'C081','C082','C083','C084','C085','C086','C087','C088',
     1          'C089','C090','C091','C092','C093','C094','C095','C096',
     1          'C097','C098','C099','C100','C101','C102','C103','C104',
     1          'C105','C106','C107','C108','C109','C110','C111','C112',
     1          'C113','C114','C115','C116','C117','C118','C119','C120',
     1          'C121','C122','C123','C124','C125','C126','C127','C128'/
      DATA LSTCDE/16/
C---
C---     NWORK1.LT.0 INDICATES THIS ROUTINE HAS ALREADY ENCOUNTERED
C---     ERROR IN TRYING TO ASSEMBLE CURRENT EVENT. JUST RETURN. EVREAD
C---     WILL CLEAR THIS NEGATIVE FLAG AT THE BEGINNING OF NEXT TRUE
C---     EVENT.
C---
      IF(NWORK1.LT.0) RETURN
C---
C---     A REASONABLE PARTIAL EVENT FROM THE NORD MUST HAVE AT LEAST A
C---     HEADER BANK WITH 15 DATA WORDS AND 4 BOS HEADER WORDS, THE
C---     BOS HEADER OF AT LEAST ONE MORE BANK AND AT LEAST ONE DATA
C---     WORD FROM THAT BANK, IN ALL 24 WORDS.
C---
      IF((NWORK.LT.24).OR.(NWORK.GT.10000)) GO TO 1001
C---
C---     IWORK MUST BEGIN WITH THE NAME OF THE HEADER BANK.
C---
      IF(IWORK(1).NE.NAME(1)) GO TO 1002
C---
C---     LOOP OVER ALL THE BOS BANKS IN CWORK. COUNT THEM, CHECK THAT
C---     THEY ALL HAVE RECOGNIZED NAMES, CHECKS THAT VARIOUS LENGTHS
C---     ARE REASONABLE AND SAVE THE POINTER TO THE LAST BANK FOR USE
C---     IN LATER CALLS TO THIS ROUTINE FOR THE SAME EVENT.
C---
      IBSUM=0
      LPNT=4
    1 CONTINUE
      NBN=IWORK(LPNT-3)
      IBNK=1
    2 CONTINUE
      IF(NBN.EQ.NAME(IBNK)) GO TO 3
      IBNK=IBNK+1
      IF(IBNK.LE.128) GO TO 2
      GO TO 1003
    3 CONTINUE
C---
C---     HAVE FOUND A RECOGNIZED BANK NAME.
C---
      IBSUM=IBSUM+1
      LENGB=IWORK(LPNT)
      IF((LENGB.LT.1).OR.((LENGB+LPNT).GT.10000)) GO TO 1004
      KPLBNK=LPNT
      LPNT=LPNT+LENGB+4
      IF(LPNT.LT.NWORK) GO TO 1
C---
C---     CHECK THAT NWORK POINTS EXACTLY TO THE END OF THE LAST DATA
C---     WORD OF THE LAST BANK.
C---
      IF(LPNT.NE.(NWORK+4)) GO TO 1005
C---
C---  CHECK THAT THERE WERE AT LEAST TWO BANKS.
C---
      IF(IBSUM.LT.2) GO TO 1006
C---
C---  IS THIS THE FIRST PIECE OF A CONTINUED EVENT?
C---
      IF(NWORK1.NE.0) GO TO 4
      IF(HWORK(23).NE.2) GO TO 1008
      IF(LSTCDE.NE.16) GO TO 1008
      LSTCDE=2
C---
C---     CLEAR COUNTERS FOR THE POSSIBLE TRAILING -1S IN THE THREE
C---     JETC BANKS
C---
      NMOADD(1)=0
      NMOADD(2)=0
      NMOADD(3)=0
C---
C---     THIS IS THE FIRST NORD PSEUDO EVENT CONTRIBUTING TO THE CURRENT
C---     TRUE EVENT. SIMPLY MOVE CWORK, HEADER AND ALL INTO CWORK1.
C---
      NWORK1=NWORK
      LMOVE=4*NWORK
      CALL MVCL(IWORK1(1),0,IWORK(1),0,LMOVE)
C---
C---     LPLBNK IS ALWAYS THE POINTER TO THE LAST BANK IN CWORK1.
C---
      LPLBNK=KPLBNK
      GO TO 7
    4 CONTINUE
      IF((HWORK(23).NE.16).AND.(HWORK(23).NE.(LSTCDE+2))) GO TO 1008
      LSTCDE=HWORK(23)
C---
C---     CURRENT NORD PSEUDO EVENT HOLDS A CONTINUATION OF THE TRUE
C---     EVENT BEING BUILT UP IN CWORK1. IT ALSO HOLDS A REPEATED
C---     HEADER BANK AND, UNLESS THE LAST BANK IN CWORK1 IS COMPLETE,
C---     THE REPEATED BOS HEADER OF THAT BANK AND A REPEATED BANK
C---     DESCRIPTOR. NOW CHECK WHETHER THE FIRST BANK AFTER THE HEADER
C---     IN CWORK HAS THE SAME BOS NAME AND NUMBER AS THE LAST BANK
C---     IN CWORK1.
C---
      LHEAD=IWORK(4)
      NNAM=IWORK(LHEAD+5)
      NNUM=IWORK(LHEAD+6)
      LNAM=IWORK1(LPLBNK-3)
      LNUM=IWORK1(LPLBNK-2)
      ISPLIT=0
      IF((NNAM.EQ.LNAM).AND.(NNUM.EQ.LNUM)) ISPLIT=1
C---     IF(ISPLIT.EQ.0) WRITE(6,200) LNAM,LNUM,NNAM,NNUM,NWORK1
  200    FORMAT('0ADDON: EVENT CONTINUED. NO SPLIT: ',A4,I4,' ',A4,I4,
     1   I8)
         IF(ISPLIT.EQ.0) GO TO 6
C---     WRITE(6,201) NNAM,NNUM,NWORK1
  201    FORMAT('0ADDON: EVENT CONTINUED. BANK SPLIT: ',A4,I4,I8)
         IF(NNAM.EQ.NAME(12)) GO TO 6
         IF((HWORK1(2*NWORK1).NE.-1).AND.(HWORK1(2*NWORK1).NE.0))
     1   GO TO 6
         WRITE(6,202) NNAM,NNUM,NWORK1
  202    FORMAT('0*****WARNING. POSSIBLE SPLIT ERROR: ',A4,I4,I8)
         CALL DUMWK1
         GO TO 2000
    6 CONTINUE
C---
C---     THE NUMBER OF WORDS TO BE ADDED TO THE EVENT BEING BUILT UP
C---     IN CWORK1 IS JUST NWORK MINUS THE LENGTH OF THE REPEATED
C---     HEADER BANK, INCLUDING ITS BOS HEADER, MINUS THE LENGTH OF
C---     THE REPEATED BOS HEADER AND BANK DESCRIPTOR OF THE LAST BANK
C---     IN CWORK1 IN CASE THAT BANK IS NOT YET COMPLETE.
C---
      NADD=NWORK-LHEAD-4-5*ISPLIT
      IF((NADD.LT.1).OR.((NADD+NWORK1).GT.10000)) GO TO 1007
C---
C---     IN CASE THE LAST BANK IN CWORK1 IS BEING CONTINUED, UPDATE ITS
C---     INTERNAL BOS LENGTH PARAMETER. SUBTRACT 1 FOR THE BANK
C---     DESCRIPTOR WORD, WHICH WILL NOT BE REPEADED.
C---
      IF(ISPLIT.EQ.1) IWORK1(LPLBNK)=IWORK1(LPLBNK)+IWORK(LHEAD+8)-1
C---
C---     MOVE THE APPROPRIATE PART OF CWORK INTO CWORK1.
C---
      LMOVE=4*NADD
      CALL MVCL(IWORK1(NWORK1+1),0,IWORK(LHEAD+5+5*ISPLIT),0,LMOVE)
      LNAW=IWORK(KPLBNK-3)
      LNUW=IWORK(KPLBNK-2)
      IF((LNAW.NE.LNAM).OR.(LNUW.NE.LNUM))
     1 LPLBNK=NWORK1+KPLBNK-LHEAD-4-5*ISPLIT
      NWORK1=NWORK1+NADD
    7 CONTINUE
      NNAM=IWORK1(LPLBNK-3)
      NNUM=IWORK1(LPLBNK-2)
      IF(NNAM.NE.NAME(12)) GO TO 5
      IF(HWORK1(2*NWORK1).NE.-1) GO TO 5
C---
C---     THERE IS A TRAILING -1 IN THE JETC BANK JUST ADDED TO CWORK1.
C---     KEEP TRACK OF IT ITS ADDRESS SO THAT IF THE SAME BANK IS
C---     LATER CONTINUED WE CAN GET IT OUT OF THE MIDDLE OF THE BANK.
C---
      IF((NNUM.LT.1).OR.(NNUM.GT.3)) GO TO 1009
      JETPNT(NNUM)=LPLBNK
      NMOADD(NNUM)=NMOADD(NNUM)+1
      NMO=NMOADD(NNUM)
      IF((NMO.LT.1).OR.(NMO.GT.10)) GO TO 1010
      IMOADD(NNUM,NMO)=2*NWORK1
    5 CONTINUE
C---
C---     IF IT IS THE LAST PIECE OF THE CURRENT EVENT WHICH HAS JUST
C---     BEEN ADDED TO CWORK1, CLEAN UP THE POSSIBLE INTERNAL -1S IN
C---     THE JETC BANKS.
C---
      IF(LSTCDE.EQ.16) CALL JETMRG
      RETURN
C---
C---     ERROR MESSAGES.
C---
 1001 CONTINUE
      IAERKT(1)=IAERKT(1)+1
      IF(IERRMS.LT.0) WRITE(6,101) NWORK
  101 FORMAT('0ADDON ERROR 1. NWORK = ',I10,//)
      GO TO 2000
 1002 CONTINUE
      IAERKT(2)=IAERKT(2)+1
      IF(IERRMS.LT.0) WRITE(6,102) IDATA(1)
  102 FORMAT('0ADDON ERROR 2. IDATA(1) = ',I10,//)
      GO TO 2000
 1003 CONTINUE
      IAERKT(3)=IAERKT(3)+1
      IF(IERRMS.LT.0) WRITE(6,103) LPNT,NBN
  103 FORMAT('0ADDON ERROR 3. LPNT, NBN = ',2I10,//)
      GO TO 2000
 1004 CONTINUE
      IAERKT(4)=IAERKT(4)+1
      IF(IERRMS.LT.0) WRITE(6,104) LPNT,LENGB
  104 FORMAT('0ADDON ERROR 4. LPNT, LENGB = ',2I10,//)
      GO TO 2000
 1005 CONTINUE
      IAERKT(5)=IAERKT(5)+1
      IF(IERRMS.LT.0) WRITE(6,105) LPNT,NWORK
  105 FORMAT('0ADDON ERROR 5. LPNT, NWORK = ',2I10,//)
      GO TO 2000
 1006 CONTINUE
      IAERKT(6)=IAERKT(6)+1
      IF(IERRMS.LT.0) WRITE(6,106) LPNT,NWORK,IBSUM
  106 FORMAT('0ADDON ERROR 6. LPNT, NWORK, IBSUM = ',3I10,//)
      GO TO 2000
 1007 CONTINUE
      IAERKT(7)=IAERKT(7)+1
      IF(IERRMS.LT.0) WRITE(6,107) NWORK1,NADD
  107 FORMAT('0ADDON ERROR 7. NWORK1, NADD = ',2I10,//)
      GO TO 2000
 1008 CONTINUE
      IAERKT(8)=IAERKT(8)+1
      IF(IERRMS.LT.0) WRITE(6,108) HWORK(18),HWORK(19),HWORK(23),LSTCDE
  108 FORMAT('0ADDON ERROR 8. RUN, EVENT, CODE, LAST CODE = ',4I8,//)
      GO TO 2000
 1009 CONTINUE
      IAERKT(9)=IAERKT(9)+1
      IF(IERRMS.LT.0) WRITE(6,109) HWORK(18),HWORK(19),NNUM
  109 FORMAT('0ADDON ERROR 9. RUN, EVENT, JETC BANK NO. = ',3I8,//)
      GO TO 2000
 1010 CONTINUE
      IAERKT(10)=IAERKT(10)+1
      IF(IERRMS.LT.0) WRITE(6,110) HWORK(18),HWORK(19),NMOADD
  110 FORMAT('0ADDON ERROR 10. RUN, EVENT, JETC BANK NO. = ',5I8,//)
 2000 CONTINUE
      IERRMS=IERRMS+1
      IF(IERRMS.LE.0) CALL DUMWK1
      IF(IERRMS.LE.0) CALL LHODMP
      NWORK1=-1
      LSTCDE=16
      RETURN
      END
      SUBROUTINE DUMWK1
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON/CWORK1/NWORK,HWORK(20000)
#include "cdata.for"
#include "cgraph.for"
C
      DATA ICALL /0/
      ICALL = ICALL + 1
      IF(ICALL.GT.0) RETURN
C
      DO 1 I=1,1
      IF(I.EQ.2) WRITE(JUSCRN,103)
      IF(I.EQ.2) WRITE(JUSCRN,103)
      IF(I.EQ.1) WRITE(JUSCRN,101)
      IF(I.EQ.2) WRITE(JUSCRN,102)
  101 FORMAT(' WORK1 EVENT:')
  102 FORMAT(' REFORMATTED EVENT:')
      WRITE(JUSCRN,103)
  103 FORMAT('  ')
      IF(I.EQ.1) LENG=2*NWORK
      IF(I.EQ.2) LENG=2*HDATA(208)
      IF((LENG.GE.1).AND.(LENG.LE.20000)) GO TO 3
      WRITE(JUSCRN,104) I,LENG
  104 FORMAT(' ILLEGAL LENGTH IN LHODMP. I, LENG=',2I10)
      GO TO 1
    3 CONTINUE
      LINES=1+(LENG-1)/20
      DO 2 LINE=1,LINES
      LIM1=20*(LINE-1)+1
      LIM2=LIM1+19
      IF(LIM2.GT.LENG) LIM2=LENG
      IF(I.EQ.1) WRITE(JUSCRN,105) LIM1,(HWORK(LHO),LHO=LIM1,LIM2)
      IF(I.EQ.2) WRITE(JUSCRN,105) LIM1,(HDATA(LHO),LHO=LIM1,LIM2)
  105 FORMAT(1X,I6,6X,20I6)
    2 CONTINUE
    1 CONTINUE
      RETURN
C
      END
      SUBROUTINE JETMRG
      IMPLICIT INTEGER*2 (H)
C---
C---     ROUTINE TO GET RID OF INTERNAL -1S IN JETC BANKS.
C---
      COMMON/CMOADD/JETPNT(3),NMOADD(3),IMOADD(3,10)
      COMMON/CWORK1/NWORK1,IWORK1(10000)
      DIMENSION HWORK1(20000)
      EQUIVALENCE(IWORK1(1),HWORK1(1))
C---
C---     LOOP OVER THE THREE POSSIBLE JETC BANKS
C---
      DO 1 IJET=1,3
C---
C---     HOW MANY -1S ARE IN THIS BANK? LOOK UP IN LIST SET UP BY ADDON.
C---
      NUMMIN=NMOADD(IJET)
      IF(NUMMIN.LT.1) GO TO 1
C---
C---     BY HOW MANY I*4 WORDS WILL THE LENGTH OF THIS BANK DECREASE?
C---
      NDECR=NUMMIN/2
      IODD=NUMMIN-2*NDECR
      IPNJET=JETPNT(IJET)
      IBNEND=IPNJET+IWORK1(IPNJET)
      IWORK1(IPNJET)=IWORK1(IPNJET)-NDECR
C---
C---     CLOSE UP THE -1S IN THIS BANK ONLY, STARTING FROM THE HIGHER
C---     ADDRESSES AND WORKING DOWNWARDS SO THAT THE ADDRESSES OF THE
C---     REMAINING -1S DO NOT CHANGE.
C---
      IBHEND=2*IBNEND
      DO 2 IGAP=1,NUMMIN
      INDEX=NUMMIN+1-IGAP
      IHTARG=IMOADD(IJET,INDEX)
      LMOVE=2*(IBHEND-IHTARG)
      IF(LMOVE.LT.1) GO TO 2
      IBHEND=IBHEND-1
      CALL MVCL2(HWORK1(IHTARG),0,HWORK1(IHTARG+1),0,LMOVE) !PMF 28/06/99 MVCL -> MVCL2
    2 CONTINUE
C---
C---     IF AN ODD NUMBER OF I*2 WORDS HAVE BEEN DELETED, SET THE LAST
C---     I*2 WORD OF THE BANK TO 0, AS PER THE USUAL CONVENTION.
C---
      LASTI2=2*(IPNJET+IWORK1(IPNJET))
      IF(IODD.EQ.1) HWORK1(LASTI2)=0
C---
C---     NOW MOVE THE HIGHER ADDRESS BANKS IN CWORK1 DOWN BY THE
C---     DECREASE IN THE LENGTH OF THE CURRENT JETC BANK. FIRST FIX
C---     THE POINTERS TO THE OTHER JETC BANKS IF THEY ARE AT HIGHER
C---     ADDRESSES.
C---
      IF(NDECR.LT.1) GO TO 1
      DO 3 JJET=1,3
      IF(JETPNT(JJET).LE.IPNJET) GO TO 3
      JETPNT(JJET)=JETPNT(JJET)-NDECR
      NMO=NMOADD(JJET)
      IF(NMO.LT.1) GO TO 3
      DO 4 IGAP=1,NMO
      IMOADD(JJET,IGAP)=IMOADD(JJET,IGAP)-2*NDECR
    4 CONTINUE
    3 CONTINUE
      LMOVE=4*(NWORK1-IBNEND)
      IF(LMOVE.LT.1) GO TO 1
      CALL MVCL(IWORK1(IBNEND+1-NDECR),0,IWORK1(IBNEND+1),0,LMOVE)
      NWORK1=NWORK1-NDECR
    1 CONTINUE
      RETURN
      END
      BLOCK DATA
      COMMON/CADDMS/IAERKT(10)
      DATA IAERKT/10*0/
      END

C   31/08/79 C9083101   MEMBER NAME  SPELST   (JADENS)      FORTRAN
      SUBROUTINE SPELST
      IMPLICIT INTEGER*2 (H)
#include "cgraph.for"
#include "cdata.for"
C---
C---     SHOWS CONTENTS OF THE SPECIAL LIST.
C---
      DIMENSION LIST(200)
      CALL BSLT
      CALL BMRT(N,LIST,200)
      WRITE(JUSCRN,100) N
  100 FORMAT(' SPELST CALLED.',I4,' BANKS ARE IN THE SPECIAL LIST:',/)
      IF(N.LT.1) RETURN
      WRITE(JUSCRN,101) (LIST(I),I=1,N)
  101 FORMAT(10(' ',A4))
      DO 2 I=1,N
      IPNTR=IDATA(IBLN(LIST(I)))
      WRITE(JUSCRN,102) I,LIST(I),IPNTR
  102 FORMAT(1X,I4,' ',A4,I8)
    2 CONTINUE
      RETURN
      END

C   13/04/78 C8110801   MEMBER NAME  ENDCLG   (S)           FORTRAN
      SUBROUTINE ENDCLG(R,NBL,*)
C  *--------------------------------------------------------
C  *
C  *   VERSION OF 10/07/78
C  *   THIS ROUTINE COMPUTES BLOCK NUMBERS IN THE END CAP
C  *   R = R(3) THREE DIM VECTOR TO A POINT IN THE LG ARRAYS
C  *   NBL = BLOCK NUMBER ON RETURN
C  *   NBL = 0    MEANS NO BLOCK IS HIT
C  *   IF NBL = 0 RETURN 1 EXIT IS USED
C  *   NBL RANGES FROM 2689 TO 2880
C  *   NBL = 2689 TO 2784  FOR R3 LT 0
C  *   NBL = 2785 TO 2880 FOR R3 GT 0
C  *--------------------------------------------------------
C
      COMMON/CGEO1/BKGAUS, RPIP,DRPIP,XRLPIP, RBPC,DRBPC,XRLBPC,
     *             RITNK,DRITNK,XRLTKI, R0ROH,DR0ROH,XR0ROH,
     *             R1ROH,DR1ROH,XR1ROH, R2ROH,DR2ROH,XR2ROH,
     *             R3ROH,DR3ROH,XR3ROH, ROTNK,DROTNK,XRLTKO,
     *             RTOF,DRTOF,XRTOF, RCOIL, DRCOIL, XRCOIL,
     *             ZJM,DZJM,XRZJM, ZJP,DZJP,XRZJP,
     *             ZTKM,DZTKM,XRZTKM, ZTKP,DZTKP,XRZTKP,
     *             ZBPPL,ZBPMI,ZTOFPL,ZTOFMI,
     *             XRJETC,
     *             RLG,ZLGPL,ZLGMI,OUTR2,CTLIMP,CTLIMM,DELFI,
     *             BLXY,BLZ,BLDEP,ZENDPL,ZENDMI,DEPEND,
     *             XHOL1,XHOL2,YHOL1,YHOL2,BLPHI
      DIMENSION R(1)
      INTEGER NB1(5,5)/0,2,6,11,17,3,7,12,18,0,8,13,20,19,0,14,22,21,0,
     *                 0,23,0,0,0,0/
      INTEGER NB2(4)  /1,5,10,16/
      INTEGER NB3(4)  /4,9,15,24/
      INTEGER MIRROR(24)/28,27,26,25,33,32,31,30,29,39,38,37,36,35,34,
     *                   48,47,46,45,44,43,42,41,40/
C
      NBL=0
      NBL0 = 2688
      X=R(1)
      Y=R(2)
      Z=R(3)
      XX=ABS(X)
      YY=ABS(Y)
      ZZ=ABS(Z)
C
C     CHECK Z COORDINATE (ASSUME + - Z SYMMETRY)
C
      IF(ZZ.LT.ZENDPL-5. .OR. ZZ.GT.ZENDPL+DEPEND+5.) RETURN 1
C
      IF(YY.LE.YHOL1) GO TO 1
      IF(XX.LE.XHOL1) GO TO 2
C
      NCOL=(XX-XHOL1)/XHOL1+1
      IF(NCOL.GT.5) GO TO 90
      NROW=(YY-YHOL1)/YHOL1+1
      IF(NROW.GT.5) GO TO 90
      NBL=NB1(NCOL,NROW)
      IF(NBL.EQ.0) RETURN 1
      GO TO 3
C
    1 NCOL=(XX-XHOL2)/XHOL1+1
      IF(NCOL.LT.1) GO TO 90
      IF(NCOL.GT.4) GO TO 90
      NBL=NB2(NCOL)
      GO TO 3
C
    2 NROW=(YY-YHOL2)/YHOL1+1
      IF(NROW.LT.1) GO TO 90
      IF(NROW.GT.4) GO TO 90
      NBL=NB3(NROW)
C
C
    3 CONTINUE
      IF(X.GE.0. .AND. Y.GE.0.) GO TO 5
      IF(X.LT.0. .AND. Y.LT.0.) GO TO 4
C
      NBL=MIRROR(NBL)
      IF(X.LT.0. .AND. Y.GE.0.) GO TO 5
C
    4 NBL=NBL+48
C
    5 NBL = NBL + NBL0
C
      IF(Z.LT.0) RETURN
      NBL=NBL+96
      RETURN
C
   90 NBL=0
      RETURN 1
      END

C   06/06/84 406142232  MEMBER NAME  FINCMD   (S)           FORTRAN
      SUBROUTINE FINCMD(H,N,I,M)
      IMPLICIT INTEGER*2 (H)
C     WRITE(6,1)
C1    FORMAT(' UNKNOWN COMMAND (TEMP)')
      I = 0
      RETURN
      END

C   07/06/96 606071806  MEMBER NAME  BDMP     (S4)          FORTG1
      SUBROUTINE BDMP
C     BOS SUBPROGRAM =1.16=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
C   07/06/96 606071821  MEMBER NAME  CCS      (S4)          FORTG1
      COMMON/CCS/IUND,INDT,INDC,NPT,INDA,LISTE(5),IPAS
      INTEGER TEXT(4)/'IW()','LFDI','LFDK','NLST'/
      REAL*8 TEXTB(10)
   10 WRITE(6,101) ICOND
      WRITE(6,102)
      CALL UWP(ICOND,1,80)
      CALL UWP(IUND,1,10)
C     PRINTOUT OF TRACEBACK
*xxx 09.01.98      M=ITRACE(TEXTB,10)
       	TEXTB(1) = 'PEDR'
       	TEXTB(2) = 'ANTO'
       	TEXTB(3) = 'MOVI'
       	TEXTB(4) = 'FERN'
     	M=20
*xxx
      WRITE(6,105) (TEXTB(J),J=1,M)
C
      IF(NLAST.NE.NLAST1) GOTO 20
      IF(NDUMP.NE.NDUMP1) GOTO 20
      GOTO 30
   20 WRITE(6,103)
      CALL UWU(IW,1,1000)
      GOTO 100
   30 WRITE(6,104) TEXT(2)
      IF(LFDI.GE.11.AND.LFDI.LT.NLAST) CALL UWP(IW,LFDI-10,LFDI+10)
      IF(LFDI.GT.0.AND.LFDI.LT.11.AND.LFDI.LT.NLAST)
     1   CALL UWP(IW,LFDI,LFDI+10)
      WRITE(6,104) TEXT(3)
      IF(LFDK.GT.0.AND.LFDK.LT.NLAST) CALL UWP(IW,LFDK-10,LFDK+10)
      WRITE(6,104) TEXT(4)
      IF(NLST.GE.0.AND.NLST.LT.NLAST) CALL UWU(IW,NLST,NLAST)
      IF(NDUMP.LT.0.OR.NDUMP.GT.NLAST) GOTO 20
      WRITE(6,104) TEXT(1)
      CALL UWU(IW,1,NDUMP)
  100 CALL ABEND
      STOP
C
      ENTRY BDMPF
      ICOND=31
      GOTO 10
  101 FORMAT('0','++++++++++','  DUMP  -  ERROR  CODE',I3,'  ',
     1   '+++++++++++++++++++++++++++++++++'/)
  102 FORMAT('0PRINTOUT OF COMMON/ACS/'/
     112X,' ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,'/
     212X,' NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,'/
     312X,' NHISTH(11),                              '/
     412X,'      NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,'/
     512X,' NER(10),                                 '/
     612X,' NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,'/
     712X,' NHISTL(11),                              '/
     812X,'      MARKWR,NOUT(3),IASW,NPRE,IDUMMY(2),NDUMP1 '/)
  103 FORMAT('0COMMON/ACS/ DESTROYED'/)
  104 FORMAT('0',6X,A4)
  105 FORMAT('0TRACEBACK OF SUBPROGRAMS'/(1X,10(2X,A8)))
      END

C   28/09/88 809281622  MEMBER NAME  TPSEFL   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPSEFL( IFLAG, ICODE )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery      28/09/88:  Store error flag  (TPEV)
C
C
C
C     Routine to store/update one of the error flags in TPEV/1 bank
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     IFLAG     In       I*4      Flag number of error
C     ICODE     In       I*4      Error code
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      INTEGER  IFLAG, ICODE, ITPEV

C------------------  C O D E  ------------------------------------------

C                            Find TPEV/1 bank

      CALL CLOC( ITPEV, 'TPEV', 1 )

      IF( ITPEV .GT. 0 ) THEN

        IF( IFLAG .GT. 0  .AND.  IFLAG .LE. 9 ) THEN

          HDATA(2*ITPEV+110+IFLAG) = HDATA(2*ITPEV+110+IFLAG) + ICODE

        ELSE

C                            Illegal error flag

          CALL TPERRH

        ENDIF

      ELSE

C                            TPEV bank is missing!

        CALL TPERRH

      ENDIF

      RETURN
      END

C   07/06/96 606071828  MEMBER NAME  BPOS     (S4)          FORTG1
      SUBROUTINE BPOS(NAME)
C     BOS SUBPROGRAM =1.9=
#include "acs.for"
      COMMON/BCS/IW(1)
      LOGICAL POS/.FALSE./
      EXTERNAL BDLG
      ENTRY CPOS(NAME)
      IW(INAMV)=NAME
      LFDI=MOD(IABS(NAMEV),NPRIM)+NAMAX1
    1 LFDI=IW(LFDI+IPLST)
      IF(IW(LFDI+INAMV).NE.IW(INAMV)) GOTO 1
      IF(LFDI.EQ.0) LFDI=IBLN(IW(INAMV))
      KPOS=LFDI
      GOTO 100
C
      ENTRY BPRL(NAME)
      IF(NPRE.GE.NAME) GOTO 100
      NPRE=NPRE+1
      CALL BPRM
  100 RETURN
      END

C   07/06/96 606071804  MEMBER NAME  BDLG     (S4)          FORTG1
      SUBROUTINE BDLG
C     BOS SUBPROGRAM =1.14=
C   18/10/82            MEMBER NAME  ACS      (S)           FORTRAN
      COMMON/ACS/
     1   ICOND,NLAST,NDUMP,NSPL,NAMAX,NAMAX1,NLIST,NPRIM,NFRS,NLST,
     2   NEXT,NCI,NFRE,IN,KPOS,LIND,ILOW,LFDI,LFDK,NCPL,
     3   NHISTH(11),
     4        NCOL,NZT,IBFI,NLAST1,ISLST,IMLST,INAMV,IOLST,IPLST,
     5   NER(10),
     6   NRECL,NERRL,NRIN,NROUT,NS,NEXTI,NEXTA,NEXTB,ISAVB,NSAVB,
     7   NHISTL(11),
     8        MARKWR,NOUT(3),IASW,NPRE,IDUMMY(1),NEOTP,NDUMP1
      COMMON/BCS/IW(1)
C
C
C     BDLG = BDLM + BGAR, BUT FASTER IN MOST CASES
      CALL BDLM
      IF(NFRE.NE.0) CALL BGAR(IGA)
      GOTO 100
C
      ENTRY BPRM
      IF(IN.LE.0) GOTO 100
      DO 40 J=1,IN
      K=IW(NLST+J)
      I=IW(K)
      GOTO 35
   30 I=IW(I-1)
   35 IF(I.EQ.0) GOTO 40
      CALL BPRS(IW(I-3),IW(I-2))
      GOTO 30
   40 CONTINUE
      GOTO 100
C
      ENTRY BSLW
      IN=0
      IF(NS.EQ.0) GOTO 100
      DO 80 I=1,NS
      IF(IW(IMLST+I).EQ.0) GOTO 80
      IN=IN+1
      IW(NLST+IN)=IW(ISLST+I)
   80 CONTINUE
      GOTO 100
C
      ENTRY BSLT
      IN=NS
      IF(NS.EQ.0) GOTO 100
      DO 90 I=1,NS
   90 IW(NLST+I)=IW(ISLST+I)
      GOTO 100
C
      ENTRY BSLC
      NS=0
  100 RETURN
      END

C   31/05/79 912061908  MEMBER NAME  ANOMAL   (S)           FORTRAN
      SUBROUTINE ANOMAL
C---  SPECIFY ANOMALIES OF INDIVIDUAL RUNS
C---  (SHIFTS FROM JUNE TO NOVEMBER 1979;
C---   THE CORRESPONDING PROGRAM FOR THE MAY SHIFTS IS ON GAMGAM.S/L)
C
C     H.WRIEDT    31.05.79     11:20
C     LAST MODIFICATION     06.12.79     19:05
C
      IMPLICIT INTEGER*2 (H)
C
      COMMON /CRUNCO/ HRUN
C
      COMMON /CPHASE/ LIMEVT,KCONST(192),LIMIT(192),LCHANN(192),
     &                LTHRES(192),LDEAD(192),LSUB(240)
      LOGICAL LCHANN,LTHRES,LDEAD,LSUB
C
C---  LCHANN:  CHANNELS WITH CONSTANT PEDESTALS
C---  LDEAD:   CHANNELS WHICH MUST BE SET TO 0 (E.G. FOR MISSING BITS
C              IN THE ADC
C---  KCONST:  CHANNELS FOR WHICH THE SUBTRACTION CONSTANT MUST BE
C              HIGHER (-1) OR LOWER (+1) THAN THE PROGRAM WOULD
C              AUTOMATICALLY CALCULATE
C---  LIMIT:   GIVES THE LOWER BOUND OF THE SUBTRACTION CONSTANT
C---  LTHRES:  CHANNELS FOR WHICH THE LOWER CUT BOUND IS SET TO 100
C              INSTEAD OF 50
C
      DO 1 I = 1,192
      KCONST(I) = 0
      LIMIT(I) = 0
      LCHANN(I) = .FALSE.
      LDEAD(I) = .FALSE.
    1 LTHRES(I) = .FALSE.
        DO 2 I = 1,240
    2   LSUB(I) = .FALSE.
      LIMEVT = 0
C
      IF (HRUN.GT.564) GOTO 5
      IRUN = HRUN - 539
      IF (IRUN.LE.0) RETURN
C---  13.6 GEV - RUNS
      CALL ANOM01(IRUN)
      RETURN
C
    5 IF (HRUN.GT.672) GOTO 6
      IRUN = HRUN - 580
      IF (IRUN.LE.0) RETURN
C---  13.86 GEV - RUNS
      CALL ANOM02(IRUN)
      RETURN
C
    6 IF (HRUN.GT.709) GOTO 7
      IRUN = HRUN - 698
      IF (IRUN.LE.0) RETURN
C---  15.8 GEV - RUNS
      CALL ANOM11(IRUN)
      RETURN
C
    7 IF (HRUN.GT.893) GOTO 8
      IRUN = HRUN - 763
      IF (IRUN.LE.0) RETURN
C---  15.8 GEV - RUNS
      CALL ANOM12(IRUN)
      RETURN
C
    8 IF (HRUN.GT.960) GOTO 9
      IRUN = HRUN - 913
      IF (IRUN.LE.0) RETURN
C---  15.8 GEV - RUNS
      CALL ANOM13(IRUN)
      RETURN
C
    9 IF (HRUN.GT.1082) GOTO 10
      IRUN = HRUN - 971
      IF (IRUN.LE.0) RETURN
C---  15.8 GEV - RUNS
      CALL ANOM14(IRUN)
      RETURN
C
   10 IF (HRUN.GT.1083) GOTO 11
      IRUN = HRUN - 1082
      IF (IRUN.LE.0) RETURN
C---  11.0 GEV - RUN
      CALL ANOM21(IRUN)
      RETURN
C
   11 IF (HRUN.GT.1121) GOTO 12
      IRUN = HRUN - 1083
      IF (IRUN.LE.0) RETURN
C---  13.86 GEV - RUNS
      CALL ANOM31(IRUN)
      RETURN
C
   12 IF (HRUN.GT.1162) GOTO 13
      IRUN = HRUN - 1121
      IF (IRUN.LE.0) RETURN
C---  11.0 GEV - RUNS
      CALL ANOM41(IRUN)
      RETURN
C
   13 IF (HRUN.GT.1397) GOTO 20
      IRUN = HRUN - 1209
      IF (IRUN.LE.0) RETURN
C---  15.0 GEV - RUNS
      CALL ANOM51(IRUN)
      RETURN
C
   20 IF (HRUN.GT.1559) GOTO 21
      IRUN = HRUN - 1496
      IF (IRUN.LE.0) RETURN
C---  15.25 GEV - RUNS
      CALL ANOM61(IRUN)
      RETURN
C
   21 IF (HRUN.GT.1576) GOTO 22
      IRUN = HRUN - 1560
      IF (IRUN.LE.0) RETURN
C---  15.26 GEV - RUNS
      CALL ANOM62(IRUN)
      RETURN
C
   22 IF (HRUN.GT.1604) GOTO 23
      IRUN = HRUN - 1577
      IF (IRUN.LE.0) RETURN
C---  15.27 GEV - RUNS
      CALL ANOM63(IRUN)
      RETURN
C
   23 IF (HRUN.GT.1626) GOTO 24
      IRUN = HRUN - 1608
      IF (IRUN.LE.0) RETURN
C---  15.28 GEV - RUNS
      CALL ANOM64(IRUN)
      RETURN
C
   24 IF (HRUN.GT.1637) GOTO 25
      IRUN = HRUN - 1626
      IF (IRUN.LE.0) RETURN
C---  15.29 GEV - RUNS
      CALL ANOM65(IRUN)
      RETURN
C
   25 IF (HRUN.GT.1648) GOTO 26
      IRUN = HRUN - 1638
      IF (IRUN.LE.0) RETURN
C---  15.30 GEV - RUNS
      CALL ANOM66(IRUN)
      RETURN
C
   26 IF (HRUN.GT.1661) GOTO 27
      IRUN = HRUN - 1648
      IF (IRUN.LE.0) RETURN
C---  15.31 GEV - RUNS
      CALL ANOM67(IRUN)
      RETURN
C
   27 IF (HRUN.GT.1686) GOTO 28
      IRUN = HRUN - 1661
      IF (IRUN.LE.0) RETURN
C---  15.32 GEV - RUNS
      CALL ANOM68(IRUN)
      RETURN
C
   28 IF (HRUN.GT.1713) GOTO 29
      IRUN = HRUN - 1710
      IF (IRUN.LE.0) RETURN
C---  15.33 GEV - RUNS
      CALL ANOM69(IRUN)
      RETURN
C
   29 IF (HRUN.GT.1724) GOTO 30
      IRUN = HRUN - 1713
      IF (IRUN.LE.0) RETURN
C---  15.34 GEV - RUNS
      CALL ANOM70(IRUN)
      RETURN
C
   30 IF (HRUN.GT.1729) GOTO 31
      IRUN = HRUN - 1724
      IF (IRUN.LE.0) RETURN
C---  15.35 GEV - RUNS
      CALL ANOM71(IRUN)
      RETURN
C
   31 IF (HRUN.GT.1739) GOTO 32
      IRUN = HRUN - 1731
      IF (IRUN.LE.0) RETURN
C---  15.36 GEV - RUNS
      CALL ANOM72(IRUN)
      RETURN
C
   32 IF (HRUN.GT.1749) GOTO 33
      IRUN = HRUN - 1739
      IF (IRUN.LE.0) RETURN
C---  15.37 GEV - RUNS
      CALL ANOM73(IRUN)
      RETURN
C
   33 IF (HRUN.GT.1755) GOTO 34
      IRUN = HRUN - 1749
      IF (IRUN.LE.0) RETURN
C---  15.38 GEV - RUNS
      CALL ANOM74(IRUN)
      RETURN
C
   34 IF (HRUN.GT.1762) GOTO 35
      IRUN = HRUN - 1755
      IF (IRUN.LE.0) RETURN
C---  15.39 GEV - RUNS
      CALL ANOM75(IRUN)
      RETURN
C
   35 IF (HRUN.GT.1769) GOTO 36
      IRUN = HRUN - 1762
      IF (IRUN.LE.0) RETURN
C---  15.40 GEV - RUNS
      CALL ANOM76(IRUN)
      RETURN
C
   36 IF (HRUN.GT.1778) GOTO 37
      IRUN = HRUN - 1769
      IF (IRUN.LE.0) RETURN
C---  15.41 GEV - RUNS
      CALL ANOM77(IRUN)
      RETURN
C
   37 IF (HRUN.GT.1783) GOTO 38
      IRUN = HRUN - 1778
      IF (IRUN.LE.0) RETURN
C---  15.42 GEV - RUNS
      CALL ANOM78(IRUN)
      RETURN
C
   38 IF (HRUN.GT.1796) GOTO 39
      IRUN = HRUN - 1783
      IF (IRUN.LE.0) RETURN
C---  15.43 GEV - RUNS
      CALL ANOM79(IRUN)
      RETURN
C
   39 IF (HRUN.GT.1801) GOTO 40
      IRUN = HRUN - 1796
      IF (IRUN.LE.0) RETURN
C---  15.44 GEV - RUNS
      CALL ANOM80(IRUN)
      RETURN
C
   40 IF (HRUN.GT.1809) GOTO 41
      IRUN = HRUN - 1801
      IF (IRUN.LE.0) RETURN
C---  15.45 GEV - RUNS
      CALL ANOM81(IRUN)
      RETURN
C
   41 IF (HRUN.GT.1813) GOTO 42
      IRUN = HRUN - 1809
      IF (IRUN.LE.0) RETURN
C---  15.46 GEV - RUNS
      CALL ANOM82(IRUN)
      RETURN
C
   42 IF (HRUN.GT.1865) GOTO 43
      IRUN = HRUN - 1845
      IF (IRUN.LE.0) RETURN
C---  15.46 GEV - RUNS (AFTER SHUT-DOWN)
      CALL ANOM83(IRUN)
      RETURN
C
   43 IF (HRUN.GT.1868) GOTO 44
      IRUN = HRUN - 1865
      IF (IRUN.LE.0) RETURN
C---  15.47 GEV - RUNS
      CALL ANOM84(IRUN)
      RETURN
C
   44 IF (HRUN.GT.1871) GOTO 45
      IRUN = HRUN - 1868
      IF (IRUN.LE.0) RETURN
C---  15.50 GEV - RUNS
      CALL ANOM85(IRUN)
      RETURN
C
   45 IF (HRUN.GT.1875) GOTO 46
      IRUN = HRUN - 1871
      IF (IRUN.LE.0) RETURN
C---  15.47 GEV - RUNS
      CALL ANOM86(IRUN)
      RETURN
C
   46 IF (HRUN.GT.1881) GOTO 47
      IRUN = HRUN - 1875
      IF (IRUN.LE.0) RETURN
C---  15.48 GEV - RUNS
      CALL ANOM87(IRUN)
      RETURN
C
   47 IF (HRUN.GT.1888) GOTO 48
      IRUN = HRUN - 1881
      IF (IRUN.LE.0) RETURN
C---  15.49 GEV - RUNS
      CALL ANOM88(IRUN)
      RETURN
C
   48 IF (HRUN.GT.1892) GOTO 49
      IRUN = HRUN - 1888
      IF (IRUN.LE.0) RETURN
C---  15.50 GEV - RUNS
      CALL ANOM89(IRUN)
      RETURN
C
   49 IF (HRUN.GT.1897) GOTO 50
      IRUN = HRUN - 1892
      IF (IRUN.LE.0) RETURN
C---  15.51 GEV - RUNS
      CALL ANOM90(IRUN)
      RETURN
C
   50 IF (HRUN.GT.1904) GOTO 51
      IRUN = HRUN - 1897
      IF (IRUN.LE.0) RETURN
C---  15.52 GEV - RUNS
      CALL ANOM91(IRUN)
      RETURN
C
   51 IF (HRUN.GT.1908) GOTO 52
      IRUN = HRUN - 1904
      IF (IRUN.LE.0) RETURN
C---  15.53 GEV - RUNS
      CALL ANOM92(IRUN)
      RETURN
C
   52 IF (HRUN.GT.1911) GOTO 53
      IRUN = HRUN - 1908
      IF (IRUN.LE.0) RETURN
C---  15.54 GEV - RUNS
      CALL ANOM93(IRUN)
      RETURN
C
   53 IF (HRUN.GT.1919) GOTO 54
      IRUN = HRUN - 1911
      IF (IRUN.LE.0) RETURN
C---  15.55 GEV - RUNS
      CALL ANOM94(IRUN)
      RETURN
C
   54 IF (HRUN.GT.1928) GOTO 55
      IRUN = HRUN - 1919
      IF (IRUN.LE.0) RETURN
C---  15.56 GEV - RUNS
      CALL ANOM95(IRUN)
      RETURN
C
   55 IF (HRUN.GT.1934) GOTO 56
      IRUN = HRUN - 1930
      IF (IRUN.LE.0) RETURN
C---  15.57 GEV - RUNS
      CALL ANOM96(IRUN)
      RETURN
C
   56 IF (HRUN.GT.1940) GOTO 57
      IRUN = HRUN - 1934
      IF (IRUN.LE.0) RETURN
C---  15.58 GEV - RUNS
      CALL ANOM97(IRUN)
      RETURN
C
   57 IF (HRUN.GT.1945) GOTO 58
      IRUN = HRUN - 1940
      IF (IRUN.LE.0) RETURN
C---  15.59 GEV - RUNS
      CALL ANOM98(IRUN)
      RETURN
C
   58 IF (HRUN.GT.1952) GOTO 59
      IRUN = HRUN - 1945
      IF (IRUN.LE.0) RETURN
C---  15.60 GEV - RUNS
      CALL ANOM99(IRUN)
      RETURN
C
   59 IF (HRUN.GT.1958) GOTO 60
      IRUN = HRUN - 1952
      IF (IRUN.LE.0) RETURN
C---  15.61 GEV - RUNS
      CALL ANO100(IRUN)
      RETURN
C
   60 IF (HRUN.GT.1965) GOTO 61
      IRUN = HRUN - 1958
      IF (IRUN.LE.0) RETURN
C---  15.62 GEV - RUNS
      CALL ANO101(IRUN)
      RETURN
C
   61 IF (HRUN.GT.1969) GOTO 62
      IRUN = HRUN - 1965
      IF (IRUN.LE.0) RETURN
C---  15.63 GEV - RUNS
      CALL ANO102(IRUN)
      RETURN
C
   62 IF (HRUN.GT.1972) GOTO 63
      IRUN = HRUN - 1969
      IF (IRUN.LE.0) RETURN
C---  15.64 GEV - RUNS
      CALL ANO103(IRUN)
      RETURN
C
   63 IF (HRUN.GT.1975) GOTO 64
      IRUN = HRUN - 1972
      IF (IRUN.LE.0) RETURN
C---  15.65 GEV - RUNS
      CALL ANO104(IRUN)
      RETURN
C
   64 IF (HRUN.GT.1986) GOTO 65
      IRUN = HRUN - 1978
      IF (IRUN.LE.0) RETURN
C---  15.66 GEV - RUNS
      CALL ANO105(IRUN)
      RETURN
C
   65 IF (HRUN.GT.2008) GOTO 66
      IRUN = HRUN - 1986
      IF (IRUN.LE.0) RETURN
C---  15.67 GEV - RUNS
      CALL ANO106(IRUN)
      RETURN
C
   66 IF (HRUN.GT.2017) GOTO 67
      IRUN = HRUN - 2008
      IF (IRUN.LE.0) RETURN
C---  15.68 GEV - RUNS
      CALL ANO107(IRUN)
      RETURN
C
   67 IF (HRUN.GT.2025) GOTO 68
      IRUN = HRUN - 2017
      IF (IRUN.LE.0) RETURN
C---  15.69 GEV - RUNS
      CALL ANO108(IRUN)
      RETURN
C
   68 IF (HRUN.GT.2032) GOTO 69
      IRUN = HRUN - 2025
      IF (IRUN.LE.0) RETURN
C---  15.70 GEV - RUNS
      CALL ANO109(IRUN)
      RETURN
C
   69 IF (HRUN.GT.2041) GOTO 70
      IRUN = HRUN - 2032
      IF (IRUN.LE.0) RETURN
C---  15.71 GEV - RUNS
      CALL ANO110(IRUN)
      RETURN
C
   70 IF (HRUN.GT.2051) GOTO 71
      IRUN = HRUN - 2041
      IF (IRUN.LE.0) RETURN
C---  15.72 GEV - RUNS
      CALL ANO111(IRUN)
      RETURN
C
   71 IF (HRUN.GT.2055) GOTO 80
      IRUN = HRUN - 2051
      IF (IRUN.LE.0) RETURN
C---  15.73 GEV - RUNS
      CALL ANO112(IRUN)
      RETURN
C
   80 IF (HRUN.GT.2062) GOTO 81
      IRUN = HRUN - 2056
      IF (IRUN.LE.0) RETURN
C---  15.00 GEV - RUNS
      CALL ANO120(IRUN)
      RETURN
C
   81 IF (HRUN.GT.2068) GOTO 82
      IRUN = HRUN - 2062
      IF (IRUN.LE.0) RETURN
C---  15.01 GEV - RUNS
      CALL ANO121(IRUN)
      RETURN
C
   82 IF (HRUN.GT.2076) GOTO 83
      IRUN = HRUN - 2069
      IF (IRUN.LE.0) RETURN
C---  15.02 GEV - RUNS
      CALL ANO122(IRUN)
      RETURN
C
   83 IF (HRUN.GT.2082) GOTO 84
      IRUN = HRUN - 2076
      IF (IRUN.LE.0) RETURN
C---  15.03 GEV - RUNS
      CALL ANO123(IRUN)
      RETURN
C
   84 IF (HRUN.GT.2091) GOTO 85
      IRUN = HRUN - 2082
      IF (IRUN.LE.0) RETURN
C---  15.04 GEV - RUNS
      CALL ANO124(IRUN)
      RETURN
C
   85 IF (HRUN.GT.2096) GOTO 86
      IRUN = HRUN - 2091
      IF (IRUN.LE.0) RETURN
C---  15.05 GEV - RUNS
      CALL ANO125(IRUN)
      RETURN
C
   86 IF (HRUN.GT.2110) GOTO 87
      IRUN = HRUN - 2096
      IF (IRUN.LE.0) RETURN
C---  15.06 GEV - RUNS
      CALL ANO126(IRUN)
      RETURN
C
   87 IF (HRUN.GT.2116) GOTO 88
      IRUN = HRUN - 2111
      IF (IRUN.LE.0) RETURN
C---  15.07 GEV - RUNS
      CALL ANO127(IRUN)
      RETURN
C
   88 IF (HRUN.GT.2121) GOTO 89
      IRUN = HRUN - 2116
      IF (IRUN.LE.0) RETURN
C---  15.08 GEV - RUNS
      CALL ANO128(IRUN)
      RETURN
C
   89 IF (HRUN.GT.2125) GOTO 90
      IRUN = HRUN - 2121
      IF (IRUN.LE.0) RETURN
C---  15.09 GEV - RUNS
      CALL ANO129(IRUN)
      RETURN
C
   90 IF (HRUN.GT.2129) GOTO 91
      IRUN = HRUN - 2125
      IF (IRUN.LE.0) RETURN
C---  15.10 GEV - RUNS
      CALL ANO130(IRUN)
      RETURN
C
   91 IF (HRUN.GT.2133) GOTO 92
      IRUN = HRUN - 2129
      IF (IRUN.LE.0) RETURN
C---  15.11 GEV - RUNS
      CALL ANO131(IRUN)
      RETURN
C
   92 IF (HRUN.GT.2145) GOTO 93
      IRUN = HRUN - 2133
      IF (IRUN.LE.0) RETURN
C---  15.12 GEV - RUNS
      CALL ANO132(IRUN)
      RETURN
C
   93 IF (HRUN.GT.2149) GOTO 94
      IRUN = HRUN - 2145
      IF (IRUN.LE.0) RETURN
C---  15.13 GEV - RUNS
      CALL ANO133(IRUN)
      RETURN
C
   94 IF (HRUN.GT.2152) GOTO 95
      IRUN = HRUN - 2149
      IF (IRUN.LE.0) RETURN
C---  15.14 GEV - RUNS
      CALL ANO134(IRUN)
      RETURN
C
   95 IF (HRUN.GT.2154) GOTO 96
      IRUN = HRUN - 2152
      IF (IRUN.LE.0) RETURN
C---  15.15 GEV - RUNS
      CALL ANO135(IRUN)
      RETURN
C
   96 IF (HRUN.GT.2159) GOTO 97
      IRUN = HRUN - 2154
      IF (IRUN.LE.0) RETURN
C---  15.16 GEV - RUNS
      CALL ANO136(IRUN)
      RETURN
C
   97 IF (HRUN.GT.2163) GOTO 98
      IRUN = HRUN - 2159
      IF (IRUN.LE.0) RETURN
C---  15.17 GEV - RUNS
      CALL ANO137(IRUN)
      RETURN
C
   98 IF (HRUN.GT.2167) GOTO 99
      IRUN = HRUN - 2163
      IF (IRUN.LE.0) RETURN
C---  15.18 GEV - RUNS
      CALL ANO138(IRUN)
      RETURN
C
   99 IF (HRUN.GT.2175) GOTO 100
      IRUN = HRUN - 2167
      IF (IRUN.LE.0) RETURN
C---  15.19 GEV - RUNS
      CALL ANO139(IRUN)
      RETURN
C
  100 IF (HRUN.GT.2182) GOTO 101
      IRUN = HRUN - 2176
      IF (IRUN.LE.0) RETURN
C---  15.20 GEV - RUNS
      CALL ANO140(IRUN)
      RETURN
C
  101 IF (HRUN.GT.2187) GOTO 102
      IRUN = HRUN - 2182
      IF (IRUN.LE.0) RETURN
C---  15.21 GEV - RUNS
      CALL ANO141(IRUN)
      RETURN
C
  102 IF (HRUN.GT.2190) GOTO 103
      IRUN = HRUN - 2187
      IF (IRUN.LE.0) RETURN
C---  15.22 GEV - RUNS
      CALL ANO142(IRUN)
      RETURN
C
  103 IF (HRUN.GT.2194) GOTO 104
      IRUN = HRUN - 2190
      IF (IRUN.LE.0) RETURN
C---  15.23 GEV - RUNS
      CALL ANO143(IRUN)
      RETURN
C
  104 IF (HRUN.GT.2201) GOTO 110
      IRUN = HRUN - 2194
      IF (IRUN.LE.0) RETURN
C---  15.24 GEV - RUNS
      CALL ANO144(IRUN)
      RETURN
C
  110 IF (HRUN.GT.2207) GOTO 111
      IRUN = HRUN - 2201
      IF (IRUN.LE.0) RETURN
C---  14.95 GEV - RUNS
      CALL ANO150(IRUN)
      RETURN
C
  111 IF (HRUN.GT.2216) GOTO 112
      IRUN = HRUN - 2208
      IF (IRUN.LE.0) RETURN
C---  14.96 GEV - RUNS
      CALL ANO151(IRUN)
      RETURN
C
  112 IF (HRUN.GT.2219) GOTO 113
      IRUN = HRUN - 2216
      IF (IRUN.LE.0) RETURN
C---  14.97 GEV - RUNS
      CALL ANO152(IRUN)
      RETURN
C
  113 IF (HRUN.GT.2222) GOTO 114
      IRUN = HRUN - 2219
      IF (IRUN.LE.0) RETURN
C---  14.98 GEV - RUNS
      CALL ANO153(IRUN)
      RETURN
C
  114 IF (HRUN.GT.2226) GOTO 120
      IRUN = HRUN - 2222
      IF (IRUN.LE.0) RETURN
C---  14.99 GEV - RUNS
      CALL ANO154(IRUN)
      RETURN
C
  120 IF (HRUN.GT.2385) GOTO 121
      IRUN = HRUN - 2305
      IF (IRUN.LE.0) RETURN
C---  6 GEV - RUNS
      CALL ANO160(IRUN)
      RETURN
C
  121 IF (HRUN.GT.2447) GOTO 122
      IRUN = HRUN - 2385
      IF (IRUN.LE.0) RETURN
C---  6 GEV - RUNS
      CALL ANO161(IRUN)
      RETURN
C
  122 IF (HRUN.GT.2520) RETURN
      IRUN = HRUN - 2447
      IF (IRUN.LE.0) RETURN
C---  6 GEV - RUNS
      CALL ANO162(IRUN)
      RETURN
C
      END

C   19/04/79 903031500  MEMBER NAME  STHEAD   (S)           FORTRAN
      SUBROUTINE STHEAD( LENGTH, IHEAD )
C-----------------------------------------------------------
C
C  VERSION OF 18/04/79                       E.ELSEN
C     CHANGED TO SET WORD 16 IN HEAD BANK TO 1, TO MARK THE USAGE OF
C     NEW, CORRECTED VERSION OF TRKGAM    SEE JCN NR     .
C                       MOD. 15.2.1986       J.OLSON
C     CHANGED TO SET WORD 18 IN HEAD BANK TO -1, TO MARK IF TRACKING WAS
C     DONE WITHOUT MULTIPLE SCATTERING AND ENERGY LOSS (FLAGS= ELOSS,
C                                                              MULSC)
C     CHANGED TO SET WORD 17 IN HEAD BANK TO 1, IF LFLAG(4)=.TRUE.
C     THIS MARKS THE USE OF MEIER/MAGNUSSEN LEAD GLASS SIMULATION.
C
C     CHANGED TO SET WORD 17 IN HEAD BANK TO 2, IF LFLAG(6)=.TRUE.
C     THIS MARKS THE USE OF THE TOKYO SHOWER PROGRAM
C
C     CHANGED TO SET WORD 14 IN HEAD BANK TO VERSION NR OF SF5-SF6
C     SHOWER PROGRAM, TAKEN FROM COMMON /CVER56/
C
C     CHANGED TO SET WORD 15 IN HEAD BANK TO 1, IF LFLAG(8)=.TRUE.
C     INDICATING THE USE OF GEANT SHOWER PROGRAM FOR TAGGER.
C
C                       MOD. 10.06.1986       J.HAGEMANN
C                       MOD. 11.06.1986       J.OLSSON
C                       MOD. 06.12.1986       J.OLSSON
C                       MOD. 25.04.1987       J.OLSSON
C                       MOD. 17.10.1988       J.OLSSON
C                              (UPDATE THE CHANGES 18.12.87 IN JMC.S/L )
C                  LAST MOD. 03.03.1989       J.OLSSON
C
C
C     PRODUCTION DATE NOW SAVED IN HALF WORDS 93-95
C                         18/12/87    E ELSEN
C
C  SET FIRST 50 WORDS OF BANK 'HEAD', CONTAINING EVENT AND
C  RUN INFORMATION ( SEE JADE COMPUTER NOTE 23 )
C  EXTRA ENTRY LHHEAD RETURN LENGTH ONLY.
C----------------------------------------------------------
C
      IMPLICIT INTEGER*2 (H)
      COMMON / BCS / IW(1)
      DIMENSION RW(1), HW(1)
      EQUIVALENCE (HW(1),RW(1),IW(1))
      DIMENSION IHEAD(50)
C
C  VERSION OF SF5-6 SHOWER MONTE CARLO, TO BE STORED IN WORD 14 OF HEAD
C
      COMMON /CVER56/ IVER56
C
      LOGICAL  ELOSS, MULSC
      COMMON / CJSWLO / ITIMOD, MULSC, ELOSS
C
      LOGICAL*1 LFLAG
      COMMON/CFLAG/LFLAG(10)
C
      COMMON/TODAY/IDATE(3)
      DIMENSION HPROD(6)
C
      COMMON / CGEO1 / BKGAUS
      DIMENSION HELP(2)
      EQUIVALENCE (IHELP,HELP(1))
      DATA HRCTYP / 1 /, HROPAT / Z61CC /
      DATA ICALL / 0 /
C
      IF( ICALL .GT. 0 ) GO TO 1
      ICALL = 1
      IPVECT = IBLN('VECT')
    1 CONTINUE
      IBEAM = 0
      NR = 0
      NPVECT = IW(IPVECT)
      IF( NPVECT .LE. 0 ) GO TO 2
      NR = IW(NPVECT+3)
      L0 = IW(NPVECT+1)
      IF( L0 .LE. 12 ) GO TO 2
      IBEAM = IW(NPVECT+13)
    2 CONTINUE
C               CONFIGURATION DATE FROM /TODAY/, INTO HEAD DATE AREA
C
      IHEAD(2) = IDATE(1)
      IHEAD(3) = IDATE(2)
      IHEAD(4) = IDATE(3)
C
C                              EVENT NUMBER, WORD 11
C                              EVENT TYPE, WORD 12
      HELP(1) = NR
      HELP(2) = HRCTYP
      IHEAD(6) = IHELP
C                              READ OUT PATTERN, WORD 13
C         NOTE THAT HROPAT IS HEAVILY OUTDATED AND MEANINGLESS...
C                              SF5-SF6 VERSION NUMBER, WORD 14
      HELP(1) = HROPAT
      HELP(2) = 0
      IF(LFLAG(6)) HELP(2) = IVER56
      IHEAD(7) = IHELP
C
C   OVERFLOW WORD, ALWAYS ZERO IN MC, WORD 15
C     USE WORD 15 FOR TAGGER GEANT USAGE INDICATION    3.3.89  J.O.
C   NEW TRKGAM MARKER, WORD 16   SEE JCN NR 87.     15.2.1986
C
      HELP(1) = 0
      IF(LFLAG(8)) HELP(1) = 1
      HELP(2) = 1
      IHEAD(8) = IHELP
C
C   NEW MARKER FOR USE OF MEIER/MAGNUSSEN LG TRACKING     11.06.86
C                      OR TOKYO SHOWER PROGRAM            25.4.1987
C   WORD 17
C
      HELP(1) = 0
      IF(LFLAG(4)) HELP(1) = 1
      IF(LFLAG(6)) HELP(1) = 2
C
C   NEW MARKER FOR MULTIPLE SCATTERING AND ENERGY LOSS    10.06.86
C   WORD 18
C
647   HELP(2) = 0
      IF( .NOT.ELOSS .AND. .NOT.MULSC ) HELP(2) = -1
      IHEAD(9) = IHELP
C                            BEAM ENERGY, WORD 29
C                            MAGNETIC FIELD, WORD 30
      HELP(1) = IBEAM
      HELP(2) = BKGAUS * 1000.
      IHEAD(15) = IHELP
C
C                                           STORE PRODUCTION DATE
      CALL DATEMC( HPROD )
      HELP(1) = HPROD(4)
      HELP(2) = HPROD(5)
      IHEAD(47) = IHELP
      IHELP = IHEAD(48)
      HELP(1) = HPROD(6)
      IHEAD(48) = IHELP
C
C
C-----------------------------------------------------------
      ENTRY LHHEAD( LENGTH )
C-----------------------------------------------------------
      LENGTH = 100
      RETURN
      END

C   09/12/87 807261203  MEMBER NAME  TPSPUT   (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPSPUT( NP, SPHITY, AXES )
C-----------------------------------------------------------------------
C
C     Author:   C. Bowdery       9/12/87:  Store sphericity info (TPEV)
C
C     Last mod: C. Bowdery      26/07/88:  NP argument added.
C
C     Routine to store sphericity eigenvalues and vectors in TPEV/1 bank
C
C-----------------   A R G U M E N T S      ----------------------------
C
C     NP        In       I*4      Number of particles used
C     SPHITY    In       R*4      Eigenvalues of sphericity
C                                   SPHITY(1) = smallest eigenvalue
C                                   SPHITY(2) = medium   eigenvalue
C                                   SPHITY(3) = largest  eigenvalue
C     AXES      In       R*4      Eigenvectors of sphericity (1..9)
C                                   AXES(1) = x dir. cos. of minor axis
C                                   AXES(2) = y dir. cos. of minor axis
C                                   AXES(3) = z dir. cos. of minor axis
C                                   AXES(4) = x dir. cos. of major axis
C                                   AXES(7) = x dir. cos. of S axis, etc
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

#include "bosdata.for"

      REAL  SPHITY(3), AXES(9)

      INTEGER  NP

C------------------  C O D E  ------------------------------------------

C                            Find the TPEV/1 bank and copy eigenvalues
C                            and eigenvectors.

      CALL CLOC( ITPEV, 'TPEV', 1 )

      IF( ITPEV .GT. 0 ) THEN

        ADATA( ITPEV + 29 ) = SPHITY(1)
        ADATA( ITPEV + 30 ) = SPHITY(2)
        ADATA( ITPEV + 31 ) = SPHITY(3)

        CALL UCOPY( AXES, ADATA( ITPEV + 32 ), 9 )

C                            Set flag to say charged and neutrals used.
C                            Record number of particles used.

        HDATA( 2*ITPEV + 55 ) = 0
        HDATA( 2*ITPEV + 56 ) = NP

      ELSE

C                            TPEV bank is missing!

        CALL TPERRH

      ENDIF

      RETURN
      END

C   22/03/97 703221932  MEMBER NAME  JEOSUM6  (JADEGS)      FORTRAN
C   22/03/97 703221923  MEMBER NAME  JBKALSAV (JADEGS)      FORTRAN
//F11LHO   JOB 10622622,OLSSON,MSGLEVEL=(0,0),TIME=(0,05),CLASS=E
//*MAIN RELPRI=HIG,ORG=EXT
//*EXEC NEWFAST
// EXEC FCLG,PARM.FORT=XL,
//  REGION.GO=500K
      DIMENSION IWORD(30000)
C
      NREC = 0
      NUNIT = 2
      LUNIT = 3
10    CONTINUE
      READ(NUNIT,ERR=1,END=2) NWORD,(IWORD(I),I=1,NWORD)
      NREC = NREC + 1
      IF(NREC.LT.10) WRITE(6,630) NWORD,(IWORD(J),J=1,10)
630   FORMAT(' ',I12,10I10)
      WRITE(LUNIT) NWORD,(IWORD(I),I=1,NWORD)
      GO TO 10
C
    1 WRITE(6,1020) NREC
 1020 FORMAT(' READ ERROR AT RECORD ',I10)
      STOP
    2 WRITE(6,1030) NREC
1030  FORMAT(' END OF RECORD AT RECORD NR ',I10)
      STOP
      END
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DSN=R01UTL.CERNLIB,DISP=SHR,UNIT=FAST
//            DD DSN=DESYLIB,DISP=SHR,UNIT=FAST
//GO.SYSIN    DD *
//*                        INPUT:
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KB81121A
//*                        OUTPUT:
//*GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//GO.FT03F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
C   22/03/97 703221923  MEMBER NAME  JBKALTST (JADEGS)      FORTRAN
//F11LHOTT JOB 10622622,CLASS=E,TIME=(0,30),MSGLEVEL=(0,0)
// EXEC NEWLIB,PS='F11LHO.JADEGS',
// OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C KLREAD
./ I 8300
         WRITE(6,8787) NDUUM,ITM1,KUNIT
 8787    FORMAT(1X,' NDUUM,ITM,UNIT = ',2I12)
./ I 8400
         WRITE(6,8787) NDUUM,ITM2,LUNIT
./ I 10300
         JCALL=ICALL/12
         KCALL=ICALL-12*JCALL+1
         ITIME(1)=0
         ITIME(2)=0
         ITIME(3)=0
         ITIME(4)=1
         ITIME(5)=KCALL
         ITIME(6)=1979+JCALL
./ I 10400
         WRITE(6,9787) ICALL,ITIME,IEVTIM
 9787    FORMAT(1X,' ICALL, ITIME, IEVTIM = ',I3,6I5,I10)
         ICALL=ICALL+1
./ C USERCP
./ I 4100
C--      MAXIMUM NUMBER OF EVENTS TO BE WRITTEN OUT.
      NWRTMX=100000
C--      MINIMUM AND MAXIMUM RUN NUMBERS TO BE ACCEPTED.
      NRUNMN=0
      NRUNMX=100000
C--      MINIMUM AND MAXIMUM EVENT NUMBERS TO BE ACCEPTED.
C--      IF A MINIMUM RUN NUMBER GREATER THAN 0 HAS BEEN
C--      SPECIFIED, THE MINIMUM EVENT NUMBER CUT APPLIES ONLY TO
C--      THE FIRST ACCEPTED RUN. SIMILARLY, IF A MAXIMUM RUN
C--      NUMBER LESS THAN 50000 IS GIVEN, THE MAXIMUM EVENT NUMBER
C--      CUT APPLIES ONLY TO THE LAST RUN ACCEPTED.
      NEVTMN=0
      NEVTMX=1000000
C--      MINIMUM AND MAXIMUM RECORD NUMBERS FROM THE BEGINNING
C--      OF THE INPUT DATA SET FOR WHICH THE CORRESPONDING RECORDS
C--      MAY BE WRITTEN OUT.
      NRECMN=0
      NRECMX=1000000
C--      IFPRNT=M AND ILPRNT=N SPECIFY THAT FOR THE MTH THROUGH
C--      THE NTH EVENTS TO BE WRITTEN OUT A PRINTOUT OF THE EVENT
C--      RECORD WILL BE MADE. NOT MORE THAN 10 PRINTOUTS CAN BE MADE.
      IFPRNT=1
      ILPRNT=0
// EXEC FLG,PARM.LKED='MAP,LIST',REGION=750K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USERCP)
//GO.FT10F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
//GO.FT11F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.NEWSTRT0
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.KW81043
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.NEWUPDT0
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F22ELS.TPMH630
//GO.FT03F001 DD DUMMY
C   22/03/97 703221923  MEMBER NAME  JBLINK   (JADEGS)      FORTRAN
//F11LHOLK JOB '10622622',PRODUC,CLASS=E,TIME=(0,15)
//*MAIN RELPRI=HIG,LINES=(2),ORG=EXT
//*
//LINK EXEC FCL,PARM.LKED='LIST,MAP,XREF'
//FORT.SYSIN DD *
#include "jdmain0.for"
//*
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=F11PST.JADELD
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERN.KERNLIB4
//LKED.SYSLMOD DD DISP=SHR,UNIT=FAST,DSN=F11PST.JADELD(LINKM1)
//LKED.SYSIN DD *
 INCLUDE SYSLIB(USZTRIG,ZTRIG2,DUMDU1)
//*
C   22/03/97 703221923  MEMBER NAME  JBLKMP   (JADEGS)      FORTRAN
//F11LHOLX JOB 10622622,LKED,TIME=(0,10),CLASS=E
//*MAIN RELPRI=HIG
// EXEC LKED,PARM.LKED='MAP,LIST,XREF'
//SYSPRINT DD UNIT=FAST,DSN=F11LHO.IPSLINK,
// DCB=(BLKSIZE=968,LRECL=121,RECFM=FBA),
// DISP=(NEW,CATLG,DELETE),
// SPACE=(TRK,(50,10),RLSE)
//SYSLIB DD DSN=F11LHO.GRAPHL,UNIT=FAST,DISP=SHR
//       DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//       DD DSN=F11GOD.PATRECLD,UNIT=FAST,DISP=SHR
//       DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//       DD DSN=F22ALL.JADEMUL,UNIT=FAST,DISP=SHR
//       DD DSN=F22NAR.TOFLIB.L,UNIT=FAST,DISP=SHR
//       DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
//*      DD DSN=F1EBLO.BOSLIB.L,UNIT=FAST,DISP=SHR
//*      DD DSN=R02SCH.TSOIPS.LOAD,DISP=SHR
//*      DD DSN=R02SCH.TCSUSER.LOAD,DISP=SHR
//*      DD DSN=DESYLIB,DISP=SHR
//*      DD DSN=SYS1.FORTLIB,DISP=SHR
//*      DD DSN=R01UTL.CERNLIB,UNIT=FAST,DISP=SHR
//*IPSLOADS DD DSN=R02IPS.USE.LOAD,UNIT=FAST,DISP=SHR
 INCLUDE SYSLIB(GPHMAIN)
 ENTRY MAIN
//
C   22/03/97 703221923  MEMBER NAME  JBMENU   (JADEGS)      FORTRAN
***********************************************************************
*        SEE    JADEPR.TEXT(JBJCN34)                             ******
***********************************************************************
C   22/03/97 703221923  MEMBER NAME  JBMENU0  (JADEGS)      FORTRAN
//F11OLSMN JOB 10622622,OLSSON,CLASS=E,MSGLEVEL=(0,0),TIME=(0,05)
//*MAIN RELPRI=MED
// EXEC FCLG
//FORT.SYSIN DD *
      DIMENSION A(80)
C********************** NCOPY IS NUMBER OF COPIES WANTED  *****
      NCOPY = 1
      DO 2 N=1,NCOPY
      WRITE(6,102)
      DO 1 I=1,100000
      READ(5,100,END=99) A
  100 FORMAT(80A1)
C     IF(MOD(I,33).EQ.0) WRITE(6,102)
  102 FORMAT(1H1,/)
      WRITE(6,101) A
  101 FORMAT(3X,72A1,30X,8A1)
C     WRITE(6,103)
  103 FORMAT(/)
    1 CONTINUE
   99 REWIND 5
    2 CONTINUE
      STOP
      END
//GO.FT06F001 DD SYSOUT=K
//GO.SYSIN DD *

                       ****************************
                     I                              I
                    I   JADE COMPUTER NOTE NR. 34    I
                     I                              I
                       ****************************

   *********************************************************************
   *                                                                   *
   *      JADE GRAPHICS PROGRAM           VERSION FROM  14.08.1981     *
   *                                                                   *
   *********************************************************************
                                                     J.OLSSON  L.O'NEILL

                 (THE CHANGED PARTS FROM LAST VERSION ARE MARKED BY A *)
                                   (LAST VERSION WAS DATED 15.05.80)



    TO START A SESSION AT THE IBM TSO-GRAPHICS TERMINALS:
      (IF YOU ARE NOT ABLE TO LOGON, READ THE YELLOW TSOIPS FILE BEFORE
       CALLING FOR HELP...)
    FIRST LOGON UNDER TSO BY ENTERING:

                    LOGON IDENTIFIER SIZE(834)
                    KEYWORD

*   OBS... THE SIZE PARAMETER IS NECESSARY, SINCE THE JADE GRAPHICS
*          MODULE IS TOO BIG FOR THE DEFAULT TSO REGION (ABOUT 600K).
*          IF YOU LEAVE THE SIZE PARAMETER OUT, YOUR SESSION WILL
*          SOON ABEND WITH AN ERROR CODE 80A

    TO  ENTER THE GRAPHICS PROGRAM, NOW PROCEED WITH

                    IPS LIBRARYNAME(MODULENAME)

               EXAMPLE:   IPS 'F11LHO.GRAPHL(JADEZ)'
               OR         IPS GRAPHL(JADEZ)        IF YOU ARE F11LHO
    OBS.... THE LIBRARY F11LHO.GRAPHL IS KEPT AS STANDARD LIBRARY FOR
            GRAPHICS MODULES. IT IS FREQUENTLY UPDATED TO ACCOUNT FOR
            RECENT IMPROVEMENTS.
*           THE "STANDARD MODULE" HAS THE NAME  JADEZ

    AFTER PRINTING SOME GREETINGS AND OTHER GENERAL INFORMATION,
    THE GRAPHICS PROGRAM NOW REQUESTS THE NAME OF A CATALOGUED DATA SET.
    THIS HAS TO BE ENTERED WITH FULL IDENTIFIER, E.G. F22ELS.TPMH735C ;
    THE DATA SET MOREOVER HAS TO BE "ON DISK", OR IN MASS STORAGE, MSS.

    IF THE INPUT FILE HAS BEEN ALLOCATED SUCCESSFULLY, THE PROGRAM NOW
    ASKS WHETHER THE SCANNER WANTS TO WRITE EVENTS OR NOT.
        ANSWERING  'YES'  STARTS A DIALOGUE, IN WHICH THE SCANNER HAS
        TO SPECIFY OUTPUT DATA SET AND WHETHER HE WANTS TO ADD EVENTS TO
        ALREADY EXISTING ONES OR TO OVERWRITE THEM.
        THE SCANNER IS ALSO ASKED TO SPECIFY THE WRITE MODE, IN CASE OF
        OVERWRITING THE FILE. THE CHOICE IS BETWEEN BOS M AND BOS S
        FORMATS.
        OBS.....   IF YOU WRITE IN BOS M FORMAT AND THE SYSTEM CRASHES
                   YOUR OUTPUT FILE IS LEFT IN AN UNDEFINED STATE. THIS
                   DOES NOT HAPPEN WITH BOS S FORMAT, WHICH IS STRONGLY
                   RECOMMENDED.
        FINALLY THE SCANNER IS GIVEN THE OPPORTUNITY TO ALLOCATE A FILE
        FOR SAVING INTERMEDIATE  'EDITING' RESULTS.

*   OBS... THESE OUTPUT FILES MUST EXIST BEFORE YOUR SESSION, THEY WILL
*          NOT BE CREATED BY THE GRAPHICS PROGRAM.

    THE PROGRAM NOW REQUESTS A STANDARD VIEW.THIS VIEW APPEARS AUTO-
    MATICALLY WHEN A NEW EVENT IS READ (SEE ALSO COMMAND CSTV BELOW).
    AND IS TO BE CHOSEN FROM THE AVAILABLE VIEWS LISTED BELOW:
       RA=1, RB=2, RC=3, ZXA=4, ZXB=5, ZXC=6, ZXD=7, ZYA=8, ZYB=9,
*      ZYC=10, ZYD=11, FW=12, RU=13, CYL=14, FWMU=15.
     THE NUMBER CODE IS TO BE ENTERED.

*   THE PROGRAM NOW USES SOME TIME TO ALLOCATE VARIOUS CALIBRATION
*   FILES. AT TIMES OF HEAVY COMPUTER OCCUPANCY, THIS MAY BE A FEW
*   MINUTES. BE PATIENT AND DO SOMETHING USEFUL MEANWHILE...

    THE SCANNER IS NOW REQUESTED TO SET USER INDICES, CORRESPONDING TO
    VARIOUS LEVELS IN THE ANALYSIS PROGRAM CHAIN. AT THESE POINTS
    THE SCANNER CAN GIVE COMMANDS TO LOOK AT THE EVENT IN VARIOUS VIEWS,
    DISPLAY RESULTS OF ANALYSIS ROUTINES PERFORMED SO FAR, ETC.
         WARNING: NOT SETTING ANY INDICES LEADS TO A READING THROUGH OF
                  THE COMPLETE DATA SET WITHOUT ANY STOPPING.
    THE LEVELS OF THE SUPERVISOR ANALYSIS PROGRAM ARE LISTED BELOW:

         INDEX=1   CALLED AT THE BEGINNING OF EACH NEW RUN.
               2   CALLED IMMEDIATELY AFTER EVENT IS READ INTO /BCS/.
               3   LEAD GLASS ENERGIES HAVE BEEN COMPUTED.
               4   FAST Z VERTEX RECONSTRUCTION HAS BEEN DONE.
               5   INNER DETECTOR PATTERN RECOGNITION HAS BEEN RUN.
               6   ENERGY CLUSTERS IN THE LEAD GLASS HAVE BEEN FOUND.
               7   UNUSED
               8   MUON CHAMBER TRACKING HAS BEEN DONE.
               9   UNUSED
              10   UNUSED

    WHEN SCANNING ALREADY PROCESSED EVENTS, IT IS SUFFICIENT TO STOP AT
*   LEVEL 2. EVENTS THAT HAVE PASSED THE REDUC1 PROGRAM HAS ANALYSIS
*   PERFORMED UP TO LEVEL 5, I.E. NO CLUSTER ANALYSIS HAS BEEN DONE.

*   EXAMPLE:  LEVELS 2 AND 6 ARE SET.  WHEN THE PROGRAM HAS READ AN
*             EVENT, IT WILL HALT AT THE LEVEL WITH THE LOWEST NUMBER,
*             I.E. 2, AND DISPLAY IT IN THE STANDARD VIEW. TO PROCEED
*             TO NEXT LEVEL, I.E. 6, THE COMMAND "C" MAY BE USED.
*             TO SKIP THIS LEVEL AND IMMEDIATELY GO TO NEXT EVENT, THE
*             COMMAND "N" IS USED
*   THE LEVELS CAN BE CHANGED AT ANY POINT IN THE SESSION BY THE
*   COMMAND CSTL, SEE BELOW.

    IF THE LONGER DIALOGUE MENTIONED ABOVE IS GONE THROUGH, ANOTHER SET
    OF STOP FLAGS CAN BE PUT INTO ACTION, WHICH CAN HALT THE PROGRAM
    IF ANY SPECIAL CONDITION IS FULFILLED IN ANY ANALYSIS ROUTINE. THIS
    HAS TO BE CODED FOR BY THE USER, AND LOADED INTO A PRIVATE GRAPHICS
    MODULE. NORMALLY JUST ENTER HERE.

    THE FIRST EVENT ON THE FILE WILL NOW APPEAR ON THE SCREEN AND ALL
    COMMANDS LISTED BELOW ARE AVAILABLE TO THE SCANNER.

    EXPLANATION OF THE VARIOUS COMMANDS
    -----------------------------------

    MENU:   DISPLAYS LIST OF AVAILABLE COMMANDS WITH SHORT EXPLANATIONS.

    HELP:   DISPLAYS MORE DETAILED INFORMATION ON ANY COMMAND WHICH IS
            GIVEN IN UPON PROMPTING.
            THIS COMMAND IS STILL INACTIVE, SORRY.

    NEWS:   DISPLAYS NEWS OF RECENT CHANGES TO THE GRAPHICS.

------------- THE STANDARD VIEWS:

      RA:   DISPLAY EVENT IN R-PHI VIEW. ONLY INNER DETECTOR.

      RB:   DISPLAY EVENT IN R-PHI VIEW. INNER DETECTOR AND LEAD GLASS.

      RC:   DISPLAY EVENT IN R-PHI VIEW. INNER DETECTOR, LEAD GLASS AND
                                         MUON FILTER.

     ZXA:   DISPLAY EVENT IN Z-X VIEW. ONLY INNER DETECTOR.

     ZXB:   DISPLAY EVENT IN Z-X VIEW. INNER DETECTOR AND LEAD GLASS.

     ZXC:   DISPLAY EVENT IN Z-X VIEW. INNER DETECTOR, LEAD GLASS AND
                                       MUON FILTER.

     ZXD:   DISPLAY EVENT IN Z-X VIEW. INNER DETECTOR, LEAD GLASS, MUON
                                       FILTER AND FORWARD DETECTOR.

       OBS... THE ZX OR ZY VIEWS ARE SHOWN IN THE R - Z MODE, I.E. THE
            RADII OF HITS ARE ROTATED INTO THE PLANE OF THE VIEW. THE
            TRUE PROJECTIONS ARE OBTAINED BY SWITCHING CDTL 9.

     ZYA:   DISPLAY EVENT IN Z-Y VIEW. ONLY INNER DETECTOR.

     ZYB:   DISPLAY EVENT IN Z-Y VIEW. INNER DETECTOR AND LEAD GLASS.

     ZYC:   DISPLAY EVENT IN Z-Y VIEW. INNER DETECTOR, LEAD GLASS AND
                                       MUON FILTER.

     ZYD:   DISPLAY EVENT IN Z-Y VIEW. INNER DETECTOR, LEAD GLASS, MUON
                                       FILTER AND FORWARD DETECTOR.

* OBS... THE ZX AND ZY VIEWS SHOW AS DEFAULT A ROTATED PROJECTION OF
*        CHAMBER HITS. THIS IS TO SHOW CORRELATION WITH THE LEAD GLASS
*        ENERGIES, WHICH ARE ALWAYS SHOWN IN THIS FASHION. THE TRUE
*        PROJECTIONS OF CHAMBER HITS CAN BE OBTAINED IF DISPLAY DETAIL 9
*        IS FLIPPED,  COMMAND "CDTL 9".
*        THE CURRENT VERSION, PROJECT MODE OR ROTATE MODE, IS WRITTEN AT
*        THE TOP OF THE PICTURE.

      FW:   DISPLAY OVERALL VIEW OF THE FORWARD DETECTOR.
*           LEAD GLASS BLOCK ENERGIES ARE DISPLAYED WITH THE SAME CODE
*           AS IN THE FOLLOWING VIEW, RU.

      RU:   DISPLAY EVENT IN A ROLLED OUT VIEW OF ALL LEAD GLASS BLOCKS,
            INCLUDING ENDCAPS AND FORWARD DETECTOR. THE PULSE HEIGHTS
            ARE DISPLAYED WITH A NUMBER AND LETTER CODE AS FOLLOWS:
                 0:  LESS THAN 10 MEV
                 1:  BETWEEN 10 AND 20 MEV
                  .........
                 A:  BETWEEN 100 AND 200 MEV
                  .........
                 J:  BETWEEN 1000 AND 2000 MEV
                  .........
                 S:  BETWEEN 10000 AND 20000 MEV

*           THE CODE IS AVAILABLE AT THE SCREEN VIA COMMAND "BL 6"
            IN MAGNIFIED VIEWS, THE PULSE HEIGHTS ARE WRITTEN OUT IN MEV

     CYL:   DISPLAYS EVENT IN A PERSPECTIVE VIEW, INCLUDING INNER DETEC-
            TOR HITS AND LEAD GLASS HITS IN THE MAIN CYLINDER.

    FWMU:   DISPLAYS FORWARD MUON COUNTERS ONLY

---------- END OF STANDARD VIEWS

    STVW:   DISPLAYS EVENT IN THE STANDARD VIEW.
            THIS COMMAND IS USEFUL, IF A MAGNIFIED VIEW HAS BEEN CHOSEN
            AS STANDARD VIEW. THIS IS POSSIBLE BY THE COMMAND CSTV 1.

     DET:   DRAWS THE DETECTOR ONTO THE CURRENT EVENT DISPLAY.

     PRO:   DRAWS PROJECTIONS OF Z-X AND Z-Y VIEWS IN SMALLER SCALE ONTO
            R-FI VIEWS. AVAILABLE IN VIEWS RA,RB,RC AND CYL.
            IF DISPLAY DETAIL FLAG 17 IS .TRUE. PROJECTIONS APPEAR AUTO-
            MATICALLY. THIS IS OBTAINED WITH COMMAND 'CDTL 17'
            IF THE COMMAND IS GIVEN IN A MAGNIFIED R-FI VIEW, ONLY THOSE
            HITS WHICH HAVE THEIR R-FI COORDINATES INSIDE THE MAGNIFIED
            VIEW, APPEAR IN THE PROJECTIONS.
*           THESE VIEWS ARE TRUE PROJECTIONS, NOT R - Z VIEWS.
*           SWITCHING CDTL 9 WILL CAUSE THE R-Z MODE TO APPEAR IN THE
*           PROJECTIONS.

      BW:   WRITES THE CONTENTS OF A SPECIFIED BANK ONTO THE SCREEN.
            THE BANK NAME IS PROMPTED FOR.
            EACH PAGE CAN BE SUBMITTED FOR HARDCOPY.
            THE STANDARD PRINT FORMAT IS INT*2 ; HOWEVER, MANY BANKS
            ARE NOW PRINTED WITH TAILOR MADE FORMATS
            IF SEVERAL BANKS WITH THE SAME NAME EXIST, THE SCANNER IS
            PROMPTED TO GIVE THE BOS BANK NUMBER.
            IF A BANK DISPLAY EXTENDS OVER SEVERAL PAGES, THE SCANNER
            IS GIVEN THE POSSIBILITY TO STOP AFTER EACH PAGE.
*           IF A NEGATIVE TRAILING NUMBER, E.G. "BW -1" IS ENTERED, A
*           LIST OF ALL BANKS IN THE EVENT IS DISPLAYED.

    STOP:   THIS IS THE NORMAL WAY TO END A SESSION.
            THE "PANIC BUTTON" TO ABORT A SESSION:   CONTROL+G

       C:   CONTINUE. THE ANALYSIS PROGRAM CONTINUES TO THE NEXT LEVEL
            FLAG SET BY THE SCANNER. IF ONLY ONE FLAG WAS SET, THE NEXT
            EVENT IS READ.
            IF AN OUTPUT FILE HAS BEEN ALLOCATED, THIS COMMAND LEADS TO
            A WRITING OUT OF THE EVENT, WHEN GOING TO THE NEXT ONE.

    JUMP:   A USER LEVEL INDEX IS REQUESTED. THE ANALYSIS PROGRAM THEN
            PROCEEDS TO THE SPECIFIED LEVEL.
*           THE LEVEL CAN BE ENTERED AS A TRAILING NUMBER, E.G. JUMP 6

       N:   READ NEXT EVENT. A TRAILING NUMBER CAN BE ENTERED TO SKIP
            SEVERAL EVENTS. EXAMPLE: IF THE PRESENT EVENT IS 16, THE
            COMMAND N 3 CAUSES THE READING OF EVENT 19, N -3 EVENT 13.

    JOYS:   THE JOYSTICK IS ACTIVATED, VISIBLE AS A HAIR CROSS ON SCREEN
            THE JOYSTICK INPUT IS GIVEN BY:       CONTROL + E
            THE COMMAND IS USED TO ENLARGE A PARTICULAR AREA OF THE PIC-
            TURE. TWO MODES ARE AVAILABLE:
            JOYS WITH A TRAILING NUMBER: ONE JOYSTICK INPUT; POSITION
                WILL BE CENTER OF MAGNIFIED VIEW, TRAILING NUMBER GIVES
                THE DEGREE OF MAGNIFICATION.
            JOYS WITHOUT TRAILING NUMBER: TWO JOYSTICK INPUTS SPECIFY
                OPPOSITE CORNERS OF NEW VIEW; THIS AUTOMATICALLY GIVES
                THE MAGNIFICATION.

      RS:   RESETTING THE SCALE, IF CHANGED BY COMMAND JOYS.

       H:   HARDCOPY OF THE PRESENT VIEW IS GENERATED ON GOULD PLOTTER
            AFTER SOME WAITING TIME A MESSAGE APPEAR: DATA SUBMITTED TO
            PLOTTER QUEUE.
            A TRAILING NUMBER (E.G. H 3) GENERATES SEVERAL IDENTICAL
            HARDCOPIES. MAXIMUM IS 4, HOWEVER.

*           IF SEVERAL COMMANDS HAVE BEEN GIVEN, LIKE COM,RES,PRO,ETC..
*           AND THE END OF PAGE IS REACHED, ONE CAN CONTINUE ON NEXT
*           PAGE; THE HARDCOPY WILL STILL HAVE ALL THE DRAWN INFORMA-
*           TION. THE PICTURE IS CLOSED BY HARDCOPY REQUEST, OR BY THE
*           SOFTWARE "CALL ERASE", E.G. WHEN GIVING ONE OF THE STANDARD
*           VIEW COMMANDS.

    WRIT:   WRITE THE CURRENT EVENT AND READ NEXT EVENT. THIS COMMAND IS
            AVAILABLE ONLY IF THE SCANNER HAS SPECIFIED A DATA SET FOR
            WRITING ONTO, IN THE INITIALIZATION STAGE OF THE SESSION.

     COM:   GIVES THE SCANNER POSSIBILITY TO ADD HIS OWN COMMENTS TO THE
            PICTURE, IN ANY PLACE. THE COMMENTS APPEAR ON THE HARDCOPY.
            POSITION (BY JOYSTICK) AND COMMENT IS PROMPTED FOR.

    BDLS:   DELETE A BANK. THE NAME IS PROMPTED FOR AS WELL AS THE BOS
            BANK NUMBER IF MORE THAN ONE BANK WITH THE SAME NAME EXIST.
            IF THE BANK 'JETC' IS DELETED, A RENUMBERING OF THE RAW
            DATA BANK 'JETC' IS DONE, SO THAT PASSING LEVEL 4 WILL LEAD
*           TO A PROPER RECALIBRATION. FOR THIS TO BE USEFUL, ONE SHOULD
*           OF COURSE GIVE THE COMMAND AT LEVEL 2 OR 3

    CSTL:   COMMAND TO CHANGE THE USER-LEVEL FLAGS IN ANALYSIS PROGRAM.

    CSTV:   COMMAND TO CHANGE OPTIONS IN THE STANDARD VIEW.THE FOLLOWING
            CHANGES ARE AVAILABLE:
                       1 FREEZE STANDARD VIEW.
*                        THE CURRENT VIEW WILL APPEAR AS STANDARD VIEW
*                        IN THE NEXT EVENT, OR AT NEXT LEVEL ENTERED.
                       2 TURN ON/OFF AUTOMATIC DISPLAY OF NEW EVENT.
                       3 TURN ON/OFF DETECTOR WITH STANDARD VIEW.

            CSTV CAN BE ENTERED WITH A TRAILING NUMBER.

    CDTL:   COMMAND TO CHANGE DETAILS IN THE VARIOUS DISPLAY VIEWS. THE
            FOLLOWING CHANGES ARE AVAILABLE:
                  1 TURN ON/OFF DISPLAY OF INNER DETECTOR.
                  2 TURN ON/OFF DISPLAY OF LEAD GLASS.
                  3 TURN ON/OFF DISPLAY OF MUON FILTER.
                  4 TURN ON/OFF DISPLAY OF CHAMBER WALLS.
                  5 TURN ON/OFF DISPLAY OF CHAMBER WIRES.
                  6 TURN ON/OFF CROSSES FOR INNER DET. HITS.
                  7 TURN ON/OFF HISTOGRAMS OF LEAD GLASS ENERGY.
                  8 TURN ON/OFF SHRINKING OF MUON HIT RADIUS.
                  9 TURN ON/OFF Z-RADIUS DISPLAY OF TRACKS.
                 10 TURN ON/OFF MIRROR HITS IN Z-RADIUS MODE.
                 11 TURN ON/OFF T2 TRIGGER DISPLAY
                 12 TURN ON/OFF TRACK NUMBERS IN RES. DISPLAY OF ID
                 13 TURN ON/OFF TRACK BANK WRITING IN RES. DISPLAYS
                 14 TURN ON/OFF SINGLE TRACK DISPLAY IN COMMAND RES
                 15 TURN ON/OFF DASH LINE DRAWING OF LEAD GLASS
                                AVAILABLE IN VIEWS CYL AND RU
                 16 TURN ON/OFF RESULT (TRACK FIT) DISPLAY.
                 17 TURN ON/OFF Z-X AND Z-Y PROJECTIONS.
                 18 TURN ON/OFF T3 TRIGGER DISPLAY
                 19 TURN ON/OFF FITTED TRACK DISPLAY FROM CLOSEST
                                APPROACH TO ORIGIN.
                 20 TURN ON/OFF HIT DISPLAY IN PROJECTIONS.
                 21 TURN ON/OFF HIT DISPLAY IN INNER DETECTOR
                 22 TURN ON/OFF MU-HIT NUMBER DISPLAY
                 23 TURN ON/OFF PROJECTION OF FITTED TRACKS TO LEAD
                                GLASS LIMIT.
                 24 TURN ON/OFF MU DISPLAY OF "OUT OF PLANE" HITS
                 25 TURN ON/OFF OVERLAP OF SCINTILLATORS IN FORWARD
                                DETECTOR DISPLAY  (COMMAND FW)
                 26 TURN ON/OFF SUPPRESSION OF ODD LAYER HITS IN JETC.
    (THIS IS USEFUL TO SPEED UP THE DISPLAY, AT SLOW RESPONSE TIME)
                 27 TURN ON/OFF DISPLAY OF MAIN VERTEX
                 28 TURN ON/OFF DISPLAY OF PHOTONS TOGETHER WITH
                                CHARGED TRACKS (COMM. RES,TR,VRES)
                 29 TURN ON/OFF DISPLAY OF PHOTONS WITHOUT CHARGED
                                TRACKS (COMMAND RES,TR,VRES)
*                30 TURN ON/OFF DISPLAY OF FORWARD MUON CNTR TOF VALUES
*                31 TURN ON/OFF DISPLAY OF TRACK NR IN TR DISPLAY
*                32 TURN ON/OFF DISPLAY OF TRACK NR IN VRES DISPLAY
*                33 TURN ON/OFF DISPLAY OF TOF NUMBERS, COUNTER NUMBERS
*                34 TURN ON/OFF DISPLAY OF SPINNING 1-BLOCK PHOTONS
*                35 TURN ON/OFF DISPLAY OF PHOTONS BELOW 200 MEV

            CDTL CAN BE ENTERED WITH A TRAILING NUMBER.

    CPAR:   COMMAND TO CHANGE PARAMETERS IN MONTE CARLO EVENTS.

    TRUE:   DISPLAYS THE "TRUE" TRACKS IN A MONTE CARLO EVENT. THE
            FOLLOWING TRAILING NUMBER OPTIONS ARE AVAILABLE:
                       0 ONLY CHARGED TRACKS ARE DISPLAYED.
                       1 ONLY PHOTONS ARE DISPLAYED.
                       2 BOTH CHARGED TRACKS AND PHOTONS ARE DISPLAYED.
                       3 THE PARTICLE CHARGES, ORIGIN COORDINATES AND
                          MOMENTUM VECTORS ARE WRITTEN TO THE SCREEN.
                          A HARD COPY CAN THEN BE MADE.
            THIS COMMAND IS UNFORTUNATELY ONLY WORKING IN MC EVENTS.

    CLUS:   DISPLAY THE RESULTS OF THE LEAD GLASS CLUSTER ROUTINES.
             THE COMMAND CAN BE GIVEN WITH THE FOLLOWING TRAILING
             NUMBERS:
                    NONE OR 0: DISPLAY CLUSTER STRUCTURE IN BARREL AND
                                END CAPS.
                            1: DISPLAY CLUSTER STRUCTURE AND GAMMA
                                DIRECTIONS DERIVED BY CLUSTER ANALYSIS
                                ROUTINES.
                            2: WRITE TO SCREEN THE NUMERICAL RESULTS
                                OF CLUSTER ANALYSIS.
                            3: EXECUTE CLUSTER ANALYSIS, E.G. IF THE
                                SUPERVISOR HAS NOT YET CALLED IT. IF
                                THE CLUSTER ANALYSIS BANK DOES EXIST
                                IT IS DELETED AND REPLACED. NOTHING IS
                                DISPLAYED FOLLOWING THIS COMMAND.

      ZV:   DISPLAY THE RESULTS OF THE Z-VERTEX ROUTINE.
                     A SMALL COMMAND (BY NUMBERS) MENU IS AVAILABLE

    MUPT:   DISPLAY THE RESULT OF PATTERN RECOGNITION IN THE MUON FILTER
             THE COMMAND CAN BE GIVEN WITH THE FOLLOWING TRAILING
             NUMBERS:
*                   NONE OR 0: DISPLAY THE FITTED TRACKS FOUND BY MUON
*                               PATTERN RECOGNITION.
*                          -N: REANALYSIS OF MUON PATTERN RECOGNITION
*                              AND DISPLAY OF ALL TRACKS.
*                           N: DISPLAY OF TRACK NR N ONLY.

     RES:   DISPLAY ANALYSIS RESULTS. PRESENTLY AVAILABLE FOR PATREC
            AND LEAD GLASS CLUSTER ANALYSIS RESULTS. THE BANK BOS NUMBER
            (FOR BANK PATR) CAN BE ENTERED AS A TRAILING NUMBER.
            IF NOT GIVEN, THE LOWEST BANK NUMBER IS LOOKED FOR.
              IF DISPLAY DETAIL 14 IS SET, SINGLE TRACK DISPLAY IS
                 AVAILABLE. THE WANTED TRACK IS SPECIFIED BY A TRAILING
                 NUMBER.
              IF DISPLAY DETAIL 17 IS SET, THE FITTED TRACKS ALSO APPEAR
                 IN THE PROJECTIONS.
              IF DISPLAY DETAIL 28 OR 29 IS SET, PHOTONS ARE DISPLAYED
                 AS HATCHED LINES. THE NUMBERS CORRESPOND TO THE TRUE
                 PHOTON NUMBER, I.E. PHOTON NR 3 IS THE THIRD LEAD GLASS
                 CLUSTER THAT IS NOT ASSOCIATED WITH A CHARGED TRACK.
                 A LIST OF CLUSTER INFORMATION IS ALSO PRINTED, WITH
                 INFORMATION ON THE PHOTON NUMBER OR ASSOCIATED CHARGED
*                TRACK NUMBER. SEE ALSO CDTL 34,35.

            IN THE VIEW RU (ROLLED OUT LEAD GLASS VIEW), THE IMPACT
            POINTS OF THE CHARGED TRACKS ARE DISPLAYED TOGETHER WITH THE
            NEUTRAL CLUSTERS. A LIST OF CLUSTER INFORMATION IS PROVIDED.

      TR:   COMMAND TO DISPLAY PATTERN RECOGNITION RESULTS AS STORED IN
            THE HIT LABEL ARRAY 'JHTL'.
            THE BOS BANK NUMBER CAN BE ENTERED AS A TRAILING NUMBER. IF
            NO NUMBER IS ENTERED, THE LOWEST IS TAKEN.
            THE SCANNER IS ASKED TO ENTER ONE OF THE FOLLOWING OPTIONS:
                 CODE 0 :  CODE LIST
                 CODE 1 : DISPLAY ALL HITS ASSOCIATED WITH TRACKS
                 CODE 2 : DISPLAY ALL HITS NOT ASSOCIATED WITH TRACKS
                 CODE 3 : DISPLAY ALL HITS ASSOCIATED WITH TRACKS,
                          MARKING SELECTED ONES
                 CODE 4 : DISPLAY ALL HITS,MARKING TRACK-ASSOCIATED ONES
                 CODE 5 : DISPLAY RAW EVENT, MARKING SELECTED TRACKS.

*           IF A TRAILING NR 1 TO 5 IS ENTERED, IT IS INTERPRETED AS THE
*           CORRESPONDING VIEW OPTION, WITH THE LOWEST NUMBER JHTL AND
*           PATR BANKS.
*           THIS COMMAND ENABLES THE SCANNER TO DISPLAY ID HITS WITH
*           SUPRESSION OF MIRROR HITS.

    MASS:   COMMAND TO COMPUTE INVARIANT MASS OF A GIVEN SYSTEM OF PAR-
            TICLES. PARTICLE NUMBERS AND TYPES ARE PROMPTED FOR. THE
            COMMAND CAN BE USED FOR CHARGED TRACKS AS WELL AS FOR GAMMAS
            AND TRACK ASSOCIATED CLUSTERS. IF MORE THAN ONE CHARGED
            TRACK IS ENTERED, A VERTEX FIT IS PERFORMED, AND 4-VECTORS
            ARE TAKEN WITH RESPECT TO THE FOUND VERTEX. A LIST OF THE
            VARIOUS RESULTS IS WRITTEN ON THE SCREEN.

    TRG2:   COMMAND TO DISPLAY TRIGGER 2 INFORMATION ONTO THE INNER
            DETECTOR.

      VX:   DISPLAY THE RESULT OF THE VERTEX PROGRAM. SEVERAL OPTIONS
            ARE AVAILABLE, TO BE ENTERED AS TRAILING NUMBERS:
                       0 : MAIN VERTEX IS DISPLAYED AS A CROSS
                       1 : ALL VERTICES ARE DISPLAYED AS CROSSES, WITH
                           THE NUMBERS WRITTEN CLOSE BY. A LIST OF
                           VERTEX INFORMATION IS ALSO WRITTEN OUT AND
                           APPEARS ON THE HARDCOPY.
                       2 : ALL E+E- (PHOTON CONVERSION) VERTICES ARE
                           DISPLAYED.
                       3 : CREATE THE BANK 'GVTX' WITH THE RESULTS FROM
                           THE VERTEX PROGRAM.
            SEE ALSO UNDER COMMAND CDTL FOR AUTOMATIC VERTEX DISPLAY.
            FOR MORE INFORMATION, SEE JADE COMPUTER NOTE 32.

    DEDX:   DISPLAY THE RESULT OF THE DEDX PROGRAM. SEVERAL OPTIONS
            ARE AVAILABLE, TO BE ENTERED AS TRAILING NUMBERS:
                       0 : DEDX RESULTS FOR ALL CHARGED TRACKS ARE
                           WRITTEN ON THE SCREEN (NOT ON HARDCOPY).
                     ITR : DEDX RESULT FOR TRACK ITR IS WRITTEN ON THE
                           SCREEN ( NOT ON THE HARDCOPY)
                      -1 : THE BANK 'DEDX' IS CREATED WITH DEDX RESULTS
                           AND CAN BE INSPECTED WITH THE COMMAND BW.
                           AT PRESENT, THE CONTENT OF BANK 'DEDX' CORRE-
                           SPONDS EXACTLY TO THE CONTENT OF BANK 'TPTR'
                      -2 : A GRAPH DEDX VS MOMENTUM IS DRAWN, WITH
                           ENTRIES FOR EACH TRACK. THE THEORETICAL
                           CURVES USED IN ASSIGNING CHISQUARES FOR PAR-
                           TICLE IDENTIFICATION ARE ALSO DRAWN.

     TOF:   DISPLAY THE RESULT OF THE TOF PROGRAM. SEVERAL OPTIONS
            ARE AVAILABLE, TO BE ENTERED AS TRAILING NUMBERS:
                       0 : TOF RESULTS FOR ALL CHARGED TRACKS ARE
                           WRITTEN ON THE SCREEN (NOT ON HARDCOPY).
                     ITR : TOF RESULTS FOR TRACK ITR IS WRITTEN ON THE
                           SCREEN ( NOT ON THE HARDCOPY)
                      -1 : THE BANK 'TOFR' IS CREATED AND CAN BE
                           INSPECTED WITH THE COMMAND BW. THE FORMAT IS
                           DESCRIBED IN JADE COMPUTER NOTE 20.
                      -2 : A GRAPH BETA VS MOMENTUM IS DRAWN, WITH
                           ENTRIES FOR EACH TRACK. THE THEORETICAL
                           CURVES USED IN ASSIGNING CHISQUARES FOR PAR-
                           TICLE IDENTIFICATION ARE ALSO DRAWN.

      QP:   THE Q-PLOT ANALYSIS PROGRAM OF KOBAYASHI IS CALLED UP.
            SEVERAL DISPLAY OPTIONS EXIST, AS TRAILING NUMBERS:
                       1 : 3-VECTORS OF CHARGED TRACKS AND PHOTONS
                           ARE DISPLAYED IN TWO DIFFERENT PLANES OF THE
                           MOMENTUM ELLIPSOID. LEAD GLASS ENERGIES ARE
                           SHOWN IN HISTOGRAM FASHION.
                       2 : 3-VECTORS OF CHARGED TRACKS AND PHOTONS
                           ARE DISPLAYED IN THREE DIFFERENT PLANES OF
                           THE MOMENTUM ELLIPSOID.
                       3 : THE TRIANGULAR Q-PLOT IS DRAWN, WITH THE
                           POSITION OF THE EVENT MARKED. THIS Q-PLOT IS
                           ALSO DRAWN IN OPTIONS 1 AND 2 ABOVE.

      BL:   THIS COMMAND CONTAINS SOME OPTIONS USEFUL IN LEAD GLASS
*           ANALYSIS. THE CURRENT VIEW MUST BE 'RU OR FW'.
            THE OPTIONS (CAN BE ENTERED AS TRAILING NUMBERS) ARE:
                       1 : DISPLAY LIST OF OPTIONS
                       2 : WRITE BLOCK NUMBERS FOR ALL BLOCKS THAT
                           CONTAIN ENERGY. MAGNIFICATION IS NEEDED.
                       3 : SHOW ALL BLOCKS THAT WERE KILLED IN THE 'BAD
                           LEADGLASS ANALYSIS', I.E. BLOCKS PRESENT IN
                           BANK 'ALGL' BUT NOT IN BANK 'ALGN'.THE CORRE-
                           SPONDING BLOCKS ARE MARKED WITH A CROSS.
                       4 : SHOW WHICH OF CURRENTLY HIT BLOCKS ARE KNOWN
                           AS 'SPINNERS'.MARKING IS DONE BY A HEAVY BOX.
                       5 : SHOW CURRENT DEAD BLOCKS, I.E. BLOCKS WHICH
                           WERE SWITCHED OFF IN THIS PERIOD.THE MARKING
                           IS HERE DONE WITH A HEAVY CIRCLE.
*                      6 : WRITE OUT THE CODE INFORMATION FOR DISPLAY OF
*                          PULSEHEIGHTS IN NON-MAGNIFIED VIEWS.
*                      7 : PRINT CLUSTER NUMBERS FOR KNOWN SPINNING
*                          BLOCKS.   AVAILABLE IN ALL VIEWS.

*   VRES:   THIS COMMAND IS A VARIANT OF THE RES COMMAND. IT USES INFOR-
*           MATION FROM THE VERTEX PROGRAM (COMMAND VX) AND DISPLAYS
*           CHARGED TRACKS FROM THE CORRESPONDING VERTEX. PHOTONS ARE
*           TAKEN TO COME FROM THE MAIN VERTEX. THE OPTIONS, ENTERED
*           AS TRAILING NUMBERS, ARE:
*                      0 : DISPLAY ALL TRACKS FROM THEIR VERTICES.
*                     -N : DISPLAY ALL TRACKS FROM VERTEX NR N ONLY.
*                      N : DISPLAY TRACK NR N ONLY. THIS IS ACTIVE ONLY
*                          IF CDTL 14 HAS BEEN ACTIVATED.

*   FIND:  THIS COMMAND ENABLES THE SCANNER TO FIND A PARTICULAR EVENT.
*          IF NOT ENTERED AS TRAILING NUMBERS (FIND NRUN NEVENT), THE
*          RUN AND EVENT NUMBERS ARE PROMPTED FOR. THE PROGRAM PROCEEDS
*          TO SEARCH FOR THE DESIRED EVENT AND DISPLAYS IT EVENTUALLY.

    SPVA:   USER DEVOTED COMMAND. THIS COMMAND CAUSES A CALL TO SUB-
            ROUTINE SPARE, WHICH CAN BE SUPPLIED BY THE USER IN A
*           PRIVATE GRAPHICS MODULE. IN THE STANDARD MODULE THIS IS A
*           DUMMY COMMAND. MORE ABOUT PRIVATE MODULES IN THE GENERAL
*           COMMENTS BELOW.

------------- EDITING COMMANDS -----

    EDIT:   COMMAND TO EDIT RESULTS OF PATTERN RECOGNITION IN INNER
            DETECTOR.
            THIS COMMAND ENTERS THE SCANNER INTO A DISPLAY ROUTINE WITH
            A NUMBER OF SUBCOMMANDS. THESE AND EDITING IN GENERAL ARE
            DESCRIBED IN A SEPARATE NOTE (JADE COMPUTER NOTE 28)

     RET:   THIS COMMAND (RETURN) IS TO BE USED IF THE SCANNER CALLS THE
            GRAPHICS DISPLAY PROGRAM FROM THE EDITING PROGRAM (SEE THE
            DESCRIPTION OF EDITING IN JADE COMPUTER NOTE NR 28). THE
            COMMAND HAS NO EFFECT "OUTSIDE EDITING".

    SAVE:   COMMAND TO WRITE THE CONTENT OF COMMON /CWORK/ OUT TO A
            SCRATCH FILE, TOGETHER WITH HEAD BANK INFORMATION. THIS
            COMMAND IS HEAVILY USED IN EDITING. A CATALOGUED SCRATCH
            FILE MUST HAVE BEEN ALLOCATED AT SESSION BEGIN, OF COURSE.

-------- END EDITING COMMANDS ---

     LIM:   COMMAND TO CHANGE COMMON /CPATLM/, WHICH HOLDS ALL LIMITS
            THAT ARE USED IN PATREC ROUTINES.
            THE COMMON /CJDRCH/ CAN ALSO BE CHANGED BY THIS COMMAND
            THE TWO OPTIONS ARE PROMPTED FOR OR CAN BE OBTAINED AUTOMA-
            TICALLY BY A TRAILING NUMBER:
                          1 :    /CPATLM/
                          2 :    /CJDRCH/
            THIS COMMAND CAN OF COURSE ALSO BE USED FOR RESETTING TO
            DEFAULT VALUES OR SIMPLY TO INSPECT CURRENT VALUES.

    SETF:   GIVES THE SCANNER POSSIBILITY TO SET HIS OWN FLAG FOR PERSO-
            NAL USE IN THE USER ROUTINE CODING, IN A PRIVATE MODULE.

  ---------------------------------------------------------------

                        GENERAL COMMENTS:
                      --------------------

  TRAILING NUMBERS:    ANY VIEW COMMAND FOLLOWED BY A TRAILING NUMBER
                       (EXCEPT 0) WILL CAUSE THE CORRESPONDING DETECTOR
                       TO APPEAR WITH THE EVENT DISPLAY.

*                      COMMANDS WITH VARIOUS OPTIONS CAN NORMALLY BE
*                      GIVEN WITH THE OPTION AS TRAILING NUMBER.

  FAST DISPLAY:        THE DISPLAY OF A COMPLICATED EVENT CAN BE RATHER
                       SLOW AT HIGH OCCUPANCY TIME. FOR PURE SCANNING
                       PURPOSES, THE DISPLAY CAN BE SPEEDED UP BY:
                                   CDTL 6
                                   CDTL 26

* ANSWER YES OR NO:    IN ANSWERING QUESTIONS, WITH YES OR NO, THE
*                      FOLLOWING ANSWERS ARE ACCEPTED AS POSITIVE:
*
*                        YES,YE,Y   JA,JAWOHL,J    HAI,HA,H
*
*                      ANYTHING ELSE, INCLUDING A SIMPLE RETURN, IS A
*                      NEGATIVE ANSWER.

* REPEAT LAST COMMAND: IF A SIMPLE RETURN IS GIVEN AS COMMAND, IT WILL
*                      BE INTERPRETED IN THE SAME WAY AS THE LAST
*                      COMMAND, I.E. IF THE LAST COMMAND GIVEN WAS N,
*                      THEN A RETURN WILL AGAIN LEAD TO READING THE NEXT
*                      EVENT. THIS SAVES SOME EFFORT IN SCANNING.

DATA FILES:            IN ORDER TO SELECT DATA FROM A TAPE AND MAKE
                       A DISK DATA FILE, ONE CAN CONVENIENTLY USE THE
                       MEMBER JBSIMCNF ON F11LHO.JADEGS. COPY THIS
                       MEMBER TO YOUR OWN LIBRARY, CHANGE THE JOB CARD
                       TO YOUR OWN IDENTIFIER, CHANGE THE FT02F001 CARD
                       SO THAT DSN=THE NAME OF THE TAPE DATA SET FROM
                       WHICH YOU WISH TO SELECT DATA AND THE FT03F001
                       SO THAT DSN=THE NAME YOU WISH TO GIVE TO THE
                       NEW DISK DATA FILE YOU WILL BE CREATING.

                       THE SPACE PARAMETERS, NOW SET TO (150,50), SHOULD
                       BE SAFELY SUFFICIENT FOR ABOUT 300 EVENTS. SCALE
                       BOTH THESE NUMBERS UP OR DOWN ROUGHLY IN PRO-
                       PORTION AS YOU WISH TO WRITE MORE OR FEWER THAN
                       300 EVENTS. THE SECOND NUMBER SHOULD REMAIN
                       ROUGHLY A THIRD OF THE FIRST. YOUR JOB MAY FAIL
                       IF YOU REQUEST MORE DISK SPACE THAN IS AVAILABLE.
                       THE SPACE AVAILABLE DEPENDS UPON MACHINE CONDI-
                       TIONS AND CANNOT BE PRECISELY PREDICTED. IN
                       GENERAL IT IS NOT PRACTICAL TO WRITE MORE THAN
                       A FEW HUNDRED EVENTS.

                             NOW READ THE COMMENT CARDS IN JBSIMCNF AND
                       CHANGE THE VARIABLES TO SPECIFY THE NUMBER OF
                       EVENTS YOU WANT, RUN NUMBER RANGE, EVENT NUMBER
                       RANGE, ETC. IF YOU SIMPLY WANT THE FIRST N EVENTS
                       ON SUCH AND SUCH A TAPE REGARDLESS OF RUN NUMBER
                       ETC. YOU NEED ONLY SET NWRTMX TO N. THE OTHER
                       VARIABLES ARE APPROPRIATELY DEFAULTED. SUBMIT
                       THE JOB.

                       SHOULD YOU WANT TO SELECT SCANNED EVENTS AND
                       WRITE THEM TO AN OUTPUT FILE, YOU MUST FIRST
                       CREATE THE OUTPUT FILE ON DISK AND HAVE IT
                       CONTAIN ONE ARBITRARY EVENT, WHICH YOU LATER
                       OVERWRITE. YOU CAN CONVENIENTLY DO THIS BY
                       COPYING THE MEMBER JBMAKEOP FROM F11LHO.JADEGS
                       AND CHANGING THE JOB CARD TO YOUR OWN IDENTIFIER.
                       NOW CHANGE THE FT02F001 CARD SO THAT DSN=THE
                       NAME OF ANY JADE DATA DISK FILE WHICH IS ON DISK,
                       MOST CONVENIENTLY THE ONE YOU WISH TO SCAN. SET
                       DSN IN THE FT03F001 CARD TO THE NAME OF THE
                       OUTPUT FILE YOU WISH TO CREATE AND SET THE
                       SPACE PARAMETERS ( NOW (150,50) ) ACCORDING
                       TO THE MAXIMUM NUMBER OF EVENTS YOU THINK YOU
                       MAY WRITE OUT. THE SAME REMARKS APPLY HERE AS
                       WERE MADE ABOVE IN CONNECTION WITH THE SELECTOR
                       JOB JBSIMCNF. NOTICE THAT THE "RLSE" PARAMETER
                       IS MISSING HERE. THOUGH ONLY ONE EVENT WILL BE
                       WRITTEN BY JBMAKEOP, THE UNUSED SPACE ON THE
                       FILE CREATED WILL NOT BE RELEASED AND WILL
                       CONTINUE TO BE AVAILABLE TO THE SCAN PROGRAM
                       RUNNING UNDER GRAPHICS. FOR THIS REASON IT IS
                       GOOD CITIZENSHIP, WHEN YOU FINALLY ARE THROUGH
                       WITH ADDING TO THE OUTPUT FILE, TO COPY IT
                       INTO ANOTHER FILE WRITTEN WITH THE "RLSE"
                       PARAMETER SET AND TO DELETE THE ORIGINAL OUT-
                       PUT FILE. THIS WAY YOU OCCUPY ONLY AS MUCH
                       DISK SPACE AS YOU REALLY NEED. YOU CAN CONVEN-
                       IENTLY MAKE SUCH A COPY BY USING THE JBSIMCNF
                       DESCRIBED ABOVE.
                       SET NWRTMX TO SOME VERY LARGE NUMBER LIKE 100000
                       SO YOU JUST COPY ALL THE DATA ON THE FILE WRITTEN
                       FROM GRAPHICS.

* PRIVATE MODULES:     THE GRAPHIC DISPLAY IS OFTEN A CONVENIENT WAY
*                      TO INVESTIGATE THE DETAILED WORKING OF A PROGRAM.
*                      FOR THIS PURPOSE, THE USER WILL OFTEN WISH TO
*                      USE SPECIAL DISPLAY OPTIONS OR COMMUNICATE IN
*                      SPECIAL WAYS WITH HIS PROGRAM. THIS CAN BE DONE
*                      IN CREATING A PRIVATE MODULE WITH THE SPECIAL
*                      CODE LINKED IN. THE PROTOTYPE JOB FOR DOING THIS
*                      IS THE MEMBER JBOVER ON  F11LHO.JADEGS ; THIS
*                      MEMBER CONTAINS THE RELEVANT OVERLAY STRUCTURE.
*                      WHEN YOU USE IT, BE SURE TO CHANGE FILE NAMES
*                      CORRESPONDINGLY. FOR MORE INFORMATION ON PRIVATE
*                      MODULES, CONTACT J.OLSSON, G.PEARCE OR M.GODDARD.

                       THE GRAPHICS PROGRAM IS STILL BEING IMPROVED
                       AND CHANGES ARE SOMETIMES DONE.
                       UNFORESEEN RESULTS MAY OCCUR AND SHOULD BE
                       BROUGHT TO THE ATTENTION OF J.OLSSON.
                       ALSO SUGGESTIONS OF IMPROVEMENT ARE WELCOME...

                       A COPY OF THIS INFORMATION CAN BE OBTAINED BY
                       SUBMITTING THE JOB   JBMENU    ON THE LIBRARY
                       F11LHO.JADEGS
C   22/03/97 703221923  MEMBER NAME  JBOVER   (JADEGS)      FORTRAN
//         JOB 10622622,CLASS=E,TIME=(0,12),MSGLEVEL=(1,0)
//*MAIN RELPRI=MED
//*********************************************************************
//*  THE MACRO JADEOVLY CONTAINS THE VALID OVERLAY STRUCTURE
//*    YOU CAN ADD YOUR OWN OVERLAY DETAILS OR INCLUDES AS FOLLOWS:
//*   //SYSLIN DD *
//*    INCLUDE SYSLIB(PRIVAT1,PRIVAT2,..)
//*   %MACRO 'F11LHO.JADEGS(JADEOVLY)'
//*    OVERLAY ONE
//*     INSERT MYOWN1
//*     INSERT MYOWN2
//*     INSERT MYOWN3
//*    ENTRY MAIN
//*    NAME JADE(R)
//*********************************************************************
// EXEC NEWLIB,PS='F11LHO.GRAPHS',
// PL='F11LHO.GRAPHL',TO=DISK
./ SCRATCH JADE0
//COMPRESS EXEC COMPRESS,LIB='F11LHO.GRAPHL'
//LINK EXEC PGM=IEWL,PARM='OVLY,MAP,LIST,SIZE=(512K,72K)',
//  REGION=900K
//SYSUT1 DD DSN=&&UT1,SPACE=(TRK,(20,20)),UNIT=DISK
//SYSPRINT DD SYSOUT=*
//SYSLIB DD DSN=F11LHO.GRAPHL,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=F11LHO.JADEGL,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=F11GOD.PATRECLD,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=JADELG.LOAD,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=JADEPR.JADELD,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=F22ALL.JADEMUL,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=F22NAR.TOFLIB.L,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=F11LHO.TAGG.L,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//       DD DSN=F1EBLO.BOSLIB.L,DISP=SHR
//       DD DSN=R02SCH.TSOIPS.LOAD,DISP=SHR
//       DD DSN=R02SCH.TCSUSER.LOAD,DISP=SHR
//       DD DSN=DESYLIB,DISP=SHR
//       DD DSN=SYS1.FORTLIB,DISP=SHR
//       DD DSN=R01UTL.CERNLIB,DISP=SHR
//SYSLMOD DD DSN=F11LHO.GRAPHL,DISP=SHR,VOL=SER=STOR05,UNIT=FAST
//*SYSLMOD DD DSN=F11LHO.GRAPHLX,DISP=(NEW,CATLG,DELETE),
//*  SPACE=(TRK,(95,0,10),),UNIT=FAST
//SYSLIN DD *
#include "jadeovly.for"
 ENTRY MAIN
 NAME JADE(R)
C   22/03/97 703221923  MEMBER NAME  JBOVER0  (JADEGS)      FORTRAN
//F11LHO   JOB 10622622,CLASS=E,TIME=(0,20),MSGLEVEL=(0,0)
//*MAIN RELPRI=HIG
//LINK EXEC PGM=IEWL,PARM='OVLY,LIST,SIZE=(320K,100K)',REGION=600K
//SYSUT1 DD DSN=&&UT1,SPACE=(TRK,(20,20)),UNIT=DISK
//SYSPRINT DD SYSOUT=*
//SYSLIB DD DSN=F11LHO.GRAPHL,UNIT=FAST,DISP=SHR
//       DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//       DD DSN=F11GOD.PATRECLD,UNIT=FAST,DISP=SHR
//       DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//       DD DSN=JADEPR.JADELD,UNIT=FAST,DISP=SHR
//       DD DSN=F22ALL.JADEMUL,UNIT=FAST,DISP=SHR
//       DD DSN=F22NAR.TOFLIB.L,UNIT=FAST,DISP=SHR
//       DD DSN=F1EBLO.BOSLIB.L,UNIT=FAST,DISP=SHR
//       DD DSN=R02SCH.TSOIPS.LOAD,DISP=SHR
//       DD DSN=R02SCH.TCSUSER.LOAD,DISP=SHR
//       DD DSN=DESYLIB,DISP=SHR
//       DD DSN=SYS1.FORTLIB,DISP=SHR
//       DD DSN=R01UTL.CERNLIB,UNIT=FAST,DISP=SHR
//SYSLMOD DD DSN=F11LHO.GRAPHL,DISP=SHR
//*SYSLMOD DD DSN=F11LHO.GRAPHLX,DISP=(NEW,CATLG,DELETE),
//*  SPACE=(TRK,(80,0,10),),UNIT=FAST
//SYSLIN DD *
 INCLUDE SYSLIB(GPHMAIN0,MUINIG,SUPERVY)
 INCLUDE SYSLIB(SCANNR0,USER0,STPLST0,RETTEN0,STWADD0,NEWS0,NOTICE0)
 OVERLAY ONE
  INSERT IDFUN
  INSERT JOBNAM
  INSERT NOTICE
  INSERT OPUNIT
  INSERT STWADD
  INSERT WALLOK
  INSERT STPLST
  INSERT NEWS
  INSERT CDTLCO
  INSERT MENU
  INSERT HELPUS
  INSERT RETTEN
  INSERT GNUREC
  INSERT SAFCHK
  INSERT FREEDD
  INSERT INITT
  INSERT GETSDD
  INSERT GETPDD
  INSERT ALCDYN
  INSERT DALDYN
  INSERT GETDD
  INSERT RESET
  INSERT TERM
  INSERT NEWPAG
  INSERT FINITT
  INSERT ABEND
  INSERT ERRSET
  INSERT ERRPRT
 OVERLAY ONE
  INSERT ZVERTF
  INSERT TRUTH
  INSERT TRKNM
  INSERT BANKPR
  INSERT AGRPR
  INSERT TRIG2
  INSERT TBGDIS
  INSERT TBGSTR
  INSERT CIRSEG
  INSERT ECAPQ
  INSERT EXJHTL
 OVERLAY ONE
  INSERT MUANA
  INSERT MUANAF
  INSERT MUFFLE
  INSERT MUFFLM
  INSERT MUFFLS
  INSERT MUFFLT
  INSERT MUFFLX
  INSERT MUFFLY
  INSERT MUFFLZ
  INSERT MUREGM
  INSERT MUREGY
  INSERT MUREGS
  INSERT MUDCHK
  INSERT MATIN1
 OVERLAY ONE
  INSERT CHANGE
  INSERT ALPHAN
  INSERT INITZV
  INSERT MUINI
  INSERT MUFINI
  INSERT LGINIT
  INSERT KALIBR
  INSERT MUREG
  INSERT LGCALB
  INSERT LGERSE
  INSERT LGBADC
  INSERT JETCAL
  INSERT EVREA1
  INSERT KTMCON
 OVERLAY ONE
  INSERT SRTREL
  INSERT FLINEL
  INSERT FTRKEL
  INSERT PRHTAR
 OVERLAY ONE
  INSERT KNTREL
  INSERT TRHTCK
  INSERT LRFIT
  INSERT TRLCHI
  INSERT PARFIT
  INSERT CIRFIT
  INSERT RESIDS
  INSERT NEWINC
  INSERT FXYZ
  INSERT XYFIT
  INSERT ZRFIT
  INSERT PCWORK
  INSERT ERRORM
  INSERT PATROL
  INSERT BAKPAK
  INSERT TRLORD
  INSERT PATROL
  INSERT BACKTR
  INSERT RSTBTR
  INSERT LFRT
  INSERT SIDE1
  INSERT BAKFIT
  INSERT BSIDE
  INSERT COREC
  INSERT SLCOR
  INSERT BSTORE
  INSERT RINCON
  INSERT INTJN1
  INSERT CHOOSE
 OVERLAY ONE
  INSERT EVREAD
  INSERT MUCON
  INSERT PARCHN
  INSERT EVWRIT
  INSERT MUCONW
  INSERT RDSTAT
  INSERT RDMODN
  INSERT RDDOUB
  INSERT RDINEF
  INSERT RDMERG
  INSERT RDPOIN
  INSERT RDRDMH
  INSERT RDPATR
  INSERT RDRESO
  INSERT RDDDCL
  INSERT RDTRG1
  INSERT TAGSIM
  INSERT RDTRG2
 OVERLAY ONE
  INSERT EVDISP
  INSERT CRICRO
  INSERT FICOOR
  INSERT HITMRK
  INSERT HODRFI
  INSERT MUHDSP
  INSERT MUHIT
  INSERT PBGRFI
  INSERT PBGCYL
  INSERT PBGSUM
  INSERT TR3DSP
  INSERT PBGRZ
  INSERT PHNUMB
  INSERT RROTAT
  INSERT FWCHEV
  INSERT RODRAW
  INSERT HITDSP
  INSERT CRTREL
  INSERT BLSHOW
  INSERT BLNUMB
  INSERT LGDEAD
  INSERT FWMUHT
  INSERT FTDLHO
 OVERLAY ONE
  INSERT RSDISP
  INSERT GMTEXT
  INSERT LGCDIR
  INSERT ILCTRC
  INSERT INTOLG
  INSERT LGEERR
  INSERT LGCRN2
  INSERT LGAVDE
  INSERT SHMAX
  INSERT LGAVDP
  INSERT LGCHC2
  INSERT LGBHIT
  INSERT LGEHIT
  INSERT LGBFIL
  INSERT LGEFIL
  INSERT LGECOR
  INSERT LGECR0
  INSERT LGNMEC
  INSERT LGREIN
  INSERT TPCNST
  INSERT TRTEXT
  INSERT XXXYYY
  INSERT GAMDIS
  INSERT LGCLST
  INSERT TRKROL
  INSERT RUTRCK
  INSERT YAMADA
  INSERT PARDIS
  INSERT CIRDIS
  INSERT BANKLS
  INSERT LINDIS
  INSERT LGANAL
  INSERT LGDCPY
  INSERT IDATTM
  INSERT LGCRNR
  INSERT LGEIGN
  INSERT LGCCTL
  INSERT LGTHCR
  INSERT LGESMR
  INSERT LGCLPB
  INSERT LGCLPC
  INSERT LGCLUS
  INSERT LGNBLS
  INSERT LGSRTH
  INSERT VTXAFT
  INSERT VTXPRE
  INSERT VTXPNT
  INSERT VTXBNK
  INSERT VTXSRC
  INSERT VTXEE
  INSERT VTXS
  INSERT VERTEX
  INSERT GVTXFT
  INSERT SMINVD
  INSERT EFMASS
  INSERT GETGAM
  INSERT VTXINI
  INSERT JEGAIN
  INSERT MCGJET
  INSERT JETREC
  INSERT RJXX
  INSERT MINUS
  INSERT RESTAR
  INSERT SPHERC
  INSERT ARROW
  INSERT AXSHOW
 OVERLAY ONE
  INSERT JADISP
  INSERT ECAP
  INSERT DRACAP
  INSERT FWCAP
  INSERT FWNEW
  INSERT NEWCAP
  INSERT RUTEXT
  INSERT FWCAP1
  INSERT FWSCIN
  INSERT FWSCN1
  INSERT FWCHAM
  INSERT FWCHM1
  INSERT FWCHM2
  INSERT BARREL
  INSERT FORWRD
  INSERT MUPIC
  INSERT MUWIRE
  INSERT FWMUCN
 OVERLAY ONE
  INSERT DEDXDS
  INSERT DEDXBN
  INSERT GAMM
  INSERT DRUCK
  INSERT POLINT
  INSERT WAHR
  INSERT DSORT
  INSERT DEDXBK
  INSERT DEDXVW
  INSERT TIMCOR
  INSERT NDATE
  INSERT CRSTLK
 OVERLAY ONE
  INSERT TOFDS
  INSERT LGBTDC
  INSERT TOFVW
  INSERT TOFBK
  INSERT TOFINT
  INSERT TOFIN2
  INSERT TOFMAS
  INSERT TOFARD
  INSERT TFARNW
  INSERT TOFBRA
  INSERT TOFCLC
  INSERT TOFMA2
  INSERT TOFAR2
  INSERT TOFCL2
  INSERT TOFCOR
  INSERT TFSTOR
  INSERT TFCTD1
  INSERT CMASS
  INSERT MOCARD
 OVERLAY ONE
  INSERT EVIPR4
  INSERT EVIPR2
  INSERT BOX3
  INSERT TRIANQ
  INSERT QPLOTS
  INSERT PLIMIT
  INSERT SUMPAT
  INSERT CHCLSP
  INSERT SPHRIX
  INSERT BOX
  INSERT EHIST
  INSERT OUTPRD
  INSERT MOTAPR
  INSERT MTOPRM
  INSERT KIPRCR
 OVERLAY ONE
  INSERT DSFADC
 ENTRY MAIN
 NAME JADE(R)
C   22/03/97 703221923  MEMBER NAME  JBOVER8  (JADEGS)      FORTRAN
//F11LHOLN JOB 10622622,CLASS=A,TIME=(0,15),MSGLEVEL=(0,0)
//*MAIN RELPRI=HIG
//LINK EXEC PGM=IEWL,PARM='OVLY,XREF,LIST,SIZE=(320K,100K)',REGION=600K
//SYSUT1 DD DSN=&&UT1,SPACE=(TRK,(20,20)),UNIT=DISK
//SYSPRINT DD SYSOUT=A
//SYSLIB DD DSN=F11LHO.GRAPHL,UNIT=FAST,DISP=SHR
//       DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//       DD DSN=F11GOD.PATRECLD,UNIT=FAST,DISP=SHR
//       DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//       DD DSN=F22ALL.JADEMUL,UNIT=FAST,DISP=SHR
//       DD DSN=F22NAR.TOFLIB.L,UNIT=FAST,DISP=SHR
//       DD DSN=F1EBLO.BOSLIB.L,UNIT=FAST,DISP=SHR
//       DD DSN=R02SCH.TSOIPS.LOAD,DISP=SHR
//       DD DSN=R02SCH.TCSUSER.LOAD,DISP=SHR
//       DD DSN=DESYLIB,DISP=SHR
//       DD DSN=SYS1.FORTLIB,DISP=SHR
//       DD DSN=R01UTL.CERNLIB,UNIT=FAST,DISP=SHR
//SYSLMOD DD DSN=F11LHO.GRAPHL,DISP=SHR
//SYSLIN DD *
 INCLUDE SYSLIB(GPHMAIN)
 OVERLAY ONE
  INSERT INITZV
  INSERT LGINIT
  INSERT INPATC
  INSERT INBACK
  INSERT INPATR
  INSERT MUINI
  INSERT MUFINI
 OVERLAY ONE
  INSERT EXJHTL
 OVERLAY ONE
  INSERT RDMODN
  INSERT RDDOUB
  INSERT RDINEF
  INSERT RDMERG
  INSERT RDPOIN
  INSERT RDRDMH
  INSERT RDPATR
  INSERT RDRESO
  INSERT NVERT
  INSERT RDTRG1
  INSERT TAGSIM
  INSERT RDTRG2
  INSERT RDDDCL
  INSERT RDSTAT
 OVERLAY ONE
  INSERT EVWRIT
  INSERT MUCONW
 OVERLAY ONE
  INSERT LGCALB
  INSERT LGERSE
  INSERT LGBADC
 OVERLAY ONE
  INSERT JETCAL
  INSERT ZVERTF
 OVERLAY ONE
  INSERT PATREC
  INSERT FXYZ
  INSERT XYFIT
  INSERT PCWORK
  INSERT ZRFIT
  INSERT PATROL
  INSERT TRLORD
  INSERT CHOOSE
  INSERT BSTORE
  INSERT INTJN1
  INSERT RINCON
  INSERT SRTREL
  INSERT ATRKEL
  INSERT FLINEL
  INSERT FTRKEL
  INSERT PRHTAR
 OVERLAY TWO
  INSERT KNTREL
 OVERLAY TWO
  INSERT PATRC1
  INSERT BACKTR
  INSERT LFRT
  INSERT BSIDE
  INSERT COREC
  INSERT SIDE1
  INSERT SLCOR
  INSERT BAKFIT
 OVERLAY ONE
  INSERT LGANAL
  INSERT IDATTM
  INSERT LGCCTL
  INSERT LGCLUS
  INSERT LGMESG
  INSERT LGNBLS
  INSERT LGSRTH
  INSERT LGCLPB
  INSERT LGCLPC
  INSERT LGSHP
  INSERT LGCRNR
  INSERT LGEERR
  INSERT LGEIGN
  INSERT LGMESG
  INSERT LGDCPY
 OVERLAY ONE
  INSERT MUFFLE
  INSERT MUFFLM
  INSERT MUFFLS
  INSERT MUFFLY
  INSERT MUREGM
  INSERT MUREGY
  INSERT MUREGS
  INSERT MUCON
  INSERT MUANAJ
  INSERT MUJOIN
  INSERT MUFFLX
  INSERT MUFFLZ
  INSERT MUANAF
  INSERT MUDCHK
  INSERT MUREG
 OVERLAY ONE
  INSERT MUANAL
  INSERT MULINE
  INSERT MULINA
  INSERT MULINF
  INSERT MULING
  INSERT MULINW
  INSERT MULINP
  INSERT MULINU
  INSERT MULIND
  INSERT MULINO
  INSERT MULINR
  INSERT MULINM
  INSERT MULINS
  INSERT MUR2DS
 OVERLAY ONE
  INSERT EVDISP
  INSERT PBGRZ
  INSERT FWMUHT
  INSERT FTDLHO
  INSERT PBGSUM
  INSERT XYBLK
  INSERT XYTAG
  INSERT CAPMRK
  INSERT CROAX
  INSERT FICOOR
  INSERT WRAP
  INSERT FWCHEV
  INSERT XYTAG
  INSERT RODRAW
  INSERT HITMRK
  INSERT HODRFI
  INSERT CRICRO
  INSERT PBGCYL
  INSERT PBGRFI
  INSERT PHNUMB
 OVERLAY ONE
  INSERT JADISP
  INSERT ECAP
  INSERT DRACAP
  INSERT DRAMOV
  INSERT FWCAP
  INSERT MUPIC
  INSERT MUVIER
  INSERT MUWIRE
  INSERT BARREL
  INSERT FORWRD
  INSERT FWCAP1
  INSERT FWCHM1
  INSERT FWCHM2
  INSERT FWSCN1
  INSERT FWCHAM
  INSERT FWSCIN
  INSERT FWMUCN
 OVERLAY ONE
  INSERT MENU
  INSERT NOTICE
  INSERT TRUTH
  INSERT BANKPR
  INSERT OPUNIT
  INSERT DRCHCH
 OVERLAY ONE
  INSERT DEDXVW
  INSERT DEDXDS
  INSERT DEDXBN
  INSERT GAMM
  INSERT POLINT
  INSERT WAHR
  INSERT DSORT
  INSERT DEDXBK
  INSERT TIMCOR
  INSERT CRSTLK
 OVERLAY ONE
  INSERT TOFDS
  INSERT TOFVW
  INSERT TOFINT
  INSERT TOFMAS
  INSERT TOFARD
  INSERT TOFCLC
  INSERT TOFCOR
  INSERT TFSTOR
  INSERT TFCTD1
  INSERT CORCST
  INSERT CMASS
  INSERT MOCARD
 OVERLAY ONE
  INSERT INITT
  INSERT GETPDD
  INSERT FINITT
  INSERT ERRSET
  INSERT ERRPRT
  INSERT ABEND
 ENTRY MAIN
 NAME JADEZ(R)
C   22/03/97 703221923  MEMBER NAME  JBPATT1  (JADEGS)      FORTRAN
//F11LHO   JOB CLASS=E,MSGLEVEL=(0,0),TIME=(,20)
//*MAIN LINES=(2),RELPRI=HIG,ORG=EXT,SYSTEM=/CC
//* EXEC NEWFAST
// EXEC NEWLIB,PS='F11LHO.JADEGS',
// LEVEL=0,OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ COMPILE USPATT
./ COMPILE KALIBR9
// EXEC FLG,PARM.LKED='LIST',REGION.GO=800K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//            DD DSN=F11GOD.PATRECLD,UNIT=FAST,DISP=SHR
//            DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//            DD DSN=F22ALL.JADEMUL,UNIT=FAST,DISP=SHR
//            DD DSN=F1EBLO.BOSLIB.L,UNIT=FAST,DISP=SHR
//            DD DSN=R01UTL.HBOOK321.L,UNIT=FAST,DISP=SHR
//            DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USPATT,KALIBR9)
//*
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.JADEPR.MS115
//*
//GO.FT03F001 DD DUMMY
//*
//GO.FT10F001 DD UNIT=FAST,DSN=F11LHO.ASTART0,DISP=SHR
//GO.FT11F001 DD UNIT=FAST,DSN=F11LHO.ASTART1,DISP=SHR
//GO.FT21F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT0,DISP=SHR
//GO.FT22F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT1,DISP=SHR
//*
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(100,20),RLSE),DSN=F11PST.DSK466C
//*GO.FT03F001 DD UNIT=FAST,DISP=OLD,DSN=F11PST.DSK466C
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   DSN=F11PST.TPRF133
C   22/03/97 703221923  MEMBER NAME  JBPATT2  (JADEGS)      FORTRAN
//F11LHO   JOB CLASS=E,MSGLEVEL=(0,0),TIME=(,30)
//*MAIN LINES=(2),RELPRI=MED,ORG=EXT,SYSTEM=/CC
//* EXEC NEWFAST
// EXEC NEWLIB,PS='F11LHO.JADEGS',
// LEVEL=0,OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ COMPILE USPATT
// EXEC FLG,PARM.LKED='LIST',REGION.GO=800K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DSN=F11LHO.JADEGL,UNIT=FAST,DISP=SHR
//            DD DSN=F11GOD.PATRECLD,UNIT=FAST,DISP=SHR
//            DD DSN=JADELG.LOAD,UNIT=FAST,DISP=SHR
//            DD DSN=F22ALL.JADEMUL,UNIT=FAST,DISP=SHR
//            DD DSN=F1EBLO.BOSLIB.L,UNIT=FAST,DISP=SHR
//            DD DSN=R01UTL.HBOOK321.L,UNIT=FAST,DISP=SHR
//            DD DSN=R02BUT.CERNLIB,UNIT=FAST,DISP=SHR
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USPATT,KALIBR9)
//*
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11OLS.JADEPR.MS115
//*
//*O.FT03F001 DD DUMMY
//FT03F001 DD MSVGP=VTMP,UNIT=3330V,DISP=(NEW,CATLG,DELETE),
//         DCB=R01DCB.VBS,DSN=F11PST.JADEPR.MS115
//*
//GO.FT10F001 DD UNIT=FAST,DSN=F11LHO.ASTART0,DISP=SHR
//GO.FT11F001 DD UNIT=FAST,DSN=F11LHO.ASTART1,DISP=SHR
//GO.FT21F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT0,DISP=SHR
//GO.FT22F001 DD UNIT=FAST,DSN=F11LHO.AUPDAT1,DISP=SHR
//*
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(100,20),RLSE),DSN=F11PST.DSK466C
//*GO.FT03F001 DD UNIT=FAST,DISP=OLD,DSN=F11PST.DSK466C
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   DSN=F11PST.TPRF133
C   22/03/97 703221923  MEMBER NAME  JBRECALI (JADEGS)      FORTRAN
//F11LHOC3 JOB 10622622,CLASS=L,TIME=(15,00),MSGLEVEL=(0,0)
//*MAIN RELPRI=MED
// EXEC NEWLIB,PS='F11LHO.JADEGS',
// OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USERCP
./ I 7700
         GO TO 11
./ I 800
      COMMON / CJDRCH / RDEC(4),PSIIN(3),RINCR(3),FIRSTW(3),FSENSW(3),
     * RDEPTH,SWDEPL,YSUSPN,TIMDEL(2,3),ZMAX,ZOFFS,ZRESOL,ZNORM,ZAL,
     * ZSCAL,DRIDEV,DRICOS,DRISIN,PEDES,TZERO(3)
        COMMON/  CPK/ NTOT,NTOLD,NBLK,NEV,NS
./ I 4600
C---
C---     THE COMMENTED OUT TZEROS BELOW MUST BE TURNED ON AND SET
C---     APPROPRIATELY IF ONE WISHES TO OVERWRITE THE DEFAULT
C---     TZEROS PROVIDED BY KALIBR AT EACH NEW RUN.
C---
C     TZERO(1)=-3.4
C     TZERO(2)=-3.0
C     TZERO(3)=-2.0
C     IF(NRUN.GE. 699) TZERO(3)=-2.3
./ I 9600
      IF((NWRIT.LT.IFPRNT).OR.(NWRIT.GT.ILPRNT)) GO TO 444
      CALL BSLW
      CALL BPRL(1000)
  444 CONTINUE
./ RS 6400 ' ' 'C'
./ I 6400
         IPNJET=IDATA(IBLN('JETC'))
         IF((IPNJET.LT.4).OR.(IPNJET.GT.20000)) WRITE(6,445) IPNJET,NREC
     1   ,NRUN,NEVT
  445    FORMAT('0UNORTHODOX IPNJET = ',I10,' AT: ',3I8,/)
         IF((IPNJET.LT.4).OR.(IPNJET.GT.20000)) GO TO 11
         NUMJET=IDATA(IPNJET-2)
         IPNNEX=IDATA(IPNJET-1)
         IF((IPNNEX.LT.4).OR.(IPNNEX.GT.20000)) WRITE(6,446) IPNNEX,NREC
     1   ,NRUN,NEVT
  446    FORMAT('0UNORTHODOX IPNNEX = ',I10,' AT: ',3I8,/)
         IF((IPNNEX.LT.4).OR.(IPNNEX.GT.20000)) GO TO 11
C---     NUMNEX=IDATA(IPNNEX-2)
C---     CALL BDLS('JETC',NUMJET)
C---     IPNJET=IDATA(IBLN('JETC'))
C---     IF((IPNJET.LT.4).OR.(IPNJET.GT.20000)) WRITE(6,447) IPNJET,NREC
C--- 1   ,NRUN,NEVT
C-447    FORMAT('0UNORTHODOX IPNJET (TWO) = ',I10,' AT: ',3I8,/)
C---     IF((IPNJET.LT.4).OR.(IPNJET.GT.20000)) GO TO 11
C---     CALL BRNM('JETC',NUMNEX,'JETC',NUMJET)
C---
C---     COMMENT CARDS BELOW MUST BE SWITCHED ON IN CASE Z VERTEX,
C---     PATTERN RECOGNITION OR HIT LABEL RESULTS ARE TO BE DELETED
C---     AND REGENERATED.
C---
C        CALL CLOC(JERROR,'ZVTX',0)
C        IF(JERROR.LT.1) WRITE(6,501) NREC,NRUN,NEVT
C 501    FORMAT('0ZVTX(0) DOES NOT EXIST AT: ',3I8,/)
C        IF(JERROR.LT.1) GO TO 11
C        CALL BDLS('ZVTX',0)
         CALL CLOC(JERROR,'PATR',9)
         IF(JERROR.LT.1) WRITE(6,502) NREC,NRUN,NEVT
  502    FORMAT('0PATR(9) DOES NOT EXIST AT: ',3I8,/)
         IF(JERROR.LT.1) GO TO 11
C---     CALL BDLS('PATR',9)
         CALL CLOC(JERROR,'JHTL',9)
         IF(JERROR.LT.1) WRITE(6,503) NREC,NRUN,NEVT
  503    FORMAT('0JHTL(9) DOES NOT EXIST AT: ',3I8,/)
         IF(JERROR.LT.1) GO TO 11
         CALL BDLS('JETC',NUMJET)
         CALL BDLS('PATR',9)
         CALL BDLS('JHTL',9)
         CALL BGAR(IGA)
         IF(IGA.NE.1) WRITE(6,504) NREC,NRUN,NEVT
  504    FORMAT('0GARBAGE COLLECTION NOT DONE AT: ',3I8,/)
./ I 4100
C--      MAXIMUM NUMBER OF EVENTS TO BE WRITTEN OUT.
      NWRTMX=10000
C--      MINIMUM AND MAXIMUM RUN NUMBERS TO BE ACCEPTED.
      NRUNMN=0
      NRUNMX=100000
C--      MINIMUM AND MAXIMUM EVENT NUMBERS TO BE ACCEPTED.
C--      IF A MINIMUM RUN NUMBER GREATER THAN 0 HAS BEEN
C--      SPECIFIED, THE MINIMUM EVENT NUMBER CUT APPLIES ONLY TO
C--      THE FIRST ACCEPTED RUN. SIMILARLY, IF A MAXIMUM RUN
C--      NUMBER LESS THAN 50000 IS GIVEN, THE MAXIMUM EVENT NUMBER
C--      CUT APPLIES ONLY TO THE LAST RUN ACCEPTED.
      NEVTMN=0
      NEVTMX=1000000
C--      MINIMUM AND MAXIMUM RECORD NUMBERS FROM THE BEGINNING
C--      OF THE INPUT DATA SET FOR WHICH THE CORRESPONDING RECORDS
C--      MAY BE WRITTEN OUT.
      NRECMN=0
      NRECMX=1000000
C--      IFPRNT=M AND ILPRNT=N SPECIFY THAT FOR THE MTH THROUGH
C--      THE NTH EVENTS TO BE WRITTEN OUT A PRINTOUT OF THE EVENT
C--      RECORD WILL BE MADE. NOT MORE THAN 10 PRINTOUTS CAN BE MADE.
      IFPRNT=1
      ILPRNT=0
// EXEC FLG,PARM.LKED='MAP,LIST',REGION=750K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USERCP)
//GO.FT10F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
//GO.FT11F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART1
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F22ORI.P.DSK009
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.ST033
//*GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F22ORI.RMH330.FASTSELD
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*  SPACE=(TRK,(250,50),RLSE),DSN=F11LHO.DSKPEDES
//GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//   DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//   DSN=JADEPR.ST033R
//*GO.FT03F001 DD DUMMY
C   22/03/97 703221923  MEMBER NAME  JBREDUC2 (JADEGS)      FORTRAN
//F11JEO   JOB 10622622,OLSSON,CLASS=K,MSGLEVEL=(0,0),TIME=(4,25)
//*MAIN RELPRI=MED
// EXEC NEWLIB,PS='F11LHO.JADEGS',PL='F11OLS.JADELD',UNIT=FAST,
// LEVEL=8,OPT=3,FORT=XL,REGION.NEWLIB=800K
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ COMPILE USREDUC2
// EXEC FLG,REGION.GO=900K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,DSN=F11LHO.JADEGL
//            DD DISP=SHR,DSN=JADELG.LOAD
//            DD DISP=SHR,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,DSN=F22NAR.TOFLIB.L
//            DD DISP=SHR,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,DSN=R02BUT.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USREDUC2)
//GO.FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.ST094
//   DD UNIT=AFF=FT02F001,DISP=OLD,DSN=JADEPR.ST095
//*GO.FT02F001 DD DISP=SHR,DSN=F11OLS.RED2TST3
//*            DD DISP=SHR,DSN=F11OLS.RED2TST3
//*                        OUTPUT:
//*GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD DISP=SHR,DSN=F11OLS.RED2TST2
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(40,5),),DSN=F11OLS.RED2TST7
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   DSN=F11OLS.R28890
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//       SPACE=(CYL,(200,20)),DSN=&&SCRTCH
//*LOGPRINT DD SYSOUT=*
         0         0    100000         0         0         0         0
         0    400000         0     10000         0         0         0
     IHIST     IRED1    MAXEVS      IPRN    ICALIB    ICALJC    IREPAT
    NNRMIN    NNRMAX LOW RUNLIM  HIGH RUNLIM  IREFRM  ITMLOG    IPATRJ
    BOTH LIMITS ARE WRITTEN
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//COPY EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//          DSN=F11OLS.R2187B
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
C   22/03/97 703221923  MEMBER NAME  JBRED282 (JADEGS)      FORTRAN
//F11JEO   JOB 10622622,OLSSON,CLASS=K,MSGLEVEL=(1,0),TIME=(4,30)
//*MAIN RELPRI=MED
//*EXEC NEWFAST
//* EXEC NEWLIB,PS='F11LHO.JADEGS',PL='F11LHO.JADEGL',UNIT=FAST,
//* LEVEL=8,OPT=3,FORT=XL,REGION.NEWLIB=800K
//*MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
//*./ COMPILE USRED282
// EXEC FLG,REGION.GO=950K
//LKED.SYSLIB DD
//            DD
//*           DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,DSN=F11LHO.JADEGL
//            DD DISP=SHR,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,DSN=JADELG.LOAD
//            DD DISP=SHR,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,DSN=F22NAR.TOFLIB.L
//            DD DISP=SHR,DSN=JADEPR.JADELD
//            DD DISP=SHR,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,DSN=R01UTL.HBOOK321.L
//            DD DISP=SHR,DSN=R02BUT.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0)
 INCLUDE SYSLIB(USRED282)*
//GO.FT21F001 DD DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD DISP=SHR,DSN=F11LHO.AUPDAT1
//*                        INPUT:
//GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.REDUCONE.G0519V00
//*GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.REDUC1.G0496,
//*    VOL=SER=939517,LABEL=(1,SL,,IN)
//*GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=JADEPR.REDUC1.G0427,
//*    VOL=SER=(934049,934048),LABEL=(1,SL,,IN)
//* DD UNIT=AFF=FT02F001,DISP=OLD,DSN=JADEPR.ST095
//*                        OUTPUT:
//*GO.FT03F001 DD DUMMY,DCB=R01DCB.VBS
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   SPACE=(TRK,(80,11),),DSN=F11OLS.NEUTR2.SUM121
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   DSN=F11OLS.R28890
//*GO.FT03F001 DD DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*    DSN=F11OLS.NEUSUM.DISK13,
//*         MSVGP=VTMP,UNIT=3330V
//GO.FT03F001 DD UNIT=DISK,DISP=(,PASS),
//   DCB=(R01DCB.VBS,LRECL=6236),
//       SPACE=(CYL,(180,20)),DSN=&&SCRTCH
//*LOGPRINT DD SYSOUT=*
         0         0    100000         0         0         0         0
         0    400000         0     20000         0         0         0
     IHIST    ITOFCT    MAXEVS      IPRN    ICALIB    ICALJC    IREPAT
    NNRMIN    NNRMAX LOW RUNLIM  HIGH RUNLIM  IREFRM  ITMLOG    IPATRJ
    BOTH LIMITS ARE WRITTEN
//*
//*  COPY DISK OUTPUT TO TAPE
//*
//COPY EXEC PGM=IEBGENER
//SYSUT1 DD UNIT=DISK,DISP=(OLD,DELETE),DSN=&&SCRTCH
//SYSUT2 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//          DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//          DSN=F11OLS.R2519
//SYSPRINT DD SYSOUT=*
//SYSIN DD DUMMY
C   22/03/97 703221923  MEMBER NAME  JBSIMCNF (JADEGS)      FORTRAN
//F11LHOTT JOB 10622622,CLASS=E,TIME=(0,30),MSGLEVEL=(0,0)
// EXEC NEWLIB,PS='F11LHO.JADEGS',
// OPT=2,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ C USERCP
./ I 4100
C--      MAXIMUM NUMBER OF EVENTS TO BE WRITTEN OUT.
      NWRTMX=100000
C--      MINIMUM AND MAXIMUM RUN NUMBERS TO BE ACCEPTED.
      NRUNMN=0
      NRUNMX=100000
C--      MINIMUM AND MAXIMUM EVENT NUMBERS TO BE ACCEPTED.
C--      IF A MINIMUM RUN NUMBER GREATER THAN 0 HAS BEEN
C--      SPECIFIED, THE MINIMUM EVENT NUMBER CUT APPLIES ONLY TO
C--      THE FIRST ACCEPTED RUN. SIMILARLY, IF A MAXIMUM RUN
C--      NUMBER LESS THAN 50000 IS GIVEN, THE MAXIMUM EVENT NUMBER
C--      CUT APPLIES ONLY TO THE LAST RUN ACCEPTED.
      NEVTMN=0
      NEVTMX=1000000
C--      MINIMUM AND MAXIMUM RECORD NUMBERS FROM THE BEGINNING
C--      OF THE INPUT DATA SET FOR WHICH THE CORRESPONDING RECORDS
C--      MAY BE WRITTEN OUT.
      NRECMN=0
      NRECMX=1000000
C--      IFPRNT=M AND ILPRNT=N SPECIFY THAT FOR THE MTH THROUGH
C--      THE NTH EVENTS TO BE WRITTEN OUT A PRINTOUT OF THE EVENT
C--      RECORD WILL BE MADE. NOT MORE THAN 10 PRINTOUTS CAN BE MADE.
      IFPRNT=1
      ILPRNT=0
// EXEC FLG,PARM.LKED='MAP,LIST',REGION=750K
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//            DD DISP=SHR,UNIT=FAST,DSN=F1EBLO.BOSLIB.L
//            DD DISP=SHR,UNIT=FAST,DSN=R01UTL.CERNLIB
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USERCP)
//GO.FT10F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART0
//GO.FT11F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.ASTART1
//GO.FT21F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT0
//GO.FT22F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.AUPDAT1
//*GO.FT02F001 DD UNIT=TAPE,DISP=OLD,DSN=F11LHO.JDATA01.REFORM.G0254V00
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F22ORI.RMH330.FASTSELD
//*GO.FT03F001 DD UNIT=FAST,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*  SPACE=(TRK,(250,50),RLSE),DSN=F11LHO.DSKPEDES
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),DCB=R01DCB.VBS,
//*   DSN=F11LHO.TAPESEL
//*GO.FT03F001 DD UNIT=TAPE,DISP=(NEW,CATLG,DELETE),
//*   DCB=(R01DCB.VBS,LRECL=6236,BLKSIZE=24948),
//*   DSN=F11LHO.JDATA03.REFORM.G0066V00
//GO.FT03F001 DD DUMMY
C   22/03/97 703221923  MEMBER NAME  JOB0     (JADEGS)      FORTRAN
//F11LHO   JOB 10622622,CLASS=E,MSGLEVEL=(0,0)
//*MAIN ORG=EXT,LINES=(2)
// EXEC NEWLIB,PS='F11LHO.JADEGS',
// LEVEL=0,OPT=0,FORT=XL
//MACRO DD DSN=F11GOD.PATRECSR,DISP=SHR,UNIT=FAST
./ COMMENT : THIS IS AN EXEMPLE FOR TEMPORARY CHANGES
./ C USER0
./ I 5300
      CALL BSLW
      CALL BPRL(1000)
// EXEC FLG,PARM.LKED='MAP,LIST'
//LKED.SYSLIB DD
//            DD
//            DD DISP=SHR,UNIT=FAST,DSN=&&LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F11LHO.JADEGL
//            DD DISP=SHR,UNIT=FAST,DSN=F11GOD.PATRECLD
//            DD DISP=SHR,UNIT=FAST,DSN=JADELG.LOAD
//            DD DISP=SHR,UNIT=FAST,DSN=F22ALL.JADEMUL
//LKED.SYSIN DD *
 INCLUDE SYSLIB(JDMAIN0,USER0)
//GO.FT02F001 DD UNIT=FAST,DISP=SHR,DSN=F11LHO.DSK798M

C   07/06/96 606071908  MEMBER NAME  SMDIST   (S4)          FORTG1
      SUBROUTINE SMDIST(Y,YH,Z,N,IP,MODE)
      REAL Y(N),YH(N),Z(N),H(320)
C
C                 -      - -- ----
C     CALL SMDIST(Y,YH,Z,N,IP,MODE)
C                   -- -
C
C     SMOOTH N DATA Y( ) ASSUMED AT EQUIDISTANT ABSCISSA VALUES
C
C      Y( ) = INPUT DATA
C     YH( ) = AUXILIARY ARRAY
C      Z( ) = RESULT (SMOOTHED VALUES)
C
C     Y( ) AND YH( ) MAY BE THE SAME ARRAY.
C
C        IP = 0   FOR POISSON DISTRIBUTED (COUNTER) DATA
C           = NOT EQUAL 0 OTHERWISE
C      MODE = 1   353QH
C           = 2   353QH TWICE
C           = 3   353QH TWICE + SPLINE FIT
C
C
C
      DO 5  I=1,N
    5 YH(I)=Y(I)
      IF(IP.EQ.0) CALL SMPTEQ(YH,N)
      DO 10 I=1,N
   10 Z(I)=YH(I)
      DO 60 K=1,2
      CALL SMOPER(Z,N,54321)
      IF(MODE.EQ.1) GOTO 90
      GOTO (20,40),K
   20 NSP=3+0.2*FLOAT(N)
      NSP=MIN0(64,NSP)
      CALL SMSPLE(Z,YH,W,N,H,NSP,-1,CHDF)
      DO 30 I=1,N
      ZZ=Z(I)
      Z(I)=YH(I)-ZZ
   30 YH(I)=ZZ
      GOTO 60
   40 DO 50 I=1,N
      Z(I)=YH(I)+Z(I)
   50 YH(I)=Z(I)
   60 CONTINUE
      IF(MODE.EQ.2.OR.N.LT.10) GOTO 90
      DO 80 K=1,2
      IF(K.EQ.2) GOTO 62
      NSP=2+(N+1)/2
      IF(NSP.GT.64) GOTO 65
      GOTO 64
   62 NSP=2.0+YH(N)*0.5
      IF(NSP.GT.64) GOTO 65
   64 CALL SMSPLE(Z,YH,W,N,H,NSP,-K,CHDS)
      GOTO 72
   65 KL=(N+101)/112
      LK=(N+12*KL-11)/KL
      CHDS=0.0
      JA=1
      DO 70 LL=1,KL
      JB=MIN0(N,JA+LK-1)
      IF(K.EQ.1) NSP=2+(JB-JA)/2
      IF(K.EQ.2) NSP=2+(YH(JB)-YH(JA))*0.5
      NSP=MIN0(64,NSP)
      CALL SMSPLE(Z(JA),YH(JA),W,JB-JA+1,H,NSP,-K,CHDF)
      CHDS=CHDS+CHDF
   70 JA=JB-10
      CHDS=CHDS/FLOAT(KL)
   72 CHDS=18.0*SQRT(CHDS)
C     RMS DEVIATION IS REDUCE BY A FACTOR OF 18.0 BY PREVIOUS
C     SMOOTH OPERATIONS
      IF(K.EQ.2) GOTO 80
      D1=Z(2)-Z(1)
      NM=N-1
      DO 74 I=2,NM
      D2=Z(I+1)-Z(I)
      DD=D2-D1
      Z(I)=YH(I)
      YH(I)=0.4
      IF(ABS(DD).GT.CHDS) YH(I)=1.0
   74 D1=D2
      Z(1)=YH(1)
      Z(N)=YH(N)
      YH(1)=YH(2)
      YH(N)=YH(NM)
      CALL SMOPER(YH,N,51)
      DO 76 I=2,N
   76 YH(I)=YH(I-1)+YH(I)
   80 CONTINUE
   90 IF(IP.NE.0) GOTO 100
      CALL SMEQTP(Z,N)
  100 RETURN
      END

C   29/09/86 711061741  MEMBER NAME  TPUOPT8  (S)        M  FORTRAN77
C
C-----------------------------------------------------------------------
      SUBROUTINE  TPUOPT( CHAR, IOPTS )
C-----------------------------------------------------------------------
C
C     Author:  C. Bowdery        1/10/86:  Provide options
C
C
C
C     Routine to provide options  (DUMMY VERSION)
C
C------------------  D E F I N I T I O N S  ----------------------------

      IMPLICIT  INTEGER*2 (H)

      INTEGER  IOPTS(10)

      CHARACTER*4  CHAR

C------------------  C O D E  ------------------------------------------

      IF( CHAR .EQ. 'MUON' ) THEN
        IOPTS(1) = -1
        IOPTS(2) = 1
        IOPTS(3) = 0

      ELSE IF( CHAR .EQ. 'TAGG' ) THEN
        IOPTS(1) = 0
        IOPTS(2) = 0
        IOPTS(3) = 0

      ELSE IF( CHAR .EQ. 'TOFS' ) THEN
        IOPTS(1) = -1
        IOPTS(2) = 1
        IOPTS(3) = 0

      ELSE IF( CHAR .EQ. 'JETC' ) THEN
        IOPTS(1) = -1
        IOPTS(2) = 1
        IOPTS(3) = 1
        IOPTS(4) = -1
        IOPTS(5) = 1

      ELSE IF( CHAR .EQ. 'LGSC' ) THEN
        IOPTS(1) = -1
        IOPTS(2) = -1
        IOPTS(3) = 1
        IOPTS(4) = 1

      ELSE IF( CHAR .EQ. 'RFIT' ) THEN
        IOPTS(1) = -1
        IOPTS(2) = 1
        IOPTS(3) = -1
        IOPTS(4) = 1
        IOPTS(5) = 2

      ELSE IF( CHAR .EQ. 'DEDX' ) THEN
        IOPTS(1) = 1

      ELSE IF( CHAR .EQ. 'TRAK' ) THEN
        IOPTS(1) = 1

      ELSE
        CALL TPERRH
        IOPTS(1) = 0
        IOPTS(2) = 0
        IOPTS(3) = 0

      ENDIF

      RETURN
      END

C   25/06/78            MEMBER NAME  BREMS2   (LGSOURCE)    FORTRAN
      SUBROUTINE BREMS2(ENE,EPSI)
      COMMON /BRPAR/ BRA,BRB,BDEL
      COMMON/SFCPA/SFP,SFE
      BH(X)=4.184*ALOG(X+0.952)-0.280
      XR=RN(DAM)
      EPSI=SQRT(XR)
      XR=RN(DAM)
      DEL=BDEL*EPSI/(ENE*(1.-EPSI))
      IF(DEL-1.)20,20,21
 20    G2=1.-BRB*DEL*(3.242-0.625*DEL)
      GO TO 2
 21    G2=1.-BRB*BH(DEL)
 2    IF(XR*SFE-G2)30,30,31
 30    IF(EPSI.LE. 1.-1./ENE) RETURN
 31    EPSI=0.
      RETURN
      END

C   07/06/96 606071848  MEMBER NAME  IAF      (S4)          FORTG1
      FUNCTION IAF(NB,IW)
      INTEGER IL(2),IB/'    '/
      LOGICAL*1LL(8)
      EQUIVALENCE(IL(1),LL(1))
      DATA IL(2)/0/
      NL=0
      NC=IABS(NB)
      IF(NC.NE.0) GOTO 10
      IL(1)=IB
      GOTO 100
   10 IL(1)=IW
      DO 30 I=1,4
      LL(8)=LL(5-I)
      IF(IL(2).NE.64) GOTO 30
      NL=I
      KL=MOD(NC,10)
      IF(KL.EQ.0.AND.NC.EQ.0) GOTO 20
      IL(2)=240+KL
      LL(5-I)=LL(8)
   20 NC=NC/10
   30 CONTINUE
      IF(NB.GT.0) GOTO 100
      IF(NL.EQ.0) GOTO 100
      IL(2)=96
      LL(5-NL)=LL(8)
  100 IAF=IL(1)
      RETURN
      END

#!/bin/awk -f
# 
# 28/04/00 Pedro Movilla Fernandez
#
# Utility to restore the original TOF counter numbers in the
# TOF counter calibration data banks "TOFC". In the present 
# ASCII files aupdat1 and bupdat0, these data were erroneously
# written out as floating point numbers with exponent E-78.
# The original integer number can be easily reconstructed 
# from the mantissa of the floating point number.
#
# E.g.: 0.000026E-78  0.392330E+02   means: 26  0.392330E+02
#
# usage: awk -f tofc.awk <old file> > <new file>
#

###
BEGIN{}

### Process lines containing the string "E-78"
/E-78/ {
       iline++
       #print iline " --- Line#"NR " #Fields="NF " Content:" $0
       for ( i=1; i<=NF; i++ ) 
	 {
	   if ($i ~ /E-78/) { icount++; gsub(/E-78/,"",$i); gsub(/0\.0*/,"",$i) }
	   $i = sprintf("%13s",$i)
	 }
       #printf "%36-s %s \n" ," ---> changed to:", $0
       $1 = ( " " $1 )
  } 

### Let the rest unchanged
!/E-78/

### Statistics
END{ 
  #printf "%+30s\n", "------------------------------"
  #printf "%+30s %s\n", "Processed calibration file:", FILENAME
  #printf "%+30s %d\n", "Number of total lines:", NR
  #printf "%+30s %d\n", "Number of processed lines:", iline
  #printf "%+30s %d\n", "Number of processed numbers:", icount
    }

#!/bin/ksh
#
if [ -z "$INIT_JADE_ENV" ]; then
   export INIT_JADE_ENV=1
#
   echo "   *** Executing init_jade_env.ksh"
#
    ###### The JADE path here! #####
    # The part of ${PWD} up to the 
    # last appearance of 'jadesoft' 
    # is taken as the absolute path
    export PWD=`pwd`
    JADE=""
    ic=0
    ip=0
    IFS="/"
    for dir in ${PWD}; do
	((ic=$ic+1))
	if [ "$dir" = "jadesoft"  ]; then 
	    ip=$ic
	fi
    done
    ic=0
    if [ "$ip" != 0 ]; then
	for dir in ${PWD}; do
	    ((ic=$ic+1))
	    if [ x"$dir" != "x" ]; then
		JADE="${JADE}/${dir}"
	    fi
	if [ $ic = $ip ]; then 
	    break
	fi
	done
    else
	echo "Init_jade_env.ksh: JADE root directory must be '<path>/jadesoft/'!"
	exit -9
    fi
    IFS=" "
    # export  JADE = ~/jadesoft
    ################################

#
   if [ -x /bin/uname ]; then 
       alias machine="echo `/bin/uname`"
   fi
   if [ -x /bin/arch ]; then 
       alias machine="echo `/bin/arch`"
   fi
   if [ -z "$HARDWARE" ]; then 
       export HARDWARE="`machine`"
   fi
   if [ "$HARDWARE" = "mips" ]; then 
       export HARDWARE="decs"
            BinPath="Dbin"
            LibPath="DLib"
   fi
   if [ "$HARDWARE" = "i586" ]; then 
       export HARDWARE="pentium"
   fi
   if [ "$HARDWARE" = "i686" ]; then 
       export HARDWARE="pentium"
   fi
   if [ "$HARDWARE" = "AIX" ]; then 
       export HARDWARE="RS6000"
   fi
   if [ "$HARDWARE" = "decs" ]; then 
            BinPath="Dbin"
            LibPath="DLib"
   fi
   if [ "$HARDWARE" = "pentium" ]; then 
            BinPath="Pbin"
            LibPath="Plib"
   fi
   if [ "$HARDWARE" = "RS6000" ]; then 
            BinPath="Rbin"
            LibPath="Rlib"
   fi

# CERN library version
   if [ "$HARDWARE" = "RS6000" ]; then
     export CERN_ROOT=/cern/98
   else
     export CERN_ROOT=/cern/99
   fi

# JADE resources/binaries
#export JADE_LIB=$JADE/${LibPath}
#export JADE_BIN=$JADE/${BinPath}
export JADE_LIB=$JADE/lib
export JADE_BIN=$JADE/bin
export JADE_SRC=$JADE/src
export JADE_CAL=$JADE/cal
export JADE_JOB=$JADE/job
export JADE_MAIN=$JADE/main
export JADE_UTIL=$JADE/util
export JADE_ULIB=$JADE/util/${LibPath}
export JADE_UBIN=$JADE/util/${BinPath}
export JADE_MCLIB=$JADE/util/mcgen/${LibPath}
export JADE_MCBIN=$JADE/util/mcgen/${BinPath}
export ZE4V=${JADE_MAIN}/ze4v
export SUPERV=${JADE_MAIN}/superv
export MCJADE=${JADE_MAIN}/mcjade
export JADEZ=${JADE_MAIN}/jadez

export propath=". ${JADE_UTIL}/Scripts ${JADE_ULIB}  ${JADE_MCLIB} ${JADE_UTIL}/mcgen/src ${JADE_UTIL}/mcgen/mc"
export PATH="""${JADE_UTIL}/Scripts:${JADE_UBIN}:${JADE_MCBIN}:${JADE_BIN}:$PATH"""

echo "   *** JADE = $JADE"

fi

#!/bin/ksh
#
# Shell script to compile the ZE4V data reading routine
#
# 19.06.2003  Pedro A. Movilla Fernandez
#


#
. ../../Init_jade_env.ksh


fort zread.f
Stat=$?
if [ $Stat -ne 0 ]; then
    exit 9
fi
link zread.o
Stat=$?
if [ $Stat -ne 0 ]; then
    exit 9
fi

rm -f zread.o

env=`uname`
mv -f zread.run  zread.${env}.run

echo ""
echo "zread.${env}.run created."
echo ""

exit 0

#!/bin/ksh
#
# Shell script to compile some event generator code 
# and analyses libraries from OPAL
#
# 19.06.2003  Pedro A. Movilla Fernandez
#

. ../../../Init_jade_env.ksh

# basenames of car files to install
genl="ariadne408 coj623d herwig58d herwig59 jt63jade jt74opal pythia5722 ckern104 ckern105 px113 px114"

for car in $genl; do
 echo "--------------------------------------"
 echo "... installing $car"
 echo "--------------------------------------"

 ytofort ${car}.cra 
 Stat=$?
 if [ $Stat -ne 0 ]; then
    exit 9
 fi
 ftolib ${car}.f
 Stat=$?
 if [ $Stat -ne 0 ]; then
    exit 9
 fi
 rm -rf ${car}
 #rm -f ${car}.f 
 mkdir -p ${JADE_MCLIB}
 mv -f ${car}.a ${JADE_MCLIB}/lib${car}.a

 echo "***"
 echo "*** library ${JADE_MCLIB}/lib${car}.a created."
 echo "***"

done

exit 0

#!/usr/bin/ksh
##########################################
#
# Steering job for the JADE Supervisor
#
#      28/05/00  Pedro Movilla Fernandez
#      24/06/03  PMF last mod.
#
##########################################

# Check current platform
if [ `uname` != 'AIX' ] ; then
   echo Current platform is not supported.
   exit
fi
. ../../Init_jade_env.ksh

# Time stamp:
echo
echo 'Start SUPERV job at: '`date`
echo

# Initialise random number seed for smearing MC
SVSTART=ON

# Set input BOS file (no more than 78 characters)
MCBOS=`pwd`/mc_t86-05-17.bos

# Set calibration file: Use either AUPDAT1 or ( BUPDAT0 and BUPDAT1 )
AUPDAT0=${JADE_CAL}/aupdat1.b
#BUPDAT0=${JADE_CAL}/bupdat0.b
#BUPDAT1=${JADE_CAL}/bupdat1.b

# Set the name of the .hist, .bos and .bnk ouput files for this run
NAME=sv_t86-05-17

# Go to scratch directory:
out=out
mkdir -p $out
cd $out

# Delete files if neccessary:
if [ $SVSTART = 'ON' ] ; then
    echo Will remove superv.stat.
    rm -f superv.stat
fi

# Execute:
time superv << EOF
LIST

C Initialise random number generator
SVSTART $SVSTART

C First and last event to be reconstructed
C      LAST=0: process until end of input file
FIRST  1
LAST   0

C Name of the input BOS file
MCBOS
'$MCBOS'

C Reconstruction options
ZSRFTV OFF
VTXFIT OFF

C Calibration constants
C - Name of the calibration file
AUPDAT0 
'$AUPDAT0'
BUPDAT0 
'$BUPDAT0'
BUPDAT1 
'$BUPDAT1'

C - Calibration constants reading flags
C (corresponds to COMMON /CMCCAL/ LBMC(1...15))
MUCA ON
LGMA OFF
TAGS OFF
TOFC OFF
LGST OFF
DEDX OFF
SPTG OFF
RVTX OFF
ZCAL OFF
TAGF OFF
IDJS OFF
VTXC OFF
VTXR OFF
VTXB OFF
VTXF OFF

C Name of the BOS banks output file
SVBOS '$NAME.bos'

C Print out of BOS banks in readable ASCII format
C (memory consuming, only for tests!!!)
BANKS   ON
SVBANK '$NAME.bnk'

C If BANKS=ON, specify the BOS banks whose contents should
C be printed out in readable form for each supervisor level (1-7)
C   Some BOS banks of interest:
C   HEAD ALGN JETC ZVTX PATR JHTL LGCL LATC 
C   ATOF VECT PALL HITL VTXC HTSL TRIG

C LEVEL1 'HEAD LATC ATOF ALGN JETC PATR'
C LEVEL2 'LATC ATOF ALGN JETC PATR HTSL JHTL'
LEVEL2 'HEAD'
LEVEL3 'ALGN'
LEVEL4 'ZVTX'
C LEVEL5 'PATR'
C LEVEL6 'LGCL'
LEVEL7 'PATR LGCL'

C Control histograms
HISTO   ON
SVHIST '$NAME.hist'
C
STOP
EOF

# Time stamp:
echo
echo 'Finish SUPERV job at: '`date`
echo

# The End
exit

#!/usr/bin/ksh
##########################################
#
# Steering job for the ZE4V job.
#
#      05/06/00  Pedro Movilla Fernandez
#      24/06/03  PMF last mod.
#
##########################################

# Check current platform
if [ `uname` != 'AIX' ] ; then
   echo Current platform is not supported.
   exit
fi
. ../../Init_jade_env.ksh

# Time stamp:
echo
echo 'Start ZE4V job at: '`date`
echo

# Initialise random number seed for dEdx MC
ZSTART=ON

# Set input BOS file
SVBOS=`pwd`/sv_t86-05-17.bos

# Set calibration file: Use either AUPDAT1 or ( BUPDAT0 and BUPDAT1 )
AUPDAT0=${JADE_CAL}/aupdat1.b
#BUPDAT0=${JADE_CAL}/bupdat0.b
#BUPDAT1=${JADE_CAL}/bupdat1.b

# Set the name of the .hist, .bos and .bnk ouput files for this run
NAME=ze_t86-05-17

# Go to scratch directory:
out=out
mkdir -p $out
cd $out

# Delete files if neccessary:
if [ $ZSTART = 'ON' ] ; then
    echo Will remove ze4v.stat.
    rm -f ze4v.stat
fi

# Execute:
time ze4v << EOF
LIST

C Initialise random number generator
ZSTART $ZSTART

C Input file with the JADE events in BOS format
SVBOS
'$SVBOS'

C Max number of events to read from this file
C EVTREAD=0: process until end of input file
EVTREAD  0

C Initial event skip
EVTSKP   0

C Output file with compressed JADE BOS events in ZE4V format
ZE4V  '$NAME.ze4v'

C Max number of compressed BOS events to write out into this file 
C  ZE4VOUT=0: write out until end of reading input file
ZE4VOUT 0

C Max number of ZE4V-bank prints
ZE4VPRT 30

C Max number of full JADE BOS events to write out
C  EVTOUT=0: write out until end of reading input file
EVTOUT  0

C TP/PK-flag (1=TP/2=PK)
TPPK 2

C Selection (0:enab/1:disab)
SELECT 1
C Muon quality selection
MSELCT 0
C Elektron selection
ESELCT 0

C Output file with the JADE events in BOS format
ZBOS
'$NAME.bos'

C Print out of event BOS banks in readable ASCII format
C (memory consuming, only for tests!!!)
BANKS   ON
ZBANK  '$NAME.bnk'

C If BANKS=ON, specify the BOS banks whose contents should
C be printed out in readable form
CONT 'HEAD ALGN LGCL PATR ZVTX'

C Name of the calibration file
AUPDAT0 '$AUPDAT0'
BUPDAT0 '$BUPDAT0'
BUPDAT1 '$BUPDAT1'

C
STOP
EOF

# Time stamp:
echo
echo 'Finish ZE4V job at: '`date`
echo

# The End
exit

#!/bin/tcsh
#
if ( ! $?INIT_JADE_ENV ) then
   setenv INIT_JADE_ENV 1
#
   echo "   *** Executing init_jade_env.csh"
#
    ###### The JADE path here! #####
    # The part of ${PWD} up to the 
    # last appearance of 'jadesoft' 
    # is taken as the absolute path    
    setenv PWD `pwd`
    set JADE0 = ${PWD}
    set c = " "
    while ( $c != "jadesoft" )
    set c = ${JADE0:t}
    set JADE0 = ${JADE0:h}
    if ( "x$JADE0" == "x" ) break
    end
    if ( "x$JADE0" == "x" )  then 
	echo "Init_jade_env.csh: JADE root directory must be '<path>/jadesoft/'!"
	exit -9
    else
	setenv JADE $JADE0/$c
    endif
    # setenv JADE  ~/jadesoft
    ################################
#
   if ( -x /bin/uname ) then 
       alias machine "echo `/bin/uname`"
   endif
   if ( -x /bin/arch ) then 
       alias machine "echo `/bin/arch`"
   endif
   if ( ! $?HARDWARE ) then 
       setenv HARDWARE "`machine`"
   endif
   if ( "$HARDWARE" == "mips" ) then 
       setenv HARDWARE "decs"
            set BinPath="Dbin"
            set LibPath="DLib"
   endif
   if ( "$HARDWARE" == "i586" ) then 
       setenv HARDWARE "pentium"
   endif
   if ( "$HARDWARE" == "i686" ) then 
       setenv HARDWARE "pentium"
   endif
   if ( "$HARDWARE" == "AIX" ) then 
       setenv HARDWARE "RS6000"
   endif
   if ( "$HARDWARE" == "decs" ) then 
            set BinPath="Dbin"
            set LibPath="DLib"
   endif
   if ( "$HARDWARE" == "pentium" ) then 
            set BinPath="Pbin"
            set LibPath="Plib"
   endif
   if ( "$HARDWARE" == "RS6000" ) then 
            set BinPath="Rbin"
            set LibPath="Rlib"
   endif

# CERN library version
   if ( "$HARDWARE" == "RS6000" ) then
     setenv CERN_ROOT /cern/98
   else
     setenv CERN_ROOT /cern/99
   endif


# JADE resources/binaries
#setenv JADE_LIB $JADE/${LibPath}
#setenv JADE_BIN $JADE/${BinPath}
setenv JADE_LIB $JADE/lib
setenv JADE_BIN $JADE/bin
setenv JADE_SRC $JADE/src
setenv JADE_CAL $JADE/cal
setenv JADE_JOB $JADE/job
setenv JADE_MAIN $JADE/main
setenv JADE_UTIL $JADE/util
setenv JADE_ULIB $JADE/util/${LibPath}
setenv JADE_UBIN $JADE/util/${BinPath}
setenv JADE_MCLIB $JADE/util/mcgen/${LibPath}
setenv JADE_MCBIN $JADE/util/mcgen/${BinPath}
setenv ZE4V ${JADE_MAIN}/ze4v
setenv SUPERV ${JADE_MAIN}/superv
setenv MCJADE ${JADE_MAIN}/mcjade
setenv JADEZ ${JADE_MAIN}/jadez

echo "   *** JADE = $JADE"

# Path variables
setenv propath ". ${JADE_UTIL}/Scripts ${JADE_ULIB}  ${JADE_MCLIB} ${JADE_UTIL}/mcgen/src ${JADE_UTIL}/mcgen/mc"
setenv PATH """${JADE_UTIL}/Scripts:${JADE_UBIN}:${JADE_MCBIN}:${JADE_BIN}:$PATH"""

endif

#!/bin/ksh
#
# Shell script tool for extracting "#include-file" dependencies
# of FORTRAN files within the current directory.
# This routine is called by the Makefile for the JADE library.
#
# Nov/1999  P.A. Movilla Fernandez
#
# Arguments:
# ${1}     : The name of the library corresponding to the examined directory
# $(2),... : List of *.F files in the source library directory
#
log=Incdep.log
# check arguments
if [ ${#*} -lt 2 ]; then
 echo "GNUmake-Incdep: too few arguments" > $log
 exit
fi
#
Lib=${1}
echo "Current directory is"`pwd` > $log

# remove first argument
shift 1

# assign include files with the corresponding FORTRAN files
set -A FFiles `grep "#include" ${1} ${*}| cut -d : -f1`
set -A IFiles `grep "#include" ${1} ${*}| cut -d \" -f2`

# list of include files (alphabetically order)
set -A InclFiles `grep "#include" ${*}| cut -d \" -f2| sort|uniq`

# dependencies
echo ""              >> $log
echo "Dependencies:" >> $log
echo "-------------" >> $log
let i=0
while [ $i -lt ${#IFiles[@]} ]
do
    echo ${FFiles[$i]} '...' ${IFiles[$i]} >> $log
    let i=i+1
done

# FORTRAN files sorted by the include dependencies
echo ""                                  >> $log
echo ".F files sorted by include-files:" >> $log
echo "-- ----- ------ -- --------------" >> $log

let i=0
for ifile in ${InclFiles[@]}
do
    let k=0
    savefile="x"
    while [ $k -lt ${#FFiles[@]} ]
    do
	if [ ${IFiles[$k]} = $ifile ] 
	then
	    if [ $savefile !=  ${FFiles[$k]} ]
	    then
		cmd="Dep$i=\$Dep$i' '\${FFiles[$k]}"; eval $cmd
		oFiles=`echo ${FFiles[$k]}|sed 's/\.F/\.o/g'`
		cmd="LibDep$i=\$LibDep$i' '\${oFiles}"; eval $cmd
		savefile=${FFiles[$k]}
	    fi
	fi
	let k=k+1
    done
    cmd="echo $ifile: \${Dep$i}"; eval $cmd >> $log
    let i=i+1
done

# Compose `make' rules for #include dependencies
echo ""                                        >> $log
echo "Library members sorted by include-files:" >> $log
echo "------- ------- ------ -- -------------" >> $log

let i=0
for ifile in ${InclFiles[@]}
do
    cmd="echo ${Lib}'(' \${LibDep$i}' ) :\t '$ifile"; eval $cmd >> $log
    cmd="echo ${Lib}'(' \${LibDep$i}' ) :\t '$ifile"; eval $cmd
    let i=i+1
done
#

#!/usr/bin/ksh
# Job to generate 4-vector MC with JETSET 7.4
# 12.06.01 PMF: taken from py57.ksh
#
# 19.06.03, PMF: modified for use with a minimal JADE environment 
#                + further modifications
#

# Time stamp:
echo
echo 'Start job at: '`date`
echo

#
. ../../../Init_jade_env.ksh

# Switch for making of executable:
MAKEEXE=OFF
if [ x"$1" = 'xcomp' ]; then MAKEEXE=ON; fi

# Switches for 4-vector writing:
MC4VEC=OFF
MCSTART=ON

# Set the name of the .hist, .dat, .cprod (and .evki) file for this run:
NAME=jt74

# Set the version of MC package:
VERSION=105j
echo The version of the MC package is: mc$VERSION

# Go to scratch directory:
# cd  /home/iwsatlas1/pedro/mc/pythia

# Make the executable if demanded:
if [ $MAKEEXE = ON ] ; then

# Compose cradle file:
cat > mcjt74_$VERSION.cra <<EOF
+SELF.+USE,HPUX,ERRTRP.
+USE,TYPE.
+USE,PYJTAR.
+USE,LUCMMN.
+USE,MCCDES.
+EXE.
+USE,P=MCJT74.
+USE,P=MCUSER.
+PAM,11,R=LUCMMN,T=A,C. jt74opal.car
+PAM,13,T=A,C. mc$VERSION.car
+QUIT.
EOF

# Run patchy to get the code:
ytofort mcjt74_$VERSION
rc=$?
if [ $rc -ne 0 ] ; then
     echo 'jt74_qq: patchy return code' $rc
     echo `whoami` -m 'jt74_qq: patchy wrong'
     exit $rc
fi

# Compile, output goes in subdirectory:
fort mcjt74_$VERSION.f
rc=$?
if [ $rc -ne 0 ] ; then
     echo 'jt74_qq: compilation return code' $rc
     echo `whoami` -m 'jt74_qq: compilation wrong'
     exit $rc
fi

# Link it:
if [ $HARDWARE = "RS6000" ]; then
    ulink=""
else
    ulink="-uludata_ -umcevbl_ -umcpobl_"
fi
link -m -D $ulink mcjt74_$VERSION.o  \
	libmc$VERSION  \
	libjt74opal libckern105 libpx114
rc=$?
if [ $rc -ne 0 ] ; then
  echo 'jt74_qq: bad news, link return code' $rc
  echo `whoami` -m 'mc-comp_link: no executable made'
  exit $rc
fi

mkdir -p ${JADE_MCBIN}
if [ -x mcjt74_$VERSION.run ]; then
    mv -f mcjt74_$VERSION.run ${JADE_MCBIN}/.
    echo "mcjt74_$VERSION.run moved to ${JADE_MCBIN}/."
else
    echo "Compilation error!"
    exit 9
fi

# Delete temporary files:
rm -f mcjt74_$VERSION.cra
rm -f mcjt74_$VERSION.lis
#rm -f mcjt74_$VERSION.f
rm -f mcjt74_$VERSION.o
exit
# End of optional making of executable:
fi

# Delete files if neccessary:
if [ $MC4VEC = 'ON' ] ; then
  echo Will try to remove $NAME.evki
  rm -f $NAME.evki
  echo Will try to remove $NAME.cprod
  rm -f $NAME.cprod
  if [ $MCSTART = 'ON' ] ; then
    echo Will try to remove mcrnset.dat and mcrncnt.dat
    rm -f mcrnset.dat
    rm -f mcrncnt.dat
  fi
fi

# Execute:
time ${JADE_MCBIN}/mcjt74_$VERSION.run << EOF
LIST
C
C Cards for MC package:
MCIRUN 6666
MCSTART $MCSTART
MC4VEC  $MC4VEC
C
C Define the name of the 4-vector output file:
C   - extension .cprod forces binary format (JADE 'CPROD' format)
C   - extension .nt forces a HBOOK NTuple format (not yet supported!!!)
C   - other extensions yield to a readable ascii format (for test purposes)
C
MCEVFILE '$NAME.cprod'
MCNEVT 100
MCECMS 14.0
MCNPRI 100
MCTAB  OFF
MCISR  OFF
MCFSR  ON
C List of PDG IDs for particles to be declared as stable if MCSTBL = ON
MCSTBL OFF
MCIDST  511 513 521 523 531 533 541 543 5122
C        411 421 431
C  3112 3122 3222 3312 3322 3334 310

MCBOOS OFF
MCRDM  101234567
C
C QUARK TYPE TO ANALYSE:
C
C MCUDSC = ON: Only UDSC flavours are filled at parton level AND hadron level
C MCBQRK = ON: Only B quark flavour is analysed for partons/hadrons
C MCFLAV = I : I=0: all flavours analysed, I=1-5: Flavour I is analysed
C
MCUDSC OFF
MCBQRK OFF
MCFLAV 0
C
C JETSET 7.4 OPAL standard parameters: b=        0.52  +/- 0.04   PARJ(42)
C                                      sigma_Q=  0.40  +/- 0.03   PARJ(21)
C                                      Q_0=      1.90  +/- 0.50   PARJ(82)
C                                      eps_c=   -0.031 +/- 0.011  PARJ(54)
C                                      eps_b=   -0.0038+/- 0.0010 PARJ(55)
C                                      a=        0.11             PARJ(41)
C                                      Lamb_QCD= 0.250 +/- 0.006  PARJ(81)
JTPB    0.52
JTPSQ   0.40
JTPQ0   1.90
JTPEC  -0.031
JTPEB  -0.0038
JTPA    0.11
JTPLAMB 0.25
C
C
C Jetrates (time saving option) calculation
C
C MCJTEV: Number of events to analyse for jet finding, -1: all
C MCDURH = ON: Analyse using the Durham jet finding
C MCJDE0 = ON: Analyse using the JADE E0 jet finding
C MCCONE = ON: Analyse using the Cone jet finders
C MCCAMJ = ON: Analyse using the Cambridge Jet finder
C MCCKRN = ON: Analyse using the CKERN Cambridge
C
MCJTEV 0
MCJDE0 OFF
MCDURH OFF
MCCONE OFF
MCCAMJ OFF
MCCKRN OFF
C
C User cards for MCUSxx routines:
OUTFILE '$NAME.hist'
FSRRM OFF
ISRRM OFF
STOP
EOF

# Time stamp:
echo
echo 'Finish job at: '`date`
echo

# The End
exit

#!/bin/ksh
#
# Shell script to compile all utility programs
#
# 19.06.2003  Pedro A. Movilla Fernandez
#

. ../Init_jade_env.ksh

env=`uname`

# Compile the MC libraries
cd ${JADE_UTIL}/mcgen/src/.
${JADE_UTIL}/mcgen/src/Inst.ksh 2>&1 | tee  ${JADE_UTIL}/mcgen/src/Inst.${env}.log

cd ${JADE_UTIL}/mcgen/mc/.
${JADE_UTIL}/mcgen/mc/mc105j_lib.ksh 2>&1 | tee ${JADE_UTIL}/mcgen/mc/Inst.mc105j_lib.${env}.log

# Compile the QCD generator programs
cd ${JADE_UTIL}/mcgen/pythia/.
${JADE_UTIL}/mcgen/pythia/py57.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/pythia/Inst.py57.${env}.log

cd ${JADE_UTIL}/mcgen/jetset/.
${JADE_UTIL}/mcgen/jetset/jt63.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/jetset/Inst.jt63.${env}.log

${JADE_UTIL}/mcgen/jetset/jt74.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/jetset/Inst.jt74.${env}.log

cd ${JADE_UTIL}/mcgen/herwig/.
${JADE_UTIL}/mcgen/herwig/hw58d.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/herwig/Inst.hw58d.${env}.log
${JADE_UTIL}/mcgen/herwig/hw59.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/herwig/Inst.hw59.${env}.log

cd ${JADE_UTIL}/mcgen/ariadne/.
${JADE_UTIL}/mcgen/ariadne/ar48p.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/ariadne/Inst.ar48p.${env}.log

cd ${JADE_UTIL}/mcgen/cojets/.
${JADE_UTIL}/mcgen/cojets/cj623.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/cojets/Inst.cj623.${env}.log

cd ${JADE_UTIL}/mcgen/lepton/.
${JADE_UTIL}/mcgen/lepton/lepton.ksh comp 2>&1 | tee ${JADE_UTIL}/mcgen/lepton/Inst.lepton.${env}.log

# Compile the ZE4V reading program
cd ${JADE_UTIL}/zread/.
${JADE_UTIL}/zread/zread.ksh  2>&1 | tee ${JADE_UTIL}/zread/Inst.zread.${env}.log

# Compile the calibration file conversion programs
cd ${JADE_UTIL}/ccal/.
${JADE_UTIL}/ccal/ccal.ksh  2>&1 | tee ${JADE_UTIL}/ccal/Inst.ccal.${env}.log

echo "***"
echo "*** Installation of ${JADE_UTIL} finished."
echo "***"

#!/usr/bin/ksh
##########################################
#
# Steering job for MCJADE.
#
#      28/05/00  Pedro Movilla Fernandez
#      24/06/03  PMF last mod.
#
##########################################

# Check current platform
if [ `uname` != 'AIX' ] ; then
   echo Current platform is not supported.
   exit
fi
. ../../Init_jade_env.ksh

# Time stamp:
echo
echo 'Start MCJADE job at: '`date`
echo

# Initialise random number seed:
MCSTART=ON

# Set JADE detector configuration:
YEAR=86; MONTH=05; DAY=17
#YEAR=81; MONTH=07; DAY=17

# Set name of the 4-vector input file (no more than 78 characters)
#VECT=`pwd`/demo.py57isr_35.aix.cprod
VECT=`pwd`/demo.py57isr_35.linux.cprod

# Set the name of the .hist, .bos and .bnk files for this run
NAME=mc_t$YEAR-$MONTH-$DAY

# Go to scratch directory:
job=$$
out=out
mkdir -p $out
cd $out

# Delete files if neccessary:
if [ $MCSTART = 'ON' ] ; then
    echo Will remove mcjade.stat.
    rm -f mcjade.stat
fi

# Execute:
time mcjade << EOF
LIST

C Initialise random number generator
MCSTART $MCSTART

C Configuration of the JADE detector
YEAR    $YEAR
MONTH   $MONTH
DAY     $DAY

C Tracking options
C --- Smear gamma and electron energies
SMEAR    ON
C --- Gamma conversion in outer tank and coil
CONVERT  ON
C --- Absorption losses
ABSORB   ON
C --- 3 dim shower profile fit to eggs code
SHOW3D   ON
C --- Vertex chamber tracking:
C     Normally, this option is set automatically in MCJADE
C     VERTEX = ON : Vertex chamber tracking is performed
C            = OFF: Old beam pipe geometry and beam pipe counters
C                   is considered (before Mai 84)
VERTEX   ON

C First and last event to be tracked
C     LAST=0: process until end of 4-vector 'CPROD' file
FIRST   1
LAST    100
C 4-Vector print out
MCNPRI  100

C Name of the 4-vector input file
MCVECT
'$VECT'
C Name of the bos banks output file
MCBOS '$NAME.bos'

C Print out of BOS banks in readable ASCII format
C (memory consuming, only for tests!!!)
BANKS   OFF
MCBANK '$NAME.bnk'

C Control histograms
HISTO   ON
MCHIST '$NAME.hist'
C
STOP
EOF

# Time stamp:
echo
echo 'Finish MCJADE job at: '`date`
echo

# The End
exit

#!/bin/ksh
#
# Shell script to compile the ZE4V data reading routine
#
# 19.06.2003  Pedro A. Movilla Fernandez
#

#
. ../../Init_jade_env.ksh

env=`uname`

# compile conversion routine
fort conv.f
Stat=$?
if [ $Stat -ne 0 ]; then
    exit 9
fi
link conv.o
Stat=$?
if [ $Stat -ne 0 ]; then
    exit 9
fi
rm -f conv.o
mv -f conv.run  conv.${env}.run

# compile read routine (for tests)
fort rconv.f
Stat=$?
if [ $Stat -ne 0 ]; then
    exit 9
fi
link rconv.o
Stat=$?
if [ $Stat -ne 0 ]; then
    exit 9
fi
rm -f rconv.o
mv -f rconv.run  rconv.${env}.run

# demo calibration file
rm -f aupdat1
ln -s ${JADE_CAL}/aupdat1

echo ""
echo "conv.${env}.run, rconv.${env}.run created."
echo ""

exit 0

#!/usr/bin/ksh
# Job to generate lepton pairs w/o any underlying physics
# 09.11.00, P. Movilla Fernandez
#
# 19.06.03, PMF: modified for use with a minimal JADE environment
#                + further modifications
#

# Time stamp:
echo
echo 'Start job at: '`date`
echo

#
. ../../../Init_jade_env.ksh

# Switch for making of executable:
MAKEEXE=OFF
if [ x"$1" = 'xcomp' ]; then MAKEEXE=ON; fi

# Number of events to generate
EVENTS=1000

# Center-of-mass energy
ECM=12.0

# Lepton flavour: 1=electron, 2=muon
LEPTON=1

# Set the name of the .cprod (and .evki) file for this run:
NAME=lepton.${ECM}.${LEPTON}

# Go to scratch directory:
# cd ~/mc/lepton

# Make the executable if demanded:
if [ $MAKEEXE = ON ] ; then

# Compose cradle file:
cat > lepton.cra <<EOF
+USE,P=LEPTON.
+EXE.
+PAM,13,T=A,C. lepton.car
+QUIT.
EOF

# Run patchy to get the code:
ytofort lepton
rc=$?
if [ $rc -ne 0 ] ; then
     echo 'lepton: patchy return code' $rc
     echo `whoami` -m 'py57_qq: patchy wrong'
     exit $rc
fi
# Compile, output goes in subdirectory:
fort lepton.f
rc=$?
if [ $rc -ne 0 ] ; then
     echo 'lepton: compilation return code' $rc
     echo `whoami` -m 'lepton: compilation wrong'
     exit $rc
fi

# Link it:
if [ $HARDWARE = "RS6000" ]; then
    ulink=""
else
    ulink="-uludata_ -upydata_ -umcevbl_ -umcpobl_"
fi
link -m $ulink lepton.o

rc=$?
if [ $rc -ne 0 ] ; then
  echo 'lepton: bad news, link return code' $rc
  echo `whoami` -m 'mc-comp_link: no executable made'
  exit $rc
fi

mkdir -p ${JADE_MCBIN}
if [ -x lepton.run ]; then
    mv -f lepton.run ${JADE_MCBIN}/.
    echo "lepton.run moved to ${JADE_MCBIN}/."
else
    echo "Compilation error!"
    exit 9
fi

# Delete temporary files:
rm -f lepton.cra
rm -f lepton.lis
#rm -f lepton.f
rm -f lepton.o
exit
# End of optional making of executable:
fi

# Delete files if neccessary:
echo Will try to remove $NAME.cprod
rm -f $NAME.cprod

# Execute:
${JADE_MCBIN}/lepton.run << EOF
LIST
C
C Cards for MC package:

C Define the name of the 4-vector output file:
MCEVFILE '$NAME.cprod'
C Format of the 4-vector output file:
C 'A': ASCII
C 'B': Binary
FORMAT 'B'

C Number of events generate
NEVENT $EVENTS

C CENTER OF MASS ENERGY
CMS    $ECM

C LEPTON FLAVOUR TO GENERATE
C TYPE=1: ELECTRON
C     =2: MUON
TYPE ${LEPTON}

STOP
EOF

# Time stamp:
echo
echo 'Finish job at: '`date`
echo

# The End
exit

#!/usr/bin/ksh 
# Shell script to compile and create 4-vector MC generation library:
# Modifications:
# 29.07.96, STK: add -z flag to ftolib to get debugable library 
# 18.09.96, STK: introduce variable for version of MC package, set to 101,
#                use HERWIG 5.9 cards
# 19.09.96, STK: Mods for use with version 101 of MC
#
# 11.05.00, PMF: adapted for use on the Linux/AIX platforms at the MPI
#                + some further mods
# 13.05.00, PMF: introduce an additional patchy step to choose
#                the event record write out routine.
#                The cradle file must contain
#                 '+USE,OPAL,EVWRTO.'   for OPAL format
#                 '+USE,JADE,EVWRTO.'   for JADE format
#
# 19.06.03, PMF: modified for use with a minimal JADE environment + further modifications
#

# Time stamp:
echo
echo 'Start at:'`date`
echo

#
. ../../../Init_jade_env.ksh

# Set version number:
VERSION=105j
echo
echo 'The MC code version number is:' $VERSION
echo

# Compose cradle files:
cat > mc$VERSION.cra <<EOF
+SELF.+USE,HPUX.
+USE,JADE,EVWRTO.
+USE,TYPE.
+USE,LUCMMN.
+USE,LU63MN.
+USE,MCCDES.
+EXE.
+USE,P=MCKERN.
+USE,P=PXMOD.
+USE,P=JADEEV.
+PAM,11,R=LUCMMN,T=A,C. jt74opal.car
+PAM,12,T=A,C. jt63jade.car
+PAM,13,T=A,C. mc$VERSION.car
+QUIT.
EOF

# Run ypatchy:
ytofort mc$VERSION

rm -f mc$VERSION.cra
rm -f mc$VERSION.lis

# Compile the code and make library:
ftolib mc$VERSION.f

rm -f mc$VERSION.f
rm -rf mc$VERSION
rm -f ftolib.log

mkdir -p ${JADE_MCLIB}
mv -f mc$VERSION.a ${JADE_MCLIB}/libmc$VERSION.a

echo "library ${JADE_MCLIB}/libmc$VERSION.a created"

# The End:
exit
